Via the makefile the different ftoc_xyz.h files are copied to ftoc_test.h 
(in $MIDASHOME/$MIDVERS/incl) and for each ftoc_xyz.h the module ftoc_test.c
(generated from ftoc_test.fc) is compiled again with this new include file,
and a new ftoc_xyz.exe (which is the for_test.exe with the include file 
ftoc_xyz.h) is built. 

Then the shell script ftoc_params (in ../exec) is executed which checks 
each of the ftoc_xyz.exe and, if all is o.k., it returns the corresponding 
ftoc_xyz.h file
which is then copied for good to ftoc.h for the Midas installation.
A message indicating which include file matched is displayed as well.

If there's no success, a warning message is displayed and one has to try
manually to find the mechanism how Fortran parameters are passed to the
C-stack by the compiler.

------------------------------------------------------------------------

For testing an unknown Fortran / C parameter passing mechanism there
are two more executables available:
ftoc_test.exe, ftoc_stack.exe
which are compiled and linked via the "maketest" makefile:
$ make -f maketest

but it's better to compile it non-optimized:
$ make DEBUG=-g STRIP=echo C_OPT=  -f maketest 

ftoc_stack.fc (as well as ftoc_test.fc) includes file ftoc_test.h, 
so one should copy the most likely ftoc_xyz.h file to ftoc_test.h by hand.
OJO: ftoc_test.h was set to the last trial ftoc_xyz.h in the general make - 
so it usually has to be reset manually.
To display the parametrer stack common code for the different subroutines, 
which is stored in stack_dump.h is used within ftoc_stack.fc (all include (.h) 
files are in /midas/version/incl).
As Fortran front-end the module for_try.for contains the calls to
various subroutines of ftoc_test.fc with different calling sequences and 
parameters.

ftoc_test.fc also includes file ftoc_test.h (in /midas/version/incl) and
calls 3 different C routines (SSP1, SSP2, SSP3) checking the parameters
in the routines with the values passed in for_test.for. If all is o.k., a
status of 0 is returned.

To compile and link these modules, do:

$ make -f maketest basic
which creates ftoc_test.exe

$ make -f maketest stack 
which creates ftoc_stack.exe

$ ../exec/ftoc_stack.exe

should show the layout of the stack somewhat better for different subroutine 
calls.

Testing a new compiler setup involves then modifying the ftoc_test.h file
and also stack_dump.h.
The changes to ftoc_stack.fc would be mainly to toggle the flags (nogo) for
the different stack entries to avoid SEG faults through invalid pointers.
Then do the makes as indicated above, and keep trying ...

For more details, read ./doc/modules.txt.

------------------------------------------------------------------------

on Solaris:
kbanse@dmdsol8b$ ../exec/ftoc_names.exe
-fl_
Note: Nonstandard floating-point mode enabled 
See the Numerical Computation Guide, ieee_sun(3M) 

on Linux:
somidas@pc004351> ../exec/ftoc_names.exe
-fl_





060228 KB

1. @@ prepare

create necessary catalogs

2. @@ init ThAr???? start

3. Check Objects.cat, for missing TCS-Infos, e.g. cident. if this is the case,
insert the descriptor o_pos. Otherwise comp/prec will be wrong or fail.

4. Create cident entries in the table Objects.tbl and insert options
for dark subtraction and extmode (see check.prg)

5. @@ autoreduce_cat Objects.cat

  The modules in this directory are stored in the library 
  /midas/version/lib/libidicl.a
  and their functions are used by the Midas display/graphics applications;
  libidicl.a is part of the Midas library libgmidas.a
  So, after a modification here, also a make in /midas/version/lib
  is necessary.
  
100119

version 1.0					941128


The "red_batches.bdf" image has seven objects:

   o  o o o o o o
   1  2 3 4 5 6 7 

Each procedure expects input from center/gauss. The default box size
is used.

procedure & parameters    expected result             objects to be selected
-----------------------------------------------------------------------------
seeing                    1.51  1.52                  1-2-3-4-5-6-7
wfocus                    -0.639  -67.137 0.031       2-4-6
point 100 100             -202.68  251.16             1
tfocus 8220 15            mean = 8234.31 (???)        1-2-3-4-5-6-7
rotate G                  289.31  89.69               1-7
shslit 1011 1039          vertical line with a circle surrounding object #4



The SCCS controlled procedures are stored in /midas/$MIDVERS/contrib/obs/ntt .

This directory contains a list of subdirectories with the names of machines
on which MIDAS has been ported (and verified):

AIX:		IBM AIX Version 3 for RISC System/6000
silicon_grap:   Silicon Graphics IRIX Release 4.0.1 System V
convex:		Convex 3440 
ULTRIX:		DecStation ULTRIX V4.3 (Rev. 44)
HP-UX:		HP-UX A.08.07 E 9000/750 (also series 800)
SunOS_4.1.3:	Sun SunOS 4.1.n. Solbourne OS/MP 4.1A
SunOS_4.1.2:	Sun SunOS 4.1.n. Solbourne OS/MP 4.1A
SunOS_5.1:	Sun SunOS 5.1 Sparc10/30 (Solaris 2.1)
Linux		PC/386-486 with Linux SLS 1.01
PC-SCO:		PC/486 with SCO Unix 3.2v4.2
other:		Other systems not matching the list above.

 
**************************** IMPORTANT NOTES **********************************

   the following notes are relevant for cygwin as of version CYGWIN_NT-5.1
   and later
 

1)	the include file values.h in this directory has to be copied
	to /usr/include/mingw to replace the values.h in there, e.g. :
	$ cd /usr/include/mingw
	$ mv values.h values.h.orig
	$ cp /midas/version/install/unix/systems/Cygwin/values.h .

2)	the VLT filenames using colons (:) make trouble, e.g. a tar aborts
	if it contains such a filename 
	so, we use instead of, eg:
	VISIR. 2004-09-30T03:17:49.095.fits 
	filenames like:
	VISIR.2004-09-30T03c17c49.095.fits

070521

*******************************************************************************

 
**************************** IMPORTANT NOTES **********************************
				
001220:	We do not use the library `libtermcap.a' anymore   
	instead `libncurses.a' is used                         
								
050531:	the development packages (which contain the include files)
	are needed for Motif, the curses library and X11

	names differ from distro to distro,
	e.g. openmotif-devel, ncurses-devel and XFree86-devel for Suse

080523:	for (K)Ubuntu 8.04 we also had to install the libxmu-dev, and
        libxmu-headers besides libxmu to get Motif going

090525:	for (K)Ubuntu 7.10 - 9.04 we also have to install the package
	x11proto-print-dev     (for the printing extension protocol)
	besides the usual packages libmotif-dev, libmotif3
	to make the Motif check work in the Midas installation
	(because in Xm/Xm.h reference was made to X11/extension/Print.h)

*******************************************************************************

  The modules in this directory are stored in the library 
  /midas/version/lib/libidi.a
  and used by the idiserver (source code in /midas/test/system/idiserv/src).
  These functions are not used by the Midas display/graphics applications,
  and libidi.a is not part of the different Midas libraries!
  After a modification here, also  a make in /midas/test/system/idiserv/src
  is necessary.
  
100119

24 Nov 1989: Please Check Your Limit Paramaters  !!!!
=====================================================
Use the command "limit" to check them. 
Put special atention to "stacksize", which must be 
at least 8192 Kbytes for some MIDAS applications.
It seems that Ultrix system for DecStation have
a default value which is too small.

********************************************************************************
*  IMPORTANT NOTE BEFORE YOU START THE INSTALLATION OF MIDAS:                  *
*  ----------------------------------------------------------                  *
*  Check your 'path' and 'LD_LIBRARY_PATH' environment variables, and the      *
*  MIDAS ./local/make_options file as indicated here:                          *
*                                                                              *
*  On SunOS 5.5: X11   libraries are expected to be in /usr/openwin/lib  and   *
*                Motif libraries are expected to be in /usr/dt/lib             *
********************************************************************************

- MIDAS installation using the SUN C compiler SC3.0.1 (or higher) and the SUN 
  Fortran compiler SC3.0.1 (or higher) requires the following definitions:
        set path=(/opt/SUNWspro/bin /usr/bin /usr/ccs/bin .)
        setenv LD_LIBRARY_PATH  \
             /usr/dt/lib:/usr/openwin/lib:/opt/SUNWspro/lib:/usr/ccs/lib

- MIDAS installation with g77 requires you edit ./local/make_options and
  remove the "-fast" option for F_OPT and LD77_OPT.

03.03.94: MIDAS 93NOV has been installed using the GNU C compiler and the 
          ATT "f2c" Fortran_To_C conversor. We have used the script "f77" 
          provided in "<midas_dir>/local/util/f77 as the Fortran F77 compiler.

 
**************************** IMPORTANT NOTES **********************************
				
				

		Mac OSX 10.5.x
		--------------

080619:  How to get Fortran, Motif for OSX 10.5 (Leopard)

	This time, with Leopard on an Intel MacBook we got 
	the necessary code via MacPorts
        http://www.macports.org
        (read the installation guide of MacPorts)

        First of all, we need Apple's Xcode 3.0 Developer Tools for 
	Leopard - so, off to the Apple Developer Connection site.
        To download anything you must be registered with Apple's
        Developers Community, so if that's not the case, register now.

        Download Xcode3.0.dmg, unpack via double click and install 
	XcodeTools.pkg also via double click.

        Back to the MacPorts site and download MacPorts for Leopard,
        unpack and install Macports-1.6.0.pkg as above.
        All stuff goes to /opt/local/bin
        so you have to add this to the PATH env. variable,
        only then you finally have access to the "port" command
        with which you can get our desired software

        to get Fortran you have to get gcc 4.2 (which contains also
        frontend gfortran), default on Mac is gcc 4.0
        $ sudo port install gcc42

        to get the Motif stuff for the Midas GUIs
        $ sudo port install openmotif

        After that you must set the following links in /opt/local/bin
        $ cd /opt/local/bin
        $ ln -s gcc-mp-4.2 gcc
        $ ln -s gcc-mp-4.2 cc
        $ ln -s gfortran-mp-4.2 gfortran


080620:  we recommend John Pritchard's webpage about his experiences 
	with Midas on the Mac:
        www.eso.org/~jpritcha/MIDASonMacOSX.html


		Mac OSX 10.6.x
		--------------

100426:  if you still use Mac OSX 10.5 you have to rename 
	make_options.osx.10.5 to  make_options (1)
	before doing the installation!


100426:	 for OSX 10.6 we use Fink to get all necessary Linux apps for 
	the Mac, see http://www.finkproject.org/ for more details

	in particular /sw/bin/gcc-4 as the C compiler (gcc 4.4.x), 
	and /sw/bin/gfortran as Fortran compiler,
	also Motif can be installed via Fink (32bit code)


110715: if you use Mac OSX 10.6 with Kernel Darwin 10.4.0
	you have to rename make_options.osx.10.6 to  make_options (1)
        before doing the installation!

(1) 	this has to be done in /midas/version/local before starting the 
   	installation via step 6 of the config script
   	when using the autoconfig script this renaming has to be done in
  	/midas/version/install/unix/systems/Darwin


111012: Midas checks if the default C compiler produces 32- or 64-bit code
	and adapts the installation accordingly.
	However, that's not working with the default gcc from Apple:
	That compiler produces 64-bit code, so Midas will do the
	installation , accordingly, producing 64bit executable modules,
	e.g.     $ file midas/version/monit/prepa.exe	displays
	prepa.exe: MACH-0 64bit executable x86_64
	and starting Midas: $ inmidas
	will abort with some trap no.
	You have to use the Fink C compiler, instead, see above (100426)
	and also get the gfortran from fink.
	Then, either change your PATH variable, or, as root, do
	# mv /usr/bin/gcc /usr/bin/gcc-orig
	# ln -s /sw/bin/gcc-4 /usr/bin/gcc
	Now, Midas will do a 32bit installation, and everything should work.


111015: with Kernel Darwin 10.7.0 you only need additionally the gfortran 
	frontend (e.g. from Fink) and can use the default gcc from Apple.
	The 32bit gfortran works together with the native gcc provided
	by OSX and creates 64bit executables on relevant architectures
	With this kernel the 64bit Midas executables do work.

	Above also applies to Mac OSX 10.7 (Lion).


*******************************************************************************

24.08.93: The default installation uses the options "-O" and "+z" for the
 	  C compiler. They are used to optimize the C code and to generate
	  position independent code for shared libraries.

	  Here you could get "Warning" messages because these two options are 
	  not supported by the HP-UX C compiler when is provided as part of the
	  standard HP-UX system. They are supported by the C compiler sold as 
	  an optional separated pruduct.

	  If this is your case you will have to remove options "-O" and "+z" 
          and those entries starting with "SH_" in "./local/make_options" file.

24.08.93: MIDAS has been installed on a PC-486 running SCO Unix release 3.2v4.2
          It uses the Microsofts's C compiler version 6, and the LPI-FORTRAN 
          (lpifortran/lpild). The "make_options" file is ready to use these
          compilers.

25.08.93: MIDAS has been installed on a PC-486 running SCO Unix release 3.2v4.2
	  It uses the public domain GNU C compiler v2.4 and the FORTRAN_TO_C
   	  TRANSLATOR "f2c" v 23.4.93. Edit the file "make_options" to change 
	  the compiler definitions.

********************************************************************************
*  IMPORTANT NOTE BEFORE YOU START THE INSTALLATION OF MIDAS:                  *
*  ----------------------------------------------------------                  *
*  Check your 'path' and 'LD_LIBRARY_PATH' environment variables, and the      *
*  MIDAS ./local/make_options file as indicated here:                          *
********************************************************************************
- MIDAS installation using the SUN C compiler SC2.0.1 and the SUN Fortran 
  compiler SC2.0.1 requires the following definitons:
	set path=(/usr/ucb /usr/ccs/bin /opt/SUNWspro/bin /usr/bin .)
	setenv LD_LIBRARY_PATH /usr/ccs/lib:/opt/SUNWspro/lib:/usr/openwin/lib

- MIDAS installation using the SUN C compiler SC3.0.1 and the SUN Fortran
  compiler SC3.0.1 requires the following definitons:
        set path=(/opt/SUNWspro/bin /usr/bin /usr/ccs/bin .)
        setenv LD_LIBRARY_PATH /usr/openwin/lib:/opt/SUNWspro/lib:/usr/ccs/lib

- MIDAS installation using the GNU C compiler and the SUN Fortran compiler 
  SC2.0.1 requires the following definitions:
	set path=(/opt/cygnus/bin /opt/SUNWspro/bin /usr/ccs/bin /usr/bin .)
	setenv LD_LIBRARY_PATH /usr/openwin/lib:/usr/ccs/lib
  and in the "./local/make_options" file the SLIB definition should be:
	SLIB=-lsocket -lnsl -lgcc -R$(MIDASHOME)/$(MIDVERS)/lib
  and /usr/lib/libgcc.a must be a soft link to /opt/cygnus/lib/libgcc.a

24.08.93: The default installation uses the options "-O" and "+z" for the
 	  C compiler. They are used to optimize the C code and to generate
	  position independent code for shared libraries.

	  Here you could get "Warning" messages because these two options are 
	  not supported by the HP-UX C compiler when is provided as part of the
	  standard HP-UX system. They are supported by the C compiler sold as 
	  an optional separated pruduct.

	  If this is your case you will have to remove options "-O" and "+z" 
          and those entries starting with "SH_" in "./local/make_options" file.

15.06.94: All GUIs with Motif 1.1 overlap some of the widgets with the 
          blue-menu-bar (solved in Motif 1.2). The overlapped widgets appear
	  as they should be after resizing the window.
          The XDo (Data Organizer GUI) might be very slow for some features 
	  with Motif 1.2.0 (due to a bug solved in Motif 1.2.3).

 
**************************** IMPORTANT NOTES *********************************


080604 - Some manual work is needed for installation on OpenSolaris (5.11)

For the Fortran compiler we download Sun Studio 11 software, as 
described in:
http://www.opensolaris.org/os/community/tools/sun_studio_tools/
sun_studio_11_tools/

Following the link in that doc. you have to register first at the 
Sun Download Center and then download the stuff. We actually downloaded 
Studio 12 which was just released.
As root download the .tar.bz2 file to /var/tmp, then
# cd /opt
# bzcat /var/tmp/sunstudio12ml-solaris-x86-200709-pkg.tar.bz2 | /bin/tar -xf -
and to install use
# .installer
and mark everything.
Installation doesn't succeed completely, but we get Fortran.
After that update PATH via
export PATH=/opt/SUNWspro/:$PATH

The x11 stuff can be downloaded via the package manager.

The ncurses library as well as motif currently not found, 
but the installation works.


******************************************************************************
 

C===========================================================================
C Copyright (C) 1995-2011 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C.VERSION
C 111019	last modif
C===========================================================================
C
      PROGRAM ALLST
C
      IMPLICIT NONE
      INTEGER MAXFRM, PSFMAX, NOPT, MAPSIZ
      PARAMETER (MAXFRM=105000000, PSFMAX=35, NOPT=10) 
C     MAXFRM=105000000   => 10000 x 10500
C 
C     PARAMETER (MAXFRM=655360, PSFMAX=35, NOPT=10) => 640 x 1024
C     MAXFRM=16810000   => 4100 x 4100
C
C MAXFRM represents the maximum image size the program is designed to
C        tolerate.  655360 is large enough for 640 x 1024, and is also
C        more than adequate for 800 x 800.
C     PN 3/99 this is not true anymore, therefore MAXFRM increased
C
C PSFMAX is the maximum PSF radius.  A value of 35 is consistent with
C        DAOPHOT.
C
C   NOPT is just the number of user-definable options (see below).
C
      CHARACTER*26 LBL(NOPT)
      REAL OPT(NOPT), OMIN(NOPT), OMAX(NOPT)
C      REAL DATA(MAXFRM), SUBT(MAXFRM), SIGMA(MAXFRM)
C      SAVE DATA, SUBT, SIGMA
C
      CHARACTER*30 INPICT, OPTFIL, CASE
      CHARACTER*80  TXTBUF
      REAL PERERR, PROERR
      INTEGER NCOL, NROW, ISTAT
      INTEGER*8 PNTRA, PNTRB, PNTRC
      INTEGER MADRID(1)                              ! MIDAS
      LOGICAL OPEN, CENTER
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'            ! MIDAS
      COMMON /VMR/ MADRID                         ! MIDAS
      COMMON /SIZE/ NCOL, NROW
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'            ! MIDAS
C
      DATA OPEN /.FALSE./
      DATA LBL/'            FITTING RADIUS',     ! 1
     .         '    CE (CLIPPING EXPONENT)',     ! 2
     .         '     REDETERMINE CENTROIDS',     ! 3
     .         '       CR (CLIPPING RANGE)',     ! 4
     .         '            WATCH PROGRESS',     ! 5
     .         '        MAXIMUM GROUP SIZE',     ! 6
     .         '      PERCENT ERROR (in %)',     ! 7
     .         '      PROFILE ERROR (in %)',     ! 8
     .         '     IS (INNER SKY RADIUS)',     ! 9
     .         '     OS (OUTER SKY RADIUS)'/     ! 10
      DATA OPT / 2.5, 6., 1., 2.5, 1., 50., 0.75, 5., 0., 0./
      DATA OMIN  / 1.6, 0.0, 0.0, 0., 0.0, 1.0, 0., 0., 0., 0./
      DATA OMAX  / 10., 8.0, 1.0, 10., 2.0, 100., 100., 100.,
     .           35., 50./
C
C Set up the values of the optional parameters.
C
C Call OPTION, first with OPTFIL = 'allstar.opt' to set initial
C values for the optional parameters.  If the file isn't there, the
C routine will check that the default values (specified in the data
C statement above) are valid, and return here with those values intact.
C
      CALL STSPRO ('allstar')                        ! MIDAS
      CALL STECNT('PUT', 1, 0, 0)                    ! MIDAS

      MAPSIZ = MAXFRM

      CALL STFXMP(MAPSIZ,D_R4_FORMAT,PNTRA,ISTAT)
      CALL STFXMP(MAPSIZ,D_R4_FORMAT,PNTRB,ISTAT)
      CALL STFXMP(MAPSIZ,D_R4_FORMAT,PNTRC,ISTAT)
      INPICT = '                             '     ! avoid strange output
C
C This section show at start up a short message to the user informing him
C about the maximum size of the frames,
C
      CALL STTPUT('       '//
     2'--------------------------------------------------------------',
     2ISTAT)
      CALL STTPUT('       '//
     2'                        W A R N I N G                         ',
     2ISTAT)
      CALL STTPUT(' ',ISTAT)
      CALL STTPUT('       '//
     2'This version of ALLSTAR can be used for frames with a maximum ',
     2ISTAT)
      WRITE(TXTBUF,12345) MAPSIZ
12345 FORMAT('size of 10000 * 10500 (= ',I9,') pixels.')
      CALL STTPUT('       '//TXTBUF,ISTAT)
      CALL STTPUT('       '//
     2'In case your frame is larger than this value,', ISTAT)
      CALL STTPUT('       '//
     2'ALLSTAR will not be able to process it.',ISTAT)
      CALL STTPUT('       '//
     2'In such case, please contact your local MIDAS support person.',
     2ISTAT)
      CALL STTPUT('       '//
     2'--------------------------------------------------------------',
     2ISTAT)

      CALL FABORT
      OPTFIL=CASE('allstar.opt')
      CALL OPTION (OPTFIL, NOPT, LBL, OPT, OMIN, OMAX, 'OPT>', ISTAT)
      CALL TBLANK
      IF (OPT(3) .GE. 0.5) THEN
         CENTER=.TRUE.
      ELSE
         CENTER=.FALSE.
      END IF
      PERERR = 0.01*OPT(7)
      PROERR = 0.01*OPT(8)
C 
 1900 CALL GETNAM ('Input image name:', INPICT)
      IF ((INPICT .EQ. 'END OF FILE') .OR. (INPICT .EQ. 'EXIT'))
     .     CALL BYEBYE
      CALL ATTACH (INPICT, OPEN)
      IF (.NOT. OPEN) THEN
         INPICT = 'EXIT'
         GO TO 1900
      END IF
      IF (NCOL*NROW .GT. MAXFRM) THEN
         CALL STUPID ('Picture is too large!')
         WRITE (6,69) MAXFRM
  69     FORMAT (/' Maximum allowed number of pixels =', I8)
         CALL OOPS
      END IF
C
      CALL ALLSTR (MADRID(PNTRA), NCOL, NROW, MADRID(PNTRB), 
     .     MADRID(PNTRC),
     .     OPT(1), OPT(5), OPT(4), NINT(OPT(2)), CENTER,
     .     NINT(OPT(6)), PERERR, PROERR, OPT(9), OPT(10))
C
      CALL CLPIC ('DATA')
      CALL BYEBYE
      END!
C
C#######################################################################
C
      SUBROUTINE  ALLSTR  (DATA, NCOL, NROW, SUBT, SIGMA,
     .     FITRAD, WATCH, HALF, IEXP, CENTER,
     .     MAXGRP, PERERR, PROERR, SKYIN, SKYOUT)
C
C=======================================================================
C
C Photometry for many stars by simultaneous multiple PSF fits iterating
C the entire star list simultaneously.
C
C              OFFICIAL DAO VERSION:  1987 June 30
C
C Input arguments:
C
C       DATA is the input image, stored as a two-dimensional REAL
C            array.
C
C NCOL, NROW are the dimensions of the input image.
C
C       SUBT is the address of some working space where ALLSTAR can
C            keep a scratch copy of the image.
C
C     SIGMA is the address of some working space where ALLSTAR can
C            keep track of the standard errors of the individual pixels
C
C     FITRAD is the user-definable parameter "Fitting radius."  It
C            governs how many pixels out from the centroid of the star
C            will actually be considered in computing the least-
C            squares profile fits.
C
C      WATCH is the 'watch progress' parameter specified by the user.
C            If WATCH > 0, information relating to the progress of
C            the reductions will be typed on the terminal during
C            execution.
C
C HALF, IEXP are the "Clipping radius" and "Clipping exponent"
C            parameters which specify the degree to which discordant
C            pixels are to be ignored.
C
C     CENTER is a logical specifying whether the user wants the stellar
C            centroids to be redetermined.
C
C     MAXGRP is the largest group size for which the solution is to be
C            performed.
C
C=======================================================================
C
      IMPLICIT NONE
      INTEGER MAXSTR, MAXPSF, MAXIT, MAXMAX, MAXPAR, MAXEXP
      PARAMETER (MAXSTR=50000, MAXPSF=145, MAXIT=200, MAXMAX=100,
     .     MAXPAR=6, MAXEXP=6)
C
C Parameters:
C
C MAXSTR The maximum number of stars in a frame.
C
C MAXPSF the largest PSF look-up table that can be accomodated.  If
C        PSFMAX is the largest acceptable PSF radius (see main-line
C        program above), then MAXPSF = 2*[2*(PSFMAX+1)]+7.
C
C MAXMAX is the largest group for which a solution will ever be
C        attempted = maximum permissible value of MAXGRP.
C
      INTEGER NCOL, NROW
      CHARACTER*30 COOFIL, MAGFIL, PSFFIL, PROFIL, GRPFIL, SWITCH
      CHARACTER LINE*80, SUBPIC*30, EXTEND*30, CASE*5
      REAL C(3*MAXMAX+1,3*MAXMAX+1), V(3*MAXMAX+1), X(3*MAXMAX+1)
      REAL DATA(NCOL,NROW), SUBT(NCOL,NROW), SIGMA(NCOL,NROW)
      REAL PSF(MAXPSF,MAXPSF,MAXEXP), PAR(MAXPAR)
C
      REAL XC(MAXSTR+1), YC(MAXSTR+1), MAG(MAXSTR+1), SKY(MAXSTR+1)
      REAL RPIXSQ(MAXSTR), CHI(MAXSTR), SUMWT(MAXSTR)
      REAL NUMER(MAXSTR), DENOM(MAXSTR)
      REAL MAGERR(MAXSTR), DXOLD(MAXSTR), DYOLD(MAXSTR)
      REAL XCLAMP(MAXSTR), YCLAMP(MAXSTR)
C
      SAVE XC, YC, MAG, SKY
      SAVE RPIXSQ, CHI, SUMWT
      SAVE NUMER, DENOM
      SAVE MAGERR, DXOLD, DYOLD
      SAVE XCLAMP, YCLAMP
C
      INTEGER ID(MAXSTR+1)
      INTEGER NPIX(MAXSTR)
      LOGICAL SKIP(MAXSTR), LAST(MAXSTR)
C
      REAL AMIN1, AMAX1, ABS, SQRT, USEPSF
      INTEGER MIN0, MAX0, INT, RDPSF
C
      REAL LOBAD, HIBAD, ERR, SEP, THRESH, AP1, PHPADU, RONOIS, DUM
      REAL FAINT, CLMPMX, WCRIT, RADIUS, XMIN, XMAX, YMIN, YMAX
      REAL PERERR, PROERR, SKYIN, SKYOUT, SKYISQ, SKYOSQ, RELERR
      REAL PSFMAG, BRIGHT, XPSF, YPSF, SEPCRT, SEPMIN, PSFRAD, PEAK
      REAL FITRAD, WATCH, HALF, PKERR, PSFRSQ, RADSQ, RSQ, DX, DYSQ
      REAL SIGSQ, WT, VAL, RHOSQ, DWT, SKYBAR, CHIGRP, SUMRES, GRPWT
      REAL DPOS, DFDSIG, XKWT, DF, DIFF, SHARP, DELTAX, DELTAY, D, DY
      REAL DVDXC, DVDYC, Y
      INTEGER I, J, K, L, IFAINT, IDUM, IY, IX, NSTAR, NCONV, NITER
      INTEGER MAXGRP, ITSKY, MINSKY, MAXUNK, LX, LY, ISTAT, INTRVL
      INTEGER IPSTYP, NPSF, NPAR, NEXP, NFRAC, NL
      INTEGER IEXP, IXMIN, IXMAX, IYMIN, IYMAX, MX, MY, NDISAP
      INTEGER I3, J3, LSTAR, NSTR, NTERM, I3M2, ISTAR, N
      LOGICAL CENTER, CLIP, OMIT, REDO
C
      COMMON /FILNAM/ COOFIL, MAGFIL, PSFFIL, PROFIL, GRPFIL
C
      DATA SUMWT /MAXSTR*1./
C
C-----------------------------------------------------------------------
C
C SECTION 1
C
C Get ready, get set, . . .
C
      SKYISQ = SKYIN**2
      SKYOSQ = AMIN1(SKYOUT**2, SKYISQ + (MAXSTR-1)/3.1415927)
      SKYOUT = AMIN1(SKYOUT, SQRT(SKYOSQ))
      ITSKY = 3
      MINSKY = 100.
      MAXUNK=MAXMAX*3+1            ! Largest possible number of unknowns
      CALL TBLANK                                  ! Type a blank line
C
C Read the point-spread function into memory.
C
  950 CALL GETNAM ('File with the PSF:', PSFFIL)
      IF ((PSFFIL .EQ. 'END OF FILE') .OR.
     .     (PSFFIL .EQ. 'GIVE UP')) RETURN
C
      ISTAT = RDPSF (PSFFIL, IPSTYP, PAR, MAXPAR, NPAR,
     .     PSF, MAXPSF, MAXEXP, NPSF, NEXP, NFRAC,
     .     PSFMAG, BRIGHT, XPSF, YPSF)
      IF (ISTAT .NE. 0) THEN
         PSFFIL = 'GIVE UP'
         GO TO 950
      END IF
      PEAK = USEPSF(IPSTYP, 0., 0., BRIGHT, PAR, PSF, NPSF,
     .     NPAR, NEXP, NFRAC, 0., 0., DVDXC, DVDYC)
C
C Stars will be checked for merger if they are separated by less than
C 1 FWHM of the image core.
C
C     Crit. sep. = 2.355*sigma, where
C          sigma = SQRT [ (sigma(X)**2 + sigma(Y)**2)/2 ]
C
      SEPCRT=2.*(PAR(1)**2+PAR(2)**2)
C
C Stars will be considered unconditionally merged if they are separated
C by less than about 0.375 * FWHM.
C
      SEPMIN=AMIN1(1.,0.14*SEPCRT)
C
C SEPCRT contains the square of the critical separation.
C SEPMIN  contains the square of the minimum separation.
C
      PKERR=PROERR/(PAR(1)*PAR(2))**2      ! See fitting errors below
C
      PSFRAD = (REAL(NPSF-1)/2.-1.)/2.
      PSFRSQ = PSFRAD**2
C
C Ascertain the name of the file with the input photometry, and open it.
C
  960 CALL GETNAM ('Input file:', MAGFIL)
      IF ((MAGFIL .EQ. 'END OF FILE') .OR.
     .     (MAGFIL .EQ. 'GIVE UP')) RETURN
C
      CALL INFILE (2, MAGFIL, ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error opening input file '//MAGFIL)
         MAGFIL = 'GIVE UP'
         GO TO 960
      END IF
C
      CALL RDHEAD (2, NL, IDUM, IDUM, LOBAD, HIBAD, THRESH, AP1,
     .     PHPADU, RONOIS, DUM)
      IF ((NL .LT. 1) .OR. (NL .GT. 3)) THEN
         CALL STUPID ('Not a valid input file.')
         CALL CLFILE (2)
         MAGFIL = 'GIVE UP'
         GO TO 960
      END IF
C
C Inquire the name of the output file, and open it.
C
      PROFIL=SWITCH(MAGFIL, CASE('.als'))
  970 CALL GETNAM ('File for results:', PROFIL)
      IF ((PROFIL .EQ. 'END OF FILE') .OR.
     .     (PROFIL .EQ. 'GIVE UP')) RETURN
C
      PROFIL = EXTEND(PROFIL, CASE('als'))
      CALL OUTFIL (1, PROFIL, ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error opening output file '//PROFIL)
         PROFIL = 'GIVE UP'
         GO TO 970
      END IF
      CALL WRHEAD (1, 1, NCOL, NROW, 7, LOBAD, HIBAD, THRESH, AP1,
     .     PHPADU, RONOIS, FITRAD)
C
C Name for the output image.
C
      SUBPIC=SWITCH(PROFIL, CASE('s'))
      CALL GETNAM ('Name for subtracted image:', SUBPIC)
C
C We need to keep track of the anticipated standard error of the
C brightness value in a given pixel as the reductions proceed.
C
      RONOIS=RONOIS**2
C
      LX = 1
      L = 1
      DO IY=1,NROW
         LY = IY
         CALL RDARAY ('DATA', LX, LY, NCOL, L, NCOL, DATA(1,IY), ISTAT)
         IF (ISTAT .NE. 0) THEN
            CALL STUPID ('Error reading picture.')
            RETURN
         END IF
C
         DO IX=1,NCOL
            IF ((DATA(IX,IY) .GT. HIBAD) .OR.
     .           (DATA(IX,IY) .LT. LOBAD)) THEN
               SIGMA(IX,IY) = -1.1E38
            ELSE
               SIGMA(IX,IY) = RONOIS
            END IF
         END DO
      END DO
C
      RADSQ=FITRAD**2
      NSTAR=0
C
C Read in all the stars.
C
      FAINT=PSFMAG+12.5
      CLMPMX=0.25*FITRAD
      I=0
 1110 I=I+1
      IF (I .GT. MAXSTR) THEN
         CALL STUPID ('Too many stars.')
         CALL CLPIC ('DATA')
         CALL BYEBYE
      END IF
 1120 CALL RDSTAR (2, NL, ID(I), XC(I), YC(I), MAG(I), SKY(I))
      IF (ID(I) .LT. 0) GO TO 2000        ! End-of-file was encountered
      IF (ID(I) .EQ. 0) GO TO 1120        ! A blank line was encountered
      IF (MAG(I) .LT. FAINT) THEN
         MAG(I)=10.**(0.4*(PSFMAG-MAG(I)))
      ELSE
         MAG(I)=0.003
      END IF
      DXOLD(I)=0.
      DYOLD(I)=0.
      XCLAMP(I)=CLMPMX
      YCLAMP(I)=CLMPMX
      GO TO 1110
C
C-----------------------------------------------------------------------
C
C SECTION 2
C
C GO.
C
 2000 NSTAR=I-1                                      ! Number of stars
      CALL CLFILE (2)
      WRITE (6,5552) NSTAR
 5552 FORMAT (/1X, I5, ' stars.  <<')
      WRITE (6,610)
  610 FORMAT (//' I = iteration number',
     .        //' R = number of stars that remain'
     .        //' D = number of stars that disappeared'
     .        //' C = number of stars that converged'
     .       //)
      CALL OVRWRT ('     I     R     D     C', 1)
C
C Initialize accumulators and constraints on parameter corrections.
C
      NCONV=0
      NITER=0
      CALL STRIP (ID, XC, YC, MAG, SKY, SKIP, MAXSTR,
     .     NSTAR, NDISAP, SQRT(SEPMIN), NUMER, DENOM)
      IF (NDISAP .GT. 0) THEN
         WRITE (LINE,682) NITER, NSTAR, NDISAP, NCONV
         CALL OVRWRT (LINE(1:28), 3)
      END IF
C
 2100 NITER = NITER+1
      CLIP = (IEXP .NE. 0) .AND. (NITER .GE. 4)
C
C Set up critical errors for star rejection.
C
      WCRIT = 0.
      IF (NITER .GE. 5) WCRIT = 1.0
      IF (NITER .GE. 10) WCRIT = 1.5
      IF (NITER .GE. 15) WCRIT = 2.0
C
C Sort stars by y-coordinate, for minimum paging.
C
      CALL QUICK (YC, NSTAR, NUMER)
      CALL IRECTFY (ID, NSTAR, NUMER, DENOM)
      CALL RECTFY (XC, NSTAR, NUMER, DENOM)
      CALL RECTFY (MAG, NSTAR, NUMER, DENOM)
      CALL RECTFY (SKY, NSTAR, NUMER, DENOM)
      CALL RECTFY (SUMWT, NSTAR, NUMER, DENOM)
      CALL RECTFY (DXOLD, NSTAR, NUMER, DENOM)
      CALL RECTFY (DYOLD, NSTAR, NUMER, DENOM)
      CALL RECTFY (XCLAMP, NSTAR, NUMER, DENOM)
      CALL RECTFY (YCLAMP, NSTAR, NUMER, DENOM)
C
C Determine how much of the image we need to copy into the working area.
C
C First determine the big rectangular area that contains all the pixels
C within one working radius of any star.  The "working radius" is
C either the fitting radius or the outer sky radius (if this is an
C iteration during which the sky is to be determined), whichever is
C larger.  Set their SIGMAs negative.
C
      IF ((MOD(NITER, ITSKY) .EQ. 0) .AND. (SKYOUT .GT. FITRAD))
     .     THEN
         RADIUS = SKYOUT
      ELSE
         RADIUS = FITRAD
      END IF
C
      XMIN=NCOL+RADIUS
      XMAX=-RADIUS
      DO I=1,NSTAR
         XMIN=AMIN1(XMIN, XC(I))
         XMAX=AMAX1(XMAX, XC(I))
      END DO
C
      IXMIN=MAX0(1, MIN0(NCOL, INT(XMIN-RADIUS)+1))
      IXMAX=MAX0(1, MIN0(NCOL, INT(XMAX+RADIUS)))
      IYMIN=MAX0(1, MIN0(NROW, INT(YC(1)-RADIUS)+1))
      IYMAX=MAX0(1, MIN0(NROW, INT(YC(NSTAR)+RADIUS)))
C
      IF (WATCH .GT. 0.5) THEN
C
C Set up reporting intervals for row counter.
C
         D=AMAX1(0.1, ALOG10(FLOAT(IYMAX-IYMIN+1)/10.))
         INTRVL=INT(D)
         D=D-FLOAT(INTRVL)
         IF (D .GT. 0.8) THEN
            INTRVL=10**(INTRVL+1)
         ELSE IF (D .GT. 0.5) THEN
            INTRVL=5*10**INTRVL
         ELSE IF (D .GT. 0.2) THEN
            INTRVL=2*10**INTRVL
         ELSE
            INTRVL=10**INTRVL
         END IF
      END IF
C
C Beginning of big loop over y-coordinates.
C
      RSQ = RADIUS**2
      N = 0
      L = 0
      DO 2190 IY=IYMIN,IYMAX
         Y = REAL(IY)
         DO IX=IXMIN,IXMAX
            SIGMA(IX,IY) = -ABS(SIGMA(IX,IY))
         END DO
C
C OK.  Now find all the points within one working radius of each
C star.  Set the sigmas of these pixels positive again and copy
C them from DATA to SUBT.
C
C N points at the last star that has such a low x-coordinate
C that it can be omitted.
C
         DO 2120 I=N+1,NSTAR
            DY = Y - YC(I)
C
            IF (DY .GT. RADIUS) THEN
               N = I
               GO TO 2120
            ELSE IF (DY .LT. -RADIUS) THEN
               GO TO 2150
            ELSE
               DYSQ = (REAL(IY) - YC(I))**2
               LX=MAX0(1, MIN0(NCOL, INT(XC(I)-RADIUS)+1))
               MX=MAX0(1, MIN0(NCOL, INT(XC(I)+RADIUS)))
               DO IX=LX,MX
                  DX = REAL(IX) - XC(I)
                  IF (DX**2+DYSQ .LE. RSQ) THEN
                     IF (SIGMA(IX,IY) .GT. -1.E38) THEN
                        SIGMA(IX,IY) = ABS(SIGMA(IX,IY))
                        SUBT(IX,IY) = DATA(IX,IY)
                     END IF
                  ELSE
                     IF (DX .GE. 0.) GO TO 2120
                  END IF
               END DO
            END IF
 2120    CONTINUE
C
C Subtract from the working copy of the image (SUBT) each star which
C has not yet converged by subtracting the shifted, scaled PSF
C according to the current best parameter estimates; do this only
C for pixels with positive SIGMAs, indicating that
C they will actually be needed for this iteration.
C
C L points at the last star that has such a low y-coordinate
C that it can be omitted.
C
 2150    CONTINUE
         DO 2170 I=L+1,NSTAR
            DY = Y - YC(I)
            IF (DY .GT. PSFRAD) THEN
               L = I
               GO TO 2170
            ELSE IF (DY .LT. -PSFRAD) THEN
               GO TO 2180
            ELSE
               LX=MAX0(IXMIN, MIN0(IXMAX, INT(XC(I)-PSFRAD)+1))
               MX=MAX0(IXMIN, MIN0(IXMAX, INT(XC(I)+PSFRAD)))
               DELTAX=(XC(I)-1.)/XPSF-1.
               DELTAY=(YC(I)-1.)/YPSF-1.
               DYSQ=DY**2
               DO 2160 IX=LX,MX
                  IF (SIGMA(IX,IY) .GT. 0.) THEN
                     DX=FLOAT(IX)-XC(I)
                     IF (DX**2+DYSQ .LT. PSFRSQ) THEN
                        SUBT(IX,IY)=SUBT(IX,IY)-
     .                       MAG(I)*USEPSF(IPSTYP, DX, DY, BRIGHT,
     .                       PAR, PSF, NPSF, NPAR, NEXP, NFRAC,
     .                       DELTAX, DELTAY, DVDXC, DVDYC)
                     ELSE
                        IF (DX .GT. 0.) GO TO 2170
                     END IF
                  END IF
 2160          CONTINUE
            END IF
 2170    CONTINUE
 2180    IF ((WATCH .GT. 0.5) .AND.
     .        (INTRVL*(IY/INTRVL) .EQ. IY)) THEN
            WRITE (LINE, 5551) IYMIN, IY, IYMAX
 5551       FORMAT (3I5)
            CALL OVRWRT (LINE(1:15), 2)
         END IF
 2190 CONTINUE
C
C If sky values are to be redetermined this iteration, do it now.
C
      IF ((SKYOUT .GT. 0.5) .AND. (MOD(NITER, ITSKY) .EQ. 0))
     .     THEN
         DO 2198 ISTAR=1,NSTAR
            LX=MAX0(IXMIN, MIN0(IXMAX, INT(XC(ISTAR)-SKYOUT)+1))
            MX=MAX0(IXMIN, MIN0(IXMAX, INT(XC(ISTAR)+SKYOUT)))
            LY=MAX0(IYMIN, MIN0(IYMAX, INT(YC(ISTAR)-SKYOUT)+1))
            MY=MAX0(IYMIN, MIN0(IYMAX, INT(YC(ISTAR)+SKYOUT)))
            N = 0
c           nbad = 0
            DO 2196 J=LY,MY
               DYSQ = (REAL(J) - YC(ISTAR))**2
               DO 2194 I = LX,MX
                  DX = REAL(I) - XC(ISTAR)
                  RSQ = DX**2 + DYSQ
                  IF (RSQ .GT. SKYOSQ) THEN
                     IF (DX .GT. 0.) THEN
                        GO TO 2196
                     ELSE
                        GO TO 2194
                     END IF
                  END IF
C
                  IF (RSQ .GE. SKYISQ) THEN
                     IF (SIGMA(I,J) .GT. -1.E38) THEN
                        N = N+1
                        NUMER(N) = SUBT(I,J)
                        IF (N .GE. MAXSTR) GO TO 2197
c                       else
c                          nbad = nbad+1
                     END IF
                  END IF
C
 2194          CONTINUE
 2196       CONTINUE
C
 2197       IF (N .GT. MINSKY) THEN
               CALL QUICK (NUMER, N, DENOM)
               J = NINT(0.2*N)
               DX = 0.
               DO I=(N+1)/2-J,(N/2)+1+J
                  DX = DX + NUMER(I)
               END DO
               SKY(ISTAR) = DX/REAL((N/2)+2*J+2-(N+1)/2)
            END IF
 2198    CONTINUE
      END IF
C
C Create provisional star groups.
C
      CALL REGRP (ID, XC, YC, MAG, SKY, SUMWT, DXOLD, DYOLD,
     .     XCLAMP, YCLAMP, MAXSTR, NSTAR, FITRAD, LAST, NUMER,
     .     DENOM)
C
C Now get ready to do the next iteration, group by group.
C
      IF (WATCH .GT. 0.5) THEN
C
C Set up reporting intervals for star counter.
C
         D=AMAX1(0.1, ALOG10(FLOAT(NSTAR)/10.))
         INTRVL=INT(D)
         D=D-FLOAT(INTRVL)
         IF (D .GT. 0.8) THEN
            INTRVL=10**(INTRVL+1)
         ELSE IF (D .GT. 0.5) THEN
            INTRVL=5*10**INTRVL
         ELSE IF (D .GT. 0.2) THEN
            INTRVL=2*10**INTRVL
         ELSE
            INTRVL=10**INTRVL
         END IF
      END IF
      RADIUS=FITRAD
      ISTAR=1
 2200 CONTINUE
C
C Find the last star in the current group.
C
      DO LSTAR = ISTAR,NSTAR
         IF (LAST(LSTAR)) GO TO 2210
      END DO
      LSTAR=NSTAR
 2210 NSTR=LSTAR-ISTAR+1
C
C Start crunching on this group.
C
      IF (NSTR .GT. MAXGRP) THEN
         IF (WATCH .GT. 1.5) THEN
            WRITE (LINE,61) NSTR, RADIUS
   61       FORMAT ('Group too large:', I5, '  (', F5.2, ')')
            CALL OVRWRT (LINE(1:30), 3)
         END IF
         RADIUS=0.95*RADIUS
         IF (CENTER .AND. (NITER .GE. 2)) THEN
            IF (RADIUS .LT. 1.2) THEN
               IF (WATCH .GT. 1.5) THEN
                  WRITE (LINE,62)
   62             FORMAT ('Group too dense to reduce.')
                  CALL OVRWRT (LINE(1:26), 3)
               END IF
C
C Mark the faintest star in this group for deletion.
C
               FAINT=100.
               DO I=ISTAR,LSTAR
                  IF (MAG(I) .LT. FAINT) THEN
                     FAINT=MAG(I)
                     L=I
                  END IF
               END DO
               IF (WATCH .GT. 1.5) THEN
                  WRITE (6,63) ID(L), XC(L), YC(L),
     .                 PSFMAG-1.085736*ALOG(MAG(L)), ' group too dense'
   63             FORMAT (1X, I5, 2F9.3, F9.3, 9X, A, F6.3)
               END IF
               SKIP(L)=.TRUE.                        ! Flag for deletion
               NDISAP=NDISAP+1
               GO TO 3000
            END IF
         ELSE
            IF (RADIUS .LT. 0.8) THEN
               IF (WATCH .GT. 1.5) THEN
                  WRITE (LINE,62)
                  CALL OVRWRT (LINE(1:26), 3)
               END IF
C
C Mark the faintest star in this group for deletion.
C
               FAINT=100.
               DO I=ISTAR,LSTAR
                  IF (MAG(I) .LT. FAINT) THEN
                     FAINT=MAG(I)
                     L=I
                  END IF
               END DO
               IF (WATCH .GT. 1.5) WRITE (6,63) ID(L), XC(L), YC(L),
     .              PSFMAG-1.085736*ALOG(MAG(L)), ' group too dense'
               SKIP(L)=.TRUE.                        ! Flag for deletion
               NDISAP=NDISAP+1
               GO TO 3000
            END IF
         END IF
         L = NSTR
         CALL REGRP (ID(ISTAR), XC(ISTAR), YC(ISTAR), MAG(ISTAR),
     .        SKY(ISTAR), SUMWT(ISTAR), DXOLD(ISTAR), DYOLD(ISTAR),
     .        XCLAMP(ISTAR), YCLAMP(ISTAR), L, NSTR, RADIUS,
     .        LAST(ISTAR), NUMER(ISTAR), DENOM(ISTAR))
         GO TO 2200
      END IF
C
      RADIUS=FITRAD
      XMIN=NCOL+FITRAD
      XMAX=-FITRAD
      YMIN=NROW+FITRAD
      YMAX=-FITRAD
C
C Get the extent of the rectangular area of the frame relevant to this
C group.  At the same time, determine the average SKY and the average
C CHI value for the group, and zero the various statistical
C accumulators.  What we would REALLY like to do is to compute the
C anticipated error for each pixel the same way as PEAK and NSTAR do.
C We can't really do that, because stellar groups aren't defined the
C same way as in NSTAR: here they change as stars move from one group
C to another, or converge and are subtracted from the frame.  Therefore,
C there is no consistent way to define a group's CHI value the same as
C was done in NSTAR.  I will take the cheap way out:  using the
C individual smoothed CHI values for the stars which were obtained
C during the previous iteration (which should still be stored in the
C array SUMWT) I will simply average those values and call the mean the
C group's effective smoothed CHI.  This way, at least, the reductions
C will be the same as before for isolated stars.  (Note that,
C for the first iteration, the SUMWT's have been set to 1.0 by a DATA
C statement above.)
C
      SKYBAR = 0.
      CHIGRP = 0.
      DO I=ISTAR,LSTAR
         XMIN = AMIN1(XMIN, XC(I))
         XMAX = AMAX1(XMAX, XC(I))
         YMIN = AMIN1(YMIN, YC(I))
         YMAX = AMAX1(YMAX, YC(I))
         SKYBAR = SKYBAR+SKY(I)
         CHIGRP = CHIGRP+SUMWT(I)
         CHI(I) = 0.
         SUMWT(I) = 0.
         NUMER(I) = 0.
         DENOM(I) = 0.
         NPIX(I) = 0
      END DO
      SKYBAR = SKYBAR/FLOAT(NSTR)
      CHIGRP = CHIGRP/FLOAT(NSTR)
      IF (CENTER .AND. (NITER .GE. 2)) THEN
         NTERM=3*NSTR
      ELSE
         NTERM=NSTR
      END IF
C
C If sky is to be determined: NTERM=NTERM+1
C
C Now... on with the iteration.
C
      IXMIN=MIN0(NCOL, MAX0(1, INT(XMIN-FITRAD)+1))
      IXMAX=MIN0(NCOL, MAX0(1, INT(XMAX+FITRAD)))
      IYMIN=MIN0(NROW, MAX0(1, INT(YMIN-FITRAD)+1))
      IYMAX=MIN0(NROW, MAX0(1, INT(YMAX+FITRAD)))
C
C IXMIN, IXMAX, IYMIN, and IYMAX are now the limits of a rectangular
C array containing all pixels within one fitting radius of any star in
C the group.
C
C Zero the normal matrix and the vector of residuals.
C
      DO 2270 J=1,NTERM
      V(J)=0.0
      DO 2270 I=J,NTERM
 2270 C(I,J)=0.0
      SUMRES=0.
      GRPWT=0.
C
C Now deal with the pixels one by one.
C
      DO 2390 IY=IYMIN,IYMAX
      DO 2380 IX=IXMIN,IXMAX
      IF (SIGMA(IX,IY) .LE. 0.) GO TO 2380
C
C If this pixel is within one fitting radius of at least one star in
C the current group, include it in the calculation.  Otherwise, skip
C it.  While figuring this out, compute the squared distance of this
C pixel from the centroid of each star in the group.
C
      OMIT=.TRUE.
      DO I=ISTAR,LSTAR
         RPIXSQ(I)=(FLOAT(IX)-XC(I))**2+(FLOAT(IY)-YC(I))**2
         IF (RPIXSQ(I) .LT. RADSQ) THEN
            OMIT=.FALSE.
         END IF
      END DO
      IF (OMIT) GO TO 2380                      ! Do not need this pixel
C
      DO I=ISTAR,LSTAR
         IF (RPIXSQ(I) .LT. RADSQ) THEN
            SKIP(I)=.FALSE.
         ELSE
            SKIP(I)=.TRUE.
         END IF
      END DO
C
C The expected random error in the pixel is the quadratic sum of
C the Poisson statistics, plus the readout noise, plus an estimated
C error of 0.75% of the total brightness for the difficulty of flat-
C fielding and bias-correcting the chip, plus an estimated error of
C some fraction of the fourth derivative at the peak of the profile,
C to account for the difficulty of accurately interpolating within the
C point-spread function.  The fourth derivative of the PSF is
C proportional to H/sigma**4 (sigma is the Gaussian width parameter for
C the stellar core); using the geometric mean of sigma(x) and sigma(y),
C this becomes H/[sigma(x)*sigma(y)]**2.  The ratio of the fitting
C error to this quantity is estimated from a good-seeing CTIO frame to
C be approximately 0.027 (see definition of PKERR above.)
C
      D=SUBT(IX,IY)-SKYBAR                      ! Residual of this pixel
      DPOS=AMAX1(0., DATA(IX,IY)-D)
C
C    DPOS = raw data minus residual
C         = model-predicted brightness in this pixel, consisting of sky
C           plus all stellar profiles, which presumably is non-negative.
C
C The four error sources in our noise model are:
C     (1) Readout noise
C     (2) Poisson noise
C     (3) Flat-field errors
C     (4) Errors in the PSF
C
C Numerically, the squares of these quantities are
C     (1) RONOIS = SIGMA(IX,IY)   (initially, at least)
C     (2) DPOS/PHPADU where DPOS = sum of the stellar profiles plus sky
C     (3) constant x DPOS**2
C     (4) constant x the sum of (stellar profile)**2
C
C Here's the thing:  at this point we don't have the
C sum of (stellar profile)**2 available to us.  All we have is
C (sum of stellar profile)**2, which isn't the same thing at all.
C Nevertheless, we have to assume that
C
C     sum of (stellar profile)**2 = (sum of stellar profile)**2;
C
C otherwise I'd have to use a whole new REAL array as big as the
C original CCD image, and I don't want to do that.  This should be
C good enough for pixels where either (a) the other three error sources
C dominate, .OR. (b) one of the stars putting light into that pixel is
C much brighter than all the rest.  Thus, the approximation should be
C good UNLESS the pixel is near the center of two or more bright
C stars --- in which case things will be hairy anyway.
C
      SIGSQ = SIGMA(IX,IY) + DPOS/PHPADU + (PERERR*DPOS)**2 +
     .     (PKERR*(DPOS-SKYBAR))**2
      RELERR=ABS(D)/SQRT(SIGSQ)
      IF (CLIP .AND. (RELERR .GT. 100.)) GO TO 2380
      WT=0.
C
C Now include this pixel in the fitting equations for the group.
C
      DO 2320 I=ISTAR,LSTAR
      IF (SKIP(I)) GO TO 2320
      RSQ=RPIXSQ(I)/RADSQ
      IF (RSQ .GE. 0.999999) GO TO 2320  ! Safety check vs divide by 0
      WT=AMAX1(WT, 5./(5.+RSQ/(1.-RSQ)))
C
C The condition equation for pixel (IX,IY) is of the form
C
C data(IX,IY)-summation{scale*psf(IX-Xcenter,IY-Ycenter)}-sky=residual
C
C Then we will jigger the scale's, Xcenter's, and Ycenter's such that
C
C                Summation{weight * residual**2}
C
C is minimized.  'weight' will be a function (1) of the distance of this
C pixel from the center of the nearest star, (2) of the model-predicted
C brightness of the pixel (taking into consideration the readout noise,
C the photons/ADU, and the interpolation error of the PSF), and (3) of
C the size of the residual itself.  (1) is necessary to prevent the
C non-linear least-squares solution from oscillating:  oft-times it will
C come to pass that if you include a pixel in the solution, then the
C predicted shift of the centroid will cause that pixel to be excluded
C in the next iteration, and the new predicted shift of the centroid
C will cause that pixel to be included again.  This could go on ad
C infinitum.  The cure is to have the weight of a pixel go
C continuously to zero as its distance from the stellar centroid
C approaches the fitting radius.  In a case like that just described,
C the solution can then find a real minimum of the sum of the
C weighted squared residuals with that pixel at some low-weight position
C just inside the fitting radius.  (2) is just sensible weighting.
C (3) is just a crude attempt at making the solution more robust against
C bad pixels.
C
      VAL = USEPSF(IPSTYP, FLOAT(IX)-XC(I), FLOAT(IY)-YC(I), BRIGHT,
     .     PAR, PSF, NPSF, NPAR, NEXP, NFRAC, (XC(I)-1.)/XPSF-1.,
     .     (YC(I)-1.)/YPSF-1., DVDXC, DVDYC)
      IF (NTERM .GT. NSTR) THEN
         I3=(I-ISTAR+1)*3
         K=I3-2
         X(K)=-VAL
         K=I3-1
         X(K)=-MAG(I)*DVDXC
         X(I3)=-MAG(I)*DVDYC
      ELSE
         K=I-ISTAR+1
         X(K)=-VAL
      END IF
      RHOSQ=((XC(I)-FLOAT(IX))/PAR(1))**2+
     .     ((YC(I)-FLOAT(IY))/PAR(2))**2
      IF (RHOSQ .LE. 36.) THEN
         RHOSQ = 0.6931472*RHOSQ
         DFDSIG = EXP(-RHOSQ)*(RHOSQ-1.)
         NUMER(I) = NUMER(I)+DFDSIG*D/SIGSQ
         DENOM(I) = DENOM(I)+DFDSIG**2/SIGSQ
      END IF
 2320 CONTINUE
C
C At this point, the vector X contains the first derivative of
C the condition equation for pixel (IX,IY) with respect to each of
C the fitting parameters for all of the stars. Now these derivatives
C will be added into the normal matrix and the vector of residuals.
C
C Add this residual into the weighted sum of the absolute relative
C residuals.
C
      DWT=WT*RELERR
      SUMRES=SUMRES+DWT
      GRPWT=GRPWT+WT
C
C SUMRES is the weighted sum of [ABS(residual)/sigma] for all the
C pixels in the group.  Now also add the weighted value of
C [ABS(residual)/sigma] into the accumulating sum for each of the
C stars.
C
      DO 2330 I=ISTAR,LSTAR
      IF (SKIP(I)) GO TO 2330
      CHI(I)=CHI(I)+DWT
      SUMWT(I)=SUMWT(I)+WT
      NPIX(I)=NPIX(I)+1
 2330 CONTINUE
C
C Up until now, WT represents only the radial weighting profile.  Now
C figure in the anticipated standard error of the pixel.  Reject any
C pixel with a 100-sigma residual after iteration 2.
C
      WT=WT/SIGSQ
      IF (CLIP) WT=WT/(1.+(RELERR/(CHIGRP*HALF))**IEXP)
C
C Now work this pixel into the normal matrix.
C
      DWT=D*WT
C     If sky is to be determined: C(NTERM,NTERM)=C(NTERM,NTERM)+WT
C     If sky is to be determined: V(NTERM)=V(NTERM)-DWT
      DO 2370 I=ISTAR,LSTAR
      IF (SKIP(I)) GO TO 2370
      IF (NTERM .GT. NSTR) THEN
         I3=(I-ISTAR+1)*3
         I3M2=I3-2
         DO 2340 K=I3M2,I3
C        If sky is to be determined: C(NTERM,K)=C(NTERM,K)-X(K)*WT
 2340    V(K)=V(K)+X(K)*DWT
         DO 2360 J=ISTAR,I
         IF (SKIP(J)) GO TO 2360
         J3=(J-ISTAR+1)*3
         DO 2350 K=I3M2,I3
         XKWT=X(K)*WT
         DO 2350 L=J3-2,MIN0(K, J3)
 2350    C(K,L)=C(K,L)+X(L)*XKWT
 2360    CONTINUE
      ELSE
         K=I-ISTAR+1
         V(K)=V(K)+X(K)*DWT
         XKWT=X(K)*WT
C        If sky is to be determined: C(NTERM,K)=C(NTERM,K)-XKWT
         DO 2365 J=ISTAR,I
         IF (SKIP(J)) GO TO 2365
         L=J-ISTAR+1
         C(K,L)=C(K,L)+X(L)*XKWT
 2365    CONTINUE
      END IF
 2370 CONTINUE
C
 2380 CONTINUE
 2390 CONTINUE
C
C Reflect the normal matrix across the diagonal.
C
      IF (NTERM .GT. 1) THEN
         DO 2410 L=2,NTERM
         DO 2410 K=1,L-1
 2410    C(K,L)=C(L,K)
      END IF
C
C Compute the estimate of the standard deviation of the residuals for
C the group as a whole, and for each star.  This estimate starts out as
C SQRT(PI/2)*{SUM[weight*ABS(residual/sigma)]/SUM(weight)} and then gets
C corrected for bias by SQRT(no. of pixels/(no. of pixels - degrees of
C freedom)).
C
      IF (GRPWT .GT. NTERM) THEN
         CHIGRP=1.2533141*SUMRES/SQRT(GRPWT*(GRPWT-NTERM))
C
C But then I drive the value toward unity, depending on exactly how
C many pixels were involved:  if CHI is based on exactly a total
C weight of 3, then it is extremely poorly determined, and we just
C want to keep CHI = 1.  The larger GRPWT is, the better determined
C CHI is, and the less we want to force it toward unity.  So,
C just take the weighted average of CHI and unity, with weights
C GRPWT-3 and 1, respectively.
C
         CHIGRP=((GRPWT-3.)*CHIGRP+3.)/GRPWT
      ELSE
         CHIGRP=1.
      END IF
C
C CHIGRP has been pulled toward its expected value of unity to keep the
C statistics of a small number of pixels from compeletely dominating
C the error analysis.  Similarly, the photometric errors for the
C individual stars will be pulled toward unity now.  Later on, if the
C number of stars in the group is greater than one, CHI(I) will be
C nudged toward the group average.  In order to work optimally, of
C course, this requires that PHPADU, RONOIS, and the other noise
C contributors which I have postulated properly represent the true
C errors expected in each pixel.
C
C At the same time, be sure that every star in the group contains at
C least 3 valid pixels if recentroiding is being performed, 1 valid
C pixel if not.  If any star in the group fails to meet this criterion
C mark that star for deletion, set REDO to true, and skip ahead to the
C next group.
C
      REDO=.FALSE.
      DO I=ISTAR,LSTAR
         IF (CENTER .AND. (NITER .GE. 2)) THEN
            IF (NPIX(I) .LT. 3) THEN
               REDO=.TRUE.
               IF (WATCH .GT. 1.5) WRITE (6,63) ID(I), XC(I), YC(I),
     .              PSFMAG-1.085736*ALOG(MAG(I)),
     .              ' too few valid pixels'
               SKIP(I)=.TRUE.                    ! Flag for deletion
               NDISAP=NDISAP+1
            ELSE
               SKIP(I)=.FALSE.                   ! Flag for retention
               I3=(I-ISTAR+1)*3-2
               IF (SUMWT(I) .GT. 3.) THEN
                  CHI(I)=1.2533141*CHI(I)/SQRT(SUMWT(I)*(SUMWT(I)-3.))
C
C Store a smoothed CHI value for the star in SUMWT.
C
                  SUMWT(I) = ((SUMWT(I)-3.)*CHI(I) + 3.)/SUMWT(I)
               ELSE
                  CHI(I)=CHIGRP
               END IF
            END IF
         ELSE
            IF (NPIX(I) .LT. 1) THEN
               REDO=.TRUE.
               SKIP(I)=.TRUE.                    ! Flag for deletion
               NDISAP=NDISAP+1
               IF (WATCH .GT. 1.5) WRITE (6,63) ID(I), XC(I), YC(I),
     .              PSFMAG-1.085736*ALOG(MAG(I)),
     .              ' too few valid pixels'
            ELSE
               SKIP(I)=.FALSE.                   ! Flag for retention
               I3=I-ISTAR+1
               IF (SUMWT(I) .GT. 1.) THEN
                  CHI(I)=1.2533141*CHI(I)/SQRT(SUMWT(I)*(SUMWT(I)-1.))
C
C Store a smoothed CHI value for the star in SUMWT.
C
                  SUMWT(I) = ((SUMWT(I)-3.)*CHI(I) + 3.)/SUMWT(I)
               ELSE
                  CHI(I)=CHIGRP
               END IF
            END IF
         END IF
      END DO
      IF (REDO) THEN
         GO TO 3000
      END IF
      CALL INVERS (C, MAXUNK, NTERM, ISTAT)
      DO J=1,NTERM
         IF (C(J,J) .LE. 0.) THEN
C
C Uh-oh.  Zero on the diagonal. Booma Booma!
C
            IF (CENTER .AND. (NITER .GE. 2)) THEN
               I = (J+2)/3
            ELSE
               I = J
            END IF
C
C I now points at the (first, at least) star that caused the problem.
C
            SKIP(I) = .TRUE.
            NDISAP=NDISAP+1
            IF (WATCH .GT. 1.5) WRITE (6,63) ID(I), XC(I), YC(I),
     .           PSFMAG-1.085736*ALOG(MAG(I)), ' singular matrix'
            GO TO 3000
         END IF
      END DO
      CALL VMUL (C, MAXUNK, NTERM, V, X)
C If sky is to be determined: SKYBAR=SKYBAR-X(NTERM)
C If sky is to be determined: IF(ABS(X(NTERM)).GT.0.01)REDO=.TRUE.
C
C In the beginning, the brightness of each star will be permitted to
C change by no more than two magnitudes per iteration, and the x,y
C coordinates of each centroid will be permitted to change by no more
C than 0.4 pixel per iteration.  Any time that the parameter
C correction changes sign from one iteration to the next, the maximum
C permissible change will be reduced by a factor of two.  These
C clamps are released any time a star in the group disappears.
C
      DO 2520 I=ISTAR,LSTAR
         IF (CENTER .AND. (NITER .GE. 2)) THEN
C
C Correct both magnitude and position.
C
            L=3*(I-ISTAR+1)
            K=L-1
            J=L-2
C
C Note that the sign of the correction is such that it must be
C SUBTRACTED from the current value of the parameter to get the
C improved parameter value.  This being the case, if the correction
C to the brightness is negative (the least-squares thinks that the
C star should be brighter) a change of 1 magnitude is a change of a
C factor of 2.5; if the brightness correction is positive (the star
C should be fainter) a change of 1 magnitude is a change of 60%.
C
            DWT=DXOLD(I)*X(K)
            IF (DWT .LT. 0.) THEN
               XCLAMP(I)=AMAX1(0.001,0.5*XCLAMP(I))
            ELSE
               XCLAMP(I)=AMIN1(CLMPMX,1.2*XCLAMP(I))
            END IF
            XC(I)=XC(I)-X(K)/(1.+ABS(X(K)/XCLAMP(I)))
            DXOLD(I)=X(K)
            DWT=DYOLD(I)*X(L)
            IF (DWT .LT. 0.) THEN
               YCLAMP(I)=AMAX1(0.001,0.5*YCLAMP(I))
            ELSE
               YCLAMP(I)=AMIN1(CLMPMX,1.2*YCLAMP(I))
            END IF
            YC(I)=YC(I)-X(L)/(1.+ABS(X(L)/YCLAMP(I)))
            DYOLD(I)=X(L)
            MAG(I)=MAG(I)-X(J)/
     .           (1.+AMAX1( X(J)/(0.84*MAG(I)) , -X(J)/(5.25*MAG(I)) ))
            MAGERR(I) = SUMWT(I)*SQRT(C(J,J))
            IF (NITER .GE. 4) THEN
               REDO = .FALSE.
               IF (ABS(X(J)) .GT.
     .              AMAX1( 0.1*MAGERR(I) , 0.0005*MAG(I) )) THEN
                  REDO=.TRUE.
               ELSE
                  DF = (0.1*SUMWT(I))**2
                  IF (X(K)**2 .GT. AMAX1(DF*C(K,K), 4.E-6)) THEN
                     REDO=.TRUE.
                  ELSE IF (X(L)**2 .GT. AMAX1(DF*C(L,L), 4.E-6)) THEN
                     REDO=.TRUE.
                  END IF
               END IF
            ELSE
               REDO = .TRUE.
            END IF
         ELSE
            J=I-ISTAR+1
C
C Correct magnitude only. Since this is an easy, linear problem,
C elaborate clamps are not needed.  A simple one will do to keep
C the brightness from ever going negative.
C
            MAG(I)=MAG(I)-X(J)/(1. + 1.2*ABS( X(J)/MAG(I) ))
            MAGERR(I) = SUMWT(I)*SQRT(C(J,J))
            IF (NITER .GE. 2) THEN
               REDO=.FALSE.
               IF (ABS(X(J)) .GT.
     .              AMAX1( 0.1*MAGERR(I), 0.0005*MAG(I) )) REDO = .TRUE.
            ELSE
               REDO=.TRUE.
            END IF
         END IF
C
C No star will be allowed to converge with a signal-to-noise ratio
C worse than 2.0.  Such stars must be retained until either they get
C better than S/N = 2, or they get eliminated some time after
C iteration 5 (if S/N < 1.0), 10 (if S/N < 1.5), or 15 (if S/N < 2.0).
C However, anything which is lucky enough to survive until the last
C iteration will be written out regardless.
C
         IF (MAG(I) .LT. 2.0*MAGERR(I)) REDO = .TRUE.
         IF (NITER .GE. MAXIT) REDO=.FALSE.
C
C If this star converged, write out the results for it,
C flag it for deletion from the star list (SKIP = .TRUE.), and
C subtract it from the reference copy of the image (DATA).
C
         IF (.NOT. REDO) THEN
            NCONV=NCONV+1
C
C Subtract from the reference copy of the image (DATA).
C
            LX=MAX0(0, MIN0(NCOL, INT(XC(I)-PSFRAD)))+1
            MX=MAX0(1, MIN0(NCOL, INT(XC(I)+PSFRAD)))
            LY=MAX0(0, MIN0(NROW, INT(YC(I)-PSFRAD)))+1
            MY=MAX0(1, MIN0(NROW, INT(YC(I)+PSFRAD)))
            DELTAX=(XC(I)-1.)/XPSF-1.
            DELTAY=(YC(I)-1.)/YPSF-1.
            DO 2195 J=LY,MY
               DY=FLOAT(J)-YC(I)
               DYSQ=DY**2
               DO 2195 K=LX,MX
                  IF (SIGMA(K,J) .GT. -1.E38) THEN
                     DX=FLOAT(K)-XC(I)
                     IF (DX**2+DYSQ .GE. PSFRSQ) GO TO 2195
                     DIFF=MAG(I)*USEPSF(IPSTYP, DX, DY, BRIGHT, PAR,
     .                    PSF, NPSF, NPAR, NEXP, NFRAC, DELTAX, DELTAY,
     .                    DVDXC, DVDYC)
                     DATA(K,J)=DATA(K,J)-DIFF
C
C We must add this star's contribution to the pixel's noise into the
C noise map SIGMA (which, of course, actually contains sigma**2).
C Please note that of the four contributors to the variance
C
C     (1) RONOIS = SIGMA(IX,IY)   (initially, at least)
C     (2) DPOS/PHPADU where DPOS = sum of the stellar profiles plus sky
C     (3) constant x DPOS**2
C     (4) constant x the sum of (the stellar profiles)**2
C
C (1) is already included in SIGMA, and we can calculate this star's
C contribution to (2) and (4) directly.  (3) is tricker.  (3) is
C (sum of sky plus all stellar profiles)**2, and we need to determine
C the contribution of (this stellar profile).  We need to use algebra:
C
C (sum of sky and all OTHER stellar profiles + this stellar profile)**2
C
C = (sum of sky plus all OTHER stellar profiles)**2 +
C  2 x (sum of sky plus OTHER stellar profiles) x (this stellar profile)
C   + (this stellar profile)**2.
C
C So we must add
C
C 2 x (sum of sky plus OTHER stellar profiles) x (this stellar profile)
C + (this stellar profile)**2
C
C into SIGMA.  That way, later on when the solution has forgotten that
C this star ever existed, so it only adds
C
C (sum of sky plus all OTHER stellar profiles)**2
C
C into the noise expected for the pixel, it will get the noise right.
C Since we have already subtracted this star's contribution to the image
C (array DATA) above, I will use the current DATA as my working
C approximation for (sum of sky plus all OTHER stellar profiles).
C I really shouldn't do this; I should really be calculating each star's
C model-predicted contribution to this pixel, but that would take too
C long.
C
                     IF (DIFF .GT. 0.) THEN
                       DIFF = DIFF/PHPADU +
     .                      PERERR*2.*AMAX1(0., DATA(K,J))*DIFF
     .                      + (PKERR*DIFF)**2
                       SIGMA(K,J)=SIGN(ABS(SIGMA(K,J))+DIFF, SIGMA(K,J))
                     END IF
                  END IF
 2195       CONTINUE                          ! End of loops over pixels
            SHARP=1.4427*PAR(1)*PAR(2)*NUMER(I)/(MAG(I)*PEAK*DENOM(I))
            SHARP=AMIN1( 99.999, AMAX1( SHARP, -99.999 ))
            ERR=1.085736*MAGERR(I)/MAG(I)
            MAG(I)=PSFMAG-1.085736*ALOG(MAG(I))
            WRITE (1,321) ID(I), XC(I), YC(I), MAG(I), ERR, SKY(I),
     .                                    FLOAT(NITER), CHI(I), SHARP
  321       FORMAT (I6, 5F9.3, F9.0, F9.2, F9.3)
            SKIP(I)=.TRUE.                    ! Remove from star list
         END IF
 2520 CONTINUE
C
C If there is more than one star remaining in this group, check to see
C whether any two of them have merged.  This means, find the closest
C pair and see whether they are TOO close.
C
      K = 0
      RSQ = SEPCRT
      IF (NSTR .GT. 1) THEN
         DO 2230 I=ISTAR+1,LSTAR
         IF (SKIP(I)) GO TO 2230
C
         DO 2220 J=ISTAR,I-1
            IF (SKIP(J)) GO TO 2220
            SEP=(XC(I)-XC(J))**2+(YC(I)-YC(J))**2
            IF (SEP .GE. RSQ) GO TO 2220
C
C Two stars are overlapping.  Identify the fainter of the two.
C
            RSQ = SEP
            IF (MAG(I) .LT. MAG(J)) THEN
               K = I
               L = J
            ELSE
               K = J
               L = I
            END IF
 2220    CONTINUE
C
 2230    CONTINUE
C
C No two stars have merged if K still equals zero.
C
         IF (K .LE. 0) GO TO 2260
C
C The K-th star is now the fainter of the two, the L-th, the brighter.
C
C Now eliminate the fainter of the two if they are TOO close.
C
         IF ((RSQ .GT. SEPMIN) .AND.
     .        (MAG(K) .GT. WCRIT*MAGERR(K))) GO TO 2260
C
C Now replace the centroid of the L-th star with the weighted mean of
C the most recent estimates of the centroids of the L-th and K-th
C stars, and the brightness of the L-th with the sum of the brightnesses
C of the L-th and K-th.
C
         XC(L)=XC(L)*MAG(L)+XC(K)*MAG(K)
         YC(L)=YC(L)*MAG(L)+YC(K)*MAG(K)
         MAG(L)=MAG(L)+MAG(K)
         XC(L)=XC(L)/MAG(L)
         YC(L)=YC(L)/MAG(L)
C
C Remove the K-th star from the group.
C
         SKIP(K)=.TRUE.                       ! Remove from star list
         IF (WATCH .GT. 1.5) THEN
            WRITE (6,63) ID(K), XC(K), YC(K),
     .           PSFMAG-1.085736*ALOG(MAG(K)), ' blended with'
            WRITE (6,63) ID(L), XC(L), YC(L),
     .           PSFMAG-1.085736*ALOG(MAG(L))
         END IF
         NDISAP=NDISAP+1
C
C Loosen the clamps of every star in the group.
C
         DO I=ISTAR,LSTAR
            DXOLD(I)=0.
            DYOLD(I)=0.
            XCLAMP(I)=AMAX1(0.5*CLMPMX, XCLAMP(I))
            YCLAMP(I)=AMAX1(0.5*CLMPMX, YCLAMP(I))
         END DO
      END IF
C
C If the number of iterations completed is less than or equal to 3,
C perform another iteration no questions asked.
C
 2260 IF (NITER .LE. 3) GO TO 3000
C
C > IF NO STAR HAS BEEN REMOVED FROM THIS GROUP DURING THIS ITERATION <
C
C Check whether any of the stars is too faint (more than 12.5
C magnitudes fainter than the PSF star).  If several stars are
C too faint, delete the faintest one, and set the brightnesses of
C the other faint ones exactly to 12.5 mag below the PSF star.
C That way on the next iteration we will see whether these stars
C want to grow or to disappear.
C
      FAINT=1.0E-5
      IFAINT=0
C
      DO I=ISTAR,LSTAR
         IF (SKIP(I)) GO TO 3000
         IF (MAG(I) .LT. FAINT) THEN
            FAINT=MAG(I)
            IFAINT=I
         END IF
         IF (MAG(I) .LT. 1.E-5) MAG(I)=1.E-5
      END DO
C
C If at least one star is more than 12.5 mag. fainter than the
C PSF, then  IFAINT  is the index of the faintest of them, and FAINT
C is the relative brightness of the faintest of them.
C
      IF (IFAINT .GT. 0) THEN
         SKIP(IFAINT)=.TRUE.                     ! Remove from star list
         NDISAP=NDISAP+1
         IF (WATCH .GT. 1.5) WRITE (6,63) ID(IFAINT), XC(IFAINT),
     .           YC(IFAINT), PSFMAG-1.085736*ALOG(MAG(IFAINT)),
     .           ' too faint'
C
C Loosen the clamps of every star in the group.
C
         DO I=ISTAR,LSTAR
            DXOLD(I)=0.
            DYOLD(I)=0.
            XCLAMP(I)=AMAX1(0.5*CLMPMX, XCLAMP(I))
            YCLAMP(I)=AMAX1(0.5*CLMPMX, YCLAMP(I))
         END DO
      ELSE IF (NITER .GE. 5) THEN
C
C If no star in this group is more than 12.5 mag. fainter than the PSF,
C then after the fifth iteration delete the least certain star if it
C is less than a one-sigma detection; after the tenth iteration delete
C the least certain star if it is less than a 1.5-sigma detection;
C after the fifteenth iteration delete the least certain star if it is
C less than a two-sigma detection.
C
         FAINT=1.E38
         IFAINT=0
C
         DO 2550 I=ISTAR,LSTAR
            WT=MAG(I)/MAGERR(I)
            IF (WT .LT. FAINT) THEN
               FAINT=WT
               IFAINT=I
            END IF
 2550    CONTINUE
C
         IF (FAINT .LT. WCRIT) THEN
            SKIP(IFAINT)=.TRUE.                  ! Remove from star list
            IF (WATCH .GT. 1.5) WRITE (6,63) ID(IFAINT), XC(IFAINT),
     .              YC(IFAINT), PSFMAG-1.085736*ALOG(MAG(IFAINT)),
     .              ' error too big: ',
     .              1.085736*MAGERR(IFAINT)/MAG(IFAINT)
            NDISAP=NDISAP+1
C
C Loosen the clamps of every star in the group.
C
            DO I=ISTAR,LSTAR
               DXOLD(I)=0.
               DYOLD(I)=0.
               XCLAMP(I)=AMAX1(0.5*CLMPMX, XCLAMP(I))
               YCLAMP(I)=AMAX1(0.5*CLMPMX, YCLAMP(I))
            END DO
         END IF
      END IF
 3000 CONTINUE
      IF (WATCH .GT. 0.5) THEN
         IF (LSTAR/INTRVL .GT. (ISTAR-1)/INTRVL) THEN
            WRITE (LINE,682) NITER, INTRVL*(LSTAR/INTRVL),
     .           NDISAP, NCONV
            CALL OVRWRT (LINE(1:24), 2)
         END IF
      END IF
      ISTAR=LSTAR+1
      IF (ISTAR .LE. NSTAR) GO TO 2200           ! Go on to next group
C
C We've gone through the entire star list for this iteration.
C
C Find the last star in the list that still needs more work
C (SKIP=.FALSE.).  If there aren't any, then we're done!  If there is
C one, point NSTAR at it.
C
      ISTAR=0
 3005 CONTINUE
      IF (SKIP(NSTAR)) THEN
         NSTAR=NSTAR-1
         IF (NSTAR .GT. 0) THEN
            GO TO 3005
         ELSE
            WRITE (LINE,682) NITER, NSTAR, NDISAP, NCONV
            CALL OVRWRT (LINE(1:28), 3)
            GO TO 9000                       ! None left!! We can go now
         END IF
      END IF
C
C Well, at this point we've established that there are at least some
C stars in the list that still need more work.  Remove any stars with
C which we are finished (SKIP = .TRUE.) by overwriting the first such
C star with the star at position NSTAR in the list (we have just
C confirmed that this is the last star in the list that still needs
C work).  Then decrement NSTAR and go back up to 3005 to find the new
C last star in the list that still needs work.
C
 3010 ISTAR=ISTAR+1
      IF (ISTAR .GE. NSTAR) THEN
         WRITE (LINE,682) NITER, NSTAR, NDISAP, NCONV
  682    FORMAT (4I6, '  <<')
         CALL OVRWRT (LINE(1:28), 3)
         GO TO 2100        ! The list is ready.  Start another iteration
      END IF
C
      IF (SKIP(ISTAR)) THEN
         ID(ISTAR)=ID(NSTAR)
         XC(ISTAR)=XC(NSTAR)
         YC(ISTAR)=YC(NSTAR)
         MAG(ISTAR)=MAG(NSTAR)
         SKY(ISTAR)=SKY(NSTAR)
         SUMWT(ISTAR)=SUMWT(NSTAR)
         DXOLD(ISTAR)=DXOLD(NSTAR)
         DYOLD(ISTAR)=DYOLD(NSTAR)
         XCLAMP(ISTAR)=XCLAMP(NSTAR)
         YCLAMP(ISTAR)=YCLAMP(NSTAR)
         SKIP(ISTAR)=.FALSE.
         NSTAR=NSTAR-1
         GO TO 3005
      ELSE
         GO TO 3010
      END IF
C
C-----------------------------------------------------------------------
C
C Normal return.
C
 9000 CONTINUE
      CALL CLFILE (1)
C
C Copy the input picture verbatim into the output picture.
C
      IF (SUBPIC(1:11) .NE. 'END OF FILE') THEN
         CALL COPPIC (SUBPIC, SUBT, NCOL, NROW, ISTAT)
         IF (ISTAT .NE. 0) THEN
            CALL STUPID ('Error opening output picture.')
            RETURN
         END IF
         LX = 1
         LY = 1
         CALL WRARAY ('COPY', LX, LY, NCOL, NROW, NCOL, DATA, ISTAT)
         IF (ISTAT .NE. 0) THEN
            CALL STUPID ('Error writing picture.')
            RETURN
         END IF
         CALL CLPIC ('COPY')
      END IF
      CALL STUPID ('    Done.  ')
      CALL CLFILE (2)
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================

C ++++++++++++++++++++++++  YF2CGEN.FOR +++++++++++++++++++++++++++++++++++++++
C .LANGUAGE Fortran 77
C .IDENTIFICATION Module YF2CGEN.FOR
C .COMMENTS
C Module contains layer between the keyword related FORTRAN STxxxx interfaces
C and the SC_interfaces written in (hopefully independent) C
C .AUTHOR         K. Banse        ESO - Garching
C .KEYWORDS       standard interfaces.
C .ENVIRONMENT    FORTRAN and C standards
C .VERSION  [1.00] 871207:  created from SXFTOC.C
C
C 100209	last modif
C ......................................................
C

      SUBROUTINE COPWND(PNTRA,NPIXA,PNTRB,NPIXB,BGNA,BGNB,ENDA)
C
      IMPLICIT NONE
C
      REAL   PNTRA(*), PNTRB(*)
      INTEGER  NPIXA,NPIXB,BGNA,BGNB,ENDA
C 
      CALL YY1(NPIXA,NPIXB,BGNA,BGNB)
      CALL YY2(PNTRA,PNTRB,ENDA)
C
      RETURN
      END
C
      SUBROUTINE COPYF1(PNTRA,NPIXA,BGNA,DIMWA,PNTRB,NPIXB,BGNB)
C
      IMPLICIT NONE
C
      REAL   PNTRA(*), PNTRB(*)
      INTEGER  NPIXA,NPIXB,BGNA,BGNB,DIMWA
C
      CALL YY1(NPIXA,NPIXB,BGNA,BGNB)
      CALL YY3(PNTRA,DIMWA,PNTRB)
C
      RETURN
      END
C
      SUBROUTINE JMAGN(JMETH, ARR, NX, NY, NI, NB, FAC, XC, YC,
     +                 MAG, DMAG, SKY, DSKY, NRPIX, FLUX, STAT )
C
      IMPLICIT NONE
C
      REAL   ARR(*), FAC, XC, YC, MAG, DMAG, SKY, DSKY
      REAL   NRPIX, FLUX
      INTEGER  JMETH, NX, NY, NI, NB, STAT
      CALL YY1(JMETH,NI,NB,0)
      CALL YY1a(NX, NY,XC, YC)
      CALL YY1b(MAG,DMAG,SKY,DSKY)
      CALL YY4(ARR,FAC,NRPIX,FLUX,STAT)
C
      RETURN
      END
C

      SUBROUTINE STACEN(P_IMG,DIMX,DIMY,METH,IMAGE,XOUT,YOUT,XERR,YERR,
     +             XSIG,YSIG,XYVAL,STAT)
C
      IMPLICIT NONE
C
      CHARACTER*(*) METH
      REAL   P_IMG(*), XOUT,YOUT,XERR,YERR,XSIG,YSIG, XYVAL
      INTEGER  DIMX, DIMY, IMAGE(*), STAT
C
      CALL STSTR(1,METH)
C 
      CALL YY1a(DIMX,DIMY,0.,0.)
      CALL YY1b(XOUT,YOUT,XERR,YERR)
      CALL YY1c(XSIG,YSIG,XYVAL)
      CALL YY5(P_IMG,IMAGE,STAT)

C
      RETURN
      END
C

      SUBROUTINE PIXLIN(XA,YA,XB,YB,STEP,XINDX,YINDX,LIMIT,NINDX)
C
      IMPLICIT NONE
C
      REAL   XA,YA,XB,YB,STEP,XINDX,YINDX
      INTEGER  LIMIT, NINDX
C
      CALL YY1b(XA,YA,XB,YB)
      CALL YY6(STEP,XINDX,YINDX,LIMIT,NINDX)
C
      RETURN
      END
C
      SUBROUTINE ZIMA(P_IN,NPIX,XINDX,YINDX,NDIM,P_OUT,FMIN,FMAX)
C
      IMPLICIT NONE
C
      REAL   P_IN(*),P_OUT(*)
      REAL   XINDX,YINDX,FMIN,FMAX
      INTEGER  NPIX(*), NDIM
C
      CALL YY1b(XINDX,YINDX,FMIN,FMAX)
      CALL YY7(P_IN,NPIX,NDIM,P_OUT)
C
      RETURN
      END
C
      SUBROUTINE DATFIL(INFILE,DATTYP,TOTAL,A,B,MINFLG,FMIN,FMAX)
C
      IMPLICIT NONE
C
      CHARACTER*(*) INFILE
      REAL   A(*),B(*)
      REAL   FMIN,FMAX
      INTEGER  DATTYP,TOTAL,MINFLG
C
      CALL STSTR(1,INFILE)
C 
      CALL YY1(DATTYP,TOTAL,MINFLG,0)
      CALL YY8(INFILE,A,B,FMIN,FMAX)
C
      RETURN
      END

      SUBROUTINE W1FORM(FORM,FLAG,IVA,RVA,DVA,OUTSTR)
C
      CHARACTER*(*) FORM, OUTSTR
      INTEGER  FLAG,IVA
      REAL RVA
      DOUBLE PRECISION DVA
C
      CALL STSTR(1,FORM)
      CALL STLOC(1,1,OUTSTR)                              !blank CHAR_LOC
C 
      CALL YY14(FLAG,IVA,RVA,DVA)
C
      RETURN
      END



      SUBROUTINE FRAMOU( FRAME )
C 
      CHARACTER*(*) FRAME
      INTEGER  IDUM
C
      CALL STSTR(1,FRAME)
      CALL YY9(IDUM)
C
      RETURN
      END
 
      SUBROUTINE OPNTAB( TABLE, TID, NCOLS, NROWS, STAT )
C
      IMPLICIT NONE
C
      CHARACTER*(*) TABLE
      INTEGER  TID, NCOLS, NROWS, STAT
C
      CALL STSTR(1,TABLE)
      CALL YY10(TID, NCOLS, NROWS, STAT)
C
      RETURN
      END

      SUBROUTINE BLDLUT(TABLE,RLUT,STAT)
C 
      IMPLICIT NONE
C
      CHARACTER*(*) TABLE
      INTEGER  STAT
      REAL   RLUT(*)
C
      CALL STSTR(1,TABLE)
      CALL YY11(RLUT,STAT)
C
      RETURN
      END

      SUBROUTINE BLDITT( TABLE, RITT, STAT )
C 
      IMPLICIT NONE
C
      CHARACTER*(*) TABLE
      INTEGER  STAT
      REAL   RITT(*)
C
      CALL STSTR(1,TABLE)
C
      CALL YY12(RITT,STAT)
C
      RETURN
      END

      SUBROUTINE TCOLIM(TABLE,COLUMN,COLNO,STAT)
C
      IMPLICIT NONE
C
      CHARACTER*(*) TABLE
      CHARACTER*(*)  COLUMN
      INTEGER  COLNO, STAT
C
      CALL STSTR(1,TABLE)
      CALL STSTR(2,COLUMN)
C
      CALL YY13(COLNO,STAT)
C
      RETURN
      END


      SUBROUTINE CLNFRA(INFILE,OUTFILE,OPTIO)
C
      IMPLICIT NONE
C
      CHARACTER*(*) INFILE, OUTFILE
C 
      INTEGER  OPTIO
C
      CALL STSTR(1,INFILE)
      CALL STLOC(1,1,OUTFILE)                              !blank CHAR_LOC
C 
      CALL YYA1(1,OPTIO)
C
      RETURN
      END



      SUBROUTINE CLNTAB(INFILE,OUTFILE,OPTIO)
C
      IMPLICIT NONE
C
      CHARACTER*(*) INFILE, OUTFILE
C
      INTEGER  OPTIO
C
      CALL STSTR(1,INFILE)
      CALL STLOC(1,1,OUTFILE)
C
      CALL YYA1(3,OPTIO)
C
      RETURN
      END



      SUBROUTINE CLNFIT(INFILE,OUTFILE,OPTIO)
C
      IMPLICIT NONE
C
      CHARACTER*(*) INFILE, OUTFILE
C
      INTEGER  OPTIO
C
      CALL STSTR(1,INFILE)
      CALL STLOC(1,1,OUTFILE)
C
      CALL YYA1(4,OPTIO)
C
      RETURN
      END

C @(#)redsubs2.for	19.1 (ES0-DMD) 02/25/03 13:28:47
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE POLYGON(ARRAY,IFLAG,LABEL)
C  @(#)redsubs2.for	19.1  (ESO-IPG)  02/25/03  13:28:47
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT (c) European Southern Observatory 1992
C.IDENT		redsubs2.for
C.MODULE
C.AUTHOR	Andrew T. Young
C.KEYWORD
C.LANGUAGE	FORTRAN 77
C.PURPOSE       more subroutines for REDUCE
C.COMMENTS
C.VERSION	5.9
C.RETURNS
C.ENVIRONMENT
C.
C-----------------------------------------------------------------------------
C
C
C       scans array for items with NSTR=iflag, and does polygon interpolation.
C
C
      IMPLICIT NONE
      REAL ARRAY, XBAR, YBAR, SLOPE, FRACT, YMAX, YMIN
C
      INTEGER IFLAG, LEN, LWORD, JBGN, NIGHT, K, J,
     1         JMIN, JMAX, JEND, K1, K2
C
      INCLUDE 'MID_REL_INCL:obs.inc'
C
C
      DIMENSION ARRAY(MXOBS)
C
      CHARACTER A, LABEL*(*), CARD*79
C
      LOGICAL HELP
      EXTERNAL HELP
C
C
C
      LEN=LWORD(LABEL)
      JBGN=1
C
      DO 100 NIGHT=1,NIGHTS
C
        CALL SPACE2
        CALL NEED(24)
        CARD(:LEN)=LABEL(:LEN)
        CARD(LEN+1:LEN+6)='  for '
        CALL JD2DAT(REAL(2400000.5D0+DTZERO(NIGHT)),CARD(LEN+7:))
        CALL TV(CARD)
        K=0
        YMAX=-3.E33
        YMIN=3.E33
C
        DO 10 J=JBGN,NDATA
C
C         find data for current night.
          IF (NITE(J).NE.NIGHT) GO TO 20
          IF (NSTR(J).EQ.IFLAG)THEN
C           add to XS, YS.
            K=K+1
            XS(K)=DJOBS(J)
            YS(K)=ARRAY(J)
            YMAX=MAX(YMAX,YS(K))
            YMIN=MIN(YMIN,YS(K))
            IF (K.EQ.1) JMIN=J
            JMAX=J
          END IF
C
   10   CONTINUE
        J=NDATA+1
C
   20   CONTINUE
        JEND=J-1
C
C    JBGN, JEND index the first and last data of ANY kind for the night.
C    JMIN, JMAX index the first and last IFLAG data for the night.
C
C
C       K is count of data for night N.
C
        IF (YMAX.GT.YMIN) THEN
C           K > 1.
   22       CALL NEED(24)
            CALL PLOT(K,XS,YS,'*')
            CALL TVN('     Time (decimal days) -->')
            CALL ASKN('OK to interpolate with a polygon?',A)
            IF (A.EQ.'N') THEN
   24           CALL TV('Enter C to replace data with a Constant,')
                IF (K.GE.6)
     1               CALL TVN('      L to smooth with a Linear fit,')
                CALL ASKN('   or Q to Quit.',A)
                IF (A.EQ.'C') THEN
C                   be lazy: fit line, but force it horizontal.
                    CALL ROBLIN(XS,YS,K, XBAR,YBAR,SLOPE)
                    SLOPE=0.
                ELSE IF (A.EQ.'L') THEN
                    IF (K.LT.6) THEN
                        CALL TV('Not enough data to fit a line safely.')
                        CALL TVN('Try a constant instead.')
                        GO TO 24
                    END IF
                    CALL ROBLIN(XS,YS,K, XBAR,YBAR,SLOPE)
                ELSE
                   GO TO 24
                END IF
C
                DO 28 J=JBGN,JEND
                    ARRAY(J)=(DJOBS(J)-XBAR)*SLOPE+YBAR
   28           CONTINUE
C
                GO TO 41
            ELSE IF (A.EQ.'Y' .OR. A.EQ.'O') THEN
C               go on.
            ELSE IF (HELP(A)) THEN
                CALL TV('Reply NO to smooth data.')
                GO TO 22
            ELSE
                GO TO 22
            END IF
        ELSE IF (YMAX.EQ.YMIN) THEN
            CALL TV('Only 1 value available for this night!')
            CALL SPACE2
            DO 30 J=JBGN,JEND
                ARRAY(J)=ARRAY(JMIN)
   30       CONTINUE
            GO TO 99
        ELSE
            CALL TV('NO DATA AVAILABLE FOR THIS NIGHT')
            CALL STSEPI
        END IF
C
C       Now interpolate.
C
        K1=1
        K2=2
C
        DO 40 J=JBGN,JEND
           IF (J.LT.JMIN) THEN
               ARRAY(J)=ARRAY(JMIN)
           ELSE IF (J.GT.JMAX) THEN
               ARRAY(J)=ARRAY(JMAX)
           ELSE
               IF (DJOBS(J).GT.XS(K2)) THEN
                   K1=K2
                   K2=K2+1
               END IF
C
C               linear interp...
               FRACT=(DJOBS(J)-XS(K1))/(XS(K2)-XS(K1))
               ARRAY(J)=YS(K1)+(YS(K2)-YS(K1))*FRACT
           END IF
   40   CONTINUE
C
   41   CARD(66:78)=CARD(53:65)
        CARD(53:65)=CARD(40:52)
        CARD(40:52)=CARD(27:39)
        CARD(27:39)=CARD(14:26)
        CARD(14:26)=CARD(:13)
        CARD(:13)='Interpolated '
        CALL NEED(24)
        CALL TV(CARD)
C       fudge to get right plot limits....
        XS(1)=DJOBS(JBGN)
        XS(K)=DJOBS(JEND)
        CALL PLOT(-K,XS,YS,' ')
        DO 50 J=JBGN,JEND
        CALL PLOT(-1,DJOBS(J),ARRAY(J),'+')
   50   CONTINUE
C       now undo fudge.
        XS(1)=DJOBS(JMIN)
        XS(K)=DJOBS(JMAX)
        CALL PLOT(K,XS,YS,'*')
        CALL RTNCON('     Time (decimal days) -->',28)
C
   99   JBGN=JEND+1
C       IF (JBGN.GT.NDATA) RETURN
  100 CONTINUE
C
      RETURN
      END
      SUBROUTINE DARKFIT(NDET,NDUSED,LABEL)
C
C       scans SIGNAL for items with NSTR=-1, models dark level vs. DTMP,
C       and subtracts dark current for detector number NDET.
C
C
C     C A U T I O N :  This routine has *** NOT *** been debugged!
C     ===============
C
      IMPLICIT NONE
C
      REAL XLIMS, YLIMS, SIGMIN, SIGMAX, YMAX, 
     1   YMIN, XBAR, YBAR, SLOPE, XBAR1, YBAR1, SLOPE1, TRY, XBAR2, 
     2         YBAR2, SLOPE2, FIT
      INTEGER NDET, LEN, LWORD, K, J, JMIN,
     1   JMAX, K3, K1, I, K2, NIX
C
      INCLUDE 'MID_REL_INCL:mbands.inc'
C     PARAMETER (MBANDS=9)
      INTEGER MXCOLR
      PARAMETER (MXCOLR=3*MBANDS)
      INTEGER NDUSED(MXCOLR)
C
      INCLUDE 'MID_REL_INCL:obs.inc'
C     This defines SIGNAL, NSTR, KBND, etc.
C
C     Includes for dlsq:
      INCLUDE 'MID_REL_INCL:kingfit.inc'
      INCLUDE 'MID_REL_INCL:dlsq.inc'
C
      CHARACTER A1, LABEL*16, CARD*79
C
      DIMENSION XLIMS(2),YLIMS(2)
C
      LOGICAL HELP
      EXTERNAL HELP
C
      EXTERNAL YP2EXP
C
C
C       Begin execution:
C
      LEN=LWORD(LABEL)
C
    2 K=0
      SIGMAX=-3.E33
      SIGMIN=3.E33
      CALL SPACE2
      CARD(:LEN)=LABEL(:LEN)
      CARD(LEN+1:)='  Log(DARK) vs. Temperature'
C
      DO 10 J=1,NDATA
C
C       find  dark data    for  current detector.
        IF (NSTR(J).EQ.-1 .AND. KBND(J).EQ.NDET)THEN
C           add to XS, YS.
            K=K+1
            XS(K)=DTMP(J)
            IF (SIGNAL(J).GT.0.) THEN
               YS(K)=LOG(SIGNAL(J))
            ELSE
               CARD='Negative dark reading at MJD ='
               WRITE(CARD(35:),'(F12.5)') DTZERO(NITE(J))+DJOBS(J)
               CARD(48:)='in channel'
               WRITE(CARD(55:),'(I3)') NDET
               CALL TV(CARD)
               K=K-1
               GO TO 10
            END IF
            SIGMAX=MAX(SIGMAX,SIGNAL(J))
            SIGMIN=MIN(SIGMIN,SIGNAL(J))
C
C           SYMB is night label:
            IF (NITE(J).LT.10) THEN
                SYMB(K)=CHAR(ICHAR('0')+NITE(J))
            ELSE
                SYMB(K)=CHAR(ICHAR('A')+NITE(J)-1)
            END IF
C
            IF (K.EQ.1) THEN
               JMIN=J
            END IF
C               do this every time, in case only 1 datum.
            JMAX=J
        END IF
C
   10 CONTINUE
C
C       K is count of data for current detector.
C
   21 YMAX=-3.E33
      YMIN=3.E33
C
      IF (SIGMAX.GT.SIGMIN) THEN
C           K > 1.
C           set page size:
            CALL PLOT(0,78.,22.,'P')
C           set different-symbol mode:
   22       CALL PLOT(0,78.,22.,'D')
            CALL NEED(24)
            CALL TV(CARD)
C           plot each night with its own symbol.
            CALL PLOT(K,XS,YS,SYMB)
C           set same-symbol mode:
            CALL PLOT(0,78.,22.,'S')
            IF (K.GT.10) THEN
                CALL TVN('     Temperature -->')
                CALL ASKN('OK to fit with 2 lines?',A1)
            ELSE IF (HELP(A1)) THEN
                CALL TV('Reply YES only if concave upward')
                CALL TVN('(high at ends, lower in middle)')
                GO TO 22
            ELSE
                A1='N'
                CALL RTNCON('     Temperature -->', 20)
            END IF
C
            IF (A1.EQ.'N') THEN
   24           CALL TV('Enter C to replace data with a Constant,')
                CALL TVN('      L to smooth with a Linear fit,')
                CALL ASKN('   or Q to Quit.',A1)
C
                IF (A1.EQ.'C') THEN
C                   be lazy: fit line, but force it horizontal.
                    CALL ROBLIN(XS,YS,K, XBAR,YBAR,SLOPE)
                    SLOPE=0.
                    NIX=1
                    IX(1)=2
                ELSE IF (A1.EQ.'L') THEN
                    IF (K.LT.6) THEN
                        CALL TV('Not enough data to fit 1 line safely.')
                        CALL TVN('Try a constant instead.')
                        GO TO 24
                    END IF
C                       fit a simple exponential in temperature:
                    CALL ROBLIN(XS,YS,K, XBAR,YBAR,SLOPE)
                    NIX=0
                ELSE
                   GO TO 24
                END IF
C
C
C               Refine one-exponential fit:
C
                IPR=0
                KIP=2
                PG(1)=EXP(YBAR)
                PG(2)=SLOPE
                DO 26 J=1,K
                  X(1,J)=XS(J)-XBAR
                  Y(J)=EXP(YS(J))
C                 use expected ordinates to weight:
                  W(J)=1./EXP(YBAR+X(1,J)*SLOPE)
   26           CONTINUE
C               refine fit:
C      subroutine DLSQ(YP,NPTS,NPARMS,NBLOX,MBLOK,NIX,NARGS,NKARGS,TEST)
                CALL DLSQ(YP2EXP,K,2,   1,    2,  NIX,  1,    0,  1.E-3)
                SLOPE=LOG(P(2))
                YBAR=P(1)
C
C
C               now subtract fit from ALL data with this detector:
C
                DO 28 J=1,NDATA
                   IF ((NSTR(J).GT.0 .AND. NDUSED(KBND(J)).NE.NDET) .OR.
     1                 (NSTR(J).EQ.-1 .AND. KBND(J).NE.NDET)) GO TO 28
C                  subtract dark:
                   SIGNAL(J)=SIGNAL(J)-EXP((DTMP(J)-XBAR)*SLOPE+YBAR)
                   IF (NSTR(J).EQ.-1) THEN
                      YMAX=MAX(YMAX,SIGNAL(J))
                      YMIN=MIN(YMIN,SIGNAL(J))
                   END IF
   28           CONTINUE
C
                GO TO 61
C
C
            ELSE IF (A1.EQ.'Y' .OR. A1.EQ.'O') THEN
C               go on to do two-exponential fit at *****.
C
            ELSE IF (A1.EQ.'H')THEN
                CALL TV('If the plot is generally concave upward,')
                CALL TVN('and the different nights (different symbols)')
                CALL TVN('appear to follow the same curve, reply YES.')
                CALL TV('If the plot is straight or concave downward,')
                CALL TVN('or some nights are offset, reply NO.')
                CALL TV('Overlapping points are denoted by "$".')
                CALL SPACE2
                CALL RTNCON(' ',1)
                GO TO 21
C
            ELSE
                GO TO 22
C
            END IF
C
      ELSE IF (SIGMAX.EQ.SIGMIN) THEN
            CALL TV('Only 1 dark value available!')
            CALL SPACE2
            DO 30 J=1,NDATA
C               subtract dark:
                IF (NSTR(J).GT.0 .AND. NDUSED(KBND(J)).EQ.NDET)
     1             SIGNAL(J)=SIGNAL(J)-SIGMIN
   30       CONTINUE
C           skip plot.
            GO TO 99
      ELSE
            CALL TV('NO DATA AVAILABLE -- cannot subtract dark')
            RETURN
      END IF
C
C     *****
C
C       Here to fit 2 lines (exponentials), and remove their sum.
C
      K3=K/3
C
      IF (K3.LT.9) THEN
          CALL TV('CAUTION: probably too few points to get a fit.')
          CALL ASKN('Were there any wild points in the plot above?',A1)
C
          IF (A1.EQ.'Y')THEN
              CALL TV('Then you should try to fit just one line.')
              CALL RTNCON(' ',1)
              GO TO 21
          ELSE IF (A1.EQ.'N') THEN
C               go ahead.
          ELSE IF (A1.EQ.'H') THEN
C               get help: show plot again.
                GO TO 21
          ELSE
          END IF
C
      END IF
C
      CALL SORT2(XS,YS,K)
C     fit trial line to bottom 1/3 of data.
      CALL ROBLIN(XS,YS,K3, XBAR1,YBAR1,SLOPE1)
C
C     remove lower trial line, and fit the upper line.
C
      K1=0
C
      DO 32 I=1,K3
C        move upper third to lower third:
         K2=K-K3+I
         TRY=EXP(YS(K2))-EXP(YBAR1+SLOPE1*(XS(K2)-XBAR1))
         IF (TRY.LE.0.) THEN
C           skip this point.
         ELSE
            K1=K1+1
C           save K1 in K1+K.
            XS(K1+K)=XS(K1)
            YS(K1+K)=YS(K1)
C           move K2 to K1.
            YS(K1)=LOG(TRY)
            XS(K1)=XS(K2)
         END IF
   32 CONTINUE
C
      IF (K1.LT.6)THEN
          CALL TV('Sorry; can''t fit 2 lines.  Try 1 line.')
          CALL RTNCON(' ',1)
          GO TO 2
      ELSE
          CALL ROBLIN(XS,YS,K1, XBAR2,YBAR2,SLOPE2)
          IF (SLOPE2.LT.0. .OR. SLOPE2.LT.SLOPE1) THEN
C               unphysical result; complain.
              CALL TV('Sorry; attempted fit is nonsense.')
              CALL RTNCON('Try again, using 1 line.',24)
              GO TO 2
          ELSE
          END IF
      END IF
C
C     Now restore saved data to lower K1:
      DO 35 I=1,K1
         XS(K1)=XS(K1+K)
         YS(K1)=YS(K1+K)
   35 CONTINUE
C
C     *****  Polish the result.  *****
C
C     Set up for DLSQ:
C
      IPR=0
      NIX=0
C     Set up data:
      XBAR=(XBAR1+XBAR2)*0.5
      DO 36 I=1,K
         X(1,I)=XS(I)-XBAR
         Y(I)=YS(I)
         W(I)=1./(EXP(YBAR1+SLOPE1*(XS(I)-XBAR1)) +
     1            EXP(YBAR2+SLOPE2*(XS(I)-XBAR2)) )
   36 CONTINUE
      KIP=4
      PG(1)=EXP(YBAR1+SLOPE1*(XBAR-XBAR1))
      PG(2)=SLOPE1
      PG(3)=EXP(YBAR2+SLOPE2*(XBAR-XBAR2))
      PG(4)=SLOPE2
C               refine fit:
      DO 40 I=1,3
C     Subroutine DLSQ(YP,NPTS,NPARMS,NBLOX,MBLOK,NIX,NARGS,NKARGS,TEST)
        CALL DLSQ(YP2EXP, K,    2,    1,    2,   NIX, 1,    0,   1.E-3)
C
        IF (P(1).LE.0.D0 .OR. P(3).LE.0.D0) THEN
          CALL TV('Sorry -- unable to fit two lines.  Try one.')
          CALL RTNCON(' ',1)
          GO TO 2
        END IF
C       Update values:
        DO 38 J=1,4
   38   PG(J)=P(J)
        SLOPE1=P(2)
        YBAR1=LOG(P(1))-SLOPE1*(XBAR-XBAR1)
        SLOPE2=P(4)
        YBAR2=LOG(P(3))-SLOPE2*(XBAR-XBAR2)
C       Revise weights:
        DO 39 J=1,K
          W(J)=1./(EXP(YBAR1+SLOPE1*(XS(I)-XBAR1)) +
     1             EXP(YBAR2+SLOPE2*(XS(I)-XBAR2)) )
   39   CONTINUE
   40 CONTINUE
C
C
C
C     Subtract the interpolated values from ALL data for this det.
C
      DO 60 J=1,NDATA
         IF ((NSTR(J).GT.0 .AND. NDUSED(KBND(J)).NE.NDET) .OR.
     1            (NSTR(J).EQ.-1 .AND. KBND(J).NE.NDET)) GO TO 60
         FIT=EXP(YBAR1+SLOPE1*(DTMP(J)-XBAR1)) +
     1        EXP(YBAR2+SLOPE2*(DTMP(J)-XBAR2))
         SIGNAL(J)=SIGNAL(J)-FIT
         IF (NSTR(J).NE.-1) GO TO 60
C        use only dark data to set limits for residual plot.
         YMAX=MAX(YMAX,SIGNAL(J))
         YMIN=MIN(YMIN,SIGNAL(J))
   60 CONTINUE
C
C       Now inspect resids. vs. time:
C
   61 CARD(:LEN)=LABEL(:LEN)
      CARD(LEN+1:)=' Dark RESIDUALS  vs. Time'
      CALL NEED(24)
      CALL TV(CARD)
C     set plot limits....
      XLIMS(1)=DJOBS(1)
      XLIMS(2)=DJOBS(NDATA)
      YLIMS(1)=YMIN
      YLIMS(2)=YMAX
      CALL PLOT(0,XLIMS,YLIMS,'L')
      DO 80 J=1,NDATA
          IF (NSTR(J).NE.-1 .OR. KBND(J).NE.NDET) GO TO 80
          IF (NITE(J).LT.10) THEN
             A1=CHAR(ICHAR('0')+NITE(J))
          ELSE
             A1=CHAR(ICHAR('A')+NITE(J)-1)
          END IF
          CALL PLOT(-1,DJOBS(J),SIGNAL(J),A1)
   80 CONTINUE
C     force plot:
      CALL PLOT(1,0.,0.,'+')
      CALL RTNCON('     Time (decimal days) -->',28)
C
   99 CONTINUE
C
      RETURN
      END
      SUBROUTINE YP2EXP
C
C   Fits  Y = P(1)*EXP(P(2)*Z(1)) + P(3)*EXP(P(4)*Z(1))
C
C
      IMPLICIT NONE
C
C     Includes for dlsq:
      INCLUDE 'MID_REL_INCL:kingfit.inc'
      INCLUDE 'MID_REL_INCL:dlsq.inc'
C
      DOUBLE PRECISION TERM
C
C
C   Start with first term:
C
C
C     KIP is set by DARKFIT.
C
      IP(1)=1
      IP(2)=2
C
      TERM=P(2)*Z(1)
      TERM=EXP(MIN(TERM,30.D0))
      PART(1)=TERM
      PART(2)=P(1)*TERM*Z(1)
C
      YT = P(1)*TERM
C
      IF (KIP.EQ.2) RETURN
C
C   Here for second term:
C
      IP(3)=3
      IP(4)=4
C
      TERM=P(4)*Z(1)
      TERM=EXP(MIN(TERM,30.D0))
      PART(3)=TERM
      PART(4)=P(3)*TERM*Z(1)
C
      YT = YT + P(3)*TERM
C
C
      RETURN
      END
      SUBROUTINE DARKPOLY(NDET,NDUSED,LABEL)
C
C       scans SIGNAL for items with NSTR=-1, and does polygon interpolation
C       and subtraction of dark current for detector number NDET.
C
C
      IMPLICIT NONE
C
      REAL XLIMS, YLIMS, SIGMIN, SIGMAX, SIGA, SIGZ, YMAX, 
     1         YMIN, XBAR, YBAR, SLOPE, FRACT
      INTEGER NDET, LEN, LWORD, JBGN, NIGHT, K, J,
     1         JMIN, JMAX, JEND, K1, K2, NIX
C
      INCLUDE 'MID_REL_INCL:mbands.inc'
C     PARAMETER (MBANDS=9)
      INTEGER MXCOLR
      PARAMETER (MXCOLR=3*MBANDS)
      INTEGER NDUSED(MXCOLR)
C
      INCLUDE 'MID_REL_INCL:obs.inc'
C     This defines NITE, SIGNAL, NSTR, KBND, etc.
C
C     Includes for dlsq:
      INCLUDE 'MID_REL_INCL:kingfit.inc'
      INCLUDE 'MID_REL_INCL:dlsq.inc'
C
      CHARACTER A1, LABEL*16, CARD*79
C
      DIMENSION XLIMS(2),YLIMS(2)
C
      LOGICAL HELP
      EXTERNAL HELP
C
      EXTERNAL YPLIN
C
C
C       Begin execution:
C
      LEN=LWORD(LABEL)
      JBGN=1
C
      DO 100 NIGHT=1,NIGHTS
C
        CALL SPACE2
        CALL NEED(24)
        CARD(:LEN)=LABEL(:LEN)
        CARD(LEN+1:LEN+10)='  DARK on '
        CALL JD2DAT(REAL(2400000.5D0+DTZERO(NIGHT)),CARD(LEN+11:))
        CARD(LWORD(CARD)+3:)='=  MJD'
        WRITE (CARD(LWORD(CARD)+1:),'(F7.0)') DTZERO(NIGHT)
        CALL TV(CARD)
        SIGMAX=-3.E33
        SIGMIN=3.E33
        K=0
C
        DO 10 J=JBGN,NDATA
C
C         find dark data for current night and detector.
          IF (NITE(J).NE.NIGHT) GO TO 20
c         KBND holds NDET for DARK data, remember.
          IF (NSTR(J).EQ.-1 .AND. KBND(J).EQ.NDET)THEN
C           add to XS, YS.
            K=K+1
            XS(K)=DJOBS(J)
            YS(K)=SIGNAL(J)
            IF (K.EQ.1) JMIN=J
            IF (K.EQ.1) SIGA=SIGNAL(J)
            JMAX=J
            SIGZ=SIGNAL(J)
            SIGMAX=MAX(SIGMAX,SIGNAL(J))
            SIGMIN=MIN(SIGMIN,SIGNAL(J))
          END IF
C
   10   CONTINUE
        J=NDATA+1
C
   20   CONTINUE
        JEND=J-1
C
C    JBGN, JEND index the first and last data of ANY kind for the night.
C    JMIN, JMAX index the first and last DARK data for the night.
C    SIGA, SIGZ are the first and last dark LEVELS for the night.
C    SIGMIN, SIGMAX are the lowest and highest dark LEVELS for the night.
C
C
        YMAX=-3.E33
        YMIN=3.E33
C
C       K is count of data for night N.
C
        IF (SIGMAX.GT.SIGMIN) THEN
   22       CALL NEED(24)
            CALL PLOT(K,XS,YS,'*')
            CALL TVN('     TIME (decimal days) -->')
            CALL ASKN('OK to interpolate with a polygon?',A1)
            IF (A1.EQ.'N') THEN
   24           CALL TV('Enter C to replace data with a Constant,')
                IF (K.GE.6)
     1               CALL TVN('      L to smooth with a Linear fit,')
                CALL ASKN('   or Q to Quit.',A1)
                IF (A1.EQ.'C') THEN
C                   be lazy: fit line, but force it horizontal.
                    CALL ROBLIN(XS,YS,K, XBAR,YBAR,SLOPE)
                    SLOPE=0.
                    NIX=1
                    IX(1)=2
                ELSE IF (A1.EQ.'L') THEN
                    IF (K.LT.6) THEN
                        CALL TV('Not enough data to fit a line safely.')
                        CALL TVN('Try a constant instead.')
                        GO TO 24
                    END IF
                    CALL ROBLIN(XS,YS,K, XBAR,YBAR,SLOPE)
                    NIX=0
                ELSE IF (HELP(A1)) THEN
                    CALL TV('Reply NO to smooth data.')
                    GO TO 22
                ELSE
                   GO TO 24
                END IF
C
C
C               Refine fit:
C
                IPR=0
                PG(1)=YBAR
                PG(2)=SLOPE
                DO 26 J=1,K
                  X(1,J)=XS(J)-XBAR
                  Y(J)=YS(J)
                  W(J)=1.
   26           CONTINUE
C               refine fit:
C     Subroutine DLSQ(YP,NPTS,NPARMS,NBLOX,MBLOK,NIX,NARGS,NKARGS,TEST)
                CALL DLSQ(YPLIN,K,2,  1,    2,   NIX, 1,    0,   1.E-3)
                SLOPE=P(2)
                YBAR=P(1)
C
C
C               Subtract fit:
C
                DO 28 J=JBGN,JEND
                    IF((NSTR(J).GT.0 .AND. NDUSED(KBND(J)).NE.NDET) .OR.
C                       real star, not observed with current det...
     1                 (NSTR(J).LE.0 .AND. KBND(J).NE.NDET)) GO TO 28
C                       ...or dark, not observed with current det.
C                   OK, subtract interpolated dark line:
                    SIGNAL(J)=SIGNAL(J)-((DJOBS(J)-XBAR)*SLOPE+YBAR)
                    IF (NSTR(J).EQ.-1) THEN
C                       reset limits for residual plot.
                        YMAX=MAX(YMAX,SIGNAL(J))
                        YMIN=MIN(YMIN,SIGNAL(J))
                    END IF
   28           CONTINUE
C
C               plot residuals.
C
                CALL NEED(24)
                CARD(66:78)=CARD(53:65)
                CARD(53:65)=CARD(40:52)
                CARD(40:52)=CARD(27:39)
                CARD(27:39)=CARD(14:26)
                CARD(14:26)=CARD(:13)
                CARD(:13)='RESIDUALS of '
                CALL TV(CARD)
C               set plot limits....
                XLIMS(1)=DJOBS(JBGN)
                XLIMS(2)=DJOBS(JEND)
                YLIMS(1)=YMIN
                YLIMS(2)=YMAX
                CALL PLOT(0,XLIMS,YLIMS,'L')
                CALL XAXIS(XLIMS)
                DO 29 J=JBGN,JEND
                   IF (NSTR(J).NE.-1 .OR. KBND(J).NE.NDET) GO TO 29
C                  plot only dark resids., not star data.
                   CALL PLOT(-1,DJOBS(J),SIGNAL(J),'*')
   29           CONTINUE
C               force plot:
                CALL PLOT(1,0.,0.,'+')
                CALL RTNCON('     Time (decimal days) -->',28)
                GO TO 99
C
            ELSE IF (A1.EQ.'Y' .OR. A1.EQ.'O') THEN
C               go on.
            ELSE
                GO TO 22
            END IF
        ELSE IF (K.EQ.1) THEN
            CALL TV('Only 1 datum available for this night!')
            CALL SPACE2
            DO 30 J=JBGN,JEND
C                subtract dark:
                 IF((NSTR(J).GT.0 .AND. NDUSED(KBND(J)).NE.NDET) .OR.
     1                 (NSTR(J).LE.0 .AND. KBND(J).NE.NDET)) THEN
c                   skip it.
                 ELSE
                    SIGNAL(J)=SIGNAL(J)-SIGA
                 END IF
   30       CONTINUE
C           skip plot.
            GO TO 99
        ELSE
            CALLTV('NO DATA AVAILABLE FOR THIS NIGHT -- no subtraction')
            GO TO 99
        END IF
C
C       Do polygon interpolation here.
C
        K1=1
        K2=2
C
        DO 40 J=JBGN,JEND
           IF (NDUSED(KBND(J)).NE.NDET) GO TO 40
C          skip observations with other detectors.
           IF (J.LT.JMIN) THEN
C              Before 1st dark (at JMIN); use it.
               SIGNAL(J)=SIGNAL(J)-SIGA
           ELSE IF (J.GT.JMAX) THEN
C              After last dark (at JMAX); use it.
               SIGNAL(J)=SIGNAL(J)-SIGZ
           ELSE
C              Can interpolate.
               IF (DJOBS(J).GT.XS(K2)) THEN
C                  Step to next interval.
                   K1=K2
                   K2=K2+1
               END IF
C
C               linear interp...
                FRACT=(DJOBS(J)-XS(K1))/(XS(K2)-XS(K1))
                SIGNAL(J)=SIGNAL(J)-(YS(K1)+(YS(K2)-YS(K1))*FRACT)
           END IF
C          note that we have no plot of residuals at the DARK data points,
C          as they are negligible for polygon fit.
   40   CONTINUE
C
   99   JBGN=JEND+1
C       IF (JBGN.GT.NDATA) RETURN
  100 CONTINUE
C
      RETURN
      END
      SUBROUTINE ROBLIN (X, Y, N,  XBAR, YBAR, SLOPE)
C
C       Fits a robust line to N pairs (X,Y), having medians (Xbar, Ybar)
C       and SLOPE.  Method: see Hoaglin, Mosteller & Tukey, Ch.5.
C
C       Does NOT mess up input data; but leaves them sorted on X in XDUM,YDUM.
C
C
C       Input arguments:
C
      INTEGER N
      REAL X(N), Y(N)
C
C       Output arguments:
C
      REAL XBAR,YBAR,SLOPE
C
C   Scratch arrays:
C
      INCLUDE 'MID_REL_INCL:obs.inc'
C     (defines MXOBS.)
      REAL XDUM,YDUM,ZDUM
      COMMON /SCRAT/ XDUM(MXOBS), YDUM(MXOBS), ZDUM(MXOBS)
C
C   Local variables:
C
      INTEGER I,J,N3,MID,MIDL,MIDR
      REAL XL,XR,YL,YR,B,B0,B1,B2,RL,RR,DELTA1,DELTAX,DR0,DR1
C
C
C   *****  BEGIN EXECUTION  *****
C
      IF (N.GT.MXOBS)THEN
            CALL TV('Too many data to sort in available slots.')
            CALL TV('Expand MXOBS and recompile.')
            CALL STSEPI
      ELSE IF (N.EQ.2)THEN
            XBAR=(X(1)+X(2))/2.
            YBAR=(Y(1)+Y(2))/2.
            IF (X(2).NE.X(1)) THEN
              SLOPE=(Y(2)-Y(1))/(X(2)-X(1))
            ELSE
              SLOPE=0.
            END IF
            RETURN
      ELSE IF (N.EQ.1)THEN
            XBAR=X(1)
            YBAR=Y(1)
            SLOPE=0.
            RETURN
      ELSE IF (N.LE.0)THEN
            CALL TV('ROBLIN can''t fit a line to 0 points!')
            CALL TVN('BUG in program')
            CALL STSEPI
      END IF
C
      DO 1 I=1,N
      XDUM(I)=X(I)
      YDUM(I)=Y(I)
      ZDUM(I)=Y(I)
    1 CONTINUE
C
      CALL SORT1(ZDUM,N)
      CALL SORT2(XDUM,YDUM,N)
      MID=(N+1)/2
C
      IF (MID.EQ.N/2) THEN
C                             N EVEN
            XBAR=(XDUM(MID)+XDUM(MID+1))*0.5
            YBAR=(ZDUM(MID)+ZDUM(MID+1))*0.5
      ELSE
C                             N ODD
            XBAR=XDUM(MID)
            YBAR=ZDUM(MID)
      END IF
C
C             Pick size of end thirds:
C
      N3=(N+1)/3
C                     Pick end thirds:
      MIDL=(N3+1)/2
      MIDR=N+1-MIDL
C
      IF (MIDL.EQ.N3/2) THEN
C                             N3 EVEN
            XL=(XDUM(MIDL)+XDUM(MIDL+1))*0.5
            XR=(XDUM(MIDR)+XDUM(MIDR-1))*0.5
      ELSE
C                             N3 ODD
            XL=XDUM(MIDL)
            XR=XDUM(MIDR)
      END IF
      DELTAX=(XR-XL)
C
C       Now find y medians for left and right groups.
C                             LEFT group:
      DO 10 I=1,N3
   10 ZDUM(I)=YDUM(I)
      CALL SORT1(ZDUM,N3)
C
      IF (MIDL.EQ.N3/2) THEN
C                     N3 EVEN
            YL=(ZDUM(MIDL)+ZDUM(MIDL+1))*0.5
      ELSE
C                     N3 ODD
            YL=ZDUM(MIDL)
      END IF
C                             RIGHT group:
      DO 20 I=1,N3
   20 ZDUM(I)=YDUM(N+1-I)
      CALL SORT1(ZDUM,N3)
C
      IF (MIDL.EQ.N3/2) THEN
C                     N3 EVEN
            YR=(ZDUM(MIDL)+ZDUM(MIDL+1))*0.5
      ELSE
C                     N3 ODD
            YR=ZDUM(MIDL)
      END IF
C
      B0=(YR-YL)/DELTAX
      B=B0
C
C       B0 is initial slope.
C
C                     *****  BEGIN ITERATIONS  *****
      DO 50 J=1,5
C             Put RESIDS. in zdum:
C                             LEFT:
        DO 30 I=1,N3
   30   ZDUM(I)=YDUM(I)-(YBAR+B*(XDUM(I)-XBAR))
        CALL SORT1(ZDUM,N3)
C
        IF (MIDL.EQ.N3/2) THEN
C                     N3 EVEN
            RL=(ZDUM(MIDL)+ZDUM(MIDL+1))*0.5
        ELSE
C                     N3 ODD
            RL=ZDUM(MIDL)
        END IF
C                             RIGHT:
        DO 40 I=1,N3
   40   ZDUM(I)=YDUM(N+1-I)-(YBAR+B*(XDUM(N+1-I)-XBAR))
        CALL SORT1(ZDUM,N3)
C
        IF (MIDL.EQ.N3/2) THEN
C                     N3 EVEN
            RR=(ZDUM(MIDL)+ZDUM(MIDL+1))*0.5
        ELSE
C                     N3 ODD
            RR=ZDUM(MIDL)
        END IF
C
        IF (J.EQ.1) THEN
            DR0=RR-RL
            DELTA1=DR0/DELTAX
            B1=B0+DELTA1
            IF (B1.EQ.B0) GOTO 100
            B=B1
        ELSE
            DR1=RR-RL
            IF (DR1.EQ.0.) GOTO 100
            IF (ABS((DR1-DR0)/DR1).LT.1.E-4) GOTO 100
            B2=B1-DR1*(B1-B0)/(DR1-DR0)
            B=B2
            IF (ABS(B2-B1).LT.1.E-6*ABS(B1)) GO TO 100
C                     prepare for next round:
            B0=B1
            B1=B2
            DR0=DR1
        END IF
   50 CONTINUE
C
  100 CONTINUE
      SLOPE=B
C       Current value of b is converged.  Recalculate all resids.:
C
      DO 110 I=1,N
  110 ZDUM(I)=YDUM(I)-(YBAR+B*(XDUM(I)-XBAR))
      CALL SORT1(ZDUM,N)
C
      IF (MID.EQ.N/2) THEN
C                             N EVEN
            YBAR=(ZDUM(MID)+ZDUM(MID+1))*0.5+YBAR
      ELSE
C                             N ODD
            YBAR=ZDUM(MID)+YBAR
      END IF
C
C
      RETURN
      END
      SUBROUTINE SORT1(X,N)
C
C       Sorts X, in place.
C
C  BOOTHROYD'S SHELL-SORT:  COMM.ACM 6,445(1963) ALG.201.
C
C  SEE H.LORIN,"SORTING & SORT SYSTEMS" (ADDISON-WESLEY,1975)
C  CH.3 & 11 FOR THEORY AND TESTS.
C
C
      IMPLICIT NONE
C
      INTEGER N
      REAL X(N)
C
C
C  Local variables:
C
      INTEGER I,J,M
      REAL DUM
C
C  **** BEGIN ****
C
      IF(N.EQ.1)RETURN
      I=1
    3 I=I+I
      IF(I.LE.N)GO TO 3
      M=I-1
    5 M=M/2
      IF(M.EQ.0)RETURN
      DO 20 J=1,N-M
      DO 10 I=J,1,-M
      IF(X(I+M).GE.X(I)) GO TO 20
      DUM=X(I)
      X(I)=X(I+M)
      X(I+M)=DUM
   10 CONTINUE
   20 CONTINUE
      GO TO 5
C
      END
      SUBROUTINE SORT2(X,Y,N)
C
C       Sorts (X,Y) pairs on X, in place.
C
C  BOOTHROYD'S SHELL-SORT:  COMM.ACM 6,445(1963) ALG.201.
C
C  SEE H.LORIN,"SORTING & SORT SYSTEMS" (ADDISON-WESLEY,1975)
C  CH.3 & 11 FOR THEORY AND TESTS.
C
C
      IMPLICIT NONE
C
      INTEGER N
      REAL X(N),Y(N)
C
C
C  Local variables:
C
      INTEGER I,J,M
      REAL DUM
C
C  **** BEGIN ****
C
      IF(N.EQ.1)RETURN
      I=1
    3 I=I+I
      IF(I.LE.N)GO TO 3
      M=I-1
    5 M=M/2
      IF(M.EQ.0)RETURN
      DO 20 J=1,N-M
      DO 10 I=J,1,-M
      IF(X(I+M).GE.X(I)) GO TO 20
      DUM=X(I)
      X(I)=X(I+M)
      X(I+M)=DUM
      DUM=Y(I)
      Y(I)=Y(I+M)
      Y(I+M)=DUM
   10 CONTINUE
   20 CONTINUE
      GO TO 5
C
      END
      SUBROUTINE YPLIN
C
C  YP for use by DLSQ in linear fits.
C
C
C  fits:   Y = P(1) + P(2)*Z(1)
C
C
      IMPLICIT NONE
C
C     Includes for dlsq:
      INCLUDE 'MID_REL_INCL:kingfit.inc'
      INCLUDE 'MID_REL_INCL:dlsq.inc'
C
C
C
      YT = P(1) + P(2)*Z(1)
C
      PART(1)=1.D0
      PART(2)=Z(1)
C
      IP(1)=1
      IP(2)=2
      KIP=2
C
C
      RETURN
      END
      SUBROUTINE SKYSUB(BANDS,KMIN,KMAX,DTYPE,KDIAPHRAGM,EXTIN)
C
C       scans SIGNAL for items with DTYPE='Y', and does modelling,
C       interpolation, and subtraction of sky for each passband.
C
C
      IMPLICIT NONE
C
C
      INCLUDE 'MID_REL_INCL:mbands.inc'
C     PARAMETER (MBANDS=9)
C
      INCLUDE 'MID_REL_INCL:obs.inc'
      REAL XDUM,YDUM,ZDUM
      COMMON /SCRAT/ XDUM(MXOBS), YDUM(MXOBS), ZDUM(MXOBS)
C
C
C   Args:
C
      INTEGER KMIN, KMAX, KDIAPHRAGM
      CHARACTER DTYPE(MXOBS)
      REAL EXTIN(MBANDS)
C
C
      REAL COSOB, SINOB, RASUN, DESUN, HASUN, SOLONG, ELMOON, BMOON, 
     1    SINPHI, COSPHI, ELONG, ELROT, UTROT, STUTZ, TWOPI, ST2UT, 
     2    TNOON1, TNOON2, PI, DEGRAD, ALAT, XLIMS, YLIMS, ALTS, T, 
     3    YMAX, YMIN, AIRMAX, SALTS, OBLIQ, SIGMIN, 
     4    SIGMAX, RISE, SET, DAWN, DUSK, UTRAD, TLST, HAMOON, COSDEL, 
     5    SINDEL, COSHA, XM, YM, ZM, AZMOON, DELAZ, COSEL, XBAR, 
     6    YBAR, SLOPE, OLDVAR, ELONGMAX, ELONGMIN, ZENITH
C
      INTEGER NB, LEN, LWORD, JBGN, NIGHT, NTWI,
     1       K, J, JMIN, JMAX, JEND, MOONUP, NERROR, NIX, NPTS, NFIT
C
C   COMMONS FOR SPHERICAL TRIG.:
C
      COMMON /CSUN/ COSOB,SINOB,RASUN,DESUN,HASUN,SOLONG,ELMOON,BMOON
      COMMON /SPHERE/ SINPHI,COSPHI,ELONG,ELROT,UTROT,STUTZ,TWOPI,ST2UT,
     1 TNOON1,TNOON2,PI,DEGRAD,ALAT
      INTEGER MXCOLR
      PARAMETER (MXCOLR=3*MBANDS)
C
C       commons for star catalog:
      INCLUDE 'MID_REL_INCL:mstars.inc'
C     PARAMETER (MSTARS=1650)
      CHARACTER *32 STARS
      COMMON /SCATA/ STARS(MSTARS)
C
C     Includes for dlsq:
      INCLUDE 'MID_REL_INCL:kingfit.inc'
      INCLUDE 'MID_REL_INCL:dlsq.inc'
C
C
C   Commons for 12 Diaphragms:
C
      INTEGER NP2NDIA(12*MBANDS)
      INTEGER NDIA2NP(12,MBANDS), NDIAS,NDIA
C          indices: NDIA,K
      REAL      XNDIA(12,MBANDS)
      COMMON /DIACOM/XNDIA,NP2NDIA,NDIA2NP,NDIAS,NDIA
C
      CHARACTER DIANAM(12)*4
      COMMON /DIACH/DIANAM
C
C
C   LOCAL variables:
C
      CHARACTER A1, CARD*80, BANDS(MXCOLR)*8, DATSTR*16
C
      REAL ERRSAVE(12)
      INTEGER LORDER(12),L,NN, JDUSK,JDAWN, NPARMS,NREFDIA
C
      LOGICAL TWILIT, SHORT
C
C
      EXTERNAL YPLIN, YPSKY
C
C
      DIMENSION XLIMS(2),YLIMS(2)
      DIMENSION ALTS(2), SALTS(5)
C
C       true altitude of Moon at rise & set:
      DATA ALTS/-.0145,-.0145/
C
C
C       true altitude of Sun at limit of astronomical twilight:
      DATA SALTS/-.309,0.,0.,0.,-.309/
C
C
C
C       Begin execution:
C
      CALL SPACE2
      CALL TV('               SKY subtraction:')
      CALL TV('You will see graphs of sky brightness, plotted against')
      CALL TVN('time, airmass, and lunar elongation, for each band,')
      CALL TVN('on each night separately.')
      CALL TV('Then you can choose the method of fitting or')
      CALL TVN('interpolating sky brightness, for each case.')
      CALL SPACE
      CALL RTNCON(' ',1)
      CALL PLOT(0,78.,23.,'P')
C
      DO 1000 NB=KMIN,KMAX
        LEN=LWORD(BANDS(NB))
        JBGN=1
      DO 1000 NIGHT=1,NIGHTS
        CALL SPACE2
        CALL NEED(24)
    2   CARD(:LEN)=BANDS(NB)
        CARD(LEN+1:LEN+10)='  SKY on'
        CALL JD2DAT(REAL(2400000.5D0+DTZERO(NIGHT)),CARD(LEN+11:))
        DATSTR=CARD(LEN+6:)
        SHORT=.FALSE.
C
    3   K=0
        DO 5 NDIA=1,NDIAS
           NDIA2NP(NDIA,1)=0
    5   CONTINUE
        YMAX=-3.E33
        YMIN=3.E33
        AIRMAX=1.
C
        DO 10 J=JBGN,NDATA
C
C         find range of sky data for current night and passband.
          IF (NITE(J).NE.NIGHT) GO TO 12
          IF (KBND(J).NE.NB) GO TO 10
          IF (DTYPE(J).EQ.'Y')THEN
C           add to XS, YS.
            K=K+1
            XS(K)=DJOBS(J)
            YS(K)=SIGNAL(J)
            YMAX=MAX(YMAX,SIGNAL(J))
            YMIN=MIN(YMIN,SIGNAL(J))
            AIRMAX=MAX(AIRMAX,AIRM(J))
            IF (K.EQ.1) JMIN=J
            IF (K.EQ.1) SIGMIN=SIGNAL(J)
            JMAX=J
            SIGMAX=SIGNAL(J)
          END IF
C
   10   CONTINUE
        J=NDATA+1
C
   12   CONTINUE
        JEND=J-1
C
C    JBGN, JEND index the first and last data of ANY kind for the night.
C    JMIN, JMAX index the first and last SKY data for the night & band.
C    SIGMIN, SIGMAX are the first and last sky LEVELS for the night.
C
C       K is count of data for night N.
C
        T=(DTZERO(NIGHT)+INT(DJOBS((JBGN+JEND)/2))-51544.5)/36525.
        CALL STUTZR(T)
C       STUTZR sets sidereal time for later use by UTMOON & UTSUN.
C       Set OBLIQ for SUN (called by UTSUN).
        OBLIQ=(23.43929-T*(1.30042E-2+T*(1.639E-7-T*5.036E-7)))*DEGRAD
        COSOB=COS(OBLIQ)
        SINOB=SIN(OBLIQ)
C
C     Adjust YMAX for possible outliers:
C
        CALL SORT2(YS,XS,K)
C       (Note reversal of Y and X.)
        YM=(YS((K+1)/2)+YS(K/2+1))*0.5
C       YM is median.
        NN=(K+2)/4
        ZM=YS(K-NN)-YS(NN)
C       ZM is interquartile range.
        YMAX=MIN(YMAX,YM+4.*ZM)
C
        IF (K.GT.1) THEN
C
C           Take shortcut if required:
            IF (SHORT) THEN
               A1='T'
               GO TO 102
            END IF
C
C           set up plots; first, TIME:
C
C           set plot limits:
            XLIMS(1)=DJOBS(JMIN)
            XLIMS(2)=DJOBS(JMAX)
            YLIMS(1)=YMIN
            YLIMS(2)=YMAX
            CALL PLOT(0,XLIMS,YLIMS,'L')
C
C           plot moonrise & moonset.  First, guarantee RISE < SET:
            RISE=DJOBS(JMIN)
            SET=DJOBS(JMAX)
C           UTMOON needs T in Julian centuries from J2000.
            T=((2400000.5D0-2451545.D0)+DTZERO(NIGHT)+
     1                   INT(DJOBS((JBGN+JEND)/2)))/36525.
            CALL UTMOON(T,ALTS,1,*21)
C           UTMOON returns result in UTROT, in /SPHERE/.
            RISE=UTROT+INT(DJOBS((JBGN+JEND)/2))
C           we have at most 18 intervals between YMIN & YMAX.
            CALL PLOT(-1,RISE,(YMIN+14.*YMAX)/15.,'|')
            CALL PLOT(-1,RISE,(YMIN*2.+13.*YMAX)/15.,'|')
            CALL PLOT(-1,RISE,YMAX,'R')
            IF (DJOBS(JMIN).LT.RISE .AND. DJOBS(JMAX).GT.RISE)
     1         CARD(LWORD(CARD)+5:)='R = moonrise'
   21       CALL UTMOON(T,ALTS,2,*22)
            SET=UTROT+INT(DJOBS((JBGN+JEND)/2))
            CALL PLOT(-1,SET,(YMIN+14.*YMAX)/15.,'|')
            CALL PLOT(-1,SET,(YMIN*2.+13.*YMAX)/15.,'|')
            CALL PLOT(-1,SET,YMAX,'S')
            IF (DJOBS(JMIN).LT.SET .AND. DJOBS(JMAX).GT.SET)
     1         CARD(LWORD(CARD)+5:)='S = moonset'
   22       CONTINUE
C
C           RISE & SET now are correct for Moon.  Do SUN:
            DUSK=DJOBS(JMIN)
            DAWN=DJOBS(JMAX)
C           Here the argument is DAYS from J2000.
            CALL UTSUN(T*36525.,SALTS,1,*23)
            DUSK=UTROT+INT(DJOBS((JBGN+JEND)/2))
   23       CALL UTSUN(T*36525.,SALTS,5,*24)
            DAWN=UTROT+INT(DJOBS((JBGN+JEND)/2))
   24       CONTINUE
C           DUSK & DAWN are now limits of astronomical twilight.
C
            TWILIT=.FALSE.
            JDUSK=JEND
            JDAWN=JBGN
            DO 26 J=JMIN,JMAX
                IF (KBND(J).NE.NB) GO TO 26
                IF ( (DAWN.LT.DUSK  .AND.
     1               DJOBS(J).GT.DAWN .AND. DJOBS(J).LT.DUSK) .OR.
     2               (DAWN .GT.DUSK  .AND.
     3               (DJOBS(J).GT.DAWN .OR. DJOBS(J).LT.DUSK) )  ) THEN
C                   Twilight.
                    A1='t'
                    TWILIT=.TRUE.
                ELSE
C                   Not twilit.
                    A1='*'
                    JDUSK=MIN(JDUSK,J)
                    JDAWN=MAX(JDAWN,J)
                END IF
                IF (DTYPE(J).EQ.'Y')THEN
                    CALL PLOT(-1,DJOBS(J),SIGNAL(J),A1)
                END IF
   26       CONTINUE
            IF (TWILIT) CARD(LWORD(CARD)+5:)='t = twilight sky'
            CALL TV(CARD)
            CALL SPACE
            CALL PLOT(1,0.,0.,'+')
            WRITE(CARD,'(A,F7.0)')'    TIME (MJD =',DTZERO(NIGHT)
            CARD(LWORD(CARD):)=' + decimal of day) -->'
            CALL RTNCON(CARD,LWORD(CARD))
C
C               End of TIME plot; begin AIRMASS plot.
C
            CALL NEED(24)
            CARD(:32)='SKY brightness vs. AIRMASS, for'
            CARD(33:LEN+33)=BANDS(NB)
            CARD(LEN+34:)=DATSTR
            CARD(LWORD(CARD)+5:)='M = Moon up'
            CALL TV(CARD)
            CALL SPACE
            XLIMS(1)=1.
            XLIMS(2)=AIRMAX
            CALL PLOT(0,XLIMS,YLIMS,'L')
            K=0
            MOONUP=0
            NTWI=0
            DO 30 J=JMIN,JMAX
              IF (KBND(J).NE.NB) GO TO 30
              IF (DTYPE(J).EQ.'Y')THEN
                K=K+1
                IF ( (DAWN.LT.DUSK  .AND.
     1               DJOBS(J).GT.DAWN .AND. DJOBS(J).LT.DUSK) .OR.
     2               (DAWN .GT.DUSK  .AND.
     3               (DJOBS(J).GT.DAWN .OR. DJOBS(J).LT.DUSK) )  ) THEN
C                   Twilight.
                    A1='t'
                    NTWI=NTWI+1
                    KX(1,K)=-1
                ELSE IF ( (RISE.LT.SET  .AND.
     1               DJOBS(J).GT.RISE .AND. DJOBS(J).LT.SET) .OR.
     2               (RISE .GT.SET  .AND.
     3               (DJOBS(J).GT.RISE .OR. DJOBS(J).LT.SET) )  ) THEN
C                   Moon is up.  Flag in KX.
                    A1='M'
                    MOONUP=MOONUP+1
C                   Flag for model solution.
                    KX(1,K)=1
                ELSE
C                   Moon is down.
                    A1='-'
                    KX(1,K)=0
                END IF
                SYMB(K)=A1
                CALL PLOT(-1,AIRM(J),SIGNAL(J),A1)
C               Set KX(2,*) to NDIA, or 0 if no diaphragm:
                DO 28 NDIA=1,NDIAS
                  IF (DIAPH(J).EQ.DIANAM(NDIA)) THEN
                     KX(2,K)=NDIA
                     NDIA2NP(NDIA,1)=NDIA2NP(NDIA,1)+1
                     GO TO 29
                  END IF
   28           CONTINUE
C               Here only if no dias.
                KX(2,K)=0
C                          Debugging:
C                          IF (KDIAPHRAGM.NE.-1) CALL TV('Dia.error!')
   29           CONTINUE
C               Set KX(3,*) to J for use in later plots.
                KX(3,K)=J
C               Set X(1,*) to airmass.
                X(1,K)=AIRM(J)
C               Set X(4,*) to nearest star signal.
                CALL HALO(NB,DTYPE,KDIAPHRAGM,J,JBGN,JEND, X(4,K))
                Y(K)=SIGNAL(J)
                W(K)=1./ABS(SIGNAL(J))
              END IF
   30       CONTINUE
            CALL PLOT(1,50.,-50.,' ')
            CALL RTNCON('     AIRMASS -->',16)
C
C               End of AIRMASS plot; begin LUNAR ELONGATION plot.
C
            IF(MOONUP.LT.2) GO TO 100
            ELONGMAX=0.
            ELONGMIN=50.
            CALL NEED(24)
            CARD(:41)='SKY brightness vs. LUNAR ELONGATION, for'
            CARD(42:LEN+42)=BANDS(NB)
            CARD(LEN+43:)=DATSTR
            CARD(LWORD(CARD)+5:)='M = Moon up'
            CALL TV(CARD)
            CALL SPACE
            XLIMS(1)=0.
            XLIMS(2)=180.
            CALL PLOT(0,XLIMS,YLIMS,'L')
            K=0
            DO 40 J=JMIN,JMAX
              IF (KBND(J).NE.NB) GO TO 40
              IF (DTYPE(J).EQ.'Y')THEN
                K=K+1
                T=(DTZERO(NIGHT)-51544.5D0+DJOBS(J))/36525.
                UTRAD=MOD(DJOBS(J),1.)*TWOPI
                TLST=STUTZ+(UTRAD*1.00273791)+ELONG
C               MOON uses T for lunar position, TLST for topocentric ephemeris.
                CALL MOON(T, TLST)
C               MOON returns lunar coords. in RASUN, DESUN in /CSUN/.
                HAMOON=TLST-RASUN
                COSDEL=COS(DESUN)
                SINDEL=SIN(DESUN)
                COSHA=COS(HAMOON)
                XM= -COSDEL*SIN(HAMOON)
                YM=COSPHI*SINDEL-SINPHI*COSDEL*COSHA
                ZM=SINPHI*SINDEL+COSPHI*COSDEL*COSHA
                IF (ZM.GT.ALTS(1)) THEN
C                  Set X(2,*) to LUNAR airmass.  (ZM is cosZ(Moon).)
                   X(2,K)=(.0096467+ZM*(.148386+ZM*1.0024342))/
     1                    (.000303978+ZM*(.0102963+ZM*(.149864+ZM)))
                ELSE
C                  Moon below horizon.
                   X(2,K)=50.
C                                  WRITE(CARD,*)'ZM=',ZM
C                                  IF(KX(1,K).EQ.1)CALL TV(CARD)
                   IF(KX(1,K).EQ.1) SYMB(K)='m'
                END IF
                AZMOON=ATAN2(YM,XM)
                DELAZ=AZMOON-AZIM(J)
C               approximate cosz(sky) as 1/airmass.
                COSEL=ZM/AIRM(J) +
     1               SQRT((1.-ZM*ZM)*(1.-1./AIRM(J)**2))*COS(DELAZ)
C               Set X(3,*) to lunar elongation.
                X(3,K)=ACOS(COSEL)
                IF (KX(1,K).EQ.1) THEN
                   ELONGMAX=MAX(ELONGMAX,X(3,K))
                   ELONGMIN=MIN(ELONGMIN,X(3,K))
                END IF
                XS(K)=ACOS(COSEL)/DEGRAD
                YS(K)=SIGNAL(J)
              END IF
   40       CONTINUE
            CALL PLOT(0,0.,0.,'D')
            CALL PLOT(K,XS,YS,SYMB)
            CALL PLOT(0,0.,0.,'S')
            CALL RTNCON('     LUNAR ELONGATION (deg.) -->',32)
C
C               End of plots.
C
  100       CALL SPACE
            CALL TVN('Do you want to interpolate in TIME alone, or')
            CALL TVN('do you want to try fitting sky with a MODEL?')
            CALL TV('(Enter T for Time; M to Model the sky; or)')
            CALL ASKN('(        R to re-display the plots.)',A1)
            CALL SPACE
C
  102       IF (A1.EQ.'T') THEN
                K=0
                DO 105 J=JMIN,JMAX
C
C                  restore sky data for current night and passband.
                   IF (KBND(J).NE.NB) GO TO 105
                   IF (DTYPE(J).EQ.'Y')THEN
C                    add to XS, YS.
                     K=K+1
                     XS(K)=DJOBS(J)
                     YS(K)=SIGNAL(J)
                   END IF
C
  105           CONTINUE
C
  110           CALL TV('Enter C to replace sky data with a Constant,')
                CALL TVN('      L to smooth with a Linear fit,')
                CALL TVN('      N to use the sky Nearest the star,')
                CALL TVN('      P to use the sky Preceding the star,')
                CALL TVN('      F to use the sky Following the star,')
                CALL TVN('      R to Re-display plots,')
                CALL TVN('   or Q to Quit.')
                CALL ASKN('?',A1)
                IF (A1.EQ.'C') THEN
C                   be lazy: fit line, but force it horizontal.
                    CALL ROBLIN(XS,YS,K, XBAR,YBAR,SLOPE)
                    SLOPE=0.
                    PG(2)=0.
                    NIX=1
                    IX(1)=2
                ELSE IF (A1.EQ.'L') THEN
                    IF (K.LT.6) THEN
                        CALL TV('Not enough data to fit a line safely.')
                        CALL TVN('Try a constant instead.')
                        GO TO 110
                    END IF
                    CALL ROBLIN(XS,YS,K, XBAR,YBAR,SLOPE)
                    PG(2)=SLOPE
                    NIX=0
                ELSE
C                  for neighboring-sample subtraction:
C
                   IF (A1.EQ.'N') THEN
C                     use NEAREST neighbor.
                      CALL TV('CAUTION: This method is not robust!')
                      CALL SKYNBR(NB,DTYPE,KDIAPHRAGM,JBGN,JEND)
                   ELSE IF (A1.EQ.'P') THEN
C                     SKY comes first.
                      CALL TV('CAUTION: This method is not robust!')
                      CALL SKYADJ(NB,DTYPE,KDIAPHRAGM,JBGN,JEND,NERROR)
                      IF (NERROR.GT.0) GO TO 2
                   ELSE IF (A1.EQ.'F') THEN
C                     STAR comes first, so scan in reverse order.
                      CALL TV('CAUTION: This method is not robust!')
                      CALL SKYADJ(NB,DTYPE,KDIAPHRAGM,JEND,JBGN,NERROR)
                      IF (NERROR.GT.0) GO TO 2
                   ELSE IF (A1.EQ.'R') THEN
                      GO TO 2
                   ELSE
                      CALL TV('Usually N is your best choice; but')
                      CALL TVN('if you have been careful to take sky')
                      CALL TVN('ALWAYS before or after every star, you')
                      CALL TVN('can choose P for sky-then-star, or')
                      CALL TVN('           F for star-then-sky.')
                      GO TO 110
                   END IF
C                  skip residual plots if sky is subtracted exactly.
                   CALL TV('(Sky samples were subtracted exactly; so')
                   CALL TVN(' there are no residuals to plot.)')
                   GO TO 999
                END IF
C
C               here when linear model was used.
C
                IPR=0
                PG(1)=YBAR
C               PG(2) was set above.
                DO 120 J=1,K
                  X(1,J)=XS(J)-XBAR
                  Y(J)=YS(J)
                  W(J)=1.
  120           CONTINUE
C               refine fit:
C     Subroutine DLSQ(YP,NPTS,NPARMS,NBLOX,MBLOK,NIX,NARGS,NKARGS,TEST)
                CALL DLSQ(YPLIN,K,2,  1,    2,   NIX, 1,    0,   1.E-3)
                SLOPE=P(2)
                YBAR=P(1)
C
                YMAX=-3.E33
                YMIN=3.E33
C
                DO 130 J=JBGN,JEND
                    IF (KBND(J).NE.NB) GO TO 130
C                   subtract fitted sky:
                    SIGNAL(J)=SIGNAL(J)-((DJOBS(J)-XBAR)*SLOPE+YBAR)
                    IF (DTYPE(J).EQ.'Y') THEN
                        YMAX=MAX(YMAX,SIGNAL(J))
                        YMIN=MIN(YMIN,SIGNAL(J))
                    END IF
  130           CONTINUE
C
C               plot sky resids.
C
                CALL NEED(24)
                CARD(:26)='Sky resids.  vs. TIME for'
                CARD(27:)=BANDS(NB)
                CALL TV(CARD)
C               set plot limits....
                XLIMS(1)=DJOBS(JMIN)
                XLIMS(2)=DJOBS(JMAX)
                YLIMS(1)=YMIN
                YLIMS(2)=YMAX
                CALL PLOT(0,XLIMS,YLIMS,'L')
                DO 140 J=JBGN,JEND
                   IF (KBND(J).NE.NB) GO TO 140
                   CALL PLOT(-1,DJOBS(J),SIGNAL(J),'*')
  140           CONTINUE
C               force plot:
                CALL PLOT(1,0.,0.,'+')
                CALL RTNCON('     Time (decimal days) -->',28)
                GO TO 999
C
            ELSE IF (A1.EQ.'M') THEN
C               go on.
C
            ELSE IF (A1.EQ.'R') THEN
                GO TO 2
C
            ELSE IF (A1.EQ.'H') THEN
                CALL SPACE2
                CALL TV('Reply M to detect bad sky measurements.')
                CALL TV('Reply T to use a neighboring sky sample,')
                CALL TVN('either before, after, or nearest the star.')
                CALL SPACE2
                GO TO 100
C
            ELSE
                GO TO 100
            END IF
        ELSE IF (K.EQ.1) THEN
            CALL TV('Only 1 datum available for this night!')
            CALL SPACE2
            DO 150 J=JBGN,JEND
C               subtract sky:
                IF (KBND(J).EQ.NB)
     1              SIGNAL(J)=SIGNAL(J)-SIGMIN
  150       CONTINUE
C           skip plot.
            GO TO 999
        ELSE
            CALL TV('NO SKY DATA AVAILABLE for this night')
            Call ASK('Do you want to continue?',A1)
            IF (A1.EQ.'Y') THEN
               RETURN
            ELSE
               CALL STSEPI
            END IF
        END IF
C
C
C       Now  *****  MODEL  *****  and interpolate sky.
C
        IPR=0
        NPTS=K
C       remove const. term:
        NIX=1
        IX(1)=1
        PG(1)=0.
C       set up diaphragm factors:
        NPARMS=11
        NN=0
        NREFDIA=0
        DO 157 K=12,11+NDIAS
           PG(K)=1.
           NDIA=K-11
               WRITE(CARD,*)NDIA2NP(NDIA,1),' data in dia.',DIANAM(NDIA)
               CALL TV(CARD)
C          Set NPARMS to largest one actually used.
           IF (NDIA2NP(NDIA,1).GT.0) NPARMS=K
C          Find leading diaphragm...
           IF (NDIA2NP(NDIA,1).GT.NN) THEN
C             flag NDIA as possible NREFDIA.
              NN=NDIA2NP(NDIA,1)
              NREFDIA=NDIA
           END IF
  157   CONTINUE
C
C
C       Plot star haloes:
        K=0
        DO 160 J=1,NPTS
           IF (X(4,J).GT.0.) THEN
             K=K+1
             XS(K)=X(4,J)
             YS(K)=Y(J)
           END IF
  160   CONTINUE
        CALL ROBLIN(XS,YS,K,  XBAR, YBAR, SLOPE)
C       Fraction of star included:
        IF (SLOPE.GT.0. .AND. SLOPE.LT.0.01) THEN
          CALL SORT2(XS,YS,K)
          ZM=XS(K)
C         ZM is max. value of XS.
          CALL NEED(24)
          CALL CENTER('Sky vs. corresponding Star signal:')
          CALL TVN('    Sky')
          CALL PLOT(-K,XS,YS,' ')
          CALL PLOT(0,0.,0.,'O')
          DO 165 J=1,20
             XM=J*ZM/20.
             YM=YBAR+SLOPE*(XM-XBAR)
             CALL PLOT(-1,XM,YM,'+')
  165     CONTINUE
          CALL PLOT(0,0.,1.,'O')
          DO 166 J=1,NPTS
            IF (X(4,J).EQ.0.) GO TO 166
            CALL PLOT(-1,X(4,J),Y(J),SYMB(J))
  166     CONTINUE
          CALL PLOT(1,0.,0.,'+')
          CARD='   Star signal -->      (Sky is 0.xxxx of Star)'
          WRITE (CARD(32:38),'(F7.4)') SLOPE
          CALL RTNCON(CARD,49)
        ELSE
          CALL TV('Contribution of star to sky measures not detected.')
          SLOPE=0.
        END IF
C
C       Set default order:
        DO 167 J=1,10
           LORDER(J)=J
  167   CONTINUE
C
C       estimate PG's:
C
        PG(11)=SLOPE
C
C       Start for dark sky:
C         Fit rough line to dark sky:
          K=0
          DO 170 J=1,NPTS
            IF (KX(1,J).EQ.0) THEN
C             Add to new list:
              K=K+1
              XS(K)=X(1,J)
              YS(K)=Y(J) - PG(11)*X(4,J)
C             set initial wt.:
              W(J)=1.
            ELSE
C             zero weights if Moon is up, or twilight:
              W(J)=0.
            END IF
  170     CONTINUE
          NN=K
C
        IF (NPTS-MOONUP-NTWI.GT.6 .AND. AIRMAX.GT.1.5) THEN
C             Debugging:
C             CALL TV('DATA:')
C             CALL PLOT(-NN,XS,YS,'*')
C         NN data now set for moonless part.
C
          OLDVAR=3.E33
          NFIT=1
C         Set order of relaxation:
          LORDER(3)=4
          LORDER(4)=5
          LORDER(5)=3
C
C         Fit line to data vs. airmass:
          CALL ROBLIN(XS,YS,NN, XBAR,YBAR,SLOPE)
C             Debugging:
C             DO 174 K=1,NN
C               CALL PLOT(-1, XS(K), YBAR+SLOPE*(XS(K)-XBAR),'-')
C 174         CONTINUE
C             CALL PLOT(1,0.,0.,'+')
C             CALL RTNCON('  AIRMASS -->',13)
          PG(2)=YBAR/XBAR
C
          IF (YBAR.LE.XBAR*SLOPE) THEN
C           Negative or zero intercept; form can't be fit.
C                             CALL TV('Negative intercept.')
            PG(3)=0.D0
            PG(4)=0.D0
            PG(5)=0.D0
          ELSE
C           Positive intercept; OK.
            IF (SLOPE.GT.0.5*YBAR/XBAR) THEN
C             P(4) is small.
C                             CALL TV('P(4) small.')
              PG(4)=(SQRT(YBAR/(XBAR*SLOPE))-1.)/XBAR
              PG(5)=PG(4)**2
            ELSE
C             P(4) is big.
C                             CALL TV('P(4) big; using P(5).')
              PG(4)=1./XBAR
              PG(5)=(YBAR/XBAR-SLOPE)/((YBAR+SLOPE*XBAR)*XBAR)
              PG(2)=(YBAR/XBAR+YBAR*PG(4)+YBAR*XBAR*PG(5))
              LORDER(3)=5
              LORDER(4)=4
            END IF
          END IF
C                     Override trial line with a priori values:
                      PG(4)=EXTIN(NB)
                      PG(5)=0.5*PG(4)*PG(4)
                      PG(2)=YBAR/(1.+(PG(4)+PG(5)*XBAR)*XBAR)
        ELSE
C         Not enough data or range to fit.
                              CALL TV('Can''t fit dark sky.')
          PG(2)=YMIN*2.
          PG(4)=EXTIN(NB)
          PG(5)=0.5*PG(4)*PG(4)
        END IF
        PG(3)=PG(5)*PG(2)*0.1
        ZENITH=PG(1)+(PG(2)+PG(3))/(1.+PG(4)+PG(5))
        IF (NPTS-MOONUP-NTWI.LT.6) GO TO 200
C
C       PG's now set.
C
C       hold all fixed but P(2):
        DO 180 J=2,11
          CALL FIXP(J,PG(J),NIX)
  180   CONTINUE
        CALL UNFIXP(2,NIX)
C
C       Relax successive parameters:
        DO 190 L=3,6
           CARD='Solving for x sky parameters...'
C          IF(L.EQ.3) CARD(24:24)=' '
           WRITE(CARD(12:13),'(I2)') L-1
           CALL TV(CARD)
           IF (NPTS+NIX.LT.NPARMS+4) GO TO 191
C
C          Fix all sky parms.:
           DO 181 K=1,11
             IX(K)=K
  181      CONTINUE
           NIX=11
           IF (NDIAS.GT.0) THEN
C             Fix reference diaphragm:
              K=NREFDIA+11
              CALL FIXP(K,PG(K),NIX)
C                    Debugging:
C                    WRITE(CARD,*)'Holding PG(',K,') at',PG(K)
C                    CALL TV(CARD)
           END IF
C
C          See if we can release P(11), the star fraction:
           IF (NPTS.GT.2*MOONUP) CALL UNFIXP(11,NIX)
C
C         First, vary ONLY the new parameter.
          CALL UNFIXP(LORDER(L-1),NIX)
C
C      Subroutine DLSQ(YP,NPTS,NPARMS,NBLOX,MBLOK,NIX,NARGS,NKARGS,TEST)
          CALL DLSQ(YPSKY,NPTS,NPARMS, 1,  NPARMS,NIX, 4,    2,   1.E-3)
C
C          Next, see if result is acceptable:
           IF (WVAR.GT.0.D0) PG(LORDER(L-1))=P(LORDER(L-1))
C          Check each case individually:
           IF (P(2).LT.0.D0) CALL FIXP(2,0.,NIX)
           IF (P(3).LT.0.D0) CALL FIXP(3,0.,NIX)
           IF (P(5).LT.0.D0) CALL FIXP(5,0.,NIX)
           IF (P(11).LT.0.D0) CALL FIXP(11,0.,NIX)
C
           DO 182 K=3,L
              CALL UNFIXP(LORDER(K-1),NIX)
  182      CONTINUE
C
C      Subroutine DLSQ(YP,NPTS,NPARMS,NBLOX,MBLOK,NIX,NARGS,NKARGS,TEST)
          CALL DLSQ(YPSKY,NPTS,NPARMS, 1,  NPARMS,NIX, 4,    2,   1.E-3)
C
C         Give up if solution failed:
          IF (WVAR.EQ.0.D0 .OR. WVAR.GT.1.2*OLDVAR) GO TO 189
C
C         Debugging:
C             CALL TV('DATA:')
C             CALL PLOT(-NN,XS,YS,'*')
C             DO 184 K=1,NPTS
C               remember that YC is DP...
C               IF (W(K).GT.0.) CALL PLOT(-1,X(1,K),REAL(YC(K)),'C')
C 184         CONTINUE
C             CALL PLOT(1,0.,0.,'+')
C             CALL RTNCON('  AIRMASS -->',13)
C
C         Check solution for plausibility:
          IF (P(2).LE.0.D0 .OR. P(3).LT.0.D0 .OR. P(5).LT.0.D0 .OR.
     1       (P(4).LT.0.D0 .AND. P(4)*P(4).GE.4.D0*P(5)) .OR.
     2       (P(4).GT.100.D0 .OR. P(5).GE.100.D0) .OR.
     3       (P(11).GT.0.01D0 .OR. P(11).LT.0.D0) ) THEN
C            Trouble.
             GO TO 189
          ELSE
C            OK.
          END IF
C
C         Adjust weights of moonless data:
          ZENITH=PG(1)+(PG(2)+PG(3))/(1.+PG(4)+PG(5))
          DO 185 K=1,NPTS
            IF (KX(1,K).EQ.0) W(K)=EXPTIM(KX(3,K))/(ABS(YC(K)) + ZENITH)
  185     CONTINUE
C         Update parameters:
          DO 187 K=1,5
             PG(K)=P(K)
             ERRSAVE(K)=SP(K)
C             WRITE(CARD,'(''P('',I2,'') ='',G9.2)') K,P(K)
C             CALL TV(CARD)
C             WRITE(CARD,'(4X,''+/-'',G9.2)') SP(K)
C             CALL TVN(CARD)
  187     CONTINUE
C         Star wings:
          PG(11)=P(11)
C          IF (SP(11).GT.0.) THEN
C             WRITE(CARD,'(''P(11) ='',G9.2)') P(11)
C             CALL TV(CARD)
C             WRITE(CARD,'(4X,''+/-'',G9.2)') SP(11)
C             CALL TVN(CARD)
C          END IF
C         Diaphragms:
          DO 188 K=12,NPARMS
             IF (P(K).GT.0.) PG(K)=P(K)
  188     CONTINUE
          NFIT=NPARMS-NIX
          WRITE(CARD,'(I5,A)') NFIT,'-parameter fit accepted.'
          CALL TV(CARD)
          OLDVAR=WVAR
C         Release next parameter and try again.
  189     CALL UNFIXP(LORDER(L),NIX)
  190   CONTINUE
C
  191   CONTINUE
C
C       Plot fit:
        CALL SPACE
        CALL NEED(24)
        WRITE (CARD,'(A,I3,A,I4,2A)')
     1    'Fit',NFIT,' parameters to',NN,' dark-sky data in ',BANDS(NB)
        CALL CENTER(CARD)
        CALL TVN('    Sky')
        ZENITH=PG(1)+(PG(2)+PG(3))/(1.+PG(4)+PG(5))
C       Reserve space:
        XLIMS(1)=1.0
        XLIMS(2)=AIRMAX
        YLIMS(1)=0.7*ZENITH
        XM=SQRT(AIRMAX)
        YLIMS(2)=1.4*MAX(ZENITH, PG(1)+((PG(2)+AIRMAX*PG(3))*AIRMAX)/
     1                             (1.+AIRMAX*(PG(4)+AIRMAX*PG(5))),
     2         PG(1)+((PG(2)+XM*PG(3))*XM)/(1.+XM*(PG(4)+XM*PG(5))))
        CALL PLOT(0,XLIMS,YLIMS,'L')
        CALL PLOT(0,0.,0.,'O')
C       Show fitted fcn.:
        DO 194 K=1,40
           XS(1)=1.+(AIRMAX-1.)*.025*K
           YS(1)=PG(1)+((PG(2)+XS(1)*PG(3))*XS(1))/
     1                (1.+XS(1)*(PG(4)+XS(1)*PG(5)))
           CALL PLOT(-1,XS,YS,'+')
  194   CONTINUE
        CALL PLOT(0,0.,1.,'O')
C       Show data:
        DO 195 K=1,NPTS
           IF(KX(1,K).EQ.0) CALL PLOT(-1,X(1,K),Y(K)-PG(11)*X(4,K), '*')
  195   CONTINUE
        CALL PLOT(1,0.,0.,'+')
        CALL RTNCON('   Airmass -->',14)
C
C     Start for MOONLIGHT:
C
C       Rough estimates for large-airmass parameters:
  200   PG(9)=0.35*EXTIN(NB)
        PG(10)=EXP(-EXTIN(NB))
C
C         Fit rough fcn. to lunar aureole:
          K=0
          DO 210 J=1,NPTS
            IF (KX(1,J).EQ.1) THEN
C             Add to new list:
              K=K+1
              XM=X(1,J)+X(2,J)
              ZM=X(1,J)*X(2,J)
              XS(K)=X(3,J)
C                        remove dark-sky component...
              YS(K)=(Y(J) - (PG(1)+((PG(2)+X(1,J)*PG(3))*X(1,J))/
     1                        (1.+X(1,J)*(PG(4)+X(1,J)*PG(5))))
C                     ... remove star halo ...
     2                    - PG(11)*X(4,J)
C                        ...and scale to unit airmass.
     3                  ) * X(3,J)/(X(1,J)*(EXP(-PG(9)*XM)+PG(10)/ZM))
C             partial allowance for photon noise:
              W(J)=EXPTIM(KX(3,J))/(ABS(Y(J))+ZENITH)
            ELSE
C             Keep old wt. for dark sky.
            END IF
  210     CONTINUE
C
        IF (MOONUP.GT.6 .AND. ELONGMAX-ELONGMIN.GT.0.2) THEN
C         Sort on elongation & use bottom of list for aureole:
          CALL SORT2(XS,YS,K)
          DO 211 J=1,K
C            Select points in aureole:
             IF (XS(J).GT.1.) GO TO 212
  211     CONTINUE
C         Whole set is in aureole.  Use 1st half:
          J=NPTS/2
  212     IF (J.EQ.1) THEN
C            No aureole data. Pick something:
             J=3
          END IF
C                      Debugging:
C                      WRITE(CARD,*) J,' points in initial fit.'
C                      CALL TV(card)
C         First J now suitable to estimate PG(6).
          CALL ROBLIN(XS,YS,J, XBAR,YBAR,SLOPE)
          PG(6)=YBAR-XBAR*SLOPE
          PG(7)=SLOPE
          IF (PG(6).LT.0.D0) THEN
C            Aureole not detectable.
             PG(6)=0.D0
             PG(7)=YBAR/XBAR
          END IF
C         Now move down *last* third...
          DO 216 J=1,K/3
             XS(J)=XS(K-K/3+J)
C            ...and divide by elongation.
             YS(J)=YS(K-K/3+J)/XS(J)
  216     CONTINUE
          CALL ROBLIN(XS,YS,K/3, XBAR,YBAR,SLOPE)
          PG(8)=MAX(SLOPE,0.)
        ELSE
C         Not enough data to fit with Moon.
          IF (K.GT.0) THEN
C           Use median Y:
            CALL SORT2(YS,XS,K)
            PG(7)=(YS((K+1)/2)+YS(K/2+1))*0.5
          ELSE
            PG(7)=0.
          END IF
          PG(6)=0.
          PG(8)=0.
        END IF
C
C       PG's now set for moonlight terms.
C
        IF (ELONGMAX-ELONGMIN.LT.2.) THEN
C          Rearrange order of solving:
           IF (ELONGMIN.GT.1.5) THEN
              LORDER(6)=8
              LORDER(8)=10
              LORDER(10)=6
              IF (ELONGMIN.GT.2.) THEN
                 LORDER(7)=9
                 LORDER(9)=7
              END IF
           ELSE IF (ELONGMIN.GT.0.5) THEN
              LORDER(6)=7
              LORDER(7)=6
              IF (ELONGMAX.LT.1.) THEN
                 LORDER(7)=9
                 LORDER(8)=10
                 LORDER(9)=6
                 LORDER(10)=8
              END IF
           ELSE IF (ELONGMAX.LT.1.0) THEN
              LORDER(7)=9
              LORDER(8)=7
              LORDER(9)=10
              LORDER(10)=8
           END IF
        END IF
C
        OLDVAR=3.E33
        NFIT=0
        IF (MOONUP.LT.3) GO TO 241
        DO 240 J=6,10
C          Relax parameters one by one:
           DO 221 K=1,11
              IX(K)=K
  221      CONTINUE
           NIX=11
           IF (NDIAS.GT.0) THEN
C             Fix reference diaphragm:
              K=NREFDIA+11
              CALL FIXP(K,PG(K),NIX)
           END IF
C
C          Release P(11), the star fraction:
           CALL UNFIXP(11,NIX)
C
           CARD='Solving for x moonlight parameters...'
           IF(J.EQ.6) CARD(24:24)=' '
           WRITE(CARD(12:13),'(I2)') J-5
           CALL TV(CARD)
C
C          First, vary ONLY the new parameter.
           CALL UNFIXP(LORDER(J),NIX)
           IF (MOONUP.LT.NPARMS+4-NIX) GO TO 241
C
C     subroutine DLSQ(YP,NPTS,NPARMS,NBLOX,MBLOK,NIX,NARGS,NKARGS,TEST)
           CALL DLSQ(YPSKY,NPTS,NPARMS, 1,NPARMS,NIX, 4,    2,   1.E-3)
C
C          Next, see if result is acceptable:
           IF (WVAR.GT.0.D0) PG(LORDER(J))=P(LORDER(J))
C          Check each case individually:
           IF (P(6).LT.0.D0) CALL FIXP(6,0.,NIX)
           IF (P(8).LT.0.D0) CALL FIXP(8,0.,NIX)
           IF (P(9).LT.0.D0) CALL FIXP(9,0.,NIX)
           IF (P(10).LT.0.D0) CALL FIXP(10,0.,NIX)
           IF (P(9).GT.9.D0 .AND. P(10).EQ.0.D0) CALL FIXP(9,9.,NIX)
           IF (P(9).GT.10.D0) CALL FIXP(9,1.,NIX)
           IF (P(11).LT.0.D0) CALL FIXP(11,0.,NIX)
C
C          Then, vary parameters 6 to J.
           DO 222 K=6,J
              CALL UNFIXP(LORDER(K),NIX)
  222      CONTINUE
           IF (MOONUP.LT.NPARMS+4-NIX) GO TO 241
C
C     subroutine DLSQ(YP,NPTS,NPARMS,NBLOX,MBLOK,NIX,NARGS,NKARGS,TEST)
           CALL DLSQ(YPSKY,NPTS,NPARMS, 1,NPARMS,NIX, 4,    2,   1.E-3)
C
C          Re-extract data for plots:
           YMAX=-3.E33
           YMIN=3.E33
           K=0
           DO 226 L=1,NPTS
             IF (KX(1,L).EQ.1) THEN
C              Add to new list:
               K=K+1
               XS(K)=X(3,L)
               XM=X(1,L)+X(2,L)
               ZM=X(1,L)*X(2,L)
C                         remove dark-sky component...
               YS(K)=(Y(L) - (P(1)+((P(2)+X(1,L)*P(3))*X(1,L))/
     1                         (1.+X(1,L)*(P(4)+X(1,L)*P(5))))
C                ...subtract star halo, and scale to unit airmass.
     2           - PG(11)*X(4,L) ) / (X(1,L)*(EXP(-P(9)*XM) + P(10)/ZM))
               IF(NDIAS.GT.1) YS(K)=YS(K)/P(KX(2,L)+11)
               YMAX=MAX(YMAX,YS(K))
               YMIN=MIN(YMIN,YS(K))
             END IF
  226      CONTINUE
           NN=K
C
C          Skip plotting:
C
           IF (NIX.GT.0) GO TO 231
C
C          Fix up plot limits:
C
           XLIMS(1)=0.1
           XLIMS(2)=ELONGMAX
C          Adjust for possible outliers:
           CALL SORT2(YS,XS,K)
C          (Note reversal of Y and X.)
           YM=(YS((K+1)/2)+YS(K/2+1))*0.5
C          YM is median.
           L=(K+2)/4
           ZM=YS(K-L)-YS(L)
C          ZM is interquartile range.
           YMAX=MIN(YMAX,YM+4.*ZM)
           YMIN=MAX(YMIN,YM-4.*ZM)
           YLIMS(1)=YMIN
           YLIMS(2)=YMAX
C
C          Show result:
           CALL SPACE
           CALL NEED(24)
           WRITE(CARD,'(I5,A,I4,1X,2A)')
     1           NPARMS-NIX,'-parameter fit ( + + + ) to',MOONUP,
     2           BANDS(NB)(:LWORD(BANDS(NB))),' data ( * ) with Moon'
           CALL CENTER(CARD)
           CALL TVN('Normalized Sky')
           CALL PLOT(0,0.,0.,'O')
C          Reserve space:
           CALL PLOT(0,XLIMS,YLIMS,'L')
           IF (YLIMS(1).LT.0.) CALL XAXIS(XLIMS)
C          Plot fit to aureole terms:
           DO 230 K=1,40
              XM=0.1+(.02+.003*K)*K
              YM=(P(6)/XM + P(7) + P(8)*XM)
              CALL PLOT(-1,XM,YM,'+')
  230      CONTINUE
           CALL PLOT(0,0.,1.,'O')
           CALL PLOT(NN,XS,YS,'*')
           CALL RTNCON('     LUNAR ELONGATION (rad.) -->',32)
C
C          Give up if solution failed:
  231      IF (WVAR.EQ.0.D0 .OR. WVAR.GT.1.2*OLDVAR) GO TO 240
C          Tests for plausibility:
           IF (P(6).LT.0.D0 .OR. P(8).LT.0.D0 .OR.
     1         P(9).LT.0.D0 .OR. P(10).LT.0.D0 .OR.
     2        (P(9).GT.10.D0 .AND. P(10).EQ.0.D0) .OR.
     3       (P(11).GT.0.01D0 .OR. P(11).LT.0.D0) ) GO TO 240
C
C          Result accepted.
C
C          Revise weights:
           DO 235 K=1,NPTS
C             partial allowance for photon noise:
              IF(KX(1,K).EQ.1) W(K)=EXPTIM(KX(3,K))/(ABS(Y(K))+ZENITH)
  235      CONTINUE
C          Update parameters:
           DO 237 K=6,10
             PG(K)=P(K)
             ERRSAVE(K)=SP(K)
C             WRITE(CARD,'(''P('',I2,'') ='',G9.2)') K,P(K)
C             CALL TV(CARD)
C             WRITE(CARD,'(4X,''+/-'',G9.2)') SP(K)
C             CALL TVN(CARD)
  237      CONTINUE
C          Wings of star image:
           IF (P(11).GT.0.D0) PG(11)=P(11)
           IF (SP(11).GT.0.) THEN
C             WRITE(CARD,'(''P(11) ='',G9.2)') P(11)
C             CALL TV(CARD)
C             WRITE(CARD,'(4X,''+/-'',G9.2)') SP(11)
C             CALL TVN(CARD)
           END IF
C         Diaphragms:
          DO 238 K=12,NPARMS
             IF (P(K).GT.0.) PG(K)=P(K)
  238     CONTINUE
C
           NFIT=NPARMS-NIX
           WRITE(CARD,'(I5,A)') NFIT,'-parameter fit accepted.'
           CALL TV(CARD)
           OLDVAR=WVAR
C
  240   CONTINUE
C
C       Re-extract data for final plot:
  241   YMAX=-3.E33
        YMIN=3.E33
        K=0
        DO 244 L=1,NPTS
          IF (KX(1,L).EQ.1) THEN
C           Add to new list:
            K=K+1
            XS(K)=X(3,L)
            XM=X(1,L)+X(2,L)
            ZM=X(1,L)*X(2,L)
C                      remove dark-sky component...
            YS(K)=(Y(L) - (PG(1)+((PG(2)+X(1,L)*PG(3))*X(1,L))/
     1                       (1.+X(1,L)*(PG(4)+X(1,L)*PG(5))))
C           ...subtract star halo, and scale to unit airmass.
     2         - PG(11)*X(4,L) ) / (X(1,L)*(EXP(-PG(9)*XM) + PG(10)/ZM))
            YMAX=MAX(YMAX,YS(K))
            YMIN=MIN(YMIN,YS(K))
          END IF
  244   CONTINUE
C
C       Fix up plot limits:
        XLIMS(1)=ELONGMIN
        XLIMS(2)=ELONGMAX
        IF (K.EQ.0) GO TO 300
C       Adjust for possible outliers:
        CALL SORT2(YS,XS,K)
C       (Note reversal of Y and X.)
        YM=(YS((K+1)/2)+YS(K/2+1))*0.5
C       YM is median.
        L=(K+2)/4
        ZM=YS(K-L)-YS(L)
C       ZM is interquartile range.
        YMAX=MIN(YMAX,YM+3.*ZM)
        YMIN=MAX(YMIN,YM-3.*ZM)
        IF (YMAX.EQ.YMIN) GO TO 300
        YLIMS(1)=YMIN
        YLIMS(2)=YMAX
C
C       Show result:
        CALL SPACE
        CALL NEED(24)
        WRITE(CARD,'(I5,A,I4,1X,2A)')
     1           NFIT,'-parameter fit ( + + + ) to',MOONUP,
     2           BANDS(NB)(:LWORD(BANDS(NB))),' data ( * ) with Moon'
        CALL CENTER(CARD)
        CALL TVN('Normalized Sky')
        CALL PLOT(0,0.,0.,'O')
C       Reserve space:
        CALL PLOT(0,XLIMS,YLIMS,'L')
        IF (YLIMS(1).LT.0.) CALL XAXIS(XLIMS)
C       Plot fit to aureole terms:
        DO 250 K=1,40
           XM=ELONGMIN+(ELONGMAX-ELONGMIN)*(.02+.003*K)*K
           YM=(PG(6)/XM + PG(7) + PG(8)*XM)
           CALL PLOT(-1,XM,YM,'+')
  250   CONTINUE
        CALL PLOT(0,0.,1.,'O')
        CALL PLOT(NN,XS,YS,'*')
        CALL RTNCON('     LUNAR ELONGATION (rad.) -->',32)
C
  300   CONTINUE
C
C
C   Now display fitted equation:
C
        DO 310 J=1,10
          SP(J)=ERRSAVE(J)
  310   CONTINUE
        CALL SKYEQN(PG,SP,CARD)
C
C
C   Don't forget diaphragm scaling:
C
        IF (NPARMS.GT.11) THEN
          CALL SPACE
          CALL TV('Diaphragm scaling:')
        END IF
        DO 320 J=12,NPARMS
          WRITE(CARD,'(A,F7.3,'' +/-'',F7.3)') DIANAM(J-11),P(J),SP(J)
          CALL TV(CARD)
  320   CONTINUE
C
C
C   Now display overall fit:
C
C       Hold all fixed; evaluate YC's:
        DO 355 K=1,NPARMS
           IX(K)=K
  355   CONTINUE
        NIX=NPARMS
C
C     subroutine DLSQ(YP,NPTS,NPARMS,NBLOX,MBLOK,NIX,NARGS,NKARGS,TEST)
           CALL DLSQ(YPSKY,NPTS,NPARMS, 1, NPARMS,NIX, 4,    2,   1.E-1)
C
        CALL SPACE
        CALL NEED(24)
        CARD='Measured vs. model ( + + ) sky brightness in '//BANDS(NB)
        CARD(LWORD(CARD)+1:)=':'
        CALL CENTER(CARD)
        CALL TVN('Observed sky')
        XLIMS(1)=3.E33
        YLIMS(1)=0.
        YLIMS(2)=0.
        K=0
        DO 360 J=1,NPTS
C          omit twilight.
           IF (KX(1,J).LT.0) GO TO 360
           K=K+1
           XS(K)=YC(J)
           YS(K)=Y(J)
           XLIMS(1)=MIN(XLIMS(1),XS(K))
           IF (KX(1,J).EQ.0) THEN
             SYMB(K)='*'
           ELSE IF (KX(1,J).EQ.1) THEN
             SYMB(K)='M'
C          ELSE IF (KX(1,J).EQ.-1) THEN
C            SYMB(K)='t'
           ELSE
             SYMB(K)='?'
           END IF
  360   CONTINUE
        CALL SORT2(XS,YS,K)
        IF (XS(K).LT.2.*XS(K-1)) THEN
          XLIMS(2)=XS(K)
        ELSE
          XLIMS(2)=XS(K-1)
        END IF
        YLIMS(1)=0.8*XLIMS(1)
        YLIMS(2)=1.2*XLIMS(2)
        CALL PLOT(0,XLIMS,YLIMS,'L')
C       Draw unit diagonal:
        DO 370 J=1,20
           XM=J*XLIMS(2)/20.
           CALL PLOT(-1,XM,XM,'+')
  370   CONTINUE
        CALL PLOT(0,0.,0.,'D')
        CALL PLOT(K,XS,YS,SYMB)
        CALL RTNCON('     Calculated sky -->',23)
C
C       Plot star halo resids.:
C
        CALL SPACE
        CALL NEED(24)
        CARD='Residuals vs. Star signal in '//BANDS(NB)
        CARD(LWORD(CARD)+1:)=':'
        CALL CENTER(CARD)
        CALL TVN('  Residual')
        XLIMS(1)=0.
        YLIMS(1)=0.
        YLIMS(1)=0.
        YLIMS(2)=0.
        K=0
        DO 380 J=1,NPTS
           IF (KX(1,J).LT.0) GO TO 380
           K=K+1
           XS(K)=X(4,J)
           YS(K)=Y(J)-YC(J)
           XLIMS(2)=MAX(XLIMS(2),XS(K))
           YLIMS(1)=MIN(YLIMS(1),YS(K))
           YLIMS(2)=MAX(YLIMS(2),YS(K))
  380   CONTINUE
        CALL PLOT(0,XLIMS,YLIMS,'L')
        CALL XAXIS(XLIMS)
        CALL PLOT(K,XS,YS,SYMB)
        CALL PLOT(0,0.,0.,'S')
        CARD='   Star signal -->      (Sky is 0.xxxx of Star)'
        WRITE (CARD(32:38),'(F7.4)') PG(11)
        CALL RTNCON(CARD,49)
C
C       Plot resids. vs. time:
C
        CALL SPACE
        CALL NEED(24)
        CARD='O/C Ratio vs. Time in '//BANDS(NB)
        CARD(LWORD(CARD)+1:)=':'
        CALL CENTER(CARD)
        CALL TVN('   Ratio')
        XLIMS(1)=DJOBS(JDUSK)
        XLIMS(2)=DJOBS(JDAWN)
        YLIMS(1)=0.6
        YLIMS(2)=1.5
        CALL PLOT(0,XLIMS,YLIMS,'L')
C       Draw "axis" at 1.0:
        DO 388 J=1,80
           XM=XLIMS(1)+(XLIMS(2)-XLIMS(1))*J/80.
           CALL PLOT(-1,XM,1.,'-')
  388   CONTINUE
        DO 390 J=1,NPTS
           IF (KX(1,J).LT.0) GO TO 390
           IF (YC(J).EQ.0.D0) YC(J)=1.E-6
           CALL PLOT(-1,DJOBS(KX(3,J)),Y(J)/REAL(YC(J)),SYMB(J))
  390   CONTINUE
C       force plot:
        CALL PLOT(1,10.,0.,'+')
        WRITE(CARD,'(A,F7.0)')'    TIME (MJD =',DTZERO(NIGHT)
        CARD(LWORD(CARD):)=' + decimal of day) -->'
        CALL RTNCON(CARD,LWORD(CARD))
C
C
C    List outliers:
C
        CALL SPACE2
        CALL NEED(10)
        CARD='Sky anomalies in '//BANDS(NB)
        WRITE(CARD(LWORD(CARD)+2:),'(''on MJD'',F7.0)')
     1       DTZERO(NIGHT)+INT(DJOBS((JBGN+JEND)/2))
        CALL TV(CARD)
        CARD='DECIMAL    SKY      LUNAR     LUNAR    STELLAR'
        CARD(52:)='SKY       SKY       O/C'
        CALL TV(CARD)
        CARD='  DAY    AIRMASS   AIRMASS  ELONGATION  SIGNAL  OBSERVED'
        CARD(59:)='CALCULATED  RATIO'
        CALL TVN(CARD)
        WRITE(CARD,'(''------'',7(3X,''-------''))')
        CALL TVN(CARD)
        NN=0
        DO 450 J=1,NPTS
          IF (KX(1,J).GE.0 .AND.
     1        W(J)*(Y(J)-REAL(YC(J)))**2 .GT. SCALE*36.) THEN
            WRITE(CARD,'(F6.4,F9.3,2F10.3,1PE12.2,0P2F10.3,F8.3)')
     1           DJOBS(KX(3,J)),(X(K,J),K=1,4),Y(J),YC(J),Y(J)/YC(J)
            IF (KX(1,J).NE.1) THEN
               CARD(20:35)='   -         -'
            END IF
            CALL TVN(CARD)
            NN=NN+1
          END IF
  450   CONTINUE
        IF (NN.EQ.0) THEN
           CALL TV('   (none)')
        ELSE
           WRITE(CARD,'(I3,'' anomalous sky data'')') NN
           IF (NN.EQ.1) CARD(22:23)='um'
           CALL TV(CARD)
        END IF
C
C
C    Ask for approval:
C
  500   CARD=
     1    'Do you want to subtract the fitted model from stellar data?'
        CALL ASK(CARD,A1)
        IF (A1.EQ.'Y' .OR. A1.EQ.'O') THEN
C         Go on.
        ELSE IF (A1.EQ.'N') THEN
C         Take short-cut to 110.
          SHORT=.TRUE.
          GO TO 3
        ELSE IF (A1.EQ.'R') THEN
          GO TO 2
        ELSE IF (A1.EQ.'H') THEN
          IF (NPTS.GT.20*NN .AND. SCALE.LT.0.1*ZENITH) THEN
C            Clearly a good fit.
             CALL TV('     YES, that''s a good fit.')
          ELSE IF (NPTS.LT.10*NN .OR. SCALE.GT.0.2*ZENITH) THEN
C            Clearly a bad fit.
             CALL TV('     NO, that''s a POOR fit.')
          ELSE
C            Not clear.
             CALL SPACE
             WRITE(CARD,'(I5,''% rejects; typical residual is'',F5.2)')
     1              (NN*100+NPTS/2)/NPTS,SCALE/ZENITH
             CARD(LWORD(CARD)+2:)='of zenith brightness.'
             CALL TV(CARD)
             CALL TV('Hard to say.  You may want to try it both ways,')
             CALL TVN('and compare the results.')
          END IF
          GO TO 500
        ELSE
          CALL SPACE2
          CALL TV('Enter either YES or NO, or')
          CALL TVN('H for Help, or R to Re-display plots.')
          GO TO 500
        END IF
C
C
C     Now subtract sky fit from data:
C
C    JBGN, JEND index the first and last data of ANY kind for the night.
C    JMIN, JMAX index the first and last SKY data for the night & band.
C
C
        IF (NTWI.GT.0) THEN
          CALL TV('Using nearest-neighbor subtraction in twilight...')
          CALL SKYNBR(NB,DTYPE,KDIAPHRAGM,JBGN,JDUSK)
          CALL SKYNBR(NB,DTYPE,KDIAPHRAGM,JDAWN,JEND)
        END IF
C
C       Subtract fitted fcn. from rest:
        CALL TV('Using fitted model...')
        DO 600 J=JDUSK,JDAWN
           IF (NB.NE.KBND(J)) GO TO 600
           Z(1)=AIRM(J)
           IF ( (RISE.LT.SET  .AND.
     1               DJOBS(J).GT.RISE .AND. DJOBS(J).LT.SET) .OR.
     2               (RISE .GT.SET  .AND.
     3               (DJOBS(J).GT.RISE .OR. DJOBS(J).LT.SET) )  ) THEN
C               Moon is up.
                KZ(1)=1
                T=(DTZERO(NIGHT)-51544.5D0+DJOBS(J))/36525.
                UTRAD=MOD(DJOBS(J),1.)*TWOPI
                TLST=STUTZ+(UTRAD*1.00273791)+ELONG
C               MOON uses T for lunar position, TLST for topocentric ephemeris.
                CALL MOON(T, TLST)
C               MOON returns lunar coords. in RASUN, DESUN in /CSUN/.
                HAMOON=TLST-RASUN
                COSDEL=COS(DESUN)
                SINDEL=SIN(DESUN)
                COSHA=COS(HAMOON)
                XM= -COSDEL*SIN(HAMOON)
                YM=COSPHI*SINDEL-SINPHI*COSDEL*COSHA
                ZM=SINPHI*SINDEL+COSPHI*COSDEL*COSHA
                IF (ZM.GT.0.) THEN
C                  Set Z(2) to LUNAR airmass.
                   Z(2)=1./ZM
                ELSE
C                  Moon below horizon.
                   Z(2)=100.
                END IF
                AZMOON=ATAN2(YM,XM)
                DELAZ=AZMOON-AZIM(J)
C               approximate cosz(sky) as 1/airmass.
                COSEL=ZM/AIRM(J) +
     1               SQRT((1.-ZM*ZM)*(1.-1./AIRM(J)**2))*COS(DELAZ)
C               Set Z(3) to lunar elongation.
                Z(3)=ACOS(COSEL)
           ELSE
C               Moon is down.
                KZ(1)=0
                Z(2)=0.
           END IF
C
           IF (DTYPE(J).EQ.'S') THEN
C             Star.
              Z(4)=SIGNAL(J)
           ELSE IF (DTYPE(J).EQ.'Y') THEN
C             Sky.
              CALL HALO(NB,DTYPE,KDIAPHRAGM,J,JBGN,JEND, Z(4))
           ELSE
C             Dark, etc.
              GO TO 600
           END IF
C
C          Put NDIA in KZ(2):
           DO 580 NDIA=1,NDIAS
              IF (DIAPH(J).EQ.DIANAM(NDIA)) THEN
                 KZ(2)=NDIA
                 GO TO 581
              END IF
  580      CONTINUE
           KZ(2)=0
  581      CONTINUE
C
C          Z's and KZ(1) are now set for YPSKY:
           CALL YPSKY
C          Sky brightness now returned in YT.
           SIGNAL(J)=SIGNAL(J)-YT
  600   CONTINUE
C
C
C       Prepare for next night:
C
  999   JBGN=JEND+1
C
 1000 CONTINUE
C               END of loops over bands and nights.
C
      RETURN
      END
      SUBROUTINE YPSKY
C
C   Fits  Y = [Y1 + Y2 + Y3 + P(1)] * P(diaphragm),  where
C
C
C                                 2
C            P(2)*Z(1) + P(3)*Z(1)
C   Y1 = ---------------------------   is the sky background, and
C                                 2
C        1 + P(4)*Z(1) + P(5)*Z(1)
C
C
C
C   Y2 = Z(1) * [P(6)/Z(3) + P(7) + P(8)*Z(3)] * {exp[-P(9)*v1] + P(10)/v3}
C
C                                      is the scattered moonlight.
C
C
C   Y3 = Z(4) * P(11)       is the part of the star included in sky measures.
C
C
C
C     P(1) is a possible zero-offset, if dark was not subtracted.
C
C
C     Independent variables:
C     ---------------------
C
C     Z(1) = observed airmass           v1 = Z(1) + Z(2) = sum of airmasses
C
C     Z(2) = lunar airmass              v3 = Z(1)*Z(2) = product of airmasses
C
C     Z(3) = lunar elongation
C
C     Z(4) = nearest star signal, or zero if none found.
C
C
C     KZ(1) = Moon flag (1 if Moon up)
C
C     KZ(2) = diaphragm number (KDIA)
C
C
C
C
      IMPLICIT NONE
C
C     Includes for dlsq:
      INCLUDE 'MID_REL_INCL:kingfit.inc'
      INCLUDE 'MID_REL_INCL:dlsq.inc'
C
      DOUBLE PRECISION DEN,  V1, V3, FIRST, SECOND, FZ1, EXPFAC, Y2
C
      INTEGER I, KDIA
C
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C
C
      IF (KZ(1).LT.0) THEN
C        Twilight:  Not in model.
         KIP=0
         YT=0.
         RETURN
      END IF
C
C
C                                 2
C            P(2)*Z(1) + P(3)*Z(1)
C   Y1 = ---------------------------   is the sky background...
C                                 2
C        1 + P(4)*Z(1) + P(5)*Z(1)
C
C
      KIP=6
      IP(1)=1
      IP(2)=2
      IP(3)=3
      IP(4)=4
      IP(5)=5
      IP(6)=11
C
      DEN = 1.D0 + (P(4) + P(5)*Z(1))*Z(1)
      YT = (P(2) + P(3)*Z(1))*Z(1)/DEN
C
      PART(1)=1.D0
      PART(2)=Z(1)/DEN
      PART(3)=Z(1)*PART(2)
      PART(4)= -YT*PART(2)
      PART(5)= -YT*PART(3)
      PART(11)=Z(4)
C
      YT = YT + P(1) + P(11)*Z(4)
C
      IF (KZ(1).EQ.0) THEN
C        Don't need moonlight, so finish up:
         IF (KZ(2).GT.0) THEN
C           Scale old partials by diaphragm factor...
            KDIA=KZ(2)+11
            DO 30 I=1,KIP
               PART(IP(I))=PART(IP(I))*P(KDIA)
   30       CONTINUE
C           Scale by diaphragm factor, and add to KIP:
            KIP=7
            IP(7)=KDIA
            PART(KDIA)=YT
            YT=P(KDIA)*YT
         END IF
         RETURN
      END IF
C
C
C     Here if we need to add moonlight:
C
C
C   Y2 = Z(1) * [P(6)/Z(3) + P(7) + P(8)*Z(3)] * {exp[-P(9)*v1] + P(10)/v3}
C
C                                      is the scattered moonlight.
C
      KIP=11
      IP(7)=6
      IP(8)=7
      IP(9)=8
      IP(10)=9
      IP(11)=10
C
      V1=Z(1)+Z(2)
      V3=Z(1)*Z(2)
C
      FIRST=P(6)/Z(3) + P(7) + P(8)*Z(3)
      FZ1=FIRST*Z(1)
      IF (-P(9)*V1.GT.30.D0) THEN
C        try to prevent floating-point exceptions.
         EXPFAC=EXP(30.D0)
      ELSE
         EXPFAC=EXP(-P(9)*V1)
      END IF
      SECOND=EXPFAC + P(10)/V3
C
      Y2 = FZ1*SECOND
C
      PART(7)=SECOND*Z(1)
      PART(6)=PART(7)/Z(3)
      PART(8)=Z(3)*PART(7)
      PART(9)= -V1*EXPFAC*FZ1
      PART(10)=FZ1/V3
C
      YT = YT + Y2
C
C        Diaphragm scaling:
         IF (KZ(2).GT.0) THEN
C           Scale old partials by diaphragm factor...
            KDIA=KZ(2)+11
            DO 50 I=1,KIP
               PART(IP(I))=PART(IP(I))*P(KDIA)
   50       CONTINUE
C           Scale by diaphragm factor, and add to KIP:
            KIP=12
            IP(12)=KDIA
            PART(KDIA)=YT
            YT=P(KDIA)*YT
         END IF
C
      RETURN
      END
      SUBROUTINE SKYADJ(NB,DTYPE,KDIAPHRAGM,JBGN,JEND,NERROR)
C
C       Picks an ADJACENT sky sample, and subtracts it from star.
C
C
      IMPLICIT NONE
C
      REAL SKY, PHNOISE, ERREST
      INTEGER NB, KDIAPHRAGM, JBGN, JEND, NERROR, J3, J,
     1         LWORD, JJ
C
      INCLUDE 'MID_REL_INCL:obs.inc'
C
      INCLUDE 'MID_REL_INCL:mstars.inc'
C     PARAMETER (MSTARS=1650)
C       MSTARS is max.number of star-catalog entries.
C       commons for star catalog:
      CHARACTER *32 STARS
      COMMON /SCATA/ STARS(MSTARS)
C
      CHARACTER DTYPE(MXOBS)
C
      CHARACTER A, CARD*48, PRECEDED*8, FOLLOWING*9, DSKY*4
C
C
      SKY=-3.E33
      DSKY=' '
      NERROR=0
C
C     Decide which way to scan:
C
      IF (JBGN.LT.JEND) THEN
          J3=1
          PRECEDED='preceded'
          FOLLOWING='FOLLOWING'
      ELSE
          J3=-1
          PRECEDED='followed'
          FOLLOWING='PRECEDING'
      END IF
C
      DO 134 J=JBGN,JEND,J3
C
         IF (KBND(J).NE.NB .OR. NSTR(J).LT.0) GO TO 134
C        here if bands match.
         IF (DTYPE(J).EQ.'Y') THEN
C           this is sky; reset it.
            SKY=SIGNAL(J)
            PHNOISE=PHVAR(J)
            ERREST=ESTER(J)
            IF (KDIAPHRAGM.NE.-1) THEN
C              flag sky diaphragm code; expect star to match.
               DSKY=DIAPH(J)
            END IF
         ELSE
C           this is star; subtract sky.
C
            IF (SKY.EQ.-3.E33) THEN
C              ERROR: no previous sky!
               CALL SPACE2
               CARD=STARS(NSTR(J))
               CARD(LWORD(CARD)+2:LWORD(CARD)+6)='at'
               WRITE(CARD(LWORD(CARD)+2:),'(F7.4)')DJOBS(J)
               CALL TV(CARD)
               CARD='!! Star not '//PRECEDED//' by sky !!'
               CALL TVN(CARD)
               CARD='Do you want to use the '//FOLLOWING//' sky?'
               CALL ASK(CARD,A)
C
               IF (A.EQ.'Y' .OR. A.EQ.'O')THEN
C                 look for following sky:
                  DO 132 JJ=J+J3,JEND,J3
                     IF (KBND(JJ).NE.NB .OR.
     1                   NSTR(JJ).LT.0) GO TO 132
                     IF(DTYPE(JJ).EQ.'Y') THEN
                        IF(KDIAPHRAGM.NE.-1 .AND.
     1                    DIAPH(JJ).NE.DIAPH(J)) GOTO 132
C                       fix this one, but do not set SKY.
                        SIGNAL(J)=SIGNAL(J)-SIGNAL(JJ)
C                       accumulate photon variances.
                        PHVAR(J)=PHVAR(J)+PHVAR(JJ)
                        IF (ESTER(J).NE.0.)
     1                      ESTER(J)=SQRT(ESTER(J)**2 + ESTER(JJ)**2)
                        GO TO 134
                     END IF
  132             CONTINUE
                  CALL TV('No sky found! Quitting.')
                  CALL STSEPI
               ELSE
                  GO TO 999
               END IF
C
            ELSE
C              probably normal case.  Check DIAPH:
               IF (KDIAPHRAGM.NE.-1 .AND.
     1                DIAPH(J).NE.DSKY) THEN
                  CALL SPACE2
                  CARD=STARS(NSTR(J))
                  CARD(LWORD(CARD)+2:LWORD(CARD)+6)='at'
                  WRITE(CARD(LWORD(CARD)+2:),
     1                '(F7.4)')DJOBS(J)
                  CALL TV(CARD)
                  CALL TV(
     1              'Sky and Star taken through DIFFERENT diaphragms.')
                  CALL TVN('Sky subtraction impossible.')
                  GO TO 999
               END IF
C              NORMAL case. Subtract sky:
               SIGNAL(J)=SIGNAL(J)-SKY
               PHVAR(J)=PHVAR(J)+PHNOISE
               IF(ESTER(J).NE.0.) ESTER(J)=SQRT(ESTER(J)**2 + ERREST**2)
            END IF
C
         END IF
C
  134 CONTINUE
C
C       Normal return.
C
      RETURN
C
C
C       error return:
C
  999 CALL ASK('Do you want to try another sky-subtraction method?',A)
      IF (A.EQ.'Y' .OR. A.EQ.'O') THEN
          NERROR=1
          RETURN
      ELSE IF (A.EQ.'H') THEN
                   CALL TV('The photometric system changes with')
                   CALL TVN('diaphragm size, so you cannot combine')
                   CALL TVN('data taken through different holes.')
                   CALL RTNCON('Try the "Nearest" option.',25)
                   NERROR=1
                   RETURN
      ELSE
          CALL TV('Quitting.')
          CALL STSEPI
      END IF
C
      END
      SUBROUTINE HALO(NB,DTYPE,KDIAPHRAGM,J,JBGN,JEND, SKYUSE)
C
C       Picks the NEAREST STAR sample to sky(J), and returns it in SKYUSE.
C
C  Arguments:
C
C	NB	is band number
C	DTYPE   is 'Y' for sky, 'S' for star
C	KDIAPHRAGM is column pointer for diaphragm data
C	JBGN	is observation number for start of night
C	JEND	is observation number for end of night
C
C
      IMPLICIT NONE
C
C
      INTEGER NB, KDIAPHRAGM, JBGN, JEND
C
      INCLUDE 'MID_REL_INCL:obs.inc'
C
      CHARACTER DTYPE(MXOBS)
C
C
C
      REAL SKY, SKY2, SKYAIR, SKYAZ, SKYTIM,   PI,TWOPI,
     1   SKYAIR2, SKYAZ2, SKYTIM2, S1, S2, SKYUSE
C
      INTEGER J, JJ
C
C   Meaning of local variables:
C
C		Previous	Following
C		--------	---------
C     Star        SKY		  SKY2
C     Airmass	SKYAIR		SKYAIR2
C     Azimuth	SKYAZ		SKYAZ2
C     Time	SKYTIM		SKYTIM2
C     Diaphragm  DSKY		 DSKY2
C
C
      INCLUDE 'MID_REL_INCL:mstars.inc'
C     PARAMETER (MSTARS=1650)
C       MSTARS is max.number of star-catalog entries.
C       commons for star catalog:
      CHARACTER *32 STARS
      COMMON /SCATA/ STARS(MSTARS)
C
      CHARACTER DSKY*4, DSKY2*4
C
      DATA PI/3.1415926535/
C
C
C     *****  BEGIN  *****
C
      TWOPI=PI+PI
      SKY=-3.E33
      SKY2=-3.E33
      DSKY=' '
      DSKY2=' '
      SKYAIR2 = 0.0
      SKYAZ2  = 0.0
      SKYTIM2 = 0.0
C
C     J is current sky datum in band NB.
C
      IF (DTYPE(J).EQ.'Y') THEN
C        this is sky.
         IF (KDIAPHRAGM.NE.-1) THEN
C            save new diaphragm.
             DSKY=DIAPH(J)
         ELSE
C            no diaphragm info.
         END IF
      ELSE
         CALL TV('Called HALO with non-sky datum.')
         RETURN
      END IF
C
C     This is sky; look for PREVIOUS star.
   20       IF (SKY.LT.0.) THEN
C                No previous star.  Find one.
                 DO 28 JJ=J-1,JBGN,-1
                     IF (KBND(JJ).NE.NB .OR. NSTR(JJ).LT.0) GO TO 28
                     IF(DTYPE(JJ).EQ.'S') THEN
                        IF(KDIAPHRAGM.NE.-1 .AND.
     1                    DIAPH(JJ).NE.DIAPH(J)) GOTO 28
C                       OK; JJ is the previous star we seek.
                        DSKY=DIAPH(JJ)
                        SKY=SIGNAL(JJ)
                        SKYAIR=AIRM(JJ)
                        SKYAZ=AZIM(JJ)
                        SKYTIM=DJOBS(JJ)
                        GO TO 40
                     END IF
   28            CONTINUE
C                No previous star.
                 SKY=-3.E33
                 DSKY=' '
            ELSE
C               probably normal case.  Check DIAPH:
                IF (KDIAPHRAGM.NE.-1 .AND. DIAPH(J).NE.DSKY) THEN
C                  Mismatch; force search for previous star.
                   SKY=-3.E33
                   GO TO 20
                ELSE
C                  NORMAL case. Existing star OK.
                END IF
            END IF
C
C        SKY is now valid previous value. Look for FOLLOWING value:
C
   40   IF (SKY2.LT.0.) THEN
C           Look for next star.
            DO 48 JJ=J+1,JEND
                  IF (KBND(JJ).NE.NB .OR. NSTR(JJ).LT.0) GO TO 48
                  IF(DTYPE(JJ).EQ.'S') THEN
                        IF(KDIAPHRAGM.NE.-1 .AND.
     1                    DIAPH(JJ).NE.DIAPH(J)) GOTO 48
C                       OK; JJ is the following star we seek.
                        DSKY2=DIAPH(JJ)
                        SKY2=SIGNAL(JJ)
                        SKYAIR2=AIRM(JJ)
                        SKYAZ2=AZIM(JJ)
                        SKYTIM2=DJOBS(JJ)
                        GO TO 60
                  END IF
   48       CONTINUE
C           No following star.
            SKY2=-3.E33
            DSKY2=' '
        ELSE
C           existing sky2 might still be OK. Check it:
            IF (SKYTIM2.GT.DJOBS(J)) THEN
C               Time is OK.  Check diaphragm:
                IF (KDIAPHRAGM.NE.-1) THEN
                    IF (DIAPH(J).EQ.DSKY2) THEN
C                       we are OK; go on.
                    ELSE
C                       need a new SKY2.
                        SKY2=-3.E33
                        GO TO 40
                    END IF
                ELSE
C                   No problem.  Go on.
                END IF
            ELSE
C               We are past the old second star.  Move it back & get new one:
                SKY=SKY2
                DSKY=DSKY2
                SKYAIR=SKYAIR2
                SKYAZ=SKYAZ2
                SKYTIM=SKYTIM2
                SKY2=-3.E33
                GO TO 40
            END IF
        END IF
C
C       Now compare to find "nearer" star:
C
   60   IF (SKY.GT.0. .AND. SKY2.GT.0.) THEN
C           Everything is hunky-dory.  Find closer sample:
            S1=ABS(SKYTIM-DJOBS(J))*20. + ABS(SKYAIR-AIRM(J))
            IF (ABS(SKYAZ-AZIM(J)).GT.PI) THEN
               S1=S1+ (SKYAIR+AIRM(J))*(TWOPI-ABS(SKYAZ-AZIM(J)))
            ELSE
               S1=S1+ (SKYAIR+AIRM(J))*ABS(SKYAZ-AZIM(J))
            END IF
            S2=ABS(SKYTIM2-DJOBS(J))*20. + ABS(SKYAIR2-AIRM(J))
            IF (ABS(SKYAZ2-AZIM(J)).GT.PI) THEN
               S2=S2+ (SKYAIR2+AIRM(J))*(TWOPI-ABS(SKYAZ2-AZIM(J)))
            ELSE
               S2=S2+ (SKYAIR2+AIRM(J))*ABS(SKYAZ2-AZIM(J))
            END IF
C
            IF (S2.LT.S1) THEN
                SKYUSE=SKY2
                IF (S2.GT.0.1) THEN
C                  complain.
C                  CALL SKYFAR()
                END IF
            ELSE
                SKYUSE=SKY
                IF (S1.GT.0.1) THEN
C                  complain.
                END IF
            END IF
        ELSE IF (SKY.GT.0.) THEN
C           SKY is the only good one.  Use it.
            SKYUSE=SKY
        ELSE IF (SKY2.GT.0.) THEN
C           SKY2 is the only good one.  Use it.
            SKYUSE=SKY2
        ELSE
C           NEITHER star is any good.
C           set value to zero and return:
            SKYUSE=0.
            RETURN
        END IF
C
C       OK, we have now rigged SKYUSE to be the value to use.  Report it.
C
C
C       Normal return.
C
      RETURN
C
      END
      SUBROUTINE SKYNBR(NB,DTYPE,KDIAPHRAGM,JBGN,JEND)
C
C       Picks the NEAREST sky sample, and subtracts it from star.
C
C  Arguments:
C
C	NB	is band number
C	DTYPE   is 'Y' for sky
C	KDIAPHRAGM is column pointer for diaphragm data
C	JBGN	is observation number for start of night
C	JEND	is observation number for end of night
C
C
      IMPLICIT NONE
C
C
      INTEGER NB, KDIAPHRAGM, JBGN, JEND
C
      INCLUDE 'MID_REL_INCL:obs.inc'
C
      CHARACTER DTYPE(MXOBS)
C
C
C
      REAL SKY, SKY2, SKYAIR, SKYAZ, SKYTIM,   PI,TWOPI,
     1   PHNOISE, ERREST, SKYAIR2, SKYAZ2, SKYTIM2, 
     2         PHN2, ERR2, S1, S2, SKYUSE, PHNUSE, ERRUSE
C
      INTEGER J, JJ
C
C   Meaning of local variables:
C
C		Previous	Following
C		--------	---------
C     Sky         SKY		  SKY2
C     Airmass	SKYAIR		SKYAIR2
C     Azimuth	SKYAZ		SKYAZ2
C     Time	SKYTIM		SKYTIM2
C     Phot.noisePHNOISE		 PHN2
C     Est.error ERREST		 ERR2
C     Diaphragm  DSKY		 DSKY2
C
C
      INCLUDE 'MID_REL_INCL:mstars.inc'
C     PARAMETER (MSTARS=1650)
C       MSTARS is max.number of star-catalog entries.
C       commons for star catalog:
      CHARACTER *32 STARS
      COMMON /SCATA/ STARS(MSTARS)
C
      CHARACTER CARD*48, DSKY*4, DSKY2*4
C
      DATA PI/3.1415926535/
C
C
      TWOPI=PI+PI
      SKY=-3.E33
      SKY2=-3.E33
      DSKY=' '
      DSKY2=' '
C
      DO 100 J=JBGN,JEND
C
         IF (KBND(J).NE.NB .OR. NSTR(J).LT.0) GO TO 100
C        here if bands match.
C
         IF (DTYPE(J).EQ.'Y') THEN
C           this is sky.
            IF (KDIAPHRAGM.NE.-1) THEN
C               save new diaphragm.
                DSKY=DIAPH(J)
            ELSE
C               no diaphragm info.
            END IF
            SKY=SIGNAL(J)
            SKYAIR=AIRM(J)
            SKYAZ=AZIM(J)
            SKYTIM=DJOBS(J)
            PHNOISE=PHVAR(J)
            ERREST=ESTER(J)
            GO TO 100
         ELSE
C           this is star; look for PREVIOUS sky.
   20       IF (SKY.LT.0.) THEN
C                No previous sky.  Find one.
                 DO 28 JJ=J-1,JBGN,-1
                     IF (KBND(JJ).NE.NB .OR. NSTR(JJ).LT.0) GO TO 28
                     IF(DTYPE(JJ).EQ.'Y') THEN
                        IF(KDIAPHRAGM.NE.-1 .AND.
     1                    DIAPH(JJ).NE.DIAPH(J)) GOTO 28
C                       OK; JJ is the previous sky we seek.
                        DSKY=DIAPH(JJ)
                        SKY=SIGNAL(JJ)
                        SKYAIR=AIRM(JJ)
                        SKYAZ=AZIM(JJ)
                        SKYTIM=DJOBS(JJ)
                        PHNOISE=PHVAR(J)
                        ERREST=ESTER(J)
                        GO TO 40
                     END IF
   28            CONTINUE
C                No previous sky.
                 SKY=-3.E33
                 DSKY=' '
            ELSE
C               probably normal case.  Check DIAPH:
                IF (KDIAPHRAGM.NE.-1 .AND. DIAPH(J).NE.DSKY) THEN
C                  Mismatch; force search for previous sky.
                   SKY=-3.E33
                   GO TO 20
                ELSE
C                  NORMAL case. Existing sky OK.
                END IF
            END IF
         END IF
C
C        SKY is now valid previous value. Look for FOLLOWING value:
C
   40   IF (SKY2.LT.0.) THEN
C           Look for next sky.
            DO 48 JJ=J+1,JEND
                  IF (KBND(JJ).NE.NB .OR. NSTR(JJ).LT.0) GO TO 48
                  IF(DTYPE(JJ).EQ.'Y') THEN
                        IF(KDIAPHRAGM.NE.-1 .AND.
     1                    DIAPH(JJ).NE.DIAPH(J)) GOTO 48
C                       OK; JJ is the following sky we seek.
                        DSKY2=DIAPH(JJ)
                        SKY2=SIGNAL(JJ)
                        SKYAIR2=AIRM(JJ)
                        SKYAZ2=AZIM(JJ)
                        SKYTIM2=DJOBS(JJ)
                        PHN2=PHVAR(JJ)
                        ERR2=ESTER(JJ)
                        GO TO 60
                  END IF
   48       CONTINUE
C           No following sky.
            SKY2=-3.E33
            DSKY2=' '
        ELSE
C           existing sky2 might still be OK. Check it:
            IF (SKYTIM2.GT.DJOBS(J)) THEN
C               Time is OK.  Check diaphragm:
                IF (KDIAPHRAGM.NE.-1) THEN
                    IF (DIAPH(J).EQ.DSKY2) THEN
C                       we are OK; go on.
                    ELSE
C                       need a new SKY2.
                        SKY2=-3.E33
                        GO TO 40
                    END IF
                ELSE
C                   No problem.  Go on.
                END IF
            ELSE
C               We are past the old second sky.  Move it back & get new one:
                SKY=SKY2
                DSKY=DSKY2
                SKYAIR=SKYAIR2
                SKYAZ=SKYAZ2
                SKYTIM=SKYTIM2
                PHNOISE=PHN2
                ERREST=ERR2
                SKY2=-3.E33
                GO TO 40
            END IF
        END IF
C
C       Now compare to find "nearer" sky:
C
   60   IF (SKY.GT.0. .AND. SKY2.GT.0.) THEN
C           Everything is hunky-dory.  Find closer sample:
            S1=ABS(SKYTIM-DJOBS(J))*20. + ABS(SKYAIR-AIRM(J))
            IF (ABS(SKYAZ-AZIM(J)).GT.PI) THEN
               S1=S1+ (SKYAIR+AIRM(J))*(TWOPI-ABS(SKYAZ-AZIM(J)))
            ELSE
               S1=S1+ (SKYAIR+AIRM(J))*ABS(SKYAZ-AZIM(J))
            END IF
            S2=ABS(SKYTIM2-DJOBS(J))*20. + ABS(SKYAIR2-AIRM(J))
            IF (ABS(SKYAZ2-AZIM(J)).GT.PI) THEN
               S2=S2+ (SKYAIR2+AIRM(J))*(TWOPI-ABS(SKYAZ2-AZIM(J)))
            ELSE
               S2=S2+ (SKYAIR2+AIRM(J))*ABS(SKYAZ2-AZIM(J))
            END IF
C
            IF (S2.LT.S1) THEN
                SKYUSE=SKY2
                PHNUSE=PHN2
                ERRUSE=ERR2
                IF (S2.GT.0.1) THEN
C                  complain.
C                  CALL SKYFAR()
                END IF
            ELSE
                SKYUSE=SKY
                PHNUSE=PHNOISE
                ERRUSE=ERREST
                IF (S1.GT.0.1) THEN
C                  complain.
                END IF
            END IF
        ELSE IF (SKY.GT.0.) THEN
C           SKY is the only good one.  Use it.
            SKYUSE=SKY
            PHNUSE=PHNOISE
            ERRUSE=ERREST
        ELSE IF (SKY2.GT.0.) THEN
C           SKY2 is the only good one.  Use it.
            SKYUSE=SKY2
            PHNUSE=PHN2
            ERRUSE=ERR2
        ELSE
C           AARRRGHHH!!  NEITHER sky is any good!
            CARD='Can''t find a sky sample to match '//STARS(NSTR(J))
            CALL TV(CARD)
            WRITE(CARD,'(''at '',F7.4)') DJOBS(J)
            IF (KDIAPHRAGM.NE.-1) CARD(30:)='in diaphragm '//DIAPH(J)
            CALL TVN(CARD)
            CALL TV('This value will be REJECTED.')
            CALL SPACE
C           set value to zero and continue:
            SKYUSE=SIGNAL(J)
            PHVAR(J)=1.E10
            ERRUSE=1.E10
        END IF
C
C       OK, we have now rigged SKYUSE to be the value to subtract.  Do it.
C
        SIGNAL(J)=SIGNAL(J)-SKYUSE
        PHVAR(J)=PHVAR(J)+PHNUSE
        IF (ESTER(J).NE.0.) ESTER(J)=SQRT(ESTER(J)**2 +ERRUSE**2)
C
  100 CONTINUE
C
C       Normal return.
C
      RETURN
C
      END
      SUBROUTINE REDSUB(BANDS,KMIN,KMAX,LASTK,MAXK,DTYPE)
C
C       Subtracts red-leak data from corresponding bands.
C       Picks the NEAREST red-leak sample, and subtracts it from star.
C
C
      IMPLICIT NONE
C
      REAL RLFACT, RL, RLVAR, ERVAR
      INTEGER KMIN, KMAX, LASTK, MAXK, NBRL, K, KRL, JBGN, NIGHT, 
     1         KK, J, JMIN, JMAX, JEND, ISTR, JOFF, J1, J2
C
      INCLUDE 'MID_REL_INCL:obs.inc'
C
      INCLUDE 'MID_REL_INCL:mstars.inc'
C     PARAMETER (MSTARS=1650)
C       MSTARS is max.number of star-catalog entries.
C       commons for star catalog:
      CHARACTER *32 STARS
      COMMON /SCATA/ STARS(MSTARS)
C
      CHARACTER DTYPE(MXOBS)
C
      INCLUDE 'MID_REL_INCL:mbands.inc'
C     PARAMETER (MBANDS=9)
      INTEGER MXCOLR
      PARAMETER (MXCOLR=3*MBANDS)
      CHARACTER *8 BANDS(MXCOLR)
C
C       Common for red leaks:
C
      COMMON /REDLK/ NBRL(MXCOLR), RLFACT(MXCOLR)
C
C
C       Useful   bands run from KMIN to LASTK.
C       Measured bands run from KMIN to KMAX, including red leaks.
C       MAXK  marks end of expected red-leak bands, starting at NBANDS+1.
C
C
C    EXAMPLE of red-leak storage:
C
C       In UBVRI system, NBANDS = 5.  Suppose we measure only B,V,R, & BRL.
C
C               K     BAND(K)    NBRL(K)
C               -     -------    -------
C               1        U          0
C               2        B          6    <-- KMIN = 2
C               3        V          0
C               4        R          0    <-- LASTK = 4
C               5        I          0
C               6       BRL         0    <-- KMAX = MAXK = 6
C
C
C
C
      DO 1000 K=KMIN,LASTK
          IF (NBRL(K).EQ.0) GO TO 1000
         KRL=NBRL(K)
         JBGN=1
C
      DO 900 NIGHT=1,NIGHTS
         KK=0
         DO 10 J=JBGN,NDATA
C           get limits for current night & passband.
            IF (NITE(J).NE.NIGHT) GO TO 20
            IF (DTYPE(J).EQ.'Y') GO TO 10
            KK=KK+1
            IF (KK.EQ.1) JMIN=J
            JMAX=J
   10    CONTINUE
         J=NDATA+1
   20    JEND=J-1
C
C       JBGN, JEND index the first & last data of ANY kind for the night.
C       JMIN, JMAX index the first & last STAR data for the night & band.
C       KK counts star data for the night.
C
C
      DO 100 J=JMIN,JMAX
C
         IF (DTYPE(J).EQ.'Y' .OR. NSTR(J).LT.0) GO TO 100
C        here if datum is stellar.
C
         IF (KBND(J).EQ.K) THEN
C
C           this observation requires red-leak correction.
            ISTR=NSTR(J)
C           scan forward & back for nearest red-leak datum for same star:
            DO 50 JOFF=1,50
C               look ahead...
                J1=J+JOFF
                IF (J1.GT.JMAX) GO TO 40
                IF (KBND(J1).NE.KRL .OR. NSTR(J1).NE.ISTR) GO TO 40
                RL=SIGNAL(J1)
                RLVAR=PHVAR(J1)
                ERVAR=ESTER(J1)
                GO TO 60
   40           CONTINUE
C               look back...
                J2=J-JOFF
                IF (J2.LT.JMIN) GO TO 50
                IF (KBND(J2).NE.KRL .OR. NSTR(J2).NE.ISTR) GO TO 50
                RL=SIGNAL(J2)
                RLVAR=PHVAR(J2)
                ERVAR=ESTER(J2)
                GO TO 60
   50       CONTINUE
            CALL TV('No red-leak datum found for')
            CALL TVN(STARS(ISTR))
C
   60       CONTINUE
            IF (RL.LT.0.) THEN
               RL=0.
               CALL TV('Negative red-leak found for')
               CALL TVN(STARS(NSTR(J)))
               GO TO 100
            END IF
C
C           Correct for red leak:
            SIGNAL(J)=SIGNAL(J)-RL*RLFACT(K)
            PHVAR(J)=PHVAR(J)+RLVAR*RLFACT(K)
            IF(ESTER(J).NE.0.)ESTER(J)=SQRT(ESTER(J)**2+ERVAR*RLFACT(K))
C
        END IF
C
  100 CONTINUE
C
C     prepare for next pass.
      JBGN=JEND+1
  900 CONTINUE
C
 1000 CONTINUE
C
C       Normal return.
C
      RETURN
C
      END
      SUBROUTINE NEED(LINES)
C
C       Tell it how many lines you need for a plot.  It reads the LOG
C       keyword and adds spaces to start a new page if necessary.
C
C
      IMPLICIT NONE
C
      INTEGER LINES, NGOT, LINE, IUNIT, NULLS, ISTAT, NLPP, I
C
C
      CALL STKRDI('LOG',6,1, NGOT,LINE,IUNIT,NULLS,ISTAT)
      IF (ISTAT.NE.0) CALL TERROR(9999,'Could not read Keyword LOG')
      CALL STKRDI('LOG',7,1, NGOT,NLPP,IUNIT,NULLS,ISTAT)
      IF (ISTAT.NE.0) CALL TERROR(9999,'Could not read Keyword LOG')
      IF(LINE+LINES.GT.NLPP)THEN
C        we must space to a new page.
         DO 1 I=1,NLPP-LINE
            CALL TVN(' ')
    1    CONTINUE
      ELSE
C        we are OK.
      END IF
C
      RETURN
      END

C @(#)tdorder.for	19.1 (ES0-DMD) 02/25/03 14:11:19
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:59 - 11 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C.IDENTIFICATION        TDORDER.FOR
C.KEYWORDS           TABLE, APPLICATIONS
C.ENVIRONMENT  MIDAS
C.PURPOSE
C
C RETURNS THE VALUES -1,0,+1 IF THE ALPHANUMERIC CHARACTER
C STRING IN
C IX IS < , = , > TO THAT IN IY, IN THE SENSE THAT
C 0<1<2,...<9<SPACE<A<B<...<Z   .
C
C
C------------------------------------------------------------------
    
      INTEGER FUNCTION TDORDE(IST,IEN,IX,IY)
      IMPLICIT NONE
      INTEGER IST      ! IN : starting byte
      INTEGER IEN      ! IN : last byte
      CHARACTER*(*) IX ! IN : string1
      CHARACTER*(*) IY ! IN : string2
C
      INTEGER K
      DO 10 K = IST,IEN
          IF (IX(K:K).GT.IY(K:K)) GO TO 20
          IF (IX(K:K).LT.IY(K:K)) GO TO 30
   10 CONTINUE
      TDORDE = 0
      RETURN
   20 TDORDE = 1
      RETURN
   30 TDORDE = -1
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2007 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
        PROGRAM AFI
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C IDENTIFICATION
C   	program afi			version 1.00		910320
C	G.M.Richter ZIAP Sternwarte Babelsberg
C
C PURPOSE
C	adaptive filtering of images:
C	reduction of the noise without damaging the resolution.
C	cleaning (smoothing, low pass filtering) as well as structur enhancing
C	and detecting (by two types of high pass filtering: gradient and 
C	Laplace filter) is possible.
C
C ALGORITHM
C	The local signal-to-noise ratio as a function of decreasing resolution
C	is evaluated via the H-transform: mean gradients and curvatures over 
C	different scale lengths (obtained from the H-coefficients of different
C	order) are compared to the corresponding exspectation values of the
C	noise. The order for which this signal-to-noise ratio exceedes a given
C	parameter K indicates the local resolution scale lenght of the signal
C	(dubbed: the point becomes significant at this order), and determines
C	the size of the impuls response of the filter at this point.
C
C KEYWORDS
C	IN_A	input frame
C	IN_B	input mask for noise statistics:
C		Only unmasked (mask value=0) pixels of the input frame are
C		used to estimate the noise statistics.
C		If 'NULL' is put in, no mask is used
C	OUT_A	output frame
C	INPUTC/C/1/1 type of adaptive filter:
C		'S'=smoothing
C		'G'=gradient filter
C		'L'=Laplace-filter
C	INPUTC/C/2/1 shape of impulse resonse:
C		'B'=box
C		'P'=pyramide
C	INPUTI/I/1/1 maximal size of impulse response
C		(in regions of high resolution the actual size is smaller)
C	INPUTR/R/1/1 threshold for significance
C	INPUTC/C/3/1 noise model:
C		'A'=additive noise is assumed
C		'P'=Poisson-noise is assumed
C
C NOTE
C	When the algorithm is finished some information on the noise 
C	statistics is put out on the terminal: the standard deviation and
C	the exspectation values of the gradients and the Laplace-terms at 
C	every order involved, and the number of pixels which became significant
C	on every order by the gradient and by the Laplace term respectively.
C	The rest pixels are set to the maximal size response.
C
C
C--------------------------------------------------------------------------
       IMPLICIT NONE

       INTEGER       MADRID(1),NRD,K1,K2,STAT,ORD,SIZ,
     >               NAXIS,NPIX(2),NAXISMT,NPIXMT(2),
     >               IMNIN,IMNOUT,IMNH0,IMNH1,IMNHG,IMNHL,IMNM,IMNMT
     
       INTEGER*8     PNTIN,PNTOUT,PNTH0,PNTH1,PNTHG,PNTHL,PNTM,PNTMT
       INTEGER	     NSG,NSL,REST
       CHARACTER*60  IN,OUT,MT
       CHARACTER     IDENT*72,UNIT*64,TYP*1,FORM*1,NOI*1,YMT*1

       DOUBLE PRECISION START(2),STEP(2)

       REAL          K,EG,EL,SG,SL,MOG,MOL,MUL,CUT(4)
C
C *** include MIDAS definition table
       INCLUDE       'MID_INCLUDE:ST_DEF.INC'
       COMMON        /VMR/MADRID
       COMMON        /TEST/EG(16),SG(16),EL(16),SL(16),NSG(16),NSL(16),
     >                     REST,MOG,MOL,MUL
       INCLUDE       'MID_INCLUDE:ST_DAT.INC'
C
C common block for statistics

C *** set up MIDAS environment
      CALL STSPRO('afi')

C get input frame and map it as an image with pixels in floating point format
      CALL STKRDC('IN_A',1,1,60,NRD,IN,K1,K2,STAT)
      CALL STIGET(IN,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,2,NAXIS,NPIX,
     >      	    START,STEP,IDENT,UNIT,PNTIN,IMNIN,STAT)
C
      IF (NAXIS.LT.2) CALL STETER(1,'*** FATAL: dimension less than 2')

C get name of output frame and create and map it
      CALL STKRDC('OUT_A',1,1,60,NRD,OUT,K1,K2,STAT)
      CALL STIPUT(OUT,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,NAXIS,NPIX,
     >           START,STEP,IDENT,UNIT,PNTOUT,IMNOUT,STAT)

C get name of mask image, if name=NULL -> no mask image
      YMT='Y'
      CALL STKRDC('IN_B',1,1,60,NRD,MT,K1,K2,STAT)
      IF ((MT(1:4).EQ.'NULL').OR.(MT(1:4).EQ.'null'))THEN
         YMT='N'
      ELSE
         CALL STIGET(MT,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,2,NAXISMT,
     >               NPIXMT,START,STEP,IDENT,UNIT,PNTMT,IMNMT,STAT)
         IF ((NPIXMT(1).NE.NPIX(1)).OR.(NPIXMT(2).NE.NPIX(2))) THEN
            CALL STETER(1,
     2           '*** FATAL: Image and mask have different dimensions')
         ENDIF
      ENDIF
C
C *** read char.key 'FILTER TYPE [S/G/L]'
      CALL STKRDC('INPUTC',1,1,1,NRD,TYP,K1,K2,STAT)
C
C *** read char.key 'IMPULSE-RESPONSE SHAPE [P/B]'
      CALL STKRDC('INPUTC',1,2,1,NRD,FORM,K1,K2,STAT)
C
C *** read integer key 'FILTER-SIZE'
      CALL STKRDI('INPUTI',1,1,NRD,SIZ,K1,K2,STAT)
C
C *** read real key 'THRESHOLD K'
      CALL STKRDR('INPUTR',1,1,NRD,K,K1,K2,STAT)
C
C read char.key 'NOISE TYPE [A/P]'
      CALL STKRDC('INPUTC',1,3,1,NRD,NOI,K1,K2,STAT)
C
C *** check input parameter
      CALL UPCAS(NOI,NOI)
      IF (NOI.NE.'A' .AND. NOI.NE.'P') THEN
         CALL STETER(1,'FATAL: *** INVALID NOISE-TYPE')
      ENDIF
      CALL UPCAS(TYP,TYP)
      IF (TYP.NE.'S' .AND. TYP.NE.'G' .AND. TYP.NE.'L') THEN
         CALL STETER(1,'*** FATAL: INVALID FILTER-TYPE')
      ENDIF
      CALL UPCAS(FORM,FORM)
      IF (FORM.NE.'B' .AND. FORM.NE.'P') THEN
         CALL STETER(1,'*** FATAL: INVALID IMPULSE-RESPONSE SHAPE')
      ENDIF
C
C *** get transform-order ORD from window-size SIZ
      IF (FORM.EQ.'P') THEN
         ORD=2                                    ! size = 3
         IF(SIZ.GT.3)   ORD=3
         IF(SIZ.GT.5)   ORD=4
         IF(SIZ.GT.7)   ORD=5
         IF(SIZ.GT.11)  ORD=6
         IF(SIZ.GT.15)  ORD=7
         IF(SIZ.GT.23)  ORD=8
         IF(SIZ.GT.31)  ORD=9
         IF(SIZ.GT.47)  ORD=10
         IF(SIZ.GT.63)  ORD=11
         IF(SIZ.GT.95)  ORD=12
         IF(SIZ.GT.127) ORD=13
         IF(SIZ.GT.191) ORD=14	!255
      ELSE
         ORD=2                                    ! size = 3
         IF(SIZ.GT.3)   ORD=3
         IF(SIZ.GT.5)   ORD=4
         IF(SIZ.GT.9)   ORD=5
         IF(SIZ.GT.17)  ORD=6
         IF(SIZ.GT.33)  ORD=7
         IF(SIZ.GT.65)  ORD=8
         IF(SIZ.GT.129) ORD=9
         IF(SIZ.GT.257) ORD=10	!513
      ENDIF
C
C *** create and map images to work
      CALL STIPUT('mid_h0',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,NAXIS,NPIX,
     >           START,STEP,IDENT,UNIT,PNTH0,IMNH0,STAT)
      CALL STIPUT('mid_h1',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,NAXIS,NPIX,
     >        START,STEP,IDENT,UNIT,PNTH1,IMNH1,STAT)
      CALL STIPUT('mid_hg',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,NAXIS,NPIX,
     >        START,STEP,IDENT,UNIT,PNTHG,IMNHG,STAT)
      CALL STIPUT('mid_hl',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,NAXIS,NPIX,
     >        START,STEP,IDENT,UNIT,PNTHL,IMNHL,STAT)
      CALL STIPUT('mid_m',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,NAXIS,NPIX,
     >        START,STEP,IDENT,UNIT,PNTM,IMNM,STAT)
C
C *** start algorithm
      CALL AFIDO(NPIX(1),NPIX(2),MADRID(PNTMT),MADRID(PNTIN),
     >           MADRID(PNTH0),MADRID(PNTH1),MADRID(PNTHG),
     >           MADRID(PNTHL),MADRID(PNTOUT),MADRID(PNTM),
     >           ORD,TYP,FORM,NOI,K,YMT)

C *** information on image statistics and number of significant points
      CALL AINFO(ORD)
c
C *** copy all descriptors from input frame to output frame
C
C  copy descriptors and update LHCUTS + HISTORY
      CALL DSCUPT(IMNIN,IMNOUT,' ',STAT)
C
C *** write cuts for gradient and laplace
      IF (TYP.NE.'S') THEN
         IF (TYP.EQ.'G') THEN
            CUT(2)=3.*MOG
            CUT(1)=0.
         ELSE
            CUT(2)=3.*MOL
            CUT(1)=3.*MUL
         ENDIF
         CALL STDWRR(IMNOUT,'LHCUTS',CUT,1,2,K1,STAT)
      ENDIF
C
C *** release files, update keywords and exit
      CALL STSEPI
      END

C @(#)brthmz.for	19.2 (ESO-DMD) 05/13/03 16:04:26
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE 
     +COMPUB(RESFMT,EXPRSS,ATOM,APNTRS,UPDA,FRAMEC,CUTS)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine COMPUB         version 4.50      880920
C  K. Banse                  ESO - Garching
C  				     4.60      890426
C
C.KEYWORDS
C  arithmetic operations, bulk data frames
C
C.PURPOSE
C  evaluate an arithmetic expression involving frames, constants and functions
C  and store the result into a data frame or key OUTPUTR(1), if used as pocket calculator
C
C.ALGORITHM
C  "clean" the expression by replacing all frame names by F, all constants by C
C  and all functions by P, convert it to polish (postfix) notation and evaluate it piecewise
C  intermediate results are stored in OUTPUTR(1) or frame midtempn.bdf
C  establish special condition handler for arithmetic traps...
C  copy all descriptors of first frame operand to result frame.
C
C.INPUT/OUTPUT
C      
C  call as  COMPUB(RESFMT,EXPRSS,ATOM,APNTRS,UPDA,FRAMEC,CUTS)
C 
C  input par:
C  RESFMT:	I*4           data format for result frame 
C  EXPRSS:      char.exp.     arithmetic expression in polish postfix notation
C  ATOM:        char. array   holds the operands
C  APNTRS:      I*4 array     holds the pointers to ATOM
C  FRAMEC:      char. exp.    name of result frame
C  UPDA:	I*4           if = 1, result frame is just modified,
C                             else a new result frame is created
C      
C  output par:
C  CUTS:        R*4 array     min, max of result frame
C.VERSION
C 030513	last modif
C 
C-------------------------------------------------------------------------
C
      IMPLICIT NONE
C
      CHARACTER*(*)    EXPRSS,ATOM(*),FRAMEC
      CHARACTER*80     FRAMEA,FRAMEB,FRAME
      CHARACTER*1      DUM(24)
      CHARACTER        CUNITA*64,CUNITB*64,IDENTA*72,IDENTB*72
      CHARACTER*60     OPERA,OPERB,OPERC
      CHARACTER        WORK(2)*50
      CHARACTER        OPERAT*4,LINE*80,DUMMY*20
      CHARACTER        ERROR1*40,ERROR2*30,ERROR4*30
C      
      DOUBLE PRECISION STEPA(3),STEPB(3),STEPC(3)
      DOUBLE PRECISION STARTA(3),STARTB(3),STARTC(3)
      DOUBLE PRECISION BEGIN(3),END(3),DIF,DDUM(1)
      DOUBLE PRECISION EPS1
C 
      REAL         CNSTAB(2),CONST,CUTS(2),RDUM(1),USRNUL
C      
      INTEGER      NULCNT,NNN
      INTEGER      RESFMT,APNTRS(*),UPDA,IMNOC
      INTEGER      APIX(3,2),BPIX(3,2),CPIX(3,2)
      INTEGER      NPIXA(3),NPIXB(3),NPIXC(3)
      INTEGER      IDUM(1),IDUMMY,LL
      INTEGER      MAXDIM,N,NAXISA,NAXISB,NAXISC
      INTEGER      NBRA,P1,P2,P3
      INTEGER*8    PNTRA,PNTRB,PNTRC
      INTEGER      PP,SIZE,STAT
      INTEGER      IMNOA,IMNOB
      INTEGER      UNI(1),NULO,MADRID(1)
      INTEGER      APIXDF,BPIXDF,CPIXDF,KK
C 
      INCLUDE  'MID_INCLUDE:ST_DEF.INC'
C 
      COMMON      /NULCOM/ NULCNT,USRNUL
C 
      COMMON      /VMR/ MADRID
C      
      DATA      
     +ERROR1 /'Operands do not match in stepsize... '/
      DATA      ERROR2      /'Operands do not overlap...'/
      DATA      ERROR4      /'Too many operands...'/
c 
      DATA      APIX /6*1/, BPIX /6*1/, CPIX /6*1/
      DATA      DUM  /'a','b','c','d','e','f','g','h','i','j',
     +                'k','l','m','n','o','p','q','r','s','t',
     +                'u','v','w','x'/
      DATA      IDENTA /' '/,  CUNITA /' '/
      DATA      IDENTB /' '/,  CUNITB /' '/
      DATA      NPIXA  /3*1/,    NPIXB /3*1/,     NPIXC /3*1/
      DATA      STARTA /3*0.D0/, STARTB /3*0.D0/, STARTC /3*0.D0/
      DATA      STEPA  /3*1.D0/, STEPB  /3*1.D0/, STEPC  /3*1.D0/
      DATA      DUMMY  /'midtemp   .bdf '/
C 
      INCLUDE  'MID_INCLUDE:ST_DAT.INC'
C      
C  initialize
      IDUMMY = 0
      WORK(1) = EXPRSS
      CALL STKRDC('MID$SESS',1,11,2,LL,DUMMY(8:),UNI,NULO,STAT)
C      
C  extract basic operations
1000  CALL EXPRDC(WORK(1),WORK(2),OPERAT,PP)
C      
C  extract operands
      P1 = APNTRS(PP)
      P2 = APNTRS(PP+1)
      OPERA = ATOM(P1)
      OPERB = ATOM(P2)
      IF (OPERAT(1:1).EQ.'Q') THEN                  !treat 2-arg functions...
         P3 = APNTRS(PP+2)
         OPERC = ATOM(P3)
      ENDIF
C      
C  find out what kind of OPERA to do
      IF (INDEX(OPERAT,'C').GT.0) THEN
         N = INDEX(OPERAT,'F')                  !also F involved...?
         IF (N.GT.0) GOTO 1600                  !yes. 
      ELSE
         IF (OPERAT(1:1).EQ.'P') THEN
            GOTO 1600                              !handle PF)
         ELSE
            GOTO 2000                              !handle FF or QFF)
         ENDIF
      ENDIF
C      
C  ***
C  only constants involved, do it right now
C  ***
C      
      IF (OPERAT(1:2).EQ.'CC') THEN
         LL = INDEX(OPERA,' ') - 1
         IF (LL.LE.0) LL = 60
         LINE(1:) = OPERA(1:LL)//','//OPERB
         CALL GENCNV(LINE(1:61),2,2,IDUM,CNSTAB,DDUM,LL)
         IF (LL.LE.1) GOTO 9990                              !we need 2 values...
         CALL OPCC(OPERAT,CNSTAB(1),CNSTAB(2),CONST)
      ELSE
         IF (OPERAT(1:1).EQ.'P') THEN                  !1-arg functions
            CALL GENCNV(OPERB,2,1,IDUM,CNSTAB,DDUM,LL)
            IF (LL.LE.0) GOTO 9990
            CALL FUN1C(OPERA(1:5),CNSTAB,CONST)
         ELSE                                          !2-arg functions
            LINE(1:41) = OPERB//','//OPERC
            CALL GENCNV(LINE(1:61),2,2,IDUM,CNSTAB,DDUM,LL)
            IF (LL.LE.0) GOTO 9990
            CALL FUN2CC(OPERA(1:5),CNSTAB,CONST)
         ENDIF
      ENDIF
C
C  put resulting constant back into relevant ATOM + goto loopend
      IF (WORK(2)(2:2).NE.' ') THEN
         WRITE(ATOM(P1),10000) CONST
         GOTO 5000
      ELSE
         GOTO 9000
      ENDIF
C
C  ***
C  one operand is a file
C  ***
C      
1600  IF (OPERAT(1:2).EQ.'FC') THEN
         FRAME = OPERA
         LINE(1:20) = OPERB
         NBRA = 1                                    !no function
         GOTO 1700
      ENDIF
C 
      IF (OPERAT(1:2).EQ.'CF') THEN
         FRAME = OPERB
         LINE(1:20) = OPERA
         NBRA = 1                                    !no function
         GOTO 1700
      ENDIF
C 
      IF (OPERAT(1:2).EQ.'PF') THEN
         FRAME = OPERB
         NBRA = 2                                    !1-arg function
         GOTO 1800
      ENDIF
      NBRA = 3                                    !2-arg function
C 
      IF (OPERAT(1:2).NE.'QC') THEN
         FRAME = OPERB
         LINE(1:20) = OPERC
      ELSE
         FRAME = OPERC
         LINE(1:20) = OPERB
      ENDIF
C      
1700  CALL GENCNV(LINE(1:20),2,1,IDUM,RDUM,DDUM,LL)
      CONST = RDUM(1)
      IF (LL.LE.0) GOTO 9990                     !problems with conversion...
C      
1800  CALL CLNFRA(FRAME,FRAMEA,0)                !take care of & and # ...
C      
C  now map the result frame
      IF ( (WORK(2)(2:2).EQ.' ') .AND.
     +     (FRAMEA.EQ.FRAMEC) ) THEN
         CALL STIGET(FRAMEA,RESFMT,F_IO_MODE,F_IMA_TYPE,
     +               3,NAXISC,NPIXC,STARTC,STEPC,IDENTA,
     +               CUNITA,PNTRA,IMNOA,STAT)
         SIZE = 1
C 
         DO 1805, N=1,NAXISC
            SIZE = SIZE * NPIXC(N)
1805     CONTINUE
         PNTRC = PNTRA
         IMNOC = IMNOA
      ELSE
C      
C  result frame different from input frames
         CALL STIGET(FRAMEA,RESFMT,F_I_MODE,F_IMA_TYPE,
     +               3,NAXISA,NPIXA,STARTA,STEPA,IDENTA,
     +               CUNITA,PNTRA,IMNOA,STAT)
         NAXISC = NAXISA
         SIZE = 1
C 
         DO 1810, N=1,NAXISA
            SIZE = SIZE * NPIXA(N)
            NPIXC(N) = NPIXA(N)
            STARTC(N) = STARTA(N)
            STEPC(N) = STEPA(N)
1810     CONTINUE
C      
C  last operation ?
         IF (WORK(2)(2:2).EQ.' ') THEN
            IF (UPDA.EQ.1) THEN         
               CALL STIGET(FRAMEC,RESFMT,F_IO_MODE,F_IMA_TYPE,
     +                     3,NAXISC,NPIXC,STARTC,STEPC,IDENTA,
     +                     CUNITA,PNTRC,IMNOC,STAT)
C                                            we have to recalculate SIZE
               SIZE = 1                       
               DO 1815, N=1,NAXISC
                  SIZE = SIZE * NPIXC(N)
1815           CONTINUE
            ELSE
               CALL STIPUT(FRAMEC,RESFMT,F_O_MODE,F_IMA_TYPE,
     +                     NAXISC,NPIXC,STARTC,STEPC,IDENTA,
     +                     CUNITA,PNTRC,IMNOC,STAT)
            ENDIF
         ELSE                                      !use dummy result frame
C       
C  no. loop more
            IDUMMY = IDUMMY + 1                    !increment dummy file counter
            IF (IDUMMY.GT.24) THEN                 !check operand count
               CALL STETER(3,ERROR4)
            ELSE
               DUMMY(10:10) = DUM(IDUMMY)
            ENDIF
            CALL STIPUT(DUMMY,RESFMT,F_O_MODE,F_IMA_TYPE,
     +                  NAXISC,NPIXC,STARTC,STEPC,IDENTA,
     +                  CUNITA,PNTRC,IMNOC,STAT)
         ENDIF
      ENDIF
C
C  now do the actual operation
      GOTO (1850,1860,1870),NBRA                       
C 
1850  CALL OPFC(OPERAT,MADRID(PNTRA),CONST,MADRID(PNTRC),
     +          SIZE,USRNUL,NNN)
      GOTO 1900
C 
1860  CALL FUN1F(OPERA(1:5),MADRID(PNTRA),MADRID(PNTRC),
     +          SIZE,USRNUL,NNN)
      GOTO 1900
C 
1870  CALL FUN2FC(OPERA(1:5),MADRID(PNTRA),CONST,MADRID(PNTRC),
     +          SIZE,USRNUL,NNN)
C      
1900  NULCNT = NULCNT + NNN                !update null count
      IF (WORK(2)(2:2).NE.' ') THEN
         CALL STFCLO(IMNOA,STAT) 
         GOTO 4400                           
      ELSE
         GOTO 9000                           
      ENDIF
C
C  ***
C  both operands are files 
C  ***
C      
2000  IF (OPERAT(1:1).NE.'Q') THEN
         CALL CLNFRA(OPERA,FRAMEA,0)
         CALL CLNFRA(OPERB,FRAMEB,0)
      ELSE
         CALL CLNFRA(OPERB,FRAMEA,0)
         CALL CLNFRA(OPERC,FRAMEB,0)
      ENDIF
C      
C  get first input frame
      IF ( (WORK(2)(2:2).EQ.' ') .AND.
     +     (FRAMEA.EQ.FRAMEC) ) THEN
         CALL STIGET(FRAMEA,RESFMT,F_IO_MODE,F_IMA_TYPE,
     +               3,NAXISC,NPIXC,STARTC,STEPC,IDENTA,
     +               CUNITA,PNTRA,IMNOA,STAT)      !map input/result frame
         NAXISA = NAXISC
         SIZE = 1
C 
         DO 2050, N=1,NAXISC
            SIZE = SIZE * NPIXC(N)
            NPIXA(N) = NPIXC(N)
            STARTA(N) = STARTC(N)
            STEPA(N) = STEPC(N)
2050     CONTINUE
         PNTRC = PNTRA
         IMNOC = IMNOA
      ELSE
         CALL STIGET(FRAMEA,RESFMT,F_I_MODE,F_IMA_TYPE,
     +               3,NAXISA,NPIXA,STARTA,STEPA,IDENTA,
     +               CUNITA,PNTRA,IMNOA,STAT)
      ENDIF
C      
C  handle 2. input frame
      IF (FRAMEA.EQ.FRAMEB) THEN                        !check, if both operands are the same
         PNTRB = PNTRA
         IMNOB = IMNOA
         DO 2100, N=1,NAXISA
            NPIXB(N) = NPIXA(N)
            STARTB(N) = STARTA(N)
            STEPB(N) = STEPA(N)
2100     CONTINUE
         NAXISB = NAXISA
      ELSE
         CALL STIGET(FRAMEB,RESFMT,F_I_MODE,F_IMA_TYPE,
     +               3,NAXISB,NPIXB,STARTB,STEPB,IDENTB,
     +               CUNITB,PNTRB,IMNOB,STAT)
      ENDIF
C
C  see, if stepsizes and origins fit + frames overlap 
      IF (NAXISB.GT.NAXISA) THEN
         MAXDIM = NAXISB                        !take maximum
      ELSE
         MAXDIM = NAXISA
      ENDIF
C 
      DO 2150, N=1,MAXDIM
         EPS1 = 0.0001 * ABS(STEPA(N))        !take 0.01% of stepsize as epsilon
         IF (ABS(STEPA(N)-STEPB(N)).GT.EPS1) 
     +      CALL STETER(1,ERROR1)
         CALL OVRLAP(STARTA(N),STEPA(N),NPIXA(N),STARTB(N),
     +               STEPB(N),NPIXB(N),BEGIN(N),END(N),STAT)
         IF (STAT.NE.0) CALL STETER(3,ERROR2)        !if STAT = 1, no overlap...
2150  CONTINUE
C 
C  create new result frame with dimension = intersection of input frames
      IF ( (WORK(2)(2:2).EQ.' ') .AND.
     +     (FRAMEA.EQ.FRAMEC) ) GOTO 3000            !we already have the result frame
C      
      IF (NAXISA.GT.NAXISB) THEN
         NAXISC = NAXISB
      ELSE
         NAXISC = NAXISA
      ENDIF
C 
      SIZE = 1
      DO 2200, N=1,NAXISC
         STARTC(N) = BEGIN(N)
         STEPC(N) = STEPA(N)
         NPIXC(N) = NINT( (END(N)-BEGIN(N)) / STEPC(N) ) + 1
         SIZE = SIZE * NPIXC(N)
2200  CONTINUE
C      
C  now map the resulting frame
      IF (WORK(2)(2:2).EQ.' ') THEN                !use real result frame
         IF (UPDA.EQ.1) THEN                      !test, if update or new file
            CALL STIGET(FRAMEC,RESFMT,F_IO_MODE,F_IMA_TYPE,
     +                  3,NAXISC,NPIXC,STARTC,STEPC,IDENTA,
     +                  CUNITA,PNTRC,IMNOC,STAT)
            SIZE = 1                              !we have to recalculate SIZE
            DO 2250, N=1,NAXISC
               SIZE = SIZE * NPIXC(N)
2250        CONTINUE
         ELSE
            CALL STIPUT(FRAMEC,RESFMT,F_O_MODE,F_IMA_TYPE,
     +                  NAXISC,NPIXC,STARTC,STEPC,IDENTA,
     +                  CUNITA,PNTRC,IMNOC,STAT)
         ENDIF
C      
      ELSE                                         !use dummy result frame
         IDUMMY = IDUMMY + 1                       !increment dummy file counter
         IF (IDUMMY.GT.24) THEN                    !check operand count
            CALL STETER(2,ERROR4)
         ELSE
            DUMMY(10:10) = DUM(IDUMMY)
         ENDIF
         CALL STIPUT(DUMMY,RESFMT,F_O_MODE,F_IMA_TYPE,
     +               NAXISC,NPIXC,STARTC,STEPC,IDENTA,
     +               CUNITA,PNTRC,IMNOC,STAT)
      ENDIF
C 
C  convert start + end of overlap region into pixel no.'s
3000  DO 3100, N=1,MAXDIM
         DIF = (BEGIN(N)-STARTA(N))/STEPA(N)
         APIX(N,1) = NINT(DIF) + 1
         DIF = (END(N)-STARTA(N))/STEPA(N)
         APIX(N,2) = NINT(DIF) + 1
         APIXDF = APIX(N,2)-APIX(N,1)
         DIF = (BEGIN(N)-STARTB(N))/STEPB(N)
         BPIX(N,1) = NINT(DIF) + 1
         DIF = (END(N)-STARTB(N))/STEPB(N)
         BPIX(N,2) = NINT(DIF) + 1
         BPIXDF = BPIX(N,2)-BPIX(N,1)
         DIF = (BEGIN(N)-STARTC(N))/STEPC(N)
         CPIX(N,1) = NINT(DIF) + 1
         DIF = (END(N)-STARTC(N))/STEPC(N)
         CPIX(N,2) = NINT(DIF) + 1
         CPIXDF = CPIX(N,2)-CPIX(N,1)
         KK = MIN(APIXDF,BPIXDF,CPIXDF)            !take smallest size
         APIX(N,2) = APIX(N,1) + KK
         BPIX(N,2) = BPIX(N,1) + KK
         CPIX(N,2) = CPIX(N,1) + KK
3100  CONTINUE
C 
C  now do the actual operation
      IF (OPERAT(1:1).NE.'Q') THEN
         CALL OPFFW(OPERAT,MADRID(PNTRA),MADRID(PNTRB),
     +          MADRID(PNTRC),APIX,BPIX,CPIX,NPIXA,NPIXB,NPIXC)
      ELSE
         CALL FN2FFW(OPERA(1:5),MADRID(PNTRA),MADRID(PNTRB),
     +          MADRID(PNTRC),APIX,BPIX,CPIX,NPIXA,NPIXB,NPIXC)
      ENDIF
      IF (WORK(2)(2:2).EQ.' ') GOTO 9000
C      
      CALL STFCLO(IMNOA,STAT)      !release input frames
      CALL STFCLO(IMNOB,STAT) 
C
C  put resulting frame back into relevant ATOM, if we are not finished yet
4400  ATOM(P1) = DUMMY
      CALL STFCLO(IMNOC,STAT)      !release dummy result frame
C      
C  loopend for all basic operations
5000  IF (OPERAT(1:1).NE.'Q') THEN
         NBRA = 2
      ELSE
         NBRA = 3
      ENDIF
C 
      DO 5050, N=PP+1,45                        !update pointers for ATOM
         APNTRS(N) = APNTRS(N+NBRA)
5050  CONTINUE
C 
      WORK(1) = WORK(2)
      GOTO 1000                        !get next operation
C  
C  ***
C  we're done. test, if result goes to frame or constant
C  ***
C      
C  calculate new dynamic range of result frame
9000  CALL MYMX(MADRID(PNTRC),SIZE,CUTS)
      CALL STFCLO(IMNOC,STAT)                 !make sure result frame is closed
C      
C  delete any dummy frames
      IF (IDUMMY.GT.0) THEN
         DO 9100, N=1,IDUMMY
            DUMMY(10:10) = DUM(N)
            CALL STFDEL(DUMMY,STAT)
9100     CONTINUE
      ENDIF
C      
C  That's it folks
      RETURN
C      
C  error with conversion of ASCII to number
9990  CALL STETER(10,'conversion error of ASCII -> number ...')
C
C  formats...
10000 FORMAT(G15.7)
      END

C @(#)satobj.for	19.1 (ES0-DMD) 02/25/03 13:25:39
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE SATOBJ(A, JAPY, JOFF, I, J, HCUT, AV)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C-----------------------------------------------------------------------
      IMPLICIT NONE
C
      REAL       A(1)
      INTEGER    JAPY(1)
      INTEGER    JOFF
      INTEGER    I
      INTEGER    J
      REAL       HCUT
      REAL       AV
C
      INTEGER    II, JOF
      REAL       AA(9)
C
      JOF = JAPY(J-JOFF-1) + I
      AA(1) = MIN( A(JOF-1) , HCUT )
      AA(2) = MIN( A(JOF) , HCUT )
      AA(3) = MIN( A(JOF+1) , HCUT )
      JOF = JAPY(J-JOFF) + I
      AA(4) = MIN( A(JOF-1) , HCUT )
      AA(5) = MIN( A(JOF) , HCUT )
      AA(6) = MIN( A(JOF+1) , HCUT )
      JOF = JAPY(J-JOFF+1) + I
      AA(7) = MIN( A(JOF-1) , HCUT )
      AA(8) = MIN( A(JOF) , HCUT )
      AA(9) = MIN( A(JOF+1) , HCUT )
C
      AV = 0.0
      DO 10 II = 1 , 9
            AV = AV + AA(II)
  10      CONTINUE
C
        AV = AV / 9.0
C
      RETURN
      END

C @(#)rctscl.for	19.1 (ES0-DMD) 02/25/03 13:30:48
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE RCTSCL(SUB,IN)
C +++
C.PURPOSE: This subroutine compares the sum of the fluxes in the individual
C          subpixels to the flux in the original input pixel. The fluxes in
C          the subpixels are then scaled such that their sum equals the
C          original flux. Hence, flux conservation should be achieved on the
C          pixel scale.
C ---
      IMPLICIT   NONE
      REAL       SUB(3,3)
      REAL       IN
C
      REAL       SUM,SCALE
      INTEGER    K
      INTEGER    L
C
      SCALE  = 1
      SUM    = SUB(1,1) + SUB(1,2) + SUB(1,3) + SUB(2,1) + SUB(2,2) +
     +         SUB(2,3) + SUB(3,1) + SUB(3,2) + SUB(3,3)
C  
      IF (SUM.NE.0) THEN     ! assume sum does not vanish due to neg. fluxes ...
         SCALE  = IN/SUM 
      ENDIF
C
      DO 20 K = 1,3
         DO 10 L = 1,3
            SUB(K,L) = SUB(K,L)*SCALE
   10    CONTINUE
   20 CONTINUE
C
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2008 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
        PROGRAM TEXLV
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENT:      program TEXLV
C.AUTHOR:     A. Lauberts
C.KEYWORDS:   MIDAS table file, select, parameters, tex file
C.PURPOSE:    prepare tex file with selected parameters from ESOLV catalogue
C.USAGE:      MIDAS applic program
C             execute as @@ TEXLV P1 P2
C.PARAMETERS: P1 = name of ESOLV catalogue on MIDAS table file (default PCAT)
C	      P2 = name of Tex include file (default TABNEW)
C Output:     Tex file on 'P1'.TEX
C.COMMENTS:   New page and header after 35 objects;
C             Remember to sort ESOLV in RA order!
C
C	     In order to execute Tex file ESOLV (def = PCAT) you need to
C	     include the macros specified in the following command lines
C	     (please consult A. Lauberts, E. Valentijn or E. Huizinga):
C
C 	     % \magnification=\magstep1
C	     \input texinp:header
C	     %\draft    % switch for own work copy with comments etc
C	     \facsimile  % switch for JOURNAL lay out
C	     %\forcopyeditor % switch for ordinary double line spacing
C	     \aaformat
C	     \ifdraft \draft \fi
C	     \input DESCRIPTORS
C	     \input PCAT
C	    \bye
C.VERSION: 890317 AL  Creation
C.VERSION: 890714 AL  ???
C.VERSION:        EAV ??? 
C.VERSION: 890425 ??? print all selected entries of whole catalogue 25/4/89
C.VERSION: 890420 ??? version without ra,dec bug
C.VERSION: 890406 ??? version that creates header and wants input in pages
C.VERSION: 890413 AL  new version with Jacek ext received from AL
C.VERSION: 890320 AL  Jacek's ext withdrawn! 20-03-89 AL
C.VERSION: ?????? ??   **** NEW VERSION 21.4 WITH CHANGED ALGORITHMS FOR 
C.                     RA AND DEC/AL *** NOTE four usual substitutes!!!
C 080722	last modif
C-------------------------------------------------------------------------------
C 
        IMPLICIT     NONE
C 
        INTEGER      MADRID(1)
        INTEGER      N35
        INTEGER      IACT
        INTEGER      N1, N2
        INTEGER      NCOL, NROW, NSC, ACOL, AROW
        INTEGER      IST
        INTEGER      I, J, N
        INTEGER      ISTAT
        INTEGER      NSEQ
        INTEGER      TID,KNUL,KUN
        INTEGER      COL(256),STAT
        INTEGER      IH
        INTEGER      IHM
        INTEGER      IHMS
        INTEGER      ID
        REAL         ROW(256)
        REAL         A
        REAL         DEC
        REAL         DM 
        REAL         H
        REAL         HM
        REAL         HMS
        REAL         PI
        REAL         RA, RA1
        REAL         SBA
        LOGICAL      NULL(256),FLAG1
C
        CHARACTER*1  SORT
        CHARACTER*3  PAGE
        CHARACTER*4  MORPH,DIMEN,EXT
        CHARACTER*5  FLAG,REDSH,MAGNIT,ORIENT,DENS,SURFB,COLOUR
        CHARACTER*6  EXPGRA
        CHARACTER*8  PSKIP
        CHARACTER*7  IDENT
        CHARACTER*60 PCAT,TABNEW
        CHARACTER*10 POSIT
        CHARACTER*11 PAGENO
        CHARACTER*30 LHEAD
        CHARACTER*80 TEXT,TEX3,TEX4,TEX5,TEX6
        CHARACTER*150 LIN1,LIN2,TEX1,TEX2
C
        PARAMETER (PI=3.141593)
        INCLUDE       'MID_INCLUDE:ST_DEF.INC/NOLIST'
        COMMON        /VMR/MADRID
        INCLUDE       'MID_INCLUDE:ST_DAT.INC/NOLIST'
C
        DATA TEX1(1:48)/ 
     *      '&&        &&          -&&   -&&    -&& -       &'/
        DATA TEX1(49:94)/ 
     *      '    -&&    -&    -&&    -&    -&&    -&     -&'/
         DATA TEX1(95:138)/ 
     *      '    -&&    -&    -&&     -&&      -&&     -&'/
        DATA TEX2(1:48)/
     *      '&&        &&          -&&   -&&    -&& -       &'/
        DATA TEX2(49:94)/ 
     *      '    -&&    -&    -&&    -&    -&&    -&     -&'/
        DATA TEX2(95:139)/ 
     *      '    -&&    -&    -&&     -&&      -&&      &'/

        DATA TEX3/'\\noalign{\\hrule height 0.4pt}'/
        DATA TEX4/'\\noalign{\\hrule height 1pt}'/
        DATA TEX5/'\\cr'/
        DATA TEX6/'}$$'/
        DATA SORT/'N'/
        DATA PSKIP/'\\eject'/

        SBA=2.5*ALOG10(PI*25.)
        N35=35
C
        CALL STSPRO('TEXLV')
C  get keywords
        CALL STKRDC('IN_A',1,1,60,IACT,PCAT,KUN,KNUL,STAT)
        CALL STKRDC('IN_B',1,1,60,IACT,TABNEW,KUN,KNUL,STAT)
C
C  get entry limits; 1st entry no should start at 1+N*35, else
C  warning and truncation to next lower permissible integer
C
C  has been changed to page output with leaving the old structure intact
         N1  = 1
C
C  open TEX files
C
        OPEN (UNIT=10,FILE=TABNEW//'.TEX',STATUS='OLD')
        OPEN (UNIT=11,FILE=PCAT//'.TEX',STATUS='NEW')
C
C  open table file and get info
C
        CALL TBTOPN(PCAT,F_O_MODE,TID,STAT)
        CALL TBIGET(TID,NCOL,NROW,NSC,ACOL,AROW,IST)
C
        N2 = NROW
        NCOL=NCOL-1
        DO I=1,NCOL
          COL(I)=I
        ENDDO
C
C  normally PCAT should be sorted according to RA
C  if not, you will get ONE warning
C
C  write one time first page number; other page numbers handled by tex
        WRITE(PAGE,120) N1
  120   FORMAT(I3)
        PAGENO(1:8)  = '\\pageno='
        PAGENO(9:11) = PAGE
        WRITE(11,99) PAGENO
C
        RA=0.
C
C  read table file, row by row
C
        DO NSEQ=N1,N2
C
C  new page and header after 35 objects;
C  if N35 = 35 copy TABNEW.TEX to PCAT.TEX
C
          IF(N35.EQ.35) THEN
            N35=0
            IF(NSEQ.NE.1) THEN
              REWIND 10
              WRITE(11,99) PSKIP
            ENDIF
c  make the header for RA
          CALL TBRRDR(TID,NSEQ,NCOL,COL,ROW,NULL,STAT)
          RA=ROW(9)
          H=RA/15.
          IH=INT(H)
          HM=(H-IH)*60.
          IHM=INT(HM)
          HMS=(HM-IHM)*60.
          IHMS=NINT(HMS)
          IF(IHMS.EQ.60) THEN
            IHM=IHM+1
            IHMS=0
          ENDIF
          IF(IHM.EQ.60) THEN
            IH=IH+1
            IHM=0
          ENDIF
          WRITE(POSIT,101) IH,IHM,IHMS
          LIN1(16:23)=POSIT
          IF(LIN1(22:22).EQ.' ') LIN1(22:22)='0'
          IF(LIN1(19:19).EQ.' ') LIN1(19:19)='0'
          LHEAD(1:30) = '\\def \\llhead{\\bf   $^h$  $^m$}'
          LHEAD(18:19) = LIN1(16:17)
          LHEAD(24:25) = LIN1(19:20)
          WRITE(11,99) LHEAD
C continue with contents of TABNEW.TEX
10          READ(10,99,END=20) TEXT
            WRITE(11,99) TEXT
99          FORMAT(A)
            GOTO 10
          ENDIF
20        CONTINUE
          LIN1=TEX1
          LIN2=TEX2
C  read select flag
          CALL TBSGET(TID,NSEQ,FLAG1,ISTAT)
          IF (FLAG1) THEN
            CALL TBRRDR(TID,NSEQ,NCOL,COL,ROW,NULL,STAT)
            N35 = N35 +1
            ELSE
            GOTO 998
          ENDIF
C
C  IDENT
C  ESO_NO = FFF NNNC , where FFF = field no and NNNC = object no (C=0,1,2)
C  assume all identifiers = NULL are at the end of PCAT
C
          IF(NULL(1)) GOTO 999
          I=ROW(1)
          IF(I.LT.10010.OR.I.GT.6061000) GOTO 999
          WRITE(IDENT,100) I
          LIN1(3:5) =IDENT(1:3)
          LIN1(7:10)=IDENT(4:7)
100       FORMAT(I7)
C  NGC
          N=ROW(2)
          IF(.NOT.NULL(2).AND.N.GT.0) THEN
            WRITE(IDENT,100) N
            LIN2(4:10)=IDENT
            LIN2(4:6)='N\\x'
          ENDIF
C  IC
          I=ROW(3)
          IF(.NOT.NULL(3).AND.NULL(2).AND.I.GT.0) THEN
            WRITE(IDENT,100) I
            LIN2(4:10)=IDENT
            LIN2(4:6)='I\\x'
          ENDIF
C
C  POSITION
C  RA_O, DEC_O
          RA1=RA
          RA=ROW(9)
          IF(SORT.NE.'Y'.AND.RA.LT.RA1) THEN
            WRITE(6,*) 'WARNING: PCAT is NOT sorted in RA'
            WRITE(6,*) 'Answer with (capital!) Y if OK'
            READ(5,99) SORT
            IF(SORT.NE.'Y') THEN
              WRITE(6,*) 'Since you didn''t say Y, program STOPs now'
              GOTO 999
            ENDIF
          ENDIF
          DEC=ROW(10)
          H=RA/15.
          IH=INT(H)
          HM=(H-IH)*60.
          IHM=INT(HM)
          HMS=(HM-IHM)*60.
          IHMS=NINT(HMS)
          IF(IHMS.EQ.60) THEN
            IHM=IHM+1
            IHMS=0
          ENDIF
          IF(IHM.EQ.60) THEN
            IH=IH+1
            IHM=0
          ENDIF
          WRITE(POSIT,101) IH,IHM,IHMS
101       FORMAT(I2,1X,I2,1X,I2)
          LIN1(16:23)=POSIT
          IF(LIN1(22:22).EQ.' ') LIN1(22:22)='0'
          IF(LIN1(19:19).EQ.' ') LIN1(19:19)='0'
          ID=DEC
          DM=(ID-DEC)*60.
          IF(DM.GT.59.95) THEN
            DM=0.
            ID=ID-1.
          ENDIF
          WRITE(POSIT,1010) ID,DM
1010      FORMAT(I3,1X,F4.1)
          LIN2(16:23)=POSIT
          IF(LIN2(20:20).EQ.' ') LIN2(20:20)='0'
C
C  MORPH
C  T_NEW
          IF(.NOT.NULL(7)) THEN
            A=ROW(7)
            WRITE(MORPH,102) A
102         FORMAT(F4.1)
            LIN1(26:29)=MORPH
          ENDIF
C  I_FLAG
          IF(NULL(182)) THEN
            I=0
          ELSE
            I=ROW(182)
          ENDIF
C  T_FLAG
          IF(NULL(8)) THEN
            J=0
          ELSE
            J=ROW(8)
          ENDIF
C  write I and J to FLAG
          WRITE(FLAG,1020) I, J
1020      FORMAT(I1,'~~',I1)
          LIN2(26:29)=FLAG
C
C  REDSHIFT
C  CZ and CZ_ERR
          IF(.NOT.NULL(13)) THEN
            I=ROW(13)
            IF(IABS(I).LT.99999) THEN
              WRITE(REDSH,103) I
103           FORMAT(I5)
              LIN1(32:36)=REDSH
              IF(.NOT.NULL(14)) THEN
                I=ROW(14)
                WRITE(REDSH,103) I
                LIN2(32:36)=REDSH
              ENDIF
            ENDIF
          ENDIF
C
C  MAGNITUDES
C
C  flags for saturated and pg-pe replacement
C  case: B replaced,                    flag - on B_TOT
C        B and R repl, R_TOT non-exist, flag = on B_TOT
C        R replaced,   R_TOT existing,  flag - on R_TOT
C
C
C  flag  for saturated, not pg-pe replacement, not deblended
C  case: B (and R) saturated            flag #sat on B_TOT
C
C  The above scheme is motivated by the wish to use only a one char flag.
C  Furthermore, cases with pg-pe replacement need not show number of
C  saturated rings because the saturation problem is solved anyway.
C
C  The only complication is the case B saturated, not pg-pe replaced
C  together with R pg-pe replaced but no R_TOT exist. In this case
C  flag #sat is put on B_TOT, not showing the pg-pe replacement on R.
C
C  flag for resolved blends             flag 0 on B_TOT
C  note that blends are never resolved if also pg-pe repl
C
C  B_TOT
          IF(.NOT.NULL(15)) THEN
            A=ROW(15)
            IF(A.GT.5..AND.A.LT.25.) THEN
              WRITE(MAGNIT,104) A
104           FORMAT(F5.2)
              LIN1(40:44)=MAGNIT
              IF(.NOT.NULL(105)) THEN
                LIN1(39:39)='$'
                LIN1(45:47)='^-$'
                IF(NULL(16).AND..NOT.NULL(106)) LIN1(45:47)='^=$'
              ELSE IF(.NOT.NULL(112)) THEN
                LIN1(39:39)='$'
                LIN1(45:47)='^0$'
              ELSE IF(.NOT.NULL(11)) THEN
                I=ROW(11)
                IF(I.GT.0.AND.I.LT.10) THEN
                  WRITE(FLAG,1020) I
                  LIN1(39:39)='$'
                  LIN1(45:47)='^-$'
                  LIN1(46:46)=FLAG(1:1)
                ENDIF
              ENDIF
            ENDIF
          ENDIF
C  R_TOT
          IF(.NOT.NULL(16)) THEN
            A=ROW(16)
            IF(A.GT.5..AND.A.LT.25.) THEN
              WRITE(MAGNIT,104) A
              LIN2(40:44)=MAGNIT
              IF(.NOT.NULL(106)) THEN
                LIN2(39:39)='$'
                LIN2(45:47)='^-$'
              ENDIF
            ENDIF
          ENDIF
C  B_B26
          IF(.NOT.NULL(17)) THEN
            A=ROW(17)
            IF(A.GT.5..AND.A.LT.25.) THEN
              WRITE(MAGNIT,104) A
              LIN2(49:53)=MAGNIT
            ENDIF
          ENDIF
C  B_B25
          IF(.NOT.NULL(19)) THEN
            A=ROW(19)
            IF(A.GT.5..AND.A.LT.25.) THEN
              WRITE(MAGNIT,104) A
              LIN1(49:53)=MAGNIT
            ENDIF
          ENDIF
C
C  SURFB
C  BS_E
          IF(.NOT.NULL(143)) THEN
            A=ROW(143)
            IF(A.GT.10.AND.A.LT.30.) THEN
              WRITE(SURFB,113) A
113           FORMAT(F5.2)
              LIN1(56:60)=SURFB
            ENDIF
          ENDIF
C  RS_E
          IF(.NOT.NULL(144)) THEN
            A=ROW(144)
            IF(A.GT.10.AND.A.LT.30.) THEN
              WRITE(SURFB,113) A
              LIN2(56:60)=SURFB
            ENDIF
          ENDIF
C  BS_10
          IF(.NOT.NULL(21)) THEN
            A=ROW(21)+SBA
            IF(A.GT.10.AND.A.LT.30.) THEN
              WRITE(SURFB,113) A
              LIN1(62:66)=SURFB
            ENDIF
          ENDIF
C  RS_10
          IF(.NOT.NULL(34)) THEN
            A=ROW(34)+SBA
            IF(A.GT.10.AND.A.LT.30.) THEN
              WRITE(SURFB,113) A
              LIN2(62:66)=SURFB
            ENDIF
          ENDIF
C
C  B-R COLOUR
C  BR_T
          IF(.NOT.NULL(101)) THEN
            A=ROW(101)
            IF(A.GT.-9..AND.A.LT.9.) THEN
              WRITE(COLOUR,105) A
              LIN1(69:73)=COLOUR
            ENDIF
          ENDIF
C  BR_E
          IF(.NOT.NULL(99)) THEN
            A=ROW(99)
            IF(A.GT.-9..AND.A.LT.9.) THEN
              WRITE(COLOUR,105) A
105           FORMAT(F5.2)
              LIN2(69:73)=COLOUR
            ENDIF
          ENDIF
C  BR_10
          IF(.NOT.NULL(100)) THEN
            A=ROW(100)
            IF(A.GT.-9..AND.A.LT.9.) THEN
              WRITE(COLOUR,105) A
              LIN1(75:79)=COLOUR
            ENDIF
          ENDIF
C  BR_DIFF
          IF(.NOT.NULL(171)) THEN
            A=ROW(171)
            IF(A.GT.-9..AND.A.LT.9.) THEN
              WRITE(COLOUR,105) A
              LIN2(75:79)=COLOUR
            ENDIF
          ENDIF
C
C  DIMENSIONS
C  DB_E
          IF(.NOT.NULL(122)) THEN
            A=ROW(122)
            IF(A.LT.99.5) THEN
              WRITE(DIMEN,106) A
            ELSE
              I=NINT(A)
              WRITE(DIMEN,107) I
            ENDIF
            LIN1(83:86)=DIMEN
          ELSE IF (.NOT.NULL(15)) THEN
            LIN1(82:86)='$<10$'
          ENDIF
C  AB_E
          IF(.NOT.NULL(125)) THEN
            A=ROW(125)
            IF(A.LT.99.5) THEN
              WRITE(DIMEN,106) A
            ELSE
              I=NINT(A)
              WRITE(DIMEN,107) I
            ENDIF
            LIN2(83:86)=DIMEN
          ELSE IF (.NOT.NULL(15)) THEN
            LIN2(82:86)='$<10$'
          ENDIF
C  SD25
          IF(.NOT.NULL(109)) THEN
            A=ROW(109)
C           IF(A.LT.99.5) THEN
C             WRITE(DIMEN,106) A
106           FORMAT(F4.1)
C           ELSE
              I=NINT(A)
              WRITE(DIMEN,107) I
107           FORMAT(I4)
C           ENDIF
            LIN1(90:93)=DIMEN
          ENDIF
C  SD26
          IF(.NOT.NULL(110)) THEN
            A=ROW(110)
C           IF(A.LT.99.5) THEN
C             WRITE(DIMEN,106) A
C           ELSE
              I=NINT(A)
              WRITE(DIMEN,107) I
C           ENDIF
            LIN2(90:93)=DIMEN
          ENDIF
C  SD27
          IF(.NOT.NULL(111)) THEN
            A=ROW(111)
C           IF(A.LT.99.5) THEN
C             WRITE(DIMEN,106) A
C           ELSE
              I=NINT(A)
              WRITE(DIMEN,107) I
C           ENDIF
            LIN1(97:100)=DIMEN
          ENDIF
C  DB_90
          IF(.NOT.NULL(121)) THEN
            A=ROW(121)
C           IF(A.LT.99.5) THEN
C             WRITE(DIMEN,106) A
C           ELSE
              I=NINT(A)
              WRITE(DIMEN,107) I
C           ENDIF
            LIN2(97:100)=DIMEN
          ENDIF
C
C  ORIENT
C  D_R_N
          IF(.NOT.NULL(116)) THEN
            A=ROW(116)
            IF(A.LT.99.5) THEN
              WRITE(ORIENT,110) A
              LIN1(103:107)=ORIENT
            ENDIF
          ENDIF
C  PA_N
          IF(.NOT.NULL(118)) THEN
            A=ROW(118)
            IF(A.GE.0..AND.A.LE.180.) THEN
              WRITE(ORIENT,111) A
              LIN1(109:113)=ORIENT
            ENDIF
          ENDIF
C  ABEOCT
          IF(.NOT.NULL(113)) THEN
            A=ROW(113)
            IF(A.LT.99.5) THEN
              WRITE(ORIENT,110) A
110           FORMAT(F5.2)
              LIN2(103:107)=ORIENT
            ENDIF
          ENDIF
C  PAEOCT
          IF(.NOT.NULL(114)) THEN
            A=ROW(114)
            IF(A.GE.0..AND.A.LE.180.) THEN
              WRITE(ORIENT,111) A
111           FORMAT(F5.1)
              LIN2(109:113)=ORIENT
            ENDIF
          ENDIF
C
C  DENSITY
C  NG_T
          IF(.NOT.NULL(127)) THEN
            A=ROW(127)
            WRITE(DENS,112) A
112         FORMAT(F5.1)
            LIN1(126:130)=DENS
          ENDIF
C  NG_SP
          IF((.NOT.NULL(127)).AND.(.NOT.NULL(131))) THEN
            A=ROW(131)
            WRITE(DENS,112) A
            LIN2(126:130)=DENS
          ENDIF
C
C  GRADIENT
C  EXPO_B
c  changed to oct values
          IF(.NOT.NULL(150)) THEN
            A=ROW(150)
            IF(A.GT.-10..AND.A.LT.10.) THEN
              WRITE(EXPGRA,108) A
108           FORMAT(F6.2)
              LIN1(116:121)=EXPGRA
            ENDIF
          ENDIF
C  EXPO_R
          IF(.NOT.NULL(162)) THEN
            A=ROW(162)
            IF(A.GT.-10..AND.A.LT.10.) THEN
              WRITE(EXPGRA,109) A
109           FORMAT(F6.2)
              LIN2(116:121)=EXPGRA
            ENDIF
          ENDIF
C
C  EXTINCT
C  AEXT
          IF(.NOT.NULL(177)) THEN
            A=ROW(177)
            IF(A.LT.10.) THEN
              WRITE(EXT,114) A
114           FORMAT(F4.2)
              LIN1(135:138)=EXT
            ENDIF
          ENDIF
C  JEXT withdrawn !!!!
c          IF(.NOT.NULL(102)) THEN
c            A=ROW(102)
c            IF(A.LT.10.) THEN
c              WRITE(EXT,114) A
c              LIN2(135:138)=EXT
c            ENDIF
c          ENDIF
C
C  write tex file
C
          WRITE(11,99) LIN1
          WRITE(11,99) LIN2
          IF(N35.NE.35.AND.NSEQ.NE.N2) THEN
            WRITE(11,99) TEX3
          ELSE
            WRITE(11,99) TEX4
            WRITE(11,99) TEX5
            WRITE(11,99) TEX6
          ENDIF
998     CONTINUE
        ENDDO
C 
        IF(N35.NE.35.AND.NSEQ.NE.N2) THEN
          WRITE(11,99) TEX5
          WRITE(11,99) TEX6
        ENDIF
C
999     CONTINUE
        CALL STSEPI
        END

C @(#)ustat.for	19.1 (ES0-DMD) 02/25/03 13:21:23
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C @(#)ustat.for	5.1 (ESO-IPG) 4/5/93 15:15:11
       SUBROUTINE AVEVAR(DATA,N,AVE,VAR)
       INTEGER J,N
       REAL DATA(N),AVE,VAR,S
       AVE = 0.
       VAR = 0.
       DO 10 J = 1,N
           AVE = AVE+DATA(J)
10       CONTINUE
       AVE=AVE/N
       DO 20 J = 1,N
           S = DATA(J) - AVE
           VAR =  VAR+S*S
20       CONTINUE
       VAR = VAR/(N-1)
       RETURN
       END



       SUBROUTINE CRANK(N,W,INDX,IRANK,S)
       INTEGER  N,INDX(N),J,JI,JT
       REAL IRANK(N),W(N),RANK,S,T
       S = 0
       J = 1
1       IF (J.LT.N) THEN
          IF(W(INDX(J)).NE.W(INDX(J+1))) THEN
              IRANK(INDX(J)) = J
              J = J+1
          ELSE
              DO 10 JT = J+1,N
                    IF(W(INDX(JT)).NE.W(INDX(J))) GOTO 20

10            CONTINUE
             JT = N+1
20             RANK = 0.5*(J+JT-1)
             DO 30 JI = J,JT-1
                 IRANK(INDX(JI)) = RANK
30             CONTINUE
             T = JT-J
             S = S + T**3-T
             J = JT
          ENDIF
       GOTO 1
       ENDIF
       IF(J.EQ.N) IRANK(INDX(N)) = N
       RETURN
       END




       SUBROUTINE INDEXX(N,ARRIN,INDX)
       INTEGER J,N,I
       REAL ARRIN(N),Q,INDXT
       INTEGER L,IR,INDX(N)
       DO J=1,N
          INDX(J)=J
       ENDDO
       L = N/2 + 1       
       IR = N
10      CONTINUE
       IF (L.GT.1)THEN
           L = L-1
           INDXT = INDX(L)
           Q = ARRIN(INDX(L))
       ELSE
           INDXT = INDX(IR)
           Q = ARRIN(INDX(IR))
           INDX(IR) = INDX(1)
           IR = IR-1
            IF (IR.EQ.1) THEN
              INDX(1) = INDXT
              RETURN
           ENDIF
       ENDIF       
       I = L
       J = L+L
20      IF (J.LE.IR) THEN
            IF(J.LT.IR)THEN
               IF(ARRIN(INDX(J)).LT.ARRIN(INDX(J+1)))J=J+1
            ENDIF
            IF (Q.LE.ARRIN(INDX(J)))THEN
                INDX(I) = INDX(J)
                I = J
                J = J+J
            ELSE
                J = IR+1
            ENDIF
       GOTO 20
       ENDIF
       INDX(I) = INDXT
       GOTO 10
       END




        SUBROUTINE SORT(LISTE,NBINT)
       INTEGER NBINT,I1,J,I2,JNEW
       REAL LISTE(NBINT)
       J=NBINT-1
2       CONTINUE
           JNEW=0
           DO 3 I1=1,J
              I2=I1+1
              IF(LISTE(I1).LE.LISTE(I2)) GOTO 3
               CALL SWAP(LISTE(I1),LISTE(I2))
               JNEW=I1-1
3           CONTINUE
            J=JNEW
       IF(J.GT.0) GOTO 2
       END

       SUBROUTINE SWAP(C1,C2)
       REAL*4 C1,C2,KAUX
       KAUX=C1
       C1=C2
       C2=KAUX
        END
       
       SUBROUTINE TMAP(TID,NROW,COL,X,NREAL)
       INTEGER TID,NROW,ISTAT,I,COL,NREAL
       LOGICAL NULL,ISEL
       REAL X(NROW)
       NREAL = 0
       DO I=1,NROW
          CALL TBSGET(TID,I,ISEL,ISTAT)
          IF (ISEL)  THEN 
            NREAL = NREAL+1
            CALL TBERDR(TID,I,COL,X(NREAL),NULL,ISTAT)
            IF (NULL) NREAL = NREAL-1
          ENDIF
       ENDDO
       RETURN
       END


       SUBROUTINE TMAP2(TID,NROW,COL1,COL2,X1,X2,NREAL)
       INTEGER TID,NROW,COL1,COL2,ISTAT,I,NREAL
       LOGICAL NULL1,NULL2,ISEL
       REAL*4 X1(NROW),X2(NROW)
       NREAL = 0 
       DO I=1,NROW
          CALL TBSGET(TID,I,ISEL,ISTAT)
          IF (ISEL)  THEN 
            NREAL = NREAL+1
            CALL TBERDR(TID,I,COL1,X1(NREAL),NULL1,ISTAT)
            CALL TBERDR(TID,I,COL2,X2(NREAL),NULL2,ISTAT)
            IF (NULL1 .OR. NULL2) NREAL = NREAL-1 
          ENDIF 
       ENDDO
       RETURN
       END

C @(#)invset.for	19.1 (ES0-DMD) 02/25/03 13:26:21
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C.IDENTIFICATION:  INVSET
C.PURPOSE:         Show the keywords used by inventory and set them to
C                  other different values
C.AUTHOR:          A. Kruszewski
C.LANGUAGE:        F77+ESOext
C.VERSION:         CHO 840522 Creation
C.VERSION:         RHW 871120 ESO-FORTRAN Conversion
C.VERSION:         AK  881213 Changes for the portable version
C.VERSION:         RHW 891214 Combine the SET and SHOW code
C -------------------------------------------------------
      PROGRAM SETINV
C
      IMPLICIT NONE
C
      INTEGER IAC,IST,I,ISTAT,IACT
      INTEGER ANALITER,OUPROFIL,HALFEDGE,FIELDVAR,UNITS
      INTEGER PRFLCTRL,IJBORDER(4),ITERATE(2),BRGTCTRL
      INTEGER ISOPHOTR,MARGINS,FULLPSF,UNDRSMPL
      INTEGER IA(23),IKEYVAL(4),NETHEDGE,SKYDETER
      INTEGER IVAL(44),IPOS(44),KUN,KNUL,PHYSICAL
C
      REAL TRESHOLD,CLASSPAR(3),BRGHTLMT,CUTS(2)
      REAL DISTANCE,EXPRTIME,ZEROMAGN,STMETRIC(2),SPROFIL1(5)
      REAL SPROFIL2(5),SPROFIL3(5),SPROFIL4(5),SPROFIL5(5)
      REAL CTRLMODE,CVFACTOR,SGFACTOR,PAIRSPRT,MULTDTCT
      REAL ELONGLMT,YFACTOR,DFVALLEY,BRIGHTOB
      REAL PRFLCLNG(3),NEBLIMIT,ETAFUNCT
      REAL RKEYVAL(5),A(57),XYBORDER(4)
      REAL FILTER,SKYSAMPL
C
      CHARACTER OPTION1*1,OPTION2*1,CMND*20
      CHARACTER KEYWOR(44)*8,KEYNUM(44)*8
      CHARACTER PROMP1*34,PROMP2*26,PROMP3*24,TEXT*80,STRING*80
C
      DATA KEYWOR/
     +     'OUPROFIL','HALFEDGE','FIELDVAR','PRFLCTRL','UNITS   ',
     +     'ITERATE ','ANALITER','IJBORDER','BRGTCTRL','ISOPHOTR',
     +     'LHCUTS  ','TRESHOLD','CTRLMODE','CVFACTOR','SGFACTOR',
     +     'PAIRSPRT','MULTDTCT','ELONGLMT','YFACTOR ','DFVALLEY',
     +     'BRIGHTOB','PRFLCLNG','EXPRTIME','ZEROMAGN','STMETRIC',
     +     'ETAFUNCT','SPROFIL1','SPROFIL2','BRGHTLMT','DISTANCE',
     +     'CLASSPAR','SPROFIL3','SPROFIL4','SPROFIL5','NEBLIMIT',
     +     'MARGINS ','CLASSPAR','PHYSICAL','XYBORDER','FULLPSF ',
     +     'UNDRSMPL','NETHEDGE','SKYDETER','FILTER  '/
C
      DATA KEYNUM/
     +     '18      ','1       ','16      ','15      ','17      ',
     +     '28      ','33      ','30      ','32      ','34      ',
     +     '35      ','2       ','5       ','6       ','7       ',
     +     '3       ','4       ','8       ','9       ','10      ',
     +     '19      ','20      ','13      ','11      ','12      ',
     +     '14      ','21      ','22      ','26      ','27      ',
     +     '29      ','23      ','24      ','25      ','31      ',
     +     '36      ','37      ','38      ','39      ','40      ',
     +     '41      ','42      ','43      ','44      '/
C
      DATA IVAL/
     +      1, 1, 1, 1, 1,
     +      2, 1, 4, 1, 1,
     +      2, 1, 1, 1, 1,
     +      1, 1, 1, 1, 1,
     +      1, 3, 1, 1, 2,
     +      1, 5, 5, 1, 1,
     +      3, 5, 5, 5, 1,
     +      1, 3, 1, 4, 1,
     +      1, 1, 1, 1/
C
      DATA IPOS/
     +      6, 8, 9,11,10,
     +     17, 2,12,22, 5,
     +      1, 3,39,40,41,
     +     42,43,44,45,46,
     +     47,49,10,11,12,
     +     53,14,19, 8, 9,
     +      5,24,29,34,52,
     +     19, 5, 7,54,20,
     +     21,23,16,4/
C
 9000 FORMAT('LHCUTS   (35)=',2F12.1,'          TRESHOLD ( 2)=',F8.3)
 9010 FORMAT('HALFEDGE ( 1)=',I4,'      PAIRSPRT ( 3)=',F7.2,'   MULT',   
     &       'DTCT ( 4)=',F7.2)
 9020 FORMAT('HALFEDGE ( 1)=',I4,'     PAIRSPRT ( 3)=',F7.2,'    ANAL',
     &       'ITER (33)=',I4)
 9030 FORMAT('EXPRTIME (13)=',F10.3,'    STMETRIC (12)=',2F7.2)
 9040 FORMAT('PRFLCTRL (15)=',I4,'     CLASSPAR (37)=',F7.2,'    ZERO',
     &       'MAGN (11)=',F7.2)
 9050 FORMAT('CTRLMODE ( 5)=',F7.2,'   CVFACTOR ( 6)=',F7.2,'   SGF',
     +       'ACTOR ( 7)=',F7.2)
 9060 FORMAT('ELONGLMT ( 8)=',F7.2,'   YFACTOR  ( 9)=',F7.2,'   DFV',
     +       'ALLEY (10)=',F7.2)
 9070 FORMAT('FILTER   (44)=',F7.2,'   UNITS    (17)=',I4,'      MAR',
     &       'GINS  (36)=',I4)
 9080 FORMAT('FULLPSF  (40)=',I4,'      UNDRSMPL (41)=',I4,'      OUP',
     &       'ROFIL (18)=',I4)
 9090 FORMAT('BRIGHTOB (19)=',F7.2,'   PRFLCLNG (20)=',3F7.2)
 9095 FORMAT('ISOPHOTR (34)=',I4,'      ETAFUNCT (14)=',F7.2,'   NEB',
     &       'LIMIT (31)=',F7.2)
 9100 FORMAT('SPROFIL1 (21)=',5F8.3)
 9110 FORMAT('SPROFIL2 (22)=',5F8.3)
 9120 FORMAT('SPROFIL3 (23)=',5F8.3)
 9130 FORMAT('SPROFIL4 (24)=',5F8.3)
 9140 FORMAT('SPROFIL5 (25)=',5F8.3)
 9150 FORMAT('TRESHOLD ( 2)=',F6.2,'    BRGHTLMT (26)=',F6.2,'    DIS',
     +       'TANCE (27)=',F6.2)
 9160 FORMAT('ITERATE (28)=',2I6,'    CLASSPAR (29)=',3F7.2)
 9170 FORMAT('Enter ',I1,' integer value(s): ')
 9180 FORMAT('Enter ',I2,' real value(s): ')
 9190 FORMAT('PHYSICAL (38)=',I4,'      IJBORDER (30)=',4I6)
 9200 FORMAT('XYBORDER (39)=',4F10.2)
 9210 FORMAT('BRGTCTRL (32)=',I4,'      NETHEDGE (42)=',I4,'      SKY',
     &       'DETER (43)=',I4)
 9220 FORMAT('FILTER   (44)=',F7.2,'   MARGINS  (36)=',I4,'      FIEL',
     &       'DVAR (16)=',I4)
C
C *** do the work
C
      CALL STSPRO('SETINV')
      CALL STKRDC('MID$CMND',1,1,20,IAC,CMND,KUN,KNUL,IST)
C
C *** read option1 in INPUTC/C/1/1
C
      CALL STKRDC('INPUTC',1,1,1,IAC,OPTION1,KUN,KNUL,IST)
      IF ((OPTION1.NE.'S') .AND. (OPTION1.NE.'s' ) .AND.
     &    (OPTION1 .NE. 'A') .AND. (OPTION1 .NE. 'a') .AND.
     &    (OPTION1 .NE. 'C') .AND. (OPTION1 .NE. 'c')) THEN
          CALL STTPUT(
     &          '*** FATAL: Option "S" or "A" or "C" is missing',IST)
          CALL STSEPI
      END IF

      CALL STKRDC('INPUTC',1,2,1,IAC,OPTION2,KUN,KNUL,IST)
C
C *** read keywords INV_INTG and INV_REAL
C
      CALL STKRDI('INV_INTG',1,23,IAC,IA,KUN,KNUL,IST)
      CALL STKRDR('INV_REAL',1,57,IAC,A,KUN,KNUL,IST)
C
C *** store the integer keywords of inventory
C
      ANALITER = IA(2)
      ISOPHOTR = IA(5)
      OUPROFIL = IA(6)
      PHYSICAL = IA(7)
      HALFEDGE = IA(8)
      FIELDVAR = IA(9)
      UNITS    = IA(10)
      PRFLCTRL = IA(11)
      DO 10 I = 1,4
          IJBORDER(I) = IA(11+I)
   10 CONTINUE
      SKYDETER   = IA(16)
      ITERATE(1) = IA(17)
      ITERATE(2) = IA(18)
      MARGINS    = IA(19)
      FULLPSF    = IA(20)
      UNDRSMPL   = IA(21)
      BRGTCTRL   = IA(22)
      NETHEDGE   = IA(23)
C
C *** store the real keywords of inventory
C
      CUTS(1)     = A(1)
      CUTS(2)     = A(2)
      TRESHOLD    = A(3)
      FILTER      = A(4)
      CLASSPAR(1) = A(5)
      CLASSPAR(2) = A(6)
      CLASSPAR(3) = A(7)
      BRGHTLMT    = A(8)
      DISTANCE    = A(9)
      EXPRTIME    = A(10)
      ZEROMAGN    = A(11)
      STMETRIC(1) = A(12)
      STMETRIC(2) = A(13)
      DO 20 I = 1,5
         SPROFIL1(I) = A(13+I)
         SPROFIL2(I) = A(18+I)
         SPROFIL3(I) = A(23+I)
         SPROFIL4(I) = A(28+I)
         SPROFIL5(I) = A(33+I)
   20 CONTINUE
      CTRLMODE    = A(39)
      CVFACTOR    = A(40)
      SGFACTOR    = A(41)
      PAIRSPRT    = A(42)
      MULTDTCT    = A(43)
      ELONGLMT    = A(44)
      YFACTOR     = A(45)
      DFVALLEY    = A(46)
      BRIGHTOB    = A(47)
      SKYSAMPL    = A(48)
      PRFLCLNG(1) = A(49)
      PRFLCLNG(2) = A(50)
      PRFLCLNG(3) = A(51)
      NEBLIMIT    = A(52)
      ETAFUNCT    = A(53)
      XYBORDER(1) = A(54)
      XYBORDER(2) = A(55)
      XYBORDER(3) = A(56)
      XYBORDER(4) = A(57)
C
C *** write the keyword contents according to the option
C
      IF (OPTION1.EQ.'S' .OR. OPTION1.EQ.'s' ) THEN
         WRITE (TEXT,9000) CUTS,TRESHOLD
         CALL STTPUT(TEXT,IST)
         WRITE (TEXT,9010) HALFEDGE,PAIRSPRT,MULTDTCT
         CALL STTPUT(TEXT,IST)
         WRITE ( TEXT , 9210 ) BRGTCTRL,NETHEDGE,SKYDETER
         CALL STTPUT( TEXT , IST )
         WRITE ( TEXT , 9220 ) FILTER,MARGINS, FIELDVAR
         CALL STTPUT( TEXT , IST )
         TEXT   = ' '
         CALL STTPUT(TEXT,IST)
C
         IF (OPTION2.EQ.'A' .OR. OPTION2.EQ.'a' ) THEN
            WRITE ( TEXT , 9190 ) PHYSICAL , IJBORDER
            CALL STTPUT( TEXT , IST )
            WRITE ( TEXT , 9200 ) XYBORDER
            CALL STTPUT( TEXT , IST )
            WRITE (TEXT,9050) CTRLMODE,CVFACTOR,SGFACTOR
            CALL STTPUT(TEXT,IST)
            WRITE (TEXT,9060) ELONGLMT,YFACTOR,DFVALLEY
            CALL STTPUT(TEXT,IST)
            TEXT   = ' '
            CALL STTPUT(TEXT,IST)
         END IF
C
      ELSE IF (OPTION1.EQ.'A' .OR. OPTION1.EQ.'a' ) THEN
         WRITE (TEXT,9000) CUTS,TRESHOLD
         CALL STTPUT(TEXT,IST)
         WRITE (TEXT,9020) HALFEDGE,PAIRSPRT,ANALITER
         CALL STTPUT(TEXT,IST)
         WRITE (TEXT,9040) PRFLCTRL,CLASSPAR(1),ZEROMAGN
         CALL STTPUT(TEXT,IST)
         WRITE (TEXT,9030) EXPRTIME,STMETRIC
         CALL STTPUT(TEXT,IST)
         WRITE (TEXT,9070) FILTER,UNITS,MARGINS
         CALL STTPUT( TEXT , IST )
         TEXT   = ' '
         CALL STTPUT(TEXT,IST)
C
         IF (OPTION2.EQ.'A' .OR. OPTION2.EQ.'a' ) THEN
            WRITE (TEXT,9080) FULLPSF,UNDRSMPL,OUPROFIL
            CALL STTPUT(TEXT,IST)
            WRITE ( TEXT , 9190 ) PHYSICAL , IJBORDER
            CALL STTPUT( TEXT , IST )
            WRITE ( TEXT , 9200 ) XYBORDER
            CALL STTPUT( TEXT , IST )
            WRITE (TEXT,9090) BRIGHTOB,PRFLCLNG
            CALL STTPUT(TEXT,IST)
            WRITE (TEXT,9095) ISOPHOTR,ETAFUNCT,NEBLIMIT
            CALL STTPUT(TEXT,IST)
            WRITE (TEXT,9100) SPROFIL1
            CALL STTPUT(TEXT,IST)
            WRITE (TEXT,9110) SPROFIL2
            CALL STTPUT(TEXT,IST)
            WRITE (TEXT,9120) SPROFIL3
            CALL STTPUT(TEXT,IST)
            WRITE (TEXT,9130) SPROFIL4
            CALL STTPUT(TEXT,IST)
            WRITE (TEXT,9140) SPROFIL5
            CALL STTPUT(TEXT,IST)
            TEXT   = ' '
            CALL STTPUT(TEXT,IST)
         END IF
C
      ELSE IF (OPTION1.EQ.'C' .OR. OPTION1.EQ.'c' ) THEN
         WRITE (TEXT,9150) TRESHOLD,BRGHTLMT,DISTANCE
         CALL STTPUT(TEXT,IST)
         WRITE (TEXT,9160) ITERATE,CLASSPAR
         CALL STTPUT(TEXT,IST)
         TEXT   = ' '
         CALL STTPUT(TEXT,IST)
C
      ELSE
         CALL STTPUT('*** FATAL: Unknown parameter as input',ISTAT)
         CALL STSEPI
      END IF
C
C *** if command is SET/INV read new values of inventory keyword ***
C
      IF (CMND(1:3).EQ.'SET') THEN
   30    CONTINUE
         STRING(1:) = ' '
         PROMP1 = 'Enter the keyword name or number: '
         CALL STKPRC(PROMP1,'INPUTC',1,1,20,IACT,STRING,
     2               KUN,KNUL,ISTAT)
C
         IF (STRING.EQ.' ') THEN
            CALL STSEPI
         ELSE
            DO 40 I = 1,44
               IF (STRING(1:8).EQ.KEYWOR(I) (1:8) .OR. STRING(1:8).EQ.
     +            KEYNUM(I) (1:8)) THEN
                  IF ( I .LE. 10 .OR. I .EQ. 36 .OR. I .EQ. 38
     &                        .OR. ( I .GT. 39 .AND. I .LT. 44 ) ) THEN
                     WRITE (PROMP2,9170) IVAL(I)
                     CALL STKPRI(PROMP2,'INPUTI',1,IVAL(I),IACT,
     +                           IKEYVAL,KUN,KNUL,ISTAT)
                     CALL STKWRI('INV_INTG',IKEYVAL,IPOS(I),
     +                           IVAL(I),KUN,IST)

                  ELSE
                     WRITE(PROMP3,9180) IVAL(I)
                     CALL STKPRR(PROMP3,'INPUTR',1,IVAL(I),IACT,
     +                           RKEYVAL,KUN,KNUL,ISTAT)
                     CALL STKWRR('INV_REAL',RKEYVAL,IPOS(I),
     +                           IVAL(I),KUN,IST)
                  END IF
                  GO TO 30
               END IF

   40       CONTINUE
            CALL STTPUT('*** WARNING: Illegal keyword or '//
     +                  'number; try again ...',ISTAT)
            GO TO 30
         END IF
       ENDIF
C
      CALL STSEPI
      END

C @(#)dgamma.for	19.1 (ES0-DMD) 02/25/03 13:17:29
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
       DOUBLE PRECISION FUNCTION DGAMMA(W)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C M. Rosa ST-ECF ESO Garching 11-12-87
C      IMPLICIT NONE
C
C Double Precision Gamma-Function (15 digits) using modified version
C of Comm. ACM algorithm No 309 "Gamma function with arbitrary precision"
C by Souza and Schwachheim, CAMC Vol. 10, p. 511, 1967.
C
C Def.   Gamma(x+1) = x!  fuer alle x, X.NEQ.-1 ;  0! = 1.0
C
C  Note: 1. The Coefficients C(i) are given as irreducible fractions so that
C          accuracy is automatically machine appropriate.
C           (The original article uses 20 coefficients to obtain an accuracy
C          of up to  50 digits.
C
C       2. The routine evaluates LOG(Gamma(w)). It might be preferred to
C          pass LOGGAMMA instead of exp(LOGGAMMA) to avoid additional
C          inaccuracies. (For example if 1/DGAMMA is needed, EXP(-LOGGAMMA)
C          would do at once.
C
C ---------------------------------------------------------------------
C
      INTEGER I
      REAL W2
      DOUBLE PRECISION W
      DOUBLE PRECISION F,DEN,S,C0,C(10),PS
      DATA C0/0.9189385332046727417803D0/
C
      C(1)   = 1.D0/12.D0
      C(2)   = -1.D0/360.D0
      C(3)   = 1.D0/1260.D0
      C(4)   = -1.D0/1680.D0
      C(5)   = 1.D0/1188.D0
      C(6)   = -691.D0/360360.D0
      C(7)   = 1.D0/156.D0
      C(8)   = -3617.D0/122400.D0
      C(9)   = 43867.D0/244188.D0
      C(10)  = -174611.D0/125400.D0
C
      IF (W.LE.7.0D0) THEN
          F      = W
   10     W      = W + 1.0D0
          IF (W.LT.7.0D0) THEN
              F      = F*W
              GO TO 10

          END IF

          F      = -DLOG(F)

      ELSE
          F      = 0.0D0
      END IF
C
      DEN    = W
      W2     = W*W
      PS     = (W-0.5D0)*DLOG(W) - W + C0
      DO 20 I = 1,10
          S      = PS + C(I)/DEN
          IF (S.EQ.PS) GO TO 30
          DEN    = DEN*W2
          PS     = S
   20 CONTINUE
   30 S      = S + F
C
      DGAMMA = DEXP(S)
      END

C @(#)irsshift.for	19.1 (ESO-DMD) 02/25/03 14:23:43
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.COPYRIGHT   (C) 1992 European Southern Observatory
C.IDENT       irsshift.for
C.AUTHOR      E. Oliva,  Firenze-Arcetri
C.KEYWORDS    Spectroscopy, IRSPEC
C
C.PURPOSE     Shift a frame in X by a given number of pixels.
C
C.ALGORITHM   Simple.
C
C
C.INPUT/OUTPUT
C
C
C.VERSION     1.0    Creation     28.09.1992   E. Oliva
C 
C 021031	last modif
C
C-------------------------------------------------------
C
      PROGRAM SKYBUB
      IMPLICIT REAL(A-H,O-Z)
      IMPLICIT INTEGER(I-N)
      
      CHARACTER*64 CUNIT
      CHARACTER*72 IDENT
      CHARACTER*60 FIN,FOUT
      COMMON /VMR/ MADRID(1)
      INTEGER NPIX(3)
      INTEGER*8 INPNTR,OUPNTR
      DOUBLE PRECISION START(3),STEP(3)
     

      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'

      DATA MAXDIM/2/

      IRET=1
      CALL STSPRO('SHIFT')
C
C Input frame.
C
CC      CALL STKRDC('fin',1,1,60,IRET,FOBJ,KUNIT,KNUL,ISTAT)
      CALL CLNFRA('&fs',FIN,0)
      CALL STIGET(FIN,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,MAXDIM,
     ,            NAXIS,NPIX,START,STEP,
     ,            IDENT,CUNIT,INPNTR,NOBJ,ISTAT)
      NX=NPIX(1)
      NY=NPIX(2)
C
C Output frame
C
CC      CALL STKRDC('fout',1,1,60,IRET,FOUT,KUNIT,KNUL,ISTAT)
      CALL CLNFRA('&fr',FOUT,0)
      CALL STIPUT(FOUT,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     ,            NAXIS,NPIX,START,STEP,
     ,            IDENT,CUNIT,OUPNTR,NOUT,ISTAT)
C
C Get value of shift (in pixels)
C
      CALL STKRDR('shift',1,1,IRET,SHIFT,KUNIT,KNUL,ISTAT)
C
C Call routine which shifts
C
      CALL SH(MADRID(INPNTR),MADRID(OUPNTR),NX,NY,SHIFT)
C
C RELEASE FILES, UPDATE KEYWORDS AND EXIT
C
      CALL STSEPI
      END
C
C
C
      SUBROUTINE SH(A,B,NX,NY,SHIFT)
C
      IMPLICIT REAL(A-H,O-Z)
      IMPLICIT INTEGER(I-N)

      DIMENSION A(NX,NY),B(NX,NY)
C
      IF(SHIFT.EQ.0.0) RETURN
C
      DO IY=1,NY
        DO IX=1,NX
          A1=FLOAT(IX)+SHIFT
          IA1=AINT(A1)
          IF(A1.LT.0.) IA1=IA1-1
          IF(IA1.LT.1) THEN
            B(IX,IY)=A(1,IY)
            GO TO 10
          ENDIF
          IF(IA1.GT.NX) THEN
            B(IX,IY)=A(NX,IY)
            GO TO 10
          ENDIF
          W1=1-A1+FLOAT(IA1)
          IA2=IA1+1
          W2=1.-W1
          X1=A(IA1,IY)
          X2=A(IA2,IY)
          B(IX,IY)=W1*X1+W2*X2
10        CONTINUE
        ENDDO
      ENDDO

      RETURN
      END

C @(#)rea.for	19.1 (ESO-IPG) 02/25/03 13:28:06

C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C       Internet e-mail: midas@eso.org
C       Postal address: European Southern Observatory
C                       Data Management Division 
C                       Karl-Schwarzschild-Strasse 2
C                       D 85748 Garching bei Muenchen 
C                       GERMANY
C===========================================================================
C
C

C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
      SUBROUTINE  ReaSpe(NomSpe,n)
C     
C        Legge file contenente lo spettro da analizzare.
C     
C     NomSpe       (input):         Nome del file da aprire
C     n            (in/out):        In input: dimensione di alam e smod
C     in output: n. di punti letti.
C     Se < 0 errore di lettura.
C     
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
      
      implicit none
      character*(*) NomSpe
      integer n
      
      include 'MID_REL_INCL:fit_var.inc'
      integer iread,istat,is,k
      integer TABID,ColTab(10)
      DOUBLE PRECISION val(5)
      character*70 Mes
      integer irr,nj,i1,i2,i3,i4
      logical ilog(5),ipix

C      include 'MID_REL_INCL:fit_mid.inc'
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'


c     Open table
      call TBTOPN(NomSpe,F_IO_MODE,TABID,Istat)
      if (istat.ne.0) then 
         n=-istat
         write(Mes,*)n
         call sttdis(Mes,0,is)
         return
      end if
      call TBIGET(TABID,i1,nj,i2,i3,i4,irr)

c     Find columns
      i1=1                      !doesn't stop on errors
      i2=0
      i3=0
      call STECNT('PUT',i1,i2,i3)

      call TBLSER(TABID,'WAVE',ColTab(1),istat)
      if (istat .ne. 0) then
         call ErrMsg('Column WAVE not found - Aborting')
         n=-1
         return
      endif

      call TBLSER(TABID,'NORMFLUX',ColTab(2),istat)        
      if (istat .ne. 0) then
         call ErrMsg('Column NORMFLUX not found - Aborting')
         n=-2
         return
      endif

      call TBLSER(TABID,'STDEV',ColTab(3),istat)
      if (istat .ne. 0) then
         call ErrMsg('Column STDEV not found - Aborting')
         n=-3
         return
      endif

      call TBLSER(TABID,'FWHM',ColTab(4),istat)
      if (istat .ne. 0) then
         call ErrMsg('Column FWHM not found - Aborting')
         n=-4
         return
      endif

      call TBLSER(TABID,'PIXSIZE',ColTab(5),istat)
      ipix=.true.
      if (ColTab(5) .lt. 0) then
         ipix=.false.
         call WrnMsg('Column PIXSIZE not found - I will compute them')
      endif

                                ! READ DATA
      iread=0
      do irr = 1 , nj
         if (ipix) call TBRRDD(TABID,irr,5,ColTab,val,ilog,istat)
         if (.not.ipix) call TBRRDD(TABID,irr,4,ColTab,val,ilog,istat)
         if(ilog(1).or.ilog(2).or.ilog(3).or.ilog(4)) then
            continue
         else
            iread=iread+1
            XLAMBD(iread) = val(1)
            SPECTR(iread) = val(2)
            SIGNOI(iread) = val(3)
            FWHM(iread) = val(4)
            if (ipix) PIXSIZ(iread) = val(5)
         end if
         if (iread.eq.n) goto 101
      end do


 101  continue
      if (iread.eq.n) then
         Mes='****************** WARNING **********************'
         call DisMsg(Mes)
         Mes='*  Too many data for this program configuration'
         call DisMsg(Mes)
         Mes=' '
         call DisMsg(Mes)
         write(Mes,*)'*  Acquisition stopped after',iread,
     1        ' points.'
         call DisMsg(Mes)
         Mes=' '
         call DisMsg(Mes)
         Mes='*  Re-compile program to enlarge storage'
         call DisMsg(Mes)
         Mes='*************************************************'
         call DisMsg(Mes)         
      end if

      n=iread
      call TBTCLO(TABID,istat)

      do k = 1,n
         CONTIN(k) = 1.
         SKYLEV(k) = 0.
      end do      

      if (.not.ipix) then
         PIXSIZ(1) = XLAMBD(2) - XLAMBD(1)
         PIXSIZ(n) = XLAMBD(n) - XLAMBD(n-1)
         do irr = 2,n-1
            PIXSIZ(irr)= (XLAMBD(irr+1) - XLAMBD(irr-1))/2.
         enddo
      endif
      
      i1=0                      !stops on errors
      i2=2
      i3=1
      call STECNT('PUT',i1,i2,i3)

      return
      end

C @(#)radcor.for	19.1 (ES0-DMD) 02/25/03 13:25:37
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine RADCOR         version 1.2        870729
C  A. Kruszewski             ESO Garching
C.PURPOSE
C  Correct different radial size parameters and isophotal magnitude
C  for influence of brightness dependent finite size of the used image.
C  A stellar object is assumed.
C  This subroutine should remove any brightness dependence of
C  corrected radial size parameters and isophotal magnitudes
C  for stellar objects.
C  It is irrelevant for galaxies.
C  It work for unsaturated objects only.
C.INPUT/OUTPUT
C  input arguments
C  PMTR        real*4 array      array holding classifiers
C  M           integer*4         number of objects
C  STPR        real*4 array      one-dimensional point spread function
C                                of stallar objects
C  TRSH        real*4            detection treshold
C  output arguments
C  PCLA        real*4 array      array holding corrected classifiers
C-----------------------------------------------------------------------
      SUBROUTINE RADCOR(PMTR,PCLA,M,STPR,TRSH)
C
      IMPLICIT NONE
      INCLUDE 'MID_REL_INCL:INVENT.INC/NOLIST'
C
      REAL     PMTR(30,MAXCNT)
      REAL     PCLA(0:13,MAXCNT)
      INTEGER  M
      REAL     STPR(MAXCNT)
      REAL     TRSH
C
      INTEGER  I, IR, IT
      INTEGER  J
      INTEGER  NPXL(0:MAXSUB)
C
      REAL     TEMP
      REAL     FI, FRCT
      REAL     SPIU(0:MAXSUB)
      REAL     DIF1, DIF2
      REAL     ALIM
      REAL     CTRS, CR, CM
      REAL     CMAG(0:100)
      REAL     CRAD(0:100),AIN0(0:MAXSUB)
      REAL     AIN1(0:MAXSUB),AIN2(0:MAXSUB),AINK(0:MAXSUB)
C
      DATA NPXL/1,8,12,16,32,28,40,40,48,68,56,72,68,88,88,84,112,112,
     +     112,116,112,144,140,144,144,168,164,160,184,172,200,192,188,
     +     208,224,224,228,224,248,236,264,248,264,276,264,288,276,304,
     +     304,312,316/
C
C     Transforms the differential logarithmic
C *** point spread function STPR into profile
C     in intensity units SPIU.
C
      SPIU(0) = 1.0
      DO 10 I = 1,50
          SPIU(I) = SPIU(I-1)* (10.0** (-STPR(I)))
   10 CONTINUE
C
C *** Calculates integrated quantities.
C
      AIN0(0) = 1.0
      AIN1(0) = 0.333
      AIN2(0) = 0.1
      AINK(0) = 10.0
      DO 20 I = 1,50
          TEMP   = SPIU(I)*NPXL(I)
          AIN0(I) = AIN0(I-1) + TEMP
          AIN1(I) = AIN1(I-1) + TEMP*I
          AIN2(I) = AIN2(I-1) + TEMP*I*I
          AINK(I) = AINK(I-1) + TEMP/ (I*I)
   20 CONTINUE
      DO 30 I = 0,50
          AIN1(I) = AIN1(I)/AIN0(I)
          AIN2(I) = AIN2(I)/AIN0(I)
          AINK(I) = AINK(I)/AIN0(I)
   30 CONTINUE
      DO 40 I = 0,50
          AIN1(I) = AIN1(25)/AIN1(I)
          AIN2(I) = AIN2(25)/AIN2(I)
          AIN2(I) = AIN2(I)**0.5
          AINK(I) = AINK(25)/AINK(I)
          AINK(I) = AINK(I)**(-0.5)
   40 CONTINUE
C
C *** Correct following parameters: "RADIUS1", "RADIUS2","KRON RADIUS".
C
      DO 50 I = 1,M
C
C *** Store value of the limiting radius in variable TEMP.
          TEMP   = PMTR(15,I)
          IR     = INT(TEMP)
          FRCT   = TEMP - IR
C
C *** Apply the corrections.
C
          PCLA(4,I)  = PMTR(6,I)*  
     2                 (AIN1(IR)* (1.0-FRCT)+AIN1(IR+1)*FRCT)
          PCLA(5,I)  = PMTR(7,I)*  
     2                 (AIN2(IR)* (1.0-FRCT)+AIN2(IR+1)*FRCT)
          PCLA(12,I) = PMTR(18,I)* 
     2                 (AINK(IR)* (1.0-FRCT)+AINK(IR+1)*FRCT)
   50 CONTINUE
C
C     Corrects parameters: "ISOPHOTAL MAGNITUDE", "LIMITING RADIUS".
C     it takes into account that the stellar profile is cut by
C     limiting treshold in a different way depending on stellar
C *** brightness. Average of 9 central pixels is taken as a 
C     measure of stellar brightness. Stellar profile is cut 
C     horizontally by 100 eqidistant levels. Corrections are
C     calculated for each level and stored in arrays CMAG and 
C     CRAD. Linear interpolation is used.
C
      DO 80 I = 1,100
          J      = 0
          CMAG(I) = 0.0
          CRAD(I) = 0.0
          FI     = FLOAT(I)
          ALIM   = (100.0-FI)*0.01
   60     CONTINUE
              IF ( .NOT. (SPIU(J).GT.ALIM) ) GO TO 70
              CMAG(I) = CMAG(I) + SPIU(J)*NPXL(J)
              J = J + 1
              IF (J.GT.50) THEN
                 J = 50
              ELSE
                GO TO 60
              ENDIF
   70     CONTINUE
          DIF1   = SPIU(J-1) - ALIM
          DIF2   = SPIU(J-1) - SPIU(J)
          IF (DIF1.GT.0.0001 .AND. DIF2.GT.0.0001) THEN
              FRCT   = DIF1/DIF2
          ELSE
              FRCT   = 0.0
          END IF

          IF (FRCT.GT.1.0) THEN
              FRCT   = 1.0
          END IF

          CMAG(I) = CMAG(I) + FRCT*SPIU(J)*NPXL(J)
          CRAD(I) = J - 1 + FRCT
   80 CONTINUE
C
      DO 90 I = 1,100
          CMAG(I) = 2.5*LOG10(CMAG(I)/CMAG(100))
          CRAD(I) = CRAD(99) - CRAD(I)
   90 CONTINUE
C
      CMAG(0) = 3.0*CMAG(1) - 2.0*CMAG(2)
      CRAD(0) = 3.0*CRAD(1) - 2.0*CRAD(2)
      CTRS   = (SPIU(0)+8.0*SPIU(1))* (TRSH/9)
      DO 100 I = 1,M
          IF (PMTR(2,I).GT.TRSH) THEN
              TEMP   = (1.0-CTRS/PMTR(2,I))*100.0
              IT     = INT(TEMP)
              FRCT   = TEMP - IT
              CM     = CMAG(IT)* (1.0-FRCT) + CMAG(IT+1)*FRCT
              IF (IT.EQ.99) THEN
                  CR     = 0.0

              ELSE
                  CR     = CRAD(IT)* (1.0-FRCT) + CRAD(IT+1)*FRCT
              END IF

          ELSE
              CM     = 0.0
              CR     = 0.0
          END IF

          PCLA(3,I) = PMTR(5,I) + CM
          PCLA(9,I) = PMTR(15,I) + CR
  100 CONTINUE
C
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2011 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C

      PROGRAM REFRAC

C****************************************************************************
C*                                                                          *
C*   Usage:   @@ P2:REFRAC infile outfile                                   *
C*                                                                          *
C*            This program can only be used in MIDAS in interactive mode    *
C*            (graphic window must have been opened)                        *
C*                                                                          *
C*                                                                          *
C*   Description:                                                           *
C*                                                                          *
C*   This program calculates the atmosperic differential refraction         *
C*   and the light losses of the observed spectra depending on the          *
C*   airmass. The input file is the observed spectra, the output file       *
C*   the calculated spectra which would have been obtained without any      *
C*   light losses (atm.refraction, seeing, slit width).                     *
C*   The parallactic angel (slit/elongated aperture perpendicular to horizon*
C*   will be calculated at any given time. Using this angle at observation  *
C*   ligth losses will be minimized.                                        *
C*                                                                          *
C*   See also the documentation below the subroutine CALCREC in this file   *
C*   as well as the documentation file REFRAC.DOC                           *
C*                                                                          *
C*   VERSION       DATE          AUTHOR                                     *
C*   ------------------------------------------------------------------------ 
C*     1.0        Jan'94        P.W.A. GOERDT                               *
C*                                                                          *
C 
C 110504	last modif
C 
C****************************************************************************
C         
      IMPLICIT NONE
C      
      INTEGER   ISTAT,NAXISA,NPIXA(2),MODE
      INTEGER   MADRID(1),UNIT,KNUL,ACTS
      INTEGER*8 PNTRA,PNTRB
      INTEGER   IMNOA,IMNOB,CUNITA
C
      DOUBLE PRECISION STARTA(2),STEPA(2)
C
      REAL   WAVE(200000),FAKTOR(200000)
C
      CHARACTER*60 FRAMEA,FRAMEB, CMODE
      CHARACTER*72 IDENTA
      CHARACTER*80 STRING
C
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON /VMR/ MADRID
      COMMON /MYMOD/ MODE
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C  INITIALLISIEREN
      CALL STSPRO('REFRAC')
C
C  GET NAME OF INPUT FILE
      CALL STKRDC('IN_A',1,1,60,ACTS,FRAMEA,UNIT,KNUL,ISTAT)
      CALL STKRDC('IN_B',1,1,60,ACTS,CMODE,UNIT,KNUL,ISTAT)
      CALL STKRDC('OUT_A',1,1,60,ACTS,FRAMEB,UNIT,KNUL,ISTAT)
C
C
      MODE = 0
      WRITE(STRING,9099) CMODE
      IF (CMODE(1:1) .EQ. 'A') MODE = 1
C
C  OPEN INPUT IMAGE NAME
      CALL STIGET (FRAMEA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,2,NAXISA,      
     &             NPIXA,STARTA,STEPA,IDENTA,CUNITA,PNTRA,IMNOA,ISTAT) 
C
C  CHECK IMAGE TYPE
      IF(NAXISA.NE.1) CALL STETER(1,'WRONG IMAGE TYPE!! ')
C
C  CALCULATION OF ATMOSPHERIC REFRACTION
      CALL CALCREC(STARTA(1),STEPA(1),NPIXA(1),WAVE,FAKTOR)
C    
C  CREATE NEW FRAMES
      CALL STIPUT (FRAMEB,D_R4_FORMAT,F_IO_MODE,F_IMA_TYPE,1,NPIXA,
     &             STARTA,STEPA,IDENTA,CUNITA,PNTRB,IMNOB,ISTAT)
C
C  FILL FRAMES WITH VALUES MULTIPLIED BY FAKTOR
       CALL FRAMFILL (MADRID(PNTRA),MADRID(PNTRB),NPIXA,FAKTOR)    
C
C  Disconnect from MIDAS enviroment and release keywords
      CALL STSEPI       
C 
9099  FORMAT('CMODE=',A)
C 
      END


      SUBROUTINE FRAMFILL(A,B,NPIX,FAKTOR)
C         
      REAL A(1),B(1),FAKTOR(*)
      INTEGER NPIX(2),I
C
C  POINTER CALCULATION
      DO 200 I=1,NPIX(1)
        IF (FAKTOR(I).LT.1E-4) THEN
          CALL STETER(9,'Error: Division by a too small value')
         ENDIF
        B(I)=A(I) / FAKTOR(I)
 200  CONTINUE
C
C
      RETURN
      END 

      SUBROUTINE CALCREC(START,STEP,NPIX,WAVE,RFLUX)
      IMPLICIT INTEGER(I-N)
      IMPLICIT REAL(A-H,O-Z)
      EXTERNAL GAUSS
************************************************************************
*                                                                      *
*  Written by P.W.Alexander Goerdt, Goettingen (FRG), 1994             *
*                                                                      *
*  This program calculates the differentiel atmospheric refraction     *
*  depending on the zenith distance of the targets.                    *
*  The difference DELTA (in arcsec) of a given wavelength will be      *
*  computed as well as the parallactic angle of the slit (degree),     *
*  which can be rotated to be perpendicular to the horizon             *
*  (North--South = 0.), to get the whole wavelength region of the      *
*  light source into the slit.                                         *  
*  Input data are the slit size (in arcsec) and the astronomical       * 
*  angle you have observed the object with and the seeing.             *
*  Hence the flux we will get from a point source observed with a given*
*  angle will be integrated.                                           *
*                                                                      *
*  References :                                                        *
*        1) C.W. Allen, Astrophy. Quantities 3rd edition, p.118ff      *
*        2) De Ball, Lehrbuch d. sph. Astronomie, Leipzig 1912, p.46   *
*        3) Duffett-Smith, Practical astr. with your calculater        *
*        4) Filippenko, A., P.A.S.P.(1982), Vol. 94, p.715             *
************************************************************************
      DOUBLE PRECISION BRECH(2),BLAM,BLHT,BALL,BALLN,DATEJUL,LSTD
      DOUBLE PRECISION PI,LTR,DECR,RECR,PHR,XLONG,ZENIT
      DOUBLE PRECISION START,STEP,XLAMBDA
      REAL ABWEICH(200000)
      REAL RFLUX(*),WAVE(*)
      CHARACTER*80 STRING

      COMMON /MYMOD/ MODE
      PI = ACOS(-1.D0)
      IZAHL = 0
 90   CALL STTPUT(' ',ISTAT)
      CALL STTPUT('Select the unit of your input wavelength!',ISTAT)
      CALL STTPUT( '     UNIT                      PRESS   ',ISTAT)
      CALL STTPUT( '   [ANGSTROM]  (10**-10m)        1     ',ISTAT)
      CALL STTPUT( '      [nm]     (10** -9m)        2     ',ISTAT)
      CALL STTPUT( '    [METER]          (1m)        3     ',ISTAT)
      CALL STTPUT( '  Other Unit          (?)        4     ',ISTAT)
      STRING(1:) = 'This program is only valid in the optical '//
     +             'wavelength region!'
      CALL GETI(STRING,IUNIT,MODE,1)
      IF(IUNIT.EQ.1) THEN
         WUNIT = 1.
      ELSEIF(IUNIT.EQ.2) THEN
         WUNIT = 10.
      ELSEIF(IUNIT.EQ.3) THEN
         WUNIT = 10.E10
      ELSEIF(IUNIT.EQ.4) THEN
      CALL STTPUT('INPUT ONLY THE EXPONENT OF THE REQUIRED UNIT',ISTAT)  
      CALL GETI(' e.g.: km: PRESS 3  (1km = 10**3m)',IEXPO,MODE,2)
         WUNIT = 10**(IEXPO+10)
      ELSE
         CALL STTPUT(' WRONG INPUT !  TRY AGAIN ',ISTAT)
         GOTO 90
      ENDIF
      CALL INORT(ALTI,TEMP,WDD,PHG,XLONG)
      CALL INOBS(RECH,DECG,SIGMA,WAVENORM,XSLIT,YSLIT,ANGLE)
      CALL INDATE(JAHR,MONAT,NTAG,GMTH)
      CALL HOEHE(ALTI,P)
      CALL STDTORAD(RECH,RECR)
      CALL GRADTORAD(PHG,PHR)
      CALL DECTORAD(DECG,DECR)
      CALL STDTODEZ(GMTH,GMTD)
      CALL GETR('EXPOSURE TIME (min)?',BELT,MODE,1)
      GMTD = GMTD + BELT / 120.
      IF(GMTD.GE.24.) THEN
         GMTD = GMTD - 24.
         NTAG = NTAG + 1
      ENDIF
      TAG = NTAG + (GMTD / 24.)
      XLOND = XLONG / 15.
      CALL JULIENDAY(JAHR,MONAT,TAG,DATEJUL,TAGDJAHRES)
      CALL SIDEREAL(GMTD,JAHR,XLOND,DATEJUL,TAGDJAHRES,LSTD)
      CALL DEZTOSTD(LSTD,STH)
      LTR = LSTD * 2. * PI / 24.
      CALL PARALLAXE(RECR,DECR,PHR,LTR,ZENIT,WINKEL)
      CALL AIRMASS(ZENIT,AM)
C** CALCULATION OF THE REFRACTION INDEX
      WNORM = WAVENORM * WUNIT / 1.E4
      CALL REFLAM(WNORM,BLAM)
      CALL REFLHT(BLAM,TEMP,P,BLHT)
      CALL REFALL(BLHT,WDD,TEMP,WNORM,BALL)
      BALLN = BALL
C** CALCULATION OF THE REFRACTION INDEX AND THE DIFFERENTIEL 
C** DIFFERENCE IN ARCSEC FOR ALL WAVELENGTH
      DO 100 NRLAMBDA = 0,(NPIX-1),1 
        XLAMBDA = START + ( STEP * NRLAMBDA)
        IZAHL=IZAHL+1
        WAVEL = XLAMBDA * WUNIT / 1.E4
        IF(WAVEL.LE.0.) THEN
           CALL STTPUT('ALL WAVELENGTHS SHOULD BE POSITIVE',ISTAT)
           WRITE(STRING,9099) (NRLAMBDA+1),XLAMBDA
           CALL STETER(9,STRING)
        ENDIF
        CALL REFLAM(WAVEL,BLAM)
        CALL REFLHT(BLAM,TEMP,P,BLHT)
        CALL REFALL(BLHT,WDD,TEMP,WAVEL,BALL)
        BRECH(1)=BALLN
        BRECH(2)=BALL
        CALL DIFFERENZ(BRECH,ZENIT,DELTA)
        CALL INTEGRAL(XSLIT,YSLIT,DELTA,SIGMA,ANGLE,WINKEL,FLUX)
        WAVE(IZAHL) = XLAMBDA
        ABWEICH(IZAHL) = DELTA
        RFLUX(IZAHL) = FLUX
        NZAHL = IZAHL
 100  CONTINUE
      CALL DATOUT(WAVE,ABWEICH,RFLUX,NZAHL,AM,WINKEL,STH,ANGLE)
C 
9099  FORMAT(I5,'. WAVELENGTH INPUT: ',F12.5)
C 
      END

      SUBROUTINE JULIENDAY(JAHR,MONAT,TAG,DATEJUL,TAGDJAHRES)
      IMPLICIT INTEGER(I-N)
      IMPLICIT REAL(A-H,O-Z)
      DOUBLE PRECISION DATEJUL
      COMMON /MYMOD/ MODE
      JJ = JAHR
      MM = MONAT
      IF(MONAT.LE.2) THEN
         JJ = JAHR - 1
         MM = MONAT + 12
      ENDIF
      GREGOR = JAHR + ((MONAT-1)+AINT(TAG)/31)/12
      IF(GREGOR.GT.1582.791) THEN
         A = AINT(1.*JJ/100)
         B = 2 - A + AINT(A/4)
      ELSE
         B = 0
      ENDIF
      C = AINT(365.25*JJ)
      D = AINT(30.6001*(MM+1))
      DAYS=D+AINT(TAG)
      DATEJUL = B + C + D + TAG + 0.5
      DATEJUL = DATEJUL + 1720994.
C      CALL STTPUT( 'JULIEN DATE = ' , DATEJUL,ISTAT)
      NSCHALT=0
      IF(MOD(JAHR,4).EQ.0.AND.MOD(JAHR,100).NE.0.
     *OR.MOD(JAHR,400).EQ.0) THEN
         NSCHALT = 1
      ENDIF
C     CALL STTPUT('IST ',JAHR,' EIN SCHALTJAHR ? (1=JA)',NSCHALT,ISTAT)
      IF(MONAT.GE.3.AND.MONAT.LE.12) THEN
         XM = AINT((MONAT + 1) * 30.6)
         IF(NSCHALT.EQ.0) XM = XM - 63.
         IF(NSCHALT.EQ.1) XM = XM - 62.
      ELSEIF(MONAT.LE.2.AND.MONAT.GE.1) THEN
         XM = (MONAT - 1)
         IF(NSCHALT.EQ.0) XM = XM * 63.
         IF(NSCHALT.EQ.1) XM = XM * 62.
         XM = AINT(XM/2)
      ELSE
         CALL STETER(9,'Wrong input for the month!')
      ENDIF
      TAGDJAHRES = XM + AINT(TAG)
C     CALL STTPUT( 'DAY OF THE YEAR : ',TAGDJAHRES,ISTAT)
      END

      SUBROUTINE SIDEREAL(GMTD,JAHR,XLOND,DATEJUL,TAGDJAHRES,LSTD)
      IMPLICIT INTEGER(I-N)
      IMPLICIT REAL(A-H,O-Z)
      DOUBLE PRECISION DATEJB,DATEJUL,A,B,C,E,F,G,T,R,U,GSTD,LSTD
      PARAMETER(A=0.0657098D0,C=1.002738D0,E=6.6460656D0)
      PARAMETER(F=2400.051262D0,G=0.00002581D0)
      COMMON /MYMOD/ MODE
      CALL JULIENDAY(JAHR,1,0.,DATEJB,TAG)
      T = (DATEJB - 2415020.0) / 36525.0
      R = E + (F*T) + (G*T**2.D0)
      U = R - (24.D0*(JAHR-1900.D0))
      B = 24.D0 - U
      GSTD = TAGDJAHRES * A - B + (GMTD * C)
      IF(GSTD.LT.0.) GSTD = GSTD + 24.
      IF(GSTD.GT.24.) GSTD = GSTD - 24.
C     CALL STTPUT( 'GREENWICH SIDERIAL TIME :',GSTD,ISTAT)
      LSTD = GSTD - XLOND
      IF(LSTD.LT.0.) LSTD = LSTD + 24.
      IF(LSTD.GT.24.) LSTD = LSTD - 24.
C     CALL STTPUT( 'LOCAL SIDERIAL TIME :',LSTD,ISTAT)
      END

      SUBROUTINE AIRMASS(ZENIT,AM)
      IMPLICIT INTEGER(I-N)
      IMPLICIT REAL(A-H,O-Z)
      CHARACTER*80  STRING
      DOUBLE PRECISION A,B,C,SECZ,ZENIT
      PARAMETER(A=0.0018167,B=0.002875,C=0.0008083)
      COMMON /MYMOD/ MODE
      SECZ = 1 / ZENIT
C     CALL STTPUT( 'SEC Z = ',SECZ,ISTAT)
      AM = SECZ - A*(SECZ-1.) - B*(SECZ-1.)**2 - C*(SECZ-1.)**3
C     CALL STTPUT('AIRMASS = ',AM,ISTAT)
      IF(AM.LT.0.) THEN
         CALL STTPUT('TARGET NOT OBSERVABLE AT THIS TIME !',ISTAT)
         WRITE(STRING,456) AM
         CALL STTPUT(STRING,ISTAT)
 456     FORMAT('AIRMASS =',F12.6)
         CALL STETER(9,'Sorry...')
      ENDIF
      END

      SUBROUTINE DIFFERENZ(BRECH,ZENIT,DELTA)
      IMPLICIT INTEGER(I-N)
      IMPLICIT REAL(A-H,O-Z)
      DOUBLE PRECISION BRECH(2),ZENIT,PI
      COMMON /MYMOD/ MODE
      PI=ACOS(-1.D0)
      DO 100 I=1,2
         BRECH(I) = BRECH(I) * 1D-6 + 1.
 100  CONTINUE
      ZENRAD = ACOS (ZENIT)
      DELTA = (BRECH(1) - BRECH(2)) / (BRECH(1) * BRECH(2))*TAN(ZENRAD)
      ARCSEC = 2. * PI / 360. / 3600.
      DELTA = DELTA / ARCSEC
      END
      
      SUBROUTINE INORT(ALTI,TEMP,WDD,PHG,XLONG)
      IMPLICIT INTEGER(I-N)
      IMPLICIT REAL(A-H,O-Z)
      DOUBLE PRECISION XLONG
      COMMON /MYMOD/ MODE
      
      CHARACTER*9 H
 10   FORMAT(A)
 111  CALL STTPUT('Which Telescope? ',ISTAT)
      CALL STTPUT('CALAR ALTO (Spain)  :         CA ',ISTAT)
      CALL STTPUT('KITT PEAK (Arizona) :         KP ',ISTAT)
      CALL STTPUT('LA PALMA (Kanary I) :         LP ',ISTAT)
      CALL STTPUT('LA SILLA (Chile)    :         LS ',ISTAT)
      CALL STTPUT('Mc DONALD (Texas)   :         MD ',ISTAT)
      CALL STTPUT('OTHER OBS. SITE     :         OS ',ISTAT)
      CALL GETC('?',H, MODE, 1)
      IF(INDEX(H,'CA').GT.0.OR.INDEX(H,'ca').GT.0) THEN
         PHG   = 37.23
         XLONG = 2.5367
         ALTI  = 2168.
         CALL STTPUT(' ',ISTAT)
         CALL STTPUT('TELESCOPE :   CALAR ALTO',ISTAT)
      ELSEIF(INDEX(H,'LS').GT.0.OR.INDEX(H,'ls').GT.0) THEN
         PHG   =-29.2567
         XLONG = 70.73
         ALTI  = 2347.
         CALL STTPUT('  ',ISTAT)
         CALL STTPUT('TELESCOPE :   LA SILLA',ISTAT)
      ELSEIF(INDEX(H,'MD').GT.0.OR.INDEX(H,'md').GT.0) THEN
         PHG   = 30.67167
         XLONG = 104.021667
         ALTI  = 2075.
         CALL STTPUT('  ',ISTAT)
         CALL STTPUT('TELESCOPE :   Mc DONALD',ISTAT)
      ELSEIF(INDEX(H,'KP').GT.0.OR.INDEX(H,'kp').GT.0) THEN
         PHG   = 31.96
         XLONG = 111.6
         ALTI  = 2120.
         CALL STTPUT(' ',ISTAT)
         CALL STTPUT('TELESCOPE :   KITT PEAK',ISTAT)
      ELSEIF(INDEX(H,'LP').GT.0.OR.INDEX(H,'lp').GT.0) THEN
         PHG   = 28.7594
         XLONG = 17.87611
         ALTI  = 2369.
         CALL STTPUT(' ',ISTAT)
         CALL STTPUT('TELESCOPE :   LA PALMA',ISTAT)
      ELSEIF(INDEX(H,'OS').GT.0.OR.INDEX(H,'os').GT.0) THEN
         CALL STTPUT ('coordinates of observing site:      ',ISTAT)
         CALL GETR('LATITUDE (-90. to 90. DEGREE)', PHG, MODE, 2)
         RR = SNGL(XLONG)
         CALL GETR(
     +   'LONGITUDE (-180 to 180 degree, east of Greenwich negative!)',
     +    RR, MODE, 3)
         CALL GETR('altitude of observing site [meter] ? ',ALTI, 
     +             MODE, 4)
      ELSE
         CALL STTPUT(H,ISTAT)
         CALL STTPUT('Error: Wrong input Telescope, try again:',ISTAT)
         GOTO 111
      ENDIF
      CALL GETR('AIR TEMPERATURE [C] ? ',TEMP, MODE, 5)
      CALL DRUCKGRAF
      CALL GETR('WATER VAPOUR PRESSURE [Torr (mmHg)] ? ',WDD, MODE, 6)
      END

      SUBROUTINE INOBS(RECH,DECG,SIGMA,WAVENORM,XSLIT,YSLIT,ANGLE)
      IMPLICIT INTEGER(I-N)
      IMPLICIT REAL(A-H,O-Z)
      COMMON /MYMOD/ MODE
      CALL STTPUT('Coordinates of Target',ISTAT)
      CALL GETR('RA.  (HH.MMSS) ',RECH, MODE, 7)
      RECH = RECH * 10000.
      CALL GETR('DECLINATION (GG.MMSS) ',DECG, MODE, 8)
      DECG = DECG * 10000.
      CALL GETR('wavelength [in units you selected before] centered'
     +    //' at slit?',WAVENORM, MODE, 9)
C     WAVENORM=5550
      CALL GETR('SEEING [arcsec]?',SEEING, MODE, 10)
      SIGMA = SEEING / 2.354
      CALL GETR('SLIT ANGLE (0-180; 0.& 180.= NORTH--SOUTH) ?',ANGLE,
     +          MODE, 11)
      CALL GETR('SLIT LENGTH [arcsec]? ',YSLIT, MODE, 12)
      CALL GETR('SLIT WIDTH  [arcsec]?',XSLIT, MODE, 13)
      END

      SUBROUTINE INDATE(JAHR,MONAT,NTAG,GMTH)
      IMPLICIT INTEGER(I-N)
      IMPLICIT REAL(A-H,O-Z)
      COMMON /MYMOD/ MODE
      CALL STTPUT('TIME OF OBSERVATION :',ISTAT)
      CALL GETI('YEAR ? ',JAHR, MODE, 3)
      CALL GETI(' MONTH ?',MONAT, MODE, 4)
      CALL GETI('DAY OF MONTH ?',NTAG, MODE, 5)
      CALL GETR('UNIVERSAL TIME (GMT) [HH.MMSS] ? ',GMTH, MODE, 14)
      GMTH = GMTH * 10000.
      END

      SUBROUTINE REFLAM(WAVEL,BLAM)
      IMPLICIT INTEGER(I-N)
      IMPLICIT REAL(A-H,O-Z)
************************************************************************
*     Calculation of the refraction index depending on the wavelength  *
*     for the standard atmosphere                                      *
*     air pressure          :    1013.25 hPa  (760 Torr)               *
*     temperature           :    15.00 C                               *
*     water vapour pressure :     0.00 hPa                             *
************************************************************************
      DOUBLE PRECISION BLAM,TERM1,TERM2,A,B,C,D,E
      PARAMETER(A=64.328,B=29498.1,C=146,D=255.4,E=41)
      COMMON /MYMOD/ MODE
      TERM1 = A + B / (C - (1. / WAVEL)**2.)
      TERM2 =     D / (E - (1. / WAVEL)**2.)
      BLAM = TERM1 + TERM2
      END

      SUBROUTINE REFLHT(BLAM,TEMP,P,BLHT)
      IMPLICIT INTEGER(I-N)
      IMPLICIT REAL(A-H,O-Z)
************************************************************************
*     Calculation of the refraction index taken into account the       *
*     air pressure and the temperature                                 *
************************************************************************
      DOUBLE PRECISION BLAM,BLHT,A,B,C,D,TERM1,TERM2
      PARAMETER(A=1.049,B=0.0157,C=720.883,D=0.003661)
      COMMON /MYMOD/ MODE
      TERM1 = P * (1. + (A - B * TEMP) * 1.E-6 * P)
      TERM2 = C * (1. + D * TEMP)
      BLHT = BLAM * TERM1 / TERM2
      END

      SUBROUTINE REFALL(BLHT,WDD,TEMP,WAVEL,BALL)
      IMPLICIT INTEGER(I-N)
      IMPLICIT REAL(A-H,O-Z)
************************************************************************
*     Calculation of the refraction index taken into account the       *
*     water vapour pressure                                            *
************************************************************************
      DOUBLE PRECISION BLHT,BALL,TERM1,TERM2,A,B,C
      PARAMETER(A=0.0624,B=0.00068,C=0.003661)
      COMMON /MYMOD/ MODE
      TERM1 = A - B / WAVEL**2.
      TERM2 = 1. + C * TEMP
      BALL = BLHT - TERM1 / TERM2 * WDD
      END

      SUBROUTINE DATOUT(WAVE,ABWEICH,RFLUX,NZAHL,AM,WINKEL,STH,ANGLE)
      IMPLICIT INTEGER(I-N)
      IMPLICIT REAL(A-H,O-Z)
      INTEGER NZAHL
      CHARACTER*80 STRING
      REAL ABWEICH(*),RFLUX(*),WAVE(*)
      COMMON /MYMOD/ MODE
 10   FORMAT(A18,F8.3,3X,A18,F8.3)
 11   FORMAT(A18,F8.1)
 12   FORMAT(A26)
 14   FORMAT(A18,F8.4)
 19   FORMAT(1X,I5,1X,F9.1,4X,2(F9.5,5X))
      DO 100 I=1,2
C     CALL STTPUT( 'N(',LAMBDA(I),')=',BRECH(I),ISTAT)
 100  CONTINUE
      STERNZ = STH / 10000.
C** TERMINAL OUTPUT
      WRITE(STRING,14)  'LS TIME (HH.MMSS)=',STERNZ
      CALL STTPUT(STRING,ISTAT)
      WRITE(STRING,10)  ' AIRMASS         =',AM
      CALL STTPUT(STRING,ISTAT)
      WRITE(STRING,12)  ' -------------------------'
      CALL STTPUT(STRING,ISTAT)
      CALL STTPUT('  ',ISTAT)
      WRITE(STRING,11)  ' ANGLE (DEGREE)  = ',WINKEL
      CALL STTPUT(STRING,ISTAT)
      WRITE(STRING,12) ' --------------------------'
      CALL STTPUT('  ',ISTAT)
C** OUTPUT ON FILE UNIT 12
C      WRITE(12,10)'     BEST ANGLE  :',WINKEL,'CHOOSEN ANGLE   :',
C     $     ANGLE
C      WRITE(12,10)'AIRMASS          :',AM
C      WRITE(12,*) '    NR.  LAMBDA    DELTA [ARCSEC]  FLUSS [%]  '
C      WRITE(12,*)  NZAHL
C      DO 200 I=1,NZAHL
C         WRITE(12,19) I,WAVE(I),ABWEICH(I),RFLUX(I)
 200  CONTINUE
      END

      SUBROUTINE HOEHE(ALTI,P)
      IMPLICIT INTEGER(I-N)
      IMPLICIT REAL(A-H,O-Z)
************************************************************************
*     Input  : Altitude [meters]                                       *
*     Output : pressure in Torr (mmHg)                                 *
*     This subroutine calculates the air pressure P [hectopascal] as   *
*     a function of the altitude h [m] due to the barometric altitude  *
*     formula:                                                         *
*     P(h) = Po * exp (-(Do * g / Po) * h)                             *
*     References: Bergmann/Schaefer  Vol.1, page 232                   *
*     Here there is:                                                   *
*     Po  : pressure at sea level  ==> 101325 pascal                   *
*     Do  : density at sea level   ==> 1.2930 kg/m3                    *
*     g   : earth acceleration     ==> 9.8100 m/s2                     *
*     h   : altitude above sea level in meters                         *
************************************************************************
      PARAMETER(DRUCK=101325.,DICHTE=1.293,G=9.81)
      COMMON /MYMOD/ MODE
C** CALCULATIONS
      CONST=DICHTE*G/DRUCK
      PRESSURE = DRUCK / 100. * EXP ( -CONST * ALTI )
      P = PRESSURE * 0.75
C     CALL STTPUT( 'AIR PRESSURE [Torr] :',P,ISTAT)
      END

      SUBROUTINE GRADTORAD(GRAD,RAD)
      IMPLICIT INTEGER(I-N)
      IMPLICIT REAL(A-H,O-Z)
      CHARACTER*80 STRING
      DOUBLE PRECISION RAD,PI
      COMMON /MYMOD/ MODE
      PI=ACOS(-1.D0)
      IF(GRAD.GT.90.OR.GRAD.LT.-90.) THEN
         CALL STTPUT
     +        ('Wrong input of latitude of observatory! ',ISTAT)
         WRITE(STRING,9099) GRAD
9099  FORMAT('DEGREE INPUT= ',F12.5)
         CALL STETER(9,STRING)
      ENDIF
      RAD = GRAD / 360. * 2. * PI
C     CALL STTPUT( 'POLHOEHE = ',RAD
      END

      SUBROUTINE STDTORAD(HOUR,RAD)
      IMPLICIT INTEGER(I-N)
      IMPLICIT REAL(A-H,O-Z)
      CHARACTER*80 STRING
      DOUBLE PRECISION RAD,PI
      COMMON /MYMOD/ MODE
      PI=ACOS(-1.D0)
      A1 = AINT(HOUR/10000)
      B1 = A1 / 24. * 360.
      IF(A1.GE.24.) THEN
      CALL STTPUT('Wrong input of coordinates (hour)! ',ISTAT)
         WRITE(STRING,9099) A1
9099  FORMAT('HOUR INPUT = ',F12.5)
      CALL STETER(9,STRING)
      ENDIF
      A2 = MOD(HOUR,10000.)
      A3 = AINT(A2/100)
      IF(A3.GE.60.) THEN
      CALL STTPUT('Wrong input of coordinates (min)! ',ISTAT)
         WRITE(STRING,9098) A3
9098  FORMAT('MIN. INPUT = ',F12.5)
      CALL STETER(9,STRING)
      ENDIF
      B2 = A3 / 60. * 15.
      A4 = MOD(A2,100.)
      IF(A4.GE.60.) THEN
      CALL STTPUT('Wrong input of coordinates (sec)! ',ISTAT)
         WRITE(STRING,9097) A4
9097  FORMAT('SEC. INPUT = ',F12.5)
      CALL STETER(9,STRING)
      ENDIF
      B3 = A4 / 3600. * 15.
      DEZ = B1 + B2 + B3
      RAD = DEZ / 360. * 2. * PI
      END

      SUBROUTINE DECTORAD(GRAH,RAD)
      IMPLICIT INTEGER(I-N)
      IMPLICIT REAL(A-H,O-Z)
      CHARACTER*80 STRING
      DOUBLE PRECISION RAD,PI
      COMMON /MYMOD/ MODE
      PI=ACOS(-1.D0)
      A1 = AINT(GRAH/10000.)
      IF(A1.GT.90..OR.A1.LT.-90.) THEN
      CALL STTPUT('Wrong input of declination ! ',ISTAT)
         WRITE(STRING,9099) A1
9099  FORMAT('DEGREE INPUT =',F12.5)
      CALL STETER(9,STRING)
      ENDIF
      A2 = MOD(GRAH,10000.)
      A3 = AINT(A2/100)
      IF(A3.GE.60.) THEN
      CALL STTPUT('Wrong input of declination (mm) ! ',ISTAT)
         WRITE(STRING,9098) A3
9098  FORMAT('MM INPUT =',F12.5)
      CALL STETER(9,STRING)
      ENDIF
      B2 = A3 / 60.
      A4 = MOD(GRAH,100.)
      IF(A4.GE.60.) THEN
      CALL STTPUT('Wrong input of declination (ss) ! ',ISTAT)
         WRITE(STRING,9097) A4
9097  FORMAT('SEC INPUT =',F12.5)
      CALL STETER(9,STRING)
      ENDIF
      B3 = A4 / 3600.
      DEZ = A1 + B2 + B3
      RAD = DEZ / 360. * 2. * PI
      END

      SUBROUTINE STDTODEZ(STD,DEZ)
      IMPLICIT INTEGER(I-N)
      IMPLICIT REAL(A-H,O-Z)
      COMMON /MYMOD/ MODE
      A1 = AINT(STD/10000)
      A2 = MOD(STD,10000.)
      A2 = AINT (A2/100.)
      A3 = MOD(STD,100.)
      IF(A1.GE.24..OR.A2.GE.60..OR.A1.GE.60.) THEN
      CALL STETER(9, 'Wrong input of coordinates (times) ! ')
      ENDIF
      A3 = A3 / 60.
      A2 = (A2 + A3) / 60.
      DEZ = A1 + A2
      END

      SUBROUTINE DEZTOSTD(DEZ,STD)
      IMPLICIT INTEGER(I-N)
      IMPLICIT REAL(A-H,O-Z)
      DOUBLE PRECISION DEZ
      COMMON /MYMOD/ MODE
      A1 = DINT(DEZ)
      A2 = (DEZ-A1)*60.
      A3 =  MOD((A2),1.)*6./1000.
      A2 = AINT (A2)/100.
      STD = (A1 + A2 + A3) * 10000.
      IF ((A3*10000.).GE.59.5) THEN
         A3 = 0.
         IF(A2.EQ.0.59) THEN
            A2 = 0.
            IF(A1.EQ.23) THEN
               A1 = 0.
            ELSE
               A1 = A1 + 1.
            ENDIF
         ELSE
            A2 = A2 + 0.01
         ENDIF
      ENDIF
      STD = (A1 + A2 + A3) * 10000.
      END

      SUBROUTINE PARALLAXE(RECR,DECR,PHR,LTR,ZENIT,WINKEL)
      IMPLICIT INTEGER(I-N)
      IMPLICIT REAL(A-H,O-Z)
      DOUBLE PRECISION LTR,DECR,RECR,PHR,ZENIT,XNENNER,COSWINKEL,PI
      COMMON /MYMOD/ MODE
      PI=ACOS(-1.D0)
      ZENIT = (SIN(PHR)*SIN(DECR)+COS(PHR)*COS(DECR)*COS(LTR-RECR))
      ZAEHLER =(SIN(PHR)*COS(DECR)-COS(PHR)*SIN(DECR)*COS(LTR-RECR))
      XNENNER = SQRT(1 - (ZENIT**2.))
      COSWINKEL = ZAEHLER / XNENNER
      COSW = COSWINKEL
      WINKEL = ACOS (COSW) * 360. / (2. * PI)
      ABW = REAL(DMIN1(DABS(RECR-LTR),(2.*PI) - DABS(RECR-LTR)))
      IF (RECR.GT.LTR) THEN
         IF((RECR+ABW).GT.(2.*PI).AND.(LTR-ABW).LT.0.) THEN
         ELSE
            WINKEL = 360. - WINKEL
         ENDIF
      ENDIF
      IF(RECR.LT.LTR) THEN
         IF((LTR+ABW).GT.(2.*PI).AND.(RECR-ABW).LT.0.) THEN
            WINKEL = 360. - WINKEL
         ENDIF
      ENDIF
      END

      FUNCTION GAUSS(X,SIGMA)
      IMPLICIT INTEGER(I-N)
      IMPLICIT REAL(A-H,O-Z)
      PI = ACOS (-1.)
C      IF (ABS(X/SIGMA).GT.12.) THEN
C         GAUSS = 0.
C      ELSE
         GAUSS= 1/(SQRT(2.*PI)*SIGMA) *EXP(-(X**2/2./SIGMA**2))
C      ENDIF
      END

      SUBROUTINE TRAPZD(GAUSS,SIGMA,A,B,S,N,IT)
      IMPLICIT INTEGER(I-N)
      IMPLICIT REAL(A-H,O-Z)
      EXTERNAL GAUSS
      COMMON /MYMOD/ MODE
      IF (N.EQ.1) THEN
         S=0.5*(B-A)*(GAUSS(A,SIGMA)+GAUSS(B,SIGMA))
         IT=1
      ELSE
         TNM=IT
         DEL=(B-A)/TNM
         X=A+0.5*DEL
         SUM=0.
         DO 11 J=1,IT
            SUM=SUM+GAUSS(X,SIGMA)
            X=X+DEL
 11      CONTINUE
         S=0.5*(S+(B-A)*SUM/TNM)
         IT=2*IT
      ENDIF
      RETURN
      END

      SUBROUTINE POLINT(XA,YA,N,X,Y,DY)
      IMPLICIT INTEGER(I-N)
      IMPLICIT REAL(A-H,O-Z)
      PARAMETER (NMAX=10)
      DIMENSION XA(N),YA(N),C(NMAX),D(NMAX)
      COMMON /MYMOD/ MODE
      NS=1
      DIF=ABS(X-XA(1))
      DO 11 I=1,N
         DIFT=ABS(X-XA(I))
         IF (DIFT.LT.DIF) THEN
            NS=I
            DIF=DIFT
         ENDIF
         C(I)=YA(I)
         D(I)=YA(I)
 11   CONTINUE
      Y=YA(NS)
      NS=NS-1
      DO 13 M=1,N-1
         DO 12 I=1,N-M
            HO=XA(I)-X
            HP=XA(I+M)-X
            W=C(I+1)-D(I)
            DEN=HO-HP
            IF (DEN.EQ.0.) THEN
              CALL STETER(44,
     +        'Division by zero (var. DEN in routine POLINT) - we stop')
            ENDIF
C 
            DEN=W/DEN
            D(I)=HP*DEN
            C(I)=HO*DEN
 12      CONTINUE
         IF (2*NS.LT.N-M)THEN
            DY=C(NS+1)
         ELSE
            DY=D(NS)
            NS=NS-1
         ENDIF
         Y=Y+DY
 13   CONTINUE
      RETURN
      END

      SUBROUTINE INTEGRAL(XSLIT,YSLIT,DELTA,SIGMA,ANGLE,WINKELOPT,FLUX)
      IMPLICIT INTEGER(I-N)
      IMPLICIT REAL(A-H,O-Z)
      CHARACTER*80 STRING
      EXTERNAL GAUSS
      COMMON /MYMOD/ MODE
      PI = ACOS (-1.)
      THETA = ABS (WINKELOPT - ANGLE)
      IF (THETA.GT.360.) THEN
      CALL STTPUT('Problems with angles !!',ISTAT)
         WRITE(STRING,9099) WINKELOPT
9099  FORMAT('BEST ANGLE    : 0 < A < 360   A =',F12.5)
      CALL STTPUT(STRING,ISTAT)
         WRITE(STRING,9098) ANGLE
9098  FORMAT('INPUT ANGLE   : 0 < B < 180   B =',F12.5)
      CALL STETER(9,STRING)
      ENDIF
      IF (THETA.GE.180.) THETA = THETA - 180.
      IF (THETA.GT.90.) THETA = 180. - THETA
      THETA = THETA * 2. * PI / 360.
      XDELTA = DELTA * SIN (THETA)
      YDELTA = DELTA * COS (THETA)
C** Limits to prevent an under(over-)flow during integration (QROMB)
      A = XDELTA - XSLIT / 2.
      IF ((A/SIGMA).GT.12.)  A =  (12. * SIGMA)
      IF ((A/SIGMA).LT.-12.) A = -(12. * SIGMA)
      B = XDELTA + XSLIT / 2.
      IF ((B/SIGMA).GT.12.)  B = (12. * SIGMA)
      IF ((B/SIGMA).LT.-12.) B = -(12. * SIGMA)
      IF(ABS(A-B).LT.10.E-6) THEN 
         XFLUX = 0.
      ELSE
         CALL QROMB(GAUSS,SIGMA,A,B,XFLUX)
      ENDIF
      A = YDELTA - YSLIT / 2.
      IF ((A/SIGMA).GT.12.) A = (12. * SIGMA)
      IF ((A/SIGMA).LT.-12.) A = -(12. * SIGMA)
      B = YDELTA + YSLIT / 2.
      IF ((B/SIGMA).GT.12.)  B = (12. * SIGMA)
      IF ((B/SIGMA).LT.-12.) B = -(12. * SIGMA)
      IF(ABS(A-B).LT.10.E-6) THEN 
         YFLUX = 0.
      ELSE
         CALL QROMB(GAUSS,SIGMA,A,B,YFLUX)
      ENDIF
      FLUX = XFLUX * YFLUX
      END

      SUBROUTINE QROMB(GAUSS,SIGMA,A,B,SS)
      IMPLICIT INTEGER(I-N)
      IMPLICIT REAL(A-H,O-Z)
      EXTERNAL GAUSS
      PARAMETER(EPS=1.E-6,JMAX=20,JMAXP=JMAX+1,K=5,KM=4)
      DIMENSION S(JMAXP),H(JMAXP)
      COMMON /MYMOD/ MODE
      H(1)=1.
      IT = 0
      DO 11 J=1,JMAX
         CALL TRAPZD(GAUSS,SIGMA,A,B,S(J),J,IT)
         IF (J.GE.K) THEN
            L=J-KM
            CALL POLINT(H(L),S(L),K,0.,SS,DSS)
            IF (ABS(DSS).LT.EPS*ABS(SS)) RETURN
         ENDIF
         S(J+1)=S(J)
         H(J+1)=0.25*H(J)
 11   CONTINUE
      CALL STETER(45,'Too many steps (routine QROMB)')
      END

      SUBROUTINE DRUCKGRAF
      IMPLICIT INTEGER(I-N)
      IMPLICIT REAL(A-H,O-Z)
      CHARACTER*80 STRING
      COMMON /MYMOD/ MODE
      CALL STTPUT(' ',ISTAT)
      CALL STTPUT
     +('        Sketch to determine the water vapour pressure',ISTAT)
      CALL STTPUT
     +('            Saturation curve = 100% relative humidity',ISTAT)
      WRITE(STRING,16)
      CALL STTPUT(STRING,ISTAT)
      WRITE(STRING,1)
      CALL STTPUT(STRING,ISTAT)
      WRITE(STRING,2)
      CALL STTPUT(STRING,ISTAT)
      WRITE(STRING,3)
      CALL STTPUT(STRING,ISTAT)
      WRITE(STRING,4)
      CALL STTPUT(STRING,ISTAT)
      WRITE(STRING,5)
      CALL STTPUT(STRING,ISTAT)
      WRITE(STRING,6)
      CALL STTPUT(STRING,ISTAT)
      WRITE(STRING,7)
      CALL STTPUT(STRING,ISTAT)
      WRITE(STRING,8)
      CALL STTPUT(STRING,ISTAT)
      WRITE(STRING,9)
      CALL STTPUT(STRING,ISTAT)
      WRITE(STRING,10)
      CALL STTPUT(STRING,ISTAT)
      WRITE(STRING,11)
      CALL STTPUT(STRING,ISTAT)
      WRITE(STRING,12)
      CALL STTPUT(STRING,ISTAT)
      WRITE(STRING,13)
      CALL STTPUT(STRING,ISTAT)
      WRITE(STRING,14)
      CALL STTPUT(STRING,ISTAT)
      WRITE(STRING,15)
      CALL STTPUT(STRING,ISTAT)
      WRITE(STRING,17)
      CALL STTPUT(STRING,ISTAT)
      WRITE(STRING,18)
      CALL STTPUT(STRING,ISTAT)
      WRITE(STRING,19)
      CALL STTPUT(STRING,ISTAT)
 1    FORMAT(5X,'|',71X,'|')
 2    FORMAT('P    |',71X,'*')
 3    FORMAT('R    |',68X,'*',2X,'|')
 4    FORMAT('E  15-',65X,'*',5X,'-')
 5    FORMAT('S    |',62X,'*',8X,'|')
 6    FORMAT('S    |',59X,'*',11X,'|')
 7    FORMAT('U    |',55X,'*',15X,'|')
 8    FORMAT('R  10-',51X,'*',19X,'-')
 9    FORMAT('E    |',46X,'*',24X,'|')
 10   FORMAT(5X,'|',40X,'*',30X,'|')
 11   FORMAT('T    |',34X,'*',36X,'|')
 12   FORMAT('O  5 -',27X,'*',43X,'-')
 13   FORMAT('R    |',19X,'*',51X,'|')
 14   FORMAT('R    |',10X,'*',60X,'|')
 15   FORMAT(5X,'*',71X,'|')
 16   FORMAT(2X,'20 -',6(11('-'),'|'))
 17   FORMAT(3X,'0 |',6(11('-'),'|'))
 18   FORMAT(4X,'-10',9X,'-5',11X,'0',11X,'5',10X,'10',10X,'15',
     +     10X,'20')
 19   FORMAT(34X,'TEMPERATURE [C]')
      CALL STTPUT(' ',ISTAT)
      STRING='    e.g.: at 70% humidity and T=10 C, the pressure would'
     +  //'be about 6 Torr'
      CALL STTPUT(STRING,ISTAT)
      END

      SUBROUTINE GETR(PROMPT, VALUE, MODE, RANK)
      IMPLICIT INTEGER(I-N)
      IMPLICIT REAL(A-H,O-Z)
      CHARACTER*(*) PROMPT
      REAL          VALUE
      INTEGER       MODE, RANK
      INTEGER       ACTS, KUN, KNUL, STAT

      IF (MODE .EQ. 0) THEN
          CALL STKPRR(PROMPT,'INPUTR',1,1,ACTS,VALUE,KUN,KNUL,STAT)
      ELSE
          CALL STKRDR('INPUTR',RANK,1,ACTS,VALUE,KUN,KNUL,STAT)
      ENDIF
      END

      SUBROUTINE GETI(PROMPT, VALUE, MODE, RANK)
      IMPLICIT INTEGER(I-N)
      IMPLICIT REAL(A-H,O-Z)
      CHARACTER*(*) PROMPT
      INTEGER       VALUE ,MODE, RANK
      INTEGER       ACTS, KUN, KNUL, STAT
      IF (MODE .EQ. 0) THEN
         CALL STKPRI(PROMPT,'INPUTI',1,1,ACTS,VALUE,KUN,KNUL,STAT)
      ELSE
         CALL STKRDI('INPUTI',RANK,1,ACTS,VALUE,KUN,KNUL,STAT)
      ENDIF
      END

      SUBROUTINE GETC(PROMPT, VALUE, MODE, RANK)
      IMPLICIT INTEGER(I-N)
      IMPLICIT REAL(A-H,O-Z)
      CHARACTER*(*) PROMPT
      CHARACTER*9   VALUE
      INTEGER       MODE, RANK
      INTEGER       ACTS, KUN, KNUL, STAT
      IF (MODE .EQ. 0) THEN
        CALL STKPRC(PROMPT,'INPUTC',1,1,9,ACTS,VALUE,KUN,KNUL,STAT)
      ELSE
        CALL STKRDC('OUT_B',1,RANK,9,ACTS,VALUE,KUN,KNUL,STAT)
      ENDIF
      END

C===========================================================================
C Copyright (C) 1995,2004 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.COPYRIGHT: Copyright (c) 1987,2004 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  15:25 - 20 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION
C
C  program FITCREA.FOR
C
C.PURPOSE
C
C  Execute the commands
C  COMP/FIT image[,error] [= array[(refima)]]
C  COMP/FIT table dvar[,error] [= array[(in.var)]]
C
C.KEYWORDS
C
C  FIT
C
C.INPUT/OUTPUT
C
C  P1 - P8     contain input parameters
C
C.ALGORITHM
C
C  Use fit interface routines
C
C.VERSION
C 040521	last modif
C 
C-----------------------------------------------------------
C
C
C ... define parameters
C
      IMPLICIT   NONE
C
      INTEGER    KUN,KNUL,ISTAT,IND,INDEX
      INTEGER    I,II,II1,HLEN,NAMLEN,IMNOC
C
      CHARACTER*80 NAME,FILE,MASK
      CHARACTER    IAC*1
      CHARACTER    LINE1*34,LINE2*80,REFIMA*80,HISTORY*160
      CHARACTER*80 P1,P2,P3,P4,FTABLE
      CHARACTER*82 LINE
C
      INCLUDE  'MID_INCLUDE:ST_DEF.INC'
      INCLUDE  'MID_INCLUDE:FITI.INC'
      INCLUDE  'MID_INCLUDE:FITC.INC'
      INCLUDE  'MID_INCLUDE:ST_DAT.INC'
C
      DATA NAMLEN/80/
C
C ... get into MIDAS
C
      CALL STSPRO('FITCREA')
      CALL FITBL
      HISTORY(1:) = 'COMPUTE/FIT '
      CALL STKRDC('P1',1,1,80,I,P1,KUN,KNUL,ISTAT)
      I = INDEX(P1,' ')
      HISTORY(13:) = P1(1:I)//' '
      HLEN = I + 15
      CALL STKRDC('P2',1,1,80,I,P2,KUN,KNUL,ISTAT)
      I = INDEX(P2,' ')
      II = HLEN + I + 2
      IF (II .LE. 160) THEN
         HISTORY(HLEN:) = P2(1:I)//' '
         HLEN = II
      ENDIF
      CALL STKRDC('P3',1,1,80,I,P3,KUN,KNUL,ISTAT)
      I = INDEX(P3,' ')
      II = HLEN + I + 2
      IF (II .LE. 160) THEN
         HISTORY(HLEN:) = P3(1:I)//' '
         HLEN = II
      ENDIF
      CALL STKRDC('P4',1,1,80,I,P4,KUN,KNUL,ISTAT)
      I = INDEX(P4,' ')
      II = HLEN + I + 2
      IF (II .LE. 160) THEN
         HISTORY(HLEN:) = P4(1:I)//' '
         HLEN = II
      ENDIF
C 
      IF (P2(1:1).EQ.':' .OR. P2(1:1).EQ.'#') THEN
          P3     = '='
      ELSE
          P2     = '='
      END IF  
C 
      IF (P2(1:1).EQ.'=') THEN                            !   IMAGE
          FTABLE = P1
          IAC    = 'I'
          II     = INDEX(P1,',')
          IF (II.EQ.0) THEN
              FILE   = P1
              MASK   = ' '
          ELSE
              FILE   = P1(1:II-1)
              MASK   = P1(II+1:)
          END IF
          II     = INDEX(P3,'(')
          IF (II.EQ.0) THEN
              NAME   = P3
              REFIMA = '?'
          ELSE
              NAME   = P3(1:II-1)
              LINE   = P3//')'
              II1    = INDEX(LINE,')')
              REFIMA = P3(II+1:II1-1)
          END IF 
      ELSE                                                !   TABLE
          IND    = INDEX(P1,' ') - 1
          FTABLE = P1(1:IND)//'.TBL'
          IAC    = 'T'
          FILE   = P1
          LINE1  = P2
          II     = INDEX(P4,'(')
          IF (II.EQ.0) THEN
              NAME   = P4
              LINE2  = '?'
          ELSE
              NAME   = P4(1:II-1)
              LINE   = P4//')'
              II1    = INDEX(LINE,')')
              LINE2  = P4(II+1:II1-1)
          END IF
      END IF
      IF (NAME(1:1).EQ.'?') THEN
          CALL STKRDC('FITNAME',1,1,NAMLEN,I,NAME,KUN,KNUL,ISTAT)
      ELSE
          CALL STKWRC('FITNAME',1,NAME,1,NAMLEN,KUN,ISTAT)
      END IF
C
C ... read computed parameters
C
      CALL FTINIT(NAME,ISTAT)
C
C ... modify independent variables if required
C     and define dependent variables
C
      IF (IAC.EQ.'I') THEN
          IF (REFIMA(1:1).NE.'?') CALL FTDIVI(REFIMA,ISTAT)
          CALL FTDDVI(FILE,MASK,ISTAT)
      ELSE
          IF (LINE2(1:1).NE.'?') CALL FTDIVT(FILE,LINE2,ISTAT)
          CALL FTDDVT(FILE,LINE1,ISTAT)
      END IF
      CALL FTCOMP(ISTAT)
C 
      IF (IAC.EQ.'I') THEN
         CALL STFOPN(FILE,D_OLD_FORMAT,0,F_OLD_TYPE,IMNOC,ISTAT)
         IF (HLEN .LT. 81) THEN
            HLEN = 80
         ELSE
            HLEN = 160
         ENDIF
         CALL STDWRC(IMNOC,'HISTORY',1,HISTORY,1,HLEN,KUN,ISTAT)
      ENDIF

C
C ... end
C
      CALL STSEPI
9000  FORMAT (I4)
      END
      

C @(#)rfotgroup.for	19.1 (ES0-DMD) 02/25/03 13:30:14
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM GROUP
C+++
C.IDENTIFICATION: RFOTGROUP
C.PURPOSE: Group the objects found by the SEARCH command
C.AUTHOR:  R. Buonanno, G. Buscema, C. Corsi, I. Ferraro, G. Iannicola
C          Osservatorio Astronomico di Roma
C.VERSION: 16.09.87 First running version at ESO (outside MIDAS)   R. Buonanno
C          17.12.87 Installation in MIDAS                          R.H. Warmels
C          29.09.88 New version                                    R. Buonanno
C          11.01.89 Include MIDAS for background values            R.H. Warmels
C          06.06.89 MIDAS tables included; partially rewritten     R.H. Warmels
C.VERSION  910122 RHW IMPLICIT NONE added; all variables define
C----
      IMPLICIT  NONE
      INCLUDE   'MID_REL_INCL:RFOTDECL.INC'
C
      INTEGER   IGV
      REAL      VPA
      INTEGER   NDX
      INTEGER   NDY
      INTEGER   MBB
      INTEGER   NCD
      INTEGER   NOB
      INTEGER   NTM
      INTEGER   NTU
      INTEGER   NTAB
      PARAMETER (IGV=100)
      PARAMETER (VPA=.5)
      PARAMETER (NDX=55)
      PARAMETER (NDY=55)
      PARAMETER (MBB=256)
      PARAMETER (NCD=MBB-18)
      PARAMETER (NOB=NCD/3)
      PARAMETER (NTM=NCD/6.5)
      PARAMETER (NTU=100)
      PARAMETER (NTAB=30000)
C
      INTEGER      AREA(4)
      INTEGER      CERSTE,CERINT
      INTEGER      CUU
      INTEGER      EC,EL,ED
      INTEGER      ISTF(NTM),ISTB(IGV),ISTC(IGV)
      INTEGER      IAV, KUN, KNUL, ISTAT
      INTEGER      IXW, IYW
      INTEGER      IMF
      INTEGER      IAC, IPERCE
      INTEGER      IROW, IDUM3, IOBJ, IFL
      INTEGER      I, I3, ISAV, ICA, ITF, ITT, IGRP, INF, IL
      INTEGER      INFB, INFC, INFT, IFNM, INY, INX
      INTEGER      IFX, IFY
      INTEGER      IX, IY
      INTEGER      IXMA, IYMA
      INTEGER      IXMI, IYMI
      INTEGER      J, JIL, JH, JI, JEL
      INTEGER      LX0, LY0
      INTEGER      LX1, LY1
      INTEGER      LFI, LI, L, LMW, LX, LY
      INTEGER      KAA, KN, KC, KS
      INTEGER      K, KSR
      INTEGER      MADRID(1)
      INTEGER      MQQ2, MQQ3, MQQ4, MQQ5, MQQ6, MQQ7, MQQ8, MQQ9
      INTEGER      MAF, MAC, MAT
      INTEGER      NOS(NTAB)
      INTEGER      NST, NSF, NSPR, NSMQ
      INTEGER      NGRP, NOBJ
      INTEGER      NT, NDUM
      INTEGER      NIX, NIY
      INTEGER      NAXIS, NPL, NL	
      INTEGER      NTC, NO, NEX
      INTEGER      NRC, NHL, NCP, NC, NCAL, NBW, NI
      INTEGER      TIDCAT,NCCAT,NRCAT,NSCAT,NACCAT,NARCAT
      INTEGER      TIDINT,NCINT,NRINT,NSINT,NACINT,NARINT
C
C
      REAL         AIN, ANCL    
      REAL         AM1, AM2
      REAL         BETA
      REAL         DAT(7,NTAB)
      REAL         DEX, DEY, DW2
      REAL         DICI, DICS, DIS
      REAL         DWI
      REAL         FOME, FOG, FAR
      REAL         HHS, HV
      REAL         IS(NOB,4)
      REAL         PFA
      REAL         RME, RMA
      REAL         RA, RAS
      REAL         RINPUT(2)
      REAL         RDUM1, RDUM2, RDUM3, RDUM4, RDUM5, RDUM6, RDUM7
      REAL         RDUM9, RDUM10, RDUM11, RDUM12, RDUM13, RDUM
      REAL         SSLA, SUV, SATU, SIGMA, SIV
      REAL         SF(NTM,7)
      REAL         SMRA
      REAL         V(7)
      REAL         VVV(15)
      REAL         XCEN, YCEN
      REAL         ZZ, ZMRA
C
      CHARACTER*60 FRAME,INTFIL,CATFIL
      CHARACTER    TEXT*80,COO*1
      CHARACTER    CHG*40,CHB*40,XXX*60
      CHARACTER    STRING*80
C
      LOGICAL      LOG,LOG1
C
      INCLUDE      'MID_INCLUDE:ST_DEF.INC'
      COMMON       /VMR/MADRID
      INCLUDE      'MID_INCLUDE:ST_DAT.INC'
C
 9001 FORMAT('*** INFO: Reduction factor range',I3,',',I3,' %')
 9002 FORMAT('          Area in pixel units: [',
     2                  I5, ',', I5, ':', I5, ',', I5, ']')
 9003 FORMAT('          Sigma=',F6.2,          '; Beta=',F6.2)  
 9004 FORMAT('          Saturation=',F10.2,'; Threshold=',F10.2)
 9005 FORMAT('          Maximum # objects=',I5,'; Maximum # holes=',I5)
 9006 FORMAT('          Group ',I6,' written:', I6,' star(s); ',
     2                                          I6,' hole(s)')
 9007 FORMAT(80('-'))
 9008 FORMAT(' Frequency of groups with N components')
 9009 FORMAT(' Group   N')
 9010 FORMAT(1X,I5,2X,I2,1X,'I',A40)
 9011 FORMAT(1X,I5,2X,I2,1X,'I')
 9012 FORMAT(' Number of components failed to group: ',I6)
 9013 FORMAT(' # comp.   perc.   mag.    index   H')
C9014 FORMAT(2X,I5,2X,I6,2X,F5.1,2X,F9.0,2X,'I',A40)
 9015 FORMAT(2X,I5,2X,I6,2X,F5.1,2X,F9.0,2X,'I')
 9017 FORMAT(2X,I5,2X,I6,2X,F5.1,2X,F9.0,2X,'I',40('B'))
 9018 FORMAT(2X,I5,2X,I6,2X,F5.1,2X,F9.0,2X,'I',40('G'))
 9019 FORMAT(' Number of components examined: ', I6, ' (total= ', I6,
     2       ' +', I5, ' at the edge)') 
 9020 FORMAT(' Number of components grouped:  ', I6)
 9021 FORMAT(' Number of groups:              ', I6)
C
C *****
      CALL STSPRO('GROUP')
C
C *** find file name and read the data
      CALL STKRDC('IN_A',1,1,60,IAC,FRAME,KUN,KNUL,ISTAT)
      CALL STFOPN(FRAME,D_R4_FORMAT,0,F_IMA_TYPE,IMF,ISTAT)
      CALL STDRDI(IMF,'NAXIS',1,1,IAC,NAXIS,KUN,KNUL,ISTAT)
CC      CALL STFCLO(IMF,ISTAT) 
C 
C *** get the area over which the grouping should be done
      CALL STKRDC('INPUTC',1,1,80,IAC,STRING,KUN,KNUL,ISTAT)
      CALL EXTCOO(IMF,STRING,NAXIS,NDUM,AREA(1),AREA(3),ISTAT)
C
      LX0 = AREA(1)
      LY0 = AREA(2)
      LX1 = AREA(3) - AREA(1) + 1
      LY1 = AREA(4) - AREA(2) + 1
      COO = 'A'
      IF (LX1.GT.0. AND. LY1.GT.0) THEN
         COO = 'S'
      ENDIF
C
C *** get the catalogue table
      CALL STKRDC('IN_B',1,1,60,IAV,CATFIL,KUN,KNUL,ISTAT)    ! get catalogue
C
C *** open the catalogue table
      CALL STECNT('GET',EC,ED,EL)
      CALL STECNT('PUT',1,0,0)
      CALL TBTOPN(CATFIL,F_IO_MODE,TIDCAT,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL: Problems with opening the catalogue'//
     2            ' table; Try again ...'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
C
      CALL TBIGET(TIDCAT,NCCAT,NRCAT,NSCAT,NACCAT,NARCAT,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL: Problems with getting info for'//
     2            ' catalogue table; Try again ...'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
      IF (NRCAT.EQ.0) THEN
         STRING = '*** FATAL: No data in the catalogue table'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
C
C *** read the descriptor data
      CALL CATDRD(TIDCAT,NST,NSF,NSPR,RMA,RME,NIX,NIY,NPL,NL,
     2                   XCEN,YCEN,DICI,DICS,IXW,IYW)
C
      IROW = 1
      CALL CATTRD(TIDCAT,IROW,CUU,VVV(1),VVV(2),VVV(3),VVV(4),
     2                        VVV(5),VVV(6),VVV(7),VVV(8),VVV(9),
     3                        VVV(10),VVV(11),VVV(12),VVV(13))
      SIGMA = VVV(9)
      BETA  = VVV(10)
      SATU  = VVV(11)
      AIN   = VVV(12)
      SIV   = VVV(13)
C
C *** get the intermediate tabel
      CALL STKRDC('OUT_A',1,1,60,IAV,INTFIL,KUN,KNUL,ISTAT)  ! get interm. name
      CALL TBTOPN(INTFIL,F_IO_MODE,TIDINT,ISTAT)
      IF (ISTAT.NE.0) THEN                                         ! new table
         IROW   = 1
         NGRP   = 0
         IDNGRP = 0
         NOBJ   = 0
         CALL INTINI(INTFIL,TIDINT)

      ELSE                                                  ! append old table 
         CALL TBIGET(TIDINT,NCINT,NRINT,NSINT,NACINT,NARINT,ISTAT)
         IF (ISTAT.NE.0) THEN
            STRING = '*** FATAL: Problems with getting info '//
     2               'for intermediate table ...'
            CALL STTPUT(STRING,ISTAT)
            CALL STSEPI
         ENDIF

         IF (NRINT.EQ.0) THEN
            STRING = '*** INFO: No points in the intermediate '//
     2               'table'
            CALL STTPUT(STRING,ISTAT)
            IROW   = 1
            NGRP   = 0
            IDNGRP = 0
            NOBJ   = 0
         ELSE

C *** get the intermediate table parameters
            CALL INTDRD(TIDINT,NGRP,NOBJ,IDUM3,RDUM1,RDUM2,RDUM3,
     2                                   RDUM4,RDUM5,RDUM6,RDUM7)
            IROW   = NRINT + 1
            IDNGRP = NGRP
         ENDIF
      ENDIF
      CALL STECNT('PUT',EC,ED,EL)
C
C *** get the threshold
      SSLA = 2.*SIGMA*SQRT(2.**(1/BETA)-1.)
      DWI  = SSLA
      CALL STKRDR('INPUTR',1,1,IAV,SUV,KUN,KNUL,ISTAT)
      IF (SUV.GT.0.) THEN
         SIV = SUV
      ENDIF
C      IF (SIV.LT.1.) THEN
C         SIV = 1.
C      ENDIF
      AM1 = -2.5*ALOG10(SIV)
      AM2 = -2.5*ALOG10(SATU)
C
C *** get maximum number of objects to group
      CALL STKRDI('INPUTI',1,1,IAV,NT,KUN,KNUL,ISTAT)
C
C *** get the action radius
      CALL STKRDR('INPUTR',2,2,IAV,RINPUT,KUN,KNUL,ISTAT)
      SMRA   = RINPUT(1)
      ZMRA   = RINPUT(2)
C
C *** get the window percentage
      CALL STKRDR('INPUTR',4,1,IAV,PFA,KUN,KNUL,ISTAT)
      PFA = PFA/100
      IF (SMRA.GT.ZMRA) THEN
         KAA  = SMRA
         SMRA = ZMRA
         ZMRA = KAA
      END IF
C
      DO 40 KN=1,NST
         CALL CATTRD(TIDCAT,KN,NOS(KN),DAT(2,KN),DAT(3,KN),DAT(4,KN),
     2               DAT(5,KN),DAT(6,KN),ZZ,ZZ,DAT(7,KN),
     3               RDUM9,RDUM10,RDUM11,RDUM12,RDUM13)
         DAT(1,KN) = KN
   40 CONTINUE
 
C
      IF (NT.EQ.0) THEN
         NT = NTU
      ENDIF
      IF (NT.GT.NTM .OR. NT.LT.0) THEN
         NT = NTU
      ENDIF
      NTC = NT
      NO  = (NCD-(6.5*FLOAT(NT)))/3.
      DO 50 I3 = 1,40
        CHB(I3:I3) = 'B'
        CHG(I3:I3) = 'G'
   50 CONTINUE
      DO 60 I3 = 1,NTM
         FLGCMP(I3) = 1
         FLGHOL(I3) = 1
   60 CONTINUE
C
C *** write the info 
      WRITE(STRING,9001) INT(SMRA),INT(ZMRA)
      CALL STTPUT(STRING,ISTAT)
      WRITE(STRING,9002) LX0,LY0,LX1,LY1
      CALL STTPUT(STRING,ISTAT)
      WRITE(STRING,9003) SIGMA,BETA
      CALL STTPUT(STRING,ISTAT)
      WRITE(STRING,9004) SATU,SIV
      CALL STTPUT(STRING,ISTAT)
      WRITE(STRING,9005) NT,NO
      CALL STTPUT(STRING,ISTAT)
      WRITE(STRING,9007)
      CALL STTPUT(STRING,ISTAT)

C
C *** start the automatic selection
      MQQ2 = 0
      MQQ3 = 0
      MQQ4 = 0
      MQQ5 = 0
      MQQ6 = 0
      MQQ7 = 0
      MQQ8 = 0
      MQQ9 = 0
      ISAV = 0
      NEX  = 0
      NRC  = 0
      LFI  = 0
      I    = 0
      ICA  = 0
      NCP  = 0
      NHL  = 0

  100 CONTINUE
        IF (I.GT.NST) GO TO 101
           IF (ICA.GE.3.AND.ICA.LE.7) THEN
              FAR = FAR - 0.0999999
              IF (FAR.LT.SMRA/100.) THEN
                 ICA = 8
              ELSE
                 ICA = 0
                 NC  = 2
              END IF
           ELSE
              I   = I+1
              FAR = ZMRA/100.
              ICA = 0
              NC  = 2
           END IF
C
           IF (ICA.EQ.0) THEN        ! legge la stella da esaminare (record i)
              DO 110 LI = 2,7
                 V(LI) = DAT(LI,I)
  110         CONTINUE
C
              IF (MOD(I,100).EQ.0 .AND. FAR.EQ.ZMRA/100.
     2                            .AND. IDNGRP.GT.NGRP) THEN
                 WRITE(STRING,9006) IDNGRP,NCP,NHL
                 CALL STTPUT(STRING,ISTAT)
              ENDIF
C
              IF (V(7).NE.2) THEN
                 IF (LFI.EQ.0) THEN
                    IF (V(7).EQ.0.OR.V(7).EQ.-1) THEN
                       LFI = 1
                       ITF = V(7)
                       ITT = IABS(ITF)-1
                    END IF
                 END IF
                 DO 120 LI = 1,7
                    SF(1,LI) = DAT(LI,I)
  120            CONTINUE
                 LOG = V(2).GE.LX0 .AND. V(2).LT.LX0+LX1
                 LOG = V(3).GE.LY0 .AND. V(3).LT.LY0+LY1 .AND. LOG
                 LOG = COO.EQ.'A'.OR.LOG
C
                 IF ((V(7).EQ.ITF .OR. V(7).EQ.9) .AND.
     2             V(4).GE.SIV.AND.LOG) THEN
                   ASSIGN 10011 TO CERINT
                   GO TO 10010
10011              CONTINUE
                   IF (ICA.EQ.0) THEN
                     DO 130 JIL = 1,NC-1
                        IF (SF(JIL,7).EQ.ITT) ICA = 4
  130                CONTINUE
                     IF (ICA.EQ.0) THEN
                       ASSIGN 10021 TO CERSTE
                       GO TO 10020
10021                  CONTINUE
                       IF (ICA.EQ.0) THEN
                         IDNGRP     = IDNGRP + 1
                         IGRP       = IGRP   + 1
                         IOBJ       = IOBJ   + NC - 1
C
C *** prepare the output for the intermediate table
                         NCP        = NC-1
                         NHL        = KC
C
                         PARINT(1)  = FLOAT(IX)
                         PARINT(2)  = FLOAT(IY)
                         PARINT(3)  = 0.0
                         PARINT(4)  = 0.0
                         PARINT(5)  = 0.0
                         PARINT(6)  = FLOAT(LX)
                         PARINT(7)  = FLOAT(LY)
                         PARINT(8)  = 0.0
                         PARINT(9)  = 0.0
                         PARINT(10) = FOME
                         PARINT(11) = BETA
                         PARINT(12) = 0.0
                         PARINT(13) = 0.0
                         PARINT(14) = 0.0
                         PARINT(15) = FLOAT(NCP)
                         PARINT(16) = FLOAT(NHL)
C
                         DO 140 J = 1,NCP
                           FITCMP((J-1)*6+1) = SF(J,4)
                           FITCMP((J-1)*6+2) = SF(J,2)-FLOAT(IX)+1
                           FITCMP((J-1)*6+3) = SF(J,3)-FLOAT(IY)+1
                           FITCMP((J-1)*6+4) = SIGMA 
                           FITCMP((J-1)*6+5) = 0.0
                           FITCMP((J-1)*6+6) = 0.0
                           IDNGRP            = NOS(I)
                           IDNCMP(J)         = 100+J
  140                    CONTINUE

                         IF (NHL.GT.0) THEN
                           DO 160 J = 1, NHL
                             FITHOL((J-1)*3+1) = IS(J,3)
                             FITHOL((J-1)*3+2) = IS(J,1)-FLOAT(IX)+1
                             FITHOL((J-1)*3+3) = IS(J,2)-FLOAT(IY)+1
                             IDNGRP            = NOS(I)
                             IDNHOL(J)         = 200+J
  160                      CONTINUE
                         ENDIF
C
C *** write the info into the intermediate table !!!
                         CALL INTWWR(TIDINT,IROW,NCP,NHL)
                         IROW = IROW + NCP + NHL
C
                         DO 165 JIL = 1,NC-1
                            HV = -2.5*ALOG10(SF(JIL,4))
                            IF (HV.LT.AM2) HV = AM2
                            IF (HV.GT.AM1) HV = AM1
                            NCAL       = (AM1-HV)/VPA+1
                            ISTB(NCAL) = ISTB(NCAL)+1
  165                    CONTINUE
                         ISTF(NC-1)=ISTF(NC-1)+1
                       END IF
                     END IF
                   END IF

                 ELSE   ! Prim. gia' esam. o sotto la soglia o fuori finestra
                    ICA=2
                 END IF
              ELSE
                 ICA=10
              END IF
           END IF

           IF (ICA.EQ.10) THEN
              MQQ2 = MQQ2+1
           ELSE IF (ICA.EQ.3.AND.ISAV.NE.I) THEN
              MQQ3 = MQQ3+1
              ISAV = I
           ELSE IF (ICA.EQ.4.AND.ISAV.NE.I) THEN
              MQQ4 = MQQ4+1
              ISAV = I
           ELSE IF (ICA.EQ.5.AND.ISAV.NE.I) THEN
              MQQ5 = MQQ5+1
              ISAV = I
           ELSE IF (ICA.EQ.6.AND.ISAV.NE.I) THEN
              MQQ6 = MQQ6+1
              ISAV = I
           ELSE IF (ICA.EQ.7.AND.ISAV.NE.I) THEN
              MQQ7 = MQQ7+1
              ISAV = I
           ELSE IF (ICA.EQ.8) THEN
              MQQ8 = MQQ8+1
           ELSE IF (ICA.EQ.9) THEN
              MQQ9 = MQQ9+1
           END IF
C        
           IF ((ICA.LT.3.OR.ICA.GT.7).AND.ICA.NE.10) THEN
              DO 170 L = 1,NC-1
                 IL = SF(L,1)
                 DO 171 JH = 2,7
                    VVV(JH+1) = DAT(JH,IL)
  171            CONTINUE
                 LOG  =  VVV(3).GE.LX0 .AND. VVV(3).LT.LX0+LX1
                 LOG  =  VVV(4).GE.LY0 .AND. VVV(4).LT.LY0+LY1 .AND.
     2                   LOG
                 LOG  =  COO.EQ.'A' .OR. LOG
                 LOG1 = (VVV(8).EQ.ITF .OR. VVV(8).EQ.9) .AND.
     2                   VVV(5).GE.SIV
                 IF (LOG1.AND.LOG) NEX = NEX+1
                 IF (ICA.NE.0 .AND. VVV(8).EQ.ITF .AND. ICA.NE.2) THEN
                    IF (VVV(5).GE.SIV .AND. LOG) THEN
                       HV = -2.5*ALOG10(VVV(5))
                       IF (HV.LT.AM2) HV = AM2
                       IF (HV.GT.AM1) HV = AM1
                       NCAL       = (AM1-HV)/VPA+1
                       ISTC(NCAL) = ISTC(NCAL)+1
                       NRC        = NRC+1
                    END IF
                 END IF
                 IF (VVV(8).EQ.ITF .OR. VVV(8).EQ.9) THEN
                    IF (ICA.EQ.0) THEN
                       VVV(8) = 1
                    ELSE
                       IF (LOG) THEN
                          VVV(8) = ITT
                       ELSE
                          VVV(8) = 9
                       END IF
                    END IF
                 END IF
                 DO 172 JH = 2,7
                    DAT(JH,IL) = VVV(JH+1)
  172            CONTINUE
  170         CONTINUE
           END IF
           GO TO 100
  101   CONTINUE

        DO 210 JIL = 1,NST
           CALL CATTRD(TIDCAT,JIL,CUU,VVV(3),VVV(4),VVV(5),VVV(6),
     2                 VVV(7),VVV(8),VVV(9),VVV(10),VVV(11),VVV(12),
     3                 VVV(13),VVV(14),VVV(15))
           IF (DAT(7,JIL).EQ.ITF) THEN
              DAT(7,JIL) = ITT
           ENDIF

           DO 220 JH = 2,7
              VVV(JH+1) = DAT(JH,JIL)
  220      CONTINUE
           VVV(10) = VVV(8)
           CALL CATTWR(TIDCAT,JIL,CUU,VVV(3),VVV(4),VVV(5),VVV(6),
     2                 VVV(7),VVV(8),VVV(9),VVV(10),VVV(11),VVV(12),
     3                 VVV(13),VVV(14),VVV(15))
  210   CONTINUE

        IF (IOBJ.GT.0) THEN
           NGRP = NGRP + IGRP
           NOBJ = NOBJ + IOBJ
           RDUM = 0.0
           CALL INTDWR(TIDINT,NGRP,NOBJ,IDUM3,SATU,RDUM3,SIGMA,
     2                        BETA,SIV,AIN,FOG)
        END IF

        MAF = -32000
        MAC = MAF
        DO 230 JIL = 1,NT
           MAF = MAX0(MAF,ISTF(JIL))
  230   CONTINUE
        NCAL = (AM1-AM2)/VPA+1
        DO 240 JIL = 1,NCAL
           MAC = MAX0(MAC,ISTC(JIL))
  240   CONTINUE
C
        IF (MAF.GT.0.) THEN
           WRITE(STRING,9007)
           CALL STTPUT(STRING,ISTAT)
           WRITE(STRING,9008)
           CALL STTPUT(STRING,ISTAT)
           WRITE(STRING,9009)
           CALL STTPUT(STRING,ISTAT)
C
           DO 250 JIL = 1,NT
              INF = ISTF(JIL)*40/MAF
              IF (INF.GT.0) THEN
                 XXX = ' '
                 DO 251 JI = 1,INF
                    XXX(JI:JI) = 'X'
  251            CONTINUE            
                 WRITE(STRING,9010) ISTF(JIL),JIL,XXX(1:40)
                 CALL STTPUT(STRING,ISTAT)
              ELSE
                 WRITE(STRING,9011) ISTF(JIL),JIL
                 CALL STTPUT(STRING,ISTAT)
              END IF
  250      CONTINUE
        ELSE
           STRING = 'No groups found in the data set'
           CALL STTPUT(STRING,ISTAT)
        END IF
C
C       IF (MAC.GT.0.) THEN
C          WRITE(STRING,9007)
C          CALL STTPUT(STRING,ISTAT)
C          WRITE(STRING,9012) NRC
C          CALL STTPUT(STRING,ISTAT)
C          WRITE(STRING,9013)
C          CALL STTPUT(STRING,ISTAT)

C          DO 260 JIL = 1,NCAL
C             INF  = ISTC(JIL)*40/MAC
C             ANCL = -JIL*VPA+VPA
C             HHS  = 10.**(-.4*(ANCL+AM1))
C
C             IF (INF.GT.0) THEN
C                XXX = ' '
C                DO 261 JI = 1,INF
C                   XXX(JI:JI) = 'X'
C 261            CONTINUE
C                IPERCE = (100.*ISTC(JIL))/(ISTC(JIL)+ISTB(JIL))
C                WRITE(STRING,9014) ISTC(JIL),IPERCE,ANCL+AM1,HHS,
C    2                              XXX(1:40)
C             ELSE
C                IF (ISTC(JIL)+ISTB(JIL).NE.0) THEN
C                   IPERCE = (100*ISTC(JIL))/(ISTC(JIL)+ISTB(JIL))
C                ELSE
C                   IPERCE = 0
C                END IF
C                WRITE(STRING,9015) ISTC(JIL),IPERCE,ANCL+AM1,HHS
C             END IF
C             CALL STTPUT(STRING,ISTAT)
C 260      CONTINUE
C       END IF

        MAT  = -32000
        NCAL = (AM1-AM2)/VPA+1
        DO 270 JIL = 1,NCAL
           MAT = MAX0(ISTC(JIL)+ISTB(JIL),MAT)
  270   CONTINUE

        IF (MAT.GT.0) THEN
           WRITE(STRING,9007)
           CALL STTPUT(STRING,ISTAT)
           WRITE(STRING,9012) NRC
           CALL STTPUT(STRING,ISTAT)
           WRITE(STRING,9013)
           CALL STTPUT(STRING,ISTAT)

           DO 280 JIL = 1,NCAL
              INF  = ((ISTC(JIL)+ISTB(JIL))*40.)/MAT
              INFC = (ISTC(JIL)*40.)/MAT+0.5
              INFB = INF-INFC
              ANCL = -JIL*VPA+VPA
              HHS  = 10.**(-.4*(ANCL+AM1))
              IF (INF.GT.0) THEN
                 IPERCE = (100*ISTC(JIL))/(ISTC(JIL)+ISTB(JIL))
                 IF (INFB.GT.0 .AND. INFC.GT.0) THEN
                    STRING = ' '
                    WRITE(STRING,9015) ISTC(JIL),IPERCE,ANCL+AM1,HHS
                    INFT = 36  + INFB + INFC
                    STRING(37:36+INFB)   = CHG(1:INFB)
                    STRING(37+INFB:INFT) = CHB(1:INFC)
                    IF (INFT.GT.79) THEN
                       CALL STTPUT(STRING,ISTAT)
                    ELSE
                       TEXT(1:79) = STRING(1:79)
                       CALL STTPUT(TEXT,ISTAT)
                    ENDIF
 
                 ELSE IF(INFC.GT.0) THEN
                    STRING = ' '
                    WRITE(STRING,9017) 
                    LMW = INFC + 37
                    CALL STTPUT(STRING(1:LMW),ISTAT)
                 ELSE
                    STRING = ' '
                    WRITE(STRING,9018) ISTC(JIL),IPERCE,ANCL+AM1,HHS
                    LMW = INFB + 37
                    CALL STTPUT(STRING(1:LMW),ISTAT)
                 END IF

              ELSE
                 IF (ISTC(JIL)+ISTB(JIL).NE.0) THEN
                    IPERCE = (100.*ISTC(JIL))/(ISTC(JIL)+ISTB(JIL))
                 ELSE
                    IPERCE = 0
                 END IF
                 STRING = ' '
                 WRITE(STRING,9015) ISTC(JIL),IPERCE,ANCL+AM1,HHS
                 CALL STTPUT(STRING(1:40),ISTAT)
              END IF
  280      CONTINUE
        END IF

        WRITE(STRING,9007)
        CALL STTPUT(STRING,ISTAT)
        NSMQ = NST-MQQ2
        WRITE(STRING,9019) NEX,NSMQ,MQQ2
        CALL STTPUT(STRING,ISTAT)
        WRITE(STRING,9020) IOBJ
        CALL STTPUT(STRING,ISTAT)
        WRITE(STRING,9021) IGRP
        CALL STTPUT(STRING,ISTAT)

        CALL TBSINI(TIDINT,ISTAT)
        CALL TBTCLO(TIDINT,ISTAT)
        CALL TBTCLO(TIDCAT,ISTAT)
        CALL STSEPI

C +++
C   Procedure CERINT
C---
10010   CONTINUE

        NI  = 1
        NT  = NTC
        KSR = 0
        RA  = SF(1,6)
        ICA = 0
        CALL INTERS(SF,NTM,NTC,NC,NI,IFNM,RMA,NST,FAR,DAT)
        IF(IFNM.EQ.0) THEN  ! Trovate troppe compagne della primaria che non si
           ICA = 3          ! risolve neppure diminuendo il suo raggio d'azione
        END IF

        IF (ICA.EQ.0) THEN
           SF(1,6) = RA
           KS      = 1
           IF (NC.GT.2) THEN
10110         CONTINUE
              IF (NC-1.EQ.NI .OR. KS.NE.1) GO TO 10210
              NI = NI+1
              CALL INTERS(SF,NTM,NTC,NC,NI,IFNM,RMA,NST,FAR,DAT)
              IF (IFNM.EQ.0) THEN    ! Stelle che si intersecano superano il 
                 KS  = -1                             ! limite imposto da NT
                 ICA = 5
              END IF
              GO TO 10110
10210         CONTINUE
           END IF
        END IF
        GO TO CERINT

C +++
C   Procedure CERSTE
C---
10020   CONTINUE

        IXMA = -32000
        IXMI = -IXMA
        IYMA = IXMA
        IYMI = IXMI
        FOME = 0.

        DO 10120 J = 1,NC-1
           IXMA = MAX0(IXMA,INT(SF(J,2)+SSLA))
           IXMI = MIN0(IXMI,INT(SF(J,2)-SSLA))
           IYMA = MAX0(IYMA,INT(SF(J,3)+SSLA))
           IYMI = MIN0(IYMI,INT(SF(J,3)-SSLA))
           FOME = FOME+SF(J,5)
10120   CONTINUE
C 
        FOME = FOME/FLOAT(NC-1)
        DEX  = IXMA-IXMI+1
        DEY  = IYMA-IYMI+1
C
        IF (DEX.GT.NDX .OR. DEY.GT.NDY) THEN   ! Matrice per il fit supera i 
           ICA = 6                             ! limiti imposti da NDX,NDY
        ELSE
C          Vengono calcolate le dimensioni della matrice di dati
C          stella isolata : e' pari a 6 volte la larghezza della
C          PSF a meta altezza.
C          stelle multiple: e' pari alla somma fra la distanza delle
C          Stelle piu' estreme della finestra e 4 volte la larghezza
C          a meta' altezza della PSF scelta.
C
           DW2 = DWI
           IF (NC-1.EQ.1) THEN
              DW2 = 3.5*SSLA
           ELSE
              IF (NC-1 .LE. 6) THEN
                 DW2 = 2.*SSLA
              ENDIF
           ENDIF

           LX = DEX+1+2*DW2
           LY = DEY+1+2*DW2
           LX = LX*PFA
           LY = LY*PFA
           LX = MIN0(LX,NDX)
           LY = MIN0(LY,NDY)
           IX = IXMI-(LX-DEX)/2.
           IY = IYMI-(LY-DEY)/2.

           IF (IX.LT.NIX) THEN
              LX = LX+IX-NIX
              IX = NIX
           END IF
           IF (IY.LT.NIY) THEN
              LY = LY+IY-NIY
              IY = NIY
           END IF
 
           IF (IX+LX-1 .GT. NPL+NIX-1) LX = NPL+NIX-IX
           IF (IY+LY-1 .GT. NL+NIY-1)  LY = NL+NIY-IY
           INX = IX-RMA
           INY  = IY-RMA
           IFX  = IX+LX-1+RMA+.5
           IFY  = IY+LY-1+RMA+.5
           V(3) = SF(1,3)
           J    = SF(1,1)
           KC   = 0
           NBW  = (NCD-(6.5*(NC-1)))/3.

10220      CONTINUE
           IF (J.GE.NST .OR. V(3).GT.IFY .OR. ICA.NE.0) GO TO 10320
              J = J+1
              CALL COSTEL(K,IFL,NC,J,SF,NTM)
C
              IF (IFL.EQ.0) THEN
                 IF (KC.LT.NBW) THEN
                    DO 10420 K = 2,7
                       V(K) = DAT(K,J)
10420               CONTINUE
                    IF (V(3).LE.IFY) THEN
                       CALL LIMITX(V,IS,NOB,KC,IX,IY,LX,LY)
                    END IF
                 ELSE     !Il numero dei buchi supera il limite imposto da NBW
                    ICA = 7
                 END IF
              END IF
              GO TO 10220
C
10320      CONTINUE
           V(3) = SF(1,3)
           J    = SF(1,1)
 
10520      CONTINUE
           IF (J.LE.1 .OR. V(3).LT.INY .OR. ICA.NE.0) GO TO 10620
              J = J-1
              CALL COSTEL(K,IFL,NC,J,SF,NTM)
 
              IF (IFL.EQ.0) THEN
                 IF (KC.LT.NBW) THEN
                    DO 10521 K = 2,7
                       V(K) = DAT(K,J)
10521               CONTINUE
                    IF (V(3).GE.INY) THEN
                       CALL LIMITX(V,IS,NOB,KC,IX,IY,LX,LY)
                    END IF
                 ELSE       !Il numero dei buchi supera il limite imposto da NBW
                    ICA = 7
                 END IF
              END IF
              GO TO 10520
10620      CONTINUE
        END IF

        JIL = 0
10720   CONTINUE
        IF (JIL.GE.KC .OR. ICA.NE.0) GO TO 10820
           JIL = JIL+1
           RA  = IS(JIL,3)**2
           JEL = 0
10920      CONTINUE
           IF (JEL.GE.(NC-1) .OR. ICA.NE.0) GO TO 11020
              JEL = JEL+1
              RAS = SF(JEL,6)**2
              DIS = (IS(JIL,1)-SF(JEL,2))**2+(IS(JIL,2)-SF(JEL,3))**2
              IF (DIS.LE.RA) THEN
                 IF (IS(JIL,4).EQ.2) THEN
                    IS(JIL,3) = SQRT(DIS)-1.
                 ELSE
                    ICA = 9
                 END IF
              END IF
              IF (DIS.LE.RAS) THEN
                 IF (IS(JIL,4).NE.2) THEN 
                    ICA = 9
                 END IF
              END IF
              GO TO 10920
11020      CONTINUE
           GO TO 10720
10820   CONTINUE

        GO TO CERSTE
        END

C @(#)lsfun1i.for	19.1 (ES0-DMD) 02/25/03 13:17:40
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C @(#)lsfun1i.for	2.1.1.1 (ESO-IPG) 9/27/91 18:10:00
      SUBROUTINE LSFU1I(NRRES,NRPRM,PRM,FCTVEC,PIXEL,WEIGHT,IDIM1,            
     +                    IDIM2,IDIM3)                                          
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++        
C                                                                               
C.MODULE                                                                        
C       FIT                                                                     
C                                                                               
C.NAME                                                                          
C       LSFUN1_I                                                                
C                                                                               
C.PURPOSE                                                                       
C       Function to compute the approximating function at each point,           
C       for FIT/IMAG                                                            
C                                                                               
C.KEYWORDS                                                                      
C       Approximating Function.                                                 
C                                                                               
C.DESCRIPTION                                                                   
C       Read the TABLE row by row, and compute the fitting function by          
C       calling MIDAS functions                                                 
C                                                                               
C.LANGUAGE                                                                      
C       FORTRAN                                                                 
C                                                                               
C.CALLING SEQUENCE                                                              
C  CALL LSFUN1_I(NRRES,NRPRM,PRM,FCTVEC,PIXEL,WEIGHT,IDIM1,IDIM2,IDIM3)         
C                                                                               
C.INPUT PARAMETERS                                                              
C       NRRES               INTEGER  Number of residuals                        
C       NRPRM             INTEGER  Number of parameters                         
C       PRM (NRPRM)       DOUBLE   Parameters                                   
C       PIXEL (IDIM_)       REAL     pixel values of the image                  
C       WEIGHT (IDIM_)      REAL     weighting factors                          
C       IDIM_               INTEGER  dimension of the 3-dim image.              
C                                                                               
C.MODIFIED PARAMETERS                                                           
C       none                                                                    
C                                                                               
C.OUTPUT PARAMETERS                                                             
C       FCTVEC (NRRES)      DOUBLE   Approximating values                       
C                                                                               
C.FILES                                                                         
C       FIT_NAG.INC/NOLIST                                                      
C                                                                               
C.MODULES CALLED                                                                
C       FTFUNC                                                                  
C                                                                               
C.AUTHOR                                                                        
C       Ph. DEFERT,      Feb 1986                                               
C                                                                               
C.MODIFICATIONS                                                                 
C                                                                               
C      MODIF APR92 MP put correct coordinates of pixels  !!!!!             
C-----------------------------------------------------------------------        
C      IMPLICIT NONE                                                            
C                                                                               
C     .. Scalar Arguments ..                                                    
      INTEGER NRPRM,NRRES,IDIM1,IDIM2,IDIM3,MADRID(1)                           
C     ..                                                                        
C     .. Array Arguments ..                                                     
      DOUBLE PRECISION FCTVEC(NRRES),PRM(NRPRM)                                 
      REAL PIXEL(IDIM1,IDIM2,IDIM3),WEIGHT(IDIM1,IDIM2,IDIM3)                   
C     ..                                                                        
C     .. Scalars in Common ..                                                   
      INTEGER NRCOL,ISTAR                                                       
      CHARACTER WGTTYP*1                                                        
C     ..                                                                        
C     .. Arrays in Common ..                                                    
      INTEGER ICOL(10)                                                          
C     ..                                                                        
C     .. Local Scalars ..                                                       
      DOUBLE PRECISION W,Y,Y1,YOUT,YY                                           
      INTEGER IFUN,K,BEGFCT,IP,I1,I2,I3,IPNT                                    
C     ..                                                                        
C     .. Local Arrays ..                                                        
      DOUBLE PRECISION DUMMY(10)                                                
      REAL X(10)                                                                
C     ..                                                                        
C     .. Common blocks ..                                                       
C     ..                                                                        
C     .. External Files ..                                                      
       INCLUDE 'MID_INCLUDE:FITNAGI.INC/NOLIST'                                 
       INCLUDE 'MID_INCLUDE:FITNAGC.INC/NOLIST'                                 
      COMMON /VMR/MADRID                                                     
      COMMON /LSQFUN/ICOL,NRCOL,ISTAR,WGTTYP                                    
C     ..                                                                        
C     .. Executable Statements ..                                               
C                                                                               
C   deal with simple linear constraints                                         
C                                                                               
      DO 10 K = 1,NRPRM                                                         
          IP     = FIXPAR(K)                                                    
          IF (IP.EQ.0) PRM(K) = PARINI(K)                                       
          IF (IP.GT.0) THEN                                                     
              PRM(K) = PRM(IP)*PRPFAC(K)                                        
              PARAM(K) = PRM(K)                                                 
          END IF                                                                
                                                                                
   10 CONTINUE                                                                  
C                                                                               
C   go through the all image                                                    
C                                                                               
      X(1)   = START(1)                                                         
      X(2)   = START(2)                                                         
      X(3)   = START(3)                                                         
      IPNT   = 0                                                                
      DO 50 I3 = 1,NRPIX(3)                                                     
          X(2) = START(2)
          DO 40 I2 = 1,NRPIX(2)                                                 
              X(1) = START(1)
              DO 30 I1 = 1,NRPIX(1)                                             
C                                                                               
C   compute weights                                                             
C                                                                               
                  Y      = PIXEL(I1,I2,I3)                                      
                  IPNT   = IPNT + 1                                             
                  Y      = PIXEL(I1,I2,I3)                                      
                  IF (WGTTYP(1:1).EQ.'C') THEN                                  
                      W      = 1.                                               
                                                                                
                  ELSE IF (WGTTYP(1:1).EQ.'W') THEN                             
                      W      = WEIGHT(I1,I2,I3)                                 
                                                                                
                  ELSE IF (WGTTYP(1:1).EQ.'S') THEN                             
                      YY     = ABS(Y)                                           
                      IF (YY.LT.1.E-12) THEN                                    
                          W      = 1.                                           
                                                                                
                      ELSE                                                      
                          W      = 1./YY                                        
                      END IF                                                    
                                                                                
                  ELSE IF (WGTTYP(1:1).EQ.'I') THEN                             
                      W      = 1./WEIGHT(I1,I2,I3)**2                           
                  END IF                                                        
C                                                                               
C   Compute fitting values                                                      
C                                                                               
                  Y1     = 0.D0                                                 
                  BEGFCT = 1                                                    
                  DO 20 IFUN = 1,NRFUN                                          
                      CALL FTFUNC(FCTCOD(IFUN),NRIND,X,ACTPAR(IFUN),            
     +                            PRM(BEGFCT),YOUT,DUMMY)                       
                      Y1     = Y1 + YOUT                                        
                      BEGFCT = BEGFCT + ACTPAR(IFUN)                            
   20             CONTINUE                                                      
                  FCTVEC(IPNT) = SQRT(W)* (Y1-Y)                                
                  X(1)   = X(1) + STEP(1)                                       
   30         CONTINUE                                                          
              X(2)   = X(2) + STEP(2)                                           
   40     CONTINUE                                                              
          X(3)   = X(3) + STEP(3)                                               
   50 CONTINUE                                                                  
      RETURN                                                                    
                                                                                
      END                                                                       

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
         PROGRAM DANISH
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENT         danish.for
C.MODULE
C.AUTHOR        Andrew T. Young
C.KEYWORD
C.LANGUAGE      FORTRAN 77
C.PURPOSE       convert Danish photometric data files to uniform ascii
C.COMMENTS
C.VERSION       5.2    ATY  April 21, 1993
C 
C 100621	last modif
C-----------------------------------------------------------------------------
C*****************************************************************************
C
C       This program reads data recorded in intermixed formats and combines
C       them into a uniform format, in the file 'data.dat' that is converted
C       into a MIDAS table-format file, using the *.fmt file 'data.fmt'.
C
C       The version you see here is designed to convert data from the Danish
C       0.5-meter telescope.  Data codes are in col. 1.
C       These codes are read and decoded at statements 110-190 in the main
C       program.
C
C       The basic method is to load the data as they are read from different
C       types of cards into the COMMON blocks /OUTR/ and /OUTC/, which hold
C       real and character variables, respectively.  (Some compilers want you
C       to keep such blocks separate.)  When enough card images have been read
C       to make a complete observation, the contents of /OUT*/ are written to
C       the uniform-format file 'data.dat'; then the common blocks are cleared,
C       to the appropriate "null" values.  (Blanks are used to clear character
C       strings.)
C
C       The MIDAS command CREATE/TABLE can then be used, with the *.fmt file
C       supplied, to convert the uniform 'data.dat' file to MIDAS table format.
C       This is done in the command CONVERT/PHOT.
C
C       As this is based on the esodcon program, it probably contains fossils.
C
C
C*****************************************************************************
C
        IMPLICIT NONE
C
C  BEGIN Declarations:
C
        DOUBLE PRECISION DJD, OLDMJD
C
        REAL DIAM, ELONG, PHI
C
        INTEGER INULL
        REAL RNULL
        DOUBLE PRECISION DNULL
        COMMON /NULLS/ INULL, RNULL, DNULL
C
        INTEGER NDATA, NOUTP
C
        INTEGER NREC,NRECOLD
C
        INTEGER NBAD(4)
        REAL RELERR(4),COUNT(4)
C
        CHARACTER*80 LINE(2), DATFIL
        COMMON /LINES/LINE
        INTEGER LENBUF, NOW
        COMMON /BUF/LENBUF, NOW
C
        INTEGER ITBL, ISTAT, NCOLS, NROWS, NSORTC, NWPRAL, 
     1         NROWSAL, NCOL, NCDIAM, NROW, I, NBANDS, J, LWORD, K, K2
C
        CHARACTER A*1, CODE*2, END*1, STATUS*7
        CHARACTER*10 LSTSTR,OLDLST
        CHARACTER*32 COM1,COM2,COM3
C 
        CHARACTER*32  CTEST
C
        CHARACTER BNDCOD(6),BNAME(6)*5,CODES(4)
C
        LOGICAL MATCH
        LOGICAL EFLAG
C
C
C       Declarations for the output (must be in WRITER too!):
C
        DOUBLE PRECISION MJDOBS
        REAL SIGNAL,EXPTIME,ESTERR
        COMMON /OUTR/ SIGNAL,EXPTIME,MJDOBS,ESTERR
        CHARACTER OBJECT*9,STARSKY*4,BAND*8,COMMENT*32,DIAPH
        COMMON /OUTC/ OBJECT,STARSKY,BAND,COMMENT,DIAPH
C
C  Set up MIDAS declarations:
C
        INTEGER MADRID(1)
C
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
        COMMON /VMR/ MADRID
C
        INTEGER NACTEL, IUNIT, NULLS
C
C  END Declarations.
C
C
C  BEGIN DATA statements:
C
        INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
        DATA NDATA/7/, NOUTP/8/
C
        DATA BNDCOD/'U', 'V', 'B', 'Y',   'W',    'N'/
        DATA BNAME /'u', 'v', 'b', 'y', 'betaW','betaN'/
C
C
C  END DATA statements.
C
C
C  ********************  PROLOGUE  ********************
C
        CALL STSPRO ('DANISH')
C
C       Because the Sun library barfs on -Inf (which is used as NULL
C       by MIDAS), I define my own "NULL" values here as 3.e33:
C
        RNULL=3.E33
        DNULL=3.D33
C
C  Real program begins here:            (use RUN DANISH to test in MIDAS)
C
C
        INQUIRE(FILE='data.dat',EXIST=EFLAG)
        IF (EFLAG) THEN
                CALL TV('File "data.dat" already exists!')
    1           CALL ASK ('Do you want to write over it?? ',A)
                IF (MATCH(A,'Y')) THEN
                        OPEN(NOUTP,FILE='data.dat',STATUS='UNKNOWN')
                        REWIND NOUTP
C                       Make sure it gets truncated to zero length.
                        CLOSE (NOUTP,STATUS='DELETE')
                ELSE IF (MATCH(A,'N')) THEN
                        CALL STETER(1,
     1                  'Please move "data.dat" to a new name.')
                ELSE
                        CALL TV('Please reply "yes" or "no".')
                        GO TO 1
                END IF
         END IF
C               Open the uniform-format ascii file:
        OPEN(NOUTP,FILE='data.dat',STATUS='UNKNOWN')
        REWIND NOUTP
C
C       Find telescope coordinates:
C
        INQUIRE (FILE='esotel.tbl', EXIST=EFLAG)
        IF (EFLAG) THEN
                CALL TBTOPN ('esotel.tbl', 0,  ITBL, ISTAT)
                IF (ISTAT.NE.0) THEN
                        CALL TV('Problem opening "esotel.tbl".')
                        CALL STETER(2,'Do you have read permission?')
                END IF
                CALL TBIGET (ITBL,
     1                    NCOLS, NROWS, NSORTC, NWPRAL, NROWSAL, ISTAT)
                CALL TBLSER (ITBL, 'TELESCOP',  NCOL, ISTAT)
                CALL TBLSER (ITBL, 'DIAM',  NCDIAM, ISTAT)
                CALL TV(' ')
                CALL TV ('Which telescope did you use?')
                DO 2 NROW=1,NROWS
                CALL TBERDC (ITBL, NROW, NCOL, CTEST, EFLAG, ISTAT)
                CALL FT_EOS (CTEST,32,COM2,ISTAT)
                IF (EFLAG.OR. ISTAT.NE.0) GOTO 2
                CALL TBERDR (ITBL, NROW, NCDIAM,  DIAM, EFLAG, ISTAT)
                IF (EFLAG.OR. ISTAT.NE.0) GOTO 2
                WRITE (COM1,'(8X,I2,'':  '',A8,F6.2,'' m'')')
     1                              NROW,COM2,DIAM
                CALL TV (COM1)
    2           CONTINUE
                WRITE(COM1,'(8X,I2,'':  (None of these)'')') NROWS+1
                CALL TV(COM1)
                CALL ASK ('Please enter the number: ',COM1)
    3           READ (COM1,'(BN,I2)', ERR=4) NROW
                IF (NROW.LE.NROWS .AND. NROW.GE.1) THEN
                       CALL TBERDC (ITBL,NROW,NCOL,CTEST,EFLAG,ISTAT)
                       CALL FT_EOS (CTEST,32,COM2,ISTAT)
                ELSE
                        COM2='"none"'
                END IF
                GO TO 6
C
C               Bad row number:
    4           DO 5 NROW=1,NROWS
                CALL TBERDC (ITBL, NROW, NCOL,CTEST, EFLAG, ISTAT)
                CALL FT_EOS (CTEST,32,COM2,ISTAT)
                IF (COM1.EQ.COM2) THEN
                        GO TO 6
                END IF
    5           CONTINUE
                CALL ASK ('Please use the numbers at left.',COM1)
                GO TO 3
C
    6           WRITE(COM1,'(''   You selected '',A8)') COM2
                CALL TV (COM1)
C
                IF (INDEX(COM2,'DAN').NE.1) THEN
                   CALL TV('Not a Danish telescope.  Please try again.')
                   GO TO 3
                END IF
C
                IF (NROW.LE.NROWS .AND. NROW.GE.1) THEN
                        CALL TBLSER (ITBL, 'LON',  NCOL, ISTAT)
                        CALL TBERDR (ITBL,NROW,NCOL, ELONG,EFLAG,ISTAT)
                        IF(EFLAG.OR. ISTAT.NE.0) THEN
                            CALL QF('Enter EAST longitude (deg):',
     1                                 ELONG)
                        END IF
                        CALL TBLSER (ITBL, 'LAT',  NCOL, ISTAT)
                        CALL TBERDR (ITBL,NROW,NCOL, PHI,EFLAG,ISTAT)
                        IF(EFLAG.OR. ISTAT.NE.0) THEN
                             CALL QF('Enter Latitude (deg):', PHI)
                        END IF
                ELSE
                        CALL QF('Enter EAST longitude (deg):', ELONG)
                        CALL QF('Enter Latitude (deg):', PHI)
                END IF
                ELONG=ELONG/15.
                CALL TBTCLO(ITBL, ISTAT)
        ELSE
                CALL TV('File "esotel.tbl" not available!')
                CALL STETER(6,'Please get a copy of "esotel.tbl"')
        END IF
C
C
C       clear data storage:
C
        OBJECT=' '
        STARSKY=' '
        BAND=' '
        DIAPH=' '
        COMMENT=' '
        SIGNAL=RNULL
        ESTERR=RNULL
        EXPTIME=RNULL
        MJDOBS=DNULL
C
C       *** Prepare input buffer ***
C
        CALL TV(' ')
    7   Call STKRDC ('RAWDAT',1,1,80,  NACTEL,DATFIL,IUNIT,NULLS,ISTAT)
C   7   CALL ASKFIL('What is the name of the file of observed data?',
C    1                  DATFIL)
        INQUIRE(FILE=DATFIL,EXIST=EFLAG)
        IF (.NOT.EFLAG) THEN
                CALL TV('No such file exists!')
                CALL TVN('Please try again:')
                GO TO 7
        END IF
        OPEN(NDATA,FILE=DATFIL,STATUS='UNKNOWN')
        REWIND NDATA
        CALL TV('Converting data...')
C
        OLDMJD=0.
        NRECOLD=0
        OLDLST=' '
C
C       Read data.
C
  110   READ (7,'(A80)',END=200) LINE(1),LINE(2)
C
C
C           Start reading first card:
            A=LINE(1)(:1)
            IF (A.EQ.'c') GO TO 112
            READ (LINE(1),111,ERR=301) A,NREC,DJD,LSTSTR,STATUS
  111       FORMAT(A1,I4,F12.5,2(1X,A7))
C           Convert Danish MJD to real JD.
            DJD=DJD+2440000.D0
C           Convert real JD to MJD.
            MJDOBS=DJD-2400000.5D0
C           Check that times are in order.
            IF (MJDOBS.LT.OLDMJD .OR. NREC.LT.NRECOLD .OR.
     1                (LSTSTR.LT.OLDLST .AND. LSTSTR(:2).NE.'00')) THEN
               CALL SPACE2
               CALL TV('     Sequence error:')
               CALL TV('Record    Danish JD      LST')
               CALL TVN('------   -----------   -------')
               WRITE(DATFIL,'(I4,5X,F11.5,3X,A)')
     1                      NRECOLD,OLDMJD-39999.5,OLDLST
               IF (DATFIL(10:10).EQ.' ') DATFIL(10:10)='0'
               CALL TVN(DATFIL)
               CALL TV('    is followed by')
               WRITE(DATFIL,'(I4,5X,F11.5,3X,A)')
     1                      NREC,MJDOBS-39999.5,LSTSTR
               IF (DATFIL(10:10).EQ.' ') DATFIL(10:10)='0'
               CALL TV(DATFIL)
C
               I=0
               CALL SPACE2
               IF (NREC.LT.NRECOLD) THEN
                  CALL TVN('     RECORD numbers out of order')
                  I=1
               END IF
C
               IF (MJDOBS.LT.OLDMJD) THEN
                  CALL TVN('     JDs out of order')
                  I=2
               END IF
C
               IF (LSTSTR.LT.OLDLST .AND. LSTSTR(:2).NE.'00' .AND.
     1                      OLDLST(:2).NE.'23') THEN
                  CALL TVN('     LSTs out of order')
                  I=4
               END IF
C
               IF (I.EQ.1)THEN
                  CALL TV('Bad record number?')
               ELSE IF (I.EQ.2) THEN
                  CALL TV('JD is probably wrong; others are in order.')
               ELSE IF (I.EQ.4) THEN
                  CALL TV('LST is probably wrong; others are in order.')
               END IF
            END IF
            OLDMJD=MJDOBS
            NRECOLD=NREC
            OLDLST=LSTSTR
C
            DIAPH=STATUS(2:2)
C
C
  112       IF (A.EQ.'s') THEN
C
C                       s: measurement
C
C               Finish reading first card:
                READ(LINE(1),113,ERR=392)EXPTIME,OBJECT,CODE
  113           FORMAT(40X,F3.0,1X,A9,1X,A2)
                IF (EXPTIME.EQ.0.) THEN
                   DATFIL='ZERO exposure time at MJDOBS ='
                   WRITE(DATFIL(31:),'(F12.5)') MJDOBS
                   CALL TV(DATFIL)
                   CALL TVN('   Observation rejected.')
                   GO TO 110
                END IF
C               convert MJDOBS from end to start of exposure.
                MJDOBS=MJDOBS-EXPTIME/86400.
C
C               Interpret second card:
                IF (STATUS(:1).EQ.'U')THEN
C                   uvby data:
                    READ(LINE(2),114,ERR=393)
     1                 (CODES(I),COUNT(I),RELERR(I),NBAD(I),I=1,4),END
  114               FORMAT(4(A1,F9.0,1X,F4.4,I3,1X),A1)
                    NBANDS=4
                ELSE IF (STATUS(:1).EQ.'H')THEN
C                   H-beta data:
                    READ(LINE(2),115,ERR=394)
     1                 (CODES(I),COUNT(I),RELERR(I),NBAD(I),I=1,2),END
  115               FORMAT(2(A1,F9.0,1X,F4.4,I3,1X),38X,A1)
                    IF (END.NE.'e') THEN
                       I=LWORD(LINE(2))
                       END=LINE(2)(I:I)
                    END IF
                    NBANDS=2
                ELSE
C                   unknown data:
                    CALL TV('Unknown data:')
                    CALL TV(LINE(1))
                    CALL TVN(LINE(2))
                    CALL SPACE
                    GO TO 399
                END IF
C
                IF (END.NE.'e') GO TO 395
C
C               Convert STAR/SKY flag to standard strings.
                IF (CODE.EQ.'*0') THEN
                        STARSKY='STAR'
                ELSE IF (CODE.EQ.'B0') THEN
                        STARSKY='SKY'
                ELSE
                        CALL TV(CODE)
                        CALL TV('Unexpected code in STAR/SKY column:')
                        CALL TV(LINE(1))
                        CALL TVN(LINE(2))
                        CALL SPACE
                        CALL STETER(118,'Fix data and try again.')
                END IF
C
C               Loop over bands:
C
                DO 150 I=1,NBANDS
C                  Convert band codes to band names:
                   DO 120 J=1,6
                      IF (CODES(I).EQ.BNDCOD(J)) THEN
                         BAND=BNAME(J)
                         GO TO 121
                      END IF
  120              CONTINUE
C
                   CALL TV('Non-standard band name!')
                   GO TO 399
C
  121              CONTINUE
C
                   IF (STATUS(3:3).EQ.'1') THEN
C                       OPEN position.  Go on.
                   ELSE IF (STATUS(3:3).EQ.'2') THEN
C                       CLOSED position.  Set to DARKn.
                        BAND='DARK'
                        WRITE(BAND(5:5),'(I1)') J
                   ELSE IF (STATUS(3:3).EQ.'3') THEN
C                       ND=1 position.  Append ND1.
                        BAND(LWORD(BAND)+1:)='ND1'
                   ELSE
                        DATFIL='Undefined shutter code (status(3:3)):'
                        DATFIL(39:39)=STATUS(3:3)
                        CALL TV(DATFIL)
                        CALL TV(LINE(1))
                        CALL TVN(LINE(2))
                        CALL ASK(
     1                       'Ignore this observation and continue?',A)
                        IF (A.EQ.'Y' .OR. A.EQ.'O')THEN
C                           Clear data & look for next observation.
                            GO TO 160
                        ELSE
                            CALL TV('Program cannot continue.')
                            CALLSTETER(122,'Fix data and try again.')
                        END IF
                   END IF
C
C                  Check for v & b neutral-density filters:
                   IF ((J.EQ.2 .OR. J.EQ.3) .AND.
     1                       STATUS(4:4).EQ.'G') THEN
                        IF (BAND(2:3).EQ.'ND') THEN
C                           Both ND filters.
                             BAND(4:4)='3'
                        ELSE
C                           Only the vb filter.
                            BAND(4:4)='2'
                        END IF
                   END IF
C
C                  Check for viewing optics in the way:
                   IF (STATUS(6:6).EQ.'M' .OR. STATUS(7:7).EQ.'M') THEN
                      CALL SPACE2
                      IF (STATUS(6:6).EQ.'M') THEN
                         CALL TV('Field-viewing optics in the way.')
                      ELSE IF (STATUS(7:7).EQ.'M') THEN
                         CALL TV('Viewing microscope in the way.')
                      END IF
                      CALL TV(LINE(1))
                      CALL TVN(LINE(2))
                      CALL ASK('Do you want to use this as DARK?',A)
                      IF (A.EQ.'Y' .OR. A.EQ.'O') THEN
                         BAND='DARK'
                         DATFIL=COMMENT(:LWORD(COMMENT))//
     1                                      'Optics in beam'
                         COMMENT=DATFIL(:32)
                      ELSE
                         GO TO 160
                      END IF
                   END IF
C
                   SIGNAL=COUNT(I)
C                  RELERR was read as a fraction, not %.
                   ESTERR=RELERR(I)*SIGNAL
                   IF (SIGNAL.EQ.0.) SIGNAL=RNULL
                   IF (ESTERR.EQ.0.) ESTERR=RNULL
                   CALL WRITER
  150           CONTINUE
C
C               clear data arrays:
C
  160           OBJECT=' '
                STARSKY=' '
                BAND=' '
                COMMENT=' '
                EXPTIME=RNULL
                MJDOBS=DNULL
C
                GO TO 110
C
C
C
            ELSE IF (A.EQ.'c')THEN
C
C                       c: comment
C
C               Split up comment card cleanly if possible:
                DO 186 K=34,14,-1
                IF (LINE(2)(K:K).EQ.' ') GO TO 187
  186           CONTINUE
  187           DO 188 K2=K+32,K+12,-1
                IF (LINE(2)(K2:K2).EQ.' ') GO TO 189
  188           CONTINUE
  189           IF (LINE(2)(K2+32:).EQ.' ') THEN
                        COM1=LINE(2)(3:K)
                        COM2=LINE(2)(K+1:K2)
                        COM3=LINE(2)(K2+1:)
                ELSE
                        READ (LINE(2),'(2X,2A32,A14)') COM1,COM2,COM3
                END IF
                COMMENT=COM1
                CALL WRITER
                MJDOBS=OLDMJD+1.D-6
                COMMENT=COM2
                IF (COM2.NE.' ') CALL WRITER
                MJDOBS=OLDMJD+2.D-6
                COMMENT=COM3
                IF (COM3.NE.' ') CALL WRITER
                GO TO 110
C
C
            ELSE IF (A.EQ.'f') THEN
C
C                       f: error
C
                GO TO 110
C
C
            ELSE
C
C                       other: Illegal card.
C
                GO TO 399
C
            END IF
C
C
  200   CLOSE(NOUTP)
C
C       Now make format file:
C
        OPEN (NOUTP,FILE='data.fmt',STATUS='UNKNOWN')
        WRITE(NOUTP,'(A29)')'! Format file for Danish Data'
  300   FORMAT(A39)
C       Caution -- columns here MUST match FORMATs 5 & 6 in WRITER !!
        WRITE(NOUTP,300)'DEFINE/FIELD   1  10 R   F10.0 :SIGNAL '
        WRITE(NOUTP,300)'DEFINE/FIELD  11  42 C   A9    :OBJECT '
        WRITE(NOUTP,300)'DEFINE/FIELD  44  47 C   A7    :STARSKY'
        WRITE(NOUTP,300)'DEFINE/FIELD  49  56 C*8 A7    :BAND   '
        WRITE(NOUTP,300)'DEFINE/FIELD  57  68 D   F12.6 :MJD_OBS'
        WRITE(NOUTP,300)'DEFINE/FIELD  69  76 R   F8.3  :EXPTIME'
        WRITE(NOUTP,300)'DEFINE/FIELD  77 108 C   A32   :COMMENT'
        WRITE(NOUTP,300)'DEFINE/FIELD 109 118 R   F10.0 :ESTERR '
        WRITE(NOUTP,300)'DEFINE/FIELD 120 123 C   A6  :DIAPHRAGM'
        WRITE(NOUTP,'(A3)')'END'
        CLOSE(NOUTP)
C
        CALL TV('Danish is finished')
C
C
C       End MIDAS:
C
        CALL STSEPI
C
C       --------------------
C
C       Error messages:
C
  301   CALL TV('ERROR reading card at 111.')
        GO TO 399
C
  392   CALL TV('ERROR reading card at 113.')
        GO TO 399
C
  393   CALL TV('ERROR reading card at 114.')
        GO TO 399
C
  394   CALL TV('ERROR reading card at 115.')
        GO TO 399
C
  395   CALL TV('Card does not end with "e".')
        GO TO 399
C
  399   CONTINUE
        CALL TV('These cards are not in standard format:')
        CALL TV(LINE(1))
        CALL TVN(LINE(2))
        CALL SPACE
        CALL TV('Please fix data and try again.')
        CALL STETER(399,'Data not in std. format')
        END
        SUBROUTINE WRITER
C
C       writes output to uniform ascii file 'data.dat'
C
        INTEGER INULL
        REAL RNULL
        DOUBLE PRECISION DNULL
        COMMON /NULLS/ INULL, RNULL, DNULL
C
        DOUBLE PRECISION MJDOBS
        REAL SIGNAL,EXPTIME,ESTERR
        COMMON /OUTR/ SIGNAL,EXPTIME,MJDOBS,ESTERR
        CHARACTER OBJECT*9,STARSKY*4,BAND*8,COMMENT*32,DIAPH
        COMMON /OUTC/ OBJECT,STARSKY,BAND,COMMENT,DIAPH
C
        CHARACTER C*124
C
C
        WRITE(C,5) SIGNAL,OBJECT,STARSKY,BAND,MJDOBS,EXPTIME,COMMENT
    5   FORMAT        (F10.0,A9,24X,A4,1X,A8,F12.6,F8.3,A32)
        WRITE(C(109:),6) ESTERR,DIAPH
    6   FORMAT(F10.0,1X,A1)
C
C       Fix up NULL fields:
C
        IF (SIGNAL.EQ.RNULL) C(1:10)=' '
        IF (MJDOBS.EQ.DNULL) C(57:68)=' '
        IF (EXPTIME.EQ.RNULL) C(69:76)=' '
        IF (ESTERR.EQ.RNULL) C(109:118)=' '
C
        WRITE(8,'(A123)') C
C
        RETURN
        END

C @(#)minmax.for	19.1 (ESO-DMD) 02/25/03 14:01:08
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE MNMX(ARRAY,SIZE,CUTS,PIX)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine MNMX            version 1.50      850813
C             MYMX            version 1.50      850813
C             MNVAL            version 1.1      830407
C             MOMENT                    1.30	840116
C  K. Banse                        ESO - Garching
C  source code on minmax.for
C
C.KEYWORDS
C  minimum, maximum, mean value, standard deviation
C
C.PURPOSE
C  calculate min, max and mean + standard deviation of an array
C
C.ALGORITHM
C  std is calculated as SQRT of VAR(X), with VAR(X) = E(X)**2 - E(X**2)
C
C.INPUT/OUTPUT
C  call as MNMX(ARRAY,SIZE,CUTS,PIX)
C          DMYMX(ARRAY,SIZE,CUTS)	double precision
C          MYMX(ARRAY,SIZE,CUTS)
C          MNVAL(ARRAY,NAXIS,NPIX,PIXELS,FMEAN,STD,FMIN,FMAX)
C          MOMENT(ARRAY,NAXIS,NPIX,PIXELS,FMOM,STD,FMIN,FMAX,MINPIX,MAXPIX)
C
C  input par:
C  ARRAY:	R*4 array      input data array
C  SIZE:	I*4            size of ARRAY
C  NAXIS:	I*4            no. of dimensions of ARRAY
C  NPIX:	I*4 array      no. of pixels/rows in complete frame
C  PIXELS:	I*4 array      start + end pixels in each dimension
C
C  output par:
C  CUTS:	R*4 array      minimum,maximum of ARRAY
C  FMEAN:	R*4            mean value of ARRAY
C  STD:		R*4            standard deviation from FMEAN
C  FMOM:	R*4 array      1., 2., 3. + 4. moments of ARRAY
C  PIX:		I*4 array      index of min. + max. pixel
C
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      SIZE,N
      INTEGER      MINPIX,MAXPIX,PIX(2)
C
      REAL         ARRAY(SIZE)
      REAL         CUTS(2),FMIN,FMAX
C
C  initialize
      FMIN = ARRAY(1)
      MINPIX = 1
      FMAX = FMIN
      MAXPIX = MINPIX
C
C  now loop through array
      DO 100, N=1,SIZE
         IF (ARRAY(N).LT.FMIN) THEN
            FMIN = ARRAY(N)
            MINPIX = N
         ELSE IF (ARRAY(N).GT.FMAX) THEN
            FMAX = ARRAY(N)
            MAXPIX = N
         ENDIF
100   CONTINUE
C
C  set up output parms
      CUTS(1) = FMIN
      CUTS(2) = FMAX
      PIX(1) = MINPIX
      PIX(2) = MAXPIX
C
      RETURN
      END

      SUBROUTINE DMYMX(ARRAY,SIZE,CUTS)
C
      IMPLICIT NONE
C
      INTEGER      SIZE,N
C
      DOUBLE PRECISION   ARRAY(SIZE)
      DOUBLE PRECISION   CUTS(2),FMIN,FMAX
C
C  initialize
      FMIN = ARRAY(1)
      FMAX = FMIN
C
C  now loop through array
      DO 100, N=1,SIZE
         IF (ARRAY(N).LT.FMIN) THEN
            FMIN = ARRAY(N)
         ELSE IF (ARRAY(N).GT.FMAX) THEN
            FMAX = ARRAY(N)
         ENDIF
100   CONTINUE
C
C  set up output parms
      CUTS(1) = FMIN
      CUTS(2) = FMAX
C
      RETURN
      END

      SUBROUTINE MYMX(ARRAY,SIZE,CUTS)
C
      IMPLICIT NONE
C
      INTEGER      SIZE,N
C
      REAL         ARRAY(SIZE)
      REAL         CUTS(2),FMIN,FMAX
C
C  initialize
      FMIN = ARRAY(1)
      FMAX = FMIN
C
C  now loop through array
      DO 100, N=1,SIZE
         IF (ARRAY(N).LT.FMIN) THEN
            FMIN = ARRAY(N)
         ELSE IF (ARRAY(N).GT.FMAX) THEN
            FMAX = ARRAY(N)
         ENDIF
100   CONTINUE
C
C  set up output parms
      CUTS(1) = FMIN
      CUTS(2) = FMAX
C
      RETURN
      END

      SUBROUTINE MNVAL(ARRAY,NAXIS,NPIX,PIXELS,FMEAN,STD,FMIN,FMAX)
C
      IMPLICIT NONE
C 
      INTEGER      NAXIS,NPIX(*),PIXELS(2,2)
      INTEGER      NOPIX,LOWX,HIX,SIZE
      INTEGER      LOWY,HIY,IOFF,NX,NY,N
C 
      REAL     ARRAY(*),FMIN,FMAX,FMEAN,STD,PIX
C 
      DOUBLE PRECISION    SUM,SUMS,S1,S2,EXPECT,SIGMA
C
C  initialize
      NOPIX = NPIX(1)                     !points per line in father frame...
      SUM = 0.D0
      SUMS = 0.D0
      LOWX = PIXELS(1,1)
      HIX = PIXELS(1,2)
      SIZE = HIX - LOWX + 1
C
      IF (NAXIS.GE.2) THEN
         LOWY = PIXELS(2,1)
         HIY = PIXELS(2,2)
         SIZE = SIZE * (HIY - LOWY + 1)
      ELSE
         LOWY = 1
         HIY = 1
      ENDIF
C
      N = (LOWY-1)*NOPIX + LOWX           !get index of 1. element in sybframe
      FMIN = ARRAY(N)
      FMAX = FMIN
C
C  now loop through array
      DO 800, NY=LOWY,HIY
         IOFF = (NY-1)*NOPIX
         DO 500, NX=LOWX,HIX
            N = IOFF + NX
            PIX = ARRAY(N)
            IF(PIX.LT.FMIN) THEN
               FMIN = PIX
            ELSE
               IF(PIX.GT.FMAX) FMAX = PIX
            ENDIF
            SUM = SUM + PIX                     !sum of values
            SUMS = SUMS + (PIX*PIX)            	!sum of squares
500      CONTINUE
800   CONTINUE
C
C  now calculate mean + standard deviation
      EXPECT = SUM/SIZE
      S1 = SUMS/SIZE
      S2 = EXPECT * EXPECT
      SIGMA = SQRT(MAX(0.D0,(S1-S2)))
      FMEAN = EXPECT                         !get single precision values
      STD = SIGMA
C 
      RETURN
      END

      SUBROUTINE MOMENT(ARRAY,NAXIS,NPIX,PIXELS,FMOM,STD,FMIN,FMAX,
     +                     MINPIX,MAXPIX)
C
      IMPLICIT NONE
C 
      INTEGER      NAXIS,NPIX(*),PIXELS(2,2)
      INTEGER      NOPIX,LOWX,HIX,SIZE
      INTEGER      LOWY,HIY,IOFF,NX,NY
      INTEGER      MINPIX,MAXPIX,N
C 
      REAL            ARRAY(*),FMIN,FMAX,FMOM(4),STD
      REAL            PIX,PIX2,PIX3,PIX4
C 
      DOUBLE PRECISION SUM,SUM2,SUM3,SUM4,SIGMA
C
      DATA      SUM /0.D0/, SUM2 /0.D0/, SUM3 /0.D0/, SUM4 /0.D0/
C
C  initialize
      NOPIX = NPIX(1)                   !points per line in father frame...
      LOWX = PIXELS(1,1)
      HIX = PIXELS(1,2)
      SIZE = HIX - LOWX + 1
C
      IF (NAXIS.GE.2) THEN
         LOWY = PIXELS(2,1)
         HIY = PIXELS(2,2)
         SIZE = SIZE * (HIY - LOWY + 1)
      ELSE
         LOWY = 1
         HIY = 1
      ENDIF
C
      N = (LOWY-1)*NOPIX + LOWX          !get index of 1. element in subframe
      FMIN = ARRAY(N)
      MINPIX = N
      FMAX = FMIN
      MAXPIX = MINPIX
C
C  now loop through array
      IOFF = (LOWY-1) * NOPIX            		!init offset...
      DO 800, NY=LOWY,HIY
C
         DO 600, NX=LOWX,HIX
            N = IOFF + NX
            PIX = ARRAY(N)
            IF (PIX.LT.FMIN) THEN
               FMIN = PIX
             MINPIX = N
            ELSE
               IF (PIX.GT.FMAX) THEN
                FMAX = PIX
                MAXPIX = N
             ENDIF
            ENDIF
            PIX2 = PIX*PIX
            PIX3 = PIX2*PIX
            PIX4 = PIX3*PIX
            SUM = SUM + PIX                     !sum of values
            SUM2 = SUM2 + PIX2                  !sum of squares
            SUM3 = SUM3 + PIX3                  !sum of PIX**3
            SUM4 = SUM4 + PIX4                  !sum of PIX**4
600      CONTINUE
C
         IOFF = IOFF + NOPIX                    !increment offset...
800   CONTINUE
C
C  now calculate moments + standard deviation
      SUM = SUM/SIZE                            !1. moment
      SUM2 = SUM2/SIZE                          !2. moment
      SUM3 = SUM3/SIZE                          !3. moment
      SUM4 = SUM4/SIZE                          !4. moment
      SIGMA = SQRT(MAX(0.D0,(SUM2-(SUM*SUM))))  !standard deviation
      FMOM(1) = SUM                             !get single precision values
      FMOM(2) = SUM2
      FMOM(3) = SUM3
      FMOM(4) = SUM4
      STD = SIGMA
C
C  return
      RETURN
      END

C @(#)test.for	19.1 (ES0-DMD) 02/25/03 14:31:15
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM TEST
C+++
C.IDENTIFICATION
C     PROGRAM TEST
C
C.PURPOSE
C     TEST THE EXTRACTION OF FORTRAN EXTENSIONS FROM A SOURCE FILE
C
C---
      PARAMETER    (MAX_ARRAY=100)
C
      IMPLICIT NONE
      INTEGER  I,N
      REAL     ARRAY(MAX_ARRAY,MAX_ARRAY)
      REAL     THIS_IS_REAL,RESULT
C+
C     TEST ENDDO
C-
      DO I = 1,MAX_ARRAY
	 DO N = 1,MAX_ARRAY
            IF (I.EQ.N) GOTO 200
	    ARRAY(I,N) = I*K
  200    ENDDO
      ENDDO
C+
C     INITIATE VARIABLES
C-
      RESULT = 0.0E0                    ! RESET RESULT
C+
C     NEXT TEST
C-
      DO I = 1,MAX_ARRAY
	 DO 100, N = 1,MAX_ARRAY
            THIS_IS_REAL = RESULT + ARRAY(I,N)
  100    CONTINUE
      ENDDO
C+
C     CALL SUBROUTINE
C-
      CALL DUMMTEST(RESULT)
C+
C     END TEST
C-
      STOP
      END
C+
C
C-
      SUBROUTINE DUMMTEST(X)
      IMPLICIT NONE
      REAL X
C
      X = X * X
C
      RETURN
      END
C+
C
C-
      CHARACTER*(*)  FUNCTION  NTOCHR (N)
C
C Converts an integer in the range 1-99 to two characters representing
C the number.
C
      IMPLICIT NONE
      INTEGER N, ITENS
      IF ((N .GT. 0) .AND. (N .LT. 100)) GO TO 1010
      NTOCHR='00'
      RETURN
C
 1010 ITENS=N/10
      NTOCHR=CHAR(48+ITENS)//CHAR(48+N-10*ITENS)
      RETURN
C
      END

C===========================================================================
C Copyright (C) 1995-2008 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM ECHNORD
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  21:22 - 3 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: D.PONZ
C
C.MODIFICATIONS: M.PERON
C                PB       910313    Suppress creation of TRACE.bdf
C
C.IDENTIFICATION
C                  echnord.for
C
C.KEYWORDS
C
C  echelle, order searching, maxima following
C
C.PURPOSE
C
C Search echelle orders on a flat field image.
C Output is a table with the following columns :
C
C COLUMN NO.  LABEL   UNIT      DESCRIPTION
C    1        :ORDER  -         ORDER NUMBER
C    2        :X      PIXEL     SAMPLE NUMBER
C    3        :Y      PIXEL     1. MOMENT AS SUM(F*Y)/SUM(F)
C    4        :YBKG   PIXEL     POSITION OF THE BACKGROUND
C    5        :BKG    DN        BACKGROUND LEVEL
C
C.ALGORITHM
C
C  Maxima following algorithm.
C
C  CONSTRAINS : MAXIMUM NUMBER OF ORDERS IN THE IMAGE IS 100
C               FOR EACH ORDER 19 POINTS ARE FOUND
C
C.INPUT/OUTPUT
C
C  COMMAND :
C  SEARCH/ORDER INPUT W,T,S OUTPUT METH
C  input keywords are
C  ECHC(1:8)   INPUT   - IMAGE NAME
C  ECHC(21:28)  OUTPUT  - TABLE NAME
C         W,T,S   - PARAMETERS WHERE :
C  ECHR(2)              T THRESHOLD IN THE DETECTION
C
C.VERSION
C 080717	last modif
C 
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      IMPLICIT  NONE
      INTEGER   MADRID
      INTEGER   ACTVAL,I,ISTAT,IXSTR
      INTEGER   NACOL,NAXIS,NDIM,NORDER,NP
      INTEGER*8 ITRACE
      INTEGER   NTOT
      INTEGER*8 PNTRA
      INTEGER   STATUS,WINDOW,IACOL,ID
      INTEGER   NPIX(3),ICOL(7), KUN, KNUL, IMNO
C     INTEGER*8 IMSK
CC      INTEGER   II
      INTEGER   IJ
      INTEGER UPPER(200),LOWER(200),INEW
      REAL    RPAR(4),LEVEL,FORD(200),FBACK(200),SLOPE
      DOUBLE PRECISION START(3),STEP(3)
      DOUBLE PRECISION ST
      CHARACTER*80 CA
      CHARACTER*80 TABLE,TRACE
      CHARACTER*72 IDENA
      CHARACTER*80 LINE
      CHARACTER*64 CUNITA
      CHARACTER*16 LABCOL(5),UNIT(5)
      CHARACTER*6  FORM(5)
      CHARACTER*60  FRMIN
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
      DATA LABCOL(1)/'ORDER'/,FORM(1)/'I6'/
      DATA LABCOL(2)/'X'/,FORM(2)/'F7.1'/
      DATA LABCOL(3)/'Y'/,FORM(3)/'F7.1'/
      DATA LABCOL(4)/'YBKG'/,FORM(4)/'F7.1'/
      DATA LABCOL(5)/'BKG'/,FORM(5)/'E12.3'/
      DATA UNIT(1)/'UNITLESS'/
      DATA UNIT(2)/'World Coord'/
      DATA UNIT(3)/'World Coord'/
      DATA UNIT(4)/'World Coord'/
      DATA UNIT(5)/'DN'/
      DATA NACOL/5/
      DATA TRACE/'TRACE.bdf'/

      CA = 'TEST'
      ST = 1.D0
      NDIM   = 3
C
C ... initialize system and read parameters
C
      CALL STSPRO('ECHNORD')
      CALL STKRDC('IN_A',1,1,60,ACTVAL,FRMIN,KUN,KNUL,STATUS)
      CALL CLNFRA(FRMIN,FRMIN,0)
      CALL STKRDC('IN_B',1,1,60,ACTVAL,TABLE,KUN,KNUL,STATUS)
      CALL CLNTAB(TABLE,TABLE,0)
      CALL STKRDR('INPUTR',1,3,ACTVAL,RPAR,KUN,KNUL,STATUS)
      WINDOW = RPAR(1)
      LEVEL  = RPAR(2)
      SLOPE  = RPAR(3)
      CALL STTPUT(' ECHELLE DEFINITION',ISTAT)
      CALL STTPUT(' ------------------',ISTAT)
      CALL STTPUT(' INPUT IMAGE  : '//FRMIN,ISTAT)
      CALL STTPUT(' OUTPUT TABLE : '//TABLE,ISTAT)
      CALL STTPUT(' PARAMETERS  ',ISTAT)
      WRITE (LINE,9000) WINDOW
      CALL STTPUT(LINE,ISTAT)
      WRITE (LINE,9010) RPAR(2)
      CALL STTPUT(LINE,ISTAT)
C
C ... read frame
C
      CALL STIGET(FRMIN,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     .NDIM,NAXIS,NPIX,START,STEP,IDENA,CUNITA,PNTRA,IMNO,STATUS)
C
C             ......................... CREATE ORDER MASK FOR DEBUGGING
C
C      CALL STIPUT('MASK',D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
C     .     1,NPIX(2),ST,ST,CA,CA,IMSK,II,STATUS)
      CALL STIPUT(TRACE,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .     1,NPIX(2),ST,ST,CA,CA,ITRACE,IJ,STATUS)
C
C ... generate trace
C
      IXSTR  = NPIX(1)/2
      CALL EXTR3(MADRID(PNTRA),NPIX(1),NPIX(2),IXSTR,
     .           MADRID(ITRACE))
C
C ... find order positions in the middle of the image by simple thresholding
C
      NORDER = 0
      NP     = NPIX(2) - 2*WINDOW
      CALL ABSTHR(MADRID(ITRACE),NPIX(2),LEVEL,
     .            NORDER,UPPER,LOWER)
      CALL ORDBAC(NPIX(2),MADRID(ITRACE),
     .            NORDER,UPPER,LOWER,FORD,FBACK)
      CALL ORDREJ(WINDOW,NORDER,UPPER,LOWER,FORD,FBACK)
C
C ... while new orders are found detect previous and next orders 
C     using variable thresholding
C
50    CONTINUE
      CALL LVRTHR(MADRID(ITRACE),NPIX(2),
     .            NORDER,UPPER,LOWER,FORD,FBACK,INEW)
      IF (INEW.GT.0) GOTO 50
60    CONTINUE
      CALL RVRTHR(MADRID(ITRACE),NPIX(2),
     .            NORDER,UPPER,LOWER,FORD,FBACK,INEW)
      IF (INEW.GT.0) GOTO 60
C
C ... generate mask for control
C
C      CALL MASKIN(MADRID(IMSK),NPIX(2),NORDER,UPPER,LOWER,FORD,FBACK)
C
      IF (NORDER.EQ.0) THEN
          CALL STTPUT('Ordr detection failed',STATUS)
          CALL STTPUT('Use a lower threshold',STATUS)
          GO TO 20
      END IF
      WRITE (LINE,9030) NORDER
      CALL STTPUT(LINE,ISTAT)
C
C ... allocate table
C
      NTOT   = (NORDER+1)*NPIX(1)/10
      IACOL  = 12
      CALL TBTINI(TABLE,F_TRANS,F_O_MODE,IACOL,NTOT,ID,STATUS)
      DO 10 I = 1,NACOL
          CALL TBCINI(ID,D_R4_FORMAT,1,FORM(I),
     .    UNIT(I),LABCOL(I),ICOL(I),STATUS)
   10 CONTINUE
C
C ... follow orders
C
      CALL FOLLOW(MADRID(PNTRA),NPIX(1),NPIX(2),NORDER,UPPER,
     .     LOWER,FORD,FBACK,ID,SLOPE)
C
C ... update number of elements
C
C      NTOT   = NPOINT
      CALL STKWRI('OUTPUTI',NORDER,1,1,KUN,STATUS)
      CALL STKWRI('OUTPUTI',NPIX,2,2,KUN,STATUS)
      IDENA = 'ORDER POSITION'
      CALL TBSINI(ID,STATUS)
      CALL TBTCLO(ID,STATUS)
C
C ... free data
C
   20 CONTINUE
      CALL STFDEL(TRACE,STATUS)
      CALL STSEPI

 9000 FORMAT ('  ORDER WIDTH : ',I6)
 9010 FORMAT ('    THRESHOLD : ',F10.1)
 9030 FORMAT (' NUMBER OF DETECTED ORDERS : ',I4)
      END

      SUBROUTINE FOLLOW(X,N1,N2,NORDER,UPPER,LOWER,FO,FB,TID,SLOPE)
C
C  DEFINE ORDER POSTIONS BY DETECTING THE UPPER AND LOWER
C  EDGES
C
      IMPLICIT NONE
C
      INTEGER   N1             ! NUMBER OF SAMPLES
      INTEGER   N2             ! NUMBER OF ROWS
      REAL X(N1,N2)            ! INPUT IMAGE
      INTEGER   NORDER         ! NUMBER OF DETECTED ORDERS
      INTEGER   UPPER(*)       ! ROW NUMBER OF ASCENDING EDGE
      INTEGER   LOWER(*)       ! ROW NUMBER OF DESCENDING EDGE
      REAL      FO(*)          ! ORDER FLUX IN THE MIDDLE OF THE IMAGE
      REAL      FB(*)          ! BACKGROUND IN THE MIDDLE OF THE IMAGE
      INTEGER   TID            ! TABLE IDENTIFIER
C
      INTEGER   ISTAT, ICOL(5), IXSTR, NP, IX, IL, IU, NC, W,IP
      INTEGER   IORD, WINDOW, ILIM1, ILIM2, IHW, IBACK, K, IBUF
      INTEGER   LOWBND, UPPBND
      INTEGER   ILPOS, IUPOS, IRL, ISTEP, NSAMP, ORDPOS, NF1, NF2
C
      REAL      THRES, T1, T2, BACK, RBACK1, RBACK2, RVAL(5)
      REAL      F1, F2, BUF(100, 4),SLOPE
C
      CHARACTER*80 LINE
C
      LOGICAL NEXT
C
      DATA      ICOL/1,2,3,4,5/
C
      NSAMP  = 10
      WINDOW = 10
      IXSTR  = N1/2
      ILIM2  = N2 - WINDOW
      ILIM1  = N1 - WINDOW
C
      LOWBND = 2
      UPPBND = N2 - 2
C
C ... DISPLAY RESULTS
C
      CALL STTPUT(' ',ISTAT)
      WRITE (LINE,9020)
      CALL STTPUT(LINE,ISTAT)
      WRITE (LINE,9030)
      CALL STTPUT(LINE,ISTAT)
C
C ... ITERATION ON ORDERS
C
      NP     = 0
      DO 40 IORD = 1,NORDER

          IF (IORD.NE.NORDER) IHW = (UPPER(IORD+1)-LOWER(IORD))*0.5
          W  = (LOWER(IORD)-UPPER(IORD))*0.5
          IF (IORD.EQ.1) THEN
              BACK = FB(1)
          ELSE IF (IORD.EQ.NORDER) THEN
              BACK = FB(NORDER-1)
          ELSE
              BACK = 0.5*(FB(IORD-1) + FB(IORD))
          ENDIF
          THRES = BACK + 0.5*(FO(IORD) - BACK)
C
C ... LEFT/RIGHT  PART OF THE IMAGE
C
          NC   = 3
          IBUF = 0
          DO 30 IRL = 1,2
C
C ...  INITIAL THRESHOLD
C
              IF (IRL.EQ.1) THEN
                  ISTEP  = -1
              ELSE
C ...                          INCLUDE START POSITION OF THE ORDER
                  NP      = NP + 1
                  RVAL(1) = IORD
                  RVAL(2) = 1.
                  CALL TBRWRR(TID,NP,2,ICOL,RVAL,ISTAT)
                  DO 5 K = IBUF, 1, -1
                     NP      = NP + 1
                     NC      = NC + 1
                     RVAL(1) = IORD
                     RVAL(2) = BUF(K,1)
                     RVAL(3) = BUF(K,2)
                     IF (BUF(K,3).LT.0.) THEN
                       CALL TBRWRR(TID,NP,3,ICOL,RVAL,ISTAT)
                     ELSE
                       RVAL(4) = BUF(K,3)
                       RVAL(5) = BUF(K,4)
                       CALL TBRWRR(TID,NP,5,ICOL,RVAL,ISTAT)
                     ENDIF
 5                CONTINUE
C ...                          INCLUDE CENTRAL POSITION OF THE ORDER
                  NP      = NP + 1
                  RVAL(1) = IORD
                  RVAL(2) = IXSTR
                  RVAL(3) = UPPER(IORD) + (LOWER(IORD)-UPPER(IORD))/2
                  ORDPOS  = RVAL(3)
                  IF (IORD.LT.NORDER) THEN
                    IBACK  = LOWER(IORD) + IHW
                    IF (IBACK.LT.ILIM2) THEN
                      RVAL(4) = IBACK
                      RVAL(5) = BACK
                      CALL TBRWRR(TID,NP,5,ICOL,RVAL,ISTAT)
                    ENDIF
                  ELSE
                  CALL TBRWRR(TID,NP,3,ICOL,RVAL,ISTAT)
                  END IF
                  ISTEP  = 1
              END IF
              T1     = THRES
              T2     = THRES
              IX     = IXSTR
              IU     = UPPER(IORD)
              IL     = LOWER(IORD)
              NEXT   = .TRUE.
              IP = 1
 10           CONTINUE
              IX     = IX + ISTEP
C
C ... FIND ASCENDING  EDGE
C
              F1      = 0.
              NF1     = 0
              IUPOS   = 0
              RBACK1  = 10000.
              ISLOPE = NINT(SLOPE)

              DO 50 K = IU-1-IP*ISLOPE, IU+W+IP*ISLOPE
               IF (K.GE.LOWBND) THEN
                  RBACK1 = MIN(RBACK1, X(IX, K))
                  IF (X(IX,K-1).LT.T1.AND.X(IX,K).GT.T1) IUPOS = K
                  IF (IUPOS.GT.0) THEN
                    F1  = F1 + X(IX,K)
                    NF1 = NF1 + 1
                  ENDIF
               ENDIF
50            CONTINUE
C
C ... FIND DESCENDING EDGE
C
              ILPOS  = 0
              F2     = 0.
              NF2    = 0
              RBACK2 = 10000.
              DO 70 K = IL+1+IP*ISLOPE, IL-W-IP*ISLOPE, -1
                 IF (K.LE.UPPBND) THEN
                   RBACK2 = MIN(RBACK2, X(IX, K))
                   IF (X(IX,K+1).LT.T2.AND.X(IX,K).GT.T2) ILPOS = K
                   IF (ILPOS.GT.0) THEN
                     F2  = F2 + X(IX,K)
                     NF2 = NF2 + 1
                   ENDIF
                 ENDIF
70            CONTINUE
              IF ((IUPOS.GT.0).AND.(ILPOS.GT.0)) THEN
                 T1    = RBACK1 + 0.5*(F1/NF1 - RBACK1)
                 T2    = RBACK2 + 0.5*(F2/NF2 - RBACK2)
C
C ... STORE INTO TABLE
C
                 IF (MOD(IX,NSAMP).EQ.0) THEN
                   IF (IRL.EQ.1) THEN         ! STORE ON BUFFER
                     IF (IORD.LT.NORDER) THEN
                       IBACK  = ILPOS + IHW
                       IF (IBUF.GE.200) GOTO 30
                       IF (IBACK.LT.ILIM2) THEN
                         IBUF    = IBUF + 1
                         BUF(IBUF,1) = IX
                         BUF(IBUF,2) = IUPOS+(ILPOS-IUPOS)/2
                         BUF(IBUF,3) = IBACK
                         BUF(IBUF,4) = 0.5*(RBACK1 + RBACK2)
                       ENDIF
                     ELSE
                         IBUF    = IBUF + 1
                         BUF(IBUF,1) = IX
                         BUF(IBUF,2) = IUPOS+(ILPOS-IUPOS)/2
                         BUF(IBUF,3) = -1.
                         BUF(IBUF,4) = -1.
                     END IF
                   ELSE
                     NC      = NC + 1
                     NP      = NP + 1
                     RVAL(1) = IORD
                     RVAL(2) = IX
                     RVAL(3) = IUPOS+(ILPOS-IUPOS)/2
                     IF (IORD.LT.NORDER) THEN
                       IBACK  = ILPOS + IHW
                       IF (IBACK.LT.ILIM2) THEN
                         RVAL(4) = IBACK
                         RVAL(5) = 0.5*(RBACK1 + RBACK2)
                         CALL TBRWRR(TID,NP,5,ICOL,RVAL,ISTAT)
                       ENDIF
                     ELSE
                       CALL TBRWRR(TID,NP,3,ICOL,RVAL,ISTAT)
                     END IF
                   END IF
                 END IF
              ENDIF
              IF (ILPOS.GT.0.AND.IUPOS.GT.0) THEN
                 IL   = ILPOS
                 IU   = IUPOS
                 IP   = 1
              ELSE
                 IP=IP+1
              ENDIF
C              NEXT = (IU.LT.IL).AND.(IL.LT.ILIM2).AND.(IU.GT.IHW)
C     .               .AND.(IX.GT.WINDOW).AND.(IX.LT.ILIM1)

              NEXT = (IU.LT.IL).AND.(IL.LT.ILIM2).AND.(IU.GT.IHW).AND.
     .         (IP.LT.11).AND.(IX.GT.WINDOW).AND.(IX.LT.ILIM1)
              IF (NEXT) GO TO 10
C   20         CONTINUE
   30     CONTINUE
C ...                          INCLUDE END POSITION OF THE ORDER
          NP      = NP + 1
          RVAL(1) = IORD
          RVAL(2) = N1
          CALL TBRWRR(TID,NP,2,ICOL,RVAL,ISTAT)
C          WRITE (LINE,9010) IORD,IXSTR,ORDPOS,IHW,NC,T1,T2
          WRITE (LINE,9010) IORD,IXSTR,ORDPOS,IHW,NC
          CALL STTPUT(LINE,ISTAT)
   40 CONTINUE
      WRITE (LINE,9040)
      CALL STTPUT(LINE,ISTAT)
      RETURN

C 9000 FORMAT (I4)
C 9010 FORMAT (1X,I7,2X,I8,2X,I8,2X,I10,2X,I8)
 9010 FORMAT (1X,I7,2X,I8,2X,I8,2X,I10,2X,I8,2F10.1)
 9020 FORMAT (' SEQ.NO.  X CENTER  Y CENTER  INTERORDER  TEMPLATE')
 9030 FORMAT (' -------  --------  --------  ----------  --------')
 9040 FORMAT (' -------------------------------------------------')
      END

      SUBROUTINE ABSTHR(X,N,THRES,NORDER,UPPER,LOWER)
C
C  FIND EDGES OF THE ORDERS BY SIMPLE THRESHOLDING
C
      IMPLICIT NONE
C
      INTEGER   N              ! NUMBER OF SAMPLES
      REAL      X(N)           ! INPUT IMAGE TRACE
      REAL      THRES          ! DETECTING THRESHOLD
      INTEGER   NORDER         ! NUMBER OF DETECTED ORDERS
      INTEGER   UPPER(*)       ! ROW NUMBER OF ASCENDING EDGE
      INTEGER   LOWER(*)       ! ROW NUMBER OF DESCENDING EDGE
C
      INTEGER I, NO
      LOGICAL UP
C
C ... ITERATION
C
      UP = .TRUE.
      NO = 0
C
      DO 10 I = 1, N
         IF (UP) THEN
            IF (X(I).GT.THRES .AND. X(I-1).LT.THRES) THEN
C ...                                     ASCENDING EDGE
               UP = .FALSE.
               NO = NO + 1
               UPPER(NO) = I 
            ENDIF            
         ELSE
            IF (X(I).LT.THRES .AND. X(I-1).GT.THRES) THEN
C ...                                     DESCENDING EDGE
               UP = .TRUE.
               LOWER(NO) = I-1
            ENDIF    
         ENDIF        
10    CONTINUE
      IF (UP) THEN
          NORDER = NO
      ELSE
          NORDER = NO - 1
      ENDIF
      RETURN
      END

      SUBROUTINE MASKIN(X,N,NO,UPPER,LOWER,FO,FB)
C
C  DERIVE A MASK WITH THE ORDER POSITIONS
C
      IMPLICIT NONE
C
      INTEGER  N                 ! NUMBER OF PIXELS
      REAL     X(N)              ! MASK
      INTEGER  NO                ! INPUT/OUTPUT NUMBER OF ORDERS
      INTEGER  UPPER(*)          ! ASCENDING EDGE POSITION
      INTEGER  LOWER(*)          ! DESCENDING EDGE POSITION
      REAL     FO(*)
      REAL     FB(*)
C
      INTEGER  I, J
      REAL     ON, OFF, THRES, BACK
C
      ON  = 10000.
      OFF = 0.
      THRES = ON/2.
C
C ... BUILD THE MASK
C
      BACK = 0.
      J = 1
      DO 10 I = 1, N
        IF (I .GE. UPPER(J) .AND. I .LE. LOWER(J) ) THEN
           X(I) = FO(J)
        ELSE
           IF (I.GT.LOWER(J)) THEN
              BACK = FB(J)
              J = J + 1          
              IF (J.GT.NO) GOTO 20
           ENDIF
           X(I) = BACK
        ENDIF
10    CONTINUE
      RETURN
20    DO 30 J = I, N
         X(J) = BACK
30    CONTINUE
C
      RETURN
      END


      SUBROUTINE EXTR3(X,N1,N2,I,OUT)
C
C     EXTRACE PERPENDICULAR TRACE
C
      INTEGER N1
      INTEGER N2
      REAL    X(N1, N2)
      INTEGER I
      REAL    OUT(N2)
C
      INTEGER J
C
      DO 10 J = 1, N2
         OUT(J) = (X(I-1,J)+X(I,J)+X(I+1,J))/3.
10    CONTINUE
      RETURN
      END

      SUBROUTINE ORDBAC(N,X,
     .            NORDER,UPPER,LOWER,FORD,FBACK)
      IMPLICIT NONE
C
      INTEGER    N                 ! NUMBER OF SAMPLES
      REAL       X(N)              ! INPUT IMAGE
      INTEGER    NORDER            ! INPUT/OUTPUT NUMBER OF ORDERS
      INTEGER    UPPER(*)          ! ASCENDING EDGE
      INTEGER    LOWER(*)          ! DESCENDING EDGE
      REAL       FORD(*)
      REAL       FBACK(*)
C
      INTEGER    I, I1, I2, NBACK, IORD, IO1, IO2, NORD
      REAL       ORDER, BACK
C
C ... COMPUTE FOR EACH ORDER THE AVERAGE FLUX AND THE NEXT BACKGROUND
C
      DO 40 IORD = 1, NORDER
         IO1   = UPPER(IORD) + 1 !..............
         IO2   = LOWER(IORD) - 1 !..............
         NORD  = IO2-IO1+1
         ORDER = 0.
         DO 20 I = IO1,IO2
            ORDER = ORDER + X(I)/NORD
20       CONTINUE
         FORD(IORD) = ORDER
         I1 = LOWER(IORD) + 1
         IF (IORD.EQ.NORDER) THEN
            FBACK(IORD) = 0.
         ELSE
            I2 = UPPER(IORD+1) - 1
            NBACK = I2-I1+1
C            BACK  = 0.
            BACK  = 10000.             !..........
            DO 30 I = I1, I2
               BACK = MIN(BACK, X(I))  !..........
C              BACK  = BACK + X(I)/NBACK
30          CONTINUE
            FBACK(IORD) = BACK
         ENDIF
40    CONTINUE
      RETURN
      END


      SUBROUTINE ORDREJ(WINDOW,NORDER,UPPER,LOWER,FORD,FBACK)
C
C     REJECT SPURIOUS ORDERS
      IMPLICIT NONE
C
      INTEGER    WINDOW            ! ORDER WIDTH
      INTEGER    NORDER            ! INPUT/OUTPUT NUMBER OF ORDERS
      INTEGER    UPPER(*)          ! ASCENDING EDGE
      INTEGER    LOWER(*)          ! DESCENDING EDGE
      REAL       FORD(*)
      REAL       FBACK(*)
C
      INTEGER    I, J, IW, STATUS, KK
      CHARACTER*70 LINE
C
      I = 1
      KK = NORDER
10    CONTINUE
        IW  = LOWER(I)-UPPER(I) + 1
        IF (ABS(IW-WINDOW).GT.2)THEN
            WRITE(LINE,1000)I,IW
            CALL STTPUT(LINE,STATUS)
            IF (I.NE.KK) THEN
              DO 20 J = I, KK-1
                 LOWER(J) = LOWER(J+1)
                 UPPER(J) = UPPER(J+1)
                 FORD(J)  = FORD(J+1)
                 FBACK(J) = FBACK(J+1)
20            CONTINUE
            ENDIF
            LOWER(KK) = 0            
            UPPER(KK) = 0            
            FORD(KK)  = 0.            
            FBACK(KK) = 0.            
            KK = KK-1
            I  = I-1
        ENDIF
      I = I+1
      IF (I.LE.KK) GO TO 10
      NORDER = KK
      RETURN
1000  FORMAT(' Reject order ',I4, ' computed width = ',I4)
      END

      SUBROUTINE LVRTHR(X,N,NORDER,UPPER,LOWER,FORD,FBACK,INEW)
C
C  FIND EDGES OF THE ORDERS BY RELATIVE THRESHOLDING
C
      IMPLICIT NONE
C
      INTEGER   N              ! NUMBER OF SAMPLES
      REAL      X(N)           ! INPUT IMAGE TRACE
      INTEGER   NORDER         ! NUMBER OF DETECTED ORDERS
      INTEGER   UPPER(*)       ! ROW NUMBER OF ASCENDING EDGE
      INTEGER   LOWER(*)       ! ROW NUMBER OF DESCENDING EDGE
      REAL      FORD(*)
      REAL      FBACK(*)
      INTEGER   INEW
C
      INTEGER I, IUP, ILOW, N1, I1, I2
      LOGICAL UP
      REAL    THRES, F
C
      INEW  = 0
      THRES = FBACK(1) + (FORD(1) - FBACK(1))/2.
C
C ... ITERATION
C
      UP = .TRUE.
C
      I1 = UPPER(1) - 2
      DO 10 I = I1, 1, -1
         IF (UP) THEN
            IF (X(I).GT.THRES .AND. X(I+1).LT.THRES) THEN
C ...                                     ASCENDING EDGE
               UP  = .FALSE.
               IUP = I
            ENDIF            
         ELSE
            IF (X(I).LT.THRES .AND. X(I+1).GT.THRES) THEN
C ...                                     DESCENDING EDGE
               UP   = .TRUE.
               ILOW = I-1
               INEW = 1
               GO TO 20
            ENDIF    
         ENDIF        
10    CONTINUE
      RETURN
20    CONTINUE
C
C ...                                     INCLUDE NEW ORDER
C
      NORDER  = NORDER + 1
      DO 30 I = NORDER, 2, -1
        UPPER(I) = UPPER(I-1)
        LOWER(I) = LOWER(I-1)
        FORD(I)  = FORD(I-1)
        FBACK(I) = FBACK(I-1)
30    CONTINUE
      UPPER(1) = ILOW
      LOWER(1) = IUP
C
C ...                                     COMPUTE NEW BACKGROUND AND ORDER FLUX
C
      F  = 0.
C
      I1 = UPPER(1) + 1       !.........
      I2 = LOWER(1) - 1       !.........
      N1 = I2 - I1 + 1
      DO 40 I = I1, I2
        F = F + X(I)/N1
40    CONTINUE
      FORD(1) = F
      F  = 10000.
      I1 = UPPER(2)-1
      I2 = IUP + 1
      N1 = I1-I2 + 1
      DO 50 I = I2, I1
        F = MIN(F,X(I))
50    CONTINUE
      FBACK(1) = F
      RETURN
      END

      SUBROUTINE RVRTHR(X,N,NORDER,UPPER,LOWER,FORD,FBACK,INEW)
C
C  FIND EDGES OF THE ORDERS BY RELATIVE THRESHOLDING
C
      IMPLICIT NONE
C
      INTEGER   N              ! NUMBER OF SAMPLES
      REAL      X(N)           ! INPUT IMAGE TRACE
      INTEGER   NORDER         ! NUMBER OF DETECTED ORDERS
      INTEGER   UPPER(*)       ! ROW NUMBER OF ASCENDING EDGE
      INTEGER   LOWER(*)       ! ROW NUMBER OF DESCENDING EDGE
      REAL      FORD(*)
      REAL      FBACK(*)
      INTEGER   INEW
C
      INTEGER I, IUP, ILOW, N1, I1, I2
      LOGICAL UP
      REAL    THRES, F
C ................................. NOTE THAT FBACK(NORDER) IS 0.
      INEW  = 0
      THRES = FBACK(NORDER-1)+(FORD(NORDER)-FBACK(NORDER-1))/2.
C
C ... ITERATION
C
      UP = .TRUE.
      I1 = LOWER(NORDER) + 2
C
      DO 10 I = I1, N
         IF (UP) THEN
            IF (X(I).GT.THRES .AND. X(I-1).LT.THRES) THEN
C ...                                     ASCENDING EDGE
               UP  = .FALSE.
               IUP = I
            ENDIF            
         ELSE
            IF (X(I).LT.THRES .AND. X(I-1).GT.THRES) THEN
C ...                                     DESCENDING EDGE
               UP   = .TRUE.
               ILOW = I-1
               INEW = 1
               GO TO 20
            ENDIF    
         ENDIF        
10    CONTINUE
      RETURN
20    CONTINUE
C
C ...                                     INCLUDE NEW ORDER
C
      NORDER  = NORDER + 1
      UPPER(NORDER) = IUP
      LOWER(NORDER) = ILOW
C
C ...                                     COMPUTE NEW BACKGROUND AND ORDER FLUX
C
      F  = 0.
      I1 = IUP + 1
      I2 = ILOW -1 
      N1 = I2-I1+1
      DO 40 I = I1, I2
        F = F + X(I)/N1
40    CONTINUE
      FORD(NORDER)  = F
      FBACK(NORDER) = 0.
      F  = 10000.
      I2 = UPPER(NORDER)-1
      I1 = LOWER(NORDER-1) + 1
      N1 = I2-I1 + 1
      DO 50 I = I1, I2
        F = MIN(F,X(I))
50    CONTINUE
      FBACK(NORDER-1) = F
      RETURN
      END

C @(#)spec3b.for	19.1 (ESO-DMD) 02/25/03 13:24:48
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
       PROGRAM SPEC3B
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C
C  Program SPEC3B       version 1.00        860906
C                       version 1.01        870609
C                       (Any no. of rows in i/p table).
C                       version 2.00        890424 (pMIDAS)
C.AUTHOR
C  F. Murtagh                  STECF              
C.MODIFICATIONS
C  M. Peron                    IPG           890901  add include files
C  P. Ballester                IPG           910313  Compil. option -u
C                                                    and more
C
C.KEYWORDS
C  Simulated images, test images.
C  Box function taken as PSF - with an option for the delta function.
C
C.PURPOSE
C  Create spectrum of more than 1 line, each a "box" in form.
C
C.OUTPUT
C
C  Keys:  OUT_A/C/1/60       output data array
C         INPUTR/R/1/1       centring relative to pixel centre
C         IN_TAB/C/1/60      table of positions of lines
C         INPUTR/R/2/1       box (PSF) width
C
C-----------------------------------------------------------
C
C
       IMPLICIT NONE
C
       REAL                     RMIN,RMAX
       REAL                     STEPO(3),STARTO(3),CUTS(4)
       REAL                     CENTR,BOX
C 
       DOUBLE PRECISION         DSTEP(3),DSTART(3)
C 
       INTEGER                  NPIXO(3),IMNO
       INTEGER                  NDIMO
       INTEGER                  MADRID,KUN,KNUL,TID
       INTEGER                  IACT,ISTAT,IDIM,IACTV,NC,NR,NS,NAC,NAR
       INTEGER                  KUNIT
C 
       INTEGER*8                JPNTR,IPTR
C 
       CHARACTER*60             OUTIMA,INTAB
       CHARACTER*72             IDENTO
       CHARACTER*80             CUNITO
C
       INCLUDE                 'MID_INCLUDE:ST_DEF.INC/NOLIST'
       COMMON                  /VMR/MADRID(1)
       INCLUDE                 'MID_INCLUDE:ST_DAT.INC/NOLIST'
C
C
C ... get into MIDAS
C
       CALL STSPRO('SPEC3B')
C
C ... get name of output frame
C
        CALL STKRDC('OUT_A',1,1,60,IACT,OUTIMA,KUN,KNUL,ISTAT)
C
C ... get centring.
C
        CALL STKRDR('INPUTR',1,1,IACT,CENTR,KUN,KNUL,ISTAT)
C
C ... map output image
C
       NDIMO = 1
       IDIM  = 660
       NPIXO(1)  = IDIM
       STARTO(1) = 1
       STEPO(1)  = 1.0
       CUNITO    = ' NONE'
       IDENTO    = ' ARTIFICIAL SPECTRUM' 
        DSTART(1) = STARTO(1)
        DSTEP(1)  = STEPO(1)
        CALL STIPUT(OUTIMA,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .                  NDIMO,NPIXO,DSTART,
     .                  DSTEP,IDENTO,CUNITO,JPNTR,IMNO,ISTAT)
C
C ... get line positions from table.
C
        CALL STKRDC('IN_TAB',1,1,60,IACTV,INTAB,KUN,KNUL,ISTAT)
        CALL TBTOPN(INTAB,0,TID,ISTAT)
        CALL TBIGET(TID,NC,NR,NS,NAC,NAR,ISTAT)
       IF (NC.NE.1.OR.NR.LT.1) THEN
          CALL STTPUT(' Invalid nos. of rows or columns.',ISTAT)
          CALL STTPUT(' in table specifying the lines.',ISTAT)
          CALL STTPUT(' Aborting.',ISTAT)
          GOTO 1000
       ENDIF
        CALL TBCMAP(TID,1,IPTR,ISTAT)
C
C ... get box width.
C
        CALL STKRDR('INPUTR',2,1,IACT,BOX,KUN,KNUL,ISTAT)
C
C ... now do the work
C
       IF (BOX.GT.0.001) THEN      ! PSF is a box of given width.
            CALL PATTERN1(MADRID(JPNTR),RMIN,RMAX,NR,MADRID(IPTR),
     +                    CENTR,BOX,ISTAT)
       ELSE                        ! PSF is a delta function.
            CALL PATTERN2(MADRID(JPNTR),RMIN,RMAX,NR,MADRID(IPTR),
     +                    CENTR,ISTAT)
       ENDIF
C
C ... write cuts
C
       CUTS(1) = RMIN
       CUTS(2) = RMAX
       CUTS(3) = RMIN
       CUTS(4) = RMAX
       CALL STDWRR(IMNO,'LHCUTS',CUTS,1,4,KUNIT,ISTAT)
C
C ... end
C
1000   CONTINUE
       CALL STFCLO(IMNO,ISTAT)
       CALL STSEPI
       END

C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C
C  Program PATTERN1    
C  F. MURTAGH                                 ST-ECF  Version 1.0 860411
C
C.KEYWORDS
C
C  Test patterns, simulated images.
C  A box function is taken as PSF.
C
C
C.OUTPUT PARAMETERS
C 
C  ARR  = the frame,
C  RMIN, RMAX = cut values (max. and min. flux values).
C
C----------------------------------------------------------------------
       SUBROUTINE PATTERN1(ARR,RMIN,RMAX,N,VALS,CENTR,BOX,
     +                          ISTAT)
C
       IMPLICIT NONE
C
C
       INTEGER           N,ISTAT,I,II,III,IVAL,IBEG,IEND
       REAL              ARR(660),VALS(N),VAL,XL,XU
       REAL              RMIN,RMAX,CENTR,BOX,X,ZL,ZU,V
C
C
C
       DO I=1,660
          ARR(I) = 0.0
       ENDDO
C
C
       DO II = 1,N
       IVAL = VALS(II)           
C Just a check on integer values,...
C ...since this is impt. for pixel addressing.
       VAL = IVAL
C
C ...   a few calculations:
C
C ...   XL and XU are extremities of the box:
C
       XL = VAL - 0.5*BOX
       XU = VAL + 0.5*BOX
       XL = MAX(0.5,XL)
       XU = MIN(660.5,XU)
C
C
          DO I =1, 660      ! Do, crudely, for all pixels.
             X = I
             ZL = X-0.5     ! Lower limit of pixel,
             ZU = X+0.5     ! upper limit of pixel.
             IF (XL.GE.ZL.AND.XL.LE.ZU) THEN  ! Lr. end of box is in this pix.
                IF (XU.LE.ZU) THEN            ! All of box is in same pixel.
                   ARR(I) = ARR(I) + XU*10000.0-XL*10000.0
                  GOTO 350 
                ENDIF
                ARR(I) = ARR(I) + ZU*10000.0-XL*10000.0
                IBEG = I+1
                GOTO 200
             ENDIF
          ENDDO
  200          CONTINUE
          DO I = IBEG-1,660
             X = I
             ZL = X-0.5
             ZU = X+0.5
             IF (XU.GT.ZL.AND.XU.LE.ZU) THEN
                ARR(I) = ARR(I) + XU*10000.0-ZL*10000.0             
                IEND = I-1
                GOTO 300
             ENDIF
          ENDDO
  300          CONTINUE
          IF (IEND.GE.IBEG) THEN
             DO III = IBEG,IEND
                ARR(III) = ARR(III) + 10000.0
             ENDDO
          ENDIF
  350      CONTINUE
C
C ...   Now offset input value by +0.5
C
C ...   XL and XU are extremities of the box:
C
       V  = VAL + 0.5
       XL = V - 0.5*BOX
       XU = V + 0.5*BOX
       XL = MAX(0.5,XL)
       XU = MIN(660.5,XU)
C
C
          DO I =1, 660      ! Do, crudely, for all pixels.
             X = I
             ZL = X-0.5     ! Lower limit of pixel,
             ZU = X+0.5     ! upper limit of pixel.
             IF (XL.GE.ZL.AND.XL.LE.ZU) THEN  ! Lower end of box is in this pix.
                IF (XU.LE.ZU) THEN            ! All of box is in same pixel.
                  ARR(I+220) = ARR(I+220) + XU*10000.0-XL*10000.0
                  GOTO 550 
                ENDIF
                ARR(I+220) = ARR(I+220) + ZU*10000.0-XL*10000.0
                IBEG = I+1
                GOTO 400
             ENDIF
          ENDDO
  400          CONTINUE
          DO I = IBEG-1,660
             X = I
             ZL = X-0.5
             ZU = X+0.5
             IF (XU.GT.ZL.AND.XU.LE.ZU) THEN
              ARR(I+220) = ARR(I+220) + XU*10000.0-ZL*10000.0             
              IEND = I-1
              GOTO 500
             ENDIF
          ENDDO
  500          CONTINUE
          IF (IEND.GE.IBEG) THEN
             DO III = IBEG,IEND
                ARR(III+220) = ARR(III+220) + 10000.0
             ENDDO
          ENDIF
  550      CONTINUE
C
C ...   Now offset input value by +CENTR
C
C ...   XL and XU are extremities of the box:
C
       V  = VAL + CENTR
       XL = V - 0.5*BOX
       XU = V + 0.5*BOX
       XL = MAX(0.5,XL)
       XU = MIN(660.5,XU)
C
C
          DO I =1, 660      ! Do, crudely, for all pixels.
             X = I
             ZL = X-0.5     ! Lower limit of pixel,
             ZU = X+0.5     ! upper limit of pixel.
             IF (XL.GE.ZL.AND.XL.LE.ZU) THEN  ! Lower end of box is in this pix.
                IF (XU.LE.ZU) THEN            ! All of box is in same pixel.
                   ARR(I+440) = ARR(I+440) + XU*10000.0-XL*10000.0
                  GOTO 750 
                ENDIF
                ARR(I+440) = ARR(I+440) + ZU*10000.0-XL*10000.0
                IBEG = I+1
                GOTO 600
             ENDIF
          ENDDO
  600          CONTINUE
          DO I = IBEG-1,660
             X = I
             ZL = X-0.5
             ZU = X+0.5
             IF (XU.GT.ZL.AND.XU.LE.ZU) THEN
                ARR(I+440) = ARR(I+440) + XU*10000.0-ZL*10000.0             
                IEND = I-1
                GOTO 700
             ENDIF
          ENDDO
  700          CONTINUE
          IF (IEND.GE.IBEG) THEN
             DO III = IBEG,IEND
                ARR(III+440) = ARR(III+440) + 10000.0
             ENDDO
          ENDIF
  750      CONTINUE
C
C ...   that's all:
C
       ENDDO
C
C
C ------DETERMINE CUTS (I.E. MAX AND MIN VALUES)---------------------
C
       RMIN = 1000.0
       RMAX = 0.0
       DO I = 1, 660
          ARR(I) = ARR(I)/100.0
          IF (ARR(I).GT.RMAX) RMAX = ARR(I) 
          IF (ARR(I).LT.RMIN) RMIN = ARR(I) 
       ENDDO
C
C
       RETURN
C
       END

C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C
C  Program PATTERN2    
C  F. MURTAGH                                 ST-ECF  Version 1.0 860411
C
C.KEYWORDS
C
C  Test patterns, simulated images.
C  Delta function taken as PSF of lines.
C
C
C.OUTPUT PARAMETERS
C 
C  ARR  = the frame,
C  RMIN, RMAX = cut values (max. and min. flux values).
C
C----------------------------------------------------------------------
       SUBROUTINE PATTERN2(ARR,RMIN,RMAX,N,VALS,CENTR,
     X                          ISTAT)
C
       IMPLICIT NONE
C
       REAL                     ARR(660),VALS(1)
C
       INTEGER                  N,ISTAT,I
       REAL                     RMIN,RMAX,CENTR
       INTEGER                  LVAL             ! From Real to INT 25.04.91
C
C
C
       DO I = 1, 660
          ARR(I) = 0.0
       ENDDO
C
C ...   first line is located at centre of pixel:
        DO I = 1, N
          LVAL = VALS(I)
          ARR(LVAL) = 100.0
       ENDDO
C ...   next, line is located at pixel boundary - by convention,
C ...   with delta function, all goes to one pixel:
       DO I = 1, N
          LVAL = VALS(I)
          ARR(LVAL+220) = 100.0
       ENDDO
C ...   finally, line is located at offset rel. to pix. centre:
       DO I = 1, N
          LVAL = VALS(I)
          IF (CENTR.GT.0.5.AND.CENTR.LT.1.0) LVAL = LVAL+1
          IF (LVAL+440.LE.660) ARR(LVAL+440) = 100.0
       ENDDO
C
C
C ------DETERMINE CUTS (I.E. MAX AND MIN VALUES)---------------------
C
       RMIN = 0.0
       RMAX = 100.0
C
C
       RETURN
C
       END

C @(#)psf.for	19.1 (ES0-DMD) 02/25/03 13:23:50
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE  GETPSF (PIC, NCOL, NROW, PAR, PSF, OPT, NOPT)
      IMPLICIT NONE
C
C=======================================================================
C
C This subroutine generates a point-spread function from one or the
C average of several stars.
C
C                OFFICIAL DAO VERSION:  1991 May 10
C
C The subroutine reads in a subarray around the first desired
C point-spread function star, fits a gaussian profile to the core of
C the image, and generates a look-up table of the residuals of the
C actual image data from the gaussian fit.  If desired, it will then
C fit this PSF to another star to determine its precise centroid,
C scale the same Gaussian to the new star's core, and add the
C differences between the actual data and the scaled Gaussian to the
C look-up table.  This can go on star after star after star.
C The parameters of the Gaussian approximation and the table of
C corrections from the approximation to the true PSF are stored in
C a disk file.
C
C Arguments
C
C PSFRAD (INPUT) is the radius, in pixels, of the circular area within
C        which we ultimately wish to define the PSF.  Because of the
C        need to perform numerical interpolation, we will actually
C        generate and store a look-up table occupying a larger area.
C        The look-up table will be square, even though the corners will
C        be unused.
C
C FITRAD (INPUT) is the fitting radius, which will be used in defining
C        what is meant by a "neighbor" of the PSF star.
C
C Both of these arguments are user-definable parameters, whose values
C may be altered by a DEFAULT.OPT file, or by the OPTIONS command.
C
C=======================================================================
C
C Modifications as of 1991 May 10.
C ===================================
C
C
C I'm going to try to rig this thing so it can reduce the weights of
C (that is, "ignore") discordant pixels in the calculation of the
C look-up tables of corrections.  To accomplish this, I'm going to
C change the way PSF operates.  Instead of reading in a subsection
C for each PSF star one at a time, it will read in the whole image
C and work in memory.
C
      INTEGER MAXBOX, MAXPSF, MAXSTR, MAXN, MAXPAR, MAXEXP, NCOL, NROW
      INTEGER NOPT
      PARAMETER  (MAXPAR=6, MAXPSF=145, MAXEXP=6,
     .     MAXBOX=69, MAXSTR=60000, MAXN=200)
C MAXSTR increased from 9999 to 60000, because now larger images are
C allowed which will also result in more stars 5/99 PN     
C
C Parameters
C
C MAXBOX is the square subarray that will hold the largest final PSF.
C        If the maximum PSF radius permitted is R, then MAXBOX is the
C        odd integer 2*INT(R)+1.  However, because we will be dealing
C        with two levels of interpolation:  (1) interpolating the raw
C        picture data to arrive at a PSF whose centroid coincides with
C        the central pixel of the look-up table; and (2) interpolating
C        within the PSF itself to evaluate it for comparison with the
C        raw picture data for the program stars, PSF will have to
C        operate on a square array which is larger by 7 pixels in X
C        and Y than MAXBOX.  Hence, the dimensions below are all
C        MAXBOX + 7.
C
C MAXPSF is the dimension of the largest lookup table that will ever
C        need to be generated.  Recall that the corrections from the
C        Gaussian approximation of the PSF to the true PSF will be
C        stored in a table with a half-pixel grid size.
C        MAXPSF must then equal
C
C                       2*[ 2*INT(R) + 1 ] + 7.
C
C MAXSTR is the largest number of stars permitted in a data file.
C
C MAXN is the maximum permitted number of PSF stars.
C
C MAXPAR is the maximum number of parameters which may be used to
C        describe the analytic part of the PSF, *** IN ADDITION TO
C        the central intensity, and the x and y centroids.
C
C MAXEXP is the maximum number of terms in the expansion of the
C        look-up table (1 for constant, 3 for linear, 6 for quadratic).
C
      CHARACTER LINE*80, LABEL*8
      CHARACTER*30 COOFIL, MAGFIL, PSFFIL, FITFIL, GRPFIL, SWITCH
      CHARACTER EXTEND*30, CASE*30, FLAG(MAXN)*1, ANSWER*1
      REAL CON(MAXPSF,MAXPSF), CORNER(MAXPSF*MAXPSF/4)
      REAL PIC(NCOL,NROW)
      REAL PAR(MAXPAR)
      REAL C(MAXEXP,MAXEXP), V(MAXEXP), TERM(MAXEXP)
      REAL PSF(MAXEXP,MAXPSF,MAXPSF)
      REAL XCEN(MAXSTR), YCEN(MAXSTR), APMAG(MAXSTR), SKY(MAXSTR)
      REAL HPSF(MAXN), OPT(NOPT)
      REAL HJNK(MAXN), XJNK(MAXN), YJNK(MAXN)
      REAL PROFIL, BICUBC, PCTILE, SQRT
      INTEGER ID(MAXSTR), NTAB(-1:2), NPARAM
      LOGICAL IN(MAXPSF,MAXPSF), EDGE(MAXPSF,MAXPSF)
C
      DOUBLE PRECISION SUM, VOL
      REAL LOBAD, HIBAD, THRESH, AP1, PHPADU, READNS, FRAD, RONOIS,
     .     FWHM, WATCH, FITRAD, RADSQ, PSFRAD, PSFMAG, FMAX, DATUM, RSQ,
     .     DFDX, DFDY, SIG, DX, DY, RDX, RDY, XMID, YMID, DP, OLD, W,
     .     WT, RADIUS, SCALE, SUMSQ, SUMN
      INTEGER I, J, K, L, N, NIN, LX, LY, MX, MY, NTOT, NSTAR, ISTAR, NL
      INTEGER IEXPAND, IFRAC, IPSTYP, NPSF, NPAR, ISTAT, EDGESQ,
     .     NEXP, MIDDLE, MIDSQ, IDX, JDY, JDYSQ, IX, JY, ITER, NPASS
      LOGICAL STAROK
C
      COMMON /FILNAM/ COOFIL, MAGFIL, PSFFIL, FITFIL, GRPFIL
      COMMON /PEAK/ PHPADU, RONOIS
C
      DATA NTAB / 0, 1, 3, 6 /
C
C-----------------------------------------------------------------------
C
C SECTION 1
C
C Set up the necessary variables, open the necessary files, read in the
C relevant data for all stars.
C
      FWHM = OPT(5)
      WATCH = OPT(11)
      FITRAD = OPT(12)
      RADSQ = FITRAD**2
      PSFRAD = OPT(13)
      IEXPAND = NINT(OPT(14))
      IFRAC = NINT(OPT(15))
      NPASS = NINT(OPT(17))
C
C If in the final analysis we want to be able to determine a value for
C the point-spread function anywhere within a radius of R pixels, and
C we want the lookup table to have a one-half pixel grid spacing in
C each coordinate.  To go from 0 to R with half-pixel steps, we
C need 2*R points, not including the central ("0") one.  Outside this
C we will need an additional pixel, just to make sure we will be able to
C do the interpolations at the outermost radii.  Then, to get a
C square box centered on (0,0) we will need 2*(2*R+1)+1 pixels.
C
      NPSF = 2*(NINT(2.*PSFRAD)+1)+1
      PSFRAD = (REAL(NPSF-1)/2. - 1.)/2.
      MIDDLE = (NPSF+1)/2
C
C Ascertain the name of the input (aperture, usually) photometry file,
C and read in the relevant data for all stars.
C
      CALL TBLANK
  920 CALL GETNAM ('File with aperture results:', MAGFIL)
      IF ((MAGFIL .EQ. 'END OF FILE') .OR.
     .     (MAGFIL .EQ. 'GIVE UP')) THEN
         MAGFIL = ' '
         RETURN
      END IF
      CALL INFILE (2, MAGFIL, ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error opening input file '//MAGFIL)
         MAGFIL = 'GIVE UP'
         GO TO 920
      END IF
      CALL RDHEAD (2, NL, I, I, LOBAD, HIBAD, THRESH, AP1,
     .     PHPADU, READNS, DX)
      RONOIS = READNS**2
C
      I = 0
 1010 I = I+1
      IF (I .GT. MAXSTR) GO TO 1100
 1020 CALL RDSTAR (2, NL, ID(I), XCEN(I), YCEN(I), APMAG(I), SKY(I))
      IF (ID(I) .LT. 0) GO TO 1100             ! End-of-file encountered
      IF (ID(I) .EQ. 0) GO TO 1020             ! Blank line encountered
      GO TO 1010
C
 1100 NTOT = I-1
      CALL CLFILE (2)
      PSFFIL = SWITCH(MAGFIL, CASE('.lst'))
      CALL GETNAM ('File with PSF stars:', PSFFIL)
      IF ((PSFFIL .EQ. 'END OF FILE') .OR.
     .     (PSFFIL .EQ. 'GIVE UP')) THEN
         PSFFIL = ' '
         RETURN
      END IF
      CALL INFILE (2, PSFFIL, ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error opening input file '//PSFFIL)
         PSFFIL = 'GIVE UP'
         GO TO 1120
      END IF
      NL = -1
      CALL RDHEAD (2, NL, I, I, LOBAD, HIBAD, THRESH, AP1,
     .     PHPADU, READNS, FRAD)
      PSFFIL = SWITCH(PSFFIL, CASE('.psf'))
 1120 CALL GETNAM ('File for the PSF:', PSFFIL)
      IF ((PSFFIL .EQ. 'END OF FILE') .OR.
     .     (PSFFIL .EQ. 'GIVE UP')) THEN
         PSFFIL = ' '
         RETURN
      END IF
      PSFFIL = EXTEND(PSFFIL, CASE('psf'))
      CALL OUTFIL (3, PSFFIL, ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error opening output file '//PSFFIL)
         PSFFIL = 'GIVE UP'
         GO TO 1120
      END IF
      CALL TBLANK
C
C Read in the entire image.
C
      LX = 1
      LY = 1
      MX = NCOL
      MY = NROW
      CALL RDARAY ('DATA', LX, LY, MX, MY, NCOL, PIC, ISTAT)
C
C-----------------------------------------------------------------------
C
C SECTIONS 2
C
C Learn the name of each PSF star and find it in the star list.  Display
C a subarray around it if desired, and check it for invalid pixels.
C
      NSTAR = 0
      N = NPARAM(1, FWHM, LABEL, PAR, MAXPAR)
C
C NSTAR will point at the last PSF star in the stack after the PSF
C stars have been brought to the top.
C
 2000 CONTINUE
      CALL RDSTAR (2, NL, I, DX, DY, RDX, RDY)
      IF (I .EQ. 0) GO TO 2000
      IF (I .LT. 0) THEN
         CALL CLFILE (2)
         GO TO 3000
      END IF
C
      DO 2010 ISTAR=NSTAR+1,NTOT
      IF (ID(ISTAR) .EQ. I) GO TO 2020
 2010 CONTINUE
      WRITE (LINE, 701) I, ': Star not found.'
  701 FORMAT (I5, A)
      CALL STUPID (LINE)
      GO TO 2000
C
 2020 CONTINUE
      IF ( ( INT(XCEN(ISTAR)-FITRAD) .LT. 0 ) .OR.
     .     ( INT(XCEN(ISTAR)+FITRAD) .GT. NCOL ) .OR.
     .     ( INT(YCEN(ISTAR)-FITRAD) .LT. 0 ) .OR.
     .     ( INT(YCEN(ISTAR)+FITRAD) .GT. NROW ) ) THEN
         WRITE (LINE,701) ID(ISTAR), ': Too near edge of frame.'
         CALL STUPID (LINE)
         GO TO 2000
      END IF
      IF (NSTAR .EQ. 0) THEN
C
C This assigns the aperture magnitude of the first PSF star to the
C constant PSFMAG.  If the star-list file contains an aperture
C magnitude, use that one rather than the one in the input
C photometry file, which may have accumulated some drift over the
C course of several iterations.
C
         IF ((RDX .GT. 0.5) .AND. (RDX .LT. 50.)) THEN
            PSFMAG = RDX
         ELSE
            PSFMAG = APMAG(ISTAR)
         END IF
      END IF
C
C Define the subarray containing the star and search it for "bad"
C pixels.  This will include a two-pixel border around the PSF box
C itself, to guarantee valid interpolations to within the PSF box.
C
      LX = MAX0( 1, INT(XCEN(ISTAR)-PSFRAD)-1 )
      LY = MAX0( 1, INT(YCEN(ISTAR)-PSFRAD)-1 )
      MX = MIN0(NCOL, INT(XCEN(ISTAR)+PSFRAD)+2 )
      MY = MIN0(NROW, INT(YCEN(ISTAR)+PSFRAD)+2 )
C
      FMAX=-32768.
      STAROK=.TRUE.
C
      DO J=LY,MY
         DO I=LX,MX
            DATUM = PIC(I,J)
            IF ((DATUM .LT. LOBAD) .OR. (DATUM .GT. HIBAD)) THEN
               RSQ = (I-XCEN(ISTAR))**2 + (J-YCEN(ISTAR))**2
               IF (RSQ .LE. RADSQ) THEN
                 WRITE (LINE,627) ID(ISTAR)
 627             FORMAT (1X, I5, ' is not a good star.')
                 CALL STUPID (LINE(1:26))
                 GO TO 2000
               END IF
C
               IF (STAROK) THEN
                 STAROK = .FALSE.
                 IF (WATCH .GT. -0.5) THEN
                   CALL TBLANK
                   WRITE (6,628) ID(ISTAR), DATUM, 7, I, J
 628               FORMAT (1X, I5, ' has a bad pixel:',  F9.1,
     .                  ' at position', A1, 2I5)
                 ELSE
                   WRITE (6,629) ID(ISTAR)
 629               FORMAT (1X, I5, ' has bad pixels.')
                 END IF
               ELSE
                 IF (WATCH .GT. -0.5)
     .                WRITE (6,628) ID(ISTAR), DATUM, 0, I, J
               END IF
C
C Replace the defective pixel with an average of surrounding
C pixels.
C
               DATUM = 0.
               SUMN = 0.
               DO L=MAX0(1,J-1),MIN0(NROW,J+1)
                  DO K=MAX0(1,I-1),MIN0(NCOL,I+1)
                     IF ((PIC(K,L) .GE. LOBAD) .AND.
     .                   (PIC(K,L) .LE. HIBAD)) THEN
                        DATUM = DATUM + PIC(K,L)
                        SUMN = SUMN+1.
                     END IF
                  END DO
               END DO
               IF (SUMN .LT. 1.5) THEN
                  WRITE (LINE,627) ID(ISTAR)
                  CALL STUPID (LINE(1:26))
                  GO TO 2000
               ELSE
                  PIC(I,J) = DATUM/SUMN
               END IF
            ELSE
               IF (DATUM .GT. FMAX) FMAX=DATUM
            END IF
         END DO
      END DO
C
      IF ((WATCH .GT. -0.5) .AND. (.NOT. STAROK)) THEN
         CALL TBLANK
         CALL GETYN ('Try this one anyway?', ANSWER)
         IF (ANSWER .EQ. 'E') THEN
            CALL CLFILE (2)
            CALL CLFILE (3)
            RETURN
         END IF
         IF (ANSWER .NE. 'Y') GO TO 2000
      END IF
C
      IF (WATCH .GT. 0.5) THEN
         CALL SHOW (PIC(LX,LY), FMAX, SKY(ISTAR),
     .        MX-LX+1, MY-LY+1, NCOL)
         WRITE (6,622) ID(ISTAR), XCEN(ISTAR), YCEN(ISTAR),
     .        APMAG(ISTAR), NINT(FMAX)
  622    FORMAT (1X, I5, 2F9.2, F9.3, 2X, 'Brightest pixel:', I7)
         CALL GETYN ('Use this one?', ANSWER)
         IF (ANSWER .EQ. 'E') THEN
            CALL CLFILE (2)
            CALL CLFILE (3)
            RETURN
         END IF
         IF (ANSWER .EQ. 'N') GO TO 2000
      END IF
C
C Switch this star (at position ISTAR) with the one at position NSTAR+1
C (which is the highest star in the stack not already a PSF star).
C Estimate the height of the best-fitting profile of type 1 (probably
C a Gaussian) on the basis of the central pixel.
C
      NSTAR = NSTAR+1
      CALL SWAPP (ID, XCEN, YCEN, APMAG, SKY, ISTAR, NSTAR)
      HPSF(NSTAR) = (FMAX-SKY(NSTAR))/
     .     PROFIL(1, 0., 0., PAR, DFDX, DFDY, TERM, 0)
      IF (NSTAR .LE. MAXN) GO TO 2000
C
 3000 CONTINUE
      NEXP = NTAB(IEXPAND) + 2*IFRAC
      IF (NSTAR .LT. NEXP) THEN
         CALL STUPID (
     .   'There aren''t enough PSF stars for a PSF this variable.')
         WRITE (6,*) 'Please change something.'
         CALL TBLANK
         RETURN
      END IF
      CALL TBLANK
      CALL OVRWRT ('    Chi     Parameters...', 1)
C
C If OPT(16) (Analytic model PSF) is negative, then try all PSF types
C from 1 to | OPT(16) |, inclusive.
C
      K = NINT(OPT(16))
      J = MAX0(1,K)
      K = IABS(K)
      OLD = 1.E38
      IPSTYP = 0
      DO 3050 I=J,K
C
         DO L=1,NSTAR
            HJNK(L) = HPSF(L)
            XJNK(L) = XCEN(L)
            YJNK(L) = YCEN(L)
         END DO
C
         N = NPARAM(I, FWHM, LABEL, PAR, MAXPAR)
         CALL  FITANA  (PIC, NCOL, NROW, HJNK, XJNK, YJNK, SKY,
     .       NSTAR, LOBAD, HIBAD, FITRAD, WATCH, I, PAR, N, SIG)
C
C SIG is the root-mean-square scatter about the best-fitting analytic
C function averaged over the central disk of radius FITRAD, expressed
C as a fraction of the peak amplitude of the analytic model.
C
         IF (PAR(1) .LT. 0.) GO TO 3050
C
C If this latest fit is better than any previous one, store the
C parameters of the stars and the model for later reference.
C
         IF (SIG .LT. OLD) THEN
            IPSTYP = I
            NPAR = N
            WRITE (LINE,201) (PAR(L), L=1,NPAR)
  201       FORMAT (1X, 1P, 6E13.5)
            DO L=1,NSTAR
               HPSF(L) = HJNK(L)
               XCEN(L) = XJNK(L)
               YCEN(L) = YJNK(L)
            END DO
            OLD = SIG
         END IF
 3050 CONTINUE
      IF (IPSTYP .LE. 0) RETURN
      CALL TBLANK
      READ (LINE,*) (PAR(L), L=1,NPAR)
C
C This last bit ensures that the subsequent computations will be
C performed with the parameters rounded off exactly the same as they
C appear in the output .PSF file.
C
C Write PSF file header.
C
      XMID = REAL(NCOL-1)/2.
      YMID = REAL(NROW-1)/2.
      WRITE (3,202) LABEL, NPSF, NPAR, NTAB(IEXPAND), 5*IFRAC,
     .     PSFMAG, HPSF(1), XMID, YMID
  202 FORMAT (1X, A8, 4I5, F9.3, F15.3, 2F9.1)
      WRITE (3,203) LINE
  203 FORMAT (A)
C
C=======================================================================
C
C At this point, we have values for the parameters of the best-fitting
C analytic function.  Now we may want to generate the look-up table of
C corrections from the best-fitting analytic function to the actual
C data.  This will be generated within a square box of size NPSF x NPSF
C with half-pixel spacing, centered on the centroid of the star.
C
C First, subtract the analytic function from all the PSF stars in the
C original image.
C
      DP = 0.
      DO ISTAR=1,NSTAR
         LX = MAX0( 1, INT(XCEN(ISTAR)-PSFRAD)-1 )
         LY = MAX0( 1, INT(YCEN(ISTAR)-PSFRAD)-1 )
         MX = MIN0(NCOL, INT(XCEN(ISTAR)+PSFRAD)+2 )
         MY = MIN0(NROW, INT(YCEN(ISTAR)+PSFRAD)+2 )
         RDX = 0.0
         RDY = 0.0
         DO 3350 J=LY,MY
            DY = REAL(J) - YCEN(ISTAR)
            W = DY**2
            DO I=LX,MX
               DX = REAL(I) - XCEN(ISTAR)
               PIC(I,J) = PIC(I,J) - HPSF(ISTAR) *
     .              PROFIL(IPSTYP, DX, DY, PAR, DFDX, DFDY, TERM, 0)
               IF (DX**2 + W .LT. RADSQ) THEN
                  RDX = RDX + (PIC(I,J)-SKY(ISTAR))**2
                  RDY = RDY + 1.
               END IF
            END DO
 3350    CONTINUE
         DP = DP + RDY                      ! Total number of pixels
         RDX = SQRT(RDX/RDY)                ! Scatter inside fit radius
         PSF(ISTAR,1,1) = RDX/(HPSF(ISTAR)*
     .        PROFIL(IPSTYP, 0., 0., PAR, DFDX, DFDY, TERM, 0))
      END DO
C
      DP = SQRT(DP/(DP-REAL(NEXP+3*NSTAR))) ! Degrees of freedom
      DO ISTAR=1,NSTAR
         PSF(ISTAR,1,1) = DP * PSF(ISTAR,1,1)
         FLAG(ISTAR) = ' '
         IF (SIG .GT. 0.) THEN
            RDX = PSF(ISTAR,1,1)/SIG
            IF (RDX .GE. 3.) THEN
               FLAG(ISTAR) = '*'
            ELSE IF (RDX .GE. 2.) THEN
               FLAG(ISTAR) = '?'
            END IF
         END IF
      END DO
      K = (NSTAR-1)/5 + 1                   ! Number of lines
      WRITE (6,68)
   68 FORMAT (/' Profile errors:'/)
      DO I=1,K
         WRITE (6,69) (ID(ISTAR), PSF(ISTAR,1,1),
     .        FLAG(ISTAR), ISTAR=I,NSTAR,K)
   69    FORMAT (5(1X, I5, F7.3, 1X, A1, 1X))
      END DO
      CALL TBLANK
CD     CALL COPPIC (CASE('junk'), ISTAT)
CD     LX = 1
CD     LY = 1
CD     MX = NCOL
CD     MY = NROW
CD     CALL WRARAY ('copy', LX, LY, MX, MY, NCOL, PIC, ISTAT)
CD     CALL CLPIC ('COPY')
      IF (IEXPAND+IFRAC .LT. 0) GO TO 2900
      SCALE = HPSF(1)
      DO ISTAR=NSTAR,1,-1
         HPSF(ISTAR) = HPSF(ISTAR)/HPSF(1)
      END DO
C
C=======================================================================
C
C Now compute look-up tables.
C
      MIDSQ = MIDDLE**2
C
C MIDDLE is the center of the look-up table, which will correspond to
C the centroid of the analytic PSF.  MIDSQ is the square of the
C radius of the PSF table, plus a pixel's worth of slack just to
C make sure you'll always have a 4x4 array suitable for interpolation.
C
      NIN = 0
      EDGESQ = (MIDDLE-2)**2
      DO J=1,NPSF
         JDY = J-MIDDLE
         JDYSQ = JDY**2
         DY = REAL(JDY)/2.
         DO I=1,NPSF
            DO K=1,NEXP
               PSF(K,I,J) = 0.0
            END DO
C
            IDX = I-MIDDLE
            IF (IDX**2 + JDYSQ .LE. MIDSQ) THEN
               IN(I,J) = .TRUE.
               NIN = NIN + 1
               IF (IDX**2 + JDYSQ .GE. EDGESQ) THEN
                  EDGE(I,J) = .TRUE.
               ELSE
                  EDGE(I,J) = .FALSE.
               END IF
            ELSE
               IN(I,J) = .FALSE.
               EDGE(I,J) = .FALSE.
            END IF
         END DO
      END DO
C
      TERM(1) = 1.
      DO 4950 JY=1,NPSF
         RDY = REAL(JY-MIDDLE)/2.
C
         DO 4940 IX=1,NPSF
            IF (.NOT. IN(IX,JY)) GO TO 4940
C
C Don't waste time with pixels outside a radius = (MIDDLE-1).
C
            RDX = REAL(IX-MIDDLE)/2.
            DO 4935 ITER=0,NPASS
C
C Initialize accumulators.
C
            SUMSQ = 0.
            SUMN = 0.
            DO L=1,NEXP
               V(L) = 0.
               DO K=1,NEXP
                  C(K,L) = 0.
               END DO
            END DO
C
C Now, for this point in the set of lookup table(s) [(IX,JY), where
C (MIDDLE,MIDDLE) corresponds to the centroid of the PSF], consult
C each of the PSF stars to determine the value(s) to put into the
C table(s).
C
            DO 4900 ISTAR = 1,NSTAR
C
C What pixels in the original image constitute a 4x4 box surrounding
C this (IX,JY) in the PSF, as referred to this star's centroid?
C
               DX = XCEN(ISTAR) + RDX
               DY = YCEN(ISTAR) + RDY
               I = INT(DX)
               J = INT(DY)
C
C The 4x4 box is given by  I-1 <= x <= I+2, J-1 <= y <= J+2.
C
               IF ((I .LT. 2) .OR. (J .LT. 2) .OR.
     .              (I+2 .GT. NCOL) .OR.
     .              (J+2 .GT. NROW)) GO TO 4900           ! Next star
               DX = DX - I
               DY = DY - J
C
C The point which corresponds PRECISELY to the offset (RDX,RDY)
C from the star's centroid, lies a distance (DX,DY) from pixel
C (I,J).
C
C Use bicubic interpolation to evaluate the residual PSF amplitude
C at this point.  Scale the residual up to match the first PSF star.
C
               DP = BICUBC(PIC(I-1,J-1), NCOL, DX, DY, DFDX, DFDY)
     .              - SKY(ISTAR)
               DP = DP/HPSF(ISTAR)
               SUMSQ = SUMSQ + ABS(DP)
               SUMN = SUMN + 1.
               IF (IEXPAND .GE. 1) THEN
                  TERM(2) = (XCEN(ISTAR)-1.)/XMID-1.
                  TERM(3) = (YCEN(ISTAR)-1.)/YMID-1.
                  IF (IEXPAND .GE. 2) THEN
                     TERM(4) = 1.5*TERM(2)**2-0.5
                     TERM(5) = TERM(2)*TERM(3)
                     TERM(6) = 1.5*TERM(3)**2-0.5
                  END IF
               END IF
C
C               IF (IFRAC .GE. 1) THEN
C
C INSERT CODE HERE
C
               IF (ITER .GT. 0) THEN
                  OLD = 0.
                  DO K=1,NEXP
                     OLD = OLD + PSF(K,IX,JY) * TERM(K)
                  END DO
C
                  IF (ITER .LT. MAX0(3,NPASS/2)) THEN
                     W = HPSF(ISTAR)/(1. + (ABS(DP - OLD)/SIG))
                  ELSE
                     W = HPSF(ISTAR)/(1. + ((DP - OLD)/SIG)**2)
                  END IF
               ELSE
                  W = HPSF(ISTAR)
               END IF
C
               DO K=1,NEXP
                  WT = W*TERM(K)
                  V(K) = V(K) + WT*DP
                  DO L=1,NEXP
                     C(K,L) = C(K,L) + WT*TERM(L)
                  END DO
               END DO
 4900       CONTINUE
C
            CALL INVERS (C, MAXEXP, NEXP, ISTAT)
            CALL VMUL (C, MAXEXP, NEXP, V, PSF(1,IX,JY))
            SIG = 1.2533*SUMSQ/SQRT(SUMN*(SUMN - NEXP))
 4935       CONTINUE
 4940    CONTINUE
 4950 CONTINUE
      IF (NEXP .LT. 2) GO TO 2800
C
C At this point, we must be sure that any higher order terms
C in the PSF [i.e. those that go as powers of (XCEN-XMID) and
C (YCEN-YMID)] contain zero volume, so that the total volume
C of the PSF is independent of position.  This will be done
C by looking at the total flux contained in the look-up
C tables of index 2 and higher.  The analytic function
C will be scaled to the same total flux and subtracted from
C each of the higher lookup tables and added into the
C lookup table of index 1.  I scale the analytic function
C instead of simply transferring the net flux from the
C higher tables to table 1, because it is poor fits of
C the analytic profile to the image data which has caused
C the net flux in the lookup tables to depend upon position.
C
C Compute the brightness weighted average value of each of
C the terms in the polynomial expansion.
C
      DO K=1,NEXP
         TERM(K) = 0.
      END DO
C
      DO ISTAR=NSTAR,1,-1
         DX = (XCEN(ISTAR)-1.)/XMID-1.
         DY = (YCEN(ISTAR)-1.)/YMID-1.
         TERM(1) = TERM(1) + HPSF(ISTAR)
         TERM(2) = TERM(2) + HPSF(ISTAR)*DX
         TERM(3) = TERM(3) + HPSF(ISTAR)*DY
         IF (IEXPAND .GE. 2) THEN
            TERM(4) = TERM(4) + HPSF(ISTAR)*(1.5*DX**2-0.5)
            TERM(5) = TERM(5) + HPSF(ISTAR)*(DX*DY)
            TERM(6) = TERM(6) + HPSF(ISTAR)*(1.5*DY**2-0.5)
         END IF
C
C            IF (IFRAC .GE. 1) THEN
C
C INSERT CODE HERE
C
      END DO
C
      DO K=NEXP,1,-1
         TERM(K) = TERM(K)/TERM(1)
      END DO
C
C Okey doke.  Now if there is any net volume contained in any of the
C higher order (variable) terms of the PSF, we will remove it in two
C steps.  First of all, there is the possibility that there were some
C errors in the sky estimates which was correlated with position.
C We will remove this by determining the median value of PSF(K,I,J)
C in the outermost ring of the PSF, at the PSF RADIUS.  This
C value will be subtracted from PSF(K,I,J); it will also be added into
C the constant part of the PSF --- evaluated at a location corresponding
C to the mean value of the polynomial term --- to keep the PSF for the
C mean polynomial unchanged.  That way, if there is on average some
C systematic error in sky estimate, at least it will be constant over
C the area of the frame.  (This, of course, is potentially dangerous for
C a globular cluster or similar object centered within the frame.  I
C have to think about this some more.)
C
CD     CALL COPPIC (CASE('stuff'), ISTAT)
CD     DO K=1,NCOL
CD        CORNER(K) = -32768
CD     END DO
CD     LX = 1
CD     MX = NCOL
CD     MY = 1
CD     DO K=1,NROW
CD        LY = K
CD        CALL WRARAY ('COPY', LX, LY, MX, MY, NCOL, CORNER, ISTAT)
CD     END DO
C
CD     DO K=1,NEXP
CD        L = MOD(K-1,6)
CD        L = L*NPSF + L
CD        LY = (K-1)/6
CD        LY = LY*NPSF + LY
CD        MX = 1
CD        MY = 1
CD        DO J=1,NPSF
CD           LY = LY + 1
CD           DO I=1,NPSF
CD              LX = L + I
CD              CALL WRARAY ('COPY', LX, LY, MX, MY, MAXPSF,
CD    .              PSF(K,I,J), ISTAT)
CD           END DO
CD        END DO
CD     END DO
C
      DO K=2,NEXP
CD        L = 0
CD        DO J=1,NPSF
CD           DO I=1,NPSF
CD              IF (.NOT. IN(I,J)) THEN
CD                 L = L+1
CD                 CORNER(L) = PSF(K,I,J)
CD              END IF
CD           END DO
CD        END DO
CD        WRITE (6,*) K, ' CORNER =', PCTILE(CORNER, L, (L+1)/2), L
C
         L = 0
         DO J=1,NPSF
            DO I=1,NPSF
               IF (EDGE(I,J)) THEN
                  L = L+1
                  CORNER(L) = PSF(K,I,J)
               END IF
            END DO
         END DO
         DX = PCTILE(CORNER, L, (L+1)/2)
CD        WRITE (6,*) K, L, '     DX =', DX, TERM(K)
         DY = TERM(K) * DX
C
CD        L = 0
         DO J=1,NPSF
            DO I=1,NPSF
               IF (IN(I,J)) THEN
                  PSF(K,I,J) = PSF(K,I,J) - DX
                  PSF(1,I,J) = PSF(1,I,J) + DY
CD              ELSE
CD                 PSF(K,I,J) = PSF(K,I,J) - DX
CD                 PSF(1,I,J) = PSF(1,I,J) + DY
CD                 L = L+1
CD                 CORNER(L) = PSF(K,I,J)
               END IF
            END DO
         END DO
CD        WRITE (6,*) K, ' CORNER =', PCTILE(CORNER, L, (L+1)/2), L
CD        L = 0
CD        DO J=1,NPSF
CD           DO I=1,NPSF
CD              IF (EDGE(I,J)) THEN
CD                 L = L+1
CD                 CORNER(L) = PSF(K,I,J)
CD              END IF
CD           END DO
CD        END DO
CD        WRITE (6,*) K, '   EDGE =', PCTILE(CORNER, L, (L+1)/2), L
CD        WRITE (6,*)
      END DO
C
CD     DO K=1,NEXP
CD        L = MOD(K-1,6)
CD        L = L*NPSF + L
CD        LY = (K-1)/6 + ((NEXP-1)/6 + 1)
CD        LY = LY*NPSF + LY
CD        MX = 1
CD        MY = 1
CD        DO J=1,NPSF
CD           LY = LY + 1
CD           DO I=1,NPSF
CD              LX = L + I
CD              CALL WRARAY ('COPY', LX, LY, MX, MY, MAXPSF,
CD    .              PSF(K,I,J), ISTAT)
CD           END DO
CD        END DO
CD     END DO
C
C Now for each of the higher PSF's, determine the mean volume inside
C the PSF RADIUS.  Scale the constant part of the PSF as needed and
C subtract from the variable part and add back in to the constant part.
C
C Tabulate the constant part of the PSF and compute its net volume.
C
      DO J=1,NPSF
         DY = REAL(J-MIDDLE)/2.
         DO I=1,NPSF
            IF (IN(I,J)) THEN
               DX = REAL(I-MIDDLE)/2.
               CON(I,J) = SCALE *
     .              PROFIL(IPSTYP, DX, DY, PAR, DFDX, DFDY, V, 0)
C    .              + PSF(1,I,J)
            END IF
         END DO
      END DO
C
C Ensure that that profile which will be added to or subtracted from
C the various subtables has a median value of zero around its rim.
C
      L = 0
      DO J=1,NPSF
         DO I=1,NPSF
            IF (EDGE(I,J)) THEN
               L = L+1
               CORNER(L) = CON(I,J)
            END IF
         END DO
      END DO
      DX = PCTILE(CORNER, L, (L+1)/2)
CD     WRITE (6,*) 1, L, '     DX =', DX
C
      VOL = 0.0D0
      DO J=1,NPSF
         DO I=1,NPSF
            IF (IN(I,J)) THEN
               CON(I,J) = CON(I,J) - DX
               VOL = VOL + DBLE(CON(I,J))
            END IF
         END DO
      END DO
CD     LY = 3*((NEXP-1)/6+1)
CD     LY = LY*NPSF + LY
CD     MX = 1
CD     MY = 1
CD     DO J=1,NPSF
CD        LY = LY + 1
CD        DO I=1,NPSF
CD           LX = I
CD           CALL WRARAY ('COPY', LX, LY, MX, MY, MAXPSF,
CD    .              CON(I,J), ISTAT)
CD        END DO
CD     END DO
C
CD     WRITE (6,*) 'VOL =', SNGL(VOL)
C
C Now determine the net volume of each of the higher-order PSF
C tables, and force it to zero by subtracting a scaled copy of
C the constant PSF.  Scale the part that has been subtracted off
C by the mean polynomial term and add it in to the constant
C part of the PSF, so that at the centroid of the PSF stars'
C positions, the PSF remains unchanged.
C
      DO K=2,NEXP
         SUM = 0.0D0
         DO J=1,NPSF
            DO I=1,NPSF
               IF (IN(I,J)) SUM = SUM + DBLE(PSF(K,I,J))
            END DO
         END DO
C
CD        WRITE (6,*) K, '  SUM =', SUM
         DX = SNGL(SUM/VOL)
         DY = TERM(K)*DX
CD        SUM = 0.0D0
         DO J=1,NPSF
            DO I=1,NPSF
               IF (IN(I,J)) THEN
                  PSF(K,I,J) = PSF(K,I,J) - DX * CON(I,J)
                  PSF(1,I,J) = PSF(1,I,J) + DY * CON(I,J)
CD                 SUM = SUM + PSF(K,I,J)
               END IF
            END DO
         END DO
CD        WRITE (6,*) K, '  SUM =', SUM
CD        WRITE (6,*)
      END DO
C
CD     DO K=1,NEXP
CD        L = MOD(K-1,6)
CD        L = L*NPSF + L
CD        LY = (K-1)/6 + 2*((NEXP-1)/6+1)
CD        LY = LY*NPSF + LY
CD        MX = 1
CD        MY = 1
CD        DO J=1,NPSF
CD           LY = LY + 1
CD           DO I=1,NPSF
CD              LX = L + I
CD              CALL WRARAY ('COPY', LX, LY, MX, MY, MAXPSF,
CD    .              PSF(K,I,J), ISTAT)
CD           END DO
CD        END DO
CD     END DO
C
CD     CALL CLPIC ('COPY')
C
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C
 2800 CONTINUE
      DO K=1,NEXP
         WRITE (3,204) ((PSF(K,I,J), I=1,NPSF), J=1,NPSF)
  204    FORMAT (1X, 1P, 6E13.6)
      END DO
C
 2900 CALL CLFILE (3)
C
C Now generate the file of neighbors.
C
      MAGFIL = SWITCH(PSFFIL, CASE('.nei'))
      CALL TBLANK
      WRITE (6,*) 'File with PSF stars'' neighbors = ', MAGFIL
 2920 CALL OUTFIL (3, MAGFIL, ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error opening output file '//MAGFIL)
         MAGFIL = 'GIVE UP'
         CALL GETNAM ('Name for neighbor-star file:', MAGFIL)
         IF ((MAGFIL .EQ. 'END OF FILE') .OR.
     .        (MAGFIL .EQ. 'GIVE UP')) THEN
            MAGFIL = ' '
            RETURN
         ELSE
            MAGFIL = EXTEND(MAGFIL, CASE('nei'))
            GO TO 2920
         END IF
      END IF
C
C First, write out the PSF stars.
C
      CALL WRHEAD (3, 3, NCOL, NROW, 7, LOBAD, HIBAD, THRESH, AP1,
     .     PHPADU, READNS, RADIUS)
      DO I=1,NSTAR
         WRITE (3,280) ID(I), XCEN(I), YCEN(I), APMAG(I), SKY(I)
 280     FORMAT (1X, I5, 4F9.3)
      END DO
C
C Now look for all stars within a radius equal to
C 1.5*PSFRAD+2.*FITRAD+1 of any of the PSF stars.
C
      RSQ = (1.5*PSFRAD+2.*FITRAD+1.)**2
      L = NSTAR+1
C
C L will point at the first irrelevant star.
C
      DO I=1,NSTAR
         J = L
 5020    IF ((XCEN(J)-XCEN(I))**2 + (YCEN(J)-YCEN(I))**2 .LE. RSQ) THEN
            CALL SWAPP (ID, XCEN, YCEN, APMAG, SKY, J, L)
            WRITE (3,280) ID(L), XCEN(L), YCEN(L), APMAG(L), SKY(L)
            L = L+1
         END IF
         IF (J .LT. NTOT) THEN
            J = J+1
            GO TO 5020
         END IF
      END DO
C
C Now all stars in the stack between positions NSTAR+1 and L-1,
C inclusive, lie within the specified radius of the PSF stars and have
C been written out.  Finally, look for any stars within a radius
C equal to 2*FITRAD+1 of any of THESE stars, and of each other.
C
      RSQ = (2.*FITRAD+1)**2
      I = NSTAR+1
 5110 J = L
 5120 IF ((XCEN(J)-XCEN(I))**2 + (YCEN(J)-YCEN(I))**2 .LE. RSQ) THEN
         CALL SWAPP (ID, XCEN, YCEN, APMAG, SKY, J, L)
         WRITE (3,280) ID(L), XCEN(L), YCEN(L), APMAG(L), SKY(L)
         L = L+1
      END IF
      IF (J .LT. NTOT) THEN
         J = J+1
         GO TO 5120
      END IF
C
      I = I+1
      IF (I .LT. L) GO TO 5110
      CALL CLFILE (3)
      RETURN
      END!
C
C#######################################################################
C
      SUBROUTINE  FITANA  (PIC, NCOL, NROW, H, XCEN, YCEN, SKY, NSTAR,
     .     LOBAD, HIBAD, FITRAD, WATCH, IPSTYP, PAR, NPAR, CHI)
C
C This subroutine fits the ANALYTIC profile to the selected stars.
C
C  OFFICIAL DAO VERSION:    1991 May 10
C
      IMPLICIT NONE
      INTEGER MAXPAR, MAXBOX, MAXN, NCOL, NROW
      PARAMETER  (MAXPAR=6, MAXBOX=69, MAXN=200)
      CHARACTER*80 LINE
      REAL PIC(NCOL,NROW)
      REAL H(*), XCEN(*), YCEN(*), SKY(*), CLAMP(MAXPAR), OLD(MAXPAR)
      REAL C(MAXPAR,MAXPAR), V(MAXPAR), PAR(MAXPAR), T(MAXPAR),
     .     Z(MAXPAR)
      REAL XCLAMP(MAXN), YCLAMP(MAXN), XOLD(MAXN), YOLD(MAXN)
      REAL ABS, PROFIL, SQRT
C
      REAL DHN, DHD, DXN, DXD, DYN, DYD, DX, DY, DYSQ
      REAL LOBAD, PEAK, DP, PROD, DHDXC, DHDYC, P, WT
      REAL RSQ, SUMWT, OLDCHI, CHI, WATCH, FITRAD, HIBAD
      INTEGER I, J, K, L, LX, LY, MX, MY, ISTAT
      INTEGER ISTAR, MPAR, NITER, NPAR, IPSTYP, NSTAR
      LOGICAL FULL
C
C-----------------------------------------------------------------------
C
      FULL = .FALSE.
      DO I=1,NPAR
         Z(I) = 0.
         OLD(I) = 0.
         CLAMP(I) = 0.5
      END DO
      CLAMP(1) = 2.
      CLAMP(2) = 2.
      NITER = 0
      OLDCHI = 0.
      DO I=1,NSTAR
         XOLD(I) = 0.
         YOLD(I) = 0.
         XCLAMP(I) = 1.
         YCLAMP(I) = 1.
      END DO
C
      MPAR = 2
C
C-----------------------------------------------------------------------
C
C SECTION 1
C
C Now we will fit an integrated analytic function to the central part
C of the stellar profile.  For each star we will solve for three
C parameters: (1) H, the central height of the model profile (above
C sky); (2) XCEN, C the centroid of the star in x; and (3) YCEN,
C likewise for y.  In addition, from ALL STARS CONSIDERED TOGETHER
C we will determine any other parameters, PAR(i), required to describe
C the profile.  We will use a circle of radius FITRAD centered on the
C position of each PSF star. NOTE THAT we do not fit the data to an
C actual analytic profile, but rather the function is numerically
C integrated over the area of each pixel, and the observed data are fit
C to these integrals.
C
 1000 NITER = NITER+1
      IF (NITER .GT. 300) THEN
         CALL STUPID ('Failed to converge.')
         PAR(1) = -1.
         RETURN
      END IF
C
C Initialize the big accumulators.
C
      DO I=1,NPAR
         V(I)=0.0                        ! Zero the vector of residuals
         DO J=1,NPAR
            C(J,I)=0.0                   ! Zero the normal matrix
         END DO
      END DO
      CHI = 0.0
      SUMWT = 0.0
C
C Using the analytic model PSF defined by the current set of parameters,
C compute corrections to the brightnesses and centroids of all the PSF
C stars.  MEANWHILE, accumulate the corrections to the model parameters.
C
      RSQ = FITRAD**2
      DO 1400 ISTAR=1,NSTAR
      LX = INT(XCEN(ISTAR)-FITRAD) + 1
      LY = INT(YCEN(ISTAR)-FITRAD) + 1
      MX = INT(XCEN(ISTAR)+FITRAD)
      MY = INT(YCEN(ISTAR)+FITRAD)
C
      DHN = 0.0D0
      DHD = 0.0D0
      DXN = 0.0D0
      DXD = 0.0D0
      DYN = 0.0D0
      DYD = 0.0D0
      DO J=LY,MY
         DY = REAL(J) - YCEN(ISTAR)
         DYSQ = DY**2
         DO I=LX,MX
            DX = REAL(I) - XCEN(ISTAR)
            WT = (DX**2+DYSQ)/RSQ
            IF (WT .LT. 1.) THEN
               P = PROFIL(IPSTYP, DX, DY, PAR, DHDXC, DHDYC, T, 0)
               DP = PIC(I,J) - H(ISTAR)*P - SKY(ISTAR)
               DHDXC = H(ISTAR)*DHDXC
               DHDYC = H(ISTAR)*DHDYC
C              WT = 1. - WT**2            ! Weight as function of radius
               WT = 5./(5.+WT/(1.-WT))
               PROD = WT*P
               DHN = DHN + PROD*DP
               DHD = DHD + PROD*P
               PROD = WT*DHDXC
               DXN = DXN + PROD*DP
               DXD = DXD + PROD*DHDXC
               PROD = WT*DHDYC
               DYN = DYN + PROD*DP
               DYD = DYD + PROD*DHDYC
            END IF
         END DO
      END DO
C
      H(ISTAR) = H(ISTAR) + DHN/DHD
C
      DXN = DXN/DXD
      IF (XOLD(ISTAR)*DXN .LT. 0.) XCLAMP(ISTAR) = 0.5*XCLAMP(ISTAR)
      XOLD(ISTAR) = DXN
      XCEN(ISTAR) = XCEN(ISTAR)+DXN/(1.+ABS(DXN)/XCLAMP(ISTAR))
C
      DYN = DYN/DYD
      IF (YOLD(ISTAR)*DYN .LT. 0.) YCLAMP(ISTAR) = 0.5*YCLAMP(ISTAR)
      YOLD(ISTAR) = DYN
      YCEN(ISTAR) = YCEN(ISTAR)+DYN/(1.+ABS(DYN)/YCLAMP(ISTAR))
C
      PEAK = H(ISTAR) * PROFIL(IPSTYP,0.,0., PAR, DHDXC, DHDYC, T, 0)
      DO J=LY,MY
         DY = REAL(J)-YCEN(ISTAR)
         DYSQ = DY**2
         DO I=LX,MX
            DX = REAL(I)-XCEN(ISTAR)
            WT = (DX**2+DYSQ)/RSQ
            IF (WT .LT. 1.) THEN
               P = PROFIL(IPSTYP, DX, DY, PAR, DHDXC, DHDYC, T, 1)
               DP = PIC(I,J) - H(ISTAR)*P - SKY(ISTAR)
               DO K=1,MPAR
                  T(K) = H(ISTAR)*T(K)
               END DO
               CHI = CHI + (DP/PEAK)**2
               SUMWT = SUMWT + 1.
C              WT = 1. - WT**2            ! Weight as function of radius
               WT = 5./(5.+WT/(1.-WT))
               DO K=1,MPAR
                  V(K) = V(K) + WT*DP*T(K)
                  DO L=1,MPAR
                     C(L,K) = C(L,K) + WT*T(L)*T(K)
                  END DO
               END DO
            END IF
         END DO
      END DO
 1400 CONTINUE
C
C Correct the fitting parameters.
C
      CALL INVERS (C, MAXPAR, MPAR, ISTAT)
      CALL VMUL (C, MAXPAR, MPAR, V, Z)
      DO I=1,MPAR
         IF (Z(I)*OLD(I) .LT. 0.) THEN
            CLAMP(I) = 0.5*CLAMP(I)
         ELSE
            CLAMP(I) = 1.1*CLAMP(I)
         END IF
         OLD(I) = Z(I)
         Z(I) = CLAMP(I)*Z(I)
      END DO
      Z(1) = AMAX1(-0.1*PAR(1), AMIN1(0.1*PAR(1), Z(1)))
      Z(2) = AMAX1(-0.1*PAR(2), AMIN1(0.1*PAR(2), Z(2)))
      DO I=1,MPAR
         PAR(I) = PAR(I)+Z(I)
      END DO
C
      SUMWT = SUMWT - REAL(MPAR + 3*NSTAR)
      IF (SUMWT .GT. 0) THEN
         CHI = SQRT(CHI/SUMWT)
      ELSE
         CHI = 9.9999
      END IF
C
      WRITE (LINE,661) CHI, (PAR(I), I=1,MPAR)
  661 FORMAT (1X, F7.4, 6F10.5)
      I=10*MPAR+13
      IF (WATCH .GT. -1.5) CALL OVRWRT (LINE(1:I), 2)
      IF (MPAR .EQ. NPAR) THEN
         IF (ABS(OLDCHI/CHI-1.) .LT. 1.E-5) THEN
            CALL OVRWRT (LINE(1:I), 3)
            RETURN
         END IF
      ELSE
         IF (ABS(OLDCHI/CHI-1.) .LT. 1.E-3) THEN
            MPAR = MPAR+1
            OLDCHI = 0.
            GO TO 1000
         END IF
      END IF
C
      OLDCHI = CHI
      GO TO 1000
      END!
C
C#######################################################################
C
C Exchange two stars in the star list.
C
C   OFFICIAL DAO VERSION:       1991 May 10
C
      SUBROUTINE SWAPP (ID, X, Y, A, S, I, J)
      IMPLICIT NONE
      REAL X(*), Y(*), A(*), S(*)
      INTEGER ID(*)
C
      REAL HOLD
      INTEGER I, J, IHOLD
C
      IHOLD = ID(I)
      ID(I) = ID(J)
      ID(J) = IHOLD
      HOLD = X(I)
      X(I) = X(J)
      X(J) = HOLD
      HOLD = Y(I)
      Y(I) = Y(J)
      Y(J) = HOLD
      HOLD = A(I)
      A(I) = A(J)
      A(J) = HOLD
      HOLD = S(I)
      S(I) = S(J)
      S(J) = HOLD
      RETURN
      END!

C===========================================================================
C Copyright (C) 1995-2005 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================

C ++++++++++++++++++++++++  YF2CDSP.FOR +++++++++++++++++++++++++++++++++++++++
C .LANGUAGE Fortran 77
C .IDENTIFICATION Module YF2CDSP.FOR
C  AUTHOR         K. Banse
C .ENVIRONMENT    FORTRAN and C standards
C .VERSION  [1.00] 050728:  created 
C 
C 050803	last modif
C 
C -----------------------------------------------------------------------------
C
      SUBROUTINE BLDGRA(SHAPE,COORDS,ARCS,XFIG,YFIG,FIGMAX,NOP)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   SHAPE
      INTEGER     COORDS(*),XFIG(*),YFIG(*),FIGMAX,NOP
      REAL        ARCS(*)
C 
      CALL YDSP1(SHAPE,COORDS,XFIG,YFIG,0)
      CALL YDSP2(ARCS,FIGMAX,NOP)
C
      RETURN
      END

      SUBROUTINE CURSIN(DSPLAY,IACT,NOCURS,XYA,MCA,ISCA,XYB,MCB,ISCB)
C
      IMPLICIT NONE
C
      INTEGER     DSPLAY, IACT, NOCURS, XYA, MCA, ISCA, XYB, MCB, ISCB
C
      CALL YDSP1('dum',DSPLAY, IACT, NOCURS,0)
      CALL YDSP3(XYA, MCA, ISCA, XYB, MCB, ISCB)
C
      RETURN
      END

      SUBROUTINE GETCUR(ACTION,FRAME,ICUR1,FP1,WC1,VAL1,STAT1,
     +                         ICUR2,FP2,WC2,VAL2,STAT2)
C
      IMPLICIT NONE
C
      CHARACTER*(*) ACTION, FRAME
      INTEGER     ICUR1,STAT1,ICUR2,STAT2
      REAL        FP1(*), FP2(*), WC1(*), WC2(*), VAL1, VAL2
C
      CALL YDSP1(ACTION,ICUR1,STAT1,ICUR2,STAT2)
      CALL YDSP1a(FP1,WC1,VAL1,FP2,WC2,VAL2)
      CALL YDSP4(FRAME)
C
      RETURN
      END

      SUBROUTINE WRITT(DSPLAY,CHAN,NITT,ISTA,COUNT,RITT,IDST)
C
      IMPLICIT NONE
C
      INTEGER     DSPLAY,CHAN,NITT,ISTA,COUNT,IDST
      REAL        RITT(*)
C
      CALL YDSP1('dummy',DSPLAY,CHAN,NITT,ISTA)
      CALL YDSP5(COUNT,RITT,IDST)
C
      RETURN
      END

      SUBROUTINE RDITT(DSPLAY,CHAN,NITT,ISTA,COUNT,RITT,IDST)
C
      IMPLICIT NONE
C
      INTEGER     DSPLAY,CHAN,NITT,ISTA,COUNT,IDST
      REAL        RITT(*)
C
      CALL YDSP1('dummy',DSPLAY,CHAN,NITT,ISTA)
      CALL YDSP6(COUNT,RITT,IDST)
C
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2006 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C     This FORTRAN code is in the file named "ftoc_commf.for"
C     and checks our MADRID concept for allocating memory in Fortran
C
C.VERSION
C 060322		last modif
C 
C
      PROGRAM F2CCOM
C 
      INTEGER    MADRID(3)
      INTEGER    VALUE(3)
      INTEGER    STAT,MANY,NOPIX,NOBYT
      INTEGER*8    PNTR
C
      COMMON/VMR/MADRID
C
C  call a C-function which sets PNTR to an array start address
      MADRID(1) = -99
      CALL CSUB(PNTR)
C 
CC      write(*,1235) PNTR
CC1235  FORMAT('after CSUB, PNTR = ',I8)
C
      VALUE(1)=MADRID(PNTR)
      VALUE(2)=MADRID(PNTR+1)
      VALUE(3)=MADRID(PNTR+2)
C 
CC      write(*,2345) (madrid(n),n=-1,-9,-1)
CC2345  FORMAT('madrid(-1 -> -9) = ',9I6)
CC      write(*,2346) (value(n),n=1,3)
CC2346  FORMAT('value(1-3) = ',3I6)

      IF ((MADRID(PNTR).NE.10) .OR. (MADRID(PNTR+1).NE.50)
     +    .OR. (MADRID(PNTR+2).NE.70)) GOTO 1000
C 
C assume 4 bytes for real data
C and allocate space for 400 000 real values in  a C-function
C 
      NOBYT = 4                     
      NOPIX = 400000			!400 000 float values
      MANY = NOPIX*NOBYT
      CALL FMAP(MANY,PNTR,STAT)
C 
CC      write(*,4567) STAT,PNTR
CC4567  FORMAT('FMAP: STAT = ',I3,' PNTR = ',I20)
      IF (STAT.NE.0) GOTO 1010
C 
C now try to fill the allocated data with real values
C in a Fortran subroutine
C 
      CALL RTST(MADRID(PNTR),NOPIX,STAT)
      IF (STAT.NE.0) GOTO 1020
C 
      CALL FIN(0)
C 
C the following are all exits for failed code
C 
1000  CALL FIN(1)
C 
1010  CALL FIN(2)
C 
1020  CALL FIN(3)
C 
      STOP
      END

C @(#)cloudpsf.for	19.1 (ESO-DMD) 02/25/03 13:23:29
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
       PROGRAM PSF
C**************************************************
C       M.PIERRE 1-88                                
C                                                   
C       CALCULATION OF  A 1D_GAUSSIAN NORMALIZED   
C                   AND CENTERED AT 0              
C       Modified: START, STEP double precision i/o  
C 
C 990805
C**************************************************
C
       IMPLICIT NONE
C
       INTEGER MADRID(1),IMNO
       INTEGER NCARA,KUN,KNUL,IST,NPIX
       INTEGER*8  PNTR
C
       REAL START,FNORM
       REAL FWHM,STEP,DIM(3)
C
       DOUBLE PRECISION DSTA, DSTP
C
       CHARACTER NOMP*60,IDENT*72,CUNIT*80
C
       COMMON/VMR/MADRID
C
       CALL STSPRO('PSF')
C
       CALL STKRDC('IN_A',1,1,60,NCARA,NOMP,KUN,KNUL,IST)
       CALL STKRDR('INR',1,1,NCARA,FWHM,KUN,KNUL,IST)
       CALL STKRDR('CLDDIM',1,3,NCARA,DIM,KUN,KNUL,IST)
C
       STEP =DIM(2)
       START=-4.*FWHM
       NPIX =-2.*START/STEP
       FNORM=.9394373/FWHM*STEP
C
       IDENT='PSF '
       CUNIT = ' '
       DSTA = START
       DSTP = STEP
       CALL STIPUT(NOMP,10,1,1,1,NPIX,DSTA,DSTP,IDENT,
     :                   CUNIT,PNTR,IMNO,IST)       
       CALL IMAGE(MADRID(PNTR),NPIX,STEP,START,FWHM,FNORM)
       CALL STSEPI
       END
C
       SUBROUTINE IMAGE(Y,NPIX,STEP,START,FWHM,FNORM)
       INTEGER NPIX,I
       REAL  Y(1),START,STEP,FWHM,FNORM,WL
       DO 10 I=1,NPIX
         WL=START+FLOAT(I-1)*STEP
         Y(I)=FNORM*EXP(-0.69315*((2.*WL/FWHM)**2))
10     CONTINUE
       RETURN
       END
C

C @(#)tdmemory.for	19.1 (ESO-DMD) 02/25/03 14:11:18
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  19:55 - 11 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C.IDENTIFICATION        TDMEMORY.FOR
C.KEYWORDS           TABLE, APPLICATIONS
C.ENVIRONMENT  MIDAS
C.PURPOSE
C   Map and unmap virtual memory from FORTRAN.
C   It uses STFMAP temporarily.
C
C  010621               last modif
C
C------------------------------------------------------------------
C 
      SUBROUTINE TDMGET(SIZE,IPOINT,ISTAT)
C
C    get virtual memory (system dependent)
C
      IMPLICIT NONE
C
      INTEGER SIZE,ISTAT
      INTEGER PSIZE,IAC,IND,FID(16)
C
      INTEGER*8  IPOINT
      INTEGER*8  MADDR(16)
C 
      CHARACTER*8  NAME(16)
C 
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      COMMON/TVM1/ IND,FID
      COMMON/TVM2/ MADDR
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
      DATA   IND  /0/               !initial value
      DATA NAME/'VMDUMM01','VMDUMM02','VMDUMM03','VMDUMM04',
     -          'VMDUMM05','VMDUMM06','VMDUMM07','VMDUMM08',
     -          'VMDUMM09','VMDUMM10','VMDUMM11','VMDUMM12',
     -          'VMDUMM13','VMDUMM14','VMDUMM15','VMDUMM16'/
C
      IF (IND.LT.16) THEN
        IND = IND + 1
      ELSE
        IND = 1
      ENDIF
      PSIZE = SIZE/4
      CALL STFCRE(NAME(IND),D_R4_FORMAT,F_X_MODE,
     +            1,PSIZE,FID(IND),ISTAT)
      CALL STFMAP(FID(IND),F_X_MODE,1,PSIZE,IAC,IPOINT,ISTAT)
      MADDR(IND) = IPOINT
      RETURN
      END

      SUBROUTINE TDMFRE(SIZE,IPOINT,ISTAT)
C
C     free virtual memory
C 
      IMPLICIT NONE
C
      INTEGER SIZE,ISTAT
      INTEGER I,IND,FID(16)
C
      INTEGER*8  IPOINT
      INTEGER*8  MADDR(16)
C
      COMMON/TVM1/ IND,FID
      COMMON/TVM2/ MADDR
C
C 
      DO 10, I=1,16
         IF (IPOINT.EQ.MADDR(I)) GOTO 20
10    CONTINUE
      ISTAT  = 1
      RETURN
C 
20    CALL STFCLO(FID(I),ISTAT)
      MADDR(I) = -1
      RETURN
      END

C @(#)dcprin.for	19.1 (ES0-DMD) 02/25/03 13:17:29
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE DCPRIN(A,N,NDIM)                                               
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                   
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:25 - 13 JAN 1988                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C.IDENTIFICATION                                                                
C                                                                               
C  FITLIB.FOR   VERSION 1.0  27 MAR 1984                                        
C                                                                               
C.PURPOSE                                                                       
C                                                                               
C  INTERFACE ROUTINES FOR THE FITTING STRUCTURES                                
C                                                                               
C.ALGORITHM                                                                     
C                                                                               
C  USE MIDAS I/O INTERFACES TO FRAMES AND TABLES                                
C                                                                               
C.KEYWORDS                                                                      
C                                                                               
C  NON LINEAR FITTING                                                           
C                                                                               
C                                                                               
C----------------------------------------------------------------               
C                                                                               
C PRINT CORRELATION MATRIX                                                      
C      IMPLICIT NONE                                                            
C                                                                               
C INPUT PARAMS                                                                  
C A DBLE INPUT MATRIX (COVARIANCE)                                              
C N INTG NUMBER OF PARAMS                                                       
C NDIM INTG DIMENSION OF THE MATRIX                                             
C                                                                               
      INTEGER N,NDIM,K,ISTAT,I,J,II,IC(129)
      DOUBLE PRECISION A(NDIM,NDIM)                                             
      REAL C(129),B,D                                        
      CHARACTER*80 IGNR,TEXT*22
c      DATA ITEXT/1H-,1HI,1HH,1HG,1HF,1HE,1HD,1HC,1HB,1HA,1H0,1H1,1H2,           
c     +     1H3,1H4,1H5,1H6,1H7,1H8,1H9,1H+,1H//                                 
                                                                                
      TEXT(1:) = '-IHGFEDCBA0123456789+/'
      IF (N.LT.2) RETURN                                                        
      K      = 5                                                                
      IF (N.GT.76) GO TO 120                                                    
      IF (N.GT.10) K      = 1                                                   
      IF (N.GT.15) K      = 2                                                   
      IF (N.GT.25) K      = 3                                                   
      IF (N.GT.38) K      = 4                                                   
      CALL STTPUT(' Estimated correlations matrix ',ISTAT)                      
      CALL STTPUT(' _____________________________ ',ISTAT)                      
      CALL STTPUT(' ',ISTAT)                                                    
      DO 110 I = 2,N                                                            
          B      = SNGL(A(I,I))                                                 
          II     = I - 100* (I/100)                                             
          DO 10 J = 1,I - 1                                                     
              D      = SNGL(A(J,J))*B                                           
              IF (D.LE.0.0) THEN                                                
                  C(J)   = 0.0                                                  
                                                                                
              ELSE                                                              
                  C(J)   = SNGL(A(I,J))/SQRT(D)                                 
                  IF (ABS(C(J)).GT.1.0) GO TO 130                               
              END IF                                                            
                                                                                
   10     CONTINUE                                                              
          GO TO (20,30,50,70,90),K                                              
                                                                                
   20     WRITE (IGNR,9010) I, (C(J),J=1,I-1)                                   
          GO TO 100                                                             
                                                                                
   30     DO 40 J = 1,I - 1                                                     
              IC(J)  = INT(100.0*C(J))                                          
   40     CONTINUE                                                              
          WRITE (IGNR,9020) I, (IC(J),J=1,I-1)                                  
          GO TO 100                                                             
                                                                                
   50     DO 60 J = 1,I - 1                                                     
              IC(J)  = INT(10.0*C(J))                                           
   60     CONTINUE                                                              
          WRITE (IGNR,9030) I, (IC(J),J=1,I-1)                                  
          GO TO 100                                                             
                                                                                
   70     DO 80 J = 1,I - 1                                                     
              IF (C(J).GT.99999.9) C(J)   = 1.1                                 
              IC(J)  = INT(10.0* (1.0+C(J))) + 1                                
   80     CONTINUE                                                              
cc          WRITE (IGNR,9040) II, (ITEXT(IC(J)),J=1,I-1)                          
          WRITE(IGNR,9040)II,(TEXT(IC(J):IC(J)),J=1,I-1)
          GO TO 100                                                             
                                                                                
   90     WRITE (IGNR,9000) I, (C(J),J=1,I-1)                                   
  100     CALL STTPUT(IGNR,ISTAT)                                               
  110 CONTINUE                                                                  
      CALL STTPUT(' ',ISTAT)                                                    
      RETURN                                                                    
                                                                                
  120 CALL STTPUT(' ',ISTAT)                                                    
      CALL STTPUT('*** WARN-CORR : Correlation matrix is too '//                
     +            'big ***',ISTAT)                                              
      RETURN                                                                    
                                                                                
  130 CALL STTPUT(' ',ISTAT)                                                    
      CALL STTPUT('*** ERR-CORR : Error in correlation matrix ***',             
     +            ISTAT)                                                        
      WRITE (*,*) I,J                                                           
      RETURN                                                                    
                                                                                
 9000 FORMAT (1X,I2,' |',10F7.4)                                                
 9010 FORMAT (1X,I2,' |',15F5.2)                                                
 9020 FORMAT (1X,I2,' |',25I3)                                                  
 9030 FORMAT (1X,I2,1X,38I2)                                                    
 9040 FORMAT (1X,I2,1X,A)                                                    
      END                                                                       

C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENT:   subroutine CMPSUB          version 1.1          870315
C          A. Kruszewski              Obs. de Geneve
C          undersampled case          version 2.0          880826
C          A. Kruszewski              Warsaw U. Obs.
C.PURPOSE: Subtracts stellar components in a subframe copied from image frame.
C.INPUT/OUTPUT
C  Input parameters
C
C  A         real*4 array        input image array
C  JAPY      integer*4 array     pointers to imege lines
C  IBUF      integer*4           limits of image buffer
C  I         integer*4           x-coordinate of object
C  J         integer*4           y-coordinate of object
C  L0        integer*4           offset to catalog objects
C  L1        integer*4           last object in catalog
C  LW        integer*4           last object written to file
C  L         integer*4           identification number of object
C  M         integer*4           actuall number of objects
C  LSTP      integer*4 array     manage linked lists of pointers
C  NREG      integer*4           number of regional linked lists
C  LHED      integer*4           half edge size of subarray
C  TRSH      real*4              limiting threshold
C  APSF      real*4 array        one-dimensional point spread function
C  FPSF      real*4 array        two-dimensional point spread function
C  IPSF      integer*4 array     pointers to two-dimensional p.s.f.
C  LPXL      integer*4           number of 2-d pixels
C  LSBP      integer*4           number of subpixels
C  NCAT      integer*4 array     integer parameters array
C  PMTR      real*4 array        real parameters array
C  PRCT      real*4 array        catalog of one-dimensional profiles
C  NP        integer*4           dimension of catalog buffer
C  NPAS      integer*4           actuall iteration number
C  HCUT      real*4              saturation level
C  Output parameters
C  AS        real*4 array        data subarray after subtraction
C  JAPYS     integer*4 array     pointers to subarray lines
C  IBUFS     integer*4 array     limits of data in subarray
C----------------------------------------------------------------------
      SUBROUTINE CMPSUB (A, JAPY, IBUF, I, J, L0, L1, LW,
     &            L, M, NREG, LSTP, LHED, TRSH, APSF, FPSF,
     &            IPSF, LPXL, LSBP, NCAT, PMTR, PRCT, NPAS,
     &            AS, JAPYS, IBUFS, HCUT, MAS )
C
      IMPLICIT  NONE
      INCLUDE  'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER   NP , NREG
      INTEGER   JAPY(1) , IBUF(4), NCAT(NIPAR,MAXCNT)
      INTEGER   JAPYS(2*MAXSUB+1), IBUFS(4)
      INTEGER   LSTP(0:4, 0:NREG)
      INTEGER   NCT(NIPAR)
      INTEGER   MAS((-MAXSUB):MAXSUB,(-MAXSUB):MAXSUB)
      INTEGER   I, IPSF(1), J, L, L0, L1, LHED
      INTEGER   LPXL, LSBP, LW
      INTEGER   M
      INTEGER   NPAS
      INTEGER   MDIS
      INTEGER   MPXL
      INTEGER   MSBP
      INTEGER   IL1, IL2
      INTEGER   JL1, JL2
      INTEGER   MXS
      INTEGER   ITMP
      INTEGER   IS, IS1, IS2
      INTEGER   JOFF, JOFFS
      INTEGER   JOF, JOFS
      INTEGER   IL, IN
      INTEGER   K, KK, KK2
      INTEGER   LK, LN, LZ, LD
      INTEGER   JN, JL
      INTEGER   IDIF
      INTEGER   JDIF
      INTEGER   IOPC
      INTEGER   IINT
C
      REAL      AS((2*MAXSUB+1)**2)
      REAL      A(1), APSF(0:MAXSUB)
      REAL      CINT
      REAL      CINT1
      REAL      FPSF(1)
      REAL      HCUT
      REAL      PRCT( 0:MAXSUB, MAXCNT), PMTR(NRPAR,MAXCNT)
      REAL      PMT(NRPAR), PCT(0:MAXSUB)
      REAL      SCALE
      REAL      TRSH
C
C     LOGICAL   CENTER
      LOGICAL   UNDER
      LOGICAL   DONE
C
      IINT = 0
      NP = MAXCNT
      MDIS = MAXSUB + LHED
      IF ( LPXL .GT. 0 .OR. LSBP .GT. 0 ) THEN
            UNDER = .TRUE.
            MPXL = 2 * LPXL + 1
            MSBP = 2 * LSBP + 1
      ELSE
            UNDER = .FALSE.
      ENDIF
      LHED = MIN( MAXSUB , LHED )
      SCALE = 9.0 / ( 1.0 + 8.0*APSF(1) )
      CINT = 0.0
C
C ******      Prepare subarrays.
C
      IL1 = MAX( I-LHED , IBUF(1) )
      IL2 = MIN( I+LHED , IBUF(3) )
      JL1 = MAX( J-LHED , IBUF(2) )
      JL2 = MIN( J+LHED , IBUF(4) )
      IBUFS(1) = IL1 - I
      IBUFS(2) = JL1 - J
      IBUFS(3) = IL2 - I
      IBUFS(4) = JL2 - J
      MXS = 2*MAXSUB + 1
      IS1 = IBUFS(2)
      IS2 = IBUFS(4)
      DO 5 IS = IS1 , IS2
          ITMP = IS - IS1 + 1
          JAPYS(ITMP) = (ITMP-1) * MXS + MAXSUB + 1
    5 CONTINUE
      JOFF = IBUF(2) - 1
      JOFFS = IBUFS(2) - 1
      DO 10 JL = JL1 , JL2
          JOF = JAPY(JL-JOFF)
          JOFS = JAPYS(JL-J-JOFFS)
          DO 20 IL = IL1 , IL2
              AS(JOFS+IL-I) = A(JOF+IL)
   20     CONTINUE
   10 CONTINUE
C
C *** Start subtracting contributions from close components.
C
      K = 0
   31 CONTINUE
          CALL GETLST( L , L0 , L1 , MDIS , NREG ,
     &                 LSTP , NCAT , PMTR , PRCT , K ,
     &                 NCT , PMT , PCT , DONE )
          IF ( .NOT. DONE ) GOTO 30
C
C ***     Ignore the L-th object.
C
          IF ( K .EQ. L ) GOTO 32
C
C ***     Look for close neighbour.
C ***     Check first if K-th object is in buffer.
C
c            IF ( K .LE. L0 .OR. K .GT. L1 ) THEN
c                  READ( ISF , REC=K )  NCT , PMT , PCT
c            ELSE
          LK = K - L0
          DO 60 KK = 1 , NIPAR
              NCT(KK) = NCAT(KK,LK)
   60     CONTINUE
          DO 70 KK = 1 , NRPAR
              PMT(KK) = PMTR(KK,LK)
   70     CONTINUE
          KK2 = MIN( NCT(5) , MAXSUB )
          DO 80 KK = 0 , KK2
                PCT(KK) = PRCT(KK,LK)
   80     CONTINUE
c         ENDIF
          IF ( PMT(2) .LE. TRSH ) THEN
C
C ***         Too faint objects are not considered.
C
              GOTO 32
          ENDIF
          IN = NCT(1)
          JN = NCT(2)
          LN = NCT(5)
          IDIF = I-IN
          JDIF = J-JN
          LD = LN + LHED
          IF ( ABS(IDIF) .LE. LD .AND. ABS(JDIF) .LE. LD ) THEN
C
C ***         Found one!
C
              IOPC = -1
              CALL STARSA( IOPC , AS , JAPYS , IBUFS , I ,
     &                     J , LPXL , LSBP , NCT , PMT ,
     &                     PCT , APSF , FPSF , NPAS , SCALE ,
     &                     CINT1 )
              IF ( CINT1 .GT. CINT ) THEN
                  CINT = CINT1
                  IINT = K
              ENDIF
          ENDIF
   32     CONTINUE
          IF ( DONE ) GOTO 31
   30 CONTINUE
C
C *** Write down the number of the brightest stellar component
C *** if it contribute more than 10 % to the central pixel.
C
      LZ = L - L0
      IF ( CINT .GT. 0.1*PMTR(2,LZ) ) THEN
          NCAT(10,LZ) = IINT
      ELSE
          NCAT(10,LZ) = 0
      ENDIF
C
C *** Restore values of saturated points.
C
      DO 40 JL = JL1 , JL2
          JOFS = JAPYS(JL-J-JOFFS)
          DO 50 IL = IL1 ,IL2
              IF ( MAS(IL-I,JL-J) .EQ. -1 ) THEN
                  AS(JOFS+IL-I) = HCUT
              ENDIF
   50     CONTINUE
   40 CONTINUE
C
      RETURN
C
      END

C @(#)gd8aux.for	19.1 (ES0-DMD) 02/25/03 13:55:24
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
	SUBROUTINE KKCTAB(SHAPE,COLOUR,CURSAR,IDST)
C	
C	      =  2   - use table CROSSA.CUR (or CROSSC.CUR)
C	      =  3   - use table CROSSB.CUR (or CROSSD.CUR)
C	      =  4   - use table SQUARE.CUR  [not implemented yet...]
C	      =  5   - use table DIAMOND.CUR [not implemented yet...]
C	      =  6   - use table CIRCLE.CUR
C	      =  7   - use table ARROW.CUR
C	      =  8   - use table SMALL.CUR  (small xhair)
C	      =  0   - use table stored in keyword IN_A
C
	IMPLICIT NONE
C	
	INTEGER*4	SHAPE,COLOUR,IDST
	INTEGER*4	OLDSHAPE
	INTEGER*4	NCOLS,NROWS,N
	INTEGER*4	TABCOLNUM,TID
	INTEGER*4	E_C,E_D,E_L,LTAB
	INTEGER*4	KUNIT(1),NULLO
C	
	INTEGER*2	CURSAR(1)
C	
	CHARACTER	TABLEFILE*60,FILE*80
	CHARACTER	TABUNIT*16,MYLABEL*16
C	
	INTEGER*4	TABNULL
C 
	INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C 
	DATA	MYLABEL	  /'CURSOR '/
	DATA	OLDSHAPE  /-1/
C 
	INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C
	IDST = 0
C 
C  check, if we already loaded that last time ...
	IF ( (OLDSHAPE.EQ.SHAPE) .AND. (COLOUR.NE.99) ) RETURN
	OLDSHAPE = SHAPE
C
	IF (SHAPE.EQ.3) THEN
	   TABLEFILE(1:) = 'crossb.cur '
	   IF (COLOUR.EQ.1) TABLEFILE(6:6) = 'd'
C
	ELSE IF (SHAPE.EQ.4) THEN
	   TABLEFILE(1:) = 'square.cur '
C
	ELSE IF (SHAPE.EQ.5) THEN
	   TABLEFILE(1:) = 'diamond.cur '
C
	ELSE IF (SHAPE.EQ.6) THEN
	   TABLEFILE(1:) = 'circle.cur '
C
	ELSE IF (SHAPE.EQ.7) THEN
	   TABLEFILE(1:) = 'arrow.cur '
C
	ELSE IF (SHAPE.EQ.8) THEN
	   TABLEFILE(1:) = 'small.cur '
C
	ELSE IF (SHAPE.EQ.0) THEN
	   CALL STKRDC('IN_A',1,1,60,N,TABLEFILE,KUNIT,NULLO,IDST)
	   N = INDEX(TABLEFILE,' ')
	   TABLEFILE(N:) = '.cur '
C
	ELSE 						!default is cross
	   TABLEFILE(1:) = 'crossa.cur '
	   IF (COLOUR.EQ.1) TABLEFILE(6:6) = 'c'
	ENDIF
C	
C  first look for system table, then for own table
	FILE(1:) = 'MID_SYSTAB:'//TABLEFILE
	CALL STECNT('GET',E_C,E_L,E_D)
	CALL STECNT('PUT',1,0,0)
	CALL TBTOPN(FILE,F_I_MODE,TID,IDST)
	CALL STECNT('PUT',E_C,E_L,E_D)
	IF (IDST.NE.0) THEN
	   IDST = 0
	   FILE = TABLEFILE
	   CALL TBTOPN(FILE,F_I_MODE,TID,IDST)
	ENDIF
	IF (IDST.NE.0) THEN
	   IDST = 2
	   RETURN
	ENDIF
C	
C  get info about table
	CALL TBIGET(TID,NCOLS,NROWS,N,N,N,IDST)
	CALL TBLSER(TID,MYLABEL,TABCOLNUM,IDST)
	IF (TABCOLNUM.LE.0) THEN		!incorrect columns...
	   IDST = 1
	   RETURN
	ENDIF
C	
C  now read cursor table
	DO N=1,1024
	   CALL TBRRDI(TID,N,1,TABCOLNUM,CURSAR(N),TABNULL,IDST)
	ENDDO
C
C  release table file properly
	CALL TBTCLO(TID,IDST)
C
	RETURN
	END

	SUBROUTINE TRKBAL(UNIT)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine TRKBAL	version 1.00	861120
C  K. Banse		ESO - Garching
C
C.KEYWORDS
C  DeAnza unit, logical assignment
C
C.PURPOSE
C  init registers for use woth trackball
C
C.ALGORITHM
C  according to DeAnza manual
C
C.INPUT/OUTPUT
C  call as  TRKBAL(UNIT)
C
C  input par:
C  UNIT:	I*2		DeAnza unit no.
C				currently always 0
C
C--------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*2	UNIT,TBGO,TMASK,NUL(4)
	INTEGER*2	LPR
C
	EXTERNAL 	LPR
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
C
	DATA	TBGO	/'143'O/
	DATA	TMASK	/'103'O/
	DATA	NUL	/0,0,0,0/
C	
C  clear status reg. + X,Y position registers
	CALL IP8QW(LPR,UNIT,DZIOSB,,,NUL,8,0,0)	
C	
C  set tracking mode + GO flag (bit 5) in TKB control register (reg. 1)
	CALL IP8QW(LPR,UNIT,DZIOSB,,,TMASK,2,0,1)	!enable both cursors
	CALL IP8QW(LPR,UNIT,DZIOSB,,,TBGO,2,0,1)	!as above, but also set but 5 to 1
C	
	RETURN
	END

	SUBROUTINE BITS(IN,BIT)
C
C  the word array BIT(16) is set to 0 or 1
C  if the corresponding bit in word IN is set
C
	INTEGER*2	IN,BIT(16)
	INTEGER*2	MASK(16)
C
	DATA	MASK	/"1,"2,"4,"10,"20,"40,
     +                   "100,"200,"400,"1000,"2000,"4000,
     +                   "10000,"20000,"40000,"100000/
C
	DO N=1,16
	   IF (IAND(MASK(N),IN).NE.0) THEN
	      BIT(N) = 1
	   ELSE
	      BIT(N) = 0
	   ENDIF
	ENDDO
C
	RETURN
	END

	SUBROUTINE KKGRA(DISPLAY,CHAN,STRING,LSTR,XPOS,YPOS,PATH,
     +	                  ORIENT,INTENS,HT,IDST)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine KKGRA		version 1.00	880513
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  DeAnza, overlay channel, alphabet
C
C.PURPOSE
C  support text plotting in the graphics memory
C
C.ALGORITHM
C  characters are built in a 7*8 matrix (x:0-6, y:0-7)
C  use IIGPLY to plot the stuff in the overlay plane
C
C.INPUT/OUTPUT
C call as  KKGRA(DISPLAY,CHAN,STRING,LSTR,XPOS,YPOS,PATH,ORIENT,INTENS,HT,IDST)
C
C  input par:
C  DISPLAY:	I*4		unit no.
C  CHAN:	I*4		memory id
C  STRING:	char. expr.	character string to be displayed
C  LSTR:	I*4		length of above
C  XPOS:	I*4 		x-position
C  YPOS:	I*4 		y-position
C  PATH:	I*4		text path:
C  INTENS:	I*4		intensity
C  HT:		I*4		text height, currently not supported
C				characters are built in a 7*8 matrix
C                               or fixed in the alphanumerics memory
C	
C  output par:
C  IDST:	I*4		return status
C
C--------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,CHAN,LSTR,ORIENT
	INTEGER*4	INTENS,XPOS,YPOS,PATH,HT,IDST
	INTEGER*4 	N,NN,NNN,MM
	INTEGER*4	FCHARX(14),FCHARY(14)
	INTEGER*4	XXPOS,YYPOS,IX,IY
C	
	CHARACTER*(*)	STRING
C	
	REAL*4		ANGLE,CA,SA
C	
	INCLUDE 'MID_INCLUDE:DAZFONT.INC'
C
C	
	XXPOS = XPOS				!save start coords.
	YYPOS = YPOS
C	
C  currently text path is always taken as = 0, (runs from left to right)
C	
C  compare each character with our alphabet
	IF (ORIENT.EQ.0) THEN
	   DO N=1,LSTR
	      DO NN=1,LALP
	         IF (STRING(N:N).EQ.ALPHA(NN:NN)) THEN
	            IF (NN.GT.45) THEN
		       MM = NN - 45		!take care of lowercase chars.
	            ELSE
		       MM = NN
		    ENDIF
C
	            DO NNN=1,ALPLEN(MM)
		       FCHARX(NNN) = ALPFIG(1,NNN,MM) + XXPOS
		       FCHARY(NNN) = ALPFIG(2,NNN,MM) + YYPOS
		    ENDDO
		    CALL GD8021(DISPLAY,CHAN,FCHARX,FCHARY,
     +                          ALPLEN(MM),INTENS,1,IDST)
	         ENDIF
	      ENDDO
	      XXPOS = XXPOS + 9 			!move along the line ...
	   ENDDO	
C	
C  here with an angle
C
	ELSE
	   ANGLE = ORIENT
	   CA = COSD(ANGLE)
	   SA = SIND(ANGLE)
C	
C  compare each character with our alphabet
	   DO N=1,LSTR
	      DO NN=1,LALP
	         IF (STRING(N:N).EQ.ALPHA(NN:NN)) THEN
		    IF (NN.GT.45) THEN
		       MM = NN - 45			!take care of lowercase
		    ELSE
		       MM = NN
		    ENDIF
	            DO NNN=1,ALPLEN(MM)
		       IX = ALPFIG(1,NNN,MM) + XXPOS - XPOS
		       IY = ALPFIG(2,NNN,MM) + YYPOS - YPOS
		       CALL ROTA(CA,SA,IX,IY,IX,IY)
		       FCHARX(NNN) = IX + XPOS
		       FCHARY(NNN) = IY + YPOS
		    ENDDO
		    CALL GD8021(DISPLAY,CHAN,FCHARX,FCHARY,
     +                          ALPLEN(MM),INTENS,1,IDST)
	         ENDIF
	      ENDDO
	      XXPOS = XXPOS + 9 			!move along the line ...
 	   ENDDO	
	ENDIF
C	
C  that's it folks
	IDST = 0
	RETURN
	END

	SUBROUTINE KKALP(DISPLAY,STRING,LSTR,COL,LINE,MODE,IDST)
C	
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine KKALP		version 1.00	880120
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  DeAnza, alphanumerics board
C
C.PURPOSE
C  support IIGTXT for alphanumerics memory
C
C.ALGORITHM
C  use DeAnza level 0 software
C
C.INPUT/OUTPUT
C  call as  KKALP(DISPLAY,STRING,LSTR,COL,LINE,MODE,IDST)
C
C  input par:
C  DISPLAY:	I*4		display id.
C  STRING:	char.exp.	string to be displayed
C  LSTR:	I*4		length of STRING
C  COL:		I*4		column number (0 - 79)
C  LINE:	I*4		line number (0 - 24)
C  MODE:	I*4		mode: 0,1,2,3 for white, yellow, etc.
C
C  output par:
C  IDST:	I*4		return status
C	
C.VERSIONS
C--------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,LSTR,COL,LINE,MODE,IDST
	INTEGER*4	N,NN,MM
C	
	INTEGER*2	UNIT,BYTSTR(80),MODBITS,RES
	INTEGER*2	LAR,LPA,RR,LR
C
	CHARACTER*(*)	STRING
	CHARACTER	ALPHA*89
C	
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
C	
	EXTERNAL	LAR,LPA,RR,LR
C	
	DATA	ALPHA(1:26)	/'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
	DATA	ALPHA(27:57)	
     +		           /'[\]^_ !"#$%& ()*+,-./0123456789'/
	DATA	ALPHA(58:63)	/':;<=>?'/
	DATA	ALPHA(64:89)	/'abcdefghijklmnopqrstuvwxyz'/
C	
	UNIT = DISPLAY
	ALPHA(39:39) = ''''
	IDST = 0
C	
C  make sure we work on low resolution
	CALL IP8QW(RR,UNIT,DZIOSB,,,SYSREG(12),2,0,11)		!reg. 11
	RES = IAND(SYSREG(12),"177677)			!force to low byte xfer
	RES = IOR(RES,"100)				!force to low byte xfer
	CALL IP8QW(LR,UNIT,DZIOSB,,,RES,2,0,11)	
C	
C  load address register (reg. 0) of alphanumerics board
	N = (80 * LINE) + COL			!a line has 80 chars.
	CALL IP8QW(LAR,UNIT,DZIOSB,,,N,2,0,0)	!CAP = 0 for A/N board
C	
C  shift MODE already into correct bit position
	MODBITS = ISHFT(MODE,6)
C	
C  translate character string to A/N bytes
	IF (LSTR.LT.1) RETURN
C
	DO N=1,LSTR
	   BYTSTR(N) = 0
C 
	   DO NN=1,89
	      IF (STRING(N:N).EQ.ALPHA(NN:NN)) THEN
		 IF (NN.GT.63) THEN
		    MM = NN - 63
		 ELSE
		    MM = NN
		 ENDIF
     		 BYTSTR(N) = IOR(MM,MODBITS)
	      ENDIF
	   ENDDO
	ENDDO
C	
C  send bytes to A/N board
	CALL IP8QW(LPA,UNIT,DZIOSB,,,BYTSTR,2*LSTR,0,2)	!A/N is group 2
C	
C  reset resolution in reg. 11
	CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(12),2,0,11)		!reg. 11
C	
	RETURN
	END

	SUBROUTINE JOYPSH(UNIT,PUSH,ISS)
C	
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine JOYPSH		version 1.00	861121
C  	      TRKPSH			1.00	861121
C  					1.10	870513
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  DeAnza, joystick, trackball
C
C.PURPOSE
C  get status of joystick/trackball + cursor status
C
C.ALGORITHM
C  use DeAnza level-0 software
C
C.INPUT/OUTPUT
C  call as  JOYPSH(UNIT,PUSH,ISS)
C	    TRKPSH(UNIT,PUSH,ISS)
C
C  input par:
C  UNIT:	I*2		DeAnza unit
C
C  output par:
C  PUSH:	I*4		= 1 for ENTER button pushed
C				= 0 else
C
C  in/output par:
C  ISS:		I*4		cursor bit mask on input
C				cursor status: .NOT. 0   or   0
C	
C.VERSIONS
C  1.10		clear ENTER bit after the ENTER button has been pushed
C		and EVSTAT returned properly
c		for both JOYPSH + TRKPSH
C	
C--------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*2	UNIT,ENTER,CONTROL
	INTEGER*2	RPR,LPR
C	
	INTEGER*4	PUSH,ISS
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
C	
	EXTERNAL	RPR,LPR
C	
	DATA	ENTER	/"004000/
C	
C  read peripheral register
	CALL IP8QW(RPR,UNIT,DZIOSB,,,CONTROL,2,0,1)
C	
C  'AND' input mask with register
	ISS = IAND(CONTROL,ISS)		
C	
C  test, if something came in
     	IF (IAND(CONTROL,ENTER).NE.0) THEN
	   PUSH = 1
	   CALL IP8QW(LPR,UNIT,DZIOSB,,,1,2,0,1)	!clear control reg.
	ELSE
	   PUSH = 0
	ENDIF
C	
	RETURN
	END

	SUBROUTINE TRKPSH(UNIT,PUSH,ISS)
C	
	IMPLICIT NONE
C	
	INTEGER*2 	UNIT
	INTEGER*2	IPR,EPUSH,EOFF,ETRACK,TMODE
	INTEGER*2	RPR,LPR
C	
	INTEGER*4	PUSH,ISS,ISC1,ISC2
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
C
	EXTERNAL 	RPR,LPR
C
	DATA	EPUSH	/'0001'O/		!mask for ENTER button
	DATA	EOFF	/'7776'O/		!mask for complement of ENTER
	DATA	ETRACK	/'0010'O/		!mask for TRACK/ON switch
C
C  look at the TKB status register (reg. 0)
	CALL IP8QW(RPR,UNIT,DZIOSB,,,IPR,2,0,0)	!read peripheral register 0
C	
C  always extract cursor states
	IF (IAND('40'O,IPR).NE.0) THEN
	   ISC1 = 1					!bit B6 = cursor 1 on/off
	ELSE
	   ISC1 = 0
	ENDIF
	IF (IAND('20'O,IPR).NE.0) THEN			!bit B5 = cursor 2 on/off
	   ISC2 = 1
	ELSE
	   ISC2 = 0
	ENDIF
C	
C  if a cursor has been turned on/off, en/disable cursor tracking
	TMODE = ISC1 + 2*ISC2	
	CALL IP8QW(LPR,UNIT,DZIOSB,,,TMODE,2,0,1)	
	TMODE = TMODE + '40'O				!add the GO bit
	CALL IP8QW(LPR,UNIT,DZIOSB,,,TMODE,2,0,1)	
C	
C  check for push button or TRACK on
	IF ( (IAND(ETRACK,IPR).NE.0) .OR.
     +	     (IAND(EPUSH,IPR).NE.0) ) THEN
	   PUSH = 1
	   IPR = IAND(IPR,EOFF)				!clear the ENTER bit
	   CALL IP8QW(LPR,UNIT,DZIOSB,,,IPR,2,0,0)	!and rewrite the control reg.
	ELSE
	   PUSH = 0
	ENDIF
C	
C  set up return value for ISS
	IF (ISS.EQ.0) THEN
	   ISS = ISC1
	ELSE IF (ISS.EQ.1) THEN
	   ISS = ISC2
	ELSE
	   ISS = ISC1 + ISC2
	ENDIF
C
	RETURN
	END

	SUBROUTINE TRKRD(UNIT,IX,IY)
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine TRKRD		version 1.00	861121
C  K. Banse			ESO - Garching
C
C.KEYWORDS
C  DeAnza, trackball
C
C.PURPOSE
C  to read the trackball displacements
C
C.ALGORITHM
C  use the level-0 DeAnza routines
C
C.INPUT/OUTPUT
C
C  call as  TRKRD(UNIT,IX,IY)
C	
C  input par:
C  UNIT	:	I*2		DeAnza unit no.
C	
C  output par:
C  IX	:	I*4		X trackball displacement in [-128,+127]
C  IY	:	I*4		Y joystick trackball displacement in [-128,+127]
C
C----------------------------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*2	UNIT,TPOS(2),TMODE
	INTEGER*2 	IJR
	INTEGER*2	LPR,RPR
C	
	INTEGER*4	IX,IY
	INTEGER*4	IC1,IC2
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
C	
	EXTERNAL 	LPR,RPR
C
C  poll TKB status register (reg. 0)
	CALL IP8QW(RPR,UNIT,DZIOSB,,,IJR,2,0,0)		!read reg 0
C	
C  always extract cursor states
	IF (IAND('40'O,IJR).NE.0) THEN
	   IC1 = 1				!bit B6 = cursor 1 on/off
	ELSE
	   IC1 = 0
	ENDIF
	IF (IAND('20'O,IJR).NE.0) THEN			!bit B5 = cursor 2 on/off
	   IC2 = 1
	ELSE
	   IC2 = 0
	ENDIF
C	
C  if a cursor has been turned on/off, en/disable cursor tracking
	TMODE = IC1 + 2*IC2	
	CALL IP8QW(LPR,UNIT,DZIOSB,,,TMODE,2,0,1)	
	TMODE = TMODE + '40'O				!add the GO bit
	CALL IP8QW(LPR,UNIT,DZIOSB,,,TMODE,2,0,1)	
C	
C  get X,Y positions
	CALL IP8QW(RPR,UNIT,DZIOSB,,,TPOS,4,0,2)
C	
C  take care of decrements...
	IF (IAND('4000'O,TPOS(1)).NE.0)
     +	   TPOS(1) = IOR(TPOS(1),'170000'O)
	IF (IAND('4000'O,TPOS(2)).NE.0)
     +	   TPOS(2) = IOR(TPOS(2),'170000'O)
C	
C  multiply by factor of 3 since trackball is so slow
	TPOS(1) = 3 * TPOS(1)
	TPOS(2) = 3 * TPOS(2)
C	
	IF (TPOS(1).LT.-128) THEN			!force into [-128,127]
	   IX = -128
	ELSE IF (TPOS(1).GT.127) THEN
	   IX = 127
	ELSE
	   IX = TPOS(1)
	ENDIF
	IF (TPOS(2).LT.-128) THEN
	   IY = -128
	ELSE IF (TPOS(2).GT.127) THEN
	   IY = 127
	ELSE
	   IY = TPOS(2)
	ENDIF
C	
C  and clear position registers again
	TPOS(1) = 0
	TPOS(2) = 0
	CALL IP8QW(LPR,UNIT,DZIOSB,,,TPOS,4,0,2)
C	
	RETURN
	END

	SUBROUTINE KKOWLT(UNIT,ISTA,COUNT,ROVT,IDST)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine KKOWLT		version 1.00	880120
C  K. Banse			ESO - Garching
C
C.KEYWORDS
C  DeAnza display , overlay table
C
C.PURPOSE
C  to load an overlay into the DeAnza,
C
C.ALGORITHM
C  use DeAnza level 0 software
C
C.INPUT/OUTPUT
C  call as  KKOWLT(UNIT,ISTA,COUNT,ROVT,IDST)
C
C  input par:
C  UNIT:	I*2		unit no.
C  COUNT:	I*4		no. of entries in table to send/read
C	
C  input/output par:
C  ROVT:	R*4 array	OVT table
C  IDST:	I*4		return status
C
C-----------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4	ISTA,COUNT,IDST
	INTEGER*4	N
C	
	REAL*4		ROVT(1)
C	
	INTEGER*2 	UNIT,RESREG,OVT(1024)
	INTEGER*2	RR,LR,LWA,LVR
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
C	
	EXTERNAL	RR,LR,LWA,LVR
C	
C  set resolution register for low byte transfer
	CALL IP8QW(RR,UNIT,DZIOSB,,,SYSREG(12),2,0,11)
	RESREG = IOR(SYSREG(12),"100)
	CALL IP8QW(LR,UNIT,DZIOSB,,,RESREG,2,0,11)
C	
C  set OVT LUT section (always = 0...) in LUT address register
	VOCREG(4) = 0			!shift 9 bits left..
	CALL IP8QW(LVR,UNIT,DZIOSB,,,VOCREG(4),2,0,3)	
C
C  convert real OVT table to I*2 and send it to the DeAnza
C	
	DO N=1,COUNT
	   OVT(N) = NINT(ROVT(N)*255.)
	ENDDO
C	
	CALL IP8QW(LWA,UNIT,DZIOSB,,,OVT,COUNT*2,0,1)
C
C  reset the resolution register
	CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(12),2,0,11)
C
	RETURN
	END	


C @(#)fitell1.for	19.1 (ESO-DMD) 02/25/03 13:31:22
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondemce concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C.IDENTIFICATION: FITELL
C.PURPOSE:   Fit ellipses to a 2-dim image
C.LANGUAGE:  F77+ESOext
C.AUTHOR:    Andris Lauberts
C.KEYWORDS:  Ellipse fitting, display fit
C.ALGORITHM: Search for points selected on radius and intensity,
C            demand at least three points in 3x3 pixel region,
C            least square fit to the rectangular coords of these points,
C            retrieve ellips parameters, display points + fit
C.VERSION:   890717 AL   creation
C            890727 AL   revised
C            900315 MP   SX ---> ST
C 
C 010201		last modif
C 
C ---------------------------------------------------------------------
 
      PROGRAM FITELL1
C
      IMPLICIT  NONE
C
      INTEGER   MADRID,KUN,KNUL
      INTEGER   I,IAV
      INTEGER   M
      INTEGER   NAXIS
      INTEGER   NPIX(2)
      INTEGER   INO,ONO
      INTEGER   STAT
      INTEGER*8   PNTRA,PNTRB
C
      REAL      STEP(2),START(2)
      REAL      C(4)
      REAL      CENTER(2)
      REAL      RLIM
      REAL      XF(10000),YF(10000)
      REAL      ISOP(2),MISO,P,A,B,DEG,ERR
C
      DOUBLE PRECISION DSTART(2),DSTEP(2)
      CHARACTER IDENT*72,CUNIT*48,TEXT*80
      CHARACTER INFR*60,OUTFR*60
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON / VMR /MADRID(1)
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      DEG=180./3.1415926
C
C *** start code
C
      CALL STSPRO('FITELL1 ')                      ! set up Midas environment
C
C ** get keywords
C  
      CALL STKRDC('IN_A',1,1,60,IAV,INFR,KUN,KNUL,STAT) !  get inframe name
      CALL STKRDC('OUT_A',1,1,60,IAV,OUTFR,KUN,KNUL,STAT)!  get outframe name
      CALL STKRDR('INPUTR',4,2,IAV,ISOP,KUN,KNUL,STAT)     !  isophote bounds
      CALL STKRDR('INPUTR',1,2,IAV,CENTER,KUN,KNUL,STAT)   !  center coords
      CALL STKRDR('INPUTR',3,1,IAV,RLIM,KUN,KNUL,STAT)    !  limiting radius 
C
C *** get the images
C
C
      CALL STIGET(INFR,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,2,NAXIS,
     +     NPIX,DSTART,DSTEP,IDENT,CUNIT,PNTRA,INO,STAT)
C
      CALL STIGET(OUTFR,D_R4_FORMAT,F_U_MODE,F_IMA_TYPE,2,NAXIS,
     +     NPIX,DSTART,DSTEP,IDENT,CUNIT,PNTRB,ONO,STAT)
C
C *** Search for points within radius and isophotal window
C     For found M points retrieve only their rectangular 
C     coordinates in XF, YF arrays
C
      DO 100 I =1,2
         START(I) = SNGL(DSTART(I))
         STEP(I)  = SNGL(DSTEP(I))
100   CONTINUE
         CALL SELECT(MADRID(PNTRA),MADRID(PNTRB),
     +       	    NPIX,START,STEP,CENTER,XF,YF,ISOP,RLIM,M)
C
C *** Check on the actual number of points found
C
         IF (M.GT.10000) THEN
            CALL STTPUT('*** WARNING:  > 10000 Points found '//
     +                   ' results unreliable',STAT)
            CALL STTPUT('*** ADVICE:  make window smaller',STAT)
           GOTO 999
         END IF
         IF (M.LT.10) THEN
            CALL STTPUT('*** WARNING: < 10 points found '//
     +                   ' results unreliable',STAT)
            CALL STTPUT('*** ADVICE:  make window larger',STAT)
           GOTO 999
         END IF
C
C *** do least square fit; ellipse fit coefficients in array C
C
         CALL LSQ(XF,YF,M,C,ERR)
C
C *** solve for position angle P (0 on X-axis, increasing towards Y-axis)
C     and semi-diameters A, B.
C
        CALL SOLVE(C,P,A,B)
C
C *** mark found datapoints and ellipse in outframe
C
         MISO=(ISOP(1)+ISOP(2))/2.
         CALL DISPLAY(MADRID(PNTRB),NPIX,START,STEP,CENTER,P,A,B)
C
C *** Print table
C
      CALL STTPUT(' ',STAT)
      CALL STTPUT('*** Summary of the Results ***',STAT)
      CALL STTPUT(
     +  'Mean isoph   Semi-diameters      Posangle    #points  Error',
     +STAT)
      P=P*DEG
      WRITE (TEXT,9000) MISO,A,B,P,M,ERR
9000  FORMAT (G9.3,3F10.2,I8,F10.3)
      CALL STTPUT(TEXT,STAT)
      XF(1)=CENTER(1)
      XF(2)=CENTER(2)
      XF(3)=A
      XF(4)=B
      XF(5)=P
      CALL STDWRR(ONO,'ELLPAR',XF,1,5,KUN,STAT)
      CALL STFCLO(ONO,STAT)
C
999   CALL STSEPI
      END
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION: SELECT
C.AUTHOR:   A. Lauberts
C.PURPOSE:  Selects image pixels in range of intensities and limiting radius
C.INPUT     A       inframe image intensities                   
C           B       outframe image intensities                  output
C           NPIX    number of pixels/axis
C           START   start X, Y coords
C           STEP    step size in X, Y
C           CENTER  center X, Y
C           XF      X coord of found points relative to center  output
C           YF      Y coord of found points relative to center  output
C           ISOP    lower, upper isophotal levels                keyword
C           RLIM    maximum radius used for search              keyword
C           M       number of points found                      output
C---------------------------------------------------------------------
      SUBROUTINE SELECT(A,B,NPIX,START,STEP,CENTER,XF,YF,ISOP,
     + RLIM,M)
C
      IMPLICIT  NONE
      REAL      A(1)
      REAL      B(1)
      INTEGER   NPIX(2)
      REAL      START(2)
      REAL      STEP(2)
      REAL      CENTER(2)
      REAL      XF(1)
      REAL      YF(1)
      REAL      ISOP(2)
      REAL      RLIM
      INTEGER   M

      INTEGER   I, II
      INTEGER   N,STAT
      INTEGER   NPX1, NPX2
      INTEGER   J
      INTEGER   K
      INTEGER   L
      REAL      R2, RLM2
      REAL      STC1, STC2, STP1, STP2
      REAL      X
      REAL      Y, Y2
      REAL      AN,AM,BM
      REAL      LOLIM,UPLIM
      CHARACTER TEXT*80
C
 9000 FORMAT ('Isop limits=',F8.2,1X,F8.2,' Rad=',F8.2,
     + '  #Pnts=',I4)
C
      LOLIM = ISOP(1)
      UPLIM = ISOP(2)
C
C *** Search intensity array for filtered values,
C     simultaneously check radii limit,
C     if true put corresponding coords in XF and YF arrays.
C     Skip two first and two last scan lines.
C
C     Also mark found pixels in outframe by value 32000.
C
      NPX1 = NPIX(1)                          ! put before `N=NPX1*2' 
      NPX2 = NPIX(2)
      RLM2 = RLIM**2
      STC1 = START(1)-CENTER(1)
      STC2 = START(2)-CENTER(2)
      STP1 = STEP(1)
      STP2 = STEP(2)
      M = 0
      N = NPX1*2
      DO J = 3,NPX2-2
        Y = STC2+(J-1)*STP2
        Y2= Y**2
        DO I = 1,NPX1
           X = STC1+(I-1)*STP1
           R2= X**2+Y2
           N = N+1
           AN= A(N)
           IF (R2.LT.RLM2 .AND. AN.LT.UPLIM .AND. 
     +      AN.GT.LOLIM) THEN
            M      = M + 1
           IF(M.GT.10000) RETURN
            XF(M)  = X
            YF(M)  = Y
            B(N)  = 32000.
           END IF
        ENDDO
      ENDDO
      WRITE (TEXT,9000) ISOP(1),ISOP(2),RLIM,M
      CALL STTPUT(TEXT,STAT)
C
C  Go through the image again. 
C  This time demand that a 3x3 pixel region should contain 
C  at least 3 selected points, including the central point,
C  expected to join a well behaved contour line.
C
      L = 0
      M = 0
      N = NPX1*2
      DO J = 3,NPX2-2
       DO I = 1,NPX1
         N = N+1
         IF(B(N).EQ.32000.) THEN
           L = L+1
           K = 0
           DO II = N-1,N+1
             IF(B(II-NPX1).EQ.32000.) K = K+1
             IF(B(II     ).EQ.32000.) K = K+1
             IF(B(II+NPX1).EQ.32000.) K = K+1
           ENDDO
           IF(K.GT.2) THEN
             M = M+1
             XF(M) = XF(L)
             YF(M) = YF(L)
           ELSE
             AM = A(N)
             BM = B(N)
             B(N) = A(N)
             BM = B(N)
           ENDIF
         ENDIF
       ENDDO
      ENDDO
      WRITE (TEXT,9000) ISOP(1),ISOP(2),RLIM,M
      CALL STTPUT(TEXT,STAT)
      END
C
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION: SOLVE
C.PURPOSE:        get position angle P and semi-diameters A, B 
C       	  for ellipse fit to an image isophote
C
C.AUTHOR:         A. Lauberts
C--------------------------------------------------------------------
       SUBROUTINE SOLVE(C,P,A,B)
C
       IMPLICIT NONE
       REAL	C(4)
       REAL     P
       REAL     A
       REAL     B
C
       REAL     SP2
       REAL     A2
       REAL     B2
       REAL     P2,C1,C2,C3,PI,PI2,PIH
C
       PI=3.1415926
       PIH=PI/2.
       PI2=PI*2.
C
C  Let ellipse equation in quadratic form be
C
C       C1*X*X+C2*X*Y+C3*Y*Y = 1
C
C  Let ellipse equation in normal form be
C
C       r*U*U + s*V*V = 1
C
C  with  1/r = A*A  and  1/s = B*B.
C
C  (U,V) and (X,Y) coordinate systems are transformed by relative rotation
C
C       U = X cos P + Y sin P
C       V =-X sin P + Y cos P
C
C  using this transformation and identifying the two ellipse equation forms
C  gives P, A, B expressed in C's:
C
       C1=C(1)
       C2=C(2)
       C3=C(3)
       IF(C1.NE.C3) THEN
         P2=C2/(C1-C3)
         P2=ATAN(P2)
         SP2=SIN(P2)
       ELSE
         P2=PIH
         SP2=1.
       ENDIF
       IF(SP2.NE.0.) THEN
           A2=C1+C3+C2/SP2
           B2=C1+C3-C2/SP2
           IF(A2.GT.0..AND.B2.GT.0.) THEN
       	A=SQRT(2./A2)
       	B=SQRT(2./B2)
       	IF(A.GT.B) THEN
       	  P=P2/2.
       	ELSE
       	  A2=A
       	  A=B
       	  B=A2
       	  P=P2/2.+PIH
       	ENDIF
       	IF(P.LT.0.) P=P+PI
       	IF(P.GT.PI) P=P-PI
            ELSE
       	WRITE(6,*) 'A2 or B2 < 0, A2,B2=',A2,B2
       	RETURN
           ENDIF
       ELSE
           WRITE(6,*) 'SP2 = 0'
           A2=C1+C3
           IF(A2.GT.0.) THEN
             A=SQRT(2./A2)
             B=A
             P=0.
           ELSE
             WRITE(6,*) 'A2 < 0, A2= ',A2
             RETURN
           ENDIF
       ENDIF
       END
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION: DISPLAY
C.PURPOSE:        Marks rectangular image coordinates and labels in
C                 outframe (original copy of inframe) consisting of:
C                 set of M points in rectangular coords given by XF and YF,
C                 ellips given by least square parameters P = posangle, 
C       	  A = semi-major diameter and B = semi-minor diameter
C.AUTHOR:         A. Lauberts
C.NOTE:       	  The isophotal points have already been marked in SELECT
C -------------------------------------------------------------------
      SUBROUTINE DISPLAY(DISP,NPIX,START,STEP,CENTER,P,A,B)
C
      IMPLICIT NONE
      REAL     DISP(1)
      INTEGER  NPIX(2)
      REAL     START(2)
      REAL     STEP(2)
      REAL     CENTER(2)
      REAL     P,A,B
C
      INTEGER  I, IX, IY, II
      REAL     DISP1(400)
      REAL     TH,XX,YY,X,Y,RAD,COSP,SINP
C
       RAD = 3.1415926/180.
       COSP=COS(P)
       SINP=SIN(P)
C  
C *** mark the ellips in one degree angular steps;
C     data of found points from previous step are lost if they coincide
C
      DO 30 I = 1,361
         TH     = (I-1)*RAD
         X      = A*COS(TH)
         Y      = B*SIN(TH)
         XX     = X*COSP-Y*SINP
         YY     = X*SINP+Y*COSP
         IX     = IFIX((XX+CENTER(1)-START(1))/STEP(1)+1.5)
         IY     = IFIX((YY+CENTER(2)-START(2))/STEP(2)+1.5)
         II     = (IY-1)*NPIX(1) + IX
         DISP1(I) = DISP(II)
         DISP(II) = 0.
   30 CONTINUE
      END
C
       SUBROUTINE LSQ(X,Y,M,C,E1)
C+++++++++
C  LSQ fit of ellipse equation with coeffs C
C  
C     C(1)*X*X + C(2)*X*Y + C(3)*Y*Y = 1
C
C  to max M points (X,Y)
C
C  2nd iteration with restricted set of points within smaller
C  error bounds
C-------------
       IMPLICIT  NONE
       REAL      X(1)
       REAL      Y(1)
       INTEGER   M
       REAL      C(4)
       REAL      E1
C
       INTEGER   N, N1
       INTEGER   J
       INTEGER   K
       INTEGER   L
       INTEGER   I
       REAL      E2
       DOUBLE PRECISION  A(4,4),B(4),S(4)
C
       N=3
       N1=N+1
       DO I=1,N1
         DO J=1,N1
           A(I,J)=0.D0
         ENDDO
         S(I)=0.D0
         C(I)=0.
       ENDDO
       DO K=1,M
           B(1)=X(K)*X(K)
           B(2)=X(K)*Y(K)
           B(3)=Y(K)*Y(K)
           B(4)=1.
           DO I=1,N1
             DO J=1,N1
       	A(I,J)=A(I,J)+B(I)*B(J)
             ENDDO
           ENDDO
           S(1)=S(1)+B(1)
           S(2)=S(2)+B(2)
           S(3)=S(3)+B(3)
       ENDDO
       CALL SIMUL(N,A,C)
C  squared error E2 per point, 1st iteration
       S(4)=M
       E2 = 1.-(C(1)*S(1)+C(2)*S(2)+C(3)*S(3))/S(4)
       IF(E2.GE.0.) THEN
         E1 = SQRT(E2)
       ELSE
         E1=0.
         WRITE(6,*) '*** Negative error'
       ENDIF
       WRITE(6,*) 'Error, 1st iteration:',E1
C  2nd selection with E2 < 1st E2/2.
       E1 = E2/2.
       L=0
       DO K=1,M
         E2=(1.-C(1)*X(K)*X(K)-C(2)*X(K)*Y(K)-C(3)*Y(K)*Y(K))**2
         IF(E2.LT.E1) THEN
           L=L+1
           X(L)=X(K)
           Y(L)=Y(K)
         ENDIF
       ENDDO
C
       M=L
       IF(M.LT.10) RETURN
       DO I=1,N1
         DO J=1,N1
           A(I,J)=0.D0
         ENDDO
         S(I)=0.D0
         C(I)=0.
       ENDDO
       DO K=1,M
           B(1)=X(K)*X(K)
           B(2)=X(K)*Y(K)
           B(3)=Y(K)*Y(K)
           B(4)=1.
           DO I=1,N1
             DO J=1,N1
       	A(I,J)=A(I,J)+B(I)*B(J)
             ENDDO
           ENDDO
           S(1)=S(1)+B(1)
           S(2)=S(2)+B(2)
           S(3)=S(3)+B(3)
       ENDDO
       CALL SIMUL(N,A,C)
C  squared error E2 per point, second iteration
       S(4)=M
       E2 = 1.-(C(1)*S(1)+C(2)*S(2)+C(3)*S(3))/S(4)
       IF(E2.GE.0.) THEN
         E1=SQRT(E2)
       ELSE
         E1=0.
         WRITE(6,*) '*** Negative error'
       ENDIF
       WRITE(6,*) 'Error, 2nd iteration:',E1
       END

C  @(#)idfunc.for	19.1 (ESO-DMD) 02/25/03 14:00:27 
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM IDFUNC
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: K.Banse
C
C.IDENTIFICATION
C  program IDFUNC              		version 1.00	890628
C 981019
C
C.KEYWORDS
C  Image Display, split screen, overlay, alpha numeric generator
C  LUT tables, system status, cursor, distance
C
C
C.PURPOSE
C  a) en/disable the split screen mode, modify the VOC control register
C  b) write alphanumeric string to alphanumeric memory or 
C     overlay channel of ImageDisplay
C  c) create LUT tables for Image Display, using hue, saturation and intensity
C     store them optionally in a table file 
C  d) depending upon P1 display the general layout of the ImageDisplay
C     or the different internal registers
C  e) read the position of the two cursors on the display
C     and calculate the distance of relevant pixels in world coordinate space
C     Store xworlds, yworlds + distance in descriptor or table or not at all.
C
C
C.ALGORITHM
C  a) use the IDIs to do the "hardware" job
C  b) create my alphabet
C  d) get relevant keywords and display info in user friendly format
C     use IIDIAG to read the registers
C  e) use both cursors and read screen pixels, when the ENTER button is pressed
C     get real pixels and world coordinates and compute Euclidean distance
C
C.INPUT/OUTPUT
C  the following keys are used:
C
C  ACTION/C/1/2         action flag
C                  	= SS, set split screen info (a)
C                  	= CE, set the CE bit (a)
C                  	= CP, copy overlay graph + text to image channel
C                  	= IC, iconify display
C                  	= IK, iconify graphics window
C                  	= AE, enable the alpha numerics (a)
C                  	= GE, set the GE bit (a)
C                  	= AN, manage alphanumerics (b)
C                  	= HU, handle HIS model LUT (c)
C                  	= DI, compute distance between two points (e)
C                  	= ST, use GETSTR to get an input string from Midas
C			      command window while in a different 
C			      display window
C 
C  DAZHOLD/I/1/10       cursor no., cursor form,  (for all)
C                  	split screen mode + x,y- split addresses
C 
C  a) 
C  DAZIN/I/1/1          if ACTION = C, A or G, enable flag, 0 or 1
C
C  b)
C  P1/C/1/100		max. 100 characters to be displayed in one go
C			if only blanks => clear alpha memory
C  P3/C/1/1		mode = A      - use alphanumeric memory
C			     = O,Norm - use overlay channel
C  P5/C/1/1		text size  (0, 1, 2)
C 
C  c)
C  P1/C/1/60		name of table file 
C  DAZIN/I/1/2		section of LUT table 
C  INPUTR/R/1/9		start, end + number of levels 
C			for Intensity, Saturation and Hue
C
C  d)
C  MID$SESS/C/1/5            display type
C  P1/C/1/1                  G(eneral) or I(nternal)
C  P2/C/1/1                  flag for output to file
C 
C  e)
C  P1/C/1/15			optional descriptor name where world coordinates
C				+ distance should be stored
C				or table name, if data should go to a table
C				= ?, if data only to be displayed on terminal
C  P2/C/1/2			= A or ?, for appending values to descriptor 
C				          or not
C				= ID for using identifiers in tables
C				= NO[,start_no]  for automatic numbering 
C                                                in tables
C				start_no an optional starting number
C  P3/C/1/2			mark flag,
C				(1:1) = Y - put crosses on screen, else no
C				(2:2) = Y - draw also the connecting line in
C				            the overlay channel, else no
C
C  OUTPUTR/R/10/5		receives world coords + distance
C  OUTPUTI/I/1/1		receives total no. of coordinates obtained
C  CURSOR/I/1/4			(1) holds max. no. of coords reading on input
C				(1,,,4) will be filled with cursor pos. within
C				routine GETCURS ...
C 
C. VERSIONS
C  1.00            build up from te different individual programs
C see SCCS
C 
C 020502	last modif
C 
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      FLAG,IAV,N,M,SPLMOD,STAT
      INTEGER      SPLCX(4,5),SPLCY(4,5)
      INTEGER      DAZHLD(10),KK,SXO,SYO
      INTEGER      MEMIDS(4),XOFFS(4),YOFFS(4)
      INTEGER      SPLFLG,XSPLIT,YSPLIT
      INTEGER      ILIN,IPOS,IOFF,NBYTE,COOS(4)
      INTEGER      KIN(2),XY1(3),XY2(2),MEMO1,MEMO2
      INTEGER      KSECT,UNI(1),NULO,LUTSZ
      INTEGER      COOCNT,COOMAX,COOFF,FELEM
      INTEGER      IDFLAG,NCOLS,NCOLS1,NOREC
      INTEGER      NOFLAG,NOOFF,JM(40),SUBLO(3)
      INTEGER      TABFLG,ST1,ST2
      INTEGER      XYDUM(2),TCOLNM(7)
      INTEGER      XFIG(5),YFIG(5),XCROSS(5),YCROSS(5)
      INTEGER      TID,IMNO,LABCOL,TXTSIZ,INFLAG,FILESW
      INTEGER      MADRID(1)
C
      REAL         REA(5,10),RDX,RDY
      REAL         PCUR1(6),PCUR2(6),VAL
      REAL         RLUT(768),HSI(768),RQ(768)
      REAL         H,HEND,S,SEND,FI,FIEND,IVALU,HVALU,SVALU
      REAL         RBUF(10),RINCI,RINCH,RINCS,RD
C 
      DOUBLE PRECISION DD
C 
      CHARACTER    COMPAR(11)*2
      CHARACTER    ACTION*3,LINE*100,CBUF*220,COLO*3
      CHARACTER    DISPMO*1,KEYFLG*1
      CHARACTER    FRAME*80
      CHARACTER    HEADR1*80
      CHARACTER    INFO*24,DESCR*15
      CHARACTER    APPFLG*1,IDF*8,OLDIDF*8,LABL*8,DRAW*2
      CHARACTER    TABLE*80,TABUNI*16,TABLAB(7)*16
      CHARACTER    ERROR1*30,PROMPT*40,CACT*8
C
      INCLUDE  'MID_INCLUDE:ST_DEF.INC'
C
      INCLUDE  'MID_INCLUDE:IDIDEV.INC'
      INCLUDE  'MID_INCLUDE:IDIMEM.INC'
C 
      COMMON  /VMR/ MADRID
C
      EQUIVALENCE      (TABLE,DESCR)
C 
      INCLUDE  'MID_INCLUDE:ST_DAT.INC'
C
      DATA      COOS      /-1,-1,-1,-1/
      DATA      XOFFS     /4*0/,   YOFFS  /4*0/  
      DATA      ERROR1    /'No image loaded... '/
      DATA      INFO      /'switch cursor(s) on... '/
      DATA      IDF       /'ID '/,     OLDIDF   /' '/
      DATA      TCOLNM    /1,2,3,4,5,6,7/
      DATA      TABLAB    /'XSTART ','YSTART ',
     +                     'XEND ','YEND ','DISTANCE',
     +                     'NO ','IDENT '/
      DATA      REA       /50*0./
      DATA      DRAW      /'??'/
      DATA      XCROSS    /0,0,0,-4,5/,   YCROSS    /-4,4,0,0,0/
      DATA      PROMPT    /' enter identifier '/
      DATA      CACT      /'YYYY?C0 '/,   LABL      /' '/
      DATA      COMPAR 
     +      /'SS','CE','AE','GE','AN','HU','ST','DI','CP','IC','IK'/
C
C  get into MIDAS
      CALL STSPRO('IDFUNC')
      FILESW = 0
      NOREC = 0
C
C  get action flags
      CALL STKRDC('ACTION',1,1,3,IAV,ACTION,UNI,NULO,STAT)
      CALL UPCAS(ACTION,ACTION)
C 
      DO 120 N=1,11
         IF (ACTION(1:2).EQ.COMPAR(N)) THEN
            FLAG = N
            GOTO 200
         ENDIF
120   CONTINUE
      GOTO 90000
C
C  branch to desired action
200   IF (FLAG .NE. 11) CALL DTOPEN(1,STAT)
      CALL STKRDI('DAZHOLD',1,10,IAV,DAZHLD,UNI,NULO,STAT)
      GOTO (1000,2000,2000,2000,6000,7000,8800,9000,
     +      3000,3300,3300),FLAG  
C 

C 
C******************************
C 
C  here we handle the VOC related stuff
C 
C******************************
C 
C  get split screen mode + split addresses, if mode < 0
1000  SPLMOD = DAZHLD(3)
      MEMIDS(3) = QLSTCH + 1
      MEMIDS(4) = MEMIDS(3)
      SXO = 0
      SYO = QDSZY - 1
C
      IF (SPLMOD.EQ.1) THEN
         DO 1100 N=1,4
            MEMIDS(N) = N - 1
1100     CONTINUE
         SPLFLG = 0
         XSPLIT = (QDSZX - 1) / 2
         YSPLIT = (QDSZY - 1) / 2
C 
      ELSE IF (SPLMOD.EQ.2) THEN
         MEMIDS(1) = 1
         MEMIDS(2) = 0
         SPLFLG = 1
         XSPLIT = (QDSZX - 1) / 2
         YSPLIT = 0
C 
      ELSE IF (SPLMOD.EQ.3) THEN
         MEMIDS(1) = 2
         MEMIDS(2) = 3
         SPLFLG = 1
         XSPLIT = (QDSZX - 1) / 2
         YSPLIT = 2*QDSZY - 1
C 
      ELSE IF (SPLMOD.EQ.4) THEN
         MEMIDS(1) = 0
         MEMIDS(2) = 3
         SPLFLG = 2
         XSPLIT = 0
         YSPLIT = (QDSZY - 1) / 2
C 
      ELSE IF (SPLMOD.EQ.5) THEN
         MEMIDS(1) = 1
         MEMIDS(2) = 2
         SPLFLG = 2
         XSPLIT = 2*QDSZX - 1
         YSPLIT = (QDSZY - 1) / 2
      ENDIF
C
C  compute center values for split screen mode
      CALL SPLCNT(SPLCX,SPLCY)
C
C  clear alpha-numerics
      CALL IIMCMY(QDSPNO,QALPNO,1,0,STAT)
C
C *** clear split screen ***
C
      IF (SPLMOD.EQ.0) THEN           !set up VOC to show only one image
C
         SPLFLG = -1
         MEMIDS(1) = 0
         XSPLIT = 0
         YSPLIT = QDSZY - 1
C 
         DO 1300 M=1,QLSTCH+1            !loop through memory channels
            N = M - 1
            IF (N.NE.QOVCH) THEN
               CALL DTGICH(QDSPNO,N,LINE,RBUF,STAT)
               SCROLX = SXO
               SCROLY = SYO
               CALL DTPICH(QDSPNO,N,LINE,RBUF,STAT)
            ENDIF
1300     CONTINUE
C
         CALL IIDSSS(QDSPNO,MEMIDS,XOFFS,YOFFS,SPLFLG,
     +               XSPLIT,YSPLIT,STAT)    !do the hardware part...
         QIMCH = 0            	  
         CALL WALPHB(QIMCH,0)                !display alpha stuff for channel 0
C
C *** set split screen ***
C
      ELSE            			!set up VOC to show 4 channels
         CALL STETER(13,'Currently no support for split screen...')
      ENDIF
          GOTO 90000
C *****
C
C  enable/disable Cursor/ Graphics/ Alpha-memory
2000  CALL STKRDI('DAZIN',1,1,IAV,M,UNI,NULO,STAT)
C
C  en/disable cursor(s)
      IF (FLAG.EQ.1) THEN
         IF (DAZHLD(1).EQ.2) THEN
            CALL IICSCV(QDSPNO,1,M,STAT)            !we use two cursors
            CALL IICSCV(QDSPNO,2,M,STAT)
         ELSE IF (DAZHLD(1).EQ.1) THEN
            CALL IICSCV(QDSPNO,2,M,STAT)
         ELSE
            CALL IICSCV(QDSPNO,1,M,STAT)
         ENDIF
C
C  en/disable the alpha numerics board
      ELSE IF (FLAG.EQ.2) THEN
         CALL DAZVIS(QDSPNO,QALPNO,2,M)
C
C  en/disable graphics/overlay
      ELSE
         CALL DAZVIS(QDSPNO,QOVCH,2,M) 
      ENDIF
      GOTO 90000
C 
C *****
C
C  copy overlay -> image channel
C 
3000  CALL STKRDI('DAZIN',1,2,IAV,KIN,UNI,NULO,STAT)     !chanl_no, append_flag
      CALL IIGCPY(QDSPNO,KIN(1),KIN(2),STAT)
      GOTO 90000
C 
C  iconify/de-iconify display window
C 
3300  CALL STKRDI('DAZIN',1,1,IAV,M,UNI,NULO,STAT)      !1 or 0 (iconify_flag)
      IF (ACTION(2:2).EQ.'K') THEN
         CALL DTOPEN(2,STAT)                            !open graphics w.
         CALL IIDICO(GDSPNO,M,STAT)
         CALL DTCLOS(GDSPNO)                            !and close it
C refresh the overlay:      
CC         CALL REFOVR(STAT) 			!why did I do that??
         CALL STSEPI
      ELSE
         CALL IIDICO(QDSPNO,M,STAT)
         GOTO 90000
      ENDIF

C 
C******************************
C 
C  here we handle the alphanumerics stuff
C 
C******************************
C 
C  get characters + all other info
6000  IF (ACTION(3:3).EQ.'F') THEN                     !we have input from file
         CALL STKRDC('P1',1,1,80,IAV,FRAME,UNI,NULO,STAT)     !get file name
         N = INDEX(FRAME,' ') - 1
         IF (N.LT.1) N = 80
         OPEN(UNIT=33,FILE=FRAME(1:N),STATUS='OLD',ERR=6906)
         FILESW = 1                       !indicate, that we have file input
      ELSE
         GOTO 6060
      ENDIF
C
C  reading loop for file input
6030  DISPMO = 'O'                            !that's a capital `o'
      COLO(1:3) = 'WHI'
      TXTSIZ = 0
      KEYFLG = 'N'
C 
      CBUF(1:) = ' '
      READ(33,10100,END=6909) CBUF
      N = 1                                   !start for extraction
      LINE(1:) = ' ' 
      CALL EXTRSS(CBUF,' ',N,LINE,IAV)
      IF (IAV.LE.0) GOTO 6030                 !skip empty records
      FRAME(1:) = ' '
      CALL EXTRSS(CBUF,' ',N,FRAME,IAV)
      IF (IAV.LE.0) THEN
         FRAME = 'CURSOR '
         GOTO 6090
      ENDIF
      IF (FRAME(1:1).EQ.'?') FRAME = 'CURSOR '
      CALL EXTRSS(CBUF,' ',N,HEADR1,IAV)
      IF (IAV.LE.0) GOTO 6090                !end of record reached
      DISPMO = HEADR1(1:1)
      IF (DISPMO.EQ.'?') DISPMO = 'O '
      CALL EXTRSS(CBUF,' ',N,HEADR1,IAV)
      IF (IAV.LE.0) GOTO 6090                !end of record reached
      COLO(1:3) = HEADR1(1:3)
      IF (COLO(1:1).EQ.'?') COLO(1:3) = 'WHI'
      CALL EXTRSS(CBUF,' ',N,HEADR1,IAV)
      IF (IAV.LE.0) GOTO 6090                !end of record reached
      IF (HEADR1(1:1).NE.'?') THEN
         CALL GENCNV(HEADR1,1,1,TXTSIZ,RD,DD,N)
         IF (N.NE.1) CALL STETER(14,'Invalid label size...')
      ENDIF
      GOTO 6090                              !skip keyword reading
C 
6060  CALL STKRDC('P3',1,1,1,IAV,DISPMO,UNI,NULO,STAT)
      CALL STKRDC('P1',1,1,100,IAV,LINE,UNI,NULO,STAT)     !get text string
      IF (LINE(1:1).EQ.' ') THEN
         CALL TRUNCC(LINE,100,IOFF,NBYTE)
         IF ((NBYTE.LT.1) .AND. (DISPMO.EQ.'A')) THEN
            CALL IIMCMY(QDSPNO,QALPNO,1,0,STAT)
            GOTO 90000
         ENDIF
      ENDIF
      CALL STKRDC('P2',1,1,80,IAV,FRAME,UNI,NULO,STAT)  
      CALL STKRDC('P4',1,1,3,IAV,COLO,UNI,NULO,STAT)
      CALL STKRDC('P5',1,1,8,IAV,HEADR1,UNI,NULO,STAT)
      CALL GENCNV(HEADR1,1,1,TXTSIZ,RD,DD,N) 
      IF (N.NE.1) CALL STETER(14,'Invalid label size...')
      CALL STKRDC('P6',1,1,1,IAV,KEYFLG,UNI,NULO,STAT)       !get loop flag
C 
6090  INFLAG = 0
      COOCNT = 0
      CALL UPCAS(DISPMO,DISPMO)
      IF ((FRAME(1:1).EQ.'C').OR.(FRAME(1:1).EQ.'c')) THEN
         INFLAG = 1                                        !show cursor input
         GOTO 6360
      ENDIF
      KK = INDEX(FRAME,',F')
      IF (KK.LT.1) KK = INDEX(FRAME,',f')
      IF (KK.GT.0) THEN                           !we have frame pixels
         FRAME(KK:) = ' '            
         KK = INDEX(FRAME,',')                    !flip y,x coords for PIXXCV
         IF (INDEX(FRAME,'@').GT.0) THEN
            TABLE(1:) = FRAME(KK+1:)
            FRAME(KK:) = ' '
            KK = INDEX(TABLE,' ')
            TABLE(KK:) = ','//FRAME(1:)
         ELSE
            TABLE(1:) = '@'//FRAME(KK+1:)
            FRAME(KK:) = ' '
            KK = INDEX(TABLE,' ')
            TABLE(KK:) = ',@'//FRAME(1:)
         ENDIF
         CALL DTGICH(QDSPNO,QIMCH,FRAME,RBUF,STAT)
         IF (STAT.EQ.1) CALL STETER(3,'no image loaded...')
C
         CALL STFOPN(FRAME,D_OLD_FORMAT,0,F_IMA_TYPE,IMNO,STAT)
         CALL PIXXCV('INIT',IMNO,RBUF,STAT)
C
         CALL EXTCO1(IMNO,TABLE,2,N,SUBLO,STAT)
         IF (STAT.NE.0) CALL STETER
     +      (4,'Bad syntax in line,column specification...')
C 
         RBUF(1) = SUBLO(1)
         RBUF(2) = SUBLO(2)
         CALL PIXXCV('_RS',0,RBUF,STAT) 
         ILIN = NINT(RBUF(6))
         IPOS = NINT(RBUF(5))
         GOTO 6360
      ENDIF
C 
      IF ((KEYFLG(1:1).EQ.'K') .OR. (KEYFLG(1:1).EQ.'k')) THEN
         CALL STKRDC('P1',1,1,15,IAV,DESCR,UNI,NULO,STAT)    
         CALL STKRDC(DESCR,1,1,220,IAV,CBUF,UNI,NULO,STAT)  !key for strings
         IF (IAV.LT.220)
     +      CBUF(IAV+1:IAV+2) = '~~'              !make sure we have an end...
         CALL STKRDC('P2',1,1,15,IAV,DESCR,UNI,NULO,STAT)   !key for lengths
         CALL STKRDI(DESCR,1,40,IAV,JM,UNI,NULO,STAT)
         KK = INDEX(CBUF,'~')
         IF (KK.LE.1)
     +      CALL STETER(91,'Wrong string in key "P2"...')
         NOOFF = 1 + KK 
         LINE(1:) = CBUF(1:KK-1)//' '
         NOREC = 3
      ELSE
         DO 6100,N=1,80
            IF (FRAME(N:N).EQ.' ') THEN
               FRAME(N:N) = ','
               GOTO 6160
            ENDIF
6100     CONTINUE
6160     KK = INDEX(FRAME,'.')
         IF (KK.GT.0) THEN
            CALL GENCNV(FRAME,2,2,KK,RBUF,DD,N)
            JM(1) = NINT(RBUF(1)*(QDSZY-1))
            JM(2) = NINT(RBUF(2)*(QDSZX-1))
         ELSE
            CALL GENCNV(FRAME,1,2,JM,RD,DD,N)           !get integers...
         ENDIF
         IF (N.LT.2) 
     +      CALL STETER(7,'invalid start pixels for label')
         NOREC = 0
      ENDIF
      ILIN = JM(1)
      IPOS = JM(2)
C 
C get length of string
6360  CALL TRUNCC(LINE,100,IOFF,NBYTE)

C  
C  if NBYTE < 1, clear alphanumerics
      IF (NBYTE.LT.1) THEN
         IF (DISPMO.EQ.'A') THEN
            CALL IIMCMY(QDSPNO,QALPNO,1,0,STAT)
            GOTO 90000
         ELSE
            CALL STETER(1,'no. of bytes should be > 0 ...')
         ENDIF
      ENDIF
C 
      CALL TSCOLR(COLO,LABCOL)        !color string -> color no.
C
C  write character string to AN board or overlay channel + display it

      IF (INFLAG.NE.1) THEN                          !fixed position on screen
         IF (DISPMO.NE.'A') THEN                              !overlay plane
            CALL IIGTXT(QDSPNO,QOVCH,LINE(IOFF:IOFF+NBYTE-1), 
     +                  IPOS,ILIN,0,0,LABCOL,TXTSIZ,STAT)
         ELSE                                                 !alphanum. plane
            CALL ALPTXT(LINE(IOFF:IOFF+NBYTE-1),IPOS,ILIN,0)
         ENDIF
C 
         IF (NOREC.GT.1) THEN
            KK = INDEX(CBUF(NOOFF:),'~')
            IF (KK.EQ.1) GOTO 90000                    !~~ = that's the end
            IF (KK.LE.0)
     +         CALL STETER(91,'Wrong string in key "P2"...')
            M = NOOFF + KK - 2                        !avoid final ~
            LINE(1:) = CBUF(NOOFF:M)//' '
            NOOFF = NOOFF + KK 
            ILIN = JM(NOREC)
            IPOS = JM(NOREC+1)
            NOREC = NOREC + 2
            GOTO 6360                                 !get next label
         ENDIF
         GOTO 6900                                    !we're done
      ENDIF
C 
C  here we write into the alphanumerics/overlay plane via Cursor 
C  alpha-mem not possible for XWindow environment...
C 
      IF (DISPMO.EQ.'A') 
     +   CALL STETER(2,'Cursor input not possible for alpha memory...')
C 
C  for Cursor input we enable first cursor 0, shape = 0, colour = 0, + loop
      CALL SETCUR(QDSPNO,0,2,0,COOS,STAT) 
6500  CALL CURSIN(QDSPNO,0,0,XY1,MEMO1,STAT,XY2,MEMO2,STAT)   !bind interaction
C 
6600  CALL CURSIN(QDSPNO,1,0,XY1,MEMO1,IAV,XY2,MEMO2,STAT) 
      IF (IAV.EQ.0) THEN
         FRAME(1:) = 'Please, use ENTER not EXIT button ... '
         CALL STTDIS(FRAME,0,STAT)
         CALL IIISTI(QDSPNO,STAT)
         GOTO 6500
      ENDIF
      IPOS = XY1(1) + 1                                      !offset of 1 pixel
      ILIN = XY1(2) + 1
      IF (DISPMO.NE.'A') THEN                                !overlay plane
         CALL IIGTXT(QDSPNO,QOVCH,LINE(IOFF:IOFF+NBYTE-1),IPOS,ILIN,
     +               0,0,LABCOL,TXTSIZ,STAT)
      ELSE                                                   !alphanum. plane
         CALL ALPTXC(LINE(IOFF:IOFF+NBYTE-1),IPOS,ILIN,0)
      ENDIF
C 
      IF (COOCNT.EQ.0) THEN
         COOCNT = 1
         LINE(1:) = 'Keep cursor inside display window!!! '
         CALL STTDIS(LINE,0,STAT)
      ENDIF
      LINE(1:) = 'Type new string + RETURN (only RETURN to exit) '//
     +           '+ use Cursor again: '
      CALL STTDIS(LINE,0,STAT)
      IAV = 76
      CALL GETSTR(LINE,IAV)               !get character string
C 
      IF (IAV.GT.0) THEN
         CALL TRUNCC(LINE,IAV,IOFF,NBYTE)
         GOTO 6600
      ENDIF
C 
6900  IF (FILESW.EQ.1) THEN
         GOTO 6030
      ELSE
         GOTO 90000
      ENDIF
C
6906  CALL STTPUT('Problems opening ASCII file...',STAT)
      CALL STETER(1,CBUF)
C
6909  CLOSE(UNIT=33)
      GOTO 90000


C 
C******************************
C 
C  here we handle the HIS colour stuff
C 
C******************************
C 
C  get start values + steps + incrementers as well as table name
7000  LUTSZ = 256
      RD = LUTSZ - 1
      CALL STKRDR('INPUTR',1,10,IAV,RBUF,UNI,NULO,STAT)
      FI = RBUF(1) 
      IF (FI.LT.0.0) FI = 0.0
      IF (FI.GT.360.0) FI = 360.0
      FIEND = RBUF(2)
      IF (FIEND.LT.FI) FIEND = FI
      IF (FIEND.GT.1.0) FIEND = 1.0
      RINCI = RBUF(3)
      IF (RINCI.LT.0.0) RINCI = (FIEND-FI)/RD
C      
      S = RBUF(4)
      IF (S.LT.0.0) S = 0.0
      IF (S.GT.1.0) S = 1.0
      SEND = RBUF(5)
      IF (SEND.LT.S) SEND = S
      IF (SEND.GT.1.0) SEND = 1.0
      RINCS = RBUF(6)
      IF (RINCS.LT.0.0) RINCS = (SEND-S)/RD
C
      H = RBUF(7)
      IF (H.LT.0.0) H = 0.0
      IF (H.GT.1.0) H = 1.0
      HEND = RBUF(8)
      IF (HEND.LT.H) HEND = H
      IF (HEND.GT.360.0) HEND = 360.0
      RINCH = RBUF(9)
      IF (RINCH.LT.0.0) RINCH = (HEND-H)/RD
C      
      CALL STKRDC('P1',1,1,80,IAV,TABLE,UNI,NULO,STAT)
      KSECT = DAZHLD(10)
C      
C-------
C      
C  here the real processing takes place
C      
C-------
C      
C  now loop
      HVALU = H
      SVALU = S
      IVALU = FI
      IAV = 1
C 
      DO 7700, N=1,LUTSZ
         HSI(IAV) = HVALU
         HSI(IAV+1) = SVALU
         HSI(IAV+2) = IVALU
C      
         HVALU = H + (N*RINCH)
         SVALU = S + (N*RINCS)
         IVALU = FI + (N*RINCI)
         IF (RBUF(10).GT.0.) THEN            !continue cyclical
            IF (HVALU.GT.360.) HVALU = HVALU - 360.
            IF (SVALU.GT.1.0) SVALU = SVALU - 1.0
            IF (IVALU.GT.1.0) IVALU = IVALU - 1.0
         ELSE
            IF (HVALU.GT.360.) HVALU = 360.
            IF (SVALU.GT.1.0) SVALU = 1.0
            IF (IVALU.GT.1.0) IVALU = 1.0
         ENDIF
         IAV = IAV + 3
7700  CONTINUE
C
C  convert from HSI -> RGB and send the LUT table to Display
      CALL HSIRGB(2,HSI,RLUT)
      CALL MAKLUT(1,LUTSZ,RLUT,QLUTSZ,RQ)          !rearrange LUT
      CALL WRLUT(QDSPNO,KSECT,1,QLUTSZ,RQ,STAT)
C
C  finally store the tables in "real" Tablefile
      IF (TABLE(1:1).NE.'+') CALL BLDLUT(TABLE,RLUT,STAT)
      GOTO 90000
C
C 
C******************************
C 
C  here we get a string from the Midas command window
C 
C******************************
C
8800  LINE(1:) = ' '
      IAV = 76
      CALL GETSTR(LINE,IAV)                        !get character string
      CALL STKWRC('GETSTR',1,LINE,1,80,UNI,STAT)
      CALL STKWRI('AUX_MODE',IAV,7,1,UNI,STAT)
      GOTO 90000

C 
C******************************
C 
C  here we compute the distance between two cursor positions
C 
C******************************
C
C  zoom/scroll overlay as image channel
9000  CALL DAZZSC(QDSPNO,QOVCH,ZOOMX,SCROLX,SCROLY,STAT)
      HEADR1(1:30) =  'world coords (xs,ys) '
      HEADR1(26:60) = 'world coords (xe,ye) '
      HEADR1(50:80) = 'distance '
C
C  get descriptor or table name for storage of data
      CALL STKRDC('P3',1,1,2,IAV,DRAW,UNI,NULO,STAT)
      TABFLG = 0
      CALL STKRDC('P1',1,1,60,IAV,TABLE,UNI,NULO,STAT) 
      IF (TABLE(1:1).EQ.'+') GOTO 9200           !neither table nor descriptor
C      
      N = INDEX(TABLE,'/D')
      IF (N.LE.0) N = INDEX(TABLE,'/d')
      IF (N.LE.0) THEN
         TABFLG = 1
         CALL STKRDC('P2',1,1,12,IAV,LINE,UNI,NULO,STAT)      !get ident option
         HEADR1(62:) = 'identifier '
         NOFLAG = 0
         IDFLAG = 0
C      
         IF (LINE(1:2).EQ.'ID') THEN
            IDFLAG = 1
         ELSE IF (LINE(1:2).EQ.'NO') THEN
            NOFLAG = 1
            HEADR1(62:) = 'sequence no. '
            N = INDEX(LINE(1:12),',')                  !look for optional start no.
            IF (N.LE.0) THEN
               NOOFF = 0
            ELSE
               CALL GENCNV(LINE(N+1:12),1,1,NOOFF,RD,DD,N)
               IF (N.LE.0) NOOFF = 1
               NOOFF = NOOFF - 1
            ENDIF
         ENDIF
C      
         NCOLS = 6
         NCOLS1 = NCOLS - 1                        !no. of pure data columns
C      
C  create (NCOLS+10)*100 table to have already columns allocated for later use
C  (for speed reasons)
C 
         CALL TBTINI(TABLE,0,F_O_MODE,NCOLS+10,100,TID,STAT)      
         TABUNI = 'WORLD COORD '
         DO 9100 IAV=1,NCOLS1                  !and define the columns
            CALL TBCINI(TID,D_R4_FORMAT,1,'G12.6',TABUNI,
     +                  TABLAB(IAV),TCOLNM(IAV),STAT)
9100     CONTINUE
C      
C  handle label column
         CALL TBCINI(TID,D_C_FORMAT,8,'A8',TABUNI,
     +               TABLAB(NCOLS+1),TCOLNM(NCOLS+1),STAT)
C      
C  handle optional number column
         IF (NOFLAG.EQ.1)
     +      CALL TBCINI(TID,D_I4_FORMAT,1,'I8',TABUNI,
     +                  TABLAB(NCOLS),TCOLNM(NCOLS),STAT)
C      
C  check option for descriptor business
      ELSE
         DESCR(N:) = ' '                        !clear descriptor name
         CALL STKRDC('P2',1,1,1,IAV,APPFLG,UNI,NULO,STAT)
         IF (APPFLG.EQ.'A') THEN                !see, if data is to be appended
            FELEM = -1
         ELSE
            FELEM = 1
         ENDIF
      ENDIF
C
C  get max. coord readings
9200  CALL STKRDI('CURSOR',1,1,IAV,COOMAX,UNI,NULO,STAT)
C      
C  set up cursor #1 as open white cross
      CALL SETCUR(QDSPNO,0,3,2,COOS,STAT)
      CALL STTPUT(HEADR1,STAT)
      COOCNT = 0
      COOFF = 0
      NOREC = 1
      FRAME(1:) = ' '
C      
C  read cursor position(s)
9300  IF (COOCNT.GE.COOMAX) THEN
         GOTO 9900                              !limit reached...
      ELSE
         IF (IDFLAG.EQ.1) THEN                  !if we use id's,
            CALL STKPRC(PROMPT,'INPUTC',1,1,8,IAV,IDF,
     +                  UNI,NULO,STAT)               !get id + cursor value
            IF (IDF.EQ.' ') IDF = OLDIDF
            OLDIDF = IDF
         ELSE
            WRITE(IDF(3:),10010) COOCNT+1
         ENDIF
      ENDIF
C      
9400  CALL GETCUR
     +     (CACT,FRAME,XY1,PCUR1(1),PCUR1(3),VAL,ST1,
     +                 XYDUM,RBUF(1),RBUF(3),VAL,ST2)
      IF (ST1.EQ.0) THEN
         IF ((COOCNT.EQ.0).AND.(COOFF.EQ.0)) THEN
            FRAME(1:) = ' '                    !reinitialize for GETCUR
            COOFF = 1
            CALL STTDIS
     +      ('switch cursor on - next time we exit...',0,STAT)
            GOTO 9400
         ELSE
            GOTO 9900
         ENDIF
      ENDIF
C 
9440  CALL GETCUR
     +     (CACT,FRAME,XY2,PCUR2(1),PCUR2(3),VAL,ST1,
     +                 XYDUM,RBUF(1),RBUF(3),VAL,ST2)
      IF (ST1.EQ.0) THEN
         IF ((COOCNT.EQ.0).AND.(COOFF.EQ.0)) THEN
            FRAME(1:) = ' '                    !reinitialize for GETCUR
            COOFF = 1
            CALL STTDIS
     +      ('we need 2. cursor input - next time we exit...',0,STAT)
            GOTO 9440
         ELSE
            GOTO 9900
         ENDIF
      ENDIF
C
      COOCNT = COOCNT + 1            !update coordinate counter
      REA(1,NOREC) = PCUR1(3)
      REA(2,NOREC) = PCUR1(4)
      REA(3,NOREC) = PCUR2(3)
      REA(4,NOREC) = PCUR2(4)
C      
C now we compute the distance
      RDX = (REA(1,NOREC) - REA(3,NOREC))
      RDY = (REA(2,NOREC) - REA(4,NOREC))
      REA(5,NOREC) = SQRT( RDX*RDX + RDY*RDY )
C      
C  if desired, draw connecting line into overlay plane
      IF (DRAW(2:2).EQ.'Y') THEN
         XFIG(1) = XY1(1)
         YFIG(1) = XY1(2)
         XFIG(2) = XY2(1)
         YFIG(2) = XY2(2)
         CALL IIGPLY(QDSPNO,QOVCH,XFIG,YFIG,2,255,1,STAT)
      ENDIF
C      
C  display line with complete info
      WRITE(LINE,10001) (REA(N,NOREC),N=1,5),LABL
      CALL STTPUT(LINE,STAT)
C      
C  store info also in keyword LINER(10,...)
      CALL STKWRR('LINER',REA(1,NOREC),10,5,UNI,STAT)
C
C  fill table, if applicable
      IF (TABFLG.EQ.1) THEN
         CALL TBRWRR(TID,COOCNT,NCOLS1,TCOLNM,REA(1,NOREC),STAT)
C      
C  handle label column
         CALL TBEWRC(TID,COOCNT,TCOLNM(NCOLS+1),IDF,STAT)
C      
C  handle optional number column
         IF (NOFLAG.EQ.1) THEN
            N = COOCNT + NOOFF            !determine sequence no.
            WRITE(LABL,10006) N           !put it also into char. string LABL
            CALL TBRWRI(TID,COOCNT,1,TCOLNM(NCOLS),N,STAT)
         ELSE
            LABL = IDF                    !use the IDF
         ENDIF
C      
         GOTO 9300                        !branch to common section
      ENDIF
C      
C  fill descriptor, if applicable
      IF (DESCR(1:1).NE.'+') THEN
         CALL STFOPN(FRAME,D_OLD_FORMAT,0,F_IMA_TYPE,IMNO,STAT)
         IF (NOREC.EQ.10) THEN                        !buffer decriptor LINE...
            CALL STDWRR(IMNO,DESCR,REA,FELEM,50,UNI,STAT)    !fill descriptor
            FELEM = -1
            NOREC = 1
         ELSE
            NOREC = NOREC + 1
         ENDIF
      ENDIF
C      
      GOTO 9300                        !look for more
C
C  That's it folks...
9900  IF (TABFLG.EQ.1) THEN
         CALL TBSINI(TID,STAT)
         CALL TBTCLO(TID,STAT)
      ELSE
         IF ((DESCR(1:1).NE.'?').AND.(NOREC.GT.1)) THEN
            CALL STDWRR(IMNO,DESCR,REA,FELEM,5*(NOREC-1),UNI,STAT)
         ENDIF
      ENDIF
C      
C  save no. of coordinates obtained for subsequent applications
      CALL STKWRI('LINEI',COOCNT,1,1,UNI,STAT)
      GOTO 90000
C 

C
C  that's it folks...
90000 CALL DTCLOS(QDSPNO)
      IF (LABCOL.EQ.0) CALL REFOVR(STAT)     !refresh the overlay, if we delete
      CALL STSEPI
C
C  FORMATS
C 
10000 FORMAT(15X,' ----- image system snapshot -----'//
     +        8X,'Unit = ',A)
10001  FORMAT(2G12.6,1X,2G12.6,G12.6,1X,A)
10006  FORMAT(I4)
10010  FORMAT(I4.4)
10100  FORMAT(A)
C
      END

      SUBROUTINE TRUNCC(LINE,MAXLEN,IOFF,NBYTE)
C 
      IMPLICIT NONE
C      
      INTEGER      IOFF,NBYTE,MAXLEN
      INTEGER      N
C
      CHARACTER    LINE*(*)
C      
C  determine length of string
      NBYTE = 0                        !default to 1 character
C 
      IF (LINE(1:1).EQ.'"') THEN
         IOFF = 2
         DO 100 N=MAXLEN,IOFF,-1
            IF (LINE(N:N).EQ.'"') THEN
               NBYTE = N - 2
               GOTO 500
            ENDIF
100      CONTINUE
      ELSE
         IOFF = 1
         DO 200 N=MAXLEN,IOFF,-1
            IF (LINE(N:N).NE.' ') THEN
               NBYTE = N 
               GOTO 500
            ENDIF
200      CONTINUE
      ENDIF
C 
500   RETURN
      END

C @(#)creastar.for	19.1 (ES0-DMD) 02/25/03 13:19:04
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C.IDENTIFICATION: CRSTAR
C.LANGUAGE:  F77+ESOext
C.AUTHOR:    Rein H. Warmels
C.PURPOSE:   Create an image file pixels containing the profile
C            of the standard reference star, by adding and averaging
C            some selected  stars, after recentering
C.VERSION:   840524 ChO ???
C.VERSION:   931122 RHW rewritten 
C ---------------------------------------------------------------------
        PROGRAM CRSTAR
C
        IMPLICIT NONE
        REAL             PARAM(7)
        REAL             XYZ(3,1000)
        REAL             CUTS(4)
        REAL             DMIN, DMAX
C
        INTEGER          NAXIS
        INTEGER          NPIX1(2), NPIX(2), NPX
        INTEGER          ICOL(3)
        INTEGER          IAC, I, IZONE
        INTEGER          TID,IMF
        INTEGER*8        IP,IPOUT
        INTEGER          IMF1
        INTEGER          KUN,KNUL,ISTAT
        INTEGER          NCOL,NROW,NSC,NAC,NAR
        INTEGER          MADRID(1)
C
        DOUBLE PRECISION START(2), STEP(2)
        DOUBLE PRECISION START1(2), STEP1(2)
C
        CHARACTER*16     LABEL(3)
        CHARACTER*60     FRAMIN,TBIN,FRAMOUT
        CHARACTER        IDENT*72,CUNIT*64
C     
        LOGICAL          NULL(3)
C
        INCLUDE          'MID_INCLUDE:ST_DEF.INC/NOLIST'
        COMMON           /VMR/MADRID
        INCLUDE          'MID_INCLUDE:ST_DAT.INC/NOLIST'
C
        DATA LABEL       /'X_COORD','Y_COORD','VALUE'/
C
C ***   start the code
        CALL STSPRO('CSTAR')
        CALL STKRDC('IN_A',1,1,60,IAC,FRAMIN,KUN,KNUL,ISTAT)
        CALL STKRDC('IN_B',1,1,60,IAC,TBIN,KUN,KNUL,ISTAT)
        CALL STKRDC('OUT_A',1,1,60,IAC,FRAMOUT,KUN,KNUL,ISTAT)
        CALL STKRDI('INPUTI',1,1,IAC,NPX,KUN,KNUL,ISTAT)
        CALL STKRDR('INPUTR',1,7,IAC,PARAM,KUN,KNUL,ISTAT)
C
C ***   open the image
        CALL STIGET(FRAMIN,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,2,NAXIS,
     2              NPIX,START,STEP,IDENT,CUNIT,IP,IMF,ISTAT)
C
C *** prepare the tables
        CALL TBTOPN(TBIN,F_I_MODE,TID,ISTAT)
        CALL TBIGET(TID,NCOL,NROW,NSC,NAC,NAR,ISTAT)               ! read table
C
C *** search of colonne indices by name
        DO I=1,3
           CALL TBLSER(TID,LABEL(I),ICOL(I),ISTAT)
        ENDDO
        DO I = 1,NROW
           CALL TBRRDR(TID,I,3,ICOL,XYZ(1,I),NULL,ISTAT)
        ENDDO
        CALL TBTCLO(TID,ISTAT)
C
C *** open the output frame
        START1(1) = PARAM(1)
        START1(2) = PARAM(2)
        STEP1(1)  = PARAM(3)
        STEP1(2)  = PARAM(4)
        NPIX1(1)  = NPX
        NPIX1(2)  = NPX
        CALL STIPUT(FRAMOUT,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,NAXIS,
     2              NPIX1,START1,STEP1,IDENT,CUNIT,IPOUT,IMF1,ISTAT)
C
C *** get minimum and maximum
        DMIN  = PARAM(5)
        DMAX  = PARAM(6)
        IZONE = INT(PARAM(7))
        IF (DMIN .EQ. DMAX) THEN
            CALL STDRDR(IMF,'LHCUTS',1,4,IAC,CUTS,KUN,KNUL,ISTAT) ! min and max
            DMIN = CUTS(3)
            DMAX = CUTS(4)
        ENDIF
C
C *** do the stellar creation
        CALL SPPHOT(MADRID(IP),NPIX,START,STEP,XYZ,NROW,
     2              NPX,IZONE,DMIN,DMAX,MADRID(IPOUT))
C
C *** finish
        CALL STSEPI
        END




        SUBROUTINE SPPHOT(XIN,NPIX,START,STEP,XYZ,NET,
     *                    NPNT,IZONE,DMIN,DMAX,XOUT)
C+++
C       routine for stellar photometry; generates a stellar image by averaging
C---

        IMPLICIT NONE
 
        INTEGER          NPN, NPN1
        PARAMETER        (NPN  = 1024)
        PARAMETER        (NPN1 = NPN + 1)

        REAL             XIN(*)
        INTEGER          NPIX(*)
        DOUBLE PRECISION START(*),STEP(*)
        REAL             XYZ(3,1000)
        INTEGER          NET
        INTEGER          NPNT
        INTEGER          IZONE
        REAL             DMIN, DMAX
        REAL             XOUT(*)
C            
        INTEGER          NPNT1
        INTEGER          J, LL
        INTEGER          NETOT
        INTEGER          I, IE
        INTEGER          IVAL, ISTAT
        INTEGER          KL, KLT, KP, KTOT
        INTEGER          IP, IPMIN, IPMAX
        INTEGER          IL, ILMIN, ILMAX
        INTEGER          IN1, IN2
        INTEGER          NPL, NL, NP
        REAL             AIL, AIP
        REAL             D, DPHI
        REAL             ETOT
        REAL             X0, Y0, XD, YD
        REAL             DX, DY
        REAL             DP, DL
        REAL             P1, P2, P3, P4
        REAL             RMES(NPN1,2),RMESS(NPN)
        REAL             SMOY(NPN,NPN), SMOYB
        REAL             TOT
        CHARACTER        TEXT*80
C
 1100   FORMAT('Number of stars:',I5)
C
        NPNT1 = NPNT + 1
        DX    = STEP(1)
        DY    = STEP(2)
        NPL   = NPIX(1)
        NL    = NPIX(2)
        X0    = START(1)
        Y0    = START(2)
        IVAL  = IZONE/2
C
C *** 
        NETOT = 0
        DO 40 KL = 1,NPNT
           DO 41 KP = 1,NPNT
              SMOY(KP,KL) = 0.
   41      CONTINUE
   40   CONTINUE            
C
        DO 100 IE = 1,NET
           XD   = XYZ(1,IE)
           YD   = XYZ(2,IE)
           D    = XYZ(3,IE)
           DPHI = D
           IF (DPHI.GT.DMAX.OR.DPHI.LT.DMIN) THEN
              GO TO 100
           ENDIF
C
C ***   calculate zone limits
           AIP   = (XD-X0)/DX+1.
           AIL   = (YD-Y0)/DY+1.
           IP    = AIP
           IL    = AIL
           IPMIN = IP-IVAL
           IPMAX = IP+IVAL
           ILMIN = IL-IVAL
           ILMAX = IL+IVAL
C
C *** exclusion of bordwer points
           IF (IPMIN.LT.1) GO TO 100
           IF (IPMAX.GT.NPL) GO TO 100
           IF (ILMIN.LT.1) GO TO 100
           IF (ILMAX.GT.NL) GO TO 100
           DP = AIP-IP
           DL = AIL-IL
C
C *** interpolation 
           P1 = (1.-DP)*(1.-DL)
           P2 = DP*(1.-DL)
           P3 = (1.-DP)*DL
           P4 = DP*DL
           J  = 1
           CALL LIRE(ILMIN,NPL,IPMIN,IPMAX,1,XIN,RMES(1,J))
           KTOT = IVAL*2
           KL   = 0
C
C ** added after interpolation
           DO 50 LL=ILMIN+1,ILMAX
              KL= KL+1
              I = J
              J = MOD(J,2)+1
              CALL LIRE(LL,NPL,IPMIN,IPMAX,1,XIN,RMES(1,J))
              DO 51 KP = 1,KTOT
                 SMOY(KP,KL) = SMOY(KP,KL) +
     2                         P1*RMES(KP,I) + P2*RMES(KP+1,I) +
     3                         P3*RMES(KP,J) + P4*RMES(KP+1,J)
   51         CONTINUE
   50      CONTINUE
           NETOT = NETOT+1 
  100    CONTINUE
C
C *** 
        WRITE (TEXT,1100) NETOT
        CALL STTPUT(TEXT,ISTAT)
        IF (NETOT.GT.0) GO TO 110
           CALL STTPUT('*** WARNING: Stars are beyound limits',ISTAT)
           RETURN
  110   CONTINUE
C
C *** normalize
        ETOT = FLOAT(NETOT)
        DO 120 KLT = 1,KL
           DO 121 KP = 1,KTOT
              SMOY(KP,KLT) = SMOY(KP,KLT)/ETOT
  121      CONTINUE
  120   CONTINUE
C
C *** prepare output table; calculate the pixel values
        SMOYB = 0.                
        DO 401 I = 1,KTOT
           SMOYB = SMOYB+SMOY(I,1)
           SMOYB = SMOYB+SMOY(I,KL)
  401   CONTINUE
        DO 402 I = 2,KL-1
           SMOYB = SMOYB+SMOY(1,I)
           SMOYB = SMOYB+SMOY(KTOT,I)
  402   CONTINUE
        TOT   = KTOT*2+(KL-2)*2
        SMOYB = SMOYB/TOT
        IN1   = INT(NPNT/2) - 1 - IVAL
        IN2   = IN1+IZONE-1
        IF (IN1.EQ.0) THEN
           IN2 = NPNT
           GO TO 2
        END IF
C
C *** write the otput tabler after re-centering
        DO 291 KP = 1,NPNT
           RMESS(KP) = SMOYB
  291   CONTINUE
        DO 301 NL = 1,IN1
           CALL ECRIT(NL,NPNT,RMESS,XOUT)
  301   CONTINUE
C
        J=1
    2   CONTINUE
        DO 302 NL = IN1+1,IN2
           I=1
           DO 292 NP = 1,IN1
              RMESS(NP) = SMOYB
  292      CONTINUE
           DO 293 NP = IN1+1,IN2
              RMESS(NP) = SMOY(I,J)
              I=I+1
  293      CONTINUE
           DO 294 NP = IN2+1,NPNT
              RMESS(NP) = SMOYB
  294      CONTINUE
           CALL ECRIT(NL,NPNT,RMESS,XOUT)
           J = J+1
  302   CONTINUE
C         
        IF (IN2.EQ.NPNT) THEN
           RETURN
        ENDIF
        DO 295 KP=1,NPNT
           RMESS(KP) = SMOYB
  295   CONTINUE        
        DO 303 NL = IN2+1,NPNT
           CALL ECRIT(NL,NPNT,RMESS,XOUT)
  303   CONTINUE
C
        RETURN
        END


        SUBROUTINE ECRIT(NLI,NPOINT,RMES,FMES)
C
        IMPLICIT NONE
        INTEGER  NLI, NPOINT
        REAL     RMES(1),FMES(1)
C
        INTEGER  KI, I
C
        DO I = 1,NPOINT
              KI = I + (NLI-1)*NPOINT
              FMES(KI) = RMES(I)
        ENDDO
C
        RETURN
        END



        SUBROUTINE LIRE(NL,NPL,NPL1,NPL2,NPL3,FMES,RMES)
C+++
C.PURPOSE:  Write part of a frame into an array
C.AUTHOR:   ???
C.VERSION:  ?????? ??? created
C.VERSION:  890117 RHW documented
C.COMMENTS: none
C---
        IMPLICIT   NONE
        INTEGER    NL
        INTEGER    NPL
        INTEGER    NPL1
        INTEGER    NPL2
        INTEGER    NPL3
        REAL       FMES(*)
        REAL       RMES(*)                         

        INTEGER    NPD, NPF, K, I 

C ***
        NPD = NPL* (NL-1) + NPL1    
        NPF = NPD + NPL2 - NPL1
        K   = 0 
C 
        DO 10 I = NPD,NPF,NPL3
           K       = K + 1  
           RMES(K) = FMES(I)
   10   CONTINUE 
C       RETURN
        END

C @(#)tdrhist.for	19.1 (ESO-DMD) 02/25/03 14:11:20
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.1  ESO-FORTRAN Conversion, AA  15:21 - 19 NOV 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION:
C     TDRHIST
C
C.PURPOSE
C
C  Execute the command
C   READ/HISTO table-name column-ref1
C   PRINT/HISTO table-name column-ref1
C
C.KEYWORDS
C
C  Histogram, tables
C
C.ALGORITHM
C
C  uses table interface routines
C
C.VERSION
C 020807	last modif
C 
C-----------------------------------------------------------
C
      SUBROUTINE TDRHIS
      IMPLICIT NONE
C
      INTEGER      CODE, ISTAT, NPAR, TID, IAC
      INTEGER      NBINS, NCOL, NROW, NSC, NAC, NAR
      INTEGER      STATUS, INS
      INTEGER      COL(3)
      INTEGER      PNEVAL, DUNIT, DNULL
      INTEGER      PNCODE
      INTEGER      IFR(512)
C
      REAL         TSTAT(8),CL(512)
C
      CHARACTER*80 TABLE
      CHARACTER*16 OLAB
      CHARACTER*22 LABEL1,LABEL2
      CHARACTER*30 LAB
      CHARACTER*80 LINE
      CHARACTER*80 LINE1
      CHARACTER*16 LABEL(3),UNIT(3)
      CHARACTER*10 DESNA1, DESNA2, DESNA3
      CHARACTER*4  WS
      CHARACTER*2  PCODE
      CHARACTER*16 MSG
      CHARACTER*30 COLUMN(3)
C
       INCLUDE 'MID_INCLUDE:TABLES.INC'
       INCLUDE 'MID_INCLUDE:TABLED.INC'
C
      DATA PNCODE/2/
      DATA PNEVAL/5/
      DATA PCODE/'PR'/
      DATA DESNA1/'TSTATxxx  '/
      DATA DESNA2/'TCLASxxx  '/
      DATA DESNA3/'TFREQxxx  '/
      DATA MSG/'ERR:THISTTBLxxxx'/
C
C ... get input parameters + default
C
      CALL TDPCOD(PNCODE,PCODE,CODE,ISTAT)
      CALL TDPGET(PNEVAL,NPAR,ISTAT)
      IF (ISTAT.NE.0) GO TO 10
      TABLE  = TPARBF(1)
      COLUMN(1) = TPARBF(2)
C
C ... read table (only descriptors)
C
      TID = -1
      CALL TBTOPN(TABLE,F_D_MODE,TID,ISTAT)
      IF (ISTAT.NE.0) GO TO 10
      CALL TBIGET(TID,NCOL,NROW,NSC,NAC,NAR,ISTAT)
      IF (ISTAT.NE.0) GO TO 10
      CALL TBCSER(TID,COLUMN(1),COL(1),ISTAT)
      IF (ISTAT.NE.0) GO TO 10
      IF (COL(1).EQ.-1) THEN
          ISTAT  = ERRPAR
          GO TO 10
      END IF
      CALL TBLGET(TID,COL(1),LABEL(1),ISTAT)
      IF (ISTAT.NE.0) GO TO 10
      CALL TBUGET(TID,COL(1),UNIT(1),ISTAT)
      IF (ISTAT.NE.0) GO TO 10
C
C ... Display histogram
C
      LAB    = 'HISTOGRAM TABLE : '//TABLE
      LABEL1 = 'FREQUENCY'
      OLAB   = 'COLUMN '
      IF (LABEL(1) (1:2).EQ.'  ') THEN
          WRITE (OLAB(7:10),9000) COL(1)
      ELSE
          OLAB   = LABEL(1)
      END IF
      LABEL2 = 'BINS: '//OLAB
      INS    = COL(1) + 1000
      WRITE (WS,9000) INS
      DESNA1(6:8) = WS(2:4)
      DESNA2(6:8) = WS(2:4)
      DESNA3(6:8) = WS(2:4)
      CALL STDRDR(TID,DESNA1,1,8,IAC,TSTAT,DUNIT,DNULL,ISTAT)
      IF (ISTAT.NE.0) GO TO 10
      NBINS  = TSTAT(7)
      CALL STDRDR(TID,DESNA2,1,NBINS,IAC,CL,DUNIT,DNULL,ISTAT)
      IF (ISTAT.NE.0) GO TO 10
      CALL STDRDI(TID,DESNA3,1,NBINS,IAC,IFR,DUNIT,DNULL,ISTAT)
      IF (ISTAT.NE.0) GO TO 10
C
C  delete descriptors
C
      CALL STDDEL(TID,DESNA1,ISTAT)
      CALL STDDEL(TID,DESNA2,ISTAT)
      CALL STDDEL(TID,DESNA3,ISTAT)
C
      LINE   = '  TABLE :         '
      LINE(11:) = TABLE(1:)
      CALL STTPUT(LINE,ISTAT)
      CALL TDRSEL(TID,LINE,ISTAT)
      IF (LINE(1:1).NE.'-') THEN
          LINE1  = ' SELECT  '//LINE
          CALL STTPUT(LINE1,ISTAT)
      END IF
      CALL TDHLIS(NBINS,CL,IFR,TSTAT,LABEL1,LABEL2,LAB,UNIT(1),ISTAT)
      IF (ISTAT.NE.0) GO TO 10
C
C ... end
C
      CALL TBTCLO(TID,ISTAT)
   10 IF (ISTAT.NE.0) THEN
          WRITE (MSG(13:16),9000) ISTAT
          CALL TDERRR(ISTAT,MSG,STATUS)
      END IF
      RETURN
 9000 FORMAT (I4)
      END

C===========================================================================
C Copyright (C) 1995,2004 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.COPYRIGHT: Copyright (c) 1987,2004 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  18:13 - 21 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION
C
C  program FITIMAG.FOR
C
C.PURPOSE
C
C  Execute the commands
C  FIT/IMA [iter[,chisq[,relax]]] image[,error] [FZname]
C  FIT/IMA [iter[,chisq[,relax]]] GCURSOR         [FZname]
C  FIT/IMA [iter[,chisq[,relax]]] CURSOR  [FZname] - NOT YET IMPLEM.
C
C  FIT/TAB [iter[,chisq[,relax]]] table dep[,err] ind.vars [FZname]
C
C.KEYWORDS
C
C  FIT
C
C.INPUT/OUTPUT
C
C  P1 - P8     contain input parameters
C
C.ALGORITHM
C
C  Use fit interface routines
C
C.VERSION
C 040521	last modif
C 
C-----------------------------------------------------------
C
C
C ... define parameters
C
      IMPLICIT NONE
C
      INTEGER IVAR(8),FIX(20),KUN,KNUL, NP
      INTEGER ISTAT, I, II, IAV, NIND, NPAR
      INTEGER NFUN,NDAT,N,J,IDVAR,NL,NACT,NAMLEN,MM,IVAL
C
      REAL CHISQ,VAL1,VAL2
C
      DOUBLE PRECISION PAR(20),ERR(20),DVAL
C
      CHARACTER*80 FNAME,NAME,FILE,MASK,LINE1
      CHARACTER    IAC*1,AUX*30,AUX1*30
      CHARACTER    LINE2*80,TYPE*4,LINE*80
      CHARACTER    LINE3*80
      CHARACTER*80 HEAD,OUT,HEADER
      CHARACTER*16 MSG
      CHARACTER*4  PPRINT
C
      INCLUDE 'MID_INCLUDE:FITI.INC/NOLIST'
      INCLUDE 'MID_INCLUDE:FITC.INC/NOLIST'
C
      DOUBLE PRECISION OURSTART(FZINDMAX),OURSTEP(FZINDMAX)
C 
      DATA NAMLEN/80/
      DATA MSG/'ERR:FITIMAGxxxx'/
      DATA HEAD/' Parameter Initial Guess      Actual Value       Error'
     +     /
C
C ... get into MIDAS
C
      CALL STSPRO('FITIMAG')
      CALL FITBL
      CALL STKRDC('P2',1,1,NAMLEN,I,LINE3,KUN,KNUL,ISTAT)
      II     = INDEX(LINE3,',')
      IF (II.EQ.0) THEN
          FILE   = LINE3
          MASK   = ' '
      ELSE
          FILE   = LINE3(1:II-1)
          MASK   = LINE3(II+1:)
      END IF
      CALL STKRDC('P3',1,1,NAMLEN,II,LINE1,KUN,KNUL,ISTAT)
      IF (LINE1(1:1).EQ.':' .OR. LINE1(1:1).EQ.'#') THEN
          IAC    = 'T'
          CALL STKRDC('P4',1,1,80,IAV,LINE2,KUN,KNUL,ISTAT)
          CALL STKRDC('P5',1,1,NAMLEN,IAV,NAME,KUN,KNUL,ISTAT)
      ELSE
          IAC    = 'I'
          NAME   = LINE1
      END IF
      IF (NAME(1:1).EQ.'?') THEN
          CALL STKRDC('FITNAME',1,1,NAMLEN,IAV,NAME,KUN,KNUL,ISTAT)
      ELSE
          CALL STKWRC('FITNAME',1,NAME,1,NAMLEN,KUN,ISTAT)
      END IF
      CALL STKRDR('INPUTR',1,9,IAV,FZMETPAR(2),KUN,KNUL,ISTAT)
      CALL STKRDC('FITCHAR',1,21,4,IAV,PPRINT,KUN,KNUL,ISTAT)
      CALL GENCNV(PPRINT,2,1,IVAL,FZMETPAR(1),DVAL,MM)
      VAL1 = 0.0
      VAL2 = 0.0
C
C ... fit for image - start, step from image => fit-function
C
      IF (IAC.EQ.'I') THEN
          CALL FTIMAG(FILE,MASK,ISTAT)
      ELSE
          CALL FTTABL(FILE,LINE1,LINE2,ISTAT)
      END IF
C 
C  FTINIT overwrites FZSTART, FZSTEP - so save them
C 
      DO 100, I = 1,FZINDMAX
         OURSTART(I) = FZSTART(I)
         OURSTEP(I) = FZSTEP(I)
100   CONTINUE
      CALL FTINIT(NAME,ISTAT)
      DO 200, I = 1,FZINDMAX
         FZSTART(I) = OURSTART(I)
         FZSTEP(I) = OURSTEP(I)
200   CONTINUE
C
      CALL FTDODO(NINT(FZMETPAR(2)),FZMETPAR(4),FZMETPAR(3),VAL1,
     +            VAL2,NACT,CHISQ,ISTAT)
C
C ... read parameters
C
      CALL FTINFO(FILE,TYPE,IDVAR,NIND,NFUN,NDAT,ISTAT)
      LINE   = ' No. of data points '
      WRITE (LINE(25:32),9030) NDAT
      CALL STTPUT(LINE,ISTAT)
C
      CALL STTPUT(' ',ISTAT)
      IF (TYPE.EQ.'TBL ') THEN
          LINE   = ' Dependent variable '
          WRITE (LINE(25:28),9000) IDVAR
          CALL STTPUT(LINE,ISTAT)
      END IF
      LINE   = ' No. of ind. variables '
      WRITE (LINE(25:28),9000) NIND
      CALL STTPUT(LINE,ISTAT)
C
C ... read fit variables
C
      IF (NIND.GT.0) THEN
          CALL FTRDIN(NIND,IVAR,N,ISTAT)
          IF (TYPE.EQ.'BDF ') THEN
              LINE   = ' variable .... is axis   ....'
          ELSE
              IF (TYPE.EQ.'TBL ') THEN
                  LINE   = ' variable .... is column ....'
              ELSE  !   DO NOT PRINT IVAR
                  NIND   = 0
              END IF
          END IF
          DO 20 I = 1,NIND
              WRITE (LINE(11:14),9000) I
              WRITE (LINE(26:29),9000) IVAR(I)
              CALL STTPUT(LINE,ISTAT)
   20     CONTINUE
      END IF
C
C ... read coeffs
C
      CALL STTPUT(' ',ISTAT)
      LINE   = ' No. of functions '
      WRITE (LINE(25:28),9000) NFUN
      CALL STTPUT(LINE,ISTAT)
      NP     = 0
      DO 40 I = 1,NFUN
          CALL STTPUT(' ',ISTAT)
          CALL FTRDFN(I,LINE,ISTAT)
          II     = INDEX(LINE,')')
          CALL STTPUT(LINE(1:II),ISTAT)
          CALL STTPUT(HEAD,ISTAT)
          CALL FTRDPR(I,FNAME,NPAR,PAR,ERR,FIX,ISTAT)
          LINE   = FZSPEC(I)
          IF (NPAR.GT.0) THEN
              DO 30 J = 1,NPAR
                  NP     = NP + 1
                  NL     = FZPLEN(NP)
                  AUX    = FZPTOKEN(NP)
                  AUX1   = AUX(1:NL)//'='
                  II     = INDEX(LINE,AUX1(1:NL+1))
                  IF (II.EQ.0) THEN
                      AUX1   = '-'
                  ELSE
                      AUX    = LINE(II+NL+1:)
                      II     = INDEX(AUX,' ') - 1
                      AUX1   = AUX(1:II)
                  END IF
                  WRITE (OUT,9010) FZPTOKEN(NP),AUX1(1:16),PAR(J),
     +              ERR(J)
                  CALL STTPUT(OUT,ISTAT)
   30         CONTINUE
          END IF
   40 CONTINUE
C
C ... end
C
      CALL STTPUT(' ',ISTAT)
      CALL STTPUT('     Red. Chisq      Act. Nr. F. Eval.',ISTAT)
      WRITE (HEADER,9020) FZCCHIS,FZNITER
      CALL STTPUT(HEADER,ISTAT)
      CALL STTPUT(' ',ISTAT)
      CALL FTEXIT(NAME,ISTAT)
      IF (ISTAT.NE.0) THEN
          WRITE (MSG(13:16),9000) ISTAT
C   CALL TDERRR(ISTAT,MSG,STATUS)
      END IF
      CALL STSEPI
 9000 FORMAT (I4)
 9010 FORMAT (1X,A,2X,A,1X,E14.6,1X,E14.6)
 9020 FORMAT (3X,1PE12.4,12X,I6)
 9030 FORMAT (I8)
      END

C @(#)mima.for	19.1 (ES0-DMD) 02/25/03 13:29:44
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE MIMA(IMF,FMES,ISIZE,DMI,DMA)                                  
C+++                                                                            
C.PURPOSE:  Determine the minimum and maximum and write into descriptor
C.AUTHOR:   Rein H. Warmels
C.COMMENTS: none
C.VERSION:  890117 RHW documented
C.VERSION:  910115 RHW IMPLICIT NONE added
C---                                                                            
      IMPLICIT      NONE
      INTEGER       IMF
      REAL          FMES(1)
      INTEGER       ISIZE
      REAL          DMA
      REAL          DMI
C
      INTEGER       ISTAT	
      INTEGER       KNUL, KUN
      INTEGER       MADRID(1)
      REAL          VAL(4)                                           
C
      COMMON        /VMR/MADRID                                              
C                                                                               
      CALL MINMAX(FMES,ISIZE,DMI,DMA)
      VAL(1) = DMI                                                              
      VAL(2) = DMA                                                              
      VAL(3) = DMI                                                              
      VAL(4) = DMA                                                              
      CALL STDRDR(IMF,'LHCUTS',VAL,1,4,KUN,KNUL,ISTAT)
C                                                                               
      RETURN                                                                    
      END                                                                       


      SUBROUTINE MINMAX(ARRAY,NDIM,FMIN,FMAX)                                   
C+++                                                                            
C.PURPOSE: Determine the minnimum and maximum in an array
C.AUTHOR:  Ch. Ounnas, ESO - Garching                                    
C.VERSION: 810820 Creation                                                
C.VERSION: 910115 RHW IMPLICIT NONE added
C---                                                                            
      IMPLICIT  NONE
      INTEGER   NDIM                                                          
      REAL      FMIN
      REAL      FMAX
C
      INTEGER   MADRID(1)
      INTEGER   N 
      REAL      ARRAY(NDIM)
      REAL      PIX
C
      COMMON   /VMR/MADRID
C
C ***
      FMIN   = ARRAY(1)                                                         
      FMAX   = ARRAY(1)                                                         
C                                                                               
      DO 10 N = 1,NDIM                                                          
         PIX = ARRAY(N)                                                         
         IF (PIX.LT.FMIN) THEN                                                  
            FMIN = PIX                                                          
         ELSE                                                                   
            IF (PIX.GT.FMAX) THEN                                               
              FMAX = PIX                                                        
            ENDIF                                                               
        ENDIF                                                                   
   10 CONTINUE                                                                  
C                                                                               
      RETURN                                                                    
      END                                                                       

C @(#)ran3.for	19.1 (ES0-DMD) 02/25/03 13:29:45
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      REAL FUNCTION RAN3(IDUM)
C+++
C.PURPOSE:      Returns a uniform random  derivative bteen 0.0 and 1.0. 
C               Set IDUM to any negative value to initiaze the sequence.
C.ALGORYTHM:    From Numerical Recipes (Press et al., 1988)
C.VERSION:      910115 RHW IMPLICIT NONE added
C---
      IMPLICIT  NONE
      INTEGER   IDUM                                !
C
      INTEGER   MBIG
      INTEGER   MSEED
      INTEGER   MZ
      REAL      FAC
      PARAMETER (MBIG=1000000000)
      PARAMETER (MSEED=161803398)
      PARAMETER (MZ=0)
      PARAMETER (FAC=1./MBIG)
C
      INTEGER   IFF, II, I
      INTEGER   INEXT, INEXTP
      INTEGER   K
      INTEGER   MJ, MK
      INTEGER   MA(55)
      SAVE
C
      DATA      IFF/0/
C
C ***
      IF (IDUM.LT.0 .OR. IFF.EQ.0) THEN
         IFF    = 1
         MJ     = MSEED - IABS(IDUM)
         MJ     = MOD(MJ,MBIG)
         MA(55) = MJ
         MK     = 1
         DO 11 I=1,54
            II = MOD(21*I,55)
            MA(II) = MK
            MK     = MJ - MK
            IF (MK.LT.MZ) THEN
               MK = MK + MBIG
            ENDIF
            MJ = MA(II)
  11     CONTINUE
C
         DO 13 K = 1,4
            DO 12 I = 1,55
               MA(I) = MA(I)-MA(1+MOD(I+30,55))
               IF (MA(I).LT.MZ) THEN
                  MA(I) = MA(I) + MBIG
               ENDIF
   12       CONTINUE
   13    CONTINUE
         INEXT  = 0
         INEXTP = 31
         IDUM   = 1
      ENDIF
C
      INEXT = INEXT + 1
      IF (INEXT.EQ.56) THEN
         INEXT = 1
      ENDIF
      INEXTP = INEXTP + 1
      IF (INEXTP.EQ.56) THEN
         INEXTP = 1
      ENDIF
      MJ = MA(INEXT) - MA(INEXTP)
      IF (MJ.LT.MZ) THEN
         MJ = MJ + MBIG
      ENDIF
      MA(INEXT) = MJ
      RAN3      = MJ*FAC

      RETURN
      END

C @(#)compxy.for	19.1 (ESO-DMD) 02/25/03 14:01:41
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM COMPXY
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  original FORTRAN code: 		D. Gillet	ESO - Garching
C  modified and adapted to MIDAS environment: D. Baade	ST-ECF, Garching
C  program  BARYCORR 			version 1.00	860203
C  original FORTRAN code: 		D. Gillet	ESO - Garching
C  modified and adapted to MIDAS environment: D. Baade	ST-ECF, Garching
C  program  PRECESS			    version 1.0   860201
C  original FORTRAN code:       	D. Gillet	ESO - Garching
C  modified and adapted to MIDAS environment: D. Baade	ST-ECF, Garching
C
C  this is the merged version of old COMPST.FOR, COMPUT.FOR, BARYCORR.FOR
C  					K.Banse		ESO - IPG
C  program  COMPXY			version 2.00	890519
C     2.10   900213	2.15	900711		2.20	901008
C     2.25   910429     2.3     911127
C     3.35   920602 
C     3.50   920902 PJG				3.60	931112
C
C.COMMENT
C  The program was changed so that to input longitude now conform
C  to IAU standard namely east-longitude is positive!!!
C  Internally east-longitudes are converted back to west!  PJG 920902
C
C.KEYWORDS
C  a,b) Julian date, conversion from universal time to local sidereal time
C  c)   barycentric and heliocentric corrections of times and radial velocities
C  d)   precession of equatorial coordinates
C
C.PURPOSE
C  a) calculate Julian date, convert from UT to local ST
C  b) calculate Julian date, convert from local ST to UT
C  c) correct times for the light travel time in the solar system, i.e.
C     reduce to either barycentric or heliocentric times
C     and
C     correct radial velocities for the earth's orbital and diurnal velocities,
C     i.e. reduce to either barycentric or heliocentric radial velocities
C  d) precess equatorial coordinates from one epoch to another
C
C.ALGORITHM
C
C  Reference : the Astronomical Almanac 1983, p B7
C  in 1983: 1 mean solar day = 1.00273790931 mean sidereal days
C  ST without equation of equinoxes correction => accuracy +/- 1 sec
C
C.INPUT/OUTPUT
C  the following keywords are used:
C  ACTION/C/1/2    a,b) US for UT -> ST, SU for ST -> UT
C		   c)   BA for barycorr stuff
C		   d)   PR for precession stuff
C
C  for COMPUTE/UT /ST
C  INPUTR/R/1/3    date: year,month,day
C  INPUTR/R/4/3    universal or sidereal time: hour,min,sec
C  INPUTR/R/7/3    EAST longitude of observatory: degree,min,sec  !! NOTE
C  OUTPUTR/R/1/3   sidereal or universal time : hour,min,sec
C  OUTPUTD/D/1/1   Julian date
C
C  for COMPUTE/BARYCORR
C  INPUTR/R/1/3    date: year,month,day
C  INPUTR/R/4/3    universal time: hour,min,sec
C  INPUTR/R/7/3    EAST longitude of observatory: degree,min,sec  !! NOTE
C  INPUTR/R/10/3   latitude of observatory: degree,min,sec
C  INPUTR/R/13/3   right ascension: hour,min,sec
C  INPUTR/R/16/3   declination: degree,min,sec
C  OUTPUTD/D/1/1   barycentric correction to time (days)
C  OUTPUTD/D/2/1   heliocentric correction to time (days)
C  OUTPUTR/R/1/1   barycentric correction to radial velocity (km/s)
C  OUTPUTR/R/2/1   heliocentric correction to radial velocity (km/s)
C
C  for COMPUTE/PRECESSION
C  INPUTR/R/1/3    	original epoch: year,month,day
C  INPUTR/R/4/3		new epoch: year,month,day
C  INPUTR/R/7/3		original right ascension: hour,min,sec
C  INPUTR/R/10/3  	original declination: degree,min,sec
C  OUTPUTR/R/1/3        precessed right ascension: hour,min,sec
C  OUTPUTR/R/4/3        precessed declination: degree,min,sec
C  OUTPUTR/R/7/1        new epoch: real years
C  OUTPUTD/D/1/2	old epoch, new epoch
C
C------------------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER   IAV,STAT,KUN(1),KNUL,N
      INTEGER   MADRID
C
      DOUBLE PRECISION   UTR,STR,T0,DL,THETA0,PE,ST0HG,STG,GAST,R1
      DOUBLE PRECISION   JD,JD0H,JD00,ZERO
      DOUBLE PRECISION   DCORB(3),DCORH(3),DVELB(3),DVELH(3)
      DOUBLE PRECISION   ALP,BCT,BEOV,BERV,DEL,EDV
      DOUBLE PRECISION   HAR,HCT,HEOV,HERV,PHI,PI
      DOUBLE PRECISION   EQX0,EQX1
      DOUBLE PRECISION   A0R,A1R,D0R,D1R
      DOUBLE PRECISION   DSMALL,DTEMP(3)
C
      REAL   DATE0(3),DATE1(3),DATE00(3),A0(3),A1(3),D0(3),D1(3)
      REAL   DATE(3),UT(3),OLONG(3),ST(3)
      REAL   OLAT(3),ALPHA(3),DELTA(3)
      REAL   RBUF(20)
C
      CHARACTER   ACTIO*2,SIGNS*3,INPSGN*3
C
      COMMON      /VMR/MADRID(1)
C
      EQUIVALENCE (RBUF(1),DATE(1)),(RBUF(7),OLONG(1))
      EQUIVALENCE (RBUF(10),OLAT(1)),(RBUF(13),ALPHA(1))
      EQUIVALENCE (RBUF(16),DELTA(1))
C 
      DATA    PI  /3.1415926535897928D0/
      DATA    DSMALL  /1.D-38/
C
C ... set up MIDAS environment
C
      CALL STSPRO('COMPXY')
      ZERO = 0.D0
      DO 100, N=1,3
         DATE0(N) = 0.0
         DATE1(N) = 0.0
         DATE00(N) = 0.0
         A0(N) = 0.0
         A1(N) = 0.0
         D0(N) = 0.0
         D1(N) = 0.0
         DATE(N) = 0.0
         UT(N) = 0.0
         ST(N) = 0.0
         OLONG(N) = 0.0
         OLAT(N) = 0.0
         ALPHA(N) = 0.0
         DELTA(N) = 0.0
100   CONTINUE
C
C ... read keywords for input
C
      CALL STKRDC('ACTION',1,1,2,IAV,ACTIO,KUN,KNUL,STAT)
      CALL UPCAS(ACTIO,ACTIO)
      CALL STKRDR('INPUTR',1,20,IAV,RBUF,KUN,KNUL,STAT)
      CALL STKRDC('INPUTC',1,1,3,IAV,INPSGN,KUN,KNUL,STAT)
C
C  compute/barycorr is done in section 1000, compute/precession in section 2000
C
      IF (ACTIO.EQ.'BA') GOTO 1000
      IF (ACTIO.EQ.'PR') GOTO 2000
C 
C  *****************************************************
C
C  here for COMPUTE/UT or COMPUTE/ST
C 
C  *****************************************************
C
      IF (ACTIO.EQ.'US') THEN
         DO 200, N=1,3
            UT(N) = RBUF(N+3)
200      CONTINUE
         UTR = UT(1)+UT(2)/60.D0+UT(3)/3600.D0      !convert UT to real hours
      ELSE
C
         DO 300, N=1,3
            ST(N) = RBUF(N+3)
300      CONTINUE
         STR = ST(1)+ST(2)/60.D0+ST(3)/3600.D0      !convert ST to real hours
      ENDIF
C
C ... likewise convert longitude of observatory to real hours,
C     take care of sign. NOTE: east longitude is assumed for input !!
C
      SIGNS = '+++'
      IF ((OLONG(1).LT.0.0) .OR. (OLONG(2).LT.0.0) .OR.
     +    (OLONG(3).LT.0.0) .OR. (INPSGN(1:1).EQ.'-')) THEN  
         SIGNS(1:1) = '-'
         OLONG(1) = ABS(OLONG(1))
         OLONG(2) = ABS(OLONG(2))
         OLONG(3) = ABS(OLONG(3))
      ENDIF
      DTEMP(1) = DBLE(OLONG(1))
      DTEMP(2) = DBLE(OLONG(2))
      DTEMP(3) = DBLE(OLONG(3))
      DL = DTEMP(1)+DTEMP(2)/60.D0+DTEMP(3)/3600.D0
      IF (SIGNS(1:1).EQ.'-') DL = -DL              ! negative longitude
      DL = -DL*24.D0/360.D0                !convert back to west longitude
C
C ... compute ST at 0 hours UT (ST0HG)
C ... REFERENCE : MEEUS J.,1980,ASTRONOMICAL FORMULAE FOR CALCULATORS
C
      CALL JULDAT(DATE,ZERO,JD0H)
      DTEMP(1) = 2415020.D0
      T0=(JD0H-DTEMP(1))/36525.D0
      DTEMP(1) = 0.276919398D0
      DTEMP(2) = 100.0021359D0
      DTEMP(3) = 0.000001075D0
      THETA0 = DTEMP(1) + DTEMP(2)*T0 + DTEMP(3)*T0*T0
      PE=DINT(THETA0)
      THETA0=THETA0-PE
      ST0HG=THETA0*24.D0
C
      IF (ACTIO.EQ.'US') THEN
C
C now do the conversion UT -> ST (MEAN SIDEREAL TIME)
         STG=ST0HG + (UTR*1.00273790931D0)
         IF (STG.LT.DL) STG=STG+24.D0
         STR=STG-DL
400      IF (STR.GE.24.D0) THEN
            STR=STR-24.D0
            GOTO 400
         ENDIF
         ST(1)=IDINT(STR)
         R1=(STR-ST(1))*60.D0
         ST(2)=IDINT(R1)
         ST(3)=(R1-ST(2))*60.D0
      ELSE
C
C now do the conversion ST -> UT (MEAN SIDEREAL TIME)
         GAST=STR+DL
         IF(GAST.LT.ST0HG)GAST=GAST+24.D0
         UTR=(GAST-ST0HG)/1.00273790931D0
         IF (UTR.GE.24.D0) UTR=UTR-24.D0
         UT(1)=IDINT(UTR)
         R1=(UTR-UT(1))*60.D0
         UT(2)=IDINT(R1)
         UT(3)=(R1-UT(2))*60.D0
      ENDIF
C
C ... compute Julian date
C
      CALL JULDAT(DATE,UTR,JD)
C
C ... write output to keyword
C
      CALL STKWRD('OUTPUTD',JD,1,1,KUN,STAT)
      IF (ACTIO.EQ.'US') THEN
         CALL STKWRR('OUTPUTR',ST,1,3,KUN,STAT)
      ELSE
         CALL STKWRR('OUTPUTR',UT,1,3,KUN,STAT)
      ENDIF
      GOTO 9000
C
C  *****************************************************
C 
C here we do COMPUTE/BARYCORR
C 
C  *****************************************************
C
1000  SIGNS = '+++'
      DO 1100 N=1,3
         UT(N) = RBUF(N+3)
1100  CONTINUE
C
C ... convert UT to real hours, calculate Julian date
C
      UTR = UT(1)+UT(2)/60.D0+UT(3)/3600.D0
      CALL JULDAT(DATE,UTR,JD)
C
C ... likewise convert longitude and latitude of observatory to real hours
C ... and degrees, respectively; take care of signs
C ... NOTE: east longitude is assumed for input !!
C
      IF ((OLONG(1).LT.0.0) .OR. (OLONG(2).LT.0.0) .OR.
     +    (OLONG(3).LT.0.0) .OR. (INPSGN(1:1).EQ.'-')) THEN  
         SIGNS(1:1) = '-'
         OLONG(1) = ABS(OLONG(1))
         OLONG(2) = ABS(OLONG(2))
         OLONG(3) = ABS(OLONG(3))
      ENDIF
      DL = OLONG(1)+OLONG(2)/60.D0+OLONG(3)/3600.D0
      IF (SIGNS(1:1).EQ.'-') DL = -DL              ! negative longitude
      DL = -DL*24.D0/360.D0                ! convert back to west longitude
C
      IF ((OLAT(1).LT.0.0) .OR. (OLAT(2).LT.0.0) .OR.
     +    (OLAT(3).LT.0.0) .OR. (INPSGN(2:2).EQ.'-')) THEN  
         SIGNS(2:2) = '-'
         OLAT(1) = ABS(OLAT(1))
         OLAT(2) = ABS(OLAT(2))
         OLAT(3) = ABS(OLAT(3))
      ENDIF
      PHI = OLAT(1)+OLAT(2)/60.D0+OLAT(3)/3600.D0
      IF (SIGNS(2:2).EQ.'-') PHI = -PHI                 ! negative latitude
      PHI = PHI*PI/180.D0
C
C ... convert right ascension and declination to real radians
C
      ALP = (ALPHA(1)*3600D0+ALPHA(2)*60D0+ALPHA(3))*PI/(12.D0*3600.D0)
C
      IF ((DELTA(1).LT.0.0) .OR. (DELTA(2).LT.0.0) .OR.
     +    (DELTA(3).LT.0.0) .OR. (INPSGN(3:3).EQ.'-')) THEN  
         SIGNS(3:3) = '-'
         DELTA(1) = ABS(DELTA(1))
         DELTA(2) = ABS(DELTA(2))
         DELTA(3) = ABS(DELTA(3))
      ENDIF
      DEL = (DELTA(1)*3600.D0 + DELTA(2)*60.D0 + DELTA(3))
     +      * PI/(3600.D0*180.D0)
      IF (SIGNS(3:3).EQ.'-') DEL = -DEL                 ! negative declination
C
C ... calculate earth's orbital velocity in rectangular coordinates X,Y,Z
C ... for both heliocentric and barycentric frames (DVELH, DVELB)
C ... Note that setting the second argument of BARVEL to zero as done below
C ... means that the input coordinates will not be corrected for precession.
C
      CALL BARVEL(JD,0.0D0,DVELH,DVELB)
C
C ... with the rectangular velocity components known, the respective projections
C ... HEOV and BEOV on a given line of sight (ALP,DEL) can be determined:
C
C ... REFERENCE: THE ASTRONOMICAL ALMANAC 1982 PAGE:B17
C
      BEOV=DVELB(1)*DCOS(ALP)*DCOS(DEL)+
     1     DVELB(2)*DSIN(ALP)*DCOS(DEL)+
     2     DVELB(3)*DSIN(DEL)
      HEOV=DVELH(1)*DCOS(ALP)*DCOS(DEL)+
     1     DVELH(2)*DSIN(ALP)*DCOS(DEL)+
     2     DVELH(3)*DSIN(DEL)
C
C ... For determination also of the contribution due to the diurnal rotation of
C ... the earth (EDV), the hour angle (HAR) is needed at which the observation
C ... was made which requires conversion of UT to sidereal time (ST).
C
C ... Therefore, first compute ST at 0 hours UT (ST0HG)
C
C ... REFERENCE : MEEUS J.,1980,ASTRONOMICAL FORMULAE FOR CALCULATORS
C
      CALL JULDAT(DATE,ZERO,JD0H)
      T0=(JD0H-2415020.D0)/36525.D0
      THETA0=0.276919398D0+100.0021359D0*T0+0.000001075D0*T0*T0
      PE=DINT(THETA0)
      THETA0=THETA0-PE
      ST0HG=THETA0*24.D0
C
C ... now do the conversion UT -> ST (MEAN SIDEREAL TIME)
C
C ... REFERENCE : THE ASTRONOMICAL ALMANAC 1983, P B7
C ... IN 1983: 1 MEAN SOLAR DAY = 1.00273790931 MEAN SIDEREAL DAYS
C ... ST WITHOUT EQUATION OF EQUINOXES CORRECTION => ACCURACY +/- 1 SEC
C
      STG=ST0HG+UTR*1.00273790931D0
      IF (STG.LT.DL) STG=STG+24.D0
      STR=STG-DL
      IF (STR.GE.24.D0) STR=STR-24.D0
      STR = STR*PI/12.D0                                 ! ST in radians
C
      HAR=STR-ALP                                     ! hour angle of observation
      EDV=-0.4654D0*DSIN(HAR)*DCOS(DEL)*DCOS(PHI)
C
C ... the total correction (in km/s) is the sum of orbital and diurnal components
C
      HERV=HEOV+EDV
      BERV=BEOV+EDV
C
C ... Calculation of the barycentric and heliocentric correction times
C ... (BCT and HCT) requires knowledge of the earth's position in its
C ... orbit. Subroutine BARCOR returns the rectangular barycentric (DCORB)
C ... and heliocentric (DCORH) coordinates.
C
      CALL BARCOR(DCORH,DCORB)
C
C ... from this, the correction times (in days) can be determined:
C ... (REFERENCE: THE ASTRONOMICAL ALMANAC 1982 PAGE:B16)
C
      BCT=+0.0057756D0*(DCORB(1)*DCOS(ALP)*DCOS(DEL)+
     1                DCORB(2)*DSIN(ALP)*DCOS(DEL)+
     2                DCORB(3)*          DSIN(DEL))
      HCT=+0.0057756D0*(DCORH(1)*DCOS(ALP)*DCOS(DEL)+
     1                DCORH(2)*DSIN(ALP)*DCOS(DEL)+
     2                DCORH(3)*          DSIN(DEL))
C
C ... write results to keywords
C
      CALL STKWRD('OUTPUTD',BCT,1,1,KUN,STAT)    ! barycentric correction time
      CALL STKWRD('OUTPUTD',HCT,2,1,KUN,STAT)    ! heliocentric correction time
      RBUF(1) = BERV                             ! barocentric RV correction
      RBUF(2) = HERV                             ! heliocentric RV correction
C ... (note that EDV is already contained in both BERV and HERV)
      RBUF(3) = EDV                              ! diurnal RV correction
      CALL STKWRR('OUTPUTR',RBUF,1,3,KUN,STAT)
      GOTO 9000
C 
C  *****************************************************
C
C  here we handle COMPUTE/PRECESSION
C 
C  *****************************************************
C
2000  SIGNS = '++'
      DO 2100 N=1,3
         DATE0(N) = RBUF(N)
         DATE1(N) = RBUF(N+3)
         A0(N) = RBUF(N+6)
         D0(N) = RBUF(N+9)
2100  CONTINUE
C
C ... convert equinoxes to real years
C
      CALL JULDAT(DATE0,ZERO,JD)
      DATE00(1)=DATE0(1)
      CALL JULDAT(DATE00,ZERO,JD00)
      EQX0=DATE0(1)+(JD-JD00)/365.25D0
C
      CALL JULDAT(DATE1,ZERO,JD)
      DATE00(1)=DATE1(1)
      CALL JULDAT(DATE00,ZERO,JD00)
      EQX1=DATE1(1)+(JD-JD00)/365.25D0
C
C ... check if equinoxes are in fact different
C
      CALL STKWRD('OUTPUTD',EQX0,1,1,KUN,STAT)
      CALL STKWRD('OUTPUTD',EQX1,2,1,KUN,STAT)
      IF (ABS(EQX0-EQX1).LT.DSMALL) THEN
         CALL STTPUT
     +   ('Equinoxes identical - no precession applied',STAT)
         CALL STKWRR('OUTPUTR',RBUF(7),1,7,KUN,STAT)
         GOTO 9000
      ENDIF
C
C ... convert right ascension and declination to real radians
C
      A0R = (A0(1)*3600D0+A0(2)*60D0+A0(3))*PI/(12.*3600.)
      IF ((D0(1).LT.0.0) .OR.
     +    (D0(2).LT.0.0) .OR.
     +    (D0(3).LT.0.0) .OR.
     +    (INPSGN(1:1).EQ.'-')) THEN           !take care of -0  ...!
         SIGNS(1:1) = '-'
         D0(1) = ABS(D0(1))
         D0(2) = ABS(D0(2))
         D0(3) = ABS(D0(3))
      ENDIF
      D0R = (D0(1)*3600.D0+D0(2)*60.D0+D0(3))
     +      * PI/(3600.0D0*180.0D0)
      IF (SIGNS(1:1).EQ.'-') D0R = -D0R
C
C ... subroutine PRE computes the precession
C
      CALL PRE(A0R,D0R,A1R,D1R,EQX0,EQX1)
C
C ... convert precessed right ascension to hours, minutes, seconds
C
      A1R   = A1R*12/PI                  ! convert R.A. to real hours
      A1(1) = DINT(A1R)
      R1    = (A1R-A1(1))*60.
      A1(2) = DINT(R1)
      A1(3) = (R1-A1(2))*60
C
C ... convert precessed declination to degrees, minutes, seconds
C ... take care of sign
C
      IF (D1R.LT.0.D0) THEN
         SIGNS(1:1) = '-'
         D1R = -D1R
      ELSE
         SIGNS(1:1) = '+'
      ENDIF
      D1R = D1R*180./PI            ! convert decl. to real degrees
      D1(1) = DINT(D1R)
      R1 = (D1R-D1(1))*60.
      D1(2) = DINT(R1)
      D1(3) = (R1-D1(2))*60
      IF (SIGNS(1:1).EQ.'-') THEN           ! negative declination
         IF (D1(1).GT.DSMALL) THEN
            D1(1) = -D1(1)
         ELSE IF (D1(2).GT.DSMALL) THEN
            D1(2) = -D1(2)
         ELSE
            D1(3) = -D1(3)
         ENDIF
      ENDIF
C
C ... write results to keyword
C
      CALL STKWRC('SIGN',1,SIGNS(1:1),1,1,KUN,STAT)         !communicate sign
      CALL STKWRR('OUTPUTR',A1,1,3,KUN,STAT)
      CALL STKWRR('OUTPUTR',D1,4,3,KUN,STAT)
C
C ... finish off
C
9000  CALL STSEPI
      END

      SUBROUTINE PRE(A0,D0,A1,D1,EQX0,EQX1)
C
C ... calculate general precession for two given epochs
C
C ... References: STUMPFF P.,ASTRON. ASTROPHYS. SUPPL. 41, P. 1 (1980)
C ...             EXPLAN. SUPPL. ASTRON. EPHEREMERIS, P. 28 (1961)
C
      IMPLICIT NONE             !REAL*8 (A-H,O-Z)
C
      DOUBLE PRECISION A0,D0,D1,EQX0,EQX1
      
C      DOUBLE PRECISION DT0,DT,DTS,DTC,DC1900,DC1M2
      DOUBLE PRECISION DT0,DT,DTS,DTC,DC2000,DC1M2
      DOUBLE PRECISION DC1,DC2,DC3,DC4,DC5,DC6,DC7,DC8,DC9
      DOUBLE PRECISION DZED,DZETA,DCSAR,DTHETA
      DOUBLE PRECISION PI,SINR,COSR,A1,R
C
C      DATA DCSAR/4.848136812D-6/,DC1900/1900.0D0/,
C     * DC1M2/0.01D0/,
C     * DC1/2304.25D0/,DC2/1.396D0/,DC3/0.302D0/,DC4/0.018D0/,
C     * DC5/0.791D0/,DC6/2004.683D0/,DC7/-0.853D0/,DC8/-0.426D0/,
C     * DC9/-0.042D0/

      DATA DCSAR/4.84813681109535994D-6/,
     * DC2000/2000.0D0/,
     * DC1M2/0.01D0/,
     * DC1/2306.2181D0/,
     * DC2/1.39656D0/,
     * DC3/0.30188D0/,
     * DC4/0.018203D0/,
     * DC5/0.791D0/,
     * DC6/2004.3109D0/,
     * DC7/-0.85330D0/,
     * DC8/-0.42665D0/,
     * DC9/-0.041833D0/
     
     
C
      PI = 3.1415926535897928D0
C
C ... first determine the precession angles zeta, z and theta
C
C     DT0=(EQX0-DC1900)*DC1M2
      DT0=(EQX0-DC2000)*DC1M2
      DT=(EQX1-EQX0)*DC1M2
      DTS=DT*DT
      DTC=DTS*DT
      DZETA=((DC1+DC2*DT0)*DT+DC3*DTS+DC4*DTC)*DCSAR
      DZED=DZETA + DC5*DTS*DCSAR
      DTHETA=((DC6+DC7*DT0)*DT+DC8*DTS+DC9*DTC)*DCSAR
C
C ... with these and A0,D0 compute the precessed coordinates A1,D1
C
      D1 = ASIN(DCOS(DTHETA)*DSIN(D0)+DSIN(DTHETA)*DCOS(D0)*
     1                                              DCOS(A0+DZETA))
      SINR = (DCOS(D0)*DSIN(A0+DZETA))/DCOS(D1)
      COSR = (DCOS(DTHETA)*DCOS(D0)*DCOS(A0+DZETA)-
     1                         DSIN(DTHETA)*DSIN(D0))/DCOS(D1)
      R = DASIN(SINR)
      IF (COSR.LT.0) R=PI-R                ! determine quadrant of R
      A1 = R+DZED                      ! this is the precessed R.A.
      IF (A1.GT.2.0D0*PI) A1=A1-2.0D0*PI
      IF (A1.LT.0.0D0) A1=A1+2.0D0*PI
C
      RETURN
      END

      SUBROUTINE BARVEL(DJE,DEQ,DVELH,DVELB)
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C   PURPOSE : compute rectangular heliocentric and barycentric components of
C             the earth's orbital velocity
C
C   REFERENCE : STUMPFF P. ASTRON. ASTOPHYS. SUPPL. 41,1,1980
C               MODIFICATION : D. GILLET 1983-9-15
C
C   OTHER ROUTINES CALLED : PRE   (calculates matrix of general precession)
C
C-------------------------------------------------------------------------------
C
      IMPLICIT NONE                            !REAL*8 (A-H,O-Z)
C
      DOUBLE PRECISION   DJE,DEQ,DVELH(3),DVELB(3),SN(4)
      DOUBLE PRECISION   DT,DTL,DCT0,DCJUL,DTSQ,DLOCAL,DC2PI,CC2PI
      DOUBLE PRECISION   DRD,DRLD,DCSLD,DC1
      DOUBLE PRECISION   DXBD,DYBD,DZBD,DZHD,DXHD,DYHD
      DOUBLE PRECISION   DYAHD,DZAHD,DYABD,DZABD
      DOUBLE PRECISION   DML,DEPS,PHI,PHID,PSID,DPARAM,PARAM
      DOUBLE PRECISION   CCFDI,CCKM,CCMLD,PLON,POMG,PECC
      DOUBLE PRECISION   PERTL,PERTLD,PERTRD,PERTP,PERTR,PERTPD
      DOUBLE PRECISION   SINA,CCSGD,DC1MME,TL
      DOUBLE PRECISION   CCSEC3,COSA,ESQ
      DOUBLE PRECISION   DCFEL(3,8),DCEPS(3),CCSEL(3,17),DCARGS(2,15)
      DOUBLE PRECISION   CCAMPS(5,15),CCSEC(3,4),DCARGM(2,3)
      DOUBLE PRECISION   CCAMPM(4,3),CCPAMV(4)
      DOUBLE PRECISION   A,B,E,F,G,SINF,COSF,T,TSQ,TWOE,TWOG
C
      DOUBLE PRECISION   DPREMA(3,3),DPSI,D1PDRO,DSINLS
      DOUBLE PRECISION   DCOSLS,DSINEP,DCOSEP
      DOUBLE PRECISION   FORBEL(7),SORBEL(17),SINLP(4),COSLP(4)
      DOUBLE PRECISION   SINLM,COSLM,SIGMA
C
      INTEGER     IDEQ,K,N
C
      COMMON /BARXYZ/    DPREMA,DPSI,D1PDRO,DSINLS,DCOSLS,
     +                   DSINEP,DCOSEP,FORBEL,SORBEL,SINLP,
     +                   COSLP,SINLM,COSLM,SIGMA,IDEQ
C
      EQUIVALENCE (SORBEL(1),E),(FORBEL(1),G)
C
      DATA DC2PI/6.2831853071796D0/,CC2PI/6.283185/,
     *DC1/1.0D0/,DCT0/2415020.0D0/,DCJUL/36525.0D0/
C
      DATA DCFEL/ 1.7400353D+00, 6.2833195099091D+02, 5.2796D-06,
     *            6.2565836D+00, 6.2830194572674D+02,-2.6180D-06,
     *            4.7199666D+00, 8.3997091449254D+03,-1.9780D-05,
     *            1.9636505D-01, 8.4334662911720D+03,-5.6044D-05,
     *            4.1547339D+00, 5.2993466764997D+01, 5.8845D-06,
     *            4.6524223D+00, 2.1354275911213D+01, 5.6797D-06,
     *            4.2620486D+00, 7.5025342197656D+00, 5.5317D-06,
     *            1.4740694D+00, 3.8377331909193D+00, 5.6093D-06/
C
      DATA DCEPS/ 4.093198D-01,-2.271110D-04,-2.860401D-08/
C
      DATA CCSEL/ 1.675104D-02,-4.179579D-05,-1.260516D-07,
     *            2.220221D-01, 2.809917D-02, 1.852532D-05,
     *            1.589963D+00, 3.418075D-02, 1.430200D-05,
     *            2.994089D+00, 2.590824D-02, 4.155840D-06,
     *            8.155457D-01, 2.486352D-02, 6.836840D-06,
     *            1.735614D+00, 1.763719D-02, 6.370440D-06,
     *            1.968564D+00, 1.524020D-02,-2.517152D-06,
     *            1.282417D+00, 8.703393D-03, 2.289292D-05,
     *            2.280820D+00, 1.918010D-02, 4.484520D-06,
     *            4.833473D-02, 1.641773D-04,-4.654200D-07,
     *            5.589232D-02,-3.455092D-04,-7.388560D-07,
     *            4.634443D-02,-2.658234D-05, 7.757000D-08,
     *            8.997041D-03, 6.329728D-06,-1.939256D-09,
     *            2.284178D-02,-9.941590D-05, 6.787400D-08,
     *            4.350267D-02,-6.839749D-05,-2.714956D-07,
     *            1.348204D-02, 1.091504D-05, 6.903760D-07,
     *            3.106570D-02,-1.665665D-04,-1.590188D-07/
C
      DATA DCARGS/ 5.0974222D+00,-7.8604195454652D+02,
     *             3.9584962D+00,-5.7533848094674D+02,
     *             1.6338070D+00,-1.1506769618935D+03,
     *             2.5487111D+00,-3.9302097727326D+02,
     *             4.9255514D+00,-5.8849265665348D+02,
     *             1.3363463D+00,-5.5076098609303D+02,
     *             1.6072053D+00,-5.2237501616674D+02,
     *             1.3629480D+00,-1.1790629318198D+03,
     *             5.5657014D+00,-1.0977134971135D+03,
     *             5.0708205D+00,-1.5774000881978D+02,
     *             3.9318944D+00, 5.2963464780000D+01,
     *             4.8989497D+00, 3.9809289073258D+01,
     *             1.3097446D+00, 7.7540959633708D+01,
     *             3.5147141D+00, 7.9618578146517D+01,
     *             3.5413158D+00,-5.4868336758022D+02/
C
      DATA CCAMPS/
     *-2.279594D-5, 1.407414D-5, 8.273188D-6, 1.340565D-5,-2.490817D-7,
     *-3.494537D-5, 2.860401D-7, 1.289448D-7, 1.627237D-5,-1.823138D-7,
     * 6.593466D-7, 1.322572D-5, 9.258695D-6,-4.674248D-7,-3.646275D-7,
     * 1.140767D-5,-2.049792D-5,-4.747930D-6,-2.638763D-6,-1.245408D-7,
     * 9.516893D-6,-2.748894D-6,-1.319381D-6,-4.549908D-6,-1.864821D-7,
     * 7.310990D-6,-1.924710D-6,-8.772849D-7,-3.334143D-6,-1.745256D-7,
     *-2.603449D-6, 7.359472D-6, 3.168357D-6, 1.119056D-6,-1.655307D-7,
     *-3.228859D-6, 1.308997D-7, 1.013137D-7, 2.403899D-6,-3.736225D-7,
     * 3.442177D-7, 2.671323D-6, 1.832858D-6,-2.394688D-7,-3.478444D-7,
     * 8.702406D-6,-8.421214D-6,-1.372341D-6,-1.455234D-6,-4.998479D-8,
     *-1.488378D-6,-1.251789D-5, 5.226868D-7,-2.049301D-7, 0.0D0,
     *-8.043059D-6,-2.991300D-6, 1.473654D-7,-3.154542D-7, 0.0D0,
     * 3.699128D-6,-3.316126D-6, 2.901257D-7, 3.407826D-7, 0.0D0,
     * 2.550120D-6,-1.241123D-6, 9.901116D-8, 2.210482D-7, 0.0D0,
     *-6.351059D-7, 2.341650D-6, 1.061492D-6, 2.878231D-7, 0.0D0/
C
      DATA CCSEC3/-7.757020D-08/
C
      DATA CCSEC/ 1.289600D-06, 5.550147D-01, 2.076942D+00,
     *            3.102810D-05, 4.035027D+00, 3.525565D-01,
     *            9.124190D-06, 9.990265D-01, 2.622706D+00,
     *            9.793240D-07, 5.508259D+00, 1.559103D+01/
C
      DATA DCSLD/ 1.990987D-07/, CCSGD/ 1.990969D-07/
C
      DATA CCKM/3.122140D-05/, CCMLD/2.661699D-06/, CCFDI/2.399485D-07/
C
      DATA DCARGM/ 5.1679830D+00, 8.3286911095275D+03,
     *             5.4913150D+00,-7.2140632838100D+03,
     *             5.9598530D+00, 1.5542754389685D+04/
C
      DATA CCAMPM/
     *  1.097594D-01, 2.896773D-07, 5.450474D-02, 1.438491D-07,
     * -2.223581D-02, 5.083103D-08, 1.002548D-02,-2.291823D-08,
     *  1.148966D-02, 5.658888D-08, 8.249439D-03, 4.063015D-08/
C
      DATA CCPAMV/8.326827D-11,1.843484D-11,1.988712D-12,1.881276D-12/,
     *     DC1MME/0.99999696D0/
C
      IDEQ=DEQ
      DT=(DJE-DCT0)/DCJUL
      T=DT
      DTSQ=DT*DT
      TSQ=DTSQ
      DO 100, K=1,8
         DLOCAL=DMOD(DCFEL(1,K)+DT*DCFEL(2,K)+DTSQ*DCFEL(3,K),DC2PI)
         IF (K.EQ.1)  DML=DLOCAL
         IF (K.NE.1)  FORBEL(K-1)=DLOCAL
  100 CONTINUE
      DEPS=DMOD(DCEPS(1)+DT*DCEPS(2)+DTSQ*DCEPS(3), DC2PI)
      DO 200, K=1,17
         SORBEL(K)=DMOD(CCSEL(1,K)+T*CCSEL(2,K)+TSQ*CCSEL(3,K),CC2PI)
  200 CONTINUE
      DO 300, K=1,4
         A=DMOD(CCSEC(2,K)+T*CCSEC(3,K),CC2PI)
         SN(K)=DSIN(A)
  300 CONTINUE
      PERTL =  CCSEC(1,1)          *SN(1) +CCSEC(1,2)*SN(2)
     *       +(CCSEC(1,3)+T*CCSEC3)*SN(3) +CCSEC(1,4)*SN(4)
      PERTLD=0.0
      PERTR =0.0
      PERTRD=0.0
C
      DO 400, K=1,15
         A=DMOD(DCARGS(1,K)+DT*DCARGS(2,K), DC2PI)
         COSA=DCOS(A)
         SINA=DSIN(A)
         PERTL =PERTL+CCAMPS(1,K)*COSA+CCAMPS(2,K)*SINA
         PERTR =PERTR+CCAMPS(3,K)*COSA+CCAMPS(4,K)*SINA
         IF (K.GE.11) GO TO 400
         PERTLD=PERTLD+(CCAMPS(2,K)*COSA-CCAMPS(1,K)*SINA)*CCAMPS(5,K)
         PERTRD=PERTRD+(CCAMPS(4,K)*COSA-CCAMPS(3,K)*SINA)*CCAMPS(5,K)
  400 CONTINUE
      ESQ=E*E
      DPARAM=DC1-ESQ
      PARAM=DPARAM
      TWOE=E+E
      TWOG=G+G
      PHI=TWOE*((1.0-ESQ*0.125D0)*DSIN(G)+E*0.625D0*DSIN(TWOG)
     *          +ESQ*0.5416667D0*DSIN(G+TWOG) )
      F=G+PHI
      SINF=DSIN(F)
      COSF=DCOS(F)
      DPSI=DPARAM/(DC1+E*COSF)
      PHID=TWOE*CCSGD*((1.0+ESQ*1.5D0)*COSF+E*(1.25D0-SINF*SINF*0.5D0))
      PSID=CCSGD*E*SINF/SQRT(PARAM)
      D1PDRO=(DC1+PERTR)
      DRD=D1PDRO*(PSID+DPSI*PERTRD)
      DRLD=D1PDRO*DPSI*(DCSLD+PHID+PERTLD)
      DTL=DMOD(DML+PHI+PERTL, DC2PI)
      DSINLS=DSIN(DTL)
      DCOSLS=DCOS(DTL)
      DXHD = DRD*DCOSLS-DRLD*DSINLS
      DYHD = DRD*DSINLS+DRLD*DCOSLS
      PERTL =0.0
      PERTLD=0.0
      PERTP =0.0
      PERTPD=0.0
C
      DO 500 K=1,3
         A=DMOD(DCARGM(1,K)+DT*DCARGM(2,K), DC2PI)
         SINA  =DSIN(A)
         COSA  =DCOS(A)
         PERTL =PERTL +CCAMPM(1,K)*SINA
         PERTLD=PERTLD+CCAMPM(2,K)*COSA
         PERTP =PERTP +CCAMPM(3,K)*COSA
         PERTPD=PERTPD-CCAMPM(4,K)*SINA
  500 CONTINUE
      TL=FORBEL(2)+PERTL
      SINLM=DSIN(TL)
      COSLM=DCOS(TL)
      SIGMA=CCKM/(1.0+PERTP)
      A=SIGMA*(CCMLD+PERTLD)
      B=SIGMA*PERTPD
      DXHD=DXHD+A*SINLM+B*COSLM
      DYHD=DYHD-A*COSLM+B*SINLM
      DZHD=    -SIGMA*CCFDI*DCOS(FORBEL(3))
      DXBD=DXHD*DC1MME
      DYBD=DYHD*DC1MME
      DZBD=DZHD*DC1MME
      DO 600 K=1,4
         PLON=FORBEL(K+3)
         POMG=SORBEL(K+1)
         PECC=SORBEL(K+9)
         TL=DMOD(PLON+2.0*PECC*DSIN(PLON-POMG), CC2PI)
         SINLP(K)=DSIN(TL)
         COSLP(K)=DCOS(TL)
         DXBD=DXBD+CCPAMV(K)*(SINLP(K)+PECC*DSIN(POMG))
         DYBD=DYBD-CCPAMV(K)*(COSLP(K)+PECC*DCOS(POMG))
         DZBD=DZBD-CCPAMV(K)*SORBEL(K+13)*DCOS(PLON-SORBEL(K+5))
  600 CONTINUE
      DCOSEP=DCOS(DEPS)
      DSINEP=DSIN(DEPS)
      DYAHD=DCOSEP*DYHD-DSINEP*DZHD
      DZAHD=DSINEP*DYHD+DCOSEP*DZHD
      DYABD=DCOSEP*DYBD-DSINEP*DZBD
      DZABD=DSINEP*DYBD+DCOSEP*DZBD
      DVELH(1)=DXHD
      DVELH(2)=DYAHD
      DVELH(3)=DZAHD
      DVELB(1)=DXBD
      DVELB(2)=DYABD
      DVELB(3)=DZABD
      DO 800 N=1,3
         DVELH(N)=DVELH(N)*1.4959787D8
         DVELB(N)=DVELB(N)*1.4959787D8
  800 CONTINUE
C
      RETURN
      END

      SUBROUTINE BARCOR(DCORH,DCORB)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C   PURPOSE : calculate rectangular barycentric and heliocentric coordinates
C             of the earth
C
C   REFERENCE : STUMPFF,P.,ASTRON. ASTROPHYS. SUPPL. 41,1,1980
C               MODIFICATION : D. GILLET 1983-9-15
C
C   AUXILIARY ROUTINES CALLED : BARVEL,PRE
C
C-------------------------------------------------------------------------------
C
      IMPLICIT NONE                                    !REAL*8 (A-H,O-Z)
C
      DOUBLE PRECISION  DCORH(3),DCORB(3),CCPAM(4)
      DOUBLE PRECISION  DR,CCIM,FLAT,FLATM
      DOUBLE PRECISION  DXH,DYH,DZH,DXB,DYB,DZB
      DOUBLE PRECISION  DYAH,DZAH,DYAB,DZAB
      DOUBLE PRECISION  A,B
      DOUBLE PRECISION  DC1MME
C
      DOUBLE PRECISION  DPREMA(3,3),DPSI,D1PDRO,DSINLS,DCOSLS
      DOUBLE PRECISION  DSINEP,DCOSEP,FORBEL(7),SORBEL(17),SINLP(4)
      DOUBLE PRECISION  COSLP(4),SINLM,COSLM,SIGMA
C
      INTEGER   IDEQ,K,N
C
      COMMON /BARXYZ/   DPREMA,DPSI,D1PDRO,DSINLS,DCOSLS,
     +                  DSINEP,DCOSEP,FORBEL,SORBEL,SINLP,
     +                  COSLP,SINLM,COSLM,SIGMA,IDEQ
C
      DATA CCPAM/4.960906D-3,2.727436D-3,8.392311D-4,1.556861D-3/,
     *     CCIM /8.978749D-2/, DC1MME/0.99999696D0/
C
      DR=DPSI*D1PDRO
      FLATM=CCIM*DSIN(FORBEL(3))
      A=SIGMA*DCOS(FLATM)
      DXH=DR*DCOSLS-A*COSLM
      DYH=DR*DSINLS-A*SINLM
      DZH=         -SIGMA*DSIN(FLATM)
      DXB=DXH*DC1MME
      DYB=DYH*DC1MME
      DZB=DZH*DC1MME
      DO 10, K=1,4
         FLAT=SORBEL(K+13)*DSIN(FORBEL(K+3)-SORBEL(K+5))
         A=CCPAM(K)*(1.0-SORBEL(K+9)*DCOS(FORBEL(K+3)-SORBEL(K+1)))
         B=A*DCOS(FLAT)
         DXB=DXB-B*COSLP(K)
         DYB=DYB-B*SINLP(K)
         DZB=DZB-A*DSIN(FLAT)
10    CONTINUE
      DYAH=DCOSEP*DYH-DSINEP*DZH
      DZAH=DSINEP*DYH+DCOSEP*DZH
      DYAB=DCOSEP*DYB-DSINEP*DZB
      DZAB=DSINEP*DYB+DCOSEP*DZB
      IF(IDEQ.NE.0) GO TO 20
C
      DCORH(1)=DXH
      DCORH(2)=DYAH
      DCORH(3)=DZAH
      DCORB(1)=DXB
      DCORB(2)=DYAB
      DCORB(3)=DZAB
      RETURN
C
20    DO 30, N=1,3
         DCORH(N)=DXH*DPREMA(N,1)+DYAH*DPREMA(N,2)+DZAH*DPREMA(N,3)
         DCORB(N)=DXB*DPREMA(N,1)+DYAB*DPREMA(N,2)+DZAB*DPREMA(N,3)
30    CONTINUE
C
      RETURN
      END

      SUBROUTINE JULDAT(INDATE,UTR,JD)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  FORTRAN subroutine                    JULDAT     version 1.0       870102
C  original coding:                      D. Gillet        ESO - Garching
C  variables renamed and restructured:   D. Baade         ST-ECF, Garching
C
C.KEYWORDS
C  geocentric Julian date
C
C.PURPOSE
C  calculate geocentric Julian date for any civil date (time in UT)
C
C.ALGORITHM
C adapted from MEEUS J.,1980, ASTRONOMICAL FORMULAE FOR CALCULATORS
C
C.INPUT/OUTPUT
C the following are passed from and to the calling program:
C  INDATE(3)    :         civil date as year,month,day OR year.fraction
C  UT           :         universal time expressed in real hours
C  JD           :         real geocentric Julian date
C
C.REVISIONS
C made to accept also REAL dates         D. Baade             910408
C
C-------------------------------------------------------------------------------
C
      IMPLICIT NONE
C
      DOUBLE PRECISION YP,P,C,A,UT
      DOUBLE PRECISION UTR,JD
C
      INTEGER  STAT,IA,IB,IC,ND,DATE(3)
C
      REAL    INDATE(3),FRAC
C
      UT=UTR / 24.0D0
C
C CHECK FORMAT OF DATE: may be either year,month,date OR year.fraction,0,0 
C (Note that the fraction of the year must NOT include fractions of a day.)
C For all other formats exit and terminate also calling command sequence.
C
      IF ((INDATE(1)-INT(INDATE(1))).GT.1.0E-6) THEN 
         IF ((INDATE(2).GT.1.0E-6).OR.(INDATE(3).GT.1.0E-6)) 
     +       CALL   STETER(1,'Error: Date was entered in wrong format.')
C
C copy date input buffer copy to other buffer so that calling program 
C does not notice any changes
C
C FIRST CASE: format was year.fraction
C
         DATE(1)=INT(INDATE(1))
         FRAC=INDATE(1)-DATE(1)
         DATE(2)=1
         DATE(3)=1
      ELSE
C
C SECOND CASE: format was year,month,day
C
         DATE(1)=NINT(INDATE(1))
         FRAC=0
         DATE(2)=NINT(INDATE(2))
         DATE(3)=NINT(INDATE(3))
         IF ((DATE(2).EQ.0).AND.(DATE(3).EQ.0)) THEN
             DATE(2)=1
             DATE(3)=1 
         ENDIF
         IF ((DATE(2).LT.1).OR.(DATE(2).GT.12))
     +   CALL STETER(1,'Error: such a month does not exist')
         IF ((DATE(3).LT.1).OR.(DATE(3).GT.31))
     +   CALL STETER(1,'Error: such a day does not exist')
      ENDIF
C
C from here on, the normal procedure applies which is based on the 
C format year,month,day:
C
      IF (DATE(2) .GT. 2) THEN
         YP=DATE(1)
         P=DATE(2)
      ELSE
         YP=DATE(1)-1
         P=DATE(2)+12.0
      ENDIF
C
      C = DATE(1) + DATE(2)*1.D-2 + DATE(3)*1.D-4 + UT*1.D-6
      IF (C .GE. 1582.1015D0) THEN
         IA=IDINT(YP/100.D0)
         A=DBLE(IA)
         IB=2-IA+IDINT(A/4.D0)
      ELSE
         IB=0
      ENDIF
C
      JD = DINT(365.25D0*YP) + DINT(30.6001D0*(P+1.D0)) + DATE(3) + UT
     *        + DBLE(IB) + 1720994.5D0
C
C finally, take into account fraction of year (if any), respect leap
C year conventions
C
      IF (FRAC.GT.1.0E-6) THEN
         ND=365
         IF (C.GE.1582.1015D0) THEN
            IC = MOD(DATE(1),4)
            IF (IC.EQ.0) THEN
               ND=366
               IC = MOD(DATE(1),100)
               IF (IC.EQ.0) THEN
                  IC = MOD(DATE(1),400)
                  IF (IC.NE.0) ND=365
               ENDIF
            ENDIF
         ENDIF
C
         IF (ABS(FRAC*ND-NINT(FRAC*ND)).GT.0.3) THEN
            CALL STTPUT
     +      ('Warning: Fraction of year MAY not correspond to ',STAT)
            CALL STTPUT('         integer number of days.',STAT)
         ENDIF
C
         JD = JD+NINT(FRAC*ND)
      ENDIF
C
      RETURN
      END

C @(#)stgrnt.for	19.1 (ES0-DMD) 02/25/03 13:25:40
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine STGRNT         version 1.1       830920
C  A. Kruszewski             ESO Garching
C.KEYWORDS
C  profiles
C.PURPOSE
C  updates lowest KSRG values of standart stellar profile "STPR"
C.ALGORYTHM
C  for each annular ring with K<=KSGR the subroutine finds a maximum
C  in histogram of values: LOG10(PRFL(K-1)/PRFL(K)) in a range
C  of values from STPR(K)-0.15 to STPR(K)+0.15.
C  therefore an intial value of standart stellar profile "STPR" should
C  be within 0.15 from its true value for obtaining good results.
C.INPUT/OUTPUT
C  input arguments
C  PRCT        real*4 array      catalog of observed profiles
C  M           integer*4         number of catalogued objects
C  KSGR        integer*4         number of updated values of standard
C                                profile
C  HHCUT       real*4            upper limit for used observed profiles
C  TRSH        real*4            limiting lower treshold
C  CRMD        real*4 array      control parameters for subroutine
C                                "MODE"
C  STPR        real*4 array      standard stellar profile
C  output parameters
C  STPR        real*4 array      standard stellar profile
C-----------------------------------------------------------------------
      SUBROUTINE STGRNT(L0, L1, LW, NREG, LSTP,
     &                  NCAT, PMTR, PRCT, KSGR, HHCUT,
     &                  TRSH, UPGR, CRMD, STPR)
C
      IMPLICIT  NONE
      INCLUDE   'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER   L0
      INTEGER   L1
      INTEGER   LW
      INTEGER   NREG
      INTEGER   LSTP(0:4,0:NREG)
      INTEGER   NCAT(NIPAR,MAXCNT)
      REAL      PMTR(NRPAR,MAXCNT)
      REAL      PRCT(0:MAXSUB,MAXCNT)
      INTEGER   KSGR
      REAL      HHCUT
      REAL      TRSH
      REAL      UPGR
      REAL      CRMD(3)
      REAL      STPR(MAXSUB)
C
      INTEGER   M, MM
      INTEGER   L, LZ	
      INTEGER   K, KK
      INTEGER   ICNT(MAXSUB)
      REAL      HHHC
      REAL      RLPR(MPSF,MAXSUB)
      REAL      SIGMA, SCR
C     REAL      FCT(MAXSUB)
C
C *** M is number of objects.
C
      M = MAX( L1 , LW )
C      MARK = 1
C
C *** Set lower limit of central intensity in used objects.
C
      HHHC = MIN( 0.05*HHCUT , 5.0*TRSH )
C
C *** Prepares array of usable values of local gradient RLPR.
C *** Array ICNT hold number of usable values for each annular ring.
C
c      DO 10 K = 1 , 3
c          FCT(K) = 3.0 * HHHC
c   10 CONTINUE
c      DO 20 K = 4 , MAXSUB
c          FCT(K) = 10.0 * HHHC / FLOAT(K)
c   20 CONTINUE
c      DO 30 K = 1 , MAXSUB
c          ICNT(K)=0
c   30 CONTINUE
      DO 40 L = 1 , M
C          IF ( L .GT. L1 .OR. L .LE. L0 ) THEN
C              IOCOD = -1
C              CALL PARFIL( ISF , L , L0 , L1 , LW ,
C     &                     IOCOD , MARK , NCAT , PMTR , PRCT )
C              MARK = 0
C          ENDIF
          LZ = L - L0
          IF ( PRCT(0,LZ) .GT. HHHC ) THEN
              K = 1
   51         CONTINUE
                  IF ( PRCT(K,LZ) .LE. 0.0 .OR. K .GT. KSGR ) GOTO 50
                  IF ( PRCT(K-1,LZ) .LT. HHCUT ) THEN
                      SCR = ALOG10(PRCT(K-1,LZ)/PRCT(K,LZ))
                      IF ( ABS( SCR-STPR(K) ) .LT. UPGR
     &                               .AND. ICNT(K) .LT. MPSF ) THEN       
                          ICNT(K) = ICNT(K) + 1
                          KK = ICNT(K)
                          RLPR(KK,K) = SCR
                      ENDIF
                  ENDIF
                  K = K + 1
                  GOTO 51
   50         CONTINUE
          ENDIF
   40 CONTINUE
C
C *** Calculate updated values of stellar profile.
C
      DO 60 K = 1 , KSGR
          IF ( ICNT(K) .GT. 3 ) THEN
              MM = ICNT(K)
              CALL MODE( RLPR(1,K) , MM , CRMD , STPR(K) , SIGMA )
          ENDIF
   60 CONTINUE
C
      RETURN
C
      END

C @(#)askfil.for	19.1 (ES0-DMD) 02/25/03 13:28:45
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C  @(#)askfil.for	19.1  (ESO-IPG)  02/25/03  13:28:45
      SUBROUTINE ASKFIL(QUERY,REPLY)
C
C       Copyright (C) Andrew T. Young, 1990
C       Copyright (C) European Southern Observatory, 1992
C
C  ASKS THE QUERY ON THE TERMINAL SCREEN AND    28 Sep.,'88
C  ACCEPTS REPLY FROM KEYBOARD.
C       Asks for file names; accept lower case.
C
C  QUITS IF REPLY IS 'Q' OR 'QUIT'.
C
      IMPLICIT NONE
C
      INTEGER ISTAT, NACTEL, IUNIT, NULLS, LWORD
C
      CHARACTER *(*) QUERY,REPLY, A*1
      CHARACTER*80 BUFIN, BUFOUT
C
C
      LOGICAL MATCH
      EXTERNAL MATCH
C
      BUFIN=QUERY
    1 CALL STTPUT(' ',ISTAT)
      CALL STKPRC(BUFIN, 'INPUTC', 1, 1, 80,
     1           NACTEL, BUFOUT, IUNIT, NULLS, ISTAT)
      REPLY=BUFOUT
      IF (ISTAT.NE.0) THEN
                CALL STTPUT('Failed to get string; try again:',ISTAT)
                GO TO 1
      END IF
C   3 FORMAT(/1X,A/)
      IF(LWORD(REPLY).EQ.0) GOTO 1
       IF(MATCH(REPLY,'QUIT').OR.MATCH(REPLY,'quit'))THEN
      CALL ASK('DO YOU WANT TO QUIT?',A)
      IF(A.EQ.'Y'.OR.A.EQ.'Q'.OR.A.EQ.'y'.OR.A.EQ.'q') THEN
        CALL TV('ABANDONED.')
        CALL STSEPI
      END IF
      GO TO 1
       END IF
      RETURN
C
      END

C @(#)mono4.for	19.1 (ES0-DMD) 02/25/03 13:29:44
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE MONO4(IVX,VZ,NP,VP,FS)
C+++++
C.PURPOSE: Fit con gaussiana monodimensionale a 4 parametri:
C          altezza; larghezza; posizione; fondo)
C-----
      IMPLICIT NONE
      INTEGER  IVX(1)
      REAL     VZ(1)
      INTEGER  NP
      REAL     VP(4)
      REAL     FS
C
      INTEGER  I,J, K
      REAL     EPES, EP, CO, FNO
      REAL     FK
      INTEGER  NCD
      REAL     VPR(4)
      REAL     RMT(4,4)
      REAL     VTN(4)
      REAL     VFZ(4)
      REAL     VFF(4)
      REAL     VC(4)
      REAL     SG(4)
C
      DATA    VPR/2.,1.,1.,2./
C
C *** start the code
      DO 10 I = 1,4
         VFF(I) = 0
         VFZ(I) = 0
         VC(I)  = 0
         DO 20 J = 1,4
            RMT(I,J) = 0
   20    CONTINUE
   10 CONTINUE

      FK     = -4.*ALOG(2.)/(VP(3)**2)
      VTN(4) = 1

      DO 30 K = 1,NP
         EPES   = (IVX(K)-VP(2))**2
         EP     = EXP(EPES*FK)
         CO     = -VP(1)*EP*2.*FK
         VTN(1) = EP
         VTN(2) = CO*(IVX(K)-VP(2))
         VTN(3) = CO*(IVX(K)-VP(2))**2/VP(3)
         FNO    = VP(1)*EP+VP(4)
C
         DO 40 I = 1,4
            VFZ(I) = VFZ(I)+VZ(K)*VTN(I)
            VFF(I) = VFF(I)+FNO*VTN(I)
            DO 50 J = 1,4
               RMT(I,J)=RMT(I,J)+VTN(I)*VTN(J)
   50       CONTINUE
   40    CONTINUE
   30 CONTINUE
C
      DO 60 I = 1,4
         RMT(I,I) = RMT(I,I)*(1+FS**2)
         VC(I)    = VC(I)+VFZ(I)-VFF(I)
   60 CONTINUE
C
      NCD = 4
      CALL LISIB(RMT,VC,4,NCD,SG)
      DO 70  I = 1,4
        VP(I)= VC(I)*VPR(I)+VP(I)
   70 CONTINUE

      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
         PROGRAM HORFRM
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENT         horform.for
C.MODULE
C.AUTHOR        Andrew T. Young
C.KEYWORD
C.LANGUAGE      FORTRAN 77
C.PURPOSE       generate horizon-table forms
C.COMMENTS
C.RETURNS
C.ENVIRONMENT   requires esotel.tbl in local directory
C.VERSION       0.0
C
C 100618	last modif
C-----------------------------------------------------------------------------
C
      IMPLICIT REAL (A-H,O-Z)
      IMPLICIT INTEGER (I-N)
C
C  BEGIN Declarations:
C
        DOUBLE PRECISION DNULL
        COMMON /NULLS/ INULL, RNULL, DNULL
C
        LOGICAL NULL
        INTEGER NOUT,NFILE
        CHARACTER*80 TOP,LINE2,LINE3,LINE4,LINE5,LINE6,GAP,FOOT
        CHARACTER*80 SPACER
        CHARACTER*84 FMT2,FMT3
        CHARACTER*64 GERMAN(2)
        CHARACTER*8 TELNAMES(100),TELESCOP,FMT1,MOUNTING,CTEST
        REAL PHIS(100),PHI,DELTA(0:50)
C
C  Set up MIDAS declarations:
C
        INTEGER MADRID(1)
C
        COMMON /VMR/ MADRID
C
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
C  END Declarations.
C
C
C  BEGIN DATA statements:
C
        INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
        DATA FMT1/'(4X,A76)'/
        DATA NFILE/7/
C
C  END DATA statements.
C
C
C  ********************  PROLOGUE  ********************
C
        CALL STSPRO ('HORFRM')
        OPEN(NFILE,FILE='FORM',STATUS='UNKNOWN')
        REWIND NFILE
C
C  Real program begins here:            (use RUN HORFORM to test in MIDAS)
C
        CALL TBTOPN('esotel.tbl',0,ITBL,ISTAT)
C TBLSER        search for table column with given label; get number
        CALL TBLSER (ITBL, 'TELESCOP',  NCTEL, ISTAT)
         CALL TBLSER (ITBL, 'LAT',  NCLAT, ISTAT)
C
C  find number of rows:
        CALL TBIGET(ITBL, NCOLS, NROWS, NSORTC, NWPRAL, NROWSAL, ISTAT)
C  loop over rows:
        DO 5 NROW=1,NROWS
C        read telnames(nrow):
        CALL TBERDC(ITBL,NROW,NCTEL,CTEST,NULL,ISTAT)
        CALL FT_EOS(CTEST,8,TELNAMES(NROW),ISTAT)
C        read phis(nrow)=LAT:
        CALL TBERDR(ITBL,NROW,NCLAT,PHIS(NROW),NULL,ISTAT)
    5   CONTINUE
C
C       display menu:
C
    6   CALL MENU1('Please choose a telescope:',TELNAMES,NROWS,NOUT)
C STKPRC        prompt user for character-valued keyword data at terminal
        CALL STKPRC ('Please enter your selection:','INPUTC', 1, 1, 8,
     1               NACTEL, TELESCOP, IUNIT, NULLS, ISTAT)
C       convert to caps:
        IDIFF=ICHAR('A')-ICHAR('a')
        DO 8 I=1,8
        IF(ICHAR(TELESCOP(I:I)).GE.ICHAR('a'))
     1     TELESCOP(I:I)=CHAR(ICHAR(TELESCOP(I:I))+IDIFF)
    8   CONTINUE
        DO 10 NROW=1,NROWS
        IF (TELNAMES(NROW) .EQ. TELESCOP) GOTO 20
   10   CONTINUE
C       no match, so assume number was entered:
        READ(TELESCOP,'(I3)',ERR=6) NROW
        IF (NROW.GT.NROWS) GO TO 6
        TELESCOP=TELNAMES(NROW)
   20   PHI=PHIS(NROW)
C
C       Begin converted awk script:
C
        DEGRAD=180./3.1415926535
        ABSPHI=ABS(PHI)
        COSPHI=COS(PHI/DEGRAD)

        MOUNTING=' '
   25   CALL STKPRC ('Is its mounting FORK, GERMAN, or ALTAZ?',
     1               'INPUTC', 1, 1, 6,
     2               NACTEL, MOUNTING, IUNIT, NULLS, ISTAT)
C       convert to caps:
        IDIFF=ICHAR('A')-ICHAR('a')
        DO 28 I=1,6
        IF(ICHAR(MOUNTING(I:I)).GE.ICHAR('a'))
     1     MOUNTING(I:I)=CHAR(ICHAR(MOUNTING(I:I))+IDIFF)
   28   CONTINUE
        IF (MOUNTING.EQ.'FORK') THEN
            TOP(1:)    = '           '//
     +          '__________________________________________________'
            LINE2(1:)  = '           |'//
     +          '        |   Looking  EAST   |   Looking  WEST   |'
            LINE3(1:)  = '           |'//
     +          '        |===================|===================|'
            LINE4(1:)  = '           |'//
     +          '        |   ALL   |  LAST   |   ALL   |  LAST   |'
            LINE5(1:)  = '           |'//
     +          '  DEC.  |  CLEAR  |   SKY   |  CLEAR  |   SKY   |'
            LINE6(1:)  = '           |'//
     +          '        |  (OBSE) | (MOONE) |  (OBSW) | (MOONW) |'
            SPACER(1:) = '           |'//
     +          '--------+---------+---------+---------+---------|'
            GAP(1:)    = '           |'//
     +          '        |         |         |         |         |'
            FOOT(1:)   = '           '//
     +          '=================================================='
            FMT2(1:)   = '(''               |  '',
     + F4.0,''  |         |         |         |         |'')'
            FMT3       = FMT2
            FMT3(65:68)= 'omit'
            FMT3(45:48)= 'omit'
            GERMAN(1)  = ' '
            LOOPS      = 1
C
         ELSE IF (MOUNTING.EQ.'GERMAN') THEN
            TOP(1:)    = '           '//
     +          '__________________________________________________'
            LINE2(1:)  = '           |'//
     +          '        |   Looking  EAST   |   Looking  WEST   |'
            LINE3(1:)  = '           |'//
     +          '        |===================|===================|'
            LINE4(1:)  = '           |'//
     +          '        |   ALL   |  LAST   |   ALL   |  LAST   |'
            LINE5(1:)  = '           |'//
     +          '  DEC.  |  CLEAR  |   SKY   |  CLEAR  |   SKY   |'
            LINE6(1:)  = '           |'//
     +          '        | (TEOBSE)|(TEMOONE)| (TEOBSW)|(TEMOONW)|'
            SPACER(1:) = '           |'//
     +          '--------+---------+---------+---------+---------|'
            GAP(1:)    = '           |'//
     +          '        |         |         |         |         |'
            FOOT(1:)   = '           '//
     +          '=================================================='
            FMT2(1:)   = '(''               |  '',
     + F4.0,''  |         |         |         |         |'')'
            FMT3       = FMT2
            FMT3(65:68)= 'omit'
            FMT3(45:48)= 'omit'
            GERMAN(1)='  T e l e s c o p e   E A S T   o f   p i e r'
            GERMAN(2)='  T e l e s c o p e   W E S T   o f   p i e r'
            LOOPS=2
C
        ELSE IF (MOUNTING.EQ.'ALTAZ') THEN
            TOP(1:)   = '           '//
     +          ' _____________________________________________'
            LINE4(1:) = '            '//
     +          '|             |      ALL     |     LAST     |'
            LINE5(1:) = '            '//
     +          '|   AZIMUTH   |     CLEAR    |      SKY     |'
            LINE6(1:) = '            '//
     +          '|    (AZI)    |   (OBSALT)   |   (MOONALT)  |'
            SPACER(1:)= '            '//
     +          '|-------------+--------------+--------------|'
            GAP(1:)   = '            '//
     +          '|             |              |              |'
            FOOT(1:)  = '           '//
     +          '=============================================='
                DO 36, J=0,35
                        IF (MOD(J,12).EQ.0 ) THEN
                                IF (J.GT.0) THEN        ! BREAK PAGE
                                        WRITE(NFILE,FMT1)FOOT
                                        WRITE(NFILE,'(1H1)')
                                END IF
                                WRITE(NFILE,'(A57,A8)')
     1 ' L I M I T I N G   A L T I T U D E S   f o r  ',TELESCOP
                                WRITE(NFILE,FMT1)
                                WRITE(NFILE,FMT1)TOP
                                WRITE(NFILE,FMT1)GAP
                                WRITE(NFILE,FMT1)LINE4
                                WRITE(NFILE,FMT1)LINE5
                                WRITE(NFILE,FMT1)GAP
                                WRITE(NFILE,FMT1)LINE6
                        END IF
                        WRITE(NFILE,FMT1)SPACER
                        WRITE(NFILE,FMT1)GAP
                        WRITE(NFILE,'(''                |     '',I3,
     +           ''     |              |             |'')')J*10
                        WRITE(NFILE,FMT1)GAP
   36           CONTINUE
                WRITE(NFILE,FMT1)FOOT
                I=0
                CALL STTPUT('Done!',NOUT)
                CALL STTPUT(' ',NOUT)
                CALL STTPUT(' --> Don''t forget to print the file FORM',
     1                      NOUT)
                CALL STTPUT(' ',NOUT)
                CALL STSEPI
        ELSE
                CALL STTPUT('Please reply FORK or GERMAN or ALTAZ only.'
     1                     ,NOUT)
                I=0
                GOTO 25
        END IF

        DELTA(0)=0.
        DCRIT=0.
        DO 50 I=1,49
                DEL=DELTA((I-1))/DEGRAD         ! RADIANS
                COSDEL=COS(DEL)
                RAT=SIN(DEL) / COSPHI
                IF (RAT.GE.1) THEN      ! LAST ONE WAS CIRCUMPOLAR
C                         last deg.of dec. that meets horizon:
                        IF (DELTA((I-2)) .NE. 89-INT(ABSPHI) ) THEN
                                DELTA(I-1)= 89-INT(ABSPHI)
                        ELSE
                                DELTA(I-1)= 90-INT(ABSPHI)
                        END IF
                        DO 45 J=I,I+5
                                DELTA(J)=DELTA((J-1))+1
   45                   CONTINUE
                        K=I+5
                        GOTO 100
                END IF
C        place intersections with horizon no more than 0.2 rad apart:
                DD=0.2*(COSPHI/COSDEL)*SQRT(1.-RAT*RAT)
                IF (DD .LT. 1./DEGRAD) DD=1.005/DEGRAD
                DELTA(I)=DELTA((I-1))+INT(DD*DEGRAD)
C                       Moon only reaches 30 deg...
                IF (DCRIT.EQ.0. .AND. DELTA(I).GT.30.) DCRIT=DELTA(I)
   50   CONTINUE
        K=49
C
  100   LINE=3
        I=K
        IF (I.EQ.0) CALL STSEPI
        I=I-1
        DO 150 LOOP=1,LOOPS
                LINE=0
                DO 110 J=I,0,-1
                        IF (MOD(LINE,10) .EQ.0) THEN
                                IF (LINE.GT.0) THEN     ! BREAK PAGE
                                        WRITE(NFILE,FMT1)FOOT
                                        WRITE(NFILE,'(1H1)')
                                END IF
                                WRITE(NFILE,'(A58,A8)')
     1  ' H O U R   A N G L E   L I M I T S   f o r  ',
     2                             TELESCOP
                                WRITE(NFILE,FMT1)
                                IF (MOUNTING.EQ.'GERMAN')
     1                               WRITE(NFILE,FMT1)GERMAN(LOOP)
                                WRITE(NFILE,FMT1)
                                WRITE(NFILE,FMT1)TOP
                                WRITE(NFILE,FMT1)LINE2
                                WRITE(NFILE,FMT1)LINE3
                                WRITE(NFILE,FMT1)LINE4
                                WRITE(NFILE,FMT1)LINE5
                                WRITE(NFILE,FMT1)GAP
                                WRITE(NFILE,FMT1)LINE6
                        END IF
                        LINE=LINE+1
                        WRITE(NFILE,FMT1)SPACER
                        WRITE(NFILE,FMT1)GAP
                         IF (DELTA(J).LE.DCRIT) THEN
                                WRITE(NFILE, FMT2) DELTA(J)
                        ELSE
                                WRITE(NFILE, FMT3) DELTA(J)
                        END IF
                        WRITE(NFILE,FMT1)GAP
  110           CONTINUE
                DO 120 J=1,I
                        IF (MOD(LINE,10) .EQ.0) THEN
                                IF (LINE.GT.0) THEN     ! BREAK PAGE
                                        WRITE(NFILE,FMT1)FOOT
                                        WRITE(NFILE,'(1H1)')
                                END IF
                                WRITE(NFILE,'(A58,A8)')
     1 ' H O U R   A N G L E   L I M I T S   f o r  ',
     2                             TELESCOP
                                WRITE(NFILE,FMT1)
                                IF (MOUNTING.EQ.'GERMAN')
     1                               WRITE(NFILE,FMT1)GERMAN(LOOP)
                                WRITE(NFILE,FMT1)
                                WRITE(NFILE,FMT1)TOP
                                WRITE(NFILE,FMT1)LINE2
                                WRITE(NFILE,FMT1)LINE3
                                WRITE(NFILE,FMT1)LINE4
                                WRITE(NFILE,FMT1)LINE5
                                WRITE(NFILE,FMT1)GAP
                                WRITE(NFILE,FMT1)LINE6
                        END IF
                        LINE=LINE+1
                        WRITE(NFILE,FMT1)SPACER
                        WRITE(NFILE,FMT1)GAP
                        IF (DELTA(J).LE.DCRIT) THEN
                                WRITE(NFILE, FMT2) -DELTA(J)
                        ELSE
                                WRITE(NFILE, FMT3) -DELTA(J)
                        END IF
                        WRITE(NFILE,FMT1)GAP
  120           CONTINUE
                WRITE(NFILE,FMT1)FOOT
                IF (LOOPS.EQ.2) THEN
                        LINE6=
     1'       |        | (TWOBSE) | (TWMOONE) | (TWOBSW) | (TWMOONW) |'
                        IF (LOOP.EQ.1) WRITE(NFILE,'(1H1)')
                END IF
  150   CONTINUE
        CLOSE(NFILE)
C
        CALL STTPUT('Done!',NOUT)
        CALL STTPUT(' ',NOUT)
        CALL STTPUT('--> Don''t forget to print the file FORM',NOUT)
        CALL STTPUT(' ',NOUT)
C
C       End MIDAS:
C
        CALL STSEPI
C
C
C
        END
        SUBROUTINE MENU1(PROMPT,WORDS,NITEMS,NOUT)
C
      IMPLICIT REAL (A-H,O-Z)
      IMPLICIT INTEGER (I-N)
C
        CHARACTER*(*) PROMPT,WORDS(NITEMS)
        CHARACTER*80 CARD
        CHARACTER B24(2)*24, B16(4)*16, B8(8)*8, B64*64
        EQUIVALENCE (B64,B24(1),B16(1),B8(1))
C
C       *****  Begin  *****
C
        CALL STTPUT(PROMPT,NOUT)
        IF (NITEMS.LT.9)THEN
                DO 10 I=1,NITEMS
                B64=WORDS(I)
                WRITE(CARD,5) I,B64
    5           FORMAT(20X,I2,':',2X,A50)
                CALL STTPUT(' ',NOUT)
                CALL STTPUT(CARD,NOUT)
   10           CONTINUE
        ELSE IF (NITEMS.LT.17) THEN
                INC=NITEMS/2
                DO 20 I=1,(NITEMS+1)/2
                K=1
                DO 12 J=I,NITEMS,INC
                B24(K)=WORDS(J)
   12           K=K+1
                WRITE(CARD,15) (I+(KK-1)*INC,B24(KK),KK=1,K)
   15           FORMAT(10X,I2,':',2X,A24,8X,I2,':',A24)
                CALL STTPUT(' ',NOUT)
                CALL STTPUT(CARD,NOUT)
   20           CONTINUE
        ELSE IF (NITEMS.LT.65) THEN
                INC=NITEMS/4
                DO 30 I=1,(NITEMS+3)/4
                K=1
                DO 22 J=I,NITEMS,INC
                B16(K)=WORDS(J)
   22           K=K+1
                WRITE(CARD,25) (B16(KK),KK=1,K)
   25           FORMAT(6X,4(2X,A16))
                IF (NITEMS.LT.33) CALL STTPUT(' ',NOUT)
                CALL STTPUT(CARD,NOUT)
   30           CONTINUE
        ELSE
                INC=NITEMS/8
                DO 40 I=1,(NITEMS+7)/8
                K=1
                DO 32 J=I,NITEMS,INC
                B8(K)=WORDS(J)
   32           K=K+1
                WRITE(CARD,35) (B8(KK),KK=1,K)
   35           FORMAT(4X,8(1X,A8))
                CALL STTPUT(CARD,NOUT)
   40           CONTINUE
        END IF
        CALL STTPUT(' ',NOUT)
        RETURN
        END

C===========================================================================
C Copyright (C) 1995-2006 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++
C.IDENTIFICATION for_try.f
C.LANGUAGE       F77
C.AUTHOR         K. Banse
C.ENVIRONMENT    Any
C.KEYWORDS       FOR to C
C.PURPOSE        Check Fortran to C interface
C.COMMENTS       
C.VERSION  1.0   16-Oct-1990
C 
C 060217	last modif
C 
C 
C this is an extended version of the for_test.for program, to be used
C with ftoc_stack.fc
C to get a look at the stack
C 
C----------------
C 
      CHARACTER*79  s1
      CHARACTER*161 s2
      CHARACTER*4   s3
      CHARACTER*6   s4
      CHARACTER*2   s5
      CHARACTER*23  s6
      CHARACTER*40  st1, st2, st3
C 
      INTEGER    ls1, ls2, ls3, ls4, ls5, ls6
      INTEGER    CTRFLG,KSTART,KSIZE
      INTEGER    MADRID(3)
C 
      COMMON /VMR/ MADRID
C 
      WRITE(*,10100) 
     +     'We expect as I3 numbers: control_flag kstart ksize'
      s1 = 'stack-test '
      OPEN(UNIT=33,FILE=s1(1:10),STATUS='OLD',ERR=9998)
      READ(33,10100,END=9998) ST1
      READ(ST1,10102) CTRFLG,KSTART,KSIZE
      WRITE(*,10101) ST1,CTRFLG,KSTART,KSIZE
C  
 
      s1 = 'sY<01234567890ABCDEFGHIJKLMNOPQRSTUVWXYZ>'
      s2 = 's2<abcdefghijklmnopqrstuvwxyz01234567890>XYZ'
      s3 = 's3.X'
      st1 = 'where does this string go? '
      s4 = 'sKlaus'
      st2 = 'filling up space... '
      st3 = '&now, occupying 40 characters over here&& '
      s5 = 'sS'
      s6 = 's[1234567890]AB'
C 
      ls1 = 79
      ls2 = 161
      ls3 = 4
      ls4 = 6
      ls5 = 2
      ls6 = 23
C 
      WRITE(*,995)                      !write title
      WRITE(*,998)
      WRITE(*,996)
C 
      MADRID(1) = KSTART
      MADRID(2) = KSIZE
      MADRID(3) = 33
      CALL CSUB()
C 
      IF ((CTRFLG .EQ. 1) .OR. (CTRFLG .EQ. 10)) THEN
         WRITE(*,2100) 99123
         CALL SSA(99123)
         WRITE(*,2200) 8855,-12
         CALL SSB(8855,-12)
         WRITE(*,1000) s5,ls5
         CALL SSS(s5)
         WRITE(*,2100) -7031
         CALL SSA(-7031)
         WRITE(*,2200) 303,12400
         CALL SSB(303,12400)
         WRITE(*,1000) s2,ls2
         CALL SSS(s2)
         WRITE(*,997)
C 
         WRITE(*,2300) 1000,2000,3000
         CALL SSC(1000,2000,3000)
         WRITE(*,2300) 200,-200,5500
         CALL SSC(200,-200,5500)
         WRITE(*,997)
      ENDIF
C 
      IF ((CTRFLG .EQ. 2) .OR. (CTRFLG .EQ. 10)) THEN
         WRITE(*,1300) 12345,202,s4,ls4
         CALL SSQ(12345,s4,202)
         WRITE(*,1400) s5,ls5,s3,ls3
         CALL SSU(s5,s3)
         WRITE(*,1100) -99,101,7788,-4455
         CALL SSD(-99,101,7788,-4455)
         WRITE(*,1300) -333,444,s1,ls1
         CALL SSQ(-333,s1,444)
         WRITE(*,1400) s6,ls6,s1,ls1
         CALL SSU(s6,s1)
         WRITE(*,1100) 21,-333,-456789,1088
         CALL SSD(21,-333,-456789,1088)
         WRITE(*,997)
      ENDIF
C 
      IF ((CTRFLG .EQ. 3) .OR. (CTRFLG .EQ. 10)) THEN
         WRITE(*,2400) 3,123555,400,-71,555
         CALL SSE(3,123555,400,-71,555)
         WRITE(*,1770) 766,s1,ls1,s3,ls3
         CALL SSR(s1,766,s3)
         WRITE(*,2400) 900,800,700,600,-222
         CALL SSE(900,800,700,600,-222)
         WRITE(*,1770) -111,'ABC',3,s5,ls5
         CALL SSR('ABC',-111,s5)
         WRITE(*,997)
C 
         WRITE(*,1700) s5,ls5,s3,ls3,s4,ls4
         CALL SST(s5,s3,s4)
         WRITE(*,1700) s6,ls6,s1,ls1,s2,ls2
         CALL SST(s6,s1,s2)
         WRITE(*,997)
      ENDIF
C 
      IF ((CTRFLG .EQ. 4) .OR. (CTRFLG .EQ. 10)) THEN
         WRITE(*,1600) 101,202,st1,40,st2,40
         CALL SSV(101,st1,202,st2)
         WRITE(*,1500) -7543,s2,ls2,s4,ls4,s1,ls1
         CALL SSW(s2,s4,-7543,s1)
         WRITE(*,1600) -666,-345,s1,ls1,s2,ls2
         CALL SSV(-666,s1,-345,s2)
         WRITE(*,1500) 3255,s6,ls6,s3,ls3,s5,ls5
         CALL SSW(s6,s3,3255,s5)
         WRITE(*,997)
      ENDIF
C 
      IF ((CTRFLG .EQ. 5) .OR. (CTRFLG .EQ. 10)) THEN
         WRITE(*,2500) 66,-1,77,0,222,1009
         CALL SSF(66,-1,77,0,222,1009)
         WRITE(*,1200) -71,-2,33,s1,ls1,s2,ls2,s3,ls3
         CALL SSP(s1,-71,s2,-2,33,s3)
         WRITE(*,2500) -4321,+567,3300,-223344,567,789
         CALL SSF(-4321,+567,3300,-223344,567,789)
         WRITE(*,1200) 1009,-99,10233,st1,40,s6,ls6,st2,40
         CALL SSP(st1,1009,s6,-99,10233,st2)
         WRITE(*,997)
      ENDIF
C 
      GOTO 9999
C 
C file open error
9998  WRITE(*,10100) 'Problems opening file stack-test ...'
9999  CLOSE(UNIT=33)
C 
995   FORMAT
     +(/'*********************************************************')
996   FORMAT
     +('*********************************************************'/)
997   FORMAT('================================================'//)
998   FORMAT(/'   for_try.for  to test the F77',
     +       ' -> C parameter passing '/)
999   FORMAT('1 ')
1000  FORMAT('calling SSS(str1), str1 = ',A,' : F77 length = ',I4)
1100  FORMAT('calling SSD(n1,n2,n3,n4), n1,n2,n3,n4 = ',4I8)
2100  FORMAT('calling SSA(n1), n1 = ',I8)
2200  FORMAT('calling SSB(n1,n2), n1,n2 = ',2I8)
2300  FORMAT('calling SSC(n1,n2,n3), n1,n2,n3 = ',3I8)
2400  FORMAT('calling SSE(n1,n2,n3,n4,n5), n1,n2,n3,n4,n5 = '/5I8)
2500  FORMAT('calling SSF(n1,n2,n3,n4,n5,n6), n1,n2,n3,n4,n5,n6 = '/6I8)
1200  FORMAT('calling SSP(str1,n1,str2,n2,n3,str3), n1,n2,n3 = ',3I8/
     +       'str1 = ',A,': F77 length = ',I4/
     +       'str2 = ',A,': F77 length = ',I4/
     +       'str3 = ',A,': F77 length = ',I4)
1300  FORMAT('calling SSQ(n1,str1,n2), n1, n2 = ',2I8/
     +       'str1 = ',A,': F77 length = ',I4)
1400  FORMAT('calling SSU(str1,str2)'/
     +       'str1 = ',A,': F77 length = ',I4/
     +       'str2 = ',A,': F77 length = ',I4)
1500  FORMAT('calling SSW(str1,str2,n1,str3), n1 = ',I8/
     +       'str1 = ',A,': F77 length = ',I4/
     +       'str2 = ',A,': F77 length = ',I4/
     +       'str3 = ',A,': F77 length = ',I4)
1600  FORMAT('calling SSV(n1,str1,n2,str2), n1, n2 = ',2I8/
     +       'str1 = ',A,': F77 length = ',I4/
     +       'str2 = ',A,': F77 length = ',I4)
1700  FORMAT('calling SST(str1,str2,str3)'/
     +       'str1 = ',A,': F77 length = ',I4/
     +       'str2 = ',A,': F77 length = ',I4/
     +       'str3 = ',A,': F77 length = ',I4)
1770  FORMAT('calling SSR(str1,n2,str3), n2 = ',I8/
     +       'str1 = ',A,': F77 length = ',I4/
     +       'str3 = ',A,': F77 length = ',I4)
10100 FORMAT(A)
10101 FORMAT('we read: [',A10,'] and -> ',3I3)
10102 FORMAT(3I3)
C 
      STOP
      END

C @(#)xyad.for	19.1 (ES0-DMD) 02/25/03 13:23:05
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C @(#)xyad.for	19.1 (ESO-SDAG) 02/25/03 13:23:05
c----------------------------------------------------------------------
      SUBROUTINE XYAD(AKSI,ANU,IA1,ID1,DA1S,DD1S,ITEGN1,ALFAS,DELTS,
     *COSD0,SIND0,ALFA0)
c----------------------------------------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z), INTEGER*4 (I-N)
      DIMENSION ALFA(3),DELTA(3),IA1(3),ID1(3)
      CHARACTER*2 ITEGN1

      PI = 4.0D0*DATAN(1.0D0)
      DOPI18 = PI/1.8D2
      DO1 = 1.0D0
      RH = DSQRT(AKSI**2 + ANU**2)
      SINPH = AKSI/RH 
      COSPH = ANU/RH
      RH = RH*DOPI18
      SINRH= DSIN(RH) 
      COSRH = DCOS(RH)
      DELTS = COSRH*SIND0+SINRH*COSD0*COSPH 
      DELTS = DATAN(DELTS/DSQRT(DO1-DELTS**2))
      ALFAS = SINRH*SINPH/DCOS(DELTS) 
      ALFAS = ALFA0 + DATAN(ALFAS/DSQRT(DO1-ALFAS**2))

      CALL ADCON(ALFAS,DELTS,ALFA,DELTA)

      DO 670 J=1,2
        IA1(J) = IDINT(ALFA(J)+1.0D-3)
  670   ID1(J) = IDINT(DELTA(J)+DSIGN(1.0D-3,DELTA(J))) 

      DA1S = ALFA(3)
      DD1S = DELTA(3) 
      ID1(1) = IABS(ID1(1)) 
      ITEGN1 = ' +' 
C      IF (DELTS.LT.DO0) ITEGN1 = ' -' 
      IF (DELTS.LT. 0.0D0) ITEGN1 = ' -' 
      RETURN
      END 

C @(#)vcopy.for	19.1 (ESO-DMD) 02/25/03 14:00:31 
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM VCOPY
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C program VCOPY				version 1.00 	881028
C  K. Banse				ESO - Garching
C  1.10    890622
C
C.KEYWORDS
C ImageDisplay, Hardcopy
C
C.PURPOSE
C  read Image display
C
C.ALGORITHM
C  use RDMON to build up the greycopy
C
C.INPUT/OUTPUT
C  the following keywords are used:
C  INPUTI/I/1/2		(1) termination flag: 
C			    1 go all the way
C			    0 stop after filling mask with display data
C			(2) save flag: 
C			    1 = save image in "screen.bdf"
C			    0 = no
C
C.VERSIONS
C  see SCCS for later versions than 1.10
C
C 011130	last modif
C 
C----------------------------------------------------------------------------
C
      IMPLICIT NONE
C      
      CHARACTER    IDENT*72,FRAME*60
      CHARACTER    CUNIT*48,TYPE*4,PRMODE*6
C
      INTEGER*8    PNTR
      INTEGER      IMNOI,IMNOK,BITS8
      INTEGER      N1,N2,I,STAT,NDIM,IAV
      INTEGER      IBUF(800)
      INTEGER      NPIX(2),CHANL,KDEVR(20)
      INTEGER      SECTN,LUTSZ,PLOTCL,PACKF
      INTEGER      UNI(1),NULO,MADRID(1)
C
      DOUBLE PRECISION START(2),STEP(2),END(2)
C 
      REAL         CUTS(4),RINF(8),RBUF(800),RQ(768),PBUF(30)
C      
      INCLUDE      'MID_INCLUDE:ST_DEF.INC'
C 
      INCLUDE  'MID_INCLUDE:IDIDEV.INC'
      INCLUDE  'MID_INCLUDE:IDIMEM.INC'
C 
      COMMON  /VMR/  MADRID
C 
      DATA      START    /0.D0,0.D0/
      DATA      STEP     /1.D0,1.D0/
      DATA      PLOTCL   /9/                       !no. of plot colours
C               Ojo: PBUF must have size = 3*PLOTCL
C 
      INCLUDE      'MID_INCLUDE:ST_DAT.INC'
C      
C  initialize MIDAS
      CALL STSPRO('VCOPY')
C
C  read main control block of Image Display
      CALL DTOPEN(1,STAT)
C
      CUNIT(1:16) = 'Screen pixels '
      CUNIT(17:32) = CUNIT(1:16)
      CUNIT(33:48) = 'Screen intens. '
      CALL STKRDC('DEFAULT',1,1,1,IAV,TYPE,UNI,NULO,STAT)
C
C..  create + init screen output file of e.g. 512x512 pixels
C
      NPIX(1) = QDSZX
      NPIX(2) = QDSZY
      NDIM = NPIX(1) * NPIX(2)
      LUTSZ = QLUTSZ
      FRAME = 'vcopy.bdf '
      IDENT(1:) = ' '
      CHANL = QIMCH
      CALL STKRDI('DAZDEVR',1,20,IAV,KDEVR,UNI,NULO,STAT)
      QRGBFL = KDEVR(18)
      CALL STKRDI('IDIDEV',1,20,IAV,IBUF,UNI,NULO,STAT)
      SECTN = 0                              !temporarily set LUT section to 0
      IF ((QRGBFL .EQ. 0) .AND.(QDDEP .EQ. 8)) THEN
         BITS8 = 1
      ELSE
         BITS8 = 0                           !take care of 16, 24-bit displays
      ENDIF
C 
C  get current LUT (avoid extrapolation)
      IF (BITS8.EQ.1) THEN
         CALL RDLUT(QDSPNO,SECTN,1,QLUTSZ,RQ,STAT)
         CALL MAKLUT(2,QLUTSZ,RQ,256,RBUF)         !to fill the LUT all the way 
         CALL MAKLUT(2,QLUTSZ,RQ,QLUTSZ,RBUF) 
      ENDIF
C      
C  X11 environment
      IF (IDINUM.NE.11) THEN
         CALL STETER(13,'WE only support X-Windows...')
         CALL STSEPI
      ENDIF
C 
      IF (TYPE(1:1).EQ.'Z') THEN          !we want to copy the zoom-window
         CALL DTOPEN(3,STAT)              !that sets ZDSPNO ...
         CHANL = 0
         NPIX(1) = IBUF(19)
         NPIX(2) = IBUF(20)
         NDIM = NPIX(1) * NPIX(2)
      ELSE
         ZDSPNO = -1
      ENDIF
C 
      IF (BITS8 .EQ. 1)  THEN            !PseudoColor
         CALL STIPUT(FRAME,D_I1_FORMAT,F_O_MODE,F_IMA_TYPE,2,
     +            NPIX,START,STEP,IDENT,CUNIT,PNTR,IMNOI,STAT)
         PACKF = 4
      ELSE                                !RGB mode
         CALL STIPUT(FRAME,D_I4_FORMAT,F_O_MODE,F_IMA_TYPE,2,
     +            NPIX,START,STEP,IDENT,CUNIT,PNTR,IMNOI,STAT)
         PACKF = 1
      ENDIF
C 
      IF (ZDSPNO.LT.0) THEN
         CALL 
     +      IIDSNP(QDSPNO,0,NDIM,0,0,QMDEP,PACKF,MADRID(PNTR),STAT)
      ELSE
         CALL 
     +      IIDSNP(ZDSPNO,0,NDIM,0,0,QMDEP,PACKF,MADRID(PNTR),STAT)
         CALL DTCLOS(ZDSPNO)
      ENDIF
C 
      IF (BITS8 .EQ. 1)  THEN 
         CALL RDLUT(QDSPNO,99,1,PLOTCL,RQ,STAT)    !get plot colours
         CALL MAKLUT(2,PLOTCL,RQ,PLOTCL,PBUF)
         N1 = 3 * QLUTSZ
         N2 = PLOTCL*3 - 2
         DO 300,I=1,N2,3                         !and add them in the end
            RBUF(N1+I) = PBUF(I)
            RBUF(N1+I+1) = PBUF(I+1)
            RBUF(N1+I+2) = PBUF(I+2)
300      CONTINUE
         LUTSZ = QLUTSZ + PLOTCL
      ELSE
         LUTSZ = 256
      ENDIF
C 
C  check PrintMode, if we really need originally loaded frame
      CALL STKRDC('P6',1,1,5,IAV,PRMODE,UNI,NULO,STAT)
      CALL UPCAS(PRMODE,PRMODE)
      IF (PRMODE(5:5).NE.'Z') THEN               !T/Z = Text/NoText
C 
C  copy info of displayed frame
         CALL DTGICH(QDSPNO,CHANL,FRAME,RINF,STAT)
         CALL STFOPN(FRAME,D_OLD_FORMAT,0,F_IMA_TYPE,IMNOK,STAT)
         CALL STDWRC(IMNOI,'ROOT_FRAME',1,FRAME,1,60,UNI,STAT)
         CALL STDWRR(IMNOI,'ROOT_CUTS',RINF(5),1,2,UNI,STAT)     !original cuts
C 
         CALL STDCOP(IMNOK,IMNOI,4,'IDENT',STAT)
         CALL STDCOP(IMNOK,IMNOI,4,'STEP',STAT)
         START(1) = RINF(1)
         START(2) = RINF(2)
         CALL STDWRD(IMNOI,'START',START,1,2,UNI,STAT)     !start as in display
         END(1) = RINF(3)
         END(2) = RINF(4)
         CALL STDWRD(IMNOI,'END',END,1,2,UNI,STAT)         !end as in display
C 
         IF (BITS8 .EQ. 1) THEN
            CALL STDFND(IMNOK,'MIDAS_ITT',TYPE,N1,N2,STAT)
            IF (TYPE(1:1).EQ.'I') THEN
               CALL STDRDI(IMNOK,'MIDAS_ITT',1,N1,IAV,IBUF,UNI,
     +                     NULO,STAT)
               CALL STDWRI(IMNOI,'MIDAS_ITT',IBUF,1,N1,UNI,STAT)
            ELSE IF (TYPE(1:1).EQ.'R') THEN
               CALL STDRDR(IMNOK,'MIDAS_ITT',1,N1,IAV,RBUF,UNI,
     +                     NULO,STAT)
               CALL STDWRR(IMNOI,'MIDAS_ITT',RBUF,1,N1,UNI,STAT)
            ENDIF
            CALL STDFND(IMNOK,'MIDAS_LUT',TYPE,N1,N2,STAT)
            IF (TYPE(1:1).EQ.'I') THEN
               CALL STDRDI(IMNOK,'MIDAS_LUT',1,N1,IAV,IBUF,UNI,
     +                     NULO,STAT)
               CALL STDWRI(IMNOI,'MIDAS_LUT',IBUF,1,N1,UNI,STAT)
            ELSE IF (TYPE(1:1).EQ.'R') THEN
               CALL STDRDR(IMNOK,'MIDAS_LUT',1,N1,IAV,RBUF,UNI,
     +                     NULO,STAT)
               CALL STDWRR(IMNOI,'MIDAS_LUT',RBUF,1,N1,UNI,STAT)
            ENDIF
         ENDIF
      ELSE
         FRAME(1:) = 'None '
         CALL STDWRC(IMNOI,'ROOT_FRAME',1,FRAME,1,60,UNI,STAT)
         RINF(5) = 0.
         RINF(6) = 255.
         CALL STDWRR(IMNOI,'ROOT_CUTS',RINF(5),1,2,UNI,STAT)     !original cuts
         START(1) = 0.
         START(2) = 0.
         CALL STDWRD(IMNOI,'START',START,1,2,UNI,STAT)     !start as in display
         END(1) = 512.
         END(2) = 512.
         CALL STDWRD(IMNOI,'END',END,1,2,UNI,STAT)         !end as in display
      ENDIF
C
C  now store the LUT in `middumml.lut'
      IDENT(1:) = 'MID_WORK:middumml '
      CALL BLDLUT(IDENT,RBUF,STAT)     !create table and fill it with LUT
C 
      CUTS(1) = 0.
      CUTS(2) = LUTSZ - 1.
      CUTS(3) = CUTS(1)
      CUTS(4) = CUTS(2)
      CALL STDWRR(IMNOI,'LHCUTS',CUTS,1,4,UNI,STAT)
      CALL STDWRI(IMNOI,'VCOPY-LUTSIZE',LUTSZ,1,1,UNI,STAT)
C
      CALL DTCLOS(QDSPNO)
      CALL STSEPI
C      
      END

C @(#)rctmap.for	19.1 (ES0-DMD) 02/25/03 13:30:47
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE RCTMAP(OUT,NPX,NPY,START,IPOL,NPXIP,NPYIP,CX,CY,
     2                  OUTSTA,SUBFAC,NREP)
C +++
C.PURPOSE: This subroutine maps each set of subpixels into the rectified
C          coordinate frame and adds the contents of each subpixel into
C          the output pixel concerned.
C ---
      IMPLICIT     NONE
      INTEGER      NPX
      INTEGER      NPY
      INTEGER      NPXIP
      INTEGER      NPYIP
      REAL         OUT(NPX,NPY)
      REAL         START(2)
      REAL         IPOL(NPXIP,NPYIP)
      DOUBLE PRECISION CX(20),CY(20)
      REAL         OUTSTA(2)
      REAL         SUBFAC
      INTEGER      NREP
C
      DOUBLE PRECISION X,Y
      DOUBLE PRECISION X0,Y0
      REAL         WIDTH
      REAL         OFFX,OFFY
      INTEGER      IXR, IYR 
      INTEGER      ISTAT
      INTEGER      K, L
      INTEGER      M, N
      INTEGER      NPERC
      INTEGER      OFFINT
      REAL         XS,YS
      REAL         XR,YR
      REAL         FXIN,FXOUT,FYIN,FYOUT
      REAL         OFFMAX
      REAL         FLUX
      LOGICAL      CENTX
      LOGICAL      CENTY
      LOGICAL      LOWX
      LOGICAL      HIGHX
      LOGICAL      LOWY
      LOGICAL      HIGHY
      CHARACTER*50 PROGR
C
 9000 FORMAT ('          ',I3,' percent completed ...')
C  
      XS     = START(1) - 1                                     ! permit work on
      YS     = START(2) - 1                                          ! subframes
      WIDTH  = 1./(SUBFAC*NREP)                        ! width of (sub-)subpixel
      OFFMAX = 0.5* (1-WIDTH)   ! max. offs. to be still in nearest output pixel
      OFFINT = INT(SUBFAC/2.)
      NPERC  = 0
      CALL STTPUT('*** INFO: Mapping started',ISTAT)
C
C *** map coordinates of subpixels into rectified grid
C
      DO 40 L = 1,NPYIP
         DO 30 K = 1,NPXIP
            X0     = XS + (K+OFFINT)/SUBFAC           ! coordinates of subpixels
            Y0     = YS + (L+OFFINT)/SUBFAC
            FLUX   = IPOL(K,L)/(NREP*NREP)
            DO 20 M = 1,NREP           ! if requested, go to still smaller units
               X      = X0 + (M-0.5-NREP*0.5)*WIDTH
               DO 10 N = 1,NREP
                  Y      = Y0 + (N-0.5-NREP*0.5)*WIDTH
C
C *** transformation in x
C     ------------------------------------------------------------------------
C     |  note the CONVENIENT definition of a 2D third-order regression       |
C     |  analysis with two independent variables adopted                     |
C     |  in the midas command regression/poly. conformance to his definition |
C     |  is, however, mandatory.                                             |
C     ------------------------------------------------------------------------
C
                  XR     = CX(1)+X*(CX(2) +X*(CX(3) +X*CX(4))) +
     +                    (CX(5)+X*(CX(6) +X*(CX(7) +X*CX(8))))*Y +
     +                    (CX(9)+X*(CX(10)+X*(CX(11)+X*CX(12))))*
     +                     Y*Y  +  (CX(13)+X*(CX(14)+X*(CX(15)+X*
     +                     CX(16))))*Y*Y*Y
C
C *** and the same in y
C
                  YR     = CY(1)+X*(CY(2) +X*(CY(3) +X*CY(4))) +
     +                    (CY(5)+X*(CY(6) +X*(CY(7) +X*CY(8))))*Y +
     +                    (CY(9)+X*(CY(10)+X*(CY(11)+X*CY(12))))*
     +                     Y*Y  +  (CY(13)+X*(CY(14)+X*(CY(15)+X*
     +                     CY(16))))*Y*Y*Y
C
C *** transformation from world coordinates to pixel coordinates 
C     to be used throughout the rest of this subroutine
C
                  XR     = XR - OUTSTA(1)
                  YR     = YR - OUTSTA(2)
C
C *** drop flux into respective output pixel
C     if necessary, divide flux in one subpixel among several output
C     pixels assuming that the flux does not vary over one subpixel
C  
                  IXR    = NINT(XR)                     !   nearest output pixel
                  IYR    = NINT(YR)        !   (should receive most of the flux)
                  OFFX   = XR - IXR           !   offset of subpixel center from
                  OFFY   = YR - IYR                      !   output pixel center
C
C *** determine position in x of subpixel relative to nearest output pixel
C
                  IF ((ABS(OFFX)-OFFMAX).LE.0) THEN     ! within cen. pixel in x
                     LOWX   = .FALSE.  
                     CENTX  = .TRUE.
                     HIGHX  = .FALSE.
                     FXIN   = 1.

                  ELSE IF ((XR-IXR-OFFMAX).GT.0) THEN  ! beyond cent. pixel in x
                     LOWX   = .FALSE.
                     CENTX  = .FALSE.  
                     HIGHX  = .TRUE.
                     FXIN   = (IXR+0.5-XR)/WIDTH + 0.5

                  ELSE                                ! below central pixel in x
                     LOWX   = .TRUE.
                     CENTX  = .FALSE.
                     HIGHX  = .FALSE.
                     FXIN   = (XR-IXR+0.5)/WIDTH + 0.5
                  END IF
                  FXOUT  = 1. - FXIN
C
C *** the same in y
C
                  IF ((ABS(OFFY)-OFFMAX).LE.0) THEN
                      LOWY   = .FALSE.
                      CENTY  = .TRUE.
                      HIGHY  = .FALSE.
                      FYIN   = 1.

                  ELSE IF ((YR-IYR-OFFMAX).GT.0) THEN
                      LOWY   = .FALSE.
                      CENTY  = .FALSE.
                      HIGHY  = .TRUE.
                      FYIN   = (IYR+0.5-YR)/WIDTH + 0.5

                  ELSE
                      LOWY   = .TRUE.
                      CENTY  = .FALSE.
                      HIGHY  = .FALSE.
                      FYIN   = (YR-IYR+0.5)/WIDTH + 0.5
                  END IF
                  FYOUT  = 1. - FYIN
C
C ***  First case, then: subpixel completely within one output pixel
                  IF (CENTX .AND. CENTY) THEN
                     OUT(IXR,IYR) = OUT(IXR,IYR) + FLUX

                  ELSE IF (HIGHX) THEN          ! test if subpixel on right edge
                     IF (HIGHY) THEN               ! pixel on upper right corner
C
C *** direct flux of subpixel into the four output pixels concerned
                        OUT(IXR+1,IYR+1) = OUT(IXR+1,IYR+1) +
     +                                     FXOUT*FYOUT*FLUX
                        OUT(IXR+1,IYR)   = OUT(IXR+1,IYR) +
     +                                     FXOUT*FYIN*FLUX
                        OUT(IXR,IYR+1)   = OUT(IXR,IYR+1) +
     +                                     FXIN*FYOUT*FLUX
                        OUT(IXR,IYR)     = OUT(IXR,IYR) +
     +                                     FXIN*FYIN*FLUX
                     ELSE IF (LOWY) THEN     ! three subp. on lower right corner
                        OUT(IXR+1,IYR-1) = OUT(IXR+1,IYR-1) +
     +                                     FXOUT*FYOUT*FLUX
                        OUT(IXR+1,IYR) = OUT(IXR+1,IYR) +
     +                                     FXOUT*FYIN*FLUX
                        OUT(IXR,IYR-1) = OUT(IXR,IYR-1) +
     +                                     FXIN*FYOUT*FLUX
                        OUT(IXR,IYR) = OUT(IXR,IYR) +
     +                                     FXIN*FYIN*FLUX
C
                     ELSE          ! four: subpixel on center right edge
C                                  ! (need to consider now only 2 output pixels)
                        OUT(IXR+1,IYR) = OUT(IXR+1,IYR) + FXOUT*FLUX
                        OUT(IXR,IYR)   = OUT(IXR,IYR) + FXIN*FLUX
                     END IF

                  ELSE IF (LOWX) THEN              ! subpixel falls on left edge
                     IF (HIGHY) THEN       ! five: subpixel on upper left corner

                        OUT(IXR-1,IYR+1) = OUT(IXR-1,IYR+1) +
     +                                     FXOUT*FYOUT*FLUX
                        OUT(IXR-1,IYR)   = OUT(IXR-1,IYR) +
     +                                     FXOUT*FYIN*FLUX
                        OUT(IXR,IYR+1)   = OUT(IXR,IYR+1) +
     +                                     FXIN*FYOUT*FLUX
                        OUT(IXR,IYR)     = OUT(IXR,IYR) +
     +                                     FXIN*FYIN*FLUX
C
                     ELSE IF (LOWY) THEN    ! six: subpixel on lower left corner
                        OUT(IXR-1,IYR-1) = OUT(IXR-1,IYR-1) +
     +                                     FXOUT*FYOUT*FLUX
                        OUT(IXR-1,IYR)   = OUT(IXR-1,IYR) +
     +                                     FXOUT*FYIN*FLUX
                        OUT(IXR,IYR-1)   = OUT(IXR,IYR-1) +
     +                                     FXIN*FYOUT*FLUX
                        OUT(IXR,IYR)     = OUT(IXR,IYR) +
     +                                      FXIN*FYIN*FLUX
C
                      ELSE          ! seventh case: subpixel on center left edge
                         OUT(IXR-1,IYR) = OUT(IXR-1,IYR) + FXOUT*FLUX
                         OUT(IXR,IYR)   = OUT(IXR,IYR) + FXIN*FLUX
                      END IF
C
                  ELSE      ! now only the center upper and lower edges are left
                     IF (LOWY) THEN       ! eigth: subpixel on center lower edge
                        OUT(IXR,IYR-1) = OUT(IXR,IYR-1) + FYOUT*FLUX
                        OUT(IXR,IYR) = OUT(IXR,IYR) + FYIN*FLUX

                     ELSE                  !nine: subpixel on center upper edge 
                        OUT(IXR,IYR+1) = OUT(IXR,IYR+1) + FYOUT*FLUX
                        OUT(IXR,IYR) = OUT(IXR,IYR) + FYIN*FLUX
                     END IF
                  END IF  
   10          CONTINUE                       !   this row of sub-subpixels done
   20       CONTINUE                       !   this column of sub-subpixels done
   30    CONTINUE                             !   this row of (sub-) pixels done
C
C *** feed them progress messages ...
C
         IF (((10*L)/NPYIP).GE. (NPERC+1)) THEN
            NPERC  = NPERC + 1
            WRITE (PROGR,9000) 10*NPERC
            CALL STTPUT(PROGR,ISTAT)
         END IF
C  
   40 CONTINUE                             !   this column of (sub-) pixels done
C
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C       Internet e-mail: midas@eso.org
C       Postal address: European Southern Observatory
C                       Data Management Division 
C                       Karl-Schwarzschild-Strasse 2
C                       D 85748 Garching bei Muenchen 
C                       GERMANY
C===========================================================================
C
C 
C.VERSION
C 100614	last modif
C        
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
      SUBROUTINE DefGrW(ireg)
C     
C     Permette di plottare diverse regioni dello spettro
C     
C     Lavora con le variabili di default XSPETTRO
C     
C     Ritorna il numero di regioni selezionate.
C     
C     Version 1 - 26/X/93  at ESO
C     Version 2 - 07/XII/95  at OAR:
C                + Velocity space
C                + returns meaningful ireg
C                + global variables updated only when input is complete
C     
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
      
      implicit none

      integer ireg      
      include 'MID_REL_INCL:fit_var.inc'

      character space
      character*72 stt_ap
      character*65 Commnt
      character*60 lbl(NMXLIN)
      character*40 domand
      integer istt,iredo,i,icurer,ij,nj,ik,j
      logical iexist,i_red
      real WinCen(NMXLIN),ydum,vel,c,lam0
      double precision ranvel,WinSiz(NMXLIN),z

      parameter (c=2.997e5)

      INTEGER MADRID(1)
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      
      COMMON/VMR/MADRID
      
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'

     
C&&&&&&&
C&&   Menu con loop se l'input non e' corretto (la flag e' "iscelta")
C&&&&&&&
      
 100  call sttdis(' ',0,istt)
      call sttdis(' ',0,istt)
      call sttdis('****** Define Graphic Window  ******',0,istt)
      write(Commnt,'(A30,F10.2,A5,F10.2)')
     1     '---> Spectrum ranging from: ',XLAMBD(1),' to :',
     2     XLAMBD(NPUNTI)
      call sttdis(Commnt,0,istt)
      call sttdis(' ',0,istt)

      ireg = -1                 !default return

      if (I_Z) space='V'
      if (.not.I_Z) space='L'
      i_red = I_Z
 99   call AskC('(L)ambda.or.(V)elocity space?',space,iredo)
      if (iredo.eq.-1) return
      if (space.eq.'L'.or.space.eq.'l') I_red=.false. 
      if (space.eq.'V'.or.space.eq.'v') I_red=.true. 

                                ! NUMERO  DELLE REGIONI
      call AskI('### Number of regions:',NREGIO,iredo)
      if (iredo.eq.-1) goto 100 !torna al menu


                                ! LIMITI DELLE REGIONI
      if (I_red) then

         call sttdis('Plot will be performed in the VELOCITY space',
     1        0,icurer)
         z = REDSH
         call AskD('Input central redshift or wavelength',z,iredo)
         if (iredo.eq.-1) goto 100 !torna al menu
         if (I_GRAP.and.iredo.eq.-98) then ! legge cursore
           call WrnMsg('I will use the WAVELENGTH from the cursor:')
           call GetXCr(WinCen(1),ydum,z,vel,icurer)  
           z = WinCen(1)
         end if

      else

         call sttdis('Plot will be performed in the WAVELENGTH space',
     1        0,icurer)
         do i  = 1,NREGIO
            write(Commnt,'(a18,i2,a10)')' Input CENTER of ',i
     1           ,' ^ region '
            if (REGMIN(i).ge.0) WinCen(i) = (REGMIN(i) + REGMAX(i))/2.
            call AskR(Commnt,WinCen(i),iredo)
            if (iredo.eq.-1) goto 100 !torna al menu
            if (I_GRAP.and.iredo.eq.-98) then ! legge cursore
               call GetXCr(WinCen(i),ydum,z,vel,icurer) 
            end if
         end do

      endif

 200  continue                  ! SIZES
      if (i_red) then
         ranvel = VELRAN
         call AskD('Input VELOCITY range',ranvel,iredo)
         if (iredo.eq.-1) goto 100
      else
         do i  = 1,NREGIO
            write(Commnt,'(a18,i2,a10)')' Input SIZE of ',i
     1           ,' ^ region'
            winsiz(i) = WINSTE(i)
            if (winsiz(i).le.0) winsiz(i)=winsiz(i-1)
            call AskD(Commnt,winsiz(i),iredo)
            if (iredo.eq.-1) goto 100
         end do
      endif


                                ! LABELS
      do i  = 1,NREGIO
         write(Commnt,'(a,i2,a)')' Input LABEL for ',i
     1        ,' ^ region (NULL to clear)'
         iredo=0
         lbl(i) = LLABEL(i)
         domand=lbl(i)
 1002    call AskC(Commnt,domand,iredo)
         lbl(i) = domand
         if (lbl(i).eq.'null'.or.lbl(i).eq.'NULL') lbl(i)=' '
         if (iredo.eq.-1) goto 100 !torna al menu
                                ! help
         if (Lbl(i).eq.'help'.or.Lbl(i).eq.'HELP') then
            call sttdis('*** List of elements: **',0,istt)
            nj=nint(AT_N/5.)+1
            do ij=1,nj
               write(stt_ap,'(1x,5A14)')(AT_NAM(ij+ik*nj),ik=0,4)
               call sttdis(stt_ap,0,istt)
            end do
            goto 1002
         end if

         if (i_red) then          ! Checks whether it exists.
            iexist = .false.    
            do ij=1,AT_N
               if (Lbl(i).eq.AT_NAM(ij))  iexist = .true.
            end do  
            if (.not.iexist) then
            call sttput('no matching entry found in atompar.tbl',istt)
               goto 1002
            endif
         endif
      end do        



                                ! computes limits..
      do i = 1 , NREGIO
         LLABEL(i) = lbl(i)
      end do

      if (i_red) then

         REDSH = z
         VELRAN = ranvel
         
         do i = 1 , NREGIO       ! trova le lam0
           lam0 = -1.
           do j = 1 ,AT_N
              if (LLABEL(i).eq.AT_NAM(j)) lam0=AT_LAM(j)
           end do
           if (i.eq.1.and.REDSH.gt.100) REDSH = REDSH / lam0 -1.
           REGMIN(i)=(1.d0-VELRAN/c)/(1.d0+VELRAN/c)*lam0*(REDSH+1.D0)
           REGMAX(i)=(1.d0+VELRAN/c)/(1.d0-VELRAN/c)*lam0*(REDSH+1.D0)
           WINSTE(i)= REGMAX(i) - REGMIN(i)           
        end do

      else
        
         REDSH=0.
         VELRAN=0.
         do i  = 1,NREGIO
            WINSTE(i) = winsiz(i)
            REGMIN(i)= WinCen(i) - (WINSTE(i) / 2.)
            REGMAX(i)= WinCen(i) + (WINSTE(i) / 2.)
         end do        
      
      endif
      
      I_GRAP = .TRUE.
      I_Z = i_red
      ireg=0

      return
      end



C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE   GraMai(ierr)
C
C     Main plot routine.
C     Calls appropriate graph routine
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        IMPLICIT NONE
        integer ierr

        integer ist
        include 'MID_REL_INCL:fit_var.inc'

C%%%%%%
C       Is graph active? Are regions defined?
C%%%%%%
        if (.not.I_GRAP) then
           ierr=-1
           return
        end if

        if (NREGIO .eq. 0) then
           NREGIO = 1
           REGMIN(1) = XLAMBD(1)
           REGMAX(1) = XLAMBD(NPUNTI)
           I_Z = .false.
        end if

        if (I_Z) then
           call GraRed(ist)     ! z plot
           ierr = ist
        else
           call GraLam(ist)     ! lambda plot 
           ierr = ist
        endif
        
        return
        end


C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE   GraRed(ierr)
C
C     Plot routine in the redshift space.
C     Calls appropriate graph routine
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        IMPLICIT NONE
        integer ierr

        include 'MID_REL_INCL:fit_var.inc'


        real rx,ry,rgroff
        real xdef(4),ydef(4)
        real   dummy(2)
        real grf_w(NMXWRK),grf_f(NMXWRK),grf_r(NMXWRK),lin_ww(NMXLIN)
        real grf_ww(NMXWRK),grf_fw(NMXWRK),grf_rw(NMXWRK)
        real lim_x(4), lim_y(4),rgra
        real lam0(20),z,dv
        integer colore(4),ipt,i,imode,k,nptgra,j,m

C        include 'MID_REL_INCL:fit_mid.inc'

        double precision c
        parameter (c=2.997D5)
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'

        if (NGRALI .gt. 0) then
           do i = 1,NGRALI
              YLIN(i) = GR_TIC
           end do
        end if

        do i = 1 , NREGIO       ! trova le lam0
           lam0(i) = -1.
           do j = 1 ,AT_N
              if (LLABEL(i).eq.AT_NAM(j)) lam0(i)=AT_LAM(j)
           end do
           if (lam0(i).lt.0) then
              call ErrMsg('Transition or element unknown')
              ierr = -1
              return
           end if
        end do

        if (REDSH.gt. 100)  REDSH = REDSH/ lam0(1) - 1.
        z = REDSH + 1

                                ! ricalcola REGMIN e REGMAX
        do i = 1, NREGIO
           REGMIN(i) = (1.d0-VELRAN/2./c) / (1.d0+VELRAN/2./c) * 
     1          lam0(i) * z
           REGMAX(i) = (1.d0+VELRAN/2./c) / (1.d0-VELRAN/2./c) * 
     +          lam0(i) * z
           WINSTE(i) = REGMAX(i) - REGMIN(i)
        end do

c%%%%%%% 
C        inserisco limiti e set up
C%%%%%%%

        GR_YMN = - GR_BOT
        GR_DEL = 1 + GR_BOT + GR_TOP
        GR_YMX = NREGIO * GR_DEL - GR_BOT


        call PTKWRC('BINMODE','ON')
        CALL PTKWRR('SCALES',0,dummy)
        CALL PTKWRR('OFFS',0,dummy)
        if (NREGIO .ne. 1) then
           call PTKWRC('YFORMAT','NONE') 
        end if

        xdef(1)=-VELRAN
        xdef(2)=VELRAN
        xdef(3)=2*VELRAN/5.
        xdef(4)=xdef(3)/5.
        
        ydef(1)=GR_YMN 
        ydef(2)=GR_YMX 
        ydef(3) = 1.            !(GR_YMX - GR_YMN) * 100.
        ydef(4)=  ydef(3) / 5


        do i = 1,NREGIO

C%%%%%% 
C     creo i vettori grafici
C%%%%%%
          nptgra=1
          do j = 1,NPUNTI
             dv = 2.*c*(XLAMBD(j) - lam0(i) * z )/(XLAMBD(j)+lam0(i)*z)
             if(abs(dv).le.VELRAN)then 
                GraWav(nptgra)=dv
                GraSpe(nptgra)=SPECTR(j)
                GraSig(nptgra)=SIGNOI(j)
                nptgra=nptgra+1
             end if
          end do   
          nptgra=nptgra-1



C%%%%%%%
C       OPEN WINDOW
C%%%%%%%
          call PTKWRR('XWNDL',4,xdef)
          call PTKWRR('YWNDL',4,ydef)
          imode = -1
          if (i.eq.1)then
            call PTOPEN(' ','fitlyman.plt',0,imode) ! plot
            call AGVERS()
          else
             call PTOPEN(' ','fitlyman.plt',1,imode)    ! overplot     
          end if
          if (i.eq.1) call PTFRAM(xdef,ydef,'Velocity (km/s)',
     1         'Normalized flux') 

          GR_OFF = i * GR_DEL - GR_BOT - GR_TOP - 1.
          rgroff = GR_OFF

          colore(1)=GCOLOR(2)
          call PTKWRI('COLOUR',1,colore)
          call PTDATA(5,1,0,GraWav,CONTIN,rgroff,nptgra)
          call PTDATA(5,3,0,GraWav,SKYLEV,rgroff,nptgra)   

          colore(1)=GCOLOR(1)
          call PTKWRI('COLOUR',1,colore)
          call PTDATA(5,1,1,GraWav,GraSpe,rgroff,nptgra)
C 
C next 8 lines inserted on advice of A. Smette 040827, Midas PR 02505, KB
            if (I_VAR) then
               colore(1)=GCOLOR(5)
               call PTKWRI('COLOUR',1,colore)
               call PTOPEN(' ','fitlyman.plt',1,imode) ! overplot
               GR_OFF = i * GR_DEL - GR_BOT -GR_TOP - 1.
               rgra = GR_OFF
               call PTDATA(5,1,0,GraWav,GraSig,rGRA,nptgra)
            end if
C
          ry = rgroff +1 + GR_LAB
          rx = - 4 * VELRAN / 5
          colore(1)=GCOLOR(6)
          call PTKWRI('COLOUR',1,colore)
          call PTTEXT(LLABEL(i),rx,ry,0.,.7,1)
          colore(1)=GCOLOR(1)
          call PTKWRI('COLOUR',1,colore)

        end do


C!!!!!!!
C       Draws the fit
C!!!!!!!

C     reads fdummy.grf
        open(25,file='fdummy.grf',status='old',iostat=ipt,err=29)
        ipt=1
 122    read(25,*,end=123,err=123)grf_w(ipt),grf_f(ipt),grf_r(ipt)
        ipt=ipt+1
        goto 122
 123    continue
        ipt=ipt -1
        if (ipt.lt.1) goto29
        close(25)

        lim_x(1)=-VELRAN
        lim_x(2)=VELRAN
        lim_y(1)= GR_YMN
        lim_y(2)= GR_YMX
        imode = -1
        
        do i = 1,NREGIO
            do k=1,NMXWRK
               grf_ww(k)=0.
               grf_rw(k)=0.
               grf_fw(k)=0.
            end do


            j = 1
            do k = 1,ipt
             dv = 2.*c*(grf_w(k) - lam0(i) * z )/(grf_w(k)+lam0(i)*z)
               if(abs(dv).le.VELRAN)then
                  grf_ww(j)=dv
                  grf_fw(j)=grf_f(k)
                  grf_rw(j)=grf_r(k)
                  j = j+1
               end if
            end do
            j = j-1

            call PTKWRR('XWNDL',2,lim_x)        
            CALL AGWDEF(lim_x(1),lim_x(2),lim_y(1),lim_y(2))

                                ! position of fitted lines
            if (NGRALI .gt. 0) then
               m = 1
               do k = 1,NGRALI
                  dv=2.*c*(Lamcen(k) - lam0(i)*z)/(lamcen(k)+lam0(i)*z)
                  if(abs(dv).le.VELRAN)then
                     lin_ww(m)=dv
                     m = m+1
                  end if
               end do
               m = m-1

               colore(1)=GCOLOR(7)
               call PTKWRI('COLOUR',1,colore)
               call PTOPEN(' ','fitlyman.plt',1,imode) ! overplot
               GR_OFF = i * GR_DEL - GR_BOT -GR_TOP - 1.
               rgra = GR_OFF
               dummy(1)=2.
               CALL PTKWRR('SSIZE',1,dummy)
               call PTDATA(13,0,0,Lin_ww,YLIN,rGRA,NGRALI)
               dummy(1)=1.
               CALL PTKWRR('SSIZE',1,dummy)
            end if

                                ! residuals
            if (I_RESD.and.j.gt.0) then
               colore(1)=GCOLOR(4)
               call PTKWRI('COLOUR',1,colore)
               call PTOPEN(' ','fitlyman.plt',1,imode) ! overplot
               GR_OFF = i * GR_DEL - GR_BOT -GR_TOP - 1.
               rgra = GR_OFF
               call PTDATA(5,1,1,grf_ww,grf_rw,rGRA,j)
            end if

                                ! fitted profile
            if (j.gt.0) then
               colore(1)=GCOLOR(3)
               call PTKWRI('COLOUR',1,colore)
               call PTOPEN(' ','fitlyman.plt',1,imode) ! overplot
               GR_OFF = i * GR_DEL - GR_BOT -GR_TOP - 1.
               rgra = GR_OFF
               call PTDATA(5,1,0,grf_ww,grf_fw,rGRA,j)
            end if
                                ! variance
            if (I_VAR) then
               colore(1)=GCOLOR(5)
               call PTKWRI('COLOUR',1,colore)
               call PTOPEN(' ','fitlyman.plt',1,imode) ! overplot
               GR_OFF = i * GR_DEL - GR_BOT -GR_TOP - 1.
               rgra = GR_OFF
               call PTDATA(5,1,0,GraWav,GraSig,rGRA,nptgra)
            end if

          end do

          colore(1)=GCOLOR(1)
          call PTKWRI('COLOUR',1,colore)

          call PTKWRR('XWNDL',2,lim_x)        
          CALL AGWDEF(lim_x(1),lim_x(2),lim_y(1),lim_y(2))


 29     continue


c        call PTKWRC('BINMODE','OFF')
        call PTKWRC('YFORMAT','AUTO') 


        return
        end

C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE   GraLam(ierr)
C
C     Plot routine in the lambda space.
C     Calls appropriate graph routine
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        IMPLICIT NONE
        integer ierr

        include 'MID_REL_INCL:fit_var.inc'
        real rx,ry,rgroff
        real xdef(4),ydef(4)
c        real xcont(10),ycont(10)
        character*15 cwave
        real   dummy(2)
        real grf_w(NMXWRK),grf_f(NMXWRK),grf_r(NMXWRK)
        real grf_ww(NMXWRK),grf_fw(NMXWRK),grf_rw(NMXWRK)
        real lim_x(4), lim_y(4),rgra
        integer colore(4),ipt,i,imode,k,nptgra,j

C        include 'MID_REL_INCL:fit_mid.inc'
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'



C%%%%%% 
C     creo i vettori grafici
C%%%%%%
        nptgra=1
        do i = 1,NPUNTI
          do k = 1 , NREGIO
             if(XLAMBD(i).gt.REGMIN(k).and.XLAMBD(i).lt.REGMAX(k))then 
                GraWav(nptgra)=XLAMBD(i)
                GraSpe(nptgra)=SPECTR(i)
                GraSig(nptgra)=SIGNOI(i)
                nptgra=nptgra+1
                goto 10
             end if
 10          continue
          end do   
        end do
        nptgra=nptgra-1

        if (NGRALI .gt. 0) then
           do i = 1,NGRALI
              YLIN(i) = GR_TIC
           end do
        end if

c%%%%%%% 
C        inserisco limiti e set up
C%%%%%%%

        GR_YMN = - GR_BOT
        GR_DEL = 1 + GR_BOT + GR_TOP
        GR_YMX = NREGIO * GR_DEL - GR_BOT


        call PTKWRC('BINMODE','ON')
        CALL PTKWRR('SCALES',0,dummy)
        CALL PTKWRR('OFFS',0,dummy)
        if (NREGIO .ne. 1) then
           call PTKWRC('YFORMAT','NONE') 
        end if


        do i = 1,NREGIO
C%%%%%%%
C       OPEN WINDOW
C%%%%%%%
          xdef(1)=REGMIN(i)
          xdef(2)=REGMAX(i)
          xdef(3)=-(REGMIN(i)-REGMAX(i))/5.
          xdef(4)=xdef(3)/5.

          ydef(1)=GR_YMN 
          ydef(2)=GR_YMX 

          ydef(3) = 1. !(GR_YMX - GR_YMN) * 100.
          ydef(4)=  ydef(3) / 5

          call PTKWRR('XWNDL',4,xdef)
          call PTKWRR('YWNDL',4,ydef)
          imode = -1
          if (i.eq.1)then

            call PTOPEN(' ','fitlyman.plt',0,imode) ! plot
            call AGVERS()
          else
             call PTOPEN(' ','fitlyman.plt',1,imode)    ! overplot     

                               ! Draws wavelengths of upper spectra
            ry= i * GR_DEL - GR_BOT - GR_TOP - 1
            rx=REGMIN(i)
            write(cwave,'(f5.0)')rx
            call PTTEXT(cwave,rx,ry,0.,.9,2)
            rx=REGMAX(i)
            write(cwave,'(f5.0)')rx
            call PTTEXT(cwave,rx,ry,0.,.9,1)
          end if
          if (NREGIO .eq. 1) then
             call PTFRAM(xdef,ydef,'Wavelength (A)','Normalized Flux') 
          else
             if (i.eq.1) call PTFRAM(xdef,ydef,'Wavelength (A)',' ') 
          end if

          GR_OFF = i * GR_DEL - GR_BOT - GR_TOP - 1.
          rgroff = GR_OFF

          colore(1)=GCOLOR(2)
          call PTKWRI('COLOUR',1,colore)
          call PTDATA(5,1,0,GraWav,CONTIN,rgroff,nptgra)
          call PTDATA(5,3,0,GraWav,SKYLEV,rgroff,nptgra)   

          colore(1)=GCOLOR(1)
          call PTKWRI('COLOUR',1,colore)
          call PTDATA(5,1,1,GraWav,GraSpe,rgroff,nptgra)
          ry = rgroff +1 + GR_LAB
          rx = REGMIN(i) + (REGMAX(i) - REGMIN(i)) / 10
          colore(1)=GCOLOR(6)
          call PTKWRI('COLOUR',1,colore)
          call PTTEXT(LLABEL(i),rx,ry,0.,.7,1)
          colore(1)=GCOLOR(1)
          call PTKWRI('COLOUR',1,colore)

        end do


C!!!!!!!
C       Draws the fit
C!!!!!!!

C     reads fdummy.grf
          open(25,file='fdummy.grf',status='old',iostat=ipt,err=29)
          ipt=1
 122      read(25,*,end=123,err=123)grf_w(ipt),grf_f(ipt),grf_r(ipt)
          ipt=ipt+1
          goto 122
 123      continue
          ipt=ipt -1
          if (ipt.lt.1) goto29
          close(25)

          imode = -1
          do i = 1,NREGIO

            lim_x(1)=REGMIN(i)
            lim_x(2)=REGMAX(i)
            lim_y(1)= GR_YMN
            lim_y(2)= GR_YMX

            do k=1,NMXWRK
               grf_ww(k)=0.
               grf_rw(k)=0.
               grf_fw(k)=0.
            end do

            j = 1
            do k = 1,ipt
               if(grf_w(k).ge.REGMIN(i).and.grf_w(k).le.REGMAX(i))then
                  grf_ww(j)=grf_w(k)
                  grf_fw(j)=grf_f(k)
                  grf_rw(j)=grf_r(k)
                  j = j+1
               end if
            end do
            j = j-1
            call PTKWRR('XWNDL',2,lim_x)        
            CALL AGWDEF(lim_x(1),lim_x(2),lim_y(1),lim_y(2))

                                ! position of fitted lines
            if (NGRALI .gt. 0) then
               colore(1)=GCOLOR(7)
               call PTKWRI('COLOUR',1,colore)
               call PTOPEN(' ','fitlyman.plt',1,imode) ! overplot
               GR_OFF = i * GR_DEL - GR_BOT -GR_TOP - 1.
               rgra = GR_OFF
               dummy(1)=2.
               CALL PTKWRR('SSIZE',1,dummy)
               call PTDATA(13,0,0,LamCen,YLIN,rGRA,NGRALI)
               dummy(1)=1.
               CALL PTKWRR('SSIZE',1,dummy)
            end if

                                ! residuals
            if (I_RESD.and.j.gt.0) then
               colore(1)=GCOLOR(4)
               call PTKWRI('COLOUR',1,colore)
               call PTOPEN(' ','fitlyman.plt',1,imode) ! overplot
               GR_OFF = i * GR_DEL - GR_BOT -GR_TOP - 1.
               rgra = GR_OFF
               call PTDATA(5,1,1,grf_ww,grf_rw,rGRA,j)
            end if

                                ! fitted profile
            if (j.gt.0) then
               colore(1)=GCOLOR(3)
               call PTKWRI('COLOUR',1,colore)
               call PTOPEN(' ','fitlyman.plt',1,imode) ! overplot
               GR_OFF = i * GR_DEL - GR_BOT -GR_TOP - 1.
               rgra = GR_OFF
               call PTDATA(5,1,0,grf_ww,grf_fw,rGRA,j)
            end if
                                ! variance
            if (I_VAR) then
               colore(1)=GCOLOR(5)
               call PTKWRI('COLOUR',1,colore)
               call PTOPEN(' ','fitlyman.plt',1,imode) ! overplot
               GR_OFF = i * GR_DEL - GR_BOT -GR_TOP - 1.
               rgra = GR_OFF
               call PTDATA(5,1,0,GraWav,GraSig,rGRA,nptgra)
            end if

          end do

          colore(1)=GCOLOR(1)
          call PTKWRI('COLOUR',1,colore)

          lim_x(1)=REGMIN(1)
          lim_x(2)=REGMAX(1)
          lim_y(1)=GR_YMN
          lim_y(2)=GR_YMX
          
          call PTKWRR('XWNDL',2,lim_x)        
          CALL AGWDEF(lim_x(1),lim_x(2),lim_y(1),lim_y(2))


 29     continue


c        call PTKWRC('BINMODE','OFF')
        call PTKWRC('YFORMAT','AUTO') 

        return
        end




C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE GetXCr(wave,flux,z,vel,ierr)
C
C
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

        IMPLICIT NONE
        real WAVE,flux,riplot,vel
        integer ierr

        include 'MID_REL_INCL:fit_var.inc'

        integer ikey,ier,icur,iplot
        real lim_x(2),xcur,ycur
        character*40 strapp
        DOUBLE PRECISION scafac,z

        DOUBLE PRECISION c,zr,dcur
        parameter (c=2.997D5)

C        include 'MID_REL_INCL:fit_mid.inc'
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'


          if (I_Z) then
             xcur = 0.
             ycur=1.
             lim_x(1)=-VELRAN
             lim_x(2)=VELRAN
          else
             xcur = (REGMIN(1) + REGMAX(1)) / 2.
             ycur = 1.
             lim_x(1)=REGMIN(1)
             lim_x(2)=REGMAX(1)
          endif

         call PTKWRR('XWNDL',2,lim_x)        

         call PTOPEN(' ',' ',-1,1) 

         z=0.
         vel=0.
         if (I_Z) then
           call sttdis(' VELOCITY  REDSHIFT  WAVELENGTH    FLUX',0,ier)
         else
           call sttdis(' WAVELENGTH        FLUX',0,ier)
         ENDIF
         strapp = ' '
          call sttdis(strapp,0,ier)
         
         call PTGCUR(xcur,ycur,ikey,icur)

 100    continue

         CALL AGGPLM(xcur,ycur,1,4) ! Overplots a cross

          ierr=icur
          GR_DEL = 1 + GR_BOT + GR_TOP
          riplot = (ycur + GR_BOT) / GR_DEL
          iplot = riplot
          iplot = iplot + 1

          scafac=(REGMAX(iplot)-REGMIN(iplot))/(REGMAX(1)-REGMIN(1))
          flux = ycur - (iplot - 1)*GR_DEL 
          
          strapp = ' '
          if (I_Z) then
             dcur = xcur
             wave = (1.D0 + dcur/2./c)/(1.D0-dcur/2./c)*
     1            (REGMAX(iplot)+REGMIN(iplot))/2.D0
             zr = (2.*dcur + REDSH * dcur + 2.*c*REDSH)/(2.*c - dcur)
             write(strapp,'(f9.2,f10.6,2f10.2)')xcur,zr,wave,flux
             vel=xcur
             z=zr
          else
             wave = (xcur - REGMIN(1))*scafac + REGMIN(iplot)
             write(strapp,'(f9.2,5x,f9.2)')wave,flux
          endif

          call sttdis(strapp,0,ier)
          call PTGCUR(xcur,ycur,ikey,icur)

          if (ikey.ne.32) goto 100

        return
        end

C @(#)part.for	19.1 (ES0-DMD) 02/25/03 13:27:15
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                 C
C  Generate a random partition.                                   C
C                                                                 C
C  Parameters:                                                    C
C                                                                 C
C  MEMGP(N)         Group memberships,                            C
C  NG               number of groups,                             C
C  ISEED            seed for random number generator.             C
C                                                                 C
C  Note: random number generator is machine-dependent.            C
C                                                                 C
C  F. Murtagh, ESA/ESO/STECF, Garching-bei-Muenchen, Feb. 1986.   C
C                                                                 C
C-----------------------------------------------------------------C
        SUBROUTINE RANDP(N,NG,MEMGP,ISEED)
        INTEGER N,NG,ISEED,I,ICL
        INTEGER MEMGP(N)
        REAL X,VAL,BNDRY,SRAN
C
        DO 100 I = 1, N
           MEMGP(I) = 1
  100   CONTINUE
C
        IF (NG.LE.1.OR.N.LE.1) GOTO 500
        X = 1.0/FLOAT(NG)
        DO 400 I = 1, N
           VAL = SRAN(ISEED)
           BNDRY = X
           ICL = 1
  200      IF (ICL.EQ.NG) GOTO 300
           IF (VAL.LT.BNDRY) GOTO 300
           BNDRY = BNDRY + X
           ICL = ICL + 1
           GOTO 200
  300      MEMGP(I) = ICL
  400   CONTINUE
C
  500   CONTINUE
        RETURN
        END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                 C
C  Uniform random number generator, Spaeth p. 143                 C
C  Returns real in interval [0,1)                                 C
C                                                                 C
C-----------------------------------------------------------------C
         REAL FUNCTION SRAN(IY)
         INTEGER IY,IA,IC,M2,M,MIC,ITWD
         DOUBLE PRECISION HALFM, DATAN, DSQRT
         REAL S
         DATA M2/0/,ITWD/2/
         IF (M2.NE.0) GOTO 20
         M=1
   10    M2=M
         M=ITWD*M2
         IF (M.GT.M2) GOTO 10
         HALFM=M2
         IA=8*IDINT(HALFM*DATAN(1.D0)/8.D0) + 5
         IC=2*IDINT(HALFM*(0.5D0-DSQRT(3.D0)/6.D0)) + 1
         MIC=(M2-IC)+M2
         S=0.5/HALFM
   20    IY=IY*IA
         IF(IY.GT.MIC) IY=(IY-M2)-M2
         IY=IY+IC
         IF (IY/2.GT.M2) IY=(IY-M2)-M2
         IF(IY.LT.0) IY=(IY+M2)+M2
         SRAN=FLOAT(IY)*S
         RETURN
         END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                 C
C  Optimise the variances of a set of groups, by assigning        C
C  the objects in groups such that they are minimally distant     C
C  from group centres.                                            C
C                                                                 C
C  Parameters:                                                    C
C                                                                 C
C  N, M, NG         Numbers of rows, columns, groups,             C
C  A(N,M)           initial data,                                 C
C  MEMGP(N)         group memberships,                            C
C  NGP0             minimum acceptable group cardinality,         C
C  NUMGP(NG)        cardinalities of groups,                      C
C  GPCEN(NG,M)      group centres,                                C
C  COMP(NG)         compactness values for the groups,            C
C  CTOT             sum of these compactnesses,                   C
C  IERR             error indicator (should be zero).             C
C                                                                 C
C  IERR = 1: invalid group number (<1 or >NG), - is number of     C
C  groups correctly specified?  IERR = 2: a group has < minimum   C
C  allowed number of members, - reduce the number of groups and   C
C  try again.                                                     C
C                                                                 C
C  F. Murtagh, ESA/ESO/STECF, Garching-bei-Muenchen, Feb. 1986.   C
C                                                                 C
C-----------------------------------------------------------------C
        SUBROUTINE MINDST(A,N,M,MEMGP,NGP0,NUMGP,GPCEN,NG,
     X            COMP,CTOT,ITER,IERR)
        REAL  A(N,M), GPCEN(NG,M),COMP(NG),BIG,ONE
        REAL  CMAX,X,Y,DIFF,CTOT
        INTEGER MEMGP(N),NUMGP(N),ITER,I,J,K,ICL
        INTEGER N,M,IERR,NG,NGP0
C
        BIG = 1.0E+30
        ONE = 0.999
        CMAX = BIG
        ITER = 0
  100   ITER = ITER + 1
        IF (ITER.GT.15) GOTO 500
        CALL GMEANS(A,N,M,MEMGP,NGP0,NUMGP,GPCEN,NG,IERR)
        CALL COMPCT(A,N,M,NG,MEMGP,GPCEN,COMP,CTOT)
        IF (IERR.NE.0) GOTO 500
        IF (NG.LE.1) GOTO 500
        IF (CTOT.GE.CMAX) GOTO 500
        CMAX = CTOT*ONE
        DO 400 I = 1, N
           X = BIG
           DO 300 K = 1, NG
              Y = 0.0
              DO 200 J = 1, M
                 DIFF = GPCEN(K,J) - A(I,J)
                 Y = Y + DIFF*DIFF
  200         CONTINUE
              IF (Y.GE.X) GOTO 300
              X = Y
              ICL = K
  300      CONTINUE
           MEMGP(I) = ICL
  400   CONTINUE
        GOTO 100
C
  500   RETURN
        END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                 C
C  Optimise the variances of a set of groups, by exchanging       C
C  the objects between groups such that they are minimally        C
C  distant from group centres.                                    C
C                                                                 C
C  Parameters:                                                    C
C                                                                 C
C  N, M, NG         Numbers of rows, columns, groups,             C
C  A(N,M)           initial data,                                 C
C  MEMGP(N)         group memberships,                            C
C  NGP0             minimum acceptable group cardinality,         C
C  NUMGP(NG)        cardinalities of groups,                      C
C  GPCEN(NG,M)      group centres,                                C
C  COMP(NG)         compactness values for the groups,            C
C  CTOT             sum of these compactnesses,                   C
C  IERR             error indicator (should be zero).             C
C                                                                 C
C  IERR = 1: invalid group number (<1 or >NG), - is number of     C
C  groups correctly specified?  IERR = 2: a group has < minimum   C
C  allowed number of members, - reduce the number of groups and   C
C  try again.                                                     C
C                                                                 C
C  F. Murtagh, ESA/ESO/STECF, Garching-bei-Muenchen, Feb. 1986.   C
C                                                                 C
C-----------------------------------------------------------------C
        SUBROUTINE EXCH(A,N,M,MEMGP,NGP0,NUMGP,GPCEN,NG,
     X            COMP,CTOT,ITER,IERR)
        REAL    A(N,M),GPCEN(NG,M), COMP(NG)
        REAL    BIG,ONE,V,EQ,X,FRAC1,FRAC2,EP
        REAL    EK,DIFF,FRAC,VAL,CTOT,W
        INTEGER MEMGP(N),NUMGP(NG),N,M,IERR,NG
        INTEGER ITER,I,ICL,NUM,IS,J,K,NGP0,IQ 
C
        BIG = 1.0E+30
        ONE = 0.999
        CALL GMEANS(A,N,M,MEMGP,NGP0,NUMGP,GPCEN,NG,IERR)
        CALL COMPCT(A,N,M,NG,MEMGP,GPCEN,COMP,CTOT)
        IF (IERR.NE.0) GOTO 800
        IF (NG.LE.1) GOTO 800
        ITER = 0
        I = 0
        IS = 0
  100   IS = IS + 1
        IF (IS.GT.N) GOTO 800
  200   I = I + 1
        IF (I.LE.N) GOTO 300
        ITER = ITER + 1
        IF (ITER.GT.15) GOTO 800
        I = 1
  300   ICL = MEMGP(I)
        NUM = NUMGP(ICL)
        IF (NUM.LE.NGP0) GOTO 100
        V = NUM
        EQ = BIG
        DO 600 K = 1, NG
           X = 0.0
           DO 400 J = 1, M
              DIFF = GPCEN(K,J) - A(I,J)
              X = X + DIFF*DIFF
  400      CONTINUE
           IF (K.NE.ICL) GOTO 500
           FRAC1 = V/(V-1.0)
           EP = X*FRAC1
           GOTO 600
  500      FRAC2 = NUMGP(K)
           FRAC = FRAC2/(FRAC2+1.0)
           EK = FRAC*X
           IF (EK.GE.EQ) GOTO 600
           EQ = EK
           IQ = K
           W = FRAC2
  600   CONTINUE
        IF (EQ.GE.EP*ONE) GOTO 100
        IS = 0
        COMP(ICL) = COMP(ICL) - EP
        COMP(IQ) = COMP(IQ) + EQ
        CTOT = CTOT - EP + EQ
        FRAC1 = 1.0/(V-1.0)
        FRAC2 = 1.0/(W+1.0)
        DO 700 J = 1, M
           VAL = A(I,J)
           GPCEN(ICL,J) = (V*GPCEN(ICL,J)-VAL)*FRAC1
           GPCEN(IQ,J) = (W*GPCEN(IQ,J)+VAL)*FRAC2
  700   CONTINUE
        MEMGP(I) = IQ
        NUMGP(ICL) = NUM - 1
        NUMGP(IQ) = NUMGP(IQ) + 1
        GOTO 200
C
  800   CONTINUE
        RETURN
        END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                 C
C  Standardize to zero mean and unit standard deviation.          C
C                                                                 C
C  Parameters:                                                    C
C                                                                 C
C  N, M, NG         Numbers of rows, columns, groups,             C
C  A(N,M)           initial data, replaced by standardized values.C
C                                                                 C
C  F. Murtagh, ESA/ESO/STECF, Garching-bei-Muenchen, Feb. 1986.   C
C                                                                 C
C-----------------------------------------------------------------C
        SUBROUTINE STND(A,N,M)
        INTEGER I,J,M,N
        REAL  A(N,M),DIFF,XBAR,X
C
        DO 500 J = 1, M
           X = 0.0
           DO 100 I = 1, N
              X = X + A(I,J)
  100      CONTINUE
           XBAR = X/FLOAT(N)
           X = 0.0
           DO 200 I = 1, N
              DIFF = A(I,J) - XBAR
              X = X + DIFF*DIFF
  200      CONTINUE
           IF (X.LE.0.0) X = 1.0
           X = 1.0/SQRT(X)
           DO 300 I = 1, N
              A(I,J) = X*(A(I,J)-XBAR)
  300      CONTINUE
  500   CONTINUE
C
        RETURN
        END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                 C
C  Determine means of the groups.                                 C
C                                                                 C
C  Parameters:                                                    C
C                                                                 C
C  N, M, NG         Numbers of rows, columns, groups,             C
C  A(N,M)           initial data,                                 C
C  MEMGP(N)         group memberships,                            C
C  NGP0             minimum acceptable group cardinality,         C
C  NUMGP(NG)        cardinalities of groups,                      C
C  GPCEN(NG,M)      group centres,                                C
C  IERR             error indicator (should be zero).             C
C                                                                 C
C  F. Murtagh, ESA/ESO/STECF, Garching-bei-Muenchen, Feb. 1986.   C
C                                                                 C
C-----------------------------------------------------------------C
        SUBROUTINE GMEANS(A,N,M,MEMGP,NGP0,NUMGP,GPCEN,NG,IERR)
        REAL       A(N,M), GPCEN(NG,M),X
        INTEGER    MEMGP(N),NUMGP(NG),K,NG,I,M,N
        INTEGER    ICL,J,NUM,IERR,NGP0
C
        DO 200 K = 1, NG
           NUMGP(K) = 0
           DO 100 J = 1, M
              GPCEN(K,J) = 0.0
  100      CONTINUE
  200   CONTINUE
C
        DO 500 I = 1, N
           ICL = MEMGP(I)
           IF (ICL.GE.1.AND.ICL.LE.NG) GOTO 300
              IERR = 1
              RETURN
  300      CONTINUE
           NUMGP(ICL) = NUMGP(ICL) + 1
           DO 400 J = 1, M
              GPCEN(ICL,J) = GPCEN(ICL,J) + A(I,J)
  400      CONTINUE
  500   CONTINUE
C
        DO 800 K = 1, NG
           NUM = NUMGP(K)
           IF (NUM.GE.NGP0) GOTO 600
              IERR = 2
              RETURN
  600      CONTINUE
           X = 1.0/FLOAT(NUM)
           DO 700 J = 1, M
              GPCEN(K,J) = GPCEN(K,J)*X
  700      CONTINUE
  800   CONTINUE
C
        RETURN
        END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                 C
C  Determine compactness of the groups (i.e. their variances).    C
C                                                                 C
C  Parameters:                                                    C
C                                                                 C
C  N, M, NG         Numbers of rows, columns, groups,             C
C  A(N,M)           initial data,                                 C
C  MEMGP(N)         group memberships,                            C
C  GPCEN(NG,M)      group centres,                                C
C  COMP(NG)         variances of groups (output),                 C
C  CTOT             sum of these variances.                       C
C                                                                 C
C  F. Murtagh, ESA/ESO/STECF, Garching-bei-Muenchen, Feb. 1986.   C
C                                                                 C
C-----------------------------------------------------------------C
        SUBROUTINE COMPCT(A,N,M,NG,MEMGP,GPCEN,COMP,CTOT)
        REAL       A(N,M), GPCEN(NG,M), COMP(NG),X
        REAL       DIFF,CTOT
        INTEGER    MEMGP(N)
        INTEGER    N,M,NG,I,J,K,ICL
C
        CTOT = 0.0
        DO 100 K = 1, NG
           COMP(K) = 0.0
  100   CONTINUE
C
        DO 300 I = 1, N
           ICL = MEMGP(I)
           X = 0.0
           DO 200 J = 1, M
              DIFF = GPCEN(ICL,J) - A(I,J)
              X = X + DIFF*DIFF
  200      CONTINUE
           COMP(ICL) = COMP(ICL) + X
           CTOT = CTOT + X
  300   CONTINUE
C
        RETURN
        END

C @(#)gd8m1.for	19.1 (ES0-DMD) 02/25/03 13:55:09
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
	SUBROUTINE GD8018(DISPLAY,CHAN,NOCHAN,VALUE,IDST)
C	
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine IIMCMY		version 1.00	880122
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  DeAnza, memory
C
C.PURPOSE
C  fulfill the requirements as described in the IDI document
C
C.ALGORITHM
C  use DeAnza level 0 software
C
C.INPUT/OUTPUT
C  call as  IIMCMY(DISPLAY,CHAN,NOCHAN,VALUE,IDST)
C
C  input par:
C  DISPLAY:	I*4		display id.
C  CHAN:	I*4 array	memory ids
C  NOCHAN:	I*4		no. of memory ids
C  VALUE:	I*4		constant
C
C  output par:
C  IDST:	I*4		return status
C	
C.VERSIONS
C
C--------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,CHAN(1),NOCHAN,VALUE,IDST
	INTEGER*4	N,NN
C	
	INTEGER*2	UNIT,BYTSTR(40),RES
	INTEGER*2	LAR,LPA,RR,LR,WR,LMC
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
	INCLUDE	'MID_INCLUDE:IDIDEV.INC'
	INCLUDE	'MID_INCLUDE:IDIMEM.INC'
C	
	DATA	BYTSTR	/40*0/
C	
	EXTERNAL	LAR,LPA,RR,LR,WR,LMC
C
	UNIT = DISPLAY
C
C  loop through memories
	DO NN=1,NOCHAN
	   N = CHAN(NN) + 1
C
C  if alpha memory treat it differently
	   IF (N.GT.90) THEN
C	
C  make sure we work on high resolution
	      CALL IP8QW(RR,UNIT,DZIOSB,,,SYSREG(12),2,0,11)		!reg. 11
	      RES = IAND(SYSREG(12),"177677)		!force to full byte xfer
	      CALL IP8QW(LR,UNIT,DZIOSB,,,RES,2,0,11)	
C	
C  load address register (reg. 0) of alphanumerics board with addr. 0
	      CALL IP8QW(LAR,UNIT,DZIOSB,,,0,2,0,0)	!CAP = 0 for A/N board
C	
C  send 25 times 80 bytes to A/N board
	      DO N=1,25
	         CALL IP8QW(LPA,UNIT,DZIOSB,,,BYTSTR,80,0,2)	!A/N is group 2
	      ENDDO
C	
C  reset resolution in reg. 11
	      CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(12),2,0,11)		!reg. 11
	   ELSE	
C	
C  set up memory registers
	      MEMREG(1,N) = 0
	      MEMREG(2,N) = QDSZY - 1
	      MEMREG(3,N) = -1				!default for register 2
	      MEMREG(4,N) = IAND(MEMREG(4,N),"175777)	!clear G bit (10)
	      IF (CHAN(NN).EQ.QOVCH)			!if graphics channel...
     +		 MEMREG(4,N) = IOR(MEMREG(4,N),"2000)	!set G bit again
	      MEM7RG(N) = 0				!default for register 7
C	
	      CALL IP8QW(LMC,UNIT,DZIOSB,,,MEMREG(1,N),8,CHAN,0)
C 	
C  get system registers 10 - 31, and 32,33 = CMR0
	      CALL IP8QW(RR,UNIT,DZIOSB,,,SYSREG(11),48,1,10)
C	
C  set up CMR0 for memory channel CHAN(NN)
	      SYSREG(33) = 2**CHAN(NN)
	      SYSREG(34) = 0			!34+33 = CMR0 (CHAN always < 15)
C	
C  set the X registers
	      SYSREG(17) = 0				!X = start value	(16)
	      SYSREG(18) = 0				!XT = 0		(17)
	      SYSREG(19) = SYSREG(17)			!XMIN = X	(18)
	      SYSREG(20) = QMSZX - 1			!XMAX = last value (19)
	      SYSREG(21) = 0				!XAMIN = 0	(20)
	      SYSREG(22) = SYSREG(20)			!XAMAX = XMAX
	      SYSREG(23) = SYSREG(20)			!DX = XAMAX	(22)
	      SYSREG(24) = 0				!XTEMP = 0	(23)
C
C  set the Y registers
	      SYSREG(25) = 0				!Y = start value	(24)
	      SYSREG(26) = 0				!YT = 0		(25)
	      SYSREG(27) = SYSREG(25)			!YMIN = Y	(26)
	      SYSREG(28) = QMSZY - 1			!YMAX = last value (27)
	      SYSREG(29) = 0				!YAMIN = 0	(28)
	      SYSREG(30) = SYSREG(28)			!YAMAX = YMAX
	      SYSREG(31) = SYSREG(28)			!DY = YAMAX	(30)
	      SYSREG(32) = 0				!YTEMP = 0	(31)
C	
C  set up matrix mode, x-primary, y-secondary, positive increments
	      SYSREG(11) = "10			!CONTROL	(10)
C	
C  set resolution to single byte transfer
	      SYSREG(12) = IAND(SYSREG(12),"177477)	!RESOLUTION	(11)
	      SYSREG(12) = IOR(SYSREG(12),"100)
C	
C  fill foreground register with value
	      SYSREG(13) = VALUE			!FG		(12)
C	
C  write system registers back
	      CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(11),48,1,10)
C	
C  finally issue the "write rectangle command"
	      CALL IP8QW(WR,UNIT,DZIOSB,,,N,2,0,1)		!N is dummy value...
C	
C  reset to non matrix mode
	      SYSREG(11) = 0			!CONTROL	(10)
	      CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(11),2,0,10)
	   ENDIF
C
	ENDDO
C	
	IDST = 0
	RETURN
	END

	SUBROUTINE GD8020(DISPLAY,CHAN,LOADFL,SZX,SZY,DEPTH,
     +		          XBEG,YBEG,IDST)
C	
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine IIMSTW		version 1.00	880616
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  DeAnza, initialisation
C
C.PURPOSE
C  fulfill the requirements as described in the IDI document
C
C.ALGORITHM
C  use DeAnza level 0 software
C
C.INPUT/OUTPUT
C  call as  IIMSTW(DISPLAY,CHAN,LOADFL,SZX,SZY,DEPTH,XBEG,YBEG,IDST)
C
C  input par:
C  DISPLAY:	I*4		display id.
C  CHAN:	I*4		memory id
C  LOADFL:	I*4		load direction: 0 = bottom-up, 1 = top-down
C  SZX:		I*4		size in x
C  SZY:		I*4		size in y
C  DEPTH:	I*4		depth in bits per pixel
C  XBEG:	I*4		x offset
C  YBEG:	I*4		y offset
C
C  output par:
C  IDST:	I*4		return status
C	
C.VERSIONS
C
C--------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,CHAN,SZX,SZY,LOADFL,DEPTH,IDST,XBEG,YBEG
	INTEGER*4	N,NN
C	
	INTEGER*2	UNIT,FCREG,POWCHAN(10)
	INTEGER*2	LMC,LR,LVR,RR,RVR
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
	INCLUDE	'MID_INCLUDE:IDIDEV.INC/NOLIST'
	INCLUDE	'MID_INCLUDE:IDIMEM.INC/NOLIST'
C	
	EXTERNAL	LMC,LR,LVR,RR,RVR
C	
	DATA	POWCHAN	/1,2,4,8,16,32,64,128,256,512/
C
C	
	UNIT = DISPLAY
	N = CHAN + 1
C	
C  read + modify relevant system registers
	CALL IP8QW(RR,UNIT,DZIOSB,,,SYSREG(12),42,1,11)
C	
C  set to non-matrix mode and take care of load direction (in register 10)
	IF (LOADFL.EQ.0) THEN
	   SYSREG(11) = 0			!bottom-up
	ELSE
	   SYSREG(11) = 2			!top-down
	ENDIF
C
C  set RESOLUTION register (reg 11):
C  always 2 bytes xfer
C	
	SYSREG(12) = IAND(SYSREG(12),"177677)
C
C  set the X registers
	SYSREG(17) = XBEG			!X = start value	(16)
	SYSREG(18) = 0				!XT = 0		(17)
	SYSREG(19) = SYSREG(17)			!XMIN = X	(18)
	SYSREG(20) = SYSREG(17) + SZX -1	!XMAX = last value (19)
	SYSREG(21) = 0				!XAMIN = 0	(20)
	SYSREG(22) = QMSZX - 1			!XAMAX = 511,1023, ... (21)
	SYSREG(23) = 0				!DX = 0		(22)
	SYSREG(24) = 0				!XTEMP = 0	(23)
C
C  set the Y registers
	SYSREG(25) = YBEG			!Y = start value	(24)
	SYSREG(26) = 0				!YT = 0		(25)
	SYSREG(27) = SYSREG(25)			!YMIN = Y	(26)
	SYSREG(28) = SYSREG(25) + SZY -1	!YMAX = last value (27)
	SYSREG(29) = 0				!YAMIN = 0	(28)
	SYSREG(30) = QMSZY - 1			!YAMAX = 511,1023,... (29)
	SYSREG(31) = 0				!DY = 0		(30)
	SYSREG(32) = 0				!YTEMP = 0	(31)
C	
C  and write it all out
	CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(11),44,1,10)
C	
C  set up CMR 0 + 1
C	
	SYSREG(33) = POWCHAN(N)
	SYSREG(34) = 0			!34+33 = CMR0 (CHAN always < 15)
	IF (DEPTH.EQ.16) THEN
	   SYSREG(35) = POWCHAN(N+1)
	ELSE
	   SYSREG(35) = 0
	ENDIF
	SYSREG(36) = 0			!36+35 = CMR1 (CHAN always < 15)
	CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(33),8,1,32)
C
C  for graphics channel we also have to update the FCRs
	IF (CHAN.EQ.QOVCH) THEN
	   CALL IP8QW(RVR,UNIT,DZIOSB,,,FCR(5),8,0,12)
	   FCREG = ISHFT(CHAN,8)		!put channel into left byte of FCREG
	   DO N=5,8
	      FCR(N) = IAND(FCR(N),"377)	!clear left byte of FCRs
	      FCR(N) = IOR(FCR(N),FCREG)	!and replace by FCREG
	   ENDDO
C	
	   CALL IP8QW(LVR,UNIT,DZIOSB,,,FCR(5),8,0,12)
	ENDIF
C	
C  alright then...
	IDST = 0
	RETURN
	END

	SUBROUTINE GD8017(DISPLAY,CHAN,PIX,SIZE,DEPTH,PACK,XBEG,YBEG,IDST)
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION:
C  subroutine IIMWMY		version 1.00	880118
C  K. Banse			ESO - Garching
C
C.KEYWORDS:
C  memory, DeAnza
C
C.PURPOSE:
C  write a 2-dimensional image into given memory board of DeAnza
C  handle the functions as described in the IDI document
C
C.ALGORITHM:
C  wait for unit to be ready
C  send the data (either low byte or both are transferred)
C	
C.INPUT/OUTPUT:
C  call as IIMWMY(DISPLAY,CHAN,PIX,SIZE,DEPTH,PACK,XBEG,YBEG,IDST)
C
C  input par:
C  DISPLAY:	I*4		unit no.
C  CHAN:	I*4 array	memory board(s) to store image in
C  PIX:		I*4 array	array containing the pixels
C  SIZE:	I*4		no. of pixels
C  DEPTH:	I*4		depth of pixel
C  PACK:	I*4		packing factor:
C				1, 2 or 4 pixels per integer (32 bits)
C  XBEG:	I*4		data position in x
C  YBEG:	I*4		data position in y
C	
C  Note:	the XBEG, YBEG values are ignored, for the data positions
C		in x and y are initialized once and automatically upgraded
C		by subsequent writes ...
C
C  output par:
C  IDST:	I*4		return status
C
C------------------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4 	DISPLAY,CHAN,SIZE,DEPTH,PACK
	INTEGER*4	XBEG,YBEG,PIX(1),IDST
	INTEGER*4	NN
C
	INTEGER*2	UNIT,NO_BYTES
	INTEGER*2	WI
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
	INCLUDE	'MID_INCLUDE:IDIDEV.INC/NOLIST'
	INCLUDE	'MID_INCLUDE:IDIMEM.INC/NOLIST'
C	
	EXTERNAL 	WI
C
C  set total transfer rate
	UNIT = DISPLAY
	IF (DEPTH.EQ.8) THEN
	   NN = SIZE
	   NO_BYTES = 1
	ELSE
	   NN = SIZE * 2
	   NO_BYTES = 2
	ENDIF
C
C  send everything to the DeAnza in one go
	CALL IP8W(UNIT)
	CALL IP8Q(WI,UNIT,DZIOSB,,,PIX,NN,NO_BYTES,1)		!don't wait for completion
C
C  we've done it again
	IDST = 0
	RETURN
	END

	SUBROUTINE GD8019(DISPLAY,CHAN,SIZE,XBEG,YBEG,DEPTH,
     +                    PACK,ITTFLG,PIX,IDST)
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION:
C  subroutine IIMRMY		version 1.00	880118
C  K. Banse			ESO - Garching
C
C.KEYWORDS:
C  memory, DeAnza
C
C.PURPOSE:
C  read a 2-dimensional image from given memory board of DeAnza
C  handle the functions as described in the IDI document
C
C.ALGORITHM:
C  wait for unit to be ready
C  read the data (either low byte or both are transferred)
C	
C.INPUT/OUTPUT:
C  call as IIMRMY(DISPLAY,CHAN,SIZE,XBEG,YBEG,DEPTH,PACK,ITTFLG,PIX,IDST)
C
C  input par:
C  DISPLAY:	I*4		unit no.
C  CHAN:	I*4 array	memory board(s) to store image in
C  SIZE:	I*4		no. of pixels
C  DEPTH:	I*4		depth of pixel
C  XBEG:	I*4		data position in x
C  YBEG:	I*4		data position in y
C	
C  output par:
C  PIX:		I*4 array	array containing the pixels
C  IDST:	I*4		return status
C
C.VERSIONS
C
C------------------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4 	DISPLAY,CHAN,SIZE,DEPTH,PACK,ITTFLG
	INTEGER*4	XBEG,YBEG,IDST
	INTEGER*4	NOCHUNKS,REMAINDER,NOFF,NITT,ILADR,N
C
	INTEGER*2	UNIT,NO_BYTES,SAVREG(8),ITT(256)
	INTEGER*2	RESREG,TEMP
	INTEGER*2	RI,LR,RR,LMC,RPA
C 
	BYTE		PIX(1),TPIX(2)
C 
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
	INCLUDE	'MID_INCLUDE:IDIDEV.INC'
	INCLUDE	'MID_INCLUDE:IDIMEM.INC'
C 
	EQUIVALENCE	(TEMP,TPIX(1))
C	
	EXTERNAL 	RI,LR,RR,LMC,RPA
C
	UNIT = DISPLAY
C	
C  check depth
	IF (DEPTH.NE.8) THEN
	   NO_BYTES = 2
	   IDST = 1			!currently only 8-bit pixels supported
	   RETURN
	ELSE
	   NO_BYTES = 1
	ENDIF
C 
C  if we only want to get 1 pixel we set up the transfer window here
C  otherwise a call to IIMSTW should have been done before... !!!
C 
	IF (SIZE.EQ.1) THEN
C 
C  set RESOLUTION register (reg 11) to 2 bytes transfer
	   CALL IP8QW(RR,UNIT,DZIOSB,,,SYSREG(12),42,1,11)
	   SYSREG(12) = IAND(SYSREG(12),"177677)	
	   CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(12),2,0,11)
C 
	   DO NOFF=1,4
	      SAVREG(NOFF) = SYSREG(16+NOFF)
	      SAVREG(4+NOFF) = SYSREG(24+NOFF)
	   ENDDO
C	
C  set up x-, y-registers
	   SYSREG(17) = XBEG
	   SYSREG(18) = 0
	   SYSREG(19) = XBEG
	   SYSREG(20) = XBEG
	   CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(17),8,1,16)
	   SYSREG(25) = YBEG
	   SYSREG(26) = 0
	   SYSREG(27) = YBEG
	   SYSREG(28) = YBEG 
	   CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(25),8,1,24)
C	
C  load CMR 0 + read the one value
	   SYSREG(33) = 2**CHAN
	   CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(33),2,1,32)
	   CALL IP8QW(RI,UNIT,DZIOSB,,,PIX(1),1,NO_BYTES,1)
C 
C  reset the system registers as they were
	   DO NOFF=1,4
	      SYSREG(16+NOFF) = SAVREG(NOFF) 
	      SYSREG(24+NOFF) = SAVREG(4+NOFF) 
	   ENDDO
	   CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(17),8,1,16)
	   CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(25),8,1,24)
	ELSE
C	
C  get no. of chunks of 32000 pixels
	   NOCHUNKS = SIZE / 32000
	   REMAINDER = SIZE - (NOCHUNKS*32000)
C
C  read everything from the DeAnza
	   NOFF = 1
	   DO WHILE (NOCHUNKS.GT.0)
	      CALL IP8QW(RI,UNIT,DZIOSB,,,PIX(NOFF),32000,NO_BYTES,1)
	      NOFF = NOFF + 32000			!PIX is declared as I*4 ...!
	      NOCHUNKS = NOCHUNKS - 1
	   ENDDO
C	
	   IF (REMAINDER.GT.0)
     +	      CALL IP8QW(RI,UNIT,DZIOSB,,,PIX(NOFF),REMAINDER,NO_BYTES,1)
	ENDIF
C 
C  now see, if we also have to do the ITT mapping
	IF (ITTFLG.EQ.0) GOTO 9000
C 
	CALL IP8QW(RR,UNIT,DZIOSB,,,SYSREG(12),2,0,11)
	RESREG = IAND(SYSREG(12),"177677)	
	RESREG = IOR(RESREG,"100)
	CALL IP8QW(LR,UNIT,DZIOSB,,,RESREG,2,0,11)
C 
C  build ITT address
	IF (ITTNUM.LE.3) THEN
	   NITT = ITTNUM
	ELSE
	   NITT = ITTNUM - 100
	ENDIF
	N = "10000				!set ITT enable bit
	ILADR = IOR(N,ISHFT(NITT,8))		!integrate also ITT section
	N = CHAN + 1
	MEMREG(4,N) = IAND(MEMREG(4,N),"176377)		!clear L9,L8 bit (9,8)
	MEMREG(4,N) = IOR(MEMREG(4,N),ILADR)
C
C  read the table from the DeAnza
	CALL IP8QW(LMC,UNIT,DZIOSB,,,MEMREG(4,N),2,CHAN,3)	!set LUT address reg.
	N = 256							!no. of elements
	CALL IP8QW(RPA,UNIT,DZIOSB,,,ITT,N*2,CHAN,0)
	DO N=1,256
	   ITT(N) = IAND(ITT(N),"377)
	ENDDO
C 
C  and reset the Resolution register
	CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(12),2,0,11)
C 
C  now map through the ITT
	DO N=1,SIZE
	   TEMP = 0
	   TPIX(1) = PIX(N)
	   TEMP = ITT(TEMP+1)
	   PIX(N) = TPIX(1)
	ENDDO
C	
C  we've done it again
9000	IDST = 0
	RETURN
	END

C @(#)sort1.for	19.1 (ES0-DMD) 02/25/03 13:30:48
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE SORT1(RA,N) 
C+++
C.IDENTIFICATION
C.AUTHOR:   M.Rosa, ESO-Garching, 831105
C.PURPOSE:  Sort string of values into ascending sequence of values 
C.ALGORITM: The art of scientific computing
C           Press et al., Cambridge university Press, 1986
C.USE:      CALL SORT2(XC,YC,N)                      
C.VERSION:  910115 RHW IMPLICIT NONE added
C---
C     
      IMPLICIT   NONE
      INTEGER    N
      REAL       RA(N)
C
      INTEGER    I, IR
      INTEGER    J
      INTEGER    L
      REAL       RRA
                         
      L  = N/2 + 1
      IR = N      
                  
10    CONTINUE
      IF (L.GT.1) THEN
         L      = L - 1
         RRA    = RA(L)
      ELSE 

         RRA    = RA(IR)
         RA(IR) = RA(1)
         IR     = IR - 1

         IF (IR.EQ.1) THEN 
            RA(1) = RRA
            RETURN
         ENDIF
      ENDIF

      I = L 
      J = L+L

20    CONTINUE
      IF (J.LE.IR) THEN
         IF (J.LT.IR) THEN
            IF (RA(J).LT.RA(J+1)) THEN
               J = J + 1
            ENDIF
         ENDIF

         IF (RRA.LT.RA(J)) THEN
            RA(I) = RA(J)
            I     = J
            J     = J + J
         ELSE
            J     = IR + 1 
         ENDIF
         GO TO 20
      ENDIF

      RA(I) = RRA
      GO TO 10
      END 

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
         PROGRAM ESODCON
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENT         esodcon.for
C.MODULE
C.AUTHOR        Andrew T. Young
C.KEYWORD
C.LANGUAGE      FORTRAN 77
C.PURPOSE       convert La Silla photometric data files to uniform ascii
C.COMMENTS
C.VERSION       5.2
C 
C 100621	last modif
C-----------------------------------------------------------------------------
C*****************************************************************************
C
C       This program reads data recorded in intermixed formats and combines
C       them into a uniform format, in the file 'data.dat' that is converted
C       into a MIDAS table-format file, using the *.fmt file ''.
C
C       The version you see here is designed to convert data from the ESO
C       1-meter telescope, as described in "The Optical Photometer on the
C       ESO 1m Telescope" by H. Lindgren & F. Gutierrez W. (ESO Operating
C       Manual No. 14, Version No.1, August 1991).  These data come in
C       several different card-image formats, flagged by a digit in col.1.
C       These codes are read and decoded at statements 110-190 in the main
C       program.
C
C       The basic method is to load the data as they are read from different
C       types of cards into the COMMON blocks /OUTR/ and /OUTC/, which hold
C       real and character variables, respectively.  (Some compilers want you
C       to keep such blocks separate.)  When enough card images have been read
C       to make a complete observation, the contents of /OUT*/ are written to
C       the uniform-format file 'data.dat'; then the common blocks are cleared,
C       to the appropriate "null" values.  (Blanks are used to clear character
C       strings.)
C
C       The MIDAS command CREATE/TABLE can then be used, with the *.fmt file
C       supplied, to convert the uniform 'data.dat' file to MIDAS table format.
C       This is done in the command CONVERT/PHOT.
C
C       The only tricky things in this data reformatting are:
C
C            1. The ESO Data contain retroactive cancellation codes.
C               This requires a look-ahead/look-back feature, which is
C               handled by storing the incoming data lines in a circular
C               buffer, LINE(nline).  The READER subroutine does the
C               looking back, to delete cancelled data.  This involves
C               some tricky indexing; be sure you understand what is going
C               on here before you change anything!
C
C            2. As long as we have the line buffer available, we use it to
C               assign times to COMMENT cards.  Times are simply interpolated
C               between the actual times of observations.  When a COMMENT is
C               longer than 32 characters, the pieces are ordered by assigning
C               times successively 0.1 second later to the second and third
C               32-byte parts.  Comments need times, because the MIDAS table
C               can be rearranged (e.g., by sorting on some column), and only
C               sorting on the MJD_OBS column will restore everything to the
C               proper order.
C
C*****************************************************************************
C
C
C  BEGIN Declarations:
C
        DOUBLE PRECISION DJD, DJZ, DJZ1, OLDMJD
C
        INTEGER INULL
        REAL RNULL
        DOUBLE PRECISION DNULL
        COMMON /NULLS/ INULL, RNULL, DNULL
C
        LOGICAL MATCH
        LOGICAL EFLAG, UTWRAP, SIDTIM, TIMSEL
        INTEGER NDATA, NOUTP
C
        INTEGER MXLINE
        PARAMETER(MXLINE=100)
        CHARACTER*80 LINE(MXLINE), DATFIL
        COMMON /LINES/LINE
        SAVE /LINES/
        COMMON /BUF/LENBUF, NOW
C 
        CHARACTER*32  CTEST
C
        CHARACTER A*1
        CHARACTER*10 RASTR, DESTR,UTSTR, TIME
        CHARACTER*32 COM1,COM2,COM3, OBJNAM
        CHARACTER*3 MON
        DOUBLE PRECISION DJ
C
C       Filter conversion table:
C
        CHARACTER*8 FILTCD(20),BNDNAM(20)
        COMMON /FILTBC/ FILTCD,BNDNAM
C
C
C       Declarations for the output (must be in WRITER too!):
C
        DOUBLE PRECISION MJDOBS
        COMMON /OUTR/ SIGNAL,EXPTIME,MJDOBS, GENEVAQ,GENEVAR,GENEVAG
        CHARACTER OBJECT*32,STARSKY*4,BAND*8,COMMENT*32
        COMMON /OUTC/ OBJECT,STARSKY,BAND,COMMENT
C
C
        INTEGER LENBUF, NOW, ITBL, ISTAT, NCOLS, NROWS, NSORTC, NWPRAL, 
     1   NROWSAL, NCOL, NCDIAM, NROW, NLINE, I, I1, I2, M, MON2M, NTYPE, 
     2         ID, NFILT, NSTSK, K, K2
        REAL SIGNAL, EXPTIME, GENEVAQ, GENEVAR, GENEVAG, DIAM, 
     1     ELONG, PHI, OLDUT, UT1, UT2, UT, TIMER, DAY, YEAR, STUTZH, 
     2     STUTZROT, TINT, SIGIN, FNINTS, STDDEV, GENQ, GENR, GENG, FLST
C
C  Set up MIDAS declarations:
C
        INTEGER MADRID(1)
C
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
        COMMON /VMR/ MADRID
C
        INTEGER NACTEL, IUNIT, NULLS
        CHARACTER CARD*80
C
C  END Declarations.
C
C
C  BEGIN DATA statements:
C
        INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
        DATA NDATA/7/, NOUTP/8/
C
C  END DATA statements.
C
C
C  ********************  PROLOGUE  ********************
C
        CALL STSPRO ('ESODCON')
C
C       Because the Sun library barfs on -Inf (which is used as NULL
C       by MIDAS), I define my own "NULL" values here as 3.e33:
C
        RNULL=3.E33
        DNULL=3.D33
C
C  Real program begins here:            (use RUN ESODCON to test in MIDAS)
C
C
        INQUIRE(FILE='data.dat',EXIST=EFLAG)
        IF (EFLAG) THEN
                CALL TV('File "data.dat" already exists!')
    1           CALL ASK ('Do you want to write over it?? ',A)
                IF (MATCH(A,'Y')) THEN
                        OPEN(NOUTP,FILE='data.dat',STATUS='UNKNOWN')
                        REWIND NOUTP
                        CLOSE (NOUTP,STATUS='DELETE')
                ELSE IF (MATCH(A,'N')) THEN
                        CALL STETER(1,
     1                  'Please move "data.dat" to a new name.')
                ELSE
                        CALL TV('Please reply "yes" or "no".')
                        GO TO 1
                END IF
         END IF
C               Open the uniform-format ascii file:
        OPEN(NOUTP,FILE='data.dat',STATUS='UNKNOWN')
        REWIND NOUTP
C
C       Find telescope coordinates:
C
        INQUIRE (FILE='esotel.tbl', EXIST=EFLAG)
        IF (EFLAG) THEN
                CALL TBTOPN ('esotel.tbl', 0,  ITBL, ISTAT)
                IF (ISTAT.NE.0) THEN
                        CALL TV('Problem opening "esotel.tbl".')
                        CALL STETER(2,'Do you have read permission?')
                END IF
                CALL TBIGET (ITBL,
     1                    NCOLS, NROWS, NSORTC, NWPRAL, NROWSAL, ISTAT)
                CALL TBLSER (ITBL, 'TELESCOP',  NCOL, ISTAT)
                CALL TBLSER (ITBL, 'DIAM',  NCDIAM, ISTAT)
                CALL TV(' ')
                CALL TV ('Which telescope did you use?')
                DO 2 NROW=1,NROWS
                CALL TBERDC (ITBL, NROW, NCOL,  CTEST, EFLAG, ISTAT)
                IF (EFLAG.OR. ISTAT.NE.0) GOTO 2
                CALL FT_EOS (CTEST,32,COM2,ISTAT)
                CALL TBERDR (ITBL, NROW, NCDIAM,  DIAM, EFLAG, ISTAT)
                IF (EFLAG.OR. ISTAT.NE.0) GOTO 2
                WRITE (COM1,'(8X,I2,'':  '',A8,F6.2,'' m'')')
     1                              NROW,COM2,DIAM
                CALL TV (COM1)
    2           CONTINUE
                WRITE(COM1,'(8X,I2,'':  (None of these)'')') NROWS+1
                CALL TV(COM1)
                CALL ASK ('Please enter the number: ',COM1)
    3           READ (COM1,'(BN,I2)', ERR=4) NROW
                IF (NROW.LE.NROWS .AND. NROW.GE.1) THEN
                        CALL TBERDC (ITBL,NROW,NCOL,CTEST,EFLAG,ISTAT)
                        CALL FT_EOS (CTEST,32,COM2,ISTAT)
                ELSE
                        COM2='"none"'
                END IF
                GO TO 6
    4           DO 5 NROW=1,NROWS
                CALL TBERDC (ITBL, NROW, NCOL, CTEST, EFLAG, ISTAT)
                CALL FT_EOS (CTEST,32,COM2,ISTAT)
                IF (COM1.EQ.COM2) THEN
                        GO TO 6
                END IF
    5           CONTINUE
                CALL ASK ('Please use the numbers at left.',COM1)
                GO TO 3
    6           WRITE(COM1,'(''   You selected '',A8)') COM2
                CALL TV (COM1)
                IF (NROW.LE.NROWS .AND. NROW.GE.1) THEN
                        CALL TBLSER (ITBL, 'LON',  NCOL, ISTAT)
                        CALL TBERDR (ITBL,NROW,NCOL, ELONG,EFLAG,ISTAT)
                        IF(EFLAG.OR. ISTAT.NE.0) THEN
                            CALL QF('Enter EAST longitude (deg):',
     1                                 ELONG)
                        END IF
                        CALL TBLSER (ITBL, 'LAT',  NCOL, ISTAT)
                        CALL TBERDR (ITBL,NROW,NCOL, PHI,EFLAG,ISTAT)
                        IF(EFLAG.OR. ISTAT.NE.0) THEN
                             CALL QF('Enter Latitude (deg):', PHI)
                        END IF
                ELSE
                        CALL QF('Enter EAST longitude (deg):', ELONG)
                        CALL QF('Enter Latitude (deg):', PHI)
                END IF
                ELONG=ELONG/15.
                CALL TBTCLO(ITBL, ISTAT)
        ELSE
                CALL TV('File "esotel.tbl" not available!')
                CALL STETER(3,'Please get a copy of "esotel.tbl"')
        END IF
C
C       Get filter conversion table:
C
        CALL FILTBL
C
C       clear data storage:
C
        OBJECT=' '
        STARSKY=' '
        BAND=' '
        COMMENT=' '
        SIGNAL=RNULL
        EXPTIME=RNULL
        GENEVAQ=RNULL
        GENEVAR=RNULL
        GENEVAG=RNULL
        MJDOBS=DNULL
C
C       *** Prepare input buffer ***
C
        CALL TV(' ')
    7   Call STKRDC ('RAWDAT',1,1,80,  NACTEL,DATFIL,IUNIT,NULLS,ISTAT)
C   7   CALL ASKFIL('What is the name of the file of observed data?',
C    1                  DATFIL)
        INQUIRE(FILE=DATFIL,EXIST=EFLAG)
        IF (.NOT.EFLAG) THEN
                CALL TV('No such file exists!')
                CALL TVN('Please try again:')
                GO TO 7
        END IF
        OPEN(NDATA,FILE=DATFIL,STATUS='UNKNOWN')
        REWIND NDATA
        NOW=0
C
C       Read data.  (READER returns negative NLINE at EOF.)
C
        CALL READER(NLINE)
C
C       Initialize times on first read:
C
        UTWRAP=.FALSE.
        SIDTIM=.FALSE.
        TIMSEL=.FALSE.
    8   DJZ=0.D0
        DJZ1=0.D0
        OLDMJD=-1.D0
        OLDUT=-1.
        UT1=0.
        UT2=0.
        UT=-1.
C
        DO 10 I=1,LENBUF
            IF (LINE(I)(:2).EQ.' 8') THEN
C               Look for first day of double date:
                IF (DJZ.EQ.0.D0) THEN
                        CALL GETJDC (I,DJZ)
                        IF (DJZ.GT.0.D0) THEN
C                               found date on card.
                                CALL TV('Date found on:')
                                CALL TVN(LINE(I))
                                DJZ1=DJZ
                        END IF
                END IF
C               Look for UT:
                CALL GETUT(I,UT)
C               Look for "Tim.Out":
                IF (LINE(I)(5:11).EQ.'Tim.Out' .AND.
     1              LINE(I)(13:14).EQ.'SI') THEN
                    CALL TV('Using Local Sidereal Time.')
                    SIDTIM=.TRUE.
                    TIMSEL=.TRUE.
                ELSE IF (LINE(I)(5:11).EQ.'Tim.Out' .AND.
     1              LINE(I)(13:14).EQ.'UT') THEN
                    CALL TV('Using Universal Time.')
                    SIDTIM=.FALSE.
                    TIMSEL=.TRUE.
                END IF
            ELSE IF (LINE(I)(:2).EQ.' 7') THEN
                UT=TIMER(LINE(I)(26:33))
C               Look for JD of 0h UT:
                IF (DJZ.EQ.0.D0) THEN
        WRITE(CARD,*)'I=',I
        CALL TV(CARD)
        CALL TVN(LINE(I)(11:19))
                    READ(LINE(I)(11:19),'(F9.1)',ERR=10) DJZ
                END IF
            END IF
            IF (UT.GE.0.) GO TO 12
   10   CONTINUE
        CALL TV('Can''t find U.T. in first 100 cards.')
C
   12   UT1=UT
        I1=I
        UT=-1.
C
        DO 20 I=I+1,LENBUF
            IF (LINE(I)(:2).EQ.' 8') THEN
C               Look for first day of double date:
                IF (DJZ.EQ.0.D0) THEN
                        CALL GETJDC (I,DJZ)
                        IF (DJZ.GT.0.D0) THEN
C                               found date on card.
                                CALL TV('Date found on:')
                                CALL TVN(LINE(I))
                                DJZ1=DJZ
                        END IF
                END IF
C               Look for UT:
                CALL GETUT(I,UT)
C               Look for "Tim.Out":
                IF (LINE(I)(5:11).EQ.'Tim.Out' .AND.
     1              LINE(I)(13:14).EQ.'SI') THEN
                    CALL TV('Using Local Sidereal Time.')
                    SIDTIM=.TRUE.
                    TIMSEL=.TRUE.
                ELSE IF (LINE(I)(5:11).EQ.'Tim.Out' .AND.
     1              LINE(I)(13:14).EQ.'UT') THEN
                    CALL TV('Using Universal Time.')
                    SIDTIM=.FALSE.
                    TIMSEL=.TRUE.
                END IF
            ELSE IF (LINE(I)(:2).EQ.' 7') THEN
                UT=TIMER(LINE(I)(26:33))
                IF (DJZ.EQ.0.D0) THEN
                        READ(LINE(I)(11:19),'(F9.1)') DJZ
                        IF (UT.LT.UT1) THEN
                                DJZ=DJZ-1.D0
                        END IF
                END IF
            END IF
            IF (UT.GE.0.) GO TO 22
   20   CONTINUE
C
   22   UT2=UT
        I2=I
C
        IF (UT2.GT.UT1) THEN
C               OK.
        ELSE IF (UT1.GT.21. .AND. UT2.LT.UT1+24.+3.) THEN
C               wrap through 0h U.T.; 3-hr. grace period.
                IF (DJZ.EQ.0.D0) UTWRAP=.TRUE.
        ELSE
                CALL TV('Times are out of order!')
                CALL TV(' ')
                IF (I2.GT.I1 .AND. I2.LT.MXLINE)THEN
                    DO 23 I=I1,I2
                        CALL TVN(LINE(I))
   23               CONTINUE
                    CALL TV(' ')
                    CALL STETER(23,'Please fix data.')
                ELSE
                    CALL STETER(23,'Please fix data.')
                END IF
        END IF
C
        IF (DJZ.EQ.0.D0) THEN
C               read on until we find a type 7 card...
                DO 26 I=I,LENBUF
                    IF (LINE(I)(:2).EQ.' 7') THEN
                        UT=TIMER(LINE(I)(26:33))
                        READ(LINE(I)(11:19),'(F9.1)') DJZ
                        IF (UT.LT.UT1) THEN
                                DJZ=DJZ-1.D0
                        END IF
                        GO TO 30
                    END IF
   26           CONTINUE
C
                IF (DJZ.EQ.0.D0) THEN
C                       still not found, so ask for help:
   28                   CALL ASK ('Please supply UT date at start:',
     1                             COM1)
                        CALL MDYC(COM1,MON,DAY,YEAR)
                        M=MON2M(MON)
                        IF (M.EQ.0 .OR. DAY.LT.0. .OR. DAY.GT.32. .OR.
     1                      YEAR.LT.0. .OR. YEAR.GT.2100. .OR.
     2                      (YEAR.GT.99. .AND. YEAR.LT.1900.)) GOTO 28
                        IF (YEAR.LT.50.) THEN
                                 YEAR=YEAR+2000.
                        ELSE
                                YEAR=YEAR+1900.
                        END IF
C                       compute JD of 0h UT:
                        IF (M.GT.2) GOTO 29
                        M=M+12
                        YEAR=YEAR-1.
   29                   DJZ=AINT(365.25*YEAR) + AINT(30.6001*(M+1)) +
     1                       DAY + 1720981.5D0
                        COM1=' '
                END IF
        ELSE
                IF (UTWRAP) DJZ=DJZ-1.D0
        END IF
   30   CONTINUE
C
        IF(.NOT.TIMSEL .AND. NLINE.LT.25) THEN
            DO 33 I=I,25
                IF (LINE(I)(5:11).EQ.'Tim.Out' .AND.
     1              LINE(I)(13:14).EQ.'SI') THEN
                    CALL TV('Using Local Sidereal Time.')
                    SIDTIM=.TRUE.
                    TIMSEL=.TRUE.
                ELSE IF (LINE(I)(5:11).EQ.'Tim.Out' .AND.
     1              LINE(I)(13:14).EQ.'UT') THEN
                    CALL TV('Using Universal Time.')
                    SIDTIM=.FALSE.
                    TIMSEL=.TRUE.
                END IF
   33       CONTINUE
        END IF
C
        IF(.NOT.TIMSEL) THEN
                CALL TV('ASSUMING Universal Time is used...')
                CALL ASK('               IS this correct???',COM1)
                IF (MATCH(COM1,'Y')) THEN
                        TIMSEL=.TRUE.
                ELSE IF (MATCH(COM1,'N'))THEN
                        CALL TV('Assuming Sidereal Time is used.')
                        TIMSEL=.TRUE.
                        SIDTIM=.TRUE.
                END IF
        END IF
C
C       Decide which date to use:
        IF (DJZ1.NE.0.D0 .AND. UT1.LT.MOD(36.-ELONG,24.))THEN
C               use 2nd day of double date:
                DJZ=DJZ+1.D0
        ELSE
C               use 1st day of double date:
        END IF
        STUTZH=STUTZROT(DJZ)*24.
C       Now fix up JD zero-point to make MJD_OBS:
        DJZ=DJZ-2400000.5D0
        GO TO 111
C
  110   CALL READER(NLINE)
  111   IF (NLINE.GT.0) THEN
                READ (LINE(NLINE)(:2),'(I2)',ERR=199) NTYPE
                IF (NTYPE.LT.0 .OR. NTYPE.GT.9) GOTO 199
                NTYPE=NTYPE+1
                GO TO (115,125,130,140,140,150,160,170,180,190) NTYPE
C                 type: 0   1   2   3   4   5   6   7   8   9
C
C                 Card Type:
C
C                       0: measurement
C
  115           CONTINUE
                READ (LINE(NLINE),116) ID,TINT,TIME,NFILT,NSTSK,SIGIN,
     1                              FNINTS,STDDEV,GENQ, GENR, GENG
  116           FORMAT(2X,I3,F5.1,2X,A10,I4,4X,I4,F10.1,F7.0,2F7.2,2F6.2
     1)
                OBJECT=OBJNAM
C               Convert mean rate to integral count.
                SIGNAL=SIGIN*FNINTS
C               Convert exposure time to total.
                EXPTIME=TINT*FNINTS
                UT=TIMER(TIME)
                IF (SIDTIM) THEN
                        FLST=UT
                        UT=MOD((UT-ELONG-STUTZH+48.D0),24.D0)/1.00273791
                        IF(FLST.LT.0.00273791*24.)THEN
C                               LST may have rolled over.
                                IF (DJZ+UT/24.D0.LT.OLDMJD) THEN
                                        UT=UT+24./1.00273791
                                ELSE
                                END IF
                        END IF
                END IF
C               Correct time of observation from middle to start of exposure.
C               Remember to convert from seconds to days:
                MJDOBS=DJZ+(UT/24.D0) - EXPTIME*0.5/86400.
                IF (MJDOBS.LT.OLDMJD) THEN
                    IF (UT.LT.3. .AND. OLDUT.GT.21.) THEN
C                       assume we just went through 0h UT.
                        CALL TV('   0h UT passed by:')
                        CALL TVN(LINE(NLINE))
                        DJZ=DJZ+1.D0
                        STUTZH=24.*STUTZROT(DJZ+2400000.5D0)
                    ELSE
  117                   IF (TIMSEL) THEN
                            CALL TV('Times out of order!')
                            CALL TV(LINE(NLINE))
                            WRITE(LINE(1),118) 'old MJD =',OLDMJD,
     1                                     '; oldut=',OLDUT
  118                       FORMAT(A9,F13.5,A8,F13.5)
                            CALL TV(LINE(1))
                            WRITE(LINE(1),118) 'MJD =',MJDOBS,
     1                                          ';    ut=',UT
                            CALL TVN(LINE(1))
                            CALL STETER(118,'Please fix data.')
                        ELSE
C                           See if we are using sidereal time:
  119                       CALL ASK('Are you using Sidereal Time?',
     1                                  COM1)
                            IF (MATCH(COM1,'Y'))THEN
                                SIDTIM=.TRUE.
                                TIMSEL=.TRUE.
                                REWIND NDATA
                                REWIND NOUTP
                                NOW=0
                                CALL READER(NLINE)
                                GO TO 8
                            ELSE IF (MATCH(COM1,'N'))THEN
                                SIDTIM=.FALSE.
                                TIMSEL=.TRUE.
                                GO TO 117
                            ELSE
                                CALL TV('Please reply "y" or "n".')
                                GO TO 119
                            END IF
                        END IF
                    END IF
                END IF
                OLDMJD=MJDOBS
                OLDUT=UT
C               Convert STAR/SKY flag to standard strings.
                IF (NSTSK.EQ.0) THEN
                        STARSKY='STAR'
                ELSE IF (NSTSK.EQ.1) THEN
                        STARSKY='SKY'
                ELSE
                        CALL TV('Unexpected value in STAR/SKY column:')
                        CALL TV(LINE(NLINE))
                        CALL STETER(119,'Fix data and try again.')
                END IF
C               Convert filter position to band name:
                BAND=BNDNAM(NFILT+1)
C               Save Geneva parameters:
                GENEVAQ=GENQ
                GENEVAR=GENR
                GENEVAG=GENG
                CALL WRITER
                GO TO 110
C
C                       1: last integration results if MAGtape,All (??)
  125           CONTINUE
                GO TO 110
C
C                       2: (unused)
  130           CONTINUE
                GO TO 110
C
C                       3 or 4: rejects (should never occur!)
  140           CONTINUE
                CALL VIEW('PROGRAM ERROR: kept bad data!',NLINE)
                GO TO 110
C
C                       5: Object identifier
  150           CONTINUE
                READ (LINE(NLINE),'(2X,A32)') OBJNAM
                GO TO 110
C
C                       6: Telescope coordinates
  160           CONTINUE
                READ (LINE(NLINE),'(5X,A10,1X,A10)') RASTR, DESTR
                GO TO 110
C
C                       7: measurement number, UT, & JD
  170           CONTINUE
                READ (LINE(NLINE),'(2X,I5,F12.1,2A10)')M,DJ,UTSTR
C               lststr is truncated to nearest minute on card 7, so useless.
                UT=TIMER(UTSTR)
                IF (DJ.EQ.DJZ+2400000.5D0) THEN
C                       OK.
                ELSE IF (DJ.EQ.DJZ+2400001.5D0) THEN
C                       probably OK.
                        IF (UT.LT.3. .AND. OLDUT.GT.21.) THEN
C                           assume we just went through 0h UT.
                            CALL TV('0h UT passed by:')
                            CALL TVN(LINE(NLINE))
                            DJZ=DJZ+1.
                            STUTZH=24.*STUTZROT(DJZ+2400000.5D0)
                        ELSE
                            CALL TV('Computed JD does not match data:')
                            CALL TV(LINE(NLINE))
                            CALL STETER(176,'Please fix data.')
                        END IF
                ELSE
C                       problem:
                        CALL TV('Computed JD does not match data:')
                        CALL TV(LINE(NLINE))
                        WRITE(COMMENT,*) 'Computed was ',DJZ+2400000.5D0
                        CALL TV(COMMENT)
                        CALL STETER(178,'Please fix data.')
                END IF
                OLDUT=UT
                GO TO 110
C
C                       8: Heading or comment
  180           CONTINUE
                CALL GETUT(NLINE,UT)
                IF (UT.GE.0.)THEN
C                       time found on card
                        DJD=DJZ+(UT/24.D0)
                        IF (DJD.LT.OLDMJD) THEN
                            IF (UT.LT.3. .AND. OLDUT.GT.21.) THEN
C                               assume we just went through 0h UT.
                                DJZ=DJZ+1.D0
                                DJD=DJD+1.D0
                                STUTZH=24.*STUTZROT(DJZ+2400000.5D0)
                                CALL TV('0h UT passed by:')
                                CALL TVN(LINE(NLINE))
                            ELSE
  183                           IF (TIMSEL) THEN
                                    CALL TV('Times out of order!')
                                    CALL TV(LINE(NLINE))
                                    CALL STETER(183,'Please fix data.')
                                ELSE
                                    CALL TV('Times seem out of order.')
  184                               CALL ASK('Are you using UT or LST?',
     1                                         COM1)
                                    IF (MATCH(COM1,'U')) THEN
                                        SIDTIM=.FALSE.
                                        TIMSEL=.TRUE.
                                        GO TO 183
                                     ELSE IF (MATCH(COM1,'LST') .OR.
     1                                        MATCH(COM1,'SID')) THEN
                                        CALL TV('Starting over....')
                                        CALL TV(' ')
                                        SIDTIM=.TRUE.
                                        TIMSEL=.TRUE.
                                        REWIND NDATA
                                        REWIND NOUTP
                                        NOW=0
                                        CALL READER(NLINE)
                                        GO TO 8
                                    ELSE
                                        CALL TV('Please reply "LST"')
                                        CALL TVN('         or "UT".')
                                        GO TO 184
                                    END IF
                                END IF
                            END IF
                        END IF
                        OLDMJD=DJD
                        OLDUT=UT
                ELSE
C                       time not found on card
                        IF (OLDMJD.EQ.-1.D0) THEN
                                DJD=DJZ+(UT1/24.)-1.E-5*(I1-NLINE)
                        ELSE
                                DJD=OLDMJD+1.E-5
                        END IF
                END IF
                MJDOBS=DJD
C               Split up comment card cleanly if possible:
                DO 186 K=34,14,-1
                IF (LINE(NLINE)(K:K).EQ.' ') GO TO 187
  186           CONTINUE
  187           DO 188 K2=K+32,K+12,-1
                IF (LINE(NLINE)(K2:K2).EQ.' ') GO TO 189
  188           CONTINUE
  189           IF (LINE(NLINE)(K2+32:).EQ.' ') THEN
                        COM1=LINE(NLINE)(3:K)
                        COM2=LINE(NLINE)(K+1:K2)
                        COM3=LINE(NLINE)(K2+1:)
                ELSE
                        READ (LINE(NLINE),'(2X,2A32,A14)')COM1,COM2,COM3
                END IF
                COMMENT=COM1
                CALL WRITER
                MJDOBS=DJD+1.D-6
                COMMENT=COM2
                IF (COM2.NE.' ') CALL WRITER
                MJDOBS=DJD+2.D-6
                COMMENT=COM3
                IF (COM3.NE.' ') CALL WRITER
                GO TO 110
C
C                       9: End of object
  190           CONTINUE
                OBJNAM=' '
                GO TO 110
C
C                       other: Illegal card.
  199           CONTINUE
                CALL TV('This card is not in standard format:')
                CALL TV(LINE(NLINE))
                CALL TV('Please fix data and try again.')
                CALL STETER(199,'Data not in std. ESO format')
        END IF
C
C       *** fall through at EOF ***
C
        CLOSE(NOUTP)
C
C       Now make format file:
C
        OPEN (NOUTP,FILE='data.fmt',STATUS='UNKNOWN')
        WRITE(NOUTP,'(A26)')'! Format file for ESO Data'
  200   FORMAT(A39)
        WRITE(NOUTP,200)'DEFINE/FIELD   1  10 R  F10.1 :SIGNAL  '
        WRITE(NOUTP,200)'DEFINE/FIELD  11  42 C  A32   :OBJECT  '
        WRITE(NOUTP,200)'DEFINE/FIELD  43  46 C  A7    :STARSKY '
        WRITE(NOUTP,200)'DEFINE/FIELD  48  55 C  A8    :BAND    '
        WRITE(NOUTP,200)'DEFINE/FIELD  56  67 D  F12.6 :MJD_OBS '
        WRITE(NOUTP,200)'DEFINE/FIELD  68  75 R  F8.3  :EXPTIME '
        WRITE(NOUTP,200)'DEFINE/FIELD  76 107 C  A32   :COMMENT '
        WRITE(NOUTP,200)'DEFINE/FIELD 108 113 R  F8.2  :GENEVA_Q'
        WRITE(NOUTP,200)'DEFINE/FIELD 114 119 R  F8.2  :GENEVA_R'
        WRITE(NOUTP,200)'DEFINE/FIELD 120 125 R  F8.2  :GENEVA_G'
        WRITE(NOUTP,'(A3)')'END'
        CLOSE(NOUTP)
C
        CALL TV('DCON is finished')
C
C
C       End MIDAS:
C
        CALL STSEPI
        END
        SUBROUTINE WRITER
C
C       writes output to uniform ascii file 'data.dat'
C
        INTEGER INULL
        REAL RNULL
        DOUBLE PRECISION DNULL
        COMMON /NULLS/ INULL, RNULL, DNULL
C
        REAL SIGNAL, EXPTIME, GENEVAQ, GENEVAR, GENEVAG
        DOUBLE PRECISION MJDOBS
        COMMON /OUTR/ SIGNAL,EXPTIME,MJDOBS, GENEVAQ,GENEVAR,GENEVAG
        CHARACTER OBJECT*32,STARSKY*4,BAND*8,COMMENT*32, C*125
        COMMON /OUTC/ OBJECT,STARSKY,BAND,COMMENT
C
C
        WRITE(C,5) SIGNAL, OBJECT,STARSKY,BAND,MJDOBS,EXPTIME,COMMENT,
     1                                        GENEVAQ,GENEVAR,GENEVAG
    5   FORMAT(F10.1,A32,A4,1X,A8,F12.6,F8.3,A32,3F6.2)
C
C       Fix up NULL fields:
C
        IF (SIGNAL.EQ.RNULL) C(1:10)=' '
        IF (MJDOBS.EQ.DNULL) C(56:67)=' '
        IF (EXPTIME.EQ.RNULL) C(68:75)=' '
        IF (GENEVAQ.EQ.RNULL) C(108:113)=' '
        IF (GENEVAR.EQ.RNULL) C(114:119)=' '
        IF (GENEVAG.EQ.RNULL) C(120:125)=' '
C
        WRITE(8,'(A125)') C
C
C       clear data arrays:
C
        OBJECT=' '
        STARSKY=' '
        BAND=' '
        COMMENT=' '
        SIGNAL=RNULL
        EXPTIME=RNULL
        GENEVAQ=RNULL
        GENEVAR=RNULL
        GENEVAG=RNULL
        MJDOBS=DNULL
C
        RETURN
        END
        SUBROUTINE READER(NLINE)
C
C       Reads data lines, and returns ptr. to one in buffer each time.
C
C *****************************************************************************
C
C       This subroutine uses a circular buffer to read the data, because the
C       ESO data contain codes for "cancel last star" and "cancel last datum".
C
C       The circular buffer is also used here to look ahead, and interpolate
C       times to assign to comments that lack time information.
C
C *****************************************************************************
C
        INTEGER MXLINE
        PARAMETER (MXLINE=100)
C
        INTEGER NLINE, LENBUF, NOW, NEOF, LAST
        CHARACTER*80 LINE(MXLINE)
        COMMON /LINES/LINE
        SAVE /LINES/
        COMMON /BUF/LENBUF, NOW
C
        SAVE NEOF
C
        DATA NEOF/0/
C
C
        IF (NOW.EQ.0) THEN
C
C       *****   initial entry:  *****
C
                NOW=1
    1           READ (7,'(A80)', END=9) LINE(NOW)
C                       Test for backup (bad data):
                IF (LINE(NOW)(:2).EQ.' 4') THEN
C                       Back up over object:
                        DO 4 NOW=NOW-1,1,-1
                        IF (LINE(NOW)(:2).EQ.' 5') GO TO 6
    4                   CONTINUE
                        NOW=0
                ELSE IF (LINE(NOW)(:2).EQ.' 3') THEN
C                       Back up over last filter:
                        IF (LINE(NOW-1)(:2).EQ.' 0') THEN
                                NOW=NOW-2
                        ELSE IF (LINE(NOW-2)(:2).EQ.' 0') THEN
                                NOW=NOW-3
                        ELSE
                                CALL TV('Did not find bad datum:')
                                DO 5 LAST=MAX(1,NOW-3),NOW
    5                           CALL TVN(LINE(LAST))
                        END IF
                END IF
C
                NOW=NOW+1
C
C               *** test for full buffer ***
C
    6           IF(NOW.GT.MXLINE) THEN
                        LENBUF=MXLINE
                ELSE
                        GO TO 1
                END IF
C
C               *** return from initial entry ***
C
    8           NOW=1
                NLINE=1
                RETURN
C
C               *** EOF found on initial entry ***
C
    9           LENBUF=NOW
                NEOF=LENBUF
                GOTO 8
C
        ELSE
C
C       *****  normal entry (NOW > 0):  *****
C
                LAST=NOW
   10           IF (NEOF.EQ.0) THEN
C                       overwrite last output line:
                        READ (7, '(A80)',END=99) LINE(NOW)
C
C                       Test for backup (bad data):
                        IF (LINE(NOW)(:2).EQ.' 4') THEN
C                               back up over object:
                                DO 14 NOW=NOW-1,1,-1
                                IF (LINE(NOW)(:2).EQ.' 5') GOTO 10
   14                           CONTINUE
                                DO 15 NOW=LENBUF,LAST+1,-1
                                IF (LINE(NOW)(:2).EQ.' 5') GOTO 10
   15                           CONTINUE
                                CALL TV('Backed up over entire buffer!')
                                CALL STETER(15,
     1                          'Increase MXLINE and recompile')
C
                        ELSE IF (LINE(NOW)(:2).EQ.' 3') THEN
C                               back up over filter:
                                DO 17 NOW=NOW-1,1,-1
                                IF (LINE(NOW)(:2).EQ.' 0') GOTO 10
   17                           CONTINUE
                                DO 18 NOW=LENBUF,LAST+1,-1
                                IF (LINE(NOW)(:2).EQ.' 0') GOTO 10
   18                           CONTINUE
                                CALL TV('Backed up over entire buffer!')
                                CALL STETER(18,
     1                          'Increase MXLINE and recompile')
                        END IF
                END IF
C
   20           IF (NOW.NE.LAST) THEN
C                       Refill buffer, if needed:
                        NOW=NOW+1
                        IF (NOW.GT.LENBUF) NOW=1
                        GO TO 10
                END IF
C
C               Advance line counter:
                IF (NOW.EQ.LENBUF) THEN
                        NOW=1
                ELSE
                        NOW=NOW+1
                END IF
C
                IF (NOW.EQ.NEOF) THEN
C                       Return negative value at eof:
                        NLINE=-NOW
                        RETURN
                ELSE
                        NLINE=NOW
                END IF
C
                RETURN
C
   99           NEOF=NOW
                IF (NEOF.GT.LENBUF) NEOF=1
                GO TO 20
C
        END IF
C
        END
        SUBROUTINE VIEW(STRING,NLINE)
C
        CHARACTER*(*) STRING
C
        INTEGER MXLINE
        PARAMETER (MXLINE=100)
C
        CHARACTER*80 LINE(MXLINE)
        INTEGER NLINE, LENBUF, NOW, NM1, NP1, NP2, NP3
        COMMON /LINES/LINE
        SAVE /LINES/
        COMMON /BUF/LENBUF, NOW
C
C
        CALL TV(STRING)
        CALL TV(' ')
        NM1=NLINE-1
        IF (NM1.LE.0) THEN
                NM1=LENBUF
                IF(LENBUF.EQ.MXLINE) CALL TVN(LINE(NM1))
        ELSE
                CALL TVN(LINE(NM1))
        END IF
        CALL TVN(LINE(NLINE))
        NP1=NLINE+1
        IF (NP1.GT.LENBUF) NP1=1
        CALL TVN(LINE(NP1))
        NP2=NLINE+2
        IF (NP2.GT.LENBUF) NP2=1
        CALL TVN(LINE(NP2))
        NP3=NLINE+3
        IF (NP3.GT.LENBUF) NP3=1
        CALL TVN(LINE(NP3))
C
        RETURN
        END
        SUBROUTINE  FILTBL
C
C       Filter conversion table:
C
        CHARACTER*8 FILTCD(20),BNDNAM(20)
        COMMON /FILTBC/ FILTCD,BNDNAM
C
        LOGICAL MATCH
C
        CHARACTER ANS, ROW*40
        CHARACTER*8 ESORCD(12),ESOBCD(12),ESORED(12),ESOBLU(12)
        INTEGER I
C
        DATA ESORCD/' 0',' 1',' 2',' 3',' 4',' 5',' 6',
     1              ' 7',' 8',' 9','10','11'/
C
        DATA ESORED/'B','U','DARK','DARK','DARK','DARK','DARK',
     1              'DARK','DARK','I','R','V'/
C
        DATA ESOBCD/' 0',' 1',' 2',' 3',' 4',' 5',' 6',
     1              ' 7',' 8',' 9','10','11'/
C
        DATA ESOBLU/'BETAN','BETAW','u','v','b','y','DARK',
     1              'DARK','DARK','U','V','B'/
C
C
        CALL TV(' ')
    1   CALL TV('Did you use the "red" standard wheel (UBVRI),')
        CALL TVN('            the "blue" standard wheel (uvby, beta),')
        CALL TVN('            or some other arrangement?')
        CALL ASK('(Please reply "red", "blue", or "other"):',ANS)
    2   IF (MATCH(ANS,'R')) THEN
C               ESO Std.red wheel.
                CALL TV('The standard table for this wheel is:')
                CALL TV('      code   band')
                DO 3 I=1,12
                WRITE(ROW,'(7X,A6,A8)') ESORCD(I),ESORED(I)
                CALL TV(ROW)
                FILTCD(I)=ESORCD(I)
                BNDNAM(I)=ESORED(I)
    3           CONTINUE
                CALL ASK('Are these correct?',ANS)
                IF (MATCH(ANS,'Y'))THEN
                        RETURN
                ELSE IF (MATCH(ANS,'N')) THEN
                        GO TO 2
                ELSE
                        CALL TV('Please reply "yes" or "no".')
                        CALL TV('Let''s try this again:')
                        GO TO 1
                END IF
        ELSE IF (MATCH(ANS,'B')) THEN
C               ESO Std.red wheel.
                CALL TV('The standard table for this wheel is:')
                CALL TV('      code   band')
                DO 4 I=1,12
                WRITE(ROW,'(7X,A6,A8)') ESOBCD(I),ESOBLU(I)
                CALL TV(ROW)
                FILTCD(I)=ESOBCD(I)
                BNDNAM(I)=ESOBLU(I)
    4           CONTINUE
                CALL ASK('Are these correct?',ANS)
                IF (MATCH(ANS,'Y'))THEN
                        RETURN
                ELSE IF (MATCH(ANS,'N')) THEN
                        GO TO 2
                ELSE
                        CALL TV('Please reply "yes" or "no".')
                        CALL TV('Let''s try this again:')
                        GO TO 1
                END IF
        ELSE IF (MATCH(ANS,'O')) THEN
C               Non-std. wheel.
                CALL TV('Enter the standard filter name for each place')
                CALL TVN('in the wheel:')
                DO 5 I=1,12
                CALL ASK(ESORCD(I),BNDNAM(I))
    5    CONTINUE
        ELSE
                GO TO 1
        END IF
C
        RETURN
        END

C @(#)fttokn.for	19.1 (ES0-DMD) 02/25/03 13:17:37
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FTTOKN(LINE,EOFMRK,DELIM,TOKEN,LENGTH,EOF)                    
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                   
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:25 - 13 JAN 1988                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C.IDENTIFICATION                                                                
C                                                                               
C  FITLIB.FOR   VERSION 1.0  27 MAR 1984                                        
C                                                                               
C.PURPOSE                                                                       
C                                                                               
C  INTERFACE ROUTINES FOR THE FITTING STRUCTURES                                
C                                                                               
C.ALGORITHM                                                                     
C                                                                               
C  USE MIDAS I/O INTERFACES TO FRAMES AND TABLES                                
C                                                                               
C.KEYWORDS                                                                      
C                                                                               
C  NON LINEAR FITTING                                                           
C                                                                               
C                                                                               
C----------------------------------------------------------------               
C                                                                               
C FIND NEXT TOKEN                                                               
C      IMPLICIT NONE                                                            
C                                                                               
      INTEGER I,LENGTH
      CHARACTER*(*) LINE,TOKEN                                                  
      LOGICAL EOF
      CHARACTER*1 EOFMRK,DELIM,C                                               
C                                                                               
      EOF    = .FALSE.                                                          
      C      = ' '                                                              
      I      = 0                                                                
99    CONTINUE
          IF ( .NOT. (C.EQ.' ')) GO TO 20                                       
          I      = I + 1                                                        
          C      = LINE(I:I)                                                    
      GOTO 99
   20 CONTINUE                                                                  
      I      = I - 1                                                            
      LENGTH = 0                                                                
      TOKEN  = ' '                                                              
999   CONTINUE
          IF ( .NOT. (.NOT.EOF)) GO TO 40                                       
          I      = I + 1                                                        
          C      = LINE(I:I)                                                    
          EOF    = C .EQ. EOFMRK                                               
          IF (C.EQ.DELIM) THEN                                                  
              RETURN                                                            
                                                                                
          ELSE                                                                  
              LENGTH = LENGTH + 1                                               
              TOKEN(LENGTH:LENGTH) = C                                          
          END IF                                                                
                                                                                
      GOTO 999
   40 CONTINUE                                                                  
      IF (EOF) THEN                                                             
          LENGTH = LENGTH - 1                                                   
          IF (LENGTH.NE.0) EOF    = .FALSE.                                     
      END IF                                                                    
C 
      RETURN                                                                    
      END                                                                       

C @(#)deflst.for	19.1 (ES0-DMD) 02/25/03 13:25:32
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine DEFLST          version 1.0         880901
C  A. Kruszewski              Warsaw U. Obs.
C.PURPOSE
C.INPUT/OUTPUT
C  Input parameters
C  ITOB      integer*4 array      limits of objects area
C  M         integer*4            number of objects
C  Output parameters
C  LSTP      integer*4 array      array defining regional linked lists
C  NREG      integer*4            number of regional linked lists
C
C-----------------------------------------------------------------------
      SUBROUTINE DEFLST(LSTP, ITOB, M, NREG)
C
      IMPLICIT  NONE
      INCLUDE  'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER   LSTP(LPBUF)
      INTEGER   ITOB(4)
      INTEGER   M
      INTEGER   NREG
C
      INTEGER   I
      INTEGER   ISIDE
      INTEGER   IX
      INTEGER   IY
      INTEGER   KX
      INTEGER   KY
      INTEGER   NREG1
C
      DO I = 1, LPBUF
         LSTP(I) = 0.0
      ENDDO
C
      NREG1 = LPBUF / 5 - 1
      NREG = MIN ( NREG1 , M/5 )
      IX = ITOB(3) - ITOB(1) + 1
      IY = ITOB(4) - ITOB(2) + 1
      ISIDE = ( IX * IY ) / NREG
      ISIDE = INT( SQRT( FLOAT( ISIDE ) ) )
   10 CONTINUE
          KX = IX / ISIDE
          IF ( MOD( IX , ISIDE ) .GT. 0 ) THEN
              KX = KX + 1
          ENDIF
          KY = IY / ISIDE
          IF ( MOD( IY , ISIDE ) .GT. 0 ) THEN
              KY = KY + 1
          ENDIF
          IF ( KX*KY .GT. NREG1 ) THEN
              ISIDE = ISIDE + 1
              GOTO 10
          ENDIF
      NREG = KX * KY
      LSTP(1) = ISIDE
      LSTP(2) = KX
      LSTP(3) = KY
      CALL FLSTBD( NREG , LSTP , ITOB )
C
      RETURN
      END

C @(#)kolmogorov.for	19.1 (ES0-DMD) 02/25/03 13:21:22
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, 29 JUN 89
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: M . PERON
C
C.IDENTIFICATION
C
C  Program KOLMOGOROV
C
C.KEYWORDS
C
C  
C
C.PURPOSE
C
C  Test de Kolmogorov for one or two distributions.
C
C references: Numerical Recipes p472
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++       



       REAL FUNCTION  PROBKS(ALAM)
       REAL EPS1,EPS2,TERM,FAC,TERMBF,ALAM
       REAL A2
       INTEGER J
       PARAMETER (EPS1=0.001,EPS2=1.E-8)
       A2 = -2*ALAM**2
       FAC = 2.
       PROBKS = 0.
       TERMBF = 0.
       DO 10 J=1,100
          TERM = FAC*EXP(A2*J**2)
          PROBKS = PROBKS+TERM
          IF (ABS(TERM).LT.EPS1*TERMBF.OR.ABS(TERM).LE.EPS2*PROBKS)
     1            RETURN
          FAC = -FAC
          TERMBF = ABS(TERM)
10      CONTINUE
       PROBKS = 1.
       RETURN
       END




       SUBROUTINE KOLM2DIS(X1,N1,X2,N2,D,PROB)
       INTEGER J1,J2,N1,N2
       REALX1(N1),X2(N2),D,PROB,FN1,FN2,EN1,EN2
       REAL D1,D2,DT,PROBKS
       J1 = 1
       J2 = 1
       FN1 = 0.
       FN2 = 0.
       EN1 = N1
       EN2 = N2
       D = 0.
10       IF(J1.LE.N1.AND.J2.LE.N2)THEN
          D1 = X1(J1)
          D2 = X2(J2)
          IF (D1.LE.D2) THEN
              FN1 = J1/EN1
              J1 = J1+1
          ENDIF
          IF (D2.LE.D1)THEN
              FN2 = J2/EN2
              J2 = J2+1
          ENDIF
          DT = ABS(FN2-FN1)
          IF (DT.GT.D) D = DT
        GOTO 10
       ENDIF
       PROB = PROBKS(SQRT(EN1*EN2/(EN1+EN2))*D)
       RETURN
       END



       SUBROUTINE  KOLM1D(DATA,N,DISTRI,PARA,D,PROB)
       INTEGER J,N
       REAL DATA(N),D,PROB,EN,F0,PARA(2),FN,FF,DT
       REAL ERFCC,GAMMAQ,PROBKS,UNIF,CONST
       CHARACTER*1 DISTRI

       EN = N
       D = 0.
       F0 = 0.
       DO 10 J=1,N
          FN = J/EN
          IF (DISTRI.EQ.'U') THEN
            FF = 1-UNIF(DATA(J),PARA)
          ELSE IF (DISTRI.EQ.'G') THEN
            CONST = 1./(SQRT(2.)*PARA(2))
            FF = 1-0.5*ERFCC((DATA(J)-PARA(1))*CONST)
          ELSE IF (DISTRI.EQ.'P') THEN
            FF = GAMMAQ(DATA(J),PARA(1))
          ELSE
            GOTO 80
          ENDIF
          DT = MAX(ABS(F0-FF),ABS(FN-FF))
C          D = MAX(ABS(FN-FF),D)
          IF (DT.GT.D) D = DT
          F0 = FN
10       CONTINUE
         PROB = PROBKS(SQRT(EN)*D)
80       RETURN
       END

C===========================================================================
C Copyright (C) 1995-2011 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
CC     ---------------------------------------------------------------------
CC     *RMIDAT*: READ DATA AND OPTIONS
C
C 110427	last modif
C 
CC     ---------------------------------------------------------------------

       SUBROUTINE RMIDAT(NCAS,NVAR,JCST,JPRT,NVSB,NVAD,VALMS,
     1  X,Y,JPLT,JNDEX,PREC,JPLACE,LAB,XMED,XMAD,AW,NMVAL,
     1  RESDU,WEIGHTS,NDXX,NDXY,MVAL,NMXV,LUA,LUB,LUC,JHEAD,
     1  YNSAVE,JDIAG,ALGO,NSTOP,FNAMEA,FNAMEB,FNAMEC,OUTN1,OUTN2)

       INCLUDE 'MID_REL_INCL:implicit.inc'

       DIMENSION X(NDXX,NDXY),Y(NDXY),JNDEX(NDXX)
       DIMENSION AW(NDXY),NMVAL(NDXY),RESDU(NDXY),WEIGHTS(NDXY)
       DIMENSION XMED(NDXX),XMAD(NDXX),JPLACE(NDXX),VALMS(NDXX)
       CHARACTER YN,YNOK,YNSAVE,YNM,ALGO
       CHARACTER*30 FNAMEA,FNAMEB,FNAMEC
       CHARACTER*20 LAB(NDXX)
       CHARACTER*60 JFMT,JHEAD
       CHARACTER*20 LABJ
       CHARACTER    HELP(20)
       LOGICAL NULL,VALUE
       CHARACTER*17 OUTC1,OUTC2
       CHARACTER*100 CBUF
       INTEGER      ISTAT
       INTEGER STATUS,ACTS,KUN,KNUL,OUTN1,OUTN2
       INTEGER FINDEX, LINDEX, L, POSITION(20)
       INTEGER COLUMN,ROW,NSC,ACOL,AROW,NSEL

       INCLUDE 'MID_INCLUDE:st_def.inc'
       COMMON  /VMR/ MADRID
       EQUIVALENCE (LABJ,HELP)

       INCLUDE 'MID_INCLUDE:st_dat.inc'

       LOCA=0
C       WRITE (*,8000)

CC-----NAME OF THE FILE CONTAINING THE DATA
C       FNAMEA = 'parabol.tbl'
       CALL STKRDC('IN_A',1,1,80,ACTS,FNAMEA,KUN,KNUL,STATUS)

C ----  OPEN THE TABLE
       CALL TBTOPN(FNAMEA, F_IO_MODE, LUA, STATUS)
       CALL TBIGET(LUA,COLUMN,ROW,NSC,ACOL,AROW,STATUS)

CC-----GIVE THE NUMBER OF CASES
       NSEL = 0
       DO 10 J=1,ROW
          CALL TBSGET(LUA,J,VALUE,STATUS)
          IF (VALUE) NSEL = NSEL + 1
 10     CONTINUE   
 11     CONTINUE
       NCAS = NSEL

       IF (NCAS.GT.NDXY.OR.NCAS.LE.1) THEN
         IF (NCAS.GT.NDXY) THEN
            WRITE (CBUF,8020) NDXY
            CALL STTPUT(CBUF,ISTAT)
         ELSEIF (NCAS.LE.1) THEN
            WRITE(CBUF,8030)
            CALL STTPUT(CBUF,ISTAT)
         ENDIF   
         CALL STETER(9,'Buffer Overflow')
       ENDIF


CC-----CONSTANT TERM OR NOT

20     CONTINUE
C      get YN from keyword
C      e.g.  YN = 'Y'
       CALL STKRDC('ACTION',1,1,1,ACTS,YN,KUN,KNUL,STATUS)        

       IF (YN.EQ.'y') YN='Y'
       IF (YN.EQ.'n') YN='N'
       IF (YN.NE.'Y'.AND.YN.NE.'N') THEN
         WRITE (CBUF,8050)
         CALL STTPUT(CBUF,ISTAT)
         GOTO 20
       ELSE
         IF (YN.EQ.'Y') JCST=1
         IF (YN.EQ.'N') JCST=0
       ENDIF

CC-----TOTAL NUMBER OF VARIABLES IN THE DATA SET
  30    CONTINUE
       JVARS = COLUMN

       IF (JVARS.LT.1.OR.JVARS.GT.50) THEN
         WRITE(CBUF,8050)
         CALL STTPUT(CBUF,ISTAT)
         GOTO 30
       ENDIF

CC-----GIVE A LABEL FOR THE RESPONSE VARIABLE
       CALL STKRDC('INPUTC',1,1,20,ACTS,LABJ,KUN,KNUL,STATUS)
       LAB(NDXX)=LABJ

CC-----WHICH VARIABLE WILL BE TAKEN AS THE RESPONSE VARIABLE
        CALL TBCSER(LUA,LAB(NDXX),JPLACE(NDXX),STATUS)
        WRITE(CBUF,*) 'Dependent Column : ',LAB(NDXX),JPLACE(NDXX)
          CALL STTPUT(CBUF,ISTAT)
       IF (JPLACE(NDXX).LT.0) CALL STETER(9,'Wrong dependent variable')

       IF (JCST.EQ.0) THEN
         CALL STTPUT('JCST=0, no constant term',ISTAT)
CC-----JWR = MAXIMAL NUMBER OF EXPLANATORY VARIABLES POSSIBLE         
         CALL STTPUT('Max. number of explanatory variables ',ISTAT)
         JWR=NMXV
         IF((JVARS-1).LT.NMXV) JWR=JVARS-1
       ELSE
         CALL STTPUT ('JCST=1, constant term',ISTAT)
         JWR=NMXV-1
         IF ((JVARS-1).LT.NMXV) JWR=JVARS-1
       ENDIF

CC-----HOW MANY EXPLANATORY VARIABLES DO YOU WANT TO USE
       CALL STKRDI('INPUTI',1,20,ACTS,POSITION,KUN,KNUL,STATUS)
       NVAR = POSITION(1)

       DO 67 L=1,NVAR

          IF (L.EQ.1)    THEN
              FINDEX = 1
          ELSE
              FINDEX = POSITION(L) + 1
          ENDIF

          IF (L.EQ.NVAR) THEN
              LINDEX = POSITION(NVAR+1) 
          ELSE
              LINDEX = POSITION(L+1) - 1
          ENDIF

          LINDEX = LINDEX - FINDEX + 1
          CALL STKRDC('IN_B',1,FINDEX,LINDEX,ACTS,LAB(L),KUN,
     +                KNUL,STATUS)

 67     CONTINUE

CC-----LOCATE EXPLANATORY COLUMNS
       DO 177 J=1,NVAR
             CALL TBCSER(LUA,LAB(J),JPLACE(J),STATUS)
             IF (JPLACE(J) .LT. 0) CALL STETER(9,'Wrong column name')
             WRITE(CBUF,*) 'Label: ',LAB(J)
             CALL STTPUT(CBUF,ISTAT)	     
             WRITE(CBUF,*) ' Position: ',JPLACE(J)
             CALL STTPUT(CBUF,ISTAT)     
  177  CONTINUE

CC-----MOVE STRINGS TO THE RIGHT 

       DO 70 J=1,NVAR
C          write(6,*) 'Index, LAB(J)', J, ':',LAB(J),':',' (before)'
          LABJ   = LAB(J)
          CALL MOVE(HELP)
          LAB(J) = LABJ
C          write(6,*) 'After: ',LAB(J)
 70    CONTINUE

CC-----ADD A VARIABLE IF CST TERM IS SELECTED AND
CC     MOVE DEPENDENT VARIABLE TO POSITION NVAR+1

       IF (JCST.EQ.1) NVAR=NVAR+1
       NVAD=NVAR+1
       JPLACE(NVAD)=JPLACE(NDXX)
       LAB(NVAD)=LAB(NDXX)

CC-----HOW MUCH OUTPUT?
  150   CONTINUE
C
C       CALL STTPUT('Default is 1 = medium-sized output',ISTAT)
       YN = '1'

       IF(.NOT.(YN.EQ.'0'.OR.YN.EQ.'1'.OR.YN.EQ.'2')) THEN
         WRITE (CBUF,8050)
         CALL STTPUT(CBUF,ISTAT)
         GOTO 150
       ENDIF
       JPRT=JNTGR(YN)

CC-----DO YOU WANT TO LOOK AT THE RESIDUALS?
  160   CONTINUE
       YN = '3'

       IF(.NOT.(YN.EQ.'0'.OR.YN.EQ.'1'.OR.(YN.EQ.'2'.AND.LOCA.NE.1)
     1               .OR.(YN.EQ.'3'.AND.LOCA.NE.1) ) ) THEN
         WRITE (CBUF,8050)
         CALL STTPUT(CBUF,ISTAT)
         GOTO 160
       ENDIF
       JPLT=JNTGR(YN)
       IF (JCST.EQ.1.AND.NVAR.EQ.1.AND.JPLT.NE.0) JPLT=2

CC-----DO YOU WANT TO COMPUTE OUTLIER DIAGNOSTICS
       IF (LOCA.NE.1) THEN
          YN = 'Y'

          IF (YN.EQ.'y'.OR.YN.EQ.'Y') THEN
                                        JDIAG=1
                                                          ELSE
                                        JDIAG=0
          ENDIF
       ENDIF

       IF (FNAMEA.EQ.'CON') THEN
CC-----DO YOU WANT TO SAVE THE DATA
  170    CONTINUE
         YNSAVE = 'N'

         IF (YNSAVE.EQ.'y') YNSAVE='Y'
         IF (YNSAVE.EQ.'n') YNSAVE='N'
         IF (YNSAVE.NE.'Y'.AND.YNSAVE.NE.'N') THEN
            WRITE(CBUF,8050)
            CALL STTPUT(CBUF,ISTAT)
            GOTO 170
         ENDIF
         IF (YNSAVE.EQ.'Y') THEN
            WRITE(CBUF,8250)
            CALL STTPUT(CBUF,ISTAT)
            READ(*,9030) FNAMEC
            OPEN(LUC,FILE=FNAMEC,STATUS='NEW')
         ENDIF
       ENDIF

CC-----READ OUTPUT COLUMNS NAMES AND CREATE THEM
       CALL STKRDC('OUTPUTC',1,1,17,ACTS,OUTC1,KUN,KNUL,STATUS)
       CALL STKRDC('OUTPUTC',1,18,17,ACTS,OUTC2,KUN,KNUL,STATUS)
       CALL TBCSER(LUA,OUTC1,OUTN1,STATUS)
       IF (OUTN1.LT.0) THEN
          CALL TBCINI(LUA,D_R8_FORMAT,1,'F12.6','Units',OUTC1,
     +             OUTN1,STATUS)
       ENDIF

       CALL TBCSER(LUA,OUTC2,OUTN2,STATUS)
       IF (OUTN2.LT.0) THEN
           CALL TBCINI(LUA,D_R8_FORMAT,1,'F12.6','Units',OUTC2,
     +             OUTN2,STATUS)
       ENDIF

CC-----WHERE DO YOU WANT THE OUTPUT
       CALL STKRDC('OUT_A',1,1,80,ACTS,FNAMEB,KUN,KNUL,STATUS)


       IF (FNAMEB.EQ.'con'.OR.FNAMEB.EQ.'Con') FNAMEB='CON'
       IF (FNAMEB.EQ.'prn'.OR.FNAMEB.EQ.'Prn') FNAMEB='PRN'
       IF (FNAMEB.EQ.'CON'.OR.FNAMEB.EQ.'PRN')
     +     OPEN(LUB,FILE=FNAMEB,STATUS='UNKNOWN')
       IF (.NOT.(FNAMEB.EQ.'CON'.OR.FNAMEB.EQ.'PRN'))
     1     OPEN(LUB,FILE=FNAMEB,STATUS='UNKNOWN')

CC-----PLEASE ENTER A TITLE FOR THE OUTPUT
       JHEAD = ' ' 

       NVSB=NVAR-1
       ANVAR=NVAR

CC-----DO YOU WANT TO READ THE DATA IN FREE FORMAT
  180   CONTINUE
       YN = 'Y'

       IF (YN.EQ.'y') YN='Y'
       IF (YN.EQ.'n') YN='N'
       IF (YN.NE.'Y'.AND.YN.NE.'N') THEN
         WRITE(CBUF,8050)
         CALL STTPUT(CBUF,ISTAT)
         GOTO 180
       ENDIF
       IF (YN.NE.'Y') THEN
CC-----READ FORMAT FOR THE INPUT
         WRITE(CBUF,8290)
         CALL STTPUT(CBUF,ISTAT)
         READ (*,9040) JFMT
       ENDIF
       IF (LOCA.NE.1) THEN

CC-----  WHICH ALGORITHM
  190    CONTINUE
         ALGO = 'E'

         IF (ALGO.EQ.'e') ALGO='E'
         IF (ALGO.EQ.'q') ALGO='Q'
         IF (ALGO.NE.'Q'.AND.ALGO.NE.'E') THEN
            WRITE(CBUF,8050)
            CALL STTPUT(CBUF,ISTAT)
            GOTO 190
         ENDIF
       ENDIF

CC-----OPTION FOR THE TREATMENT OF MISSING VALUE
  200   CONTINUE
       YNOK = '0'

       IF (.NOT.(YNOK.EQ.'0'.OR.YNOK.EQ.'1'.OR.
     1                  (YNOK.EQ.'2'.AND.LOCA.NE.1) ) ) THEN
         WRITE (CBUF,8050)
         CALL STTPUT(CBUF,ISTAT)
         GOTO 200
       ENDIF
       MVAL=JNTGR(YNOK)
       
CC-----ABSTRACT OF ALL THE OPTIONS
       IF (LOCA.EQ.1) THEN
         WRITE(CBUF,8330) LAB(NVAD),NCAS
         CALL STTPUT(CBUF,ISTAT)
                      ELSE
         IF (JCST.EQ.0) THEN
           CALL STTPUT('****************************************',ISTAT)
           CALL STTPUT('             P R O G R E S S            ',ISTAT)
           CALL STTPUT('WILL PERFORM A REGRESSION WITHOUT CONSTANT TERM'
     1 ,ISTAT)
           CALL STTPUT('****************************************',ISTAT)
           WRITE(CBUF,202) NCAS
  202      FORMAT(' THE NUMBER OF CASES EQUALS',17X,I5)
           CALL STTPUT(CBUF,ISTAT)
           WRITE(CBUF,204) NVAR
  204      FORMAT(' THE NUMBER OF EXPLANATORY VARIABLES EQUALS ',I5)
           CALL STTPUT(CBUF,ISTAT)
   
         ELSEIF (JCST.EQ.1) THEN
            CALL STTPUT('***************************************',ISTAT)
            CALL STTPUT('*           P R O G R E S S           *',ISTAT)
            CALL STTPUT('*WILL PERFORM A REGRESSION WITH CONSTANT TERM*'
     1 ,ISTAT)
            CALL STTPUT('***************************************',ISTAT)            
            WRITE(CBUF,205) NCAS 	
  205       FORMAT(' THE NUMBER OF CASES EQUALS',19X,I5)
            CALL STTPUT(CBUF,ISTAT)
            WRITE(CBUF,207) NVSB 
  207       FORMAT('THE NUMBER OF EXPLANATORY VARIABLES EQUALS',3X,I5)
            CALL STTPUT(CBUF,ISTAT)
         ENDIF   
         WRITE(CBUF,8360) LAB(NVAD)
         CALL STTPUT(CBUF,ISTAT)
       ENDIF
       IF (FNAMEA.NE.'CON') THEN
           WRITE(CBUF,8370) FNAMEA
           CALL STTPUT(CBUF,ISTAT)
       ELSEIF (FNAMEA.EQ.'CON') THEN
           WRITE(CBUF,8380)
           CALL STTPUT(CBUF,ISTAT)
       ENDIF 
       IF (YNSAVE.EQ.'Y') THEN
          WRITE(CBUF,8390) FNAMEC
          CALL STTPUT(CBUF,ISTAT)
       ENDIF  
       WRITE(CBUF,8400) JHEAD
       CALL STTPUT(CBUF,ISTAT)
       IF (YN.EQ.'Y') THEN
          WRITE(CBUF,8410)
          CALL STTPUT(CBUF,ISTAT)
       ELSEIF (YN.EQ.'N') THEN
          WRITE(CBUF,8420) JFMT
          CALL STTPUT(CBUF,ISTAT)
       ENDIF  
       IF (JPRT.EQ.0) THEN
           WRITE (CBUF,8430)
           CALL STTPUT(CBUF,ISTAT)   
       ELSEIF (JPRT.EQ.1) THEN
           WRITE (CBUF,8440)
           CALL STTPUT(CBUF,ISTAT)
       ELSEIF (JPRT.EQ.2) THEN
           WRITE (CBUF,8450)
           CALL STTPUT(CBUF,ISTAT)
       ENDIF
       IF (JPLT.EQ.0) THEN
          WRITE(CBUF,8460)
          CALL STTPUT(CBUF,ISTAT)
       ELSEIF (JPLT.EQ.1) THEN
          WRITE(CBUF,8470)
          CALL STTPUT(CBUF,ISTAT)
       ELSEIF (JPLT.EQ.2) THEN
          WRITE(CBUF,8480)
          CALL STTPUT(CBUF,ISTAT)
       ELSEIF (JPLT.EQ.3) THEN
          WRITE(CBUF,8490)
          CALL STTPUT(CBUF,ISTAT)
       ENDIF
       IF (LOCA.NE.1) THEN
         IF (ALGO.EQ.'Q') THEN
           WRITE(CBUF,8500)
           CALL STTPUT(CBUF,ISTAT)
         ELSEIF (ALGO.EQ.'E') THEN 
            WRITE(CBUF,8510)
            CALL STTPUT(CBUF,ISTAT)
         ENDIF   
       ENDIF
       IF (MVAL.EQ.0) THEN
          WRITE(CBUF,8520)
          CALL STTPUT(CBUF,ISTAT)
       ELSEIF (MVAL.EQ.1.AND.LOCA.NE.1) THEN
          WRITE(CBUF,8530)
          CALL STTPUT(CBUF,ISTAT)
       ELSEIF (MVAL.EQ.1.AND.LOCA.EQ.1) THEN
          WRITE(CBUF,8535)
          CALL STTPUT(CBUF,ISTAT)
       ELSEIF (MVAL.EQ.2) THEN
          WRITE(CBUF,8540)
          CALL STTPUT(CBUF,ISTAT)
       ENDIF
       WRITE(CBUF,8550) FNAMEB
       CALL STTPUT(CBUF,ISTAT)
       WRITE (CBUF,8560)
       CALL STTPUT(CBUF,ISTAT)

 210   CONTINUE
       YNOK = 'Y'

       IF (YNOK.EQ.'y') YNOK='Y'
       IF (YNOK.EQ.'n') YNOK='N'
       IF (YNOK.NE.'Y'.AND.YNOK.NE.'N') THEN
         WRITE (CBUF,8050)
         CALL STTPUT(CBUF,ISTAT)
         GOTO 210
       ENDIF
       IF (YNOK.NE.'Y') GOTO 11

C       CALL STTPUT('If LOCA=1, LCAT starts',ISTAT)
       IF (LOCA.EQ.1)       
     1 CALL LCAT(NCAS,NVAR,JCST,JPRT,NVAD,X,Y,RESDU,WEIGHTS,PREC,
     2 XMED,XMAD,NZWE,AVW,JPLT,AW,NMVAL,NDXX,NDXY,MVAL,LUA,LUB,LUC,
     3 JREG,JHEAD,FNAMEA,FNAMEB,FNAMEC,YNSAVE,LAB,JFMT,JVARS,YN,JPLACE)

       IF (MVAL.NE.0) THEN
         DO 220 J=1,NVAD
         IF (J.EQ.1) THEN
           WRITE (CBUF,8570)
           CALL STTPUT(CBUF,ISTAT)
 225           READ (*,9000) YNM
           IF (YNM.EQ.'y') YNM='Y'
           IF (YNM.EQ.'n') YNM='N'
           IF (YNM.NE.'Y'.AND.YNM.NE.'N') THEN
              WRITE(CBUF,8050)
              CALL STTPUT(CBUF,ISTAT)
              GOTO 225
           ENDIF
           IF (YNM.EQ.'Y'.OR.YNM.EQ.'y') THEN
              YNM='Y'
              WRITE (CBUF,8580)
              CALL STTPUT(CBUF,ISTAT)
              READ(*,*,ERR=226)CODE
226           CONTINUE
           ENDIF
         ENDIF
         IF (YNM.NE.'Y') THEN
           IF (J.EQ.NVAR.AND.JCST.EQ.1) GOTO 220
           IF (J.NE.NVAD) THEN
              WRITE (CBUF,8590) LAB(J)
              CALL STTPUT(CBUF,ISTAT)
           ELSEIF (J.EQ.NVAD) THEN
              WRITE (CBUF,8600)
              CALL STTPUT(CBUF,ISTAT)
           ENDIF
 230       READ (*,9000) YNOK
           IF (YNOK.EQ.'y') YNOK='Y'
           IF (YNOK.EQ.'n') YNOK='N'
           IF (YNOK.NE.'Y'.AND.YNOK.NE.'N') THEN
             WRITE (CBUF,8050)
             CALL STTPUT(CBUF,ISTAT)
             GOTO 230
           ENDIF
                         ELSE
           YNOK='Y'
         ENDIF
         IF (YNOK.NE.'Y') THEN
            JNDEX(J)=0
                          ELSE
            JNDEX(J)=1
CC-----READ THE VALUE WHICH HAS TO BE INTERPRETED AS THE MISSING VALUE CODE
            IF (YNM.NE.'Y')  THEN
               WRITE(CBUF,8610)
               CALL STTPUT(CBUF,ISTAT)
               READ(*,*,ERR=231)VALMS(J)
231            CONTINUE
            ELSE
               VALMS(J)=CODE
            ENDIF
         ENDIF
 220   CONTINUE
       ENDIF
CC-----ENTER THE DATA FOR EACH CASE
       IF (FNAMEA.EQ.'CON') THEN
          WRITE(CBUF,8615)
          CALL STTPUT(CBUF,ISTAT)
       ENDIF  

       JNC = 0
       DO 250 NSEL=1,ROW
       CALL TBSGET(LUA,NSEL,VALUE,STATUS)
       IF (VALUE) THEN

       JNC = JNC + 1
       NMVAL(JNC)=JNC

C--------------------------------------------------------        
       IF (JCST.EQ.0) THEN
         CALL STTPUT('Without constant term',ISTAT)
         IF (YN.EQ.'Y') THEN
            CALL STTPUT('Data in free format (default).',ISTAT)	 

            DO 260 J=1,NVAD
            JH=JPLACE(J)
            CALL TBERDR(LUA,NSEL,JH,AW(JH),NULL,STATUS)
            X(J,JNC)=AW(JH)
 260            CONTINUE
            IF (YNSAVE.EQ.'Y') WRITE(LUC,*)(AW(J),J=1,JVARS)
         ELSE
            CALL STTPUT('Data is not in free format',ISTAT)
            READ(LUA,JFMT)(AW(J),J=1,JVARS)
            DO 270 J=1,NVAD
            JH=JPLACE(J)
            X(J,JNC)=AW(JH)
 270            CONTINUE
            IF (YNSAVE.EQ.'Y') WRITE(LUC,*)(AW(J),J=1,JVARS)
         ENDIF

       ELSE
         X(NVAR,JNC)=1.0
         IF (YN.EQ.'Y') THEN
           DO 280 J=1,NVAD
           IF (.NOT.(J.EQ.NVAR.AND.JCST.EQ.1)) THEN
             JH=JPLACE(J)
             CALL TBERDR(LUA,NSEL,JH,AW(JH),NULL,STATUS)
             X(J,JNC)=AW(JH)
           ENDIF
 280           CONTINUE
           IF (YNSAVE.EQ.'Y') WRITE(LUC,*)(AW(J),J=1,JVARS)
         ELSE
           DO 290 J=1,NVAD
           IF (.NOT.(J.EQ.NVAR.AND.JCST.EQ.1)) THEN
             JH=JPLACE(J)
             CALL TBERDR(LUA,NSEL,JH,AW(JH),NULL,STATUS)
             X(J,JNC)=AW(JH)
           ENDIF
 290           CONTINUE
           IF (YNSAVE.EQ.'Y') WRITE(LUC,*) (AW(J),J=1,JVARS)
         ENDIF
       ENDIF
C--------------------------------------------------------

       ENDIF
 250   CONTINUE

       IF (YNSAVE.EQ.'Y') CLOSE(LUC,STATUS='KEEP')
       IF (YNSAVE.EQ.'Y') THEN
         WRITE(CBUF,8395) FNAMEC
         CALL STTPUT(CBUF,ISTAT)
       ENDIF 
C
C     
CC-----FORMATS
CK 8000  FORMAT(/////////////////30X,19('*')/
CK     1 30X,'* P R O G R E S S *'/30X,19('*')///////)
CK 8010  FORMAT(/' ENTER THE NUMBER OF CASES PLEASE : ',$)
 8020  FORMAT(/' THERE ARE TOO MANY CASES (AT MOST',I5,' )',
     1 ' ACCORDING TO THE LIMITS'
     1 /' OF THE ARRAYS IN THE PROGRAM. THE USER HAS TO ADAPT THESE'
     1 /' LIMITS SUCH THAT THE CONCERNING LIMITS ARE GREATER THAN OR'
     1 /' EQUAL TO THE NUMBER OF CASES IN HIS DATA SET OR'
     1 /' ANOTHER REGRESSION CAN BE PERFORMED.'//)
 8030  FORMAT(/' THERE ARE NOT ENOUGH CASES'
     1 ' (AT LEAST 2 ARE REQUIRED).'//)
 8050  FORMAT(' NOT ALLOWED !  ENTER YOUR CHOICE AGAIN : ',$)
CK 8060  FORMAT(/' WHAT IS THE TOTAL NUMBER OF VARIABLES IN YOUR',
CK     1 ' DATA SET?'/1X,56('-')/
CK     1 ' PLEASE GIVE A NUMBER BETWEEN 1 AND 50 : ',$)
CK 8070  FORMAT(/' THE PROBLEM IS REDUCED TO ESTIMATING A LOCATION',
CK     1 ' PARAMETER.')
CK 8080  FORMAT(/' WHICH VARIABLE DO YOU CHOOSE AS RESPONSE VARIABLE?'/
CK     1 1X,50('-')/' OUT OF THESE ',I4,' GIVE ITS POSITION : ',$)
CK 8090  FORMAT(/' GIVE A LABEL FOR THIS VARIABLE',
CK     1 ' (AT MOST 10 CHARACTERS) : ',$)
CK 8100  FORMAT(/' HOW MANY EXPLANATORY VARIABLES DO YOU WANT TO USE',
CK     1 ' IN THE ANALYSIS?'/1X,66('-')/
CK     1 ' (AT MOST ',I4,' ) : ',$)
CK 8110  FORMAT(//' TOO MANY COEFFICIENTS ACCORDING TO THE NUMBER',
CK     1 ' OF CASES.'//' NUMBER OF CASES',8X,'= ',I5/
CK     1 ' NUMBER OF COEFFICIENTS = ',I5/' THE NUMBER OF CASES MUST',
CK     1 ' BE TWICE THE NUMBER OF COEFFICIENTS.')
CK 8115  FORMAT(//' THERE ARE TOO MANY COEFFICIENTS (AT MOST',I3,'  )',
CK     1 ' ACCORDING TO THE LIMITS'/' OF THE ARRAYS IN THE PROGRAM.',
CK     1 ' THE USER HAS TO ADAPT THESE'/' LIMITS SUCH THAT THE',
CK     1 ' CONCERNING LIMITS ARE GREATER THAN OR'/
CK     1 ' EQUAL TO THE NUMBER OF COEFFICIENTS IN THE MODEL.'//)
CK 8120  FORMAT(' (INCLUDING THE CONSTANT TERM!)')
CK 8130  FORMAT(//' EXPLANATORY VARIABLES      :   POSITION',
CK     1 '   LABEL (AT MOST 10 CHARACTERS)'/
CK     1 1X,32('-'),4(' '),6('-'),10(' '),19('-'))
CK 8140  FORMAT(' NUMBER  ',I4,15X,':',4X,I4,6X,$)
CK 8150  FORMAT(' NUMBER  ',I4,15X,':',4X,$)
CK 8160  FORMAT(/' THIS POSITION HAS ALREADY BEEN CHOOSEN FOR ANOTHER',
CK     1 ' VARIABLE.'/' ENTER THE RIGHT POSITION PLEASE : ')
CK 8170  FORMAT(/' HOW MUCH OUTPUT DO YOU WANT?'/1X,29('-')/
CK     1 ' 0 = SMALL OUTPUT',7X,': LIMITED TO BASIC RESULTS'/
CK     1 ' 1 = MEDIUM-SIZED OUTPUT:',
CK     1 ' ALSO INCLUDES A TABLE WITH THE OBSERVED VALUES OF Y,'/
CK     1 25X,' THE ESTIMATES OF Y, THE RESIDUALS AND THE WEIGHTS'/
CK     1 ' 2 = LARGE OUTPUT',7X,
CK     1 ': ALSO INCLUDES THE RAW AND STANDARDIZED DATA'/
CK     1 ' ENTER YOUR CHOICE : ',$)
CK 8180  FORMAT(/' DO YOU WANT TO LOOK AT THE RESIDUALS?'/1X,38('-')/
CK     1 ' 0 = NO RESIDUAL PLOTS'/
CK     1 ' 1 = PLOT OF STANDARDIZED RESIDUALS VERSUS THE ESTIMATED',
CK     1 ' VALUE OF Y'/' 2 = PLOT OF THE STANDARDIZED RESIDUALS',
CK     1 ' VERSUS THE INDEX OF THE OBSERVATION'/' 3 = PERFORMS',
CK     1 ' BOTH TYPES OF RESIDUAL PLOTS'/' ENTER YOUR CHOICE : ',$)
CK 8190  FORMAT(/' DO YOU WANT TO LOOK AT THE RESIDUALS?'/1X,38('-')/
CK     1 ' 0 = NO RESIDUAL PLOTS'/
CK     1 ' 1 = PLOT OF THE STANDARDIZED RESIDUALS',
CK     1 ' VERSUS THE INDEX OF THE OBSERVATION'/
CK     1 ' ENTER YOUR CHOICE : ',$)
CK 8200  FORMAT(/' DO YOU WANT TO COMPUTE OUTLIER DIAGNOSTICS ?',
CK     1 /' YES OR NO : ',$)
CK 8210  FORMAT(/' GIVE THE NAME OF THE FILE CONTAINING THE DATA',
CK     1 ' (e.g. TYPE  A:EXAMPLE.DAT ),'/' or TYPE',
CK     1 '  KEY  IF YOU PREFER TO ENTER THE DATA BY KEYBOARD.'/
CK     1 ' WHAT DO YOU CHOOSE ? ',$)
CK 8220  FORMAT(/' THIS FILE DOES NOT EXIST, PLEASE ENTER ANOTHER ONE.')
CK 8230  FORMAT(/' FORTRAN ERROR CODE : ',I8/)
CK 8240  FORMAT(/' DO YOU WANT TO SAVE YOUR DATA IN A FILE ?'/
CK     1 ' ANSWER YES OR NO : ',$)
8250  FORMAT(/' IN WHICH FILE DO YOU WANT TO SAVE YOUR DATA?'/
     1 ' (WARNING : IF THERE ALREADY EXISTS A FILE WITH THE SAME',
     1 ' NAME,'/11X,' THEN THE OLD FILE WILL BE OVERWRITTEN.)'/
     1 ' TYPE e.g.  B:SAVE.DAT  : ',$)
CK 8260  FORMAT(/' WHERE DO YOU WANT YOUR OUTPUT?'/1X,31('-')/
CK     1 '    TYPE  CON  IF YOU WANT IT ON THE SCREEN'/
CK     1 ' or TYPE  PRN  IF YOU WANT IT ON THE PRINTER'/
CK     1 ' or TYPE THE NAME OF A FILE (e.g. B:EXAMPLE.OUT)'/
CK     1 ' (WARNING : IF THERE ALREADY EXISTS A FILE WITH THE SAME',
CK     1' NAME',/11X,' THEN THE OLD FILE WILL BE OVERWRITTEN.)'/
CK     1 ' WHAT DO YOU CHOOSE ?  ',$)
CK 8270  FORMAT(/' PLEASE ENTER A TITLE FOR THE OUTPUT',
CK     1 ' (AT MOST 60 CHARACTERS).'/1X,60('-')/1X,$)
CK 8280  FORMAT(/' DO YOU WANT TO READ THE DATA IN FREE FORMAT?'/
CK     1 1X,44('-')/' THIS MEANS THAT YOU ONLY HAVE TO INSERT BLANK(S)',
CK     1 ' BETWEEN NUMBERS.'/' (WE ADVISE USERS WITHOUT',
CK     1 ' KNOWLEDGE OF FORTRAN FORMATS TO ANSWER YES.)'/
CK     1 ' MAKE YOUR CHOICE (YES/NO): ',$)
 8290  FORMAT(/' YOUR DESIRED FORTRAN FORMAT IS :'/
     1 ' (BETWEEN BRACKETS AND',
     1 ' AT MOST 60 CHARACTERS, e.g. (2F3.0,F1.0) )')
CK 8300  FORMAT(/' WHICH VERSION OF THE ALGORITHM WOULD YOU LIKE',
CK     1' TO USE?'/1X,53('-')/' Q = QUICK VERSION'/
CK     1 ' E = EXTENSIVE SEARCH '/
CK     1 ' ENTER YOUR CHOICE PLEASE (Q OR E) : ',$)
CK 8310  FORMAT(/' CHOOSE AN OPTION FOR THE TREATMENT OF MISSING VALUES'/
CK     1 1X,53('-')/' 0 = THERE ARE NO MISSING VALUES IN THE DATA'/
CK     1 ' 1 = ELIMINATION OF THE CASES FOR WHICH AT LEAST ONE',
CK     1 ' VARIABLE IS MISSING'/' 2 = ESTIMATES ARE FILLED IN FOR',
CK     1 ' UNOBSERVED VALUES'/' ENTER YOUR CHOICE : ',$)
CK 8320  FORMAT(/' CHOOSE AN OPTION FOR THE TREATMENT OF MISSING VALUES'/
CK     1 1X,53('-')/' 0 = THERE ARE NO MISSING VALUES IN THE DATA'/
CK     1 ' 1 = ELIMINATION OF THE CASES FOR WHICH THE',
CK     1 ' VARIABLE IS MISSING'/' ENTER YOUR CHOICE : ',$)
 8330  FORMAT(//////////8X,63('*')/8X,
     1 '* P R O G R E S S  WILL PERFORM A LOCATION AND SCALE',
     1 ' ANALYSIS *'/8X,63('*')//
     1 1X,A10,' IS THE LABEL OF THE VARIABLE.'/
     1 ' THE NUMBER OF CASES EQUALS',13X,I5/)
C 8340  FORMAT(/////////6X,68('*')/6X,
C     1 '* P R O G R E S S  WILL PERFORM A REGRESSION WITHOUT CONSTANT',
C     1' TERM *'/6X,68('*')//' THE NUMBER OF CASES EQUALS',17X,I5/
C     1 ' THE NUMBER OF EXPLANATORY VARIABLES EQUALS ',I5)
C 8350  FORMAT(/////////8X,65('*')/8X,
C     1 '* P R O G R E S S  WILL PERFORM A REGRESSION WITH CONSTANT',
C     1 ' TERM *'/8X,65('*')//' THE NUMBER OF CASES EQUALS',19X,I5/
C     1 ' THE NUMBER OF EXPLANATORY VARIABLES EQUALS',3X,I5)
 8360  FORMAT(1X,A10,' IS THE RESPONSE VARIABLE.')
 8370  FORMAT(' YOUR DATA RESIDE IN FILE',7X,': ',A30)
 8380  FORMAT(' THE DATA WILL BE READ FROM THE KEYBOARD.')
 8390  FORMAT(' THE DATA WILL BE SAVED IN FILE : ',A30)
 8395  FORMAT(//' THE DATA WILL BE SAVED IN FILE : ',A30//)
 8400  FORMAT(' TITLE FOR OUTPUT : ',A60)
 8410  FORMAT(' THE DATA WILL BE READ IN FREE FORMAT.')
 8420  FORMAT(' DATA INPUT FORMAT :'/5X,A60)
 8430  FORMAT(' SMALL OUTPUT IS WANTED.')
 8440  FORMAT(' MEDIUM-SIZED OUTPUT IS WANTED.')
 8450  FORMAT(' LARGE OUTPUT IS WANTED.')
 8460  FORMAT(' NO RESIDUAL PLOTS ARE WANTED.')
 8470  FORMAT(' A PLOT OF STANDARDIZED RESIDUALS VERSUS',
     1 ' ESTIMATED Y IS WANTED.')
 8480  FORMAT(' AN INDEX PLOT IS WANTED.')
 8490  FORMAT(' BOTH TYPES OF RESIDUAL PLOTS ARE WANTED.')
 8500  FORMAT(' THE QUICK VERSION OF THE ALGORITHM WILL BE USED.')
 8510  FORMAT(' THE EXTENSIVE SEARCH VERSION WILL BE USED.')
 8520  FORMAT(' THERE ARE NO MISSING VALUES.')
 8530  FORMAT(' TREATMENT OF MISSING VALUES IN OPTION 1:',
     1 ' THIS MEANS THAT A CASE WITH A'/' MISSING VALUE',
     1 ' FOR AT LEAST ONE VARIABLE WILL BE DELETED.'/)
 8535  FORMAT(' TREATMENT OF MISSING VALUES :',
     1 ' A CASE WITH A'/' MISSING VALUE',
     1 ' FOR THE VARIABLE WILL BE DELETED.'/)
 8540  FORMAT(' TREATMENT OF MISSING VALUES IN OPTION 2:'/
     1 ' FIRST, A CASE WITH A MISSING VALUE FOR THE RESPONSE VARIABLE'
     1 /' OR FOR ALL EXPLANATORY VARIABLES WILL BE DELETED.'/
     1 ' THEN, A MISSING VALUE FOR A VARIABLE WILL BE REPLACED BY'/
     1 ' THE MEDIAN OF THE NON-MISSING VALUES .'/)
 8550  FORMAT(' YOUR OUTPUT WILL BE WRITTEN ON : ',A30)
 8560  FORMAT(' ARE ALL THESE OPTIONS OK ?',' YES OR NO : ')
 8570  FORMAT(/' IS THERE A UNIQUE VALUE WHICH IS TO BE',
     1 ' INTERPRETED'/' AS A MISSING MEASUREMENT FOR ANY VARIABLE?'/
     1 ' ANSWER YES OR NO : ',$)
 8580  FORMAT(/' PLEASE ENTER THIS VALUE : ',$)
 8590  FORMAT(' DOES VARIABLE ',A10,
     1 ' CONTAIN MISSING VALUE(S)?'/' ANSWER YES OR NO : ',$)
 8600  FORMAT(' DOES THE RESPONSE VARIABLE CONTAIN MISSING VALUE(S)?'/
     1 ' ANSWER YES OR NO : ',$)
 8610  FORMAT(' ENTER THE VALUE OF THIS VARIABLE',
     1 ' WHICH HAS TO BE INTERPRETED AS'/
     1 ' THE MISSING VALUE CODE : ',$)
 8615  FORMAT(//' ENTER YOUR DATA FOR EACH CASE.'//)
CK 8620  FORMAT(1X,' THE DATA FOR CASE NUMBER ',I4,' : ',$)
CK 8630  FORMAT(' THE DATA FOR CASE NUMBER ',I4,' : ',$)
 9000  FORMAT(A1)
CK 9010  FORMAT(A10)
CK 9020  FORMAT(BN,I4,6X,A10)
 9030  FORMAT(A30)
 9040  FORMAT(A60)
       RETURN
       END

CC     ------------------------------------------------------------------------
CC     *JNTGR*: SUBROUTINE FOR TRANSFORMING A CHARACTER INTO AN INTEGER
CC     ------------------------------------------------------------------------
       FUNCTION JNTGR(KAR)

       INCLUDE 'MID_REL_INCL:implicit.inc'

       CHARACTER*1 KAR
       IF (KAR.EQ.'0') JNTGR=0
       IF (KAR.EQ.'1') JNTGR=1
       IF (KAR.EQ.'2') JNTGR=2
       IF (KAR.EQ.'3') JNTGR=3
       RETURN
       END
CC     ------------------------------------------------------------------------
CC     *SMISSING*: SUBROUTINE FOR HANDLING MISSING VALUES
CC     ------------------------------------------------------------------------
       SUBROUTINE SMISSING(NVAR,NCAS,NDXX,NDXY,JCST,X,Y,AW,NMVAL,
     1 MVAL,JNDEX,JNDVC,VALMS,NSTOP,LAB,JPRT,LUB)

       INCLUDE 'MID_REL_INCL:implicit.inc'

       DIMENSION X(NDXX,NDXY),Y(NDXY),AW(NDXY)
       DIMENSION NMVAL(NDXY),VALMS(NDXX),JNDVC(NDXX),JNDEX(NDXX)
       CHARACTER*10 LAB(NDXX)
       CHARACTER*80 OUTEXT
       INTEGER      ISTAT
       NVSB=NVAR-1
       NVAD=NVAR+1
       JHALT=0
       JHLT=0
       MAXM=(NCAS*4)/5
       DO 10 J=1,NVAD
       JNDVC(J)=0
       IF (.NOT.((J.EQ.NVAR.AND.JCST.EQ.1).OR.(JNDEX(J).EQ.0)))THEN
          DO 20 JNC=1,NCAS
          IF (X(J,JNC).EQ.VALMS(J)) THEN
             JNDVC(J)=JNDVC(J)+1
             NMVAL(JNC)=0
          ENDIF
 20          CONTINUE
          IF (JNDVC(J).GT.MAXM) JHALT=JHALT+1
          IF (MVAL.EQ.1.AND.JPRT.NE.0) WRITE(LUB,8000) LAB(J),JNDVC(J)
       ENDIF
 10    CONTINUE
       IF(JHALT.EQ.0) GOTO 30
       WRITE(LUB,8010) JHALT,MAXM
       NSTOP=1
       RETURN
 30    NCASM=NCAS
       MAXM=NCAS-MAXM
       JL=0
       JHALT=0
       DO 50 JNC=1,NCASM
       IF (NMVAL(JNC).NE.0) GOTO 65
       IF(JHALT.EQ.1.OR.MVAL.EQ.2) GOTO 60
       IF (JPRT.NE.0) WRITE(LUB,8020) NVAD
       JHALT=1
 60    JTVAR=0
       DO 70 J=1,NVAD
       IF(((JCST.EQ.1.AND.J.EQ.NVAR).OR.(JNDEX(J).EQ.0)).OR.
     1 (X(J,JNC).NE.VALMS(J))) GOTO 70
       JTVAR=JTVAR+1
       JNDVC(JTVAR)=J
 70    CONTINUE
       IF (JTVAR.EQ.0) GOTO 65
       IF (MVAL.EQ.1.OR.JHLT.EQ.1) GOTO 80
       IF (JPRT.NE.0) WRITE(LUB,8030)
       JHLT=1
 80    IF (MVAL.EQ.1.AND.JPRT.NE.0) THEN
          IF (JTVAR.GT.10) GOTO 90
          WRITE(LUB,8040) JNC,(JNDVC(J),J=1,JTVAR)
          GOTO 100
 90          WRITE(LUB,8040) JNC,(JNDVC(J),J=1,10)
          WRITE(LUB,8050) (JNDVC(J),J=11,JTVAR)
       ENDIF
 100   IF (MVAL.EQ.2.AND.X(NVAD,JNC).EQ.VALMS(NVAD)) THEN
          IF (JPRT.NE.0) WRITE(LUB,8060) JNC
          JTVAR=JTVAR-1
       ENDIF
       IF (JCST.EQ.1) JTVAR=JTVAR+1
       IF(MVAL.EQ.2.AND.JTVAR.EQ.NVAR.AND.JPRT.NE.0) WRITE(LUB,8070) JNC
       IF (.NOT.(MVAL.EQ.2.AND.JTVAR.LT.NVAR.AND.X(NVAD,JNC).
     1 NE.VALMS(NVAD))) GOTO 50
 65    JL=JL+1
       DO 110 J=1,NVAD
 110   X(J,JL)=X(J,JNC)
       NMVAL(JL)=JNC
 50    CONTINUE
       NCAS=JL
       WRITE(LUB,8080) NCAS
       IF (NCAS.LE.(NVAR*1.75)) THEN
          WRITE (OUTEXT,8090) NCAS,NVAR
          CALL STTPUT(OUTEXT,ISTAT)
          IF (JCST.EQ.1) THEN
             WRITE(OUTEXT,8100)
             CALL STTPUT(OUTEXT,ISTAT)
          ENDIF   
          NSTOP=1
          RETURN
       ENDIF
       IF (NCAS.LE.MAXM) THEN
          WRITE(LUB,8110)
          NSTOP=1
          RETURN
       ENDIF
       IF (MVAL.NE.1) THEN
         DO 150 J=1,NVAR
         IF ((JCST.EQ.1.AND.J.EQ.NVAR).OR.
     1         (JNDEX(J).EQ.0)) GOTO 150
         JJ=0
         NCASM=NCAS
         JPLUS=0
         DO 160 JNC=1,NCAS
         JPLUS=JPLUS+1
         AW(JPLUS)=X(J,JNC)
         IF (X(J,JNC).EQ.VALMS(J)) THEN
            NCASM=NCASM-1
            JJ=JJ+1
            JPLUS=JPLUS-1
            Y(JJ)=JNC
         ENDIF
 160         CONTINUE
         IF (JJ.EQ.0) THEN
            IF (JPRT.NE.0) WRITE(LUB,8120) LAB(J)
                      ELSE
            NCASM=NCAS-JJ
            AMED=AMDAN(AW,NDXY,AW,NCASM)
            DO 180 J2=1,JJ
            JY=Y(J2)+0.2
 180            X(J,JY)=AMED
            IF (JPRT.NE.0) WRITE(LUB,8130) LAB(J),JJ
            DO 190 J2=1,JJ
            J2Y=Y(J2)+0.2
 190            IF (JPRT.NE.0) WRITE(LUB,8140) NMVAL(J2Y)
         ENDIF
 150   CONTINUE
       ENDIF
 8000  FORMAT(' VARIABLE ',A10,' HAS A MISSING VALUE FOR',
     1 I4,' CASES.')
 8010  FORMAT(' THERE ARE(IS) ',I4,' VARIABLE(S),WHICH CONTAIN(S)'/
     1 ' MORE THAN 80 PERCENT (=',I4,' ) CASES WITH MISSING VALUE.')
 8020  FORMAT(/' CASE HAS A MISSING VALUE FOR VARIABLES',
     1 ' (VARIABLE NUMBER ',I4,' IS THE RESPONSE)'/1X,
     1 4('-'),25X,9('-'))
 8030  FORMAT(' THE FOLLOWING CASES HAVE BEEN DELETED.'/)
 8040  FORMAT(1X,I4,23X,10I4)
 8050  FORMAT(28X,10I4)
 8060  FORMAT(' CASE ',I4,' HAS A MISSING VALUE FOR',
     1 ' THE RESPONSE VARIABLE.')
 8070  FORMAT(' CASE ',I4,' HAS A MISSING VALUE FOR ALL THE',
     1 ' EXPLANATORY VARIABLES.')
 8080  FORMAT(/' THERE ARE ',I4,' CASES STAYING IN THE ANALYSIS.'/)
 8090  FORMAT(/' TOO MANY COEFFICIENTS ACCORDING TO THE NUMBER',
     1 ' OF CASES.'//' NUMBER OF CASES',8X,'= ',I5/
     1 ' NUMBER OF COEFFICIENTS = ',I5/' THE NUMBER OF CASES MUST',
     1 ' BE TWICE THE NUMBER OF COEFFICIENTS.')
 8100  FORMAT(' (INCLUDING THE CONSTANT TERM!)')
 8110  FORMAT(' MORE THAN 80 PERCENT OF THE CASES HAD TO BE DELETED'/
     1 ' BECAUSE OF THE MISSING VALUES. THE ANALYSIS WILL BE STOPPED.')
 8120  FORMAT(' VARIABLE ',A10,' CONTAINS NO MISSING VALUES.')
 8130  FORMAT(' THE VALUES OF ',A10,' WILL BE REPLACED',
     1 ' BY THE MEDIAN FOR',I5,' CASES NAMELY')
 8140  FORMAT(30X,'CASE NUMBER',I6)
       RETURN
       END
CC     ------------------------------------------------------------------------
CC     SUBROUTINE FOR CALCULATING THE NUMBER OF REPLICATIONS IN THE
CC     LMS ALGORITHM
CC     ------------------------------------------------------------------------
       SUBROUTINE SUBREP(NVAR,NCAS,NDXX,ALGO,JNDVC,JREP)

       INCLUDE 'MID_REL_INCL:implicit.inc'

       DIMENSION JNDVC(NDXX)
       CHARACTER ALGO
       NVSB=NVAR-1
       NVAD=NVAR+1
CC-----JNDVC(NVAD) IS SET EQUAL TO 11 IF ONE HAS TO CONSIDER ALL
CC-----            COMBINATIONS OF P POINTS OUT OF N INSTEAD OF
CC-----            RANDOM SELECTION
       IF (NVAR.NE.1) GOTO 20
       IF (ALGO.EQ.'E') JREP=500
       IF (ALGO.EQ.'Q') JREP=150
       IF((NCAS.LE.500.AND.ALGO.EQ.'E').OR.(NCAS.LE.150.AND.
     1 ALGO.EQ.'Q'))JNDVC(NVAD)=11
       GOTO 70
 20    IF (NVAR.NE.2) GOTO 30
       IF (ALGO.EQ.'E') JREP=1000
       IF (ALGO.EQ.'Q') JREP=300
       IF((NCAS.LE.50.AND.ALGO.EQ.'E').OR.(NCAS.LE.25.AND.
     1 ALGO.EQ.'Q'))JNDVC(NVAD)=11
       GOTO 70
 30    IF (NVAR.NE.3) GOTO 40
       IF (ALGO.EQ.'E') JREP=1500
       IF (ALGO.EQ.'Q') JREP=400
       IF((NCAS.LE.22.AND.ALGO.EQ.'E').OR.(NCAS.LE.15.AND.
     1 ALGO.EQ.'Q'))JNDVC(NVAD)=11
       GOTO 70
 40    IF (NVAR.NE.4) GOTO 50
       IF (ALGO.EQ.'E') JREP=2000
       IF (ALGO.EQ.'Q') JREP=500
       IF((NCAS.LE.17.AND.ALGO.EQ.'E').OR.(NCAS.LE.12.AND.
     1 ALGO.EQ.'Q'))JNDVC(NVAD)=11
       GOTO 70
 50    IF (NVAR.NE.5) GOTO 60
       IF (ALGO.EQ.'E') JREP=2500
       IF (ALGO.EQ.'Q') JREP=600
       IF((NCAS.LE.15.AND.ALGO.EQ.'E').OR.(NCAS.LE.11.AND.
     1 ALGO.EQ.'Q'))JNDVC(NVAD)=11
       GOTO 70
 60    IF (ALGO.EQ.'Q') GOTO 80
       JREP=3000
       IF((NCAS.LE.14).AND.(NVAR.EQ.6)) JNDVC(NVAD)=11
       GOTO 70
 80    IF (NVAR.EQ.6) JREP=700
       IF (NVAR.EQ.7) JREP=850
       IF (NVAR.EQ.8) JREP=1250
       IF (NVAR.GE.9) JREP=1500
 70    IF( .NOT.((NVAR.GE.7).OR.(JNDVC(NVAD).NE.11)))THEN
CC-----CALCULATION OF THE NUMBER OF COMBINATION OF P POINTS OUT OF N
       JTLLR=NCAS
       JNEM=NVAR
       IF (NVAR.EQ.1) GOTO 100
       DO 90 JNP=1,NVSB
       JTLLR=JTLLR*(NCAS-JNP)
       JNEM=JNEM*(NVAR-JNP)
 90    CONTINUE
 100   NCMB=JTLLR/JNEM
       JNDVC(NVAD)=11
       JREP=NCMB
       ENDIF
       RETURN
       END

CC
CC  *MIDUAL* : CALCULATES THE RESIDUALS OF ALL CASES
CC
       SUBROUTINE MIDUAL(AA,JKEUS,JDA,NCAS,NVAR,JCST,JPRT,NVAD,LUB,PREC,
     1 JREG,X,Y,RESDU,WEIGHTS,XMED,XMAD,NZWE,AVW,JPLT,AW,NMVAL,
     1 NDXX,NDXY,JHEAD,LAB,LUA,OUTN1,OUTN2)

       INCLUDE 'MID_REL_INCL:implicit.inc'

       DIMENSION AA(JDA),X(NDXX,NDXY),Y(NDXY),RESDU(NDXY),WEIGHTS(NDXY)
       DIMENSION XMED(NDXX),XMAD(NDXX),AW(NDXY),NMVAL(NDXY)
       CHARACTER*10 LAB(NDXX)
       CHARACTER*60 JHEAD
       INTEGER      LUA,OUTN1,OUTN2,STATUS,NSEL
       INTEGER      COLUMN,ROW,NSC,ACOL,AROW
       LOGICAL       VALUE
       INTEGER       INUL
       REAL          RNUL
       DOUBLE PRECISION DNUL


       CALL TBIGET(LUA,COLUMN,ROW,NSC,ACOL,AROW,STATUS)
       CALL TBMNUL(INUL,RNUL,DNUL)

       JPL2=1
       AL=NCAS

       JNC = 0
       DO 20 NSEL=1,ROW
       CALL TBSGET(LUA,NSEL,VALUE,STATUS)
       IF (VALUE) THEN
       JNC = JNC + 1
       IF (.NOT.(NVAR.EQ.1.AND.JCST.EQ.1)) GOTO 40
       BBB=Y(JNC)-AA(1)
       GOTO 60
 40    AW(JNC)=0.0
       DO 30 J=1,NVAR
 30    AW(JNC)=AW(JNC)+AA(J)*(X(J,JNC)*XMAD(J)+XMED(J))
       YJ=Y(JNC)*XMAD(NVAD)+XMED(NVAD)
       BBB=YJ-AW(JNC)
 60    IF (AA(NVAD).GT.PREC) GOTO 70
       IF (ABS(BBB).LT.PREC) BBB=0.0
       RESDU(JNC)=BBB
       GOTO 50
 70    RESDU(JNC)=BBB/AA(NVAD)
 50    IF (JPRT.EQ.0) GOTO 20
       IF (NVAR.EQ.1.AND.JCST.EQ.1) GOTO 80

CC-----UPDATES MIDAS TABLE
        CALL TBEWRR(LUA,NSEL,OUTN1,AW(JNC),STATUS)
        CALL TBEWRR(LUA,NSEL,OUTN2,BBB,STATUS)

        GOTO 20
   80   CONTINUE
       ELSE
        CALL TBEWRD(LUA,NSEL,OUTN1,DNUL,STATUS)
        CALL TBEWRD(LUA,NSEL,OUTN2,DNUL,STATUS)
       ENDIF

 20    CONTINUE
CC 90    CONTINUE
CC 8000  FORMAT(//11X,'OBSERVED',12X,'RESIDUAL',
CC     1 '   NO',' RES/SC'/9X,A10/)
CC 8010  FORMAT(//11X,'OBSERVED',12X,'RESIDUAL',
CC     1 '   NO','  RES/SC',' WEIGHT'/9X,A10/)
CC 8020  FORMAT(//11X,'OBSERVED',11X,'ESTIMATED',12X,'RESIDUAL',
CC     1 3X,'NO',' RES/SC'/9X,A10,10X,A10/)
CC 8030  FORMAT(//11X,'OBSERVED',11X,'ESTIMATED',12X,'RESIDUAL',
CC     1 3X,'NO',' RES/SC',' WEIGHT'/9X,A10,10X,A10/)
CC 8040  FORMAT(1X,F18.5,2(1X,F19.5),I5,1X,F7.2,F6.1)
CC 8050  FORMAT(1X,F18.5,2(1X,F19.5),I5,'  *****')
C 
       RETURN
       END

C @(#)franz2d.for	19.1 (ES0-DMD) 02/25/03 13:17:31
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FRANZ2(X,NP,PARAM,Y1,DERIV)                                   
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                  
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  18:01 - 21 DEC 1987                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C--------------------------------------------------------------                 
C**********************************************                                 
C                                                                               
C      IMPLICIT NONE                                                            
C 2-DIM ROTATIONALLY SYMMETRIC FRANZ-FUNCTION                                   
C                                                                               
C**********************************************                                 
C                                                                               
C Author: O.-G. Richter, ESO Garching                                           
C                                                                               
      INTEGER NP
      REAL X(2)                                                            
      DOUBLE PRECISION Y1,PARAM(NP),DERIV(NP)                                   
C                                                                               
      DOUBLE PRECISION A,A1,A2,B,C,D,E,F,G,H,O,P,Q                              
C  !   1 / Sigma1                                                               
      C      = 1.0D0/ (DABS(PARAM(4))+1.0D-14)  !   1 / Sigma2                  
      D      = 1.0D0/PARAM(6)  !   x - xc                                       
      A1     = DBLE(X(1)) - PARAM(2)  !   (y - yc) / alfa                       
      A2     = (DBLE(X(2))-PARAM(3))/PARAM(7)                                   
      O      = A1*A2                                                            
      B      = A1*A1 + A2*A2 - 2.0D0*PARAM(8)*O                                 
      IF (B.LT.0.0D0) B      = 0.0D0  !   Distance from center                  
      B      = DSQRT(B)                                                         
      E      = 1.0D0 + B*D  !   Exponent                                        
      F      = E*PARAM(5)  !   Avoid singular value                             
      G      = B*C + 1.0D-34  !   \                                             
      H      = -DLOG(G)*F  !   |                                                
      IF (H.GE.+80.0D0) H      = 1.0D37  !   |                                  
      IF (DABS(H).LT.80.0D0) H      = DEXP(H)  !   |                            
      IF (H.LE.-80.0D0) H      = 0.0D0  !   |                                   
      F      = 0.0D0  !   |   Computation of                                    
      Q      = 0.0D0  !    >  the denominator                                   
      IF (B.EQ.0.0D0) GO TO 10  !   |   avoiding overflow                       
      F      = PARAM(6)/B  !   |                                                
      Q      = DLOG(G)  !   |                                                   
   10 P      = 0.0D0  !   |                                                     
      IF (H.EQ.0.0D0) GO TO 20  !   /                                           
      H      = 1.0D0/H  !   Denominator                                         
      P      = 1.0D0/ (1.0D0+H)                                                 
   20 DERIV(1) = P  !   Function value                                          
      Y1     = PARAM(1)*P                                                       
      P      = Y1*P*H                                                           
      DERIV(5) = -P*E*Q                                                         
      P      = P*PARAM(5)                                                       
      DERIV(4) = P*E*C                                                          
      P      = P*D                                                              
      A      = -P* (PARAM(4)* (1.0D0+F)+Q)/ (B+1.0D-35)                         
      DERIV(2) = A* (PARAM(8)*A2-A1)                                            
      DERIV(3) = A* (PARAM(8)*A1-A2)/PARAM(7)                                   
      DERIV(6) = P*B*Q*D                                                        
      DERIV(7) = A*A2* (PARAM(8)*A1-A2)/PARAM(7)                                
      DERIV(8) = -A*O                                                           
C                                                                               
      RETURN                                                                    
                                                                                
      END                                                                       

C @(#)objshp.for	19.1 (ES0-DMD) 02/25/03 13:25:36
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine OBJSHP         version 1         820521
C  A. Kruszewski             ESO Garching
C.KEYWORDS
C  search, shape
C.PURPOSE
C  calculates elongation of a geometrical figure formed by
C  multiple detections
C  positions of detections are used only
C.INPUT/OUTPUT
C  input arguments
C  ICAT        integer*4 array   pixel coordinates of detections
C  M           integer*$         number of independent detections
C                                of the same object
C  AVI         real*4            average x-coordinate in pixels
C  AVJ         real*4            average y-coordinate in pixels
C  output arguments
C  ELON        real*4            elongation of detection points
C  THETA       real*4            position angle of major axis
C  ISIZ        integer*4         maximal distance between detection
C                                points in pixels
C-----------------------------------------------------------------------
      SUBROUTINE OBJSHP(AVI, AVJ, AVII, AVIJ, AVJJ, ELON, THETA)
C
      IMPLICIT NONE
      REAL     ARG1 , ARG2
      REAL     AVI , AVII , AVIJ , AVJ , AVJJ
      REAL     ELON , THETA
C
C ******      Calculate elongation ELON and
C ******      position angle of major axis THETA.
C
      ELON = (AVII-AVJJ) * (AVII-AVJJ) + 4 * AVIJ * AVIJ
      ELON = SQRT( ELON )
      IF ( AVII+AVJJ .GT. 0.0 ) THEN
          ELON = ELON / (AVII+AVJJ)
          ARG1 = 2.0 * AVIJ
          ARG2 = AVII - AVJJ
          IF ( ARG1 .NE. 0.0 .OR. ARG2 .NE. 0.0 ) THEN
            THETA = 0.5 * ATAN2( ARG1 , ARG2 )
          ELSE
            ELON = 0.0
            THETA = 0.0
          ENDIF
      ELSE
          ELON = 0.0
          THETA = 0.0
      ENDIF
C
      RETURN
C
      END  

C @(#)util.for	19.1 (ESO-DMD) 02/25/03 14:01:09
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C 
      SUBROUTINE UPCAS(SA,SB)
C 
      IMPLICIT NONE
C
      INTEGER   M,N,KLEN,MLEN
C
      CHARACTER*(*)   SA,SB
      CHARACTER*27    ALPHU,ALPHL
C
      DATA   ALPHU  /' ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      DATA   ALPHL  /' abcdefghijklmnopqrstuvwxyz'/
C
      KLEN = LEN(SA)
      MLEN = LEN(SB)
      IF (KLEN.GT.MLEN) KLEN = MLEN
C
C  compare each input character with lowercase alphabet
      DO 100 N=1,KLEN
C
         DO 50 M=1,27
            IF (SA(N:N).EQ.ALPHL(M:M)) THEN
               SB(N:N) = ALPHU(M:M)
               GOTO 100
            ENDIF
50       CONTINUE
C 
         SB(N:N) = SA(N:N)
C
100   CONTINUE
C
      RETURN
      END

      SUBROUTINE LOWCAS(SA,SB)
C 
      IMPLICIT NONE
C
      INTEGER   M,N,KLEN,MLEN
C
      CHARACTER*(*)   SA,SB
      CHARACTER*27    ALPHU,ALPHL
C
      DATA   ALPHU  /' ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      DATA   ALPHL  /' abcdefghijklmnopqrstuvwxyz'/
C
      KLEN = LEN(SA)
      MLEN = LEN(SB)
      IF (KLEN.GT.MLEN) KLEN = MLEN
C
C  compare each input character with lowercase alphabet
      DO 100 N=1,KLEN
C
         DO 50 M=1,27
            IF (SA(N:N).EQ.ALPHU(M:M)) THEN
               SB(N:N) = ALPHL(M:M)
               GOTO 100
            ENDIF
50       CONTINUE
C 
         SB(N:N) = SA(N:N)
C
100   CONTINUE
C
      RETURN
      END

      SUBROUTINE BLANKO(STRING)
C
      INTEGER   N
C
      CHARACTER*(*)  STRING
C
      N = 2
C
200   IF (STRING(N:N).EQ.']') RETURN
C
      IF (STRING(N:N).EQ.' ') THEN
         STRING(N:) = STRING(N+1:)//' '
         GOTO 200
      ENDIF
C
      N = N + 1
      GOTO 200
C
      END

      SUBROUTINE BLANKI(STRING)
C
      INTEGER   N,M,K,KK
C
      CHARACTER*(*)  STRING
      CHARACTER*1    CC
C
      M = LEN(STRING)
      K = 1
C
      DO 100, N=1,M                      !get rid of leading blanks
         IF (STRING(N:N).NE.' ') THEN
            K = N
            GOTO 200
         ENDIF
100   CONTINUE
      RETURN                             !blank string
C
200   IF (K.GT.1) THEN
         STRING(1:) = STRING(K:)//' '
         M = M - K - 1
      ENDIF
C
220   DO 400, N=1,M
         IF (STRING(N:N).EQ.' ') THEN
            CC = STRING(N-1:N-1)
            IF ((CC.EQ. '(') .OR. (CC.EQ.'[')) THEN
               KK = N - 1
            ELSE
               KK = N
            ENDIF
            K = N
300         K = K + 1
            IF (K.GT.M) RETURN
C 
            IF (STRING(K:K) .EQ. ' ') THEN
               GOTO 300
            ELSE IF (K.GT.KK+1) THEN
               STRING(KK+1:) = STRING(K:)//' '
               M = M - (K-KK-1)
               GOTO 220                           !start afresh
            ENDIF
         ENDIF
400   CONTINUE
      RETURN                             !blank string
C 

      END

      SUBROUTINE GROWIT(ACT,NPIXA,A,NPIXB,B,LINNO)
C
C
      IMPLICIT NONE
C
      INTEGER     NPIXA(2),NPIXB(2),LINNO
      INTEGER     I,J,INOFF,OUTOFF,KIN,KOUT
C
      REAL        A(*),B(*)
C
      CHARACTER   ACT*1
C
      INOFF = (LINNO - 1) * NPIXA(1)
      OUTOFF = 0
C
      IF (ACT.EQ.'L') THEN
         DO 50, I=1,NPIXB(2)
            DO 10, J=1,NPIXB(1)
               KOUT = OUTOFF + J
               KIN = INOFF + J
               B(KOUT) = A(KIN)
10          CONTINUE
C
            OUTOFF = OUTOFF + NPIXB(1)
50       CONTINUE
C
      ELSE
         DO 150, I=1,NPIXB(2)
            KIN = INOFF + I
            DO 110, J=1,NPIXB(1)
               KOUT = OUTOFF + J
               B(KOUT) = A(KIN)
110         CONTINUE
C
            OUTOFF = OUTOFF + NPIXB(1)
150      CONTINUE
      ENDIF
C
      RETURN
      END

C @(#)invert.for	19.1 (ES0-DMD) 02/25/03 13:25:35
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine INVERT         version 1.0       830818
C  A. Kruszewski             ESO Garching
C.PURPOSE
C  inverts a symmetrical positively defined array SMTR
C  and keeps the result in the same array SMTR
C  it was written and tested in the case when array SMTR represents
C  a covariance matrix of a multimensional random variable
C  it may fail in other applications
C.INPUT/OUTPUT
C  input arguments
C  SMTR        real*4 array      symmetrical array
C  N           integer*4         dimension of array SMTR
C  output arguments
C  SMTR        real*4 array      inverted input array
C-----------------------------------------------------------------------
      SUBROUTINE INVERT(SMTR,N)
C
      IMPLICIT NONE
      INTEGER  N
      REAL     SMTR(N,N)
C
      INTEGER  I, I1
      INTEGER  J, J1
      INTEGER  K
      INTEGER  N1
      REAL     TEMP
C
C calculates triangular square root of the input array
C
      SMTR(1,1) = SQRT(SMTR(1,1))
      DO 40 I = 2,N
          I1     = I - 1
          DO 20 J = 1,I1
              TEMP   = SMTR(I,J)
              J1     = J - 1
              DO 10 K = 1,J1
                  TEMP   = TEMP - SMTR(I,K)*SMTR(J,K)
   10         CONTINUE
              SMTR(I,J) = TEMP/SMTR(J,J)
   20     CONTINUE
          TEMP   = SMTR(I,I)
          DO 30 K = 1,I1
              TEMP   = TEMP - SMTR(I,K)*SMTR(I,K)
   30     CONTINUE
          SMTR(I,I) = SQRT(TEMP)
   40 CONTINUE
C
C inverts the triangular square root matrix
C
      DO 50 I = 1,N
          SMTR(I,I) = 1.0/SMTR(I,I)
   50 CONTINUE
      N1     = N - 1
      DO 80 I = 1,N1
          I1     = I + 1
          DO 70 J = I1,N
              J1     = J - 1
              TEMP   = 0.0
              DO 60 K = I,J1
                  TEMP   = TEMP + SMTR(I,K)*SMTR(J,K)
   60         CONTINUE
              SMTR(I,J) = -TEMP*SMTR(J,J)
   70     CONTINUE
   80 CONTINUE
C
C squares inverted triangular matrix
C
      DO 110 I = 1,N
          DO 100 J = 1,I
              TEMP   = 0.0
              DO 90 K = I,N
                  TEMP   = TEMP + SMTR(I,K)*SMTR(J,K)
   90         CONTINUE
              SMTR(J,I) = TEMP
              SMTR(I,J) = TEMP
  100     CONTINUE
  110 CONTINUE
      RETURN

      END

C @(#)clbrgt.for	19.1 (ES0-DMD) 02/25/03 13:25:32
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENT:   subroutine CLBRGT         version 1.1       870729
C          A. Kruszewski             ESO Garching
C.PURPOSE: classifies saturated objects into stars and galaxies
C.INPUT/OUTPUT: 
C. input arguments
C  PMTR        real*4 array      array holding classifiers
C  BRGT        logical array     array indicating saturated objects
C  M           integer*4         number of objects
C  output arguments
C  ICLS        integer*4 array   array holding the classification
C                                coded: 0-defect or not classified,
C                                1-star, 2-galaxy. for each object 
C 				 the first element gives a seed value,
C				 the second gives a current value.
C-----------------------------------------------------------------------
      SUBROUTINE CLBRGT(PMTR, BRGT, ICLS, M)
C
      IMPLICIT NONE
      INCLUDE'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER I
      INTEGER IAC
      INTEGER ICLS(2,MAXCNT)
      INTEGER ISTAT
      INTEGER KUN, KNUL
      INTEGER MADRID(1)
      INTEGER M
C
      REAL    ALIM
      REAL    CVAR(3)
      REAL    PMTR(30,MAXCNT)
C
      LOGICAL BRGT(MAXCNT)
C
      COMMON /VMR/MADRID
C
      CALL STKRDR('INV_REAL', 5, 3, IAC, CVAR, KUN, KNUL, ISTAT )
C
      ALIM   = (CVAR(2)-CVAR(1))/2.0
      DO 10 I = 1,M
          IF (BRGT(I)) THEN
              IF (PMTR(3,I).GT.ALIM) THEN
                  ICLS(2,I) = 1

              ELSE
                  ICLS(2,I) = 2
              END IF

          END IF

   10 CONTINUE
      RETURN

      END

C @(#)midint.for	19.1 (ES0-DMD) 02/25/03 13:25:06
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C
C MIDINT.F - an interface between some IRAF F77/VOS routines and MIDAS
C
C Richard Hook, ST-ECF, August 1992
C
C This collection of routines is intended to ease the implementation of an IRAF
C F77/VOS application as a MIDAS program. However it is NOT intended to be a ful
C emulation. Almost all programs will require some 'MIDASification' for them to
C
      SUBROUTINE UMSPUT(STRING,ID1,ID2,ISTAT)
C
C Write out a string
C
      CHARACTER*(*) STRING
      INTEGER ID1,ID2,ISTAT
                           
      CALL STTPUT(STRING,ISTAT)
                               
      RETURN
      END
C
C Keyword reading routines. Note that these are just SCALAR
C versions and the VECTOR capacities of the MIDAS keyword system
C are ignored.
C
      SUBROUTINE UCLGST(KEY,STRING,ISTAT)
C
C Read in a string from a keyword
C
      CHARACTER*(*) KEY,STRING
      INTEGER ISTAT
                   
      INTEGER IACT,KUN,KNUL
                           
      CALL STKRDC(KEY,1,1,LEN(STRING),IACT,STRING,KUN,KNUL,ISTAT)
                                                                 
      RETURN
      END
         
      SUBROUTINE UCLGSI(KEY,VAL,ISTAT)
C
C Read in an integer from a keyword
C
      CHARACTER*(*) KEY
      INTEGER VAL
      INTEGER ISTAT
                   
      INTEGER IACT,KUN,KNUL
                           
      CALL STKRDI(KEY,1,1,IACT,VAL,KUN,KNUL,ISTAT)
                                                  
      RETURN
      END
         
      SUBROUTINE UCLGSR(KEY,VAL,ISTAT)
C
C Read in a real from a keyword
C
      CHARACTER*(*) KEY
      REAL VAL
      INTEGER ISTAT
                   
      INTEGER IACT,KUN,KNUL
                           
      CALL STKRDR(KEY,1,1,IACT,VAL,KUN,KNUL,ISTAT)
                                                  
      RETURN
      END
         
      SUBROUTINE UCLGSD(KEY,VAL,ISTAT)
C
C Read in a double from a keyword
C
      CHARACTER*(*) KEY
      DOUBLE PRECISION VAL
      INTEGER ISTAT
                   
      INTEGER IACT,KUN,KNUL
                           
      CALL STKRDD(KEY,1,1,IACT,VAL,KUN,KNUL,ISTAT)
                                                  
      RETURN
      END
         
      SUBROUTINE UCLGSB(KEY,VAL,ISTAT)
C
C Read in a logical from a keyword
C In this case we fudge things as MIDAS doesn't
C support logical keywords. We read a single character
C and check for y/n
C
      CHARACTER*(*) KEY
      LOGICAL VAL
      INTEGER ISTAT
      CHARACTER*1 TEMP
                      
      INTEGER IACT,KUN,KNUL
                           
      CALL STKRDC(KEY,1,1,1,IACT,TEMP,KUN,KNUL,ISTAT)
                                                     
      IF(TEMP.EQ.'Y' .OR. TEMP.EQ.'y') THEN
         VAL=.TRUE.
      ELSE IF (TEMP.EQ.'N' .OR. TEMP.EQ.'n') THEN
         VAL=.FALSE.
      ELSE
         VAL=.FALSE.
         CALL UMSPUT('Value should be Y/N - assuming N',
     :               1,0,ISTAT)
      ENDIF
           
      RETURN
      END
         
      SUBROUTINE UIMOPN(NAME,MODE,ID,ISTAT)
C
C Open an image, assumed to exist and to be opened readonly.
C
C We also assume that the MIDAS BDF is REAL
C
      IMPLICIT NONE
                   
      CHARACTER*(*) NAME
      INTEGER MODE
      INTEGER ID
      INTEGER ISTAT

      INCLUDE 'MID_INCLUDE:ST_DEF.INC/NOLIST'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC/NOLIST'
                                          
                   
C Open the file
      CALL STFOPN(NAME,D_R4_FORMAT,1,F_IMA_TYPE,ID,ISTAT)
                                                         
      RETURN
      END
         
      SUBROUTINE UDMGET(NVALS,TYPE,POINT,ISTAT)
C
C Allocate a dynamic array of 'nvals' elements of type 'type'.
C
C Note that the array allocated by this routine cannot be
C deallocated except by the closing down of the application.
C The F77/VOS routine udmfre is just a dummy.
C
      IMPLICIT NONE
                                          
      INTEGER NVALS,TYPE,POINT,ISTAT
                   
      INCLUDE 'MID_INCLUDE:ST_DEF.INC/NOLIST'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC/NOLIST'
                                    
      IF(TYPE.EQ.6) THEN
         CALL STFXMP(NVALS,D_R4_FORMAT,POINT,ISTAT)
      ELSE IF(TYPE.EQ.7) THEN
         CALL STFXMP(NVALS,D_R8_FORMAT,POINT,ISTAT)
      ELSE IF(TYPE.EQ.4) THEN
         CALL STFXMP(NVALS,D_I4_FORMAT,POINT,ISTAT)
      ELSE
         ISTAT=100
      ENDIF
           
      RETURN
      END
         
      SUBROUTINE UIGS2D(ID,X1,X2,Y1,Y2,DATA,ISTAT)
C
C Read a subset of a double precision 2d array into a given
C area of memory. We assume that the MIDAS BDF is REAL*4 and
C that it has been opened.
C
      IMPLICIT NONE
                   
      INTEGER MEMD(1)
      COMMON /VMR/MEMD
                                          
      INTEGER ID,X1,X2,Y1,Y2
      DOUBLE PRECISION DATA((X2-X1+1)*(Y2-Y1+1))
      INTEGER ISTAT
                   
      INTEGER NVALS,IACT,TP
                      
      INCLUDE 'MID_INCLUDE:ST_DEF.INC/NOLIST'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC/NOLIST'
                           
      NVALS=(X2-X1+1)*(Y2-Y1+1)
                               
C Map the data into a temporary array as REAL*4s
      CALL STFMAP(ID,F_I_MODE,1,NVALS,IACT,TP,ISTAT)
      IF(ISTAT.NE.0) RETURN
                           
C Convert to double precision
      CALL RTODP(MEMD(TP),NVALS,DATA)
                                     
C Unmap the data and free the temporary array
      CALL STFUNM(ID,ISTAT)
                           
      RETURN
      END
         
      SUBROUTINE RTODP(IN,NVALS,OUT)
C
C Convert an array of numbers from REAL*4 to REAL*8
C
      IMPLICIT NONE
                   
      INTEGER NVALS
      REAL IN(NVALS)
      DOUBLE PRECISION OUT(NVALS)
                                 
      INTEGER I
               
      DO I=1,NVALS
         OUT(I)=DBLE(IN(I))
      ENDDO
           
      RETURN
      END
         
      SUBROUTINE UDMFRE(POINT,TYPE,ISTAT)
C
C Free dynamic memory - this routine is a dummy and
C does nothing at all.
C
      INTEGER POINT,TYPE,ISTAT
                              
      RETURN
      END
         
      SUBROUTINE UIMCLO(ID,ISTAT)
C
C Close an image
C
      INTEGER ID,ISTAT
                      
      CALL STFCLO(ID,ISTAT)
                           
      RETURN
      END
         
      SUBROUTINE UIMGID(ID,DATATYPE,NAXIS,DIMEN,ISTAT)
C
C Get basic information about an open image. Note that
C it is assumed that the image is REAL*4 (datatype=6)
C
      IMPLICIT NONE
                   
      INTEGER ID,DATATYPE,NAXIS,DIMEN(7),ISTAT
      INTEGER IACT,DUN,DNUL
                           
      DATATYPE=6
                
      CALL STDRDI(ID,'NAXIS',1,1,IACT,NAXIS,DUN,DNUL,ISTAT)
      CALL STDRDI(ID,'NPIX',1,NAXIS,IACT,DIMEN,DUN,DNUL,ISTAT)
                                                              
      RETURN
      END
         
      SUBROUTINE UIMCRE(NAME,DATATYPE,NAXIS,DIMEN,ID,ISTAT)
C
C Create an image file on disk. It will always be REAL*4 whatever
C the value of 'datatype' which is specified.
C
      IMPLICIT NONE
                   
      CHARACTER*(*) NAME
      INTEGER DATATYPE,NAXIS,DIMEN(NAXIS),ID,ISTAT
      INTEGER SIZE,I
      DOUBLE PRECISION START(7)

      INCLUDE 'MID_INCLUDE:ST_DEF.INC/NOLIST'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC/NOLIST'
                                          
                               
      SIZE=1
      DO I=1,NAXIS
         SIZE=SIZE*DIMEN(I)
      ENDDO
           
      CALL STFCRE(NAME,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     :            SIZE,ID,ISTAT)
                                
C Now write some descriptors
      CALL STDWRI(ID,'NAXIS',NAXIS,1,1,1,ISTAT)
                                               
      CALL STDWRI(ID,'NPIX',DIMEN,1,NAXIS,1,ISTAT)
                                                  
      DO I=1,NAXIS
         START(I)=1.0D0
      ENDDO
           
      CALL STDWRD(ID,'START',START,1,NAXIS,1,ISTAT)
      CALL STDWRD(ID,'STEP',START,1,NAXIS,1,ISTAT)
                                                  
      CALL STDWRC(ID,'IDENT',1,'No IDENT available',1,18,1,ISTAT)
      CALL STDWRC(ID,'CUNIT',1,'No CUNIT available',1,18,1,ISTAT)
      RETURN
      END
         
      SUBROUTINE UIPS2R(ID,X1,X2,Y1,Y2,DATA,ISTAT)
C
C Write out a 2d subset array of values into what is assumed
C to be a 2d REAL*4 image
C
      IMPLICIT NONE
                                          
      INTEGER MEMD(1)
      COMMON /VMR/MEMD
                      
      INTEGER ID,X1,X2,Y1,Y2
      REAL DATA((X2-X1+1)*(Y2-Y1+1))
                                    
      INTEGER IACT,POINT,ISTAT
                   
      INCLUDE 'MID_INCLUDE:ST_DEF.INC/NOLIST'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC/NOLIST'
                              
C First map the output image
      CALL STFMAP(ID,F_O_MODE,1,(X2-X1+1)*(Y2-Y1+1),IACT,
     :            POINT,ISTAT)
      IF(ISTAT.NE.0) RETURN
                           
C Copy the data from one array to the other
      CALL COPY2R(DATA,(X2-X1+1)*(Y2-Y1+1),MEMD(POINT))
                                                       
C Unmap the data
      CALL STFUNM(ID,ISTAT)
                           
      RETURN
      END
         
      SUBROUTINE UIPS2D(ID,X1,X2,Y1,Y2,DATA,ISTAT)
C
C Write out a 2d subset array of values into what is assumed
C to be a 2d REAL*4 image
C
      IMPLICIT NONE
                                          
      INTEGER MEMD(1)
      COMMON /VMR/MEMD
                      
      INTEGER ID,X1,X2,Y1,Y2
      DOUBLE PRECISION DATA((X2-X1+1)*(Y2-Y1+1))
                                                
      INTEGER IACT,POINT,ISTAT
                   
      INCLUDE 'MID_INCLUDE:ST_DEF.INC/NOLIST'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC/NOLIST'
                              
C First map the output image
      CALL STFMAP(ID,F_O_MODE,1,(X2-X1+1)*(Y2-Y1+1),IACT,
     :            POINT,ISTAT)
      IF(ISTAT.NE.0) RETURN
                           
C Convert the data from double precision to single
      CALL DPTOR(DATA,(X2-X1+1)*(Y2-Y1+1),MEMD(POINT))
                                                      
C Unmap the data
      CALL STFUNM(ID,ISTAT)
                           
      RETURN
      END
         
      SUBROUTINE DPTOR(IN,NVALS,OUT)
C
C Convert an array from double precision to single
C
      INTEGER NVALS
      DOUBLE PRECISION IN(NVALS)
      REAL OUT(NVALS)
                     
      INTEGER I
               
      DO I=1,NVALS
         OUT(I)=SNGL(IN(I))
      ENDDO
           
      RETURN
      END
         
      SUBROUTINE COPY2R(IN,NVALS,OUT)
C
C Convert a real array into another
C
      INTEGER NVALS
      REAL IN(NVALS)
      REAL OUT(NVALS)
                     
      INTEGER I
               
      DO I=1,NVALS
         OUT(I)=IN(I)
      ENDDO
           
      RETURN
      END
         
      SUBROUTINE TIMOTP(CLIST,LIST,ISTAT)
C
C Emulate image list reading in a very crude way - no
C wildcard expansion is permitted.
C
      IMPLICIT NONE
                   
      CHARACTER*80 STRING
      INTEGER CURPOS
                    
      COMMON /TIM/STRING,CURPOS
                               
      CHARACTER*(*) CLIST
      INTEGER LIST,ISTAT
                        
      CURPOS=1
      STRING(1:80)=' '
      STRING=CLIST
                  
      RETURN
      END
         
      SUBROUTINE TIMXTP(LIST,VALUE,ISTAT)
C
C Get the next value from the character string list held
C in COMMON
C
      IMPLICIT NONE
                   
      CHARACTER*80 STRING
      INTEGER CURPOS
                    
      COMMON /TIM/STRING,CURPOS
                               
      INTEGER LIST
      CHARACTER*(*) VALUE
      INTEGER ISTAT
      INTEGER I,J,K
      INTEGER USEOF
                   
      PARAMETER (USEOF=-2)
                          
      I=CURPOS
      J=1
         
C If we start with nothing we are finished
      IF(STRING(CURPOS:CURPOS).EQ.' ') THEN
          ISTAT=USEOF
          RETURN
      ENDIF
           
      DO K=1,100
         IF(I.GT.80) GOTO 88
         IF(STRING(I:I).EQ.' ') THEN
            ISTAT=0
            RETURN
         ELSE IF(STRING(I:I).EQ.',') THEN
            CURPOS=CURPOS+1
            ISTAT=0
            RETURN
         ELSE
            VALUE(J:J)=STRING(I:I)
         ENDIF
              
         I=I+1
         J=J+1
         CURPOS=CURPOS+1
      ENDDO

 88   CONTINUE
           
      ISTAT=USEOF
                 
      RETURN
      END
         
      SUBROUTINE TIMCTP(LIST,ISTAT)
C
C Close the image list stuff - this is a dummy
C
      IMPLICIT NONE
      INTEGER LIST,ISTAT
      RETURN
      END

C @(#)fitsele.for	19.1 (ESO-DMD) 02/25/03 13:18:46
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  16:01 - 20 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION
C
C  program FUNCREA.FOR
C
C.PURPOSE
C
C  Execute the commands
C  SELECT/FUNCTION function number[,...]
C
C  SELECT BASIC FUNCTION COMPONENTS
C  THE SELECTED FUNCTIONS ARE USED IN COMPUTE/FIT AND COMPUTE/FUNCTION
C  THE COMPLETE SET IS USED IN FIT/IMAGE OR /TABLE
C
C.KEYWORDS
C
C  SELECT, FIT
C
C.INPUT/OUTPUT
C
C  P1 - P2     contain input parameters
C
C.ALGORITHM
C
C  Use fit interface routines
C
C 000605
C-----------------------------------------------------------
C
      IMPLICIT NONE
C
C ... define variables
C
      INTEGER IFUN(20),ISELE(20),STATUS
      INTEGER I,II,II1,IAV,IP,KUN,KNUL,ISTAT,DUN
      INTEGER MADRID(1),NAMLEN
C
      CHARACTER*80 P1,NAME
      CHARACTER*16 MSG
C
      INCLUDE 'MID_INCLUDE:FITI.INC/NOLIST'
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      INCLUDE 'MID_INCLUDE:FITC.INC/NOLIST'
C 
      COMMON/VMR/MADRID
C 
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      DATA NAMLEN/80/
      DATA ISELE/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0/
      DATA MSG/'ERR:FUNCREAxxxx'/
C
C ... get into MIDAS
C
      CALL STSPRO('FITSELE')
      CALL FITBL
C
C ... read parameters
C
      CALL STKRDC('P1',1,1,NAMLEN,IAV,P1,KUN,KNUL,ISTAT)
      CALL STKRDI('INPUTI',1,16,IAV,IFUN,KUN,KNUL,ISTAT)
      DO 10, I=1,16
          II = IFUN(I)
          IF (II.NE.0) THEN
              IF (II.GT.0 .AND. II.LE.16) THEN
                  ISELE(II) = 1
              ELSE
                  CALL STTPUT(' Error in function number... ',ISTAT)
                  GO TO 30
              END IF
          ELSE
              GO TO 20
          END IF
   10 CONTINUE
C
C ... write selection
C
   20 II1    = INDEX(P1,'.')
      IF (II1.NE.0) THEN
          NAME   = P1
      ELSE
          II     = INDEX(P1,' ') - 1
          NAME   = P1(1:II)//'.fit'
      END IF
      CALL STFOPN(NAME,D_R4_FORMAT,0,F_FIT_TYPE,IP,ISTAT)
      CALL STDWRI(IP,'FITSELE',ISELE,1,20,DUN,ISTAT)
C
C ... end
C
   30 IF (ISTAT.NE.0) THEN
          WRITE (MSG(13:16),9000) ISTAT
          CALL TDERRR(ISTAT,MSG,STATUS)
      END IF
      CALL STSEPI
 9000 FORMAT (I4)
      END

C @(#)neczebord.for	19.1 (ES0-DMD) 02/25/03 14:20:26
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1991 Special Astrophisical Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, 26 Aug 1991
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: A.Yu.Kniazev, V.Shergin
C
C.IDENTIFICATION
C                  zeb_ord.for
C
C.KEYWORDS
C
C  echelle, order searching, maxima following
C
C.PURPOSE
C
C Search for echelle(ZEBRA) orders on any echelle image.
C Output is a table with the following columns :
C
C COLUMN NO.  LABEL   UNIT      DESCRIPTION
C    1        :ORDER  -         ORDER NUMBER
C    2        :X      PIXEL     SAMPLE NUMBER
C    3        :Y      PIXEL     1. MOMENT AS SUM(F*Y)/SUM(F)
C    4        :YBKG   PIXEL     POSITION OF THE BACKGROUND
C    5        :BKG    DN        BACKGROUND LEVEL
C
C.ALGORITHM
C  Maxima following algorithm.
C
C.INPUT/OUTPUT
C
C  COMMAND :
C  SEARCH/ORDER INPUT W OUTPUT
C  input keywords are
C  ECHC(1:8)   INPUT   - IMAGE NAME
C  ECHC(21:28)  OUTPUT  - TABLE NAME
C         W - PARAMETER WHERE :
C  ECHR(1)              average widht of orders
C
C  OUTPUT PARAMETRES:
C
C-----------------------------------------------------------------
      PROGRAM ZEBORD

      IMPLICIT NONE
      INTEGER MAXORD
      PARAMETER (MAXORD = 100)
      INTEGER MADRID
      INTEGER ACTVAL,I,ISTAT,IXSTR,COLUMN(3)
      INTEGER NACOL,NAXIS,NDIM,NORDER
C     INTEGER NPOINT
      INTEGER IVEC1, IVEC2, IVEC3, IVEC4, ITBL, NTBL
      INTEGER NTOT,PNTRA,STATUS,WINDOW,IACOL
      INTEGER NPIX(3),ICOL(7), KUN, KNUL, IMNO, IJ
      INTEGER UPPER(MAXORD),LOWER(MAXORD)
      REAL    FORD(MAXORD), RPAR(2), CORD(MAXORD)
      REAL    INCLIN
      INTEGER ISTEP, IS, ISTART, ISTOP, IDIR, TID
      INTEGER UP0(MAXORD),LOW0(MAXORD)
      REAL    CORD0(MAXORD)
      DOUBLE PRECISION START(3),STEP(3)
      DOUBLE PRECISION ST
      CHARACTER*80 CA
      CHARACTER*60 TABLE
      CHARACTER*72 IDENA
      CHARACTER*80 LINE
      CHARACTER*64 CUNITA
      CHARACTER*16 LABCOL(5),UNIT(5)
      CHARACTER*6  FORM(5)
      CHARACTER*8  FRMIN
      CHARACTER*1  PLOT
      LOGICAL      DBGPLT
C                   WIDTH  - HALF 0F WIDTH FOR AVERAGE
      INTEGER WIDTH, NTRACE, NTR, KX, KY
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      DATA LABCOL(1)/'ORDER'/,FORM(1)/'I6'/
      DATA LABCOL(2)/'X'/,FORM(2)/'F7.1'/
      DATA LABCOL(3)/'Y'/,FORM(3)/'F7.1'/
      DATA LABCOL(4)/'YBKG'/,FORM(4)/'F7.1'/
      DATA LABCOL(5)/'BKG'/,FORM(5)/'E12.3'/
      DATA UNIT(1)/'UNITLESS'/
      DATA UNIT(2)/'PIXEL'/
      DATA UNIT(3)/'PIXEL'/
      DATA UNIT(4)/'PIXEL'/
      DATA UNIT(5)/'DN'/
      DATA NACOL/5/
      DATA PLOT/'N'/

      CA = 'COUNTS'
      ST = 1.D0
      NDIM   = 3
C
C ... initialize system and read parameters
C
      CALL STSPRO('ZEBORD')
      CALL STKRDC('IN_B',1,1,60,ACTVAL,TABLE,KUN,KNUL,STATUS)
      CALL STKRDC('IN_A',1,1,60,ACTVAL,FRMIN,KUN,KNUL,STATUS)
      CALL STKRDC('INPUTC',1,1,1,ACTVAL,PLOT,KUN,KNUL,STATUS)
      CALL STKRDI('INPUTI',1,3,ACTVAL,COLUMN,KUN,KNUL,STATUS)
      CALL STKRDR('INPUTR',1,2,ACTVAL,RPAR,KUN,KNUL,STATUS)
      IXSTR   = COLUMN(1)
      WIDTH   = COLUMN(2)
      NTRACE  = COLUMN(3)
      INCLIN  = RPAR(1)
      WINDOW  = RPAR(2) + 0.5
      DBGPLT  = (PLOT.EQ.'Y') .OR. (PLOT.EQ.'y')
C
      CALL STTPUT(' Echelle(ZEBRA) definition',ISTAT)
      CALL STTPUT(' ------------------',ISTAT)
      CALL STTPUT(' InputImage  : '//FRMIN,ISTAT)
      CALL STTPUT(' OutputTable : '//TABLE,ISTAT)
      CALL STTPUT(' Parameters  ',ISTAT)
      WRITE (LINE,9040) IXSTR
      CALL STTPUT(LINE ,ISTAT)
      WRITE (LINE,9050) WIDTH
      CALL STTPUT(LINE ,ISTAT)
      WRITE (LINE,9020) WINDOW
      CALL STTPUT(LINE,ISTAT)
      WRITE (LINE,9030) INCLIN
      CALL STTPUT(LINE,ISTAT)
      WRITE (LINE,9010) NTRACE
      CALL STTPUT(LINE,ISTAT)
      CALL STTPUT(' PLOT FLAG  : '//PLOT,ISTAT)
 9010 FORMAT ('Follow_Steps_Number: ',I6)
 9020 FORMAT ('Order_Width: ',I6)
 9030 FORMAT ('Order_Inclination: ',F8.4)
 9040 FORMAT ('Center_Column: ',I6)
 9050 FORMAT ('Averagin_Width: ',I6)
C
C ... read frame
C
      CALL STIGET(FRMIN,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     .NDIM,NAXIS,NPIX,START,STEP,IDENA,CUNITA,PNTRA,IMNO,STATUS)
C
C ... generate working space
C
      CALL STIPUT('ZEB_ORD.WRK',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,1,
     .            NPIX(2)*4 + MAXORD*NTRACE*3,
     .            ST,ST,CA,CA,IVEC1,IJ,STATUS)
      IVEC2 = IVEC1 + NPIX(2)
      IVEC3 = IVEC2 + NPIX(2)
      IVEC4 = IVEC3 + NPIX(2)
      ITBL  = IVEC4 + NPIX(2)
C
C ... extract and plot "averaging" column
      CALL EXTRAV(MADRID(PNTRA),NPIX(1),NPIX(2),IXSTR,WIDTH,INCLIN,
     .           MADRID(IVEC1))
      IF ( DBGPLT ) THEN
        CALL PLTARR(MADRID(IVEC1),NPIX(2),100,NPIX(2)-150,FRMIN,0)
      ENDIF
C
C ... find order positions in the middle of the image by BGD-thresholding
C
      CALL ORDTHR(MADRID(IVEC1),MADRID(IVEC2),MADRID(IVEC3),
     .           MADRID(IVEC4),NPIX(2),WINDOW,UPPER,LOWER,FORD,
     .           CORD,NORDER,FRMIN,DBGPLT)
C
CD... simulate order miss ( for ORDCHK() debuging )
CD      NORDER = NORDER - 1
CD      DO I = 2, NORDER
CD          UPPER(I) = UPPER(I+1)
CD          LOWER(I) = LOWER(I+1)
CD          CORD(I)  = CORD(I+1)
CD      ENDDO
C
C ... try to find missing orders
      CALL ORDCHK(NORDER,UPPER,LOWER,CORD,MADRID(ITBL),MADRID(IVEC3)
     .           ,NPIX(2),FRMIN,DBGPLT)
C
C ... allocate table
C
      NTOT   = (NORDER+1)*NTRACE
      IACOL  = 12
      CALL TBTINI(TABLE,F_TRANS,F_O_MODE,IACOL,NTOT,TID,STATUS)
      DO 10 I = 1,NACOL
          CALL TBCINI(TID,D_R4_FORMAT,1,FORM(I),
     .    UNIT(I),LABCOL(I),ICOL(I),STATUS)
 10   CONTINUE
C
C ... now we need to follow orders
      ISTEP = NPIX(1)/NTRACE
      NTBL = 1
      NTR  = 0
      KY   = MAX(0, MIN(3, (NORDER+3)/5))
      DO IDIR = -1,1,2
        DO I = 1,NORDER
            UP0(I) = UPPER(I)
            LOW0(I) = LOWER(I)
            CORD0(I) = CORD(I)
        ENDDO
        IF (IDIR.GT.0) THEN
            CALL REVTBL(MADRID(ITBL),NTBL)
            ISTART = ((IXSTR/ISTEP) + 1) * ISTEP + 1
            ISTOP  = NPIX(1) - ISTEP
        ELSE
            ISTART = (IXSTR/ISTEP) * ISTEP + 1
            ISTOP  = ISTEP + 1
        ENDIF
        IS = ISTART - IXSTR
        DO I = ISTART, ISTOP, ISTEP*IDIR
            WRITE(*,*) '========================================='
            WRITE(*,*) 'AvrColunm=',I
            NTR = NTR + 1
            KX = MAX(0, MIN(2, NTBL/8/(KY+1)-1 ))
C
C23456789012345678901234567890123456789012345678901234567890123456789012345
C
            CALL ORDFIT(MADRID(ITBL),NTBL,KX,KY,I,UP0,LOW0,CORD0,NORDER
     .          ,INCLIN,IS,MADRID(IVEC3),NPIX(1),NPIX(2),FRMIN,.FALSE.)
            IS = ISTEP*IDIR
            CALL EXTRAV(MADRID(PNTRA),NPIX(1),NPIX(2),I,ISTEP,INCLIN,
     .                  MADRID(IVEC1))
CD            READ(*,*) III
            IF ( DBGPLT ) THEN
             CALL PLTARR(MADRID(IVEC1),NPIX(2),100,NPIX(2)-150,FRMIN,0)
            ENDIF
            CALL ORDCOR(MADRID(IVEC1),MADRID(IVEC2),MADRID(IVEC3),
     .                 MADRID(IVEC4),NPIX(2),WINDOW,UP0,LOW0,FORD,
     .                 CORD0,NORDER,FRMIN,DBGPLT)
            CALL ORDTBL(I,FORD,CORD0,NORDER,MADRID(ITBL),NTBL)
        ENDDO
      ENDDO
      CALL WRTTBL(TID,NORDER,MADRID(ITBL),NTBL,NPIX(1))
C
C ... update number of elements
C      NTOT   = NPOINT
      CALL STKWRI('ECHORD',NORDER,1,1,KUN,KNUL,STATUS)
      IDENA = 'ORDER POSITION'
C      CALL SXDPUT(TABLEFULL,'IDENT','C',IDENA,1,72,STATUS)
C      CALL DSCUPD(TABLEFULL,TABLEFULL,' ',STATUS)
CD    CALL TBCSRT(TID,1,1,1,STATUS)
      CALL TBSINI(TID,STATUS)
      CALL TBTCLO(TID,STATUS)
C
C ... that's all ...
C ... free data
   20 CALL STSEPI

      END

C*****************************************************************
      SUBROUTINE ORDTHR(VEC1,VEC2,VEC3,IVEC4,N2,WINDOW,
     .                  UP,LOW,FORD,CORD,NORD,FRMIN,DBGPLT)
C
C       Search for orders in the image trace (BGD-threshholding)
C
      INTEGER MAXORD
      REAL    SIGMA3
      PARAMETER (MAXORD = 100)
      INTEGER N2
      REAL    VEC1(N2)                   ! input trace
      REAL    VEC2(N2),VEC3(N2)          ! working space
      INTEGER IVEC4(N2)                  ! working space
      INTEGER WINDOW                     ! order width (IN/OUT!)
      INTEGER UP(MAXORD)                 ! orders beg. (OUT)
      INTEGER LOW(MAXORD)                ! orders end  (OUT)
      REAL    FORD(MAXORD)               ! avr.flux    (OUT)
      REAL    CORD(MAXORD)               ! ord. center (OUT)
      INTEGER NORD                       ! # of orders (OUT)
      CHARACTER*(*) FRMIN                ! label
      LOGICAL DBGPLT                     ! debug plotting flag
C
      INTEGER I, WND, ISTAT, IB, IE, K, L
C      REAL    AM, XC, HWHI
      REAL    S, S0, S1
      REAL    NOISE0, NOISE1, NOISE2
      REAL    MAXR, MAXL, MINC, Q
      CHARACTER*80 LINE
C
CD... culculate  "autocorrelation"
CD    CALL CONVL(VEC1, 1, N2, 1, 1, VEC2, WINDOW*5)
CD    K = N2/2-WINDOW*5
CD    L = WINDOW*10
CD    CALL PLTARR(VEC2, N2, K, K+L, FRMIN, 1)
C
CD... determine order width
CD    WINDOW = LWORD(VEC2, N2, N2/2, AM, XC, HWHI)
CD    WRITE (LINE,9000) WINDOW*2
CD    CALL STTPUT(LINE,ISTAT)
C
C ... estimate noise level
      NOISE0 = SIGMA3(VEC1, N2)
C
C ... extract "background" (variable threshold level)
      WND = WINDOW * 0.75 + 0.5
      I = 0
      CALL BGRND(VEC1, N2, VEC2, VEC3, WND, NOISE0, 4, I)
CD    CALL PLTARR(VEC3, N2, 100, N2-150, FRMIN, 1)
      NOISE1 = SIGMA3(VEC2, N2)
      CALL BGRND(VEC1, N2, VEC2, VEC3, WND, NOISE1, 4, I)
CD    CALL PLTARR(VEC3, N2, 100, N2-150, FRMIN, 1)
      NOISE2 = SIGMA3(VEC2, N2)
CD    CALL BGRND(VEC1, N2, VEC2, VEC3, WND, NOISE2, 4, I)
      IF ( DBGPLT ) THEN
        CALL PLTARR(VEC3, N2, 100, N2-150, FRMIN, 1)
CD        READ(*,*) III
      END IF
      WRITE (LINE,9010)  NOISE0, NOISE1, NOISE2
      CALL STTPUT(LINE,ISTAT)
C
C ... use threshold level to form orders mask
      IVEC4(1) = 0
      IVEC4(N2) = 0
      DO I = 2, N2-1
        VEC2(I) = VEC1(I)-VEC2(I)
        IF ( VEC1(I) .GT. VEC3(I)+NOISE1) THEN
            IVEC4(I) = 1
        ELSE
            IVEC4(I) = 0
        ENDIF
        VEC3(I) = IVEC4(I)
      ENDDO
      IF ( DBGPLT ) THEN
        CALL PLTARR(VEC3, N2, 100, N2-150, FRMIN, 1)
CD        READ(*,*) III
      ENDIF
C
C ... try to find orders
      WRITE (LINE, *) '_No._Begin__End__AvrFlux_Center_______'
      CALL STTPUT(LINE,ISTAT)
      NORD = 0
      DO I = 1, N2-1
        VEC3(I) = 0.
        IF (IVEC4(I).EQ.0 .AND. IVEC4(I+1).NE.0) THEN
            IB = I+1
            S  = 0.
            S0 = 0.
            S1 = 0.
        ELSEIF (IVEC4(I).NE.0 .AND. IVEC4(I+1).NE.0) THEN
            S  = S  + VEC2(I)
            S0 = S0 + VEC1(I)
            S1 = S1 + VEC1(I)*I
        ELSEIF (IVEC4(I).NE.0 .AND. IVEC4(I+1).EQ.0) THEN
            IE = I
            IF (IE.GT.IB) THEN
                S1 = S1/S0
                S0 = S0/(IE-IB+1)
            ENDIF
            IF (IE-IB+1 .GE. WINDOW/2) THEN
                Q = (IE-IB)/3.0             !    |  Q  |     |  Q  |
                K = IB+Q+0.5                !    |     |     |     |
                L = IE-Q+0.5                ! ..IB.....K.....L.....IE..
                CALL MINMAX(VEC2(IB), K-IB,  Q, MAXL)
                CALL MINMAX(VEC2(K),  L-K+1, MINC, Q)
                CALL MINMAX(VEC2(L+1),IE-L,  Q, MAXR)
                IF ((IE-IB+1.0 .GE. WINDOW*1.4) .AND.
     .              (MAXR.GT.MINC .AND. MAXL.GT.MINC)) THEN
                    IVEC4((IE+IB)/2) = 0
                    I = IB-2
CD                  WRITE (*,*) IB,K,L,IE
CD                  WRITE (*,*) MAXL,MINC,MAXR
                    WRITE (LINE,9040) IB, IE, S0, S1
                    CALL STTPUT(LINE,ISTAT)
C
C23456789012345678901234567890123456789012345678901234567890123456789012345
C
                    WRITE (LINE, *) 
     .              '-- Warning! Problems with order detection! -- '
                    CALL STTPUT(LINE,ISTAT)
                ELSEIF (S .GT. WINDOW*NOISE1*2.) THEN
                    IF (NORD.LT.MAXORD) THEN
                        NORD = NORD + 1
                    ELSE
                        GO TO 100
                    ENDIF
                    UP(NORD) = IB
                    LOW(NORD) = IE
                    FORD(NORD) = S0
                    CORD(NORD) = S1
                    WRITE (LINE,9020) NORD, IB, IE, S0, S1
                    CALL STTPUT(LINE,ISTAT)
                    VEC3( INT(S1+0.5) ) = FORD(NORD)
                ELSE
                    GO TO 100
                ENDIF
            ELSE
100             CONTINUE
                WRITE (*,9030) IB, IE, S0, S1
            ENDIF
        ENDIF
      ENDDO
      WRITE(*,*) 'NumOrders=',NORD
CD    READ(*,*) I
      IF ( DBGPLT ) THEN
        CALL PLTARR(VEC1, N2, 100, N2-150, FRMIN, 0)
CD        READ(*,*) III
        CALL PLTARR(VEC3, N2, 100, N2-150, FRMIN, 1)
CD        READ(*,*) III
      ENDIF
C
      RETURN
 9000 FORMAT ('OrderWidth: ',I6)
 9010 FORMAT ('NoiseLevels: ', 3F8.3)
 9020 FORMAT (I4,2I6,2F8.1)
 9030 FORMAT (' ---',2I6,2F8.1)
 9040 FORMAT (' ***',2I6,2F8.1)
      END

C*****************************************************************
      SUBROUTINE ORDCHK(NORD,UP,LOW,CORD,TBL,VEC,N2,FRMIN,DBGPLT)
C
C       Check orders positions (to find missing orders)
C
      INTEGER MAXORD
      REAL    EVAPOL
      PARAMETER (MAXORD = 100)
      INTEGER NORD                       ! # of orders (IN/OUT)
      INTEGER UP(MAXORD)                 ! orders beg. (IN/OUT)
      INTEGER LOW(MAXORD)                ! orders end  (IN/OUT)
      REAL    CORD(MAXORD)               ! ord. center (IN/OUT)
      REAL    TBL(3,MAXORD)              ! wrk.space
      INTEGER N2
      REAL    VEC(N2)                    ! wrk.space
      CHARACTER*(*) FRMIN                ! label
      LOGICAL DBGPLT                     ! debug plotting flag
C
      INTEGER I, ISTAT, J, K, L, LM, NEW
      REAL    COEF(30), ERR, ERR0, ERR1, ERR2, CL, C1, C2
      CHARACTER*80 LINE
      LOGICAL OK
C
C ... perform polynomial fitting of order positions
      OK = .FALSE.
  10  DO I = 1,NORD
        TBL(1,I) = CORD(I)
        TBL(2,I) = I
        TBL(3,I) = 0.
      ENDDO
C     K   = MAX(0, MIN(3, (NORDER+3)/5))
      IF (NORD .LE. 4) THEN
        RETURN
      ELSE IF (NORD .LE. 6) THEN
        K = 1
      ELSE IF (NORD .LE. 11) THEN
        K = 2
      ELSE
        K = 3
      ENDIF
      CALL POLFIT(TBL, NORD, K, 0, COEF, ERR)
      ERR0 = SQRT(ERR**2/NORD)
C
      IF ( OK ) GO TO 100
C
C ... for debuging plot:
CD    WRITE (*, 9000) K, 0
CD    WRITE (*, 9010) (COEF(I),I=1,K+1)
CD    WRITE (*, 9020) ERR0
CD    READ (*,*) I
      IF ( DBGPLT ) THEN
        J = N2/NORD
        DO I = 1,N2
          VEC(I) = CORD( MIN(NORD, (I - 1)/J + 1) )
        ENDDO
        CALL PLTARR(VEC, N2, 1, N2, FRMIN, 0)
        DO I = 1,N2
          VEC(I) = EVAPOL(COEF, K, 0, FLOAT(I-1)/J+0.5, 0.)
        ENDDO
        CALL PLTARR(VEC, N2, 1, N2, FRMIN, 1)
      ENDIF
C
C ... try to insert new orders between every pair of old orders
      NEW = 0
      DO L = 2,NORD
C ...   at first - one order
        DO I = 1,NORD+1
            IF (I .LT. L) THEN
                TBL(1,I) = CORD(I)
            ELSE IF (I .GT. L) THEN
                TBL(1,I) = CORD(I-1)
            END IF
            TBL(2,I) = I
            TBL(3,I) = 0.
        ENDDO
        TBL(1,L) = (CORD(L) + CORD(L-1)) / 2.0
        CALL POLFIT(TBL, NORD+1, K, 0, COEF, ERR)
        ERR1 = SQRT(ERR**2/(NORD+1))
        CL = EVAPOL(COEF, K, 0, FLOAT(L), 0.)
C ...   then - two (if posible)
        IF (NORD .GE. 7) THEN
            DO I = 1,NORD+2
                IF (I .LT. L) THEN
                    TBL(1,I) = CORD(I)
                ELSE IF (I .GT. L+1) THEN
                    TBL(1,I) = CORD(I-2)
                END IF
                TBL(2,I) = I
                TBL(3,I) = 0.
            ENDDO
            TBL(1,L) = CORD(L-1) + (CORD(L) - CORD(L-1)) * 0.333
            TBL(1,L+1) = CORD(L-1) + (CORD(L) - CORD(L-1)) * 0.667
            CALL POLFIT(TBL, NORD+2, K, 0, COEF, ERR)
            ERR2 = SQRT(ERR**2/(NORD+2))
        ELSE
            ERR2 = ERR1*2.
        END IF
CD      WRITE (*, 9030) L-1, L, ERR1, ERR2
C
        IF (ERR1.LT.ERR0 .OR. ERR2.LT.ERR0) THEN
            IF (ERR1 .LE. ERR2) THEN
                ERR0 = ERR1
                NEW = 1
                C1 = CL
            ELSE
                ERR0 = ERR2
                NEW = 2
                C1 = EVAPOL(COEF, K, 0, FLOAT(L), 0.)
                C2 = EVAPOL(COEF, K, 0, FLOAT(L+1), 0.)
            END IF
            LM = L
        END IF
      ENDDO
C
C ... if there are new orders, fix them
      IF (NEW .GT. 0) THEN
        WRITE (LINE, 9040) NEW, LM-1, LM
        CALL STTPUT(LINE,ISTAT)
        DO I = NORD+NEW, LM+NEW, -1
            CORD(I) = CORD(I-NEW)
            UP(I)   = UP(I-NEW)
            LOW(I)  = LOW(I-NEW)
        ENDDO
        CORD(LM) = C1
        L = (LOW(LM-1) - UP(LM-1) + LOW(LM) - UP(LM))/2 + 1
        LOW(LM) = MIN(INT(CORD(LM) + L/2.0 + 0.5), UP(LM)-1)
        UP(LM)  = MAX(INT(CORD(LM) - L/2.0 + 0.5), LOW(LM-1)+1)
        IF (NEW .GT. 1) THEN
            CORD(LM+1) = C2
            UP(LM+1)  = MAX(INT(CORD(LM+1) - L/2.0 + 0.5), LOW(LM)+1)
            LOW(LM+1) = MIN(INT(CORD(LM+1) + L/2.0 + 0.5), UP(LM+2)-1)
        END IF
        NORD = NORD+NEW
      ELSE
        OK = .TRUE.
      END IF
      GO TO 10
C
100   DO I = 1, NORD
        CORD(I) = EVAPOL(COEF, K, 0, FLOAT(I), 0.)
      ENDDO
C
      RETURN
CD9000 FORMAT ('Degrees: ',2I2)
CD9010 FORMAT ('Coef-s: ',3F8.3)
CD9020 FORMAT ('Error: ',F7.3)
CD9030 FORMAT ('Ord:',I2,'-',I2,' Err: ',2F6.3)
 9040 FORMAT ('-- Attention! ',I1,'-ord.miss.in:',I2,'-',I2)
      END

C*****************************************************************
      SUBROUTINE ORDCOR(VEC1,VEC2,VEC3,VEC4,N2,WINDOW,
     .                  UP,LOW,FORD,CORD,NORD,FRMIN,DBGPLT)
C
C       Correct orders positions (by correlation with model contour)
C
      INTEGER MXBEAM, MAXORD
      REAL    SIGMA3
      PARAMETER (MAXORD = 100)
      PARAMETER (MXBEAM = 100)
      INTEGER N2
      REAL    VEC1(N2)                   ! input trace
      REAL    VEC2(N2),VEC3(N2),VEC4(N2) ! working space
      INTEGER WINDOW                     ! order width (IN)
      INTEGER UP(MAXORD)                 ! orders beg. (IN/OUT)
      INTEGER LOW(MAXORD)                ! orders end  (IN/OUT)
      REAL    FORD(MAXORD)               ! avr.flux    (OUT)
      REAL    CORD(MAXORD)               ! ord. center (IN/OUT)
      INTEGER NORD                       ! # of orders (IN)
      CHARACTER*(*) FRMIN                ! label
      LOGICAL DBGPLT                     ! debug plotting flag
C
      INTEGER I, WND, J, NBEAM, K, KMAX, IMAX, L
      INTEGER IB, IE, PIX(2)
      REAL    S, SS, SX, SB, SMAX, CUTS(2)
      REAL    NOISE0, NOISE1, NOISE2
      REAL    BEAM(MXBEAM)
C
      DATA BEAM /MXBEAM*0./
C
C ... estimate noise level
      NOISE0 = SIGMA3(VEC1, N2)
C
C ... extract and subtract "background"
      WND = WINDOW * 0.75 + 0.5
      I = 0
      CALL BGRND(VEC1, N2, VEC2, VEC3, WND, NOISE0, 4, I)
      NOISE1 = SIGMA3(VEC2, N2)
      CALL BGRND(VEC1, N2, VEC2, VEC3, WND, NOISE1, 4, I)
      NOISE2 = SIGMA3(VEC2, N2)
C     CALL BGRND(VEC1, N2, VEC2, VEC3, WND, NOISE2, 4, I)
      IF ( DBGPLT ) THEN
        CALL PLTARR(VEC3, N2, 100, N2-150, FRMIN, 1)
      ENDIF
CD    WRITE (LINE,9010)  NOISE0, NOISE1, NOISE2
CD    CALL STTPUT(LINE,ISTAT)
      DO I = 1, N2
        VEC2(I) = VEC1(I)-VEC3(I)
      ENDDO
C
C ... construct sample order profile (we use gaussian)
      NBEAM =  MIN(WINDOW,MXBEAM)
      BEAM(1) = 1.0
      SB = 1.0
      DO I = 2, NBEAM
        BEAM(I) = EXP(-FLOAT(I-1)**2 / (WINDOW/2.0)**2)
        SB = SB + 2*BEAM(I)**2
      ENDDO
CD    WRITE(*,9030) (BEAM(I),I=1,NBEAM)
C
C ... for debuging plot:
      IF ( DBGPLT ) THEN
        DO I = 1,N2
            VEC4(I) = 0.
        ENDDO
      END IF
C
C ... for every known order...
      DO I = 1, NORD
C ...   search for max.correlation with model order within UP and LOW
        SMAX = -1.
        KMAX = CORD(I)
C ...   try to modify UP and LOW edges if need
        IF (I .GT. 1) THEN
            IB = LOW(I-1) + 1
        ELSE
            IB = 2
        ENDIF
        K = UP(I)
        DO J = UP(I), IB, -1
            IF (VEC2(J-1) .GE. VEC2(J)) GO TO 100
            K = J-1
        ENDDO
100     IB = K
        IF (I .LT. NORD) THEN
            IE = UP(I+1) - 1
        ELSE
            IE = N2-1
        ENDIF
        K = LOW(I)
        DO J = LOW(I), IE
            IF (VEC2(J+1) .GE. VEC2(J)) GO TO 200
            K = J+1
        ENDDO
200     IE = K
        SS = 0.
        SX = 0.
        DO K = IB, IE
C ...       calc.next val. of conv-n with BEAM
            S = VEC2(K)*BEAM(1)
            DO J = 2, NBEAM
                L = K - (J-1)
                IF (L .GE. IB) THEN
                    S = S + VEC2(L)*BEAM(J)
                ELSE
                    S = S + VEC2(IB)*BEAM(IB-L+1)*BEAM(J)
                ENDIF
                L = K + (J-1)
                IF (L .LE. IE) THEN
                    S = S + VEC2(L)*BEAM(J)
                ELSE
                    S = S + VEC2(IE)*BEAM(L-IE+1)*BEAM(J)
                ENDIF
            ENDDO
            S = S/SB
            SS = SS + S
            SX = SX + K*S
            IF (S .GT. SMAX) THEN
                SMAX = S
                KMAX = K
            ENDIF
            IF ( DBGPLT ) VEC4(K) = S
        ENDDO
C ... check is it significant or not?
        CALL MNMX(VEC2(IB), IE-IB+1, CUTS, PIX)
        IMAX = PIX(2)-1 + IB
CD      WRITE (*,*) IB,IE,IMAX,KMAX,SMAX
        IF ( (SMAX .GT. 5.*NOISE1) .AND.
     .       (IMAX .GT. IB) .AND. (IMAX .LT. IE) .AND.
     .       (KMAX .GT. IB) .AND. (KMAX .LT. IE) )  THEN
            CORD(I) = SX / SS
            FORD(I) = SMAX
        ELSE
            FORD(I) = -1.
        ENDIF
      ENDDO
      IF ( DBGPLT ) THEN
        CALL PLTARR(VEC4, N2, 100, N2-150, FRMIN, 1)
      ENDIF
C
C ... for debuging plot
      IF ( DBGPLT ) THEN
        DO I = 1,N2
            VEC4(I) = 0.
        ENDDO
        DO I = 1, NORD
            IF (FORD(I) .GT. 0.) THEN
                VEC4( INT(CORD(I)+0.5) ) = FORD(I)
            ENDIF
        ENDDO
        CALL PLTARR(VEC4, N2, 100, N2-150, FRMIN, 1)
      ENDIF
C
C ... as the last step correct edges location
CD    WRITE (LINE, *) '_No._Begin__End__AvrFlux_Center_______'
CD    CALL STTPUT(LINE,ISTAT)
      DO I = 1, NORD
        IF (I .GT. 1) THEN
            J = (CORD(I-1) + CORD(I))/2.0 + 1.5
        ELSE
            J = 2
        ENDIF
        IF (I .LT. NORD) THEN
            K = (CORD(I+1) + CORD(I))/2.0 + 0.5
        ELSE
            K = N2-1
        ENDIF
        L = LOW(I) - UP(I) + 1
        UP(I)  = MAX(INT(CORD(I)+0.5) - L/2, J)
        LOW(I) = MIN(INT(CORD(I)+0.5) + (L-1)/2, K)
CD      WRITE (LINE,9020) I, UP(I), LOW(I), FORD(I), CORD(I)
CD      CALL STTPUT(LINE,ISTAT)
      ENDDO
C
      RETURN
CD9010 FORMAT ('NoiseLevels: ', 3F8.3)
CD9020 FORMAT (I4,2I6,2F8.1)
CD9030 FORMAT (3F8.3)
      END

C*****************************************************************
      SUBROUTINE ORDFIT(TBL,NTBL,KX,KY,XPOS,UP,LOW,CORD,NORD,INCL
     .                 ,STEP,VEC,N1,N2,FRMIN,DBGPLT)
C
C       2D-poly.fit of current table
C       eval. edges&centers for new X-position
C
      INTEGER MAXORD
      REAL    EVAPOL
      PARAMETER (MAXORD = 100)
      INTEGER NTBL                       ! # of rows in table (IN)
      REAL    TBL(3,NTBL)                ! "in core" table (IN)
      INTEGER KX, KY                     ! polinomial degrees (IN)
      INTEGER XPOS                       ! X-posit.    (IN)
      INTEGER UP(MAXORD)                 ! orders beg. (IN/OUT)
      INTEGER LOW(MAXORD)                ! orders end  (IN/OUT)
      REAL    CORD(MAXORD)               ! ord.cent.   (IN/OUT)
      INTEGER NORD                       ! # of orders (IN)
      REAL    INCL                       ! inclination (IN/OUT)
      INTEGER STEP                       ! step of XPOS(IN)
      INTEGER N1, N2
      REAL    VEC(N1)                    ! wrk.space
      CHARACTER*(*) FRMIN                ! label
      LOGICAL DBGPLT                     ! debug plotting flag
C
      REAL    COEF(30), ERR, SI
      INTEGER OVR, I, J
C
      IF (KX.GT.0 .AND. KY.GT.0) THEN
        CALL POLFIT(TBL, NTBL, KX, KY, COEF, ERR)
        ERR = SQRT(ERR**2/NTBL)
        WRITE(*,*) 'TblLength:',NTBL
        WRITE(*,*) 'FitDegrees:',KX,KY
        WRITE(*,*) 'FitError:',ERR
        IF ( DBGPLT ) THEN
            OVR = 0
            VEC(1)    = N2-150.
            VEC(N1)   = N2-150.
            VEC(2)    = 100.
            VEC(N1-1) = 100.
        ENDIF
        SI = 0.
        DO I = 1,NORD
            CORD(I) = EVAPOL(COEF, KX, KY, FLOAT(XPOS), FLOAT(I))
            UP(I)   = EVAPOL(COEF, KX, KY, FLOAT(XPOS), I-0.4) + 0.5
            LOW(I)  = EVAPOL(COEF, KX, KY, FLOAT(XPOS), I+0.4) + 0.5
            SI = SI + (EVAPOL(COEF, KX, KY, XPOS+1.0, FLOAT(I)) -
     .                 EVAPOL(COEF, KX, KY, XPOS-1.0, FLOAT(I))) / 2.0
            IF ( DBGPLT ) THEN
                DO J = 2, N1-2
                    VEC(J) = EVAPOL(COEF, KX, KY, FLOAT(J), FLOAT(I))
                ENDDO
                CALL PLTARR(VEC, N1, 1, N1, FRMIN, OVR)
                OVR = 1
            END IF
        ENDDO
        INCL = SI / NORD
        WRITE (*,*) 'NewInclination:',INCL
      ELSE
        WRITE (*,*) 'OldInclination:',INCL
        SI = INCL * STEP
        DO I = 1,NORD
          CORD(I) = CORD(I) + SI
          UP(I)   = UP(I)   + SI + 0.5
          LOW(I)  = LOW(I)  + SI + 0.5
        ENDDO
      END IF
C
      RETURN
      END

C*****************************************************************
      SUBROUTINE ORDTBL(XPOS,FORD,CORD,NORD,TBL,NTBL)
C
C       Put next portion of rows to TBL-array
C
      INTEGER MAXORD
      PARAMETER (MAXORD = 100)
      INTEGER XPOS                       ! X-posit.(:X) (IN)
      REAL    FORD(MAXORD)               ! avr.flux     (IN)
      REAL    CORD(MAXORD)               ! ord.cent.(:Y)(IN)
      INTEGER NORD                       ! # of orders  (IN)
      REAL    TBL(3,1)                   ! "in core" table (IN/OUT)
      INTEGER NTBL                       ! # of rows in table (OUT)
C
      INTEGER NC                         ! curr.row number
      INTEGER I
C
      DATA      NC/1/
C
      DO I = 1, NORD
        IF (FORD(I) .GT. 0.) THEN
            TBL(1,NC) =  CORD(I)
            TBL(2,NC) =  XPOS
            TBL(3,NC) =  I
            NTBL = NC
            NC = NC + 1
        ENDIF
      ENDDO
C
      RETURN
      END

C*****************************************************************
      SUBROUTINE REVTBL(TBL,NTBL)
C
C       Reverse TBL-array
C
      INTEGER NTBL                       ! # of rows in TBL (IN)
      REAL    TBL(3,NTBL)                ! "in core" table (IN/OUT)
C
      REAL RVAL(3)
      INTEGER I, J, K
C
      IF (NTBL .GT. 1) THEN
        DO I = 1, NTBL/2
            K = NTBL-I+1
            DO J = 1, 3
                RVAL(J) = TBL(J,I)
            ENDDO
            DO J = 1, 3
                TBL(J,I) = TBL(J,K)
            ENDDO
            DO J = 1, 3
                TBL(J,K) = RVAL(J)
            ENDDO
        ENDDO
      END IF
C
      RETURN
      END

C*****************************************************************
      SUBROUTINE WRTTBL(TID,NORD,TBL,NTBL,N1)
C
C       Form the output table sorted by :ORDER
C
      INTEGER TID                        ! table id     (IN)
      INTEGER NORD                       ! # of orders  (IN)
      INTEGER NTBL                       ! # of rows in table (IN)
      REAL    TBL(3,NTBL)                ! "in core" table (IN)
      INTEGER N1                         ! image X-size       (IN)
C
      INTEGER NC                         ! curr.row number
      REAL RVAL(5)
      INTEGER I, K, ICOL(5), ISTAT
C
      DATA      ICOL/1,2,3,4,5/
      DATA      NC/1/
C
      DO I = 1, 5
        RVAL(I) = 0.
      ENDDO
C
      DO I = 1, NORD
        RVAL(1) =  I
        RVAL(2) =  1.0
        CALL TBRWRR(TID,NC,2,ICOL,RVAL,ISTAT)
        NC = NC + 1
        DO K = 1, NTBL
            IF ( INT(TBL(3,K)+0.1) .EQ. I) THEN
                RVAL(1) =  TBL(3,K)
                RVAL(2) =  TBL(2,K)
                RVAL(3) =  TBL(1,K)
                CALL TBRWRR(TID,NC,5,ICOL,RVAL,ISTAT)
                NC = NC + 1
            ENDIF
        ENDDO
        RVAL(1) =  I
        RVAL(2) =  N1
        CALL TBRWRR(TID,NC,2,ICOL,RVAL,ISTAT)
        NC = NC + 1
      ENDDO
C
      RETURN
      END

C*****************************************************************
      SUBROUTINE EXTRAV(X,N1,N2,I,WIDTH,INCL,OUT)
C
C       Extract and average 2*WIDHT+1 vertical columns
C       from image array X(N1,N2) centered at I-column
C       ( with order inclination account )
C
      INTEGER N1
      INTEGER N2
      REAL    X(N1, N2)     ! input image
      INTEGER I             ! position of center column
      INTEGER WIDTH         ! +- from I-column
      REAL    INCL          ! orders inclination coefficient
      REAL    OUT(N2)       ! output trace
C
      INTEGER J, J1, K, K1
C
      DO 10 J = 1, N2
         OUT(J) = 0.
         DO 20 K = I-WIDTH,I+WIDTH
            J1 = MAX(1, MIN(N2, INT(J + (K-I)*INCL + 0.5)))
            IF (K .LT. 1)  THEN
                K1 = -(K-1)
            ELSE IF (K .GT. N1) THEN
                K1 = N1-(K-N1)
            ELSE
                K1 = K
            ENDIF
            OUT(J) = OUT(J) + X(K1,J1)
20       CONTINUE
         OUT(J) = OUT(J)/(2*WIDTH+1)
10    CONTINUE
      RETURN
      END

CC*****************************************************************
C      SUBROUTINE CONVL(X,N1,N2,I1,I2,OUT,NSTEP)
CC
CC       Perform "convolution" of two vertical columns: I1, I2
CC       of image array X(N1,N2)
CC
C      INTEGER N1
C      INTEGER N2
C      REAL    X(N1, N2)
C      INTEGER I1, I2
C      REAL    OUT(N2)
C      INTEGER NSTEP
CC
C      INTEGER J, K, N, N22
C      REAL S, S1
CC
C      N22 = N2/2
C      N = MIN0(NSTEP,N22-1)
C      S1 = 0.
C      DO 10 K = 1, N2
C         OUT(K) = 0.
C         S1 = S1 + X(I1,K)
C10    CONTINUE
C      DO 30 J = -N, N
C         S = 0.
C         DO 20 K = 1, N2
C            S = S + X(I1,K)*X(I2,MOD(N2+K+J-1,N2)+1)
C20       CONTINUE
C         OUT(N22+J) = S/S1
C30    CONTINUE
C      RETURN
C      END
C
CC*****************************************************************
C      INTEGER FUNCTION LWORD(INP,NP,CENTER,AM,XC,HWHI)
CC
CC      Determine new order width
CC
C      INTEGER NP                   ! IN arr.length
C      REAL    INP(NP)              ! IN input array
C      INTEGER CENTER               ! IN center pixel of contour
C      REAL    AM, XC, HWHI         ! OUT output params
CC
C      INTEGER I, J, K, WND, IC
C      REAL    A, B, D, A11, A12, A22, B1, B2
C      REAL    X, Y, Y1, Y2
CC
CC ... at first - rough estimation of HWHI
C      K = NP
C      DO I = CENTER+1,NP-1
C        IF (INP(I) .LE. INP(CENTER)/2.) THEN
C            K = I
C            GO TO 10
C        ENDIF
C        IF ((INP(I-1).GE.INP(I)) .AND. (INP(I+1).GE.INP(I))) THEN
C            K = I-2
C            GO TO 10
C        ENDIF
C      ENDDO
CC
C10    WND = K - CENTER
C      LWORD = WND
CC
CC ... and then try to determine parameters with more precision
C      AM = INP(CENTER)
C      IC = CENTER
CC ... make sure that we stay at maximum
C      DO I = CENTER-WND+1, CENTER+WND
C        IF (INP(I) .GT. AM) THEN
C            AM = INP(I)
C            IC = I
C        ENDIF
C      ENDDO
CC ... redefine window of interest
C      Y1 = AM
C      Y  = (INP(IC+1) + INP(IC-1))/2.
C      DO I = 1, WND
C        Y2  = (INP(IC+I+1) + INP(IC-I-1))/2.
C        IF (Y1-Y .GE. Y-Y2) THEN
C            WND = I+1
C            GO TO 20
C        ENDIF
C        Y1 = Y
C        Y  = Y2
C      ENDDO
CC ... perform very simple fit
C20    A11 = 0.
C      A12 = 0.
C      A22 = WND*2.
C      B1 = 0.
C      B2 = 0.
C      DO I = IC-WND+1, IC+WND
C        AM = MAX(AM, INP(I))
C        X = I - 0.5
C        Y = INP(I) - INP(I-1)
C        A11 = A11 + X**2
C        A12 = A12 + X
C        B1  = B1  + X*Y
C        B2  = B2  + Y
C      ENDDO
C      D = (A11*A22 - A12*A12)
C      A = (B1*A22  - B2*A12)/D
C      B = (B2*A11  - B1*A12)/D
C      XC = -B/A
C      HWHI = SQRT( MAX(0., -AM/A))
C      WRITE (*,9000) AM, XC, HWHI*2.
CC
C      RETURN
C 9000 FORMAT ('Am=',F7.1,'  Xc=',F6.1,'  FWHI=',F6.3)
C      END
C
C*****************************************************************
      REAL FUNCTION SIGMA3(INP,NP)
C
C       Rough noise estimation by a "3-point dispersion" algorithm
C
      INTEGER NP
      REAL    INP(NP)
C
      INTEGER K
      REAL S
C
      S = 0.
      DO 10 K = 2, NP-1
          S = S + (INP(K) - (INP(K-1)+INP(K+1))/2.)**2
10    CONTINUE
      SIGMA3 = SQRT(S/(NP-3))
      RETURN
      END

C*****************************************************************
      SUBROUTINE BGRND(INP,NP,WRK,OUT,PORT,NOISE,NIT,CIT)
C
C       Background extraction
C
      INTEGER NP                 ! vectors lehgth
      REAL    INP(NP)            ! input vector
      REAL    WRK(NP)            ! working array
      REAL    OUT(NP)            ! output vector
      INTEGER PORT               ! smoothing window = PORT*2+1
      REAL    NOISE              ! "cutting" level
      INTEGER NIT                ! # of steps to pass
      INTEGER CIT                ! current step (IN/OUT!!!)
C
      INTEGER IT, I, II, IO, N
      REAL S
C
C ...  copy input values to the working area
      IF (CIT .EQ. 0) THEN
           DO 5 I = 1,NP
5              WRK(I) =INP(I)
      ENDIF
C
C ...  execute NIT steps of iteration: "smoothing" + "cutting"
      DO 60 IT = 1,NIT
         CIT = CIT + 1
C
C ...    first - simlple smooth with a "sliding-window"
         S = 0.
         DO 10 I = 1,PORT
10           S = S + WRK(I)           ! fill smoothing window
         N = PORT
         DO 40 I = 1,NP
             II = I + PORT
             IO = I - PORT-1
             IF (II .LE. NP) THEN
                 S = S + WRK(II)      ! add input element to window
                 N = N + 1
             ENDIF
             IF (IO .GE. 1 ) THEN
                 S = S - WRK(IO)      ! del. output elem. from window
                 N = N - 1
             ENDIF
             OUT(I) = S / N
40      CONTINUE
C
C ...   and then supperss strong details with noise level account
        DO 50 I = 1,NP
             IF (INP(I) .GT. OUT(I)+NOISE) THEN
                 WRK(I) = OUT(I)
             ELSE
                 WRK(I) = INP(I)
             ENDIF
50      CONTINUE
C
60    CONTINUE
C
      RETURN
      END

C*****************************************************************

      SUBROUTINE PLTARR(OUT,N2,NB,NE,NAME,OVR)
C
C       Plot elements from NB to NE of array OUT(N2) with identifier NAME
C       (for debuging)
C
      INTEGER N2                    ! total length of data array
      REAL    OUT(N2)               ! array with data to plot
      INTEGER NB, NE                ! edges of plotting part of array
      INTEGER OVR                   ! overplot?
      CHARACTER*(*) NAME            ! label
C
      INTEGER   ISTAT, IAC, KUN, KNUL
      INTEGER   FMODE, IMAGE(4), NPL
      REAL      XS, SX, YOFF
      REAL      CUTS(2)
      REAL      FRAME(8)
      REAL      MUDAKI(2)
      CHARACTER LABEL1*80, LABEL2*80, LABEL3*80, LABEL4*80
      CHARACTER XFRAME*4, YFRAME*4
C
      INCLUDE 'MID_INCLUDE:PLTDEC.INC/NOLIST'
      INCLUDE 'MID_INCLUDE:PLTDAT.INC/NOLIST'
C
      DATA PMODE/-1/
      DATA MUDAKI/0.,0./
C
      CALL STKWRR('PLRSTAT',MUDAKI,19,2,KUN,ISTAT)
C
      CALL STKRDI('PLISTAT',1,1,IAC,FMODE,KUN,KNUL,ISTAT)
      FMODE = MIN0(FMODE,1)       ! we need not too complicated legenda
      CALL STKRDC('PLCSTAT',1,5,4,IAC,XFRAME,KUN,KNUL,ISTAT)
      CALL STKRDC('PLCSTAT',1,9,4,IAC,YFRAME,KUN,KNUL,ISTAT)
      IF (PMODE.LT.0 .OR. OVR.EQ.0) THEN
         PMODE = 0
      ELSE
         PMODE = 2
      ENDIF
C
      IMAGE(1) = MAX( 1, NB)
      IMAGE(2) = MIN(N2, NE)
      IMAGE(3) = 1
      IMAGE(4) = 1
      NPL = MAX( 2,  IMAGE(2) - IMAGE(1) + 1 )
      XS = 1.
      SX = 1.
C
C *** only for plot command
      IF (PMODE.EQ.0) THEN
         YOFF = 0.0
C
C *** find min and max of the data values
         CALL MINMAX(OUT,N2,CUTS(1),CUTS(2))
C
C*** get the frame parameters
         IF (XFRAME(1:4).EQ.'MANU') THEN                        
            CALL STKRDR('PLRSTAT',11,4,IAC,FRAME(1),KUN,KNUL,ISTAT)
C            CALL BOXWTP(FRAME(1),NPL,XS,SX,IMAGE(1))
         ELSE
            XFRAME   = 'AUTO'
            FRAME(1) = FLOAT(IMAGE(1))
            FRAME(2) = FLOAT(IMAGE(2))
         END IF
C
         IF (YFRAME(1:4).EQ.'MANU') THEN
             CALL STKRDR('PLRSTAT',15,4,IAC,FRAME(5),KUN,KNUL,ISTAT)
         ELSE
             YFRAME   = 'AUTO'
             FRAME(5) = CUTS(1)
             FRAME(6) = CUTS(2)
         END IF

C         CALL GETFRM(FRAME(1),FRAME(2),FRAME(3),FRAME(4),XFRAME)
C         CALL GETFRM(FRAME(5),FRAME(6),FRAME(7),FRAME(8),YFRAME)
C
C        WRITE(*,*) 'XFRAME=', XFRAME
C        WRITE(*,*) 'YFRAME=', YFRAME
C        WRITE(*,*) 'FRAME=', FRAME(1), FRAME(2), FRAME(3), FRAME(4)
C        WRITE(*,*) 'FRAME=', FRAME(5), FRAME(6), FRAME(7), FRAME(8)
C
         CALL STKWRR('PLRSTAT',FRAME,11,8,KUN,ISTAT)
C
C     ELSE                                                       ! overplot mode
C        YOFF = YOFF + ABS(CUTS(1) - CUTS(2))/10.
C        CALL STKRDR('INPUTR',1,1,IAC,YOFF,KUN,KNUL,ISTAT)
      ENDIF
C
C *** do the plot setup
C      CALL PLOPN(NAME,PMODE,FMODE)
C
C *** do the work
C      CALL PLKEY(OUT(IMAGE(1)),NPL,IMAGE,XS,SX,YOFF)
C
C *** plot the legenda
      IF (FMODE.EQ.1 .AND. PMODE.EQ.0) THEN
C         CALL PLFRAM(FRAME(1),FRAME(2),FRAME(3),FRAME(4),
C     2               FRAME(5),FRAME(6),FRAME(7),FRAME(8))
         LABEL1 = 'Sequence Number'
         LABEL2 = 'Value'
C
         IF (FMODE.EQ.1) THEN
            LABEL3 = 'Array: '//NAME
            LABEL4 = ' '
C            CALL PLLABL(LABEL1,LABEL2,LABEL3,LABEL4)
         END IF
      END IF
C
C
C *** good bye and return
C      CALL PLCLS
C
      RETURN
      END

C *********************************************************************
C   INSERTED POLYFIT.FOR
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  15:55 - 19 NOV 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.PURPOSE
C  Evaluation of 2D-polynomial
C
C.KEYWORDS
C  REGRESSION
C
C.ALGORITHM
C
C
C-----------------------------------------------------------
C
      REAL FUNCTION EVAPOL(PAR, K, L, VAL1, VAL2)
C
      INTEGER K, L                    ! polynomial degrees
      REAL    PAR(30)                 ! arr. of (K+1)*(L+1) coef-s
      REAL    VAL1, VAL2              ! arguments
C
      INTEGER NA, K1, L1, IP
      DOUBLE PRECISION WORK(30),RESULT,DC
C
      IP     = 0
      DC     = 1.D0
      RESULT = 0.D0
      NA = (K+1)*(L+1)
      IF ( NA.GE.1 .AND. NA.LE.30) THEN
          DO L1 = 0,L
              IP     = IP + 1
              WORK(IP) = DC
              RESULT = RESULT + WORK(IP)*PAR(IP)
              IF (K .GT. 0) THEN
                  DO K1 = 1,K
                      IP = IP + 1
                      WORK(IP) = WORK(IP-1)*VAL1
                      RESULT = RESULT + WORK(IP)*PAR(IP)
                  END DO
              END IF
              DC = DC*VAL2
          ENDDO
      END IF
C
      EVAPOL = RESULT
C
      RETURN
      END

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  16:02 - 19 NOV 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.PURPOSE
C
C  2D-polynomial fitting
C
C.KEYWORDS
C
C  POLYNOMIAL FIT
C
C.ALGORITHM
C
C  fitting algorithm using Householder transformation
C
C-----------------------------------------------------------
C
      SUBROUTINE POLFIT(VAL,NROW,IDEG1,IDEG2,COEF,ERROR)
      IMPLICIT NONE
C
      INTEGER NROW                       ! # data elements:
      REAL    VAL(3,NROW)                !    { Y, X1, X2 }
      INTEGER IDEG1,IDEG2                ! polynomial degrees
      REAL    COEF(30)                   ! polyn-l coefficients (OUT)
      REAL    ERROR                      ! fitting error        (OUT)
C
      INTEGER IPAR(13)
      INTEGER I, ISTAT, KUN, KMIN
      INTEGER NVAR, K, L, N, LL, N1
      INTEGER IROW, K1
      CHARACTER*20 CPAR
      REAL RPAR(13)
C
      DOUBLE PRECISION XMIN,XMAX,YMIN,YMAX,V1,V2,V3
      DOUBLE PRECISION G(30,30),X(30)
C
      ERROR = -1.
      DO 15 I = 1, 30
          X(I) = 0.D0
   15 CONTINUE
      K      = IDEG1
      L      = IDEG2
      IF (K.EQ.0 .AND. L.EQ.0) THEN
          GO TO 70
      ELSE
          N      = (K+1) * (L+1)
      END IF
      IF (N.GT.29) THEN
          GO TO 70
      END IF
      IF (K.EQ.0 .OR. L.EQ.0) THEN
          NVAR = 2
      ELSE
          NVAR = 3
      END IF
C
C
C ... SOLVE LEAST SQUARE PROBLEM
C
      XMIN   = 1.D30
      YMIN   = 1.D30
      XMAX   = -XMIN
      YMAX   = -YMIN
      LL     = 0
      N1     = 0
      DO 50 IROW = 1,NROW
          V1     = VAL(1,IROW)
          V2     = VAL(2,IROW)
          V3     = VAL(3,IROW)
          XMIN   = MIN(XMIN,V2)
          XMAX   = MAX(XMAX,V2)
          YMIN   = MIN(YMIN,V3)
          YMAX   = MAX(YMAX,V3)
          CALL TDSET2(LL+1,V2,V3,V1,K,L,G,X,N,30)
          IF (LL.NE.0) THEN
              KMIN   = MIN(LL,N+1)
              DO 40 K1 = 1,KMIN
                  CALL TDHHTR(K1,LL+1,G,X,N,30)
   40         CONTINUE
          END IF
          LL     = MIN(LL+1,N+1)
   50 CONTINUE
      CALL TDSOLV(G,X,N,30)
      ERROR  = ABS(G(N+1,N+1))
C
C ... COPY RESULT OF REGRESSION
C
      CPAR(9:16) = 'ORDER   '
      IPAR(1) = NROW
      IPAR(2) = NVAR - 1
      IPAR(3) = 3             ! :Y
      CPAR(17:20) = 'MULT'
      IPAR(4) = 2             ! :X
      IPAR(5) = 1             ! :ORDER
      IPAR(6) = IDEG1
      IPAR(7) = IDEG2
      RPAR(1) = XMIN
      RPAR(2) = XMAX
      RPAR(3) = YMIN
      RPAR(4) = YMAX
      RPAR(5) = SQRT((ERROR*ERROR)/IPAR(1))
      CALL STKWRC('OUTPUTC',1,CPAR,1,20,KUN,ISTAT)
      CALL STKWRI('OUTPUTI',IPAR,1,13,KUN,ISTAT)
      CALL STKWRR('OUTPUTR',RPAR,1,5,KUN,ISTAT)
      CALL STKWRD('OUTPUTD',X,1,N,KUN,ISTAT)
70    DO I = 1, N
          COEF(I) = X(I)
      END DO
C
C ... END
C
      RETURN
      END
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  18:24 - 11 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.KEYWORDS           TABLE, APPLICATIONS
C.ENVIRONMENT  MIDAS
C.PURPOSE
C LINEAR REGRESSION
C.ALGORITHM
C
C HOUSEHOLDER TRANSFORMATION
C REF.: CH.L.LAWSON AND R.J.HANSON
C       SOLVING LEAST SQUARES PROBLEMS
C       PRENTICE HALL INC. 1974
C
C
C------------------------------------------------------------------
C
      SUBROUTINE TDSET2(LL,X1,X2,Y,K,L,G,X,N,M)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.PURPOSE
C
C PREPARE DATA IN WORK SPACE FOR 1 OR 2D POLYNOMIAL
C
C------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER LL
      DOUBLE PRECISION X1
      DOUBLE PRECISION X2
      DOUBLE PRECISION Y
      INTEGER K
      INTEGER L
      INTEGER N
      INTEGER M
      DOUBLE PRECISION G(M,M)
      DOUBLE PRECISION X(M)
C
      INTEGER IP,L1,K1
      DOUBLE PRECISION DC

      IP     = 0
      DC     = 1.D0
      DO 20 L1 = 0,L
          IP     = IP + 1
          G(LL,IP) = DC
          DO 10 K1 = 1,K
              IP     = IP + 1
              G(LL,IP) = G(LL,IP-1)*X1
   10     CONTINUE
          DC     = DC*X2
   20 CONTINUE
      G(LL,N+1) = Y
      RETURN

      END

      SUBROUTINE TDHHTR(K,L1,G,X,N,M)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.PURPOSE
C
C     Apply a Householder transformation to the two rows K and L1 of G.
C
C------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER K
      INTEGER L1  !   IN : RANK OF THE MATRIX
      INTEGER N
      INTEGER M
      DOUBLE PRECISION G(M,M)
      DOUBLE PRECISION X(M)
C
      INTEGER KH,J
      DOUBLE PRECISION S,H,B
C
C ... CONSTRUCT THE TRANSFORMATION
C
      S      = DSQRT(G(K,K)**2+G(L1,K)**2)
      IF (G(K,K).GE.0.D0) S      = -S
      H      = G(K,K) - S
      G(K,K) = S
      B      = G(K,K)*H
C
C ... APPLY THE TRANSFORMATION TO THE ROWS K AND L1 OF G.
C
      KH     = N + 1 - K
      IF ((KH.NE.0) .AND. (B.NE.0.D0)) THEN
          DO 10 J = 1,KH
              S      = (G(K,K+J)*H+G(L1,K+J)*G(L1,K))/B
              G(K,K+J) = G(K,K+J) + S*H
              G(L1,K+J) = G(L1,K+J) + S*G(L1,K)
   10     CONTINUE
      END IF

      RETURN

      END

      SUBROUTINE TDSOLV(G,X,N,M)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.PURPOSE
C
C
C                Solve the set of linear equations which are
C                represented by the upper triangular part
C                of the matrix G(1:n,1:n+1).
C
C------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER N
      INTEGER M
      DOUBLE PRECISION G(M,M)  
      DOUBLE PRECISION X(M)
C
      INTEGER I,II,J
      DOUBLE PRECISION S
C
      DO 10 I = 1,N
          X(I)   = G(I,N+1)
   10 CONTINUE
      DO 30 II = 1,N
          I      = N - II + 1
          S      = 0.D0
          IF (I.NE.N) THEN
              DO 20 J = 2,N + 1 - I
                  S      = S + G(I,I+J-1)*X(I+J-1)
   20         CONTINUE
          END IF

          X(I)   = (X(I)-S)/G(I,I)
   30 CONTINUE
      RETURN

      END

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C Author: P. Ballester. Creation 17-AUG-1992
C
C Find minimum and maximum in a 1D array of type REAL
C
      SUBROUTINE MINMAX(TAB,NEL,MIN,MAX)

      INTEGER NEL
      REAL    TAB(NEL),MIN,MAX

      INTEGER CNT

      MIN = TAB(1)
      MAX = TAB(1)

      IF (NEL .GT. 1) THEN

          DO 1000 CNT = 2,NEL

             IF (TAB(CNT) .GT. MAX) MAX = TAB(CNT)
             IF (TAB(CNT) .LT. MIN) MIN = TAB(CNT)

1000      CONTINUE

      ENDIF

      RETURN
      END

      

C===========================================================================
C Copyright (C) 1995-2008 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C. IDENTIFICATION
C
C   Program    ECHBACK            version 1.00 : 27.06.90
C
C   Author : P. BALLESTER       ESO - Garching
C
C. KEYWORDS
C   Echelle spectroscopy background rebinning
C
C. PURPOSE
C   Fit the background and generates a frame
C
C. ALGORITHM
C Adapted from W. Verschueren, H. Hensberge, Astr. Astroph. 240,216(1990)
C "Order extraction and background subtraction on CCD Caspec Echelle Spectra"
C
C. INPUT/OUTPUT
C   The following keywords are used :
C     IN_A/C/1/60           IN: input table (type ORDER)
C     IN_B/C/1/60           IN: reference image
C     INPUTI/I/1/1          IN: half-size of the measure window
C     INPUTI/I/2/1          IN: degree of the spline polynomials
C     INPUTR/R/1/1          IN: smoothing factor of the spline interpolation
C     OUT_A/C/1/60          OUT: output image (background estimate)
C
C. VERSIONS
C   0.00   27.06.90   from version 1.20 of 19.02.90 of REBIN.FOR
C   1.00   17.07.90   Reference version
C   1.10   19.07.90   Speed improvements : from 9.26 Mmbbe to 2.06 Mmbbe
C          22.06.99   Measurement mode (MMODE) added (swolf@eso.org)
C. BUGS
C   Since the STDWRC standard interface does not work properly for felem=-1,
C     the first line of the HISTORY descriptor of the output frame is
C     overwritten (17.07.90)
C
C.VERSIOn
C 080717	last modif
C 
C-----------------------------------------------------------------------------
C
      IMPLICIT NONE
C
      LOGICAL FLAG,NULL
C     LOGICAL DBG
C
      INTEGER   NAXIS,ROW,ABSROW,NPOINT,DEGREE
      INTEGER   WIDTH,TYP,DUN,MMODE
C     INTEGER   COL   !  DBG
      INTEGER   IMNOA,IMNOB
      INTEGER*8 PNTRA,PNTRB
      INTEGER   NPIX(2),ERROR
      INTEGER   IAV,UNI(1),NULO,STAT
      INTEGER   MADRID(1)
      INTEGER   TID,NCINT,NRINT,NACINT,NARINT,NSINT
      INTEGER   POSX,POSY,POSBK
      INTEGER   PSXSTA,PSXEND,PSYSTA,PSYEND
      REAL    XSTA,XEND,YSTA,YEND
C
      CHARACTER*60  ORDER,REFIMA,BAKIMA
      CHARACTER*80  STRING,HISTO
      CHARACTER     CUNIT*48,IDENT*72
      CHARACTER*16  LABX,LABY,LABBK,LBXSTA,LBXEND
      CHARACTER*16  LBYSTA,LBYEND,FORM,UNIT
C
      PARAMETER (NPOINT=20000)
      REAL      BACK(3,NPOINT),SMOOTH,MEASUR,CUTS(4)
C
      DOUBLE PRECISION STEP(2),START(2)
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      COMMON /VMR/ MADRID
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      DATA LABX,LABY,LABBK /'X' , 'YBKG' , 'BKG'/
      DATA LBXSTA,LBXEND,LBYSTA,LBYEND /'XSTA','XEND','YSTA','YEND'/
C
C --- 0. MIDAS environment set up and enables automatic error abort
C
      CALL STSPRO ('ECHBAK')
C
C --- Set DEBUG flag or not
C
C      DBG = (.FALSE.)
C
C --- 1. Read input/output descriptors
C
      CALL STKRDC ('IN_A',1,1,60,IAV,ORDER,UNI,NULO,STAT)
      CALL STKRDC ('IN_B',1,1,60,IAV,REFIMA,UNI,NULO,STAT)
      CALL STKRDC ('OUT_A',1,1,60,IAV,BAKIMA,UNI,NULO,STAT)
C
C --- Translate names
C
      CALL CLNTAB (ORDER,ORDER,0)
      CALL CLNFRA (REFIMA,REFIMA,0)
      CALL CLNFRA (BAKIMA,BAKIMA,0)
C
      CALL STKRDI ('INPUTI',1,1,IAV,WIDTH,UNI,NULO,STAT)
      CALL STKRDR ('INPUTR',1,1,IAV,SMOOTH,UNI,NULO,STAT)
      CALL STKRDI ('INPUTI',2,1,IAV,DEGREE,UNI,NULO,STAT)
      CALL STKRDI ('INPUTI',3,1,IAV,MMODE,UNI,NULO,STAT)
C
C --- Display read descriptors
C
C       IF (DBG) THEN
C        STRING = '*** Read descriptors : '
C        CALL STTPUT (STRING,STAT)
C        STRING = ORDER(1:25)//REFIMA(1:25)//BAKIMA(1:25)
C        CALL STTPUT (STRING,STAT)
C       ENDIF
C
C --- 2. Get reference frame and map it.
C
      CALL STIGET (REFIMA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +             2,NAXIS,NPIX,START,STEP,IDENT,CUNIT,
     +             PNTRA,IMNOA,STAT)
C
C --- A call to STETER will abort the program...
C
      IF (NAXIS.NE.2)
     +     CALL STETER (1,'Input frame must have two dimensions...')
C
C --- 3.1. Get input table and open it
C
      CALL TBTOPN (ORDER,F_IO_MODE,TID,STAT)
C
C --- 3.2. Read table descriptors
C
      CALL TBIGET (TID,NCINT,NRINT,NSINT,NACINT,NARINT,STAT)
      IF (NRINT.EQ.0) THEN
          STRING = '*** FATAL : There are no data in the table'
          CALL STETER (9,STRING)
      ENDIF
C
C --- 4. Table columns processing
C
C --- 4.1. Search for columns defining background positions
C
      CALL TBLSER (TID,LABX ,POSX, STAT)
      IF (POSX.EQ.-1) THEN
         STRING = 'Column label '//LABX//'not found in table '//ORDER
         CALL STTPUT (STRING,STAT)
      ENDIF
C
      CALL TBLSER (TID,LABY ,POSY, STAT)
      IF (POSY.EQ.-1) THEN
         STRING = 'Column label '//LABY//'not found in table '//ORDER
         CALL STTPUT (STRING,STAT)
      ENDIF

      CALL TBLSER (TID,LBXSTA ,PSXSTA, STAT)
      CALL TBLSER (TID,LBXEND ,PSXEND, STAT)
      CALL TBLSER (TID,LBYSTA ,PSYSTA, STAT)
      CALL TBLSER (TID,LBYEND ,PSYEND, STAT)
C
C --- 4.2. Create column for measured background
C          Check that the column do not already exist and if not, creates
C          a new one.
C
      CALL TBLSER (TID,LABBK,POSBK,STAT)

      IF (POSBK.GT.0) THEN
         STRING = 'Warning : Column label '//LABBK//'already exists'
         CALL STTPUT (STRING,STAT)
         STRING = '          Not created'
         CALL STTPUT (STRING,STAT)
      ELSE
         TYP  = D_R4_FORMAT
         FORM = 'E12.3'
         UNIT = 'PIXELS'
         CALL TBCINI (TID,TYP,1,FORM,UNIT,LABBK,POSBK,STAT)
      ENDIF
C
C --- 5. Prepares array BACK by reading selected position values in the table
C         and measures local background level on these positions.
C
      ABSROW=0
      DO 100 ROW = 1,NRINT
C
C --- 5.1. Read selection flag
C
         CALL TBSGET (TID,ROW,FLAG,STAT)

         IF (STAT.NE.0) THEN
          WRITE (STRING,350) ROW,ORDER
350       FORMAT ('*** Fatal : Cannot access row ',I5,' of table ',A40)
          CALL STETER (9,STRING)
         ENDIF
C
         IF (FLAG) THEN

             ABSROW = ABSROW + 1

             IF (ABSROW.GT.NPOINT) THEN
          STRING = 'Do you really want to process such a big table ???'
          CALL STTPUT (STRING,STAT)
          STRING= '*** Warning : Buffer overflow in module FITBACK.FOR'
          CALL STETER (9,STRING)
             ENDIF
C
C --- 5.2. Read positions
C
             CALL TBERDR (TID,ROW,POSX, BACK(1,ABSROW),NULL,STAT)
             CALL TBERDR (TID,ROW,POSY, BACK(2,ABSROW),NULL,STAT)
             CALL TBERDR (TID,ROW,PSXSTA, XSTA,NULL,STAT)
             CALL TBERDR (TID,ROW,PSXEND, XEND,NULL,STAT)
             CALL TBERDR (TID,ROW,PSYSTA, YSTA,NULL,STAT)
             CALL TBERDR (TID,ROW,PSYEND, YEND,NULL,STAT)
C
C --- 5.3. Measures background
C
             BACK (3,ABSROW) = MEASUR (MADRID(PNTRA),NPIX(1),NPIX(2),
     +             XSTA,XEND,YSTA,YEND,WIDTH,MMODE)
C
C --- 5.4. Write measured background on the table
C
             CALL TBEWRR (TID,ROW,POSBK,BACK(3,ABSROW),STAT)
C
         ENDIF

C         IF (DBG) THEN
C          WRITE (STRING,300) ROW,FLAG,ABSROW,(BACK(COL,ABSROW),COL=1,3)
C300       FORMAT(3I5,3F12.3)
C          CALL STTPUT (STRING,STAT)
C         ENDIF

100   CONTINUE
C
C --- 5.5 If DEGREE<0 EXIT
C      
      IF (DEGREE.LT.0) GOTO 1000

C
C --- 6. Get output frame
C
      IF (REFIMA.EQ.BAKIMA) THEN
         CALL STETER (2,'Input and Output frames must be different...')
      ENDIF
C
      CALL STIPUT (BAKIMA,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +             NAXIS,NPIX,START,STEP,IDENT,CUNIT,
     +             PNTRB,IMNOB,STAT)
C
C --- 7. Update descriptors of the output frame
C
C --- 7.1 Copy all descriptors from the input frame to the output frame
C
      CALL STDCOP (IMNOA,IMNOB,1,' ',STAT)
C
C --- 7.2. Write specific IDENT on the output frame
C
      WRITE (HISTO,800) WIDTH,SMOOTH,DEGREE
800   FORMAT ('Background estimate -  Half-width:',I3,' Smooth:',E13.4,
     +        ' Degree:',I3)
      CALL STTPUT (HISTO,STAT)
C
C
      CALL STDWRC (IMNOB,'ORIGIN',1,REFIMA,1,60,DUN,STAT)
      CALL STDWRC (IMNOB,'HISTORY',1,HISTO,1,80,DUN,STAT)
C
C      CALL STDWRC (IMNOB,'HISTORY',1,HISTO,-1,80,DUN,STAT)
C. ---> STDWRC does not work properly for felem = -1. (17.07.90)
C
C
C --- 8. Call the routine which actually process the data
C
C     - Check initial conditions
C     - Do the smoothing spline interpolation along the columns.
C     - Interpolates background row by row for residual undefined positions
C     - Writes interpolated values on the frame
C     - Returns an error code (0 = O.K.)
C  !!! The subroutine modifies the value of SMOOTH !!!
C
      CALL FITBAK (NPOINT,BACK,ABSROW,MADRID(PNTRB),NPIX(1),NPIX(2),
     +             DEGREE,SMOOTH,ERROR,CUTS)
C
      IF (ERROR.NE.0) THEN
         STRING = '*** An error occured during execution'
         CALL STETER (9,STRING)
      ENDIF
C
C --- 8.2 Finish descriptor updating
C
      CALL STDWRR (IMNOB,'LHCUTS',CUTS,1,4,DUN,STAT)
C
C --- 9. Release files, update keywords and exit
C
 1000 CONTINUE
      CALL STSEPI
C
      STOP
      END




      SUBROUTINE FITBAK (DIMTAB,TABLE,NBVAL,IMAGE,NX,NY,DEGREE,SMOOTH,
     +                   ERR,CUTS)
C
C     
C
C     DESCRIPTION :
C
C     This subroutine do the actual work of inter- or extrapolation
C     using a smoothing spline algorithm to fit the data in mainly
C     two steps :
C
C     1. First, assuming that background positions are defined column
C     by column, one fits the data for all defined columns. This operation
C     involves the following steps.
C
C       - Search for a defined column in the table and load X,Y and W arrays
C            which represents respectively the row position, the background
C            measured value and the relative weight of the value (here W=1.0).
C       - Updates the array of defined columns (TABFLG)
C       - If necessary, forces the values on the edges of the column
C       - Computes knots and b-spline coefficients
C       - Computes interpolated values along the whole column and writes
C            them on the frame.
C
C     2. Residual undefined pixels are interpolated using a row by row
C     spline interpolation. This time, one forces the spline interpolation
C     to pass exactly by the already defined values (smoothing factor s=0.).
C     This is done in a similar way of the previous step :
C
C       - In order to accelerate computation :
C          One loads an array of residual undefined columns positions (UNDCOL)
C          Since this array is constant, so are the knots positions of the
C          spline interpolation, which are computed only once, for the
C          first row.
C       - Computes the ratio of the job already done and displays it.
C       - Computes b-spline coefficients for each row
C       - Computes interpolated values along the whole row and writes
C          them on the frame.
C
C     If something is wrong during the execution, an error message is
C     displayed, trying to fix the problem. An error code is returned to
C     the driver program and the execution immediately stopped. 
C
C
C     INPUT/OUTPUT :
C
C     ERR   is the only output variable
C     IMAGE is an input/output variable
C     All others variables are input data
C
C     DIMTAB     INTEGER      Second dimension of the array TABLE
C                             (First dimension is supposed to be 3)
C     TABLE      REAL array   Col. 1 : X posiitons of background
C                             Col. 2 : Y posiitons of background
C                             Col. 3 : measured values of background
C     NBVAL      INTEGER      Number of significant data in array TABLE
C     IMAGE      REAL array   Adress of the output image
C     NX         INTEGER      X-dimension of the output image
C     NY         INTEGER      Y-dimension of the output image
C     DEGREE     INTEGER      Degree of the spline polynomials
C     SMOOTH     REAL         Smoothing factor of the spline interpolation
C     ERR        INTEGER      Error return code (0 = O.K.)
C
C     VERSIONS :
C
C     V. 0.00   27.06.90   Creation
C     V. 1.00   17.06.90   Reference version
C     V. 1.10   19.07.90   Remove MASK, introduce CUTS computation
C          Speed improv. : (use PREPOS, remove IMAGE init. and W init)
C
C --- 1. Variables declarations
C
      IMPLICIT NONE
C
C --- 1.1. Input/Output variables
C
      INTEGER   DIMTAB
      INTEGER   NBVAL,NX,NY,DEGREE,ERR
      REAL      TABLE(3,DIMTAB),CUTS(4)
      REAL      IMAGE(1),SMOOTH
C
C --- 1.2. Internal variables
C
      INTEGER   M,NEST,LEVEL
      INTEGER   PTIMA,PTTAB,STAT,FLAG,NK1,NU,PASS1
      INTEGER   INTCOL,INTROW
      INTEGER   IOPT,NBKNOT,IER,NBUND,PREPOS

      PARAMETER (M=10000,NEST=4096)
      INTEGER   ROW,COL,POSARG,POSCOL,POSTAB,NPTS,TABFLG(M,2)

      REAL      X(M),Y(M),W(M),Q(M,6),XB,XE,KNOTS(NEST),COEF(NEST),FP
      REAL      NRDATA(NEST),FPO,FPOLD,NPLUS,THRES
      REAL      ARG,DERIV,UNDCOL(M),MEAN,RATIO
      REAL      BIGSMO

      CHARACTER STRING*80

C
C --- 2. Initialisations
C
       IF (NX.GT.M.OR.NY.GT.M) THEN
        STRING = 'Do you really want to process such a big image ???'
        CALL STTPUT (STRING,STAT)
        STRING = '*** Fatal : Parameter M in module FITBAK is too small'
        CALL STTPUT (STRING,STAT)
        IF (NY.GT.NX) NX = NY
        WRITE (STRING,5100) NX,M
5100    FORMAT ('Minimum value is : ',I8,' instead of :',I8)
        CALL STTPUT (STRING,STAT)
        ERR = 10		! No "science" error
        RETURN
       ENDIF
C
C
      DO 50,COL = 1 , M
         TABFLG (COL,1) = 0	! Number of data for interpolation
         TABFLG (COL,2) = 0	! Interpolation done (=1)
         W (COL) = 1.0		! Weights of values
50    CONTINUE

      ERR    = 0	! Normal return
      LEVEL  = 2	! Level of messages when calling IERSPL
C      SMOOTH = 0.	! Smoothing factor for this part of the algorithm
      INTCOL  = 0
      INTROW  = 0
      BIGSMO  = 1.0E+20
C
C --- 3. Building the table of values
C
100   CONTINUE		! Beginning of the loop on table values
C
C --- 3.1. Identification of a new column position not yet interpolated
C
      FLAG = 0
      DO 110,PTTAB = 1 , NBVAL
         COL = NINT (TABLE(1,PTTAB))
         IF (TABFLG(COL,1).EQ.0) THEN
            FLAG   = 1
            POSTAB = PTTAB
            GOTO 150
         ENDIF
110   CONTINUE
150   CONTINUE
C
C --- 3.2. If FLAG#0, loading of table data for the given column number
C
      IF (FLAG.EQ.0) THEN
         GOTO 1000
      ELSE

         NPTS = 0	! Number of ORDER table values for column COL
         DO 200 PTTAB = POSTAB , NBVAL
C
            POSCOL = NINT (TABLE(1,PTTAB))
            IF (COL.EQ.POSCOL) THEN
                NPTS = NPTS + 1

       IF (NPTS.GT.M) THEN
        STRING = '*** Fatal : Parameter M in module FITBAK is too small'
        CALL STTPUT (STRING,STAT)
        WRITE (STRING,5100) NPTS,M
        ERR = 10		! No "science" error
        RETURN
       ENDIF

                X(NPTS) = TABLE (2,PTTAB)	! Y position, in pixels
                Y(NPTS) = TABLE (3,PTTAB)	! Background value
            ENDIF
200      CONTINUE
       ENDIF
C
C --- 3.3. Update the array of interpolated columns and check number of data
C
         TABFLG(COL,1) = NPTS
C
        IF (TABFLG(COL,1).LE.DEGREE) THEN
         STRING = '*** Warning : Number insufficient for interpolation'
         CALL STTPUT (STRING,STAT)
         GOTO 100	! Search for another column number
        ENDIF
C
C --- 4. Smoothing spline interpolation along columns
C
             IOPT = 0		! Restart all computations
C
C --- 4.1. Evaluating minimum abscisse XB and maximum XE and eventually,
C          forces the values on the edges of the column
C
             IF (NINT(X(1)).NE.1) THEN
                DO 350 PTTAB = NPTS , 1 , -1
                  X(PTTAB+1) = X(PTTAB)
                  Y(PTTAB+1) = Y(PTTAB)
350             CONTINUE
                X(1) = 1.0
                Y(1) = Y(2)
                NPTS = NPTS + 1
             ENDIF

             IF (NINT(X(NPTS)).NE.NY) THEN
                X(NPTS+1) = FLOAT(NY)
                Y(NPTS+1) = Y(NPTS)
                NPTS = NPTS + 1
             ENDIF

             XB = 1.0
             XE = FLOAT(NY)
             IXB = 1
             IXE = NY

C
C --- 4.2. Computation of knots sequence and b-spline coefficients
C
             CALL SMOOT (X,Y,W,Q,NPTS,XB,XE,DEGREE,SMOOTH,NBKNOT,
     +                    KNOTS,COEF,FP,IOPT,IER,NRDATA,FPO,FPOLD,NPLUS)
C
C --- 4.3. Error management
C
             IF (IER.EQ.3) THEN  !   No convergence achieved

             CALL SMOOT (X,Y,W,Q,NPTS,XB,XE,DEGREE,BIGSMO,NBKNOT,
     +                    KNOTS,COEF,FP,0,IER,NRDATA,FPO,FPOLD,NPLUS)
             PASS1  = 0
             INTCOL = INTCOL + 1

             ENDIF

             CALL IERSPL (IER,LEVEL)	! Displays error messages

             IF (IER.GT.0) THEN

              ERR = 1		! Error during spline interpolation
5200          FORMAT ('Error while processing column ',I6)
              WRITE(STRING,5200) POSCOL
              CALL STTPUT(STRING,STAT)
              RETURN

             ELSE

              TABFLG (COL,2) = 1 ! Interpolation correctly done

             ENDIF
C
C --- 5. Computation of interpolated values
C
      NU  = 0				! Order of the derivative
      PREPOS = DEGREE + 1

      DO 400,ROW = IXB,IXE 
         ARG = FLOAT(ROW)
C
C --- 5.1. Find the position of the argument within the knots sequence
C
         CALL ARGSPL (ARG,KNOTS,NBKNOT,DEGREE,PREPOS,POSARG,NK1)
C
C --- 5.2. Computes interpolated values
C
C        COL is already defined within the main loop
         PTIMA = (ROW-1)*NX+COL
         IMAGE(PTIMA)  = DERIV (KNOTS,NBKNOT,COEF,NK1,NU,ARG,POSARG)
400   CONTINUE
C
C --- End of loop on table values
C
      GOTO 100		! Search for another column number

1000  CONTINUE		! Continue the process
      IF (INTCOL.GT.0) THEN
         WRITE (STRING,395) INTCOL
395      FORMAT(1X,I5,' columns interpolated by a polynomial')
         CALL STTPUT(STRING,STAT)
      ENDIF         
C
C --- 6. Interpolating along the rows
C
C --- 6.0. Initialisations
C
      THRES = 20.
      PASS1 = 0		! Indicates the first pass in the loop on ROW

      XB = 1.0		! Boundaries of the interpolation
      XE = FLOAT(NX)
      IXB = 1
      IXE = NX

      NBUND = 0		! Initialises number of undefined columns
      DO 1050,COL = 1 , NX
         IF (TABFLG(COL,2).EQ.0) THEN
            NBUND = NBUND + 1
            UNDCOL (NBUND) = FLOAT(COL)
         ENDIF
1050  CONTINUE
      IF (NBUND.EQ.0) RETURN ! All columns are defined.
C                              That's no more work to do...

      DO 1100,ROW = 1 , NY

C
C --- 
C
         RATIO = 100.*FLOAT(ROW)/FLOAT(NY)
         IF (RATIO.GE.THRES) THEN
             WRITE (STRING,1150) THRES
1150         FORMAT ('Background interpolation:',F5.1,' % done')
             CALL STTPUT (STRING,STAT)
             THRES = THRES + 20.0
         ENDIF

         NPTS = 0
         DO 1200,COL = 1 , NX
C
C --- 6.1. Load values for the defined columns in arrays X,Y,W
C
           IF (TABFLG(COL,2).NE.0) THEN

              NPTS = NPTS + 1
              X(NPTS) = FLOAT (COL)
              PTIMA = (ROW-1)*NX+COL
              Y(NPTS) = IMAGE(PTIMA)
           ENDIF
1200     CONTINUE
C
C --- 6.2. Computes b-splines coefficients.
C

         IF (PASS1.EQ.0) THEN 	! On the first pass, ...
            IOPT = 0		! Restart all computations, ...
            PASS1 = 1
         ELSE			! then ...
            IOPT = 1		! starts with the knots found at the
         ENDIF			! last call.
         
         CALL SMOOT (X,Y,W,Q,NPTS,XB,XE,DEGREE,SMOOTH,NBKNOT,
     +                KNOTS,COEF,FP,IOPT,IER,NRDATA,FPO,FPOLD,NPLUS)
C
C --- 6.3. Error management
C
             IF (IER.EQ.3) THEN  !   No convergence achieved

             CALL SMOOT (X,Y,W,Q,NPTS,XB,XE,DEGREE,BIGSMO,NBKNOT,
     +                    KNOTS,COEF,FP,0,IER,NRDATA,FPO,FPOLD,NPLUS)
             PASS1 = 0
             INTROW = INTROW + 1

             ENDIF

         CALL IERSPL (IER,LEVEL)	! Displays error messages

         IF (IER.GT.0) THEN

              ERR = 1		! Error during spline interpolation
              WRITE(STRING,5200) ROW
              CALL STTPUT(STRING,STAT)
              RETURN

         ENDIF
C
C --- 6.4. Computes interpolated values 
C          (Only where it is not already defined)
C
      NU  = 0				! Order of the derivative
      PREPOS = DEGREE + 1

      DO 1400,COL = 1,NX
         ARG = FLOAT(COL)
C
C --- 6.4.1. Find the position of the argument within the knots sequence
C
         CALL ARGSPL (ARG,KNOTS,NBKNOT,DEGREE,PREPOS,POSARG,NK1)
C
C --- 6.4.2. Computes interpolated values
C
C        ROW is already defined within the main loop
         PTIMA = (ROW-1)*NX+COL
         IMAGE(PTIMA)  = DERIV (KNOTS,NBKNOT,COEF,NK1,NU,ARG,POSARG)

1400   CONTINUE		! End of the loop on ARG

1100   CONTINUE		! End of the loop on ROW

      IF (INTROW.GT.0) THEN
         WRITE (STRING,396) INTROW
396      FORMAT(1X,I5,' rows interpolated by a polynomial')
         CALL STTPUT(STRING,STAT)
      ENDIF         
C
C --- 7. CUTS computation
C
      CUTS(3) = IMAGE(1)	! Minimum value
      CUTS(4) = IMAGE(1)	! Maximum value

      DO 2000,PTIMA = 2 , NX*NY

       IF (IMAGE(PTIMA).LT.CUTS(3)) CUTS(3)=IMAGE(PTIMA)
       IF (IMAGE(PTIMA).GT.CUTS(4)) CUTS(4)=IMAGE(PTIMA)

2000  CONTINUE

      MEAN = (CUTS(3)+CUTS(4))/2.
      CUTS(3) = MEAN - (MEAN-CUTS(3))*1.0
      CUTS(4) = MEAN + (CUTS(4)-MEAN)*1.0

      CUTS(1) = CUTS(3)
      CUTS(2) = CUTS(4)
C
C --- 8. That's all folks          
C
      RETURN
      END

       FUNCTION MEASUR (IMAGE,NX,NY,XSTA,XEND,YSTA,YEND,WIDTH,MMODE)
C
C ----------------------------------------------------------------------------
C
C.  IDENTIFICATION
C
C       Author : P. Ballester    ESO - Garching
C
C       Versions :           1.00    30.06.90
C
C.  PURPOSE
C
C      This function measures on the frame the median value of the signal
C           on the neighbourhood of the position (POSX,POY), inside
C           a sub-frame of dimension (2*WIDX+1,2*WIDY+1)
C
C.  RESTRICTIONS : 
C
C       (2*WIDX+1)*(2*WIDY+1) < 225 (Parameter MAXPIX)
C       Executable only within MIDAS environment (STTPUT,STETER)
C
C.  INPUTS :
C
C       IMAGE       Frames on which the signal is measured
C       NX,NY       Dimensions of the frame
C       POSX,POSY   Central position of the sub-image
C       WIDX        X Half-size of the window
C       WIDY        Y Half-size of the window
C
C.  OUTPUTS :
C
C       MEASUR      Mean value of the signal in the sub-image
C
C.  ALGORITHM :
C
C      One checks that the central position is defined in the frame. Then
C          the pixels of the neighbourhood of the central position are
C          summed up (excepted the ones which are not defined in the
C          frame) and the median value is returned.
C
C ----------------------------------------------------------------------------
C
C --- 1. Variables definition
C
       IMPLICIT NONE
C
       LOGICAL FLAG

       INTEGER MAXPIX,NPIX,MEDMIN,MEDMAX,KC,MMODE
       INTEGER NX,NY,WIDTH
       INTEGER PTIMA,COL,ROW,POSY,KR, STP, NXSTA, NXEND

       PARAMETER (MAXPIX=1024)
       REAL    MEASUR,IMAGE(1),HISTO(MAXPIX),BUFFER
       REAL    XSTA,XEND,YSTA,YEND,SLOPE,INTER

       CHARACTER STRING*80
C
C --- 3. Computes mean value
C

       SLOPE  = (YEND-YSTA)/(XEND-XSTA)
       INTER  = ((YEND+YSTA)-SLOPE*(XEND+XSTA))/2.

       STP = 1
       IF (XSTA.GT.XEND) THEN 
           NXSTA = NINT(XEND)
           NXEND = NINT(XSTA)
       ELSE
           NXSTA = NINT(XSTA)
           NXEND = NINT(XEND)
       ENDIF

       MEASUR = 0.
       NPIX   = 0

       DO  100,COL = NXSTA, NXEND

       POSY = NINT(COL*SLOPE+INTER)

       DO  50,KR = -WIDTH,WIDTH

       ROW  = POSY + KR

       IF (COL.LT.1.OR.COL.GT.NX.OR.ROW.LT.1.OR.ROW.GT.NY) GOTO 50

       NPIX  = NPIX + 1

       IF (NPIX.GT.MAXPIX) THEN
           STRING = '*** Fatal : Buffer HISTO is too small in MEASUR'
           CALL STETER (9,STRING)
       ENDIF

       PTIMA = (ROW-1)*NX + COL

       HISTO(NPIX) = IMAGE (PTIMA)

50     CONTINUE
100    CONTINUE
C
C --- 4. Sort the values
C
      IF (NPIX.EQ.1) THEN
          MEASUR = HISTO(1)
          RETURN
      ENDIF

150   CONTINUE
      FLAG = (.FALSE.)
      DO 200 KC = 1, NPIX-1
         IF (HISTO(KC).GT.HISTO(KC+1)) THEN
             BUFFER = HISTO (KC+1)
             HISTO(KC+1) = HISTO(KC)
             HISTO(KC)   = BUFFER
             FLAG = (.TRUE.)
         ENDIF
200    CONTINUE
       IF (FLAG) GOTO 150
C
C --- 5.a) Return the MINIMUM if desired
C
       IF (MMODE.EQ.1) THEN
          MEASUR = HISTO(1)
          RETURN
       ENDIF
C
C --- 5.b) Define the median value
C
       IF (2*NINT(NPIX/2.).EQ.NPIX) THEN
            MEDMIN = NPIX/2
            MEDMAX = NPIX/2 + 1
            MEASUR = (HISTO(MEDMIN)+HISTO(MEDMAX))/2.
       ELSE
            MEDMIN = (NPIX-1)/2+1
            MEASUR = HISTO(MEDMIN)
       ENDIF

       RETURN
       END

C @(#)conts3.for	19.1 (ES0-DMD) 02/25/03 13:29:42
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE CONTS3(A,MX,NX,NY,H,D,K1G,M1)
C++++++++++++
C     ROUTINE FOR PLOTTING CONTOURS OF A TABULETED FUNCTION
C
C     A = INPUT MATRIX OF DIMENSION A(MX,NY)
C     NX= NUMBER OF POINTS USED IN X-DIRECTION, .LE. MX
C     H = LEVEL OF CONTOURS
C     D =MESH SIZE IN PLOTTER UNITS
C-----------------
      IMPLICIT  NONE
      REAL      A(1)
      INTEGER   MX
      INTEGER   NX
      INTEGER   NY
      REAL      H
      REAL      D
      INTEGER   K1G
      INTEGER   M1
C
      INCLUDE   'MID_INCLUDE:IDIDEV.INC'
      INCLUDE   'MID_INCLUDE:IDIMEM.INC'
C
      INTEGER   I, IN, INEXT, IST, IX, ITM, IKX
      INTEGER   NP, N1
      INTEGER   J, JFOR, JNB, JM, JX, JM1, JABS
      INTEGER   L, LDA, LDB
      INTEGER   K, KX
      INTEGER   JA(3,2)
      INTEGER   MXR
      INTEGER   LX(1000)
      INTEGER   IX2(1000), IY2(1000)
      INTEGER   ERRCOD,WHITE
      REAL      ADN, AH
      REAL      X, Y
      REAL      PX
      CHARACTER STRING*80
C
      DATA      PX/0.5/,WHITE/2/
  999 FORMAT('*** WARNING: Error in CONTS3 - PL',I5)
C
      IX  = 0
      MXR = MX*(NY-1)
      N1  = NX-1
C
C *** tabulating mesh points . . . begin
      DO 100 JX = 2,N1
         DO 200 JM = JX,MXR,MX
            J  = JM+MX
            AH = A(J)-H
            IF (AH) 60,60,61
 60         IF (A(JM)-H) 62,62,1
 61         IF (A(JM)-H)  1,1,63
  1         IX     =  IX+1
            LX(IX) = -J
            IF (AH) 62,62,63
 62         IF (A(J-1)-H) 200,200,4
 63         IF (A(J-1)-H) 4,4,200
  4          IX     =  IX+1
            LX(IX) = J
200      CONTINUE
100   CONTINUE
C
      DO 300 JM = NX,MXR,MX
         J  = JM+MX
         AH = A(J)-H
         IF (AH) 64,64,65
 64      IF (A(J-1)-H) 66,66,76
 65      IF (A(J-1)-H) 76,76,67
 76      IX     = IX+1
         LX(IX) = J
         IF (AH) 66,66,67
 66      IF (A(JM)-H) 300,300,78 
 67      IF (A(JM)-H) 78,78,300
 78      IX     =IX+1
         LX(IX) = -J
300   CONTINUE
C
      DO 400 JM=1,MXR,MX
         J = JM+MX
         IF (A(J)-H) 68,68,69
 68      IF (A(JM)-H) 400,400,71
 69      IF (A(JM)-H) 71,71,400
 71      IX     = IX+1
         LX(IX) = -J
400   CONTINUE
C
      DO 500 J=2,NX
         IF (A(J)-H) 58,58,59
 58      IF (A(J-1)-H) 500,500,72
 59      IF (A(J-1)-H) 72,72,500
 72      IX     = IX+1
         LX(IX) = J
500   CONTINUE
C
C *** tabulating mesh points . . . end
      IF (IX) 50,50,8
  8   IN=IX
C 
C *** start on a new line
      NP   = 0
      JFOR = 0
      LDA  = 1
      LDB  = 2
 30   JX   = LX(IN)
C
C *** interploation to neigbouring point
      IF (JX) 21,22,22
 21   JABS = -JX
      JNB  = JABS-MX
      GO TO 23
 22   JABS = JX
      JNB  = JABS-1
 23   ADN=A(JABS)-A(JNB)
      IF (ADN) 24,9,24
 24   PX   = (A(JABS)-H)/ADN
  9   KX   = (JABS-1)/MX
      IKX  = JABS-MX*KX-1
      IF (JX)25,26,26
C
C *** evaluation of coordinates
 25   X    = (IKX)*D
      Y    = D*(KX-PX)+K1G
      GO TO 27
 26   X    = D*(IKX-PX)
      Y    = D*KX+K1G
 27   CONTINUE
C
C *** plotting is done here
      NP      = NP+1
      IX2(NP) = X
      IY2(NP) = Y
C
C *** start looking for next point
      ITM     = 1
      JM1     = MX
      IF (JX) 10,10,11
  10  JM1     = -1
  11  JA(1,1) = JX+JM1
      JA(2,1) = -JA(1,1)
      JA(3,1) = -JX+1-MX
      JA(3,2) = -JX
      JA(1,2) = JX-JM1
      JA(2,2) = JA(3,1)+JM1
      IF (KX) 14,14,39
  39  IF (IKX) 14,14,36
  36  IF (IKX+1-NX) 35,37,37
  37  IF (JX)   38,38,35
  35  IF (JFOR) 28,29,28
  28  DO 600 I=1,3
         IF (JFOR-JA(I,2)) 600,14,600
 600  CONTINUE
C
  38  LDA = 2
      GO TO 15
  14  LDA =1
  15  LDB = LDA
  29  DO 700 K=1,3
         DO 800 L=LDA,LDB
            DO 900 I=1,IX
               IF (LX(I)-JA(K,L)) 900,17,900
 900        CONTINUE
            GO TO 800
  17        CONTINUE
            ITM=ITM+1
            INEXT=I
            IF (JFOR) 19,33,19
  33        CONTINUE
            GO TO (800,800,20), ITM
 800     CONTINUE
 700  CONTINUE
C
  19  CONTINUE
      LX(IN) = 0
      GO TO (6,20,20),ITM
  20  CONTINUE
      JFOR   = JX
      IN     = INEXT
      GO TO 30
C
C *** end of a line. look for another
   6  CONTINUE
      CALL IIGPLY(QDSPNO,QOVCH, IY2, IX2, NP, WHITE, 1, ERRCOD)
      IF (ERRCOD .NE. 0) THEN
         WRITE (STRING,999) ERRCOD
         CALL STTPUT(STRING,IST)
      END IF
C   
  31  IF (LX(IX)) 8,7,8
   7  IX = IX-1
      IF (IX) 51,51,31
  51  CONTINUE
C
C *** raise pen before exit from routine
  50  RETURN
      END

C @(#)necavmed.for	19.1 (ES0-DMD) 02/25/03 14:20:21
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C @(#)necavmed.for	19.1 (ESO)   02/25/03    14:20:21
C
C+
C.COPYRIGHT: Copyright (c) 1991 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0          23-JULY-1991
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: P.BALLESTER
C
C.IDENTIFICATION
C
C.KEYWORDS
C
C  ECHELLE, CASPEC, BLAZE FUNCTION
C
C.PURPOSE
C
C  COMPARE SUCCESSIVE ORDERS TO GET THE MEDIAN AND AVERAGE BLAZE FUNCTION
C  
C.ALGORITHM
C
C  IN DEVELOPMENT ...
C
C.INPUT/OUTPUT
C
C-
      PROGRAM AVEMED

      IMPLICIT  NONE

      INTEGER   NAXISA,NPIXA(2),IAV,STAT,ACTVAL,MAXORD
      INTEGER*8   PNTRA,PNTRB
      INTEGER   IMNOA,IMNOB
      INTEGER   KNULL,KUNIT(1)
      INTEGER   MADRID(1)

      PARAMETER (MAXORD=500)

      CHARACTER FRAMEA*60,FRAMEB*60
      CHARACTER CUNIT*64,IDENTA*72

      INTEGER          ORDSTA(MAXORD),ORDEND(MAXORD),DELTAY
      REAL             THRES
      DOUBLE PRECISION STEPA(2),STARTA(2)

      INCLUDE 'MID_INCLUDE:st_def.inc'

      COMMON /VMR/ MADRID

      INCLUDE 'MID_INCLUDE:st_dat.inc'

      CALL STSPRO('AVEMED')


      CALL STKRDC('IN_A',1,1,60,IAV,FRAMEA,KUNIT,KNULL,STAT)

      CALL STIGET(FRAMEA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +            2,NAXISA,NPIXA,STARTA,STEPA,IDENTA,CUNIT,
     +            PNTRA,IMNOA,STAT)

      IF (NPIXA(2).LT.MAXORD) THEN

          CALL STDRDI(IMNOA,'ORDSTA',1,NPIXA(2),ACTVAL,ORDSTA,
     +                                       KUNIT,KNULL,STAT)
          CALL STDRDI(IMNOA,'ORDEND',1,NPIXA(2),ACTVAL,ORDEND,
     +                                       KUNIT,KNULL,STAT)

      ELSE

          CALL STETER(10,'Buffer overflow in AVEMED.')

      ENDIF

      CALL STKRDC('OUT_A',1,1,60,IAV,FRAMEB,KUNIT,KNULL,STAT)

      CALL STIPUT(FRAMEB,D_R4_FORMAT,F_IO_MODE,F_IMA_TYPE,
     +            NAXISA,NPIXA,STARTA,STEPA,IDENTA,CUNIT,
     +            PNTRB,IMNOB,STAT)

      CALL STKRDI('INPUTI',1,1,IAV,DELTAY,KUNIT,KNULL,STAT)


      IF (DELTAY.GT.0) THEN

         CALL STKRDR('INPUTR',1,1,IAV,THRES,KUNIT,KNULL,STAT)

         CALL MEDIAN(MADRID(PNTRA),NPIXA(1),NPIXA(2),MADRID(PNTRB),
     +            ORDSTA,ORDEND,DELTAY,THRES)

      ELSE 

         CALL AVERAGE(MADRID(PNTRA),NPIXA(1),NPIXA(2),MADRID(PNTRB),
     +            ORDSTA,ORDEND)

      ENDIF

      CALL STSEPI

      END

C ======================Median Filtering====================

      SUBROUTINE MEDIAN(INPFRAM,NX,NY,OUTFRAM,ORDSTA,ORDEND,
     +                  DELY,THRES)

      IMPLICIT   NONE

      INTEGER    NX,NY,DELY,ROW,COL
      INTEGER    ORDSTA(NY),ORDEND(NY)

      REAL       INPFRAM(NX,NY),OUTFRAM(NX,NY),THRES,RATIO

      INTEGER    STAMIN,STAMAX,ENDMIN,ENDMAX
      INTEGER    ROWINF,ROWSUP,FLAG,ROWCUR,Y
      REAL       TRANS,BUFFER(-50:50)

      IF (DELY.GT.50) THEN

         CALL STETER(9,'Width too big in AVEMED. Limited to 50.')

      ENDIF

C --- Initialisations

      STAMIN = ORDSTA(1)
      STAMAX = ORDSTA(1)
      ENDMIN = ORDEND(1)
      ENDMAX = ORDEND(1)
      ROWINF = 0
      ROWSUP = 0

      DO 5  ROW = 1,NY

             IF (ORDSTA(ROW).LT.STAMIN) STAMIN = ORDSTA(ROW)
             IF (ORDSTA(ROW).GT.STAMAX) STAMAX = ORDSTA(ROW)
             IF (ORDEND(ROW).LT.ENDMIN) ENDMIN = ORDEND(ROW)
             IF (ORDEND(ROW).GT.ENDMAX) ENDMAX = ORDEND(ROW)

5     CONTINUE

      DO 10  COL = 1,NX

C --- Find out what is ROWINF and ROWSUP for column COL
C --- This part is easier to program with a DO WHILE. Consider C language.

      IF (COL.GE.STAMAX.AND.COL.LE.ENDMIN) THEN

          ROWINF = 1
          ROWSUP = NY

      ELSE IF (COL.LT.STAMAX) THEN

          ROWINF = 0
          ROWSUP = 0
          DO 20  ROW = 1,NY
             IF (ORDSTA(ROW).LT.COL.AND.ROWINF.EQ.0)  ROWINF = ROW
20        CONTINUE
          DO 25  ROW = NY,1,-1
             IF (ORDSTA(ROW).LT.COL.AND.ROWSUP.EQ.0)  ROWSUP = ROW
25        CONTINUE

      ELSE IF (COL.GT.ENDMIN) THEN

          ROWINF = 0
          ROWSUP = 0
          DO 30  ROW = 1,NY
             IF (ORDEND(ROW).GT.COL.AND.ROWINF.EQ.0)  ROWINF = ROW
30        CONTINUE
          DO 35  ROW = NY,1,-1
             IF (ORDEND(ROW).GT.COL.AND.ROWSUP.EQ.0)  ROWSUP = ROW
35        CONTINUE

      ENDIF

C --- Fill in the buffer with defined values, prolonging the frame by a
C --- mirror effect.

      DO 40 ROW = ROWINF,ROWSUP

         DO 50 Y = (-1)*DELY , DELY

             ROWCUR = ROW+Y

             IF (ROWCUR.LT.ROWINF)
     +               BUFFER(Y) = INPFRAM(COL,2*ROWINF-ROWCUR)

             IF (ROWCUR.GT.ROWSUP)
     +           BUFFER(Y) = INPFRAM(COL,2*ROWSUP-ROWCUR)

             IF (ROWCUR.GE.ROWINF.AND.ROWCUR.LE.ROWSUP)
     +           BUFFER(Y) = INPFRAM(COL,ROWCUR)

50       CONTINUE

C ---    Sort the buffer values and get the median value.
C ---    Consider using HeapSort algorithm (Numerical Recipes)

60       CONTINUE

         FLAG = 0

         DO 70 Y = (-1)*DELY , DELY-1

            IF (BUFFER(Y).GT.BUFFER(Y+1)) THEN
                TRANS = BUFFER(Y)
                BUFFER(Y) = BUFFER(Y+1)
                BUFFER(Y+1) = TRANS
                FLAG = 1
            ENDIF

70       CONTINUE

         IF (FLAG.NE.0) GOTO 60

         RATIO = (INPFRAM(COL,ROW)-BUFFER(0))/(INPFRAM(COL,ROW)
     +                                                   +BUFFER(0))

         IF (ABS(RATIO).GT.THRES)   THEN
                 OUTFRAM(COL,ROW) = BUFFER(0)
         ELSE
                 OUTFRAM(COL,ROW) = INPFRAM(COL,ROW)
         ENDIF

40    CONTINUE
10    CONTINUE

      RETURN
      END

C ====================== Average ====================

      SUBROUTINE AVERAGE(INPFRAM,NX,NY,OUTFRAM,ORDSTA,ORDEND)

      IMPLICIT   NONE

      INTEGER    NX,NY,ROW,COL
      INTEGER    ORDSTA(NY),ORDEND(NY)

      REAL       INPFRAM(NX,NY),OUTFRAM(NX,NY)

      INTEGER    STAMIN,STAMAX,ENDMIN,ENDMAX
      INTEGER    ROWINF,ROWSUP,CNT
      REAL       SUM

      DO 5  ROW = 1,NY

             IF (ORDSTA(ROW).LT.STAMIN) STAMIN = ORDSTA(ROW)
             IF (ORDSTA(ROW).GT.STAMAX) STAMAX = ORDSTA(ROW)
             IF (ORDEND(ROW).LT.ENDMIN) ENDMIN = ORDEND(ROW)
             IF (ORDEND(ROW).GT.ENDMAX) ENDMAX = ORDEND(ROW)

5     CONTINUE

      DO 10  COL = 1,NX

C --- Find out what is ROWINF and ROWSUP for column COL
C --- This part is easier to program with a DO WHILE. Consider C language.

      IF (COL.GE.STAMAX.AND.COL.LE.ENDMIN) THEN

          ROWINF = 1
          ROWSUP = NY

      ELSE IF (COL.LT.STAMAX) THEN

          ROWINF = 0
          ROWSUP = 0
          DO 20  ROW = 1,NY
             IF (ORDSTA(ROW).LT.COL.AND.ROWINF.EQ.0)  ROWINF = ROW
20        CONTINUE
          DO 25  ROW = NY,1,-1
             IF (ORDSTA(ROW).LT.COL.AND.ROWSUP.EQ.0)  ROWSUP = ROW
25        CONTINUE

      ELSE IF (COL.GT.ENDMIN) THEN

          ROWINF = 0
          ROWSUP = 0
          DO 30  ROW = 1,NY
             IF (ORDEND(ROW).GT.COL.AND.ROWINF.EQ.0)  ROWINF = ROW
30        CONTINUE
          DO 35  ROW = NY,1,-1
             IF (ORDEND(ROW).GT.COL.AND.ROWSUP.EQ.0)  ROWSUP = ROW
35        CONTINUE

      ENDIF

C --- Fill in the buffer with defined values, prolonging the frame by a
C --- mirror effect.

      SUM = 0.
      DO 40 ROW = ROWINF,ROWSUP

          SUM = SUM + INPFRAM(COL,ROW)

40    CONTINUE

      CNT = ROWSUP - ROWINF + 1
      SUM = SUM/CNT

      DO 50 ROW = 1,NY

         OUTFRAM(COL,ROW) = SUM

50    CONTINUE
10    CONTINUE

      RETURN
      END

C===========================================================================
C Copyright (C) 1995,2004 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987,2004 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  16:48 - 19 NOV 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION
C
C  program TDTSTAT.FOR
C
C.PURPOSE
C
C  Execute the command
C  STAT/TABLE table column-ref [step [min-val  [max-val]]] LOG10
C
C.KEYWORDS
C
C  histogram, table
C
C.ALGORITHM
C
C  use table interface routines
C
C
C.VERSION
C 04021	last modif
C
C-----------------------------------------------------------
C
      SUBROUTINE TDSTAT
      IMPLICIT NONE
C
      LOGICAL TRIV
C
      INTEGER IOUT(2), ISTAT
      INTEGER PARVAL, NPAR, TID, NROW, NCOL, NSC, NAC, NAR
      INTEGER IFREQ(512)
      INTEGER I, II, II1, II2, DUMMY, NVALS, ICOL
      INTEGER IAC, NACT, INS, IX, NNN, NBINS, IDUMMY, LL
      INTEGER DUNIT
      INTEGER INDEX
      INTEGER TINULL
      INTEGER KUN, KNUL, DTYPE
C
      REAL TRNULL
      REAL TSTAT(8),XMEAN,XSTD
      REAL CR,STEP,X0,X1,XT,AXMAX,AXMIN
      REAL CINT(512),XMIN,XMAX
      REAL ROUT(4),RPAR(4)
C
      DOUBLE PRECISION TDNULL, DXMIN, DXMAX
C
      CHARACTER*16 LABEL
      CHARACTER*16 MSG
      CHARACTER*80 TABLE, LINE
      CHARACTER*17 COLREF
      CHARACTER*80 WORK
      CHARACTER*10 DESNA1, DESNA2, DESNA3
      CHARACTER*4  WS,COMLIN
      CHARACTER*8  TYPE,FORM
C
      INCLUDE 'MID_INCLUDE:TABLES.INC'
      INCLUDE 'MID_INCLUDE:TABLED.INC'
      DATA PARVAL/7/
      DATA DESNA1/'TSTATxxx  '/
      DATA DESNA2/'TCLASxxx  '/
      DATA DESNA3/'TFREQxxx  '/
      DATA MSG/'ERR:TSTATTBLxxxx'/
C
C ... GET MACHINE CONSTANTS
C
      CALL TBMNUL(TINULL, TRNULL, TDNULL)
C
C ... get input parameters + default
C
      CALL TDPGET(PARVAL,NPAR,ISTAT)
      IF (ISTAT.NE.0) GO TO 3000
      TABLE   = TPARBF(1)
      COLREF  = TPARBF(2)
      RPAR(2) = TRNULL
      RPAR(3) = RPAR(2)
      RPAR(1) = 0.0
C 
      IF (NPAR .GE. 3) THEN
         II1 = 1
         DO 10, II2 = 3,NPAR
            II     = INDEX(TPARBF(II2),' ') - 1
            WORK   = TPARBF(II2) (1:II)
            IF (WORK(1:1).NE.'L' .AND. WORK(1:1).NE.'?') THEN
               CALL GENCNV(WORK,2,1,IDUMMY,RPAR(II1),DUMMY,NVALS)
               II1    = II1 + 1
               IF (NVALS.NE.1) THEN
                  CALL STTPUT('Invalid input param. ...',ISTAT)
                  GO TO 3000
               ENDIF
            ENDIF
10       CONTINUE
      ENDIF
C 
      STEP   = RPAR(1)
      AXMIN  = RPAR(2)
      AXMAX  = RPAR(3)
C
C ... init input table
C
      TID = -1
      CALL TBTOPN(TABLE,F_U_MODE,TID,ISTAT)
      CALL TBIGET(TID,NCOL,NROW,NSC,NAC,NAR,ISTAT)
      IF (NROW.EQ.0) THEN
          CALL STTPUT(' Table empty ...',ISTAT)
          GO TO 3000
      ENDIF
C
C ... find input column
C
      CALL TBCSER(TID,COLREF,ICOL,ISTAT)
      IF (ICOL.EQ.-1) THEN
          CALL STTPUT('Column not found...',ISTAT)
          GO TO 3000
      ENDIF
      CALL TBFGET(TID,ICOL,FORM,LL,DTYPE,ISTAT)
      IF (DTYPE.EQ.D_C_FORMAT) THEN
          CALL STTPUT('Error, Column of type Character',ISTAT)
          GO TO 3000
      ENDIF
C
C ... build the grid
C
      IF (DTYPE.EQ.D_R8_FORMAT) THEN
          CALL TDMXDS(TID,ICOL,NROW,0,DXMIN,DXMAX)
          TYPE = 'R*8'
          XMIN = DXMIN
          XMAX = DXMAX
      ELSE IF (DTYPE.EQ.D_R4_FORMAT) THEN
          CALL TDMXRS(TID,ICOL,NROW,0,XMIN,XMAX)
          TYPE = 'R*4'
      ELSE
          CALL TDMXIS(TID,ICOL,NROW,0,XMIN,XMAX)
          IF (DTYPE.EQ.D_I1_FORMAT) THEN
              TYPE = 'I*1'
          ELSE IF (DTYPE.EQ.D_I2_FORMAT) THEN
              TYPE = 'I*2'
          ELSE
              TYPE = 'I*4'
          END IF
      ENDIF
C 
      IF (XMAX.LE.(XMIN+STEP)) THEN
          XMAX = XMIN + STEP
          IF (XMIN.GE.XMAX) THEN
             CALL STTPUT
     2       ('WARNING: XMAX = XMIN; increased XMAX by 1.0',ISTAT)
             XMAX = XMIN + 1
          ENDIF
          TRIV = .TRUE.
      ELSE
          TRIV = .FALSE.
      ENDIF
C 
      CALL TDSCAL(XMIN,XMAX,1.,X0,X1,IX,XT,NNN)
      IF (NNN .LE. 0) THEN                      !no dynamic range...
         XMEAN = XMIN
         XSTD = 0
         NBINS = 1
         NACT = 1
         GOTO 1000
      ENDIF
C 
      IF (AXMIN.EQ.TRNULL) THEN
          AXMIN  = X0*10.**IX
      END IF
      IF (AXMAX.EQ.TRNULL) THEN
          AXMAX  = X1*10.**IX
      END IF
      IF (STEP.LE.0.0) STEP = XT
C 
      NBINS  = (AXMAX-AXMIN)/STEP + 2
      NBINS  = MIN(NBINS,512)
      CR     = AXMIN
      CINT(1) = CR
      DO 20, I = 1,NBINS - 2
         CR = CR + STEP
         CINT(I+1) = CR
20    CONTINUE
C
C ... frequency analysis
C
      IF (DTYPE.EQ.D_R8_FORMAT) THEN
          CALL TDDSTA(TID,ICOL,NROW,NBINS,1,CINT,
     +                IFREQ,NACT,XMEAN,XSTD)
      ELSE IF (DTYPE.EQ.D_R4_FORMAT) THEN
          CALL TDRSTA(TID,ICOL,NROW,NBINS,1,CINT,
     +                IFREQ,NACT,XMEAN,XSTD)
      ELSE
          CALL TDISTA(TID,ICOL,NROW,NBINS,1,CINT,
     +                IFREQ,NACT,XMEAN,XSTD)
      ENDIF
      IF (TRIV) XMAX = XMIN
C 
      IF (NACT.EQ.0) 
     +   CALL STTPUT(' No selected entries or empty column',ISTAT)
C
C ... write results as descriptors
C
1000  INS = 1000 + ICOL
      WRITE (WS,9000) INS
      DESNA1(6:8) = WS(2:4)
      DESNA2(6:8) = WS(2:4)
      DESNA3(6:8) = WS(2:4)
      CALL STKRDC('MID$CMND',1,1,4,IAC,COMLIN,KUN,KNUL,ISTAT)
C
C ... STATISTIC/TABLE
C
      IF (COMLIN(1:4).EQ.'STAT') THEN
          LINE =  'Table : '//TABLE
          CALL STTPUT(LINE,ISTAT)
          WRITE (WORK,9000) ICOL
          CALL TBLGET(TID,ICOL,LABEL,ISTAT)
          LINE = 'Column #'//WORK(1:4)//' Label :'//LABEL//
     +           ' Type :'//TYPE
          CALL STTPUT(LINE, ISTAT)
          WRITE (WORK,9020) NROW,NACT
          CALL STTPUT(WORK,ISTAT)
          WRITE (WORK,9030) XMIN,XMAX
          CALL STTPUT(WORK,ISTAT)
          WRITE (WORK,9040) XMEAN,XSTD
          CALL STTPUT(WORK,ISTAT)
      ELSE
          TSTAT(1) = 1.
          TSTAT(2) = NACT
          TSTAT(3) = XMEAN
          TSTAT(4) = XSTD
          TSTAT(5) = XMIN
          TSTAT(6) = XMAX
          TSTAT(7) = NBINS
          TSTAT(8) = 0.
          CALL STDWRR(TID,DESNA1,TSTAT,1,8,DUNIT,ISTAT)
          IF (ISTAT.NE.0) GO TO 3000
          CALL STDWRR(TID,DESNA2,CINT,1,NBINS,DUNIT,ISTAT)
          IF (ISTAT.NE.0) GO TO 3000
          CALL STDWRI(TID,DESNA3,IFREQ,1,NBINS,DUNIT,ISTAT)
          IF (ISTAT.NE.0) GO TO 3000
      ENDIF
      IOUT(1) = ICOL
      IOUT(2) = NACT
      ROUT(1) = XMIN
      ROUT(2) = XMAX
      ROUT(3) = XMEAN
      ROUT(4) = XSTD
      CALL STKWRI('OUTPUTI',IOUT,1,2,KUN,ISTAT)
      CALL STKWRR('OUTPUTR',ROUT,1,4,KUN,ISTAT)
C
C ... end
C
      CALL TBTCLO(TID,ISTAT)
3000  IF (ISTAT.NE.0) THEN
         WRITE (MSG(13:16),9000) ISTAT
         CALL TDERRR(ISTAT,MSG,I)
      ENDIF
      RETURN
 9000 FORMAT (I4)
 9020 FORMAT ('Total no. of entries :',I8,', selected no. of entries :',
     +       I8)
C 9030 FORMAT ('Minimum value :',E14.5,', Maximum value:',E14.5)
C 9040 FORMAT ('Mean value    :',E14.5,', Standard dev.:',E14.5)
 9030 FORMAT ('Minimum value :',g16.7,', Maximum value:',g16.7)
 9040 FORMAT ('Mean value    :',g16.8,', Standard dev.:',g16.8)
      END

C===========================================================================
C Copyright (C) 1995-2007 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================

C ++++++++++++++++++++++++  yf2cdsp.for +++++++++++++++++++++++++++++++++++++++
C .LANGUAGE Fortran 77
C .IDENTIFICATION Module yf2cdsp.for
C  AUTHOR         K. Banse
C .ENVIRONMENT    FORTRAN and C standards
C .VERSION  [1.00] 050728:  created 
C 
C 070314	last modif
C -----------------------------------------------------------------------------
C
      SUBROUTINE TSCOLOR(CBUF,COLOR)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   CBUF
      INTEGER     COLOR
C 
      CALL STSTR(1,CBUF)			!STRIPPED_STRING
      CALL DAZ1(COLOR)
C 
      RETURN
      END


      SUBROUTINE ALPTXC(CBUF,XP,YP,COLO)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   CBUF
      INTEGER   XP,YP,COLO
C
      CALL STSTR(1,CBUF)                  !STRIPPED_STRING
      CALL DAZ2(XP,YP,COLO)
C
      RETURN
      END

      SUBROUTINE ALPTXT(CBUF,NA,NB,COLO)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   CBUF
      INTEGER   NA,NB,COLO
C
      CALL STSTR(1,CBUF)                  !STRIPPED_STRING
      CALL DAZ3(NA,NB,COLO)
C
      RETURN
      END


      SUBROUTINE BLDGRA(SHAPE,COORDS,ARCS,XFIG,YFIG,FIGMAX,NOP)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   SHAPE
      INTEGER     COORDS(*),XFIG(*),YFIG(*),FIGMAX,NOP
      REAL        ARCS(*)
C 
      CALL STSTR(1,SHAPE)                  !STRIPPED_STRING
      CALL DAZ4(COORDS,ARCS,XFIG,YFIG,FIGMAX,NOP)
C
      RETURN
      END


      SUBROUTINE GETCUR(ACTION,FRAME,ICUR1,FP1,WC1,VAL1,STAT1,
     +                         ICUR2,FP2,WC2,VAL2,STAT2)
C
      IMPLICIT NONE
C
      CHARACTER*(*) ACTION, FRAME
      INTEGER     ICUR1(*),STAT1,ICUR2(*),STAT2
      REAL        FP1(*), FP2(*), WC1(*), WC2(*), VAL1, VAL2
C 
      CALL STSTR(1,ACTION)                !STRIPPED_STRING
      CALL STLOC(1,0,FRAME)               !untouched CHAR_LOC
C 
      CALL DAZ5(ICUR1,FP1,WC1,VAL1,STAT1,ICUR2,FP2,WC2,VAL2,STAT2)
C
      RETURN
      END

      SUBROUTINE GETSTR( OUTSTR, DIM )
      IMPLICIT NONE
C
      CHARACTER*(*) OUTSTR
      INTEGER     DIM
C
      CALL STLOC(1,1,OUTSTR)                 !blanked CHAR_LOC
      CALL DAZ6(DIM)
C
      RETURN
      END


      SUBROUTINE WRITT(DSPLAY,CHAN,NITT,ISTA,COUNT,RITT,IDST)
C
      IMPLICIT NONE
C
      INTEGER     DSPLAY,CHAN,NITT,ISTA,COUNT,IDST
      REAL        RITT(*)
C
      CALL DAZ7(DSPLAY,CHAN,NITT,ISTA,COUNT,RITT,IDST)
C
      RETURN
      END

      SUBROUTINE RDITT(DSPLAY,CHAN,NITT,ISTA,COUNT,RITT,IDST)
C
      IMPLICIT NONE
C
      INTEGER     DSPLAY,CHAN,NITT,ISTA,COUNT,IDST
      REAL        RITT(*)
C
      CALL DAZ8(DSPLAY,CHAN,NITT,ISTA,COUNT,RITT,IDST)
C
      RETURN
      END


      SUBROUTINE PIXXCV(CFLAG,IMNO,RBUFF,STAT)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   CFLAG
      INTEGER     IMNO, STAT
      REAL        RBUFF(*)
C
      CALL STSTR(1,CFLAG)                  !STRIPPED_STRING
C 
      CALL DAZ9(IMNO,RBUFF,STAT)
C
      RETURN
      END

C @(#)pranlz.for	19.1 (ES0-DMD) 02/25/03 13:25:37
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine PRANLZ         version 2.7       830922
C  A. Kruszewski             ESO Garching
C  modified for FX           version 2.9       870315
C  A. Kruszewski             Obs. de Geneve
C  modified for MSDOS        version 4.0       880626
C  A. Kruszewski             Warsaw U. Obs.
C.KEYWORDS
C  profiles positions classifiers
C.PURPOSE
C  this subroutine calculates at first an image profile in eight
C  octants. it removes contributions from blended objects and
C  uses a cleaned profile for calculating corrections to the position,
C  elongations, position angle
C.INPUT/OUTPUT
C  input arguments
C  A         real*4 array        image frame
C  N1        integer*4 array     x-dimension of an array A
C  N2        integer*4           y-dimension of an array
C  ID        integer*4           object identification number
C  M         integer*4           number of objects at start of approximation
C  M0        integer*4           initial number of objects
C  MM        integer*4           actuall number of objects
C  IARR      integer*4 array     integer values of keywords
C  RARR      real*4 array        real values of keywords
C  NPAS      integer*4           number of iteration
C  NCAT      integer*4 array     array with integer parameters
C  PRCT      real*4 array        array with one-dimensional profiles
C  PMTR      real*4 array        array holding classifiers
C  output arguments
C  MM        integer*4           actuall number of objects
C  NCAT      integer*4 array     array with integer parameters
C  PRCT      real*4 array        array with one-dimensional profiles
C  PMTR      real*4 array        array holding classifiers
C  MCM       integer*4 array     array holding informations about
C-----------------------------------------------------------------------
      SUBROUTINE PRANLZ(A, JAPY, NX, ITOB, IXYU,
     &                  IBUF, L0, L1, LW, ID,
     &                  M, M0, MM , LSTP, NREG,
     &                  IARR, RARR, APSF, FPSF, IPSF,
     &                  NPAS, NCAT, PMTR, PRCT,
     &                  IAVDIS, MCM)
C
      IMPLICIT  NONE
      INCLUDE  'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER   NREG
      INTEGER   I , IARR(32) , IAVDIS , IAVR(0:MAXSUB)
      INTEGER   IBUF(4) , IBUFS(4) , IC , ICNT(8,0:MAXSUB)
      INTEGER   ID , IDB , IDIF , IDLM , IHED , IK
      INTEGER   IPSF(1) , ISOP , ITT , ITOB(4) , IVRF , IXYU(4)
      INTEGER   J , JAPY(1) , JAPYS(2*MAXSUB+1) , JHED , JK
      INTEGER   K , KM , KMM , KN
      INTEGER   L0 , L1 , LDBG , LHED , LIM , LIM1 , LPXL
      INTEGER   LSBP , LSTP(0:4,0:NREG) , LW , LZ
      INTEGER   MAS((2*MAXSUB+1)**2)
      INTEGER   M , M0 , MCM(21) , MCM0(21) , MM , MN , MS1
      INTEGER   NCAT(NIPAR,MAXCNT) , NCT(NIPAR)
      INTEGER   NPAS, NPXL(0:MAXSUB) , NX
C     INTEGER   NP
C
      INTEGER   LHED0
      INTEGER   KHED
      INTEGER   LN
      INTEGER   II
      INTEGER   IOPC
C     INTEGER   IUSD(4)
C
      REAL      FLTR
      REAL      SIG
      REAL      SCALE
      REAL      CINT2
      REAL      A(1) , ADLM , APSF(0:MAXSUB)
      REAL      AS((2*MAXSUB+1)**2) , AVPR(0:MAXSUB)
      REAL      BGRD , CTRL(3) , DNEB , FPSF(1) , HCUT
      REAL      PMT(NRPAR) , PMTR(NRPAR,MAXCNT) , PRFL(8,0:MAXSUB)
      REAL      PRC(0:MAXSUB) , PRCT(0:MAXSUB,MAXCNT) , RARR(64)
      REAL      STMT, TRSH
      REAL      ZRMG
C
      LOGICAL   TWOD , GOOD
C
      DATA NPXL/1,8,12,16,32,28,40,40,48,68,56,72,68,88,88,84,112,
     &            112,112,116,112,144,140,144,144,168,164,160,184,172,
     &            200,192,188,208,224,224,228,224,248,236,264,248,264,
     &            276,264,288,276,304,304,312,316/
      MS1 = MAXSUB + 1
C
C ******      Restore values of keywords.
C
      LZ = ID - L0
      I = NCAT(1,LZ)
      J = NCAT(2,LZ)
      BGRD = PMTR(1,LZ)
      LDBG = IARR(1)
      IVRF = IARR(4)
      ISOP = IARR(5)
      IHED = IARR(8)
      JHED = IHED/2
      LPXL = IARR(20)
      LSBP = IARR(21)
      HCUT = RARR(2)
      TRSH = RARR(3)
      FLTR = RARR(4)
      ZRMG = RARR(11)
      STMT = RARR(12)
      CTRL(1) = RARR(39)
      CTRL(2) = RARR(40)
      CTRL(3) = RARR(41)
      ADLM = RARR(42)
      IDLM = NINT(ADLM)
      DNEB = RARR(52)
      ITT = IARR(2) + 1
      IF ( LPXL .GT. 0 .AND. LSBP .GT. 0 ) THEN
            TWOD = .TRUE.
      ELSE
            TWOD = .FALSE.
      ENDIF
C
C ******      NCAT(5,LZ) - object size.
C
      LIM = NCAT(5,LZ)
C
C ******      Most of this subroutine body may be repeated up to
C ******      4 times in a DO WHILE loop. The condition for
C ******      terminating the loop is that the image size is
C ******      sufficiently small in comparison with used subarray.
C ******      On each repeatition the size of subarray is increased.
C ******      Index variable IC controls the loop.
C
      IC = 0
      LHED = MIN( MAXSUB , MAX( IHED , LIM+5 ) )
      LHED0 = LHED
C
C ******      Main loop start here.
C
   10      CONTINUE
C
C ******          Fill image buffer if necessary.
C
c            IUSD(1) = MAX( I-LHED , IXYU(1) )
c            IUSD(2) = MAX( J-LHED , IXYU(2) )
c            IUSD(3) = MIN( I+LHED , IXYU(3) )
c            IUSD(4) = MIN( J-LHED , IXYU(4) )
c            IF ( IUSD(1) .LT. IBUF(1) .OR. IUSD(2) .LT.
c     &                        IBUF(2)      .OR. IUSD(3) .GT. IBUF(3)
c     &                              .OR. IUSD(4) .GT. IBUF(4) ) THEN
c                       CALL FILBUF( IMF , MSF , A , MA , JAPY , NX ,
c     &                                    IXYU , IUSD , IBUF )
c                 ENDIF
C
C ***     Mark saturated and bad pixels.
C
          CALL SATBAD( A , JAPY , IBUF , I , J , LHED , RARR , MAS )
C
C ******          Subtract components if not first pass.
C
          IF ( NPAS .GT. 1 ) THEN
              CALL CMPSUB( A , JAPY , IBUF , I , J ,
     &                     L0 , L1 , LW , ID , MM ,
     &                     NREG , LSTP , LHED , TRSH , APSF ,
     &                     FPSF , IPSF , LPXL , LSBP , NCAT ,
     &                     PMTR , PRCT , NPAS , AS , JAPYS ,
     &                     IBUFS , HCUT , MAS )
          END IF
C
C ***     Calculates local background when necessary.
C
          IF ( NPAS .EQ. 1 .AND. LHED .GT. LHED0 ) THEN
              CALL SKYMOD( A , JAPY , IBUF , I , J ,
     &                     CTRL , LHED , 0 , BGRD )
              PMTR(1,LZ) = BGRD
          ELSE IF ( NPAS .GT. 1 ) THEN
            CALL SKYMOD( AS , JAPYS , IBUFS , 0 , 0 ,
     &                   CTRL , LHED , 0 , BGRD )
            PMTR(1,LZ) = BGRD
          ENDIF
C
C ***     Calculate profile in eight octants PRFL.
C
          IF ( NPAS .GT. 1 ) THEN
              CALL PROFIL( AS , MAS , JAPYS , IBUFS , 0 ,
     &                     0 , LHED , LDBG , BGRD , HCUT ,
     &                     PRFL , ICNT )
          ELSE
              CALL PROFIL( A , MAS , JAPY , IBUF , I ,
     &                     J , LHED , LDBG , BGRD , HCUT ,
     &                     PRFL , ICNT )
          ENDIF
          CALL RLBIAS( PRFL , ICNT , PMTR(25,LZ) )
C
C ***     Calculate averaged over octants profile AVPR
C ***     and a number of significant profile rings LIM.
C
          CALL AVERPR( LHED , PRFL , TRSH , ICNT , AVPR ,
     &                 IAVR , NCAT(4,LZ) , NCAT(6,LZ) , LIM )
C
C ***     Clean the profile from influence of other objects.
C
          IDIF = MIN( NCAT(3,LZ) , IAVDIS )
          IF ( NPAS .EQ. 1 .AND. IARR(2) .GT. 0 ) THEN
              KHED = LHED
          ELSE
              KHED = LIM
          ENDIF
          CALL PRFLCL( PRFL , ICNT , AVPR , IAVR , KHED , BGRD , IDIF ,
     &                 LDBG , RARR , MCM0 , NCAT(4,LZ) , NCAT(6,LZ) )
C   
C ***     Update average profile AVPR and image size LIM.
C
          IF ( NCAT(4,LZ) .LT. LIM ) THEN
              CALL AVERPR( LHED , PRFL , TRSH , ICNT , AVPR ,
     &                     IAVR , NCAT(4,LZ) , NCAT(6,LZ) , LIM )
          ENDIF
          CALL INTDET( AVPR , IAVR , APSF , LIM , PMTR(2,LZ) )
C
C ***     Check if average profile goes down sufficiently fast.
C
          IF ( DNEB .GT. 0.0 ) THEN
              CALL PRFLCH( AVPR , LHED , NCAT(6,ID) , HCUT , APSF ,
     &                                          DNEB , LIM )
          ENDIF
C
C ***     Check if an image is sufficiently small
C ***     and enlarge subarray LHED when necessary.
C
          IF ( ( ( LIM .GE. LHED-2 ) .OR. ( LIM .GT. LHED-5 .AND.
     &                  AVPR(0) .GT. (HCUT-BGRD)/2.0 ) ) .AND.
     &                  LHED .LT. MAXSUB .AND. IC .LE. 2 ) THEN
C
              LHED = MIN( MAXSUB , 2*LIM )
              IC = IC + 1
          ELSE
              IC = 3
          ENDIF
          IC = IC + 1
C
C ***     Main loop end here.
C
      IF ( IC .LE. 3 ) GOTO 10
C
C **  Update entry for local background.
C
      PMTR(1,LZ) = BGRD
C
C *** Transform relative coordinates of newly found components
C *** into absolute pixel coordinates IK and JK. Form new
C *** array MCM holding informations about new objects
C
      IF ( .NOT. ( IVRF .EQ. 0 .AND. IARR(2) .EQ. 0 ) ) THEN
          KMM = 0
          DO 20 MN = 1 , 21
              MCM(MN) = 0
   20     CONTINUE
          KM = MCM0(1)
          DO 30 KN = 1 , KM
              IF ( NPAS .GT. 1 ) THEN
                  CALL CPCNTR( AS , JAPYS , IBUFS , 0 , 0 ,
     &                         MCM0(2*KN) , MCM0(2*KN+1) , IK , JK )
                  CALL IFGOOD( AS , JAPYS , IBUFS , MAS , 0 ,
     &                         0 , IK , JK , BGRD , FLTR ,
     &                         TRSH , GOOD )
                  IF ( .NOT. GOOD ) GOTO 30
                  IK = IK + I 
                  JK = JK + J
              ELSE
                  CALL CPCNTR( A , JAPY , IBUF , I , J , MCM0(2*KN) ,
     &                                    MCM0(2*KN+1) , IK , JK )
                  CALL IFGOOD( A ,JAPY , IBUF , MAS , I ,
     &                         J , IK , JK , BGRD , FLTR ,
     &                         TRSH , GOOD )
                  IF ( .NOT. GOOD ) GOTO 30
              ENDIF
              IDB = MIN( IK-ITOB(1) , ITOB(3)-IK ,
     &                              JK-ITOB(2) , ITOB(4)-JK )
              IF ( IDB .GE. JHED .AND. KMM .LT. 10 ) THEN
                  KMM = KMM + 1
                  MCM(2*KMM) = IK
                  MCM(2*KMM+1) = JK
              ENDIF
   30     CONTINUE
          MCM(1) = KMM
      ENDIF
C
C ******      Calculate image parameters.
C
      CALL FPPMTR( PRFL , ICNT , AVPR , IAVR , LHED ,
     &             LIM , NCAT(4,LZ) , NCAT(6,LZ) , ID , L0 ,
     &             TRSH , IVRF , M0 , ITT , NPAS ,
     &             NCAT , PMTR )
      DO 40 K = 0 , LIM
          PRCT(K,LZ) = AVPR(K)
   40 CONTINUE
          LIM1 = LIM + 1
      DO 50 K = LIM1 , MAXSUB
          PRCT(K,LZ) = 0.0
   50 CONTINUE
      NCAT(5,LZ) = LIM
C
C *** Calculate accurate position, evaluate contribution
C *** of central part to convolved magnitude, store data on
C *** corrections to two-dimensional point spread function.
C
      IF ( ( LPXL .GT. 0 .OR. LSBP .GT. 0 ) .AND. NPAS .GT. 1 ) THEN
          IF ( NCAT(10,LZ) .GT. 0 ) THEN
              LN = NCAT(10,LZ) - L0
              DO 60 II = 1 , NIPAR
                  NCT(II) = NCAT(II,LN)
   60         CONTINUE
              DO 70 II = 1 , NRPAR
                  PMT(II) = PMTR(II,LN)
   70         CONTINUE
              DO 80 II = 0 , MAXSUB
                  PRC(II) = PRCT(II,LN)
   80         CONTINUE
          ENDIF
          CALL TWODIM( AS , MAS , JAPYS , IBUFS , LZ ,
     &                 APSF , FPSF , IPSF , NCAT , PMTR ,
     &                 PRCT , NCT , PMT , PRC , IARR ,
     &                 RARR , SIG )
C
C ***     Subtract the object.
C
          IOPC = -1
          CALL STARSA( IOPC , AS , JAPYS , IBUFS , I ,
     &                 J , LPXL , LSBP , NCAT(1,LZ) , PMTR(1,LZ) ,
     &                 PRCT(0,LZ) , APSF , FPSF , 3 , SCALE ,
     &                 CINT2 )
C
C ***     Subtract the brightest stellar component if necessary.
C
          IF ( NCAT(10,LZ) .GT. 0 ) THEN
              CALL STARSA( IOPC , AS , JAPYS , IBUFS , I ,
     &                     J , LPXL , LSBP , NCT , PMT ,
     &                     PRC , APSF , FPSF , 3 , SCALE ,
     &                     CINT2 )
          ENDIF
          IF ( LDBG .GE. 3 ) THEN
              CALL PROFIL( AS , MAS , JAPYS , IBUFS , 0 ,
     &                     0 , LHED , LDBG , BGRD , HCUT ,
     &                     PRFL , ICNT )
          ENDIF
C
C ***     Search for additional faint objects.
C
          CALL SRHNEW( AS , MAS , JAPYS , IBUFS , LHED ,
     &                 I , J , TRSH , FLTR , BGRD ,
     &                 SIG , MCM )
      ENDIF
C
C *** Record newly found objects.
C
      IF ( ID .LE. M .AND. ( .NOT. ( IVRF .EQ. 0 .AND.
     &                              IARR(2) .EQ. 0 ) ) ) THEN
          IF ( NPAS .GT. 1 .AND. NPAS .LE. IARR(2) ) THEN
              CALL NEWOBJ( AS , JAPYS , IBUFS , 0 , 0 ,
     &                     NREG , LSTP , NCAT , PMTR , PRCT ,
     &                     ID , L0 , L1 , LW , MM ,
     &                     TRSH , ADLM , MCM )
          ELSE IF ( NPAS .EQ. 1 ) THEN
              CALL NEWOBJ( A , JAPY , IBUF , I , J ,
     &                     NREG , LSTP , NCAT , PMTR , PRCT ,
     &                     ID , L0 , L1 , LW , MM ,
     &                     TRSH , ADLM , MCM )
          ENDIF
      ENDIF
C
      RETURN
C
      END

C @(#)tdhistory.for	19.1 (ES0-DMD) 02/25/03 14:11:17
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  19:51 - 11 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C
C.IDENTIFICATION        TDHISTORY.FOR
C.KEYWORDS           TABLE, APPLICATIONS
C.ENVIRONMENT  MIDAS
C.PURPOSE
C
C
C------------------------------------------------------------------
      SUBROUTINE TDHSTR(TID,ISTAT)
C
C    HANDLING OF HISTORY
C
      IMPLICIT NONE
      INTEGER TID,ISTAT
C
      INTEGER IAC,UNO,LEN,KUN,KNUL
      CHARACTER*8 NAME
      CHARACTER*80 HISTO
C
      NAME   = 'HISTORY '
      UNO    = 1
      LEN    = 80
C
      CALL STKRDC(NAME,UNO,UNO,LEN,IAC,HISTO,KUN,KNUL,ISTAT)
C
      UNO    = -UNO
C      CALL STDWRC(TID,NAME,UNO,HISTO,UNO,LEN,KUN,ISTAT)
      RETURN

      END

C @(#)cloudemi.for	19.1 (ESO-DMD) 02/25/03 13:23:29
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
       PROGRAM EMI
C**************************************************
C       M.PIERRE 10-87                             
C                                                   
C       CALCULATION OF  A EMISSION SPECTRUM        
C                 SUM OF GAUSSIANS     (MAX 50 )       
C                       +                          
C                 POLYNIMIAL CONTINUUM (MAX DEG=5)   
C       Modified - START, STEP double precision in i/o
C 
C 990805
C**************************************************
C
       IMPLICIT NONE
C
       CHARACTER*60 IMA,TBL
       CHARACTER*72 IDENT
       CHARACTER*64 CUNIT
       LOGICAL      NULL1,NULL2,NULL3,ISEL
       INTEGER      MADRID(1),TID, I1, NCARA, KUN, KNUL
       INTEGER      IST, NPIX, NGAUSS, I, NAC, NAR, IMNO
       INTEGER*8    PNTR
C 
       REAL         DIM(3),CONT(6)
       REAL         HMAX(50),POS(50),FWHM(50)
       REAL         X1, X2, X3, START, STEP
C 
       DOUBLE PRECISION DSTA, DSTP
C
       COMMON/VMR/MADRID
C
       CALL STSPRO('EMI')
C
       CALL STKRDC('IN_A',1,1,60,NCARA,IMA,KUN,KNUL,IST)
       CALL STKRDC('IN_B',1,1,60,NCARA,TBL,KUN,KNUL,IST)
       CALL STKRDR('CLDCT',1,6,NCARA,CONT,KUN,KNUL,IST)
       CALL STKRDR('CLDDIM',1,3,NCARA,DIM,KUN,KNUL,IST)
C
       START=DIM(1)
       STEP =DIM(2)
       NPIX =INT(DIM(3))
C
       I1 = 0
        IF (TBL(1:4).EQ.'NULL') THEN
           NGAUSS = 0
        ELSE
          CALL TBTOPN(TBL,0,TID,IST)
          CALL TBIGET(TID,I,NGAUSS,I,NAC,NAR,IST)
          DO 10 I=1,NGAUSS
            CALL TBSGET(TID,I,ISEL,IST)
            IF (ISEL) THEN
              CALL TBERDR(TID,I,2,X1,NULL1,IST)
              CALL TBERDR(TID,I,3,X2,NULL2,IST)
              CALL TBERDR(TID,I,4,X3,NULL3,IST)
              IF (NULL1 .OR. NULL2 .OR. NULL3) GOTO 5
                 I1        = I1 + 1
                 HMAX(I1)  = X1
                 POS(I1)   = X2
                 FWHM(I1)  = X3
5             CONTINUE
            ENDIF
10        CONTINUE
          NGAUSS = I1
        ENDIF
C
       IDENT='EMI. SPEC.'//TBL
       CUNIT= ' '
       DSTA = START
       DSTP = STEP
       CALL STIPUT(IMA,10,1,1,1,NPIX,DSTA,DSTP,IDENT,
     :                   CUNIT,PNTR,IMNO,IST)       
       CALL IMAGE(MADRID(PNTR),NPIX,STEP,START,NGAUSS,
     :             HMAX,POS,FWHM,CONT)
       CALL STSEPI
       STOP
       END
C
C ********* SOUS PROGRAMME ******************
C
       SUBROUTINE IMAGE(Y,NPIX,STEP,START,NGAUSS,
     :                    HMAX,POS,FWHM,CONT)
       INTEGER NPIX,I,NGAUSS,J
       REAL START,STEP,RAIE,WL,WWLL
       REAL Y(1),HMAX(1),POS(1),FWHM(1),CONT(1)
C
       DO 30 I=1,NPIX
          WL=START+FLOAT(I-1)*STEP
          Y(I)=CONT(1)
          WWLL=WL
          DO 10 J=2,6
             Y(I)=+Y(I)+CONT(J)*WWLL 
             WWLL=WWLL*WL
10        CONTINUE
          IF (NGAUSS.GT.0) THEN
             DO 20 J=1,NGAUSS
                RAIE=HMAX(J)*EXP(-0.69315*((2.*(POS(J)-WL)
     :               /FWHM(J))**2))
                Y(I)=RAIE+Y(I)
20           CONTINUE
          ENDIF
30     CONTINUE
C
       RETURN
       END
C

C @(#)realin.for	19.1 (ES0-DMD) 02/25/03 13:29:45
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE REALIN(NPL,NL,IY,IX,NV,A,DAT)
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION: REALIN.FOR
C.PURPOSE:        read a line of a frame
C.AUTHOR:         R. Buanonno
C.USE:            input:  NPL - number of pixel in the x direction
C                         NL  - number of pixels in the y direction
C                         IX  - start pixel to read
C                         IY  - line number to read
C                         NV  - number of pixels to read
C                 output: DAT - data array containing the pixels values
C.VERSION:        18-12-88  recoded and documented
C ---------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER  NPL
      INTEGER  NL
      INTEGER  IY
      INTEGER  IX
      INTEGER  NV
      REAL     A(NPL,NL)
      REAL     DAT(NPL)
C
      INTEGER  I, K
C
      K=0
      DO 10 I=IX,IX+NV-1
         K     = K+1
         DAT(K) = A(I,IY)
   10 CONTINUE
C
      RETURN
      END

C @(#)specenter.for	19.1 (ESO-DMD) 02/25/03 14:29:43
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM SPECEN
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  19:10 - 3 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION
C
C   PROGRAM SPECENTER
C
C.KEYWORDS
C
C   LINE CENTER
C
C.PURPOSE
C
C   LINE CENTERING. INPUT/OUTPUT IN TABLE
C
C   COMMAND
C   CENTER/method  image table EMISSION/ABSORPTION
C
C.ALGORITHM
C
C   LINE CENTER IS FOUND BY
C   MAXI/MINI       - POSITION OF THE MAXIMUM/MINIMUM VALUE  ! Not anymore
C   MOMENT          - POSITION OF THE FIRST MOMENT (Modif. P.Ballester 901127)
C   GAUSSIAN        - CENTER OF THE FITTED GAUSSIAN
C   GRAVITY         - GRAVITY CENTER OF THE 2 HIGHEST PIXELS
C                     WITH RESPECT TO THE THIRD ONE
C
C.INPUT/OUTPUT
C
C   TABLE COLUMNS :
C   :XSTART - FIRST COORD   INPUT
C   :XEND   - SECOND COORD  INPUT
C   :XCEN   - COMPUTED CENTER
C   :YSTART - IMAGE VALUE FIRST COORD   INPUT
C   :YEND   - IMAGE VALUE SECOND COORD  INPUT
C   :PEAK   - MAXIMUM VALUE
C   :YFIT   - FITTED MAXIMUM IN GAUSSIAN METHOD ONLY
C   :FWHM   - FWHM IN GAUSSIAN METHOD ONLY
C
C
C.MODIFICATIONS
C  [2.1]      INCLUDE FWHM AND FORMAT FOR NON EXISTING COLUMNS
C  [2.1]      INCLUDE :YSTART, :YEND AND :YFIT
C
C-----------------------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER   MADRID
      INTEGER   I,I1,I2,IACT,IAV,ICY,IFAIL,II1,IMETH
      INTEGER   IMODE
      INTEGER*8 IP
      INTEGER   ISI,IYCOOR,NAXIS,NCOL,NCOLS,NL
      INTEGER   NOUT,NPL,NROW,NSC
      INTEGER   NPIX(2),KUN,KNUL,IMNO,TID,NAC,NAR
      INTEGER   STATUS,IC(8)
C
      REAL VY
      REAL ACOE(4),START(2),STEP(2),VALUE(8),W1(400),W2(400)
      DOUBLE PRECISION DSTART(2), DSTEP(2)
C
      CHARACTER FRAME1*80,METH*2
      CHARACTER TABLE*80,TABUNT(8)*16,TABLAB(8)*16,IEA*1
      CHARACTER FORM(8)*6,LINE*72
      CHARACTER IDENT*72,CUNIT*48,LABEL2*16,COMLIN*80
C
      LOGICAL NULL(2),NULLY,FLAG
C
      INCLUDE  'MID_INCLUDE:TABLES.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE  'MID_INCLUDE:TABLED.INC'
C
      DATA NULLY/.FALSE./
      DATA NCOLS/6/
      DATA NOUT/4/
      DATA TABUNT/' ',' ',' ',' ',' ',' ',' ',' '/
      DATA TABLAB/'XSTART','XEND','XCEN','YSTART','YEND','PEAK',
     +     'YFIT','FWHM'/
      DATA FORM/'E13.5','E13.5','E13.5','G15.5','G15.5','G15.5','G15.5',
     +     'E13.5'/
      DATA LABEL2/'Y'/
      DATA LINE/' Column ...... not present in table '/
C
C  initialize
C
      CALL STSPRO('SPECENTER')
      CALL STKRDC('P3',1,1,1,IACT,IEA,KUN,KNUL,STATUS)
      IF (IEA.EQ.'E') THEN
          IMODE  = 1
      ELSE
          IMODE  = 0
      END IF
      CALL STKRDC('MID$CMND',1,1,80,IACT,COMLIN,KUN,KNUL,STATUS)
      METH   = COMLIN(11:12)
      IF (METH.EQ.'GA') THEN
          IMETH  = -1
          NCOLS  = 8
          NOUT   = 6
      ELSE
          IF (METH.EQ.'GR') THEN
              IMETH  = 0
          ELSE
              IMETH  = 1
          END IF
      END IF
C
C  read image
C
      CALL STKRDC('P1',1,1,80,IACT,FRAME1,KUN,KNUL,STATUS)
      CALL STIGET(FRAME1,10,0,1,2,NAXIS,NPIX,DSTART,DSTEP,IDENT,
     +            CUNIT,IP,IMNO,STATUS)
      START(1) = DSTART(1)
      START(2) = DSTART(2)
      STEP(1)  = DSTEP(1)
      STEP(2)  = DSTEP(2)
      IF (NAXIS.GT.1 .AND. NPIX(2).GT.1) THEN
          IYCOOR = 1
      ELSE
          IYCOOR = 0
          NL     = 1
          NPIX(2) = 1
      END IF
      NPL    = NPIX(1)
      ISI    = NPIX(1)*NPIX(2)
      II1    = 16*NAXIS
      TABUNT(1) = CUNIT(II1+1:II1+16)
      TABUNT(2) = TABUNT(1)
      TABUNT(3) = TABUNT(1)
      TABUNT(4) = CUNIT(1:16)
      TABUNT(5) = TABUNT(4)
      TABUNT(6) = TABUNT(4)
      TABUNT(7) = TABUNT(4)
      TABUNT(8) = TABUNT(1)
C
C  get table name for storage of data
C
      CALL STKRDC('P2',1,1,80,IACT,TABLE,KUN,KNUL,STATUS)
      CALL TBTOPN(TABLE,2,TID,STATUS)
      CALL TBIGET(TID,NCOL,NROW,NSC,NAC,NAR,STATUS)
      DO 10 IAV = 1,NCOLS
          CALL TBLSER(TID,TABLAB(IAV),IC(IAV),STATUS)
          IF (IAV.LE.2) THEN
              IF (IC(IAV).EQ.-1) THEN
                  WRITE (LINE,9000) TABLAB(IAV) (1:6)
                  CALL STTPUT(LINE,STATUS)
                  GO TO 30
              END IF
          ELSE
              IF (IC(IAV).EQ.-1) THEN
                  CALL TBCINI(TID,D_R4_FORMAT,1,FORM(IAV),TABUNT(IAV),
     +                        TABLAB(IAV),IC(IAV),STATUS)
              END IF
          END IF
   10 CONTINUE
      IF (IYCOOR.EQ.1) THEN
          CALL TBLSER(TID,LABEL2,ICY,STATUS)
          IF (ICY.EQ.-1) THEN
              WRITE (LINE,9000) ':Y     '
              CALL STTPUT(LINE,STATUS)
              GO TO 30
          END IF
      END IF
C
C  loop on input - pairs of points
C
      DO 20 I = 1,NROW
          CALL TBSGET(TID,I,FLAG,STATUS)
          IF (FLAG) THEN
              CALL TBRRDR(TID,I,2,IC,VALUE,NULL,STATUS)
              IF (IYCOOR.EQ.1) THEN
                  CALL TBERDR(TID,I,ICY,VY,NULLY,STATUS)
                  NL     = (VY-START(2))/STEP(2) + 1
              END IF
              IF ((.NOT.NULL(1)) .AND. (.NOT.NULL(2)) .AND.
     +            (.NOT.NULLY)) THEN
                  I1     = (VALUE(1)-START(1))/STEP(1) + 1
                  I2     = (VALUE(2)-START(1))/STEP(1) + 1
                  CALL FIND(MADRID(IP),NPIX(1),NPIX(2),
     +                      START,STEP,NL,I1,
     +                      I2,IMODE,IMETH,VALUE(3),VALUE(6),
     +                      IFAIL,W1,
     +                      W2,ACOE,VALUE(4),VALUE(5))
                  VALUE(7) = ACOE(1)
                  VALUE(8) = ACOE(3)
                  IF (IFAIL.EQ.0) THEN
                      CALL TBRWRR(TID,I,NOUT,IC(3),VALUE(3),
     +                            STATUS)
                  ELSE
                      CALL TBEDEL(TID,I,IC(3),STATUS)
                      CALL TBEDEL(TID,I,IC(4),STATUS)
                      CALL TBEDEL(TID,I,IC(5),STATUS)
                      CALL TBEDEL(TID,I,IC(6),STATUS)
                      IF (IMETH.EQ.-1) THEN
                          CALL TBEDEL(TID,I,IC(7),STATUS)
                          CALL TBEDEL(TID,I,IC(8),STATUS)
                      END IF
                  END IF
              ELSE
                  CALL TBEDEL(TID,I,IC(3),STATUS)
                  CALL TBEDEL(TID,I,IC(4),STATUS)
                  CALL TBEDEL(TID,I,IC(5),STATUS)
                  CALL TBEDEL(TID,I,IC(6),STATUS)
                  IF (IMETH.EQ.-1) THEN
                      CALL TBEDEL(TID,I,IC(7),STATUS)
                      CALL TBEDEL(TID,I,IC(8),STATUS)
                  END IF
              END IF
          END IF
   20 CONTINUE
C
C  exit
C
   30 CALL TBTCLO(TID,STATUS)
      CALL STSEPI
      STOP 
 9000 FORMAT (A)
      END

C @(#)bintabl.for	19.1 (ES0-DMD) 02/25/03 13:21:31
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT:  Copyright (c) 1987 European Southern Observatory,
C.                               all rights reserved
C.IDENTIFICATION: BINTBL.FOR
C.PURPOSE:    Produces table with binned averages of input table columns
C             together with some statistics. For more info see MIDAS help
C             file.
C.LANGUAGE:   F77+ESOext
C.AUTHOR:     J. Edwin Huizinga
C.ALGORITHM:  Straightforward
C.VERSION:    910109 JEH private version converted to MIDAS standards
C.VERSION:    910624 RHW include in the MIDAS applic area
C.VERSION:    910701 RHW standard fortran code
C             920908 MP correct the type of CT1 and LF1
C---------------------------------------------------------------------
      PROGRAM BINTBL
C
      IMPLICIT NONE
C
      INTEGER       MAXBIN
      INTEGER       MAXROW
      PARAMETER     (MAXBIN=1024)  ! maximum number of bins
      PARAMETER     (MAXROW=16000) ! maximum number of selected table rows
C
      INTEGER       TID
      INTEGER       J
      INTEGER       STATUS,IAV,NC,MADRID(1)
      INTEGER       COLS(5),ROW,I,IND,NVAL,IPOINT(MAXROW)
      INTEGER       NCOL,NROW,NSC,ACOL,AROW,IBIN
      INTEGER       UNIT(1),ICOL(2),TINULL,NBIN
      REAL          SUM(MAXbiN),COUNT(MAXBIN),SD(MAXBIN),sig(MAXBIN)
      REAL          VAL(2),XX(5),BINCEN(MAXBIN)
      REAL          X(MAXROW),Y(MAXROW),MEAN(MAXBIN)
      REAL          TRNULL,USRMIN,USRMAX,USRBSI
      REAL          RMIN,RMAX,DUMMY,SIGMA
      DOUBLE PRECISION TDNULL
      LOGICAL       NULL(2),FLAG
      CHARACTER*1   METHOD,STABIN
      CHARACTER*4   DEFAUL
      CHARACTER*60  TABLE
      CHARACTER*40  COLUM1,COLUM2
      CHARACTER*80  LABEL1,LABEL2,TEXT
      CHARACTER*16  UNIT1,UNIT2,FORM1
      INTEGER       CT1,LF1
C
C
C set up MIDAS:
C
      COMMON        /VMR/MADRID
      INCLUDE       'MID_INCLUDE:TABLES.INC/NOLIST'
      INCLUDE       'MID_INCLUDE:TABLED.INC/NOLIST'
C
   10 FORMAT('*** FATAL: To many selected entries, maximum: ',I6)
C
c *** start midas communications
      CALL STSPRO('BINTBL')
C
C init some values:
C
      DO I=1, MAXBIN
         SD(I)     = 0.0
         SUM(I)    = 0.0
         SIG(I)    = 0.0
         COUNT(I)  = 0
         BINCEN(I) = 0.0
      ENDDO
      CALL TBMNUL(TINULL,TRNULL,TDNULL)
      METHOD = 'A'
      STABIN = 'L'
C
C get table name, and column:
C
      CALL STKRDC('P1',1,1,60,IAV,TABLE,UNIT,NULL,STATUS)
      IF (STATUS.NE.0) THEN
         TEXT = '*** FATAL: Problems with table parameter'//TABLE
         GOTO 9000
      ENDIF
C
      CALL STKRDC('P2',1,1,40,IAV,COLUM1,UNIT,NULL,STATUS)
      CALL STKRDC('P3',1,1,40,IAV,COLUM2,UNIT,NULL,STATUS)
C
C get user binsize,min,max parameters, null if omitted
C
      USRBSI  = TRNULL
      USRMIN  = TRNULL
      USRMAX  = TRNULL
      SIGMA   = TRNULL
      CALL STKRDC('DEFAULT',1,1,4,IAV,DEFAUL,UNIT,NULL,STATUS)
      IF (DEFAUL(1:1).NE.'Y')
     +   CALL STKRDR('INPUTR',1,1,IAV,USRBSI,UNIT,NULL,STATUS)
      IF (DEFAUL(2:2).NE.'Y')
     +   CALL STKRDR('INPUTR',2,1,IAV,USRMIN,UNIT,NULL,STATUS)
      IF (DEFAUL(3:3).NE.'Y')
     +   CALL STKRDR('INPUTR',3,1,IAV,USRMAX,UNIT,NULL,STATUS)
      IF (DEFAUL(4:4).NE.'Y')
     +   CALL STKRDR('INPUTR',4,1,IAV,SIGMA,UNIT,NULL,STATUS)
C
C check user options
C
      IF ((USRMIN.NE.TRNULL).AND.(USRMAX.NE.TRNULL)) THEN
         IF (USRMAX.LT.USRMIN) THEN
            STABIN = 'U'
            DUMMY  = USRMAX
            USRMAX = USRMIN
            USRMIN = DUMMY
         ENDIF
      ENDIF
      IF ((USRBSI.NE.TRNULL).AND.(USRBSI.LT.0.0)) THEN
         METHOD = 'B'
         IBIN = INT(-1.0*USRBSI)
         IF ((USRBSI+IBIN).NE.0.0) THEN
            TEXT = '*** FATAL: Only integer bin_frequencies, dumbo'
            GOTO 9000
         ENDIF
         IF (IBIN.EQ.1) THEN
            TEXT = '*** FATAL: Binsize = 1, does not make sence, dumbo'
            GOTO 9000
         ENDIF
         USRBSI = 1.0*IBIN
      ENDIF
C
C open table, read info and labels, units, formats etc:
C
      CALL TBTOPN(TABLE,F_I_MODE,TID,STATUS)
      IF (STATUS.NE.0) THEN
         TEXT = '*** FATAL: Problems opening table:'//TABLE
         GOTO 9000
      ENDIF
C
      CALL TBIGET(TID,NCOL,NROW,NSC,ACOL,AROW,STATUS)
      IF (STATUS.NE.0) THEN
         TEXT = '*** FATAL: Problems with getting table info'//TABLE
         GOTO 9000
      ENDIF
      IF (NROW.EQ.0) THEN
         TEXT = '*** FATAL: No selected entries, or empty table'
         CALL STTPUT(TEXT,STATUS)
      ENDIF
C
      CALL TBCSER(TID,COLUM1,ICOL(1),STATUS)
      IF (STATUS.NE.0) THEN
         TEXT = '*** FATAL: Problems finding column:'//COLUM1
         GOTO 9000
      ENDIF
C
      CALL TBCSER(TID,COLUM2,ICOL(2),STATUS)
      IF (STATUS.NE.0) THEN
         TEXT = '*** FATAL: Problems finding column:'//COLUM2
         GOTO 9000
      ENDIF
C
      FORM1 = '                '
      CALL TBLGET(TID,ICOL(1),LABEL1,STATUS)
      CALL TBLGET(TID,ICOL(2),LABEL2,STATUS)
      CALL TBUGET(TID,ICOL(1),UNIT1,STATUS)
      CALL TBUGET(TID,ICOL(2),UNIT2,STATUS)
      CALL TBFGET(TID,ICOL(1),FORM1,LF1,CT1,STATUS)
C
C get min,max from table column
C
      CALL TDMXRS(TID,ICOL(1),NROW,0,RMIN,RMAX)
      IF (RMAX.EQ.RMIN) THEN
         TEXT = '*** FATAL: This is useless, column max = min'
         GOTO 9000
      ENDIF
C
C make bins, if no user defaults are given
C
      IF (USRMIN.EQ.TRNULL)  USRMIN = RMIN
      IF (USRMAX.EQ.TRNULL)  USRMAX = RMAX
      IF (USRBSI.EQ.TRNULL)  USRBSI = (USRMAX-USRMIN)/9.99
      NBIN = INT((USRMAX-USRMIN)/USRBSI)+1
      IF ((NBIN.GT.MAXBIN).AND.(METHOD.EQ.'A')) THEN
         TEXT = ' *** FATAL: To many bins, max bins= '
         WRITE(TEXT(37:42),'(I5)') MAXBIN
         GOTO 9000
      ENDIF
C
C doit:
C
      NVAL = 0
      DO ROW=1, NROW
         CALL TBSGET(TID,ROW,FLAG,STATUS)
         IF (FLAG) THEN
            CALL TBRRDR(TID,ROW,2,ICOL,VAL,NULL,STATUS)
            IF (.NOT.(NULL(1).OR.NULL(2))) THEN
               IF ((VAL(1).GE.USRMIN).AND.(VAL(1).LE.USRMAX)) THEN
                  NVAL = NVAL+1
                  IF (NVAL.GT.MAXROW) THEN
                     WRITE(TEXT,10) MAXROW
                     GOTO 9000
                  ENDIF
                  X(NVAL) = VAL(1)
                  Y(NVAL) = VAL(2)
               ENDIF
            ENDIF
         ENDIF
      ENDDO
      CALL TBTCLO(TID,STATUS)
C
C bin the data one way or the other:
C
      NBIN = 0
      IF (METHOD.EQ.'A') THEN
         DO I=1, NVAl
            IND = INT((X(I)-USRMIN)/USRBSI)+1
            IF ((IND.GT.0).AND.(IND.LE.MAXBIN)) THEN
               COUNT(IND) = COUNT(IND) + 1
               SUM(IND)   = SUM(IND) + Y(I)
               IF (IND.GT.NBIN) NBIN = IND
            ELSE
               TEXT= ' *** WARNING: This should never happen'
               CALL STTPUT(TEXT,STATUS)
            ENDIF
         ENDDO
      ELSE                       ! contant number of points per bin
C
C sort x and get rearranged indexing in ipoint
C ipoint can than be used to index y as well
C user indicates starting point by order of min,max
C
         IF (STABIN.EQ.'U') THEN
            CALL TBSRRD(X,IPOINT,NVAL,STATUS)
         ELSE
            CALL TBSRRA(X,IPOINT,NVAL,STATUS)
         ENDIF
         DO I=1, NVAL
            NBIN = INT(1.0*(I-1)/IBIN)+1
            IF (NBIN.GT.MAXBIN) THEN
               TEXT = '*** FATAL: to many bins, maximum = '
               WRITE(TEXT(36:41),'(I6)') MAXBIN
               GOTO 9000
            ENDIF
            SUM(NBIN) = SUM(NBIN)+Y(IPOINT(I))
            BINCEN(NBIN) = BINCEN(NBIN)+X(I)
         ENDDO
         DO I=1, NBIN
            COUNT(I) = IBIN
         ENDDO
         COUNT(NBIN) = MOD(NVAL,IBIN)
         IF (COUNT(NBIN).EQ.0) COUNT(NBIN)=IBIN
      ENDIF
C
C compute mean:
C
      DO I=1, NBIN
         IF (COUNT(I).GT.0) MEAN(I) = SUM(I)/COUNT(I)
      ENDDO
      IF (METHOD.NE.'A') THEN
         DO I=1, NBIN
            IF (COUNT(I).GT.0) BINCEN(I) = BINCEN(I)/COUNT(I)
         ENDDO
      ENDIF
C
C compute standard deviation:
C
      IF (METHOD.EQ.'A') THEN
         DO I=1, NVAL
            IND = INT((X(I)-USRMIN)/USRBSI+1.0)
            IF ((IND.GT.0).AND.(IND.LE.NBIN))
     +         SD(IND) = SD(IND) + (MEAN(IND)-Y(I))**2.0
         ENDDO
      ELSE
         DO I=1, NVAL
            J = INT(1.0*I/IBIN)+1
            SD(J) = SD(J) + (MEAN(J)-Y(IPOINT(I)))**2.0
         ENDDO
      ENDIF
C
C compute sigma of distribution
C
      DO I=1, NBIN
         IF (COUNT(I).GT.1) THEN
            SD(I)=SQRT(SD(I)/(COUNT(I)*(COUNT(I)-1.0)))
            SIG(I)=SD(I)*SQRT(COUNT(I))
         ENDIF
      ENDDO
C
C check for x-sigma deviations from the mean
C
      IF (SIGMA.NE.TRNULL) THEN
         IF (METHOD.EQ.'A') THEN
            DO I=1, NVAL
               IND = INT((X(I)-USRMIN)/USRBSI+1.0)
               IF (ABS(MEAN(IND)-Y(I)).GT.SIGMA*SIG(IND)) THEN
                  IF ((IND.GT.0).AND.(IND.LE.NBIN)) THEN
                     COUNT(IND) = COUNT(IND) - 1
                     SUM(IND)   = SUM(IND) - Y(I)
                  ELSE
                     TEXT= ' *** WARNING: This should never happen'
                     CALL STTPUT(TEXT,STATUS)
                  ENDIF
               ENDIF
            ENDDO
         ELSE                       ! constant number of points per bin
            DO I=1, NBIN
               IF (COUNT(I).GT.1) BINCEN(I) = BINCEN(I)*COUNT(I)
            ENDDO
            DO I=1, NVAL
               NBIN = INT(1.0*(I-1)/IBIN)+1
               IF (ABS(MEAN(NBIN)-Y(IPOINT(I))).GT.SIGMA*SIG(NBIN)) THEN
                  SUM(NBIN) = SUM(NBIN)-Y(IPOINT(I))
                  BINCEN(NBIN) = BINCEN(NBIN)-X(I)
                  COUNT(NBIN) = COUNT(NBIN)-1
               ENDIF
            ENDDO
         ENDIF
         DO i=1, NBIN
            IF (COUNT(I).GT.0) MEAN(I) = SUM(I)/COUNT(I)
         ENDDO
         IF (METHOD.NE.'A') THEN
            DO I=1, NBIN
               IF (COUNT(I).GT.0) BINCEN(I) = BINCEN(I)/COUNT(I)
            ENDDO
         ENDIF
C
C recompute standard deviation:
C
         IF (METHOD.EQ.'A') THEN
            DO I=1, NVAL
               IND = INT((X(I)-USRMIN)/USRBSI+1.0)
               IF ((IND.GT.0).AND.(IND.LE.NBIN))
     +            SD(IND) = SD(IND) + (MEAN(IND)-Y(I))**2.0
            ENDDO
         ELSE
            DO I=1, NVAL
               J = INT(1.0*I/IBIN)+1
               SD(J) = SD(J) + (MEAN(J)-Y(IPOINT(I)))**2.0
            ENDDO
         ENDIF
C
C recompute sigma of distribution
C
         DO I=1, NBIN
            IF (COUNT(I).GT.1) THEN
               SD(I)=SQRT(SD(I)/(COUNT(I)*(COUNT(I)-1.0)))
               SIG(I)=SD(I)*SQRT(COUNT(I))
            ENDIF
         ENDDO
      ENDIF
C
C create output tabel:
C
      CALL TBTINI('bin',F_TRANS,F_O_MODE,5,NBIN,TID,STATUS)
      IF (STATUS.NE.0) THEN
         TEXT = '*** FATAL: Problems creating output table'
         GOTO 9000
      ENDIF
      CALL TBCINI(TID,D_R4_FORMAT,1,FORM1,UNIT1,LABEL1,NC,STATUS)
      CALL TBCINI(TID,D_R4_FORMAT,1,'E15.7',UNIT2,LABEL2,NC,STATUS)
      CALL TBCINI(TID,D_R4_FORMAT,1,'E15.7',UNIT2,'ERR_AV',NC,STATUS)
      CALL TBCINI(TID,D_R4_FORMAT,1,'E15.7',UNIT2,'SIGMA',NC,STATUS)
      CALL TBCINI(TID,D_R4_FORMAT,1,'I8',' ','FREQUENCY',NC,STATUS)
C
C write results
C
      DO I=1,5
         COLS(I) = I
      ENDDO
      DO I=1, NBIN
         IF (METHOD.EQ.'A') THEN
            XX(1) = USRMIN + (I-0.5)*USRBSI
         ELSE
            XX(1) = BINCEN(I)
         ENDIF
         XX(2) = MEAN(I)
         XX(3) = SD(I)
         XX(4) = SIG(I)
         XX(5) = COUNT(I)
         CALL TBRWRR(TID,I,5,COLS,XX,STATUS)
      ENDDO
      CALL TBTCLO(TID,STATUS)
C
c finito:
C
      GOTO 9001
C
C here for errors:
C
 9000 CALL STTPUT(TEXT,STATUS)
 9001 CALL STSEPI
      END
 
 
      SUBROUTINE TBSRRD(A, IPOINT, N, IFAIL)
C
C     SORT REAL ARRAY A(N) IN DESCENDING ORDER
C     POINT(N) CONTAINS THE PREMUTATION SORTING THE ARRAY
C
      IMPLICIT NONE
      INTEGER   N
      INTEGER   IPOINT(N)
      REAL      A(N)
      INTEGER IFAIL
C
      INTEGER   I, II, J, JJ, K, M, IJ, IT, ITT, L
      INTEGER   IU(22),IL(22)
      REAL      T, TT
C
      DO 5 I = 1, N
        IPOINT(I) = I
 5    CONTINUE
C
      II = 1
      JJ = N
      K  = 4
      J  = II - JJ
      M  = 1
      I  = II
      J  = JJ
120   IF (I-J) 140, 400, 400
140   K  = I
      IJ = (J+I)/2
      T  = A(IJ)
      IT = IPOINT(IJ)
      IF (A(I)-T) 160, 180, 180
160   A(IJ) = A(I)
      A(I)  = T
      T     = A(IJ)
      IPOINT(IJ) = IPOINT(I)
      IPOINT(I)  = IT
      IT         = IPOINT(IJ)
180   L = J
      IF (A(J)-T) 260, 260, 200
200   A(IJ) = A(J)
      A(J)  = T
      T     = A(IJ)
      IPOINT(IJ) = IPOINT(J)
      IPOINT(J)  = IT
      IT         = IPOINT(IJ)
      IF (A(I)-T) 220, 260, 260
220   A(IJ) = A(I)
      A(I)  = T
      T     = A(IJ)
      IPOINT(IJ) = IPOINT(I)
      IPOINT(I)  = IT
      IT         = IPOINT(IJ)
      GO TO 260
240   A(L) = A(K)
      A(K) = TT
      IPOINT(L) = IPOINT(K)
      IPOINT(K) = ITT
260   L = L - 1
      IF (A(L)-T) 260, 280, 280
280   TT  = A(L)
      ITT = IPOINT(L)
300   K   = K + 1
      IF (A(K)-T) 320, 320, 300
320   IF (K-L) 240, 240, 340
340   IF (L-I-J+K) 380, 380, 360
360   IL(M) = I
      IU(M) = L
      I = K
      M = M + 1
      GO TO 440
380   IL(M) = K
      IU(M) = J
      J     = L
      M     = M + 1
      GO TO 440
400   M = M - 1
      IF (M) 420, 640, 420
420   I = IL(M)
      J = IU(M)
440   IF (J-I-11) 460, 140, 140
460   IF (I-II) 500, 120, 500
480   I = I + 1
500   IF (I-J) 520, 400, 520
520   T  = A(I+1)
      IT = IPOINT(I+1)
      IF (A(I)-T) 540, 480, 480
540   K           = I
560   A(K+1)      = A(K)
      IPOINT(K+1) = IPOINT(K)
      K           = K - 1
      IF (T-A(K)) 580, 580, 560
580   A(K+1)      = T
      IPOINT(K+1) = IT
      GO TO 480
640   RETURN
      END
 
 
      SUBROUTINE TBSRRA(A, IPOINT, N, IFAIL)
C
C     SORT REAL ARRAY A(N) IN ASCENDING ORDER
C     POINT(N) CONTAINS THE PREMUTATION SORTING THE ARRAY
C
      IMPLICIT NONE
      INTEGER   N
      INTEGER   IPOINT(N)
      REAL      A(N)
      INTEGER IFAIL
C
      INTEGER   I, II, J, JJ, K, M, IJ, IT, ITT, L
      INTEGER   IU(22),IL(22)
      REAL      T, TT

      DO 5 I = 1, N
        IPOINT(I) = I
5     CONTINUE
C
      II = 1
      JJ = N
      K  = 4
      J  = II - JJ
      M  = 1
      I  = II
      J  = JJ
120   IF (I-J) 140, 400, 400
140   K  = I
      IJ = (J+I)/2
      T  = A(IJ)
      IT = IPOINT(IJ)
      IF (T-A(I)) 160, 180, 180
160   A(IJ) = A(I)
      A(I)  = T
      T     = A(IJ)
      IPOINT(IJ) = IPOINT(I)
      IPOINT(I)  = IT
      IT         = IPOINT(IJ)
180   L = J
      IF (T-A(J)) 260, 260, 200
200   A(IJ) = A(J)
      A(J)  = T
      T     = A(IJ)
      IPOINT(IJ) = IPOINT(J)
      IPOINT(J)  = IT
      IT         = IPOINT(IJ)
      IF (T-A(I)) 220, 260, 260
220   A(IJ) = A(I)
      A(I)  = T
      T     = A(IJ)
      IPOINT(IJ) = IPOINT(I)
      IPOINT(I)  = IT
      IT         = IPOINT(IJ)
      GO TO 260
240   A(L) = A(K)
      A(K) = TT
      IPOINT(L) = IPOINT(K)
      IPOINT(K) = ITT
260   L = L - 1
      IF (T-A(L)) 260, 280, 280
280   TT  = A(L)
      ITT = IPOINT(L)
300   K   = K + 1
      IF (T-A(K)) 320, 320, 300
320   IF (K-L) 240, 240, 340
340   IF (L-I-J+K) 380, 380, 360
360   IL(M) = I
      IU(M) = L
      I = K
      M = M + 1
      GO TO 440
380   IL(M) = K
      IU(M) = J
      J     = L
      M     = M + 1
      GO TO 440
400   M = M - 1
      IF (M) 420, 640, 420
420   I = IL(M)
      J = IU(M)
440   IF (J-I-11) 460, 140, 140
460   IF (I-II) 500, 120, 500
480   I = I + 1
500   IF (I-J) 520, 400, 520
520   T  = A(I+1)
      IT = IPOINT(I+1)
      IF (T-A(I)) 540, 480, 480
540   K           = I
560   A(K+1)      = A(K)
      IPOINT(K+1) = IPOINT(K)
      K           = K - 1
      IF (A(K)-T) 580, 580, 560
580   A(K+1)      = T
      IPOINT(K+1) = IT
      GO TO 480
640   RETURN
      END

C @(#)minmon.for	19.1 (ES0-DMD) 02/25/03 13:17:42
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE MINMON(NRPRM,PRM,FCT,GRD,ISTATE,GPJNRM,COND,POSDEF,            
     +                  ITER,NFEVAL,IW,LIW,W,LW)                                
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++        
C                                                                               
C.MODULE                                                                        
C       FIT                                                                     
C                                                                               
C.NAME                                                                          
C       MINMON                                                                  
C                                                                               
C.PURPOSE                                                                       
C       Monitoring the least squares algorithms.                                
C                                                                               
C.KEYWORDS                                                                      
C       Monitoring.                                                             
C                                                                               
C.DESCRIPTION                                                                   
C       trivial                                                                 
C                                                                               
C.LANGUAGE                                                                      
C       FORTRAN                                                                 
C                                                                               
C.CALLING SEQUENCE                                                              
C       CALL  MINMON(NRPRM,PRM,FCT,GRD,ISTATE,GPJNRM,COND,                      
C     +                 POSDEF,NRITER,NFEVAL,IW,LIW,W,LW)                       
C                                                                               
C.INPUT PARAMETERS                                                              
C       NRPRM               INTEGER  Number of parameters                       
C       PRM (NRPRM)         DOUBLE   Parameters                                 
C       FCT                 DOUBLE   Sum of residuals                           
C       GRD (NRPRM)         DOUBLE   values of the gradient                     
C       ISTATE (NRPRM)      INTEGER  Status of the param.                       
C       GPJNRM              DOUBLE   Norm of Proj. Gradient                     
C       COND                DOUBLE   Condition number of hessian                
C       POSDEF              LOGICAL  Positiveness of Hessian                    
C       NRITER              INTEGER  Iteration number                           
C       NFEVAL              INTEGER  Actual number of F. Eval.                  
C       IW (LIW)            INTEGER  unused                                     
C       LIW                 INTEGER                                             
C       W (LW)              DOUBLE                                              
C       LW                  INTEGER                                             
C                                                                               
C.MODIFIED PARAMETERS                                                           
C       none                                                                    
C                                                                               
C.OUTPUT PARAMETERS                                                             
C       none                                                                    
C                                                                               
C.FILES                                                                         
C       none                                                                    
C                                                                               
C.MODULES CALLED                                                                
C       STTPUT                                                                  
C                                                                               
C.AUTHOR                                                                        
C       Ph. DEFERT,      Feb 1986                                               
C                                                                               
C.MODIFICATIONS                                                                 
C                                                                               
C                                                                               
C-----------------------------------------------------------------------        
C      IMPLICIT NONE                                                            
C     ..                                                                        
C     .. Scalar Arguments ..                                                    
      INTEGER LIW,LW,NFEVAL,ITER,NRPRM                                          
      DOUBLE PRECISION GPJNRM,COND,FCT                                          
      LOGICAL POSDEF                                                            
C     ..                                                                        
C     .. Array Arguments ..                                                     
      DOUBLE PRECISION PRM(NRPRM),GRD(NRPRM),W(LW)                              
      INTEGER IW(LIW),ISTATE(NRPRM)                                             
C     ..                                                                        
C     .. Local Scalars ..                                                       
      INTEGER I,STATUS,ISJ                                                      
      DOUBLE PRECISION CHIOLD,REDCHI,PERDEC                                     
C     ..                                                                        
C     .. Local Arrays ..                                                        
      CHARACTER LINE*78                                                         
      CHARACTER*11 STAT(4)                                                      
C     ..                                                                        
C     .. Initializations ..                                                     
      INCLUDE 'MID_INCLUDE:FITNAGI.INC/NOLIST'                                 
      INCLUDE 'MID_INCLUDE:FITNAGC.INC/NOLIST'                                 
      SAVE REDCHI

      DATA STAT/'Free       ','Upper Bound','Lower Bound','Constant   '/        
      DATA REDCHI/1.D15/

CC      DATA CHIOLD/1.D15/                                                        
C     ..                                                                        
C     .. External Files ..                                                      
C     ..                                                                        
C     .. Executable Statements ..                                               
      CHIOLD = REDCHI                                                           
      REDCHI = DMAX1(FCT/DBLE(NRDATA-NRPRM+NRPFIX),0.D0)                      
      IF (ITER.GT.1 .AND. CHIOLD.GT.1.D-15) THEN                                
          PERDEC = 100.* (CHIOLD-REDCHI)/CHIOLD                                 
      ELSE                                                                      
          PERDEC = 0.                                                           
      END IF                                                                    
      CALL STTPUT(' ',STATUS)                                                   
      CALL STTPUT(                                                              
     +           ' Iter  F. Eval.  Sum of Squares  Red. Chisq.  % Decr.'        
     +            //'  Prj. Grad. Norm.',STATUS)                                
      WRITE (LINE,9000) ITER,NFEVAL,FCT,REDCHI,PERDEC,GPJNRM                    
      CALL STTPUT(LINE,STATUS)                                                  
      CALL STTPUT(' ',STATUS)                                                   
      CALL STTPUT('        Parameters       Gradient    '//'Status',            
     +            STATUS)                                                       
      DO 10 I = 1,NRPRM                                                         
          IF (ISTATE(I).GT.0) THEN                                              
              ISJ    = 1                                                        
          ELSE                                                                  
              ISJ    = ABS(ISTATE(I)) + 1                                       
          END IF                                                                
          WRITE (LINE,9010) PRM(I),GRD(I),STAT(ISJ)                             
          CALL STTPUT(LINE,STATUS)                                              
   10 CONTINUE                                                                  
      CALL STTPUT(' ',STATUS)                                                   
      IF (COND.LT.1.D-9) RETURN                                                 
      IF (COND.LT.1.D+6) THEN                                                   
          WRITE (LINE,9020) COND                                                
          CALL STTPUT(LINE,STATUS)                                              
      ELSE                                                                      
          CALL STTPUT(                                                          
     +          'Estimated Condition Number of the Projected Hessian is'        
     +                //' more than 10**6',STATUS)                              
      END IF                                                                    
      IF ( .NOT. POSDEF) CALL STTPUT(                                           
     +          ' Projected Hessian Matrix is not Positive Definite ...'        
     +                               ,STATUS)                                   
                                                                                
      RETURN                                                                    
 9000 FORMAT (I5,2X,I5,3X,1PE12.4,4X,1PE12.4,2X,0PF6.2,5X,1PE9.1)               
 9010 FORMAT (2X,1PD15.7,6X,1PD9.1,6X,A11)                                      
 9020 FORMAT ('Estimated Condition Number of the Projected Hessian',            
     +       ' is ',1PD10.3)                                                    
      END                                                                       

C @(#)poly2d.for	19.1 (ES0-DMD) 02/25/03 13:17:43
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE POLY2D(X,NP,PARAM,Y1,DERIV)                                    
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                  
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  18:01 - 21 DEC 1987                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C--------------------------------------------------------------                 
C*********************************************                                  
C                                                                               
C      IMPLICIT NONE                                                            
C  FIT WITH A TWO-DIMENSIONAL POLYNOMIAL                                        
C                                                                               
C*********************************************                                  
C                                                                               
C  Author: O.-G. Richter, ESO Garching                                          
C                                                                               
      INTEGER I,J,K,NP,MAX
      REAL X(2)                                                            
      DOUBLE PRECISION Y1,PARAM(NP),DERIV(NP)                                   
C  !   Maximum order                                                            
      PARAMETER (MAX=5)                                                         
      DOUBLE PRECISION A,B(MAX,MAX),C(MAX*MAX)                                  
C                                                                               
      A      = 1.0D0                                                            
      DO 10 I = 1,MAX                                                           
          B(1,I) = A                                                            
          A      = A*X(1)                                                       
   10 CONTINUE                                                                  
      DO 30 I = 2,MAX                                                           
          DO 20 J = 1,MAX                                                       
              B(I,J) = B(I-1,J)*X(2)                                            
   20     CONTINUE                                                              
   30 CONTINUE                                                                  
      K      = 0                                                                
      DO 50 I = 1,MAX                                                           
          DO 40 J = 1,I                                                         
              K      = K + 1                                                    
              C(K)   = B(J,I+1-J)                                               
   40     CONTINUE                                                              
   50 CONTINUE                                                                  
      Y1     = 0.0                                                              
      DO 60 I = 1,NP                                                            
          DERIV(I) = C(I)                                                       
          Y1     = Y1 + C(I)*PARAM(I)                                           
   60 CONTINUE                                                                  
      RETURN                                                                    
                                                                                
      END                                                                       

C @(#)filbuf.for	19.1 (ES0-DMD) 02/25/03 13:25:33
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine FILBUF         version 1.0       880827
C  A. Kruszewski             Warsaw U. Obs.
C.PURPOSE
C  Fill with new data image and mask buffers.
C.INPUT/OUTPUT
C  input arguments:
C  IMF         integer*4           image file logical unit number
C  A           real*4 array        image buffer
C  JAPY        integer*4 array     array with line pointers
C  NX          integer*4           X image dimension
C  IXYU        integer*4 array     limits of accessible area
C  IUSD        integer*4 array     limits of used buffer
C  IBUF        integer*4 array     limits of buffer
C  output arguments:
C  JAPY        integer*4 array     array with line pointers
C  IBUF        integer*4 array     limits of buffer
C-----------------------------------------------------------------------
C
C
      SUBROUTINE FILBUF(IMF, A, JAPY, NX, IXYU, IUSD, IBUF)
C
      IMPLICIT  NONE
      INTEGER   IMF
      REAL      A(1)
      INTEGER   JAPY(1) 
      INTEGER   NX
      INTEGER   IXYU(4)
      INTEGER   IUSD(4)
      INTEGER   IBUF(4)
      INTEGER   JOFF , JSWE
C
      INTEGER   L , LBUF
      INTEGER   NLPB , NPPL , NPIB
C
C ******      Calculate number of pixels per line NPPL,
C ******      number of lines per buffer NLPB
C ******      and number of pixels in buffer NPIB.
C
c      IBS = IBUF(1)
c      JBS = IBUF(2)
c      IBE = IBUF(3)
c      JBE = IBUF(4)
c      NPPL = IXYU(3) - IXYU(1) + 1
      NPPL = IBUF(3) - IBUF(1) + 1
c      NLPB = MIN ( NYBUF , NIBUF/NPPL )
      NLPB = IBUF(4) - IBUF(2) + 1
      NPIB = NPPL * NLPB
c      IF ( NLPB .LE. IUSD(4)-IUSD(2) ) THEN
c            NSIZ = INT( SQRT( FLOAT( NPIB ) ) )
c            NSIZ = MIN( NYBUF , NSIZ )
c            NSIZ = MAX( IUSD(4)-IUSD(2)+1 , NSIZ )
c            ITMP = IUSD(2) - ( NSIZ - IUSD(4)+IUSD(2)-1 ) / 2
c            IBUF(2) = MIN( IUSD(2) , ITMP )
c            IBUF(2) = MAX( IBUF(2) , IXYU(2) )
c            IBUF(4) = MAX( IUSD(4) , IBUF(2) + NSIZ - 1 )
c            IBUF(4) = MIN( IBUF(4) , IXYU(4) )
c            NLPB = IBUF(4) - IBUF(2) + 1
c            IF ( NYBUF .LT. NLPB ) PAUSE 'NYBUF too small'
c            NPPL = NIBUF / NLPB
c            IMEAN = ( IUSD(1) + IUSD(3) ) / 2
c            IBUF(1) = IMEAN - NPPL / 2
c            IBUF(1) = MIN( IBUF(1) , IUSD(1) )
c            IBUF(1) = MAX( IXYU(1) , IBUF(1) )
c            IBUF(3) = IBUF(1) + NPPL - 1
c            IBUF(3) = MAX( IBUF(3) , IUSD(3) )
c            IBUF(3) = MIN( IXYU(3) , IBUF(3) )
c            IF ( NPPL .LE. IBUF(3)-IBUF(1) ) THEN
c                  PAUSE 'too small image buffer'
c            ELSE
c                  NPPL = IBUF(3) - IBUF(1) + 1
c            ENDIF
c            NPIB = NPPL * NLPB
c      ELSE
c            IBUF(1) = IXYU(1)
c            IBUF(2) = IUSD(2)
c            IBUF(3) = IXYU(3)
c            IBUF(4) = MIN( IXYU(4) , IBUF(2)+NLPB-1 )
c      ENDIF
c      IOFF = IBUF(1) - 1
C
C ******      Calculate limiting lines to be read JSWS and JSWE,
C ******      offset to pointers JOFF,
C ******      and number of newly read buffer lines LBUF.
C
c      IF ( IBUF(1) .EQ. IBS .AND. IBUF(3) .EQ. IBE .AND.
c     &                  IBUF(2) .LE. JBE .AND. IBUF(2) .GE. JBS ) THEN
c            JSWS = MAX( JBE+1 , IBUF(2) )
c      ELSE
c            JSWS = IBUF(2)
c      ENDIF
      JSWE = IBUF(4)
      JOFF = IBUF(2) - 1
      LBUF = JSWE - JOFF
C
C ******      Update pointers to buffer lines.
C
      DO 10 L = 1 , LBUF
          JAPY(L) = MOD( (L+JOFF-1)*NPPL , NPIB ) - IBUF(1) + 1
   10      CONTINUE
C
C ******      Read new lines.
C
c      DO 20 J = JSWS , JSWE
c            CALL RDILIN ( IMF , 1 , A(JAPY(J-JOFF)+IOFF+1) , NX ,
c     &                                    J , IOFF , NPPL )
c  20      CONTINUE
C
C ******      Read mask lines.
C
c      DO 30 J = JSWS , JSWE
c            CALL RDMLIN ( MSF , 1 , MA(JAPY(J-JOFF)+IOFF+1) ,
c     &                               NX , J , IOFF , NPPL )
c  30      CONTINUE
C
C ******      Update limits of buffered lines.
C
c      IBUF(2) = JOFF + 1
c      IBUF(4) = JSWE
c 1000   CONTINUE
C
      RETURN
C
      END

C @(#)tdcmap.for	19.1 (ESO-IPG) 02/25/03 14:11:15
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:58 - 19 NOV 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION
C
C  program TDCMAP
C
C.PURPOSE
C
C  Execute the command
C  CONV/TAB image = table colx[,coly] [z] refima method
C         for method = FREQ
C                    = POLY deg1[,deg2]
C                    = PLOT min,max
C
C
C.KEYWORDS
C
C  table, image, conversion
C
C.ALGORITHM
C
C  use table interface routines
C
C.COMMENTS
C
C  One has to include ths internal routines into the TD library
C
C.MODIF : make it work for FREQ method MPeron 050990
C 
C  010110		last modif
C 
C-----------------------------------------------------------
C
      SUBROUTINE TDCMAP 
      IMPLICIT NONE
C
      INTEGER MADRID
      INTEGER PARVAL, ID
      INTEGER ICOL(3),NPIX(2)
      INTEGER N,ISTAT,STATUS,NPAR,IAV,IMETH,INDX,NDIM,NAXIS
      INTEGER*8   PNTR
      INTEGER TID,NCOL,NROW,NAC,NAR,NSC,I,I1,I2
      INTEGER ICOLV,NIND,K,L,NTROW,N1
      INTEGER INDEX, KUN, KNUL, IREF, NN,TLEN,CLEN1,CLEN2
C
      DOUBLE PRECISION START(2), STEP(2)
      REAL AXMIN(2),BIN(2),RMIN,RMAX,XMIN,XMAX,YMIN,YMAX
      REAL CUTS(4),RPAR(2),ERROR
C
      DOUBLE PRECISION G, XC
C
      CHARACTER*16 MSG
      CHARACTER*80 TABLE
      CHARACTER*80 IMAGE,REFIMA
      CHARACTER*2 METH
      CHARACTER*17 COLREF(2),COLREV
      CHARACTER*60 WORK
      CHARACTER*72 IDENT
      CHARACTER*80 CUNIT
C
       INCLUDE 'MID_INCLUDE:TABLES.INC'
      COMMON /VMR/MADRID(1)
      COMMON /LS/G(50,50),XC(50),N
       INCLUDE 'MID_INCLUDE:TABLED.INC'
C
      DATA PARVAL/8/
      DATA NPIX/1,1/
      DATA START/0.,0./, STEP /1.,1./
      DATA MSG/'ERR:TMAPITBLxxxx'/
C
C ... get input parameters + default
C
      CALL TDPGET(PARVAL,NPAR,ISTAT)
      IF (ISTAT.NE.0) GO TO 30
      IMAGE  = TPARBF(1)
      TABLE  = TPARBF(3)
      CALL GENLEN(TABLE,TLEN)
      WORK   = TPARBF(4)
      METH   = TPARBF(6)
      CALL FORUPC(METH,METH)
      IF (METH(1:2).EQ.'FR' .AND. TPARBF(7)(1:1).EQ.'+') THEN
          IMETH  = 1
          REFIMA = TPARBF(5)
          GO TO 10
      END IF
      METH   = TPARBF(7)
      CALL FORUPC(METH,METH)
      IF (METH(1:2).EQ.'PO') THEN
          IMETH  = 3
          REFIMA = TPARBF(6)
          COLREV = TPARBF(5)
          CALL STKRDR('INPUTR',1,2,IAV,RPAR,KUN,KNUL,ISTAT)
          GO TO 10
      END IF
      IF (METH(1:2).EQ.'PL') THEN
          IMETH  = 2
          REFIMA = TPARBF(6)
          COLREV = TPARBF(5)
          CALL STKRDR('INPUTR',1,2,IAV,RPAR,KUN,KNUL,ISTAT)
          GO TO 10
      END IF
      CALL STTPUT(' Wrong method ... ',ISTAT)
      GO TO 30
   10 CONTINUE
      INDX   = INDEX(WORK,',')
      IF (INDX.EQ.0) THEN
          NDIM   = 1
          COLREF(1) = WORK
          CALL GENLEN(COLREF(1),CLEN1)
      ELSE
          NDIM   = 2
          COLREF(1) = WORK(1:INDX-1)
          CALL GENLEN(COLREF(1),CLEN1)
          COLREF(2) = WORK(INDX+1:)
          CALL GENLEN(COLREF(2),CLEN2)
      END IF
      IREF = -1
      CALL STFOPN(REFIMA,D_R4_FORMAT,0,F_IMA_TYPE,IREF,ISTAT)
      CALL STDRDI(IREF,'NAXIS',1,1, NN,    NAXIS,KUN,KNUL,ISTAT)
      CALL STDRDI(IREF,'NPIX', 1,NAXIS,NN, NPIX, KUN,KNUL,ISTAT)
      CALL STDRDD(IREF,'START',1,NAXIS,NN, START,KUN,KNUL,ISTAT)
      CALL STDRDD(IREF,'STEP', 1,NAXIS,NN, STEP, KUN,KNUL,ISTAT)
      CALL STDRDC(IREF,'IDENT',1,1,72,NN,  IDENT,KUN,KNUL,ISTAT)
      CALL STDRDC(IREF,'CUNIT',1,1,80,NN,  CUNIT,KUN,KNUL,ISTAT)
      AXMIN(1) = START(1)
      AXMIN(2) = START(2)
      BIN(1)   = STEP(1)
      BIN(2)   = STEP(2)
C [2.1]
C IF (NAXIS.LT.NDIM) THEN
C   CALL STTPUT(' Wrong reference image ... ',ISTAT)
C   GO TO 1000
C ENDIF
C
C ... init input table
C
      TID = -1
      CALL TBTOPN(TABLE,F_I_MODE,TID,ISTAT)
      IF (ISTAT.NE.0) GO TO 30
      CALL TBIGET(TID,NCOL,NROW,NSC,NAC,NAR,ISTAT)
      IF (ISTAT.NE.0) GO TO 30
C
C ... find input column
C
      DO 20 I = 1,NDIM
          CALL TBCSER(TID,COLREF(I),ICOL(I),ISTAT)
          IF (ICOL(I).EQ.-1) THEN
              ISTAT  = ERRCOL
              GO TO 30
          END IF
          CALL TBUGET(TID,ICOL(I),WORK,ISTAT)
CC PN 8/99: CUNIT has to be put into CUNIT(17:32) and CUNIT(33:48)
          I1     = I*16 + 1
          I2     = I1 + 15
CC         WRITE(CBUF,*) 'WORK=',WORK(1:16)   
CC         CALL STTPUT(CBUF,ISTAT)
          CUNIT(I1:I2) = WORK(1:16)
   20 CONTINUE
C
C... handle the different methods
C   
      IF (IMETH.EQ.1) THEN		! Method = FREQUENCY
CC PN 8/99: this has to be written into CUNIT(1:16)
CC          CUNIT(I2+1:I2+16) = 'FREQUENCY'
          CUNIT(1:16) = 'FREQUENCY'
          IF (NDIM.EQ.1) THEN
              IDENT  = 'FREQUENCY OF '//TABLE(1:TLEN)
     1                 //' COL. :'//COLREF(1)(1:CLEN1)
          ELSE
              IDENT  = 'FREQUENCY OF '//TABLE(1:TLEN)
     +                 //' COLS. :'//COLREF(1)(1:CLEN1)
     +                 //' '//COLREF(2)(1:CLEN2)
          END IF

      ELSE IF (IMETH.EQ.2) THEN		! Method = PLOT

              CALL TBCSER(TID,COLREV,ICOLV,ISTAT)
              IF (ICOLV.EQ.-1) THEN
                  ISTAT  = ERRCOL
                  GO TO 30
              END IF
              CALL TBUGET(TID,ICOLV,WORK,ISTAT)
CC PN 8/99: This also has to be written into CUNIT(1:16) instead
CC              CUNIT(I2+1:I2+16) = WORK(1:16)
              CUNIT(1:16) = WORK(1:16)
              IF (NDIM.EQ.1) THEN
                  IDENT  = 'MAP OF '//TABLE(1:TLEN)
     +                     //' COL. :'//COLREF(1)(1:CLEN1)
              ELSE
                  IDENT  = 'MAP OF '//TABLE(1:TLEN)
     +                     //' COLS. :'//COLREF(1)(1:CLEN1)
     +                     //' '//COLREF(2)(1:CLEN2)
              END IF

      ELSE IF (IMETH.EQ.3) THEN		! Method = POLYNOMIAL
              CALL TBCSER(TID,COLREV,ICOLV,ISTAT)
              IF (ICOLV.EQ.-1) THEN
                  ISTAT  = ERRCOL
                  GO TO 30
              END IF
              CALL TBUGET(TID,ICOLV,WORK,ISTAT)
CC PN 8/99 same procedure again ... CUNIT(1:16) instead
CC              CUNIT(I2+1:I2+16) = WORK(1:16)
              CUNIT(1:16) = WORK(1:16)
              IF (NDIM.EQ.1) THEN
                  IDENT  = 'POLY.FIT : '//TABLE(1:TLEN)
     +                     //' COL. :'//COLREF(1)(1:CLEN1)
              ELSE
                  IDENT  = 'POLY.FIT : '//TABLE(1:TLEN)
     +                     //' COLS. :'//COLREF(1)(1:CLEN1)
     +                     //' '//COLREF(2)(1:CLEN2)
              END IF

      ENDIF
C
C ... map image
C
      CALL STIPUT(IMAGE,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .     NDIM,NPIX,START,STEP,IDENT,CUNIT,PNTR,ID,STATUS)

      IF (IMETH.EQ.1) THEN		! Method = FREQUENCY
C
C ... frequency analysis
C
          IF (NDIM.EQ.1) THEN
              CALL FREQ1(TID,ICOL(1),NROW,NPIX,
     .        MADRID(PNTR),AXMIN,BIN,RMIN,RMAX)
          ELSE
              CALL FREQ2(TID,ICOL(1),ICOL(2),NROW,
     .        NPIX(1),NPIX(2),MADRID(PNTR),AXMIN,BIN,RMIN,RMAX)
          END IF

      ELSE IF (IMETH.EQ.2) THEN		! Method = PLOT
C
C ... mapping in plot format
C
           IF (NDIM.EQ.1) THEN
               CALL COUNT1(TID,ICOL(1),ICOLV,NROW,
     .         NPIX,MADRID(PNTR),AXMIN,BIN,RPAR,RMIN,RMAX)
           ELSE
              CALL COUNT2(TID,ICOL(1),ICOL(2),ICOLV,NROW,
     .        NPIX(1),NPIX(2),MADRID(PNTR),AXMIN,BIN,RPAR,RMIN,RMAX)
           END IF

      ELSE IF (IMETH.EQ.3) THEN		! Method = POLYNOMIAL
C
C ... polynomial fit
C
              NTROW  = NAR
C [2.1] START
              IF (NDIM.EQ.1) THEN
                  NIND   = 3
                  ICOL(2) = ICOL(1)
                  ICOL(3) = ICOLV
              ELSE
C [2.1] END
                  NIND   = NDIM + 1
                  ICOL(NIND) = ICOLV
              END IF
              K      = NINT(RPAR(1))
              L      = 0
              IF (NDIM.GT.1) L      = NINT(RPAR(2))
              N      = (K+1)* (L+1)
              CALL LSQFIT(TID,NROW,NTROW,NCOL,NIND,ICOL,K,L,N1,
     +                    XMIN,XMAX,YMIN,YMAX,ERROR)
              IF (NDIM.EQ.1) THEN
                  CALL COMFT2(NPIX(1),1,MADRID(PNTR),AXMIN,BIN,K,0,
     +                         RMIN,RMAX)
              ELSE
                  CALL COMFT2(NPIX(1),NPIX(2),MADRID(PNTR),AXMIN,BIN,
     +                         K,L,RMIN,RMAX)
              END IF

      ENDIF	! End of test on IMETH
C
C ... write cuts
C
      CUTS(1) = RMIN
      CUTS(2) = RMAX
      CUTS(3) = RMIN
      CUTS(4) = RMAX
      CALL STDWRR(ID,'LHCUTS',CUTS,1,4,KUN,ISTAT)
C
C ... end
C
      CALL DSCUPT(ID,ID,' ',ISTAT)
      CALL TBTCLO(TID,ISTAT)
   30 IF (ISTAT.NE.0) THEN
          WRITE (MSG(13:16),9000) ISTAT
          CALL TDERRR(ISTAT,MSG,STATUS)
      END IF
      RETURN
 9000 FORMAT (I4)
      END

      SUBROUTINE FREQ1(TID,ICOL,NROW,NPIX,F,START,STEP,RMIN,RMAX)
C
C compute the frequency
C
      IMPLICIT NONE
      INTEGER  TID
      INTEGER  ICOL
      INTEGER  NROW
      INTEGER  NPIX
      REAL     F(NPIX)
      REAL     START
      REAL     STEP
      REAL     RMIN
      REAL     RMAX
C
      REAL    X
      INTEGER I, STATUS, J
      LOGICAL INULL, ISEL
C
      DO 10 I = 1,NPIX
          F(I)   = 0.
   10 CONTINUE
      RMIN   = 0.
      RMAX   = 0.
      DO 20 I = 1,NROW
          CALL TBSGET(TID,I,ISEL,STATUS)
          CALL TBERDR(TID,I,ICOL,X,INULL,STATUS)
          IF (ISEL.AND.(.NOT.INULL)) THEN
              J      = (X-START)/STEP + 1
              IF (J.GE.1 .AND. J.LE.NPIX) THEN
                  F(J)   = F(J) + 1
                  RMAX   = AMAX1(RMAX,F(J))
              END IF
          END IF
   20 CONTINUE
      RETURN
      END

      SUBROUTINE FREQ2(TID,ICOL1,ICOL2,NROW,
     .                 NPIX1,NPIX2,F,START,STEP,RMIN,RMAX)
C
C compute the frequency
C
      IMPLICIT NONE
      INTEGER  TID
      INTEGER  ICOL1
      INTEGER  ICOL2
      INTEGER  NROW
      INTEGER  NPIX1
      INTEGER  NPIX2
      REAL     F(NPIX1,NPIX2)
      REAL     START(2)
      REAL     STEP(2)
      REAL     RMIN
      REAL     RMAX
C
      INTEGER I, J, STATUS, I1, J1
      LOGICAL INULL1, INULL2, ISEL
      REAL STARTX, STARTY, STEPX, STEPY, X, Y
C
C
      DO 20 I = 1,NPIX2
          DO 10 J = 1,NPIX1
              F(J,I) = 0.
   10     CONTINUE
   20 CONTINUE
      RMIN   = 0.
      RMAX   = 0.
      STARTX = START(1)
      STARTY = START(2)
      STEPX  = STEP(1)
      STEPY  = STEP(2)
      DO 30 I = 1,NROW
          CALL TBSGET(TID,I,ISEL,STATUS)
          CALL TBERDR(TID,I,ICOL1,X,INULL1,STATUS)
          CALL TBERDR(TID,I,ICOL2,Y,INULL2,STATUS)
          IF (ISEL.AND.(.NOT.INULL1).AND.(.NOT.INULL2)) THEN
              J1     = (X-STARTX)/STEPX + 1
              I1     = (Y-STARTY)/STEPY + 1
              IF (J1.GE.1 .AND. J1.LE.NPIX1 .AND. I1.GE.1 .AND. I1.LE.
     +            NPIX2) THEN
                  F(J1,I1) = F(J1,I1) + 1
                  RMAX   = AMAX1(RMAX,F(J1,I1))
              END IF
          END IF
   30 CONTINUE
      RETURN
      END

      SUBROUTINE COUNT2
     .(TID,ICOL1,ICOL2,ICOLR,N,NPIX1,NPIX2,A,
     . START,STEP,RFLAG,RMIN,RMAX)
C
C compute distribution
C
      IMPLICIT NONE
      INTEGER  TID
      INTEGER  ICOL1
      INTEGER  ICOL2
      INTEGER  ICOLR
      INTEGER  N
      INTEGER  NPIX1
      INTEGER  NPIX2
      REAL     A(NPIX1, NPIX2)
      REAL     START(2)
      REAL     STEP(2)
      REAL     RFLAG(2)
      REAL     RMIN
      REAL     RMAX
C
      REAL    X1,Y1,Z1
      LOGICAL ISEL, INULL1, INULL2, INULL3
      REAL    RLOW, RUPP
      INTEGER I, J, STATUS, J1, I1
      CHARACTER*80 STRING
      INTEGER      ISTAT,OVER
C
C
C ... clear counts
C
      RLOW   = RFLAG(1)
      RUPP   = RFLAG(2)
      DO 20 I = 1,NPIX2
          DO 10 J = 1,NPIX1
              A(J,I) = RLOW
   10     CONTINUE
   20 CONTINUE
      RMIN   = RLOW
      RMAX   = RLOW
C
C ... iteration on rows
C
      OVER = 0		! Set overwriting flag to 0
      DO 30 I = 1,N
          CALL TBSGET(TID,I,ISEL,STATUS)
          IF (ISEL) THEN
              CALL TBERDR(TID,I,ICOL1,X1,INULL1,STATUS)
              CALL TBERDR(TID,I,ICOL2,Y1,INULL2,STATUS)
              CALL TBERDR(TID,I,ICOLR,Z1,INULL3,STATUS)
              IF (.NOT.INULL1.AND..NOT.INULL2.AND..NOT.INULL3)THEN
                  J1     = NINT((X1-START(1))/STEP(1)) + 1
                  I1     = NINT((Y1-START(2))/STEP(2)) + 1
                  IF (J1.GE.1 .AND. J1.LE.NPIX1 .AND. I1.GE.1 .AND.
     +                I1.LE.NPIX2) THEN

                      IF (A(J1,I1).NE.RLOW) THEN
                          A(J1,I1) = RUPP
                          OVER = 1
                      ELSE
                          A(J1,I1) = Z1
                      END IF
                      RMAX   = AMAX1(RMAX,A(J1,I1))
                  END IF
              END IF
          END IF
   30 CONTINUE

      IF (OVER.NE.0) THEN
         STRING = 'Attempted to overwrite pixels. Change START or STEP'
         CALL STTPUT (STRING,ISTAT)
         WRITE (STRING,500) RUPP
500      FORMAT ('Overwritten value is : ',E15.6)
         CALL STTPUT (STRING,ISTAT)
      ENDIF

      RETURN
      END

      SUBROUTINE COUNT1
     . (TID,ICOL,ICOLR,N,NPIX1,A,START,STEP,RFLAG,RMIN,RMAX)
C
C compute distribution
C
      IMPLICIT NONE
      INTEGER  TID
      INTEGER  ICOL
      INTEGER  ICOLR
      INTEGER  N
      INTEGER  NPIX1
      REAL     A(NPIX1)
      REAL     START
      REAL     STEP
      REAL     RFLAG(2)
      REAL     RMIN
      REAL     RMAX
C
      LOGICAL  ISEL, INULL, INULLR
      INTEGER  I, J, STATUS, J1
      REAL     RLOW, RUPP, X1, Z1
      CHARACTER*80 STRING
      INTEGER      ISTAT,OVER
C
C
C ... clear counts
C
      RLOW   = RFLAG(1)
      RUPP   = RFLAG(2)
      DO 10 J = 1,NPIX1
          A(J)   = RLOW
   10 CONTINUE
      RMIN   = RLOW
      RMAX   = RLOW
C
C ... iteration on rows
C
      OVER = 0		! Set overwriting flag to 0
      DO 20 I = 1,N
          CALL TBSGET(TID,I,ISEL,STATUS)
          IF (ISEL) THEN
              CALL TBERDR(TID,I,ICOL,X1,INULL,STATUS)
              CALL TBERDR(TID,I,ICOLR,Z1,INULLR,STATUS)
              IF (.NOT.INULL.AND..NOT.INULLR)THEN
                  J1     = (X1-START)/STEP + 1
                  IF (J1.GE.1 .AND. J1.LE.NPIX1) THEN
                      IF (A(J1).NE.RLOW) THEN
                          A(J1)  = RUPP
                      ELSE
                          A(J1)  = Z1
                      END IF
                      RMAX   = AMAX1(RMAX,A(J1))
                  END IF
              END IF
          END IF
   20 CONTINUE

      IF (OVER.NE.0) THEN
         STRING = 'Attempted to overwrite pixels. Change START or STEP'
         CALL STTPUT (STRING,ISTAT)
         WRITE (STRING,500) RUPP
500      FORMAT ('Overwritten value is : ',E15.6)
         CALL STTPUT (STRING,ISTAT)
      ENDIF

      RETURN
      END

      SUBROUTINE LSQFIT
     .(TID,NROW,NRALL,NCOL,NIND,IVAR,K,L,N1,XMIN,XMAX,YMIN,YMAX,ERROR)
C
C SOLVE LEAST SQUARE PROBLEM
C
      IMPLICIT NONE
      INTEGER  IVAR(3)
      INTEGER TID, NROW, NRALL, NCOL, NIND, K, L, N1
      REAL    XMIN, XMAX, YMIN, YMAX, ERROR
C
      DOUBLE PRECISION G,XC
C
      LOGICAL ISEL, INULL1, INULL2, INULLY
      REAL    X1, X2, Y
      INTEGER IX1, IX2, IY, LL, I, STATUS, N, K1, KMIN
      COMMON /LS/G(50,50),XC(50),N
C

      XMIN   = 1.E30
      XMAX   = -XMIN
      YMIN   = XMIN
      YMAX   = XMAX
C
C ITERATION
C
      LL     = 0
      N1     = 0
      IX1    = IVAR(1)
      IX2    = IVAR(2)
      IY     = IVAR(3)
      DO 20 I = 1,NROW
          CALL TBSGET(TID,I,ISEL,STATUS)
          IF (ISEL) THEN
             CALL TBERDR(TID,I,IX1,X1,INULL1,STATUS) 
             CALL TBERDR(TID,I,IX2,X2,INULL2,STATUS) 
             CALL TBERDR(TID,I,IY, Y ,INULLY,STATUS) 
             IF (.NOT.INULL1 .AND. .NOT.INULL2 
     .           .AND..NOT.INULLY) THEN 
                XMIN   = AMIN1(XMIN,X1)
                XMAX   = AMAX1(XMAX,X1)
                YMIN   = AMIN1(YMIN,X2)
                YMAX   = AMAX1(YMAX,X2)
                N1     = N1 + 1
                CALL SETUP(LL+1,X1,X2,Y,K,L)
                IF (LL.NE.0) THEN
                    KMIN   = MIN(LL,N+1)
                    DO 10 K1 = 1,KMIN
                        CALL HT(K1,LL+1)
   10               CONTINUE
                END IF
                LL     = MIN(LL+1,N+1)
            END IF
          END IF
   20 CONTINUE
      CALL SOLVE
      ERROR  = ABS(G(N+1,N+1))
      RETURN
      END

      SUBROUTINE SETUP(LL,X1,X2,Y,K,L)
C
C PREPARE DATA IN WORK SPACE
C
      IMPLICIT NONE
      INTEGER LL, K, L
      REAL X1, X2, Y
C
      INTEGER IP, N, L1, K1
C
      DOUBLE PRECISION G,X,DC
C
      COMMON /LS/G(50,50),X(50),N
C
      IP     = 0
      DC     = 1.D0
      DO 20 L1 = 0,L
          IP     = IP + 1
          G(LL,IP) = DC
          DO 10 K1 = 1,K
              IP     = IP + 1
              G(LL,IP) = G(LL,IP-1)*X1
   10     CONTINUE
          DC     = DC*X2
   20 CONTINUE
      G(LL,N+1) = Y
      RETURN
      END

      SUBROUTINE HT(K,L1)

C     FUNCTION : Apply a Householder transformation to the
C                two rows K and L1 of G.
C
C     INPUT :    * matrix G(1:L1,1:n+1)
C                * numbers L1 and K of the two rows
C                * n : rank of the matrix
C
C     OUTPUT :   modified rows K and L1 of the matrix G.
      IMPLICIT NONE
      INTEGER K, L1
C
      INTEGER KH, J, N
      DOUBLE PRECISION G,X,S,H,B
      COMMON /LS/G(50,50),X(50),N

C     Construct the transformation

      S      = DSQRT(G(K,K)**2+G(L1,K)**2)
      IF (G(K,K).GE.0) THEN
          S      = -S
      END IF
      H      = G(K,K) - S
      G(K,K) = S
      B      = G(K,K)*H
C
C     Apply the transformation to the rows K and L1 of G.
C
      KH     = N + 1 - K
      IF ((KH.NE.0) .AND. (B.NE.0)) THEN
          DO 10 J = 1,KH
              S      = (G(K,K+J)*H+G(L1,K+J)*G(L1,K))/B
              G(K,K+J) = G(K,K+J) + S*H
              G(L1,K+J) = G(L1,K+J) + S*G(L1,K)
   10     CONTINUE
      END IF
      END

      SUBROUTINE SOLVE
C     FUNCTION : Solve the set of linear equations which are
C                represented by the upper triangular part
C                of the matrix G(1:n,1:n+1).
C
C     INPUT :    * matrix G(1:n,1:n+1)
C                * n : rank of the matrix
C
C     OUTPUT :   solution vector x(1:n)
      IMPLICIT NONE
      INTEGER  I, II, N, J
      DOUBLE PRECISION G,X,S
      COMMON /LS/G(50,50),X(50),N

      DO 10 I = 1,N
          X(I)   = G(I,N+1)
   10 CONTINUE
      DO 30 II = 1,N
          I      = N - II + 1
          S      = 0.D0
          IF (I.NE.N) THEN
              DO 20 J = 2,N + 1 - I
                  S      = S + G(I,I+J-1)*X(I+J-1)
   20         CONTINUE
          END IF
          X(I)   = (X(I)-S)/G(I,I)
   30 CONTINUE
      END

      SUBROUTINE COMFT2(NPIX1,NPIX2,OUT,START,STEP,K,L,RMIN,RMAX)
C
      IMPLICIT NONE
C
      INTEGER NPIX1,NPIX2,K,L,IY,IX,L1,N,K1,IP
      REAL OUT(NPIX1,NPIX2),RMIN,RMAX
      REAL START(*),STEP(*)
      DOUBLE PRECISION WORK(50),DC,YVAL,G,A
      DOUBLE PRECISION X1,X2,XSTART,YSTART,XSTEP,YSTEP
      COMMON /LS/G(50,50),A(50),N
C
C  initialize variables
      XSTART = START(1)
      YSTART = START(2)
      XSTEP  = STEP(1)
      YSTEP  = STEP(2)
C
C  calculate 1st value already for RMIN, RMAX
      IP = 0
      DC = 1.D0
      YVAL = 0.D0 
      DO 1020, L1 = 0,L
         IP = IP + 1
         WORK(IP) = DC
         YVAL = YVAL + WORK(IP)*A(IP)
         DO 1010, K1 = 1,K
            IP = IP + 1
            WORK(IP) = WORK(IP-1)*XSTART
            YVAL = YVAL + WORK(IP)*A(IP)
1010     CONTINUE
         DC = DC*YSTART
1020  CONTINUE
      RMIN = YVAL
      RMAX = RMIN
C 
C  start loop
      DO 40, IY=1,NPIX2
          X2     = (IY-1)*YSTEP + YSTART
          DO 30, IX = 1,NPIX1
              X1     = (IX-1)*XSTEP + XSTART
              IP     = 0
              DC     = 1.D0
              YVAL   = 0.D0
              DO 20, L1 = 0,L
                  IP     = IP + 1
                  WORK(IP) = DC
                  YVAL   = YVAL + WORK(IP)*A(IP)
                  DO 10, K1 = 1,K
                      IP     = IP + 1
                      WORK(IP) = WORK(IP-1)*X1
                      YVAL   = YVAL + WORK(IP)*A(IP)
   10             CONTINUE
                  DC     = DC*X2
   20         CONTINUE
              OUT(IX,IY) = YVAL
              RMIN   = AMIN1(RMIN,OUT(IX,IY))
              RMAX   = AMAX1(RMAX,OUT(IX,IY))
   30     CONTINUE
   40 CONTINUE
      RETURN
C 
      END

C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or
C modify it under the terms of the GNU General Public License as
C published by the Free Software Foundation; either version 2 of
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public
C License along with this program; if not, write to the Free
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge,
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C       Internet e-mail: midas@eso.org
C       Postal address: European Southern Observatory
C                       Data Management Division
C                       Karl-Schwarzschild-Strasse 2
C                       D 85748 Garching bei Muenchen
C                       GERMANY
C===========================================================================

      SUBROUTINE IIMSTW(DSPLAY,CHAN,LOADFL,SZX,SZY,DEPTH,
     +                  XBEG,YBEG,IDST)
C
      IMPLICIT NONE
C
      INTEGER     DSPLAY
      INTEGER     CHAN,LOADFL,SZX,SZY,DEPTH,XBEG,YBEG,IDST
C
      CALL IIM1(DSPLAY,CHAN,LOADFL,SZX,SZY)
      CALL IIM2(DEPTH,XBEG,YBEG,IDST)
C
      RETURN
      END
C
      SUBROUTINE IIMWMY(DSPLAY,CHAN,PIX,SIZE,DEPTH,PACK,XBEG,YBEG,IDST)
C
      IMPLICIT NONE
C
      INTEGER     DSPLAY,CHAN
      INTEGER     PIX,SIZE,DEPTH,PACK,XBEG,YBEG,IDST
C
      CALL IIM1(DSPLAY,CHAN,PIX,SIZE,0)
      CALL IIM3(DEPTH,XBEG,YBEG,IDST)
C
      RETURN
      END
C
      SUBROUTINE IIMRMY(DSPLAY,CHAN,SIZE,XBEG,YBEG,DEPTH,PACK,
     +                  ITTFLG,PIX,IDST)

      IMPLICIT NONE
C
      INTEGER     DSPLAY,CHAN,ITTFLG,PIX
      INTEGER     SIZE,DEPTH,PACK,XBEG,YBEG,IDST
C
      CALL IIM1(DSPLAY,CHAN,SIZE,XBEG,YBEG)
      CALL IIM4(DEPTH,PACK,ITTFLG,PIX,IDST)
C
      RETURN
      END
C

C @(#)backly.for	19.1 (ESO-IPG) 02/25/03 13:28:03

C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C       Internet e-mail: midas@eso.org
C       Postal address: European Southern Observatory
C                       Data Management Division 
C                       Karl-Schwarzschild-Strasse 2
C                       D 85748 Garching bei Muenchen 
C                       GERMANY
C===========================================================================
C
C



      program backly
      
      implicit none
      include 'MID_REL_INCL:fit_var.inc'
      
                                ! keywords coming from line
      character*80 SPESYS,INPSYS,HISSYS,OUTSYS
      integer GRASYS
      INTEGER IDrun(10000)      ! ID of the fits to be executed


      integer ist,i,ijk,iok,nj,j,Nidrun,indx_i,indx_o
      integer TabID,i1,i2,i3,i4,icol(20)
      logical la
      character*80 filnam,sjunk

      
C      include 'MID_REL_INCL:fit_mid.inc'
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'

C!!!!!!!
C     MIDAS SET-UP
C!!!!!!!
      call STSPRO('backly')
      
      call STKRDC('SPECTAB',1,1,80,i,SPESYS,ijk,ijk,iok) !Input spectrum
      if (iok.ne.0) then
         call ErrMsg('Error in reading keywords: check context..')
         call STSEPI() 
         stop
      end if   

      call STKRDC('INPUTC',1,1,20,i,INPSYS,ijk,ijk,iok) ! Input histtab
      if (iok.ne.0) then
         call ErrMsg('Error in reading keywords: check context..')
         call STSEPI() 
         stop
      end if   

      call STKRDC('OUTTAB',1,1,80,i,OUTSYS,ijk,ijk,iok) !Output results
      if (iok.ne.0) then
         call ErrMsg('Error in reading keywords: check context..')
         call STSEPI() 
         stop
      end if   

      call STKRDC('HISTAB',1,1,80,i,HISSYS,ijk,ijk,iok) !Output history
      if (iok.ne.0) then
         call ErrMsg('Error in reading keywords: check context..')
         call STSEPI() 
         stop
      end if   

      call STKRDI('GRAWIN',1,1,i,GRASYS,ijk,ijk,iok) !Graphics
      if (iok.ne.0) then
         call ErrMsg('Error in reading keywords: check context..')
         call STSEPI() 
         stop
      end if   

      

C!!!!!!!
C     Videata iniziale
C!!!!!!!
      call DisMsg('Loading data...')
      call DisMsg('Wait please..')
      
C!!!!!!!
C     Inizializzazione programma
C!!!!!!!
      call AtmRD(ist)            !read atompar.dat
      NPUNTI=NMXSPE
      call reaspe(SPESYS,NPUNTI)    !reads spectrum
      if (NPUNTI.lt.1) goto 666
                                ! reads input history to get IDrun
      indx_i=index(INPSYS,' ')
      filnam=INPSYS(1:indx_i-1)//PARTBL 
      call TBTOPN(filnam,F_IO_MODE,TabID,ist) !open table
      call TBLSER(TabID,'ID',icol(1),ist)


      i1=1                      !doesn't stop on errors
      i2=0
      i3=0
      call STECNT('PUT',i1,i2,i3)

      call TBIGET(TABID,i1,i2,i3,i4,nj,ist) !n. of rows

      j=0
      do i=1,nj
         call TBSGET(TABID,i,la,ist) ! selected?
         if (la) then
            call TBERDI(TABID,i,icol(1),j,la,ist) !reads element 
            IDrun(j) = j
         end if
      end do

      call TBTCLO(TABID,ist)

      Nidrun = j
c      write(sjunk,*)Nidrun
c      call sttdis(sjunk,0,ist)
c      do j=1,Nidrun
c         write(sjunk,*)idrun(j)
c         call sttdis(sjunk,0,ist)
c      end do

      indx_o=index(HISSYS,' ')       !Reads output history
      filnam=HISSYS(1:indx_o-1)//PARTBL
      call GETIDN(filnam,IDnum,ist) 
      if (ist.ne.0) then
         call WrnMsg('Log files not found: starting from scratch')
         IDnum=0
      end if



C####
C     Main loop : executes minimizations
C####
      do j=1,Nidrun
         
         if (IDrun(j) .ne. 0 ) then
                                !reads from input history files
            filnam=INPSYS(1:indx_i-1)//PARTBL 
            call f_tblr(filnam,IDrun(j),ist)
            if (ist.ne.0) then
               call ErrMsg('Error in reading parameter table')
               call STSEPI()
               stop
            end if   
            filnam=INPSYS(1:indx_i-1)//MINTBL 
            call rminui(filnam,IDrun(j),ist)
            if (ist.ne.0) then
               call ErrMsg('Error in reading minuit command table')
               call STSEPI()
               stop
            end if   
            filnam=INPSYS(1:indx_i-1)//LIMTBL 
            call rintvl(filnam,IDrun(j),ist)
            if (ist.ne.0) then
               call ErrMsg('Error in reading interval table')
               call STSEPI()
               stop
            end if   
                  
            call f_tblw(PARTBL,1,ist) ! save on standard tables
            call ssetup(PARTBL,ist)
            call sminui(MINTBL,1,ist)
            call sintvl(LIMTBL,1,ist)
         

                                ! Executes minimization
            call FitWin(i,iok)  ! create data for FCN
            if (iok.lt.0) then
               call ErrMsg('Error in initial condition for fit')
               call STSEPI()
               stop
            end if
            call FCNHd()
            call MinuHd()
            call DisMsg('...Done')
c            write(sjunk,*)i
c            call sttdis(sjunk,0,ist)
            write(sjunk,'(a25,i6)')'Number of pixel selected:',i
            call sttdis(sjunk,0,ist)
            call DisMsg(sjunk)

C       Esegue il fit
            call DisMsg('Executing fitting procedures...')
            call Minmze()
            call DisMsg('...Done')

C       Presenta e salva i risultati
            call GraMai(iok)
            call ShoRes

C       SAVE
            IDnum=IDNum+1
            call SavRes(OUTSYS,ist)
         
                                !saves on output history file 
            filnam=HISSYS(1:indx_o-1)//PARTBL
            call f_tblw(filnam,IDNum,ist)
         
            filnam=HISSYS(1:indx_o-1)//MINTBL
            call sminui(filnam,IDNum,ist)
         
            filnam=HISSYS(1:indx_o-1)//LIMTBL
            call sintvl(filnam,IDNum,ist)

            
            write(sjunk,'(a17,i6)')'Saved with ID =  ',IDnum
            call DisMsg(sjunk)
               

         end if

      end do


 666  continue
      call STSEPI()
      end

C===========================================================================
C     Copyright (C) 1995 European Southern Observatory (ESO)
C     
C     This program is free software; you can redistribute it and/or 
C     modify it under the terms of the GNU General Public License as 
C     published by the Free Software Foundation; either version 2 of 
C     the License, or (at your option) any later version.
C     
C     This program is distributed in the hope that it will be useful,
C     but WITHOUT ANY WARRANTY; without even the implied warranty of
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU General Public License for more details.
C     
C     You should have received a copy of the GNU General Public 
C     License along with this program; if not, write to the Free 
C     Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C     MA 02139, USA.
C     
C     Correspondence concerning ESO-MIDAS should be addressed as follows:
C     Internet e-mail: midas@eso.org
C     Postal address: European Southern Observatory
C     Data Management Division 
C     Karl-Schwarzschild-Strasse 2
C     D 85748 Garching bei Muenchen 
C     GERMANY
C===========================================================================
C     
      PROGRAM ECHMRG
C     +
C     .COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C     all rights reserved
C     
C     .VERSION: 1.0  ESO-FORTRAN Conversion, AA  22:26 - 3 DEC 1987
C     
C     .LANGUAGE: F77+ESOext
C     
C     .AUTHOR: D.PONZ
C     
C     
C     .IDENTIFICATION
C     
C     program  ECHMERG 
C     
C     .MODIFICATIONS
C     
C     910128   P. Ballester   Define and set variables for mmake -i
C     981104   O. Stahl       Modified for FEROS
C     
C     .KEYWORDS
C     
C     ECHELLE, CASPEC, ORDER MERGING
C     
C     .PURPOSE
C     
C     OBTAIN A 1D FRM CALIBRATED IN WAVELENGTHS FROM A 2D FRM
C     SAMPLED IN THE SPACE WAVELENGTH-ORDER.
C     
C     .ALGORITHM
C     
C     OVERLAPPING REGIONS OF CONSECUTIVE ORDERS ARE PROCESSED IN TWO WAYS:
C     - CONCATENATION OF CONSECUTIVE ORDERS, USING THE MIDDLE POINT AS
C     CONCATENATING POSITION (METHOD='CONCATENATE', DEFAULT)
C     - AVERAGE OF OVERLAPPING REGION (METHOD='AVERAGE')
C     - NO MERGING. INDIVIDUAL ORDERS ARE WRITTEN IN DIFFERENT FILES
C     (METHOD = 'NOMERGE')
C     - WEIGHTED AVERAGE. WEIGHTS PROPORTIONAL TO SINC**2 (METHOD='SINC')
C     THE METHOD 'NOMERGE' WILL PRODUCE AS MANY FILES AS DEFINED ORDERS
C     WITH NAMES xxxyyyy, xxxx IS THE OUTPUT FILE NAME, yyyy IS THE 
C     ORDER NUMBER
C     
C     .INPUT/OUTPUT
C     
C     MERGE/ECHELLE INPUT OUTPUT  [CONC]
C     MERGE/ECHELLE INPUT OUTPUT  ORD1,ORD2 NOCONCAT
C     MERGE/ECHELLE INPUT OUTPUT  DEL       AVERAGE
C     OR
C     MERGE/ECHELLE INPUT OUTPUT  TABLE SINC
C 
C.VERSION
C 30714		last modif
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C     
C     
      IMPLICIT NONE
C 
      INTEGER MADRID
      INTEGER I, II1, II2, IORD1
      INTEGER IORD2
      INTEGER*8 IPNTRA, IPNTRB
      INTEGER ISTAT
      INTEGER NAXISA, NAXISB
C 
      DOUBLE PRECISION    DEL, WEND, WINIT, WSTEP
C     
      INTEGER NPIXA(3),NPIXB(3),NPTOT(100),ICOL(3),KUN,KNUL
      INTEGER INIMA, OUTIMA, TID
      DOUBLE PRECISION  WSTART(100),STEPA(3)
      DOUBLE PRECISION  STARTA(3),STEPB(3),STARTB(3)
      REAL CUT(4),XMIN,XMAX,WRANGE(2),VAL(3)
      REAL WAVE(100),ORDER(100),WAVE1(100),WAVE2(100)
      REAL WAVE3(100),WAVE4(100)
      CHARACTER*60 INFRM,OUTFRM
      CHARACTER OUTFIL*60
      CHARACTER METHOD*1,WS*5
      CHARACTER IDENTA*72,IDENTB*72,CUNITA*64,CUNITB*64
      CHARACTER*16 LABEL(3)
      LOGICAL NULL(3)
C     
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C     
C     DATA CUNITB/'WAVELENGTH      FLUX      '/
      DATA CUNITB/'FLUX            WAVELENGTH'/
      DATA LABEL(1)/'WAVE'/,LABEL(2)/'ORDER'/,LABEL(3)/'LNWAVE'/
C     
C     ... INITIALIZE SYSTEM
C     
      CALL STSPRO('ECHMRG')
      INFRM = ' '
      OUTFRM = ' '
      CALL STKRDC('P1',1,1,60,I,INFRM,KUN,KNUL,ISTAT)
      CALL STKRDC('P2',1,1,60,I,OUTFRM,KUN,KNUL,ISTAT)
      CALL CLNFRA(INFRM,INFRM,0)
      CALL CLNFRA(OUTFRM,OUTFRM,0)
      CALL STKRDC('P4',1,1,1,I,METHOD,KUN,KNUL,ISTAT)
      CALL FORUPC(METHOD,METHOD)
      CALL STKRDR('INPUTR',1,2,I,WRANGE,KUN,KNUL,ISTAT)
C
      IF (METHOD.EQ.'A') THEN
         WINIT  = 0.
         WEND   = WINIT
         DEL    = WRANGE(1)
      ELSE
         WINIT  = WRANGE(1)
         WEND   = WRANGE(2)
      END IF
 
C
      IF (METHOD.EQ.'S') THEN
         WINIT  = 0.
         WEND   = WINIT
         DEL    = WRANGE(1)
      END IF
C     
C     ... MAP INPUT FRM
C     
      CALL STIGET(INFRM,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     .     3,NAXISA,NPIXA,STARTA,STEPA,IDENTA,CUNITA,
     .     IPNTRA,INIMA,ISTAT)
      CALL STDRDD(INIMA,'WSTART',1,NPIXA(2),I,
     .     WSTART,KUN,KNUL,ISTAT)
      CALL STDRDI(INIMA,'NPTOT',1,NPIXA(2),I,NPTOT,
     .     KUN,KNUL,ISTAT)
C     ... CHECK IF NPTOT(NPIXA(2)) IS 0 
      IF (NPTOT(NPIXA(2)).EQ.0) THEN  
         NPIXA(2) = NPIXA(2) - 1
      END IF
      WSTEP  = STEPA(1)
      IF (METHOD.EQ.'N') THEN
C     
C     ... NO MERGE - PRODUCE ONE FILE PER ORDER
C     
         IF (WINIT.EQ.WEND .AND. WINIT.LT.0.5) THEN
            IORD1  = 1
            IORD2  = NPIXA(2)
         ELSE
            IORD1  = MAX(NINT(WINIT),1)
            IORD2  = MIN(NINT(WEND),NPIXA(2))
         END IF
         OUTFRM = OUTFRM(1:59)//' '
         II1    = INDEX(OUTFRM,' ') - 1
         II1    = MIN(II1,20)
         OUTFIL = OUTFRM(1:II1)
         DO 10 I = IORD1,IORD2
            II2    = 10000 + I
            WRITE (WS,9000) II2
            OUTFIL(II1+1:II1+4) = WS(2:5)
            NAXISB    = 1
            NPIXB(1)  = NPTOT(I)
            NPIXB(2)  = 1
            STARTB(1) = WSTART(I)
            STARTB(2) = 1.
            STEPB(1)  = WSTEP
            STEPB(2)  = 0.
            WRITE (IDENTB,9010) I
            IDENTB(11:72) = IDENTA(1:62)
            CALL STIPUT(OUTFIL,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .           NAXISB,NPIXB,STARTB,STEPB,
     .           IDENTB,CUNITB,IPNTRB,OUTIMA,ISTAT)
            CALL COPY(MADRID(IPNTRA),NPIXA(1),NPIXA(2),MADRID(IPNTRB),
     .           NPIXB(1),I,XMIN,XMAX)
            CUT(1) = XMIN
            CUT(2) = XMAX
            CUT(3) = XMIN
            CUT(4) = XMAX
            CALL DSCUPT(INIMA,OUTIMA,' ',ISTAT)
            CALL STDWRR(OUTIMA,'LHCUTS',CUT,1,4,KUN,ISTAT)
C     
            CALL STFCLO(OUTIMA,ISTAT)
            CALL STTPUT('File '//OUTFIL//' created ...',ISTAT)
 10      CONTINUE

      ELSE
C     
C     ... MAP OUTPUT FRAME
C     
         IF (WINIT.EQ.WEND) THEN
            WINIT  = WSTART(1)
            WEND   = WSTART(NPIXA(2)) + (NPTOT(NPIXA(2))-1)*WSTEP
         END IF
         NAXISB    = 1
         NPIXB(1)  = (WEND-WINIT)/WSTEP + 1
         NPIXB(2)  = 1
         STARTB(1) = WINIT
         STARTB(2) = 1.
         STEPB(1)  = WSTEP
         STEPB(2)  = 0.
         CALL STIPUT(OUTFRM,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .        NAXISB,NPIXB,STARTB,STEPB,
     .        IDENTA,CUNITB,IPNTRB,OUTIMA,ISTAT)
C     
C     ... METHODS OF OVERLAPPING
C     
         IF (METHOD.EQ.'C') CALL ECHMR1(MADRID(IPNTRA),
     +        NPIXA(1),NPIXA(2),STARTA,
     +        STEPA,WSTART,NPTOT,MADRID(IPNTRB),
     +        NPIXB,STARTB,XMIN,XMAX)
         IF (METHOD.EQ.'A') CALL ECHMR2(MADRID(IPNTRA),
     +        NPIXA(1),NPIXA(2),STARTA,
     +        STEPA,WSTART,NPTOT,MADRID(IPNTRB),
     +        NPIXB,STARTB,XMIN,XMAX,DEL)


         IF (METHOD.EQ.'S') THEN
C     
C     ... READ RIPPLE TABLE ------------------------------------------
C     
            CALL TBTOPN('BLAZE',F_I_MODE,TID,ISTAT)
            CALL TBLSER(TID,LABEL(1),ICOL(1),ISTAT)
            CALL TBLSER(TID,LABEL(2),ICOL(2),ISTAT)
            CALL TBLSER(TID,LABEL(3),ICOL(3),ISTAT)
C
            DO 20 I = 1,NPIXA(2)-1
               CALL TBRRDR(TID,I,2,ICOL,VAL,NULL,ISTAT)

               IF(WSTART(1).GT.1000) THEN
C     looks like linear wavelength scale
                  WAVE(I)  = VAL(1)
               ELSE
C     looks like logarithmic wavelength scale
                  WAVE(I)  = VAL(3)
               ENDIF

               ORDER(I)   = VAL(2)
 20         CONTINUE
            
            DO 30 I=1,NPIXA(2)
               WAVE1(I) = WSTART(I)+DEL
               WAVE2(I) = WSTART(I)+(NPTOT(I)-1)*STEPA(1) - DEL
 30         CONTINUE

            DO 60 I=1,NPIXA(2)
               WAVE3(I) = WAVE1(I)
               WAVE4(I) = WAVE2(I)
 60         CONTINUE

            DO 40 I = 1,NPIXA(2)-2
               WAVE3(I+1)  = (WAVE(I)+WAVE(I+1))/2 -
     +              (WAVE(I+1)-WAVE(I))/2*1.5
               WAVE4(I+1)  = (WAVE(I)+WAVE(I+1))/2 +
     +              (WAVE(I+1)-WAVE(I))/2*1.5
               
 40         CONTINUE
            
            DO 50 I=1,NPIXA(2)
               WAVE1(I) = MAX(WAVE1(I),WAVE3(I))
               WAVE2(I) = MIN(WAVE2(I),WAVE4(I))
 50         CONTINUE
            

            CALL ECHMR3(MADRID(IPNTRA),
     +           NPIXA(1),NPIXA(2),STARTA,
     +           STEPA,WSTART,NPTOT,MADRID(IPNTRB),
     +           NPIXB,STARTB,XMIN,XMAX,DEL,WAVE1,WAVE2)
            
         END IF

C     ... DONE WITH RIPPLE TABLE --------------------------------------

C     
C     ... WRITE PROCESS DESCRIPTORS
C     
         CUT(1) = XMIN
         CUT(2) = XMAX
         CUT(3) = XMIN
         CUT(4) = XMAX
         CALL DSCUPT(INIMA,OUTIMA,' ',ISTAT)
         CALL STDWRR(OUTIMA,'LHCUTS',CUT,1,4,KUN,ISTAT)

      END IF
      CALL STSEPI
 9000 FORMAT (I5)
 9010 FORMAT ('ORDER:',I3)
      END

      SUBROUTINE ECHMR1(X,NPIXA1,NPIXA2,STARTA,STEPA,WI,NP,Y,NY,YSTR,
     +     XMIN,XMAX)
C     
C     MERGE THE ORDERS, USING SIMPLE CONCATENATION IN THE MIDDLE POINT
      IMPLICIT NONE
C     
      INTEGER  NY,J2,I,J1,JOFF,J,JJ
      REAL     XMIN,XMAX,WEN1,WST2,WSTART
      INTEGER  NPIXA1,NPIXA2
      INTEGER  NP(NPIXA2)
      REAL     X(NPIXA1,NPIXA2)
      DOUBLE PRECISION STARTA(2),STEPA(2),WI(NPIXA2),YSTR
      REAL     Y(NY)
      DOUBLE PRECISION WEND, YSTEP, YEND, WSTR
C     
      XMIN   = 0.
      XMAX   = 0.
      DO 10 I = 1,NY
         Y(I)   = 0.
 10   CONTINUE
      YSTEP  = STEPA(1)
      YEND   = YSTR + (NY-1)*YSTEP
C     
C     ... ITERATION ON ORDERS
C     
      WEND   = 0.
      DO 30 I = 1,NPIXA2
         WSTR   = DMAX1(WI(I),WEND+YSTEP)
         IF (I.EQ.NPIXA2) THEN
            WEND   = WI(I) + (NP(I)-1)*YSTEP
         ELSE
            WEN1   = WI(I) + (NP(I)-1)*YSTEP
            WST2   = WI(I+1)
            IF (WST2.LT.WEN1) THEN
               WEND   = 0.5* (WEN1+WST2)
            ELSE
               WEND   = WEN1
            END IF
         END IF

         IF (WSTR.GE.YEND) RETURN
         IF (WEND.GT.YSTR) THEN
C     
C     ... ITERATION ON WAVELENGTHS
C     
            WSTART = DMAX1(YSTR,WSTR)
            WEND   = DMIN1(WEND,YEND)
            J1     = NINT((WSTART-WI(I))/YSTEP) + 1
            J2     = NINT((WEND-WI(I))/YSTEP) + 1
            JOFF   = NINT((WI(I)-YSTR)/YSTEP)
            DO 20 J = J1,J2
               JJ     = J + JOFF
               IF (JJ.GT.0) THEN
                  Y(JJ)  = X(J,I)
                  XMAX   = MAX(XMAX,Y(JJ))
                  XMIN   = MIN(XMIN,Y(JJ))
               END IF

 20         CONTINUE
         END IF

 30   CONTINUE
      RETURN

      END

      SUBROUTINE ECHMR2(X,NPIXA1,NPIXA2,STARTA,STEPA,WI,NP,Y,NY,YSTR,
     +     XMIN,XMAX,DEL)
C     
C     MERGE THE ORDERS, AVERAGE ON THE OVERLAPPING REGION
C     
      IMPLICIT NONE
C     
      INTEGER NPIXA1, NPIXA2, NY
      INTEGER NP(NPIXA2)
      REAL X(NPIXA1,NPIXA2)
      DOUBLE PRECISION STARTA(2),STEPA(2),YSTR,DEL,WI(NPIXA2)
      REAL Y(NY), XMIN, XMAX
C     
      INTEGER I, IORD1, IORD2, IPIX, IPIX1, IPIX2
      DOUBLE PRECISION YSTEP, W0, W1, WL, P1, P2
C     
      XMIN   = 0.
      XMAX   = 0.
      DO 10 I = 1,NY
         Y(I)   = 0.
 10   CONTINUE
      YSTEP  = STEPA(1)
      IORD1  = 1
      IORD2  = 2
      W0     = WI(IORD2) + DEL
      W1     = WI(IORD1) + (NP(IORD1)-1)*YSTEP - DEL
C     
C     ... ITERATION ON ORDERS
C     
      DO 20 IPIX = 1,NY
         WL     = YSTR + (IPIX-1)*YSTEP
         IF (WL.LT.W0) THEN
            IPIX1  = NINT((WL-WI(IORD1))/YSTEP) + 1
            Y(IPIX) = X(IPIX1,IORD1)
            XMAX   = MAX(Y(IPIX),XMAX)
            XMIN   = MIN(Y(IPIX),XMIN)
         ELSE IF (WL.LT.W1) THEN
            IPIX1  = NINT((WL-WI(IORD1))/YSTEP) + 1
            IPIX2  = NINT((WL-WI(IORD2))/YSTEP) + 1
            P2     = (WL-W0)/ (W1-W0)
            P1     = 1.D0 - P2
            IF (X(IPIX1,IORD1).LE.0.0) THEN
               P2     = 1.D0
               P1     = 0.D0
            END IF
            IF (X(IPIX2,IORD2).LE.0.0) THEN
               P2     = 0.D0
               P1     = 1.D0
            END IF
            Y(IPIX) = X(IPIX1,IORD1)*P1 + X(IPIX2,IORD2)*P2
            XMAX   = MAX(Y(IPIX),XMAX)
            XMIN   = MIN(Y(IPIX),XMIN)
         ELSE
            IORD1  = IORD1 + 1
            IF (IORD1.GT.NPIXA2) RETURN
            IORD2  = IORD2 + 1
            IF (IORD2.GT.NPIXA2) THEN
               W0     = 1.E20
            ELSE
               W0     = WI(IORD2) + DEL
            END IF
            W1     = WI(IORD1) + (NP(IORD1)-1)*YSTEP - DEL
            IPIX1  = NINT((WL-WI(IORD1))/YSTEP) + 1
            Y(IPIX) = X(IPIX1,IORD1)
            XMAX   = MAX(Y(IPIX),XMAX)
            XMIN   = MIN(Y(IPIX),XMIN)
         END IF
 20   CONTINUE
      RETURN
      END

      SUBROUTINE COPY(A,NA1,NA2,B,NB,I,XMIN,XMAX)
C     
C     COPY THE ORDER NUMBER I
C     
      IMPLICIT NONE
      INTEGER NA1, NA2, NB, I, J
      REAL A(NA1,NA2),B(NB)
      REAL XMIN, XMAX
C     
      XMIN = 0.
      XMAX = 0.
C     
      DO 10 J = 1,NB
         B(J)   = A(J,I)
         XMIN   = MIN(B(J),XMIN)
         XMAX   = MAX(B(J),XMAX)
 10   CONTINUE
      RETURN
      END

      SUBROUTINE ECHMR3(X,NPIXA1,NPIXA2,STARTA,STEPA,WI,NP,Y,NY,YSTR,
     +     XMIN,XMAX,DEL,WAVE1,WAVE2)
C     
C     MERGE THE ORDERS, AVERAGE ON THE OVERLAPPING REGION
C     
      IMPLICIT NONE
C     
      INTEGER NPIXA1, NPIXA2, NY
      INTEGER NP(NPIXA2)
      REAL X(NPIXA1,NPIXA2)
      DOUBLE PRECISION STARTA(2),STEPA(2),YSTR,DEL,WI(NPIXA2)
      REAL Y(NY), XMIN, XMAX, WAVE1(NPIXA2), WAVE2(NPIXA2)
C     
      INTEGER I, IORD1, IORD2, IPIX, IPIX1, IPIX2
      DOUBLE PRECISION YSTEP, W0, W1, WL, P1, P2
C     
      XMIN   = 0.
      XMAX   = 0.
      DO 10 I = 1,NY
         Y(I)   = 0.
 10   CONTINUE
      YSTEP  = STEPA(1)
      IORD1  = 1
      IORD2  = 2

C      W0     = WI(IORD2) + DEL
C      W1     = WI(IORD1) + (NP(IORD1)-1)*YSTEP - DEL

      W0 = WAVE1(IORD2)
      W1 = WAVE2(IORD1)
C     
C     ... ITERATION ON ORDERS
C     
      DO 20 IPIX = 1,NY
         WL     = YSTR + (IPIX-1)*YSTEP
         IF (WL.LT.W0) THEN
            IPIX1  = NINT((WL-WI(IORD1))/YSTEP) + 1
            Y(IPIX) = X(IPIX1,IORD1)
            XMAX   = MAX(Y(IPIX),XMAX)
            XMIN   = MIN(Y(IPIX),XMIN)
         ELSE IF (WL.LT.W1) THEN
            IPIX1  = NINT((WL-WI(IORD1))/YSTEP) + 1
            IPIX2  = NINT((WL-WI(IORD2))/YSTEP) + 1
            P2     = (WL-W0)/ (W1-W0)
            P1     = 1.D0 - P2
            IF (X(IPIX1,IORD1).LE.0.0) THEN
               P2     = 1.D0
               P1     = 0.D0
            END IF
            IF (X(IPIX2,IORD2).LE.0.0) THEN
               P2     = 0.D0
               P1     = 1.D0
            END IF
            Y(IPIX) = X(IPIX1,IORD1)*P1 + X(IPIX2,IORD2)*P2
            XMAX   = MAX(Y(IPIX),XMAX)
            XMIN   = MIN(Y(IPIX),XMIN)
         ELSE
            IORD1  = IORD1 + 1
            IF (IORD1.GT.NPIXA2) RETURN
            IORD2  = IORD2 + 1
            IF (IORD2.GT.NPIXA2) THEN
               W0     = 1.E20
            ELSE
C               W0     = WI(IORD2) + DEL
               W0     = WAVE1(IORD2)
            END IF
C            W1     = WI(IORD1) + (NP(IORD1)-1)*YSTEP - DEL
            W1     = WAVE2(IORD1)
            IPIX1  = NINT((WL-WI(IORD1))/YSTEP) + 1
            Y(IPIX) = X(IPIX1,IORD1)
            XMAX   = MAX(Y(IPIX),XMAX)
            XMIN   = MIN(Y(IPIX),XMIN)
         END IF
 20   CONTINUE
      RETURN
      END

C @(#)rfotanalys.for	19.1 (ES0-DMD) 02/25/03 13:30:13
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION: RFOTANALYS
C.PURPOSE:   Select all stars within selected subfield (input mode)
C.           Look at results of fit operation and select results for final
C.           storage (output mode)
C.AUTHOR:    R. Buonanno, G. Buscema, C. Corsi, I. Ferraro, G. Iannicola
C.           Osservatorio Astronomico di Roma
C.           Modified for MIDAS:  Rein. H. Warmels, ESO
C.VERSION    870127  RHW  First implementation in MIDAS
C.VERSION    890425  RHW  Implementation of the ST interfaces
C.VERSION    890425  RHW  Conversion for the Portable MIDAS version
C.NOTES:     This program is a modified version of the orginal Romafot module
C            It consists of a main body and a number of procedures which 
C            correspond which the options the program offers to the user.
C----------------------------------------------------------------------------
       PROGRAM      ANALYS

       IMPLICIT     NONE
       INCLUDE      'MID_REL_INCL:RFOTDECL.INC'
C
       INTEGER      MX1
       INTEGER      MY1
       INTEGER      MX2
       INTEGER      KFD
       INTEGER      MXYF
       INTEGER      MXYR
       INTEGER      MBB
       INTEGER      NCD
       INTEGER      NTB
       INTEGER      NN
       INTEGER      IDP
       INTEGER      IDB
       PARAMETER    (MX1=55)
       PARAMETER    (MY1=MX1)
       PARAMETER    (MX2=110)
       PARAMETER    (KFD=10000) 
       PARAMETER    (MXYF=MX1*3+15) 
       PARAMETER    (MXYR=(MX1*3)*2+30)
       PARAMETER    (MBB=256)
       PARAMETER    (NCD=MBB-18)
       PARAMETER    (NTB=NCD/3)
       PARAMETER    (NN=NCD/6.5)
       PARAMETER    (IDP=(NN*4)+3)
       PARAMETER    (IDB=NTB*3)
C
C *** Procedure names
       INTEGER      ACCSTE,ACSTDA,APPDAT,APPNF,APRKFI
       INTEGER      CONMAT,CANREC,COLFAC,CAMSLO
       INTEGER      DIMMAT,DISAGA,DISISO,DEPM,DEFMAP,DEFR
       INTEGER      DELCMP,DELHOL,FABUC, FINPRO,GRAISO,HELP
       INTEGER      INIFIN,INPDAT,INTEGR,ISOSTE, LEMARA, LEGMAT
       INTEGER      PARLAS,PNONCE,PREMAS
       INTEGER      RICFIL,RESMAT,RIPBUC,RIPFIN,RIPMAS
       INTEGER      RISCOM,RIMANF
       INTEGER      SCRBUC,SPOMAT,SCAPRO,SEREOU,SEREIN
       INTEGER      SMOOTH
       INTEGER      TROLIV,TYPNOM,TYPCOM
       INTEGER      VISMAT,WNDRD,XYMAX,VERREC
C
C ***  MIDAS parameters
       INTEGER      NONS(NN)
       INTEGER      CURDAT(4)
       INTEGER      MADRID(1)
       INTEGER      IVB(KFD)
       INTEGER      IINPUT(10)
       REAL         PB(IDB)
       REAL         RMASK(MX1,MY1)
       REAL         RNY(MY1,MX1)
       REAL         RNF(MY1,MX1)
       REAL         VVV(13)
       REAL         P(IDP)
       REAL         RIA(MX2)
       REAL         USC(NN),USE(NN)
       REAL         RESI(MY1,MX1)
       REAL         RINPUT(10)
       LOGICAL      COND
       LOGICAL      NEXTW
       LOGICAL      KALO
       LOGICAL      LOG23
       CHARACTER    CCOM*1
       CHARACTER    STRING*80
       CHARACTER    DSA*1, RAI*1, IGS*1, IGS2*1, CAR*1, IOD*1
       CHARACTER    SMY*1, INY*1, BBC*1, IAM*1, RFM*1
C
       INTEGER      COOS(2,2),IXYA(2),IXYB(2),MCA,MCB,ISCA,ISCB
       INTEGER      DAZHLD(14),UNI(1),NULO,ENTFLG,GRE
       INTEGER      ED, EC, EL
       INTEGER      FLAGS(2)
       INTEGER      IWND, IDWND, IDWND1
       INTEGER      IRWND1, IRWND2, IRWNDC, IRWNDI
       INTEGER      IDHOL, IDHOL1, IRHOL, IHOL
       INTEGER      IDISIS, IPIANT
       INTEGER      IDCMP, IDCMP1, IRCMP, IROW, ICMP
       INTEGER      INDM, IIST, IGL, ISIT
       INTEGER      I1, I2, I3
       INTEGER      IDN, IFG, IAI
       INTEGER      IAX, IAY
       INTEGER      I, IC, IH, IHS, ICB, IK
       INTEGER      IX, IY
       INTEGER      IX0, IY0
       INTEGER      IHO
       INTEGER      ILX, ILY
       INTEGER      IPX, IPY
       INTEGER      IPXE, IPYE
       INTEGER      IP3
       INTEGER      IPXS, IPYS
       INTEGER      IPXSA, IPYSA
       INTEGER      IPJ1, IPJ2, IPJX, IPJY
       INTEGER      IMF
       INTEGER*8    IPNTR
       INTEGER      IA1, IA2, IA3, IA4, IA5, IA6, IA7, IA8
       INTEGER      IZE, IHE, IFA, IFONDO
       INTEGER      IAC, ISTAT, IAV
       INTEGER      JX, JY
       INTEGER      JFVR
       INTEGER      JIL, JAC, JN, J5, JK
       INTEGER      KK1, KK2 
       INTEGER      K3
       INTEGER      KAUT, K23
       INTEGER      LF4, LFF, LI
       INTEGER      LIV, LLVV
       INTEGER      L, LCHAR
       INTEGER      L2, L3, L4, L5
       INTEGER      L21, L22 
       INTEGER      LLL, LSTA, LSTO
       INTEGER      LJ1, LJ3, LK
       INTEGER      LMB, L78, K1G
       INTEGER      MX, MY
       INTEGER      N1, NOC, NN1, NNI
       INTEGER      NPI, NCI, NWD, NHL, MAXH, NC, NP, NCP, NFINP
       INTEGER      NITER
       INTEGER      NAXIS, NPL, NL
       INTEGER      N1X, N1Y
       INTEGER      NOBJ, NGR
       INTEGER      NSR, NIL, NPN, NCN
       INTEGER      NOCHAN, NSTCAT
       INTEGER      NPI1, NPC1
       INTEGER      NPM, NCM
       INTEGER      NULL
       INTEGER      TIDCAT, TIDINT
       REAL         AMINH
       REAL         AAX, AAY
       REAL         AX, AY
       REAL         BBB, P33
       REAL         AAII, SOSO
       REAL         AM
       REAL         D1, D2, D3, D4, DDD, DELT
       REAL         RMA, RR
       REAL         V, B, U, H
       REAL         FLCO, F78, FAT, FOG, SCAP, FOG1
       REAL         CUU, SIGMA, BETA, SAT, AIN, SIV
       REAL         SAS01, S01, SOAL, SSS
       REAL         VG, ESPO
       REAL         PIXV, PMAX
       REAL         FATSA, FATT1, RABU, ZESI, RL
       REAL         BA1, BA2, BA3, BA4, BA5, BA6
       REAL         DUM1, DUM2, DUM3, DUM4, DUM5 ,DUM6
       REAL         DUM7, DUM8, DUM9, DUM10, DUM11, DUM12, DUM13
       
       INTEGER      KUN, KNUL
       INTEGER      NCCAT, NRCAT, NSCAT, NACCAT, NARCAT
       INTEGER      NCINT, NRINT, NSINT, NACINT, NARINT
       INTEGER      INTNUM(2),CATNUM(2)
       INTEGER      NPIX(3)
       INTEGER      TINULL
       INTEGER      COLERR
       INTEGER      ERRCOD,CHAN

       DOUBLE PRECISION BEGIN(3),STEP(3)
       DOUBLE PRECISION TDNULL,TDTRUE,TDFALS
       REAL         TRNULL,TBLSEL
       CHARACTER    FRAME*60,CATFIL*60,INTFIL*60
       CHARACTER    IDENT*72,CUNIT*72
       CHARACTER*60 GRPREF,IDNREF
       LOGICAL      CATAL
C
       REAL         GALEG
       REAL         GALE2
C
       INCLUDE      'MID_INCLUDE:ST_DEF.INC'
       INCLUDE      'MID_INCLUDE:IDIDEV.INC'
       INCLUDE      'MID_INCLUDE:IDIMEM.INC'
       COMMON       /VMR/MADRID
C
       INTEGER      ICGRP
       INTEGER      ICIDN
       INTEGER      ICGEN(NINTP)
       INTEGER      ICFLG
       INTEGER      ICPAR(NINTC)
C
       INCLUDE      'MID_INCLUDE:ST_DAT.INC'
       DATA         ICGRP/1/
       DATA         ICIDN/2/
       DATA         ICGEN/3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18/
       DATA         ICFLG/19/
       DATA         ICPAR/20,21,22,23,24,25/
C
       DATA         NEXTW/.FALSE./
       DATA         CATAL/.FALSE./
       DATA         GRPREF/':GROUP'/
       DATA         IDNREF/':IDENT'/
       DATA         CHAN/0/
       DATA         SMY/'N'/
       DATA         INY/'N'/
       DATA         CURDAT/100,1,1,2/
       DATA         COOS/-1,-1,-1,-1/
       DATA         FLAGS/1,1/
C
C *** format statements
  30  FORMAT('*** INFO: Number of components to examine: ',I5)

C
C *** Start the program *****************************************************
      CALL STSPRO('ANALYS')
      CALL DTOPEN(1,ERRCOD)
      CALL STKRDI('DAZHOLD',1,14,IAV,DAZHLD,UNI,NULO,ISTAT)
      CALL CONCHA(QDSPNO,QIMCH,0,0)                            ! clear image
      CALL CONCHA(QDSPNO,QOVCH,0,0)                            ! clear graphics
C
      NOC = DAZHLD(1)
      IF (DAZHLD(2).EQ.-1) THEN
         IF (NOC.EQ.2) THEN
            N1  = 0
            NN1 = 0
         ELSE
            N1  = 3
            NN1 = 2
         ENDIF
      ELSE
         N1  = 99
         NN1 = 2
      ENDIF
C
      IF (IDINUM.EQ.11) THEN
         ENTFLG = 1
      ELSE 
         ENTFLG = 2
      ENDIF
      CALL SETCUR(QDSPNO,NOC,N1,NN1,COOS,ISTAT)
C
      CALL TBMNUL(TINULL,TRNULL,TDNULL)
      CALL TBMCON(TBLSEL,TDTRUE,TDFALS)
      NNI = NN 
      LMB = NTB
      MX  = MX1
      MY  = MY1
C
C *** read the frame
      CALL STKRDC('IN_A',1,1,60,IAC,FRAME,KUN,KNUL,ISTAT)
      CALL STIGET(FRAME,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,3,NAXIS,
     2            NPIX,BEGIN,STEP,IDENT,CUNIT,IPNTR,IMF,ISTAT)
      NPL   = NPIX(1)
      NL    = NPIX(2)
C
C *** read the catalogue file
      CALL STKRDC('IN_B',1,1,60,IAC,CATFIL,KUN,KNUL,ISTAT)     ! catalogue file
C
C *** read the intermediate file
      CALL STKRDC('INPUTC',1,1,60,IAC,INTFIL,KUN,KNUL,ISTAT)     ! interm. file
C
C *** open the catalogue table
      CALL STECNT('GET',EC,ED,EL)
      CALL STECNT('PUT',1,0,0)
      CALL TBTOPN(CATFIL,F_IO_MODE,TIDCAT,ISTAT)
      IF (ISTAT.NE.0) THEN                                       ! problems
         CATAL = .FALSE.
         STRING = '*** INFO: No catalogue table present'
         CALL STTPUT(STRING,ISTAT)

      ELSE                                             ! get catalog table info
         CALL TBIGET(TIDCAT,NCCAT,NRCAT,NSCAT,NACCAT,NARCAT,ISTAT)
         IF (ISTAT.NE.0) THEN
            STRING = '*** FATAL: Problems with getting info for '//
     2               ' catalogue table; Try again ... '
            CALL STTPUT(STRING,ISTAT)
            CALL STSEPI
         ENDIF
C
         IF (NRCAT.EQ.0) THEN
            STRING = '*** FATAL: No data points in catalogue table'
            CALL STTPUT(STRING,ISTAT)
            CALL STSEPI
         ENDIF
C
         CATAL  = .TRUE.                                 ! catalogue is present
         IRWNDC = 1                                    ! and read the catalogue
         CALL CATTRD(TIDCAT,IRWNDC,CUU,VVV(1),VVV(2),VVV(3),VVV(4),
     2                      VVV(5),VVV(6),VVV(7),VVV(8),VVV(9),
     3                      VVV(10),VVV(11),VVV(12),VVV(13))
         CALL TBCSER(TIDCAT,GRPREF,CATNUM(1),ISTAT)     ! CAT column for group
         SIGMA = VVV(9)
         BETA  = VVV(10)
         SAT   = VVV(11)
         AIN   = VVV(12)
         SIV   = VVV(13)
      ENDIF
C
C *** get the intermediate table
      CALL TBTOPN(INTFIL,F_IO_MODE,TIDINT,ISTAT)
      IF (ISTAT.NE.0) THEN                                   ! no interm. table
         IF (.NOT.CATAL) THEN
            STRING = '*** FATAL: You need at least a catalogue or '//
     2                          'an intermediate table ...'
            CALL STTPUT(STRING,ISTAT)
            CALL STSEPI
         ELSE
            STRING = '*** INFO: No intermediate table present '//
     2                          'we will create one'
            CALL STTPUT(STRING,ISTAT)
            CALL INTINI(INTFIL,TIDINT)                   ! create interm. table
            CALL TBCSER(TIDINT,GRPREF,INTNUM(1),ISTAT)   ! column for group 
            CALL TBCSER(TIDINT,IDNREF,INTNUM(2),ISTAT)   ! column for ident
            NGR    = 0                                   ! number of groups
            NOBJ   = 0                                   ! number of objects
            NSR    = 0                                   ! number of iterations
            IRWNDI = 0                                ! point to current group 
            NRINT  = 0                                   ! number of rows
         ENDIF

      ELSE                            !table present; does it contain something
         CALL TBIGET(TIDINT,NCINT,NRINT,NSINT,NACINT,NARINT,ISTAT)
         IF (ISTAT.NE.0) THEN
             STRING = '*** FATAL: Problems with getting info for '//
     2                ' intermediate table; Try again ... '
             CALL STTPUT(STRING,ISTAT)
             CALL STSEPI
         ENDIF
C
         IF (NRINT.EQ.0) THEN
            STRING = '*** FATAL: No data points in intermediate table'
            CALL STTPUT(STRING,ISTAT)
            IF (CATAL) THEN
               NNI    = 5
               NGR    = 0
               NOBJ   = 0
               NSR    = 0
               IRWNDI = 0                           ! pointer to current group 
               NRINT  = 0                                      ! number of rows
               GO TO 50
            ELSE
               CALL STSEPI
            ENDIF
         ENDIF
C                                                       ! read table descriptor
         CALL INTDRD(TIDINT,NGR,NOBJ,NSR,SAT,FAT,SIGMA,BETA,SIV,AIN,FOG)
         CALL TBCSER(TIDINT,GRPREF,INTNUM(1),ISTAT)     ! INT column for group 
         CALL TBCSER(TIDINT,IDNREF,INTNUM(2),ISTAT)      ! INT column for ident
      ENDIF
   50 CONTINUE
C
C ***  
      ASSIGN 50151 TO PARLAS  
      GO TO 50051
50151 CONTINUE

C
C *** do the work !!!
      NOCHAN = 1
      KAUT   = 1
C
      IF (CATAL) THEN
         CALL CATDRD(TIDCAT,NSTCAT,IA1,IA2,BA1,BA2,IA3,IA4,IA5,IA6,
     2                          BA3,BA4,BA5,BA6,IA7,IA8)
      ELSE
         NSTCAT = 0
      ENDIF
      WRITE(STRING,30) NSTCAT
      CALL STTPUT(STRING,ISTAT)
C
      IRWNDI = 0
      IAM    = 'M'
      RAI    = 'M'
      BBC    = 'M'
      IGS    = 'A'
      IZE    = 1
      IHE    = 1
      SAS01  = 0.007
      S01    = SAS01
      NPI    = 23
      NCI    = 23
      DSA    = 'A'
      DDD    = 3.
      K23    = 0
      F78    = 1.
      FATSA  = 4
      FATT1  = FATSA
      ZESI   = -2.
      DO 101 I = 1,NN
         FLGCMP(I) = 1
         FLGHOL(I) = 1
  101 CONTINUE
C
 100  continue
      IF (CAR.EQ.'F') THEN
         CALL INTDWR(TIDINT,NGR,NOBJ,NSR,SAT,FAT,SIGMA,BETA,SIV,AIN,FOG)
         CALL TBSINI(TIDINT,ISTAT)                          ! close the old one
         CALL TBTCLO(TIDINT,ISTAT)                          ! close the old one
         CALL DTCLOS(QDSPNO)
         CALL STSEPI
      ENDIF
C
      KALO = .FALSE.
      CALL UPCAS(CCOM,CCOM)    
      IF (CCOM.EQ.'M') THEN
         CALL STKPRC('Enter option [M]: ',
     2            'INPUTC',1,1,1,IAV,CCOM,KUN,KNUL,ISTAT)
         IF (IAV.EQ.0) THEN
            CCOM = 'M'
         ENDIF

      ELSE
         CALL STKPRC('Enter option [D]: ',
     2            'INPUTC',1,1,1,IAV,CCOM,KUN,KNUL,ISTAT)
         IF (IAV.EQ.0) THEN
            CCOM = 'D'
         ENDIF
      ENDIF

      CALL UPCAS(CCOM,CAR)    
      IF (CAR.EQ.'D' .OR. CAR.EQ.'M') THEN
         KALO = .TRUE.
      ENDIF
C
C *** here come the choises
      IF (CAR.EQ.'A') THEN
         ASSIGN 50101 TO DEFMAP
         GO TO 50001
50101    CONTINUE

      ELSE IF (CAR.EQ.'B') THEN
         ASSIGN 50102 TO SCAPRO
         GO TO 50002
50102    CONTINUE

      ELSE IF (CAR.EQ.'C') THEN
         ASSIGN 50103 TO CANREC
         GO TO 50003
50103    CONTINUE

      ELSE IF ((CAR.EQ.'D') .OR. (KALO.AND.KAUT.EQ.2)) THEN
         ASSIGN 50104 TO CONMAT
         GO TO 50004
50104    CONTINUE

      ELSE IF (CAR.EQ.'E') THEN
         STRING = 'E__Use cursor to pass the hole coordinates'
         CALL STTPUT(STRING,ISTAT)
         CALL CURSIN(QDSPNO,0,NOC,IXYA,MCA,ISCA,IXYB,MCB,ISCB)
         CALL CURSIN(QDSPNO,ENTFLG,NOC,IXYA,MCA,ISCA,IXYB,MCB,ISCB)
         IX = IXYA(1)
         IY = IXYA(2)
         ASSIGN 50105 TO FABUC
         GO TO 50005
50105    CONTINUE

      ELSE IF (CAR.EQ.'F') THEN
         ASSIGN 50106 TO FINPRO
         GO TO 50006
50106    CONTINUE

      ELSE IF (CAR.EQ.'G') THEN
         ASSIGN 50107 TO RIPBUC
         GO TO 50007
50107    CONTINUE

      ELSE IF (CAR.EQ.'H') THEN
         ASSIGN 50108 TO HELP
         GO TO 50008
50108    CONTINUE

      ELSE IF ((CAR.EQ.'I') .OR. (CAR.EQ.'J')) THEN
         ASSIGN 50109 TO INPDAT
         GO TO 50009
50109    CONTINUE

      ELSE IF (CAR.EQ.'K') THEN
         ASSIGN 50111 TO XYMAX
         GO TO 50011
50111    CONTINUE

      ELSE IF (CAR.EQ.'L') THEN
         ASSIGN 50112 TO TROLIV
         GO TO 50012
50112    CONTINUE

      ELSE IF ((CAR.EQ.'M') .OR. (KALO .AND. KAUT.EQ.1)) THEN
         ASSIGN 50113 TO ACCSTE
         GO TO 50013
50113    CONTINUE

      ELSE IF (CAR.EQ.'N') THEN
         ASSIGN 50114 TO ACSTDA
         GO TO 50014
50114    CONTINUE

      ELSE IF (CAR.EQ.'P') THEN
         ASSIGN 50116 TO ISOSTE
         GO TO 50016
50116    CONTINUE

      ELSE IF (CAR.EQ.'Q') THEN
         ASSIGN 50117 TO RIPFIN
         GO TO 50017
50117    CONTINUE

      ELSE IF (CAR.EQ.'R') THEN
         ASSIGN 50118 TO RESMAT
         GO TO 50018
50118    CONTINUE

      ELSE IF (CAR.EQ.'S') THEN
         ASSIGN 50119 TO SPOMAT
         GO TO 50019
50119    CONTINUE

      ELSE IF (CAR.EQ.'T') THEN
         ASSIGN 50120 TO PNONCE
         GO TO 50020
50120    CONTINUE

      ELSE IF (CAR.EQ.'U')THEN
         ASSIGN 50121 TO COLFAC
         GO TO 50021
50121    CONTINUE

      ELSE IF (CAR.EQ.'V') THEN
         ASSIGN 50122 TO APRKFI
         GO TO 50022
50122    CONTINUE

      ELSE IF (CAR.EQ.'W') THEN
         ASSIGN 50123 TO CAMSLO
         GO TO 50023
50123    CONTINUE

      ELSE IF ((CAR.EQ.'X') .OR. (CAR.EQ.'Y')) THEN
         ASSIGN 50124 TO DISISO
         IDISIS = 1
         GO TO 50024
50124    CONTINUE

      ELSE IF (CAR.EQ.'Z') THEN
         ASSIGN 50126 TO DEPM
         GO TO 50026
50126    CONTINUE

      ELSE IF (CAR.EQ.'4') THEN
         ASSIGN 50134 TO SEREOU
         GO TO 50034
50134    CONTINUE

      ELSE IF (CAR.EQ.'5') THEN
         ASSIGN 50135 TO SEREIN
         GO TO 50035
50135    CONTINUE

      ELSE IF (CAR.EQ.'6') THEN
         ASSIGN 50136 TO SMOOTH
         GO TO 50036
50136    CONTINUE

      ELSE IF (CAR.EQ.'7') THEN
         ASSIGN 50137 TO INTEGR
         GO TO 50037
50137    CONTINUE

      ELSE IF (CAR.EQ.' ') THEN
         ASSIGN 50141 TO DISAGA
         GO TO 50041
50141    CONTINUE

      ELSE IF(CAR.EQ.'/') THEN
         ASSIGN 50142 TO DIMMAT
         GO TO 50042
50142    CONTINUE

      ELSE IF (CAR.EQ.'?') THEN
         ASSIGN 50143 TO DEFR
         GO TO 50043
50143    CONTINUE

      ELSE IF (CAR.EQ.'-') THEN
         ASSIGN 50144 TO SCRBUC
         GO TO 50044
50144    CONTINUE

      ELSE IF (CAR.EQ.'@') THEN
         ASSIGN 50145 TO RISCOM
         GO TO 50045
50145    CONTINUE

      ELSE
         CALL STTPUT('*** WARNING: Unknown ANALYSE option, '//
     2               'try again ...',ISTAT)
      END IF
      GO TO 100

C+++
50001  CONTINUE                                        ! Proc. DEFMAP; option A
C---
       IF (IPIANT.EQ.0) THEN
          IPIANT = 1
          CALL STTPUT('*** INFO: Colour map display enabled',ISTAT)
       ELSE
          IPIANT = 0
          CALL STTPUT('/__*** INFO: Contour map display enabled',ISTAT)
       ENDIF
C
       GO TO DEFMAP

C+++
50002  CONTINUE                                        ! Proc. SCAPRO; option B
C---
       CALL STKPRR('B__Enter graphic scale factor: ',
     2             'INPUTR',1,1,IAV,F78,KUN,KNUL,ISTAT)
       GO TO SCAPRO

C+++
50003  CONTINUE                                        ! Proc. CANREC; option C
C---
59003  FORMAT('C__*** INFO: Group',I5,' has ',I3,' component(s)')
58003  FORMAT('C__*** WARNING: Cannot find our component ',I3, 
     2        '; sorry ...')
C
       IF (NCP.GE.1) THEN
          WRITE(STRING,59003) IDWND,NCP                   ! write group  + comp
          CALL STTPUT(STRING,ISTAT)
          CALL STKPRI('C__Enter component to be deleted: ',
     2                'INPUTI',1,1,IAV,IDCMP,KUN,KNUL,ISTAT)
C
          IDCMP1 = IDCMP+100                                   ! ident in table
          CALL TBESRI(TIDINT,INTNUM(2),IDCMP1,COLERR,IRWNDI,
     2                IRCMP,ISTAT)
          IF (IRCMP.LE.0) THEN                           ! can't find component
             WRITE(STRING,58003) IDCMP
             CALL STTPUT(STRING,ISTAT)
             GO TO CANREC                                   ! return to monitor
          ELSE
             ICMP = IRCMP - IRWNDI + 1               ! which component in table
          ENDIF
C
          IF (ICMP.GT.NCP) THEN                             ! in another group 
             WRITE(STRING,58003) IDCMP
             CALL STTPUT(STRING,ISTAT)
             GO TO CANREC                                   ! return to monitor
          ELSE
             GRE = 0
             ASSIGN 50172 TO DELCMP                      ! delete the component
             GO TO 50072
50172        CONTINUE
             ASSIGN 50270 TO WNDRD                          ! reread the group 
             GO TO 50070
50270        CONTINUE
          ENDIF
C
       ELSE
          IF (IDWND.EQ.0) THEN                                ! no group  known
             CALL STTPUT('C__*** INFO: Group disabled or unknown',
     2                   ISTAT)
          ELSE                                                  ! no components
             CALL STTPUT('C__*** INFO: No components in this group  '//
     2                   '; sorry ...',ISTAT)
          ENDIF
       ENDIF
C
       GO TO CANREC

C+++
50004  CONTINUE                                        ! Proc. CONMAT; option D
C---
58004  FORMAT('D__*** WARNING: Sorry, requested group not present')
C
       IOD  = 'D'
       JFVR = 0
C
51004  CONTINUE
       IF (JFVR.NE.0) GO TO 55004
          IF (RAI.EQ.'M') THEN                               ! manual selection
             CALL STKPRI('D__Enter group identification: ',
     2                  'INPUTI',1,1,IAV,IDWND,KUN,KNUL,ISTAT)      ! get ident
             CALL TBESRI(TIDINT,INTNUM(1),IDWND,COLERR,1,
     2                          IRWNDI,ISTAT)                      ! find ident
          ELSE                                                 ! auto selection
             IF (NEXTW) THEN
                IF (IRWNDI.EQ.0 .OR. (NCP+NHL.LE.1)) THEN  ! precaut. for start
                   IRWNDI = IRWNDI+1                              ! next group 
                ELSE
                   IRWNDI = IRWNDI+NCP+NHL                        ! next group 
                ENDIF
             ELSE
                NEXTW = .TRUE.
             ENDIF
          END IF
C
C *** read the object ocmponents and holes
          IF (IRWNDI.LE.NRINT .AND. IRWNDI.GE.1) THEN           ! valid group 
             ASSIGN 50170 TO WNDRD                               ! read group 
             GO TO 50070
50170        CONTINUE
             JFVR  = 0
             IF (RAI.NE.'M' .AND. RAI.NE.'A') THEN       ! manual or automatic
                ASSIGN 50152 TO VERREC
                GO TO 50052
50152           CONTINUE
             ELSE
                JFVR = 1
             END IF

          ELSE                                                ! nonvalid group 
             WRITE(STRING,58004)
             CALL STTPUT(STRING,ISTAT)
             JFVR  = 2
          END IF
          GO TO 51004
C
55004  CONTINUE
       IF (JFVR.EQ.1) THEN
          ASSIGN 50253 TO APPDAT
          GO TO 50053
50253     CONTINUE
          ASSIGN 50158 TO LEMARA
          GO TO 50058
50158     CONTINUE
          ASSIGN 50455 TO RIMANF
          GO TO 50055
50455     CONTINUE
C
          IF (IPIANT.EQ.0) THEN
             L78=200.0 - (P(3)*F78)/3.
             CALL PROFI5(RNF,MX,MY,NP,NC,L78,F78,'Y')
             CALL PIANT5(RNF,MX,MY,NP,NC,MXYF,FATT1,P(3),ZESI)
             CALL PIANT5(RESI,MX,MY,NP,NC,MXYR,FATT1,P(3),ZESI)
             K1G = 1
          ELSE
            ASSIGN 50324 TO DISISO
            GO TO 50024
50324       CONTINUE
          END IF
          CALL DAZVIS(QDSPNO,QIMCH,2,1)                    ! display everything
       END IF
C
       GO TO CONMAT

C+++
50005  CONTINUE                                         ! Proc. FABUC; option E
C---
59005  FORMAT ('E__*** WARNING: Maximum holes number allowed: ',I3)
C
       MAXH = (NCD-NCP*6.5)/3.
       IF (IOD.EQ.'D' .OR. K1G.GT.1) THEN
          INDM = (IX-1)/(MXYF-1)
          IX   = IX-(INDM*(MXYF-1))
       END IF
C
       IF (NHL.LT.MAXH) THEN             ! is there still space for more holes?
          RABU = 0.0
          CALL STKWRR('INPUTR',RABU,1,1,KUN,ISTAT)          ! store the default
          CALL STKPRR('E__Enter radius of the hole: ',
     2                 'INPUTR',1,1,IAV,RABU,KUN,KNUL,ISTAT)     ! get the hole
          IF (RABU.GT.0) THEN                                    ! legal radius
             ASSIGN 50166 TO RIPMAS
             GO TO 50066
50166        CONTINUE
C
C *** write the hole in the table
             PARINT(16) = FLOAT(NHL+1)                       ! increase # holes
             IRWND1     = IRWNDI
             IRWND2     = MAX((IRWNDI),(IRWNDI+NCP+NHL-1))
             DO 51005 IROW = IRWND1,IRWND2             ! update number of holes
                CALL TBEWRR(TIDINT,IROW,18,PARINT(16),ISTAT)
51005        CONTINUE
C
             NHL   = NHL + 1                     ! table contains one more hole
             NRINT = NRINT + 1                   ! table contains one more row
             IF (NHL.EQ.1) THEN
                IDNHOL(NHL) = 201                           ! ident of new hole
             ELSE
                IDNHOL(NHL) = IDNHOL(NHL-1) + 1             ! ident of new hole
             ENDIF
C
             FLGHOL(NHL)         = 1                         ! flag of new hole
             FITHOL((NHL-1)*3+1) = RABU
             FITHOL((NHL-1)*3+2) = (IX-1)/3+1
             FITHOL((NHL-1)*3+3) = (IY-1)/3+1
             CALL INTHWR(TIDINT,NRINT,NHL)
             CALL TBCSRT(TIDINT,2,INTNUM,FLAGS,ISTAT)
             ASSIGN 50870 TO WNDRD
             GO TO 50070
50870        CONTINUE
C
             ASSIGN 50559 TO PREMAS
             GO TO 50059
50559        CONTINUE
C
             GRE    = 0
             IF (IOD.EQ.'M') THEN
                IF (NFINP.EQ.1) THEN
                   NWD = NWD + 1
                ENDIF
                IDWND  = NWD
                NFINP  = 0
             END IF

          ELSE
             CALL STTPUT('E__*** WARNING: Do not know what to do with'//
     2                   ' this number, sorry ...',ISTAT)
          END IF
C
       ELSE
          WRITE(STRING,59005) MAXH
          CALL STTPUT(STRING,ISTAT)
       END IF
C
       GO TO FABUC

C+++
50006  CONTINUE                                        ! Proc. FINPRO; option F
C---
       CAR = 'N'
       CALL STKWRC('INPUTC',1,CAR,1,1,KUN,ISTAT)
       CALL STKPRC('F__Do you really want to finish? [N]: ',
     2             'INPUTC',1,1,1,IAV,CAR,KUN,KNUL,ISTAT)
       CALL UPCAS(CAR,CAR)    
       IF (CAR.EQ.'Y') THEN
          CAR = 'F'
       ELSE
          CAR = 'N'
       ENDIF
C
       GO TO FINPRO

C+++
50007  CONTINUE                                        ! Proc. RIPBUC; option G
C---
58007  FORMAT('G__*** WARNING: Cannot find our hole ',I3, 
     2        '; sorry ...')
C
       IF (NHL.GT.0) THEN
          CALL STKPRI('G___Enter hole identification to be restored: ',
     2                'INPUTI',1,1,IAV,IDHOL,KUN,KNUL,ISTAT)
          IDHOL1 = IDHOL+200
          CALL TBESRI(TIDINT,INTNUM(2),IDHOL1,COLERR,IRWNDI,
     2                IRHOL,ISTAT) 
C
C *** find component
          IF (IRHOL.LE.0) THEN                           ! can't find component
             WRITE(STRING,58007) IDHOL
             CALL STTPUT(STRING,ISTAT)
             GO TO RIPBUC
          ELSE
             IHOL = IRHOL-(IRWNDI+NCP-1)                  ! which hole in table
          ENDIF
C
          IF (IHOL.GT.NHL) THEN                             ! in another group 
             WRITE(STRING,58007) IDHOL
             CALL STTPUT(STRING,ISTAT)
             GO TO RIPBUC
          ELSE
             GRE = 0
             ASSIGN 50173 TO DELHOL                           ! delete the hole
             GO TO 50073
50173        CONTINUE
             ASSIGN 50370 TO WNDRD                          ! reread the group 
             GO TO 50070
50370        CONTINUE
          ENDIF
       
       ELSE
          IF (IDWND.EQ.0) THEN                                ! no group  known
             CALL STTPUT('G__*** INFO: Group disabled or unknown',
     2                   ISTAT)
          ELSE                                                  ! no components
             CALL STTPUT('G__*** INFO: No holes in this group'//
     2                   '; sorry ...',ISTAT)
          ENDIF
       ENDIF

       GO TO RIPBUC

C+++
50008  CONTINUE                                      ! Procedure HELP; option H
C---
50208  FORMAT('A: Display colour or a contour map')
50308  FORMAT('B: Scale intensity projections (data not affected)')
50408  FORMAT('C: Delete a component')
50508  FORMAT('D: Display a group from INTERMEDIATE table ',
     2            '(OUTPUT mode)')
50608  FORMAT('E: Make a hole of given radius at cursor position')
50708  FORMAT('F: Finish up')
50808  FORMAT('G: Restore a hole')
50908  FORMAT('H: Show the help documentation')
51008  FORMAT('I: Add a component at cursor position ',
     *            '(trial height is local maximum)')
51108  FORMAT('J: Add a component at cursor position ',
     *            '(trial height must be entered)')
51208  FORMAT('K: Give coordinates and pixel value at cursor position')
51308  FORMAT('L: Give height above the background at vertical cursor')
51408  FORMAT('M: Display a group of a input CATALOGUE table')
51508  FORMAT('N: Display a group from INTERMEDIATE table ',
     2            '(INPUT mode)')
51608  FORMAT('P: Enter star identification and disable all other',
     2            ' components')
51708  FORMAT('Q: Restore P')
51808  FORMAT('R: Reduce subarray to a particular size in x and y')
51908  FORMAT('S: Move the subarray in x and y')
52008  FORMAT('T: Disable star for display and registration;'
     2            ' undo with T(-n)')
52108  FORMAT('U: Redefine zero point of the colour scale')
52208  FORMAT('V: Close old files and open new ones')
52308  FORMAT('W: Change slope of the colour scale')
52408  FORMAT('X: Display isophotes')
52508  FORMAT('Y: Scale isophotes to an arbitrary threshold')
52608  FORMAT('Z: Give info or display components already considered')
52708  FORMAT('4: OUTPUT mode. Components to examine: A, M or S. ')
52808  FORMAT('   If selective examine only special subarrays: ')
52908  FORMAT('   No conv., height above ..., ',
     2            'more than ... iterations')
53008  FORMAT('5: INPUT mode. Components to examine: A, M or S. ')
53108  FORMAT('   If selective examine only special subarrays: ')
53208  FORMAT('   not grouped by GROUP, height above ...')
53308  FORMAT('6: Enable smoothing')
53408  FORMAT('7: Enable integration')
53508  FORMAT('bar: Repeat last display (with new parameters)')
53608  FORMAT('/: Change window size in x and y')
53708  FORMAT('-: Enable or disable reporting of holes')
53808  FORMAT('?: Enable or disable registration of previously',
     2            ' registrated subarrays')
53908  FORMAT('@: Replace or append one component with the next input')
C
       WRITE(STRING,50208)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,50308)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,50408)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,50508)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,50608)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,50708)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,50808)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,50908)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,51008)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,51108)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,51208)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,51308)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,51408)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,51508)
       CALL STTPUT(STRING,ISTAT)
       CALL STTPUT(' ',ISTAT)
       CALL STKPRC('*** Return for more','INPUTC',1,1,1,
     2             IAV,RFM,KUN,KNUL,ISTAT)

       WRITE(STRING,51608)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,51708)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,51808)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,51908)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,52008)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,52108)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,52208)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,52308)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,52408)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,52508)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,52608)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,52708)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,52808)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,52908)
       CALL STTPUT(STRING,ISTAT)
       CALL STTPUT(' ',ISTAT)
       CALL STKPRC('*** Return for more','INPUTC',1,1,1,
     2             IAV,RFM,KUN,KNUL,ISTAT)

       WRITE(STRING,53008)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,53108)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,53208)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,53308)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,53408)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,53508)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,53608)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,53708)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,53808)
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,53908)
       CALL STTPUT(STRING,ISTAT)
       CALL STTPUT(' ',ISTAT)
C
       GO TO HELP

C+++
50009  CONTINUE                                  ! Procedure INPDAT; option I+J
C---
59109  FORMAT('I__Component ',I6,' has been replace')
59209  FORMAT('J__Component ',I6,' has been replace')
58109  FORMAT('I__Component ',I6,' has been added')
58209  FORMAT('J__Component ',I6,' has been added')
57109  FORMAT('I__*** WARNING: Cannot find your component',I6)
57209  FORMAT('J__*** WARNING: Cannot find your component',I6)
56109  FORMAT('I__*** Error: Not more than ',I3,' components allowed')
56209  FORMAT('J__*** Error: Not more than ',I3,' components allowed')
C
       IF (CAR.EQ.'I') THEN
          STRING = 'I__Use cursor to pass the component coordinates'
       ENDIF
       IF (CAR.EQ.'J') THEN
          STRING = 'J__Use cursor to pass the component coordinates'
       ENDIF
       CALL STTPUT(STRING,ISTAT)
       CALL CURSIN(QDSPNO,0,NOC,IXYA,MCA,ISCA,IXYB,MCB,ISCB)
C
59909  CONTINUE
       CALL CURSIN(QDSPNO,ENTFLG,NOC,IXYA,MCA,ISCA,IXYB,MCB,ISCB)
       IF (ISCA.EQ.0) THEN                                  ! return to monitor
          GO TO INPDAT
       ENDIF
C
C *** do the work
       IX = IXYA(1)
       IY = IXYA(2)
       IF (IOD.EQ.'D'. OR. K1G.GT.1) THEN
          INDM = (IX-1)/(MXYF-1)
          IX   = IX-(INDM*(MXYF-1))
       END IF
C
       IF (IX.GE.1 .AND. IX.LE.NPM .AND. 
     2     IY.GE.1 .AND. IY.LE.NCM) THEN
          IF (CATAL .OR. IOD.NE.'M') THEN
             NNI = (NCD-NHL*3)/6.5
             IF (NCP.LT.NNI) THEN
                IPJ1   = (IX-1)/3+1
                IPJ2   = (IY-1)/3+1
C
C *** append a component
                IF (IGS.EQ.'A') THEN                       ! append a component
                   IF (IOD.EQ.'M') THEN
                      CALL TBESRI(TIDINT,INTNUM(1),IDWND,COLERR,1,
     2                            IRWNDI,ISTAT)                   ! find group
                      IF (IRWNDI.GT.0 .AND. IRWNDI.LE.NRINT) THEN       ! known
                         CALL INTWRD(TIDINT,IRWNDI,NCP,NHL)
                         IRWND1     = IRWNDI
                         IRWND2     = MAX(IRWNDI,(IRWNDI+NCP+NHL-1))
                         PARINT(15) = FLOAT(NCP+1)
                         DO 52009 IROW = IRWND1,IRWND2    ! update # components
                            CALL TBEWRR(TIDINT,IROW,17,PARINT(15),ISTAT)
52009                    CONTINUE
                      ELSE
                         NGR        = NGR + 1
                         NCP        = 0
                         NHL        = 0
                         IDNGRP     = IDWND          ! new group to be written
                         PARINT(1)  = FLOAT(IPX)
                         PARINT(2)  = FLOAT(IPY)
                         PARINT(3)  = 0.0
                         PARINT(4)  = 0.0
                         PARINT(5)  = 0.0
                         PARINT(6)  = FLOAT(NP)
                         PARINT(7)  = FLOAT(NC)
                         PARINT(8)  = 0.0
                         PARINT(9)  = 0.0
                         PARINT(10) = P(3)
                         PARINT(11) = BETA
                         PARINT(12) = 0.0
                         PARINT(13) = 0.0
                         PARINT(14) = 0.0
                         PARINT(15) = 1.0
                         PARINT(16) = 0.0
                      ENDIF

                   ELSE                                       ! in D  or N mode
                      IRWND1     = IRWNDI
                      IRWND2     = MAX(IRWNDI,(IRWNDI+NCP+NHL-1))
                      PARINT(15) = FLOAT(NCP+1)
                      DO 53009 IROW = IRWND1,IRWND2       ! update # components
                         CALL TBEWRR(TIDINT,IROW,17,PARINT(15),ISTAT)
53009                 CONTINUE
                   ENDIF
C
C *** get the data into the table
                   NCP    = NCP + 1                        ! one more component
                   NRINT  = NRINT + 1
                   IF (NCP.EQ.1) THEN                          ! identification
                      IDNCMP(NCP) = 101
                   ELSE
                      IDNCMP(NCP) = IDNCMP(NCP-1)+1
                   ENDIF
                   IRCMP               = NRINT     ! add component at end table
                   FLGCMP(NCP)         = 1                       ! flag
                   FITCMP((NCP-1)*6+2) = IPJ1                    ! x coordinate
                   FITCMP((NCP-1)*6+3) = IPJ2                    ! y coordinate
C
C *** get the intensity
                   IF (CAR.EQ.'J') THEN                     ! get the intensity
                      CALL STKPRR('J__Enter the intensity above the '//
     2                              'sky level: ','INPUTR',1,1,IAV,PIXV,
     3                          KUN,KNUL,ISTAT)
                      FITCMP((NCP-1)*6+1) = PIXV
                   ELSE
                      FITCMP((NCP-1)*6+1) = RNY(IPJ2,IPJ1)-P(3)
                   END IF
C 
C *** write the group
                   FITCMP((NCP-1)*6+4) = SIGMA                ! sigma
                   FITCMP((NCP-1)*6+5) = 0.                   ! fit parameters
                   FITCMP((NCP-1)*6+6) = 0.
                   CALL INTCWR(TIDINT,IRCMP,NCP)              ! write component
                   CALL TBCSRT(TIDINT,2,INTNUM,FLAGS,ISTAT)
                   CALL TBESRI(TIDINT,INTNUM(1),IDWND,COLERR,1,
     2                         IRWNDI,ISTAT)                  ! reread group
                   ASSIGN 51070 TO WNDRD
                   GO TO 50070
51070              CONTINUE
C
C *** give info to user
                   IF (CAR.EQ.'I') THEN                     ! get the intensity
                     WRITE(STRING,58109) IDNCMP(NCP)-100           ! write info
                   ELSE
                      WRITE(STRING,58209) IDNCMP(NCP)-100          ! write info
                   ENDIF
                   CALL STTPUT(STRING,ISTAT)
C
C *** option REPLACE: replace the component
                ELSE                                        ! replace component
                   IF (CAR.EQ.'I') THEN
                      CALL STKPRI('I__Enter component to replace: ',
     2                            'INPUTI',1,1,IAV,IDCMP,KUN,KNUL,ISTAT)
                   ELSE
                      CALL STKPRI('J__Enter component to replace: ',
     2                            'INPUTI',1,1,IAV,IDCMP,KUN,KNUL,ISTAT)
                   ENDIF
C
                   IDCMP1 = IDCMP+100                      ! find the component
                   CALL TBESRI(TIDINT,INTNUM(2),IDCMP1,COLERR,IRWNDI,
     2                         IRCMP,ISTAT)                  ! get ident
                   IF (IRCMP.LE.0) THEN                  ! can't find component
                      IF (CAR.EQ.'I') THEN                  ! get the intensity
                         WRITE(STRING,57109) IDCMP                 ! write info
                      ELSE
                         WRITE(STRING,57209) IDCMP                 ! write info
                      ENDIF
                      CALL STTPUT(STRING,ISTAT)
                   ELSE
                      ICMP = IRCMP - IRWNDI + 1          ! relative comp number
                   END IF
C
                   IF (ICMP.GT.NCP) THEN
                      IF (CAR.EQ.'I') THEN                  ! get the intensity
                         WRITE(STRING,57109) IDCMP                 ! write info
                      ELSE  
                         WRITE(STRING,57209) IDCMP                 ! write info
                      ENDIF
                      CALL STTPUT(STRING,ISTAT)
                   ELSE                       ! everything fine, all systems go
                      IF (CAR.EQ.'J') THEN
                         CALL STKPRR('J__Enter the intensity above '//
     2                               'the sky level: ','INPUTR',1,1,IAV,
     3                               PIXV, KUN,KNUL,ISTAT)
                         FITCMP((ICMP-1)*6+1) = PIXV
                         FITCMP((ICMP-1)*6+2) = IPJ1              ! x coordinate
                         FITCMP((ICMP-1)*6+3) = IPJ2              ! y coordinate
                      ELSE
                         FITCMP((ICMP-1)*6+1) = RNY(IPJ2,IPJ1)-P(3)
                         FITCMP((ICMP-1)*6+2) = IPJ1              ! x coordinate
                         FITCMP((ICMP-1)*6+3) = IPJ2              ! y coordinate
                      END IF
                      FITCMP((ICMP-1)*6+5) = 0.0
                      FITCMP((ICMP-1)*6+6) = 0.0 
                      FLGCMP(ICMP)         = 1                   ! flag
                      CALL INTCWR(TIDINT,IRCMP,ICMP)
                      ASSIGN 50970 TO WNDRD
                      GO TO 50070
50970                 CONTINUE
C
                      IF (CAR.EQ.'I') THEN                  ! get the intensity
                         WRITE(STRING,59109) IDCMP                 ! write info
                      ELSE
                         WRITE(STRING,59209) IDCMP                 ! write info
                      ENDIF
                      CALL STTPUT(STRING,ISTAT)
                   ENDIF
                ENDIF
        
                GRE    = 0
                IF (IOD.EQ.'M') THEN
                   IF (NFINP.EQ.1) THEN
                      NWD = NWD + 1
                   ENDIF
                   IDWND  = NWD
                   NFINP  = 0
                END IF
C
                IF (IOD.EQ.'M') THEN
                   IF (CATAL) THEN
                      CALL INTDWR(TIDCAT,NGR,NOBJ,NSR,SAT,FAT,
     2                            SIGMA,BETA,SIV,AIN,FOG)
                      ASSIGN 50165 TO RICFIL
                      GO TO 50065
50165                 CONTINUE
                   END IF
                END IF
C
             ELSE
                IF (CAR.EQ.'I') THEN                        ! get the intensity
                   WRITE(STRING,56109) NNI                         ! write info
                ELSE    
                   WRITE(STRING,56209) NNI                         ! write info
                ENDIF
                CALL STTPUT(STRING,ISTAT)
             END IF
          END IF

       ELSE
          IF (CAR.EQ.'I') THEN
             CALL STTPUT('I__*** WARNING: Cursor outside group',
     2                   ISTAT)
          ELSE
             CALL STTPUT('J__*** WARNING: Cursor outside group',
     2                   ISTAT)
          ENDIF
          CALL STTPUT(STRING,ISTAT)
       END IF
C
       GO TO 59909

C+++
50011  CONTINUE                                      ! Procedure XYMAX; option K
C---
51011  FORMAT ('K__Abs.:',I5,1X,I4,1X,', Rel.:',I3,1X,I2,
     *         1X,', Max:',I6)
52011  FORMAT ('K__Abs.:',I5,1X,I4,1X,', Rel.:',I3,1X,I2,
     *         1X,', Max: ----')

       STRING = 'K__Use cursor to get the coordinates'
       CALL STTPUT(STRING,ISTAT)
       CALL CURSIN(QDSPNO,0,NOC,IXYA,MCA,ISCA,IXYB,MCB,ISCB)
C
53011  CONTINUE
       CALL CURSIN(QDSPNO,ENTFLG,NOC,IXYA,MCA,ISCA,IXYB,MCB,ISCB)
C
       IF (ISCA.EQ.0) THEN
          GO TO XYMAX
       ELSE
          IX = IXYA(1)
          IY = IXYA(2)
C
          IF (IOD.EQ.'D' .OR. K1G.GT.1) THEN
             INDM = (IX-1)/(MXYF-1)
             IX   = IX-(INDM*(MXYF-1))
          END IF
C
          IF (IX.GE.1 .AND. IX.LE.NPM .AND. 
     2        IY.GE.1 .AND. IY.LE.NCM) THEN
             IPJ1 = (IX-1)/3+1
             IPJ2 = (IY-1)/3+1
             IPJX = IPX+IPJ1-1
             IPJY = IPY+IPJ2-1
C
             IF (INDM.EQ.0) THEN
                PMAX = RNY(IPJ2,IPJ1)-P(3)
             ELSE IF (INDM.EQ.1) THEN
                PMAX = RNF(IPJ2,IPJ1)-P(3)
             ELSE IF (INDM.EQ.2) THEN
                PMAX = RESI(IPJ2,IPJ1)-P(3)
             END IF
C
             IF (PMAX.GT.-200000000.) THEN
                WRITE(STRING,51011) IPJX,IPJY,IPJ1,IPJ2,
     2                              INT(PMAX)
             ELSE
                WRITE(STRING,52011) IPJX,IPJY,IPJ1,IPJ2
             END IF
             CALL STTPUT(STRING,ISTAT)

          ELSE
             CALL STTPUT('K__*** WARNING: Cursor position '//
     2                   'outside group',ISTAT)
          END IF

       ENDIF
       GO TO 53011


C+++
50012  CONTINUE                                     ! Procedure TROLIV; option L
C---
51012  FORMAT ('L__Height =',I6)
C
       STRING = 'L__Use cursor to get the coordinates'
       CALL STTPUT(STRING,ISTAT)
       CALL CURSIN(QDSPNO,0,NOC,IXYA,MCA,ISCA,IXYB,MCB,ISCB)
C
52012  CONTINUE
       CALL CURSIN(QDSPNO,1,NOC,IXYA,MCA,ISCA,IXYB,MCB,ISCB)
       IF (ISCA.EQ.0) THEN
          GO TO TROLIV
       ELSE
          IX = IXYA(1)
          IY = IXYA(2)
          LIV = (IY-200)*3/F78
          WRITE(STRING,51012) LIV
          CALL STTPUT(STRING,ISTAT)
       ENDIF
 
       GO TO 52012

C+++
50013  CONTINUE                                     ! Procedure ACCSTE; option M
C---
59013  FORMAT('M__*** WARNING: Group ', I8, ' already examined')
58013  FORMAT('M__*** INFO: Catalogue contains ',I6,' entries; ',
     2               'last group is ',I8)
C
       IF (CATAL) THEN
          NFINP = 1
          IOD   = 'M'
          NP    = NPI
          NC    = NCI
          NCP   = 0
          LLVV  = 0
C
51013     CONTINUE
          IF (LLVV.NE.0) GO TO 52013
             IF (BBC.EQ.'M') THEN
                CALL STKWRI('INPUTI',IDWND,1,1,KUN,ISTAT)
                CALL STKPRI('M__Enter group to display: ',
     2                      'INPUTI',1,1,IAV,IDWND,KUN,KNUL,ISTAT)
             ELSE
                IDWND = IDWND+1
             END IF                                                 !find ident
             CALL TBESRI(TIDCAT,CATNUM(1),IDWND,COLERR,1,IRWNDC,ISTAT)
C
             IF (IRWNDC.LE.NRCAT .AND. IRWNDC.GE.1) THEN
                CALL CATTRD(TIDCAT,IRWNDC,IDWND,D1,D2,RMA,V,B,U,P(3),
     2                      FLCO,BA1,BA2,BA3,BA4,BA5)
                NHL    = 0
                LLVV   = 0
                IF (BBC.NE.'M' .AND. BBC .NE. 'A') THEN
                   IF (ABS(FLCO).LT.2.) THEN
                      IF (BBC.EQ.'R') THEN
                         IF (FLCO.LE.0.0) THEN
                            LLVV = 1
                         ENDIF
                      ELSE IF (BBC.EQ.'H') THEN
                         IF (RMA.GE.SOAL) THEN
                            LLVV = 1
                         ENDIF
                      ELSE
                         IF (FLCO.LE.0.0 .AND. RMA.GE.SOAL) THEN
                            LLVV = 1
                         ENDIF
                      END IF
                   END IF
                ELSE
                   LLVV=1
                END IF
C
                IF (FLCO.EQ.1. .AND. IZE.EQ.1) THEN
                   IF (BBC.EQ.'M') THEN
                      WRITE(STRING,59013) IDWND
                      CALL STTPUT(STRING,ISTAT)
                   ELSE
                      LLVV = 0
                   END IF

                ELSE
                   IF (LLVV.EQ.1) THEN
                      IP3 = 1
                      IF (P(3).LE.0.0001) IP3=0
                      IPY = INT(D2)-NC/2
                      IPX = INT(D1)-NP/2
                      NPM = NP*3
                      NCM = NC*3
                      ASSIGN 50154 TO LEGMAT
                      GO TO 50054
50154                 CONTINUE
                      ASSIGN 50160 TO VISMAT
                      GO TO 50060
50160                 CONTINUE
                      CALL DAZVIS(QDSPNO,QIMCH,2,1)         ! display everything
                   END IF
                END IF
C
             ELSE                           ! no enter found; display last entry
                CALL CATTRD(TIDCAT,NRCAT,IDWND,DUM1,DUM2,DUM3,
     2                      DUM4,DUM5,DUM6,DUM7,DUM8,DUM9,DUM10,
     3                      DUM11,DUM12,DUM13)
                WRITE(STRING,58013) NSTCAT,IDWND
                CALL STTPUT(STRING,ISTAT)
                IDWND  = NRCAT+1
                LLVV   = 2
             END IF
             GO TO 51013
52013     CONTINUE               
C
       ELSE
          CALL STTPUT('M__*** WARNING: Sorry, no catalogue table '//
     2                'present',ISTAT)
       END IF
C
       GO TO ACCSTE

C+++
50014  CONTINUE                                     ! Procedure ACSTDA; option N
C---
59014  FORMAT('N__*** WARNING: Sorry, cannot find group; ',
     2                'try again ...')
C
       CALL STKWRI('INPUTI',IDWND,1,1,KUN,ISTAT)
       CALL STKPRI('N__Enter group identification: ',
     2             'INPUTI',1,1,IAV,IDWND,KUN,KNUL,ISTAT)
       CALL TBESRI(TIDINT,INTNUM(1),IDWND,COLERR,1,IRWNDI,ISTAT)   ! find ident
       IF (IRWNDI.LE.0 .OR. IRWNDI.GT.NRINT) THEN
          WRITE(STRING,59014)
          CALL STTPUT(STRING,ISTAT)
       ENDIF
C
C *** read the group components and holes
       IF (IRWNDI.LE.NRINT .AND. IRWNDI.GE.1) THEN
          ASSIGN 50470 TO WNDRD
          GO TO 50070
50470     CONTINUE
C          
C         IPIANT = 1
          IOD    = 'N'
          IP3    = 1
          IF (P(3).LE.0.0001) THEN
             IP3=0
          ENDIF
C
          ASSIGN 50153 TO APPDAT
          GO TO 50053
50153     CONTINUE
C
          ASSIGN 50254 TO LEGMAT
          GO TO 50054
50254     CONTINUE
C
          ASSIGN 50159 TO PREMAS
          GO TO 50059
50159     CONTINUE
C
          ASSIGN 50260 TO VISMAT
          GO TO 50060
50260     CONTINUE
C
          IF (IPIANT.EQ.1) THEN
             ASSIGN 50164 TO GRAISO
             GO TO 50064
50164        CONTINUE
          END IF
          CALL DAZVIS(QDSPNO,QIMCH,2,1)                     ! display everything
C
       ELSE
            
          WRITE(STRING,59014)
          CALL STTPUT(STRING,ISTAT)
       END IF
C
       GO TO ACSTDA

C+++
50016  CONTINUE                                    ! Procedure ISOSTE; option P
C---
       IF (IOD.EQ.'D') THEN
          CALL STKPRI('P__Enter component to examine: ',
     *                'INPUTI',1,1,IAV,IDCMP,KUN,KNUL,ISTAT)
          IDCMP1 = IDCMP+100
          CALL TBESRI(TIDINT,INTNUM(2),IDCMP1,COLERR,IRWNDI,
     2                IRCMP,ISTAT)                                      ! find
          IF (IRCMP.LE.0) THEN                     ! can't find such component
             WRITE(STRING,58003) IDCMP
             CALL STTPUT(STRING,ISTAT)
          ELSE
             ICMP = IRCMP - IRWNDI + 1             ! which component in table
          ENDIF
C
          IF (ICMP.GT.NCP) THEN                    ! in another group
             WRITE(STRING,58003) IDCMP
             CALL STTPUT(STRING,ISTAT)
          ELSE
             IF (IIST.EQ.1) THEN
                ASSIGN 50217 TO RIPFIN
                GO TO 50017
50217           CONTINUE
             ENDIF
C
             IIST = 1
             IF (ICMP.GE.1) THEN
                DO 51016 NIL= 1,NCP
                   FLGCMP(NIL) = 0
51016           CONTINUE
                FLGCMP(ICMP) = 1
C
                ASSIGN 50255 TO RIMANF
                GO TO 50055
50255           CONTINUE
             ENDIF
          ENDIF
       ENDIF
C
       GO TO ISOSTE

C+++
50017  CONTINUE                                    ! Procedure RIPFIN; option Q
C---
       IF (IOD.EQ.'D') THEN
          IIST = 0
          DO 51017 NIL=1,NCP
             FLGCMP(NIL) = NONS(NIL)
51017     CONTINUE
C
          ASSIGN 50355 TO RIMANF
          GO TO 50055
50355     CONTINUE
       END IF
C
       GO TO RIPFIN

C+++
50018  CONTINUE                                    ! Procedure RESMAT; option R
C---
       IF (IOD.NE.'D') THEN
          CALL STKPRI('R__Enter new size_x,size_y for the group: ',
     *                'INPUTI',1,2,IAV,IINPUT,KUN,KNUL,ISTAT)
          NPN = IINPUT(1)
          NCN = IINPUT(2)
          IF (NPN.GT.MX) NPN=MX
          IF (NPN.LT. 3) NPN= 3
          IF (NCN.GT.MY) NCN=MY
          IF (NCN.LT. 3) NCN= 3
C
          N1X  = NP   - NPN
          N1Y  = NC   - NCN
          IPXS = IPX  + N1X/2
          IPYS = IPY  + N1Y/2
          IPXE = IPXS + NPN-1
          IPYE = IPYS + NCN-1
C
C *** Check if group within boundaries
          IF ((IPXS.LT.1   .OR. IPYS.LT.1) .OR.
     2        (IPXE.GT.NPL .OR. IPYE.GT.NL)) THEN
             STRING = 'R__*** WARNING: Window boundary will fall '//
     2                       'outside frame; resizing NOT done!!'
             CALL STTPUT(STRING,ISTAT)
             GOTO RESMAT
          ENDIF
C
C *** All fine lets do it
          IPX = IPXS
          IPY = IPYS
          NP  = NPN
          NC  = NCN
          JX  = JX + N1X/2
          JY  = JY + N1Y/2
C
          PARINT(1) = IPX
          PARINT(2) = IPY
          PARINT(6) = NP
          PARINT(7) = NC
C
          IF (NCP.GT.0) THEN
             DO 51018 IC = 1,NCP
                FITCMP((IC-1)*6+2) = FITCMP((IC-1)*6+2) - N1X/2
                FITCMP((IC-1)*6+3) = FITCMP((IC-1)*6+3) - N1Y/2
51018        CONTINUE
          ENDIF
C
          IF (NHL.GT.0) THEN
             DO 52018 IH = 1,NHL
                FITHOL((IH-1)*3+2) = FITHOL((IH-1)*3+2) - N1X/2
                FITHOL((IH-1)*3+3) = FITHOL((IH-1)*3+3) - N1Y/2
52018        CONTINUE
          ENDIF
C
          CALL INTWWR(TIDINT,IRWNDI,NCP,NHL)
          ASSIGN 50670 TO WNDRD
          GO TO 50070
50670     CONTINUE
C
          IF (JX+NP-1.GT.MX .OR. JY+NC-1.GT.MY .OR. 
     2       JX.LT.1 .OR. JY.LT.1) THEN
             ASSIGN 50354 TO LEGMAT
             GO TO 50054
50354        CONTINUE

          ELSE
             ASSIGN 50257 TO APPNF
             GO TO 50057
50257        CONTINUE
          END IF

          ASSIGN 50259 TO PREMAS
          GO TO 50059
50259     CONTINUE
C
          ASSIGN 50560 TO VISMAT
          GO TO 50060
50560     CONTINUE
          CALL DAZVIS(QDSPNO,QIMCH,2,1)            ! display everything
       ELSE
C
          STRING = 'R__*** WARNING: In OUTPUT MODE reductions are '//
     *              'NOT allowed (try N)'
          CALL STTPUT(STRING,ISTAT)
       END IF
C
       GO TO RESMAT

C+++
50019  CONTINUE                                    ! Procedure SPOMAT; option S
C---
       IF (IOD.NE.'D') THEN
          CALL STKPRI('S__Enter del_x,del_y for window displacement '//
     2                'in x and y: ','INPUTI',1,2,IAV,IINPUT,
     3                KUN,KNUL,ISTAT)
          ILX  = IINPUT(1)
          ILY  = IINPUT(2)
C
          IPXS = IPX  + ILX
          IPYS = IPY  + ILY
          IPXE = IPXS + NP-1
          IPYE = IPYS + NC-1
C
C *** Check if window within boundaries
          IF ((IPXS.LT.1   .OR. IPYS.LT.1) .or.
     2        (IPXE.GT.NPL .OR. IPYE.GT.NL)) THEN
             STRING = 'S__*** WARNING: Window boundary will fall '//
     2                       'outside frame; shift NOT done!!'
             CALL STTPUT(STRING,ISTAT)
             GOTO SPOMAT
          ENDIF
C
          IPX = IPXS
          IPY = IPYS
          JX  = JX + ILX
          JY  = JY + ILY
C
          PARINT(1) = IPX
          PARINT(2) = IPY
          PARINT(6) = NP
          PARINT(7) = NC
C
          IF (NCP.GT.0) THEN
             DO 51019 IC = 1,NCP
                FITCMP((IC-1)*6+2) = FITCMP((IC-1)*6+2) - ILX
                FITCMP((IC-1)*6+3) = FITCMP((IC-1)*6+3) - ILY
51019        CONTINUE
          ENDIF
          IF (NHL.GT.0) THEN
             DO 52019 IH = 1,NHL
                FITHOL((IH-1)*3+2) = FITHOL((IH-1)*3+2) - ILX
                FITHOL((IH-1)*3+3) = FITHOL((IH-1)*3+3) - ILY
52019        CONTINUE
          ENDIF
C
          CALL INTWWR(TIDINT,IRWNDI,NCP,NHL)
          ASSIGN 50770 TO WNDRD
          GO TO 50070
50770     CONTINUE
C
          IF (JX+NP-1.GT.MX .OR. JY+NC-1.GT.MY .OR. 
     2        JX.LT.1 .OR. JY.LT.1) THEN
             ASSIGN 50454 TO LEGMAT
             GO TO 50054
50454        CONTINUE

          ELSE
             ASSIGN 50357 TO APPNF
             GO TO 50057
50357        CONTINUE
          END IF
C
          ASSIGN 50459 TO PREMAS
          GO TO 50059
50459     CONTINUE
C
          ASSIGN 50660 TO VISMAT
          GO TO 50060
50660     CONTINUE
          CALL DAZVIS(QDSPNO,QIMCH,2,1)            ! display everything
       ELSE
          STRING = 'S__*** WARNING: In OUTPUT MODE displacements are '//
     *             'NOT allowed (try N) '
          CALL STTPUT(STRING,ISTAT)
       END IF

       GO TO SPOMAT

C+++
50020  CONTINUE                                    ! Procedure PNONCE; option T
C---
58020  FORMAT('T__*** WARNING: Cannot find our component ',
     2        I2, ' sorry ...')
C
       IF (IIST.EQ.0 .AND. IOD.EQ.'D') THEN
          CALL STKPRI('T__Enter component to be excluded: ',
     2                'INPUTI',1,1,IAV,IDCMP,KUN,KNUL,ISTAT)
          IDCMP1 = IABS(IDCMP) + 100                           ! find component
          CALL TBESRI(TIDINT,INTNUM(2),IDCMP1,COLERR,IRWNDI,
     2                IRCMP,ISTAT)
C
          IF (IRCMP.LE.0) THEN                     ! can't find component
             WRITE(STRING,58020) IABS(IDCMP)
             CALL STTPUT(STRING,ISTAT)
          ELSE
             ICMP= IRCMP - IRWNDI + 1              ! relative comp number
          ENDIF
C
          IF (ICMP.GT.NCP) THEN                    ! in another group
             WRITE(STRING,58020) IABS(IDCMP)
             CALL STTPUT(STRING,ISTAT)
          ELSE
             IF (IDCMP.LT.0) THEN              
                FLGCMP(ICMP) = 1
                NONS(ICMP)   = 1
             ELSE
                FLGCMP(ICMP) = 0
                NONS(ICMP)   = 0
             END IF
             GRE = 0
             CALL INTCWR(TIDINT,IRCMP,ICMP)
          ENDIF
       END IF

       GO TO PNONCE

C+++
50021  CONTINUE                                    ! Procedure COLFAC; option U
C---
       CALL STKPRR('U__Enter zero level for display: ',
     2             'INPUTR',1,1,IAV,ZESI,KUN,KNUL,ISTAT)
       GO TO COLFAC

C+++
50022  CONTINUE                                    ! Procedure APRKFI; option V
C---
       CALL STKPRC('V__Enter input frame: ','IN_A',1,1,60,IAC,FRAME,
     2             KUN,KNUL,ISTAT)
       CALL STIGET(FRAME,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,3,NAXIS,
     2            NPIX,BEGIN,STEP,IDENT,CUNIT,IPNTR,IMF,ISTAT)
       IF (ISTAT.NE.0) THEN
          CALL STTPUT('V__*** WARNING: No such frame available, sorry',
     2                ISTAT)
          GO TO APRKFI                             ! back to monitor
       ELSE
          NPL   = NPIX(1)
          NL    = NPIX(2)
       ENDIF
C
C *** get new intermediate file
       CALL STKPRC('U__Enter new intermediate table [no new one]: ',
     2             'INPUTC',1,1,60,IAV,INTFIL,KUN,KNUL,ISTAT)
       IF (IAV.GT.0) THEN                          ! new table given
          CALL TBTCLO(TIDINT,ISTAT)                ! close the old one
          NNI = NN
          IGL = 0
          CALL TBTOPN(INTFIL,F_IO_MODE,TIDINT,ISTAT)  ! and open new one
          IF (ISTAT.NE.0) THEN                     ! no int. table present
             STRING = 'V__*** INFO: No intermediate table present '//
     2                'we will create one'
             CALL STTPUT(STRING,ISTAT)
             CALL INTINI(INTFIL,TIDINT)            ! create intermediate table
             NWD = 0
             NSR = 0

          ELSE                       ! table present; does it contain something
             CALL TBIGET(TIDINT,NCINT,NRINT,NSINT,NACINT,NARINT,ISTAT)
             IF (ISTAT.NE.0) THEN
                 STRING = 'V__*** FATAL: Problems with getting info '//
     2                    'for intermediate table; try again ... '
                 CALL STTPUT(STRING,ISTAT)
                 GO TO APRKFI
             ELSE
                 IF (NRINT.EQ.0) THEN              ! no info in table
                     STRING = 'V__*** FATAL: No data points in '//
     2                        'intermediate table'
                     CALL STTPUT(STRING,ISTAT)
                     NWD = 0
                     NSR = 0
                     NNI = 5
                 ELSE                              ! yes everything ok
                     CALL INTDRD(TIDINT,NGR,NOBJ,NSR,SAT,FAT,
     2                           SIGMA,BETA,SIV,AIN,FOG)
                 ENDIF
             ENDIF
          ENDIF
C
          ASSIGN 50251 TO PARLAS  
          GO TO 50051
50251     CONTINUE
       END IF
       GO TO APRKFI

C+++
50023  CONTINUE                                    ! Procedure CAMSLO; option W
C---
       CALL STKPRR('W__Enter slope of the colour scale: ',
     *             'INPUTR',1,1,IAV,FATT1,KUN,KNUL,ISTAT)
C
       IF (FATT1.EQ.0.) THEN
          CALL STTPUT('W__*** WARNING: Slope 0 not allowed, '//
     2                'slope 0.0001 assumed',ISTAT)
          FATT1=0.0001
       END IF
C
       GO TO CAMSLO

C+++
50024  CONTINUE                                  ! Procedure DISISO; option X+Y
C---
C
       IF (IOD.EQ.'D' .AND. (CAR.EQ.'X' .OR. CAR.EQ.'Y')) THEN
          ASSIGN 50555 TO RIMANF
          GO TO 50055
50555     CONTINUE
       END IF

       IF (CAR.EQ.'Y') THEN
          CALL STKPRR('Y__Enter isophotal threshold: ',
     *                'INPUTR',1,1,IAV,S01,KUN,KNUL,ISTAT)
       END IF

       IF (CAR.NE.' ') THEN
          IF (CAR.NE.'D') THEN
             CALL CONCHA(QDSPNO,QOVCH,0,0)         ! clear graphics
             CALL CONCHA(QDSPNO,QIMCH,0,0)         ! clear image
             CALL STKWRI('DAZIN',CURDAT,1,4,KUN,ISTAT)
             ASSIGN 50361 TO TYPNOM
             GO TO 50061
50361        CONTINUE
             ASSIGN 50362 TO TYPCOM
             GO TO 50062
50362        CONTINUE
             CALL PROFI5(RNY,MX,MY,NP,NC,L78,F78,'Y')
          END IF
C
          IF (NCP.GT.0 .AND. IOD.EQ.'D') THEN
             CALL PROFI5(RNF,MX,MY,NP,NC,L78,F78,'Y')
          END IF
       END IF
C
       ASSIGN 50264 TO GRAISO
       GO TO 50064
50264  CONTINUE
C
       S01=SAS01
       GO TO DISISO


C+++
50026  CONTINUE                                    ! Procedure DEPM; option Z
C---
       IF (IZE.EQ.0) THEN
          IZE = 1
          CALL STTPUT('Z__Examined stars will be displayed',ISTAT)
       ELSE
          IZE = 0
          CALL STTPUT('Z__Examined stars will not be displayed',ISTAT)
       ENDIF 
C
       GO TO DEPM

C+++
50034  CONTINUE                                    ! Procedure SEREOU; option 4
C---
51034  FORMAT('4__Enter group identification to start [',I6,']: ')
52034  FORMAT('4__*** WARNING: Group ',I6,' not available; ',
     2        'start with first group')
C
       KAUT  = 2
       NEXTW = .FALSE.
       RAI   = 'M'
       CALL STKWRC('INPUTC',1,RAI,1,1,KUN,ISTAT)
       CALL STKPRC('4__Enter display mode (A)utomatic, '//
     2             '(S)elective or (M)anual [M]: ','INPUTC',1,1,1,
     3              IAV,RAI,KUN,KNUL,ISTAT)
       CALL UPCAS(RAI,RAI)    
C
       IF (RAI.NE.'M') THEN
          ISIT = 1
          SOAL = 0
          IF (RAI.NE.'A') THEN
             RAI = 'A'
             CALL STKWRC('INPUTC',1,RAI,1,1,KUN,ISTAT)
             CALL STKPRC('4__Enter selection (A)ll, (N)o conv., '//
     2                   '(H)eight, (I)teration or (T)est [A]: ',
     3                    'INPUTC',1,1,1,IAV,RAI,KUN,KNUL,ISTAT)
             IF (IAV.EQ.0) THEN
                RAI = 'A'
             ENDIF
             CALL UPCAS(RAI,RAI)    
C
             IF (RAI.EQ.'H' .OR. RAI.EQ.'A') THEN
                SOAL = 0.0
                CALL STKWRR('INPUTR',SOAL,1,1,KUN,ISTAT)
                CALL STKPRR('Enter threshold level [0.0]: ','INPUTR',
     2                    1,1,IAV,SOAL,KUN,KNUL,ISTAT)
             END IF
C
             IF (RAI.EQ.'I' .OR. RAI.EQ.'A') THEN
                ISIT = 1
                CALL STKWRI('INPUTI',ISIT,1,1,KUN,ISTAT)
                CALL STKPRI('4__Enter number of iterations [1]: ',
     2                      'INPUTI',1,1,IAV,ISIT,KUN,KNUL,ISTAT)
                IF (ISIT.LE.0) ISIT = 1
             END IF
          END IF
C
          IF (NCP+NHL.GT.1) THEN                   ! are there any components
             IRWNDI = IRWNDI+NCP+NHL               ! default with next group
          ELSE                                     ! nothing left
             IRWNDI = IRWNDI+1                     ! increase group by 1
          ENDIF
          CALL TBERDI(TIDINT,IRWNDI,INTNUM(1),IDWND,NULL,ISTAT)    ! group id
          IF (IDWND.LE.0) THEN                     ! group  not known
             IRWNDI = 1                            ! start from begin
             CALL TBERDI(TIDINT,IRWNDI,INTNUM(1),IDWND,NULL,ISTAT) ! group id
          ENDIF
C
          WRITE(STRING,51034) IDWND                ! give info to user
          LCHAR = INDEX(STRING,':')+1               
          CALL STKWRI('INPUTI',IDWND,1,1,KUN,ISTAT)
          CALL STKPRI(STRING(1:LCHAR),'INPUTI',1,1,IAV,IWND,
     2                KUN,KNUL,ISTAT)              ! prompt for ident
          IF (IAV.EQ.0) THEN
             IWND = IDWND
          ENDIF
          CALL TBESRI(TIDINT,INTNUM(1),IWND,COLERR,1,IROW,ISTAT) ! present
          IF (IROW.LE.0) THEN                      ! wrong group
             WRITE(STRING,52034) IWND
             CALL STTPUT(STRING,ISTAT)
             GO TO SEREOU
          ELSE
             IRWNDI = IROW
          ENDIF
       END IF
C        
       GO TO SEREOU

C+++
50035  CONTINUE                                    ! Procedure SEREIN; option 5
C---
51035  FORMAT('5__Enter group identification to start [',I6,']: ')

       KAUT = 1
       BBC  = 'M'
       CALL STKWRC('INPUTC',1,BBC,1,1,KUN,ISTAT)
       CALL STKPRC('5__Enter examining mode (A)utomatic, '//
     2             '(S)elective or (M)anual [M]: ','INPUTC',1,1,1,
     3              IAV,BBC,KUN,KNUL,ISTAT)
       CALL UPCAS(BBC,BBC)    
C
       IF (BBC.NE.'M') THEN
          SOAL = 0
          IF (BBC.NE.'A') THEN
             BBC = 'A'
             CALL STKWRC('INPUTC',1,BBC,1,1,KUN,ISTAT)
             CALL STKPRC('5__Enter selection (A)ll, (R)ejected, or '//
     2                   '(H)eight [A]: ','INPUTC',1,1,1,IAV,BBC,
     3                   KUN,KNUL,ISTAT)
             CALL UPCAS(BBC,BBC)    
             IF (IDWND.LE.0)  THEN
                IDWND = 0
             ENDIF
             IF (BBC.EQ.'H' .OR. BBC.EQ.'A') THEN
                CALL STKPRR('5__Enter intensity threshold: [0.0]: ',
     2                      'INPUTR',1,1,IAV,SOAL,KUN,KNUL,ISTAT)
             END IF
          END IF
C
          IF (IDWND.GE.NRCAT) THEN
             IDWND = 0
          ENDIF
          WRITE(STRING,51035) IDWND+1
          LCHAR = INDEX(STRING,':')+1               
          CALL STKPRI(STRING(1:LCHAR),'INPUTI',1,1,IAV,IDWND1,
     2                KUN,KNUL,ISTAT)
          IF (IDWND1.GT.0) THEN
             IDWND = IDWND1-1
          ENDIF
       END IF
C        
       GO TO SEREIN

C+++
50036  CONTINUE                                    ! Procedure SMOOTH; option 6
C---
       CALL STKPRC('6__Enter "Y" to enable smoothing [Y]: ',
     2             'INPUTC',1,1,1,IAV,SMY,KUN,KNUL,ISTAT)
       CALL UPCAS(SMY,SMY)    
       IF (IAV.EQ.0. OR. SMY.NE.'N') THEN
          SMY='Y'
       ENDIF
C
       GO TO SMOOTH

C+++
50037  CONTINUE                                    ! Procedure INTEGR; option 7
C---
       CALL STKPRC('7__Enter "Y" to enable integration [Y]: ',
     2             'INPUTC',1,1,1,IAV,INY,KUN,KNUL,ISTAT)
       CALL UPCAS(INY,INY)    
       IF (IAV.EQ.0 .OR. INY.NE.'N') THEN
          INY = 'Y'
       ENDIF
C
       GO TO INTEGR

C+++
50041  CONTINUE                                  !Procedure DISAGA; option " "
C---
       ASSIGN 50353 TO APPDAT
       GO TO APPDAT
50353  CONTINUE
       ASSIGN 50258 TO LEMARA
       GO TO 50058
50258  CONTINUE
C
       IF (IOD.EQ.'D') THEN
          ASSIGN 50155 TO RIMANF
          GO TO 50055
50155     CONTINUE
          CALL PROFI5(RNF,MX,MY,NP,NC,L78,F78,'Y')
          IF (IPIANT.EQ.0) THEN
             CALL PIANT5(RNF,MX,MY,NP,NC,MXYF,FATT1,P(3),ZESI)
             CALL PIANT5(RESI,MX,MY,NP,NC,MXYR,FATT1,P(3),ZESI)
             K1G=1
          END IF
       END IF
C
       IF (IPIANT.EQ.1) THEN
          ASSIGN 50224 TO DISISO
          GO TO 50024
50224     CONTINUE
       END IF
       CALL DAZVIS(QDSPNO,QIMCH,2,1)               ! display everything
C
       GO TO DISAGA

C+++
50042  CONTINUE                                    ! Procedure DIMMAT; option /
C---
59042  FORMAT ('/__Enter new window size in x and y [',
     2             I2, ',', I2, ']: ')
C
       WRITE(STRING,59042) NPI,NCI
       IINPUT(1) = NPI
       IINPUT(2) = NCI
       CALL STKWRI('INPUTI',IINPUT,1,2,KUN,ISTAT)
       LCHAR = INDEX(STRING,':')+1               
       CALL STKPRI(STRING(1:LCHAR),
     2            'INPUTI',1,2,IAV,IINPUT,KUN,KNUL,ISTAT)
       NPI1 = IINPUT(1)
       NPC1 = IINPUT(2)
       LOG23 = NPI1.GT.MX .OR. NPC1.GT.MY
       IF (LOG23 .OR. NPI1.LT.1 .OR. NPC1.LT.1) THEN
          CALL STTPUT('/__*** WARNING: Illegal window size;'// 
     2                ' try again ...', ISTAT)
       ELSE
          NPI = NPI1
          NCI = NPC1
       ENDIF
C        
       GO TO DIMMAT

C+++
50043  CONTINUE                                    ! Procedure DEFR; option ?
C---
       IF (IHE.EQ.0) THEN
          IHE = 1
          CALL STTPUT('*** INFO: Multiple registration enabled',ISTAT)
       ELSE 
          IHE = 0
          CALL STTPUT('*** INFO: Multiple registration disabled',ISTAT)
       ENDIF 
C       
       GO TO DEFR

C+++
50044  CONTINUE                                    ! Procedure SCRBUC; option -
C---
       IF (K23.EQ.1) THEN
          K23 = 0
          CALL STTPUT('*** INFO: Holes will not be reported', ISTAT)
       ELSE
          CALL STTPUT('*** INFO: Holes will be reported', ISTAT)
          K23 = 1
          ASSIGN 50161 TO TYPNOM
          GO TO 50061
50161     CONTINUE
          ASSIGN 50162 TO TYPCOM
          GO TO 50062
50162     CONTINUE
       ENDIF
C
       GO TO SCRBUC

C+++
50045  CONTINUE                                    ! Procedure RISCOM; option @
C---
51045  FORMAT ('@__Enter "R" to replace, "A" to append [',
     2          A1,']: ')
C
       IF (IGS.EQ.'A') THEN
          IGS = 'A'
       ELSE
          IGS = 'R'
       END IF
C
       WRITE(STRING,51045) IGS
       LCHAR = INDEX(STRING,':')+1               
       CALL STKPRC(STRING(1:LCHAR),
     2             'INPUTC',1,1,1,IAV,IGS2,KUN,KNUL,ISTAT)
       CALL UPCAS(IGS2,IGS2)    
       IF (IGS2.NE.IGS .AND. IGS2.NE.' ') THEN
          IGS = IGS2
       ENDIF
C
       GO TO RISCOM

C+++
50051  CONTINUE                                    ! Procedure PARLAS
C---
51051  FORMAT('*** INFO: Sigma and saturation used: ',F6.2,',',F7.0)
C
       IF ((SAT.EQ.0.0) .AND. (SIGMA.EQ.0.0)) THEN
          SIGMA = 3.
          SAT   = 12000.
C         BETA  = 4.
       ENDIF
C
       FOG1 = 0.0
       CALL STKRDR('INPUTR',1,2,IAC,RINPUT,KUN,KNUL,ISTAT)
       IF (RINPUT(1).NE.0 .OR. RINPUT(2).NE.0 
     2                    .OR. FOG1.NE.0.0) THEN
          SIGMA = RINPUT(1)
          SAT   = RINPUT(2)
          FOG   = FOG1
       ENDIF
       WRITE(STRING,51051) SIGMA,SAT
       CALL STTPUT(STRING,ISTAT)
       IFA   = 1
C
       GO TO PARLAS

C+++
50052  CONTINUE                                    ! Procedure VERREC
C---
       IF (RAI.EQ.'N' .OR. RAI.EQ.'A') THEN
          IF (GRE.EQ.2) THEN
             JFVR = 1
          ELSE
             JIL = 1
51052        CONTINUE
             IF (JFVR.NE.0 .OR. JIL.GT.NCP) GO TO 52052
                IF (FLGCMP(JIL).GT.2) JFVR = 1
                JIL = JIL+1
                GO TO 51052
52052        CONTINUE
          END IF
       END IF
C
       JAC = 0
       IF (RAI.EQ.'A' .AND. JFVR.EQ.1) THEN
          JAC  = JAC+1
          JFVR = 0
       END IF
C
       IF (RAI.EQ.'I' .OR. RAI.EQ.'A') THEN
          IF (NITER.GE.ISIT) JFVR = 1
       END IF
C
       IF (RAI.EQ.'A' .AND. JFVR.EQ.1) THEN
          JAC  = JAC+1
          JFVR = 0
       END IF
C
       IF (RAI.EQ.'H' .OR. RAI.EQ.'A') THEN
          JIL = 1
53052     CONTINUE
          IF (JFVR.NE.0 .OR. JIL.GT.NCP) GO TO 54052
             IF (FLGCMP(JIL).GE.1) THEN
                IF (P((JIL-1)*4+4).GE.SOAL) JFVR=1
             END IF
             JIL=JIL+1
             GO TO 53052
54052     CONTINUE
       END IF

       IF(RAI.EQ.'A' .AND. JFVR.EQ.1) JAC=JAC+1
       IF (RAI.EQ.'T') THEN
          JIL = 1
55052     CONTINUE
          IF (JFVR.NE.0 .OR. JIL.GT.NCP) GO TO 56052
             IF (FLGCMP(JIL).EQ.2) JFVR = 1
             JIL=JIL+1
             GO TO 55052
56052     CONTINUE
       END IF
C
       IF (RAI.EQ.'A' .AND. JAC.LT.3) THEN
          JFVR = 0
       END IF
C
       GO TO VERREC

C+++
50053  CONTINUE                                    ! Procedure APPDAT
C---
       IPX = INT(D1)
       IPY = INT(D2)
       NP  = INT(D3)
       NC  = INT(D4)
       IF (NP.LE.0)  NP=31
       IF (NC.LE.0)  NC=31
       IF (NP.GT.MX) NP=31
       IF (NC.GT.MY) NC=31
       NPM   = NP*3
       NCM   = NC*3
       MX    = MX1
       MY    = MY1
C
       IF (NCP.GT.0) THEN
          DO 51153 NIL = 1,NCP
             NONS(NIL) = FLGCMP(NIL)
51153     CONTINUE
       END IF
C
       GO TO APPDAT

C+++
50054  CONTINUE                                    ! Procedure LEGMAT
C---
        ASSIGN 50156 TO INIFIN
        GO TO 50056
50156   CONTINUE
        IF (IP3.EQ.0) THEN
           DO 51154 IH = 1,KFD
              IVB(IH) = 0
51154      CONTINUE
        END IF
        DO 52054 IH = IY0,IY0+MY-1
           CALL REALIN(NPL,NL,IH,IX0,MX,MADRID(IPNTR),RIA)
           DO 53054 IHO = 1,MX
              RL = RIA(IHO)-FOG
              L  = RL+.5
              IF (IP3.EQ.0) THEN
                 IF (L.GT.0 .AND. L.LE.KFD) THEN
                    IVB(L)=IVB(L)+1
                 ENDIF
              END IF
              RNF(IH-IY0+1,IHO) = RL
53054      CONTINUE
52054   CONTINUE
C
        IF (IP3.EQ.0) THEN
           IFONDO =0
           DO 55054 IH = 1,KFD
              IF (IVB(IH).GT.IFONDO) THEN
                 IFONDO = IVB(IH)
                 IHS    = IH
              END IF
55054      CONTINUE
           P(3) = IHS
        END IF
C
        IF (CAR.EQ.'M') THEN
           P(1)=0.
           P(2)=0.
        END IF
C
        IF (SMY.NE.'N') THEN
           CALL SMOOT(RNF,MY,MX)
        END IF
C
        ASSIGN 50157 TO APPNF
        GO TO 50057
50157   CONTINUE
C
        GO TO LEGMAT

C+++
50055  CONTINUE                                    ! Procedure RIMANF
C---
        DO 51055 I1 = 1,NC
           AAY = I1-.5
           DO 52055 I2 = 1,NP
              AAX  = I2-.5
              VG   = P(1)*I2+P(2)*I1+P(3)
              DO 53055 I3 = 1,NCP
                 IF (FLGCMP(I3).GE.1) THEN
                    JN   = (I3-1)*4
                    ESPO = ((I2-P(5+JN))**2+(I1-P(6+JN))**2)/
     2                     (P(7+JN)**2)
                    IF (ABS(BETA).LT.1.0E-30) THEN
                       IF (INY.EQ.'N') THEN
                          VG = VG+P(4+JN)*EXP(-ESPO*4*ALOG(2.))
                       ELSE
                          VG = VG+GALEG(3,3,P(4+JN),P(7+JN),AAX,AAY,
     *                         P(5+JN),P(6+JN))
                       END IF
                    ELSE
                       IF (INY.EQ.'N') THEN
                          VG = VG+P(4+JN)*(1+ESPO)**(-BETA)
                       ELSE
                          VG = VG+GALE2(3,3,P(4+JN),P(7+JN),BETA,
     *                         AAX,AAY,P(5+JN),P(6+JN))
                       END IF
                    END IF
                 END IF
53055         CONTINUE
C
              RNF(I1,I2)=VG
              IF (IPIANT.EQ.0) THEN
                 IF (RNY(I1,I2).GT.-2000000000) THEN
                    RESI(I1,I2) = RNY(I1,I2) - RNF(I1,I2)+P(3)
                 ELSE
                    RESI(I1,I2) = -2000000000
                 END IF
              END IF
52055     CONTINUE
51055  CONTINUE
C 
       GO TO RIMANF

C+++
50056  CONTINUE                                    ! Procedure INIFIN
C---
       IPX   = IPX-BEGIN(1)+1
       IPY   = IPY-BEGIN(2)+1
       IPXSA = IPX
       IPYSA = IPY
       JX    = MX/2-NP/2+1
       JY    = MY/2-NC/2+1
       IX0   = IPX-JX+1
       IY0   = IPY-JY+1
C
       IF (IX0.LT.1) THEN
          IX0 = 1
          IF (IPX.LT.1) THEN
             IPX = 1
             ILX = IPX-IPXSA+ILX
             JX  = 1 
          ELSE
             JX = IPX
          END IF
       END IF
C
       IF (IY0.LT.1) THEN
          IY0=1
          IF (IPY.LT.1) THEN
             IPY = 1
             ILY = IPY-IPYSA+ILY
             JY  = 1
          ELSE
             JY  = IPY
          END IF
       END IF
C
       IF (IX0+MX-1.GT.NPL) THEN
          IX0 = NPL-MX+1
          IF (IPX+NP-1.GT.NPL) THEN
             IPX = NPL-NP+1
             ILX = IPX-IPXSA+ILX
          END IF
          JX = IPX-IX0+1
       END IF
C
       IF (IY0+MY-1.GT.NL) THEN
          IY0 = NL-MY+1
          IF (IPY+NC-1.GT.NL) THEN
             IPY = NL-NC+1
             ILY = IPY-IPYSA+ILY
          END IF
          JY = IPY-IY0+1
       END IF
       IPX = IPX+BEGIN(1)-1
       IPY = IPY+BEGIN(2)-1
C
       GO TO INIFIN

C+++
50057  CONTINUE                                    ! Procedure APPNF
C---
       DO 51057 KK1 = JY,JY+NC-1
          DO 52057 KK2 = JX,JX+NP-1
             RNY(KK1-JY+1,KK2-JX+1) = RNF(KK1,KK2)
52057     CONTINUE
51057  CONTINUE
C
       GO TO APPNF

C+++
50058  CONTINUE                                    ! Procedure LEMARA
C---
       LJ1 = IPX-BEGIN(1)+1
       LJ3 = IPY-BEGIN(2)+1
       DO 51058 J5 = LJ3,LJ3+NC-1
          CALL REALIN(NPL,NL,J5,LJ1,NP,MADRID(IPNTR),RIA)
          DO 52058 I = 1,NP
             RIA(I) = RIA(I)-FOG
             IF (RIA(I).GT.SAT) THEN
                RIA(I) = SAT
             ENDIF
             RNY(J5-LJ3+1,I) = RIA(I)
52058     CONTINUE
51058  CONTINUE
C
       IF (SMY.NE.'N') THEN
          CALL SMOOT(RNY,MY,MX)
       END IF
C
       ASSIGN 50359 TO PREMAS
       GO TO 50059
50359  CONTINUE
C
       ASSIGN 50360 TO VISMAT
       GO TO 50060
50360  CONTINUE
C
       GO TO LEMARA

C+++
50059  CONTINUE                                    ! Procedure PREMAS
C---
       IF (NHL.GT.0) THEN
          DO 51059 LI = 1,NHL
             ICB = (LI-1)*3
             RR  = PB(ICB+1)**2
             L4  = AMAX1(1.,PB(ICB+3)-PB(ICB+1))
             L5  = AMIN1(FLOAT(NC),PB(ICB+3)+PB(ICB+1)+.99)
             L21 = AMAX1(1.,PB(ICB+2)-PB(ICB+1))
             L22 = AMIN1(FLOAT(NP),PB(ICB+2)+PB(ICB+1)+.99)
             DO 52059 L2 = L21,L22
                 DO 53059 L3 = L4,L5
                    DELT = (L2-PB(ICB+2))**2+(L3-PB(ICB+3))**2
                    IF (RR.GE.DELT) THEN
                       IF (RNY(L3,L2).GT.-2000000000) THEN
                          IF (L3.GE.1 .AND. L3.LE.MX1) THEN
                             IF (L2.GE.1 .AND. L2.LE.MY1)THEN
                                RMASK(L3,L2) = RNY(L3,L2)
                                RNY(L3,L2)   = -2000000000
                             END IF
                          END IF
                       END IF
                    END IF
53059            CONTINUE
52059         CONTINUE
51059     CONTINUE
       END IF
C
       GO TO PREMAS

C+++
50060  CONTINUE                                    ! Procedure VISMAT
C---
       NPM = 3*NP
       NCM = 3*NC
C
       IF (CAR.EQ.'M') IFG = FLCO
       IF (CAR.EQ.'N' .OR. CAR.EQ.'D') THEN
          IFG = GRE
       ENDIF
C
       CALL CONCHA(QDSPNO,QIMCH,0,0)               ! clear image
       CALL CONCHA(QDSPNO,QOVCH,0,0)               ! clear graphics
       CALL STKWRI('DAZIN',CURDAT,1,4,KUN,ISTAT)
       ASSIGN 50261 TO TYPNOM
       GO TO 50061
50261  CONTINUE
C
       ASSIGN 50262 TO TYPCOM
       GO TO 50062
50262  CONTINUE
C
       L78 = 200.-(P(3)*F78)/3.
       COND = IOD.EQ.'D' .OR. CAR.EQ.'X' .OR. CAR.EQ.'Y'
       IF (COND.OR.(IOD.EQ.'N'.AND.IPIANT.EQ.1)) THEN
          DSA = 'Y'
       ENDIF
       CALL PROFI5(RNY,MX,MY,NP,NC,L78,F78,DSA)
       DSA = 'A'
       IF (IPIANT.EQ.0) THEN
          CALL PIANT5(RNY,MX,MY,NP,NC,1,FATT1,P(3),ZESI)
          K1G = 1
       END IF
C
       GO TO VISMAT

C+++
50061  CONTINUE                                    ! Procedure TYPNOM
C---
51061  FORMAT('   Group: ',I8,'; int=',E10.4,'; x0,y0=',
     2         I4,', ',I4,'; nx,ny=',I2,', ',I2,'; flag=',I2)
52061  FORMAT('   Group: ',I8,'; # comp=',I3,'; x0,y0=',
     2         I4,', ',I4,'; nx,ny=',I2,', ',I2,'; flag=',I2)
C
       IF (IOD.NE.'D') THEN
          WRITE(STRING,51061) IDWND,RMA,IPX,IPY,NP,NC,IFG
       ELSE
          WRITE(STRING,52061) IDWND,NCP,IPX,IPY,NP,NC,IFG
       END IF
       CALL STTPUT(STRING,ISTAT)
C
       IF ((RAI.NE.'M' .OR. IAM.NE.'M') .AND. (IOD.EQ.'O')) THEN
C      IF (RAI.NE.'M' .AND. IOD.EQ.'O') THEN
          IRWNDI = IRWNDI+NCP+NHL                  ! row for next group
       ENDIF
C
       IF ((BBC.NE.'M' .OR. IAM.NE.'M') .AND. (IOD.EQ.'I')) THEN
C      IF (BBC.NE.'M' .AND. IOD.EQ.'I') THEN
          IRWNDI = IRWNDI+NCP+NHL                  ! row for next group
       ENDIF
C
       GO TO TYPNOM

C+++
50062  CONTINUE                                    ! Procedure TYPCOM
C---
59062  FORMAT('   Background:  ', 3(G12.6,2X))
58062  FORMAT('   Component ',I2,': ',4(G12.6,2X),I2)
57062  FORMAT('   Hole      ',I2,': ',3(G12.6,2X))
C
       WRITE(STRING,59062) (P(L),L=1,3)            ! write the background
       CALL STTPUT(STRING,ISTAT)
C
       IF (NCP.GT.0) THEN                          ! write the components
          DO 51062 LLL = 1,NCP
             LSTA = (LLL-1)*4+4
             LSTO = (LLL-1)*4+7
             IDN  = IDNCMP(LLL)-100
             WRITE(STRING,58062) IDN,(P(L),L=LSTA,LSTO),FLGCMP(LLL)
             CALL STTPUT(STRING,ISTAT)
51062     CONTINUE
       END IF
C
       IF (NHL.GT.0. AND. K23.EQ.1) THEN           ! write the holes
          DO 52062 LLL = 1,NHL
              LSTA = (LLL-1)*3+1
              LSTO = (LLL-1)*3+3
              IDN  = IDNHOL(LLL)-200
              WRITE(STRING,57062) IDN,(PB(L),L=LSTA,LSTO)
              CALL STTPUT(STRING,ISTAT)
52062      CONTINUE
       END IF
C
       GO TO TYPCOM

C+++
50064  CONTINUE                                    ! Procedure GRAISO
C---
        AM = 0.
        DO 51064 IK=1,NC
           DO 52064 JK=1,NP
              AM = AMAX1(AM,RNY(IK,JK))
52064      CONTINUE
51064   CONTINUE
C
        AM    = AM-P(3)
        AMINH = P(4)
        DO 50364 LK=1,NCP
           IC = (LK-1)*4+4
           AMINH = AMIN1(AMINH,P(IC))
50364   CONTINUE
C
        K1G = 1
        IF (NC.LT.MY) THEN
           DO 50464 IK=NC+1,MY
              DO 50564 JK=1,MX
                 RNY(IK,JK)=0
                 IF (IOD.EQ.'D') RNF(IK,JK)=0
50564         CONTINUE
50464      CONTINUE
        END IF
C
        IF (NP.LT.MX) THEN
           DO 50664 IK=1,MY
              DO 50764 JK=NP+1,MX
                 RNY(IK,JK)=0
                 IF (IOD.EQ.'D') RNF(IK,JK)=0
50764         CONTINUE
50664      CONTINUE
        END IF
C
        DO 50864  K3=2,9,3
           H = (AM*S01)*K3+P(3)
           IF ((H-P(3)).GT.AMINH.AND.K3.EQ.2.AND.IOD.EQ.'D') THEN
              H = 0.8*AMINH+P(3)
           END IF
           CALL CONTS3(RNY,MY,MY,MX,H,DDD,K1G,MY)
           IF (NCP.GT.0 .AND. IOD.EQ.'D') THEN
              CALL CONTS3(RNF,MY,MY,MX,H,DDD,K1G,MY)
           END IF
           K1G = K1G+MXYF-1
50864  CONTINUE

       GO TO GRAISO

C+++
50065  CONTINUE                                    ! Procedure RICFIL
C---
       IAX = IPJ1+IPX-1
       IAY = IPJ2+IPY-1
       LF4 = 0
       LFF = 0
       IAI = IDWND-1
C
51065  CONTINUE
       IF (LFF.NE.0) GO TO 52065
          IAI = IAI+1
          CALL CATTRD(TIDCAT,IAI,IDWND,AX,AY,RMA,V,B,U,P33,FLCO,
     *                           BBB,SSS,AAII,SOSO,BA1)
          IF (FLCO.LT.1.) THEN
             IF (ABS(IAX-AX).LE.3..AND.ABS(IAY-AY).LE.3.) THEN
                LFF  = 1
                FLCO = 1.
                CALL CATTWR(TIDCAT,IAI,IDWND,AX,AY,RMA,V,B,U,P33,
     2                                 FLCO,BBB,SSS,AAII,SOSO,BA1)
                LF4  = 1
             END IF
          END IF
          IF (ABS(IAY-AY).GT.NC.OR.IAI.GE.NSTCAT) THEN
             LFF = 1
          ENDIF
          GO TO 51065
52065  CONTINUE 
C
       CALL CATTRD(TIDCAT,IRWNDC,IDWND,DUM1,DUM2,DUM3,DUM4,DUM5,DUM6,
     2              DUM7,DUM8,DUM9,DUM10,DUM11,DUM12,DUM13)
       GO TO RICFIL

C+++
50066  CONTINUE                                    ! Procedure RIPMAS
C---
       IF (NHL.GT.0) THEN
          DO 51066 LI=1,NHL
             ICB = (LI-1)*3
             RR  = PB(ICB+1)**2
             L4  = AMAX1(1.,PB(ICB+3)-PB(ICB+1))
             L5  = AMIN1(FLOAT(NC),PB(ICB+3)+PB(ICB+1)+.99)
             L21 = AMAX1(1.,PB(ICB+2)-PB(ICB+1))
             L22 = AMIN1(FLOAT(NP),PB(ICB+2)+PB(ICB+1)+.99)
             DO 52066 L2 = L21,L22
                DO 53066 L3 = L4,L5
                   DELT = (L2-PB(ICB+2))**2+(L3-PB(ICB+3))**2
                   IF (RR.GE.DELT) THEN
                      IF (L3.GE.1 .AND. L3.LE.MX1) THEN
                         IF (L2.GE.1 .AND. L2.LE.MY1)THEN
                            RNY(L3,L2) = RMASK(L3,L2)
                         END IF
                      END IF
                   END IF
53066           CONTINUE
52066        CONTINUE
51066     CONTINUE
       END IF
C
       GO TO RIPMAS

C+++
50070  CONTINUE                                    ! Procedure WNDRD
C---
       CALL INTWRD(TIDINT,IRWNDI,NCP,NHL)
       IDWND  = IDNGRP
       D1     = PARINT(1)
       D2     = PARINT(2)
       V      = PARINT(3)
       B      = PARINT(4)
       U      = PARINT(5)
       D3     = PARINT(6)
       D4     = PARINT(7)
       P(1)   = PARINT(8)
       P(2)   = PARINT(9)
       P(3)   = PARINT(10)
       BETA   = PARINT(11)
       SCAP   = PARINT(12)
       NITER  = PARINT(13)
       GRE    = PARINT(14)
C
       IF (NCP.GT.0) THEN
          DO 52070 IC = 1,NCP                      ! loop through components
             P((IC-1)*4+4)  = FITCMP((IC-1)*6+1)   ! intensity
             P((IC-1)*4+5)  = FITCMP((IC-1)*6+2)   ! x coord
             P((IC-1)*4+6)  = FITCMP((IC-1)*6+3)   ! y coord
             P((IC-1)*4+7)  = FITCMP((IC-1)*6+4)
             USC(IC)        = FITCMP((IC-1)*6+5)
             USE(IC)        = FITCMP((IC-1)*6+6)
52070    CONTINUE
       ENDIF
C
       IF (NHL.GT.0) THEN
          DO 53070 IH = 1,NHL                      ! loop through holes
             PB((IH-1)*3+1) =  FITHOL((IH-1)*3+1)
             PB((IH-1)*3+2) =  FITHOL((IH-1)*3+2)
             PB((IH-1)*3+3) =  FITHOL((IH-1)*3+3)
53070    CONTINUE
       ENDIF

       GO TO WNDRD

C+++
50072  CONTINUE                                    ! Procedure DELCMP
C---
57072  FORMAT('C__Component ',I3,' has been deleted')
58072  FORMAT('C__Last component ',I3,' has been deleted;',
     2                                ' group is empty now.')
C
       PARINT(15) =  FLOAT(NCP-1)                  ! reduce # comps
       DO 51072 IROW = IRWNDI,IRWNDI+NCP+NHL-1     ! update # components
          CALL TBEWRR(TIDINT,IROW,17,PARINT(15),ISTAT)
51072  CONTINUE
C
       IF (NCP.EQ.1 .AND. NHL.EQ.0) THEN           ! last component
          NGR                  = NGR  - 1
C         IDNCMP(ICMP)         = IDNCMP(ICMP) + 1000
          FLGCMP(ICMP)         = 0
          FITCMP((ICMP-1)*6+1) = TRNULL
          FITCMP((ICMP-1)*6+2) = TRNULL
          FITCMP((ICMP-1)*6+3) = TRNULL
          FITCMP((ICMP-1)*6+4) = TRNULL
          FITCMP((ICMP-1)*6+5) = TRNULL
          FITCMP((ICMP-1)*6+6) = TRNULL
          CALL INTCWR(TIDINT,IRCMP,ICMP)
          CALL TBCSRT(TIDINT,2,INTNUM,FLAGS,ISTAT)
          WRITE(STRING,58072) IDCMP
          CALL STTPUT(STRING,ISTAT)
       ELSE
          CALL TBRDEL(TIDINT,IRCMP,ISTAT)
          CALL TBCSRT(TIDINT,2,INTNUM,FLAGS,ISTAT)
          WRITE(STRING,57072) IDCMP
          CALL STTPUT(STRING,ISTAT)
       ENDIF
C
       GO TO DELCMP
C

C+++
50073  CONTINUE                                    ! Procedure DELHOL
C---
59073  FORMAT('G__hole ',I3,' has been deleted')
58073  FORMAT('G__Last hole ',I3,' has been deleted;',
     2                           ' group is empty now.')
C
       PARINT(16) = FLOAT(NHL-1)                   ! reduce # holes
       DO 51073 IROW = IRWNDI,IRWNDI+NCP+NHL-1     ! update number of holes
          CALL TBEWRR(TIDINT,IROW,18,PARINT(16),ISTAT)
51073  CONTINUE
C
       IF (NHL.EQ.1 .AND. NCP.EQ.0) THEN           ! last hole
          NGR                  = NGR - 1           ! one group less
C         IDNHOL(IHOL)         = IDNHOL(IHOL) + 1000
          FLGHOL(IHOL)         = 0
          FITHOL((IHOL-1)*3+1) = TRNULL
          FITHOL((IHOL-1)*3+2) = TRNULL
          FITHOL((IHOL-1)*3+3) = TRNULL
          CALL INTHWR(TIDINT,IRHOL,IHOL)
          CALL TBCSRT(TIDINT,2,INTNUM,FLAGS,ISTAT)
          WRITE(STRING,58073) IDHOL
          CALL STTPUT(STRING,ISTAT)
       ELSE
          CALL TBRDEL(TIDINT,IRHOL,ISTAT)
          CALL TBCSRT(TIDINT,2,INTNUM,FLAGS,ISTAT)
          WRITE(STRING,59073) IDHOL
          CALL STTPUT(STRING,ISTAT)
       ENDIF
C
       GO TO DELHOL
C
C *** finish up
       END

C @(#)updat.for	19.1 (ES0-DMD) 02/25/03 13:30:49
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++            
C.IDENT:   UPDAT                                                                
C.PURPOSE: Update the mask frame and the buffer setting to a flag value points  
C          with residual greater than kappa*sigma                               
C.INPUT:   MASK  : INPUT_B is the frame masking bright objects in the image     
C          ATEMP : a buffer containing the rebinned input image - used for speed
C          FLMSK : flag = .TRUE. if MASK exists                                 
C          REJ   : value assigned to 'bad' pixels in the buffer ATEMP           
C          NMX,... usual descriptors of the frame MASK                          
C          IDEG  : polinomial degree                                            
C          RKAPPA: parameter for kappa-sigma clipping                           
C          SIGM1 : standard deviation of residuals image-fit.pol. for the       
C                  'good' pixels                                                
C          C     : up to 21 coefficients of the polinomial surface              
C          NSX,... usual descriptors for the temporary frame ATEMP              
C.OUTPUT:  none                                                                 
C ------------------------------------------------------------------            
      SUBROUTINE UPDAT(MASK,ATEMP,FLMSK,REJ,NMX,NMY,RXSTR,RYSTR,RXSTP,          
     +                 RYSTP,NSX,NSY,SXSTR,SYSTR,SXSTP,SYSTP,IDEG,              
     +                 RKAPPA,SIGM1,C)                                          
      IMPLICIT NONE
C
      INTEGER  NMX
      INTEGER  NMY
      REAL     MASK(NMX,NMY)
      REAL     ATEMP(128,128)
      LOGICAL  FLMSK
      REAL     REJ
      DOUBLE PRECISION RXSTR
      DOUBLE PRECISION RYSTR
      DOUBLE PRECISION RXSTP
      DOUBLE PRECISION RYSTP
      INTEGER  NSX
      INTEGER  NSY
      DOUBLE PRECISION SXSTR
      DOUBLE PRECISION SYSTR
      DOUBLE PRECISION SXSTP
      DOUBLE PRECISION SYSTP
      INTEGER  IDEG
      REAL     RKAPPA
      REAL     SIGM1
      DOUBLE PRECISION C(21)
C
      INTEGER  I
      INTEGER  I1MSK
      INTEGER  IX, IY
      INTEGER  J
      INTEGER  J1MSK
      INTEGER  NCV(5)
      REAL     DCX, DCY
      REAL     POLIN
      REAL     RES
      REAL     X1
      REAL     Y1
      REAL     V
      DOUBLE PRECISION CC(6)
      DOUBLE PRECISION XD,YD
      REAL     BTSIG
C
      EXTERNAL POLIN
C                                                                               
      DATA NCV/3,6,10,15,21/                                                    
C                                                                               
C *** calculate residuals and update mask and temporary array                   
C                                                                               
      DCX    = (NSX-1.)/2.                                                      
      DCY    = (NSY-1.)/2.                                                      
C                                                                               
C *** loop : update mask and set -rej- flag in temporary array                  
C                                                                               
      BTSIG  = RKAPPA*SIGM1                                                     
      DO 70 J = 1,NSY                                                           
         IY = J - 1                                                             
         Y1 = SYSTR + SYSTP*FLOAT(IY)                                           
         IF (FLMSK) THEN                                                        
             J1MSK  = (Y1-RYSTR)/RYSTP + 1.5                                    
         END IF                                                                 
                                                                                
         YD     = DCY - IY                                                      
         CALL COEFY(YD,C,CC,IDEG)                                               
C                                                                               
C *** check mask                                                                
C                                                                               
         IF ( .NOT. FLMSK) GO TO 30                           ! y outofbounds   
         IF (J1MSK.LT.1 .OR. J1MSK.GT.NMY) GO TO 30                             
C                                                                               
          DO 20 I = 1,NSX                                                       
             IX     = I - 1                                                     
             XD     = IX - DCX                                                  
             RES    = ATEMP(I,J) - POLIN(XD,CC,IDEG)                            
             X1     = SXSTR + SXSTP*FLOAT(IX)                                   
             I1MSK  = (X1-RXSTR)/RXSTP + 1.5                                    
             IF (I1MSK.LT.1 .OR. I1MSK.GT.NMX) THEN                             
                IF (ATEMP(I,J).EQ.REJ) THEN                                     
                   GO TO 10                                                     
                END IF                                                          
                IF (ABS(RES).GT.BTSIG) THEN                                     
                   ATEMP(I,J) = REJ                                             
                END IF                                                          
             ELSE                                                               
                V      = MASK(I1MSK,J1MSK)                                      
                IF (V.LE.0.) THEN                                               
                   GO TO 10                                                     
                END IF                                                          
                IF (ABS(RES).LE.BTSIG) THEN                                     
                   GO TO 10                                                     
                END IF                                                          
                MASK(I1MSK,J1MSK) = -1                                          
                ATEMP(I,J) = REJ                                                
             END IF                                                             
   10        CONTINUE                                                           
   20     CONTINUE                                                              
          GO TO 60                                                              
C                                                                               
   30     DO 50 I = 1,NSX                                                       
             IF (ATEMP(I,J).EQ.REJ) THEN                                        
                GO TO 40                                                        
             END IF                                                             
             IX     = I - 1                                                     
             XD     = IX - DCX                                                  
             RES    = ATEMP(I,J) - POLIN(XD,CC,IDEG)                            
             IF (ABS(RES).GT.BTSIG) THEN                                        
                ATEMP(I,J) = REJ                                                
             END IF                                                             
   40        CONTINUE                                                           
   50     CONTINUE                                                              
C                                                                               
   60     CONTINUE                                                              
   70 CONTINUE                                                                  
C                                                                               
      RETURN                                                                    
      END                                                                       

C @(#)abox.for	19.1 (ES0-DMD) 02/25/03 13:18:58
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE abox(NX,NY,MT,IN,H0,HG,HL,EG,EL,SG,SL,V,YMT)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C     executes one order of the algorithm
C     V : shift parametre for H-transform; minimum=2 (in)
C     other parameters as in afido
C
C--------------------------------------------------------------------------
      IMPLICIT    NONE
      LOGICAL     L
      CHARACTER*1 YMT
      INTEGER     NX,NY,V,V1,V2,V21,NXV,NYV,NXV1,NYV1,JV,IV,
     >            J2,I2,I,J,T
      REAL        IN(NX,NY),H0(NX,NY),HG(NX,NY),HL(NX,NY),MT(NX,NY),
     >            EG,EL,SG,SL,A,B,C,D,HX,HY,H,QG,QL,NP,NPP
C
      V1=V
      V2=V1/2
      L=.FALSE.
      NP=0.
      EL=NP
      EG=NP
      QL=NP
      QG=NP

      DO J=1,NY-V1
         JV=J+V1
         J2=J+V2
         DO I=1,NX-V1
            IV=I+V1
            I2=I+V2
            A=IN(I,J)
            B=IN(IV,J)
            C=IN(I,JV)
            D=IN(IV,JV)
            H=(A+B+C+D)/4.
            H0(I2,J2)=H                      ! smooth
            H=IN(I2,J2)-H
            HL(I2,J2)=H                      ! Laplace
            IF (YMT.EQ.'N') GOTO 5           ! no mask for statistics
            T=MT(I2,J2)
            IF (T.NE.0) L=.TRUE.
            IF (L) GOTO 6                    ! pixel not used for statistics
    5       NPP=NP
            NP=NP+1
            NPP=NPP/NP
            H=H-EL
            EL=EL+H/NP                       ! estimate statistics
            QL=QL+H*H*NPP                    ! for Laplace
    6       HX=(A-B+C-D)/4.
            HY=(A+B-C-D)/4.
            H=SQRT(HX*HX+HY*HY)
            HG(I2,J2)=H                      ! gradient
            IF (YMT.EQ.'N') GOTO 7           ! no mask for statistics
            IF (L) GOTO 10                   ! pixel not used for statistics
    7       H=H-EG
            EG=EG+H/NP                       ! estimate statistics
            QG=QG+H*H*NPP                    ! for gradient
   10       L = .FALSE.
         ENDDO
      ENDDO
C
C *** correct statistics
      NP=NP-1
      SL=SQRT(QL/NP)
      SG=SQRT(QG/NP)
C
C *** set edge lines and corners
      V21=V2+1
      NXV=NX-V2
      NYV=NY-V2
      NXV1=NXV+1
      NYV1=NYV+1

      DO I=V21,NXV                           ! edge rows
         A=H0(I,V21)
         B=HG(I,V21)
         C=HL(I,V21)
         DO J=1,V2                           ! up
            H0(I,J)=A
            HG(I,J)=B
            HL(I,J)=C
         ENDDO
         A=H0(I,NYV)
         B=HG(I,NYV)
         C=HL(I,NYV)
         DO J=NYV1,NY                        ! down
            H0(I,J)=A
            HG(I,J)=B
            HL(I,J)=C
        ENDDO
      ENDDO

      DO J=V21,NYV                            ! edge columns
         A=H0(V21,J)
         B=HG(V21,J)
         C=HL(V21,J)
         DO I=1,V2                            ! left
            H0(I,J)=A
            HG(I,J)=B
            HL(I,J)=C
         ENDDO
         A=H0(NXV,J)
         B=HG(NXV,J)
         C=HL(NXV,J)
         DO I=NXV1,NX                         ! right
            H0(I,J)=A
            HG(I,J)=B
            HL(I,J)=C
         ENDDO
      ENDDO

      A=H0(V21,V21)
      B=HG(V21,V21)
      C=HL(V21,V21)
      DO I=1,V2                              ! upper left corner
         DO J=1,V2
            H0(I,J)=A
            HG(I,J)=B
            HL(I,J)=C
         ENDDO
      ENDDO

      A=H0(NXV,V21)
      B=HG(NXV,V21)
      C=HL(NXV,V21)
      DO I=NXV1,NX                           ! upper right corner
         DO J=1,V2
            H0(I,J)=A
            HG(I,J)=B
            HL(I,J)=C
         ENDDO
      ENDDO

      A=H0(V21,NYV)
      B=HG(V21,NYV)
      C=HL(V21,NYV)
      DO I=1,V2                              ! lower left corner
         DO J=NYV1,NY
            H0(I,J)=A
            HG(I,J)=B
            HL(I,J)=C
         ENDDO
      ENDDO

      A=H0(NXV,NYV)
      B=HG(NXV,NYV)
      C=HL(NXV,NYV)
      DO I=NXV1,NX                           ! lower right corner
         DO J=NYV1,NY
            H0(I,J)=A
            HG(I,J)=B
            HL(I,J)=C
         ENDDO
      ENDDO

      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2005 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM MODIF
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION              
C  program MODIF 			version 1.00	890630
C  K. Banse 				ESO - Garching
C
C.KEYWORDS    
C  modify pixels
C
C.PURPOSE
C  merge of MODPIX.FOR, MODAR.FOR, MODCUT.FOR
C
C.ALGORITHM
C  see the subroutines
C
C.INPUT/OUTPUT
C  the following keywords are used:
C  ACTION/C/1/2			action = MP for modify/pixel
C  				       = MA for modify/area
C  				       = MC for modify/cuts
C.VERSIONS
C  1.00		created 
C 
C 051014		last modif
C-------------------------------------------------------------------
C
      IMPLICIT NONE
C      
      INTEGER      IAV,STAT
      INTEGER      UNI(1),NULO
C 
      CHARACTER    ACTION*2
C
C  get into MIDAS environment
      CALL STSPRO('MODIF')
C 
      CALL STKRDC('ACTION',1,1,2,IAV,ACTION,UNI,NULO,STAT)
      CALL UPCAS(ACTION,ACTION)
C 
C  branch according to option

      IF (ACTION .EQ. 'MP') THEN
         CALL MODPIX(1)
      ELSE IF (ACTION .EQ. 'MA') THEN
         CALL MODPIX(2)
      ELSE IF (ACTION .EQ. 'MC') THEN
         CALL STKRDC('P2',1,1,1,IAV,ACTION,UNI,NULO,STAT)
         CALL MODCUT(ACTION)
      ENDIF
C   
      CALL STSEPI
      END

      SUBROUTINE MODPIX(MODMOD)
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION              
C  subroutine MODPIX 			version 1.00	881028
C  K. Banse 				ESO - Garching
C  1.50  980923 S.Wolf
C
C.KEYWORDS    
C  bulk data frame, bad pixels
C
C.PURPOSE
C  to replace a group of undefined or bad pixels values by surface 
C  interpolation of neighboring area. The bad pixel area is defined via the 
C  cursor.
C
C.ALGORITHM
C  a)   (original input from H. Waldthausen, had to be cleaned a lot...)
C  a surface is fitted using the pixels surrounding the cursor area
C  the surrounding area is chosen as 
C                       x-pixels = x-area factor * x-size of cursor rectangle
C                       y-pixels = y-area factor * y-size of cursor rectangle
C  the program forms an approximation to the weighted, least-squares Chebyshev 
C  series surface fit; the weights are derived from the Poisson error.
C
C  b)  (original input from A. Lauberts)
C  a LSQ surface is fitted using the pixels around a circle but inside
C  the cursor rectangle
C 
C.INPUT/OUTPUT
C             call as MODPIX(MODMOD)
C 
C  MODMOD:	Integer		1 = Modify/Pixel
C				2 = Modify/Area
C 
C  the following keywords are used:
C  a)
C  P1/C/1/60			input frame, table
C				or 
C				CURSOR
C  IN_A/C/1/60			input frame, if P1 = CURSOR
C  OUT_A/C/1/60			result frame
C  INPUTI/I/1/6			area factors in x,y
C				x,y degree of fitting polynomial, 
C				no. of iterations + overlay_draw_flag
C  NOISE/C/1/1                  Y or N - whether to add noise
C  IMASEC/C/1/100               allowed image section
C	
C  b)
C  P1/C/1/80			input frame, table
C				or 
C				CURSOR
C  IN_A/C/1/60			input frame, if P1 = CURSOR
C  OUT_A/C/1/60			result frame
C  INPUTI/I/1/2			degree of fitted SURFACs, draw flag
C  INPUTR/R/1/1			constant in case that INPUTI = 0
C 
C-------------------------------------------------------------------
C
      IMPLICIT NONE
C      
      INTEGER      MODMOD
      INTEGER      ICX,ICY,IPX,IPY
      INTEGER      ISX,ISY,IT,XDEG,YDEG
      INTEGER      IPIXS(4),ISUR(4)
      INTEGER      DEGREE,IAV,IDRAW
      INTEGER      N,N2,NAXIS,NCOL,NROW,NMAL
      INTEGER*8    PNTRA,PNTRB
      INTEGER      IMNOA,IMNOB,SIZE,LFLAGS(2)
      INTEGER      STAT1,STAT2,STAT,TABFLG
      INTEGER      NPIXA(3),KCOOR(4),WPIX(3)
      INTEGER      SPIX(3),EPIX(3)
      INTEGER      IXLO,IXUP,IYLO,IYUP,INPUTI(6),DAZOP
      INTEGER      ICUR1(2),ICUR2(2),WW(4)
      INTEGER      TID,TABCOLN(4)
      INTEGER      LOW1(3),HI(3),CUTIND,COOFF
      INTEGER      UNI(1),NUL,MADRID(1)
      INTEGER      XFIGU(6),YFIGU(8)
C      
      CHARACTER    FRAMEA*80,TABLE*80,FRAMEB*80
      CHARACTER*80  OUTPUT
      CHARACTER*100  CIMASEC
      CHARACTER      CUNITA*64,IDENTA*72,CACT*8,CNOISE*1
      CHARACTER      TABLAB(4)*16
      CHARACTER*40   ERMS12,ERMS13,ERMS15,ERMS16
      CHARACTER      INFO*44,TIP15*56,TIP12*28
      CHARACTER      CSYST
C      
      DOUBLE PRECISION STARTA(3),STEPA(3)
      DOUBLE PRECISION DD1(4),DD2(4)                     !for WCS conversions
C 
      REAL         RBUF(6),CUTS(4),COOR(4),STPINV(2)
      REAL         RCUTS(2),ZCUTS(2),PCUR1(6),PCUR2(6),CONST
      REAL         OFFSET,OMIN,CRMS,PCEN(6)
      REAL         INPUTR(8)
C      
      LOGICAL      NOISE,TABNUL(4),SELFLG
C 
      INCLUDE  'MID_INCLUDE:ST_DEF.INC'
C 
      INCLUDE  'MID_INCLUDE:IDIDEV.INC'
      INCLUDE  'MID_INCLUDE:IDIMEM.INC'
C 
      COMMON    /VMR/  MADRID
C
C  messages
      DATA
     +  INFO /' switch cursors on - next time we exit ... '/,
     +  ERMS12 /' ERR: surface dimension too large  '/,
     +  ERMS13 /' ERR: in mathematical subroutines '/,
     +  ERMS15 /' ERR: surface-column undersampled '/,
     +  ERMS16 /' ERR: area not fully in image section '/
      DATA
     +  TIP12 /' TIP: reduce cursor area '/,
     +  TIP15 /' TIP: enlarge cursor area, reduce degree and #iter.'/
C
      DATA    OUTPUT   /' '/, TABLE  /' '/,  FRAMEA  /' '/, FRAMEB /' '/
      DATA    TABLAB   /'XSTART ','YSTART ','XEND ','YEND '/
      DATA    KCOOR    /-1,-1,-1,-1/
      DATA    LOW1     /1,1,1/,   HI /1,1,1/
      DATA    NPIXA    /1,1,1/,   WPIX   /1,1,1/
      DATA    DAZOP  /1/,      COOFF /0/
      DATA    CUNITA   /' '/,     IDENTA /' '/
      DATA    SPIX     /1,1,0/,   EPIX   /1,1,0/
      DATA    PCUR1    /6*0.0/,   PCUR2  /6*0.0/
C 
      INCLUDE  'MID_INCLUDE:ST_DAT.INC'
C
C  get input option (CURSOR or table) + read keys
      CSYST = 'W'               !coord.system default: world
      LFLAGS(1) = -99
      IXLO = 0
      IXUP = 0
      IYLO = 0
      IYUP = 0
      CALL STKRDC('P1',1,1,80,IAV,OUTPUT,UNI,NUL,STAT)
      N = INDEX(OUTPUT,',')
      IF (N.GT.0) THEN                               !table specified
         TABFLG = 2
         FRAMEA(1:80) = OUTPUT(1:N-1)//' '
         CALL CLNFRA(FRAMEA,FRAMEA,0)
         TABLE(1:80) = OUTPUT(N+1:)//' '
         N2 = INDEX(TABLE,',')
         IF (N2.GT.0) THEN                           !only for MODI/PIX implem.
            CSYST = TABLE(N2+1:N2+2)
            CALL UPCAS(CSYST,CSYST)
            TABLE(1:80) = TABLE(1:N2-1)//' '
            IF (CSYST.EQ.'P') THEN                   !pixel coord. selected
               DO 90, N=1,4
                  N2 = INDEX(TABLAB(N),' ')          !labels have to end
                  TABLAB(N)(1:) = TABLAB(N)(1:N2-1)//'PIX '
90             CONTINUE                              !with PIX
            ELSE IF (CSYST.NE.'W') THEN              !Wrong flag used
               OUTPUT(1:) = 'Wrong table flag used. Only PIXEL or'//
     +              ' WORLD is possible '
               CALL STETER(3,OUTPUT)
            ENDIF
         ELSE
            CSYST = 'W'                              !world coordinates
         ENDIF
         CALL CLNTAB(TABLE,TABLE,0)
         CALL TBTOPN(TABLE,F_I_MODE,TID,STAT)
         CALL TBIGET(TID,NCOL,NROW,N,N,N,STAT)       !get no. of columns + rows
C 
         DO 100, N=1,4
            CALL TBLSER(TID,TABLAB(N),TABCOLN(N),STAT)      !find columns...
            IF (TABCOLN(N).LE.0) THEN
               OUTPUT(1:) = 'column labelled '//TABLAB(N)//
     +                      'missing... '
               CALL STETER(1,OUTPUT)
            ENDIF
100      CONTINUE
      ELSE
C 
         TABFLG = 1
         CALL STKRDC('IN_A',1,1,80,IAV,FRAMEA,UNI,NUL,STAT)
      ENDIF
C      
C  get result frame + integer parameters
      CALL STKRDC('OUT_A',1,1,80,IAV,FRAMEB,UNI,NUL,STAT)
      CALL STKRDI('INPUTI',1,6,IAV,INPUTI,UNI,NUL,STAT)
      CALL STKRDR('INPUTR',1,3,IAV,INPUTR,UNI,NUL,STAT)
C
C get remaining parameters depending on method
      IF (MODMOD.EQ.1) THEN                          !get the noise flag
                                                     !(RNH)
         CALL STKRDC('NOISE',1,1,1,IAV,CNOISE,UNI,NUL,STAT)
         IF (CNOISE.EQ.'Y' .OR. CNOISE.EQ.'y') THEN
            NOISE=.TRUE.
         ELSE
            NOISE=.FALSE.
         ENDIF
                                                     !get allowed image section
         CALL STKRDC('IMASEC',1,1,100,IAV,CIMASEC,UNI,NUL,STAT)
C
C  verify area factors, degree of polynomial + no. of iterations
         INPUTR(1) = MAX(1.0,INPUTR(1))              !arfacts specified by
         INPUTR(2) = MAX(1.0,INPUTR(2))              !... MODI/PIX
         INPUTI(1) = MAX(1,INPUTI(1))                !only used by MODI/AREA
         INPUTI(2) = MAX(1,INPUTI(2))                !only used by MODI/AREA
         INPUTI(3) = MIN(10,MAX(0,INPUTI(3)))
         INPUTI(4) = MIN(10,MAX(0,INPUTI(4)))
         INPUTI(5) = MAX(0,INPUTI(5))
         IDRAW = INPUTI(6)
      ELSE
C
C  verify degree (only relevant for MODI/AREA)
         DEGREE = INPUTI(1)
         IF (DEGREE.LT.0) THEN
            DEGREE = 0
         ELSE IF (DEGREE.GT.2) THEN
            DEGREE = 2
         ENDIF
         IDRAW = INPUTI(2)
         IF (DEGREE.EQ.0)                   !for degree 0 get constant value
     +        CONST = INPUTR(1)             !changed by swolf@eso.org
c     +      CALL STKRDR('INPUTR',1,1,IAV,CONST,UNI,NUL,STAT)
      ENDIF
C
C  map input + result frame

      IF (FRAMEB(1:1).NE.'+') THEN
         CALL GENEQF(FRAMEA,FRAMEB,STAT) 
      ELSE
         FRAMEB(1:) = FRAMEA(1:)                  !result frame = input frame
         STAT = 1
      ENDIF
      IF (STAT.EQ.1) THEN
         CALL STIGET(FRAMEA,D_R4_FORMAT,F_IO_MODE,F_IMA_TYPE,
     +               2,NAXIS,NPIXA,STARTA,STEPA,IDENTA,
     +               CUNITA,PNTRA,IMNOA,STAT)
         IMNOB = IMNOA
         PNTRB = PNTRA
         SIZE = NPIXA(1)*NPIXA(2)
         IF (NAXIS.GT.2) THEN
            NAXIS = 2
            CALL STTPUT('Only 1. plane of frame used!',STAT)
         ENDIF
         CALL STTPUT
     +   ('Warning: Input frame will be updated...',STAT)
      ELSE
         CALL STIGET(FRAMEA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +               2,NAXIS,NPIXA,STARTA,STEPA,IDENTA,
     +               CUNITA,PNTRA,IMNOA,STAT)
         IF (NAXIS.GT.2) THEN
            NAXIS = 2
            CALL STTPUT('Only 1. plane of input frame used!',STAT)
         ENDIF
         CALL STIPUT(FRAMEB,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +               NAXIS,NPIXA,STARTA,STEPA,IDENTA,
     +               CUNITA,PNTRB,IMNOB,STAT)
         SIZE = NPIXA(1)*NPIXA(2)
         OUTPUT(1:) = '... copying input frame to result frame ... '
         CALL STTDIS(OUTPUT,99,STAT)
         CALL COPYF(MADRID(PNTRA),MADRID(PNTRB),SIZE)
         IF (IDRAW .GE. 2) THEN                !copy to disk
            IPIXS(1) = 1                       !IPIXS will be reset later on...
            IPIXS(2) = 1
            CALL MEMDSK(IMNOB,0,MADRID(PNTRB),NPIXA,
     +                  IPIXS,NPIXA,STAT)
         ENDIF
      ENDIF
      LFLAGS(2) = D_R4_FORMAT                   !indicate real data type
C
C  get cuts of input image 
      CALL STDRDR(IMNOA,'LHCUTS',1,4,IAV,CUTS,UNI,NUL,STAT)
      IF (CUTS(1).GE.CUTS(2)) THEN
         CUTIND = 3
      ELSE
         CUTIND = 1
      ENDIF
      ZCUTS(1) = CUTS(3)
      ZCUTS(2) = CUTS(4)
      STPINV(1) = 1.0 / STEPA(1)
      STPINV(2) = 1.0 / STEPA(2)
C 
      IF (MODMOD.EQ.1) THEN
         IF (CIMASEC(1:1).NE.'+') THEN
            CALL EXTCOO(IMNOA,CIMASEC,3,IAV,SPIX,EPIX,STAT)
            IF (STAT.NE.0) 
     +         CALL STETER(2,'Invalid coords for image section...')
C 
         ELSE
            SPIX(1) = 1
            EPIX(1) = NPIXA(1)
            SPIX(2) = 1
            EPIX(2) = NPIXA(2)
         ENDIF
         IXLO = SPIX(1)         !lower x-coordinate
         IXUP = EPIX(1)         !upper x-coordinate
         IYLO = SPIX(2)         !lower y-coordinate
         IYUP = EPIX(2)         !upper y-coordinate of allowed image section
         OMIN = CUTS(3)
         IF (OMIN.LE.0.) THEN                    !set offset value...
            OFFSET = ABS(OMIN) + 1.
         ELSE
            OFFSET = 0.
         ENDIF
      ENDIF
C  
C  fork according to input mode
      NMAL = 0
      IF (TABFLG.EQ.2) THEN
         IF (IDRAW.GE.2) THEN
            CALL DTOPEN(1,STAT)                  !check, if image is loaded
            CALL DTGICH(QDSPNO,QIMCH,OUTPUT,INPUTR,STAT)
            CALL GENEQF(FRAMEA,OUTPUT,STAT) 
            IF (STAT.NE.1) THEN
               CALL STTPUT
     +         ('Input image not lodaded => draw flag ignored...',
     +          STAT)
               IDRAW = 0
            ELSE
               CALL PIXXCV('INIT',IMNOA,RBUF,STAT)
            ENDIF
         ELSE
            DAZOP = 0                      !indicate, that we don't use display
         ENDIF
         IF (CSYST.EQ.'W')           !init wc --> frame pixel conversion
     +      CALL FPXWCO(0,IMNOA,DD1,DD2,STAT)
         GOTO 3000
      ENDIF
C
      IF ((IDRAW.EQ.1).OR.(IDRAW.EQ.3)) THEN
         CACT = 'NYYY?C0 '
      ELSE
         CACT = 'NNYY?C0 '
      ENDIF
C
C  for interactive (cursor) mode - attach ImageDisplay
      CALL DTOPEN(1,STAT)
      FRAMEA(1:) = ' '                         !to init GETCUR ...
      CALL SETCUR(QDSPNO,2,0,0,KCOOR,STAT)     !set cursor rectangle
      CALL CONCHA(QDSPNO,QOVCH,1,0)            !clear overlay channel
      CALL PIXXCV('INIT',IMNOA,RBUF,STAT)
C
C  input cursor positions and check status
1000  WRITE(OUTPUT,10000) NMAL+1
      CALL STTDIS(OUTPUT,99,STAT)
      CALL GETCUR(CACT,FRAMEA,
     +            ICUR1,PCUR1,COOR(1),RBUF(1),STAT1,
     +            ICUR2,PCUR2,COOR(3),RBUF(1),STAT2)
C
C  check cursor status  
      IF ((STAT1.EQ.0).AND.(STAT2.EQ.0)) THEN
         IF ((NMAL.EQ.0) .AND. (COOFF.EQ.0)) THEN
            COOFF = 1
            FRAMEA(1:) = ' '
            CALL STTPUT(INFO,STAT)
            GOTO 1000
         ELSE
            GOTO 5000
         ENDIF
      ENDIF
C      
C  now goto section, where we really do the work
      NMAL = NMAL + 1                        !update counter
      IF (MODMOD.EQ.1) THEN
         PCEN(1) = (ICUR1(1)+ICUR2(1)) * .5
         PCEN(2) = (ICUR1(2)+ICUR2(2)) * .5
         CALL PIXXCV('IRW',0,PCEN,STAT)
      ENDIF
      GOTO 4000
C      
C  here we get our input data from a table
C      
3000  NMAL = NMAL + 1
      IF (NMAL.GT.NROW) THEN
         CALL TBTCLO(TID,STAT)
         WRITE(OUTPUT,10001) (NMAL-1)
         CALL STTPUT(OUTPUT,STAT)
         GOTO 5000
      ENDIF
C      
C  read xstart, ystart, xend, yend from table
      CALL TBSGET(TID,NMAL,SELFLG,STAT)
      IF (.NOT.SELFLG) GOTO 3000
C 
      CALL TBRRDR(TID,NMAL,4,TABCOLN,COOR,TABNUL,STAT)
      IF (CSYST.EQ.'W') THEN          !world coordinates --> transfer to pixels
         DD1(1) = COOR(1)                !convert wc -> fp
         DD1(2) = COOR(2)
         CALL FPXWCO(-1,0,DD1,DD2,STAT)
         IF (STAT .GT. 0)
     +      CALL STETER(36,'Problems with WCS of frame...')
         PCUR1(1) = DD2(1)
         PCUR1(2) = DD2(2)
         DD1(1) = COOR(3)
         DD1(2) = COOR(4)
         CALL FPXWCO(-1,0,DD1,DD2,STAT)
         IF (STAT .GT. 0)
     +      CALL STETER(36,'Problems with WCS of frame...')
         PCUR2(1) = DD2(1)
         PCUR2(2) = DD2(2)
      ELSE                            !table entries area already in pixels
         PCUR1(1) = COOR(1)
         PCUR1(2) = COOR(2)
         PCUR2(1) = COOR(3)
         PCUR2(2) = COOR(4)
      END IF
      IF (IDRAW.GE.2) CALL PIXXCV('_RS',0,PCUR1,STAT)
      ICUR1(1) = NINT(PCUR1(5))
      ICUR1(2) = NINT(PCUR1(6))
C 
C  do the replacement
4000  IF (MODMOD.EQ.1) THEN           !define cursor area + surrounding surface 
         IPIXS(1) = NINT(PCUR1(1))    !real pixel no.s
         IPIXS(2) = NINT(PCUR2(1))
         IPIXS(3) = NINT(PCUR1(2))
         IPIXS(4) = NINT(PCUR2(2))
         IF ((IPIXS(2).LT.IXLO) .OR. (IPIXS(1).GT.IXUP) .OR.
     +       (IPIXS(4).LT.IYLO) .OR. (IPIXS(3).GT.IYUP)) THEN
            CALL STTPUT(ERMS16,STAT)
            GOTO (1000,3000),TABFLG
         ENDIF
         IPX = IPIXS(2) - IPIXS(1) + 1        !no. of pixels in cursor area...
         IPY = IPIXS(4) - IPIXS(3) + 1
         ICX = IPIXS(1) + IPX/2               !center of cursor area
         ICY = IPIXS(3) + IPY/2
C      
         ISX = NINT(INPUTR(1)*(IPX-1)) + 1     !no. of pixels in surface
         ISY = NINT(INPUTR(2)*(IPY-1)) + 1 
         ISUR(1) = MAX(IXLO,ICX - ISX/2)       !xlow
         ISUR(2) = MIN(IXUP,ISUR(1) + ISX - 1) !xhi
         ISUR(3) = MAX(IYLO,ICY - ISY/2)       !ylow
         ISUR(4) = MIN(IYUP,ISUR(3) + ISY - 1) !yhi
C
         XDEG = INPUTI(3)                     !erase spot
         YDEG = INPUTI(4)
         IT = INPUTI(5)
         CRMS = -1.
C 
         CALL ERASE(MADRID(PNTRB),NPIXA(1),NPIXA(2),IPIXS,ISUR,XDEG,
     +              YDEG,OFFSET,IT,CRMS,NOISE,STAT)
C
         IF (STAT.NE.0) THEN                        !check return status
            IF (STAT.GE.1 .AND. STAT.LE.5) THEN     !NAGLIB error
               WRITE(OUTPUT,111) STAT
               CALL STTPUT(OUTPUT,STAT)
               CALL STTPUT(ERMS13,STAT)
               GOTO 5500
            ELSE IF (STAT .EQ. 7) THEN             !surface dimension too large
               CALL STTPUT(ERMS12,STAT)
               CALL STTPUT(TIP12,STAT)
               GOTO (1000,3000),TABFLG
            ELSE IF (STAT.EQ.8) THEN                !subimage-row undersampled
               CALL STTPUT(ERMS15,STAT)
               CALL STTPUT(TIP15,STAT)
               GOTO (1000,3000),TABFLG
            ELSE IF (STAT.EQ.9) THEN                !subimage-not well defined
               CALL STTPUT(ERMS16,STAT)
               GOTO (1000,3000),TABFLG
            ENDIF
         ENDIF
C 
         PCEN(5) = (COOR(1)+COOR(3)) * .5
         PCEN(6) = (COOR(2)+COOR(4)) * .5
         WRITE(OUTPUT,222) IPX,IPY,PCEN(5),PCEN(6)
         CALL STTPUT(OUTPUT,STAT)
C
      ELSE
         CALL STAREM(MADRID(PNTRB),NPIXA(1),NPIXA(2),
     +               STARTA,STEPA,COOR,CSYST,DEGREE,CONST,RCUTS)
         IF (ZCUTS(1).GT.RCUTS(1)) ZCUTS(1) = RCUTS(1)
         IF (ZCUTS(2).LT.RCUTS(2)) ZCUTS(2) = RCUTS(2)
      ENDIF
C
C  if required, reload modified subwindow
      IF (IDRAW.GE.2) THEN
         LOW1(1) = NINT(PCUR1(1))
         LOW1(2) = NINT(PCUR1(2))
         HI(1) = NINT(PCUR2(1))
         HI(2) = NINT(PCUR2(2))
         WPIX(1) = HI(1) - LOW1(1) + 1
         WPIX(2) = HI(2) - LOW1(2) + 1
         CALL MEMDSK(IMNOB,0,MADRID(PNTRB),NPIXA,LOW1,WPIX,STAT)
         WW(1) = ICUR1(1)
         WW(2) = ICUR1(2)
         WW(3) = SCALX
         WW(4) = SCALY
         CALL LOADWN(LFLAGS,IMNOB,NPIXA,LOW1,WPIX,WW,CUTS(CUTIND))
      ENDIF
C
      IF ((IDRAW.EQ.1) .OR. (IDRAW.EQ.3)) THEN
         WW(1) = ICUR1(1)
         WW(2) = ICUR1(2)
         WPIX(1) = HI(1) - LOW1(1) + 1
         WPIX(2) = HI(2) - LOW1(2) + 1
         IF (SCALX.GT.1) THEN
            WPIX(1) = WPIX(1)/SCALX
         ELSE IF (SCALX.LT.-1) THEN
            N2 = -SCALX
            WPIX(1) = WPIX(1)*N2
         ENDIF
         IF (SCALY.GT.1) THEN
            WPIX(2) = WPIX(2)/SCALY
         ELSE IF (SCALY.LT.-1) THEN
            N2 = -SCALY
            WPIX(2) = WPIX(2)*N2
         ENDIF
         WW(3) = WW(1) + WPIX(1) - 1
         WW(4) = WW(2)+ WPIX(2) - 1
         CALL BLDGRA('REC',WW,INPUTR,XFIGU,YFIGU,6,N2)
         CALL IIGPLY(QDSPNO,QOVCH,XFIGU,YFIGU,N2,255,1,STAT)
      ENDIF
C 
      IF (TABFLG.EQ.1) THEN
         GOTO 1000
      ELSE
         GOTO 3000
      ENDIF
C
C  get new dynamic range + write descriptor LHCUTS
5000  IF (CUTS(3).GT.ZCUTS(1)) CUTS(3) = ZCUTS(1)
      IF (CUTS(4).LT.ZCUTS(2)) CUTS(4) = ZCUTS(2)
C      
C  append HISTORY
      CALL DSCUPT(IMNOA,IMNOB,' ',STAT)
      CALL STDWRR(IMNOB,'LHCUTS',CUTS,1,4,UNI,STAT)      !but use old cuts...
C      
C  That's it folks...
5500  IF (DAZOP.EQ.1) THEN
         CALL DTCLOS(QDSPNO)
         IF (IDRAW.GT.0) CALL REFOVR(STAT)
      ENDIF
      OUTPUT(1:) = ' '
      CALL STTDIS(OUTPUT,99,STAT)
      RETURN
C      
C  format statements
10000 FORMAT(I3,', ready for cursor input...')
10001 FORMAT(I6,' rows processed.')
111   FORMAT('IFAIL = ',I3)
222   FORMAT('cleaned area:',I3,' x',I3,' pixels at xc = ',F10.3,
     +       ', yc = ',F10.3)
      END

      SUBROUTINE 
     + STAREM(A,NPIX1,NPIX2,STARTA,STEPA,COOR,CSYST,IDEG,CONST,RMAX)
C
      IMPLICIT NONE
C      
      INTEGER  NPIX1,NPIX2,IDEG
      INTEGER  I,I1,I2,J,J1,J2
      INTEGER  M,N,INC
      INTEGER  STAT
C 
      REAL     A(NPIX1,NPIX2),COOR(4),RMAX(2)
      REAL     X(200),Y(200),Z(200),B(7)
      REAL     AIJ,B1,B2,B3,B4,B5,B6,D2
      REAL     Q2,Q22,QX,QX2,QY,QY2
      REAL     X1,X2,XC,XX,Y1,Y2,Y22,YC,YY
      REAL     ZMAX,ZMIN
      REAL     STEP1,STEP2,START1,START2
      REAL     CONST,STEP11,STEP22
C 
      DOUBLE PRECISION STARTA(*),STEPA(*)
C
      CHARACTER CSYST*1, OUTPUT*80
C
222   FORMAT('clean area:',I3,' x',I3,' pixels at xc = ',F10.3,
     +       ', yc = ',F10.3)
C      
C  init
      STEP1=STEPA(1)
      STEP2=STEPA(2)
      START1=STARTA(1)
      START2=STARTA(2)
C      
C  compute
      X1=COOR(1)
      Y1=COOR(2)
      X2=COOR(3)
      Y2=COOR(4)
C      
      XC=(X1+X2)*0.5
      YC=(Y1+Y2)*0.5
      QX=X2-XC
      QY=Y2-YC
      QX2=QX**2
      QY2=QY**2
      Q2=QX*QY
      Q22=Q2**2
C      
C  define outer rectangular boundary
      IF (CSYST.EQ.'W') THEN
         J1=(Y1-START2)/STEP2+1.
         J2=(Y2-START2)/STEP2+1.
         IF (J1.LT.1) THEN
            J1=1
         ELSE IF (J2.GT.NPIX2) THEN
            J2=NPIX2
         ENDIF
C 
         I1=(X1-START1)/STEP1+1.
         I2=(X2-START1)/STEP1+1.
         IF (I1.LT.1) THEN
            I1=1
         ELSE IF (I2.GT.NPIX1) THEN
            I2=NPIX1
         ENDIF
         Y1 = FLOAT(J1-1)*STEP2+START2-YC
         X1 = FLOAT(I1-1)*STEP1+START1-XC
      ELSE
         J1=NINT(Y1)
         J2=NINT(Y2)
         I1=NINT(X1)
         I2=NINT(X2)
         IF (J1.LT.1) THEN
            J1=1
         ELSE IF (J2.GT.NPIX2) THEN
            J2=NPIX2
         ENDIF
         IF (I1.LT.1) THEN
            I1=1
         ELSE IF (I2.GT.NPIX1) THEN
            I2=NPIX1
         ENDIF
         Y1 = Y1 - YC
         X1 = X1 - XC
         STEP1 = 1.0
         STEP2 = 1.0
      ENDIF
C      
C  assemble points between outer ellipse and circumscribed rectangle
C  XX and YY are coordinates relative to the centre (XC,YC)
C 
      YY = Y1
C
      WRITE(OUTPUT,222) I2-I1+1,J2-J1+1,XC,YC
      CALL STTPUT(OUTPUT,STAT)
C      
C  if degree = 0, replace intensities inside ellipse by constant
      IF (IDEG.EQ.0) THEN
         DO 400, J=J1,J2
            Y22=YY*YY*QX2
            XX=X1
            DO 380, I=I1,I2
               D2 = (XX*XX*QY2) + Y22
               IF (D2.LE.Q22) THEN
                  A(I,J)=CONST
               ENDIF
               XX=XX+STEP1
380         CONTINUE
            YY=YY+STEP2
400      CONTINUE
C 
         RMAX(1) = CONST
         RMAX(2) = CONST
         RETURN                        !we're done...
      ENDIF
C 
C  compute approx max no of points (the exact no depends on ellipse centre) 
C  if necessary take coarser sample
C 
      M = (I2-I1+1)*(J2-J1+1) - NINT(3.14159*Q2/STEP1**2)      !no. of points
      INC = 1 + (M/200)
      STEP11 = STEP1*FLOAT(INC)
      STEP22 = STEP2*FLOAT(INC)
      M = 0
      ZMIN = 1.E10
      ZMAX = -ZMIN
      DO 2000, J=J1,J2,INC
         Y22=YY*YY*QX2
         XX=X1
         DO 1000, I=I1,I2,INC
            D2 = (XX*XX*QY2) + Y22
            IF(D2.LT.Q22) GOTO 990
            M=M+1
            X(M)=XX
            Y(M)=YY
            AIJ=A(I,J)
            Z(M)=AIJ
            ZMIN=AMIN1(ZMIN,AIJ)
            ZMAX=AMAX1(ZMAX,AIJ)
            IF(M.EQ.200) GOTO 3000
990         XX=XX+STEP11
1000     CONTINUE
         YY=YY+STEP22
2000  CONTINUE
C      
C  test M
      RMAX(1) = ZMIN
      RMAX(2) = ZMAX
      IF (M.LT.4) RETURN
C      
C  compute N
      IF ( (IDEG.EQ.1) .OR.
     +     ((ZMAX-ZMIN).LT.(ZMAX+ZMIN)*0.2) ) THEN
         N=3
      ELSE
         N=6
      ENDIF
C
C  fit max 2nd order SURFAC to M points 
C  if M < 12, then use a plane only (degree = 1)
C  the 4 corner points should always be included
C  otherwise skip replacement
C
3000  CALL SURFAC(X,Y,Z,B,M,N)
      B1 = B(1)
      IF (N.NE.3.AND.(B1.LT.ZMIN.OR.B1.GT.ZMAX)) THEN
         N=3
         GOTO 3000
      ENDIF
C      
      B2=B(2)
      B3=B(3)
      B4=B(4)
      B5=B(5)
      B6=B(6)
C      
C  replace intensities inside ellipse
      YY=Y1
      DO 4000, J=J1,J2
         Y22=YY*YY*QX2
         XX=X1
         DO 3800, I=I1,I2
            D2 = (XX*XX*QY2) + Y22
            IF (D2.LE.Q22) THEN
               A(I,J)=B1 + XX*(B2+XX*B4+YY*B5) + YY*(B3+YY*B6)
               IF (RMAX(1) .GT. A(I,J)) THEN
                  RMAX(1) = A(I,J)
               ELSE IF (RMAX(2) .LT. A(I,J)) THEN
                  RMAX(2) = A(I,J)
               ENDIF
            ENDIF
            XX=XX+STEP1
3800     CONTINUE
         YY=YY+STEP2
4000  CONTINUE
C      
      RETURN
      END

      SUBROUTINE SURFAC(X,Y,Z,B,M,N)
C 
      IMPLICIT NONE
C 
      INTEGER   M,N
      INTEGER   N1,K,I,J
C 
      DOUBLE PRECISION  A(7,7),C(7)
C 
      REAL   X(M),Y(M),Z(M),B(7)
C  
C      LSQ fitting of surface
C      Z = B1 + B2*X + B3*Y + B4*X*X + B5*X*Y + B6*Y*Y
C      to M points
C
      IF (M.LT.12) N=3
      N1 = N+1
      DO 2, I=1,7
         DO 1, J=1,7
            A(I,J)=0.D0
1        CONTINUE
         B(I)=0.
2     CONTINUE
C 
      DO 5, K=1,M
         C(1)=1.D0
         C(2)=DBLE(X(K))                
         C(3)=DBLE(Y(K))
         C(N1)=DBLE(Z(K))
         IF (N.EQ.6) THEN
            C(4)=C(2)**2
            C(5)=C(2)*C(3)
            C(6)=C(3)**2
         ENDIF
C 
         DO 4, I=1,N1
            DO 3, J=1,N1
               A(I,J)=A(I,J)+C(I)*C(J)
3           CONTINUE
4        CONTINUE     
5     CONTINUE
C 
      CALL SIMUL(N,A,B)
C 
      RETURN
      END   

      SUBROUTINE SIMUL(N,A,X)
C 
C   the GAUSS-JORDAN complete elimination method is employed
C   with the maximum pivot strategy
C 
      IMPLICIT NONE
C 
      INTEGER    N,I,J,K,IROWI,IROWK,JCOLI,JCOLK
      INTEGER    ISCAN,JSCAN,KM1,MAX 
      INTEGER    IROW(6),JCOL(6),STAT
C 
      DOUBLE PRECISION  A(7,7),EPS,AIJCK,PIVOT,FPIVOT
C 
      REAL       X(N)
C 
      DATA   EPS  /1.D-15/
      DATA   IROW /6*0/, JCOL /6*0/
C 
      MAX=N+1   
C 
C  begin elimination procedure   
C 
      DO 19,K=1,N                 
         KM1=K-1                     
         PIVOT=0.D0                    !search for the pivot element  
         DO 10,I=1,N                 
            DO 11,J=1,N                 
C 
C search irow and jcol arrays for invalid pivot subscripts
               IF (K.EQ.1) GOTO 9            
               DO 8,ISCAN=1,KM1            
                  DO 7,JSCAN=1,KM1            
                     IF (I.EQ.IROW(ISCAN)) GOTO 11 
                     IF (J.EQ.JCOL(JSCAN)) GOTO 11 
7                 CONTINUE                    
8              CONTINUE                    
9              CONTINUE                    
               IF (DABS(A(I,J)).LE.DABS(PIVOT)) GOTO 11
               PIVOT=A(I,J)
               IROW(K)=I   
               JCOL(K)=J   
11          CONTINUE    
10       CONTINUE    
C 
C  insure that selected pivot is larger than eps
         IF (DABS(PIVOT).LE.EPS) THEN
            CALL STTPUT(' Warning! Singular Matrix',STAT)
            RETURN                      
         ELSE
            FPIVOT = 1.D0 / PIVOT
         ENDIF
C 
         IROWK=IROW(K)               
         JCOLK=JCOL(K)               
C 
C   normalize pivot row elements  
         DO 14,J=1,MAX               
            A(IROWK,J)=A(IROWK,J)*FPIVOT 
14       CONTINUE
C 
C carry out elimination   
C 
         A(IROWK,JCOLK)=FPIVOT     
         DO 18,I=1,N                 
            AIJCK=A(I,JCOLK)            
            IF (I.EQ.IROWK) GOTO 18       
            A(I,JCOLK) = -(AIJCK*FPIVOT)
            DO 17,J=1,MAX               
               IF (J.NE.JCOLK) A(I,J)=A(I,J)-AIJCK*A(IROWK,J) 
17          CONTINUE              
18       CONTINUE
19    CONTINUE   
C 
C order solution values   
C 
      DO 20,I=1,N           
         IROWI=IROW(I)         
         JCOLI=JCOL(I)         
         X(JCOLI)= A(IROWI,MAX)
20    CONTINUE
C 
      RETURN
      END

      SUBROUTINE MODCUT(ACTIO)
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION              
C  subroutine MODCUT		version 1.00	890119
C  K. Banse			ESO - Garching
C
C.KEYWORDS    
C  bulk data frame, scaling
C
C.PURPOSE
C  to rescale subimages on the ImageDisplay
C
C.ALGORITM
C  extract subimage via cursor window + apply new cut values
C
C.INPUT/OUTPUT
C  ACTIO	char. array	1 = C - cursor option, else full image
C 
C  the following keywords are used:
C  INPUTI/I/1/4                 no_of_cursors,draw_flag 
C                               and xsiz,ysiz if single cursor
C 
C  last used cut values are written to
C  OUTPUTR/R/1/2
C
C-------------------------------------------------------------------
C
      IMPLICIT NONE
C      
      INTEGER      IMNO,IAV,N,NMAL,NAXPIX(4),KEY
      INTEGER      STAT1,STAT2,STAT,LFLAGS(2)
      INTEGER      NPIXA(3),KCOOR(4),WPIX(3)
      INTEGER      LOW1(3),HI(3),IFIRST
      INTEGER      BOX(4),COOFF,UNI(1),NULO
C      
      CHARACTER    ACTIO*(*)
      CHARACTER    FRAMEA*100
      CHARACTER    INFO*44,AREA*80,FRMSTR*8,OPTION*5,CACT*8
C      
      DOUBLE PRECISION STARTA(3),STEPA(3)
C 
      REAL         RR,RVAL1,RVAL2,COOR(4),RCUTS(2)
      REAL         PCUR(4),ZBINS(3),RBUF(8),ROLD(4)
C 
      INCLUDE  'MID_INCLUDE:ST_DEF.INC'
      INCLUDE  'MID_INCLUDE:IDIDEV.INC'
      INCLUDE  'MID_INCLUDE:IDIMEM.INC'
C 
      DATA     INFO
     +    /' switch cursors on - next time we exit ... '/
C
      DATA    FRAMEA   /'         '/
      DATA    KCOOR    /-1,-1,-1,-1/
      DATA    LOW1     /1,1,1/,     HI   /1,1,1/
      DATA    NPIXA    /1,1,1/,     WPIX /1,1,1/
      DATA    COOFF    /0/,         IFIRST /0/
      DATA    FRMSTR   /'E15.6'/
      DATA    ZBINS    /256.0,0.0,0.0/
C 
      INCLUDE  'MID_INCLUDE:ST_DAT.INC'
C      
C  attach Image Display + get loaded image
      CALL DTOPEN(1,STAT)
      CALL DTGICH(QDSPNO,QIMCH,FRAMEA,RBUF,STAT)
C 
      CALL STFOPN(FRAMEA,D_R4_FORMAT,0,F_IMA_TYPE,IMNO,STAT)
      CALL STDRDI(IMNO,'NAXIS',1,1,IAV,NAXPIX,UNI,NULO,STAT)
      CALL STDRDI(IMNO,'NPIX',1,NAXPIX(1),IAV,NPIXA,UNI,NULO,STAT)
      CALL STDRDD(IMNO,'START',1,NAXPIX(1),IAV,STARTA,UNI,NULO,STAT)
      CALL STDRDD(IMNO,'STEP',1,NAXPIX(1),IAV,STEPA,UNI,NULO,STAT)
      DO 100, N=1,3
         NAXPIX(N+1) = NPIXA(N)
100   CONTINUE
C
      LFLAGS(2) = D_R4_FORMAT     !tell LOADWN that we opened as R4 data
      IF (ACTIO(1:1).EQ.'C') GOTO 490
C 
C ---------------------------------------
C 
C  here we handle the full image
C 
C ---------------------------------------
C 
      OPTION = 'YYHNH'            !full frame, histogram only
      BOX(1) = SSPX
      BOX(2) = SSPY
      LOW1(1) = SFPX
      LOW1(2) = SFPY
      WPIX(1) = NSX
      WPIX(2) = NSY
      LFLAGS(1) = -100            !whole frame in display window
C 
400   AREA(1:) = ' '
      WRITE(AREA,10001) COOR(1),COOR(2),COOR(3),COOR(4)
      CALL BLANKO(AREA)           !make statistics in displayed area
      CALL ZMSTAT(IMNO,AREA,NAXPIX,STARTA,STEPA,ZBINS,FRMSTR,OPTION)
C
440   CALL PLOHI(IMNO)
      IF (IFIRST.EQ.0) THEN
         RVAL1 = 50
         RVAL2 = 50
         IFIRST = 1
      ELSE
         CALL PTDATA(20,0,0,ROLD(1),ROLD(2),0.0,1)    !show old cuts
         CALL PTDATA(20,0,0,ROLD(3),ROLD(4),0.0,1)
      ENDIF
      CALL PTGCUR(RVAL1,RVAL2,KEY,STAT)               !graphCursor input
      IF (KEY.EQ.32) GOTO 8900                        !gCursor exit
C 
      ROLD(1) = RVAL1
      ROLD(2) = RVAL2
      CALL PTDATA(4,0,0,RVAL1,RVAL2,0.0,1)
      RCUTS(1) = RVAL1
      CALL PTGCUR(RVAL1,RVAL2,KEY,STAT)
      IF (KEY.EQ.32) GOTO 8900                        !gCursor exit
C 
      ROLD(3) = RVAL1
      ROLD(4) = RVAL2
      CALL PTDATA(4,0,0,RVAL1,RVAL2,0.0,1)
      RCUTS(2) = RVAL1
      IF (RCUTS(1).GT.RCUTS(2)) THEN
         RR = RCUTS(1)
         RCUTS(1) = RCUTS(2)
         RCUTS(2) = RR
      ENDIF
      WRITE(AREA,10010) RCUTS(1),RCUTS(2)
      CALL STTDIS(AREA,99,STAT)
      CALL STDWRR(IMNO,'LHCUTS',RCUTS,1,2,UNI,STAT)
C
C  load image with new cuts
C
      CALL LOADWN(LFLAGS,IMNO,NPIXA,LOW1,WPIX,BOX,RCUTS)
      CALL DAZVIS(QDSPNO,QIMCH,2,1)
      GOTO 440
C 
C ---------------------------------------
C 
C  here we handle cursor defined sub-frames
C 
C ---------------------------------------
C 
490   LFLAGS(1) = -99             !subframes in display window
      CACT = 'YNYY?C0 '
      CALL SETCUR(QDSPNO,2,0,2,KCOOR,STAT)     !set cursor shape
      FRAMEA(1:) = ' '                         !to init GETCUR ...
      NMAL = -1
      OPTION = 'NYHNH'            !subframe, histogram only
C
C  input cursor positions and check status
500   NMAL = NMAL + 1
550   CALL GETCUR(CACT,FRAMEA,
     +            BOX(1),PCUR(1),COOR(1),RVAL1,STAT1,
     +            BOX(3),PCUR(3),COOR(3),RVAL2,STAT2)
C
C  check cursor status  
      IF ((STAT1.EQ.0).AND.(STAT2.EQ.0)) THEN
         IF ((NMAL.EQ.0) .AND. (COOFF.EQ.0)) THEN
            COOFF = 1
            FRAMEA(1:) = ' '
            CALL STTPUT(INFO,STAT)
            GOTO 550
         ELSE
            GOTO 9000                          !get out
         ENDIF
      ENDIF
C
      AREA(1:) = ' '
      WRITE(AREA,10001) COOR(1),COOR(2),COOR(3),COOR(4)
      CALL BLANKO(AREA)
      CALL ZMSTAT(IMNO,AREA,NAXPIX,STARTA,STEPA,ZBINS,FRMSTR,OPTION)
C 
700   CALL PLOHI(IMNO)
      IF (IFIRST.EQ.0) THEN
         RVAL1 = 50
         RVAL2 = 50
         IFIRST = 1
      ELSE
         CALL PTDATA(20,0,0,ROLD(1),ROLD(2),0.0,1)    !show old cuts
         CALL PTDATA(20,0,0,ROLD(3),ROLD(4),0.0,1)
      ENDIF
      CALL PTGCUR(RVAL1,RVAL2,KEY,STAT)
      IF (KEY.EQ.32) GOTO 1000                        !move to next subframe
C 
      ROLD(1) = RVAL1
      ROLD(2) = RVAL2
      CALL PTDATA(4,0,0,RVAL1,RVAL2,0.0,1)
      RCUTS(1) = RVAL1
      CALL PTGCUR(RVAL1,RVAL2,KEY,STAT)
      IF (KEY.EQ.32) GOTO 1000                        !move to next subframe
C 
      ROLD(3) = RVAL1
      ROLD(4) = RVAL2
      CALL PTDATA(4,0,0,RVAL1,RVAL2,0.0,1)
      RCUTS(2) = RVAL1
      IF (RCUTS(1).GT.RCUTS(2)) THEN
         RR = RCUTS(1)
         RCUTS(1) = RCUTS(2)
         RCUTS(2) = RR
      ENDIF
      WRITE(AREA,10010) RCUTS(1),RCUTS(2)
      CALL STTDIS(AREA,99,STAT)
C 
C  load sub-image with new cuts
C 
      LOW1(1) = NINT(PCUR(1))
      LOW1(2) = NINT(PCUR(2))
      HI(1) = NINT(PCUR(3))
      HI(2) = NINT(PCUR(4))
      WPIX(1) = HI(1) - LOW1(1) + 1
      WPIX(2) = HI(2) - LOW1(2) + 1
      CALL LOADWN(LFLAGS,IMNO,NPIXA,LOW1,WPIX,BOX,RCUTS)
      GOTO 700
C 
1000  CALL STTPUT(AREA,STAT)
      CALL STTDIS
     + ('Move to next subframe                           ',99,STAT)
      IFIRST = 0
      GOTO 500
C      
C  That's it folks...
8900  CALL STTPUT(AREA,STAT)                  !write permanently
      CALL STDWRR(IMNO,'LHCUTS',RCUTS,1,2,UNI,STAT)    !update descr. LHCUTS
C 
9000  CALL STTDIS(' ',-9,STAT)
      CALL DTCLOS(QDSPNO)
      CALL STKWRR('OUTPUTR',RCUTS,1,2,UNI,STAT)         !save last cuts
      RETURN
C      
10001 FORMAT('[',G12.6,',',G12.6,':',G12.6,',',G12.6,'] ')
10010 FORMAT('Cut values used: ',2F12.5)
      END

      SUBROUTINE ERASE(CIMG,NPIX,NLIN,ICUR,IMAP,
     +                 K,L,OFS,IT,CRMS,NOISE,ISTAT)
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION 
C subroutine ERASE     		
C (H.Waldthausen)
C K. Banse			version 1.00	880922
C R. Hook                       version 1.10    890621
C        - Less restrictive area of fit
C        - Optional noise according to new logical flag (NOISE)
C
C.TYPE        subroutine
C
C.KEYWORDS    interpolation
C
C.PURPOSE
C
C	This routine removes an unwanted detail in an image. 
C	The surface is 
C       an approximation to the weighted,least- squares Chebyshev
C	series surface fit.The weights are derived from the Poisson
C	error for the two first modes. 
C
C.ALGORITHM   1) read cursor coordinates
C             2) construct surface area around cursor
C	      3) replace bad pixels inside cursor
C	      4) optionally add noise
C
C.MODULES CALLS   E02CAF,E02CBF  from NAGLIB
C
C.INPUT/OUPUT   parameters
C
C	->CIMG  input image to be updated
C	->NPIX  x-pixels and 
C	->NLIN  y-lines of CIMG
C	->IMAP  surface area indices
C	->ICUR  cursor area indices
C	->K     surface fit order in x
C	->L     surface fit order in y
C	->OFS   add this pixel offset to CIMG 
C	->IT    number of iterations 
C	->CRMS  rms of CIMG  (if pos. take this value)  
C	->NOISE logical flag for whether patch should be filled with noise
C	<-ISTAT output status 
C               : 0 O.K.
C               : POS 1-5 failure of E02CAF or E02CBF routines
C		: 6 fit order exeeded
C		: 7 surface-size larger than 102400 pixels
C		: 8 subimage-row undersampled
C		: 9 subimage-bounds are wrong
C
C CHANGED:
C     28.4.98 swolf@eso.org - blow area up: 60x60 --> 320x320
C     24.9.98 swolf@eso.org - check areas (xlo<xup, ylo<yup)
C------------------------------------------------------------------
C					 	
      IMPLICIT NONE
C 
      INTEGER   KMAX,MAXLIN,MAXPIX,MTOTAL,NA,NW
      PARAMETER (KMAX = 10)
      PARAMETER (MAXLIN = 4096)           !max 4096 lines
      PARAMETER (MAXPIX = 1024)           !max 1024 pixels per line
      PARAMETER (MTOTAL = 204800)         !but only 1024*200 in total
      PARAMETER (NA = (KMAX+1)*(KMAX+1))
      PARAMETER (NW = MTOTAL+2*MAXLIN+2*MAXLIN*(KMAX+2)+5*(1+KMAX))
C 
      INTEGER   NPIX,NLIN,ICUR(4),IMAP(4),M(MAXLIN)
      INTEGER   K,L,IT,ISTAT
      INTEGER   JOXA,JOXE,JOYA,JOYE
      INTEGER   JDXA,JDXE,JDYA,JDYE
      INTEGER   KP,KI,KX,KY,KPO,LPO,NPC,NLC,NPP,NPY
      INTEGER   MPC,MLC,JY,JX,KA,KE
      INTEGER   IN,IS,I,ITER
C 
      LOGICAL	NOISE
C
      CHARACTER CBUF*40
C
      REAL      ZZ,CRMS,OFS,CIMG(NPIX,NLIN),RAN1
C
      DOUBLE PRECISION  X(MTOTAL),Y(MAXLIN),F(MTOTAL),W(MTOTAL),A(NA)
      DOUBLE PRECISION  XMIN(MAXLIN),XMAX(MAXLIN),UX(1),UY(1),WORK(NW)
      DOUBLE PRECISION  FF(MTOTAL),YMI,YMA,XMI,XMA,YBS,SQ,DEL,DELC
      DOUBLE PRECISION  ARG,RMS,AKAP,AP
C
C     dimensions of arrays used by E02CAF and E02CBF are a function
C     of MAXLIN, MAXPIX, MTOTAL + KMAX 
C     currently MAXLIN = 1024, MAXPIX = 4096, MTOTAL = 1024*200, KMAX = 10
C     to change, use the following recipe:
C     dimension MAXLIN for array M,Y,XMIN,XMAX
C     dimension MTOTAL for array X,F,W
C     dimension (KMAX+1)**2  for array A 
C     dimension NW           for array WORK
C     NW = MTOTAL + 2*max(MAXLIN,MAXPIX) + 2*MAXLIN*(KMAX+2) + 5*(1+KMAX)
C      
      ISTAT = 0
C
C  initialize 
      JOXA = IMAP(1)
      JOXE = IMAP(2)
      JOYA = IMAP(3)
      JOYE = IMAP(4)
      JDXA = ICUR(1)
      JDXE = ICUR(2)
      JDYA = ICUR(3)
      JDYE = ICUR(4) 
      KPO = K + 1
      LPO = L + 1
C
C
C**      automatic kap*sig surface fit
C 
C
C  check size of surrounding surface...
      NPC = JOXE - JOXA + 1
      NLC = JOYE - JOYA + 1
      IF ( (NPC.GT.MAXPIX) .OR.
     +     (NLC.GT.MAXLIN) .OR.
     +     ((NPC*NLC).GT.MTOTAL) ) THEN
         ISTAT = 7
         RETURN
      ENDIF
      MPC = JDXE - JDXA + 1
      MLC = JDYE - JDYA + 1
C
C  make sure, that cursor area is within surrounding area + not undersampled...
C  This has been modified to be less restrictive in V1.1 (RNH)
      IF ( (JDXA.LT.JOXA) .OR.
     +     (JDXE.GT.JOXE) .OR.
     +     (JDYA.LT.JOYA) .OR.
     +     (JDYE.GT.JOYE) .OR.
     +     (NPC*NLC-MPC*MLC) .LT. LPO+KPO) THEN
         ISTAT = 8
         RETURN
      ENDIF
C
C  check if areas are well defined (SW)
      IF ( (JDXA.GE.JDXE) .OR.
     +     (JDYA.GE.JDYE) .OR.
     +     (JOXA.GE.JOXE) .OR.
     +     (JOYA.GE.JOYE) ) THEN
         ISTAT = 9
         RETURN
      ENDIF
C
C  define param. and subr-matrices
      YMI = JOYA
      YMA = JOYE
      XMI = JOXA
      XMA = JOXE
      IS = 0
      DO 200,JY=JOYA,JOYE
         IS = IS + 1
         Y(IS) = JY
         M(IS) = NPC
         XMIN(IS) = XMI
         XMAX(IS) = XMA
200   CONTINUE
C
C  data and weight matrices
      I = 1
      DO 600,JY = JOYA,JOYE
         DO 400,JX = JOXA,JOXE
            X(I) = JX
            F(I) = DBLE(CIMG(JX,JY))
            W(I) = 1.D0
            IF ( (JY.GE.JDYA) .AND. (JY.LE.JDYE) .AND.
     +           (JX.GE.JDXA) .AND. (JX.LE.JDXE) )     W(I) = 0.D0
            I = I + 1
400      CONTINUE
600   CONTINUE
C
C  fit a first surface to all points
C 
      CALL E02CAF(M,NLC,K,L,X,Y,F,W,MTOTAL,A,NA,XMIN,XMAX,UX,1,UY,1,
     +            WORK,NW,ISTAT)
      IF (ISTAT.NE.0) RETURN
C
C  compute initial rms 
      KA = 1
      NPP = 0
      DEL = 0.0D0
      DO 1000,JY = JOYA,JOYE
         YBS = JY
         KE = KA + NPC - 1
         CALL E02CBF(KA,KE,K,L,X,XMI,XMA,YBS,YMI,YMA,
     +               FF,A,NA,WORK,NW,ISTAT)
         DO 800,JX = KA,KE
            NPP = NPP + 1
            SQ = F(JX) - FF(JX) 
            DELC = SQ * SQ                  !DELC = (F-FF)**2
            DEL = DEL + DELC
800      CONTINUE
         KA = KE + 1
1000  CONTINUE
C
      AP = NPP - 1
      DEL = DEL/AP
      ARG = DMAX1(1.D-37,DEL)
      RMS = DSQRT(ARG)
      AKAP = 2.0D0*RMS
C
C  now iterate
C 
      IF (IT.LE.0) GO TO 8000
C 
      DO 4000,ITER=1,IT
         KA = 1
         NPP = 0
         DEL = 0.0
         DO 2000,JY=JOYA,JOYE
            YBS = JY
            KE = KA + NPC - 1
            CALL E02CBF(KA,KE,K,L,X,XMI,XMA,YBS,YMI,YMA,FF,A,NA,WORK,
     +                  NW,ISTAT)
            NPY = 0
            DO 1500,JX=KA,KE
               W(JX) = 0.0D0
               NPY = NPY + 1
               IF ( DABS(F(JX) - FF(JX)) .LE. AKAP) THEN
                  W(JX) = 1.0D0
                  NPP = NPP + 1
                  NPY = NPY - 1
                  SQ = F(JX) - FF(JX) 
                  DELC = SQ * SQ                  !DELC = (F-FF)**2
                  DEL = DEL + DELC
               ENDIF
1500        CONTINUE
C 
            KP = NPC - NPY
            IF (KP.LT.KPO)  THEN
               CBUF(1:) = 'Warning: No convergence ... '
               CALL STTPUT(CBUF,KI)
               GOTO 8000
            ELSE
               KA = KE + 1
            ENDIF
2000     CONTINUE
C
C  find new rms
         AP = NPP - 1
         DEL = DEL/AP
         ARG = DMAX1(1.D-37,DEL)
         RMS = DSQRT(ARG)
         AKAP = 2.0D0*RMS
C
C  fit new surface
         CALL E02CAF(M,NLC,K,L,X,Y,F,W,MTOTAL,A,NA,XMIN,XMAX,UX,1,UY,1,
     +               WORK,NW,ISTAT)
         IF (ISTAT.NE.0) RETURN
4000  CONTINUE
C
C  flag "bad" pixels...
8000  KI = 1
      DO 8800,KY=JDYA,JDYE
         DO 8600,KX=JDXA,JDXE
            W(KI) = KX               !W now contains indices of bad pixels
            KI = KI + 1
8600     CONTINUE
8800  CONTINUE
C      
C  and calculate new pixels
      KA = 1
      DO 9000,KY=JDYA,JDYE
         KE = KA + MPC - 1
         YBS = KY 
         CALL E02CBF(KA,KE,K,L,W,XMI,XMA,YBS,YMI,YMA,FF,A,NA,WORK,
     +               NW,ISTAT)
         IF (ISTAT.NE.0) RETURN
         KA = KE + 1
9000  CONTINUE
C
C  add noise if optional flag is set (RNH)
C 
      IF (NOISE) THEN
         OFS = RAN1(-JDXA)                       !init random generator
         IS = 1
      ENDIF
      IF (CRMS.GT.0.) RMS = DBLE(CRMS)
C 
      DO 9500,KY=JDYA,JDYE
         IN = (KY-JDYA) * MPC - JDXA + 1
         IF (NOISE) THEN
            DO 9100,KX=JDXA,JDXE
               ZZ = SNGL(FF(IN+KX))
               OFS = RAN1(0)                          !IN is in ]0,1]
               IF (OFS.LT.0.5) THEN
                  IF (IS.GT.0) THEN
                     CIMG(KX,KY) = (1.0 + 0.1*OFS) * ZZ
                     IS = 0
                  ELSE
                     CIMG(KX,KY) = (1.0 - 0.1*OFS) * ZZ
                     IS = 1
                  ENDIF
               ELSE
                  CIMG(KX,KY) = ZZ
               ENDIF
9100        CONTINUE
            L = 1000.*OFS                              !new root for RAN1
            OFS = RAN1(-L)
         ELSE
            DO 9200,KX=JDXA,JDXE
               CIMG(KX,KY) = SNGL(FF(IN+KX))
9200        CONTINUE
         ENDIF
9500  CONTINUE
C
      RETURN
      END

      REAL FUNCTION RAN1(IDUM)
C 
C    returns an uniform deviate between 0.0 and 1.0. 
C    input par. IDUM, set IDUM to a negative value to initialize the sequence
C    K. Banse    941024			(from Numerical Recipes)
C
      IMPLICIT NONE
C 
      INTEGER IDUM
      INTEGER IFF,IX1,IX2,IX3,IC1,IC2,IC3
      INTEGER J,IA1,IA2,IA3,M1,M2,M3
C 
      REAL R(97),RM1,RM2
C 
      SAVE R,IX1,IX2,IX3
C 
      DATA M1/259200/,IA1/7141/,IC1/54773/
      DATA M2/134456/,IA2/8121/,IC2/28411/
      DATA M3/243000/,IA3/4561/,IC3/51349/
      DATA IFF/0/
C 
      RM1=1./M1
      RM2=1./M2
      IF (IDUM.LT.0.OR.IFF.EQ.0) THEN
         IFF = 1
         IX1 = MOD(IC1-IDUM,M1)
         IX1 = MOD(IA1*IX1+IC1,M1)
         IX2 = MOD(IX1,M2)
         IX1 = MOD(IA1*IX1+IC1,M1)
         IX3 = MOD(IX1,M3)
         DO 10, J=1,97
            IX1 = MOD(IA1*IX1+IC1,M1)
            IX2 = MOD(IA2*IX2+IC2,M2)
            R(J) = (FLOAT(IX1)+FLOAT(IX2)*RM2)*RM1
10       CONTINUE
      ENDIF
C 
      IX1 = MOD(IA1*IX1+IC1,M1)
      IX2 = MOD(IA2*IX2+IC2,M2)
      IX3 = MOD(IA3*IX3+IC3,M3)
      J = 1+(97*IX3)/M3
      RAN1 = R(J)
      R(J) = (FLOAT(IX1)+FLOAT(IX2)*RM2)*RM1
      RETURN
C 
      END       

C @(#)tddspfit.for	19.1 (ESO-DMD) 02/25/03 14:11:16
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  11:40 - 15 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C  900219  KB, throw out SX calls
C
C
C.IDENTIFICATION        TDDSPFIT.FOR
C.KEYWORDS           TABLE, APPLICATIONS
C.ENVIRONMENT  MIDAS
C
C------------------------------------------------------------------
      SUBROUTINE TDRDIS(CPAR,IPAR,RPAR,DPAR,ISTAT)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.PURPOSE
C      IMPLICIT NONE
C
C DISPLAY STANDARD FIT RESULTS
C
C------------------------------------------------------------------
      CHARACTER*20 CPAR         !   IN : METHOD 
      INTEGER IPAR(*)           !   IN : INTEGER INFO
      REAL RPAR(*)              !   IN : SINGLE PRECISION INFO
      DOUBLE PRECISION DPAR(*)  !   IN : DOUBLE PRECISION INFO
      INTEGER ISTAT             !   OUT: STATUS

      CHARACTER*4 METHOD
C
C BRANCH TO THE CORRESPONDING ROUTINE
C
      METHOD = CPAR(17:20)
      IF (METHOD(1:4).EQ.'LINE') 
     .    CALL TDRDS1(CPAR,IPAR,RPAR,DPAR,ISTAT)
      IF (METHOD(1:4).EQ.'MULT') 
     .    CALL TDRDS2(CPAR,IPAR,RPAR,DPAR,ISTAT)
      RETURN

      END

      SUBROUTINE TDRDS1(CPAR,IPAR,RPAR,DPAR,ISTAT)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.PURPOSE
C
C DISPLAY STANDARD RESULTS OF THE DISPERSION ANALYSIS
C
C------------------------------------------------------------------
C      IMPLICIT NONE
      CHARACTER*20 CPAR         ! IN  : METHOD
      INTEGER IPAR(*)           ! IN  : INTEGER INFO 
      REAL RPAR(*)              ! IN  : SINGLE PRECISION INFO
      DOUBLE PRECISION DPAR(*)  ! IN  : DOUBLE PRECISION INFO
      INTEGER ISTAT             ! OUT : STATUS
C
      INTEGER I
      CHARACTER*80 FREG01
      CHARACTER*80 FREG02
      CHARACTER*80 FREG03
      CHARACTER*80 FREG04
      CHARACTER*80 FREG05
      CHARACTER*80 FREG06
      CHARACTER*80 FREG07
      DATA FREG01/
     +  ' REGRESSION          Input Table :            Type :          '
     +             /
      DATA FREG02/
     +  ' N.Cases    :         ; N.Ind.Vars   :                        '
     +             /
      DATA FREG03/
     +  ' Dependent variable  :   column #                             '
     +             /
      DATA FREG04/
     +  ' Conf.level:                        Std.Error  :              '
     +             /
      DATA FREG05/
     +  '   Var. Column           Coefficient          Std.Err         '
     +             /
      DATA FREG06/
     +  '         #                                                    '
     +             /
      DATA FREG07/
     +  '   Constant Term                                              '
     +             /
C
      FREG01(15:18) = CPAR(1:4)
      FREG01(37:44) = CPAR(9:16)
      FREG01(54:62) = ' '
      IF (CPAR(17:20).EQ.'LINE') FREG01(54:59) = 'LINEAR'
      IF (CPAR(17:20).EQ.'POWE') FREG01(54:58) = 'POWER'
      IF (CPAR(17:20).EQ.'NONL') FREG01(54:62) = 'NONLINEAR'
      CALL STTPUT(FREG01,ISTAT)
      CALL STTPUT(' ',ISTAT)
      WRITE (FREG02(15:21),9000) IPAR(1)
      WRITE (FREG02(40:42),9020) IPAR(2)
      CALL STTPUT(FREG02,ISTAT)
      WRITE (FREG03(35:37),9020) IPAR(3)
      CALL STTPUT(FREG03,ISTAT)
      WRITE (FREG04(15:27),9010) RPAR(1)
      WRITE (FREG04(50:62),9010) RPAR(2)
C CALL STTPUT(FREG04,ISTAT)
      CALL STTPUT(' ',ISTAT)
      CALL STTPUT(FREG05,ISTAT)
      DO 10 I = 1,IPAR(2)
          WRITE (FREG06(4:6),9020) I
          WRITE (FREG06(12:14),9020) IPAR(I+3)
          WRITE (FREG06(21:41),9030) DPAR(I+1)
          WRITE (FREG06(45:57),9010) RPAR(I+3)
          CALL STTPUT(FREG06,ISTAT)
   10 CONTINUE
      WRITE (FREG07(21:41),9030) DPAR(1)
      WRITE (FREG07(45:57),9010) RPAR(3)
      CALL STTPUT(' ',ISTAT)
      CALL STTPUT(FREG07,ISTAT)
      RETURN

 9000 FORMAT (I7)
 9010 FORMAT (G13.7)
 9020 FORMAT (I3)
 9030 FORMAT (G20.12)
      END

      SUBROUTINE TDRDS2(CPAR,IPAR,RPAR,DPAR,ISTAT)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.PURPOSE
C
C DISPLAY STANDARD RESULTS OF THE POLYNOMIAL FIT
C
C------------------------------------------------------------------
C      IMPLICIT NONE
      CHARACTER*20 CPAR         ! IN  : METHOD
      INTEGER IPAR(*)           ! IN  : INTEGER INFO
      REAL RPAR(*)              ! IN  : SINGLE PRECISION INFO
      DOUBLE PRECISION DPAR(*)  ! IN  : DOUBLE PRECISION INFO
      INTEGER ISTAT             ! OUT : STATUS
C
      INTEGER I,I1,J
      REAL XX
      CHARACTER*132 FREG01
      CHARACTER*132 FREG02
      CHARACTER*132 FREG03
      CHARACTER*132 FREG04
      CHARACTER*132 FREG05
      CHARACTER*132 FREG06
      CHARACTER*132 FREG07
C
      DATA FREG01/
     +  ' POLYNOMIALS         Input Table :            Type :          '
     +             /
      DATA FREG02/
     +  ' N.Cases    :         ; N.Ind.Vars   :                        '
     +             /
      DATA FREG03/
     +  ' Dependent variable  :   column #                             '
     +             /
      DATA FREG04/
     +  ' Independent variable:   column #           degree :          '
     +             /
      DATA FREG05/
     +  '  degree                                                      '
     +             /
      DATA FREG06/
     +  '                                                              '
     +             /
      DATA FREG07/
     +  '          R.M.S error    :                                    '
     +             /
C
      FREG01(15:18) = CPAR(1:4)
      FREG01(37:44) = CPAR(9:16)
      FREG01(54:62) = 'MUL L-S'
      CALL STTPUT(FREG01,ISTAT)
      CALL STTPUT(' ',ISTAT)
      WRITE (FREG02(15:21),9000) IPAR(1)
      WRITE (FREG02(40:42),9020) IPAR(2)
      CALL STTPUT(FREG02,ISTAT)
      WRITE (FREG03(35:37),9020) IPAR(3)
      CALL STTPUT(FREG03,ISTAT)
      WRITE (FREG04(35:37),9020) IPAR(4)
      WRITE (FREG04(54:56),9020) IPAR(6)
      CALL STTPUT(FREG04,ISTAT)
      WRITE (FREG04(35:37),9020) IPAR(5)
      WRITE (FREG04(54:56),9020) IPAR(7)
      IF (IPAR(2).GT.1) CALL STTPUT(FREG04,ISTAT)
      CALL STTPUT(' ',ISTAT)
      CALL STTPUT(FREG05,ISTAT)
      DO 10 I = 1,IPAR(6) + 1
          I1     = (I-1)* (IPAR(7)+1) + 1
          WRITE (FREG06(4:),9030) I - 1, (DPAR(J),J=I1,I1+IPAR(7))
          CALL STTPUT(FREG06,ISTAT)
   10 CONTINUE
      XX     = RPAR(5)
      XX     = SQRT((XX*XX)/IPAR(1))
      WRITE (FREG07(31:43),9010) XX
      CALL STTPUT(' ',ISTAT)
      CALL STTPUT(FREG07,ISTAT)
      RETURN

 9000 FORMAT (I7)
 9010 FORMAT (G13.7)
 9020 FORMAT (I3)
 9030 FORMAT (I3,1P10E12.4)
      END

C @(#)adcon.for	19.1 (ES0-DMD) 02/25/03 13:23:04
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C @(#)adcon.for	19.1 (ESO-SDAG) 02/25/03 13:23:04
cc----------------------------------------------------------------------
      SUBROUTINE ADCON(ALFAM,DELTM,ALFA,DELTA)
c----------------------------------------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z), INTEGER*4 (I-N)
      DIMENSION ALFA(3),DELTA(3)

      DO0 = 0.0D0
      DO1 = 1.0D0
      DO12 = 1.2D1
      DO24 = 2.4D1
      DO60 = 6.0D1
      PI = 4.0D0*DATAN(1.0D0)
      DOPI18 = PI/1.8D2
      ALFAS = ALFAM*DO12/PI + 2.8D-9

      IF (ALFAS.GE.DO24) ALFAS = ALFAS -DO24
      IF (ALFAS.LT.DO0) ALFAS = ALFAS + DO24
      ALFA(1) = DINT(ALFAS)
      ALFAS = (ALFAS-ALFA(1))*DO60
      ALFA(2) = DINT(ALFAS)
      ALFA(3) = (ALFAS-ALFA(2))*DO60

      DELTS = DELTM/DOPI18 + DSIGN(1.0D0,DELTM)*2.8D-8
      DELTA(1) = DINT(DELTS) 
      DELTS = (DELTS-DELTA(1))*DO60 
      DELTA(2) = DINT(DELTS) 
      DELTA(3) = (DELTS-DELTA(2))*DO60
      DELTA(2) = DABS(DELTA(2)) 
      DELTA(3) = DABS(DELTA(3)) 

      IF(DELTA(3).NE.DO60) return
      DELTA(3) = DO0
      DELTA(2) = DELTA(2) + DO1 

      IF (DELTA(2).NE.DO60) return
      DELTA(2) = DO0
      DELTA(1) = DELTA(1) + DSIGN(DO1,DELTA(1)) 

      RETURN
      END 

C @(#)coord.for	19.1 (ES0-DMD) 02/25/03 13:19:39
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE BOXWTP(RBOUND,NPIX,START,STEP,IBOUND)
C+++
C.PURPOSE:  Compute pixel coordinates and check for legal boundaries     
C.AUTHOR:   Rein H. Warmels, ESO-Garching
C.COMMENTS: none
C.VERSION:  87???? RHW creation   
C.VERSION:  910115 RHW IMPICIT NONE added
C---
      IMPLICIT   NONE
      REAL       RBOUND(2)      ! IN:  image pixel in world coordinates
      INTEGER    NPIX           ! IN:  number of pixels in the x direction
      REAL       START          ! IN:  start of image in x in world unit
      REAL       STEP           ! IN:  distance between x pixels in world unit
      REAL       IBOUND(2)      ! OUT: image coordinate in pixel coordinates
C
      INTEGER    ISTAT,ERR1,ERR2
      CHARACTER  TEXT*37,TEXT1*43,TEXT2*43
C
      DATA       TEXT/'*** WARNING: One or more coordinates '/
      DATA       TEXT1/'fall(s) below frame boundaries'/
      DATA       TEXT2/'fall(s) beyond frame boundaries'/
      DATA       ERR1/0/
      DATA       ERR2/0/
C 
C ***
      IBOUND(1) = (RBOUND(1)-START)/STEP+1
      IBOUND(2) = (RBOUND(2)-START)/STEP+1
C
      IF (IBOUND(1).LE.0.) THEN
         IBOUND(1) = 1.
         ERR1 = 1
      END IF
      IF (IBOUND(1).GT.FLOAT(NPIX)) THEN
         IBOUND(1) = FLOAT(NPIX)
         ERR2 = 1
      END IF
C
      IF (IBOUND(2).LE.0.) THEN
         IBOUND(2) = 1.
         ERR1 = 1
      END IF 
      IF (IBOUND(2).GT.FLOAT(NPIX)) THEN 
         IBOUND(2) = FLOAT(NPIX)
         ERR2 = 1
      END IF
C
      IF (ERR1.EQ.1) THEN
         CALL STTPUT(TEXT//TEXT1,ISTAT)
      ENDIF
      IF (ERR2.EQ.1) THEN
         CALL STTPUT(TEXT//TEXT2,ISTAT)
      ENDIF
C      
      RETURN                                                                 
      END


      SUBROUTINE BOXPTW(IBOUND,NPIX,START,STEP,RBOUND)
C+++ 
C.PURPOSE:  Compute world coordinates and check for legal boundaries     
C.AUTHOR:   Rein H. Warmels, ESO-Garching
C.COMMENTS: none
C.VERSION:  87???? RHW creation   
C.VERSION:  910115 RHW IMPICIT NONE added
C---
      IMPLICIT   NONE
      REAL       IBOUND(2)      ! IN: image coordinate in pixel coordinates    
      INTEGER    NPIX           ! IN: number of pixels in the x direction      
      REAL       START          ! IN: start of image in x in world unit        
      REAL       STEP           ! IN: distance between x pixels in world unit
      REAL       RBOUND(2)      ! OUT:image pixel in world coordinates         
C
      INTEGER    ISTAT,ERR1,ERR2
      CHARACTER  TEXT*37,TEXT1*43,TEXT2*43
C
      DATA       TEXT/'*** WARNING: One or more coordinates '/
      DATA       TEXT1/'fall(s) below frame boundaries'/
      DATA       TEXT2/'fall(s) beyond frame boundaries'/
      DATA       ERR1/0/
      DATA       ERR2/0/
C
C ***
      IF (IBOUND(1).EQ.-1.) THEN                    !  first x coord. too low
         ERR1 = 1
         IBOUND(1) = 1.
      ENDIF
      IF (IBOUND(1).EQ.0.) THEN                     !  first x coord. too high
         ERR2 = 1
         IBOUND(1) = FLOAT(NPIX)
      ENDIF
C 
      IF (IBOUND(2).EQ.-1.) THEN                    !  second x coord. too low 
         ERR1 = 1
         IBOUND(2) = 1.
      ENDIF
      IF (IBOUND(2).EQ.0.) THEN                     !  second x coord. too high
         ERR2 = 1
         IBOUND(2) = FLOAT(NPIX) 
      ENDIF

      RBOUND(1) = START + (IBOUND(1)-1.)*STEP
      RBOUND(2) = START + (IBOUND(2)-1.)*STEP
C
      IF (ERR1.EQ.1) THEN
         CALL STTPUT(TEXT//TEXT1,ISTAT)
      ENDIF
      IF (ERR2.EQ.1) THEN
         CALL STTPUT(TEXT//TEXT2,ISTAT)
      ENDIF
C      

      RETURN
      END

C===========================================================================
C Copyright (C) 1995,2004 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FTEXIT(NAME,ISTAT)                                             
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                   
C.COPYRIGHT: Copyright (c) 1987,2004 European Southern Observatory,
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:25 - 13 JAN 1988                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C.IDENTIFICATION                                                                
C                                                                               
C  FITLIB.FOR   VERSION 1.0  27 MAR 1984                                        
C                                                                               
C.PURPOSE                                                                       
C                                                                               
C  INTERFACE ROUTINES FOR THE FITTING STRUCTURES                                
C FINISH FIT SESSION                                                            
C CLOSE  DATA FILE                                                              
C CREATE FIT FILE NAME.FIT                                                      
C                                                                               
C.ALGORITHM                                                                     
C  use MIDAS I/O interfaces to frames and tables                                
C                                                                               
C.KEYWORDS                                                                      
C  non linear fitting                                                           
C 
C.VERSION:
C 040524	last modif
C                                                                               
C----------------------------------------------------------------               
C                                                                               
      IMPLICIT NONE                                                            
C                                                                               
C INPUT PARAMETERS                                                              
C NAME CHAR FIT DATA FILE NAME                                                  
C                                                                               
C OUTPUT PARAMETERS                                                             
C ISTAT INTG STATUS RETURN                                                      
C                                                                               
      INTEGER DUN,IP,ISTAT,II,I,N1
C 
      CHARACTER*(*) NAME                                                        
      CHARACTER*60 FITNAME                                                      
      CHARACTER WS*5,FITSPEC*7,HTXT*44
C 
      INCLUDE 'MID_INCLUDE:ST_DEF.INC/NOLIST' 
      INCLUDE 'MID_INCLUDE:FITI.INC/NOLIST'   
C 
      DOUBLE PRECISION STASTEP(2*FZINDMAX)
C 
      INCLUDE 'MID_INCLUDE:FITC.INC/NOLIST'  
      INCLUDE 'MID_INCLUDE:ST_DAT.INC/NOLIST'  
C 
      DATA FITSPEC /'FIT....'/
      DATA HTXT /'start (1-3), step (4-6) of related image '/
C                                                                               
C CLOSE DATA FILE                                                               
C                                                                               
      IF (FZMAPPED.NE.0) THEN                                                 
          IF (FZTYPE.EQ.'BDF ') THEN                                          
              CALL STFCLO(FZIDEN,ISTAT)                                       
          ELSE                                                                  
              CALL TBTCLO(FZIDEN,ISTAT)                                       
          END IF                                                                
          FZMAPPED = 0                                                        
      END IF                                                                    
C                                                                               
C EXIT DATA                                                                     
C                                                                               
      II = INDEX(NAME,' ') - 1                                         
      FITNAME = NAME(1:II)//'.fit'                                              
      CALL STFOPN(FITNAME,D_R4_FORMAT,0,F_FIT_TYPE,IP,ISTAT)
C 
      II = 0                         !just in case write NAXIS = 0
      CALL STDWRI(IP,'NAXIS',II,1,1,DUN,ISTAT)             
      CALL STDWRC(IP,'FITCHAR',1,FZCHAR,1,FZNCHAR,DUN,ISTAT)             
      CALL STDWRI(IP,'FITINTG',FZINTG,1,FZNINTG,DUN,ISTAT)             
      CALL STDWRR(IP,'FITREAL',FZREAL,1,FZNREAL,DUN,ISTAT)           
C 
      DO 100,II=1,FZINDMAX                  !save start, step in FITDOUBLE
         STASTEP(II) = FZSTART(II)
         STASTEP(II+FZINDMAX) = FZSTEP(II)
100   CONTINUE
      N1 = 2 * FZINDMAX
      CALL STDWRD(IP,'FITDOUBLE',STASTEP,1,N1,DUN,ISTAT)         
      CALL STDWRH(IP,'FITDOUBLE',HTXT,1,43,ISTAT)         
C 
      IF (FZNPTOT.EQ.0) THEN
         N1 = 128
      ELSE
         N1 = FZNPTOT
      ENDIF
      CALL STDWRD(IP,'FITPARAM',FZVALUE,1,N1,DUN,ISTAT)         
      CALL STDWRD(IP,'FITERROR',FZERROR,1,N1,DUN,ISTAT)         
      DO 200,I = 1,FZNFUN                                                      
          WRITE (WS,9000) 10000 + I                                             
          FITSPEC(4:7) = WS(2:5)                                                
          CALL STDWRC(IP,FITSPEC,1,FZSPEC(I),1,80,DUN,ISTAT)               
200   CONTINUE  
C 
      CALL STFCLO(IP,ISTAT)                                                
      RETURN                                                                    
C 
9000  FORMAT (I5)  
      END                                                                       

C @(#)tdfdecd.for	19.1 (ES0-DMD) 02/25/03 14:11:17
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:34 - 11 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C
C.IDENTIFICATION        TDFDECD.FOR
C.KEYWORDS           TABLE, APPLICATIONS
C.ENVIRONMENT  MIDAS
C.PURPOSE
C  DECODE EXTERNAL FORMAT LINE
C
C
C------------------------------------------------------------------
      SUBROUTINE TDFDEC(LINE,I1,I2,C,FORM,LABEL,UNIT,STATUS)
      IMPLICIT NONE
      CHARACTER*(*) LINE  !   IN : input format line
      INTEGER I1          !   OUT: start position
      INTEGER I2          !   OUT: end position
      CHARACTER*(*) C     !   OUT: type
      CHARACTER*8 FORM    !   OUT: format
      CHARACTER*16 LABEL  !   OUT: label
      CHARACTER*16 UNIT   !   OUT : unit 
      INTEGER STATUS      !   OUT : status
C
      INTEGER COUNT,START,I,IST,FIELD
      INTEGER FORSKP
      INTEGER LTOKEN(8)
C
      CHARACTER*1  CC
      CHARACTER*64 TOKEN(8)
      CHARACTER*1  SYMILL(9)
      CHARACTER*80 LINE1
       INCLUDE 'MID_INCLUDE:TABLES.INC/NOLIST'
       INCLUDE 'MID_INCLUDE:TABLED.INC/NOLIST'
      DATA SYMILL/')','(','+','-','*','/','.','#',':'/
C
      COUNT  = 0
      LABEL  = ' '
      UNIT   = ' '
      FORM   = ' '
      START  = FORSKP(' ',LINE(1:))
      IF (START.LE.0) THEN
          STATUS = ERRFMT
          RETURN
      END IF
      DO 10 I = 1,8
          CALL GENEXT(LINE,' ',START,TOKEN(I),LTOKEN(I))
          IF (LTOKEN(I).GT.0 .AND. (TOKEN(I) (1:1).NE.'!')) THEN
C
C ... TO BE REMOVED
C
C              CALL FORUPC(TOKEN(I),TOKEN(I))
              COUNT  = COUNT + 1
          ELSE
              GO TO 20
          END IF
   10 CONTINUE
   20 CONTINUE
      IF (COUNT.LE.3) THEN
          LINE1 = LINE
          CALL STTPUT('Wrong definition',IST)
          CALL STTPUT(LINE1,IST)
          STATUS = ERRFMT
          RETURN
      END IF
      FIELD  = LTOKEN(2)
      LINE1  = TOKEN(2)
C      READ(TOKEN(2) (1:LTOKEN(2)),9000) I1
      CALL ASCINT(LINE1, FIELD, I1)
      FIELD  = LTOKEN(3)
      LINE1  = TOKEN(3)
C      READ(TOKEN(3) (1:LTOKEN(3)),9000) I2
      CALL ASCINT(LINE1, FIELD, I2)
      IF (COUNT.GT.4) THEN
          DO 30 I = 5,COUNT
              CC     = TOKEN(I) (1:1)
              IF (CC.EQ.':' .OR. CC.EQ.'#') THEN
                  IF (CC.EQ.':') LABEL  = TOKEN(I) (2:LTOKEN(I))
              ELSE
                  IF (CC.EQ.'"') THEN
                      UNIT   = TOKEN(I) (2:LTOKEN(I)-1)
                  ELSE
                      FORM   = TOKEN(I)
                  END IF
              END IF
   30     CONTINUE
      END IF
      C      = TOKEN(4)
      DO 40 I = 1,9
          IF (INDEX(LABEL,SYMILL(I)).NE.0) THEN
              LINE1 = ' '
              LINE1 = ' Wrong label '//LABEL
              CALL STTPUT(LINE1,IST)
              STATUS = ERRPAR
          END IF
   40 CONTINUE
      RETURN
C100 FORMAT(I<FIELD>)
C 9000 FORMAT (I4)
      END

      SUBROUTINE ASCINT(A, N, I)
C
C      CONVERT ASCII STRING IN TO INTEGER
C
      IMPLICIT NONE
      CHARACTER*(*) A
      INTEGER       N
      INTEGER       I
C
      CHARACTER*1   T
      INTEGER       J, K
C
      I = 0
      DO 10 J = 1, N
        T = A(J:J)
        IF (T.GE.'0' .AND. T.LE.'9') THEN
          READ(T,100) K
          I = I*10 +  K
        ELSE
          RETURN
        ENDIF
10    CONTINUE
      RETURN
100   FORMAT(I1)
      END           

C @(#)clussbr.for	19.1 (ES0-DMD) 02/25/03 13:27:13
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION:
C      CLUS VERSION 1                 85.01.21
C      F. MURTAGH     ST-ECF, MUNICH
C
C.KEYWORDS:
C      APPLICATIONS, STATISTICS, CLUSTERING.
C
C.PURPOSE:
C      HIERARCHICAL CLUSTERING USING MINIMUM VARIANCE CRITERION.
C      N * M ARRAY PASSED TO PROGRAM IN "DATA",
C      SEQUENCE OF N-1 AGGLOMERATIONS OF ROW POINTS RETURNED IN
C      VECTORS "IA" AND "IB", WITH CRITERION VALUES IN "CRIT".
C
C.ALGORITHM:
C      NEAREST NEIGHBOUR CHAIN ALGORITHM IS USED (SEE BIBLIOGRA-
C      PHIC REFERENCES IN DOCUMENTATION), WHICH ALLOWS HIERARCHY
C      TO BE CONSTRUCTED WITHOUT THE NEED FOR A DISSIMILARITY
C      MATRIX.
C
C.INPUT/OUTPUT:
C      PARAMETERS:
C      N, M, DATA : DIMENSION OF, AND ARRAY, OF REALS;
C      IA, IB, CRIT : SEQ. OF AGGLOMERANDS & CRITERION VALUES,
C                     RETURNED (ONLY LOCNS 1 TO N-1 OF INTEREST);
C      MEMBR : CARDINALITIES OF CLASSES;
C      DISS  : NEAREST NEIGHBOUR DISSIMILARITIES;
C      ICHAIN: NEAREST NEIGHBOUR CHAIN;
C      FLAG  : INDICATES AGGLOMERABLE OBJECTS/CLUSTERS.
C      *** NOTE *** THAT STORAGE IS OVERLAID AS INDICATED BY
C                   COMMENTED EQUIVALENCE STATEMENT.
C                   ALSO NOTE THAT IJKLMN VARIABLE DEFINITION
C                   CONVENTION IS FOLLOWED.
C
C---------------------------------------------------------------
C
      SUBROUTINE CLUS(N,M,DATA,IA,IB,CRIT,
     X      MEMBR,DISS,ICHAIN,FLAG)
      REAL MEMBR(N),DATA(N,M),DISS(N),CRIT(N),D
      INTEGER ICHAIN(N),IA(N),IB(N),N,M,I,LEN,IDUM,I1,I2,NCL
      REAL INF
      LOGICAL FLAG(N)
      DATA INF/1.E+25/
C     EQUIVALENCE (ICHAIN(1),IA(1)),(DISS(1),CRIT(1))
C
C
      DO 150 I=1,N
      MEMBR(I)=1
      FLAG(I)=.TRUE.
  150 CONTINUE
      NCL=N
      I1=1
C
C-----START THE NN-CHAIN:--------------------------------------------
  200 LEN=N
      ICHAIN(LEN)=I1
      DISS(LEN)=INF
C-----DET. NN OF OBJECT I1:------------------------------------------
  300 FLAG(I1)=.FALSE.
C-----(TURN OFF FLAG SO THAT ZERO DISS. OF I1 WITH SELF NOT OBTAINED.)
      D=DISS(LEN)
      IF (LEN.LT.N) I2=ICHAIN(LEN+1)
C-----(FOR IDENTICAL DISS'S, ABOVE ENSURES THAT RNN WILL BE FOUND.)
      CALL DETNN(DATA,FLAG,MEMBR,N,M,I1,I2,D)
      FLAG(I1)=.TRUE.
C-----IF LEN=1 PLACE OBJ. I2 AS SECOND OBJ. IN NN-CHAIN:--------------
      IF (LEN.LT.N) GOTO 350
      LEN=LEN-1
      IF (LEN.LT.N-NCL) GOTO 700
      ICHAIN(LEN)=I2
      DISS(LEN)=D
      GOTO 500
C-----IF LEN<N DISTINGUISH BETWEEN HAVING RNN & CONTINUING NN-CHAIN:--
  350 CONTINUE
      IF (I2.NE.ICHAIN(LEN+1)) GOTO 400
C-----(HAVE RNN.)-----------------------------------------------------
      NCL=NCL-1
      CALL AGGLOM(I1,I2,D,DATA,MEMBR,FLAG,IA,IB,CRIT,NCL,N,M)
      LEN=LEN+2
      GOTO 500
  400 CONTINUE
C-----(GROW EXTRA LINK ON NN-CHAIN.)
      IDUM=ICHAIN(LEN+1)
      FLAG(IDUM)=.FALSE.
      LEN=LEN-1
      IF (LEN.LE.N-NCL) GOTO 700
      ICHAIN(LEN)=I2
      DISS(LEN)=D
      GOTO 500
C-----SELECT OBJ. FOR CONTINUING TO GROW (OR RESTARTING) NN-CHAIN.-----
  500 CONTINUE
      IF (NCL.EQ.1) GOTO 600
      IF (LEN.EQ.N+1) GOTO 550
      I1=ICHAIN(LEN)
      FLAG(I1)=.TRUE.
      IDUM=ICHAIN(LEN+1)
      IF (LEN.LT.N) FLAG(IDUM)=.TRUE.
C-----(REESTABLISH AGGLOMERABILITY OF OBJ.'S IN NN-CHAIN.)-------------
      GOTO 300
  550 CALL NEXT(FLAG,I1,N)
      GOTO 200
C
C
  600 CONTINUE
C     CALL OUTP(IA,IB,CRIT,N,M,DATA,dismax)
      RETURN
  700 WRITE(6,750)
  750 FORMAT(' ERROR IN NN-CHAIN ROUTINE - INSUFFICIENT CHAIN SPACE'/)
      STOP
      END
C
C
C
C
C
C-----------------------------------------------------------------------
C
C
C
C
C
      SUBROUTINE DETNN(DATA,FLAG,MEM,N,M,I1,I2,D)
C-----DETERMINE A NEAREST NEIGHBOUR; CALLED FROM SUBR. "CLUS".
      INTEGER N,M,I,J,I1,I2
      REAL DATA(N,M),MEM(N),D,DISS
      LOGICAL FLAG(N)
C
      DO 200 I=1,N
      IF (.NOT.FLAG(I)) GOTO 200
      DISS=0.
      DO 100 J=1,M
  100 DISS=DISS+(DATA(I1,J)-DATA(I,J))*(DATA(I1,J)-DATA(I,J))
      DISS=DISS*MEM(I)*MEM(I1)/(MEM(I1)+MEM(I))
      IF (DISS.GE.D) GOTO 200
            D=DISS
            I2=I
  200 CONTINUE
C
      RETURN
      END
C
C
C
C
C
C-----------------------------------------------------------------------
C
C
C
C
C
      SUBROUTINE AGGLOM(I1,I2,D,DATA,MEM,FLAG,IA,IB,CRIT,NCL,N,M)
C-----CARRY OUT AN AGGLOMERATION; CALLED FROM SUBR. "CLUS".
      REAL MEM(N),DATA(N,M),CRIT(N),D
      INTEGER IA(N),IB(N),N,M,NCL,I1,I2,I,J,NAGGL
      LOGICAL FLAG(N)
      INTEGER O1,O2,LB,UB,J1
C
C
      O1=MIN0(I1,I2)
      O2=MAX0(I1,I2)
      DO 100 J=1,M
      DATA(O1,J)=( MEM(O1)*DATA(O1,J)+MEM(O2)*DATA(O2,J) )
     X            / (MEM(O1)+MEM(O2))
      DATA(O2,J)=DATA(O1,J)
  100 CONTINUE
      NAGGL=N-NCL
      MEM(O1)=MEM(O1)+MEM(O2)
      FLAG(O2)=.FALSE.
C-----KEEP SORTED LIST OF CRIT. VALUES: FIND 1ST WHERE NEW CRIT. FITS:
      I=NAGGL-1
  120 IF (D.GE.CRIT(I)) GOTO 140
      I=I-1
      IF (I.GE.1) GOTO 120
C-----(ARRIVING HERE MUST MEAN THAT D > ALL CRIT. VALUES FOUND SO FAR:)
      I=0
  140 CONTINUE
C-----NOW, SHIFT RIGHTWARDS FROM I+1 TO AGGL-1 TO MAKE ROOM FOR NEW CRIT
      LB=I+1
      UB=NAGGL-1
      IF (LB.GT.UB) GOTO 180
      J=UB
  160 J1=J+1
      IA(J1)=IA(J)
      IB(J1)=IB(J)
      CRIT(J1)=CRIT(J)
      J=J-1
      IF (J.GE.LB) GOTO 160
  180 CONTINUE
      IA(LB)=O1
      IB(LB)=O2
      CRIT(LB)=D
C
C
      RETURN
      END
C
C
C
C
C
C-----------------------------------------------------------------------
C
C
C
C
C
      SUBROUTINE NEXT(FLAG,I1,N)
C-----DETERMINE NEXT AGGLOMERABLE OBJECT/CLUSTER; CALLED FROM "CLUS".
      INTEGER N,I1,NXT,I
      LOGICAL FLAG(N)
C
C
      NXT=I1+1
      IF (NXT.GT.N) GOTO 150
      DO 100 I=NXT,N
      IF (FLAG(I)) GOTO 500
  100 CONTINUE
  150 DO 200 I=1,I1
      IF (FLAG(I)) GOTO 500
  200 CONTINUE
C
C
      STOP
C
C
  500 I1=I
C
C
      RETURN
      END
C
C
C
C
C
C-----------------------------------------------------------------------
C
C
C
C
C
      SUBROUTINE OUTP(IA,IB,CRIT,N,M,DATA)
C-----OUTPUT DATA: THIS ROUTINE IS CURRENTLY DEAD.
      INTEGER N,M,IA(N),IB(N),NMIN1,JJJ,K
      REAL CRIT(N),DATA(N,M)
C
C
      NMIN1=N-1
      DO 100 JJJ=1,NMIN1
      WRITE(6,50) JJJ,IA(JJJ),IB(JJJ),CRIT(JJJ)
   50 FORMAT(1H ,I6,I6,I6,F15.4)
  100 CONTINUE
C
C
      WRITE(6,70)
   70 FORMAT(////,' CLUSTER CENTRE COORDINATES FOLLOW.',///)
      DO 300 JJJ=1,N
      WRITE(6,80) JJJ,(DATA(JJJ,K),K=1,M)
   80 FORMAT(I4,13F6.3)
  300 CONTINUE
C
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2008 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  21:13 - 3 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR : M Peron, S. Wolf
C
C.IDENTIFICATION
C  program  NECOPT (old ECHOPT)  version 1.0 910120 
C
C.KEYWORDS
C
C  ECHELLE, CASPEC, DATA EXTRACTION
C
C.PURPOSE
C 
C Extract orders from an echelle spectrum, the order position is defined by 
C the coefficients of a regression. The slit width and the orders to be 
C extracted are defined by the keyword INPUTI
C The flux is calculated by assigning to each pixel a weighting factor 
C proportional to the amount of signal in it.
C 
C.ALGORITHM
C The algorithm is based on a paper of Koji Mukai ( 1990, Optimal Extraction of
C Cross-Dispersed Spectra, Pub. of Astr.Soc. of the Pacific,102:183-189)
C AND a paper of Keith Horne:
C (1986, Pub. of Astr.Soc. of the Pacific, 98:609-617)
C
C.SYNTAX
C   EXTRACT/ORDER input output  width,ord1,ord2 ron,g,sigma table coeffs
C
C  the connection file contains
C  IN_A      input FRM (has to be de-biased BEFORE)
C  OUTPUTC   variance image of input data (same dimension as input frame)
C  OUT_A     output FRM
C  OUT_B     weight map FRM
C  IN_B      table with positions of the orders
C  INPUTC    coeffs
C  INPUTI    slit,ord1,ord2, weight_determination_flag
C  INPUTR    ron,g,sigma (ron: readout-noise, g: inverse gain,
C                         sigma: threshold for cosmic ray rejection)
C
C.HISTORY:
C  1999.04.08-SW save weight map, make use of variances,
C                iterative cosmic ray rejection (negative sigma switches off)
C                calculates the variance of the extracted spectrum
C  1999.09.08-SW the variance of the extracted spectrum is calculated in
C                  any case of INPUTI(4).
C                bug fix: the variance has to be devided by the squared
C                  number of extracted lines (represented usually by the
C                  keyword SLIT) in order to be consistent with the
C                  extracted orders which are averaged data! The number of
C                  lines is specified by INPUTI(1).
C  1999.10.28-SW Do a gaussian fit to the profils (CALCPROFI(),
C                  G_PROF()).
C                Save the cosmic ray detections in a table if EXTSIGMA>0
C  1999.11.09-SW Prevent division by zero in CALCULx() and CALC_x().
C  1999.11.11-SW Profile normalization removed in VSAMPLE() so that the
C                variances may be easily derived for the cosmic ray
C                rejection.
C
C 
C 081030	last modif
C 
C***************************************************************************
C 
      PROGRAM NECOPT
C 
      IMPLICIT NONE
C 
      INTEGER NDIM
      PARAMETER (NDIM=2)
C 
      INTEGER MADRID, NAC, NAR, IMNO,SCAN(2),BINSIZE
      INTEGER I,IAV,INDX,IORD,IORD1,IORD2
      INTEGER ICOL1,ICOL2
      INTEGER ISTAT,NA,NAXISA,NAXISB,NAXISC
      INTEGER NCOL,NPAR,NROW,NSORT,NCR
      INTEGER TID,MTID,INO,INVO
      INTEGER NPIXA(3),NPIXB(3),NPIXC(3)
      INTEGER IPAR(10),KUN,KNUL
      INTEGER IKIND,IWIDTH,DIMP
      INTEGER NWY,NWXY,WID,VID,DETWGT
C 
      INTEGER*8 PNTRA,PNTRB,PNTRC,PNTRV,PNTVO             !pointers ...
C
      REAL  RPAR(10),WIDTH
      REAL  PARAMS(12),OFFSET
C
      DOUBLE PRECISION STEPA(3),STEPB(3),STARTA(3),STARTB(3)
      DOUBLE PRECISION DPAR(40)
C
      CHARACTER*72 IDENA,IDENB,LINE
      CHARACTER*64 CUNITA,CUNITB,DESNAM
      CHARACTER*60 FRMIN,FRMOUT,FRMVOUT,FRMWGT,FRMVAR
      CHARACTER*60 INA1,INA2,INA3,INA4,TABLE
      CHARACTER*8  FNAME,FTYPE
C
      COMMON /CRMASK/MTID,NCR
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      DATA CUNITB/
     +     'FLUX            PIXEL                           ORDER'/
C
C  initialize system
C
      CALL STSPRO('ECHOPT')
      CALL STKRDC('IN_A',1,1,60,I,INA1,KUN,KNUL,ISTAT)
      CALL STKRDC('IN_B',1,1,60,I,TABLE,KUN,KNUL,ISTAT)
      CALL STKRDC('OUT_A',1,1,60,I,INA2,KUN,KNUL,ISTAT)
      CALL STKRDC('OUT_B',1,1,60,I,INA3,KUN,KNUL,ISTAT)
      CALL STKRDC('OUTPUTC',1,1,60,I,INA4,KUN,KNUL,ISTAT)
      CALL STKRDC('INPUTC',1,1,8,I,FNAME,KUN,KNUL,ISTAT)
      CALL STKRDR('INPUTR',1,3,I,RPAR,KUN,KNUL,ISTAT)
      CALL STKRDI('INPUTI',1,4,I,IPAR,KUN,KNUL,ISTAT)
      CALL STKRDI('SCAN',1,2,I,SCAN,KUN,KNUL,ISTAT)
      CALL STKRDR('OFFSET',1,1,I,OFFSET,KUN,KNUL,ISTAT)
      BINSIZE =  10             !binsize for virtual resampling VSAMPLE().
      IORD1  = IPAR(2)
      IORD2  = IPAR(3)
      DETWGT = IPAR(4)           !1: determine 0: use weight map
      CALL CLNFRA(INA1,FRMIN,0)  !input frame (pixel-pixel-space)
      CALL CLNFRA(INA2,FRMOUT,0) !output frame (extracted orders)
      CALL CLNFRA(INA3,FRMWGT,0) !weight map (pixel-full_order-space)
      CALL CLNFRA(INA4,FRMVAR,0) !variance frame (pixel-pixel-space)
      CALL CLNTAB(TABLE,TABLE,0) !order table (order positions)
C
C  input parameters in table
C
      CALL TBTOPN(TABLE,F_U_MODE,TID,ISTAT)
      CALL TBIGET(TID,NCOL,NROW,NSORT,NAC,NAR,ISTAT)
C
C
C  map variance frame
C
      CALL STIGET(FRMVAR,D_R4_FORMAT,F_IO_MODE,F_IMA_TYPE,
     .     NDIM,NAXISA,NPIXA,STARTA,STEPA,IDENA,
     +     CUNITA,PNTRV,VID,ISTAT)
C
C  map input FRM
C
      CALL STIGET(FRMIN,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     .            NDIM,NAXISA,NPIXA,STARTA,STEPA,IDENA,
     +            CUNITA,PNTRA,IMNO,ISTAT)

      PARAMS(1) = IPAR(1)       !slitwidth (in spatial direction)
      PARAMS(2) = RPAR(3)       !threshold factor for CR-rejection
      PARAMS(3) = RPAR(2)       !invers gain factor [e-/ADU]
      PARAMS(4) = RPAR(1)       !readout-noise [e-]
C
C  read coeffs
C
      INDX   = INDEX(FNAME//' ',' ') - 1
      DESNAM = FNAME(1:INDX)//'C'
      CALL STDRDC(TID,DESNAM,1,17,4,IAV,FTYPE,KUN,KNUL,ISTAT)
      FTYPE   = 'MULT'
      IF (FTYPE.EQ.'MULT') THEN
          DESNAM = FNAME(1:INDX)//'I'
          CALL STDRDI(TID,DESNAM,4,4,IAV,IPAR,KUN,KNUL,ISTAT)
          NA     = (IPAR(3)+1)* (IPAR(4)+1)
          DESNAM = FNAME(1:INDX)//'R'
          CALL STDRDR(TID,DESNAM,1,4,IAV,PARAMS(5),KUN,KNUL,ISTAT)
          DESNAM = FNAME(1:INDX)//'D'
          CALL STDRDD(TID,DESNAM,1,NA,IAV,DPAR,KUN,KNUL,ISTAT)
C
C ... map output FRM
C
          IF (IORD1.EQ.IORD2 .AND. IORD1.EQ.0) THEN
              IORD1  = PARAMS(7)
              IORD2  = PARAMS(8)
          END IF
          STARTB(1) = STARTA(1)
          STARTB(2) = IORD1
          STEPB(1)  = STEPA(1)
          STEPB(2)  = 1.
          IDENB     = IDENA
          NAXISB    = 2
          NPIXB(1)  = NPIXA(1)
          NPIXB(2)  = IORD2 - IORD1 + 1
          FRMVOUT = 'var_'//FRMOUT
          I = MAX(INDEX(FRMVOUT,' ')-1,1)
          CALL STIPUT(FRMOUT,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +         NAXISB,NPIXB,STARTB,STEPB,IDENB,CUNITB,PNTRB,INO,ISTAT)
          WRITE(LINE,9099) FRMOUT(1:I)
9099  FORMAT('OUTPUT:',A,' extracted spectrum')

          CALL STTPUT(LINE,ISTAT)
c
c ... variance of extracted orders
c
          IDENB = 'variance'
          CALL STIPUT(FRMVOUT,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +         NAXISB,NPIXB,STARTB,STEPB,IDENB,CUNITB,PNTVO,INVO,ISTAT)
          WRITE(LINE,9098) FRMVOUT(1:I)
9098  FORMAT('       ',A,' variance of extr. spectrum')
          CALL STTPUT(LINE,ISTAT)
C
C  ... map weight FRM
C
          WIDTH  = PARAMS(1)
          IWIDTH = WIDTH
          IF (MOD(IWIDTH,2).EQ.0)THEN
             IKIND=1            !even slit width
             DIMP = IWIDTH+1    !dimension of the weight profil
          ELSE
             IKIND=0            !odd slit width
             DIMP = IWIDTH+2    !dimension of the weight profil
          ENDIF
          NWY  = DIMP*(IORD2 - IORD1 + 1)
          NWXY = NPIXA(1)*NWY
          STARTB(1) = STARTA(1)
          STARTB(2) = 1.
          STEPB(1)  = STEPA(1)
          STEPB(2)  = 1.
          IDENB     = 'weight map'
          NAXISC    = 2
          NPIXC(1)  = NPIXA(1)
          NPIXC(2)  = NWY

          IF (DETWGT .EQ. 1) THEN
             CALL STIPUT(FRMWGT,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +            NAXISC,NPIXC,STARTB,STEPB,
     +            IDENB,CUNITB,PNTRC,WID,ISTAT)
C
C cosmic ray rejection ONLY if weights should be determined
C
             IF (PARAMS(2).LT.0) THEN
                CALL STTPUT('       NO cosmic ray rejection',ISTAT)
                MTID = -1
             ELSE
C  create CR-mask table
                FRMOUT = 'crm_'//FRMIN
                I = MAX(INDEX(FRMOUT,' ')-4,1)
                FRMOUT = FRMOUT(1:I)//'tbl'
                I = I + 3
                CALL TBTINI(FRMOUT,F_TRANS,F_O_MODE,2,100,MTID
     $               ,ISTAT)
                CALL TBCINI(MTID,D_I4_FORMAT,1,'I','PIXEL',':X',ICOL1
     $               ,ISTAT)
                CALL TBCINI(MTID,D_I4_FORMAT,1,'I','PIXEL',':Y',ICOL2
     $               ,ISTAT)
                NCR = 0
                WRITE(LINE,9097) PARAMS(2) 
9097  FORMAT('       Cosmic ray rejection (>',F12.5,'*sigma)')
                CALL STTPUT(LINE,ISTAT)
                WRITE(LINE,9096) FRMOUT(1:I)
9096  FORMAT('         save detections on: ',A)
                CALL STTPUT(LINE,ISTAT)
      
             ENDIF
             CALL DSCUPT(IMNO,WID,' ',ISTAT)

          ELSE
             CALL STIGET(FRMWGT,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     .            NDIM,NAXISC,NPIXC,STARTB,STEPB,IDENB,
     +            CUNITB,PNTRC,WID,ISTAT)
          ENDIF
          I = MAX(1,INDEX(FRMWGT,' ')-1)
          WRITE(LINE,9095) FRMWGT(1:I)
9095  FORMAT('       ',A,' weight map')
          CALL STTPUT(LINE,ISTAT)
          I = MAX(1,INDEX(TABLE,' ')-1)
          WRITE(LINE,9094) TABLE(1:I)
9094  FORMAT('       ',A,' order table')
          CALL STTPUT(LINE,ISTAT)
          WRITE(LINE,9093) OFFSET
9093  FORMAT('       OFFSET to order positions:',F12.5)
          CALL STTPUT(LINE,ISTAT)
          WRITE(LINE,9092) BINSIZE
9092  FORMAT('       BINSIZE of virtually resampled data:', I2)
          CALL STTPUT(LINE,ISTAT)
          WRITE(LINE,9091) PARAMS(4),PARAMS(3)
9091  FORMAT('       RON=',F12.5,' [e], GAIN=',F12.5,' [e/ADU]')
          CALL STTPUT(LINE,ISTAT)
C
C  extract order
C
          NPAR       = 11
          PARAMS(9)  = IPAR(3)
          PARAMS(10) = IPAR(4)
          IF (SCAN(1).EQ.0) THEN
             SCAN(1) = 1
             SCAN(2) = NPIXA(2)
          ENDIF

          DO 10 I = IORD1,IORD2
              WRITE(LINE,9090) I
9090  FORMAT('Order number : ',I4)
              CALL STTPUT(LINE,ISTAT)
              PARAMS(11) = I
              IORD       = I - IORD1 + 1
              IF (DETWGT .EQ. 1) THEN
c do an optimal extraction, save weights and variances on disk.
                 CALL EXTRACT(MADRID(PNTRA),MADRID(PNTRV),NPIXA(1)
     $                ,NPIXA(2),MADRID(PNTRB),MADRID(PNTVO),NPIXB(1)
     $                ,NPIXB(2),MADRID(PNTRC),NPIXC(1),NPIXC(2),IORD
     $                ,NPAR,PARAMS,NA,DPAR,SCAN,OFFSET,BINSIZE,STARTA
     $                ,STEPA,IKIND,IWIDTH,DIMP)
              ELSE
c do an immediate extraction using the weights of a previous optimal extract.
                 CALL EXTRACT_I(MADRID(PNTRA),MADRID(PNTRV),NPIXA(1)
     $                ,NPIXA(2),MADRID(PNTRB),MADRID(PNTVO),NPIXB(1)
     $                ,NPIXB(2),MADRID(PNTRC),NPIXC(1),NPIXC(2),IORD
     $                ,NPAR,PARAMS,NA,DPAR,SCAN,OFFSET,STARTA,STEPA
     $                ,IKIND,IWIDTH,DIMP)
              ENDIF

C
10        CONTINUE
      ELSE
          CALL STTPUT('Error in Dispersion coefficients',ISTAT)
          GOTO 20
      ENDIF

      IF (MTID.GT.0) CALL TBTCLO(MTID,ISTAT) !close CR-mask table

      CALL DSCUPT(IMNO,INO,' ',ISTAT)
C
C  free data
C
   20 CALL STSEPI

      END

      
      SUBROUTINE EXTRACT(RIN,VARI,NPIXA1,NPIXA2,ROUT,VOUT,NB1,NB2,WGT
     $     ,NC1,NC2,INDX,NPAR,PAR,ND,DPAR,SCAN,OFFSET,BINSIZE,STARTA
     $     ,STEPA,IKIND,IWIDTH,DIMP)
C
C
C   ARGUMENTS
C RIN    REAL*4  INPUT IMAGE
C VARI   REAL*4  VARIANCE IMAGE
C NPIXA1 INTG*4  NO. OF SAMPLES
C NPIXA2 INTG*4  NO. OF LINES
C ROUT   REAL*4  EXTRACTED ORDERS
C VOUT   REAL*4  VARIANCE OF EXTRACTED ORDERS
C NB1    INTG*4  NO. OF SAMPLES
C NB2    INTG*4  NO. OF ORDERS
C WGT    REAL*4  WEIGHT MAP
C NC1    INTG*4  NO. OF SAMPLES
C NC2    INTG*4  NO. OF ORDERS * THICKNESS OF ORDERS (profil dimension)
C INDX   INTG*4  SEQUENTIAL NO. OF THE ORDER
C NPAR   INTG*4  NO. OF EXTRACTION PARAMETERS
C PAR    REAL*4  EXTRACTION PARAMETERS
C ND     INTG*4  NO. OF COEFFS.
C DPAR   REAL*8  COEFFS. TO DEFINE ORDER POSITION
C XMIN   REAL*4  MINIMUM VALUE
C XMAX   REAL*4  MAXIMUMVALUE
C IKIND  INTG*4  EVEN/ODD FLAG: 1: EVEN, 0: ODD SLIT WIDTH SIZE
C IWIDTH INTG*4  SLIT WIDTH  (size perpendicular to dispersion in pixel)
C DIMP   INTG*4  DIMENSION OF THE PROFILE OF THE ORDERS
C
      IMPLICIT NONE
C 
      INTEGER  NPIXA1, NPIXA2, NB1, NB2, NC1, NC2, NPAR, ND     
      INTEGER  IKIND, IWIDTH, DIMP
      INTEGER  NWW, IYLIM, NX, N1, N2, K, L, IX, INDX
      INTEGER  NBY1,ISTAT,MADRID,DIM
      INTEGER  NBY2,BINSIZE,IAC,NBY4
      INTEGER  FID1,FID2,FID3,FID4,FID5,FID6
      INTEGER  IR(2),SCAN(2),IXMIN,IXMAX
      INTEGER  IXWIND,IOFF
C 
      INTEGER*8  PT1,PT2,PT3,PT4,PT5,PT6                  !pointers
C 
      REAL WGT(NC1,NC2)
      REAL ROUT(NB1,NB2),VOUT(NB1,NB2)
      REAL RIN(NPIXA1,NPIXA2), VARI(NPIXA1,NPIXA2)
      REAL PAR(NPAR)
      REAL RON, CONAD, THRESH
      REAL XMIN,XMAX,OFFSET
C 
      DOUBLE PRECISION DPAR(ND),START(2),STEP(2)
      DOUBLE PRECISION WIDTH,HWIDTH
      DOUBLE PRECISION YV
      DOUBLE PRECISION SKWDX,SKWDY,SKWOF
      DOUBLE PRECISION DEGREE, STARTA(2), STEPA(2)
      CHARACTER*64    CUNIT

      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
      DATA DEGREE/0.017453292519943295769237D+0/
      DATA CUNIT/
     +     'INTENSITY       PIXEL                           ORDER'/
C

      NWW    = 50
C
C ... define extraction constants
C
      WIDTH  = IWIDTH
      HWIDTH = 0.5*WIDTH
      SKWDX  = 0.0
      SKWDY  = 1.0
      SKWOF  = 0.0
      XMIN   = 0.0
      XMAX   = XMIN
      IYLIM  = NPIXA2 - IWIDTH
      NX     = SKWOF
      N1     = NX
      N2     = NPIXA1 - NX
C
C ... get RON and CONAD
C
      THRESH = PAR(2)           !cosmic ray rejection threshold
      CONAD  = PAR(3)           !inverse GAIN: CONAD [e-/ADU]
      RON    = PAR(4)           !readout-noise [e-]
      RON    = (RON / CONAD)**2 !-> converted to ADU^2 (variance!)

C
C ... get ordinate values
C
      K      = PAR(9)           !Dimension of the coefficient
      L      = PAR(10)          !matrix to get order pos.
      YV     = PAR(11)          !Current order
C
C ... get offset within weight buffer for corresponding order
C
      IOFF   = (INDX - 1) * DIMP + 1
C
C ... loop over the samples
C
      NBY1 = NPIXA1
      CALL STFCRE('vdummx',D_R8_FORMAT,F_X_MODE,1,NBY1,FID1,ISTAT)
      CALL STFMAP(FID1,F_X_MODE,1,NBY1,IAC,PT1,ISTAT) 
      CALL CENT(MADRID(PT1),NPIXA1,DPAR,ND,K,L,YV,IWIDTH,SCAN,OFFSET,
     1          IXMIN,IXMAX,STARTA,STEPA)
      DIM = ((IWIDTH/2)*2+2)*BINSIZE+1
      START(1) = 0
      START(2) = 0
      STEP(1) = 1.
      STEP(2) = 1./BINSIZE 
      IR(1) = NPIXA1
      IR(2) = DIM
      NBY2  = NPIXA1 * DIM
      CALL STFCRE('vdummy',D_R4_FORMAT,F_X_MODE,1,NBY2,FID2,ISTAT)
      CALL STFMAP(FID2,F_X_MODE,1,NBY2,IAC,PT2,ISTAT)

      CALL STFCRE('mask',D_I2_FORMAT,F_X_MODE,1,NBY2,FID3,ISTAT)
      CALL STFMAP(FID3,F_X_MODE,1,NBY2,IAC,PT3,ISTAT)

      IR(2) = 4                 !parameter buffer
      NBY4 = IR(1) * IR(2)      !size of the buffer
      CALL STFCRE('pdummy',D_R4_FORMAT,F_X_MODE,1,NBY4,FID4,ISTAT)
      CALL STFMAP(FID4,F_X_MODE,1,NBY4,IAC,PT4,ISTAT)

      IR(1) = DIM
      IR(2) = 1                 !parameter buffer
      NBY4 = IR(1) * IR(2)      !size of the buffer
      CALL STFCRE('colum',D_R4_FORMAT,F_X_MODE,1,NBY4,FID5,ISTAT)
      CALL STFMAP(FID5,F_X_MODE,1,NBY4,IAC,PT5,ISTAT)
      CALL STFCRE('sigma',D_R4_FORMAT,F_X_MODE,1,NBY4,FID6,ISTAT)
      CALL STFMAP(FID6,F_X_MODE,1,NBY4,IAC,PT6,ISTAT)


      DO IX=1,NPIXA1
         ROUT(IX,INDX) = 0
      ENDDO
      CALL VSAMPLE(RIN,WGT(1,IOFF),MADRID(PT1),MADRID(PT2),
     +     MADRID(PT3),DIMP,IWIDTH,BINSIZE,NPIXA1,IXMIN,
     +     IXMAX,NPIXA2,DIM,IKIND)
      IXWIND = 15               !window size of the order chunks
      CALL CALCPROFI(MADRID(PT2),MADRID(PT3),MADRID(PT4),MADRID(PT5)
     +     ,MADRID(PT6),NPIXA1,IXWIND,IXMIN,IXMAX,DIM,4,RON,CONAD,THRESH
     +     ,BINSIZE,WIDTH)
      IF (IKIND.EQ.0) THEN
         CALL CALCULI(RIN,VARI,WGT(1,IOFF),MADRID(PT1),MADRID(PT2)
     +        ,MADRID(PT3),ROUT,VOUT,DIMP,IWIDTH,BINSIZE,NPIXA1,IXMIN
     +        ,IXMAX,NPIXA2,DIM,NB1,NB2,INDX,PAR,NPAR)
      ELSE
         CALL CALCULP(RIN,VARI,WGT(1,IOFF),MADRID(PT1),MADRID(PT2),
     +        MADRID(PT3),ROUT,
     +        VOUT,DIMP,IWIDTH,BINSIZE,NPIXA1,IXMIN,IXMAX,NPIXA2,DIM,
     +        NB1,NB2,INDX,PAR,NPAR)
C
      ENDIF
      CALL STFCLO(FID1,ISTAT)
      CALL STFCLO(FID2,ISTAT) 
      CALL STFCLO(FID3,ISTAT)
      CALL STFCLO(FID4,ISTAT)
      CALL STFCLO(FID5,ISTAT)
      CALL STFCLO(FID6,ISTAT)
      RETURN
C 
      END

      SUBROUTINE EXTRACT_I(RIN,VARI,NPIXA1,NPIXA2
     +     ,ROUT,VOUT,NB1,NB2,WGT,NC1,NC2,INDX,NPAR,PAR
     +     ,ND,DPAR,SCAN,OFFSET,STARTA,STEPA,IKIND,IWIDTH,DIMP)
C
C  Do an immediate extract using the weights of a previous optimal extraction
C
C   ARGUMENTS
C RIN    REAL*4  INPUT IMAGE
C VARI   REAL*4  VARIANCE IMAGE
C NPIXA1 INTG*4  NO. OF SAMPLES
C NPIXA2 INTG*4  NO. OF LINES
C ROUT   REAL*4  EXTRACTED ORDERS
C VOUT   REAL*4  VARIANCE OF EXTRACTED ORDERS
C NB1    INTG*4  NO. OF SAMPLES
C NB2    INTG*4  NO. OF ORDERS
C WGT    REAL*4  WEIGHT MAP
C NC1    INTG*4  NO. OF SAMPLES
C NC2    INTG*4  NO. OF ORDERS * THICKNESS OF ORDERS (profil dimension)
C INDX   INTG*4  SEQUENTIAL NO. OF THE ORDER
C NPAR   INTG*4  NO. OF EXTRACTION PARAMETERS
C PAR    REAL*4  EXTRACTION PARAMETERS
C ND     INTG*4  NO. OF COEFFS.
C DPAR   REAL*8  COEFFS. TO DEFINE ORDER POSITION
C IKIND  INTG*4  EVEN/ODD FLAG: 1: EVEN, 0: ODD SLIT WIDTH SIZE
C IWIDTH INTG*4  SLIT WIDTH  (size perpendicular to dispersion in pixel)
C DIMP   INTG*4  DIMENSION OF THE PROFILE OF THE ORDERS
C
      IMPLICIT NONE
C 
      INTEGER  NPIXA1, NPIXA2, NB1, NB2, NC1, NC2, NPAR, ND
      INTEGER  IKIND, IWIDTH, DIMP
      INTEGER  NWW, K, L, IX, INDX
      INTEGER  NBY1,ISTAT,MADRID
      INTEGER  IAC,FID1
      INTEGER  SCAN(2),IXMIN,IXMAX,IOFF
C 
      INTEGER*8 PT1
C 
      REAL WGT(NC1,NC2)
      REAL ROUT(NB1,NB2),VOUT(NB1,NB2)
      REAL RIN(NPIXA1,NPIXA2), VARI(NPIXA1,NPIXA2)
      REAL PAR(NPAR)
      REAL OFFSET
C 
      DOUBLE PRECISION DPAR(ND)
      DOUBLE PRECISION YV
      DOUBLE PRECISION DEGREE, STARTA(2), STEPA(2)
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
      DATA DEGREE/0.017453292519943295769237D+0/
C
      NWW    = 50
C
C ... get ordinate values
C
      K      = PAR(9)           !Dimension of the coefficient
      L      = PAR(10)          !matrix to get order pos.
      YV     = PAR(11)          !Current order
C
C ... get offset within weight buffer for corresponding order
C
      IOFF   = (INDX - 1) * DIMP + 1
C
C ... loop over the samples
C
      NBY1 = NPIXA1
      CALL STFCRE('vdummx',D_R8_FORMAT,F_X_MODE,1,NBY1,FID1,ISTAT)
      CALL STFMAP(FID1,F_X_MODE,1,NBY1,IAC,PT1,ISTAT) 
c
c get the centers of the orders: stored in yval[] == madrid(pt1)
c
      CALL CENT(MADRID(PT1),NPIXA1,DPAR,ND,K,L,YV,IWIDTH,SCAN,OFFSET,
     1          IXMIN,IXMAX,STARTA,STEPA)

      DO IX=1,NPIXA1
         ROUT(IX,INDX) = 0
      ENDDO

      IF (IKIND.EQ.0) THEN
         CALL CALC_I(RIN,VARI,WGT(1,IOFF),MADRID(PT1),ROUT,VOUT
     $        ,NPIXA1,NPIXA2,NB1,NB2,DIMP,IXMIN,IXMAX,IWIDTH,INDX)
      ELSE
         CALL CALC_P(RIN,VARI,WGT(1,IOFF),MADRID(PT1),ROUT,VOUT
     $        ,NPIXA1,NPIXA2,NB1,NB2,DIMP,IXMIN,IXMAX,IWIDTH,INDX)
C
      ENDIF
C
      CALL STFCLO(FID1,ISTAT)
C 
      END

      SUBROUTINE CENT(YVAL,NPIXA1,DPAR,ND,K,L,YV,IWIDTH,
     +                SCAN,OFFSET,IXMIN,IXMAX,STARTA,STEPA)
C
C     Get the centres of the orders at each wavelength
C
      IMPLICIT NONE
C 
      INTEGER K,L,IX1,L1,K1,ND,NPIXA1,IWIDTH,IP,IXMIN,IXMAX
      INTEGER SCAN(2),ITEST 
C 
      DOUBLE PRECISION YVAL(NPIXA1),DPAR(ND),AX,XVAL,DC,YV
      DOUBLE PRECISION WW(50),STARTA(2), STEPA(2)
      DOUBLE PRECISION XI_R8R8, IX_R8R8
C 
      REAL OFFSET
C 
          AX = 1
          IXMIN = 1
          IXMAX = NPIXA1
          ITEST = 0
          DO 50, IX1 = 1,NPIXA1
              IP     = 0
              DC     = 1.D0
              YVAL(IX1)  = 0.D0
              XVAL   = IX_R8R8(AX, STARTA(1), STEPA(1))
              DO 30, L1 = 0,L
                  IP     = IP + 1
                  WW(IP) = DC
                  YVAL(IX1)  = YVAL(IX1)+ WW(IP)*DPAR(IP)
                  DO 20, K1 = 1,K
                      IP     = IP + 1
                      WW(IP) = WW(IP-1)*XVAL
                      YVAL(IX1)  = YVAL(IX1) + WW(IP)*DPAR(IP)
   20             CONTINUE
                  DC     = DC*YV
   30         CONTINUE
              YVAL(IX1) = XI_R8R8(YVAL(IX1),STARTA(2),STEPA(2)) + OFFSET
              AX = AX+1
          IF ( INT(YVAL(IX1)-IWIDTH/2-1).LE.SCAN(1)) THEN
              IXMIN = IX1
          ELSE IF ( INT(YVAL(IX1)+IWIDTH/2+2).GE.SCAN(2).AND.
     +         ITEST.EQ.0) THEN
              IXMAX = IX1
              ITEST = 1
          ENDIF
   50     CONTINUE
      RETURN
      END

      SUBROUTINE CALCPROFI(FBVAL,MASK,PBUF,COLUM,SIGMA,NPIXA1,IXWIND
     +     ,IXMIN,IXMAX,DIM,PDIM,RON,CONAD,THRESH,BINSIZE,WIDTH) 
C 
      IMPLICIT NONE
C 
      INTEGER NUM,I1,I2,K,JMAX
      INTEGER DIM,PDIM,I,J,NPIXA1
      INTEGER IXMIN,IXMAX,IXWIND,IXWMAX
      INTEGER BINSIZE,ISTAT,JWIN
      INTEGER LP(4), MFIT
C 
      INTEGER*2 MASK(NPIXA1,DIM),IMASK
C 
      REAL YMIN,YMAX
      REAL FBVAL(NPIXA1,DIM),PBUF(PDIM,NPIXA1)
      REAL RON,CONAD,THRESH
      REAL COLUM(DIM),SIGMA(DIM),PARAM(4),CHI2
      REAL AMIN1,LOW,HGH
C 
      DOUBLE PRECISION WIDTH
C 
      DATA LP/1,2,3,4/
      DATA MFIT/4/
c
c     Chop the order (FBVAL) into equaly spaced windows (IXWIND) in
c     wavelength space.
c     Do an averaging in the chunks to get averaged order profiles
c     Fit a gaussian to each of these averaged profiles.
c     Save the parameters of the gaussian in the first four rows
c     of FBVAL.
c     These parameters will finally be fitted in wavelength space,
c     this will be done by G_PROF().
c

      JMAX = 0
      IMASK = 1                 !mask: 1=valid pixel, 0:invalid

      LOW = BINSIZE*WIDTH/10.0  !these are empircal data !!!
      HGH = BINSIZE*WIDTH/3.0   !.. and should be replaced by measurements

      NUM = (IXMAX - IXMIN) / IXWIND
      I1 = IXMIN
      I2 = I1 + IXWIND - 1
      DO K=1,NUM
         YMIN = 1E33
         YMAX = -YMIN
         DO J = 1,DIM           !Do the averaging within one window
            COLUM(J) = 0.0
            DO I=I1,I2
               COLUM(J) = COLUM(J) + FBVAL(I,J)*MASK(I,J)
            ENDDO
            COLUM(J) = COLUM(J) / IXWIND
            SIGMA(J) = (RON + ABS(COLUM(J))/CONAD) / IXWIND / IXWIND
            YMIN = AMIN1(COLUM(J),YMIN)  !get the minimum
            IF (COLUM(J) .GT. YMAX) THEN !get maximum
               JMAX = J
               YMAX = COLUM(JMAX)
            ENDIF
         ENDDO
C
C     Determine the initial parameters for gaussfit
         JWIN = 2 * BINSIZE
         PARAM(4) = (YMAX - YMIN) * 0.01
         PARAM(1) = YMAX - PARAM(4)
         PARAM(2) = JMAX
         IF (JMAX.LT.JWIN .OR. DIM-JMAX.LT.JWIN) THEN
            IMASK = 0
            GOTO 90
         ENDIF
         PARAM(3) = DIM / 8.0
         I = 4
         CALL GAUSS_FIT(COLUM,SIGMA,DIM,PARAM,I,LP,MFIT,CHI2,ISTAT)
         IF (ISTAT.LT.0 .OR.
     +        PARAM(3).LT.LOW .OR. PARAM(3).GT.HGH) IMASK = 0
90       I = IXMIN+K-1
         PBUF(1,I) = 1.0
         DO J=2,4
            PBUF(J,I) = PARAM(J)
            MASK(I,J) = IMASK  !mask out if parameters are BAD
         ENDDO
         IMASK = 1
         I1 = I2 + 1
         I2 = I1 + IXWIND - 1
      ENDDO
c
c     Determine the gaussian profils at each wavelength. At the beginning
c     the gaussians have a zero background and an amplitude of 1.0.
c
      IXWMAX = IXMIN + (IXMAX - IXMIN) / IXWIND - 1
      CALL G_PROF(FBVAL,MASK,PBUF,COLUM,SIGMA,NPIXA1,IXWMAX,IXWIND,IXMIN
     +     ,IXMAX,DIM,PDIM,RON,CONAD,THRESH)
c
c     Now determine background and amplitude for fixed 
c     sigma and position of maximum
c
      RETURN
      END

      SUBROUTINE G_PROF(FBVAL,MASK,PBUF,COLUM,SIGMA,NPIXA1,IXWMAX,IXWIND
     +     ,IXMIN,IXMAX,DIM,PDIM,RON,CONAD,THRESH)
C 
      IMPLICIT NONE
C 
      INTEGER DIM,PDIM,I,J,POLORD,NPIXA1
      INTEGER IXWMAX,IXWIND,IXMIN,IXMAX
      INTEGER I1,NOUT,ITER,MXITER
C 
      INTEGER*2 MASK(NPIXA1,DIM)
C 
      REAL FBVAL(NPIXA1,DIM),PBUF(PDIM,NPIXA1)
      REAL COLUM(DIM),SIGMA(DIM)
      REAL A(10),B(10),S(10),W(10),CHISQ,X,DY(4)
      REAL RON,CONAD,THRESH,THRESH2
C
CC      EXTERNAL FGAUSS_C

      DATA MXITER/5/
c
c     Fit the parameters of all the gaussians fitted to the averaged
c     order profils. As a result you get the parameters of a gaussian
c     at each wavelength, stored in PBUF[]. The gaussians itself are
c     saved in FBVAL[].
c
c     At first determin sigma and position of maximum of each gaussian
C 
      THRESH2 = THRESH**2
C 
      I1 = IXMIN + 15
      DO J=2,PDIM-1
         POLORD = 2
         CALL  LSORTHO (PBUF,MASK,A,B,S,W,NPIXA1,I1,IXWMAX,
     1        PDIM,J,CHISQ,POLORD,IXWIND)
         DO I =  IXMIN,IXMAX
            CALL POLY(FLOAT(I),PBUF(J,I),A,B,S,POLORD)
         ENDDO
      ENDDO

c     The parameters of the gaussians at each wavelength are determined
c     Now calculate the gaussian profils and save them in FBVAL[].

      DO I =  IXMIN,IXMAX
         DO J = 1,DIM
            MASK(I,J) = 1       !initialize mask
         ENDDO
         ITER = 1
 101     PBUF(1,I) = 1.0        !amplitude of gaussian
         PBUF(4,I) = 0.0        !background (additional constant)

c     The amplitude and the background of the gaussian
c     may be determined analytically

         DO J = 1,5
            A(J) = 0.0
         ENDDO
         DO J = 1,DIM
            IF (MASK(I,J).GT.0) THEN
               X = J
               CALL XGAUSS_C(X,PBUF(1,I),COLUM(J),DY)
               SIGMA(J) = RON + ABS(FBVAL(I,J))/CONAD
               B(1) = COLUM(J)/SIGMA(J)
               B(2) = 1.0/SIGMA(J)
               A(1) = A(1) + B(1) * COLUM(J)
               A(2) = A(2) + B(1)
               A(3) = A(3) + B(1) * FBVAL(I,J)
               A(4) = A(4) + B(2)
               A(5) = A(5) + B(2) * FBVAL(I,J)
            ENDIF
         ENDDO
         PBUF(4,I) = A(1)*A(4) - A(2)*A(2)
         IF (PBUF(4,I) .NE. 0) THEN
            PBUF(4,I) = (A(1)*A(5) - A(2)*A(3)) / PBUF(4,I)
         ELSE
            PBUF(4,I) = 1E33
             WRITE(*,12345) I,A(1),A(2),A(3),A(4),A(5)
         ENDIF
         IF (A(1) .NE. 0) THEN
            PBUF(1,I) = (A(3) - A(2)*PBUF(4,I)) / A(1)
         ELSE
            PBUF(1,I) = 1E33
             WRITE(*,12346) I,A(1),A(2),A(3),PBUF(4,I)
         ENDIF

c     Now the amplitude and the background are known
c     Determine the final gaussian profil

c     Do the kappa sigma clipping if enabled (THRESH>0)

         IF (THRESH.GT.0) THEN
            NOUT = 0
            DO J = 1,DIM
               IF (MASK(I,J).GT.0) THEN
                  X = J
                  CALL XGAUSS_C(X,PBUF(1,I),COLUM(J),DY)
                  IF (FBVAL(I,J).GT.0) THEN !only interested in CR !!
                     DY(1) = MAX(0.0, FBVAL(I,J) - COLUM(J))
                     DY(2) = DY(1)*DY(1)/SIGMA(J)
                     IF (DY(2).GT.THRESH2) THEN
                        MASK(I,J) = 0
                        NOUT = NOUT+1
                     ENDIF
                  ENDIF
               ENDIF
            ENDDO
            ITER = ITER + 1
            IF (NOUT.GT.0.AND.ITER.LT.MXITER) GOTO 101
            DO J = 1,DIM
               X = J
               CALL XGAUSS_C(X,PBUF(1,I),FBVAL(I,J),DY)
            ENDDO
         ELSE
            DO J = 1,DIM
               X = J
               CALL XGAUSS_C(X,PBUF(1,I),FBVAL(I,J),DY)
            ENDDO
         ENDIF
      ENDDO
C
12345 FORMAT('(4) BAD profile at X = ',I5,5G13.7)
12346 FORMAT('(1) BAD profile at X = ',I5,4G13.7)
C
      RETURN
      END


      SUBROUTINE PROFI(FBVAL,MASK,A,B,S,W,NPIXA1,
     +                 IXMIN,IXMAX,DIM,POLORD) 

C 
      INTEGER DIM,I,J,POLORD,NPIXA1,IXMIN,IXMAX
C 
      INTEGER*2 MASK(NPIXA1,DIM)
C 
      REAL FBVAL(NPIXA1,DIM)
      REAL A(10),B(10),S(10),W(10),CHISQ
c
c     old version to determine the order profiles
c     using a polynomial least squares fit of the resampled
c     intensity profils along the wavelength in each row of the
c     order.
c
      DO J=1,DIM
         POLORD = 2
         CALL  LSORTH (FBVAL,MASK,A,B,S,W,NPIXA1,IXMIN,IXMAX,
     1        DIM,J,CHISQ,POLORD,1)
         DO I =  IXMIN,IXMAX
            CALL POLY(FLOAT(I),FBVAL(I,J),A,B,S,POLORD)
         ENDDO
      ENDDO
      RETURN
      END



      SUBROUTINE CALCULI(IN,VARI,PROF,YVAL,FBVAL,MASK,OUT,VOUT,DIMP,
     1     IWIDTH,BINSIZE,NPIXA1,IXMIN,IXMAX,
     2     NPIXA2,DIM,NB1,NB2,INDX,PAR,NPAR)
C
      IMPLICIT NONE
C 
      INTEGER MTID,ISTAT
      INTEGER NPIXA1,NPIXA2,NB1,NB2,NPAR,I1
      INTEGER I,J,K,KMAX,L,IWIDTH,DIM,BINSIZE,INDX,DIMP
      INTEGER INDY,FIND,IXMIN,IXMAX
      INTEGER NUM,NBAD,NCR
C 
      INTEGER*2 MASK(NPIXA1,DIM)
C 
      DOUBLE PRECISION YVAL(NPIXA1),X1,X2,X
C 
      REAL YPOS, YYY
      REAL FBVAL(NPIXA1,DIM),PROF(NPIXA1,DIMP)
      REAL SUM,SUM1,SUM2
      REAL IN(NPIXA1,NPIXA2),VARI(NPIXA1,NPIXA2)
      REAL OUT(NB1,NB2),VOUT(NB1,NB2)
      REAL PAR(NPAR),RON,CONAD
C 
      CHARACTER*80 LINE
C 
      COMMON /CRMASK/MTID,NCR

      CONAD = PAR(3)            !inverse GAIN: CONAD [e-/ADU]
      RON = PAR(4)              !readout-noise [e-]
      RON = (RON / CONAD)**2    !-> converted to ADU^2 (used for variance!)
      NBAD = 0
C
C  Loop through the 'wavelength'-range [IXMIN,IXMAX]
C
      DO I = IXMIN,IXMAX
         SUM = 0
         I1 = INT(YVAL(I)-IWIDTH/2-1)  
c         K = INT(YVAL(I)-IWIDTH/2)
         K = INT(YVAL(I)-IWIDTH/2.)
         KMAX = K+DIMP-1
         YPOS = YVAL(I)
C
C  Do the linear interpolation of the profile in the 'virtual space'
C  to get the profile in 'real space'.
C  At first find the nearest neighbours of X: (X1,X2)
C  X -> (I,J-K+1) is the profile position of interest.
C
         DO J = K,KMAX-1
            X  = J + 0.5 
c            X  = INT(YVAL(I)-IWIDTH/2)+J-K +0.5 
c            X  = INT(YVAL(I)-IWIDTH/2.)+J-K +0.5 
            X1 = YVAL(I)-IWIDTH/2-1 + J-K
            X2 = X1 + 1./BINSIZE
            FIND = 0 
 10         IF (FIND.EQ.0) THEN
               IF  ((X1.LE.X).AND.(X.LE.X2)) THEN
                  FIND = 1
               ELSE
                  X1 = X2
                  X2 = X2 +1./BINSIZE
               ENDIF
               GOTO 10
            ENDIF
            YYY  = (X1-YVAL(I)+IWIDTH/2+1)*BINSIZE+1
            INDY = NINT( YYY )
            PROF(I,J-K+1) = FBVAL(I,INDY)*(X2-X)*BINSIZE+
     1           FBVAL(I,INDY+1)*(X-X1)*BINSIZE
            IF (MASK(I,INDY).EQ.0) THEN
               NCR = NCR + 1    !count total number of cosmics
               CALL TBEWRI(MTID,NCR,1,I,ISTAT)
               CALL TBEWRI(MTID,NCR,2,J,ISTAT)
               IN(I,J) = PROF(I,J-K+1)
            ENDIF
         ENDDO
C
C  Do the extraction
C  Start with the normalization of the profile
C
         SUM = 0
         IF (NINT(YPOS).EQ.INT(YPOS)) THEN
            DO L = 1,DIMP-1
               SUM = SUM + ABS(PROF(I,L))
            ENDDO
            PROF(I,DIMP) = 0    !set to 0 as not used
         ELSE
            PROF(I,1) = 0       !set to 0 as not used
            DO L = 2,DIMP
               SUM = SUM + ABS(PROF(I,L))
            ENDDO
         ENDIF

         IF (SUM.NE.0) THEN
            DO L = 1,DIMP       !normalize profile
               PROF(I,L) = PROF(I,L)/SUM
            ENDDO
         ELSE                   !All PROF() are 0.0
            SUM2 = 0            !--> skip
            OUT(I,INDX)  = 0.0
            VOUT(I,INDX) = 0.0
            NBAD = NBAD+1
            GOTO 998
         ENDIF
C
C  Recalculate the variance
C
         DO J=K,KMAX
            L = J-K+1
            IF (PROF(I,L).NE.0)
     1           VARI(I,J)=RON+ABS(IN(I,K))/CONAD
         ENDDO
C
C  Now the profile is determined. Extract the spectrum:
C
         SUM2 = 0               !do the extraction ...
         SUM1 = 0               !... sum over spatial coordinate
         IF (NINT(YPOS).EQ.INT(YPOS)) THEN
            SUM1 =  PROF(I,1)*IN(I,K)/VARI(I,K)/(DIMP-2)*
     1           (NINT(YPOS-0.5)-YPOS+0.5)
            SUM2 = PROF(I,1)*PROF(I,1)/VARI(I,K)
            DO J=K+1,KMAX-2
               L = J-K+1
               SUM1 = SUM1 + PROF(I,L)*IN(I,J)/VARI(I,J)/(DIMP-2)
               SUM2 = SUM2 + PROF(I,L)*PROF(I,L)/VARI(I,J)
            ENDDO
            J = KMAX-1
            SUM1 =  SUM1+PROF(I,DIMP-1)*IN(I,J)/VARI(I,J)/(DIMP-2)*
     1           (0.5+YPOS-NINT(YPOS-0.5))
            SUM2 =  SUM2+PROF(I,DIMP-1)*PROF(I,DIMP-1)/VARI(I,J)
         ELSE
            SUM1 = PROF(I,2)*IN(I,K+1)/VARI(I,K+1)/(DIMP-2)*
     1           (1-(YPOS-0.5-NINT(YPOS-0.5))) 
            SUM2 = PROF(I,2)*PROF(I,2)/VARI(I,K+1)
            DO J= K+2,KMAX-1
               L = J-K+1
               SUM1 = SUM1 + PROF(I,L)*IN(I,J)/VARI(I,J)/(DIMP-2) 
               SUM2 = SUM2 + PROF(I,L)*PROF(I,L)/VARI(I,J)
            ENDDO
            J = KMAX
            SUM1 = SUM1 +PROF(I,DIMP)*IN(I,J)/VARI(I,J)/(DIMP-2)*
     1           (YPOS-0.5-NINT(YPOS-0.5))
            SUM2 =  SUM2+PROF(I,DIMP)*PROF(I,DIMP)/VARI(I,J)
         ENDIF
         NUM = DIMP-2
         OUT(I,INDX)  = SUM1/SUM2                    !extracted spectrum 
         VOUT(I,INDX) = 1.0/SUM2/NUM/NUM             !and its variance
c To be consistent the variance has to be devided by the square of the
c number of extracted lines as the extracted data are averged data!

C
C Now store the weights in PROF() and register all bad pixels in the table
C
 998     IF (NINT(YPOS).EQ.INT(YPOS)) THEN
c         IF (NINT(YVAL(I)).EQ.INT(YVAL(I))) THEN
            PROF(I,1) = PROF(I,1)/VARI(I,K)/SUM2*
     1           (NINT(YPOS-0.5)-YPOS+0.5)
            DO J=K+1,KMAX-2
               L = J-K+1
               PROF(I,L) = PROF(I,L)/VARI(I,J)/SUM2
            ENDDO
            J = KMAX-1
            PROF(I,DIMP-1) = PROF(I,DIMP-1)/VARI(I,J)/SUM2*         
     1           (0.5+YPOS-NINT(YPOS-0.5))
         ELSE
            PROF(I,2) = PROF(I,2)/VARI(I,K+1)/SUM2*
     1           (1-(YPOS-0.5-NINT(YPOS-0.5)))
            DO J=K+2,KMAX-1
               L = J-K+1
               PROF(I,L) = PROF(I,L)/VARI(I,J)/SUM2
            ENDDO
            J = KMAX
            PROF(I,DIMP) = PROF(I,DIMP)/VARI(I,J)/SUM2*         
     1           (YPOS-0.5-NINT(YPOS-0.5))
         ENDIF
      ENDDO
      IF (NBAD.GT.0) THEN
         WRITE(LINE,9089) NBAD
9089  FORMAT(I5,' bad profils found (extracted to 0.0).')
         CALL STTPUT(LINE,NBAD)
      ENDIF

      RETURN
      END 
         

      SUBROUTINE CALCULP(IN,VARI,PROF,YVAL,FBVAL,MASK,OUT,VOUT,DIMP,
     +     IWIDTH,BINSIZE,NPIXA1,IXMIN,IXMAX,
     +     NPIXA2,DIM,NB1,NB2,INDX,PAR,NPAR)
C
      INTEGER NPIXA1,NPIXA2,NB1,NB2,NPAR,I1
      INTEGER I,J,K,KMAX,L,IWIDTH,DIM,BINSIZE,INDX,DIMP
      INTEGER INDY,FIND,IXMIN,IXMAX
      INTEGER NUM,NBAD,MTID,NCR
C 
      INTEGER*2 MASK(NPIXA1,DIM)
C 
      DOUBLE PRECISION YVAL(NPIXA1),X1,X2,X
C 
      REAL FBVAL(NPIXA1,DIM),PROF(NPIXA1,DIMP)
      REAL SUM,SUM1,SUM2
      REAL IN(NPIXA1,NPIXA2),VARI(NPIXA1,NPIXA2)
      REAL OUT(NB1,NB2),VOUT(NB1,NB2)
      REAL PAR(NPAR),RON,CONAD
C 
      CHARACTER*80 LINE
C 
      COMMON /CRMASK/MTID,NCR
C 
      CONAD = PAR(3)            !inverse GAIN: CONAD [e-/ADU]
      RON = PAR(4)              !readout-noise [e-]
      RON = (RON / CONAD)**2    !-> convert to [ADU^2]

      DO I = IXMIN,IXMAX
         SUM = 0
         I1 = INT(YVAL(I)-IWIDTH/2)  
         K = I1
         KMAX = K+DIMP-1
C
C  Do the linear interpolation of the profile in the 'virtual space'
C  to get the profile in 'real space'.
C  At first find the nearest neighbours of X: (X1,X2)
C  X -> (I,J-K+1) is the profile position of interest.
C
         DO  J = K,KMAX
            X = INT(YVAL(I)-IWIDTH/2)+J-K +0.5 
            X1 = YVAL(I)-IWIDTH/2 +J-K-1
            X2  = YVAL(I)-IWIDTH/2 + J-K-1 +1./BINSIZE
            FIND = 0 
 10         IF (FIND.EQ.0) THEN
               IF  ((X1.LE.X).AND.(X.LE.X2)) THEN
                  FIND = 1
               ELSE
                  X1 = X2
                  X2 = X2 +1./BINSIZE
               ENDIF
               GOTO 10
            ENDIF
            INDY = NINT((X1-YVAL(I)+IWIDTH/2+1)*BINSIZE+1)
            PROF(I,J-K+1)= FBVAL(I,INDY)*(X2-X)*BINSIZE+
     1           FBVAL(I,INDY+1)*(X-X1)*BINSIZE
            IF (MASK(I,INDY).EQ.0) THEN
               NCR = NCR + 1    !count total number of cosmics
               CALL TBEWRI(MTID,NCR,1,I,ISTAT)
               CALL TBEWRI(MTID,NCR,2,J,ISTAT)
               IN(I,J) = PROF(I,J-K+1)
            ENDIF
         ENDDO
C
C  Do the extraction
C  Start with the normalization of the profile
C
         SUM = 0
         DO L = 1,DIMP
            SUM = SUM + PROF(I,L)
         ENDDO

         IF (SUM.NE.0) THEN
            DO L = 1,DIMP       !normalize profile
               PROF(I,L) = PROF(I,L)/SUM
            ENDDO
         ELSE                   !All PROF() are 0.0
            SUM2 = 0            !--> skip
            OUT(I,INDX)  = 0.0
            VOUT(I,INDX) = 0.0
            NBAD = NBAD+1
            GOTO 998
         ENDIF
C
C Recalculate the variance
C
         DO J=K,KMAX
            L = J-K+1
            IF (PROF(I,L).NE.0)
     1           VARI(I,J)=RON+ABS(IN(I,K))/CONAD
c     1           VARI(I,J)=RON+ABS(OUT(I,INDX)*PROF(I,L))/CONAD
         ENDDO
C
C  Now the profile is determined. Extract the spectrum:
C
         SUM1 =  PROF(I,1)*IN(I,K)/VARI(I,K)/(DIMP-1)*
     1        (INT(YVAL(I))+1-YVAL(I))
         SUM2 = PROF(I,1)*PROF(I,1)/VARI(I,K)
         DO J=K+1,KMAX-1
            L = J-K+1
            SUM1 = SUM1 + PROF(I,L)*IN(I,J)/VARI(I,J)/(DIMP-1)
            SUM2 = SUM2 + PROF(I,L)*PROF(I,L)/VARI(I,J)
         ENDDO
         J = K+DIMP-1
         SUM1 =  SUM1+PROF(I,DIMP)*IN(I,J)/VARI(I,J)/(DIMP-1)*
     1        (YVAL(I)-INT(YVAL(I)))
         SUM2 =  SUM2+PROF(I,DIMP)*PROF(I,DIMP)/VARI(I,J)

         NUM = DIMP-1
         OUT(I,INDX)  = SUM1/SUM2                   !extracted spectrum 
         VOUT(I,INDX) = 1.0/SUM2/NUM/NUM            !and its variance
c To be consistent the variance has to be devided by the square of the
c number of extracted lines as the extracted data are averged data!

C
C Now store the weights in PROF() and register all bad pixels in the table
C
 998     PROF(I,1) = PROF(I,1)/VARI(I,K)/SUM2*
     1        (INT(YVAL(I))+1-YVAL(I))
         DO J=K+1,KMAX-1
            L = J-K+1
            PROF(I,L) = PROF(I,L)/VARI(I,J)/SUM2
         ENDDO
         J = K+DIMP-1
         PROF(I,DIMP) = PROF(I,DIMP)/VARI(I,J)/SUM2*         
     1        (YVAL(I)-INT(YVAL(I)))

      ENDDO
      IF (NBAD.GT.0) THEN
         WRITE(LINE,9089) NBAD
9089  FORMAT(I5,' bad profils found (extracted to 0.0).')
         CALL STTPUT(LINE,NBAD)
      ENDIF

      RETURN
      END



      SUBROUTINE CALC_I(IN,VARI,PROF,YVAL,OUT,VOUT
     1     ,NPIXA1,NPIXA2,NB1,NB2,DIMP,IXMIN,IXMAX,IWIDTH,INDX)
      
      INTEGER I,J,K,KMAX,L
      INTEGER IXMIN,IXMAX,IWIDTH,INDX,DIMP
      INTEGER NPIXA1,NPIXA2,NB1,NB2
      REAL IN(NPIXA1,NPIXA2),VARI(NPIXA1,NPIXA2)
      REAL OUT(NB1,NB2),VOUT(NB1,NB2)
      REAL PROF(NPIXA1,DIMP),PART
      DOUBLE PRECISION SUM1,SUM2,SUM3
      DOUBLE PRECISION YVAL(NPIXA1)

      DO I = IXMIN,IXMAX
c         K = INT(YVAL(I)-IWIDTH/2)
         K = INT(YVAL(I)-IWIDTH/2.0)
         KMAX = K+DIMP-1
C
C  Do the extraction
C
         SUM3 = 0
         SUM2 = 0               !do the extraction ...
         SUM1 = 0               !... sum over spatial coordinate
         IF (NINT(YVAL(I)).EQ.INT(YVAL(I))) THEN
            PART = NINT(YVAL(I)-0.5)-YVAL(I)+0.5
            SUM1 = PROF(I,1)*IN(I,K)*PART
            SUM2 = PROF(I,1)
            SUM3 = PROF(I,1)*PROF(I,1)*VARI(I,K)*PART
            DO J=K+1,KMAX-2
               L = J-K+1
               SUM1 = SUM1 + PROF(I,L)*IN(I,J)
               SUM2 = SUM2 + PROF(I,L)
               SUM3 = SUM3 + PROF(I,L)*PROF(I,L)*VARI(I,J)
            ENDDO
            J = KMAX-1
            PART = 0.5+YVAL(I)-NINT(YVAL(I)-0.5)
            SUM1 =  SUM1 + PROF(I,DIMP-1)*IN(I,J)*PART
            SUM2 =  SUM2 + PROF(I,DIMP-1)
            SUM3 =  SUM3 + PROF(I,DIMP-1)*PROF(I,DIMP-1)*VARI(I,J)*PART
         ELSE
            PART = 1-(YVAL(I)-0.5-NINT(YVAL(I)-0.5))
            SUM1 = PROF(I,2)*IN(I,K+1)*PART
            SUM2 = PROF(I,2)
            SUM3 = PROF(I,2)*PROF(I,2)*VARI(I,K+1)*PART
            DO J= K+2,KMAX-1
               L = J-K+1
               SUM1 = SUM1 + PROF(I,L)*IN(I,J)
               SUM2 = SUM2 + PROF(I,L)
               SUM3 = SUM3 + PROF(I,L)*PROF(I,L)*VARI(I,J)
            ENDDO
            J = KMAX
            PART = YVAL(I)-0.5-NINT(YVAL(I)-0.5)
            SUM1 = SUM1 + PROF(I,DIMP)*IN(I,J)*PART
            SUM2 = SUM2 + PROF(I,DIMP)
            SUM3 = SUM3 + PROF(I,DIMP)*PROF(I,DIMP)*VARI(I,J)*PART
         ENDIF

         IF (SUM2.NE.0) THEN
            OUT(I,INDX)  = SUM1/SUM2/(DIMP-2)               !extracted spect. 
            VOUT(I,INDX) = SUM3/SUM2/SUM2/(DIMP-2)/(DIMP-2) !and its variance
         ELSE
            OUT(I,INDX)  = 0.0
            VOUT(I,INDX) = 0.0
         ENDIF            
c To be consistent the variance has to be devided by the square of the
c number of extracted lines as the extracted data are averged data!
      ENDDO
      RETURN
      END



      SUBROUTINE CALC_P(IN,VARI,PROF,YVAL,OUT,VOUT
     $     ,NPIXA1,NPIXA2,NB1,NB2,DIMP,IXMIN,IXMAX,IWIDTH,INDX)
      
      INTEGER I,J,K,KMAX,L
      INTEGER IXMIN,IXMAX,IWIDTH,IWIDTH2,INDX,DIMP
      INTEGER NPIXA1,NPIXA2,NB1,NB2
      REAL IN(NPIXA1,NPIXA2),VARI(NPIXA1,NPIXA2)
      REAL OUT(NB1,NB2),VOUT(NB1,NB2)
      REAL PROF(NPIXA1,DIMP),PART
      DOUBLE PRECISION SUM1,SUM2,SUM3
      DOUBLE PRECISION YVAL(NPIXA1)

      IWIDTH2 = IWIDTH/2
      DO I = IXMIN,IXMAX
         SUM = 0
         K = INT(YVAL(I)-IWIDTH2)
         KMAX = K+DIMP-1
C
C  Do the extraction
C
         PART = INT(YVAL(I))+1-YVAL(I)
         SUM1 = PROF(I,1)*IN(I,K)*PART
         SUM2 = PROF(I,1)
         SUM3 = PROF(I,1)*PROF(I,1)*VARI(I,K)*PART
         DO J=K+1,KMAX-1
            L = J-K+1
            SUM1 = SUM1 + PROF(I,L)*IN(I,J)
            SUM2 = SUM2 + PROF(I,L)
            SUM3 = SUM3 + PROF(I,L)*PROF(I,L)*VARI(I,J)
         ENDDO
         J = K+DIMP-1
         PART = YVAL(I)-INT(YVAL(I))
         SUM1 = SUM1 + PROF(I,DIMP)*IN(I,J)*PART
         SUM2 = SUM2 + PROF(I,DIMP)
         SUM3 = SUM3 + PROF(I,DIMP)*PROF(I,DIMP)*VARI(I,DIMP)*PART

         IF (SUM2.NE.0) THEN
            OUT(I,INDX)  = SUM1/SUM2/(DIMP-1)               !extracted spect. 
            VOUT(I,INDX) = SUM3/SUM2/SUM2/(DIMP-1)/(DIMP-1) !and its variance
         ELSE
            OUT(I,INDX)  = 0.0
            VOUT(I,INDX) = 0.0
         ENDIF            
c To be consistent the variance has to be devided by the square of the
c number of extracted lines as the extracted data are averged data!
      ENDDO
      RETURN
      END



      SUBROUTINE VSAMPLE(IN,PROF,YVAL,FBVAL,MASK,DIMP,
     1     IWIDTH,BINSIZE,NPIXA1,IXMIN,IXMAX,NPIXA2,DIM,IKIND)
C
C     Do the sampling in the virtual space.
C
      INTEGER I,J,IWIDTH,DIM,IX,BINSIZE,IND,DIMP,IY
      INTEGER NPOINT,NPIXA1,NPIXA2,K,IKIND,IXMIN,IXMAX
C 
      INTEGER*2 MASK(NPIXA1,DIM)
C 
      DOUBLE PRECISION YVAL(NPIXA1),YDVAL,XDVAL
C 
      REAL FBVAL(NPIXA1,DIM)
      REAL PROF(NPIXA1,DIMP),DX,DY
      REAL IN(NPIXA1,NPIXA2),YDEC,SUM

C 
      DO J=1,DIM
         DO I=IXMIN,IXMAX
            FBVAL(I,J) = 0
            MASK(I,J) = 0
         ENDDO
      ENDDO
      DO J=1,DIMP
         DO I=IXMIN,IXMAX
            PROF(I,J) = 0
         ENDDO
      ENDDO
      IF (IKIND.EQ.0) THEN
         DO I = IXMIN,IXMAX
            SUM = 0
            K = INT(YVAL(I)-IWIDTH/2-1) 
            PROF(I,1) = IN(I,K)
            DO  J = K+1,K+DIMP-2
               PROF(I,J-K+1) = IN(I,J)
               SUM = SUM+IN(I,J)
            ENDDO
            IF ( NINT(YVAL(I)).EQ.INT(YVAL(I))) THEN
               SUM = SUM + IN(I,K)
            ELSE
               SUM = SUM + IN(I,K+DIMP-1)
            ENDIF
            PROF(I,DIMP) = IN(I,K+DIMP-1)
c            IF (SUM.EQ.0)  SUM=1
c            DO J = K,K+DIMP-1
c               PROF(I,J-K+1) = PROF(I,J-K+1)/SUM
c            ENDDO
         ENDDO
      ELSE
         DO I=IXMIN,IXMAX
            SUM = 0
            K = INT(YVAL(I)-IWIDTH/2)
            DO J = K,K+DIMP-1
               PROF(I,J-K+1) = IN(I,J)
               SUM = SUM+IN(I,J)
            ENDDO
c            IF (SUM.EQ.0) SUM = 1  
c            DO J = K,K+DIMP-1
c               PROF(I,J-K+1) = PROF(I,J-K+1)/SUM
c            ENDDO
         ENDDO
      ENDIF
      IF (IKIND.EQ.0) THEN
         DO J=1,DIM
            NPOINT =0
            DO I= IXMIN,IXMAX
               XDVAL = I
               IND = I
               K = INT(YVAL(I)-IWIDTH/2-1)
               YDVAL = YVAL(IND)-IWIDTH/2-1 + (J-1.)/BINSIZE
               IX = XDVAL
               YDEC = INT(YDVAL)+0.5
               DX = XDVAL-IX
               DY = YDVAL-YDEC
               IY  = INT(YDVAL)
               IF (DY.GT.-0.5.AND.DY.LE.0) THEN
                  IF ((IY-K).GT.0) THEN
                     FBVAL(I,J) =  (1+DY)*PROF(IX,IY-K+1) -
     1                    DY*PROF(IX,IY-K)
                     MASK(I,J) = 1
                     NPOINT = NPOINT+1
                  ENDIF
               ELSE IF (DY.LT.0.5.AND.DY.GE.0) THEN
                  IF ((IY-K+1).LT.DIMP) THEN
                     FBVAL(I,J) =  (1-DY)*PROF(IX,IY-K+1) +
     1                    DY*PROF(IX,IY-K+2)
                     MASK(I,J) = 1
                     NPOINT = NPOINT+1
                  ENDIF
               ENDIF
            ENDDO
         ENDDO
      ELSE
         DO J=1,DIM
            NPOINT =0
            DO I= IXMIN,IXMAX
               XDVAL = I
               IND = I
               K = INT(YVAL(I)-IWIDTH/2)
               YDVAL = YVAL(IND)-IWIDTH/2-1 + (J-1.)/BINSIZE
               IX = XDVAL
               YDEC = INT(YDVAL)+0.5
               DX = XDVAL-IX
               DY = YDVAL-YDEC
               IY  = INT(YDVAL)
               IF (DY.GT.-0.5.AND.DY.LE.0.AND.
     1              (IY-K+1).LE.DIMP.AND.(IY-K).GE.0) THEN
                  IF ((IY-K).NE.0.AND.(IY-K).NE.DIMP) THEN
                     FBVAL(I,J) =  (1+DY)*PROF(IX,IY-K+1) -
     1                    DY*PROF(IX,IY-K)
                  ELSE IF((IY-K).EQ.0) THEN
                     FBVAL(I,J) = PROF(IX,IY-K+1) 
                  ELSE
                     FBVAL(I,J) = PROF(IX,IY-K)
                  ENDIF
                  MASK(I,J) = 1
                  NPOINT = NPOINT+1
               ELSE IF (DY.LT.0.5.AND.DY.GE.0.AND.
     1                 (IY-K+1).LE.DIMP.AND.(IY-K).GE.0) THEN
                  IF ((IY-K+1).NE.DIMP.AND.(IY-K+1).NE.0) THEN
                     FBVAL(I,J) =  (1-DY)*PROF(IX,IY-K+1) +
     1                    DY*PROF(IX,IY-K+2)
                  ELSE IF ((IY-K+1).EQ.DIMP) THEN
                     FBVAL(I,J) = PROF(IX,IY-K+1)
                  ELSE
                     FBVAL(I,J) = PROF(IX,IY-K+2)
                  ENDIF
                  MASK(I,J) = 1
                  NPOINT = NPOINT+1
               ENDIF
            ENDDO
         ENDDO
      ENDIF
      RETURN
      END


      SUBROUTINE LSORTHO (DAT,MASK,A,B,S,W,NPIXA1,
     1                    IXMIN,IXMAX,DIM,LIN,CHISQ,IORD,IXSTP)
C
      IMPLICIT  NONE
C 
      INTEGER      IMAX,IMAXST,IFAUTO,IORD,I,N,I1,IFF,K,K1
      INTEGER      IFTEST,DIM,LIN,NPIXA1,IXMIN,IXMAX,IXSTP
C 
      INTEGER*2    MASK(NPIXA1,DIM)
C 
      REAL         DAT(DIM,NPIXA1),A(10),B(10),S(10),W(10),P(10)
      REAL         CHISQ,DEL,XNU,F,F95,DCHI,P2
      REAL         X
C
      DATA IMAXST/10/,IFTEST/2/ 
C 
C 
      IMAX=IMAXST     

      IFAUTO=0   
      IF(IORD .LT. 10) GOTO 110
      IORD=9
      IFAUTO=1
 110  CONTINUE 
      IF(IORD .NE. 0) IMAX=MAX0(IABS(IORD)+1,2) 
      DO 10 I=1,IMAXST
         W(I)=0. 
         S(I)=0. 
         A(I)=0. 
         B(I)=0.
 10   CONTINUE
      X = IXMIN - IXSTP
      P(1)=1.
      DO 20 N=IXMIN,IXMAX
         IF (MASK(N,LIN).EQ.1) THEN
            X   = X + IXSTP
            W(1)=W(1)+1.   
            S(1)=S(1)+DAT(LIN,N)  
            A(1)=A(1)+X
c            A(1)=A(1)+N
         ENDIF
 20   CONTINUE
      IF (W(1) .EQ. 0) RETURN
      S(1)=S(1)/W(1)
      A(1)=A(1)/W(1)    
      I=1   
      XNU=INT(W(1))-1
 30   IFF=1  
 40   I1=I   
      IF(IMAX .GT. I) I = I+1    
      X = IXMIN - IXSTP
      CHISQ=0.  
      DO 70 N=IXMIN,IXMAX
         X = X + IXSTP
         IF (MASK(N,LIN).EQ.1) THEN
c            P(2)=N-A(1)    
            P(2)=X-A(1)    
            IF(I .EQ. 2) GOTO 60 
            DO 50 K=3,I
               K1=K-1    
               P(K)=(X-A(K1))*P(K1)-B(K1)*P(K-2)  
c               P(K)=(N-A(K1))*P(K1)-B(K1)*P(K-2)  
 50         CONTINUE
 60         DEL=DAT(LIN,N)-S(I1)*P(I1)   
            DAT(LIN,N)=DEL  
            CHISQ=CHISQ+DEL*DEL 
            IF(IMAX .LE. I1) GOTO 70  
            P2=P(I)**2
            S(I)=S(I)+DEL*P(I)
            A(I)=A(I)+X*P2  
c            A(I)=A(I)+N*P2  
            W(I)=W(I)+P2    
         ENDIF
 70   CONTINUE       
      IF(IMAX .LE. I1) GOTO 80  
      A(I)=A(I)/W(I)  
      B(I)=W(I)/W(I1)  
      S(I)=S(I)/W(I)      
      XNU=XNU-1.     
      DCHI=S(I)**2*W(I)  
      IF(DCHI .GE. CHISQ) GOTO 30   
      F=XNU*DCHI/(CHISQ-DCHI)   
      F95=3.84+(10.+(12.+(30.+105./XNU/XNU)/XNU)/XNU)/XNU    
      IF(F .GT. F95) GOTO 30  
      IF(IFAUTO.EQ.0) GOTO 30   ! F-TEST OFF
      XNU=XNU+1.   
      IFF=IFF+1      
      S(I)=0.   
      IF(IFF .LE. IFTEST) GOTO 40  
 80   IORD=MIN0(IMAX-1,I1)-IFF+1
      RETURN 
      END


      SUBROUTINE POLY(XFIT,YFIT,A,B,S,IORD)
C
      IMPLICIT NONE
      INTEGER           K,IORD
      REAL              A(10),B(10),S(10),P(10)
      REAL              XFIT,YFIT
C     
      P(1)=1.
      YFIT = S(1)
C     
      P(2)=XFIT-A(1)
      YFIT = YFIT+S(2)*P(2)
C     
      DO 10 K=3,IORD+1
         P(K)=(XFIT-A(K-1))*(P(K-1))-B(K-1)*P(K-2)
         YFIT =YFIT+S(K)*P(K)
 10   CONTINUE
      RETURN
      END


      SUBROUTINE XGAUSS_C(X,A,Y,DYDA)
      REAL X,Y,A(4),DYDA(4)
      DOUBLE PRECISION ARG,EX,FAC

      Y=0.
      ARG=(X-A(2))/A(3)
      EX=EXP(-ARG**2)
      FAC=A(1)*EX*2.*ARG
      Y=A(1)*EX + A(4)
      DYDA(1)=EX
      DYDA(2)=FAC/A(3)
      DYDA(3)=FAC*ARG/A(3)
      DYDA(4)=1.0
      RETURN
      END


c
c OBSOLETE SUBROUTINES:
c
c      SUBROUTINE LSORTH (FBVAL,MASK,A,B,S,W,NPIXA1,
c     1                    IXMIN,IXMAX,DIM,LIN,CHISQ,IORD)
      SUBROUTINE LSORTH (FBVAL,MASK,A,B,S,W,NPIXA1,
     1                    IXMIN,IXMAX,DIM,LIN,CHISQ,IORD,IXSTP)
C
      IMPLICIT  NONE
      INTEGER      IMAX,IMAXST,IFAUTO,IORD,I,N,I1,IFF,K,K1
      INTEGER      IFTEST,DIM,LIN,NPIXA1,IXMIN,IXMAX,IXSTP
      INTEGER*2    MASK(NPIXA1,DIM)
      REAL         FBVAL(NPIXA1,DIM),A(10),B(10),S(10),W(10),P(10)
      REAL         CHISQ,DEL,XNU,F,F95,DCHI,P2
      REAL         X
C
      DATA IMAXST/10/,IFTEST/2/ 
      IMAX=IMAXST     

      IFAUTO=0   
      IF(IORD .LT. 10) GOTO 110
      IORD=9
      IFAUTO=1
 110  CONTINUE 
      IF(IORD .NE. 0) IMAX=MAX0(IABS(IORD)+1,2) 
      DO 10 I=1,IMAXST
         W(I)=0. 
         S(I)=0. 
         A(I)=0. 
         B(I)=0.
 10   CONTINUE
      X = IXMIN - IXSTP
      P(1)=1.
      DO 20 N=IXMIN,IXMAX
         IF (MASK(N,LIN).EQ.1) THEN
            X   = X + IXSTP
            W(1)=W(1)+1.   
            S(1)=S(1)+FBVAL(N,LIN)  
            A(1)=A(1)+X
c            A(1)=A(1)+N
         ENDIF
 20   CONTINUE
      IF (W(1) .EQ. 0) RETURN
      S(1)=S(1)/W(1)
      A(1)=A(1)/W(1)    
      I=1   
      XNU=INT(W(1))-1
 30   IFF=1  
 40   I1=I   
      IF(IMAX .GT. I) I = I+1    
      X = IXMIN - IXSTP
      CHISQ=0.  
      DO 70 N=IXMIN,IXMAX
         X = X + IXSTP
         IF (MASK(N,LIN).EQ.1) THEN
c            P(2)=N-A(1)    
            P(2)=X-A(1)    
            IF(I .EQ. 2) GOTO 60 
            DO 50 K=3,I
               K1=K-1    
               P(K)=(X-A(K1))*P(K1)-B(K1)*P(K-2)  
c               P(K)=(N-A(K1))*P(K1)-B(K1)*P(K-2)  
 50         CONTINUE
 60         DEL=FBVAL(N,LIN)-S(I1)*P(I1)   
            FBVAL(N,LIN)=DEL  
            CHISQ=CHISQ+DEL*DEL 
            IF(IMAX .LE. I1) GOTO 70  
            P2=P(I)**2
            S(I)=S(I)+DEL*P(I)
            A(I)=A(I)+X*P2  
c            A(I)=A(I)+N*P2  
            W(I)=W(I)+P2    
         ENDIF
 70   CONTINUE       
      IF(IMAX .LE. I1) GOTO 80  
      A(I)=A(I)/W(I)  
      B(I)=W(I)/W(I1)  
      S(I)=S(I)/W(I)      
      XNU=XNU-1.     
      DCHI=S(I)**2*W(I)  
      IF(DCHI .GE. CHISQ) GOTO 30   
      F=XNU*DCHI/(CHISQ-DCHI)   
      F95=3.84+(10.+(12.+(30.+105./XNU/XNU)/XNU)/XNU)/XNU    
      IF(F .GT. F95) GOTO 30  
      IF(IFAUTO.EQ.0) GOTO 30   ! F-TEST OFF
      XNU=XNU+1.   
      IFF=IFF+1      
      S(I)=0.   
      IF(IFF .LE. IFTEST) GOTO 40  
 80   IORD=MIN0(IMAX-1,I1)-IFF+1
      RETURN 
      END

C @(#)sgepi.for	19.1 (ESO-DMD) 02/25/03 13:31:24
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION:
C  PROGRAM SGEPI               VERSION 1.0                SEP   8, 1988
C  P.GROSBOL                   ESO - GARCHING
C
C.PURPOSE:
C  PROGRAM ESTIMATES THE POSITION AND INCLINATION ANGLE OF A GALAXY.
C  THIS IS DONE BY USE THE VARIATION OF THE 2ND FOURIER HARMONIC.
C
C.INPUT/OUTPUT:
C  THE PROGRAM RUNS UNDER MIDAS AND USES THE FOLLOWING KEYWORDS:
C    IN_A       :  NAME OF IMAGE FILE                               (I)
C    INPUTR(1-5):  REAL INPUT PARAMETERS DEFINING RADIAL RANGE      (I)
C                  1:INNER RADIUS, 2:OUTER RADIUS, 3:RADIAL STEP
C                  4:X CENTER POSITION, 5:Y CENTER POSITION,
C    OUTPUTR(1-4): REAL OUTPUT PARAMETERS GIVING                    (O)
C                  1:X CENTER POSITION, 2:Y CENTER POSITION,
C                  3:POSITON ANGLE (DEG), 4:INCLINATION ANGLE (DEG)
C
C.VERSION:
C  Included in the ESO-MIDAS version                          910208 RHW
C 
C 010201		last modif
C 
C---------------------------------------------------------------------
      PROGRAM SGEPI
C
      IMPLICIT   NONE
      INTEGER    MR
      INTEGER    MF
      INTEGER    MFD
      INTEGER    MIS
      PARAMETER  (MR=100)
      PARAMETER  (MF=6)
      PARAMETER  (MFD=MF+1)
      PARAMETER  (MIS=15)
C
      INTEGER    MADRID(1)
      INTEGER    IERR, IAV
      INTEGER    NA
      INTEGER    MC
      INTEGER    I
      INTEGER    NR
      INTEGER    NPIX(3),IMNO,KUNIT(4),INULL
      INTEGER*8    PNTR
      
      REAL       PI, PA, PM
      REAL       R, RI, RO, RM, RP
      REAL       DR, DTR, D24, DI
      REAL       XC, YC, XM
      REAL       AN
      REAL       SM, SA, SB
      REAL       WM
      REAL       AIR
      REAL       A, AI
      REAL       B
      REAL       XS, YS, SX, SY
C
      REAL       AMP(MFD),PHA(MFD),RANGE(3),POSI(4),
     2           AMP2(MR),PHA2(MR),AMP4(MR),PHA4(MR),
     3           W(MR),XV(MR),YV2(MR),YV4(MR)
      DOUBLE PRECISION START(3), STEP(3)
C
      CHARACTER*60 INAME
      CHARACTER*64 UNIT
      CHARACTER*72 IDEN
      CHARACTER*80 MSG
C
      INCLUDE  'MID_INCLUDE:ST_DEF.INC'
      COMMON   /VMR/MADRID
      INCLUDE  'MID_INCLUDE:ST_DAT.INC'
C
C     INITIATE MIDAS
C
      CALL STSPRO('SGEPI')
C
C     READ PARAMETERS
C
      CALL STKRDC('IN_A',1,1,60,IAV,INAME,KUNIT,INULL,IERR)
      CALL STKRDR('INPUTR',1,3,IAV,RANGE,KUNIT,INULL,IERR)
      CALL STKRDR('INPUTR',4,2,IAV,POSI,KUNIT,INULL,IERR)
C
C     OPEN IMAGE FRAME
C
      CALL STIGET(INAME,D_R4_FORMAT,F_I_MODE,1,3,NA,NPIX,
     ,                START,STEP,IDEN,UNIT,PNTR,IMNO,IERR)
      IF (NA.NE.2 .OR. IERR.NE.0 .OR.
     .    ABS(STEP(1)/STEP(2)-1.0).GT.1E-5) THEN
         CALL STTPUT('*** FATAL: WRONG IMAGE FORMAT',IERR)
         CALL STSEPI
      ENDIF
C
C     CHECK PARAMETERS AND CONVERT TO PIXEL VALUES
C
      PI  = 4.0 * ATAN(1.0)
      DTR = PI / 180.0
      XS  = START(1)
      YS  = START(2)
      SX  = STEP(1)
      SY  = STEP(2)
      RI  = MAX(0.0, ABS(RANGE(1)))
      RO  = MAX(RI, ABS(RANGE(2)))
      RM  = MIN(ABS(POSI(1)-XS), ABS(POSI(2)-YS))
      RM  = MIN(RM, ABS(POSI(1)-XS-NPIX(1)*SX))
      RM  = MIN(RM, ABS(POSI(2)-YS-NPIX(2)*SY))
      RO  = MIN(RM-2.0*ABS(SX), RO)
      DR  = ABS(RANGE(3))
      XC  = (POSI(1)-XS)/SX + 1.0
      YC  = (POSI(2)-YS)/SY + 1.0
      NR = MIN(MR, INT((RO-RI)/DR))
C
C     GET FOURIER COEFFICIENTS FROM EACH RADIUS
C
      R  = RI
      DO 100, I = 1,NR
         RP = R / STEP(1)
         CALL APFFTC(MADRID(PNTR),NPIX(1),NPIX(2),XC,YC,RP,0.0,0.0,
     ,               MFD,MC,AMP,PHA,AN)
         AMP2(I) = 0.0
         PHA2(I) = 0.0
         AMP4(I) = 0.0
         PHA4(I) = 0.0
         W(I)    = 0.0
         IF (MC.GT.0) THEN
            AMP2(I) = AMP(3) / AMP(1)
            PHA2(I) = PHA(3) / (2.0*DTR)
            AMP4(I) = AMP(5) / AMP(1)
            PHA4(I) = PHA(5) / (4.0*DTR)
            D24     = COS( 4.0*DTR*(PHA2(I)-PHA4(I)) )
            W(I)    = MAX( 0.0 , D24*MIN( 10.0,AMP2(3)/AN) )
         ENDIF
         WRITE(MSG,605) R,AMP2(I),PHA2(I),PHA4(I),D24,AN,W(I)
  605    FORMAT(' R,A,P(2,4,6),W :',F6.1,F7.3,2F6.1,2F7.3,F7.3)
         CALL STTPUT(MSG,IERR)
         R  = R + DR
  100 CONTINUE
C
C    COMPUTE ESTIMATE OF POSITION ANGLE
C
      PM = 0.0
      RM = 0.0
      SM = 0.0
      WM = 0.0
      DO 200, I = 1,NR
         RM = RM + W(I)*I
         XM = XM + W(I)*PHA2(I)
         WM = WM + W(I)
  200 CONTINUE
      PA = XM / WM
      RM = (RM/WM - 1.0)*DR + RI
      WRITE(MSG,620) RM,PA
  620 FORMAT('RADIUS, P.A. : ',2F8.1)
      CALL STTPUT(MSG,IERR)
C
C     ESTIMATE INCLINATION ANGLE WITH THIS POSITION ANGLE
C
      RP = RM / STEP(1)
      AI = 0.0
      DI = 5.0 
      PA = DTR * PA
      DO 300, I = 1,MIS
         AIR = DTR * AI
         CALL APFFTC(MADRID(PNTR),NPIX(1),NPIX(2),XC,YC,RP,PA,AIR,
     ,               MFD,MC,AMP,PHA,AN)
         W(I)    = 0.0
         IF (MC.GT.0) THEN
            XV(I) = COS( AIR )
            YV2(I) = AMP(3) * COS( PHA(3) ) / AMP(1)
            YV4(I) = AMP(5) * COS( PHA(5) ) / AMP(1)
            W(I)  = 2.0*COS(ATAN(4.0*YV2(I)))
         ENDIF
         WRITE(MSG,630) AI,XV(I),YV2(I),YV4(I),W(I)
  630    FORMAT(' R,A2,P2,W :',F6.1,F8.3,2F8.3,F8.3)
         CALL STTPUT(MSG,IERR)
         AI = AI + DI
  300 CONTINUE
C
C     FIT LINE TO GET ESTIMATE FOR INCLINATION ANGLE
C
      CALL LFIT(XV,YV2,W,MIS,1,A,SA,B,SB,R)
      AI = ACOS( -A/B ) / DTR
      PA = PA / DTR
      WRITE(MSG,640) R,PA,AI
  640 FORMAT('RADIUS, PA, I : ',F8.1,2F7.1)
      CALL STTPUT(MSG,IERR)
      CALL STKWRR('OUTPUTR',POSI,1,2,KUNIT,IERR)
      CALL STKWRR('OUTPUTR',PA,3,1,KUNIT,IERR)
      CALL STKWRR('OUTPUTR',AI,4,1,KUNIT,IERR)
C
C     FINISHED - EXIT
C
      CALL STSEPI
      END

C @(#)lire.for	19.1 (ES0-DMD) 02/25/03 13:30:46
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE LIRE(NL,NPL,NPL1,NPL2,NPL3,FMES,RMES)                          
C+++                                                                            
C.PURPOSE:  Write part of a frame into an array
C.AUTHOR:   ???
C.VERSION:  ?????? ??? created
C.VERSION:  890117 RHW documented
C.COMMENTS: none
C---
      IMPLICIT   NONE
      INTEGER    NL
      INTEGER    NPL
      INTEGER    NPL1
      INTEGER    NPL2
      INTEGER    NPL3
      REAL       FMES(1)
      REAL       RMES(1)                                                

      INTEGER    MADRID(1)
      INTEGER    NPD, NPF, K, I 
C
      COMMON     /VMR/MADRID                                                 
C
C ***
      NPD = NPL* (NL-1) + NPL1                                                  
      NPF = NPD + NPL2 - NPL1                                                   
      K   = 0                                                                   
C                                                                               
      DO 10 I = NPD,NPF,NPL3                                                    
         K       = K + 1                                                        
         RMES(K) = FMES(I)                                                      
   10 CONTINUE                                                                  
C                                                                               
      RETURN                                                                    
      END                                                                       

C @(#)rfotctrans.for	19.1 (ES0-DMD) 02/25/03 13:30:14
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
       PROGRAM CTRANS
C+++
C.IDENTIFICATION: RFOTCTRANS
C.PURPOSE: Create two tables for coordinate transformation between two frames
C.AUTHOR:  R. Buonanno, G. Buscema, C. Corsi, I. Ferraro, G. Iannicola
C          Osservatorio Astronomico di Roma, and
C.         R.H. Warmels, ESO-IPG
C.VERSION: 881119 RB   First installation in MIDAS
C          890914 RHW  Rewritten for MIDAS tables
C----
      IMPLICIT         NONE
      INCLUDE          'MID_REL_INCL:RFOTDECL.INC'
C
      INTEGER          LC
      INTEGER          LT
      PARAMETER        (LC=10000)
      PARAMETER        (LT=41)
C
      INTEGER          LF(LC)
      INTEGER          MADRID(1)
      INTEGER          ICOL(12)
      INTEGER          ICIDN, IDN1, IDN2
      INTEGER          IAV, KUN, KNUL
      INTEGER          ISTAT
      INTEGER          EC, ED, EL
      INTEGER          IGP 
      INTEGER          KK
      INTEGER          NCP, NHL
      INTEGER          I
      INTEGER          J
      INTEGER          NST, NPA
      INTEGER          LL, LLK, LF1
      INTEGER          IROW
      INTEGER          NCINT,NRINT,NSINT,NCAINT,NRAINT
      INTEGER          NCCB1,NRCB1,NSCB1,NCACB1,NRACB1
      INTEGER          NCCB2,NRCB2,NSCB2,NCACB2,NRACB2
      INTEGER          TIDINT,TIDCB1,TIDCB2
C
      DOUBLE PRECISION X(LC),Y(LC),Z(LC),ZX(LC),ZY(LC),XD,YD
      DOUBLE PRECISION C(LT),CX(LT),CY(LT)
      REAL             TAB1(12),TAB2(12)
      REAL             DEX,DEY,DEX2,DEY2
      REAL             BIP
      REAL             VZ
      REAL             SQST, SQM
C
      CHARACTER        STRING*80
      CHARACTER        YH*1
      CHARACTER        TABINT*60,TABCB1*60,TABCB2*60
C
      LOGICAL          NUL(12)
C
      INCLUDE          'MID_INCLUDE:TABLES.INC'
      COMMON           /VMR/MADRID
      INCLUDE          'MID_INCLUDE:TABLED.INC'
C
      DATA             LF/LC*0/
      DATA             ICOL/2,3,4,5,6,7,8,9,10,11,12,13/
      DATA             ICIDN/1/
C
  901 FORMAT('            Seq   IDENT  Difference')
  902 FORMAT('         ',I5,2X,I5,2X,E12.5)
  903 FORMAT('*** INFO: SQM = ',E12.5)
C
C *** Is MIDAS out there
      CALL STSPRO('CTRANS')
C
C *** start input procedures intermediate file
      CALL STKRDC('IN_A',1,1,60,IAV,TABINT,KUN,KNUL,ISTAT)   !intermediate file
      CALL STECNT('GET',EC,ED,EL)
      CALL STECNT('PUT',1,0,0)
      CALL TBTOPN(TABINT,F_IO_MODE,TIDINT,ISTAT)                       !open it
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL: No intermediate file available, '//
     2            'sorry ...'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
C
      CALL TBIGET(TIDINT,NCINT,NRINT,NSINT,NCAINT,NRAINT,ISTAT) !get table info
      IF (NRINT.EQ.0 .OR. ISTAT.NE.0) THEN
         STRING = '*** FATAL: Something wrong with the intermediate '//
     2            'file, sorry ...'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
C
C *** get coordinate tables
      CALL STKRDC('INPUTC',1,1,30,IAV,TABCB1,KUN,KNUL,ISTAT)       !first table
      CALL TBTOPN(TABCB1,F_I_MODE,TIDCB1,ISTAT)                        !open it
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL: First coordinate table not available, '//
     2            'sorry ...'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
C
      CALL TBIGET(TIDCB1,NCCB1,NRCB1,NSCB1,NCACB1,NRACB1,ISTAT) !get table info
      IF (NRCB1.EQ.0 .OR. ISTAT.NE.0) THEN
         STRING = '*** FATAL: Something wrong with the first '//
     2            'coordinate table, sorry ...'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
C
      CALL STKRDC('INPUTC',1,31,30,IAV,TABCB2,KUN,KNUL,ISTAT)     !second table
      CALL TBTOPN(TABCB2,F_I_MODE,TIDCB2,ISTAT)                        !open it
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL: Second coordinate table not available, '//
     2            'sorry ...'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
C
      CALL TBIGET(TIDCB2,NCCB2,NRCB2,NSCB2,NCACB2,NRACB2,ISTAT) !get table info
      IF (NRCB2.EQ.0 .OR. ISTAT.NE.0) THEN
         STRING = '*** FATAL: Something wrong with the seond '//
     2            'coordinate table, sorry ...'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
      CALL STECNT('PUT',EC,ED,EL)
C
C *** get the degrees of the fit
      CALL STKRDI('INPUTI',1,1,IAV,IGP,KUN,KNUL,ISTAT)
C
C *** get the data from the table  ***************************************
      DEX  = 0.
      DEY  = 0.
      DEX2 = 0.
      DEY2 = 0.
      KK   = 0
C
      DO 10 I=1,NRCB1
         CALL TBERDI(TIDCB1,I,ICIDN,IDN1,NUL,ISTAT)
         CALL TBRRDR(TIDCB1,I,12,ICOL,TAB1,NUL,ISTAT)
         J   = 0
         LF1 = 0
C
  101    CONTINUE
         IF (LF1.NE.0 .OR. J.GE.NRCB2) GO TO 102
            LF1 = 0
            J   = J+1
            CALL TBERDI(TIDCB2,J,ICIDN,IDN2,NUL,ISTAT)
            CALL TBRRDR(TIDCB2,J,12,ICOL,TAB2,NUL,ISTAT)
            IF (IDN1.EQ.IDN2) THEN
               LF1 = 1
            ENDIF
         GO TO 101
C
  102    CONTINUE
         IF (LF1.EQ.1) THEN
            LF(I) = 1
            KK    = KK+1
            IF (IGP.GT.0) THEN
               X(KK)  = TAB1(1)
               Y(KK)  = TAB1(2)
               ZX(KK) = TAB2(1)
               ZY(KK) = TAB2(2)
            ELSE
               DEX  = DEX+TAB2(1)-TAB1(1)
               DEY  = DEY+TAB2(2)-TAB1(2)
               DEX2 = DEX2+(TAB2(1)-TAB1(1))**2
               DEY2 = DEY2+(TAB2(2)-TAB1(2))**2
            END IF
         END IF
   10 CONTINUE
C
      IF (IGP.EQ.0) THEN
         DEX = DEX/KK
         DEY = DEY/KK
      END IF
      NST = KK
C
C *** do the fitting *****************************************************
      IF (IGP.GT.0) THEN
         DO 201 I = 1,NST
            Z(I) = ZX(I)
  201    CONTINUE
C
         CALL IPERD(X,Y,Z,C,NST,IGP,SQM,NPA)
         WRITE(STRING,901)
         CALL STTPUT(STRING,ISTAT)
         LLK = 0
         DO 202 LL=1,NST
            IF (LF(LL).EQ.1) THEN
               LLK  = LLK+1
               VZ   = BIP(X(LLK),Y(LLK),C,IGP)
               SQST = VZ-Z(LLK)
               CALL TBERDI(TIDCB1,LL,ICIDN,IDN1,NUL,ISTAT)
               CALL TBRRDR(TIDCB1,LL,12,ICOL,TAB1,NUL,ISTAT)
               WRITE(STRING,902) LL,IDN1,SQST
               CALL STTPUT(STRING,ISTAT)
            END IF
  202    CONTINUE
C
         DO 203 I=1,NPA
            CX(I) = C(I)
  203    CONTINUE
C
         CALL STTPUT(' ',ISTAT)
C
         DO 204 I = 1,NST
            Z(I) = ZY(I)
  204    CONTINUE
C
C *** inizio proc. calcola scarto
         CALL IPERD(X,Y,Z,C,NST,IGP,SQM,NPA)
         WRITE(STRING,901)
         LLK = 0
         DO 301 LL=1,NST
            IF (LF(LL).EQ.1) THEN
               LLK  = LLK+1
               VZ   = BIP(X(LLK),Y(LLK),C,IGP)
               SQST = VZ-Z(LLK)
               CALL TBERDI(TIDCB1,LL,ICIDN,IDN1,NUL,ISTAT)
               CALL TBRRDR(TIDCB1,LL,12,ICOL,TAB1,NUL,ISTAT)
               WRITE(STRING,902) LL,IDN1,SQST
               CALL STTPUT(STRING,ISTAT)
            END IF
  301    CONTINUE
C
         DO 302 I = 1,NPA
            CY(I) = C(I)
  302    CONTINUE

      ELSE
         SQM = SQRT(DEX2/KK-DEX**2)
         WRITE(STRING,903) SQM
         CALL STTPUT(STRING,ISTAT)
         SQM = SQRT(DEY2/KK-DEY**2)
         WRITE(STRING,903) SQM
         CALL STTPUT(STRING,ISTAT)
      END IF
C
C *** do we want this or not
      CALL STTPUT('*** Do you want this transformation [N]?',ISTAT)
      CALL STKPRC('*** WARNING: If "Y" the intermediate table will '//
     2            'be modified: ','INPUTC',1,1,1,IAV,YH,
     3            KUN,KNUL,ISTAT)
      CALL UPCAS(YH,YH)
      IF (YH.EQ.'Y') THEN
C
C *** read table descriptor
         IROW = 1
  401    CONTINUE
         CALL INTWRD(TIDINT,IROW,NCP,NHL)
         IF (IGP.GT.0) THEN
            XD        = PARINT(1)
            YD        = PARINT(2)
            VZ        = BIP(XD,YD,CX,IGP)
            PARINT(1) = VZ+.5
            VZ        = BIP(XD,YD,CY,IGP)
            PARINT(2) = VZ+.5
         ELSE
            PARINT(1) = PARINT(1)+DEX
            PARINT(2) = PARINT(2)+DEY
         END IF
         CALL INTWWR(TIDINT,IROW,NCP,NHL)
         IROW = IROW + NCP + NHL
         IF (IROW.LE.NRINT) THEN
            GO TO 401
         ENDIF
      ELSE
         STRING = '*** INFO: User veto: no conversion done'
         CALL STTPUT(STRING,ISTAT)
      ENDIF
C
      CALL STSEPI
      END

C @(#)necsord.for	19.1 (ESO-DMD) 02/25/03 14:20:25
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM ECHSRD
C
C+
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  23:20 - 3 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: D.PONZ
C
C.IDENTIFICATION
C
C  program  ECHSORD  version 1.6 830310
C
C.MODIFICATIONS
C
C  910128   P.Ballester   Define and set variables
C
C.KEYWORDS
C
C  ECHELLE, CASPEC
C
C.PURPOSE
C
C SEARCH FOR ORDERS IN AN IMAGE. TYPE ECHELLE - FLAT FIELD
C OUTPUT IS A TABLE WITH THE FOLLOWING COLUMNS :
C COLUMN NO.  LABEL   UNIT      DESCRIPTION
C    1        :ORDER  -         ORDER NUMBER
C    2        :X      PIXEL     SAMPLE NUMBER
C    3        :Y      PIXEL     1. MOMENT AS SUM(F*Y)/SUM(F)
C    4        :YBKG   PIXEL     POSITION OF THE BACKGROUND
C    5        :BKG    DN        BACKGROUND LEVEL
C
C.ALGORITHM
C
C  MAXIMA FOLLOWING ALGORITHM IS USED
C
C  CONSTRAINS : MAXIMUM NUMBER OF ORDERS IN THE IMAGE IS 100
C               FOR EACH ORDER 19 POINTS ARE FOUND
C
C.INPUT/OUTPUT
C
C  COMMAND :
C  SEARCH/ORDER INPUT W,T,S OUTPUT METH
C  input keywords are
C  ECHC(1:8)   INPUT   - IMAGE NAME
C  ECHC(21:28)  OUTPUT  - TABLE NAME
C         W,T,S   - PARAMETERS WHERE :
C  ECHR(1)              W IS THE ESTIMATED WIDTH OF THE ORDER ACCROSS THE
C                         DISPERSION DIRECTION IN USER COORDINATES
C  ECHR(2)              T THRESHOLD IN THE DETECTION
C  ECHR(4)              S SLOPE OF THE ORDER IN THE MIDDLE OF THE
C                         IMAGE TAG(ALFA)
C  ECHC(17:20)  METH   - STD STANDARD STAR METHOD (DEFAULT)
C      COM COMPLEMENT
C
C  010621		last modif
C 
C-
      IMPLICIT NONE
C 
      INTEGER MADRID
      INTEGER ACTVAL,I,IADD,IDELTA,IPOINT
      INTEGER IST,ISTAT,NACOL,NAUX
      INTEGER NAXIS,NDIM,NORDER,NTOT
      INTEGER NWIN1,NWIN2,PNTRA,STATUS,TID
C 
      INTEGER*8  IXCOL,IYAUX
C
      INTEGER NPIX(3),ICOL(7),IAUX(300),KUN,KNUL,IMNI
      INTEGER NSTART(300),NDATA(300),NPOINT(300),IHW(300)
C 
      REAL RPAR(4),LEVEL,SLOPE
      REAL ORDPOS(300),XAUX(300)
C 
      DOUBLE PRECISION START(3),STEP(3)
C 
      CHARACTER*8 FRMIN,TABLE
      CHARACTER*72 IDENA
      CHARACTER*80 LINE
      CHARACTER*64 CUNITA
      CHARACTER*2 METH
      CHARACTER*16 LABCOL(5),UNIT(5)
      CHARACTER*6 FORM(5)
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      DATA LABCOL(1)/'ORDER'/,FORM(1)/'I6'/
      DATA LABCOL(2)/'X'/,FORM(2)/'F7.1'/
      DATA LABCOL(3)/'Y'/,FORM(3)/'F7.1'/
      DATA LABCOL(4)/'YBKG'/,FORM(4)/'F7.1'/
      DATA LABCOL(5)/'BKG'/,FORM(5)/'E12.3'/
      DATA UNIT(1)/'UNITLESS'/
      DATA UNIT(2)/'PIXEL'/
      DATA UNIT(3)/'PIXEL'/
      DATA UNIT(4)/'PIXEL'/
      DATA UNIT(5)/'DN'/
      DATA NACOL/5/
C
      NDIM   = 3
C
C  initialize system
C
      CALL STSPRO('ECHSRD')
      CALL STKRDC('ECHC',1,1,8,ACTVAL,FRMIN,KUN,KNUL,STATUS)
      CALL STKRDC('ECHC',1,17,4,ACTVAL,METH,KUN,KNUL,STATUS)
C CALL SXKGET('ECHC', 'C', 21, 8, ACTVAL, TABLE, STATUS)
      TABLE  = 'ORDER'
      CALL STKRDR('ECHR',1,4,ACTVAL,RPAR,KUN,KNUL,STATUS)
      LEVEL  = RPAR(2)
      SLOPE  = RPAR(4)
      IF (METH.EQ.'CO') THEN
          LABCOL(3) = 'YBKG'
          LABCOL(4) = 'Y'
      END IF
      CALL STTPUT(' ECHELLE DEFINITION',ISTAT)
      CALL STTPUT(' ------------------',ISTAT)
      CALL STTPUT(' INPUT IMAGE  : '//FRMIN,ISTAT)
      CALL STTPUT(' OUTPUT TABLE : '//TABLE,ISTAT)
      CALL STTPUT(' PARAMETERS  ',ISTAT)
      WRITE (LINE,9000) RPAR(1)
      CALL STTPUT(LINE,ISTAT)
      WRITE (LINE,9010) RPAR(2)
      CALL STTPUT(LINE,ISTAT)
      WRITE (LINE,9020) SLOPE
      CALL STTPUT(LINE,ISTAT)
      IF (METH.EQ.'CO') THEN
          LINE   = '       METHOD : COMPLEMENT'
      ELSE
          LINE   = '       METHOD : STANDARD'
      END IF
      CALL STTPUT(LINE,ISTAT)
C
C  read frame
C
      CALL STIGET(FRMIN,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     .            NDIM,NAXIS,NPIX,START,STEP,IDENA,
     .            CUNITA,PNTRA,IMNI,STATUS)
      NWIN2  = RPAR(1)
      NWIN1  = NWIN2/3 + 1
C
C  extract column
C
      CALL TDMGET(4*NPIX(2),IXCOL,IST)
      CALL TDMGET(4*NPIX(2),IYAUX,IST)
      IPOINT = NPIX(1)/2
      CALL EXTR3(MADRID(PNTRA),NPIX(1),NPIX(2),IPOINT,1,NPIX(2),
     +           MADRID(IXCOL))
      IF (METH.EQ.'CO') CALL VCOM(NPIX(2),MADRID(IXCOL),MADRID(IXCOL))
C
C  find order positions in the middle of the image
C
      NAUX   = 200
      CALL FINDM1(MADRID(IXCOL),NPIX(2),NWIN1,NWIN2,LEVEL,NSTART,NDATA,
     +            NORDER,MADRID(IYAUX),XAUX,IAUX,NAUX)
      CALL TDMFRE(4*NPIX(2),IXCOL,IST)
      CALL TDMFRE(4*NPIX(2),IYAUX,IST)
      DO 10 I = 1,NORDER
          ORDPOS(I) = FLOAT(NSTART(I)) + FLOAT(NDATA(I)-1)*0.5
   10 CONTINUE
      WRITE (LINE,9030) NORDER
      CALL STTPUT(LINE,ISTAT)
C
C  get order positions
C
      IDELTA = (NPIX(1)-IPOINT)/10
      IF (NORDER.EQ.1) THEN
          IHW(1) = MIN0(NPIX(2),2*NDATA(1))
      ELSE
          DO 20 I = 1,NORDER - 1
              IHW(I) = (ORDPOS(I+1)-ORDPOS(I))
   20     CONTINUE
          IHW(NORDER) = IHW(NORDER-1)
      END IF
C
C  allocate table
C
      NTOT   = NORDER*30
      CALL TBTINI(TABLE,F_TRANS,F_O_MODE,12,NTOT,TID,STATUS)
      DO 30 I = 1,NACOL
          CALL TBCINI(TID,D_R4_FORMAT,1,FORM(I),UNIT(I),
     .                LABCOL(I),ICOL(I),STATUS)
   30 CONTINUE
      CALL TBCMAP(TID,0,IADD,STATUS)
C
C  follow maxima
C
      CALL FOLLOW(MADRID(PNTRA),NPIX(1),NPIX(2),IPOINT,ORDPOS,NORDER,
     +            IDELTA,IHW,SLOPE,NWIN1,NWIN2,LEVEL,MADRID(IADD),NTOT,
     +            NACOL,NPOINT,METH)
C
C  update number of elements
C
      NTOT   = 0
      DO 40 I = 1,NORDER
          NTOT   = NTOT + NPOINT(I)
   40 CONTINUE
      CALL STKWRI('ECHI',NORDER,4,1,KUN,STATUS)
      CALL STKWRI('ECHI',NPIX,7,2,KUN,STATUS)
      CALL TBIPUT(TID,NACOL,NTOT,STATUS)
      IDENA = 'ORDER POSITION'
      CALL STDWRC(TID,'IDENT',1,IDENA,1,72,KUN,STATUS)
C      CALL DSCUPX(TABLEF,TABLEF,' ',STATUS)
      CALL TBSINI(TID,STATUS)
      CALL TBTCLO(TID,STATUS)
C
C  free data
C
      CALL STSEPI
 9000 FORMAT ('  ORDER WIDTH : ',F6.1)
 9010 FORMAT ('    THRESHOLD : ',F6.1)
 9020 FORMAT ('        SLOPE : ',F6.3)
 9030 FORMAT (' NUMBER OF DETECTED ORDERS : ',I4)
      END

      SUBROUTINE VCOM(N,X,Y)
C
C COMPUTE COMPLEMENT IN VECTOR FORM
C
      IMPLICIT NONE
      INTEGER    N,I
      REAL       X(N),Y(N)

      DO 10 I = 1,N
          Y(I)   = -X(I)
   10 CONTINUE
      RETURN

      END


      SUBROUTINE FOLLOW(X,N1,N2,IXST,ORDPOS,NORDER,IDELTA,IHW,SLOPE,
     +                  NWI1,NWI2,THRES,TAB,NTOT,NACOL,NP,METH)
      IMPLICIT NONE
C
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  SUBROUTINE  FOLLOW      VERSION 1   28 FEB 1983
C  J.D.PONZ
C
C.KEYWORDS:
C  SPECTROSCOPY, CASPEC
C
C.PURPOSE:
C  DEFINE ORDER POSTIONS BY FOLLOWING STRUCTURES ABOVE A GIVEN THRESHOLD
C
C.ALGORITHM:
C
C  ORDER POSITIONS ARE CALCULATED BY THE ROUTINE FINDLT
C
C.INPUT/OUTPUT
C  INPUT ARGUMENTS
C
C  X(N1, N2) REAL*4 INPUT ARRAY
C  N1, N2       INTG*4 DIMENSIONS OF X
C  IXST         INTG*4  STARTING X POSITION IN PIXELS
C  ORDPOS(NORDER)REAL*4 Y POSITION OF THE ORDERS IN PIXELS
C  NORDER INTG*4 NUMBER OF ORDERS
C  IDELTA INTG*4 X INTERVAL IN PIXELS
C  IHW(NORDER) INTG*4 HALFWIDTH OF THE Y-INTERVAL TO BE SEARCHED
C  SLOPE REAL INITIAL SLOPE OF THE ORDERS
C  NWI INTG*4 NUMBER OF PIXELS IN THE WINDOW
C  THRES REAL THRESHOLD
C  NTOT  INTG*4 ALLOCATED SPACE
C
C  OUTPUT ARGUMENTS
C
C  TAB   REAL ARRAY WITH THE LOCATED POSITIONS IN FORMAT
C                   (NTOT,0:NACOL) 1 - ORDER NUMBER
C               2 - SAMPLE
C       3 - MOMENT ORDER 1
C                            4 - position of back.
C       5 - BACKGROUND
C  NPOS  INTG NUMBER OF LOCATED POSITIONS
C
C-------------------------------------------------------------
C
C
      INTEGER   N1,N2,NLIM,I,IXST,NORDER,IDELTA,NWI1,NWI2
      INTEGER   NTOT,NACOL,NP,ISTAT,IORD,NPF,IDELT1,NL
      INTEGER   NPIX,IX0,IY01,IY0,KZ6907,NPIX1,NMAX,I1,I2
      INTEGER   IB1,IB2,NR,KZ6910
      REAL      SLOPE,THRES,SLOPE1,SLMAX,SLMIN,BACK,AVE,Y,A
      REAL      SLOPE2,F

      REAL X(N1,N2),ORDPOS(NORDER),XPIX(300)
      REAL XL(50),YL(50),XAUX(300),YAUX(300)
      INTEGER IHW(NORDER),IAUX(300),NSTART(10),NDATA(10)
      REAL TAB(NTOT,0:NACOL),TRNULL
      DOUBLE PRECISION       TDNULL
      INTEGER                TINULL
      CHARACTER*2 METH
      CHARACTER*80 LINE
C
      CALL TBMNUL(TINULL,TRNULL,TDNULL)
C
      NLIM   = N1 - 2
      NP     = 0
C
C ... DISPLAY RESULTS
C
      CALL STTPUT(' ',ISTAT)
      WRITE (LINE,9020)
      CALL STTPUT(LINE,ISTAT)
      WRITE (LINE,9030)
      CALL STTPUT(LINE,ISTAT)
C
C ... ITERATION ON ORDERS
C
      DO 90 IORD = 1,NORDER
C
C ... INCLUDE START + END POINTS
C
          NPF = 0
          NP     = NP + 1
          TAB(NP,1) = IORD
          TAB(NP,2) = 1.
          TAB(NP,3) = TRNULL
          TAB(NP,4) = TRNULL
          TAB(NP,5) = TRNULL
          NP     = NP + 1
          TAB(NP,1) = IORD
          TAB(NP,2) = N1
          TAB(NP,3) = TRNULL
          TAB(NP,4) = TRNULL
          TAB(NP,5) = TRNULL
C
C ... LEFT PART OF THE IMAGE
C
          IDELT1 = IDELTA
          NL     = 1
          SLOPE1 = SLOPE
          SLMAX  = SLOPE
          SLMIN  = SLOPE
          NPIX   = 2*IHW(IORD)
          IX0    = IXST
          IY01   = ORDPOS(IORD) - IHW(IORD) + 0.5
          IY0    = MAX0(1,IY01)
          XL(1)  = IX0 + IDELT1
          YL(1)  = ORDPOS(IORD) + IDELT1*SLOPE1
          NPIX   = MIN0(NPIX,N2-IY0)
          DO 20 KZ6907 = 1,2147483647
              IF ( .NOT. (IX0.GE.2.AND.NPIX.GT.NWI2)) GO TO 30
C
C ... EXTRACT COLUMN
              NPIX1  = NPIX - (IY0-IY01)
              CALL EXTR3(X,N1,N2,IX0,IY0,NPIX1,XPIX)
              IF (METH.EQ.'CO') CALL VCOM(NPIX1,XPIX,XPIX)
C
C
C ... FIND MAXIMUM
              IF (METH.EQ.'ST' .OR. METH.EQ.'CO') THEN
                  CALL FINDM1(XPIX,NPIX1,NWI1,NWI2,THRES,NSTART,
     +                        NDATA,NMAX,YAUX,XAUX,IAUX,300)

              ELSE
                  CALL FINDM5(XPIX,NPIX1,NWI2,THRES,NSTART,NDATA,
     +                        NMAX)
              END IF

              IF (NMAX.EQ.1) THEN
                  NL     = NL + 1
                  XL(NL) = IX0
                  YL(NL) = FLOAT(NSTART(1)) + FLOAT(NDATA(1)-1)*0.5 +
     +                     IY0 - 1.
                  IDELT1 = IDELTA
C
C ... COMPUTE MOMENTA
                  NP     = NP + 1
                  I1     = NSTART(1)
                  I2     = NSTART(1) + NDATA(1) - 1
                  BACK   = (XPIX(I1-1)+XPIX(I1-2)+XPIX(I1-3)+XPIX(I2+1)+
     +                     XPIX(I2+2)+XPIX(I2+3))/6.
                  AVE    = 0.
                  Y      = 0.
                  DO 10 I = I1,I2
                      F      = XPIX(I) - BACK
                      AVE    = AVE + F
                      Y      = Y + F*I
   10             CONTINUE
                  TAB(NP,1) = IORD
                  TAB(NP,2) = IX0
                  A      = Y/AVE
                  NPF = NPF + 1
                  IF (IORD.NE.1 .OR. IX0.EQ.IXST) THEN
                      TAB(NP,3) = A + IY0 - 1

                  ELSE
                      TAB(NP,3) = TRNULL
                  END IF

                  IB1    = NINT(A-IHW(IORD)/2.)
                  IB2    = NINT(A+IHW(IORD)/2.)
                  IF (IB2.LE.NPIX .AND. IB2.GE.1) THEN
                      IF (METH.EQ.'CO') THEN
                          TAB(NP,5) = -XPIX(NINT(A))

                      ELSE
                          TAB(NP,5) = XPIX(IB2)
                      END IF

                      TAB(NP,4) = IB2 + IY0 - 1

                  ELSE
                      TAB(NP,5) = TRNULL
                      TAB(NP,4) = TRNULL
                  END IF
C       ENDIF
              ELSE
                  NP     = NP + 1
                  TAB(NP,1) = IORD
                  TAB(NP,2) = IX0
                  TAB(NP,3) = TRNULL
                  TAB(NP,4) = TRNULL
                  TAB(NP,5) = TRNULL
                  IDELT1 = IDELT1 + IDELTA
              END IF

              IX0    = XL(NL) - IDELT1
              IF (NL.GT.2) THEN
                  SLOPE2 = (YL(NL)-YL(NL-1))/ (XL(NL)-XL(NL-1))
C       IF (ABS(SLOPE2-SLOPE1).GT.ABS(SLOPE1)*1.0) THEN
C         TYPE *,SLOPE1,SLOPE2
C         NP = NP - 1
C         GO TO 10
C       ENDIF
                  SLOPE1 = SLOPE2
                  SLMAX  = MAX(SLMAX,SLOPE1)
                  SLMIN  = MIN(SLMIN,SLOPE1)
              END IF

              IY01   = YL(NL) - SLOPE1*IDELT1 - IHW(IORD) + 0.5
              IY0    = MAX0(1,IY01)
              NPIX   = 2*IHW(IORD)
              NPIX   = MIN0(NPIX,N2-IY0)
   20     CONTINUE
   30     CONTINUE
C
C ... RIGTH PART OF THE IMAGE
C
          IDELT1 = IDELTA
          NR     = 1
          SLOPE1 = SLOPE
          XL(1)  = IXST
          YL(1)  = ORDPOS(IORD)
          NPIX   = 2*IHW(IORD)
          IX0    = IXST + IDELT1
          IY01   = ORDPOS(IORD) + IDELT1*SLOPE1 - IHW(IORD) + 0.5
          IY0    = MAX0(1,IY01)
          NPIX   = MIN0(NPIX,N2-IY0)
          DO 60 KZ6910 = 1,2147483647
              IF ( .NOT. (IX0.LT.NLIM.AND.NPIX.GT.NWI2)) GO TO 70
C
C ... EXTRACT COLUMN
              NPIX1  = NPIX - (IY0-IY01)
              CALL EXTR3(X,N1,N2,IX0,IY0,NPIX1,XPIX)
              IF (METH.EQ.'CO') CALL VCOM(NPIX1,XPIX,XPIX)
C
C ... FIND MAXIMUM
              IF (METH.EQ.'ST' .OR. METH.EQ.'CO') THEN
                  CALL FINDM1(XPIX,NPIX1,NWI1,NWI2,THRES,NSTART,
     +                        NDATA,NMAX,YAUX,XAUX,IAUX,300)

              ELSE
                  CALL FINDM5(XPIX,NPIX1,NWI2,THRES,NSTART,NDATA,
     +                        NMAX)
              END IF

              IF (NMAX.EQ.1) THEN
                  NR     = NR + 1
                  XL(NR) = IX0
                  YL(NR) = FLOAT(NSTART(1)) + FLOAT(NDATA(1)-1)*0.5 +
     +                     IY0 - 1.
                  IDELT1 = IDELTA
C
C ... COMPUTE MOMENTA
                  NP     = NP + 1
                  I1     = NSTART(1)
                  I2     = NSTART(1) + NDATA(1) - 1
                  BACK   = (XPIX(I1-1)+XPIX(I1-2)+XPIX(I1-3)+XPIX(I2+1)+
     +                     XPIX(I2+2)+XPIX(I2+3))/6.
                  AVE    = 0.
                  Y      = 0.
                  DO 50 I = I1,I2
                      F      = XPIX(I) - BACK
                      AVE    = AVE + F
                      Y      = Y + F*I
   50             CONTINUE
                  TAB(NP,1) = IORD
                  TAB(NP,2) = IX0
                  A      = Y/AVE
                  NPF = NPF + 1
                  IF (IORD.NE.NORDER) THEN
                      TAB(NP,3) = A + IY0 - 1

                  ELSE
                      TAB(NP,3) = TRNULL
                  END IF

                  IB1    = NINT(A-IHW(IORD)/2.)
                  IB2    = NINT(A+IHW(IORD)/2.)
                  IF (IB2.LE.NPIX .AND. IB2.GE.1) THEN
                      IF (METH.EQ.'CO') THEN
                          TAB(NP,5) = -XPIX(NINT(A))

                      ELSE
                          TAB(NP,5) = XPIX(IB2)
                      END IF

                      TAB(NP,4) = IB2 + IY0 - 1

                  ELSE
                      TAB(NP,5) = TRNULL
                      TAB(NP,4) = TRNULL
                  END IF

              ELSE
                  NP     = NP + 1
                  TAB(NP,1) = IORD
                  TAB(NP,2) = IX0
                  TAB(NP,3) = TRNULL
                  TAB(NP,4) = TRNULL
                  TAB(NP,5) = TRNULL
                  IDELT1 = IDELT1 + IDELTA
              END IF

              IX0    = XL(NR) + IDELT1
              IF (NR.GT.2) THEN
                  SLOPE2 = (YL(NR)-YL(NR-1))/ (XL(NR)-XL(NR-1))
C       IF (ABS(SLOPE2-SLOPE1).GT.ABS(SLOPE1)*1.0) THEN
C         TYPE *,SLOPE1,SLOPE2
C         NP = NP - 1
C         GO TO 20
C       ENDIF
                  SLOPE1 = SLOPE2
                  SLMAX  = MAX(SLMAX,SLOPE1)
                  SLMIN  = MIN(SLMIN,SLOPE1)
              END IF

              IY01   = YL(NR) + SLOPE1*IDELT1 - IHW(IORD) + 0.5
              IY0    = MAX0(1,IY01)
              NPIX   = 2*IHW(IORD)
              NPIX   = MIN0(NPIX,N2-IY0)
   60     CONTINUE
   70     CONTINUE
          WRITE (LINE,9010) IORD,IXST,NINT(ORDPOS(IORD)),IHW(IORD),
     +      NPF,SLMAX,SLMIN
          CALL STTPUT(LINE,ISTAT)
   90 CONTINUE
      WRITE (LINE,9040)
      CALL STTPUT(LINE,ISTAT)
      RETURN

C 9000 FORMAT (I4)
 9010 FORMAT (1X,I7,2X,I8,2X,I8,2X,I10,2X,I8,2X,F8.2,2X,F8.2)
 9020 FORMAT (' SEQ.NO.  X CENTER  Y CENTER  INTERORDER  TEMPLA',' MAX',
     +       '.SLOPE MIN.SLOPE')
 9030 FORMAT (' -------  --------  --------  ----------  --------',' -',
     +       '-------- ---------')
 9040 FORMAT (' -------------------------------------------------','--',
     +       '------------------')
      END



      SUBROUTINE EXTR3(X,N1,N2,IXS,IYS,N,XCOL)
C+
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  23:45 - 3 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: D.PONZ
C
C.KEYWORDS
C
C
C.PURPOSE
C
C  EXTRACTS A COLUMN IN A 2D ARRAY AS AVERAGE OF 3 CONTIGUOUS COLUMNS
C
C.ALGORITHM
C
C  OUTPUT COLUMN IS THE AVERAGE OF THREEE CONTIGUOUS COLUMNS
C
C.INPUT/OUTPUT
C
C  INPUT ARGUMENTS ARE
C  X(N1,N2) REAL*4 INPUT 2D FRAME
C  N1,N2 INTG*4 X-DIMENSION
C  IXS  INTG*4 CENTRAL COLUMN NUMBER
C  IYS  INTG*4 STARTING ROW NUMBER
C  N  INTG*4 NUMBER OF PIXELS IN THE COLUMN
C
C  OUTPUT ARGUMENTS ARE
C  XCOL(N) REAL*4 EXTRACTED COLUMN
C
C-
C
C  EXTRACT COLUMN AT IPOINT
C
C      IMPLICIT NONE
      INTEGER N1,N2,N,I1,IXS,IYS,I,J,I2,J1
      REAL X(N1,N2),XCOL(N)

      I1     = IXS - 1
      I2     = IXS + 1
      I      = IXS
      DO 10 J = 1,N
          J1     = J + IYS - 1
          XCOL(J) = (X(I1,J1)+X(I,J1)+X(I2,J1))/3.0
   10 CONTINUE
      RETURN
      END


C
      SUBROUTINE FINDM1(X,N,NW1,NW2,THRES,IST,NDAT,NPOS,YAUX,XAUX,IAUX,
     +                  NAUX)
C+
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  23:50 - 3 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: D.PONZ
C
C.KEYWORDS
C
C  CASPEC
C
C.PURPOSE
C
C  FIND VALUES ABOVE A GIVEN THRESHOLD
C
C.ALGORITHM
C
C
C.INPUT/OUTPUT
C
C  INPUT ARGUMENTS
C  X(N)  REAL INPUT ARRAY
C  N  INTG ARRAY DIMENSION
C  NW1          INTG    SMALL WINDOW
C  NW2          INTG    LARGE WINDOW
C  THRES REAL THRESHOLD
C
C  OUTPUT ARGUMENTS
C  IST  INTG STARTING POSITION OF THE REGION
C  NDAT         INTG    NUMBER OF PIXELS IN THE REGION
C  NPOS  NPOS NUMBER OF REGIONS ABOVE THRESHOLD
C
C  AUXILIARY SPACE
C  YAUX(N)      REAL
C  XAUX(NAUX)   REAL
C  IAUX(NAUX)   INTG
C
C-
C
C      IMPLICIT NONE
      REAL X(N),YAUX(N),XAUX(NAUX),THRES
      INTEGER IST(1),NDAT(1),IAUX(NAUX),N,I,NFIRST
      INTEGER NW1,NW2,NPIX,NPOS,NAUX,MWIND,NO
      LOGICAL FIRST
C
C ... median filtering using threshold
C
      MWIND = 2*NW2 + 1
      CALL MEDNTH(X,N,MWIND,THRES,YAUX,XAUX,IAUX,NAUX)
C
C ... original - filtered
C
      FIRST  = .TRUE.
      NO     = 0
      DO 10 I = NW2,N - NW2 + 1
          YAUX(I) = X(I) - YAUX(I)
          IF (YAUX(I).GT.0.) THEN
C ... above the threshold
              IF (FIRST) THEN
C ... first value above the threshold
                  FIRST  = .FALSE.
                  NFIRST = I
                  NPIX   = 1

              ELSE
                  NPIX   = NPIX + 1
              END IF

          ELSE
C ... below the threshold
              IF ( .NOT. FIRST) THEN
C ... first value below the threshold
                  FIRST  = .TRUE.
                  IF (NPIX.GE.NW1) THEN
                      NO     = NO + 1
                      IST(NO) = NFIRST
                      NDAT(NO) = NPIX
                  END IF

              END IF

          END IF

   10 CONTINUE
      NPOS   = NO
      RETURN

      END


      SUBROUTINE FINDM5(X,N,NW,T,IST,NDAT,NACT)
C+
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  23:56 - 3 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: D.PONZ
C
C  SUBROUTINE FINDM5  VERSION 1.0 11 MAR 1983
C  J.D.PONZ   ESO - GARCHING
C
C.KEYWORDS
C
C  FIND SPECTRAL FEATURES, SPECTROSCOPY
C
C.PURPOSE
C
C  FIND FLAT FIELD PROFILES
C
C.ALGORITHM
C
C  SIMPLE THRESHOLDING METHOD
C
C.INPUT/OUTPUT
C
C  INPUT ARGUMENTS
C  X(N)  REAL INPUT ARRAY
C  N  INTG ARRAY DIMENSION
C  NW           INTG    WINDOW SIZE IN PIXELS
C  T  REAL THRESHOLD
C
C  OUTPUT ARGUMENTS
C  IST  INTG POINTER OF THE STARTING POSITION
C  NDAT  INTG NUMBER OF PIXELS ABOVE THE THRESHOLD
C  NACT         INTG    NUMBER OF DETECTED FEATURES
C
C-
C      IMPLICIT NONE
      REAL X(N),T
      INTEGER IST(1),NDAT(1),N,NW,NACT
      INTEGER I,NPIX,NO
      LOGICAL BACK
C
      BACK   = .FALSE.
      NO     = 0
      DO 10 I = 1,N
          IF (X(I).GT.T) THEN
              IF (BACK) THEN
                  BACK   = .FALSE.
                  NO     = NO + 1
                  IST(NO) = I
                  NPIX   = 1

              ELSE
                  NPIX   = NPIX + 1
              END IF

          ELSE
              IF ( .NOT. BACK) THEN
                  BACK   = .TRUE.
                  IF (NO.GT.0) NDAT(NO) = NPIX
              END IF

          END IF

   10 CONTINUE
      NACT   = NO
      IF (NO.EQ.2) THEN
          NACT   = 1

      ELSE
          IF (NO.EQ.3) THEN
              NACT   = 1
              NDAT(1) = NDAT(2)
              IST(1) = IST(2)
          END IF

      END IF

      RETURN

      END


      SUBROUTINE MEDNTH(IA,LEN,WIDTH,THRES,OA,FA,LINK,NAUX)
C+
C
C.IDENTIFICATION
C  SUBROUTINE MEDIAN              VERSION 1.0     8 MAR 1983
C
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  0:34 - 4 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: D.PONZ
C
C.KEYWORDS
C
C  FILTERING, MEDIAN FILTERING, SPECTROSCOPY, THRESHOLDING
C
C.PURPOSE
C
C  PERFORM MEDIAN FILTERING AND THRESHOLDING ON THE INPUT ARRAY
C
C.ALGORITHM
C
C  DATA IN A RUNNING WINDOW IS SORTED TO FORM A LOCAL HISTOGRAM
C  THE VALUE IN THE MIDDLE OF THE LOCAL HISTOGRAM IS TAKEN AS
C  OUTPUT VALUE IF ABS(MEDIAN-VALUE) .GT. ABS(THRES)
C
C.INPUT/OUTPUT
C
C  INPUT ARGUMENTS :
C  IA      REAL*4     INPUT ARRAY
C  LEN     INTG*4     NUMBER OF INPUT PIXELS
C  WIDTH   INTG*4     WINDOW WIDTH
C  THRES   REAL*4     THRESHOLD
C
C  OUTPUT ARGUMENTS :
C  OA      REAL*4     OUTPUT ARRAY
C
C  WORK SPACE :
C  FA(NAUX)   REAL*4     AUXILIARY SPACE
C  LINK(NAUX) INTG*4     AUXILIARY SPACE
C  NAUX       INTG*4     SPACE SIZE. NAUX .GT. WIDTH+1
C
C-
C      IMPLICIT NONE
      REAL FA(NAUX),IA(LEN),OA(LEN),THRES,T
      INTEGER LINK(NAUX),MIN,MAX,WIDTH,LEN,MIDPT,FRONT,AVAIL
      INTEGER RANGE,NEWNOD,I,J,K,NODE,ITMP,N,NAUX
C
C  SET UP BEGINNING (MIN) AND END (MAX) OF FILTER ARRAY
C   ALSO SET UP POINTER TO AVAIL LIST AND LIST HEADER (FA(1),LINK(1)
C
      T      = ABS(THRES)
      MIN    = 2
      MAX    = NAUX
      AVAIL  = MIN
      FA(1)  = -1.0
      LINK(1) = 0
C
C  SET UP FIRST FILTER WINDOW
C
      RANGE  = WIDTH - 1
      DO 10 I = 1,RANGE,1
          NODE   = NEWNOD(IA(I),AVAIL,MIN,MAX,FA,LINK,NAUX)
          CALL INSNOD(NODE,FA,LINK,NAUX)
   10 CONTINUE
C
C COPY BORDERS TO OUTPUT BUFFER (CANNOT PROCESS BORDER POINTS)
C
      RANGE  = WIDTH/2
      K      = LEN - RANGE
      DO 20 J = 1,RANGE,1
          OA(J)  = IA(J)
          K      = K + 1
C          K POINTS TO HIGH END OF ARRAY, J POINTS TO LOW
          OA(K)  = IA(K)
   20 CONTINUE
C
C  FOR EACH POINT FROM WIDTH/2 TO LEN-WIDTH/2+1
C   FIND ITS MEDIAN
C
      FRONT  = MIN
C                  FRONT IS THE OLDEST POINT IN THE FILTER ARRAY
      K      = RANGE
C                  K IS THE POINT BEING PROCESSED (LOC IN OA)
      MIDPT  = RANGE + 1
C                  MIDPT IS THE MIDDLE OF THE WINDOW (IN FA)
      DO 40 J = WIDTH,LEN,1
          NODE   = NEWNOD(IA(J),AVAIL,MIN,MAX,FA,LINK,NAUX)
          CALL INSNOD(NODE,FA,LINK,NAUX)
          K      = K + 1
C    FIND THE MIDPT - - IT IS THE MEDIAN VALUE
          ITMP   = LINK(1)
          DO 30 I = 2,MIDPT,1
              ITMP   = LINK(ITMP)
   30     CONTINUE
C        GET THE LINK WHICH POINTS TO THE VALUE OF THE MEDIAN
C        MODIFY ONLY IF GREATHER THAN THRESHOLD
          IF (ABS(FA(ITMP)-IA(K)).GT.T) THEN
              OA(K)  = FA(ITMP)

          ELSE
              OA(K)  = IA(K)
          END IF

          CALL DELNOD(FRONT,FA,LINK,NAUX)
          FRONT  = FRONT + 1
          IF (FRONT.GT.MAX) FRONT  = MIN
C                    DELETE OLDEST AND ADVANCE PTR, FRONT ALSO WRAPS
   40 CONTINUE
C
C USE SMOOTH VALUE AT THE ENDS
C
      N      = WIDTH/2 + 1
      DO 50 I = 1,N
          OA(I)  = OA(N)
          OA(LEN-I+1) = OA(LEN-N)
   50 CONTINUE
      RETURN

      END

C @(#)ccdscan.for	19.1 (ESO-IPG) 02/25/03 14:16:39
C $Id: ccdscan.for,v 1.1.1.1 2003-06-04 14:49:46 cguirao Exp $   
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C $Id: ccdscan.for,v 1.1.1.1 2003-06-04 14:49:46 cguirao Exp $
      PROGRAM OVSCAN
C --------------------------------------------------------------------
C.COPYRIGHT: Copyright (c) 1983 European Southern Observatory,
C                                         all rights reserved
C.IDENTIFICATION: CCDOVSCAN.FOR
C.LANGUAGE:  F77+ESOext
C.AUTHOR:    R.H. Warmels
C.KEYWORDS:  average, overscan
C.PURPOSE:   produce a 1d image from a 2d by averaging over rows or columns
C.ALGORITHM  add rows/columns
C.VERSION:   900202  KB   take care of options in lower case
C.VERSION:   ??????  MP   cosmectic changes
C.VERSION:   910417  xx   replace numbers by symbolic constants in ST calls
C.VERSION:   910417  xx   replace numbers by symbolic constants in ST calls
C.VERSION:   930226  RHW  modification for ccd package
C.VERSION:   930331  RHW  modification for average row wise
C.VERSION:   980609  SW   correct use of the selected AREA (OV_SEC)
C ------------------------------------------------------------------

      IMPLICIT NONE
C
      INTEGER MADRID(1)
      INTEGER NDIM,KUN,KNUL
      INTEGER I1,I2,L1,L2,NI,NL
      INTEGER NAXIS,IMNO
      INTEGER NPIX(3)
      INTEGER*8 PNTRA,PNTRB,PNTRC
      INTEGER TIDO
      INTEGER NCOL, NROW, COL(3)
      INTEGER NDUM
      INTEGER STATUS
      INTEGER IMAGE(4)
      INTEGER IAV, ILOG
      INTEGER I, ISMO
C variable in first part not used anymore 05/00 PN
C      INTEGER IR
      INTEGER IXMIN, IXMAX
      INTEGER NCUR, KA, NPAR
      INTEGER ACCESS, PLMODE
      INTEGER NBINS, NACT, NNN, IX
      INTEGER IFREQ(512)
C
      REAL    AMIN, AMAX, XMIN, XMAX, STP
      REAL    X0, X1, XT
      
      REAL    CINT(512), CR
      REAL    LHCUTS(4)
      REAL    FRAME(8)
      REAL    XPA(2), YPA(2)
      REAL    XMEAN, XSTD
      REAL    XCUR, YCUR
      REAL    SCALES(3),OFFSET(2),CLIP(4)

      DOUBLE PRECISION STEP(3)
      DOUBLE PRECISION START(3)
C
      CHARACTER*60     FRAM, AREA
      CHARACTER*60     TABLE
      CHARACTER*80     CINPUT
      CHARACTER*80     TEXT, SEL
      CHARACTER*17     COLUMN(3)
      CHARACTER*80     LABEL1, LABEL2, LABEL3
      CHARACTER*72     CUNIT
      CHARACTER*1      DIRECT
      CHARACTER*72     IDENT
      CHARACTER        IOP*1
      CHARACTER        TABUNI(3)*16,TABLAB(3)*16,TABFOR(3)*16
C 
      INCLUDE          'MID_INCLUDE:ST_DEF.INC'
      COMMON           /VMR/ MADRID
      INCLUDE          'MID_INCLUDE:ST_DAT.INC'
C
      DATA             SEL     /' '/
      DATA             ILOG    /0/
      DATA             COLUMN  /':X', ':FLUX',':FIT'/
      DATA             NDIM    /2/
      DATA             IOP     /'A'/
      DATA             TABUNI  /' ', ' ', ' '/
      DATA             TABLAB  /'X', 'FLUX', 'FIT'/
      DATA             TABFOR  /'G13.6', 'G13.6','G13.6'/
      DATA             SCALES  /0.0,0.0,0.0/
      DATA             CLIP    /0.15,0.95,0.1,0.95/
      DATA             OFFSET  /-999., -999./
C
 9001 FORMAT('*** WARNING: zero dynamics range in y; '//
     2       'value = ',G13.6)
 9002 FORMAT('[@', I5.5, ',@', I5.5, ':@', I5.5, ',@', I5.5, ']')
 9003 FORMAT(':X.GE.',I5.5,'.AND.:X.LE.',I5.5)       
C
C  *** initialize system
      CALL STSPRO('OVSCAN')
C
C  *** read parameter input
      CALL STKRDC('CCDIN',1,1,60,IAV,FRAM,KUN,KNUL,STATUS)
      CALL STKRDC('CCDOUT',1,1,60,IAV,TABLE,KUN,KNUL,STATUS)
      CALL STKRDC('OV_SEC',1,1,60,IAV,AREA,KUN,KNUL,STATUS)
      CALL STKRDC('DIRECT',1,1,1,IAV,DIRECT,KUN,KNUL,STATUS)     ! read direct.
      CALL STKRDC('OV_IMODE',1,1,3,IAV,CINPUT,KUN,KNUL,STATUS)
      CALL STKRDI('INPUTI',1,1,IAV,ISMO,KUN,KNUL,STATUS)
C
C *** read input frame
      CALL STIGET(FRAM,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,NDIM,NAXIS,
     +            NPIX,START,STEP,IDENT,CUNIT,PNTRA,IMNO,STATUS)
C 
      CALL EXTCOO(IMNO,AREA,NAXIS,NDUM,IMAGE(1),IMAGE(3),STATUS) !pixel coords.
      IF (STATUS.NE.0) THEN
         TEXT = '*** FATAL: invalid coordinate input ...'
         CALL STTPUT(TEXT,STATUS)
         CALL STSEPI
      ENDIF
      I1 = IMAGE(1)
      I2 = IMAGE(3)
      L1 = IMAGE(2)
      L2 = IMAGE(4)

C      type *,"IMAGE: ",IMAGE

      NI = I2-I1+1
      NL = L2-L1+1
C
C *** map output table and fill the column
      NCOL = 3
      CALL UPCAS(DIRECT,DIRECT)
      IF ((DIRECT.EQ.'R') .OR. (DIRECT.EQ.'X'))THEN
         DIRECT = 'X'
         FRAME(1) = FLOAT(L1)
         FRAME(2) = FLOAT(L2)
c         NROW     = NPIX(2)
         NROW     = NL

      ELSE IF ((DIRECT.EQ.'C') .OR. (DIRECT.EQ.'Y')) THEN
         DIRECT = 'Y'
         FRAME(1) = FLOAT(I1)
         FRAME(2) = FLOAT(I2)
c         NROW     = NPIX(1)
         NROW     = NI
      ENDIF
      CALL TBTINI(TABLE,F_TRANS,F_IO_MODE,NCOL,NROW,TIDO,STATUS)! create table
      DO 20 IAV = 1,NCOL                                       ! define columns
         CALL TBCINI(TIDO,D_R4_FORMAT,1,TABFOR(IAV),TABUNI(IAV),
     2               TABLAB(IAV),COL(IAV),STATUS)
   20 CONTINUE
C
      CALL TBCSER(TIDO,COLUMN(1),COL(1),STATUS)             ! find pixel column
      CALL TBCSER(TIDO,COLUMN(2),COL(2),STATUS)             ! find flux column
      CALL TBCMAP(TIDO,COL(1),PNTRB,STATUS)                 ! map x column
      CALL TBCMAP(TIDO,COL(2),PNTRC,STATUS)                 ! map flux column
      IF (DIRECT.EQ.'X') THEN                               ! column readout
         CALL AVERC(NPIX(1),NPIX(2),MADRID(PNTRA),MADRID(PNTRB),
     +              MADRID(PNTRC),I1,I2,IOP,ISMO,LHCUTS(3),LHCUTS(4))
         CALL TBIPUT(TIDO,NCOL,NROW,STATUS)                 ! put the columns
c 98.06.09-SW (swolf@eso.org):
c The following selection part is not necessary
c as the table consits only of valid rows!
c         DO 21 IR = 1,L1
c            CALL TBSPUT(TIDO,IR,.FALSE.,STATUS)
c   21    CONTINUE
c         DO 22 IR = L2,NROW
c            CALL TBSPUT(TIDO,IR,.FALSE.,STATUS)
c   22    CONTINUE
C 
C *** get the statistics
         CALL TDMXRS(TIDO,COL(2),NROW,0,XMIN,XMAX)
         IF (XMIN.EQ.XMAX) THEN
            XMAX   = XMIN + 1.
         END IF
         CALL TDSCAL(XMIN,XMAX,1.,X0,X1,IX,XT,NNN)
         AMIN    = X0*10.**IX
         AMAX    = X1*10.**IX
         STP     = XT
         NBINS   = (AMAX-AMIN)/STP + 2
         NBINS   = MIN(NBINS,512)
         CR      = AMIN
         CINT(1) = CR
         DO 23 I = 1,NBINS - 2
            CR        = CR + STP
            CINT(I+1) = CR
 23      CONTINUE
         CALL TDRSTA(TIDO,COL(2),NROW,NBINS,1,CINT,
     2               IFREQ,NACT,XMEAN,XSTD)

      ELSE                                                  ! row readout
         CALL AVERR(NPIX(1),NPIX(2),MADRID(PNTRA),MADRID(PNTRB),
     +              MADRID(PNTRC),L1,L2,IOP,ISMO,LHCUTS(3),LHCUTS(4))
         CALL TBIPUT(TIDO,NCOL,NROW,STATUS)                 ! put the columns
c 98.06.09-SW (swolf@eso.org):
c The following selection part is not necessary
c as the table consits only of valid rows!
c         DO 31 IR = 1,I1
c            CALL TBSPUT(TIDO,IR,.FALSE.,STATUS)
c   31    CONTINUE
c         DO 32 IR = I2,NROW
c            CALL TBSPUT(TIDO,IR,.FALSE.,STATUS)
c   32    CONTINUE
C 
C *** get the statistics
         CALL TDMXRS(TIDO,COL(2),NROW,0,XMIN,XMAX)
         IF (XMIN.EQ.XMAX) THEN
            XMAX   = XMIN + 1.
         END IF
         CALL TDSCAL(XMIN,XMAX,1.,X0,X1,IX,XT,NNN)
         AMIN   = X0*10.**IX
         AMAX   = X1*10.**IX
         STP    = XT
         NBINS  = (AMAX-AMIN)/STP + 2
         NBINS  = MIN(NBINS,512)
         CR     = AMIN
         CINT(1) = CR
         DO 33 I = 1,NBINS - 2
            CR        = CR + STP
            CINT(I+1) = CR
 33      CONTINUE
         CALL TDRSTA(TIDO,COL(2),NROW,NBINS,1,CINT,
     2               IFREQ,NACT,XMEAN,XSTD)
      ENDIF
      LHCUTS(3) = XMEAN-3.*XSTD
      LHCUTS(4) = XMEAN+3.*XSTD
C
C *** the interactive mode
      CALL UPCAS(CINPUT,CINPUT)
      IF (CINPUT(1:1).EQ.'Y') THEN
         IF (LHCUTS(3).EQ.LHCUTS(4)) THEN
            WRITE(TEXT,9001) LHCUTS(3)
            CALL STTPUT(TEXT,STATUS)
            FRAME(5) = 0.95*LHCUTS(3)
            FRAME(6) = 1.05*LHCUTS(4)
         ELSE
            FRAME(5) = LHCUTS(3)
            FRAME(6) = LHCUTS(4)
         ENDIF
C
C *** get the frame ranges in x and y
         CALL GETAXS('AUTO',FRAME(1))
         CALL GETAXS('AUTO',FRAME(5))
         CALL PTKWRR('XWNDL',4,FRAME(1))
         CALL PTKWRR('YWNDL',4,FRAME(5))
C
C *** statistics determined; start the display
         CALL PTKWRR('SCALE',2,SCALES)
         CALL PTKWRR('OFFS',2,OFFSET)
C
         ACCESS = 0
         PLMODE = 1
         CALL PTOPEN(' ','overscan',ACCESS,PLMODE)             ! open plot file
         CALL PTKWRR('CLPL',4,CLIP)
C
         IF (DIRECT.EQ.'X') THEN
            LABEL1 = 'Pixel Row Number '
            LABEL2 = 'Pixel Intensity'
         ELSE
            LABEL1 = 'Pixel Column Number '
            LABEL2 = 'Pixel Intensity'
         ENDIF
         LABEL3 = 'TITLE=Frame: '//TABLE
         CALL PTKWRR('CLPL',4,CLIP)
         CALL PTAXES(FRAME(1),FRAME(5),LABEL1,LABEL2,LABEL3)   ! plot the frame
         NPAR = 3
         CALL PLTBL(TIDO,NPAR,COL(1),COL(2),NROW)               ! plot the data
C
C ***    Now do the looping for 2 cursers
         NCUR  = 2
         DO 50 I = 1,NCUR 
            CALL PTGCUR(XCUR,YCUR,KA,STATUS)
            IF (XCUR.LT.1.0) THEN
               XCUR = 1.0
            ENDIF
            IF (XCUR.GT.FLOAT(NROW)) THEN
               XCUR = FLOAT(NROW)
            ENDIF 
            XPA(I) = XCUR
            YPA(I) = YCUR
   50    CONTINUE
         CALL SORT2(XPA,YPA,NCUR)
         CALL AGGPLM(XPA,YPA,2,4)
         IXMIN = INT(XPA(1))
         IXMAX = INT(XPA(2))  
         CALL PTCLOS()
         WRITE(SEL,9003) IXMIN,IXMAX
         CALL STKWRC('SCANSEL',1,SEL,1,80,KUN,STATUS)      ! set selection flag
      ENDIF
C
C *** free data
      CALL TBTCLO(TIDO,STATUS)
      CALL STSEPI
      END


      SUBROUTINE AVERR(NPIX1,NPIX2,Z,X,Y,L1,L2,IOP,ISM,YMIN,YMAX)
C
C row average from row I1 to I2
C
      IMPLICIT    NONE
      INTEGER     NPIX1, NPIX2
      REAL        Z(NPIX1,NPIX2)
      REAL        X(NPIX1),Y(NPIX1)
      INTEGER     L1, L2
      CHARACTER*1 IOP
      INTEGER     ISM
      REAL        YMIN, YMAX
C 
      INTEGER     NPMAX
      PARAMETER   (NPMAX=10000)
      INTEGER     I, L
      INTEGER     IX, ISX, ILIS, IOFF, IXG
      INTEGER     NAV
      REAL        RN
      REAL        DATA(NPMAX)
      REAL        AVE
C
      DO 10 I = 1,NPIX1
          X(I)   = I
          Y(I)   = 0.
   10 CONTINUE
      IF ((IOP.EQ.'S').OR.(IOP.EQ.'s')) THEN
          DO 30 I = 1,NPIX1
              DO 20 L = L1,L2
                  DATA(I)   = DATA(I) + Z(I,L)
   20         CONTINUE
   30     CONTINUE
      ELSE
          RN     = L2 - L1 + 1
          DO 50 I = 1,NPIX1
              DO 40 L = L1,L2
                  DATA(I)   = DATA(I) + Z(I,L)/RN
   40         CONTINUE
   50     CONTINUE
      END IF
C
C *** do the smooting
      IF (ISM.GT.1) THEN
         ILIS = 2*(ISM/2) + 1
         IOFF = ILIS/2
         DO 60 IX = 1, NPIX1
            AVE = 0.0
            NAV  = 0
            DO 61 ISX = 1,ILIS
               IXG = IX + ISX - IOFF - 1
               IF (IXG.LE.0 .OR. IXG.GT.NPIX1) THEN
                  GO TO 61
               ENDIF
               NAV = NAV + 1
               AVE = AVE + DATA(IXG)
   61       CONTINUE
            Y(IX) = AVE/FLOAT(NAV)
   60    CONTINUE

      ELSE
         DO 70 IX = 1, NPIX1
            Y(IX) = DATA(IX)
   70    CONTINUE
      ENDIF
C
      YMAX   = -1.E30
      YMIN   = -YMAX
      DO 80 I = 1,NPIX1
          YMIN   = MIN(YMIN,Y(I))
          YMAX   = MAX(YMAX,Y(I))
   80 CONTINUE
      RETURN
      END


      SUBROUTINE AVERC(NPIX1,NPIX2,Z,X,Y,I1,I2,IOP,ISM,YMIN,YMAX)
C
C Column average from column 1 to column 2
C
      IMPLICIT    NONE
      INTEGER     NPIX1, NPIX2
      REAL        Z(NPIX1,NPIX2)
      REAL        X(NPIX2), Y(NPIX2)
      INTEGER     I1, I2
      CHARACTER*1 IOP
      INTEGER     ISM
      REAL        YMIN, YMAX
C
      INTEGER     NPMAX
      PARAMETER   (NPMAX=10000)
      INTEGER     I, J
      INTEGER     IX, ISX, ILIS, IOFF, IXG
      INTEGER     NAV
      REAL        RN
      REAL        DATA(NPMAX)
      REAL        AVE
C
C *** do the integration
      DO 10 I = 1,NPIX2
          X(I)   = I
          Y(I)   = 0.
   10 CONTINUE
      IF ((IOP.EQ.'S').OR.(IOP.EQ.'s')) THEN
          DO 30 I = 1,NPIX2
              DO 20 J = I1,I2
                  DATA(I)   = DATA(I) + Z(J,I)
   20         CONTINUE
   30     CONTINUE
      ELSE
          RN     = I2 - I1 + 1
          DO 50 I = 1,NPIX2
              DO 40 J = I1,I2
                  DATA(I)   = DATA(I) + Z(J,I)/RN
   40         CONTINUE
   50     CONTINUE
      END IF
C
C *** do the smooting
      IF (ISM.GT.1) THEN
         ILIS = 2*(ISM/2) + 1
         IOFF = ILIS/2
         DO 60 IX = 1, NPIX2
            AVE = 0.0
            NAV  = 0
            DO 61 ISX = 1,ILIS
               IXG = IX + ISX - IOFF - 1
               IF (IXG.LE.0 .OR. IXG.GT.NPIX2) THEN
                  GO TO 61
               ENDIF
               NAV = NAV + 1
               AVE = AVE + DATA(IXG)
   61       CONTINUE
            Y(IX) = AVE/FLOAT(NAV)
   60    CONTINUE

      ELSE
         DO 70 IX = 1, NPIX2
            Y(IX) = DATA(IX)
   70    CONTINUE
      ENDIF
C
C *** get the minimum and maximum
      YMAX   = -1.E30
      YMIN   = -YMAX
      DO 80 I = 1,NPIX2
          YMIN   = MIN(YMIN,Y(I))
          YMAX   = MAX(YMAX,Y(I))
   80 CONTINUE
      RETURN
      END



      SUBROUTINE SORT2(RA,RB,N)                     
C+++
C.IDENTIFICATION 
C.AUTHOR:   M.Rosa, ESO-Garching, 831105
C.PURPOSE:  Sort string of values into ascending sequence of values 
C.ALGORITM: The art of scientific computing
C           Press et al., Cambridge university Press, 1986   
C.USE:      CALL SORT2(XC,YC,N)                              
C.VERSION:  910115 RHW IMPLICIT NONE added
C---
C     
      IMPLICIT   NONE
      INTEGER    N
      REAL       RA(N)
      REAL       RB(N)                                                         
C
      INTEGER    I, IR
      INTEGER    J
      INTEGER    L
      REAL       RRA, RRB

      L  = N/2 + 1
      IR = N

10    CONTINUE
      IF (L.GT.1) THEN 
         L      = L - 1
         RRA    = RA(L)
         RRB    = RB(L)
      ELSE 
         RRA    = RA(IR)
         RRB    = RB(IR)
         RA(IR) = RA(1) 
         RB(IR) = RB(1) 
         IR     = IR - 1

         IF (IR.EQ.1) THEN
            RA(1) = RRA   
            RB(1) = RRB   
            RETURN        
         ENDIF
      ENDIF

      I = L
      J = L+L

20    CONTINUE
      IF (J.LE.IR) THEN 
         IF (J.LT.IR) THEN
            IF (RA(J).LT.RA(J+1)) THEN
               J = J + 1
            ENDIF
         ENDIF

         IF (RRA.LT.RA(J)) THEN
            RA(I) = RA(J) 
            RB(I) = RB(J) 
            I     = J 
            J     = J + J
         ELSE            
            J     = IR + 1
         ENDIF
         GO TO 20 
      ENDIF

      RA(I) = RRA 
      RB(I) = RRB
      GO TO 10
      END


      SUBROUTINE PLTBL(TID,NCOLUM,I1,I2,NROW)
C +++
C.PURPOSE:      Plots one or two columns of a table                           
C.AUTHOR:       Rein H. Warmels                                               
C.COMMENTS:     none                                                          
C.VERSION:      931103 RHW Createsd for environment document
C ---
      IMPLICIT    NONE
      INTEGER     TID               ! Table identifier
      INTEGER     NCOLUM            ! # of columns to be plotted 
      INTEGER     I1                ! index to first column
      INTEGER     I2                ! index to second column
      INTEGER     NROW              ! number of row
C
      INTEGER     NPMAX
      PARAMETER   (NPMAX=100000)
      INTEGER     IFIRST, I, ISTAT, IR, IAC
      INTEGER     STYPE, LTYPE
      REAL        VX, VY
      REAL        XPS(NPMAX), YPS(NPMAX)
      LOGICAL     IPLOT,ISEL,INULL
      CHARACTER   TEXT*80
C
 9001 FORMAT('*** FATAL: Maximum number of table entries is ',I8)
C
      IFIRST = 0
      IR     = 0
C
      DO 10 I = 1,NROW
         IPLOT  = .TRUE.
         CALL TBSGET(TID,I,ISEL,ISTAT)
         IF (ISEL) THEN            
            CALL TBRRDR(TID,I,1,I1,VX,INULL,ISTAT)
            IF (INULL) THEN
               IPLOT  = .FALSE.
            ENDIF
C 
            CALL TBRRDR(TID,I,1,I2,VY,INULL,ISTAT)
            IF (INULL) THEN 
               IPLOT  = .FALSE. 
            ENDIF
            IF (IPLOT) THEN
               IR      = IR + 1
               IF (IR.GT.NPMAX) THEN
                  WRITE (TEXT,9001) NPMAX
                  CALL STTPUT(TEXT,ISTAT)
                  CALL STSEPI
               ENDIF
               XPS(IR) = VX
               YPS(IR) = VY
            ENDIF
         ENDIF 
   10 CONTINUE 
C
      CALL PTKRDI('STYPE',1,IAC,STYPE)
      CALL PTKRDI('LTYPE',1,IAC,LTYPE)
      IF (LTYPE.EQ.0 .AND. STYPE.EQ.0) THEN 
         CALL STTPUT('*** FATAL: LTYPE and STYPE '//                   
     2               'both equal 0: NO PLOT',ISTAT)
         CALL PTCLOS()
         CALL STSEPI
      ELSE 
         CALL PTDATA(STYPE,LTYPE,0,XPS,YPS,0.0,IR)
      ENDIF
C
C *** end of the plotting
      RETURN
      END

C @(#)mcoadd.for	19.1 (ES0-DMD) 02/25/03 13:25:12
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
CI    SUBROUTINE ACOADD   !I
      PROGRAM MCOADD      !M
C++
C
C ACOADD.F Version 1.2
C
C Lucy co-addition, FFT version with acceleration option.
C
C This code is a preliminary and UNSUPPORTED implementation of
C an algorithm for combining images which have different PSFs.
C
C More details of the method are given in the ST-ECF Newsletter,
C 17, Feb 92, p10 and references given therein.
C
C This version uses the F77/VOS interface to IRAF parameters and
C data structures.
C
C Apart from the F77/VOS standard libraries the only other external
C dependencies are:
C
C fftetc.f - a set of FFT support routines including several
C            FFT codes.
C
C x_fcoadd.x - the one line of SPP needed for linking purposes.
C
C timtem.x - SPP code for image extension defaulting.
C
C Test version, Richard Hook, ST-ECF, Dec 1991
C               e-mail: rhook@eso.org (Internet)
C                       eso::rhook    (SPAN)
C                       rhook@dgaeso51.bitnet
C
C Note:
C
C This version may also be compiled and linked to run under MIDAS
C as well as IRAF. Essentailly all that is required is for the
C lines ending with !I are to be commented out and the comment
C characters removed from lines starting   . The result should
C then be linked with the additional library 'midint.f' which
C emulates (partially) the F77/VOS routines using MIDAS.
C
C History:
C
C Acceleration added, Richard Hook, ST-ECF, Mar 1992
C Double precision (partly) version, Mar 1992
C Starting image option added, Mar 1992
C Fully double precision version, May 1992
C Weighting error corrected, May 1992
C Additional checks added, May 1992
C Added residual information, June 1992
C Version 1.0, 2nd June 1992
C One D support, 4th June 1992
C Sub-sampling support added, 29th July 1992
C MIDAS compatible version, 7th August 1992
C Version 1.1 frozen, 16th September 1992
C Modified to use faster FFTs and remove powers of 2 restriction, 16/10/92
C Code made more portable (uppercase etc), 21/10/92
C--
      IMPLICIT NONE
                   
      INTEGER MAXIMS,USEOF
      PARAMETER (MAXIMS=10)
      PARAMETER (USEOF=-2)
                          
C Iraf global storage
CI    DOUBLE PRECISION MEMD(1) !I
CI    COMMON /MEM/MEMD         !I
                                 
C MIDAS global storage
      INTEGER MEMD(1)          !M
      COMMON /VMR/MEMD         !M
                                 
C Local variables
      INTEGER DATTYP(MAXIMS),NDIMS
      INTEGER DATPNT(MAXIMS),PSFPNT(MAXIMS)
      INTEGER ISTAT,NX,NY,N,M,NITER,IMSTAT,DIMS(2)
      INTEGER PSFFFT(MAXIMS),WORK,REST,W,DPS,NNEG
      INTEGER CORRFAC,PH(MAXIMS)
      INTEGER IDD(MAXIMS),IDP(MAXIMS),IDDC,IDCOAD(MAXIMS),FID
      DOUBLE PRECISION WEIGHT(MAXIMS),T,FMAX,PT,SCRATCH(4096)
      DOUBLE PRECISION RMSRES,RESMAX
      INTEGER IRMAX,JRMAX
      CHARACTER*80 DATA(MAXIMS),PSF(MAXIMS),FIM
      CHARACTER*80 COADDR,COADD(MAXIMS),DECON
      CHARACTER*80 CHARS
      CHARACTER*80 IMAGES,PSFS
      INTEGER NIM,NPSF
      INTEGER IMLD,PSFLD,IST,IEND
      INTEGER INR,I,L
      INTEGER NBX,NBY
      DOUBLE PRECISION DRV1,DRV2,DD1,DD2,HH,HHT
      DOUBLE PRECISION XLP,XL1,XL
      LOGICAL ACC
      LOGICAL VERBOSE
      LOGICAL FIRST
      LOGICAL SUBSAM
C++
   
C Start of code
               
      CALL STSPRO('MCOADD') !M
                              
C First get the boolean control logicals
      CALL UCLGSB('Verbose',VERBOSE,ISTAT)
      CALL UCLGSB('Accel',ACC,ISTAT)
                                    
C Announce the version
CI    IF(VERBOSE) CALL UMSPUT('+ ACOADD Version 1.2D (Dec. 1992)', !I
CI   :            1,0,ISTAT)                                      !I
      IF(VERBOSE) CALL UMSPUT('+ MCOADD Version 1.2D (Dec. 1992)', !M
     :            1,0,ISTAT)                                      !M
                            
C Initialise the template filename processing
      CALL UCLGST('Images',IMAGES,ISTAT)
      CALL TIMOTP(IMAGES,IMLD,ISTAT)
                                    
C Get the names of the input data images
      NIM=1
      IMSTAT=0
      DO I=1,MAXIMS+1
                               
C Check that there are not too many images
         IF(NIM.GT.MAXIMS) THEN
            CALL UMSPUT('Too many images specified',
     :                  1,0,ISTAT)
            GO TO 99
         ENDIF
              
         CALL TIMXTP(IMLD,DATA(NIM),IMSTAT)
         IF(IMSTAT.EQ.USEOF) GO TO 77
         CALL UIMOPN(DATA(NIM),1,IDD(NIM),ISTAT)
         IF(ISTAT.NE.0) THEN
               CALL UMSPUT('Unable to open data image',
     :                    1,0,ISTAT)
            GO TO 99
         ELSE
             IF(VERBOSE) CALL UMSPUT
     :         ('-Input Image: '//DATA(NIM),1,0,ISTAT)
         ENDIF
         NIM=NIM+1
      ENDDO
           
 77   CONTINUE
      NIM=NIM-1
               
      CALL TIMCTP(IMLD,ISTAT)
                             
C Open the list of PSF names
      CALL UCLGST('PSFs',PSFS,ISTAT)
      CALL TIMOTP(PSFS,PSFLD,ISTAT)
                                   
      NPSF=1
      IMSTAT=0
      DO I=1,MAXIMS+1
         CALL TIMXTP(PSFLD,PSF(NPSF),IMSTAT)
         IF(IMSTAT.EQ.USEOF) GO TO 78
         CALL UIMOPN(PSF(NPSF),1,IDP(NPSF),ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT('Unable to open PSF image',
     :                    1,0,ISTAT)
            GO TO 99
         ELSE
             IF(VERBOSE) CALL UMSPUT('-Input PSF: '//PSF(NPSF),
     :                   1,0,ISTAT)
         ENDIF
         NPSF=NPSF+1
      ENDDO
           
 78   CONTINUE
      NPSF=NPSF-1
                 
      CALL TIMCTP(PSFLD,ISTAT)
                              
C Do some checks on PSFs size, number etc
      IF(NPSF.NE.NIM) THEN
         CALL UMSPUT('Different number of PSFs and Images',
     :                 1,0,ISTAT)
         GO TO 99
      ELSE
         WRITE(CHARS,'(''-There are '',I4,'' images/PSFs'')') NIM
         IF(VERBOSE) CALL UMSPUT(CHARS,1,0,ISTAT)
                                                 
C In either case we set the acceleration to 1.0 as default
         XL=1.0D0
      ENDIF
           
C Get the shapes and sizes of the images
      CALL UIMGID(IDD(1),DATTYP(1),NDIMS,DIMS,ISTAT)
                                                    
      IF(NDIMS.EQ.1) THEN
         DIMS(2)=1
      ENDIF
           
      NX=DIMS(1)
      NY=DIMS(2)
                
C Check that the dimensions are EVEN, if not abort
      IF(MOD(NX,2).NE.0 .OR.
     :   (MOD(NY,2).NE.0 .AND. NY.NE.1)) THEN
         CALL UMSPUT('Image dimensions must be even',
     :               1,0,ISTAT)
         GO TO 99
      ENDIF

      DO N=1,NIM
        CALL UIMGID(IDD(N),DATTYP(N),NDIMS,DIMS,ISTAT)
                                                      
         IF(NDIMS.EQ.1) THEN
            DIMS(2)=1
         ENDIF
              
C Check they are OK
        IF(DIMS(1).NE.NX .OR.
     :     DIMS(2).NE.NY) THEN
           CALL UMSPUT('Data/PSF size/shape error',1,0,ISTAT)
           GO TO 99
        ENDIF
      ENDDO
           
C Same for the PSFs
      DO N=1,NIM
        CALL UIMGID(IDP(N),DATTYP(N),NDIMS,DIMS,ISTAT)
                                                      
         IF(NDIMS.EQ.1) THEN
            DIMS(2)=1
         ENDIF
              
C Check they are OK
        IF(NX.NE.DIMS(1) .OR.
     :     NY.NE.DIMS(2)) THEN
           CALL UMSPUT('Data/PSF size/shape error',1,0,ISTAT)
           GO TO 99
        ENDIF
      ENDDO
           
C Allocate space for the data
      DO N=1,NIM
        CALL UDMGET(NX*NY,7,DATPNT(N),ISTAT)
        IF(ISTAT.NE.0) THEN
           CALL UMSPUT(
     :        'Unable to allocate memory for data array',
     :                 1,0,ISTAT)
           GO TO 99
        ENDIF
             
C Read the data into the memory
        CALL UIGS2D(IDD(N),1,NX,1,NY,MEMD(DATPNT(N)),ISTAT)
        IF(ISTAT.NE.0) THEN
           CALL UMSPUT(
     :        'Unable to read in data input image',
     :                 1,0,ISTAT)
           GO TO 99
        ENDIF
             
C Check that the data is non-negative
        CALL ZAPNEG(MEMD(DATPNT(N)),NX,NY,NNEG)
        IF(NNEG.GT.0) THEN
             WRITE(CHARS,
     :       '(''Warning, data image #'',I2,
     :       '' contains'',I7,'' negative values, these'',
     :       '' have been zeroed.'')') N,NNEG
            CALL UMSPUT(CHARS,1,0,ISTAT)
        ENDIF
             
C Allocate space for the PSF
        CALL UDMGET(NX*NY,7,PSFPNT(N),ISTAT)
        IF(ISTAT.NE.0) THEN
           CALL UMSPUT(
     :        'Unable to allocate memory for PSF array',
     :                 1,0,ISTAT)
           GO TO 99
        ENDIF
             
C Read the PSF into the memory
        CALL UIGS2D(IDP(N),1,NX,1,NY,MEMD(PSFPNT(N)),ISTAT)
        IF(ISTAT.NE.0) THEN
           CALL UMSPUT(
     :        'Unable to read in PSF input image',
     :                 1,0,ISTAT)
           GO TO 99
        ENDIF
             
C Get working space arrays for the FFTs
        CALL UDMGET(NX*NY*2,7,PSFFFT(N),ISTAT)
        IF(ISTAT.NE.0) THEN
           CALL UMSPUT(
     :        'Unable to allocate memory for PSF FFT array',
     :                 1,0,ISTAT)
           GO TO 99
        ENDIF
      ENDDO
           
C Create the output data arrays
      CALL UCLGST('Decon',DECON,ISTAT)
      CALL UIMCRE(DECON,7,2,DIMS,IDDC,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :     'Unable to open output deconvolved image',
     :                 1,0,ISTAT)
         GO TO 99
      ELSE
         IF(VERBOSE) CALL UMSPUT(
     :     '-Created output (deconvolved) image: '//DECON,
     :     1,0,ISTAT)
      ENDIF
           
C Get the root name for the coadded output images
      CALL UCLGST('Coaddr',COADDR,ISTAT)
                                        
C Find the length of the string to avoid blanks in the names
      CALL LENSTR(COADDR,IST,IEND)
      L=IEND-IST+1
                                  
      DO N=1,NIM
         COADD(N)(1:L)=COADDR(IST:IEND)
         COADD(N)(L+1:L+1)='_'
         WRITE(COADD(N)(L+2:L+2),'(I1)') N
         CALL UIMCRE(COADD(N),7,2,DIMS,IDCOAD(N),ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT('Unable to open output coadded image',
     :                    1,0,ISTAT)
            GO TO 99
         ELSE
             IF(VERBOSE) CALL UMSPUT(
     :        '-Created output (coadded) image: '//COADD(N),
     :        1,0,ISTAT)
         ENDIF
       ENDDO
            
89    CONTINUE
              
C Get the sub-sampling values in X and Y and check that
C the X and Y dimensions are multiples of them.
      CALL UCLGSI('Xsubsam',NBX,ISTAT)
      CALL UCLGSI('Ysubsam',NBY,ISTAT)
                                      
      IF(MOD(NX,NBX).NE.0 .OR.
     :   MOD(NY,NBY).NE.0) THEN
         CALL UMSPUT('Warning - arrays are not multiples'//
     :               ' of the sub-sampling',1,0,ISTAT)
      ENDIF
           
      IF(NBX.NE.1 .OR. NBY.NE.1) THEN
         SUBSAM=.TRUE.
      ELSE
         SUBSAM=.FALSE.
      ENDIF
           
C Prepare the arrays for the FFT routine
C and do the FFTs of the PSF and rotated PSF
C
C At this point we also check that the PSFs are normalised to
C a total of 1 - if they aren't we warn the user but continue
      DO N=1,NIM
                
C First check for negative values, if there are any set them
C to zero
         CALL ZAPNEG(MEMD(PSFPNT(N)),NX,NY,NNEG)
         IF(NNEG.GT.0) THEN
             WRITE(CHARS,
     :       '(''Warning, PSF #'',I2,
     :       '' contained '',I7,'' negative values, these'',
     :       '' have been set to zero.'')') N,NNEG
            CALL UMSPUT(CHARS,1,0,ISTAT)
         ENDIF
              
         CALL TOTAL(MEMD(PSFPNT(N)),NX,NY,PT)
         IF(DABS(PT-1.0D0).GT.1.0E-5) THEN
            WRITE(CHARS,
     :       '(''Warning, PSF #'',I2,
     :       '' not normalised to a total of 1.0'',
     :       ''. Sum is '',F15.13)') N,PT
            CALL UMSPUT(CHARS,1,0,ISTAT)
         ENDIF
              
         CALL DFILL(MEMD(PSFPNT(N)),NX,NY,MEMD(PSFFFT(N)))
         CALL DFOURT(MEMD(PSFFFT(N)),DIMS,2,-1,0,SCRATCH)
                                                         
C At this point we have finished with the PSFs so they can be closed
C and the memory freed.
         CALL UIMCLO(IDP(N),ISTAT)
         CALL UDMFRE(PSFPNT(N),7,ISTAT)
      ENDDO
           
C Create other arrays needed, workspace etc
        CALL UDMGET(NX*NY,7,W,ISTAT)
        IF(ISTAT.NE.0) THEN
           CALL UMSPUT(
     :        'Unable to allocate memory for working array',
     :                 1,0,ISTAT)
           GO TO 99
        ENDIF
             
        CALL UDMGET(NX*NY*2,7,WORK,ISTAT)
        IF(ISTAT.NE.0) THEN
           CALL UMSPUT(
     :        'Unable to allocate memory for workspace array',
     :                 1,0,ISTAT)
           GO TO 99
        ENDIF
             
        CALL UDMGET(NX*NY,7,REST,ISTAT)
        IF(ISTAT.NE.0) THEN
           CALL UMSPUT(
     :        'Unable to allocate memory for restored array',
     :                 1,0,ISTAT)
           GO TO 99
        ENDIF
             
C PHI arrays and DPS are only needed in the accelerated case
       IF(ACC)THEN
        DO N=1,NIM
           CALL UDMGET(NX*NY,7,PH(N),ISTAT)
           IF(ISTAT.NE.0) THEN
              CALL UMSPUT(
     :           'Unable to allocate memory for Phi array',
     :                    1,0,ISTAT)
              GO TO 99
           ENDIF
         ENDDO
              
         CALL UDMGET(NX*NY,7,DPS,ISTAT)
         IF(ISTAT.NE.0) THEN
           CALL UMSPUT(
     :        'Unable to allocate memory for delta Psi array',
     :                 1,0,ISTAT)
           GO TO 99
         ENDIF
       ENDIF
            
C Get space for and initialise the correction factor array
       CALL UDMGET(NX*NY,7,CORRFAC,ISTAT)
       IF(ISTAT.NE.0) THEN
          CALL UMSPUT('Unable to create corr. fac. image',
     :                    1,0,ISTAT)
          GO TO 99
       ENDIF
            
C Calculate the weights - just the normalised total counts in each image
       T=0.0D0
       DO N=1,NIM
          CALL TOTAL(MEMD(DATPNT(N)),NX,NY,WEIGHT(N))
          T=T+WEIGHT(N)
       ENDDO
            
       DO N=1,NIM
          WRITE(CHARS,'(''-Image '',I2,'' Total counts: '',
     :         F10.1,'' Weight: '',F5.3)') N,WEIGHT(N),WEIGHT(N)/T
          IF(VERBOSE) CALL UMSPUT(CHARS,1,0,ISTAT)
          WEIGHT(N)=WEIGHT(N)/T
       ENDDO
            
C Check whether we have a first estimate image, if so try to get it
      CALL UCLGSB('First',FIRST,ISTAT)
      IF(FIRST) THEN
         CALL UCLGST('FirstIm',FIM,ISTAT)
                                         
         CALL UIMOPN(FIM,1,FID,ISTAT)
         IF(ISTAT.NE.0) THEN
           CALL UMSPUT(
     :        'Unable to open first estimate image file',
     :                 1,0,ISTAT)
           GO TO 99
         ELSE
            IF(VERBOSE) CALL UMSPUT
     :         ('-First Estimate Image: '//FIM,1,0,ISTAT)
         ENDIF
              
         CALL UIGS2D(FID,1,NX,1,NY,MEMD(REST),ISTAT)
      ELSE
          
C Prepare the first estimate - just a flat image with the same total flux
          CALL FILCON(MEMD(REST),NX,NY,T/DFLOAT(NX*NY))
      ENDIF
           
C Now we can start the iterative procedure
      CALL UCLGSI('Niter',NITER,ISTAT)
                                      
      DO N=1,NITER
                  
         WRITE(CHARS,'(''--Starting iteration '',I5)') N
         IF(VERBOSE) CALL UMSPUT(CHARS,1,0,ISTAT)
                                                 
C The correction array has to be initialised each time
        CALL FILCON(MEMD(CORRFAC),NX,NY,0.0D0)
                                              
        DO M=1,NIM
                  
C We must first multiply the current estimate by the weight
C to get something with the same total flux as the data 
         CALL MULC(MEMD(REST),NX,NY,WEIGHT(M),MEMD(W))
                                                      
C Convolve the current estimate with the PSF to give Phi
         IF(ACC) THEN
          CALL DCONV(MEMD(W),NX,NY,MEMD(WORK),
     :              MEMD(PSFFFT(M)),MEMD(PH(M)),1)
         ELSE
          CALL DCONV(MEMD(W),NX,NY,MEMD(WORK),
     :              MEMD(PSFFFT(M)),MEMD(W),1)
         ENDIF
              
C Calculate and display the residual information to assist closeness
C of fit assessment
         IF(VERBOSE) THEN
          IF(ACC) THEN
             CALL RESINF(MEMD(PH(M)),MEMD(DATPNT(M)),
     :                    NX,NY,RMSRES,RESMAX,IRMAX,JRMAX)
          ELSE
             CALL RESINF(MEMD(W),MEMD(DATPNT(M)),
     :                    NX,NY,RMSRES,RESMAX,IRMAX,JRMAX)
          ENDIF
               
          WRITE(CHARS,'(''--Image #'',I2,'' RMS residual: '',D10.4,
     :                '' Max residual of '',D10.4,
     :                '' at ('',I4'','',I4,'')'')')
     :             M,RMSRES,RESMAX,IRMAX,JRMAX
          CALL UMSPUT(CHARS,1,0,ISTAT)
         ENDIF
              
C If we are sub-sampling we must do so here.
      IF(SUBSAM) THEN
         IF(ACC) THEN
            CALL REBIN(MEMD(PH(M)),NX,NY,NBX,NBY)
         ELSE
            CALL REBIN(MEMD(W),NX,NY,NBX,NBY)
         ENDIF
      ENDIF
C Divide the data by this convolution
         IF(ACC) THEN
          CALL DIVIDE(MEMD(DATPNT(M)),MEMD(PH(M)),NX,NY,MEMD(W))
         ELSE
          CALL DIVIDE(MEMD(DATPNT(M)),MEMD(W),NX,NY,MEMD(W))
         ENDIF
              
C Convolve again, this time by the rotated PSF
         CALL DCONV(MEMD(W),NX,NY,MEMD(WORK),
     :             MEMD(PSFFFT(M)),MEMD(W),-1)
                                              
C Add the correction factor so deduced into the overall correction
C factor with the correct weighting
         CALL ADDW(MEMD(W),WEIGHT(M),NX,NY,MEMD(CORRFAC))
        ENDDO
             
C In the accelerated case calculate the maximum possible multiplication
C factor which is consistent with the non-negativity contraint
        IF(ACC) THEN
           CALL FIMAXF(MEMD(REST),MEMD(CORRFAC),NX,NY,FMAX)
           WRITE(CHARS,
     :   '(''--Max. speed-up possible'',
     :     '' within non-negativity (fmax): '',
     :      F10.5)') FMAX
           IF(VERBOSE) CALL UMSPUT(CHARS,1,0,ISTAT)
                                                   
C Work out the increment in Psi
           CALL PHINC(MEMD(REST),MEMD(CORRFAC),NX,NY,MEMD(DPS))
                                                               
C We now start the iteration loop for the Newton-Raphson search
                                                               
           IF(VERBOSE) THEN
             CALL UMSPUT('---Starting search for optimal speed'//
     :                 '-up factor...',1,0,ISTAT)
           ENDIF
                
           XL1=1.0D0
           INR=0
                
145        CONTINUE
           XLP=XL1
                  
           DRV1=0.0D0
           DRV2=0.0D0
           HHT=0.0D0
                    
           DO M=1,NIM
                     
C Convolve the increment in psi to get the increment in phi
              CALL DCONV(MEMD(DPS),NX,NY,MEMD(WORK),
     :                  MEMD(PSFFFT(M)),MEMD(W),1)
                                                  
C Multiply by the weight again to conserve the flux total
C (this is again a new addition)
              CALL MULC(MEMD(W),NX,NY,WEIGHT(M),MEMD(W))
                                                        
C If we are sub-sampling we must do so here again.
      IF(SUBSAM) THEN
         CALL REBIN(MEMD(W),NX,NY,NBX,NBY)
      ENDIF
           
C Calculate the derivatives needed for Newton-Raphson
              CALL DERIVS(MEMD(DATPNT(M)),MEMD(PH(M)),MEMD(W),
     :                    NX,NY,XL1,DD1,DD2,HH)
                                               
              HHT=HH+HHT
                        
C Add in the derivs with the correct weights
              DRV1=DRV1+DD1*WEIGHT(M)
              DRV2=DRV2+DD2*WEIGHT(M)
           ENDDO
                
           INR=INR+1
                    
C Calculate next estimate
           XL1=XL1-DRV1/DRV2
                            
           WRITE(CHARS,
     :       '(''---Iteration: '',I3,'' Speed up: '',F9.4,
     :         '' Log.Likelihood: '',
     :         D15.8)') INR,XL1,HHT
           IF(VERBOSE)  CALL UMSPUT(CHARS,1,0,ISTAT)
                                                    
C Check for negative likelihood gradient
           IF(INR.EQ.1 .AND.DRV1.LT.0.0D0) THEN
              CALL UMSPUT('Error - drv1<0 for inr=1',1,0,ISTAT)
              CALL UMSPUT('No acceleration this time round',1,0,
     :                    ISTAT)
              XL1=1.0D0
              GO TO 148
           ENDIF
                
C Check for speed-up too big for non-negativity
C In which case set the speed-up-factor at 70% of the max
C permitted factor
           IF(XL1.GT.FMAX) THEN
              XL1=1.0D0+0.7D0*(FMAX-1.0D0)
              IF(VERBOSE) CALL UMSPUT(
     :        '---Avoiding non-negativity violation'//
     :        ' (accel=1.0+0.7*(fmax-1))',
     :                    1,0,ISTAT)
              GO TO 148
           ENDIF
                
           IF(ABS(XL1-XLP).GT.0.02D0) GO TO 145
                                               
148        CONTINUE
           XL=XL1
           WRITE(CHARS,'(''---Speed up factor used: '',
     :           F10.5)') XL
           IF(VERBOSE) CALL UMSPUT(CHARS,1,0,ISTAT)
        ENDIF
             
C Multiply the last estimate by the total correction factor from all the
C images and hence obtain the next estimate
C We also remormalise at this stage to prevent accumulating
C normalisation errors
        CALL UPCORR(MEMD(REST),MEMD(CORRFAC),XL,NX,NY,
     :                MEMD(REST),T,VERBOSE)
      ENDDO
           
C Write out the results, deconvolved and then the coadded images
C which are the convolutions with the relavant PSFs
       IF(VERBOSE)
     :  CALL UMSPUT('-Writing output deconvolved image: '//DECON
     :              ,1,0,ISTAT)
                               
       CALL UIPS2D(IDDC,1,NX,1,NY,MEMD(REST),ISTAT)
       CALL UIMCLO(IDDC,ISTAT)
                              
       DO N=1,NIM
          CALL DCONV(MEMD(REST),NX,NY,MEMD(WORK),
     :              MEMD(PSFFFT(N)),MEMD(W),1)
                                              
          IF(VERBOSE)
     :     CALL UMSPUT('-Writing output co-added image: '//
     :                 COADD(N),1,0,ISTAT)
                                          
          CALL UIPS2D(IDCOAD(N),1,NX,1,NY,MEMD(W),ISTAT)
          CALL UIMCLO(IDCOAD(N),ISTAT)
       ENDDO
            
99     CONTINUE
               
C Close all the images
      DO N=1,NIM
         CALL UIMCLO(IDD(N),ISTAT)
      ENDDO
           
C Free all the dynamic arrays
      DO N=1,NIM
         CALL UDMFRE(DATPNT(N),7,ISTAT)
         CALL UDMFRE(PSFFFT(N),7,ISTAT)
         IF(ACC) CALL UDMFRE(PH(N),7,ISTAT)
      ENDDO
           
      CALL UDMFRE(CORRFAC,7,ISTAT)
      CALL UDMFRE(WORK,7,ISTAT)
      CALL UDMFRE(REST,7,ISTAT)
      CALL UDMFRE(W,7,ISTAT)
      IF(ACC) CALL UDMFRE(DPS,7,ISTAT)
                                      
C Close down MIDAS
      CALL STSEPI    !M
                       
      END
         
      SUBROUTINE MULC(IN1,NX,NY,F,OUT)
C
C Just multiply one array by a constant
C
      IMPLICIT NONE
                   
      INTEGER NX,NY,I,J
      DOUBLE PRECISION IN1(NX,NY),OUT(NX,NY),F
                                              
      DO J=1,NY
         DO I=1,NX
            OUT(I,J)=IN1(I,J)*F
         ENDDO
      ENDDO
           
      RETURN
      END
         
      SUBROUTINE UPCORR(IN1,IN2,XL,NX,NY,OUT,T,VERBOSE)
C
C Apply the update, with a speed up factor
C
C Also renormalise to prevent accumulating errors
C
      IMPLICIT NONE
                   
      INTEGER NX,NY,I,J,ISTAT,NNEG
      DOUBLE PRECISION IN1(NX,NY),IN2(NX,NY)
      DOUBLE PRECISION T,V,OUT(NX,NY),XL,TOTAL
      CHARACTER*80 CHARS
      LOGICAL VERBOSE
                     
      TOTAL=0.0D0
      NNEG=0
            
C Work out the total counts allowing for negative number
C corrections
      DO J=1,NY
         DO I=1,NX
            V=IN1(I,J)*(1.0D0+XL*(IN2(I,J)-1.0D0))
            TOTAL=TOTAL+V
            IF(V.LT.0.0D0) THEN
               TOTAL=TOTAL-V
               OUT(I,J)=0.0D0
               NNEG=NNEG+1
            ELSE
               OUT(I,J)=V
            ENDIF
         ENDDO
      ENDDO
           
C Do the renormalisation
      DO J=1,NY
         DO I=1,NX
            OUT(I,J)=OUT(I,J)*T/TOTAL
         ENDDO
      ENDDO
           
      WRITE(CHARS,'(''--Renormalising restored image'',
     :'', (Factor: '',F20.18,'')'')')
     : T/TOTAL
      IF(VERBOSE) CALL UMSPUT(CHARS,1,0,ISTAT)
                                              
      IF(NNEG.GT.0) THEN
         WRITE(CHARS,'(''--A total of '',I8,
     :         '' Negative points set to zero.'')') NNEG
         IF(VERBOSE) CALL UMSPUT(CHARS,1,0,ISTAT)
      ENDIF
           
      RETURN
      END
         
      SUBROUTINE DIVIDE(IN1,IN2,NX,NY,OUT)
C
C Just divide one array by another of the same size
C
      IMPLICIT NONE
                   
      INTEGER NX,NY,I,J
      DOUBLE PRECISION IN1(NX,NY),IN2(NX,NY),OUT(NX,NY)
                                                       
      DO J=1,NY
         DO I=1,NX
            IF(IN2(I,J).EQ.0.0D0) THEN
               OUT(I,J)=0.0D0
            ELSE
               OUT(I,J)=IN1(I,J)/IN2(I,J)
            ENDIF
         ENDDO
      ENDDO
           
      RETURN
      END
         
      SUBROUTINE FILCON(DATA,NX,NY,VAL)
C
C Fill up an array with a constant value
C
      IMPLICIT NONE
                   
      INTEGER NX,NY,I,J
      DOUBLE PRECISION DATA(NX,NY),VAL
                                      
      DO J=1,NY
         DO I=1,NX
            DATA(I,J)=VAL
          ENDDO
      ENDDO
           
      RETURN
      END
         
      SUBROUTINE TOTAL(DATA,NX,NY,TOT)
C
C Add up all elements in an image
C
      IMPLICIT NONE
                   
      INTEGER NX,NY,I,J
      DOUBLE PRECISION DATA(NX,NY),TOT
                                      
      TOT=0.0D0
      DO J=1,NY
         DO I=1,NX
             TOT=TOT+DATA(I,J)
         ENDDO
      ENDDO
           
      RETURN
      END
         
      SUBROUTINE ADDW(DATA,W,NX,NY,OUT)
C
C Add an image, weighted, to another
C
      IMPLICIT NONE
                   
      INTEGER NX,NY,I,J
      DOUBLE PRECISION DATA(NX,NY),W,OUT(NX,NY)
                                               
      DO J=1,NY
         DO I=1,NX
            OUT(I,J)=DATA(I,J)*W+OUT(I,J)
         ENDDO
      ENDDO
           
      RETURN
      END
         
      SUBROUTINE FIMAXF(PS,CF,NX,NY,FMAX)
C
C Find the maximum multiplying factor possible for acceleration
C which is consistent with the non-negativity contraint.
C
      IMPLICIT NONE
                   
      INTEGER NX,NY,I,J
      DOUBLE PRECISION PS(NX,NY),CF(NX,NY),FMAX,RT
                                                  
      FMAX=1.0D10
                 
      DO J=1,NY
         DO I=1,NX
             IF(PS(I,J).LT.1.0D-10 .OR.
     :          CF(I,J).EQ.1.0) GO TO 88
             RT=-1.0D0/(CF(I,J)-1.0D0)
             IF(RT.LT.0.0D0) GO TO 88
             IF(RT.LT.FMAX) FMAX=RT
 88          CONTINUE
          ENDDO
      ENDDO
           
      RETURN
      END
         
      SUBROUTINE DERIVS(PHT,PH,DPH,NX,NY,XL,DD1,DD2,HH)
C
C Calculate derivatives needed in Newton-Raphson search for
C optimal acceleration factor.
C
C Based on code by Leon Lucy
C
      IMPLICIT NONE
                   
      INTEGER NX,NY
      DOUBLE PRECISION PHT(NX,NY),PH(NX,NY),DPH(NX,NY)
      DOUBLE PRECISION XL
      DOUBLE PRECISION DD1,DD2,HH
                                 
      INTEGER I,J
      DOUBLE PRECISION DM,AA,DDPH,DPHT
                                      
      DD1=0.0D0
      DD2=0.0D0
      HH=0.0D0
              
C NB here we are ignoring negative values of dm - these
C may represent pathological situations which should be checked
C out.
      DO J=1,NY
         DO I=1,NX
            DDPH=DPH(I,J)
            DM=PH(I,J)+XL*DDPH
            IF(DM.GT.1.0D-20) THEN
               DPHT=PHT(I,J)
               AA=DDPH/DM
               DD1=DD1+DPHT*AA
               DD2=DD2-DPHT*AA*AA
               HH=HH+DPHT*DLOG(DM)
            ENDIF
         ENDDO
      ENDDO
           
      RETURN
      END
         
      SUBROUTINE PHINC(PS,CF,NX,NY,DPS)
C
C Calculate the increment in Psi, this is only needed in the
C accelerated case
C
      IMPLICIT NONE
                   
      INTEGER NX,NY
      DOUBLE PRECISION PS(NX,NY),CF(NX,NY),DPS(NX,NY)
      INTEGER I,J
                 
      DO J=1,NY
         DO I=1,NX
            DPS(I,J)=PS(I,J)*(CF(I,J)-1.0D0)
         ENDDO
      ENDDO
           
      RETURN
      END
         
      SUBROUTINE LENSTR(STRING,I1,I2)
C
C Find the start and end of a string
C
      IMPLICIT NONE
                   
      CHARACTER*(*) STRING
      INTEGER I,I1,I2
      LOGICAL IN
                
      IN=.FALSE.
                
      DO I=1,LEN(STRING)
         IF(STRING(I:I).NE.' ' .AND.
     :      .NOT.IN) THEN
           I1=I
           IN=.TRUE.
         ENDIF
              
         IF(STRING(I:I).EQ.' ' .AND.
     :      IN) THEN
            I2=I-1
            GO TO 99
         ENDIF
      ENDDO
           
99    CONTINUE
              
      RETURN
      END
         
      SUBROUTINE RESINF(IM1,IM2,NX,NY,RMSRES,RESMAX,
     :                   IRMAX,JRMAX)
C
C Calculate the RMS residual between two images and the
C largest residual.
C
      IMPLICIT NONE
                   
      INTEGER NX,NY,IRMAX,JRMAX
      DOUBLE PRECISION RMSRES,RESMAX,IM1(NX,NY),IM2(NX,NY)
                                                          
      INTEGER I,J
      DOUBLE PRECISION RES,T
                            
      T=0.0D0
      RESMAX=0.0D0
                  
      DO J=1,NY
         DO I=1,NX
            RES=IM1(I,J)-IM2(I,J)
            T=T+RES*RES
            IF(DABS(RES).GT.DABS(RESMAX)) THEN
               RESMAX=RES
               IRMAX=I
               JRMAX=J
            ENDIF
         ENDDO
      ENDDO
           
      RMSRES=DSQRT(T/DBLE(NX*NY))
                                 
      RETURN
      END
         
      SUBROUTINE REBIN(IN,NX,NY,NBX,NBY)
C
C Re-bin an array by replacing groups of pixels by their
C average. This is needed in the sub-sampling case.
C Flux is conserved and the operation is done 'in place'
C
      IMPLICIT NONE
                   
      INTEGER NX,NY,NBX,NBY
      DOUBLE PRECISION IN(NX,NY)
                                
      INTEGER I,J,K,L
      DOUBLE PRECISION T,DN
                           
      DN=DBLE(NBX*NBY)
                      
      DO J=1,NY,NBY
         DO I=1,NX,NBX
            T=0D0
            DO L=1,NBY
               DO K=1,NBX
                  T=T+IN(I+K-1,J+L-1)
               ENDDO
            ENDDO
            DO L=1,NBY
               DO K=1,NBX
                  IN(I+K-1,J+L-1)=T/DN
               ENDDO
            ENDDO
         ENDDO
      ENDDO
           
      RETURN
      END
         
      SUBROUTINE ZAPNEG(DATA,NX,NY,NNEG)
C
C Find negative points in an array and set them to zero
C
      IMPLICIT NONE
                   
      INTEGER NX,NY,NNEG
      DOUBLE PRECISION DATA(NX,NY)
      INTEGER I,J
                 
      NNEG=0
            
      DO J=1,NY
         DO I=1,NX
            IF(DATA(I,J).LT.0.0D0) THEN
               DATA(I,J)=0.0D0
               NNEG=NNEG+1
            ENDIF
         ENDDO
      ENDDO
           
      RETURN
      END

C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION        ISDLOW.FOR
C.AUTHOR:               J.D.PONZ  ESA-VILSPA        
C.KEYWORDS              IUE, GO FORMAT, LOW DISPERSION SPECTRUM
C.PURPOSE
C  \begin{TeX}
C  Reads low dispersion spectra and stores the 
C  information into a MIDAS table.
C
C  The routine performs the following functions:
C  \begin{enumerate}
C  \item Handles the file header (ISDFHD)
C  \item Creates the MIDAS table file (TBTINI)
C  \item Read wavelength record  and decodes the values
C  \item Creates a column to store the wavelengths (TBCINI)
C  \item Writes the wavelengths into the table column (TBEWRR)
C  \item  Read epsilon record and decodes the values
C  \item Creates a column to store the epsilon flags (TBCINI)
C  \item Writes the values into the table column (TBEWRI)
C  \item For each extracted spectrum (GROSS, BACKGROUND, NET, ABS. FLUX):
C        \begin{itemize}
C        \item Read  record (ISTREA) and decodes the values
C        \item  Creates a column to store the values (TBCINI)
C        \item Writes the values into the table column (TBEWRR)
C        \end{itemize}
C  \item Writes IUE specific descriptors (ISTDES)
C  \item Closes table file (TBTCLO)
C  \end{enumerate}
C \end{TeX}
C
C.LANGUAGE:             F77 
C.COMMENTS
C \begin{TeX}
C The following extensions are used:
C  \begin{itemize}
C     \item IMPLICIT NONE
C     \item INCLUDE statement
C     \item long variable names
C     \item Underscore character
C  \end{itemize}
C.VERSION: 1.0  INITIAL CODING  24 JUN 1994
C------------------------------------------------------------------
      SUBROUTINE ISDLOW(CHANL,BUFF,FILE,DSKFMT,
     .                  NRECO,NBYTE,DSPFLG,IOFF,STATUS)
C
      IMPLICIT NONE
      INTEGER       CHANL             ! IN: tape channel number
      CHARACTER*(*) BUFF              ! IN: buffer with the ascii header
      CHARACTER*(*) FILE              ! IN: file name
      INTEGER       DSKFMT            ! IN: disk format (-1 no file)
      INTEGER       NRECO             ! IN: number of records
      INTEGER       NBYTE             ! IN: number of bytes per record
      INTEGER       DSPFLG            ! IN: display flag
      INTEGER       STATUS            ! OUT: status
C
      INTEGER I, LEN, NROW, LAM0, TID, IROW, IVAL, IVALUE,IOFF
      INTEGER JG, KG, JB, KB, JN, KN, JF, KF, IC
      INTEGER    BBUFF(1024)
      INTEGER    IBUFF(1024)
      REAL    VALUE, SCG, SCB, SCN, SCF
      CHARACTER*16 LLABEL,ELABEL,GLABEL,BLABEL,NLABEL,FLABEL
      CHARACTER*16 LUNIT,EUNIT,GUNIT,BUNIT,NUNIT,FUNIT
      CHARACTER*8  LFORM,EFORM,GFORM,BFORM,NFORM,FFORM
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      EQUIVALENCE (BBUFF,IBUFF)
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      DATA LLABEL/'WAVELENGTH'/,ELABEL/'EPSILON'/
      DATA GLABEL/'GROSS'/,     BLABEL/'BACKGROUND'/
      DATA NLABEL/'NET'/,       FLABEL/'FLUX'/
      DATA LUNIT/'ANGSTROM'/, EUNIT/'UNITLESS'/
      DATA GUNIT/'FN'/,       BUNIT/'FN'/
      DATA NUNIT/'FN'/,       FUNIT/'ERG/CM2/A'/
      DATA LFORM/'F8.3'/, EFORM/'I5'/
      DATA GFORM/'E12.4'/
      DATA BFORM/'E12.4'/
      DATA NFORM/'E12.4'/
      DATA FFORM/'E12.4'/
C
      STATUS = 0
C
C ... decode full header, print it and put info in common area
C
      CALL ISDFHD(CHANL,BUFF,DSPFLG,IOFF,STATUS)
      IF (STATUS.NE.0) RETURN
      IF (DSKFMT.LT.0) RETURN     ! only displays the header
C
C ... reads record zero
C
      CALL ISDRHW(CHANL,BBUFF,NBYTE,LEN,IOFF,STATUS)
      IF ((NBYTE+IOFF).NE.LEN .OR. STATUS.NE.0) RETURN
C
C ... extracts useful info
C
      NROW = IBUFF(303)
      LAM0 = IBUFF(103)
      JG   = IBUFF(23)
      KG   = IBUFF(24)
      JB   = IBUFF(27)
      KB   = IBUFF(28)
      JN   = IBUFF(31)
      KN   = IBUFF(32)
      JF   = IBUFF(35)
      KF   = IBUFF(36)
      SCG  = JG/(2.**KG)
      SCB  = JB/(2.**KB)
      SCN  = JN/(2.**KN)
      SCF  = JF/(2.**KF)
C
C ... create the table file
C
      CALL TBTINI(FILE,F_TRANS,F_O_MODE,10,NROW,TID,STATUS)
      IF (STATUS.NE.0) RETURN
C
C ... scaled wavelengths
C
      CALL ISDRHW(CHANL,BBUFF,NBYTE,LEN,IOFF,STATUS)
      IF ((NBYTE+IOFF).NE.LEN .OR. STATUS.NE.0) RETURN
      CALL TBCINI(TID,D_R4_FORMAT,1,LFORM,LUNIT,LLABEL,IC,STATUS)
      IROW = 1
      IVAL = 3
      DO 10 I = 5, NBYTE, 2
          VALUE      = LAM0+0.2*IBUFF(IVAL)    
          CALL TBEWRR(TID,IROW,IC,VALUE,STATUS)
          IVAL = IVAL + 1
          IROW = IROW + 1
          IF (IROW.GT.NROW) GOTO 15
 10   CONTINUE
C
C ... epsilons
C
 15   CALL ISDRHW(CHANL,BBUFF,NBYTE,LEN,IOFF,STATUS)
      IF ((NBYTE+IOFF).NE.LEN .OR. STATUS.NE.0) RETURN
      CALL TBCINI(TID,D_I4_FORMAT,1,EFORM,EUNIT,ELABEL,IC,STATUS)
      IROW = 1
      IVAL = 3
      DO 20 I = 5, NBYTE, 2
          IVALUE     = IBUFF(IVAL)    
          CALL TBEWRI(TID,IROW,IC,IVALUE,STATUS)
          IVAL = IVAL + 1
          IROW = IROW + 1
          IF (IROW.GT.NROW) GOTO 25
 20   CONTINUE
C
C ... GROSS
C
 25   CALL ISDRHW(CHANL,BBUFF,NBYTE,LEN,IOFF,STATUS)
      IF ((NBYTE+IOFF).NE.LEN .OR. STATUS.NE.0) RETURN
      CALL TBCINI(TID,D_R4_FORMAT,1,GFORM,GUNIT,GLABEL,IC,STATUS)
      IROW = 1
      IVAL = 3
      DO 30 I = 5, NBYTE, 2
          VALUE      = IBUFF(IVAL)*SCG
          CALL TBEWRR(TID,IROW,IC,VALUE,STATUS)
          IVAL = IVAL + 1
          IROW = IROW + 1
          IF (IROW.GT.NROW) GOTO 35
 30   CONTINUE
C
C ... BACKGROUND
C
 35   CALL ISDRHW(CHANL,BBUFF,NBYTE,LEN,IOFF,STATUS)
      IF ((NBYTE+IOFF).NE.LEN .OR. STATUS.NE.0) RETURN
      CALL TBCINI(TID,D_R4_FORMAT,1,BFORM,BUNIT,BLABEL,IC,STATUS)
      IROW = 1
      IVAL = 3
      DO 40 I = 5, NBYTE, 2
          VALUE      = IBUFF(IVAL)*SCB
          CALL TBEWRR(TID,IROW,IC,VALUE,STATUS)
          IVAL = IVAL + 1
          IROW = IROW + 1
          IF (IROW.GT.NROW) GOTO 45
 40   CONTINUE
C
C ... NET
C
 45   CALL ISDRHW(CHANL,BBUFF,NBYTE,LEN,IOFF,STATUS)
      IF ((NBYTE+IOFF).NE.LEN .OR. STATUS.NE.0) RETURN
      CALL TBCINI(TID,D_R4_FORMAT,1,NFORM,NUNIT,NLABEL,IC,STATUS)
      IROW = 1
      IVAL = 3
      DO 50 I = 5, NBYTE, 2
          VALUE      = IBUFF(IVAL)*SCN    
          CALL TBEWRR(TID,IROW,IC,VALUE,STATUS)
          IVAL = IVAL + 1
          IROW = IROW + 1
          IF (IROW.GT.NROW) GOTO 55
 50   CONTINUE
C
C ... FLUX
C
 55   CALL ISDRHW(CHANL,BBUFF,NBYTE,LEN,IOFF,STATUS)
      IF ((NBYTE+IOFF).NE.LEN .OR. STATUS.NE.0) RETURN
      CALL TBCINI(TID,D_R4_FORMAT,1,FFORM,FUNIT,FLABEL,IC,STATUS)
      IROW = 1
      IVAL = 3
      DO 60 I = 5, NBYTE, 2
          VALUE      = IBUFF(IVAL)*SCF
          CALL TBEWRR(TID,IROW,IC,VALUE,STATUS)
          IVAL = IVAL + 1
          IROW = IROW + 1
          IF (IROW.GT.NROW) GOTO 65
 60   CONTINUE
C
C ... write label descriptors
C
 65   CONTINUE
      CALL ISTDES(TID,BUFF,STATUS)
      CALL TBTCLO(TID,STATUS)
      RETURN
      END

C @(#)fittable.for	19.1 (ES0-DMD) 02/25/03 13:18:46
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.2  ESO-FORTRAN Conversion, AA  14:17 - 19 NOV 1989
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION:
C         PROGRAM fittable
C
C.PURPOSE
C
C  Copy fit file into table format for editing
C
C.KEYWORDS
C
C ARITHMETIC OPERATS, TABLES.
C
C.ALGORITHM
C
C USE TABLE INTERFACE ROUTINES
C
C-----------------------------------------------------------
C
      PROGRAM FITTBL
      IMPLICIT NONE
C
C      CHARACTER*72  LINE
      CHARACTER*60  FILENA, TABLE
      CHARACTER*80 SPEC
      CHARACTER*60  FUNC, PARM
      CHARACTER*16  LABEL1, LABEL2, UNIT
      CHARACTER*10  FORM
      INTEGER       KUN, KNUL, STAT, IC, TID, NROW, I, II
      INTEGER       INDEX, NW, NC, IFILE, J
      INTEGER       MADRID(1)
C
      INCLUDE      'MID_INCLUDE:ST_DEF.INC'
      INCLUDE      'MID_INCLUDE:FITI.INC'
      INCLUDE      'MID_INCLUDE:FITC.INC'
      COMMON/VMR/MADRID
      INCLUDE      'MID_INCLUDE:ST_DAT.INC'
      DATA          FILENA/'   '/
      DATA          LABEL1/'FUNCTIONS   '/
      DATA          LABEL2/'PARAMETERS  '/
      DATA          UNIT/'             '/
      DATA          FORM/'A60    '/
C
C ... GET INTO MIDAS
C
      CALL STSPRO('TOPERTBL')
      CALL FITBL
C
C ... GET COMMAND FORM ENVIRONMENT
C
      CALL STKRDC('IN_A',1,1,60,I,FILENA,KUN,KNUL,STAT)
      CALL STKRDI('INPUTI',1,1,I,IFILE,KUN,KNUL,STAT)
C
C ... INITIALIZE FIT FILE
C
      IF (IFILE .EQ. 0) THEN
           CALL STTPUT(' Info: New fit file ', STAT)
           CALL FTINI1(STAT)
      ELSE
           CALL STTPUT(' Info: Fit file already exists ', STAT)
           CALL FTINIT(FILENA, STAT)
      ENDIF
C
C ... INITIALIZE TABLE FILE
C
      I     = INDEX(FILENA,'.')
      IF (I .EQ. 0) I = INDEX(FILENA,' ')
      I     = I - 1
      TABLE = FILENA(1:I)//'_fit '
      CALL STKWRC('OUT_A',1,TABLE,1,60,KUN,STAT)
      NC    = 60
      NROW  = 20
      NW    = NC/2
      CALL TBTINI(TABLE, F_TRANS, F_O_MODE, NW, NROW, TID, STAT)
      CALL TBCINI(TID, D_C_FORMAT, NC, FORM, UNIT, LABEL1, IC, STAT)
      CALL TBCINI(TID, D_C_FORMAT, NC, FORM, UNIT, LABEL2, IC, STAT)
C
C ... INITIALIZE TABLE DATA
C
      DO 10 I = 1, NROW
         IF (I .LE. FZNFUN ) THEN
             CALL FTRDFN(I, SPEC, STAT)
             II   = INDEX(SPEC,')')
             FUNC = SPEC(1:II)
             II   = II + 1
             DO 5 J = II, 80
                IF (SPEC(J:J) .NE. ' ') GOTO 6
5            CONTINUE
C
C ... END OF STRUCTURED CODE
C
6            PARM = SPEC(J:) 
C
C
         ELSE
             FUNC = ' '
             PARM = ' '
         ENDIF
         CALL TBEWRC(TID, I, 1, FUNC, STAT)
         CALL TBEWRC(TID, I, 2, PARM, STAT)
10    CONTINUE
      CALL TBTCLO(TID, STAT)
      FZMAPPED = 0
      IF (IFILE .EQ. 0) THEN
           CALL FTEXT1(FILENA, STAT)
      ELSE
           CALL FTEXIT(FILENA, STAT)
      ENDIF
C
C ... EXIT FROM MIDAS
C
      CALL STSEPI
      END
C      BLOCK DATA
C      INCLUDE      'MID_INCLUDE:FITI.INC'
C      INCLUDE      'MID_INCLUDE:FITC.INC'
C      INCLUDE      'MID_INCLUDE:FITD.INC'
C      END

C @(#)functions.for	16.1 (ESO-DMD) 06/19/01 15:22:45
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE IFILL(A,NAXIS,NPIX,START,STEP,RC,NO,RMIN,RMAX)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.COPYRIGHT: Copyright (c) 1988 European Southern Observatory,
C                                         all rights reserved
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: K.Banse
C
C.IDENTIFICATION
C  subroutine IFILL		version 2.30	881028
C             IMFUNC			2.00	881028
C             GAUSS			2.05	881028
C  K. Banse                        ESO - Garching
C  source code on FUNCTIONS.FOR
C
C.KEYWORDS
C  images, masks
C
C.PURPOSE
C  create a MIDAS image or mask frame
C
C.ALGORITHM
C  use MIDAS interfaces
C
C.INPUT/OUTPUT
C  call as IFILL(A,NAXIS,NPIX,START,STEP,RC,NO,RMIN,RMAX)
C          IMFUNC(METHOD,A,NAXIS,NPIX,START,STEP,RC,RMIN,RMAX)
C          GAUSS(A,NAXIS,NPIX,START,STEP,RC,NO,RMIN,RMAX)
C          RANDOM(METHOD,IROOT,A,NAXIS,NPIX,RC,RMIN,RMAX)
C      
C.VERSIONS
C  2.50 (IFILL)    split for 1-dim and 2-dim option
C  2.10 (IMFUNCT)  add method=3 for circle
C  3.00		work on precision for pixels (IMFILL)
C 
C  010802		last modif
C      
C--------------------------------------------------
C      
      IMPLICIT NONE
C      
      REAL         A(*),RC(*),RMIN,RMAX
C 
      DOUBLE PRECISION START(*),STEP(*)
      DOUBLE PRECISION XSTART,YSTART,XSTEP,YSTEP
      DOUBLE PRECISION WX,WY,CY,TY,FYY,PIX
C      
      INTEGER      NAXIS,NPIX(*),NO
      INTEGER      IOFF,N,NDIM,NX,NY
      INTEGER      XDIM,YDIM
C      
C -----
C      
C  branch according to dimension of image
C      
C -----
C      
C  for NAXIS > 2 only constant option supported ...
C      
      IF (NAXIS.GT.2) THEN
         NDIM = 1
         DO 100 N=1,NAXIS
            NDIM = NPIX(N) * NDIM
100      CONTINUE
C      
         DO 150 N=1,NDIM
            A(N) = RC(1)
150      CONTINUE
         RMIN = RC(1)
         RMAX = RMIN
         RETURN
      ENDIF
C      
C  for NAXIS = 2 do it elsewhere...
      IF (NAXIS.EQ.2) GOTO 10000
C      
C  here we handle NAXIS = 1: that is the polynomial a + bx + cxx
C      
      XDIM = NPIX(1)
      XSTART = START(1)
      XSTEP = STEP(1)
C      
C  branch according to no. of coefficients (= order of polynomial + 1)
      IF (NO.GT.3) NO = 3
      GOTO (1000,2000,3000),NO
C      
C  just constant
1000  DO 1100 N=1,XDIM
         A(N) = RC(1)
1100  CONTINUE
      RMIN = RC(1)
      RMAX = RMIN
      RETURN
C      
C  p(x) = a + bx
2000  WX = XSTART
      DO 2100 NX=1,XDIM
         PIX = RC(1) + RC(2)*WX
         IF (RMIN.GT.PIX) RMIN = PIX
         IF (RMAX.LT.PIX) RMAX = PIX
         A(NX) = PIX
         WX = WX + XSTEP
2100  CONTINUE
      RETURN
C      
C  p(x) = a + bx + cxx
3000  WX = XSTART 
      DO 3100 NX=1,XDIM
         PIX = RC(1) + RC(2)*WX + RC(3)*WX*WX
         IF (RMIN.GT.PIX) RMIN = PIX
         IF (RMAX.LT.PIX) RMAX = PIX
         A(NX) = PIX
         WX = WX + XSTEP
3100  CONTINUE
      RETURN
C      
C  here we handle NAXIS = 2, i.e. the polynomial a + bx + cy + dxy + exx + fyy
C      
10000 XDIM = NPIX(1)
      YDIM = NPIX(2)
      XSTART = START(1)
      YSTART = START(2)
      XSTEP = STEP(1)
      YSTEP = STEP(2)
      IOFF = 0
C      
C  branch according to no. of coefficients (= order of polynomial + 1)
      GOTO (11000,12000,13000,14000,15000,16000),NO
C      
C  just constant
11000 NDIM = 1
      DO 11010 N=1,NAXIS
         NDIM = NPIX(N) * NDIM
11010 CONTINUE
C      
      DO 11020 N=1,NDIM
         A(N) = RC(1)
11020 CONTINUE
      RMIN = RC(1)
      RMAX = RMIN
      RETURN
C      
C  p(x,y) = a + bx
12000 DO 12500 NY=1,YDIM
         WX = XSTART
         DO 12100 NX=1,XDIM
            PIX = RC(1) + RC(2)*WX
            IF (RMIN.GT.PIX) RMIN = PIX
            IF (RMAX.LT.PIX) RMAX = PIX
            A(NX+IOFF) = PIX
            WX = WX + XSTEP
12100    CONTINUE
         IOFF = IOFF + XDIM
12500 CONTINUE
      RETURN
C      
C  p(x,y) = a + bx + cy
13000 WY = YSTART
      DO 13500 NY=1,YDIM
         CY = WY * RC(3)
         WX = XSTART 
         DO 13100 NX=1,XDIM
            PIX = RC(1) + RC(2)*WX + CY
            IF (RMIN.GT.PIX) RMIN = PIX
            IF (RMAX.LT.PIX) RMAX = PIX
            A(NX+IOFF) = PIX
            WX = WX + XSTEP
13100    CONTINUE
         WY = WY + YSTEP
         IOFF = IOFF + XDIM
13500 CONTINUE
      RETURN
C      
C  p(x,y) = a + bx + cy + dxy
14000 WY = YSTART
      DO 14500 NY=1,YDIM
         CY = WY * RC(3)
         TY = WY * RC(4)
         WX = XSTART 
         DO 14100 NX=1,XDIM
            PIX = RC(1) + RC(2)*WX + CY + TY*WX
            IF (RMIN.GT.PIX) RMIN = PIX
            IF (RMAX.LT.PIX) RMAX = PIX
            A(NX+IOFF) = PIX
            WX = WX + XSTEP
14100    CONTINUE
         WY = WY + YSTEP
         IOFF = IOFF + XDIM
14500 CONTINUE
      RETURN
C      
C  p(x,y) = a + bx + cy + dxy + exx
15000 WY = YSTART
      DO 15500 NY=1,YDIM
         CY = WY * RC(3)
         TY = WY * RC(4)
         WX = XSTART 
         DO 15100 NX=1,XDIM
            PIX = RC(1) + RC(2)*WX + CY + WX*(TY + RC(5)*WX)
            IF (RMIN.GT.PIX) RMIN = PIX
            IF (RMAX.LT.PIX) RMAX = PIX
            A(NX+IOFF) = PIX
            WX = WX + XSTEP
15100    CONTINUE
         IOFF = IOFF + XDIM
         WY = WY + YSTEP
15500 CONTINUE
      RETURN
C      
C  p(x,y) = a + bx + cy + dxy + exx + fyy
16000 WY = YSTART
      DO 16500 NY=1,YDIM
         CY = WY * RC(3)
         TY = WY * RC(4)
         FYY = WY * WY * RC(6)
         WX = XSTART
         DO 16100 NX=1,XDIM
            PIX = RC(1) + RC(2)*WX + CY + WX*(TY + RC(5)*WX) + FYY
            IF (RMIN.GT.PIX) RMIN = PIX
            IF (RMAX.LT.PIX) RMAX = PIX
            A(NX+IOFF) = PIX
            WX = WX + XSTEP
16100    CONTINUE
         IOFF = IOFF + XDIM
         WY = WY + YSTEP
16500 CONTINUE
      RETURN
C      
      END

      SUBROUTINE IMFUNC(METHOD,A,NAXIS,NPIX,START,STEP,RC,RMIN,RMAX)
C      
      IMPLICIT NONE
C 
      REAL      A(*),RC(*),RMIN,RMAX
C 
      DOUBLE PRECISION XSTEP,XSTART,YSTEP,YSTART
      DOUBLE PRECISION CX,CY,CPA,SPA,CDI,SC,AMP
      DOUBLE PRECISION X1,Y1,R,PIX,DX,DY,FACT
      DOUBLE PRECISION START(*),STEP(*)
C 
      INTEGER   METHOD,NAXIS,NPIX(*)
      INTEGER   XDIM,YDIM,IPAIR,NH
      INTEGER   I,NX,NY,IRC
C 
      DATA  FACT /0.0174532925/                   !FACT = PI / 180.
C      
C  initialize + branch according to method
      XDIM = NPIX(1)
      XSTART = START(1)
      XSTEP = STEP(1)
C 
      IF (NAXIS.GE.2) THEN                  !but we only fill xy-plane...
         YDIM = NPIX(2)
         YSTART = START(2)
         YSTEP = STEP(2)
      ELSE
         YDIM = 1
         YSTART = 0.
         YSTEP = 1.
      ENDIF
C      
      IPAIR = 1 - MOD(XDIM,2)                  !get center coords.
      NH = (XDIM-1)/2      
      CX = XSTART + NH*XSTEP + IPAIR*XSTEP*0.5
      IPAIR = 1 - MOD(YDIM,2)      
      NH = (YDIM-1)/2      
      CY = YSTART + NH*YSTEP + IPAIR*YSTEP*0.5
C      
      GOTO (1000,2000,3000,4000,5000,6000,7000,8000),METHOD
C      
C +++++
C  build exponential disk
C +++++
C      
1000  CPA = COS(RC(3)*FACT)
      SPA = SIN(RC(3)*FACT)
      CDI = COS(RC(4)*FACT)
      SC = -1./RC(2)
      AMP = RC(1)
C      
C  now loop
      I = 1
      DY = YSTART - CY
      DO 1500 NY=1,YDIM
         DX = XSTART - CX
         DO 1100 NX=1,XDIM
            X1 = SPA*DX - CPA*DY
            Y1 = CDI * (CPA*DX + SPA*DY)
            R = DSQRT(X1*X1 + Y1*Y1)
            PIX = AMP * EXP(R*SC)
            IF (RMIN.GT.PIX) RMIN = PIX
            IF (RMAX.LT.PIX) RMAX = PIX
            A(I) = PIX
            I = I + 1
            DX = DX + XSTEP
1100     CONTINUE
         DY = DY + YSTEP
1500  CONTINUE
      RETURN
C      
C +++++
C  build frame according to radius law
C +++++
C      
2000  CPA = COS(RC(3)*FACT)
      SPA = SIN(RC(3)*FACT)
      CDI = COS(RC(4)*FACT)
      SC = 1./RC(2)
      AMP = RC(1)
C      
C  now loop
      I = 1
      DY = YSTART - CY
      DO 2500 NY=1,YDIM
         DX = XSTART - CX
         DO 2100 NX=1,XDIM
            X1 = SPA*DX - CPA*DY
            Y1 = CDI * (CPA*DX + SPA*DY)
            R = DSQRT(X1*X1 + Y1*Y1)
            PIX = AMP * 10.**(-3.33*(R*SC)**0.25)
            IF (RMIN.GT.PIX) RMIN = PIX
            IF (RMAX.LT.PIX) RMAX = PIX
            A(I) = PIX
            I = I + 1
            DX = DX + XSTEP
2100     CONTINUE
         DY = DY + YSTEP
2500  CONTINUE
      RETURN
C      
C +++++
C  build frame with circle in the center
C +++++
C      
3000  AMP = RC(1) * RC(1)                  !radius squared...
C      
C  now loop
      I = 1
      DY = YSTART
      DO 3500 NY=1,YDIM
         DX = XSTART 
         DO 3100 NX=1,XDIM
            SC =  ((DX-CX)*(DX-CX)) + ((DY-CY)*(DY-CY))
            IF (SC.LE.AMP) THEN
             PIX = RC(2)
            ELSE
             PIX = RC(3)
            ENDIF
            IF (RMIN.GT.PIX) RMIN = PIX
            IF (RMAX.LT.PIX) RMAX = PIX
            A(I) = PIX
            I = I + 1
            DX = DX + XSTEP
3100     CONTINUE
         DY = DY + YSTEP
3500  CONTINUE
      RETURN
C      
C +++++
C  build frame with ellips in the center
C +++++
C      
4000  CPA = 1./(RC(1)*RC(1))                  !get 1/a**2, 1/b**2
      SPA = 1./(RC(2)*RC(2))
C      
C  now loop
      I = 1
      DY = YSTART
      DO 4500 NY=1,YDIM
         DX = XSTART 
         DO 4100 NX=1,XDIM
            SC =  ( (DX-CX)*(DX-CX)*CPA ) + ( (DY-CY)*(DY-CY)*SPA )
            IF (SC.LE.1.) THEN
               PIX = RC(3)
            ELSE
               PIX = RC(4)
            ENDIF
            IF (RMIN.GT.PIX) RMIN = PIX
            IF (RMAX.LT.PIX) RMAX = PIX
            A(I) = PIX
            I = I + 1
            DX = DX + XSTEP
4100     CONTINUE
         DY = DY + YSTEP
4500  CONTINUE
      RETURN
C      
C +++++
C  build Butterworth lowpass filter
C +++++
C      
5000  IRC = NINT(RC(2)) * 2                  !get 2n
      RC(1) = 1./RC(1)                       !get 1/Do
      IF ( (IRC.EQ.2) .AND.
     +     ((ABS(RC(3))-1.).LE.10.E-12) ) GOTO 5500            !simple filter
C      
C  now loop
      I = 1
      DY = YSTART
      DO 5200 NY=1,YDIM
         DX = XSTART 
         DO 5100 NX=1,XDIM
            CPA = (DX-CX)
            SPA = (DY-CY)
            SC =  DSQRT( CPA*CPA + SPA*SPA )           !get distance from center
            PIX = 1. + ( RC(3) * (SC*RC(1))**IRC )
            PIX = 1./PIX
            IF (RMIN.GT.PIX) RMIN = PIX
            IF (RMAX.LT.PIX) RMAX = PIX
            A(I) = PIX
            I = I + 1
            DX = DX + XSTEP
5100     CONTINUE
         DY = DY + YSTEP
5200  CONTINUE
      RETURN
C      
C  here we loop through the simple version
5500  I = 1
      DY = YSTART
      DO 5700 NY=1,YDIM
         DX = XSTART 
         DO 5600 NX=1,XDIM
            CPA = (DX-CX)
            SPA = (DY-CY)
            SC =  DSQRT( CPA*CPA + SPA*SPA )           !get distance from center
            SC = SC * RC(1)
            PIX = 1. / ( 1. + (SC * SC) )
            IF (RMIN.GT.PIX) RMIN = PIX
            IF (RMAX.LT.PIX) RMAX = PIX
            A(I) = PIX
            I = I + 1
            DX = DX + XSTEP
5600     CONTINUE
         DY = DY + YSTEP
5700  CONTINUE
      RETURN
C      
C +++++
C  build exponential lowpass filter
C +++++
C      
6000  IRC = NINT(RC(2))                   !get n
      RC(1) = 1./RC(1)                    !get 1/Do
      IF ( (IRC.EQ.1) .AND.
     +     ((ABS(RC(3))-1.).LE.10.E-12) ) GOTO 6500            !simple filter
C      
C  now loop
      I = 1
      DY = YSTART
      DO 6200 NY=1,YDIM
         DX = XSTART 
         DO 6100 NX=1,XDIM
            CPA = (DX-CX)
            SPA = (DY-CY)
            SC =  DSQRT( CPA*CPA + SPA*SPA )           !get distance from center
            PIX = DEXP ( -(RC(3) * (SC*RC(1))**IRC) )
            IF (RMIN.GT.PIX) RMIN = PIX
            IF (RMAX.LT.PIX) RMAX = PIX
            A(I) = PIX
            I = I + 1
            DX = DX + XSTEP
6100     CONTINUE
         DY = DY + YSTEP
6200  CONTINUE
      RETURN
C      
C  here we loop through the simple version
6500  I = 1
      DY = YSTART
      DO 6700 NY=1,YDIM
         DX = XSTART 
         DO 6600 NX=1,XDIM
            CPA = (DX-CX)
            SPA = (DY-CY)
            SC =  DSQRT( CPA*CPA + SPA*SPA )           !get distance from center
            PIX = DEXP ( -(SC*RC(1)) )
            IF (RMIN.GT.PIX) RMIN = PIX
            IF (RMAX.LT.PIX) RMAX = PIX
            A(I) = PIX
            I = I + 1
            DX = DX + XSTEP
6600     CONTINUE
         DY = DY + YSTEP
6700  CONTINUE
      RETURN
C      
C +++++
C  build Butterworth highpass filter
C +++++
C      
7000  IRC = NINT(RC(2)) * 2                  !get 2n
      AMP = MIN(ABS(XSTEP),ABS(YSTEP))       !take minimum of steps
      IF ( (IRC.EQ.2) .AND.
     +     ((ABS(RC(3))-1.).LE.10.E-12) ) GOTO 7500            !simple filter
C      
C  now loop
      I = 1
      DY = YSTART
      DO 7200 NY=1,YDIM
         DX = XSTART 
         DO 7100 NX=1,XDIM
            CPA = (DX-CX)
            SPA = (DY-CY)
            SC =  DSQRT( CPA*CPA + SPA*SPA )           !get distance from center
            IF (SC.GE.AMP) THEN
               PIX = 1. + ( RC(3) * (RC(1)/SC)**IRC )
               PIX = 1.0D0/PIX
            ELSE
               PIX = 0.0D0
            ENDIF
            IF (RMIN.GT.PIX) RMIN = PIX
            IF (RMAX.LT.PIX) RMAX = PIX
            A(I) = PIX
            I = I + 1
            DX = DX + XSTEP
7100     CONTINUE
         DY = DY + YSTEP
7200  CONTINUE
      RETURN
C      
C  here we loop through the simple version
7500  I = 1
      DY = YSTART
      DO 7700 NY=1,YDIM
         DX = XSTART 
         DO 7600 NX=1,XDIM
            CPA = (DX-CX)
            SPA = (DY-CY)
            SC =  DSQRT( CPA*CPA + SPA*SPA )           !get distance from center
            IF (SC.GE.AMP) THEN
               PIX = 1. + ( RC(1) / SC )
               PIX = 1.0D0/PIX
            ELSE
               PIX = 0.0D0
            ENDIF
            IF (RMIN.GT.PIX) RMIN = PIX
            IF (RMAX.LT.PIX) RMAX = PIX
            A(I) = PIX
            I = I + 1
            DX = DX + XSTEP
7600     CONTINUE
         DY = DY + YSTEP
7700  CONTINUE
      RETURN
C      
C +++++
C  build exponential highpass filter
C +++++
C      
8000  IRC = NINT(RC(2))                     !get n
      AMP = MIN(ABS(XSTEP),ABS(YSTEP))      !take minimum of steps
      IF ( (IRC.EQ.1) .AND.
     +     ((ABS(RC(3))-1.).LE.10.E-12) ) GOTO 8500            !simple filter
C      
C  now loop
      I = 1
      DY = YSTART
      DO 8200 NY=1,YDIM
         DX = XSTART 
         DO 8100 NX=1,XDIM
            CPA = (DX-CX)
            SPA = (DY-CY)
            SC =  DSQRT( CPA*CPA + SPA*SPA )           !get distance from center
            IF (SC.GE.AMP) THEN
               PIX = DEXP ( -(RC(3) * (RC(1)/SC)**IRC) )
            ELSE
               PIX = 0.
            ENDIF
            IF (RMIN.GT.PIX) RMIN = PIX
            IF (RMAX.LT.PIX) RMAX = PIX
            A(I) = PIX
            I = I + 1
            DX = DX + XSTEP
8100     CONTINUE
         DY = DY + YSTEP
8200  CONTINUE
      RETURN
C      
C  here we loop through the simple version
8500  I = 1
      DY = YSTART
      DO 8700 NY=1,YDIM
         DX = XSTART 
         DO 8600 NX=1,XDIM
            CPA = (DX-CX)
            SPA = (DY-CY)
            SC =  DSQRT( CPA*CPA + SPA*SPA )           !get distance from center
            IF (SC.GE.AMP) THEN
               PIX = DEXP ( -(RC(1)/SC) )
            ELSE
               PIX = 0.
            ENDIF
            IF (RMIN.GT.PIX) RMIN = PIX
            IF (RMAX.LT.PIX) RMAX = PIX
            A(I) = PIX
            I = I + 1
            DX = DX + XSTEP
8600     CONTINUE
         DY = DY + YSTEP
8700  CONTINUE
      RETURN
C      
      END

      SUBROUTINE GAUSS(A,NAXIS,NPIX,START,STEP,RC,NO,RMIN,RMAX)
C      
      IMPLICIT NONE
C 
      REAL         A(*),RC(*),RMIN,RMAX
C 
      DOUBLE PRECISION PI2,WX,WY,WXX,WYY,W1,W2,F1,PIX
      DOUBLE PRECISION X,Y
      DOUBLE PRECISION START(*),STEP(*)
C 
      INTEGER      NAXIS,NPIX(*),NO
      INTEGER      NOFF,N,NX,NY
C      
      DATA   PI2 /6.2831853071/                   ! PI2 = 2 * PI
C      
C  branch according to NAXIS
      GOTO (1000,2000),NAXIS
C      
C  1-dim gaussian function:
C  f(x) = 1/(sigma*sqrt(2pi)) * exp(-(x-mean)**2/2sigma**2
C 
1000  W1 = DSQRT(PI2)
      W2 = 1./(2.*RC(2)*RC(2))
      F1 = 1./(RC(2)*W1)
      WX = START(1) - RC(1)                !do 1st pixel twice for MIN, MAX
      WXX = WX * WX
      PIX = F1 * DEXP(-WXX*W2)
      RMIN = PIX
      RMAX = RMIN
C 
      X = START(1)
      DO 1100, N=1,NPIX(1)
         WX = X - RC(1)
         WXX = WX * WX
         PIX = F1 * DEXP(-WXX*W2)
         IF (RMIN.GT.PIX) RMIN = PIX
         IF (RMAX.LT.PIX) RMAX = PIX
         A(N) = PIX
         X = X + STEP(1)
1100  CONTINUE
      RETURN
C      
C  2-dim gaussian function: 
C  f(x,y) = 1/(xsigma*ysigma*2pi) * 
C           exp(-(x-xmean)**2/2xsigma**2 + -(y-ymean)**2/2ysigma**2)
C 
2000  F1 = 1./ (RC(2)*RC(4)*PI2)
      W1 = 1./ (2. * RC(2) * RC(2))
      W2 = 1./ (2. * RC(4) * RC(4))
C 
      WX = START(1) - RC(1)                    !do 1st pixel twice for MIN, MAX
      WXX = WX * WX
      WY = START(2) - RC(3)
      WYY = WY * WY
      PIX = F1 * DEXP(-(WXX*W1 + WYY*W2))
      RMIN = PIX
      RMAX = RMIN
C 
      NOFF = 0
      Y = START(2)
C 
      DO 2200, NY=1,NPIX(2)
         WY = Y - RC(3)
         WYY = WY * WY
         X = START(1)
C 
         DO 2100 NX=1,NPIX(1)
            WX = X - RC(1)
            WXX = WX * WX
            PIX = F1 * DEXP(-(WXX*W1 + WYY*W2))
            IF (RMIN.GT.PIX) RMIN = PIX
            IF (RMAX.LT.PIX) RMAX = PIX
            A(NX+NOFF) = PIX
            X = X + STEP(1)
2100     CONTINUE
C 
         Y = Y + STEP(2)
         NOFF = NOFF + NPIX(1)
2200  CONTINUE
C 
      RETURN
      END

C @(#)franz1d.for	19.1 (ES0-DMD) 02/25/03 13:17:31
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FRANZ1(X,NP,PARAM,Y1,DERIV)                                   
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                  
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  18:01 - 21 DEC 1987                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C--------------------------------------------------------------                 
C**********************************************                                 
C                                                                               
C      IMPLICIT NONE                                                            
C 1-DIM FRANZ-FUNCTION  18 MAR 1986                                             
C                                                                               
C**********************************************                                 
C                                                                               
C Author: O.-G. Richter, ESO Garching                                           
C                                                                               
      INTEGER NP
      REAL X
      DOUBLE PRECISION Y1,PARAM(NP),DERIV(NP)                                   
C                                                                               
      DOUBLE PRECISION A,A1,B,B1,B2,C,C1,D                                      
C                                                                               
      A      = X - PARAM(2)                                                     
      A1     = DABS(A)                                                          
      B      = A1/PARAM(3)                                                      
      B1     = 1.0D0 + B                                                        
      B2     = DLOG(B1)                                                         
      C      = A1/PARAM(5)                                                      
      C1     = 1.0D0 + C                                                        
      D      = (PARAM(5)+A1)/ (PARAM(3)+A1)                                     
C                                                                               
      DERIV(1) = B1** (-PARAM(4)*C1)                                            
      Y1     = PARAM(1)*DERIV(1)                                                
C                                                                               
      A1     = Y1*PARAM(4)/PARAM(5)                                             
      DERIV(2) = DSIGN(A1* (B2+D),A)                                            
      DERIV(3) = A1*B*D                                                         
      DERIV(4) = -Y1*C1*B2                                                      
      DERIV(5) = A1*C*B2                                                        
C                                                                               
      RETURN                                                                    
                                                                                
      END                                                                       

C @(#)sbgnet.for	19.1 (ES0-DMD) 02/25/03 13:25:39
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine SBGNET          version 1.0          880503
C  A. Kruszewski              Warsaw U. Obs.
C                                     1.1          881114 
C.INPUT/OUTPUT
C  input arguments
C  A          real*4 array           image buffer
C  JAPY       integer*4 array        pointers to image lines
C  IBUF       integer*4 array        limits of frame buffer
C  IXYU       integer*4 array        limits of used area
C  JS         integer*4              segment number
C  JSTART     integer*4              first searched line
C  JEND       integer*4              last searched line
C  INET       integer*4 array        net X-coordinates
C  SKYNET     real*4 array           sky background net
C  NHSEG      integer*4              number of horizontal segments
C  CRMD       real*4 array           controls subroutine mode
C  IHED       integer*4              subarray halfedge
C  output arguments
C  SKYNET     real*4 array           sky background net
C-----------------------------------------------------------------------
      SUBROUTINE SBGNET(A, JAPY, IBUF, IXYU, JS, JSTART,
     &                 JEND, inet0, INET, 
     +                 skynet0, SKYNET, NHSEG, CRMD, IHED)
C
      IMPLICIT  NONE
C
      INTEGER   NHSEG
      INTEGER   IBUF(4) , IFULL , IHED , II
      INTEGER   IXYU(4) , JAPY(1) , JEND
      INTEGER   JS , JSTART , INET0, INET(NHSEG)
C
      REAL   A(1) , CRMD(3) , SKYNET0(2),skynet(2,NHSEG)
C
C ******      Fill first line of SKYNET.
C
      write(*,12345) jstart,jend,nhseg,ihed,crmd(1),crmd(2),crmd(3)
12345 format('jstart, jend, nhseg, ihed = ',4i4,' crmd = ',3f8.3)

      IFULL = 1
      IF ( JS .GT. 1 ) THEN
            SKYNET0(1) = SKYNET0(2)
          DO 10 II = 1 , NHSEG
            SKYNET(1,II) = SKYNET(2,II)
   10          CONTINUE

      ELSE
          CALL SKYMOD( A , JAPY , IBUF , INET0 ,
CKB     &                  JSTART , CRMD , IHED , IFULL , SKYNET(1,0) )
     &                  JSTART , CRMD , IHED , IFULL , SKYNET0(1) )
          DO 20 II = 1 , NHSEG
            CALL SKYMOD( A , JAPY , IBUF , INET(II) ,
     &                  JSTART , CRMD , IHED , IFULL , SKYNET(1,II) )
   20          CONTINUE
        ENDIF
C
C ******      Fill second line of SKYNET.
C
      CALL SKYMOD( A , JAPY , IBUF , INET0 , JEND ,
     &                        CRMD , IHED , IFULL , SKYNET0(2) )
      DO 30 II = 1 , NHSEG
          CALL SKYMOD( A , JAPY , IBUF , INET(II) , JEND ,
     &                        CRMD , IHED , IFULL , SKYNET(2,II) )
   30      CONTINUE
C
      RETURN
C
      END

C @(#)precess.for	19.1 (ES0-DMD) 02/25/03 14:27:54
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C @(#)precess.for	19.1 (ESO-IPG) 14:27:54 02/25/03
        PROGRAM PRECES
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION: PRECESS.FOR
C.PURPOSE: Precess RA and DEC coordinates in table created by CREATE/OPTABLE
C.         command.
C.AUTHOR:  Alessandra Gemmo           Padova Department of Astronomy
C.VERSION: 910826 AG Creation
C------------------------------------------------------------------------------
        IMPLICIT NONE
C
C ***
C
        INTEGER    MADRID(1)
        INTEGER    NRINP
        INTEGER    NCINP
        INTEGER    NROUT
        INTEGER    NCOUT
        INTEGER    NCPAR1
        PARAMETER  (NCOUT=15)
        PARAMETER  (NCPAR1=2)
        PARAMETER  (NROUT=300)
        INTEGER    ISTAT,IAC
        INTEGER    KUN,KNUL
        INTEGER    NACINP,NARINP,NSINP
        INTEGER    OUTTYP,OUTCOL(2),COLNUM(2)
        INTEGER    TIDINP
        INTEGER    I1,I2
C
C ***
C
        DOUBLE PRECISION    RARAD,DECRAD
        DOUBLE PRECISION    PRA,PDEC,EQUI0,EQUI1
        DOUBLE PRECISION    PRARAD,PDECRA
        DOUBLE PRECISION    RA,DEC,PI
C
C ***
C
        CHARACTER*80        STRING(10)
        CHARACTER*60        INPFIL
        CHARACTER*16        LABEL1(NCPAR1),OUTLAB
        CHARACTER*16        UNIT1(NCPAR1),OUTUNI
        CHARACTER*16        OUTFOR
        CHARACTER*16        FORMR8(2)
C
C ***
C
        LOGICAL             NULL
C
C ***
C
        INCLUDE             'MID_INCLUDE:ST_DEF.INC'
        COMMON              /VMR/MADRID
        INCLUDE             'MID_INCLUDE:ST_DAT.INC'
C
        DATA                LABEL1/'PRA     ','PDEC    '/
        DATA                UNIT1 /'HOURS   ','DEGREES '/
C
C ***
C
        DATA                FORMR8/'F12.9','F12.9'/
        DATA                PI/3.14159265358979D0/
C
C *** start the code
C
        CALL STSPRO('OPTAB')
C
C *** get the input table
C
        CALL STKRDC('INPUTFI',1,1,60,IAC,INPFIL,KUN,KNUL,ISTAT)
C
C *** open input table
C
        CALL TBTOPN(INPFIL,F_IO_MODE,TIDINP,ISTAT)
C
C *** get information about the input table
C
        CALL TBIGET(TIDINP,NCINP,NRINP,NSINP,NACINP,NARINP,ISTAT)
        IF(NRINP.EQ.0)THEN         !no rows in table
          STRING(1) = '*** FATAL: There are no data in input table'
          CALL STETER(9,STRING(1))
        ENDIF
C
C *** initialize PRA and PDEC columns
C
        DO I1=1,NCPAR1
          OUTTYP = D_R8_FORMAT
          OUTFOR = FORMR8(I1)
          OUTUNI = UNIT1(I1)
          OUTLAB = LABEL1(I1)
          CALL TBCINI(TIDINP,OUTTYP,1,OUTFOR,OUTUNI,
     2                       OUTLAB,OUTCOL(I1),ISTAT)
        ENDDO
C
C *** fill in PRA and PDEC columns
C
        CALL STKRDD('EQUINOX',1,1,IAC,EQUI0,KUN,KNUL,ISTAT)
        CALL STKRDD('EQUINOX',2,1,IAC,EQUI1,KUN,KNUL,ISTAT)
C
C *** read in RA and DEC columns
C
        DO I2=1,NRINP
          CALL TBLSER(TIDINP,'RA',COLNUM(1),ISTAT)
          CALL TBERDD(TIDINP,I2,COLNUM(1),RA,NULL,ISTAT)
C
          CALL TBLSER(TIDINP,'DEC',COLNUM(2),ISTAT)
          CALL TBERDD(TIDINP,I2,COLNUM(2),DEC,NULL,ISTAT)
C
          RARAD  = RA*1.5D1*(PI/1.8D2)
          DECRAD = DEC*(PI/1.8D2)
C
C *** compute precession
C
          CALL PRE(RARAD,DECRAD,PRARAD,PDECRA,EQUI0,EQUI1)
C
          PRA    = PRARAD*(1.8D2/PI)/15.
          PDEC   = PDECRA*(1.8D2/PI)
C
          CALL TBEWRD(TIDINP,I2,OUTCOL(1),PRA,ISTAT)
          CALL TBEWRD(TIDINP,I2,OUTCOL(2),PDEC,ISTAT)
        ENDDO
C
C *** close the table
C
        CALL TBTCLO(TIDINP,ISTAT)
C
C *** over and out
C
        CALL STSEPI
        END
C------------------------------------------------------------------------------
      SUBROUTINE PRE(A0,D0,A1,D1,EQX0,EQX1)
C
C ... calculate general precession for two given epochs
C
C ... References: STUMPFF P.,ASTRON. ASTROPHYS. SUPPL. 41, P. 1 (1980)
C ...             EXPLAN. SUPPL. ASTRON. EPHEREMERIS, P. 28 (1961)
C
      IMPLICIT NONE             !REAL*8 (A-H,O-Z)
C
      DOUBLE PRECISION A0,D0,D1,EQX0,EQX1
      DOUBLE PRECISION DT0,DT,DTS,DTC,DC1900,DC1M2
      DOUBLE PRECISION DC1,DC2,DC3,DC4,DC5,DC6,DC7,DC8,DC9
      DOUBLE PRECISION DZED,DZETA,DCSAR,DTHETA
      DOUBLE PRECISION PI,SINR,COSR,A1,R
C
      DATA DCSAR/4.848136812D-6/,DC1900/1900.0D0/,DC1M2/0.01D0/,
     * DC1/2304.25D0/,DC2/1.396D0/,DC3/0.302D0/,DC4/0.018D0/,
     * DC5/0.791D0/,DC6/2004.683D0/,DC7/-0.853D0/,DC8/-0.426D0/,
     * DC9/-0.042D0/
C
      PI = 3.1415926535897928
C
C ... first determine the precession angles zeta, z and theta
C
      DT0=(EQX0-DC1900)*DC1M2
      DT=(EQX1-EQX0)*DC1M2
      DTS=DT*DT
      DTC=DTS*DT
      DZETA=((DC1+DC2*DT0)*DT+DC3*DTS+DC4*DTC)*DCSAR
      DZED=DZETA + DC5*DTS*DCSAR
      DTHETA=((DC6+DC7*DT0)*DT+DC8*DTS+DC9*DTC)*DCSAR
C
C ... with these and A0,D0 compute the precessed coordinates A1,D1
C
      D1 = ASIN(DCOS(DTHETA)*DSIN(D0)+DSIN(DTHETA)*DCOS(D0)*
     1                                              DCOS(A0+DZETA))
      SINR = (DCOS(D0)*DSIN(A0+DZETA))/DCOS(D1)
      COSR = (DCOS(DTHETA)*DCOS(D0)*DCOS(A0+DZETA)-
     1                         DSIN(DTHETA)*DSIN(D0))/DCOS(D1)
      R = DASIN(SINR)
      IF (COSR.LT.0) R=PI-R                ! determine quadrant of R
      A1 = R+DZED                      ! this is the precessed R.A.
      IF (A1.GT.2.0D0*PI) A1=A1-2.0D0*PI
      IF (A1.LT.0.0D0) A1=A1+2.0D0*PI
C
      RETURN
      END

C @(#)calfon.for	19.1 (ES0-DMD) 02/25/03 13:19:39
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE CALFON(ETAB,IDIM,FONDM,FOND,R,IERR)                            
C +++                                                                           
C.PURPOSE: PROGRAMME DE CALCUL DU FOND AU VOISINAGE D'UN OBJET                  
C          PAR METHODE SEPARATION DE ZONE EN NIVEAUX(2)                         
C.INPUT/OUTPUT:  ETAB:  [E] tableau des valeurs entrees                         
C                IDIM:  [E] dimension du tableau                                
C                FONDM: [E] val. max. estimee du fond                           
C                FOND:  [S] valeur du fond                                      
C                R:     [S] dimension de l'objet(circulaire..)en pixels         
C                IERR:  [S] error parameter: =0:  ok                            
C                                            =-1: excessive background          
C                                            =-2: indefinite diameter           
C                                            =-3: the max. is out object        
C.VERSION: 80015  ???                          Created                          
C ---                                                                           
      IMPLICIT NONE	
      REAL     ETAB(1)
      INTEGER  IDIM
      REAL     FONDM
      REAL     FOND
      REAL     R
      INTEGER  IERR
C
      INTEGER  I
      INTEGER  IFIN
      INTEGER  ITEMP
      INTEGER  J
      INTEGER  K
      INTEGER  MADRID(1)
      INTEGER  MM
      INTEGER  N
      INTEGER  TWO
C
      REAL     DR
      REAL     ITAB(256)
      REAL     SIGMA
      REAL     SOM
      REAL     TAB(256)                                        
      REAL     TFOND
      REAL     TEMP
      REAL     VAL
      REAL     VTEST
      REAL     XMOY
      REAL     XMOYC
C
      COMMON  /VMR/MADRID                                                    
                                                                                
      FOND   = 0.                                                               
      R      = 0.                                                               
      IERR   = 0                                                                
      IFIN   = IDIM - 1                                                         
      DO 10 K = 1,IFIN                                                          
         ITAB(K) = K                                                            
   10 CONTINUE                                                                  
      DO 20 I = 2,IDIM                                                          
          TAB(I-1) = ETAB(I)                                                    
   20 CONTINUE                                                                  
C                                                                               
C *** sort by increassing order                                                 
C                                                                               
      DO 50 I = 1,IFIN - 1                                                      
         DO 40 J = I + 1,IFIN                                                   
            IF (TAB(I).LT.TAB(J)) GO TO 40                                      
            ITEMP   = ITAB(I)                                                   
            ITAB(I) = ITAB(J)                                                  
            ITAB(J) = ITEMP                                                    
            TEMP    = TAB(I)                                                    
            TAB(I)  = TAB(J)                                                    
            TAB(J)  = TEMP                                                      
   40    CONTINUE                                                               
   50 CONTINUE                                                                  
                                                                                
      IF (ITAB(IFIN).GT.3) IERR   = -3                                          
      IF (ITAB(IFIN).GT.3) RETURN                        ! max.hors de l'objet  
C                                                                               
C **** 1st background & sigma estimation with the 4 lesser values               
      VAL    = 0.                                                               
      SOM    = 0.                                                               
      DO 60 N = 1,4                                                             
         VAL    = VAL + TAB(N)*TAB(N)                                           
         SOM    = SOM + TAB(N)                                                  
   60 CONTINUE                                                                  
C                                                                               
      XMOY   = SOM/4.                                                           
      XMOYC  = SOM*SOM/4.                                                       
      SIGMA  = (VAL-XMOYC)/3.                                                   
      SIGMA  = SQRT(SIGMA)                                                      
      FOND   = XMOY                                                             
C                                                                               
C *** compute background & test                                                 
      MM     = 3                                                                
      VTEST  = XMOY + 5.*SIGMA                                                  
   70 MM     = MM + 1                                                           
      IF (TAB(MM).GT.VTEST) GO TO 80                                            
      GO TO 70                                                                  
C                                                                               
   80 CONTINUE                                                                  
      IF (MM.EQ.4) GO TO 100                                                    
      DO 90 K = 5,MM                                                            
          VAL    = VAL + TAB(K)*TAB(K)                                          
          SOM    = SOM + TAB(K)                                                 
   90 CONTINUE                                                                  
C                                                                               
      FOND   = SOM/FLOAT(MM)                                                    
      SIGMA  = (VAL-SOM*FOND)/FLOAT(MM-1)                                       
      SIGMA  = SQRT(SIGMA)                                                      
  100 IF (FOND.GT.FONDM) IERR   = -1                                            
      IF (FOND.GT.FONDM) RETURN                                                 
C                                                                               
C *** compute radius (to background+6*sigma level) & test                       
      TFOND  = FOND + 6.*SIGMA                                                  
      TWO    = 2
      DR     = ETAB(TWO)

      DO 110 J = 2,IDIM                                                         
         IF (ETAB(J).LE.TFOND) GO TO 120     ! test remontee(diam>480 microns)  
         IF (ETAB(J).GT.DR .AND. J.GT.8) GO TO 130                              
         DR     = ETAB(J)                                                       
  110 CONTINUE                                                                  
C                                                                               
      IERR = -2                                                                 
      RETURN                                                                    
C                                                                               
  120 R    = FLOAT(J-1)                                                         
      RETURN                                                                    
C                                                                               
  130 R    = FLOAT(J-2)                                                         
      RETURN                                                                    
      END                                                                       

C===========================================================================
C Copyright (C) 1995-2011 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++
C .IDENT       lnsearch.for                                      
C .AUTHOR:     Daniel PONZ
C
C .KEYWORDS    Spectroscopy, Long-Slit                   
C
C.PURPOSE:
C  SEARCH FOR EMISSION/ABSORPTION LINES IN A 1D- OR 2D-IMAGE AND
C  CALCULATE PARAMETERS :
C  - LINE CENTER
C  - PEAK VALUE
C
C.ALGORITHM:
C
C  LINES ARE DETECTED BY USING A MEDIAN + THRESHOLDING ALGORITHM
C  ABSORPTION LINES ARE TREATED AS NEGATIVE EMISSION
C  CENTER OF THE LINE IS COMPUTED AS
C  (1)- CENTER OF GRAVITY OF THE 2 HIGHEST PIXELS RELATIVE TO THE 
C	THIRD ONE
C  (2)- CENTER OF THE GAUSSIAN FIT TO THE POINTS ABOVE THE BACKGROUND
C  (3)- PIXEL CORRESPONDING TO THE MAXIMUM
C
C.INPUT/OUTPUT:
C  THE FOLLOWING KEYWORDS SHOULD BE DEFINED :
C       P1 : IMAGE TO BE SEARCHED
C INPUTR  : SEARCH PARAMETERS
C                 WINDOW, THRESHOLD, NAVER
C P3 : TABLE FILE
C       P4 : SEARCH METHOD
C                 GRAVITY  - DEFAULT
C                 GAUSSIAN
C                 MAXIMUM
C       P5 : EMISSION/ABSORPTION
C
C .VERSION     1.0  Package Creation  17-MAR-1993        
C 
C 110610	last modif
C -------------------------------------------------------
C
      PROGRAM  LNSEARCH
      IMPLICIT NONE
      INTEGER   MD, NMAX
      PARAMETER (MD=2)
      PARAMETER (NMAX=1000)
      INTEGER   MADRID
      INTEGER   I,IAV,IC,IMETH,IMODE,IS,ISTAT, ALGO
      INTEGER   NAX,NOBJ,NAVER,ISIZE
      INTEGER*8 IPM,IPNTA
      INTEGER   KUN,KNUL,TID,IMNO
      INTEGER   NPIX(MD), STEP
C
      CHARACTER*2  METH,IEA
      CHARACTER*80 INA
      CHARACTER*80 FOUTA
      CHARACTER*48 UNIT
      CHARACTER*72 INST
      CHARACTER*80 LINE,LINEM,LINEE
C
      REAL RBUF(2,NMAX)
      REAL STRA(MD),STPA(MD),PARM(5)
      DOUBLE PRECISION DSTRA(2), DSTPA(2), DPAR(5)
C
      CHARACTER*16 LABEL(5),TUNIT(5)
      CHARACTER*6  FORM(5)
C
      INCLUDE      'MID_INCLUDE:ST_DEF.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE      'MID_INCLUDE:ST_DAT.INC'
C
      DATA LABEL(1)/'X'/,TUNIT(1)/'PIXEL'/,FORM(1)/'F10.2'/
      DATA LABEL(2)/'Y'/,TUNIT(2)/'PIXEL'/,FORM(2)/'F10.2'/
      DATA LABEL(3)/'PEAK'/,TUNIT(3)/'DN'/,FORM(3)/'E12.3'/
C
C ... INITIATE MIDAS
C
      CALL STSPRO('LNSEARCH')
C
      CALL STKRDC('IN_A',1,1,80,IAV,INA,KUN,KNUL,IS)
      CALL STKRDC('OUT_A',1,1,80,IAV,FOUTA,KUN,KNUL,IS)
      CALL STKRDC('IN_B',1,1,2,IAV,METH,KUN,KNUL,IS)
      CALL STKRDC('OUT_B',1,1,1,IAV,IEA,KUN,KNUL,IS)
      CALL STKRDI('INPUTI',1,1,IAV,ALGO,KUN,KNUL,IS)
      CALL STKRDR('INPUTR',1,4,IAV,PARM,KUN,KNUL,IS)
      CALL STKRDD('INPUTD',1,4,IAV,DPAR,KUN,KNUL,IS)
      CALL FORUPC(METH,METH)
      CALL FORUPC(IEA,IEA)
C
      CALL STIGET(INA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     .     MD,NAX,NPIX,DSTRA,DSTPA,INST,UNIT,IPNTA,IMNO,IS)
C
      NPIX(1) = MAX(1,NPIX(1))
      NPIX(2) = MAX(1,NPIX(2))
      NAX    = 2
C      STRA(1) = DSTRA(1) 
C      STRA(2) = DSTRA(2) 
C      STPA(1) = DSTPA(1) 
C      STPA(2) = DSTPA(2) 
       STRA(1) = DPAR(1) 
       STRA(2) = DPAR(2) 
       STPA(1) = DPAR(3) 
       STPA(2) = DPAR(4) 
      IF (NPIX(1).EQ.1) THEN
          NPIX(1) = NPIX(2)
          NPIX(2) = 1
      END IF
C
C ... READ PARAMETERS
C
C      NMAX   = 800
C
      IF (METH(1:2).EQ.'GA') THEN
          IMETH  = -1
          LINEM  = '    centering method : gaussian fit'
      ELSE
          IF (METH(1:2).EQ.'GR') THEN
              IMETH  = 0
              LINEM  = '    centering method : center of gravity'
          ELSE
              IMETH  = 1
              LINEM  = '    centering method : position of max(min)'
          END IF
      END IF
      IF (IEA(1:1).EQ.'E') THEN
          IMODE  = 1
          LINEE  = ' search for emission lines'
      ELSE
          IMODE  = 0
          LINEE  = ' search for absorption lines'
      END IF
C
C ... CREATE THE TABLE FILE PLUS COLUMNS
C
      CALL TBTINI(FOUTA,F_TRANS,F_O_MODE,15,NMAX,TID,IS)
      CALL STDWRD(TID,'PIXEL',DSTPA,1,1,KUN,IS)
      DO 10 I = 1,3
          CALL TBCINI(TID,D_R4_FORMAT,1,FORM(I),
     .                TUNIT(I),LABEL(I),IC,IS)
   10 CONTINUE
      CALL STTPUT(' search lines ',ISTAT)
      CALL STTPUT(' ------------',ISTAT)
      CALL STTPUT(' input image  : '//INA,ISTAT)
      CALL STTPUT(' output table : '//FOUTA,ISTAT)
      CALL STTPUT(' input parameters ',ISTAT)
      WRITE (LINE,9000) NINT(PARM(1))
      CALL STTPUT(LINE,ISTAT)
      WRITE (LINE,9010) PARM(2)
      CALL STTPUT(LINE,ISTAT)
      NAVER = PARM(3)
      STEP  = PARM(4)
      WRITE (LINE,9030) NAVER
      CALL STTPUT(LINE,ISTAT)
      WRITE (LINE,9040) STEP 
      CALL STTPUT(LINE,ISTAT)
      CALL STTPUT(LINEM,ISTAT)
      CALL STTPUT(LINEE,ISTAT)
C
C ...  DO THE SEARCH
C
          ISIZE = NPIX(1)*4
          CALL TDMGET(ISIZE,IPM,ISTAT)
          CALL SRCOD3(MADRID(IPNTA),NAX,NPIX(1),NPIX(2),STRA,
     +    STPA,NMAX,PARM,NOBJ,TID,RBUF,IMETH,IMODE,NAVER,STEP,
     +    MADRID(IPM),ALGO)
          CALL TDMFRE(ISIZE,IPM,ISTAT)
C
      WRITE (LINE,9020) NOBJ
      CALL STTPUT(LINE,ISTAT)
C
C ...  FINISHED
C
      CALL TBSINI(TID,IS)
      CALL TBTCLO(TID,IS)
      CALL STSEPI

 9000 FORMAT ('       search window : ',I3,' pixels')
 9010 FORMAT (' detection threshold : ',F10.2,' DN')
 9030 FORMAT ('          average on : ',I3,' scan-lines')
 9040 FORMAT ('             step of : ',I3,' scan-lines')
 9020 FORMAT ('    no. of detections: ',I8)
      END

C--------------------------------------------------------------------

      SUBROUTINE FNDMAX(X,N,R,NMAX,NACT,START,STEP)
C
C FIND MAXIMUM VALUE IN CASE OF HIGH THRESHOLD
C
      IMPLICIT NONE
      INTEGER N, NMAX, NACT
      REAL    X(N),R(2,NMAX)
      REAL    START, STEP
C
      INTEGER I, IP
      REAL    XMAX
C
      XMAX   = 1.E-30
      DO 10 I = 3,N - 2
          IF (X(I).GT.XMAX) THEN
              XMAX   = X(I)
              IP     = I
          END IF
   10 CONTINUE
      R(1,1) = START + (IP-1)*STEP
      R(2,1) = XMAX
      NACT   = 1
      RETURN
      END

C--------------------------------------------------------------------

       SUBROUTINE SRCOD3(F,NAF,NPF1,NPF2,STRA,STPA,NMAX,PARM,NOBJ,
     +                  TID,RBUF,IMETH,IMODE,NAVER,STEP,RVAL,ALGO)
C
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  SUBROUTINE SRCOD3   VERSION 1   23 NOV 1982
C  J.D.PONZ
C
C.KEYWORDS:
C  SEARCH
C
C.PURPOSE:
C  SEARCH SPECTRA FOR EMISSION LINES
C
C.ALGORITHM:
C  USE FINDM2
C
C.INPUT/OUTPUT
C  F          original image                            Input
C  NAF        dimension of F                            Input
C  NPF        number of pixels in F (x,y,z...)          Input
C  STRA       starting point in F                       Input
C  STPA       step                                      Input
C  PARM       floating-point parameters of filter       Input
C  NOBJ       number of objects found                   Output
C  OBJ        charateristics of objects                 Output
C
C-------------------------------------------------------------
C
C
      IMPLICIT NONE
      INTEGER NPF1, NPF2, NAF, NMAX, NOBJ, IMETH, IMODE, ALGO
      INTEGER NAVER, STEP
      REAL    STRA(2),STPA(2),PARM(2),OBJ(6)
      REAL    RBUF(2,NMAX), F(NPF1,NPF2), RVAL(NPF1)
      REAL    XAUX(100)
      INTEGER IAUX(100), I, NSEQ, IS, NACT, TID
      INTEGER J, J1, J2, K
      INTEGER ICOL(5), NAUX, NT, NW, ISTAT, IAC, NW1, IORD
      REAL    T
      CHARACTER     LINE*80
C
      DATA ICOL/1,2,3,4,5/
C
      NAUX   = 99
C
      NT     = NPF1
      NW     = PARM(1)
      T      = PARM(2)
      NOBJ   = 0
C
C     search features
C
      IF (NPF2.GT.1) THEN
          CALL STTPUT(' seq.no.  detected lines ',ISTAT)
          CALL STTPUT(' -------  -------------- ',ISTAT)
      END IF
      IAC    = 3
      NW1    = 2*NW + 1
      NSEQ   = 0
      DO 20 IORD = 1, NPF2, STEP
          DO 1 J = 1, NPF1
             RVAL(J) = 0.
1         CONTINUE
          J1 = MAX(IORD-NAVER,1)
          J2 = MIN(J1 + NAVER,NPF2) 
          DO 3 J = J1, J2
             DO 2 K = 1, NPF1
                RVAL(K) = RVAL(K) + F(K,J)/(NAVER*2+1)
2            CONTINUE
3         CONTINUE

          IF (ALGO .EQ. 0) THEN
          CALL FNDMDN(RVAL,NT,NW1,T,NMAX,RBUF,NACT,XAUX,IAUX,
     +                NAUX, IMETH,IMODE,STRA(1),STPA(1))
          ELSE
          CALL FINDIT(RVAL,NT,NW1,T,NMAX,RBUF,NACT,XAUX,IAUX,
     +                NAUX, IMETH,IMODE,STRA(1),STPA(1))
          ENDIF

          IF (NACT.LE.0) CALL FNDMAX(RVAL,NT,RBUF,NMAX,NACT,
     +                               STRA(1),STPA(1))
          IF (NPF2.GT.1) THEN
              WRITE (LINE,9000) IORD,NACT
              CALL STTPUT(LINE,ISTAT)
          END IF
          NOBJ   = NOBJ + NACT
          DO 10 I = 1,NACT
              OBJ(1) = RBUF(1,I)
              OBJ(2) = (IORD-1)*STPA(2) + STRA(2)  
              OBJ(3) = RBUF(2,I)
              NSEQ   = NSEQ + 1
              CALL TBRWRR(TID,NSEQ,IAC,ICOL,OBJ,IS)
   10     CONTINUE
   20 CONTINUE
      IF (NPF2.GT.1) CALL STTPUT(' ----------------------- ',ISTAT)
      RETURN
C
 9000 FORMAT (1X,I8,2X,I8)
      END


C-----------------------------------------------------------------------

      SUBROUTINE FNDMDN(IA,LEN,WIDTH,THRES,NMAX,RBUF,NACT,FA,LINK,
     +                  NAUX,IMETH,IMODE,XSTR,XSTP)
C
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  23:58 - 3 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: D.PONZ
C
C.IDENTIFICATION
C
C  SUBROUTINE FNDMDN       
C
C.KEYWORDS
C
C  SEARCH
C
C.PURPOSE
C
C  SEARCH EMISSION/ABSORPTION FEATURES
C
C.ALGORITHM
C
C  DATA IN A RUNNING WINDOW IS SORTED TO FORM A LOCAL HISTOGRAM
C  AN EMISSION(ABSORPTION) FEATURE IS FOUND WHEN THE CENTRAL
C  VALUE IN THE WINDOW IS GREATER THAN THE MEDIAN VALUE PLUS THE
C  THRESHOLD.
C
C.INPUT/OUTPUT
C
C  IA         REAL*4     INPUT ARRAY
C  LEN        INTG*4     NUMBER OF INPUT PIXELS
C  WIDTH      INTG*4     WINDOW WIDTH
C  THRES      REAL*4     THRESHOLD
C  NMAX       INTG*4     MAXIMUM NO. OF DETECTED LINES
C  RBUF       REAL*4     RBUF(1,I) - CENTER
C                        RBUF(2,I) - MAXIMUM VALUE
C  NACT       INTG*4     ACTUAL NUMBER OF DETECTED LINES
C  FA(NAUX)   REAL*4     AUXILIARY SPACE
C  LINK(NAUX) INTG*4     AUXILIARY SPACE
C  NAUX       INTG*4     SPACE SIZE. NAUX .GT. WIDTH+1
C  IMETH      INTG*4     CENTERING METHOD AS
C  IMODE      INTG*4     0
C  XSTR       REAL*4     STARTING COORD.
C  XSTP       REAL*4     STEP
C
C-
C      IMPLICIT NONE
      INTEGER NAUX
      INTEGER LINK(NAUX),MIN,MAX,WIDTH,LEN,MIDPT,FRONT,AVAIL
      INTEGER RANGE,NEWNOD,I,J,K,NODE,ITMP
      INTEGER NMAX,NACT,IMODE,IMETH
      INTEGER ISTART,IFAIL,NPIX,NOBJ,NLOBJ
      REAL FA(NAUX),IA(LEN),RBUF(2,NMAX),AM
      REAL THRES,T,XSTR,XSTP,CHICHK,XGO,XCNTR
      REAL ACOE(4),WORK1(200),WORK2(200),XPREV
      REAL DELTA
      LOGICAL IFIRST
C
C   SET UP BEGINNING (MIN) AND END (MAX) OF FILTER ARRAY
C   ALSO SET UP POINTER TO AVAIL LIST AND LIST HEADER (FA(1),LINK(1))
C
      CHICHK = 0.005
      IFIRST = .TRUE.
      T      = ABS(THRES)
      MIN    = 2
      MAX    = NAUX
      AVAIL  = MIN
      FA(1)  = -1.0
      LINK(1) = 0
      NOBJ   = 0
C
C   SET UP FIRST FILTER WINDOW
C
      RANGE  = WIDTH - 1
      DO 10 I = 1,RANGE,1
          NODE   = NEWNOD(IA(I),AVAIL,MIN,MAX,FA,LINK,NAUX)
          CALL INSNOD(NODE,FA,LINK,NAUX)
   10 CONTINUE
      RANGE  = WIDTH/2
C
C   FOR EACH POINT FROM WIDTH/2 TO LEN-WIDTH/2+1
C   FIND ITS MEDIAN
C
      FRONT  = MIN
C   FRONT IS THE OLDEST POINT IN THE FILTER ARRAY
      K      = RANGE
C   K IS THE POINT BEING PROCESSED
      MIDPT  = RANGE + 1
C   MIDPT IS THE MIDDLE OF THE WINDOW (IN FA)
      DO 70 J = WIDTH,LEN,1
          NODE   = NEWNOD(IA(J),AVAIL,MIN,MAX,FA,LINK,NAUX)
          CALL INSNOD(NODE,FA,LINK,NAUX)
          K      = K + 1
C
C    FIND THE MIDPT - - IT IS THE MEDIAN VALUE
C
          ITMP   = LINK(1)
          DO 20 I = 2,MIDPT,1
              ITMP   = LINK(ITMP)
   20     CONTINUE
C
C    GET THE LINK WHICH POINTS TO THE VALUE OF THE MEDIAN
C
          IF (ABS(FA(ITMP)-IA(K)).GT.T) THEN
              IF (IFIRST) THEN
                  IFIRST = .FALSE.
                  NLOBJ  = 1
                  ISTART = K - 1
                  NPIX   = 3

              ELSE
                  NPIX   = NPIX + 1
              END IF

          ELSE
              IF ( .NOT. IFIRST) THEN
                  IFIRST = .TRUE.
C
C   FIND LINE CENTER
C
                  XGO    = XSTR + (ISTART-1)*XSTP
                  IF (IMETH.LT.0) THEN
                     GOTO 30
                  ELSE IF (IMETH.EQ.0) THEN
                     GOTO 40
                  ELSE
                     GOTO 50
                  ENDIF                    !was: IF (IMETH) 30,40,50
C
C              GAUSSIAN
C
   30             CALL SGAUS(IA(ISTART),WORK1,WORK2,IMODE,NPIX,IFAIL,
     +                       XGO,XSTP,XCNTR,CHICHK,1,AM,ACOE)
                  GO TO 60
C
C              GRAVITY
C
   40             CALL GRAVT(IA(ISTART),NPIX,IMODE,IFAIL,XGO,XSTP,XCNTR,
     +                       AM)
                  IF (IFAIL.EQ.0) GO TO 60
C
C              MAXIMUM
C
   50             CALL CNTRH(IA(ISTART),NPIX,IMODE,IFAIL,XGO,XSTP,XCNTR,
     +                       AM)
   60             IF (IFAIL.EQ.0) THEN
                      NOBJ   = NOBJ + 1
                      RBUF(1,NOBJ) = XCNTR
                      RBUF(2,NOBJ) = AM
                      IF (NOBJ.EQ.NMAX) GO TO 80
                  END IF

              END IF

          END IF

          CALL DELNOD(FRONT,FA,LINK,NAUX)
          FRONT  = FRONT + 1
          IF (FRONT.GT.MAX) FRONT  = MIN
C
C      DELETE OLDEST AND ADVANCE PTR, FRONT ALSO WRAPS
C
   70 CONTINUE
   80 CONTINUE
C
C CHECK DOUBLETS
C
      XPREV  = RBUF(1,1)
      I      = 1
   85 CONTINUE
          IF ( .NOT. (I.LT.NOBJ)) GO TO 110
          DELTA = 2.*XSTP
          IF (ABS(XPREV-RBUF(1,I+1)).LE.DELTA) THEN
              DO 90 J = I,NOBJ - 2
                  RBUF(1,J) = RBUF(1,J+2)
                  RBUF(2,J) = RBUF(2,J+2)
   90         CONTINUE
              NOBJ   = NOBJ - 2

          ELSE
              I      = I + 1
          END IF

          XPREV  = RBUF(1,I)
      GOTO 85 
  110 CONTINUE
      NACT   = NOBJ
      RETURN
      END


C-----------------------------------------------------------------------

      SUBROUTINE FINDIT(IA,LEN,WIDTH,THRES,NMAX,RBUF,NACT,FA,LINK,
     +                  NAUX,IMETH,IMODE,XSTR,XSTP)
C+
C.COPYRIGHT: Copyright (c) 1993 European Southern Observatory,
C                                         all rights reserved
C
C.AUTHOR: P. BALLESTER
C
C.IDENTIFICATION
C
C  SUBROUTINE FINDIT    
C
C.INPUT/OUTPUT
C
C  IA         REAL*4     INPUT ARRAY
C  LEN        INTG*4     NUMBER OF INPUT PIXELS
C  WIDTH      INTG*4     WINDOW WIDTH
C  THRES      REAL*4     THRESHOLD
C  NMAX       INTG*4     MAXIMUM NO. OF DETECTED LINES
C  RBUF       REAL*4     RBUF(1,I) - CENTER
C                        RBUF(2,I) - MAXIMUM VALUE
C  NACT       INTG*4     ACTUAL NUMBER OF DETECTED LINES
C  FA(NAUX)   REAL*4     AUXILIARY SPACE
C  LINK(NAUX) INTG*4     AUXILIARY SPACE
C  NAUX       INTG*4     SPACE SIZE. NAUX .GT. WIDTH+1
C  IMETH      INTG*4     CENTERING METHOD AS
C  IMODE      INTG*4     0
C  XSTR       REAL*4     STARTING COORD.
C  XSTP       REAL*4     STEP
C
C-
      IMPLICIT NONE
      INTEGER NAUX
      INTEGER LINK(NAUX),MIN,MAX,WIDTH,LEN
      INTEGER RANGE,I,J,K,NODE
      INTEGER NMAX,NACT,IMODE,IMETH
      INTEGER ISTART,IFAIL,NPIX,NOBJ
      REAL FA(NAUX),IA(LEN),RBUF(2,NMAX),AM
      REAL THRES,T,XSTR,XSTP,CHICHK,XGO,XCNTR
      REAL ACOE(4),WORK1(200),WORK2(200),XPREV
      REAL DELTA
      LOGICAL IFIRST
      REAL    R(2,1)
      INTEGER IH,PREVK
C
C   SET UP BEGINNING (MIN) AND END (MAX) OF FILTER ARRAY
C   ALSO SET UP POINTER TO AVAIL LIST AND LIST HEADER (FA(1),LINK(1))
C
      CHICHK = 0.005
      IFIRST = .TRUE.
      T      = ABS(THRES)
      MIN    = 2
      MAX    = NAUX
      FA(1)  = -1.0
      NOBJ   = 0
      PREVK  = 0
C
C   SET UP FIRST FILTER WINDOW
C
      RANGE  = WIDTH - 1
      RANGE  = WIDTH/2
C
C   FOR EACH POINT FROM WIDTH/2 TO LEN-WIDTH/2+1
C   FIND ITS MEDIAN
C
      DO 70 J = RANGE+1,LEN-RANGE

C
C    GET THE LINK WHICH POINTS TO THE VALUE OF THE MEDIAN
C
          MIN = J-RANGE
          MAX = J+RANGE
          DO 66 NODE = MIN,MAX
                FA(NODE-MIN+1) = IA(NODE)
66        CONTINUE

          CALL FNDMAX(FA,WIDTH,R,1,IH,1.,1.)
          IH = R(1,1)
          K = IH+MIN-1

C
C   FIND LINE CENTER
C
          IF (K.NE.PREVK.AND.IA(K).GT.T) THEN

                  PREVK  = K
                  ISTART = K - RANGE
                  NPIX   = WIDTH

                  XGO    = XSTR + (ISTART-1)*XSTP

                  IF (IMETH.LT.0) THEN
                     GOTO 30
                  ELSE IF (IMETH.EQ.0) THEN
                     GOTO 40
                  ELSE
                     GOTO 50
                  ENDIF                    !was: IF (IMETH) 30,40,50
C
C              GAUSSIAN
C
   30             CALL SGAUS(IA(ISTART),WORK1,WORK2,IMODE,NPIX,IFAIL,
     +                       XGO,XSTP,XCNTR,CHICHK,1,AM,ACOE)
                  GO TO 60
C
C              GRAVITY
C
   40             CALL GRAVT(IA(ISTART),NPIX,IMODE,IFAIL,XGO,XSTP,XCNTR,
     +                       AM)
                  IF (IFAIL.EQ.0) GO TO 60
C
C              MAXIMUM
C
   50             CALL CNTRH(IA(ISTART),NPIX,IMODE,IFAIL,XGO,XSTP,XCNTR,
     +                       AM)

C
   60             IF (IFAIL.EQ.0) THEN
                      NOBJ   = NOBJ + 1
                      RBUF(1,NOBJ) = XCNTR
                      RBUF(2,NOBJ) = AM
                      IF (NOBJ.EQ.NMAX) GO TO 80
                  END IF

      ENDIF

   70 CONTINUE
   80 CONTINUE

C
C CHECK DOUBLETS
C
      XPREV  = RBUF(1,1)
      I      = 1
   85 CONTINUE
          IF ( .NOT. (I.LT.NOBJ)) GO TO 110
          DELTA = WIDTH*XSTP
          IF (ABS(XPREV-RBUF(1,I+1)).LE.DELTA) THEN
              DO 90 J = I,NOBJ - 1
                  RBUF(1,J) = RBUF(1,J+1)
                  RBUF(2,J) = RBUF(2,J+1)
   90         CONTINUE
              NOBJ   = NOBJ - 1

          ELSE
              I      = I + 1
          END IF

          XPREV  = RBUF(1,I)
      GOTO 85 
  110 CONTINUE
      NACT   = NOBJ
      RETURN
      END

C @(#)updtll.for	19.1 (ES0-DMD) 02/25/03 13:25:40
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C
C-----------------------------------------------------------------------
      SUBROUTINE UPDTLL ( MCAT , NL , IDET , NXS , ILIM ,
     &                                          IDA , IP , M )
C
      IMPLICIT NONE
      INTEGER  ILIM , NL , NXS
      INTEGER  IDA(2,0:ILIM)
      INTEGER  IDET(NXS,0:ILIM)
      INTEGER  IP
      INTEGER  K , L , L1 , L2
      INTEGER  M , MCAT(4,NL) , NN
C
C ******      Look for other close detections.
C
      DO 10 K = 0 , ILIM
          L1 = MAX( 1 , IP - IDA(1,K) )
          L2 = MIN( NXS , IP + IDA(2,K) )
          DO 20 L = L1 , L2
            NN = IDET(L,K)
            IF ( NN .NE. 0 ) THEN
                CALL UPDTL( MCAT , NL , NN , M )
            ENDIF
   20          CONTINUE
   10      CONTINUE
C
C ******      Write detection entry in array IDET.
C
      IDET(IP,0) = M
C
      RETURN
C
      END

C===========================================================================
C Copyright (C) 1995-2011 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C 
C 110504	last modif
C 
C===========================================================================
C
CC
CC     PROGRESS : PROGRAM FOR ROBUST REGRESSION
CC-----------------------------------------------------------------------------
CC-----LIST OF VARIABLES AND ARRAYS IN THIS PROGRAM
CC-----------------------------------------------------------------------------
CC     NDXY           = MAXIMAL NUMBER OF CASES
CC     NMXV           = MAXIMAL NUMBER OF EXPLANATORY VARIABLES
CC     NDXX           = NMXV+1 = MAXIMAL NUMBER OF COEFFICIENTS,
CC                               INCLUDING INTERCEPT
CC     JDMB           = NMXV*(NMXV+1)
CC-----------------------------------------------------------------------------
CC     X(NDXX,NDXY)   = MATRIX OF THE VALUES OF THE EXPLANATORY
CC                      VARIABLES (TRANSPOSED DESIGN MATRIX)
CC     Y(NDXY)        = VECTOR WITH THE VALUES OF
CC                      THE RESPONSE VARIABLE
CC     RESDU(NDXY)    = VECTOR FOR STORING THE RESIDUALS
CC                      (EXCEPT IN SUBROUTINE STATIS, WHERE IT IS
CC                      A WORKING VECTOR)
CC     WEIGHTS(NDXY)  = WEIGHT ASSIGNED TO EACH OBSERVATION
CC     AW(NDXY)       = WORKING VECTOR
CC     A(NMXV+1)      = VECTOR OF REGRESSION COEFFICIENTS  (LS OR RLS)
CC     DA(NMXV+1)     = VECTOR WITH THE STAND. DEVIATION OF THE COEFFICIENTS
CC     DRCTA(NMXV+1)  = VECTOR OF COEFFICIENTS FOR THE LMS
CC     XMED(NMXV+1)   = VECTOR WITH THE MEDIANS OF ALL VARIABLES
CC     XMAD(NMXV+1)   = VECTOR WITH MEDIAN ABSOLUTE DEVIATIONS
CC     UHYB(NDXY)     = VECTOR WITH THE RESISTANT DIAGNOSTICS
CC     C(NMXV,NMXV+1) = MATRIX USED FOR - STORING THE COEFFICIENTS
CC                                        OF THE LINEAR SYSTEM TO BE SOLVED
CC                                        AT EACH REPLICATION
CC                                      - STORING THE SPEARMAN
CC                                        CORRELATION COEFFICIENTS
CC     H(NMXV,NMXV+1) = MATRIX USED FOR - STORING THE VARIANCE-COVARIANCE
CC                                        MATRIX OF THE LS AND RLS COEFFICIENTS
CC                                      - STORING THE PEARSON
CC                                        CORRELATION COEFFICIENTS
CC     HVEC(JDMB)     = AUXILIARY VECTOR
CC-----------------------------------------------------------------------------
CC     NMVAL(NDXY)    = VECTOR WITH THE ORIGINAL INDEX OF THE CASES
CC     JNDVC(NMXV+1)  = VECTOR - CONTAINING THE INDEX OF THE CASES
CC                               CONSIDERED IN A RANDOM SUBSAMPLE
CC                             - COUNTING THE NUMBER OF MISSING CASES FOR
CC                               EACH VARIABLE
CC     VALMS(NMXV+1)  = VECTOR WITH THE "MISSING VALUE CODES"
CC     JNDEX(NMXV+1)  = JNDEX(J), (J=1,NVAR+1) IS 1 IF VAR(J) CONTAINS MISSING
CC                      VALUES AND IS 0 OTHERWISE
CC                      (CONSIDERED IN A RANDOM SUBSAMPLE)
CC     JNDA(NMXV)     = VECTOR CONTAINING THE INDEX OF THE CASES
CC                      WHICH YIELD THE "BEST" LMS SOLUTION
CC     JPLACE(NMXV+1) = VECTOR CONTAINING THE POSITIONS OF THE VARIABLES
CC                      USED IN THE ANALYSIS (FROM THE TOTAL DATA SET)
CC     LAB(NMXV+1)    = VECTOR WITH THE LABEL OF EACH VARIABLE
CC-----------------------------------------------------------------------------
CC-----LIST OF MOST IMPORTANT PARAMETERS:
CC-----------------------------------------------------------------------------
CC     FNAMEA         = NAME OF THE FILE WHERE THE INPUT HAS TO BE READ
CC     FNAMEB         = NAME OF THE FILE WHERE THE OUTPUT HAS TO BE WRITTEN
CC     FNAMEC         = NAME OF THE FILE WHERE THE DATA HAS TO BE SAVED
CC     LUA            = LOGICAL UNIT FOR 'FNAMEA'
CC     LUB            = LOGICAL UNIT FOR 'FNAMEB'
CC     LUC            = LOGICAL UNIT FOR 'FNAMEC'
CC     NVAR           = NUMBER OF COEFFICIENTS (INCLUDING THE CONSTANT TERM
CC                      IF THERE IS ONE)
CC     ANVAR              = REAL VALUE OF NVAR
CC     NVSB              = NVAR-1
CC     NVAD              = NVAR+1
CC     NCAS              = NUMBER OF CASES
CC     AL              = REAL VALUE OF NCAS
CC     ALGO              = CHARACTER WHICH IS 'E' FOR THE EXTENSIVE SEARCH
CC                        VERSION AND 'Q' FOR THE QUICK VERSION OF THE ALGORITHM
CC     NZWE              = NUMBER OF NON-ZERO WEIGHTS
CC     RSQ              = R SQUARED (COEFFICIENT OF DETERMINATION)
CC     AVW              = AVERAGE WEIGHT
CC     FCKW              = OBJECTIVE FUNCTION VALUE
CC     JCST              = INTEGER WHICH IS 1 IN THE CASE OF A MODEL WITH
CC                        INTERCEPT AND 0 OTHERWISE
CC     JPLT              = PLOT OPTION (0=NONE, 1=RESIDUAL, 2=INDEX, 3=BOTH)
CC     JPRT              = PRINT OPTION (0=SMALL, 1=MEDIUM-SIZED, 2=LARGE)
CC     MVAL              = OPTION FOR MISSING VALUES (0=NONE, 1=DELETE, 2=REPLACE)
CC     YNSAVE              = CHARACTER (YES OR NO) NEEDED FOR THE INTERACTIVE INPUT
CC     JHEAD              = TITLE FOR THE OUTPUT
CC     NZWE              = NUMBER OF NON-ZERO WEIGHTS
CC     PREC              = PRECISION OF THE CALCULATIONS
CC     JEY,JLP              = INTEGER VARIABLES USED FOR COUNTING THE NUMBER OF
CC                        REPLICATIONS IN THE LMS ALGORITHM
CC     JPLXY              = OPTION FOR XY PLOT (0=NO XY PLOT, 1=OTHERWISE)
CC     JREP              = NUMBER OF RANDOM SUBSAMPLES TO BE CONSIDERED
CC     JREG              = WHICH REGRESSION ? (1=LS, 2=LMS, 3=RLS)
CC     JDIAG              = OPTION FOR DIAGNOSTICS (0=NO DIAGNOSTICS, ELSE 1)
CC     JQU              = THE RANK OF THE ABSOLUTE RESIDUAL TO BE MINIMIZED
CC     NSTOP              = 1 MEANS STOP THE ANALYSIS, OTHERWISE NSTOP=0
CC-----------------------------------------------------------------------------
CC-----LIST OF SUBROUTINES AND FUNCTIONS
CC-----------------------------------------------------------------------------
CC     SUBROUTINE WRDATA  :CREATES FIRST PART OF THE OUTPUT
CC     SUBROUTINE WRDATB  :CREATES SECOND PART OF THE OUTPUT
CC     SUBROUTINE SUBHAT  :CALCULATION OF THE HAT MATRIX
CC     SUBROUTINE PRTRLS  :PRINTS THE RLS (OR LS) RESULTS
CC     SUBROUTINE SUBLMS  :ALGORITHM FOR CALCULATING THE LMS ESTIMATES
CC     SUBROUTINE PRTLMS  :PRINTS THE LMS RESULTS
CC     SUBROUTINE RDAT          :INTERACTIVE INPUT WITH READING OF THE DATA
CC     FUNCTION JNTGR          :TRANSFORMS A CHARACTER INTO AN INTEGER
CC     SUBROUTINE SMISSING:HANDLES MISSING VALUES
CC     SUBROUTINE SUBREP  :CALCULATES THE NUMBER OF REPLICATIONS
CC                           FOR THE LMS ALGORITHM
CC     SUBROUTINE STATIS  :STANDARDIZATION OF THE OBSERVATIONS
CC                           AND CALCULATION OF SOME STATISTICS
CC     SUBROUTINE CORR    :CALCULATES SPEARMAN RANK CORRELATION COEFFICIENT
CC     FUNCTION PULL      :SEARCHES THE KTH VALUE IN A VECTOR
CC     FUNCTION AMDAN     :CALCULATES THE MEDIAN
CC     FUNCTION RSQU      :CALCULATES COEFFICIENT OF DETERMINATION
CC                         OF LS AND RLS
CC     SUBROUTINE RESTT   :CALCULATES RESIDUALS AND LMS SCALE
CC     SUBROUTINE RANGS   :SORTS A VECTOR
CC     SUBROUTINE RDUAL   :GENERATES A TABLE WITH OBSERVED AND ESTIMATED
CC                         RESPONSE, RESIDUALS AND STANDARDIZED RESIDUALS
CC                         AND (IF WANTED) CALLS RESIDUAL PLOTS
CC     SUBROUTINE SHHLF   :CALCULATES LMS IN ONE DIMENSION
CC     SUBROUTINE TRC     :RETRANSFORMATION OF THE VARIANCE-COVARIANCE MATRIX
CC     SUBROUTINE SCHCV   :PRINTS THE VARIANCE-COVARIANCE MATRIX
CC     SUBROUTINE RTRAN   :RETRANSFORMATION OF THE REGRESSION COEFFICIENTS
CC     SUBROUTINE RANPN   :RANDOM NUMBER GENERATOR
CC     SUBROUTINE GENPN   :GENERATES ALL COMBINATIONS OF P POINTS OUT OF N
CC     SUBROUTINE EQUAT   :SOLVES A SYSTEM OF LINEAR EQUATIONS
CC     SUBROUTINE LSL     :LS OR RLS IN THE CASE P=1
CC     SUBROUTINE FCN     :PUTS A ROW OF THE MATRIX X IN A VECTOR
CC     SUBROUTINE LSREG   :CALCULATES LS OR RLS REGRESSION
CC     FUNCTION QLSRG     :CALCULATES LS OR RLS OBJECTIVE FUNCTION
CC     SUBROUTINE MATNV   :MATRIX INVERSION
CC     SUBROUTINE LCAT    :TREATS THE LOCATION AND SCALE ESTIMATORS
CC     SUBROUTINE SMISLOC :TREATMENT OF MISSING VALUES IN THE CASE OF LOCATION
CC     SUBROUTINE MOVE    :MOVES CHARACTERS TO THE RIGHT (IN A LABEL)
CC     FUNCTION PVAL      :CALCULATES THE P-VALUE ASSOCIATED WITH AN F-VALUE
CC     FUNCTION PTVAL     :CALCULATES THE P-VALUE ASSOCIATED WITH A T-VALUE
CC     FUNCTION SUM       :FUNCTION NEEDED IN PVAL
CC     FUNCTION ODD       :FUNCTION NEEDED IN PVAL
CC     SUBROUTINE GRAF    :MAKES A SCATTERGRAM, AND RESIDUAL AND/OR INDEX PLOTS
CC-----------------------------------------------------------------------------
CC
       PROGRAM   PROGRESS

       INCLUDE 'MID_REL_INCL:implicit.inc'

       CHARACTER YNSAVE,ALGO
       CHARACTER*80 FNAMEA,FNAMEB,FNAMEC
       CHARACTER*60 JHEAD

CC     ------------------------------------------------------------------------
CC     IF YOU LIKE TO CHANGE THE DIMENSIONS OF THE ARRAYS, THEN YOU
CC     ONLY HAVE TO ADAPT THE VALUES IN THE FOLLOWING NINE LINES:
CC     ------------------------------------------------------------------------
       DIMENSION X(21,3000),Y(3000),RESDU(3000)
       DIMENSION AW(3000),UHYB(3000)
       DIMENSION JNDVC(21),VALMS(21),JNDEX(21)
       DIMENSION NMVAL(3000),WEIGHTS(3000)
       DIMENSION A(21),DA(21),JNDA(20),JPLACE(21)
       DOUBLE PRECISION H(20,21),HVEC(420)
       DOUBLE PRECISION DTERM
       DIMENSION DRCTA(21),XMED(21),XMAD(21)
       DIMENSION C(20,21)
       CHARACTER*20 LAB(21)
       INTEGER      OUTN1,OUTN2
       INTEGER ISTAT
       CHARACTER*80 OUTEXT

       INCLUDE 'MID_INCLUDE:st_def.inc'
       COMMON  /VMR/ MADRID
       INCLUDE 'MID_INCLUDE:st_dat.inc'

CC     ------------------------------------------------------------------------
CC     INITIALIZATIONS
CC     ------------------------------------------------------------------------

       CALL STSPRO('progress')

       LUA=1
       LUB=2
       LUC=3

       NMXV=20
       NDXY=3000
       NDXX=NMXV+1
       JDMB=NMXV*NDXX
       NZWE=0
       PREC=1.0E-6
       JLP=0
       JPLT=0
       JPLXY=0
       JREG=0
       NSTOP=0
       DO 5 J=1,NMXV
       JNDA(J)=0
 5     CONTINUE

       NCAS = 0
       NVAR = 0
       JDIAG = 0
       JCST = 0
       JPRT = 0
       NVAD = 0
       NVSB = 0
       MVAL = 0

CC     ------------------------------------------------------------------------
CC     READ THE DATA
CC     ------------------------------------------------------------------------
       CALL RMIDAT(NCAS,NVAR,JCST,JPRT,NVSB,NVAD,VALMS,
     1 X,Y,JPLT,JNDEX,PREC,JPLACE,LAB,XMED,XMAD,AW,NMVAL,
     1 RESDU,WEIGHTS,NDXX,NDXY,MVAL,NMXV,LUA,LUB,LUC,JHEAD,
     1 YNSAVE,JDIAG,ALGO,NSTOP,FNAMEA,FNAMEB,FNAMEC,OUTN1,OUTN2)

CK       IF (NSTOP.EQ.1) GOTO 30       NSTOP not used in RMIDAT ... 110427
       AL=NCAS
       ANVAR=NVAR
CC     ------------------------------------------------------------------------
CC     CREATE THE BEGINNING OF THE OUTPUT: THE SELECTED OPTIONS
CC     ------------------------------------------------------------------------
       CALL WRDATA(NVAR,NCAS,JCST,MVAL,JPRT,ALGO,YNSAVE,FNAMEA,FNAMEB,
     1 FNAMEC,JHEAD,LUB)
CC     ------------------------------------------------------------------------
CC     IF THE DATA CONTAIN MISSING VALUES, THEN TREAT THEM
CC     ------------------------------------------------------------------------
       IF (MVAL.NE.0) THEN
       CALL SMISSING(NVAR,NCAS,NDXX,NDXY,JCST,X,Y,AW,NMVAL,MVAL,
     1 JNDEX,JNDVC,VALMS,NSTOP,LAB,JPRT,LUB)
       IF (NSTOP.EQ.1) GOTO 20
       ENDIF
CC     ------------------------------------------------------------------------
CC     CREATE SECOND PART OF THE OUTPUT: THE DATA AND AN X-Y PLOT
CC     ------------------------------------------------------------------------
       CALL WRDATB(NVAR,NCAS,NDXX,NDXY,JCST,MVAL,LAB,NMVAL,X,Y,
     1 AW,JPLT,JPRT,JREG,JHEAD,LUB)
CC     ------------------------------------------------------------------------
CC     STANDARDIZATION OF THE DATA (WITH OPTIONAL PRINTING)
CC     AND CALCULATION OF SOME STATISTICS ON THE VARIABLES
CC     (IN THIS SUBROUTINE "RESDU" IS USED AS A WORKING VECTOR)
CC     ------------------------------------------------------------------------
       CALL STATIS(X,Y,XMED,XMAD,RESDU,WEIGHTS,AW,NMVAL,C,H,JNDVC,
     1 NSTOP,NVAR,NVAD,NVSB,NCAS,JCST,JPRT,NDXX,NDXY,LUB,NMXV,
     1 PREC,LAB)
       IF (NSTOP.EQ.1) GOTO 20
CC     ------------------------------------------------------------------------
CC     CALCULATION OF THE LS ESTIMATES
CC     ------------------------------------------------------------------------
       IF (NCAS.LE.(NVAR*2)) THEN
          CALL STTPUT('TOO MANY COEFFICIENTS ACCORDING TO THE ',ISTAT)
          CALL STTPUT('NUMBER OF CASES. NUMBER OF CASES',ISTAT) 
          WRITE(OUTEXT,8050) NCAS,NVAR
          CALL STTPUT(OUTEXT,ISTAT)
          CALL STTPUT('THE NUMBER OF CASES MUST BE TWICE THE NUMBER
     1 OF COEFFICIENTS.',ISTAT)
          IF (JCST.EQ.1) CALL STTPUT(' (INCLUDING THE 
     1 CONSTANT TERM!)',ISTAT)
          GOTO 20
       ENDIF
       JREG=1
       IF (NVAR.EQ.1) THEN
       CALL LSL(NCAS,NDXY,X,Y,WEIGHTS,A,FCKW,H,NMXV,NDXX)
       ELSE
       CALL LSREG(NDXX,NDXY,NMXV,NVAR,NCAS,NVAR,A,X,Y,WEIGHTS,DA,
     1 H,FCKW,HVEC,JDMB,JNDEX)
       ENDIF
CC     ------------------------------------------------------------------------
CC     RETRANSFORMATION OF THE LS ESTIMATES
CC     ------------------------------------------------------------------------
       CALL RTRAN(NVAR,JCST,NVSB,NVAD,NDXX,XMED,XMAD,A,NVAD,FCKW)
       CALL TRC(H,DA,NMXV,NDXX,NDXY,NVAR,JCST,NVSB,NVAD,XMED,XMAD)
CC     ------------------------------------------------------------------------
CC     PRINTING THE LS RESULTS WITH THE REQUESTED OPTIONS
CC     ------------------------------------------------------------------------
       CALL PRTRLS(NVAR,NCAS,JCST,NVSB,NVAD,NDXX,NDXY,NMXV,
     1 XMED,XMAD,A,DA,H,AW,RESDU,WEIGHTS,X,Y,NMVAL,AVW,NZWE,FCKW,
     1 JREG,JPRT,JPLT,JDIAG,JHEAD,LAB,PREC,LUB)
CC     ------------------------------------------------------------------------
CC     CALCULATION OF LMS REGRESSION
CC     ------------------------------------------------------------------------  
C       CALL STTPUT('',ISTAT)
       CALL STTPUT(' ALGORITHM FOR CALCULATING THE LEAST MEDIAN
     1 OF SQUARES IS STARTED.   ',ISTAT)

       CALL SUBLMS(NVAR,NCAS,JCST,NDXX,NDXY,NMXV,PREC,X,Y,
     1 XMED,XMAD,JDIAG,ALGO,FNAMEB,JQU,JREP,DRCTA,JNDA,RESDU,WEIGHTS,
     1 UHYB,AVW,NZWE,RSQ,JHYB,JDMB,JERD,JLP,NERR,DTERM,C,HVEC,JNDVC,AW)
CC     ------------------------------------------------------------------------
CC     RETRANSFORMATION OF THE LMS ESTIMATES
CC     ------------------------------------------------------------------------
       CALL RTRAN(NVAR,JCST,NVSB,NVAD,NDXX,XMED,XMAD,DRCTA,NVAD,FCKW)
       DRCTA(NVAD)=DRCTA(NVAD)*XMAD(NVAD)
CC     ------------------------------------------------------------------------
CC     PRINTING THE LMS RESULTS WITH THE REQUESTED OPTIONS
CC     ------------------------------------------------------------------------
       CALL PRTLMS(NVAR,NCAS,JCST,NVSB,NVAD,NDXX,NDXY,NMXV,JNDVC,XMED,
     1 XMAD,DRCTA,AW,RESDU,WEIGHTS,X,Y,NMVAL,UHYB,AVW,NZWE,RSQ,JREG,
     1 JPRT,JPLT,JREP,JERD,JLP,JQU,JHYB,JDIAG,NSTOP,JHEAD,LAB,PREC,LUB)
       IF (NSTOP.NE.1) THEN
CC     ------------------------------------------------------------------------
CC     CALCULATION OF RLS REGRESSION
CC     ------------------------------------------------------------------------
       JREG=3
       CALL STTPUT('PROGRESS IS CURRENTLY CALCULATING REWEIGHTED LEAST
     1 SQUARES ...',ISTAT)
       NNUL=NZWE
       DO 10 J=1,NDXX
       A(J)=0.0
       DA(J)=0.0
       DO 10 JNC=1,NMXV
  10   H(JNC,J)=0.D0
       IF (NVAR.EQ.1) THEN
       CALL LSL(NCAS,NDXY,X,Y,WEIGHTS,A,FCKW,H,NMXV,NDXX)
       ELSE
       CALL LSREG(NDXX,NDXY,NMXV,NVAR,NCAS,NVAR,A,X,Y,WEIGHTS,DA,
     1 H,FCKW,HVEC,JDMB,JNDEX)
       ENDIF
CC     ------------------------------------------------------------------------
CC     RETRANSFORMATION OF THE RLS ESTIMATES
CC     ------------------------------------------------------------------------
       CALL RTRAN(NVAR,JCST,NVSB,NVAD,NDXX,XMED,XMAD,A,NVAD,FCKW)
       CALL TRC(H,DA,NMXV,NDXX,NDXY,NVAR,JCST,NVSB,NVAD,XMED,XMAD)
CC     ------------------------------------------------------------------------
CC     PRINTING THE RLS RESULTS WITH THE REQUESTED OPTIONS
CC     ------------------------------------------------------------------------
       CALL PRTRLS(NVAR,NCAS,JCST,NVSB,NVAD,NDXX,NDXY,NMXV,
     1 XMED,XMAD,A,DA,H,AW,RESDU,WEIGHTS,X,Y,NMVAL,AVW,NZWE,FCKW,
     1 JREG,JPRT,JPLT,JDIAG,JHEAD,LAB,PREC,LUB)

CC-----UPDATES MIDAS TABLES
       CALL MIDUAL(A,JKEUS,NVAD,NCAS,NVAR,JCST,JPRT,NVAD,LUB,PREC,JREG,
     1 X,Y,RESDU,WEIGHTS,XMED,XMAD,NZWE,AVW,JPLT,AW,NMVAL,NDXX,NDXY,
     1 JHEAD,LAB,LUA,OUTN1,OUTN2)
       ENDIF

CC     END OF THE RUN
       CALL STTPUT('                                         ',ISTAT)
       CALL STTPUT(' THE RUN HAS SUCCESSFULLY BEEN EXECUTED. ',ISTAT)
       CALL STTPUT('                                         ',ISTAT)
     
 20    IF (YNSAVE.EQ.'Y') THEN
         WRITE (OUTEXT,8020) FNAMEC
         CALL STTPUT(OUTEXT,ISTAT)
       ENDIF	 
       IF (FNAMEA.NE.'CON') THEN
         WRITE(OUTEXT,8030) FNAMEA
         CALL STTPUT(OUTEXT,ISTAT)
       ENDIF	 
       IF (FNAMEB.NE.'CON'.AND.FNAMEB.NE.'PRN') THEN
         WRITE(OUTEXT,8040)FNAMEB
         CALL STTPUT(OUTEXT,ISTAT)
       ENDIF	 
CC     -----------------------------------------------------------------
CC     FORMATS
CC     -----------------------------------------------------------------
 8020  FORMAT(' THE DATA IS SAVED IN FILE : ',A30)
 8030  FORMAT(' THE DATA HAS BEEN READ FROM FILE : ',A30)
 8040  FORMAT(' THE OUTPUT HAS BEEN WRITTEN IN FILE : ',A30)
 8050  FORMAT( 8X,'= ',I5,' NUMBER OF COEFFICIENTS = ',I5)

CK  30    CONTINUE
       CALL STSEPI
       END
CC     ------------------------------------------------------------------------
CC     SUBROUTINE FOR CREATING THE BEGINNING OF THE OUTPUT:
CC                      - DESCRIPTION OF THE SELECTED OPTIONS
CC     ------------------------------------------------------------------------
       SUBROUTINE WRDATA(NVAR,NCAS,JCST,MVAL,JPRT,ALGO,YNSAVE,FNAMEA,
     1 FNAMEB,FNAMEC,JHEAD,LUB)

       INCLUDE 'MID_REL_INCL:implicit.inc'

       CHARACTER ALGO,YNSAVE
       CHARACTER*30 FNAMEA,FNAMEB,FNAMEC
       CHARACTER*60 JHEAD
       WRITE(LUB,8050)
       WRITE(LUB,8040)JHEAD
       IF (JCST.EQ.0) THEN
          WRITE(LUB,8000) NCAS,NVAR	  
       ELSEIF (JCST.NE.0) THEN
          WRITE(LUB,8010) NCAS,NVAR
       ENDIF	  
       IF (ALGO.EQ.'Q') THEN
          WRITE(LUB,8020)	  
       ELSEIF (ALGO.EQ.'E') THEN
          WRITE(LUB,8030)
       ENDIF	  
CX       IF (FNAMEB.EQ.'CON') PAUSE ' '		=> STETER call
       IF (FNAMEB.EQ.'CON') THEN
          CALL STETER(44,'FNAMEB.EQ."CON" in WRDATA()')
       ENDIF

CC-----TREATMENT OF MISSING VALUES
       IF (MVAL.EQ.0) THEN
          WRITE(LUB,8060)
       ELSEIF (MVAL.EQ.1) THEN
          WRITE(LUB,8070)
       ELSEIF (MVAL.EQ.2) THEN
          WRITE(LUB,8080)
       ENDIF  
       IF (JPRT.EQ.0) THEN
          WRITE(LUB,8090)
       ELSEIF (JPRT.EQ.1) THEN 
          WRITE(LUB,8100)
       ELSEIF (JPRT.EQ.2) THEN
          WRITE(LUB,8110)
       ENDIF  
       IF (YNSAVE.EQ.'Y') THEN
          WRITE(LUB,8120) FNAMEC
       ENDIF  
       IF (FNAMEA.NE.'CON') THEN
          WRITE(LUB,8130) FNAMEA
       ENDIF  
 8000  FORMAT(//' REGRESSION WITHOUT A CONSTANT TERM.'//
     1 ' NUMBER OF CASES',8X,'= ',I5/
     1 ' NUMBER OF COEFFICIENTS = ',I5)
 8010  FORMAT(/' REGRESSION WITH A CONSTANT TERM.'//
     1 ' NUMBER OF CASES',8X,'= ',I5/
     1 ' NUMBER OF COEFFICIENTS (INCLUDING CONSTANT TERM) = ',I5)
 8020  FORMAT(/' THE QUICK VERSION WILL BE USED.')
 8030  FORMAT(/' THE EXTENSIVE SEARCH VERSION WILL BE USED.')
 8040  FORMAT(/' DATA SET = ',A60)
 8050  FORMAT(//30X,19('*')/30X,'* P R O G R E S S *'/
     1 30X,19('*')///' This program performs a robust regression',
     1 ' analysis based on'/' the least median of squares',
     1 ' (LMS) method as described in'/3X,
     1 ' P. Rousseeuw (1984), Least Median of Squares Regression',/
     1 '    Journal of the American Statistical Association, 79,',
     1' 871-880.'/' A user manual to this program is the book:'/
     1 '    P. Rousseeuw and A. Leroy (1987), Robust Regression'/
     1 '    and Outlier Detection, Wiley, New York.'/)
 8060  FORMAT(/' THERE ARE NO MISSING VALUES.')
 8070  FORMAT(/' TREATMENT OF MISSING VALUES IN OPTION 1:',
     1 ' THIS MEANS THAT A CASE WITH A/14H MISSING VALUE',
     1 ' FOR AT LEAST ONE VARIABLE WILL BE DELETED.'/)
 8080  FORMAT(/' TREATMENT OF MISSING VALUES IN OPTION 2:'/
     1 ' FIRST, A CASE WITH A MISSING VALUE FOR THE RESPONSE VARIABLE'
     1 /' OR FOR ALL EXPLANATORY VARIABLES WILL BE DELETED.'/
     1 ' THEN, A MISSING VALUE FOR A VARIABLE WILL BE REPLACED BY'/
     1 ' THE MEDIAN OF THE NON-MISSING VALUES .'/)
 8090  FORMAT(/' SMALL OUTPUT IS WANTED.')
 8100  FORMAT(/' MEDIUM-SIZED OUTPUT IS WANTED.')
 8110  FORMAT(/' LARGE OUTPUT IS WANTED.')
 8120  FORMAT(//' THE DATA ARE SAVED IN FILE : ',A30/)
 8130  FORMAT(/' YOUR DATA RESIDE IN FILE',7X,': ',A30/)
       RETURN
       END
CC     ------------------------------------------------------------------------
CC     SUBROUTINE FOR CREATING THE SECOND PART OF THE OUTPUT:
CC                     - WRITING DOWN THE OBSERVATIONS
CC                     - AN X-Y PLOT
CC     ------------------------------------------------------------------------
       SUBROUTINE WRDATB(NVAR,NCAS,NDXX,NDXY,JCST,MVAL,LAB,NMVAL,X,Y,
     1 AW,JPLT,JPRT,JREG,JHEAD,LUB)

       INCLUDE 'MID_REL_INCL:implicit.inc'

       DIMENSION X(NDXX,NDXY),Y(NDXY),AW(NDXY),NMVAL(NDXY)
       CHARACTER*10 LAB(NDXX)
       CHARACTER*60 JHEAD
       NVSB=NVAR-1
       NVAD=NVAR+1
       IF ((NVAR.EQ.1.AND.JCST.EQ.0).OR.
     1 (NVAR.EQ.2.AND.JCST.EQ.1)) JPLXY=1
       IF (JPRT.EQ.2) THEN
         IF (MVAL.EQ.0) WRITE(LUB,8110)
         IF (MVAL.NE.0) WRITE(LUB,8120)
         IF (JCST.EQ.1) WRITE(LUB,8130) (LAB(J),J=1,NVSB),LAB(NVAD)
         IF (JCST.EQ.0) WRITE(LUB,8130) (LAB(J),J=1,NVAD)
       ENDIF
       DO 10 JNC=1,NCAS
       IF(JPRT.GE.2) THEN
       IF((NVAD.GT.6.AND.JCST.EQ.0).OR.(NVAD.GT.7.AND.JCST.EQ.1))
     1 GOTO 15
       IF (JCST.EQ.1) WRITE(LUB,8140) NMVAL(JNC),(X(J,JNC),J=1,NVSB),
     1 X(NVAD,JNC)
       IF (JCST.EQ.0) WRITE(LUB,8140) NMVAL(JNC),(X(J,JNC),J=1,NVAD)
       GOTO 5
 15    WRITE(LUB,8140) NMVAL(JNC),(X(J,JNC),J=1,6)
       IF (JCST.EQ.1.AND.NVSB.GE.7)
     1 WRITE(LUB,8150) (X(J,JNC),J=7,NVSB),X(NVAD,JNC)
       IF (JCST.EQ.1.AND.NVSB.LT.7) WRITE(LUB,8150) X(NVAD,JNC)
       IF (JCST.EQ.0) WRITE(LUB,8150) (X(J,JNC),J=7,NVAD)
       ENDIF
  5    IF (JPLXY.EQ.1) THEN
       AW(JNC)=X(1,JNC)
       Y(JNC)=X(NVAD,JNC)
       ENDIF
  10   CONTINUE
       IF (JPLXY.EQ.1)
     1 CALL GRAF(AW,Y,NCAS,JPLXY,0,JPLT,NMVAL,NDXY,LUB,JREG,
     1 JHEAD,NDXX,NVAD,LAB)
 8110  FORMAT(/' THE OBSERVATIONS ARE:'/)
 8120  FORMAT(/' THE OBSERVATIONS, AFTER TREATMENT'
     1 ' OF MISSING VALUES ARE:'/)
 8130  FORMAT(7X,6(A10,1X)/15X,5(A10,1X))
 8140  FORMAT(I5,2X,6(F10.4,1X))
 8150  FORMAT(15X,5(F10.4,1X))
       RETURN
       END
CC     ------------------------------------------------------------------------
CC     SUBROUTINE FOR COMPUTING THE ELEMENTS OF THE HAT MATRIX
CC     ------------------------------------------------------------------------
       SUBROUTINE SUBHAT(NVAR,NCAS,NDXX,NDXY,NMXV,X,XMED,XMAD,H,AW,
     1 WEIGHTS,NMVAL,FCKW,LUB)

       INCLUDE 'MID_REL_INCL:implicit.inc'

       DIMENSION X(NDXX,NDXY),AW(NDXY),NMVAL(NDXY),WEIGHTS(NDXY)
       DOUBLE PRECISION H(NMXV,NDXX)
       DIMENSION XMED(NDXX),XMAD(NDXX)
       DO 10 J=1,NVAR
       DO 10 J2=1,J
       H(J,J2)=H(J,J2)/DBLE(FCKW)
       H(J2,J)=H(J,J2)
 10    CONTINUE
       IF (NCAS.LE.20) WRITE (LUB,8000)
       IF (NCAS.GT.20) WRITE (LUB,8010)
       DO 20 JNA=1,NCAS
       DO 30 JNB=1,NCAS
       IF (NCAS.GT.20.AND.JNA.NE.JNB) GOTO 30
       AW(JNB)=0.0
       DO 40 J=1,NVAR
       DO 50 J2=1,NVAR
       RHJ2J=H(J2,J)
       AW(JNB)=AW(JNB)+(X(J2,JNA)*XMAD(J2)+XMED(J2))*WEIGHTS(JNA)*
     1 RHJ2J*(X(J,JNB)*XMAD(J)+XMED(J))*WEIGHTS(JNB)
 50    CONTINUE
 40    CONTINUE
 30    CONTINUE
       IF (NCAS.LE.9) THEN
         WRITE(LUB,8020) NMVAL(JNA),(AW(JNB),JNB=1,NCAS)
         GOTO 20
       ENDIF
       IF (NCAS.GT.20) THEN
         WRITE(LUB,8020) NMVAL(JNA),AW(JNA)
                       ELSE
         WRITE(LUB,8020) NMVAL(JNA),(AW(JNB),JNB=1,9)
         WRITE(LUB,8030) (AW(JNB),JNB=10,NCAS)
       ENDIF
 20    CONTINUE
 8000  FORMAT(//' --- THE HAT MATRIX ---'/1X,22('-'))
 8010  FORMAT(//' THE DIAGONAL ELEMENTS OF THE HAT MATRIX'/1X,40('-'))
 8020  FORMAT(1X,I4,1X,9(F6.3,2X))
 8030  FORMAT(4X,F8.3,F8.3,F8.3,F8.3,F8.3,F8.3,F8.3,F8.3,F8.3)
       RETURN
       END
CC     ------------------------------------------------------------------------
CC     PRINTING THE RLS ESTIMATES AND SOME OPTIONS
CC     ------------------------------------------------------------------------
       SUBROUTINE PRTRLS(NVAR,NCAS,JCST,NVSB,NVAD,NDXX,NDXY,NMXV,
     1 XMED,XMAD,A,DA,H,AW,RESDU,WEIGHTS,X,Y,NMVAL,AVW,NZWE,FCKW,
     1 JREG,JPRT,JPLT,JDIAG,JHEAD,LAB,PREC,LUB)

       INCLUDE 'MID_REL_INCL:implicit.inc'

       INTEGER   UNIT,STATUS
       DIMENSION X(NDXX,NDXY),Y(NDXY),WEIGHTS(NDXY),A(NMXV),DA(NMXV)
       DIMENSION XMED(NDXX),XMAD(NDXX),AW(NDXY),RESDU(NDXY),NMVAL(NDXY)
       DOUBLE PRECISION H(NMXV,NDXX),DS,PTVAL,DST,PVAL
       CHARACTER*10 LAB(NDXX)
       CHARACTER*60 JHEAD

       AL=NCAS
       ANVAR=NVAR
       WRITE(LUB,8000)
       IF (JREG.EQ.1) THEN
       WRITE(LUB,8010)
       NNUL=NCAS
       AVW=1
       ELSE
       WRITE(LUB,8020)
       NNUL=NZWE
       ENDIF
       NDF=NNUL-NVAR
CC-----PRINTING THE COEFFICIENTS WITH THEIR STANDARD ERROR,
CC-----AND T-VALUE
       WRITE(LUB,8030)
C       
       DO 10 J=1,NVSB
       IF (DA(J).LT.PREC) DA(J)=PREC
       STUD=A(J)/DA(J)
       DS=DBLE(STUD)
       DST=PTVAL(DS,NDF)
       RDST=DST
       WRITE(LUB,8040) LAB(J),A(J),DA(J),STUD,RDST
C----put value into MIDAS keyword OUTPUTR(1):
       CALL STKWRR('OUTPUTR',A(J),J,1,UNIT,STATUS)
C----put also error into MIDAS keyword, use OUTPUTR(3)
       CALL STKWRR('OUTPUTR',DA(J),J+2,1,UNIT,STATUS)    
C           
 10    CONTINUE
       IF(DA(NVAR).LT.PREC) DA(NVAR)=PREC
       STUD=A(NVAR)/DA(NVAR)
       DS=DBLE(STUD)
       DST=PTVAL(DS,NDF)
       RDST=DST
       IF (JCST.EQ.0) WRITE(LUB,8040) LAB(NVAR),A(NVAR),DA(NVAR),
     1 STUD,RDST
       IF (JCST.EQ.1) WRITE(LUB,8050) A(NVAR),DA(NVAR),STUD,RDST
C----put value into MIDAS keyword OUTPUTR(2):        
       CALL STKWRR('OUTPUTR',A(NVAR),NVAR,1,UNIT,STATUS)
C----put error into MIDAS keyword, use OUTPUTR(4)        
       CALL STKWRR('OUTPUTR',DA(NVAR),NVAR+2,1,UNIT,STATUS)
C              
CC-----CALCULATION OF THE COEFFICIENT OF DETERMINATION AND F-VALUE
       RSQ=RSQU(NCAS,NVAD,JCST,Y,NDXY,FCKW,FVALUE,PREC,
     1 XMAD,XMED,NDXX,WEIGHTS,NNUL)
CC-----CALCULATION OF THE SCALE ESTIMATE
       A(NVAD) = SQRT(FCKW/(AL*AVW-ANVAR))
       IF (JREG.EQ.1) THEN
       WRITE(LUB,8080) FCKW
                      ELSE
       WRITE(LUB,8090) FCKW
       ENDIF
       WRITE(LUB,8060) NDF
       WRITE(LUB,8070) A(NVAD)
CC-----PRINTING THE VARIANCE-COVARIANCE MATRIX
       CALL SCHCV(NVAR,NDXX,NMXV,H,LUB)
CC-----IF DIAGNOSTICS ARE REQUESTED, THEN PRINT THE HAT MATRIX
CC-----                              OR THE DIAGONAL ELEMENTS ONLY
       FCKW=FCKW/(AL*AVW-ANVAR)
       IF(FCKW.LT.PREC)GOTO 24
       IF (JDIAG.EQ.1) CALL SUBHAT(NVAR,NCAS,NDXX,NDXY,NMXV,X,XMED,
     1 XMAD,H,AW,WEIGHTS,NMVAL,FCKW,LUB)
CC-----PRINT COEFFICIENT OF DETERMINATION, F-VALUE, AND P-VALUE
  24   WRITE(LUB,8100) RSQ
       NDF1=NVAR-JCST
       DS=DBLE(FVALUE)
       DST=PVAL(DS,NDF1,NDF)
       RDST=DST
       WRITE(LUB,8110) FVALUE,NDF1,NDF,RDST
       IF (JREG.EQ.3) THEN
          WRITE(LUB,8200) NNUL
          WRITE(LUB,8210) AVW
          JKEUS=2
                      ELSE
          JKEUS=0
       ENDIF
CC-----GIVE RESIDUAL PLOTS IF REQUESTED
       IF(JPRT.NE.0.OR.JPLT.NE.0) THEN
       CALL RDUAL(A,JKEUS,NVAD,NCAS,NVAR,JCST,JPRT,NVAD,LUB,PREC,JREG,
     1 X,Y,RESDU,WEIGHTS,XMED,XMAD,NZWE,AVW,JPLT,AW,NMVAL,NDXX,NDXY,
     1 JHEAD,LAB)

       ENDIF

 8000  FORMAT(/1X,78('*')/)
 8010  FORMAT(' LEAST SQUARES REGRESSION '/1X,24('*')/)
 8020  FORMAT(' REWEIGHTED LEAST SQUARES BASED ON THE LMS'/
     1 1X,41('*')/)
 8030  FORMAT(/5X,'VARIABLE',5X,'COEFFICIENT',
     1 4X,'STAND. ERROR',5X,'T - VALUE',5X,'P - VALUE'/
     1 3X,70('-'))
 8040  FORMAT(3X,A10,5X,F11.5,4X,F12.5,5X,F9.5,5X,F9.5)
 8050  FORMAT(5X,'CONSTANT',5X,F11.5,4X,F12.5,5X,F9.5,5X,F9.5)
 8060  FORMAT(/' DEGREES OF FREEDOM ',5X,'= ',4X,I5)
 8070  FORMAT(/' SCALE ESTIMATE',10X,'= ',F15.5/)
 8080  FORMAT(/' SUM OF SQUARES',10X,'= ',F15.5)
 8090  FORMAT(/' WEIGHTED SUM OF SQUARES'' = ',F15.5)
 8100  FORMAT(/' COEFFICIENT OF DETERMINATION (R SQUARED) =',F15.5/)
 8110  FORMAT(' THE F-VALUE = ',F12.3,' (WITH ',I3,' AND ',
     1 I4,' DF)',3X,'P - VALUE = ',F7.5)
 8200  FORMAT(/'THERE ARE',2X,I4,
     1 ' POINTS WITH NON-ZERO WEIGHT.' )
 8210  FORMAT(/' AVERAGE WEIGHT',10X,'= ',F15.5/)
       RETURN
       END
CC     ------------------------------------------------------------------------
CC     SUBROUTINE FOR CALCULATING THE LMS REGRESSION
CC     ------------------------------------------------------------------------
       SUBROUTINE SUBLMS(NVAR,NCAS,JCST,NDXX,NDXY,NMXV,PREC,X,Y,
     1 XMED,XMAD,JDIAG,ALGO,FNAMEB,JQU,JREP,DRCTA,JNDA,RESDU,WEIGHTS,
     1 UHYB,AVW,NZWE,RSQ,JHYB,JDMB,JERD,JLP,NERR,DTERM,C,HVEC,JNDVC,AW)

       INCLUDE 'MID_REL_INCL:implicit.inc'

       DIMENSION X(NDXX,NDXY),Y(NDXY),C(NMXV,NDXX),DRCTA(NDXX)
       DIMENSION JNDA(NMXV),JNDVC(NDXX),XMED(NDXX),XMAD(NDXX)
       DIMENSION AW(NDXY),RESDU(NDXY),UHYB(NDXY),WEIGHTS(NDXY)
       DOUBLE PRECISION HVEC(JDMB)
       DOUBLE PRECISION DTERM
       CHARACTER ALGO
       CHARACTER*30 FNAMEB
       CHARACTER*80 CBUF
CC-----LIST OF VARIABLES WHICH ENTER "SUBLMS" (WITHOUT CHANGING INSIDE)
CC     NVAR, NCAS, JCST, NDXX, NDXY, NMXV, PREC,
CC     X, Y, XMED, XMAD, JDIAG, ALGO, FNAMEB
CC-----LIST OF VARIABLES THE VALUE OF WHICH IS CALCULATED IN "SUBLMS"
CC     JQU, JREP, DRCTA, JNDA, RESDU, WEIGHTS, UHYB, AVW, NZWE, RSQ,
CC     JHYB, JDMB, JERD, JLP, NERR, DTERM
CC-----LIST OF VARIABLES WHICH ARE NEEDED FOR THE CALCULATIONS
CC     C, HVEC, JNDVC, AW
CC-----LIST OF SUBROUTINES USED IN "SUBLMS"
CC     SUBROUTINE SUBREP
CC     SUBROUTINE GENPN
CC     SUBROUTINE RANPN
CC     SUBROUTINE EQUAT
CC     SUBROUTINE RESTT
CC     SUBROUTINE RANGS
CC     SUBROUTINE SHHLF
CC     FUNCTION PULL
CC-----INITIALIZATIONS
       JERD=0
       JFRST=0
       JEY=0
       AVW=0.0
       NZWE=0
       JREADZ=0
       JHYB=JDIAG
       AL=NCAS
       ANVAR=NVAR
CC-----CALCULATION OF JQU, THE RANK OF THE ABSOLUTE RESIDUAL TO BE MINIMIZED
       JQU = INT(AL/2.0) + INT( (ANVAR+1.0)/2.0 )
CC-----CALCULATE THE NUMBER OF REPLICATIONS
       CALL SUBREP(NVAR,NCAS,NDXX,ALGO,JNDVC,JREP)
CC-----MAXIMAL NUMBER OF REPLICATIONS
       MAXRP=3*JREP
       NVSB=NVAR-1
       NVAD=NVAR+1
CC-----START OF THE ALGORITHM : THE "10" LOOP PERFORMS THE REPLICATIONS
       DO 10 JJJ=1,JREP
CC-----IF (JNDVC(NVAD) = 11 THEN TAKE A COMBINATION OF NVAR POINTS
CC-----OUT OF NCAS, ELSE TAKE A RANDOM SAMPLE OF NVAR POINTS OUT OF NCAS
 20    IF(JNDVC(NVAD).EQ.11) THEN
       CALL GENPN(NCAS,NVAR,JNDVC,NDXX,JJJ)
       ELSE
           IF (JJJ.GT.2) THEN
             CALL RANPN(NCAS,NVAR,JNDVC,NDXX,JEY,JLP,MAXRP)
             IF (JLP.GT.MAXRP) GOTO 210
           ELSE
             IF (JJJ.EQ.2) THEN
             JLP=JLP+1
             DO 30 MNDX=1,NVAR
 30             JNDVC(MNDX)=NCAS-MNDX+1
                           ELSE
             JLP=JLP+1
             DO 40 MNDX=1,NVAR
 40             JNDVC(MNDX)=MNDX
             ENDIF
           ENDIF
       ENDIF
CC-----STORE THE NVAR SELECTED OBSERVATIONS IN THE MATRIX C
       DO 50 MNDX=1,NVAR
         DO 60 KJ=1,NVAD
           NDR=JNDVC(MNDX)
           C(MNDX,KJ)=X(KJ,NDR)
 60         CONTINUE
 50    CONTINUE
CC-----THE FOLLOWING FIVE LINES ARE INSTRUCTIONS FOR INFORMING
CC-----THE USER ABOUT HOW FAR THE CALCULATIONS OF THE LMS ARE ALREADY ADVANCED
CC-----(THESE LINES MAY BE DELETED IF USED ON OTHER COMPUTER)
       JREADY=(JJJ*100)/JREP
       IF (MOD(JREADY,5).EQ.0.AND.JREADY.NE.JREADZ) THEN
           WRITE(CBUF,65) JREADY
 65        FORMAT(I4,' PERCENT OF THE CALCULATIONS HAVE BEEN EXECUTED.')
           CALL STTPUT(CBUF,ISTAT)
       ENDIF	   
CX       IF (FNAMEB.EQ.'CON'.AND.JREADY.GE.100) PAUSE ' '	=> STETER call
       IF (FNAMEB.EQ.'CON'.AND.JREADY.GE.100) THEN
          CALL STETER
     +    (45,'FNAMEB.EQ."CON".AND.JREADY.GE.100 in SUBLMS()')
       ENDIF
 
       JREADZ=JREADY

CC-----SOLVE THE SYSTEM OF EQUATIONS STORED IN C
       IF(NVAR.GT.1) THEN
         CALL EQUAT(C,NMXV,NDXX,HVEC,JDMB,NVAR,1,NERR,DTERM)
         IF(NERR.GE.0) GOTO 70
         JERD=JERD+1
         IF (JNDVC(NVAD).NE.11.AND.JJJ.GT.2) GOTO 20
         GOTO 10
                     ELSE
         IF(C(1,1).NE.0.0) C(1,1)=C(1,2)/C(1,1)
       ENDIF
CC-----CALCULATE THE RESIDUALS AND THE ASSOCIATED OBJECTIVE FUNCTION
CC-----VALUE FOR THE TRIAL ESTIMATE OBTAINED ABOVE
 70    DO 80 JNC=1,NCAS
       RESDU(JNC)=0.0
       DO 90 J=1,NVAR
       RESDU(JNC)=RESDU(JNC)+C(J,1)*X(J,JNC)
 90    CONTINUE
       RESDU(JNC)=ABS(X(NVAD,JNC)-RESDU(JNC))
 80    CONTINUE
       FCTVA=PULL(AW,NDXY,RESDU,NCAS,JQU)*1.4826
CC-----INITIALIZE THE "BEST" ESTIMATE AND OBJECTIVE FUNCTION VALUE
       IF(JFRST.NE.1) THEN
         JFRST=1
         DRCTA(NVAD)=FCTVA
         DO 100 J=1,NVAR
         JNDA(J)=JNDVC(J)
         DRCTA(J)=C(J,1)
 100         CONTINUE
         IF (FCTVA.LT.PREC) JHYB=0
CC-----IF DIAGNOSTICS ARE WANTED, THEN CALCULATE THE RDi
         IF (JHYB.EQ.0) GOTO 200
         DO 110 JNC=1,NCAS
         UHYB(JNC)=RESDU(JNC)/FCTVA*1.4826
 110         CONTINUE
                      ELSE
 120         IF(FCTVA.LT.PREC) JHYB=0
         IF (JHYB.NE.0) THEN
           DO 130 JNC=1,NCAS
           UH=RESDU(JNC)/FCTVA*1.4826
           IF(UHYB(JNC).LT.UH) UHYB(JNC)=UH
 130           CONTINUE
         ENDIF
CC-----UPDATE THE "BEST" ESTIMATE AND OBJECTIVE FUNCTION VALUE
CC-----IF NECESSARY
         IF (FCTVA.LT.DRCTA(NVAD)) THEN
           DRCTA(NVAD)=FCTVA
           DO 140 J=1,NVAR
           JNDA(J)=JNDVC(J)
 140           DRCTA(J)=C(J,1)
         ENDIF
       ENDIF
CC-----IF FCTVA IS LESS THAN PREC (A PRECISION CONSTANT) THEN ONE IS
CC-----RESORTED TO THE EXACT FIT CASE
 200   CONTINUE
C       write(6,*) 'FCTVA,PREC', FCTVA, PREC
       IF (FCTVA.LE.PREC) THEN
          DRCTA(NVAD)=FCTVA 
          CALL RESTT(DRCTA,1,0,NVAR,NCAS,NVAD,NZWE,X,Y,RESDU,WEIGHTS,
     1          XMED,XMAD,NDXX,NDXY,0,SCAL,QUAN,PREC)
          AVW=(NZWE*1.0 )/AL
C          RETURN
       ENDIF
 10    CONTINUE
 210   CONTINUE
CC-----ADJUSTING THE INTERCEPT IN THE CASE OF A MODEL WITH
CC-----CONSTANT TERM
       write(CBUF,*) 'JCST = ',JCST
       CALL STTPUT(CBUF,ISTAT)
       IF (JCST.NE.0) THEN
          CALL RESTT(DRCTA,0,0,NVSB,NCAS,NVAD,NZWE,X,Y,RESDU,
     1          WEIGHTS,XMED,XMAD,NDXX,NDXY,0,SCAL,QUAN,PREC)
          CALL RANGS(RESDU,NCAS)
          CALL SHHLF(RESDU,NCAS,JQU,SLUTN,BSTD,PREC)
          DRCTA(NVAR)=SLUTN
          DRCTA(NVAD)=BSTD*1.4826
       ENDIF
CC-----COMPUTING THE FINAL SCALE ESTIMATE OF THE LMS AND THE
CC-----RESULTING WEIGHTS
       QUAN=DRCTA(NVAD)
       QUAN=QUAN*(5.0/(AL-ANVAR)+1.0)
       CALL RESTT(DRCTA,1,0,NVAR,NCAS,NVAD,NZWE,
     1 X,Y,RESDU,WEIGHTS,XMED,XMAD,NDXX,NDXY,1,SCAL,QUAN,PREC)
       DRCTA(NVAD)=SCAL
       AVW=(NZWE*1.0)/AL
CC-----COEFFICIENT OF DETERMINATION CORRESPONDING TO THE LMS
       RSQ= DRCTA(NVAD)*XMAD(NVAD)
       DO 220 JNC=1,NCAS
 220   AW(JNC)=ABS(Y(JNC)*XMAD(NVAD))
       RSY=PULL(AW,NDXY,AW,NCAS,JQU)*1.4826
       RSQ=1.0-(RSQ/RSY)**2
       IF (RSQ.LT.0.0) RSQ=0.0
       IF (RSQ.GT.1.0) RSQ=1.0
       RETURN
       END
CC     ------------------------------------------------------------------------
CC     PRINTING  LMS ESTIMATES AND SOME OPTIONS
CC     ------------------------------------------------------------------------
       SUBROUTINE PRTLMS(NVAR,NCAS,JCST,NVSB,NVAD,NDXX,NDXY,NMXV,JNDVC,
     1 XMED,XMAD,DRCTA,AW,RESDU,WEIGHTS,X,Y,NMVAL,UHYB,AVW,NZWE,RSQ,
     1 JREG,JPRT,JPLT,JREP,JERD,JLP,JQU,JHYB,JDIAG,NSTOP,JHEAD,LAB,
     1 PREC,LUB)

       INCLUDE 'MID_REL_INCL:implicit.inc'

       DIMENSION X(NDXX,NDXY),Y(NDXY),XMED(NDXX),XMAD(NDXX),UHYB(NDXY)
       DIMENSION DRCTA(NMXV),AW(NDXY),RESDU(NDXY),NMVAL(NDXY)
       DIMENSION WEIGHTS(NDXY)
       DIMENSION JNDVC(NDXX)
       CHARACTER*10 LAB(NDXX)
       CHARACTER*60 JHEAD
       WRITE(LUB,8000)
       WRITE(LUB,8010)
       IF (JPRT.NE.0) WRITE(LUB,8020) JQU
       NSTOP=0
       IF (JERD.NE.0) THEN
       IF (JNDVC(NVAD).NE.11) THEN
          IF  (JERD.EQ.JLP) THEN
              WRITE(LUB,8030) NVAR,NCAS
              NSTOP=1
              RETURN
                            ELSE
              IF (JPRT.NE.0) WRITE(LUB,8040) JLP,NVAR,NCAS,JERD
          ENDIF
                              ELSE
          IF (JERD.EQ.JREP) THEN
             WRITE(LUB,8050) NVAR,NCAS
             NSTOP=1
             RETURN
                            ELSE
             IF (JPRT.NE.0) WRITE(LUB,8060) JERD,NVAR,NCAS,JREP
          ENDIF
       ENDIF
       ENDIF
CC-----LMS IN THE CASE OF EXACT FIT
       IF (DRCTA(NVAD).LE.PREC) THEN
          WRITE(LUB,8070)
          DO 10 J=1,NVSB
 10          WRITE(LUB,8080) LAB(J),DRCTA(J)
          IF (JCST.EQ.0) WRITE(LUB,8080) LAB(NVAR),DRCTA(NVAR)
          IF (JCST.NE.0) WRITE(LUB,8090) DRCTA(NVAR)
          WRITE(LUB,8100) DRCTA(NVAD)
          WRITE(LUB,8110) NZWE
          JREG=2
CC-----RESIDUAL PLOT FOR THE LMS IN THE CASE OF EXACT FIT
          CALL RDUAL(DRCTA,0,NVAD,NCAS,NVAR,JCST,JPRT,NVAD,LUB,PREC,
     1    JREG, X,Y,RESDU,WEIGHTS,XMED,XMAD,NZWE,AVW,JPLT,AW,NMVAL,
     1    NDXX,NDXY,JHEAD,LAB)
          NSTOP=1
          RETURN
       ENDIF
CC-----LMS IN THE GENERAL CASE
       WRITE(LUB,8130)
       DO 20 J=1,NVSB
 20    WRITE(LUB,8080) LAB(J),DRCTA(J)
       IF (JCST.EQ.0) WRITE(LUB,8080) LAB(NVAR),DRCTA(NVAR)
       IF (JCST.NE.0) WRITE(LUB,8090) DRCTA(NVAR)
       WRITE(LUB,8200) DRCTA(NVAD)
CC-----PRINT COEFFICIENT OF DETERMINATION OF THE LMS
       WRITE(LUB,8210) RSQ
       JREG=2
CC-----RESIDUAL PLOTS IF REQUESTED
       CALL RDUAL(DRCTA,1,NVAD,NCAS,NVAR,JCST,JPRT,NVAD,LUB,PREC,JREG,
     1 X,Y,RESDU,WEIGHTS,XMED,XMAD,NZWE,AVW,JPLT,AW,NMVAL,NDXX,NDXY,
     1 JHEAD,LAB)
       IF (JHYB.NE.0.AND.JDIAG.EQ.1) THEN
          WRITE(LUB,8220)
          UH=AMDAN(AW,NDXY,UHYB,NCAS)
          DO 40 JNC=1,NCAS
          RDI=UHYB(JNC)/UH
          WRITE(LUB,8230) NMVAL(JNC),UHYB(JNC),RDI
 40    CONTINUE
       ENDIF
 8000  FORMAT(/1X,78('*')/)
 8010  FORMAT(' LEAST MEDIAN OF SQUARES REGRESSION'/
     1 1X,34('*')/)
 8020  FORMAT(' THE MINIMIZATION OF THE ',I4,
     1 'TH ORDERED SQUARED RESIDUAL IS PERFORMED.')
 8030  FORMAT(//' ALL SUBSAMPLES OF ',I3,' POINTS OUT OF ',I5,
     1 ' LED TO A SINGULAR SYSTEM OF EQUATIONS.'/
     1 ' THIS MEANS THAT THERE IS AN ENORMOUS PROBLEM OF',
     1 ' COLLINEARITY IN THE DATA SET.'/
     1 ' TRY THE ANALYSIS AGAIN IN A LOWER DIMENSION.'//)
 8040  FORMAT(/' ON A TOTAL OF ',I8,' SUBSAMPLES (OF',
     1 I3,'POINTS OUT OF ',I5,')', /I7,
     1 ' SUBSAMPLES LED TO A SINGULAR SYSTEM OF EQUATIONS.'/
     1 ' THE SOLUTION IS ONLY BASED ON THE GOOD SUBSAMPLES.'//)
 8050  FORMAT(//' ALL COMBINATIONS OF ,I3,15H POINTS OUT OF ',I5,
     1 ' LED TO A SINGULAR SYSTEM OF EQUATIONS.'/
     1 ' THIS MEANS THAT THERE IS AN ENORMOUS PROBLEM OF',
     1 ' COLLINEARITY IN THE DATA SET.'/
     1 ' TRY THE ANALYSIS AGAIN IN A LOWER DIMENSION.'//)
 8060  FORMAT(/' THERE WERE ',I7,' COMBINATIONS (OF ',I3,
     1 ' POINTS OUT OF ,I5,16H) OF A TOTAL OF '/I8,' COMBINATIONS,',
     1 ' WHICH LED TO A SINGULAR SYSTEM OF EQUATIONS.'/
     1 ' THE SOLUTION IS ONLY BASED ON THE GOOD COMBINATIONS.'//)
 8070  FORMAT(/' MORE THAN THE HALF OF THE DATA LIE ON THE'
     1 /' SAME HYPERPLANE, WITH COEFFICIENTS = '//)
 8080  FORMAT(3X,A10,F20.5)
 8090  FORMAT(3X,'  CONSTANT',F20.5)
 8100  FORMAT(/' SCALE ESTIMATE',10X,'= ',F15.5/)
 8110  FORMAT(' THERE ARE',2X,I4,' POINTS ON THE HYPERPLANE')
 8130  FORMAT(/5X,'VARIABLE',9X,'COEFFICIENT'/3X,30('-'))
 8200  FORMAT(/' FINAL SCALE ESTIMATE',9X,'= ',F15.5)
 8210  FORMAT(/' COEFFICIENT OF DETERMINATION = ',F15.5/)
 8220  FORMAT(//1X,'INDEX',3X,'      Ui     ',3X,'RESISTANT '/
     1 25X,'DIAGNOSTIC'/1X,34('-'))
 8230  FORMAT(1X,I4,3X,F13.4,3X,F10.4)
       RETURN
       END

C @(#)ainfo.for	19.1 (ES0-DMD) 02/25/03 13:18:59
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
       SUBROUTINE AINFO(ORD)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C  writes information on the noise statistics and filter performance
C  to the terminal:
C      ORD   : order
C      EG    : exspectation value by noise of gradients at the given order
C      SG    : standard deviation of gradients
C      ES    : exspectation value of Laplace-terms
C      EL    : standard deviation of Laplace-terms
C      NSG   : number of pixels wich became significant by the gradient
C      NSL   : number of pixels wich became significant by Laplace
C      NREST : number of pixels wich did not become significant at
C      any order. They are set by the maximal filter size.
C---------------------------------------------------------------------
       IMPLICIT NONE
C
       INTEGER       NSG,NSL,NREST,ORD,I,ST
       REAL          EG,SG,EL,SL
       CHARACTER*80  A
C
       COMMON        /TEST/EG(16),SG(16),EL(16),SL(16),NSG(16),
     >                     NSL(16),NREST
 100   FORMAT(' ',1X,'ORD',7X,'EG',11X,'SG',11X,'EL',11X,
     >        'SL',11X,'NSG',7X,'NSL')
 200   FORMAT (' ',1X,I3,4(1X,G12.3),2(I10))
 300   FORMAT (' ',60X,'NREST:',I10)
C
       WRITE(A,100)
       CALL STTPUT(A,ST)
C
       DO I=2,ORD
          WRITE (A,200) I,EG(I),SG(I),EL(I),SL(I),NSG(I),NSL(I)
          CALL STTPUT(A,ST)
       ENDDO
C
       WRITE (A,300) NREST
       CALL STTPUT(A,ST)
C
       RETURN
       END

C @(#)rtape.for	19.1 (ES0-DMD) 02/25/03 14:32:28
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT    (c) 1988  European Southern Observatory
C.LANGUAGE     VAX/VMS FORTRAN
C.IDENT        rtape.for
C.AUTHOR       P.Grosbol   ESO/IPG
C.KEYWORDS     read tape, copy tape to disk
C.ENVIRON      VAX/VMS
C.PURPOSE      copy tape to disk files in fix block format
C.COMMENT      Fix block file format is used only because it is more
C              efficient on a VAX/VMS system!!
C              Size could be increased from 512 to 1024 or larger.
C.VERSION      1.0  1989-Mar-16 : Creation,   PJG
C--------------------------------------------------------------------
      PARAMETER     (MBUF=32000,IBZ=1024,NBZ=IBZ/4)
C
      LOGICAL*1     BUF(MBUF)
C
      INTEGER       NO,NOF,N,REC,NOL,NPF
      INTEGER       MB,IDX,NB,I,FDI
      INTEGER       DEFLIST,GETLIST
      INTEGER       IOOPEN,IOCLOSE,IOREAD,IOREW,IOFSF
      CHARACTER*80  INPUT,PREFIX,LIST,OUTPUT
C
C     READ INPUT PARAMETERS
C
      WRITE(6,600)
  600 FORMAT(' Name of input tape unit   : ',$)
      READ(5,500) INPUT
  500 FORMAT(A)
      WRITE(6,602)
  602 FORMAT(' Prefix on output filename : ',$)
      READ(5,500) PREFIX
      NPF = INDEX(PREFIX,' ') - 1
      WRITE(6,604)
  604 FORMAT(' List of file no. to copy  : ',$)
      READ(5,500) LIST
C
C     CHECK IF LIST VALID
C
      IF (DEFLIST(LIST).NE.0) THEN
         WRITE(6,690)
  690    FORMAT(' Error: Invalid list of file no''s')
         GOTO 90000
      ENDIF
C
C     OPEN AND POSITION TAPE DRIVE
C
      FDI = IOOPEN(INPUT,0,1600)
      IF (FDI.LE.0) THEN
         WRITE(6,691)
  691    FORMAT(' Error: cannot open mag. tape')
         GOTO 90000
      ENDIF
      CALL IOREW(FDI)
      NOL = 1
 1000 IF (GETLIST(NOF).EQ.0) GOTO 4000
        IF (NOL.LT.NOF) THEN
           NO = NOF - NOL
           DO 1100, I = 1,NO
              N = IOREAD(FDI,BUF,IBZ)
              IF (N.LE.0) THEN
                 WRITE(6,692)
  692            FORMAT(' Warning: End of Information detected')
                 CALL IOREW(FDI)
                 GOTO 90000
              ENDIF
              CALL IOFSF(FDI,1)
 1100      CONTINUE
        ELSE IF (NOF.LT.NOL) THEN
           WRITE(6,693)
  693      FORMAT(' Error: List NOT ascending')
           GOTO 90000
        ENDIF
C
C     GET NEW FILE NAME
C
        WRITE(OUTPUT,610) PREFIX(1:NPF),NOF
  610   FORMAT(A,I4.4,'.mt')
C
C     INITIATE COUNTERS FOR REDING FILE
C
        REC = 0
        IDX = 1
        MB = MBUF - IBZ
C
C     READ BLOCK BY BLOCK
C
 2000   CONTINUE
          NO = IOREAD(FDI,BUF(IDX),MB)
C
C     NO MORE DATA IN THIS FILE - EOF
C
          IF (NO.LE.0) THEN
             IF (REC.NE.0) GOTO 3000
             WRITE(6,694)
  694        FORMAT(' Warning: End of Information detected on tape')
             GOTO 4000
          ENDIF
C
C     CREATE FILE FOR DATA
C
          IF (REC.EQ.0) THEN
             NBYTE = 0
             OPEN(UNIT=10,FILE=OUTPUT,FORM='UNFORMATTED',
     ,            ORGANIZATION='SEQUENTIAL',ACCESS='SEQUENTIAL',
     ,            RECL=NBZ,RECORDTYPE='FIXED',
     ,            STATUS='UNKNOWN',ERR=2900)
             GOTO 2100
 2900        WRITE(6,695)
  695        FORMAT(' Error: Output file cannot be created!')
             GOTO 90000
          ENDIF
C
 2100     CONTINUE
          REC = REC + 1
          NBYTE = NBYTE + NO
          IDX = IDX + NO
          DO 2200, N = 1,IDX,IBZ
             NB = N + IBZ - 1
             IF (NB.LT.IDX) THEN
                WRITE(10) (BUF(I),I=N,NB)
                NEXT = NB + 1
             ENDIF
 2200     CONTINUE
C
C     MOVE THE REST OF BUFFER TO THE START
C
          NO = IDX - 1
          IDX = 1
          DO 2300, I = NEXT,NO
             BUF(IDX) = BUF(I)
             IDX = IDX + 1
 2300     CONTINUE
        GOTO 2000
C
C     EOF DETECTED - WRITE REMAINING DATA TO DISK
C
 3000   CONTINUE
        IF (IDX.GT.1) THEN 
          DO 3100, N = 1,IDX,IBZ
             NB = MIN(N+IBZ-1,IDX-1)
             WRITE(10) (BUF(I),I=N,NB)
 3100     CONTINUE
        ENDIF
        NOL = NOF + 1
        CLOSE(10)
        BYTE = FLOAT(NBYTE)/(1024.0*1024.0)
        WRITE(6,630) BYTE,REC,OUTPUT(1:32)
  630   FORMAT(1X,F7.2,' Mbyte in ',I4,' records copied to file: ',A)
      GOTO 1000
C
C     FINISH READING - CLOSE AND EXIT
C
 4000 CONTINUE
90000 CONTINUE
      CALL IOCLOSE(FDI)
      END

C @(#)linpack100.for	19.1 (ES0-DMD) 02/25/03 14:35:47
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      double precision aa(200,200),a(201,200),b(200),x(200)
      double precision time(8,6),cray,ops,total,norma,normx
      double precision resid,residn,eps,epslon
      integer ipvt(200)
      call nosci(15)
      lda = 201
      ldaa = 200
c
      n = 100
      cray = .056
c     write(6,1)
c   1 format(' Please send the results of this run to:'//
c    $       ' Jack J. Dongarra'/
c    $       ' Mathematics and Computer Science Division'/
c    $       ' Argonne National Laboratory'/
c    $       ' Argonne, Illinois 60439'//
c    $       ' Telephone: 312-972-7246'//
c    $       ' ARPAnet: DONGARRA@ANL-MCS'/)
      ops = (2.0d0*n**3)/3.0d0 + 2.0d0*n**2
c
         call matgen(a,lda,n,b,norma)
         t1 = second()
         call dgefa(a,lda,n,ipvt,info)
         time(1,1) = second() - t1
         t1 = second()
         call dgesl(a,lda,n,ipvt,b,0)
         time(1,2) = second() - t1
         total = time(1,1) + time(1,2)
c
c     compute a residual to verify results.
c
         do 10 i = 1,n
            x(i) = b(i)
   10    continue
         call matgen(a,lda,n,b,norma)
         do 20 i = 1,n
            b(i) = -b(i)
   20    continue
         call dmxpy(n,b,n,lda,x,a)
         resid = 0.0
         normx = 0.0
         do 30 i = 1,n
            resid = dmax1( resid, dabs(b(i)) )
            normx = dmax1( normx, dabs(x(i)) )
   30    continue
         eps = epslon(1.0d0)
         residn = resid/( n*norma*normx*eps )
         write(6,40)
   40    format('     norm. resid      resid           machep',
     $          '         x(1)          x(n)')
         write(6,50) residn,resid,eps,x(1),x(n)
   50    format(1p5e16.8)
c
         write(6,60) n
   60    format(//'    times are reported for matrices of order ',i5)
         write(6,70)
   70    format(6x,'dgefa',6x,'dgesl',6x,'total',5x,'mflops',7x,'unit',
     $         6x,'ratio')
c
         time(1,3) = total
         time(1,4) = ops/(1.0d6*total)
         time(1,5) = 2.0d0/time(1,4)
         time(1,6) = total/cray
         write(6,80) lda
   80    format(' times for array with leading dimension of',i4)
         write(6,110) (time(1,i),i=1,6)
c
         call matgen(a,lda,n,b,norma)
         t1 = second()
         call dgefa(a,lda,n,ipvt,info)
         time(2,1) = second() - t1
         t1 = second()
         call dgesl(a,lda,n,ipvt,b,0)
         time(2,2) = second() - t1
         total = time(2,1) + time(2,2)
         time(2,3) = total
         time(2,4) = ops/(1.0d6*total)
         time(2,5) = 2.0d0/time(2,4)
         time(2,6) = total/cray
c
         call matgen(a,lda,n,b,norma)
         t1 = second()
         call dgefa(a,lda,n,ipvt,info)
         time(3,1) = second() - t1
         t1 = second()
         call dgesl(a,lda,n,ipvt,b,0)
         time(3,2) = second() - t1
         total = time(3,1) + time(3,2)
         time(3,3) = total
         time(3,4) = ops/(1.0d6*total)
         time(3,5) = 2.0d0/time(3,4)
         time(3,6) = total/cray
c
         ntimes = 10
         tm2 = 0
         t1 = second()
         do 90 i = 1,ntimes
            tm = second()
            call matgen(a,lda,n,b,norma)
            tm2 = tm2 + second() - tm
            call dgefa(a,lda,n,ipvt,info)
   90    continue
         time(4,1) = (second() - t1 - tm2)/ntimes
         t1 = second()
         do 100 i = 1,ntimes
            call dgesl(a,lda,n,ipvt,b,0)
  100    continue
         time(4,2) = (second() - t1)/ntimes
         total = time(4,1) + time(4,2)
         time(4,3) = total
         time(4,4) = ops/(1.0d6*total)
         time(4,5) = 2.0d0/time(4,4)
         time(4,6) = total/cray
c
         write(6,110) (time(2,i),i=1,6)
         write(6,110) (time(3,i),i=1,6)
         write(6,110) (time(4,i),i=1,6)
  110    format(6(1pe11.3))
c
         call matgen(aa,ldaa,n,b,norma)
         t1 = second()
         call dgefa(aa,ldaa,n,ipvt,info)
         time(5,1) = second() - t1
         t1 = second()
         call dgesl(aa,ldaa,n,ipvt,b,0)
         time(5,2) = second() - t1
         total = time(5,1) + time(5,2)
         time(5,3) = total
         time(5,4) = ops/(1.0d6*total)
         time(5,5) = 2.0d0/time(5,4)
         time(5,6) = total/cray
c
         call matgen(aa,ldaa,n,b,norma)
         t1 = second()
         call dgefa(aa,ldaa,n,ipvt,info)
         time(6,1) = second() - t1
         t1 = second()
         call dgesl(aa,ldaa,n,ipvt,b,0)
         time(6,2) = second() - t1
         total = time(6,1) + time(6,2)
         time(6,3) = total
         time(6,4) = ops/(1.0d6*total)
         time(6,5) = 2.0d0/time(6,4)
         time(6,6) = total/cray
c
         call matgen(aa,ldaa,n,b,norma)
         t1 = second()
         call dgefa(aa,ldaa,n,ipvt,info)
         time(7,1) = second() - t1
         t1 = second()
         call dgesl(aa,ldaa,n,ipvt,b,0)
         time(7,2) = second() - t1
         total = time(7,1) + time(7,2)
         time(7,3) = total
         time(7,4) = ops/(1.0d6*total)
         time(7,5) = 2.0d0/time(7,4)
         time(7,6) = total/cray
c
         ntimes = 10
         tm2 = 0
         t1 = second()
         do 120 i = 1,ntimes
            tm = second()
            call matgen(aa,ldaa,n,b,norma)
            tm2 = tm2 + second() - tm
            call dgefa(aa,ldaa,n,ipvt,info)
  120    continue
         time(8,1) = (second() - t1 - tm2)/ntimes
         t1 = second()
         do 130 i = 1,ntimes
            call dgesl(aa,ldaa,n,ipvt,b,0)
  130    continue
         time(8,2) = (second() - t1)/ntimes
         total = time(8,1) + time(8,2)
         time(8,3) = total
         time(8,4) = ops/(1.0d6*total)
         time(8,5) = 2.0d0/time(8,4)
         time(8,6) = total/cray
c
         write(6,140) ldaa
  140    format(/' times for array with leading dimension of',i4)
         write(6,110) (time(5,i),i=1,6)
         write(6,110) (time(6,i),i=1,6)
         write(6,110) (time(7,i),i=1,6)
         write(6,110) (time(8,i),i=1,6)
	 sum=0.
	 do 160 i=1,4
	    sum=sum+time(i,4)
  160    continue
      sum=sum/4.0
      write(15,165)sum
  165 format('MFLOPS =',F8.2)
      call noscf()
      stop
      end
      subroutine matgen(a,lda,n,b,norma)
      double precision a(lda,1),b(1),norma
c
      init = 1325
      norma = 0.0
      do 30 j = 1,n
         do 20 i = 1,n
            init = mod(3125*init,65536)
            a(i,j) = (init - 32768.0)/16384.0
            norma = dmax1(a(i,j), norma)
   20    continue
   30 continue
      do 35 i = 1,n
          b(i) = 0.0
   35 continue
      do 50 j = 1,n
         do 40 i = 1,n
            b(i) = b(i) + a(i,j)
   40    continue
   50 continue
      return
      end
      subroutine dgefa(a,lda,n,ipvt,info)
      integer lda,n,ipvt(1),info
      double precision a(lda,1)
c
c     dgefa factors a double precision matrix by gaussian elimination.
c
c     dgefa is usually called by dgeco, but it can be called
c     directly with a saving in time if  rcond  is not needed.
c     (time for dgeco) = (1 + 9/n)*(time for dgefa) .
c
c     on entry
c
c        a       double precision(lda, n)
c                the matrix to be factored.
c
c        lda     integer
c                the leading dimension of the array  a .
c
c        n       integer
c                the order of the matrix  a .
c
c     on return
c
c        a       an upper triangular matrix and the multipliers
c                which were used to obtain it.
c                the factorization can be written  a = l*u  where
c                l  is a product of permutation and unit lower
c                triangular matrices and  u  is upper triangular.
c
c        ipvt    integer(n)
c                an integer vector of pivot indices.
c
c        info    integer
c                = 0  normal value.
c                = k  if  u(k,k) .eq. 0.0 .  this is not an error
c                     condition for this subroutine, but it does
c                     indicate that dgesl or dgedi will divide by zero
c                     if called.  use  rcond  in dgeco for a reliable
c                     indication of singularity.
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas daxpy,dscal,idamax
c
c     internal variables
c
      double precision t
      integer idamax,j,k,kp1,l,nm1
c
c
c     gaussian elimination with partial pivoting
c
      info = 0
      nm1 = n - 1
      if (nm1 .lt. 1) go to 70
      do 60 k = 1, nm1
         kp1 = k + 1
c
c        find l = pivot index
c
         l = idamax(n-k+1,a(k,k),1) + k - 1
         ipvt(k) = l
c
c        zero pivot implies this column already triangularized
c
         if (a(l,k) .eq. 0.0d0) go to 40
c
c           interchange if necessary
c
            if (l .eq. k) go to 10
               t = a(l,k)
               a(l,k) = a(k,k)
               a(k,k) = t
   10       continue
c
c           compute multipliers
c
            t = -1.0d0/a(k,k)
            call dscal(n-k,t,a(k+1,k),1)
c
c           row elimination with column indexing
c
            do 30 j = kp1, n
               t = a(l,j)
               if (l .eq. k) go to 20
                  a(l,j) = a(k,j)
                  a(k,j) = t
   20          continue
               call daxpy(n-k,t,a(k+1,k),1,a(k+1,j),1)
   30       continue
         go to 50
   40    continue
            info = k
   50    continue
   60 continue
   70 continue
      ipvt(n) = n
      if (a(n,n) .eq. 0.0d0) info = n
      return
      end
      subroutine dgesl(a,lda,n,ipvt,b,job)
      integer lda,n,ipvt(1),job
      double precision a(lda,1),b(1)
c
c     dgesl solves the double precision system
c     a * x = b  or  trans(a) * x = b
c     using the factors computed by dgeco or dgefa.
c
c     on entry
c
c        a       double precision(lda, n)
c                the output from dgeco or dgefa.
c
c        lda     integer
c                the leading dimension of the array  a .
c
c        n       integer
c                the order of the matrix  a .
c
c        ipvt    integer(n)
c                the pivot vector from dgeco or dgefa.
c
c        b       double precision(n)
c                the right hand side vector.
c
c        job     integer
c                = 0         to solve  a*x = b ,
c                = nonzero   to solve  trans(a)*x = b  where
c                            trans(a)  is the transpose.
c
c     on return
c
c        b       the solution vector  x .
c
c     error condition
c
c        a division by zero will occur if the input factor contains a
c        zero on the diagonal.  technically this indicates singularity
c        but it is often caused by improper arguments or improper
c        setting of lda .  it will not occur if the subroutines are
c        called correctly and if dgeco has set rcond .gt. 0.0
c        or dgefa has set info .eq. 0 .
c
c     to compute  inverse(a) * c  where  c  is a matrix
c     with  p  columns
c           call dgeco(a,lda,n,ipvt,rcond,z)
c           if (rcond is too small) go to ...
c           do 10 j = 1, p
c              call dgesl(a,lda,n,ipvt,c(1,j),0)
c        10 continue
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas daxpy,ddot
c
c     internal variables
c
      double precision ddot,t
      integer k,kb,l,nm1
c
      nm1 = n - 1
      if (job .ne. 0) go to 50
c
c        job = 0 , solve  a * x = b
c        first solve  l*y = b
c
         if (nm1 .lt. 1) go to 30
         do 20 k = 1, nm1
            l = ipvt(k)
            t = b(l)
            if (l .eq. k) go to 10
               b(l) = b(k)
               b(k) = t
   10       continue
            call daxpy(n-k,t,a(k+1,k),1,b(k+1),1)
   20    continue
   30    continue
c
c        now solve  u*x = y
c
         do 40 kb = 1, n
            k = n + 1 - kb
            b(k) = b(k)/a(k,k)
            t = -b(k)
            call daxpy(k-1,t,a(1,k),1,b(1),1)
   40    continue
      go to 100
   50 continue
c
c        job = nonzero, solve  trans(a) * x = b
c        first solve  trans(u)*y = b
c
         do 60 k = 1, n
            t = ddot(k-1,a(1,k),1,b(1),1)
            b(k) = (b(k) - t)/a(k,k)
   60    continue
c
c        now solve trans(l)*x = y
c
         if (nm1 .lt. 1) go to 90
         do 80 kb = 1, nm1
            k = n - kb
            b(k) = b(k) + ddot(n-k,a(k+1,k),1,b(k+1),1)
            l = ipvt(k)
            if (l .eq. k) go to 70
               t = b(l)
               b(l) = b(k)
               b(k) = t
   70       continue
   80    continue
   90    continue
  100 continue
      return
      end
      subroutine daxpy(n,da,dx,incx,dy,incy)
c
c     constant times a vector plus a vector.
c     jack dongarra, linpack, 3/11/78.
c
      double precision dx(1),dy(1),da
      integer i,incx,incy,ix,iy,m,mp1,n
c
      if(n.le.0)return
      if (da .eq. 0.0d0) return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        dy(iy) = dy(iy) + da*dx(ix)
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
c
c        code for both increments equal to 1
c
   20 continue
      do 30 i = 1,n
        dy(i) = dy(i) + da*dx(i)
   30 continue
      return
      end
      double precision function ddot(n,dx,incx,dy,incy)
c
c     forms the dot product of two vectors.
c     jack dongarra, linpack, 3/11/78.
c
      double precision dx(1),dy(1),dtemp
      integer i,incx,incy,ix,iy,m,mp1,n
c
      ddot = 0.0d0
      dtemp = 0.0d0
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        dtemp = dtemp + dx(ix)*dy(iy)
        ix = ix + incx
        iy = iy + incy
   10 continue
      ddot = dtemp
      return
c
c        code for both increments equal to 1
c
   20 continue
      do 30 i = 1,n
        dtemp = dtemp + dx(i)*dy(i)
   30 continue
      ddot = dtemp
      return
      end
      subroutine  dscal(n,da,dx,incx)
c
c     scales a vector by a constant.
c     jack dongarra, linpack, 3/11/78.
c
      double precision da,dx(1)
      integer i,incx,m,mp1,n,nincx
c
      if(n.le.0)return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      nincx = n*incx
      do 10 i = 1,nincx,incx
        dx(i) = da*dx(i)
   10 continue
      return
c
c        code for increment equal to 1
c
   20 continue
      do 30 i = 1,n
        dx(i) = da*dx(i)
   30 continue
      return
      end
      integer function idamax(n,dx,incx)
c
c     finds the index of element having max. dabsolute value.
c     jack dongarra, linpack, 3/11/78.
c
      double precision dx(1),dmax
      integer i,incx,ix,n
c
      idamax = 0
      if( n .lt. 1 ) return
      idamax = 1
      if(n.eq.1)return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      ix = 1
      dmax = dabs(dx(1))
      ix = ix + incx
      do 10 i = 2,n
         if(dabs(dx(ix)).le.dmax) go to 5
         idamax = i
         dmax = dabs(dx(ix))
    5    ix = ix + incx
   10 continue
      return
c
c        code for increment equal to 1
c
   20 dmax = dabs(dx(1))
      do 30 i = 2,n
         if(dabs(dx(i)).le.dmax) go to 30
         idamax = i
         dmax = dabs(dx(i))
   30 continue
      return
      end
      double precision function epslon (x)
      double precision x
c
c     estimate unit roundoff in quantities of size x.
c
      double precision a,b,c,eps
c
c     this program should function properly on all systems
c     satisfying the following two assumptions,
c        1.  the base used in representing dfloating point
c            numbers is not a power of three.
c        2.  the quantity  a  in statement 10 is represented to 
c            the accuracy used in dfloating point variables
c            that are stored in memory.
c     the statement number 10 and the go to 10 are intended to
c     force optimizing compilers to generate code satisfying 
c     assumption 2.
c     under these assumptions, it should be true that,
c            a  is not exactly equal to four-thirds,
c            b  has a zero for its last bit or digit,
c            c  is not exactly equal to one,
c            eps  measures the separation of 1.0 from
c                 the next larger dfloating point number.
c     the developers of eispack would appreciate being informed
c     about any systems where these assumptions do not hold.
c
c     *****************************************************************
c     this routine is one of the auxiliary routines used by eispack iii
c     to avoid machine dependencies.
c     *****************************************************************
c
c     this version dated 4/6/83.
c
      a = 4.0d0/3.0d0
   10 b = a - 1.0d0
      c = b + b + b
      eps = dabs(c-1.0d0)
      if (eps .eq. 0.0d0) go to 10
      epslon = eps*dabs(x)
      return
      end
      subroutine mm (a, lda, n1, n3, b, ldb, n2, c, ldc)
      double precision a(lda,*), b(ldb,*), c(ldc,*)
c
c   purpose:
c     multiply matrix b times matrix c and store the result in matrix a.
c
c   parameters:
c
c     a double precision(lda,n3), matrix of n1 rows and n3 columns
c
c     lda integer, leading dimension of array a
c
c     n1 integer, number of rows in matrices a and b
c
c     n3 integer, number of columns in matrices a and c
c
c     b double precision(ldb,n2), matrix of n1 rows and n2 columns
c
c     ldb integer, leading dimension of array b
c
c     n2 integer, number of columns in matrix b, and number of rows in
c         matrix c
c
c     c double precision(ldc,n3), matrix of n2 rows and n3 columns
c
c     ldc integer, leading dimension of array c
c
c ----------------------------------------------------------------------
c
      do 20 j = 1, n3
         do 10 i = 1, n1
            a(i,j) = 0.0
   10    continue
         call dmxpy (n2,a(1,j),n1,ldb,c(1,j),b)
   20 continue
c
      return
      end
      subroutine dmxpy (n1, y, n2, ldm, x, m)
      double precision y(*), x(*), m(ldm,*)
c
c   purpose:
c     multiply matrix m times vector x and add the result to vector y.
c
c   parameters:
c
c     n1 integer, number of elements in vector y, and number of rows in
c         matrix m
c
c     y double precision(n1), vector of length n1 to which is added 
c         the product m*x
c
c     n2 integer, number of elements in vector x, and number of columns
c         in matrix m
c
c     ldm integer, leading dimension of array m
c
c     x double precision(n2), vector of length n2
c
c     m double precision(ldm,n2), matrix of n1 rows and n2 columns
c
c ----------------------------------------------------------------------
c
c   cleanup odd vector
c
      j = mod(n2,2)
      if (j .ge. 1) then
         do 10 i = 1, n1
            y(i) = (y(i)) + x(j)*m(i,j)
   10    continue
      endif
c
c   cleanup odd group of two vectors
c
      j = mod(n2,4)
      if (j .ge. 2) then
         do 20 i = 1, n1
            y(i) = ( (y(i))
     $             + x(j-1)*m(i,j-1)) + x(j)*m(i,j)
   20    continue
      endif
c
c   cleanup odd group of four vectors
c
      j = mod(n2,8)
      if (j .ge. 4) then
         do 30 i = 1, n1
            y(i) = ((( (y(i))
     $             + x(j-3)*m(i,j-3)) + x(j-2)*m(i,j-2))
     $             + x(j-1)*m(i,j-1)) + x(j)  *m(i,j)
   30    continue
      endif
c
c   cleanup odd group of eight vectors
c
      j = mod(n2,16)
      if (j .ge. 8) then
         do 40 i = 1, n1
            y(i) = ((((((( (y(i))
     $             + x(j-7)*m(i,j-7)) + x(j-6)*m(i,j-6))
     $             + x(j-5)*m(i,j-5)) + x(j-4)*m(i,j-4))
     $             + x(j-3)*m(i,j-3)) + x(j-2)*m(i,j-2))
     $             + x(j-1)*m(i,j-1)) + x(j)  *m(i,j)
   40    continue
      endif
c
c   main loop - groups of sixteen vectors
c
      jmin = j+16
      do 60 j = jmin, n2, 16
         do 50 i = 1, n1
            y(i) = ((((((((((((((( (y(i))
     $             + x(j-15)*m(i,j-15)) + x(j-14)*m(i,j-14))
     $             + x(j-13)*m(i,j-13)) + x(j-12)*m(i,j-12))
     $             + x(j-11)*m(i,j-11)) + x(j-10)*m(i,j-10))
     $             + x(j- 9)*m(i,j- 9)) + x(j- 8)*m(i,j- 8))
     $             + x(j- 7)*m(i,j- 7)) + x(j- 6)*m(i,j- 6))
     $             + x(j- 5)*m(i,j- 5)) + x(j- 4)*m(i,j- 4))
     $             + x(j- 3)*m(i,j- 3)) + x(j- 2)*m(i,j- 2))
     $             + x(j- 1)*m(i,j- 1)) + x(j)   *m(i,j)
   50    continue
   60 continue
      return
      end

C===========================================================================
C Copyright (C) 1995,2004 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987,2004 European Southern Observatory,
C                                         all rights reserved
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION
C
C  program FUNCREA.FOR
C
C.PURPOSE
C
C  Execute the commands
C  COMPUTE/FUNCTION image = function(refima[;pars])
C  COMPUTE/FUNCTION table dvar = function(in.var[;pars])
C
C  The first format corresponds to images, the second to tables
C
C  The functional specification can be as:
C   function(reference)      -- where function is function file
C                               edited via EDIT/FUNCTION
C  or
C  function(reference;pars) -- where function is en explicit function
C                              name, including parameters
C
C.KEYWORDS
C
C  FUNCTIONS, FIT
C
C.INPUT/OUTPUT
C
C  P1 - P8     contain input parameters
C
C.ALGORITHM
C
C  Use fit interface routines
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  16:04 - 20 DEC 1987
C 041129	last modif
C
C-----------------------------------------------------------
C 
      IMPLICIT NONE
C
C ... define variables
C
      INTEGER CODE,IAV,KUN,KNUL,I,II
      INTEGER INDEX,IND,ISTAT,II1,NAMLEN
      INTEGER IMNOA,IMNOC
C
      CHARACTER*80 NAME,FILE,MASK,LINE
      CHARACTER*1  IAC
      CHARACTER    PARS*80,LINE1*34,LINE2*80,REFIMA*80
      CHARACTER*80 P1,P2,P3,P4,FILENA
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC/NOLIST'
C
      INCLUDE 'MID_INCLUDE:FITI.INC/NOLIST'
      INCLUDE 'MID_INCLUDE:FITC.INC/NOLIST'
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC/NOLIST'
C
      DATA NAMLEN/80/
C
C ... get into MIDAS
C
      CALL STSPRO('FUNCREA')
      CALL FITBL
C
C ... read parameters
C
      CALL STKRDC('P1',1,1,80,IAV,P1,KUN,KNUL,ISTAT)
      CALL STKRDC('P2',1,1,80,IAV,P2,KUN,KNUL,ISTAT)
      CALL STKRDC('P3',1,1,80,IAV,P3,KUN,KNUL,ISTAT)
      CALL STKRDC('P4',1,1,80,IAV,P4,KUN,KNUL,ISTAT)
C
C ... decode if image or table format
C                                                    IMAGE
      IF (P2(1:1).EQ.'=') THEN
          FILENA = P1
          IAC    = 'I'
          FILE   = P1
          II     = INDEX(P3,'(')
          IF (II.EQ.0) 
     +       CALL STETER(11,'FUNCREA: Missing function arguments ')
          NAME   = P3(1:II-1)
          II1    = INDEX(P3,')')
          IF (II1.EQ.0) 
     +       CALL STETER(12,'FUNCREA: Missing right parenthesis')
          LINE2  = P3(II+1:II1-1)
          LINE   = P3
      ELSE
C                                                  TABLE
          IND    = INDEX(P1//' ',' ') - 1
          FILENA = P1(1:IND)//'.tbl'
          IAC    = 'T'
          FILE   = P1
          LINE1  = P2
          II     = INDEX(P4,'(')
          IF (II.EQ.0)
     +       CALL STETER(11,'FUNCREA: Missing function arguments ')
          NAME   = P4(1:II-1)
          II1    = INDEX(P4,')')
          IF (II1.EQ.0) 
     +       CALL STETER(12,'FUNCREA: Missing right parenthesis')
          LINE2  = P4(II+1:II1-1)
          LINE   = P4
      END IF
C
C ... decode function arguments
C
      II1    = INDEX(LINE2,';')
      IF (II1.EQ.0) THEN
          REFIMA = LINE2
          PARS   = ' '
      ELSE
          REFIMA = LINE2(1:II1-1)
          PARS   = LINE2(II1+1:)
      END IF
C
C ... read function file or initialize parameters
C
      CALL FTDCFN(NAME,CODE)
      IF (CODE.GT.0 .OR. PARS(1:1).NE.' ') THEN
          CALL FTINIF(LINE,ISTAT)
          DO 10 I = 1,20
              FZSELE(I) = 1
   10     CONTINUE
      ELSE
          CALL FTINIT(NAME,ISTAT)
      END IF
C
C ... copy parameter guesses to actual values
C
      CALL FTCPGV(ISTAT)
C
C ... modify independent variables if required
C     and define dependent variables
C
      IF (IAC.EQ.'I') THEN
          MASK   = ' '
          CALL FTDIVI(REFIMA,ISTAT)
          CALL FTDDVI(FILE,MASK,ISTAT)
      ELSE
          CALL FTDIVT(FILE,REFIMA,ISTAT)
          CALL FTDDVT(FILE,LINE1,ISTAT)
      END IF
C
C ... compute functional values
C
      CALL FTCOMP(ISTAT)
      IF (IAC.EQ.'I') THEN
         CALL STFOPN(REFIMA,D_OLD_FORMAT,0,F_OLD_TYPE,IMNOA,ISTAT)
         CALL STFOPN(FILE,D_OLD_FORMAT,0,F_OLD_TYPE,IMNOC,ISTAT)
         CALL DSCUPT(IMNOA,IMNOC,' ',ISTAT)
      ENDIF
C
      CALL STSEPI
9000  FORMAT (I4)
      END

C @(#)ctable.for	19.1 (ES0-DMD) 02/25/03 13:25:32
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine CTABLE         version 1.1       830916
C  A. Kruszewski             ESO Garching
C  modified                  version 1.2       870304
C  A. Kruszewski             Obs. de Geneve
C.PURPOSE
C  creates a table and writes parameters of detected objects into it
C.INPUT/OUTPUT
C  input parameters
C  NCOL        integer*4         number of table columns
C  NROW        integer*4         number of table rows
C  START       real*8 array      physical coordinates of (1,1) pixel
C  STEP        real*8 array      physical size of one pixel
C  NCAT        integer*4 array   integer parameters
C  PMTR        real*4 array      array holding classifiers
C  PRCT        real*4 array      catalog of objects profiles
C  NP          integer*4         dimension of catalog buffer
C  output parameters
C  IOF         integer*4         output table
C-----------------------------------------------------------------------
      SUBROUTINE CTABLE(IOF,NCOL,NROW,START,STEP, NCAT,
     &                  PMTR, PRCT, NP)
C
      IMPLICIT  NONE
      INCLUDE  'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER        IOF
      INTEGER        NCOL
      INTEGER        NROW
      DOUBLE PRECISION START(2)
      DOUBLE PRECISION STEP(2)
      INTEGER        NP
      INTEGER        NCAT(NIPAR,NP)
      REAL           PMTR(NRPAR,NP) 
      REAL           PRCT(0:MAXSUB,NP)
C
      REAL           PVAL(27+MAXSUB)
      INTEGER        ICOL(MAXSUB+27)
      INTEGER        IPRF, ISTAT
      INTEGER        K
      INTEGER        L
      INTEGER        MADRID(1)
      CHARACTER*16   LABEL(26), UNIT(26), LABELP, UNITP
C
      INCLUDE        'MID_INCLUDE:TABLES.INC'
      COMMON        /VMR/MADRID
      INCLUDE       'MID_INCLUDE:TABLED.INC'
C
      DATA LABEL/'IDENT','X','Y','MAG_CNV','MAG_AP_1','MAG_AP_2',
     &     'REL_GRAD','SIGMA_GR','BG','INT','RADIUS_1','RADIUS_2',
     &     'ELONG','POS_ANG','RAD_ISO','MAG_PET','RAD_PET','RAD_KRON',
     &     'ALPHA','MAG_ISO','CLASS','NR_OTH_OBJ','AR','SIGMA_X',
     &     'SIGMA_Y','SIGMA_MAG'/
      DATA UNIT/'NO_DIM','MICRON','MICRON','MAGNITUDE','MAGNITUDE',
     &      'MAGNITUDE','NO_DIM','NO_DIM','INSTR_UNITS','INSTR_UNITS',
     &      'PIXEL','PIXEL','NO_DIM','DEGREES','PIXEL','MAGNITUDE',
     &      'PIXEL','PIXEL','NO_DIM','MAGNITUDE','NO_DIM','PIXEL',
     &      'PIXEL','PIXEL','PIXEL','NO_DIM'/
C
      UNITP  = 'INSTR_UNITS'
      LABELP = 'PROFILE'
      DO 10 L = 1 , NCOL
          ICOL(L) = L
   10 CONTINUE
C
      DO 20 L = 1 , 26
          CALL TBCINI(IOF, D_R4_FORMAT, 1, 'E12.4', UNIT(L),
     &                LABEL(L), ICOL(L), ISTAT)
   20 CONTINUE
      IPRF = NCOL - 26
      IF (IPRF.GT.0) THEN
         DO 30 L = 27 , NCOL
            CALL TBCINI(IOF, D_R4_FORMAT, 1, 'E12.4', UNITP,
     &                  LABELP, ICOL(L), ISTAT)
   30    CONTINUE
      ENDIF
C
C ****** Write data into output table.
C
      DO 60 K = 1 , NROW
          DO 40 L = 1 , 26
              IF ( L .EQ. 1 ) THEN
                  PVAL(L) = FLOAT(K)
              ELSE IF ( L .EQ. 2 ) THEN
                  PVAL(L) = SNGL( START(1) +
     &                              STEP(1) * DBLE(PMTR(10,K)-1.0) )
              ELSE IF ( L .EQ. 3 ) THEN
                  PVAL(L) = SNGL( START(2) +
     &                              STEP(2) * DBLE(PMTR(11,K)-1.0) )
              ELSE IF ( L .EQ. 4 ) THEN
                  PVAL(L) = PMTR(12,K)
              ELSE IF ( L .EQ. 5 ) THEN
                  PVAL(L) = PMTR(13,K)
              ELSE IF ( L .EQ. 6 ) THEN
                  PVAL(L) = PMTR(20,K)
              ELSE IF ( L .EQ. 7 ) THEN
                  PVAL(L) = PMTR(3,K)
              ELSE IF ( L .EQ. 8 ) THEN
                  PVAL(L) = PMTR(4,K)
              ELSE IF ( L .EQ. 9 ) THEN
                  PVAL(L) = PMTR(1,K)
              ELSE IF ( L .EQ. 10 ) THEN
                  PVAL(L) = PMTR(2,K)
              ELSE IF ( L .EQ. 11 ) THEN
                  PVAL(L) = PMTR(6,K)
              ELSE IF ( L .EQ. 12 ) THEN
                  PVAL(L) = PMTR(7,K)
              ELSE IF ( L .EQ. 13 ) THEN
                  PVAL(L) = PMTR(8,K)
              ELSE IF ( L .EQ. 14 ) THEN
                  PVAL(L) = PMTR(9,K)
              ELSE IF ( L .EQ. 23 ) THEN
                  PVAL(L) = FLOAT( NCAT(5,K) )
              ELSE IF ( L .EQ. 20 ) THEN
                  PVAL(L) = PMTR(5,K)
              ELSE IF ( L .EQ. 22 ) THEN
                  PVAL(L) = FLOAT( NCAT(3,K) )
              ELSE IF ( L .EQ. 24 ) THEN
                  PVAL(L) = PMTR(22,K)
              ELSE IF ( L .EQ. 25 ) THEN
                  PVAL(L) = PMTR(23,K)
              ELSE IF ( L .EQ. 26 ) THEN
                  PVAL(L) = PMTR(24,K)
              ELSE
                  PVAL(L) = PMTR(L,K)
              ENDIF
   40     CONTINUE
          DO 50 L = 27 , NCOL
              PVAL(L) = PRCT(L-27,K)
   50     CONTINUE
          CALL TBRWRR( IOF , K , NCOL , ICOL , PVAL , ISTAT )
   60 CONTINUE
      CALL TBSINI( IOF , ISTAT )
C
      RETURN
C
      END
C

C===========================================================================
C Copyright (C) 1995-2006 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================

C ++++++++++++++++++++++++  YSTVALS.FOR +++++++++++++++++++++++++++++++++++++++
C .LANGUAGE Fortran 77
C .IDENTIFICATION Module YSTVALS.FOR
C .COMMENTS
C Module contains layer between the keyword related FORTRAN STxxxx interfaces
C and the SC_interfaces written in (hopefully independent) C
C .AUTHOR         K. Banse        ESO - Garching
C .KEYWORDS       standard interfaces.
C .ENVIRONMENT    FORTRAN and C standards
C .VERSION  [1.00] 871207:  created from SXFTOC.C
C
C 060330	last modif
C ......................................................
C
C
C  call as
C  STVALS(ACTION,A,NAXIS,NPIX,SUBLO,SUBHI,CUTVLS,RSULTS,RESPIX,NOPIX,STAT)
C
C  input par:
C  ACTION:      char. exp.  = MIN for min, max calculation
C                           = MEAN for above + mean values, std deviation
C                           = ALL for above + moments of 2. + 3. order
C  A:           R*4 array   array to work on
C  NAXIS:       I*4         no. of axis of A (maxium of 3, currently)
C  NPIX:        I*4 array   no. of pixels per axis in A
C  SUBLO:       I*4 array   start pixels of subframe
C  SUBHI:       I*4 array   end pixels of subframe
C  CUTVLS:      R*4 array   user supplied cutvalues for subframe
C
C  output par:
C  RSULTS:      R*4 array   depending on ACTION, this array contains
C                           min, max, mean, sigma, 2-moment, 3-moment,
C                           total intensity
C  RESPIX:      I*4 array   holds pixel no. of min + max of array
C  NOPIX:       I*4         total no. of pixels inside subframe
C                           with value in [CUTVLS(1),CUTVLS(2)]
C  STAT:        I*4         return status
C                           = 0 o.k., otherwise error
C
C -------------------------------------------------- 
C 
C
      SUBROUTINE STVALS(ACTION,A,NAXIS,NPIX,SUBLO,SUBHI,CUTVLS,
     +            RSULTS,RESPIX,NOPIX,STAT)
C
      IMPLICIT NONE
C
      CHARACTER*(*)  ACTION
      REAL      A(*), CUTVLS(*), RSULTS(*)
      INTEGER     NAXIS, NPIX(*), SUBLO(*), SUBHI(*)
      INTEGER     RESPIX(*), NOPIX, STAT
C
      CALL STSTR(1,ACTION)
      CALL YST1(A,NAXIS,NPIX,SUBLO,SUBHI,CUTVLS,
     +          RSULTS,RESPIX,NOPIX,STAT)
C
      RETURN
      END
C
      SUBROUTINE ZMSTAT(IMNO,AREA,NAXPIX,START,STEP,RBINS,
     +                  FORMSTR,DEFAUL)
C 
      IMPLICIT NONE
C
      CHARACTER*(*)  AREA, FORMSTR, DEFAUL
      REAL      RBINS(*)
      DOUBLE PRECISION START(*), STEP(*)
      INTEGER     IMNO, NAXPIX(*)
C
      CALL STSTR(1,AREA)
      CALL STSTR(2,FORMSTR)
      CALL STSTR(3,DEFAUL)
      CALL ZST1(IMNO,NAXPIX,START,STEP,RBINS)
C
      RETURN
      END
C

        SUBROUTINE ISTUPC(SA,SB)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.VERSION: 1.0  
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C.IDENTIFICATION        ISTUPC.FOR
C.KEYWORDS              FORTRAN FUNCTION
C.ENVIRONMENT  VMS
C.PURPOSE
C       Converts characters in the input string into uppercase.
C
C------------------------------------------------------------------
        IMPLICIT  NONE
        CHARACTER*(*)   SA      ! IN  : Input string 
        CHARACTER*(*)   SB      ! OUT : Destination string
C
        INTEGER   N,KLEN,LEN,M
        CHARACTER*26    ALPHU,ALPHL
C 
        DATA   ALPHU  /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
        DATA   ALPHL  /'abcdefghijklmnopqrstuvwxyz'/
C 
        KLEN = LEN(SA)
C 
C  compare each input character with lowercase alphabet
        DO 100 N=1,KLEN
C 
           SB(N:N) = SA(N:N)
           DO 50 M=1,26
              IF (SA(N:N).EQ.ALPHL(M:M)) SB(N:N) = ALPHU(M:M)
50         CONTINUE
C 
100     CONTINUE
C 
        RETURN
        END

C  @(#)ftcva1.for	19.1 (ESO-DMD) 02/25/03 13:17:32 
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FTCVA1(X,W,NAXIS,NPIX1,NPIX2,NPIX3,STR,STP,CUT)                             
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                   
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:25 - 13 JAN 1988                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C.IDENTIFICATION                                                                
C                                                                               
C  FITLIB.FOR   VERSION 1.0  27 MAR 1984                                        
C                                                                               
C.PURPOSE                                                                       
C                                                                               
C  INTERFACE ROUTINES FOR THE FITTING STRUCTURES                                
C INTERMEDIATE ROUTINE TO COMPUTE FITTED VALUES                                 
C LIMITED TO THREE DIMS IN THIS VERSION-SPEED                                   
C                                                                               
C.ALGORITHM                                                                     
C                                                                               
C  USE MIDAS I/O INTERFACES TO FRAMES AND TABLES                                
C                                                                               
C.KEYWORDS                                                                      
C                                                                               
C  NON LINEAR FITTING                                                           
C                                                                               
C.VERSION
C 021122	last modif
C                                                                               
C----------------------------------------------------------------               
C                                                                               
C      IMPLICIT NONE                                                            
C                                                                               
      INTEGER NAXIS,NPIX1,NPIX2,NPIX3,I1,I2,I3

      REAL X(NPIX1,NPIX2,NPIX3)                                      
      REAL W(NPIX1,NPIX2,NPIX3)                                      
      REAL XIND(8),RESULT(2),CUT(4)                                        

      DOUBLE PRECISION RES(2)                                                   
      DOUBLE PRECISION STR(3),STP(3)                                           
C 
      INCLUDE   'MID_INCLUDE:FITI.INC'
      INCLUDE   'MID_INCLUDE:FITC.INC'
C                                                                               
C ITERATE ON PIXEL VALUES                                                       
C                                                                               
      CUT(1) = 0.                                                               
      CUT(2) = 0.                                                               
      CUT(3) = 1.E20                                                            
      CUT(4) = -CUT(3)                                                          
      DO 30 I3 = 1,NPIX3                                                      
          XIND(3) = STR(3) + (I3-1)*STP(3)                                      
          DO 20 I2 = 1,NPIX2                                                  
              XIND(2) = STR(2) + (I2-1)*STP(2)                                  
              DO 10 I1 = 1,NPIX1                                              
                  XIND(1) = STR(1) + (I1-1)*STP(1)                              
                  CALL FTCVAL(NAXIS,XIND,RES)                                   
                  RESULT(1) = RES(1)                                            
                  CUT(3) = AMIN1(CUT(3),RESULT(1))                              
                  CUT(4) = AMAX1(CUT(4),RESULT(1))                              
                  X(I1,I2,I3) = RESULT(1)                                       
                  IF (FZPTRM.NE.0) W(I1,I2,I3) = RES(2)                       
   10         CONTINUE                                                          
   20     CONTINUE                                                              
   30 CONTINUE                                                                  
      RETURN                                                                    
                                                                                
      END                                                                       

C @(#)sortit.for	19.1 (ESO-DMD) 02/25/03 14:01:08
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE SORTME(RA,ZBINS,N,LL,VALU,STATUS)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine SORTME	
C.AUTHOR
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  sorting
C
C.PURPOSE
C  sort an array to get the median value
C
C.ALGORITHM
C  for sorting we use the Heapsort algorithm from "Numerical Recipes", page 231
C
C.INPUT/OUTPUT
C
C  call as SORTME(RA,ZBINS,N,LL,VALU,STATUS)
C
C  input par:
C  ZBINS:	R*4 array	low, high excess bins
C				if low >= high, no excess bins
C  N:		I*4		size of array RA
C  LL:		I*4		index of array element to be returned
C
C  in/output par:
C  RA:		R*4 array	array to be sorted
C
C  output par:
C  VALU:	R*4 		value = RA(LL) of sorted array RA
C  STATUS:	I*4		return status, = 0 is o.k.
C
C.VERSIONS
C  1.00		pulled out from `smosub3.for'
C 
C--------------------------------------------------
C
C 
      IMPLICIT NONE
C 
      INTEGER   N,LL,STATUS
      INTEGER   NTRUE,LLTRUE,L
C 
      REAL      RA(N),ZBINS(2),VALU
      REAL      ZL,ZH
C 
      STATUS = 0
C 
C  first check for excess bins
      IF (ZBINS(2).GT.ZBINS(1)) THEN
         ZL = ZBINS(1)
         ZH = ZBINS(2)
         NTRUE = 0
         DO 100, L=1,N
            IF ((RA(L).GE.ZL).AND.(RA(L).LE.ZH)) THEN
               NTRUE = NTRUE + 1
               RA(NTRUE) = RA(L)
            ENDIF
100      CONTINUE
         LLTRUE = (NTRUE+1)/2
      ELSE
         NTRUE = N
         LLTRUE = LL
      ENDIF
C 
      IF (NTRUE.LE.3) THEN
         IF (NTRUE.LT.1) THEN
            STATUS = -1
            RETURN
         ELSE IF (NTRUE.LE.2) THEN
            VALU = RA(1)                 !for ndim = 1,2, median is 1st elem.
            RETURN
         ELSE 
            VALU = RA(2)                 !for ndim = 3, median is 2nd elem.
            RETURN
         ENDIF
      ENDIF
C 
      CALL NSORT(RA,NTRUE,LLTRUE,VALU)
      RETURN
C 
      END

C @(#)lisid.for	19.1 (ES0-DMD) 02/25/03 13:29:44
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE LISID(RMT,VN,NEQ,ND)
C++++
C.Purpose: RMT = MATRICE COEFFICIENTI
C          VN  = VETTORE TERMINI NOTI IN INPUT
C                VETTORE SOLUZIONE IN OUTPUT
C          NEQ = NUMERO EQUAZIONI SISTEMA
C          ND  = DIMENSIONI DELLA MATRICE RMT
C     
      IMPLICIT  DOUBLE PRECISION(A-H,O-Z)
      DOUBLE PRECISION  RMT(ND,ND)
      DOUBLE PRECISION  VN(1)
      INTEGER           NEQ
      INTEGER           ND
C
      INTEGER           I, J, K, L
C
      IF (NEQ.LE.ND) THEN
         DO 10 I = 1,NEQ                               ! controllo coefficienti 
            IF (ND.GT.0) THEN
               L = 0
               IF (RMT(I,I).EQ.0) THEN
                  L = 10
                  DO 20 J = 1,NEQ
                     IF (RMT(J,I).NE.0 .AND. RMT(I,J).NE.0 .AND. 
     2                  L.EQ.10) THEN
                        DO 30 K = 1,NEQ
                           AP       = RMT(I,K)
                           RMT(I,K) = RMT(J,K)
                           RMT(J,K) = AP
   30                   CONTINUE
                        AP    = VN(I)
                        VN(I) = VN(J)
                        VN(J) = AP
                        L     = 100
                     END IF
   20             CONTINUE
               END IF
C
               IF (L.EQ.10) THEN
                  ND = -1
               END IF
            END IF
   10    CONTINUE
C
         IF (ND.GT.0) THEN
            DO 40 I = 1,NEQ                                     ! soluzione sistema
               A = RMT(I,I)
               DO 50 L=I,NEQ
                  RMT(I,L)=RMT(I,L)/A
   50          CONTINUE
               VN(I) = VN(I)/A
               DO 60 J = 1,NEQ
                  IF (J.NE.I) THEN
                     B = RMT(J,I)
                     DO 70 K=I,NEQ
                        RMT(J,K) = RMT(J,K)-RMT(I,K)*B
   70                CONTINUE
                     VN(J) = VN(J)-VN(I)*B
                  END IF
   60          CONTINUE
   40       CONTINUE
         END IF
      END IF
C
      RETURN
      END

C @(#)ifstar.for	19.1 (ES0-DMD) 02/25/03 13:25:34
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C
C-----------------------------------------------------------------------
      SUBROUTINE IFSTAR(IBUFS, SCA, LPXL, LSBP, IS ,
     &                  JS, MPRF, IPSF, FPSF, IOFF0,
     &                  IOFF, STAR, IOFFI)
      INTEGER   IBUFS(4)
      REAL      SCA
      INTEGER   LPXL
      INTEGER   LSBP
      INTEGER   IS
      INTEGER   JS
      INTEGER   MPRF
      INTEGER   IPSF(0:MPRF)
      REAL      FPSF(1)
      INTEGER   IOFF0
      INTEGER   IOFF
      LOGICAL   STAR
      INTEGER   IOFFI                    ! OUT: Corrections offset
C
      INTEGER   I , ICSP , IOF0 , ITMP , NADR , NOSP
      REAL      TEMP , TEMP1
      REAL      MSBP
C
C *** Check if standard star.
      IF ( (-LPXL) .GE. IBUFS(1)
     &                  .AND. (-LPXL) .GE. IBUFS(2)
     &                  .AND. LPXL .LE. IBUFS(3)
     &                  .AND. LPXL .LE. IBUFS(4) ) THEN
          STAR = .TRUE.
      ELSE
          STAR = .FALSE.
      ENDIF
C
      IF ( STAR ) THEN
          MSBP = 2 * LSBP + 1
C
C ***     NOSP - maximum number of standard stars.
C
          NOSP = IPSF(0)
C
C ***     Find offset to adresses of standard stars intensities.
C
          IOF0 = (5+NOSP) * IOFF +
     &           ( (LSBP+JS) * MSBP + LSBP + IS ) * NOSP
C
C ***     Calculate current number of this standard object.
C
          NADR = (LSBP+JS) * MSBP + LSBP + IS + 1 + NOSP
          ICSP = IPSF(NADR) + 1
          IF ( ICSP .GT. NOSP ) THEN
C
C ***         Look if present object is brighter than any
C ***         of previously recorded standard objects.
C
              TEMP = FPSF(IOF0+1) + 1.0
              ITMP = 0
              DO 40 I = 1 , NOSP
                  TEMP1 = FPSF(IOF0+I)
                  IF ( SCA .GT. TEMP1 ) THEN
                      IF ( TEMP1 .LT. TEMP ) THEN
                          TEMP = TEMP1
                          ITMP = I
                      ENDIF
                  ENDIF
   40         CONTINUE
              IF ( ITMP .GT. 0 .AND. ITMP .LE. NOSP ) THEN
C
C ***             Replace fainter object.
C
                  ICSP = ITMP
                  FPSF(IOF0+ICSP) = SCA
              ELSE
C
C ***             Is too faint.
C
                  STAR = .FALSE.
                  ICSP = ICSP - 1
              ENDIF
          ELSE
C
C ***         Add new standard star.
C
              IPSF(NADR) = ICSP
              FPSF(IOF0+ICSP) = SCA
          ENDIF
C
          IOFFI = IOFF0 + (4+ICSP) * IOFF
      ENDIF
C
      RETURN
C
      END
C

C===========================================================================
C Copyright (C) 1995-2006 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C       Internet e-mail: midas@eso.org
C       Postal address: European Southern Observatory
C                       Data Management Division 
C                       Karl-Schwarzschild-Strasse 2
C                       D 85748 Garching bei Muenchen 
C                       GERMANY
C
C 
C.VERSION
C 060529	last modif
C 
C===========================================================================
C

C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
      SUBROUTINE FCN(NFrePm,g,f,x,flag,fuser)
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
      
c     dichiarazioni

      IMPLICIT DOUBLE PRECISION (a-h,o-z)
      integer NFrePm            ! number of FREE param: 
                                ! value may change during minimization
      integer flag
      INTEGER NTOT,NTOT2,NPAR,NPAR2
      parameter (NTOT=5000,NTOT2=2*NTOT,NPAR=50,NPAR2=100)
      
      DOUBLE PRECISION fuser
      DOUBLE PRECISION gammq,equwid !recipes & routine
      DOUBLE PRECISION x(NPAR),g(NPAR),f
      DOUBLE PRECISION tau(NTOT),spe_teo(NTOT),res(NTOT),pixsiz(NTOT)
      DOUBLE PRECISION alam(NTOT),speoss(NTOT),sig_n(NTOT),stdev(NTOT)
      
      DOUBLE PRECISION gaunor(NTOT),fitt(NTOT),chi,prob
      DOUBLE PRECISION bsum,sum1,sum,chi_rid,chi2,andf
      integer kk,il,ndf,iok,k

      DOUBLE PRECISION ErrPos(NPAR),ErrNeg(NPAR),ErrPar(NPAR)
      DOUBLE PRECISION Glob(NPAR),w(NPAR2)
      DOUBLE PRECISION ErLaPo(NPAR2),ErLaNe(NPAR2),ErLaPa(NPAR2)
      DOUBLE PRECISION ErNnPo(NPAR2),ErNnNe(NPAR2),ErNnPa(NPAR2)
      DOUBLE PRECISION ErBbPo(NPAR2),ErBbNe(NPAR2),ErBbPa(NPAR2)
      DOUBLE PRECISION ErBtPo(NPAR2),ErBtNe(NPAR2),ErBtPa(NPAR2)

      integer ninf(NPAR),nsup(NPAR)
      SAVE                              !previous SAVE (see below)
                                        !doesn't work with gfortran (gcc 4.0)
       
C!!!!!!!
C     Dati globali (ma limitati a MID_REL_INCL:fit_min)
C!!!!!!!
      DOUBLE PRECISION LamEm(NPAR2),Gam(NPAR2),Fos(NPAR2)
      DOUBLE PRECISION LamCen(NPAR2),BDopp(NPAR2),Coeff(4,NPAR2)
      DOUBLE PRECISION BTur(NPAR2),NHFit(NPAR2),FitMn(NPAR2)
      DOUBLE PRECISION FitMx(NPAR2)

      integer npunti,NIntv,NRgTot,ij,jj,i
      integer NTotPm,IPar(4,NPAR2)
      
      common/dati/LamEm,Gam,Fos,LamCen,BDopp,BTur,NHFit,FitMn,FitMx,
     1     NPunti,NIntv,NRgTot,NTotPm,IPar,Coeff


C      SAVE ninf,nsup            !KB on a hint of Alain Smette
C                                ! <smette@astro.ulg.ac.be>
     
 
      if (flag.eq.1) then
         
C!!!!!!!
C     Inizializza FCN leggendo la configurazione di righe di default
C!!!!!!!
c     debug
c      write(6,*)'Start 1 run - read set up'
c     end debug
         
         call InizParam(iok)
         do i=1,Npunti
            res(i)=0.D0
         end do
c     debug
c      write(6,*) LamEm(1),Gam(1),Fos(1),LamCen(1),BDopp(1),NHFit(1)
     
C!!!!!!!
C     Legge il file con lo spettro, il S/N e la FWHM
C!!!!!!!
         open(10,file='fdummy.spe',status='old')
         jj=1
 10      read(10,*,end=15) alam(jj),pixsiz(jj),speoss(jj),sig_n(jj),
     +        stdev(jj)
         jj=jj+1
         go to 10
 15      close(10)
         npunti=jj-1
         call InitConvGauss(stdev,gaunor,npunti)
         
c     debug
c     write(6,*) alam(1), speoss(1), sig_n(1)
c     write(6,*) alam(2), speoss(2), sig_n(2)
c     
         
         
C!!!!!!!
C     Ricava gli indici relativi agli estremi tra cui calcolare il chi2
C!!!!!!!
         do ij = 1,NIntv
            do i=1,NPunti
               if (FitMn(ij).eq.alam(i)) then
                  ninf(ij)=i
               else if (FitMn(ij).gt.alam(i).and.FitMn(ij).
     1                 lt.alam(i+1)) then
                  ninf(ij)=i+1
               end if
               if (FitMx(ij).eq.alam(i)) then
                  nsup(ij)=i
               else if (FitMx(ij).gt.alam(i).and.FitMx(ij).
     1                 lt.alam(i+1)) then
                  nsup(ij)=i
               end if
            end do
         end do
         
      end if                    ! fine inizializzazione
c     write(6,*)alam(1),alam(2),alam(128)
C!!!!!!!
C     OPERAZIONI ORDINARIE 
C!!!!!!!
      
c     debug
c     write(6,*)'start run'
c     write(6,*)'lam: ',alam(1),alam(2),alam(128)
c     write(6,*)'function value: ',f
c     write(6,*)'Nparam: ',n
c     write(6,*)'Param: ',x(1),x(2),x(3)
c     end debug
      
      x(NTotPm+1)=0.D0
      
      do i=1,NRGTot
         LamCen(i)=x(IPar(1,i))*Coeff(1,i)
         NHFit(i)=x(IPar(2,i))*Coeff(2,i)
         BDopp(i)=x(IPar(3,i))*Coeff(3,i)
         BTur(i)=x(IPar(4,i))*Coeff(4,i)
      end do
c      write(6,*) LamEm(1),Gam(1),Fos(1),LamCen(1),BDopp(1),NHFit(1),
c     1 BTur(1)
c     do kji =1,NFrePm
c     write(6,*)x(kji)
c     end do
c     write(6,*)' end run'
c     
C!!!!!!!
C     calcolo della profondita' ottica
C!!!!!!!
      
      do i=1,NPunti
         tau(i)=0.D0
      end do
      
c     debug
c     write(6,*)NPunti,' Npunti'
c     write(6,*)'alam:'
c     write(6,*)alam(1),alam(2),alam(128)
c     end debug
      
      do i=1,NRgTot
         bsum=dsqrt(BDopp(i)*BDopp(i)+BTur(i)*BTur(i))
         call OptDep(LamCen(i),bsum,NHFit(i),LamEm(i),
     1        fos(i),gam(i),alam,NPunti,tau)
      end do
c     write(6,*)alam(1),alam(2),alam(128)
c     debug
c     write(6,*)'tau:'
c     write(6,*)tau(1),tau(2),tau(128)
c     write(6,*)' end run'
C!!!!!!!
C     calcolo dello spettro non convoluto
C!!!!!!!
      do i=1,NPunti
         fitt(i)=dexp(-tau(i))
      end do
      
C!!!!!!!
C     Convolution with Instrumental Response
C!!!!!!!
      call ConvGauss(alam,pixsiz,fitt,stdev,gaunor,spe_teo,NPunti)
c      do ij=1,NPunti 
c         if (spe_teo(ij).gt.1.D0) spe_teo(ij)=1.D0
c      end do
      
c     debug
c     write(6,*)'Spettro teorico:'
c     write(6,*)spe_teo(1),spe_teo(2),spe_teo(128)
c     end debug
C!!!!!!!
c        calcolo chi quadro
C!!!!!!!
      kk=0                               
      sum1=0.D0
      f=0.D0
      do ij = 1,NIntv
         do i=ninf(ij),nsup(ij)
            sum=speoss(i)-spe_teo(i)
            sum1=sum*sum/sig_n(i)
            f=f+sum1
            kk =kk+1
         end do
      end do
      
C!!!!!!!
C     Fine operazione ORDINARIE  (continua solo se ha trovato minimo)
C!!!!!!!
c     debug
c     write(6,*)'lam: ',alam(1),alam(2),alam(128)
c     write(6,*)'function value: ',f
c     write(6,*)'Nparam: ',n
c     write(6,*)'Param: ',x(1),x(2),x(3)
c     write(6,*)'End run'
c     end debug
      if (flag.ne.3) return
c     debug
c     call ConvGauss2(alam,fitt,stdev,gaunor,spe_teo,NPunti)
c     end debug
      
      
C!!!!!!!
c     calcolo probabilita' del fit
C!!!!!!!
      chi=f
      ndf=kk-NFrePm
      andf=ndf
      chi_rid=chi/andf
      andf=ndf/2.D0
      chi2=chi/2.D0
      prob=gammq(andf,chi2)

c!!!!!!! 
C     Retrieves errors
c!!!!!!!
      do i=1,NTotPm
         call MNERRS(i,ErrPos(i),ErrNeg(i),ErrPar(i),Glob(i))
      end do

      do i=1,NRGTot

         ErLaPo(i)=ErrPos(IPar(1,i))*Coeff(1,i)
         ErLaNe(i)=ErrNeg(IPar(1,i))*Coeff(1,i)
         ErLaPa(i)=ErrPar(IPar(1,i))*Coeff(1,i)

         ErNnPo(i)=ErrPos(IPar(2,i))*Coeff(2,i)
         ErNnNe(i)=ErrNeg(IPar(2,i))*Coeff(2,i)
         ErNnPa(i)=ErrPar(IPar(2,i))*Coeff(2,i)

         ErBbPo(i)=ErrPos(IPar(3,i))*Coeff(3,i)
         ErBbNe(i)=ErrNeg(IPar(3,i))*Coeff(3,i)
         ErBbPa(i)=ErrPar(IPar(3,i))*Coeff(3,i)

         ErBtPo(i)=ErrPos(IPar(4,i))*Coeff(4,i)
         ErBtNe(i)=ErrNeg(IPar(4,i))*Coeff(4,i)
         ErBtPa(i)=ErrPar(IPar(4,i))*Coeff(4,i)
      end do

C     Calcola la larghezza equivalente

      do il=1,NRgTot
         bsum=dsqrt(BDopp(il)*BDopp(il)+BTur(il)*BTur(il))         
c         write(strout,*)LamCen(il),bsum,NHFit(il)
c     1        LamEm(il),fos(il),gam(il)
c         call sttdis(strout,0,il)
         w(il)=Equwid(LamCen(il),bsum,NHFit(il),
     1        LamEm(il),fos(il),gam(il))
      end do 

c!!!!!!!
c     Aggiorna File fdummy.res
c!!!!!!!
      
      open(11,file='fdummy.res',status='old',err=33)
      close(11,status='delete')
 33   open(11,file='fdummy.res',status='new')

      write(11,*)chi_rid,prob
      do i=1,NRgTot
         
         write(11,'(17G19.9E3)')LamCen(i),NHfit(i),BDopp(i),BTur(i),
     1        w(i),ErLaPa(i),ErNnPa(i),ErBbPa(i),ErBtPa(i),
     2        ErLaPo(i),ErLaNe(i),ErNnPo(i),ErNnNe(i),
     3        ErBbPo(i),ErBbNe(i),ErBtPo(i),ErBtNe(i)

      end do

      close(11)
      
      
c!!!!!!!
c     Aggiorna file fdummy.grf
c!!!!!!!
      open(20,file='fdummy.grf',status='old',err=305)
      close(20,status='delete')
 305  open(20,file='fdummy.grf',status='new')
                                ! calcola i residui
      do ij = 1,NIntv
         do i=ninf(ij),nsup(ij)
            res(i)=speoss(i)-spe_teo(i)
         end do
      end do

      do k=1,npunti
c         if (spe_teo(k).gt.1.) spe_teo(k)=1.D0
         write(20,'(4E16.7)') alam(k),spe_teo(k),res(k),fitt(k)
      end do
      close (20)
      
      return
      end
      
      
      FUNCTION H(A,V)
C     *************** 
      
C     FUNCTION DI VOIGT
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      
      LOGICAL Q      
      
      VV=V*V
      Q=A.LT.0.2
      IF(Q.AND.V.GT.5.)GOTO 1 
      IF(.NOT.Q.AND.(A.GT.1.4.OR.A+V.GT.3.2))GOTO 2    
      HO=DEXP(-VV)
      H2=(1.-2.*VV)*HO
      IF(V.GT.2.4)GOTO 3
      IF(V.GT.1.3)GOTO 4 
      H1=(.42139D0*VV-2.34358D0*V+3.28868D0)*VV-.15517D0*V-1.1247D0
    5 IF(Q)GOTO 6      
      HH1=H1+HO*1.12838D0
      HH2=H2+HH1*1.12838D0-HO  
      HH3=(1.-H2)*.37613D0-HH1*.66667D0*VV+HH2*1.12838D0 
      HH4=(3.D0*HH3-HH1)*.37613D0+HO*.66667D0*VV*VV  
      H=((((HH4*A+HH3)*A+HH2)*A+HH1)*A+HO)*(((-.122727278D0*A
     1     +.532770573D0)*A-.96284325D0)*A+.979895032D0)
      RETURN     
    1 H=((2.12D0/VV+.8463D0)/VV+.5642D0)*A/VV  
      RETURN               
    2 AA=A*A
      U=(AA+VV)*1.4142D0 
      UU=U*U          
      H=((((AA-10.D0*VV)*AA*3.D0+15.D0*VV*VV)/UU+3.D0*VV-AA)/UU+1.D0)*
     1     A*.79788D0/U  
      RETURN      
    3 H1=((-.0032783D0*VV+.0429913D0*V-.188326D0)*VV+.278712D0*
     >     V+.55415D0)/(VV-1.5D0)
      GOTO 5       
    4 H1=(-.220416D0*VV+1.989196D0*V-6.61487D0)*VV+9.39456D0*V-4.4848D0
      GOTO 5  
    6 H=(H2*A+H1)*A+HO  
      RETURN             
      END
      
      
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        function Equwid(LC,B,N,LE,fos,gam)
C
C        Calcola la larghezza equivalente di una riga
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DOUBLE PRECISION LC,B,LE,N,fos,gam
        DOUBLE PRECISION le0
        integer nint
        double precision offset,tau

        common /datiriga/al,bd,ah,le0,fos0,gam0

        external GG

        le0=le
        fos0=fos
        gam0=gam
        al=LC
        bd=B
        ah=N
        offset = 4.
        
 10     offset = offset +2.
        alambda2 = LC+offset
        tau=0.
        call OptDep(LC,B,N,LE,fos,gam,alambda2,1,tau)
        if (tau.gt.1.D-3) goto 10

        alambda2=LC+offset
        alambda1=LC-offset
        nint=2.*offset/0.05 +1
        call sim(alambda1,alambda2,sint,nint,GG)
        Equwid=sint/LC*LE

        return

        end


C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        FUNCTION GG(ALAMM)
C
C        Funzione ausiliaria per il calcolo della larghezza equiv.
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DOUBLE PRECISION LC,B,LE,N,fos,gam
        INTEGER NPUNTI

        common /datiriga/lc,b,n,le,fos,gam

        tau=0.
        NPunti=1
        call OptDep(LC,B,N,LE,fos,gam,alamm,Npunti,tau)

        GG=1.D0-dexp(-tau)

        return

        end



C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE SIM(AA,BB,SOMMA,NINT,G)
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        INTEGER NINT,JK,NN

        EXTERNAL G
        BA=BB-AA
        SOMMA=G(AA)+G(BB)
        VINT=BA/NINT
        XD=AA+VINT/2.D0
        SD=G(XD)
        SP=0.
        NN=NINT-1
        DO 1 JK=1,NN
        XP=XD+VINT/2.D0
        XD=XP+VINT/2.D0
        SP=SP+G(XP)
1        SD=SD+G(XD)
        SOMMA=SOMMA+2.D0*SP+4.D0*SD
        SOMMA=SOMMA*VINT/6.D0
        RETURN
        END



C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        subroutine InizParam(flag)
C
C        Legge una configurazione di righe dal file fitly.fcn
C        e genera i vettori di parametri delle righe
C        che usa FCN
C        Ritorna una flag  di errore
C
C        flag:            integer        flag di errore: se 0 ok, 
C                                se <0 errore
C
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

        integer flag
C        IMPLICIT none
        INTEGER NTOT,NTOT2,NPAR,NPAR2
        parameter (NTOT=5000,NTOT2=NTOT*2,NPAR=50,NPAR2=100)
        DOUBLE PRECISION LamEm(NPAR2),Gam(NPAR2),Fos(NPAR2)
        DOUBLE PRECISION LamCen(NPAR2),BDopp(NPAR2),Coeff(4,NPAR2)
        DOUBLE PRECISION BTur(NPAR2),NHFit(NPAR2),FitMn(NPAR2)
        DOUBLE PRECISION FitMx(NPAR2)
        integer npunti,NIntv,NRgTot
        integer NTotPm,IPar(4,NPAR2)

        common/dati/LamEm,Gam,Fos,LamCen,BDopp,BTur,NHFit,FitMn,FitMx,
     1        NPunti,NIntv,NRgTot,NTotPm,IPar,Coeff

C        character*20 Junk
        integer i,k,j

C&&&&&&&
C        Azzera un po' di variabili..
C&&&&&&&
        NTotPm=0
        do i=1,NPAR2
                LamEm(i)=0.D0
                Gam(i)=0.D0
                Fos(i)=0.D0
                LamCen(i)=0.D0
                BDopp(i)=0.D0
                BTur(i)=0.D0
                NHFit(i)=0.D0
                FitMn(i)=0.D0
                FitMx(i)=0.D0
                do k=1,4
                   Coeff(k,i)=0.D0
                   IPar(k,i)=0
                end do
        end do

        flag=-1
C&&&&&&&
C&        Apre file
C&&&&&&&
        open(10,file='fdummy.fcn',iostat=i,status='old')
        if (i.ne.0)  then
                flag=-1
                close(10)
                return
        end if
        
C&&&&&&&
C&        Legge parametri innesco
C&&&&&&&

 101    format(4I3,G16.8,F4.1,G16.8,F4.1,F11.4,F9.5,G13.5)

        read(10,*)NRgTot
        do j=1,NRgTot
 90        read(10,1001,err=99)(IPar(i,j),i=1,4),(Coeff(i,j),i=1,4)
     1    ,LamEm(j),Fos(j),Gam(j)
        end do
 1001        format(4I3,7G16.8)

C         gets number of parameters
        do  j=1,NRgTot
           do i=1,4
              if (IPar(i,j).gt.NTotPm) NTotPm= IPar(i,j)
           end do
        end do

C&&&&&&&
C       Reads limits
C&&&&&&&
        read(10,*,end=99,err=99)NIntv
        do i  = 1,NIntv
          read(10,*,end=99,err=99)FitMn(i),FitMx(i)
        end do        

        flag=0

99            continue

        close(10)
        return

        end



C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        subroutine Minmze
C
C        Chiama la routine di minimizzazione MINUIT
C
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

        external FCN
        integer ista,iwrite,iread,ipunch

c        include 'MID_REL_INCL:fit_var.inc'

        open(90,file='fdummy.min',status='old',err=93)

        open(91,file='punch.dat',status='old',err=10)
        close(91,status='delete')
10      open(91,file='punch.dat',status='new',iostat=ista)

        open(92,file='fdummy.jou',status='old',err=20)
        close(92,status='delete')
 20     open(92,file='fdummy.jou',status='new',iostat=ista)

        iwrite=92
        iread=90
        ipunch=91

        call mintio(iread,iwrite,ipunch)
        CALL MINUIT(FCN,0)

        close(90)
        close(91,status='delete')
        close(92)

 93     return 
        end


C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        Subroutine InitConvGauss(stdev,gaunor,npunti)
C
C       Prepare variables for ConvGauss from fwhm
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        INTEGER NTOT,NTOT2,NPAR,NPAR2
        parameter (NTOT=5000,NTOT2=2*NTOT,NPAR=50,NPAR2=100)
        integer npunti,ijk
        DOUBLE PRECISION stdev(npunti),gaunor(npunti)
        DOUBLE PRECISION pi
        pi=dacos(-0.1D+01)

c        DOUBLE PRECISION ax,step
c        DOUBLE PRECISION gausstab(NTOT2)
c        common/gauss/gausstab,step,nstep

c     nstep=NTOT
c     step = 3.5/nstep
c     do ij=1,nstep
c     rij=ij - 1
c     ax = rij * step
c     gausstab(ij)= dexp(-ax*ax)
c     end do

        DO IJK=1,npunti
            stdev(ijk) = stdev(ijk)/2.D0/dsqrt(2.D0*dlog(2.D0))   ! FWHM -> sigma
            gaunor(ijk) = 1.D0 / dsqrt(2.D0 * pi) /stdev(ijk)    ! gauss. norm.
            stdev(ijk) = stdev(ijk) * dsqrt(2.D0)               ! sigma-> s*rad2
        end do

        return
        end

C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        Subroutine ConvGauss(alam,pixsiz,fitt,sig,norm,spe_t,NPunti)
C        
C        Performs convolution of a spectrum with a gaussian response
c        function variyng with wavelength
c        
c        alam: spectrum wavelengths
c        fitt: spectrum data
c        sig: sqrt(2.) * stdev gaussian   (stdev = FWHM / 2/sqrt(2*alog(2))  )
c        norm:  stdev * sqrt(2*3.14)        (gaussian normalization)
c        spe_t: convolved spectrum
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

C        IMPLICIT NONE
        integer NPunti
        DOUBLE PRECISION alam(Npunti),fitt(NPunti),sig(NPunti)
        DOUBLE PRECISION spe_t(NPunti),norm(NPunti),pixsiz(NPunti)

        DOUBLE PRECISION gauss

c        integer nstep,i,ind
c        DOUBLE PRECISION gausstab(10000),step
c        common/gauss/gausstab,step,nstep

        integer il,ic
        DOUBLE PRECISION sum,dlam


        do il=1,NPunti
          sum=0.D0
          do ic=il,Npunti
            dlam = (alam(ic) - alam(il)) / sig(ic)
c            ind = idnint(dabs(dlam)/step) + 1
c            if (ind.gt.nstep) goto 100
c            sum = sum + norm(ic)*gausstab(ind)*fitt(ic)
            gauss  = dexp(-dlam * dlam)
            if (gauss.lt.1D-5) goto 100
            sum = sum + norm(ic)*gauss*fitt(ic)

          end do
 100      continue
          if (gauss.gt.1D-5) then
             dlam = dlam+pixsiz(il)/ sig(Npunti)
             gauss  = dexp(-dlam * dlam)
             sum = sum + norm(Npunti)*gauss*1.D0  !convolvo continuo
             goto 100
          endif              

          do ic=il-1,1,-1
            dlam = (alam(ic) - alam(il))/sig(ic)
c            ind = idnint(dabs(dlam)/step) + 1
c            if (ind.gt.nstep) goto 200
c            sum = sum + norm(ic)*gausstab(ind)*fitt(ic)
            gauss  = dexp(-dlam * dlam)
            if (gauss.lt.1D-5) goto 200
            sum = sum + norm(ic)*gauss*fitt(ic)
          end do
 200      continue
          if (il.eq.1)  then
             gauss =1.D0
             dlam = 0.D0
          endif
 201      if (gauss.gt.1D-5) then
             dlam = dlam-pixsiz(il)/ sig(1)
             gauss  = dexp(-dlam * dlam)
             sum = sum + norm(1)*gauss*1.D0  !convolvo continuo
             goto 201
          endif              

                        ! moltiplica per il pixel size.
          spe_t(il) = sum * pixsiz(il)

        end do

        return
        end



C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE OptDep(cla,b,nh,lamem,f,gamma,lam,nlam,tau)
C
C       Calcola la profondita' ottica relativa ad una riga e la SOMMA
C       a quella gia' esistente.
C       Versione FAST: il calcolo e' limitato alla zona in cui tau>10^-7
C
C       Variabili:
C       cla     DOUBLE PRECISION            Input   lambda osservata della riga
C       b       DOUBLE PRECISION            "       b Doppler riga
C       nh      DOUBLE PRECISION            "       NH riga
C       lamem   DOUBLE PRECISION            "       lamda emissione
C       f       DOUBLE PRECISION            "       Forza oscillatore
C       gamma   DOUBLE PRECISION            "       Damping constant
C       lam     DOUBLE PRECISION(nlam)      "       vettore lambda
C       nlam    INTEGER         "       numero punti
C       tau     DOUBLE PRECISION(nlam)      In/Out  vettore prof. ottica
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DOUBLE PRECISION cla,b,nh,f,lamem,gamma,lam(nlam),tau(nlam)
        DOUBLE PRECISION SOGLIA
        PARAMETER  (SOGLIA=1.D-7)
        INTEGER NLAM,I,ind0
        pi=dacos(-0.1D+01)
        sp=dsqrt(pi)
        r0=2.81794D-13
        c=3.0D+05

        a=0.D0
        hh=0.D0
        sig1=0.D0
        sig2=0.D0

        dlamD=b*cla/c
        a=gamma*lamem/(4.D0*pi*b*1.D13)
        sig1=r0*lamem*1.d-8*f*sp/dlamD*cla

        do i=1,nlam
          if (lam(i).gt.cla) goto 10
        end do
10      ind0=i

        do i=ind0,nlam
              v=dabs((cla-lam(i))/dlamD)
              hh=h(a,v)
              sig2=sig1*hh
              tau(i)=10.D0**nh*sig2+tau(i)
              if (tau(i).lt.SOGLIA) goto 20
        end do

20      continue

        do i=ind0-1,1,-1
              v=dabs((cla-lam(i))/dlamD)
              hh=h(a,v)
              sig2=sig1*hh
              tau(i)=10.D0**nh*sig2+tau(i)
              if (tau(i).lt.SOGLIA) goto 30
        end do
c debug write(6,*)lam(1),lam(nlam)
30      continue

        return
        end



C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        subroutine CHECK(gptau,NomEle,lambda,b,NH,fullwh,nrighe,x,
     1    pixs,npt,flux,unconv)
C
C       Compute an absorption  spectrum
C
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        implicit none
        include 'MID_REL_INCL:fit_var.inc'   ! for atompar.dat

        integer npt,nrighe
        character*14 NomEle(nrighe)
        double precision gptau,lambda(nrighe),b(nrighe)
        double precision NH(nrighe),fullwh(nrighe)
        double precision  x(npt),flux(npt),unconv(npt),pixs(npt)

        double precision lamem,f,gamma
        double precision gaunor(NMXSPE),tau(NMXSPE)
        double precision stdev(NMXSPE),gptau0

        integer j,i
        
c        integer pp
        
        do i=1,npt
           stdev(i)=fullwh(i)
        end do

        gptau0=dexp(-gptau)
        
        
        call InitConvGauss(stdev,gaunor,npt)
        

C&&&&&&&
C       Calcola il profilo teorico
C&&&&&&&
        do i=1,npt
           tau(i)=0.0
        end do
        
        do i=1,nrighe
           do j = 1,AT_N
              if (NomEle(i).eq.AT_NAM(j)) then
                 lamem = AT_LAM(j)
                 f = AT_FOS(j)
                 gamma = AT_GAM(j)
                 goto 456
              end if
           end do
 456       continue
           
           call OptDep(lambda(i),b(i),NH(i),lamem,
     1          f,gamma,x,npt,tau)
        end do
        
        do i=1,npt
           unconv(i)=exp(-tau(i)) * gptau0
        end do
        
        call ConvGauss(x,pixs,unconv,stdev,gaunor,flux,Npt)
        
c       debug
c       do i=1,npt
c           if (flux(i).lt.-0.5.or.flux(i).gt.1.5) then
c              open(20,file='test2.dbx',status='unknown')
c              write(20,*)'lambda, flusso:, flusso conv.'
c              do pp = 1,npt
c                 write(20,*)x(pp),tau(pp),flux(pp)
c              end do
c              close(20)
c              stop
c           end if
c        end do
c end debug

        return 
       end




C******
      function INTRAC()
C
C     required by MINUIT
C******
      logical INTRAC
      INTRAC=.FALSE.
      return
      end

CC
C     This is a small subset of the "Numerical Recipes" routines,
C     currently used by the program. They are exactly identical to 
C     those of the original library, except  for a different warning
C     (instead of 'A too large, ITMAX too small' , a 
C     Midas warning is inserted)



      FUNCTION GAMMQ(A,X)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      IMPLICIT INTEGER (I-N)
CC      IF(X.LT.0..OR.A.LE.0.)PAUSE		=> to STETER call 
      IF (X.LT.0..OR.A.LE.0.)THEN
         CALL STETER(44,'X.LT.0..OR.A.LE.0. in function INTRAC')
      ENDIF
 
      IF(X.LT.A+1.)THEN
        CALL GSER(GAMSER,A,X,GLN)
        GAMMQ=1.D0-GAMSER
      ELSE
        CALL GCF(GAMMCF,A,X,GLN)
        GAMMQ=GAMMCF
      ENDIF
      RETURN
      END


      SUBROUTINE GSER(GAMSER,A,X,GLN)
      IMPLICIT INTEGER (I-N)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      PARAMETER (ITMAX=100,EPS=3.E-7)
      GLN=GAMMLN(A)
      IF(X.LE.0.)THEN
CC        IF(X.LT.0.)PAUSE			=> STETER call
        IF (X.LT.0.) THEN
           CALL STETER(45,'X.LT.0. in function GSER')
        ENDIF
 
        GAMSER=0.
        RETURN
      ENDIF
      AP=A
      SUM=1./A
      DEL=SUM
      DO 11 N=1,ITMAX
        AP=AP+1.
        DEL=DEL*X/AP
        SUM=SUM+DEL
        IF(DABS(DEL).LT.DABS(SUM)*EPS)GO TO 1
11    CONTINUE
c      PAUSE 'A too large, ITMAX too small'
      call WrnMsg('Prob(chi2) may be inaccurate')
1     GAMSER=SUM*DEXP(-X+A*DLOG(X)-GLN)
      RETURN
      END
      SUBROUTINE GCF(GAMMCF,A,X,GLN)
      IMPLICIT INTEGER (I-N)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      PARAMETER (ITMAX=100,EPS=3.E-7)
      GLN=GAMMLN(A)
      GOLD=0.
      A0=1.
      A1=X
      B0=0.
      B1=1.
      FAC=1.
      DO 11 N=1,ITMAX
        AN=DFLOAT(N)
        ANA=AN-A
        A0=(A1+A0*ANA)*FAC
        B0=(B1+B0*ANA)*FAC
        ANF=AN*FAC
        A1=X*A0+ANF*A1
        B1=X*B0+ANF*B1
        IF(A1.NE.0.D0)THEN
          FAC=1.D0/A1
          G=B1*FAC
          IF(DABS((G-GOLD)/G).LT.EPS)GO TO 1
          GOLD=G
        ENDIF
11    CONTINUE
c      PAUSE 'A too large, ITMAX too small'
      call WrnMsg('Prob(chi2) may be inaccurate')
1     GAMMCF=DEXP(-X+A*DLOG(X)-GLN)*G
      RETURN
      END
      SUBROUTINE PIKSR2(N,ARR,BRR)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      IMPLICIT INTEGER (I-N)
      DIMENSION ARR(N),BRR(N)
      DO 12 J=2,N
        A=ARR(J)
        B=BRR(J)
        DO 11 I=J-1,1,-1
          IF(ARR(I).LE.A)GO TO 10
          ARR(I+1)=ARR(I)
          BRR(I+1)=BRR(I)
11      CONTINUE
        I=0
10      ARR(I+1)=A
        BRR(I+1)=B
12    CONTINUE
      RETURN
      END
      FUNCTION GAMMLN(XX)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      IMPLICIT INTEGER (I-N)
      DOUBLE PRECISION COF(6),STP,HALF,ONE,FPF,X,TMP,SER
      DATA COF,STP/76.18009173D0,-86.50532033D0,24.01409822D0,
     *    -1.231739516D0,.120858003D-2,-.536382D-5,2.50662827465D0/
      DATA HALF,ONE,FPF/0.5D0,1.0D0,5.5D0/
      X=XX-ONE
      TMP=X+FPF
      TMP=(X+HALF)*DLOG(TMP)-TMP
      SER=ONE
      DO 11 J=1,6
        X=X+ONE
        SER=SER+COF(J)/X
11    CONTINUE
      GAMMLN=TMP+DLOG(STP*SER)
      RETURN
      END
      function gasdev(idum)
      double precision gasdev,v1,v2,r,fac,gset,ran1n
       external  ran1n
       integer iset,idum
       iset=0
       if(iset.eq.0)then
  1       v1=2.D0*ran1n(idum)-1.D0
          v2=2.D0*ran1n(idum)-1.D0
          r=v1**2.D0+v2**2.D0
          if(r.ge.1.)go to 1
          fac=dsqrt(-2.*dlog(r)/r)
          gset=v1*fac
          gasdev=v2*fac
          iset=1
       else
          gasdev=gset
          iset=0
       endif
       return
       end
      FUNCTION RAN1N(IDUM)
      double PRECISION RAN1N  
      DOUBLE  PRECISION R(97)
      INTEGER M1,M2,M3,IA1,IA2,IA3,IC1,IC2,IC3,IFF
      INTEGER IDUM,ix1,ix2,ix3,j	
      DOUBLE PRECISION RM1,RM2
      PARAMETER (M1=259200,IA1=7141,IC1=54773,RM1=3.8580247D-6)
      PARAMETER (M2=134456,IA2=8121,IC2=28411,RM2=7.4373773D-6)
      PARAMETER (M3=243000,IA3=4561,IC3=51349)
      data IFF /1/

      IF (IDUM.LT.0.OR.IFF.EQ.0) THEN
        IFF=1
        IX1=MOD(IC1-IDUM,M1)
        IX1=MOD(IA1*IX1+IC1,M1)
        IX2=MOD(IX1,M2)
        IX1=MOD(IA1*IX1+IC1,M1)
        IX3=MOD(IX1,M3)
        DO 11 J=1,97
          IX1=MOD(IA1*IX1+IC1,M1)
          IX2=MOD(IA2*IX2+IC2,M2)
          R(J)=(DFLOAT(IX1)+DFLOAT(IX2)*RM2)*RM1
11      CONTINUE
        IDUM=1
      ENDIF
      IX1=MOD(IA1*IX1+IC1,M1)
      IX2=MOD(IA2*IX2+IC2,M2)
      IX3=MOD(IA3*IX3+IC3,M3)
      J=1+(97*IX3)/M3
      IF(J.GT.97.OR.J.LT.1)PAUSE
      RAN1N=R(J)
      R(J)=(DFLOAT(IX1)+DFLOAT(IX2)*RM2)*RM1
      RETURN
      END

C @(#)rlbias.for	19.1 (ES0-DMD) 02/25/03 13:25:38
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C
C-----------------------------------------------------------------------
      SUBROUTINE RLBIAS(PRFL, ICNT, BARG)
C
      IMPLICIT  NONE
      REAL      PRFL(8,0:1)
      INTEGER   ICNT(8,0:1)
      REAL      BARG
C
      INTEGER   ITEMP
      INTEGER   K
C
      REAL      AV, SIG
      REAL      TEMP(8)
C
      ITEMP = 0
      DO 10 K = 1 , 8
          IF ( ICNT(K,1) .GT. 0 ) THEN
              ITEMP = ITEMP + 1
              TEMP(ITEMP) = PRFL(K,1)
          ENDIF
   10 CONTINUE
      IF ( ITEMP .GE. 2 ) THEN
          CALL MEAN ( TEMP , ITEMP , AV , SIG )
          IF ( SIG .GT. 0.1*AV ) THEN
              BARG = AV / SIG
          ELSE
              BARG = 10.0
          ENDIF
      ELSE
          BARG = 10.0
      ENDIF
C
      RETURN
C
      END
C

C @(#)tsaort.for	19.1 (ESO-DMD) 02/25/03 13:33:26
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT (c) 1992 European Southern Observatory & Copernicus Astron. Center
C.IDENT     tsaort.for
C.AUTHOR    Alex Schwarzenberg-Czerny, Copernicus Astron. Center, Warsaw
C.KEYWORD   MIDAS, time series, ORT/TSA
C.LANGUAGE  FORTRAN 77
C.PURPOSE   Compute multiharmonic Fourier spectrum by orthogonal projections
C.VERSION   0.0               June 1996
C.RETURNS   None
C.ENVIRON   TIME/ANAL context
C 
C 020507	last modif
C 02/10/11	new meaning of ORDERTSA/order parameter
C 02/10/11	algorithm uses new formulae for better rounding
C 
C-----------------------------------------------------------------------------
C
      IMPLICIT NONE
      INTEGER      NAXIS
      PARAMETER    (NAXIS=2)
      INTEGER      LENGTH(NAXIS)        !  NUMBER OF FREQUENCIES
      INTEGER      ORDER                !  NUMBER OF BINS
      INTEGER      MODE                
      INTEGER      IACTS,KUN,KNUL
      INTEGER      TID,ITIME,IVAL
      INTEGER      NCOL,ICOL,NROW,IROW,ISOR
      INTEGER      LFIELD,TTYP,VTYP
      INTEGER      ICZ,ICZN,ICCF,ICP
      INTEGER      NOBS2,ASIZE
      INTEGER*8    PTIME,PVAL,PPER,IDPER
      INTEGER*8    CZ,CZN,CCF,CP
C 
      CHARACTER*10 FORM
      CHARACTER*80 TEXT
      CHARACTER*60 INAME                !  NAME OF INPUT TABLE
      CHARACTER*60 ONAME                !  NAME OF OUTPUT IMAGE
C
      DOUBLE PRECISION  START(NAXIS)         !  START FREQUENCY
      DOUBLE PRECISION  STEP(NAXIS)          !  STEP IN FREQUENCY
      DOUBLE PRECISION  OM
C
      INCLUDE 'MID_REL_INCL:TSA_DEF.INC'
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      INCLUDE 'MID_REL_INCL:TSA_DAT.INC'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C   Get parameters
C
      CALL STSPRO ('tsaort')
      CALL STKRDC ('IN_A'  ,1,1,60,IACTS,INAME    ,KUN,KNUL,ISTAT)
      CALL STKRDC ('OUT_A', 1,1,60,IACTS,ONAME    ,KUN,KNUL,ISTAT)
      CALL STKRDD ('STARTTSA',
     $     1, 1,IACTS,START(1) ,KUN,KNUL,ISTAT)
      CALL STKRDD ('STEPTSA',
     $     1, 1,IACTS,STEP(1)  ,KUN,KNUL,ISTAT)
      CALL STKRDI ('NSTEPS',  1, 1,IACTS,LENGTH(1),KUN,KNUL,ISTAT)
      CALL STKRDI ('ORDERTSA',
     $     1, 1,IACTS,ORDER, KUN,KNUL,ISTAT)
      MODE=1
      START(NAXIS)=  ZERO
      STEP(NAXIS)=   ONE
      LENGTH(NAXIS)= 2
C
C   Map input data
C
      CALL TBTOPN (INAME,F_I_MODE,TID,ISTAT)
      CALL TBIGET (TID,NCOL,NROW,ISOR,ICOL,IROW,ISTAT)
      CALL TBLSER (TID,'TIME',ITIME,ISTAT)
      IF (ITIME.LT.0) THEN
        CALL STETER(3,'Column :TIME not found')
      ENDIF
      CALL TBLSER (TID,'VALUE',IVAL,ISTAT)
      IF (IVAL.LT.0) THEN
        CALL STETER(3,'Column :VALUE not found')
      ENDIF
      CALL TBFGET (TID,ITIME,FORM,LFIELD,TTYP,ISTAT)
      CALL TBFGET (TID,IVAL, FORM,LFIELD,VTYP,ISTAT)
      CALL TBDGET (TID,ISTORE,ISTAT)
      IF (ISTORE.NE.F_TRANS) THEN
        TEXT='Input table '//INAME//' stored not transposed'
        CALL STETER(2,TEXT)
      ENDIF
      IF (TTYP.NE.D_R8_FORMAT.OR.VTYP.NE.D_R8_FORMAT) THEN
        CALL STETER(1,'Column(s) must be of DOUBLE PRECISION type')
      ENDIF
      CALL TBCMAP (TID,ITIME,PTIME,ISTAT)
      CALL TBCMAP (TID,IVAL, PVAL, ISTAT)
C
C   Create and map work tables  Z,ZN,CF,P,DZ,DCF
C
      NOBS2=NROW+NROW
      CALL STFCRE('ZZMIDAWORK',D_R8_FORMAT,F_X_MODE,F_IMA_TYPE,
     $   NOBS2,ICZ,  ISTAT)
      CALL STFMAP(ICZ,  F_X_MODE,1,NOBS2,ASIZE,CZ,  ISTAT)
C
      CALL STFCRE('ZZMIDDWORK',D_R8_FORMAT,F_X_MODE,F_IMA_TYPE,
     $   NOBS2,ICZN, ISTAT)
      CALL STFMAP(ICZN, F_X_MODE,1,NOBS2,ASIZE,CZN, ISTAT)
C
      CALL STFCRE('ZZMIDEWORK',D_R8_FORMAT,F_X_MODE,F_IMA_TYPE,
     $   NOBS2,ICCF, ISTAT)
      CALL STFMAP(ICCF, F_X_MODE,1,NOBS2,ASIZE,CCF, ISTAT)
C
      CALL STFCRE('ZZMIDFWORK',D_R8_FORMAT,F_X_MODE,F_IMA_TYPE,
     $   NOBS2,ICP,  ISTAT)
      CALL STFMAP(ICP,  F_X_MODE,1,NOBS2,ASIZE,CP,  ISTAT)
C
C   Map output data
C
      CALL STIPUT (ONAME,D_R8_FORMAT,F_IO_MODE,
     $   F_IMA_TYPE,NAXIS,LENGTH,
     $   START,STEP,ONAME,'AXIS: 1/TIME DATA: UNITLESS',
     $   PPER,IDPER,ISTAT)
C
C   Compute multiharmonic Fourier periodogramme
C
      CALL TIMORT(NROW,MADRID(PTIME),MADRID(PVAL),LENGTH(1),START(1),
     $   STEP(1),ORDER,MODE,MADRID(PPER),OM,MADRID(CZ),MADRID(CZN),
     $   MADRID(CCF),MADRID(CP))
C
C   Wind-up
C
      CALL DSCUPT(IDPER,IDPER,' ',ISTAT)
      CALL STSEPI
C
      END
C
C
C
      subroutine TIMORT(no,t,f,nf,fr0,frs,norder,mode,th,om,
     $    z,zn,cf,p)
c
c   Fast Fit Periodogramme
c
c   Method: A. Schwarzenberg-Czerny, 
c       Ap.J. 460, L107, 1996 April 1
c
c   Input:
c     no - number of observations
c     t(no),f(no) - times and values of observations
c     nf - number of frequencies
c     fr0 - first frequency
c     frs - frequency step
c     n2 - number of fitted harmonics
c     mode - mode of operation
c       1 - AOV periodogramme
c       2 - Chi2 periodogramme
c       3 - values in f(no) replaced by residua, AOV periodogramme
c       4 - harmonics amplitudes and AOV periodogramme
c
c   Output
c     th(nf) - Periodogramme (type depends on 'mode')
c     om - frequency of maximum power
c
C
      IMPLICIT NONE
      INCLUDE  'MID_REL_INCL:TSA_DEF.INC'
C
      INTEGER  norder                   ! NORDER (2*NUMBER OF HARMONICS)
      INTEGER  no                       ! NUMBER OF OBSERVATIONS
      INTEGER  nf                       ! NUMBER OF FREQUENCIES
      INTEGER  mode                     ! MODE OF OPERATION

      integer k,n,n2,nn,l,lmax,mtrig,ksign
C
      INTEGER  MN
      PARAMETER(MN=100)
      DOUBLE PRECISION tol,tiny
      parameter (tol=1d-6,tiny=1d-99)
C 
      DOUBLE PRECISION   T(no),F(no)    ! TIMES AND VALUES OF OBSERVATIONS
      DOUBLE PRECISION   TH(nf,2)       ! PERIODOGRAMME
      DOUBLE PRECISION   FR0,FRS,OM     ! FREQUENCY START AND INCREMENT
      DOUBLE PRECISION   pi2,sav,df1,df2,df3,avf,vrf,t0,thmax,sn,ph
C 
      COMPLEX*16 Z(no),ZN(no),CF(no),P(no) ! WORK TABLES
      complex*16 a,c,al,sc,pc,amx,cmx,zz
      dimension a(0:mn),c(0:mn),amx(0:mn),cmx(0:mn)
C
      CHARACTER*80 TEXT
C 
      logical test
c
      REAL   PROB
      REAL riembi
      EXTERNAL RIEMBI
C 
C
      INCLUDE 'MID_REL_INCL:TSA_CONST.INC'
C
      CALL STTPUT('Mapped arrays',ISTAT)
      nn=min(max(NORDER/2*2,2),MN)
      n2=nn/2
      write(text,'(a24,i5,i5)') 'TIMORT: No_harm, order: ',n2,nn
      CALL STTPUT(TEXT,ISTAT)

      pi2=two*atan2(zero,-one)
      df3=no-1
      df1=nn
      df2=no-nn-1

C mean and variance
      avf=zero
      do k=1,no
        avf=avf+f(k)
      enddo
      avf=avf/no
      t0=(t(1)+t(no))*half
      vrf=zero
      do k=1,no
        sav=f(k)-avf
        vrf=vrf+sav*sav
      enddo

      thmax=zero
      do l=1,nf 
        om=(fr0+(l-1)*frs)
        do k=1,no
          ph=om*(t(k)-t0)
          ph=pi2*(ph-nint(ph))
          z(k)=cmplx(cos(ph),sin(ph))
          ph=n2*ph
          cf(k)=(f(k)-avf)*cmplx(cos(ph),sin(ph))
          zn(k)=one
          p(k)=one
        enddo

        th(l,1)=zero
        do n=0,nn
          sn=zero
          al=zero
          sc=zero
          do k=1,no
            pc=conjg(p(k))
            sn=p(k)*pc+sn
            al=p(k)*z(k)+al
            sc=cf(k)*pc+sc
          enddo
          sn=max(sn,10.*tiny)
          al=al/sn
          a(n)=al
          c(n)=sc/sn
          th(l,1)=abs(sc)**2/sn+th(l,1)
          do k=1,no
            p(k)=p(k)*z(k)-al*zn(k)*conjg(p(k))
            zn(k)=zn(k)*z(k)
          enddo
        enddo

        if (abs(al).le.tiny) then
          write(text,9099) om/pi2
9099  FORMAT('TIMORT: Singular at frequency',G15.7)
          CALL STTPUT(TEXT,ISTAT)
        endif
        if (th(l,1).ge.thmax) then
          thmax=th(l,1)
          lmax=l
          do n=0,nn
            amx(n)=a(n)
            cmx(n)=c(n)
          enddo
        endif
        if (mode.eq.2) then
          th(l,1)=th(l,1)*df3/(df1*vrf)
        else
          sav=max((vrf-th(l,1))/df2,tiny)
          th(l,1)=th(l,1)/(df1*sav)
          th(l,2)=sav
        endif
      enddo
      
      if (mode.eq.2) then
        prob=exp(-th(lmax,l))
      else 
        prob=riembi(REAL(half*df2),REAL(half*df1),
     $          REAL(df2/(df2+df1*th(lmax,1))))
      endif
      om=pi2*(fr0+(lmax-1)*frs)
 
      if (mode.eq.3) then
        ksign=0
C sn->vrf, al->z,zz->zn,pc->p,sc
        sn=zero
        do k=1,no
          ph=om*t(k)
          al=cmplx(cos(ph),sin(ph))
          zz=one
          pc=one
          sc=zero
          do n=0,nn
            sc=cmx(n)*pc+sc
            pc=pc*al-amx(n)*zz*conjg(pc)
            zz=zz*al
          enddo
          ph=-n2*ph
          sav=f(k)-sc*cmplx(cos(ph),sin(ph))
          sn=sn+sav*sav
        enddo
        vrf=abs(vrf-sn-thmax)/vrf
        if (vrf.gt.tol) then
          write(text,9098) vrf
9098  FORMAT('TIMORT: Rounding error',G15.7)
          CALL STTPUT(TEXT,ISTAT)
        endif
      endif

      if (mode.eq.4) then
       
        CALL STTPUT('TIMORT: Power step expansion unimplemented yet '
     $     ,ISTAT)
      endif

      write(text,'(a,1pe15.6,2e12.3,0p)') 
     $   'TIMORT:max: f, th, prob=',om/pi2,th(lmax,1),prob
        CALL STTPUT(TEXT,ISTAT)

      end 

C @(#)mask.for	19.1 (ESO-DMD) 02/25/03 14:23:06
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM BADPIX
C++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1992 European Southern Observatory,
C                                         all rights reserved
C.IDENTIFICATION: mask.for
C.PURPOSE:   Replace bad pixels by nearest good pixel according to pixel mask
C.LANGUAGE:  F77+ESOext
C.KEYWORDS:  IRAC2, infrared
C.AUTHOR:    Gert Finger, ESO-VLT
C.VERSION: 
C 
C 010710	last modif
C 
C---------------------------------------------------------------------
C 
      IMPLICIT NONE
C 
      INTEGER      NAXISA,NPIXA(2),IAV,STAT
      INTEGER      IMNOA,IMNOC,IMNOG
      INTEGER      KNULL,KUNIT(1)
      INTEGER      MADRID(1)
      INTEGER      FNO,IBUF(5)
C 
      INTEGER*8    PNTRA,PNTRC,PNTRG
C 
      CHARACTER*60 FRAMEA,FRAMEC,FRAMEG
      CHARACTER    CUNITA*64,IDENTA*72
C 
      DOUBLE PRECISION STEPA(2),STARTA(2)
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'   
      COMMON /VMR/ MADRID
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'   
C 
C 
C 
      CALL STSPRO('BADPIX')
C
C  GET NAME OF INPUT FRAME AND MAP IT 
C
      CALL STKRDC('IN_A',1,1,60,IAV,FRAMEA,KUNIT,KNULL,STAT)
C
C  TEST DATA FORMAT (NUMBER OF BYTES PER PIXEL = IBUF(1)
C
      FNO=2 
      CALL STFINF(FRAMEA,FNO,IBUF,STAT)
C     WRITE (6,*) (IBUF(I),I=1,5)
C
C  DOUBLE PRECISSION
C
      IF (IBUF(1).EQ.8) THEN 
      CALL STIGET(FRAMEA,D_R8_FORMAT,F_I_MODE,F_IMA_TYPE,
     +            2,NAXISA,NPIXA,STARTA,STEPA,IDENTA,
     +            CUNITA,PNTRA,IMNOA,STAT)
      GOTO 1000
      ENDIF 
C
C  SINGLE PRECISSION
C
      IF (IBUF(1).EQ.4) THEN 
      CALL STIGET(FRAMEA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +            2,NAXISA,NPIXA,STARTA,STEPA,IDENTA,
     +            CUNITA,PNTRA,IMNOA,STAT)
      GOTO 1000
      ENDIF 
C
1000  CONTINUE
      IF (NAXISA.NE.2)
     +CALL STETER(1,'INPUT FRAME MUST HAVE TWO DIMENSIONS')
C
C  GET NAME OF OUTPUT FRAME CREATE AND MAP IT
C
      CALL STKRDC('OUT_A',1,1,60,IAV,FRAMEC,KUNIT,KNULL,STAT) 
      CALL STIPUT(FRAMEC,D_R8_FORMAT,F_O_MODE,F_IMA_TYPE,
     +            NAXISA,NPIXA,STARTA,STEPA,IDENTA,
     +            CUNITA,PNTRC,IMNOC,STAT)
C
C  GET IMAGE GOODPX AND MAP IT ( IMAGE OF GOOD PIXELS )
C
      FRAMEG='GOODPX'
      CALL STIGET(FRAMEG,D_R8_FORMAT,F_I_MODE,F_IMA_TYPE,
     +            2,NAXISA,NPIXA,STARTA,STEPA,IDENTA,
     +            CUNITA,PNTRG,IMNOG,STAT)
C
C  CALL SUBROUTINE TO DO THE REPLACEMENT OF BAD PIXELS
C
C
C  DOUBLE PRECISSION
C
      IF (IBUF(1).EQ.8) THEN 
      CALL RPLBP(MADRID(PNTRA),MADRID(PNTRC),MADRID(PNTRG),
     +                NPIXA(1),NPIXA(2))
      ENDIF
C
C  SINGLE PRECISSION
C
      IF (IBUF(1).EQ.4) THEN 
      CALL RPLBPS(MADRID(PNTRA),MADRID(PNTRC),MADRID(PNTRG),
     +                NPIXA(1),NPIXA(2))
      ENDIF
C
C  COPY ALL DESCRIPTORS FROM INPUT FRAME TO OUTPUT FRAME
C
      CALL STDCOP(IMNOA,IMNOC,3,' ',STAT) 
      CALL STSEPI
      END

C
C-----------------------------------------------------------------------------
C
      SUBROUTINE RPLBP(A,B,G,NX,NY)
C
C  SUBROUTINE TO REPLACE BAD PIXELS BY NEAREST GOOD PIXEL
C
      IMPLICIT NONE
      INTEGER NX,NY
      INTEGER NL,NC,I
      INTEGER ZNEX(11,11),SNEX(11,11)
      INTEGER M,Z,S
      DOUBLE PRECISION A(1),B(1),G(1) 
      DOUBLE PRECISION AA(256,256),BB(256,256)
      INTEGER GOODPX(256,256)
      INTEGER ZZ,SS,ZTRY,STRY
C     REAL THRMIN,THRMAX
C
C  READ INDEX OF NEXT NEIGHBOURS
C
      M=11 
C     CALL RDNXTN(M,ZNEX,SNEX)
      CALL NXTZS(M,ZNEX,SNEX)
C     DO Z=1,M
C     WRITE (6,*) (ZNEX(Z,S),SNEX(Z,S),S=1,M)
C     END DO
C
C  REWRITE 1D IMAGE A INTO 2D IMAGE AA
C
      I=0
      DO NL=1,NX
         DO NC=1,NY
            I=I+1
            AA(NL,NC)=A(I)
            GOODPX(NL,NC)=INT(G(I))
         END DO 
      END DO  
C
C  DO ALL THE PROCESSING OF DATA HERE
C
C**********************************************************************
C
C  SUBSTITUTE BADPIXEL BY NEXT GOOD PIXEL
C
      DO Z=1,NX
         DO S=1,NY
            IF (GOODPX(Z,S).EQ.0) THEN
              DO ZZ=1,M
                DO SS=1,M
                  ZTRY=Z+ZNEX(ZZ,SS)
                  STRY=S+SNEX(ZZ,SS)
                  IF (ZTRY.LT.1) ZTRY=1
                  IF (ZTRY.GT.NX) ZTRY=NX
                  IF (STRY.LT.1) STRY=1
                  IF (STRY.GT.NY) STRY=NY
                  IF (GOODPX(ZTRY,STRY).EQ.1) GOTO 1
                END DO
              END DO
1             CONTINUE
              BB(Z,S)=AA(ZTRY,STRY)
            ELSE
              BB(Z,S)=AA(Z,S)
            ENDIF
         END DO 
      END DO   
C**********************************************************************
C
C  REWRITE 2D IMAGE BB INTO 1D IMAGE B
C
      I=0
      DO NL=1,NX
         DO NC=1,NY
            I=I+1
            B(I)=BB(NL,NC)
        END DO 
      END DO  
      RETURN
      END
C
C-----------------------------------------------------------------------------
C
      SUBROUTINE RPLBPS(A,B,G,NX,NY)
C
C  SUBROUTINE TO CONVERT REAL A DOUBLE PRECISSION AD
C
      IMPLICIT NONE
      INTEGER NX,NY
      INTEGER NTOT,I
      DOUBLE PRECISION G(1),B(1) 
      REAL A(1) 
      DOUBLE PRECISION AD(65536)
      NTOT=NX*NY 
      DO I=1,NTOT
            AD(I)=A(I)
      END DO  
      CALL RPLBP(AD,B,G,NX,NY)
      RETURN
      END
C
C-----------------------------------------------------------------------------
C
      SUBROUTINE RDNXTN(M,ZNEX,SNEX)
C
C  READ INDEX OF NEIGHBOURING PIXELS ORDERD ACCORDING TO 
C  INCREASING DISTANCE FROM FILE NEXTN
C  GFI 17.6.92
C 
      IMPLICIT NONE
      INTEGER Z,M
      INTEGER ZNEX(M,M),SNEX(M,M)
      OPEN (UNIT=3,FILE='NEXTN',STATUS='UNKNOWN')
C
C     DO Z=1,M
C     READ (3,*) (ZNEX(Z,S),SNEX(Z,S),S=1,M)
C     WRITE (6,*) (ZNEX(Z,S),SNEX(Z,S),S=1,M)
C     END DO
C
      CALL NXTZS(M,ZNEX,SNEX)
C
      DO Z=1,M
C     READ (3,*) (ZNEX(Z,S),SNEX(Z,S),S=1,M)
C     WRITE (6,*) (ZNEX(Z,S),SNEX(Z,S),S=1,M)
      END DO
      RETURN 
      END
C
C-----------------------------------------------------------------------------
C
      SUBROUTINE NXTZS(M,ZNEX,SNEX)
C
C  CREATES INDEX ZNEX,SNEX OF NEIGHBOURING PIXELS ORDERD ACCORDING TO 
C  INCREASING DISTANCE USING HEAPSORT ALGORITHM
C  GFI 18.6.92
C 
      IMPLICIT NONE
      INTEGER  Z,S,M,C,I,NTOT
      INTEGER  ZNEX(M,M),SNEX(M,M)
      REAL     DIST(11,11),DIST1(121)
      INTEGER  ZNEX1(121),SNEX1(121),ORDER(121)
      NTOT=M*M
      DO Z=1,M 
C     WRITE (6,*) (ZNEX(Z,S),SNEX(Z,S),S=1,M)
      END DO
C
C  DETERMINE DISTANCE FROM CENTER PIXEL
C
      C=INT(M/2.0)+1
      DO Z=1,M
        DO S=1,M
          ZNEX(Z,S)=Z-C
          SNEX(Z,S)=S-C
          DIST(Z,S)=SQRT(1.0*ZNEX(Z,S)*ZNEX(Z,S)+
     2                   1.0*SNEX(Z,S)*SNEX(Z,S))
C         WRITE (6,*) ZNEX(Z,S),SNEX(Z,S),DIST(Z,S)        
        END DO
      END DO     
C
C  REWRITE ZNEX,SNEX,DIST TO 1D ARRAYS
C
      I=0
      DO Z=1,M
        DO S=1,M
          I=I+1
          ZNEX1(I)=ZNEX(Z,S)
          SNEX1(I)=SNEX(Z,S)
          DIST1(I)=DIST(Z,S)
          ORDER(I)=I
        END DO
      END DO
C
C  GENERATE INDEX VECTOR ORDER FOR SORTING ZNEX,SNEX ACCORDING TO
C  ASCENDING DISTANCE 
C 
      CALL INDEXX(NTOT,DIST1,ORDER)      
C
C  REWRITE AND ORDER ZNEX,SNEX,DIST TO 2D ARRAYS ACCORDING TO 
C  INCREASING DISTANCE
C
      I=0
      DO Z=1,M
        DO S=1,M
          I=I+1
          ZNEX(Z,S)=ZNEX1(ORDER(I))
          SNEX(Z,S)=SNEX1(ORDER(I))
          DIST(Z,S)=DIST1(ORDER(I))
C         WRITE (6,*) ZNEX(Z,S),SNEX(Z,S),DIST(Z,S)        
        END DO
      END DO
      RETURN 
      END
C
C-----------------------------------------------------------------------------
C
      SUBROUTINE INDEXX(N,ARRIN,INDX)
C
C  CREATES INDEX VECTOR INDX ACCORDING TO INCREASING ARRIN 
C  USING HEAPSORT ALGORITHM ( NUMERICAL RECIPES H. PRESS p 233)
C  GFI 18.6.92
C
      IMPLICIT NONE
      INTEGER  N
      REAL     ARRIN(N),Q
      INTEGER  INDX(N)
      INTEGER  I,J,L,IR,INDXT
C
      DO J=1,N
        INDX(J)=J
      END DO
      L=N/2+1
      IR=N
10    CONTINUE
        IF (L.GT.1) THEN
          L=L-1
          INDXT=INDX(L)
          Q=ARRIN(INDXT)
        ELSE
          INDXT=INDX(IR)
          Q=ARRIN(INDXT)
          INDX(IR)=INDX(1)
          IR=IR-1
          IF (IR.EQ.1) THEN
            INDX(1)=INDXT
            RETURN
          ENDIF
        ENDIF
        I=L
        J=L+L
20      IF (J.LE.IR) THEN
          IF (J.LT.IR) THEN
            IF (ARRIN(INDX(J)).LT.ARRIN(INDX(J+1))) J=J+1
          ENDIF
          IF (Q.LT.ARRIN(INDX(J))) THEN
            INDX(I)=INDX(J)
            I=J
            J=J+J
          ELSE
            J=IR+1
          END IF
        GOTO 20
        ENDIF
        INDX(I)=INDXT
      GOTO 10     
      END

C @(#)lognorm.for	19.1 (ES0-DMD) 02/25/03 13:17:40
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE LOGNRM(IND,X,NP,PARAM,Y,DERIV)                                
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                  
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  18:01 - 21 DEC 1987                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C--------------------------------------------------------------                 
C                                                                               
C   Logarithmic normal distribution                                             
C      IMPLICIT NONE                                                            
C                                                                               
C   Y = P1*EXP(-0.5*((LN(X-P4)-P2)/P3)**2)/((X-P4)*P3*SQRT(2*PI))               
C                                                                               
      INTEGER NP,IND,I
      DOUBLE PRECISION Y,PARAM(NP),DERIV(NP)                                    
      REAL X(IND)                                                          
      DOUBLE PRECISION A,B,C,D,E                                                
C                                                                               
      Y      = 0.0D0                                                            
      DO 10 I = 1,4                                                             
          DERIV(I) = 0.0D0                                                      
   10 CONTINUE                                                                  
      A      = X(1) - PARAM(4)                                                  
      IF (A.LE.0.0D0) RETURN                                                    
C                                                                               
      B      = DLOG(A) - PARAM(2)                                               
      C      = 1.0D0/PARAM(3)                                                   
      D      = B*C*C                                                            
      E      = B*D                                                              
      DERIV(1) = 3.989422803D-1*C*DEXP(-0.5D0*E)/A                              
      Y      = PARAM(1)*DERIV(1)                                                
      DERIV(2) = Y*D                                                            
      DERIV(3) = Y*C* (E-1.0D0)                                                 
      DERIV(4) = Y* (D+1.0D0)/A                                                 
      RETURN                                                                    
                                                                                
      END                                                                       

C @(#)iil.for	19.1 (ES0-DMD) 02/25/03 13:55:01
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE IILWLT(DSPLAY,NLUT,ISTA,COUNT,RLUT,IDST)
C
      IMPLICIT NONE
C      
      INTEGER      DSPLAY,NLUT,ISTA,COUNT,IDST
C      
      REAL         RLUT(3,COUNT)
C      
      INCLUDE      'MID_INCLUDE:IDIDEV.INC'
C      
      IF (IDINUM.EQ.0) THEN
         CALL GD8025(DSPLAY,NLUT,ISTA,COUNT,RLUT,IDST)
      ELSE IF (IDINUM.EQ.10) THEN
         CALL MXW025(DSPLAY,NLUT,ISTA,COUNT,RLUT,IDST)
      ELSE
         IDST = 0
      ENDIF
C 
      RETURN
      END      
C      
C      
C --------------------------------------------------------------------
C
C 
      SUBROUTINE IILRLT(DSPLAY,NLUT,ISTA,COUNT,RLUT,IDST)
C      
      IMPLICIT NONE
C      
      INTEGER      DSPLAY,NLUT,ISTA,COUNT,IDST
C      
      REAL            RLUT(3,COUNT)
C
      INCLUDE      'MID_INCLUDE:IDIDEV.INC'
C      
      IF (IDINUM.EQ.0) THEN
         CALL GD8026(DSPLAY,NLUT,ISTA,COUNT,RLUT,IDST)
      ELSE IF (IDINUM.EQ.10) THEN
         CALL MXW026(DSPLAY,NLUT,ISTA,COUNT,RLUT,IDST)
      ELSE
         IDST = 0
      ENDIF
C 
      RETURN
      END      

      SUBROUTINE IILWIT(DSPLAY,CHAN,NITT,ISTA,COUNT,RITT,IDST)
C 
      IMPLICIT NONE
C      
      INTEGER      DSPLAY,CHAN,NITT,ISTA,COUNT,IDST
C      
      REAL            RITT(1)
C      
      INCLUDE      'MID_INCLUDE:IDIDEV.INC'
C 
      IF (IDINUM.EQ.0) THEN
         CALL GD8023(DSPLAY,CHAN,NITT,ISTA,COUNT,RITT,IDST)
      ELSE IF (IDINUM.EQ.10) THEN
         CALL MXW023(DSPLAY,CHAN,NITT,ISTA,COUNT,RITT,IDST)
      ELSE
         IDST = 0
      ENDIF
C 
      RETURN
      END      
C      
C      
C --------------------------------------------------------------------
C
C 
      SUBROUTINE IILRIT(DSPLAY,CHAN,NITT,ISTA,COUNT,RITT,IDST)
C
      IMPLICIT NONE
C      
      INTEGER      DSPLAY,CHAN,NITT,ISTA,COUNT,IDST
C      
      REAL            RITT(1)
C      
      INCLUDE      'MID_INCLUDE:IDIDEV.INC'
C 
      IF (IDINUM.EQ.0) THEN
         CALL GD8024(DSPLAY,CHAN,NITT,ISTA,COUNT,RITT,IDST)
      ELSE IF (IDINUM.EQ.10) THEN
         CALL MXW024(DSPLAY,CHAN,NITT,ISTA,COUNT,RITT,IDST)
      ELSE
         IDST = 0
      ENDIF
C 
      RETURN
      END      

      SUBROUTINE IILSBV(DSPLAY,CHAN,VISI,IDST)
C 
      IMPLICIT NONE
C      
      INTEGER      DSPLAY,CHAN,VISI,IDST
C      
      INCLUDE      'MID_INCLUDE:IDIDEV.INC'
C      
      IF (IDINUM.EQ.0) THEN
         CALL GD8049(DSPLAY,CHAN,VISI,IDST)
      ELSE IF (IDINUM.EQ.10) THEN
         CALL MXW049(DSPLAY,CHAN,VISI,IDST)
      ELSE
         IDST = 0
      ENDIF
C 
      RETURN
      END      

C @(#)lsqmon.for	19.1 (ES0-DMD) 02/25/03 13:17:41 
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE LSQMON(NRPNT,NRPRM,PRM,FCTVEC,FCTJAC,LJAC,SV,DIMGRA,           
     +                  ITER,NFEVAL,IW,LIW,W,LW)                                
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++        
C                                                                               
C.MODULE                                                                        
C       FIT                                                                     
C                                                                               
C.NAME                                                                          
C       LSQMON                                                                  
C                                                                               
C.PURPOSE                                                                       
C       Monitoring the least squares algorithms.                                
C                                                                               
C.KEYWORDS                                                                      
C       Monitoring.                                                             
C                                                                               
C.DESCRIPTION                                                                   
C       trivial                                                                 
C                                                                               
C.LANGUAGE                                                                      
C       FORTRAN                                                                 
C                                                                               
C.CALLING SEQUENCE                                                              
C       CALL LSQMON(NRRES,NRPRM,PRM,FCTVEC,FCTJAC,LJAC,SV,DIMGRA,               
C     +                 ITER,NFEVAL,IW,LIW,W,LW)                                
C                                                                               
C.INPUT PARAMETERS                                                              
C       NRRES               INTEGER  Number of residuals                        
C       NRPRM               INTEGER  Number of parameters                       
C       PRM (NRPRM)         DOUBLE   Parameters                                 
C       LJAC                INTEGER  1st dimension of jacobian                  
C       FCTVEC (NRRES)      DOUBLE   Approximating values                       
C       FCTJAC (LJAC,NRRES) DOUBLE   values of the jacobian                     
C       SV (NRPRM)          DOUBLE   singular values                            
C       DIMGRA              INTEGER  Dimension of gradient space                
C       ITER                INTEGER  Iteration number                           
C       NFEVAL              INTEGER  Present number of fct eval.                
C       IW (LIW)            INTEGER  unused                                     
C       LIW                 INTEGER                                             
C       W (LW)              DOUBLE                                              
C       LW                  INTEGER                                             
C                                                                               
C.MODIFIED PARAMETERS                                                           
C       none                                                                    
C                                                                               
C.OUTPUT PARAMETERS                                                             
C       none                                                                    
C                                                                               
C.FILES                                                                         
C       none                                                                    
C                                                                               
C.MODULES CALLED                                                                
C       STTPUT                                                                  
C                                                                               
C.AUTHOR                                                                        
C       Ph. DEFERT,      Feb 1986                                               
C                                                                               
C.MODIFICATIONS                                                                 
C       M.  Peron        Nov 1990  replace F01DEF by F06EAF                                                                        
C                                                                               
C-----------------------------------------------------------------------        
C      IMPLICIT NONE                                                            
C     ..                                                                        
C     .. Scalar Arguments ..                                                    
      INTEGER DIMGRA,LIW,LJAC,LW,NFEVAL,ITER,NRPRM,NRPNT                        
      INTEGER MADRID(1)
C     ..                                                                        
C     .. Array Arguments ..                                                     
      DOUBLE PRECISION FCTJAC(LJAC,NRPRM),FCTVEC(NRPNT),IW(LIW),                
     +                 PRM(NRPRM),SV(NRPRM),W(LW)                               
C     ..                                                                        
C     .. Local Scalars ..                                                       
      DOUBLE PRECISION FSUMSQ,GRDNRM,REDCHI,RCHOLD,CHIPERC                      
      INTEGER I,STATUS                                                          
C     ..                                                                        
C     .. Local Arrays ..                                                        
      DOUBLE PRECISION GRD(100)                                                 
      CHARACTER LINE*78                                                         
C
      DOUBLE PRECISION F06EAF                                                   
C     ..                                                                        
C     .. External Files ..                                                      
       INCLUDE 'MID_INCLUDE:FITNAGI.INC/NOLIST'                                 
      COMMON /VMR/MADRID                                                     
       INCLUDE 'MID_INCLUDE:FITNAGC.INC/NOLIST'                                 

      SAVE REDCHI
      DATA REDCHI/0.0/ 
C     ..                                                                        
C     .. Executable Statements ..                                               
      RCHOLD = REDCHI                                                           
      FSUMSQ = F06EAF(NRPNT,FCTVEC,1,FCTVEC,1)                                      
      REDCHI = DMAX1(FSUMSQ/DBLE(NRPNT-NRPRM+NRPFIX),0.D0)                    
      IF (ITER.GT.1 .AND. RCHOLD.GT.1.D-15) THEN                                
          CHIPERC = 100.* (RCHOLD-REDCHI)/RCHOLD                                
                                                                                
      ELSE                                                                      
          CHIPERC = 0.                                                          
      END IF                                                                    
                                                                                
      CALL LSQGRD(NRPNT,NRPRM,FCTVEC,FCTJAC,LJAC,GRD)                           
      GRDNRM = DSQRT(F06EAF(NRPRM,GRD,1,GRD,1))                                     
      CALL STTPUT(' ',STATUS)                                                   
      CALL STTPUT(                                                              
     +           ' Iter  F. Eval.  Sum of Squares  Red. Chisq.  % Decr.'        
     +            //'  Grad. Norm.  Grad. Dim.',STATUS)                         
      WRITE (LINE,9000) ITER,NFEVAL,FSUMSQ,REDCHI,CHIPERC,GRDNRM,DIMGRA         
                                                                                
      CALL STTPUT(LINE,STATUS)                                                  
      CALL STTPUT(' ',STATUS)                                                   
      CALL STTPUT('        Parameters       Gradient    '//                     
     +            'Singular Values',STATUS)                                     
      DO 10 I = 1,NRPRM                                                         
          WRITE (LINE,9010) PRM(I),GRD(I),SV(I)                                 
                                                                                
          CALL STTPUT(LINE,STATUS)                                              
   10 CONTINUE                                                                  
      CALL STTPUT(' ',STATUS)                                                   
      RETURN                                                                    
                                                                                
 9000 FORMAT (I5,2X,I5,3X,1PE12.4,4X,1PE12.4,2X,0PF6.2,3X,1PE9.1,7X,I3)         
 9010 FORMAT (2X,1PD15.7,6X,1PD9.1,6X,1PD9.1)                                   
      END                                                                       

C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
       SUBROUTINE E04FDF(M,N,X,FSUMSQ,IW,LIW,W,LW,IFAIL)
       INTEGER  M,N,LIW,IW(LIW),LW,IFAIL,ISTAT
       DOUBLE PRECISION X(N),FSUMSQ,W(LW)

C      dummy routine
       CALL STTPUT('Sorry but NAG is not implemented...',ISTAT)
       CALL STTPUT('Try to use the NR method.',ISTAT)
       CALL STSEPI
       END


       SUBROUTINE E04FCF(M,N,LSQFUN,LSQMON,IPRINT,
     1           MAXCAL,ETA,XTOL,STEPMX,X,FSUMSQ,FVEC,
     2           FJAC,LJ,S,V,LV,NITER,NF,IW,LIW,W,
     3           LW,IFAIL)
       INTEGER M,N,IPRINT,MAXCAL,LJ,LV,NITER,NF,
     1        LIW,IW(LIW),LW,IFAIL,ISTAT
       DOUBLE PRECISION  ETA,XTOL,STEPMX,X(N),FSUMSQ,FVEC(M),
     2        FJAC(LJ,N),S(N),V(1,1),W(LW)
       EXTERNAL  LSQFUN,LSQMON
       CALL STTPUT('Sorry but NAG is not implemented...',ISTAT)
       CALL STTPUT('Try to use the NR method.',ISTAT)
       CALL STSEPI
C      dummy routine
       END


       SUBROUTINE E04GCF(M,N,X,FSUMSQ,IW,LIW,W,LW,IFAIL)
       INTEGER  M,N,LIW,IW(LIW),LW,IFAIL,ISTAT
       DOUBLE PRECISION X(N),FSUMSQ,W(LW)

       CALL STTPUT('Sorry but NAG is not implemented...',ISTAT)
       CALL STTPUT('Try to use the NR method.',ISTAT)
C      dummy routine
       CALL STSEPI
       END     

       SUBROUTINE E04GEF(M,N,X,FSUMSQ,IW,LIW,W,LW,IFAIL)
       INTEGER  M,N,LIW,IW(LIW),LW,IFAIL,ISTAT
       DOUBLE PRECISION X(N),FSUMSQ,W(LW)

C      dummy routine
       CALL STTPUT('Sorry but NAG is not implemented...',ISTAT)
       CALL STTPUT('Try to use the NR method.',ISTAT)
       CALL STSEPI
       END     


       SUBROUTINE E04GBF(M,N,LSQLIN,LSQFUN,LSQMON,IPRINT,
     1           MAXCAL,ETA,XTOL,STEPMX,X,FSUMSQ,FVEC,
     2           FJAC,LJ,S,V,LV,NITER,NF,IW,LIW,W,
     3           LW,IFAIL)
       INTEGER M,N,IPRINT,MAXCAL,LJ,LV,NITER,NF,
     1        LIW,IW(LIW),LW,IFAIL,ISTAT
       DOUBLE PRECISION  ETA,XTOL,STEPMX,X(N),FSUMSQ,FVEC(M),
     2        FJAC(LJ,N),S(N),V(1,1),W(LW)
       EXTERNAL  LSQFUN,LSQMON,LSQLIN

       CALL STTPUT('Sorry but NAG is not implemented...',ISTAT)
       CALL STTPUT('Try to use the NR method.',ISTAT)
C      dummy routine
       CALL STSEPI
       END

       SUBROUTINE E04GDF(M,N,LSQFUN,LSQMON,IPRINT,
     1           MAXCAL,ETA,XTOL,STEPMX,X,FSUMSQ,FVEC,
     2           FJAC,LJ,S,V,LV,NITER,NF,IW,LIW,W,
     3           LW,IFAIL)
       INTEGER M,N,IPRINT,MAXCAL,LJ,LV,NITER,NF,
     1        LIW,IW(LIW),LW,IFAIL,ISTAT
       DOUBLE PRECISION  ETA,XTOL,STEPMX,X(N),FSUMSQ,FVEC(M),
     2        FJAC(LJ,N),S(N),V(1,1),W(LW)
       EXTERNAL  LSQFUN,LSQMON

       CALL STTPUT('Sorry but NAG is not implemented...',ISTAT)
       CALL STTPUT('Try to use the NR method.',ISTAT)
C      dummy routine
       CALL STSEPI
       END



       SUBROUTINE E04YCF(JOB,M,N,FSUMSQ,S,V,LV,CJ,WORK,IFAIL)
       INTEGER JOB,M,N,IFAIL,LV
       DOUBLE PRECISION FSUMSQ,S(N),V(LV,N),CJ(N),WORK(N)

C      dummy routine
       RETURN
       END



       SUBROUTINE E04JAF(N,IBOUND,BL,BU,X,F,IW,LIW,W,LW,IFAIL)
       INTEGER N,IBOUND,IFAIL,LW,LIW,IW
       DOUBLE PRECISION BL(N),BU(N),X(N),F,W(N)

C      dummy routine
       RETURN
       END


       SUBROUTINE E04HBF(N,FUNCT,X,NF,DELTA,HESL,LH,HESD,F,G,IW,LIW,
     1                  W,LW,IFAIL)
       INTEGER N,NF,LH,LIW,IW(LIW),LW,IFAIL
       DOUBLE PRECISION X(N),DELTA(N),HESL(LH),HESD(N),F,G(N),W(LW)
       EXTERNAL FUNCT
 
C      dummy routine
       RETURN
       END





       SUBROUTINE E04JBF(N,FUNCT,MONIT,IPRINT,LOCSCH,INTYPE,
     1           MINLIN,MAXCAL,ETA,XTOL,STEPMX,FEST,DELTA,
     2           IBOUND,BL,BU,X,HESL,LH,HESD,ISTATE,F,G,
     3           IW,LIW,W,LW,IFAIL)
      
       INTEGER N,IPRINT,MAXCAL,IBOUND,LH,ISTATE(N),
     1        LIW,IW(LIW),LW,IFAIL,INTYPE
       DOUBLE PRECISION ETA,XTOL,STEPMX,FEST,DELTA(N),BL(N),BU(N),
     2         X(N),HESL(LH),HESD(N),F,G(N),W(LW)
       LOGICAL LOCSCH
       EXTERNAL FUNCT,MONIT,MINLIN
C      dummy routine
       RETURN
       END



       SUBROUTINE E04KAF(N,IBOUND,BL,BU,X,F,G,IW,LIW,W,LW,IFAIL)
       INTEGER N,IBOUND,LIW,IW(LIW),LW,IFAIL
       DOUBLE PRECISION BL(N),BU(N),X(N),F,G(N),W(LW)
C      dummy routine
       RETURN
       END
       


       SUBROUTINE E04HCF(N,FUNCT,X,F,G,IW,LIW,W,LW,IFAIL)
       INTEGER N,LIW,LW,IFAIL,IW(LIW)
       DOUBLE PRECISION X(N),G(N),W(LW),F
       EXTERNAL FUNCT

C      dummy routine
       RETURN
       END

       SUBROUTINE E04KBF(N,FUNCT,MONIT,IPRINT,LOCSCH,INTYPE,
     1           MINLIN,MAXCAL,ETA,XTOL,STEPMX,FEST,
     2           IBOUND,BL,BU,X,HESL,LH,HESD,ISTATE,F,G,
     3           IW,LIW,W,LW,IFAIL)
      
       INTEGER N,IPRINT,MAXCAL,IBOUND,LH,ISTATE(N),
     1        LIW,IW(LIW),LW,IFAIL,INTYPE
       DOUBLE PRECISION ETA,XTOL,STEPMX,FEST,BL(N),BU(N),
     2         X(N),HESL(LH),HESD(N),F,G(N),W(LW)
       LOGICAL LOCSCH
       EXTERNAL FUNCT,MONIT,MINLIN

C     dummy routine
       RETURN
       END



       SUBROUTINE E04KCF(N,IBOUND,BL,BU,X,F,G,IW,LIW,W,LW,IFAIL)
       INTEGER N,IBOUND,LIW,IW(LIW),LW,IFAIL
       DOUBLE PRECISION BL(N),BU(N),X(N),F,G(N),W(LW)
C      dummy routine
       RETURN
       END





       SUBROUTINE E04KDF(N,FUNCT,MONIT,IPRINT,
     1           MAXCAL,ETA,XTOL,DELTA,STEPMX,
     2           IBOUND,BL,BU,X,HESL,LH,HESD,ISTATE,F,G,
     3           IW,LIW,W,LW,IFAIL)
      
       INTEGER N,IPRINT,MAXCAL,IBOUND,LH,ISTATE(N),
     1        LIW,IW(LIW),LW,IFAIL
       DOUBLE PRECISION ETA,XTOL,STEPMX,DELTA,BL(N),BU(N),
     2         X(N),HESL(LH),HESD(N),F,G(N),W(LW)
       EXTERNAL FUNCT,MONIT

C     dummy routine
       RETURN
       END


       DOUBLE PRECISION FUNCTION F01DEF(A,B,N)
       INTEGER N
       DOUBLE PRECISION A(N),B(N)
C     dummy routine
       F01DEF = 0
       RETURN
       END

       DOUBLE PRECISION FUNCTION F06EAF(N,X,
     1                            NINX,Y,NINY)
       INTEGER N,NINX,NINY
       DOUBLE PRECISION X(N),Y(N)
       F06EAF = 0
       RETURN
       END


       SUBROUTINE E01AAF(A,B,C,N1,N2,N,X)
       INTEGER N1,N2,N,ISTAT
       DOUBLE PRECISION A(N1),B(N1),C(N2),X
       CALL STTPUT('Sorry, NAG is not implemented',ISTAT)
       CALL STSEPI 
       RETURN
       END

       SUBROUTINE E01BAF(M,X,Y,K,C,LCK,WRK,LWRK,IFAIL)
       INTEGER           IFAIL, LCK, LWRK, M, ISTAT
       DOUBLE PRECISION  C(LCK), K(LCK), WRK(LWRK), X(M), Y(M)
       CALL STTPUT('Sorry, NAG is not implemented',ISTAT)
       CALL STSEPI 
       RETURN
       END

       SUBROUTINE E02BCF(NCAP7,K,C,X,LEFT,S,IFAIL)
       DOUBLE PRECISION  X
       INTEGER           IFAIL, LEFT, NCAP7, ISTAT
       DOUBLE PRECISION  C(NCAP7), K(NCAP7), S(4)
       CALL STTPUT('Sorry, NAG is not implemented',ISTAT)
       CALL STSEPI 
       RETURN
       END

       DOUBLE PRECISION FUNCTION E04HEV(N,X)
       INTEGER N
       DOUBLE PRECISION X(N)
C     dummy routine
       E04HEV = 0
       RETURN
       END


       DOUBLE PRECISION FUNCTION E04JBQ(N,X)
       INTEGER N
       DOUBLE PRECISION X(N)
C     dummy routine
       E04JBQ = 0 
       RETURN
       END


       DOUBLE PRECISION FUNCTION E04LBS(N,X)
       INTEGER N
       DOUBLE PRECISION X(N)
C     dummy routine
       E04LBS = 0
       RETURN
       END

C @(#)tintertbl.for	19.1 (ES0-DMD) 02/25/03 14:11:57
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.2  ESO-FORTRAN Conversion, AA  14:17 - 19 NOV 1989
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION:
C         PROGRAM TINTERTBL
C
C.PURPOSE
C
C Statistics and mathematical operations on tables. 
C Implements the commands:
C INTERPOLATE/TI, TT, IT, II
C REBIN/TI, TT, IT, II
C
C.KEYWORDS
C
C ARITHMETIC OPERATS, TABLES.
C
C.ALGORITHM
C
C USE TABLE INTERFACE ROUTINES
C
C-----------------------------------------------------------
C
      PROGRAM TINTER
      IMPLICIT NONE
      INTEGER     NCOM
      PARAMETER   (NCOM=2)
      INTEGER     I, KUN, KNUL, STAT
      CHARACTER*4 COMMAND,WS
      CHARACTER*4 COMTAB(NCOM)
      CHARACTER*70 LINE
C
      DATA COMTAB/'INTE','REBI'/
C
C ... GET INTO MIDAS
C
      CALL STSPRO('TINTETBL')
C
C ... GET COMMAND FORM ENVIRONMENT
C
      CALL STKRDC('MID$CMND',1,1,4,I,COMMAND,KUN,KNUL,STAT)
      CALL FORUPC(COMMAND,WS)      
      IF (WS.EQ.'PRIN') WS = 'READ'
C
C ... SELECT THE ACTION
C
      DO 10 I = 1, NCOM
         IF (WS.EQ.COMTAB(I)) GOTO 20
   10 CONTINUE
      CALL STKRDC('MID$CMND',1,11,2,I,WS,KUN,KNUL,STAT) 
      WRITE(LINE,2000) COMMAND,WS
2000  FORMAT('Error: command ',A,'/',A,' not found')
      CALL STTPUT(LINE,STAT)
      GOTO 3000
C
C ... EXECUTE ACTION
C
   20 GOTO (100,200),I
      CALL STTPUT('Warning: command not found',STAT)
      GOTO 3000
  100 CALL STKRDC('MID$CMND',1,11,2,I,WS,KUN,KNUL,STAT) ! INTERPOLATE
      CALL FORUPC(WS,WS)
      IF (WS(1:2).EQ.'II') THEN
         CALL TDINII
      ELSE IF (WS(1:2).EQ.'IT') THEN
         CALL TDINIT
      ELSE IF (WS(1:2).EQ.'TI') THEN
         CALL TDINTI
      ELSE 
         CALL TDINTT
      END IF
      GOTO 3000
  200 CALL STKRDC('MID$CMND',1,11,2,I,WS,KUN,KNUL,STAT) ! REBIN
      CALL FORUPC(WS,WS)
      IF (WS(1:2).EQ.'II') THEN
         CALL TDRBII
      ELSE IF (WS(1:2).EQ.'IT') THEN
         CALL TDRBIT
      ELSE IF (WS(1:2).EQ.'TI') THEN
         CALL TDRBTI
      ELSE 
         CALL TDRBTT
      END IF
      GOTO 3000
C
C ... EXIT FROM MIDAS
C
 3000 CALL STSEPI
      END
C

C @(#)arithm.for	19.2 (ESO-DMD) 05/13/03 16:05:29
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM ARITHM
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  program ARITHM		version 1.00	850822
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  arithmetic operations, bulk data frames
C
C.PURPOSE
C  evaluate an arithmetic expression involving frames, constants and functions
C  and store the result into a data frame or key OUTPUTR(1), if used as pocket calculator
C
C.ALGORITHM
C  "clean" the expression by replacing all frame names by F, all constants by C
C  and all functions by P, convert it to polish (postfix) notation and evaluate it piecewise
C  establish special condition handler for arithmetic traps...
C  copy all descriptors of first frame operand to result frame.
C
C.INPUT/OUTPUT
C  the following keys are used:
C
C  DEFAULT/C/1/2	1. elem. = Y, result goes to frame
C			         = N, result is a constant -> key OUTPUTR(1)
C			2. elem. = I (use world coords),
C 				 = P (use frame pixels, i.e frames are arrays)
C 				 = X (use frame pixels + work on planes)
C  OUT_A/C/1/80		result frame, if DEFAULT(1:1) = Y
C  Pi/C/1/100		arithmetic expression, may contain up to
C			12 operands;
C			i = 3 or 1, if DEFAULT = Y or N
C	
C.VERSIONS
C 030513	last modif
C	
C-------------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      NULCNT
      INTEGER      FRACNT
      INTEGER      STAT,IAV,N,OFF
      INTEGER      UNIT(1),NULLO
      INTEGER      MADRID(1)
C
      REAL         USRNUL,RNULL(2)
C
      CHARACTER    ZLINE*320,ZRESFR*100,ZDEFA*2
      CHARACTER    OPERAT*2,PARMS(8)*2,CBUF*100
C 
      INCLUDE  'MID_INCLUDE:ST_DEF.INC'
C 
      COMMON      /NULCOM/ NULCNT,USRNUL
      COMMON      /IPOOL/  FRACNT
C
      COMMON      /VMR/ MADRID
C
      INCLUDE  'MID_INCLUDE:ST_DAT.INC'
C 
      DATA   ZRESFR  /' '/
      DATA   ZLINE   /' '/
      DATA   PARMS   /'P1','P2','P3','P4','P5','P6','P7','P8'/
C
C  set up MIDAS environment
      CALL STSPRO('ARITHM ')
C
C  get default indicator + null data
      CALL STKRDC('DEFAULT',1,1,2,IAV,ZDEFA,UNIT,NULLO,STAT)
      CALL STKRDR('NULL',2,2,IAV,RNULL,UNIT,NULLO,STAT)
      NULCNT = 0         
      USRNUL = RNULL(1)
C
C  get expression
      OFF = 1
      IF (ZDEFA(1:1).EQ.'N') THEN
         DO 400, N=1,8
            CALL STKRDC(PARMS(N),1,1,100,IAV,CBUF,UNIT,NULLO,STAT)
            IF (CBUF(1:1).EQ.'?') GOTO 1000
C 
            IF (N.EQ.8) THEN                  !P8 may have embedded blanks
               ZLINE(OFF:) = CBUF(1:)//' '
               GOTO 1010
            ENDIF
C 
            IAV = INDEX(CBUF,' ')             !no blanks in here ...
            IF (IAV.LE.1) IAV = 100
            ZLINE(OFF:) = CBUF(1:)
            OFF = OFF + IAV - 1
400      CONTINUE
C 
C  here for result = expression
C 
      ELSE                                               !get result frame...
         CALL STKRDC('OUT_A',1,1,100,IAV,ZRESFR,UNIT,NULLO,STAT)
         DO 800, N=3,8
            CALL STKRDC(PARMS(N),1,1,100,IAV,CBUF,UNIT,NULLO,STAT)
            IF (CBUF(1:1).EQ.'?') GOTO 1000
C 
            IF (N.EQ.8) THEN                  !P8 may have embedded blanks
               ZLINE(OFF:) = CBUF(1:)//' '
               GOTO 1010
            ENDIF
C
            IAV = INDEX(CBUF,' ')             !no blanks in here ...
            IF (IAV.LE.1) IAV = 100
            ZLINE(OFF:) = CBUF(1:)
            OFF = OFF + IAV - 1
800      CONTINUE
      ENDIF
C
1000  ZLINE(OFF:) = ' '
C
1010  CALL STKRDC('HISTORY',1,9,4,IAV,CBUF,UNIT,NULLO,STAT)  !get qualifier
      CALL UPCAS(CBUF(1:4),CBUF(1:4))
      IF (CBUF(1:2).EQ.'XZ') THEN
         N = X_Z_PLANE
         CALL ARTHMY(N,ZDEFA,ZRESFR,ZLINE)
      ELSE IF (CBUF(1:2).EQ.'XY') THEN
         N = X_Y_PLANE
         CALL ARTHMY(N,ZDEFA,ZRESFR,ZLINE)
      ELSE IF (CBUF(1:2).EQ.'ZY') THEN
         N = Z_Y_PLANE
         CALL ARTHMY(N,ZDEFA,ZRESFR,ZLINE)
      ELSE IF (CBUF(1:2).EQ.'PL') THEN            !COMPUTE/PLANE
         ZDEFA(2:2) = 'X'
         OPERAT = '.P'
         N = INDEX(ZRESFR,OPERAT)                  !check for result plane
         IF (N.LE.0) THEN
            OPERAT = '.p'
            N = INDEX(ZRESFR,OPERAT)
            IF (N.LE.0) 
     +         CALL STETER(3,'missing plane of result frame...')
            N = N + 1
            ZRESFR(N:N) = 'P'
         ENDIF
         CALL ARTHMZ(ZDEFA,ZRESFR,ZLINE)
      ELSE
         CALL ARTHMZ(ZDEFA,ZRESFR,ZLINE)
      ENDIF
C
      RNULL(1) = FLOAT(NULCNT)
      CALL STKWRR('NULL',RNULL,1,1,UNIT,STAT)     !update null count in key NULL
      IF (NULCNT.GT.0) CALL DSPNUL(NULCNT)        !display if NULL values there
C 
      CALL STSEPI
      END

C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION        ISTDES.FOR
C.AUTHOR:               J.D.PONZ  ESA-VILSPA        
C.KEYWORDS              IUE, GO FORMAT, FILE HEADER
C.ENVIRONMENT           VMS
C.PURPOSE
C  Writes the first five lines of the header into a descriptor
C  -- not yet implemented
C         
C.LANGUAGE              F77
C.COMMENTS
C  \begin{TeX}
C    The following extensions are used:
C   \begin{itemize}
C    \item IMPLICIT NONE
C    \item INCLUDE statement
C    \item long variable names
C    \item underscore character
C   \end{itemize}
C  \end{TeX}
C.VERSION: 1.0  INITIAL CODING  09 JUL 1990
C------------------------------------------------------------------
      SUBROUTINE ISTDES(NO,BUFF,STATUS)
C
      IMPLICIT NONE
      INTEGER       NO                ! IN: file id
      CHARACTER*(*) BUFF              ! IN: first header record
      INTEGER       STATUS            ! OUT: status return
C
      INTEGER   DUM(1), CAMERA, DISPER, IMANUM, ISTAT
      CHARACTER*3  TELESCOP, CAM(5)
      CHARACTER*8  DISP(3)
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
      DATA TELESCOP/'IUE'/
      DATA DISP(1)/'HIGH    '/
      DATA DISP(2)/'LOW     '/
      DATA DISP(3)/'N.A.    '/
      DATA CAM(1)/'LWP'/
      DATA CAM(2)/'LWR'/
      DATA CAM(3)/'SWP'/
      DATA CAM(4)/'SWR'/
      DATA CAM(5)/'FES'/
C
C      CALL STDWRC(NO,'IDENT',1,IDENT,1, 72,DUM,STATUS)
C      CALL STDWRI(NO,'NPIX',NPIX,1,2,DUM,STATUS)
C      CALL STDWRD(NO,'START',START,1,2,DUM,STATUS)
C      CALL STDWRR(NO,'LHCUTS',CUTS,1,4,DUM,STATUS)
      CALL STDWRC(NO,'TELESCOP',1,TELESCOP,1, 3,DUM,STATUS)
      READ(BUFF(50:50),1001,ERR=999) CAMERA      ! decode camera number
      READ(BUFF(51:51),1001,ERR=999) DISPER      ! decode dispersion
      READ(BUFF(52:56),1002,ERR=999) IMANUM      ! decode image number
      IF (CAMERA.EQ.9) THEN                  !  FES
         CAMERA = 5
         DISPER = 2
      ENDIF
      CALL STDWRC(NO,'CAMERA',1,CAM(CAMERA),1, 3,DUM,STATUS)
      CALL STDWRC(NO,'DISPERSN',1,DISP(DISPER+1),1, 8,DUM,STATUS)
      CALL STDWRI(NO,'IMAGE',IMANUM,1,1,DUM,STATUS)
      RETURN
 999  CONTINUE
      CALL STTPUT('*** Error decoding the header info ***',ISTAT)
      CALL STTPUT('*** File is not in GO format ***',ISTAT)
      STATUS = 1
      RETURN
 1001 FORMAT(I1)
 1002 FORMAT(I5)
      END

C @(#)rfotsky.for	19.1 (ES0-DMD) 02/25/03 13:30:15
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
       PROGRAM ROMSKY
C++++
C.PURPOSE: Register the sky background counts in rectangular or
C          annular regions. The sky is defined as the mode of the
C          pixel intensity distribution in the region.
C.AUTHORS: R. Buonanno, G. Buscema, C. Corsi, I. Ferraro, G. Iannicola
C          Osservatorio Astronomico di Roma
C.VERSION: 16.01.87 First running version outside MIDAS         R. Buonanno
C          17.12.87 Installation in MIDAS                       R.H. Warmels
C          --.11.88 new version                                 R. Buonanno
C          16.12.88 rewritten for portability and readability   R.H. Warmels
C          02.01.89 sky background written in MIDAS tables      R.H. Warmels
C.VERSION  910123 RHW IMPLICIT NONE included; all variables defined
C---
       IMPLICIT     NONE
C
       INTEGER      NT
       INTEGER      NZ
       INTEGER      NDATA
       INTEGER      NBIN
       INTEGER      NTZ
       PARAMETER    (NT=256)
       PARAMETER    (NZ=1024)
       PARAMETER    (NBIN=1024)
       PARAMETER    (NDATA=2048)
C      PARAMETER    (NDATA=100000)
       PARAMETER    (NTZ=NT*NZ)
C
       INTEGER      MADRID(1)
       INTEGER      EC, ED, EL
       INTEGER      I, J, IY, K
       INTEGER      MIK, KMOD, LMOD, IOLD, II
       INTEGER      IAC, KUN, KNUL, ISTAT
       INTEGER      NAXIS, NPL, NL, NC
       INTEGER      IXW, IYW
       INTEGER      IPX, IPY
       INTEGER      IX0, IY0, IX1, IY1
       INTEGER      LX, LY, LXY
       INTEGER      NRX, NRY
       INTEGER      NDUM
       INTEGER      LV
       INTEGER      MI(NT,NZ)
       INTEGER      IVI(NBIN)
       INTEGER      NPIX(2)
       INTEGER      AREA(6)
       INTEGER      ICOL(256)
       INTEGER      MAK
       INTEGER      TIDSKY
       INTEGER*8    IPNTR
       INTEGER      IMF
C
       REAL         AMI, AMA
       REAL         BACKGR(NT)
       REAL         BINS, BINL, BINH, BINSS
       REAL         DATA(NDATA)
       REAL         DENS(4)
       REAL         FO(NTZ)
       REAL         PSX, PSY
       REAL         RBIN(2)
       DOUBLE PRECISION BEGIN(2),STEP(2)
C
       CHARACTER    IDENT*72
       CHARACTER    CUNIT*72
       CHARACTER    FRAME*60
       CHARACTER    STRING*80
       CHARACTER    SKYFIL*60
       CHARACTER*16 TUNIT,TLABEL,TTYPE,TFORM
C      
       INCLUDE      'MID_INCLUDE:ST_DEF.INC/NOLIST'
       COMMON       /VMR/MADRID
       INCLUDE      'MID_INCLUDE:ST_DAT.INC/NOLIST'
C
       DATA         TUNIT/' '/
       DATA         TLABEL/'BACKGR_LEVEL'/
       DATA         TTYPE/'R*4'/
       DATA         TFORM/'G13.6'/
C
  901  FORMAT(10X,'Minimum and maximum used:', G13.6,', ', G13.6)
  902  FORMAT(10X,'Area in pixel units: [', 
     2            I5, ',', I5, ':', I5, ',', I5, ']')
C 903  FORMAT('*** FATAL: Too many histogram bins; maximum is ',I5)
  904  FORMAT(10X,'Number of cells in x: ',I3, '; in y:', I3)
C
       CALL STSPRO('RFOTSKY')
C
       CALL STKRDC('IN_A',1,1,60,IAC,FRAME,KUN,KNUL,ISTAT)
       CALL STIGET(FRAME,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     2             2,NAXIS,NPIX,BEGIN,STEP,IDENT,CUNIT,
     3             IPNTR,IMF,ISTAT)
       NPL = NPIX(1)
       NL  = NPIX(2)
       IXW = BEGIN(1)
       IYW = BEGIN(2)
C
       CALL STKRDC('OUT_A',1,1,60,IAC,SKYFIL,KUN,KNUL,ISTAT)
C
       CALL STKRDC('INPUTC',1,1,80,IAC,STRING,KUN,KNUL,ISTAT)
       CALL EXTCOO(IMF,STRING,NAXIS,NDUM,AREA(1),AREA(3),ISTAT)
       IX0 = AREA(1)
       IY0 = AREA(2)
       IX1 = AREA(3)
       IY1 = AREA(4)
       LX  = AREA(3) - AREA(1) + 1
       LY  = AREA(4) - AREA(2) + 1
       LXY = LX*LY
C
       CALL STKRDI('INPUTI',1,2,IAC,AREA(5),KUN,KNUL,ISTAT)   !# cells in #x,#y
       NRX = AREA(5)
       NRY = AREA(6)  
       NC  = NRX*NRY                               !total number of rectanguals
C
C *** INFO to the use
       STRING = '*** INFO: Sky values will be calculated in '//
     2          'rectangular grid'
       CALL STTPUT(STRING,ISTAT)
C
C *** get binning parameters for the histogram determination
       CALL STKRDR('INPUTR',1,2,IAC,RBIN,KUN,KNUL,ISTAT)                !# bins
       BINL = RBIN(1)
       BINH = RBIN(2)
       IF (ABS(BINH-BINL).LT.10.0E-10) THEN
C
C *** set min and max pixel values
          CALL STDRDR(IMF,'LHCUTS',1,4,IAC,DENS,KUN,KNUL,ISTAT)
          IF (DENS(1).LT.DENS(2)) THEN
             BINL = DENS(1)
             BINH = DENS(2)
          ELSE
             BINL = DENS(3)
             BINH = DENS(4)
          ENDIF
C
          IF ((BINH-BINL).LT.10.0E-10) THEN
             CALL MINMAX(MADRID(IPNTR),LXY,BINL,BINH)
             IF ((BINH-BINL).LT.10.0E-10) THEN
                STRING = '*** FATAL: frame minimum = frame maximum ...'
                CALL STTPUT(STRING,ISTAT)
                CALL STSEPI
             ENDIF
          ENDIF
       ENDIF
       BINS = (BINH-BINL)/NBIN
C
       WRITE (STRING,901) BINL, BINH
       CALL STTPUT(STRING,ISTAT)
C
C ***  Create output table
       CALL STECNT('GET',EC,ED,EL)
       CALL STECNT('PUT',1,0,0)
       CALL TBTINI(SKYFIL, 0, F_O_MODE, NRX, NRY, TIDSKY, ISTAT)
       IF (ISTAT.NE.0) THEN
          STRING = '*** FATAL: Problems with sky file; try again ...'
          CALL STTPUT(STRING,ISTAT)
          CALL STSEPI
       ENDIF
       CALL STECNT('PUT',EC,ED,EL)
       DO 10 I = 1, NRX
          CALL TBCINI(TIDSKY, D_R4_FORMAT, 1, TFORM, TUNIT,
     &                TLABEL, ICOL(I), ISTAT)
   10  CONTINUE
C
       WRITE (STRING,902) IX0,IY0,IX1,IY1
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,904) NRX,NRY
       CALL STTPUT(STRING,ISTAT)
C
       DO 20 I=1,NT
          DO 21 J=1,NZ
             MI(I,J) = 0
   21     CONTINUE
   20  CONTINUE
        DO 30 I=1,NBIN
          IVI(I) = 0
   30  CONTINUE
C
C *** determine the intensity histogram
       DO 40 IY=IY0,IY1
          CALL REALIN(NPL,NL,IY,IX0,LX,MADRID(IPNTR),DATA)
          MAK = -1000000
          MIK = -MAK
          DO 41 J = 1,LX
             IF (DATA(J).GT.BINL .AND. DATA(J).LT.BINH) THEN
                K      = (DATA(J)-BINL)/BINS+1
                IVI(K) = IVI(K)+1
                MAK    = MAX0(MAK,K)
                MIK    = MIN0(MIK,K)
             END IF
   41     CONTINUE
   40  CONTINUE
C
C ** get the maximum in the histogram
       KMOD = 0
       LMOD = 0
       DO 50 I = MIK,MAK
          IF (IVI(I).GT.LMOD) THEN
             LMOD = IVI(I)
             KMOD = I
          END IF
   50  CONTINUE
C
       BINSS = BINS/10.0
       AMI = BINL+KMOD*BINS-NZ*BINSS/2
       IF (AMI.LT.BINL) THEN
          AMI=BINL
       ENDIF
       AMA = AMI+NZ*BINSS
C
       PSX = FLOAT(LX)/NRX
       PSY = FLOAT(LY)/NRY
       DO 60 IY=IY0,IY1
          IOLD = IY-IY0+1
          CALL REALIN(NPL,NL,IY,IX0,LX,MADRID(IPNTR),DATA)
          DO 61 J = 1,LX
             IF (DATA(J).GE.AMI .AND. DATA(J).LT.AMA) THEN
                IF (PSX-INT(PSX).EQ.0.) THEN
                   IPX=(J-1)/INT(PSX)+1
                ELSE
                   IPX=J/PSX+1
                END IF
                IF (PSY-INT(PSY).EQ.0.) THEN
                   IPY=(IY-IY0)/INT(PSY)+1
                ELSE
                   IPY = IOLD/PSY+1
                END IF
                K        = IPX+(IPY-1)*NRX
                II       = (DATA(J)-AMI)/BINS + 1
                MI(K,II) = MI(K,II)+1
             END IF
   61     CONTINUE
   60  CONTINUE
C
       DO 70 I = 1,NC                                          !  to trova fondi
          LV = 0
          DO 72 J = 1,NZ
             IF (MI(I,J).GT.LV) THEN
                LV = MI(I,J)
                FO(I) = (J-1)*BINS+BINS/2.+AMI
             END IF
   72     CONTINUE
   70  CONTINUE
C
       DO 80 J = 1,NRY
          DO 81 I = 1,NRX
             BACKGR(I) = FO((J-1)*NRX+I)
   81     CONTINUE
          CALL TBRWRR(TIDSKY,J,NRX,ICOL,BACKGR,ISTAT)
   80  CONTINUE
C
       CALL STDWRI(IMF,'SKY_AREA',AREA,1,6,KUN,ISTAT)
       CALL TBSINI(TIDSKY,ISTAT)
       CALL TBTCLO(TIDSKY,ISTAT)
       CALL STSEPI
       END

C @(#)fist.for	19.1 (ES0-DMD) 02/25/03 13:29:43
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FIST(IVZ,NP,VP)
C+++
C.Purpose: Fit con gaussiana monodimensionale a 3 parametri
C         (altezza - larghezza - posizione)
C---
      IMPLICIT NONE
      INTEGER  IVZ(1)
      INTEGER  NP
      REAL     VP(1)
C
      REAL     VPR(3),SIGP(3)
      REAL     RMT(3,3),VTN(3),VFZ(3),VFF(3),VC(3)
      REAL     FS
      REAL     CO
      INTEGER  I, J , K
      INTEGER  TWO, THREE
      INTEGER  NC
      REAL     FK, EP, EPES, FNO

      DATA     FS/.7/,VPR/1.,1.,1./
C
      TWO = 2
      THREE = 3

      DO 10 I=1,3
         VFF(I)=0
         VFZ(I)=0
         VC(I)=0
         DO 11 J=1,3
            RMT(I,J)=0
   11    CONTINUE
   10 CONTINUE

      FK=-4.*ALOG(2.)/(VP(THREE)**2)
C
      DO 20 K=1,NP
         EPES   = (K-VP(TWO))**2
         EP     = EXP(EPES*FK)
         CO     = -VP(1)*EP*2.*FK
         VTN(1) = EP
         VTN(2) = CO*(K-VP(TWO))
         VTN(3) = CO*(K-VP(TWO))**2/VP(THREE)
         FNO    = VP(1)*EP
         DO 21 I=1,3
            VFZ(I) = VFZ(I)+IVZ(K)*VTN(I)
            VFF(I) = VFF(I)+FNO*VTN(I)
            DO 22 J = 1,3
               RMT(I,J) = RMT(I,J)+VTN(I)*VTN(J)
   22       CONTINUE
   21    CONTINUE
   20 CONTINUE
C
      DO 30 I=1,3
         RMT(I,I) = RMT(I,I)*(1+FS**2)
         VC(I)    = VC(I)+VFZ(I)-VFF(I)
   30 CONTINUE
C
      NC = 3
      CALL LISIB(RMT,VC,3,NC,SIGP)
      DO 40 I=1,3
        VP(I) = VC(I)*VPR(I)+VP(I)
   40 CONTINUE
C
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2005 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION: INTESTAR 
C.PURPOSE:        Compute the stellar magnitude
C.LANGUAGE:       F77+ESOext
C.AUTHOR:         Charlie Ounnas
C.VERSION:        870928 RHW Change from old to new ST calls
C.VERSION:        880708 RHW Converted to standard Fortran
C.VERSION:        890214 RHW ST_interfaces
C.VERSION:        901128 RHW changes due to change in command syntax;
C.                           cursor selection now possible
C.VERSION:        910115 RHW IMPLICIT NONE added
C 
C 051116		last modif
C 
C-------------------------------------------------------------------

      PROGRAM  INTSTR
C
      IMPLICIT NONE
C
      INTEGER           MADRID(1)
      INTEGER           ISTAT
      INTEGER           I,IAC
      INTEGER*8         IP
      INTEGER           IMF,J,N,IR
      INTEGER           ST1,ST2,COORDC,COOFF
      INTEGER           KUN,KNUL, INCURS
      INTEGER           TIDI,TIDO,ACOL,AROW
      INTEGER           NAXIS,NCOL,NCOLO,NROW
      INTEGER           ICOL(8)
      INTEGER           MASK, OVCON
      INTEGER           NPIX(3)
      INTEGER           XY1(2),XY2(2)
      INTEGER           MASKO(1000)

      REAL              DMAX
      REAL              FPIX1(6),FPIX2(6)
      REAL              RVAL(11), RV
      REAL              RINF(6)
      REAL              CUTS(4)
      REAL              STA(2), STE(2)
      REAL              XYZI(2)
      REAL              XYZ(8)
      REAL              XYZO(8,1000)
      REAL              PARAM(3)
C 
      DOUBLE PRECISION  START(3),STEP(3)
C
      CHARACTER         FRAME*60,TBIN*60,TBOUT*60
      CHARACTER*16      COLX,COLY
      CHARACTER         FORM*5
      CHARACTER         INFO*40
      CHARACTER*16      LABEL(2),UNIT(2)
      CHARACTER         MODE*4
      CHARACTER         TEXT*88
      CHARACTER*16      LABELO(8),UNITO(8)
      CHARACTER         IDENT*72,CUNIT*64
      LOGICAL           NULL(2)
C
      INCLUDE           'MID_INCLUDE:ST_DEF.INC/NOLIST'
      INCLUDE           'MID_INCLUDE:IDIDEV.INC/NOLIST'
      INCLUDE           'MID_INCLUDE:IDIMEM.INC/NOLIST'
      COMMON            /VMR/MADRID
      INCLUDE           'MID_INCLUDE:ST_DAT.INC/NOLIST'
C
      DATA              LABEL /'X_COORD','Y_COORD'/
      DATA              LABELO/'X_COORD','Y_COORD','FLUX','MAGNITUDE',
     2                         'BACKGROUND','DIAMETER','LOG_DIAMETER',
     3                         'NO_REFERENCE'/
      DATA              UNIT  /'WORLD COORD.', 'WORLD COORD.'/
      DATA              UNITO /'WORLD COORD.', 'WORLD COORD.',
     2                          ' ', ' ', ' ', 'WORLD COORD.',' ',' '/
      DATA              FORM/'E12.5'/
      DATA              INFO/'*** INFO: Switch the cursor on ...'/
C
901   FORMAT(' Id.       World coord          Flux        Mag.      ',
     2       'Backgr     Diameter')
902   FORMAT(I4,2X,6(G12.6))
903   FORMAT('INFO: switch cursor on ...')
C
C *** start executable code
      CALL STSPRO('INTSTR')
C
C *** 
      CALL STKRDC('IN_A',1,1,60,IAC,FRAME,KUN,KNUL,ISTAT)
      IF (FRAME.EQ.'*') THEN
         CALL CLNFRA(FRAME,FRAME,0)
         INCURS = 1
      ELSE
         INCURS = 0
      ENDIF
      CALL STIGET(FRAME,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     2            3,NAXIS,NPIX,START,STEP,IDENT,CUNIT,IP,IMF,ISTAT)
C
C *** get the subarea input options
      CALL STKRDC('IN_B',1,1,60,IAC,TBIN,KUN,KNUL,ISTAT)
C
C *** get the output table
      CALL STKRDC('OUT_A',1,1,60,IAC,TBOUT,KUN,KNUL,ISTAT)
C
C *** get the parameters  
      CALL STKRDR('INPUTR',1,3,IAC,PARAM,KUN,KNUL,ISTAT)
      IF (PARAM(1).LE.0.) THEN
         PARAM(1)  = 30.
      ENDIF
      IF (PARAM(1).LT.10.) THEN
         CALL STTPUT('*** WARNING: Radius is less than 10 pixel',ISTAT)
         CALL STTPUT('             You can expect unreliable results',
     2                ISTAT)
C        PARAM(1)  = 10.
      ENDIF
      IF (PARAM(1).GT.200.) THEN
         PARAM(1)   = 200.
      ENDIF
C
C *** get the operation mode
      CALL STKRDC('INPUTC',1,1,4,IAC,MODE,KUN,KNUL,ISTAT)
      CALL UPCAS(MODE,MODE)
C
      CALL STDRDR(IMF,'LHCUTS',1,4,IAC,CUTS,KUN,KNUL,ISTAT)
      IF (CUTS(1).LT.CUTS(2)) THEN
         DMAX   = CUTS(2)
      ELSE
         DMAX   = CUTS(4)
      END IF
      STA(1) = START(1)
      STA(2) = START(2)
      STE(1) = STEP(1)
      STE(2) = STEP(2)
C
C *** main contreol loop for cursor input
      IF (INCURS.EQ.1) THEN
C
C *** get main control block for DeAnza + attach device
         CALL DTOPEN(1,ISTAT)
         CALL STKRDI('DAZHOLD',14,1,IAC,OVCON,KUN,KNUL,ISTAT)
C
C *** get scroll values of displayed channel + scroll overlay accordingly
         CALL DTGICH(QDSPNO,QIMCH,FRAME,RINF,ISTAT)
         CALL DAZSCR(QDSPNO,QIMCH,SCROLX,SCROLY,ISTAT)	
         COORDC  = 0
         COOFF  = 0
         FRAME  = ' '                    !that's needed for cursor interface
         NROW    = 0
C
C ***    read cursor position(s)
   10    CONTINUE 
         CALL GETCUR('NNYY',FRAME,XY1,FPIX1,RVAL(1),RV,ST1,
     +                            XY2,FPIX2,RVAL(3),RV,ST2)
         IF ((ST1.EQ.0) .AND. (ST2.EQ.0)) THEN
            GO TO 20
         ELSE
            GO TO 30
         END IF
C
C *** write output heading
   20    IF ((COORDC.EQ.0).AND.(COOFF.EQ.0)) THEN
            WRITE(TEXT,903)
            CALL STTPUT(TEXT,ISTAT)
            FRAME = ' '
            COOFF = 1
            GO TO 10
         ELSE
            GO TO 50
         END IF
C
   30    COORDC = COORDC + 1                       !  update coordinate counter
         IF (COORDC.EQ.1) THEN
            WRITE(TEXT,901)
            CALL STTPUT(TEXT,ISTAT)
         ENDIF
C
C ***    compute the radius of the aperture
C ***    world coordinates of the area center
         XYZI(1) = RVAL(1)
         XYZI(2) = RVAL(2)
         MASK    = 0
C
         IF (MODE.EQ.'AUTO') THEN
            CALL SPFLXA(MADRID(IP),NPIX,STA,STE,PARAM(1),
     2                  PARAM(2),DMAX,PARAM(3),XYZI,MASK,XYZ)
         ELSE
            CALL SPFLXI(MADRID(IP),NPIX,STA,STE,PARAM(1),
     2                  PARAM(2),DMAX,PARAM(3),XYZI,MASK,XYZ)
         ENDIF
C
C *** output the result
         IF (MASK.EQ.-1) THEN                     ! on error next entry
            CALL STTPUT('*** ERROR: Excessive background', ISTAT)
         ELSE IF (MASK.EQ.-2) THEN
            CALL STTPUT('*** ERROR: Indefinite diameter', ISTAT)
         ELSE IF (MASK.EQ.-3) THEN
            CALL STTPUT('*** ERROR: Maximum is outside the object',
     2                    ISTAT)
           
         ELSE                                       ! all systems ok
            NROW = NROW + 1                         !  update table row counter
            DO 120 J = 1,8
               XYZO(J,NROW) = XYZ(J)
  120       CONTINUE
            MASKO(NROW) = MASK

            WRITE(TEXT,902) INT(XYZ(8)),XYZ(1),XYZ(2),
     2                      XYZ(3),XYZ(4),XYZ(5),XYZ(6)
            CALL STTPUT(TEXT,ISTAT)
         ENDIF
         GO TO 10

      ELSE                                      ! here for the input from table
         WRITE(TEXT,901)
         CALL STTPUT(TEXT,ISTAT)
         COLX = 'X_COORD'
         COLY = 'Y_COORD'
         CALL TBTOPN(TBIN,F_I_MODE,TIDI,ISTAT)
         CALL TBIGET(TIDI,NCOL,NROW,N,ACOL,AROW,ISTAT)
C
C search for colomn indices by name
         DO 210 I = 1,2
            CALL TBLSER(TIDI,LABEL(I),ICOL(I),ISTAT)
  210    CONTINUE
         DO  220 IR = 1,NROW
            CALL TBRRDR(TIDI,IR,2,ICOL,XYZI,NULL,ISTAT)
            MASK = 0
            IF (MODE.EQ.'AUTO') THEN
               CALL SPFLXA(MADRID(IP),NPIX,STA,STE,PARAM(1),
     2                     PARAM(2),DMAX,PARAM(3),XYZI,MASK,XYZ)
            ELSE
               CALL SPFLXI(MADRID(IP),NPIX,STA,STE,PARAM(1),
     2                     PARAM(2),DMAX,PARAM(3),XYZI,MASK,XYZ)
            ENDIF
C
            IF (MASK.EQ.-1) THEN                         ! on error next entry
               CALL STTPUT('*** ERROR: Excessive background', ISTAT)
            ELSE IF (MASK.EQ.-2) THEN
               CALL STTPUT('*** ERROR: Indefinite diameter', ISTAT)
            ELSE IF (MASK.EQ.-3) THEN
               CALL STTPUT('*** ERROR: Maximum is outside the object',
     2                       ISTAT)
            ELSE                                    ! all systems ok
               DO 221 J = 1,8
                  XYZO(J,IR) = XYZ(J)
  221          CONTINUE
               MASKO(IR) = MASK
C
               WRITE(TEXT,902) INT(XYZ(8)),XYZ(1),XYZ(2),
     2                      XYZ(3),XYZ(4),XYZ(5),XYZ(6)
               CALL STTPUT(TEXT,ISTAT)
            ENDIF
  220    CONTINUE
         CALL TBTCLO(TIDI,ISTAT)
      ENDIF
C  
C *** open table if wanted	
   50 CONTINUE
      IF (TBOUT.NE.'?') THEN
         NCOLO = 8
         CALL TBTINI(TBOUT,F_O_MODE,F_TRANS,NCOLO,NROW,TIDO,ISTAT)
         DO 60 I = 1,8
            CALL TBCINI(TIDO,D_R4_FORMAT,1,FORM,UNITO(I),
     2                  LABELO(I),ICOL(I),ISTAT)
   60    CONTINUE
C
C *** write to table
         J = 0
         DO 130 I = 1,NROW
            IF (MASKO(I).GT.0) THEN
               J = J + 1
               CALL TBRWRR(TIDO,J,8,ICOL,XYZO(1,I),ISTAT)
            ENDIF
  130    CONTINUE
         CALL TBTCLO(TIDO,ISTAT)
      ENDIF
C
      IF (INCURS.EQ.1) THEN
         CALL DTCLOS(QDSPNO)
      ENDIF
      CALL STSEPI
      END

C @(#)rctint.for	19.1 (ES0-DMD) 02/25/03 13:30:47
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C +++
C.PURPOSE:     Interpolation
C.ALGORYTHM:   Each input pixel is divided into 9 subpixels
C              Their indices are defined as follows:
C              1,3   2,3   3,3       FIRST INDEX:  X
C              1,2   2,2   3,2
C              1,1   2,1   3,1     SECOND INDEX: Y
C
C              For the interpolation, the following weighting scheme is used:
C             .1667       .1667      .333      .1667       .1667
C                      --------------------------------
C             .1667    |  .5         .667      .5     |    .1667
C             .333     |  .667      (1.)       .667   |    .333
C             .1667    |  .5         .667      .5     |    .1667
C                      --------------------------------
C             .1667       .1667      .333      .1667       .1667
C
C                (the box marks the edges of one input pixel)
C
C.NOTE:        This "deconvolution" makes an implicit assumption about
C              the point spread function, namely that its fwhm is smaller 
C              than or roughly equal to one input pixel. future improvements
C              could include reading in a more realistic or even exact 
C              point spread function and doing a proper deconvolution.
C ---
      SUBROUTINE RCTINT(IN,NPX,NPY,IPOL)
C
      IMPLICIT  NONE
      REAL      IN(1)
      INTEGER   NPX
      INTEGER   NPY
      REAL      IPOL(3*NPX,3*NPY)
C     
      REAL      SUB(3,3)
      INTEGER   NPERC
      INTEGER   INDXX
      INTEGER   INDXY
      CHARACTER PROGR*50
      INTEGER   ISTAT
      INTEGER   IPOS, TWO 
      INTEGER   I, J, K, L
C
 9000 FORMAT ('*** INFO: ',I3,' percent completed ...')
C
      CALL STTPUT('*** INFO: Deconvolution started',ISTAT)
      NPERC  = 0
      TWO = 2
C
C *** Begin with all pixels on the edge of the input frame
C *** lower left corner
C
      DO 20 K = 1,3
         DO 10 L = 1,3
            SUB(K,L) = IN(1)
   10    CONTINUE
   20 CONTINUE
C  
      SUB(3,1) = .667*IN(1) + .333*IN(TWO)        !   first index: x, second: y
      SUB(3,2) =  SUB(3,1)
      SUB(3,3) = .5*IN(1) + .1667* (IN(TWO)+IN(NPX+1)+IN(NPX+2))
      SUB(2,3) = .667*IN(1) + .333*IN(NPX+1)
      SUB(1,3) =  SUB(2,3)
      CALL RCTSCL(SUB,IN(1))
C
      DO 40 K = 1,3
         DO 30 L = 1,3
            INDXX  = K
            INDXY  = L
            IPOL(INDXX,INDXY) = IPOL(INDXX,INDXY) + SUB(K,L)
   30    CONTINUE
   40 CONTINUE
C
C *** lower right corner
C
      DO 60 K = 1,3
         DO 50 L = 1,3
            SUB(K,L) = IN(NPX)
   50    CONTINUE
   60 CONTINUE
C
      SUB(1,1) = .667*IN(NPX) + .333*IN(NPX-1)
      SUB(1,2) = SUB(1,1)
      SUB(1,3) = .5*IN(NPX) + .1667* (IN(NPX-1)+IN(2*NPX-1)+IN(2*NPX))
      SUB(2,3) = .667*IN(NPX) + .333*IN(2*NPX)
      SUB(3,3) = SUB(2,3)
C
      CALL RCTSCL(SUB,IN(NPX))
C
      DO 80 K = 1,3
         DO 70 L = 1,3
            INDXX  = NPX*3 - 3 + K
            INDXY  = L
            IPOL(INDXX,INDXY) = IPOL(INDXX,INDXY) + SUB(K,L)
   70    CONTINUE
   80 CONTINUE
C
C *** upper left corner
C
      IPOS  = NPX*(NPY-1) + 1
      DO 100 K = 1,3
         DO 90 L = 1,3
            SUB(K,L) = IN(IPOS)
   90    CONTINUE
  100 CONTINUE
C
      SUB(1,1) = .667*IN(IPOS) + .333*IN(IPOS-NPX)
      SUB(2,1) = SUB(1,1)
      SUB(3,1) = .5*IN(IPOS) + .1667* (IN(IPOS-NPX)+IN(IPOS-NPX-1)+
     +           IN(IPOS+1))
      SUB(3,2) = .667*IN(IPOS) + .333*IN(IPOS+1)
      SUB(3,3) = SUB(3,2)
      CALL RCTSCL(SUB,IN(IPOS))
C
      DO 120 K = 1,3
         DO 110 L = 1,3
            INDXX  = K
            INDXY  = NPY*3 - 3 + L
            IPOL(INDXX,INDXY) = IPOL(INDXX,INDXY) + SUB(K,L)
  110    CONTINUE
  120 CONTINUE
C
C *** upper right corner
C
      IPOS   = NPX*NPY
      DO 140 K = 1,3
         DO 130 L = 1,3
            SUB(K,L) = IN(IPOS)
  130    CONTINUE
  140 CONTINUE
C
      SUB(1,3) = .667*IN(IPOS) + .333*IN(IPOS-1)
      SUB(1,2) =  SUB(1,3)
      SUB(3,1) = .5*IN(IPOS) + .1667* (IN(IPOS-1)+IN(IPOS-NPX-1)+
     +            IN(IPOS-NPX))
      SUB(2,1) = .667*IN(IPOS) + .333*IN(IPOS-NPX)
      SUB(3,1) =  SUB(2,1)
      CALL RCTSCL(SUB,IN(IPOS))
C
      DO 160 K = 1,3
         DO 150 L = 1,3
            INDXX  = NPX*3 - 3 + K
            INDXY  = NPY*3 - 3 + L
            IPOL(INDXX,INDXY) = IPOL(INDXX,INDXY) + SUB(K,L)
  150    CONTINUE
  160 CONTINUE
C
C  *** bottom edge
C
      DO 210 I = 2,NPX - 1
         IPOS   = I
         DO 180 K = 1,3
            DO 170 L = 1,3
               SUB(K,L) = IN(IPOS)
  170       CONTINUE
  180    CONTINUE
C
         SUB(1,1) = .667*IN(IPOS) + .333*IN(IPOS-1)
         SUB(1,2) = SUB(1,1)
         SUB(1,3) = .5*IN(IPOS) + .1667*
     +              (IN(IPOS-1)+IN(IPOS+NPX-1)+IN(IPOS+NPX))
         SUB(2,3) = .667*IN(IPOS) + .333*IN(IPOS+NPX)
         SUB(3,3) = .5*IN(IPOS) + .1667*
     +              (IN(IPOS+1)+IN(IPOS+NPX)+IN(IPOS+NPX+1))
         SUB(3,2) = .667*IN(IPOS) + .333*IN(IPOS+1)
         SUB(3,1) = SUB(3,2)
         CALL RCTSCL(SUB,IN(IPOS))
C
         DO 200 K = 1,3
            DO 190 L = 1,3
               INDXX  = I*3 - 3 + K
               INDXY  = L
               IPOL(INDXX,INDXY) = IPOL(INDXX,INDXY) + SUB(K,L)
  190       CONTINUE
  200    CONTINUE
  210 CONTINUE
C
C *** top edge
C
      DO 260 I = 2,NPX - 1
         IPOS   = (NPY-1)*NPX + I
         DO 230 K = 1,3
            DO 220 L = 1,3
               SUB(K,L) = IN(IPOS)
  220       CONTINUE
  230    CONTINUE
C
         SUB(1,3) = .667*IN(IPOS) + .333*IN(IPOS-1)
         SUB(1,2) = SUB(1,3)
         SUB(1,1) = .5*IN(IPOS) + .1667*
     +              (IN(IPOS-1)+IN(IPOS-NPX-1)+IN(IPOS-NPX))
         SUB(2,1) = .667*IN(IPOS) + .333*IN(IPOS-NPX)
         SUB(3,1) = .5*IN(IPOS) + .1667*
     +              (IN(IPOS-NPX)+IN(IPOS-NPX)+IN(IPOS-NPX+1))
         SUB(3,2) = .667*IN(IPOS) + .333*IN(IPOS+1)
         SUB(3,3) = SUB(3,2)
         CALL RCTSCL(SUB,IN(IPOS))
C
         DO 250 K = 1,3
            DO 240 L = 1,3
               INDXX  = I*3 - 3 + K
               INDXY  = NPY*3 - 3 + L
               IPOL(INDXX,INDXY) = IPOL(INDXX,INDXY) + SUB(K,L)
  240       CONTINUE
  250    CONTINUE
  260 CONTINUE
C
C *** left edge
C
      DO 310 J = 2,NPY - 1
         IPOS   = (J-1)*NPX + 1
         DO 280 K = 1,3
            DO 270 L = 1,3
               SUB(K,L) = IN(IPOS)
  270       CONTINUE
  280    CONTINUE
C
         SUB(1,1) = .667*IN(IPOS) + .333*IN(IPOS-NPX)
         SUB(2,1) = SUB(1,1)
         SUB(3,1) = .5*IN(IPOS) + .1667*
     +              (IN(IPOS-NPX)+IN(IPOS-NPX+1)+IN(IPOS+1))
         SUB(3,2) = .667*IN(IPOS) + .333*IN(IPOS+1)
         SUB(3,3) = .5*IN(IPOS) + .1667*
     +              (IN(IPOS+1)+IN(IPOS+NPX+1)+IN(IPOS+NPX))
         SUB(2,3) = .667*IN(IPOS) + .333*IN(IPOS+NPX)
         SUB(1,3) = SUB(2,3)
         CALL RCTSCL(SUB,IN(IPOS))
C
         DO 300 K = 1,3
            DO 290 L = 1,3
               INDXX  = K
               INDXY  = J*3 - 3 + L
               IPOL(INDXX,INDXY) = IPOL(INDXX,INDXY) + SUB(K,L)
  290       CONTINUE
  300    CONTINUE
  310 CONTINUE
C
C *** right edge
C
      DO 360 J = 2,NPY - 1
         IPOS   = J*NPX
         DO 330 K = 1,3
            DO 320 L = 1,3
               SUB(K,L) = IN(IPOS)
  320       CONTINUE
  330    CONTINUE
C
         SUB(3,1) = .667*IN(IPOS) + .333*IN(IPOS-NPX)
         SUB(2,1) = SUB(3,1)
         SUB(1,1) = .5*IN(IPOS) + .1667*
     +              (IN(IPOS-NPX)+IN(IPOS-NPX-1)+IN(IPOS-1))
         SUB(1,2) = .667*IN(IPOS) + .333*IN(IPOS-1)
         SUB(1,3) = .5*IN(IPOS) + .1667*
     +              (IN(IPOS-1)+IN(IPOS+NPX-1)+IN(IPOS+NPX))
         SUB(2,3) = .667*IN(IPOS) + .333*IN(IPOS+NPX)
         SUB(3,3) = SUB(2,3)
         CALL RCTSCL(SUB,IN(IPOS))
C
         DO 350 K = 1,3
            DO 340 L = 1,3
               INDXX  = NPX*3 - 3 + K
               INDXY  = J*3 - 3 + L
               IPOL(INDXX,INDXY) = IPOL(INDXX,INDXY) + SUB(K,L)
  340       CONTINUE
  350    CONTINUE
  360 CONTINUE
C
C *** and now the rest is straight forward
C
      DO 400 J = 2,NPY - 1
         DO 390 I = 2,NPX - 1
            IPOS   = (J-1)*NPX + I  !   CENTRAL SUBPIXEL
            SUB(2,2) = IN(IPOS)
            SUB(1,1) = .5*IN(IPOS) + .1667*
     +                 (IN(IPOS-1)+IN(IPOS-NPX-1)+IN(IPOS-NPX))
            SUB(2,1) = .667*IN(IPOS) + .333*IN(IPOS-NPX)
            SUB(3,1) = .5*IN(IPOS) + .1667*
     +                 (IN(IPOS-NPX)+IN(IPOS-NPX+1)+IN(IPOS+1))
            SUB(3,2) = .667*IN(IPOS) + .333*IN(IPOS+1)
            SUB(3,3) = .5*IN(IPOS) + .1667*
     +                (IN(IPOS+1)+IN(IPOS+NPX+1)+IN(IPOS+NPX))
            SUB(2,3) = .667*IN(IPOS) + .333*IN(IPOS+NPX)
            SUB(1,3) = .5*IN(IPOS) + .1667*
     +                 (IN(IPOS+NPX)+IN(IPOS+NPX-1)+IN(IPOS-1))
            SUB(1,2) = .667*IN(IPOS) + .333*IN(IPOS-1)
            CALL RCTSCL(SUB,IN(IPOS))
C
            DO 380 K = 1,3
               DO 370 L = 1,3
                  INDXX  = I*3 - 3 + K
                  INDXY  = J*3 - 3 + L
                  IPOL(INDXX,INDXY) = IPOL(INDXX,INDXY) + SUB(K,L)
  370          CONTINUE
  380       CONTINUE
  390    CONTINUE
C
C *** feed them progress messages ...
C
         IF (((10*J)/NPY).GE. (NPERC+1)) THEN
            NPERC  = NPERC + 1
            WRITE (PROGR,9000) 10*NPERC
            CALL STTPUT(PROGR,ISTAT)
         END IF
  400 CONTINUE

      RETURN
      END

C @(#)updtl.for	19.1 (ES0-DMD) 02/25/03 13:25:40
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C
C-----------------------------------------------------------------------
      SUBROUTINE UPDTL( MCAT , NL , NN , M )
C
      IMPLICIT NONE
C
      INTEGER   ISTAT
      INTEGER   NL
      INTEGER   M , M3 , M4
C     INTEGER   M1 , M2 
      INTEGER   MB , MCAT(4,NL) , MM3 , MR , MS
C     INTEGER   MX1 , MX2
      INTEGER   MX3 , MX4 , MXX4
C     INTEGER   MY1 , MY2
      INTEGER   MY3 , MY4 , MYY4
      INTEGER   NN , NNB , NXB
C     REAL      B1 , B2, BX1 , BX2 , BY1 , BY2
C
      M3 = 0
      M4 = 0
      MX4 = 0
      MY4 = 0
      MS = M - MOD( M-1 , NL ) - 1
      IF (MS .GE. NL) THEN
         CALL STTPUT('*** FATAL: Internal buffer overflow; ',ISTAT)
         CALL STTPUT
     +   ('    Please, restrict search to smaller subframe',ISTAT)
         CALL STTPUT
     +   ('    or modify parameter setup fro detection',ISTAT)
         CALL STSEPI
      ENDIF

      MB = M - MS
      IF ( MB .EQ. 0 ) THEN
          MS = MS - NL
          MB = NL
     
      ENDIF
      MM3 = MCAT(3,MB)
C
C ******      Read neighbour parameters.
C
      IF ( NN .GT. MS ) THEN
          NNB = MOD( NN-1 , NL ) + 1
          M3 = MCAT(3,NNB)
          M4 = MCAT(4,NNB)
c      ELSE
c          READ ( ISF , REC=NN ) M1 , M2 , M3 , M4 , B1 , B2
      ENDIF
      MR = 0
C
C ******      Four out of five cases will be considered.
C
      IF ( M3 . EQ. 0 .AND. MM3 .EQ. 0 ) THEN
C
C ******          Detection is single and neighbour is single.
C
          M3 = NN
          MM3 = NN
          M4 = M
          MR = 1
      ELSE IF ( M3 .EQ. 0 .AND. MM3 .NE. 0 ) THEN 
C
C ******          Detection is multiple and neighbour is single.
C
          IF ( MM3 .GT. MS ) THEN
            NXB = MOD( MM3-1 , NL ) + 1
            MX4 = MCAT( 4 , NXB )
c          ELSE
c            READ ( ISF , REC=MM3 ) MX1 , MX2 , MX3 , MX4 , BX1 , BX2
               ENDIF
          M4 = MX4
          MX4 = NN
          M3 = MM3
          IF ( MM3 .GT. MS ) THEN
            MCAT( 4 , NXB ) = MX4
c          ELSE
c            WRITE ( ISF , REC=MM3 ) MX1, MX2, MX3, MX4, BX1, BX2
               ENDIF
          MR = 1
      ELSE IF ( M3 .NE. 0 .AND. MM3 .EQ. 0 ) THEN
C
C ******          Detection is single, neighbour is multiple.
C
          MM3 = M3
          MX4 = M4
          MXX4 = M4
          IF ( M4 .EQ. 0 ) THEN
            M4 = M
            MR = 1
          ENDIF
   10          CONTINUE
          IF ( MXX4 .GT. MS ) THEN
            NXB = MOD ( MXX4-1 , NL ) + 1
            MX4 = MCAT(4,NXB)
c          ELSE IF ( MXX4 .GT. 0 ) THEN
c            READ ( ISF , REC=MXX4 ) MX1, MX2, MX3, MX4, BX1, BX2       
          ENDIF
          IF ( MX4 .NE. 0 ) THEN
            MXX4 = MX4
            GOTO 10
          ENDIF
          MX4 = M
          IF ( MXX4 .GT. MS ) THEN
            NXB = MOD( MXX4-1 , NL ) + 1
            MCAT(4,NXB) = MX4
c          ELSE IF ( MXX4 .GT. 0 ) THEN
c            WRITE ( ISF , REC=MXX4 ) MX1, MX2, MX3, MX4, BX1, BX2
          ENDIF
      ELSE IF ( M3 .NE. 0 .AND. MM3 .NE. 0 .AND. M3 .NE. MM3 ) THEN
C
C ******            Detection is multiple, neighbour is multiple.
C ******            They belong to different objects.
C
          MY3 = MM3
          IF ( MY3 .GT. MS ) THEN
            NXB = MOD( MY3-1 , NL ) + 1
            MY4 = MCAT( 4 , NXB )
c          ELSE
c            READ ( ISF , REC=MY3 ) MY1, MY2, MY3, MY4, BY1, BY2
          ENDIF
          MYY4 = MY4
          MX3 = M3
          IF ( MX3 .GT. MS ) THEN
            NXB = MOD( MX3-1 , NL ) + 1
            MX4 = MCAT( 4 , NXB )
c          ELSE
c            READ ( ISF , REC=MX3 ) MX1, MX2, MX3, MX4, BX1, BX2
          ENDIF
          MY4 = MX3
          MX3 = MY3
          IF ( MY3 . GT. MS ) THEN
            NXB = MOD( MY3-1 , NL ) + 1
            MCAT( 4 , NXB ) = MY4
c          ELSE
c            WRITE ( ISF , REC=MY3 ) MY1, MY2, MY3, MY4, BY1, BY2
          ENDIF
          IF ( MY4 .GT. MS ) THEN
            NXB = MOD( MY4-1 , NL ) + 1
            MCAT ( 3 , NXB ) = MX3
c          ELSE
c            WRITE ( ISF , REC=MY4 ) MX1, MX2, MX3, MX4, BX1, BX2
          ENDIF
          MXX4 = MX4
  20          CONTINUE
            IF ( MXX4 .GT. MS ) THEN
            NXB = MOD ( MXX4-1 , NL ) + 1
            MX4 = MCAT( 4 , NXB )
c          ELSE IF ( MXX4 .GT. 0 ) THEN
c            READ ( ISF , REC=MXX4 ) MX1, MX2, MX3, MX4, BX1, BX2
          ENDIF
          IF ( MX4 .NE. 0 ) THEN
            MX3 = MY3
            IF ( MXX4 .GT. MS ) THEN
                NXB = MOD( MXX4-1 , NL ) + 1
                MCAT( 3 , NXB ) = MX3
c            ELSE
c                READ ( ISF , REC=MXX4 ) MX1,MX2,MX3,MX4,BX1,BX2
                 ENDIF
            MXX4 = MX4
            GOTO 20
          ENDIF
          MX3 = MY3
          MX4 = MYY4
          IF ( MXX4 .GT. MS ) THEN
            NXB = MOD( MXX4-1 , NL ) + 1
            MCAT(3,NXB) = MX3
            MCAT(4,NXB) = MX4
c          ELSE IF ( MXX4 .GT. 0 ) THEN
c            WRITE ( ISF , REC=MXX4 ) MX1, MX2, MX3, MX4, BX1, BX2
          ENDIF
      ENDIF
      IF ( MR .EQ. 1 ) THEN
          IF ( NN .GT. MS ) THEN
            NXB = MOD( NN-1 , NL ) + 1
            MCAT(3,NXB) = M3
            MCAT(4,NXB) = M4
c          ELSE
c            WRITE ( ISF , REC=NN ) M1 , M2 , M3 , M4 , B1 , B2
          ENDIF
      ENDIF
      MCAT(3,MB) = MM3
C
      RETURN
C
      END

C @(#)dto.for	19.1 (ES0-DMD) 02/25/03 13:59:58
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C.IDENTIFICATION:
C  subroutine DTO               version 1.00   840614
C  R.M. van Hees                ESO - Garching
C
C.KEYWORDS:
C  High level image display interfaces
C
C.PURPOSE:
C  Takes care of opening and closing of display devices
C
C.ALGORITHM:
C  updates display keywords and display common blocks
C  calls high level C display interfaces 
C
C.COMMENTS
C  holds DTOPEN, DTCLOS, DTGICH and DTPICH
C
C.VERSIONS
C  1.00       Taken from DAZSUBS.FOR, author K.Banse
C--------------------------------------------------------------------------
C
C
C ++++++++++++++++++++++++++++++
C.IDENTIFIER  DTOPEN
C.PURPOSE
C  connect to IDI device + save info display common blocks IDIDEV & IDIMEM
C
C.INPUT/OUTPUT
C  call as   DTOPEN(FLAG,STAT)
C
C  input par:
C     FLAG:        integer	1 for display window
C                               2 for graphics window
C                               3 for zoom window (display)
C  output par:
C  STAT: 	integer		return status: 
C				0   if o.k. - no change in window size
C                               1   if o.k. - yes, a change in window size
C                              -1   if error
C ------------------------------
C
      SUBROUTINE DTOPEN(FLAG,STAT)
C
      IMPLICIT NONE
C
      INTEGER FLAG,STAT
      INTEGER IAV
      INTEGER UNIT(1),NULLO
C
      INCLUDE  'MID_INCLUDE:IDIDEV.INC'
      INCLUDE  'MID_INCLUDE:IDIMEM.INC'
C 
      CALL DAZOPN(FLAG)
C 
      CALL STKRDI('IDIDEV',1,26,IAV,DZDEV,UNIT,NULLO,STAT)
      CALL STKRDI('IDIMEMI',1,17,IAV,DZMEMI,UNIT,NULLO,STAT)
      RETURN
C 
      END

C
C ++++++++++++++++++++++++++++++
C.IDENTIFIER  DTCLOS
C.PURPOSE
C  close display & save display common blocks
C
C.INPUT/OUTPUT
C  call as   DTCLOS(DISPNO)
C
C  input par:
C  DISPNO:      integer         display number
C
C ------------------------------
C
      SUBROUTINE DTCLOS(DISPNO)
C 
      IMPLICIT NONE
C
      INTEGER DISPNO,STAT
      INTEGER UNIT(1)
C
      INCLUDE  'MID_INCLUDE:IDIDEV.INC'
C 
      CALL DAZCLO(DISPNO)
C
      CALL STKWRI('IDIDEV',DZDEV,1,26,UNIT,STAT)
      RETURN
C 
      END

C
C ++++++++++++++++++++++++++++++
C.IDENTIFIER  DTGICH
C.PURPOSE
C  return info about given channel in the image display
C
C.INPUT/OUTPUT
C  call as   DTGICH(DSPLAY,CHANL,NAME,RBUF,STAT)
C
C  input par:
C  DSPLAY: 	integer		image display device no.
C  CHANL: 	integer		image display channel no. (0,1,...)
C 
C  output par:
C  NAME: 	char. string 	name of frame currently loaded into channel
C  RBUF: 	real array	real info related to channel, 
C                               (8 elements long)
C  STAT: 	integer		return status: 
C				0 = o.k.
C				1 = nothing loaded into channel
C
C ------------------------------
C
      SUBROUTINE DTGICH(DSPLAY,CHANL,NAME,RBUF,STAT)
C
      IMPLICIT NONE
C
      INTEGER IAV,DSPLAY,CHANL,STAT
      INTEGER RLEN,ILEN,CLEN
      INTEGER UNIT(1),NULLO
C
      CHARACTER*(*) NAME
      CHARACTER WORK*60
C 
      REAL  RBUF(*)
C
      INCLUDE  'MID_INCLUDE:IDIDEV.INC'
      INCLUDE  'MID_INCLUDE:IDIMEM.INC'
C 
      DATA  RLEN /8/                        !float length per channel
      DATA  CLEN /60/                       !char. length per channel
      DATA  ILEN /17/                       !integer length per channel
C
      CALL DAZGII(CHANL)
C 
C  move from keywords to COMMON + Parameter arrays
C 
      CALL STKRDC('IDIMEMC',1,1,CLEN,IAV,WORK,UNIT,NULLO,STAT)
      CALL STKRDI('IDIMEMI',1,ILEN,IAV,DZMEMI,UNIT,NULLO,STAT)
      CALL STKRDR('IDIMEMR',1,RLEN,IAV,RBUF,UNIT,NULLO,STAT)
C 
      NAME(1:) = WORK(1:CLEN)//' '
      IF (NAME(1:1).EQ.' ') THEN
         STAT = 1                          !indicate, that there is no image
      ELSE
         STAT = 0
      ENDIF
C 
      RETURN
      END

C
C ++++++++++++++++++++++++++++++
C.IDENTIFIER  DTPICH
C.PURPOSE
C  store info about given channel in the relevant keywords
C
C.INPUT/OUTPUT
C  call as   DTPICH(DSPLAY,CHANL,NAME,RBUF,STAT)
C
C  input par:
C  DSPLAY: 	integer		image display device no.
C  CHANL: 	integer		image display channel no. (0,1,...)
C  NAME: 	char. string 	name of frame currently loaded into channel
C  RBUF: 	real array	real info related to channel, 
C                               (8 elements long)
C
C  output par:
C  STAT: 	integer		return status: 0 = o.k., 
C                                              else something wrong...
C
C ------------------------------
C
      SUBROUTINE DTPICH(DSPLAY,CHANL,NAME,RBUF,STAT)
C
      IMPLICIT NONE
C
      INTEGER DSPLAY,CHANL,STAT
      INTEGER RLEN,ILEN,CLEN
      INTEGER UNIT(1)
C
      CHARACTER*(*) NAME
      CHARACTER WORK*60
C
      REAL  RBUF(*)
C
      INCLUDE  'MID_INCLUDE:IDIDEV.INC'
      INCLUDE  'MID_INCLUDE:IDIMEM.INC'
C
      DATA  RLEN /8/                        !float length per channel
      DATA  CLEN /60/                       !char. length per channel
      DATA  ILEN /17/                       !integer length per channel
C
C  store name of loaded frame 
      WORK(1:) = NAME(1:)//' '
      CALL STKWRC('IDIMEMC',1,WORK,1,CLEN,UNIT,STAT) 
      CALL STKWRI('IDIMEMI',DZMEMI,1,ILEN,UNIT,STAT)
      CALL STKWRR('IDIMEMR',RBUF,1,RLEN,UNIT,STAT)
C
      CALL DAZPII(CHANL)
C 
      STAT   = 0
      RETURN
      END

C @(#)addstr.for	19.1 (ES0-DMD) 02/25/03 13:28:45
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C  @(#)addstr.for	19.1  (ESO-IPG)  02/25/03  13:28:45
      SUBROUTINE ADDSTR(EPOCH,RA,DEC) 
c
c       Copyright (C) Andrew T. Young, 1990
c       Copyright (C) European Southern Observatory, 1992
C 
C  ASKS FOR NEW STAR POSITION FROM KEYBOARD.     2 JAN.'87
C 
C 
      IMPLICIT NONE
C 
C 
      REAL EPOCH, RA, DEC, DEG10, DEGRAD, PI
C 
      INTEGER N1,N2
C 
      EXTERNAL DEG10, DEG2MS
      EXTERNAL HELP,ASKN,TV
C 
      LOGICAL HELP
      CHARACTER STRING*32, DEG2MS*13, A*1 
      CHARACTER*38 BIGSTR
      DATA DEGRAD/0.017453292519943/, PI/3.1415926535898/ 
      DATA BIGSTR/'                                      '/
C 
C     *****  BEGIN  *****
C 
    1 CALL TV('Enter coordinates:') 
      CALL TV('    h  m  s      o  ''  "  Epoch')
C                11 22 34.56 -12 34 56.7  1985.25 
      CALL ASKN('?',STRING)
       IF(HELP(STRING))THEN 
          CALL TV('   Omit Epoch if current date.')
          GO TO 1 
       END IF 
      RA=DEG10(STRING(:12))*PI/12.
      N1=INDEX(STRING,'(')
      IF (N1.NE.0) STRING(N1:N1)=' '
      DEC=DEG10(STRING(13:24))*DEGRAD 
      IF (N1.EQ.0) THEN
         N1=24
         N2=33
      ELSE
         N2=INDEX(STRING,')')
         IF (N2.EQ.0) N2=33
      END IF
      READ(STRING(N1+1:N2-1),'(BN,F7.0)',ERR=1)EPOCH
C   Verify. 
      CALL TV('Please verify:')
      CALL TVN('    h  m  s      o  ''  "   EPOCH')
      BIGSTR(2:15)=DEG2MS(RA*12./PI) 
      BIGSTR(15:27)=DEG2MS(DEC/DEGRAD)
      IF(EPOCH.NE.0.) WRITE(BIGSTR(27:),'(F7.2)')EPOCH
      BIGSTR(36:)='OK?'
      CALL ASKN(BIGSTR,A)
      IF(A.EQ.'N') GO TO 1
      RETURN
      END 

C @(#)round.for	19.1 (ES0-DMD) 02/25/03 13:28:48
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C  @(#)round.for	19.1  (ESO-IPG)  02/25/03  13:28:48
      SUBROUTINE ROUND(XMIN,XMAX,NCELLS,DELTA,INT,SCALE)
C
C       Copyright (C) Andrew T. Young, 1990
C
C                           SPACING IN (X , CELLS)
C
C  PICKS ROUND NUMBERS FOR GRAPH LIMITS.            23 AUG 1985
C
C
      IMPLICIT NONE
C
      INTEGER NCELLS, INT, INTS, LOGS, I
      REAL XMIN, XMAX, DELTA, SCALE, RECIPS, DELS, RANGE, FNM1, PEAK,
     1         WIDTH, FULL, BOT, TOP
C
      DIMENSION RECIPS(10),INTS(10),DELS(10)
        INTEGER*4 MINTIC
C
      DATA RECIPS/5.,4.,3.,2.5,2.,1.5,1.2,1.,.8,.6/
C                                                      CELLS/UNIT.
      DATA INTS / 5, 4, 3,  5, 4,  3,  6, 5,  4, 3/
C                                                      CELLS/TICK.
      DATA DELS / 1.,1.,1., 2.,2., 2., 5.,5., 5.,5./
C                                                      UNITS/TICK.
C
      RANGE=XMAX-XMIN
      FNM1=NCELLS-1
C   IS ZERO INCLUDED?
      IF(XMIN*XMAX.LE.0.) GO TO 20
C  NO.  SHOULD IT BE?
      IF(RANGE.LT.0.) GO TO 6
C
C  HERE FOR NORMAL PLOT.
      IF(XMIN.GT.0.) GO TO 3
C    ZERO AT TOP, ALL NEG.VALUES.
      IF(XMAX/XMIN.GT.0.2) GO TO 20
    2 XMAX=0.
      GO TO 5
C    ZERO AT BOTTOM; NORMAL (ALL +.)
    3 IF(XMAX/XMIN.LT.5.) GO TO 20
    4 XMIN=0.
    5 RANGE=XMAX-XMIN
      GO TO 20
C
C  INVERTED PLOT.
    6 IF(XMIN.GT.0.) GO TO 8
C    ALL NEG.,ZERO AT BOTTOM.
      IF(XMAX/XMIN.GT.5.) GO TO 4
      GO TO 20
C    ALL +, ZERO AT TOP.
    8 IF(XMAX/XMIN.LT.0.2) GO TO 2
C
C  FIND SCALING.
C
   20 LOGS=LOG10(ABS(RANGE)/FNM1)-98.3
C    ENSURE MULTIPLES .GT.1
      SCALE=10.**(LOGS+98)
   21 PEAK=ABS(RANGE)/SCALE
C    PEAK IS RANGE IN SCALE UNITS.
      WIDTH=PEAK/FNM1
C    WIDTH OF ONE CELL.
      DO 22 I=1,10
      IF(RECIPS(I)*WIDTH.LE.1.) GO TO 25
   22 CONTINUE
   23 SCALE=SCALE*10.
      GO TO 21
C
   25 DELTA=SIGN(DELS(I),RANGE)
      INT=INTS(I)
      FULL=FNM1/RECIPS(I)
C    FULL IS IN SCALE UNITS.
C
C  TEST BOTH ENDS FOR CLEARANCE.
C
      MINTIC=XMIN/(SCALE*DELS(I)) + 1.D8
      MINTIC=MINTIC-100000000
      IF(RANGE.LT.0. .AND. MINTIC*DELS(I)*SCALE.NE.XMIN)MINTIC=MINTIC+1
      BOT=(MINTIC)*DELS(I)
      IF((RANGE.GT.0. .AND. BOT.LE.XMIN/SCALE) .OR.
     1 (RANGE.LT.0. .AND. BOT.GE.XMIN/SCALE)) GO TO 28
C    NEEDS MORE ROOM...
   27 I=I+1
      IF(I-10) 25,25,23
C
C  CHECK TOP.
C
   28  IF(RANGE.GT.0.)THEN
      TOP=FULL+BOT
      IF(TOP.LT.XMAX/SCALE) GO TO 27
       ELSE
      TOP=BOT-FULL
      IF(TOP.GT.XMAX/SCALE) GO TO 27
       END IF
      XMAX=TOP*SCALE
      XMIN=BOT*SCALE
      RETURN
C
      END

C @(#)objmng.for	19.1 (ES0-DMD) 02/25/03 13:25:36
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine OBJMNG         version 1         820520
C  A. Kruszewski             ESO Garching
C  modified by               version 2         830905
C  Ch. Ounnas                ESO - Garching
C  modified to FX            version 2.1       870219
C  A. Kruszewski             Obs. de Geneve
C.PURPOSE
C  writes data into arrays NCAT and ACAT
C.INPUT/OUTPUT
C  input arguments
C  A           real*4 array      image frame
C  NPIX        integer*4 array   dimensions of an array "A"
C  ACAT        real*4 array      real parameters of detected objects
C  ICAT        integer*4 array   array holding positions of independent
C                                detections of the same object
C  M           integer*4         identification number of considered
C                                object
C  INN         integer*4         number of independent detections
C                                of the same object
C  IAV         integer*4         average X-coordinate in pixels
C  JAV         integer*4         average Y-coordinate in pixels
C  BGRD        real*4            average background
C  output arguments
C  ACAT        real*4 array      real parameters of detected objects
C  MM          integer*4         new identification number of an object
C-----------------------------------------------------------------------
C
      SUBROUTINE OBJMNG ( A , JAPY , IBUF , ACAT , NC ,
     &                    MM , MMB , IAV , JAV , BGRD ,
     &                    TRSH , GCUT , MINCR )
C
      IMPLICIT     NONE
      INTEGER      NC, ISTAT
      INTEGER      IARG , IAV , IBUF(4)
C     INTEGER      ITF
      INTEGER      JAPY(1) , JAV , JOF , JOFF
      INTEGER      K , L , MINCR , MM , MMB
      REAL         A(1) , ACAT(5,NC) , BGRD , TMP , TRLM , TRSH , GCUT
      CHARACTER*80 TEXT
C
      JOFF = IBUF(2) - 1
      IF ( MMB .EQ. NC ) THEN
          WRITE (TEXT,'(A)') 'Too many objects'
          CALL STTPUT(TEXT,ISTAT)
c          CALL CTLG( ITF , START , STEP , ACAT , NC , MM , MMB )
c          MMB = 0
      ENDIF
      MMB = MMB + 1
      MM = MM + 1
      ACAT(1,MMB) = FLOAT( IAV )
      ACAT(2,MMB) = FLOAT( JAV )
      ACAT(3,MMB) = BGRD
      JOF = JAV - JOFF
      IF ( JOF .LT. 2 ) THEN
          JOF = 2
      ENDIF
      TMP = 0.0
      DO 10 L = -1 , 1
          IARG = JAPY(JOF+L) + IAV
          DO 20 K = -1 , 1
            TMP = TMP + A(IARG+K)
   20          CONTINUE
   10      CONTINUE
        ACAT(4,MMB) = TMP / 9.0
      TRLM = BGRD + TRSH
      IF ( ACAT(4,MMB) .LE. TRLM ) THEN
          MMB = MMB - 1
          MM = MM - 1
      ELSE
          CALL RADDET( A , JAPY , IBUF , IAV , JAV ,
     &                 MINCR , TRLM , ACAT(4,MMB) , TRSH , ACAT(5,MMB) )
          IF ( ACAT(5,MMB) .LE. 0.0 .AND. ACAT(4,MMB) .LT. GCUT ) THEN
            MMB = MMB - 1
            MM = MM - 1
          ENDIF
      ENDIF
C
      RETURN
C
      END
C

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
       PROGRAM OPTOP
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION: program OPTOP 
C.PURPOSE: to provide X and Y coordinates for plates to be used at the
C          Cassegrain focus of the 3.6mt telescope.
C.AUTHOR:  A. Gemmo         Padova Department of Astronomy
C.VERSION: 861101 G. Lund       Creation 
C          900625 S. Cristiani  Last update on HP machine
C          910301 A. Gemmo      New portable version running in MIDAS env.
C          910524 A. Gemmo      Modified for OPTOPUS context.
C          910717 A. Gemmo      Modified to handle "-00" in coordinates
C                               of the center. DEC read as a string.  
C 
C 100616	last modif
C------------------------------------------------------------------------------
       IMPLICIT NONE
C
C ***
C
       INTEGER		MADRID(1)
       INTEGER		NRINP
       INTEGER		NCINP
       INTEGER		NROUT
       INTEGER		NCOUT
       PARAMETER	(NCINP=7)
       PARAMETER	(NCOUT=9)
       PARAMETER        (NROUT=300)
       INTEGER		ISTAT,IAC,IAV
       INTEGER		LFIEL1,LFIEL2,LFIEL3,LFIEL4
       INTEGER          LFIEL5,LFIEL6,LFIEL7
       INTEGER          TYP1,TYP2,TYP3,TYP4
       INTEGER          TYP5,TYP6,TYP7
       INTEGER		KUN,KNUL
       INTEGER		NACINP,NARINP,NSINP
       INTEGER		OUTTYP,OUTCOL(10),COLNUM(10),CN(10)
       INTEGER		TIDINP
       INTEGER		TIDOUT
       INTEGER		NBIG
       INTEGER		I1,I7,I8,I9,I10,NCOL,II
       INTEGER       	I12,I13,I14,I15,I16,I17,I18,J4,J5,J7
       INTEGER          K1,K2,NCINP1,IND1,IND2,IND3
C
C ***  
C
       INTEGER		ICOUN0,ICOUN1,ICOUN2,ICOUN3
       INTEGER		FLAG(NROUT),FLAG1(NROUT),FLAG2(NROUT)
C
C ***
C
       REAL             CDEC(3)
C
C ***
C
       DOUBLE PRECISION		FRAD,SGSEP,BGSEP,OOSEP,OGSEP
       DOUBLE PRECISION		SCALFA,EXDGUI,EXDOBJ
       DOUBLE PRECISION 	XFAREA,YFAREA
       DOUBLE PRECISION         CRA(3),DCDEC(3),CRA1,CDEC1
       DOUBLE PRECISION		DRA(NROUT),DDEC(NROUT)
       DOUBLE PRECISION 	X(NROUT),Y(NROUT),Z(NROUT)
       DOUBLE PRECISION         PI  
       DOUBLE PRECISION		RARAD,DECRAD,CRARAD,CDECRA
       DOUBLE PRECISION 	DISTAN
       DOUBLE PRECISION         FAR1,FAR2  
       DOUBLE PRECISION		DBGUID,DSGUID
       DOUBLE PRECISION         XX(360),YY(360)
       DOUBLE PRECISION         RAXRAD(360),DECYRAD(360)
       DOUBLE PRECISION         RAX(360),DECY(360)
       DOUBLE PRECISION         XF(4),YF(4),XFRAD(4),YFRAD(4)
       DOUBLE PRECISION         FX(4),FY(4)
       DOUBLE PRECISION         EQUI0,EQUI1,PCRARA,PCDECR
       DOUBLE PRECISION         PCRA,PCDEC
C
C ***
       CHARACTER*80	STRING(25)
       CHARACTER*60	INPFIL
       CHARACTER*60	OUTFIL
       CHARACTER*16	ILAB(NCINP),RLAB(NCINP),OUTLAB
       CHARACTER*16	OUTUNI
       CHARACTER*16	OUTFOR
       CHARACTER*8      FORM
       CHARACTER*16     FORMC16,FORMC1,FORMR8
       CHARACTER*16     IDENT(NROUT)
       CHARACTER*1      TYPE(NROUT)
       CHARACTER*1      CHECK(NROUT)
       CHARACTER*80     CDECCH
       CHARACTER*80     DECCHA(3)
       CHARACTER*1      SIGN,ACFLAG,PFLAG
       CHARACTER      CTEST*16
C
C ***
       LOGICAL          NULL
C
C ***
       INCLUDE          'MID_INCLUDE:TABLES.INC'
       COMMON		/VMR/ MADRID
       INCLUDE          'MID_INCLUDE:TABLED.INC'
C
C ***
       DATA 	ILAB/'IDENT   ','TYPE    ','CHECK   ',
     2               'OLDRA   ','OLDDEC  ','RA      ','DEC     '/
C
C ***
C
       DATA    FORMC16/'A16'/
       DATA    FORMC1 /'A1'/
       DATA    FORMR8 /'F7.0'/
       DATA    PI/3.14159265358979D0/
       DATA    ICOUN0,ICOUN1,ICOUN2,ICOUN3/0,0,0,0/
       DATA    DBGUID,DSGUID/0.0D0,0.0D0/
       DATA    FX/-20010.,-20010.,20010.,20010./
       DATA    FY/137000.,118100.,118100.,137000./
       DATA    SIGN/'+'/
C
C *** start definition of constraints of starplates
C
       DATA	FRAD   /1.37D5/  !radius of the field                (microns)
       DATA	SGSEP  /3.45D3/  !min. sep. between small guidestars (microns)
       DATA	BGSEP  /1.25D4/  !min. sep. between big guidestars   (microns)
       DATA	NBIG   /2/       !number of big guidestars
       DATA	OOSEP  /3.45D3/  !min. object-object separation      (microns)
       DATA	OGSEP  /9.00D3/  !min. object-guidestar separation   (microns)
       DATA 	SCALFA /1.56D-7/ !scal. fact. for depth of the holes (microns)
       DATA	EXDGUI /-6.00D2/ !extra-depth for guidestars         (microns)
       DATA     EXDOBJ /-1.49D3/ !extra-depth for objects            (microns)
       DATA	XFAREA /2.001D4/ !half X-dimension of forbidden area (microns)
       DATA	YFAREA /1.890D4/ !Y-dimension of forbidden area      (microns)
C
C *** start the code
C
         CALL STSPRO('OPTOP')
C
       DO II=1,NROUT
          FLAG (II) = 0
          FLAG1(II) = 0
          FLAG2(II) = 0
       ENDDO
C
C *** get the input table and the output table
C
       CALL STKRDC('INPUTFI',1,1,60,IAC,INPFIL,KUN,KNUL,ISTAT)
       CALL STKRDC('OUTPUTF',1,1,60,IAC,OUTFIL,KUN,KNUL,ISTAT)
C
C *** open input table
C
       CALL TBTOPN(INPFIL,F_I_MODE,TIDINP,ISTAT)
C
C *** get information about the input table
C
       CALL TBIGET(TIDINP,NCOL,NRINP,NSINP,NACINP,NARINP,ISTAT)
       IF(NRINP.EQ.0)THEN      !no rows in table
         STRING(1) = '*** FATAL: There are no data in the input TABLE'
         CALL STETER(9,STRING(1))
       ENDIF
C
       CALL TBLSER(TIDINP,'IDENT',COLNUM(1),ISTAT)
       CALL TBLSER(TIDINP,'TYPE',COLNUM(2),ISTAT)
       CALL TBLSER(TIDINP,'CHECK',COLNUM(3),ISTAT)
       CALL TBLSER(TIDINP,'OLDRA',COLNUM(4),ISTAT)
       CALL TBLSER(TIDINP,'OLDDEC',COLNUM(5),ISTAT)
       CALL TBLSER(TIDINP,'RA',COLNUM(6),ISTAT)
       CALL TBLSER(TIDINP,'DEC',COLNUM(7),ISTAT)
C
       DO I1=1,NCINP
         IF(COLNUM(I1).GE.1)THEN
           CALL TBLGET(TIDINP,COLNUM(I1),RLAB(I1),ISTAT)
         ELSE
           GOTO 1902
         ENDIF
         IF(RLAB(I1).NE.ILAB(I1))THEN   
            STRING(2) = '*** FATAL: Wrong column label'
           CALL STETER(9,STRING(2))
         ENDIF
1902   ENDDO
C
       IF (COLNUM(1).GE.1)THEN
          CALL TBFGET(TIDINP,COLNUM(1),FORM,LFIEL1,TYP1,ISTAT)
          IF (TYP1.NE.D_C_FORMAT)THEN
             STRING(3) = '*** FATAL: Wrong `IDENT` column format'
             CALL STETER(9,STRING(3))
          ENDIF   
       ENDIF

       IF (COLNUM(2).GE.1)THEN
          CALL TBFGET(TIDINP,COLNUM(2),FORM,LFIEL2,TYP2,ISTAT)
          IF (TYP2.NE.D_C_FORMAT)THEN
             STRING(4) = '*** FATAL: Wrong `TYPE` column format'
             CALL STETER(9,STRING(4))
          ENDIF
       ENDIF

       IF (COLNUM(3).GE.1)THEN
          CALL TBFGET(TIDINP,COLNUM(3),FORM,LFIEL3,TYP3,ISTAT)
          IF (TYP3.NE.D_C_FORMAT)THEN
             STRING(5) = '*** FATAL: Wrong `CHECK` column format'
             CALL STETER(9,STRING(5))
          ENDIF
       ENDIF

       IF (COLNUM(4).GE.1)THEN
          CALL TBFGET(TIDINP,COLNUM(4),FORM,LFIEL4,TYP4,ISTAT)
          IF (TYP4.NE.D_R8_FORMAT)THEN
             STRING(6) = '*** FATAL: Wrong `OLDRA` column format'
             CALL STETER(9,STRING(6))
          ENDIF
       ENDIF

       IF (COLNUM(5).GE.1)THEN
          CALL TBFGET(TIDINP,COLNUM(5),FORM,LFIEL5,TYP5,ISTAT)
          IF (TYP5.NE.D_R8_FORMAT)THEN
            STRING(7) = '*** FATAL: Wrong `OLDDEC` column format'
            CALL STETER(9,STRING(7))	  
          ENDIF
       ENDIF

       IF (COLNUM(6).GE.1)THEN
          CALL TBFGET(TIDINP,COLNUM(6),FORM,LFIEL6,TYP6,ISTAT)
          IF (TYP6.NE.D_R8_FORMAT)THEN
             STRING(8) = '*** FATAL: `RA` column format'
             CALL STETER(9,STRING(8))	  
          ENDIF
       ENDIF

       IF (COLNUM(7).GE.1)THEN
          CALL TBFGET(TIDINP,COLNUM(7),FORM,LFIEL7,TYP7,ISTAT)
          IF (TYP7.NE.D_R8_FORMAT)THEN
             STRING(9) = '*** FATAL: Wrong `DEC` column format'
             CALL STETER(9,STRING(9))	  
          ENDIF
       ENDIF
C
C *** create the output table
C
       CALL TBTINI(OUTFIL,0,F_O_MODE,NCOUT,NROUT,TIDOUT,ISTAT)
C
       OUTTYP = TYP1     !initialize ident column
       OUTFOR = FORMC16
       OUTUNI = '        '
       OUTLAB = 'IDENT   '
       CALL TBCINI(TIDOUT,OUTTYP,16,OUTFOR,OUTUNI,
     2                     OUTLAB,OUTCOL(1),ISTAT)      
C
       OUTTYP = D_C_FORMAT    !initialize type column
       OUTFOR = FORMC1
       OUTUNI = '        '
       OUTLAB = 'TYPE    '
       CALL TBCINI(TIDOUT,OUTTYP,1,OUTFOR,OUTUNI,
     2                     OUTLAB,OUTCOL(2),ISTAT)
C
       OUTTYP = D_C_FORMAT    !initialize check column
       OUTFOR = FORMC1
       OUTUNI = '        '
       OUTLAB = 'CHECK   '
       CALL TBCINI(TIDOUT,OUTTYP,1,OUTFOR,OUTUNI,
     2                     OUTLAB,OUTCOL(3),ISTAT)
C
       OUTTYP = D_R8_FORMAT    !initialize x column
       OUTFOR = FORMR8
       OUTUNI = 'MICRONS'
       OUTLAB = 'X      '
       CALL TBCINI(TIDOUT,OUTTYP,1,OUTFOR,OUTUNI,
     2                     OUTLAB,OUTCOL(4),ISTAT)
C 
       OUTTYP = D_R8_FORMAT    !initialize y column
       OUTFOR = FORMR8
       OUTUNI = 'MICRONS'
       OUTLAB = 'Y      '
       CALL TBCINI(TIDOUT,OUTTYP,1,OUTFOR,OUTUNI,
     2                     OUTLAB,OUTCOL(5),ISTAT)
C
       OUTTYP = D_R8_FORMAT    !initialize z column
       OUTFOR = FORMR8
       OUTUNI = 'MICRONS'
       OUTLAB = 'Z      '
       CALL TBCINI(TIDOUT,OUTTYP,1,OUTFOR,OUTUNI,
     2                     OUTLAB,OUTCOL(6),ISTAT)
C
C *** read center coordinates (if present)
C
       CALL STKRDD('PLATECEN',1,1,IAV,CRA(1),KUN,KNUL,ISTAT)
       CALL STKRDD('PLATECEN',2,1,IAV,CRA(2),KUN,KNUL,ISTAT)
       CALL STKRDD('PLATECEN',3,1,IAV,CRA(3),KUN,KNUL,ISTAT)
       CALL STKRDC('ACFLAG',1,1,1,IAC,ACFLAG,KUN,KNUL,ISTAT)
       IF(ACFLAG.EQ.'Y'.OR.ACFLAG.EQ.'y')THEN
         CALL STKRDD('PLATECEN',4,1,IAV,DCDEC(1),KUN,KNUL,ISTAT)
         CALL STKRDD('PLATECEN',5,1,IAV,DCDEC(2),KUN,KNUL,ISTAT)
         CALL STKRDD('PLATECEN',6,1,IAV,DCDEC(3),KUN,KNUL,ISTAT)
         GOTO 8888
       ELSE IF(ACFLAG.EQ.'N'.OR.ACFLAG.EQ.'n')THEN
         CALL STKRDC('PLATECHA',1,1,80,IAV,CDECCH,KUN,KNUL,ISTAT)
       ENDIF
C
       IND1 = INDEX(CDECCH,',')
       IND2 = INDEX(CDECCH(IND1+1:80),',') + IND1
       DECCHA(1) = CDECCH(1:IND1-1)
       IND3 = INDEX(CDECCH,'-')
       DECCHA(2) = CDECCH(IND1+1:IND2-1)
       DECCHA(3) = CDECCH(IND2+1:80)
C
C *** decode character DECCHA to real array
C
      CALL USRINP(CDEC(1),80,'R',DECCHA(1))
      CALL USRINP(CDEC(2),80,'R',DECCHA(2))
      CALL USRINP(CDEC(3),80,'R',DECCHA(3))
C
C *** write decoded dec in keyword
C
      DCDEC(1) = DBLE(CDEC(1))
      DCDEC(2) = DBLE(CDEC(2))
      DCDEC(3) = DBLE(CDEC(3))
C
      IF(DCDEC(1).LT.-90..OR.DCDEC(1).GT.90.)THEN
        CALL STETER(ISTAT,'*** FATAL: Wrong DEC-degrees !!')
      ELSE IF(DCDEC(2).GT.60.)THEN
        CALL STETER(ISTAT,'*** FATAL: Wrong DEC-arcmin !!')
      ELSE IF(DCDEC(3).GT.60.)THEN
        CALL STETER(ISTAT,'*** FATAL: Wrong DEC-arcsec !!')
      ENDIF
C
      CALL STKWRD('PLATECEN',DCDEC(1),4,1,KUN,ISTAT)
      CALL STKWRD('PLATECEN',DCDEC(2),5,1,KUN,ISTAT)
      CALL STKWRD('PLATECEN',DCDEC(3),6,1,KUN,ISTAT)
C
C *** convert RA and DEC to decimal format
C
8888  CRA1 = CRA(1)+CRA(2)/60.+CRA(3)/3600.
      IF(DCDEC(1).LT.0..OR.
     1    DCDEC(2).LT.0..OR.
     2    DCDEC(3).LT.0..OR.
     3    IND3.NE.0) THEN
       SIGN(1:1) = '-'
       DCDEC(1) = DABS(DCDEC(1))
       DCDEC(2) = DABS(DCDEC(2))
       DCDEC(3) = DABS(DCDEC(3))
      ENDIF 
       CDEC1 = DCDEC(1)+DCDEC(2)/60.+DCDEC(3)/3600.
       IF(SIGN(1:1).EQ.'-')CDEC1 = -CDEC1
C  
C *** do the work
C
C
C *** start computation of X and Y positions
C
       DO I7=1,NRINP      !read in table elements
          CALL TBERDC(TIDINP,I7,COLNUM(1),CTEST,KNUL,ISTAT)
          CALL FT_EOS(CTEST,16,IDENT(I7),ISTAT)      !get clean Foprtran string
          CALL TBERDC(TIDINP,I7,COLNUM(2),CTEST,KNUL,ISTAT)
          TYPE(I7) = CTEST(1:1)
C
C *** convert TYPE to uppercase
C
          IF(TYPE(I7).EQ.'o')TYPE(I7) = 'O'
          IF(TYPE(I7).EQ.'s')TYPE(I7) = 'S'
          IF(TYPE(I7).EQ.'b')TYPE(I7) = 'B'
C
          CALL TBERDD(TIDINP,I7,COLNUM(6),DRA(I7),KNUL,ISTAT)
          CALL TBERDD(TIDINP,I7,COLNUM(7),DDEC(I7),KNUL,ISTAT)
       ENDDO
C
C *** convert center RA and DEC to radians
C
       CRARAD     = CRA1*1.5D1*(PI/1.8D2)
       CDECRA     = CDEC1*(PI/1.8D2)
C
C *** precess center coordinates
C
       CALL STKRDC('PFLAG',1,1,1,IAC,PFLAG,KUN,KNUL,ISTAT)
       CALL STKRDD('EQUINOX',1,1,IAC,EQUI0,KUN,KNUL,ISTAT)
       CALL STKRDD('EQUINOX',2,1,IAC,EQUI1,KUN,KNUL,ISTAT)
C
       IF(PFLAG.EQ.'N'.OR.PFLAG.EQ.'n')THEN
         CALL STTPUT('     ',ISTAT)
      CALL STTPUT('No precession applied to center coordinates',
     1ISTAT)
         CALL STTPUT('     ',ISTAT)
         PCRARA = CRARAD
         PCDECR = CDECRA
       ELSE IF(PFLAG.EQ.'Y'.OR.PFLAG.EQ.'y')THEN
         CALL PRE(CRARAD,CDECRA,PCRARA,PCDECR,EQUI0,EQUI1)
       ENDIF
C
C *** convert precessed RA and DEC to hours and degrees
C
       PCRA = PCRARA*(1.8D2/PI)/1.5D1
       PCDEC = PCDECR*(1.8D2/PI)
       CALL STKWRD('PLATEC1',PCRA,1,1,KUN,ISTAT)
       CALL STKWRD('PLATEC1',PCDEC,2,1,KUN,ISTAT)
C
C *** subroutine ADXY taken from Yanling Fang's astrometric package
C     (modified by A. Gemmo)
       DO J7=1,NRINP
          RARAD  = DRA(J7)*1.5D1*(PI/1.8D2)
          DECRAD  = DDEC(J7)*(PI/1.8D2)
          CALL ADXY(RARAD,DECRAD,PCRARA,PCDECR,X(J7),Y(J7))
       ENDDO
C
C *** fill in table elements
C
       DO J4=1,NRINP
           CALL TBEWRC(TIDOUT,J4,OUTCOL(1),IDENT(J4),ISTAT)
           CALL TBEWRC(TIDOUT,J4,OUTCOL(2),TYPE(J4),ISTAT)
           CALL TBEWRD(TIDOUT,J4,OUTCOL(4),X(J4),ISTAT)
           CALL TBEWRD(TIDOUT,J4,OUTCOL(5),Y(J4),ISTAT)
       ENDDO
C
C *** check maximum distance from the center
C       
       DO I8=1,NRINP
           DISTAN = DSQRT(X(I8)**2+Y(I8)**2)
           IF(DISTAN.GE.FRAD)THEN
            ICOUN1 = ICOUN1+1
            WRITE(STRING(7),222)IDENT(I8)
            WRITE(STRING(8),333)TYPE(I8),X(I8),Y(I8)
222    FORMAT(1X,'Object: ',A16)
333    FORMAT(1X,'Type: ',A1,',',' X = ',F10.0,' Y = ',F10.0,
     2                ' is too far from the center')
            CALL STTPUT(STRING(7),ISTAT)
            CALL STTPUT(STRING(8),ISTAT)
            CHECK(I8) = 'N'
          ENDIF
       ENDDO
       IF(ICOUN1.NE.0)THEN
         WRITE(STRING(9),444)ICOUN1,NRINP
444    FORMAT(1X,'You are going to loose',I3,' object(s) out of ',I3)
         CALL STTPUT(STRING(9),ISTAT)
         STRING(10)=' You can delete it/them or change the center positi
     2on'
          CALL STTPUT(STRING(10),ISTAT)
       ENDIF
C
C *** check if there is any object in the forbidden area
C
       FAR1 = XFAREA
       FAR2 = FRAD-YFAREA
       DO I9=1,NRINP
          IF(DABS(X(I9)).LE.FAR1.AND.Y(I9).GE.FAR2)THEN
            ICOUN2 = ICOUN2+1
            WRITE(STRING(11),555)IDENT(I9)
            WRITE(STRING(12),666)TYPE(I9),X(I9),Y(I9)
555    FORMAT(1X,'Object: ',A16)
666    FORMAT(1X,'Type: ',A1,',',' X = ',F10.0,' Y = ',F10.0,
     2                ' is in the forbidden area')
            CALL STTPUT(STRING(11),ISTAT)
            CALL STTPUT(STRING(12),ISTAT)
            CHECK(I9) = 'N'
          ENDIF
       ENDDO
       IF(ICOUN2.NE.0)THEN
          WRITE(STRING(13),777)ICOUN2
777    FORMAT(1X,I3,' object(s) is/are in the forbidden area')
          CALL STTPUT(STRING(13),ISTAT)
          WRITE(STRING(13),778)
778       FORMAT(1X,' You MUST delete it/them or change the center posit
     2ion')
          CALL STTPUT(STRING(13),ISTAT)
       ENDIF
C
C *** check the number of big guidestars 
C
       DO I10=1,NRINP
          IF(TYPE(I10).EQ.'B')THEN
            ICOUN3 = ICOUN3+1
          ENDIF
       ENDDO
       IF(ICOUN3.LT.NBIG)THEN
         STRING(14)= ' *** FATAL: Your `BIG` guidestars are not enough'
         CALL STETER(9,STRING(14))
       ENDIF
C
C *** check the reciprocal superpositions of big guidestars
C
       DO I12=1,NRINP
           IF(TYPE(I12).EQ.'B'.AND.FLAG(I12).EQ.0)THEN
               DO I13=1,NRINP
                IF(TYPE(I13).EQ.'B'.AND.I12.NE.I13.AND.
     2              FLAG(I13).EQ.0)THEN
                    DISTAN = DSQRT((X(I12)-X(I13))**2
     2                            +(Y(I12)-Y(I13))**2)
                    DBGUID = DMAX1(DBGUID,DISTAN)
                   IF(DISTAN.LT.BGSEP)THEN
       	              WRITE(STRING(16),888)IDENT(I12),IDENT(I13)
888    FORMAT(1X,' Big guidestars: ',A16,' and ',A16,' are too close')
                      CALL STTPUT(STRING(16),ISTAT)
                      CHECK(I12) = 'N'
                      CHECK(I13) = 'N'
                      FLAG(I12) = FLAG(I12)+1
                      FLAG(I13) = FLAG(I13)+1
                    ENDIF
       	         ELSE 
                    GOTO 1111
                 ENDIF
1111           ENDDO
            ELSE 
               GOTO 1112
            ENDIF
1112      ENDDO
C
C *** check the reciprocal superpositions of small guidestars and objects
C
       DO I14=1,NRINP
           IF(TYPE(I14).NE.'B'.AND.FLAG1(I14).EQ.0)THEN
               DO I15=1,NRINP
                  IF(TYPE(I15).NE.'B'.AND.I14.NE.I15.AND.
     2              FLAG1(I15).EQ.0)THEN
                    DISTAN = DSQRT((X(I14)-X(I15))**2
     2                            +(Y(I14)-Y(I15))**2)
                    DSGUID = DMAX1(DSGUID,DISTAN)
                    IF (DISTAN.LT.SGSEP)THEN
                      IF(TYPE(I14).EQ.'S'.AND.TYPE(I15).EQ.'S')THEN
                        WRITE(STRING(18),2222)IDENT(I14),IDENT(I15)
2222   FORMAT(1X,' Small guidestars: ',A16,' and ',A16,
     2           ' are too close')
                        CALL STTPUT(STRING(18),ISTAT)
                        CHECK(I14) = 'N'
                        CHECK(I15) = 'N'
                        FLAG1(I14) = FLAG1(I14)+1
                        FLAG1(I15) = FLAG1(I15)+1

       	              ELSE IF(TYPE(I14).EQ.'S'.AND.TYPE(I15).EQ.'O')THEN
                        WRITE(STRING(18),2223)IDENT(I14),IDENT(I15)
2223   FORMAT(1X,' Small guidestar: ',A16,' and object:', A16)
                        CALL STTPUT(STRING(18),ISTAT)
                        WRITE(STRING(18),3333)
3333   FORMAT(1X,' are too close')
                        CALL STTPUT(STRING(18),ISTAT)
                        CHECK(I14) = 'N'
                        CHECK(I15) = 'N'
                        FLAG1(I14) = FLAG1(I14)+1
                        FLAG1(I15) = FLAG1(I15)+1

                      ELSE IF(TYPE(I14).EQ.'O'.AND.TYPE(I15).EQ.'S')THEN
                        WRITE(STRING(18),2224)IDENT(I14),IDENT(I15)
2224   FORMAT(1X,' Object: ',A16,' and small guidestar:', A16)
                        CALL STTPUT(STRING(18),ISTAT)
                        WRITE(STRING(18),3334)
3334                    FORMAT(1X,' are too close')
                        CALL STTPUT(STRING(18),ISTAT)
                        CHECK(I14) = 'N'
                        CHECK(I15) = 'N'
       		        FLAG1(I14) = FLAG1(I14)+1
                        FLAG1(I15) = FLAG1(I15)+1

                      ELSE IF(TYPE(I14).EQ.'O'.AND.TYPE(I15).EQ.'O')THEN
                        WRITE(STRING(18),2225)IDENT(I14),IDENT(I15)
2225   FORMAT(1X,' Objects: ',A16,' and ',A16,' are too close')
                        CALL STTPUT(STRING(18),ISTAT)
                        CHECK(I14) = 'N'
                        CHECK(I15) = 'N'
                        FLAG1(I14) = FLAG1(I14)+1
                        FLAG1(I15) = FLAG1(I15)+1
                      ENDIF
                    ENDIF
       	         ELSE 
                    GOTO 1113
                 ENDIF
1113           ENDDO
            ELSE 
               GOTO 1114
            ENDIF
1114      ENDDO
C
C *** check the reciprocal superpositions of small and big guidestars
C
       DO I16=1,NRINP
           IF(TYPE(I16).EQ.'B'.AND.FLAG2(I16).EQ.0)THEN
               DO I17=1,NRINP
                  IF(TYPE(I17).NE.'B'.AND.I16.NE.I17.AND.
     2              FLAG2(I17).EQ.0)THEN
                    DISTAN = DSQRT((X(I16)-X(I17))**2
     2                            +(Y(I16)-Y(I17))**2)
                    DSGUID = DMAX1(DSGUID,DISTAN)
                   IF(DISTAN.LT.OGSEP)THEN
       	             IF (TYPE(I16).EQ.'B'.AND.TYPE(I17).EQ.'S')THEN
                        WRITE(STRING(20),4444)IDENT(I16),IDENT(I17)
4444   FORMAT(1X,' Big guidestar: ',A16, ' and small guidestar: ',A16)
                        CALL STTPUT(STRING(20),ISTAT)
                        WRITE(STRING(21),5555)
5555   FORMAT(1X,' are too close')
                        CALL STTPUT(STRING(21),ISTAT)
                        CHECK(I16) = 'N'
                        CHECK(I17) = 'N'

       	             ELSE IF(TYPE(I16).EQ.'B'.AND.TYPE(I17).EQ.'O')THEN
                        WRITE(STRING(20),4441)IDENT(I16),IDENT(I17)
4441   FORMAT(1X,' Big guidestar: ',A16,' and object: ',A16)
                        WRITE(STRING(21),5551)
5551   FORMAT(1X,' are too close')
                        CALL STTPUT(STRING(21),ISTAT)
                        CHECK(I16) = 'N'
                        CHECK(I17) = 'N'
                        FLAG2(I16) = FLAG2(I16)+1
                        FLAG2(I17) = FLAG2(I17)+1
                      ENDIF
                    ENDIF
       	    ELSE 
                      GOTO 4442
                   ENDIF
4442            ENDDO
            ELSE 
               GOTO 4443
             ENDIF
4443      ENDDO
C
C *** compute depth of the hole for big guidestars, small guidestars 
C     and objects
C
       DO I18=1,NRINP
          IF(TYPE(I18).EQ.'B')THEN
            Z(I18) = -(X(I18)*X(I18)+Y(I18)*Y(I18))*SCALFA+EXDGUI
           ELSE IF(TYPE(I18).NE.'B')THEN
             Z(I18) = -(X(I18)*X(I18)+Y(I18)*Y(I18))*SCALFA+EXDOBJ
           ENDIF
          X(I18)=-X(I18)
       ENDDO
C
C *** fill in the output table
C
       DO J5=1,NRINP
          CALL TBEWRC(TIDOUT,J5,OUTCOL(3),CHECK(J5),ISTAT)
          CALL TBEWRD(TIDOUT,J5,OUTCOL(6),Z(J5),ISTAT)
       ENDDO
C
C *** calculate circle to show plate limits
C
       CALL TBTOPN('circle',F_IO_MODE,TIDINP,ISTAT)   !open table
C
       CALL TBIGET(TIDINP,NCINP1,NRINP,NSINP,NACINP,NARINP,ISTAT) !table info
C
       DO K2=1,NRINP    !fill in RAX and DECY columns in circle.tbl
C
C *** subroutine XYAD taken from Yanling Fang's astrometric package
C              (God help us!)
         CALL TBLSER(TIDINP,'XX',CN(1),ISTAT)
         CALL TBLSER(TIDINP,'YY',CN(2),ISTAT)
         CALL TBERDD(TIDINP,K2,CN(1),XX(K2),NULL,ISTAT)
         CALL TBERDD(TIDINP,K2,CN(2),YY(K2),NULL,ISTAT)
         CALL XYAD(XX(K2),YY(K2),PCRARA,PCDECR,
     2             RAXRAD(K2),DECYRAD(K2))
         RAX(K2) = RAXRAD(K2)*360./(2.*15.*PI)
         DECY(K2) = DECYRAD(K2)*360./(2.*PI)
         CALL TBLSER(TIDINP,'RAX',CN(3),ISTAT)
         CALL TBLSER(TIDINP,'DECY',CN(4),ISTAT) 
         CALL TBEWRD(TIDINP,K2,CN(3),RAX(K2),ISTAT)
         CALL TBEWRD(TIDINP,K2,CN(4),DECY(K2),ISTAT)
       ENDDO
C
       CALL STKWRD('CIRDIM',RAX(1),1,1,KUN,ISTAT)
       CALL STKWRD('CIRDIM',DECY(90),2,1,KUN,ISTAT)
C
C *** conversion of forbidden area coordinates
C
       DO K1=1,4
         CALL XYAD(FX(K1),FY(K1),PCRARA,PCDECR,XFRAD(K1),YFRAD(K1))
         XF(K1) = XFRAD(K1)*360./(2.*15.*PI)
         CALL STKWRD('XF',XF(K1),K1,1,KUN,ISTAT)
         YF(K1) = YFRAD(K1)*360./(2.*PI)
         CALL STKWRD('YF',YF(K1),K1,1,KUN,ISTAT)
       ENDDO
C
C *** initialize row selection flag
C
       CALL TBSINI(TIDOUT,ISTAT)
C
C *** close the table
C
       CALL TBTCLO(TIDOUT,ISTAT)
C
C *** over and out
C
       CALL STSEPI
       END
C 
C *** Subroutines used in the code:
C
      SUBROUTINE PRE(A0,D0,A1,D1,EQX0,EQX1)
C
C ... calculate general precession for two given epochs
C
C ... References: STUMPFF P.,ASTRON. ASTROPHYS. SUPPL. 41, P. 1 (1980)
C ...             EXPLAN. SUPPL. ASTRON. EPHEREMERIS, P. 28 (1961)
C
      IMPLICIT NONE             !REAL*8 (A-H,O-Z)
C
      DOUBLE PRECISION A0,D0,D1,EQX0,EQX1
      DOUBLE PRECISION DT0,DT,DTS,DTC,DC1900,DC1M2
      DOUBLE PRECISION DC1,DC2,DC3,DC4,DC5,DC6,DC7,DC8,DC9
      DOUBLE PRECISION DZED,DZETA,DCSAR,DTHETA
      DOUBLE PRECISION PI,SINR,COSR,A1,R
C
      DATA DCSAR/4.848136812D-6/,DC1900/1900.0D0/,DC1M2/0.01D0/,
     * DC1/2304.25D0/,DC2/1.396D0/,DC3/0.302D0/,DC4/0.018D0/,
     * DC5/0.791D0/,DC6/2004.683D0/,DC7/-0.853D0/,DC8/-0.426D0/,
     * DC9/-0.042D0/
C
      PI = 3.1415926535897928
C
C ... first determine the precession angles zeta, z and theta
C
      DT0=(EQX0-DC1900)*DC1M2
      DT=(EQX1-EQX0)*DC1M2
      DTS=DT*DT
      DTC=DTS*DT
      DZETA=((DC1+DC2*DT0)*DT+DC3*DTS+DC4*DTC)*DCSAR
      DZED=DZETA + DC5*DTS*DCSAR
      DTHETA=((DC6+DC7*DT0)*DT+DC8*DTS+DC9*DTC)*DCSAR
C
C ... with these and A0,D0 compute the precessed coordinates A1,D1
C
      D1 = ASIN(DCOS(DTHETA)*DSIN(D0)+DSIN(DTHETA)*DCOS(D0)*
     1                                              DCOS(A0+DZETA))
      SINR = (DCOS(D0)*DSIN(A0+DZETA))/DCOS(D1)
      COSR = (DCOS(DTHETA)*DCOS(D0)*DCOS(A0+DZETA)-
     1                         DSIN(DTHETA)*DSIN(D0))/DCOS(D1)
      R = DASIN(SINR)
      IF (COSR.LT.0) R=PI-R                ! determine quadrant of R
      A1 = R+DZED                      ! this is the precessed R.A.
      IF (A1.GT.2.0D0*PI) A1=A1-2.0D0*PI
      IF (A1.LT.0.0D0) A1=A1+2.0D0*PI
C
      RETURN
      END
C
C *************** XYAD *******
C
C  The subroutine XYAD transforms X and Y coordinates in RAs and DECs
C
      SUBROUTINE XYAD(XX,YY,RA0RAD,D0RAD,RARAD,DECRAD)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C     XX        (INPUT)  Value of X coordinate to be transformed (microns)
C     YY        (INPUT)  Value of Y coordinate to be transformed (microns)
C     RA0RAD    (INPUT)  Center RA                               (radians)
C     D0RAD     (INPUT)  Center DEC                              (radians)
C     RARAD     (OUTPUT) RA                                      (radians)
C     DECRAD    (OUTPUT) DEC                                     (radians)
C------------------------------------------------------------------------------
      IMPLICIT NONE
C
C ***
C
      DOUBLE PRECISION       PI,FOC
      DOUBLE PRECISION       XX,YY,AKSI,ANU
      DOUBLE PRECISION       COSD0,SIND0
      DOUBLE PRECISION       CX,CY,BX(9),BY(9)
      DOUBLE PRECISION       TERM1,TERM2,XX1,YY1
      DOUBLE PRECISION       RH,SINPH,COSPH,SINRH,COSRH
      DOUBLE PRECISION       RARAD,DECRAD
      DOUBLE PRECISION       RA0RAD,D0RAD
C
C ***
C
      DATA         PI/3.14159265358979D0/
      DATA         BX/0.0D0,0.0D0,0.0D0,0.0D0,0.0D0,
     2                0.0D0,0.0D0,0.0D0,0.0D0/
      DATA         BY/0.0D0,0.0D0,0.0D0,0.0D0,0.0D0,
     2                0.0D0,0.0D0,0.0D0,0.0D0/
      DATA         CX,CY/0.0D0,0.0D0/
C
C *** do the work
C
      FOC   = 1.0D0/3.6D3
      BX(1) = 9.9973D-1/0.14006
      BY(2) = BX(1)
C
      COSD0 = DCOS(D0RAD)
      SIND0 = DSIN(D0RAD)
C
      TERM1 = BX(1)*BY(2)-BX(2)*BY(1)
      TERM2 = BX(2)*BY(1)-BX(1)*BY(2)
C
      XX1 = XX*FOC/1.0D3
      YY1 = YY*FOC/1.0D3
C
      ANU = XX1*BY(1)-(YY1*BY(2)*TERM2/TERM1)
     2      -(CY*BX(2)*BY(1)/TERM1)+(CY*BX(1)*BY(2)/TERM1)
      AKSI = (XX1*TERM1+ANU*BX(2)-CY*BX(2))/BY(2)+CX
C
      RH = DSQRT(AKSI**2 + ANU**2)
C
      SINPH = AKSI/RH 
      COSPH = ANU/RH
C
      RH = RH*PI/1.8D2
C
      SINRH= DSIN(RH) 
      COSRH = DCOS(RH)
C
      DECRAD = COSRH*SIND0+SINRH*COSD0*COSPH
      DECRAD = DATAN(DECRAD/DSQRT(1.0D0-DECRAD**2))
C
      RARAD = SINRH*SINPH/DCOS(DECRAD) 
      RARAD = RA0RAD + DATAN(RARAD/DSQRT(1.0D0-RARAD**2))
C      
      RETURN
      END
      
C
C
C *************** ADXY *******
C
C   The subroutine ADXY transforms RAs and DECs in X and Y coordinates 
C 
      SUBROUTINE ADXY(ALFAS,DELTS,ALFA0,DELT0,XX,YY)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C     ALFAS (INPUT) Value of RA to be transformed  (radians)
C     DELTS (INPUT) Value of DEC to be transformed (radians)
C     ALFA0 (INPUT) RA of plate center             (radians)
C     DELT0 (INPUT) DEC of plate center            (radians)
C     XX    (OUTPUT) X coordinate                  (microns)
C     YY    (OUTPUT) Y coordinate                  (microns)
C-------------------------------------------------------------------------- 
      IMPLICIT NONE	
C
C ***
C
      INTEGER	IDX(9),IDY(9)
      INTEGER   NX,NY,IXY,NITER
      INTEGER   I16,I17,N,L
C
C ***
C 
      DOUBLE PRECISION  	XX,YY
      DOUBLE PRECISION  	DELTS,ALFAS
      DOUBLE PRECISION          RH,COSRH,SINRH,COSPH,SINPH
      DOUBLE PRECISION          V,AKSI1,ANU1,AKSI,ANU
      DOUBLE PRECISION          DKSI,DNU,DDIST,DCRIT
      DOUBLE PRECISION          DKDX,DKDY,DNDX,DNDY 
      DOUBLE PRECISION          XBIS(10),AR(50,4),CX,CY,BX(9),BY(9) 
      DOUBLE PRECISION          ALFA0,DELT0,COSD0,SIND0
      DOUBLE PRECISION          XEST(2,2),YEST(2,2)
      DOUBLE PRECISION          PI,FOC
C 
C *** peculiar Cassegrain focus parameters
C 
      DATA     NX/3/
      DATA     NY/3/
      DATA     CX/0.0D0/
      DATA     CY/0.0D0/
      DATA     IDX/1,1,1,0,0,0,0,0,0/
      DATA     IDY/1,1,1,0,0,0,0,0,0/
      DATA     BX/0.0D0,0.0D0,0.0D0,0.0D0,0.0D0,
     2           0.0D0,0.0D0,0.0D0,0.0D0/
      DATA     BY/0.0D0,0.0D0,0.0D0,0.0D0,0.0D0,
     2           0.0D0,0.0D0,0.0D0,0.0D0/
C
C ***
C
      DATA     PI/3.14159265358979D0/
C
C *** do the work
C 
      NITER = 0 
      FOC   = 1.0D0/3.6D3
      BX(1) = 9.9973D-1/0.14006
      BY(2) = BX(1)
C
      COSD0 = DCOS(DELT0) 
      SIND0 = DSIN(DELT0) 
C
      IF (ALFA0.LT.PI/2D0.AND.ALFAS.GT.1.5D0*PI) ALFAS = ALFAS-2D0*PI 
      IF (ALFA0.GT.1.5D0*PI.AND.ALFAS.LT.PI/2D0) ALFAS = ALFAS+2D0*PI 
C
      COSRH = COSD0*DCOS(DELTS)*DCOS(ALFAS-ALFA0) + SIND0*DSIN(DELTS) 
      SINRH = DSQRT(1.0D0-COSRH**2) 
      SINPH = DCOS(DELTS)*DSIN(ALFAS-ALFA0)/SINRH 
      COSPH = (DSIN(DELTS)-SIND0*COSRH)/(COSD0*SINRH) 
      RH = DATAN(SINRH/COSRH) 
C 
C ***  estimate X and Y position 
C 
      AKSI = RH*SINPH/(PI/1.8D2)
      ANU = RH*COSPH/(PI/1.8D2) 
C
      XEST(1,1) = ((AKSI-CX)*BY(2)-(ANU-CY)*BX(2))/ 
     2            (BX(1)*BY(2)-BX(2)*BY(1)) 
      YEST(1,1) = ((AKSI-CX)*BY(1)-(ANU-CY)*BX(1))/ 
     2            (BX(2)*BY(1)-BX(1)*BY(2)) 
30    XEST(2,1) = XEST(1,1)*1.0D3/FOC 
      YEST(2,1) = YEST(1,1)*1.0D3/FOC 
C
C60    NITER = NITER + 1 
      NITER = NITER + 1 
C
C70   AR(1,1) = XEST(1,1) 
      AR(1,1) = XEST(1,1) 
      AR(1,2) = YEST(1,1) 
      AR(1,3) = 0.0D0 
      AR(1,4) = 0.0D0 
C
      I16 = 1 
      N = NX+1
      IXY = 1 
      CALL RAR(XBIS,N,IXY,IDX,IDY,AR,I16,0)
      L = NX
      V = 0.0D0 
      DO I17 = 1,L 
         V = V + BX(I17)*XBIS(I17)
      ENDDO
      AKSI1 = V + CX
C
      N = NY + 1
      IXY = 2 
      CALL RAR(XBIS,N,IXY,IDX,IDY,AR,I16,0)
      L = NY
      V = 0.0D0 
      DO I17 = 1,L 
         V = V + BY(I17)*XBIS(I17)
      ENDDO
      ANU1 = V + CY 
      DKSI = AKSI1 - AKSI 
      DNU = ANU1 - ANU
      DDIST = DSQRT(DKSI**2 + DNU**2) 
      DCRIT = 1.0D-6
      IF (DDIST.LE.DCRIT ) GOTO 1000
C 
C100  N = NX + 1
      N = NX + 1
      IXY = 1 
      CALL RAR(XBIS,N,IXY,IDX,IDY,AR,1,1)
      L = NX
      V = 0.0D0 
      DO I17 = 1,L
         V = V + BX(I17)*XBIS(I17)
      ENDDO
      DKDX = V
C
      N = NX + 1
      IXY = 1 
      CALL RAR(XBIS,N,IXY,IDX,IDY,AR,1,2)
      L = NX
      V = 0.0D0 
      DO I17 = 1,L
         V = V + BX(I17)*XBIS(I17)
      ENDDO
      DKDY = V
C
      N = NY + 1
      IXY = 2 
      CALL RAR(XBIS,N,IXY,IDX,IDY,AR,1,1)
      L = NY
      V = 0.0D0 
      DO I17 = 1,L
         V = V + BY(I17)*XBIS(I17)
      ENDDO
      DNDX = V
C
      N = NY + 1
      IXY = 2 
      CALL RAR(XBIS,N,IXY,IDX,IDY,AR,1,2)
      L = NY
      V = 0.0D0 
      DO I17 = 1,L
         V = V + BY(I17)*XBIS(I17)
      ENDDO
      DNDY = V
C
      YEST(1,2) = (DKSI*DNDX-DNU*DKDX)/(DNDX*DKDY-DKDX*DNDY)
      XEST(1,2) = (DKSI*DNDY-DNU*DKDY)/(DKDX*DNDY-DNDX*DKDY)
      XEST(1,1) = XEST(1,1) - XEST(1,2) 
      YEST(1,1) = YEST(1,1) - YEST(1,2) 
      GOTO 30
1000  XX = -XEST(2,1)
      YY = YEST(2,1)
      RETURN
      END 
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C 
C  The subroutine RAR comes directly from the POS package (cfr Astrom. prgs.) 
C 
C----------------------------------------------------------------------------
      SUBROUTINE RAR(XBIS,N,IXY,IDX,IDY,AR,I,K)
C
C ***
C
      IMPLICIT NONE
C
C ***
C
      INTEGER IDX(1),IDY(1)
      INTEGER K,I,I1,IXY,J,N
C
C ***
C
      DOUBLE PRECISION 	  X1(10) 
      DOUBLE PRECISION    XBIS(10),AR(50,4)
C
C ***
C
      CHARACTER STRING*80
C
C *** do the work
C
      IF (K.EQ.0) GOTO 1 
      IF (K.EQ.1) GOTO 2 
      IF (K.EQ.2) GOTO 3 
C
1     X1(1) = AR(I,1) 
      X1(2) = AR(I,2) 
      X1(3) = AR(I,1)*AR(I,2) 
      X1(4) = AR(I,1)**2
      X1(5) = AR(I,2)**2
      X1(6) = AR(I,1)**3
      X1(7) = AR(I,2)**3
      X1(8) = AR(I,1)*AR(I,2)**2
      X1(9) = AR(I,2)*AR(I,1)**2
      GOTO 5
C 
2     X1(1) = 1.0D0 
      X1(2) = 0.0D0 
      X1(3) = AR(I,2) 
      X1(4) = 2.0D0*AR(I,1) 
      X1(5) = 0.0D0 
      X1(6) = 3.0D0*AR(I,1)**2
      X1(7) = 0.0D0 
      X1(8) = AR(I,2)**2
      X1(9) = 2.0D0*AR(I,2)*AR(I,1) 
      GOTO 5
C 
3     X1(1) = 0.0D0 
      X1(2) = 1.0D0 
      X1(3) = AR(I,1) 
      X1(4) = 0.0D0 
      X1(5) = 2.0D0*AR(I,2) 
      X1(6) = 0.0D0 
      X1(7) = 3.0D0*AR(I,2)**2
      X1(8) = 2.0D0*AR(I,1)*AR(I,2) 
      X1(9) = AR(I,1)**2
C
5     IF(IXY.EQ.1) X1(10) = AR(I,3) 
      IF(IXY.EQ.2) X1(10) = AR(I,4) 
      IF(IXY.EQ.2) GOTO 20
      I1 = 0
      DO J=1,9 
         IF(IDX(J).EQ.0) GOTO 10 
         I1 = I1+1 
         XBIS(I1) = X1(J) 
10    ENDDO
      IF (N-I1.NE.1) GOTO 50 
      XBIS(I1+1) = X1(10)
      GOTO 40
20    I1= 0 
      DO J=1,9 
         IF (IDY(J).EQ.0) GOTO 30 
         I1 = I1+1 
         XBIS(I1) = X1(J) 
30    ENDDO
      IF(N-I1.NE.1) GOTO 50
      XBIS(I1+1) = X1(10)
40    RETURN
50    STRING = '*** FATAL: Coeff. trouble'
      CALL STETER(9,STRING)
      RETURN
      END 
C---------------------------------------------------------------------------

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.COPYRIGHT: Copyright (c) 1987-2006 European Southern Observatory,
C                                         all rights reserved
C.IDENTIFICATION:
C  program IDAUXZ 		version	5.10    900712
C  K. Banse         	        ESO - Garching
C  5.20     901220	5.30	910904
C
C.KEYWORDS:
C  ImageDisplay functions with cursor interaction
C
C.PURPOSE:
C  read keyword ACTION and call the relevant subroutine to do the job
C 
C.ALGORITHM:
C  all done in the subroutines
C
C.INPUT/OUTPUT:
C  the following keywords are used:
C
C  ACTION/C/1/2			action = = SC for scroll/zoom (c)
C				       = CU for set/cursor (d)
C  DAZHOLD/I/1/14		cursor(s) enabled, cursor form(s),
C				split screen mode + other info
C
C.VERSIONS
C  5.10		get the no. of cursor from the command line
C  5.20		add access to graphics window in SUBCUR
C	
C 060928		last modif
C 
C-------------------------------------------------------------------
C
      PROGRAM IDAUXZ
C 
      IMPLICIT NONE
C 
      INTEGER    IAV,STAT,DAZHLD(14)
      INTEGER    UNI(1),NULO
      INTEGER    MADRID(1)
C 
      CHARACTER  ACTIO*2
C      
      INCLUDE  'MID_INCLUDE:IDIDEV.INC'
C
      COMMON  /VMR/ MADRID
C 
      INCLUDE  'MID_INCLUDE:IDIMEM.INC'
C 
C  initialize MIDAS
      CALL STSPRO('IDAUXZ')
C
      CALL STKRDC('ACTION',1,1,2,IAV,ACTIO,UNI,NULO,STAT)
      CALL UPCAS(ACTIO,ACTIO)
C 
C  branch accordingly
      IF (ACTIO .EQ. 'CD') THEN
         CALL SUBCUR(1)
      ELSE IF (ACTIO .EQ. 'CG') THEN
         CALL SUBCUR(2)
      ELSE IF (ACTIO .EQ. 'SC') THEN
         CALL STKRDI('DAZHOLD',1,14,IAV,DAZHLD,UNI,NULO,STAT)
         CALL SUBSCR(DAZHLD)
      ELSE
         CALL STETER(9,'Module IDAUXZ: invalid option...')
      ENDIF
C 
      CALL STSEPI
      END

      SUBROUTINE SUBCUR(JFLAG)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine SUBCUR		version 2.01	840409
C  K. Banse			ESO - Garching
C  2.65      871123     2.70  890306	2.80	890630
C  2.90	     930112
C
C.KEYWORDS
C  ImageDisplay, cursor
C
C.PURPOSE
C  enable/disable fixed cursor(s) of different shapes or programmable cursors
C  and (optionally) set cursor coordinates
C
C.ALGORITHM
C  use IDI interfaces for interacting with the DeAnza (form = 0,...,15)
C  or programmed shape (form=99) or from=100,101 for X11;
C  disable cursors with form=-1
C
C.INPUT/OUTPUT
C  
C  call as SUBCUR(JFLAG)
C 
C  input par:
C  JFLAG:	Integer		= 1 for display cursor
C				  2 for graphics cursor
C 
C  also the following keywords are used
C
C  DAZIN/I/1/4		(1) = cursor_form_flag: 
C			      98 for fixed cursor_form no. (only DeAnza)
C			      99 for programmable
C			      100 for IDI cursor shapes
C			      101 for IDI region of interest (ROI)
C			      200 for ANGLE
C			      -1 for CLEAR/CURSOR
C			(2) = cursor no. (0,1,2) for cursor 1,2 or both
C			(3) = form_no. if (1) = 98
C			      if (1) = 100 then
C			      shape = 0 (implement. dependent),
C				      1 (full cross hair), 2 (cross)
C			              3 (open cross), 7 (arrow)
C			      if (1) = 101 then
C			      shape = 1 (recangular ROI)
C			      shape = 2 (circular ROI)
C			(4) = colour = 0 (checkered in our case)
C			               1 (black), 2 (white)
C			cf. IDI-doc. page 44 and 38
C  P3/C/1/60 		x1,y1,x2,y2 - cursor coordinates
C  			xc,yc,r1,r2,r3 if circular ROI
C  P4/C/1/5             = F(RAME) to indicate, that coordinates in P2
C                       are not screen coords. but frame related ones
C  INPUTR/R/1/2		angle, length in case of DAZIN(1) = 200
C
C.VERSIONS
C  2.20            move to standard interfaces
C  2.50            move to IDI interfaces
C  2.60            add ANGLE option to available shapes
C  2.65            use CLEAN_FRAME with '*' instead of '?'
C  2.70            use new IDIs + move to FORTRAN 77
C  2.80            make a subroutine out of it
C  2.90            add circular ROI
C
C--------------------------------------------------
C
      IMPLICIT NONE
C 
      INTEGER      JFLAG
C
      INTEGER      IAV,IMNO,DISPNO,ICO
      INTEGER      L1,L2,LL,N,STAT
      INTEGER      COORDS(5),NPIX(2),SUBLO(3)
      INTEGER      CURSNO,FM,DAZZIN(4)
      INTEGER      SHAPE,COLOUR,CNO
      INTEGER      UNI(1),NULO
C
      CHARACTER    INPUTC*60,FRAME*80,CWORK*2,AUXSTR*60
C 
CC      REAL         ALPHA,SIZE
      REAL         RINF(8),RDUM,RBUF(6)
C 
      DOUBLE PRECISION START(2),STEP(2)
      DOUBLE PRECISION  DDUM
C 
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      INCLUDE 'MID_INCLUDE:IDIDEV.INC'
      INCLUDE 'MID_INCLUDE:IDIMEM.INC'
C 
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C  get cursor info
      CALL STKRDI('DAZIN',1,4,IAV,DAZZIN,UNI,NULO,STAT)
      FM = DAZZIN(1)                        !internal no.
      CURSNO = DAZZIN(2) 
      IF (CURSNO.LT.0) CURSNO = 0
      SHAPE = DAZZIN(3)
      COLOUR = DAZZIN(4)
C 
      IF (JFLAG.EQ.1) THEN
         CALL DTOPEN(1,STAT)
         DISPNO = QDSPNO
      ELSE
         CALL DTOPEN(2,STAT)                      !open graphics window
         DISPNO = GDSPNO
      ENDIF
C 
C  handle ANGLE cursor definition in a special way
C       IF (DAZZIN(1).EQ.200) THEN
C          CURSNO = 2
C          FM = 99
C          CALL STKRDR('INPUTR',1,2,IAV,RBUF,UNI,NULO,STAT)
C          ALPHA = RBUF(1)
C          SIZE = RBUF(2)
C          CALL ANGLE(ALPHA,SIZE,COORDS)
C 
C
C see, if it's CLEAR/CURSOR (only possible for display window)
C 
      IF (FM.EQ.-1) THEN
         IF (CURSNO.EQ.2) THEN                  !region of interest
            CALL IIRSRV(DISPNO,0,0,STAT)
         ELSE IF (CURSNO.EQ.3) THEN             !two independent cursors
            CALL IICSCV(DISPNO,0,0,STAT)
            CALL IICSCV(DISPNO,1,0,STAT)
         ELSE
            CALL IICSCV(DISPNO,CURSNO,0,STAT)   !single cursor
         ENDIF
         L1 = -1                                !update key DAZIN(2)
         CALL STKWRI('DAZIN',L1,2,1,UNI,STAT)
         GOTO 9090
      ENDIF
C
      IF (CURSNO.GT.1) THEN
         IF ((FM.EQ.101).AND.(SHAPE.EQ.2)) THEN
            L1 = 5                              !circular ROI
         ELSE
            L1 = 4  
         ENDIF
      ELSE
         L1 = 2                                 !no. of coordinates needed...
      ENDIF
C
C  now check, if also the cursor coordinates should be set
C 
      CALL STKRDC('P3',1,1,60,IAV,INPUTC,UNI,NULO,STAT)
      IF (INPUTC(1:1).EQ.'+') THEN
         IF (L1.EQ.5) THEN                    !circular ROI
            COORDS(1) = -1
            COORDS(2) = -1
            COORDS(3) = 5                     !set inner raidus to 5 pixels
            COORDS(4) = 0
            COORDS(5) = 0
         ELSE
            DO 800 N=1,5
               COORDS(N) = -1                 !indicate that we don't use them
800         CONTINUE
         ENDIF
         GOTO 8000
      ENDIF
C
C  yes. set coordinates (frame or screen coords. input)
C 
      CALL STKRDC('P4',1,1,1,IAV,CWORK,UNI,NULO,STAT)  
      IF ((CWORK(1:1).NE.'F') .AND.
     +    (CWORK(1:1).NE.'f') ) THEN                      !screen coordinates
         CALL GENCNV(INPUTC,1,L1,COORDS,RDUM,DDUM,LL)
         IF (LL.LE.0) GOTO 9100
      ELSE
C
C  we work with frame coordinates
         CALL DTGICH(DISPNO,QIMCH,FRAME,RINF,STAT)       !FRAME = 80 chars now
         CALL STFOPN(FRAME,D_R4_FORMAT,0,F_IMA_TYPE,IMNO,STAT)
         CALL STDRDI(IMNO,'NPIX',1,2,IAV,NPIX,UNI,NULO,STAT)
         CALL STDRDD(IMNO,'START',1,2,IAV,START,UNI,NULO,STAT)
         CALL STDRDD(IMNO,'STEP',1,2,IAV,STEP,UNI,NULO,STAT)
C
         CALL PIXXCV('INIT',IMNO,RBUF,STAT)  
C
         IF (CURSNO.EQ.1) THEN
            CNO = 3
         ELSE
            CNO = 1
         ENDIF
         ICO = 0
C
C  handle cursor #0 or #1
1400     IF (ICO.GT.1) GOTO 8000
C 
         LL = INDEX(INPUTC,',')
         IF (LL.LE.0) GOTO 9100
         INPUTC(LL:LL) = '^'
         L2 = INDEX(INPUTC,',')
C 
         INPUTC(LL:LL) = ','
         IF (L1.GT.2) THEN                        !rectangle or circle
            IF (L2.GT.0) THEN
               AUXSTR(1:) = INPUTC(L2+1:)//' '
               INPUTC(L2:) = ' '
            ENDIF
         ENDIF
         ICO = ICO + 1
         CALL EXTCO1(IMNO,INPUTC,2,N,SUBLO,STAT)
         IF (STAT.NE.0) CALL STSEPI
         RBUF(1) = SUBLO(1)
         RBUF(2) = SUBLO(2)
         CALL PIXXCV('_RS',0,RBUF,STAT)           !convert to screen pixels...
         COORDS(CNO) = RBUF(5)
         COORDS(CNO+1) = RBUF(6)
         IF (CURSNO.EQ.0) GOTO 8000               !we're done
         IF (L2.GT.0) THEN
            INPUTC(1:) = AUXSTR(1:)//' ' 
            IF (L1.NE.5) THEN                     !if not circular ROI
               CNO = 3                            !move to next coords.
               GOTO 1400
            ELSE
               CALL GENCNV(INPUTC,1,3,COORDS(3),RDUM,DDUM,LL)
            ENDIF
         ENDIF
      ENDIF
C
C  now send the cursor specs to the Image Display (or graphics window)
8000  CALL SETCUR(DISPNO,CURSNO,SHAPE,COLOUR,COORDS,STAT)
C
C  job done
9090  CALL DTCLOS(DISPNO)
      RETURN
C
9100  CALL STETER(1,'Invalid cursor coords. given...')
C
      END

      SUBROUTINE ANGLE(ALPHA,SIZE,IC)
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION:
C  subroutine ANGLE            version 1.00      860708
C  K. Banse                  ESO - Garching
C
C.KEYWORDS:
C  ANGLEn fill
C
C.PURPOSE:
C  calculate coordinates for cursors to obtain a line of required angle + size
C
C.ALGORITHM:
C  straight forward
C
C.INPUT/OUTPUT:
C  call as ANGLE(ALPHA,SIZE,IC)
C
C.VERSIONS
C
C--------------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      IDX,IDY,MDX,MDY,IC(4)
C
      REAL         ALPHA,SIZE,RLIM
      REAL         CA,TA,DX,DY,FACTO
C
      DATA    FACTO  /0.0174533/                    ! PI / 180.
      RLIM = 500.
      IF (SIZE.GT.RLIM) SIZE = RLIM
C
C  fix angle into [-90,+90]
C
100   IF (ALPHA.GT.90.0) THEN
         ALPHA = ALPHA - 180.
         GOTO 100
      ENDIF
200   IF (ALPHA.LT.-90.0) THEN
         ALPHA = ALPHA + 180.
         GOTO 200
      ENDIF
      IF (ABS(ALPHA).GE.89.9) THEN
         IDX = 0
         IDY = NINT(SIZE)
         GOTO 8000
      ENDIF
C
C  compute triangular functions
      CA = COS(ALPHA*FACTO)
      TA = TAN(ALPHA*FACTO)
C
C  test size
1000  IF (SIZE.LE.1.)
     +   CALL STETER(1,'invalid angle or size...')
C
      DX = SIZE * CA                        !delta x
      DY = DX * TA                                !delta y
C
C  make sure we remain in screen space...
      IF (ABS(DY).GT.RLIM) THEN
         SIZE = SIZE - 1.
         GOTO 1000                        !loop more...
      ELSE
         IDX = NINT(DX)
         IDY = NINT(DY)
      ENDIF
C
C  final section
8000  MDX = (512 - IDX) / 2                  !left/right margin in x
      MDY = (512 - ABS(IDY)) / 2            !left/right margin in y
      IC(1) = MDX                  !coords start with 0 ...
      IC(3) = IC(1) + IDX            !delta x always > 0
      IF (ALPHA.GT.0.) THEN
         IC(2) = MDY
      ELSE
         IC(2) = 511 - MDY
      ENDIF
      IC(4) = IC(2) + IDY            !delta y > 0 or < 0 possible
C
      RETURN
      END

      SUBROUTINE SUBSCR(DAZHLD)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION:
C  subroutine SUBSCR			version 1.00	870520
C  K. Banse			   	ESO - Garching
C  1.10	871124 		1.20	881005		1.30	890424
C  1.40	890630		1.50	901015
C
C.KEYWORDS:
C  Image display, scrolling, zooming
C
C.PURPOSE:
C  a) update the scroll values of the currently displayed memory channel
C     under joystick control
C  b) do the zooming: either cursor window to determine zoom factor + center
C                     or single cursor and given zoom factor
C
C.ALGORITHM:
C  a) the scroll values in x and y are moved according to the joystick movement
C	
C   On the cursor board at least one cursor has to be on, TRACK has to be on
C   and RATE has to be on.
C   Switching both cursors off will terminate the program.
C	
C.INPUT/OUTPUT:
C
C  the following keywords are used:
C 
C  a) 			Scrolling...
C  DEFAULT/C/1/2	(1)= Y for scrolling via joystick
C			(1)= N for fixed scroll values
C			(1)= C for clear/scroll (i.e. reset to original)
C			(2)= O, scroll overlay channel accordingly
C			else scroll only given channel
C  DAZIN/I/1/2		scroll values in case of DEFAULT = N
C  DAZHOLD/I/8/1	refscale flag
C
C  b)			Zooming...
C  ACTION/C/3/3		action flags
C			(1) = C, use size of cursor square to get zoom factors
C			(1) = F, read zoom factors from DAZHOLD
C			(1) = U, zoom stepwise up from current level
C			(1) = D, zoom stepwise down from current level
C			(1) = X, clear zoom
C			(3) = X, use F option above at fixed position,
C				 which are in INPUTI(1,2)
C			(3) = else - use the cursor ...
C
C.VERSIONS
C  1.00		from vers. 1.80 of SCROLL + vers. 3.20 of ZOOM
C  1.10		take care of display screen size
C  1.20		add DEFAULT(1::1) = C option
C               and move to new IDI and ST interfaces
C  1.30		for XWindow systems, we only scroll on ENTER ...
C  1.40		make a subroutine out of it
C  1.50		use QMSZY instead of QDSZY for scrolling...
C
C---------------------------------------------------------
C
C
      IMPLICIT NONE
C	
      INTEGER      DAZHLD(*)
C 
      INTEGER      FLAG,IAV,STAT,INC,ZMLIM(2)
      INTEGER      N,LOOP,IDX,XM,YM
      INTEGER      OLDZX,ZFX,ZFY,SCRX,SCRY
      INTEGER      CHAN,REFSC,COORDS(4)
      INTEGER      DX,DY,MEMC1,MEMC2,ST1,ST2
      INTEGER      IZOOM(2)
      INTEGER      XY1(2),XY2(2),YESCUR
      INTEGER      SPLMOD,CURNO
      INTEGER      SCRVAL(2),JX,JY,ZOOMR
      INTEGER      SPLCX(4,5),SPLCY(4,5)
      INTEGER      KUNI,KNUL
C
      CHARACTER    COMPAR(5)*1,ACTION*3
      CHARACTER    DEFAUL*16,WORK*80
C      
      REAL         ZFACT,RINF(8)
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C      
      INCLUDE  'MID_INCLUDE:IDIDEV.INC'
      INCLUDE  'MID_INCLUDE:IDIMEM.INC'
C      
      DATA      COMPAR      /'C','F','U','D','X'/
      DATA      COORDS      /-1,-1,-1,-1/
C 
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      CALL DTOPEN(1,STAT)
      REFSC = DAZHLD(8)                        !get global refscale flag
      SPLMOD = DAZHLD(3)
      SCRX = 0
      SCRY = 0
      FLAG = 0
      INC = 0
C      
C  read keyword DEFAULT(16) to determine, if we want to scroll or zoom
      CALL STKRDC('DEFAULT',1,1,16,IAV,DEFAUL,KUNI,KNUL,STAT)
      CALL UPCAS(DEFAUL,DEFAUL)
      IF ((DEFAUL(16:16).EQ.'Z') .OR. (DEFAUL(16:16).EQ.'z'))
     +    GOTO 1000                            !do Zooming at label 1000
C 
C ------------------------------------------------------
C      
C  here we do the scrolling
C      
C ------------------------------------------------------
C 
C  read "image environment" for current channel 
      CALL DTGICH(QDSPNO,QIMCH,WORK,RINF,STAT)
      IF ((ZOOMX + ZOOMY) .GT. 2)
     +   CALL STETER(2,'No scrolling of zoomed channel supported...')
C      
C  if DEFAULT(1:1) = Y, we get the scroll values via joystick
      IF (DEFAUL(1:1).EQ.'Y') THEN
         SCRVAL(1) = SCROLX
         SCRVAL(2) = SCROLY
         CURNO = 1
         CALL JOYSTK(QDSPNO,0,CURNO,JX,JY,STAT)  
C 
      ELSE
         IF (DEFAUL(1:1).EQ.'N') THEN
            CALL STKRDI('DAZIN',1,2,IAV,SCRVAL,KUNI,KNUL,STAT)
         ELSE IF (DEFAUL(1:1).EQ.'C') THEN
            SCRVAL(1) = 0
            SCRVAL(2) = QDSZY - 1
         ENDIF
C 
         CALL DAZSCR(QDSPNO,QIMCH,SCRVAL(1),SCRVAL(2),STAT)
         IF (DAZHLD(13).EQ.QIMCH)
     +      CALL DAZSCR(QDSPNO,QOVCH,SCRVAL(1),SCRVAL(2),STAT)
         SCROLX = SCRVAL(1)
         SCROLY = SCRVAL(2)
         GOTO 500                              !that's it already...
      ENDIF
C 
C  get joystick input 
100   CALL JOYSTK(QDSPNO,1,CURNO,JX,JY,STAT)
      IF (STAT.EQ.1) GOTO 500                  !if cursor(s) off, terminate
C      
C modify scroll values according to joystick movement
      IF (IDINUM.NE.11) THEN
         IF ((JX.LE.-64).OR.(JX.GE.64)) THEN
            JX = JX/8
         ELSE
            JX = JX/12
         ENDIF
         IF ((JY.LE.-64).OR.(JY.GE.64)) THEN
            JY = JY/8
         ELSE
            JY = JY/12
         ENDIF
      ENDIF
C      
      IF ((JX.EQ.0) .AND. (JY.EQ.0)) GOTO 100
C 
      SCRVAL(1) = SCRVAL(1) - JX
      SCRVAL(2) = SCRVAL(2) - JY
C 
      IF (IDINUM.NE.11) THEN
         IF (SCRVAL(1).LT.-QMSZX) THEN
            SCRVAL(1) = - (QMSZX - 1)
         ELSE IF (SCRVAL(1).GE.QMSZX) THEN
            SCRVAL(1) = QMSZX - 1
         ENDIF
         IF (SCRVAL(2).LT.-QMSZY) THEN
            SCRVAL(2) = - (QMSZY - 1)
         ELSE IF (SCRVAL(2).GE.QMSZY) THEN
            SCRVAL(2) = QMSZY - 1
         ENDIF
      ENDIF
C 
C  send new scroll values to ImageDisplay
      CALL DAZSCR(QDSPNO,QIMCH,SCRVAL(1),SCRVAL(2),STAT) 
      IF (DAZHLD(13).EQ.QIMCH)
     +   CALL DAZSCR(QDSPNO,QOVCH,SCRVAL(1),SCRVAL(2),STAT)      
C      
C  now loop
      GOTO 100
C      
C  that's it folks...
500   SCROLX = SCRVAL(1)
      SCROLY = SCRVAL(2)
      CALL DAZVIS(QDSPNO,QIMCH,1,REFSC)                  !keep LUT display
      CALL DTPICH(QDSPNO,QIMCH,WORK,RINF,STAT)
C      
      IF (DAZHLD(13).EQ.QIMCH) THEN
         SCRX = SCROLX                                   !save scroll values
         SCRY = SCROLY
         CALL DTGICH(QDSPNO,QOVCH,WORK,RINF,STAT)
         SCROLX = SCRX
         SCROLY = SCRY
         CALL DTPICH(QDSPNO,QOVCH,WORK,RINF,STAT)
      ENDIF
C      
C  goto common end section
      GOTO 9000

C 
C ---------------------------------------------------------------
C      
C  here we do the zooming
C
C ---------------------------------------------------------------
C 
C  see what we should do
1000  CALL STKRDC('ACTION',1,3,3,IAV,ACTION,KUNI,KNUL,STAT)
      CALL UPCAS(ACTION,ACTION)
      DO 1010 N=1,5
         IF (ACTION(1:1).EQ.COMPAR(N)) THEN
            FLAG = N
            GOTO 1020
         ENDIF
1010  CONTINUE
      CALL STETER(3,'Invalid option...')           !invalid input...
C
1020  CALL IIDQCI(QDSPNO,17,2,ZMLIM,N,STAT)        !get zoom limits
C 
C  see, if it's CLEAR/ZOOM...
      IF (FLAG.EQ.5) THEN
         CALL SPLCNT(SPLCX,SPLCY)
C      
         ZOOMR = 1
         IF (QRGBFL.NE.1) THEN                      !pseudo-colour mode
            CALL DTGICH(QDSPNO,QIMCH,WORK,RINF,STAT)
            ZOOMX = ZOOMR
            ZOOMY = ZOOMR
            IF (SPLMOD.EQ.0) THEN            !init scroll values
               SCROLX = 0
               SCROLY = QDSZY - 1
            ELSE
               SCROLX = SPLCX(QIMCH+1,SPLMOD)
               SCROLY = SPLCY(QIMCH+1,SPLMOD)
            ENDIF
C 
            CALL DAZZSC(QDSPNO,QIMCH,1,SCROLX,SCROLY,STAT)  !reset zoom, scroll
            CALL DAZVIS(QDSPNO,QIMCH,1,REFSC)         !update refscale flag
            CALL DTPICH(QDSPNO,QIMCH,WORK,RINF,STAT)
C 
         ELSE                                 !in RGB mode
            DO 1100 CHAN=0,2                  !loop through all colour channels
               CALL DTGICH(QDSPNO,CHAN,WORK,RINF,STAT)
               ZOOMX = ZOOMR
               ZOOMY = ZOOMR
               IF (SPLMOD.EQ.0) THEN          !init scroll values
                  SCROLX = 0
                  SCROLY = QDSZY - 1
               ELSE
                  SCROLX = SPLCX(QIMCH+1,SPLMOD)
                  SCROLY = SPLCY(QIMCH+1,SPLMOD)
               ENDIF
               CALL DAZZSC(QDSPNO,CHAN,ZOOMX,SCROLX,SCROLY,STAT)   
               CALL DAZVIS(QDSPNO,CHAN,1,REFSC)
               CALL DTPICH(QDSPNO,CHAN,WORK,RINF,STAT)
1100     CONTINUE
         ENDIF
C 
         IF (DAZHLD(13).EQ.QIMCH) THEN
            IF (QOVCH.GE.0) THEN 
               CALL DTGICH(QDSPNO,QOVCH,WORK,RINF,STAT)
               SCROLX = SCRX
               SCROLY = SCRY
               ZOOMX = ZOOMR
               ZOOMY = ZOOMX
               CALL DAZZSC(QDSPNO,QOVCH,ZOOMX,SCROLX,SCROLY,STAT)
               CALL DTPICH(QDSPNO,QOVCH,WORK,RINF,STAT)
            ENDIF
         ENDIF
         GOTO 9000                              !jump to end section
      ENDIF
C      
C  --------------------------------------
C      
C  here for real zooming
C      
C  --------------------------------------
C      
C  init for stepwise zooming...
      LOOP = 0                             !initialize loop counter
      IDX = 0                              !and iteration count for rectangles
C
C  look, if we do not need cursors
      IF ( (FLAG.EQ.2) .AND. (ACTION(3:3).EQ.'X') ) THEN
         CALL STKRDI('INPUTI',1,2,IAV,XY1,KUNI,KNUL,STAT)
         MEMC1 = QIMCH
         YESCUR = 0
         IF (QRGBFL.EQ.1) THEN
            GOTO 4000
         ELSE
            GOTO 1500
         ENDIF
      ENDIF
C      
C  enable cursors
      YESCUR = 1
      IF (FLAG.EQ.1) THEN  
         CURNO = 2
         CALL SETCUR(QDSPNO,CURNO,0,0,COORDS,STAT)    !use ROI
      ELSE  
         CURNO = 0
         CALL SETCUR(QDSPNO,CURNO,3,0,COORDS,STAT)    !use curs0 as open cross
      ENDIF
C      
C  for ZOOM/UP, /DOWN set increments + limits
      IF (FLAG.EQ.3) THEN
         INC = +1
      ELSE IF (FLAG.EQ.4) THEN
         INC = -1
      ENDIF
C      
C  fork according to QRGBFL
      IF (QRGBFL.EQ.1) GOTO 4000
C
C  wait for cursor input
1500  IF (YESCUR.NE.1) GOTO 1600           !so we can jump to 1550...
C
      CALL CURSIN(QDSPNO,0,CURNO,XY1,MEMC1,ST1,XY2,MEMC2,ST2)
1550  CALL CURSIN(QDSPNO,1,CURNO,XY1,MEMC1,ST1,XY2,MEMC2,ST2)
      IF (ST1.EQ.0) THEN
         IF (LOOP.EQ.0) THEN
            CALL STTDIS('Turn cursor on...',80,STAT)
            GOTO 1550
         ELSE               
            GOTO 9000                   !for stepwise zoom, check
         ENDIF
      ENDIF
C
C  get channel info for relevant memory board
1600  CALL DTGICH(QDSPNO,MEMC1,WORK,RINF,STAT)
      OLDZX = ZOOMX                        !save old zoom factor
      CHAN = MEMC1                         !we use CHAN for image channel later on
C
C  zoomfactor taken from cursor box
C      
      IF (FLAG.EQ.1) THEN                  !cursor window option
         DX = ABS(XY2(1) - XY1(1))
         DY = ABS(XY2(2) - XY1(2))
         XM = XY1(1) + DX/2
         YM = XY1(2) + DY/2
C      
         IF ((DX.EQ.0).OR.(DY.EQ.0)) THEN           !check, if valid rectangle
            IF (IDX.EQ.1) GOTO 9000                 !allow only one iteration
            CALL STTDIS('use cursors to form a rectangle...',99,STAT)
            IDX = 1
            GOTO 1550
         ENDIF
C      
         ZFX = NINT(FLOAT(QDSZX)/FLOAT(DX))
         IF (ZFX.LT.ZMLIM(1)) ZFX = ZMLIM(1)
         IF (ZFX.GT.ZMLIM(2)) ZFX = ZMLIM(2)
         ZFY = NINT(FLOAT(QDSZY)/FLOAT(DY))
         IF (ZFY.LT.ZMLIM(1)) ZFY = ZMLIM(1)
         IF (ZFY.GT.ZMLIM(2)) ZFY = ZMLIM(2)
         IF (ZFX.GT.ZFY) THEN
            ZOOMR = ZFX
         ELSE
            ZOOMR = ZFY
         ENDIF
C      
C  fixed zoom factor
C      
      ELSE IF (FLAG.EQ.2) THEN
         XM = XY1(1)
         YM = XY1(2)
         ZOOMR = DAZHLD(6)
C      
C  here for stepwise zooming
C      
      ELSE
         XM = XY1(1)
         YM = XY1(2)
         ZFX = ZOOMX + INC
         IF ( (ZFX.LT.ZMLIM(1)) .OR. (ZFX.GT.ZMLIM(2)) ) GOTO 9000     !done...
         ZOOMR = ZFX
      ENDIF
C
C  common section for all zoom options...
C  set XSCROL, YSCROL such, that zoom center remains unchanged
C
      IF (ZOOMR.NE.OLDZX) THEN
         ZFACT = FLOAT(ZOOMX) / FLOAT(ZOOMR)
         SCROLX = XM - NINT( (XM - SCROLX) * ZFACT )
         SCROLY = YM + NINT( (SCROLY - YM) * ZFACT )
      ENDIF
C
C  now we finally zoom
C      
      CALL DAZZSC(QDSPNO,CHAN,ZOOMR,SCROLX,SCROLY,STAT)
      CALL DAZVIS(QDSPNO,CHAN,1,REFSC)             !for refscale flag 
      IF (DAZHLD(13).EQ.CHAN)
     +   CALL DAZZSC(QDSPNO,QOVCH,ZOOMR,SCROLX,SCROLY,STAT)
C
C  update channel info
      ZOOMX = ZOOMR
      ZOOMY = ZOOMX                        !we use same zoom factor in x + y
      SCRX = SCROLX                        !save scroll values
      SCRY = SCROLY
      CALL DTPICH(QDSPNO,MEMC1,WORK,RINF,STAT)
C      
C  if requested also update stuff for overlay channel
      IF (DAZHLD(13).EQ.CHAN) THEN
         IF (QOVCH.GE.0) THEN            !check, if an overlay channel exists
            CALL DTGICH(QDSPNO,QOVCH,WORK,RINF,STAT)
            SCROLX = SCRX
            SCROLY = SCRY
            ZOOMX = ZOOMR
            ZOOMY = ZOOMX
            CALL DTPICH(QDSPNO,QOVCH,WORK,RINF,STAT)
         ENDIF
      ENDIF
C      
C  for stepwise zooming, we loop
      IF (FLAG.GE.3) THEN
         LOOP = 1                        !loop
         GOTO 1550
      ENDIF
C 
C  jump to the end
      GOTO 9000                        !We're done ...
C      
C ---------------------------------------------------
C
C  handle all 3 colour channels in RGB_MODE
C
C ---------------------------------------------------
C
C  wait for cursor input
4000  IF (YESCUR.EQ.1) THEN
         CALL CURSIN(QDSPNO,0,CURNO,XY1,MEMC1,ST1,XY2,MEMC2,ST2)
         CALL CURSIN(QDSPNO,1,CURNO,XY1,MEMC1,ST1,XY2,MEMC2,ST2)
         IF ((LOOP.GT.0).AND.(ST1.EQ.0)) GOTO 5900              !done..
      ENDIF
C      
C  now loop through channels 0,1,2
      DO 4400 CHAN=0,2
         CALL DTGICH(QDSPNO,CHAN,WORK,RINF,STAT)
         OLDZX = ZOOMX                  !save old zoom factors
C
C  zoomfactor taken from cursor box
C      
         IF (FLAG.EQ.1) THEN
            DX = ABS(XY2(1) - XY1(1))
            DY = ABS(XY2(2) - XY1(2))
            XM = XY1(1) + DX/2
            YM = XY1(2) + DY/2
C      
            IF ((DX.EQ.0).OR.(DY.EQ.0)) THEN         !check, if valid rectangle
               IF (IDX.EQ.1) GOTO 9000               !allow only one iteration
               CALL STTDIS('use cursors to form a rectangle...',1,STAT)
               IDX = 1
               GOTO 4000
            ENDIF
C      
            ZFX = NINT(FLOAT(QDSZX)/FLOAT(DX))
            IF (ZFX.LT.ZMLIM(1)) ZFX = ZMLIM(1)
            IF (ZFX.GT.ZMLIM(2)) ZFX = ZMLIM(2)
            ZFY = NINT(FLOAT(QDSZY)/FLOAT(DY))
            IF (ZFY.LT.ZMLIM(1)) ZFY = ZMLIM(1)
            IF (ZFY.GT.ZMLIM(2)) ZFY = ZMLIM(2)
            IF (ZFX.GT.ZFY) THEN
               ZOOMR = ZFX
            ELSE
               ZOOMR = ZFY
            ENDIF
C      
C  explicit zoom factors
C      
         ELSE IF (FLAG.EQ.2) THEN
            XM = XY1(1)
            YM = XY1(2)
            ZOOMR = DAZHLD(6)
C      
C  here for stepwise zooming
C      
         ELSE
            XM = XY1(1)
            YM = XY1(2)
            ZFX = ZOOMX + INC
            IF ( (ZFX.LT.ZMLIM(1)) .OR. (ZFX.GT.ZMLIM(2)) ) GOTO 5900   !done..
            ZOOMR = ZFX
         ENDIF
C
C  set SCROLX, SCROLY such, that zoom center remains unchanged
         IF (ZOOMR.NE.OLDZX) THEN
            ZFACT = FLOAT(ZOOMX) / FLOAT(ZOOMR)
            SCROLX = XM - NINT( (XM - SCROLX) * ZFACT )
            SCROLY = YM - NINT( (YM - SCROLY) * ZFACT )
C                                          keep x-scroll value in [0,memsize-1]
4100        IF (SCROLX.GE.QMSZX) THEN
               SCROLX = SCROLX - QMSZX
               GOTO 4100
            ENDIF
4120        IF (SCROLX.LT.0) THEN
               SCROLX = SCROLX + QMSZX
               GOTO 4120
            ENDIF
C                                          keep y-scroll value in [0,memsize-1]
4150        IF (SCROLY.GE.QMSZY) THEN
               SCROLY = SCROLY - QMSZY
               GOTO 4150
            ENDIF
4180        IF (SCROLY.LT.0) THEN
               SCROLY = SCROLY + QMSZY
               GOTO 4180
            ENDIF
         ENDIF
C
C  now zoom
         CALL DAZZSC(QDSPNO,CHAN,ZOOMR,SCROLX,SCROLY,STAT)   !set zoom + scroll
         CALL DAZVIS(QDSPNO,CHAN,1,REFSC)
C
C  update keyword DAZMEMI
         ZOOMX = ZOOMR
         ZOOMY =ZOOMX
         SCRX = SCROLX                  !save scroll values
         SCRY = SCROLY
         CALL DTPICH(QDSPNO,CHAN,WORK,RINF,STAT)
4400  CONTINUE
C      
C  if stepwise zooming, loop
      IF (FLAG.GE.3) THEN
         LOOP = 1
         GOTO 4000
      ENDIF
C      
C  if requested also update stuff for overlay channel
5900  IF (DAZHLD(13).EQ.0) THEN
         IF (QOVCH.GE.0) THEN 
            CALL DTGICH(QDSPNO,QOVCH,WORK,RINF,STAT)
            SCROLX = SCRX
            SCROLY = SCRY
            ZOOMX = ZOOMR
            ZOOMY = ZOOMX
            CALL DAZZSC(QDSPNO,QOVCH,ZOOMX,SCROLX,SCROLY,STAT)  
            CALL DTPICH(QDSPNO,QOVCH,WORK,RINF,STAT)
         ENDIF
      ENDIF
C      
C      
C  that's it folks...
C
C
9000  IZOOM(1) = ZOOMR
      IZOOM(2) = ZOOMR
      CALL STKWRI('DAZHOLD',IZOOM,6,2,KUNI,STAT)         !update keyword DAZHLD
      CALL DTCLOS(QDSPNO)
C 
      RETURN
      END

C @(#)tmask.for	19.1 (ES0-DMD) 02/25/03 13:29:45
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE TMASK(KAMP,DAK,CMA,PAR,NCO,BET,NPU,IVX,IVY,
     *                 ITER,MX,MY,MR,MC,PMA,KFL)
C
      IMPLICIT  NONE
      INTEGER   KAMP(10000,15,2)
      REAL      DAK(2000,3)
      REAL      CMA 
      REAL      PAR(1)
      INTEGER   NCO
      REAL      BET
      INTEGER   NPU
      INTEGER   IVX(1)
      INTEGER   IVY(1)
      INTEGER   ITER
      INTEGER   MX(1)
      INTEGER   MY(1)
      INTEGER   MR
      INTEGER   MC
      REAL      PMA
      INTEGER   KFL
C
      INTEGER   NPAR
      INTEGER   MC2, MR2
      INTEGER   KR
      INTEGER   I, II, IR, J
      INTEGER   IXF, IYF
      INTEGER   IDX, IDY, INDI
      INTEGER   INX, INY
      INTEGER   KDX, KDY
      INTEGER   KRX(100),KRY(100),KRM(100)
      INTEGER   LX, LY
      INTEGER   ISCA, IA, LF, LF1
      INTEGER   IND
      INTEGER   ISTAT
      
      REAL      RMAG
      REAL      D1, D2, DH
      REAL      PARS(300)
      REAL      RX, RY
C
      NPAR=NCO*4+3
      MC2=MC/2+1
      MR2=MR/2+1
      KR=0
C
      IF (ITER.EQ.1) THEN
         DO 10 I=1,NPAR
            PARS(I)=PAR(I)
   10    CONTINUE
         DO 20 I=1,NPU
           MX(I)=0
           MY(I)=0
   20    CONTINUE
         KR=1
      ELSE
         DO 30 I=1,NCO
            IND=4*I
            D1=ABS(PARS(IND+1)-PAR(IND+1))
            D2=ABS(PARS(IND+2)-PAR(IND+2))
            DH=-2.5*ALOG10(PARS(IND)/PAR(IND))
            IF(D1.GE.0.1) KRX(I)=1
            IF(D2.GE.0.1) KRY(I)=1
            IF(DH.GE.PMA) KRM(I)=1
            IF(KRX(I).EQ.1.OR.KRY(I).EQ.1.OR.KRM(I).EQ.1) KR=1
   30    CONTINUE
      END IF
C
      IF (KR.EQ.1) THEN
         KFL=0
         DO 40 II=1,NCO
            IND=II*4
            RX=PAR(IND+1)-INT(PAR(IND+1))
            RY=PAR(IND+2)-INT(PAR(IND+2))
            IXF=INT(RX*10+.5)
            IYF=INT(RY*10+.5)
            KDX=0
            KDY=0
            IF(IXF.EQ.5.AND.RX.GT..5) KDX=-1
            IF(IYF.EQ.5.AND.RY.GT..5) KDY=-1
            IF (IXF.LE.5) THEN
               IXF=IXF+5
            ELSE
              IXF=IXF-5
            END IF
            IF (IYF.LE.5) THEN
               IYF=IYF+5
            ELSE
               IYF=IYF-5
            END IF
            RMAG = -2.5*ALOG10(PAR(IND)*3.14159*PAR(IND+3)**2/
     2             (BET-1))+CMA
            IF (RMAG.LT.DAK(1,3)) THEN
               RMAG=DAK(1,3)
               KFL=1
            END IF
            LX=0
            LY=0
            IF (IXF.GT.5) THEN
               IXF=10-IXF
               LX=1
            END IF
            IF (IYF.GT.5) THEN
               IYF=10-IYF
               LY=1
            END IF
            ISCA = 0
            IF (IYF.LT.IXF) THEN
               IA=IXF
               IXF=IYF
               IYF=IA
               ISCA=1
            END IF
            LF=0
            LF1=0
            I=0
C
12          CONTINUE
            IF (LF.NE.0) GO TO 11
            I=I+1
            IF (I.GE.2000) THEN
               IF (LF1.EQ.0) THEN
                  CALL STTPUT('***FATAL: Too many data points'//
     2                        ' (TMASK)',ISTAT)
                  CALL STSEPI
               ELSE
                  I=IR
                  LF=1
               END IF
            ELSE
               IF (INT(DAK(I,1)*10+.5).EQ.IXF) THEN
                  IF (INT(DAK(I,2)*10+.5).EQ.IYF) THEN
                     IF (RMAG.GE.DAK(I,3)) THEN
                        IF (DAK(I,3).GT.0.1) THEN
                           LF1=1
                           IR=I
                           IF (RMAG-PMA.LT.DAK(I,3)) THEN
                              LF=1
                           END IF
                        END IF
                     END IF
                  END IF
               END IF
            END IF
            GO TO 12
C
11          CONTINUE
            INDI=(IR-1)*MR
            DO 50  J=1,NPU
               IDX=INT(PAR(IND+1)+.5)-IVX(J)
               IDY=INT(PAR(IND+2)+.5)-IVY(J)
               IDX=IDX+KDX
               IDY=IDY+KDY
               IF (LX.EQ.1) IDX=-IDX
               IF(LY.EQ.1) IDY=-IDY
               IF (ISCA.EQ.1) THEN
                  IA=IDX
                  IDX=IDY
                  IDY=IA
               END IF
               INX=MC2-IDX
               INY=MR2-IDY
               IF (INX.GE.1 .AND. INX.LE.MC .AND. 
     2             INY.GE.1.AND.INY.LE.MR) THEN
                  MX(J)=MAX0(MX(J),KAMP(INDI+INY,INX,1))
                  MY(J)=MAX0(MY(J),KAMP(INDI+INY,INX,2))
               ELSE
                  MX(J)=MAX0(MX(J),1)
                  MY(J)=MAX0(MY(J),1)
               END IF
  50        CONTINUE
  40     CONTINUE
C
         DO 60 I=1,NCO
            IND=4*I
            IF (KRM(I).EQ.1) THEN
               PARS(IND)=PAR(IND)
               KRM(I)=0
            END IF
            IF (KRX(I).EQ.1) THEN
               PARS(IND+1)=PAR(IND+1)
               KRX(I)=0
            END IF
            IF (KRY(I).EQ.1) THEN
               PARS(IND+2)=PAR(IND+2)
               KRY(I)=0
           END IF
  60     CONTINUE
      END IF
C
      RETURN
      END

C @(#)clst.for	19.1 (ES0-DMD) 02/25/03 13:27:13
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION:
C      CLST VERSION 1                 85.01.21
C      F. MURTAGH     ST-ECF, MUNICH
C
C.KEYWORDS:
C      APPLICATIONS, STATISTICS, CLUSTERING.
C
C.PURPOSE:
C      HIERARCHICAL CLUSTERING USING (USER-SPECIFIED) ALTERNATIVE
C      CRITERIA.
C      N * M ARRAY PASSED TO PROGRAM IN "DATA",
C      SEQUENCE OF N-1 AGGLOMERATIONS OF ROW POINTS RETURNED IN
C      VECTORS "IA" AND "IB", WITH CRITERION VALUES IN "CRIT".
C
C.ALGORITHM:
C      LANCE-WILLIAMS DISSIMILARITY RECURRENCE FORMULA USED;
C      SEVEN CLUSTER UPDATE CRITERIA ARE AVAILABLE;
C      THE DISSIMILARITY MATRIX IS SYMMETRIC AT ALL TIMES, AND
C      THE UPPER DIAGONAL HALF MATRIX ONLY IS STORED.
C
C.INPUT/OUTPUT:
C      PARAMETERS.
C      N, M, DATA : DIMENSIONS OF, AND ARRAY, OF DATA;
C      DISS, LEN  : DISSIMILARITIES IN LOWER HALF DIAG. STORAGE,
C                   LEN = N.N-1 / 2;
C      IOPT       : CLUSTERING CRITERION TO BE USED;
C      IA, IB, CRIT: HISTORY OF AGGLOMERATIONS (1ST N-1 VALS. USED);
C      MEMBR      : CARDINALITIES OF CLUSTERS;
C      NN, DISNN  : NEAREST NEIGHBOURS AND ASSOC. DISSIMILARITIES,
C                   USED TO SPEED UP SEARCH OF "DISS";
C      FLAG       : INDICATOR OF AGGLOMERABLE OBJECTS/CLUSTERS.
C      *** NOTE *** IJKLMN VARIABLE TYPE CONVENTION FOLLOWED.
C
C---------------------------------------------------------------
C
      SUBROUTINE CLST(N,M,LEN,IOPT,DATA,IA,IB,CRIT,MEMBR,NN,DISNN,
     X                FLAG,DISS)
      REAL DATA(N,M),MEMBR(N),DISS(LEN),X
      INTEGER IA(N),IB(N)
      REAL CRIT(N),DISNN(N),DMIN,XX
      INTEGER NN(N)
      INTEGER N,M,LEN,IOPT,I,J,K,I2,J2,JJ
      INTEGER IND,IOFFSET,NCL,JM,IM,IND1,IND2,IND3
      LOGICAL FLAG(N)
      REAL INF
      DATA INF/1.E+20/
C
C
C...  INITIALIZATIONS:
      DO I=1,N
         MEMBR(I)=1.
         FLAG(I)=.TRUE.
      ENDDO
      NCL=N
C
C
C...  CONSTRUCT DISSIMILARITY MATRIX:
      DO I=1,N-1
         DO J=I+1,N
            IND=IOFFSET(N,I,J)
            DISS(IND)=0.
            DO K=1,M
               DISS(IND)=DISS(IND)+(DATA(I,K)-DATA(J,K))**2
            ENDDO
            IF (IOPT.EQ.1) DISS(IND)=DISS(IND)/2.
C           (ABOVE IS DONE FOR THE CASE OF THE MIN. VAR. METHOD,
C            WHERE MERGING CRITERIA ARE DEFINED IN TERMS OF VARIANCES
C            RATHER THAN DISTANCES.)
          ENDDO
       ENDDO
C
C
C...  CARRY OUT AN AGGLOMERATION - FIRST CREATE LIST OF NN'S:
      DO I=1,N-1
         DMIN=INF
         DO J=I+1,N
            IND=IOFFSET(N,I,J)
            IF (DISS(IND).GE.DMIN) GOTO 500
               DMIN=DISS(IND)
               JM=J
  500    CONTINUE
         ENDDO
         NN(I)=JM
         DISNN(I)=DMIN
      ENDDO
C
  400 CONTINUE
C...  NEXT, DET. LEAST DISS. FROM LIST OF NN'S:
      DMIN=INF
      DO I=1,N-1
         IF (.NOT.FLAG(I)) GOTO 600
         IF (DISNN(I).GE.DMIN) GOTO 600
            DMIN=DISNN(I)
            IM=I
            JM=NN(I)
  600    CONTINUE
      ENDDO
      NCL=NCL-1
C
C
C...  THIS ALLOWS AN AGGLOMERATION TO BE CARRIED OUT:
      I2=MIN0(IM,JM)
      J2=MAX0(IM,JM)
      IA(N-NCL)=I2
      IB(N-NCL)=J2
      CRIT(N-NCL)=DMIN
C
C
C...  UPDATE DISS.'S FROM NEW CLUSTER:
      FLAG(J2)=.FALSE.
      DMIN=INF
      DO K=1,N
         IF (.NOT.FLAG(K)) GOTO 800
         IF (K.EQ.I2) GOTO 800
         X=MEMBR(I2)+MEMBR(J2)+MEMBR(K)
         IF (I2.LT.K) THEN
                           IND1=IOFFSET(N,I2,K)
                      ELSE
                           IND1=IOFFSET(N,K,I2)
         ENDIF
         IF (J2.LT.K) THEN
                           IND2=IOFFSET(N,J2,K)
                      ELSE
                           IND2=IOFFSET(N,K,J2)
         ENDIF
         IND3=IOFFSET(N,I2,J2)
         XX=DISS(IND3)
C
C...     WARD'S MINIMUM VARIANCE METHOD - IOPT=1.
         IF (IOPT.EQ.1) THEN
            DISS(IND1)=(MEMBR(I2)+MEMBR(K))*DISS(IND1)+
     X                 (MEMBR(J2)+MEMBR(K))*DISS(IND2)-
     X                 MEMBR(K)*XX
            DISS(IND1)=DISS(IND1)/X
         ENDIF
C
C...     SINGLE LINK METHOD - IOPT=2.
         IF (IOPT.EQ.2) THEN
            DISS(IND1)=MIN(DISS(IND1),DISS(IND2))
         ENDIF
C
C...     COMPLETE LINK METHOD - IOPT=3.
         IF (IOPT.EQ.3) THEN
            DISS(IND1)=MAX(DISS(IND1),DISS(IND2))
         ENDIF
C
C...     AVERAGE LINK (OR GROUP AVERAGE) METHOD - IOPT=4.
         IF (IOPT.EQ.4) THEN
            DISS(IND1)=(MEMBR(I2)*DISS(IND1)+MEMBR(J2)*DISS(IND2))/
     X                 (MEMBR(I2)+MEMBR(J2))
         ENDIF
C
C...     MCQUITTY'S METHOD - IOPT=5.
         IF (IOPT.EQ.5) THEN
            DISS(IND1)=0.5*DISS(IND1)+0.5*DISS(IND2)
         ENDIF
C
C...     MEDIAN (GOWER'S) METHOD - IOPT=6.
         IF (IOPT.EQ.6) THEN
            DISS(IND1)=0.5*DISS(IND1)+0.5*DISS(IND2)-0.25*XX
         ENDIF
C
C...     CENTROID METHOD - IOPT=7.
         IF (IOPT.EQ.7) THEN
            DISS(IND1)=(MEMBR(I2)*DISS(IND1)+MEMBR(J2)*DISS(IND2)-
     X          MEMBR(I2)*MEMBR(J2)*XX/(MEMBR(I2)+MEMBR(J2)))/
     X          (MEMBR(I2)+MEMBR(J2))
            ENDIF
C
         IF (I2.GT.K) GOTO 800
         IF (DISS(IND1).GE.DMIN) GOTO 800
            DMIN=DISS(IND1)
            JJ=K
  800    CONTINUE
      ENDDO
      MEMBR(I2)=MEMBR(I2)+MEMBR(J2)
      DISNN(I2)=DMIN
      NN(I2)=JJ
C
C
C...  UPDATE LIST OF NN'S INSOFAR AS THIS IS REQUIRED:
      DO I=1,N-1
         IF (.NOT.FLAG(I)) GOTO 900
         IF (NN(I).EQ.I2) GOTO 850
         IF (NN(I).EQ.J2) GOTO 850
         GOTO 900
  850    CONTINUE
C        (REDETERMINE NN OF I:)
         DMIN=INF
         DO J=I+1,N
            IND=IOFFSET(N,I,J)
            IF (.NOT.FLAG(J)) GOTO 870
            IF (I.EQ.J) GOTO 870
            IF (DISS(IND).GE.DMIN) GOTO 870
               DMIN=DISS(IND)
               JJ=J
  870       CONTINUE
         ENDDO
         NN(I)=JJ
         DISNN(I)=DMIN
  900    CONTINUE
      ENDDO
C
C
C...  REPEAT PREV. STEPS UNTIL N-1 AGGLOMERATIONS EFFECTED:
      IF (NCL.GT.1) GOTO 400
C
C
C
      RETURN
      END
C
C
C
      INTEGER FUNCTION IOFFSET(N,I,J)
C...  MAP ROW (I) AND COL. (J) OF UPPER HALF DIAGONAL SYMMETRIC
C     MATRIX ONTO VECTOR.
      INTEGER I,J,N
      IOFFSET=J+(I-1)*N-(I*(I+1))/2
      RETURN
      END

C @(#)elmor.for	19.1 (ES0-DMD) 02/25/03 13:29:43
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE ELMRF(IVX,IVY,VZ,NP,VP,FS,VPES,NC,BETA,SQM,LG,WEI,
     2                  SIG)
C+++
C.PURPOSE: Moffat o Gauss sigma fisso - piano orizzontale
C---
      IMPLICIT     NONE
      INTEGER      NST
      INTEGER      NIND
      PARAMETER    (NST=40)
      PARAMETER    (NIND=4*NST+3)
C
      INTEGER      IVX(1), IVY(1)
      REAL         VZ(1)
      INTEGER      NP
      REAL         VP(1)
      REAL         FS
      REAL         VPES(7)
      INTEGER      NC
      REAL         BETA
      REAL         SQM
      INTEGER      LG, THREE
      REAL         WEI(1)
      REAL         SIG
C
      REAL         VC, VTP, VPI
      REAL         CO
      INTEGER      N1
      INTEGER      INK, INK1, NCD
      REAL         EPE, EP2, EEE
      REAL         RMT
      REAL         VTN, VFZ, VFF, VFU, VG	
      REAL         DIX, DIY
      REAL         EP, EPES
      INTEGER      NIN
      INTEGER      I, J, K, L, N
      REAL         FK(NST)
C
      COMMON      /SUFR/RMT(NIND,NIND),VTN(NIND),VFZ(NIND),VFF(NIND),
     2                  VC(NIND)
C
C *** start the code
      THREE  = 3
      NIN=NC*3

      DO 10 I=1,NIN
         VFF(I) = 0
         VFZ(I) = 0
         VC(I)  = 0
         DO 11 J = 1,NIN
            RMT(I,J) = 0
   11    CONTINUE
   10 CONTINUE

      DO 20 I = 1,NC
         IF(BETA.LE.0.) THEN
            FK(I) = -4*ALOG(2.)/(VP(4*I+3)**2)
         ELSE
            FK(I) = 1./(VP(4*I+3)**2)
         END IF
   20 CONTINUE

      VPI    = VP(THREE)
      VTN(1) = 1.

      DO 30 K=1,NP
         VFU = 0.
         DO 31 L = 1,NC
            N    = L*3-2
            N1   = L*4
            DIX  = IVX(K)-VP(N1+1)
            DIY  = IVY(K)-VP(N1+2)
            EPES = DIX*DIX+DIY*DIY

            IF (BETA.LE.0) THEN
               EP = EXP(EPES*FK(L))
               CO = -VP(N1)*EP*2.*FK(L)
            ELSE
               EPE = 1.+EPES*FK(L)
               EP  = EPE**(-BETA)
               EP2 = EPE**(-BETA-1.)
               CO  = VP(N1)*BETA*EP2*2*FK(L)
            END IF

            VTN(N)   = EP
            VTN(N+1) = CO*DIX
            VTN(N+2) = CO*DIY
            VFU      = VP(N1)*EP+VFU
   31    CONTINUE

         VFU = VFU+VPI
         DO 32 I = 1,NIN
            VTP    = VTN(I)*WEI(K)
            VC(I)  = VC(I)+(VZ(K)-VFU)*VTP
            DO 36 J = 1,I
               RMT(I,J) = RMT(I,J)+VTN(J)*VTP
   36       CONTINUE
   32    CONTINUE
   30 CONTINUE

      DO 40 I = 2,NIN
         DO 41 J = 1,I-1
            RMT(J,I) = RMT(I,J)
   41    CONTINUE
   40 CONTINUE
 
      DO 50 I=1,NIN
         RMT(I,I) = RMT(I,I)*(1+FS**2)
   50 CONTINUE

      NCD = NIND
      CALL LISIB(RMT,VC,NIN,NCD,SIG)

      IF (NCD.GT.0) THEN
         DO 60 I = 1,NC
             DO 61 J = 4,6
               INK     = J+4*(I-1)
               INK1    = J+3*(I-1)
               VP(INK) = VC(INK1)*VPES(J)+VP(INK)
               IF(ABS(VP(INK)).GT.1000..AND.J.NE.4) NCD=-1
   61        CONTINUE
   60    CONTINUE

         IF (NCD.GT.0) THEN
            SQM = 0.
            DO 63 I = 1,NP
               VG = VP(THREE)
               DO 64 J = 1,NC
                  N   = J*4
                  EEE = ((VP(N+1)-IVX(I))**2 + (VP(N+2)-IVY(I))**2)/
     2                                         (VP(N+3)**2)
                  IF(BETA.LE.0.) THEN
                     VG = VG+VP(N)*EXP(-EEE*4*ALOG(2.))
                  ELSE
                     VG = VG+VP(N)*(1+EEE)**(-BETA)
                  END IF
   64          CONTINUE
               SQM = SQM+(VZ(I)-VG)**2*WEI(I)
   63       CONTINUE
            SQM = SQM/(NP-NIN)
         END IF
      END IF

      IF(NCD.LT.1) LG=1

      RETURN
      END

      SUBROUTINE ELMRFV(IVX,IVY,VZ,NP,VP,FS,VPES,NC,BETA,SQM,LG,WEI,
     2                  SIG)
C+++
C.PURPOSE: Moffat o Gauss sigma fisso - piano fisso
C---
      IMPLICIT     NONE
      INTEGER      NST
      INTEGER      NIND
      PARAMETER    (NST=40)
      PARAMETER    (NIND=4*NST+3)
C
      INTEGER      IVX(1), IVY(1)
      REAL         VZ(1)
      INTEGER      NP
      REAL         VP(1)
      REAL         FS
      REAL         VPES(7)
      INTEGER      NC
      REAL         BETA
      REAL         SQM
      INTEGER      LG, THREE
      REAL         WEI(1)
      REAL         SIG
C
      REAL         VC, VTP, VPI
      REAL         CO
      INTEGER      N1
      INTEGER      INK, INK1, NCD
      REAL         EPE, EP2, EEE
      REAL         RMT
      REAL         VTN, VFZ, VFF, VFU, VG
      REAL         DIX, DIY
      REAL         EP, EPES
      INTEGER      NIN
      INTEGER      I, J, K, L, N
      REAL         FK(NST)
C
      COMMON      /SUFR/RMT(NIND,NIND),VTN(NIND),VFZ(NIND),VFF(NIND),
     2                  VC(NIND)
C
C *** start the code
      THREE = 3
      NIN=NC*4

      DO 10 I=1,NIN
         VFF(I) = 0
         VFZ(I) = 0
         VC(I)  = 0
         DO 11 J = 1,NIN
            RMT(I,J) = 0
   11    CONTINUE
   10 CONTINUE

      DO 20 I = 1,NC
         IF(BETA.LE.0.) THEN
            FK(I) = -4*ALOG(2.)/(VP(4*I+3)**2)
         ELSE
            FK(I) = 1./(VP(4*I+3)**2)
         END IF
   20 CONTINUE

      VPI    = VP(THREE)
      VTN(1) = 1.

      DO 30 K=1,NP
         VFU = 0.
         DO 31 L = 1,NC
            N    = L*4-3
            N1   = L*4
            DIX  = IVX(K)-VP(N1+1)
            DIY  = IVY(K)-VP(N1+2)
            EPES = DIX*DIX+DIY*DIY

            IF (BETA.LE.0) THEN
               EP = EXP(EPES*FK(L))
               CO = -VP(N1)*EP*2.*FK(L)
            ELSE
               EPE = 1.+EPES*FK(L)
               EP  = EPE**(-BETA)
               EP2 = EPE**(-BETA-1.)
               CO  = VP(N1)*BETA*EP2*2*FK(L)
            END IF

            VTN(N)   = EP
            VTN(N+1) = CO*DIX
            VTN(N+2) = CO*DIY
            VTN(N+3) = CO*EPES/VP(N1+3)
            VFU      = VP(N1)*EP+VFU
   31    CONTINUE

         VFU = VFU+VPI
         DO 32 I = 1,NIN
            VTP    = VTN(I)*WEI(K)
            VC(I)  = VC(I)+(VZ(K)-VFU)*VTP
            DO 36 J = 1,I
               RMT(I,J) = RMT(I,J)+VTN(J)*VTP
   36       CONTINUE
   32    CONTINUE
   30 CONTINUE

      DO 40 I = 2,NIN
         DO 41 J = 1,I-1
            RMT(J,I) = RMT(I,J)
   41    CONTINUE
   40 CONTINUE
 
      DO 50 I=1,NIN
         RMT(I,I) = RMT(I,I)*(1+FS**2)
   50 CONTINUE

      NCD = NIND
      CALL LISIB(RMT,VC,NIN,NCD,SIG)

      IF (NCD.GT.0) THEN
         DO 60 I = 1,NC
             DO 61 J = 4,7
               INK     = J+4*(I-1)
               INK1    = INK-3
               VP(INK) = VC(INK1)*VPES(J)+VP(INK)
               IF(ABS(VP(INK)).GT.1000..AND.J.NE.4) NCD=-1
   61        CONTINUE
   60    CONTINUE

         IF (NCD.GT.0) THEN
            SQM = 0.
            DO 63 I = 1,NP
               VG = VP(THREE)
               DO 64 J = 1,NC
                  N   = J*4
                  EEE = ((VP(N+1)-IVX(I))**2 + (VP(N+2)-IVY(I))**2)/
     2                                         (VP(N+3)**2)
                  IF(BETA.LE.0.) THEN
                     VG = VG+VP(N)*EXP(-EEE*4*ALOG(2.))
                  ELSE
                     VG = VG+VP(N)*(1+EEE)**(-BETA)
                  END IF
   64          CONTINUE
               SQM = SQM+(VZ(I)-VG)**2*WEI(I)
   63       CONTINUE
            SQM = SQM/(NP-NIN)
         END IF
      END IF

      IF(NCD.LT.1) LG=1

      RETURN
      END

      SUBROUTINE ELMRR(IVX,IVY,VZ,NP,VP,FS,VPES,NC,BETA,SQM,LG,WEI,
     2                  SIG)
C+++
C.PURPOSE: Moffat o Gauss sigma fisso - piano orizzontale
C---
      IMPLICIT     NONE
      INTEGER      NST
      INTEGER      NIND
      PARAMETER    (NST=40)
      PARAMETER    (NIND=4*NST+3)
C
      INTEGER      IVX(1), IVY(1)
      REAL         VZ(1)
      INTEGER      NP
      REAL         VP(1)
      REAL         FS
      REAL         VPES(7)
      INTEGER      NC
      REAL         BETA
      REAL         SQM
      INTEGER      LG, THREE
      REAL         WEI(1)
      REAL         SIG
C
      REAL         VC, VTP, VPI
      REAL         CO
      INTEGER      N1
      INTEGER      INK, INK1, NCD
      REAL         EPE, EP2, EEE
      REAL         RMT
      REAL         VTN, VFZ, VFF, VFU, VG
      REAL         DIX, DIY
      REAL         EP, EPES
      INTEGER      NIN
      INTEGER      I, J, K, L, N
      REAL         FK(NST)
C
      COMMON      /SUFR/RMT(NIND,NIND),VTN(NIND),VFZ(NIND),VFF(NIND),
     2                  VC(NIND)
C
C *** start the code
      THREE = 3
      NIN=NC*3+1

      DO 10 I=1,NIN
         VFF(I) = 0
         VFZ(I) = 0
         VC(I)  = 0
         DO 11 J = 1,NIN
            RMT(I,J) = 0
   11    CONTINUE
   10 CONTINUE

      DO 20 I = 1,NC
         IF(BETA.LE.0.) THEN
            FK(I) = -4*ALOG(2.)/(VP(4*I+3)**2)
         ELSE
            FK(I) = 1./(VP(4*I+3)**2)
         END IF
   20 CONTINUE

      VPI    = VP(THREE)
      VTN(1) = 1.

      DO 30 K=1,NP
         VFU = 0.
         DO 31 L = 1,NC
            N    = L*3-1
            N1   = L*4
            DIX  = IVX(K)-VP(N1+1)
            DIY  = IVY(K)-VP(N1+2)
            EPES = DIX*DIX+DIY*DIY

            IF (BETA.LE.0) THEN
               EP = EXP(EPES*FK(L))
               CO = -VP(N1)*EP*2.*FK(L)
            ELSE
               EPE = 1.+EPES*FK(L)
               EP  = EPE**(-BETA)
               EP2 = EPE**(-BETA-1.)
               CO  = VP(N1)*BETA*EP2*2*FK(L)
            END IF

            VTN(N)   = EP
            VTN(N+1) = CO*DIX
            VTN(N+2) = CO*DIY
            VFU      = VP(N1)*EP+VFU
   31    CONTINUE

         VFU = VFU+VPI
         DO 32 I = 1,NIN
            VTP    = VTN(I)*WEI(K)
            VC(I)  = VC(I)+(VZ(K)-VFU)*VTP
            DO 36 J = 1,I
               RMT(I,J) = RMT(I,J)+VTN(J)*VTP
   36       CONTINUE
   32    CONTINUE
   30 CONTINUE

      DO 40 I = 2,NIN
         DO 41 J = 1,I-1
            RMT(J,I) = RMT(I,J)
   41    CONTINUE
   40 CONTINUE
 
      DO 50 I=1,NIN
         RMT(I,I) = RMT(I,I)*(1+FS**2)
   50 CONTINUE

      NCD = NIND
      CALL LISIB(RMT,VC,NIN,NCD,SIG)

      IF (NCD.GT.0) THEN
         VP(THREE) = VC(1)*VPES(3)+VP(THREE)
         DO 60 I = 1,NC
             DO 61 J = 4,6
               INK     = J+4*(I-1)
               INK1    = J+3*(I-1)-2
               VP(INK) = VC(INK1)*VPES(J)+VP(INK)
               IF(ABS(VP(INK)).GT.1000..AND.J.NE.4) NCD=-1
   61        CONTINUE
   60    CONTINUE

         IF (NCD.GT.0) THEN
            SQM = 0.
            DO 63 I = 1,NP
               VG = VP(THREE)
               DO 64 J = 1,NC
                  N   = J*4
                  EEE = ((VP(N+1)-IVX(I))**2 + (VP(N+2)-IVY(I))**2)/
     2                                         (VP(N+3)**2)
                  IF(BETA.LE.0.) THEN
                     VG = VG+VP(N)*EXP(-EEE*4*ALOG(2.))
                  ELSE
                     VG = VG+VP(N)*(1+EEE)**(-BETA)
                  END IF
   64          CONTINUE
               SQM = SQM+(VZ(I)-VG)**2*WEI(I)
   63       CONTINUE
            SQM = SQM/(NP-NIN)
         END IF
      END IF

      IF(NCD.LT.1) LG=1

      RETURN
      END

      SUBROUTINE ELMRRV(IVX,IVY,VZ,NP,VP,FS,VPES,NC,BETA,SQM,LG,WEI,
     2                  SIG)
C
C     MOFFAT O GAUSS SIGMA VAR. - PIANO ORIZZONTALE
C
C-------------
      IMPLICIT     NONE
      INTEGER      NST
      INTEGER      NIND
      PARAMETER (NST=40)
      PARAMETER (NIND=NST*4+3)
C
      INTEGER      IVX(1), IVY(1)
      REAL         VZ(1)
      INTEGER      NP
      REAL         VP(1)
      REAL         FS
      REAL         VPES(7)
      INTEGER      NC
      REAL         BETA
      REAL         SQM
      INTEGER      LG, THREE
      REAL         WEI(1)
      REAL         SIG
C
      REAL         VC, VTP, VPI
      REAL         CO
      INTEGER      N1
      INTEGER      INK, INK1, NCD
      REAL         EPE, EP2, EEE
      REAL         RMT
      REAL         VTN, VFZ, VFF, VFU, VG
      REAL         DIX, DIY
      REAL         EP, EPES
      INTEGER      NIN
      INTEGER      I, J, K, L, N
      REAL         FK(NST)
C
      COMMON /SUFR/RMT(NIND,NIND),VTN(NIND),VFZ(NIND),VFF(NIND),
     2             VC(NIND)

      THREE = 3
      NIN = NC*4+1
      DO 10 I=1,NIN
         VFF(I)=0
         VFZ(I)=0
         VC(I)=0
         DO 11 J=1,NIN
            RMT(I,J)=0
   11    CONTINUE
   10 CONTINUE
C
      DO 20 I=1,NC
         IF (BETA.LE.0.) THEN
            FK(I) = -4*ALOG(2.)/(VP(4*I+3)**2)
         ELSE
            FK(I) = 1./(VP(4*I+3)**2)
         END IF
   20 CONTINUE
C
      VPI    = VP(THREE)
      VTN(1) = 1.
      DO 30 K=1,NP
         VFU = 0.
         DO 31 L=1,NC
            N    = L*4-2
            N1   = L*4
            DIX  = IVX(K)-VP(N1+1)
            DIY  = IVY(K)-VP(N1+2)
            EPES = DIX*DIX+DIY*DIY
            IF (BETA.LE.0) THEN
               EP  = EXP(EPES*FK(L))
               CO  = -VP(N1)*EP*2.*FK(L)
            ELSE
               EPE = 1.+EPES*FK(L)
               EP  = EPE**(-BETA)
               EP2 = EPE**(-BETA-1.)
               CO  = VP(N1)*BETA*EP2*2*FK(L)
            END IF
C
            VTN(N)   = EP
            VTN(N+1) = CO*DIX
            VTN(N+2) = CO*DIY 
            VTN(N+3) = CO*EPES/VP(N1+3)
            VFU      = VP(N1)*EP+VFU
   31    CONTINUE
C
         VFU = VFU+VPI
         DO 32 I=1,NIN
            VTP   = VTN(I)*WEI(K)
            VC(I) = VC(I)+(VZ(K)-VFU)*VTP
            DO 132 J=1,I
               RMT(I,J) = RMT(I,J)+VTN(J)*VTP
  132       CONTINUE
   32    CONTINUE
   30 CONTINUE
C 
      DO 40 I=2,NIN
         DO 41 J=1,I-1
            RMT(J,I) = RMT(I,J)
   41    CONTINUE
   40 CONTINUE
C
      DO 50 I=1,NIN
         RMT(I,I) = RMT(I,I)*(1+FS**2)
   50 CONTINUE
C
      NCD=NIND
      CALL LISIB(RMT,VC,NIN,NCD,SIG)
      IF (NCD.GT.0) THEN
         VP(THREE) = VC(1)*VPES(3)+VP(THREE)
         DO 61 I=1,NC
            DO 161 J=4,7
               INK     = J+4*(I-1)
               INK1    = INK-2
               VP(INK) = VC(INK1)*VPES(J)+VP(INK)
               IF (ABS(VP(INK)).GT.1000..AND.J.NE.4) NCD=-1
  161       CONTINUE
   61    CONTINUE
C
         IF (NCD.GT.0) THEN 
            SQM = 0.
            DO 62 I=1,NP
               VG=VP(THREE)
               DO 162 J=1,NC
                  N   = J*4
                  EEE = ((VP(N+1)-IVX(I))**2+(VP(N+2)-IVY(I))**2)/
     2                   (VP(N+3)**2)
                  IF (BETA.LE.0.) THEN
                     VG = VG+VP(N)*EXP(-EEE*4*ALOG(2.))
                  ELSE
                     VG = VG+VP(N)*(1+EEE)**(-BETA)
                  END IF
  162          CONTINUE
               SQM = SQM+(VZ(I)-VG)**2*WEI(I)
   62       CONTINUE
            SQM = SQM/(NP-NIN)
         END IF
      END IF
C
      IF (NCD.LT.1) LG=1
      RETURN
      END

      SUBROUTINE ELMRPF(IVX,IVY,VZ,NP,VP,FS,VPES,NC,BETA,SQM,LG,WEI,SIG)
C+++
C.PURPOSE: Moffat o Gauss sigma fisso - piano orizzontale - posiz. fissa
C---  
      IMPLICIT     NONE
      INTEGER      NST
      INTEGER      NIND
      PARAMETER (NST=40)
      PARAMETER (NIND=4*NST+3)
C
      INTEGER      IVX(1), IVY(1)
      REAL         VZ(1)
      INTEGER      NP
      REAL         VP(1)
      REAL         FS
      REAL         VPES(7)
      INTEGER      NC
      REAL         BETA
      REAL         SQM
      INTEGER      LG, THREE
      REAL         WEI(1)
      REAL         SIG
C
      REAL         VC, VTP
      INTEGER      N1
      INTEGER      NCD
      REAL         EPE
      REAL         RMT
      REAL         VTN, VFZ, VFF, VFU, VG
      REAL         DIX, DIY
      REAL         EP, EPES,EEE
      INTEGER      NIN
      INTEGER      I, J, K, L, N
      REAL         FK(NST)
C
      COMMON    /SUFR/RMT(NIND,NIND),VTN(NIND),VFZ(NIND),
     2                VFF(NIND),VC(NIND)
C
      THREE = 3
      NIN = NC+1
      DO 10 I = 1,NIN
         VC(I)=0
         DO 20  J = 1,NIN
            RMT(I,J)=0
   20    CONTINUE
   10 CONTINUE
C
      DO 30 I = 1,NC
         IF (BETA.LE.0.) THEN
            FK(I) = -4*ALOG(2.)/(VP(4*I+3)**2)
         ELSE
            FK(I) = 1./(VP(4*I+3)**2)
         END IF
   30 CONTINUE
C
      VTN(1) = 1.
      DO 40  K = 1,NP
         VFU = 0.
         DO 41 L=1,NC
            N1   = L*4
            DIX  = IVX(K)-VP(N1+1)
            DIY  = IVY(K)-VP(N1+2)
            EPES = DIX*DIX+DIY*DIY
            IF (BETA.LE.0) THEN
               EP  = EXP(EPES*FK(L))
            ELSE
               EPE = 1.+EPES*FK(L)
               EP  = EPE**(-BETA)
            END IF
            VTN(L+1) = EP
   41    CONTINUE
C
         DO 42 I = 1,NIN
            VTP   = VTN(I)*WEI(K)
            VC(I) = VC(I)+VZ(K)*VTP
            DO 43 J=1,I
               RMT(I,J) = RMT(I,J)+VTN(J)*VTP
   43       CONTINUE
   42    CONTINUE
   40 CONTINUE
C
      DO 50 I = 2,NIN
         DO 51 J=1,I-1
            RMT(J,I)=RMT(I,J)
   51    CONTINUE
   50 CONTINUE
C
      NCD = NIND
      CALL LISIB(RMT,VC,NIN,NCD,SIG)
      IF (NCD.GT.0) THEN
         VP(THREE) = VC(1)
         DO 60 I=1,NC
            VP(I*4) = VC(I+1)
   60    CONTINUE
         SQM=0.
         DO 70 I=1,NP
            VG = VP(THREE)
            DO 71 J=1,NC
               N   = J*4
               EEE = ((VP(N+1)-IVX(I))**2+(VP(N+2)-IVY(I))**2)/
     2                (VP(N+3)**2)
               IF (BETA.LE.0.) THEN
                  VG = VG+VP(N)*EXP(-EEE*4*ALOG(2.))
               ELSE
                  VG = VG+VP(N)*(1+EEE)**(-BETA)
               END IF
   71       CONTINUE
            SQM=SQM+(VZ(I)-VG)**2*WEI(I)
   70    CONTINUE
         SQM=SQM/(NP-NIN)
      END IF
C
      IF (NCD.LT.1) LG=1
      RETURN
      END

      SUBROUTINE ELMRPV(IVX,IVY,VZ,NP,VP,FS,VPES,NC,BETA,SQM,LG,WEI,
     2                  SIG)
C+++
C.PURPOSE: Moffat o Gauss sigma fisso - piano orizzontale - posiz. fissa
C---
      IMPLICIT     NONE
      INTEGER      NST
      INTEGER      NIND
      PARAMETER    (NST=40)
      PARAMETER    (NIND=4*NST+3)
C
      INTEGER      IVX(1), IVY(1)
      REAL         VZ(1)
      INTEGER      NP
      REAL         VP(1)
      REAL         FS
      REAL         VPES(7)
      INTEGER      NC
      REAL         BETA
      REAL         SQM
      INTEGER      LG, THREE
      REAL         WEI(1)
      REAL         SIG
C
      REAL         VC, VTP, VPI
      REAL         CO
      INTEGER      N1
      INTEGER      INK, INK1, NCD
      REAL         EPE, EP2, EEE
      REAL         RMT
      REAL         VTN, VFZ, VFF, VFU, VG
      REAL         DIX, DIY
      REAL         EP, EPES
      INTEGER      NIN
      INTEGER      I, J, K, L, N
      REAL         FK(NST)
C
      COMMON      /SUFR/RMT(NIND,NIND),VTN(NIND),VFZ(NIND),VFF(NIND),
     2                  VC(NIND)
C
C *** start the code
      THREE = 3 
      NIN=NC*2+1

      DO 10 I=1,NIN
         VFF(I) = 0
         VFZ(I) = 0
         VC(I)  = 0
         DO 11 J = 1,NIN
            RMT(I,J) = 0
   11    CONTINUE
   10 CONTINUE

      DO 20 I = 1,NC
         IF(BETA.LE.0.) THEN
            FK(I) = -4*ALOG(2.)/(VP(4*I+3)**2)
         ELSE
            FK(I) = 1./(VP(4*I+3)**2)
         END IF
   20 CONTINUE

      VPI    = VP(THREE)
      VTN(1) = 1.

      DO 30 K=1,NP
         VFU = 0.
         DO 31 L = 1,NC
            N    = L*2
            N1   = L*4
            DIX  = IVX(K)-VP(N1+1)
            DIY  = IVY(K)-VP(N1+2)
            EPES = DIX*DIX+DIY*DIY

            IF (BETA.LE.0) THEN
               EP = EXP(EPES*FK(L))
               CO = -VP(N1)*EP*2.*FK(L)
            ELSE
               EPE = 1.+EPES*FK(L)
               EP  = EPE**(-BETA)
               EP2 = EPE**(-BETA-1.)
               CO  = VP(N1)*BETA*EP2*2*FK(L)
            END IF

            VTN(N)   = EP
            VTN(N+1) = CO*EPES/VP(N1+3)
            VFU      = VP(N1)*EP+VFU
   31    CONTINUE

         VFU = VFU+VPI
         DO 32 I = 1,NIN
            VTP    = VTN(I)*WEI(K)
            VC(I)  = VC(I)+(VZ(K)-VFU)*VTP
            DO 36 J = 1,I
               RMT(I,J) = RMT(I,J)+VTN(J)*VTP
   36       CONTINUE
   32    CONTINUE
   30 CONTINUE

      DO 40 I = 2,NIN
         DO 41 J = 1,I-1
            RMT(J,I) = RMT(I,J)
   41    CONTINUE
   40 CONTINUE
 
      DO 50 I=1,NIN
         RMT(I,I) = RMT(I,I)*(1+FS**2)
   50 CONTINUE

      NCD = NIND
      CALL LISIB(RMT,VC,NIN,NCD,SIG)

      IF (NCD.GT.0) THEN
         VP(THREE) = VC(1)*VPES(3)+VP(THREE)
         DO 60 I = 1,NC
             DO 61 J = 4,7,3
               INK     = J+4*(I-1)
               INK1    = INK/2
               VP(INK) = VC(INK1)*VPES(J)+VP(INK)
               IF(ABS(VP(INK)).GT.1000..AND.J.NE.4) NCD=-1
   61        CONTINUE
   60    CONTINUE

         IF (NCD.GT.0) THEN
            SQM = 0.
            DO 63 I = 1,NP
               VG = VP(THREE)
               DO 64 J = 1,NC
                  N   = J*4
                  EEE = ((VP(N+1)-IVX(I))**2 + (VP(N+2)-IVY(I))**2)/
     2                                         (VP(N+3)**2)
                  IF(BETA.LE.0.) THEN
                     VG = VG+VP(N)*EXP(-EEE*4*ALOG(2.))
                  ELSE
                     VG = VG+VP(N)*(1+EEE)**(-BETA)
                  END IF
   64          CONTINUE
               SQM = SQM+(VZ(I)-VG)**2*WEI(I)
   63       CONTINUE
            SQM = SQM/(NP-NIN)
         END IF
      END IF

      IF(NCD.LT.1) LG=1

      RETURN
      END

      SUBROUTINE ELMRV(IVX,IVY,VZ,NP,VP,FS,VPES,NC,BETA,SQM,LG,WEI,SIG)
C+++
C.PURPOSE: Moffat o Gauss sigma var. - piano inclinato
C---
      IMPLICIT     NONE
      INTEGER      NST
      INTEGER      NIND
      PARAMETER (NST=40)
      PARAMETER (NIND=4*NST+3)
C
      INTEGER      IVX(1), IVY(1)
      REAL         VZ(1)
      INTEGER      NP
      REAL         VP(1)
      REAL         FS
      REAL         VPES(7)
      INTEGER      NC
      REAL         BETA
      REAL         SQM
      INTEGER      LG, THREE, TWO
      REAL         WEI(1)
      REAL         SIG
C
      REAL         VC, VTP, VPI
      REAL         CO
      INTEGER      N1
      INTEGER      INK, NCD
      REAL         EPE, EP2, EEE
      REAL         RMT
      REAL         VTN, VFZ, VFF, VFU, VG
      REAL         DIX, DIY
      REAL         EP, EPES
      INTEGER      NIN
      INTEGER      I, J, K, L, N
      REAL         FK(NST)
C
      COMMON    /SUFR/RMT(NIND,NIND),VTN(NIND),VFZ(NIND),
     2                 VFF(NIND),VC(NIND)
C
      TWO   = 2
      THREE = 3
      NIN = NC*4+3
      DO 10 I = 1,NIN
         VFF(I) = 0
         VFZ(I) = 0
         VC(I)  = 0
         DO 11 J = 1,NIN
            RMT(I,J) = 0
   11    CONTINUE
   10 CONTINUE
C
      DO 20 I = 1,NC
         IF (BETA.LE.0.) THEN
            FK(I) = -4*ALOG(2.)/(VP(4*I+3)**2)
         ELSE
            FK(I) = 1./(VP(4*I+3)**2)
         END IF
   20 CONTINUE
C
      VTN(THREE) = 1.
      DO 30 K = 1,NP
         VTN(1) = IVX(K)
         VTN(2) = IVY(K)
         VPI    = VP(1)*IVX(K)+VP(TWO)*IVY(K)+VP(THREE)
         VFU    = 0.
         DO 31 L = 1,NC
            N1   = L*4
            DIX  = IVX(K)-VP(N1+1)
            DIY  = IVY(K)-VP(N1+2)
            EPES = DIX*DIX+DIY*DIY
            IF (BETA.LE.0) THEN
               EP = EXP(EPES*FK(L))
               CO = -VP(N1)*EP*2.*FK(L)
            ELSE
               EPE = 1.+EPES*FK(L)
               EP  = EPE**(-BETA)
               EP2 = EPE**(-BETA-1.)
               CO  = VP(N1)*BETA*EP2*2*FK(L)
            END IF
            VTN(N1)   = EP
            VTN(N1+1) = CO*DIX
            VTN(N1+2) = CO*DIY
            VTN(N1+3) = CO*EPES/VP(N1+3)
            VFU       = VP(N1)*EP+VFU
   31    CONTINUE
C
         VFU = VFU+VPI
         DO 32 I = 1,NIN
            VTP   = VTN(I)*WEI(K)
            VC(I) = VC(I)+(VZ(K)-VFU)*VTP
            DO 33 J = 1,I
               RMT(I,J) = RMT(I,J)+VTN(J)*VTP
   33       CONTINUE
   32     CONTINUE
   30 CONTINUE
C
      DO 40 I = 2,NIN
         DO 41 J = 1,I-1
            RMT(J,I) = RMT(I,J)
   41    CONTINUE
   40 CONTINUE

      DO 50 I = 1,NIN
         RMT(I,I) = RMT(I,I)*(1+FS**2)
   50 CONTINUE
C
      NCD = NIND
      CALL LISIB(RMT,VC,NIN,NCD,SIG)
      IF (NCD.GT.0) THEN
         DO 60 I = 1,3
            VP(I) = VC(I)*VPES(I)+VP(I)
   60    CONTINUE
C
         DO 70 I = 1,NC
            DO 71 J = 4,7
              INK     = J+4*(I-1)
               VP(INK) = VC(INK)*VPES(J)+VP(INK)
               IF(ABS(VP(INK)).GT.1000..AND.J.NE.4) NCD=-1
   71       CONTINUE
   70    CONTINUE
C
         IF (NCD.GT.0) THEN
            SQM = 0.
            DO 80 I = 1,NP
               VG = VP(1)*IVX(I)+VP(TWO)*IVY(I)+VP(THREE)
               DO 81 J = 1,NC
                  N   = J*4
                  EEE = ((VP(N+1)-IVX(I))**2+(VP(N+2)-IVY(I))**2)/
     2                   (VP(N+3)**2)
                  IF (BETA.LE.0.) THEN
                     VG = VG+VP(N)*EXP(-EEE*4*ALOG(2.))
                  ELSE
                     VG = VG+VP(N)*(1+EEE)**(-BETA)
                  END IF
   81          CONTINUE
               SQM = SQM+(VZ(I)-VG)**2*WEI(I)
   80       CONTINUE
            SQM = SQM/(NP-NIN)
         END IF
      END IF
C
      IF (NCD.LT.1) LG=1
      RETURN
      END

      SUBROUTINE ELMRH(IVX,IVY,VZ,NP,VP,FS,VPES,NC,BETA,SQM,LG,WEI,SIG)
C+++
C.PURPOSE: Moffat o Gauss sigma fisso - piano fisso - posiz. fissa
C---
      IMPLICIT     NONE
      INTEGER      NST
      INTEGER      NIND
      PARAMETER  (NST=40)
      PARAMETER  (NIND=4*NST+3)
C
      INTEGER      IVX(1), IVY(1)
      REAL         VZ(1)
      INTEGER      NP
      REAL         VP(1)
      REAL         FS
      REAL         VPES(7)
      INTEGER      NC
      REAL         BETA
      REAL         SQM
      INTEGER      LG, THREE
      REAL         WEI(1)
      REAL         SIG
C
      REAL         VC, VTP
      INTEGER      N1
      INTEGER      NCD
      REAL         EPE, EEE
      REAL         RMT
      REAL         VTN, VFZ, VFF, VFU, VG
      REAL         DIX, DIY
      REAL         EP, EPES
      INTEGER      NIN
      INTEGER      I, J, K, L, N
      REAL         FK(NST)
C
      COMMON    /SUFR/RMT(NIND,NIND),VTN(NIND),VFZ(NIND),
     2                VFF(NIND),VC(NIND)
C
      THREE = 3
      NIN = NC
      DO 10 I = 1,NIN
         VC(I) = 0
         DO 11 J = 1,NIN
            RMT(I,J) = 0
   11    CONTINUE
   10 CONTINUE
C
      DO 20 I = 1,NC
         IF (BETA.LE.0.) THEN
            FK(I) = -4*ALOG(2.)/(VP(4*I+3)**2)
         ELSE
            FK(I) = 1./(VP(4*I+3)**2)
         END IF
   20 CONTINUE
C
      DO 30 K = 1,NP
         VFU = 0.
         DO 31 L = 1,NC
            N1   = L*4
            DIX  = IVX(K)-VP(N1+1)
            DIY  = IVY(K)-VP(N1+2)
            EPES = DIX*DIX+DIY*DIY
            IF (BETA.LE.0) THEN
               EP = EXP(EPES*FK(L))
            ELSE
               EPE = 1.+EPES*FK(L)
               EP  = EPE**(-BETA)
            END IF
            VTN(L) = EP
   31    CONTINUE
C
         DO 32 I = 1,NIN
            VTP   = VTN(I)*WEI(K)
            VC(I) = VC(I)+VZ(K)*VTP
            DO 33 J = 1,I
               RMT(I,J) = RMT(I,J)+VTN(J)*VTP
   33       CONTINUE
   32    CONTINUE
   30 CONTINUE
C
      DO 40 I = 2,NIN
         DO 41 J = 1,I-1
            RMT(J,I) = RMT(I,J)
   41    CONTINUE
   40 CONTINUE
C
      NCD = NIND
      CALL LISIB(RMT,VC,NIN,NCD,SIG)
      IF (NCD.GT.0) THEN
         DO 50 I = 1,NC
            VP(I*4) = VC(I)
   50    CONTINUE
C
         SQM = 0.
         DO 60 I = 1,NP
            VG = VP(THREE)   
            DO 61 J = 1,NC
               N   = J*4  
               EEE = ((VP(N+1)-IVX(I))**2+(VP(N+2)-IVY(I))**2)/
     2                (VP(N+3)**2)
               IF (BETA.LE.0.) THEN
                  VG = VG+VP(N)*EXP(-EEE*4*ALOG(2.))
               ELSE
                  VG = VG+VP(N)*(1+EEE)**(-BETA)
               END IF
   61       CONTINUE
            SQM = SQM+(VZ(I)-VG)**2*WEI(I)
   60    CONTINUE
         SQM = SQM/(NP-NIN)
      END IF
C
      IF (NCD.LT.1) LG=1
      RETURN
      END

      SUBROUTINE ELMRX(IVX,IVY,VZ,NP,VP,FS,VPES,NC,BETA,SQM,LG,WEI,
     2                  SIG)
C+++
C.PURPOSE: Moffat o Gauss sigma fisso - piano orizzontale
C---
      IMPLICIT     NONE
      INTEGER      NST
      INTEGER      NIND
      PARAMETER    (NST=40)
      PARAMETER    (NIND=4*NST+3)
C
      INTEGER      IVX(1), IVY(1)
      REAL         VZ(1)
      INTEGER      NP
      REAL         VP(1)
      REAL         FS
      REAL         VPES(7)
      INTEGER      NC
      REAL         BETA
      REAL         SQM
      INTEGER      LG, THREE, TWO
      REAL         WEI(1)
      REAL         SIG
C
      REAL         VC, VTP, VPI
      REAL         CO
      INTEGER      N1
      INTEGER      INK, INK1, NCD
      REAL         EPE, EP2, EEE
      REAL         RMT
      REAL         VTN, VFZ, VFF, VFU, VG
      REAL         DIX, DIY
      REAL         EP, EPES
      INTEGER      NIN
      INTEGER      I, J, K, L, N
      REAL         FK(NST)
C
      COMMON      /SUFR/RMT(NIND,NIND),VTN(NIND),VFZ(NIND),VFF(NIND),
     2                  VC(NIND)
C
C *** start the code
      TWO   = 2
      THREE = 3
      NIN=NC*3+3

      DO 10 I=1,NIN
         VFF(I) = 0
         VFZ(I) = 0
         VC(I)  = 0
         DO 11 J = 1,NIN
            RMT(I,J) = 0
   11    CONTINUE
   10 CONTINUE

      DO 20 I = 1,NC
         IF(BETA.LE.0.) THEN
            FK(I) = -4*ALOG(2.)/(VP(4*I+3)**2)
         ELSE
            FK(I) = 1./(VP(4*I+3)**2)
         END IF
   20 CONTINUE

      VTN(THREE) = 1.

      DO 30 K=1,NP
         VTN(1) = IVX(K)
         VTN(2) = IVY(K)
         VPI    = VP(1)*IVX(K)+VP(TWO)*IVY(K)+VP(THREE)
         VFU = 0.
         DO 31 L = 1,NC
            N    = L*3+1
            N1   = L*4
            DIX  = IVX(K)-VP(N1+1)
            DIY  = IVY(K)-VP(N1+2)
            EPES = DIX*DIX+DIY*DIY

            IF (BETA.LE.0) THEN
               EP = EXP(EPES*FK(L))
               CO = -VP(N1)*EP*2.*FK(L)
            ELSE
               EPE = 1.+EPES*FK(L)
               EP  = EPE**(-BETA)
               EP2 = EPE**(-BETA-1.)
               CO  = VP(N1)*BETA*EP2*2*FK(L)
            END IF

            VTN(N)   = EP
            VTN(N+1) = CO*DIX
            VTN(N+2) = CO*DIY
            VFU      = VP(N1)*EP+VFU
   31    CONTINUE

         VFU = VFU+VPI
         DO 32 I = 1,NIN
            VTP    = VTN(I)*WEI(K)
            VC(I)  = VC(I)+(VZ(K)-VFU)*VTP
            DO 36 J = 1,I
               RMT(I,J) = RMT(I,J)+VTN(J)*VTP
   36       CONTINUE
   32    CONTINUE
   30 CONTINUE

      DO 40 I = 2,NIN
         DO 41 J = 1,I-1
            RMT(J,I) = RMT(I,J)
   41    CONTINUE
   40 CONTINUE
 
      DO 50 I=1,NIN
         RMT(I,I) = RMT(I,I)*(1+FS**2)
   50 CONTINUE

      NCD = NIND
      CALL LISIB(RMT,VC,NIN,NCD,SIG)

      IF (NCD.GT.0) THEN
         DO 59 I = 1,3
            VP(I) = VC(I)*VPES(I)+VP(I) 
   59    CONTINUE
         DO 60 I = 1,NC
            DO 61 J = 4,6
               INK     = J+4*(I-1)
               INK1    = J+3*(I-1)
               VP(INK) = VC(INK1)*VPES(J)+VP(INK)
               IF(ABS(VP(INK)).GT.1000..AND.J.NE.4) NCD=-1
   61        CONTINUE
   60    CONTINUE

         IF (NCD.GT.0) THEN
            SQM = 0.
            DO 63 I = 1,NP
               VG = VP(1)*IVX(I)+VP(TWO)*IVY(I)+VP(THREE)
               DO 64 J = 1,NC
                  N   = J*4
                  EEE = ((VP(N+1)-IVX(I))**2 + (VP(N+2)-IVY(I))**2)/
     2                                         (VP(N+3)**2)
                  IF(BETA.LE.0.) THEN
                     VG = VG+VP(N)*EXP(-EEE*4*ALOG(2.))
                  ELSE
                     VG = VG+VP(N)*(1+EEE)**(-BETA)
                  END IF
   64          CONTINUE
               SQM = SQM+(VZ(I)-VG)**2*WEI(I)
   63       CONTINUE
            SQM = SQM/(NP-NIN)
         END IF
      END IF

      IF(NCD.LT.1) LG=1
      RETURN
      END

C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================

C ++++++++++++++++++++++++  YEXTRCO.FOR +++++++++++++++++++++++++++++++++++++++
C .LANGUAGE Fortran 77
C .IDENTIFICATION Module YEXTRCO.FOR
C .COMMENTS
C Module contains layer between the keyword related FORTRAN STxxxx interfaces
C and the SC_interfaces written in (hopefully independent) C
C .AUTHOR         K. Banse        ESO - Garching
C .KEYWORDS       standard interfaces.
C .ENVIRONMENT    FORTRAN and C standards
C .VERSION  [1.00] 871207:  created from SXFTOC.C
C ......................................................
C
C
C  call as
C   EXTCOO(IMNO,STRING,PIXDIM,SUBDIM,SUBLO,SUBHI,STAT)
C   EXTCO1(IMNO,STRING,PIXDIM,SUBDIM,SUBLO,STAT)
C
C   input par:
C   IMNO:      I*4            image no
C   STRING:    char.exp.      input string of the form [c1,c2,c3:d1,d2,d3]
C   PIXDIM:    I*4            max. no. of dimensions
C
C   output par:
C   SUBDIM:    I*4            actual dimension of subframe
C   SUBLO:     I*4 array      low pixels
C   SUBHI:     I*4 array      high pixels
C   STAT:      I*4            return status, = 0 o.k., else not o.k.
C
C  and
C 
C   XEXTC2(IMNO,STRING,PIXDIM,SUBDIM,SUBLO,SUBHI,STAT)
C   XEXTC1(IMNO,STRING,PIXDIM,SUBDIM,SUBLO,STAT)
C
C  all parameters as above, except:
C   SUBLO:     R*4 array      low pixels    (for fractions of frame pixels)
C   SUBHI:     R*4 array      high pixels
C
C 001218          last modif
C
C -------------------------------------------------- 
C 
C 
      SUBROUTINE ARTIMA(FLAG,IMNO,NPIX,STRING,SIZE,RETIMNO,STAT)
C
      IMPLICIT NONE
C
      CHARACTER*(*)  STRING
      INTEGER     FLAG, IMNO
      INTEGER     NPIX, SIZE, RETIMNO, STAT
C 
      CALL STSTR(1,STRING)                      !STRIPPED_STRRING
C 
      CALL YART2(IMNO,FLAG,NPIX,SIZE,RETIMNO,STAT)
C
      RETURN
      END
C
      SUBROUTINE EXTCOO(IMNO,STRING,PIXDIM,SUBDIM,SUBLO,SUBHI,STAT)
C
      IMPLICIT NONE
C
      CHARACTER*(*)  STRING
      INTEGER     IMNO, PIXDIM
      INTEGER     SUBDIM,SUBLO,SUBHI,STAT
C
      CALL STSTR(1,STRING)                      !STRIPPED_STRRING
C 
      CALL YEXTC1(IMNO,PIXDIM,SUBDIM,SUBLO,SUBHI,STAT)
C
      RETURN
      END
C
      SUBROUTINE XEXTC2(IMNO,STRING,PIXDIM,SUBDIM,SUBLO,SUBHI,STAT)
C
      IMPLICIT NONE
C
      CHARACTER*(*)  STRING
      INTEGER     IMNO, PIXDIM
      INTEGER     SUBDIM,SUBLO,SUBHI,STAT
C
      CALL STSTR(1,STRING)                      !STRIPPED_STRRING
C 
      CALL YEXTC2(IMNO,PIXDIM,SUBDIM,SUBLO,SUBHI,STAT)
C
      RETURN
      END
C
      SUBROUTINE EXTCO1(IMNO,STRING,PIXDIM,SUBDIM,SUBLO,STAT)
C 
      IMPLICIT NONE
C
      CHARACTER*(*)  STRING
      INTEGER     IMNO, PIXDIM
      INTEGER     SUBDIM,SUBLO,STAT
C
      CALL STSTR(1,STRING)                      !STRIPPED_STRRING
C 
      CALL YEXC1(IMNO,PIXDIM,SUBDIM,SUBLO,STAT)
C
      RETURN
      END
C 
      SUBROUTINE XEXTC1(IMNO,STRING,PIXDIM,SUBDIM,SUBLO,STAT)
C 
      IMPLICIT NONE
C
      CHARACTER*(*)  STRING
      INTEGER     IMNO, PIXDIM
      INTEGER     SUBDIM,SUBLO,STAT
C
      CALL STSTR(1,STRING)                      !STRIPPED_STRRING
C 
      CALL YEXC2(IMNO,PIXDIM,SUBDIM,SUBLO,STAT)
C
      RETURN
      END
C

C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================

C ++++++++++++++++++++++++  YF2CGEN.FOR +++++++++++++++++++++++++++++++++++++++
C .LANGUAGE Fortran 77
C .IDENTIFICATION Module YF2CGEN.FOR
C .COMMENTS
C Module contains layer between the keyword related FORTRAN STxxxx interfaces
C and the SC_interfaces written in (hopefully independent) C
C .AUTHOR         K. Banse        ESO - Garching
C .KEYWORDS       standard interfaces.
C .ENVIRONMENT    FORTRAN and C standards
C .VERSION  [1.00] 871207:  created from SXFTOC.C
C ......................................................
C

      SUBROUTINE COPWND(PNTRA,NPIXA,PNTRB,NPIXB,BGNA,BGNB,ENDA)
C
      IMPLICIT NONE
C
      REAL   PNTRA(*), PNTRB(*)
      INTEGER  NPIXA,NPIXB,BGNA,BGNB,ENDA
C 
      CALL YY1(NPIXA,NPIXB,BGNA,BGNB)
      CALL YY2(PNTRA,PNTRB,ENDA)
C
      RETURN
      END
C
      SUBROUTINE COPYF1(PNTRA,NPIXA,BGNA,DIMWA,PNTRB,NPIXB,BGNB)
C
      IMPLICIT NONE
C
      REAL   PNTRA(*), PNTRB(*)
      INTEGER  NPIXA,NPIXB,BGNA,BGNB,DIMWA
C
      CALL YY1(NPIXA,NPIXB,BGNA,BGNB)
      CALL YY3(PNTRA,DIMWA,PNTRB)
C
      RETURN
      END
C
      SUBROUTINE JMAGN(JMETH, ARR, NX, NY, NI, NB, FAC, XC, YC,
     +                 MAG, DMAG, SKY, DSKY, NRPIX, FLUX, STAT )
C
      IMPLICIT NONE
C
      REAL   ARR(*), FAC, XC, YC, MAG, DMAG, SKY, DSKY
      REAL   NRPIX, FLUX
      INTEGER  JMETH, NX, NY, NI, NB, STAT
C
      CALL YY1(JMETH,NI,NB,0)
      CALL YY1a(NX, NY,XC, YC)
      CALL YY1b(MAG,DMAG,SKY,DSKY)
      CALL YY4(ARR,FAC,NRPIX,FLUX,STAT)
C
      RETURN
      END
C

      SUBROUTINE STACEN(P_IMG,DIMX,DIMY,METH,IMAGE,XOUT,YOUT,XERR,YERR,
     +             XSIG,YSIG,XYVAL,STAT)
C
      IMPLICIT NONE
C
      CHARACTER*(*) METH
      REAL   P_IMG(*), XOUT,YOUT,XERR,YERR,XSIG,YSIG, XYVAL
      INTEGER  DIMX, DIMY, IMAGE(*), STAT
C
      CALL YY1a(DIMX,DIMY,0.,0.)
      CALL YY1b(XOUT,YOUT,XERR,YERR)
      CALL YY1c(XSIG,YSIG,XYVAL)
      CALL YY5(P_IMG,METH,IMAGE,STAT)

C
      RETURN
      END
C

      SUBROUTINE PIXLIN(XA,YA,XB,YB,STEP,XINDX,YINDX,LIMIT,NINDX)
C
      IMPLICIT NONE
C
      REAL   XA,YA,XB,YB,STEP,XINDX,YINDX
      INTEGER  LIMIT, NINDX
C
      CALL YY1b(XA,YA,XB,YB)
      CALL YY6(STEP,XINDX,YINDX,LIMIT,NINDX)
C
      RETURN
      END
C
      SUBROUTINE ZIMA(P_IN,NPIX,XINDX,YINDX,NDIM,P_OUT,FMIN,FMAX)
C
      IMPLICIT NONE
C
      REAL   P_IN(*),P_OUT(*)
      REAL   XINDX,YINDX,FMIN,FMAX
      INTEGER  NPIX(*), NDIM
C
      CALL YY1b(XINDX,YINDX,FMIN,FMAX)
      CALL YY7(P_IN,NPIX,NDIM,P_OUT)
C
      RETURN
      END
C
      SUBROUTINE DATFIL(INFILE,DATTYP,TOTAL,A,B,MINFLG,FMIN,FMAX)
C
      IMPLICIT NONE
C
      CHARACTER*(*) INFILE
      REAL   A(*),B(*)
      REAL   FMIN,FMAX
      INTEGER  DATTYP,TOTAL,MINFLG
C
      CALL YY1(DATTYP,TOTAL,MINFLG,0)
      CALL YY8(INFILE,A,B,FMIN,FMAX)
C
      RETURN
      END

C @(#)random.for	19.1 (ES0-DMD) 02/25/03 14:25:40
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT      (c) 1988 European Southern Observatory
C.IDENT          RANDOM
C.LANGUAGE       ESO-FOR
C.AUTHOR         Preben Grosbol (ESO-IPG)
C.KEYWORDS       random numbers, uniform, gaussian
C.COMMENT        Generate pseudo-random numbers, see Handbook of
C                Mathematical Functions, Abramowitz and Stegun, p.949.
C.VERSION        1.0    1988-Oct-08 : Creation,      PJG
C---------------------------------------------------------------------
C
      SUBROUTINE USEED(IIA,IIB,IIX)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.PURPOSE     define seeds and starting number for new sequence of
C             pseudo-random numbers
C.RETURN      None
C---------------------------------------------------------------------
      INTEGER   IIA                 ! IN:  Multiplier seed
      INTEGER   IIB                 ! IN:  Adder seed
      INTEGER   IIX                 ! IN:  Initial value
C
      INTEGER   IT,IA,IB,IX
      REAL      RT
      COMMON /RANCOM/IA,IB,IX,IT,RT
C
C     INITIATE SEED VARIABLES IN COMMON
C
      IT = 2**15
      RT = 1.0 / FLOAT(IT)
      IA = IIA
      IB = IIB
      IX = IIX
      RETURN
      END
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
      REAL FUNCTION UNIRAN()
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.PURPOSE     compute next number of a uniformed randon distribution
C             in the interval [0;1]
C.ALGORITHM   Modulo formula: X = a*X + b (mod T)
C.RETURN      Uniformed pseudo-random number in interval [0;1]
C---------------------------------------------------------------------
      INTEGER   IT,IA,IB,IX
      REAL      RT
      COMMON    /RANCOM/IA,IB,IX,IT,RT
C
C     COMPUTE NEXT RANDOM NUMBER
C
      IX = MOD( IA*IX+IB , IT )
      UNIRAN = FLOAT(IX) * RT
      RETURN
      END
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
      REAL FUNCTION GA1RAN()
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.PURPOSE     compute next number of a gaussian randon distribution
C             with mean 0.0 and sigma 1.0.
C.ALGORITHM   Sum of 12 uniformed distributed pseudo-random numbers
C.RETURN      Gaussian pseudo-random number with [0,1]
C---------------------------------------------------------------------
      INTEGER   I,IT,IA,IB,IX
      REAL      RT,GX
      REAL      UNIRAN
      COMMON    /RANCOM/IA,IB,IX,IT,RT
C
C     COMPUTE NEXT RANDOM NUMBER
C
      GX = -6.0
      DO 100, I = 1,12
         GX = GX + UNIRAN()
  100 CONTINUE
      GA1RAN = GX
      RETURN
      END
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
      REAL FUNCTION GA2RAN()
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.PURPOSE     compute next number of a gaussian randon distribution
C             with mean 0.0 and sigma 1.0.
C.ALGORITHM   Rational Approx. of Xp where Q(Xp) = p using
C             formula 26.2.23 in Mathmatical Functions, p.933.
C.RETURN      Gaussian pseudo-random number with [0,1]
C---------------------------------------------------------------------
      INTEGER   IT,IA,IB,IX
      REAL      RT,GX,UX
      REAL      UNIRAN
      COMMON    /RANCOM/IA,IB,IX,IT,RT
C
C     COMPUTE NEXT RANDOM NUMBER
C
      UX = UNIRAN()
      GX = UX
      IF (UX.GT.0.5) GX = 1.0 - UX
      IF (GX.LE.0.0) GX = 1.0E-20
      GX = SQRT( -2.0*ALOG(GX) )
      GX = GX - (2.515517+GX*(0.802853+GX*0.01328))/
     /          (1.0+GX*(1.432788+GX*(0.189269+GX*0.001368)))
      IF (UX.GT.0.5) THEN
         GA2RAN = GX
      ELSE
         GA2RAN = -GX
      ENDIF
      RETURN
      END

C @(#)wrilin.for	19.1 (ES0-DMD) 02/25/03 13:29:45
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE WRILIN(NPL,NL,IY,IX,NV,DAT,RV)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION:  WRILIN
C.PURPOSE:         Routine che scrive una riga, o parte di essa,
C                  di una immagine formato midas (.bdf)
C.USE:             DATI INPUT:
C                  NPL - NL :  dimensioni x - y del file immagine
C                  IY       :  coordinata y della riga da scrivere
C                  IX  - NV :  coordinata x inizio scrittura e 
C                              nr. pixels scritti
C                  DAT      :  indirizzo file immagine - da chiamare con 
C                              %val(punt) con madrid(punt) che e' standard
C                              con le nuove rout. midas
C                  DATI OUTPUT:
C                  RV       :  vettore dati
C------------------------------------------------------------------------
      IMPLICIT  NONE
      INTEGER   NPL
      INTEGER   NL
      INTEGER   IX
      INTEGER   IY
      INTEGER   NV
      REAL      DAT(NPL,NL)
      REAL      RV(1)
C
      INTEGER   I,K
C ***
      K=0
      DO 10 I = IX,IX+NV-1
         K = K+1
         DAT(I,IY) = RV(K)
   10 CONTINUE
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.VERSION: 1.2  ESO-FORTRAN Conversion, AA  14:17 - 19 NOV 1989
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION:
C         PROGRAM tablefit
C
C.PURPOSE
C
C  Copy TABLE file into fit file after editing
C
C.KEYWORDS
C
C ARITHMETIC OPERATS, TABLES.
C
C.ALGORITHM
C
C USE TABLE INTERFACE ROUTINES
C
C.VERSION
C 080391	add FZMAPPED=0  M.Peron
C 100615	last modif
C-----------------------------------------------------------
C
      PROGRAM TBLFIT
      IMPLICIT NONE
C
      CHARACTER*72 LINE
      CHARACTER*80  FILENA, TABLE
      CHARACTER*80  SPEC
      CHARACTER*60  FUNC, PARM, BLANK, CTEST
      CHARACTER*16  LABEL1, LABEL2, UNIT
      CHARACTER*10  FORM
      INTEGER       KUN, KNUL, STAT, TID, NROW, I, II, IJ
      INTEGER       INDEX, IQUIT
      INTEGER       MADRID(1)
      LOGICAL       NULL1, NULL2
C
      INCLUDE      'MID_INCLUDE:ST_DEF.INC'
      INCLUDE      'MID_INCLUDE:FITI.INC'
      INCLUDE      'MID_INCLUDE:FITC.INC'
      COMMON/VMR/MADRID
      INCLUDE      'MID_INCLUDE:ST_DAT.INC'
      DATA          LABEL1/'FUNCTIONS   '/
      DATA          LABEL2/'PARAMETERS  '/
      DATA          FILENA/'           '/
      DATA          UNIT/'             '/
      DATA          FORM/'A40    '/
C
C ... GET INTO MIDAS
C
      CALL STSPRO('TBLFIT')
      CALL FITBL
C
C ... GET COMMAND FORM ENVIRONMENT
C

      CALL STKRDC('IN_A',1,1,80,I,FILENA,KUN,KNUL,STAT)
      CALL STKRDI('OUTPUTI',1,1,I,IQUIT,KUN,KNUL,STAT)
      I     = INDEX(FILENA,'.')
      IF (I .EQ. 0) I = INDEX(FILENA,' ')
      I     = I - 1
      TABLE = FILENA(1:I)//'_fit'
      IF (IQUIT.EQ.1) GOTO 100
C
C ... INITIALIZE FIT FILE
C

      CALL FTINIT(FILENA, STAT)

C
C ... INITIALIZE TABLE FILE
C
      CALL TBTOPN(TABLE, F_I_MODE, TID, STAT)
C
C ... INITIALIZE TABLE DATA
C
      BLANK  = ' '
      NROW   = 20
      FZNFUN = 0
      DO 10 I = 1, NROW
         CALL TBERDC(TID, I, 1, CTEST, NULL1, STAT)
         CALL FT_EOS(CTEST,60,FUNC,STAT)
         CALL TBERDC(TID, I, 2, CTEST, NULL2, STAT)
         CALL FT_EOS(CTEST,60,PARM,STAT)
         IF (NULL2) PARM = BLANK
         IF (INDEX(FUNC,'(').NE.0) THEN
C
C         WRITE(LINE,9999) I,FUNC
C9999     FORMAT(1X,I4,' Function :',A40)
C         CALL STTPUT(LINE,STAT)
C         WRITE(LINE,9998) I,PARM
C9998     FORMAT(1X,I4,' Parameter:',A40)
C         CALL STTPUT(LINE,STAT)
C
             FZNFUN = FZNFUN + 1
             IJ     = INDEX(FUNC,')')
             SPEC   = FUNC(1:IJ)//PARM
             II     = FZNFUN
             CALL FTDFUN(II, SPEC, STAT)
         ENDIF
10    CONTINUE
      CALL TBTCLO(TID, STAT)
      FZMAPPED = 0
      CALL FTEXIT(FILENA, STAT)
100   CONTINUE
      I = INDEX(TABLE,' ')
      I = I - 1
      FILENA = TABLE(1:I)//'.tbl'
      CALL STFDEL(FILENA, STAT)
      WRITE(6,*)STAT
      WRITE(LINE,9997) FILENA
9997  FORMAT(' Infor: delete ',A20)
      CALL STTPUT(LINE,STAT)
C
C ... EXIT FROM MIDAS
C
      CALL STSEPI
      END

C @(#)invsearch.for	19.1 (ES0-DMD) 02/25/03 13:26:21
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT:      Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.IDENTIFICATION: INVSEARCH.FOR
C.PURPOSE:        Searches image frame for objects and create output
C                 table with positions, local background levels, central
C                 intensities, and approximate sizes of found objects.
C.LANGUAGE:       ESO-FOR
C.AUTHOR:         A. Kruszewski
C.KEYWORDS:       SEARCH, STARS, GALAXIES, IMAGES
C.ALGORITHM:      Described in an additional document.
C.REMARKS:        Main program for SEARCH/INV command.
C.ENVIRONMENT:    Portable MIDAS
C.COMMENTS:       Main program only
C.VERSION:        JUL81 AK  Created as part of INVENTORY program
C.VERSION:        OCT83 ChO Made separate program
C.VERSION:        JUL87 AK  Indirect pixel addressing
C.VERSION:        NOV87 RHW ESO-FORTRAN Conversion, AA  8:56 - 23 NOV 1987
C.VERSION:        DEC88 AK  changes for portability
C-----------------------------------------------------------------------
      PROGRAM SRCOBJ
C
      IMPLICIT NONE
C
      INCLUDE  'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER   I , IACT , IARR(32)
      INTEGER   ICOL(6) , ICRCOL(6)
      INTEGER   ILIM , IMF
      INTEGER*8   IPNTR , JPNTR, KPNTR, LPNTR
      INTEGER   ISTAT , ITF
C     INTEGER   II
      INTEGER   JSIZE
      INTEGER   KNUL , KSIZE , KUN
      INTEGER   LSIZE
C     INTEGER   LN
      INTEGER   MADRID(1)
      INTEGER   M
      INTEGER   NAXIS , NPIX(2) , NX , NXS , NY
C
      REAL      ACAT(5,MAXCNT)
      REAL      RARR(64) , TMP(6)
C
      DOUBLE PRECISION   START(2) , STEP(2)
C
      CHARACTER*16   LABEL(6) , UNIT(6)
      CHARACTER*48   CUNIT
      CHARACTER*60   FRAME , TABNAME
      CHARACTER*72   IDENT
      CHARACTER*80   TEXT
C
C     INCLUDE  'MID_INCLUDE:TABLES.INC/NOLIST'
      INCLUDE  'MID_INCLUDE:ST_DEF.INC/NOLIST'
      COMMON     /VMR/MADRID
C     INCLUDE  'MID_INCLUDE:TABLED.INC/NOLIST'
      INCLUDE  'MID_INCLUDE:ST_DAT.INC/NOLIST'
C
      DATA UNIT/' ','MICRONS','MICRONS',' ',' ','PIXELS'/
      DATA LABEL/'IDENT','X','Y','BG','INT','AR'/
C
C *** Enter Midas environment.
C
      CALL STSPRO('SEARCHOBJ')
C
C *** Read names of input frame and output table.
C
      CALL STKRDC('IN_A', 1, 1, 60, IACT,
     &            FRAME, KUN, KNUL, ISTAT)
      CALL STKRDC('OUT_A', 1, 1, 60, IACT,
     &             TABNAME, KUN, KNUL, ISTAT)
C
C *** Open bulk data frame and read standard descriptors.
C
      CALL STIGET(FRAME, D_R4_FORMAT, F_I_MODE, F_IMA_TYPE, 2,
     &            NAXIS, NPIX, START, STEP, IDENT ,
     &            CUNIT, IPNTR, IMF, ISTAT)
      NX = NPIX(1)
      NY = NPIX(2)
C
C *** Read keywords.
C
      CALL RDKINV(IARR, RARR, ISTAT)
C
C *** Find borders of an area on which the search shall be made.
C *** It has the form of rectangle. The keyword PHYSICAL = IARR(7)
C *** tells if the search rectangle is defined by physical
C *** coordinates RARR(54) - RARR(57) (IARR(7)=1), or by
C *** pixel coordinates IARR(12) - IARR(15) (IARR(7)=0).
C
      IF ( IARR(7) .EQ. 1 ) THEN
          IARR(12) = 1 + NINT((DBLE(RARR(54)) - START(1))/STEP(1))
          IARR(13) = 1 + NINT((DBLE(RARR(55)) - START(2))/STEP(2))
          IARR(14) = 1 + NINT((DBLE(RARR(56)) - START(1))/STEP(1))
          IARR(15) = 1 + NINT((DBLE(RARR(57)) - START(2))/STEP(2))
      ENDIF
C
C *** Default is whole frame.
C
      IF (IARR(14).LE. MAX(IARR(12), 0)) THEN
          IARR(12) = 1
          IARR(14) = NX
      ENDIF
      IF (IARR(15).LE. MAX(IARR(13),0)) THEN
          IARR(13) = 1
          IARR(15) = NY
      ENDIF
C
C *** Frame margins IARR(19)-pixels wide are not searched.
C
      IARR(12) = MAX(IARR(12), IARR(19)+1)
      IARR(13) = MAX(IARR(13), IARR(19)+1)
      IARR(14) = MIN(IARR(14), NX-IARR(19))
      IARR(15) = MIN(IARR(15), NY-IARR(19))
C
C *** NXS - number of searched pixels in a line.
C
      NXS = IARR(14) - IARR(12) + 1
C
C *** Allocate memory for detection marking rolling array.
C
      ILIM = INT(RARR(43))
      KSIZE = 4 * (ILIM+1) * NXS
      CALL TDMGET(KSIZE, KPNTR, ISTAT)
C
C *** Allocate memory for array that set half-circle
C *** of ILIM radius in detection marking array.
C  
      LSIZE = 8 * (ILIM+1)
      CALL TDMGET(LSIZE, LPNTR, ISTAT)
C
C *** Allocate memory for line pointers array.
C
      JSIZE = 4 * NY
      CALL TDMGET(JSIZE, JPNTR, ISTAT)
C
C *** Perform calculations.
C
      CALL SEARCH(IMF, MADRID(IPNTR), MADRID(JPNTR), NX, NY,
     &            ACAT, MADRID(KPNTR), MADRID(LPNTR), IARR, RARR,
     &            M)
C
      WRITE (TEXT,'(A)') ' search completed'
      CALL STTPUT(TEXT , ISTAT)
C
C ***     Create output table.
C
      IF (M.GT.0) THEN
          CALL TBTINI(TABNAME,0,F_O_MODE,6,M,ITF,ISTAT)
          DO 10 I = 1, 6
              CALL TBCINI(ITF, D_R4_FORMAT, 1, 'E12.4', UNIT(I),
     &                     LABEL(I), ICRCOL(I), ISTAT)
   10     CONTINUE
C
C ***     Write results into output table.
C
          DO 20 I = 1, 6
              ICOL(I) = I
   20     CONTINUE
          DO 30 I = 1, M
              TMP(1) = FLOAT(I)
              TMP(2) = SNGL(START(1) + DBLE(ACAT(1,I)-1.0)*STEP(1))
              TMP(3) = SNGL(START(2) + DBLE(ACAT(2,I)-1.0)*STEP(2))
              TMP(4) = ACAT(3,I)
              TMP(5) = ACAT(4,I) - TMP(4)
              TMP(6) = ACAT(5,I)
              CALL TBRWRR(ITF, I, 6, ICOL, TMP, ISTAT)
   30     CONTINUE
C
C ***     Write descriptors into table.
C
          CALL STDWRD(ITF, 'START', START, 1, 2, KUN, ISTAT)
          CALL STDWRD(ITF, 'STEP', STEP, 1, 2, KUN, ISTAT)
C
C ***     Close output table.
C 
          CALL TBSINI( ITF , ISTAT )
          CALL TBTCLO( ITF , ISTAT )
      ENDIF
C
      CALL TDMFRE(JSIZE, JPNTR, ISTAT)
      CALL TDMFRE(KSIZE, KPNTR, ISTAT)
      CALL TDMFRE(LSIZE, LPNTR, ISTAT)
C
C *** Quit Midas environment.
C
      CALL STSEPI
c      STOP ' '
      END

C @(#)profil.for	19.1 (ES0-DMD) 02/25/03 13:25:37
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine PROFIL         version 2.1       830907
C  A. Kruszewski             ESO Garching
C  modified for FX           version 2.2       870303
C  A. Kruszewski             Obs. de Geneve
C.KEYWORDS
C  profiles
C.PURPOSE
C  calculates profile in eight octants for an object found in
C  an image frame
C.INPUT/OUTPUT
C  input arguments
C  A           real*4 array      image frame
C  N1          integer*4         x-dimansion of array A
C  N2          integer*4         y-dimension of array A
C  I           integer*4         x-coordinate of an object
C  J           integer*4         y-coordinate of an object
C  LIM         integer*4         radial extent of calculated profile
C                                expressed in pixels
C  LDBG        integer*4         output control
C  BGDR        real*4            local background
C  output arguments
C  PRFL        real*4 array      calculated profile in eight octants
C  ICNT        integer*4 array   number of pixels used in profile points
C-----------------------------------------------------------------------
      SUBROUTINE PROFIL(A, MA, JAPY, IBUF, I, J, LIM,
     &                  LDBG, BGRD, HCUT, PRFL, ICNT)
C
      IMPLICIT    NONE
      INCLUDE    'MID_REL_INCL:INVENT.INC/NOLIST'
C
      REAL        A(1)
      INTEGER     MA((-MAXSUB):MAXSUB,(-MAXSUB):MAXSUB)
      INTEGER     JAPY(1)
      INTEGER     IBUF(4)
      INTEGER     I
      INTEGER     J
      INTEGER     LIM
      INTEGER     LDBG
      REAL        BGRD
      REAL        HCUT
      REAL        PRFL(8,0:LIM)
      INTEGER     ICNT(8,0:LIM)
C
      INTEGER     IDD
      INTEGER     JOF, JOFF
      INTEGER     I1 , I2 , IADR , II , IVAL
      INTEGER     J1 , J2 , JJ , JM , K , L
      INTEGER     IMASK
      INTEGER     L1
C
      REAL        VAL
      REAL        X, XX
C
      INTEGER     IPRF(8)
C
C *** Set to zero data in arrays PRFL and ICNT.
C
      DO 10 L = 0 , LIM
          DO 11 K = 1 , 8
              PRFL(K,L) = 0.0
              ICNT(K,L) = 0
   11     CONTINUE
   10 CONTINUE
C
C *** Assign value to the central point of profile.
C
      JOFF = IBUF(2) - 1
      IADR = JAPY(J-JOFF) + I
      IMASK = MA(0,0)
      IF ( IMASK .GE. 1 ) THEN
          VAL = A(IADR) - BGRD
          IVAL = 1
      ELSE IF ( IMASK .EQ. -1 ) THEN
          VAL = HCUT - BGRD
          IVAL = -1
      ELSE
          VAL = 0.0
          IVAL = 0
      ENDIF
      DO 20 K = 1 , 8
          PRFL(K,0) = VAL
          ICNT(K,0) = IVAL
   20 CONTINUE
C
C *** Define subarray to be used.
C
      I1 = MAX( IBUF(1) , I-LIM )
      I2 = MIN( IBUF(3) , I+LIM )
      J1 = MAX( IBUF(2) , J-LIM )
      J2 = MIN( IBUF(4) , J+LIM )
C
C *** Start calculating profile.
C
      DO 30 JJ = J1 , J2
          JOF = JAPY(JJ-JOFF)
          JM = JJ - J
          DO 31 II = I1 , I2
C
C ***         Check if good pixel.
C
              IMASK = MA(II-I,JM)
              IF ( IMASK .EQ. 0 ) GOTO 31
              VAL = A(JOF+II)
C
C ***         Calculate ring number L.
C
              IDD = (J-JJ) * (J-JJ) + (I-II) * (I-II)
              XX = SQRT( FLOAT( IDD ) )
              X = 0.382683433 * XX
              L = NINT( XX )
              IF ( L .GT. 0 .AND. L .LE. LIM ) THEN
C
C ***             Searches for octant.
C
                  IF ( ABS(FLOAT(J-JJ)) .LT. X ) THEN
                      IF ( II .GT. I ) THEN
                          K = 1
                      ELSE
                          K = 5
                      ENDIF
                  ELSE IF ( ABS(FLOAT(I-II)) .LT. X ) THEN
                      IF ( JJ .GT. J ) THEN
                          K = 3
                      ELSE
                          K = 7
                      ENDIF
                  ELSE IF ( II-I .GT. 0 ) THEN
                      IF ( JJ-J .GT. 0 ) THEN
                          K = 2
                      ELSE
                          K = 8
                      ENDIF
                  ELSE
                      IF ( JJ-J .GT. 0 ) THEN
                          K = 4
                      ELSE
                          K = 6
                      ENDIF
                  ENDIF
                  IF ( IMASK .GE. 1 ) THEN
                      IF ( ICNT(K,L) .GT. 0 ) THEN
                          PRFL(K,L) = PRFL(K,L) + VAL
                          ICNT(K,L) = ICNT(K,L) + 1
                      ELSE IF ( ICNT(K,L) .EQ. 0 ) THEN
                          PRFL(K,L) = VAL
                          ICNT(K,L) = 1
                      ENDIF
                  ELSE IF ( IMASK .EQ. -1 ) THEN
                      ICNT(K,L) = -1
                  ENDIF
              ENDIF
   31     CONTINUE
   30 CONTINUE
C
C *** Calculate profile.
C
      DO 40 L = 1 , LIM
          DO 41 K = 1 , 8
              IF ( ICNT(K,L) .GT. 0 ) THEN
                  PRFL(K,L) = PRFL(K,L) / ICNT(K,L) - BGRD
              ELSE IF ( ICNT(K,L) .EQ. -1 ) THEN
                  PRFL(K,L) = HCUT - BGRD
              ELSE
                  PRFL(K,L) = 0.0
              ENDIF
   41     CONTINUE
   40 CONTINUE
C
      IF ( LDBG .GE. 3 ) THEN
C
C ***     Write profile into screen.
C
          L1 = MIN( LIM , 10 )
          WRITE (*,*) 'Eight octants pixel spaced profile'
          DO 50 L = 0 , L1
              DO 60 K = 1 , 8
                  IPRF(K) = INT( 1000.*PRFL(K,L) / BGRD )
   60         CONTINUE
              WRITE (*,'(8I9)') IPRF 
   50     CONTINUE
      ENDIF
C
      RETURN
C
      END

C @(#)normal.for	19.1 (ES0-DMD) 02/25/03 13:30:47
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE NORMAL(A,NPIX,CRMD,BGRD)                                       
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++       
C.IDENTIFICATION: NORMAL                                                        
C.AUTHOR:         A. Kruszewski             ESO Garching                        
C.PURPOSE:        Divides data contained in array "A" by its mode "BGRD"        
C                 and stores results in the same array "A"                      
C.INPUT/OUTPUT:   input arguments                                               
C                 A       real  array       image frame                         
C                 NPIX    integer array     dimensions of array "A"             
C                 CRMD    real array        control parameters                  
C                 output arguments                                              
C                 A       real array        image frame divided by mode "BGRD"  
C                 BGRD        real*4        mode of array "A"                   
C.VERSION:        830531  AK   Creation                                         
C.VERSION:        ??????  KB                                                    
C.VERSION:        880716  RHW  Fortran conversion                               
C -----------------------------------------------------------------------      
      IMPLICIT NONE 
      REAL     A(1)
      INTEGER  NPIX(2)
      REAL     BGRD(1)
      REAL     CRMD(1)                                             
C
      INTEGER  J
      INTEGER  N1, N2, N
      REAL     FACT
      REAL     SIGMA
C                                                                               
C *** get size                                                                  
      N1     = NPIX(1)                                                          
      N2     = NPIX(2)                                                          
      N      = N1*N2                                                            
C                                                                               
C *** calculates mode "BGRD"                                                    
      CALL MODE(A,N,CRMD,BGRD,SIGMA)                                            
C                                                                               
C *** divide data from array "A" by mode "BGRD"                                 
C     and store results in the same array "A"                                   
      FACT   = 1./BGRD(1)                                                       
      DO 10 J = 1,N                                                             
         A(J)   = A(J)*FACT                                                     
   10 CONTINUE                                                                  
C                                                                               
      RETURN                                                                    
      END                                                                       

C @(#)plot.for	19.1 (ES0-DMD) 02/25/03 13:28:47
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C  @(#)plot.for	5.3  (ESO-IPG)  3/28/93  12:53:39
      SUBROUTINE PLOT(NPTS,X,Y,SYMBOL)
c
c	Copyright (C) Andrew T. Young, 1990
C
C  If you have any comments, or problems with this program,
C  please report them to:
C                         A.T.YOUNG                        28 DEC. 1985
C
C
C  Plots on printer or crt screen, in area ncols x nrows.
C   (Default is 80 x 24 for terminal screen.)
C
C   (Default o/p unit is 6; can be reset -- see below.)
C
C  ARGUMENTS: NPTS is no.of points in X,Y arrays; SYMBOL plots at each point.
C   (NPTS is negative if more data sets follow, but 1st set fixes limits.)
C
C    PLOT determines X- and Y-limits unless forced -- see below.
C
C  If NPTS = 0 and...
C
C    SYMBOL = 'I'   Inverts X if X(1)=1., Inverts Y if Y(1)=1.
C             'L'   sets LIMITS in X-Y plane to (X(1),X(2)), (Y(1),Y(2)).
C             'P'   sets PAGE SIZE to  NCOLS=X(1), NROWS=Y(1).
C             'S'   all points plot  SAME  SYMBOL(1).
C             'D'   all points plot  DIFFERENT  SYMBOLs(NP).
C             'O'   sets treatment for points Outside plot area.
C             'U'   sets ftn.output unit to INT(X(1)).  (DEFAULT = 6.)
C
C
      IMPLICIT NONE
C
      INTEGER NPTS, NCOLS, NROWS, NUNIT, NP, N, IX, IY, NROW, LAST, NCOL
      REAL X, Y, XMIN, XMAX, YMIN, YMAX, CMX, RMX, XX, DELX, UNITX,DELY, 
     1         UNITY, DY, YROW, DX, ABSXX
C
      SAVE
      EXTERNAL ROUND
C
      LOGICAL NOTYET,LIMITS,READY,INVX,INVY,SAME,XOUT,YOUT
      DIMENSION X(1000),Y(1000),SYMBOL(1000)
      INTEGER MXROWS,MXCOLS
      PARAMETER (MXROWS=32, MXCOLS=80)
      CHARACTER ROW(MXROWS)*80,SYMB,SYMBOL,WORD*5,W7*7
C
      DATA LIMITS/.FALSE./,READY/.FALSE./,INVX/.FALSE./,INVY/.FALSE./,
     1 SAME/.TRUE./, XOUT/.FALSE./,YOUT/.FALSE./
      DATA NCOLS/80/, NROWS/24/, NUNIT/6/
C
C
      NP=NPTS

      IF(NP)1,2,15
    1 NOTYET=.TRUE.
C    Neg.NPTS flags more data.
      NP=-NP
      GO TO 16
C
C  SPECIAL if NPTS=0.
C
    2 NOTYET=.TRUE.
      IF(SYMBOL(1).NE.'L') GO TO 3
C  L = LIMITS in X-Y plane.
      XMIN=X(1)
      XMAX=X(2)
      YMIN=Y(1)
      YMAX=Y(2)
      LIMITS=.TRUE.
      RETURN
C
C  P = PAGE SIZE -- set NROWS, NCOLS.
    3 IF(SYMBOL(1).NE.'P') GO TO 5
      IF(X(1).LT.7. .OR. Y(1).LT.5.) GO TO 90
      CMX=MXCOLS
      IF(X(1).GT.CMX)THEN
          IF(NUNIT.EQ.6)THEN
              WRITE(ROW(1),4)'NCOLS = ',X(1),CMX
              CALL TV(ROW(1))
          ELSE
              WRITE(NUNIT,4)'NCOLS = ',X(1),CMX
          END IF
      END IF
    4 FORMAT(/' NOT ENOUGH ROOM FOR ',A8,F5.0//' Reduced to ',F4.0/)
      RMX=MXROWS
      IF(Y(1).GT.RMX)THEN
          IF(NUNIT.EQ.6)THEN
              WRITE(ROW(1),4)'NROWS = ',Y(1),RMX
              CALL TV(ROW(1))
          ELSE
              WRITE(NUNIT,4)'NROWS = ',Y(1),RMX
          END IF
      END IF
      NCOLS=MIN(X(1),CMX)
      NROWS=MIN(Y(1),RMX)
      RETURN
C
C  I = INVERTED plots.
    5 IF(SYMBOL(1).NE.'I') GO TO 7
      INVX=.FALSE.
      IF(X(1).NE.1.) GO TO 6
      INVX=.TRUE.
    6 INVY=.FALSE.
      IF(Y(1).NE.1.)RETURN
      INVY=.TRUE.
      RETURN
C
C  S = SAME SYMBOL for all points.
    7 IF(SYMBOL(1).NE.'S') GO TO 8
      SAME=.TRUE.
      RETURN
C
C  D = DIFFERENT SYMBOL for each point.
    8 IF(SYMBOL(1).NE.'D') GO TO 9
      SAME=.FALSE.
      RETURN
C
C  O = treatment for points OUTSIDE plot area:
C      flagged by ^ or v if Y(1)=1.  (Not flagged if 0.)
C      flagged by > or < if X(1)=1.  (Not flagged if 0.)
    9 IF(SYMBOL(1).NE.'O')GO TO 10
      XOUT=.FALSE.
      YOUT=.FALSE.
      IF (X(1).GT.0.) XOUT=.TRUE.
      IF (Y(1).GT.0.) YOUT=.TRUE.
      RETURN
C
C  U = UNIT number.
   10 IF(SYMBOL(1).NE.'U')GO TO 91
      NUNIT=X(1)
      RETURN
C
C
C   NORMAL ENTRY.
C
   15 NOTYET=.FALSE.
   16 IF(READY) GO TO 34
      IF(LIMITS) GO TO 18
C
C  SET LIMITS on first entry, if not set before.
C
      XMIN=X(1)
      XMAX=X(1)
      YMIN=Y(1)
      YMAX=Y(1)
      IF(NP.EQ.1) GO TO 92
      DO 17 N=2,NP
      XMIN=MIN(XMIN,X(N))
      XMAX=MAX(XMAX,X(N))
      YMIN=MIN(YMIN,Y(N))
   17 YMAX=MAX(YMAX,Y(N))
C    INVERT limits:
      IF(INVX)THEN
      XX=XMIN
      XMIN=XMAX
      XMAX=XX
      END IF
      IF(INVY)THEN
      XX=YMIN
      YMIN=YMAX
      YMAX=XX
      END IF
C    Expand limits to next ROUND values.
   18 IF(XMIN.EQ.XMAX .OR. YMIN.EQ.YMAX) GO TO 95
      CALL ROUND(XMIN,XMAX,NCOLS-5,DELX,IX,UNITX)
      CALL ROUND(YMIN,YMAX,NROWS-3,DELY,IY,UNITY)
C
C  CLEAR IMAGE.
C
      DO 19 NROW=1,NROWS-2
   19 ROW(NROW)(:NCOLS)='     I'
C
C  LABEL AXES, vert.first.
C
      DY=(DELY/(IY))*UNITY
      YROW=YMIN/UNITY
C   Ticks and values.
      DO 20 NROW=NROWS-3,1,-IY
      WRITE(ROW(NROW),'(1X,F4.0,''+'')') YROW
      LAST=NROW
   20 YROW=YROW+DELY
      IF(UNITY-1.)21,32,24
C   Scale label.
   21 WRITE(WORD,'(F4.2)')UNITY
      IF(UNITY.GT..009)GO TO 25
C    Exponent.
   22 WRITE(W7,'(1PE7.1)')UNITY
      WORD(2:5)=W7(4:7)
      GO TO 25
   24 WRITE(WORD,'(F5.0)')UNITY
      IF(UNITY.GT.150.)GO TO 22
   25 READ(WORD,'(1X,A4)')WORD
      IF(LAST.GT.2) LAST=0
      LAST=LAST+1
      ROW(LAST+1)(2:5)=WORD(:4)
      IF(UNITY.LT.150. .AND. UNITY.GT..009)ROW(LAST)(3:3)='X'
C
C   X-AXIS...
C
   32 ROW(NROWS-3)(7:NCOLS)='-------------------------------------------
     1------------------------------------------------------------------
     2-----'
      DX=(DELX/(IX))*UNITX
      XX=XMIN/UNITX
C   Ticks and values.
      DO 33 NCOL=6,NCOLS-2,IX
C       ABSXX=ABS(XX)+.4
C       Find longest label to print:
        ABSXX=MAX(XMIN, XMAX, -10.*XMAX, -10.*XMIN)/UNITX+.4
        IF (ABSXX.LT.99.5) THEN
          WRITE(ROW(NROWS-2)(NCOL-2:NCOL+1),'(F4.0)') XX
        ELSE IF(IX.GE.4 .AND. ABSXX.LT.999.5) THEN
          WRITE(ROW(NROWS-2)(NCOL-2:NCOL+2),'(F5.0)') XX
        ELSE IF(IX.GT.4 .AND. ABSXX.LT.9999.5) THEN
          WRITE(ROW(NROWS-2)(NCOL-3:NCOL+2),'(F6.0)') XX
        ELSE
C         Label every other tick.
          IF(MOD(ABS(XX)+.4,ABS(DELX+DELX)).LT.0.5)
     1       WRITE(ROW(NROWS-2)(NCOL-4:NCOL+2),'(F7.0)') XX
        END IF
        ROW(NROWS-3)(NCOL:NCOL)='+'
   33 XX=XX+DELX
      IF(UNITX.EQ.1.) GO TO 34
C    Exponent.
      WRITE(W7,'(1PE7.1)')UNITX
      ROW(NROWS-2)(NCOLS-3:NCOLS)=W7(4:7)
   34 READY=.TRUE.
      IF(NP.EQ.0) RETURN
C
C  PUT POINTS in IMAGE.
C
      DO 35 N=1,NP
        IF (X(N).EQ.3.E33 .OR. Y(N).EQ.3.E33) GO TO 35
        NROW=(YMAX-Y(N))/DY + 1.5
        NCOL=(X(N)-XMIN)/DX + 6.5
C    Treat pts.Outside area:
        IF(NROW.LT.1) THEN
C         Y is above area.
          IF (YOUT) THEN
C           Put edge marker in plot.
            IF(NCOL.LT.6) THEN
C             Both X & Y out.  Mark upper left corner.
              IF (XOUT) ROW(1)(6:6)=CHAR(92)
            ELSE IF(NCOL.GT.NCOLS) THEN
C             Both X & Y out.  Mark upper right corner.
              IF (XOUT) ROW(1)(NCOLS:NCOLS)='/'
            ELSE
C             X is inside.  Mark correct column.
              ROW(1)(NCOL:NCOL)='^'
            END IF
          ELSE
C           Ignore.
          END IF
          GO TO 35
        ELSE IF(NROW.GT.NROWS-3) THEN
C         Y is below area.
          IF (YOUT) THEN
C           Put edge marker in plot.
            IF(NCOL.LT.6) THEN
C             Both X & Y out.  Mark lower left corner.
              IF (XOUT) ROW(NROWS-3)(6:6)='/'
            ELSE IF(NCOL.GT.NCOLS) THEN
C             Both X & Y out.  Mark lower right corner.
              IF (XOUT) ROW(NROWS-3)(NCOLS:NCOLS)=CHAR(92)
            ELSE
C             X is inside.  Mark correct column.
              ROW(NROWS-3)(NCOL:NCOL)='v'
            END IF
          ELSE
C           Ignore.
          END IF
          GO TO 35
        ELSE
C         Y is inside area, so NROW is OK.  Check X:
          IF(NCOL.LT.6) THEN
C           X is off left edge.
            IF (XOUT) ROW(NROW)(6:6)='<'
            GO TO 35
          ELSE IF(NCOL.GT.NCOLS) THEN
C           X is off right edge.
            IF (XOUT) ROW(NROW)(NCOLS:NCOLS)='>'
            GO TO 35
          ELSE
C           Both are inside.  Plot.
          END IF
        END IF
C
        SYMB=ROW(NROW)(NCOL:NCOL)
        IF ((XOUT.OR.YOUT).AND.(SYMB.EQ.'^'.OR.SYMB.EQ.'v'.OR.
     1           SYMB.EQ.'>'.OR.SYMB.EQ.'<'.OR.SYMB.EQ.'/'.OR.
     2           SYMB.EQ.CHAR(92)))THEN
        ELSE IF(SYMB.EQ.' '.OR.SYMB.EQ.'-'.OR.
     1     SYMB.EQ.' '.OR.SYMB.EQ.'-'.OR.SYMB.EQ.'I'.OR.SYMB.EQ.'+')THEN
          IF(SAME)THEN
            ROW(NROW)(NCOL:NCOL)=SYMBOL(1)
          ELSE
            ROW(NROW)(NCOL:NCOL)=SYMBOL(N)
          END IF
        ELSE
          ROW(NROW)(NCOL:NCOL)='$'
        END IF
   35 CONTINUE
      IF(NOTYET) RETURN
C
C  PRINT PLOT.
C
      IF(NUNIT.EQ.6)THEN
          DO 40 N=1,NROWS-2
              CALL TVN(ROW(N)(:NCOLS))
   40     CONTINUE
      ELSE
          WRITE(NUNIT,'(A)') (ROW(N)(:NCOLS),N=1,NROWS-2)
      END IF
      LIMITS=.FALSE.
      READY=.FALSE.
      RETURN
C
C  ERROR RETURNS.
C
   90 IF(NUNIT.EQ.6)THEN
          WRITE(ROW(1),'(2(A,G10.5))')'NCOLS = ',X(1),', NROWS = ',Y(1)
          CALL TVN(ROW(1))
          WRITE(ROW(1),'(A)')'PAGE TOO SMALL TO PLOT IN.'
          CALL TVN(ROW(1))
      ELSE
          WRITE(NUNIT,'(2(A,G10.5))')'NCOLS = ',X(1),', NROWS = ',Y(1)
          WRITE(NUNIT,'(A)')'PAGE TOO SMALL TO PLOT IN.'
C          WRITE(NUNIT,*)'NCOLS = ',X(1),', NROWS = ',Y(1)
C          WRITE(NUNIT,*)'PAGE TOO SMALL TO PLOT IN.'
      END IF
      GO TO 99
C
   91 IF(NUNIT.EQ.6)THEN
      WRITE(ROW(1),'(A)')SYMBOL(1)//
     1       ' IS NOT A RECOGNISED CODE FOR NPTS = 0.'
       CALL TVN(ROW(1))
       WRITE(ROW(1),'(A)')
     1    'POSSIBLE ATTEMPT TO PLOT A ZERO-LENGTH ARRAY.'
       CALL TVN(ROW(1))
      ELSE
       WRITE(NUNIT,'(A)')SYMBOL(1),' IS NOT A RECOGNISED CODE'//
     1     ' FOR NPTS = 0.'
       WRITE(NUNIT,'(A)')'POSSIBLE ATTEMPT TO PLOT A ZERO-LENGTH ARRAY.'
C       WRITE(NUNIT,*)SYMBOL(1),' IS NOT A RECOGNISED CODE FOR NPTS = 0.'
C       WRITE(NUNIT,*)'POSSIBLE ATTEMPT TO PLOT A ZERO-LENGTH ARRAY.'
      END IF
      GO TO 99
C
   92 IF(NUNIT.EQ.6)THEN
        WRITE(ROW(1),'(2(A,G10.5),A)')'ONE POINT (',X(1),',',Y(1),
     1     ') CANNOT SET LIMITS.'
        CALL TVN(ROW(1))
      ELSE
        WRITE(NUNIT,'(2(A,G10.5),A)')'ONE POINT (',X(1),',',Y(1),
     1     ') CANNOT SET LIMITS.'
C        WRITE(NUNIT,*)'ONE POINT (',X(1),',',Y(1),') CANNOT SET LIMITS.'
      END IF
      GO TO 99
C
   95 IF(XMAX.EQ.XMIN) SYMB='X'
      IF(YMAX.EQ.YMIN) SYMB='Y'
      IF(NUNIT.EQ.6)THEN
          WRITE(ROW(1),'(A)')'ALL '//SYMB//' VALUES EQUAL.'
          CALL TVN(ROW(1))
      ELSE
          WRITE(NUNIT,'(A)')'ALL '//SYMB//' VALUES EQUAL.'
      END IF
      LIMITS=.FALSE.
C
   99 IF(NUNIT.EQ.6)THEN
          CALL TV('NO PLOT PRODUCED.')
          CALL TVN(' ')
      ELSE
          WRITE(NUNIT,'(A)') ' '
          WRITE(NUNIT,'(A)')'NO PLOT PRODUCED.'
          WRITE(NUNIT,'(A)') ' '
C          WRITE(NUNIT,*)
C          WRITE(NUNIT,*)'NO PLOT PRODUCED.'
C          WRITE(NUNIT,*) 
      END IF
      RETURN
C
      END
      SUBROUTINE XAXIS(XLIMS)
C
C   Adds dashed X-axis to plot.  Limits MUST be established first!
C
      IMPLICIT NONE
C
      REAL XLIMS(2), XVAL, STEP
C
      INTEGER I
C
C
      STEP=(XLIMS(2)-XLIMS(1))*0.05
      XVAL=XLIMS(1)+STEP/2.
      DO 10 I=1,20
        CALL PLOT(-1, XVAL, 0., '-')
        XVAL=XVAL+STEP
   10 CONTINUE
C
C
      RETURN
      END

C @(#)seesbr.for	19.1 (ES0-DMD) 02/25/03 13:27:15
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION:
C      SEECL VERSION 1                           85.01.21
C      F.MURTAGH    ST-ECF, MUNICH.
C
C.KEYWORDS:
C      APPLICATIONS, STATISTICS, CLUSTERING.
C
C.PURPOSE:
C      GIVEN A HIERARCHIC CLUSTERING, DESCRIBED AS A SEQUENCE
C      OF AGGLOMERATIONS, DERIVE THE ASSIGNMENTS INTO CLUSTERS
C      FOR THE TOP 8 LEVELS OF THE HIERARCHY.
C      PREPARE ALSO THE REQUIRED DATA FOR REPRESENTING THE
C      DENDROGRAM OF THIS TOP PART OF THE HIERARCHY.
C
C.ALGORITHM:
C
C.INPUT/OUTPUT:
C      PARAMETERS:
C      IA, IB, CRIT : VECTORS OF DIM. N DEFINING THE AGGLOMERATIONS;
C      HVALS        : USED INTERNALLY ONLY;
C      ICLASS       : ARRAY OF CLUSTER ASSIGNMENTS;
C      IORDER, CRITVAL, HEIGHT : VECTORS DESCRIBING THE DENDROGRAM.
C      *** NOTE *** VARIABLE TYPE IJKLMN CONVENTION FOLLOWED.
C
C---------------------------------------------------------------
C
      SUBROUTINE SEECL(N,IA,IB,CRIT,ICLASS,HVALS,IORDER,CRITVAL,HEIGHT)
C
      INTEGER I,J,K,N,LOC,ICL,ILEV,LEVEL,NCL,ISTAT
      INTEGER NOR20,ICLASS(N,8)
      INTEGER IA(N),IB(N),HVALS(9),IORDER(9),HEIGHT(9)
      REAL CRIT(N),CRITVAL(9)
      CHARACTER*80 LINE
C
C
C PICK OUT THE CLUSTERS WHICH THE N OBJECTS BELONG TO,
C AT LEVELS N-2, N-3, ... N-8 OF THE HIERARCHY.
C THE CLUSTERS ARE IDENTIFIED BY THE LOWEST SEQ. NO. OF
C THEIR MEMBERS.
C THERE ARE 2, 3, ... 9 CLUSTERS, RESPECTIVELY, FOR THE
C ABOVE LEVELS OF THE HIERARCHY.
      HVALS(1)=1
      HVALS(2)=IB(N-1)
      LOC=3
      DO 59 I=N-2,N-9,-1
         DO 52 J=1,LOC-1
         IF (IA(I).EQ.HVALS(J)) GOTO 54
  52     CONTINUE
         HVALS(LOC)=IA(I)
         LOC=LOC+1
  54     CONTINUE
         DO 56 J=1,LOC-1
         IF (IB(I).EQ.HVALS(J)) GOTO 58
  56     CONTINUE
         HVALS(LOC)=IB(I)
         LOC=LOC+1
  58     CONTINUE
  59  CONTINUE
C
C
      DO 400 LEVEL=N-9,N-2
            DO 200 I=1,N
            ICL=I
                  DO 100 ILEV=1,LEVEL
  100             IF (IB(ILEV).EQ.ICL) ICL=IA(ILEV)
            NCL=N-LEVEL
            ICLASS(I,NCL-1)=ICL
  200       CONTINUE
  400  CONTINUE
C
C
      DO 120 I=1,N
      DO 120 J=1,8
      DO 110 K=2,9
      IF (ICLASS(I,J).NE.HVALS(K)) GOTO 110
         ICLASS(I,J)=K
         GOTO 120
  110 CONTINUE
  120 CONTINUE
C
C
      LINE = ' Assignments for 2-class to 9-class partitions follow.'
      CALL STTPUT(LINE,ISTAT)
      LINE = ' (See output table for full set of assignments.)'
      CALL STTPUT(LINE,ISTAT)
      LINE = ' '
      CALL STTPUT(LINE,ISTAT)
      WRITE (LINE,450)
      CALL STTPUT(LINE,ISTAT)
  450 FORMAT(4X,' SEQ NOS 2CL 3CL 4CL 5CL 6CL 7CL 8CL 9CL')
      WRITE (LINE,470)
      CALL STTPUT(LINE,ISTAT)
  470 FORMAT(4X,' ------- --- --- --- --- --- --- --- --- ----')
      NOR20 = MIN0(N,20)
      DO 500 I=1,NOR20
      WRITE (LINE,600) I,(ICLASS(I,J),J=1,8)
      CALL STTPUT(LINE,ISTAT)
  600 FORMAT(I11,8I4)
  500 CONTINUE
C
C
C DETERMINE AN ORDERING OF THE 9 CLUSTERS (AT LEVEL N-8)
C FOR LATER REPRESENTATION OF THE DENDROGRAM.
C THESE ARE STORED IN "IORDER".
C DETERMINE THE ASSOCIATED ORDERING OF THE CRITERION VALUES
C (STORED IN "CRITVAL") FOR THE VERTICAL LINES IN THE DENDROGRAM.
C THE ORDINAL VALUES OF THESE CRITERION VALUES MAY BE USED IN
C PREFERENCE, AND THESE ARE STORED IN "HEIGHT".
C FINALLY, NOTE THAT THE 9 CLUSTERS ARE RENAMED SO THAT THEY
C HAVE SEQ. NOS. 1 TO 9.
      IORDER(1)=IA(N-1)
      IORDER(2)=IB(N-1)
      CRITVAL(1)=0.0
      CRITVAL(2)=CRIT(N-1)
      HEIGHT(1)=9
      HEIGHT(2)=8
      LOC=2
      DO 700 I=N-2,N-8,-1
         DO 650 J=1,LOC
            IF (IA(I).EQ.IORDER(J)) THEN
C              SHIFT RIGHTWARDS AND INSERT IB(I) BESIDE IORDER(J):
               DO 630 K=LOC+1,J+1,-1
                  IORDER(K)=IORDER(K-1)
                  CRITVAL(K)=CRITVAL(K-1)
                  HEIGHT(K)=HEIGHT(K-1)
  630          CONTINUE
               IORDER(J+1)=IB(I)
                CRITVAL(J+1)=CRIT(I)
                HEIGHT(J+1)=I-(N-9)
               LOC=LOC+1
            ENDIF
  650   CONTINUE
  700 CONTINUE
      DO 705 J=1,9
         DO 703 I=1,9
            IF (HVALS(I).EQ.IORDER(J)) THEN
               IORDER(J)=I
               GOTO 705
            ENDIF
  703    CONTINUE
  705 CONTINUE
C
      RETURN
      END

C @(#)spflx.for	19.1 (ES0-DMD) 02/25/03 13:19:40
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE SPFLXA(XIMAG,NPIX,START,STEP,RMAX,PASR,FONDMX,
     2                  XNORM,XYZI,MASK,XYZ)
C ++++
C.INPUT/OUTPUT:  RMAX   [I] radius max of star analysis
C                PASR   [I] annulus of analysis width
C                XNORM  [I] level of magnitude normalization
C                FONDMX [I] level max for background
C.VERSION:       910115 RHW IMPLICIT NONE included
C ---
      IMPLICIT      NONE
C
      REAL          XIMAG(1)                                                
      INTEGER       NPIX(2)                                                  
      REAL          START(2)
      REAL          STEP(2)
      REAL          RMAX
      REAL          PASR
      REAL          FONDMX                                   
      REAL          XNORM
      REAL          XYZI(2)                                            
      INTEGER       MASK                                                   
      REAL          XYZ(8)                                             
C
      INTEGER       MADRID(1)
      INTEGER       KCLAST
      INTEGER       NO
      INTEGER       IERR
      INTEGER       NPL, NPL1, NPL2, NPL3
      INTEGER       NL, NLC, NL1, NL2
      INTEGER       IOPO, NBM, NPLC, IPL, ITEF
      INTEGER       I, J, IY, NPP
      INTEGER       IPV, KCL
C
      REAL          D1(256),DFLUX(256)
      REAL          AIRE(256)
      REAL          RMOY(256)      
      REAL          XFR, RP, RPOI, RPOJ
      REAL          FLUX, FOND, FLUXV, XMAGS, ROBJ
      REAL          DIAMV, RADIUS, XLOGD, DFCAL
      REAL          SURFAC
      REAL          XPW, YPW, XC0, YC0
      REAL          RMAX2, DXP
      REAL          YFR
C
      SAVE          NO
      COMMON        /VMR/MADRID
      DATA          NO/0/
C
      NO     = NO + 1
      NPL    = NPIX(1)
      NL     = NPIX(2)
      NPL3   = 1      
      IOPO   = 0      
      NBM    = NINT(RMAX) + 1
      PASR   = AMAX1(.7,PASR)
      KCLAST = RMAX/PASR
      SURFAC = ABS(STEP(1)*STEP(2))
C
C *** is star into the frame?
      IERR   = 0                                                             
      XPW    = XYZI(1)                                                    
      YPW    = XYZI(2)                                                    
      XC0    = (XPW-START(1))/STEP(1) + 1.                                    
      YC0    = (YPW-START(2))/STEP(2) + 1.                                    
      NPLC   = NINT(XC0)                                                     
      NPL1   = MAX0(NPLC-NBM,1)                                              
      NPL2   = MIN0(NPLC+NBM,NPL)                                            
      IF (NPLC.LT.1 .OR. NPLC.GT.NPIX(1)) IERR = -4                        
      NLC    = NINT(YC0)                                                     
      NL1    = MAX0(NLC-NBM,1)                                               
      NL2    = MIN0(NLC+NBM,NL)                                              
      IF (NLC.LT.1 .OR. NLC.GT.NPIX(2)) IERR = IERR - 5                    
      IF (IERR.LT.0) GO TO 100                                               
C                                
C *** yes it is
      NPP    = NPL2 - NPL1 + 1                                               
      DXP    = ABS(STEP(1))                                                  
C
C *** boucle de calcul du flux et des parametres y afferant
      DO 10 J = 1,256                                                        
         DFLUX(J) = 0.                                                       
         RMOY(J)  = 0.                                                        
         AIRE(J)  = 0.                                                        
   10 CONTINUE                                                               
C
      RMAX2  = RMAX*RMAX                                                     
      DO 30 IY = NL1,NL2                                                     
         YFR    = FLOAT(IY)                                                  
         RPOJ   = (YFR-YC0)**2                                               
         CALL LIRE(IY,NPL,NPL1,NPL2,NPL3,XIMAG,D1)                           
         DO 20 IPL = 1,NPP                                                   
            IPV    = NPL1 + IPL - 1                                          
            XFR    = FLOAT(IPV)                                              
            RPOI   = (XFR-XC0)**2 + RPOJ                                     
            IF (RPOI.LE.RMAX2) THEN                                          
               RP     = SQRT(RPOI)                                           
               KCL    = IFIX(RP/PASR) + 1                                    
               DFLUX(KCL) = DFLUX(KCL) + D1(IPL)                             
               RMOY(KCL) = RMOY(KCL) + RP                                    
               AIRE(KCL) = AIRE(KCL) + 1.                                    
            END IF                                                           
   20    CONTINUE                                                            
   30 CONTINUE                                                               
C
      FLUX   = 0.                                                            
      DO 40 I = 1,KCLAST                                                     
         IF (AIRE(I).GT.0.) THEN                                             
             RMOY(I) = RMOY(I)/AIRE(I)                                       
             FLUX   = FLUX + DFLUX(I)                                        
             DFLUX(I) = DFLUX(I)/AIRE(I)                                     
         END IF                                                              
   40 CONTINUE                                                               
C
C *** calcul du fond 
      CALL CALFON(DFLUX,KCLAST,FONDMX,FOND,ROBJ,IERR)                        
      IF (IERR.LT.0) GO TO 90                                                
C
C *** calcul du flux corrige par le fond calcule                               
      DO 50 I = 1,KCLAST - 1                                                 
         IF (ROBJ.GE.RMOY(I) .AND. ROBJ.LE.RMOY(I+1)) THEN                   
            ITEF   = I + 1                                                   
         ENDIF                                                               
   50 CONTINUE                                                               
C
      FLUXV  = 0.                                                            
      XMAGS  = 0.                                                            
      DO 60 J = 1,ITEF                                                       
         DFCAL  = DFLUX(J) - FOND                                            
         FLUXV  = FLUXV + DFCAL*AIRE(J)                                      
   60 CONTINUE                                                               
      DO 70 J = ITEF,1,-1                                                    
         DFCAL  = DFLUX(J) - FOND                                            
         IF (ABS(DFCAL).GT..001*FLUXV) GO TO 80                              
         FLUXV  = FLUXV - DFCAL*AIRE(J)                                      
   70 CONTINUE                                                               
      IERR   = -3                                                            
      RADIUS = FLOAT(KCLAST)*DXP                                             
      RETURN
                                                                                
   80 CONTINUE                                                               
      RADIUS = FLOAT(J)*DXP                                                  
      DIAMV  = 2.*RADIUS                                                     
      XLOGD  = ALOG10(DIAMV)                                                 
      FLUXV  = FLUXV*SURFAC                                                  
      IF (FLUXV.GT.0.) THEN                                                  
         XMAGS  = -2.5*ALOG10(FLUXV) + XNORM                                 
      ENDIF                                                                  
C 
      MASK     = 1                                                        
      XYZ(1)   = XPW                                           !  x center
      XYZ(2)   = YPW                                           !  y center
      XYZ(3)   = FLUXV                                   !  integrate flux
      XYZ(4)   = XMAGS                                        !  magnitude
      XYZ(5)   = FOND                                  !  local background
      XYZ(6)   = DIAMV                                         !  diameter
      XYZ(7)   = XLOGD                                 !  log. of diameter
      XYZ(8)   = NO                                    !  reference number
      GO TO 100                                                              
C                                                                            
   90 CONTINUE                                                               
      XYZ(8)   = NO                                    !  reference number
      MASK = IERR
  100 CONTINUE
      RETURN 
      END  


      SUBROUTINE SPFLXI(XIMAG,NPIX,START,STEP,RMAX,PASR,FONDMX,
     2                  XNORM,XYZI,MASK,XYZ)
C ++++ 
C.INPUT/OUTPUT:  RMAX   [I] radius max of star analysis
C                PASR   [I] annulus of analysis width
C                XNORM  [I] level of magnitude normalization
C                FONDMX [I] level max for background 
C ---
      IMPLICIT      NONE
C
      REAL          XIMAG(1)
      INTEGER       NPIX(2)
      REAL          START(2)
      REAL          STEP(2)
      REAL          RMAX
      REAL          PASR
      REAL          FONDMX
      REAL          XNORM
      REAL          XYZI(2)
      INTEGER       MASK
      REAL          XYZ(8)
C
      INTEGER       MADRID(1)
      INTEGER       NL1, NL2
      INTEGER       NPLC, NPL, NL
      INTEGER       NPL3, NPL1, NPL2
      INTEGER       IY
      INTEGER       NPP
      INTEGER       NLC, IPL, IPV
      INTEGER       ISTAT, IST
      INTEGER       IRAD
      INTEGER       KCL
      INTEGER       ITEF 
      INTEGER       I, K, J
      INTEGER       IOPO, NBM, KCLAST
      INTEGER       NO, IERR 
      INTEGER       ACCESS, PLMODE
      INTEGER       KA
C
      REAL          D1(256)
      REAL          XCUR,YCUR
      REAL          FRAME(8)
      REAL          XPW, YPW, XC0, YC0
      REAL          SURFAC
      REAL          DXP, RMAX2
      REAL          ROBJ, RPOI, RP
      REAL          XFR, YFR
      REAL          RPOJ, DFCAL
      REAL          FLUXV, XMAGS
      REAL          DIAMV, RADIUS, XLOGD
      REAL          FOND, FLUX
      REAL          SCALE(3)
      REAL          OFFSET(2)
      REAL          STAR(256,3)
      REAL          ZMAX, ZMIN
      REAL          XOUT, YOUT
C
      CHARACTER*80  TEXT
      CHARACTER*16  LABEL1,LABEL2
C      
      LOGICAL       PRINT

      INCLUDE       'MID_INCLUDE:PLTDEC.INC/NOLIST'
      COMMON        /VMR/MADRID
      SAVE          NO
C
      DATA          NO/0/
      DATA          SCALE/0.0,0.0,0.0/
      DATA          OFFSET/-999.,-999./
      DATA          LABEL1/'Radius'/
      DATA          LABEL2/'Pixel Value'/
C
  905 FORMAT(' User input: ', 41X,2(G12.6))
C
C *** START CODE
      NO     = NO + 1
      NPL    = NPIX(1)
      NL     = NPIX(2)
      NPL3   = 1
      IOPO   = 0
      NBM    = NINT(RMAX) + 1
      PASR   = AMAX1(.7,PASR) 
      KCLAST = RMAX/PASR 
      SURFAC = ABS(STEP(1)*STEP(2)) 
C
C *** is star into the frame? 
      IERR   = 0
      XPW    = XYZI(1)
      YPW    = XYZI(2)
      XC0    = (XPW-START(1))/STEP(1) + 1.
      YC0    = (YPW-START(2))/STEP(2) + 1.
      NPLC   = NINT(XC0)
      NPL1   = MAX0(NPLC-NBM,1)
      NPL2   = MIN0(NPLC+NBM,NPL)
      IF (NPLC.LT.1 .OR. NPLC.GT.NPIX(1)) IERR = -4
      NLC    = NINT(YC0)
      NL1    = MAX0(NLC-NBM,1)
      NL2    = MIN0(NLC+NBM,NL)
      IF (NLC.LT.1 .OR. NLC.GT.NPIX(2)) IERR = IERR - 5
      IF (IERR.LT.0) GO TO 100
C
C *** yes it is
      NPP    = NPL2 - NPL1 + 1                                               
      DXP    = ABS(STEP(1))                                                  
C    
C *** boucle de calcul du flux et des parametres y afferant
      DO 10 K = 1,3
         DO 11 J = 1,256
            STAR(J,K) = 0.
   11    CONTINUE
   10 CONTINUE
C
      RMAX2  = RMAX*RMAX                                                     
      DO 20 IY = NL1,NL2                                                     
         YFR    = FLOAT(IY)                                                  
         RPOJ   = (YFR-YC0)**2                                               
         CALL LIRE(IY,NPL,NPL1,NPL2,NPL3,XIMAG,D1)                           
         DO 21 IPL = 1,NPP                                                   
            IPV    = NPL1 + IPL - 1                                          
            XFR    = FLOAT(IPV)                                              
            RPOI   = (XFR-XC0)**2 + RPOJ                                     
            IF (RPOI.LE.RMAX2) THEN                                          
               RP     = SQRT(RPOI)                                           
               KCL    = IFIX(RP/PASR) + 1                                    
               STAR(KCL,2) = STAR(KCL,2) + D1(IPL)
               STAR(KCL,1) = STAR(KCL,1) + RP
               STAR(KCL,3) = STAR(KCL,3) + 1.
            END IF                                                           
   21    CONTINUE                                                            
   20 CONTINUE                                                               
C                                         
      FLUX = 0.                                                            
      DO 30 I = 1,KCLAST                                                     
         IF (STAR(I,3).GT.0.) THEN
            STAR(I,1) = STAR(I,1)/STAR(I,3)
            FLUX      = FLUX + STAR(I,2)
            STAR(I,2) = STAR(I,2)/STAR(I,3)
         END IF                                                              
   30 CONTINUE                                                               
C
C *** calcul du fond
      CALL CALFON(STAR(1,2),KCLAST,FONDMX,FOND,ROBJ,IERR)
      IF (IERR.LT.0) THEN
         RADIUS = FLOAT(KCLAST)*DXP
         GO TO 66
      ENDIF
C
C *** calcul du flux corrige par le fond calcule                               
      DO 40 I = 1,KCLAST - 1                                                 
         IF (ROBJ.GE.STAR(I,1) .AND. ROBJ.LE.STAR(I+1,1)) THEN
            ITEF   = I + 1                                                   
         ENDIF                                                               
   40 CONTINUE                                                               
C                                                                            
      FLUXV  = 0.                                                            
      XMAGS  = 0.                                                            
      DO 50 J = 1,ITEF                                                       
         DFCAL  = STAR(J,2) - FOND
         FLUXV  = FLUXV + DFCAL*STAR(J,3)
   50 CONTINUE                                                               
C
      DO 60 J = ITEF,1,-1                                                    
         DFCAL  = STAR(J,2) - FOND
         IF (ABS(DFCAL).GT..001*FLUXV) GO TO 65
         FLUXV  = FLUXV - DFCAL*STAR(J,3)
   60 CONTINUE                                                               
      IERR   = -3                                                            
      RADIUS = FLOAT(KCLAST)*DXP 
      GO TO 66
C
   65 CONTINUE                                                               
      RADIUS = FLOAT(J)*DXP
      DIAMV  = 2.*RADIUS                                                     
      XLOGD  = ALOG10(DIAMV)                                                 
      FLUXV  = FLUXV*SURFAC                                                  
      IF (FLUXV.GT.0.) THEN                                                  
         XMAGS  = -2.5*ALOG10(FLUXV) + XNORM                                 
      ENDIF                                                                  
      PRINT = .TRUE.
C
   66 CONTINUE	
      PRINT = .FALSE.
      ZMAX = STAR(1,2)
      DO 70 I = 2,KCLAST/3
         IF (ZMAX.LT.STAR(I,2)) THEN
            ZMAX = STAR(I,2)
         ENDIF
   70 CONTINUE
C
      ZMIN      = FOND
      FRAME(1)  = 0.
      FRAME(2)  = FLOAT(KCLAST)*DXP
      FRAME(5)  = ZMIN*1.1-0.1*ZMAX
      FRAME(6)  = ZMAX*1.1-0.1*ZMIN
      CALL GETAXS('AUTO',FRAME(1))
      CALL GETAXS('AUTO',FRAME(5))
      CALL PTKWRR('XWNDL',4,FRAME(1))
      CALL PTKWRR('YWNDL',4,FRAME(5))
      CALL PTKWRR('SCALE',3,SCALE)
      CALL PTKWRR('OFFSET',2,OFFSET)
C
      PLMODE = 1
      ACCESS = 0
      CALL PTOPEN(' ',' ',ACCESS,PLMODE)
      CALL PLFLUX(NO,STAR(1,1),STAR(1,2),KCLAST,
     2            RADIUS,FOND,XOUT,YOUT,IST)
      CALL PTFRAM(FRAME(1),FRAME(5),LABEL1,LABEL2)
C
C *** loop to set the background and radius
   80 CONTINUE

C *** get cursor
      CALL PTGCUR(XCUR,YCUR,KA,IST)
      IF (KA.EQ.32) THEN
         CALL PTCLOS()
         GO TO 90

      ELSE 
         RADIUS = XCUR
         FOND   = YCUR
         WRITE (TEXT,905) FOND, 2*RADIUS
         CALL STTPUT(TEXT,ISTAT)
         GO TO 80
      ENDIF
C
   90 CONTINUE
      FLUXV  = 0.0
      XMAGS  = 0.0
      IRAD   = NINT(RADIUS)
      DO 95 J = 1,IRAD
         DFCAL = STAR(J,2)-FOND
         FLUXV = FLUXV+DFCAL*STAR(J,3)
   95 CONTINUE
      DIAMV = 2.*RADIUS
      XLOGD = ALOG10(DIAMV)
      FLUXV = FLUXV*SURFAC
C
      IF (FLUXV.GT.0.) THEN
         XMAGS = -2.5*ALOG10(FLUXV)+XNORM
      ENDIF
C
      IF (IST.LE.0 .AND. IERR.LT.0) THEN
         GO TO 999
      ENDIF
C
      MASK   = 1
      XYZ(1) = XPW                               ! x center
      XYZ(2) = YPW                               ! y center
      XYZ(3) = FLUXV	                         ! integrate flux
      XYZ(4) = XMAGS	                         ! magnitude
      XYZ(5) = FOND	                         ! local background
      XYZ(6) = DIAMV	                         ! diameter
      XYZ(7) = XLOGD	                         ! log. of diameter
      XYZ(8) = NO                                ! reference number
      GO TO 998

  999 CONTINUE
      XYZ(8) = NO                                ! reference number
      MASK = IERR
  998 CONTINUE

  100 CONTINUE

      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2008 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or
C modify it under the terms of the GNU General Public License as
C published by the Free Software Foundation; either version 2 of
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public
C License along with this program; if not, write to the Free
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C       Internet e-mail: midas@eso.org
C       Postal address: European Southern Observatory
C                       Data Management Division
C                       Karl-Schwarzschild-Strasse 2
C                       D 85748 Garching bei Muenchen
C                       GERMANY
C 
C 80723	last modif
C 
C===========================================================================

      SUBROUTINE GETAXS(FRAME,WCFRAM)
C 
      CHARACTER  FRAME
      REAL     WCFRAM(*)
 
      CALL STSTR(1,FRAME)                       !STRIPPED_STRING
C 
      CALL PPP1(WCFRAM)
C
      RETURN
      END


      SUBROUTINE PTAXES(XMNMX,YMNMX,LABELX,LABELY,AGLOPT)
C
      IMPLICIT NONE
C
      CHARACTER*(*)    LABELX,LABELY,AGLOPT
      REAL     XMNMX,YMNMX
C
      CALL STSTR(1,LABELX)                       !STRIPPED_STRING
      CALL STSTR(2,LABELY)                       !STRIPPED_STRING
      CALL STSTR(3,AGLOPT)                       !STRIPPED_STRING
C 
      CALL PPP2(XMNMX,YMNMX)
C
      RETURN
      END

      SUBROUTINE PTFRAM(XWCFRAM,YWCFRAM,LABELX,LABELY)
C
      IMPLICIT NONE
C
      CHARACTER*(*)    LABELX,LABELY
      REAL     XWCFRAM,YWCFRAM
C
      CALL STSTR(1,LABELX)                       !STRIPPED_STRING
      CALL STSTR(2,LABELY)                       !STRIPPED_STRING
C
      CALL PPP3(XWCFRAM,YWCFRAM)
C
      RETURN
      END

      SUBROUTINE PTTEXT(TEXT,XC,YC,ANGLE,CHSIZ,IPOS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)    TEXT
      REAL     XC,YC,ANGLE,CHSIZ
      INTEGER     IPOS
C
      CALL STSTR(1,TEXT)                       !STRIPPED_STRING
C
      CALL PPP4(XC,YC,ANGLE,CHSIZ,IPOS)
C
      RETURN
      END

      SUBROUTINE PTOPEN(DEVNAM,PLNAME,ACCESS,PLMODE)
C
      IMPLICIT NONE
C
      CHARACTER*(*)    DEVNAM,PLNAME
      INTEGER     ACCESS,PLMODE
C
      CALL STSTR(1,DEVNAM)                       !STRIPPED_STRING
      CALL STSTR(2,PLNAME)                       !STRIPPED_STRING
C
      CALL PPP5(ACCESS,PLMODE)
C
      RETURN
      END

      SUBROUTINE PTKRDC(CPAR,MAXVALS,ACTVALS,CVAL)
C 
      IMPLICIT NONE
C
      CHARACTER*(*)    CPAR,CVAL
C
      CALL STSTR(1,CPAR)                       !STRIPPED_STRING
      CALL STLOC(1,1,CVAL)                     !blanked CHAR_LOC
C
      CALL PPP6(MAXVALS,ACTVALS)
C
      RETURN
      END


      SUBROUTINE PTKRDI(IPAR,MAXVALS,ACTVALS,IVAL)
C
      IMPLICIT NONE
C
      CHARACTER*(*)    IPAR
      INTEGER     MAXVALS,ACTVALS,IVAL(1)
C
      CALL STSTR(1,IPAR)                       !STRIPPED_STRING
C
      CALL PPP7(MAXVALS,ACTVALS,IVAL)
C
      RETURN
      END

      SUBROUTINE PTKRDR(RPAR,MAXVALS,ACTVALS,RVAL)
C
      IMPLICIT NONE
C
      CHARACTER*(*)    RPAR
      INTEGER     MAXVALS,ACTVALS
      REAL   RVAL(1)
C
      CALL STSTR(1,RPAR)                       !STRIPPED_STRING
C
      CALL PPP8(MAXVALS,ACTVALS,RVAL)
C
      RETURN
      END

      SUBROUTINE PTKWRC(CPAR,VALUE)
C
      IMPLICIT NONE
C
      CHARACTER*(*)    CPAR,VALUE
      INTEGER     IDUM
C
      CALL STSTR(1,CPAR)                       !STRIPPED_STRING
      CALL STSTR(2,VALUE)                      !STRIPPED_STRING
C
      CALL PPP9(IDUM)
C
      RETURN
      END

      SUBROUTINE PTKWRI(IPAR,NRVAL,IVAL)
C
      IMPLICIT NONE
C
      CHARACTER*(*)    IPAR
      INTEGER     NRVAL,IVAL(1)
C
      CALL STSTR(1,IPAR)                       !STRIPPED_STRING
C
      CALL PPP10(NRVAL,IVAL)
C
      RETURN
      END


      SUBROUTINE PTKWRR(RPAR,NRVAL,RVAL)
C
      IMPLICIT NONE
C
      CHARACTER*(*)    RPAR
      INTEGER     NRVAL
      REAL   RVAL(1)
C
      CALL STSTR(1,RPAR)                       !STRIPPED_STRING
C
      CALL PPP11(NRVAL,RVAL)
C
      RETURN
      END

C @(#)identigcur.for	19.1 (ES0-DMD) 02/25/03 13:19:45
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT:      Copyright (c) 1987 European Southern Observatory,
C                            all rights reserved
C.IDENTIFICATION: IDENTIGCUR
C.AUTHOR:    J.D.Ponz, ESO - Garching
C.KEYWORDS:  Line identification
C.PURPOSE:   Line identification with the graphics cursor
C.USE:       IDENTIFY/GCURSOR TABLE IDENTCOL X [Y] [ERROR]
C.ALGORITHM: Use the routines of the plotlib and midaslib
C.VERSION:   830104 JDP 
C.VERSION:   850411 JDP 
C.VERSION:   880704 RHW Conversion to Fortran 77 + eso extension
C.VERSION:   881201 JDP Selection mechanism
C.VERSION    910130 MP  get also length of column label
C.VERSION:   910115 RHW IMPLICIT NONE added
C-----------------------------------------------------------------
      PROGRAM   IDENTGC
      IMPLICIT  NONE
C
      REAL      RERR,RVAL(2),RP(2)
      REAL      XCUR,YCUR
      DOUBLE PRECISION  DERR,DVAL(2),DP(2), DELTA

      INTEGER   STATUS,ISTAT,STAT,IACT,NINCOL,IDUM,NV,NC,NCOL
      INTEGER   NROW,NSCOL,NACOL,NAROW,ICR,ICX,IL,ICY
      INTEGER   KEY,IROW,IAC,MADRID(1)
      INTEGER   IC(7),LEN
      INTEGER   NBYT2,TID,KUN,KNUL
      INTEGER   DTYPER, DTYPEX, DTYPEY
      INTEGER   ACCESS, PLMODE

      CHARACTER TABLE*64, FORM*8, HEAD*80
      CHARACTER COLUM1*17, COLUM2*17, COLUM3*17
      CHARACTER ERROR*17
      CHARACTER PROMPT*18, LINE*80, LINE1*27
      CHARACTER CVAL*80, IEXT*10, TNULL*10

      LOGICAL   IHEAD
C
      INCLUDE   'MID_INCLUDE:ST_DEF.INC/NOLIST'
      COMMON    /VMR/ MADRID
      INCLUDE   'MID_INCLUDE:ST_DAT.INC/NOLIST'
      DATA      IEXT /'^%&$*#(@)!'/
      DATA      TNULL/'*         '/
      DATA      IHEAD/.TRUE./
C
8001  FORMAT(I1)
8002  FORMAT(I2)
9000  FORMAT(' ',E12.6,' ',E12.6,' ')
C
C *** Start of executable code
      CALL STSPRO('IDENTGC')
      CALL STKRDC('P1',1,1,64,IACT,TABLE,KUN,KNUL,STATUS)
      CALL STKRDC('P2',1,1,17,IACT,COLUM1,KUN,KNUL,STATUS)
      CALL STKRDC('P3',1,1,17,IACT,COLUM2,KUN,KNUL,STATUS)
      CALL STKRDC('P4',1,1,17,IACT,COLUM3,KUN,KNUL,STATUS)
      CALL STKRDC('P5',1,1,17,IACT,ERROR,KUN,KNUL,STATUS)
C
      IF (COLUM3(1:1).EQ.':' .OR. COLUM3(1:1).EQ.'#') THEN
         NINCOL = 2
      ELSE
         NINCOL = 1
         ERROR  = COLUM3
      ENDIF
C
      IF (ERROR(1:1).EQ.'?') THEN
         RERR = 2.
      ELSE
         CALL GENCNV(ERROR,2,1,IDUM,RERR,DERR,NV)
      ENDIF
      DERR = ABS(RERR)
C
C *** initialize table
      NC = 0
      CALL TBTOPN(TABLE,F_U_MODE,TID,ISTAT)
      CALL TBIGET(TID,NCOL,NROW,NSCOL,NACOL,NAROW,ISTAT)
      CALL TBCSER(TID,COLUM1,ICR,ISTAT)
      IF (ICR.EQ.-1) THEN
         CALL TBCINI(TID,D_R4_FORMAT,1,'E14.6',' ',
     2               COLUM1(2:17),ICR,ISTAT)
      ENDIF
      NC     = NC + 1
      IC(NC) = ICR
      CALL TBCSER(TID,COLUM2,ICX,ISTAT)
      IF (ICX.LE.0) THEN
         CALL STTPUT('*** FATAL: Column not found ...',ISTAT)
         CALL TBTCLO(TID,ISTAT)
         CALL STSEPI
         GO TO 1001
      ELSE
         CALL TBFGET(TID,ICX,FORM,IL,DTYPEX,ISTAT)
         IF (DTYPEX.EQ.D_C_FORMAT) THEN
            CALL STTPUT('*** FATAL: Wrong column format ...',ISTAT)
            CALL TBTCLO(TID,ISTAT)
            CALL STSEPI
            GO TO 1001
         ENDIF
         NC     = NC + 1
         IC(NC) = ICX
      ENDIF
C
      IF (NINCOL.EQ.2) THEN
         CALL TBCSER(TID,COLUM3,ICY,ISTAT)
         IF (ICY.LE.0) THEN
            CALL STTPUT('*** FATAL: Column not found ...',ISTAT)
            CALL TBTCLO(TID,ISTAT)
            CALL STSEPI
            GO TO 1001
         ELSE
            CALL TBFGET(TID,ICY,FORM,IL,DTYPEY,ISTAT)
            IF (DTYPEY.EQ.D_C_FORMAT) THEN
               CALL STTPUT('*** FATAL: Wrong column format ...',ISTAT)
               CALL TBTCLO(TID,ISTAT)
               CALL STSEPI
               GO TO 1001
            ENDIF
            IF (DTYPEY.NE.DTYPEX) THEN
               CALL STTPUT('*** FATAL: Incompatible column format',
     2                     ISTAT)
               CALL TBTCLO(TID,ISTAT)
               CALL STSEPI
               GO TO 1001
            ENDIF
            NC = NC + 1
            IC(NC) = ICY
         ENDIF
      ENDIF
C
      CALL TBLGET(TID,ICR,PROMPT,ISTAT)
      CALL GENLEN(PROMPT,LEN)
      PROMPT(LEN+1:16) = ' '
      PROMPT(17:18) = '?:'
      CALL TBFGET(TID,ICR,FORM,IL,DTYPER,ISTAT)
      IF (DTYPER.EQ.D_R4_FORMAT) THEN
         NBYT2 = -4
      ELSE IF (DTYPER.EQ.D_R8_FORMAT) THEN
         NBYT2 = -8
      ELSE
         NBYT2 = IL
      ENDIF
C
C *** restore the graphics display
      ACCESS = -1
      PLMODE = 1
      CALL PTOPEN(' ',' ',ACCESS,PLMODE)
      CALL STTPUT('*** INFO: Position cursor and press left mouse'//
     2            ' button or any key (not RETURN)', ISTAT)
      CALL STTPUT('          Use second left mouse button or space'//
     2            ' bar to exit',ISTAT)
1000  CONTINUE
      CALL PTGCUR(XCUR,YCUR,KEY,STATUS)
      IF (KEY.EQ.32) THEN
         CALL TBTCLO(TID,ISTAT)
         CALL PTCLOS()
         CALL STSEPI
         GO TO 1001
      ELSE        
         CALL PTDATA(4,0,1,XCUR,YCUR,0.0,1)
         RP (1) = XCUR
         RP (2) = YCUR
      ENDIF
C
C *** search for position in reference
      IF (NINCOL.EQ.1) THEN
         IF(DTYPEX.EQ.D_R4_FORMAT) THEN
            CALL TBES1R(TID,ICX,RP,IROW,RVAL,STATUS)
            DELTA   = ABS(RP(1)-RVAL(1))
         ELSE
            DP(1)   = RP(1)
            DERR    = RERR
            CALL TBES1D(TID,ICX,DP,IROW,DVAL,STATUS)
            DELTA   = DABS(DP(1)-DVAL(1))
         ENDIF
       ELSE
         IF (DTYPEX.EQ.D_R4_FORMAT) THEN
            CALL TBES2R(TID,ICX,ICY,RP,IROW,RVAL,ISTAT)
            DELTA   = SQRT((RP(1)-RVAL(1))**2 + (RP(2)-RVAL(2))**2)
         ELSE
            DP(1)   = RP(1)
            DP(2)   = RP(2)
            DERR    = RERR
            CALL TBES2D(TID,ICX,ICY,DP,IROW,DVAL,ISTAT)
            DELTA   = DSQRT((DP(1)-DVAL(1))**2 + (DP(2)-DVAL(2))**2)
         ENDIF
      ENDIF
      IF (IROW.EQ.0 .OR. DELTA.GT.DERR) THEN
         WRITE (LINE1,9000) RP(1),RP(2)
         CALL STTPUT(LINE1//'*** Feature not found, try again',ISTAT)
      ELSE
C
C *** get seq no, ident, x, (y)
         CALL TDLIS2(TID,NC,IC,IROW,LINE,IHEAD,HEAD,ISTAT)
         IF (IHEAD) THEN
            IHEAD = .FALSE.
            CALL STTPUT('    X COORD.    Y COORD.    '//HEAD,ISTAT)
         ENDIF
C
         WRITE (LINE1,9000) RP(1),RP(2)
         CALL STTPUT(LINE1//LINE,ISTAT)
C5        CVAL = IEXT
         CVAL  = ' '
         STAT = 0
         CALL STKPRC(PROMPT,'INPUTC',1,1,80,IAC,CVAL,KUN,KNUL,ISTAT)
         IF (CVAL(1:10).NE.IEXT) THEN
            IF (CVAL(1:10).EQ.TNULL) THEN
               CALL TBEDEL(TID,IROW,ICR,ISTAT)
C
            ELSE
               CALL TBEWRC(TID,IROW,ICR,CVAL,ISTAT)
            ENDIF
         ENDIF
      ENDIF
      GO TO 1000
C
1001  CONTINUE
      END

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  8:58 - 9 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.IDENTIFICATION
C
C  SUBROUTINES TDRBII, TDRBIT, TDRBTI, TDRBTT
C
C.KEYWORDS
C
C  IMAGES, NONLINEAR REBIN, INTERPOLATION, INTEGRATION
C
C.PURPOSE
C
C  NONLINEAR REBIN IMAGE TO IMAGE IN 1 DIMENSION
C
C.ALGORITHM
C
C  Rebin input data YI sampled at XI with binwidth WI to
C  output data YO sampled at XO with binwidth WO.
C
C  Restriction:  Input and output independent variables are
C                assumed to be monotonic increasing or decreasing
C
C  Several FUNCTal relations between input and output independent
C  variables are foreseen, additional ones may be added in dummy call
C  U01 as follows:
C
C SUBROUTINE REB_U01 (DV,P,NP,NPC)
C   REAL*8 DV,P(NP)
C   DV = ...........
C   RETURN
C END
C
C  where DV is input-output value, P(NP) the parameter array and
C  NPC the nuber of active parameters in p(np).
C
C  According to the definition of IMAGES, pixels have constant
C  bin width (STEP) [WI;WO], are not overlapping and have filling
C  factors of exactly one. World coordinates [XI;XO] and flux values
C  [YI;YO] are pertinent
C  to the center of a pixel. In flux conservation mode (the default)
C  the flux is interpreted as the area under a smooth curve between
C  the boundaries of the pixel (i.e. a histogram representation of
C  a smooth curve).
C
C  Detailed flux conservation obtained by REAL*8 spline interpolation
C  and NAGLIB REAL*8 integration of input data over the projected
C  bin WI for fractions of input pixels and summation of flux in
C  entire input pixels covered within the valid domain of input data
C  i.e. from x(1)-0.5*step to x(n)+0.5*step. Several options available
C  to handle undefined input at the extremes and for NULLVALUE assigned
C  parts of input array.
C
C   Optimized for long arrays by search for valid range, optimum
C  direction or DO LOOPS and updating of loop boundaries - therefore
C  overdoing it for small arrays.
C
C.INPUT
C
C  Keys:  IN_A/C/1/8         input data array
C         IN_B/C/1/8         reference frame or dim of output
C         CFUNC/C/1/8        FUNCTal relation between indep.
C         INPUTD/D/1/12      parameters or FUNCT
C         COPT/C/1/8         options
C
C.OUTPUT
C
C  Key:   OUT_A/C/1/8        output data array
C 
C.VERSIUON
C 920309	MP (fix COPT)
C 100813	last modif
C 
C-----------------------------------------------------------
C
      SUBROUTINE TDRBII
      IMPLICIT NONE
      INTEGER   NFPAR
      PARAMETER (NFPAR = 12)
C
      INTEGER MADRID
      INTEGER I,IACT, IS,ISTAT
      INTEGER J,NAXISI,NAXISO,KUN,KNUL
      INTEGER NDIMI,NDIMO,NFPACT,NFUNC
      INTEGER NI,NINT,NN,NO,NBY,NBO
      INTEGER NPIXI(3),NPIXO(3),INOP,IMNO,IMNI,IREF
C 
      INTEGER*8   IP1,IP2,IP3,IPNTR, JP1,JP2,JPNTR
C 
      REAL    RMIN, RMAX, CUTS(4)
      REAL    X0,WX
C 
      DOUBLE PRECISION STEPI(3),STARTI(3)
      DOUBLE PRECISION DPARM(NFPAR),FPARM(NFPAR)
      DOUBLE PRECISION DSTART(3), DSTEP(3)
C 
      CHARACTER*3 FUN(9)
      CHARACTER*80 FUNCT,OPTION
      CHARACTER*60 INPIMA,OUTIMA,REFIMA
      CHARACTER*72 IDENTO,IDENTI
      CHARACTER*80 CUNITO,CUNITI
C
      INCLUDE 'MID_INCLUDE:TABLES.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:TABLED.INC'
C
      DATA FUN/'LIN','POL','INV','EXP','DEX','LOG','DLG','IPO','U01'/
      DATA INPIMA/'  '/
      DATA OUTIMA/'  '/
      DATA REFIMA/'  '/
      DATA IDENTI/'  '/
      DATA CUNITI/'  '/
C
C ... get input parameters
C


      CALL STKRDC('OUT_A',1,1,60,IACT,OUTIMA,KUN,KNUL,ISTAT)
      CALL STKRDC('IN_A',1,1,60,IACT,INPIMA,KUN,KNUL,ISTAT)
      CALL STKRDC('IN_B',1,1,60,IACT,REFIMA,KUN,KNUL,ISTAT)
      CALL STKRDC('CFUNC',1,1,8,IACT,FUNCT,KUN,KNUL,ISTAT)
      CALL STKRDD('INPUTD',1,NFPAR,NFPACT,FPARM,KUN,KNUL,ISTAT)
      CALL STKRDC('COPT',1,1,8,IACT,OPTION,KUN,KNUL,ISTAT)
C
C ... det. interpolation/integration options
C  !   Not implemented
      INOP   = 4
C      IF (OPTION(1:3).EQ.'PIX') INOP   = 1
C      IF (OPTION(1:3).EQ.'LIN') INOP   = 2
C      IF (OPTION(1:3).EQ.'SPG') INOP   = 3
C .......................................... the actual values are:
      CALL FORUPC(OPTION,OPTION)
      IF (OPTION(1:1).EQ.'P') INOP   = 2
      IF (OPTION(1:1).EQ.'L') INOP   = 3
      IF (OPTION(1:1).EQ.'S') INOP   = 1
C .......................................... Bitte, bitte
C
C ... translate FUNCT into FUNCT number
C
      CALL FORUPC(FUNCT,FUNCT)
      NFUNC  = 0
      DO 10 I = 1,9
          IF (FUNCT(1:3).EQ.FUN(I)) NFUNC  = I
   10 CONTINUE
      IF (NFUNC.EQ.0) THEN
          CALL STTPUT(' Specified FUNCT non-existent...',ISTAT)
          GO TO 60
      END IF
C
C ... search for number of active parameters and DOUBLE
C
      DO 20 J = NFPAR,1,-1
          NFPACT = J
          IF (FPARM(J).NE.0.000) GO TO 30
   20 CONTINUE
   30 DO 40 J = 1,NFPACT
          DPARM(J) = FPARM(J)
   40 CONTINUE
C
C ... get parameters form reference image
C
      CALL STFOPN(REFIMA,D_R4_FORMAT,0,F_IMA_TYPE,IREF,ISTAT)
      CALL STDRDI(IREF,'NAXIS',1,1,NN,NAXISO,KUN,KNUL,ISTAT)
      CALL STDRDI(IREF,'NPIX',1,NAXISO,NN,NPIXO,KUN,KNUL,ISTAT)
      CALL STDRDD(IREF,'START',1,NAXISO,NN,DSTART,KUN,KNUL,ISTAT)
      CALL STDRDD(IREF,'STEP',1,NAXISO,NN,DSTEP,KUN,KNUL,ISTAT)
      CALL STDRDC(IREF,'IDENT',1,1,72,NN,IDENTO,KUN,KNUL,ISTAT)
      CALL STDRDC(IREF,'CUNIT',1,1,80,NN,CUNITO,KUN,KNUL,ISTAT)
      IF (NAXISO.GT.1 .AND. NPIXO(2).GT.1) THEN
          CALL STTPUT(' Only 1D images are considered ...',ISTAT)
          CALL STFCLO(IREF,ISTAT)
          GO TO 60
      ELSE
          NPIXO(2) = 1
          NDIMO  = 1
      END IF
      CALL STFCLO(IREF,ISTAT)
C
C ... get input image
C
      CALL STIGET(INPIMA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     .2,NAXISI,NPIXI,STARTI,STEPI,IDENTI,CUNITI,IPNTR,IMNI,ISTAT)
      IF (NAXISI.GT.1 .AND. NPIXI(2).GT.1) THEN
          CALL STTPUT(' Only 1-D images are considered.',ISTAT)
          GO TO 50
      ELSE
          NPIXI(2) = 1
          NDIMI  = 1
      END IF
C
C ... map output image
C
      CALL STIPUT(OUTIMA,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .NDIMO,NPIXO,DSTART,DSTEP,IDENTI,CUNITO,JPNTR,IMNO,ISTAT)
C
C ... fill the arrays XI,WI and XO,WO
C
      NI     = NPIXI(1)
      NBY    = 8*NI
      CALL TDMGET(NBY,IP1,IS)
      CALL TDMGET(NBY,IP2,IS)
      CALL TDMGET(NBY,IP3,IS)
      X0     = STARTI(1)
      WX     = STEPI(1)
      CALL IMVAL3(NI,X0,WX,MADRID(IPNTR),MADRID(IP1),MADRID(IP2),
     +             MADRID(IP3))
C
      NO     = NPIXO(1)
      NBO    = 8*NO
      CALL TDMGET(NBO,JP1,IS)
      CALL TDMGET(NBO,JP2,IS)
      X0     = DSTART(1)
      WX     = DSTEP(1)
      CALL IMVAL2(NO,X0,WX,MADRID(JP1),MADRID(JP2))
C
C  ...  Now, at last, we call the interpolating (and integrating) routines:
C
C  !!!! Watch out for VECI,VECD arrays in INTERP, dimension => NINT !!!!!!
C
      NINT   = 8

      CALL REBMET(NI,MADRID(IP1),MADRID(IP3),MADRID(IP2),NO,
     +             MADRID(JP1),MADRID(JP2),NFUNC,NFPAR,NFPACT,DPARM,
     +             INOP,NINT,MADRID(JPNTR),RMIN,RMAX)
C
C ... write cuts
C
      CUTS(1) = RMIN
      CUTS(2) = RMAX
      CUTS(3) = RMIN
      CUTS(4) = RMAX
      CALL STDWRR(IMNO,'LHCUTS',CUTS,1,4,KUN,ISTAT)
C
C ... free memory
C
      CALL TDMFRE(NBY,IP1,IS)
      CALL TDMFRE(NBY,IP2,IS)
      CALL TDMFRE(NBY,IP3,IS)
      CALL TDMFRE(NBO,JP1,IS)
      CALL TDMFRE(NBO,JP2,IS)
C
C ... end
C
      CALL DSCUPT(IMNO,IMNO,' ',ISTAT)
      CALL STFCLO(IMNO,ISTAT)
   50 CALL STFCLO(IMNI,ISTAT)
   60 RETURN
      END

C
      SUBROUTINE TDRBIT
      IMPLICIT NONE
      INTEGER    NFPAR
      PARAMETER (NFPAR = 12)
C
      LOGICAL BIN
      INTEGER MADRID
      INTEGER*8  IP1,IP2,IP3,IPNTR, JP1,JP2,JP3
      INTEGER I,IACT,IC,II
      INTEGER IS,ISTAT,J,JSTAT,TID,NAC,NAR
      INTEGER NAXIS,NCOL,NDIM,NFUNC,NI
      INTEGER NINT,NMAX,NO,NROW,NSC,NBY,NBY1
      INTEGER INDEX, KUN, KNUL
      INTEGER NFPACT,INOP,IMNO
      INTEGER ICOL(3),NPIX(3)
C
      REAL RMIN,RMAX
      REAL X0,WX
C
      DOUBLE PRECISION  STEP(3),START(3)
C
      DOUBLE PRECISION DPARM(NFPAR),FPARM(NFPAR)
      CHARACTER*3 FUN(9)
      CHARACTER*80 FUNCT1,OPTION
      CHARACTER*60 TABLE,IMAGE
      CHARACTER*16 MSG
      CHARACTER*17 COLREF(3),LABEL
      CHARACTER*53 OCOLS,CBUF
      CHARACTER*72 IDENT
      CHARACTER*80 CUNIT
C
      INCLUDE 'MID_INCLUDE:TABLES.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:TABLED.INC'
C
      DATA MSG/'ERR:REBISTBxxx'/
      DATA FUN/'LIN','POL','INV','EXP','DEX','LOG','DLG','IPO','U01'/
      DATA TABLE/'  '/
      DATA IMAGE/'  '/
C
C ... get input parameters
C
      CALL STKRDC('OUT_A',1,1,60,IACT,TABLE,KUN,KNUL,ISTAT)
      CALL STKRDC('COLO',1,1,53,IACT,OCOLS,KUN,KNUL,ISTAT)
      CALL STKRDC('IN_A',1,1,60,IACT,IMAGE,KUN,KNUL,ISTAT)
      CALL STKRDC('CFUNC',1,1,8,IACT,FUNCT1,KUN,KNUL,ISTAT)
      CALL STKRDD('INPUTD',1,NFPAR,NFPACT,FPARM,KUN,KNUL,ISTAT)
      CALL STKRDC('COPT',1,1,12,IACT,OPTION,KUN,KNUL,ISTAT)
C
C ... det. integration/interpolation option
C  !   Not implemented
      INOP   = 4
C      IF (OPTION(1:3).EQ.'PIX') INOP   = 1
C      IF (OPTION(1:3).EQ.'LIN') INOP   = 2
C      IF (OPTION(1:3).EQ.'SPG') INOP   = 3
C .......................................... the actual values are:
      CALL FORUPC(OPTION,OPTION)
      IF (OPTION(1:1).EQ.'P') INOP   = 2
      IF (OPTION(1:1).EQ.'L') INOP   = 3
      IF (OPTION(1:1).EQ.'S') INOP   = 1
C .......................................... Bitte, bitte
C
C ... translate FUNCT1 into function number
C
      CALL FORUPC(FUNCT1,FUNCT1)
      NFUNC  = 0
      DO 10 I = 1,9
          IF (FUNCT1(1:3).EQ.FUN(I)) NFUNC  = I
   10 CONTINUE
      IF (NFUNC.EQ.0) THEN
          CALL STTPUT(' Specified function non-existent...',ISTAT)
          GO TO 70
      END IF
C
C ... search for number of active parameters and 'double-precision' them
C
      DO 20 J = NFPAR,1,-1
          NFPACT = J
          IF (FPARM(J).NE.0.000) GO TO 30
   20 CONTINUE
   30 DO 40 J = 1,NFPACT
          DPARM(J) = FPARM(J)
   40 CONTINUE
C
C ... sort out ind., dep. (and bin) variables
C
      II     = INDEX(OCOLS,',')
      IF (II.EQ.0) THEN
          WRITE (*,*) ' Specification of relevant input',
     +      ' table cols insufficient'
          GOTO 70
      ELSE
          COLREF(1) = OCOLS(1:II-1)
          CBUF   = OCOLS(II+1:)
          II     = INDEX(CBUF,',')
          IF (II.EQ.0) THEN
              COLREF(2) = CBUF(1:)
              BIN    = .FALSE.
          ELSE
              COLREF(2) = CBUF(1:II-1)
              COLREF(3) = CBUF(II+1:)
              BIN    = .TRUE.
          END IF
      END IF
C
C ... access input table
C
      TID = -1
      CALL TBTOPN(TABLE,F_U_MODE,TID,ISTAT)
      IF (ISTAT.NE.0) GO TO 60
      CALL TBIGET(TID,NCOL,NROW,NSC,NAC,NAR,ISTAT)
      IF (ISTAT.NE.0) GO TO 60
C
C ... find input column
C
      CALL TBCSER(TID,COLREF(1),ICOL(1),ISTAT)
      IF (ICOL(1).EQ.-1) THEN
          CALL STTPUT('Error in column reference',IS)
          GO TO 60
      END IF
      IF (BIN) THEN
          CALL TBCSER(TID,COLREF(3),ICOL(3),ISTAT)
          IF (ICOL(3).EQ.-1) THEN
              CALL STTPUT('Error in column reference',IS)
              GO TO 60
          END IF
      END IF
C
C ... copy selected values of the table into work space
C
      NBY = 8*NROW
      CALL TDMGET(NBY,JP1,IS)
      CALL TDMGET(NBY,JP2,IS)
      CALL TDMGET(NBY,JP3,IS)
      IF (BIN) THEN
          CALL COPYIT(TID,ICOL(1),ICOL(3),NROW,
     +                MADRID(JP1),MADRID(JP3),NO)
          IF (NO.LE.3) THEN
              CALL STTPUT(' Not enough points in table ',ISTAT)
              GO TO 50
          END IF
      ELSE
          CALL BCPYIT(TID,ICOL(1),NROW,MADRID(JP1),
     +                 MADRID(JP3),NO)
          IF (NO.LE.3) THEN
              CALL STTPUT(' Not enough points in table ',ISTAT)
              GO TO 50
          END IF
      END IF
C
C ... get input image
C
      CALL STIGET(IMAGE,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     .     2,NAXIS,NPIX,START,STEP,IDENT,CUNIT,IPNTR,IMNO,ISTAT)
      IF (NAXIS.GT.1 .AND. NPIX(2).GT.1) THEN
          CALL STTPUT(' Only 1-dim images are considered.',ISTAT)
          GO TO 60
      ELSE
          NPIX(2) = 1
          NDIM   = 1
      END IF
C
C image input, then fill the XO and WO arrays OF INTERPOLn
C
      NI     = NPIX(1)
      NBY1 = 8*NI
      CALL TDMGET(NBY1,IP1,IS)
      CALL TDMGET(NBY1,IP2,IS)
      CALL TDMGET(NBY1,IP3,IS)
      X0     = START(1)
      WX     = STEP(1)
      CALL IMVAL4(NI,X0,WX,MADRID(IPNTR),MADRID(IP1),MADRID(IP2),
     +             MADRID(IP3))
C
C  ...  Now, at last, we call the interpolating (and integrating)
C	routines:
C  !!!! Watch out for VECI,VECD arrays in INTERP,
C	 dimension => NINT !!!!!!
C
      CALL REBMET(NI,MADRID(IP1),MADRID(IP2),MADRID(IP3),NO,
     +             MADRID(JP1),MADRID(JP3),NFUNC,NFPAR,NFPACT,DPARM,
     +             INOP,NINT,MADRID(JP2),RMIN,RMAX)
C
C ... output table
C
C ... find if column already exists
      CALL TBCSER(TID,COLREF(2),IC,ISTAT)
      IF (IC.EQ.-1) THEN
          LABEL  = COLREF(2) (2:)
          CALL TBCINI(TID,D_R4_FORMAT,1,'E16.8',CUNIT,
     .                LABEL,IC,ISTAT)
      END IF
      NMAX   = NO
      CALL OCOPY(TID,NMAX,IC,MADRID(JP2))
C
C ... free memory
C
      CALL TDMFRE(NBY,JP1,IS)
      CALL TDMFRE(NBY,JP2,IS)
      CALL TDMFRE(NBY,JP3,IS)
   50 CONTINUE
      CALL TDMFRE(NBY1,IP1,IS)
      CALL TDMFRE(NBY1,IP2,IS)
      CALL TDMFRE(NBY1,IP3,IS)
C
C ... end
C
      CALL TBIPUT(TID,0,NO,ISTAT)
      CALL TBSINI(TID,ISTAT)
      CALL DSCUPT(TID,TID,' ',ISTAT)
      CALL TBTCLO(TID,ISTAT)
   60 IF (ISTAT.NE.0) THEN
          WRITE (MSG(13:16),9000) ISTAT
          CALL TDERRR(ISTAT,MSG,JSTAT)
      END IF
   70 RETURN
 9000 FORMAT (I4)
      END


      SUBROUTINE TDRBTI
      IMPLICIT NONE
      INTEGER    NFPAR
      PARAMETER (NFPAR = 12)
C
      LOGICAL BIN
      INTEGER MADRID
      INTEGER*8  IP1,IP2,IP3,IPNTR, JP1,JP2
      INTEGER I,I1,I2,IACT,IB,II
      INTEGER IS,ISTAT,J,JSTAT,NAXIS
      INTEGER NCOL,NDIM,NFUNC,NI,NINT,NN,NO,NROW,NSC
      INTEGER INDEX,IMNO,IREF, KUN, KNUL
      INTEGER NFPACT,INOP,NAC,NAR,TID,NBY,NBY1
      INTEGER ICOL(3),NPIX(3)
      REAL    RMIN,RMAX
      REAL    CUTS(4)
      REAL    X0,WX
      DOUBLE PRECISION DPARM(NFPAR),FPARM(NFPAR)
      DOUBLE PRECISION DSTEP(3), DSTART(3)
      CHARACTER*3 FUN(9)
      CHARACTER*8 FUNCTN
      CHARACTER*80 OPTION
      CHARACTER*60 TABLE,IMAGE,REFIMA
      CHARACTER*16 MSG
      CHARACTER*17 COLREF(3)
      CHARACTER*53 INCOLS,CBUF
      CHARACTER*60 WORK
      CHARACTER*72 IDENT
      CHARACTER*80 CUNIT
C
      INCLUDE 'MID_INCLUDE:TABLES.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:TABLED.INC'
C
      DATA MSG/'ERR:REBISTxxxx'/
      DATA FUN/'LIN','POL','INV','EXP','DEX','LOG','DLG','IPO','U01'/

      DATA TABLE/'  '/
      DATA IMAGE/'  '/
      DATA REFIMA/'  '/
C
C ... get input parameters
C
      CALL STKRDC('OUT_A',1,1,60,IACT,IMAGE,KUN,KNUL,ISTAT)
      CALL STKRDC('IN_A',1,1,60,IACT,TABLE,KUN,KNUL,ISTAT)
      CALL STKRDC('IN_B',1,1,60,IACT,REFIMA,KUN,KNUL,ISTAT)
      CALL STKRDC('COLI',1,1,53,IACT,INCOLS,KUN,KNUL,ISTAT)
      CALL STKRDC('CFUNC',1,1,8,IACT,FUNCTN,KUN,KNUL,ISTAT)
      CALL STKRDD('INPUTD',1,NFPAR,NFPACT,FPARM,KUN,KNUL,ISTAT)
      CALL STKRDC('COPT',1,1,12,IACT,OPTION,KUN,KNUL,ISTAT)
C
C ... determine integration/interpolation option
C  !   Not implemented
      INOP   = 4
C      IF (OPTION(1:3).EQ.'PIX') INOP   = 1
C      IF (OPTION(1:3).EQ.'LIN') INOP   = 2
C      IF (OPTION(1:3).EQ.'SPG') INOP   = 3
C .......................................... the actual values are:
      CALL FORUPC(OPTION,OPTION)
      IF (OPTION(1:1).EQ.'P') INOP   = 2
      IF (OPTION(1:1).EQ.'L') INOP   = 3
      IF (OPTION(1:1).EQ.'S') INOP   = 1
C .......................................... Bitte, bitte
C
C ... translate FUNCTN into function number
C
      CALL FORUPC(FUNCTN,FUNCTN)
      NFUNC  = 0
      DO 10 I = 1,9
          IF (FUNCTN(1:3).EQ.FUN(I)) NFUNC  = I
   10 CONTINUE
      IF (NFUNC.EQ.0) THEN
          CALL STTPUT(' Specified function non-existent...',ISTAT)
          GO TO 80
      END IF
C
C ... search for number of active parameters and 'double-precision' them
C
      DO 20 J = NFPAR,1,-1
          NFPACT = J
          IF (FPARM(J).NE.0.000) GO TO 30
   20 CONTINUE
   30 DO 40 J = 1,NFPACT
          DPARM(J) = FPARM(J)
   40 CONTINUE
C
C ... get parameters from reference image
C
      IREF = -1
      CALL STFOPN(REFIMA,D_R4_FORMAT,0,F_IMA_TYPE,IREF,ISTAT)
      CALL STDRDI(IREF,'NAXIS',1,1,NN,NAXIS,KUN,KNUL,ISTAT)
      CALL STDRDI(IREF,'NPIX',1,NAXIS,NN,NPIX,KUN,KNUL,ISTAT)
      CALL STDRDD(IREF,'START',1,NAXIS,NN,DSTART,KUN,KNUL,ISTAT)
      CALL STDRDD(IREF,'STEP',1,NAXIS,NN,DSTEP,KUN,KNUL,ISTAT)
      CALL STDRDC(IREF,'IDENT',1,1,72,NN,IDENT,KUN,KNUL,ISTAT)
      CALL STDRDC(IREF,'CUNIT',1,1,80,NN,CUNIT,KUN,KNUL,ISTAT)
      IF (NAXIS.GT.1 .AND. NPIX(2).GT.1) THEN
          CALL STTPUT(' Only 1D images are considered ...',ISTAT)
          CALL STFCLO(IREF,ISTAT)
          GO TO 70
      ELSE
          NPIX(2) = 1
          NDIM   = 1
      END IF
      CALL STFCLO(IREF,ISTAT)
C
C ... sort out ind., dep. (and bin) variables
C
      II     = INDEX(INCOLS,',')
      IF (II.EQ.0) THEN
          WRITE (*,*) ' Specification of relevant input',
     +      ' table cols insufficient'
          GOTO 70
      ELSE
          COLREF(1) = INCOLS(1:II-1)
          CBUF   = INCOLS(II+1:)
          II     = INDEX(CBUF,',')
          IF (II.EQ.0) THEN
              COLREF(2) = CBUF(1:)
              BIN    = .FALSE.
          ELSE
              COLREF(2) = CBUF(1:II-1)
              COLREF(3) = CBUF(II+1:)
              BIN    = .TRUE.
          END IF
      END IF
C
C ... init input table
C
      TID = -1
      CALL TBTOPN(TABLE,F_I_MODE,TID,ISTAT)
      IF (ISTAT.NE.0) GO TO 70
      CALL TBIGET(TID,NCOL,NROW,NSC,NAC,NAR,ISTAT)
      IF (ISTAT.NE.0) GO TO 70
C
C ... find input column
C
      IB     = 2
      IF (BIN) IB     = 3
      DO 50 I = 1,IB
          CALL TBCSER(TID,COLREF(I),ICOL(I),ISTAT)
          IF (ICOL(I).EQ.-1) THEN
              CALL STTPUT('Error in column reference',IS)
              GO TO 70
          END IF
C
C ... copy units from table into output image
C
          IF (I.LE.2) THEN
              CALL TBUGET(TID,ICOL(I),WORK,ISTAT)
              I1     = (I-1)*16 + 1
              I2     = I1 + 15
              CUNIT(I1:I2) = WORK(1:16)
          END IF
   50 CONTINUE
C
C ... copy selected values of the table into work space
C
      NBY  = 8*NROW
      CALL TDMGET(NBY,IP1,IS)
      CALL TDMGET(NBY,IP2,IS)
      CALL TDMGET(NBY,IP3,IS)
      IF (BIN) THEN
          CALL BCOPYC(TID,ICOL(1),ICOL(2),ICOL(3),NROW,
     .         MADRID(IP1),MADRID(IP2),MADRID(IP3),NI)
          IF (NI.LE.3) THEN
              CALL STTPUT(' Not enough points in table ',ISTAT)
              GO TO 60
          END IF
      ELSE
          CALL BCOPYI(TID,ICOL(1),ICOL(2),NROW,
     .                MADRID(IP1),MADRID(IP2),MADRID(IP3),NI)
          IF (NI.LE.3) THEN
              CALL STTPUT(' Not enough points in table ',ISTAT)
              GO TO 60
          END IF
      END IF
C
C ... map image
C
      CUNIT(1:16) = 'FLUX'
      I2 = INDEX(TABLE,' ')
      IF (I2.lt.1) I2 = LEN(TABLE)
      IDENT  = 'TABLE: '//TABLE(1:I2)//'COLS. :'//COLREF(1)//COLREF(2)
      CALL STIPUT(IMAGE,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .NDIM,NPIX,DSTART,DSTEP,IDENT,CUNIT,IPNTR,IMNO,ISTAT)
C
C image output, then fill the XO and WO arrays OF INTERPOLn
C
      NO     = NPIX(1)
      NBY1  = 8*NO
      CALL TDMGET(NBY1,JP1,IS)
      CALL TDMGET(NBY1,JP2,IS)
      X0     = DSTART(1)
      WX     = DSTEP(1)
      CALL IMVALS(NO,X0,WX,MADRID(JP1),MADRID(JP2))
C
C ...  Now, at last, we call the interpolating (and integrating)
C ...  routines:
C !!!! Watch out for VECI,VECD arrays in INTERP,
C                                  dimension => NINT !!!!!!
C
      CALL REBMET(NI,MADRID(IP1),MADRID(IP2),MADRID(IP3),NO,
     +             MADRID(JP1),MADRID(JP2),NFUNC,NFPAR,NFPACT,DPARM,
     +             INOP,NINT,MADRID(IPNTR),RMIN,RMAX)
C
C ... write cuts
C
      CUTS(1) = RMIN
      CUTS(2) = RMAX
      CUTS(3) = RMIN
      CUTS(4) = RMAX
      CALL STDWRR(IMNO,'LHCUTS',CUTS,1,4,KUN,ISTAT)
      CALL DSCUPT(IMNO,IMNO,' ',ISTAT)
C
C ... free memory
C
      CALL TDMFRE(NBY1,JP1,IS)
      CALL TDMFRE(NBY1,JP2,IS)
   60 CONTINUE
      CALL TDMFRE(NBY,IP1,IS)
      CALL TDMFRE(NBY,IP2,IS)
      CALL TDMFRE(NBY,IP3,IS)
C
C ... end
C
      CALL TBTCLO(TID,ISTAT)
   70 IF (ISTAT.NE.0) THEN
          WRITE (MSG(13:16),9000) ISTAT
          CALL TDERRR(ISTAT,MSG,JSTAT)
      END IF
   80 RETURN
 9000 FORMAT (I4)
      END

C
      SUBROUTINE TDRBTT
      IMPLICIT NONE
      INTEGER MADRID
      INTEGER    NFPAR
      PARAMETER (NFPAR = 12)
C
      INTEGER*8  IP1,IP2,IP3,JP1, JP2,JP3
      INTEGER I,IACT,IB,IC,II,IS,ISTAT
      INTEGER J,JSTAT,NCO,NCOL
      INTEGER NFUNC,NI,NINT,NMAX,NO,NRO,NROW,NSC
      INTEGER TID, TID1, NAC,NAR,NBY,NBY1
      INTEGER INDEX, KUN, KNUL
      INTEGER NFPACT,INOP
      INTEGER ICOL(3),OCOL(3)
C
      REAL RMAX,RMIN
C
      LOGICAL BIN
C
      DOUBLE PRECISION DPARM(NFPAR)
      DOUBLE PRECISION FPARM(NFPAR)
C
      CHARACTER*3  FUN(9)
      CHARACTER*8  FUNCTN
      CHARACTER*80 OPTION
      CHARACTER*60 TABIN,TABOUT
      CHARACTER*16 MSG
      CHARACTER*17 COLRFI(3),COLRFO(3),LABEL
      CHARACTER*53 INCOLS,OUTCOL,CBUF
      CHARACTER*80 CUNIT
C
      INCLUDE 'MID_INCLUDE:TABLES.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:TABLED.INC'
      DATA MSG/'ERR:REBISTBxxx'/
      DATA FUN/'LIN','POL','INV','EXP','DEX','LOG','DLG','IPO','U01'/
      DATA FPARM /12*0.0/
      DATA DPARM /12*0.0/

      DATA TABIN/'  '/
      DATA TABOUT/'  '/
C
C ... get input parameters
C
      CALL STKRDC('OUT_A',1,1,60,IACT,TABOUT,KUN,KNUL,ISTAT)
      CALL STKRDC('COLO',1,1,53,IACT,OUTCOL,KUN,KNUL,ISTAT)
      CALL STKRDC('IN_A',1,1,60,IACT,TABIN,KUN,KNUL,ISTAT)
      CALL STKRDC('COLI',1,1,53,IACT,INCOLS,KUN,KNUL,ISTAT)
      CALL STKRDC('CFUNC',1,1,8,IACT,FUNCTN,KUN,KNUL,ISTAT)
      CALL STKRDD('INPUTD',1,NFPAR,NFPACT,FPARM,KUN,KNUL,ISTAT)
      CALL STKRDC('COPT',1,1,12,IACT,OPTION,KUN,KNUL,ISTAT)
C
C ... determine integration/interpolation option
      INOP   = 4
      CALL FORUPC(OPTION,OPTION)
      IF (OPTION(1:1).EQ.'P') INOP   = 2          !PIX
      IF (OPTION(1:1).EQ.'L') INOP   = 3          !LIN
      IF (OPTION(1:1).EQ.'S') INOP   = 1          !SPG
C
C ... translate FUNCTN into function number
C
      CALL FORUPC(FUNCTN,FUNCTN)
      NFUNC  = 0
      DO 10 I = 1,9
          IF (FUNCTN(1:3).EQ.FUN(I)) NFUNC  = I
   10 CONTINUE
      IF (NFUNC.EQ.0) THEN
          CALL STTPUT(' Specified function non-existent...',ISTAT)
          GO TO 80
      END IF
C
C ... search for number of active parameters and 'double-precision' them
C
      DO 20 J = NFPAR,1,-1
          NFPACT = J
          IF (FPARM(J).NE.0.0000000) GO TO 30
   20 CONTINUE
   30 DO 40 J = 1,NFPACT
          DPARM(J) = FPARM(J)
   40 CONTINUE
C
C ... sort out ind., dep. (and bin) variables
C
      II     = INDEX(INCOLS,',')
      IF (II.EQ.0) THEN
          WRITE (*,*) ' Specification of relevant input',
     +      ' table cols insufficient'
          GOTO 70
      ELSE
          COLRFI(1) = INCOLS(1:II-1)
          CBUF   = INCOLS(II+1:)
          II     = INDEX(CBUF,',')
          IF (II.EQ.0) THEN
              COLRFI(2) = CBUF(1:)
              BIN    = .FALSE.
          ELSE
              COLRFI(2) = CBUF(1:II-1)
              COLRFI(3) = CBUF(II+1:)
              BIN    = .TRUE.
          END IF
      END IF
C
C ... init input table
C
      TID = -1
      CALL TBTOPN(TABIN,F_I_MODE,TID,ISTAT)
      IF (ISTAT.NE.0) GO TO 70
      CALL TBIGET(TID,NCOL,NROW,NSC,NAC,NAR,ISTAT)
      IF (ISTAT.NE.0) GO TO 70
C
C ... find input column
C
      IB     = 2
      IF (BIN) IB     = 3
      DO 50 I = 1,IB
          CALL TBCSER(TID,COLRFI(I),ICOL(I),ISTAT)
          IF (ICOL(I).EQ.-1) THEN
              CALL STTPUT('Error in column reference',IS)
              GO TO 70
          END IF
   50 CONTINUE
C
C ... copy selected values of the table into work space
C
      NBY = 8*NROW
      CALL TDMGET(NBY,IP1,IS)
      CALL TDMGET(NBY,IP2,IS)
      CALL TDMGET(NBY,IP3,IS)
      IF (BIN) THEN
          CALL BCOPYC(TID,ICOL(1),ICOL(2),ICOL(3),NROW,
     .         MADRID(IP1),MADRID(IP2),MADRID(IP3),NI)
          IF (NI.LE.3) THEN
              CALL STTPUT(' Not enough points in table ',ISTAT)
              GO TO 60
          END IF
      ELSE
          CALL BCOPYI(TID,ICOL(1),ICOL(2),NROW,
     .         MADRID(IP1),MADRID(IP2),MADRID(IP3),NI)


          IF (N I.LE.3) THEN
              CALL STTPUT(' Not enough points in table ',ISTAT)
              GO TO 60
          END IF
      END IF
C
C ... sort out ind., dep. (and bin) variables for output table
C
      II     = INDEX(OUTCOL,',')
      IF (II.EQ.0) THEN
          WRITE (*,*) ' Specification of relevant output',
     +      ' table cols insufficient'
          GOTO 70
      ELSE
          COLRFO(1) = OUTCOL(1:II-1)
          CBUF   = OUTCOL(II+1:)
          II     = INDEX(CBUF,',')
          IF (II.EQ.0) THEN
              COLRFO(2) = CBUF(1:)
              BIN    = .FALSE.
          ELSE
              COLRFO(2) = CBUF(1:II-1)
              COLRFO(3) = CBUF(II+1:)
              BIN    = .TRUE.
          END IF
      END IF
C
C ... access output table
C
      TID1 = -1
      CALL TBTOPN(TABOUT,F_U_MODE,TID1,ISTAT)
      IF (ISTAT.NE.0) GO TO 70
      CALL TBIGET(TID1,NCO,NRO,NSC,NAC,NAR,ISTAT)
      IF (ISTAT.NE.0) GO TO 70
C
C ... find output column
C
      CALL TBCSER(TID1,COLRFO(1),OCOL(1),ISTAT)
      IF (OCOL(1).EQ.-1) THEN
          CALL STTPUT('Error in column reference',IS)
          GO TO 70
      END IF
      IF (BIN) THEN
          CALL TBCSER(TID1,COLRFO(3),OCOL(3),ISTAT)
          IF (OCOL(3).EQ.-1) THEN
              CALL STTPUT('Error in column reference',IS)
              GO TO 70
          END IF
      END IF
C
C ... copy selected values of the table into work space
C
      NBY1 = 8*NRO
      CALL TDMGET(NBY1,JP1,IS)
      CALL TDMGET(NBY1,JP2,IS)
      CALL TDMGET(NBY1,JP3,IS)
      IF (BIN) THEN
          CALL COPYIT(TID1,OCOL(1),OCOL(3),NRO,
     +                MADRID(JP1),MADRID(JP3),NO)
          IF (NO.LE.3) THEN
              CALL STTPUT(' Not enough points in table ',ISTAT)
              GO TO 60
          END IF
      ELSE
          CALL BCPYIT(TID1,OCOL(1),NRO,MADRID(JP1),
     +                 MADRID(JP3),NO)
          IF (NO.LE.3) THEN
              CALL STTPUT(' Not enough points in table ',ISTAT)
              GO TO 60
          END IF
      END IF
C
C  ...  Now, at last, we call the interpolating (and integrating)
C       routines:
C  !!!! Watch out for VECI,VECD arrays in INTERP,
C       dimension => NINT !!!!!!
C
C 
C  NINT was not set, we put it to 2, so XVLS in REBMET is set to 1
      NINT = 2
      CALL REBMET(NI,MADRID(IP1),MADRID(IP2),MADRID(IP3),NO,
     +             MADRID(JP1),MADRID(JP3),NFUNC,NFPAR,NFPACT,DPARM,
     +             INOP,NINT,MADRID(JP2),RMIN,RMAX)
C
C ... end
C
      CALL TBTCLO(TID,ISTAT)
C
C ... output table
C
C ... check if column already exists
C
      CALL TBCSER(TID1,COLRFO(2),IC,ISTAT)
      IF (IC.EQ.-1) THEN
          LABEL  = COLRFO(2) (2:)
          CUNIT  = '  '
          CALL TBCINI(TID1,D_R4_FORMAT,1,'E16.8',CUNIT,LABEL,IC,ISTAT)
      END IF
      NMAX   = NO
      CALL OCOPY(TID1,NMAX,IC,MADRID(JP2))
C
C ... free memory
C
      CALL TDMFRE(NBY1,JP1,IS)
      CALL TDMFRE(NBY1,JP2,IS)
      CALL TDMFRE(NBY1,JP3,IS)
   60 CONTINUE
      CALL TDMFRE(NBY,IP1,IS)
      CALL TDMFRE(NBY,IP2,IS)
      CALL TDMFRE(NBY,IP3,IS)
C
C ... end
C
      CALL TBIPUT(TID1,0,NO,ISTAT)
      CALL TBSINI(TID1,ISTAT)
      CALL DSCUPT(TID1,TID1,' ',ISTAT)
      CALL TBTCLO(TID1,ISTAT)
   70 IF (ISTAT.NE.0) THEN
          WRITE (MSG(13:16),9000) ISTAT
          CALL TDERRR(ISTAT,MSG,JSTAT)
      END IF
   80 RETURN
 9000 FORMAT (I4)
      END

      SUBROUTINE COPYIT(TID,IX,IW,NROW,X1,W1,N1)
C
      IMPLICIT NONE
      INTEGER  TID, NROW, N1, IX, IW
      DOUBLE PRECISION X1(NROW),W1(NROW)
C
      DOUBLE PRECISION XVAL, YVAL
      INTEGER I, ISTAT
      LOGICAL ISEL, INULL1, INULL2
C
      N1     = 0
      DO 10 I = 1,NROW
          CALL TBSGET(TID,I,ISEL,ISTAT)
          CALL TBERDD(TID,I,IX,XVAL,INULL1,ISTAT)
          CALL TBERDD(TID,I,IW,YVAL,INULL2,ISTAT)
          IF (ISEL .AND.(.NOT.INULL1).AND.(.NOT.INULL2)) THEN
              N1     = N1 + 1
              X1(N1) = XVAL
              W1(N1) = YVAL
          END IF
   10 CONTINUE
      RETURN

      END

      SUBROUTINE BCPYIT(TID,IX,NROW,X1,W1,N1)
C
      IMPLICIT NONE
      INTEGER  TID, IX, NROW, N1
      DOUBLE PRECISION X1(NROW),W1(NROW),XD,XM
C
      DOUBLE PRECISION XVAL
      INTEGER I, ISTAT
      LOGICAL ISEL, INULL
C
      N1     = 0
      DO 10 I = 1,NROW
          CALL TBSGET(TID,I,ISEL,ISTAT)
          CALL TBERDD(TID,I,IX,XVAL,INULL,ISTAT)
          IF (ISEL .AND.(.NOT.INULL)) THEN
              N1     = N1 + 1
              X1(N1) = XVAL
          END IF
   10 CONTINUE
      IF (X1(1).LT.X1(N1)) THEN
          XM     = 1.E+33
          DO 20 I = 2,N1
              XD     = X1(I) - X1(I-1)
              IF (DABS(XM).LT.1.D-15) THEN         !XM = 0 is bad...
                 WRITE (KBUF,12345) I,I-1
                 CALL STETER(99,KBUF)
              ENDIF
              IF (XD.LT.XM) XM     = XD
   20     CONTINUE
      ELSE
          XM     = -1.E+33
          DO 30 I = 2,N1
              XD     = X1(I) - X1(I-1)
              IF (DABS(XM).LT.1.D-15) THEN         !XM = 0 is bad...
                 WRITE (KBUF,12345) I,I-1
                 CALL STETER(99,KBUF)
              ENDIF
              IF (XD.GT.XM) XM     = XD
   30     CONTINUE
      END IF
      DO 40 I = 1,N1
          W1(I)  = XM
   40 CONTINUE
      RETURN
C 
12345 FORMAT('rows',I8' and,'I8,' are identical...')
      END

      SUBROUTINE OCOPY(TID1,N,ICOL,ARRAY)
C
C ...  access output table column values from address
C
      IMPLICIT NONE
      INTEGER TID1, N, ICOL, L, ISTAT
      REAL ARRAY(N)
C
      DO 10 L = 1,N
          CALL TBEWRR(TID1,L,ICOL,ARRAY(L),ISTAT)
   10 CONTINUE
      RETURN
      END

      SUBROUTINE IMVAL2(NP,XS,WS,X,W)
C
C  Fill arrays X,W for image world coordinates and pixel size data
C
      IMPLICIT NONE
      INTEGER  I, NP
      REAL     XS, WS
      DOUBLE PRECISION X(NP),W(NP),WSS,XSS
C
      WSS    = WS
      XSS    = XS
      DO 10 I = 1,NP
          X(I)   = XSS + WSS* (I-1)
          W(I)   = WSS
   10 CONTINUE
      RETURN
      END

      SUBROUTINE IMVAL3(NP,XS,WS,YY,X,W,Y)
C
C  Fill arrays X,W for image world coordinates and pixel size data
C  Convert YY(real*4) into Y(real*8)
C
      IMPLICIT NONE
      INTEGER  NP, I
      DOUBLE PRECISION X(NP),W(NP),Y(NP),WSS,XSS
      REAL     XS, WS
      REAL YY(NP)
C
      WSS    = WS
      XSS    = XS
      DO 10 I = 1,NP
          X(I)   = XSS + WSS* (I-1)
          W(I)   = WSS
          Y(I)   = YY(I)
   10 CONTINUE
      RETURN
      END

      SUBROUTINE IMVAL4(NP,XS,WS,YS,X,Y,W)
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C copy IMAGE data into real*8
C       HERE: copy indep, dep and  bin
C -------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER NP, I
      DOUBLE PRECISION X(NP),W(NP),Y(NP),WSS,XSS
      REAL YS(NP)
      REAL     XS, WS
C
      WSS    = WS
      XSS    = XS
      DO 10 I = 1,NP
          X(I)   = XSS + WSS* (I-1)
          W(I)   = WSS
          Y(I)   = YS(I)
   10 CONTINUE
      RETURN
      END

      SUBROUTINE BCOPYC(TID,IX,IY,IW,NROW,X1,Y1,W1,N1)
C
C  REAL*8, BIN CREATION
C
C copy relevant part of the table
C       HERE: copy indep, dep and  bin --> real*8
C             then create bin as the minimum of spacing
C
      IMPLICIT NONE
      INTEGER  TID, IX, IY, IW, NROW, N1
      DOUBLE PRECISION X1(NROW),Y1(NROW),W1(NROW)
C
      INTEGER I, ISTAT
      LOGICAL ISEL, INULL1, INULL2, INULL3
      DOUBLE PRECISION X, Y, W
C
C
      N1     = 0
      DO 10 I = 1,NROW
          CALL TBSGET(TID, I, ISEL, ISTAT)          
          CALL TBERDD(TID, I, IX, X, INULL1, ISTAT)          
          CALL TBERDD(TID, I, IY, Y, INULL2, ISTAT)          
          CALL TBERDD(TID, I, IW, W, INULL3, ISTAT)          
          IF (ISEL.AND.(.NOT.INULL1).AND.(.NOT.INULL2)
     .            .AND.(.NOT.INULL3)) THEN
              N1     = N1 + 1
              X1(N1) = X
              Y1(N1) = Y
              W1(N1) = W
          END IF
   10 CONTINUE
      RETURN
      END

      SUBROUTINE BCOPYI(TID,IX,IY,NROW,X1,Y1,W1,N1)
C
C  REAL*8, BIN CREATION
C
C copy relevant part of the table
C       HERE: copy indep, dep and  bin --> real*8
C             then create bin as the minimum of spacing
      IMPLICIT NONE
      INTEGER  TID, IX, IY, NROW, N1
      DOUBLE PRECISION X1(NROW),Y1(NROW),W1(NROW)
C
      LOGICAL  INULL1, INULL2, ISEL
      DOUBLE PRECISION X, Y, XM, XD
      INTEGER  I, ISTAT
C 
      CHARACTER KBUF*80
C
C
      N1     = 0
      DO 10 I = 1,NROW
          CALL TBSGET(TID, I, ISEL, ISTAT)          
          CALL TBERDD(TID, I, IX, X, INULL1, ISTAT)          
          CALL TBERDD(TID, I, IY, Y, INULL2, ISTAT)          
          IF (ISEL.AND.(.NOT.INULL1).AND.(.NOT.INULL2)) THEN
              N1     = N1 + 1
              X1(N1) = X
              Y1(N1) = Y
          END IF
   10 CONTINUE
      IF (X1(1).LT.X1(N1)) THEN
          XM     = 1.D+33
          DO 20 I = 2,N1
              XD = X1(I) - X1(I-1)
              IF (XD.LT.XM) THEN
                 XM = XD
                 IF (DABS(XM).LT.1.D-15) THEN         !XM = 0 is bad...
                     WRITE (KBUF,12345) I,I-1
                    CALL STETER(99,KBUF)
                 ENDIF
              ENDIF
   20     CONTINUE
      ELSE
          XM     = -1.D+33
          DO 30 I = 2,N1
              XD = X1(I) - X1(I-1)
              IF (XD.GT.XM) THEN
                 XM = XD
                 IF (DABS(XM).LT.1.D-15) THEN         !XM = 0 is bad...
                     WRITE (KBUF,12345) I,I-1
                    CALL STETER(99,KBUF)
                 ENDIF
              ENDIF
   30     CONTINUE
      END IF
      DO 40 I = 1,N1
          W1(I)  = XM
   40 CONTINUE
      RETURN
C 
12345 FORMAT('rows',I8' and,'I8,' are identical...')
      END

      SUBROUTINE IMVALS(NP,XS,WS,X,W)
C
C copy IMAGE data into real*8
C HERE: copy indep, dep and  bin
C
      IMPLICIT NONE
C
      INTEGER  NP, I
      REAL     XS, WS
      DOUBLE PRECISION X(NP),W(NP),WSS,XSS
C
      WSS    = DBLE(WS)
      XSS    = DBLE(XS)
      DO 10 I = 1,NP
          X(I)   = XSS + WSS* (I-1)
          W(I)   = WSS
   10 CONTINUE
      RETURN
      END

C @(#)tsacov.for	19.1 (ESO-DMD) 02/25/03 13:33:25
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT (c) 1992 European Southern Observatory & Copernicus Astron. Center
C.IDENT     tsacov.for
C.AUTHOR    Alex Schwarzenberg-Czerny, Copernicus Astron. Center, Warsaw
C.KEYWORD   MIDAS, time series, COVAR/TSA
C.LANGUAGE  FORTRAN 77
C.PURPOSE   Compute discrete covariance function
C           Reference: Edelson R.A. and Krolik, J.H., 1988, ApJ 333, 646
C.RETURNS   None
C.ENVIRON   TSA context
C.VERSION   0.0               June 1992
C 
C 021031	last modif
C 
C-----------------------------------------------------------------------------
C
C
      INCLUDE 'MID_REL_INCL:TSA_DEF.INC'
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      CHARACTER*60 INAME1               !  NAME OF 1ST OBSERVATION TABLE
      CHARACTER*60 INAME2               !  NAME OF 2ND OBSERVATION TABLE
      CHARACTER*60 ONAME                !  NAME OF OUTPUT COVARIANCE TABLE
      REAL*8       TLAG1                !  START TIME LAG
      REAL*8       DTLAG                !  TIME LAG INCREMENT
      INTEGER      NLAG                 !  NUMBER OF TIME LAGS
C
      INTEGER      NOBS1, NOBS2
      INTEGER      ISCALE,IFUNCT,IACTS, KUN,   KNUL
      INTEGER      TID1,  TID2,  OTID,  ITIME, IDAT, IVAR
      INTEGER      NCOL,  ICOL,  NROW,  ISOR
      INTEGER      LFIELD,TTYP,  DTYP,  VTYP
      INTEGER      ICOVN, ICOVC, ICOVV
C 
      INTEGER*8      POBS1T,POBS1D,POBS1V
      INTEGER*8      POBS2T,POBS2D,POBS2V
      INTEGER*8      PCOVN, PCOVC, PCOVV
C 
      DOUBLE PRECISION       AV1,VAR1,AV2,VAR2
      CHARACTER*3  CSCALE
      CHARACTER*1  CFUNCT
      CHARACTER*10 FORM
      CHARACTER*80 TEXT
C
      INCLUDE 'MID_REL_INCL:TSA_DAT.INC'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C
C   Get parameters
C
      CALL STSPRO ('tsacov')
      CALL STKRDC ('IN_A',   1,1,60,IACTS,INAME1,KUN,KNUL,ISTAT)
      CALL STKRDC ('IN_B',   1,1,60,IACTS,INAME2,KUN,KNUL,ISTAT)
      CALL STKRDC ('OUT_A',  1,1,60,IACTS,ONAME, KUN,KNUL,ISTAT)
      CALL STKRDD ('STARTTSA',    1, 1,IACTS,TLAG1, KUN,KNUL,ISTAT)
      CALL STKRDD ('STEPTSA',     1, 1,IACTS,DTLAG, KUN,KNUL,ISTAT)
      CALL STKRDI ('NSTEPS',   1, 1,IACTS,NLAG,  KUN,KNUL,ISTAT)
      CALL STKRDC ('CSCALE', 1,1, 3,IACTS,CSCALE,KUN,KNUL,ISTAT)
      IF     (LLE(CSCALE,'LIN').AND.LGE(CSCALE,'LIN')) THEN
        ISCALE=1
      ELSEIF (LLE(CSCALE,'LOG').AND.LGE(CSCALE,'LOG')) THEN
        ISCALE=2
      ELSE
        CALL STETER(6,'SCALE must be LIN or LOG')
      ENDIF
      CALL STKRDC ('CFUNCT', 1,1, 1,IACTS,CFUNCT,KUN,KNUL,ISTAT)
      IF     (LLE(CFUNCT,'C').AND.LGE(CFUNCT,'C')) THEN
        IFUNCT=1
      ELSEIF (LLE(CFUNCT,'S').AND.LGE(CFUNCT,'S')) THEN
        IFUNCT=2
      ELSE
        CALL STETER(6,'FUNCT must be C or S')
      ENDIF

C
C   Map input data
C
      CALL TBTOPN (INAME1,F_I_MODE,TID1,ISTAT)
      CALL TBIGET (TID1,NCOL,NOBS1,ISOR,ICOL,NROW,ISTAT)
      CALL TBLSER (TID1,'TIME' ,ITIME,ISTAT)
      IF (ITIME.LT.0) THEN
        CALL STETER(5,'Column :TIME not found in 1st table')
      ENDIF
      CALL TBLSER (TID1,'VALUE',IDAT ,ISTAT)
      IF (IDAT.LT.0) THEN
        CALL STETER(6,'Column :VALUE not found in 1st table')
      ENDIF
      CALL TBLSER (TID1,'VAR'  ,IVAR, ISTAT)
      IF (IVAR.LT.0) THEN
        CALL STETER(7,'Column :VAR not found in 1st table')
      ENDIF
      CALL TBFGET (TID1,ITIME,FORM,LFIELD,TTYP,ISTAT)
      CALL TBFGET (TID1,IDAT, FORM,LFIELD,DTYP,ISTAT)
      CALL TBFGET (TID1,IVAR, FORM,LFIELD,VTYP,ISTAT)
      CALL TBDGET (TID1,ISTORE,ISTAT)
      IF (ISTORE.NE.F_TRANS) THEN
        TEXT='Input table '//INAME1//' stored not transposed'
        CALL STETER(1,TEXT)
      ENDIF
      IF (TTYP.NE.D_R8_FORMAT.OR.DTYP.NE.D_R8_FORMAT.OR.
     $     VTYP.NE.D_R8_FORMAT) THEN
        CALL STETER(1,
     $    'Column(s) in 1st table must be in DOUBLE PRECISION')
      ENDIF
      CALL TBCMAP (TID1,ITIME,POBS1T,ISTAT)
      CALL TBCMAP (TID1,IDAT, POBS1D,ISTAT)
      CALL TBCMAP (TID1,IVAR, POBS1V,ISTAT)
C
      IF (LLE(INAME2,INAME1).AND.LGE(INAME2,INAME1)) THEN
        POBS2T=POBS1T
        POBS2D=POBS1D
        POBS2V=POBS1V
      ELSE
        CALL TBTOPN (INAME2,F_I_MODE,TID2,ISTAT)
        CALL TBIGET (TID2,NCOL,NOBS2,ISOR,ICOL,NROW,ISTAT)
        CALL TBLSER (TID2,'TIME' ,ITIME,ISTAT)
        IF (ITIME.LT.0) THEN
          CALL STETER(8,'Column :TIME not found in 2nd table')
        ENDIF
        CALL TBLSER (TID2,'VALUE',IDAT ,ISTAT)
        IF (IDAT.LT.0) THEN
          CALL STETER(9,'Column :VALUE not found in 2nd table')
        ENDIF
        CALL TBLSER (TID2,'VAR'  ,IVAR, ISTAT)
        IF (IVAR.LT.0) THEN
          CALL STETER(10,'Column :VAR not found in 2nd table')
        ENDIF
        CALL TBFGET (TID2,ITIME,FORM,LFIELD,TTYP,ISTAT)
        CALL TBFGET (TID2,IDAT, FORM,LFIELD,DTYP,ISTAT)
        CALL TBFGET (TID2,IVAR, FORM,LFIELD,VTYP,ISTAT)
        CALL TBDGET (TID2,ISTORE,ISTAT)
        IF (ISTORE.NE.F_TRANS) THEN
          TEXT='Input table '//INAME2//' stored not transposed'
          CALL STETER(3,TEXT)
        ENDIF
        IF (TTYP.NE.D_R8_FORMAT.OR.DTYP.NE.D_R8_FORMAT.OR.
     $       VTYP.NE.D_R8_FORMAT) THEN
          CALL STETER(4,
     $      'Column(s) in 2nd table must be in DOUBLE PRECISION')
        ENDIF
        CALL TBCMAP (TID2,ITIME,POBS2T,ISTAT)
        CALL TBCMAP (TID2,IDAT, POBS2D,ISTAT)
        CALL TBCMAP (TID2,IVAR, POBS2V,ISTAT)
      ENDIF
C
C   Create and map output table
C
      NCOL=3
      CALL TBTINI (ONAME,F_TRANS,F_IO_MODE,NCOL,NLAG,OTID,ISTAT)
      CALL TBCINI (OTID,D_R8_FORMAT,1,'E15.6',' ','LAG',  ICOVN,ISTAT)
      CALL TBCINI (OTID,D_R8_FORMAT,1,'E15.6',' ','COVAR',ICOVC,ISTAT)
      CALL TBCINI (OTID,D_R8_FORMAT,1,'E15.6',' ','ERROR',ICOVV,ISTAT)
      CALL TBCMAP (OTID,ICOVN,PCOVN,ISTAT)
      CALL TBCMAP (OTID,ICOVC,PCOVC,ISTAT)
      CALL TBCMAP (OTID,ICOVV,PCOVV,ISTAT)
C
C   Compute covariance function
C
      CALL COVAR(
     $  MADRID(POBS1T),MADRID(POBS1D),MADRID(POBS1V),
     $  MADRID(POBS2T),MADRID(POBS2D),MADRID(POBS2V),
     $  MADRID(PCOVC), MADRID(PCOVV), MADRID(PCOVN),
     $  NOBS1,NOBS2,NLAG,ISCALE,IFUNCT,TLAG1,DTLAG,AV1,VAR1,AV2,VAR2)
      CALL TBIPUT (OTID,NCOL,NLAG,ISTAT)
C
C   Wind-up
C
      CALL DSCUPT(OTID,OTID,' ',ISTAT)
      CALL STSEPI
C
      END
C
C
C
C
C   COVAR
C
C   Compute discrete covariance function for unequaly sampled signal
C   Reference: Edelson R.A. and Krolik, J.H., 1988, ApJ 333, 646
C
C   Input:
C   OBS1T(NOBS1) - 1st set of observations: time
C   OBS1D(NOBS1) - 1st set of observations:     value
C   OBS1V(NOBS1) - 1st set of observations:          variance
C   OBS2T(NOBS2) - 2nd set of observations: time
C   OBS2D(NOBS2) - 2nd set of observations:     value
C   OBS2V(NOBS2) - 2nd set of observations:          variance
C   COVN (NLAG)  - time lag,...
C   COVC (NLAG)  -       ... covariance, ...
C   COVV (NLAG)  -                   ... and its error
C   ISCALE          - mode of output scale (linear of logarythmic)
C   IFUNCT          - type of output function (correlation or structure)
C   NOBS1         - number of observations in 1st set
C   NOBS2         - number of observations in 2nd set
C   TLAG1         - first time lag
C   DTLAG         - lag increment
C   NLAG          - number of lags
C
C   Output:
C   COV(NLAG)     - structure function
C
      SUBROUTINE COVAR(
     $  OBS1T,OBS1D,OBS1V,OBS2T,OBS2D,OBS2V,
     $  COVC,COVV,COVN,NOBS1,NOBS2,NLAG,ISCALE,IFUNCT,TLAG1,DTLAG,
     $  AV1,VAR1,AV2,VAR2)
C
      INCLUDE 'MID_REL_INCL:TSA_DEF.INC'
C
      INTEGER NOBS1,NOBS2,NLAG,ISCALE,IFUNCT
      DOUBLE PRECISION  OBS1T(NOBS1),OBS1D(NOBS1),OBS1V(NOBS1)
      DOUBLE PRECISION  OBS2T(NOBS2),OBS2D(NOBS2),OBS2V(NOBS2)
      DOUBLE PRECISION  COVC(NLAG),  COVV(NLAG),  COVN(NLAG)
      DOUBLE PRECISION  TLAG1,DTLAG
      DOUBLE PRECISION  AV1,VAR1,AV2,VAR2,VAR12
C
      INTEGER IOBS1,IOBS2,ILAG
      DOUBLE PRECISION  CT1,CT2,COUNT,OLDAVER,AVER
      DOUBLE PRECISION  V,VI,EI
      DOUBLE PRECISION  T,TLAG0,TI
C
      INCLUDE 'MID_REL_INCL:TSA_CONST.INC'
C
C   Compute weighted averages and variances
C
      AV1=ZERO
      AV2=ZERO
      VAR1=ZERO
      VAR2=ZERO
      CT1=ZERO
      CT2=ZERO
      DO 3 IOBS1=1,NOBS1
        AV1=AV1+OBS1D(IOBS1)/OBS1V(IOBS1)
 3      CT1=CT1+ONE/OBS1V(IOBS1)
      AV1=AV1/CT1
      DO 31 IOBS1=1,NOBS1
        V=OBS1D(IOBS1)-AV1
 31     VAR1=VAR1+V*V/OBS1V(IOBS1)
      VAR1=VAR1/(NOBS1-ONE)*NOBS1/CT1
      DO 4 IOBS2=1,NOBS2
        AV2=AV2+OBS2D(IOBS2)/OBS2V(IOBS2)
 4      CT2=CT2+ONE/OBS2V(IOBS2)
      AV2=AV2/CT2
      DO 41 IOBS2=1,NOBS2
        V=OBS2D(IOBS2)-AV2
 41     VAR2=VAR2+V*V/OBS2V(IOBS2)
      VAR2=VAR2/(NOBS2-ONE)*NOBS2/CT2
      VAR12=SQRT(VAR1*VAR2)
C
C   Compute binned discrete covariance function
C
      DO 5 ILAG=1,NLAG
        COVC(ILAG)=ZERO
        COVV(ILAG)=ZERO
 5      COVN(ILAG)=ZERO
      TLAG0=TLAG1
      DO 1 IOBS1=1,NOBS1
        TI=OBS1T(IOBS1)
        VI=OBS1D(IOBS1)-AV1
        EI=OBS1V(IOBS1)
        DO 1 IOBS2=1,NOBS2
          T=TI-OBS2T(IOBS2)
          IF (T.GT.ZERO) THEN
            IF (ISCALE.EQ.2) THEN
              T=LOG10(T)
            ENDIF
            ILAG=(T-TLAG0)/DTLAG
            IF (ILAG.GT.0.AND.ILAG.LE.NLAG) THEN
              V=AV2-OBS2D(IOBS2)+VI
              V=V*V-EI-OBS2V(IOBS2)
C
C   Use rounding proof algorithm for accumulation of means and variances
C
              COUNT=COVN(ILAG)+ONE
              OLDAVER=COVC(ILAG)
              AVER=OLDAVER+(V-OLDAVER)/COUNT
              COVC(ILAG)=AVER
              COVV(ILAG)=COVV(ILAG)+(V-OLDAVER)*(V-AVER)
              COVN(ILAG)=COUNT
            ENDIF
          ENDIF
 1    CONTINUE
C
C   Get errors and time lag grid
C
      DO 6 ILAG=1,NLAG
        IF (COVN(ILAG).GT.1.5) THEN
          COVV(ILAG)=SQRT(COVV(ILAG)/(COVN(ILAG)-ONE))
          IF (IFUNCT.EQ.1) THEN
            COVV(ILAG)=VAR12-COVV(ILAG)
          ENDIF
        ENDIF
        IF (IFUNCT.EQ.1) THEN
          COVC(ILAG)=VAR12-COVC(ILAG)
        ENDIF
        COVN(ILAG)=TLAG1+DTLAG*(ILAG-1)
 6    CONTINUE
      END

C===========================================================================
C Copyright (C) 1995-2006 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================

C ++++++++++++++++++++++++  sti.for +++++++++++++++++++++++++++++++++++++++
C .LANGUAGE Fortran 77
C .IDENTIFICATION Module sti.for
C .COMMENTS
C Module contains layer between the keyword related FORTRAN STxxxx interfaces
C and the SC_interfaces written in (hopefully independent) C
C .AUTHOR         K. Banse        ESO - Garching
C .KEYWORDS       standard interfaces.
C .ENVIRONMENT    FORTRAN and C standards
C .VERSION  [1.00] 871207:  created from SXFTOC.C
C 
C 060327	last modif
C -----------------------------------------------------------------------------
C
      SUBROUTINE STIGET(NAME,DATTYPE,IOMODE,FILTYPE,MAXDIM,NAXIS,NPIX,
     +                  START,STEP,IDENT,CUNIT,PNTR,NO,STATUS)
C 
      CHARACTER*(*)   NAME
      INTEGER     DATTYPE,IOMODE,FILTYPE,MAXDIM,NAXIS,NPIX(*)
      DOUBLE PRECISION  START(*), STEP(*)
      CHARACTER*(*)   IDENT, CUNIT
      INTEGER*8   PNTR
      INTEGER     NO, STATUS
C 
      CALL STSTR(1,NAME)                              !STRIPPED_STRING
      CALL STLOC(1,1,IDENT)                           !blanked CHAR_LOC
      CALL STLOC(2,1,CUNIT)                           !blanked CHAR_LOC
C 
      CALL STI1(DATTYPE,IOMODE,FILTYPE,MAXDIM,NAXIS,NPIX,
     +          START,STEP,PNTR,NO,STATUS)

      RETURN
      END
C
C 
      SUBROUTINE STIPUT(NAME,DATTYPE,IOMODE,FILTYPE,NAXIS,NPIX,
     +                  START,STEP,IDENT,CUNIT,PNTR,NO,STATUS)
C 
      CHARACTER*(*)   NAME
      INTEGER     DATTYPE,IOMODE,FILTYPE,NAXIS,NPIX(*)
      DOUBLE PRECISION  START(*), STEP(*)
      CHARACTER*(*)   IDENT, CUNIT
      INTEGER*8   PNTR
      INTEGER     NO, STATUS
C 
      CALL STSTR(1,NAME)                              !STRIPPED_STRING
      CALL STSTR(2,IDENT)                             !STRIPPED_STRING
      CALL STSTR(3,CUNIT)                             !STRIPPED_STRING
C 
      CALL STI2(DATTYPE,IOMODE,FILTYPE,NAXIS,NPIX,
     +          START,STEP,PNTR,NO,STATUS)
C
      RETURN
      END

C @(#)fltrbp.for	19.1 (ES0-DMD) 02/25/03 13:25:33
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine FLTRBP         version 1.0         1987.01.26
C  A. Kruszewski             Obs. de Geneve
C.PURPOSE
C  Identifies bright pixels and replaces them with median value
C  of eight nearest pixels. Average value of all nine pixels
C  is updated.
C.INPUT/OUTPUT
C  Input parameters
C  A          real*4 array        input image array
C  JAPY       integer*4 array     pointers to image lines
C  IBUF       integer*4 array     limits of image buffer
C  I          integer*4           pixel X coordinate
C  J          integer*4           pixel Y coordinate
C  BGRD       real*4              local background
C  FLTR       real*4              filter parameter
C  AV         real*4              average of nine central pixels
C  Output parameters
C  AV         real*4              may be updated
C-----------------------------------------------------------------------
      SUBROUTINE FLTRBP(A, JAPY, IBUF, I, J, BGRD, FLTR, AV)
C
      IMPLICIT  NONE
C
      REAL      A(1)
      INTEGER   JAPY(1)
      INTEGER   IBUF(4)
      INTEGER   I
      INTEGER   J
      REAL      BGRD 
      REAL      FLTR
      REAL      AV
C
      INTEGER   IADR , IADRM , IADRP
      INTEGER   JOFF
      INTEGER   K
      INTEGER   L, L1
      REAL      AT(8), AV5 , AV8
      REAL      CPIX 
      REAL      TEMP
C
      JOFF = IBUF(2) - 1
      IADR = JAPY(J-JOFF) + I
      CPIX = A(IADR)
      AV8 = ( AV * 9.0 - CPIX ) / 8.0
      IF ( (CPIX-AV8) .GT. (0.5*FLTR*(AV8-BGRD)) ) THEN
          IADRM = JAPY(J-JOFF-1) + I
          IADRP = JAPY(J-JOFF+1) + I
          AT(1) = A(IADRM-1)
          AT(2) = A(IADRM)
          AT(3) = A(IADRM+1)
          AT(4) = A(IADR-1)
          AT(5) = A(IADR+1)
          AT(6) = A(IADRP-1)
          AT(7) = A(IADRP)
          AT(8) = A(IADRP+1)
          DO 10 K = 1 , 7
            L1 = K + 1
            DO 20 L = 8 , L1 , -1
                IF ( AT(L) .LT. AT(L-1) ) THEN
                  TEMP = AT(L)
                  AT(L) = AT(L-1)
                  AT(L-1) = TEMP
                ENDIF
   20            CONTINUE
   10          CONTINUE
             AV5 = 0.0
          DO 30 K = 2 , 6
            AV5 = AV5 + AT(K)
   30          CONTINUE
             AV5 = AV5 / 5.0
          IF ( (CPIX-AV5) .GT. (FLTR*(AV5-BGRD)) ) THEN
            AV = AV5
          ENDIF
      ENDIF
C
      RETURN
C
      END

C @(#)gd8d1.for	19.1 (ES0-DMD) 02/25/03 13:55:08
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
	SUBROUTINE GD8001(DEVICE,DISPLAY,IDST)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine IIDOPN	version 1.00	880517
C  K. Banse		ESO - Garching
C
C.KEYWORDS
C  DeAnza unit, logical assignment
C
C.PURPOSE
C  fulfill the stuff as prescribed in the IDI document...
C
C.ALGORITHM
C  straight forward
C
C.INPUT/OUTPUT
C  call as  IIDOPN(DEVICE,DISPLAY,IDST)
C
C  input par:
C  DEVICE:	char.exp.	device type: we expect "DEANZ" ...
C	
C  output par:
C  DISPLAY:	I*4		display identifier, used for the DeAnza unit no.
C  IDST:	I*4		return status, 0 = success
C
C.VERSIONS
C  1.00		creation (from IDI_OPEN as of 880118)
C
C--------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4 	CHANL,DISPLAY,IDST
	INTEGER*4	IAV,N
	INTEGER*4	KUNIT(1),NULLO
C	
	INTEGER*2	UNIT
C	
	CHARACTER*(*)	DEVICE
C	
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
	INCLUDE	'MID_INCLUDE:IDIDEV.INC'
C
C	
	UNIT = QDSPNO
	CALL IP8DAT(UNIT)			!attach unit
C
C  see, if joystick or trackball
	IF (QJOYFL.EQ.1) CALL TRKBAL(UNIT)
C	
C  all o.k. - get the memory stuff in
	N = (QLSTCH + 1) * 2			!QLSTCH = last channel no.
	CALL STKRDI('DAZDEVR',1,N,IAV,MEMREG,KUNIT,NULLO,IDST)
C	
	CALL GD8039(DISPLAY,IDST)		!use IIISTI to clear interactive flags
C	
	IDST = 0
	RETURN
C	
	END

	SUBROUTINE GD8002(DISPLAY,IDST)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine IIDCLO	version 1.00	880118
C  K. Banse		ESO - Garching
C
C.KEYWORDS
C  DeAnza unit, logical assignment
C
C.PURPOSE
C  fulfill the stuff as prescribed in the IDI document...
C
C.ALGORITHM
C  straight forward
C
C.INPUT/OUTPUT
C  call as  IIDCLO(DISPLAY,IDST)
C
C  input par:
C  DISPLAY:	I*4		display identifier
C	
C  output par:
C  IDST:	I*4		return status, 0 = success
C
C.VERSIONS
C  1.00		creation (from IDI_CLOSE as of 880118)
C
C--------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4 	DISPLAY,IDST
	INTEGER*4	N,KUNIT(1)
C	
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
	INCLUDE	'MID_INCLUDE:IDIDEV.INC/NOLIST'
C	
C  save memory control register stuff
	N = (QLSTCH + 1) * 2
	CALL STKWRI('DAZDEVR',MEMREG,1,N,KUNIT,IDST)
	IDST = 0
C	
	RETURN
	END

	SUBROUTINE GD8003(DISPLAY,IDST)
C 
	INTEGER*4  DISPLAY,IDST
C 
	IDST = 0
	RETURN
C 
	END

	SUBROUTINE GD8004(DISPLAY,IDST)
C 
	INTEGER*4  DISPLAY,IDST
C 
	IDST = 0
	RETURN
C 
	END

	SUBROUTINE GD8010(DISPLAY,CONFNO,IDST)
C	
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine IIDSEL		version 1.00	880202
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  DeAnza, initialisation
C
C.PURPOSE
C  fulfill the requirements as described in the IDI document
C
C.ALGORITHM
C  use DeAnza level 0 software
C
C.INPUT/OUTPUT
C  call as  IIDSEL(DISPLAY,CONFNO,IDST)
C
C  input par:
C  DISPLAY:	I*4		display id.
C  CONFNO:	I*4		configuration number, currently only
C				CONFNO = 2 for RGB mode
C				       = 1 for pseudo-colour mode
C  output par:
C  IDST:	I*4		return status
C	
C.VERSIONS
C
C--------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,CONFNO,IDST
	INTEGER*4	MEMSIZ,STAT
	INTEGER*4	M,N,NN
C		
	INTEGER*2	UNIT
	INTEGER*2	NULL(2)
	INTEGER*2	FCREG,PSR,ITT(256)
	INTEGER*2	LMC,LMR,LR,LVR,WR,LCR,LPR,BPA
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
	INCLUDE	'MID_INCLUDE:IDIDEV.INC/NOLIST'
C	
	EXTERNAL	LMC,LMR,LR,LVR,WR,LCR,LPR,BPA
C
	DATA	PSR	/"162344/
	DATA	NULL	/0,0/
	DATA	NN	/0/
C	
C  get unit + last channel
	UNIT = DISPLAY
C	
C
C--------------------------------------------------
C  initialize master sync register + zero the DVP control register (misc. reg. 2
C--------------------------------------------------
C	
	CALL IP8QW(LMR,UNIT,DZIOSB,,,NULL,4,2,2)	!fill 4 bytes => reg. 2 + 3
CCC	CALL IP8QW(LMR,UNIT,DZIOSB,,,NULL,2,1,2)
C	
C--------------------------------------------------
C  handle the system registers (0 - 31)
C--------------------------------------------------
C	
C
C  set RESOLUTION register (reg 11) to: low byte xfer,
C				     yes/no extended memory,
C				     low res VOC,
C				     xres = 1024/512, yres = 1024/512
	IF (QMSZX.LT.1024) THEN		!just test the x-dim of memory
	   SYSREG(12) = "100
	ELSE
	   SYSREG(12) = "140		!extended memory ...
	ENDIF
C
C  set FOREGROUND register (reg 12) to: value = 0
	SYSREG(13) = 0
C
C  set BACKGROUND register (reg 13) to: value = 0
	SYSREG(14) = 0
C	
C  and write it out
	CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(12),6,1,11)
C
C  set the X registers
	SYSREG(17) = 0			!X = 0		(16)
	SYSREG(18) = 0			!XT = 0		(17)
	SYSREG(19) = SYSREG(17)		!XMIN = X	(18)
	SYSREG(20) = QMSZX - 1		!XMAX = 511,1023,... (19)
	SYSREG(21) = 0			!XAMIN = 0	(20)
	SYSREG(22) = SYSREG(20)		!XAMAX = XMAX	(21)
	SYSREG(23) = SYSREG(20)		!DX = XMAX	(22)
	SYSREG(24) = 0			!XTEMP = 0	(23)
C	
C  and write it out
	CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(17),16,1,16)
C
C  set the X registers
	SYSREG(25) = 0			!Y = 0		(24)
	SYSREG(26) = 0			!YT = 0		(25)
	SYSREG(27) = SYSREG(25)		!YMIN = 0	(26)
	SYSREG(28) = QMSZY - 1		!YMAX = 511, 1023, ... (27)
	SYSREG(29) = 0			!YAMIN = 0	(28)
	SYSREG(30) = SYSREG(28)		!YAMAX = YMAX	(29)
	SYSREG(31) = SYSREG(28)		!DY = YMAX	(30)
	SYSREG(32) = 0			!YTEMP = 0	(31)
C	
C  and write it out
	CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(25),16,1,24)
C	
C--------------------------------------------------
C  clear all CMRs
C--------------------------------------------------
C	
C  clear all following SYREGS = CMR0 - CMR15
	DO N=33,64
	   SYSREG(N) = 0
	ENDDO
	CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(33),64,1,32)
C	
C--------------------------------------------------
C  initialize Peripheral Select reg.
C--------------------------------------------------
C	
C                 cursor board i -> VOC i
C                 A/N generator i -> VOC i
C	
	CALL IP8QW(LMR,UNIT,DZIOSB,,,PSR,2,0,0)
C	
C--------------------------------------------------
C  init + clear all DeAnza memories
C--------------------------------------------------
C	
C  set CONTROL register (reg 10) to: matrix mode,
C				     x-dir primary, y-dir seconday,
C				     increment secondary axis by +1
C				     increment primary axis by +1
	SYSREG(11) = "10
	CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(11),2,0,10)
C	
	DO M=0,QLSTCH
	   N = M + 1
	   MEMREG(1,N) = 0			!default for register 0
	   MEMREG(2,N) = QDSZY - 1		!default for reg. 1 is top line of screen
	   MEMREG(3,N) = -1			!default for register 2
	   IF (M.EQ.QLSTCH) THEN
	      MEMREG(4,N) = "12000		!declare channel as graphics
	   ELSE
	      MEMREG(4,N) = "10000		!default for register 3
	   ENDIF
	   MEM7RG(N) = 0			!default for register 7
C	
	   CALL IP8QW(LMC,UNIT,DZIOSB,,,MEMREG(1,N),8,M,0)
C	
	   SYSREG(33) = 2**M			!fill also low part of CMR0
	   CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(33),2,1,32)
	   CALL IP8QW(WR,UNIT,DZIOSB,,,NN,2,0,1)	!NN is dummy
	ENDDO
C
C  set CONTROL register (reg 10) to: non-matrix mode,
C				     x-dir primary, y-dir seconday,
C				     increment secondary axis by +1
C				     increment primary axis by +1
	SYSREG(11) = 0
C	
C  broadcast ramp ITT to all memory channels
	M = QLSTCH + 1		!total no. of memories
	SYSREG(33) = (2**M) - 1
	CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(33),2,0,32)
	DO N=1,256
	   ITT(N) = N - 1
	ENDDO
	CALL IP8QW(BPA,UNIT,DZIOSB,,,ITT,512,0,0)
C	
C  reset also DX, DY registers and CMR0
	SYSREG(23) = 0
	SYSREG(31) = 0
	SYSREG(33) = 0
	CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(11),46,1,10)
C
C--------------------------------------------------
C  clear A/N memory
C--------------------------------------------------
C	
	IF (QALPNO.NE.0) CALL GD8018(DISPLAY,QALPNO,1,0,IDST)
C
C--------------------------------------------------
C  initialize cursor registers
C--------------------------------------------------
C	
	CURREG(1) = 224		!set cursor coord. to center of screen
	CURREG(2) = 224
	CURREG(3) = 274
	CURREG(4) = 274
C	
C  set up Cursor Control register (reg. 4):
C	disable display of programmable cursors
C	both cursors use VOC LUT section 0 (black area -> LUT section 2)
C	disable priority blinking
C	disable intensity inversion, disable X-, Y- components for cursor 1 + 2
C	use fixed cursor form 0
	CURREG(5) = 0
	CURREG(6) = 0
	CURREG(7) = 0
	CALL IP8QW(LCR,UNIT,DZIOSB,,,CURREG(1),14,0,0)
C
C--------------------------------------------------
C  initialize VOC registers:
C--------------------------------------------------
C	
C	enable split screen, disable cursors
C	enable alpha numerics
C	all FCRs use channel 0 + bypass LUT
C	
	VOCREG(1) = 0			!X split	(0)
	VOCREG(2) = QDSZY - 1		!Y split	(1)
C	
C  set VOC control reg.:
C	cursor enable, alphanumeric enable,
C	graphics enable, hardsplit enable
C	
	VOCREG(3) = "042403		!CONTROL	(2)
C	
C  use LUT section 0
	VOCREG(4) = 0			!LUT address	(3)
C	
C  send the stuff out
	CALL IP8QW(LVR,UNIT,DZIOSB,,,VOCREG,8,0,0)
C
C  set up FCR's for colour + graphics
C--------------------------------------------------
C	
C	
	IF (CONFNO.EQ.1) THEN
C	
C  in pseudo colour mode:
C  channel 0  ->  all screen segments + R, G, B channel
C  bypass LUT
C  QLSTCH ->  all screen segments + overlay channel
C	
	   FCREG = ISHFT(QLSTCH,8)
	   DO N=1,4
	      FCR(N) = 0
	      FCR(N+4) = FCREG
	   ENDDO
C	
	ELSE
C	
C  in RGB mode:
C  channel 0  ->  all screen segments + R channel
C  channel 1  ->  all screen segments + G channel
C  channel 2  ->  all screen segments + B channel
C  bypass LUT
C  QLSTCH     ->  all screen segments + overlay channel
C	
	   IF (QLSTCH.LT.3) THEN
	      DO N=1,8				!send chan 0 to everything
		 FCR(N) = "010020
	      ENDDO
	      IF (QLSTCH.GE.1) THEN
	         DO N=1,4			!send chan 0,1 comme il faut
		    FCR(N) = "010420
	         ENDDO
	      ENDIF
	      IF (QLSTCH.GE.2) THEN
	         DO N=5,8			!send chan 0,1,2 comme il faut
		    FCR(N) = "22
	         ENDDO
	      ENDIF
	   ELSE
	      DO N=1,4				!send chan 0,1,2,3 comme il faut
		 FCR(N) = "010420
		 FCR(N+4) = "001422
	      ENDDO
	   ENDIF
	ENDIF
C	
C  send the stuff out
	CALL IP8QW(LVR,UNIT,DZIOSB,,,FCR,16,0,8)
C	
C  alright then...
	RETURN
	END

	SUBROUTINE GD8016(DISPLAY,CHANS,NOCHAN,LUTF,ITTF,IDST)
C	
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine IIDSDP		version 1.00	880201
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  DeAnza, memory channel, ITT, LUT
C
C.PURPOSE
C  fulfill the requirements as described in the IDI document 
C
C.ALGORITHM
C  use DeAnza level 0 software
C
C.INPUT/OUTPUT
C  call as  IIDSDP(DISPLAY,CHANS,NOCHAN,LUTF,ITTF,IDST)
C
C  input par:
C  DISPLAY:	I*4		display id.
C  CHANS:	I*4 array	memory id's
C  NOCHAN:	I*4		no. of memories
C  LUTF:	I*4 array	LUT flags : -1 = leave it as it is
C				             7 = R + G + B
C					     1 = R
C					     2 = G
C					     4 = B
C  ITTF:	I*4 array	ITT flags : -1 = leave it as it is
C					     0 = bypass ITT
C					     1 = use ITT
C	
C  output par:
C  IDST:	I*4		return status
C
C--------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,CHANS(1),NOCHAN,LUTF(1),ITTF(1)
	INTEGER*4	IDST,N,LOOP,SPLITMODE
C	
	INTEGER*2	UNIT,FCLEFT,FCRIGHT,BY
	INTEGER*2	WORK,CLEAR
	INTEGER*2	LMC,RVR,LVR
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
	INCLUDE	'MID_INCLUDE:IDIDEV.INC'
C	
	EXTERNAL	LMC,LVR,RVR
C	
	UNIT = DISPLAY
	CALL STKRDI('DAZHOLD',3,1,N,SPLITMODE,N,N,N)
C 
C  loop over channels
	DO 1000 LOOP=1,NOCHAN
C	
C  test, if we have to modify ITT visibility
	   IF (ITTF(LOOP).GE.0) THEN
C	
C  clear + set ITT bit (12) of memory register 3 of channel CHAN
	      N = CHANS(LOOP) + 1
	      MEMREG(4,N) = IAND(MEMREG(4,N),"167777)	
	      IF (ITTF(LOOP).NE.0)
     +	         MEMREG(4,N) = IOR(MEMREG(4,N),"10000)	
C	
C  and send it out
	      CALL IP8QW(LMC,UNIT,DZIOSB,,,MEMREG(4,N),2,CHANS(LOOP),3)
	   ENDIF
C	
	   IF (CHANS(LOOP).EQ.QOVCH) GOTO 1000
C	
C  now handle the LUT part
C	
	   IF (LUTF(LOOP).LT.0) THEN			!leave bypass flag as it is
	      WORK = CHANS(LOOP)
	      CLEAR = "160				!clear only channel
	   ELSE
	      CLEAR = "140				!clear bypass bit + channel
	      IF (LUTF(LOOP).NE.0) THEN
	         BY = 0
	      ELSE
	         BY = "20
	      ENDIF
	      WORK = IOR(BY,CHANS(LOOP))		!update bypass flag
	   ENDIF
C	
C  for image channels we only have to work in non-split, non-RGB mode ...
	   CALL IP8QW(RVR,UNIT,DZIOSB,,,FCR,16,0,8)	!get current FCRs
C	
	   IF (QRGBFL.EQ.1) GOTO 1000
	   IF (SPLITMODE.EQ.0) THEN
C	
C  update FCR for screen segment 3 only (that's the one we see)
	      FCRIGHT = IAND(FCR(4),CLEAR)	!get right byte + keep only LUT section
	      FCRIGHT = IOR(FCRIGHT,WORK)	!include new bypass bit + channel
	      FCLEFT = ISHFT(FCR(4),-8)		!get left byte of FCR3
	      FCLEFT = IAND(FCLEFT,CLEAR)	!only keep LUT section
	      FCLEFT = IOR(FCLEFT,WORK)		!include new bypass bit + channel
C	
	      FCR(4) = ISHFT(FCLEFT,8)		!put the pieces back together
	      FCR(4) = IOR(FCR(4),FCRIGHT)
C	
	      FCRIGHT = IAND(FCR(8),CLEAR)	!get right byte + keep only LUT section
	      FCRIGHT = IOR(FCRIGHT,WORK)	!include new bypass bit + channel
	      FCR(8) = IAND(FCR(8),"177400)	!clear right byte completely
	      FCR(8) = IOR(FCR(8),FCRIGHT)	!and add in new right side
	   ELSE
C	
C  in split mode we only update the bypass flag
	      DO N=1,8
		 FCLEFT = ISHFT(FCR(N),-8)		!get left byte
		 FCRIGHT = IAND(FCR(N),"377)		!get right byte
		 IF (IAND(FCLEFT,"17).EQ.CHANS(LOOP)) THEN
		    FCLEFT = IAND(FCLEFT,"357)	!get rid of old BY bit
		    FCLEFT = IOR(FCLEFT,BY)		!insert new one
		 ENDIF
		 IF (IAND(FCRIGHT,"17).EQ.CHANS(LOOP)) THEN
		    FCRIGHT = IAND(FCRIGHT,"357)	!get rid of old BY bit
		    FCRIGHT = IOR(FCRIGHT,BY)	!insert new one
		 ENDIF
C	
		 FCR(N) = ISHFT(FCLEFT,8)		!put the bytes together
		 FCR(N) = IOR(FCR(N),FCRIGHT)
	      ENDDO
	   ENDIF
C	
C  send the FCRs back to the DeAnza
	   CALL IP8QW(LVR,UNIT,DZIOSB,,,FCR,16,0,8)
C	
1000	CONTINUE
C 
	IDST = 0
	RETURN
	END

	SUBROUTINE GD8050(DISPLAY,LUNO,IDST)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine IIDIAG		version 1.00	880202
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  DeAnza, system status
C
C.PURPOSE
C  display the different DeAnza registers
C
C.ALGORITHM
C  use IP8LIB routines to read the registers
C
C.INPUT/OUTPUT
C	
C--------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4 	DISPLAY,LUNO,IDST
	INTEGER*4	CURSOR,HI,LO
	INTEGER*4	I,IAV,M,N,N1
C
	INTEGER*2	REG(14),XREG(8),YREG(8)
	INTEGER*2	PSR
	INTEGER*2	JOYREG(3)
	INTEGER*2	BITTS(16)
	INTEGER*2	XREAL,YREAL
	INTEGER*2	UNIT
	INTEGER*2	RR,RMR,RVR,RCR,RPR
C	
	CHARACTER	DAZREG(14)*5
	CHARACTER*2	SS(8)
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
C	
	EXTERNAL	RR,RMR,RVR,RCR,RPR
C
	DATA	DAZREG	/'CMD','ISR',' ','PSR','RSR','DW',' ',
     +                   'DATA','IR','COUNT','CNTRL','RES','FG','BG'/
	DATA	SS	/'00','01','10','11','00','01','10','11'/
C	
	UNIT = DISPLAY
C
C  read interesting system registers
	CALL IP8QW(RR,UNIT,DZIOSB,,,REG,2,0,0)		!crashes the VAX...
 	CALL IP8QW(RR,UNIT,DZIOSB,,,REG(2),2,0,1)		!crashes the VAX...
 	CALL IP8QW(RR,UNIT,DZIOSB,,,REG(4),2,0,3)		!PSR
 	CALL IP8QW(RR,UNIT,DZIOSB,,,REG(5),2,0,4)		!RSR
 	CALL IP8QW(RR,UNIT,DZIOSB,,,REG(6),2,0,5)		!DW
CC 	CALL IP8QW(RR,UNIT,DZIOSB,,,REG(8),2,0,7)		!gives driver fault
CC 	CALL IP8QW(RR,UNIT,DZIOSB,,,REG(9),2,0,8)		!gives driver fault
 	CALL IP8QW(RR,UNIT,DZIOSB,,,REG(10),2,0,9)	!COUNT
	CALL IP8QW(RR,UNIT,DZIOSB,,,REG(11),8,1,10)	!CONTRL - BG
C
C  read X, Y registers
	CALL IP8QW(RR,UNIT,DZIOSB,,,XREG,16,1,16)
	CALL IP8QW(RR,UNIT,DZIOSB,,,YREG,16,1,24)
	XREG(5) = IAND("3777,XREG(5))
	XREG(6) = IAND("3777,XREG(6))
	YREG(5) = IAND("3777,YREG(5))
	YREG(6) = IAND("3777,YREG(6))
C
C  read Peripheral Select reg.
	CALL IP8QW(RMR,UNIT,DZIOSB,,,PSR,2,0,0)
	CURSOR = IAND("3,ISHFT(PSR,-8))
C
C  read VOC registers
	CALL IP8QW(RVR,UNIT,DZIOSB,,,VOCREG,8,0,0)
	CALL IP8QW(RVR,UNIT,DZIOSB,,,FCR,16,0,8)
C
C  read cursor registers
	CALL IP8QW(RCR,UNIT,DZIOSB,,,CURREG,14,CURSOR,0)
C
C  read joystick registers
	CALL IP8QW(RPR,UNIT,DZIOSB,,,JOYREG,6,CURSOR,1)
C
C  now let's massage the info we got...
C
C  display system interface registers 9 - 13
	WRITE(LUNO,10001)
C
C  display all interesting system registers
	N = 0				!CMD
	N1 = 1
	CALL BITS(REG(N1),BITTS)
	WRITE(LUNO,10100) N,DAZREG(N1),REG(N1)
	WRITE(LUNO,10020) (BITTS(I),I=16,1,-1)
C
	N = 1				!ISR
	N1 = 2
	CALL BITS(REG(N1),BITTS)
	WRITE(LUNO,10101) N,DAZREG(N1),REG(N1)
	WRITE(LUNO,10020) (BITTS(I),I=16,1,-1)
C
	N = 3				!PSR
	N1 = 4
	CALL BITS(REG(N1),BITTS)
	WRITE(LUNO,10103) N,DAZREG(N1),REG(N1)
	WRITE(LUNO,10020) (BITTS(I),I=16,1,-1)
C
	N = 4				!RSR
	N1 = 5
	CALL BITS(REG(N1),BITTS)
	WRITE(LUNO,10104) N,DAZREG(N1),REG(N1)
	WRITE(LUNO,10020) (BITTS(I),I=16,1,-1)
C
	N = 5				!DW
	N1 = 6
	WRITE(LUNO,10105) N,DAZREG(N1),REG(N1)
	LO = IAND(REG(N1),"377)
	HI = ISHFT(IAND(REG(N1),"177400),-8)
	WRITE(LUNO,10200) HI,LO
C
	N = 9				!COUNT
	N1 = 10
	WRITE(LUNO,10109) N,DAZREG(N1),REG(N1)
	WRITE(LUNO,10201) REG(N1)
C
	N = 10				!CONTRL
	N1 = 11
	CALL BITS(REG(N1),BITTS)
	WRITE(LUNO,10110) N,DAZREG(N1),REG(N1)
	WRITE(LUNO,10020) (BITTS(I),I=16,1,-1)
C
	N = 11				!RES
	N1 = 12
	CALL BITS(REG(N1),BITTS)
	WRITE(LUNO,10111) N,DAZREG(N1),REG(N1)
	WRITE(LUNO,10020) (BITTS(I),I=16,1,-1)
C
	N = 12				!FG
	N1 = 13
	WRITE(LUNO,10112) N,DAZREG(N1),REG(N1)
	WRITE(LUNO,10201) REG(N1)
C
	N = 13				!BG
	N1 = 14
	WRITE(LUNO,10113) N,DAZREG(N1),REG(N1)
	WRITE(LUNO,10201) REG(N1)
C
C  display X, Y reg.
	XREAL = XREG(1) + XREG(2)
	YREAL = YREG(1) + YREG(2)
	WRITE(LUNO,10002) XREG(1),YREG(1),XREG(2),YREG(2),
     +                  XREAL,YREAL,(XREG(I),YREG(I),I=3,8)
C
C  display PSR
	CALL BITS(PSR,BITTS)
	WRITE(LUNO,10003) PSR,(BITTS(I),I=16,1,-1)
C
C  display cursor reg.
	CALL BITS(CURREG(5),BITTS)
	WRITE(LUNO,10004) (CURREG(I),I=1,5),(BITTS(N),N=16,1,-1),
     +                  (CURREG(I),I=6,7)
C
C  display joystick reg.
	CALL BITS(JOYREG(1),BITTS)
	XREAL = IAND("377,ISHFT(JOYREG(3),-8))
	YREAL = IAND(JOYREG(3),"377)
	WRITE(LUNO,10005) JOYREG(1),(BITTS(N),N=16,1,-1),
     +                  JOYREG(2),JOYREG(3),XREAL,YREAL
C
C  display VOC registers
	VOCREG(1) = IAND("777,VOCREG(1))
	VOCREG(2) = IAND("777,VOCREG(2))
	CALL BITS(VOCREG(3),BITTS)
	WRITE(LUNO,10006) (VOCREG(I),I=1,3),(BITTS(I),I=16,1,-1),
     +                  VOCREG(4)
	WRITE(LUNO,10007)
	DO N=8,1,-1
	   CALL BITS(FCR(N),BITTS)
	   M = N - 1
	   WRITE(LUNO,10008) M,(BITTS(I),I=16,1,-1),SS(N)
	ENDDO
C
C  job done
	IDST = 0
	RETURN
C
C  FORMATS
10001	FORMAT('0system interface registers:')
10002	FORMAT('0X, Y registers  (dec.):'/
     +         ' X     = ',I6,T40,'Y     = ',I6/
     +         ' XT    = ',I6,T40,'YT    = ',I6/
     +         ' XREAL = ',I6,'*'T40,'YREAL = ',I6,'*'/
     +         ' XMIN  = ',I6,T40,'YMIN  = ',I6/
     +         ' XMAX  = ',I6,T40,'YMAX  = ',I6/
     +         ' XAMIN = ',I6,T40,'YAMIN = ',I6/
     +         ' XAMAX = ',I6,T40,'YAMAX = ',I6/
     +         ' DX    = ',I6,T40,'DY    = ',I6/
     +         ' XTEMP = ',I6,T40,'YTEMP = ',I6)
10003	FORMAT('0Peripheral Select : ',O6,' (oct) or',T40,'C3 C2 C1 ',
     +         'C0  A3 A2 A1 A0'/
     +         T40,2I1,1X,2I1,1X,2I1,1X,2I1,2X,2I1,1X,2I1,1X,2I1,1X,2I1)
10004	FORMAT('0Cursor registers :'/
     +         ' X, Y - coord. of cursor 1 = ',2I4,'  (dec)'/
     +         ' X, Y - coord. of cursor 2 = ',2I4,'  (dec)'/
     +         ' cursor control reg. = ',O6,' or',
     +         T40,'P2 P1 PE PB I2 B2 Y2 X2 I1 B1 Y1 X1 F3-F0'/
     +         T40,I2,11I3,2X,4I1/
     +         ' LUT address reg. = ',O6,' (oct)'/
     +         ' cursor rate reg. = ',O6,' (oct)')
10005	FORMAT('0joystick registers 1 - 3:'/
     +         ' control reg. = ',O6,' (oct) or',
     +         T40,'RES. T E M C2 C1 J7 - J2 IE CL'/
     +         T40,3I1,1X,3I2,2I3,2X,6I1,2I3/
     +         ' A/B optional input  = ',O6,' (oct)'/
     +         ' X/Y displacement = ',O6,' (oct) or',
     +         T40,'    Y       X'/
     +         T40,I6,2X,I6)
10006	FORMAT(' VOC registers:'/
     +         ' X split reg. = ',O6,' (oct)'/
     +         ' Y split reg. = ',O6,' (oct)'/
     +         ' control reg. = ',O6,' (oct) or',
     +         T40,'* CE AR M1 M0 AE GB GE *** P1 P0 SS SY SX'/
     +         T40,I1,7I3,1X,3I1,5I3/
     +         ' LUT address reg. = ',O6,' (oct)')
10007	FORMAT('0FCR registers:'//
     +         '        * S6+5 BY B3-B0  * S6+5 BY B3-B0  segment')
10008	FORMAT(' FCR',I2,2X,I1,3X,2I1,I3,2X,4I1,I3,3X,2I1,
     +         I3,2X,4I1,'  -> ',A)
10020	FORMAT(T32,I2,15I3)
10100	FORMAT(' reg.',I2,1X,A,' = ',O6,' (oct)'
     +  ,T32,'SR CR DW CW SC IE S2 MF CD VB AD P1 P0  D  I MS')
10101	FORMAT('0reg.',I2,1X,A,' = ',O6,' (oct)'
     +  ,t32,'I1 IQ IC IA IS S2 S2 MF CD VB AD P1 P0  D  I MS')
10103   FORMAT('0reg.',I2,1X,A,' = ',O6,' (oct)'
     +	,T32,'A2 A1 A0  *  *  *  *  * U7 U6 U5 U4 U3 U2 U1 U0')
10104   FORMAT('0reg.',I2,1X,A,' = ',O6,' (oct)'
     +	,T32,' *  *  *  *  *  *  * HS CD VB AP RR WR ID EF MS')
10105   FORMAT('0reg.',I2,1X,A,' = ',O6,' (oct)'
     +	,T32,'UPPER BOUND   LOWER BOUND')
10109   FORMAT('0reg.',I2,1X,A,' = ',O6,' (oct)'
     +	,T32,'UNSIGNED 16 BIT INTEGER')
10110   FORMAT('0reg.',I2,1X,A,' = ',O6,' (oct)'
     +	,T32,' *  *  *  *      CSC    PB AG MG SW ME PS SI PI')
10111   FORMAT('0reg.',I2,1X,A,' = ',O6,' (oct)'
     +	,T32,' *  *  *  *  *  *  *  * MR SG 1K MS Y1 Y0 X1 X0')
10112   FORMAT('0reg.',I2,1X,A,' = ',O6,' (oct)'
     +	,T32,' *  *  *  *  *  *  *  * FOREGROUND DATA VALUE')
10113   FORMAT('0reg.',I2,1X,A,' = ',O6,' (oct)'
     +	,T32,' *  *  *  *  *  *  *  * BACKGROUND DATA VALUE')
10200	FORMAT(T32,I5,I6)
10201	FORMAT(T32,I8)
	END

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C
C.IDENTIFICATION        TDCOPY.FOR
C.KEYWORDS           TABLE, APPLICATIONS
C.ENVIRONMENT  MIDAS
C.PURPOSE
C  UTILITIES USED INTERNALLY IN THE PACKAGE TO COPY SCALARS, VECTORS AND
C  COLUMNS
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  19:37 - 11 DEC 1987
C
C 100923	last modif
C 
C------------------------------------------------------------------
C
      SUBROUTINE TDCPVV(INPUT,OUTPUT,N)
C
C COPY INPUT(N) INTO OUTPUT(N)
C INTERNAL ROUTINE TO BE USED IN THE MAPPING CONTEXT
      IMPLICIT NONE
C
      INTEGER  N
      REAL     INPUT(N)
      REAL     OUTPUT(N)
      INTEGER  I
C
C
      DO 10 I = 1,N
          OUTPUT(I) = INPUT(I)
   10 CONTINUE
      RETURN

      END

      SUBROUTINE TDCPSV(INPUT,OUTPUT,N,I)
C
C COPY THE SINGLE PRECISION VALUE INPUT(I) INTO THE ARRAY OUTPUT(N)
C INTERNAL ROUTINE TO BE USED IN THE MAPPING CONTEXT
C
C      IMPLICIT NONE
      INTEGER I,J,N
      REAL INPUT(I),OUTPUT(N)

      DO 10 J = 1,N
          OUTPUT(J) = INPUT(I)
   10 CONTINUE
      RETURN

      END

      SUBROUTINE TDCPDV(INPUT,OUTPUT,N,I)
C
C COPY THE DOUBLE PRECISION VALUE INPUT(I) INTO THE ARRAY OUTPUT(N)
C INTERNAL ROUTINE TO BE USED IN THE MAPPING CONTEXT
C
C      IMPLICIT NONE
      INTEGER I,J,N
      DOUBLE PRECISION INPUT(I),OUTPUT(N)

      DO 10 J = 1,N
          OUTPUT(J) = INPUT(I)
   10 CONTINUE
      RETURN

      END

      SUBROUTINE TDCPSS(INPUT,OUTPUT,I,J)
C
C COPY INPUT(I) INTO OUTPUT(J)
C INTERNAL ROUTINE TO BE USED IN THE MAPPING CONTEXT
C
C      IMPLICIT NONE

      INTEGER I,J
      REAL INPUT(I),OUTPUT(J)

      OUTPUT(J) = INPUT(I)
      RETURN

      END

      SUBROUTINE TDCPDD(INPUT,OUTPUT,I,J)
C
C COPY INPUT(I) INTO OUTPUT(J)
C      IMPLICIT NONE
C INTERNAL ROUTINE TO BE USED IN THE MAPPING CONTEXT
C

      INTEGER I,J
      DOUBLE PRECISION INPUT(I),OUTPUT(J)

      OUTPUT(J) = INPUT(I)
      RETURN

      END

      SUBROUTINE TDCCRR(MASK,INPUT,OUTPUT,N)
C
C  COPY REAL ARRAY ACCORDING TO MASK.
C      IMPLICIT NONE
C SKIP OVER NON SELECTED VALUES
C
      INTEGER I,N
      REAL MASK(N),INPUT(N),OUTPUT(N)
C
      REAL TBLSEL
      DOUBLE PRECISION TDTRUE, TDFALS
C
C ... GET SELECTION VALUE
C
      CALL TBMCON(TBLSEL, TDTRUE, TDFALS)
C
C ... ITERATION
C
      DO 10 I = 1,N
          IF (MASK(I).EQ.TBLSEL) OUTPUT(I) = INPUT(I)
   10 CONTINUE
      RETURN

      END

      SUBROUTINE TDCCR1(MASK,INPUT,OUTPUT,N,NT)
C
C  COPY REAL ARRAY ACCORDING TO MASK.
C DO NOT SKIP OVER NON SELECTED VALUES
C
C      IMPLICIT NONE
      INTEGER I,N,NT,NNT
      REAL MASK(N),INPUT(N),OUTPUT(N)
C
      REAL TBLSEL
      DOUBLE PRECISION TDTRUE, TDFALS
C
C ... GET SELECTION VALUE
C
      CALL TBMCON(TBLSEL, TDTRUE, TDFALS)
C
C ... ITERATION
C
      NNT    = 0
      DO 10 I = 1,N
          IF (MASK(I).EQ.TBLSEL) THEN
              NNT    = NNT + 1
              OUTPUT(NNT) = INPUT(I)
          END IF

   10 CONTINUE
      NT     = NNT
      RETURN

      END

      SUBROUTINE TDCCR2(MASK,INPUT,OUTPUT,N,NT)
C
C  COPY REAL ARRAY ACCORDING TO MASK.
C DO NOT SKIP OVER NON SELECTED VALUES
C       DO NOT COPY THE NULL VALUES
C
C      IMPLICIT NONE
      INTEGER I,N,NT,NNT
      REAL MASK(N),INPUT(N),OUTPUT(N)
C
      INTEGER TINULL
      REAL    TBLSEL, TRNULL
      DOUBLE PRECISION TDTRUE, TDFALS, TDNULL
C
C ... GET MACHINE DEPENDENT VALUES
C
      CALL TBMCON(TBLSEL, TDTRUE, TDFALS)
      CALL TBMNUL(TINULL, TRNULL, TDNULL)
C
C ... ITERATION
C
      NNT    = 0
      DO 10 I = 1,N
          IF (MASK(I).EQ.TBLSEL .AND. INPUT(I).NE.TRNULL) THEN
              NNT    = NNT + 1
              OUTPUT(NNT) = INPUT(I)
          END IF

   10 CONTINUE
      NT     = NNT
      RETURN

      END

      SUBROUTINE TDCCDD(MASK,INPUT,OUTPUT,N)
C
C  COPY DOUBLE PRECISION ARRAY ACCORDING TO MASK.
C SKIP OVER NON SELECTED VALUES
C
C      IMPLICIT NONE
      INTEGER I,N
      REAL MASK(N)
      DOUBLE PRECISION INPUT(N),OUTPUT(N)
C
      REAL    TBLSEL
      DOUBLE PRECISION TDTRUE, TDFALS
C
C ... GET MACHINE DEPENDENT VALUES
C
      CALL TBMCON(TBLSEL, TDTRUE, TDFALS)
C
C ... ITERATION
C
      DO 10 I = 1,N
          IF (MASK(I).EQ.TBLSEL) OUTPUT(I) = INPUT(I)
   10 CONTINUE
      RETURN

      END

      SUBROUTINE TDCCD1(MASK,INPUT,OUTPUT,N,NT)
C
C  COPY REAL ARRAY ACCORDING TO MASK.
C DO NOT SKIP OVER NON SELECTED VALUES
C
C      IMPLICIT NONE
      INTEGER I,N,NT,NNT
      REAL MASK(N)
      DOUBLE PRECISION INPUT(N),OUTPUT(N)
C
      REAL    TBLSEL
      DOUBLE PRECISION TDTRUE, TDFALS
C
C ... GET MACHINE DEPENDENT VALUES
C
      CALL TBMCON(TBLSEL, TDTRUE, TDFALS)
C
C ... ITERATION
C
      NNT    = 0
      DO 10 I = 1,N
          IF (MASK(I).EQ.TBLSEL) THEN
              NNT    = NNT + 1
              OUTPUT(NNT) = INPUT(I)
          END IF

   10 CONTINUE
      NT     = NNT
      RETURN

      END

      SUBROUTINE TDCCD2(MASK,INPUT,OUTPUT,N,NT)
C
C  COPY REAL ARRAY ACCORDING TO MASK.
C DO NOT SKIP OVER NON SELECTED VALUES
C       DO NOT COPY NULL VALUES
C
C      IMPLICIT NONE
      INTEGER I,N,NT,NNT
      REAL MASK(N)
      DOUBLE PRECISION INPUT(N),OUTPUT(N)
C
      INTEGER TINULL
      REAL    TBLSEL, TRNULL
      DOUBLE PRECISION TDTRUE, TDFALS, TDNULL
C
C ... GET MACHINE DEPENDENT VALUES
C
      CALL TBMCON(TBLSEL, TDTRUE, TDFALS)
      CALL TBMNUL(TINULL, TRNULL, TDNULL)
C
C ... ITERATION
C
      NNT    = 0
      DO 10 I = 1,N
          IF (MASK(I).EQ.TBLSEL .AND. INPUT(I).NE.TDNULL) THEN
              NNT    = NNT + 1
              OUTPUT(NNT) = INPUT(I)
          END IF

   10 CONTINUE
      NT     = NNT
      RETURN

      END

      SUBROUTINE TDCCWW(MASK,INPUT,OUTPUT,N,NW)
C
C  COPY BYTE ARRAY ACCORDING TO MASK.
C SKIP OVER NON SELECTED VALUES
C
C      IMPLICIT NONE
      INTEGER I,J,N,NW
      REAL MASK(N)
      REAL INPUT(NW,N),OUTPUT(NW,N)
C
      REAL    TBLSEL
      DOUBLE PRECISION TDTRUE, TDFALS
C
C ... GET MACHINE DEPENDENT VALUES
C
      CALL TBMCON(TBLSEL, TDTRUE, TDFALS)
C
C ... ITERATION
C
      DO 20 I = 1,N
          IF (MASK(I).EQ.TBLSEL) THEN
              DO 10 J = 1,NW
                  OUTPUT(J,I) = INPUT(J,I)
   10         CONTINUE
          END IF

   20 CONTINUE
      RETURN

      END

      SUBROUTINE TDCCW1(MASK,INPUT,OUTPUT,N,NW,NT)
C
C  COPY ARRAY ACCORDING TO MASK.
C DO NOT SKIP OVER NON SELECTED VALUES
C
      INTEGER I,J,N,NW,NT,NNT
      REAL MASK(N)
      REAL INPUT(NW,N),OUTPUT(NW,N)
C
      REAL    TBLSEL
      DOUBLE PRECISION TDTRUE, TDFALS
C
C ... GET MACHINE DEPENDENT VALUES
C
      CALL TBMCON(TBLSEL, TDTRUE, TDFALS)
C
C ... ITERATION
C
      NNT    = 0
      DO 20 I = 1,N
          IF (MASK(I).EQ.TBLSEL) THEN
              NNT    = NNT + 1
              DO 10 J = 1,NW
                  OUTPUT(J,NNT) = INPUT(J,I)
   10         CONTINUE
          END IF

   20 CONTINUE
      NT     = NNT
      RETURN

      END

      SUBROUTINE TDCCSS(MASK,INPUT,OUTPUT,N,ISI,NB,ISO,NBI,NBO)
C
C  COPY BYTE SUBSTRINGS ACCORDING TO MASK.
C SKIP OVER NON SELECTED VALUES
C
C      IMPLICIT NONE
C
      INTEGER I,J,J1,ISI,NB,NBI,NBO,ISO,IEND,N
      REAL MASK(N)
      INTEGER INPUT(NBI,N),OUTPUT(NBO,N)
C
      REAL    TBLSEL
      DOUBLE PRECISION TDTRUE, TDFALS
C
C ... GET MACHINE DEPENDENT VALUES
C
      CALL TBMCON(TBLSEL, TDTRUE, TDFALS)
C
C ... ITERATION
C
      IEND   = ISI + NB - 1
C
      DO 20 I = 1,N
          IF (MASK(I).EQ.TBLSEL) THEN
              J1     = ISO
              DO 10 J = ISI,IEND
                  OUTPUT(J1,I) = INPUT(J,I)
                  J1     = J1 + 1
   10         CONTINUE
          END IF

   20 CONTINUE
      RETURN

      END

      SUBROUTINE TDCCS1(MASK,INPUT,OUTPUT,N,ISI,NB,ISO,NBI,NBO,NT)
C
C  COPY BYTE SUBSTRINGS ACCORDING TO MASK.
C DO NOT SKIP OVER NON SELECTED VALUES
C
C      IMPLICIT NONE
C
      INTEGER I,J,N,J1,NB,ISI,ISO,NBI,NBO,NT,NNT,IEND
      REAL MASK(N)
      INTEGER INPUT(NBI,N),OUTPUT(NBO,N)
C
      REAL    TBLSEL
      DOUBLE PRECISION TDTRUE, TDFALS
C
C ... GET MACHINE DEPENDENT VALUES
C
      CALL TBMCON(TBLSEL, TDTRUE, TDFALS)
C
C ... ITERATION
C
      IEND   = ISI + NB - 1
      NNT    = 0
C
      DO 20 I = 1,N
          IF (MASK(I).EQ.TBLSEL) THEN
              NNT    = NNT + 1
              J1     = ISO
              DO 10 J = ISI,IEND
                  OUTPUT(J1,NNT) = INPUT(J,I)
                  J1     = J1 + 1
   10         CONTINUE
          END IF

   20 CONTINUE
      NT     = NNT
      RETURN

      END

      SUBROUTINE TDCRRR(MASK,IDENT1,IDENT2,IREF,ISORT,NBYTES,INPUT,NBI,
     +                  ISI,OUTPUT,NBO,ISO,NIN,NOUT)
C
C      IMPLICIT NONE
C COPY BY REFERENCE VALUES
C REFERENCE COLUMN IN SINGLE PRECISION
C
      INTEGER IREF,ISORT,NBYTES,NBI,ISI,ISO,NBO,NIN,NOUT,N
      INTEGER NB,I,N1,I1,NN1,NEXT
      REAL MASK(NIN),INPUT(1),OUTPUT(1)
      REAL IDENT1(NIN),IDENT2(NOUT),ZERO,VALUE
C
      INTEGER TINULL
      REAL    TBLSEL, TRNULL
      DOUBLE PRECISION TDTRUE, TDFALS, TDNULL
C
C ... GET MACHINE DEPENDENT VALUES
C
      CALL TBMCON(TBLSEL, TDTRUE, TDFALS)
      CALL TBMNUL(TINULL, TRNULL, TDNULL)
C
      ZERO   = 0.
      N      = MAX(NIN,NOUT)
      NB     = NBYTES
C
C ... JUMP ACCORDING TO OUTPUT FORMAT
C
C     IF(NBYTES+4)10,80,150

      I = NBYTES+4
      IF (I .LT. 0) THEN
         GOTO 10
      ELSE IF (I .EQ. 0) THEN
         GOTO 80
      ELSE 
         GOTO 150
      ENDIF
C
C ... DOUBLE PRECISION
C
   10 CONTINUE
      IF (IREF.EQ.IABS(ISORT)) THEN
          IF (ISORT.GT.0) THEN
              DO 30 I = 1,NIN
                  VALUE  = IDENT1(I)
                  IF (MASK(I).EQ.TBLSEL .AND. VALUE.NE.TRNULL) THEN
                      CALL TZSBAR(IDENT2,NOUT,VALUE,ZERO,1,NEXT)
                      IF (NEXT.GT.0) THEN
   20                     N1     = 2*NEXT - 1
                          I1     = 2*I - 1
                          OUTPUT(N1) = INPUT(I1)
                          N1     = N1 + 1
                          I1     = I1 + 1
                          OUTPUT(N1) = INPUT(I1)
C
C ... CASE OF EQUAL OUTPUT REFERENCES
C
                          IF (NEXT.LT.NOUT) THEN
                              NEXT   = NEXT + 1
                              IF (IDENT2(NEXT-1).EQ.
     +                            IDENT2(NEXT)) GO TO 20
                          END IF

                      END IF

                  END IF

   30         CONTINUE

          ELSE
              DO 50 I = 1,NIN
                  VALUE  = IDENT1(I)
                  IF (MASK(I).EQ.TBLSEL .AND. VALUE.NE.TRNULL) THEN
                      CALL TZSBDR(IDENT2,NOUT,VALUE,ZERO,1,NEXT)
                      IF (NEXT.GT.0) THEN
   40                     N1     = 2*NEXT - 1
                          I1     = 2*I - 1
                          OUTPUT(N1) = INPUT(I1)
                          N1     = N1 + 1
                          I1     = I1 + 1
                          OUTPUT(N1) = INPUT(I1)
C
C ... CASE OF EQUAL OUTPUT REFERENCES
C
                          IF (NEXT.LT.NOUT) THEN
                              NEXT   = NEXT + 1
                              IF (IDENT2(NEXT-1).EQ.
     +                            IDENT2(NEXT)) GO TO 40
                          END IF

                      END IF

                  END IF

   50         CONTINUE
          END IF

      ELSE
          DO 70 I = 1,NIN
              VALUE  = IDENT1(I)
              IF (MASK(I).EQ.TBLSEL .AND. VALUE.NE.TRNULL) THEN
                  NN1    = 1
   60             CALL TZSCSR(IDENT2,NOUT,VALUE,ZERO,NN1,NEXT)
                  IF (NEXT.GT.0) THEN
                      N1     = 2*NEXT - 1
                      I1     = 2*I - 1
                      OUTPUT(N1) = INPUT(I1)
                      N1     = N1 + 1
                      I1     = I1 + 1
                      OUTPUT(N1) = INPUT(I1)
                      NN1    = NEXT + 1
                      IF (NN1.LE.NOUT) GO TO 60
                  END IF

              END IF

   70     CONTINUE
      END IF

      RETURN
C
C ... SINGLE PRECISION
C
   80 CONTINUE
      IF (IREF.EQ.IABS(ISORT)) THEN
          IF (ISORT.GT.0) THEN
              DO 100 I = 1,NIN
                  VALUE  = IDENT1(I)
                  IF (MASK(I).EQ.TBLSEL .AND. VALUE.NE.TRNULL) THEN
                      CALL TZSBAR(IDENT2,NOUT,VALUE,ZERO,1,NEXT)
                      IF (NEXT.GT.0) THEN
   90                     OUTPUT(NEXT) = INPUT(I)
C
C ... CASE OF EQUAL OUTPUT REFERENCES
C
                          IF (NEXT.LT.NOUT) THEN
                              NEXT   = NEXT + 1
                              IF (IDENT2(NEXT-1).EQ.
     +                            IDENT2(NEXT)) GO TO 90
                          END IF

                      END IF

                  END IF

  100         CONTINUE

          ELSE
              DO 120 I = 1,NIN
                  VALUE  = IDENT1(I)
                  IF (MASK(I).EQ.TBLSEL .AND. VALUE.NE.TRNULL) THEN
                      CALL TZSBDR(IDENT2,NOUT,VALUE,ZERO,1,NEXT)
                      IF (NEXT.GT.0) THEN
  110                     OUTPUT(NEXT) = INPUT(I)
C
C ... CASE OF EQUAL OUTPUT REFERENCES
C
                          IF (NEXT.LT.NOUT) THEN
                              NEXT   = NEXT + 1
                              IF (IDENT2(NEXT-1).EQ.
     +                            IDENT2(NEXT)) GO TO 110
                          END IF

                      END IF

                  END IF

  120         CONTINUE
          END IF

      ELSE
          DO 140 I = 1,NIN
              VALUE  = IDENT1(I)
              IF (MASK(I).EQ.TBLSEL .AND. VALUE.NE.TRNULL) THEN
                  NN1    = 1
  130             CALL TZSCSR(IDENT2,NOUT,VALUE,ZERO,NN1,NEXT)
                  IF (NEXT.GT.0) THEN
                      OUTPUT(NEXT) = INPUT(I)
                      NN1    = NEXT + 1
                      IF (NN1.LE.NOUT) GO TO 130
                  END IF

              END IF

  140     CONTINUE
      END IF

      RETURN
C
C ... CHARACTER STRING
C
  150 CONTINUE
      IF (IREF.EQ.IABS(ISORT)) THEN
          IF (ISORT.GT.0) THEN
              DO 170 I = 1,NIN
                  VALUE  = IDENT1(I)
                  IF (MASK(I).EQ.TBLSEL .AND. VALUE.NE.TRNULL) THEN
                      CALL TZSBAR(IDENT2,NOUT,VALUE,ZERO,1,NEXT)
                      IF (NEXT.GT.0) THEN
  160                     CALL TDCPBY(INPUT,I,NBI,ISI,OUTPUT,NEXT,NBO,
     +                                ISO,NB,N)
C
C ... CASE OF EQUAL OUTPUT REFERENCES
C
                          IF (NEXT.LT.NOUT) THEN
                              NEXT   = NEXT + 1
                              IF (IDENT2(NEXT-1).EQ.
     +                            IDENT2(NEXT)) GO TO 160
                          END IF

                      END IF

                  END IF

  170         CONTINUE

          ELSE
              DO 190 I = 1,NIN
                  VALUE  = IDENT1(I)
                  IF (MASK(I).EQ.TBLSEL .AND. VALUE.NE.TRNULL) THEN
                      CALL TZSBDR(IDENT2,NOUT,VALUE,ZERO,1,NEXT)
                      IF (NEXT.GT.0) THEN
  180                     CALL TDCPBY(INPUT,I,NBI,ISI,OUTPUT,NEXT,NBO,
     +                                ISO,NB,N)
C
C ... CASE OF EQUAL OUTPUT REFERENCES
C
                          IF (NEXT.LT.NOUT) THEN
                              NEXT   = NEXT + 1
                              IF (IDENT2(NEXT-1).EQ.
     +                            IDENT2(NEXT)) GO TO 180
                          END IF

                      END IF

                  END IF

  190         CONTINUE
          END IF

      ELSE
          DO 210 I = 1,NIN
              VALUE  = IDENT1(I)
              IF (MASK(I).EQ.TBLSEL .AND. VALUE.NE.TRNULL) THEN
                  NN1    = 1
  200             CALL TZSCSR(IDENT2,NOUT,VALUE,ZERO,NN1,NEXT)
                  IF (NEXT.GT.0) THEN
                      CALL TDCPBY(INPUT,I,NBI,ISI,OUTPUT,NEXT,NBO,ISO,
     +                            NB,N)
                      NN1    = NEXT + 1
                      IF (NN1.LE.NOUT) GO TO 200
                  END IF

              END IF

  210     CONTINUE
      END IF

      RETURN

      END

      SUBROUTINE TDCRDD(MASK,IDENT1,IDENT2,IREF,ISORT,NBYTES,INPUT,NBI,
     +                  ISI,OUTPUT,NBO,ISO,NIN,NOUT)
C
C COPY BY REFERENCE VALUES
C REFERENCE COLUMN IN DOUBLE PRECISION
C
C      IMPLICIT NONE
      INTEGER IREF,ISORT,NBYTES,NBI,ISI,ISO,NIN,NOUT,I,I1,N1
      REAL MASK(NIN),INPUT(1),OUTPUT(1)
      DOUBLE PRECISION IDENT1(NIN),IDENT2(NOUT),VALUE,ZERO
C
      INTEGER TINULL,NBO,N,NB,NEXT,NN1
      REAL    TBLSEL, TRNULL
      DOUBLE PRECISION TDTRUE, TDFALS, TDNULL
C
C ... GET MACHINE DEPENDENT VALUES
C
      CALL TBMCON(TBLSEL, TDTRUE, TDFALS)
      CALL TBMNUL(TINULL, TRNULL, TDNULL)
      ZERO   = 0.D0
      N      = MAX(NIN,NOUT)
      NB     = NBYTES
C
C ... JUMP ACCORDING TO OUTPUT FORMAT
C
C     IF (NBYTES+4) 10,80,150

      I = NBYTES + 4
      IF (I .LT. 0) THEN
         GOTO 10
      ELSE IF (I .EQ. 0) THEN
         GOTO 80
      ELSE 
         GOTO 150
      ENDIF
C
C
C ... DOUBLE PRECISION
C
   10 CONTINUE
      IF (IREF.EQ.IABS(ISORT)) THEN
          IF (ISORT.GT.0) THEN
              DO 30 I = 1,NIN
                  VALUE  = IDENT1(I)
                  IF (MASK(I).EQ.TBLSEL .AND. VALUE.NE.TDNULL) THEN
                      CALL TZSBAD(IDENT2,NOUT,VALUE,ZERO,1,NEXT)
                      IF (NEXT.GT.0) THEN
   20                     N1     = 2*NEXT - 1
                          I1     = 2*I - 1
                          OUTPUT(N1) = INPUT(I1)
                          N1     = N1 + 1
                          I1     = I1 + 1
                          OUTPUT(N1) = INPUT(I1)
C
C ... CASE OF EQUAL OUTPUT REFERENCES
C
                          IF (NEXT.LT.NOUT) THEN
                              NEXT   = NEXT + 1
                              IF (IDENT2(NEXT-1).EQ.
     +                            IDENT2(NEXT)) GO TO 20
                          END IF

                      END IF

                  END IF

   30         CONTINUE

          ELSE
              DO 50 I = 1,NIN
                  VALUE  = IDENT1(I)
                  IF (MASK(I).EQ.TBLSEL .AND. VALUE.NE.TDNULL) THEN
                      CALL TZSBDD(IDENT2,NOUT,VALUE,ZERO,1,NEXT)
                      IF (NEXT.GT.0) THEN
   40                     N1     = 2*NEXT - 1
                          I1     = 2*I - 1
                          OUTPUT(N1) = INPUT(I1)
                          N1     = N1 + 1
                          I1     = I1 + 1
                          OUTPUT(N1) = INPUT(I1)
C
C ... CASE OF EQUAL OUTPUT REFERENCES
C
                          IF (NEXT.LT.NOUT) THEN
                              NEXT   = NEXT + 1
                              IF (IDENT2(NEXT-1).EQ.
     +                            IDENT2(NEXT)) GO TO 40
                          END IF

                      END IF

                  END IF

   50         CONTINUE
          END IF

      ELSE
          DO 70 I = 1,NIN
              VALUE  = IDENT1(I)
              IF (MASK(I).EQ.TBLSEL .AND. VALUE.NE.TDNULL) THEN
                  NN1    = 1
   60             CALL TZSCSD(IDENT2,NOUT,VALUE,ZERO,NN1,NEXT)
                  IF (NEXT.GT.0) THEN
                      N1     = 2*NEXT - 1
                      I1     = 2*I - 1
                      OUTPUT(N1) = INPUT(I1)
                      N1     = N1 + 1
                      I1     = I1 + 1
                      OUTPUT(N1) = INPUT(I1)
                      NN1    = NEXT + 1
                      IF (NN1.LE.NOUT) GO TO 60
                  END IF

              END IF

   70     CONTINUE
      END IF

      RETURN
C
C ... SINGLE PRECISION
C
   80 CONTINUE
      IF (IREF.EQ.IABS(ISORT)) THEN
          IF (ISORT.GT.0) THEN
              DO 100 I = 1,NIN
                  VALUE  = IDENT1(I)
                  IF (MASK(I).EQ.TBLSEL .AND. VALUE.NE.TDNULL) THEN
                      CALL TZSBAD(IDENT2,NOUT,VALUE,ZERO,1,NEXT)
                      IF (NEXT.GT.0) THEN
   90                     OUTPUT(NEXT) = INPUT(I)
C
C ... CASE OF EQUAL OUTPUT REFERENCES
C
                          IF (NEXT.LT.NOUT) THEN
                              NEXT   = NEXT + 1
                              IF (IDENT2(NEXT-1).EQ.
     +                            IDENT2(NEXT)) GO TO 90
                          END IF

                      END IF

                  END IF

  100         CONTINUE

          ELSE
              DO 120 I = 1,NIN
                  VALUE  = IDENT1(I)
                  IF (MASK(I).EQ.TBLSEL .AND. VALUE.NE.TDNULL) THEN
                      CALL TZSBDD(IDENT2,NOUT,VALUE,ZERO,1,NEXT)
                      IF (NEXT.GT.0) THEN
  110                     OUTPUT(NEXT) = INPUT(I)
C
C ... CASE OF EQUAL OUTPUT REFERENCES
C
                          IF (NEXT.LT.NOUT) THEN
                              NEXT   = NEXT + 1
                              IF (IDENT2(NEXT-1).EQ.
     +                            IDENT2(NEXT)) GO TO 110
                          END IF

                      END IF

                  END IF

  120         CONTINUE
          END IF

      ELSE
          DO 140 I = 1,NIN
              VALUE  = IDENT1(I)
              IF (MASK(I).EQ.TBLSEL .AND. VALUE.NE.TDNULL) THEN
                  NN1    = 1
  130             CALL TZSCSD(IDENT2,NOUT,VALUE,ZERO,NN1,NEXT)
                  IF (NEXT.GT.0) THEN
                      OUTPUT(NEXT) = INPUT(I)
                      NN1    = NEXT + 1
                      IF (NN1.LE.NOUT) GO TO 130
                  END IF

              END IF

  140     CONTINUE
      END IF

      RETURN
C
C ... CHARACTER STRING
C
  150 CONTINUE
      IF (IREF.EQ.IABS(ISORT)) THEN
          IF (ISORT.GT.0) THEN
              DO 170 I = 1,NIN
                  VALUE  = IDENT1(I)
                  IF (MASK(I).EQ.TBLSEL .AND. VALUE.NE.TDNULL) THEN
                      CALL TZSBAD(IDENT2,NOUT,VALUE,ZERO,1,NEXT)
                      IF (NEXT.GT.0) THEN
  160                     CALL TDCPBY(INPUT,I,NBI,ISI,OUTPUT,NEXT,NBO,
     +                                ISO,NB,N)
C
C ... CASE OF EQUAL OUTPUT REFERENCES
C
                          IF (NEXT.LT.NOUT) THEN
                              NEXT   = NEXT + 1
                              IF (IDENT2(NEXT-1).EQ.
     +                            IDENT2(NEXT)) GO TO 160
                          END IF

                      END IF

                  END IF

  170         CONTINUE

          ELSE
              DO 190 I = 1,NIN
                  VALUE  = IDENT1(I)
                  IF (MASK(I).EQ.TBLSEL .AND. VALUE.NE.TDNULL) THEN
                      CALL TZSBDD(IDENT2,NOUT,VALUE,ZERO,1,NEXT)
                      IF (NEXT.GT.0) THEN
  180                     CALL TDCPBY(INPUT,I,NBI,ISI,OUTPUT,NEXT,NBO,
     +                                ISO,NB,N)
C
C ... CASE OF EQUAL OUTPUT REFERENCES
C
                          IF (NEXT.LT.NOUT) THEN
                              NEXT   = NEXT + 1
                              IF (IDENT2(NEXT-1).EQ.
     +                            IDENT2(NEXT)) GO TO 180
                          END IF

                      END IF

                  END IF

  190         CONTINUE
          END IF

      ELSE
          DO 210 I = 1,NIN
              VALUE  = IDENT1(I)
              IF (MASK(I).EQ.TBLSEL .AND. VALUE.NE.TDNULL) THEN
                  NN1    = 1
  200             CALL TZSCSD(IDENT2,NOUT,VALUE,ZERO,NN1,NEXT)
                  IF (NEXT.GT.0) THEN
                      CALL TDCPBY(INPUT,I,NBI,ISI,OUTPUT,NEXT,NBO,ISO,
     +                            NB,N)
                      NN1    = NEXT + 1
                      IF (NN1.LE.NOUT) GO TO 200
                  END IF

              END IF

  210     CONTINUE
      END IF

      RETURN

      END

      SUBROUTINE TDCRSS(MASK,IDENT1,IDENT2,NW,NBR,IREF,ISORT,NBYTES,
     +                  INPUT,NBI,ISI,OUTPUT,NBO,ISO,NIN,NOUT)
C      IMPLICIT NONE
C
C COPY BY REFERENCE VALUES
C REFERENCE COLUMN AS CHARACTER STRING
C
      INTEGER NBR,NW,IREF,ISORT,NBYTES,NBI,NBO,ISI,ISO,NIN
      INTEGER NOUT,I,NEXT,I1,N1,NB,N
      REAL MASK(NIN),INPUT(1),OUTPUT(1)
      INTEGER IDENT1(NW,NIN),IDENT2(NW,NOUT),VALUE
C
      INTEGER TINULL
      REAL    TBLSEL, TRNULL
      DOUBLE PRECISION TDTRUE, TDFALS, TDNULL
C
C ... GET MACHINE DEPENDENT VALUES
C
      CALL TBMCON(TBLSEL, TDTRUE, TDFALS)
      CALL TBMNUL(TINULL, TRNULL, TDNULL)
C
      N      = MAX(NIN,NOUT)
      NB     = NBYTES
C
C ... JUMP ACCORDING TO OUTPUT FORMAT
C
C     IF (NBYTES+4) 10,50,90

      I = NBYTES + 4
      IF (I .LT. 0) THEN
         GOTO 10
      ELSE IF (I .EQ. 0) THEN
         GOTO 50
      ELSE 
         GOTO 90
      ENDIF
C
C
C ... DOUBLE PRECISION
C
   10 CONTINUE
      IF (IREF.EQ.IABS(ISORT)) THEN
          IF (ISORT.GT.0) THEN
              DO 20 I = 1,NIN
                  VALUE  = IDENT1(1,I)
                  IF (MASK(I).EQ.TBLSEL .AND. VALUE.NE.0) THEN
                      CALL TZSBAC(IDENT2,NW,NOUT,IDENT1(1,I),1,NBR,1,
     +                            NEXT)
                      IF (NEXT.GT.0) THEN
                          N1     = 2*NEXT - 1
                          I1     = 2*I - 1
                          OUTPUT(N1) = INPUT(I1)
                          N1     = N1 + 1
                          I1     = I1 + 1
                          OUTPUT(N1) = INPUT(I1)
                      END IF

                  END IF

   20         CONTINUE

          ELSE
              DO 30 I = 1,NIN
                  VALUE  = IDENT1(1,I)
                  IF (MASK(I).EQ.TBLSEL .AND. VALUE.NE.0) THEN
                      CALL TZSBDC(IDENT2,NW,NOUT,IDENT1(1,I),1,NBR,1,
     +                            NEXT)
                      IF (NEXT.GT.0) THEN
                          N1     = 2*NEXT - 1
                          I1     = 2*I - 1
                          OUTPUT(N1) = INPUT(I1)
                          N1     = N1 + 1
                          I1     = I1 + 1
                          OUTPUT(N1) = INPUT(I1)
                      END IF

                  END IF

   30         CONTINUE
          END IF

      ELSE
          DO 40 I = 1,NIN
              VALUE  = IDENT1(1,I)
              IF (MASK(I).EQ.TBLSEL .AND. VALUE.NE.0) THEN
                  CALL TZSCSC(IDENT2,NW,NOUT,IDENT1(1,I),1,NBR,1,NEXT)
                  IF (NEXT.GT.0) THEN
                      N1     = 2*NEXT - 1
                      I1     = 2*I - 1
                      OUTPUT(N1) = INPUT(I1)
                      N1     = N1 + 1
                      I1     = I1 + 1
                      OUTPUT(N1) = INPUT(I1)
                  END IF

              END IF

   40     CONTINUE
      END IF

      RETURN
C
C ... SINGLE PRECISION
C
   50 CONTINUE
      IF (IREF.EQ.IABS(ISORT)) THEN
          IF (ISORT.GT.0) THEN
              DO 60 I = 1,NIN
                  VALUE  = IDENT1(1,I)
                  IF (MASK(I).EQ.TBLSEL .AND. VALUE.NE.0) THEN
                      CALL TZSBAC(IDENT2,NW,NOUT,IDENT1(1,I),1,NBR,1,
     +                            NEXT)
                      IF (NEXT.GT.0) OUTPUT(NEXT) = INPUT(I)
                  END IF

   60         CONTINUE

          ELSE
              DO 70 I = 1,NIN
                  VALUE  = IDENT1(1,I)
                  IF (MASK(I).EQ.TBLSEL .AND. VALUE.NE.0) THEN
                      CALL TZSBDC(IDENT2,NW,NOUT,IDENT1(1,I),1,NBR,1,
     +                            NEXT)
                      IF (NEXT.GT.0) OUTPUT(NEXT) = INPUT(I)
                  END IF

   70         CONTINUE
          END IF

      ELSE
          DO 80 I = 1,NIN
              VALUE  = IDENT1(1,I)
              IF (MASK(I).EQ.TBLSEL .AND. VALUE.NE.0) THEN
                  CALL TZSCSC(IDENT2,NW,NOUT,IDENT1(1,I),1,NBR,1,NEXT)
                  IF (NEXT.GT.0) OUTPUT(NEXT) = INPUT(I)
              END IF

   80     CONTINUE
      END IF

      RETURN
C
C ... CHARACTER STRING
C
   90 CONTINUE
      IF (IREF.EQ.IABS(ISORT)) THEN
          IF (ISORT.GT.0) THEN
              DO 100 I = 1,NIN
                  VALUE  = IDENT1(1,I)
                  IF (MASK(I).EQ.TBLSEL .AND. VALUE.NE.0) THEN
                      CALL TZSBAC(IDENT2,NW,NOUT,IDENT1(1,I),1,NBR,1,
     +                            NEXT)
                      IF (NEXT.GT.0) CALL TDCPBY(INPUT,I,NBI,ISI,OUTPUT,
     +                                    NEXT,NBO,ISO,NB,N)
                  END IF

  100         CONTINUE

          ELSE
              DO 110 I = 1,NIN
                  VALUE  = IDENT1(1,I)
                  IF (MASK(I).EQ.TBLSEL .AND. VALUE.NE.0) THEN
                      CALL TZSBDC(IDENT2,NW,NOUT,IDENT1(1,I),1,NBR,1,
     +                            NEXT)
                      IF (NEXT.GT.0) CALL TDCPBY(INPUT,I,NBI,ISI,OUTPUT,
     +                                    NEXT,NBO,ISO,NB,N)
                  END IF

  110         CONTINUE
          END IF

      ELSE
          DO 120 I = 1,NIN
              VALUE  = IDENT1(1,I)
              IF (MASK(I).EQ.TBLSEL .AND. VALUE.NE.0) THEN
                  CALL TZSCSC(IDENT2,NW,NOUT,IDENT1(1,I),1,NBR,1,NEXT)
                  IF (NEXT.GT.0) CALL TDCPBY(INPUT,I,NBI,ISI,OUTPUT,
     +                                NEXT,NBO,ISO,NB,N)
              END IF

  120     CONTINUE
      END IF

      RETURN

      END

      SUBROUTINE TDCPBY(INPUT,IP,NBI,ISI,OUTPUT,NEXT,NBO,ISO,NB,N)
C
C COPY BYTE STRING
C      IMPLICIT NONE
C
      INTEGER IP,NBI,ISI,NEXT,NBO,ISO,NB,I,N,I1,I2
      INTEGER INPUT(NBI,N),OUTPUT(NBO,N)
C
      DO 10 I = 0,NB - 1
          I1     = I + ISI
          I2     = I + ISO
          OUTPUT(I2,NEXT) = INPUT(I1,IP)
   10 CONTINUE
      RETURN

      END

C @(#)invrs.for	19.1 (ES0-DMD) 02/25/03 13:30:46
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE INVRS(A,N)                                                     
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++              
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C.IDENTIFICATION: INVRS                                                         
C.PURPOSE:        Determines the inverse of the matrix A, of dimension N.       
C                 the inverse is returned in A                                  
C.ALGORITHM:      chinese to me - see clever books                              
C.INPUT/OUTPUT:   <-> A      input/output  matrix                               
C                  -> N      dimension of A                                     
C.AUTHOR:         P.Stetsan                                                     
C.LANGUAGE:       F77+ESOext                                                    
C.KEYWORDS:       mathematics                                                   
C.VERSION:        8212??  A.P. Stetson     Creation                             
C.VERSION:        871123  Rein H. Warmels  ESO-FORTRAN Conversion               
C.VERSION:        H.Waldthausen            VAX-implementation                   
C-----------------------------------------------------------------------        
      IMPLICIT   NONE
      INTEGER    N
      DOUBLE PRECISION A(5,5)                                                   
C
      INTEGER    I
      INTEGER    J
      INTEGER    K
C                                                                               
      I      = 0                                                                
   10 I      = I + 1                                                            
      IF (I.GT.N) GO TO 60                                                      
      A(I,I) = 1.0/A(I,I)                                                       
      J      = 0                                                                
   20 J      = J + 1                                                            
      IF (J.GT.N) GO TO 40                                                      
      IF (J.EQ.I) GO TO 20                                                      
      A(J,I) = -A(J,I)*A(I,I)                                                   
      K      = 0                                                                
   30 K      = K + 1                                                            
      IF (K.GT.N) GO TO 20                                                      
      IF (K.EQ.I) GO TO 30                                                      
      A(J,K) = A(J,K) + A(J,I)*A(I,K)                                           
      GO TO 30                                                                  
                                                                                
   40 K      = 0                                                                
   50 K      = K + 1                                                            
      IF (K.GT.N) GO TO 10                                                      
      IF (K.EQ.I) GO TO 50                                                      
      A(I,K) = A(I,K)*A(I,I)                                                    
      GO TO 50                                                                  
C                                                                               
   60 RETURN                                                                    
      END                                                                       

C @(#)atest.for	19.1 (ES0-DMD) 02/25/03 13:18:59
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE ATEST(NX,NY,IN,HG,HL,OUT,M,OG,UL,OL,
     >                 NSG,NSL,ORD,TYP)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C  compares actual gradient and Laplaces with noise statistics and decides
C  if a pixel is significant on the actual order
C  OG,UL,OL : upper limit for gradients and lower and upper limits for 
C  Laplace-terms respectively; pixel values exceeding these
C  limits make the pixel significant. (in)
C  NSG,NSL  : number of pixels wich became significant at the actual 
C  order by gradient or Laplace respectively. (out)
C
C----------------------------------------------------------------------------
      IMPLICIT NONE
C
      CHARACTER*1 S,TYP
      INTEGER     NX,NY,ORD,NSG,NSL,I
      REAL       IN(1),HG(1),HL(1),OUT(1),OG,UL,OL,HHL,ORDR,M(1)
C
      ORDR=ORD
      S='L'
      NSG=0
      NSL=0
C
      DO 10 I=1,NX*NY
      IF (M(I).NE.0) GOTO 10          ! pixel already significant on lower order
      IF (TYP.NE.'S') GOTO 5
C
C *** test for filter type SMOOTH
      IF (HG(I).GE.OG) GOTO 2                     ! gradient significant
      HHL=HL(I)
      IF ((HHL.GE.OL).OR.(HHL.LE.UL)) GOTO 3      ! Laplace significant
      GOTO 10
C
    2 S = 'G'
    3 IF (S.EQ.'G') NSG=NSG+1
      IF (S.EQ.'L') NSL=NSL+1
      S='L'
      OUT(I)=IN(I)
      GOTO 9
C
    5 IF (TYP.NE.'G') GOTO 7

C *** test for filter type GRADIENT
      HHL=HG(I)
      IF(HHL.LT.OG) GOTO 10                       ! gradient not significant
      OUT(I)=HHL
      NSG=NSG+1
      GOTO 9
C
C *** test for filter type LAPLACE
    7 HHL=HL(I)
      IF ((HHL.LT.OL).AND.(HHL.GT.UL)) GOTO 10    ! Laplace not significant
      OUT(I)=HHL
      NSL=NSL+1
    9 M(I)=ORDR! mark significant pixel
   10 CONTINUE
C
      RETURN
      END

C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine PRFLCL         version 1.3       830915
C  A. Kruszewski             ESO Garching
C  modified                  version 1.4       870303
C  A. Kruszewski             Obs. de Geneve
C  modified for MSDOS        version 2.0       880830
C  A. Kruszewski             Warsaw U. Obs.
C.PURPOSE
C  cleans two-dimensional profile "PRFL" from influence of blended
C  components
C  puts informations about newly found components into array "MCM0"
C.INPUT/OUTPUT
C  input arguments
C  PRFL        real*4 array      two-dimensional profile
C  ICNT        integer*4 array   numbers of pixels used to calculate PRFL
C  AVER        real*4 array      one-dimensional profile
C  LIM         integer*4         radial size of profiles in pixels
C  IDIF        integer*4         distance in pixels to the nearest
C                                catalogued object
C  LOUT        integer*4         output controlling flag
C  RARR        real*4 array      values of real keywords
C  output arguments
C  PRFL        real*4 array      cleaned two-dimensional profile
C  MCM0        integer*4 array   array holding informations about
C                                newly found objects
C  KCLN        integer*4         size in pixels of good non-cleaned
C                                profile
C  KSAT        integer*4         size in pixels of saturated part
C                                of profile
C-----------------------------------------------------------------------
      SUBROUTINE PRFLCL(PRFL, ICNT, AVPR, IAVR, LIM,
     &                  BGRD, IDIF, LDBG, RARR, MCM0,
     &                  KCLN, KSAT)
C
      IMPLICIT  NONE
      INCLUDE  'MID_REL_INCL:INVENT.INC/NOLIST'
C
      REAL      PRFL(8,0:MAXSUB)
      INTEGER   ICNT(8,0:MAXSUB)
      REAL      AVPR(0:MAXSUB)
      INTEGER   IAVR(0:MAXSUB)
      INTEGER   LIM
      REAL      BGRD
      INTEGER   IDIF
      INTEGER   LDBG
      REAL      RARR(64)
      INTEGER   MCM0(21)
      INTEGER   KCLN
      INTEGER   KSAT
C
      INTEGER   ICPY(0:9,0:MAXSUB)
      INTEGER   ISTAT     
      INTEGER   INDX(8,0:MAXSUB)
C     INTEGER   IIND(0:9)
      INTEGER   IOUT(8)
      INTEGER   IB, IR, IC, ID, IK, II
      INTEGER   IDLM
      INTEGER   LDIF
      INTEGER   K, KM, KN, KS, KK, K1
      INTEGER   L, L4
      INTEGER   LIM2
      INTEGER   JJ, JJ1
C
      REAL      CPY(8,0:MAXSUB)
      REAL      CLPR1, CLPR2, CLPR3, CLPR4, CLPR5, CLPR6
      REAL      T1(2)
      REAL      DFPR(MAXSUB)
      REAL      FAMP(3,MAXSUB)
      REAL      TEMP(MAXSUB)
      REAL      COEF(7,MAXSUB)
      REAL      ATRSH, AVER
      REAL      BROBJ, BTRSH
      REAL      PZERO, PMIN, PMAX
      REAL      FMIN1, FMIN2
      REAL      FCTR
      REAL      CORR
      REAL      CTRSH
      REAL      SCALE
      REAL      PR0
      REAL      HCUT
      REAL      TMP
      REAL      SUM
      REAL      TRSH
      REAL      TRLIM
C
      CHARACTER*80 TEXT
      LOGICAL      BLEND,NEW,BRIGHT
      LOGICAL      LOG01,LOG02,LOG03,LOG04,LOG05,LOG06,LOG07
      LOGICAL      LOG08,LOG09,LOG10,LOG11,LOG12,LOG13,LOG14
      LOGICAL      LOG15,LOG16
C
      FCTR = 0
      T1(1) = 0.0
      T1(2) = 0.0
      SCALE = 1000.0 / BGRD
      HCUT = RARR(2)
      TRSH = RARR(3)
      IF (PRFL(1,0) .GT. 0.0) THEN
          TRLIM = TRSH**0.8 * PRFL(1,0)**0.2
      ELSE
          TRLIM = TRSH
      ENDIF
C
      CLPR1 = RARR(49)
      CLPR2 = RARR(50)
      IF (CLPR1 .GT. 0.1) THEN
            CLPR3 = 1.0 / CLPR1
      ELSE
            CLPR3 = 10.0
      ENDIF
C
      IF (CLPR1 .GT. 0.1) THEN
            CLPR4 = 1.0 / CLPR1
      ELSE
            CLPR4 = 10.0
      ENDIF
C
      CLPR6 = RARR(51)
      IF (CLPR6 .LT. 1.0) THEN
            CLPR6 = 1.0
      ENDIF
C
      CLPR5 = 1.0 / CLPR6
      ATRSH = CLPR2 * TRSH
      BTRSH = -ATRSH
      ATRSH = ATRSH
      CTRSH = TRSH / CLPR2
      BROBJ = RARR(47)
      IDLM = INT(RARR(42))
      LDIF = IDIF + IDLM
C
C ******      Mark empty places in the profile.
C
      DO 10 K = 0,MAXSUB
         DO 20 L = 1,8
            IF (ICNT(L,K) .EQ. 0) THEN
               INDX(L,K) = -1
            ELSE
               INDX(L,K) = 0
            ENDIF
   20    CONTINUE
   10 CONTINUE
      KM = 0
      DO 30 K = 1,21
         MCM0(K) = 0
   30 CONTINUE
C
C ******      Find largest saturated ring number KSAT.
C
c      HHCUT = 0.7 * (HCUT-BGRD)
c      K     = -1
C
c   40 CONTINUE
c      K = K + 1
c      IF (IAVR(K) .EQ. 0 .OR. AVPR(K) .GT. HHCUT) GOTO 40
c      KSAT = K - 1
C
C ******      Calculate Fourier amplitudes over octants FAMP.
C
      CALL OCTFRR( PRFL , ICNT , AVPR , LIM , COEF , FAMP )
C
C ******            Outputs average profiles AVPR and
C ******            Fourier amplitudes FAMP into screen.
C
      IF (LDBG .GE. 3) THEN
         WRITE (TEXT,'(A)') 'Average profile and first three'//
     &                      ' Fourier amplitudes'
         CALL STTPUT(TEXT,ISTAT)
         LIM2 = MIN(10,LIM)
         DO 45 K = 1,LIM2
            IOUT(1) = NINT(AVPR(K) * SCALE)
            DO 46 L = 1,3
               IOUT(L+1) = NINT (FAMP(L,K) * SCALE)
   46       CONTINUE
            WRITE(TEXT,'(4I12)') (IOUT(L),L=1,4)
            CALL STTPUT(TEXT,ISTAT)
   45    CONTINUE
      ENDIF
C
C ******      Look for faint component in each octant separately.
C
      KS = MIN(KSAT+2,LIM)
      DO 50 L = 1,8
C
C *** Fix starting values of various quantities.
C
          BLEND = .FALSE.
          BRIGHT = .FALSE.
          IB = 0
          K = KS
          PZERO = MAX(PRFL(L,0),PRFL(L,K-1),PRFL(L,K))
          PMIN = PRFL(L,K+1)
          PMAX = PRFL(L,K+1)
          IF (K .EQ. 1) THEN
              FMIN1 = MIN(FAMP(1,1),FAMP(1,2))
              FMIN2 = MIN(FAMP(2,1),FAMP(2,2))
          ELSE
              FMIN1 = FAMP(1,K)
              FMIN2 = FAMP(2,K)
          ENDIF
          DFPR(K) = CLPR1 * (PRFL(L,K) - AVPR(K))
C
C ***     Start DO WHILE loop.
C
   61     CONTINUE
              IF (K .GE. LIM) GOTO 60
              K = K + 1
              IF (FAMP(1,K) .LT. FMIN1) THEN
                  FMIN1 = FAMP(1,K)
              ENDIF
              IF (FAMP(2,K) .LT. FMIN2) THEN
                  FMIN2 = FAMP(2,K)
              ENDIF
              IF (PRFL(L,K) .GT. PMAX) THEN
                  PMAX = PRFL(L,K)
                  IF (PMIN .LT. PZERO .AND. PMAX .GT. PZERO) THEN
                      BRIGHT = .TRUE.
                  ELSE
                      BRIGHT = .FALSE.
                  ENDIF
              ELSE
                  BRIGHT = .FALSE.
              ENDIF
              IF (PRFL(L,K) .LT. PMIN) THEN
                  PMIN = PRFL(L,K)
              ENDIF
              DFPR(K) = CLPR1 * (PRFL(L,K) - AVPR(K))
C
C ***         Detect inverted profile.
C
              LOG01 = PRFL(L,K).GT.2.0*PMIN
              LOG02 = PRFL(L,K).GT.ATRSH
              LOG03 = DFPR(K).GE.DFPR(K-1)
              LOG04 = DFPR(K).GE.CLPR3*AVPR(K)
              LOG05 = PRFL(L,K) .GE. PRFL(L,K-1)
              LOG06 = DFPR(K).GT.CLPR4*(AVPR(K-1)-AVPR(K))
              LOG07 = PRFL(L,K).GT.ATRSH
              LOG08 = FAMP(1,K).GT.FMIN1
              LOG09 = FAMP(1,K).EQ.FMIN1
              LOG10 = FAMP(1,K).LT.CTRSH
              LOG11 = FAMP(2,K).GT.FMIN2
              LOG12 = CLPR6.GE.5.0
              LOG13 = FAMP(2,K).LT.CTRSH
              LOG14 = MIN(FAMP(1,K),FAMP(2,K)).LT.CTRSH
              LOG15 = FAMP(1,K).GT.CLPR5*FAMP(2,K) 
              LOG16 = FAMP(1,K).LT.CLPR6*FAMP(2,K)

              IF ( (LOG01 .AND. LOG02) .OR. 
     &            (((LOG03 .AND. LOG04) .OR. LOG05) .AND. LOG06 .AND.
     &            LOG07 .AND. ((LOG08 .OR. (LOG09 .AND. LOG10)) .AND.
     &            (LOG11 .OR. LOG12 .OR. LOG13) .AND. 
     &            (LOG14 .OR. (LOG15 .AND. LOG16))))) THEN
C
C ***             Check if an inverted profile
C ***             has not been detected before.
C
                  IF (.NOT.BLEND .AND. IB.EQ.0) THEN
C
C ***                 Component is detected for the first time.
C
                      BLEND=.TRUE.
C
C ****                Marks profile points affected
C ****                by component by means
C ****                of setting INDX(L,K) to 1.
C
                      IF ( PRFL(L,K) .GE. PRFL(L,K-2) ) THEN
                          IF ( K .GT. 2 .AND. INDX(L,K-1) .EQ. 0 ) THEN
                              INDX(L,K-1) = 1
                          ENDIF
                          IB = 3
                      ELSE
                          IB = 2
                      ENDIF
                      IF ( INDX(L,K) .EQ. 0 ) THEN
                          INDX(L,K) = 1
                      ENDIF
                  ELSE
                      IB = IB + 1
                      IF ( INDX(L,K) .EQ. 0 ) THEN
                          INDX(L,K) = 1
                      ENDIF
                  ENDIF
            
              ELSE
                  IF (BLEND) THEN
                      BLEND = .FALSE.
C
C ***                 Looks if found component can be
C ***                 added to the list of objects.
C
                      IF (K .GT. MAX(IDLM,KSAT+2) .AND.
     &                        K .LE. LDIF .AND. K .LT. LIM .AND.
c     &                        PRFL(L,K) .GT. TRLIM .AND.
     &                        INDX(L,K-2) .NE. -1 .AND.
     &                        INDX(L,K-1) .NE. -1 .AND. INDX(L,K)
     &                        .NE. -1 ) THEN
                          NEW = .TRUE.
                          DO 70 KN = 1,KM
                              IF (ABS(MCM0(2*KN)-L) .LT. 1 .AND.
     &                                ABS(MCM0(2*KN+1)-K).LT.3) THEN
                                  NEW = .FALSE.
                              ENDIF
   70                     CONTINUE
                          IF (NEW .AND. KM .LT. 10 .AND. K .GT. 2) THEN
C
C *****                       An information about
C *****                       new object is written
C *****                       into array MCM0.
C
                              KM = KM + 1
                              MCM0(2*KM) = L
                              MCM0(2*KM+1) = K - 1
                          ENDIF
                      ENDIF
                  ENDIF
C
                  IF (IB .GT. 0 .AND. INDX(L,K) .EQ. 0 ) THEN
                      INDX(L,K) = 1
                      IB = IB - 1
                  ENDIF
              ENDIF
              GOTO 61
   60     CONTINUE
   50 CONTINUE
C
      MCM0(1) = KM
      IF (LDBG .GT. 3) THEN
         WRITE(TEXT,'(A,I2,3X,20I3)') ' New objects:  ',MCM0
         CALL STTPUT(TEXT,ISTAT)
      ENDIF
C
C *** Expand a set of points which are affected by
C *** components by including also neighbouring points.
C
      DO 340 K = 0 , LIM
          DO 350 L = 1 , 8
              ICPY(L,K) = INDX(L,K)
  350     CONTINUE
          ICPY(0,K) = 0
          ICPY(9,K) = 0
  340 CONTINUE
      DO 80 K = 1 , LIM
          DO 100 L = 1 , 8
              IF ( INDX(L,K-1) .EQ. 1 ) THEN
                  ICPY(L-1,K) = 1
                  ICPY(L+1,K) = 1
                  IF ( K .GT. 4 ) THEN
                      ICPY(L,K) = 1
                  ENDIF
              ENDIF
              IF ( K .LT. LIM  .AND. K .GT. 4 .AND. INDX(L,K+1)
     &                                                .EQ. 1 ) THEN
                  ICPY(L,K) = 1
              ENDIF
  100     CONTINUE
          IF ( INDX(1,K) .NE. -1 ) THEN
              INDX(1,K) = MAX( ICPY(1,K) , ICPY(9,K) )
          ENDIF
          IF ( INDX(8,K) .NE. -1 ) THEN
              INDX(8,K) = MAX( ICPY(0,K) , ICPY(8,K) )
          ENDIF
   80 CONTINUE
      DO 90 K = 1 , LIM
          DO 110 L = 2 , 7
              IF ( INDX(L,K) .NE. -1 ) THEN
                  INDX(L,K) = ICPY(L,K)
              ENDIF
  110     CONTINUE
   90 CONTINUE
C
C *** Remove low points from a set of affected points.
C
      DO 120 K = 1 , LIM
          DO 130 L = 1 , 8
              TMP = PRFL(L,K)
              IF ( TMP .LT. ATRSH ) THEN
                  IF ( TMP .GT. BTRSH .AND. ICNT(L,K) .GT. 0 ) THEN
                      INDX(L,K) = 0
                  ELSE IF ( TMP .LE. BTRSH ) THEN
                      INDX(L,K) = 1
                  ENDIF
              ENDIF
  130     CONTINUE
  120 CONTINUE
C
C *** Copy the profile into scratch array CPY.
C
      DO 140 L = 0 , LIM
          DO 150 K = 1 , 8
              CPY(K,L) = PRFL(K,L)
  150     CONTINUE
  140 CONTINUE
C
C *** Find extend of non cleaned profile KCLN.
C
      K = 0
      KCLN = 0
      IR = 0
  161 CONTINUE
         IF (IR .NE. 0 .OR. K .GE. LIM) GOTO 160
         KCLN = K 
         K = K + 1
         IR=MAX(INDX(1,K),INDX(2,K),INDX(3,K),INDX(4,K) ,
     &         INDX(5,K),INDX(6,K),INDX(7,K),INDX(8,K))
      GOTO 161
  160 CONTINUE
C
C *** Clean the profile.
C
      DO 170 K = 1,LIM
         IC = 0
         SUM = 0
         DO 180 L = 1,8
            IF (INDX(L,K) .EQ. 0) THEN
               SUM = SUM + PRFL(L,K)
               IC = IC + 1
            ENDIF
  180    CONTINUE
         IF (IC .GT. 0) THEN
            AVER = SUM / IC
         ELSE
            AVER = MIN(PRFL(1,K),PRFL(2,K) ,
     &             PRFL(3,K),PRFL(4,K),PRFL(5,K) ,
     &             PRFL(6,K),PRFL(7,K),PRFL(8,K))
         END IF
         DO 190 L = 1,8
            IF (INDX(L,K) .EQ. 1) THEN
               IF (L .LE. 4) THEN
                  L4 = L + 4
               ELSE
                  L4 = L - 4
               ENDIF
               IF (INDX(L4,K) .EQ. 0) THEN
                  PRFL(L,K) = PRFL(L4,K)
               ELSE 
                  PRFL(L,K) = AVER
               ENDIF
            ENDIF
  190    CONTINUE
  170 CONTINUE
C
C ******      Check if cleaning is done properly.
C
      DO 200 L = 1,8
         DO 210 K = 1,LIM
            TEMP(K) = CPY(L,K) - PRFL(L,K)
  210    CONTINUE
         IC = 0
         ID = 0
         IK = 0
C
C        Finds if there is a bright neighbour in this octant.
C
C        PMAX=MAX(CPY(L,0),CPY(L,1))
C        K=2
C        BRIGHT=.FALSE.
C        DO WHILE (K.LE.LIM.AND.(.NOT.BRIGHT))
C           IF (CPY(L,K).GT.PMAX) THEN
C              BRIGHT=.TRUE.
C           END IF
C           K=K+1
C        END DO
C
         DO 230 K = 1 , LIM
             IF ( TEMP(K) .LT. 0.0 .AND. ICNT(L,K) .GT. 0
     &                            .AND. CPY(L,K) .GT. BTRSH ) THEN
                 PRFL(L,K) = CPY(L,K)
                 INDX(L,K) = 0
                 IC = 0
                 ID = 0
             ELSE IF (TEMP(K).GT.0.0 .AND. IK.EQ.0) THEN
                 IC = IC + 1
                 IF ( IC .GT. 1 .AND. TEMP(K) .GT. TEMP(K-1) ) THEN
                     IF (ID .EQ. 0) THEN
                         ID = 1
                         T1(1)=TEMP(K-1)/TEMP(K)
                     ELSE
                         ID = 0
                         T1(2)=TEMP(K-1)/TEMP(K)
                         IK = K - 3
                         FCTR = SQRT(T1(1)*T1(2))
                         FCTR = MIN(BROBJ,FCTR)
                     ENDIF
                 ELSE
                     ID = 0
                 ENDIF
             ELSE
                 IC = 0
                 ID = 0
             ENDIF
  230    CONTINUE
C
C ****** Correct central part if bright neighbour.
C
         IF (IK .GT. 0) THEN
            CORR = TEMP(IK+1)
            DO 240 K = IK,-1,-1
               CORR = CORR * FCTR
               IF (CORR .GT. 0.3 * TRSH) THEN
                  IF (K .GE. 0) THEN
                     PRFL(L,K)=PRFL(L,K)-CORR
                  ELSE
                     IF (L .LE. 4) THEN
                        L4 = L + 4
                     ELSE
                        L4 = L - 4
                     ENDIF
                     KK = ABS(K)
                     PRFL(L4,KK) = PRFL(L4,KK)-CORR
                  ENDIF
                  IF (K .EQ. 0) THEN
                     IF (L .EQ. 1) THEN
                        PRFL(8,1) = PRFL(8,1)-CORR
                        PRFL(2,1) = PRFL(2,1)-CORR
                     ELSE IF (L.EQ.8) THEN
                        PRFL(7,1) = PRFL(7,1)-CORR
                        PRFL(1,1) = PRFL(1,1)-CORR
                     ELSE
                        PRFL(L-1,1) = PRFL(L-1,1)-CORR
                        PRFL(L+1,1) = PRFL(L+1,1)-CORR
                     ENDIF
                  ENDIF
               ENDIF
  240       CONTINUE
         ENDIF
  200 CONTINUE
C
      PR0 = MIN(PRFL(1,0),PRFL(2,0),PRFL(3,0),PRFL(4,0) ,
     &          PRFL(5,0),PRFL(6,0),PRFL(7,0),PRFL(8,0))
      DO 250 L = 1,8
         PRFL(L,0) = PR0
  250 CONTINUE
C
C ******      Write informations about points affected by components.
C
      IF (LDBG .GE. 3) THEN
         WRITE(TEXT,'(A)') 'Bad points are marked by 1`s'
         CALL STTPUT(TEXT,ISTAT)
         JJ1 = MIN(10,LIM-1)
         DO 260 JJ = 0,JJ1
            WRITE(TEXT,'(8I9)') (INDX(II,JJ),II = 1,8)
            CALL STTPUT(TEXT,ISTAT)
  260    CONTINUE      
      ENDIF
C 
C ******      Write cleaned profile to the screen.
C
      IF (LDBG .GE. 3) THEN
         WRITE(TEXT,'(A)') 'Corrected 8 octant profile'
         CALL STTPUT(TEXT,ISTAT)
         K1 = MIN(9,LIM-1)
         DO 270 K = 0,K1
            DO 280 L = 1,8
               IOUT(L) = NINT(PRFL(L,K) * SCALE)
  280       CONTINUE
            WRITE(TEXT, '(8I9)') IOUT
            CALL STTPUT(TEXT,ISTAT)
  270    CONTINUE
      ENDIF
C
      RETURN
      END

C @(#)identf.for	19.1 (ES0-DMD) 02/25/03 14:29:01
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C

      SUBROUTINE IDENTF(NROW1,NACT1,BUF1,NROW2,NACT2,BUF2,ERROR,IDEG,
     +                    COEFF,IST,MODE)
C
C IDENTIFY DETECTED LINES
C
C INPUT ARGUMENTS
C NROW1   INTG*4  DIMENSION OF BUF1
C NACT1   INTG*4  NUMBER OF DETECTED LINES
C BUF1 REAL*8  BUFFER WITH DETECTED LINES
C NROW2   INTG*4  DIMENSION OF BUF2
C NACT2   INTG*4  NUMBER OF COMPARISON LINES
C BUF2 REAL*8  BUFFER WITH COMPARISON LINES
C ERROR REAL*8  TOLERANCE IN PIXELS
C IDEG INTG*4  DEGREE OF POLYNOMIAL
C MODE    INTG MODE=0 Normal identification, MODE=1 GUESS
C
C INPUT/OUTPUT ARGUMENTS
C COEFF REAL*8  DISPERSION COEFFICIENTS X <- F(WAVE)
C               COEFF is an input in mode GUESS 
C
C OUTPUT ARGUMENTS
C IST     INTG*4  STATUS RETURN (0 - OK)
C
C THE ARRAY BUF1 CONTAINS THE FOLLOWING INFORMATION:
C
C BUF1(I,1) - X1 LINE POSITION
C BUF1(I,2) - LINE FLAG  AS    1 MANUAL IDENTIFICATION
C                              0 NOT IDENTIFIED
C                             -1 AUTOMATIC IDENTIFICATION
C BUF1(I,3) - ACTUAL IDENTIFICATION
C BUF1(I,4) - COMPUTED WAVELENGTH
C BUF1(I,5) - RESIDUALS
C
      IMPLICIT NONE
C
      INTEGER      NROW1,NACT1,NROW2,NACT2,IST,MODE
      DOUBLE PRECISION ERROR,BUF1(NROW1,5),COEFF(30)
      DOUBLE PRECISION STDEV,STDEV1,STDEV3,BUF2(NROW2)
      INTEGER IDEG,ISTAT,NSTEP,NV
      INTEGER NTOT,NTOTAL,NTOTU,NTOTI,NTOTR1,NTOTR2,I
      CHARACTER*78 OUTPUT
      CHARACTER*78 OUTP2
      CHARACTER*72 OUTP3
C
      DATA OUTP2/
     +' iteration  total  unident. ident.  abs(res)>3*stdev  
     +stdev (pixel)'
     +      /
      DATA OUTP3/
     +' ---------  -----  -------  ------  ----------------  
     +-------------'
     +     /
C
      STDEV1 = -1.D20
      IST    = 0
C
C ... ITERATION
C
          OUTPUT = ' '
      CALL STTPUT(OUTPUT,ISTAT)
      CALL STTPUT(OUTP2,ISTAT)
      CALL STTPUT(OUTP3,ISTAT)

      DO 20 NSTEP = 1,10

          NV     = IDEG + 1

         IF (MODE.EQ.0.OR.NSTEP.GT.1)  THEN
C           LSOLVE is skipped at iteration 1 in mode MODE=1 (GUESS)
C
C ...    BUILD L - S MATRIX AND SOLVE SYSTEM
C
          CALL LSOLVE(NROW1,NACT1,BUF1,IDEG,NV,COEFF)

         ENDIF
C
C ...    IDENTIFY FEATURES
C
          CALL LSIDEN(IDEG,NV,COEFF,NROW1,NACT1,BUF1,NACT2,BUF2,ERROR,
     +                 NTOT,STDEV)
C
C ...    SELECT LINES WITH LOW RESIDUALS
C
          STDEV3 = STDEV*3.D0
          IF (NTOT.EQ.0) THEN
              IST    = 1
              RETURN
          ENDIF
C
C ...    STATISTICS ON THE IDENTIFICATIONS
C  !   TOTAL NUMBER OF LINES
          NTOTAL = 0  !   TOTAL NUMBER OF UNIDENTIFIED LINES
          NTOTU  = 0  !   TOTAL NUMBER OF IDENTIFIED LINES
          NTOTI  = 0  !   TOTAL NUMBER OF LINES WITH RESIDUALS .LT. 0.1 PIXEL
          NTOTR1 = 0  !   TOTAL NUMBER OF LINES WITH RESIDUALS .GT.3*STDEV
          NTOTR2 = 0
          DO 10 I = 1,NACT1
              NTOTAL = NTOTAL + 1
              IF (DABS(BUF1(I,2)).GT.0.5D0) THEN
                  NTOTI  = NTOTI + 1
                  IF (DABS(BUF1(I,5)).GT.STDEV3) THEN
                      BUF1(I,2) = 0.0D0
                      BUF1(I,4) = 0.0D0
                      BUF1(I,5) = 0.0D0
                      NTOTR2 = NTOTR2 + 1
                  END IF
              ENDIF
   10     CONTINUE
          NTOTU  = NTOTAL - NTOTI
          WRITE (OUTPUT,9000) NSTEP,NTOTAL,NTOTU,NTOTI,NTOTR2,STDEV
          CALL STTPUT(OUTPUT,ISTAT)
          IF (NTOTI.LT.NV) THEN
              CALL STTPUT(' Error : not enough  identified entries',
     +                    ISTAT)
              IST    = 1
              RETURN
          END IF
          IF (NSTEP.GT.1.AND.DABS((STDEV-STDEV1)/STDEV)
     +                                     .LE.0.005D0) RETURN
          STDEV1 = STDEV

   20 CONTINUE
 9000 FORMAT (1X,I9,2X,I5,2X,I7,2X,I6,10X,I8,2X,E10.3)

      RETURN
      END

C @(#)ccdillum.for	19.1 (ES0-DMD) 02/25/03 14:16:38
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM MKILLU
C++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION: ccdillum.FOR
C.KEYWORDS:       box smoothing
C.PURPOSE:        box smoothing with growing boxcar size
C.VERSION:        930810 RHW Creation
C--------------------------------------------------
      IMPLICIT     NONE

      INTEGER      IAV
      INTEGER      STATUS,MADRID
      INTEGER      NAXIS,NPIX(2)
      INTEGER      IMNOC,IMNOA
      INTEGER*8    PNTRA,PNTRC
      INTEGER      KUN,KNUL
      INTEGER      XBMIN, XBMAX
      INTEGER      YBMIN, YBMAX
C
      CHARACTER*60 FRAMEA,FRAMEC
      CHARACTER*72 IDENT
      CHARACTER*48 CUNIT
      CHARACTER*3  ACTION
C
      DOUBLE PRECISION START(2),STEP(2)
C
      REAL         AVER
      REAL         XBOX(2), YBOX(2)
      REAL         XBMINR, XBMAXR
      REAL         YBMINR, YBMAXR
      REAL         CLIP(2)
      REAL         LOWSIG,HIGSIG
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON/VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C *** do the work
      CALL STSPRO('ILLUM')

      CALL STKRDC('IN_A',1,1,60,IAV,FRAMEA,KUN,KNUL,STATUS)
      CALL STIGET(FRAMEA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     1                2,NAXIS,NPIX,START,STEP,IDENT,CUNIT,
     2                PNTRA,IMNOA,STATUS)
      CALL STKRDC('OUT_A',1,1,60,IAV,FRAMEC,KUN,KNUL,STATUS)
      CALL STIPUT(FRAMEC,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     1            NAXIS,NPIX,START,STEP,IDENT,CUNIT,PNTRC,
     2            IMNOC,STATUS)
C
C *** smoothing boxes
      CALL STKRDR('XBOX',1,2,IAV,XBOX,KUN,KNUL,STATUS)
      CALL STKRDR('YBOX',1,2,IAV,YBOX,KUN,KNUL,STATUS)
      XBMINR = XBOX(1)
      XBMAXR = XBOX(2)
      YBMINR = YBOX(1)
      YBMAXR = YBOX(2)
C
C *** check the smoothing boxes
      IF (XBMINR.LT.1.) THEN
         XBMINR = XBMINR*NPIX(1)
      ENDIF 
      IF (XBMAXR.LT.1.) THEN
         XBMAXR = XBMAXR*NPIX(1)
      ENDIF      
      IF (YBMINR.LT.1.) THEN
         YBMINR = YBMINR*NPIX(2)
      ENDIF      
      IF (YBMAXR.LT.1.) THEN
         YBMAXR = YBMAXR*NPIX(2)
      ENDIF
C
      XBMIN = INT(MAX(2,MIN(NPIX(1),NINT(MIN(XBMINR,XBMAXR)))))
      XBMAX = INT(MAX(2,MIN(NPIX(1),NINT(MAX(XBMINR,XBMAXR)))))
      YBMIN = INT(MAX(2,MIN(NPIX(2),NINT(MIN(YBMINR,YBMAXR)))))
      YBMAX = INT(MAX(2,MIN(NPIX(2),NINT(MAX(YBMINR,YBMAXR)))))
C
C *** to clip or not to clip
      CALL STKRDC('CLIP',1,1,3,IAV,ACTION,KUN,KNUL,STATUS)
      CALL UPCAS(ACTION,ACTION)
      IF (ACTION(1:1).EQ.'Y') THEN
         CALL STKRDR('SIGMA',1,2,IAV,CLIP,KUN,KNUL,STATUS)
         LOWSIG = CLIP(1)
         HIGSIG = CLIP(2)
      ENDIF
C
C *** test on clipping
      IF (ACTION(1:1).EQ.'Y') THEN
         CALL ILLUM(PNTRA,PNTRC,NPIX,XBMIN,XBMAX,YBMIN,YBMAX,
     2              LOWSIG,HIGSIG,AVER)
      ELSE
         CALL QILLUM(PNTRA,PNTRC,NPIX,XBMIN,XBMAX,YBMIN,YBMAX,AVER)
      ENDIF
C
      CALL STDCOP(IMNOA,IMNOC,1,' ',STATUS) 
      CALL STDWRR(IMNOC,'CCDMEAN',AVER,1,1,KUN,STATUS)
      CALL STSEPI
      END


      SUBROUTINE ILLUM(IN,OUT,NPIX,XBMIN,XBMAX,YBMIN,YBMAX,
     2                 LOW,HIGH,MEAN)
C
      IMPLICIT NONE

      INTEGER       IN, OUT
      INTEGER       NPIX(2)
      INTEGER       XBMIN,XBMAX,YBMIN,YBMAX
      REAL          LOW, HIGH
      REAL          MEAN
C
      INTEGER       LINEIN, LINEOUT
      INTEGER       IMNOS, IMNOG, IMNOP
      INTEGER*8     IPOINT, PTRS, SUM, AVG, OUTPUT
      INTEGER*8     PTR
      INTEGER       I, NITER, NREJ
      INTEGER       MADRID(1)
      INTEGER       NCOLS,NLINES
      INTEGER       STAT, IAV
      INTEGER       YBOX2

      REAL          SCALE
      REAL          ILLSUM
      EXTERNAL      ILLSUM
      INTEGER       BXCLN
      EXTERNAL      BXCLN
      INCLUDE       'MID_INCLUDE:ST_DEF.INC'
      COMMON        /VMR/MADRID
      INCLUDE       'MID_INCLUDE:ST_DAT.INC'
      DATA          NITER/10/
C
C *** here create vitual memory
      NCOLS  = NPIX(1)
      NLINES = NPIX(2)
C      
      CALL STFCRE('dummsumm',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     2            NCOLS,IMNOS,STAT)                          ! create sum array
      CALL STFMAP(IMNOS,F_X_MODE,1,NCOLS,IAV,SUM,STAT)
C
      CALL STFCRE('dummavg',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     2            NCOLS,IMNOG,STAT)                        !create output array
      CALL STFMAP(IMNOG,F_X_MODE,1,NCOLS,IAV,AVG,STAT)
      OUTPUT = AVG
C
      CALL STFCRE('dummpntr',D_I4_FORMAT,F_X_MODE,F_IMA_TYPE,
     2            YBMAX,IMNOP,STAT)                      ! create pointer array
      CALL STFMAP(IMNOP,F_X_MODE,1,YBMAX,IAV,PTRS,STAT)
C
C *** now start the work
C      IF (YBMAX.LT.NLINES) THEN
C         YBMAX = NLINES
C      ENDIF
C
C *** accumulate the minimum y box
      CALL ILLZER(MADRID(SUM),NCOLS)                   ! initialize sum array
C
C *** acumulate the minimum y box
      LINEIN = 0
   10 CONTINUE
      IF (LINEIN.LT.YBMIN) THEN
         LINEIN = LINEIN + 1
         IPOINT = IN + (LINEIN-1)*NCOLS
         CALL ILLADD(MADRID(IPOINT),MADRID(SUM),MADRID(SUM),NCOLS)
         PTR = PTRS + MOD(LINEIN,YBMAX) 
         MADRID(PTR) = IPOINT
         GOTO 10
      ENDIF
C
C *** output the minimum y box
      YBOX2 = YBMIN
      SCALE = FLOAT(YBMIN)
      CALL AGBCAR(MADRID(SUM),MADRID(AVG),NCOLS,XBMIN,XBMAX,SCALE)
C
C *** Iteratively clean the initial lines
      PTR = PTRS
      IF (YBOX2 .NE. YBMAX) THEN
         PTR = PTR+1
      ENDIF
C
      DO I = 1, NITER
         NREJ = 0
         DO LINEOUT = 1,LINEIN
            IPOINT = MADRID(PTR+LINEOUT-1)
            NREJ   = NREJ + BXCLN(MADRID(IPOINT),MADRID(AVG),
     2                            MADRID(SUM),NCOLS,LOW,HIGH)
         ENDDO
         IF (NREJ.GT.0) THEN
            CALL AGBCAR(MADRID(SUM),MADRID(AVG),NCOLS,XBMIN,XBMAX,SCALE)
         ELSE
            GOTO 20
         ENDIF
      ENDDO
C
   20 CONTINUE
      YBOX2 = (YBMIN+1)/2
      LINEOUT = 0
          
   30 CONTINUE
      IF (LINEOUT.LT.YBOX2) THEN
         LINEOUT = LINEOUT + 1
         IPOINT  = OUT + (LINEOUT-1)*NCOLS
         CALL COPYF(MADRID(OUTPUT),MADRID(IPOINT),NCOLS)
         GO TO 30
      ENDIF
      MEAN = YBOX2*ILLSUM(MADRID(OUTPUT),NCOLS)            ! calculate the MEAN
C
C *** increase the y box size by steps of 2 until the maximum szie.
   40 CONTINUE
      IF (LINEIN.LT.YBMAX) THEN
         LINEIN = LINEIN + 1
         IPOINT = IN + (LINEIN-1)*NCOLS
         CALL ILLADD(MADRID(SUM),MADRID(IPOINT),MADRID(SUM),NCOLS) 
         PTR = PTRS + MOD(LINEIN,YBMAX)
         MADRID(PTR) = IPOINT
         SCALE = SCALE + 1
C
         NREJ  = BXCLN(MADRID(IPOINT),MADRID(AVG),
     2                 MADRID(SUM),NCOLS,LOW,HIGH)
         CALL AGBCAR(MADRID(SUM),MADRID(AVG),NCOLS,XBMIN,XBMAX,SCALE)
C
         LINEIN = LINEIN + 1
         IPOINT = IN + (LINEIN-1)*NCOLS
         CALL ILLADD(MADRID(SUM),MADRID(IPOINT),MADRID(SUM),NCOLS) 
         PTR    = PTRS + MOD(LINEIN,YBMAX)
         MADRID(PTR) = IPOINT
C
         NREJ  = BXCLN(MADRID(IPOINT),MADRID(AVG),MADRID(SUM),
     2           NCOLS,LOW,HIGH)
         SCALE = SCALE + 1
         CALL AGBCAR(MADRID(SUM),MADRID(AVG),NCOLS,XBMIN,XBMAX,SCALE)
C
         LINEOUT = LINEOUT + 1
         IPOINT = OUT + (LINEOUT-1)*NCOLS
         CALL COPYF(MADRID(AVG),MADRID(IPOINT),NCOLS)
         MEAN = MEAN + ILLSUM(MADRID(IPOINT),NCOLS)            ! calculate MEAN
         GOTO 40
      ENDIF
C
C *** for each line subtract the last line from the sum, add the 
C     next line to the sum, and output a line
   50 CONTINUE
      IF (LINEIN.LT.NLINES) THEN
         LINEIN = LINEIN + 1
         PTR = PTRS + MOD(LINEIN,YBMAX)
         IPOINT = MADRID(PTR)
         CALL ILLSUB(MADRID(SUM),MADRID(IPOINT),MADRID(SUM),NCOLS) 
         IPOINT = IN + (LINEIN-1)*NCOLS
         CALL ILLADD(MADRID(SUM),MADRID(IPOINT),MADRID(SUM),NCOLS) 
         MADRID(PTR) = IPOINT
C
         NREJ  = BXCLN(MADRID(IPOINT),MADRID(AVG),MADRID(SUM),
     2           NCOLS,LOW,HIGH)
C
         LINEOUT = LINEOUT + 1
         IPOINT = OUT + (LINEOUT-1)*NCOLS
         CALL AGBCAR(MADRID(SUM),MADRID(AVG),NCOLS,XBMIN,XBMAX,SCALE)
         CALL COPYF(MADRID(AVG),MADRID(IPOINT),NCOLS)
         MEAN = MEAN + ILLSUM(MADRID(IPOINT),NCOLS)        ! calculate the MEAN
         GOTO 50
      ENDIF
C
C *** decrease the y box in steps of 2 until mimimum y box
   60 CONTINUE
      IF (LINEOUT.LT.(NLINES-YBOX2)) THEN
         LINEIN = LINEIN + 1
         PTR = PTRS + MOD(LINEIN,YBMAX)
         IPOINT = MADRID(PTR)
         CALL ILLSUB(MADRID(SUM),MADRID(IPOINT),MADRID(SUM),NCOLS) 
         LINEIN = LINEIN + 1
         PTR = PTRS + MOD(LINEIN,YBMAX)
         IPOINT = MADRID(PTR)
         CALL ILLSUB(MADRID(SUM),MADRID(IPOINT),MADRID(SUM),NCOLS) 
         SCALE = SCALE-2
C
         LINEOUT  = LINEOUT + 1
         IPOINT = OUT + (LINEOUT-1)*NCOLS
         CALL AGBCAR(MADRID(SUM),MADRID(IPOINT),NCOLS,XBMIN,XBMAX,SCALE)
         MEAN = MEAN + ILLSUM(MADRID(IPOINT),NCOLS)        ! calculate the MEAN
         GOTO 60
      ENDIF
C
C *** output the last liens of the minimum y box size
      CALL AGBCAR(MADRID(SUM),MADRID(AVG),NCOLS,XBMIN,XBMAX,SCALE)
   70 CONTINUE
      IF (LINEOUT.LT.NLINES) THEN
         LINEOUT = LINEOUT + 1
         IPOINT = OUT + (LINEOUT-1)*NCOLS
         CALL COPYF(MADRID(OUTPUT),MADRID(IPOINT),NCOLS)
         GOTO 70
      ENDIF
C
C *** write the scaling vector
      MEAN = MEAN + (NLINES-LINEOUT)*ILLSUM(MADRID(AVG),NCOLS)
      MEAN = MEAN/(NCOLS*NLINES)
C
      RETURN
      END 



      SUBROUTINE QILLUM(IN,OUT,NPIX,XBMIN,XBMAX,YBMIN,YBMAX,MEAN)
C
      IMPLICIT NONE

      INTEGER       IN, OUT
      INTEGER       NPIX(2)
      INTEGER       XBMIN,XBMAX,YBMIN,YBMAX
      REAL          MEAN
C
      INTEGER       LINEIN, LINEOUT
      INTEGER       IMNOS, IMNOO, IMNOP
      INTEGER       IPOINT, PTRS, SUM, OUTPUT
      INTEGER       PTR
      INTEGER       MADRID(1)
      INTEGER       NCOLS,NLINES
      INTEGER       STAT, IAV
      INTEGER       YBOX1

      REAL          SCALE
      REAL          ILLSUM
      EXTERNAL      ILLSUM
      INCLUDE       'MID_INCLUDE:ST_DEF.INC'
      COMMON        /VMR/MADRID
      INCLUDE       'MID_INCLUDE:ST_DAT.INC'
C
C *** here create vitual memory
      NCOLS  = NPIX(1)
      NLINES = NPIX(2)
C      
      CALL STFCRE('dummsumm',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     2            NCOLS,IMNOS,STAT)                          ! create sum array
      CALL STFMAP(IMNOS,F_X_MODE,1,NCOLS,IAV,SUM,STAT)
C
      CALL STFCRE('dummoutp',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     2            NCOLS,IMNOO,STAT)                        !create output array
      CALL STFMAP(IMNOO,F_X_MODE,1,NCOLS,IAV,OUTPUT,STAT)
C
      CALL STFCRE('dummpntr',D_I4_FORMAT,F_X_MODE,F_IMA_TYPE,
     2            YBMAX,IMNOP,STAT)                      ! create pointer array
      CALL STFMAP(IMNOP,F_X_MODE,1,YBMAX,IAV,PTRS,STAT)
C
C *** now start the work
C      IF (YBMAX.LT.NLINES) THEN
C         YBMAX = NLINES
C      ENDIF
C
C *** accumulate the minimum y box
      CALL ILLZER(MADRID(SUM),NCOLS)                   ! initialize sum array
C
C *** acumulate the minimum y box
      LINEIN = 0
   10 CONTINUE
      IF (LINEIN.LT.YBMIN) THEN
         LINEIN = LINEIN + 1
         IPOINT = IN + (LINEIN-1)*NCOLS
         CALL ILLADD(MADRID(IPOINT),MADRID(SUM),MADRID(SUM),NCOLS)
         PTR = PTRS + MOD(LINEIN,YBMAX) 
         MADRID(PTR) = IPOINT
         GOTO 10
      ENDIF
C
C *** output the minimum y box
      YBOX1 = (YBMIN+1)/2
      SCALE = FLOAT(YBMIN)
      CALL AGBCAR(MADRID(SUM),MADRID(OUTPUT),NCOLS,XBMIN,XBMAX,SCALE)
      LINEOUT = 0
   20 CONTINUE
      IF (LINEOUT.LT.YBOX1) THEN
         LINEOUT = LINEOUT + 1
         IPOINT  = OUT + (LINEOUT-1)*NCOLS
         CALL COPYF(MADRID(OUTPUT),MADRID(IPOINT),NCOLS)
         GO TO 20
      ENDIF
      MEAN = YBOX1*ILLSUM(MADRID(OUTPUT),NCOLS)            ! calculate the MEAN
C
C *** increase the y box size by steps of 2 until the maximum szie.
   30 CONTINUE
      IF (LINEIN.LT.YBMAX) THEN
         LINEIN = LINEIN + 1
         IPOINT = IN + (LINEIN-1)*NCOLS
         CALL ILLADD(MADRID(SUM),MADRID(IPOINT),MADRID(SUM),NCOLS) 
         PTR    = PTRS + MOD(LINEIN,YBMAX)
         MADRID(PTR) = IPOINT
         LINEIN = LINEIN + 1
         IPOINT = IN + (LINEIN-1)*NCOLS
         CALL ILLADD(MADRID(SUM),MADRID(IPOINT),MADRID(SUM),NCOLS) 
         PTR    = PTRS + MOD(LINEIN,YBMAX)
         MADRID(PTR) = IPOINT
C
         SCALE = SCALE + 2
         LINEOUT = LINEOUT + 1
         IPOINT = OUT + (LINEOUT-1)*NCOLS
         CALL AGBCAR(MADRID(SUM),MADRID(IPOINT),NCOLS,XBMIN,XBMAX,SCALE)
         MEAN = MEAN + ILLSUM(MADRID(IPOINT),NCOLS)            ! calculate MEAN
         GOTO 30
      ENDIF
C
C *** for each line subtract the last line from the sum, add the 
C     next line to the sum, and output a line
   40 CONTINUE
      IF (LINEIN.LT.NLINES) THEN
         LINEIN = LINEIN + 1
         PTR = PTRS + MOD(LINEIN,YBMAX)
         IPOINT = MADRID(PTR)
         CALL ILLSUB(MADRID(SUM),MADRID(IPOINT),MADRID(SUM),NCOLS) 
         IPOINT = IN + (LINEIN-1)*NCOLS
         CALL ILLADD(MADRID(SUM),MADRID(IPOINT),MADRID(SUM),NCOLS) 
         MADRID(PTR) = IPOINT
C
         LINEOUT = LINEOUT + 1
         IPOINT = OUT + (LINEOUT-1)*NCOLS
         CALL AGBCAR(MADRID(SUM),MADRID(IPOINT),NCOLS,XBMIN,XBMAX,SCALE)
         MEAN = MEAN + ILLSUM(MADRID(IPOINT),NCOLS)        ! calculate the MEAN
         GOTO 40
      ENDIF
C
C *** decrease the y box in steps of 2 until mimimum y box
   50 CONTINUE
      IF (LINEOUT.LT.(NLINES-YBOX1)) THEN
         LINEIN = LINEIN + 1
         PTR = PTRS + MOD(LINEIN,YBMAX)
         IPOINT = MADRID(PTR)
         CALL ILLSUB(MADRID(SUM),MADRID(IPOINT),MADRID(SUM),NCOLS) 
         LINEIN = LINEIN + 1
         PTR = PTRS + MOD(LINEIN,YBMAX)
         IPOINT = MADRID(PTR)
         CALL ILLSUB(MADRID(SUM),MADRID(IPOINT),MADRID(SUM),NCOLS) 
C
         LINEOUT  = LINEOUT + 1
         SCALE = SCALE -2
         IPOINT = OUT + (LINEOUT-1)*NCOLS
         CALL AGBCAR(MADRID(SUM),MADRID(IPOINT),NCOLS,XBMIN,XBMAX,SCALE)
         MEAN = MEAN + ILLSUM(MADRID(IPOINT),NCOLS)        ! calculate the MEAN
         GOTO 50
      ENDIF
C
C *** output the last liens of the minimum y box size
      CALL AGBCAR(MADRID(SUM),MADRID(OUTPUT),NCOLS,XBMIN,XBMAX,SCALE)
   60 CONTINUE
      IF (LINEOUT.LT.NLINES) THEN
         LINEOUT = LINEOUT + 1
         IPOINT = OUT + (LINEOUT-1)*NCOLS
         CALL COPYF(MADRID(OUTPUT),MADRID(IPOINT),NCOLS)
         GOTO 60
      ENDIF
C
C *** write the scaling vector
      MEAN = MEAN + (NLINES-LINEOUT)*ILLSUM(MADRID(OUTPUT),NCOLS)
      MEAN = MEAN/(NCOLS*NLINES)
C
      RETURN
      END 
C
C
C
      INTEGER FUNCTION BXCLN(DATA,BXAVG,SUM,NCOLS,LOW,HIGH)
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C   Reject data values from thr sum for the next boxcar average which
C   exceed the minimum and maximum residual values from the current
C   boxcar average. This excludes data from the moving avarge before it 
C   enters the average.
C-----------------------------------------------------------------------
C
      IMPLICIT NONE
   
      REAL     DATA(1)
      REAL     BXAVG(1)
      REAL     SUM(1)
      INTEGER  NCOLS
      REAL     LOW
      REAL     HIGH
C
      INTEGER  I,NREJ
      REAL     RMS,RESID,MINRES,MAXRES
C
      RMS    = 0.0
      DO I = 1,NCOLS
         RMS = RMS + (DATA(I)-BXAVG(1))**2
      ENDDO
      RMS    = SQRT(RMS/NCOLS)
      MINRES = -LOW*RMS
      MAXRES = HIGH*RMS
C
      NREJ = 0
      DO I = 1,NCOLS
         RESID = DATA(I)-BXAVG(I)
         IF ((RESID.LT.MINRES) .OR. (RESID.GT.MAXRES)) THEN
            DATA(I) = BXAVG(I)
            SUM(I)  = SUM(I)-RESID
            NREJ    = NREJ+1
         ENDIF
      ENDDO
C
      BXCLN = NREJ
      RETURN
      END
C
C
C
      SUBROUTINE ILLZER(A,NC)
C
      IMPLICIT NONE
      REAL     A(1)
      INTEGER  NC
      INTEGER  IC
C
      DO IC = 1,NC
         A(IC) = 0.0
      ENDDO
      RETURN
      END
C
C
C
      SUBROUTINE ILLADD(A,B,C,NC)
C
      IMPLICIT NONE
      REAL     A(1),B(1),C(1)
      INTEGER  NC
      INTEGER  IC
C
      DO IC = 1,NC
         C(IC) = A(IC)+B(IC)
      ENDDO
      RETURN
      END
C
C
C
      SUBROUTINE ILLSUB(A,B,C,NC)
C
      IMPLICIT NONE
      REAL     A(1),B(1),C(1)
      INTEGER  NC
      INTEGER  IC
C
      DO IC = 1,NC
         C(IC) = A(IC)-B(IC)
      ENDDO
      RETURN
      END
C
C
C
      REAL FUNCTION ILLSUM(A,NC)
C
      IMPLICIT NONE
      REAL     A(1)
      INTEGER  NC
      INTEGER  IC
C
      ILLSUM = 0.0       
      DO IC = 1,NC
         ILLSUM = ILLSUM + A(IC)
      ENDDO

      RETURN
      END
C
C
C

      SUBROUTINE AGBCAR(INA,OUTA,NCOLS,XBMIN,XBMAX,YBOX)
C 
C +++ Vector growing boxcar smooth. Taken from the IRAF CCD package
C
      REAL     INA(1)
      REAL     OUTA(1)
      INTEGER  NCOLS
      INTEGER  XBMIN,XBMAX
      REAL     YBOX
C
      INTEGER  COLIN, COLOUT, LASTCOL
      INTEGER  NPIX, XBMIN2
      REAL     SUM,OUTPUT
C
      XBMIN2 = (XBMIN+1)/2
      COLIN  = 0 
      SUM    = 0.0
   10 CONTINUE
      IF (COLIN.LT.XBMIN) THEN
         COLIN = COLIN + 1
         SUM   =  SUM + INA(COLIN)
         GOTO 10
      ENDIF
C
      NPIX   = XBMIN * YBOX
      OUTPUT = SUM/NPIX
      COLOUT = 0
   20 CONTINUE
      IF (COLOUT.LT.XBMIN2) THEN
         COLOUT       = COLOUT + 1
         OUTA(COLOUT) = OUTPUT
         GO TO 20
      ENDIF 
C
   30 CONTINUE
      IF (COLIN.LT.XBMAX) THEN
         COLIN  = COLIN + 1
         SUM    = SUM + INA(COLIN)
         COLIN  = COLIN + 1
         SUM    = SUM + INA(COLIN)
         NPIX   = NPIX + 2*YBOX
         COLOUT = COLOUT + 1
         OUTA(COLOUT) = SUM/NPIX
         GO TO 30
      ENDIF
C
      LASTCOL = 0
   40 CONTINUE
      IF (COLIN.LT.NCOLS) THEN
         COLIN   = COLIN + 1
         LASTCOL = LASTCOL +1
         SUM     = SUM + INA(COLIN) - INA(LASTCOL)
         COLOUT  = COLOUT + 1
         OUTA(COLOUT) = SUM/NPIX
         GO TO 40
      ENDIF
C
   50 CONTINUE
      IF (COLOUT.LT. NCOLS - XBMIN2) THEN
         LASTCOL     = LASTCOL + 1
         SUM         = SUM - INA(LASTCOL)
         LASTCOL     = LASTCOL + 1
         SUM         = SUM - INA(LASTCOL)
         NPIX        = NPIX - 2*YBOX
         COLOUT      = COLOUT + 1
         OUTA(COLOUT)= SUM/NPIX
         GO TO 50
      ENDIF
C
      OUTPUT = SUM/NPIX
   70 CONTINUE
      IF (COLOUT.LT.NCOLS) THEN
         COLOUT = COLOUT + 1
         OUTA(COLOUT) = OUTPUT
         GO TO 70
      ENDIF

      RETURN
      END

C @(#)rfotrfit.for	19.1 (ES0-DMD) 02/25/03 13:30:15
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
         PROGRAM FIT
C---
C.IDENTIFICATION:  RFOTFIT
C.PURPOSE:         Determine characteristics of object by non-linear fitting
C.                 Data and results are taken from and written the int. table
C.AUTHOR:          R. Buonanno, G. Buscema, C. Corsi, I. Ferraro, G. Iannicola
C.                 Osservatorio Astronomico di Roma
C.VERSION:         05/14/87 date of creation
C.VERSION:         15/12/87 RHW implementation in MIDAS standard interfaces
C.VERSION:         10/03/88 RB  new version 
C.VERSION:         03/05/89 RHW change to ST interfaces and streamlining code
C.VERSION:         22/01/91 RHW all variables declared; implicit none added
C+++
       IMPLICIT    NONE
       INCLUDE     'MID_REL_INCL:RFOTDECL.INC'
C
       INTEGER     NDXY
       INTEGER     NCA
       INTEGER     MBB
       INTEGER     MPA
       INTEGER     NCD
       INTEGER     NTM
       INTEGER     NOB
       INTEGER     M12
       INTEGER     IDP
       INTEGER     IDB
       PARAMETER   (NDXY=55)
       PARAMETER   (NCA=200)
       PARAMETER   (MBB=256)
       PARAMETER   (MPA=10000)
       PARAMETER   (NCD=MBB-18)
       PARAMETER   (NTM=NCD/6.5)
       PARAMETER   (NOB=NCD/3)
       PARAMETER   (M12=NDXY*NDXY)
       PARAMETER   (IDP=(NTM*4)+3)
       PARAMETER   (IDB=NOB*3)
C
       INTEGER      ODISPL,NDISPL
       INTEGER      EC, ED, EL
       INTEGER      FL, GR
       INTEGER      I, IS, IH, IQ
       INTEGER      IPX, IPY
       INTEGER      IOBJ, IROW, IDUM
       INTEGER      IKKL, IFLG
       INTEGER*8    IPNTR
       INTEGER      IMF
       INTEGER      IP, IPA
       INTEGER      IND, INK, INK1
       INTEGER      ISTZE(100),ISTUN(100),ISTMA(100)
       INTEGER      IVX(M12),IVY(M12)
       INTEGER      ISC(7), ISX, ISY
       INTEGER      ISTAT, IAC
       INTEGER      IDI, IND1, IND2
       INTEGER      IRINT
       INTEGER      IDE, ICB
       INTEGER      JL0, JL1, JL2, JIL4
       INTEGER      J5,  JIL, JOLD, JQ4
       INTEGER      JQ, JS
       INTEGER      KFR(NTM)
       INTEGER      KUN, KNUL
       INTEGER      K3, KP, KG, KKL, KL, KTP, KTS, KRO, K13
       INTEGER      KAL, KSF, KPR1, KAS
       INTEGER      K6, K7, K9, K74
       INTEGER      MADRID(1)
       INTEGER      MAXX
       INTEGER      LI, LLI
       INTEGER      L2, L3, L4, L5, L6, L7
       INTEGER      LJ1, LJ3
       INTEGER      LG, LFL2
       INTEGER      LFLAG
       INTEGER      MASK(NDXY,NDXY)
       INTEGER      NCINT,NRINT,NSINT,NACINT,NARINT
       INTEGER      NOBJ, NGRP, NINT, NAXIS
       INTEGER      NPIX(3)
       INTEGER      NONF(NTM)
       INTEGER      NPL, NL, NPS
       INTEGER      NNS, NNF
       INTEGER      NITER, NC, NP, NCOM, NCO
       INTEGER      NCM, NUX, NRFR
       INTEGER      NHL, NCP, NCOMM, NCAL
       INTEGER      NPSG
       INTEGER      RM(NCA)
       INTEGER      TNIT, TINULL
       INTEGER      TIDINT
       INTEGER      WFLAG
C      
       INTEGER      PREVET,PREMAS,FRASUZ,RIPVET,CALINT,AZZMAS,CONPAR
C
       DOUBLE PRECISION START(3),STEP(3)
       DOUBLE PRECISION TDNULL,TDTRUE,TDFALS,DDUM
C
       REAL         A, ALAL, ABC, ALT1
       REAL         AIN, ANC
       REAL         B, BET,BETA, BEBE
       REAL         D, D1, D2, D3, D4, D6
       REAL         DELT, DPS, DXY2
       REAL         EEE
       REAL         FOG, FON, FON1, FOG1, FAT
       REAL         GIG
       REAL         HH, HGU
       REAL         P(IDP),PES(7),SIGP(1000),RIA(NDXY)
       REAL         PSA, PSAS, PAS
       REAL         PA(IDP),PB(IDB)
       REAL         RAG(NTM)
       REAL         RVAL(5)
       REAL         RK4, RMIY, RKN, RR, RINTQ, RMAY
       REAL         SAT, SIGMA, SOFOT, SIGG, SCAP, SAT1
       REAL         SLU, SQM , SIGQ, SQMS, SMT, SIGMA1
       REAL         TRNULL, TBLSEL
       REAL         U, US
       REAL         USC(NTM),USE(NTM)
       REAL         V, VAL, VG
       REAL         VALME(M12)
       REAL         VEZE(MPA),VEUN(MPA),VEMA(MPA)
       REAL         VZ(M12)
       REAL         WEI(M12)
C       
       CHARACTER    FITMET*20,CBETA*80,FITOPT*4,MOF*1,WE*1,AVEOPT*1
       CHARACTER    DIS*1
       CHARACTER    FRAME*60,IDENT*72,CUNIT*72
       CHARACTER    INTFIL*60
       CHARACTER*80 STRING
       CHARACTER*60 XXX
       CHARACTER    INME*1
       CHARACTER    SIGFI*1,SKYFI*1,POSFI*1,IUT*1,TILT*1
C
       LOGICAL      RTELOG
       LOGICAL      SFLAG
C
       INCLUDE      'MID_INCLUDE:ST_DEF.INC'
       COMMON       /VMR/MADRID
       INCLUDE      'MID_INCLUDE:ST_DAT.INC'

       DATA         PES/1.,1.,2.,2.,1.,1.,2./
       DATA         D/0.7/
       DATA         ISC/7*1/
       DATA         ISTZE/100*0/
       DATA         ISTUN/100*0/
       DATA         ISTMA/100*0/

 9001  FORMAT('Frame:              ',A40)
 9002  FORMAT('Intermediate table: ',A40)
 9003  FORMAT('Sigma:     ', G13.6,'; Saturation:   ', G13.6) 
 9004  FORMAT('Tolerance: ', G13.6,'; # Iterations: ', I5)
 9005  FORMAT('Fit method: MOFFET, UNIFORM weighting; BETA: ',G13.6)
 9006  FORMAT('Fit method: MOFFET, 1/N weighting; BETA: ', G13.6)
 9007  FORMAT('Fix sigma, fix position, fix sky, tilt sky plane: ',A)
C
 9011  FORMAT('Too few pixel in this window')
 9012  FORMAT('Window identification: ',I6,2X,
     2        ' Components: ',I2,2X,' Iterations: ',I2)
 9013  FORMAT('Fit errors:      ',4F9.4)
 9014  FORMAT(3F9.4)
C
 9021  FORMAT(80('-'))
 9022  FORMAT('Components not examined: ',I6)
 9023  FORMAT('Total  Mag. index      Histogram')
 9024  FORMAT(1X,I5,2X,F5.1,1X,F11.0,1X,'I',A50)
 9025  FORMAT(1X,I5,2X,F5.1,1X,F11.0,1X,'I')
 9026  FORMAT('Components successfully fitted:  ',I6)
 9027  FORMAT('Components with no convergency: ',I6)

 9031  FORMAT('Iteration: ',I6,'; Added star: ',I6)
 9032  FORMAT('Component below the photometric threshold')
 9035  FORMAT('N O  C O N V E R G E N C E  on ',I3,' components')
 9036  FORMAT(1X,I6,' Component Parameters:        ',F15.1,2F9.1,F7.2)
 9037  FORMAT('N O  C O N V E R G E N C E')

C
C *** Start the program *****************************************************
       CALL STSPRO('FIT')
       CALL TBMNUL(TINULL,TRNULL,TDNULL)
       CALL TBMCON(TBLSEL,TDTRUE,TDFALS)

       JL0  = 0
       JL1  = 0
       JL2  = 0
       RMAY = -10.**15
       RMIY = -RMAY
C
C *** read the frame
       CALL STKRDC('IN_A',1,1,60,IAC,FRAME,KUN,KNUL,ISTAT)
       CALL STIGET(FRAME,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,3,NAXIS,
     2             NPIX,START,STEP,IDENT,CUNIT,IPNTR,IMF,ISTAT)
       NPL   = NPIX(1)
       NL    = NPIX(2)
C
C *** read the intermediate file
       CALL STKRDC('IN_B',1,1,60,IAC,STRING,KUN,KNUL,ISTAT)  ! intermediate file
       IFLG = INDEX(INTFIL,'/')                              ! look for the flag
       IF (IFLG.EQ.0) THEN
          INTFIL = STRING
       ELSE
          IUT = 'F'
          INTFIL = STRING(1:IFLG-1)
       ENDIF
       CALL STECNT('GET',EC,ED,EL)
       CALL STECNT('PUT',1,0,0)
       CALL TBTOPN(INTFIL,F_IO_MODE,TIDINT,ISTAT)
       IF (ISTAT.NE.0) THEN
          STRING = '*** FATAL: Problems with opening intermediate'//
     2             ' table ... '
          CALL STTPUT(STRING,ISTAT)
          CALL STSEPI
       ENDIF
C
C *** get table info
       CALL TBIGET(TIDINT,NCINT,NRINT,NSINT,NACINT,NARINT,ISTAT)
       IF (ISTAT.NE.0) THEN
          STRING = '*** FATAL: Problems with getting info for '//
     2             ' intermediate table; Try again ... '
          CALL STTPUT(STRING,ISTAT)
          CALL STSEPI
       ENDIF
       IF (NRINT.EQ.0) THEN
          STRING = '*** FATAL: No data points in intermediate table'
          CALL STTPUT(STRING,ISTAT)
          CALL STSEPI
       ENDIF
       CALL STECNT('PUT',EC,ED,EL)
C
C *** read table descriptor
       CALL INTDRD(TIDINT,NGRP,NOBJ,NINT,
     2             SAT,FAT,SIGMA,BETA,SOFOT,AIN,FOG)
C
C *** get threshold, sky background
       CALL STKRDR('INPUTR',1,2,IAC,RVAL,KUN,KNUL,ISTAT)    !thresh., sky backgr
       IF (RVAL(1) .GT. 0.0) THEN
          SOFOT = RVAL(1)
       ENDIF
C
       FON1    = RVAL(2)
       FOG1    = 0.0
       IF (FON1.NE.0.0) THEN
          FON  = FON1
          FOG  = FOG1
       ENDIF
C
C      FON1    = RVAL(2)
C      ALFA     = 200.0
C      FOG1     = 0.0
C      IF (FOG1.NE.0.0 .OR. FON1.NE.0.0 .OR. A1.NE.0.0) THEN
C         A1   = 200.
C         FON  = FON1
C         ALFA = A1
C         FOG  = FOG1
C      ENDIF
C
C *** get sigma, sateration, tolerance, max. number of iterations
       CALL STKRDR('INPUTR',3,4,IAC,RVAL,KUN,KNUL,ISTAT)    
       SIGMA1 = RVAL(1)
       SAT1   = RVAL(2)
       IF (SIGMA1.NE.0. .OR. SAT1.NE.0.) THEN
          SIGMA = SIGMA1
          SAT   = SAT1
       ENDIF
       PSA    = RVAL(3)
       PSAS   = RVAL(3)**2
       TNIT   = INT(RVAL(4))
       SIGG   = SIGMA
       ISX    = 0
       ISY    = 0
C
C *** get fitting method
       CALL STKRDC('INPUTC',1,1,20,IAC,FITMET,KUN,KNUL,ISTAT)       !fit method
       CALL UPCAS(FITMET,FITMET)
       IF (FITMET(1:2) .EQ.'MU') THEN
          MOF   = 'M'
          WE    = 'C'
          NCOMM = INDEX(FITMET,',')
          CBETA = FITMET(NCOMM+1:20)
          IF (NCOMM.GT.0) THEN
             CALL GENCNV(CBETA,2,1,IDUM,BETA,DDUM,ISTAT)
C            CALL USRINP(BETA,1,'R',CBETA)
             IF (ABS(BETA).LT.1.0E-30) THEN
                BETA = 4.0
             ENDIF
          ENDIF

       ELSE IF (FITMET(1:2).EQ.'MI') THEN
          MOF   = 'M'
          WE    = 'N'
          NCOMM = INDEX(FITMET,',')
          CBETA = FITMET(NCOMM+1:20)
          IF (NCOMM.GT.0) THEN
             CALL GENCNV(CBETA,2,1,IDUM,BETA,DDUM,ISTAT)
C            CALL USRINP(BETA,1,'R',CBETA)
             IF (ABS(BETA).LT.1.0E-30) THEN
                BETA = 4.0
             ENDIF
          ENDIF
 
       ELSE IF (FITMET(1:2).EQ.'GU') THEN
          MOF  = 'G'
          WE   = 'C'
          BETA = 0.0

       ELSE IF (FITMET(1:2).EQ.'GI') THEN
          MOF  = 'G'
          WE   = 'N'
          BETA = 0.0
 
       ELSE
          MOF  = 'M'
          WE   = 'C'
          BETA = 4.0
       ENDIF
C
C *** get fit option
       CALL STKRDC('INPUTC',1,21,4,IAC,FITOPT,KUN,KNUL,ISTAT)       !fit option
       CALL UPCAS(FITOPT,FITOPT)
       SIGFI = FITOPT(1:1)
       SKYFI = FITOPT(2:2)
       POSFI = FITOPT(3:3)
       TILT  = FITOPT(4:4)
C
C *** get the fix option, sigma, position, sky background, sky tilt
 1000  CONTINUE
       IF (SKYFI.EQ.'Y' .AND. POSFI.EQ.'Y') THEN
          CALL STTPUT('*** WARNING: Illegal combination, '//
     2                '... try again',ISTAT)
          FITOPT = 'YNNN'
          CALL STKWRC('INPUTC',1,FITOPT,21,4,KUN,ISTAT)
          CALL STKPRC(STRING,'INPUTC',1,21,4,IAC,FITOPT,KUN,KNUL,ISTAT) 
          CALL UPCAS(FITOPT,FITOPT)
          SIGFI = FITOPT(1:1)
          SKYFI = FITOPT(2:2)
          POSFI = FITOPT(3:3)
          TILT  = FITOPT(4:4)
          GO TO 1000
       END IF
C
       IF (SIGFI.NE.'N') SIGFI = 'Y'
       IF (POSFI.NE.'Y') POSFI = 'N'
       IF (SKYFI.NE.'Y') THEN
          SKYFI = 'N'
          IF (POSFI.NE.'Y') THEN
             TILT = FITOPT(4:4)
          END IF
          IF (TILT.NE.'Y') THEN
             TILT = 'N'
          ENDIF
       END IF
C
       CALL STKRDC('INPUTC',1,41,1,IAC,AVEOPT,KUN,KNUL,ISTAT)    ! aver. option
       CALL UPCAS(AVEOPT,AVEOPT)
       INME = AVEOPT
C
       CALL STKRDC('INPUTC',1,61,1,IAC,DIS,KUN,KNUL,ISTAT)        ! display
       CALL UPCAS(DIS,DIS)
       IF (DIS.EQ.'Y') THEN
          NDISPL = 0
       ELSE
          NDISPL = 1
       ENDIF
C
C ***  write the info to the screen
       WRITE(STRING,9001) FRAME
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,9002) INTFIL
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,9003) SIGMA, SAT       
       CALL STTPUT(STRING,ISTAT)
       WRITE(STRING,9004) PSA,TNIT
       CALL STTPUT(STRING,ISTAT)
C
       IF (FITMET(1:2).EQ.'MU') THEN
          WRITE(STRING,9005) BETA
       ELSE IF (FITMET(1:2).EQ.'MI') THEN
          WRITE(STRING,9006) BETA
       ELSE IF (FITMET(1:2).EQ.'GU') THEN
          STRING = 'Fit method: GAUSS, UNIFORM weighting'
       ELSE IF (FITMET(1:2).EQ.'GI') THEN
          STRING = 'Fit method: GAUSS, 1/N weighting'
       ENDIF
       CALL STTPUT(STRING,ISTAT)
C
       WRITE(STRING,9007) FITOPT
       CALL STTPUT(STRING,ISTAT)
C
       IF (AVEOPT.EQ.'S') THEN
          STRING = 'Trial values: mean sigma'
       ELSE IF (AVEOPT.EQ.'B') THEN
          STRING = 'Trial values: mean sky background'
       ELSE IF (AVEOPT.EQ.'A') THEN
          STRING = 'Trial values: mean sigma and mean sky background'
       ELSE
          STRING = 'Trial values: none'
       ENDIF
       CALL STTPUT(STRING,ISTAT)
C
C *** set the display flag
       CALL STKRDI('LOG',4,1,IAC,ODISPL,KUN,KNUL,ISTAT)
       CALL STKWRI('LOG',NDISPL,4,1,KUN,ISTAT)
       WRITE(STRING,9021)
       CALL STTPUT(STRING,ISTAT)
C *** do the work *****************************************************
C
       NNS  = 1
       NNF  = 1
       KAL  = 1
       ALT1 = 1.
       KSF  = 0.
       IOBJ = 0
       IROW = 1
C
 1001  CONTINUE
          CALL INTWRD(TIDINT,IROW,NCP,NHL)                     ! read the window
          CALL TBSGET(TIDINT,IROW,SFLAG,ISTAT)
          IF (SFLAG) THEN
             D1     = PARINT(1)
             D2     = PARINT(2)
             V      = PARINT(3)
             B      = PARINT(4)
             U      = PARINT(5)
             D3     = PARINT(6)
             D4     = PARINT(7)
             P(1)   = PARINT(8)
             P(2)   = PARINT(9)
             P(3)   = PARINT(10)
             BET    = PARINT(11)
             SCAP   = PARINT(12)
             D6     = PARINT(13)
             FL     = INT(PARINT(14))
C
             DO 1011 IS = 1,NCP
                P((IS-1)*4+4)  = FITCMP((IS-1)*6+1)
                P((IS-1)*4+5)  = FITCMP((IS-1)*6+2)
                P((IS-1)*4+6)  = FITCMP((IS-1)*6+3)
                P((IS-1)*4+7)  = FITCMP((IS-1)*6+4)
                USC(IS)        = FITCMP((IS-1)*6+5)
                USE(IS)        = FITCMP((IS-1)*6+6)
 1011        CONTINUE
C
             DO 1012 IH = 1,NHL
                PB((IH-1)*3+1) =  FITHOL((IH-1)*3+1)
                PB((IH-1)*3+2) =  FITHOL((IH-1)*3+2)
                PB((IH-1)*3+3) =  FITHOL((IH-1)*3+3)
 1012        CONTINUE
C
             DO 1013 K3 = 1,NTM                      ! initialize the flag array
                IF (FLGCMP(K3).GE.2) THEN
                   FLGCMP(K3) = 1
                ENDIF
                NONF(K3) = FLGCMP(K3)
                KFR(K3)  = 0
 1013        CONTINUE
C
             FL = 0

             IF (TILT.EQ.'N') THEN
                P(1) = 0.
                P(2) = 0.
             ENDIF   
             
             IF (FON1.GT.0 .OR. (INME.EQ.'B' .OR. INME.EQ.'A')) THEN
                IF (FON.NE.0) THEN
                   P(3) = FON
                ELSE
                   FON = P(3)
                END IF
                P(1) = 0.
                P(2) = 0.
             END IF
C
             D1  = D1+ISX
             D2  = D2+ISY
             IPX = D1
             IPY = D2
             NP  = D3
             NC  = D4
C
             ASSIGN 30011 TO PREVET                            ! PREPARA VETTORE
             GO TO 30001
30011        CONTINUE
C
             IF (NCOM.GT.0 .AND. FL.EQ.0) THEN
                IF (NHL.GT.0) THEN
                   ASSIGN 30012 TO PREMAS                     ! PREPARA MASCHERA
                   GO TO 30002
30012              CONTINUE
                END IF
C
                KP  = 0
                LJ1 = IPX-START(1)+1
                LJ3 = IPY-START(2)+1
                DO 1014 J5 = LJ3,LJ3+NC-1
                   JOLD = J5-LJ3+1
                   CALL REALIN(NPL,NL,J5,LJ1,NP,MADRID(IPNTR),RIA)
                   DO 1015 I = 1,NP
                      IF (MASK(JOLD,I).EQ.0) THEN
                         VAL = RIA(I) - FOG
                         IF (VAL.LT.SAT.AND.VAL.GT.0.) THEN
                            KP      = KP+1
                            IVX(KP) = I
                            IVY(KP) = JOLD
                            VZ(KP)  = VAL
                            IF (WE.EQ.'N') THEN
                               IF (VAL.GE.1) THEN
                                  WEI(KP) = 1./VAL
                               ENDIF
                            ELSE
                               WEI(KP) = 1
                            ENDIF
                         END IF
                      END IF
 1015              CONTINUE
 1014           CONTINUE

                IF (KP.GT.NCOM*4+3) THEN
                   ASSIGN 30013 TO FRASUZ                    !FRASER SUZUKI
                   GO TO 30003
30013              CONTINUE
 
                   IF (WFLAG.EQ.1) THEN
                      GR = 1
                   ELSE
                      GR = 2
                   END IF
                   WRITE (STRING,9012) IDNGRP,NCP,NITER
                   CALL STTPUT(STRING,ISTAT)
C
                   ASSIGN 30014 TO RIPVET                  !ripristina vettore
                   GO TO 30004
30014              CONTINUE
C
C                  IF (GR.EQ.1) THEN
                      DO 1016 K3 = 1,NTM
                         FLGCMP(K3) = NONF(K3)
 1016                 CONTINUE
C                  END IF
C
                   IF (AIN.GT.0) THEN
                      ASSIGN 30015 TO CALINT              !calcola interquartile
                      GO TO 30005
30015                 CONTINUE
                   END IF

                   DO 1017 KKL = 1,NCOM
                      IKKL = KTP+(KKL-1)*KTS
                      WRITE(STRING,9013) 
     2                   (SIGP(KL),KL=IKKL+1,IKKL+KTS)
                      IF (KKL.EQ.1) THEN
                         IF (KTP.GT.0) THEN
                            WRITE(STRING(53:),9014) 
     2                         (SIGP(KL),KL=1,KTP)
                         ENDIF
                      ENDIF
                      CALL STTPUT(STRING,ISTAT)
 1017              CONTINUE
                   CALL STTPUT(' ',ISTAT)
                      
                ELSE
                   GR   = 2
                   WRITE(STRING,9011)
                   CALL STTPUT(STRING,ISTAT)
                END IF
C
C *** write the output row for this window
                PARINT(1)  = D1
                PARINT(2)  = D2
                PARINT(3)  = V
                PARINT(4)  = B
                PARINT(5)  = U
                PARINT(6)  = FLOAT(NP)
                PARINT(7)  = FLOAT(NC)
                PARINT(8)  = P(1)
                PARINT(9)  = P(2)
                PARINT(10) = P(3)
                PARINT(11) = BETA
                PARINT(12) = SCAP
                PARINT(13) = FLOAT(NITER)
                PARINT(14) = FLOAT(GR)
C
                DO 1018 IS = 1,NCP
                   FITCMP((IS-1)*6+1) = P((IS-1)*4+4)
                   FITCMP((IS-1)*6+2) = P((IS-1)*4+5)
                   FITCMP((IS-1)*6+3) = P((IS-1)*4+6)
                   FITCMP((IS-1)*6+4) = P((IS-1)*4+7)
                   FITCMP((IS-1)*6+5) = USC(IS)
                   FITCMP((IS-1)*6+6) = USE(IS)
 1018           CONTINUE
C
                DO 1019 IH = 1,NHL
                   FITHOL((IH-1)*3+1) = PB((IH-1)*3+1)
                   FITHOL((IH-1)*3+3) = PB((IH-1)*3+2)
                   FITHOL((IH-1)*3+3) = PB((IH-1)*3+3)
 1019           CONTINUE
C
                CALL INTWWR(TIDINT,IROW,NCP,NHL)
                DO 1020 KRO = 1,NCP
                   RK4 = P(4*KRO)
                   IF (FLGCMP(KRO).EQ.0) THEN
                      JL0 = JL0+1
                      IF (RK4.GT.1) THEN
                         VEZE(JL0) = -2.5*ALOG10(RK4)
                      ELSE
                         VEZE(JL0) = 0
                      END IF
                      RMAY = AMAX1(RMAY,VEZE(JL0))
                      RMIY = AMIN1(RMIY,VEZE(JL0))
C
                   ELSE IF (FLGCMP(KRO).EQ.1) THEN
                      JL1 = JL1+1
                      IF (RK4.GT.1) THEN
                         VEUN(JL1) = -2.5*ALOG10(RK4)
                      ELSE
                         VEUN(JL1) = 0
                      END IF
                      RMAY = AMAX1(RMAY,VEUN(JL1))
                      RMIY = AMIN1(RMIY,VEUN(JL1))
C
                   ELSE IF (FLGCMP(KRO).GT.1)THEN
                      JL2 = JL2+1
                      IF (RK4.GT.1) THEN
                         VEMA(JL2) = -2.5*ALOG10(RK4)
                      ELSE
                         VEMA(JL2) = 0
                      END IF
                      RMAY = AMAX1(RMAY,VEMA(JL2))
                      RMIY = AMIN1(RMIY,VEMA(JL2))
                   END IF
 1020           CONTINUE
C
                CALL INTDWR(TIDINT,NGRP,NOBJ,NINT,SAT,FAT,SIGMA,
     2                                 BETA,SOFOT,AIN,FOG)
                IF (NHL.GT.0) THEN
                   ASSIGN 30016 TO AZZMAS                 !AZZERA MASCHERA
                   GO TO 30006
30016              CONTINUE
                END IF
             END IF
          END IF
          IROW = IROW + NCP + NHL
          IF (IROW.LE.NRINT) THEN
             GO TO 1001
          ENDIF
C
C *** display the histogram
       PAS  = .5
       MAXX = 0
       DO 2001 I = 1,JL0
          NCAL        = (RMAY-VEZE(I))/PAS+1
          IF (NCAL.GT.100) NCAL=100
          ISTZE(NCAL) = ISTZE(NCAL)+1
          MAXX        = MAX0(MAXX,ISTZE(NCAL))
 2001  CONTINUE

       DO 2002 I = 1,JL1
          NCAL        = (RMAY-VEUN(I))/PAS+1
          IF (NCAL.GT.100) NCAL=100
          ISTUN(NCAL) = ISTUN(NCAL)+1
          MAXX        = MAX0(MAXX,ISTUN(NCAL))
 2002  CONTINUE

       DO 2003 I = 1,JL2
          NCAL        = (RMAY-VEMA(I))/PAS+1
          IF (NCAL.GT.100) NCAL=100
          ISTMA(NCAL) = ISTMA(NCAL)+1
          MAXX        = MAX0(MAXX,ISTMA(NCAL))
 2003  CONTINUE

       NCM = (RMAY-RMIY)/PAS+1
       IF (JL0.GT.0) THEN
          WRITE(STRING,9021)
          CALL STTPUT(STRING,ISTAT)
          WRITE(STRING,9022) JL0
          CALL STTPUT(STRING,ISTAT)
          CALL STTPUT(' ',ISTAT)
          WRITE (STRING,9023)
          CALL STTPUT(STRING,ISTAT)
          CALL STTPUT(' ',ISTAT)

          DO 2004 I = 1,NCM
             NUX = 50.*ISTZE(I)/MAXX
             ANC = RMAY-PAS*(I-1)
             HH  = 10.**(-.4*ANC)
             IF (NUX.GT.0) THEN
                XXX = ' '
                DO 2005 K13 = 1,NUX
                   XXX(K13:K13) = 'X'
 2005           CONTINUE
                WRITE(STRING,9024) ISTZE(I),ANC,HH,XXX
                CALL STTPUT(STRING,ISTAT)
             ELSE
                WRITE(STRING,9025) ISTZE(I),ANC,HH
                CALL STTPUT(STRING,ISTAT)
             END IF
 2004     CONTINUE
       END IF

       IF (JL1.GT.0) THEN
          WRITE(STRING,9021)
          CALL STTPUT(STRING,ISTAT)
          WRITE(STRING,9026) JL1
          CALL STTPUT(STRING,ISTAT)
          CALL STTPUT(' ',ISTAT)
          DO 2006 I = 1,NCM
             NUX = 50.*ISTUN(I)/MAXX
             ANC = RMAY-PAS*(I-1)
             HH  = 10.**(-.4*ANC)
             IF (NUX.GT.0) THEN
                XXX = ' '
                DO 2007 K13 = 1,NUX
                   XXX(K13:K13) = 'X'
 2007           CONTINUE
                WRITE(STRING,9024) ISTUN(I),ANC,HH,XXX
                CALL STTPUT(STRING,ISTAT)
             ELSE
                WRITE(STRING,9025) ISTUN(I),ANC,HH
                CALL STTPUT(STRING,ISTAT)
             END IF
 2006     CONTINUE
       END IF
C
       IF (JL2.GT.0) THEN
          WRITE(STRING,9021)
          CALL STTPUT(STRING,ISTAT)
          WRITE(STRING,9027) JL2
          CALL STTPUT(STRING,ISTAT)
          CALL STTPUT(' ',ISTAT)
          DO 2008 I = 1,NCM
             NUX = 50.*ISTMA(I)/MAXX
             ANC = RMAY-PAS*(I-1)
             HH  = 10.**(-.4*ANC)

             IF (NUX.GT.0) THEN
                XXX = ' '
                DO 2009 K13 = 1,NUX
                   XXX(K13:K13) = 'X'
 2009           CONTINUE
                WRITE(STRING,9024) ISTMA(I),ANC,HH,XXX
                CALL STTPUT(STRING,ISTAT)
             ELSE
                WRITE(STRING,9025) ISTMA(I),ANC,HH
                CALL STTPUT(STRING,ISTAT)
             END IF
 2008     CONTINUE
       END IF

       CALL TBTCLO(TIDINT,ISTAT)
       CALL STKWRI('LOG',ODISPL,4,1,KUN,ISTAT)
       CALL STSEPI

C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C      Procedure PREVET
C
C-------------------------------------------------------------------------------
30001  CONTINUE
          DO 30101 LI = 1,3
             PA(LI) = P(LI)
30101     CONTINUE
          NCOM = 0
          DO 30201 LI = 1,NCP
             IF (FLGCMP(LI).GE.1) THEN
                IDE  = (LI-1)*4+3
                NCOM = NCOM+1
                IDI  = (NCOM-1)*4+3
C
                IF (INME.EQ.'S' .OR. INME.EQ.'A') THEN
                   P(IDE+4) = SIGG
                ELSE
                   P(IDE+4) = SIGMA
                ENDIF
C
                DO 30301 LLI = 1,4
                   PA(IDI+LLI) = P(IDE+LLI)
30301           CONTINUE
                PA(IDI+1)  = PA(IDI+1)*ALT1
                FLGCMP(LI) = 1
                NONF(LI)   = 1
             END IF
30201     CONTINUE
       GO TO PREVET

C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C      Procedure PREMAS
C
C-------------------------------------------------------------------------------
30002  CONTINUE                                            !PREPARA MASCHERA
          DO 30102 LI = 1,NHL
             ICB = (LI-1)*3
             RR  = PB(ICB+1)**2
             L4  = AMAX1(1.,PB(ICB+3)-PB(ICB+1))
             L5  = AMIN1(FLOAT(NC),PB(ICB+3)+PB(ICB+1)+.99)
             L6  = AMAX1(1.,PB(ICB+2)-PB(ICB+1))
             L7  = AMIN1(FLOAT(NP),PB(ICB+2)+PB(ICB+1)+.99)
             DO 30202 L2 = L6,L7
                DO 30302 L3 = L4,L5
                   DELT = (FLOAT(L2)-PB(ICB+2))**2 + 
     2                    (FLOAT(L3)-PB(ICB+3))**2
                   IF (RR.GE.DELT) THEN
                      MASK(L3,L2) = 1
                   END IF
30302           CONTINUE
30202        CONTINUE
30102     CONTINUE
       GO TO PREMAS

C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C      Procedure FRASUZ
C
C-------------------------------------------------------------------------------
30003  CONTINUE                                            ! TO FRASER SUZUKI
          WFLAG = 1
          LFLAG = 0
          SLU   = 0.00001
          NITER = 0
          SCAP  = 10.**15
          US    = 10.**10
          KPR1  = 0
          NRFR  = 0
          IF (POSFI.EQ.'Y' .AND. SIGFI.EQ.'Y') THEN
             CALL ELMRPF(IVX,IVY,VZ,KP,PA,D,PES,NCOM,BETA,
     2                   SQM,LFLAG,WEI,SIGP)
             KTP = 1
             KTS = 1
             DO 30103 K9 = 1,NCOM
                NONF(K9) = FLGCMP(K9)
30103        CONTINUE
             IF (LFLAG.EQ.0) THEN
                LFLAG = 1
             ENDIF
             NITER = 1

          ELSE
39803        CONTINUE
             IF (LFLAG.NE.0) GO TO 39903
39703           CONTINUE
                RTELOG = ABS(US).LE.SLU .OR. NITER.GE.TNIT .OR.
     2                   LFLAG.NE.0 
                IF (RTELOG) GO TO 39603
                   NITER = NITER+1
                   IF (MOF.EQ.'M') THEN
                      IF (NITER.LE.50.) THEN
                         D = 0.7
                      ELSE IF (NITER.GT.50. .AND. NITER.LE.80.) THEN
                         D = 0.3
                      ELSE
                         D = 0.7
                      END IF
                   END IF
                   PES(4) = 2
                   IF (NITER.LE.1.) PES(4)=.1
                   LG = 0
C
                   IF (SIGFI.EQ.'Y' .AND. SKYFI.EQ.'Y' .AND. 
     2                POSFI.NE.'Y') THEN
                      CALL ELMRF(IVX,IVY,VZ,KP,PA,D,PES,NCOM,BETA,
     2                           SQM,LFLAG,WEI,SIGP)
                      KTP = 0
                      KTS = 3

                   ELSE IF (SIGFI.EQ.'N' .AND. SKYFI.EQ.'Y' .AND.
     2                      POSFI.NE.'Y') THEN
                      CALL ELMRFV(IVX,IVY,VZ,KP,PA,D,PES,NCOM,BETA,
     2                            SQM,LFLAG,WEI,SIGP)
                      KTP = 0
                      KTS = 4

                   ELSE IF (SIGFI.EQ.'Y' .AND. TILT.EQ.'N' .AND.
     2                      POSFI.NE.'Y') THEN
                      CALL ELMRR(IVX,IVY,VZ,KP,PA,D,PES,NCOM,BETA,
     2                           SQM,LFLAG,WEI,SIGP)
                      KTP = 1
                      KTS = 3

                   ELSE IF (SIGFI.EQ.'Y' .AND. TILT.EQ.'Y' .AND. 
     2                      POSFI.NE.'Y') THEN
                      CALL ELMRX(IVX,IVY,VZ,KP,PA,D,PES,NCOM,BETA,
     2                            SQM,LFLAG,WEI,SIGP)
                      KTP = 3
                      KTS = 3

                   ELSE IF (SIGFI.EQ.'N' .AND. TILT.EQ.'N' .AND. 
     2                      POSFI.NE.'Y') THEN
                      CALL ELMRRV(IVX,IVY,VZ,KP,PA,D,PES,NCOM,BETA,
     2                            SQM,LFLAG,WEI,SIGP)
                      KTP = 1
                      KTS = 4

                   ELSE IF (SIGFI.EQ.'N' .AND. TILT.EQ.'Y' .AND.
     2                      POSFI.NE.'Y') THEN
                      CALL ELMRV(IVX,IVY,VZ,KP,PA,D,PES,NCOM,BETA,
     2                           SQM,LFLAG,WEI,SIGP)
                      KTP = 3
                      KTS = 4

                   ELSE IF(SIGFI.EQ.'N' .AND. POSFI.EQ.'Y') THEN
                      CALL ELMRPV(IVX,IVY,VZ,KP,PA,D,PES,NCOM,BETA,
     2                            SQM,LFLAG,WEI,SIGP)
                      KTP = 1
                      KTS = 2
                   END IF
C
                   IF (LFLAG.EQ.0) THEN
                      US   = (SCAP-SQM)/SQM
                      SCAP = SQM
                   END IF
C
                   ASSIGN 30017 TO CONPAR
                   GO TO 30007
30017              CONTINUE
                   GO TO 39703
39603           CONTINUE
C
                IF (NRFR.GT.0 .AND. LFLAG.EQ.0) THEN
                   NPSG  = 0
                   HGU   = 0
                   DO 30203 K3 = 1,NCP
                      IF (KFR(K3).GT.0) THEN
                         IND = K3*4
                         IF (P(IND).GT.HGU) THEN
                            HGU  = P(IND)
                            NPSG = K3
                         END IF
                      END IF
30203              CONTINUE

                   NRFR=NRFR-1
C ***                                                          !calcola code
                   IND=(NPSG-1)*4+5
                   DO 30303 K7=1,NCOM
                      K6=K7*4
                      ABC = ((PA(K6+1)-P(IND))**2 +
     2                      (PA(K6+2)-P(IND+1))**2)/PA(K6+3)**2
                      IF (ABS(BETA).LT.1.0E-30) THEN
                         ABC = PA(K6)*EXP(-ABC*4*ALOG(2.))
                      ELSE
                         ABC = PA(K6)*(1.+ABC)**(-BETA)
                      END IF
                      HGU = HGU-ABC
30303              CONTINUE
                   HGU = HGU+P(3)-PA(3)
                   WRITE (STRING,9031) NITER,NPSG
                   CALL STTPUT(STRING,ISTAT)
C
                   IF (HGU.GT.SOFOT) THEN
                      FLGCMP(NPSG) = 1
                      SLU          = 0.00001
                      NITER        = 0
                      SCAP         = 10.**15
                      US           = 10.**10
                      IND          = 1
                      IND2         = 0
C
                      IF (NPSG.LE.IND) GO TO 30503
                         IF (FLGCMP(IND).GE.1) IND2=IND2+1
                         IND = IND+1
30503                 CONTINUE
C
                      IF (IND2.LT.NCOM) THEN
                         DO 30603 LI = NCOM,IND2+1,-1
                            IND = LI*4
                            DO 30703 K3 = IND,IND+3
                               PA(K3+4) = PA(K3)
30703                       CONTINUE
30603                    CONTINUE
                      END IF
                      NCOM = NCOM+1
                      IND  = (IND2+1)*4
                      IND1 = NPSG*4
                      DO 30803 K3 = IND,IND+3
                         PA(K3) = P(IND1+K3-IND)
30803                 CONTINUE
                   ELSE
                      WRITE (STRING,9032)
                      CALL STTPUT(STRING,ISTAT)
                   END IF
                   KFR(NPSG)=-KFR(NPSG)
                ELSE
                   IF (LFLAG.EQ.0) THEN
                      LFLAG = 1
                   ENDIF
                ENDIF
                GO TO 39803
39903        CONTINUE
          END IF
       GO TO FRASUZ

C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C      Procedure RIPVET
C
C-------------------------------------------------------------------------------
30004  CONTINUE                                           !RIPRISTINA VETTORE
          DO 30104 LI=1,3
             P(LI)=PA(LI)
30104     CONTINUE
          IF (GR.NE.2) THEN
             IF (INME.EQ.'B'.OR.INME.EQ.'A') THEN
                RKN = 1./NNF
                NNF = NNF+1
                FON = (FON+PA(3)*RKN)/(1+RKN)
             END IF
          END IF
          NCO=0
          DO 30204 LI = 1,NCP
             IF (NONF(LI).GE.1) THEN
                IDE = (LI-1)*4+3
                NCO = NCO+1
                IDI = (NCO-1)*4+3
                IF (NONF(LI).EQ.1) THEN
                   KAS  = 1./KAL
                   KAL  = KAL+1
                   ALT1 = (ALT1+PA(IDI+1)/P(IDE+1)*KAS)/(1.+KAS)
                   DO 30304 LLI = 1,4
                      P(IDE+LLI) = PA(IDI+LLI)
30304              CONTINUE
                   IF (SIGFI.EQ.'N' .AND.
     2                (INME.EQ.'S'.OR.INME.EQ.'A')) THEN
                      RKN  = 1./NNS
                      NNS  = NNS+1
                      SIGG = (SIGG+PA(IDI+4)*RKN)/(1+RKN)
                   END IF
                END IF
             END IF
30204     CONTINUE
       GO TO RIPVET

C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C      Procedure CALINT
C
C-------------------------------------------------------------------------------
30005  CONTINUE                                        ! CALCOLA INTERQUARTILE
          IF (BETA.GT.0.0) BEBE=-1./BETA
C
          DO 30105 JIL = 1,NCP
             JIL4     = JIL*4 
             USC(JIL) = 0.
             USE(JIL) = 0.
             IF (FLGCMP(JIL).EQ.1) THEN
                SIGQ = P(JIL4+3)**2
                IF (ABS(BETA).LT.1.0E-30) THEN
                   ALAL = 4*ALOG(2.)
                   SMT  = AIN*EXP((1./SIGQ)*ALAL)
                   IF (P(JIL4).GE.SMT) THEN
                      RAG(JIL) = P(JIL4+3)**2*
     2                             (-ALOG(AIN/P(JIL4))/ALAL)
                   ELSE
                      RAG(JIL) = 1.0
                   END IF
                ELSE
                   BEBE = -1./BETA
                   SMT  = AIN*((1./SIGQ)+1.)**BETA
                   IF (P(JIL4).GE.SMT) THEN
                      RAG(JIL) = P(JIL4+3)**2*
     2                           ((AIN/P(JIL4))**BEBE-1.)
                   ELSE
                      RAG(JIL) = 1.0
                   END IF
                END IF
             END IF
30105     CONTINUE
C
          DO 30205 K7=1,NCP
             K74 = K7*4
             IF (FLGCMP(K7).EQ.1) THEN
                SQMS = 0.
                NPS  = 0
                DO 30305 IQ = 1,NCA
                   RM(IQ) = 0
30305           CONTINUE
                DO 30405 IQ=1,KP
                   DPS = (IVX(IQ)-P(K74+1))**2 +
     2                   (IVY(IQ)-P(K74+2))**2
                   IF (DPS.LE.RAG(K7) .AND. VZ(IQ).LT.SAT) THEN
                      NPS = NPS+1
                      VG  = P(3)
                      DO 30505 JQ = 1,NCP
                         JQ4 = JQ*4
                         IF (FLGCMP(JQ).EQ.1) THEN
                            GIG = P(JQ4+3)**2.
                            EEE = ((P(JQ4+1)-IVX(IQ))**2 +
     2                             (P(JQ4+2) - IVY(IQ))**2)/GIG
                            IF (ABS(BETA).LT.1.0E-30) THEN
                               VG = VG+P(JQ4)*EXP(-EEE*ALAL)
                            ELSE
                               VG = VG+P(JQ4)*(1.+EEE)**(-BETA)
                            END IF
                         END IF
30505                 CONTINUE
C
                      SQMS       = SQMS+(VZ(IQ)-VG)**2*WEI(IQ)
                      VALME(NPS) = (VZ(IQ)-VG)/SQRT(VG)
                   ENDIF
30405           CONTINUE
C
                DO 30705 IQ = 2,NPS
                   A = VALME(IQ)
                   DO 30605 JS = IQ-1,1,-1
                      IF (VALME(JS) .LE. A) THEN 
                         GO TO 31605
                      ELSE
                         VALME(JS+1) = VALME(JS)
                      ENDIF
30605              CONTINUE
                   JS = 0
31605              CONTINUE
                   VALME(JS+1) = A
30705           CONTINUE
C
                IRINT = FLOAT(NPS)/4. + 0.5
                RINTQ = VALME(IRINT*3)-VALME(IRINT)
C
                IF (NPS.LE.4) THEN
                   NPS = 5
                ENDIF
                SQMS = SQMS/FLOAT(NPS-4)
                IF (WE.NE.'N') THEN
                   SQMS = SQMS/P(K74)
                ENDIF
                IF (RINTQ.LT.0) THEN
                   RINTQ = 50
                ENDIF
                USC(K7) = SQMS
                USE(K7) = RINTQ
             END IF
30205     CONTINUE
       GO TO CALINT

C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C      Procedure AZZMA
C
C-------------------------------------------------------------------------------
30006  CONTINUE                                           !AZZERA MASCHERA
          DO 30106 LI=1,NHL
             ICB = (LI-1)*3
             L4  = AMAX1(1.,PB(ICB+3)-PB(ICB+1))
             L5  = AMIN1(FLOAT(NC),PB(ICB+3)+PB(ICB+1)+.99)
             L6  = AMAX1(1.,PB(ICB+2)-PB(ICB+1))
             L7  = AMIN1(FLOAT(NP),PB(ICB+2)+PB(ICB+1)+.99)
             DO 30206 L2 = L6,L7
                DO 30306 L3 = L4,L5
                   MASK(L3,L2) = 0
30306           CONTINUE
30206        CONTINUE
30106     CONTINUE
       GO TO AZZMAS

C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C      Procedure CONPAR
C
C-------------------------------------------------------------------------------
30007  CONTINUE                                          !CONTROLLA PARAMETRI
          IF(LFLAG.EQ.0) THEN
             KG   = 0
             IP   = 0
             IPA  = 0
             LFL2 = 0
             DO 30107 K3 = 1,NCOM
                IF (LFL2.EQ.0) THEN
                   IPA       = IPA+1
                   NONF(IPA) = FLGCMP(IPA)
30207              CONTINUE
                   IF (FLGCMP(IPA).NE.0 .OR. IPA.GE.NCP) THEN
                      GOTO 30307
                   ENDIF
                   IPA       = IPA+1
                   NONF(IPA) = FLGCMP(IPA)
                   GOTO 30207
30307              CONTINUE
                   INK1 = (IPA-1)*4
                   INK  = (K3-1)*4
                   IF (PA(INK+4).LT.0) THEN
                      WFLAG     = 2
                      LFLAG     = 2
                      NONF(IPA) = 3                      ! Altezza neagtive
                   END IF
                   IF (PA(INK+7).LT.0. .OR. PA(INK+7).GT.100.) THEN
                      WFLAG     = 2
                      LFLAG     = 2
                      NONF(IPA) = 5                       !Sigma errato
                   END IF
                   IF (PA(INK+4).GT.1.E10) THEN
                      WFLAG     = 2
                      LFLAG     = 2
                      NONF(IPA) = 3               !Alt. magg. di 10.000.000
                   END IF
                   DXY2 = (PA(INK+5) - P(INK1+5))**2 + 
     2                    (PA(INK+6) - P(INK1+6))**2
                   IF (DXY2.GT.PSAS) THEN
                      WFLAG     = 2
                      LFLAG     = 2
                      NONF(IPA) = 4              !La posizione del massimo
                   END IF                    !si e' spostata piu' di PSA pixels

                   IF (LFLAG.EQ.2) THEN
                      IF (KFR(IPA).EQ.0) THEN
                         NRFR        = NRFR+1
                         KFR(IPA)    = K3
                         FLGCMP(IPA) = 0
                         LFLAG       = 0
                         KPR1        = 1
                      ELSE
                         LFL2        = 1
                      END IF
                   END IF
                END IF
30107        CONTINUE
C
             IF (KPR1.EQ.1 .AND. LFL2.EQ.0) THEN
                IF (NRFR.GT.1) THEN
                   WRITE (STRING,9035) NRFR
                   CALL STTPUT(STRING,ISTAT)
                ELSE
                   STRING = 'No convergence on 1 star'
                   CALL STTPUT(STRING,ISTAT)
                ENDIF
C
                KPR1  = 0
                SLU   = 0.00001
                NITER = 0
                SCAP  = 10.**15
                US    = 10.**10
C
                ASSIGN 30018 TO PREVET                        ! #PREPARA VETTORE
                GO TO 30001
30018           CONTINUE

                IF (NCOM.LE.0) THEN
                   LFLAG = 2
                ENDIF
             ENDIF
          ELSE
             DO 30407 K3 = 1,NCOM
                FLGCMP(K3) = 6
                NONF(K3)   = 6
30407        CONTINUE 
          ENDIF
C
          IF (LFL2.EQ.1) THEN
             WFLAG = 2
             LFLAG = 2
             WRITE(STRING,9037)
             CALL STTPUT(STRING,ISTAT)
             DO 30408 K3 = 1,NCOM
                INK = (K3-1)*4
                WRITE(STRING,9036) K3,(PA(INK+JIL),JIL=4,7)
                CALL STTPUT(STRING,ISTAT)
30408        CONTINUE
          END IF
       GO TO CONPAR
       END

C @(#)rfotfind.for	19.1 (ES0-DMD) 02/25/03 13:30:14
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
       PROGRAM FIND
C+++
C.IDENTIFICATION: RFOTFIND
C.PURPOSE: Select objects from a displayed frame and put them into a
C.         catalogue table
C.AUTHOR:  R. Buonanno, G. Buscema, C. Corsi, I. Ferraro, G. Iannicola
C          Osservatorio Astronomico di Roma
C.VERSION: 870417 RXB First running version at ESO (outside MIDAS)o
C.         881031 RXB New version                                  
C.         890228 RHW Major changes for portable MIDAS   
C.                    load of frame done by LOAD/IMAGE
C.                    cursor interaction with GETCURS
C.VERSION: 900122 RHW IMPLICIT NONR added; all variables defined
C----
      IMPLICIT         NONE
C
C     INTEGER          AREA(4)
      INTEGER          CCOUNT,COOFF
      INTEGER          ED, EC, EL
      INTEGER          IVX(9)
      INTEGER          ICMP, IROW, IDUM
      INTEGER          INX, I, IT
      INTEGER          IAV, ICOM, IAC
      INTEGER          ISTAT,ISTAT1,ISTAT2
      INTEGER*8        IPNTR
      INTEGER          IMF
      INTEGER          ICATD2, ICATD3, ICATD6, ICATD7
      INTEGER          ICATD8, ICATD9, ICATD14, ICATD15
      INTEGER          J
      INTEGER          LX, LY
      INTEGER          LX1, LY1
      INTEGER          KL
      INTEGER          KUN, KNUL
      INTEGER          MADRID(1)
      INTEGER          NPIX(3)
      INTEGER          NAXIS, NPL,NL, NC
      INTEGER          NCCAT, NRCAT, NSCAT
      INTEGER          NARCAT, NACCAT
      INTEGER          NOBJ, NLIV
      INTEGER          NCH
      INTEGER          TIDCAT
      INTEGER          XY1, XY2
C
      DOUBLE PRECISION BEGIN(3),STEP(3), DDUM
C
      REAL             AL
      REAL             BB, B1
      REAL             FPIX1(2),FPIX2(2)
      REAL             FG, FO1
      REAL             H1
      REAL             PAR(4)
      REAL             PARS(4)
      REAL             RINPUT(4)
      REAL             RCATD4, RCATD5, RCATD10
      REAL             RCATD11, RCATD12, RCATD13
      REAL             RX(100),RY(100)
      REAL             RME, VME
      REAL             SQM, SQR, SL
      REAL             UU, U1
      REAL             VALUE1,VALUE2
      REAL             VET(100)
      REAL             VV
      REAL             WCO1(2),WCO2(2)
      REAL             X1, Y1

      CHARACTER*60     FRAME
      CHARACTER*72     CUNIT
      CHARACTER*80     IDENT
      CHARACTER*60     CATFIL
      CHARACTER*3      ACTION
      CHARACTER*80     STRING
      CHARACTER*60     CINPUT
      LOGICAL          NUL
C
      INCLUDE          'MID_INCLUDE:IDIDEV.INC'
      INCLUDE          'MID_INCLUDE:IDIMEM.INC'
      INCLUDE          'MID_INCLUDE:ST_DEF.INC'
      COMMON           /VMR/MADRID
      INCLUDE          'MID_INCLUDE:ST_DAT.INC'
C
      DATA             IVX/1,2,3,4,5,6,7,8,9/
C
 9001 FORMAT('*** INFO: Catalogue table already contains', I5,
     2       ' objects')
 9003 FORMAT('Enter identification., mag., col1 and col2: [', I6,
     2       ',0.0,0.0,0.0]: ')
C
C *** start the code
      CALL STSPRO('FIND')
      CALL DTOPEN(1,ISTAT)
C
C *** input parameters
      CALL STKRDC('IN_A',1,1,60,IAC,FRAME,KUN,KNUL,ISTAT)      ! name of image
      CALL STIGET(FRAME,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     2             2,NAXIS,NPIX,BEGIN,STEP,IDENT,CUNIT,IPNTR,IMF,ISTAT)
      NPL = NPIX(1)
      NL  = NPIX(2)
C
C *** get the intemediate file name
      CALL STKRDC('OUT_A',1,1,60,IAC,CATFIL,KUN,KNUL,ISTAT)   ! catalogue file
C
C *** open or create the calogue file table
      CALL STECNT('GET',EC,ED,EL)
      CALL STECNT('PUT',1,0,0)
      CALL TBTOPN(CATFIL,F_IO_MODE,TIDCAT,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** INFO: Catalogue table not present; '//
     2            'will create a new one ...'
         CALL STTPUT(STRING,ISTAT)
         CALL CATINI(CATFIL,TIDCAT)
         ICMP    = 0
         IROW    = 0
         ICATD2  = 0
         ICATD3  = 0
         RCATD4  = 0.0
         RCATD5  = 0.0
         ICATD6  = 0
         ICATD7  = 0
         ICATD8  = 0
         ICATD9  = 0
         RCATD10 = 0.0
         RCATD11 = 0.0
         RCATD12 = 0.0
         RCATD13 = 0.0
         ICATD14 = 0
         ICATD15 = 0

      ELSE
         CALL TBIGET(TIDCAT,NCCAT,NRCAT,NSCAT,NACCAT,NARCAT,ISTAT)
         IF (ISTAT.NE.0) THEN
            STRING = '*** FATAL: Problems with getting info for '//
     2               'catalogue table ...'
            CALL STTPUT(STRING,ISTAT)
            CALL STSEPI
         ENDIF
C
         IF (NRCAT.EQ.0) THEN
            STRING = '*** INFO: No points in the catalogue table'
            CALL STTPUT(STRING,ISTAT)
         ENDIF
C
C *** get the catalogue table parameters
         CALL CATDRD(TIDCAT,NOBJ,ICATD2,ICATD3,RCATD4,RCATD5,ICATD6,
     2                          ICATD7,ICATD8,ICATD9,RCATD10,RCATD11,
     3                          RCATD12,RCATD13,ICATD14,ICATD15)
         IROW = NRCAT
         WRITE(STRING,9001) NOBJ
         CALL STTPUT(STRING,ISTAT)
         CALL TBERDI(TIDCAT,NRCAT,1,ICMP,NUL,ISTAT)
      ENDIF
      CALL STECNT('PUT',EC,ED,EL)
C
C *** get the area
C     CALL STKRDC('INPUTC',1,1,40,IAC,STRING,KUN,KNUL,ISTAT)        ! user area
C     CALL EXTRCO(STRING,NAXIS,NPIX,BEGIN,STEP,NDUM,AREA(1),
C   2                   AREA(3),ISTAT)
C     IX0  = AREA(1)
C     IY0  = AREA(2)
C     NX   = AREA(3) - AREA(1) + 1
C     NY   = AREA(4) - AREA(2) + 1
C
C     IF (IX0.LT.1) IX0 = 1
C     IF (IY0.LT.1) IY0 = 1
C     IF ((IX0+NX-1).GT.NPL) NX = NPL-IX0+1
C     IF ((IY0+NY-1).GT.NL)  NY = NL-IY0+1
C     WRITE (STRING,9001) AREA(1),AREA(2),AREA(3),AREA(4)
C     CALL STTPUT(STRING,ISTAT)
C
C
C *** infinite loop for cursor interaction
      COOFF  = 0
      CCOUNT = 0
      ACTION = 'YYN'
      FRAME  = ' '
      CALL STTPUT('*** INFO: Use cursor control panel to '//
     2            'select object',ISTAT)

 1000 CONTINUE
      ICMP = ICMP + 1
 1001 CONTINUE
      CALL GETCUR(ACTION,FRAME,XY1,FPIX1,WCO1,VALUE1,ISTAT1,
     2                         XY2,FPIX2,WCO2,VALUE2,ISTAT2)
      IF (ISTAT1.EQ.0) THEN
         IF (CCOUNT.EQ.0) THEN
            IF (COOFF.EQ.1) THEN
               CALL DTCLOS(QDSPNO)
               CALL STSEPI
            ELSE
               CALL STTPUT('*** WARNING: Switch cursor on ...'//
     2                     ' next time we exit',ISTAT)
            ENDIF
            COOFF = 1
            GO TO 1001

         ELSE
            CALL CATDWR(TIDCAT,NOBJ,ICATD2,ICATD3,RCATD4,RCATD5,ICATD6,
     2                             ICATD7,ICATD8,ICATD9,RCATD10,RCATD11,
     3                             RCATD12,RCATD13,ICATD14,ICATD15)
            CALL TBSINI(TIDCAT,ISTAT)
            CALL TBTCLO(TIDCAT,ISTAT)
            CALL DTCLOS(QDSPNO)
            CALL STSEPI
         ENDIF

      ELSE
         CCOUNT = 1
         LX     = INT(FPIX1(1))
         LY     = INT(FPIX1(2))
C
C  *** fit data
         AL     = 4*ALOG(2.)
         NC     = 0
         DO 110 J = 1,9
            RX(J) = 0
            RY(J) = 0
  110    CONTINUE
C
         H1 = -10.E15
         DO 120 I = LY-4,LY+4
            NC  = NC+1
            INX = LX-4
            CALL REALIN(NPL,NL,I,INX,9,MADRID(IPNTR),VET)
            RME = 0
C
            DO 121 J=1,9
               H1  = AMAX1(H1,VET(J))
               RME = RME+VET(J)
               RX(J) = RX(J)+VET(J)
  121       CONTINUE
            RY(NC) = RME/9.
  120    CONTINUE
C
         PAR(1) = 0.
         PAR(4) = 10.E15
         DO 130 J = 1,9
            RX(J) = RX(J)/9.
            IF (RX(J).GT.PAR(1)) THEN
               PAR(1) = RX(J)
               PAR(2)=J
            END IF
            IF (RX(J).LT.PAR(4)) PAR(4)=RY(J)
  130    CONTINUE
C
         PAR(1) = PAR(1)-PAR(4)
         KL     = PAR(2)
         VME    = (RX(KL-1)+RX(KL+1))/2.
         IF (VME.GE.PAR(1)) VME=PAR(1)/2.
         PAR(3) = SQRT(AL/ALOG(PAR(1)/VME))
         SQR    = 10.**15
         SL     = SQR
         IT     = 0
         NLIV   = 9
C
         DO 140 J = 1,4
            PARS(J)=PAR(J)
  140    CONTINUE

 2001    CONTINUE
            IF (SL.LE.0.0001.OR.IT.GT.20) GO TO 2000
            IT = IT+1
            CALL MONO4(IVX,RX,NLIV,PAR,.7)
            IF (PAR(1).LT..1 .OR. ABS(PAR(2)-PARS(2)).GT.4 .OR.
     2         PAR(3).LE.0. .OR. PAR(3).GT.20.) THEN
               DO 150 J=1,4
                  PAR(J) = PARS(J)
  150          CONTINUE
               GO TO 2000
            ENDIF
C
            SQM = 0.
            DO 160  I = 1,NLIV
               FG  = PAR(1)*EXP(-4*ALOG(2.)*((I-PAR(2))/PAR(3))**2)
               SQM = SQM+(RX(I)-FG-PAR(4))**2
  160       CONTINUE
            SQM    = SQRT(SQM/NLIV)
            SL     = ABS(SQR-SQM)/SQR
            SQR    = SQM
           GO TO 2001
 2000    CONTINUE

         X1     = PAR(2)+LX-5
         FO1    = PAR(4)
C 
         PAR(1) = 0
         PAR(4) = 10.E15
         DO 170  J=1,9
            IF (RY(J).GT.PAR(1)) THEN
               PAR(1) = RY(J)
               PAR(2) = J
            END IF
            IF (RY(J).LT.PAR(4)) THEN
               PAR(4) = RY(J)
            ENDIF
  170    CONTINUE
C
         PAR(1) = PAR(1)-PAR(4)
         KL     = PAR(2)
         VME    = (RY(KL-1)+RY(KL+1))/2.
         IF (VME.GE.PAR(1)) VME = PAR(1)/2.
         PAR(3) = SQRT(AL/ALOG(PAR(1)/VME))
         SQR    = 10.**15
         SL     = SQR
         IT     = 0
         NLIV   = 9
C
         DO 180 J = 1,4
            PARS(J) = PAR(J)
  180    CONTINUE
C
 3001    CONTINUE
            IF (SL.LE.0.0001.OR.IT.GT.20) GO TO 3000
            IT = IT+1
            CALL MONO4(IVX,RY,NLIV,PAR,.7)
            IF (PAR(1).LT..1 .OR. ABS(PAR(2)-PARS(2)).GT.4 .OR. 
     2          PAR(3).LE.0. .OR. PAR(3).GT.20.) THEN
               DO 190 J = 1,4
                  PAR(J) = PARS(J)
  190          CONTINUE
               GO TO 3000
            END IF
C
            SQM = 0.
            DO 200 I = 1,NLIV
               FG = PAR(1)*EXP(-4*ALOG(2.)*((I-PAR(2))/PAR(3))**2)
               SQM = SQM+(RY(I)-FG-PAR(4))**2
  200       CONTINUE
C
            SQM = SQRT(SQM/NLIV)
            SL  = ABS(SQR-SQM)/SQR
            SQR = SQM
            GO TO 3001
 3000    CONTINUE
C
         Y1  = PAR(2)+LY-5
         FO1 = (FO1+PAR(4))/2.
         H1  = H1-FO1      
C
C *** legge magnitudine v , colori b-v e u-b e nome della
C     stella prescelta e li scrive sul file f
3002     CONTINUE
         WRITE (STRING,9003) ICMP
         NCH = INDEX(STRING,':')+1               
         CINPUT = ' '
         CALL STKPRC(STRING(1:NCH),'INPUTC',1,1,60,IAV,CINPUT,
     2               KUN,KNUL,ISTAT)
         ICOM   = MIN(INDEX(CINPUT,',')-1,6)
         IF (ICOM.LE.0) THEN
            VV    = 0.0
            BB    = 0.0
            UU    = 0.0
         ELSE
            ICMP = 4
            CALL GENCNV(CINPUT,2,ICMP,IDUM,RINPUT,DDUM,ISTAT)
C           CALL USRINP(RINPUT,4,'R',CINPUT)
C           ICMP = NEL(RINPUT,4)
            IF (ICMP.GT.0 .AND. ICMP.LT.4) THEN
               DO 3003 ICMP = ICMP+1, 4
                  RINPUT(ICMP) = 0.0
 3003          CONTINUE
            ENDIF
            ICMP    = INT(RINPUT(1))
            IF (ICMP.GT.99999) THEN
               CALL STTPUT('*** WARNING: Identification '//
     2                     'should be less than 100000; '//
     3                     'try again ...',ISTAT)
               GO TO 3002
            ELSE
               VV     = RINPUT(1)
               BB     = RINPUT(2)
               UU     = RINPUT(3)
            ENDIF
         ENDIF 
C
C *** prepare the arrays for writting
         IROW      = IROW + 1
         B1        = VV+BB
         U1        = B1+UU
         LX1       = BEGIN(1)+X1-1
         LY1       = BEGIN(2)+Y1-1
         NOBJ      = NOBJ+1
         CALL CATTWR(TIDCAT, IROW, ICMP, FLOAT(LX1), FLOAT(LY1),
     2                       H1, VV, B1, U1, 0.0, 0.0, 0.0, 0.0, 0.0,
     3                       0.0, 0.0)
         GO TO 1000
      ENDIF

      CALL STSEPI
      END

C @(#)necfilt.for	19.1 (ES0-DMD) 02/25/03 14:20:22
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
       PROGRAM ECHFILT
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  1 JUL 1989
C
C.LANGUAGE: F77+ESOext
C
C.IDENTIFICATION
C
C  Program ECHFILT
C
C  Otmar Stahl                     Landessternwarte Heidelberg
C  M Peron
C.KEYWORDS
C
C  ECHELLE, CASPEC, COSMIC RAY FILTER
C
C.PURPOSE
C
C  FILTER ECHELLE IMAGES FOR COSMIC RAY HITS AND OTHER DEFECTS. ORDER 
C  POSITIONS ARE DEFINED  BY COEFFICIENTS OF A REGRESSION. THE OFFSET 
C  IS DEFINED BY THE PARAMETER OFFSET.
C            
C
C.ALGORITHM
C   
C  TWO FILTERING METHODS ARE COMBINED: OUTSIDE THIS PROGRAM, THE RAW
C  DATA FRAME IS FILTERED WITH A STANDARD MEDIAN FILTER. THE BACKGROUND
C  IS DETERMINED ON THE FILTERED FRAME AND SUBTRACTED FROM BOTH FRAMES. 
C  BOTH THE UNFILTERED FRAME AND THE MEDIAN FILTERED FRAME ARE USED AS INPUT
C  FOR THIS PROGRAM. SINCE MEDIAN  FILTERING IS NOT GOOD CLOSE TO THE 
C  SPECTRAL ORDERS, THESE REGIONS ARE REPLACED (IN THE MEDIAN FILTERED
C  FRAME) WITH RAW DATA FILTERED THIS PROGRAM. THE METHOD MAKES USE OF
C  THE FACT, THAT IN ECHELLE FRAMES THE PROFILE PERPENDICULAR TO THE 
C  MAIN DISPERSION VARIES USALLY ONLY SLOWLY WITH WAVELENGTH. THIS 
C  PROFILE IS FOUND BY MEDIAN FILTERING A NUMBER OF  SPATIAL PROFILES
C  IN THE NEIGHBORHOOD. EACH INDIVIDUAL PROFILE IS THEN COMPARED PIXEL
C  BY PIXEL WITH THE MEDIAN PROFILE. OUTLIERS ABOVE A GIVEN THRESHOLD 
C  ARE DETECTED AND REMOVED BY REPLACING THEM WITH THE APPROPRIATE VALUE
C  FROM THE MEDIAN PROFILE. 
C
C
C  C.INPUT/OUTPUT
C
C  FILTER/ECHELLE output input widx,widy,no_iter ron,g,ethresh 
C                                             deg1,deg2 radx,rady,mthresh
C
C  IN_A               input frame
C  OUT_A               output frame 
C  INPUTI              wx,wy,iter
C  INPUTR              ron,g,ethresh
CC
C
C-----------------------------------------------------------


        IMPLICIT NONE
        INTEGER                I,IORD,IORD1,IORD2,NCOL,NROW,NOB
        INTEGER                INDX,NA,NPAR,ISTAT,ICOSM,NSORT,NOA
        INTEGER*8   PNTRA,PNTRB
        INTEGER                NDIM,NAXISA,STATUS,IDUMMY
        INTEGER                NPIXA(3), IPAR(10),JPAR(10),KUN,KNUL,IACT
        INTEGER                TID,ACOL,AROW,MASK,MADRID,MAXDIM
        PARAMETER              (NDIM = 3)
        CHARACTER*60              FRAMEIN, FRAMEOUT, INA1, INA2, TABLE
        CHARACTER*8               TYPE
        CHARACTER*9               NAME
        CHARACTER*60              TABLEFULL
        CHARACTER*1 DSC
        REAL                        RPAR(10)
        REAL                       PARAMS(12)
        DOUBLE PRECISION           DPAR(100)
        CHARACTER*72              INSTRUMA
        CHARACTER*64              CUNITA, DESNAM
        DOUBLE PRECISION          STARTA(3),STEPA(3)        
        INCLUDE 'MID_INCLUDE:TABLES.INC'
        COMMON /VMR/ MADRID(1)
        INCLUDE 'MID_INCLUDE:TABLED.INC'
        DATA MASK/3/
c
        CALL STSPRO('ECHFILT')
C
C  get input
C
        CALL STKRDC('IN_A', 1,1,60,IACT,INA1,KUN,KNUL,STATUS)
        CALL STKRDC('IN_B', 1,1,60,IACT,TABLE,KUN,KNUL,STATUS)
        CALL STKRDC('INPUTC', 1,1,9,IACT,NAME,KUN,KNUL,STATUS)
        CALL STKRDC('OUT_A',1,1,60,IACT,INA2,KUN,KNUL,STATUS)
        CALL STKRDI('INPUTI',1,3,IACT,JPAR,KUN,KNUL,STATUS)
        CALL STKRDR('INPUTR',1,3,IACT,RPAR,KUN,KNUL,STATUS)       
C
C CHECK WINDOW SIZE
C
        IF(JPAR(1).GT.21)      JPAR(1) = 21
        IF(JPAR(2).GT.21)      JPAR(2) = 21
        IF(JPAR(3).LE.JPAR(2)) JPAR(3) = JPAR(2)-1
C
       CALL CLNFRA(INA1,FRAMEIN,0)
       CALL CLNFRA(INA2,FRAMEOUT,0)
       MAXDIM = 3
       DSC = ' '
C
C  map input and output frame
C
      CALL STIGET(FRAMEIN,D_R4_FORMAT,F_IO_MODE,F_IMA_TYPE,MAXDIM,
     1    NAXISA,NPIXA,STARTA,STEPA,INSTRUMA,CUNITA,PNTRA,NOA,STATUS)
       CALL STIGET(FRAMEOUT,D_R4_FORMAT,F_IO_MODE,F_IMA_TYPE,MAXDIM,
     1   NAXISA,NPIXA,STARTA,STEPA,INSTRUMA,CUNITA,PNTRB,NOB,STATUS)

C  input parameters in table
C
       I = INDEX(TABLE,'.') 
       IF (I.EQ.0) THEN
         TABLE     = TABLE(1:59)//' '
         IDUMMY    = INDEX(TABLE,' ') - 1
         TABLEFULL = TABLE(1:IDUMMY)//'.tbl'
       ELSE
         TABLEFULL = TABLE
         TABLE     = TABLEFULL(1:I-1)
       ENDIF
       CALL TBTOPN(TABLE,F_IO_MODE,TID, STATUS)
        CALL TBIGET(TID,NCOL,NROW,NSORT,ACOL,AROW,STATUS) 
c
C  read coeffs
C
       NAME = NAME(1:8)//' '
       INDX = INDEX(NAME,' ')-1
       DESNAM = NAME(1:INDX)//'C'
        CALL STDRDC(TID,DESNAM,1,17,4,IACT,TYPE,KUN,KNUL,STATUS)
       TYPE = 'MULT'
       IF (TYPE.EQ.'MULT') THEN
         DESNAM = NAME(1:INDX)//'I'
          CALL STDRDI(TID,DESNAM,4,4,IACT,IPAR,KUN,KNUL,STATUS)
         NA = (IPAR(3)+1)*(IPAR(4)+1)
         DESNAM = NAME(1:INDX)//'R'
          CALL STDRDR(TID,DESNAM,1,4,IACT,PARAMS(4),KUN,KNUL,STATUS)
         DESNAM = NAME(1:INDX)//'D'
          CALL STDRDD(TID,DESNAM,1,NA,IACT,DPAR,KUN,KNUL,STATUS)
         CALL TBTCLO(TID, STATUS)
C
         IORD1 = PARAMS(6)
         IORD2 = PARAMS(7)
c
C  loop over the orders
C
         NPAR      = 10
         PARAMS(8) = IPAR(3)
         PARAMS(9) = IPAR(4)
          ICOSM     = 0
         DO 20 I = IORD1, IORD2
           PARAMS(10) = I 
           IORD = I - IORD1 + 1
           CALL EXTR(MADRID(PNTRA), NPIXA(1), NPIXA(2), 
     .      MADRID(PNTRB),IORD,NPAR,
     .      PARAMS,NA,DPAR,JPAR,RPAR,ICOSM) 
20     CONTINUE
       ELSE
         CALL STTPUT(' Error in dispersion coefficients ', ISTAT)
         GOTO 1000
       ENDIF
c
C
C  descriptor handling
C
       CALL STDCOP(NOA,NOB,MASK,DSC,STATUS)
C
C  free data
C
1000       CALL STSEPI
       END


       SUBROUTINE EXTR(IN,NPIXA1,NPIXA2,OUT,INDX,
     .  NPAR,PAR,ND,DPAR,JPAR,RPAR,ICOSM)
C
        IMPLICIT NONE
        INTEGER               JPAR(10),npixa1,npixa2,iwind,iwindh,nww
        INTEGER               iwidth,iter,iylim,k,l,ix1,ip,l1,k1,iy
        INTEGER               iy2,indx,icosm,ii,ixx,iyy,nd,npar,jj
        DOUBLE PRECISION      DPAR(ND)
        REAL                       OUT(NPIXA1,NPIXA2),PAR(NPAR)
        REAL                    SUBFR(21,21),FILT(21)
        REAL                       IN(NPIXA1,NPIXA2),RPAR(10)
        DOUBLE PRECISION           XVAL, YVAL, AX
        DOUBLE PRECISION           WIDTH,HWIDTH,OFFSET,DC
        DOUBLE PRECISION           YV,WW(50),SUM
       NWW = 50
C
C ... define extraction constants
C
        IWIND  = JPAR(1)
        IWIDTH = JPAR(2)
        ITER   = JPAR(3)
       WIDTH  = IWIDTH
       HWIDTH = 0.5*WIDTH
        IWINDH = IWIND/2
C
C       OFFSET = PAR(3) - HWIDTH + 1.
       OFFSET = PAR(3) - HWIDTH + 0.5
       IYLIM  = NPIXA2 - IWIDTH - 1
        ax     = 1.d0
C
C ... get ordinate values
C
       K     = PAR(8)
       L     = PAR(9)
       YV    = PAR(10)
C
C ... follow the order with the filter box
C
         DO IX1 = 1+IWINDH,NPIXA1-IWINDH
           IP  = 0
           DC  = 1.D0
           YVAL= 0.D0
            XVAL= ax
           DO L1 = 0, L
             IP = IP + 1
             WW(IP) = DC
             YVAL   = YVAL + WW(IP)*DPAR(IP)
             DO K1 = 1, K
               IP = IP + 1
               WW(IP) = WW(IP-1)*XVAL
               YVAL   = YVAL + WW(IP)*DPAR(IP)
             ENDDO
             DC = DC*YV
           ENDDO
            YVAL = YVAL + OFFSET
           SUM = 0.D0
C
            IY = YVAL
            IF (IY.GT.2 .AND. IY.LT.IYLIM) THEN
              IY2 = IY + IWIDTH
              IF(IY2.GT.2 .AND. IY2.LT.IYLIM) THEN
                DO II = 1,IWIND
                  IXX = IX1-IWINDH+(II-1)
                  DO JJ = 1,IWIDTH
                    IYY = IY+JJ-1
                    SUBFR(II,JJ) = IN(IXX,IYY)
                  ENDDO
                ENDDO
                CALL FILTER(SUBFR,FILT,JPAR,RPAR,ICOSM)
                DO JJ = 1,IWIDTH
                  IYY = IY+JJ-1
                  OUT(IX1,IYY) = filt(JJ)
                ENDDO
              ENDIF
            ENDIF
            AX = AX + 1.D0
c
         ENDDO
       RETURN
       END

      SUBROUTINE FILTER(SUBFR,Y,JPAR,RPAR,ICOSM)
C
      IMPLICIT NONE
      INTEGER         JPAR(10),ICOSM,IWIND,IWIDTH,ITER,J,K,IX,I,L,KK
      INTEGER*2       MASK(21)
      REAL            RPAR(10),RON,G,SIGMA,SIGMA2,V0
      REAL            SUBFR(21,21),VARI(21),PROF(21)
      REAL            SPEC(21),Y(21),X(21),XMED
      REAL            DIFF,DIFF2,QUOT,SUM,SUM1,SUM2,RMAX
C
      RON    = RPAR(1)
      G      = RPAR(2)
      SIGMA  = RPAR(3)
      IWIND  = JPAR(1)
      IWIDTH = JPAR(2)
      ITER   = JPAR(3)
      SIGMA2 = SIGMA*SIGMA
      V0     = RON**2/G**2
C
C SAVE COLUMN AT THE CENTER
C
      IX = IWIND/2 + 1
      DO I = 1,IWIDTH
        Y(I) = SUBFR(IX,I)
      ENDDO
C
C  EXTRACT INITIAL SPECTRUM (JUST THE SUM) AND SET mask TO 1
C
      DO J = 1,IWIND
        SUM = 0.
        DO K = 1,IWIDTH
          SUM = SUM+SUBFR(J,K)
        ENDDO
        SPEC(J) = SUM
        IF(SPEC(J).LT.1.) SPEC(J) = 1.
      ENDDO
C
      DO K = 1,IWIDTH
        MASK(K) = 1
      ENDDO
C
C COMPUTE SPATIAL PROFILE
C                                                 
      DO J = 1,IWIND
        DO K = 1,IWIDTH
          SUBFR(J,K) = SUBFR(J,K)/SPEC(J)
        ENDDO
      ENDDO 
c
      DO K = 1,IWIDTH
        DO J = 1,IWIND
          X(J) = SUBFR(J,K)
        ENDDO
C
C  MEDIAN FILTER OF ROWS
C
       CALL MDIAN1(X,IWIND,XMED)
       PROF(K) = XMED
       IF(PROF(K).LT.1.E-4) PROF(K)=1.E-4
      ENDDO
C
C NORMALIZE SPATIAL PROFILE AND ENFORCE POSITIVITY
C
      DO J = 1,IWIND
        SUM=0.
        DO K = 1,IWIDTH
          SUM = SUM+PROF(K)
        ENDDO
        DO K = 1,IWIDTH
          PROF(K) = PROF(K)/SUM
        ENDDO
      ENDDO 
C
c iterate (IN THE PRESENT VERSION, THE SPATIAL PROFILE IS NOT 
C ITERATED, BUT ONLY THE MASK AND THE VARIANCE)
c                                                                       
      DO L = 1,ITER                                                  
c                                                                       
c  compute variance estimate                 
C
        DO K = 1,IWIDTH 
          VARI(K) = V0 + ABS(SPEC(IX)*PROF(K))/G
        ENDDO
c                                                                       
c MASK COSMIC RAY HITS (ONLY ONE PER COLUMN AND ITERATION)
c
        RMAX = 1.
        KK = 0
        DO K = 1,IWIDTH
          DIFF = Y(K)-SPEC(IX)*PROF(K)
          DIFF2 = DIFF*DIFF
          QUOT = (DIFF2/(SIGMA2*VARI(K)))*MASK(K)
          IF(QUOT.GT.RMAX) THEN
            ICOSM = ICOSM+1
            RMAX = QUOT
            KK = K
          ENDIF
        ENDDO 
        IF(KK.NE.0) THEN
          MASK(KK) = 0
        ENDIF
C
C COMPUTE WEIGHTED MEAN WITH COSMICS MASKED
C
        SUM1 = 0.
        SUM2 = 0.            
        DO K = 1,IWIDTH
          SUM1 = SUM1 + MASK(K)*PROF(K)*Y(K)   /VARI(K)
          SUM2 = SUM2 + MASK(K)*PROF(K)*PROF(K)/VARI(K)
        ENDDO
        SPEC(IX) = SUM1/SUM2
      ENDDO
C
C FINALLY, REMOVE COSMICS
C
      DO K = 1,IWIDTH
        IF(MASK(K).EQ.0) THEN
          Y(K) = SPEC(IX)*PROF(K)
          ELSE 
          Y(K) = Y(K)
        ENDIF
      ENDDO      
c                                                                       
      RETURN
      END                                                           
C
C*************************************************************************
      SUBROUTINE MDIAN1(ARR,N,XMED)
C
      IMPLICIT NONE
      INTEGER      N,N2
      REAL         ARR(N),XMED
C
C  SORT DATA
C
      CALL SORT(N,ARR)
C
C  COMPUTE MEDIAN
C
      N2 = N/2
      IF(2*N2.EQ.N) THEN
        XMED = 0.5*(ARR(N2)+ARR(N2+1))
      ELSE
        XMED = ARR(N2+1)
      ENDIF
C
      RETURN
      END


      SUBROUTINE SORT(N,ARR)
C
      IMPLICIT NONE
      INTEGER       I,J,N
      REAL          ARR(N),A
C
      DO J = 2,N
        A = ARR(J)      
        DO I = J-1,1,-1
          IF(ARR(I).LE.A) GOTO 10
          ARR(I+1) = ARR(I)
        ENDDO
      I = 0
10    ARR(I+1) = A
      ENDDO
C
      RETURN
      END

C @(#)lda.for	19.1 (ES0-DMD) 02/25/03 13:27:14
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                       C
C  Carry out a LINEAR DISCRIMINANT ANALYSIS, assigning ungrouped items  C
C  to the closest group centre, using the Mahalanobis distance.         C
C                                                                       C
C                                                                       C
C  To call:   CALL LDA(N,M,DATA,GP,IPRINT,MEAN,MGP,TOTAL,DIFFVEC,       C
C                                W1,W2,IERR)     where                  C
C                                                                       C
C                                                                       C
C  N, M  : integer dimensions of ...                                    C
C  DATA  : input data (real).                                           C
C          On output the first column of DATA contains projections of   C
C          all N items on the line connecting the two group means.      C
C          Zero is the boundary point.                                  C
C  GP    : Integer vector of length N giving group assignments.  An     C
C          unassigned item has group 0.  Otherwise groups 1 and 2 will  C
C          be looked for, and other values here are not acceptable.     C
C  IPRINT: integer; print options (= 3: full; otherwise none).          C
C  MEAN  : real vector of length M (number of attributes or variables). C
C  MGP   : real array of dimensions 2 by M.                             C
C  TOTAL : real array of dimensions M by M; on output contains inverse  C
C          of total variance/covariance matrix.                         C
C  DIFFVEC: real vector of length M.                                    C
C  W1, W2: real vectors of length M.                                    C
C                                                                       C
C                                                                       C
C  Inputs here are N, M, DATA, GP, IPRINT (and IERR).                   C
C  The principle output information is contained in DATA.               C
C  IERR = 1 means that more than two groups have been specified; IERR   C
C  = 2 means that the total variance-covariance matrx was singular.     C
C                                                                       C
C  Note: we require N > M > 2, to prevent the seeking of the inverse    C
C        of a singular matrix.                                          C
C                                                                       C
C                                                                       C
C  F. Murtagh, ST-ECF/ESA/ESO, Garching-bei-Muenchen, January 1986.     C
C                                                                       C
C-----------------------------------------------------------------------C
        SUBROUTINE LDA(N,M,DATA,GP,IPRINT,MEAN,MGP,TOTAL,DIFFVEC,W1,W2,
     X                                                          IERR)
        REAL    DATA(N,M), TOTAL(M,M), MEAN(M), MGP(2,M), DIFFVEC(M)
        REAL    W1(M), W2(M),D
        INTEGER GP(N), NOG(2), G,IMAT
        INTEGER N,M,IPRINT,IERR,NEFF,I,J
        INTEGER K,J1,J2
C
C          Form global mean.
C
        IERR = 0
        NEFF = 0
        DO 50 I = 1, N
           IF (GP(I).NE.0) NEFF = NEFF + 1
           IF (GP(I).LE.2) GOTO 40
              IERR = 1
              GOTO 9000
   40   CONTINUE
   50   CONTINUE
C
        DO 200 J = 1, M
           MEAN(J) = 0.0
           DO 100 I = 1, N
              IF (GP(I).NE.0) MEAN(J) = MEAN(J) + DATA(I,J)
  100      CONTINUE
           MEAN(J) = MEAN(J)/FLOAT(NEFF)
  200   CONTINUE
C
C          Form (total) variance-covariance matrix.
C
        DO 500 J1 = 1, M
           DO 400 J2 = 1, M
              TOTAL(J1,J2) = 0.0
              DO 300 I = 1, N
                 IF (GP(I).NE.0) TOTAL(J1,J2) = TOTAL(J1,J2) +
     X              (DATA(I,J1)-MEAN(J1))*(DATA(I,J2)-MEAN(J2))
  300         CONTINUE
              TOTAL(J1,J2) = TOTAL(J1,J2)/FLOAT(NEFF)
  400      CONTINUE
  500   CONTINUE
C
        IMAT = 1
C        IF (IPRINT.EQ.3) CALL OUTMTL(IMAT,M,TOTAL)
C
C          Form group means.
C
        DO 700 J = 1, M
           DO 600 K = 1, 2
              MGP(K,J) = 0.0
  600      CONTINUE
  700   CONTINUE
C
        DO 900 I = 1, N
           G = GP(I)
           IF (G.EQ.0) GOTO 900
           NOG(G) = NOG(G) + 1
           DO 800 J = 1, M
              MGP(G,J) = MGP(G,J) + DATA(I,J)
  800      CONTINUE
  900   CONTINUE
C
        DO 1100 K = 1, 2
           DO 1000 J = 1, M
              MGP(K,J) = MGP(K,J)/NOG(K)
 1000      CONTINUE
 1100   CONTINUE
C
C          Invert variance-covariance matrix.
C
        CALL MINVL(M,TOTAL,D,W1,W2)
        IF (ABS(D).GT.0.00001) GOTO 1150
           IERR = 2
           GOTO 9000
 1150   CONTINUE
C
C          Form difference vector of group mean vectors.
C
        DO 1200 J = 1, M
           DIFFVEC(J) = MGP(1,J) - MGP(2,J)
           MEAN(J) = (MGP(1,J) + MGP(2,J))/2.
 1200   CONTINUE
C
C          Determine projections and output them.
C
        CALL PROJXL(N,M,DATA,MEAN,W1,TOTAL,DIFFVEC)
        IF (IPRINT.EQ.3) CALL OUTPXL(N,M,DATA)
C
C
C
 9000   CONTINUE
        RETURN
        END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                       C
C  Output a matrix.                                                     C
C                                                                       C
C-----------------------------------------------------------------------C
        SUBROUTINE OUTMTL(IMAT,M,ARRAY)
C
C          Output array.
C
        INTEGER IMAT,M,K1,K2
        REAL ARRAY(M,M)
C
C        IF (IMAT.EQ.1)WRITE (6,900)
        DO 100 K1 = 1, M
           WRITE (6,1000) (ARRAY(K1,K2),K2=1,M)
  100   CONTINUE
C
C   900   FORMAT(' VARIANCE/COVARIANCE MATRIX FOLLOWS.',/)
 1000   FORMAT(5(2X,F8.4))
        RETURN
        END
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                      C
C  Invert a symmetric matrix and calculate its determinant.            C
C                                                                      C
C                                                                      C
C  To call:      CALL MATINV(M,ARRAY,DET,W1,W2)   where                C
C                                                                      C
C                                                                      C
C  M       : dimension of ...                                          C
C  ARRAY   : input matrix which is replaced by its inverse.            C
C  NORDER  : degree of matrix (order of determinant)                   C
C  DET     : determinant of input matrix.                              C
C  W1, W2  : work vectors of dimension M.                              C
C                                                                      C
C                                                                      C
C  Reference: Philip B Bevington, "Data Reduction and Error Analysis   C
C             for the Physical Sciences", McGraw-Hill, New York, 1969, C
C             pp. 300-303.                                             C
C                                                                      C
C                                                                      C
C  F. Murtagh, ST-ECF, Garching-bei-Muenchen, January 1986.            C
C                                                                      C
C----------------------------------------------------------------------C
        SUBROUTINE MINVL(M,ARRAY,DET,IK,JK)
        INTEGER M,K,I,J,L
        REAL    ARRAY(M,M), IK(M), JK(M)
        REAL    DET,SAVE,AMAX
C
        DET = 1.0
        DO 100 K = 1, M
C       Find largest element ARRAY(I,J) in rest of matrix.
        AMAX = 0.0
   21      DO 30 I = K, M
              DO 30 J = K, M
                 IF (ABS(AMAX)-ABS(ARRAY(I,J))) 24,24,30
   24            AMAX = ARRAY(I,J)
                 IK(K) = I
                 JK(K) = J
   30      CONTINUE
C          Interchange rows and columns to put AMAX in ARRAY(K,K).
           IF (AMAX) 41,32,41
   32      DET = 0.0
           GOTO 140
   41      I = IK(K)
           IF (I-K) 21,51,43
   43      DO 50 J = 1, M
              SAVE = ARRAY(K,J)
              ARRAY(K,J) = ARRAY(I,J)
   50      ARRAY(I,J) = -SAVE
   51      J = JK(K)
           IF (J-K) 21,61,53
   53      DO 60 I = 1, M
              SAVE = ARRAY(I,K)
              ARRAY(I,K) = ARRAY(I,J)
   60      ARRAY(I,J) = -SAVE
C          Accumulate elements of inverse matrix.
   61      DO 70 I = 1, M
              IF (I-K) 63,70,63
   63         ARRAY(I,K) = -ARRAY(I,K)/AMAX
   70      CONTINUE
           DO 80 I = 1, M
              DO 80 J = 1, M
                 IF (I-K) 74,80,74
   74            IF (J-K) 75,80,75
   75            ARRAY(I,J) = ARRAY(I,J) + ARRAY(I,K)*ARRAY(K,J)
   80      CONTINUE
           DO 90 J = 1, M
              IF (J-K) 83,90,83
   83         ARRAY(K,J) = ARRAY(K,J)/AMAX
   90      CONTINUE
           ARRAY(K,K) = 1.0/AMAX
  100   DET = DET * AMAX
C       Restore ordering of matrix.
        DO 130 L = 1, M
           K = M - L + 1
           J = IK(K)
           IF (J-K) 111,111,105
  105      DO 110 I = 1, M
              SAVE = ARRAY(I,K)
              ARRAY(I,K) = -ARRAY(I,J)
  110      ARRAY(I,J) = SAVE
  111      I = JK(K)
           IF (I-K) 130,130,113
  113      DO 120 J = 1, M
              SAVE = ARRAY(K,J)
              ARRAY(K,J) = -ARRAY(I,J)
  120      ARRAY(I,J) = SAVE
  130   CONTINUE
  140   RETURN
        END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                       C
C  Output projections of row points.                                    C
C                                                                       C
C-----------------------------------------------------------------------C
        SUBROUTINE OUTPXL(N,M,PRJN)
        INTEGER N,M,NUM,K,J
        REAL    PRJN(N,M)
C
C
        NUM = 1
        WRITE (6,1000)
        WRITE (6,1010)
        WRITE (6,1020)
        DO 100 K = 1, N
           WRITE (6,1030) K,(PRJN(K,J),J=1,NUM)
  100   CONTINUE
C
 1000   FORMAT(1X,'PROJECTIONS OF ROW-POINTS FOLLOW.',/)
 1010   FORMAT(' OBJECT   PROJN')
 1020   FORMAT(' ------  ------')
 1030   FORMAT(I5,2X,F8.4)
        RETURN
        END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                       C
C  Form projections of row-points on factors.                           C
C                                                                       C
C-----------------------------------------------------------------------C
        SUBROUTINE PROJXL(N,M,DATA,MEAN,VEC,TOTINV,DIFF)
        INTEGER N,M,K,L,I,J1,NUM,J2
        REAL DATA(N,M),MEAN(M),VEC(M),TOTINV(M,M),DIFF(M)
C
        NUM = 1
        DO 300 K = 1, N
           DO 50 L = 1, M
              VEC(L) = DATA(K,L)
   50      CONTINUE
           DO 200 I = 1, NUM
              DATA(K,I) = 0.0
              DO 100 J1 = 1, M
                 DO 75 J2 = 1, M
                    DATA(K,I) = DATA(K,I) + (VEC(J1)-MEAN(J1))*
     X                          TOTINV(J1,J2)*DIFF(J2)
   75            CONTINUE
  100         CONTINUE
  200      CONTINUE
  300   CONTINUE
C
        RETURN
        END

C @(#)nrdist.for	19.1 (ES0-DMD) 02/25/03 13:25:36
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine NRDIST         version 1         820521
C  A. Kruszewski             ESO Garching
C  modified                  version 1.1       870303
C  A. Kruszewski             Obs. de Geneve
C.PURPOSE
C  finds for a particular object out of a list of "M" objects
C  a nearest other object
C.INPUT/OUTPUT
C  input arguments
C  L           integer*4         number of a considered object on a list
C  L0          integer*4         offset to catalog buffer
C  L1          integer*4         last object in catalog buffer
C  LDIS        integer*4         starting value
C  LSTP        integer*4 array   limits of regions
C  NREG        integer*4         number of regions
C  NCAT        integer*4 array   integer parameters of objects
C  PMTR        real*4 array      array holding positions of objects
C  PRCT        real*4 array      catalog of profiles
C  NP          integer*4         number of entries in buffers
C  output arguments
C  NCAT        integer*4 array   distance to the nearest other object
C                                is stored in NCAT(3,L)
C-----------------------------------------------------------------------
      SUBROUTINE NRDIST(L, L0, L1, LDIS, NREG, LSTP, NCAT, PMTR, PRCT)
C
      IMPLICIT  NONE
      INCLUDE  'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER   NREG
      INTEGER   L , L0 , L1 , LACT , LDIS , LSTP(0:4,0:NREG) , LTMP
      INTEGER   NCAT(NIPAR,MAXCNT) , NCT(NIPAR)
      REAL      PMTR(NRPAR,MAXCNT) , PRCT(0:MAXSUB,MAXCNT)
      REAL      PMT(NRPAR) , PRC(0:NRPAR)
      LOGICAL   DONE
C
      DONE = .TRUE.
      LTMP = 3 * LDIS
      LACT = 0
   10      CONTINUE
      IF ( .NOT. DONE ) GOTO 20
          CALL GETLST( L , L0 , L1 , LTMP , NREG , LSTP , NCAT ,
     &                  PMTR , PRCT , LACT , NCT , PMT , PRC , DONE )
          IF ( DONE ) THEN
            LTMP = NINT( SQRT( FLOAT( (NCAT(1,L)-NCAT(1,LACT))**2 +
     &                        (NCAT(2,L)-NCAT(2,LACT))**2 ) ) )
          ENDIF
          GOTO 10
   20      CONTINUE
      NCAT(3,L) = LTMP
C
      RETURN
C
      END

C @(#)normalize.for	19.1 (ESO-DMD) 02/25/03 13:31:23
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C.IDENTIFICATION: NORMALIZE
C.LANGUAGE:       F77+ESOext
C.AUTHOR:         O.-G. Richter
C.KEYWORDS:       bulk data frame, normalization, sky background
C.PURPOSE:        Normalizes an image calibrated to relative intensity to
C                 a sky background of 1.0
C.ALGORITHM:      Histogram of max. 5000 pixels is formed and MEAN, MODE and
C                 MEDIAN are computed. The third mode is taken to be
C                 the sky background. All pixels are now divided by
C                 this background value thereby normalizing the frame
C                 to a sky background 1.0.
C.INPUT/OUTPUT:   IN_A/C/1/60    input frame
C                 OUT_A/C/1/60   output frame - if omitted, input frame 
C                                will be updated
C                 INPUTR/R/1/2   truncation values (min,max),
C                                min > max indicates no truncation wanted
C                 INPUTR/R/3/4   control values for array CRMD
C.NOTE:           Resulting background will be displayed + stored into
C                 descriptor FLAT_SKY/R/1/1 and key OUTPUTR/R/11/4 as well
creation
C.VERSION:        830712 OGR creation
C.VERSION         870928 RHW ST interfaces
C.VERSION:        871123 RHW ESO-FORTRAN Conversion
C 
C 021031	last modif
C 
C -----------------------------------------------------------------------
      PROGRAM NRMLZ
C
      IMPLICIT    NONE
C
      INTEGER     MADRID
      INTEGER     IMF1,IMF2,IMF
      INTEGER     IAC,ISTAT,N
      INTEGER     NCHA,NCHB
      INTEGER     KUN(1),KNUL
      INTEGER     NAXIS,NPIX(2)
      INTEGER*8   PNTR1,PNTR2,IPNTR
C
      DOUBLE PRECISION START(2),STEP(2)
      REAL        BGRD(4),CRMD(4),CUTS(4),TRUNC(4)
C
      CHARACTER   FRAMEA*60,FRAMEB*60
      CHARACTER   CUNIT*48,IDENT*72,HIST*80,OUTPUT*80
C
      INCLUDE     'MID_INCLUDE:ST_DEF.INC/NOLIST'
      COMMON      /VMR/MADRID(1)
      INCLUDE     'MID_INCLUDE:ST_DAT.INC/NOLIST'
C
      DATA        HIST/' '/
 9000 FORMAT('background value = ',G15.7)
C
C *** begin code
      CALL STSPRO('NORMALIZE')                                    ! init MIDAS
C
C *** read keywords
      CALL STKRDC('IN_A',1,1,60,IAC,FRAMEA,KUN,KNUL,ISTAT)
      CALL STKRDC('OUT_A',1,1,60,IAC,FRAMEB,KUN,KNUL,ISTAT)
      CALL STKRDR('INPUTR',1,2,IAC,TRUNC,KUN,KNUL,ISTAT)
      CALL STKRDR('INPUTR',3,4,IAC,CRMD,KUN,KNUL,ISTAT)
C
      IF (FRAMEA.NE.FRAMEB) THEN
         CALL STIGET(FRAMEA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     2               2,NAXIS,NPIX,START,STEP,IDENT,CUNIT,
     +               PNTR1,IMF1,ISTAT)
         CALL STIPUT(FRAMEB,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     2               NAXIS,NPIX,START,STEP,IDENT,CUNIT,
     2               PNTR2,IMF2,ISTAT)
         CALL STDCOP(IMF1,IMF2,3,' ',ISTAT)
         CALL CPFRAM(MADRID(PNTR1),MADRID(PNTR2),NPIX(1),NPIX(2))         ! copy
         IMF    = IMF2
         IPNTR  = PNTR2

      ELSE                                      ! use input image frame directly
         CALL STIGET(FRAMEA,D_R4_FORMAT,F_IO_MODE,F_IMA_TYPE,
     2               2,NAXIS,NPIX,START,STEP,IDENT,CUNIT,
     +               IPNTR,IMF,ISTAT)
      END IF
C
      CALL NORMAL(MADRID(IPNTR),NPIX,CRMD,BGRD)                  ! now normalize
C
C *** display + store results
      WRITE (OUTPUT,9000) BGRD(1)
      CALL STTPUT(OUTPUT,ISTAT)
      NCHA = INDEX(FRAMEA,' ')-1
      NCHB = INDEX(FRAMEB,' ')-1
      HIST = FRAMEB(1:NCHB)//' = normalized('//FRAMEA(1:NCHA)//')'   ! app hist.
      CALL STDWRC(IMF,'HISTORY',1,HIST,-1,80,KUN,ISTAT)
      CALL STDWRR(IMF,'FLAT_SKY',BGRD,1,1,KUN,ISTAT)       ! backgrnd in keyword
      CALL STKWRR('OUTPUTR',BGRD,11,4,KUN,ISTAT)
      CALL STDRDR(IMF,'LHCUTS',1,4,IAC,CUTS,KUN,KNUL,ISTAT)
 
      DO 10 N = 1,4
         CUTS(N) = CUTS(N)/BGRD(1)
   10 CONTINUE
 
      IF (TRUNC(1).GE.TRUNC(2)) THEN
         CALL STDWRR(IMF,'LHCUTS',CUTS,1,4,KUN,ISTAT)
      ELSE
         CALL TRUNCY(MADRID(IPNTR),NPIX,TRUNC)
         CUTS(1) = MAX(CUTS(1),TRUNC(1))
         CUTS(2) = MAX(CUTS(2),TRUNC(2))
         CUTS(3) = MAX(CUTS(3),TRUNC(3))
         CUTS(4) = MAX(CUTS(4),TRUNC(4))
         CALL STDWRR(IMF,'LHCUTS',CUTS,1,4,KUN,ISTAT)
      ENDIF
C
      CALL STSEPI
      END

C @(#)fitnag.for	19.1 (ES0-DMD) 02/25/03 13:17:31
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FITNAG(ALGOR,ISTAT)                                           
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++        
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  21:29 - 20 DEC 1987                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: ECF                                                                   
C                                                                               
C.PURPOSE                                                                       
C       Interfaces the old MIDAS FIT module with yhe new one using NAG          
C       library.                                                                
C                                                                               
C.KEYWORDS                                                                      
C       NAG library, Non-linear Least Squares.                                  
C                                                                               
C.DESCRIPTION                                                                   
C       Detects if the problem is constrained and passes the control            
C       to the right module.                                                    
C                                                                               
C-----------------------------------------------------------------------        
C     ..                                                                        
C      IMPLICIT NONE                                                            
C     .. Scalar Arguments ..                                                    
      INTEGER ISTAT,STATUS,KUN,KNUL,K
      CHARACTER ALGOR* (*)                                                      
C     ..                                                                        
C     .. Local Scalars ..                                                       
      CHARACTER BNDKEY*10,BNDTYP*1                                    

C     ..                                                                        
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      INCLUDE 'MID_INCLUDE:FITNAGI.INC'
      INCLUDE 'MID_INCLUDE:FITNAGC.INC'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
      DATA BNDKEY(1:10)/'FITCHAR   '/                                           
C                                                                               
C   Get the boundary type in FITCHAR 14:14                                      
C                                                                               
      CALL STKRDC(BNDKEY,1,FZIBND,1,K,BNDTYP,KUN,KNUL,STATUS)     
C                                                                               
C   Chain to the right module                                                   
C                                                                               
      CALL UPCAS(BNDTYP,BNDTYP)
      IF (BNDTYP(1:1).EQ.'N') THEN                                              
          CALL FITUNC(ALGOR,ISTAT)                                             
                                                                                
      ELSE IF (BNDTYP(1:1).EQ.'I' .OR. BNDTYP(1:1).EQ.'P' .OR.                  
     +         BNDTYP(1:1).EQ.'G') THEN                                         
          CALL FITCON(ALGOR,BNDTYP,ISTAT)                                      
                                                                                
      ELSE                                                                      
          CALL STETER(12,'FIT/TABLE : Bounds type mismatch')                    
      END IF                                                                    
                                                                                
      RETURN                                                                    
                                                                                
      END                                                                       

C @(#)topertbl.for	19.1 (ES0-DMD) 02/25/03 14:11:57
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.2  ESO-FORTRAN Conversion, AA  14:17 - 19 NOV 1989
C  1.3   900404 KB
C 
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION:
C         PROGRAM TOPERTBL
C
C.PURPOSE
C
C Statistics and mathematical operations on tables. 
C Implements the commands:
C AVERAGE/TABLE			removed 900404  KB
C COMPUTE/REGRESSION
C COMPUTE/HISTOGRAM
C CONVERT/TABLE
C READ/HISTOGRAM
C REGRESS/LINE
C REGRESS/POLY
C REGRESS/TABLE
C SAVE/REGRESSION
C STATISTICS/TABLE, PLOT/HIST, OVER/HIST
C
C.KEYWORDS
C
C ARITHMETIC OPERATS, TABLES.
C
C.ALGORITHM
C
C USE TABLE INTERFACE ROUTINES
C
C-----------------------------------------------------------
C
      PROGRAM TOPER
      IMPLICIT NONE
      INTEGER     NCOM
      PARAMETER   (NCOM=14)
      INTEGER     I, KUN, KNUL, STAT
      CHARACTER*4 COMMAND,WS
      CHARACTER*4 COMTAB(NCOM)
C
      DATA COMTAB/'AVER','COMP','HIST','CONV',
     .            'CSPL','CMAP','LINE','POLY',
     .            'REGR','SAVE','STAT','READ',
     .            'PLOT','OVER'/
C
C ... GET INTO MIDAS
C
      CALL STSPRO('TOPERTBL')
C
C ... GET COMMAND FORM ENVIRONMENT
C
      CALL STKRDC('MID$CMND',1,1,4,I,COMMAND,KUN,KNUL,STAT)
      CALL FORUPC(COMMAND,WS)      
      IF (WS.EQ.'PRIN') WS = 'READ'
C
C ... SELECT THE ACTION
C
      DO 10 I = 1, NCOM
         IF (WS.EQ.COMTAB(I)) GOTO 20
   10 CONTINUE
      CALL STTPUT('Warning: command not found',STAT)
      GOTO 3000
C
C ... EXECUTE ACTION
C
   20 CONTINUE
      GOTO (100,200,300,400,500,600,700,800,900,1000,1100,1200,
     .      1100,1100),I
      CALL STTPUT('Warning: command not found',STAT)
      GOTO 3000
  100 CALL TDAVER
      GOTO 3000
  200 CALL TDCMPR      ! COMPUTE/REGRESSION
      GOTO 3000 
  300 CALL TDCMPH      ! COMPUTE/HISTOGRAM
      GOTO 3000
  400 CALL TDCONV      ! CONVERT/TABLE (spline 1)
      GOTO 3000
  500 CALL TDCSPL      ! CONVERT/TABLE (spline 2)
      GOTO 3000
  600 CALL TDCMAP      ! CONVERT/TABLE (map)
      GOTO 3000
  700 CALL TDREGL      ! REGRESSION/LINEAR
      GOTO 3000
  800 CALL TDREGP      ! REGRESSION/POLYNOMIAL
      GOTO 3000
  900 CALL TDREGT      ! REGRESSION/TABLE
      GOTO 3000
 1000 CALL TDSAVR      ! SAVE/REGRESSION
      GOTO 3000
 1100 CALL TDSTAT      ! STATISTICS/TABLE
      GOTO 3000
 1200 CALL TDSTAT      ! FIRST COMPUTE STATISTICS, THEN
      CALL TDRHIS      ! READ/HISTOGRAM
      GOTO 3000
C
C ... EXIT FROM MIDAS
C
 3000 CALL STSEPI
      END
C

C @(#)fsgrnt.for	19.1 (ES0-DMD) 02/25/03 13:25:34
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDNTIFICATION
C  subroutine FSGRNT         version 1.2       830920
C  A. Kruszewski             ESO Garching
C  modified                  version 1.3       870304
C  A. Kruszewski             Obs. de Geneve
C.KEYWORDS
C  profiles
C.PURPOSE
C  calculates corrections to a standard point spread function
C.ALGORYTHM
C  objects with relative gradient in limits from -0.05 to 0.05
C  are used for improving standart point spread function
C  this subroutine can work efficiently when input point spread
C  function and corresponding relative gradients are sufficiently
C  accurate
C.INPUT/OUTPUT
C  input parameters
C  PRCT        real*4 array      catalog of observed profiles
C  PMTR        real*4 array      objects' parameters
C  M           integer*4         number of catalogued objects
C  KSGR        integer*4         number of improved values of
C  HHCUT       real*4            upper limit of usable profile values
C  TRSH        real*4            limiting treshold
C  CRMD        real*4 array      control parameters for subroutine "MODE
C  SPRF        real*4 array      standard profile
C  output parameters
C  SPRF        real*4 array      standard profile
C-----------------------------------------------------------------------
      SUBROUTINE FSGRNT(L0, L1, LW, NREG, LSTP,
     &                      NP, NCAT, PMTR, PRCT, KSGR,
     &                      HHCUT, TRSH, UPGR, CRMD, SPRF)
C
      IMPLICIT  NONE
      INCLUDE   'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER   L0
      INTEGER   L1
      INTEGER   LW
      INTEGER   NREG
      INTEGER   LSTP(0:4,0:NREG)
      INTEGER   NP
      INTEGER   NCAT(NIPAR,NP)
      REAL      PMTR(NRPAR,NP)
      REAL      PRCT(0:MAXSUB,NP)
      INTEGER   KSGR
      REAL      HHCUT
      REAL      TRSH
      REAL      UPGR
      REAL      CRMD(3)
      REAL      SPRF(0:MAXSUB)
C
      INTEGER   L, LZ, LL
      INTEGER   K, KK, KKK
      INTEGER   IC
      INTEGER   M
      REAL      CINP(MPSF)
      REAL      CPRF(MPSF,0:MAXSUB)
      REAL      HHHC
      REAL      SIGMA
C     REAL      FCT(MAXSUB)
C
      HHHC = MIN( 5.0*TRSH , 0.05*HHCUT )
c      DO 10 K = 1 , 3
c          FCT(K) = 3.0 * HHHC
c   10 CONTINUE
c      DO 20 K = 4 , MAXSUB
c          FCT(K) = 10.0 * HHHC / FLOAT(K)
c   20 CONTINUE
      M = MAX ( L1 , LW )
      KK = 0
      DO 30 L = 1 , M
C          IF ( L .GT. L1 .OR. L .LE. L0 ) THEN
C              IOCOD = -1
C              CALL PARFIL( ISF , L , L0 , L1 , LW ,
C     &                     IOCOD , MARK , NCAT , PMTR , PRCT )
C              MARK = 0
C          ENDIF
          LZ = L - L0
C
C ***     Selects objects with proper values
C ***     of relative gradient PMTR(3,*).
C
          IF ( PRCT(0,LZ) .GT. HHHC .AND.
     &                 ABS( PMTR(3,LZ) ) .LT. UPGR ) THEN
C
C ***         Prepare array holding input data CPRF.
C
              IF ( KK .LT. MPSF) THEN
                  KK = KK + 1
                  DO 40 LL = 0 , KSGR
                      CPRF(KK,LL) = PRCT(LL,LZ)
   40             CONTINUE
              ENDIF
          ENDIF
   30 CONTINUE
C
C *** Improve standard profile.
C
      DO 50 L = 1 , KSGR
C
C ***     Put usable data into array CINP.
C
          KKK = 0
          DO 60 K = 1 , KK
              IF ( CPRF(K,L) .GT. 0.0 .AND.
     &                    CPRF(K,L) .LT. HHCUT ) THEN
                  IC = 0
                  LL = 0
   71             CONTINUE
                      IF ( IC .NE. 0 .OR. LL .GE. L ) GOTO 70
                      IF ( CPRF(K,LL) .LT. HHCUT ) THEN
                          IC = 1
                          KKK = KKK + 1
                          CINP(KKK) = LOG10( CPRF(K,LL) / CPRF(K,L) )
                          IF ( LL .GT. 0 ) THEN
                              CINP(KKK) = CINP(KKK)+SPRF(LL)
                          ENDIF
                      ELSE
                          LL=LL+1
                      ENDIF
                      GOTO 71
   70             CONTINUE
              ENDIF
   60     CONTINUE
C
C ***     Calculate improved values of standard profile.
C
          IF ( KKK .GT. 2 ) THEN
              CALL MODE( CINP , KKK , CRMD , SPRF(L) , SIGMA )
          ELSE IF ( KKK .EQ. 2 ) THEN
              SPRF(L) = 0.5*CINP(1) + 0.5*CINP(2)
          ELSE IF ( KKK .EQ. 1 ) THEN
              SPRF(L) = CINP(1)
          ENDIF
   50 CONTINUE
C
      RETURN
C
      END
C

C @(#)nstar.for	19.1 (ES0-DMD) 02/25/03 13:23:50
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE  NSTAR  (PAR, MAXPAR, PSF, MAXPSF, MAXEXP, DATA, 
     .     NCOL, NROW, WATCH, FITRAD, E1, E2)
C
C=======================================================================
C
C Photometry for many stars by simultaneous multiple PSF fits.
C
C              OFFICIAL DAO VERSION:  1991 April 18
C
C Currently operates on a picture no larger than 640 X 1024 pixels 
C total, regardless of format, and no more than 60 stars at a time.  
C The latter restriction may be altered by changing the first 
C parameter.
C
C Arguments:
C
C  FITRAD (INPUT) is the fitting radius specified as a user-definable 
C         option.  It governs how many pixels out from the centroid of
C         the star will actually be considered in computing the least-
C         squares profile fits.
C
C   WATCH (INPUT) is the 'watch progress' parameter specified by the
C         user.  If WATCH > 0, information relating to the progress of
C         the reductions will be typed on the terminal during execution.
C
C=======================================================================
C
      IMPLICIT NONE
      INTEGER MAXSTR, MAXEXP, MAXPSF, MAXPAR, NCOL, NROW
      PARAMETER  (MAXSTR=60)
C
C Parameters:
C
C MAXSTR The maximum number of stars in a single group.  This parameter
C        is determined primarily by the execution time per iteration--
C        at MAXSTR=60, our VAX 11/780 takes around 2.5 CPU minutes per 
C        iteration.  For MAXSTR > 150 or so, the accuracy of inverting 
C        the REAL*4 design matrix would also begin to suffer.
C
C MAXPSF the largest PSF look-up table that can be accomodated.  If
C        MAXRAD is the largest acceptable PSF radius, then
C        MAXPSF = 2*[2*(MAXRAD+1)]+7.
C
      REAL DATA(NCOL,NROW), PSF(MAXPSF,MAXPSF,MAXEXP)
      REAL PAR(MAXPAR)
      REAL C(3*MAXSTR+1,3*MAXSTR+1), V(3*MAXSTR+1)
      REAL XC(MAXSTR+1), YC(MAXSTR+1), MAG(MAXSTR+1), RPIXSQ(MAXSTR)
      REAL SKY(MAXSTR+1), CHI(MAXSTR+1), SUMWT(MAXSTR+1)
      REAL NUMER(MAXSTR+1), DENOM(MAXSTR+1), SHARP(MAXSTR+1)
      REAL MAGERR(MAXSTR+1)
      REAL CLAMP(3*MAXSTR+1), XOLD(3*MAXSTR+1), X(3*MAXSTR+1)
      INTEGER ID(MAXSTR+1), NPIX(MAXSTR), RDPSF
      LOGICAL SKIP(MAXSTR)
C
      REAL AMIN1, AMAX1, ABS, SQRT, USEPSF
      INTEGER MIN0, MAX0
C
      CHARACTER*80 LINE
      CHARACTER*30 COOFIL, MAGFIL, PSFFIL, FITFIL, GRPFIL, SWITCH,
     .     EXTEND
      CHARACTER CASE*4
      REAL LOBAD, DF, DX, DY, ERR, PSFMAG, BRIGHT, XPSF, YPSF
      REAL SEPCRIT, PSFRAD, RADIUS, THRESH, AP1, PHPADU, RONOIS
      REAL DUM, CUTOFF, RADSQ, SUMSKY, CHIGRP, HIBAD, SEPMIN
      REAL PSFRSQ, SKYBAR, WCRIT, XMIN, XMAX, YMIN, YMAX, SEP
      REAL SUMGRP, GRPWT, D, WT, DELTAX, DELTAY, VAL, DVDXC, DVDYC
      REAL RSQ, DPOS, RELERR, SIGSQ, RHOSQ, DWT, WATCH, FITRAD, E1, E2
      REAL PERERR, PKERR, DFDSIG, FAINT
      INTEGER I, J, K, IPSTYP, NPSF, NPAR, NEXP, NFRAC, NL, NTOT, NSTR
      INTEGER IX, IY, I3, I3M2, LX, LY, L, NI, IFAINT
      INTEGER NITER, NTERM, ISTAT, IDUM, IXMIN, IXMAX, IYMIN, IYMAX
      INTEGER MAXUNK
      LOGICAL OMIT, REDO, CLIP
      COMMON /FILNAM/ COOFIL, MAGFIL, PSFFIL, FITFIL, GRPFIL
C
C-----------------------------------------------------------------------
C
C SECTION 1
C
C Get ready, get set, . . .
C
      MAXUNK=MAXSTR*3+1            ! Largest possible number of unknowns
      CALL TBLANK                  ! Type a blank line
C
C Read the entire picture into memory.
C
      LX=1
      LY=1
      CALL RDARAY ('DATA', LX, LY, NCOL, NROW, NCOL, DATA, ISTAT)
      IF (ISTAT .NE. 0) GO TO 9100                 ! Error reading image
C
C Read the point-spread function into memory.
C
  940 CALL GETNAM ('File with the PSF:', PSFFIL)
      IF ((PSFFIL .EQ. 'END OF FILE') .OR.
     .     (PSFFIL .EQ. 'GIVE UP')) THEN
         PSFFIL = ' '
         RETURN
      END IF
C
      PSFFIL = EXTEND(PSFFIL, CASE('psf'))
      ISTAT = RDPSF (PSFFIL, IPSTYP, PAR, MAXPAR, NPAR,
     .     PSF, MAXPSF, MAXEXP, NPSF, NEXP, NFRAC,
     .     PSFMAG, BRIGHT, XPSF, YPSF)
      IF (ISTAT .NE. 0) THEN
         PSFFIL = 'GIVE UP'
         GO TO 940
      END IF
      PERERR = 0.01 * E1
      PKERR = 0.01 * E1 / (PAR(1)*PAR(2))**2
C
C Stars will be checked for merger if they are separated by less than
C 1 FWHM of the image core.
C
C     Crit. sep. = 2.355*sigma, where
C          sigma = SQRT [ (sigma(X)**2 + sigma(Y)**2)/2 ]
C
C Use the quadratic mean of PAR(1) and PAR(2) as the HWHM.
C
      SEPCRIT=2.*(PAR(1)**2+PAR(2)**2)
C
C SEPCRIT contains the square of the critical separation.
C
      SEPMIN = 0.14*SEPCRIT
C
      PSFRAD = (REAL(NPSF-1)/2. - 1.)/2.
      PSFRSQ = PSFRAD**2
      RADIUS = AMIN1(FITRAD, PSFRAD)
C
C Ascertain the name of the file with the stellar groups, and open it.
C
      CALL GETNAM ('File with stellar groups:', GRPFIL)
      IF (GRPFIL .EQ. 'END OF FILE') RETURN        ! CTRL-Z was entered
C
      CALL INFILE (2, GRPFIL, ISTAT)
      IF (ISTAT .LT. 0) GO TO 9300                  ! Error opening file
C
      CALL RDHEAD (2, NL, IDUM, IDUM, LOBAD, HIBAD, THRESH, AP1, 
     .     PHPADU, RONOIS, DUM)
      IF (NL .NE. 3) GO TO 9200                       ! Not a group file
C
C Inquire the name of the output file, and open it.
C
      FITFIL=SWITCH(GRPFIL, CASE('.nst'))
  980 CALL GETNAM ('File for results:', FITFIL)
      IF ((FITFIL .EQ. 'END OF FILE') .OR.
     .     (FITFIL .EQ. 'GIVE UP')) THEN
         CALL CLFILE (2)
         FITFIL = ' '
         RETURN
      END IF
C
      CALL OUTFIL (1, FITFIL, ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error opening output file '//FITFIL)
         FITFIL = 'GIVE UP'
         GO TO 980
      END IF
C
      CALL WRHEAD (1, 1, NCOL, NROW, 7, LOBAD, HIBAD, THRESH, AP1, 
     .     PHPADU, RONOIS, RADIUS)
C
C Get ready to go.
C
      RONOIS=RONOIS**2
      CALL TBLANK                                   ! Type a blank line
      IF (WATCH .GT. 0.5) THEN
         WRITE (6,610)
  610    FORMAT (/' It = number of iterations for current group',
     .          //' n* = number of stars in current group',
     .          //' N* = number of stars up through current group'
     .         //)
         CALL OVRWRT ('    It   n*   N*  ', 1)
      END IF
      RADSQ=RADIUS**2
      CUTOFF=0.999998*RADSQ
      NTOT=0
C
C-----------------------------------------------------------------------
C
C SECTION 2
C
C GO.
C
C Loop over stellar groups.
C
 2000 IF (WATCH .GT. 0.5) CALL TBLANK
      I=0
      SUMSKY=0.
C
C Read in the next group of stars.
C
 2010 I=I+1
      CALL RDSTAR (2, 3, ID(I), XC(I), YC(I), MAG(I), SKY(I))
      IF (ID(I) .LT. 0) GO TO 2100        ! End-of-file was encountered
      IF (ID(I) .EQ. 0) GO TO 2110        ! A blank line was encountered
      IF (I .GT. MAXSTR) GO TO 2020       ! Too many stars in the group
C
C A single sky brightness value, equal to the arithmetic mean of the
C skies determined for the individual stars, will be used for the
C group as a whole.  (In its present form NSTAR leaves this group sky
C value a constant.  It could in principle be determined as a fitting
C parameter along with the stellar positions and magnitudes.  My
C experiments along this line have been disappointing, but if you want
C to try it, include in the code those lines flagged with 'If sky
C is to be determined'.)
C
      SUMSKY=SUMSKY+SKY(I)
C
C Convert magnitude to brightness, scaled relative to the PSF.
C
      MAG(I)=10.**(-0.4*(MAG(I)-PSFMAG))
C
C If PHOTOMETRY was unable to obtain a magnitude for the star (Mag. =
C 99.999), NSTAR will give it the old university attempt anyway.
C
      IF (MAG(I) .LE. 1.E-4) MAG(I)=0.01
      MAGERR(I)=0.0
      SHARP(I)=0.0
      GO TO 2010
C
C The group is too large.  Type out a message, keep reading until
C a blank line is encountered, and then go back and start a completely
C new group.
C
 2020 WRITE (6,620) 7, MAXSTR
  620 FORMAT (' Group with more than ', A1, I2, ' stars.')
 2030 CALL RDSTAR (2, 3, I, DUM, DUM, DUM, DUM)
      IF (I .LT. 0) GO TO 9000
      IF (I .NE. 0) GO TO 2030
      GO TO 2000
C
C Either a blank line or the EOF has been encountered.  If at least one
C real star has been read in since the last blank line, reduce the 
C group.  If it is a blank line and no star has been read in, go back 
C and read in a new group (in case in editing the file, the user has 
C clumsily left several blank lines in a row).  If it is the EOF and 
C no star has been read in, return.
C
 2100 IF (I .EQ. 1) GO TO 9000
 2110 IF (I .EQ. 1) GO TO 2000
      NSTR=I-1                         ! Number of stars in the group
      NTOT=NTOT+NSTR                   ! Number of stars reduced to date
      SKYBAR=SUMSKY/NSTR               ! Mean sky value for group
C
C Start reducing the group.
C
      NTERM=3*NSTR
C
C If sky is to be determined: NTERM=NTERM+1
C
C Initialize accumulators and constraints on parameter corrections.
C
      CHIGRP=1.0
      NITER=0
      CLIP=.FALSE.
      DO 2120 I=1,NTERM
      XOLD(I)=0.0
 2120 CLAMP(I)=1.0
C
C Update information on screen.
C
      IF (WATCH .GT. 0.5) THEN
         WRITE (LINE,622) NITER, NSTR, NTOT
         CALL OVRWRT (LINE(1:15), 2)
      END IF
C
C Begin to iterate solution here.
C
 2200 NITER=NITER+1
 2210 IF (WATCH .GT. 0.5) THEN
         WRITE (LINE,622) NITER, NSTR, NTOT
  622    FORMAT (3I5)
         CALL OVRWRT (LINE(1:15), 2)
      END IF
C
C Set up critical error for star rejection.
C
      WCRIT = 1.E38
      IF (NITER .GE. 5) WCRIT = 1.0
      IF (NITER .GE. 10) WCRIT = 0.66667
      IF (NITER .GE. 15) WCRIT = 0.5
C If sky is to be determined: X(NTERM)=-1.0
C
C If there is more than one star, check to see whether any two stars 
C have merged.  Meanwhile, determine the upper and lower limits in x 
C and y of a rectangular box containing the centroids of all stars, and
C initialize a couple of accumulators.
C
      XMIN=NCOL
      XMAX=1.
      YMIN=NROW
      YMAX=1.
C
      DO 2230 I=1,NSTR
      CHI(I)=0.
      SUMWT(I)=0.
      NUMER(I)=0.
      DENOM(I)=0.
      XMIN=AMIN1(XMIN, XC(I))
      XMAX=AMAX1(XMAX, XC(I))
      YMIN=AMIN1(YMIN, YC(I))
      YMAX=AMAX1(YMAX, YC(I))
      IF (NSTR .EQ. 1) GO TO 2230
C
      DO 2220 J=1,I-1
      SEP=(XC(I)-XC(J))**2+(YC(I)-YC(J))**2
      IF (SEP .GT. SEPCRIT) GO TO 2220
C
C Two stars are overlapping.  Identify the fainter of the two.
C
      K=J
      IF (MAG(I) .LT. MAG(J)) K=I
      IF ((SEP .LT. SEPMIN) .OR. 
     .     (MAGERR(K)/MAG(K) .GT. WCRIT)) GO TO 2240
 2220 CONTINUE
C
 2230 CONTINUE
C
C No two stars have merged.
C
      GO TO 2260
 2240 CONTINUE
C
C Now eliminate the fainter of the two.
C
      IF (MAG(I) .LT. MAG(J)) I=J
C
C The K-th star is now the fainter of the two, the I-th, the brighter.
C
      IF (WATCH .GT. 0.5) THEN
         WRITE (LINE,623) NITER, NSTR, NTOT, ID(K), ID(I)
  623    FORMAT (3I5, 5X, 'Star', I6, ' merged with star', I6,
     .     ', so it''s been deleted.')
         CALL OVRWRT (LINE(1:76), 3)
      END IF
C
C Now replace the centroid of the I-th star with the weighted mean of
C the most recent estimates of the centroids of the I-th and K-th
C stars, and the brightness of the I-th with the sum of the brightnesses
C of the I-th and K-th.
C
      XC(I)=XC(I)*MAG(I)+XC(K)*MAG(K)
      YC(I)=YC(I)*MAG(I)+YC(K)*MAG(K)
      MAG(I)=MAG(I)+MAG(K)
      XC(I)=XC(I)/MAG(I)
      YC(I)=YC(I)/MAG(I)
C
C Remove the K-th star from the group.
C
      CALL DAORMV (K, MAXSTR, NSTR, ID, XC, YC, MAG, SKY)
      NTOT=NTOT-1
      IF (WATCH .GT. 0.5) THEN
         WRITE (LINE,622) NITER-1, NSTR, NTOT
         CALL OVRWRT (LINE(1:15), 2)
      END IF
      NTERM=NSTR*3
C     If sky is to be determined: NTERM=NTERM+1
C
C After deleting a star, release all the clamps and back up the 
C iteration counter before doing another iteration.
C
      DO 2250 I=1,NTERM
      XOLD(I)=0.0
 2250 CLAMP(I)=1.0
      CLIP=.FALSE.
      NITER=MAX0(1, NITER-1)
      GO TO 2210
C
C Now... on with the iteration.
C
 2260 IXMIN=MAX0(1, INT(XMIN-RADIUS)+1)
      IXMAX=MIN0(NCOL, INT(XMAX+RADIUS))
      IYMIN=MAX0(1, INT(YMIN-RADIUS)+1)
      IYMAX=MIN0(NROW, INT(YMAX+RADIUS))
C
C IXMIN, IXMAX, IYMIN, and IYMAX are now the limits of a rectangular 
C containing all pixels within one fitting radius of any star in the
C group.
C
C Zero the normal matrix and the vector of residuals.
C
      DO 2270 J=1,NTERM
      V(J)=0.0
      DO 2270 I=J,NTERM
 2270 C(I,J)=0.0
C
      DO 2280 I=1,NSTR
 2280 NPIX(I)=0
C
C Now deal with the pixels one by one.
C
      SUMGRP=0.
      GRPWT=0.
      DO 2390 IY=IYMIN,IYMAX
      DO 2380 IX=IXMIN,IXMAX
      IF ((DATA(IX,IY) .LT. LOBAD) .OR. (DATA(IX,IY) .GT. HIBAD))
     .     GO TO 2380
C
C If this pixel is within one fitting radius of at least one star,
C include it in the solution.  Otherwise, skip it.  While figuring
C this out, compute the squared distance of this pixel from the
C centroid of each star in the group; make sure that every star
C has at least four valid pixels within one fitting radius.
C
      OMIT=.TRUE.
      DO 2310 I=1,NSTR
      SKIP(I)=.TRUE.
      RPIXSQ(I)=(FLOAT(IX)-XC(I))**2+(FLOAT(IY)-YC(I))**2
      IF (RPIXSQ(I) .GT. CUTOFF) GO TO 2310
      SKIP(I)=.FALSE.
      NPIX(I)=NPIX(I)+1
      OMIT=.FALSE.
 2310 CONTINUE
      IF (OMIT) GO TO 2380
C
      D=DATA(IX,IY)-SKYBAR
      WT=0.
C
C Now loop over the stars, one by one, subtracting from this pixel
C the light contribution from each star within one PSF radius.
C
      DO 2320 I=1,NSTR
      DELTAX=(XC(I)-1.)/XPSF-1.
      DELTAY=(YC(I)-1.)/YPSF-1.
C
C If this pixel is within one PSF radius of this star's center, compute 
C the scaled value of the PSF at this point and subtract it.
C
      IF (RPIXSQ(I) .GE. PSFRSQ) GO TO 2320
      VAL=USEPSF(IPSTYP, FLOAT(IX)-XC(I), FLOAT(IY)-YC(I), BRIGHT, PAR, 
     .     PSF, NPSF, NPAR, NEXP, NFRAC, DELTAX, DELTAY, DVDXC, DVDYC)
      D=D-MAG(I)*VAL
C
C The condition equation for pixel (IX,IY) is of the form
C
C data(IX,IY)-sky-summation{scale*psf(IX-Xcenter,IY-Ycenter)}=residual
C
C Then we will jigger the scale's, Xcenter's, and Ycenter's such that
C
C                Summation{weight * residual**2}
C
C is minimized.  'weight' will be a function (1) of the distance of this
C pixel from the center of the nearest star, (2) of the model-predicted
C brightness of the pixel (taking into consideration the readout noise, 
C the photons/ADU, and the interpolation error of the PSF), and (3) of 
C the size of the residual itself.  (1) is necessary to prevent the
C non-linear least-squares solution from oscillating:  oft-times it will
C come to pass that if you include a pixel in the solution, then the
C predicted shift of the centroid will cause that pixel to be excluded 
C in the next iteration, and the new predicted shift of the centroid
C will cause that pixel to be included again.  This could go on ad
C infinitum.  The cure is to have the weight of a pixel go 
C asymptotically to zero as its distance from the stellar centroid
C approaches the fitting radius.  In a case like that just described,
C the solution can then find a real minimum of the sum of the
C weighted squared residuals with that pixel at some low-weight position
C just inside the fitting radius.  (2) is just sensible weighting.
C (3) is just a crude attempt at making the solution more robust against
C bad pixels.
C
      IF (SKIP(I)) GO TO 2320
      RSQ=RPIXSQ(I)/RADSQ
      WT=AMAX1(WT, 5./(5.+RSQ/(1.-RSQ)))
      I3=I*3
      K=I3-2
      X(K)=-VAL
      K=I3-1
      X(K)=-MAG(I)*DVDXC
      X(I3)=-MAG(I)*DVDYC
 2320 CONTINUE
C
C At this point, the vector X contains the first derivative of
C the condition equation for pixel (IX,IY) with respect to each of
C the fitting parameters for all of the stars.
C
C Now these derivatives will be added into the normal matrix and the
C vector of residuals.
C
C The expected random error in the pixel is the quadratic sum of
C the Poisson statistics, plus the readout noise, plus an estimated
C error of 0.75% of the total brightness for the difficulty of flat-
C fielding and bias-correcting the chip, plus an estimated error of 
C some fraction of the fourth derivative at the peak of the profile,
C to account for the difficulty of accurately interpolating within the 
C point-spread function.  The fourth derivative of the PSF is 
C proportional to H/sigma**4 (sigma is the Gaussian width parameter for
C the stellar core); using the geometric mean of sigma(x) and sigma(y), 
C this becomes H/[sigma(x)*sigma(y)]**2.  The ratio of the fitting 
C error to this quantity is estimated from a good-seeing CTIO frame to 
C be approximately 0.027 (see definition of PKERR above.)
C
      DPOS=AMAX1(0., DATA(IX,IY)-D)
C
C DPOS = raw data minus residual = model-predicted value of the 
C intensity at this point (which presumably is non-negative).
C
      SIGSQ=DPOS/PHPADU+RONOIS+(PERERR*DPOS)**2+(PKERR*(DPOS-SKYBAR))**2
      RELERR=ABS(D)/SQRT(SIGSQ)                ! Absolute relative error
C
C Add this residual into the weighted sum of the absolute relative 
C residuals.
C
      SUMGRP=SUMGRP+RELERR*WT
      GRPWT=GRPWT+WT
C
C Add into the accumulating sums of the weighted absolute relative 
C residuals and of the image sharpness parameter for each of the stars.
C
      DO 2330 I=1,NSTR
      IF (SKIP(I)) GO TO 2330
      CHI(I)=CHI(I)+RELERR*WT
      SUMWT(I)=SUMWT(I)+WT
      RHOSQ=((XC(I)-FLOAT(IX))/PAR(1))**2+
     .     ((YC(I)-FLOAT(IY))/PAR(2))**2
C
C Include in the sharpness index only those pixels within six times
C the HWHM of the centroid of the object.  (This saves time and
C floating underflows by excluding pixels which contribute less than
C about one part in a million to the index.)
C
      IF (RHOSQ .LE. 36.) THEN
        RHOSQ=0.6931472*RHOSQ
        DFDSIG=EXP(-RHOSQ)*(RHOSQ-1.)
        NUMER(I)=NUMER(I)+DFDSIG*D/SIGSQ
        DENOM(I)=DENOM(I)+DFDSIG**2/SIGSQ
      END IF
 2330 CONTINUE
C
C If clipping is in effect, reduce the weight of a bad pixel.  A pixel 
C having a residual of 2.5 sigma gets reduced to half weight; a pixel 
C having a residual of 5. sigma gets weight 1/257.
C
      WT=WT/SIGSQ
      IF (CLIP) WT=WT/(1.+(0.4*RELERR/CHIGRP)**8)
      DWT=D*WT
C     If sky is to be determined: C(NTERM,NTERM)=C(NTERM,NTERM)+WT
C     If sky is to be determined: V(NTERM)=V(NTERM)-DWT
C
C Now work this pixel into the normal matrix.
C
      DO 2370 I=1,NSTR
      IF (SKIP(I)) GO TO 2370
      I3=I*3
      I3M2=I3-2
      DO 2340 K=I3M2,I3
C     If sky is to be determined: C(NTERM,K)=C(NTERM,K)-X(K)*WT
 2340 V(K)=V(K)+X(K)*DWT
      DO 2360 J=1,I
      IF (SKIP(J)) GO TO 2360
      DO 2350 K=I3M2,I3
      DO 2350 L=3*J-2,MIN0(K, 3*J)
 2350 C(K,L)=C(K,L)+X(K)*X(L)*WT
 2360 CONTINUE
 2370 CONTINUE
C
 2380 CONTINUE
 2390 CONTINUE
C
C Make sure that every star in the group has at least four valid pixels
C within one fitting radius.
C
      REDO=.FALSE.
      DO 2400 I=1,NSTR
         IF (NPIX(I) .GE. 4) GO TO 2400
            REDO=.TRUE.
            NI=INT(ALOG10(ID(I)+0.5))+2
            IF (WATCH .GT. 0.5) THEN
               WRITE (LINE,624) NITER, NSTR, NTOT, ID(I)
               CALL OVRWRT (LINE(1:47), 3)
            ELSE
               WRITE (6,625) ID(I)
            END IF
            CALL DAORMV (I, MAXSTR, NSTR, ID, XC, YC, MAG, SKY)
            NTOT=NTOT-1
            IF (NSTR .LE. 0) GO TO 2000
            IF (WATCH .GT. 0.5) CALL TBLANK
            NTERM=NSTR*3
C           If sky is to be determined: NTERM=NTERM+1
 2400 CONTINUE
      IF (REDO) THEN
         GO TO 2210
      END IF
C
C Reflect the normal matrix across the diagonal.
C
      DO 2410 L=2,NTERM
      DO 2410 K=1,L-1
 2410 C(K,L)=C(L,K)
C
C Compute the robust estimate of the standard deviation of the
C residuals for the group as a whole, and for each star.  This 
C estimate is SQRT(PI/2) * Weighted mean absolute relative residual
C (Do you like that "absolute relative" stuff?):
C
C          CHI = 1.2533 * SUM(weight*resid)/(no. of pixels)
C
C This gets corrected for bias by being multiplied by
C
C              SQRT[(no. of pixels)/(no. of pixels - 3)].
C
      IF (GRPWT.GT.3)CHIGRP=1.2533141*SUMGRP*SQRT(1./(GRPWT*(GRPWT-3.)))
C
C But then I drive the value toward unity, depending on exactly how
C many pixels were involved:  if CHIGRP is based on exactly a total 
C weight of 3, then it is extremely poorly determined, and we just
C want to keep CHIGRP = 1.  The larger GRPWT is, the better determined
C CHIGRP is, and the less we want to force it toward unity.  So,
C just take the weighted average of CHIGRP and unity, with weights
C GRPWT-3 and 3, respectively.
C
      IF (GRPWT .GT. 3) CHIGRP=((GRPWT-3.)*CHIGRP+3.)/GRPWT
C
C CHIGRP has been pulled toward its expected value of unity to keep the 
C statistics of a small number of pixels from compeletely dominating 
C the error analysis.  Similarly, the photometric errors for the 
C individual stars will be pulled toward unity now.  Later on, if the
C number of stars in the group is greater than one, CHI will be nudged
C toward the group average.  In order to work optimally, of 
C course, this requires that PHPADU, RONOIS, and the other noise 
C contributors which I have postulated properly represent the true 
C errors expected in each pixel.
C
C Store a smoothed CHI value for the star in SUMWT.
C
      DO 2420 I=1,NSTR
      IF (SUMWT(I) .GT. 3.) THEN
         CHI(I) = 1.2533141*CHI(I)/SQRT( (SUMWT(I)-3.)*SUMWT(I) )
         SUMWT(I) = ((SUMWT(I)-3.)*CHI(I) + 3.)/SUMWT(I)
      ELSE
         CHI(I) = CHIGRP
         SUMWT(I) = GRPWT
      END IF
 2420 CONTINUE
C
      CALL INVERS (C, MAXUNK, NTERM, ISTAT)
      CALL VMUL (C, MAXUNK, NTERM, V, X)
      REDO=.FALSE.
      IF (NITER .LE. 1) REDO=.TRUE.
C If sky is to be determined: SKYBAR=SKYBAR-X(NTERM)
C If sky is to be determined: IF(ABS(X(NTERM)).GT.0.01)REDO=.TRUE.
C
C In the beginning, the brightness of each star will be permitted to
C change by no more than two magnitudes per iteration, and the x,y 
C coordinates of each centroid will be permitted to change by no more 
C than 0.4 pixel per iteration.  Any time that the parameter
C correction changes sign from one iteration to the next, the maximum 
C permissible change will be reduced by a factor of two.  These
C clamps are released any time a star disappears.
C
      DO 2520 I=1,NSTR
      L=3*I
      K=L-1
      J=L-2
C
C If any correction has changed sign since the last iteration, reduce
C the maximum permissible change by a factor of 2.
C
      IF (XOLD(J)*X(J) .LT. -1.E-37) CLAMP(J)=0.5*CLAMP(J)
      IF (XOLD(K)*X(K) .LT. -1.E-37) CLAMP(K)=0.5*CLAMP(K)
      IF (XOLD(L)*X(L) .LT. -1.E-37) CLAMP(L)=0.5*CLAMP(L)
C
C Note that the sign of the correction is such that it must be 
C SUBTRACTED from the current value of the parameter to get the 
C improved parameter value.  This being the case, if the correction
C to the brightness is negative (the least-squares thinks that the
C star should be brighter) a change of 1 magnitude is a change of a
C factor of 2.5; if the brightness correction is positive (the star
C should be fainter) a change of 1 magnitude is a change of 60%.
C
      MAG(I)=MAG(I)-X(J)/
     .  (1.+AMAX1(X(J)/(0.84*MAG(I)),-X(J)/(5.25*MAG(I)))/CLAMP(J))
      XC(I)=XC(I)-X(K)/(1.+ABS(X(K))/(CLAMP(K)*0.4))
      YC(I)=YC(I)-X(L)/(1.+ABS(X(L))/(CLAMP(L)*0.4))
      XOLD(J)=X(J)
      XOLD(K)=X(K)
      XOLD(L)=X(L)
      MAGERR(I) = SUMWT(I)*SQRT(C(J,J))
C
C There are two milestones in the convergence process:  the fits
C proceed normally until each star's magnitude changes by less than its
C standard error or 0.005 magnitudes, whichever is greater, and its
C x- and y-centroids change by less than 0.02 pixel.  At this point
C the least-squares begins to apply the down-weighting of pixels
C with large residuals, as described above.  The fits then continue
C until each star's magnitude changes by less than MAX(0.1*standard
C error, 0.0005 magnitude), and its centroids change by less than 0.002
C pixel.
C
C If you already know that the solution hasn't converged, don't bother
C to keep checking.
C
      IF (REDO) GO TO 2510
      IF (CLIP) THEN
         IF (ABS(X(J)) .GT.
     .        AMAX1( 0.1*MAGERR(I), 0.0005*MAG(I) )) THEN
            REDO=.TRUE.
         ELSE
            DF = (0.1*SUMWT(I))**2
            IF (X(K)**2 .GT. AMAX1(DF*C(K,K), 4.E-6)) THEN
               REDO=.TRUE.
            ELSE IF (X(L)**2 .GT. AMAX1(DF*C(L,L), 4.E-6)) THEN
               REDO=.TRUE.
            END IF
         END IF
      ELSE
         IF (ABS(X(J)) .GT. 
     .        AMAX1( MAGERR(I), 0.005*MAG(I) )) THEN
            REDO=.TRUE.
         ELSE
            DF = SUMWT(I)**2
            IF (X(K)**2 .GT. AMAX1(DF*C(K,K), 4.E-4)) THEN
               REDO=.TRUE.
            ELSE IF (X(L)**2 .GT. AMAX1(DF*C(L,L), 4.E-4)) THEN
               REDO=.TRUE.
            END IF
         END IF
      END IF
 2510 CONTINUE
 2520 CONTINUE
C
C Check whether the estimated centroid of any star has moved so far out 
C of the limits of the picture that it has fewer than four or five 
C pixels within one fitting radius.
C
      I=0
 2525 I=I+1
      IF (I .GT. NSTR) GO TO 2528
      DX=AMAX1( 1.-XC(I), XC(I)-NCOL, 0.)
      DY=AMAX1( 1.-YC(I), YC(I)-NROW, 0.)
C
C If the centroid of the star is outside the picture in x or y, then
C DX or DY is its distance from the center of the edge pixel; otherwise 
C DX and DY are zero.
C
      IF ((DX .LE. 0.001) .AND. (DY .LE. 0.001)) GO TO 2525
      IF ( (DX+1.)**2+(DY+1.)**2 .LT. RADSQ) GO TO 2525
      NI=INT(ALOG10(ID(I)+0.5))+2
      IF (WATCH .GT. 0.5) THEN
         WRITE (LINE,624) NITER, NSTR, NTOT, ID(I)
         CALL OVRWRT (LINE(1:47), 3)
      ELSE
         WRITE (6,625) ID(I)
      END IF
      CALL DAORMV (I, MAXSTR, NSTR, ID, XC, YC, MAG, SKY)
      NTOT=NTOT-1
      IF (NSTR .LE. 0) GO TO 2000               ! No stars left in group
      REDO=.TRUE.
C
C Update display on terminal.
C
      IF (WATCH .GT. 0.5) THEN
         WRITE (LINE,622) NITER, NSTR, NTOT
         CALL OVRWRT (LINE(1:15), 4)
      END IF
      IF (I .LT. NSTR) GO TO 2525       ! <----------------------------+
C                                                                      |
C End of loop to check that centroids aren't too far from the edge     |
C frame. --------------------------------------------------------------+
C
C Update matrix dimensions.
C
 2528 NTERM=NSTR*3
C     If sky is to be determined: NTERM=NTERM+1
C
C Now check whether any of the stars is too faint (more than 12.5
C magnitudes fainter than the PSF star).  If several stars are
C too faint, delete the faintest one, and set the brightnesses of
C the other faint ones exactly to 12.5 mag below the PSF star.
C That way on the next iteration we will see whether these stars
C want to grow or to disappear.
C
      FAINT=1.0
      IFAINT=0
C
      DO 2540 I=1,NSTR
      IF (MAG(I) .GT. 1.E-5) GO TO 2540
      IF (MAG(I) .GT. FAINT) GO TO 2530
      FAINT=MAG(I)
      IFAINT=I
 2530 MAG(I)=1.E-5
 2540 CONTINUE
C
C If at least one star is more than 12.5 mag. fainter than the
C PSF, then  I  is the index of the faintest of them, and FAINT
C is the relative brightness of the faintest of them.
C
      IF (IFAINT .GT. 0) GO TO 2560                 ! No star that faint
C
C If the solution has not converged and if the number of iterations
C is less than 4, perform another iteration no questions asked.
C
      IF (REDO .AND. (NITER .LT. 4)) GO TO 2200
C
C If the solution doesn't think it has converged, after the fourth
C iteration delete the least certain star if it is less than a one-sigma
C detection; after the eighth iteration delete the least certain star if
C it is less than a 1.50 sigma detection; after the twelfth iteration
C OR if the solution thinks it has converged, delete the least certain 
C star if it is less than a two-sigma detection.
C
      FAINT=0.
      IFAINT=0
C
      DO 2550 I=1,NSTR
      WT=MAGERR(I)/MAG(I)
      IF (WT .LT. FAINT) GO TO 2550
      FAINT=WT
      IFAINT=I
 2550 CONTINUE
C
C If the solution has not converged, and the least certain star still
C has N/S less than WCRIT, do another iteration.
C
      IF (REDO .AND. (NITER .LT. 50) .AND. (FAINT .LT. WCRIT)) 
     .     GO TO 2200
C
C Either the solution has converged, or we have hit 50 iterations,
C or the poorest star has N/S greater than WCRIT.  If the star has N/S
C LESS than half, then either the solution has converged or we have
C hit 50 iterations.  In either case we're done.  Otherwise, delete
C the poorest star and do another iteration as long as there are some
C stars left.
C
      IF (FAINT .LT. 0.5) GO TO 2900
 2560 IF (WATCH .GT. 0.5) THEN
         WRITE (LINE,624) NITER, NSTR, NTOT, ID(IFAINT)
  624    FORMAT (3I5, 5X, 'Star', I6, ' has disappeared.')
         CALL OVRWRT (LINE(1:47), 3)
      ELSE
         WRITE (6,625) ID(IFAINT)
  625    FORMAT(1X, 'Star', I6, ' has disappeared.')
      END IF
      CALL DAORMV (IFAINT, MAXSTR, NSTR, ID, XC, YC, MAG, SKY)
      NTOT=NTOT-1
      IF (NSTR .LE. 0) GO TO 2000
      IF (WATCH .GT. 0.5) THEN
         WRITE (LINE,622) NITER, NSTR, NTOT
         CALL OVRWRT (LINE(1:15), 2)
      END IF
      NTERM=NSTR*3
C     If sky is to be determined: NTERM=NTERM+1
C
C After deleting a star, release all the clamps, back the iteration
C counter up by one, and do the next iteration without incrementing 
C the counter.  That way the second most uncertain star will have
C two chances to get its act together before it comes up for tenure
C review.
C
      DO 2570 I=1,NTERM
      XOLD(I)=0.0
 2570 CLAMP(I)=1.0
      CLIP=.FALSE.
      NITER=MAX0(1, NITER-1)
      GO TO 2210
C
 2900 CONTINUE
C
C Solution has either converged or gone to 50 iterations.
C
      IF ((NITER .LT. 50) .AND. (.NOT. CLIP)) THEN
C
C The first convergence milestone has been reached.  Turn on the 
C clipper, loosen the clamps, and keep iterating.
C
         CLIP=.TRUE.
         DO I=1,NTERM
            XOLD(I)=0.0
            CLAMP(I)=AMAX1(CLAMP(I), 0.25)
         END DO
         GO TO 2200                               ! Do another iteration
      END IF
C
C Either there have been 50 iterations or real convergence has been
C achieved.  Write out the results and go on to the next group.
C
      DO 2910 I=1,NSTR
      SHARP(I)=1.4427*PAR(1)*PAR(2)*NUMER(I)/(MAG(I)*BRIGHT*DENOM(I))
      SHARP(I)=AMIN1(99.999,AMAX1(SHARP(I),-99.999))
      ERR=1.085736*MAGERR(I)/MAG(I)
      MAG(I)=PSFMAG-1.085736*ALOG(MAG(I))
 2910 WRITE (1,321) ID(I), XC(I), YC(I), MAG(I), ERR, SKY(I), 
     .     FLOAT(NITER), CHI(I), SHARP(I)
  321 FORMAT (I6, 5F9.3, F9.0, F9.2, F9.3)
      WRITE (LINE, 622) NITER, NSTR, NTOT
      IF (WATCH .GT. 0.5) CALL OVRWRT (LINE(1:15), 3)
C
      WRITE (1,321)                                 ! Write a blank line
      GO TO 2000
C
C-----------------------------------------------------------------------
C
C Normal return.
C
 9000 CONTINUE
      CALL CLFILE (1)
      WRITE (6,690) 7
  690 FORMAT (/'    Done.  ', A1/)
      CALL CLFILE (2)
      RETURN
C
C-----------------------------------------------------------------------
C
C Irrecoverable errors.
C
 9100 WRITE (6,691) 7
  691 FORMAT (/' Error reading picture.', A1/)
      RETURN
C
 9200 WRITE (6,692) 7
  692 FORMAT (/' Not a group file.', A1/)
      RETURN
C
 9300 WRITE (6,693) 7
  693 FORMAT (/' Error opening file.', A1/)
      RETURN
C
      END!
C
C#######################################################################
C
      SUBROUTINE  DAORMV (I, MAXSTR, NSTR, ID, XC, YC, MAG, SKY)
C
C=======================================================================
C
C A simple little subroutine to remove the I-th star from a group.
C The other arguments are obvious.
C
C                        1991 April 18
C
C=======================================================================
C
      IMPLICIT NONE
      INTEGER MAXSTR
      REAL XC(MAXSTR), YC(MAXSTR), MAG(MAXSTR), SKY(MAXSTR)
      INTEGER ID(MAXSTR)
C
      INTEGER I, NSTR
C
C-----------------------------------------------------------------------
C
C If we are trying to delete the last star in the group, all we need to
C do is reduce NSTR by one.  Otherwise, overwrite the I-th star with the
C NSTR-th star, and THEN reduce NSTR by one.
C
      IF (I .EQ. NSTR) GO TO 1000
      ID(I)=ID(NSTR)
      MAG(I)=MAG(NSTR)
      XC(I)=XC(NSTR)
      YC(I)=YC(NSTR)
      SKY(I)=SKY(NSTR)
 1000 NSTR=NSTR-1
      RETURN
      END!

C @(#)gcdemo.for	19.1 (ES0-DMD) 02/25/03 14:08:02
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                    all rights reserved
C.IDENTIFICATION: Program GCURSR
C.PURPOSE:   Extract the coordinates and pixel values: the coordinates can be
C            included/appended in the descriptor, table or keyword.
C.AUTHOR:    Ch. Ounnas   ESO - Garching
C.LANGUAGE:  F77+ESOext
C.KEYWORDS:  Graphics, cursor, table descriptor
C.ALGORITHM: The outines uses the standard interface and AGL plotting routines.
C.VERSION:   850513 KB  ???
C.VERSION:   850925 ChO ???
C.VERSION:   851125 JDP ???
C.VERSION:   8602?? LF  implementation of the AGL plotting routines
C.VERSION:   86???? RHW Completely restructured
C.VERSION:   870211 RHW corr. default for the maximum number of input
C.VERSION:   870629 RHW include of facilitity to read contour plots
C.VERSION:   871113 RHW ESO-FORTRAN Conversion
C.VERSION:   910115 RHW IMPLICIT NONE added
C.VERSION:   910091 RHW Additions to handle plot/row and plot/column plots
C -----------------------------------------------------------------
      PROGRAM GCURSR
      IMPLICIT  NONE

      INTEGER   NCR
      PARAMETER (NCR=1)
C
      INTEGER   ACCESS, PLMODE
      INTEGER   ISTAT, KUN, MADRID(1)
      REAL      RDUM, X, Y
C
      CHARACTER STRING*1
C
      INCLUDE   'MID_INCLUDE:PLTDEC.INC/NOLIST'
      INCLUDE   'MID_INCLUDE:ST_DEF.INC/NOLIST'
      COMMON    /VMR/MADRID
      INCLUDE   'MID_INCLUDE:ST_DAT.INC/NOLIST'
C
C *** start of executable code
      CALL STSPRO('GCURSR')
      STRING = ' '
      ACCESS = -1 
      PLMODE = -1
      CALL PLOPN(' ',ACCESS,PLMODE)
      CALL AGVLOS(X,Y,1,STRING,RDUM)
      IF ((STRING.EQ.'1') .OR.
     2    (STRING.EQ.'2') .OR.
     3   (STRING.EQ.'3') .OR.
     4   (STRING.EQ.'4') .OR.
     5   (STRING.EQ.'5') .OR.
     6   (STRING.EQ.'6') .OR.
     7   (STRING.EQ.'7') .OR.
     8   (STRING.EQ.'8') .OR.
     9   (STRING.EQ.'9') .OR.
     0   (STRING.EQ.'0')) THEN
         CALL STKWRC('WAHL',1,STRING,1,1,KUN,ISTAT)
      ELSE 
         CALL STKWRC('START',1,STRING,1,1,KUN,ISTAT)
      ENDIF
      CALL PLCLS
      CALL STSEPI
      END

C @(#)perspec.for	13.1.1.1 (ES0-DMD) 06/02/98 18:20:55
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM PERSP
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  program PERSP 			version 1.00    920103
C  K. Banse                     	ESO - Garching
C  1.10  930512		2.00	940104
C
C.KEYWORDS
C  perspective, rebinning
C
C.INPUT/OUTPUT
C  the following keywords are used:
C
C  IN_A/C/1/60			input frame
C  OUT_A/C/1/60			output frame
C  INPUTR/1/2			rotation angle in degrees, in [0,360]
C				tilt angle in degrees in [0,90]
C
C.VERSIONS
C  1.00   creation
C  1.10   STKWRR had 1 param. too many !
C  2.00   add z-perspective plot
C	
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      IAV,N,NAXISA,NAXISC
      INTEGER*8    PNTRA,PNTRB,PNTRC
      INTEGER      IMNOA,IMNOB,IMNOC,STAT
      INTEGER      NPIXA(3),NPIXB(2),NPIXC(2),KZ,KNO
      INTEGER      N1,N2,NSIZ,NPERSP,DIM3C,KDIFF,PLANES(20)
      INTEGER      UNI(1),NULO,MADRID(1)
      INTEGER      ISCAL
C
      CHARACTER*60 FRAMEA,FRAMEB
      CHARACTER    CUNITA*64,IDENTA*72,STR*80
C
      DOUBLE PRECISION STEPA(3),STARTA(3),STARTB(2),STEPB(2),STEPC(2)
      DOUBLE PRECISION ST(2)
C
      REAL         RNULL
      REAL         ANGDEG,ANGLE,AC,AS,X1,X2,X3,Y1,Y2,Y3,X4,Y4
      REAL         PC, PCDEG
      REAL         PIXROT(2),ROTOFF(2),EN(2),RST(2)
      REAL         QUOT,RQUOT,R1,R2,RROT(4),CUTS(4)
      REAL         FACTO,RBUF(20),ZCUTS(2)
C
      COMMON   /VMR/  MADRID
C
      INCLUDE  'MID_INCLUDE:ST_DEF.INC'
C 
      EQUIVALENCE (X2,RBUF(1)),(Y2,RBUF(2)),(X4,RBUF(3)),(Y4,RBUF(4))
      EQUIVALENCE (X3,RBUF(5)),(Y3,RBUF(6)),(X1,RBUF(7)),(Y1,RBUF(8))
C
      DATA     FACTO  /0.0174533/               !  Pi / 180.
      DATA     NPIXA  /1,1,1/
      DATA     IDENTA /' '/, CUNITA /' '/       !necessary ... !!!
C
      INCLUDE  'MID_INCLUDE:ST_DAT.INC'
C 
C  get into MIDAS
      CALL STSPRO('PERSP')
C
C  get input frame + map it
      CALL STKRDC('IN_A',1,1,60,IAV,FRAMEA,UNI,NULO,STAT)
      CALL STIGET(FRAMEA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,3,
     +            NAXISA,NPIXA,STARTA,STEPA,
     +            IDENTA,CUNITA,PNTRA,IMNOA,STAT)
      IF (NAXISA.EQ.1) 
     +   CALL STETER(1,'We need a 2-dim image ...')
      IF ((NPIXA(1).EQ.1) .OR. (NPIXA(2).EQ.1))
     +   CALL STETER(1,'We need a 2-dim image ...')
      CALL STDRDR(IMNOA,'LHCUTS',1,4,IAV,CUTS,UNI,NULO,STAT)
      ZCUTS(1) = CUTS(3)
      ZCUTS(2) = CUTS(4)
      RNULL = CUTS(3) - 0.01*(CUTS(4)-CUTS(3))                !null val < min
C 
      R1 = NPIXA(1) - 1.
      R2 = NPIXA(2) - 1.
      KDIFF = 12
      DIM3C = 1
C
C  get name of output frame + plane no.s (or action code)
      CALL STKRDC('OUT_A',1,1,60,IAV,FRAMEB,UNI,NULO,STAT)
      CALL STKRDC('INPUTC',1,1,80,IAV,STR,UNI,NULO,STAT)
C
C  get rotation angle + perspective angle + (scaling size)
      CALL STKRDR('INPUTR',1,4,IAV,RROT,UNI,NULO,STAT)
      IF (STR(1:4).EQ.'zper') THEN
         PLANES(1) = 1
         PLANES(2) = 0
         KNO = 0
         ISCAL = NINT(RROT(3))
         IF (ISCAL.LT.1) 
     +      CALL STETER(1,'Invalid scaling size (should be > 0)...')
         ZCUTS(2) = RROT(4)
         IF (ZCUTS(2).LE.ZCUTS(1)) CALL STETER(1,
     +      'Invalid scale limit (should be > LHCUTS(3))...')
C 
C  get planes to work on
      ELSE IF ((STR(1:1).EQ.'A') .OR. (STR(1:1).EQ.'a')) THEN
         PLANES(1) = -1                    !indicate all planes
         KNO = NPIXA(3) - 1                !no. of planes - 1
      ELSE
         CALL GENCNV(STR,1,20,PLANES,QUOT,STEPC,IAV)
         IF (IAV.LE.0)
     +      CALL STETER(5,'Invalid planes specified ...')
         IF ((PLANES(1).LE.0).OR.(PLANES(1).GT.NPIXA(3)))
     +      CALL STETER(6,'specified plane outside limits... ')
         N = PLANES(1) - 1                 !update pointer
         KNO = IAV - 1                     !no. of planes - 1
         PNTRA = PNTRA + N*NPIXA(1)*NPIXA(2)
         IAV = IAV + 1
         PLANES(IAV) = 0                   !mark the end
      ENDIF
C 
      ANGDEG = RROT(1)
      PCDEG = RROT(2)
C 
      ANGLE = ANGDEG * FACTO
      N = (NPIXA(1) + 1) / 2                  !use center pixel
      PIXROT(1) = N - 1
      N = (NPIXA(2) + 1) / 2                  !use center pixel
      PIXROT(2) = N - 1
C 
      AC = COS(ANGLE)
      AS = SIN(ANGLE)
      IF ((ANGDEG.LT.0.1).OR.(ANGDEG.GT.359.9)) THEN
         NPIXB(1) = NPIXA(1)                   !no rotation
         NPIXB(2) = NPIXA(2)
         STARTB(1) = STARTA(1)
         STARTB(2) = STARTA(2)
         STEPB(1) = STEPA(1)
         STEPB(2) = STEPA(2)
         N1 = 0
C 
         RBUF(1) = 0.
         RBUF(2) = R2
         RBUF(3) = 0.
         RBUF(4) = 0.
         RBUF(5) = R1
         RBUF(6) = 0.
         RBUF(7) = R1
         RBUF(8) = R2
C 
         GOTO 3000
      ELSE
         N1 = 1                                !yes. we do
      ENDIF
C
C  to get size of output frame, rotate corners around lower left corner
C  (assumed = 0,0)
C 
      CALL ROTA1(R1,R2,AC,AS,X1,Y1)         !(NX-1,NY-1)
      CALL ROTA1(0.,R2,AC,AS,X2,Y2)         !(0,NY-1)
      CALL ROTA1(R1,0.,AC,AS,X3,Y3)         !(NX-1,0)
      X4 = 0.
      Y4 = 0.                               !rotation point stays fixed
C
C  get result frame "corners"
      ST(1) = MIN(0.,X1,X2,X3)             !rotated x-start
      EN(1) = MAX(0.,X1,X2,X3)             !rotated x-end
      ST(2) = MIN(0.,Y1,Y2,Y3)             !rotated y-start
      EN(2) = MAX(0.,Y1,Y2,Y3)             !rotated y-end
C
C  from coords. of rotation point determine shift after rotation
      QUOT = 1. - AC
      ROTOFF(1) = PIXROT(1)*QUOT + PIXROT(2)*AS
      ROTOFF(2) = PIXROT(2)*QUOT - PIXROT(1)*AS
      CALL ROTA1(PIXROT(1),PIXROT(2),AC,AS,RROT(1),RROT(2))
C
C  choose corners such, that rotation point is hit ...
      DO 2000, N=1,2
         STEPB(N) = STEPA(N)
         QUOT =  RROT(N) - ST(N)           !distance of fixed p. to rotation p.
         RQUOT = FLOAT(INT(QUOT)) + 1.     !is forced to multiples of steps
         ST(N) = RROT(N) - RQUOT
         QUOT = EN(N) - ST(N)              !distance of start to end point
         RQUOT = FLOAT(INT(QUOT)) + 1.     !in multiples of steps
         EN(N) = ST(N) + RQUOT
         NPIXB(N) = NINT(RQUOT) + 1        !no. of points in new image
2000  CONTINUE
C
C  now update start of rotated image, so that rotation point stays fixed
      RST(1) = ST(1) + ROTOFF(1)
      RST(2) = ST(2) + ROTOFF(2)
      STARTB(1) = STARTA(1) + ( RST(1)*STEPA(1) )      !we work in 0,0 space
      STARTB(2) = STARTA(2) + ( RST(2)*STEPA(2) )
      DO 2200, N=1,7,2                       
         RBUF(N) = RBUF(N) - ST(1)              !relate to new frame
         RBUF(N+1) = RBUF(N+1) - ST(2)
2200  CONTINUE
C
C  create and map intermediate frame
C 
3000  NSIZ = NPIXB(1) * NPIXB(2)
C 
C  do the rotation
      IF (N1.EQ.1) THEN
         IF (DIM3C.EQ.1) THEN
            CALL STFCRE('midpersp',D_R4_FORMAT,F_X_MODE,1,NSIZ,
     +                  IMNOB,STAT)
            CALL STFMAP(IMNOB,F_X_MODE,1,NSIZ,IAV,PNTRB,STAT)
         ENDIF
         CALL ROTA2(MADRID(PNTRA),MADRID(PNTRB),NPIXA,NPIXB,
     +              ST,AC,AS,RNULL)
      ENDIF
C 
C  create result frame
      IF (DIM3C.EQ.1) THEN
         NPIXC(1) = NPIXB(1)
         STEPC(1) = STEPB(1)
         IF (PCDEG.LE.0.1) THEN                 !no tilt at all ...
            N2 = 0
            PC = 1
            NPIXC(2) = NPIXB(2)
         ELSE IF (PCDEG.GT.89.5) THEN           !total side view => single line
            N2 = 2
            NPIXC(2) = 1
            PC = 0
         ELSE
            N2 = 1
            PC = COS(PCDEG * FACTO)
            NPIXC(2) = INT (NPIXB(2) * PC)
            NPERSP = NPIXC(2)
            STEPC(2) = STEPB(2) * PC
         ENDIF
C
C  move corners to world coords.
         DO 4100, N=1,7,2
            RBUF(N) = STARTB(1) + (RBUF(N)*STEPC(1))
            IAV = INT (RBUF(N+1)*PC)
            IF (IAV.GE.NPIXC(2)) IAV = NPIXC(2) - 1
            RBUF(N+1) = STARTB(2) + (IAV*STEPC(2))
4100     CONTINUE
         IF (KNO.GT.0) THEN                      !if more than one plane
            QUOT = STEPC(2) * ((NPERSP+KDIFF)*KNO)
            RBUF(9) = RBUF(2) + QUOT
            RBUF(10) = RBUF(4) + QUOT
            RBUF(11) = RBUF(6) + QUOT
            RBUF(12) = RBUF(8) + QUOT
            RBUF(13) = KNO + 1                   !no. of planes
            RBUF(14) = KDIFF
            RBUF(15) = STEPC(2) * KDIFF
            RBUF(16) = STEPC(2) * (NPERSP+KDIFF)
C 
            NAXISC = 2
            NPIXC(2) = (KNO+1)*NPIXC(2) + KNO*KDIFF
            RQUOT = STARTB(2) + (NPIXC(2)-1)*STEPC(2)         !y-end
            IF (STEPC(2).GT.0.) THEN
               IF (RBUF(9).GT.RQUOT) RBUF(9) = RQUOT
               IF (RBUF(10).GT.RQUOT) RBUF(10) = RQUOT
               IF (RBUF(11).GT.RQUOT) RBUF(11) = RQUOT
               IF (RBUF(12).GT.RQUOT) RBUF(12) = RQUOT
            ELSE
               IF (RBUF(9).LT.RQUOT) RBUF(9) = RQUOT
               IF (RBUF(10).LT.RQUOT) RBUF(10) = RQUOT
               IF (RBUF(11).LT.RQUOT) RBUF(11) = RQUOT
               IF (RBUF(12).LT.RQUOT) RBUF(12) = RQUOT
            ENDIF
         ELSE
            NAXISC = NAXISA
         ENDIF
C 
         CALL STKWRR('OUTPUTR',RBUF,1,20,UNI,STAT)
         IF (STR(1:4).EQ.'zper') THEN
            IDENTA(1:) = 'perspective z-plot of input frame '
            NAXISC = 2
            NPIXC(2) = NPIXC(2)+ISCAL
            NPERSP = NPIXC(2)                     !in case we reset it later on
         ELSE
            IDENTA(1:) = 
     +      'perspective plot of selected planes of input frame '
         ENDIF
         CALL STIPUT(FRAMEB,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +               NAXISC,NPIXC,STARTB,STEPC,
     +               IDENTA,CUNITA,PNTRC,IMNOC,STAT)
      ENDIF
C
C  and do the perspective rebinning
      IF (N2.EQ.1) THEN                         !real job
         NPIXC(2) = NPERSP                      !reset to original value (3-dim)
         IF (N1.EQ.1) THEN
            IF (STR(1:4).EQ.'zper') THEN
               CALL JPERSP(MADRID(PNTRB),MADRID(PNTRC),
     +                     NPIXB,NPIXC,PC,RNULL,ZCUTS,ISCAL)
               CALL STDWRI(IMNOC,'NPIX',NPIXC(2),2,1,UNI,STAT)
            ELSE
               CALL KPERSP(MADRID(PNTRB),MADRID(PNTRC),
     +                     NPIXB,NPIXC,PC)
            ENDIF
         ELSE
            IF (STR(1:4).EQ.'zper') THEN
               CALL JPERSP(MADRID(PNTRA),MADRID(PNTRC),
     +                     NPIXB,NPIXC,PC,RNULL,ZCUTS,ISCAL)
               CALL STDWRI(IMNOC,'NPIX',NPIXC(2),2,1,UNI,STAT)
            ELSE
               CALL KPERSP(MADRID(PNTRA),MADRID(PNTRC),
     +                     NPIXB,NPIXC,PC)
            ENDIF
         ENDIF
      ELSE IF (N2.EQ.0) THEN                    !just rotated image
         IF (N1.EQ.1) THEN
            CALL COPYF(MADRID(PNTRB),MADRID(PNTRC),NSIZ)
         ELSE
            CALL COPYF(MADRID(PNTRA),MADRID(PNTRC),NSIZ)
         ENDIF
      ELSE                                      !only sideline
         IF (N1.EQ.1) THEN
            CALL COPYF(MADRID(PNTRB),MADRID(PNTRC),NPIXB(1))
         ELSE
            CALL COPYF(MADRID(PNTRA),MADRID(PNTRC),NPIXB(1))
         ENDIF
      ENDIF
C 
C  check for 3-dim case
      DIM3C = DIM3C + 1
      IF (PLANES(1).EQ.-1) THEN
         IF (DIM3C.GT.NPIXA(3)) THEN
            GOTO 9000
         ELSE
            KZ = 1
         ENDIF
      ELSE
         IF (PLANES(DIM3C).EQ.0) THEN
            GOTO 9000
         ELSE
            IF ((PLANES(DIM3C).LE.0).OR.(PLANES(DIM3C).GT.NPIXA(3)))
     +         CALL STETER(6,'specified plane outside limits... ')
            KZ = PLANES(DIM3C) - PLANES(DIM3C-1)
         ENDIF
      ENDIF
      PNTRA = PNTRA + (NPIXA(1)*NPIXA(2))*KZ
      PNTRC = PNTRC + (NPIXC(1) * (NPIXC(2) + KDIFF))
      GOTO 3000
C
9000  CALL STDWRR(IMNOC,'LHCUTS',CUTS,1,4,UNI,STAT)
      CALL STSEPI
      END

      SUBROUTINE ROTA1(X,Y,AC,AS,XOUT,YOUT)
C
      IMPLICIT NONE
C
      REAL     X,Y,AC,AS,XOUT,YOUT
C
      XOUT = X*AC - Y*AS
      YOUT = X*AS + Y*AC
C
      RETURN
      END

      SUBROUTINE KPERSP(A,B,NPIXA,NPIXB,AC)
C
C  K. Banse            920103
C
C  do "backward" perspective
C 
C  XPERS = X
C  YPERS = Y/AC
C
      IMPLICIT NONE
C
      INTEGER      INDXB,KSTX,KY
      INTEGER      NO1,NO3
      INTEGER      NX,NY,SIZEA,XDIMA,YDIMA
      INTEGER      NPIXA(2),NPIXB(2)
C
      REAL         A(*),B(*)
      REAL         AC,YFRAC
C 
      DOUBLE PRECISION  RYAC,ACINV
C
C  init
      XDIMA = NPIXA(1)
      YDIMA = NPIXA(2)
      SIZEA = XDIMA * YDIMA
C
      ACINV = 1.D0 / AC
      INDXB = 0
      RYAC = ACINV
C
C  loop through result lines
      DO 3000, NY=1,NPIXB(2)
         DO 1000, NX=1,NPIXB(1)
            INDXB = INDXB + 1              !loop along result line
            KY = INT(RYAC)
            KSTX = XDIMA*KY                !get 1. pixel in this line - 1
            NO1 = NX + KSTX                !get pixel close to integer part of
            NO3 = NO1 + XDIMA               !get low pixel in next line up
            IF (NO3.GT.SIZEA) THEN          !are we out of grid in y?
               B(INDXB) = A(NO1)
            ELSE
               YFRAC = RYAC - KY
               B(INDXB) = A(NO1) + (YFRAC * (A(NO3) - A(NO1)))
            ENDIF
1000     CONTINUE
         RYAC = RYAC + ACINV
3000  CONTINUE
C 
      RETURN
      END

      SUBROUTINE JPERSP(A,B,NPIXA,NPIXB,AC,ZNULL,FMINMA,ISCAL)
C
C
C  do "backward" z-perspective
C
C  XPERS = X
C  YPERS = Y/AC 
C 
C  Z = YPERS * ISCAL  =>      XPERS,YPERS+n   = Z
C                             XPERS,YPERS+n-1 = ...
C                                  ...
C                             XPERS,YPERS     = Min
C
      IMPLICIT NONE
C
      INTEGER      INDXB,KSTX,KY,ISCAL
      INTEGER      NO1,NO3,N
      INTEGER      NX,NY,SIZEA,XDIMA,YDIMA,XDIMB
      INTEGER      NPIXA(2),NPIXB(2)
      INTEGER      KSCAL,IZ,KNDXB,KK
C
      REAL         A(*),B(*)
      REAL         AC,FMINMA(2),ZNULL
      REAL         YFRAC,RMIN,RMAX
      REAL         Z,DZ,SCALF,CMIN,FF
      REAL         VALU
C
      DOUBLE PRECISION  RYAC,ACINV
C
C  init
      XDIMA = NPIXA(1)
      YDIMA = NPIXA(2)
      SIZEA = XDIMA * YDIMA
      XDIMB = NPIXB(1)
C
      RMIN = FMINMA(1)
      RMAX = FMINMA(2)
      ACINV = 1.D0 / AC
      INDXB = NPIXB(1)*NPIXB(2)
      KSCAL = ISCAL - 1
      SCALF = KSCAL / (RMAX-RMIN)
      CMIN = RMIN*ISCAL
      KK = NPIXB(2)-ISCAL               !reserved space for spikes of last line
C
C  loop through result lines
      DO 300, NY=NPIXB(2),KK+1,-1
         DO 100, NX=1,XDIMB
            B(INDXB) = ZNULL
            INDXB = INDXB - 1              !loop along result line
100      CONTINUE
300   CONTINUE
C 
      RYAC = KK * ACINV
      DO 3000, NY=KK,1,-1
C
         DO 1000, NX=1,XDIMB
            KY = INT(RYAC)
            KSTX = XDIMA*KY                !get 1. pixel in this line - 1
            NO1 = NX + KSTX                !get pixel close to integer part of
            NO3 = NO1 + XDIMA              !get low pixel in next line up
            IF (NO3.GT.SIZEA) THEN         !are we out of grid in y?
               Z = A(NO1)
            ELSE
               YFRAC = RYAC - KY
               Z = A(NO1) + (YFRAC * (A(NO3) - A(NO1)))
            ENDIF
            IF (Z .GT. RMAX) Z = RMAX
C 
C  get height from intensity
            DZ = Z - RMIN
            IZ = NINT(DZ*SCALF)
            IF (IZ .GE. 1) THEN
               B(INDXB) = RMIN
               FF = DZ/IZ
               KNDXB = INDXB + XDIMB
               VALU = FF + RMIN
               DO 800, N=1,IZ
                  B(KNDXB) = VALU
                  VALU = VALU + FF
                  KNDXB = KNDXB + XDIMB
800            CONTINUE
            ELSE
               B(INDXB) = Z
            ENDIF
C
            INDXB = INDXB - 1              !loop along result line
1000     CONTINUE
C
         RYAC = RYAC - ACINV
3000  CONTINUE
C
C  get rid of superfluous lines in the end
      INDXB = NPIXB(1)*NPIXB(2)
      DO 4000, NY=NPIXB(2),KK+1,-1
         DO 3300, NX=1,XDIMB
            IF (B(INDXB) .GT. ZNULL) THEN
               NPIXB(2) = NY
               RETURN
            ENDIF
            INDXB = INDXB - 1
3300     CONTINUE
4000  CONTINUE
C 
      RETURN
      END

      SUBROUTINE ROTA2(A,B,NPIXA,NPIXB,START,AC,AS,ZNULL)
C
C  K. Banse            861029, 880902, 910204
C
C  do "backward" rotation, i.e. solve the system XROT = X*AC - Y*AS
C                                       YROT = X*AS + Y*AC for X,Y
C  to yield X = XROT*AC + YROT*AS
C          Y = YROT*AC - XROT*AS  which takes AC**2 + AS**2 = 1 into account....
C
      IMPLICIT NONE
C
      INTEGER      INDXB,KX,KY,KSTX
      INTEGER      NO1,NO2,NO3,NO4
      INTEGER      NX,NY,SIZEA,XDIMA,YDIMA
      INTEGER      NPIXA(2),NPIXB(2)
C
      REAL         A(*),B(*)
      REAL         AC,AS,ZNULL
      REAL         XT,YT,XFRAC,YFRAC,XLAST,YLAST
      REAL         XF,RX
C
      DOUBLE PRECISION  START(2)
      DOUBLE PRECISION  RYAC,RYAS
C
C  init
      XF = START(1)
      XDIMA = NPIXA(1)
      YDIMA = NPIXA(2)
      XLAST = XDIMA - 1.
      YLAST = YDIMA - 1.
      SIZEA = XDIMA * YDIMA
      INDXB = 0
C
      RYAS = START(2) * AS                 !init RYAS,RYAC according to start-y
      RYAC = START(2) * AC
C 
C  loop through result lines
      DO 3000, NY=1,NPIXB(2)
         RX = XF                           !init RX to start-x
C
         DO 1000, NX=1,NPIXB(1)
            INDXB = INDXB + 1              !loop along result line
            XT = RX*AC + RYAS
            IF ((XT.LT.0.).OR.(XT.GT.XLAST)) THEN
               B(INDXB) = ZNULL
               GOTO 1000
            ENDIF
            YT = RYAC - RX*AS
            IF ((YT.LT.0.).OR.(YT.GT.YLAST)) THEN
               B(INDXB) = ZNULL
               GOTO 1000
            ENDIF
C
C  interpolate...
            XT = XT + 1.                  !adjust 0,0 to 1,1 ...
            YT = YT + 1.
            KX = INT(XT)
            KY = INT(YT)
            KSTX = XDIMA*(KY-1)          !get 1. pixel in this line - 1
            NO1 = KX + KSTX          !get pixel close to int. part of real pixel
C
            NO2 = NO1 + 1                  !get next pixel in x-direction
CC            IF ((NO2-KSTX).GT.XDIMA) THEN  !are we out of grid in x?
            IF (KX.GE.XDIMA) THEN          !are we out of grid in x?
               IF (NO2.GT.SIZEA) THEN      !also out in y?
                  B(INDXB) = A(NO1)        !yes.
               ELSE
                  NO3 = NO1 + XDIMA        !no.
                  YFRAC = YT - KY
                  B(INDXB) = A(NO1) + ( YFRAC * (A(NO3) - A(NO1)) )
               ENDIF
            ELSE
               XFRAC = XT - KX
               NO3 = NO1 + XDIMA               !get low pixel in next line up
               IF (NO3.GT.SIZEA) THEN          !are we out of grid in y?
                  B(INDXB) = A(NO1) + ( XFRAC * (A(NO2) - A(NO1)) )
               ELSE
                  NO4 = NO3 + 1
                  YFRAC = YT - KY
                  B(INDXB) = A(NO1) +
     +              XFRAC * (A(NO2) - A(NO1)) +
     +              YFRAC * (A(NO3) - A(NO1)) +
     +              XFRAC * YFRAC * (A(NO1) - A(NO2) - A(NO3) + A(NO4))
               ENDIF
            ENDIF
C
1000     RX = RX + 1.0                        !move to next x-coord
C
         RYAS = RYAS + AS                     !move to next y-coord.
         RYAC = RYAC + AC       
3000  CONTINUE
C 
      RETURN
      END

C @(#)ftdfpr.for	19.1 (ES0-DMD) 02/25/03 13:17:33
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FTDFPR(PARAM,LEN,VAL,LENV,ISTAT)                               
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                   
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:25 - 13 JAN 1988                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C.IDENTIFICATION                                                                
C                                                                               
C  FITLIB.FOR   VERSION 1.0  27 MAR 1984                                        
C                                                                               
C.PURPOSE                                                                       
C                                                                               
C  INTERFACE ROUTINES FOR THE FITTING STRUCTURES                                
C DEFINES NEW PARAMETER GUESS                                                   
C                                                                               
C.ALGORITHM                                                                     
C                                                                               
C  USE MIDAS I/O INTERFACES TO FRAMES AND TABLES                                
C                                                                               
C.KEYWORDS                                                                      
C                                                                               
C  NON LINEAR FITTING                                                           
C                                                                               
C                                                                               
C----------------------------------------------------------------               
C                                                                               
C      IMPLICIT NONE                                                            
C                                                                               
C INPUT ARGUMENTS                                                               
C PARAM CHAR PARAMETER NAME                                                     
C LEN INTG PARAMETER LENGTH                                                     
C VAL CHAR PARAMETER GUESS                                                      
C LENV INTG VALUE LENGTH                                                        
C                                                                               
C OUTPUT ARGUMENTS                                                              
C ISTAT INTG STATUS RETURN                                                      
C                                                                               
      INTEGER LEN,LENV,ISTAT,I,J,II,II1,L,IFUN,IOFF
      CHARACTER*(*) PARAM,VAL                                                   
      CHARACTER NAME*12,FSPEC*80,CVAL*30                                        
       INCLUDE 'MID_INCLUDE:FITI.INC/NOLIST'                                     
       INCLUDE 'MID_INCLUDE:FITC.INC/NOLIST'                                     
C                                                                               
C SEARCH FOR PARAMETER (I IS THE PARAMETER NUMBER)                              
C                                                                               
      DO 10 I = 1,FZNPTOT                                                     
          NAME   = FZPTOKEN(I)                                                
          IF (NAME(1:FZPLEN(I)).EQ.PARAM(1:LEN)) GO TO 20                     
   10 CONTINUE                                                                  
      ISTAT  = FERPFU                                                       
      RETURN                                                                    
C                                                                               
C FIND FUNCTION  (J IS THE FUNCTION NUMBER)                                     
C                                                                               
   20 CONTINUE                                                                  
      IF (FZFIXED(I).GT.0) THEN                                               
          ISTAT  = FERPFU                                                   
          RETURN                                                                
                                                                                
      END IF                                                                    
                                                                                
      IOFF   = 0                                                                
      DO 30 J = 1,FZNFUN                                                      
          IF (I.LE.IOFF+FZACTPAR(J)) THEN                                     
              IFUN   = FZFCODE(J)                                             
              GO TO 40                                                          
                                                                                
          END IF                                                                
                                                                                
          IOFF   = IOFF + FZACTPAR(J)                                         
   30 CONTINUE                                                                  
      ISTAT  = FERFUN                                                       
      RETURN                                                                    
C                                                                               
C SEARCH FOR INITIAL VALUE IN FSPEC                                             
C                                                                               
   40 FSPEC  = FZSPEC(J)                                                      
      NAME   = PARAM(1:LEN)//'='                                                
      II     = INDEX(FSPEC,NAME(1:LEN+1))                                       
      IF (II.EQ.0) THEN                                                         
          II     = INDEX(FSPEC,')') + 2                                         
                                                                                
      ELSE                                                                      
          II1    = INDEX(FSPEC(II:),' ')                                        
          FSPEC(II:) = FZSPEC(J) (II1:)                                       
      END IF                                                                    
C                                                                               
C INSERT VAL IN POSITION II                                                     
C                                                                               
      IF (FZFIXED(I).EQ.0) THEN                                               
          CVAL   = VAL(1:LENV)//'@'                                             
          L      = LENV + 1                                                     
                                                                                
      ELSE                                                                      
          CVAL   = VAL                                                          
          L      = LENV                                                         
      END IF                                                                    
                                                                                
      FZSPEC(J) = FSPEC(1:II-1)//CVAL(1:L)//FSPEC(II:)                        
      RETURN                                                                    
                                                                                
      END                                                                       

C @(#)rebirbr.for	19.1 (ES0-DMD) 02/25/03 14:25:23
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C @(#)rebirbr.for	19.1  (ESO)  02/25/03  14:25:23 
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++
C .COPYRIGHT   (C) 1993 European Southern Observatory    
C .IDENT       .prg                                      
C .AUTHORS     Pascal Ballester (ESO/Garching)           
C              Cristian Levin   (ESO/La Silla)           
C .KEYWORDS    Spectroscopy, Long-Slit                   
C .PURPOSE                                               
C .VERSION     1.0  Package Creation  17-MAR-1993        
C -------------------------------------------------------

C @(#)rebirbr.for	1.1 (ESO-IPG) 2/17/93 16:46:20
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  8:58 - 9 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.IDENTIFICATION
C
C  SUBROUTINES TDRBII MODIFIED TO REBIN A 2D FRAME ROW BY ROW
C                                          (M.Pierre Nov. 1989)
C.KEYWORDS
C
C  IMAGES, NONLINEAR REBIN, INTERPOLATION, INTEGRATION
C
C.PURPOSE
C
C  NONLINEAR REBIN IMAGE TO IMAGE IN 2 DIMENSIONS
C
C.ALGORITHM
C
C  Rebin input data YI sampled at XI with binwidth WI to
C  output data YO sampled at XO with binwidth WO.
C
C  Restriction:  Input and output independent variables are
C                assumed to be monotonic increasing or decreasing
C
C  Several FUNCTal relations between input and output independent
C  variables are foreseen, additional ones may be added in dummy call
C  U01 as follows:
C
C SUBROUTINE REB_U01 (DV,P,NP,NPC)
C   REAL*8 DV,P(NP)
C   DV = ...........
C   RETURN
C END
C
C  where DV is input-output value, P(NP) the parameter array and
C  NPC the nuber of active parameters in p(np).
C
C  According to the definition of IMAGES, pixels have constant
C  bin width (STEP) [WI;WO], are not overlapping and have filling
C  factors of exactly one. World coordinates [XI;XO] and flux values
C  [YI;YO] are pertinent
C  to the center of a pixel. In flux conservation mode (the default)
C  the flux is interpreted as the area under a smooth curve between
C  the boundaries of the pixel (i.e. a histogram representation of
C  a smooth curve).
C
C  Detailed flux conservation obtained by REAL*8 spline interpolation
C  and  integration of input data over the projected
C  bin WI for fractions of input pixels and summation of flux in
C  entire input pixels covered within the valid domain of input data
C  i.e. from x(1)-0.5*step to x(n)+0.5*step. Several options available
C  to handle undefined input at the extremes and for NULLVALUE assigned
C  parts of input array.
C
C   Optimized for long arrays by search for valid range, optimum
C  direction or DO LOOPS and updating of loop boundaries - therefore
C  overdoing it for small arrays.
C
C.INPUT
C
C  Keys:  IN_A/C/1/8         input data array
C         IN_B/C/1/8         reference frame or dim of output
C         CFUNC/C/1/8        FUNCTal relation between indep.
C         INPUTD/D/1/12      parameters or FUNCT
C         COPT/C/1/8         options
C
C.OUTPUT
C
C  Key:   OUT_A/C/1/8        output data array
C
C.MODIFS
C M Peron sep 90 : remove stupid limit to the size of the output frame!!!!!
C--------------------------------------------------------------------------
C
       PROGRAMM REBIRBR
      IMPLICIT NONE
      INTEGER   NFPAR
      PARAMETER (NFPAR = 12)
C
      INTEGER    MADRID
      INTEGER    I,IACT
      INTEGER*8  IP1,IP2,IP3,IPNTR
      INTEGER    IS,ISTAT
      INTEGER*8  JP1,JP2,JP3,JPNTR
      INTEGER    NAXISI,NAXISO,KUN,KNUL
      INTEGER    NFPACT,NFUNC
      INTEGER    NI,NINT,NN,NO,NBY,NBO,NCOL,NTOT
      INTEGER NPIXI(3),NPIXO(3),INOP,IMNO,IMNI,IREF
       INTEGER JJ,TID,NROW,NSC,NAC,NAR,ICOL(12),STATUS
      REAL    RMIN, RMAX, CUTS(4)
      DOUBLE PRECISION STEPI(3),STARTI(3)
        REAL X0O,WXO,X0I,WXI
      DOUBLE PRECISION DPARM(NFPAR)
      DOUBLE PRECISION DSTART(3), DSTEP(3),YPOS
      CHARACTER*3 FUN(9)
      CHARACTER*60 INPIMA,OUTIMA,REFIMA,TBCOEFF
      CHARACTER*80 FUNCT,OPTION
      CHARACTER*72 IDENTO,IDENTI
      CHARACTER*80 CUNITO,CUNITI
       LOGICAL NULL(12)
C
      INCLUDE 'MID_INCLUDE:TABLES.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:TABLED.INC'
C
      DATA FUN/'LIN','POL','INV','EXP','DEX','LOG','DLG','IPO','U01'/

C
C..... GET INTO MIDAS
       CALL STSPRO('REBLL')
C ... get input parameters
C
      CALL STKRDC('OUT_A',1,1,60,IACT,OUTIMA,KUN,KNUL,ISTAT)
      CALL STKRDC('IN_A', 1,1,60,IACT,INPIMA,KUN,KNUL,ISTAT)
      CALL STKRDC('IN_B', 1,1,60,IACT,REFIMA,KUN,KNUL,ISTAT)
      CALL STKRDC('CFUNC',1,1,8,IACT,FUNCT,KUN,KNUL,ISTAT)
      CALL STKRDC('IN_C', 1,1,60,IACT,TBCOEFF,KUN,KNUL,ISTAT)
      CALL STKRDC('COPT',1,1,8,IACT,OPTION,KUN,KNUL,ISTAT)

C
C ... det. interpolation/integration options
C  !   Not implemented
      INOP   = 4
C      IF (OPTION(1:3).EQ.'PIX') INOP   = 1
C      IF (OPTION(1:3).EQ.'LIN') INOP   = 2
C      IF (OPTION(1:3).EQ.'SPG') INOP   = 3
C .......................................... the actual values are:
      CALL FORUPC(OPTION,OPTION)
      IF (OPTION(1:3).EQ.'PIX') INOP   = 2
      IF (OPTION(1:3).EQ.'LIN') INOP   = 3
      IF (OPTION(1:3).EQ.'SPG') INOP   = 1
C .......................................... Bitte, bitte
C
C ... translate FUNCT into FUNCT number
C
      CALL FORUPC(FUNCT,FUNCT)
      NFUNC  = 0
      DO 10 I = 1,9
          IF (FUNCT(1:3).EQ.FUN(I)) NFUNC  = I
   10 CONTINUE
      IF (NFUNC.EQ.0) THEN
          CALL STTPUT(' Specified FUNCT non-existent...',ISTAT)
          GO TO 60
      END IF
C
C..... init the input table of dispersion coefficients
        CALL TBTOPN(TBCOEFF,F_U_MODE,TID,ISTAT)
       CALL TBIGET(TID,NCOL,NROW,NSC,NAC,NAR,ISTAT)
       NFPACT = NCOL-1

       DO 40 I = 1,NFPACT
       ICOL(I) = I+1
40       CONTINUE       

C
C ... get parameters form reference image
C
      CALL STFOPN(REFIMA,D_R4_FORMAT,0,F_IMA_TYPE,IREF,ISTAT)
      CALL STDRDI(IREF,'NAXIS',1,1,NN,NAXISO,KUN,KNUL,ISTAT)
      CALL STDRDI(IREF,'NPIX',1,NAXISO,NN,NPIXO,KUN,KNUL,ISTAT)
      CALL STDRDD(IREF,'START',1,NAXISO,NN,DSTART,KUN,KNUL,ISTAT)
      CALL STDRDD(IREF,'STEP',1,NAXISO,NN,DSTEP,KUN,KNUL,ISTAT)
      CALL STDRDC(IREF,'IDENT',1,1,72,NN,IDENTO,KUN,KNUL,ISTAT)
      CALL STDRDC(IREF,'CUNIT',1,1,80,NN,CUNITO,KUN,KNUL,ISTAT)
      CALL STFCLO(IREF,ISTAT)
       NTOT = NPIXO(1)*NPIXO(2)
C
C ... get input image
C
      CALL STIGET(INPIMA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     .2,NAXISI,NPIXI,STARTI,STEPI,IDENTI,CUNITI,IPNTR,IMNI,ISTAT)
 
C..... check dimensions
       IF(NPIXI(2).NE.NROW) THEN
       CALL STTPUT('Input table and image have not 
     +       the same number of rows',ISTAT)
       GO TO 50
       ELSE 
       IF(NPIXI(2).NE.NPIXO(2)) THEN
       CALL STTPUT('Input and output images have not 
     +  the same number of rows',ISTAT)
       GO TO 50
             ENDIF
       ENDIF
       CALL TBRRDD(TID,1,1,1,YPOS,NULL,STATUS)
       IF (ABS(YPOS-DSTART(2)).GT.0.001) THEN
        CALL STTPUT(' WARNING:',ISTAT)
       CALL STTPUT('Y_position recorded in the 1st line
     +        of input table is not the same',ISTAT)
        CALL STTPUT('as Y_start of the  output image',ISTAT)
       ENDIF
C ... map output image
C
      CALL STIPUT(OUTIMA,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .NAXISO,NPIXO,DSTART,DSTEP,IDENTO,CUNITO,JPNTR,IMNO,ISTAT)
C

C ... fill the arrays XI,WI and XO,WO
C
      NI     = NPIXI(1)
      NBY    = 8*NI
      CALL TDMGET(NBY,IP1,IS)
      CALL TDMGET(NBY,IP2,IS)
      CALL TDMGET(NBY,IP3,IS)
      X0O     = STARTI(1)
      WXO     = STEPI(1)
C
      NO     = NPIXO(1)
      NBO    = 8*NO
      CALL TDMGET(NBO,JP1,IS)
      CALL TDMGET(NBO,JP2,IS)
      CALL TDMGET(NBO,JP3,IS)
      X0I     = DSTART(1)
      WXI     = DSTEP(1)


C..... DO LOOP ON THE IMAGE ROWS

       DO 100       JJ = 1,NROW

      CALL IMVAL3(NI,X0O,WXO,MADRID(IPNTR),MADRID(IP1),MADRID(IP2),
     +             MADRID(IP3),JJ,NTOT)
      CALL IMVAL2(NO,X0I,WXI,MADRID(JP1),MADRID(JP2))
C
C...... Read dispersion coefficients for row JJ
       CALL TBRRDD(TID,JJ,NFPACT,ICOL,DPARM,NULL,STATUS)
       WRITE(6,*) 'ROW',JJ
C       TYPE *,'COEFF',DPARM(1),DPARM(2),DPARM(3),DPARM(4),DPARM(5)

C  ...  Now, at last, we call the interpolating (and integrating) routines:
C
C  !!!! Watch out for VECI,VECD arrays in INTERP, dimension => NINT !!!!!!
C
      NINT   = 8
      CALL REBMET(NI,MADRID(IP1),MADRID(IP3),MADRID(IP2),NO,
     +             MADRID(JP1),MADRID(JP2),NFUNC,NFPAR,NFPACT,DPARM,
     +             INOP,NINT,MADRID(JP3),RMIN,RMAX)
C
       CALL IMVAL5(NO,JJ,MADRID(JP3),MADRID(JPNTR),NTOT)


C
100       CONTINUE

      CALL TDMFRE(NBY,IP1,IS)
      CALL TDMFRE(NBY,IP2,IS)
      CALL TDMFRE(NBY,IP3,IS)
      CALL TDMFRE(NBO,JP1,IS)
      CALL TDMFRE(NBO,JP2,IS)

C ... write cuts
C
      CUTS(1) = RMIN
      CUTS(2) = RMAX
      CUTS(3) = RMIN
      CUTS(4) = RMAX
      CALL STDWRR(IMNO,'LHCUTS',CUTS,1,4,KUN,ISTAT)
C
C ... free memory
C
 
C ... end
C
      CALL STFCLO(IMNO,ISTAT)
   50 CALL STFCLO(IMNI,ISTAT)
       CALL TBTCLO(TID,ISTAT)
   60 CALL STSEPI
      END

C**************************************************************
      SUBROUTINE IMVAL2(NP,XS,WS,X,W)
C
C  Fill arrays X,W for image world coordinates and pixel size data
C
      IMPLICIT NONE
      INTEGER  I, NP
      REAL     XS, WS
      DOUBLE PRECISION X(NP),W(NP),WSS,XSS
C
      WSS    = WS
      XSS    = XS
      DO 10 I = 1,NP
          X(I)   = XSS + WSS* (I-1)
          W(I)   = WSS
   10 CONTINUE
      RETURN
      END

C------------------------------------------------------------------
      SUBROUTINE IMVAL3(NP,XS,WS,YY,X,W,Y,NL,NTOT)
C
C  Fill arrays X,W for image world coordinates and pixel size data
C  Convert YY(real*4) into Y(real*8)
C
      IMPLICIT NONE
      INTEGER  NP, I,NTOT
       INTEGER NL,IPT
      DOUBLE PRECISION X(NP),W(NP),Y(NP),WSS,XSS
      REAL     XS, WS
      REAL YY(NTOT)
C
      WSS    = WS
      XSS    = XS
      DO 10 I = 1,NP
       IPT = (NL-1)*NP+I
          X(I)   = XSS + WSS* (I-1)
          W(I)   = WSS
          Y(I)   = YY(IPT)
   10 CONTINUE
      RETURN
      END

C----------------------------------------------------------
       SUBROUTINE IMVAL5(N,NL,X,Y,NTOT)
C       FILLS THE BUFFER
       INTEGER I,N,NL,NTOT,NPT

       REAL*4 Y(NTOT),X(N)
       DO 10 I = 1,N
       NPT = (NL-1)*N+I
       Y(NPT) = X(I)
10        CONTINUE
       
       RETURN
       END

 

C @(#)lsqgrd.for	19.1 (ES0-DMD) 02/25/03 13:17:41
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE LSQGRD(NRPNT,NRPRM,FCTVEC,FCTJAC,LJAC,GRD)                     
C      IMPLICIT NONE                                                            
C     .. Scalar Arguments ..                                                    
      INTEGER LJAC,NRPRM,NRPNT                                                  
C     ..                                                                        
C     .. Array Arguments ..                                                     
      DOUBLE PRECISION FCTJAC(LJAC,NRPRM),FCTVEC(NRPNT),GRD(NRPRM)              
C     ..                                                                        
C     .. Local Scalars ..                                                       
      DOUBLE PRECISION S                                                        
      INTEGER I,J                                                               
C     ..                                                                        
C     .. External Files ..                                                      
       INCLUDE 'MID_INCLUDE:FITNAGI.INC/NOLIST'                                 
       INCLUDE 'MID_INCLUDE:FITNAGC.INC/NOLIST'                                 
C     ..                                                                        
C     .. Executable Statements ..                                               
      DO 20 I = 1,NRPRM                                                         
          S      = 0.D0                                                         
          IF (FIXPAR(I).LT.0) THEN                                              
              DO 10 J = 1,NRPNT                                                 
                  S      = S + FCTJAC(J,I)*FCTVEC(J)                            
   10         CONTINUE                                                          
          END IF                                                                
                                                                                
          GRD(I) = S + S                                                        
   20 CONTINUE                                                                  
      RETURN                                                                    
                                                                                
      END                                                                       

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
         PROGRAM OPTAB
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION: OPTAB.FOR
C.PURPOSE: Create and fill in TYPE and CHECK columns
C.AUTHOR: Alessandra Gemmo               Padova Department of Astronomy
C.VERSION:  910617 AG Creation
C.VERSION:  910826 AG Modified to include TBLSER routine and move computation
C.                    of precession to a separate procedure.
C 
C 100616	last modif
C-------------------------------------------------------------------------------
         IMPLICIT NONE
C
C ***
C
         INTEGER       MADRID(1)
         INTEGER       NRINP
         INTEGER       NCINP
         INTEGER       NROUT
         INTEGER       NCOUT
         INTEGER       NCPAR1
         PARAMETER     (NCOUT=15)
         PARAMETER     (NCPAR1=2)
         PARAMETER     (NROUT=300)
         INTEGER       ISTAT,IAC
         INTEGER       KUN,KNUL
         INTEGER       NACINP,NARINP,NSINP
         INTEGER       OUTTYP,OUTCOL,OUTCO(2),COLNUM(10)
         INTEGER       TIDINP
         INTEGER       I1,I2,I5
C
C ***
C
         DOUBLE PRECISION        AHR,AMIN,ASEC
         DOUBLE PRECISION        DDEG,DMIN,DSEC
         DOUBLE PRECISION        DRA,DDEC
C
C ***
C
         CHARACTER*80     STRING(10)
         CHARACTER*60     INPFIL
         CHARACTER*16     LABEL1(NCPAR1),LABEL2,OUTLAB
         CHARACTER*16     UNIT1(NCPAR1),UNIT2,OUTUNI
         CHARACTER*16     OUTFOR
         CHARACTER*16     FORMC1
         CHARACTER*16     FORMR8(2)
         CHARACTER*1      CHECK,SIGN
         CHARACTER      CTEST*4
C
C ***
C
         LOGICAL          NULL
C
C ***
C
         INCLUDE       'MID_INCLUDE:ST_DEF.INC'
         COMMON        /VMR/MADRID
         INCLUDE       'MID_INCLUDE:ST_DAT.INC'
C
C ***
C
         DATA          LABEL1/'RA     ','DEC    '/
         DATA          UNIT1 /'HOURS   ','DEGREES '/
         DATA          LABEL2/'CHECK   '/
         DATA          UNIT2 /'        '/
C
C ***
C
         DATA          FORMC1 /'A1'/
         DATA          FORMR8 /'F12.9','F12.9'/
C
C ***
C
         DATA          CHECK    /' '/
C
C *** start the code
C
         CALL STSPRO('OPTAB')
C
C *** get input table
C
         CALL STKRDC('OUTPUTF',1,1,60,IAC,INPFIL,KUN,KNUL,ISTAT)
C
C *** open input table
C
         CALL TBTOPN(INPFIL,F_IO_MODE,TIDINP,ISTAT)
C
C *** get information about input table
C
         CALL TBIGET(TIDINP,NCINP,NRINP,NSINP,NACINP,NARINP,ISTAT)
         IF(NRINP.EQ.0)THEN       !no rows in table
           STRING(1) = '*** FATAL: There are no data in input table'
           CALL STETER(9,STRING(1))
         ENDIF
C
C *** initialize CHECK column
C
           OUTTYP = D_C_FORMAT
           OUTFOR = FORMC1
           OUTUNI = UNIT2
           OUTLAB = LABEL2
           CALL TBCINI(TIDINP,OUTTYP,1,OUTFOR,OUTUNI,
     2                        OUTLAB,OUTCOL,ISTAT)
C
C *** fill in CHECK column
C
         DO I5=1,NRINP
           CALL TBEWRC(TIDINP,I5,OUTCOL,CHECK,ISTAT)
         ENDDO
C
C *** initialize DRA and DDEC columns
C
         DO I1=1,NCPAR1
           OUTTYP = D_R8_FORMAT
           OUTFOR = FORMR8(I1)
           OUTUNI = UNIT1(I1)
           OUTLAB = LABEL1(I1)
           CALL TBCINI(TIDINP,OUTTYP,1,OUTFOR,OUTUNI,
     2                        OUTLAB,OUTCO(I1),ISTAT)
         ENDDO
C
C *** fill in DRA and DDEC columns
C
         DO I2=1,NRINP
           CALL TBLSER(TIDINP,'AHR',COLNUM(1),ISTAT)
           CALL TBERDD(TIDINP,I2,COLNUM(1),AHR,NULL,ISTAT)
C
           CALL TBLSER(TIDINP,'AMIN',COLNUM(2),ISTAT)
           CALL TBERDD(TIDINP,I2,COLNUM(2),AMIN,NULL,ISTAT)
C
           CALL TBLSER(TIDINP,'ASEC',COLNUM(3),ISTAT)
           CALL TBERDD(TIDINP,I2,COLNUM(3),ASEC,NULL,ISTAT)
C
           CALL TBLSER(TIDINP,'SIGN',COLNUM(4),ISTAT)
           CALL TBERDC(TIDINP,I2,COLNUM(4),CTEST,NULL,ISTAT)
           SIGN = CTEST(1:1)
C
           CALL TBLSER(TIDINP,'DDEG',COLNUM(5),ISTAT)
           CALL TBERDD(TIDINP,I2,COLNUM(5),DDEG,NULL,ISTAT)
C
           CALL TBLSER(TIDINP,'DMIN',COLNUM(6),ISTAT)
           CALL TBERDD(TIDINP,I2,COLNUM(6),DMIN,NULL,ISTAT)
C
           CALL TBLSER(TIDINP,'DSEC',COLNUM(7),ISTAT)
           CALL TBERDD(TIDINP,I2,COLNUM(7),DSEC,NULL,ISTAT)
C
           DRA = AHR+AMIN/60.+ASEC/3600.
           DDEC = DDEG+DMIN/60.+DSEC/3600.
           IF(SIGN.EQ.'-')DDEC = -DDEC
C
           CALL TBEWRD(TIDINP,I2,OUTCO(1),DRA,ISTAT)
           CALL TBEWRD(TIDINP,I2,OUTCO(2),DDEC,ISTAT)
         ENDDO  
C
C *** close the table
C
         CALL TBTCLO(TIDINP,ISTAT)
C *** over and out
C
         CALL STSEPI
         END

C @(#)spec1.for	19.1 (ES0-DMD) 02/25/03 13:24:48
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
       PROGRAM SPEC1
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C
C  Program SPEC1                  version 1.00   860706
C                                 version 2.00   890424 (pMIDAS)
C  F. Murtagh                            STECF              
C  M. Peron                              IPG     890901  add include files
C  P. Ballester                          IPG     910313  Compil. option -u
C                                                        and more
C
C.KEYWORDS
C  Simulated images, test images.
C
C.PURPOSE
C  Create sloping "wave" image, given the slope, amplitude, period, 
C  phase, and dimensions of the image.
C
C.OUTPUT
C
C  Keys:  OUT_A/C/1/60       output data array
C         INPUTR/R/1/1       slope
C         INPUTR/R/2/1       amplitude
C         INPUTR/R/3/1       period
C         INPUTR/R/4/1       phase
C         INPUTI/I/1/1       frame dimensions
C
C-------------------------------------------------------------------------
C
C
       IMPLICIT NONE
C
       CHARACTER*60              OUTIMA
       CHARACTER*72              IDENTO
       CHARACTER*80              CUNIT0
       REAL                      RMIN,RMAX
       REAL                      STEPO(3),STARTO(3),CUTS(4)
       DOUBLE PRECISION          DSTEP(3),DSTART(3)
       INTEGER                   NPIXO(3), KUN, KNUL, IACT
       INTEGER                   MADRID
C
       INTEGER                   ISTAT,IDIM,NDIMO
       INTEGER*8                 JPNTR
       INTEGER                   IMNO,KUNIT
       REAL                      SLOPE,AMPL,PERIOD,PHASE,CUNITO        
C
       INCLUDE                   'MID_INCLUDE:ST_DEF.INC'
       COMMON/VMR/MADRID(1)
       INCLUDE                   'MID_INCLUDE:ST_DAT.INC'
C
C
C ... get into MIDAS
C
       CALL STSPRO('SPEC1')
C
C ... get name of output frame
C
        CALL STKRDC('OUT_A',1,1,60,IACT,OUTIMA,KUN,KNUL,ISTAT)
C
C ... get slope, amplitude, period, phase and frame dimensions.
C
        CALL STKRDR('INPUTR',1,1,IACT,SLOPE,KUN,KNUL,ISTAT)
        CALL STKRDR('INPUTR',2,1,IACT,AMPL,KUN,KNUL,ISTAT)
        CALL STKRDR('INPUTR',3,1,IACT,PERIOD,KUN,KNUL,ISTAT)
        CALL STKRDR('INPUTR',4,1,IACT,PHASE,KUN,KNUL,ISTAT)
        CALL STKRDI('INPUTI',1,1,IACT,IDIM,KUN,KNUL,ISTAT)
C
C ... map output image
C
       NDIMO = 1
       NPIXO(1)  = IDIM
       STARTO(1) = 1
       STEPO(1)  = 1.0
       CUNIT0    = ' NONE'
       IDENTO    = ' ARTIFICIAL SINUSOIDAL 1-D IMAGE' 
       DSTART(1) = STARTO(1)
       DSTEP(1)  = STEPO(1)
       CALL STIPUT(OUTIMA,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,NDIMO,
     .                  NPIXO,DSTART,DSTEP,
     .                  IDENTO,CUNITO,JPNTR,IMNO,ISTAT)
C
C ... now do the work
C
       CALL PATTRN(MADRID(JPNTR),RMIN,RMAX,SLOPE,AMPL,PERIOD,PHASE,
     X      IDIM,ISTAT)
C
C ... write cuts
C
       CUTS(1) = RMIN
       CUTS(2) = RMAX
       CUTS(3) = RMIN
       CUTS(4) = RMAX
        CALL STDWRR(IMNO,'LHCUTS',CUTS,1,4,KUNIT,ISTAT)
C
C ... end
C
       CALL STSEPI
       END

C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C
C  Program PATTRN    
C  F. MURTAGH                                 ST-ECF  Version 1.0 860411
C
C.KEYWORDS
C
C  Test patterns, simulated images.
C
C
C.OUTPUT PARAMETERS
C 
C  ARR  = the frame,
C  RMIN, RMAX = cut values (max. and min. flux values).
C
C----------------------------------------------------------------------
       SUBROUTINE PATTRN(ARR,RMIN,RMAX,SLOPE,AMPL,PERIOD,PHASE,IDIM,
     X                          ISTAT)
       IMPLICIT NONE
       INTEGER           IDIM,ISTAT,NDIM1,I
       REAL              RMIN,RMAX,SLOPE,AMPL,PERIOD,PHASE,VALMIN
       REAL              ANGLE,TOT
       REAL              ARR(IDIM)
C
C
C
       NDIM1 = IDIM
C
       VALMIN = 1000000.0
       DO I = 1, NDIM1
          ANGLE = (2*3.1415926/PERIOD)*FLOAT(I) - PHASE  ! Angle at I
          ARR(I) = AMPL*SIN(ANGLE)                       ! => y-value.
          ARR(I) = ARR(I)+SLOPE*FLOAT(I)                 ! Slope this.  
          IF (ARR(I).LT.VALMIN) VALMIN = ARR(I)
       ENDDO
C
C  Normalize to average of 100.0 flux units per pixel.
C
       TOT = 0.0
       DO I = 1, NDIM1
          ARR(I) = ARR(I) + VALMIN
          TOT = TOT + ARR(I)
       ENDDO
       TOT = TOT/FLOAT(NDIM1)
       DO I = 1, NDIM1
          ARR(I) = ARR(I)*(100.0/TOT)
       ENDDO
C
C
C ------DETERMINE CUTS (I.E. MAX AND MIN VALUES)---------------------
C
       RMIN = 1000000.
       RMAX = -100000.
       DO I = 1, NDIM1
          IF (ARR(I).LT.RMIN) RMIN = ARR(I)
          IF (ARR(I).GT.RMAX) RMAX = ARR(I)
       ENDDO
C
C
       RETURN
C
       END

C @(#)tdtypchk.for	19.1 (ES0-DMD) 02/25/03 13:57:59
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  19:59 - 11 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION        TDTYPCHK.FOR
C.KEYWORDS           TABLE, APPLICATIONS
C.ENVIRONMENT  MIDAS
C.PURPOSE
C
C CHECK EXTERNAL DATA TYP AND GENERATE INTERNAL CODE
C MODIFICATION OF GENTYP ROUTINE TO ALLOW FOR TABLE CODES
C
C
C------------------------------------------------------------------
      SUBROUTINE TDTCHK(INTYP,OUTYP,BYTELE)
C
      IMPLICIT NONE
      CHARACTER*(*) INTYP  ! IN : external type (I*4, R*4, R*8, C*N)
      CHARACTER*1 OUTYP    ! OUT: internal type as I, R, R, C or ' ' (invalid)
      INTEGER BYTELE       ! OUT: code -4 real or integer, -8 double, >0 char
C
      INTEGER LL, LL1, LEN, INDEX
      CHARACTER*80 SDUM
C
C ... CHECK FOR LIMITS
C
      LL     = INDEX(INTYP,'*')
      IF (LL.EQ.0) THEN
          BYTELE = 0
          IF (INTYP(1:1).EQ.'C') THEN
              OUTYP  = 'C'
          ELSE
              OUTYP  = ' '
          END IF
          RETURN
      END IF
C
C ... GET LENGTH
C
      SDUM   = INTYP//' '
      OUTYP  = INTYP(1:1)
      LL1    = INDEX(SDUM,' ') - 1
      LEN    = LL1 - LL
      IF (LEN.GT.0) THEN
          READ (INTYP(LL+1:LL1),9000,ERR=10) BYTELE
          IF (OUTYP.EQ.'I' .OR. OUTYP.EQ.'R') THEN
              BYTELE = -BYTELE
          ELSE IF (OUTYP.NE.'C') THEN
              BYTELE = 0
              OUTYP  = ' '
          END IF
      ELSE
          BYTELE = 0
          IF (OUTYP.NE.'C') OUTYP  = ' '
      END IF
      RETURN
   10 BYTELE = 0
      OUTYP  = ' '
      RETURN
C1000 FORMAT(I<LEN>)
 9000 FORMAT (I6)
      END

      SUBROUTINE TDTYP1(ETYPE,DTYPE,NOELEM)
C
C     Transform data type from external (I*4, R*4, R*8, C*n) into
C     internal code
C
      IMPLICIT NONE
      CHARACTER*(*) ETYPE  ! IN : external type 
      INTEGER       DTYPE  ! OUT: data type code
      INTEGER       NOELEM ! OUT: no of elements
C
      INTEGER       LL, INDEX, LL1
      CHARACTER*20  SDUM
C
      INCLUDE       'MID_INCLUDE:TABLES.INC'
      INCLUDE       'MID_INCLUDE:TABLED.INC'
C
      LL     = INDEX(ETYPE,'*')
C
C ... character string
C
      IF (ETYPE(1:1) .EQ. 'C' .OR. ETYPE(1:1) .EQ. 'c') THEN
          DTYPE  = D_C_FORMAT
          SDUM   = ETYPE//' '
          LL1    = INDEX(SDUM,' ') - 1
          READ (SDUM(LL+1:LL1),9000,ERR=10) NOELEM
          RETURN
      ENDIF
      NOELEM = 1                                
      DTYPE  = 0
      IF (ETYPE(1:3).EQ.'I*4'.OR.ETYPE(1:3).EQ.'i*4') 
     .   DTYPE=D_I4_FORMAT
      IF (ETYPE(1:3).EQ.'R*4'.OR.ETYPE(1:3).EQ.'r*4') 
     .   DTYPE=D_R4_FORMAT
      IF (ETYPE(1:3).EQ.'R*8'.OR.ETYPE(1:3).EQ.'r*8') 
     .   DTYPE=D_R8_FORMAT
      RETURN
   10 NOELEM = 0
      RETURN
 9000 FORMAT (I3)
      END

      SUBROUTINE TDTYP2(DTYPE,NOELEM,ETYPE)
C
C     Transform data type from internal into external 
C     (I*4, R*4, R*8, C*n) code
C
      IMPLICIT NONE
      INTEGER       DTYPE  ! IN : data type code
      INTEGER       NOELEM ! IN : no of elements
      CHARACTER*(*) ETYPE  ! OUT: external type 
C
      INCLUDE       'MID_INCLUDE:TABLES.INC'
      INCLUDE       'MID_INCLUDE:TABLED.INC'
C
      IF(DTYPE.EQ.D_I4_FORMAT) ETYPE = 'I*4'
      IF(DTYPE.EQ.D_R4_FORMAT) ETYPE = 'R*4'
      IF(DTYPE.EQ.D_R8_FORMAT) ETYPE = 'R*8'
      IF(DTYPE.EQ.D_C_FORMAT) WRITE(ETYPE,9000,ERR=10) NOELEM
      RETURN
   10 ETYPE = ' '
      RETURN
 9000 FORMAT ('C',I3.3)
      END

C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION        ISTPHO.FOR
C.AUTHOR:               J.D.PONZ  ESA-VILSPA        
C.KEYWORDS              IUE, GO FORMAT, PHOTOM IMAGE
C.PURPOSE
C  \begin{TeX}
C    Reads the PHOTOM image file and stores the information into a MIDAS 
C    image. The format of the image is controlled by the argument
C    DSKFMT as follows:
C       \begin{itemize}
C         \item  0 = floating point
C         \item  1 = 2-byte two's complement integer
C         \item -1 = the disk file is not created. Used to list header only.
C       \end{itemize}
C    The routine performs the following functions (routine name in brackets)
C    \begin{enumerate}
C    \item  Handles the file header (ISTFHD)
C    \item Creates the MIDAS image file (STFCRE)
C    \item Iterates on the image lines to:
C         \begin{itemize}
C           \item Read image line (ISTREA)
C           \item Decode pixel info according to DSKFMT
C           \item Write line into file (STFPUT)
C         \end{itemize}
C    \item Writes standard image descriptors (STDWRx)
C    \item Writes IUE specific descriptors (ISTDES)
C    \item Closes the image file (STFCLO)
C    \end{enumerate}
C \end{TeX}
C.LANGUAGE:               F77 
C.COMMENTS
C  \begin{TeX}
C    The following extensions are used:
C    \begin{itemize}
C     \item IMPLICIT NONE
C     \item INCLUDE statement
C     \item long variable names
C     \item underscore character
C    \end{itemize}
C \end{TeX}
C.VERSION: 1.0  INITIAL CODING  09 JUL 1990
C.VERSION: 1.1  REMOVE VMW EXTENSIONS. 14 APR 1992  
C------------------------------------------------------------------
      SUBROUTINE ISTPHO(CHANL,BUFF,FILE,DSKFMT,DSPFLG,STATUS)
C
      IMPLICIT NONE
      INTEGER       CHANL             ! IN: tape channel number
      CHARACTER*(*) BUFF              ! IN: buffer with the ascii header
      CHARACTER*(*) FILE              ! IN: file name
      INTEGER       DSKFMT            ! IN: disk format (0:R*4,  1:I*2)
      INTEGER       DSPFLG            ! IN: display flag
      INTEGER       STATUS            ! OUT: status
C
      INTEGER   DTYPE, NO, SIZE, FELM, NL, NR, LEN, I, J
      INTEGER   NAXIS(1), NPIX(2), DUM(1), NP
      INTEGER   IBUFF(768)
      INTEGER   BBUFF(1536)
      REAL      RBUFF(768)
      REAL      CUTS(4), XMAX
      DOUBLE PRECISION START(2), STEP(2)
      CHARACTER*72 IDENT, CUNIT
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      EQUIVALENCE  (IBUFF(1),BBUFF(1))
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
      DATA CUNIT/'FN              PIXEL           PIXEL '/
C
      NL     = 768
      NR     = 1536
      NP     = 768
      STATUS = 0
      SIZE   = 768*768
C
C ... decode full header, print it and put info in common area
C
      CALL ISTFHD(CHANL,BUFF,DSPFLG,STATUS)
      IF (STATUS.NE.0) RETURN
      IF (DSKFMT.LT.0) RETURN      ! only displays the header
C
C ... create the frame
C
      IF (DSKFMT.EQ.0) THEN
          DTYPE = D_R4_FORMAT
      ELSE
          DTYPE = D_I2_FORMAT
      ENDIF
      CALL STFCRE(FILE,DTYPE,F_O_MODE,F_IMA_TYPE,SIZE,NO,STATUS)
      IF (STATUS.NE.0) RETURN
C
C ... loop to read tape and write into disk
C
      XMAX = 0.
      FELM = 1
      IF (DSKFMT.EQ.0) THEN                        ! write with conversion
        DO 10 I = 1, NL
           CALL ISTRHW(CHANL,BBUFF,NR,LEN,STATUS)
           IF (NR.NE.LEN .OR. STATUS.NE.0) RETURN
           DO 5 J = 1, NP
               RBUFF(J)  = IBUFF(J)
               XMAX      = AMAX1(XMAX,RBUFF(J))
  5        CONTINUE
           CALL STFPUT(NO,FELM,NP,RBUFF,STATUS)
           IF (STATUS.NE.0) RETURN            
           FELM = FELM + NP
 10     CONTINUE
      ELSE                                         ! write without conversion
        DO 20 I = 1, NL
           CALL ISTRH1(CHANL,BBUFF,NR,LEN,STATUS)
           IF (NR.NE.LEN .OR. STATUS.NE.0) RETURN
           CALL STFPUT(NO,FELM,NP,IBUFF,STATUS)
           IF (STATUS.NE.0) RETURN            
           FELM = FELM + NP
 20     CONTINUE
        XMAX = 32767                                ! MAXIMUM HARDCODED
      ENDIF
C
C ... write image descriptors
C
      NAXIS(1) = 2
      NPIX(1)  = 768
      NPIX(2)  = 768
      START(1) = 1.0D0
      START(2) = 1.0D0
      STEP(1)  = 1.0D0
      STEP(2)  = 1.0D0
      CUTS(1)  = 0.
      CUTS(2)  = XMAX
      CUTS(3)  = 0.
      CUTS(4)  = XMAX
      IDENT    = BUFF(145:210)
      CALL STDWRI(NO,'NAXIS',NAXIS,1,1,DUM,STATUS)
      CALL STDWRI(NO,'NPIX',NPIX,1,2,DUM,STATUS)
      CALL STDWRD(NO,'START',START,1,2,DUM,STATUS)
      CALL STDWRD(NO,'STEP',STEP,1,2,DUM,STATUS)
      CALL STDWRR(NO,'LHCUTS',CUTS,1,4,DUM,STATUS)
      CALL STDWRC(NO,'IDENT',1,IDENT,1,72,DUM,STATUS)
      CALL STDWRC(NO,'CUNIT',1,CUNIT,1,48,DUM,STATUS)
C
C ... write label descriptors
C
      CALL ISTDES(NO,BUFF,STATUS)
      CALL STFCLO(NO,STATUS)
      RETURN
      END

C @(#)irsflat.for	19.1 (ES0-DMD) 02/25/03 14:23:43
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.COPYRIGHT   (C) 1992 European Southern Observatory
C.IDENT       .for
C.AUTHOR      E. Oliva,  Firenze-Arcetri
C.KEYWORDS    Spectroscopy, IRSPEC
C
C.PURPOSE     Execute command  ...
C
C.ALGORITHM
C
C
C.INPUT/OUTPUT
C
C
C.VERSION     1.0    Creation     02.09.1992   E. Oliva
C
C-------------------------------------------------------
C
      PROGRAM IRFLAT
      IMPLICIT REAL(A-H,O-Z)
      IMPLICIT INTEGER(I-N)

      CHARACTER*64 CUNIT
      CHARACTER*72 IDENT
      INTEGER*8 INPNTR,OUPNTR
      INTEGER NPIX(2),MMPIX(2)
      REAL CUTS(2)
      DOUBLE PRECISION START(2),STEP(2)
      COMMON /VMR/ MADRID(1)

      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'

      DATA MAXDIM/2/

      IRET=1
      CALL STSPRO('IRFLAT')
C
C GET INPUT FRAME AND MAP IT
C CHECK ALSO WHETHER IT IS A 2D FRAME.....
C
      CALL STIGET('middummb',D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,MAXDIM,
     ,            NAXIS,NPIX,START,STEP,
     ,            IDENT,CUNIT,INPNTR,NIN,ISTAT)
      IF(NAXIS.NE.2) 
     +     CALL STETER(1,'Input frame must be 2-D')
C
C GET OUTPUT FRAME AND MAP IT
C
      CALL STIPUT('middummc',D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     ,            NAXIS,NPIX,START,STEP,
     ,            IDENT,CUNIT,OUPNTR,NOU,ISTAT)
C
C GET key TO DEFINE threshold value
C
      CALL STKRDR('thres',1,1,IRET,THRES,KUNIT,KNUL,ISTAT)
C
C GET key TO DEFINE the value to which vignetted pixels must be
C forced.
C
      CALL STKRDR('vignet',1,1,IRET,VIGNET,KUNIT,KNUL,ISTAT)
C
C CALL ROUTINE WHICH which divides by a constant and modifies vignetted
C rows
C
      CALL NORMAL(MADRID(INPNTR),MADRID(OUPNTR),
     ,                NPIX(1),NPIX(2),THRES,VIGNET)
C
C Define and write cuts of output file
C
      CALL MNMX(MADRID(OUPNTR),NPIX,CUTS,MMPIX)
      CALL STDWRR(NOU,'LHCUTS',CUTS,3,2,KUNIT,ISTAT)
C
C RELEASE FILES, UPDATE KEYWORDS AND EXIT
C
      CALL STSEPI
      END
C
C
C
      SUBROUTINE NORMAL(A,B,NX,NY,THRES,VIGNET)
C
C divides the input frame by the average
C value of the central 10 rows (=AVER_CENT)
C In the computation of AVER_CENT the first and last 2 pixels
C of each row are not considered to avoid edge effects.
C
C All rows with average signal<THRES*AVER_CENT
C are not considered and the output is forced=VIGNET
C
      IMPLICIT REAL(A-H,O-Z)
      IMPLICIT INTEGER(I-N)


      DIMENSION A(NX,NY),B(NX,NY)
C
C Define average value of central 10 rows
C
      NYC=NY/2
      NCENT=0
      AVER_CENT=0.
      DO IX=3,NX-3
        DO IY=NYC-2,NYC+2
          AVER_CENT=AVER_CENT+A(IX,IY)
          NCENT=NCENT+1
        ENDDO
      ENDDO
      AVER_CENT=AVER_CENT/NCENT

      DO IY=1,NY
        AVEY=0.0
        NAVE=0
        DO IX=1,NX
          IF(IX.GT.2 .AND. IX.LT.(NX-2)) THEN
            AVEY=AVEY+A(IX,IY)
            NAVE=NAVE+1
          ENDIF
          B(IX,IY)=A(IX,IY)/AVER_CENT
        ENDDO
        AVEY=AVEY/NAVE
        IF(AVEY.LT.(THRES*AVER_CENT)) THEN
          DO IX=1,NX
            B(IX,IY)=VIGNET
          ENDDO
        ENDIF
      ENDDO
C
      RETURN
      END

C @(#)tdmregr.for	19.1 (ES0-DMD) 02/25/03 14:11:18
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:54 - 11 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C.IDENTIFICATION        TDMREGR.FOR
C.KEYWORDS           TABLE, APPLICATIONS
C.ENVIRONMENT  MIDAS
C.PURPOSE
C     THE SUBROUTINE DOES A MULTIPLE REGRESION ANALYZES ON THE MATRIX
C     'A(N,N)' WITH THE WEIGHTS 'WM(N)'
C
C.ALGORITHM
C
C M.A.EFROYMSON IN
C A.RALSTON & H.S.WILF,
C MATHEMATICAL METHODS FOR DIGITAL COMPUTERS, VOL 1
C JOHN WILEY & SONS, 1967
C
C
C------------------------------------------------------------------

      SUBROUTINE TDMLRG(A,N,WM,TW,COE,RMS,F1,F2,TOL)
      IMPLICIT NONE
      INTEGER N  !   IN : number of variables (dep + indep.)
      DOUBLE PRECISION A(N,N)  !   IN : matrix with correlation coeffs.
      DOUBLE PRECISION WM(N)  !   IN : weighted sum of variables
      DOUBLE PRECISION TW  !   IN : total weight
      DOUBLE PRECISION COE(N)  !   OUT: regression coeffs.
      REAL RMS(N)  !   OUT : standard errors on the coeffs.
      REAL F1  !   IN :  F value to enter variable
      REAL F2  !   IN :  F value to remove variable
      DOUBLE PRECISION TOL ! IN : the zero level of the matrix
C
      INTEGER NM1,I,J,IP1,NO,NMIN,NMAX,K
      DOUBLE PRECISION DF1,DF2,FI,SY,BO,BX,VMIN,VMAX,VI,AKK
      DOUBLE PRECISION B(10),RO(10),S(10)
C
C     INITIATE COUNTERS AND ARRAYS
C
      IF (N.LT.2 .OR. N.GT.10) RETURN
      NM1    = N - 1
      DO 10 I = 1,N
          S(I)   = 0.0D0
          COE(I) = 0.D0
          RMS(I) = 0.0
   10 CONTINUE
      IF (F1.LT.F2) F1     = F2
      DF1    = DBLE(F1)
      DF2    = DBLE(F2)
C
C     NORMALIZE MATRIX AND WEIGHTED SUMS
C
      DO 30 I = 1,N
          DO 20 J = 1,N
              A(I,J) = A(I,J) - WM(I)*WM(J)/TW
   20     CONTINUE
   30 CONTINUE
      DO 40 I = 1,N
          WM(I)  = WM(I)/TW
          IF (A(I,I).LT.0.0D0) RETURN
          RO(I)  = DSQRT(A(I,I))
   40 CONTINUE
      DO 60 I = 1,NM1
          IP1    = I + 1
          DO 50 J = IP1,N
              A(I,J) = A(I,J)/ (RO(I)*RO(J))
              A(J,I) = A(I,J)
   50     CONTINUE
   60 CONTINUE
      DO 70 I = 1,N
          A(I,I) = 1.0D0
   70 CONTINUE
C
C     DO THE MATRIX MANIPULATIONS
C
      FI     = TW - 1.0D0
      NO     = 0
   80 IF (FI.LE.0.0D0) RETURN
      SY     = RO(N)*DSQRT(A(N,N)/FI)
      NO     = NO + 1
      IF (NO.GT.1000) GO TO 190
      VMIN   = 1.0D30
      VMAX   = 0.0D0
      NMIN   = 0
      NMAX   = 0
C
      DO 110 I = 1,NM1
          B(I)   = 0.0D0
          S(I)   = 0.0D0
          IF (A(I,I).LE.TOL) GO TO 110
          VI     = A(I,N)*A(N,I)/A(I,I)
          IF (VI) 100,110,90
   90     IF (VI.LE.VMAX) GO TO 110
          VMAX   = VI
          NMAX   = I
          GO TO 110

  100     B(I)   = A(I,N)*RO(N)/RO(I)
          S(I)   = SY*DSQRT(A(I,I))/RO(I)
          IF (DABS(VI).GE.DABS(VMIN)) GO TO 110
          VMIN   = VI
          NMIN   = I
  110 CONTINUE
C
      BX     = 0.0D0
      DO 120 I = 1,NM1
          BX     = BX + B(I)*WM(I)
  120 CONTINUE
      BO     = WM(N) - BX
      IF (DABS(VMIN)*FI.GE.DF2*A(N,N)) GO TO 130
      K      = NMIN
      FI     = FI + 1.0D0
      GO TO 140

  130 IF (VMAX* (FI-1.0D0).LE.DF1* (A(N,N)-VMAX)) GO TO 190
      K      = NMAX
      FI     = FI - 1.0D0
C
  140 CONTINUE
      AKK    = A(K,K)
      DO 160 I = 1,N
          IF (I.EQ.K) GO TO 160
          DO 150 J = 1,N
              IF (J.EQ.K) GO TO 150
              A(I,J) = A(I,J) - A(I,K)*A(K,J)/AKK
  150     CONTINUE
  160 CONTINUE
C
      DO 170 I = 1,N
          IF (I.EQ.K) GO TO 170
          A(I,K) = -A(I,K)/AKK
  170 CONTINUE
      DO 180 J = 1,N
          IF (J.EQ.K) GO TO 180
          A(K,J) = A(K,J)/AKK
  180 CONTINUE
      A(K,K) = 1.0D0/AKK
      GO TO 80
C
C     REGRATION ANALYZES IS FINISHED GET RESULTS OUT
C
  190 CONTINUE
      DO 200 I = 1,NM1
          COE(I) = B(I)
          RMS(I) = SNGL(S(I))
  200 CONTINUE
      COE(N) = BO
      RMS(N) = SNGL(SY)
      RETURN

      END

C @(#)gd8d2.for	19.1 (ES0-DMD) 02/25/03 13:55:08
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
	SUBROUTINE
     +	GD8006(DISPLAY,TOTCONF,SZX,SZY,DEPTH,NLUT,NITT,NCURS,IDST)
C	
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine IIDQDV		version 1.00	880118
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  DeAnza, configuration
C
C.PURPOSE
C  fulfill the requirements as described in the IDI document
C
C.ALGORITHM
C  use DeAnza level 0 + 1 software
C
C.INPUT/OUTPUT
C  call as  IIDQDV(DISPLAY,TOTCONF,SZX,SZY,DEPTH,NLUT,NITT,NCURS,IDST)
C
C  input par:
C  DISPLAY:	I*4		display id.
C
C  output par:
C  TOTCONF:	I*4		number of available configurations
C  SZX:		I*4		display size in x
C  SZY:		I*4		display size in y
C  DEPTH:	I*4		display depth
C  NLUT:	I*4		number of LUTs
C  NITT:	I*4		number of ITTs
C  NCURS:	I*4		number of cursors
C  IDST:	I*4		return status
C	
C--------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,TOTCONF,SZX,SZY,DEPTH,
     +                  NLUT,NITT,NCURS,IDST
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
	INCLUDE	'MID_INCLUDE:IDIDEV.INC'
	INCLUDE	'MID_INCLUDE:IDIMEM.INC'
C	
C  use DZDEV to return some of the required info
	TOTCONF = 2
	SZX = QDSZX
	SZY = QDSZY
	DEPTH = QDDEP
	NLUT = 4
	NITT = 4
	NCURS = 2
C
C  that's it folks...
	IDST = 0
	RETURN
	END

	SUBROUTINE GD8009(DISPLAY,CONFNO,MEMTYP,TOTMEM,
     +                    CONFMODE,MEMID,MEMSZX,MEMSZY,MEMDEP,
     +	                  ITTDEP,NOMEM,IDST)
C	
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine IIDQDC		version 1.00	880118
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  DeAnza, configuration
C
C.PURPOSE
C  fulfill the requirements as described in the IDI document
C
C.ALGORITHM
C  use DeAnza level 0 + 1 software
C
C.INPUT/OUTPUT
C  call as IIDQDC(DISPLAY,CONFNO,MEMTYP,TOTMEM,CONFMODE,MEMID,MEMSZX,MEMSZY,
C                 MEMDEP,ITTDEP,NOMEM,IDST)
C
C  input par:
C  DISPLAY:	I*4		display id.
C  CONFNO:	I*4		configuration number, starting with 1
C  MEMTYP:	I*4		type of memory:
C				= 1 for image, = 2 for alphanumeric,
C				= 4 for graphics (and bit combinations...)
C  TOTMEM:	I*4		max. no. of memories
C
C  output par:
C  CONFMODE:	I*4		configuration mode
C  MEMID:	I*4 		memory id's
C  MEMSZX:	I*4		memory size in x
C  MEMSZY:	I*4		memory size in y
C  MEMDEP:	I*4		memory depth
C  ITTDEP:	I*4		depth of connected ITT's
C  NOMEM:	I*4		number of memories
C  IDST:	I*4		return status
C	
C--------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,CONFNO,MEMTYP,TOTMEM
	INTEGER*4	CONFMODE,MEMID(1),MEMSZX(1),MEMSZY(1),MEMDEP(1)
	INTEGER*4	ITTDEP(1),NOMEM,IDST
	INTEGER*4	IAV,N,ICOUNT
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
	INCLUDE	'MID_INCLUDE:IDIDEV.INC'
	INCLUDE	'MID_INCLUDE:IDIMEM.INC'
C	
C	
	NOMEM = 0
	IDST = 0
	ICOUNT = QLSTCH + 1
	IF (ICOUNT.GT.TOTMEM) ICOUNT = TOTMEM
C	
C  check input memory
	IF (TOTMEM.LT.1) THEN
	   IDST = 91
	   RETURN
	ENDIF
C	
C  test memory type
	IF ( (MEMTYP.GT.2) .AND. (MEMTYP.NE.4) ) RETURN
C	
C  for alpahnumerics and overlay memory, CONFNO is irrelevant
	IF (MEMTYP.EQ.2) THEN
	   NOMEM = 1
	   MEMID(1) = 99
	   MEMSZX(1) = QMSZX
	   MEMSZY(1) = QMSZY
	   MEMDEP(1) = QMDEP
	   ITTDEP(1) = 8
	   RETURN
C
	ELSE IF (MEMTYP.EQ.4) THEN
	   IF (QOVCH.LT.0) RETURN		!no graphics channel...
	   NOMEM = 1
	   MEMID(1) = QOVCH
	   MEMSZX(1) = QMSZX
	   MEMSZY(1) = QMSZY
	   MEMDEP(1) = QMDEP
	   ITTDEP(1) = 8
	   RETURN
	ENDIF
C	
C  test input configuration no.
	IF (CONFNO.EQ.0) GOTO 1000		!treat monochrome like pseudo-colour
	IF (CONFNO.EQ.1) GOTO 1000
	IF (CONFNO.EQ.2) GOTO 2000
	IF (CONFNO.EQ.-1) THEN
	   IF (QRGBFL.EQ.0) THEN
	      GOTO 1000
	   ELSE
	      GOTO 2000
	   ENDIF
	ENDIF
C	
	IDST = 90
	RETURN
C	
C  here for pseudo-colour mode
1000	DO N=0,ICOUNT-1
	   IF (N.NE.QOVCH) THEN
	      NOMEM = NOMEM + 1
	      MEMID(NOMEM) = N
	      IF (NOMEM.EQ.TOTMEM) GOTO 1100
	   ENDIF
	ENDDO
C	
1100	DO N=1,NOMEM
	   MEMSZX(N) = QMSZX
	   MEMSZY(N) = QMSZY
	   MEMDEP(N) = QMDEP
	   ITTDEP(N) = 8
	ENDDO
        RETURN
C	
C  here for RGB mode
2000	IF (QLSTCH.LE.1) RETURN		!not enough memories for RGB mode
C	
	NOMEM = 3
	DO N=1,NOMEM
	   MEMID(N) = N - 1
	   MEMSZX(N) = QMSZX
	   MEMSZY(N) = QMSZY
	   MEMDEP(N) = QMDEP
	   ITTDEP(N) = 8
	ENDDO
	RETURN
C	
	END

	SUBROUTINE GD8007(DISPLAY,CAPA,OUTSIZ,OUTDAT,TOTAL,IDST)
C	
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine IIDQCI		version 1.00	880609
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  DeAnza, configuration
C
C.PURPOSE
C  fulfill the requirements as described in the IDI document
C
C.ALGORITHM
C  use DeAnza level 0 + 1 software
C
C.INPUT/OUTPUT
C  call as  IIDQCI(DISPLAY,CAPA,OUTSIZ,OUTDAT,TOTAL,IDST)
C
C  input par:
C  DISPLAY:	I*4		display id.
C  CAPA:	I*4		capability no.
C  OUTSIZ:	I*4		size of output array
C
C  output par:
C  OUTDAT:	I*4 array	output data
C  TOTAL:	I*4		number of data values returned
C  IDST:	I*4		return status
C	
C--------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,CAPA,OUTSIZ,OUTDAT(1),TOTAL,IDST
	INTEGER*4	KK
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
	INCLUDE	'MID_INCLUDE:IDIDEV.INC/NOLIST'
	INCLUDE	'MID_INCLUDE:IDIMEM.INC/NOLIST'
C	
C  init
	TOTAL = 1
	IDST = 0
	KK = CAPA/10
	GOTO (1000,2000,3000,4000,5000,6000,7000,8000,9000,10000),KK
C	
	IF (CAPA.EQ.1) THEN
	   OUTDAT(1) = 1
	   RETURN
	ELSE
	   GOTO 11011
	ENDIF
C	
C  capability in [10,19]
1000	IF (CAPA.EQ.10) THEN
	   OUTDAT(1) = 2
C
	ELSE IF (CAPA.EQ.11) THEN
	   IF (QRGBFL.EQ.0) THEN
	      OUTDAT(1) = 1
	   ELSE
	      OUTDAT(1) = 2
	   ENDIF
C
	ELSE IF (CAPA.EQ.12) THEN
	   OUTDAT(1) = QDSZX
	   OUTDAT(2) = QDSZY
	   TOTAL = 2
C
	ELSE IF (CAPA.EQ.13) THEN
	   OUTDAT(1) = QDDEP
C
	ELSE IF (CAPA.EQ.14) THEN
	   OUTDAT(1) = 8
C
	ELSE IF (CAPA.EQ.15) THEN
	   OUTDAT(1) = 4
C
	ELSE IF (CAPA.EQ.16) THEN
	   OUTDAT(1) = 4
C
	ELSE IF (CAPA.EQ.17) THEN
	   OUTDAT(1) = 1
	   OUTDAT(2) = 8
	   TOTAL = 2
C	
	ELSE
	   GOTO 11011
	ENDIF
C	
	RETURN
C	
C  capability in [20,29]
2000	RETURN
C	
C  capability in [30,39]
3000	RETURN
C	
C  capability in [40,49]
4000	IF (CAPA.EQ.40) THEN
	   OUTDAT(1) = 2
	ENDIF
C	
	RETURN
C	
C  capability in [50,59]
5000	RETURN
C	
C  capability in [60,69]
6000	RETURN
C	
C  capability in [70,79]
7000	RETURN
C	
C  capability in [80,89]
8000	RETURN
C	
C  capability in [90,99]
9000	RETURN
C	
C  capability in [100,109]
10000	RETURN
C 	
C
11011	IDST = 90
	RETURN
	END

	SUBROUTINE GD8048(DISPLAY,MEMIDS,XOFFS,YOFFS,SPLIT_FLAG,
     +                    SPLX,SPLY,IDST)
C	
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine IIDSSS		version 1.00	880628
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  ImageDisplay, split screen
C
C.PURPOSE
C  fulfill the requirements as described in the IDI document
C
C.ALGORITHM
C  use DeAnza level 0 + 1 software
C
C.INPUT/OUTPUT
C  call as  IIDSSS(DISPLAY,MEMIDS,XOFFS,YOFFS,SPLIT_FLAG,SPLX,SPLY,IDST)
C
C  input par:
C  DISPLAY:	I*4		display id.
C  MEMIDS:	I*4 array	memory ids, 4 channels if split_flag = 0
C				            2 channels if = 1 or 2 
C					    1 channel if = -1
C  SPLIT_FLAG:	I*4		split flag:-1 = clear split screen mode
C					    0 = full split, 0,1,2,3
C					    1 = 1,0 or 2,3
C					    2 = 1,2 or 0,3
C  XOFFS:	I*4 array	x-offsets of memory
C  YOFFS:	I*4 array	y-offsets of memory
C  SPLX:	I*4 		x split address
C  SPLY:	I*4 		y split address
C	
C  output par:
C  IDST:	I*4		return status
C	
C.VERSIONS
C--------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,MEMIDS(1),SPLIT_FLAG,XOFFS(1),YOFFS(1)
	INTEGER*4	SPLX,SPLY,IDST
	INTEGER*4	MMIDS(4),CHAN,N,M,IOFF,LIMIT
C	
	INTEGER*2	UNIT,FCREG,FCLEFT,FCRIGHT
	INTEGER*2	XSPLIT,YSPLIT,SCR
	INTEGER*2	RVR,LVR,LMC
C 
	CHARACTER*20	FRAME
C 
	REAL*4		RINF(6)
C
	INCLUDE	'MID_INCLUDE:IDIDEV.INC'
	INCLUDE	'MID_INCLUDE:IDIMEM.INC'
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
C	
	EXTERNAL	RVR,LVR,LMC
C	
C  check, if we want to clear split screen mode
	CALL IP8QW(RVR,UNIT,DZIOSB,,,FCR,16,0,8)
	XSPLIT = SPLX
	YSPLIT = SPLY
	IF (SPLIT_FLAG.LT.0) GOTO 5000			!do that elsewhere...
C 
C *****
C	
C  here for "real" split screen" business
C	
C *****
C	
	MMIDS(1) = MEMIDS(2)
	MMIDS(2) = MEMIDS(1)
C	
C  set scroll values for all memory channels involved
	IF (SPLIT_FLAG.EQ.0) THEN
	   LIMIT = 4
	   MMIDS(3) = MEMIDS(3)
	   MMIDS(4) = MEMIDS(4)
	ELSE
	   LIMIT = 2
	ENDIF
C 
	DO M=1,LIMIT
	   CHAN = MMIDS(M)
	   CALL GETICH(QDSPNO,CHAN,FRAME,RINF,IDST)
	   N = CHAN + 1
	   MEMREG(1,N) = IAND(MEMREG(1,N),"176000)		!clear SCROLX
	   SCR = IAND(SCROLX,"001777)
	   MEMREG(1,N) = IOR(MEMREG(1,N),SCR)
	   MEMREG(2,N) = IAND(MEMREG(2,N),"176000)		!clear SCROLY
	   SCR = IAND(SCROLY,"001777)
	   MEMREG(2,N) = IOR(MEMREG(2,N),SCR)
	   CALL IP8QW(LMC,UNIT,DZIOSB,,,MEMREG(1,N),4,CHAN,0)
	ENDDO
C	
C  now set up split screen (depends on mode)
	IF (QRGBFL.EQ.1) THEN				!LUT = NULL.LUT !!
	   FCR(1) = "000020			!0 R, 1 R	0 = use LUT
	   FCR(2) = "010401			!1 G, 0 G	1 = bypass LUT
	   FCR(3) = "001002			!0 B, 0 B
	   FCR(4) = "000000			!0 x, 0 x
	   FCR(5) = IAND(FCR(5),"177400)	!xxx, 0 R
	   FCREG = IAND(FCR(6),"177400)			!clear right byte
	   FCR(6) = IOR(FCREG,"1)		!xxx, 0 G
	   FCREG = IAND(FCR(7),"177400)			!clear right byte
	   FCR(7) = IOR(FCREG,"23)		!xxx, 1 B
	   FCREG = IAND(FCR(8),"177400)			!clear right byte
	   FCR(8) = IOR(FCREG,"20)		!xxx, 0 x
	ELSE
	   FCR(1) = IAND(FCR(1),"170160)	!
	   FCREG = IAND(FCR(2),"170160)		!clear out channels
	   FCR(2) = IOR(FCREG,"401)		!channel 1 -> segment 1, G + R
	   FCREG = IAND(FCR(3),"170160)		!clear out channels
	   FCR(3) = IOR(FCREG,"1002)		!channel 2 -> segment 2, G + R
	   FCREG = IAND(FCR(4),"170160)		!clear out channels
	   FCR(4) = IOR(FCREG,"1403)		!channel 3 -> segment 3, G + R
	   FCR(5) = IAND(FCR(5),"177600)	!channel 0 -> segment 0, B
	   FCREG = IAND(FCR(6),"177600)		!clear out right channel
	   FCR(6) = IOR(FCREG,"1)		!channel 1 -> segment 1, B
	   FCREG = IAND(FCR(7),"177600)		!clear out right channel
	   FCR(7) = IOR(FCREG,"2)		!channel 2 -> segment 2, B
	   FCREG = IAND(FCR(8),"177600)		!clear out right channel
	   FCR(8) = IOR(FCREG,"3)		!channel 3 -> segment 3, B
	ENDIF
C	
C  jump to common end
	GOTO 8000
C *****
C	
C  here for clear split screen business
C	
C *****
5000	MMIDS(1) = MEMIDS(1)
C	
C  loop through FCRs + reset scroll values for all memory channels involved
	DO M=1,8
	   FCLEFT = ISHFT(FCR(M),-8)		!get left byte
C	
	   CHAN = IAND(FCR(M),"17)		!pull out channel from right byte
	   CALL GETICH(QDSPNO,CHAN,FRAME,RINF,IDST)
	   N = CHAN + 1
	   MEMREG(1,N) = IAND(MEMREG(1,N),"176000)		!clear SCROLX
	   SCR = IAND(SCROLX,"001777)
	   MEMREG(1,N) = IOR(MEMREG(1,N),SCR)
	   MEMREG(2,N) = IAND(MEMREG(2,N),"176000)		!clear SCROLX
	   SCR = IAND(SCROLY,"001777)
	   MEMREG(2,N) = IOR(MEMREG(2,N),SCR)
	   CALL IP8QW(LMC,UNIT,DZIOSB,,,MEMREG(1,N),4,CHAN,0)
C	
	   IF (IAND(FCLEFT,"17).NE.CHAN) THEN
	      CHAN = IAND(FCLEFT,"17)		!pull out channel
   	      CALL GETICH(QDSPNO,CHAN,FRAME,RINF,IDST)
	      N = CHAN + 1
	      MEMREG(1,N) = IAND(MEMREG(1,N),"176000)		!clear SCROLX
	      SCR = IAND(SCROLX,"001777)
	      MEMREG(1,N) = IOR(MEMREG(1,N),SCR)
	      MEMREG(2,N) = IAND(MEMREG(2,N),"176000)		!clear SCROLY
	      SCR = IAND(SCROLY,"001777)
	      MEMREG(2,N) = IOR(MEMREG(2,N),SCR)
	      CALL IP8QW(LMC,UNIT,DZIOSB,,,MEMREG(1,N),4,CHAN,0)
	   ENDIF
	ENDDO
C	
C  now set up single display (depends on mode)
	IF (QRGBFL.EQ.1) THEN
	   DO M=1,4
	      FCR(M) = "010420				!channel 1, 0 (green, red)
	      FCREG = IAND(FCR(M+4),"177740)		!clear out BY bit + channel
	      FCR(M+4) = IOR(FCREG,"22)			!channel 2 (blue)
	   ENDDO
	ELSE
	   DO M=1,4
	      FCR(M) = MMIDS(1)			!channel MMIDS(1) everywhere...
	      FCR(M+4) = IAND(FCR(M+4),"177740)
	      FCR(M+4) = IOR(FCR(M+4),MMIDS(1))
	   ENDDO
	ENDIF
C *****
C	
C  common terminating section
C	
C *****
C	
C  rewrite FCRs
8000	CALL IP8QW(LVR,UNIT,DZIOSB,,,FCR,16,0,8)
C	
C  update split addresses
	VOCREG(1) = XSPLIT
	VOCREG(2) = YSPLIT
	CALL IP8QW(LVR,UNIT,DZIOSB,,,VOCREG(1),4,0,0)
C	
	IDST = 0
	RETURN
	END

	SUBROUTINE GD8005(ERNO,ERSTR,LSTR)
C	
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine IIDERR		version 1.00	880502
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  Error message
C
C.PURPOSE
C  fulfill the requirements as described in the IDI document
C
C.ALGORITHM
C
C.INPUT/OUTPUT
C  call as  IIDERR(ERNO,ERSTR,LSTR)
C
C  input par:
C  ERNO:	I*4		error no.
C
C  output par:
C  ERSTR:	char. string    error message
C  LSTR:	I*4		lenght of error message
C	
C--------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4	ERNO,LSTR
	INTEGER*4	KSTR
C 
	CHARACTER*(*)	ERSTR
C 
	ERSTR = ' '
	LSTR = LEN(ERSTR)
	KSTR = LSTR
C 
C  error numbers are sorted according to originating routines
	IF (ERNO.GT.199) GOTO 200
C 
C  here for errors from the IIC... routines
	RETURN
C 
200	IF (ERNO.GT.299) GOTO 300
C 
C  here for errors from the IID... routines
	RETURN
C 
300	IF (ERNO.GT.399) GOTO 400
C 
C  here for errors from the IID... routines
	RETURN
C 
400	IF (ERNO.GT.499) GOTO 500
C 
C  here for errors from the III... routines
	IF (ERNO.EQ.401) THEN
	   ERSTR(1:) = 'Unsupported interactor type '
	   KSTR = 31
	ELSE IF (ERNO.EQ.402) THEN
	   ERSTR(1:) = 'Trigger no. out of range, should be in [0,9] '
	   KSTR = 45
	ELSE IF (ERNO.EQ.403) THEN
	   ERSTR(1:) = 'Unsupported object type '
	   KSTR = 28
	ELSE IF (ERNO.EQ.404) THEN
	   ERSTR(1:) = 'No description for given interactor '
	   KSTR = 40
	ELSE IF (ERNO.EQ.409) THEN
	   ERSTR(1:) = 'No interaction enabled '
	   KSTR = 27
	ENDIF
	GOTO 9000
C 
500	IF (ERNO.GT.599) GOTO 600
C 
C  here for errors from the IIG... routines
	RETURN
C 
600	IF (ERNO.GT.699) GOTO 700
C 
C  here for errors from the IIL... routines
	RETURN
C 
700	IF (ERNO.GT.799) GOTO 800
C 
C  here for errors from the IIM... routines
	RETURN
C 
800	IF (ERNO.GT.899) GOTO 900
C 
C  here for errors from the IIR... routines
	RETURN
C 
C  here for errors from the IIZ... routines
900	RETURN
C 
9000	IF (KSTR.LT.LSTR) LSTR = KSTR
	RETURN
C 
	END

C @(#)gd8m.for	19.1 (ES0-DMD) 02/25/03 13:55:25
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE GD8018(DSPLAY,CHAN,NOCHAN,VALUE,IDST)
C 
      IMPLICIT NONE
C      
      INTEGER      DSPLAY,CHAN(1),NOCHAN,VALUE,IDST
C      
      IDST = 0
      RETURN
      END

      SUBROUTINE GD8020(DSPLAY,CHAN,LOADFL,SZX,SZY,DEPTH,
     +                      XBEG,YBEG,IDST)
C
      IMPLICIT NONE
C      
      INTEGER      DSPLAY,CHAN,SZX,SZY,LOADFL,DEPTH,IDST,XBEG,YBEG
C      
      IDST = 0
      RETURN
      END

      SUBROUTINE GD8017(DSPLAY,CHAN,PIX,SIZE,DEPTH,PACK,XBEG,YBEG,IDST)
C
      IMPLICIT NONE
C      
      INTEGER       DSPLAY,CHAN,SIZE,DEPTH,PACK
      INTEGER      XBEG,YBEG,PIX(1),IDST
C      
      IDST = 0
      RETURN
      END

      SUBROUTINE GD8019(DSPLAY,CHAN,SIZE,XBEG,YBEG,DEPTH,
     +                    PACK,ITTFLG,PIX,IDST)
C
      IMPLICIT NONE
C      
      INTEGER       DSPLAY,CHAN,SIZE,DEPTH,PACK,ITTFLG
      INTEGER      XBEG,YBEG,IDST,PIX(1)
C      
      IDST = 0
      RETURN
      END

      SUBROUTINE GD8011(DSPLAY,CHAN,NOCHAN,VIS,IDST)
C      
      IMPLICIT NONE
C      
      INTEGER      DSPLAY,CHAN(1),NOCHAN,VIS,IDST
C      
      IDST = 0
      RETURN
      END

      SUBROUTINE GD8015(DSPLAY,CHAN,LUT,ITT,IDST)
C
      IMPLICIT NONE
C      
      INTEGER      DSPLAY,CHAN,ITT,LUT,IDST
C      
      IDST = 0
      RETURN
      END

      SUBROUTINE GD8047(DSPLAY,MEMIDS,MEMLIM,DELAY,IDST)
C
      IMPLICIT NONE
C      
      INTEGER      DSPLAY,MEMIDS(1),MEMLIM,IDST
C
      REAL            DELAY
C      
      IDST = 0
      RETURN
      END

C @(#)appmtr.for	19.1 (ES0-DMD) 02/25/03 13:25:31
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C
C  subroutine APPMTR         version 1.2       831004
C  A. Kruszewski             ESO Garching
C
C  modified                  version 1.3       870127
C  A. Kruszewski             Obs. de Geneve
C
C.KEYWORDS
C
C  classifiers, magnitudes
C
C.PURPOSE
C
C  calculates various kinds of magnitudes and sizes for an object
C  with given average profile "AVPR"
C
C.INPUT/OUTPUT
C
C  input arguments
C
C  AVPR        real*4 array      one-dimensional profile
C  LIM         integer*4         radial extend of determined profile
C  ISOP        integer*4         isophotal size flag
C  RARR        real*4 array      real keywords array
C  PCTL        real*4 array      array holding classifiers
C
C  output arguments
C
C  AVPR        real*4 array      modified input array
C  PCTL        real*4 array      array holding classifiers
C
C-----------------------------------------------------------------------
      SUBROUTINE APPMTR(AVPR, LIM, ISOP, RARR, APSF, PCTL)
C
      IMPLICIT  NONE
      INCLUDE   'MID_REL_INCL:INVENT.INC/NOLIST'
C
      REAL      AVPR(0:MAXSUB)
      INTEGER   LIM
      INTEGER   ISOP
      REAL      RARR(64)
      REAL      APSF(0:MAXSUB)
      REAL      PCTL(NRPAR)
C
      INTEGER   IC
      INTEGER   IW( 0:3 )
      INTEGER   K, KM
      INTEGER   L, LL
      INTEGER   NSUM
      INTEGER   NPXL( 0:MAXSUB )
      REAL      ALP , AKML, AKM
      REAL      AVPR0, AVNPK
      REAL      BSUM, BSUM1
      REAL      DETA
      REAL      DFAV
      REAL      DVGR ( 0:3 )
      REAL      ETA, ETA1
      REAL      FRCT
      REAL      PETA
      REAL      RISP
      REAL      SBRH( 0:MAXSUB )
      REAL      SIGMA
      REAL      SMTR( 2 )
      REAL      STMT
      REAL      SUMM, SUM0, SUM1, SUM2, SUM3
      REAL      TRSH
      REAL      VAR
      REAL      XRAD( 0:3 ) , YMAG( 0:3 )
C     REAL      X(5)
      REAL      ZRLV 
      REAL      ZRMG
C
      DATA NPXL/1,8,12,16,32,28,40,40,48,68,56,72,68,88,88,84,112,
     &          112,112,116,112,144,140,144,144,168,164,160,184,172,
     &          200,192,188,208,224,224,228,224,248,236,264,248,264,
     &          276,264,288,276,304,304,312,316/
C
C ***
      TRSH = RARR(3)
      ZRMG = RARR(11)
      SMTR(1) = RARR(12)
      SMTR(2) = RARR(13)
      PETA = RARR(53)
      RISP = PCTL(15)
      ETA1 = 0.0
      BSUM1 = 0.0
C
C *** Calculate quantities integrated down to isophote TRSH.
C
      AVPR0 = AVPR(0)
      SUM0 = AVPR0
      SUM1 = 0.333 * AVPR0
      SUM2 = 0.1 * AVPR0
      SUM3 = 10.0 * AVPR0
      K = 1
   11 CONTINUE
          IF ( AVPR(K) .LT. TRSH .OR. K .GE. LIM ) GOTO 10
          AVNPK = AVPR(K) * NPXL(K)
          SUM0 = SUM0 + AVNPK
          SUM1 = SUM1 + AVNPK * K
          SUM2 = SUM2 + AVNPK * K * K
          SUM3 = SUM3 + AVNPK / ( K * K )
          K = K + 1
          GOTO 11
   10 CONTINUE
      DFAV = AVPR(K-1) - AVPR(K)
      IF ( DFAV .GT. 0.01*TRSH .AND. K .LT. LIM ) THEN
          FRCT = ( AVPR(K-1) - TRSH ) / DFAV
      ELSE
          FRCT = 1.0
      ENDIF
      AVNPK = AVPR(K) * NPXL(K)
      SUM0 = SUM0 + FRCT * AVNPK
      SUM1 = SUM1 + FRCT * AVNPK * K
      SUM2 = SUM2 + FRCT * AVNPK * K * K
      SUM3 = SUM3 + FRCT * AVNPK / ( K * K )
      IF ( SUM0 .GT. 0.1 * TRSH ) THEN
          PCTL(5) = ZRMG - 2.5 * LOG10(SUM0)
          PCTL(6) = SUM1 / SUM0
          PCTL(7) = SUM2 / SUM0
          PCTL(18) = SUM3 / SUM0
          PCTL(15) = FLOAT(K) - 1.0 + FRCT
      ELSE
          PCTL(5) = ZRMG - 2.5 * ( LOG10(TRSH) - 1.0 )
      ENDIF
      IF ( PCTL(7) .GT. 0.001 ) THEN
          PCTL(7) = SQRT( PCTL(7) )
      ELSE
          PCTL(7) = 0.0
      ENDIF
      IF ( PCTL(18) .GT. 0.001 ) THEN
          PCTL(18) = ( PCTL(18) ) ** (-0.5)
      ELSE
          PCTL(18) = 0.0
      ENDIF
C
C *** If control parameter ISOP is equal 1 then isophotal
C *** magnitude is calculated inside the isophotal radius RISP.
C
      IF ( ISOP .EQ. 1 ) THEN
          AVPR0 = AVPR(0)
          SUM0 = AVPR0
          K = 1
   21     CONTINUE
              IF ( FLOAT(K) .GE. RISP .OR. K .GE. LIM ) GOTO 20 
              AVNPK = AVPR(K) * NPXL(K)
              SUM0 = SUM0 + AVNPK
              K = K + 1
              GOTO 21
   20     CONTINUE
          FRCT = RISP - K + 1
          AVNPK = AVPR(K) * NPXL(K)
          SUM0 = SUM0 + FRCT * AVNPK
          IF ( SUM0 .GT. 0.1 * TRSH ) THEN
              PCTL(5) = ZRMG - 2.5 * LOG10(SUM0)
          ELSE
              PCTL(5) = ZRMG - 2.5 * ( LOG10(TRSH) - 1.0 )
          ENDIF
          PCTL(15) = RISP
      ENDIF
C
C *** Calculate metric magnitudes and logarithmic
C *** derivative ALPHA at the first metric size. 
C
      DO 30 LL = 1 , 2
          STMT = SMTR(LL)
C
C ***     Calculate smallest radius KM out of 4 rings used
C ***     to determine metric magnitude and gradient alpha.
C
          VAR = STMT - 1.49
          KM = MAX( MIN( INT(VAR) , LIM-3 ) , 0 )
          IF ( KM .GE. 0 ) THEN
C
C ***         Calculate how much is standard
C ***         metric STMT shifted from KM.
C
              AKM = STMT - 0.5 - KM
C
C ***         Calculates cumulative magnitudes YMAG
C ***         as function of logarithmic ring radius
C ***         XRAD for four radii starting with KM.
C
              SUMM = 0.0
              DO 40 L = 0 , KM
                  SUMM = SUMM + NPXL(L) * AVPR(L)
   40         CONTINUE
              IC = 0
              IF ( SUMM .GT. 0.1*TRSH ) THEN
                  YMAG(0) = ZRMG - 2.5 * LOG10(SUMM)
                  IF ( KM .GT. 0 ) THEN
                      XRAD(0) = LOG10( FLOAT(KM) )
                  ELSE
                      XRAD(0) = -0.5
                  ENDIF
              ELSE
                  IC = 1
              ENDIF
              DO 50 L = 1 , 3
                  SUMM = SUMM + NPXL(KM+L) * AVPR(KM+L)
                  IF ( SUMM .GT. 0.1*TRSH ) THEN
                      YMAG(L) = ZRMG - 2.5 * LOG10(SUMM)
                      XRAD(L) = LOG10( FLOAT(KM+L) )
                  ELSE
                      IC=1
                  ENDIF
   50         CONTINUE
              DO 60 L = 0 , 3
                  IW(L) = 1
   60         CONTINUE
              IF ( IC .EQ. 0 ) THEN
                  CALL GRADET( 3 , XRAD , YMAG , IW , ALP ,
     &                         ZRLV , DVGR , SIGMA )
                  AKML = LOG10( FLOAT(KM) + AKM )
                  IF ( LL .EQ. 1 ) THEN
                      PCTL(13) = ZRLV + AKML * ALP
                  ELSE
                      PCTL(20) = ZRLV + AKML * ALP
                  ENDIF
              ELSE
                  IF ( LL .EQ. 1 ) THEN
                      PCTL(13) = ZRMG + 50.0
                      ALP = 0.0
                  ELSE
                      PCTL(20) = ZRMG + 50.0
                  ENDIF
              ENDIF
              IF ( LL .EQ. 1 ) THEN
                  PCTL(19) = -0.4 * ALP
              ENDIF
          ELSE
              IF ( LL .EQ. 1 ) THEN
                  PCTL(13) = ZRMG + 50.0
                  PCTL(19) = 0.0
              ELSE
                  PCTL(20) = ZRMG + 50.0
              ENDIF
          ENDIF
   30 CONTINUE
C
C *** Calculate Petrosian magnitude and radius.
C
      NSUM = 1
      BSUM = AVPR(0)
      SBRH(0) = AVPR(0)
      ETA = 0.0
      K = 1
   71 CONTINUE
          IF ( ETA .GT. PETA .OR. K .GE. LIM ) GOTO 70
          NSUM = NSUM + NPXL(K)
          BSUM = BSUM + NPXL(K) * AVPR(K)
          SBRH(K) = BSUM / NSUM
          IF ( MIN( SBRH(K)+SBRH(K-1) , AVPR(K) ) .GT. 0.1*TRSH ) THEN
              ETA = 2.5 * LOG10( 0.5 * (SBRH(K)+SBRH(K-1)) / AVPR(K) )
          ELSE
              ETA = PETA + 1.0
          ENDIF
          IF ( ETA .LT. PETA .AND. K .LT. LIM-1 ) THEN
              BSUM1 = BSUM
              ETA1 = ETA
          ENDIF
          K = K + 1
          GOTO 71
   70 CONTINUE
      DETA = ETA - ETA1
      IF ( DETA .GT. 0.001 ) THEN
          FRCT = (PETA-ETA1) / DETA
      ELSE
          FRCT = 0.5
      ENDIF
      IF ( K .GE. LIM .AND. FRCT .GT. 1.0 ) THEN
          FRCT = 1.0
      ENDIF
      BSUM = BSUM1 + FRCT * NPXL(K-1) * AVPR(K-1)
      PCTL(17) = FLOAT(K) - 2.0 + FRCT
      IF ( BSUM .GT. 0.1*TRSH ) THEN
          PCTL(16) = ZRMG - 2.5 * LOG10(BSUM)
      ELSE
          PCTL(16) = ZRMG + 50.0
      ENDIF
C
      RETURN
C
      END
C

C @(#)erfunc.for	19.1 (ES0-DMD) 02/25/03 13:17:30
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE ERFUNC(IND,X,NP,PARAM,Y,DERIV)                                 
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                  
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  18:01 - 21 DEC 1987                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C--------------------------------------------------------------                 
C***************************************************                            
C                                                                               
C      IMPLICIT NONE                                                            
C  Fit with a 1-dim integrated Gaussian Distribution                            
C                                                                               
      INTEGER NP,IND
      DOUBLE PRECISION PARAM(NP),DERIV(NP),Y                                    
      REAL X(IND)                                                          
      DOUBLE PRECISION A,B,C                                                    
C                                                                               
      A      = (X(1)/PARAM(2))**2                                               
      B      = DEXP(-A)                                                         
      C      = 1.0D0 - B                                                        
      DERIV(1) = 3.1415926536D0*PARAM(1)*PARAM(1)*C                             
      DERIV(2) = 6.2831853072D0*PARAM(1)*PARAM(2)* (C-A*B)                      
      Y      = DERIV(1)*PARAM(1)                                                
      RETURN                                                                    
                                                                                
      END                                                                       

C @(#)polin.for	19.1 (ES0-DMD) 02/25/03 13:30:47
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      REAL FUNCTION POLIN(X,CC,I)
C +++
C.PURPOSE: Evaluates polynomial at given y coord. and variable x coord.
C ---
      IMPLICIT         NONE
      DOUBLE PRECISION X
      DOUBLE PRECISION CC(6)
      INTEGER          I
C
      GO TO (50,40,30,20,10),I
C
   10 POLIN  = ((((CC(6)*X+CC(5))*X+CC(4))*X+CC(3))*X+CC(2))*X + CC(1)
      RETURN

   20 POLIN  = (((CC(5)*X+CC(4))*X+CC(3))*X+CC(2))*X + CC(1)
      RETURN

   30 POLIN  = ((CC(4)*X+CC(3))*X+CC(2))*X + CC(1)
      RETURN

   40 POLIN  = (CC(3)*X+CC(2))*X + CC(1)
      RETURN

   50 POLIN  = CC(2)*X + CC(1)
      RETURN

      END

C @(#)smtpsf.for	19.1 (ES0-DMD) 02/25/03 13:25:39
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C
C
C-----------------------------------------------------------------------
      SUBROUTINE SMTPSF(LPXL, LSBP, LL, CPSF, DPSF,
     &                  IPSF, INZ, NN, SIGMA, I,
     &                  J, K, L, AMAG, GRI,
     &                  GRJ)
C
      IMPLICIT  NONE
C
      INTEGER   LPXL
      INTEGER   LSBP
      INTEGER   LL
      REAL      CPSF((-LL):LL,(-LL):LL)
      REAL      DPSF((-LL):LL,(-LL):LL)
      INTEGER   IPSF((-LSBP):LSBP,(-LSBP):LSBP)
      INTEGER   INZ
      INTEGER   NN
      REAL      SIGMA
      INTEGER   I
      INTEGER   J
      INTEGER   K
      INTEGER   L
      REAL      AMAG
      REAL      GRI
      REAL      GRJ
C
      INTEGER   MSBP, MSBP2
      INTEGER   MPXL, MPXL2
      INTEGER   II, II1, II2, III
      INTEGER   IC, ISTEP, ITMP
      INTEGER   NJ, NI
      INTEGER   LLL
      INTEGER   KKK	
      INTEGER   JJ, JJ1, JJ2, JJJ
      REAL      DI, DJ
C
      DOUBLE PRECISION   COEF(6,6) , S(6) , TEMP , TMP(6) , X(6)
C
      IF ( NN .LT. 7 ) THEN
          AMAG = 0.0
          GRI = 0.0
          GRJ = 0.0
          RETURN
      ENDIF
      MSBP = 2 * LSBP + 1
      MPXL = 2 * LPXL + 1
      MSBP2 = MSBP * MSBP
      MPXL2 = MPXL * MPXL
      ISTEP = MAX( 2 , NINT( ( SIGMA / 0.04 ) *
     &                       SQRT(FLOAT(MSBP2*MPXL2)/FLOAT(NN)) ) )
      II = I * MSBP - K
      JJ = J * MSBP - L
      IF ( DPSF(II,JJ) .LT. 0.01 ) THEN
          AMAG = CPSF(II,JJ)
          RETURN
      ENDIF
   71 CONTINUE
      DO 10 NJ = 1 , 6
          DO 20 NI = 1 , 6
              COEF(NI,NJ) = 0.0
   20     CONTINUE
   10 CONTINUE
   70 CONTINUE
          II1 = MAX( -LL , II-ISTEP )
          II2 = MIN( LL , II+ISTEP )
          IF ( II1 .EQ. -LL .AND. II2-II1 .LE. 2 ) THEN
              II2 = II1 + 3
          ENDIF
          IF ( II2 .EQ. LL .AND. II2-II1 .LE. 2 ) THEN
              II1 = II2 - 3
          ENDIF
          JJ1 = MAX( -LL , JJ-ISTEP )
          JJ2 = MIN( LL , JJ+ISTEP )
          IF ( JJ1 .EQ. -LL .AND. JJ2-JJ1 .LE. 2 ) THEN
              JJ2 = JJ1 + 3
          ENDIF
          IF ( JJ2 .EQ. LL .AND. JJ2-JJ1 .LE. 2 ) THEN
              JJ1 = JJ2 - 3
          ENDIF
          IC = 0
          DO 30 JJJ = JJ1 , JJ2
              IF ( JJJ .LT. 0 ) THEN
                  LLL = MOD( JJJ-LSBP , MSBP ) + LSBP
              ELSE IF ( JJJ .EQ. 0 ) THEN
                  LLL = 0
              ELSE
                  LLL = MOD( JJJ+LSBP , MSBP ) - LSBP
              ENDIF
              DO 40 III = II1 , II2
                  IF ( III .LT. 0 ) THEN
                      KKK = MOD( III-LSBP , MSBP ) + LSBP
                  ELSE IF ( III .EQ. 0 ) THEN
                      KKK = 0
                  ELSE
                      KKK = MOD( III+LSBP , MSBP ) - LSBP
                  ENDIF
                  ITMP = IPSF(KKK,LLL)
                  IF ( ITMP .GT. 0 ) THEN
                      TEMP = SQRT( DBLE( ITMP ) )
                      IC = IC + 1
                      DI = DBLE(III-II)
                      DJ = DBLE(JJJ-JJ)
                      TMP(1) = 1.0 * TEMP
                      TMP(2) = DI * TEMP
                      TMP(3) = DJ * TEMP
                      TMP(4) = DI * DI * TEMP
                      TMP(5) = DJ * DJ * TEMP
                      TMP(6) = DBLE( CPSF(III,JJJ) ) * TEMP
                      DO 50 NJ = 1 , 6
                          DO 60 NI = NJ , 6
                              COEF(NI,NJ) = COEF(NI,NJ) +
     &                                      TMP(NI) * TMP(NJ)
   60                     CONTINUE
   50                 CONTINUE
                  ENDIF
   40         CONTINUE
   30     CONTINUE
          IF ( IC .LT. 7 .AND. ISTEP .LE. LL/4 ) THEN
              ISTEP = ISTEP + 1
              GOTO 70
          ENDIF
      CONTINUE
      IF ( IC .GE. 7 ) THEN
          CALL LSQSOL( 6 , COEF , IC , X , S )
          IF ( SNGL(S(1)) .GT. 0.05 .AND. ISTEP .LE. LL/4 ) THEN
              ISTEP = ISTEP + 1
              GOTO 71
          ELSE
              AMAG = SNGL(X(1))
              GRI = SNGL(X(2)) * FLOAT(MSBP)
              GRJ = SNGL(X(3)) * FLOAT(MSBP)
          ENDIF
      ELSE
          AMAG = CPSF(II,JJ)
          GRI = 0.0
          GRJ = 0.0
      ENDIF
C
      RETURN
C
      END
C

C @(#)insnod.for	19.1 (ESO-DMD) 02/25/03 14:29:01
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE INSNOD(NODE,FA,LINK,NAUX)                                      
C 
      IMPLICIT NONE                                                            
C 
      INTEGER CURR,NEXT,NODE,NAUX,LINK(NAUX)
C 
      REAL FA(NAUX)                                                             
C                                                                               
C  curr gets loc of listhead (first loc in FA, LINK)                            
C                                                                               
      CURR   = 1                                                                
   10 NEXT   = LINK(CURR)                                                       
C                                                                               
C  while next <> null LINK and SLOT not found do                                
C                                                                               
      IF (NEXT.EQ.0) GO TO 20                                                   
      IF (FA(NEXT).GE.FA(NODE)) GO TO 20                                        
      CURR = NEXT                                                             
C             advance ptrs                                                      
      GO TO 10                                                                  
                                                                                
   20 LINK(NODE) = NEXT                                                         
      LINK(CURR) = NODE                                                         
C             set pointers and return                                           
      RETURN                                                                    
C
      END                                                                       

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
         PROGRAM MEANSTAR
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENT         meanstar.for
C.MODULE
C.AUTHOR        Andrew T. Young
C.KEYWORD
C.LANGUAGE      FORTRAN 77
C.PURPOSE       collapse star table with multiple positions to means.
C.COMMENTS
C.RETURNS
C.ENVIRONMENT
C.VERSION       4.3
C
C 100618	last modif
C-----------------------------------------------------------------------------
C*****************************************************************************
C
C
C       Reads a sorted star table with duplicate positions, and tries to
C       estimate a "best" position for each star.  Complains if the spread
C       in either coordinate exceeds a minute of arc.
C
C       This is done in the command CONVERT/PHOT.
C
C       This program is modified from the "esodcon" program, and may contain
C       fossils from it.
C
C
C*****************************************************************************
C
C
        IMPLICIT NONE
C
C  BEGIN Declarations:
C
C
        INTEGER ITBL, NEWTBL
        INTEGER NCOLS,NROWS,NSORTC,NWPRAL,NROWSAL, ISTAT
C
C
        CHARACTER CARD*78, TBLFIL*80
        CHARACTER*32 OBJECT,OLDOBJ,CTEST
C
        INTEGER ITEM,ITEMS
        INTEGER KOBJ,KRA,KDEC,KEQ,NROW
        INTEGER JOBJ,JRA,JDEC,JEQ,NROUT
C
        INTEGER MXITEM
        PARAMETER (MXITEM=900)
        REAL RA,DEC,EQUINOX
        REAL RAS(MXITEM),DECS(MXITEM),EQUINOXS(MXITEM)
C
        LOGICAL NULL
C
C    Types for external fcns.:
C
C
C  Set up MIDAS declarations:
C
        INTEGER MADRID(1)
C
        COMMON /VMR/ MADRID
C
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
        INTEGER IUNIT
        INTEGER NACTEL,NULLS
C
C  END Declarations.
C
C
C  BEGIN DATA statements:
C
        INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C
C  END DATA statements.
C
C
C  ********************  PROLOGUE  ********************
C
      CALL STSPRO ('MEANSTAR')
C
      OLDOBJ=' '
      NROW=0
      NROUT=0
C
C       Set up INPUT table file:
C
      CALL TV('Opening  sdata.tbl')
      CALL TBTOPN('sdata.tbl', 1,  ITBL, ISTAT)
      IF (ISTAT.NE.0) CALL TERROR (ITBL,1,'Could not open "sdata.tbl".')
C
      CALL TBIGET(ITBL,  NCOLS,NROWS,NSORTC,NWPRAL,NROWSAL, ISTAT)
      IF (ISTAT.NE.0) CALL TERROR
     1      (ITBL,1,'Could not get basic table data.')
C
C       Get column pointers...
C
      CALL TBLSER (ITBL, 'OBJECT',  KOBJ,ISTAT)
      IF (ISTAT.NE.0 .OR. KOBJ.EQ.-1)
     1    CALL TERROR(ITBL,2,'Could not find column OBJECT')
      CALL TBLSER (ITBL, 'RA',  KRA,ISTAT)
      IF (ISTAT.NE.0 .OR. KRA.EQ.-1)
     1    CALL TERROR(ITBL,3,'Could not find column RA')
      CALL TBLSER (ITBL, 'DEC',  KDEC,ISTAT)
      IF (ISTAT.NE.0 .OR. KDEC.EQ.-1)
     1    CALL TERROR(ITBL,4,'Could not find column DEC')
      CALL TBLSER (ITBL, 'EQUINOX',  KEQ,ISTAT)
      IF (ISTAT.NE.0 .OR. KEQ.EQ.-1)
     1    CALL TERROR(ITBL,5,'Could not find column EQUINOX')
C
C       Make sure table is sorted on OBJECT column:
C
      CALL TBCSRT (ITBL, 1, KOBJ, 1,  ISTAT)
      IF (ISTAT.NE.0)
     1        CALL TERROR(ITBL,8,'Could not sort OBJECT column')
C
C
C       Set up OUTPUT table file:
C
C     First, get name from tblfil local keyword:
      CALL STKRDC ('TBLFIL', 1, 1, 80,  NACTEL,TBLFIL,IUNIT,NULLS,ISTAT)
C
      CARD='Creating '//TBLFIL(:71)
      CALL TV(CARD)
      CALL TBTINI (TBLFIL, 0, 0, 1, 1,  NEWTBL, ISTAT)
C
C       create column pointers...
C
      CALL TBCINI(NEWTBL, D_C_FORMAT,32,'A32',' ','OBJECT',JOBJ,ISTAT)
      CALL TBCINI(NEWTBL, D_R4_FORMAT, 1,'R10.5',' ','RA',JRA,ISTAT)
      CALL TBCINI(NEWTBL, D_R4_FORMAT, 1,'s9.4',' ','DEC',JDEC,ISTAT)
      CALL TBCINI
     1        (NEWTBL, D_R4_FORMAT, 1,'F10.3',' ','EQUINOX',JEQ,ISTAT)
C
C     Initialize:
C
   20 ITEM=0
C
   21 NROW=NROW+1
C
C       Read row:
C
      CALL TBERDC (ITBL, NROW, KOBJ, CTEST, NULL, ISTAT)
      CALL FT_EOS (CTEST,32, OBJECT, ISTAT)
C
      IF (OBJECT.EQ.OLDOBJ .OR.OLDOBJ.EQ.' ') THEN
C         continue collecting data for this star.
          OLDOBJ=OBJECT
          ITEM=ITEM+1
          IF (ITEM.GT.MXITEM) THEN
             CALL TV('Too many data for this star.')
             CALL STETER(21,'Increase parameter MXITEM and recompile.')
          END IF
      ELSE
C         Summarize this star.
          GO TO 30
      END IF
C
      CALL TBERDR(ITBL, NROW, KRA,  RAS(ITEM),NULL, ISTAT)
      CALL TBERDR(ITBL, NROW, KDEC,  DECS(ITEM),NULL, ISTAT)
      CALL TBERDR(ITBL, NROW, KEQ,  EQUINOXS(ITEM),NULL, ISTAT)
C
      IF (NROW.EQ.NROWS) GO TO 30
      GO TO 21
C
C
C       Summarize this star:
C
   30 NROUT=NROUT+1
      ITEMS=ITEM
C
      EQUINOX=EQUINOXS(1)
      IF (ITEM.EQ.1) THEN
         RA=RAS(1)
         DEC=DECS(1)
         CARD='Only one observation of '//OLDOBJ
         CALL TVN(CARD)
         GO TO 80
      ELSE
C        extract robust estimates.
         CARD='Processing '//OLDOBJ
         CALL TVN(CARD)
      END IF
C
C       (here is where we should display scatter.)
C
      CALL SORT1(RAS,ITEMS)
      CALL SORT1(DECS,ITEMS)
C
      RA=0.5*(RAS((ITEMS+1)/2) + RAS(ITEMS/2+1))
      DEC=0.5*(DECS((ITEMS+1)/2) + DECS(ITEMS/2+1))
C
C
C        Write summary row:
C
   80 CALL TBEWRC (NEWTBL, NROUT, JOBJ, OLDOBJ,  ISTAT)
      CALL TBEWRR (NEWTBL, NROUT, JRA, RA,  ISTAT)
      CALL TBEWRR (NEWTBL, NROUT, JDEC, DEC,  ISTAT)
      CALL TBEWRR (NEWTBL, NROUT, JEQ, EQUINOX,  ISTAT)
C
      IF (NROW.EQ.NROWS) GO TO 90
C
C     Prepare for next star:
      OLDOBJ=OBJECT
      NROW=NROW-1
      GO TO 20
C
C
  90  CALL TBTCLO(ITBL,  ISTAT)
      CALL TV('   sdata.tbl closed.')
C
      CALL TBTCLO(NEWTBL,  ISTAT)
      CARD='File '//TBLFIL(1:60)//' closed'                    ! RHW 4/10/93
      CALL TV(CARD)
C
C
      CALL STSEPI
C
      END

C @(#)coefy.for	19.1 (ES0-DMD) 02/25/03 13:30:45
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE COEFY(Y,C,CC,IDEG)                                             
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
C.PURPOSE: Evaluates coefficients depending on x coordinate only for 2-d.pol.   
C --------------------------------------------------------------------------    
      IMPLICIT         NONE
      DOUBLE PRECISION C(21)                                            
      DOUBLE PRECISION CC(6)                                            
      DOUBLE PRECISION Y                                            
      INTEGER          IDEG
                                                                                
      GO TO (50,40,30,20,10),IDEG                                               
                                                                                
   10 CC(1)  = ((((C(21)*Y+C(15))*Y+C(10))*Y+C(6))*Y+C(3))*Y + C(1)             
      CC(2)  = (((C(20)*Y+C(14))*Y+C(9))*Y+C(5))*Y + C(2)                       
      CC(3)  = ((C(19)*Y+C(13))*Y+C(8))*Y + C(4)                                
      CC(4)  = (C(18)*Y+C(12))*Y + C(7)                                         
      CC(5)  = C(17)*Y + C(11)                                                  
      CC(6)  = C(16)                                                            
      RETURN                                                                    
                                                                                
   20 CC(1)  = (((C(15)*Y+C(10))*Y+C(6))*Y+C(3))*Y + C(1)                       
      CC(2)  = ((C(14)*Y+C(9))*Y+C(5))*Y + C(2)                                 
      CC(3)  = (C(13)*Y+C(8))*Y + C(4)                                          
      CC(4)  = C(12)*Y + C(7)                                                   
      CC(5)  = C(11)                                                            
      RETURN                                                                    
                                                                                
   30 CC(1)  = ((C(10)*Y+C(6))*Y+C(3))*Y + C(1)                                 
      CC(2)  = (C(9)*Y+C(5))*Y + C(2)                                           
      CC(3)  = C(8)*Y + C(4)                                                    
      CC(4)  = C(7)                                                             
      RETURN                                                                    
                                                                                
   40 CC(1)  = (C(6)*Y+C(3))*Y + C(1)                                           
      CC(2)  = C(5)*Y + C(2)                                                    
      CC(3)  = C(4)                                                             
      RETURN                                                                    
                                                                                
   50 CC(1)  = C(3)*Y + C(1)                                                    
      CC(2)  = C(2)                                                             
      RETURN                                                                    
                                                                                
      END                                                                       

C===========================================================================
C Copyright (C) 1995-2008 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
        program DBLEND
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C  program DBLEND
C
C  Uni-Sternwarte Goettingen
C  Adaptation of TVR program TVDBLE, DBLEND command
C
C  purpose:
C
C  This routine provides de-blending of spectral lines by means of a 
C  simultaneous fit of up to six profiles to a selected spectral 
C  region.
C
C  Run by procedure DBLEND
C
C.VERSION
C 080718	last modif
C 
C------------------------------------------------------------------------------
        implicit none
C------------------------------------------------------------------------------
C
C Variable declarations
C
        integer       MADRID     !mapped section pointer function
C
        INTEGER     ACOL       !number of words allocated per table row
        INTEGER     ACTVAL     !actual number of values returned
        INTEGER     AROW       !number of rows allocated in table
        INTEGER     INTID      !table identifier assigned to input table file
        INTEGER     KNUL       !no. of null values
        INTEGER     KUN        !units
        INTEGER     LTAB       !number of columns in output table
        INTEGER     MODE,MODE1 !fit option numerical code
        INTEGER     NAXIS      !dimensionality of image
        INTEGER     NCOL       !number of columns in table
        INTEGER     NDATA      !number of points in spectrum
        INTEGER     NLINES     !number of profiles to be fit
        INTEGER     NO         !file number assigned to frame
        INTEGER     NPIX(2)    !length of spectrum
        INTEGER     NROW       !number of rows in table
        INTEGER     NSC        !sorted column in table
        INTEGER     OUTTID     !table identifier assigned to output table file
        INTEGER     RCOLS(10)   !numbers of columns to be written to table
        INTEGER     II,JJ,NN
        INTEGER     STAT       !return status for subroutine calls
        INTEGER*8     PNTR       !pointer to mapped data area of input image
C 
        REAL        CENT(6)    !centers of lines
        REAL        CMAX(6)    !central line intensity
        REAL        CONTIN(4)  !x,y of 2 continuum points chosen by user
        REAL        DATA(50000)!spectrum to be worked on
        REAL        FITLIM(2)  !limits of area to be fit
        REAL        FWHM       !full width half max of line
        REAL        LSIDE      !left FWHM point of line
        REAL        MPAR(18)   !line parameters read from table
        REAL        PAR(10)     !line parameters to be written to table
        REAL        RSIDE      !right FWHM point of line
        REAL        SCENT(6)   !estimated error of fit center
        REAL        SIGMA(6)   !Gaussian sigma of line
        REAL        SMAX(6)    !estimated error of fit maximum
        REAL        SPAR(18)   !line parameters read from table
        REAL        SSIGMA(6)  !estimated error of fit sigma
C 
        character*64  CUNIT      !units
        character*8   FNAME      !file names for individual line fits
        character*3   FOPT       !fit option
        character*1   FOPT1,FOPT2,FOPT3 !individual characters of FOPT
        character*72  IDENT      !ASCII identification
        character*72  IDNT       !Temporary buffer
        character*60  INFILE     !name of input spectrum to be fit
        character*60  INTAB      !name of input table of line parameters
        character*1   LNO        !character representation of line number
        character*60  OUTFILE    !name of output file where fit is to be stored
        character*60  OUTTAB     !name of output table of line parameters
        character*80  STRING     !holder for output messages
C 
        logical*1     NULL(3)    !null flag
C 
        DOUBLE PRECISION        START(2)   !start coordinate
        DOUBLE PRECISION        STEP(2)    !step size
C
C
C------------------------------------------------------------------------------
        common /VMR/ MADRID(1)
C------------------------------------------------------------------------------
        data RCOLS/1,2,3,4,5,6,7,8,9,10/

        data INFILE /' '/		!start with clean strings... KB
        data INTAB /' '/
        data OUTFILE /' '/
        data OUTTAB /' '/
C------------------------------------------------------------------------------
C
C Start up program as part of MIDAS environment
C
        CALL stspro('DBLEND')
C
C Get input parameters
C
        CALL stkrdc('INFRAM',1,1,60,ACTVAL,INFILE,KUN,KNUL,STAT)
        CALL stkrdc('IN_B',1,1,60,ACTVAL,INTAB,KUN,KNUL,STAT)
        CALL stkrdc('OUT_A',1,1,60,ACTVAL,OUTFILE,KUN,KNUL,STAT)
        CALL stkrdc('OUT_B',1,1,60,ACTVAL,OUTTAB,KUN,KNUL,STAT)
        CALL stkrdc('FITOPT',1,1,3,ACTVAL,FOPT,KUN,KNUL,STAT)

        CALL upcas(FOPT,FOPT)

        FOPT1 = FOPT(1:1)
        FOPT2 = FOPT(2:2)
        FOPT3 = FOPT(3:3)

C
C  translate fit option to numerical code, with all parameters free as default
C
        if (FOPT1.eq.'W') then
          MODE = 2
        else if (FOPT1.eq.'F') then
          MODE = 3
        else if (FOPT1.eq.'S') then
          MODE = 4
        else
          MODE = 1
        end if
C
C More weighting options: add a paragraph here
C
        if (FOPT2.eq.'P') then
          STRING = ' Weighting option chosen'
          CALL sttput(STRING,STAT)
          MODE = MODE + 10
        end if
C
C More curve options: add a paragraph here
C
        if (FOPT3.eq.'L') then
          STRING = ' Lorentz curve chosen'
          CALL sttput(STRING,STAT)
          MODE = MODE + 100
        end if
C
C Open input image
C
        CALL STIGET(INFILE,10,0,1,2,NAXIS,NPIX,START,STEP,IDENT,
     &     CUNIT,PNTR,NO,STAT)
C
        if (NAXIS.eq.1) then
          NDATA = NPIX(1)
          CALL read1d(MADRID(PNTR),NPIX(1),DATA)
        else if (NAXIS.eq.2.and.(NPIX(1).eq.1.or.NPIX(2).eq.1)) then
          if (NPIX(1).eq.1) then
            NDATA = NPIX(2)
            START(1) = START(2)
            STEP(1) = STEP(2)
          else
            NDATA = NPIX(1)
          end if
          CALL read2d(MADRID(PNTR),NPIX,DATA,NDATA)
        else
          STRING = 'Input image is not a suitable type'
          CALL STTPUT(STRING,STAT)
          go to 9999
        end if
C
C Open input table
C
        CALL TBTOPN(INTAB,2,INTID,STAT)
        CALL TBIGET(INTID,NCOL,NROW,NSC,ACOL,AROW,STAT)
        if (NROW.gt.22) then
          STRING = 'WARNING: only the first 6 lines in ' //
     +             'the table will be used'
          CALL STTPUT(STRING,STAT)
        end if
        NN = (NROW-4) / 3
        NLINES = min(NN,6)
C
C Read parameters from table
C
        CALL TBERDR(INTID,1,3,FITLIM(1),NULL,STAT)
        CALL TBERDR(INTID,2,3,FITLIM(2),NULL,STAT)
        CALL TBERDR(INTID,3,3,CONTIN(1),NULL,STAT)
        CALL TBERDR(INTID,4,3,CONTIN(2),NULL,STAT)
        CALL TBERDR(INTID,3,2,CONTIN(3),NULL,STAT)
        CALL TBERDR(INTID,4,2,CONTIN(4),NULL,STAT)
        do  II = 5,NROW
          CALL TBERDR(INTID,II,1,SPAR(II-4),NULL,STAT)
          CALL TBERDR(INTID,II,2,MPAR(II-4),NULL,STAT)
        end do

        JJ = 0
        do  II = 1,NLINES
          JJ = JJ + 1
          LSIDE = SPAR(JJ)
          JJ = JJ + 1
          CENT(II) = ((SPAR(JJ) - real(START(1))) / real(STEP(1)))+1.
          CMAX(II) = MPAR(JJ)
          JJ = JJ + 1
          RSIDE = SPAR(JJ)
          FWHM = abs(RSIDE - LSIDE) / real(STEP(1))
          if (MODE.ge.100) then
            SIGMA(II) = FWHM                 !Lorentz profiles
            LTAB = 8
          else
            SIGMA(II) = FWHM / 2.354         !Gaussian profiles
            LTAB = 10
          end if
          if (JJ.gt.NROW) go to 9999
        end do
C
        CALL TBTCLO(INTID,STAT)
C
C CALL the subroutine that prepares the data points and calls the fit routine
C
        MODE1 = MODE
        CALL prepfit(DATA,NDATA,FITLIM,CONTIN,NLINES,MODE,
     &               CENT,SIGMA,CMAX,SCENT,SSIGMA,SMAX)
        MODE = MODE1
C
C Create output table
C
        CALL TBTINI(OUTTAB,1,1,LTAB,NLINES,OUTTID,STAT)
C
C Initialize the columns
C
        CALL TBCINI(OUTTID,10,1,'E12.4',CUNIT,'CENTER',NN,STAT)
        CALL TBCINI(OUTTID,10,1,'E12.4',CUNIT,'ERR_CENT',NN,STAT)
        CALL TBCINI(OUTTID,10,1,'E12.4','FLUX','MAXIMUM',NN,STAT)
        CALL TBCINI(OUTTID,10,1,'E12.4','FLUX','ERR_MAX',NN,STAT)
        if (LTAB.eq.10) then
          CALL TBCINI(OUTTID,10,1,'E12.4',CUNIT,'SIGMA',NN,STAT)
          CALL TBCINI(OUTTID,10,1,'E12.4',CUNIT,'ERR_SIG',NN,STAT)
        end if
        CALL TBCINI(OUTTID,10,1,'E12.4',CUNIT,'FWHM',NN,STAT)
        CALL TBCINI(OUTTID,10,1,'E12.4',CUNIT,'ERR_FWHM',NN,STAT)
        CALL TBCINI(OUTTID,10,1,'E12.4','FLUX','INT_FLUX',NN,STAT)
        CALL TBCINI(OUTTID,10,1,'E12.4','FLUX','ERR_SIG',NN,STAT)
C
C Write resulting fit parameters to output table
C
        do  II = 1,NLINES
          PAR(1) = (CENT(II)-1)*real(STEP(1)) + real(START(1))
          PAR(2) = SCENT(II)*real(STEP(1))
          PAR(3) = CMAX(II)
          PAR(4) = SMAX(II)
          PAR(5) = SIGMA(II)*real(STEP(1))
          PAR(6) = SSIGMA(II)*real(STEP(1))
          if (LTAB.eq.10) then
            PAR(7) = PAR(5) * 2.354
            PAR(8) = PAR(6) * 2.354
            PAR(9) = SQRT(2*3.14159) * PAR(5) * PAR(3)
            PAR(10) = PAR(9) * ((PAR(4)/PAR(3)) + (PAR(6)/PAR(5)))
          else
            PAR(7) = (3.14159/2) * PAR(5) * PAR(3)
            PAR(8) = PAR(7) * ((PAR(4)/PAR(3))+(PAR(6)/PAR(5)))
          end if
          CALL tbrwrr(OUTTID,II,LTAB,RCOLS,PAR,STAT)
        end do
C
        CALL TBTCLO(OUTTID,STAT)
C
C Finished with input file
C
        CALL STFCLO(NO,STAT)
C
C Now to generate output files
C
        NPIX(1) = abs(FITLIM(2) - FITLIM(1)) + 1
        START(1) = START(1) + (dble(FITLIM(1)-1) * STEP(1))
        IDENT = 'DBLEND fit of spectrum '//INFILE
        STRING = 'generating file '//OUTFILE
        CALL sttput(STRING,STAT)
        CALL STIPUT(OUTFILE,10,1,1,1,NPIX(1),START(1),STEP(1),IDENT,
     &          CUNIT,PNTR,NO,STAT)
        CALL fitgen(MADRID(PNTR),NPIX(1),FITLIM,CONTIN,NLINES,
     &          CENT,SIGMA,CMAX,MODE)
        CALL stfclo(NO,STAT)
C
C Individual lines
C
        if (NLINES.gt.1) then
          do  II = 1,NLINES
            write (LNO,fmt='(i1)') II
            JJ = INDEX(IDENT,' ')
            IF (JJ.LT.1) JJ = LEN(IDENT)
            IDNT = IDENT(1:JJ)//', line number '//LNO
            IDENT = IDNT
            FNAME = OUTFILE(1:3)//'L000'//LNO
            STRING = 'generating file '//FNAME
            CALL sttput(STRING,STAT)
            CALL stiput(FNAME,10,1,1,1,NPIX(1),START(1),STEP(1),IDENT,
     &            CUNIT,PNTR,NO,STAT)
            CALL fitgen(MADRID(PNTR),NPIX(1),FITLIM,CONTIN,1,CENT(II),
     &            SIGMA(II),CMAX(II),MODE)
            CALL stfclo(NO,STAT)
          end do
        end if
C
C All finished!
C
 9999        CALL stsepi
        end


        subroutine prepfit(IN,NPIX,FITLIM,CONTIN,NLINES,MODE,
     &                     CENT,SIGMA,CMAX,SCENT,SSIGMA,SMAX)

        implicit none

        INTEGER     NLINES             !number of profiles to be fit
        INTEGER     NPIX               !size of image

        DOUBLE PRECISION        A(40)              !parameters to be passed to fitting routine
        DOUBLE PRECISION        A0(40)             !iteration limits for parameters A
        REAL        CENT(NLINES)       !centers of lines
        REAL        CMAX(NLINES)       !central line intensity
        REAL        CONTIN(4)          !x,y of 2 continuum points chosen by user
        DOUBLE PRECISION        D(40)              !step size for calculating derivatives
        REAL        FITLIM(2)          !limits of area to be fit
        REAL        IN(NPIX)           !input image
        INTEGER     LIM0               !zeroth pixel in subsection to be fit
        INTEGER     MODE               !fit mode
        INTEGER     NPIXS              !number of pixels in subsection to be fit
        DOUBLE PRECISION        S                  ! ??  cf snlfit
        REAL        SCENT(NLINES)      !estimated error of fit center
        DOUBLE PRECISION        SIG(40)            !error estimates of parameters A
        REAL        SIGMA(NLINES)      !Gaussian sigma of line
        DOUBLE PRECISION        SLOPE              !slope of continuum
        REAL        SMAX(NLINES)       !estimated error of fit maximum
        REAL        SSIGMA(NLINES)     !estimated error of fit sigma
        INTEGER     STAT               !return status indicator
        character*80  STRING             !character screen for terminal output
        INTEGER     TPIX               !pixel counter
        DOUBLE PRECISION        VAR                ! ??  cf snlfit
        DOUBLE PRECISION        WAV                !average weight of data points
        DOUBLE PRECISION        WW(50000)           !weights for data points
        DOUBLE PRECISION        XCONT(2),YCONT(2)  !x,y for chosen continuum points
        DOUBLE PRECISION        XX(50000),YY(50000)  !data values for least squares fit
        DOUBLE PRECISION        YBACK              !value of continuum at given pixel
C
        DOUBLE PRECISION        DX,DY              !temporary value holders
        INTEGER     II              !dummy counter
C
        external GAUSS,LORENTZ
        data WW /50000*1./

C
C Read in portion of spectrum to be fit
C
        NPIXS = nint(abs(FITLIM(2) - FITLIM(1))) + 1
        LIM0 = nint(FITLIM(1)) - 1
        do  II = 1,NPIXS
          TPIX = LIM0 + II
          XX(II) = dble(TPIX)
          YY(II) = dble(IN(TPIX))
          if (YY(II).eq.0) then
            STRING = ' zero data value at pixel '
            write (STRING(27:80),fmt='(i4)') II
            CALL sttput(STRING,STAT)
          end if
        end do
C
C More weighting options: add a paragraph here
C
        if (MODE.ge.10) then
          do  II = 1,NPIXS
            WW(II) = 1./abs(YY(II))
            if (WW(II).eq.0) then
              STRING = ' zero weight at pixel '
              write (STRING(23:80),fmt='(i4)') II
              CALL sttput(STRING,STAT)
            end if
          end do
        end if
C
C Subtract continuum
C
        do  II = 1,2
          XCONT(II) = dble(CONTIN(II))
          YCONT(II) = dble(CONTIN(II+2))
        end do

        SLOPE = (YCONT(2) - YCONT(1)) / (XCONT(2) - XCONT(1))

        do  II = 1,NPIXS
          DX = XX(II) - XCONT(1)
          DY = DX * SLOPE
          YBACK = YCONT(1) + DY
          YY(II) = YY(II) - YBACK
          if (YY(II).eq.0) then
            STRING = ' zero data value at pixel '
            write (STRING(27:80),fmt='(i4)') II
            CALL sttput(STRING,STAT)
          end if
        end do
C
C Fill variables in common block
C
        do  II = 1,40
          A(II) = 0.
          A0(II) = 0.
          SIG(II) = 0.
          D(II) = 1.0d-6
        end do

        do  II = 1,NLINES
          A(II) = dble(CENT(II))
          A(II+NLINES) = dble(SIGMA(II))
          DX = dble(CENT(II)) - XCONT(1)
          DY = DX * SLOPE
          YBACK = YCONT(1) + DY
          A(II+2*NLINES) = dble(CMAX(II)) - YBACK
          A0(II) = 0.01 * dble(SIGMA(II))
          A0(II+NLINES) = A0(II)
          A0(II+2*NLINES) = 0.01 * dble(CMAX(II))
        end do

        if (MODE.ge.100) then
          CALL snlfit(MODE,XX,YY,WW,NPIXS,NLINES,LORENTZ,
     &                A,A0,SIG,D,WAV,VAR,S) 
        else
          CALL snlfit(MODE,XX,YY,WW,NPIXS,NLINES,GAUSS,
     &                A,A0,SIG,D,WAV,VAR,S) 
        end if
C
C Re-parse variables in common block
C
        do  II = 1,NLINES
          CENT(II) = real(A(II))
          SIGMA(II) = real(A(II+NLINES))
          CMAX(II) = real(A(II+2*NLINES))
          SCENT(II) = real(SIG(II))
          SSIGMA(II) = real(SIG(II+NLINES))
          SMAX(II) = real(SIG(II+2*NLINES))
        end do

        return
        end


        subroutine fitgen(OUT,NPIX,FITLIM,CONTIN,NLINES,CENT,SIGMA,
     &                    CMAX,MODE)

        implicit none

        INTEGER  NLINES  !number of profiles to be fit
        INTEGER  NPIX          !size of image
        INTEGER  IFI1, IFI2
        INTEGER  MODE          !code for type of fit to be done
        INTEGER  PIX
        INTEGER  II,JJ         !dummy counter

        DOUBLE PRECISION     AA(40)        !parameter array for fit subroutines
        DOUBLE PRECISION     X0,Y0         !a point on the fitted curve

        REAL     CENT(NLINES)  !centers of lines
        REAL     CMAX(NLINES)  !central line intensity
        REAL     CONTIN(4)     !x,y of 2 continuum points chosen by user
        REAL     FITLIM(2)     !limits of area to be fit
        REAL     GSUM          !calculated continuum background at a given pixel
        REAL     OUT(NPIX)     !output image
        REAL     SIGMA(NLINES) !Gaussian sigma of line
        REAL     SLOPE         !slope of continuum
        REAL     XCONT(2),YCONT(2) !x,y for chosen continuum points
        REAL     DX,DY      !temporary value holders

        do  II = 1,2
          XCONT(II) = CONTIN(II)
          YCONT(II) = CONTIN(II+2)
        end do

        SLOPE = (YCONT(2) - YCONT(1)) / (XCONT(2) - XCONT(1))

        IFI1 = FITLIM(1)
        IFI2 = FITLIM(2)

        do  II = IFI1,IFI2
          DX = II - XCONT(1)
          DY = DX * SLOPE
          GSUM = YCONT(1) + DY
          X0 = dble(II)
          do  JJ = 1,NLINES
            AA(JJ) = dble(CENT(JJ))
            AA(JJ+NLINES) = dble(SIGMA(JJ))
            AA(JJ+2*NLINES) = dble(CMAX(JJ))
          end do
          if (MODE.ge.100) then
            CALL lorentz(X0,Y0,AA,NLINES)
          else
            CALL gauss(X0,Y0,AA,NLINES)
          end if
          GSUM = GSUM + real(Y0)
          PIX = II-FITLIM(1)+1
          OUT(PIX) = GSUM
        end do

        return
        end


      SUBROUTINE SNLFIT(MODE,X,Y,W,N,NLINES,FUNC,
     &                  TT,T0,TSIG,D,WAV,VAR,S)
C                                                                               
C     X(N),Y(N) x,y-points I=1...N                                              
C     W(N) = weights                                                            
C     Use MODE < 10 if W(I)=1, 10 < MODE < 20 if W(I) = 1/N (Poisson noise)
C     N = Number of points (less or equal 50000)
C     M = Number of parameters A(M) for fit function FUNC                       
C         (less or equal 40)                                                    
C     A(M) : start of SNLFIT: estimated initial parameters                      
C            end   of SNLFIT: fitted parameters                                 
C     A0(k): iteration limits for parameters A(k)                               
C     SIG(k) : Error estimation of parameters                                   
C     FUNC : Name of Function                                                   
C                                                                               
C     H.-H. LOOSE  US-GOETTINGEN  Feb 1986                                      
C                  changed     22 May 1987                                      
C           output lun=7 new   20 Jan 1990
C                                                                               
C     This Version Mmax=40, Nmax=50000
C                                                                               
      IMPLICIT DOUBLE PRECISION(A-H,O-Z), INTEGER(I-N)    
C 
      character*80  STRING  !holder for output messages
C 
      INTEGER   STAT
C 
      DIMENSION X(1),Y(1),W(1)                                                  
      DIMENSION Y1(50000),Y2(40),A1(40),A2(40),D2(40),X2(2)
      DIMENSION A(40),A0(40),SIG(40),D(40),TT(40),T0(40),TSIG(40)
      DIMENSION G(40,41)  
C 
      EXTERNAL  FUNC
C 
      DATA ITMAX/100/                                                           
      DATA IFLAG/0/
C
C  startup
C
      STRING = ' SNLFIT Vers: 22-May-87'
      CALL STTPUT(STRING,STAT)
C
C  initializations
C
      I0 = 0
        if (MODE.ge.10) then
          IFLAG = 1
          MODE = mod(MODE,10)
        end if

        if (MODE.eq.2) then
          M = 2*NLINES
          do  II = 1,M
            A(II) = TT(II+NLINES)
            A0(II) = T0(II+NLINES)
          end do
        else if (MODE.eq.3) then
          M = 2*NLINES
          do  II = 1,NLINES
            A(II) = TT(II)
            A0(II) = T0(II)
          end do
          do  II = NLINES+1,M
            A(II) = TT(II+NLINES)
            A0(II) = T0(II+NLINES)
          end do
        else if (MODE.eq.4) then
          M = 2*NLINES + 1
          do  II = 1,NLINES+1
            A(II) = TT(II)
            A0(II) = T0(II)
          end do
          do  II = NLINES+2,M
            A(II) = TT(II+NLINES-1)
            A0(II) = T0(II+NLINES-1)
          end do
        else
          M = 3*NLINES
          do  II = 1,M
            A(II) = TT(II)
            A0(II) = T0(II)
          end do
        end if

      ITER=0                                                                    
      DO 10 K=1,M                                                               
   10 D2(K) = 2.D0*D(K)                                                         
      E=1.D-3                                                                   
      M1=M+1                                                                    
C                                                                               
      DN = N                                                                    
      NFREE = N-M                                                               
      FREE = NFREE                                                              
      WAV = 0.D0                                                                
      DO  11  I=1,N                                                             
   11 WAV = WAV + W(I)                                                          
      WAV = WAV/DN                                                              
C                                                                               
      GOTO 2000                                                                 
   12 CONTINUE                                                                  

      X2(1) = S                                                                 
C                                                                               
C - - main loop                                                                 
C                                                                               
  500 ITER = ITER + 1                                                           
        STRING = ' Iteration '
        WRITE(STRING(12:80),fmt='(i4)') ITER
        CALL STTPUT(STRING,STAT)
C
C  more initializations
C
      DO 30 K=1,M                                                               
      A1(K) = A(K)                                                              
      DO 30 J=K,M1                                                              
   30 G(K,J) = 0.D0                                                             
C                                                                               
      DO 40 I=1,N                                                               
      X0 = X(I)                                                                 
C - - derivatives                                                               
      DO 41 K=1,M                                                               
        A1(K) = A(K)*(1.D0+D(K))                                                
        CALL tmake(MODE,NLINES,A1,TT)
        CALL func(X0,Y3,TT,NLINES)
        A1(K) = A(K)*(1.D0-D(K))                                                
        CALL tmake(MODE,NLINES,A1,TT)
        CALL FUNC(X0,Y0,TT,NLINES)
        Y2(K) = (Y3-Y0)/(A(K)*D2(K))                                            
        A1(K) = A(K)                                                            
   41 CONTINUE                                                                  
C - - matrix                                                                    
      DO 42 K=1,M                                                               
        G(K,M1) = G(K,M1) + W(I)*(Y(I)-Y1(I))*Y2(K)                             
      DO 42 J=K,M                                                               
   42   G(K,J) = G(K,J) + W(I)*Y2(K)*Y2(J)                                      
   40 CONTINUE                                                                  
      DO 43 K=2,M                                                               
      DO 43 J=1,K-1                                                             
   43   G(K,J) = G(J,K)                                                         
C                                                                               
C     CALL VMAT(G,M)                                                            
C                                                                               
 1000 CONTINUE                                                                  

      CALL SOLS(G,M,E,A2,SIG)                                                   
C
C  update fit parameters
C
      DO 50 K=1,M                                                               
   50 A(K) = A1(K) + A2(K)                                                      
      I0 = 1                                                                    
      GOTO 2000                                                                 
   13 CONTINUE                                                                  
      X2(2) = S                                                                 
      IF( X2(2) .LT. X2(1) ) GOTO 14                                            
      E = E*1.D1                                                                
      GOTO 1000                                                                 
   14 CONTINUE                                                                  
      E = E/1.D1                                                                
      X2(1) = X2(2)                                                             
C                                                                               
      L = 0                                                                     
      DO 60 K=1,M                                                               
      IF(DABS(A2(K)) .GT. DABS(A0(K))) L = 1                                    
   60 CONTINUE                                                                  
      IF (ITER .GE. ITMAX) THEN                                                 
         STRING = ' *** Iteration limit ITMAX=     reached ***'
         write (STRING(28:31),fmt='(i4)') ITMAX
         CALL STTPUT(STRING,STAT)
         L = 0                                                                  
      END IF                                                                    
      IF(L .GT. 0) GOTO 500                                                     
C                                                                               
C - - end of main loop                                                          
C                                                                               
        STRING = ' Variance =                 Wmean='
        write (STRING(12:24),fmt='(1PD12.4)') VAR
        write (STRING(35:80),fmt='(1PD12.4)') WAV
        CALL STTPUT(STRING,STAT)
        IF (IFLAG.eq.1) THEN                                                     
           FAC = 1.D0                                                           
        ELSE                                                     
           FAC = VAR                                                            
        END IF                                                                    
      DO 65 K=1,M                                                               
   65 SIG(K) = FAC*DSQRT(SIG(K))                                                
        CALL tmake(MODE,NLINES,SIG,TSIG)
        CALL tmake(MODE,NLINES,A,TT)
        STRING = ' SNLFIT: END  ITER='
        write (STRING(20:80),fmt='(i4)') ITER
        CALL STTPUT(STRING,STAT)
      RETURN                                                                    
C                                                                               
C - - function values and chi**2                                                
C                                                                               
 2000 S = 0                                                                     
      DO 70 I = 1,N                                                             
      X0 = X(I)                                                                 
        CALL tmake(MODE,NLINES,A,TT)
      CALL FUNC(X0,Y0,TT,NLINES)
      Y1(I) = Y0                                                                
      S = S + W(I)*(Y(I) - Y0)**2                                               

   70 CONTINUE                                                                  
      IF(NFREE .GT. 0) S = S/FREE                                               
      VAR = DSQRT(S/WAV)                                                        
      IF(I0 .EQ. 0) GOTO 12                                                     
      GOTO 13                                                                   
C                                                                               
      END                                                                       
C ------------------------------------                                          
      subroutine vmat(g,m)                                                      
      implicit DOUBLE PRECISION(a-h,o-z), integer(i-n)                                    
      dimension g(10,11)                                                        
C                                                                               
      m1 = m+1                                                                  
      do  100  iz=1,m                                                           
      write(6,300) (g(iz,is), is=1,m1)                                          
  300 format(20(f11.2))                                                         
  100 continue                                                                  
C                                                                               
      return                                                                    
      end                                                                       

      subroutine sols(g,m,e,x,s)                                                
c                                                                               
c     to be used with SNLFIT version 22-May-87 or later                         
c                                                                               
c     input:  g(m,m+1)                                                          
c             m     less or equal 40                                            
c             e     Marquardt factor                                            
c     output: x(m)  solution                                                    
c             s(m)  diagonal elements of inverse of g(m,m)                      
c                                                                               
c     H.-H. Loose US-Goettingen, 22-May-87                                      
c                                                                               
      implicit DOUBLE PRECISION(a-h,o-z), integer(i-n)                                    
      dimension g(40,41), a(40,40), x(1), s(1)                                  
c                                                                               
      m1 = m + 1                                                                
      e1 = e + 1                                                                
c                                                                               
      do 11 i=1,m                                                               
      do 10 k=1,m                                                               
   10 a(i,k) = g(i,k) / dsqrt(g(i,i)*g(k,k))                                    
   11 a(i,i) = e1                                                               
c                                                                               
      CALL matinv(a,m,det)                                                      
      if (det .eq. 0.d0) stop 'SOLS'                                            
c                                                                               
      do 20 j=1,m                                                               
      x(j) = 0.d0                                                               
      s(j) = a(j,j) / g(j,j)                                                    
      do 20 k=1,m                                                               
   20 x(j) = x(j) + g(k,m1)*a(j,k)/ dsqrt(g(j,j)*g(k,k))                        
c                                                                               
      return                                                                    
      end                                                                       


      subroutine matinv (array, norder, det)                                    
c                                                                               
c     purpose                                                                   
c       invert a symmetric matrix and calculate its determinant                 
c                                                                               
c     description of parameters                                                 
c       array  - input matrix which is replaced by its inverse                  
c       norder - degree of matrix (order of determinant)                        
c       det    - determinant of input matrix                                    
c                                                                               
c     subroutines and functions required                                        
c       none                                                                    
c                                                                               
c     comments                                                                  
c       dimension statement valid for order up to 40                            
c                                                                               
c     adapted from P.R. Bevington   program B-2                                 
c       by H.-H. Loose     checked and tested: 22-May-1987                      
c                                                                               
      implicit DOUBLE PRECISION (a-h,o-z), integer (i-n)                                  
      dimension array(40,40), ik(40), jk(40)                                    
   10 det = 1.d0                                                                
   11 do 100 k=1,norder                                                         
c                                                                               
c     find largest element array(i,j) in rest of matrix                         
c                                                                               
      amax = 0.d0                                                               
   21 do 30 i=k,norder                                                          
      do 30 j=k,norder                                                          
   23 if(dabs(amax)-dabs(array(i,j))) 24,24,30                                  
   24 amax = array(i,j)                                                         
      ik(k) = i                                                                 
      jk(k) = j                                                                 
   30 continue                                                                  
c                                                                               
c     interchange rows and columns to put amax in array(k,k)                    
c                                                                               
   31 if (amax) 41,32,41                                                        
   32 det = 0.d0                                                                
      goto 140                                                                  
   41 i = ik(k)                                                                 
      if (i-k) 21,51,43                                                         
   43 do 50 j=1,norder                                                          
      save = array(k,j)                                                         
      array(k,j)=array(i,j)                                                     
   50 array(i,j) = -save                                                        
   51 j = jk(k)                                                                 
      if (j-k) 21,61,53                                                         
   53 do 60 i=1,norder                                                          
      save = array(i,k)                                                         
      array(i,k) = array(i,j)                                                   
   60 array(i,j) = -save                                                        
c                                                                               
c     accumulate elements of inverse matrix                                     
c                                                                               
   61 do 70 i=1,norder                                                          
      if (i-k) 63,70,63                                                         
   63 array(i,k) = -array(i,k)/amax                                             
   70 continue                                                                  
   71 do 80 i=1,norder                                                          
      do 80 j=1,norder                                                          
      if (i-k) 74,80,74                                                         
   74 if (j-k) 75,80,75                                                         
   75 array(i,j) = array(i,j) + array(i,k)*array(k,j)                           
   80 continue                                                                  
   81 do 90 j=1,norder                                                          
      if (j-k) 83,90,83                                                         
   83 array(k,j) = array(k,j)/amax                                              
   90 continue                                                                  
      array(k,k) = 1.d0/amax                                                    
  100 det = det*amax                                                            
c                                                                               
c     restore ordering of matrix                                                
c                                                                               
  101 do 130 l=1,norder                                                         
      k = norder - l + 1                                                        
      j = ik(k)                                                                 
      if (j-k) 111,111,105                                                      
  105 do 110 i=1,norder                                                         
      save = array(i,k)                                                         
      array(i,k) = -array(i,j)                                                  
  110 array(i,j) = save                                                         
  111 i = jk(k)                                                                 
      if (i-k) 130,130,113                                                      
  113 do 120 j=1,norder                                                         
      save = array(k,j)                                                         
      array(k,j) = -array(i,j)                                                  
  120 array(i,j) = save                                                         
  130 continue                                                                  
  140 return                                                                    
      end                                                                       


        subroutine GAUSS(X0,Y0,AA,NLINES)

        implicit none

        DOUBLE PRECISION     X0,Y0    !data values
        DOUBLE PRECISION     AA(40)   !fit parameters
        INTEGER  NLINES   !number of gaussian profiles being fit
        DOUBLE PRECISION     CENT     !center of line
        DOUBLE PRECISION     SIGMA    !gaussian sigma of line
        DOUBLE PRECISION     CMAX     !line maximum

        INTEGER  KK       !dummy counter
        DOUBLE PRECISION     ZZ,GFIT  !dummy value holder

        Y0 = 0.

        do  KK = 1,NLINES
          CENT = AA(KK)
          SIGMA = AA(KK+NLINES)
          CMAX = AA(KK+2*NLINES)
          if (SIGMA.ne.0) then
            ZZ = (X0 - CENT) / SIGMA
C Cut-off at GFIT < 1e-6 * CMAX
C            if (ZZ.gt.5.3) then 
C              GFIT = 0
C            else
              GFIT = CMAX * exp(-(ZZ*ZZ)/2)
C            end if
            Y0 = Y0 + GFIT
          end if
        end do

        return
        end


        subroutine LORENTZ(X0,Y0,AA,NLINES)

        implicit none

        DOUBLE PRECISION     AA(40)   !fit parameters
        DOUBLE PRECISION     BETA2    !(FWHM/2)**2
        DOUBLE PRECISION     CENT     !center of line
        DOUBLE PRECISION     CMAX     !line maximum
        DOUBLE PRECISION     FWHM     !gaussian sigma of line
        INTEGER  NLINES   !number of gaussian profiles being fit
        DOUBLE PRECISION     X0,Y0    !data values

        INTEGER  II       !dummy counter
        DOUBLE PRECISION     ZZ,GFIT  !dummy value holders

        Y0 = 0.

        do  II = 1,NLINES
          CENT = AA(II)
          FWHM = AA(II+NLINES)
          CMAX = AA(II+2*NLINES)

          BETA2 = (FWHM / 2)**2
          ZZ = BETA2 / ((X0 - CENT)**2 + BETA2)
          GFIT = CMAX * ZZ
          Y0 = Y0 + GFIT
        end do

        return
        end


        subroutine TMAKE(MODE,NLINES,AA,TT)

C  reconstruct TT matrix of params from AA (possibly partial) matrix

        implicit none

        DOUBLE PRECISION     AA(40)   !fit parameters
        INTEGER  MODE     !fit mode
        INTEGER  NLINES   !number of gaussian profiles being fit
        DOUBLE PRECISION     TT(40)   !function parameters
        INTEGER  MM       !number of parameters in AA

        INTEGER  II       !dummy counter

        if (MODE.eq.2) then
          MM = 2*NLINES
          do  II = 1,MM
            TT(II+NLINES) = AA(II)
          end do
        else if (MODE.eq.3) then
          MM = 2*NLINES
          do  II = 1,NLINES
            TT(II) = AA(II)
          end do
          do  II = NLINES+1,MM
            TT(II+NLINES) = AA(II)
          end do
        else if (MODE.eq.4) then
          MM = 2*NLINES + 1
          do  II = 1,NLINES+1
            TT(II) = AA(II)
          end do
          do  II = NLINES+2,2*NLINES
            TT(II) = AA(NLINES+1)
          end do
          do  II = NLINES+2,MM
            TT(II+NLINES-1) = AA(II)
          end do
        else
          MM = 3*NLINES
          do  II = 1,MM
            TT(II) = AA(II)
          end do
        end if

        return
        end

C @(#)setselect.for	19.1 (ES0-DMD) 02/25/03 13:24:28
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT:      Copyright (c) 1989 European Southern Observatory,
C                                    all rights reserved
C.IDENTIFICATION: SETSELECT
C.PURPOSE:        set select flag in pcat for selected entries
C                 part of ESOLV image retrieval software
C.AUTHOR:         J. Edwin Huizinga
C.LANGUAGE:       F77+ESOext 
C.KEYWORDS:       ESOLV, table, select
C.ALGORITHM: 
C.INPUT/OUTPUT:   N/I/1/1 number of entries selected
C                 INPUTI/I/1/N eso-identifiers
C.VERSION:        890707 JEH creation
C----------------------------------------------------------------------
      PROGRAM SETSELECT
C
C This program is part of the package to copy files from optical disk to
C working directory provided by ESO-LV project. 
C It selects wanted entries in PCAT which will be used in FROMOD.FOR.
C Input from FROMOD.PRG via INPUTI, N.
C
C declarations:
C
      IMPLICIT NONE
      INTEGER     MADRID
      INTEGER     TID,IST,IAV,UNIT
      INTEGER     NCOL,NROW,NSC,ACOL,AROW
      INTEGER     I,ROW,ENTRY,WANTED(20),NWANT
      INTEGER     IFATAL,KUN
C
      CHARACTER   TEXT*80,TABLE*12
C
      LOGICAL     NOP
C
      INCLUDE     'MID_INCLUDE:ST_DEF.INC/NOLIST'
      COMMON      /VMR/MADRID(1)
      INCLUDE     'MID_INCLUDE:ST_DAT.INC/NOLIST'
C
C init MIDAS monitor, get PCAT and NWANT, WANTED eso identifier:
C 
      CALL STSPRO('SETSELECT')
      CALL STKRDC('P1',1,1,12,IAV,TABLE,UNIT,NOP,IST)
      CALL STKRDI('N',1,1,IAV,NWANT,UNIT,NOP,IST)
      IF (NWANT.EQ.0) THEN
         WRITE(TEXT,10) '*** FATAL: No selected entries'
 10      FORMAT(A)
         CALL STTPUT(TEXT,IST)
         IFATAL = 1
         CALL STKWRI('FATAL',IFATAL,1,1,KUN,IST)
         CALL STSEPI
      ENDIF
      CALL STKRDI('INPUTI',1,NWANT,IAV,WANTED,UNIT,NOP,IST)
      CALL TBTOPN(TABLE,F_IO_MODE,TID,IST)
      IF (IST.NE.0) THEN
         WRITE(TEXT,20) TABLE
 20      FORMAT('*** FATAL: Problems opening table ',A)
         CALL STTPUT(TEXT,IST)
         IFATAL = 1
         CALL STKWRI('FATAL',IFATAL,1,1,KUN,IST)
         CALL STSEPI
      ENDIF
      CALL TBIGET(TID,NCOL,NROW,NSC,ACOL,AROW,IST)
C
C initialize by setting all selects to false
C
      DO ROW=1, NROW
         CALL TBSPUT(TID,ROW,0,IST)
      ENDDO
C
C find row numbers in PCAT and set select to true:
C
      DO I=1, NWANT
         CALL TBESRR(TID,1,1.*WANTED(I),0,1,ENTRY,IST)
         IF (ENTRY.EQ.-1) THEN
            WRITE(TEXT,30) 'Entry not found in PCAT: ',WANTED(I)
 30         FORMAT(A,I8)
            CALL STTPUT(TEXT,IST)
         ELSE
            CALL TBSPUT(TID,ENTRY,1,IST)
         ENDIF
      ENDDO
C
C finish MIDAS and close PCAT:
C
      CALL TBTCLO(TID,IST)
      CALL STSEPI
C
C finito:
C
      END

C @(#)defpsf.for	19.1 (ES0-DMD) 02/25/03 13:25:33
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C
C
C-----------------------------------------------------------------------
      SUBROUTINE DEFPSF(RARR, FPSF, NPRF, IPSF, LPXL, LSBP)
C
      IMPLICIT NONE
      INCLUDE  'MID_REL_INCL:INVENT.INC/NOLIST'
C
      REAL      RARR(64)
      REAL      FPSF(1)
      INTEGER   NPRF
      INTEGER   IPSF(0:NPRF)
      INTEGER   LPXL
      INTEGER   LSBP
C
      INTEGER   MPXL, MPXL2
      INTEGER   MSBP, MSBP2
      INTEGER   I
      INTEGER   ISTEP
      INTEGER   IDI, IDJ
      INTEGER   I1, I2
      INTEGER   LMAX
      INTEGER   LADR, JADR, KADR
      INTEGER   L
      INTEGER   K, KK
      INTEGER   J
      INTEGER   IADR
C
      REAL      SCL
      REAL      DR, DL
      REAL      RD, RDD
      REAL      ACN, ASN
      REAL      APSF(0:MAXSUB)
      REAL      COEF(2,MAXSUB)
      REAL      ZERO
      REAL      SCL2
C
C *** Recall one-dimensional point spread function.
C
      CALL INAPSF( RARR , MAXSUB , APSF )
C
C *** Calculate dimensions of arrays.
C
      MPXL = 2 * LPXL + 1
      MSBP = 2 * LSBP + 1
      MPXL2 = MPXL * MPXL
      MSBP2 = MSBP * MSBP
      ISTEP = MSBP2 * MPXL2
      IDI = ISTEP
      IDJ = 2 * ISTEP
C
C *** Initialize array IPSF.
C
      IPSF(0) = NOSP
      I1 = IPSF(0) + 1
      I2 = IPSF(0) + MSBP2 
      DO 60 I = I1 , I2
          IPSF(I) = 0
   60 CONTINUE
C
C *** Approximate to parabola inside of central pixel.
C
      SCL = ( 1.0 - APSF(1) ) / 1.496
      ZERO = 1.0 + 0.168 * SCL
      SCL2 = (-2.0) * SCL
C
C *** Calculate coefficients of parabolic interpolation.
C
      COEF(1,2) = 0.415*(APSF(3)-APSF(2)) - 0.824*(APSF(1)-APSF(2))
      COEF(2,2) = 0.585*(APSF(3)-APSF(2)) + 0.824*(APSF(1)-APSF(2))
      LMAX = MIN( 2*LPXL , MAXSUB-1 )
      DO 15 L = 3 , LMAX
          COEF(1,L) = ( APSF(L+1) - APSF(L-1) ) / 2.0
          COEF(2,L) = ( APSF(L+1) + APSF(L-1) - 2*APSF(L) ) / 2.0
   15 CONTINUE
C
C *** Calculate initial two-dimensional point spread function.
C
      DL = 1.0 / FLOAT( 2 * LSBP + 1 )
      DO 20 L = -LSBP , LSBP
          LADR = 1 + (L+LSBP) * MSBP * MPXL2
          DO 30 K = -LSBP , LSBP
              KADR = LADR + (K+LSBP) * MPXL2
              DO 40 J = -LPXL , LPXL
                  JADR = KADR + (J+LPXL) * MPXL
                  DO 50 I = -LPXL , LPXL
                      IADR = JADR + (I+LPXL)
                      RDD = (J-L*DL)**2.0 + (I-K*DL)**2.0
                      IF ( RDD .EQ. 0.0 ) THEN
                          RDD = 0.168 * DL * DL
                      ENDIF
                      RD = SQRT( RDD )
                      IF ( RD .GT. 0.0 ) THEN
                          ACN = (I-K*DL) / RD
                          ASN = (J-L*DL) / RD
                      ELSE
                          ACN = 0.0
                          ASN = 0.0
                      ENDIF
                      IF ( RD .LT. 1.29 ) THEN
                          FPSF(IADR) = ZERO - SCL * RDD
                          FPSF(IADR+IDI) = SCL2 * RD * ACN
                          FPSF(IADR+IDJ) = SCL2 * RD * ASN
                      ELSE IF ( RD .LT. 2.6 ) THEN
                          DR = RD - 2.0
                          FPSF(IADR) = APSF(2) + ( COEF(1,2)
     &                                 + COEF(2,2) * DR ) * DR
                          FPSF(IADR+IDI) = ( COEF(1,2) +
     &                                     2.0 * COEF(2,2) * DR ) * ACN
                          FPSF(IADR+IDJ) = ( COEF(1,2) +
     &                                     2.0 * COEF(2,2) * DR ) * ASN
                      ELSE
                          KK = NINT(RD)
                          DR = RD - KK
                          FPSF(IADR) = APSF(KK) + ( COEF(1,KK)
     &                                 + COEF(2,KK) * DR ) * DR
                          FPSF(IADR+IDI) = ( COEF(1,KK) +
     &                                     2.0 * COEF(2,KK) * DR ) * ACN
                          FPSF(IADR+IDJ) = ( COEF(1,KK) +
     &                                     2.0 * COEF(2,KK) * DR ) * ASN
                      ENDIF
   50             CONTINUE
   40         CONTINUE
   30     CONTINUE
   20 CONTINUE
C
      RETURN
C
      END
C

C @(#)irscontsub.for	19.1 (ES0-DMD) 02/25/03 14:23:43
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.COPYRIGHT   (C) 1992 European Southern Observatory
C.IDENT       irscontsub.for
C.AUTHOR      E. Oliva,  Firenze-Arcetri
C.KEYWORDS    Spectroscopy, IRSPEC
C
C.PURPOSE     Fit row by row a poynom and subtract it from a
C             given image (IN_A). Regions to exclude are in dummy
C             image &w (input)
C
C.ALGORITHM   Standard fit of polynoms
C
C
C.INPUT/OUTPUT 'IN_A' : image from which to subtract the continuum
C               &w    : "selection image", fit only pixels &w(x,y)=1.0
C              'OUT_A': continuum subtracted image
C              'OUT_B': continuum image (optional)
C
C
C.VERSION     1.0    Creation     02.09.1992   E. Oliva
C
C-------------------------------------------------------
C
      PROGRAM CONTSUB
      IMPLICIT REAL(A-H,O-Z)
      IMPLICIT INTEGER(I-N)

      CHARACTER*64 CUNIT
      CHARACTER*72 IDENT
      CHARACTER*60 FRAMI,FRAMO,FRAMC,FRAMW
      INTEGER NPIX(2),MMPIX(2)
      REAL CUTS(2)
      DOUBLE PRECISION START(2),STEP(2)
c
c pointers
c
      INTEGER*8 IPI,IPO,IPC,IPW
      COMMON /VMR/ MADRID(1)

      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'

      DATA MAXDIM/2/

      IRET=1
      CALL STSPRO('CONTSUB')
C
C GET INPUT FRAME AND MAP IT
C CHECK ALSO WHETHER IT IS A 2D FRAME.....
C
      CALL STKRDC('IN_A',1,1,60,IRET,FRAMI,KUNIT,KNUL,ISTAT)
      CALL CLNFRA(FRAMI,FRAMI,0)
      CALL STIGET(FRAMI,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,MAXDIM,
     ,            NAXIS,NPIX,START,STEP,
     ,            IDENT,CUNIT,IPI,NIN,ISTAT)
C      IF(NAXIS.NE.2) 
C     +     CALL STETER(1,'Input frame must be 2-D')
      NX=NPIX(1)
      NY=NPIX(2)
C
C Get "weight" frame and map it
C
      CALL CLNFRA('&csw',FRAMW,0)
      CALL STIGET(FRAMW,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,MAXDIM,
     ,            NAXIS,NPIX,START,STEP,
     ,            IDENT,CUNIT,IPW,NW,ISTAT)
C
C GET OUTPUT FRAME AND MAP IT
C
      CALL STKRDC('OUT_A',1,1,60,IRET,FRAMO,KUNIT,KNUL,ISTAT)
      CALL CLNFRA(FRAMO,FRAMO,0)
      CALL STIPUT(FRAMO,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     ,            NAXIS,NPIX,START,STEP,
     ,            IDENT,CUNIT,IPO,NOU,ISTAT)
C
C GET FLAG TO check whether a continuum frame is requested
C
      CALL STKRDI('cont',1,1,IRET,ICONT,KUNIT,KNUL,ISTAT)
      IF(ICONT.GT.0) THEN
C
C GET continuum FRAME AND MAP IT
C
        CALL STKRDC('OUT_B',1,1,60,IRET,FRAMC,KUNIT,KNUL,ISTAT)
        CALL CLNFRA(FRAMC,FRAMC,0)
        CALL STIPUT(FRAMC,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     ,              NAXIS,NPIX,START,STEP,
     ,              'continuum frame',CUNIT,IPC,NC,ISTAT)
C
C GET FLAG TO DEFINE degree of interp. polinom
C
      ENDIF
      CALL STKRDI('deg',1,1,IRET,IDEG,KUNIT,KNUL,ISTAT)
C
C CALL ROUTINE WHICH subtracts row by row
C
      IF(ICONT.GT.0) THEN
        CALL SUBC(MADRID(IPI),MADRID(IPO),MADRID(IPW),MADRID(IPC),
     ,            NX,NY,IDEG,ICONT)
      ELSE
        CALL SUBC(MADRID(IPI),MADRID(IPO),MADRID(IPW),DUMMY,
     ,            NX,NY,IDEG,ICONT)
      ENDIF
C
C
C Define and write cuts of output file
C
      CALL MNMX(MADRID(IPO),NPIX,CUTS,MMPIX)
      CALL STDWRR(NOU,'LHCUTS',CUTS,3,2,KUNIT,ISTAT)
C
C RELEASE FILES, UPDATE KEYWORDS AND EXIT
C
      CALL STSEPI
      END
C
C
C
      SUBROUTINE SUBC(A,B,W2D,CC,NX,NY,IDEG,ICONT)
C
      IMPLICIT REAL(A-H,O-Z)
      IMPLICIT INTEGER(I-N)
C
      DIMENSION A(NX,NY),B(NX,NY),CC(NX,NY),W2D(NX,NY)
      REAL*4 DUM
      PARAMETER (MAXPAR=20)
      DOUBLE PRECISION G(MAXPAR,MAXPAR),COEF(MAXPAR)
      DOUBLE PRECISION X(10000),Y(10000)
      DOUBLE PRECISION POL


c
c Define X(I) once forever
c
      DO I=1,NX
        X(I)=I
      ENDDO
C
      NCOEF=IDEG+1
      DO J=1,NY
C
C COPY J-TH row of input IMAGE (A) into  Y 
C same for weight-image (W)
C
       LL = 0
        DO I=1,NX
          IF (W2D(I,J).LE.1.1 .AND. W2D(I,J).GE.0.9) THEN
             NPT = NPT+1
             Y(I)=A(I,J)
C
C determine coefficients of pol. fitting
C
             CALL TDSET2(LL+1,X(I),0.D0,Y(I),IDEG,0,G,COEF,NCOEF,MAXPAR)
             IF (LL.NE.0) THEN
                KMIN = MIN(LL,NCOEF+1)
                DO K1 = 1,KMIN
                 CALL TDHHTR(K1,LL+1,G,COEF,NCOEF,MAXPAR)
                ENDDO
             ENDIF
             LL = MIN(LL+1,NCOEF+1)
          ENDIF
        ENDDO 
        CALL TDSOLV(G,COEF,NCOEF,MAXPAR)
C
C compute output image row as input-pol_fit
C
        DO I=1,NX
          POL = COEF(1)
          DUM = 1.0
          DO K = 2,NCOEF
             DUM = DUM*X(I)
             POL = POL+COEF(K)*DUM
          ENDDO
          VINT=POL
          B(I,J)=A(I,J)-VINT
          IF(ICONT.GT.0) CC(I,J)=VINT
        ENDDO
      ENDDO
C
      RETURN
      END

C @(#)iosubs.for	19.1 (ES0-DMD) 02/25/03 13:23:49
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C
C=======================================================================
C
C This file contains subroutines which prompt the user neatly to enter
C needed information via the terminal keyboard.
C
C            OFFICIAL DAO VERSION:  1991 April 18
C
C***********************************************************************
C
C Current contents
C
C   INQUIR  right justifies a prompting string to an arbitrary column
C   GETNAM  asks (neatly) for a filename, offering a default.
C   GETFIL  asks for the name and opens the file
C   GETDAT  asks (neatly) for real-number input.
C   GETYN   asks (neatly) for an answer, and accepts only 'Y', 'y',
C           'N', 'n', 'E', or 'e'.
C   GETCHR  asks (neatly) for a Character string
C
C If CTRL-Z is entered as input to any of the above, the routine will
C return directly to the calling routine, with a unique response.
C
C   TBLANK  types a blank line on the terminal.
C   SWITCH  removes the filename extension from an input filename and
C           attaches another character string in its place.
C   EXTEND  checks to see whether an input filename contains a filename
C           extension and, if not, attaches a default filename
C           extension.
C
C***********************************************************************
C
      SUBROUTINE  INQUIR (PROMPT, N)
C
C=======================================================================
C
C Simply type a prompting character string on the terminal,
C right-justified to column N and followed by a single blank, and
C suppress the carriage return.
C
C Argument
C
C PROMPT  (INPUT) is the character string.
C      N  (INPUT) is the column number to contain the last character.
C
C=======================================================================
C
      IMPLICIT NONE
      INTEGER MIN0
      CHARACTER PROMPT*(*), P*132, LINE*132
      INTEGER I, J, K, L, M, N
C
C-----------------------------------------------------------------------
C
C Find the last printing character in the prompt.
C
      M = MIN0(132, N)
      L = MIN0(132, LEN(PROMPT))
      P = PROMPT
 1000 K = 0
      DO I=1,L
         J = ICHAR(P(I:I))
         IF ((J .GE. 33) .AND. (J .LE.126)) K=I
      END DO
C
C K is the position of the last valid character in the
C prompt.  If K is greater than M, the prompt won't fit in one
C line. Find the last blank before position M; this
C will serve as a line break.
C
      IF (K .GT. M) THEN
         DO J=M,1,-1
            IF (P(J:J) .EQ. ' ') GO TO 1500
         END DO
 1500    WRITE (6,600) P(1:J)
 600     FORMAT (1X, A)
         P = P(J+1:K)
         GO TO 1000
      ELSE
         J = 0
      END IF
      LINE = ' '
C
C Now right justify to column M whatever is left
C in the prompting string.
C
      L = M
      DO I=K,J+1,-1
         LINE(L:L) = P(I:I)
         L = L-1
      END DO
C
      WRITE (6,601) LINE(1:M)//' '
  601 FORMAT (1X, A, $)
      RETURN
      END!
C
C#######################################################################
C
      SUBROUTINE  GETNAM (PROMPT, FILE)
C
C=======================================================================
C
C Prompt the user neatly to type in a filename.
C
C Arguments
C
C PROMPT  (INPUT) the character string to be typed on the terminal
C         (right-justified to column 50).
C
C   FILE  (INPUT/OUTPUT) the filename.  On input, it is the default
C         filename, if any, to be offered to the user.  On output,
C         it is what the user wants.
C
C=======================================================================
C
      IMPLICIT NONE
      CHARACTER*(*) PROMPT, FILE
      CHARACTER*132 LINE
      CHARACTER*30 IFILE, SWITCH
      CHARACTER*1 PUNC
      INTEGER I, J, M, N, IERR
C
C If the input character string FILE is all non-printing characters,
C or if it C is 'END OF FILE', no default filename is to be offered.
C Special case: the filename is automatically truncated at a semicolon
C to erase VMS version numbers.
C
      IF (FILE(1:11) .EQ. 'END OF FILE') GO TO 1220
      N = 0
      DO I=1,LEN(FILE)
         J = ICHAR(FILE(I:I))
         IF (J .EQ. 59) GO TO 1210
         IF ((J .GE. 33) .AND. (J .LE. 126)) N = I
      END DO
C
C N marks the position of the last valid character (before the
C semicolon, if any).
C
 1210 IF (N .GT. 0) GO TO 1230
C
C No default filename is to be offered.
C
 1220 CALL INQUIR (PROMPT, 50)
      READ (5,501,END=9100,IOSTAT=IERR) FILE
  501 FORMAT (A)
      IF (IERR .NE. 0) THEN
         CALL STUPID ('Error reading filename.')
         GO TO 1220
      END IF
      RETURN                                             ! Normal return
C
 1230 CONTINUE
C
C A default filename is to be offered.  This is a bit more difficult.
C
C First find the last non-blank character of the prompt.  If this
C has an ascii code outside the ranges 65-90 and 97-122 regard it as
C punctuation.  Otherwise add a colon to the end of the prompt.
C
      M = 0
      DO I=1,LEN(PROMPT)
         J = ICHAR(PROMPT(I:I))
         IF ((J .NE. 0) .AND. (J .NE. 32)) M=I
      END DO
      J = ICHAR(PROMPT(M:M))
      IF ( ((J.GE.63).AND.(J.LE.90)) .OR. ((J.GE.97).AND.(J.LE.122)) )
     .     THEN
         PUNC = ':'
      ELSE
         PUNC = PROMPT(M:M)
         M = M-1
      END IF
C
C M now marks the last non-blank, non-null character before the terminal
C punctuation.  We are now ready to prompt for input.
C
 1240 CONTINUE
CCC      IF (M+N+12 .LE. 50) THEN
         LINE = PROMPT(1:M)//' (default '//FILE(1:N)//')'//PUNC
         CALL INQUIR (LINE, 50)
CCC      ELSE
CCC         CALL INQUIR (PROMPT(1:M)//' ('//FILE(1:N)//')'//PUNC, 50)
CCC      END IF
      READ (5,501,IOSTAT=IERR,END=9100) IFILE
      IF (IERR .NE. 0) THEN
         CALL STUPID ('Error reading filename.')
         GO TO 1240
      END IF
      IF (FILE(1:11) .EQ. 'END OF FILE') GO TO 9100
C
C If IFILE is blank, use the default.
C
      IF (IFILE .EQ. ' ') THEN
         FILE = FILE(1:N)
         RETURN
      END IF
C
C At this point there are three possibilities.  If the first character
C is a period ('.'), the input is to be treated as a filename extension
C which is to be substituted for that of the default.
C
      IF (IFILE(1:1) .EQ. '.') THEN
         FILE = SWITCH(FILE, IFILE)
         RETURN
      END IF
C
C Otherwise, if IFILE contains a period other than in the first
C position, it is to be adopted verbatim.
C
      DO I=1,30
         J = ICHAR(IFILE(I:I))
         IF (J .EQ. 46) THEN
            FILE = IFILE
            RETURN
         END IF
      END DO
C
C Now we are left with the trickiest possibility.  The input file name
C contains no period, so the extension from the input file is to be
C transferred (if any).
C
C Extract the filename extension from the default.  The extension is
C is any text after the last period.
C
      DO J=N,1,-1
         IF (FILE(J:J) .EQ. '.') GO TO 1250
      END DO
C
C No period was found.  The default has no extension, either, so adopt
C the input as the final filename.
C
      FILE = IFILE
      RETURN
C
 1250 FILE = SWITCH(IFILE, FILE(J:N))
      RETURN
C
C CTRL-Z or END OF FILE was entered.
C
 9100 FILE='END OF FILE'
      RETURN
C
      END!
C
C#######################################################################
C
      SUBROUTINE  GETFIL (PROMPT, FILE, LUN, STATUS)
      IMPLICIT NONE
      CHARACTER PROMPT*(*), FILE*(*), STATUS*1
      INTEGER LUN, ISTAT
C
 1000 CALL GETNAM (PROMPT, FILE)
      IF ((STATUS .EQ. 'N') .OR. (STATUS .EQ. 'n')) THEN
         CALL OUTFIL (LUN, FILE, ISTAT)
      ELSE
         CALL INFILE (LUN, FILE, ISTAT)
      END IF
      IF (ISTAT .NE. 0) GO TO 1000
      RETURN
      END!
C
C#######################################################################
C
      SUBROUTINE  GETDAT (PROMPT, DATA, N)
C
C=======================================================================
C
C Prompt the user to input numerical data.
C
C Arguments
C
C PROMPT  (INPUT) is the prompting character string to be typed out,
C         right-justified to column 50.
C
C   DATA  (OUTPUT) is a vector of dimension N, to return the numerical
C         values entered by the user to the calling program.
C
C      N  (INPUT) is the number of individual data items the user
C         is required to enter.
C
C Accept only numerical data, or CTRL-Z.  If CTRL-Z is entered, DATA(1)
C is returned to the calling program equal to -1.1E38.
C
C=======================================================================
C
      IMPLICIT NONE
      CHARACTER PROMPT*(*), LINE*80
      INTEGER N
      REAL DATA(N)
      INTEGER I, IERR
C
C-----------------------------------------------------------------------
C
 1000 CALL INQUIR (PROMPT, 50)
      READ (5,501,IOSTAT=IERR,END=9100) LINE
  501 FORMAT (A)
      IF (IERR .NE. 0) THEN
         CALL STUPID ('Error reading data.')
         GO TO 1000
      END IF
      IF ((LINE(1:1) .EQ. 'E') .OR. (LINE(1:1) .EQ. 'e')) GO TO 9100
      READ (LINE,*,IOSTAT=IERR) (DATA(I), I=1,N)
      IF (IERR .NE. 0) THEN
         CALL STUPID ('Error reading data.')
         GO TO 1000
      END IF
      RETURN
C
C CTRL-Z was entered
C
 9100 DATA(1)=-1.1E38
      RETURN
C
      END!
C
C#######################################################################
C
      SUBROUTINE  GETYN (PROMPT, ANSWER)
C
C=======================================================================
C
C A subroutine to get the user's response to a yes/no question.
C
C Arguments
C
C PROMPT  (INPUT) is the prompting character string, to be typed out
C         right-justified to column 50.
C
C ANSWER  (OUTPUT) is the user's response to the question.
C
C Accept only 'Y', 'y', 'N', 'n', or CTRL-Z as a valid response:
C If 'Y' or 'y', return ANSWER = 'Y' to the calling routine.
C If 'N' or 'n', return ANSWER = 'N' to the calling routine.
C If CTRL-Z, return ANSWER = 'E' to the calling routine.
C
C=======================================================================
C
      IMPLICIT NONE
      CHARACTER PROMPT*(*), ANSWER*1
      INTEGER IERR
C
 1000 CALL INQUIR (PROMPT, 50)
      READ (5,510,IOSTAT=IERR,END=9100) ANSWER
  510 FORMAT (A1)
      IF (IERR .NE. 0) THEN
         CALL STUPID ('Error reading answer.')
         GO TO 1000
      END IF
      IF (ANSWER .EQ. 'y') ANSWER='Y'
      IF (ANSWER .EQ. 'n') ANSWER='N'
      IF (ANSWER .EQ. 'e') ANSWER='E'
      IF ((ANSWER .NE. 'Y') .AND. (ANSWER .NE. 'N') .AND.
     .     (ANSWER .NE. 'E')) THEN
         CALL STUPID ('Error understanding answer.')
         GO TO 1000
      END IF
      RETURN                                             ! Normal return
C
C CTRL-Z was entered.
C
 9100 ANSWER='E'
      RETURN
C
      END!
C
C#######################################################################
C
      SUBROUTINE  GETCHR (PROMPT, ANSWER, N)
C
C=======================================================================
C
C A subroutine to get a character string from the user.
C
C Arguments
C
C PROMPT  (INPUT) is the prompting character string, to be typed out
C         right-justified to column 50.
C
C ANSWER  (OUTPUT) is the user's response.
C
C      N  (OUTPUT) is the number of characters in the user's response.
C
C Accept about anything.
C
C=======================================================================
C
      IMPLICIT NONE
      CHARACTER*(*) PROMPT, ANSWER
      INTEGER I, J, N, IERR
C
 1000 CALL INQUIR (PROMPT, 50)
      READ (5,510,IOSTAT=IERR,END=9000) ANSWER
  510 FORMAT (A)
      IF (IERR .NE. 0) THEN
         CALL STUPID ('Error reading input.')
         GO TO 1000
      END IF
      N = 0
      DO I = 1,LEN(ANSWER)
         J = ICHAR(ANSWER(I:I))
         IF ((J .NE. 0) .AND. (J .NE. 32)) N=I
      END DO
      RETURN
 9000 N = -1
      RETURN
C
      END!
C
C#######################################################################
C
      SUBROUTINE  TBLANK
C
C=======================================================================
C
C A subroutine to type a blank line on the terminal.
C
C=======================================================================
C
      IMPLICIT NONE
      WRITE (6,*)
      RETURN
C
      END!
C
C#######################################################################
C
      CHARACTER*30  FUNCTION  SWITCH  (FILE, ADDEND)
C
C=======================================================================
C
C Subroutine to chop off a filename extension from an input filename
C character string, and append a new character string to the end.
C
C Arguments
C
C   FILE (INPUT) is a character string containing a filename.
C
C ADDEND (INPUT) is the character string to be pasted onto the end
C        of the character string obtained by removing a directory
C        name and the period and all that follows from the input
C        filename.
C
C SWITCH is the filename part of NAFILE, with any directory name
C        contained in brackets chopped off from the front, and with
C        the character string ADDEND substituted for the period and
C        filename extension of the input string.
C
C=======================================================================
C
      IMPLICIT NONE
      INTEGER LEN
C
      CHARACTER*(*) FILE, ADDEND
      INTEGER I, L, LAST
      L = LEN(FILE)
      I=0
 1000 I=I+1
      IF (I .GT. L) GO TO 9000
C
C If a left bracket is detected, then a directory name is present.
C Find the corresponding right bracket (ignoring any periods met along
C the way).
C
      IF ((FILE(I:I) .EQ. '[') .OR. (FILE(I:I) .EQ. '<')) THEN
 1001    I=I+1
         IF (I .GT. 30) GO TO 9100
         IF ((FILE(I:I) .NE. ']') .AND. (FILE(I:I) .NE. '>')) GO TO 1001
         GO TO 1000
      ELSE IF (FILE(I:I) .EQ. '.') THEN
         SWITCH=FILE(1:I-1)//ADDEND
         RETURN
      ELSE IF (FILE(I:I) .EQ. ' ') THEN
         GO TO 1000
      ELSE
         LAST=I
         GO TO 1000
      END IF
C
 9000 CONTINUE
      SWITCH=FILE(1:LAST)//ADDEND
      RETURN
C
 9100 CONTINUE
      WRITE (6,691) CHAR(7), FILE, ADDEND
  691 FORMAT (/' Error creating file name: ', A1, 5X, A30, 5X, A10/)
      CALL BYEBYE
      END!
C
C#######################################################################
C
      CHARACTER*30  FUNCTION  EXTEND (FILE,EXT)
C
C=======================================================================
C
C A function to see whether a filename contained in an input character
C string contains a filename extension.  If it does, leave it alone.
C If not, then attach the filename extension contained in EXT.
C
C Arguments:
C
C FILE a character string presumably containing a filename.
C
C  EXT a character string containing a default filename extension.
C
C=======================================================================
C
      IMPLICIT NONE
      INTEGER LEN
C
      CHARACTER*(*) FILE, EXT
      INTEGER I, J, L
      L = LEN(FILE)
      I=0
 1000 I=I+1
      IF (I .GT. L) GO TO 9100
      IF ((FILE(I:I) .EQ. '[') .OR. (FILE(I:I) .EQ. '<')) THEN
C
C If a left bracket is found then a directory name is present.  Find the
C corresponding right bracket, ignoring any periods met along the way.
C
 1001    I=I+1
         IF ((FILE(I:I) .NE. ']') .AND. (FILE(I:I) .NE. '>')) GO TO 1001
         GO TO 1000
      ELSE
C
C If a period is found, then a filename extension is present.
C
         IF (FILE(I:I) .EQ. '.') THEN
            EXTEND=FILE
            RETURN
         END IF
C
C If a non-blank, non-null character is found, then the filename
C continues to at least this point in the string.
C
         IF ((FILE(I:I) .NE. ' ') .AND. (FILE(I:I) .NE. CHAR(0))) J=I
         IF (I .LT. L) GO TO 1000
      END IF
C
C No period was found, so append "." and EXT to the end of the
C character string.
C
      EXTEND=FILE(1:J)//'.'//EXT
      RETURN
 9100 WRITE (6,691) CHAR(7), FILE, EXT
  691 FORMAT (/' Error creating file name: ', A1, 5X, A30, 5X, A3/)
      CALL BYEBYE
      END!
C
C#######################################################################
C
      SUBROUTINE  RDSTAR (LU, NL, ID, X, Y, AMAG, SKY)
C
C=======================================================================
C
C Read in an ID number, x and y coordinates, magnitude, and sky value
C for the next star in the input file, whatever the file type (i.e.,
C NL = 1, 2, or 3).  If an end of file is encountered, set the star ID
C to a negative number and return; if a blank line is encountered, the
C star ID will be zero.  LU is the logical unit number to be used; the
C other arguments are obvious.
C
C=======================================================================
C
      IMPLICIT NONE
      CHARACTER*133 LINE
      REAL X, Y, AMAG, SKY, DUMMY
      INTEGER LU, N, ISTAT, ID, NL
C
  900 CALL RDCHAR (LU, LINE, N, ISTAT)
      IF (ISTAT .GT. 0) THEN
         ID = -1   !  ID = -1 means END OF FILE
         RETURN
      ELSE IF (ISTAT .LT. 0) THEN
         CALL STUPID ('Unable to read line from input file')
         CALL OOPS
      END IF
C
      IF (N .LE. 1) THEN
         ID = 0                 ! Blank line
         RETURN
      END IF
C
      N = N+1
      LINE(N:N) = '/'
      IF (NL .EQ. 1) THEN
         READ (LINE(2:N),*,ERR=1000) ID, X, Y, AMAG, DUMMY, SKY
      ELSE IF (NL .EQ. 2) THEN
         READ (LINE(2:N),*,ERR=1000,END=2000) ID, X, Y, AMAG
         IF (ID .NE. 0) READ(LU,*,ERR=1000) SKY
      ELSE IF (NL .EQ. 3) THEN
         READ (LINE(2:N),*,ERR=1000) ID, X, Y, AMAG, SKY
      END IF
      RETURN                                             ! Normal return
 1000 CALL STUPID
     .     ('WARNING:  Corrupt star data encountered in input.')
      GO TO 900
C
C-----------------------------------------------------------------------
C
C End of file was encountered.
C
 2000 ID=-1
      RETURN
C
      END!
C
C#######################################################################
C
      SUBROUTINE  RDHEAD (LUN, NL, NCOL, NROW, LOBAD, HIBAD,
     .     THRESH, AP1, PHPADU, READNS, FRAD)
C
C=======================================================================
C
C Read file header from a sequential data file on the disk.  If the
C file has no header, rewind to beginning.
C
C Input argument
C
C    LUN  is the logical unit number of the disk file.
C
C     NL  if NL is greater than zero on input, then in the event that
C         the header is missing from the input file, the missing
C         header information will be requested via the keyboard.
C         If NL is equal to zero on input, only NCOL and NROW
C         will be requrested.  If NL is a negative number on input,
C         missing information will NOT be requested of the user.
C
C Output arguments
C
C     NL  is a code indicating the file type:
C            NL = 3 a group file
C            NL = 2 an aperture photometry file
C            NL = 1 other (output from FIND, PEAK, or NSTAR)
C            NL = 0 a file without a header
C
C    NCOL  is the number of columns in the picture (length in x)
C
C    NROW  is the number of rows in the picture (length in y)
C
C  THRESH  is the star-finding threshold that was used (from FIND)
C
C     AP1  is the radius of the first aperture (from PHOT)
C
C  PHPADU  is the number of photons per ADU that was given(from PHOT)
C
C  READNS  is the readout noise per pixel in ADU (from PHOT)
C
C   LOBAD  is the low bad pixel limit that was used (from FIND)
C
C   HIBAD  is the high bad pixel limit that was used (from FIND)
C
C    FRAD  is the fitting radius (from OPTION, used by PSF, PEAK,
C          and NSTAR)
C
C=======================================================================
C
      IMPLICIT NONE
      CHARACTER*133 LINE
      CHARACTER*4 FIRST4, TEST
      REAL LOBAD, HIBAD, THRESH, AP1, PHPADU, READNS, FRAD, X
      INTEGER LUN, NL, NCOL, NROW, N, ISTAT, NLIN
C
      READ (LUN,900) FIRST4, TEST
  900 FORMAT (A4, 9X, A4)
      IF (FIRST4 .NE. ' NL ') GO TO 8000               ! No header lines
      IF (TEST .EQ. '  LO') THEN
C
C Latest DAOPHOT II file header.
C
         CALL RDCHAR (LUN, LINE, N, ISTAT)
         N = N+1
         LINE(N:N) = '/'
         READ (LINE,*) NL, NCOL, NROW, LOBAD, HIBAD, THRESH,
     .        AP1, PHPADU, READNS, FRAD
      ELSE IF ((TEST .NE. 'LOWB') .AND. (TEST .NE. 'OWBA')) THEN
C
C Obsolete file header.
C
         READ (LUN,901) NLIN, NCOL, NROW, THRESH, AP1, PHPADU, READNS,
     .        LOBAD, FRAD
  901    FORMAT (1X, I2, 2I4, 7F8.1)
         IF (NL .GE. 0) THEN
            IF (AP1 .LE. 0.) THEN
 1010          CALL GETDAT ('Lowest good data-value:', LOBAD, 1)
               IF (LOBAD .LE. -1.E38) GO TO 1010
            END IF
 1020       CALL GETDAT ('Highest good data-value:', HIBAD, 1)
            IF (HIBAD .LE. 0.) GO TO 1020
         END IF
         NL=NLIN
      ELSE
         READ (LUN,901) NL, NCOL, NROW, LOBAD, HIBAD, THRESH, AP1,
     .        PHPADU, READNS, FRAD
      END IF
      READ (LUN,900)
      RETURN                                           ! Normal return
C
 8000 REWIND (LUN)
      IF (NL .GE. 0) THEN
 8001    CALL GETDAT ('Number of columns in the image:', X, 1)
         IF (X .LT. 0.5) GO TO 8001
         NCOL = NINT(X)
 8002    CALL GETDAT ('Number of rows in the image:', X, 1)
         IF (X .LT. 0.5) GO TO 8002
         NROW = NINT(X)
      END IF
C
      IF (NL .GT. 0) THEN
 8003    CALL GETDAT ('Readout noise (ADU):', READNS, 1)
         IF (READNS .LE. 0.) GO TO 8003
 8006    CALL GETDAT ('Gain (photons per ADU):', PHPADU, 1)
         IF (PHPADU .LE. 0.) GO TO 8006
 8010    CALL GETDAT ('Lowest good data-value:', LOBAD, 1)
         IF (LOBAD .LE. -1.E38) GO TO 8010
 8020    CALL GETDAT ('Highest good data-value:', HIBAD, 1)
         IF (HIBAD .LE. -1.E38) GO TO 8020
      END IF
      NL=0
      RETURN
C
      END!
C
C#######################################################################
C
      SUBROUTINE  WRHEAD (LUN, NL, NCOL, NROW, ITEMS, LOBAD, HIBAD,
     .     THRESH, AP1, PHPADU, READNS, FRAD)
C
C=======================================================================
C
C Subroutine to write a standard header into an output sequential
C data file on the disk.  Same as RDHEAD, except that all the output
C arguments are now input arguments.  ITEMS tells how many of the
C individual arguments are to be written into the header.
C
C              Latest DAOPHOT II version:  1991 January 15
C=======================================================================
C
      IMPLICIT NONE
      CHARACTER*8 HEAD(7)
      REAL A(7)
C
      REAL LOBAD, HIBAD, THRESH, AP1, PHPADU, READNS, FRAD
      INTEGER LUN, NL, NCOL, NROW, ITEMS, I
      DATA HEAD /'  LOWBAD', ' HIGHBAD', '  THRESH', '     AP1',
     .     '  PH/ADU', '  RNOISE', '    FRAD'/
C
C-----------------------------------------------------------------------
C
      A(1)=LOBAD
      A(2)=HIBAD
      A(3)=THRESH
      A(4)=AP1
      A(5)=PHPADU
      A(6)=READNS
      A(7)=FRAD
      WRITE (LUN,900) (HEAD(I), I=1,ITEMS)
  900 FORMAT (' NL   NX   NY', 8A8)
      WRITE (LUN,901) NL, NCOL, NROW, (A(I), I=1,ITEMS)
  901 FORMAT (1X, I2, 2I5, 2F8.1, 5F8.2)
      WRITE (LUN,901)                             ! Write a blank line
      RETURN                                        ! Normal return
C
      END!
C
C#######################################################################
C
      SUBROUTINE RDCHAR (LUN, LINE, N, ISTAT)
      IMPLICIT NONE
      CHARACTER*(*) LINE
      INTEGER LUN, N, ISTAT, I, J
C
      READ (LUN,1,END=8000,ERR=9000) LINE
    1 FORMAT (A)
      N = 0
      DO I=1,LEN(LINE)
         J = ICHAR(LINE(I:I))
         IF ((J .GE. 33) .AND. (J .LE. 126)) N = I
      END DO
      ISTAT = 0
      RETURN
 8000 LINE = ' '
      N = 0
      ISTAT = 1  ! ISTAT = 1 means END OF FILE
      RETURN
 9000 LINE = ' '
      N = 0
      ISTAT = -1  ! ISTAT = -1 means ERROR
      RETURN
      END!
C
C#######################################################################
C
      FUNCTION EXTRCT (STRING, IFLAG)
      IMPLICIT NONE
      INTEGER LEN
      CHARACTER*(*) STRING
      REAL EXTRCT
      INTEGER L, IFLAG
C
      L = LEN(STRING)
      READ (STRING, *, ERR=9000) EXTRCT
      IFLAG = 0
      RETURN
 9000 EXTRCT = -1.1E38
      IFLAG = -1
      RETURN
      END!
C
C#######################################################################
C
      SUBROUTINE  STUPID (MESSAG)
      IMPLICIT NONE
      CHARACTER*(*) MESSAG
      CHARACTER*1 BELL
      BELL = CHAR(7)
      WRITE (6,601) MESSAG, BELL
  601 FORMAT (/1X, A, A1/)
      RETURN
      END!
C
C#######################################################################
C
      INTEGER  FUNCTION  ICNVRT (ASTRING)
C
C=======================================================================
C
C This little function is supposed to take two ASCII characters and
C express them as an integer in the range 0-(32**2-1) without
C distinguishing upper and lower case:
C
C AA = Aa = aA = aa = 0, AB = Ab = aB = ab = 1, BA = Ba = bA = ba = 32,
C etc.
C
C Argument
C
C ASTRING is a character string containing two ASCII characters.
C
C=======================================================================
C
      IMPLICIT NONE
      CHARACTER*2 ASTRING
C
C-----------------------------------------------------------------------
C
      ICNVRT=32*MOD(ICHAR(ASTRING(1:1))-1,32)+
     .     MOD(ICHAR(ASTRING(2:2))-1,32)
      RETURN
C
      END!
C
C#######################################################################
C
      SUBROUTINE  OPTION (OPTFIL, NOPT, LBL, OPT, OMIN,
     .     OMAX, PROMPT, ISTAT)
C
C=======================================================================
C
C Acquire a set of optimization parameters, either from a disk file
C or from the keyboard.
C
C              OFFICIAL DAO VERSION:  1985 October 25
C
C Arguments
C
C OPTFIL (INPUT) a character string containing either (a) the name of
C         a disk file which will be offered as the default file from
C         which the parameter definitions are to be read (if OPTFIL =
C         ' ', no default file name will be offered; if OPTFIL =
C         'daophot.opt' and this file does not exist, no error message
C         is to be produced and the current contents of OPT are to be
C         left alone), or (b) the string 'KEYBOARD INPUT', in which
C         case the user is to be prompted to define parameter values
C         via the terminal.
C
C     OPT (INPUT/OUTPUT) numerical values for the NOPT user-definable
C         parameters.
C
C=======================================================================
C
      IMPLICIT NONE
      INTEGER MAXOPT, NOPT
      PARAMETER  (MAXOPT=100)
C
C Parameter:
C
C NOPT is the number of user-specifiable optional parameters.
C
      CHARACTER*26 LBL(NOPT)
      REAL OPT(NOPT), OMIN(NOPT), OMAX(NOPT)
      INTEGER IDOPT(MAXOPT)
C
      REAL EXTRCT
      INTEGER ICNVRT
C
      CHARACTER*80 OLINE
      CHARACTER*30 CASE
      CHARACTER*(*) OPTFIL, PROMPT
      INTEGER ISTAT, NPRO, I, J, INUNIT, N, IOPT
      LOGICAL CHANGE
C
C-----------------------------------------------------------------------
C
C Get ready to interpret the option.  For each of the defined labels,
C convert the first two non-blank characters to a number.
C
 1000 NPRO = LEN(PROMPT)
      DO 1010 I=1,NOPT
         DO J=1,26
            IF (LBL(I)(J:J) .NE. ' ') GO TO 1010
         END DO
 1010 IDOPT(I)=ICNVRT(LBL(I)(J:J+1))
C
C If OPTFIL equals anything but 'KEYBOARD INPUT', then treat it as a
C filename and try to open it and read the commands from it, then
C display the results; if it happens to be daophot.opt, return quietly
C afterwards; otherwise, after displaying what you've read, go back
C and prompt for new keyboard input.
C
      IF (OPTFIL .EQ. 'KEYBOARD INPUT') THEN
         INUNIT = 5
         CALL TBLANK
         WRITE (6,610) (LBL(I), OPT(I), I=1,NOPT)
  610    FORMAT (1X, A26, ' =', F9.2, 4X, A26, ' =', F9.2)
         CALL TBLANK
         CHANGE = .FALSE.
         GO TO 2000
      END IF
C
      INUNIT = 2
      CALL INFILE (2, OPTFIL, ISTAT)
      IF (ISTAT .NE. 0) GO TO 3000
C
C-----------------------------------------------------------------------
C
C SECTION 2
C
C Loop to read and interpret commands one at a time.
C
 2000 IF (INUNIT .EQ. 5) CALL INQUIR (PROMPT, NPRO)
      CALL RDCHAR (INUNIT, OLINE, N, ISTAT)
      IF (ISTAT .GT. 0) THEN
         IF (INUNIT .EQ. 5) RETURN
         GO TO 3000
      END IF
      IF (ISTAT .LT. 0) GO TO 2000
      IF (N .LE. 3) GO TO 3000
C
C Now interpret this command line.
C
C First find the equals sign.  Set J to its numerical position in the
C string.
C
      DO 2010 J=3,N
      IF (OLINE(J:J) .EQ. '=') GO TO 2020
 2010 CONTINUE
      CALL STUPID ('The equals sign is missing.')
      GO TO 2000
C
C Now identify the parameter.
C
 2020 IOPT=ICNVRT(OLINE(1:2))
      DO 2030 I=1,NOPT
      IF (IOPT .EQ. IDOPT(I)) GO TO 2040
 2030 CONTINUE
      CALL STUPID ('Unrecognized parameter: '//OLINE(1:J-1))
      GO TO 2000
C
C Now decode the numeric constant and set the appropriate option to this
C value.  Then go back and obtain the next command line.
C
 2040 OPT(I) = EXTRCT (OLINE(J+1:N), ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID
     .        ('Invalid numeric constant: '//OLINE(J+1:N))
         ELSE
            CHANGE = .TRUE.
      END IF
      GO TO 2000
C
C-----------------------------------------------------------------------
C
C SECTION 3
C
C If file is neither 'daophot.opt' nor 'KEYBOARD INPUT', allow
C the user to enter modifications by hand.
C
 3000 IF (INUNIT .EQ. 2) THEN
         CALL CLFILE (2)
         IF (OPTFIL .NE. CASE('daophot.opt')) THEN
            CALL TBLANK
            WRITE (6,610) (LBL(I), OPT(I), I=1,NOPT)
            CALL TBLANK
            INUNIT = 5
            CHANGE = .FALSE.
            GO TO 2000
         END IF
      END IF
C
C Check that all parameters are acceptable.
C
      DO 3010 I=1,NOPT
      IF ((OPT(I) .LT. OMIN(I)) .OR. (OPT(I) .GT. OMAX(I))) GO TO 4000
 3010 CONTINUE
C
C Type out all parameter values.
C
      IF (CHANGE) THEN
         CALL TBLANK
         WRITE (6,610) (LBL(I), OPT(I), I=1,NOPT)
      END IF
      ISTAT = 0
      RETURN
C
C-----------------------------------------------------------------------
C
C SECTION 4
C
C There was some problem with one of the parameters.  Type it out and
C ask for the problem to be corrected.
C
 4000 CALL STUPID ('Value unacceptable --- please re-enter')
      CALL INQUIR (LBL(I)//' =', 50)
      CALL RDCHAR (5, OLINE, N, ISTAT)
      IF (N .LE. 0) CALL OOPS
      IF (ISTAT .GT. 0) GO TO 3000
      IF (ISTAT .LT. 0) GO TO 4000
C
C Decode the constant.
C
      OPT(I) = EXTRCT(OLINE(1:N), ISTAT)
      IF (ISTAT .NE. 0) GO TO 4000
      GO TO 3000
C
C-----------------------------------------------------------------------
C
C ERROR:  unable to open the disk file.
C
C If the file name is 'daophot.opt', no problem-- just check the
C default values for validity and return to the main program.
C Otherwise, type an error message and ask for a new file name.
C
C 9000 IF (OPTFIL .EQ. CASE('daophot.opt')) GO TO 3000
C      OLINE = 'Error opening input file '//OPTFIL
C      CALL STUPID (OLINE)
C      OPTFIL='KEYBOARD INPUT'
C      GO TO 1000
C
      END!
C
C#######################################################################
C
      SUBROUTINE CHECK(LUN,NL)
C
C Check whether an input file has a DAOPHOT data file header.
C
      IMPLICIT NONE
      CHARACTER*4 FIRST4
      INTEGER NL, LUN
C
      NL=1
      READ(LUN,200)FIRST4
  200 FORMAT(A4)
      IF(FIRST4.NE.' NL ')GO TO 1000
      READ(LUN,201)NL
  201 FORMAT(1X,I2)
      READ(LUN,200)
      RETURN
 1000 REWIND(LUN)
      RETURN
      END!

C @(#)gauss3d.for	19.1 (ES0-DMD) 02/25/03 13:17:39
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE GAUSS3(X,NP,PARAM,Y1,DERIV)                                   
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                  
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  18:01 - 21 DEC 1987                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C--------------------------------------------------------------                 
C**********************************************                                 
C                                                                               
C      IMPLICIT NONE                                                            
C   Three-dimensional Gaussian Distribution                                     
C                                                                               
C**********************************************                                 
C                                                                               
C   Author: O.-G. Richter, ESO Garching                                         
C                                                                               
      INTEGER NP
      DOUBLE PRECISION Y1,PARAM(NP),DERIV(NP)                                   
      REAL X(3)                                                            
      DOUBLE PRECISION R11,R22,R33,R12,R13,R23,R,R1                             
      DOUBLE PRECISION A,B,C,D,E,F,O,P,Q                                        
      DOUBLE PRECISION B2,C2,D2,B22,C22,D22,E1,E2,E3                            
C  !   \                                                                        
      R11    = 1.0D0 - PARAM(10)*PARAM(10)  !    > Diagonals                    
      R22    = 1.0D0 - PARAM(9)*PARAM(9)  !   /                                 
      R33    = 1.0D0 - PARAM(8)*PARAM(8)                                        
C      ! of correlation determ.  !   \                                          
      R12    = PARAM(9)*PARAM(10) - PARAM(8)  !    > Non-diagonals              
      R13    = PARAM(8)*PARAM(10) - PARAM(9)  !   /                             
      R23    = PARAM(8)*PARAM(9) - PARAM(10)                                    
C  !   Total residual dispersion                                                
      R      = 2.0D0*R12*PARAM(8) + R11 + R22 - 1.0  !   and its inverse        
      R1     = 1.0D0/R                                                          
C                                                                               
      A      = 0.6931471806D0*R1                                                
C                                                                               
      B      = (X(1)-PARAM(2))/PARAM(5)                                         
      C      = (X(2)-PARAM(3))/PARAM(6)                                         
      D      = (X(3)-PARAM(4))/PARAM(7)                                         
      B2     = B*B                                                              
      C2     = C*C                                                              
      D2     = D*D                                                              
      B22    = B2*R11                                                           
      C22    = C2*R22                                                           
      D22    = D2*R33                                                           
C                                                                               
      DERIV(1) = DEXP(-A* (B22+C22+D22+2.0* (B*C*R12+B*D*R13+C*D*R23)))         
C                                                                               
      Y1     = DERIV(1)*PARAM(1)                                                
      A      = 2.0*A*Y1                                                         
C                                                                               
      DERIV(2) = A* (B*R11+C*R12+D*R13)/PARAM(5)                                
      DERIV(3) = A* (B*R12+C*R22+D*R23)/PARAM(6)                                
      DERIV(4) = A* (B*R13+C*R23+D*R33)/PARAM(7)                                
      DERIV(5) = DERIV(2)*B                                                     
      DERIV(6) = DERIV(3)*C                                                     
      DERIV(7) = DERIV(4)*D                                                     
      A      = A*R1                                                             
      E      = 2.0*R12*R13                                                      
      E1     = E - PARAM(8)*R                                                   
      E2     = E - PARAM(9)*R                                                   
      E3     = E - PARAM(10)*R                                                  
      F      = B22 + C22 + D22                                                  
      O      = B*C                                                              
      P      = B*D                                                              
      Q      = C*D                                                              
C                                                                               
      DERIV(8) = A* (R12*F+D2*PARAM(8)*R+O* (2.0*R12*R12+R)+P*E3+Q*E2)          
      DERIV(9) = A* (R13*F+C2*PARAM(9)*R+O*E3+P* (2.0*R13*R13+R)+Q*E1)          
      DERIV(10) = A* (R23*F+B2*PARAM(10)*R+O*E2+P*E1+Q* (2.0*R23*R23+R))        
C                                                                               
      RETURN                                                                    
                                                                                
      END                                                                       

C @(#)tdminmax.for	19.1 (ES0-DMD) 02/25/03 14:11:18
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  15:39 - 15 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C.IDENTIFICATION        TDMNMX.FOR
C.KEYWORDS           TABLE, APPLICATIONS
C.ENVIRONMENT  MIDAS
C
C------------------------------------------------------------------

      SUBROUTINE TDUMNX(TID,ICOL,N,IL,XMIN,XMAX)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.PURPOSE
C FIND MINIMUM/ MAXIMUM VALUES IN THE ARRAY X.
C NULL VALUES ARE NOT CONSIDERED.
C NO SELECTION MASK.
C
C------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER TID   !   IN : table identifier
      INTEGER ICOL  !   IN : column number
      INTEGER N     !   IN : number of rows in the table
      INTEGER IL    !   IN : logarithm flag
      REAL    XMIN  !   OUT: minimum value
      REAL    XMAX  !   OUT : maximum value
C
      INTEGER          I, J, STATUS
      REAL             XX
      LOGICAL          ISEL, INULL
C
      XMIN   = 0
      XMAX   = XMIN
      IF (IL.EQ.0) THEN
          DO 10 I = 1,N
              CALL TBSGET(TID,I,ISEL,STATUS)
              CALL TBERDR(TID,I,ICOL,XX,INULL,STATUS)
              IF (ISEL .AND. (.NOT.INULL)) THEN
                  XMIN   = XX
                  XMAX   = XX
                  GO TO 20
              END IF
   10     CONTINUE
          RETURN
   20     CONTINUE
          DO 30 J = I,N
              CALL TBSGET(TID,J,ISEL,STATUS)
              CALL TBERDR(TID,J,ICOL,XX,INULL,STATUS)
              IF (ISEL .AND. (.NOT.INULL)) THEN
                  XMIN   = MIN(XMIN,XX)
                  XMAX   = MAX(XMAX,XX)
              END IF
   30     CONTINUE
      ELSE
          DO 40 I = 1,N
              CALL TBSGET(TID,I,ISEL,STATUS)
              CALL TBERDR(TID,I,ICOL,XX,INULL,STATUS)
              IF (ISEL .AND. (.NOT.INULL) .AND. XX.GT.0.0) THEN
                  XMIN   = XX
                  XMAX   = XX
                  GO TO 50
              END IF
   40     CONTINUE
          RETURN
   50     CONTINUE
          IF (IL.EQ.1) THEN
              XMIN   = ALOG10(XX)
          ELSE
              XMIN   = ALOG(XX)
          END IF
          XMAX   = XMIN
          DO 60 J = I,N
              CALL TBSGET(TID,J,ISEL,STATUS)
              CALL TBERDR(TID,J,ICOL,XX,INULL,STATUS)
              IF (ISEL .AND. (.NOT.INULL) .AND. XX.GT.0.D0) THEN
                  IF (IL.EQ.1) THEN
                      XMIN   = MIN(XMIN,ALOG10(XX))
                      XMAX   = MAX(XMAX,ALOG10(XX))
                  ELSE
                      XMIN   = MIN(XMIN,ALOG(XX))
                      XMAX   = MAX(XMAX,ALOG(XX))
                  END IF
              END IF
   60     CONTINUE
      END IF
      RETURN
      END

      SUBROUTINE TDMNXR(N,X,IL,XMIN,XMAX)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.PURPOSE
C FIND MINIMUM/ MAXIMUM VALUES IN THE ARRAY X.
C NULL VALUES ARE NOT CONSIDERED.
C NO SELECTION MASK.
C
C------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER N     !   IN : dimension
      REAL    X(N)  !   IN : data array
      INTEGER IL    !   IN : logarithm fleg
      REAL    XMIN  !   OUT: minimum value
      REAL    XMAX  !   OUT : maximum value
C
      INTEGER I, J, TINULL
      REAL XX
      REAL TBLSEL, TRNULL
      DOUBLE PRECISION TDTRUE, TDFALS, TDNULL
C
C ... GET MACHINE CONSTANTS
C
      CALL TBMCON(TBLSEL, TDTRUE, TDFALS)
      CALL TBMNUL(TINULL, TRNULL, TDNULL)
C
      I      = 1
      XX     = X(I)
      XMIN   = 0.0
      XMAX   = XMIN
      IF (IL.EQ.0) THEN
   10     CONTINUE
              IF ( .NOT. (XX.EQ.TRNULL.AND.I.LT.N)) GO TO 20
              I      = I + 1
              XX     = X(I)
          GO TO 10 
   20     CONTINUE
          XMIN   = XX
          XMAX   = XX
          DO 30 J = I,N
              IF (X(J).NE.TRNULL) THEN
                  XMIN   = MIN(XMIN,X(J))
                  XMAX   = MAX(XMAX,X(J))
              END IF
   30     CONTINUE
      ELSE
   40     CONTINUE
              IF ( .NOT. ((XX.EQ.TRNULL.OR.XX.LE.0.0).AND.I.LT.
     +            N)) GO TO 50
              I      = I + 1
              XX     = X(I)
          GO TO 40
   50     CONTINUE
          IF (IL.EQ.1) THEN
              XMIN   = ALOG10(XX)
          ELSE
              XMIN   = ALOG(XX)
          END IF
          XMAX   = XMIN
          DO 60 J = I,N
              IF (X(J).NE.TRNULL .AND. X(J).GT.0.0) THEN
                  IF (IL.EQ.1) THEN
                      XMIN   = MIN(XMIN,ALOG10(X(J)))
                      XMAX   = MAX(XMAX,ALOG10(X(J)))
                  ELSE
                      XMIN   = MIN(XMIN,ALOG(X(J)))
                      XMAX   = MAX(XMAX,ALOG(X(J)))
                  END IF

              END IF
   60     CONTINUE
      END IF
      RETURN
      END

      SUBROUTINE TDMNXD(N,X,IL,XMIN,XMAX)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.PURPOSE
C FIND MINIMUM/ MAXIMUM VALUES IN THE ARRAY X.
C NULL VALUES ARE NOT CONSIDERED.
C DOUBLE PRECISION VERSION.
C NO SELECTION MASK.
C
C------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER N              !   IN : array length
      DOUBLE PRECISION X(N)  !   IN : data array
      INTEGER IL             !   IN : logarithm flag  
      DOUBLE PRECISION XMIN  !   OUT: minimum value
      DOUBLE PRECISION XMAX  !   OUT: maximum value
C
      INTEGER I, J, TINULL
      REAL    TBLSEL, TRNULL
      DOUBLE PRECISION TDTRUE, TDFALS, TDNULL
      DOUBLE PRECISION XX
C
C ... GET MACHINE CONSTANTS
C
      CALL TBMCON(TBLSEL, TDTRUE, TDFALS)
      CALL TBMNUL(TINULL, TRNULL, TDNULL)
C
      I      = 1
      XX     = X(I)
      XMIN   = 0.D0
      XMAX   = XMIN
      IF (IL.EQ.0) THEN
   10     CONTINUE
              IF ( .NOT. (XX.EQ.TDNULL.AND.I.LT.N)) GO TO 20
              I      = I + 1
              XX     = X(I)
          GOTO 10
   20     CONTINUE
          XMIN   = XX
          XMAX   = XX
          DO 30 J = I,N
              IF (X(J).NE.TDNULL) THEN
                  XMIN   = MIN(XMIN,X(J))
                  XMAX   = MAX(XMAX,X(J))
              END IF
   30     CONTINUE
      ELSE
   40     CONTINUE
              IF ( .NOT. ((XX.EQ.TDNULL.OR.XX.LE.0.0).AND.I.LT.
     +            N)) GO TO 50
              I      = I + 1
              XX     = X(I)
          GO TO 40
   50     CONTINUE
          IF (IL.EQ.1) THEN
              XMIN   = DLOG10(XX)
          ELSE
              XMIN   = DLOG(XX)
          END IF
          XMAX   = XMIN
          DO 60 J = I,N
              IF (X(J).NE.TDNULL .AND. X(J).GT.0.0) THEN
                  IF (IL.EQ.1) THEN
                      XMIN   = MIN(XMIN,DLOG10(X(J)))
                      XMAX   = MAX(XMAX,DLOG10(X(J)))
                  ELSE
                      XMIN   = MIN(XMIN,DLOG(X(J)))
                      XMAX   = MAX(XMAX,DLOG(X(J)))
                  END IF
              END IF
   60     CONTINUE
      END IF
      RETURN
      END

      SUBROUTINE TDMXIS(TID,ICOL,N,IL,XMIN,XMAX)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.PURPOSE
C FIND MINIMUM/ MAXIMUM VALUES IN THE TABLE TID
C NULL AND NON SELECTED VALUES ARE NOT CONSIDERED.
C INTEGER VERSION.
C
C------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER TID   !   IN : table identifier
      INTEGER ICOL  !   IN : column index
      INTEGER N     !   IN : array length
      INTEGER IL    !   IN : logarithm flag
      REAL    XMIN  !   OUT:  minimum value
      REAL    XMAX  !   OUT: maximum value
C
      INTEGER          I, J, IVAL, STATUS
      REAL             XX
      LOGICAL          ISEL, INULL
C
      XMIN   = 0.0
      XMAX   = XMIN
      IF (IL.EQ.0) THEN
          DO 10 I = 1,N
              CALL TBSGET(TID,I,ISEL,STATUS)
              CALL TBERDI(TID,I,ICOL,IVAL,INULL,STATUS)
              IF (ISEL .AND. (.NOT.INULL)) THEN
                  XMIN   = IVAL
                  XMAX   = IVAL
                  GO TO 20
              END IF
   10     CONTINUE
          RETURN
   20     CONTINUE
          DO 30 J = I,N
              CALL TBSGET(TID,J,ISEL,STATUS)
              CALL TBERDI(TID,J,ICOL,IVAL,INULL,STATUS)
              XX = IVAL
              IF (ISEL .AND. (.NOT.INULL)) THEN
                  XMIN   = MIN(XMIN,XX)
                  XMAX   = MAX(XMAX,XX)
              END IF
   30     CONTINUE
      ELSE
          DO 40 I = 1,N
              CALL TBSGET(TID,I,ISEL,STATUS)
              CALL TBERDI(TID,I,ICOL,IVAL,INULL,STATUS)
              XX = IVAL
              IF (ISEL .AND. (.NOT.INULL) .AND. XX.GT.0.0) THEN
                  XMIN   = XX
                  XMAX   = XX
                  GO TO 50
              END IF
   40     CONTINUE
          RETURN
   50     CONTINUE
          IF (IL.EQ.1) THEN
              XMIN   = ALOG10(XX)
          ELSE
              XMIN   = ALOG(XX)
          END IF
          XMAX   = XMIN
          DO 60 J = I,N
              CALL TBSGET(TID,J,ISEL,STATUS)
              CALL TBERDI(TID,J,ICOL,IVAL,INULL,STATUS)
              XX = IVAL
              IF (ISEL .AND. (.NOT.INULL) .AND. XX.GT.0.D0) THEN
                  IF (IL.EQ.1) THEN
                      XMIN   = MIN(XMIN,ALOG10(XX))
                      XMAX   = MAX(XMAX,ALOG10(XX))
                  ELSE
                      XMIN   = MIN(XMIN,ALOG(XX))
                      XMAX   = MAX(XMAX,ALOG(XX))
                  END IF
              END IF
   60     CONTINUE
      END IF
      RETURN
      END

      SUBROUTINE TDMXRS(TID,ICOL,N,IL,XMIN,XMAX)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.PURPOSE
C FIND MINIMUM/ MAXIMUM VALUES IN THE TABLE TID
C NULL AND NON SELECTED VALUES ARE NOT CONSIDERED.
C SINGLE PRECISION VERSION.
C
C------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER TID   !   IN : table identifier
      INTEGER ICOL  !   IN : column index
      INTEGER N     !   IN : array length
      INTEGER IL    !   IN : logarithm flag
      REAL    XMIN  !   OUT:  minimum value
      REAL    XMAX  !   OUT: maximum value
C
      INTEGER          I, J, STATUS
      REAL             XX
      LOGICAL          ISEL, INULL
C
      XMIN   = 0.0
      XMAX   = XMIN
      IF (IL.EQ.0) THEN
          DO 10 I = 1,N
              CALL TBSGET(TID,I,ISEL,STATUS)
              CALL TBERDR(TID,I,ICOL,XX,INULL,STATUS)
              IF (ISEL .AND. (.NOT.INULL)) THEN
                  XMIN   = XX
                  XMAX   = XX
                  GO TO 20
              END IF
   10     CONTINUE
          RETURN
   20     CONTINUE
          DO 30 J = I,N
              CALL TBSGET(TID,J,ISEL,STATUS)
              CALL TBERDR(TID,J,ICOL,XX,INULL,STATUS)
              IF (ISEL .AND. (.NOT.INULL)) THEN
                  XMIN   = MIN(XMIN,XX)
                  XMAX   = MAX(XMAX,XX)
              END IF
   30     CONTINUE
      ELSE
          DO 40 I = 1,N
              CALL TBSGET(TID,I,ISEL,STATUS)
              CALL TBERDR(TID,I,ICOL,XX,INULL,STATUS)
              IF (ISEL .AND. (.NOT.INULL) .AND. XX.GT.0.0) THEN
                  XMIN   = XX
                  XMAX   = XX
                  GO TO 50
              END IF
   40     CONTINUE
          RETURN
   50     CONTINUE
          IF (IL.EQ.1) THEN
              XMIN   = ALOG10(XX)
          ELSE
              XMIN   = ALOG(XX)
          END IF
          XMAX   = XMIN
          DO 60 J = I,N
              CALL TBSGET(TID,J,ISEL,STATUS)
              CALL TBERDR(TID,J,ICOL,XX,INULL,STATUS)
              IF (ISEL .AND. (.NOT.INULL) .AND. XX.GT.0.D0) THEN
                  IF (IL.EQ.1) THEN
                      XMIN   = MIN(XMIN,ALOG10(XX))
                      XMAX   = MAX(XMAX,ALOG10(XX))
                  ELSE
                      XMIN   = MIN(XMIN,ALOG(XX))
                      XMAX   = MAX(XMAX,ALOG(XX))
                  END IF
              END IF
   60     CONTINUE
      END IF
      RETURN
      END

      SUBROUTINE TDMXDS(TID,ICOL,N,IL,XMIN,XMAX)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.PURPOSE
C FIND MINIMUM/ MAXIMUM VALUES IN THE TABLE TID
C NULL AND NON SELECTED VALUES ARE NOT CONSIDERED.
C DOUBLE PRECISION VERSION.
C
C------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER TID            ! IN : table identifier
      INTEGER ICOL           ! IN : column index
      INTEGER N              ! IN : array length
      INTEGER IL             ! IN : logarithm flag
      DOUBLE PRECISION XMIN  ! OUT: minimum value
      DOUBLE PRECISION XMAX  ! OUT : maximum value
C
      INTEGER I, J, STATUS
      DOUBLE PRECISION XX
      LOGICAL ISEL, INULL
C
      XMIN   = 0.D0
      XMAX   = XMIN
      IF (IL.EQ.0) THEN
          DO 10 I = 1,N
              CALL TBSGET(TID,I,ISEL,STATUS)
              CALL TBERDD(TID,I,ICOL,XX,INULL,STATUS)
              IF (ISEL .AND. (.NOT.INULL)) THEN
                  XMIN   = XX
                  XMAX   = XX
                  GO TO 20
              END IF
   10     CONTINUE
          RETURN
   20     CONTINUE
          DO 30 J = I,N
              CALL TBSGET(TID,J,ISEL,STATUS)
              CALL TBERDD(TID,J,ICOL,XX,INULL,STATUS)
              IF (ISEL .AND. (.NOT.INULL)) THEN
                  XMIN   = MIN(XMIN,XX)
                  XMAX   = MAX(XMAX,XX)
              END IF
   30     CONTINUE
      ELSE
          DO 40 I = 1,N
              CALL TBSGET(TID,I,ISEL,STATUS)
              CALL TBERDD(TID,I,ICOL,XX,INULL,STATUS)
              IF (ISEL .AND. (.NOT.INULL) .AND. XX.GT.0.D0) THEN
                  XMIN   = XX
                  XMAX   = XX
                  GO TO 50
              END IF
   40     CONTINUE
          RETURN
   50     CONTINUE
          IF (IL.EQ.1) THEN
              XMIN   = DLOG10(XX)
          ELSE
              XMIN   = DLOG(XX)
          END IF
          XMAX   = XMIN
          DO 60 J = I,N
              CALL TBSGET(TID,J,ISEL,STATUS)
              CALL TBERDD(TID,J,ICOL,XX,INULL,STATUS)
              IF (ISEL .AND. (.NOT.INULL) .AND. XX.GT.0.D0) THEN
                  IF (IL.EQ.1) THEN
                      XMIN   = MIN(XMIN,DLOG10(XX))
                      XMAX   = MAX(XMAX,DLOG10(XX))
                  ELSE
                      XMIN   = MIN(XMIN,DLOG(XX))
                      XMAX   = MAX(XMAX,DLOG(XX))
                  END IF
              END IF
   60     CONTINUE
      END IF
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2006 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================

C ++++++++++++++++++++++++  TBD.FOR +++++++++++++++++++++++++++++++++++++++
C .LANGUAGE Fortran 77
C .IDENTIFICATION Module TBD.FOR
C  AUTHOR         K. Banse
C  Module contains layer between the table related FORTRAN TBxxxx interfaces
C  and the TC_interfaces written in (hopefully independent) C
C .KEYWORDS       standard interfaces.
C .ENVIRONMENT    FORTRAN and C standards
C .VERSION  [1.00] 871207:  created from SXFTOC.C
C 
C 060328	last modif
C 
C -----------------------------------------------------------------------------
C
      SUBROUTINE TBFGET(TID,COLUMN,FORM,LEN,DTYPE,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   FORM
      INTEGER     TID, COLUMN, LEN, DTYPE
      INTEGER     STATUS
C 
      CALL STLOC(1,1,FORM)                      !blanked CHAR_LOC
C 
      CALL TBF1(TID, COLUMN, LEN, DTYPE, STATUS)
C
      RETURN
      END
C 
      SUBROUTINE TBFPUT(TID,COLUMN,FORM,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   FORM
      INTEGER     TID, COLUMN
      INTEGER     STATUS
C
      CALL STSTR(1,FORM)                        !STRIPPED_STRING
C
      CALL TBF2(TID, COLUMN, STATUS)
C
      RETURN
      END
C 
C 
      SUBROUTINE TBLGET(TID, COL, LABEL, STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   LABEL
      INTEGER     TID, COL 
      INTEGER     STATUS
C
      CALL STLOC(1,1,LABEL)                      !blanked CHAR_LOC
C 
      CALL TBL1(TID, COL, STATUS)
C
      RETURN
      END

C
C
      SUBROUTINE TBLPUT(TID, COL, LABEL, STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   LABEL
      INTEGER     TID, COL
      INTEGER     STATUS
C
      CALL STSTR(1,LABEL)                        !STRIPPED_STRING
C
      CALL TBL2(TID, COL, STATUS)
C
      RETURN
      END
C 
C 
      SUBROUTINE TBLSER(TID, LABEL, COL,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   LABEL
      INTEGER     TID, COL
      INTEGER     STATUS
C
      CALL STSTR(1,LABEL)                        !STRIPPED_STRING
C 
      CALL TBL3(TID, COL, STATUS)
C
      RETURN
      END
C
C
      SUBROUTINE TBUGET(TID,COL,TUNIT,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   TUNIT
      INTEGER     TID, COL
      INTEGER     STATUS
C
      CALL STLOC(1,1,TUNIT)                      !blanked CHAR_LOC
C
      CALL TBU1(TID,COL,STATUS)
C
      RETURN
      END
C
C
      SUBROUTINE TBUPUT(TID,COL,TUNIT,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   TUNIT
      INTEGER     TID, COL
      INTEGER     STATUS
C
      CALL STSTR(1,TUNIT)                        !STRIPPED_STRING
C
      CALL TBU2(TID,COL,STATUS)
C
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2006 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================

C ++++++++++++++++++++++++  YSTF.FOR +++++++++++++++++++++++++++++++++++++++
C .LANGUAGE Fortran 77
C .IDENTIFICATION Module YSTF.FOR
C .COMMENTS
C Module contains layer between the keyword related FORTRAN STxxxx interfaces
C and the SC_interfaces written in (hopefully independent) C
C .AUTHOR         K. Banse        ESO - Garching
C .KEYWORDS       standard interfaces.
C .ENVIRONMENT    FORTRAN and C standards
C .VERSION  [1.00] 871207:  created from SXFTOC.C
C 
C 060324	last modif
C -----------------------------------------------------------------------------
C

      SUBROUTINE TBCINI(TID,DTYP,ALEN,FORM,TUNIT,LABEL,COL,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   FORM, TUNIT, LABEL
      INTEGER    TID, DTYP, ALEN, COL
      INTEGER    STATUS
C 
      CALL STSTR(1,FORM)                     !STRIPPED_STRING
      CALL STSTR(2,TUNIT)                    !STRIPPED_STRING
      CALL STSTR(3,LABEL)                    !STRIPPED_STRING
C 
      CALL TBC1(TID,DTYP,ALEN,COL,STATUS)
C
      RETURN
      END
C
C 
      SUBROUTINE TBCMAP(TID,COL,PNTR,STATUS)
C
      IMPLICIT NONE
C
      INTEGER    TID, COL
      INTEGER*8  PNTR
      INTEGER    STATUS
C 
      CALL TBC2(TID,COL,PNTR,STATUS)
C
      RETURN
      END
C
C
      SUBROUTINE TBCSEL(TID,TEXT,MAX_COLS,COLS,FLAGS,FOUND_COLS,STATUS)
C 
      IMPLICIT NONE
C
      CHARACTER*(*)   TEXT
      INTEGER     TID, MAX_COLS,COLS,FLAGS,FOUND_COLS
      INTEGER     STATUS
C
      CALL STSTR(1,TEXT)                     !STRIPPED_STRING
      CALL TBC3(TID,MAX_COLS,COLS,FLAGS,FOUND_COLS,STATUS)
C
      RETURN
      END
C 
C 
      SUBROUTINE TBCSER(TID,LABEL,COL,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   LABEL
      INTEGER     TID, COL
      INTEGER     STATUS
C
      CALL STSTR(1,LABEL)                     !STRIPPED_STRING
      CALL TBC4(TID,COL,STATUS)
C
      RETURN
      END

CC SUBROUTINE TBCDEL(TID,COL,NCOL,STATUS)
CC directly done in tbc.fc ...

CC SUBROUTINE ROUTINE TBCSRT(TID,NC,COL,SORTFL,STATUS)
CC directly done in tbc.fc ...

C===========================================================================
C Copyright (C) 1995-2008 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C 
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  22:26 - 3 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: D.PONZ
C
C
C.IDENTIFICATION
C
C  program  ECHMERG 
C
C.MODIFICATIONS
C
C  910128   P. Ballester   Define and set variables for mmake -i
C  991005   S.Wolf         ECHMR2O added: does an optimal merging.
C
C.KEYWORDS
C
C  ECHELLE, CASPEC, ORDER MERGING
C
C.PURPOSE
C
C  OBTAIN A 1D FRM CALIBRATED IN WAVELENGTHS FROM A 2D FRM
C  SAMPLED IN THE SPACE WAVELENGTH-ORDER.
C
C.ALGORITHM
C
C  OVERLAPPING REGIONS OF CONSECUTIVE ORDERS ARE PROCESSED IN TWO WAYS:
C  - CONCATENATION OF CONSECUTIVE ORDERS, USING THE MIDDLE POINT AS
C    CONCATENATING POSITION (METHOD='CONCATENATE', DEFAULT)
C  - AVERAGE OF OVERLAPPING REGION (METHOD='AVERAGE')
C  - WEIGHTED AVERAGE OF OVERLAPPING REGION (METHOD='OPTIMAL')
C    spmerged = (w1*sp1 + w2*sp2)/(w1+w2)
C  - NO MERGING. INDIVIDUAL ORDERS ARE WRITTEN IN DIFFERENT FILES
C    (METHOD = 'NOMERGE')
C  - WEIGHTED AVERAGE. WEIGHTS PROPORTIONAL TO SINC**2 (METHOD='SINC')
C  THE METHOD 'NOMERGE' WILL PRODUCE AS MANY FILES AS DEFINED ORDERS
C   WITH NAMES xxxyyyy, xxxx IS THE OUTPUT FILE NAME, yyyy IS THE 
C   ORDER NUMBER
C
C.INPUT/OUTPUT
C
C  MERGE/ECHELLE INPUT OUTPUT  [CONC]
C  MERGE/ECHELLE INPUT OUTPUT  ORD1,ORD2 NOCONCAT
C  MERGE/ECHELLE INPUT OUTPUT  DELTA     AVERAGE
C  MERGE/ECHELLE INPUT OUTPUT  DELTA     OPTIMAL WEIGHTS
C  or
C  MERGE/ECHELLE INPUT OUTPUT  TABLE SINC
C
C 081030	last modif
C 
C------------------------------------------------------------------------
C 
      PROGRAM ECHMRG
C 
      IMPLICIT  NONE
C
      INTEGER   MADRID
      INTEGER   I, II1, II2, IORD1
      INTEGER   IORD2
      INTEGER   ISTAT
      INTEGER   NAXISA, NAXISB, NAXISW
      INTEGER NPIXA(3),NPIXB(3),NPIXW(3),NPTOT(100),ICOL(3),KUN,KNUL
      INTEGER INIMA, OUTIMA, VARIMA, WGTIMA, TID
C 
      INTEGER*8 IPNTRA, IPNTRB, IPNTRV, IPNTRW              !pointers ...
C   
      DOUBLE PRECISION  DEL, WEND, WINIT, WSTEP
      DOUBLE PRECISION  WSTART(100)
      DOUBLE PRECISION  STARTA(3),STEPA(3)
      DOUBLE PRECISION  STARTB(3),STEPB(3)
      DOUBLE PRECISION  STARTW(3),STEPW(3)
C
      REAL CUT(4),XMIN,XMAX,WRANGE(2),VAL(3),K(100),A(100)
      REAL RO(100)
C
      CHARACTER*60 INFRM, OUTFRM, VARFRM, WGTFRM
      CHARACTER OUTFIL*12,TABLE*12
      CHARACTER METHOD*1,WS*5
      CHARACTER IDENTA*72,IDENTB*72,CUNITA*64,CUNITB*64
      CHARACTER IDENTW*72,CUNITW*64
      CHARACTER*16 LABEL(3)
C
      LOGICAL NULL(3)
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      DATA CUNITB/'FLUX            WAVELENGTH'/
      DATA LABEL(1)/'ORDER'/,LABEL(2)/'KFIT'/,LABEL(3)/'AFIT'/
C
C ... INITIALIZE SYSTEM
C
      CALL STSPRO('ECHMRG')
      INFRM = ' '
      OUTFRM = ' '
      VARFRM = ' '
      WGTFRM = ' '
      CALL STKRDC('P1',1,1,60,I,INFRM,KUN,KNUL,ISTAT)
      CALL STKRDC('P2',1,1,60,I,OUTFRM,KUN,KNUL,ISTAT)
      CALL STKRDC('P6',1,1,60,I,VARFRM,KUN,KNUL,ISTAT)
      CALL STKRDC('P5',1,1,60,I,WGTFRM,KUN,KNUL,ISTAT)
      CALL CLNFRA(INFRM,INFRM,0)
      CALL CLNFRA(OUTFRM,OUTFRM,0)
      CALL CLNFRA(VARFRM,VARFRM,0)
      CALL CLNFRA(WGTFRM,WGTFRM,0)
      CALL STKRDC('P4',1,1,1,I,METHOD,KUN,KNUL,ISTAT)
      CALL FORUPC(METHOD,METHOD)
      IF (METHOD.EQ.'S') 
     .    CALL STKRDC('P3',1,1,8,I,TABLE,KUN,KNUL,ISTAT)
      CALL STKRDR('INPUTR',1,2,I,WRANGE,KUN,KNUL,ISTAT)
      IF (METHOD.EQ.'A' .OR. METHOD.EQ.'O') THEN
          WINIT  = 0.
          WEND   = WINIT
          DEL    = WRANGE(1)
      ELSE
          WINIT  = WRANGE(1)
          WEND   = WRANGE(2)
      END IF
C
C ... MAP INPUT FRM
C
      CALL STIGET(INFRM,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     .            3,NAXISA,NPIXA,STARTA,STEPA,IDENTA,CUNITA,
     .            IPNTRA,INIMA,ISTAT)
      CALL STDRDD(INIMA,'WSTART',1,NPIXA(2),I,
     .            WSTART,KUN,KNUL,ISTAT)
      CALL STDRDI(INIMA,'NPTOT',1,NPIXA(2),I,NPTOT,
     .            KUN,KNUL,ISTAT)
C ... CHECK IF NPTOT(NPIXA(2)) IS 0 
      IF (NPTOT(NPIXA(2)).EQ.0) THEN  
          NPIXA(2) = NPIXA(2) - 1
      END IF
      WSTEP  = STEPA(1)
C
C ... MAP WEIGHT FRM
C
      IF (METHOD.EQ.'O') THEN
         CALL STIGET(WGTFRM,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     .        3,NAXISW,NPIXW,STARTW,STEPW,IDENTW,CUNITW,
     .        IPNTRW,WGTIMA,ISTAT)
         IF (NAXISW.NE.NAXISA.OR.
     .        STARTW(1).NE.STARTA(1).OR.STARTW(2).NE.STARTA(2).OR.
     .        STEPW(1).NE.STEPA(1).OR.STEPW(1).NE.STEPA(1)) THEN
            GOTO 9998
         END IF
      END IF
      IF (METHOD.EQ.'N') THEN
C
C ... NO MERGE - PRODUCE ONE FILE PER ORDER
C
          IF (WINIT.EQ.WEND .AND. WINIT.LT.0.5) THEN
              IORD1  = 1
              IORD2  = NPIXA(2)
          ELSE
              IORD1  = MAX(NINT(WINIT),1)
              IORD2  = MIN(NINT(WEND),NPIXA(2))
          END IF
          OUTFRM = OUTFRM(1:59)//' '
          II1    = INDEX(OUTFRM,' ') - 1
          II1    = MIN(II1,4)
          OUTFIL = OUTFRM(1:II1)
          DO 10 I = IORD1,IORD2
              II2    = 10000 + I
              WRITE (WS,9000) II2
              OUTFIL(II1+1:II1+4) = WS(2:5)
              NAXISB    = 1
              NPIXB(1)  = NPTOT(I)
              NPIXB(2)  = 1
              STARTB(1) = WSTART(I)
              STARTB(2) = 1.
              STEPB(1)  = WSTEP
              STEPB(2)  = 0.
              WRITE (IDENTB,9010) I
              IDENTB(11:72) = IDENTA(1:62)
              CALL STIPUT(OUTFIL,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .                    NAXISB,NPIXB,STARTB,STEPB,
     .                     IDENTB,CUNITB,IPNTRB,OUTIMA,ISTAT)
              CALL COPY(MADRID(IPNTRA),NPIXA(1),NPIXA(2),MADRID(IPNTRB),
     .                  NPIXB(1),I,XMIN,XMAX)
              CUT(1) = XMIN
              CUT(2) = XMAX
              CUT(3) = XMIN
              CUT(4) = XMAX
              CALL DSCUPT(INIMA,OUTIMA,' ',ISTAT)
              CALL STDWRR(OUTIMA,'LHCUTS',CUT,1,4,KUN,ISTAT)
              CALL STFCLO(OUTIMA,ISTAT)
              CALL STTPUT('File '//OUTFIL//' created ...',ISTAT)
   10     CONTINUE

      ELSE
C
C ... MAP OUTPUT FRAME
C
          IF (WINIT.EQ.WEND) THEN
              WINIT  = WSTART(1)
              WEND   = WSTART(NPIXA(2)) + (NPTOT(NPIXA(2))-1)*WSTEP
          END IF
          NAXISB    = 1
          NPIXB(1)  = (WEND-WINIT)/WSTEP + 1
          NPIXB(2)  = 1
          STARTB(1) = WINIT
          STARTB(2) = 1.
          STEPB(1)  = WSTEP
          STEPB(2)  = 0.
          CALL STIPUT(OUTFRM,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .                    NAXISB,NPIXB,STARTB,STEPB,
     .                    IDENTA,CUNITB,IPNTRB,OUTIMA,ISTAT)
C
C ... METHODS OF OVERLAPPING
C
          IF (METHOD.EQ.'C') CALL ECHMR1(MADRID(IPNTRA),
     +                            NPIXA(1),NPIXA(2),
     +                            STEPA,WSTART,NPTOT,MADRID(IPNTRB),
     +                            NPIXB,STARTB,XMIN,XMAX)
          IF (METHOD.EQ.'A') CALL ECHMR2(MADRID(IPNTRA),
     +                            NPIXA(1),NPIXA(2),
     +                            STEPA,WSTART,NPTOT,MADRID(IPNTRB),
     +                            NPIXB,STARTB,XMIN,XMAX,DEL)
          IF (METHOD.EQ.'O') THEN
             CALL STIPUT(VARFRM,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .            NAXISB,NPIXB,STARTB,STEPB,
     .            IDENTA,CUNITB,IPNTRV,VARIMA,ISTAT)
             CALL ECHMR2O(MADRID(IPNTRA),MADRID(IPNTRW),
     +            NPIXA(1),NPIXA(2),
     +            STEPA,WSTART,NPTOT,MADRID(IPNTRB),MADRID(IPNTRV),
     +            NPIXB,STARTB,XMIN,XMAX,DEL)
             CALL DSCUPT(INIMA,VARIMA,' ',ISTAT)
             
          ENDIF
          IF (METHOD.EQ.'S') THEN
C
C ... READ RIPPLE TABLE
C
              CALL TBTOPN(TABLE,F_IO_MODE,TID,ISTAT)
              CALL TBLSER(TID,LABEL(1),ICOL(1),ISTAT)
              CALL TBLSER(TID,LABEL(2),ICOL(2),ISTAT)
              CALL TBLSER(TID,LABEL(3),ICOL(3),ISTAT)
              DO 20 I = 1,NPIXA(2)
                  CALL TBRRDR(TID,I,3,ICOL,VAL,NULL,ISTAT)
                  RO(I)  = VAL(1)
                  K(I)   = VAL(2)
                  A(I)   = VAL(3)
   20         CONTINUE
              CALL ECHMR3(MADRID(IPNTRA),
     +                      NPIXA(1),NPIXA(2),STEPA,WSTART,
     +                      NPTOT,MADRID(IPNTRB),NPIXB,STARTB,XMIN,XMAX,
     +                      RO,K,A)
          END IF
C
C ... WRITE PROCESS DESCRIPTORS
C
          CUT(1) = XMIN
          CUT(2) = XMAX
          CUT(3) = XMIN
          CUT(4) = XMAX
          CALL DSCUPT(INIMA,OUTIMA,' ',ISTAT)
          CALL STDWRR(OUTIMA,'LHCUTS',CUT,1,4,KUN,ISTAT)
      END IF
      GOTO 9999
 9998 CALL STTPUT('Error: Bad weight map! ',ISTAT)
      CALL STTPUT
     + ('(START, STEP and NAXIS same as in INPUT frame !?)',ISTAT)
 9999 CALL STSEPI
 9000 FORMAT (I5)
 9010 FORMAT ('ORDER:',I3)
      END

      SUBROUTINE ECHMR1(X,NPIXA1,NPIXA2,STEPA,WI,NP,Y,NY,YSTR,
     +                  XMIN,XMAX)
C
C MERGE THE ORDERS, USING SIMPLE CONCATENATION IN THE MIDDLE POINT
      IMPLICIT NONE
C
      INTEGER  NY,J2,I,J1,JOFF,J,JJ
      INTEGER  NPIXA1,NPIXA2
      INTEGER  NP(NPIXA2)
C 
      DOUBLE PRECISION STEPA(2),WI(NPIXA2),YSTR
C 
      REAL     X(NPIXA1,NPIXA2)
      REAL     XMIN,XMAX,RVAL,WEN1,WST2,WSTART
      REAL     Y(NY)
C 
      DOUBLE PRECISION WEND, YSTEP, YEND, WSTR
C
      XMIN   = 0.
      XMAX   = 0.
      DO 10 I = 1,NY
          Y(I)   = 0.
   10 CONTINUE
      YSTEP  = STEPA(1)
      YEND   = YSTR + (NY-1)*YSTEP
C
C ... ITERATION ON ORDERS
C
      WEND   = 0.
      DO 30 I = 1,NPIXA2
          WSTR   = DMAX1(WI(I),WEND+YSTEP)
          IF (I.EQ.NPIXA2) THEN
              WEND   = WI(I) + (NP(I)-1)*YSTEP
          ELSE
              WEN1   = WI(I) + (NP(I)-1)*YSTEP
              WST2   = WI(I+1)
              IF (WST2.LT.WEN1) THEN
                  WEND   = 0.5* (WEN1+WST2)
              ELSE
                  WEND   = WEN1
              END IF
          END IF

          IF (WSTR.GE.YEND) RETURN
          IF (WEND.GT.YSTR) THEN
C
C ... ITERATION ON WAVELENGTHS
C
              WSTART = DMAX1(YSTR,WSTR)
              WEND   = DMIN1(WEND,YEND)
              J1     = NINT((WSTART-WI(I))/YSTEP) + 1
              J2     = NINT((WEND-WI(I))/YSTEP) + 1
              JOFF   = NINT((WI(I)-YSTR)/YSTEP)
              DO 20 J = J1,J2
                  JJ     = J + JOFF
                  IF (JJ.GT.0) THEN
                      RVAL = X(J,I)
                      IF (RVAL .GT. XMAX) XMAX = RVAL
                      IF (RVAL .LT. XMIN) XMIN = RVAL
                      Y(JJ) = RVAL
                  END IF

   20         CONTINUE
          END IF

   30 CONTINUE
      RETURN

      END

      SUBROUTINE ECHMR2(X,NPIXA1,NPIXA2,STEPA,WI,NP,Y,NY,YSTR,
     +                  XMIN,XMAX,DEL)
C
C MERGE THE ORDERS, AVERAGE ON THE OVERLAPPING REGION
C
      IMPLICIT NONE
C
      INTEGER NPIXA1, NPIXA2, NY
      INTEGER NP(NPIXA2)
      INTEGER IORD1, IORD2, IPIX, IPIX1, IPIX2
C 
      REAL X(NPIXA1,NPIXA2)
      REAL Y(NY),XMIN,XMAX,RVAL
C 
      DOUBLE PRECISION STEPA(2),YSTR,DEL,WI(NPIXA2)
      DOUBLE PRECISION YSTEP, W0, W1, WL, P1, P2
C
C
      XMIN   = 0.
      XMAX   = 0.
      YSTEP  = STEPA(1)
      IORD1  = 1
      IORD2  = 2
      W0     = WI(IORD2) + DEL
      W1     = WI(IORD1) + (NP(IORD1)-1)*YSTEP - DEL
C
C ... ITERATION ON ORDERS
C
      DO 20 IPIX = 1,NY
          Y(IPIX) = 0.0
          WL     = YSTR + (IPIX-1)*YSTEP
          IF (WL.LT.W0) THEN
              IPIX1  = NINT((WL-WI(IORD1))/YSTEP) + 1
              RVAL = X(IPIX1,IORD1)
              IF (RVAL .GT. XMAX) XMAX = RVAL
              IF (RVAL .LT. XMIN) XMIN = RVAL
              Y(IPIX) = RVAL
          ELSE IF (WL.LT.W1) THEN
              IPIX1  = NINT((WL-WI(IORD1))/YSTEP) + 1
              IPIX2  = NINT((WL-WI(IORD2))/YSTEP) + 1
              P2     = (WL-W0)/ (W1-W0)
              P1     = 1.D0 - P2
              IF (X(IPIX1,IORD1).LE.0.0) THEN
                  P2     = 1.D0
                  P1     = 0.D0
              END IF
              IF (X(IPIX2,IORD2).LE.0.0) THEN
                  P2     = 0.D0
                  P1     = 1.D0
              END IF
              RVAL = X(IPIX1,IORD1)*P1 + X(IPIX2,IORD2)*P2
              IF (RVAL .GT. XMAX) XMAX = RVAL
              IF (RVAL .LT. XMIN) XMIN = RVAL
              Y(IPIX) = RVAL
          ELSE
              IORD1  = IORD1 + 1
              IF (IORD1.GT.NPIXA2) RETURN
              IORD2  = IORD2 + 1
              IF (IORD2.GT.NPIXA2) THEN
                  W0     = 1.E20
              ELSE
                  W0     = WI(IORD2) + DEL
              END IF
              W1     = WI(IORD1) + (NP(IORD1)-1)*YSTEP - DEL
              IPIX1  = NINT((WL-WI(IORD1))/YSTEP) + 1
              RVAL = X(IPIX1,IORD1)
              IF (RVAL .GT. XMAX) XMAX = RVAL
              IF (RVAL .LT. XMIN) XMIN = RVAL
              Y(IPIX) = RVAL
          END IF
   20 CONTINUE
      RETURN
      END

      SUBROUTINE ECHMR2O(X,WGT,NPIXA1,NPIXA2,STEPA,WI,NP,Y,VAR,NY
     $     ,YSTR,XMIN,XMAX,DEL)
C
C MERGE THE ORDERS, AVERAGE ON THE OVERLAPPING REGION USING WEIGHTS
C
      IMPLICIT NONE
C
      INTEGER NPIXA1, NPIXA2, NY
      INTEGER NP(NPIXA2)
      REAL X(NPIXA1,NPIXA2), WGT(NPIXA1,NPIXA2)
      DOUBLE PRECISION STEPA(2),YSTR,DEL,WI(NPIXA2)
      REAL Y(NY), VAR(NY),XMIN,XMAX,RVAL
C
      INTEGER IORD1, IORD2, IPIX, IPIX1, IPIX2, IBAD
      DOUBLE PRECISION YSTEP, WG1, WG2, W0, W1, WL
      CHARACTER*80 MES
C
      IBAD   = 0
      XMIN   = 0.
      XMAX   = 0.
      YSTEP  = STEPA(1)
      IORD1  = 1
      IORD2  = 2
      W0     = WI(IORD2) + DEL
      W1     = WI(IORD1) + (NP(IORD1)-1)*YSTEP - DEL
C
C ... ITERATION ON ORDERS
C
      DO 20 IPIX = 1,NY
          Y(IPIX) = 0.0
          VAR(IPIX) = 0.0
          WL     = YSTR + (IPIX-1)*YSTEP
          IF (WL.LT.W0) THEN
              IPIX1  = NINT((WL-WI(IORD1))/YSTEP) + 1
              RVAL = X(IPIX1,IORD1)
              IF (RVAL .GT. XMAX) XMAX = RVAL
              IF (RVAL .LT. XMIN) XMIN = RVAL
              Y(IPIX) = RVAL
              VAR(IPIX) = WGT(IPIX1,IORD1)
              IF (VAR(IPIX).NE.0.0) VAR(IPIX) = 1.0/VAR(IPIX)
          ELSE IF (WL.LT.W1) THEN
              IPIX1  = NINT((WL-WI(IORD1))/YSTEP) + 1
              IPIX2  = NINT((WL-WI(IORD2))/YSTEP) + 1
              WG1 = WGT(IPIX1,IORD1)
              WG2 = WGT(IPIX2,IORD2)

              IF (WG1.LT.1e-10 .AND. WG2.LT.1e-10) THEN
                 Y(IPIX) = 0.0
                 VAR(IPIX) = 0.0
                 IBAD = IBAD + 1
              ELSE
                 VAR(IPIX) = 1.0/(WG1 + WG2)
                 Y(IPIX) = X(IPIX1,IORD1)*WG1 + X(IPIX2,IORD2)*WG2
                 RVAL = Y(IPIX) * VAR(IPIX)
                 IF (RVAL .GT. XMAX) XMAX = RVAL
                 IF (RVAL .LT. XMIN) XMIN = RVAL
                 Y(IPIX) = RVAL
              ENDIF
          ELSE
              IORD1  = IORD1 + 1
              IF (IORD1.GT.NPIXA2) GOTO 99
              IORD2  = IORD2 + 1
              IF (IORD2.GT.NPIXA2) THEN
                  W0 = 1.E20
              ELSE
                  W0 = WI(IORD2) + DEL
              END IF
              W1 = WI(IORD1) + (NP(IORD1)-1)*YSTEP - DEL
              IPIX1  = NINT((WL-WI(IORD1))/YSTEP) + 1
              RVAL = X(IPIX1,IORD1)
              IF (RVAL .GT. XMAX) XMAX = RVAL
              IF (RVAL .LT. XMIN) XMIN = RVAL
              Y(IPIX) = RVAL
              VAR(IPIX) = WGT(IPIX1,IORD1)
              IF (VAR(IPIX).NE.0.0) VAR(IPIX) = 1.0/VAR(IPIX)
          END IF
 20   CONTINUE
 99   IF (IBAD.GT.0) THEN
         WRITE(MES,9099) IBAD
         CALL STTPUT(MES,IBAD)
      END IF      
      RETURN

9099  FORMAT(I5,' undefined pixels ... set to 0.0!')
         
      END

      SUBROUTINE COPY(A,NA1,NA2,B,NB,I,XMIN,XMAX)
C
C COPY THE ORDER NUMBER I
C
      IMPLICIT NONE
C 
      INTEGER NA1, NA2, NB, I, J
C 
      REAL A(NA1,NA2),B(NB)
      REAL XMIN,XMAX,RVAL
C
      XMIN = 0.
      XMAX = 0.
C
      DO 10 J = 1,NB
          B(J)   = A(J,I)
          RVAL = B(J)
          IF (RVAL .GT. XMAX) XMAX = RVAL
          IF (RVAL .LT. XMIN) XMIN = RVAL
   10 CONTINUE
      RETURN
      END

      SUBROUTINE ECHMR3(X,NPIXA1,NPIXA2,STEPA,WI,NP,Y,NY,YSTR,
     +                    XMIN,XMAX,RORDER,K,A)
C
C      IMPLICIT NONE
C MERGE THE ORDERS, AVERAGE ON THE OVERLAPPING REGION WITH
C WEIGHTS PROPORTIONAL TO THE SINC**2
C
      IMPLICIT NONE
C 
      INTEGER NY,IORD1,IPIX,NF,IORD,IPIX1,I,IFL,IORD2
      INTEGER NPIXA1,NPIXA2
      INTEGER NP(NPIXA2)
C 
      REAL    XMIN,XMAX,YSTEP,PI,DW,WL
      REAL    X(NPIXA1,NPIXA2)
      REAL    Y(NY),RORDER(NPIXA2)
      REAL    K(NPIXA2),A(NPIXA2)
C 
      DOUBLE PRECISION DK,DA,PA,DM,DC,DX,WEIGHT(3),FLUX(3),SW,SF
      DOUBLE PRECISION YSTR,STEPA(2),WI(NPIXA2)
C
      XMIN   = 0.
      XMAX   = 0.
      PI     = 0.     !  To be updated (ULTRIX installation)
      DW     = 0.     !  To be updated (ULTRIX installation)
      YSTEP  = STEPA(1)
      IORD1  = 1
      IORD2  = MIN(IORD1+2,NPIXA2)
C
C ... ITERATION ON OUTPUT WAVELENGTHS
C
      DO 30 IPIX = 1,NY
          Y(IPIX) = 0.
          FLUX(1) = 0.D0
          FLUX(2) = 0.D0
          FLUX(3) = 0.D0
          WEIGHT(1) = 0.D0
          WEIGHT(2) = 0.D0
          WEIGHT(3) = 0.D0
          NF     = 0
          WL     = YSTR + (IPIX-1)*YSTEP
C
C ... ITERATION ON ORDERS
C
          DO 10 IORD = IORD1,IORD2
              IPIX1  = (WL-WI(IORD))/YSTEP + 1
              IF (IPIX1.GT.5 .AND. IPIX1.LT. (NP(IORD)-5)) THEN
C
C ... PIXEL IN THE ORDER RANGE
C
                  NF     = NF + 1
                  FLUX(NF) = X(IPIX1,IORD)
                  DK     = K(IORD)
                  DA     = A(IORD)
                  PA     = PI*DA
                  DM     = RORDER(IORD)
                  DC     = DM/DK
                  DX     = (PA*DM*DC)* (DW-1.D0/DC)
                  IF (DABS(DX).LT.1.D-10) THEN
                      WEIGHT(NF) = 1.D0

                  ELSE
                      WEIGHT(NF) = 1.D0/ (DSIN(DX)/DX)**4
                  END IF

              END IF

   10     CONTINUE
C
C ... AVERAGE OVER FLUXES
C
          IF (NF.GE.1) THEN
              SW     = 0.D0
              SF     = 0.D0
              DO 20 IFL = 1,NF
                  SW     = SW + WEIGHT(IFL)
                  SF     = SF + WEIGHT(IFL)*FLUX(IFL)
   20         CONTINUE
              Y(IPIX) = SF/SW
              XMIN   = MIN(XMIN,Y(IPIX))
              XMAX   = MAX(XMAX,Y(IPIX))
          END IF
C
C ... CHECK ON ORDER LIMITS
C
          IPIX1  = (WL-WI(IORD1))/YSTEP + 1
          IF (IPIX1.GE.NP(IORD1)-5) THEN
              IORD1  = IORD1 + 1
              IORD2  = MIN(IORD1+2,NPIXA2)
          END IF

          IF (IORD1.GT.NPIXA2) RETURN
   30 CONTINUE
      DO 40 I = IPIX + 1,NY
          Y(I)   = 0.
   40 CONTINUE
      RETURN

      END

C===========================================================================
C Copyright (C) 1995,2003 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM FLIP
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  program FLIP			version 1.00	881028
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  bulk data frame, flipping
C
C.PURPOSE
C  flip an image in x and/or y dimension
C
C.ALGORITHM
C  straight forward, data is changed in place
C
C.INPUT/OUTPUT
C  the following keywords are used:
C
C  IN_A/C/1/60				name of input frame
C  ACTION/C/1/2				action
C					= 'X ', flip in x
C					  'Y ', flip in y
C					  'XY', flip in x and y
C					  'SH', shift the image
C					  'SC', scale the image
C					  'T ', apply thinning algorithm
C					  'C ', for correlation
C
C  if ACTION = SH, then
C  OUT_A/C/1/60				name of result fram
C  INPUTI/I/1/2				xshift,yshift in [1,NPIX-1]
C
C  if ACTION = SC, then
C  OUT_A/C/1/60				name of result fram
C  INPUTI/I/1/2				x, y scaling values,
C					> 1  - enlarge image by replication
C					< -1 - decrease image size 
C					by averaging or omission
C  ACTION(3:3)				A or N for averaging or omission
C  if ACTION = T, then
C  OUT_A/C/1/60				name of result fram
C
C  if ACTION = C, then
C  IN_A/C/1/60			      	template spectrum
C  IN_B/C/1/1/60			spectrum
C  OUT_A/C/1/60				correlation table
C  INPUTI/I/1/1				max shift in pixels
C  ACTION(2:2)				Y or N for normalizing the pixels
C					of the output frame
C
C.VERSIONS
C 030731		last modif
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      IAV,NAXIS,STAT,KFLAG,FORMA,IOMOD
      INTEGER*8    PNTR,PNTRB,PNTRC,WPNTR
      INTEGER      NPIX(2),IMNO,NPIXC(2),IMNOC,SCALE(3)
      INTEGER      NAXISB,NPIXB(2),IMNOB,ISHI
      INTEGER      SIZE,XSHIFT,YSHIFT
      INTEGER      UNI(1),NULO,MADRID(1)
C
      DOUBLE PRECISION START(2),STEP(2),STARTB(2),STEPB(2)
      DOUBLE PRECISION END(2),DIFSTP,EPS
C
      REAL         CUTS(2),MINVAL,MAXVAL,LHCUTS(4)
C
      CHARACTER    CUNIT*48,IDENT*72
      CHARACTER    FRAME*84,FRAMEB*84,FRAMEC*84,ACTION*4
C
      COMMON   /VMR/  MADRID
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      DATA    CUTS   /0.,0./
      DATA    FRAME  /' '/, FRAMEB /' '/, FRAMEC /' '/
      DATA    IDENT  /' '/,  CUNIT  /' '/
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C  get into MIDAS
      CALL STSPRO('FLIP')
C
C  get name of input image + action flags
      CALL STKRDC('IN_A',1,1,80,IAV,FRAME,UNI,NULO,STAT)
      CALL STKRDC('ACTION',1,1,3,IAV,ACTION,UNI,NULO,STAT)
      CALL UPCAS(ACTION,ACTION)
C
C  setup action flag
      IF ((ACTION(1:1).EQ.'X') .OR. (ACTION(1:1).EQ.'Y')) THEN 
         KFLAG = 1
         FORMA = D_R4_FORMAT
         IOMOD = F_IO_MODE
      ELSE IF (ACTION(1:2).EQ.'SH') THEN
         KFLAG = 2
         FORMA = D_R4_FORMAT
         IOMOD = F_I_MODE
      ELSE IF (ACTION(1:2).EQ.'SC') THEN
         KFLAG = 3
         FORMA = D_R4_FORMAT
         IOMOD = F_I_MODE
      ELSE IF (ACTION(1:1).EQ.'T') THEN
         KFLAG = 4
         FORMA = D_I4_FORMAT
         IOMOD = F_I_MODE
      ELSE IF (ACTION(1:1).EQ.'C') THEN
         KFLAG = 5
         FORMA = D_R4_FORMAT
         IOMOD = F_I_MODE
      ELSE
         CALL STETER(77,'Invalid action ...')
      ENDIF
C 
C  map input frame 
      CALL STIGET(FRAME,FORMA,IOMOD,F_IMA_TYPE,
     +            2,NAXIS,NPIX,START,STEP,IDENT,
     +            CUNIT,PNTR,IMNO,STAT)
      CALL STDRDR(IMNO,'LHCUTS',1,4,IAV,LHCUTS,UNI,NULO,STAT) 
C
C  --------------------------
C  branch according to action
C  --------------------------
C
      IF (KFLAG.EQ.1) THEN                                    !flipping ...
         CALL STFXMP(NPIX(1),D_R4_FORMAT,WPNTR,STAT)
         CALL FLIPPI(MADRID(PNTR),MADRID(WPNTR),NPIX,ACTION)
C 
C  update START + STEP descriptors accordingly
         IF (ACTION(1:1).EQ.'Y') THEN
            END(2) = START(2) + (NPIX(2)-1)*STEP(2)
            START(2) = END(2)
            STEP(2) = -STEP(2)
         ELSE IF (ACTION(2:2).EQ.'Y') THEN
            END(1) = START(1) + (NPIX(1)-1)*STEP(1)
            END(2) = START(2) + (NPIX(2)-1)*STEP(2)
            START(1) = END(1)
            START(2) = END(2)
            STEP(1) = -STEP(1)
            STEP(2) = -STEP(2)
         ELSE
            END(1) = START(1) + (NPIX(1)-1)*STEP(1)
            START(1) = END(1)
            STEP(1) = -STEP(1)
         ENDIF
         CALL STDWRD(IMNO,'START',START,1,2,UNI,STAT) 
         CALL STDWRD(IMNO,'STEP',STEP,1,2,UNI,STAT) 
         IMNOC = IMNO                                    !needed for DSCUPT ...
         GOTO 9000
      ENDIF
C
C  for shifting, thinning, scaling and correlation get output frame
C
      CALL STKRDC('OUT_A',1,1,80,IAV,FRAMEC,UNI,NULO,STAT)
C
C
      IF (KFLAG.EQ.2) THEN                                    !shifting ...
         CALL STKRDI('INPUTI',1,2,IAV,NPIXC,UNI,NULO,STAT)
         XSHIFT = NPIXC(1)
         YSHIFT = NPIXC(2)
500      IF (XSHIFT.GT.NPIX(1)) THEN
            XSHIFT = XSHIFT - NPIX(1)
            GOTO 500
         ELSE IF (XSHIFT.LT.0) THEN
            XSHIFT = NPIX(1) + XSHIFT            !remember, XSHIFT is < 0
            GOTO 500
         ENDIF
600      IF (YSHIFT.GT.NPIX(2)) THEN
            YSHIFT = YSHIFT - NPIX(2)
            GOTO 600
         ELSE IF (YSHIFT.LT.0) THEN
            YSHIFT = NPIX(2) + YSHIFT            !remember, XSHIFT is < 0
            GOTO 600
         ENDIF
         IF ((XSHIFT.EQ.0).AND.(YSHIFT.EQ.0)) GOTO 9000
         CALL STIPUT(FRAMEC,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +               NAXIS,NPIX,START,STEP,IDENT,
     +               CUNIT,PNTRC,IMNOC,STAT)
C 
C
C  if shift in both directions, get virtual memory for working buffer
         IF ((XSHIFT.NE.0).AND.(YSHIFT.NE.0)) THEN
            SIZE = NPIX(1) * NPIX(2)
            CALL STFXMP(SIZE,D_R4_FORMAT,WPNTR,STAT)
         ELSE
            WPNTR = PNTR
         ENDIF
C 
         CALL SHIFTI(MADRID(PNTR),MADRID(WPNTR),MADRID(PNTRC),
     +               NPIX,XSHIFT,YSHIFT)
         CALL STDWRR(IMNOC,'LHCUTS',LHCUTS,1,4,UNI,STAT) 
C 
      ELSE IF (KFLAG.EQ.3) THEN                               !scaling ...
         CALL STKRDI('INPUTI',1,2,IAV,SCALE,UNI,NULO,STAT)
         IF ((SCALE(1).GE.-1).AND.(SCALE(1).LE.1)) SCALE(1) = 1
         IF ((SCALE(2).GE.-1).AND.(SCALE(2).LE.1)) SCALE(2) = 1
         IF (ACTION(3:3).EQ.'A') THEN
            SCALE(3) = 1
         ELSE
            SCALE(3) = 0
         ENDIF
C
C  calculate new nopix
         IF (SCALE(1).GT.1)  THEN
            NPIXC(1) = NPIX(1) * SCALE(1)
         ELSE IF (SCALE(1).LT.1) THEN
            NPIXC(1) = ( (NPIX(1)-1) / (-SCALE(1)) ) + 1
         ELSE
            NPIXC(1) = NPIX(1)
         ENDIF
C 
         IF (SCALE(2).GT.1)  THEN
            NPIXC(2) = NPIX(2) * SCALE(2)
            IF (NAXIS.EQ.1) THEN
               NAXIS = 2
               START(2) = START(1)
               STEP(2) = STEP(1)
               CUNIT(33:) = 'as in x-dim '
            ENDIF
         ELSE IF (SCALE(2).LT.1) THEN
            NPIXC(2) = ( (NPIX(2)-1) / (-SCALE(2)) ) + 1
         ELSE
            NPIXC(2) = NPIX(2)
         ENDIF
      write(*,123) naxis,npixc(1),npixc(2)
123   format('naxis now: ',i3,' npix = ',I5,i5)
         CALL STIPUT(FRAMEC,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +               NAXIS,NPIXC,START,STEP,IDENT,
     +               CUNIT,PNTRC,IMNOC,STAT)
         CALL SCALI(SCALE,MADRID(PNTR),NPIX,MADRID(PNTRC))
         CALL STDWRR(IMNOC,'LHCUTS',LHCUTS,1,4,UNI,STAT)
C
      ELSE IF (KFLAG.EQ.4) THEN                               !thinning ...
         CALL STIPUT(FRAMEC,D_I4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +               NAXIS,NPIX,START,STEP,IDENT,
     +               CUNIT,PNTRC,IMNOC,STAT)
C
C  first copy data
         SIZE = NPIX(1) * NPIX(2)
C        CALL COPYI(MADRID(PNTR),MADRID(PNTRC),SIZE)
C
C  get virtual memory for working buffer
         CALL STFXMP(SIZE,D_I4_FORMAT,WPNTR,STAT)
C
C  and do it
         CALL THINNI(MADRID(PNTRC),NPIX,MADRID(WPNTR))
C
      ELSE                                                   !correlation ...
         CALL STKRDC('IN_B',1,1,80,IAV,FRAMEB,UNI,NULO,STAT) !get spectrum
         CALL STKRDI('INPUTI',1,1,IAV,ISHI,UNI,NULO,STAT)    !get max. shift
C
         CALL STIGET(FRAMEB,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE, !map spectrum
     +               2,NAXISB,NPIXB,STARTB,STEPB,IDENT,
     +               CUNIT,PNTRB,IMNOB,STAT)
         EPS = 0.001 * ABS(STEPB(1))                         ! 0.1 % of x-step
         DIFSTP = ABS(STEP(1)) - ABS(STEPB(1))
         IF (DIFSTP.GT.EPS)
     +      CALL STETER(1,
     +      'x-step of template and spec frame not equal...')
C
C  how many points will we have in overlap region?
         SIZE = NPIX(1) - ISHI - ISHI
         IF (SIZE.LT.3) THEN
            CALL STTPUT(' Too little overlap ',STAT)
            CALL STETER
     +      (2,'Shift too large or template frame too small...')
         ENDIF
C
         NAXIS = 1
         NPIXC(1) = 2*ISHI + 1
         START(1) = -(ISHI * STEPB(1))
         CALL STIPUT(FRAMEC,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +               NAXIS,NPIXC,START,STEPB,IDENT,
     +               CUNIT,PNTRC,IMNOC,STAT)
C
C  and do it
         IF ((ACTION(2:2).EQ.'Y') .OR. (ACTION(2:2).EQ.'y')) THEN
            CALL CTCORR(NPIX(1),MADRID(PNTR),NPIXB(1),MADRID(PNTRB),
     +                  MADRID(PNTRC),ISHI,MINVAL,MAXVAL)
         ELSE
            CALL XSCORR(NPIX(1),MADRID(PNTR),NPIXB(1),MADRID(PNTRB),
     +                  MADRID(PNTRC),ISHI,MINVAL,MAXVAL)
         ENDIF
         LHCUTS(1) = MINVAL
         LHCUTS(2) = MAXVAL
         LHCUTS(3) = MINVAL
         LHCUTS(4) = MAXVAL
         CALL STDWRR(IMNOC,'LHCUTS',LHCUTS,1,4,UNI,STAT) 
         
      ENDIF
C
C  that's it folks...
9000  CALL DSCUPT(IMNO,IMNOC,' ',STAT)         !copy all other descriptors
      CALL STSEPI
      END

      SUBROUTINE FLIPPI(A,R,NPIX,ACTION)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subrotine FLIPPI		version 1.0	870605
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  bulk data frame, flipping
C
C.PURPOSE
C  flip an image or mask in x and/or y dimension
C
C.ALGORITHM
C  straight forward, data is changed in place
C
C.INPUT/OUTPUT
C  call as FLIPPI(A,R,NPIX,ACTION)
C
C  A:		R*4 array		input image buffer
C  R:		R*4 array		buffer for single line
C  NPIX:	I*4 array		dimensions of A
C  ACTION:	char.exp		flip action
C					= 'X ', flip in x
C					  'Y ', flip in y
C					  'XY', flip in x and y
C
C.VERSIONS
C  1.00		from old FLIPPY
C	
C--------------------------------------------------
C
C	
      IMPLICIT NONE
C
      INTEGER     NPIX(2)
      INTEGER     FROM,GAP,GAPP,INDX,NTMP
      INTEGER     NX,NY,TO,XDIM,XMID,YDIM,YMID
C
      REAL        A(*),R(*)
      REAL        SAVE
C
      CHARACTER*(*)    ACTION
C
C  init
      XDIM = NPIX(1)
      YDIM = NPIX(2)
      XMID = XDIM/2
      YMID = YDIM/2
C
C  branch according to action
      IF (ACTION(1:1).EQ.'Y') GOTO 1000
      IF (ACTION(1:2).EQ.'XY') GOTO 2000
C
C  ACTION = 'X ', flip only in x
C
      FROM = 0                              !offset to first element in a row
      DO 500 NY=1,YDIM
         TO = FROM + XDIM + 1                        !point to last + 1
C
         DO 300 NX=1,XMID                            !loop till middle of row
            SAVE = A(NX+FROM)                        !flip...
            A(NX+FROM) = A(TO-NX)
            A(TO-NX) = SAVE
300      CONTINUE
         FROM = FROM + XDIM
500   CONTINUE
      RETURN
C
C  ACTION = 'Y ', flip only in y
C
1000  FROM = 0                             !offset to first element in a row
      DO 1500 NY=1,YMID                         !loop till middle of columns
         TO = YDIM + 1 - NY
         GAP = (TO-NY) * XDIM
         NTMP = FROM + GAP
C
         DO 1300 NX=1,XDIM                      !loop through row
            INDX = NX + FROM
            R(NX) = A(INDX)                     !save row elements in R
1300     CONTINUE
         DO 1330 NX=1,XDIM
            INDX = NX + FROM
            A(INDX) = A(INDX+GAP)               !flip complete row...
1330     CONTINUE
         DO 1360 NX=1,XDIM 
            INDX = NX + NTMP
            A(INDX) = R(NX)
1360     CONTINUE
         FROM = FROM + XDIM
1500  CONTINUE
      RETURN
C
C  ACTION = 'XY', flip in x and y
C
2000  FROM = 0
      DO 2500 NY=1,YMID                        !loop till middle of columns
         TO = YDIM + 1 - NY
         GAP = (TO-NY) * XDIM
         GAPP = GAP + XDIM + 1
         NTMP = FROM + GAPP
C
         DO 2300 NX=1,XDIM                      !loop through row
            INDX = NX + FROM
            R(NX) = A(INDX)                     !save row elements in R
2300     CONTINUE
         DO 2330 NX=1,XDIM
            INDX = NX + FROM
            A(INDX) = A(NTMP-NX)           !flip complete row...
2330     CONTINUE
         DO 2360 NX=1,XDIM 
            INDX = NTMP - NX
            A(INDX) = R(NX)
2360     CONTINUE
         FROM = FROM + XDIM
2500  CONTINUE
C
      IF (2*YMID.NE.YDIM) THEN                  !take care of middle row
         FROM = YMID * XDIM
         TO = FROM + XDIM + 1
         DO 2800 NX=1,XMID
            INDX = NX + FROM
            SAVE = A(INDX)
            A(INDX) = A(TO-NX)
            A(TO-NX) = SAVE
2800     CONTINUE
      ENDIF
C
      RETURN
      END

      SUBROUTINE SHIFTI(A,B,C,NPIX,XSHIFT,YSHIFT)
C
      IMPLICIT NONE
C
      INTEGER  NPIX(2),XSHIFT,YSHIFT
      INTEGER  NY,NX,NOFF,OFF1,OFF2,K1
C 
      REAL     A(*),B(*),C(*)
C 
      IF (XSHIFT.EQ.0) GOTO 3000
C 
      K1 = NPIX(1) - XSHIFT
      OFF1 = 0
C 
C  check, if we have to shift also y later on
      IF (YSHIFT.EQ.0) THEN
         DO 1800 NY=1,NPIX(2)                !shift in x for each line
            DO 1000 NX=1,K1
               NOFF = NX + OFF1
               C(NOFF+XSHIFT) = A(NOFF)
1000        CONTINUE
            DO 1500 NX=1,XSHIFT
               NOFF = NX + OFF1
               C(NOFF) = A(NOFF+K1)
1500        CONTINUE
            OFF1 = OFF1 + NPIX(1)
1800     CONTINUE
         RETURN
C 
      ELSE
         DO 2800 NY=1,NPIX(2)                !shift in x for each line
            DO 2000 NX=1,K1
               NOFF = NX + OFF1
               B(NOFF+XSHIFT) = A(NOFF)
2000        CONTINUE
            DO 2500 NX=1,XSHIFT
               NOFF = NX + OFF1
               B(NOFF) = A(NOFF+K1)
2500        CONTINUE
            OFF1 = OFF1 + NPIX(1)
2800     CONTINUE
      ENDIF
C 
3000  K1 = NPIX(2) - YSHIFT
C 
C  and now shift complete lines       (initially B = A )
      OFF1 = 0
      OFF2 = YSHIFT * NPIX(1)
      DO 4400 NY=1,K1
         DO 4000 NX=1,NPIX(1)
            C(OFF2+NX) = B(OFF1+NX)
4000     CONTINUE
         OFF1 = OFF1 + NPIX(1)               !move to next line
         OFF2 = OFF2 + NPIX(1)
4400  CONTINUE
C 
      OFF1 = 0
      OFF2 = K1 * NPIX(1)
      DO 5500 NY=1,YSHIFT
         DO 5000 NX=1,NPIX(1)
            C(OFF1+NX) = B(OFF2+NX)
5000     CONTINUE
         OFF1 = OFF1 + NPIX(1)               !move to next line
         OFF2 = OFF2 + NPIX(1)
5500  CONTINUE
C
      RETURN
      END

      SUBROUTINE SCALI(SCALE,IN,NPIX,OUT)
C	INTEGER SCALE(3) - x, yscale and method (1 = average, 0 = omit)
C	REAL IN(*) - input image
C	INTEGER NPIX(2) - dimension of input image
C	REAL OUT() - output image
C
      IMPLICIT NONE
C
      INTEGER  SCALE(3),NPIX(2),SIZE
      INTEGER  OUTNDX,INOFF,KSCAL,INDX
      INTEGER  NLINE,NY,NX,K,KK,NPX,M,JOUT
C
      REAL     IN(*),OUT(*)
      REAL     VAL,AVFACT
C
      OUTNDX = 1
      INOFF = 0
C
C  split according to y-SCALE
      IF (SCALE(2).LT.1) GOTO 10000
C
C  we keep (or increase) the no. of lines
C 
      IF (SCALE(1).GE.1) THEN                   !increase in x
C
         KSCAL = SCALE(1) - 1
         DO 2000, NLINE=1,NPIX(2)
            DO 1800, NY=1,SCALE(2)                    !replicate lines
               DO 1600, NX=1,NPIX(1)
                  INDX = INOFF + NX                   !point to input pixel
                  DO 1000, K=OUTNDX,OUTNDX+KSCAL      !replicate pixels
                     OUT(K) = IN(INDX)
1000              CONTINUE
                  OUTNDX = OUTNDX + SCALE(1)          !increment out pointer
1600           CONTINUE
1800        CONTINUE
            INOFF = INOFF + NPIX(1)                   !point to next line
2000     CONTINUE
C
      ELSE                                      !decrease in x
         SCALE(1) = -SCALE(1)
C 
         IF (SCALE(3).EQ.0) THEN                !we omit pixels
            DO 2300, NLINE=1,NPIX(2)
               DO 2200, NY=1,SCALE(2)                   !replicate lines
                  DO 2100, NX=1,NPIX(1),SCALE(1)
                     OUT(OUTNDX) = IN(INOFF+NX)
                     OUTNDX = OUTNDX + 1
2100              CONTINUE
2200           CONTINUE
               INOFF = INOFF + NPIX(1)                  !point to next line
2300        CONTINUE
C     
         ELSE                                  !averaging is harder...
            AVFACT = 1.0/SCALE(1)
            M = NPIX(1) / SCALE(1)
            NXLIM = M * SCALE(1)
            KSCAL = NPIX(1) - NXLIM            !nopts for last average on row
C 
            DO 3400,NLINE=1,NPIX(2)
               DO 3300,NY=1,SCALE(2)
                  DO 3200,NX=1,NXLIM,SCALE(1)
                     VAL = 0.
                     M = INOFF+NX-1
                     DO 3100,K=1,SCALE(1)
                        VAL = VAL + IN(M+K)
3100                 CONTINUE
                     OUT(OUTNDX) = VAL*AVFACT
                     OUTNDX = OUTNDX + 1
3200              CONTINUE
                  IF (KSCAL .GT. 0) THEN
                     VAL = 0.
                     M = INOFF+NXLIM
                     DO 3220,K=1,KSCAL               !sum up as much as we can
                        VAL = VAL + IN(M+K)
3220                 CONTINUE
                     DO 3240,K=1,SCALE(1)-KSCAL      !use last pixel for rest
                        VAL = VAL + IN(M+KSCAL)
3240                 CONTINUE
                     OUT(OUTNDX) = VAL*AVFACT
                     OUTNDX = OUTNDX + 1
                  ENDIF
3300           CONTINUE
C 
               INOFF = INOFF + NPIX(1)                  !point to next line 
3400        CONTINUE
         ENDIF
      ENDIF
      RETURN
C
C  we decrease the no. of lines
C 
10000 SCALE(2) = -SCALE(2)
      SIZE = NPIX(1) * NPIX(2)           !end of input array
      LASTROW = SIZE - NPIX(1)           !point to begin of last line
C 
      IF (SCALE(1).GE.1) THEN                   !increase in x
         KSCAL = SCALE(1) - 1
         KK = NPIX(1)*SCALE(1) - 1
C 
         IF (SCALE(3).EQ.0) THEN
            DO 12600, NLINE=1,NPIX(2),SCALE(2)
               DO 12500, NX=1,NPIX(1)
                  INDX = INOFF + NX                    !point to input pixel
                  DO 12400, K=OUTNDX,OUTNDX+KSCAL      !replicate pixels
                     OUT(K) = IN(INDX)
12400             CONTINUE
                  OUTNDX = OUTNDX + SCALE(1)           !increment out pointer
12500          CONTINUE
               INOFF = INOFF + (NPIX(1)*SCALE(2))      !point to next line
12600       CONTINUE
C
         ELSE                                  !averaging is harder...
            AVFACT = 1.0/SCALE(2)
            JOUT = 1
C 
            DO 13600, NLINE=1,NPIX(2),SCALE(2)
               DO 13100, K=OUTNDX,OUTNDX+KK            !init sums
                  OUT(K) = 0.0
13100          CONTINUE
C 
               DO 13500, NY=1,SCALE(2)
                  DO 13400, NX=1,NPIX(1)
                     INDX = INOFF + NX                 !point to input pixel
                     DO 13300, K=OUTNDX,OUTNDX+KSCAL   !sum up
                        OUT(K) = OUT(K) + IN(INDX)
13300                CONTINUE
                     OUTNDX = OUTNDX + SCALE(1)        !increment out pointer
13400             CONTINUE
                  OUTNDX = JOUT
                  INOFF = INOFF + NPIX(1)              !point to next line
                  IF (INOFF .GE. SIZE) INOFF = LASTROW  !don't fall off...
13500          CONTINUE
C 
               DO 13550, K=OUTNDX,OUTNDX+KK
                  OUT(K) = OUT(K) * AVFACT
13550          CONTINUE
               JOUT = JOUT + (NPIX(1)*SCALE(1))
               OUTNDX = JOUT
13600       CONTINUE
         ENDIF
C 
      ELSE                                      !decrease in x
         SCALE(1) = -SCALE(1)
         IF (SCALE(3).EQ.0) THEN
            DO 14400, NLINE=1,NPIX(2),SCALE(2)
               DO 14200, NX=1,NPIX(1),SCALE(1)
                  OUT(OUTNDX) = IN(INOFF+NX)
                  OUTNDX = OUTNDX + 1
14200          CONTINUE
               INOFF = INOFF + (NPIX(1)*SCALE(2))
14400       CONTINUE
C 
C average in x and y
C 
         ELSE                                  !averaging is harder...
            JOUT = 1
            AVFACT = 1.0/(SCALE(1)*SCALE(2))
            M = NPIX(1) / SCALE(1)
            NXLIM = M * SCALE(1)
            KSCAL = NPIX(1) - NXLIM            !nopts for last average on row
C 
            DO 16000, NLINE=1,NPIX(2),SCALE(2)
               DO 15100, NPX=1,NPIX(1),SCALE(1)
                  OUT(OUTNDX) = 0.0
                  OUTNDX = OUTNDX + 1
15100          CONTINUE
C
               OUTNDX = JOUT
               DO 15800,NY=1,SCALE(2)
                  DO 15700,NPX=1,NXLIM,SCALE(1)
                     INDX = INOFF + NPX - 1
                     DO 15600, NX=1,SCALE(1)
                        OUT(OUTNDX) = OUT(OUTNDX) + IN(INDX+NX)
15600                CONTINUE
                     OUTNDX = OUTNDX + 1
15700             CONTINUE
                  IF (KSCAL .GT. 0) THEN        !fill the last aver.sum
                     INDX = INOFF + NXLIM 
                     DO 15740, NX=1,KSCAL             !sum up as much as we can
                        OUT(OUTNDX) = OUT(OUTNDX) + IN(INDX+NX)
15740                CONTINUE
                     DO 15770, NX=1,SCALE(1)-KSCAL    !use last pixel for rest
                        OUT(OUTNDX) = OUT(OUTNDX) + IN(INDX+KSCAL)
15770                CONTINUE
                  ENDIF
                  OUTNDX = JOUT
                  INOFF = INOFF + NPIX(1)             !follow with in pointer
                  IF (INOFF .GE. SIZE) INOFF = LASTROW  !don't fall off...
15800          CONTINUE
C 
               DO 15900, NPX=1,NPIX(1),SCALE(1)
                  OUT(OUTNDX) = OUT(OUTNDX)*AVFACT
                  OUTNDX = OUTNDX + 1
15900          CONTINUE
               JOUT = OUTNDX                      !follow with base index
16000       CONTINUE
         ENDIF
      ENDIF
C
      RETURN
      END

      SUBROUTINE THINNI(M,NPIX,W)
C
      IMPLICIT NONE
C
      INTEGER    M(*),NPIX(2),W(*)
      INTEGER    REMAIN,INC,IOFF,IOFFX
      INTEGER    MX,MY,JN,NX,NY
      INTEGER    JOFF(4),N1,N2,N3,N4,N5,N6,N7,N8,KOFF
      INTEGER    IOFA
C
      NX = NPIX(1)
      NY = NPIX(2)
      JOFF(1) = 1
      JOFF(2) = NX
      JOFF(3) = -1
      JOFF(4) = -NX
      REMAIN = 1
C
C  main loop
200   IF (REMAIN.NE.1) RETURN                !We're done.
C
      REMAIN = 0
C
      DO 5000, JN=1,4                         !look at all direct neighbours...
         KOFF = JOFF(JN)
         INC = 0
         IOFFX = NX
         DO 4000, MY=2,NY-1                   !omit first + last line...
            DO 3000, MX=2,NX-1                !omit first + last pixel...
               IOFF = IOFFX + MX
               IF ( (M(IOFF).EQ.1) .AND.
     +              (M(IOFF+KOFF).EQ.0) ) THEN       !get all neighbours...
                  IOFA = IOFF + NX
                  N1 = M(IOFF+1)
                  N2 = M(IOFA+1)
                  N3 = M(IOFA)
                  N4 = M(IOFA-1)
                  IOFA = IOFF - NX
                  N5 = M(IOFF-1)
                  N6 = M(IOFA-1)
                  N7 = M(IOFA)
                  N8 = M(IOFA+1)
C
C  now check conditions
                  IF (N1.EQ.0) THEN
C
                     IF (N5.EQ.0) THEN                           ! 0AAA0BBB
                        IF ((N2+N3+N4.GT.0).AND.(N6+N7+N8.GT.0))
     +                     GOTO 1000
                     ELSE IF ((N7.EQ.0).AND.(N8.EQ.2)) THEN      ! 0AAAAA02
                        IF (N2+N3+N4+N5+N6.GT.0) GOTO 1000
                     ELSE IF ((N3.EQ.0).AND.(N2.EQ.2)) THEN      ! 020AAAAA
                        IF (N4+N5+N6+N7+N8.GT.0) GOTO 1000
                     ENDIF
                  ENDIF
C
                  IF (N3.EQ.0) THEN
C
                     IF (N7.EQ.0) THEN                           ! BB0AAA0B
                        IF ((N1+N2+N8.GT.0).AND.(N4+N5+N6.GT.0))
     +                     GOTO 1000
                     ELSE IF ((N5.EQ.0).AND.(N4.EQ.2)) THEN      ! AA020AAA
                        IF (N1+N2+N6+N7+N8.GT.0) GOTO 1000
                     ENDIF
                  ENDIF
C
                  IF ((N5+N7.EQ.0).AND.(N6.EQ.2)) THEN           ! AAAA020A
                     IF (N1+N2+N3+N4+N8.GT.0) GOTO 1000
                  ENDIF
C
                  M(IOFF) = 3              !no pattern match...
                  REMAIN = 1
                  INC = INC + 1
                  W(INC) = IOFF            !save index...
                  GOTO 3000
C
1000              M(IOFF) = 2              !yes, pattern match...
               ENDIF
C
3000        CONTINUE                                   !end of MX loop...
C
            IOFFX = IOFFX + NX
4000     CONTINUE                                      !end of MY loop...
C
C  change all 3's to 0's
         IF (INC.GT.0) THEN
            DO 4400, MX=1,INC
               M(W(MX)) = 0
4400        CONTINUE
         ENDIF
C
5000  CONTINUE                                         !end of JN loop...
C
C  end of main loop
      GOTO 200
C
      END


      SUBROUTINE XSCORR(NTEMP,TEMP,NSPEC,SPEC,RES,NSH,MINVAL,MAXVAL)
C
C    This program computes the cross-correlation between a template
C    and a spectrum over a bandwith of 2*NSH pixels. Identity of
C    start and step are assumed. We will have 2*NSH + 1 data.
C
C
      IMPLICIT NONE
C
      INTEGER   NTEMP,NSPEC,NSH
      INTEGER   MPS,MPE,INC,I,J
C
      REAL      TEMP(*),SPEC(*),RES(*)
      REAL      MINVAL,MAXVAL
C
      DOUBLE PRECISION  SUM
C
      MPS = 1 + NSH
      IF (NSPEC .GT. NTEMP) THEN                       !watch out for that
         MPE = NTEMP - NSH
      ELSE
         MPE = NSPEC - NSH
      ENDIF
      IF (MPE.LT.MPS)
     +   CALL STETER(2,'Shift too large or frames too small...')
      INC = 1
C
      DO 20, I=-NSH,NSH
         SUM = 0.D0
         DO 10, J=MPS,MPE
            SUM = SUM + ( SPEC(J)*TEMP(J+I) )
10       CONTINUE
C
         RES(INC) = SNGL(SUM)
         INC = INC + 1
20    CONTINUE
C
C  get min, max
      MINVAL = RES(1)
      MAXVAL = MINVAL
      DO 100, I=2,INC-1
         IF (RES(I).GT.MAXVAL) THEN
            MAXVAL = RES(I)
         ELSE IF (RES(I).LT.MINVAL) THEN
            MINVAL = RES(I)
         ENDIF
100   CONTINUE
C
      RETURN
      END


      SUBROUTINE CTCORR(NTEMP,TEMP,NSPEC,SPEC,RES,NSH,MINVAL,MAXVAL)
C
C    This program computes the cross-correlation between a template
C    and a spectrum over a bandwith of 2*NSH pixels. Identity of
C    start and step are assumed. We will have 2*NSH + 1 data.
C							M. Rosa
C
CT   Modified to compute true correlation coefficient with optimal
CT   overlap range.
CT   For two arrays x and y the correlation coefficient is
CT      r = Covar(x,y)/Sqrt[Var(x)*Var(y)], 
CT   which gives
CT      r = [n*sum(x*y) - sum(x)*sum(y)]/
CT          sqrt{[n*sum(x**2)-sum(x)**2]*[n*sum(y**2)-sum(y)**2]}
CT   Since r is normalized one can use the total overlap of two
CT   shifted arrays, varying with the shift variable.
CT   29.11.2001                                         H.-C. Thomas
CT					Max-Planck Institute for Astrophysics
C
C
      IMPLICIT NONE
C
      INTEGER   NTEMP,NSPEC,NSH
      INTEGER   MPS,MPE,INC,I,J
C
      REAL      TEMP(*),SPEC(*),RES(*)
      REAL      MINVAL,MAXVAL
C 
      DOUBLE PRECISION  SUMX,SUMY,SUMXX,SUMYY,SUMXY,NPOI,T1,T2,T3
C
CT                             compute the smallest overlap, exit if less than 1
CT
      MPS = 1
      IF (NSPEC .GT. NTEMP) THEN                       !watch out for that
         MPE = NTEMP - NSH 
      ELSE
         MPE = NSPEC - NSH
      ENDIF
      IF (MPE.LT.MPS) 
     +   CALL STETER(2,'Shift too large or frames too small...')
      INC = 1
C
CT       compute the necessary sums over a range MPS to MPE varying with shift I
CT
      DO 20, I=-NSH,NSH
         SUMX = 0.D0
         SUMXX = 0.D0
         SUMY = 0.D0
         SUMYY = 0.D0
         SUMXY = 0.D0
         MPS = 1
         IF (I .GT. 0) MPS = 1+I
         MPE = NSPEC+I
         IF (MPE .GT. NTEMP) MPE = NTEMP
         DO 10, J=MPS,MPE
            SUMX = SUMX + TEMP(J)
            SUMXX = SUMXX + TEMP(J)**2
            SUMY = SUMY + SPEC(J-I)
            SUMYY = SUMYY + SPEC(J-I)**2
            SUMXY = SUMXY + ( TEMP(J)*SPEC(J-I) )
10       CONTINUE
C
CT                                           compute the correlation coefficient
CT
         NPOI = DFLOAT(1+MPE-MPS)
         T1 = NPOI*SUMXY-SUMX*SUMY
         T2 = NPOI*SUMXX-SUMX**2
         T3 = NPOI*SUMYY-SUMY**2
         RES(INC) = SNGL(T1/DSQRT(T2*T3))
         INC = INC + 1
20    CONTINUE
C
C  get min, max
      MINVAL = RES(1)
      MAXVAL = MINVAL
      DO 100, I=2,INC-1
         IF (RES(I).GT.MAXVAL) THEN
            MAXVAL = RES(I)
         ELSE IF (RES(I).LT.MINVAL) THEN
            MINVAL = RES(I)
         ENDIF
100   CONTINUE
C
      RETURN
      END

C @(#)whet_single.for	19.1 (ES0-DMD) 02/25/03 14:35:55
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C**********************************************************************
C     Benchmark #2 -- Single Precision Whetstone (A001)
C
C     o	This is a REAL*4 version of
C	the Whetstone benchmark program.
C
C     o	DO-loop semantics are ANSI-66 compatible.
C
C     o	Final measurements are to be made with all
C	WRITE statements and FORMAT sttements removed.
C
C**********************************************************************
	IMPLICIT REAL*4 (A-H,O-Z)
C
	COMMON T,T1,T2,E1(4),J,K,L
	common/ptime/ptime,time0
	real time0,time1,walltime,ptime
C
	WRITE(6,1)
   1	FORMAT(/' Benchmark #2 -- Single Precision Whetstone (A001)')
C
C	Start benchmark timing at this point.
C
	time0 = walltime()
	ptime = time0
C
C	The actual benchmark starts here.
C
	T = .499975
	T1 = 0.50025
	T2 = 2.0
C
C	With loopcount LOOP=10, one million Whetstone instructions
C	will be executed in EACH MAJOR LOOP..A MAJOR LOOP IS EXECUTED
C	'II' TIMES TO INCREASE WALL-CLOCK TIMING ACCURACY.
C
	LOOP = 1000
	II   = 1
C
	DO 500 JJ=1,II
C
C	Establish the relative loop counts of each module.
C
	N1 = 0
	N2 = 12 * LOOP
	N3 = 14 * LOOP
	N4 = 345 * LOOP
	N5 = 0
	N6 = 210 * LOOP
	N7 = 32 * LOOP
	N8 = 899 * LOOP
	N9 = 616 * LOOP
	N10 = 0
	N11 = 93 * LOOP
C
C	Module 1: Simple identifiers
C
	X1 = 1.0
	X2 = -1.0
	X3 = -1.0
	X4 = -1.0
C
	IF (N1.EQ.0) GO TO 35
		DO 30 I=1,N1
		X1 = (X1 + X2 + X3 - X4)*T
		X2 = (X1 + X2 - X3 + X4)*T
		X3 = (X1 - X2 + X3 + X4)*T
		X4 = (-X1 + X2 + X3 + X4)*T
   30		CONTINUE
   35	CONTINUE
C
	IF (JJ.EQ.II)CALL POUT(N1,N1,N1,X1,X2,X3,X4)
C
C	Module 2: Array elements
C
	E1(1) = 1.0
	E1(2) = -1.0
	E1(3) = -1.0
	E1(4) = -1.0
C
	IF (N2.EQ.0) GO TO 45
		DO 40 I=1,N2
		E1(1) = (E1(1) + E1(2) + E1(3) - E1(4))*T
		E1(2) = (E1(1) + E1(2) - E1(3) + E1(4))*T
		E1(3) = (E1(1) - E1(2) + E1(3) + E1(4))*T
		E1(4) = (-E1(1) + E1(2) + E1(3) + E1(4))*T
   40		CONTINUE
   45	CONTINUE
C
	IF (JJ.EQ.II)CALL POUT(N2,N3,N2,E1(1),E1(2),E1(3),E1(4))
C
C	Module 3: Array as parameter
C
	IF (N3.EQ.0) GO TO 59
		DO 50 I=1,N3
		CALL PA(E1)
   50		CONTINUE
   59	CONTINUE
C
	IF (JJ.EQ.II)CALL POUT(N3,N2,N2,E1(1),E1(2),E1(3),E1(4))
C
C	Module 4: Conditional jumps
C
	J = 1
	IF (N4.EQ.0) GO TO 65
		DO 60 I=1,N4
		IF (J.EQ.1) GO TO 51
		J = 3
		GO TO 52
51		J = 2
52		IF (J.gt.2) GO TO 53
		J = 1
		GO TO 54
53		J = 0
54		IF (J.LT.1) GO TO 55
		J = 0
		GO TO 60
55		J = 1
   60		CONTINUE
   65	CONTINUE
C
	IF (JJ.EQ.II)CALL POUT(N4,J,J,X1,X2,X3,X4)
C
C	Module 5: Omitted
C 	Module 6: Integer arithmetic
C
	J = 1
	K = 2
	L = 3
C
	IF (N6.EQ.0) GO TO 75
		DO 70 I=1,N6
		J = J * (K-J) * (L-K)
		K = L * K - (L-J) * K
		L = (L - K) * (K + J)
		E1(L-1) = J + K + L
		E1(K-1) = J * K * L
   70		CONTINUE
   75	CONTINUE
C
	IF (JJ.EQ.II)CALL POUT(N6,J,K,E1(1),E1(2),E1(3),E1(4))
C
C	Module 7: Trigonometric functions
C
	X = 0.5
	Y = 0.5
C
	IF (N7.EQ.0) GO TO 85
		DO 80 I=1,N7
		X=T*ATAN(T2*SIN(X)*COS(X)/(COS(X+Y)+COS(X-Y)-1.0))
		Y=T*ATAN(T2*SIN(Y)*COS(Y)/(COS(X+Y)+COS(X-Y)-1.0))
   80		CONTINUE
   85	CONTINUE
C
	IF (JJ.EQ.II)CALL POUT(N7,J,K,X,X,Y,Y)
C
C	Module 8: Procedure calls
C
	X = 1.0
	Y = 1.0
	Z = 1.0
C
	IF (N8.EQ.0) GO TO 95
		DO 90 I=1,N8
		CALL P3(X,Y,Z)
   90 		CONTINUE
   95	CONTINUE
C
	IF (JJ.EQ.II)CALL POUT(N8,J,K,X,Y,Z,Z)
C
C	Module 9: Array references
C
	J = 1
	K = 2
	L = 3
	E1(1) = 1.0
	E1(2) = 2.0
	E1(3) = 3.0
C
	IF (N9.EQ.0) GO TO 105
		DO 100  I=1,N9
		CALL P0
  100		CONTINUE
  105	CONTINUE
C
	IF (JJ.EQ.II)CALL POUT(N9,J,K,E1(1),E1(2),E1(3),E1(4))
C
C	Module 10: Integer arithmetic
C
	J = 2
	K = 3
C
	IF (N10.EQ.0) GO TO 115
		DO 110 I=1,N10
		J = J + K
		K = J + K
		J = K - J
		K = K - J - J
  110		CONTINUE
  115	CONTINUE
C
	IF (JJ.EQ.II)CALL POUT(N10,J,K,X1,X2,X3,X4)
C
C	Module 11: Standard functions
C
	X = 0.75
C
	IF (N11.EQ.0) GO TO 125
		DO 120 I=1,N11
		X = SQRT(EXP(ALOG(X)/T1))
  120		CONTINUE
  125	CONTINUE
C
	IF (JJ.EQ.II)CALL POUT(N11,J,K,X,X,X,X)
C
C      THIS IS THE END OF THE MAJOR LOOP.
C
500	CONTINUE
C
C      Stop benchmark timing at this point.
C
	time1 = walltime()
C----------------------------------------------------------------
C      Performance in Whetstone KIP's per second is given by
C
C	(100*LOOP*II)/TIME
C
C      where TIME is in seconds.
C--------------------------------------------------------------------
	print *,' Single KIPS ',nint((100*LOOP*II)/(time1-time0))
	END
C
	SUBROUTINE PA(E)
	IMPLICIT REAL*4 (A-H,O-Z)
	DIMENSION E(4)
	COMMON T,T1,T2,E1(4),J,K,L
	J1 = 0
   10	E(1) = (E(1) + E(2) + E(3) - E(4)) * T
	E(2) = (E(1) + E(2) - E(3) + E(4)) * T
	E(3) = (E(1) - E(2) + E(3) + E(4)) * T
	E(4) = (-E(1) + E(2) + E(3) + E(4)) / T2
	J1 = J1 + 1
	IF (J1 - 6) 10,20,20
C
   20	RETURN
	END
C
	SUBROUTINE P0
	IMPLICIT REAL*4 (A-H,O-Z)
	COMMON T,T1,T2,E1(4),J,K,L
	E1(J) = E1(K)
	E1(K) = E1(L)
	E1(L) = E1(J)
	RETURN
	END
C
	SUBROUTINE P3(X,Y,Z)
	IMPLICIT REAL*4 (A-H,O-Z)
	COMMON T,T1,T2,E1(4),J,K,L
	X1 = X
	Y1 = Y
	X1 = T * (X1 + Y1)
	Y1 = T * (X1 + Y1)
	Z = (X1 + Y1) / T2
	RETURN
	END
C
	SUBROUTINE POUT(N,J,K,X1,X2,X3,X4)
	IMPLICIT REAL*4 (A-H,O-Z)
	common/ptime/ptime,time0
	real ptime,time1,time0,walltime
	time1 = walltime()
	print 10, nint(time1-time0),nint(time1-ptime),N,J,K,X1,X2,X3,X4
   10	FORMAT (2i3,1X,3I7,4(1PE12.4))
	ptime = time1
	RETURN
	END
 
        real function walltime()
        real it(2)
        walltime = etime(it)
        return
        end

C @(#)median.for	19.1 (ES0-DMD) 02/25/03 13:30:46
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine MEDIAN         version 2         810727
C  A. Kruszewski             ESO - Garching
C.PURPOSE
C  calculates median "AMED" of input array "A"
C.INPUT/OUTPUT
C  input arguments
C  A           real*4 array        data array
C  N           integer*4           number of values in "A"
C  ALC         real*4              low cut applied to data in "A"
C  AHC         real*4              high cut applied to data in "A"
C  output arguments
C  AMED        real*4              median of data in "A"
C-----------------------------------------------------------------------
      SUBROUTINE MEDIAN(A,N,ALC,AHC,AMED)
C
      IMPLICIT  NONE	
      INTEGER   N
      DIMENSION A(N)
      REAL      AHC
      REAL      AMED
C
      INTEGER   HISTO(100)
      INTEGER   L
      INTEGER   K
      REAL      A, ALC
      REAL      HN
      REAL      SUM
      REAL      CORR
      REAL      X0,X1,DX
C
      X0=ALC
      X1=AHC
C
C *** Calculates histogram.
C
      DX=(X1-X0)/100
      DO 10 L=1,100
         HISTO(L)=0
10    CONTINUE 
      DO 11 K=1,N
         L=INT((A(K)-X0)/DX)+1
         HISTO(L)=HISTO(L)+1
11    CONTINUE 
C
C *** Calculates median with help of histogram.
C
      HN=FLOAT(N)/2
      L=0
      SUM=0.0
12    CONTINUE
         L=L+1
         SUM=SUM+HISTO(L)
      IF (SUM.LT.HN) GOTO 12 
      AMED=X0+L*DX
      CORR=((SUM-HN)*DX)/HISTO(L)
      AMED=AMED-CORR
      RETURN
      END 

C @(#)waves.for	19.1 (ES0-DMD) 02/25/03 13:24:48
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
        PROGRAM WAVES
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C
C  Program WAVE	           version 1.00       860706
C                          version 2.00       890424 (pMIDAS)
C  F. Murtagh              STECF		
C  M. Peron                IPG             890901 add include files
C  P. Ballester            IPG             910313 Compil. option -u
C                                                 and more
C
C.KEYWORDS
C  Simulated images, test images.
C
C.PURPOSE
C  Create background "wave" image, given the amplitude, period, and
C  dimensions of the image.
C
C.OUTPUT
C
C  Keys:  OUT_A/C/1/60       output data array
C         INPUTR/R/1/1       amplitude
C         INPUTR/R/1/1       period
C         INPUTI/I/2/1       frame dimensions
C
C-----------------------------------------------------------
C
C
        IMPLICIT NONE
C
        REAL                    RMIN,RMAX
        REAL                    STEPO(3),STARTO(3),CUTS(4)
        DOUBLE PRECISION        DSTEP(3), DSTART(3)
        INTEGER                 NPIXO(3),MADRID,KUN,KNUL
        CHARACTER*60            OUTIMA
        CHARACTER*72            IDENTO
        CHARACTER*80            CUNITO
C
        INTEGER                 IACT,ISTAT,IDIM,NDIMO
        INTEGER*8               JPNTR
        INTEGER                 IMNO,KUNIT
        REAL                    AMPL,PERIOD
C
        INCLUDE                 'MID_INCLUDE:ST_DEF.INC/NOLIST'
        COMMON                  /VMR/MADRID(1)
        INCLUDE                 'MID_INCLUDE:ST_DAT.INC/NOLIST'

C
C
C ... get into MIDAS
C
        CALL STSPRO('WAVES')
C
C ... get name of output frame
C
        CALL STKRDC('OUT_A',1,1,60,IACT,OUTIMA,KUN,KNUL,ISTAT)
C
C ... get amplitude, period, and frame dimensions.
C
        CALL STKRDR('INPUTR',1,1,IACT,AMPL,KUN,KNUL,ISTAT)
        CALL STKRDR('INPUTR',2,1,IACT,PERIOD,KUN,KNUL,ISTAT)
        CALL STKRDI('INPUTI',1,1,IACT,IDIM,KUN,KNUL,ISTAT)
C
C ... map output image
C
        NDIMO = 2
        NPIXO(1)  = IDIM
        NPIXO(2)  = IDIM
        STARTO(1) = 1
        STARTO(2) = 1
        STEPO(1)  = 1.0
        STEPO(2)  = 1.0 
        CUNITO    = ' NONE'
        IDENTO    = ' ARTIFICIAL BACKGROUND WAVE IMAGE' 
        DSTEP(1)  = STEPO(1)
        DSTART(1) = STEPO(1)
        CALL STIPUT(OUTIMA,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .                   NDIMO,NPIXO,DSTART,
     .                   DSTEP,IDENTO,CUNITO,JPNTR,IMNO,ISTAT)
C
C ... now do the work
C
        CALL PATTERN(MADRID(JPNTR),RMIN,RMAX,AMPL,PERIOD,IDIM,ISTAT)
C
C ... write cuts
C
        CUTS(1) = RMIN
        CUTS(2) = RMAX
        CUTS(3) = RMIN
        CUTS(4) = RMAX
        CALL STDWRR(IMNO,'LHCUTS',CUTS,1,4,KUNIT,ISTAT)
C
C ... end
C
        CALL STFCLO(IMNO,ISTAT)
        CALL STSEPI
        END

C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C
C  Program PATTERN    
C  F. MURTAGH                                 ST-ECF  Version 1.0 860411
C
C.KEYWORDS
C
C  Test patterns, simulated images.
C
C
C.OUTPUT PARAMETERS
C 
C  ARR  = the frame,
C  RMIN, RMAX = cut values (max. and min. flux values).
C
C----------------------------------------------------------------------
        SUBROUTINE PATTERN(ARR,RMIN,RMAX,AMPL,PERIOD,IDIM,ISTAT)
C
        IMPLICIT NONE
C
C
        INTEGER              IDIM,ISTAT,NDIM1,NDIM2,I,J
        REAL                 ARR(IDIM,IDIM)
        REAL                 RMIN,RMAX,AMPL,PERIOD,ANGLE,PHASE
C
C
C
        NDIM1 = IDIM
        NDIM2 = IDIM
        PHASE = 0.0
C
C  (Mean, over one period, is 0 flux units per pixel.)
C
        DO I = 1, NDIM1
           DO J = 1, NDIM2
              ANGLE = (2*3.1415926/PERIOD)*FLOAT(I) - PHASE
              ARR(I,J) = AMPL*SIN(ANGLE)
           ENDDO
        ENDDO
C
C ------DETERMINE CUTS (I.E. MAX AND MIN VALUES)---------------------
C
        RMIN = 1000000.
        RMAX = -100000.
        DO I = 1, NDIM1
           DO J = 1, NDIM2
              IF (ARR(I,J).LT.RMIN) RMIN = ARR(I,J)
              IF (ARR(I,J).GT.RMAX) RMAX = ARR(I,J)
           ENDDO
        ENDDO
C
C
        RETURN
C
        END

C @(#)gradet.for	19.1 (ES0-DMD) 02/25/03 13:25:34
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine GRADET         version 1.1       830908
C  A. Kruszewski             ESO Garching
C.KEYWORDS
C  gradient regression
C.PURPOSE
C  calculates regression coefficient between vectors "X" and "Y"
C  only these values of arrays "X" and "Y" are used for which
C  corresponding element of array "IW" is equal 1
C.INPUT/OUTPUT
C  X           real*4 array      independent variable
C  Y           real*4 array      dependent variable
C  IW          integer*4 array   array indicating which values
C                                of arrays "X" and "Y" are to be used
C  N           integer*4         number of elements in "X" and "Y"
C                                minus one
C  output arguments
C  AVGR        real*4           regression coefficient
C  ZRLV        real*4           zero level
C  DVGR        real*4 array     deviations of elements of vector "X"
C                               from the regression line
C  SIGMA       real*4           sigma of single point
C-----------------------------------------------------------------------
      SUBROUTINE GRADET(N, X, Y, IW, AVGR, ZRLV, DVGR, SIGMA)
      IMPLICIT  NONE
C
      INTEGER   N
      REAL      X(0:N)
      REAL      Y(0:N)
      INTEGER   IW(0:N)
      REAL      AVGR
      REAL      ZRLV
      REAL      DVGR(0:N)
      REAL      SIGMA
C
      INTEGER   NN 
      INTEGER   L
      REAL      A11, A12, A22
      REAL      V1, V2, V12
      REAL      B11, B12, B13
      REAL      B22, B222, B23
      REAL      B33
      REAL      C11, C12, C22
C
C ***
      A11 = 0.0
      A12 = 0.0
      A22 = 0.0
      V1 = 0.0
      V2 = 0.0
      V12 = 0.0
      NN = 0
C
C ******      Prepare normal equations.
C
      DO 10 L = 0 , N
            IF ( IW(L) .EQ. 1 ) THEN
                  A11 = A11 + 1
                  A12 = A12 + X(L)
                  A22 = A22 + X(L) * X(L)
                  V1 = V1 + Y(L)
                  V2 = V2 + X(L) * Y(L)
                  V12 = V12 + Y(L) * Y(L)
                  NN = NN + 1
            ENDIF
   10      CONTINUE
C
C ******      Invert matrix of coefficients in normal equation.
C
      B11 = SQRT( A11 )
      B12 = A12 / B11
      B13 = V1 / B11
      B222 = A22 - B12 * B12
      IF ( B222 .GT. 0.0 ) THEN
            B22 = SQRT( B222 )
            B23 = ( V2 - B12 * B13 ) / B22
            B33 = V12 - B13 * B13 - B23 * B23
            C11 = 1.0 / B11
            C22 = 1.0 / B22
            C12 = -(C11*B12) / B22
C
C ******            Calculate unknowns ZRLV and AVGR.
C
            ZRLV = C11*B13 + C12*B23
            AVGR = C22*B23
C
C ******            Calculates mean error of
C ******            single data point SIGMA. 
C
            IF ( NN .GT. 2 .AND. B33 .GT. 0.0 ) THEN
                  B33 = SQRT( B33 / (NN-2) )
                  SIGMA = B33
            ELSE
                  SIGMA = 0.0
            ENDIF
C
C ******            Calculate deviations of data points
C ******            from the fitted regression line.
C
            IF ( SIGMA .GT. 0.0 ) THEN
                  DO 20 L = 0 , N
                        DVGR(L) = Y(L) - ZRLV - X(L)*AVGR
   20                  CONTINUE
               ELSE
                  DO 30 L = 0 , N
                        DVGR(L) = 0.0
   30                  CONTINUE
               ENDIF
      ELSE
            AVGR = 0.0
            SIGMA = 0.0
      ENDIF
C
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++
C 
C.IDENTIFICATION: OVERIDEN 
C.PURPOSE:   Draw columns of a table on a graphic screen
C.           in overlay mode (after a plot command)
C.AUTHOR:    J.D.Ponz       ESP - Garching
C.KEYWORDS:  Identification, table, overlay
C.USE:       OVERPLOT/IDEN table col-ref1 col-ref2 [UP/DOWN]
C.ALGORITHM: Use the routines of the agl library
C.LANGUAGE:  F77+ESOext
C.VERSION:   1.0  820707
C.VERSION:   2.0  821115
C.VERSION:   2.1  840227
C.VERSION:   3.0  860624  Conversion to Fortran 77 + ESO extensions
C 
C 190323	last modif	use STTPUT for output all over  KB
C-----------------------------------------------------------------------------
      PROGRAM   OVRIDN
      IMPLICIT  NONE
C
      INTEGER   MADRID,TID
      INTEGER   NPAR,ISTAT,ILEN,ILAB
      INTEGER   I,IAC
      INTEGER   NCOLUM,NCOL,NROW,NSC
      INTEGER   NLIM,NLAB
      INTEGER   COL(4),NTOT
      INTEGER   PARNEV,NVAL(1000)
      INTEGER   DTYPE,NACOL,NAROW

      INTEGER   ACCESS, PLMODE
      REAL      SIZEX,SIZEY,Y,Y2,Y3,VX
      REAL      YDUM
      REAL      XD(3), YD(3), CLIP(4)
C     REAL      RIDENT
      DOUBLE PRECISION DIDENT
      REAL      X(1000),XL(1000),XR(1000)
      REAL      WIND(8),XPS(2),YPS(2)

      LOGICAL   IWIND,NULL,ISEL,IMESH

      CHARACTER TABLE*64,IUD*1
      CHARACTER AFORM*8,IDENT*20,CTEST*20,FORM*16
      CHARACTER*17 COLUMN(4)
      CHARACTER TEXT*80
 
      INCLUDE   'MID_INCLUDE:PLTDEC.INC/NOLIST'
      INCLUDE   'MID_INCLUDE:TABLES.INC/NOLIST'
      COMMON    /VMR/MADRID(1)

      INCLUDE   'MID_INCLUDE:TABLED.INC/NOLIST'
      DATA      NTOT/1000/
      DATA      PARNEV/5/
C
C9000 FORMAT (I4)
 9011 FORMAT('SYDI=',F6.2)
 9012 FORMAT('CHDI=',F6.2,',',F6.2)
C
      CALL STSPRO('OVERIDEN')
C
      CALL TDPGET(PARNEV,NPAR,ISTAT)
      IF (ISTAT.NE.0) THEN
         TEXT = '*** FATAL: Problems with table parameters '
         CALL STTPUT(TEXT,ISTAT)
         CALL STSEPI
      ENDIF

      TABLE     = TPARBF(1)
      COLUMN(1) = TPARBF(2)
      COLUMN(2) = TPARBF(3)
      IUD       = TPARBF(4)
      NCOLUM    = 2
      IMESH     = .TRUE.
C
C ... read table
      CALL TBTOPN(TABLE,F_I_MODE,TID,ISTAT)
      IF (ISTAT.NE.0) THEN
         TEXT = '*** FATAL: Failed to open table: '//TABLE
         CALL STTPUT(TEXT,ISTAT)
         CALL STSEPI
      ENDIF
C
      CALL TBIGET(TID,NCOL,NROW,NSC,NACOL,NAROW,ISTAT)
      IF (ISTAT.NE.0) THEN
         TEXT = '*** FATAL: Failed to get table info '//TABLE
         CALL STTPUT(TEXT,ISTAT)
         CALL STSEPI
      ENDIF
C
C ... get column addresses
      DO 10 I = 1,NCOLUM
          CALL TBCSER(TID,COLUMN(I),COL(I),ISTAT)
          IF (ISTAT.NE.0) THEN
             TEXT = '*** FATAL: Failed to get table column'
             CALL STTPUT(TEXT,ISTAT)
             CALL STSEPI
          ENDIF

          IF (COL(I).EQ.-1) THEN
             TEXT = '*** FATAL: Failed to get table column'
             CALL STTPUT(TEXT,ISTAT)
             CALL STSEPI
          ENDIF
   10 CONTINUE
C
      CALL TBFGET(TID,COL(2),AFORM,ILEN,DTYPE,ISTAT)
      I      = INDEX(AFORM,' ')-1
      FORM   = '('//AFORM(1:I)//')'
C
C ... plot - AGL window
      ACCESS = 1
      PLMODE = -1
      CALL PTOPEN(' ',' ',ACCESS,PLMODE)
      CALL AGSSET('BOTT')
      CALL PTKRDR('XWNDL',4,IAC,WIND)
      CALL PTKRDR('YWNDL',4,IAC,WIND(5))
C
C *** get the character and symbol sizes
      CALL PTKRDR('SSIZE',1,IAC,SSIZE)
      CALL PTKRDR('TSIZE',1,IAC,TSIZE)
      WRITE(TEXT,9011) 0.75*SSIZE
      CALL AGSSET(TEXT)
      WRITE(TEXT,9012) 0.75*TSIZE,0.75*TSIZE
      CALL AGSSET(TEXT)
      LTYPE = 1
C
      SIZEX = ABS(WIND(2)-WIND(1))/60.
      NLIM  = MIN(NINT(ABS(WIND(2)-WIND(1))/SIZEX),NTOT)
      CALL AGRGET('CLPL',CLIP)
      Y2    = (CLIP(4)-CLIP(3))/10.
      CALL AGTGET('M',XD,YD)
      Y3   = YD(2)
      SIZEY = (ILEN+1)*YD(2)
      CALL UPCAS(IUD,IUD)
      IF (IUD.EQ.'T') THEN
         Y = CLIP(4) - Y3
      ELSE
         Y = CLIP(3) + Y3
      END IF
C
C ... first iteration to find label positions
CC      write(*,123)nrow,wind(1),wind(2)
      WRITE(TEXT,123) NROW,WIND(1),WIND(2)
      CALL STTPUT(TEXT,ISTAT)
123   format('nrow = ',i3,' wind(1,2) = ',g15.7,g15.7)
      NLAB  = 0
      DO 20 I = 1,NROW
         CALL TBSGET(TID,I,ISEL,ISTAT)
         IF (ISEL) THEN
            CALL TBERDR(TID,I,COL(1),VX,NULL,ISTAT)
            WRITE(TEXT,1234) I,VX
            CALL STTPUT(TEXT,ISTAT)
CC          write(*,1234) i,vx
1234  format('for selected row ',i4,' vx = ',g15.7)

            IWIND = VX .GE. WIND(1) .AND. VX .LE. WIND(2)
            IF (.NOT.NULL .AND. NLAB.LT.NLIM .AND. IWIND) THEN
               NLAB    = NLAB + 1
               X(NLAB) = VX
            END IF
         END IF
   20 CONTINUE
C
C ... if no label position found, init first XL, XR values here
C     otherwise that's not done inside LBLOVE !!
C 
      IF (NLAB.LT.2) THEN
         XL(1) = 0.0
         XL(2) = 0.0
         XL(3) = 0.0
         XR(1) = 0.0
         XR(2) = 0.0
         XR(3) = 0.0
      ENDIF
C
C ... compute new label positions without overlap
      CALL LBLOVE(X,NLAB,WIND(1),WIND(2),SIZEX,X,NVAL,XL,XR)
C 
C *** het the maximum string length
C ... second iteration to plot labels
      CALL AGSSET('NORM')
      ILAB = 0
      DO 40 I = 1,NROW
         CALL TBSGET(TID,I,ISEL,ISTAT)
         IF (ISEL) THEN
            CALL TBERDR(TID,I,COL(1),VX,NULL,ISTAT)
            IWIND = VX .GE. WIND(1) .AND. VX .LE. WIND(2)
            IF (.NOT. NULL .AND. IWIND) THEN
               IF (DTYPE.NE.D_C_FORMAT) THEN
C                 CALL TBERDR(TID,I,COL(2),RIDENT,NULL,ISTAT)
                  CALL TBERDD(TID,I,COL(2),DIDENT,NULL,ISTAT)
                  IF (.NOT. NULL) THEN
C                    WRITE (IDENT,FORM,ERR=30) RIDENT
                     WRITE (IDENT,FORM,ERR=30) DIDENT
                  END IF
   30             CONTINUE

               ELSE
                  CALL TBERDC(TID,I,COL(2),CTEST,NULL,ISTAT)
                  CALL FT_EOS(CTEST,20,IDENT,ISTAT)
               END IF
               

               ILAB   = ILAB + 1
               IF (ILAB.GE.NLIM) THEN
                  ILAB   = NLIM
                  IF (IMESH) THEN
                     IMESH  = .FALSE.
                     CALL STTPUT(' Warning: Too many identifications',
     +                             ISTAT)
                     CALL STTPUT(
     +             ' Change plotting scale or use SELECT/TABLE',ISTAT)
                  END IF
               END IF

               IF (IUD.EQ.'T') THEN
                  CALL AGVU2N(VX,WIND(6),XPS(1),YDUM)
                  XPS(2) = XPS(1)
                  YPS(1) = Y-SIZEY-Y2-Y3
                  YPS(2) = Y-SIZEY-2*Y2-Y3
                  CALL AGGPLL(XPS,YPS,2)
C
                  IF (IMESH) THEN
                     CALL AGVU2N(X(ILAB),WIND(6),XPS(1),YDUM)
                     CALL AGVU2N(VX,WIND(6),XPS(2),YDUM)
                     YPS(1) = Y-SIZEY-Y3
                     YPS(2) = Y-SIZEY-Y2-Y3
                     CALL PTDATA(0,1,0,XPS,YPS,0.0,2)
                     CALL AGGTXT(XPS(1),Y,IDENT(1:ILEN),4)
                  END IF

               ELSE
                  CALL AGVU2N(VX,WIND(5),XPS(1),YDUM)
                  XPS(2) = XPS(1)
                  YPS(1) = Y+SIZEY+Y2+Y3
                  YPS(2) = Y+SIZEY+2*Y2+Y3
                  CALL PTDATA(0,1,0,XPS,YPS,0.0,2)

                  IF (IMESH) THEN
                     CALL AGVU2N(X(ILAB),WIND(5),XPS(1),YDUM)
                     CALL AGVU2N(VX,WIND(5),XPS(2),YDUM)
                     YPS(1) = Y+SIZEY+Y3
                     YPS(2) = Y+SIZEY+Y2+Y3
                     CALL PTDATA(0,1,0,XPS,YPS,0.0,2)
                     CALL AGGTXT(XPS(1),Y,IDENT(1:ILEN),8)
                  ENDIF

               END IF
               IDENT  = ' '
            END IF
         END IF
   40 CONTINUE
C
C ... end
      CALL TBTCLO(TID,ISTAT)
      CALL PTCLOS()
      CALL STSEPI
      END



      SUBROUTINE LBLOVE(X,N,XLEFT,XRIGHT,DELTA,XC,NVAL,XL,XR)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION: LBLOVE
C.PURPOSE:        Compute new label positions without overlapping
C--------------------------------------------------------------------------
      IMPLICIT NONE	
      INTEGER  N                                           ! dimension of X
      REAL     X(N)                                        ! original positions
      REAL     XLEFT                                       ! left boundary
      REAL     XRIGHT                                      ! right boundary
      REAL     DELTA                                       ! size of label
      REAL     XC(N)
      INTEGER  NVAL(N)
      REAL     XL(N)                                       ! new positions
      REAL     XR(N)  
  
      REAL     D, D2
      REAL     XAVE
      INTEGER  I, J, J1, K
      INTEGER  M, L, ISTAT 
C 
      CHARACTER TEXT*80
C
      LOGICAL IOVER
C
C ... assign initial values
C
      D2     = DELTA/2.
CC      write(*,1234) d2,n
      WRITE(TEXT,1234) D2,N
      CALL STTPUT(TEXT,ISTAT)
1234  format('d2 = ',g15.7,' n = ',i3)
CC      write(*,123) 'X:',x(1),x(2)
      WRITE(TEXT,123) 'X:',X(1),X(2)
      CALL STTPUT(TEXT,ISTAT)
      DO 10 I = 1,N
         XL(I)  = MAX(X(I)-D2,XLEFT)
         XR(I)  = MIN(X(I)+D2,XRIGHT)
         NVAL(I) = 1
         IF (XL(I).EQ.XLEFT) THEN
            XR(I)  = XL(I) + DELTA
         ENDIF
         IF (XR(I).EQ.XRIGHT) THEN
            XL(I)  = XR(I) - DELTA
         ENDIF
   10 CONTINUE

CC      write(*,123) 'XL:',xl(1),xl(2)
      WRITE(TEXT,123) 'XL:',XL(1),XL(2)
      CALL STTPUT(TEXT,ISTAT)
123   format(' ',a,g15.7,g15.7)
CC      write(*,123) 'XR:',xr(1),xr(2)
      WRITE(TEXT,123) 'XR:',XR(1),XR(2)
      CALL STTPUT(TEXT,ISTAT)
C
C ... merge labels
C
      M      = N
C
   20 CONTINUE
      IOVER  = .FALSE.
      I      = 2
C
   30 CONTINUE
      IF (XR(I-1).GT.XL(I)) THEN
         NVAL(I-1) = NVAL(I-1) + NVAL(I)
         L      = 0
         DO 50 J = 1,M
            IF (J.NE.I) THEN
               J1     = J
               IF (J.GT.I) J1     = J1 - 1
               XAVE   = 0.D0
               DO 40 K = 1,NVAL(J)
                  L      = L + 1
                  XAVE   = XAVE + X(L)
   40          CONTINUE
               XAVE   = XAVE/FLOAT(NVAL(J))
               D      = DELTA*FLOAT(NVAL(J))
               XL(J1) = MAX(XAVE-D/2.,XLEFT)
               XR(J1) = MIN(XAVE+D/2.,XRIGHT)
               NVAL(J1) = NVAL(J)
               IF (XL(J1).EQ.XLEFT) XR(J1) = XL(J1) + D
               IF (XR(J1).EQ.XRIGHT) XL(J1) = XR(J1) - D
            END IF
   50    CONTINUE
         IF (M.EQ.1) THEN
            GOTO 60
         ELSE
            M = M - 1
         ENDIF
         IOVER  = .TRUE.
      END IF
C
      I      = I + 1
      IF (M.EQ.1) GO TO 60
      IF (I.LE.M) GO TO 30
      IF (IOVER) GO TO 20
C
C ... assign final values
C
   60 L      = 0
      DO 80 I = 1,M
         DO 70 J = 1,NVAL(I)
            L      = L + 1
            XC(L)  = XL(I) + (J-1)*DELTA + D2
   70    CONTINUE
   80 CONTINUE
C
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2006 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++
C.IDENTIFICATION ftoc_log.for
C.LANGUAGE       F77
C.AUTHOR         Francois Ochsenbein
C.ENVIRONMENT    
C.KEYWORDS       
C.PURPOSE        Test of TRUE/FALSE logical values
C.COMMENTS       
C.VERSION  1.0   19-Dec-1990
C 060203	last modif
C 
C----------------
C
      LOGICAL T,F
      INTEGER I,J
C
      T = .TRUE.
      F = .FALSE.

      WRITE (6,1)
  1   FORMAT('/*++++++++++++++++++')
      WRITE (6,2)
  2   FORMAT('.IDENTIFICATION ftoc_log.h')
      WRITE (6,3)
  3   FORMAT('.LANGUAGE       C')
      WRITE (6,4)
  4   FORMAT('.AUTHOR         Francois Ochsenbein')
      WRITE (6,5)
  5   FORMAT('.ENVIRONMENT')
      WRITE (6,6)
  6   FORMAT('.KEYWORDS')
      WRITE (6,7)
  7   FORMAT('.VERSION  1.0   12-Dec-1990')
      WRITE (6,8)
  8   FORMAT('.COMMENTS       Here is the definition of LOGICAL')
      WRITE (6,9)
  9   FORMAT('                values in Fortran.')
      WRITE (6,10)
  10  FORMAT('---------------*/')
      WRITE (6,11)
  11  FORMAT('#ifndef F77DEF_DEF'/'#define F77DEF_DEF')

C get the numerical values for .TRUE. and .FASLE.
      CALL CSUB(T,F,I,J)		!call C routine

      WRITE (6,12) I,J
  12  FORMAT('#define F77TRUE ',I10/'#define F77FALSE',I10)
      WRITE(6,13)
  13  FORMAT('#endif')
C
      STOP
      END

C @(#)necompix.for	19.1 (ESO-DMD) 02/25/03 14:20:24
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
c  Program COMPIXEL.FOR
C
C  Computes the pixelsize of an Echelle session
C
C
C  By A.Fontana
C  Version 1.0   Sun&IBM 01-01-95
C  Version 1.1   Sun&IBM 20-02-95 YFORMAT ok.
C  Version 1.2   S.Wolf  05-10-99 return minimum and maximum
c                                 pixelsize in OUTPUTD(1..2),
c                                 plot flag added (inputi(3)),
c                                 use {LINTAB} instead of line.tbl.
C!!!!!!!
C     MIDAS SET-UP
C!!!!!!!

       implicit none
       integer NMXORD,NMXPIX
       parameter (NMXORD=100,NMXPIX=5000)
       double precision wave(NMXORD,NMXPIX)
       double precision pixsiz(NMXORD,NMXPIX)
       double precision coefd(7*NMXORD)
       double precision wavmin,wavmax,pixmin,pixmax,xj

       integer ord(2),TabID,coenum,xsize

       integer iread,inul,istat,i,j,k

       real xdef(4),ydef(4)                 ! graphic
       real   dummy(2),XLAMBD(NMXPIX),SPECTR(NMXPIX)
       integer colore(4),imode,stype,ltype,plt
       character*60 LINTAB
c       character*70 stringa


       INTEGER MADRID(1)
       INCLUDE 'MID_INCLUDE:ST_DEF.INC'
       COMMON/VMR/MADRID
       INCLUDE 'MID_INCLUDE:ST_DAT.INC'

C      Initialize midas
       call STSPRO('compixel')

C      Reads ord1,ord2 from INPUTI and x-axis size from IMSIZE
       call STKRDI('INPUTI',1,2,iread,ord,inul,inul,istat)
       call STKRDI('INPUTI',3,1,iread,plt,inul,inul,istat)
       call STKRDI('IMSIZE',1,1,iread,xsize,inul,inul,istat)
       call STKRDC('LINTAB',1,1,60,iread,LINTAB,inul,inul,istat)
 
C      Opens line.tbl and reads coefd
       call TBTOPN(LINTAB,F_D_MODE,TabID,istat)
       call STDRDD(TabID,'COEFD',1,7*NMXORD,coenum,coefd,
     1       inul,inul,istat)
       call TBTCLO(TabID,istat)

C      Computes wavelengths
       do i = ord(1), ord(2)
         do j = 1,xsize
             wave(i,j) = coefd(7*i -6)
             xj = 1
             do k = 2,7
               xj = xj * dfloat(j)
               wave(i,j)=wave(i,j)+coefd(7*i-7+k)*xj
             end do
             wave(i,j)=wave(i,j) * 1.D4
c debug
c             if (j.gt.1250.and.j.lt.1350) then
c                write(stringa,*)j,wave(i,j)
c                call sttdis(stringa,o,istat)
c             end if
c  endebug
         end do
       end do

C      Computes pixelsizes
       do i = ord(1), ord(2)
         do j = 1,xsize-1
             pixsiz(i,j) = wave(i,j+1) - wave(i,j)
         end do
         pixsiz(i,xsize) = pixsiz(i,xsize-1)
       end do

C      Looks for maxima and minima
       wavmin = wave(Ord(1),1)
       wavmax = wave(Ord(2),xsize)

       pixmin = pixsiz(Ord(1),xsize)  ! should be the right one...
       pixmax = pixsiz(Ord(2),1)      ! should be the right one...
                                      ! but I check....
       do i = ord(1), ord(2)
         do j = 1,xsize
           if (pixmin .gt. pixsiz(i,j)) pixmin = pixsiz(i,j)
           if (pixmax .lt. pixsiz(i,j)) pixmax = pixsiz(i,j)
         end do
       end do

       if (plt.eq.0) goto 10
c%%%%%%% 
C        Graphic set-up
C%%%%%%%


       CALL PTKWRR('SCALES',0,dummy)
       CALL PTKWRR('OFFS',0,dummy)


       xdef(1)=wavmin - (wavmax - wavmin) / 10.
       xdef(2)=wavmax + (wavmax - wavmin) / 10.
       xdef(3)=(xdef(2) - xdef(1))/5.
       xdef(4)=xdef(3)/5.


       ydef(1)= pixmin - (pixmax - pixmin ) / 10.
       ydef(2)= pixmax + (pixmax - pixmin ) / 10.
       ydef(3) = (ydef(2) - ydef(1))/5
       ydef(4)=  ydef(3) / 5.

       call PTKWRR('XWNDL',4,xdef)
       call PTKWRR('YWNDL',4,ydef)
       call PTKRDI('STYPE',1,inul,stype)
       call PTKRDI('LTYPE',1,inul,ltype)
       imode = -1
       colore(1)=1
       call PTKWRI('COLOUR',1,colore)

C     Makes the plots

       do i = Ord(1),Ord(2)

         if (i.eq.Ord(1))then
           call PTOPEN(' ','compixel.plt',0,imode) ! plot
           call AGVERS()
           call PTFRAM(xdef,ydef,'Wavelength (A)','Pixel Size (A)') 
         else
           call PTOPEN(' ','fitlyman.plt',1,imode)    ! overplot     
         end if
  
         do j = 1,xsize
           XLAMBD(j) = wave(i,j)
           SPECTR(j) = pixsiz(i,j)
         end do

         if (colore(1) .eq. 2 ) then 
           colore(1)=1
         else
           colore(1)=2
         end if
         call PTKWRI('COLOUR',1,colore)
         call PTDATA(stype,ltype,0,XLAMBD,SPECTR,0.,xsize)
         
       end do

       colore(1)=1
       call PTKWRI('COLOUR',1,colore)
C
10     coefd(1) = pixmin
       coefd(2) = pixmax
       CALL STKWRD('OUTPUTD',coefd,1,2,inul,istat)

       call STSEPI() 
       end

      

C @(#)chaos.for	19.1 (ESO-DMD) 02/25/03 13:24:47
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM CHAOS
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  program CHAOS			version 1.00	901031
C  K. Banse				ESO - Garching
C
C.KEYWORDS
C  dynamic systems, bulk data frame
C
C.PURPOSE
C  create a MIDAS image
C
C.ALGORITHM
C  use MIDAS interfaces
C
C.INPUT/OUTPUT
C  the following keywords are used:
C
C IN_A/C/1/60                  	name of new image file
C DEFAULT/C/1/1         	= Y, all image info given in command line
C                  		= N, use frame given in key P2 for that
C P3/C/1/60                  	info frame, if DEFAULT = N
C INPUTI/I/1/7                 	NAXIS + NPIX
C INPUTR/R/1/12                	START + STEP
C P4/C/1/20                  	type of data function
C                  		= LORENZ, ELFLY, JULIA, SYMM
C P5/C/1/60                  	coefficients for data function
C
C.VERSIONS
C  1.00		from version 1.20 of crfram.for
C
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      NAXIS,CUNLEN
      INTEGER*8    PNTR
      INTEGER      IAV,IDUM,N,NCOEF,NO,STAT
      INTEGER      INO,IBUF(7),NPIX(6)
      INTEGER      NLO,RNO,UNIT(1),MADRID(1)
      INTEGER      NPIX1,NPIX2
C
      REAL         CUTS(4),COEFS(10),FMIN,FMAX,RDUM
C
      DOUBLE PRECISION START(6),STEP(6),DBUF(12)
      DOUBLE PRECISION DCOEFS(3),DDUM
C
      CHARACTER    CUNIT*112,IDENT*72,NAME*60,INFRAM*60
      CHARACTER    CBUF*60,DEFAUL*1
      CHARACTER    FUNCY*4
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      COMMON   /VMR/ MADRID
C
      DATA      CUNIT /'none given '/, CBUF /' '/
      DATA      NPIX      /6*1/,       START /6*0.D0/, STEP /6*1.D0/
      DATA      NAME      /' '/,       INFRAM /' '/
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C  get into MIDAS
      CALL STSPRO('CHAOS')
C
C  get name and type of new frame and DEFAULT flag
      CALL STKRDC('IN_A',1,1,60,IAV,NAME,UNIT,NLO,STAT)
      CALL STKRDC('DEFAULT',1,1,1,IAV,DEFAUL,UNIT,NLO,STAT)
      CALL UPCAS(DEFAUL,DEFAUL)
C
C  image info from command line or reference frame
      IF (DEFAUL.NE.'Y') THEN
         CALL STKRDC('P3',1,1,60,IAV,INFRAM,UNIT,NLO,STAT)  !get ref. frame
C
C  read all relevant descriptors
         CALL STFOPN(INFRAM,D_OLD_FORMAT,0,F_IMA_TYPE,RNO,STAT)
         CALL STDRDI(RNO,'NAXIS',1,1,IAV,NAXIS,UNIT,NLO,STAT)
         CALL STDRDI(RNO,'NPIX',1,NAXIS,IAV,NPIX,UNIT,NLO,STAT)
         CALL STDRDD(RNO,'START',1,NAXIS,IAV,START,UNIT,NLO,STAT)
         CALL STDRDD(RNO,'STEP',1,NAXIS,IAV,STEP,UNIT,NLO,STAT)
         CALL STDRDC(RNO,'IDENT',1,1,72,IAV,IDENT,UNIT,NLO,STAT)
         CALL STDRDC(RNO,'CUNIT',1,1,112,IAV,CUNIT,UNIT,NLO,STAT)
      ELSE
C
C     get NAXIS, NPIX, START + STEP (max 6 dimensions)
         CALL STKRDI('INPUTI',1,7,IAV,IBUF,UNIT,NLO,STAT)
         CALL STKRDD('INPUTD',1,12,IAV,DBUF,UNIT,NLO,STAT)
C
C     set descriptor values
         NAXIS = IBUF(1)
         IF ((NAXIS.LT.1).OR.(NAXIS.GT.6))
     +      CALL STETER(1,'invalid NAXIS ...')      !invalid NAXIS ...
C
         DO 800 N=1,NAXIS
            NPIX(N) = IBUF(N+1)
            START(N) = DBUF(N)
            STEP(N) = DBUF(N+NAXIS)
800      CONTINUE
      ENDIF
C
C  finally look for coefficients + function type
      CALL STKRDC('P4',1,1,4,IAV,FUNCY,UNIT,NLO,STAT)
      CALL UPCAS(FUNCY,FUNCY)
      CALL STKRDC('P5',1,1,60,IAV,CBUF,UNIT,NLO,STAT)
C
      IDENT = 'artificial image '
      CUNLEN = (NAXIS+1)*16
C
C  create new frame
      CALL STIPUT(NAME,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +            NAXIS,NPIX,START,STEP,IDENT,
     +            CUNIT(1:CUNLEN),PNTR,INO,STAT)
      NO = NPIX(1) * NPIX(2)
      CALL NL(MADRID(PNTR),NO)                   !set everything to 0.0
C
C  branch according to function type
C 
C
      NPIX1  =  NPIX(1)
      NPIX2  =  NPIX(2)
C  Lorenz attractors
      IF (FUNCY(1:2).EQ.'LO') THEN
         CALL GENCNV(CBUF,2,7,IDUM,COEFS,DDUM,NCOEF) !x,y,z + h,a,b + no_iter
         IF (NCOEF.LT.6) 
     +      CALL STETER(1,'we need 6 coefficients...')
         IF (NCOEF.LT.7) COEFS(7) = 4000.
         CALL LOR(MADRID(PNTR),NPIX1,NPIX2,COEFS,FMIN,FMAX,
     +                                              START,STEP)   
C 
C  chaotic dynamic system  - Electronic Fly)
      ELSE IF (FUNCY(1:3).EQ.'ELF') THEN
         CALL GENCNV(CBUF,2,6,IDUM,COEFS,DDUM,NCOEF)    !a,b,c,d,e + no_iter
         IF (NCOEF.LT.5) 
     +      CALL STETER(1,'we need 5 coefficients...')
         IF (NCOEF.LT.6) COEFS(6) = 1000000.
         CALL ELFLY(MADRID(PNTR),NPIX1,NPIX2,COEFS,FMIN,FMAX,
     +                                               START,STEP)  
C 
C  Mandelbrot set
      ELSE IF (FUNCY(1:1).EQ.'M') THEN
         CALL GENCNV(CBUF,4,3,IDUM,RDUM,DCOEFS,NCOEF)    !x,y + no_iter
         IF (NCOEF.LT.2) 
     +      CALL STETER(1,'we need 2 coefficients...')
         IF (NCOEF.LT.3) DCOEFS(3) = 100.
         CALL MANDEL(MADRID(PNTR),NPIX1,NPIX2,START,STEP,DCOEFS,
     +               FMIN,FMAX)
C 
C  Julia set
      ELSE IF (FUNCY(1:1).EQ.'J') THEN
         CALL GENCNV(CBUF,4,3,IDUM,RDUM,DCOEFS,NCOEF)    !x,y + no_iter
         IF (NCOEF.LT.2) 
     +      CALL STETER(1,'we need 2 coefficients...')
         IF (NCOEF.LT.3) DCOEFS(3) = 100.
         CALL JULIA(MADRID(PNTR),NPIX1,NPIX2,START,STEP,DCOEFS,
     +              FMIN,FMAX)
C 
C  Colour wheel
      ELSE IF (FUNCY(1:3).EQ.'COL') THEN
         CALL COLWH(MADRID(PNTR),NPIX1,NPIX2,FMIN,FMAX)
C 
C  Symmetric chaos
      ELSE IF (FUNCY(1:3).EQ.'SYM') THEN
         CALL GENCNV(CBUF,2,7,IDUM,COEFS,DDUM,NCOEF)            !a,b,c,d
         CALL SYM(MADRID(PNTR),NPIX1,NPIX2,COEFS,FMIN,FMAX)
C 
      ELSE
         CALL STETER(9,'invalid function...')
      ENDIF
C
C  update cuts
      CUTS(1) = 0.
      CUTS(2) = 0.
      CUTS(3) = FMIN
      CUTS(4) = FMAX
      CALL STDWRR(INO,'LHCUTS',CUTS,1,4,UNIT,STAT)
C     
      IF (FUNCY(1:2).EQ.'LO') THEN
         CUNIT(1:) = 'Lorenz: '//CBUF
      ELSE IF (FUNCY(1:3).EQ.'ELF') THEN
         CUNIT(1:) = 'ElFly: '//CBUF
      ELSE IF (FUNCY(1:1).EQ.'M') THEN
         CUNIT(1:) = 'Mandelbrot set: '//CBUF
      ELSE IF (FUNCY(1:1).EQ.'J') THEN
         CUNIT(1:) = 'Julia set: '//CBUF
      ELSE IF (FUNCY(1:3).EQ.'COL') THEN
         CUNIT(1:) = 'Colour wheel '
      ELSE IF (FUNCY(1:3).EQ.'SYM') THEN
         CUNIT(1:) = 'Symmetric chaos: '//CBUF
      ENDIF
      CALL STDWRC(INO,'HISTORY',1,CUNIT,1,80,UNIT,STAT)
C
C  that's it folks...
      CALL STSEPI
      END

      SUBROUTINE LOR(A,NPIX1,NPIX2,RR,FMI,FMA,START,STEP)
C 
      IMPLICIT NONE
C 
      INTEGER   NPIX1,NPIX2
      INTEGER   ITLIM,N,NX,NY
      DOUBLE PRECISION  START(2), STEP(2)
C 
      REAL      A(NPIX1,NPIX2),RR(*),FMI,FMA
      REAL      X,Y,Z,XNEW,YNEW,ZNEW,H,AAAA,FRAC
      REAL      XXMIN,XXMAX,YYMIN,YYMAX
      REAL      XINC,YINC,XXX,YYY
C 
      XXMIN = START(1)
      XXMAX = START(1)+NPIX1*STEP(1)
      YYMIN = START(2)
      YYMAX = START(2)+NPIX2*STEP(2)
      XINC  = 1./STEP(1)
      YINC  = 1./STEP(2)
C 
      X = RR(1)
      Y = RR(2)
      Z = RR(3)
      H = RR(4)
      AAAA = RR(5)
      FRAC = RR(6)
      ITLIM = INT(RR(7)+0.5)
C 
      DO 1000 N=1,ITLIM
         XNEW = X + H*10.*(Y-X)
         YNEW = Y + H*((-X*Z)+AAAA*X-Y)
         ZNEW = Z + H*(X*Y-FRAC*Z)
         X = XNEW
         Y = YNEW
         Z = ZNEW
         IF ( (X.GE.XXMIN) .AND. (X.LE.XXMAX) .AND.
     +        (Y.GE.YYMIN) .AND. (Y.LE.YYMAX) ) THEN
            XXX = (X - XXMIN) * XINC
            YYY = (Y - YYMIN) * YINC
            NX = INT(XXX+0.5)
            NY = INT(YYY+0.5)
            A(NX,NY) = 1.0
         ENDIF
1000  CONTINUE
C 
      FMI = 0.
      FMA = 1.
C 
      RETURN
      END

      SUBROUTINE NL(A,NSIZE)
C 
      IMPLICIT NONE
C 
      INTEGER  NSIZE,N
C 
      REAL  A(NSIZE)
C 
      DO 500 N=1,NSIZE
         A(N) = 0.
500   CONTINUE
C 
      RETURN
      END

      SUBROUTINE ELFLY(A,NPIX1,NPIX2,RR,FMI,FMA,START,STEP)
C 
      IMPLICIT NONE
C 
      INTEGER   NPIX2,NPIX1
      INTEGER   ITLIM,N,NX,NY
      DOUBLE PRECISION START(2), STEP(2)
C 
      REAL      A(NPIX1,NPIX2),RR(*),FMI,FMA
      REAL      AA,BB,CC,DD,EE
      REAL      XXMIN,XXMAX,YYMIN,YYMAX
      REAL      XINC,YINC,X,Y,Z,X1,Y1,Z1,XXX,YYY
C 
      AA = RR(1)
      BB = RR(2)
      CC = RR(3)
      DD = RR(4)
      EE = RR(5)
      ITLIM = INT(RR(6)+0.5)
C 
      XXMIN = START(1)
      XXMAX = START(1)+NPIX1*STEP(1)
      YYMIN = START(2)
      YYMAX = START(2)+NPIX2*STEP(2)
      XINC  = 1./STEP(1)
      YINC  = 1./STEP(2)
      X = 0.                            !start wit (0.,0.,0.)
      Y = 0.
      Z = 0.
C 
      DO 1000 N=1,ITLIM
         X1 = SIN(AA*Y) - Z*COS(BB*X)
         Y1 = Z*SIN(CC*X) - COS(DD*Y)
         Z1 = EE*SIN(X)
         X = X1
         Y = Y1
         Z = Z1
         IF ( (X.GE.XXMIN) .AND. (X.LE.XXMAX) .AND.
     +        (Y.GE.YYMIN) .AND. (Y.LE.YYMAX) ) THEN
            XXX = (X - XXMIN) * XINC
            YYY = (Y - YYMIN) * YINC
            NX = INT(XXX+0.5)
            NY = INT(YYY+0.5)
            A(NX,NY) = A(NX,NY) + 1.0
C            IF (A(NX,NY).GT.FMA) FMA = A(NX,NY)
         ENDIF
1000  CONTINUE
C 
      FMI = 0.
      FMA = 10.
C 
      RETURN
      END

      SUBROUTINE MANDEL(OUT,NPIX1,NPIX2,START,STEP,DCOF,FMI,FMA)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.ALGORITHM
C  Mandelbrot set in the tranformation    z <- z*z + c
C  with z and c complex numbers
C  input is used as initial value for z, current (x,y) coord -> c
C 
C-------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER NPIX1,NPIX2,IX,IY
      INTEGER K,KUP
C
      REAL OUT(NPIX1,NPIX2)  
      REAL FMI,FMA
C
      DOUBLE PRECISION START(2)  
      DOUBLE PRECISION STEP(2)  
      DOUBLE PRECISION DCOF(3)
      DOUBLE PRECISION UPPER  
C  
      DOUBLE PRECISION DK,X1,Y1,X2,Y2,X,Y,DX,DY,R
C
      FMI = 0.
      FMA = 0.
      KUP = 256
      DX = STEP(1)
      DY = STEP(2)
      UPPER = DCOF(3)
C 
C  loop over all lines
      Y = START(2)
      DO 400 IY=1,NPIX2
         X = START(1)
C 
C  loop over all pixels of a line
         DO 300 IX=1,NPIX1
            X1 = DCOF(1)                      !Re(c) -> Re(z)
            Y1 = DCOF(2)                      !Im(c) -> Im(z)
C 
C  iterate over max 256 pixel levels
            DO 100 K=1,KUP
               X2 = (X1*X1) - (Y1*Y1) + X          !Re(z~) = Re(z*z) + Re(c)
               Y2 = 2.*(X1*Y1) + Y                 !Im(z~) = Im(z*z) + Im(c)
               R = X2*X2 + Y2*Y2                   !Abs(z~)
               IF (R.GT.UPPER) THEN
                  DK = K - 1
                  OUT(IX,IY) = DK
                  IF (DK.GT.FMA) FMA = DK
                  GO TO 200
               ENDIF
               X1 = X2
               Y1 = Y2
100         CONTINUE                !if we come out here, leave pixel at 0.0
C 
200         X = X + DX
300      CONTINUE
C 
         Y = Y + DY
400      CONTINUE
C 
      RETURN
      END


      SUBROUTINE SYM(OUT,NPIX1,NPIX2,COF,FMI,FMA)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.ALGORITHM
C
C-------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER NPIX1,NPIX2,IX,IY
      INTEGER N,LIMIT
C
      REAL OUT(NPIX1,NPIX2)
      REAL FMI,FMA
      REAL COF(7)
C 
      DOUBLE PRECISION A,B,C,D,RFY,RFX,Z
      DOUBLE PRECISION X,Y,XX,YY,XXX,YYY,XN,YN
C
      X = COF(1)
      Y = COF(2)
      A = COF(3)
      B = COF(4)
      C = COF(5)
      D = COF(6)
      LIMIT = COF(7)
      RFX = NPIX1 - 1.
      RFY = NPIX2 - 1.
C
      DO 500, N=1,LIMIT
         XX = X * X
         XXX = XX * X
         YY = Y * Y
         YYY = YY * Y
         Z = B * (XX + YY)
         XN = A*X + B*X*(XX + YY) + C*(XXX-3.0*X*YY) + D*(XX-YY)
         YN = A*Y + B*Y*(XX + YY) + C*(3.0*XX*Y-YYY) - 2.0*D*X*Y
         X = XN
         Y = YN
         IX = (X*RFX) + 1
         IF (IX.LT.1) THEN
            IX = 1
         ELSE IF (IX.GT.NPIX1) THEN
            IX = NPIX1
         ENDIF
         IY = (Y*RFY) + 1
         IF (IY.LT.1) THEN
            IY = 1
         ELSE IF (IY.GT.NPIX2) THEN
            IY = NPIX2
         ENDIF
         OUT(IX,IY) = OUT(IX,IY) + 1.
500   CONTINUE
C 
      FMI = OUT(1,1)
      FMA = FMI
      DO 800, IY=1,NPIX2
         DO 700, IX=1,NPIX1
            IF (OUT(IX,IY).LT.FMI) THEN
               FMI = OUT(IX,IY)
            ELSE IF (OUT(IX,IY).GT.FMA) THEN
               FMA = OUT(IX,IY)
            ENDIF
700      CONTINUE
800   CONTINUE
C 
      RETURN
      END


      SUBROUTINE JULIA(OUT,NPIX1,NPIX2,START,STEP,DCOF,FMI,FMA)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.ALGORITHM
C  Julia set in the tranformation    z <- z*z + c
C  with z and c complex numbers
C  input -> c, current (x,y) coord are used as initial value for z
C 
C-------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER NPIX1,NPIX2,IX,IY
      INTEGER K,KUP
C
      REAL OUT(NPIX1,NPIX2)  
      REAL FMI,FMA
C
      DOUBLE PRECISION START(2)  
      DOUBLE PRECISION STEP(2)  
      DOUBLE PRECISION DCOF(3)
      DOUBLE PRECISION UPPER  
C  
      DOUBLE PRECISION DK,X1,Y1,X2,Y2,X,Y,DX,DY,R
C
      FMI = 0.
      FMA = 0.
      KUP = 256
      DX = STEP(1)
      DY = STEP(2)
      UPPER = DCOF(3)
C 
C  loop over all lines
      Y = START(2)
      DO 400 IY=1,NPIX2
         X = START(1)
C 
C  loop over all pixels of a line
         DO 300 IX=1,NPIX1
            X1 = X                      !xcoord -> Re(z)
            Y1 = Y                      !ycoord -> Im(z)
C 
C  iterate over max 256 pixel levels
            DO 100 K=1,KUP
               X2 = (X1*X1) - (Y1*Y1) + DCOF(1)       !Re(z~) = Re(z*z) + Re(c)
               Y2 = 2.*(X1*Y1) + DCOF(2)              !Im(z~) = Im(z*z) + Im(c)
               R = X2*X2 + Y2*Y2                   !Abs(z~)
               IF (R.GT.UPPER) THEN
                  DK = K - 1
                  OUT(IX,IY) = DK
                  IF (DK.GT.FMA) FMA = DK
                  GO TO 200
               ENDIF
               X1 = X2
               Y1 = Y2
100         CONTINUE                !if we come out here, leave pixel at 0.0
C 
200         X = X + DX
300      CONTINUE
C 
         Y = Y + DY
400      CONTINUE
C 
      RETURN
      END

      SUBROUTINE COLWH(A,NPIX1,NPIX2,FMIN,FMAX)
C 
      IMPLICIT NONE
C 
      INTEGER   NPIX1,NPIX2
      INTEGER   NX,NY,KX,KY
      INTEGER   MAXRAD,KOFF
C 
      REAL      PHI,R,X,Y
      REAL      A(1),FMIN,FMAX
C 
      FMIN = -3.2
      FMAX = 3.142
      KX = NPIX1/2
      KY = NPIX2/2
      MAXRAD = NINT(KX * 0.80)
      MAXRAD = MAXRAD * MAXRAD               !take square of radius
      KOFF = 0
C 
      DO 5000 NY=1,NPIX2
         Y = NY - KY
C 
         DO 4000 NX=1,NPIX1
            X = NX - KX
            R = X*X + Y*Y
            IF (R .GT. MAXRAD) THEN
               PHI = FMIN
            ELSE
               PHI = ATAN2(X,Y)
            ENDIF
            A(KOFF+NX) = PHI
4000     CONTINUE
         KOFF = KOFF + NPIX1
5000  CONTINUE
C 
      RETURN
      END

C @(#)tdregl.for	19.1 (ESO-DMD) 02/25/03 14:11:19
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.1  ESO-FORTRAN Conversion, AA  15:59 - 19 NOV 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION   program TDREGL
C
C.PURPOSE
C  execute the command
C  REGRESSION/LINEAR  table  y[,weight] x1,x2,x3... [f1,f2]
C
C.KEYWORDS
C  REGRESSION, TABLES
C
C.ALGORITHM
C  uses table interface routines
C
C.VERSION
C 020807	last modif
C 
C-----------------------------------------------------------
C
      SUBROUTINE TDREGL
      IMPLICIT NONE
C
      LOGICAL SEL,NEXT,NULL(10)
C
      INTEGER         IVAR(10),NVMAX
      INTEGER         NPAR,ISTAT,I,TID,NCOL,NROW,NSC1,NAC,NAR
      INTEGER         INDX,IW,LL,NAV,IND,IDEP,NIND,NN,I1,I2,NDEP,NTOT
      INTEGER         IROW,N1,J,IDX,STATUS
      INTEGER         PNEVAL, IPAR(13)
      INTEGER         INDEX, KNUL, KUN, TYPE
C
      DOUBLE PRECISION VAL(10),REGM(81),WM(10),TW,TOL,COE(9)
      DOUBLE PRECISION DPAR(20)
C
      REAL            F1,F2,SERR(9),RPAR(13)
C
      CHARACTER*80 TABLE
      CHARACTER*8  METHOD, FORM
      CHARACTER*17 COLUMN
      CHARACTER*80 LINE
      CHARACTER*64 SELE
      CHARACTER    CPAR*20
      CHARACTER*16 MSG
      CHARACTER*90 SDUM
C
       INCLUDE 'MID_INCLUDE:TABLES.INC'
       INCLUDE 'MID_INCLUDE:TABLED.INC'
      DATA           NVMAX/8/
      DATA           CPAR/' '/
      DATA           PNEVAL/4/
      DATA           MSG/'ERR:TREGRLINxxxx'/
C
C ... GET INPUT PARAMETERS
C
      CALL TDPGET(PNEVAL,NPAR,ISTAT)
      IF (ISTAT.NE.0) GO TO 80
      IF (NPAR.LT.3) THEN
          ISTAT  = ERRPAR
          GO TO 80
      END IF
      TABLE  = TPARBF(1)
      METHOD = 'LINEAR'
      DO 10 I = 1,81
          REGM(I) = 0.D0
   10 CONTINUE
      DO 20 I = 1,10
          WM(I)  = 0.D0
          NULL(I) = .FALSE.
   20 CONTINUE
      TW     = 0.D0
C
C ... INIT INPUT TABLE
C
      TID = -1
      CALL TBTOPN(TABLE,F_I_MODE,TID,ISTAT)
      IF (ISTAT.NE.0) GO TO 80
      CALL TBIGET(TID,NCOL,NROW,NSC1,NAC,NAR,ISTAT)
      IF (ISTAT.NE.0) GO TO 80
      CALL TDRSEL(TID,SELE,ISTAT)
C
C ... FIND COLUMNS WITH VARIABLES
C
      INDX   = INDEX(TPARBF(2),',')
      IF (INDX.EQ.0) THEN
          COLUMN = TPARBF(2)
          IW     = 0
      ELSE
          COLUMN = TPARBF(2) (INDX+1:)
          CALL TBCSER(TID,COLUMN,IW,ISTAT)
          IF (IW.EQ.-1) THEN
              ISTAT  = ERRPAR
              GO TO 80
          END IF
          CALL TBFGET(TID,IW,FORM,LL,TYPE,ISTAT)
          IF (TYPE.EQ.D_C_FORMAT) THEN
              ISTAT  = ERRFMT
              GO TO 80
          END IF
          COLUMN = TPARBF(2) (1:INDX-1)
      END IF
      CALL TBCSER(TID,COLUMN,IDEP,ISTAT)
      IF (IDEP.EQ.-1) THEN
          ISTAT  = ERRPAR
          GO TO 80
      END IF
      CALL TBFGET(TID,IDEP,FORM,LL,TYPE,ISTAT)
      IF (TYPE.EQ.D_C_FORMAT) THEN
          ISTAT  = ERRFMT
          GO TO 80
      END IF
      NIND   = 0
      LINE   = ' '
      LINE   = TPARBF(3)
      NN     = INDEX(LINE,' ') - 1
      I1     = 1
      SDUM   = LINE(1:NN)//','
   30 CONTINUE
      I2     = INDEX(SDUM,',') - 1
      SDUM(I2+1:I2+1) = ';'
      COLUMN = LINE(I1:I2)
      CALL TBCSER(TID,COLUMN,IND,ISTAT)
      IF (ISTAT.NE.0) GO TO 80
      IF (IND.EQ.-1) THEN
          ISTAT  = ERRPAR
          GO TO 80
      END IF
      CALL TBFGET(TID,IDEP,FORM,LL,TYPE,ISTAT)
      IF (TYPE.EQ.D_C_FORMAT) THEN
          ISTAT  = ERRFMT
          GO TO 80
      END IF
      NIND   = NIND + 1
      IVAR(NIND) = IND
      I1     = I2 + 2
      IF (I1.LT.NN) GO TO 30
      IF (NIND.GT.NVMAX) THEN
          ISTAT  = ERRPAR
          GO TO 80
      END IF
      NDEP   = NIND + 1
      IVAR(NDEP) = IDEP
      NTOT   = NDEP
C
C ... INCLUDE WEIGHTS
C
      IF (IW.EQ.0) THEN
          IW     = NDEP + 1
          VAL(IW) = 1.D0
      ELSE
          NTOT   = NTOT + 1
          IVAR(NTOT) = IW
          IW     = NTOT
      END IF
C
C ... ITERATE ON ROWS
C
      N1     = 0
      DO 60 IROW = 1,NROW
          CALL TBSGET(TID,IROW,SEL,ISTAT)
          IF (SEL) THEN
              CALL TBRRDD(TID,IROW,NTOT,IVAR,VAL,NULL,ISTAT)
              NEXT   = ( .NOT. NULL(1)) .AND. ( .NOT. NULL(2)) .AND.
     +                 ( .NOT. NULL(3)) .AND. ( .NOT. NULL(4)) .AND.
     +                 ( .NOT. NULL(5)) .AND. ( .NOT. NULL(6)) .AND.
     +                 ( .NOT. NULL(7)) .AND. ( .NOT. NULL(8)) .AND.
     +                 ( .NOT. NULL(9))
              IF (NEXT) THEN
                  N1     = N1 + 1
                  DO 50 I = 1,NDEP
                      WM(I)  = WM(I) + VAL(IW)*VAL(I)
                      DO 40 J = 1,NDEP
                          IDX    = (J-1)*NDEP + I
                          REGM(IDX) = REGM(IDX) + VAL(IW)*VAL(I)*VAL(J)
   40                 CONTINUE
   50             CONTINUE
                  TW     = TW + VAL(IW)
              END IF
          END IF
   60 CONTINUE
      IF (TW.LT.DBLE(NDEP+1)) THEN
          CALL STTPUT(' Error in no. of data...',ISTAT)
          GO TO 80
      END IF
C
C ... DO REGRESSION ANALYSIS
C
      CALL STKRDR('INPUTR',1,1,NAV,F1,KUN,KNUL,ISTAT)
      F2     = F1
      TOL    = 1.D-8
      CALL TDMLRG(REGM,NDEP,WM,TW,COE,SERR,F1,F2,TOL)
C
C ... COPY RESULT OF REGRESSION
C
      DO 65 I = 1, 20
        DPAR(I) = 0.D0
65    CONTINUE
      CPAR(9:16) = TABLE
      CPAR(17:20) = 'LINE'
      IPAR(1) = N1
      IPAR(2) = NIND
      IPAR(3) = IDEP
      RPAR(1) = 0.
      RPAR(2) = 0.
      RPAR(3) = SERR(NDEP)
      DPAR(1) = COE(NDEP)
      DO 70 I = 1,NIND
          IPAR(3+I) = IVAR(I)
          RPAR(3+I) = SERR(I)
          DPAR(1+I) = COE(I)
   70 CONTINUE
      CALL STKWRC('OUTPUTC',1,CPAR,1,20,KUN,ISTAT)
      CALL STKWRI('OUTPUTI',IPAR,1,13,KUN,ISTAT)
      CALL STKWRR('OUTPUTR',RPAR,1,13,KUN,ISTAT)
      CALL STKWRD('OUTPUTD',DPAR,1,20,KUN,ISTAT)
C
C ... PRINT RESULT
C
      IF (SELE(1:1).NE.'-') THEN
          LINE   = ' SELECT  '//SELE
          CALL STTPUT(LINE,ISTAT)
      END IF
      CALL TDRDS1(CPAR,IPAR,RPAR,DPAR,ISTAT)
      IF (ISTAT.NE.0) GO TO 80
C
C ... end
C
      CALL DSCUPT(TID,TID,' ',ISTAT)
      CALL TBTCLO(TID,ISTAT)
   80 IF (ISTAT.NE.0) THEN
          WRITE (MSG(13:16),9000) ISTAT
          CALL TDERRR(ISTAT,MSG,STATUS)
      END IF
      RETURN
 9000 FORMAT (I4)
      END

C @(#)tstest.for	19.1 (ESO-DMD) 02/25/03 13:21:26
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  5 JUL 1989
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: M.PERON
C
C.IDENTIFICATION
C
C  Program TSTEST
C
C.KEYWORDS
C
C means,Student
C
C.PURPOSE
C
C   Student-T Test for different means 
C
C.REFERENCES  Numerical Recipes p465
C 
C  010621		last modif
C 
C-----------------------------------------------------------
C
       PROGRAM TSTEST
C 
       REAL*4 T,PROB
C 
       INTEGER*8  ADDRIN(2)
C 
       INTEGER MADRID
       INTEGER PARVAL,NPAR,ISTAT,TID,NCOL,NROW,NACOL,NAROW,COL1,COL2
       INTEGER NBYTES,NSC,KUN,NREAL
C 
       CHARACTER*80 INTAB,OUTPUT1,OUTPUT2,OUT,OUTPUT3,OUTPUT0
       CHARACTER*17 COLIND,COLDEP
C 
       INCLUDE 'MID_INCLUDE:TABLES.INC'
       COMMON/VMR/MADRID(1)
C 
       INCLUDE 'MID_INCLUDE:TABLED.INC'
       DATA PARVAL/8/
       DATA OUTPUT0
     1   /'Null Hypothesis:The two samples have consistent means'/
       DATA OUTPUT1
     1    /'Student-t Statistic '/
       DATA OUTPUT2
     2    /'---------------------------------------------------------'/
       DATA OUTPUT3
     3  /' Probability of exceeding this value under Null Hypothesis'/
C 
C 
       CALL STSPRO('TSTEST')
       CALL TDPGET(PARVAL,NPAR,ISTAT)
       IF  (ISTAT.NE.0) GOTO 80
       INTAB = TPARBF(1)
       COLIND = TPARBF(2)
       COLDEP = TPARBF(3)
       CALL TBTOPN(INTAB,F_U_MODE,TID,ISTAT)       
       IF(ISTAT.NE.0) GOTO 80
       CALL TBIGET(TID,NCOL,NROW,NSC,NACOL,NAROW,ISTAT)
        CALL TBCSER(TID,COLIND,COL1,ISTAT)
         IF (COL1.LT.0) THEN
         CALL STTPUT('Column not found...',ISTAT)
          GOTO 80
        ENDIF
        CALL TBCSER(TID,COLDEP,COL2,ISTAT)
        IF (COL2.LT.0) THEN
          CALL STTPUT('Column not found...',ISTAT)
          GOTO 80
        ENDIF
       NBYTES = 4*NROW
       CALL TDMGET(NBYTES,ADDRIN(1),ISTAT)
       CALL TDMGET(NBYTES,ADDRIN(2),ISTAT)
       CALL TMAP2(TID,NROW,COL1,COL2,MADRID(ADDRIN(1)),
     1                MADRID(ADDRIN(2)),NREAL)
       CALL TTEST(MADRID(ADDRIN(1)),MADRID(ADDRIN(2)),NREAL,T,PROB)
       WRITE(OUT,100)T
       CALL STTPUT(OUTPUT0,ISTAT)
       CALL STTPUT(OUTPUT2,ISTAT)
       CALL STTPUT(OUTPUT1,ISTAT)
       CALL STTPUT(OUT,ISTAT)
       CALL STTPUT(OUTPUT2,ISTAT)
       CALL STTPUT(OUTPUT3,ISTAT)
       WRITE(OUT,100)PROB
       CALL STTPUT(OUT,ISTAT)
       CALL STTPUT(OUTPUT2,ISTAT)
       CALL STKWRR('OUTPUTR',T,1,1,KUN,ISTAT)
       CALL STKWRR('OUTPUTR',PROB,2,1,KUN,ISTAT)
80        CONTINUE
       CALL STSEPI
C 
100     FORMAT(1X,G15.6,15X,G15.6)
       END       



       SUBROUTINE TTEST(DATA1,DATA2,NROW,T,PROB)
       INTEGER NROW
       REAL*4 DATA1(NROW),DATA2(NROW),T,PROB
       REAL*4 AVE1,AVE2,VAR,VAR1,VAR2,DF,BETAI
       CALL AVEVAR(DATA1,NROW,AVE1,VAR1)
       CALL AVEVAR(DATA2,NROW,AVE2,VAR2)
       DF = 2*NROW-2
       VAR = ((NROW-1)*VAR1+(NROW-1)*VAR2)/DF
       T = (AVE1-AVE2)/SQRT(VAR*(1./NROW+1./NROW))
       PROB = BETAI(0.5*DF,0.5,DF/(DF+T**2))
       RETURN
       END

C @(#)plotlyman.for	19.1 (ESO-IPG) 02/25/03 13:28:05

C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C       Internet e-mail: midas@eso.org
C       Postal address: European Southern Observatory
C                       Data Management Division 
C                       Karl-Schwarzschild-Strasse 2
C                       D 85748 Garching bei Muenchen 
C                       GERMANY
C===========================================================================
C
C

      program plotlyman
      
      implicit none
      include 'MID_REL_INCL:fit_var.inc'
      
                                ! copies of keywords coming from line
      character*80 SPESYS,SESSYS

      character*70 sjunk


      integer ist,i,ijk,iok

C      include 'MID_REL_INCL:fit_mid.inc'
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'

C!!!!!!!
C     MIDAS SET-UP
C!!!!!!!
      call STSPRO('fitlyman')
      
      call STKRDC('SPECTAB',1,1,80,i,SPESYS,ijk,ijk,iok)
      if (iok.ne.0) then
         call ErrMsg('Error in reading keywords: check context..')
         call STSEPI() 
         stop
      end if   
      call STKRDC('SESSNAM',1,1,80,i,SESSYS,ijk,ijk,iok)
      if (iok.ne.0) then
         call ErrMsg('Error in reading keywords: check context..')
         call STSEPI() 
         stop
      end if   



      call DisMsg('Loading data...')
      call DisMsg('Wait please..')
      
C!!!!!!!
C     Inizializzazione programma
C!!!!!!!
      if (SESSYS.ne.'NULL') then
         i=index(SESSYS,' ')
         sjunk=SESSYS(1:i-1)//PARTBL
      else
         sjunk=PARTBL
      end if
      call rsetup(sjunk,ist)  ! read set-up 

      if (ist.ne.0) then        ! on error, default values
         call WrnMsg('Error in reading set-up: using defaults')
                                ! copy syskeys into variables
         if (SPESYS.ne.'NULL') then
            FILSPE=SPESYS
         else
           call ErrMsg('Missing input parameters: check line command')
           call STSEPI() 
           stop
         end if   

c         call F_TBLR('SCRATCH',1,ist) !initializes lypar (in memory!)

      else

c         call f_tblr(sjunk,1,ist) !read init. param.
         if (SPESYS.ne.'NULL') FILSPE=SPESYS ! overrides values read
         
      end if

      i_grap = .true.

      NPUNTI=NMXSPE
      call reaspe(FILSPE,NPUNTI)    !read spectrum
      if (NPUNTI.lt.1) then
         call STSEPI() 
         stop
      endif
      call AtmRD(ist)           !read atompar.dat
   
      call GraMai(ist)          ! plot 
      call ssetup(sjunk,ist)    ! saves set-up 



      call STSEPI()

      end
      

C @(#)mltobj.for	19.1 (ES0-DMD) 02/25/03 13:25:36
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C.INPUT/OUTPUT
C  Input arguments
C  A        real*4 array        image buffer
C  JAPY     integer*4 array     pointers to buffer lines
C  IBUF     integer*4 array     limits of image buffer
C  JBE      integer*4           end of buffer
C  IXYU     integer*4 array     limits of used area
C  NC       integer*4           number of entries in catalog buffer
C  MCAT     integer*4 array     integer detections buffer
C  BCAT     real*4 array        real detections buffer
C  NL       integer*4           number of entries in detections buffer
C  M        integer*4           number of detections
C  MMB      integer*4           position in buffer
C  MOB      integer*4           buffer offset
C  IARR     integer*4 array     integer parameters
C  RARR     ral*4 array         real parameters
C  output parameters
C  ACAT     real*4 array        objects buffer
C  MM       integer*4           number of objects
C
C-----------------------------------------------------------------------
      SUBROUTINE MLTOBJ ( A , JAPY , IBUF , JBE , IXYU , ACAT , NC ,
     &            MCAT , BCAT , NL , M , MM , MMB , MOB , IARR , RARR )
C
      IMPLICIT NONE
      INTEGER   NC , NL, ISTAT
C
      INTEGER   IARR(32) , IAV , IAV1 , IAV2 , IBUF(4) , IDPM(5)
      INTEGER   II , II1 , II2 , IM , ISIZ , IXYU(4)
      INTEGER   JAPY(1) , JAV , JAV1 , JAV2 , JBE
      INTEGER   JJ , JJ1 , JJ2 , JM , JOFF
      INTEGER   M , MCAT(4,NL) , MINCR , MM , MMB , MOB
C
      REAL   A(1) , ACAT(5,NC) , ADLM
      REAL   AVBG , AVI , AVII , AVIJ , AVJ , AVJJ , AVM
      REAL   BCAT(2,NL) , GCUT , RARR(64)
      REAL   ELON , TEMP , THETA , TRLM , TRSH
C
      LOGICAL   OBJECT , SINGLE , UNUSED
C
      CHARACTER*80  TEXT
C
      JOFF = IBUF(2) - 1
      GCUT = 0.9 * RARR(2)
      TRSH = RARR(3)
      ADLM = RARR(42)
      MINCR = IARR(22)
C
C ******      Calculate parameters for multiple detection.
C
      OBJECT = .FALSE.
      SINGLE = .TRUE.
      CALL MLTDET( MCAT , BCAT , NL , M , MOB , AVI , AVJ , AVII ,
     &            AVIJ , AVJJ , AVBG , IM , JM , AVM , ISIZ , OBJECT )
      IF ( .NOT. OBJECT ) THEN
          RETURN
      ENDIF
C
C ******      Check if object is elongated.
C
      CALL OBJSHP( AVI , AVJ , AVII , AVIJ , AVJJ , ELON , THETA )
      IF ( ELON .LT. RARR(44) ) THEN
C
C ******          One object is catalogued.
C
          IF ( MMB .EQ. NC ) THEN
              WRITE (TEXT,'(A)') 'Too many detections'
              CALL STTPUT(TEXT,ISTAT)
c             CALL CTLG( ITF , START , STEP , ACAT , NC , MM , MMB )
c             MMB = 0
          ENDIF
          MMB = MMB + 1
          MM = MM + 1
          IF ( AVM .GT. (RARR(2)-AVBG)/1.1 ) THEN
              IM = NINT(AVI)
              JM = NINT(AVJ)
          ELSE
              AVI = FLOAT(IM)
              AVJ = FLOAT(JM)
          ENDIF
          ACAT(1,MMB) = AVI
          ACAT(2,MMB) = AVJ
          ACAT(3,MMB) = AVBG
          ACAT(4,MMB) = AVM
          TRLM = AVBG + TRSH
          CALL RADDET( A , JAPY , IBUF , IM , JM ,
     &                 IARR(22) , TRLM , AVM , TRSH , ACAT(5,MMB) )
          IF ( ACAT(5,MMB) .LE. 0.0 .AND. AVM .LT. GCUT ) THEN
              MMB = MMB - 1
              MM = MM - 1
          ENDIF
      ELSE
C
C ******          Try to find two objects.
C
          UNUSED = .TRUE.
          CALL DOUBLE( A , JAPY , JOFF , JBE , IXYU , IARR(8) ,
     &                  AVBG , AVI , AVJ , THETA , ISIZ , RARR(42) ,
     &                       RARR(45) , RARR(46) , RARR(3) , IDPM )
          AVI = AVI - 0.001
          AVJ = AVJ - 0.001
C
C ******          Array IDPM contains informations
C ******          about double components.
C
          IF ( IDPM(1) .EQ. 2 ) THEN
              IAV1 = NINT( AVI + IDPM(2) )
              JAV1 = NINT( AVJ + IDPM(3) )
              IF ( MAX( ABS(IAV1-IM) , ABS(JAV1-JM) ) .LE. 2 ) THEN
                  IAV1 = IM
                  JAV1 = JM
                  UNUSED = .FALSE.
              ENDIF
              IF ( IAV1 .GE. IARR(12) .AND. IAV1 .LE. IARR(14)
     &                  .AND. JAV1 .GE. IARR(13) .AND. JAV1 .LE.
     &                                          IARR(15) ) THEN
C
C ******                Subroutine DOUBLE has produced
C ******                at least one new position.
C
                  CALL OBJMNG( A , JAPY , IBUF , ACAT , NC ,
     &                         MM , MMB , IAV1 , JAV1 , AVBG ,
     &                         TRSH , GCUT , MINCR )
                  SINGLE = .FALSE.
                  IAV2 = NINT( AVI + IDPM(4) )
                  JAV2 = NINT( AVJ + IDPM(5) )
                  IF ( UNUSED .AND. MAX( ABS(IAV2-IM) , ABS(JAV2-JM) )
     &                                          .LE. 2 ) THEN
                      IAV2 = IM
                      JAV2 = JM
                  ELSE
                      TEMP = A(JAPY(JAV2-JOFF)+IAV2)
                      II1 = MAX( IAV2-2 , IBUF(1) )
                      II2 = MIN( IAV2+2 , IBUF(3) )
                      JJ1 = MAX( JAV2-2 , IBUF(2) )
                      JJ2 = MIN( IAV2+2 , IBUF(4) )
                      DO 10 JJ = JJ1 , JJ2
                          DO 20 II = II1 , II2
                              IF ( A(JAPY(JJ-JOFF)+II) .GT. TEMP )
     &                                                THEN
                                  IAV2 = II
                                  JAV2 = JJ
                                  TEMP = A(JAPY(JJ-JOFF)+II)
                              ENDIF
   20                     CONTINUE
   10                 CONTINUE
                  ENDIF
                  TEMP = SQRT( FLOAT( (IAV1-IAV2)*(IAV1-IAV2) +
     &                                   (JAV1-JAV2)*(JAV1-JAV2) ) )
                  IF ( TEMP .GE. ADLM .AND. IAV2 .GE. IARR(12) .AND.
     &                   IAV2 .LE. IARR(14) .AND. JAV2 .GE. IARR(13)
     &                                .AND. JAV2 .LE. IARR(15) ) THEN
C
C ******                  Fainter component is catalogued.
C
                       CALL OBJMNG( A , JAPY , IBUF , ACAT , NC ,
     &                              MM , MMB , IAV2 , JAV2 , AVBG ,
     &                              TRSH , GCUT , MINCR )
                       SINGLE = .FALSE.
                   ENDIF
               ENDIF
          ELSE IF ( IDPM(1) .EQ. 1 ) THEN
              SINGLE = .TRUE.
          ENDIF
          IF ( SINGLE ) THEN
C
C ******            Is case that subroutine DOUBLE has
C ******            produced no acceptable position
C ******            of an object, the highest out of
C ******            multiple detection is catalogued.
C
               IF ( AVM .LE. (RARR(2)-AVBG)/1.1 ) THEN
                   IAV = IM
                   JAV = JM
               ELSE
                   IAV = NINT(AVI)
                   JAV = NINT(AVJ)
               ENDIF
               CALL OBJMNG( A , JAPY , IBUF , ACAT , NC ,
     &                      MM , MMB , IAV , JAV , AVBG ,
     &                      TRSH , GCUT , MINCR )
          ENDIF
      ENDIF
C
      RETURN
C
      END

C @(#)rfotselect.for	19.1 (ES0-DMD) 02/25/03 13:30:15
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
       PROGRAM SELECT
C++
C.IDENTIFICATION: RFOTSELECT
C.PURPOSE: Select objects from a displayed frame and stored them in an
C          intermediate table
C.AUTHOR:  R. Buonanno, G. Buscema, C. Corsi, I. Ferraro, G. Iannicola
C          Osservatorio Astronomico di Roma
C.VERSION: 870417  First running version at ESO (outside MIDAS)   R. Buonanno
C.         881031  New version                                    R. Buonanno
C.         890220  Major changes for portable MIDAS               R.H. Warmels
C.                 load of frame done by LOAD/IMAGE
C.                 cursor interaction with GETCURS
C----
      IMPLICIT         NONE
      INCLUDE          'MID_REL_INCL:RFOTDECL.INC/NOLIST'
C
C     INTEGER          AREA(4)
      INTEGER          CCOUNT,COOFF
      INTEGER          EC, ED, EL
      INTEGER          IWND(2)    
      INTEGER          IVX(9)
      INTEGER*8        IPNTR
      INTEGER          IMF
      INTEGER          I, IT, INX
      INTEGER          IAC, ICOM, IROW, IDUM
      INTEGER          ISTAT,ISTAT1,ISTAT2
      INTEGER          J
      INTEGER          KUN, KNUL, KL
      INTEGER          KDX, KDY
      INTEGER          LX1, LY1
      INTEGER          LX, LY
      INTEGER          MADRID(1)
      INTEGER          NPIX(3)
      INTEGER          NC, NLIV
      INTEGER          NCP,NHL, NCH
      INTEGER          NAXIS, NPL,NL
      INTEGER          XY1,XY2
C
      REAL             AL
      REAL             BB, B1
      REAL             DIMX, DIMY
      REAL             FPIX1(2),FPIX2(2)
      REAL             FG, FO1
      REAL             H1
      REAL             PAR(4)
      REAL             PARS(4)
      REAL             RINPUT(4)
      REAL             RX(100),RY(100)
      REAL             RINTD1, RINTD2, RINTD3, RINTD4
      REAL             RINTD5, RINTD6, RINTD7
      REAL             RME
      REAL             SQR, SQM
      REAL             SL
      REAL             X1, Y1
      REAL             VET(100)
      REAL             VALUE1,VALUE2
      REAL             VME
      REAL             UU, U1
      REAL             VV
      REAL             WC01(2),WC02(2)
C
      DOUBLE PRECISION BEGIN(3),STEP(3),DDUM
C
      LOGICAL          NUL
     
      CHARACTER*60     FRAME
      CHARACTER*72     CUNIT
      CHARACTER*80     IDENT
      CHARACTER*60     INTFIL
      CHARACTER*3      ACTION
      CHARACTER*80     STRING
      CHARACTER*60     CINPUT
C
C *** this part into the common blocks
      INTEGER          NCINT, NRINT, NSINT, NACINT, NARINT
      INTEGER          TIDINT
      INTEGER          NGRP, NOBJ, NINT
C 
      INCLUDE          'MID_INCLUDE:IDIMEM.INC'
      INCLUDE          'MID_INCLUDE:IDIDEV.INC'
      INCLUDE          'MID_INCLUDE:ST_DEF.INC'
      COMMON           /VMR/MADRID
      INCLUDE          'MID_INCLUDE:ST_DAT.INC'
C
      DATA             IVX/1,2,3,4,5,6,7,8,9/
      DATA             NCP/1/
      DATA             NHL/0/
C
 9001 FORMAT('*** INFO: Intermediate table contains', I5,
     2       ' groups with ',I5,' components')
 9004 FORMAT('          table will be appended')
 9003 FORMAT('Enter identification, mag., col1 and col2 [',I6,
     2       ',0.0,0.0,0.0]: ')
C
C *** start the code
      CALL STSPRO('SELECT')
C
C *** input parameters
      CALL STKRDC('IN_A',1,1,60,IAC,FRAME,KUN,KNUL,ISTAT)      ! name of image
      CALL STIGET(FRAME,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     2             2,NAXIS,NPIX,BEGIN,STEP,IDENT,CUNIT,IPNTR,IMF,ISTAT)
      NPL = NPIX(1)
      NL  = NPIX(2)
C
C *** get the intemediate file name
      CALL STKRDC('OUT_A',1,1,60,IAC,INTFIL,KUN,KNUL,ISTAT)   ! intermediate file
C
C *** open or create the intermediate table
      CALL STECNT('GET',EC,ED,EL)
      CALL STECNT('PUT',1,0,0)
      CALL TBTOPN(INTFIL,F_IO_MODE,TIDINT,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** INFO: Intermediate table not present; '//
     2            'will create a new one ...'
         IDNGRP = 0
         NGRP   = 0
         NOBJ   = 0
         IROW   = 0
         CALL STTPUT(STRING,ISTAT)
         CALL INTINI(INTFIL,TIDINT)

      ELSE
         CALL TBIGET(TIDINT,NCINT,NRINT,NSINT,NACINT,NARINT,ISTAT)
         IF (ISTAT.NE.0) THEN
            STRING = '*** FATAL: Problems with getting info for '//
     2               'intermediate table ...'
           CALL STTPUT(STRING,ISTAT)
           CALL STSEPI
         ENDIF
C
         IF (NRINT.EQ.0) THEN
            STRING = '*** INFO: No points in the intermediate table'
            CALL STTPUT(STRING,ISTAT)
         ENDIF
C
C *** get the intermediate table parameters
         CALL INTDRD(TIDINT,NGRP,NOBJ,NINT,RINTD1,RINTD2,RINTD3,
     2                      RINTD4,RINTD5,RINTD6,RINTD7)
         IROW = NRINT                                   ! number of rows written
         WRITE(STRING,9001) NGRP,NOBJ
         CALL STTPUT(STRING,ISTAT)
         WRITE(STRING,9004)
         CALL STTPUT(STRING,ISTAT)
         CALL TBERDI(TIDINT,NRINT,1,IDNGRP,NUL,ISTAT)
      ENDIF
      CALL STECNT('PUT',EC,ED,EL)
C
C *** open the display device
      CALL DTOPEN(1,ISTAT)
C
C *** get the area
C     CALL STKRDC('INPUTC',1,1,40,IAC,STRING,KUN,KNUL,ISTAT)        ! user area
C     CALL EXTRCO(STRING,NAXIS,NPIX,BEGIN,STEP,NDUM,AREA(1),
C   2                   AREA(3),ISTAT)
C     IX0  = AREA(1)
C     IY0  = AREA(2)
C     NX   = AREA(3) - AREA(1) + 1
C     NY   = AREA(4) - AREA(2) + 1
C
C     IF (IX0.LT.1) IX0 = 1
C     IF (IY0.LT.1) IY0 = 1
C     IF ((IX0+NX-1).GT.NPL) NX = NPL-IX0+1
C     IF ((IY0+NY-1).GT.NL)  NY = NL-IY0+1
C     WRITE (STRING,9001) AREA(1),AREA(2),AREA(3),AREA(4)
C     CALL STTPUT(STRING,ISTAT)
C
C *** get the window size
      CALL STKRDI('INPUTI',1,2,IAC,IWND,KUN,KNUL,ISTAT)
      DIMX = FLOAT(IWND(1))
      DIMY = FLOAT(IWND(2))
      IF (DIMX.GT.55) THEN
         DIMX = 55
      ENDIF
      IF (DIMY.GT.55) THEN
         DIMY = 55
      ENDIF
      KDX = DIMX/2+1
      KDY = DIMY/2+1
C
C *** infinite loop for cursor interaction
      COOFF     = 0
      CCOUNT    = 0
      ACTION    = 'YYN'
      FRAME     = ' '
      FLGCMP(1) = 1
      CALL STTPUT('*** INFO: Use cursor control panel to '//
     2                       'select object',ISTAT)
C
 1000 CONTINUE
      IDNGRP = IDNGRP + 1
 1001 CONTINUE
      CALL GETCUR(ACTION,FRAME,XY1,FPIX1,WC01,VALUE1,ISTAT1,
     2                         XY2,FPIX2,WC02,VALUE2,ISTAT2)
      IF (ISTAT1.EQ.0 .AND. ISTAT2. EQ. 0) THEN
         IF (CCOUNT.EQ.0) THEN
            IF (COOFF.EQ.1) THEN
               CALL DTCLOS(QDSPNO)
               CALL STSEPI
            ELSE
      	       FRAME     = ' '
               CALL STTPUT('*** WARNING: Switch cursor on ...'//
     2                     ' next time we exit',ISTAT)
            ENDIF
            COOFF = 1
            GO TO 1001

         ELSE
            NINT   = 0
            RINTD1 = 15000.0
            RINTD2 = 1.
            RINTD3 = 3.
            RINTD4 = 4.
            RINTD5 = 0.0
            RINTD6 = 0.0
            RINTD7 = 0.0
            CALL INTDWR(TIDINT,NGRP,NOBJ,NINT,RINTD1,RINTD2,RINTD3,
     2                         RINTD4,RINTD5,RINTD6,RINTD7)
            CALL TBSINI(TIDINT,ISTAT)
            CALL TBTCLO(TIDINT,ISTAT)
            CALL DTCLOS(QDSPNO)
            CALL STSEPI
         ENDIF

      ELSE
         CCOUNT = 1
         LX     = INT(FPIX1(1))
         LY     = INT(FPIX1(2))
C
C  *** fit data
         AL     = 4*ALOG(2.)
         NC     = 0
         DO 110 J = 1,9
            RX(J) = 0
            RY(J) = 0
  110    CONTINUE
C
         H1 = -10.E15
         DO 120 I = LY-4,LY+4
            NC  = NC+1
            INX = LX-4
            CALL REALIN(NPL,NL,I,INX,9,MADRID(IPNTR),VET)
            RME = 0
C
            DO 121 J=1,9
               H1  = AMAX1(H1,VET(J))
               RME = RME+VET(J)
               RX(J) = RX(J)+VET(J)
  121       CONTINUE
            RY(NC) = RME/9.
  120    CONTINUE
C
         PAR(1) = 0.
         PAR(4) = 10.E15
         DO 130 J = 1,9
            RX(J) = RX(J)/9.
            IF (RX(J).GT.PAR(1)) THEN
               PAR(1) = RX(J)
               PAR(2)=J
            END IF
            IF (RX(J).LT.PAR(4)) PAR(4)=RY(J)
  130    CONTINUE
C
         PAR(1) = PAR(1)-PAR(4)
         KL     = PAR(2)
         VME    = (RX(KL-1)+RX(KL+1))/2.
         IF (VME.GE.PAR(1)) VME=PAR(1)/2.
         PAR(3) = SQRT(AL/ALOG(PAR(1)/VME))
         SQR    = 10.**15
         SL     = SQR
         IT     = 0
         NLIV   = 9
C
         DO 140 J = 1,4
            PARS(J)=PAR(J)
  140    CONTINUE

 2001    CONTINUE
            IF (SL.LE.0.0001.OR.IT.GT.20) GO TO 2000
            IT = IT+1
            CALL MONO4(IVX,RX,NLIV,PAR,.7)
            IF (PAR(1).LT..1 .OR. ABS(PAR(2)-PARS(2)).GT.4 .OR.
     2         PAR(3).LE.0. .OR. PAR(3).GT.20.) THEN
               DO 150 J=1,4
                  PAR(J) = PARS(J)
  150          CONTINUE
               GO TO 2000
            ENDIF
C
            SQM = 0.
            DO 160  I = 1,NLIV
               FG  = PAR(1)*EXP(-4*ALOG(2.)*((I-PAR(2))/PAR(3))**2)
               SQM = SQM+(RX(I)-FG-PAR(4))**2
  160       CONTINUE
            SQM    = SQRT(SQM/NLIV)
            SL     = ABS(SQR-SQM)/SQR
            SQR    = SQM
           GO TO 2001
 2000    CONTINUE

         X1     = PAR(2)+LX-5
         FO1    = PAR(4)
C 
         PAR(1) = 0
         PAR(4) = 10.E15
         DO 170  J=1,9
            IF (RY(J).GT.PAR(1)) THEN
               PAR(1) = RY(J)
               PAR(2) = J
            END IF
            IF (RY(J).LT.PAR(4)) THEN
               PAR(4) = RY(J)
            ENDIF
  170    CONTINUE
C
         PAR(1) = PAR(1)-PAR(4)
         KL     = PAR(2)
         VME    = (RY(KL-1)+RY(KL+1))/2.
         IF (VME.GE.PAR(1)) VME = PAR(1)/2.
         PAR(3) = SQRT(AL/ALOG(PAR(1)/VME))
         SQR    = 10.**15
         SL     = SQR
         IT     = 0
         NLIV   = 9
C
         DO 180 J = 1,4
            PARS(J) = PAR(J)
  180    CONTINUE
C
 3001    CONTINUE
            IF (SL.LE.0.0001.OR.IT.GT.20) GO TO 3000
            IT = IT+1
            CALL MONO4(IVX,RY,NLIV,PAR,.7)
            IF (PAR(1).LT..1 .OR. ABS(PAR(2)-PARS(2)).GT.4 .OR. 
     2          PAR(3).LE.0. .OR. PAR(3).GT.20.) THEN
               DO 190 J = 1,4
                  PAR(J) = PARS(J)
  190          CONTINUE
               GO TO 3000
            END IF
C
            SQM = 0.
            DO 200 I = 1,NLIV
               FG  = PAR(1)*EXP(-4*ALOG(2.)*((I-PAR(2))/PAR(3))**2)
               SQM = SQM+(RY(I)-FG-PAR(4))**2
  200       CONTINUE
C
            SQM = SQRT(SQM/NLIV)
            SL  = ABS(SQR-SQM)/SQR
            SQR = SQM
            GO TO 3001
 3000    CONTINUE
C
         Y1  = PAR(2)+LY-5
         FO1 = (FO1+PAR(4))/2.
         H1  = H1-FO1      
C
C *** legge magnitudine v , colori b-v e u-b e nome della
C     stella prescelta e li scrive sul file f
 3002    CONTINUE
         WRITE (STRING,9003) IDNGRP
         NCH = INDEX(STRING,':')+1               
         CINPUT = ' '
         CALL STKPRC(STRING(1:NCH),'INPUTC',1,1,60,IAC,CINPUT,
     2               KUN,KNUL,ISTAT)
         ICOM   = MIN(INDEX(CINPUT,',')-1,6)
         IF (ICOM.LE.0) THEN
            VV       = 0.0
            BB       = 0.0
            UU       = 0.0
         ELSE
            ICOM=4
            CALL GENCNV(CINPUT,2,ICOM,IDUM,RINPUT,DDUM,ISTAT)
C           CALL USRINP(RINPUT,4,'R',CINPUT)
C           ICOM = NEL(RINPUT,4)
            IF (ICOM.GT.0 .AND. ICOM.LT.4) THEN
               DO 3003 ICOM = ICOM+1, 4
                  RINPUT(ICOM) = 0.0
 3003          CONTINUE
            ENDIF
            IDNGRP= INT(RINPUT(1))
            IF (IDNGRP.GT.99999) THEN
               CALL STTPUT('*** WARNING: Group identification should'//
     2                     ' be less than 100000; try again ...',ISTAT)
               GO TO 3002

            ELSE
               VV     = RINPUT(2)
               BB     = RINPUT(3)
               UU     = RINPUT(4)
            ENDIF 
         ENDIF
C
C *** prepare the arrays for writting
         IDNGRP     = IDNGRP
         IDNCMP(1)  = 101
         IROW       = IROW + 1
         B1         = VV+BB
         U1         = B1+UU
         LX1        = BEGIN(1)+X1-KDX
         LY1        = BEGIN(2)+Y1-KDY
         PARINT(1)  = FLOAT(LX1)
         PARINT(2)  = FLOAT(LY1)
         PARINT(3)  = VV
         PARINT(4)  = B1
         PARINT(5)  = U1
         PARINT(6)  = DIMX
         PARINT(7)  = DIMY
         PARINT(8)  = 0.0
         PARINT(9)  = 0.0
         PARINT(10) = FO1
         PARINT(11) = 4.0
         PARINT(12) = 0.0
         PARINT(13) = 0.0
         PARINT(14) = 0.0
         PARINT(15) = NCP
         PARINT(16) = NHL
C
         FITCMP(1)  = H1
         FITCMP(2)  = FLOAT(KDX)
         FITCMP(3)  = FLOAT(KDY)
         FITCMP(4)  = 3.0
         FITCMP(5)  = 0.0
         FITCMP(6)  = 0.0
C           
         CALL INTWWR(TIDINT,IROW,NCP,NHL)
         NOBJ       = NOBJ + 1
         NGRP       = NGRP + 1
         GO TO 1000
      ENDIF

      CALL STSEPI
      END

C @(#)fromod.for	19.1 (ES0-DMD) 02/25/03 13:24:27
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT:      Copyright (c) 1989 European Southern Observatory,
C                                 all rights reserved
C.IDENTIFICATION: FROMOD
C.PURPOSE:        Part of ESOLV image retrieval software
C.AUTHOR:         J. Edwin Huizinga
C.LANGUAGE:       F77+ESOext
C.KEYWORDS:       ESOLV,optical-disk,retrieval
C.ALGORITHM:
C.INPUT/OUTPUT:   
C.VERSION:        890707 JEH creation
C ---------------------------------------------------------------------
      PROGRAM FROMOD
C
C this program takes selected entries from INPUT TABLE and compares
C them with the optical disk directory listings to see which 
C galaxies are on which disk. For each optical disk it outputs
C a listing with selected entries in ESOMC2::ARCHIVE:[ESOLV]SELDLV?.LIS
C These files can be used with COPYFROMOD.EXE
C which extracts the selected galaxies from optical disk.
C
C     declarations:
C
      IMPLICIT NONE
      INTEGER      MADRID
      INTEGER      TID,IST,IAC,UNIT
      INTEGER      NCOL,NROW,NSC,ACOL,AROW
      INTEGER      I,J,K,ROW,COLNR
      INTEGER      NWANT,WANTED(20)
      INTEGER      B,ID
      INTEGER      NGAL,COUNT,LABEL(15500)
      INTEGER      IFATAL,KUN,INDF
C
      LOGICAL      FLAG,NOP
C
      CHARACTER*1  MODE
      CHARACTER*80 TABLE,COLUMN
      CHARACTER*80 TEXT,DIRLINE
      CHARACTER*49 O_DISK_DIR
      CHARACTER*49 SEL_FILES
      CHARACTER*1  COLOUR
      CHARACTER*8  SELEC(15500),SORTED(15500),FIRST
C
      INCLUDE      'MID_INCLUDE:ST_DEF.INC/NOLIST'
      COMMON       /VMR/MADRID(1)
      INCLUDE      'MID_INCLUDE:ST_DAT.INC/NOLIST'
C
C ... initializations:
      DO I=1,15000
         LABEL(I) = 0
      ENDDO
      IFATAL = 0
C
C ... init midas monitor:
      CALL STSPRO('FROMOD')
C
C ... get mode:
      CALL STKRDC('P1',1,1,20,IAC,MODE,UNIT,NOP,IST)
      CALL UPCAS(MODE,MODE)
      IF ((MODE.NE.'P').AND.(MODE.NE.'A')) THEN
         WRITE(TEXT,5) MODE
 5       FORMAT('*** FATAL: not a valid mode: ',A1)
         CALL STTPUT(TEXT,IST)
         IFATAL = 1
         CALL STKWRI('FATAL',IFATAL,1,1,KUN,IST)
         CALL STSEPI
      ENDIF
C         
C ... get colour:
      CALL STKRDC('P2',1,1,1,IAC,COLOUR,UNIT,NOP,IST)
      CALL UPCAS(COLOUR,COLOUR)
      IF ((COLOUR.NE.'B').AND.(COLOUR.NE.'R').AND.(COLOUR.NE.'A')) THEN
         WRITE(TEXT,10) COLOUR
 10      FORMAT('*** FATAL: not a valid colour: ',A1)
         CALL STTPUT(TEXT,IST)
         IFATAL = 1
         CALL STKWRI('FATAL',IFATAL,1,1,KUN,IST)
         CALL STSEPI
      ENDIF
C
C if mode A then do things with table else with keywords
      IF (MODE.EQ.'A') THEN
         CALL STKRDC('P3',1,1,20,IAC,TABLE,UNIT,NOP,IST)
         CALL STKRDC('P4',1,1,20,IAC,COLUMN,UNIT,NOP,IST)
         CALL TBTOPN(TABLE,F_I_MODE,TID,IST)
         IF (IST.NE.0) THEN
            WRITE(TEXT,11) TABLE
 11         FORMAT('*** FATAL: cannot open table ',A)
            IFATAL = 1
            CALL STKWRI('FATAL',IFATAL,1,1,KUN,IST)
            CALL STTPUT(TEXT,IST)
            CALL STSEPI
         ENDIF
         CALL TBIGET(TID,NCOL,NROW,NSC,ACOL,AROW,IST)
         CALL TBCSER(TID,COLUMN,COLNR,IST)
         IF (IST.NE.0) THEN
            WRITE(TEXT,12) COLUMN
 12         FORMAT('*** FATAL: problems finding column ',A20)
            IFATAL = 1
            CALL STKWRI('FATAL',IFATAL,1,1,KUN,IST)
            CALL STTPUT(TEXT,IST)
            CALL TBTCLO(TID,IST)
            CALL STSEPI
         ENDIF
C
C ... find selected entries in TABLE and put them in SELEC
C     take care of COLOUR: A = both R and B images
         K = 0
         DO ROW=1, NROW
            CALL TBSGET(TID,ROW,FLAG,IST)
            IF (FLAG) THEN
               CALL TBERDI(TID,ROW,COLNR,ID,NOP,IST)
C
C ... convert companions to main galaxy names:
               ID = ID - MOD(ID,10)
C 
C ... use I7.7 format to get leading zeroes
               IF ((COLOUR.EQ.'A').OR.(COLOUR.EQ.'B')) THEN
                  K = K + 1
                  SELEC(K)(1:1) = 'B'
                  WRITE(SELEC(K)(2:8),17) ID
 17               FORMAT(I7.7)
               ENDIF
               IF ((COLOUR.EQ.'A').OR.(COLOUR.EQ.'R')) THEN
                  K = K + 1
                  SELEC(K)(1:1) = 'R'
                  WRITE(SELEC(K)(2:8),17) ID
               ENDIF
            ENDIF
         ENDDO
C
C ... close TABLE:
         CALL TBTCLO(TID,IST)
C
C ... stop if no galaxies are selected at all:
      IF (K.EQ.0) THEN
         IFATAL = 1
         CALL STKWRI('FATAL',IFATAL,1,1,KUN,IST)
         CALL STTPUT('*** FATAL: No selected entries',IST)
         CALL STSEPI
      ENDIF
      ELSE
C
C ... get eso-identifiers from keyword:
         CALL STKRDI('N',1,1,IAC,NWANT,UNIT,NOP,IST)
         IF (NWANT.EQ.0) THEN
            WRITE(TEXT,13) '*** FATAL: No ESO-identifiers given' 
 13         FORMAT(A)
            IFATAL = 1
            CALL STKWRI('FATAL',IFATAL,1,1,KUN,IST)
            CALL STTPUT(TEXT,IST)
            CALL STSEPI
         ENDIF
         CALL STKRDI('INPUTI',1,NWANT,IAC,WANTED,UNIT,NOP,IST)
         K = 0
         DO I=1, NWANT
            WANTED(I) = WANTED(I) - MOD(WANTED(I),10)
C
            IF ((COLOUR.EQ.'A').OR.(COLOUR.EQ.'B')) THEN
               K = K + 1
               SELEC(K)(1:1) = 'B'
               WRITE(SELEC(K)(2:8),17) WANTED(I)
            ENDIF
            IF ((COLOUR.EQ.'A').OR.(COLOUR.EQ.'R')) THEN
               K = K + 1
               SELEC(K)(1:1) = 'R'
               WRITE(SELEC(K)(2:8),17) WANTED(I)
            ENDIF
         ENDDO
      ENDIF
C
C ... sort SELEC in alphabetical order and exclude doubles:
      NGAL = K
      DO I=1, K
         FIRST = 'YYYYYYYY'
         DO J=1, K
            IF (SELEC(J).LT.FIRST) THEN
               FIRST = SELEC(J)
               INDF  = J
            ELSE IF (SELEC(J).EQ.FIRST) THEN
                    SELEC(J) = 'ZZZZZZZZ'
                    NGAL = NGAL-1
            ENDIF
         ENDDO
         SORTED(I) = FIRST
         SELEC(INDF) = 'ZZZZZZZZ'
      ENDDO            
      K = NGAL
C
C ... declare file identifiers, exact numbers will be filled in below:
      O_DISK_DIR(1:49) = 'ESOMC2"ESOLV MARTINI":
     +:ARCHIVE:[ESOLV]SORTLV?.LIS'
      SEL_FILES(1:49)  = 'ESOMC2"ESOLV MARTINI":
     +:ARCHIVE:[ESOLV]SELDLV?.LIS'
C
C ... setup:
      DO I=1, 3                                   ! I = # OD_disk
         COUNT = 0 
C
C ... fill in exact file numbers:
         WRITE(O_DISK_DIR(45:45),20) I
         WRITE(SEL_FILES(45:45),20)  I
 20      FORMAT(I1)
C
C ... open existing optical disk number 'I' directory listing
C     and output file for galaxies found on this disk.
         OPEN(UNIT=12,FILE=O_DISK_DIR,STATUS='OLD')
         OPEN(UNIT=13,FILE=SEL_FILES,STATUS='NEW')
C
C ... init some counters and flags:
         B = 0      ! B=0 also next entry in listing else only in SELEC_FILES
C
C ... do it:
         READ(12,30) DIRLINE            ! read first line away in listings
  30     FORMAT(A)
         DO J = 1, NGAL
            IF (K.EQ.0) GOTO 999          ! all galaxies have been found 
            IF (LABEL(J).NE.0) GOTO 888   ! if galaxy already found on other
                                          ! disk, skip it now.
            IF (B.EQ.1) GOTO 120
 110        READ(12,30,END=999) DIRLINE
            B = 1
 120        IF (DIRLINE(1:8).EQ.SORTED(J)(1:8)) THEN
               WRITE(13,30) DIRLINE
               LABEL(J) = I               ! the disk number as label may be
                                          ! usefull later on.
               K = K - 1
               COUNT = COUNT + 1
               B = 0
            ELSE 
               IF (DIRLINE(1:8).LT.SORTED(J)(1:8)) GOTO 110
            ENDIF
 888        CONTINUE
         ENDDO
 999  CONTINUE
C
C ... each time close used files, else there are to many open!
      CLOSE(12)
      CLOSE(13)
      WRITE(TEXT,40) I,COUNT
 40   FORMAT(' Number of files found on ESOLV',I1,I6)
      CALL STTPUT(TEXT,IST)
      DO J=1,NGAL
         IF (LABEL(J).EQ.I) THEN
            WRITE(TEXT,45) SORTED(J)
 45         FORMAT(' ',A)
            CALL STTPUT(TEXT,IST)
         ENDIF
      ENDDO
C
C ... goto next disk or finish up:
      ENDDO
C
C ... finished, now see how many galaxies were not found
      IF (K.NE.0) THEN
         WRITE(TEXT,50) K
 50      FORMAT(' Number of galaxies not found:',I5)
         CALL STTPUT(TEXT,IST)
         DO I=1,NGAL
            IF (LABEL(I).EQ.0) THEN
               WRITE(TEXT,45) SORTED(I)
               CALL STTPUT(TEXT,IST)
            ENDIF
         ENDDO
      ENDIF
C
C ... if no galaxy found at all stop:
      IF (NGAL.EQ.K) THEN
         IFATAL = 1
         CALL STKWRI('FATAL',IFATAL,1,1,KUN,IST)
         CALL STTPUT('*** I stop: No galaxies found',IST)
         CALL STSEPI
      ENDIF
C
C ... close midas monitor:
      CALL STSEPI
      END

C @(#)comcc.for	19.1 (ES0-DMD) 02/25/03 13:31:21
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENT:    COMCC			A. Lauberts     ESO	890711
C.KEYWORDS: table file, characteristic curve, image file
C.PURPOSE:  transform density D to intensity I according to the Llebaria formula
C           log I = C3*log(D-C1) + C4*log(C2-D) + C5
C           with calibration parameters C1 - C5
C.USAGE:    MIDAS applic program
C           execute as @@ COMCC P1 P2
C.PARAMETERS: P1  INA   C*8  table file with calibration parameters in 1st row
C             P2  OUTA	C*8  name of output image file with characteristic curve
C Output:   1-D image file with characteristic curve D = D(log I),
C           where log I limits are determined by descriptors NPIX,
C           START and STEP.
C.COMMENTS: derived from old routine CTAB
C---------------------------------------------------------------------------
	PROGRAM COMCC
C
	COMMON/VMR/MADRID(1)
	CHARACTER*60  INA,OUTA
	INTEGER      COL(9),STAT,PNTR
	REAL         CONST(9)
	LOGICAL      NULL(9)
C
	DATA COL/1,2,3,4,5,6,7,8,9/
	PARAMETER NCOL=9
C
C  set up MIDAS environment 
	CALL SXSPRO('COMCC',STAT)
C
C  get keywords
	CALL SXKGET('IN_A','C',1,60,IAV,INA,STAT)
	CALL SXKGET('OUT_A','C',1,60,IAV,OUTA,STAT)
C  read cc coeffs from table file
	CALL TXTOPN(INA,STAT)
	CALL TXRGET(INA,'R',1,NCOL,COL,CONST,NULL,STAT)
	IF(NULL(2).EQ..TRUE.) GOTO 999
	STEP=0.01
	START=-1.
	MAX=401
C  creat 1-D image
	CALL SXIPUT(OUTA,'O',1,MAX,START,STEP,OUTA,'LOG_INT',PNTR,NO,
     + STAT)
	CALL DENS(MADRID(PNTR),CONST,MAX,STEP,START)
C  write descriptor LHCUTS
	CALL SXDPUT(OUTA,'LHCUTS','R',CONST,1,4,STAT)
C  free data
999	CALL SXSEPI
	END
C
C
	SUBROUTINE DENS(A,CONST,MAX,STEP,START)
C
	REAL  A(MAX),CONST(9)
C
	F(X) = C3*ALOG10(X-C1) + C4*ALOG10(C2-X) + C5
	DF(X)= (C3/(X-C1) - C4/(C2-X)) / 2.3
C
	C1=CONST(2)
	C2=CONST(3)
	C3=CONST(4)
	C4=CONST(5)
	C5=CONST(6)
	D1=C1+.05
	D2=C2-.05
C  find D for log I = -1 to +3 using Newton-Raphson method
	D=D1
	FI=START
	FD=F(D)
	DFD=DF(D)
       DO I=1,MAX
	IT=0
10	D0=D
	IF(IT.GT.9) THEN
	  WRITE(6,*) ' >9 iterations at log I, D=',FI,D
	  RETURN
	ENDIF
	IT=IT+1
	F0=FD
	DF0=DFD
	D = D0 - (F0-FI) / DF0
	D = AMIN1(D2,AMAX1(D1,D))
	FD=F(D)
	DFD=DF(D)
	IF(ABS(D0-D).GT.0.0001.AND.ABS(FD-FI).GT.0.0001) GOTO 10
	A(I)=D
	FI=FI+STEP
       ENDDO
C  put LHCUTS in CONST
	CONST(1)=0.
	CONST(2)=D
	CONST(3)=0.
	CONST(4)=D
	RETURN
	END
C

C @(#)mdaif.for	19.1 (ES0-DMD) 02/25/03 13:27:33
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C-----------------------------------------------------------------------
C
C.IDENTIFICATION
C
C  Program MDAIF
C
C.AUTHOR
C
C  F. Murtagh, ST-ECF, Garching.             Version 1.0  16 June 1986
C  F. Murtagh                                Version 2.0  Oct. 1988
C                                            (New std. ifs.)
C
C.PURPOSE
C
C  Pass parameters to, and execute, MDA (Multiple Discriminant Analysis)
C
C.INPUT/OUTPUT
C
C  P1 - P3 contain parameters; these are: input table name, output
C  table name, and whether or not a second output table is required, to
C  store the eigenvectors.
C
C.ALGORITHM
C
C . uses Midas Table interface routines;
C . input table is assumed to contain entries in single precision;
C . no select or null values 
C . all columns of the input table are sent to the MDA routine;
C . description of the MDA routine is in the corresponding program;
C . the output produced consists of one (or two) tables, and descriptors
C   to the first of these (eigenvalues): view with
C   READ/DESC outtable.TBL *
C . storage is limited only by the Midas Table system, and by the
C   overall system limitations;
C . assumed is: NG < M < NROW in the MDA routine.
C . note that NG eigenvalues are output, although the last is in theory 0;
C   this will indicate the limited (but usually adequate) accuracy achieved.
C
C.MODIFICATIONS
C
C  STANDARD INTERFACES, F. MURTAGH, AUG. 1988
C  New Table File System M.Peron SEP91
C-----------------------------------------------------------------------
        PROGRAM MDAIF
C
        CHARACTER*6     FORM
        CHARACTER*60     NAMEIN, NAMEOUT, TABEVEC
        CHARACTER*16    UNIT, LABEL, LABEL2
        CHARACTER*80    LINE
        INTEGER         MADRID, KUN, KNUL, DTYPE,TID,TID1,TID2
        INTEGER         NACTV,ISTAT,NCOLIN,NROW,I,NAC,NAR
        INTEGER         LEN,NSEL,IPTRIN,IWPTRIN
        INTEGER         NTOT,INULL,IPTRGP,IMISS,NG
        INTEGER         IACTV,NCOLOUT,NNCOL,NNROW
        INTEGER         NSC1,NAROUT,IWPTROUT,IPTROUT
        INTEGER         IEVEC,M,NNAC,NAROUT2,IWPTROUT2
        INTEGER         IADD0,IADD3,IADD4,IADD5,IADD6
        INTEGER         IADD7,IADD8,IADD9,IADD2
        INTEGER         IADD10,IADD11,IERR,IPRINT,IADD1,KUNIT 
        INTEGER         NSORTC,IPTROUT2
        INCLUDE         'MID_INCLUDE:TABLES.INC/NOLIST'
        COMMON          /VMR/MADRID(1)
        INCLUDE         'MID_INCLUDE:TABLED.INC/NOLIST'
C
C
C ...   Assuming this is our first action ...
C
        CALL STSPRO('MDAIF')
        DTYPE = D_R4_FORMAT
C
C ...   Get table name as a keyword passed in the command line.
C
        CALL STKRDC('P1',1,1,60,NACTV,NAMEIN,KUN,KNUL,ISTAT)
C
C ...   Read input table.
C
        CALL TBTOPN(NAMEIN,16,TID1,ISTAT)
        CALL TBIGET(TID1,NCOLIN,NROW,NSORTC,NAC,NAR,ISTAT)
C
C ...   Some error checking on input.
C
        IF (NROW.LT.1.OR.NCOLIN.LT.1) THEN
           CALL STTPUT(' Nos. of rows/columns are less than 1.',ISTAT)
           CALL STTPUT(' What sort of a table is this ??',ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
C
        DO I = 1, NCOLIN
           CALL TBFGET(TID1,I,FORM,LEN,DTYPE,ISTAT)
           IF (DTYPE.NE.D_R4_FORMAT) THEN
              CALL STTPUT(' Illegal format:',ISTAT)
              CALL STTPUT(' Only R*4 column type allowed.',ISTAT)
              CALL STTPUT(' Aborting.',ISTAT)
              GOTO 9000
           ENDIF
        ENDDO
        CALL CHSEL(TID1,NROW,NSEL)
        IF (NSEL.NE.NROW) THEN
           CALL STTPUT(' Not all rows are SELECTed. ',ISTAT)
           CALL STTPUT(' In current implementation, MUST select all.',
     X                                                         ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
C
        CALL TDMGET(4*NROW*NCOLIN,IWPTRIN,ISTAT)
        NSEL = NROW
        CALL TBCMAP(TID1,1,IPTRIN,ISTAT)
        CALL MAPSM(MADRID(IPTRIN),MADRID(IWPTRIN),
     1              NAR,NROW,NCOLIN)
        NTOT = NROW*NCOLIN
        CALL CHNULL(MADRID(IWPTRIN),NTOT,INULL)
        IF (INULL.NE.0) THEN
           CALL STTPUT
     X     (' Null entries in the table are not allowed.',ISTAT)
           CALL STTPUT
     X     (' Use SELECT, and then construct another table.',
     X                                                   ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
C
        CALL TBCMAP(TID1,NCOLIN,IPTRGP,ISTAT)
        CALL TBL_CHGP(MADRID(IPTRGP),NROW,IMISS,NG)
C
        WRITE (LINE,90) NG
        CALL STTPUT(LINE,ISTAT)
  90    FORMAT(' Number of groups:',I6)
C
C       IF (NG.GE.NROW.OR.NG.GE.NCOLIN-1) THEN
        IF (NG.GT.NROW.OR.NG.GT.NCOLIN) THEN
           CALL STTPUT(' Unacceptable no. of groups present.',ISTAT)
           CALL STTPUT(' (NG .GT. NROW or NCOL)',ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
C
        IF (IMISS.GT.0) THEN
           CALL STTPUT(' Unacceptable group memberships:',ISTAT)
           CALL STTPUT(' Check last col. of input table',ISTAT)
           CALL STTPUT(' for missing sequence numbers.',ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
C
C ...   Get the output table name.
C
        CALL STKRDC('P2',1,1,60,IACTV,NAMEOUT,KUN,KNUL,ISTAT)
C
C ...   Now create the output (projections) table.
C
C        NCOLOUT = NG-1
        NCOLOUT = NG
        CALL TBTINI(NAMEOUT,F_TRANS,17,NCOLOUT,NROW,TID,ISTAT)
        FORM = 'G14.6'
        UNIT = ' '
C       (The messing around with LABEL2 which follows is so that
C       leading zeros in a column label appear as such, and not as
C       blanks.)
        LABEL = 'DIS00'
        LABEL2 = '10001'
        DO I = 1, NCOLOUT
           WRITE (LABEL2(1:5),100) I+10000
           LABEL(4:5) = LABEL2(4:5)
           CALL TBCINI(TID,DTYPE,1,FORM,UNIT,LABEL,NSORTC,ISTAT)
        ENDDO
  100   FORMAT(I5)
C
        CALL TBIGET(TID,NNCOL,NNROW,NSC1,NAC,NAROUT,ISTAT)
        CALL TDMGET(4*NCOLOUT*NROW,IWPTROUT,ISTAT)
        CALL TBCMAP(TID,1,IPTROUT,ISTAT)
        CALL MAPSM(MADRID(IPTROUT),MADRID(IWPTROUT),
     1              NAROUT,NROW,NCOLOUT)

C
        IEVEC = 0
        CALL STKRDC('INPUTC',1,1,60,IACTV,TABEVEC,KUN,KNUL,ISTAT)

        M = NCOLIN - 1
        IF (TABEVEC.NE.'NO') THEN
           IEVEC = 1
C
C ...      Create the output (eigenvectors) table.
C
           M = NCOLIN - 1
           CALL TBTINI(TABEVEC,F_TRANS,17,NCOLOUT,M,TID2,ISTAT)
C          (The messing around with LABEL2 which follows is so that
C          leading zeros in a column label appear as such, and not as
C          blanks.)
           LABEL = 'EVC00'
           LABEL2 = '10001'
           DO I = 1, NCOLOUT
              WRITE (LABEL2(1:5),100) I+10000
              LABEL(4:5) = LABEL2(4:5)
              CALL TBCINI(TID2,DTYPE,1,FORM,UNIT,LABEL,NSORTC,ISTAT)
           ENDDO
C
           CALL TBIGET(TID2,NNCOL,NNROW,NSC1,NNAC,NAROUT2,ISTAT)
           CALL TDMGET(4*NCOLOUT*M,IWPTROUT2,ISTAT)
           CALL TBCMAP(TID2,1,IPTROUT2,ISTAT)
           CALL MAPSM(MADRID(IPTROUT2),MADRID(IWPTROUT2),
     1                NAROUT2,M,NCOLOUT)
        ENDIF
C
C ...   Allocate storage.
C
        CALL GETSTOR(NROW*M+NG+M,IADD0)
C        CALL GETSTOR(NROW*M,IADD0)
C        CALL GETSTOR(NG,IADD1)
C        CALL GETSTOR(M,IADD2)
        IADD1 = IADD0+NROW*M
        IADD2 = IADD1+NG
         CALL GETSTOR(NG*M,IADD3)
        CALL GETSTOR(M*M,IADD4)
        CALL GETSTOR(NG*NG,IADD5)
        CALL GETSTOR(NG*NG,IADD6)
        CALL GETSTOR(M*NG,IADD7)
        CALL GETSTOR(M,IADD8)
        CALL GETSTOR(M,IADD9)
        CALL GETSTOR(NROW,IADD10)
        CALL GETSTOR(NG,IADD11)
C
C ...   We now have all the storage we need; APPL will look after
C       a few further odds and ends - e.g. setting hard-wired
C       options, rearranging output, etc.  Then it will call the
C       application program.
C
        IERR = 0
        IF (IEVEC.EQ.0) THEN
           CALL APPL1(NROW,M,NG,MADRID(IWPTRIN),MADRID(IPTRGP),
     X     MADRID(IADD0),IPRINT,MADRID(IWPTROUT),
     X     MADRID(IADD1),MADRID(IADD2),MADRID(IADD3),MADRID(IADD4),
     X     MADRID(IADD5),
     X     MADRID(IADD6),MADRID(IADD7),MADRID(IADD8),MADRID(IADD9),
     X     MADRID(IADD10),
     X     MADRID(IADD11),IERR)
           CALL MAPBG(MADRID(IWPTROUT),MADRID(IPTROUT),
     1             NAROUT,NROW,NCOLOUT)

        ELSE
           CALL TBIGET(TID2,NNCOL,NNROW,NSC1,NNAC,NAROUT2,ISTAT)
           CALL APPL2(NROW,M,NG,MADRID(IWPTRIN),MADRID(IPTRGP),
     X     MADRID(IADD0),IPRINT,MADRID(IWPTROUT),
     X     MADRID(IADD1),MADRID(IADD2),MADRID(IADD3),MADRID(IADD4),
     X     MADRID(IADD5),
     X     MADRID(IADD6),MADRID(IADD7),MADRID(IADD8),MADRID(IADD9),
     X     MADRID(IADD10),
     X     MADRID(IADD11),MADRID(IWPTROUT2),IERR)
           CALL TBIGET(TID2,NNCOL,NNROW,NSC1,NNAC,NAROUT2,ISTAT)
           CALL MAPBG(MADRID(IWPTROUT),MADRID(IPTROUT),
     1             NAROUT,NROW,NCOLOUT)
           CALL MAPBG(MADRID(IWPTROUT2),MADRID(IPTROUT2),
     1             NAROUT2,M,NCOLOUT)
           CALL TBIGET(TID2,NNCOL,NNROW,NSC1,NNAC,NAROUT2,ISTAT)


        ENDIF
        IF (IERR.EQ.1) THEN
           CALL STTPUT(' IERR = 1 on return from MDA.',ISTAT)
           CALL STTPUT
     X  (' No convergence in eigenroutine TQL2, called from MDA.',ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
        IF (IERR.EQ.2) THEN
           CALL STTPUT(' IERR = 2 on return from MDA.',ISTAT)
           CALL STTPUT(' Matrix for inversion was singular.',ISTAT)
           CALL STTPUT(' Check that Nrows > Ncols. > Ngps., or',ISTAT)
           CALL STTPUT
     X          (' that no cols. of same values are present.',ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
        IF (IERR.NE.0) THEN
           CALL STTPUT(' IERR not 0 on return from MDA.',ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
C
C ...   Write out descriptors with output table.
C
        CALL DSCROUT(NAMEOUT,NCOLOUT+1,MADRID(IADD8),TID,KUNIT)
C
C ...   Finish up: write output file to disk, and release memory space.
C
        CALL RELSTOR(NROW*M+NG+M,IADD0)
        CALL RELSTOR(NG*M,IADD3)
        CALL RELSTOR(M*M,IADD4)
        CALL RELSTOR(NG*NG,IADD5)
        CALL RELSTOR(NG*NG,IADD6)
        CALL RELSTOR(M*NG,IADD7)
        CALL RELSTOR(M,IADD8)
        CALL RELSTOR(M,IADD9)
        CALL RELSTOR(NROW,IADD10)
        CALL RELSTOR(NG,IADD11)
C
        CALL TBTCLO(TID1,ISTAT)
C
        CALL TBIPUT(TID,NCOLOUT,NROW,ISTAT)
        CALL TBSINI(TID,ISTAT)
        CALL TBTCLO(TID,ISTAT)
        IF (IEVEC.NE.0) THEN
           CALL TBIGET(TID2,NNCOL,NNROW,NSC1,NNAC,NAROUT2,ISTAT)
           CALL TBIPUT(TID2,NCOLOUT,M,ISTAT)
           CALL TBSINI(TID2,ISTAT)
           CALL TBTCLO(TID2,ISTAT)
        ENDIF
C
 9000   CONTINUE
        CALL STSEPI
C
        END
C----------------------------------------------------------------------
        SUBROUTINE APPL1(N,M,NG,AIN,GPR,ACREA,IPRINT,AOUT,GPS,MEAN,GPM,
     X                      TOT,BETW,BETW2,CPROJ,W1,W2,GP,NOG,IERR)
C
C ...   This is now the application routine - note the setting of
C       IPRINT, which in future may be passed if desired
C       on the command line.
C
        INTEGER M,N,NG,IPRINT,IERR,I,J
        REAL*4  AIN(N,M), AOUT(N,NG), ACREA(N,M),GPR(N),GPS(NG),MEAN(M),
     X          TOT(M,M), GPM(NG,M), BETW(NG,NG), BETW2(NG,NG),
     X          CPROJ(M,NG), W1(M), W2(M)
        INTEGER*4       GP(N), NOG(NG)
C
        IPRINT = 3
C
        DO I = 1, N
           GP(I) = GPR(I)
           DO J = 1, M
              ACREA(I,J) = AIN(I,J)
           ENDDO
        ENDDO
        DO I = 1, NG
           NOG(I) = GPS(I)
        ENDDO
C
        CALL MDA(N,M,NG,ACREA,GP,IPRINT,NOG,MEAN,GPM,TOT,BETW,
     X           BETW2,CPROJ,W1,W2,IERR)
C
        IF (IERR.NE.0) RETURN
C
        DO I = 1, N
           DO J = 1, NG
              AOUT(I,J) = ACREA(I,J)
           ENDDO
        ENDDO
C
        RETURN
        END
C----------------------------------------------------------------------
        SUBROUTINE APPL2(N,M,NG,AIN,GPR,ACREA,IPRINT,AOUT,GPS,MEAN,GPM,
     X            TOT,BETW,BETW2,CPROJ,W1,W2,GP,NOG,AOUT2,IERR)
C
C ...   This is now the application routine - note the setting of
C       IPRINT, which in future may be passed if desired
C       on the command line.
C
        INTEGER N,M,NG,IPRINT,I,J,IERR
        REAL*4  AIN(N,M), AOUT(N,NG), ACREA(N,M),GPR(N),GPS(NG),MEAN(M),
     X          TOT(M,M), GPM(NG,M), BETW(NG,NG), BETW2(NG,NG),
     X          CPROJ(M,NG), W1(M), W2(M), AOUT2(M,NG)
        INTEGER*4       GP(N), NOG(NG)
C
        IPRINT = 3
C
        DO I = 1, N
           GP(I) = GPR(I)
           DO J = 1, M
              ACREA(I,J) = AIN(I,J)
           ENDDO
        ENDDO
        DO I = 1, NG
           NOG(I) = GPS(I)
        ENDDO
C
        CALL MDA(N,M,NG,ACREA,GP,IPRINT,NOG,MEAN,GPM,TOT,BETW,
     X           BETW2,CPROJ,W1,W2,IERR)
C
        IF (IERR.NE.0) RETURN
C
        DO I = 1, N
           DO J = 1, NG
              AOUT(I,J) = ACREA(I,J)
           ENDDO
        ENDDO
C
        DO I = 1, M
           DO J = 1, NG
              AOUT2(I,J) = CPROJ(I,J)
           ENDDO
        ENDDO
C
        RETURN
        END
C-------------------------------------------------------------------------
        SUBROUTINE CHNULL(X,NT,NULL)
C ...   Check if null values are present.
        INTEGER I,NT,NULL
        REAL*4  X(NT), TRNULL
        INTEGER TINULL
        DOUBLE PRECISION TDNULL
        CALL TBMNUL(TINULL,TRNULL,TDNULL)
        NULL = 0
        DO I = 1, NT
           IF (X(I).EQ.TRNULL) NULL = NULL + 1
           IF (NULL.GT.0) RETURN
        ENDDO
        RETURN
        END
C-------------------------------------------------------------------------
        SUBROUTINE TBL_CHGP(X,NT,IMISS,NG)
C ...   Determine no. of groups and check for consistent sequencing.
        INTEGER IMISS,NG,NT,I2,I
        REAL*4  X(NT),G
        IMISS = 0
        NG = 0
        G = NG
        DO I = 1, NT
           IF (X(I).GT.G) THEN
              G = X(I)
              NG = G
           ENDIF
        ENDDO
C
        DO I = 1, NG
           G = I
           DO I2 = 1, NT
              IF (X(I2).EQ.G) GOTO 200
           ENDDO
           IMISS = I
           IF (IMISS.GT.0) RETURN
  200      CONTINUE
        ENDDO
C
        RETURN
        END
C-------------------------------------------------------------------------
        SUBROUTINE GETSTOR(NVALS,IPTR)
C ...   Allocate storage space for NVALS real values.
        INTEGER NVALS,IPTR,ISTAT
        CALL TDMGET(4*NVALS,IPTR,ISTAT)
        RETURN
        END
C-------------------------------------------------------------------------
        SUBROUTINE RELSTOR(NVALS,IPTR)
C ...   Release storage space (already allocated) for NVALS real values.
        INTEGER NVALS,IPTR,ISTAT
        CALL TDMFRE(4*NVALS,IPTR,ISTAT)
        RETURN
        END
C---------------------------------------------------------------------
        SUBROUTINE DSCROUT(TAB,M,VALS,TID,KUNIT)
C ...   Output descriptors, with table.
        REAL*4 VALS(M),V
        INTEGER TID,M,I,KUNIT,ISTAT,INDX,MM
        CHARACTER TAB*8, TABNAME*12
C
C ...   The following values are rearranged in decreasing rather
C       than increasing order.
        DO I = 1, M/2
           V = VALS(I)
           VALS(I) = VALS(M-I+1)
           VALS(M-I+1) = V
        ENDDO
C
        INDX = INDEX(TAB//' ',' ')-1
        TABNAME = TAB(1:INDX)//'.TBL'
C
        MM = M-1
        CALL STDWRR(TID,'EIGENVALUES',VALS,1,MM,KUNIT,ISTAT)
C
        RETURN
        END

C @(#)exslit.for	13.1.1.1 (ESO-DMD) 06/02/98 18:11:33 
      PROGRAM EXSLIT
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  program EXSLIT		version 1.00	890215
C  K. Banse                  	ESO - Garching
C  1.10    900425
C
C.KEYWORDS
C  DeAnza, subimage
C
C.PURPOSE
C  extract a rotated slit (of fixed size) from the displayed image
C
C.ALGORITHM
C  use cursor 2 to change the slope of the trace + cursor 1 as rotation
C  point (or vice versa), both cursors are moved via the joystick
C  exactly like in EXTRACT/TRACE
C  i.e., we exit on ENTER with both cursors off
C
C.INPUT/OUTPUT
C  the following keywords are used:
C
C  INPUTR/R/1/2			stepsizes for slit
C  P3/C/1/60			slitlength, slitwidth, x/y
C	
C.VERSIONS
C  1.00		from version 2.80 as of 871123
C  1.10		fix bugs introduced by conversion to Portable Midas...
C	
C--------------------------------------------------
C
      IMPLICIT NONE
C      
      INTEGER      IAV,IPIXL,IPIXW
      INTEGER      IS1,IS2,MAXIDX,N,NAXIS,NINDX,NN,NOCUR
      INTEGER      PARAL,STAT,COOS(4)
      INTEGER      IMNOA,IMNOB
      INTEGER*8    PNTRA,PNTRB,PNTRX,PNTRY
      INTEGER      XR,YR,XS,YS
      INTEGER      IX1,IY1,IX2,IY2,IX3,IY3,IX4,IY4
      INTEGER      XFIG(5),YFIG(5),XOLDFG(5),YOLDFG(5)
      INTEGER      NPIX(3),NPOLD(2),SUBLO(3)
      INTEGER      NEW1(2),NEW2(2),MC1,MC2
      INTEGER      ENTER,OVCON,ENTFLG,FIRTIM,RFNO
      INTEGER      UNI(1),NULO
      INTEGER      MADRID(1)
C
      CHARACTER      CUNIT*64,IDENT*72
      CHARACTER      CDUMMY*1,LINE*80,ATOM(2)*20,ACTION*2
      CHARACTER*60   OUTFRA,INFRA,RFSLIT
C      
      REAL         RBUF(6),PIXELS(6)
      REAL         RINF(6),CUTS(4)
      REAL         PXSTA(2),PXEND(2)
      REAL         ALPHA,BETA,DX,DY
      REAL         PXSTAA(2),PXENDA(2),CA,SA,PXSTEP(2)
      REAL         X1,Y1,X2,Y2,X3,Y3,X4,Y4,XDELT,YDELT
      REAL         XCENT,YCENT,WH,SH
      REAL         FACTO
C 
      DOUBLE PRECISION START(3),STEP(3),RFSTA(2),STEPLN(2)
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C 
      INCLUDE  'MID_INCLUDE:IDIDEV.INC'
      INCLUDE  'MID_INCLUDE:IDIMEM.INC'
C 
      COMMON  /VMR/ MADRID
C
      EQUIVALENCE      (IX1,XFIG(1)),(IY1,YFIG(1)),
     +                 (IX2,XFIG(2)),(IY2,YFIG(2)),
     +                 (IX3,XFIG(3)),(IY3,YFIG(3)),
     +                 (IX4,XFIG(4)),(IY4,YFIG(4))
C      
      DATA      CUTS      /0.,0.,+999999.,-999999./
      DATA      XOLDFG    /5*0/,    YOLDFG /5*0/
      DATA      LINE      /' '/
      DATA      START     /3*0.D0/, STEP   /3*1.D0/
      DATA      NPIX      /3*1/
      DATA      COOS      /-1,-1,-1,-1/
      DATA      FACTO     /0.0174533/             ! Pi / 180.
      DATA      IDENT     /' '/,      CUNIT   /' '/
C 
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C  get into MIDAS
      CALL STSPRO('EXSLIT')
      INFRA = ' '
      PARAL = 0
      FIRTIM = 0
C      
C  get options + result frame
      CALL STKRDC('ACTION',1,1,2,IAV,ACTION,UNI,NULO,STAT)
      CALL STKRDC('OUT_A',1,1,60,IAV,OUTFRA,UNI,NULO,STAT)
C      
C  allocate virtual memory for x,y indices for extracted image
      CALL STKRDI('INPUTI',10,1,IAV,MAXIDX,UNI,NULO,STAT)
      CALL STFXMP(MAXIDX,D_R4_FORMAT,PNTRX,STAT)
      CALL STFXMP(MAXIDX,D_R4_FORMAT,PNTRY,STAT)
C      
C  if we use a reference slit, obtain all necessary info
      IF (ACTION(2:2).EQ.'F') THEN
         CALL STKRDC('IN_B',1,1,60,IAV,RFSLIT,UNI,NULO,STAT)
         CALL STFOPN(RFSLIT,D_OLD_FORMAT,0,F_IMA_TYPE,RFNO,STAT)
         CALL STDRDI(RFNO,'NAXIS',1,1,IAV,NN,UNI,NULO,STAT)
         IF (NN.LT.2) CALL STETER
     +      (3,'reference slit must be at least 2-dim frame...')
         CALL STDRDI(RFNO,'NPIX',1,2,IAV,NPIX,UNI,NULO,STAT)
         IPIXW = NPIX(2)
         IPIXL = NPIX(1)
         CALL STDRDD(RFNO,'START',1,2,IAV,RFSTA,UNI,NULO,STAT)
         CALL STDRDD(RFNO,'STEP',1,2,IAV,STEPLN,UNI,NULO,STAT)
C      
C  now split according to input spec
         IF (ACTION(1:1).EQ.'F') THEN
            CALL STKRDC('IN_A',1,1,60,IAV,INFRA,UNI,NULO,STAT)
            CALL STIGET(INFRA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +                  2,NAXIS,NPIX,START,STEP,IDENT,
     +                  CUNIT,PNTRA,IMNOA,STAT)
            GOTO 5000                    !there we handle cursorless stuff..
         ENDIF
      ENDIF
C      
C ***************
C      
C  here we come for cursor processing - connect to display + get channel info
C      
C ***************
C      
      CALL DTOPEN(1,STAT)
      CALL STKRDI('DAZHOLD',13,1,IAV,OVCON,UNI,NULO,STAT)
      CALL DTGICH(QDSPNO,QIMCH,INFRA,RINF,STAT)
      IF (SOURCE.NE.1) CALL STETER(2,'no image loaded...') 
C 
C  get displayed frame + null value
      CALL STIGET(INFRA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,3,
     +            NAXIS,NPIX,START,STEP,
     +            IDENT,CUNIT,PNTRA,IMNOA,STAT)
      IF (ZPLANE .NE. 0) THEN
         NN = (ZPLANE-1)*NPIX(1)*NPIX(2)
         PNTRA = PNTRA + NN                          !use displayed plane
      ENDIF
C      
      CALL PIXXCV('INIT',IMNOA,RBUF,STAT)            !set up PIXXCV
C      
C  if we do not use a reference slit, get width and length of slit + stepsizes
      IF (ACTION(2:2).EQ.'F') THEN
         CDUMMY = 'F'
      ELSE
         CALL STKRDC('P3',1,1,60,IAV,LINE,UNI,NULO,STAT)
         CALL STKRDD('INPUTD',1,2,IAV,STEPLN,UNI,NULO,STAT)
C      
C  extract length, width, x/y
         N = 1
         CALL EXTRSS(LINE,',',N,ATOM(1),NN)
         IF (NN.LE.0) GOTO 9100                        !wrong input...
         CALL EXTRSS(LINE,',',N,ATOM(2),NN)
         IF (NN.LE.0) GOTO 9100                        !wrong input...
         CALL EXTRSS(LINE,',',N,CDUMMY,NN)
         IF (NN.LE.0) CDUMMY = 'X'                  !default is x-coords.
      ENDIF
C      
C  first of all we need the frame pixel at center of screen
      PIXELS(1) = (QDSZX-1) * 0.5
      PIXELS(2) = (QDSZY-1) * 0.5
      CALL PIXXCV('SRW',0,PIXELS,STAT)
      XCENT = PIXELS(3)
      YCENT = PIXELS(4)
C      
C  either use x-coords
      IF (CDUMMY.EQ.'X') THEN            !convert char. strings to real pixels
         LINE(1:) = '[ '
         LINE(2:) = ATOM(1)
         N = INDEX(LINE,' ')
         LINE(N+1:) = ',@1] '
         CALL EXTCO1(IMNOA,LINE,2,N,SUBLO,STAT)
         IF (STAT.NE.0) GOTO 9100
         IPIXW = SUBLO(1)
         LINE(1:) = '[ '
         LINE(2:) = ATOM(2)
         N = INDEX(LINE,' ')
         LINE(N+1:) = ',@1] '
         CALL EXTCO1(IMNOA,LINE,2,N,SUBLO,STAT)
         IF (STAT.NE.0) GOTO 9100
         IPIXL = SUBLO(1)
C      
C  or use y-coords
      ELSE IF (CDUMMY.EQ.'Y') THEN
         LINE(1:) = '[@1, '
         LINE(5:) = ATOM(1)
         N = INDEX(LINE,' ')
         LINE(N+1:) = '] '
         CALL EXTCO1(IMNOA,LINE,2,N,SUBLO,STAT)
         IF (STAT.NE.0) GOTO 9100
         IPIXW = SUBLO(2)
         LINE(1:) = '[@1, '
         LINE(5:) = ATOM(2)
         N = INDEX(LINE,' ')
         LINE(N+1:) = '] '
         CALL EXTCO1(IMNOA,LINE,2,N,SUBLO,STAT)
         IF (STAT.NE.0) GOTO 9100
         IPIXL = SUBLO(2)
      ENDIF
C      
C  determine size of slit
      PIXELS(1) = XCENT - FLOAT(IPIXW/2)
      PIXELS(2) = YCENT - FLOAT(IPIXW/2)
      CALL PIXXCV('_RS',0,PIXELS,STAT)            !get screen pixels
      IF (STAT.NE.0) GOTO 9100                  !something wrong...
      X1 = PIXELS(5)                            !screen pixel offset
      Y1 = PIXELS(6)
      PIXELS(1) = PIXELS(1) + FLOAT(IPIXW)
      PIXELS(2) = PIXELS(2) + FLOAT(IPIXW)
      CALL PIXXCV('_RS',0,PIXELS,STAT)            !get screen pixels
      IF (STAT.NE.0) GOTO 9100                  !something wrong...
      X2 = PIXELS(5)                            !screen pixel end
      Y2 = PIXELS(6)
      IF (CDUMMY.NE.'Y') THEN
         WH = X2 - X1
      ELSE
         WH = Y2 - Y1
      ENDIF
C      
      PIXELS(1) = XCENT - FLOAT(IPIXL/2)
      PIXELS(2) = YCENT - FLOAT(IPIXL/2)
      CALL PIXXCV('_RS',0,PIXELS,STAT)            !get screen pixels
      IF (STAT.NE.0) GOTO 9100                  !something wrong...
      X1 = PIXELS(5)
      Y1 = PIXELS(6)
      PIXELS(1) = PIXELS(1) + FLOAT(IPIXL)
      PIXELS(2) = PIXELS(2) + FLOAT(IPIXL)
      CALL PIXXCV('_RS',0,PIXELS,STAT)            !get screen pixels
      IF (STAT.NE.0) GOTO 9100                  !something wrong...
      X2 = PIXELS(5)
      Y2 = PIXELS(6)
      IF (CDUMMY.NE.'Y') THEN
         SH = X2 - X1
      ELSE
         SH = Y2 - Y1
      ENDIF
C      
C  finally we get half the slit size in screen pixels
      WH = WH * 0.5
      SH = SH * 0.5
      IF ((WH.LT.1.).OR.(SH.LT.1.)) GOTO 9100        !SLITSZ too small
      IF ((WH+SH).GT.600.) GOTO 9100                 !SLITSZ too large
C
C  clear graphics channel (use same scroll values as for image channel)
      CALL CONCHA(QDSPNO,QOVCH,1,0)
      IF (OVCON.EQ.QIMCH)
     +   CALL DAZZSC(QDSPNO,QOVCH,ZOOMX,SCROLX,SCROLY,STAT)
C      
C  set up both cursors as cross hairs
      IF (IDINUM.EQ.11) THEN
         NOCUR = 3
         ENTFLG = 1
      ELSE
         NOCUR = 2
         ENTFLG = 2
      ENDIF
      CALL SETCUR(QDSPNO,0,8,2,COOS,STAT)         !shape = 8 for small crosshair
      CALL SETCUR(QDSPNO,1,8,2,COOS,STAT)
      CALL STKWRI('DAZHOLD',NOCUR,1,1,UNI,STAT)
C      
C  enable interaction
      CALL CURSIN(QDSPNO,0,NOCUR,NEW1,MC1,IS1,NEW2,MC2,IS2)
C
C  poll cursors to upgrade the graphs
100   CALL CURSIN(QDSPNO,ENTFLG,NOCUR,NEW1,MC1,IS1,NEW2,MC2,IS2)
C 
C  update rotation and/or slope coords.
      IF (NEW2(1).LT.NEW1(1)) THEN
         XR = NEW2(1)                        !keep only 2 possibilities...
         YR = NEW2(2)
         XS = NEW1(1)
         YS = NEW1(2)
      ELSE
         XR = NEW1(1)
         YR = NEW1(2)
         XS = NEW2(1)
         YS = NEW2(2)
      ENDIF
C
      IF ( (IS1.EQ.0) .AND. (IS2.EQ.0) ) THEN
         GOTO 1000                        
      ELSE IF (IS1.LT.0) THEN
         ENTER = 1
      ELSE
         ENTER = 0
      ENDIF
      PARAL = 0
C 
C  for XWindows we only draw upon ENTER
      IF ((IDINUM.EQ.11).AND.(ENTER.EQ.0)) GOTO 100
C
C  test for "critical" coordinates
      IF ((XS.EQ.XR).OR.(YS.EQ.YR)) THEN
         PARAL = 1
         GOTO 100
      ENDIF
C
C  calculate slope of line through cursors
      DX = FLOAT(XS-XR)
      DY = FLOAT(YS-YR)
      ALPHA = ATAN2(DY,DX)                          !in radians
C      
C  first get center coords
      XCENT = (XR + XS) * 0.5
      YCENT = (YR + YS) * 0.5
      XDELT = COS(ALPHA) * SH
      YDELT = SIN(ALPHA) * SH
      XS = XCENT + XDELT
      XR = XCENT - XDELT
      YS = YCENT + YDELT
      YR = YCENT - YDELT
C      
C  determine line at 90 degrees angle + endpoint on it
      BETA = ALPHA + (90. * FACTO)                 !remember that we work in radians
      XDELT = ABS(WH * COS(BETA))
      YDELT = ABS(WH * SIN(BETA))
C      
C  now build up slit
      IF (ALPHA.GT.0.) THEN
         X1 = XR - XDELT
         Y1 = YR + YDELT
         X2 = XR + XDELT
         Y2 = YR - YDELT
         X3 = XS + XDELT
         Y3 = YS - YDELT
         X4 = XS - XDELT
         Y4 = YS + YDELT
      ELSE
         X1 = XR + XDELT
         Y1 = YR + YDELT
         X2 = XR - XDELT
         Y2 = YR - YDELT
         X3 = XS - XDELT
         Y3 = YS - YDELT
         X4 = XS + XDELT
         Y4 = YS + YDELT
      ENDIF
C 
      IX1 = NINT(X1)
      IX2 = NINT(X2)
      IY1 = NINT(Y1)
      IY2 = NINT(Y2)
      IX3 = NINT(X3)
      IX4 = NINT(X4)
      IY3 = NINT(Y3)
      IY4 = NINT(Y4)
C
C  erase old vector + draw new vector
      XFIG(5) = XFIG(1)            !close rectangle
      YFIG(5) = YFIG(1)
      DO 510 N=1,5
         IF (XFIG(N).NE.XOLDFG(N)) GOTO 600
         IF (YFIG(N).NE.YOLDFG(N)) GOTO 600
510   CONTINUE
      GOTO 100                        !no change - poll cursors again
C      
C  draw slit in overlay plane 
600   IF (FIRTIM.NE.0) THEN                !erase old vector
         CALL IIGPLY(QDSPNO,QOVCH,XOLDFG,YOLDFG,5,0,1,STAT)
      ELSE
         FIRTIM = 1
      ENDIF
C
      CALL IIGPLY(QDSPNO,QOVCH,XFIG,YFIG,5,255,1,STAT)      !draw new vector
      DO 610, N=1,5                                         !save old rectangle
          XOLDFG(N) = XFIG(N)
         YOLDFG(N) = YFIG(N)
610   CONTINUE
      IF (ACTION(1:1).EQ.'C') GOTO 100
C
C  check out, if PARAL
1000  IF (PARAL.EQ.1) THEN
         LINE(1:) = 
     +   'PARAL subimages should be extracted via EXTRACT/CURSOR...'
         CALL STTPUT(LINE,STAT)
         CALL STTPUT('change angle or exit',STAT)
         GOTO 100
      ENDIF
C      
C  now convert the corner points from screen pixels to real pixel no's 
C  and  world coords
C 
      PIXELS(1) = IX2
      PIXELS(2) = IY2
      CALL PIXXCV('IRW',0,PIXELS,STAT)
      IF (STAT.NE.0) GOTO 9200                  !slit out of image bounds...
      PXSTA(1) = PIXELS(3)
      PXSTA(2) = PIXELS(4)
C      
      PIXELS(1) = IX3
      PIXELS(2) = IY3
      CALL PIXXCV('IRW',0,PIXELS,STAT)
      IF (STAT.NE.0) GOTO 9200                  !slit out of image bounds...
      PXEND(1) = PIXELS(3)
      PXEND(2) = PIXELS(4)
C      
      PIXELS(1) = IX1
      PIXELS(2) = IY1
      CALL PIXXCV('IRW',0,PIXELS,STAT)
      IF (STAT.NE.0) GOTO 9200                  !slit out of image bounds...
      PXSTAA(1) = PIXELS(3)
      PXSTAA(2) = PIXELS(4)
C      
      PIXELS(1) = IX4
      PIXELS(2) = IY4
      CALL PIXXCV('IRW',0,PIXELS,STAT)
      IF (STAT.NE.0) GOTO 9200                  !slit out of image bounds...
      PXENDA(1) = PIXELS(3)
      PXENDA(2) = PIXELS(4)
C      
      IF (ABS(STEPLN(2)).LE.10.E-10) THEN
         STEPLN(2) = STEP(2)
         PXSTEP(2) = 1.0
      ELSE
         PXSTEP(2) = STEPLN(2) / STEP(2)
      ENDIF
      IF (PXSTEP(2).LE.0.) GOTO 9300              !invalid stepsize...
C      
      IF (ABS(STEPLN(1)).LE.10.E-10) THEN
         STEPLN(1) = STEP(1)
         PXSTEP(1) = 1.0
      ELSE
         PXSTEP(1) = STEPLN(1) / STEP(1)
      ENDIF
      IF (PXSTEP(1).LE.0.) GOTO 9300                  !invalid stepsize...
C      
C  jump to common section
      GOTO 6000
C      
C ***************
C      
C  here we come for cursorless processing
C      
C ***************
C      
5000  CALL STKRDR('INPUTR',1,1,IAV,ALPHA,UNI,NULO,STAT)         !get slit angle
      ALPHA = ALPHA * FACTO                                     !with base line
      BETA = ALPHA + (90. * FACTO)
C      
C  build up slit in input frame
      PXSTA(1) = (RFSTA(1) - START(1))/STEP(1) + 1.
      PXSTA(2) = (RFSTA(2) - START(2))/STEP(2) + 1.
      PXSTEP(1) = STEPLN(1) / STEP(1)
      PXSTEP(2) = STEPLN(2) / STEP(2)
C      
C  endpoint after slitlength (add 2 more pixels for security...)
      NN = IPIXL + 1
      PXEND(1) = PXSTA(1) + (NN * PXSTEP(1) * COS(ALPHA))
      PXEND(2) = PXSTA(2) + (NN * PXSTEP(1) * SIN(ALPHA))
C      
C  endpoint after slitwidth (add 2 more pixels for security...)
      NN = IPIXW + 1
      PXSTAA(1) = PXSTA(1) + (NN * PXSTEP(2) * COS(BETA))
      PXSTAA(2) = PXSTA(2) + (NN * PXSTEP(2) * SIN(BETA))
C      
C ***************
C      
C  common section for all options
C      
C ***************
C      
C  pull out max. MAXIDX lines from area inside slit
6000  CALL PIXLIN(PXSTA(1),PXSTA(2),PXSTAA(1),PXSTAA(2),PXSTEP(2),
     +            MADRID(PNTRX),MADRID(PNTRY),MAXIDX,NINDX)
      IF (NINDX.LT.IPIXW) THEN
         WRITE(LINE,10002) NINDX
         CALL STTPUT(LINE,STAT)
         IPIXW = NINDX
      ENDIF
C      
C  pull out max. MAXIDX pixels per line along slit
      CALL PIXLIN(PXSTA(1),PXSTA(2),PXEND(1),PXEND(2),PXSTEP(1),
     +            MADRID(PNTRX),MADRID(PNTRY),MAXIDX,NINDX)
      IF (NINDX.LT.IPIXL) THEN
         WRITE(LINE,10001) NINDX
         CALL STTPUT(LINE,STAT)
         IPIXL = NINDX
      ENDIF
C      
C  create output file + get z-values for pixels recorded in XINDX + YINDX
      NPOLD(1) = NPIX(1)
      NPOLD(2) = NPIX(2)
      NPIX(1) = IPIXL
      NPIX(2) = IPIXW
      START(1) = START(1) + (PXSTA(1)-1)*STEP(1)
      START(2) = START(2) + (PXSTA(2)-1)*STEP(2)
      STEP(1) = STEPLN(1)
      STEP(2) = STEPLN(2)
C      
C  map output frame
      CALL STIPUT(OUTFRA,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +            2,NPIX,START,STEP,IDENT,
     +            CUNIT,PNTRB,IMNOB,STAT)
C      
C  compute increments in y (in pixel space)
      CA = PXSTEP(2) * COS(BETA)
      SA = PXSTEP(2) * SIN(BETA)
C      
C  and pull out complete image
      DO 8000, N=1,IPIXW
         CALL ZIMA(MADRID(PNTRA),NPOLD,MADRID(PNTRX),MADRID(PNTRY),
     +             IPIXL,MADRID(PNTRB),CUTS(3),CUTS(4))
C      
C      increment ystep and extract next line
            PXSTA(1) = PXSTA(1) + CA
            PXSTA(2) = PXSTA(2) + SA
            PXEND(1) = PXEND(1) + CA
            PXEND(2) = PXEND(2) + SA
            CALL PIXLIN(PXSTA(1),PXSTA(2),PXEND(1),PXEND(2),PXSTEP(1),
     +                  MADRID(PNTRX),MADRID(PNTRY),IPIXL,NN)
            PNTRB = PNTRB + IPIXL                  !update pointer...
8000  CONTINUE
C      
C  complete file is extracted...
      NN = INDEX(OUTFRA,' ') - 1
      IF (NN.LE.0) NN = LEN(OUTFRA)
      LINE(1:) = 'frame '//OUTFRA(1:NN)//' created'
      CALL STTPUT(LINE,STAT)
      CALL DSCUPT(IMNOA,IMNOB,' ',STAT)
C
C  that's it folks...
      IF (ACTION(1:1).EQ.'C') CALL DTCLOS(QDSPNO)
      CALL STSEPI
C      
9100  CALL STETER(3,'invalid slit size given...')
9200  CALL STETER(4,'slit out of image bounds...')
9300  CALL STETER(5,'invalid stepsize...')
C      
10001 FORMAT(' Warning: slit length only ',I4,' pixels...')
10002 FORMAT(' Warning: slit width only ',I4,' lines...')
C 
      END

C @(#)dophot.for	19.1 (ES0-DMD) 02/25/03 13:23:48
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      character*35 logfile
      character*30 direc, frames, table
      character*30 pict, switch, jobfile
      real*4 radii(2), psfopt(2)
c
c Get input relevant to all frames
c
      call getchr ('Directory:', direc, ndi)
      call getdat ('Find threshold (in sigmas):', thresh, 1)
      call getchr ('Aperture photometry table:', table, nta)
      call getdat ('Fitting radius, psf radius:', radii, 2)
      call getdat ('Number of PSF stars, analytic model:',
     .     psfopt, 2)
c
c-------------------------------------------------------------
c
c Loop over frames
c
  900 call tblank
c
c Get information relevant to this frame only
c
 1000 call getnam ('Input image:', pict)
      if ((pict .eq. 'END OF FILE') .or. 
     .     (pict .eq. 'EXIT')) call byebye
      call getchr ('Frames averaged, added:', frames, nfr)
c
c Open jobfile and write initial stuff
c
      jobfile = switch(pict, '.dop')
      call outfil (3, jobfile, istat)
      call startup (direc, ndi, pict, jobfile, logfile)
c
c Set up daophot/allstar commands
c
      call remove (switch(pict, '.coo'))
      call remove (switch(pict, '.ap'))
      call remove (switch(pict, '.lst'))
      call remove (switch(pict, '.psf'))
      call remove (switch(pict, '.nei'))
      call run ('daophot', logfile)
      write (3,*) 'no'
      write (3,*) 'no'
      write (3,*) 'op'
      write (3,*) ' '
      write (3,*) 'threshold =', thresh+2.
      write (3,*) 'wa = -2'
      write (3,*) 'va = -1'
      write (3,*) 'fi =', radii(1)
      write (3,*) 'ps =', radii(2)
      write (3,*) 'an =', psfopt(2)
      write (3,*) ' '
      write (3,*) 'attach ', pict
      write (3,*) 'find'
      write (3,*) frames(1:nfr)
      write (3,*) ' '
      write (3,*) 'y'
      write (3,*) 'photometry'
      write (3,*) table(1:nta)
      write (3,*) 'A2 = 0'
      write (3,*) ' '
      write (3,*) ' '
      write (3,*) ' '
      write (3,*) 'pickpsf'
      write (3,*) ' '
      write (3,*) psfopt(1)
      write (3,*) ' '
      write (3,*) 'psf'
      write (3,*) ' '
      write (3,*) ' '
      write (3,*) ' '
      write (3,*) 'exit'
      call confrm (ndi, logfile, jobfile)
      call remove (switch(pict, '.coo'))
c
      call remove (switch(pict, '.als'))
      call run ('allstar', logfile)
      write (3,*) 'wa = 0'
      write (3,*) 'fi =', radii(1)
      write (3,*) ' '
      write (3,*) pict
      write (3,*) switch(pict, '.psf')
      write (3,*) switch(pict, '.nei')
      write (3,*) ' '
      write (3,*) ' '
      call confrm (ndi, logfile, jobfile)
      call remove (switch(pict, '.nei'))
c
      call remove (switch(pict, '.jnk'))
      call run ('daophot', logfile)
      write (3,*) 'no'
      write (3,*) 'no'
      write (3,*) 'attach ', pict
      write (3,*) 'sub'
      write (3,*) ' '
      write (3,*) '.als'
      write (3,*) 'y'
      write (3,*) ' '
      write (3,*) ' '
      write (3,*) 'attach ', switch(pict, 's')
      write (3,*) 'op'
      write (3,*) ' '
      write (3,*) 'wa = -2'
      write (3,*) 'va = 0'
      write (3,*) 'fi =', radii(1)
      write (3,*) 'ps =', radii(2)
      write (3,*) 'an =', psfopt(2)
      write (3,*) ' '
      write (3,*) 'psf'
      write (3,*) switch(pict, '.als')
      write (3,*) switch(pict, '.lst')
      write (3,*) switch(pict, '.jnk')
      write (3,*) 'exit'
      call confrm (ndi, logfile, jobfile)
      call rename (switch(pict, '.jnk'), switch(pict, '.psf'))
c
      call run ('allstar', logfile)
      write (3,*) 'wa = 0'
      write (3,*) 'fi =', radii(1)
      write (3,*) ' '
      write (3,*) pict
      write (3,*) switch(pict, '.psf')
      write (3,*) switch(pict, '.ap')
      write (3,*) switch(pict, '.jnk')
      write (3,*) ' '
      call confrm (ndi, logfile, jobfile)
      call rename (switch(pict, '.jnk'), switch(pict, '.als'))
      call remove (switch(pict, '.ap'))
c
      call remove (switch(pict, 's.coo'))
      call remove (switch(pict, 's.off'))
      call remove (switch(pict, 's.ap'))
      call run ('daophot', logfile)
      write (3,*) 'no'
      write (3,*) 'no'
      write (3,*) 'op'
      write (3,*) ' '
      write (3,*) 'threshold = ', thresh
      write (3,*) ' '
      write (3,*) 'attach ', switch(pict, 's')
      write (3,*) 'find'
      write (3,*) frames(1:nfr)
      write (3,*) ' '
      write (3,*) 'y'
      write (3,*) 'offset'
      write (3,*) switch(pict, 's.coo')
      write (3,*) '50000 0 0 0'
      write (3,*)
      write (3,*) 'photometry'
      write (3,*) table(1:nta)
      write (3,*) 'A2 = 0'
      write (3,*) ' '
      write (3,*) switch(pict, 's.off')
      write (3,*) ' '
      write (3,*) 'ex'
      call confrm (ndi, logfile, jobfile)
c
      call remove (switch(pict, 's.als'))
      call run ('allstar', logfile)
      write (3,*) 'wa = 0'
      write (3,*) 'fi =', radii(1)
      write (3,*) ' '
      write (3,*) switch(pict, 's')
      write (3,*) switch(pict, '.psf')
      write (3,*) switch(pict, 's.ap')
      write (3,*) ' '
      write (3,*) 'END OF FILE'
      call confrm (ndi, logfile, jobfile)
c
      call remove (switch(pict, '.cmb'))
      call remove (switch(pict, '.jnk'))
      call remove (switch(pict, '.nei'))
      call run ('daophot', logfile)
      write (3,*) 'no'
      write (3,*) 'no'
      write (3,*) 'append'
      write (3,*) switch(pict, 's.als')
      write (3,*) switch(pict, '.als')
      write (3,*) switch(pict, '.cmb')
      write (3,*) 'attach ', pict
      write (3,*) 'sub'
      write (3,*) switch(pict, '.psf')
      write (3,*) '.cmb'
      write (3,*) 'y'
      write (3,*) ' '
      write (3,*) ' '
      write (3,*) 'attach ', switch(pict, 's')
      write (3,*) 'op'
      write (3,*) ' '
      write (3,*) 'wa = -2'
      write (3,*) 'va = 1'
      write (3,*) 'fi =', radii(1)
      write (3,*) 'ps =', radii(2)
      write (3,*) 'an =', psfopt(2)
      write (3,*) ' '
      write (3,*) 'psf'
      write (3,*) switch(pict, '.als')
      write (3,*) switch(pict, '.lst')
      write (3,*) switch(pict, '.jnk')
      write (3,*) 'exit'
      call confrm (ndi, logfile, jobfile)
      call rename (switch(pict, '.jnk'), switch(pict, '.psf'))
      call remove (switch(pict, '.nei'))
      call remove (switch(pict, 's.coo'))
      call remove (switch(pict, 's.off'))
      call remove (switch(pict, 's.ap'))
      call remove (switch(pict, 's.grp'))
      call remove (switch(pict, 's.nst'))
c
      call run ('allstar', logfile)
      write (3,*) 'wa = 0'
      write (3,*) 'fi =', radii(1)
      write (3,*) ' '
      write (3,*) pict
      write (3,*) switch(pict, '.psf')
      write (3,*) switch(pict, '.cmb')
      write (3,*) switch(pict, '.jnk')
      write (3,*) ' '
      call confrm (ndi, logfile, jobfile)
      call rename (switch(pict, '.jnk'), switch(pict, '.als'))
      call remove (switch(pict, '.cmb'))
c
      call shutdwn (ndi, jobfile)
      call clfile (3)
      pict = 'EXIT'
      go to 900
      end!
c
c
c
      subroutine remove (file)
      character*30 file
      write (3,*) 'if (-f ', file, ') rm ', file
      return
      end!
c
c
c
      subroutine confrm (ndi, logfile, jobfile)
      character*30 logfile, jobfile
      if (ndi .gt. 0) then
         write (3,1) logfile, jobfile, logfile
    1    format ('DONE'/'set temp=`tail -2 ', a, ' | head -1`'/
     .       'if ("$temp" != "Good bye.") then'/
     .       'cat << DONE >>! ~/running'//
     .       'cpu *BOMBED* ', a/
     .       'DONE'/
     .       'date >>! ~/running'/
     .       'exit'/'endif'/
     .       'cat << DONE >>! ', a/
     .       'Continuing...'//'DONE')
      else
         write (3,2)
    2    format ('DONE')
      end if
      return
      end!
c
c
c
      subroutine rename (file1, file2)
      character*(*) file1, file2
      write (3,*) 'mv ', file1, ' ', file2
      return
      end
c
c
c
      subroutine delete (file)
      character*(*) file
      write (3,*) 'rm ', file
      return
      end
c
c
c
      subroutine startup (direc, ndi, pict, jobfile, logfile)
      character*30 switch
      character*(*) direc, pict, jobfile, logfile
      write (3,*) 'source ~pstetson/.daophot'
      if (ndi .gt. 0) then
         write (3,*) 'set cpu = `hostname`'
         write (3,*) 'set job = ', pict
         write (3,*) 'cat >>! ~/running << DONE'
         write (3,*) ' '
         write (3,*) '$cpu is starting ', jobfile
         write (3,*) 'DONE'
         write (3,*) 'date >>! ~/running'
         write (3,*) 'cd ', direc(1:ndi)
      end if
      logfile = '$scr/'//switch(pict, '.log')
      return
      end!
c
c
c
      subroutine run (progrm, logfile)
      character*(*) progrm, logfile
      write (3,*) 'daophot << DONE >>! ', logfile
      return
      end!
c
c
c
      subroutine shutdwn (ndi, jobfile)
      character*(*) jobfile
      if (ndi .gt. 0) then
         write (3,*) 'cat >>! ~/running << DONE'
         write (3,*) ' '
         write (3,*) '$cpu finished ', jobfile
         write (3,*) 'DONE'
         write (3,*) 'date >>! ~/running'
      end if
      return
      end!

C @(#)lench.for	19.1 (ES0-DMD) 02/25/03 13:32:58
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C  @(#)lench.for	5.1 (ESO-IPG) 4/5/93 15:58:34
      INTEGER FUNCTION LENCH(STRING)
C
C    Find length of non-trivial string, i.e.
C    of string with trailing nonprintable characters truncated
C
      IMPLICIT NONE
      CHARACTER*(*) STRING
C
      CHARACTER*256 CHSET
      INTEGER       LEN,LENGTH,NC,NSET
C
      CHSET=
     $   '~!@#$%^&*()_+|`1234567890-=\\{}[]:";''<>?,./'//
     $   'QWERTYUIOPASDFGHJKLZXCVBNMqwertyuiopasdfghjklzxcvbnm'
C2345678901234567890123456789012345678901234567890123456789012345678901234567890
C        1         2         3         4         5         6         7
      NSET=42+52
      LENCH=LEN(STRING)
      DO 1 LENGTH=LEN(STRING),1,-1
        DO 2 NC=1,NSET
          IF(STRING(LENGTH:LENGTH).EQ.CHSET(NC:NC)) THEN
            GOTO 9
          ENDIF
 2      CONTINUE
        LENCH=LENGTH-1
 1    CONTINUE
 9    END

C @(#)pckpsf.for	19.1 (ES0-DMD) 02/25/03 13:23:50
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE  PCKPSF  (ID, X, Y, M, S, INDEX, MAX, FITRAD, PSFRAD)
C
C=======================================================================
C
C Subroutine to read in any of the data files created by DAOPHOT and
C to select reasonable candidates for PSF stars:
C
C   (1) More than a critical distance from the edge of the frame, and
C   (2) Having no brighter star within a critical distance.
C
C              OFFICIAL DAO VERSION:  1991 April 18
C
C=======================================================================
C
      IMPLICIT NONE
      INTEGER MAX
C
C MAX is the maximum number of stars permitted in a data file.
C
      REAL X(MAX), Y(MAX), M(MAX), S(MAX)
      INTEGER ID(MAX), INDEX(MAX)
C
      REAL ABS
C
      CHARACTER*30 COOFIL, MAGFIL, PSFFIL, PROFIL, GRPFIL, SWITCH
      CHARACTER FILE*30, CASE*4
      REAL PSFRAD, FITRAD, RADSQ, DY, RADIUS, LOBAD, HIBAD, THRESH
      REAL AP1, PHPADU, READNS, FRAD, XYMIN, XMAX, YMAX
      INTEGER I, J, N, NREQ, ISTAR, JSTAR, ISTAT, NL, NCOL, NROW
      INTEGER ITEMS, NSTAR
C
      COMMON /FILNAM/ COOFIL, MAGFIL, PSFFIL, PROFIL, GRPFIL
C
C-----------------------------------------------------------------------
C
C SECTION 1
C
C Get input file name, open the file, and read its header.
C
      CALL TBLANK
      CALL GETNAM ('Input file name:', MAGFIL)
      IF ((MAGFIL .EQ. 'END OF FILE') .OR. 
     .     (MAGFIL .EQ. 'EXIT')) THEN
         MAGFIL = ' '
         RETURN
      END IF
C
      CALL INFILE (2, MAGFIL, ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error opening input file '//MAGFIL)
         RETURN
      END IF
C
      CALL GETDAT ('Desired number of PSF stars:', DY, 1)
      IF (DY .LE. 0.5) THEN
         CALL CLFILE (2)
         RETURN
      END IF
      NREQ = NINT(DY)
C
C Generate output file name and open the file.
C
      FILE = SWITCH (MAGFIL, CASE('.lst'))
      CALL GETNAM ('Output file name:', FILE)
      CALL OUTFIL (3, FILE, ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error opening output file '//FILE)
         CALL CLFILE (2)
         RETURN
      END IF
C
      NL = 0
      CALL RDHEAD (2, NL, NCOL, NROW, LOBAD, HIBAD, THRESH, AP1,
     .     PHPADU, READNS, FRAD)
      IF (NL .EQ. 0) NL = 1
      IF (NL .GT. 3) NL = 1
C
C Copy input file header to output file.
C
      ITEMS = 6
      IF (FRAD .GT. 0.) ITEMS = 7
      CALL WRHEAD (3, 3, NCOL, NROW, ITEMS, LOBAD, HIBAD, THRESH,
     .     AP1, PHPADU, READNS, FRAD)
      XYMIN = FITRAD + 1.
      XMAX = REAL(NCOL) - FITRAD
      YMAX = REAL(NROW) - FITRAD
      RADIUS = PSFRAD+FITRAD
      RADSQ = RADIUS**2
C
C-----------------------------------------------------------------------
C
C SECTION 2
C
C Read the input file in star by star.
C
      I=0
 2000 I=I+1                                   ! Begin loop over stars
C
 2010 CALL RDSTAR (2, NL, ID(I), X(I), Y(I), M(I), S(I))
      IF (ID(I) .LT. 0) GO TO 2100            ! END OF FILE encountered
      IF (ID(I) .EQ. 0) GO TO 2010            ! Blank line encountered
      IF (M(I) .GT. 90.) M(I) = -M(I)
      IF (I .LT. MAX) GO TO 2000
C
      CALL STUPID ('*** WARNING ***  Too many stars in input file.')
      WRITE (6,6) MAX
    6 FORMAT (I10, ' stars have been read.  I will work with these.')
      I = I+1
C
C Perform the selection.
C
 2100 NSTAR=I-1                                      ! Number of stars
      CLOSE (2)
      CALL QUICK (M, NSTAR, INDEX)
      I = INDEX(1)
      IF ((M(1) .GT. -90.) .AND. (X(I) .GE. XYMIN) .AND.
     .     (Y(I) .GE. XYMIN) .AND. (X(I) .LE. XMAX) .AND.
     .     (Y(I) .LE. YMAX)) THEN
         WRITE (3,321) ID(I), X(I), Y(I), M(1), S(I)
  321    FORMAT (I6, 4(F9.3,1X))
         N = 1
      ELSE
         N = 0
      END IF
C
      DO 2195 ISTAR=2,NSTAR
         I = INDEX(ISTAR)
         IF ((M(ISTAR) .LT. -90.) .OR. (X(I) .LT. XYMIN) .OR.
     .        (Y(I) .LT. XYMIN) .OR. (X(I) .GT. XMAX) .OR.
     .        (Y(I) .GT. YMAX)) GO TO 2195
C
         DO 2190 JSTAR=1,ISTAR-1
            J = INDEX(JSTAR)
            DY = ABS(Y(J)-Y(I))
            IF (DY .GE. RADIUS) GO TO 2190
            DY = DY**2 + (X(J)-X(I))**2
            IF (DY .LT. RADSQ) GO TO 2195
 2190    CONTINUE
C
         WRITE (3,321) ID(I), X(I), Y(I), M(ISTAR), S(I)
         N = N+1
         IF (N .GE. NREQ) GO TO 2200
 2195 CONTINUE
C
 2200 CLOSE (3)
      WRITE (6,7) N
    7 FORMAT (/I10, ' suitable candidates were found.'/)
      RETURN
C
      END!

C @(#)ldaif.for	19.1 (ES0-DMD) 02/25/03 13:27:33
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C-----------------------------------------------------------------------
C
C.IDENTIFICATION
C
C  Program LDAIF
C
C.AUTHOR
C
C  F. Murtagh, ST-ECF, Garching.             Version 1.0  14 June 1986
C  F. Murtagh                                Version 2.0  Oct. 1988
C                                            (New std. ifs.)
C
C.PURPOSE
C
C  Pass parameters to, and execute, LDA (Fisher's Linear Discriminant
C  Analysis).
C
C.INPUT/OUTPUT
C
C  P1 and P2 contain parameters; these are: input table name, and output
C  table name.
C
C.ALGORITHM
C
C . uses Midas Table interface routines;
C . input table is assumed to contain entries in single precision;
C . no select or null values
C . all columns of the input table are sent to the LDA routine;
C . description of the LDA  routine is in the corresponding program;
C . the final column of the table input is taken as the definition of
C   the group memberships (values of 1, 2 and 0=unassigned are acceptable);
C . the output produced consists of a table with one column, giving the
C   projections on the axis connecting the two group centres of gravity;
C   value 0 divides the groups.
C . storage is limited only by the Midas Table system, and by the
C   overall system limitations;
C
C.MODIFICATIONS
C
C  NEW STANDARD INTERFACES, F. MURTAGH, AUG. 1988
C  New Table File System    M. Peron    SEP91
C-----------------------------------------------------------------------
        PROGRAM LDAIF
C
        CHARACTER*6     FORM
        CHARACTER*60     NAMEIN, NAMEOUT
        CHARACTER*16    UNIT, LABEL
        INTEGER         NACTV,ISTAT,TID1,NCOLIN,NROW
        INTEGER         NSORTC,NAC,NAR,I,LEN,NSEL,NTOT
        INTEGER         IPTRIN,IWPTRIN,IPTRGP,INULL
        INTEGER         ILOW,IHIGH,IACTV,NCOLOUT
        INTEGER         TID,NNCOL,NNROW,NSC1,NAROUT
        INTEGER         IPTROUT,IWPTROUT,M
        INTEGER         IADD0,IADD1,IADD2,IADD3,IADD4,IADD5
        INTEGER         IADD6,IADD7,IERR
        INTEGER         MADRID, KUN, KNUL, DTYPE
        INCLUDE         'MID_INCLUDE:TABLES.INC/NOLIST'
        COMMON          /VMR/MADRID(1)
        INCLUDE         'MID_INCLUDE:TABLED.INC/NOLIST'
C
C
C ...   Assuming this is our first action ...
C
        CALL STSPRO('LDAIF')
        DTYPE = D_R4_FORMAT
C
C ...   Get table name as a keyword passed in the command line.
C
        CALL STKRDC('P1',1,1,60,NACTV,NAMEIN,KUN,KNUL,ISTAT)
C
C ...   Read input table.
C
        CALL TBTOPN(NAMEIN,16,TID1,ISTAT)
        CALL TBIGET(TID1,NCOLIN,NROW,NSORTC,NAC,NAR,ISTAT)
C
C ...   Some error checking on input.
C
        IF (NROW.LT.1.OR.NCOLIN.LT.1) THEN
           CALL STTPUT(' Nos. of rows/columns are less than 1.',ISTAT)
           CALL STTPUT(' What sort of a table is this ??',ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
C
        DO I = 1, NCOLIN
           CALL TBFGET(TID1,I,FORM,LEN,DTYPE,ISTAT)
           IF (DTYPE.NE.D_R4_FORMAT) THEN
              CALL STTPUT(' Illegal format:',ISTAT)
              CALL STTPUT(' Only R*4 column type allowed.',ISTAT)
              CALL STTPUT(' Aborting.',ISTAT)
              GOTO 9000
           ENDIF
        ENDDO

        CALL CHSEL(TID1,NROW,NSEL)
        IF (NSEL.NE.NROW) THEN
           CALL STTPUT(' Not all rows are SELECTed. ',ISTAT)
           CALL STTPUT(' In current implementation, MUST select all.',
     X                                                         ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
        NSEL = NROW
C
C ...   Pointer IPTRIN will map the beginning of the data in NAMEIN ...
        CALL TDMGET(4*NROW*NCOLIN,IWPTRIN,ISTAT)
        CALL TBCMAP(TID1,1,IPTRIN,ISTAT)
C ...   ... and pointer IPTRGP will map the last column (gp. memberships).
        CALL MAPSM(MADRID(IPTRIN),MADRID(IWPTRIN),
     1              NAR,NROW,NCOLIN-1)
        CALL TBCMAP(TID1,NCOLIN,IPTRGP,ISTAT)
        NTOT = NROW*(NCOLIN-1)
        CALL CHNULL(MADRID(IWPTRIN),NTOT,INULL)
        IF (INULL.NE.0) THEN
           CALL STTPUT
     X     (' Null entries in the table are not allowed.',ISTAT)
           CALL STTPUT
     X     (' Use SELECT, and then construct another table.',
     X                                                    ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
        CALL TBL_CHGP(MADRID(IPTRGP),NROW,ILOW,IHIGH)
        IF (ILOW.NE.0.OR.IHIGH.NE.0) THEN
           CALL STTPUT(' Group memberships are unacceptable.',ISTAT)
           CALL STTPUT(' Check last column of the input table.',ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF

C
C
C ...   Get the output table name.
C
        CALL STKRDC('P2',1,1,60,IACTV,NAMEOUT,KUN,KNUL,ISTAT)
C
C ...   Now create the output (projections) table.
C
        NCOLOUT = 1
        CALL TBTINI(NAMEOUT,F_TRANS,17,NCOLOUT,NROW,TID,ISTAT)
        FORM = 'G14.6'
        UNIT = ' '
        LABEL = 'PROJNS'
        CALL TBCINI(TID,DTYPE,1,FORM,UNIT,LABEL,NSORTC,ISTAT)
C
        CALL TBIGET(TID,NNCOL,NNROW,NSC1,NAC,NAROUT,ISTAT)
        CALL TDMGET(4*NCOLOUT*NCOLIN,IWPTROUT,ISTAT)
        CALL TBCMAP(TID,1,IPTROUT,ISTAT)
        CALL MAPSM(MADRID(IPTROUT),MADRID(IWPTROUT),
     1              NAROUT,NROW,NCOLOUT)

C
C ...   Allocate storage.
C
        M = NCOLIN-1
        CALL GETSTOR(M,IADD0)
        CALL GETSTOR(2*M,IADD1)
        CALL GETSTOR(M*M,IADD2)
        CALL GETSTOR(M,IADD3)
        CALL GETSTOR(M,IADD4)
        CALL GETSTOR(M,IADD5)
        CALL GETSTOR(NROW*M,IADD6)
        CALL GETSTOR(NROW,IADD7)
C
C ...   We now have all the storage we need; APPL will look after
C       a few further odds and ends - e.g. setting a few hard-wired
C       options, rearranging output, etc.  Then it will call the
C       application program.
C
        IERR = 0
        CALL APPL(NROW,M,MADRID(IWPTRIN),MADRID(IPTRGP),
     X  MADRID(IWPTROUT),MADRID(IADD0),MADRID(IADD1),MADRID(IADD2),
     X  MADRID(IADD3),MADRID(IADD4),
     X  MADRID(IADD5),MADRID(IADD6),MADRID(IADD7),IERR)
        CALL MAPBG(MADRID(IWPTROUT),MADRID(IPTROUT),
     1             NAROUT,NROW,NCOLOUT)
        IF (IERR.EQ.1) THEN
           CALL STTPUT(' IERR = 1 on return from LDA.',ISTAT)
           CALL STTPUT(' Group memberships are not 1 and 2.',ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
        IF (IERR.EQ.2) THEN
           CALL STTPUT(' IERR = 2 on return from LDA.',ISTAT)
           CALL STTPUT
     X(' Singular total varariance-covariance matrix.',ISTAT)
           CALL STTPUT
     X(' Is nrows > ncols? or is some column identically valued?',ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
        IF (IERR.NE.0) THEN
           CALL STTPUT(' IERR not 0 on return from LDA.',ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
C
C ...   Finish up: write output file to disk, and release memory space.
C
        CALL RELSTOR(M,IADD0)
        CALL RELSTOR(2*M,IADD1)
        CALL RELSTOR(M*M,IADD2)
        CALL RELSTOR(M,IADD3)
        CALL RELSTOR(M,IADD4)
        CALL RELSTOR(M,IADD5)
        CALL RELSTOR(NROW*M,IADD6)
        CALL RELSTOR(M,IADD7)
C
        CALL TBTCLO(TID1,ISTAT)
C
        CALL TBIPUT(TID,NCOLOUT,NROW,ISTAT)
        CALL TBSINI(TID,ISTAT)
        CALL TBTCLO(TID,ISTAT)
C
 9000   CONTINUE
        CALL STSEPI
C
        END
C----------------------------------------------------------------------
        SUBROUTINE APPL(N,M,AIN,AGP,AOUT,MEAN,GPM,TOT,W1,W2,W3,
     X                  ACREA,GP,IERR)
C
C ...   This is now the application routine - note the setting of
C       parameters, which in a future epoch may be passed if desired
C       on the command line.
C
        INTEGER N,M,I,J,IERR,IPRINT
        REAL*4  AIN(N,M), AGP(N), AOUT(N), MEAN(M), GPM(2,M), TOT(M,M),
     X          W1(M), W2(M), W3(M), ACREA(N,M)
        INTEGER*4 GP(N)
C
        IPRINT = 3
C
        DO I = 1, N
           GP(I) = AGP(I)
           DO J = 1, M
              ACREA(I,J) = AIN(I,J)
           ENDDO
        ENDDO
C
        CALL LDA(N,M,ACREA,GP,IPRINT,MEAN,GPM,TOT,W1,W2,W3,IERR)
C
        IF (IERR.NE.0) RETURN
C
        DO I = 1, N
           AOUT(I) = ACREA(I,1)
        ENDDO
C
        RETURN
        END
C-------------------------------------------------------------------------
        SUBROUTINE CHNULL(X,NT,NULL)
C ...   Check if null values are present.
        REAL*4  X(NT), TRNULL
        INTEGER TINULL,NT,NULL,I
        DOUBLE PRECISION TDNULL
        CALL TBMNUL(TINULL,TRNULL,TDNULL)
        NULL = 0
        DO I = 1, NT
           IF (X(I).EQ.TRNULL) NULL = NULL + 1
           IF (NULL.GT.0) RETURN
        ENDDO
        RETURN
        END
C-------------------------------------------------------------------------
        SUBROUTINE TBL_CHGP(X,NT,IL,IH)
C ...   Check if unacceptable group membership values are present.
        INTEGER NT,I,IL,IH
        REAL*4  X(NT)
        IL = 0
        IH = 0
        DO I = 1, NT
           IF (X(I).LT.0.0) IL = IL + 1
           IF (X(I).GT.2.0) IH = IH + 1
           IF (IL.GT.0.OR.IH.GT.0) RETURN
        ENDDO
        RETURN
        END
C-------------------------------------------------------------------------
        SUBROUTINE GETSTOR(NVALS,IPTR)
C ...   Allocate storage space for NVALS real values.
        INTEGER NVALS,IPTR,ISTAT
        CALL TDMGET(4*NVALS,IPTR,ISTAT)
        RETURN
        END
C-------------------------------------------------------------------------
        SUBROUTINE RELSTOR(NVALS,IPTR)
C ...   Release storage space (already allocated) for NVALS real values.
        INTEGER NVALS,IPTR,ISTAT
        CALL TDMFRE(4*NVALS,IPTR,ISTAT)
        RETURN
        END

C @(#)subsky.for	19.1 (ESO-DMD) 02/25/03 13:31:24
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM SUBSKY
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  Program    SUBSKY                        version 1.00           881010
C  Principle proposed by: L. Lucy        ESO - Garching     1988 October 
C  MIDAS implementation:  D. Baade       ESO - Garching
C                                                   1.10           890518
C                                                   1.20           900220
C
C.KEYWORDS
C  Noise reduction, background subtraction 
C
C.PURPOSE
C  Subtract sky from images (model sky by extrapolating reference sky 
C  histogram to full frame). Reduce number of pixels with negative fluxes. 
C
C.ALGORITHM
C  Get the names of input + output frames from IN_A + OUT_A. Use the 
C  supplied histogram (in descriptor HISTOGRAM; descriptor STATISTIC 
C  must also be set as by MIDAS command STATISTIC/IMAGE) as a model of 
C  the background. Scale up this sky reference histogram to area of 
C  full frame. Bin-wise ratio to actual image histogram provides probability 
C  that a pixel in a given bin is due to background. If this probability 
C  is unity, set all pixels in the bin concerned to zero. Otherwise rank 
C  pixels in the bin considered by the mean flux in the ambient m x n image 
C  pixels. If NZERO pixels are probably due to background and therefore 
C  to be zeroed, select NZERO lowest ranking pixels and set them to zero. 
C  Subtract the expectation value computed for all lower bins excluding the 
C  current one from the remaining pixels in the bin. Flux conservation is 
C  not fully maintained. 
C
C.INPUT/OUTPUT
C  the following keys are used:
C
C  IN_A/C/1/60                  input frame (with STAT/IMA previously applied) 
C  OUT_A/C/1/60                 output frame 
C  INPUTI/I/1/2                 dimensions of neighbourhood box  
C
C.REFERENCES TO EXTERNAL SUBROUTINES OTHER THAN THE MIDAS STANDARD INTERFACES
C
C  HSTVLS                       to compute histogram (link with ugenlib)
C
C.VERSIONS
C  1.10  ???    KB   adapted to Portable MIDAS 
C  1.11  900807 RHW  bug fixed in routine INDEXX (sorting of 1 element failed)
C  1.20  910220 DB   a) made box size free parameter, 
C                    b) changed some working buffers from REAL to INTEGER 
C                    c) introduced finer resolution of flux values before 
C                       sorting (subroutine AMBINT)
C                    d) re-introduced original version of subroutine INDEXX
C                       but now paying special attention to case N=1 
C        
C 
C 010201		last modif
C 
C --------------------------------------------------------------------
C
      IMPLICIT NONE
C      
      INTEGER     STAT,NAXIS,NPIX(3),IAV,SHISTO(1000),WTO(2)
      INTEGER     WFR(2),NBIN,ISIZ
      INTEGER     INNO,OUTNO,BOX(2)
      INTEGER     AMBNO,SBINNO,INDXNO,SCR1NO,SCR2NO,POINNO
      INTEGER     UNI(1),NULO,MADRID(1)
      INTEGER*8   INPT,OUTPT,AMBPT,SBINPT,INDXPT,SCR1PT,SCR2PT,POINPT
C      
      DOUBLE PRECISION START(3),STEP(3)
C 
      REAL        STATS(11),CUTS(2)
C
      CHARACTER   INFRM*60,OUTFRM*60,CUNIT*64,IDENT*72
      CHARACTER   INCFLG*1

C 
      INCLUDE     'MID_INCLUDE:ST_DEF.INC'
C 
      COMMON      /VMR/  MADRID
C      
      INCLUDE     'MID_INCLUDE:ST_DAT.INC'
C 
C  set up MIDAS environment + enable automatic error abort
      CALL STSPRO('SUBSKY')
C
C  get name of input image  + map frame 
      CALL STKRDC('IN_A',1,1,60,IAV,INFRM,UNI,NULO,STAT)
      CALL STIGET(INFRM,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +            3,NAXIS,NPIX,START,STEP,
     +            IDENT,CUNIT,INPT,INNO,STAT)
      IF ((NAXIS.GT.2) .AND. (NPIX(3).GT.1)) THEN
         CALL STETER
     +   (1,'Maximum image dimension supported is 2...')
      ELSE IF (NAXIS.EQ.1) THEN 
         NPIX(2) = 1
         NAXIS = 2
      ENDIF
C
      ISIZ = NPIX(1)*NPIX(2)
C
C  Read descriptors STATISTIC, HISTOGRAM, WINDOW_FROM, WINDOW_TO, and HIST_BINS
      CALL STDRDR(INNO,'STATISTIC',1,11,IAV,STATS,UNI,NULO,STAT)
      NBIN = STATS(10)
      IF (NBIN.GT.1000) 
     +   CALL STETER
     +   (2,'Cannot handle more than 1000 histogram bins.')
      IF (NBIN.LT.5) 
     +   CALL STETER
     +   (3,'Histograms with fewer than 5 bins do not make sense.')
C 
      CALL STDRDI(INNO,'HISTOGRAM',1,NBIN,IAV,SHISTO,UNI,NULO,STAT) 
      CALL STDRDR(INNO,'HIST_BINS',3,2,IAV,CUTS,UNI,NULO,STAT)
      CALL STDRDI(INNO,'WINDOW_FROM',1,2,IAV,WFR,UNI,NULO,STAT)
      CALL STDRDI(INNO,'WINDOW_TO',1,2,IAV,WTO,UNI,NULO,STAT)
C
C  get name of output frame, map it
      CALL STKRDC('OUT_A',1,1,60,IAV,OUTFRM,UNI,NULO,STAT)
      CALL STIPUT(OUTFRM,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,3,
     2             NPIX,START,STEP,IDENT,CUNIT,OUTPT,OUTNO,STAT)
C 
C  read and test dimensions of neighbourhood box
      CALL STKRDI ('INPUTI',1,2,IAV,BOX,UNI,NULO,STAT)
      IF ((BOX(1)*BOX(2)) .LT. 0) THEN
         CALL STETER(4,'Dimensions of neighbourhood box must be '//
     +                 'non-negative') 
      ENDIF
      IF ((BOX(1)*BOX(2)) .GT. 20) THEN                ! box suspiciously large?
         CALL STTPUT('WARNING: Size of neighbourhood box appears '//
     +                         'very large',STAT)
      ENDIF
C
C  read flag for inclusion or not of central pixel in calculation
C  of flux in box
      CALL STKRDC('INPUTC',1,1,1,IAV,INCFLG,UNI,NULO,STAT)      
C
C *** We need six temporary arrays identical to inframe:
C  1. for the flux in the neighbourhood of each pixel 
      CALL STIPUT('DUMMY1',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +             NAXIS,NPIX,START,STEP,IDENT,CUNIT,AMBPT,
     +             AMBNO,STAT)
C 
C  2. for the number of the sky histogram bin corresponding to each pixel 
      CALL STIPUT('DUMMY2',D_I4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +             NAXIS,NPIX,START,STEP,IDENT,CUNIT,SBINPT,
     +             SBINNO,STAT)
C 
C  3. for the index determined during the sorting procedure 
      CALL STIPUT('DUMMY3',D_I4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +             NAXIS,NPIX,START,STEP,IDENT,CUNIT,INDXPT,
     +             INDXNO,STAT)
C 
C  4. for intermediate storage 
      CALL STIPUT('DUMMY4',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +             NAXIS,NPIX,START,STEP,IDENT,CUNIT,SCR1PT,
     +             SCR1NO,STAT)
C 
C  5. also for intermediate storage 
      CALL STIPUT('DUMMY5',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +             NAXIS,NPIX,START,STEP,IDENT,CUNIT,SCR2PT,
     +             SCR2NO,STAT)
C 
C  6. for pointers to selected image elements
      CALL STIPUT('DUMMY6',D_I4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +             NAXIS,NPIX,START,STEP,IDENT,CUNIT,POINPT,
     +             POINNO,STAT)
C
C  Now comes the real thing:
      CALL REMSKY(MADRID(INPT),MADRID(OUTPT),
     +            MADRID(AMBPT),MADRID(SBINPT),
     +            MADRID(INDXPT),MADRID(POINPT),
     +            MADRID(SCR1PT),MADRID(SCR2PT),
     +            STATS,SHISTO,NPIX,CUTS,WFR,WTO,BOX,INCFLG)
C
C  Copy all descriptors (leave also LHCUTS as it was since no large 
C  changes are expected), update HISTORY:
      CALL STDCOP(INNO,OUTNO,3,' ',STAT)
C
C  Free data
      CALL STSEPI
      END

      SUBROUTINE REMSKY(IN,OUT,AMB,SBIN,INDX,POINT,SCR1,SCR2,
     2                  STATS,SHISTO,NPIX,CUTS,WFR,WTO,BOX,INCFLG)
C
C  
      IMPLICIT NONE
C
      INTEGER   NPICS,SHISTO(1),HISTO(1000),I,J,K,NBIN,STAT
      INTEGER   NSKY,WFR(2),WTO(2),NZERO,NPIX(3),SUBLO(2),BOX(2)
      INTEGER   SBIN(1),INDX(1),POINT(1)
C
      REAL      IN(1),OUT(1),AMB(1),SCR1(1),SCR2(1)
      REAL      VCENT(1000),PBIN(1000)
      REAL      STATS(11),CUTS(1)
      REAL      EXPVAL,V1,V2,SCL,STEP,MIN,MEAN
C
      CHARACTER WARNNG*80,INCFLG*1
C
      MIN=CUTS(1)
      MEAN=STATS(3)
      NBIN=STATS(10)
      STEP=STATS(11)
C
C  Issue warning if area from which sky histogram has been determined appears 
C  rather small:
      NPICS=NPIX(1)*NPIX(2)                        ! full frame
      NSKY=(WTO(1)-WFR(1)+1)*(WTO(2)-WFR(2)+1)     ! sky reference subframe
      SCL=NSKY*100./NPICS
      IF (SCL.LT.5) THEN 
         WRITE (WARNNG,300) SCL
         CALL STTPUT(WARNNG,STAT)
      ENDIF
C
C  Construct identically structured histogram of entire frame
      SUBLO(1)=1
      SUBLO(2)=1
      CALL HSTVLS(IN,2,NPIX,SUBLO,NPIX,CUTS,STEP,NBIN,HISTO)
C
C  Determine central values of the non-excess bins (see command 
C  STATISTIC/IMAGE for definition of excess bins)
      DO 50 J=2,NBIN-1
         VCENT(J)=CUTS(1)+(J-1.5)*STEP
50    CONTINUE
C
C  Compute on the basis of a comparison of the reference sky histogram and 
C  the histogram of the complete frame the probability that the flux 
C  of pixels in a given histogram bin is due to sky (background in general) 
C  only. To this end, scale up sky histogram to area of full frame. 
C  Excess bins are special.
      DO 80 I=2,NBIN-1
         PBIN(I)=0                              ! minimum
         IF (HISTO(I).NE.0) PBIN(I)=SHISTO(I)*100./HISTO(I)/SCL  ! normally
         IF (PBIN(I).GT.1) PBIN(I)=1            ! maximum
80    CONTINUE
      PBIN(1)=0
      PBIN(NBIN)=0
C
C  Determine for each pixel the histogram bin to which its flux corresponds:
C  In order to save time, subtract from pixels in the high excess bin 
C  the expectation value of the sky reference histogram and from the lower 
C  excess bin the lower cutoff flux of the histogram :
      CALL BINS(IN,OUT,SBIN,CUTS,STEP,NPICS,NBIN,MEAN)
C
C  Now start replacing the probable sky pixels. The bins with a probability 
C  of unity of their contributing pixel values being entirely due to 
C  background are easy to handle - signals are completely zeroed. 
      DO 100 I=1,NPICS
         K=SBIN(I)
         IF (PBIN(K).EQ.1) OUT(I)=0            ! all signal due to sky
100   CONTINUE
C
C  For the remainder we procede histogram bin-wise rather than pixel-wise. 
C  Since a criterion for the order in which pixels in a given bin will be 
C  treated is the ambient flux level, we first compute the mean flux in 
C  a (2*BOX(1)+1)*(2*BOX(2)+1) box centered on each pixel:
C 
      CALL AMBINT(AMB,IN,NPIX,STEP,BOX,INCFLG)
C
      DO 400 J=2,NBIN-1                        ! exclude excess bins
         IF (PBIN(J).EQ.1) GOTO 400            ! already handled above 
         NZERO=NINT(HISTO(J)*PBIN(J))          ! number of pixels to be zeroed
         IF (NZERO.NE.0) THEN                  ! some pixels due to sky 
C
            CALL SELECT(SBIN,AMB,INDX,SCR1,SCR2,POINT,J,NPICS)
C
C  Zero the pixels selected, subtract from the remaining pixels in bin J 
C  the expectation value
            DO 360 I=1,NZERO
               K = POINT(I)
               OUT(K)=0                        ! set selected pixels to zero
360         CONTINUE
C
C  Compute expectation value as the histogram-weighted mean over all 
C  bins (excluding the low excess bin) up to the one with the observed flux:
            V1=0                        ! initialize
            V2=0                        ! dito
            DO 370 K=2,J-1
               V1=V1+VCENT(K)*SHISTO(K)
               V2=V2+SHISTO(K)
370         CONTINUE
C 
            EXPVAL=MIN                  ! lower limit to true exp. value
            IF (V2.NE.0) EXPVAL=V1/V2   ! expectation value 
C 
            DO 380 I=NZERO+1,HISTO(J)
               K = POINT(I)
               OUT(K)=IN(K) - EXPVAL    ! subtract expect. value elsewhere 
380         CONTINUE
         ELSE                           ! no pixel to be zeroed 
C
C  If the probability of a certain signal being entirely due to background 
C  is zero, just subtract the mean background flux:
            DO 390 I=1,NPICS
               K=SBIN(I)
               IF (ABS(K-J).LT.0.1) OUT(I)=IN(I)-MEAN
390         CONTINUE
         ENDIF
400   CONTINUE                          ! replacement probability was 1
C
      RETURN
C 
300   FORMAT ('WARNING: Histogram pertains to only ',G10.3,'% of
     + total image area!')
      END

      SUBROUTINE BINS(IN,OUT,SBIN,CUTS,STEP,NPICS,NBIN,MEAN)
C
C  Determine for each pixel its corresponding bin number in the histogram 
C  (conform to definition of bin boundaries used in MIDAS routine HISTVALS)
C  Simultaneously subtract from lower and upper excess bin pixels respectively 
C  lower cutoff and expectation value of sky reference histogram.
C
      IMPLICIT NONE
C
      INTEGER      NPICS,NBIN,I,SBIN(1)
C
      REAL         STEP,IN(1),MAX,MIN,MEAN,OUT(1),CUTS(1)
C
      MIN=CUTS(1)
      MAX=MIN+(NBIN-2)*STEP
C
      DO 100 I=1,NPICS
         IF ((IN(I)-MIN).LT.0) THEN 
            SBIN(I)=1
            OUT(I)=IN(I)-MIN
            GOTO 100
         ENDIF
         IF((IN(I)-MAX).GE.0) THEN 
            SBIN(I)=NBIN
            OUT(I)=IN(I)-MEAN
            GOTO 100
         ENDIF
         SBIN(I)=NINT((IN(I)-MIN)/STEP)+2
100   CONTINUE
C
      RETURN 
      END

      SUBROUTINE AMBINT(AMB,IN,NPIX,STP,BOX,INCFLG)
C
C  Compute for each pixel the mean flux in its neighbourhood of 
C  (2*BOX(1)+1)*(2*BOX(2)+1) pixels (not including the central pixel itself). 
C  Purposely degrade the resolution in flux so that later the sorting by 
C  neighbourhood flux values is somewhat faster. However, the degradation is 
C  limited to 0.01 times the histogram bin width in order to avoid a bias 
C  in the result because otherwise the effective background removal would 
C  be different at the beginning and at the end of the frame. 
C
      IMPLICIT NONE
C
      INTEGER     NPIX(3),NPICS,I,J,K,M,N,NX,NY,BOX(2),BX,BY,P,SIZE,FLAG
C
      REAL        IN(1),AMB(1),STP,STEP
C
      CHARACTER   INCFLG*1
C
      STEP=STP/100.
      NX=NPIX(1)
      NY=NPIX(2)
      NPICS=NX*NY
      BX=BOX(1)
      BY=BOX(2)
      SIZE=(2*BX+1)*(2*BY+1)-1
      IF (SIZE.LT.0.5) SIZE=1                        ! avoid zero division
C
      IF ((INCFLG.EQ.'Y').OR.(INCFLG.EQ.'y')) THEN 
         FLAG=0 
      ELSE
         FLAG=1
      ENDIF
C
C  Initialize array AMB to zero
      DO 10 I=1,NPICS
         AMB(I)=0
10    CONTINUE

C
C  Start computation for inner pixels
      DO 200 I=1+BX,NX-BX
         DO 100 J=1+BY,NY-BY
            P=(J-1)*NX+I
            DO 50 M=-BY,BY
               K=(J-1+M)*NX+I
               DO 25 N=-BX,BX
                  AMB(P)=AMB(P)+IN(K+N)
25             CONTINUE
50          CONTINUE
            AMB(P)=(NINT(((AMB(P)-FLAG*IN(P))/SIZE)/STEP)+0.5)*STEP 
100      CONTINUE
200   CONTINUE
C
C  Finish off at edges ...
      DO 300 I=1+BX,NX-BX
         DO 310 J=1,BY                             ! bottom
            P=(J-1)*NX+I
            DO 320 M=1,J+BY
               K=(M-1)*NX+I
               DO 330 N=-BX,BX
                  AMB(P)=AMB(P)+IN(K+N)
330            CONTINUE
320         CONTINUE
            SIZE=(2*BX+1)*(J+BY)-1
            IF (SIZE.LT.0.5) SIZE=1                ! avoid zero division
            AMB(P)=(NINT(((AMB(P)-FLAG*IN(P))/SIZE)/STEP)+0.5)*STEP
310      CONTINUE      
C
         DO 360 J=NY-BY+1,NY                       ! top 
            P=(J-1)*NX+I
            DO 370 M=J-BY,NY
               K=(M-1)*NX+I
               DO 380 N=-BX,BX
                  AMB(P)=AMB(P)+IN(K+N)
380            CONTINUE
370         CONTINUE
            SIZE=(2*BX+1)*(NY-J+1+BY)-1
            IF (SIZE.LT.0.5) SIZE=1                ! avoid zero division 
            AMB(P)=(NINT(((AMB(P)-FLAG*IN(P))/SIZE)/STEP)+0.5)*STEP
360      CONTINUE      
300   CONTINUE
C 
      DO 400 J=1+BY,NY-BY
         DO 410 I=1,BX                             ! left margin
            P=(J-1)*NX+I
            DO 420 M=-BY,BY
               K=(J-1+M)*NX+I
               DO 430 N=1,I+BX
                  AMB(P)=AMB(P)+IN(K+N)
430            CONTINUE
420         CONTINUE
            SIZE=(I+BX)*(2*BY+1)-1        
            IF (SIZE.LT.0.5) SIZE=1                ! avoid zero division
            AMB(P)=(NINT(((AMB(P)-FLAG*IN(P))/SIZE)/STEP)+0.5)*STEP
410      CONTINUE
C
         DO 460 I=NX-BX+1,NX                       ! right margin
            P=(J-1)*NX+I
            DO 470 M=-BY,BY
               K=(J-1+M)*NX+I
               DO 480 N=1,I+BX
                  AMB(P)=AMB(P)+IN(K+N)
480            CONTINUE
470         CONTINUE
            SIZE=(NX-I+1+BX)*(2*BY+1)-1        
            IF (SIZE.LT.0.5) SIZE=1                ! avoid zero division
            AMB(P)=(NINT(((AMB(P)-FLAG*IN(P))/SIZE)/STEP)+0.5)*STEP
460      CONTINUE
400   CONTINUE
C
C  ... and corners
      DO 511 I=1,BX                                ! left
         DO 512 J=1,BY                             ! lower
            P=(J-1)*NX+I
            DO 513 M=1,J+BY
               K=(M-1)*NX+I
               DO 514 N=1,I+BX
                  AMB(P)=AMB(P)+IN(K+N)
514            CONTINUE
513         CONTINUE
            SIZE=(I+BX)*(J+BY)-1
            IF (SIZE.LT.0.5) SIZE=1                ! avoid zero division 
            AMB(P)=(NINT(((AMB(P)-FLAG*IN(P))/SIZE)/STEP)+0.5)*STEP
512      CONTINUE
511   CONTINUE
C
      DO 611 I=1,BX                                ! left
         DO 612 J=NY-BY+1,NY                       ! upper
            P=(J-1)*NX+I
            DO 613 M=J-BY,NY
               K=(M-1)*NX+I
               DO 614 N=1,I+BX
                  AMB(P)=AMB(P)+IN(K+N)
614            CONTINUE
613         CONTINUE
            SIZE=(I+BX)*(NY-J+1+BY)-1
            IF (SIZE.LT.0.5) SIZE=1                ! avoid zero division 
            AMB(P)=(NINT(((AMB(P)-FLAG*IN(P))/SIZE)/STEP)+0.5)*STEP
612      CONTINUE
611   CONTINUE
C
      DO 711 I=NX-BX+1,NX                          ! right
         DO 712 J=1,BY                             ! lower
            P=(J-1)*NX+I
            DO 713 M=1,J+BY
               K=(M-1)*NX+I
               DO 714 N=I-BX,NX
                  AMB(P)=AMB(P)+IN(K+N)
714            CONTINUE
713         CONTINUE
            SIZE=(NX-I+1+BX)*(J+BY)-1
            IF (SIZE.LT.0.5) SIZE=1                ! avoid zero division 
            AMB(P)=(NINT(((AMB(P)-FLAG*IN(P))/SIZE)/STEP)+0.5)*STEP
712      CONTINUE
711   CONTINUE
C
      DO 811 I=NX-BX+1,NX                          ! right
         DO 812 J=NY-BY+1,NY                       ! upper
            P=(J-1)*NX+I
            DO 813 M=J-BY,NY
               K=(M-1)*NX+I
               DO 814 N=I-BX,NX
                  AMB(P)=AMB(P)+IN(K+N)
814            CONTINUE
813         CONTINUE
            SIZE=(NX-I+1+BX)*(NY-J+1+BY)-1
            IF (SIZE.LT.0.5) SIZE=1                ! avoid zero division 
            AMB(P)=(NINT(((AMB(P)-FLAG*IN(P))/SIZE)/STEP)+0.5)*STEP
812      CONTINUE
811   CONTINUE
C
      RETURN
      END

      SUBROUTINE SELECT(SBIN,AMB,INDX,SCR1,SCR2,POINT,IBIN,NPICS)
C
C  Select pixels in bin IBIN whose signal is to be zeroed completely. 
C  Selection criterion is the ambient flux level. Therefore, rank 
C  values of pixels according to the ambient flux (in AMB). 
C
      IMPLICIT NONE
C
      INTEGER    IBIN,NSORT,NPICS,I,J,K
      INTEGER    SBIN(NPICS),INDX(NPICS),POINT(NPICS)
C
      REAL       AMB(NPICS),SCR1(NPICS),SCR2(NPICS)
C
C  Prepare an index array with pointers to all pixels in IBIN
      K=0
      DO 100 I=1,NPICS
         IF (ABS(SBIN(I)-IBIN).LT.0.1) THEN 
            K=K+1
            POINT(K)=I
         ENDIF
100   CONTINUE
      NSORT=K
C
C  Store the relevant NSORT elements of array AMB in the first NSORT 
C  elements of temporary buffer SCR1 so that the sorting is more efficient. 
      DO 200 J=1,NSORT
         K = POINT(J)
         SCR1(J)=AMB(K)
         SCR2(J)=POINT(J)+0.1
200   CONTINUE
C
C  Now sort array SCR2 according to ascending values of the neighbouring 
C  flux level (in AMB). 
      CALL SORT1(NSORT,SCR1,SCR2,INDX)
C
C  Finally, revert from REAL format (array SCR2) to INTEGER (array POINT)
      DO 300 J=1,NSORT
         POINT(J)=INT(SCR2(J))
300   CONTINUE
C
      RETURN
      END

      SUBROUTINE SORT1(N,RA,RB,IWKSP)
C
C  Sort array RB using index IWKSP prepared for array RA in subroutine INDEXX
C  Code adapted from "Numerical Recipes", Chapter 8.3 "Indexing and Ranking", 
C  p. 233-234 (subroutine SORT3).
C
      IMPLICIT NONE
C
      INTEGER     N,J,K
      INTEGER     IWKSP(N)
C
      REAL        RA(N),RB(N)
C
      CALL INDEXX(RA,IWKSP,N)
C
      DO 100 J=1,N
         RA(J)=RB(J)           ! initial contents of buffer RA no longer needed
100   CONTINUE
C
      DO 200 J=1,N
         K = IWKSP(J)
         RB(J)=RA(K)           ! do the desired re-arrangement
200   CONTINUE
C
      RETURN
      END

      SUBROUTINE INDEXX(ARRIN,INDX,N)
C
C  Index array ARRIN according to ascending order of values in SCR1, result in 
C  INDX.
C  Code taken from "Numerical Recipes", Chapter 8.3 "Indexing and Ranking", 
C  p. 233 (Subroutine INDEXX)
C
      IMPLICIT NONE
C
      INTEGER     N,I,J,L,IR,INDXT,INDX(N)
C
      REAL        ARRIN(N),Q
C
      IF (N.LT.1.5) THEN 
         INDX(1)=1
         RETURN
      ENDIF
C
      DO 100 J=1,N
         INDX(J)=J                        ! initialize
100   CONTINUE
C
      L=N/2+1
      IR=N
C
10    CONTINUE
         IF (L.GT.1) THEN
            L = L-1
            INDXT=INDX(L)
            Q=ARRIN(INDXT)
         ELSE
            INDXT=INDX(IR)
            Q = ARRIN(INDXT)
            INDX(IR)=INDX(1)
            IR=IR-1
            IF (IR.LE.1) THEN
               INDX(1)=INDXT
               RETURN                     ! job done 
            ENDIF
         ENDIF
C 
         I=L
         J=L+L
C
20       CONTINUE
         IF (J.LE.IR) THEN
            IF (J.LT.IR) THEN
               IF (ARRIN(INDX(J)).LT.ARRIN(INDX(J+1))) J=J+1
            ENDIF 
            IF (Q.LT.ARRIN(INDX(J))) THEN
               INDX(I) = INDX(J)
               I=J
               J=J+J
            ELSE
               J=IR+1
            ENDIF
C    
            GOTO 20
         ENDIF
C 
         INDX(I)=INDXT
      GOTO 10
C
      END

C @(#)fotometry.for	19.1 (ES0-DMD) 02/25/03 13:23:49
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE  PHOTSB (F, SKY, INDEX, MAXSKY, NCOL, NROW, WATCH)
C
C=======================================================================
C
C This subroutine derives the concentric aperture photometry.  At
C present, this is the only place in all of DAOPHOT where sky values
C are derived for the individual stars.
C
C               OFFICIAL DAO VERSION:  1991 April 18
C
C Argument
C
C    WATCH (INPUT) governs whether information relating to the progress
C          of the reductions is to be typed on the terminal screen
C          during execution.
C
C=======================================================================
C
      IMPLICIT NONE
      INTEGER MINSKY, MAXSKY, MAXAP, NCOL, NROW
      PARAMETER  (MINSKY=20, MAXAP=12)
C
C Parameters:
C
C MINSKY is the smallest number of pixels from which the sky may be
C        determined.  If for some star the number of sky pixels
C        is less than MINSKY, an error code will result and
C        control will return to the main program.
C
C MAXSKY the maximum number of pixels allowed in the sky annulus.
C        This and the user's requested inner sky radius will later
C        determine the maximum permitted outer sky radius.
C
C MAXAP  the maximum number of star apertures allowed.
C
      CHARACTER*80 LINE
      CHARACTER*30 COOFIL, MAGFIL, PSFFIL, PROFIL, GRPFIL, TABLE
      CHARACTER SWITCH*30, EXTEND*30, LBL(MAXAP+2)*26, CASE*4
      DOUBLE PRECISION MAGLIM, MAGSQ, WT, SUMWT, DLOG10, DBLE, DMAX1
      DOUBLE PRECISION APMAG(MAXAP), AREA(MAXAP)
      REAL SKY(MAXSKY), MAGERR(MAXAP)
      REAL F(NCOL,NROW), ERROR(3)
      REAL PAR(MAXAP+2), PMIN(MAXAP+2), PMAX(MAXAP+2)
      REAL AMIN1, AMAX1, SQRT
      INTEGER INDEX(MAXSKY)
      INTEGER MIN0, MAX0
C
      REAL LOBAD, SKYMOD, SKYSIG, SKYSKW, SIGSQ, SKYVAR
      REAL DATUM, R, RSQ, FRACTN, EDGE, HIBAD, THRESH, DUM
      REAL PHPADU, READNS, XC, YC, DMAG, WATCH, APMXSQ
      REAL RINSQ, ROUT, ROUTSQ, DYSQ
      INTEGER I, J, K, L, NAPER, IDUM, NMAG, LX, LY, NX, NY
      INTEGER ISTAR, MX, MY, NSKY, ISTAT, NL
C
      COMMON /FILNAM/ COOFIL, MAGFIL, PSFFIL, PROFIL, GRPFIL
C
      DATA PAR /MAXAP*0., 2*0./
      DATA PMIN /1.E-30, MAXAP*0., 1./
      DATA PMAX/MAXAP*1.E30, 2*1.E30/
      DATA TABLE / 'photo.opt' /
      DATA LBL/' A1  RADIUS OF APERTURE  1',
     .         ' A2  RADIUS OF APERTURE  2',
     .         ' A3  RADIUS OF APERTURE  3',
     .         ' A4  RADIUS OF APERTURE  4',
     .         ' A5  RADIUS OF APERTURE  5',
     .         ' A6  RADIUS OF APERTURE  6',
     .         ' A7  RADIUS OF APERTURE  7',
     .         ' A8  RADIUS OF APERTURE  8',
     .         ' A9  RADIUS OF APERTURE  9',
     .         ' AA  RADIUS OF APERTURE 10',
     .         ' AB  RADIUS OF APERTURE 11',
     .         ' AC  RADIUS OF APERTURE 12',
     .         ' IS       INNER SKY RADIUS',
     .         ' OS       OUTER SKY RADIUS'/
C
C-----------------------------------------------------------------------
C
C SECTION 1
C
C Ascertain the name of the aperture photometry parameter table, and
C read it in.  Then set up all necessary variables for the forthcoming
C reductions. Finally, identify and open the input and output files.
C
      L = MAXAP+1
      PMIN(L) = 1.
      CALL TBLANK
      CALL GETNAM ('File with aperture radii:', TABLE)
      IF (TABLE .EQ. 'END OF FILE') THEN
         CALL TBLANK
         RETURN
      END IF
C
 1000 CALL OPTION (TABLE, MAXAP+2, LBL, PAR, PMIN, PMAX, 'PHO>', ISTAT)
      IF (ISTAT .NE. 0) RETURN
C
C Count up the number of apertures that will be used.  The first zero or
C negative number encountered terminates the list.
C
      NAPER=MAXAP
      APMXSQ=-1.
      DO 1010 I=1,MAXAP
      IF (PAR(I) .LE. 0.0) GO TO 1020
 1010 APMXSQ=AMAX1(APMXSQ, (PAR(I)+0.5)**2)
      GO TO 1030
C
 1020 NAPER=I-1
 1030 CONTINUE
C
C NAPER   is the number of apertures, whose radii are stored in
C         elements 1 through NAPER of the array PAR.
C
C APMXSQ  is the outermost edge of the largest aperture-- if the
C         distance squared of the center of a pixel from the centroid of
C         the star is greater than APMXSQ, then we know that no part
C         of the pixel is to be included in any aperture.
C
C Now define the other variables whose values are in the table.
C
      RINSQ=AMAX1(PAR(MAXAP+1), 0.)**2      ! Inner sky radius squared
      ROUTSQ = REAL(MAXSKY)/3.142 + RINSQ
      DUM = PAR(MAXAP+2)**2
      IF (DUM .GT. ROUTSQ) THEN
         CALL TBLANK
         CALL TBLANK
         CALL STUPID
     .        ('   *** You have specified too big a sky annulus. ***')
         WRITE (6,6) SQRT(ROUTSQ)
    6    FORMAT (F10.2, ' pixels is the largest outer sky radius ',
     .        'currently permitted.')
         RETURN
      ELSE IF (DUM .LE. RINSQ) THEN
         CALL TBLANK
         CALL STUPID
     .   ('Your outer sky radius is no bigger than the inner radius.')
         WRITE (6,8)
    8    FORMAT ('Please try again.')
         GO TO 1000
      ELSE
         ROUT = PAR(MAXAP+2)
         ROUTSQ = DUM
      END IF
C
C Inquire the name of the input data file with the stellar positions,
C and open it.
C
      CALL TBLANK
  900 CALL GETNAM ('File with the positions:', COOFIL)
      IF ((COOFIL .EQ. 'END OF FILE') .OR.
     .     (COOFIL .EQ. 'GIVE UP')) THEN
         COOFIL = ' '
         RETURN
      END IF
      CALL INFILE (2, COOFIL, ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error opening input file '//COOFIL)
         COOFIL = 'GIVE UP'
         GO TO 900
      END IF
      CALL RDHEAD(2, NL, IDUM, IDUM, LOBAD, HIBAD, THRESH, DUM,
     .     PHPADU, READNS, DUM)
      IF (NL .LT. 1) NL=1
C
C Inquire file name for output aperture photometry results, and open
C the new file.
C
      MAGFIL=SWITCH(COOFIL, CASE('.ap'))
  950 CALL GETNAM ('File for the magnitudes:', MAGFIL)
      IF ((MAGFIL .EQ. 'END OF FILE') .OR.
     .     (MAGFIL .EQ. 'GIVE UP')) THEN
         CALL CLFILE (2)
         MAGFIL = ' '
         RETURN
      END IF
      MAGFIL = EXTEND(MAGFIL, CASE('ap'))
      CALL OUTFIL (3, MAGFIL, ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error opening output file '//MAGFIL)
         MAGFIL = 'GIVE UP'
         GO TO 950
      END IF
      CALL WRHEAD (3, 2, NCOL, NROW, 6, LOBAD, HIBAD, THRESH,
     .     PAR(1), PHPADU, READNS, 0.)
      READNS=READNS**2
C
C If progress is being monitored, type out column headers.
C
      IF (WATCH .GT. 0.5) WRITE (6,610)
  610 FORMAT (/13X, 'STAR', 5X, 'X', 7X, 'Y', 9X, 'MAG.(1)', 8X, 'SKY')
C
C Initialize variables for the computation of the magnitude limit.
C
      MAGLIM=0.0D0
      MAGSQ=0.0D0
      SUMWT=0.0D0
      NMAG=0
C
C-----------------------------------------------------------------------
C
C SECTION 2
C
C Derive aperture photometry object by object.
C
C Get the coordinates of next object to be measured.
C
      LX = 1
      LY = 1
      NX = NCOL
      NY = NROW
      CALL RDARAY ('DATA', LX, LY, NX, NY, NCOL, F, ISTAT)
 2000 CALL RDSTAR (2, NL, ISTAR, XC, YC, DMAG, DUM)
      IF (ISTAR .LT. 0) GO TO 9000
      IF (ISTAR .EQ. 0) GO TO 2000
C
C Compute the limits of the submatrix.
C
      LX = MAX0(1, INT(XC-ROUT)+1)
      MX = MIN0(NCOL, INT(XC+ROUT))
      LY = MAX0(1, INT(YC-ROUT)+1)
      MY = MIN0(NROW, INT(YC+ROUT))
      EDGE=AMIN1(XC-0.5, (NCOL+0.5)-XC, YC-0.5, (NROW+0.5)-YC)
C
C EDGE is the distance of the star's centroid from the outermost
C extremum of the array.
C
C Initialize star counts and aperture area.
C
      DO 2010 I=1,NAPER
      APMAG(I) = 0.D0
C
C If this star aperture extends outside the array, the magnitude
C in this aperture will be no good.
C
      IF (EDGE .LT. PAR(I)) APMAG(I)=-1.0D36            ! Null magnitude
 2010 AREA(I)=0.0D0
C
C Now read through the submatrix, picking out the data we want.
C
      NSKY=0
C
      DO 2130 J=LY,MY
      DYSQ=(J-YC)**2
C
         DO 2125 I=LX,MX
            RSQ=DYSQ+(I-XC)**2
            DATUM=F(I,J)
C
C Is this pixel within the sky annulus?
C
            IF ((RSQ .LT. RINSQ) .OR. (RSQ .GT. ROUTSQ) .OR.
     .           (NSKY .GT. MAXSKY) .OR. (DATUM .LT. LOBAD) .OR.
     .           (DATUM .GT. HIBAD)) GO TO 2110
            NSKY=NSKY+1
            SKY(NSKY)=DATUM
C
C The inclusion of partial pixels inside the aperture is done as
C follows:  if the distance of the center of the current pixel from the
C centroid of the star [radius vector r(i,j)] is exactly equal to the
C radius of the aperture [R(k)], then one-half of the counts in the
C pixel are included.  If r(i,j) < R(k)-0.5, then the entire pixel is
C included, while if r(i,j) > R(k)+0.5, the pixel is wholly excluded.
C In between, viz. for  R(k)-0.5 < r(i,j) < R(k)+0.5, the fraction of
C the counts included varies linearly.  Therefore a circular aperture
C is approximated by an irregular (not even convex) polygon.
C
C If this pixel falls completely outside the LARGEST aperture, go on
C to the next pixel.  Notice that APMXSQ has actually been defined
C as (R(k)+0.5)**2 for the largest value of R(k), in accordance with
C the formula used for the partial pixels.
C
 2110       IF (RSQ .GT. APMXSQ) GO TO 2125
            R=SQRT(RSQ)-0.5
C
            DO 2120 K=1,NAPER
C
C If this pixel falls completely outside THIS aperture, go on to the
C next aperture.
C
               IF (R .GT. PAR(K)) GO TO 2120
               FRACTN=AMAX1(0.0, AMIN1(1.0,PAR(K)-R))
C
C FRACTN is the fraction of the pixel that falls inside the
C (irregular) aperture.
C
C If the pixel is bad, set the total counts in this aperture to a number
C so negative that it will never be positive again.
C
               IF ((DATUM .LT. LOBAD) .OR. (DATUM .GT. HIBAD))
     .              APMAG(K)=-1.0D36                    ! Null magnitude
               APMAG(K) = APMAG(K)+DBLE(FRACTN*DATUM)
               AREA(K) = AREA(K)+DBLE(FRACTN)
 2120       CONTINUE
 2125    CONTINUE
C
 2130 CONTINUE
C
C We have accumulated the brightnesses of individual sky pixels in the
C one-dimensional array SKY.  Pixels falling above or below the BAD
C limits have already been eliminated.  Now sort SKY to place the
C pixels in order of increasing brightness.
C
      IF (NSKY .LT. MINSKY)  THEN
         CALL STUPID ('There aren''t enough pixels in the sky annulus.')
         WRITE (6,*)
     .        ' Are you sure your bad pixel thresholds are all right?'
         WRITE (6,*)
     .        ' If so, then you need a larger outer sky radius.'
         CALL TBLANK
         CALL CLFILE (2)
         CALL CLFILE (3)
         RETURN
      END IF
      CALL QUICK (SKY, NSKY, INDEX)
C
C Obtain the mode, standard deviation, and skewness of the peak in the
C sky histogram.
C
      CALL MMM (SKY, NSKY, HIBAD, DUM, DATUM, SKYMOD, SKYSIG, SKYSKW)
      SKYVAR=SKYSIG**2
      SIGSQ=SKYVAR/FLOAT(NSKY)
C
C SKYMOD has units of (ADU/pixel), and SKYSIG is the pixel-to-pixel
C scatter of SKYMOD, in units of (ADU/pixel).  SKYVAR is the
C variance (square of the standard deviation) of the sky brightness,
C (ADU/pixel)**2, and SIGSQ is the square of the standard error of the
C mean sky brightness.
C
C Subtract the sky from the integrated brightnesses in the apertures,
C convert the results to magnitudes, and compute standard errors.
C
      DO 2220 I=1,NAPER
C
C If the modal sky value could not be determined, set the magnitude
C to 99.999.
C
      IF (SKYSIG .LT. -0.5) GO TO 2210
      APMAG(I)=APMAG(I)-DBLE(SKYMOD)*AREA(I)
C
C If the star + sky is fainter than the sky, or if the star aperture
C extends beyond the limits of the picture, or if there is a bad pixel
C in the star aperture, set the magnitude to 99.999.
C
      IF (APMAG(I) .LE. 0.0D0) GO TO 2210
      ERROR(1)=SNGL(AREA(I))*SKYVAR
      ERROR(2)=SNGL(APMAG(I))/PHPADU
      ERROR(3)=SIGSQ*SNGL(AREA(I))**2
C
C These variables ERRORn are the respective variances (squares of the
C mean errors) for: (1) random noise inside the star aperture, including
C readout noise and the degree of contamination by other stars in the
C neighborhood, as estimated by the scatter in the sky values (this
C standard error increases as the square root of the area of the
C aperture); (2) the Poisson statistics of the observed star brightness;
C (3) the uncertainty of the mean sky brightness (this standard error
C increases directly with the area of the aperture).
C
      MAGERR(I)=AMIN1(9.999,
     .     1.0857*SQRT(ERROR(1)+ERROR(2)+ERROR(3))/SNGL(APMAG(I)))
      APMAG(I)=25.D0-2.5D0*DLOG10(APMAG(I))
      IF (APMAG(I) .GT. 99.999D0) GO TO 2210
      GO TO 2220
 2210 APMAG(I)=99.999D0
      MAGERR(I)=9.999
 2220 CONTINUE
C
C Write out the answers.
C
      IF (WATCH .GT. 0.5) WRITE (6,620)ISTAR, XC, YC, APMAG(1),
     .     MAGERR(1), SKYMOD
  620 FORMAT (12X, I5, 2F8.2, F9.3, ' +-', F6.3, F8.1)
      WRITE (3,320) ISTAR, XC, YC, (APMAG(I), I=1,NAPER)
  320 FORMAT (/1X, I5, 14F9.3)
      WRITE (3,321) SKYMOD, AMIN1(99.99,SKYSIG),
     .     AMIN1(999.99, AMAX1(-99.99,SKYSKW)),
     .     (MAGERR(I), I=1,NAPER)
  321 FORMAT (4X, F9.3, 2F6.2, F8.3, 11F9.3)
C
      IF (APMAG(1) .GT. 99.D0) GO TO 2000
      WT=(2./(2.-DMAG))*(100./MAGERR(1))**2
      MAGLIM=MAGLIM+WT*(SNGL(APMAG(1))-DMAG)
      MAGSQ=MAGSQ+WT*(SNGL(APMAG(1))-DMAG)**2
      SUMWT=SUMWT+WT
      NMAG=NMAG+1
      GO TO 2000
C
C-----------------------------------------------------------------------
C
C Normal return.
C
C Estimate magnitude limit, close files, and return.
C
 9000 CONTINUE
      CALL CLFILE (3)
      CALL CLFILE (2)
      IF (SUMWT .LE. 0.0) RETURN
      MAGLIM=MAGLIM/SUMWT
      MAGSQ=MAGSQ/SUMWT-MAGLIM**2
      MAGSQ=DSQRT(DMAX1(0.D0, MAGSQ))
      WRITE (LINE,630) MAGLIM, MAGSQ
  630 FORMAT (' Estimated magnitude limit (Aperture 1): ', F4.1,
     .      ' +-', F4.1, ' per star.')
      CALL STUPID (LINE)
      RETURN
C
C-----------------------------------------------------------------------
C
      END!

C @(#)unxdaosubs.for	19.1 (ES0-DMD) 02/25/03 13:23:51
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C 
C 010322		last modif
C 
C===========================================================================
C
      SUBROUTINE FABORT
      IMPLICIT     NONE
      RETURN
      END
C
C=================================================================
C
      SUBROUTINE CLFILE (LUN)
      IMPLICIT NONE
      INTEGER  LUN
      CLOSE (LUN)
      END
C
C=========================================================================
C
      SUBROUTINE BYEBYE
      IMPLICIT NONE
      WRITE (6,*)
      WRITE (6,*) 'Good bye.'
      WRITE (6,*)
      STOP
      END
C
C==========================================================================
C
      SUBROUTINE  OOPS
      IMPLICIT     NONE
      WRITE (6,*)
      WRITE (6,*) 'Sorry about that.'
      WRITE (6,*)
      STOP
      END
C
C==============================================================================
C
      SUBROUTINE INFILE (LUN, FILE, ISTAT)
      IMPLICIT     NONE
      INTEGER      LUN	
      CHARACTER*30 FILE
      INTEGER      ISTAT
C
      CHARACTER*100 EXPAND
      OPEN (LUN, FILE=EXPAND(FILE), STATUS='OLD', ERR=999)
      ISTAT = 0
      RETURN
  999 ISTAT = -1
      RETURN
      END
C
C========================================================
C
      CHARACTER*(*) FUNCTION EXPAND(FILE)
      IMPLICIT     NONE
      CHARACTER*30 FILE
      INTEGER I
      INTEGER J
      INTEGER K
C
      K = 0
      DO I=2,29
         IF (FILE(I:I) .EQ. ':') THEN
            CALL GETENV (FILE(1:I-1), EXPAND)
            DO J=1,100
               IF (EXPAND(J:J) .NE. ' ') K=J
            END DO
            IF (K .NE. 0) THEN
               EXPAND = EXPAND(1:K)//'/'//FILE(I+1:30)
               RETURN
            END IF
         END IF
      END DO
      EXPAND = FILE
      RETURN
      END
C
C======================================================
C
      SUBROUTINE OUTFIL (LUN, FILE, ISTAT)
      IMPLICIT     NONE
      INTEGER      LUN
      CHARACTER*30 FILE
      INTEGER      ISTAT
      CHARACTER*30 ANSWER
      CHARACTER*100 EXPAND
      LOGICAL EXIST
C
 1000 INQUIRE (FILE=EXPAND(FILE), EXIST=EXIST)
      IF (EXIST) THEN
         CALL STUPID ('This file already exists: '//FILE)
         ANSWER = 'OVERWRITE'
         CALL GETNAM ('NEW OUTPUT FILE NAME:', ANSWER)
         IF (ANSWER .EQ. 'OVERWRITE') THEN
            OPEN (LUN, FILE=EXPAND(FILE), STATUS='OLD')
            CLOSE (LUN, STATUS='DELETE')
         ELSE
            FILE = ANSWER
            GO TO 1000
         END IF
      END IF
      OPEN (LUN, FILE=EXPAND(FILE), STATUS='NEW', IOSTAT=ISTAT)
      RETURN
      END
C
C====================================================
C
      CHARACTER*(*) FUNCTION CASE (STRING)
      IMPLICIT      NONE
      CHARACTER*(*) STRING
C
C FOR UNIX, LEAVE THE CASES OF THE CHARACTERS ALONE!
C
      CASE = STRING
      RETURN
      END 
C
C
C====================================================
C
      SUBROUTINE OVRWRT (LINE, IWHICH)
      IMPLICIT      NONE
      CHARACTER*(*) LINE
      INTEGER       IWHICH
C
      CHARACTER*79 OUTPUT
      INTEGER LEN
C
      IF (IWHICH .EQ. 1) THEN
         WRITE (6,1) LINE
    1    FORMAT (A)
      ELSE IF (IWHICH .EQ. 2) THEN
         IF (LEN(LINE) .LT. 79) THEN
            OUTPUT = ' '
            OUTPUT = LINE
            WRITE (6,2) OUTPUT, CHAR(13)
            WRITE (6,2) OUTPUT, CHAR(13)
    2       FORMAT (A, A1, $)
         ELSE
            WRITE (6,2) LINE, CHAR(13)
         END IF
      ELSE IF (IWHICH .EQ. 3) THEN
         WRITE (6,3) LINE
    3    FORMAT (A)
      ELSE
         WRITE (6,4) LINE, CHAR(13)
    4    FORMAT (/A, A1, $)
      END IF
      RETURN
      END
C

C @(#)fitdirect.for	19.1 (ESO-IPG) 02/25/03 13:28:04

C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C       Internet e-mail: midas@eso.org
C       Postal address: European Southern Observatory
C                       Data Management Division 
C                       Karl-Schwarzschild-Strasse 2
C                       D 85748 Garching bei Muenchen 
C                       GERMANY
C===========================================================================
C
C


      program fitdirect
      
      implicit none
      include 'MID_REL_INCL:fit_var.inc'
      
                                ! copies of keywords coming from line
      character*80 SPESYS,SESSYS,OUTSYS,HISSYS
      integer GRASYS


      character*30 choice
      character*70 sjunk
      character*60 filnam


      integer ifla,ist,i,ijk,iok

C      include 'MID_REL_INCL:fit_mid.inc'
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'

C!!!!!!!
C     MIDAS SET-UP
C!!!!!!!
      call STSPRO('fitdirect')
      
      call STKRDC('SPECTAB',1,1,80,i,SPESYS,ijk,ijk,iok)
      if (iok.ne.0) then
         call ErrMsg('Error in reading keywords: check context..')
         call STSEPI() 
         stop
      end if   
      call STKRDC('OUTTAB',1,1,80,i,OUTSYS,ijk,ijk,iok)
      if (iok.ne.0) then
         call ErrMsg('Error in reading keywords: check context..')
         call STSEPI() 
         stop
      end if   
      call STKRDC('HISTAB',1,1,80,i,HISSYS,ijk,ijk,iok)
       if (iok.ne.0) then
         call ErrMsg('Error in reading keywords: check context..')
         call STSEPI() 
         stop
      end if   
      call STKRDC('SESSNAM',1,1,80,i,SESSYS,ijk,ijk,iok)
      if (iok.ne.0) then
         call ErrMsg('Error in reading keywords: check context..')
         call STSEPI() 
         stop
      end if   
      call STKRDI('GRAWIN',1,1,i,GRASYS,ijk,ijk,iok)
      if (iok.ne.0) then
         call ErrMsg('Error in reading keywords: check context..')
         call STSEPI() 
         stop
      end if   


C!!!!!!!
C     Videata iniziale
C!!!!!!!
      choice = ' '
      do i=1,4
         call sttdis(choice,0,ist)
      end do
      
      sjunk = '      - FitLyman-   Lyman clouds fitting procedure'
      do i=1,2
         call sttdis(' ',0,ist)
      end do
      call DisMsg('Loading & initializing data...')
      call DisMsg('Wait please..')
      
C!!!!!!!
C     Inizializzazione programma
C!!!!!!!
      if (SESSYS.ne.'NULL') then
         i=index(SESSYS,' ')
         sjunk=SESSYS(1:i-1)//PARTBL
      else
         sjunk=PARTBL
      end if
      call rsetup(sjunk,ist)  ! read set-up 

      if (ist.ne.0) then        ! on error, default values
         call WrnMsg('Error in reading set-up: using defaults')
                                ! copy syskeys into variables
         if (SPESYS.ne.'NULL') then
            FILSPE=SPESYS
         else
           call ErrMsg('Missing input parameters: check line command')
           call STSEPI() 
           stop
         end if   

         if (OUTSYS.ne.'NULL') then
            FILOUT=OUTSYS
         else
           call ErrMsg('Missing input parameters: check line command')
           call STSEPI() 
           stop
         end if   

         if (HISSYS.ne.'NULL') then
            FILLOG=HISSYS
         else
           call ErrMsg('Missing input parameters: check line command')
           call STSEPI() 
           stop
         end if   
         
         TURBLN=0
         i_grap = .false.
         if (GRASYS.ne.0) i_grap = .true.

         call F_TBLR('SCRATCH',1,ist) !initializes lypar (in memory!)

      else

         call f_tblr(sjunk,1,ist) !read init. param.
         if (SPESYS.ne.'NULL') FILSPE=SPESYS ! overrides values read
         if (OUTSYS.ne.'NULL') FILOUT=OUTSYS
         if (HISSYS.ne.'NULL') FILLOG=HISSYS
         if (GRASYS.ne.-1) then
            if (GRASYS .eq.1) i_grap = .true.
            if (GRASYS .eq.0) i_grap = .false.
         end if

      end if

      call f_tblw(PARTBL,1,ist)
c     call AskStp('PROGRAM',ist)
      call ssetup(PARTBL,ist)
      if (ist.ne.0) then
         call ErrMsg('Error in writing set-up: check disk space')
         call STSEPI() 
         stop
      end if   

      call AtmRD(ist)            !read atompar.dat
      NPUNTI=NMXSPE
      call reaspe(FILSPE,NPUNTI)    !read spectrum
      if (NPUNTI.lt.1) goto 666      
      i=index(FILLOG,' ')
      filnam=fillog(1:i-1)//PARTBL
      call GETIDN(filnam,IDnum,ist) 
      if (ist.ne.0) then
         call WrnMsg('Log files not found: starting from scratch')
         IDnum=0
      end if
                                ! read fit limits
      if (SESSYS.ne.'NULL') then
         i=index(SESSYS,' ')
         sjunk=SESSYS(1:i-1)//LIMTBL
      else
         sjunk=LIMTBL
      end if   
      call rintvl(sjunk,1,ist)  
      call sintvl(sjunk,1,ist) 

                                ! read minuit instructions
      if (SESSYS.ne.'NULL') then
         i=index(SESSYS,' ')
         sjunk=SESSYS(1:i-1)//MINTBL
      else
         sjunk=MINTBL
      end if   
      call rminui(sjunk,1,ist) 
      call sminui(sjunk,1,ist)


      call GraMai(ist)          ! plot 


      call DisMsg('        ..done')
      call sttdis(' ',0,ist)
      

C####
C    DIRECTMINI
C####
      call DisMsg('Preparing minimization data...')
      
      call f_tblr(PARTBL,1,ifla)
      if (ifla.ne.0) then
         call ErrMsg('Error in reading lypar')
         call STSEPI()
         stop
      end if               
                       
      call rintvl(LIMTBL,1,ifla)
      if (ifla.ne.0)  then
         call ErrMsg('Error in reading lypar')
         call STSEPI()
         stop
      end if
      
      call rminui(MINTBL,1,ifla)
      if (ifla.ne.0)  then
         call ErrMsg('Error in reading lypar')
         call STSEPI()
         stop
      end if
      
      call FitWin(i,ifla)       ! create data for FCN
      if (ifla.lt.0) then
         call ErrMsg('Error in initial condition for fit')
         call STSEPI()
         stop
      end if
      call FCNHd()
      call MinuHd()
      call DisMsg('...Done')
      write(sjunk,'(a25,i6)')'Number of pixel selected:',i
      call DisMsg(sjunk)

C       Esegue il fit
      call DisMsg('Executing fitting procedures...')
      call Minmze()
      call DisMsg('...Done')
      
C       Presenta e salva i risultati
      call GraMai(ifla)
      call ShoRes

      
      IDnum=IDNum+1
      call SavRes(FILOUT,ist)
      
      i=index(FILLOG,' ')       !saves on history file 
      filnam=FILLOG(1:i-1)//PARTBL
      call f_tblw(filnam,IDNum,ist)
      
      filnam=FILLOG(1:i-1)//MINTBL
      call sminui(filnam,IDNum,ist)
      
      filnam=FILLOG(1:i-1)//LIMTBL
      call sintvl(filnam,IDNum,ist)
      
            
      write(sjunk,'(a17,i6)')'Saved with ID =  ',IDnum
      call DisMsg(sjunk)

 666  continue
      call STSEPI()
      
      end
      

C===========================================================================
C Copyright (C) 1995-2008 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================

C ++++++++++++++++++++++++  yagl.for +++++++++++++++++++++++++++++++++++++++
C .LANGUAGE Fortran 77
C .IDENTIFICATION Module yagl.for
C .COMMENTS
C Module contains layer for the AGL related FORTRAN interfaces
C and the SC_interfaces written in (hopefully independent) C
C .AUTHOR         K. Banse        ESO - Garching
C .KEYWORDS       standard interfaces.
C .ENVIRONMENT    FORTRAN and C standards
C .VERSION  [1.00] 871207:  
C 
C 080723		last modif
C -----------------------------------------------------------------------------
C
      SUBROUTINE AGSSET(COMMAND)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   COMMAND
      INTEGER   STATUS
C 
      CALL STSTR(1,COMMAND)                          !STRIPPED_STRING
C 
      CALL AGL1(STATUS)
C
      RETURN
      END
C


      SUBROUTINE AGVDEF(DEVICE,XA,XB,YA,YB,XLIM,YLIM)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   DEVICE
      INTEGER   XA,XB,YA,YB,XLIM,YLIM
C 
      CALL STSTR(1,DEVICE)                             !STRIPPED_STRING
C 
      CALL AGL2(XA,XB,YA,YB,XLIM,YLIM)
C
      RETURN
      END

      SUBROUTINE AGGTXT (XC,YC,STR,CNTR)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   STR
      INTEGER   XC,YC,CNTR
C
      CALL STSTR(1,STR)                             !STRIPPED_STRING
C
      CALL AGL3(XC,YC,CNTR)
C
      RETURN
      END

      SUBROUTINE AGGERR (CODE,MESG)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   MESG
      INTEGER   CODE
C
      CALL STSTR(1,MESG)                             !STRIPPED_STRING
C
      CALL AGL4(CODE)
C
      RETURN
      END

      SUBROUTINE AGIGET (ITEM,IVAL)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   ITEM
      INTEGER   IVAL
C
      CALL STSTR(1,ITEM)                             !STRIPPED_STRING
C
      CALL AGL5(IVAL)
C
      RETURN
      END

      SUBROUTINE AGRGET (ITEM,RVAL)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   ITEM
      REAL   RVAL
C
      CALL STSTR(1,ITEM)                             !STRIPPED_STRING
C
      CALL AGL6(RVAL)
C
      RETURN
      END

      SUBROUTINE AGTGET (ITEM,XD,YD)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   ITEM
C
      CALL STSTR(1,ITEM)                             !STRIPPED_STRING
C
      CALL AGL7(XD,YD)
C
      RETURN
      END

      SUBROUTINE AGVLOS (XV,YV,MAXLEN,CHSTRG,PIXVAL)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   CHSTRG
      INTEGER   XV,YV,MAXLEN,PIXVAL
C
      CALL STSTR(1,CHSTRG)                             !STRIPPED_STRING
C
      CALL AGL8(XV,YV,MAXLEN,PIXVAL)
C
      RETURN
      END

      SUBROUTINE AGMOPN (FNAME)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   FNAME
      INTEGER   STATUS
C
      CALL STSTR(1,FNAME)                             !STRIPPED_STRING
C
      CALL AGL9(STATUS)
C
      RETURN
      END

      SUBROUTINE AGMRDW (METAFILE)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   METAFILE
      INTEGER   STATUS
C
      CALL STSTR(1,METAFILE)                             !STRIPPED_STRING
C
      CALL AGL10(STATUS)
C
      RETURN
      END


      SUBROUTINE AGESC (CMD,CMDLEN)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   CMD
      INTEGER   CMDLEN
C
      CALL STSTR(1,CMD)                             !STRIPPED_STRING
C
      CALL AGL11(CMDLEN)
C
      RETURN
      END

      SUBROUTINE AGAXES (X1,X2,Y1,Y2,STRING) 
C
      IMPLICIT NONE
C
      CHARACTER*(*)   STRING
      INTEGER   X1,X2,Y1,Y2
C
      CALL STSTR(1,STRING)                             !STRIPPED_STRING
C
      CALL AGL12(X1,X2,Y1,Y2)
C
      RETURN
      END


      SUBROUTINE AGAXIS (TYPE, DATA, LSPACE, FORM, LABEL) 
C
      IMPLICIT NONE
C
      CHARACTER*(*)   FORM, LABEL
      INTEGER   TYPE, DATA, LSPACE
C
      CALL STSTR(1,FORM)                             !STRIPPED_STRING
      CALL STSTR(2,LABEL)                             !STRIPPED_STRING
C
      CALL AGL13(TYPE, DATA, LSPACE)
C
      RETURN
      END

      SUBROUTINE AGORAX ( TYPE, ENDS, DATA, FORM, LABEL ) 
C
      IMPLICIT NONE
C
      CHARACTER*(*)   FORM, LABEL
      INTEGER   TYPE, DATA, ENDS
C
      CALL STSTR(1,FORM)                             !STRIPPED_STRING
      CALL STSTR(2,LABEL)                             !STRIPPED_STRING
C
      CALL AGL14(TYPE, ENDS, DATA)
C
      RETURN
      END

      SUBROUTINE AGNLIN(X1,X2,Y1,Y2,STRING)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   STRING
C
      CALL STSTR(1,STRING)                             !STRIPPED_STRING
C
      CALL AGL15(X1,X2,Y1,Y2)
C
      RETURN
      END

      SUBROUTINE AGFILL(X,Y,N,SPACE,ANGLE,SSET)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   SSET
      INTEGER   X,Y,N,SPACE,ANGLE
C
      CALL STSTR(1,SSET)                             !STRIPPED_STRING
C
      CALL AGL16(X,Y,N,SPACE,ANGLE)
C
      RETURN
      END

C @(#)ffnorm.for	19.1 (ES0-DMD) 02/25/03 14:25:21
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C @(#)ffnorm.for	19.1  (ESO)  02/25/03  14:25:21 
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++
C .COPYRIGHT   (C) 1993 European Southern Observatory    
C .IDENT       ffnorm.for                                    
C .AUTHORS     Otmar STAHL (Landessternwarte Heidelberg)
C .KEYWORDS    Spectroscopy, Long-Slit, Flat-Field, 
C              Normalization                   
C .PURPOSE                                               
C
C  Normalize a flat field image which is extended along columns.
C  The image is divided by a polynomial along the rows, in order
C  to achieve flux values close to unity. The bias value is subtracted
C  before the division. The normalized flat field and the polynomial
C  (in the form of a spectrum) are returned.
C
C .ALGORITHM
C
C  THE PROGRAM FIRST LOCATES THE EDGES OF THE SLIT IN THE DIRECTION
C  PERPENDICULAR TO THE DISPERSION BY LOOKING FOR A FLUX DECREASE.
C  THEN THE MEAN OF THE SPECTRUM IS TAKEN AND FITTED WITH A POLYNOMIAL. 
C
C .INPUT/OUTPUT
C
C  NORMALIZE/FLAT  norm_image fit_func input bias fit_order 
C  
C  OUT_A                 normalized output frame
C  OUT_B                 function used for normalization
C  IN_A                  input frame
C  INPUTR                bias value to subtract
C  INPUTI                order of the polynomial fit
C
C .VERSION     1.0  From package Long 22-APR-1988
C              2.0  Package Creation  17-MAR-1993        
C -------------------------------------------------------

      IMPLICIT NONE                 
      INTEGER         NPIX(2),IAV,ISTAT,NAXIS,IORD,NUM
      INTEGER*8       IPNTR1,IPNTR2,IPNTR3,IPNTR4,IPNTR5
      INTEGER         KUN, KNUL, MADRID, IDI, IDO, IDF, ISS
      CHARACTER*60    INFR,OUTFR,FITTED
      CHARACTER       CUNIT*64,IDENT*72
      REAL            BIAS
      DOUBLE PRECISION START(2),STEP(2)
      INCLUDE         'MID_INCLUDE:ST_DEF.INC'
      COMMON/VMR/MADRID(1)
      INCLUDE         'MID_INCLUDE:ST_DAT.INC'
C
      CALL STSPRO('FFNORM')
C
C GET INPUT AND MAP IMAGES
C
      CALL STKRDC('IN_A', 1,1,60,IAV,INFR,KUN,KNUL,ISTAT)
      CALL STKRDC('OUT_A',1,1,60,IAV,OUTFR,KUN,KNUL,ISTAT)
      CALL STKRDC('OUT_B',1,1,60,IAV,FITTED,KUN,KNUL,ISTAT)
      CALL STKRDR('INPUTR',1,1,IAV,BIAS,KUN,KNUL,ISTAT)
      CALL STKRDI('INPUTI',1,1,IAV,IORD,KUN,KNUL,ISTAT)
C
      CALL STIGET(INFR, D_R4_FORMAT, F_I_MODE, F_IMA_TYPE,
     .2,NAXIS,NPIX,START,STEP,IDENT,CUNIT,IPNTR1,IDI,ISTAT)
C
      CALL STIPUT(OUTFR,D_R4_FORMAT, F_O_MODE, F_IMA_TYPE,
     .NAXIS,NPIX,START,STEP,IDENT,CUNIT,IPNTR2,IDO,ISTAT)
C
      CALL STIPUT(FITTED,D_R4_FORMAT, F_O_MODE, F_IMA_TYPE,
     .1,NPIX(1),START(1),STEP(1),IDENT,CUNIT,IPNTR3,IDF,ISTAT)
C
C GET VIRTUAL MEMORY FOR ARRAYS
C
      NUM = NPIX(1)
      IF(NUM.LT.NPIX(2)) NUM = NPIX(2)
      NUM = NUM*4
      CALL TDMGET(NUM,IPNTR4,ISS)
      CALL TDMGET(NUM,IPNTR5,ISS)
C
C NORMALIZE FRAME
C
      CALL NORM(MADRID(IPNTR1),MADRID(IPNTR2),MADRID(IPNTR3),
     .          MADRID(IPNTR4),MADRID(IPNTR5),NPIX,BIAS,IORD)
C
C COPY HISTOR
C
C      CALL COPYDSC_ST(INFR,OUTFR,4,'HISTORY',ISTAT)
C      CALL COPYDSC_ST(INFR,FITTED,4,'HISTORY',ISTAT)
C
      CALL TDMFRE(NUM,IPNTR4,ISS)
      CALL TDMFRE(NUM,IPNTR5,ISS)
      CALL STSEPI
      END
C
C*************************************************************************
      SUBROUTINE NORM(IN,OUT,BLAZE,X,Y,NPIX,BIAS,IORD)
C
C normalize the image in dispersion correction
C
      IMPLICIT  NONE 
      INTEGER         NPIX(2),M,N,J,II,K,IMAX,J1,J2,IORD
      REAL            IN(1),OUT(1),BLAZE(1),FRAC,SUM,BIAS,RMAX,RMIN
      REAL            X(1),Y(1),CHISQ,YY
      REAL            A(10),B(10),S(10),W(10)  
C                       
C fixed parameter: 
C frac: used to locate the edges of the useful flat field (frac*max flux)
C
      FRAC = 0.5
      M = NPIX(1)
      N = NPIX(2)
C
C   DETERMINE PROFILE PERPENDICULAR TO DISPERSION   
C
      DO 20 J = 1,N
        SUM = 0.
        II = (J-1)*M                                                       
        DO 10 K = 1,M
          SUM = SUM+IN(II+K) 
10      CONTINUE
        Y(J) = SUM-N*BIAS
20    CONTINUE
C
C            LOCATE BEST EXPOSED PART OF SPECTRUM
C
      RMAX = 0.
      DO 30 J = 1,N
        IF(Y(J).GT.RMAX) THEN
          IMAX = J
          RMAX = Y(J)
        ENDIF
30    CONTINUE
C
      RMIN = RMAX*FRAC
      J1 = 1
      J2 = N
      DO 40 J = IMAX,N
        J2 = J
        IF(Y(J).LE.RMIN) GOTO 100
40    CONTINUE
100   J2 = J2-1
      DO 50 J = IMAX,1,-1
        J1 = J
        IF(Y(J).LE.RMIN) GOTO 200
50    CONTINUE
200   J1 = J1+1
      II = J2-J1+1    
C
C find mean spectrum (average perpendicular to dispersion)
C           
      DO 70 J = 1,M
        SUM = 0.
        DO 60 K = J1,J2
          SUM = SUM+IN((K-1)*M+J)
60      CONTINUE
        X(J) = J
        Y(J) = SUM/II-BIAS
70    CONTINUE
C 
C     FIT POLYNOMIAL               
C
      CALL LSORTH(X,Y,A,B,S,W,M,CHISQ,IORD)
C   
      DO 80 J = 1,M                                   
        CALL POLY(X(J),YY,A,B,S,W,IORD)
        BLAZE(J) = YY
80    CONTINUE
C                                                                       
C     NORMALIZE                                              
C                                     
       DO 90 J = 1,M
         DO 95 K = 1,N 
           II = (K-1)*M+J                                                  
           OUT(II) = (IN(II)-BIAS)/BLAZE(J) 
95       CONTINUE
90    CONTINUE
C                                                                       
C                                                                       
      RETURN
      END
C
C*****************************************************************************
C        POLY :  EVALUATES A POLYNOMIAL AT A POSITION XFIT
C       INPUT:  XFIT AND POLYNOMIAL COEFFICIENTS COMPUTED WITH LSORTH
C
C       OUTPUT: YFIT
C                                                                      
        SUBROUTINE POLY(XFIT,YFIT,A,B,S,W,IORD)  
C
        IMPLICIT NONE
        INTEGER           K,IORD
        REAL             A(10),B(10),S(10),W(10),P(10) 
        REAL              XFIT,YFIT
C   
        P(1)=1.  
        YFIT=S(1) 
C     
        P(2)=XFIT-A(1)   
        YFIT=YFIT+S(2)*P(2) 
C  
        DO 10 K=3,IORD+1   
          P(K)=(XFIT-A(K-1))*(P(K-1))-B(K-1)*P(K-2)
          YFIT=YFIT+S(K)*P(K)   
10      CONTINUE   
        RETURN     
        END 
C
C***************************************************************************   
C        LSORTH : FITS ORTHOGONAL POLYNOMIAL OF MAXIMUM DEGREE IORD
C                 THROUGH X-Y TABLE. AN F-TEST DECIDES WHETHER THE FIT
C                 STOPS ALREADY AT A LOWER ORDER THAN IORD.
C       INPUT:   THE ARRAYS X AND Y OF SIZE M CONTAIN THE VARIABLES.
C                THE ARRAY Y IS RETURNED AS A VECTOR WITH THE RESIDUALS.
C                 THE ROUTINE IS DESCRIBED IN PASP 91 (1979), PG. 546.    
C 
C       OUTPUT:  THE POLYNOMIAL COEFFICIENTS AND CHISQ ARE RETURNED 
C
        SUBROUTINE LSORTH (X,Y,A,B,S,W,M,CHISQ,IORD)
C
        IMPLICIT       NONE
        INTEGER      IMAX,IMAXST,IFAUTO,IORD,I,N,M,I1,IFF,K,K1
        INTEGER      IFTEST
        REAL         X(1),Y(1),A(10),B(10),S(10),W(10),P(10)
        REAL         CHISQ,DEL,XNU,F,F95,DCHI,P2
C
        DATA IMAXST/10/,IFTEST/2/ 
        IMAX=IMAXST     
        IFAUTO=0   
        IF(IORD .LT. 10) GOTO 110
        IORD=9
        IFAUTO=1
110     CONTINUE 
        IF(IORD .NE. 0) IMAX=MAX0(IABS(IORD)+1,2) 
        DO 10 I=1,IMAXST
          W(I)=0. 
          S(I)=0. 
          A(I)=0. 
          B(I)=0.
10      CONTINUE
        P(1)=1.
        DO 20 N=1,M
          W(1)=W(1)+1.   
          S(1)=S(1)+Y(N)  
          A(1)=A(1)+X(N)
20      CONTINUE
        S(1)=S(1)/W(1)
        A(1)=A(1)/W(1)    
        I=1   
        XNU=M-1
30      IFF=1  
40      I1=I   
        IF(IMAX .GT. I) I = I+1    
        CHISQ=0.  
        DO 70 N=1,M    
          P(2)=X(N)-A(1)    
          IF(I .EQ. 2) GOTO 60 
          DO 50 K=3,I
            K1=K-1    
50          P(K)=(X(N)-A(K1))*P(K1)-B(K1)*P(K-2)  
60        DEL=Y(N)-S(I1)*P(I1)   
          Y(N)=DEL  
          CHISQ=CHISQ+DEL*DEL 
          IF(IMAX .LE. I1) GOTO 70  
          P2=P(I)**2
          S(I)=S(I)+DEL*P(I)                                                     
          A(I)=A(I)+X(N)*P2  
          W(I)=W(I)+P2    
70      CONTINUE       
        IF(IMAX .LE. I1) GOTO 80  
        A(I)=A(I)/W(I)  
        B(I)=W(I)/W(I1)  
        S(I)=S(I)/W(I)      
        XNU=XNU-1.     
        DCHI=S(I)**2*W(I)  
        IF(DCHI .GE. CHISQ) GOTO 30   
        F=XNU*DCHI/(CHISQ-DCHI)   
        F95=3.84+(10.+(12.+(30.+105./XNU/XNU)/XNU)/XNU)/XNU    
        IF(F .GT. F95) GOTO 30  
        IF(IFAUTO.EQ.0) GOTO 30  ! F-TEST OFF
        XNU=XNU+1.   
        IFF=IFF+1      
        S(I)=0.   
        IF(IFF .LE. IFTEST) GOTO 40  
80      IORD=MIN0(IMAX-1,I1)-IFF+1
        RETURN 
        END

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM ALIGN
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION:
C  program ALIGN		version 1.00	881028
C  K. Banse			ESO - Garching
C
C.KEYWORDS:
C  images, rotation
C
C.PURPOSE:
C  given 2 tables with coordinates of the same objects in different images,
C  calculate the coefficients of the transformation function
C
C.ALGORITHM:
C  Use least squares approximation.
C
C.INPUT/OUTPUT:
C
C  The following keywords are used:
C  ACTION/C/1/1				A for aligning, R for rotation
C  IN_A/C/1/80				input_table1
C  IN_B/C/1/80				input_table2
C  INPUTC/C/1/1				method for transformation
C  P4/C/1/20				overlay flag, optional intensity
C
C  TRANSFRM/D/1/9			this key will be filled with the 
C					transformation values as in IHAP
C	
C.VERSIONS
C  1.00		taken from version 3.10 (871123) of original ALIGN code 
C		written by P. Grosbol
C 
C 100630	last modif
C--------------------------------------------------------------------------
C
      IMPLICIT NONE
C      
      INTEGER      COLNM1(3),COLNM2(3),COLNMR(3)
      INTEGER      BOX(4),XFIG(5),YFIG(5)
      INTEGER      OVINTS
      INTEGER      IAV,ICOUNT
      INTEGER      N,NN,NOPNTS
      INTEGER      NCNT1,NCNT2,NROW1,NROW2
      INTEGER      STAT,LL,IDNO(2000)
      INTEGER      TID1,TID2,IMNO
      INTEGER      UNI(1),NULO,MADRID(1)
C
      CHARACTER*80   TABLE1,TABLE2,FRAME
      CHARACTER      CBUF*80,METHOD*1,RESIDU*1,OVFLAG*20
      CHARACTER      LABEL1(3)*16,LABEL2(3)*16,IDENT1*8
      CHARACTER      IDENT2*8,ID(2000)*8
      CHARACTER      CTEST*8
C     
      REAL    R1,R2
      REAL    XX1(2,2000),XX2(2,2000),TEMP1(3),TEMP2(3)
      REAL    A,A1,A2,A3,A4,CX,CY,R,X,Y
      REAL    RBUF(17),PBUF(6)
      REAL    RINF(8)
C 
      LOGICAL       TABNUL(3)
      LOGICAL       ISEL1, ISEL2
C      
      DOUBLE PRECISION  TR(6),F1,F2,ANG,DBUF(9)
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C 
      INCLUDE 'MID_INCLUDE:IDIMEM.INC'
      INCLUDE 'MID_INCLUDE:IDIDEV.INC'
C 
      COMMON  /VMR/  MADRID
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C 
C  set up MIDAS environment + enable automatic error abort
C
      CALL STSPRO('ALIGN')
      ICOUNT = 0
      CALL STKRDC('ACTION',1,1,1,IAV,METHOD,UNI,NULO,STAT)
      IF (METHOD.EQ.'R') THEN
         CALL ALIGNR
         CALL STSEPI
      ENDIF
C
C  get input tables and columns
      CALL STKRDC('IN_A',1,1,80,IAV,TABLE1,UNI,NULO,STAT)
      CALL STKRDC('IN_B',1,1,80,IAV,TABLE2,UNI,NULO,STAT)
C      
C  look for column labels
      LABEL1(3) = 'IDENT '
      LABEL2(3) = 'IDENT '
      LL = INDEX(TABLE1,',')
      IF (LL.LE.0) THEN
         LABEL1(1) = 'XCEN '
         LABEL1(2) = 'YCEN '
      ELSE
         CBUF(1:) = TABLE1(LL+1:)//' '
         TABLE1(LL:) = ' '
         LL = INDEX(CBUF,',')
         IF (LL.LE.0)
     +      CALL STETER(9,'invalid syntax for 1. input table')
         LABEL1(1) = CBUF(2:LL-1)            !omit the leading ':'
         LABEL1(2) = CBUF(LL+2:)
      ENDIF
C      
      LL = INDEX(TABLE2,',')
      IF (LL.LE.0) THEN
         LABEL2(1) = 'XCEN '
         LABEL2(2) = 'YCEN '
      ELSE
         CBUF(1:) = TABLE2(LL+1:)//' '
         TABLE2(LL:) = ' '
         LL = INDEX(CBUF,',')
         IF (LL.LE.0)
     +      CALL STETER(9,'invalid syntax for 2. input table')
         LABEL2(1) = CBUF(2:LL-1)            !omit the leading ':'
         LABEL2(2) = CBUF(LL+2:)
      ENDIF
C      
      IF (TABLE1.EQ.TABLE2)
     +   CALL STETER(1,'input and output table have to be different...')
       
C  get method
      CALL STKRDC('INPUTC',1,1,2,IAV,CBUF,UNI,NULO,STAT)
      CALL UPCAS(CBUF,CBUF)              !make sure we have upper case
      METHOD = CBUF(1:1)
      RESIDU = CBUF(2:2)
C
C  test, if required columns are there
      CALL TBTOPN(TABLE1,F_IO_MODE,TID1,STAT)
      CALL TBTOPN(TABLE2,F_I_MODE,TID2,STAT)
      DO 100,N=1,3
         CALL TBLSER(TID1,LABEL1(N),COLNM1(N),STAT)
         IF (COLNM1(N).EQ.-1) THEN
            CBUF(1:) = 'column '//LABEL1(N)//
     +                   'not found in table '//TABLE1//' '
            CALL STETER(2,CBUF)
         ENDIF
         CALL TBLSER(TID2,LABEL2(N),COLNM2(N),STAT)
         IF (COLNM2(N).EQ.-1) THEN
            CBUF(1:) = 'column '//LABEL2(N)//
     +                   'not found in table '//TABLE2//' '
            CALL STETER(2,CBUF)
         ENDIF
100   CONTINUE
C 
C  check, that IDENT columns are of type character
        CALL TBFGET(TID1,COLNM1(3),CBUF,IAV,NN,STAT)
        IF (NN.NE.D_C_FORMAT) THEN
           CALL STETER(22,
     +     '1. Table: Column :IDENT not character type ...')
        ENDIF
        CALL TBFGET(TID2,COLNM2(3),CBUF,IAV,NN,STAT)
        IF (NN.NE.D_C_FORMAT) THEN
           CALL STETER(22,
     +     '2. Table: Column :IDENT not character type ...')
        ENDIF
C 
C  if RESIDU is set, look for residual columns
      IF (RESIDU.EQ.'Y') THEN
         CBUF(1:) = ' '
         CALL TBLSER(TID1,'XRESIDUAL',COLNMR(1),STAT)
         IF (COLNMR(1).EQ.-1) THEN
            CALL TBCINI(TID1,D_R4_FORMAT,1,'G12.6',CBUF(1:16),
     +                  'XRESIDUAL',COLNMR(1),STAT)
         ENDIF
         CALL TBLSER(TID1,'YRESIDUAL',COLNMR(2),STAT)
         IF (COLNMR(2).EQ.-1) THEN
            CALL TBCINI(TID1,D_R4_FORMAT,1,'G12.6',CBUF(1:16),
     +                  'YRESIDUAL',COLNMR(2),STAT)
         ENDIF
         CALL TBLSER(TID1,'RESIDUALS',COLNMR(3),STAT)
         IF (COLNMR(3).EQ.-1) THEN
            CALL TBCINI(TID1,D_R4_FORMAT,1,'G12.6',CBUF(1:16),
     +                  'RESIDUALS',COLNMR(3),STAT)
         ENDIF
      ENDIF
C      
C  get values from tables
      CALL TBIGET(TID1,N,NROW1,N,N,N,STAT)            !get total no. of rows
      CALL TBIGET(TID2,N,NROW2,N,N,N,STAT)            !get total no. of rows
C      
C  here we loop and look for equal identifiers
      DO 1000,NCNT1=1,NROW1
         CALL TBSGET(TID1,NCNT1,ISEL1,STAT)
         IF (ISEL1) THEN
            CALL TBRRDR(TID1,NCNT1,2,COLNM1,TEMP1,    !get next row of table1
     +                  TABNUL,STAT)
            IF (TABNUL(1).OR.TABNUL(2)) GOTO 1000     !skip Null values

            CALL TBERDC(TID1,NCNT1,COLNM1(3),      
     +                  CTEST,TABNUL,STAT)
            CALL FT_EOS(CTEST,8,IDENT1,STAT)
            DO 400,NCNT2=1,NROW2
               CALL TBSGET(TID2,NCNT2,ISEL2,STAT)
               IF (ISEL2) THEN
                  CALL TBERDC(TID2,NCNT2,      
     +                        COLNM2(3),CTEST,TABNUL,STAT)
                  CALL FT_EOS(CTEST,8,IDENT2,STAT)
                  IF (IDENT1.EQ.IDENT2) THEN       !match, read also x,y values
                     CALL TBRRDR(TID2,NCNT2,2,COLNM2,TEMP2,
     +                           TABNUL,STAT)
                     GOTO 800            
                  ENDIF
               ENDIF
400         CONTINUE
         ENDIF
C      
C  no matching identifier in TABLE2 so skip this row
         GOTO 1000
C      
C  matching identifiers
800      ICOUNT = ICOUNT + 1
         IF (ICOUNT.GT.2000) THEN
            ICOUNT = 2000
            GOTO 1500                        !we only take max. 2000 points
         ELSE
            ID(ICOUNT) = IDENT1
            IDNO(ICOUNT) = NCNT1             !save row no.
            XX1(1,ICOUNT) = TEMP1(1)
            XX1(2,ICOUNT) = TEMP1(2)
            XX2(1,ICOUNT) = TEMP2(1)
            XX2(2,ICOUNT) = TEMP2(2)
         ENDIF
1000  CONTINUE
C
C  check if errors      
C
1500  IF (ICOUNT.EQ.0)
     +   CALL STETER(3,'no identifiers match')
C      
C  now calculate the transformation
C 
      CALL TRANS(XX2,XX1,ICOUNT,METHOD,ANG,F1,F2,TR,STAT)
      IF (STAT.NE.0)
     +   CALL STETER(4,'problems in calculating the transformation')
C      
C  fill keyword TRANSFRM
C 
      ANG = 57.29578D0 * ANG            !transform to degrees
      DBUF(1) = ANG
      DBUF(2) = F1
      DBUF(3) = F2
      DO 1800,N=1,6
         DBUF(N+3) = TR(N)
1800  CONTINUE
      CALL STKWRD('TRANSFRM',DBUF,1,9,UNI,STAT)
C      
C  display results
      WRITE(CBUF,10001) DBUF(1)
      CALL STTPUT(CBUF,STAT)
      WRITE(CBUF,10002) DBUF(2),DBUF(3)
      CALL STTPUT(CBUF,STAT)
      CBUF = ' '
      CALL STTPUT(CBUF,STAT)
C      
C  if desired, draw computed new position into overlay plane
      CALL STKRDC('P4',1,1,20,IAV,OVFLAG,UNI,NULO,STAT)
      IF (OVFLAG(1:1).EQ.'o') OVFLAG(1:1) = 'O'
      IF (OVFLAG(1:1).EQ.'O') THEN
         CALL DTOPEN(1,STAT)
         NN = INDEX(OVFLAG,',')
         IF (NN.LE.0) THEN
            OVINTS = 255                  !default intensity is 255
         ELSE
            CALL GENCNV(OVFLAG(NN+1:),1,1,OVINTS,OVINTS,OVINTS,N)
            IF (N.LE.0) OVINTS = 255
         ENDIF
C
C  get info of displayed image
         CALL DTGICH(QDSPNO,QIMCH,FRAME,RINF,STAT)
         CALL STFOPN(FRAME,D_OLD_FORMAT,0,F_IMA_TYPE,IMNO,STAT)
         CALL PIXXCV('INIT',IMNO,RBUF,STAT)       !set up PIXXCV
      ENDIF
C
C  compute residuals and mean error
      A = 0.
      A1 = TR(1)
      A2 = TR(2)
      A3 = TR(3)
      A4 = TR(4)
      CX = TR(5)
      CY = TR(6)
C      
      WRITE(CBUF,10003)
      CALL STTPUT(CBUF,STAT)
      DO 2200,N=1,ICOUNT
         X = A1*XX1(1,N) + A2*XX1(2,N) + CX
         Y = A3*XX1(1,N) + A4*XX1(2,N) + CY
         R1 = X - XX2(1,N)
         R2 = Y - XX2(2,N)
         R = SQRT( R1*R1 + R2*R2 )
         WRITE(CBUF,10004) ID(N),X,Y,R1,R2,R
         IF (RESIDU.EQ.'Y') THEN               !save residuals in input table
            TEMP1(1) = R1
            TEMP1(2) = R2
            TEMP1(3) = R
            CALL TBRWRR(TID1,IDNO(N),3,COLNMR,TEMP1,STAT)
         ENDIF
C 
         CALL STTPUT(CBUF,STAT)
         A = A + R                              !sum up...
         IF (OVFLAG(1:1).EQ.'O') THEN
            PBUF(1) = X
            PBUF(2) = Y
            CALL PIXXCV('WRS',0,PBUF,STAT)      !world c. -> screen c.
            BOX(1) = PBUF(5) - 5
            BOX(2) = PBUF(6) - 5
            BOX(3) = PBUF(5) + 5
            BOX(4) = PBUF(6) + 5
            TEMP1(1) = -1.0
            TEMP1(2) = -1.0
            CALL BLDGRA('REC',BOX,TEMP1,XFIG,YFIG,5,NOPNTS)
            CALL IIGPLY(QDSPNO,QOVCH,XFIG,YFIG,NOPNTS,OVINTS,1,STAT)
         ENDIF
2200  CONTINUE
C 
      A = A/ICOUNT                              !normalize...
      WRITE(CBUF,10000) A
      CALL STTPUT(CBUF,STAT)
      IF (OVFLAG(1:1).EQ.'O') CALL DTCLOS(QDSPNO)
C      
C  that's it folks...
C
      CALL STSEPI
C      
C  Formats
10000 FORMAT('mean error = ',E15.6)
10001 FORMAT('rotation angle = ',F8.3,' degrees')
10002 FORMAT('scaling factors in x,y :',E15.6,', ',E15.6)
10003 FORMAT('ID         X              Y            x-residual   ',
     +       ' y-residual    residuals')
10004 FORMAT(A,5E14.6)
C 
      END         

      SUBROUTINE TRANS(X1,X2,N,METH,ANG,F1,F2,TR,STAT)
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION:
C  subroutine TRANS            version 2.10      850812
C  K. Banse                  ESO - Garching
C
C.KEYWORDS:
C  transformation, coordinate sets
C
C.PURPOSE:
C  Calculate the coefficients of a linear transformation between the
C  two point sets X1 and X2 of N points each.
C  The transformation is assumed to be of the form:
C      
C  X1(1,k) = TR(1)*X2(1,k) + TR(2)*X2(2,k) + TR(5)
C  X1(2,k) = TR(3)*X2(1,k) + TR(4)*X2(2,k) + TR(6)
C      
C  or alternatively
C      
C  X1(1,k) =  F1*cos(ANG)*X2(1,k) + F2*sin(ANG)*X2(2,k) + TR(5)
C  X1(2,k) = -F1*sin(ANG)*X2(1,k) + F2*cos(ANG)*X2(2,k) + TR(6)
C
C.ALGORITHM:
C  Use least square algorithm.
C
C.INPUT/OUTPUT:
C  call as TRANS(X1,X2,N,METH,ANG,F1,F2,TR,STAT)
C
C  input par:
C  X1:           R*4 array            1. set of points
C  X2:           R*4 array            2. set of points
C  N:            I*4                  no. of points in X1 and X2
C  METH:         char.exp.            method to use,
C                              F = free paramaters, E = F1 and F2 are equal
C                              U = F1 = F2 = 1.0
C                              S = shift only: F1 = F2 = 1.0, angle = 0.0
C      
C  output par:
C  ANG:           R*8                  rotation angle in radians
C  F1:            R*8                  scaling factor in x-direction
C  F2:            R*8                  scaling factor in y-direction
C  TR:            R*8 array            array of coefficients
C                                      ANG, F1, F2 are derived from TR ...
C  STAT:          I*4                  return status
C
C--------------------------------------------------------------------------
C
      IMPLICIT NONE
C      
      CHARACTER*(*)      METH
C      
      INTEGER      I,N,STAT
C      
      REAL         X1(2,N),X2(2,N)
C      
      DOUBLE PRECISION      TR(6),F1,F2,ANG,AC
      DOUBLE PRECISION      RN,X,Y,XI,YI,XX,XY,YY,XXI,XYI,XIY,YYI
      DOUBLE PRECISION      A,B,C,D,DINV
      DOUBLE PRECISION      DATAN2,DCOS,DSIGN,DSIN,DSQRT            !system functions...
C      
C  check input
      IF ( ((METH(1:1).EQ.'F').AND.(N.LT.3)) .OR.
     +     ((METH(1:1).EQ.'E').AND.(N.LT.2)) .OR.
     +     ((METH(1:1).EQ.'U').AND.(N.LT.2)) .OR.
     +     ((METH(1:1).EQ.'S').AND.(N.LT.1)) ) THEN
         CALL STTPUT('not enough points in tables...',STAT)
         STAT = -1
         RETURN
      ELSE
         STAT= 0
      ENDIF
C      
C  init sums
      RN = 1.D0 / DBLE (FLOAT(N) )
      X = 0.D0
      Y = 0.D0
      XI = 0.D0
      YI = 0.D0
      XX = 0.D0
      XY = 0.D0
      YY = 0.D0
      XXI = 0.D0
      XYI = 0.D0
      XIY = 0.D0
      YYI = 0.D0
C      
C  compute the sums
      DO 1000, I=1,N
         A = DBLE (X2(1,I))
         B = DBLE (X2(2,I))
         C = DBLE (X1(1,I))
         D = DBLE (X1(2,I))
C      
         X = X + A                  !sum of x-coords of X2
         Y = Y + B                  !sum of y-coords of X2
         XX = XX + A*A
         XY = XY + A*B
         YY = YY + B*B
         XI = XI + C
         YI = YI + D
         XXI = XXI + A*C
         XYI = XYI + A*D
         XIY = XIY + C*B
         YYI = YYI + B*D
1000  CONTINUE
C      
C  normalize coefficients
      XX = XX - X*X*RN
      XY = XY - X*Y*RN
      YY = YY - Y*Y*RN
      XXI = XXI - X*XI*RN
      XYI = XYI - X*YI*RN
      XIY = XIY - XI*Y*RN
      YYI = YYI - Y*YI*RN
C      
C  branch according to method
      IF (METH(1:1).EQ.'E') GOTO 2000
      IF (METH(1:1).EQ.'U') GOTO 3000
      IF (METH(1:1).EQ.'S') GOTO 4000
C      
C  fall through to method = FREE      (all paramters are free)
      D = XX*YY - XY*XY
      IF (DABS(D).LT.1.D-20) THEN
         CALL STTPUT('points not well chosen...',STAT)
         STAT = 1
         RETURN
      ENDIF
C
      A = (YY*XXI - XY*XIY) / D
      B = (XX*XIY - XY*XXI) / D
      C = (YY*XYI - XY*YYI) / D
      D = (XX*YYI - XY*XYI) / D
C      
      TR(1) = A
      TR(2) = B
      TR(3) = C
      TR(4) = D
      TR(5) = (XI - A*X - B*Y)*RN
      TR(6) = (YI - C*X - D*Y)*RN
C      
      ANG = DATAN2(B,D)
      F1 = DSQRT(A*A + C*C)
      F2 = DSQRT(B*B + D*D)
      AC = DCOS(ANG)
      IF (DABS(AC).GT.0.5D0) THEN
         F1 = DSIGN( F1,TR(1)*AC)
         F2 = DSIGN( F2,TR(4)*AC)
      ELSE
         AC = DSIN(ANG)
         F1 = DSIGN( F1,-TR(3)*AC)
         F2 = DSIGN( F2,TR(2)*AC)
      ENDIF
      RETURN
C      
C  method = EQUAL      (F1 = F2)
2000  D = XX + YY
      IF (DABS(D).LT.1.D-20) THEN
         CALL STTPUT('points not well chosen...',STAT)
         STAT = 1
         RETURN
      ELSE
         DINV = 1.D0 / D
      ENDIF
C
      A = (XXI + YYI) * DINV
      B = (XIY - XYI) * DINV
C      
      TR(1) = A
      TR(2) = B
      TR(3) = -TR(2)
      TR(4) = TR(1)
      TR(5) = (XI - A*X - B*Y)*RN
      TR(6) = (YI + B*X - A*Y)*RN
C      
      ANG = DATAN2(B,A)
      F1 = DSQRT(A*A+B*B)
      F2 = F1
      RETURN
C      
C  method = UNIT            (F1 = F2 = 1.0)
3000  A = DATAN2( (XIY-XYI),(XXI+YYI) )
      ANG = A
      TR(1) = DCOS(ANG)
      TR(2) = DSIN(ANG)
      TR(3) = -TR(2)
      TR(4) = TR(1)
      TR(5) = (XI - TR(1)*X - TR(2)*Y)*RN
      TR(6) = (YI + TR(2)*X - TR(1)*Y)*RN
C      
      F1 = 1.0D0
      F2 = 1.0D0
      RETURN
C      
C  method = SHIFT            (F1 = F2 = 1.0, angle = 0.0)
4000  ANG = 0.0D0
      TR(1) = 1.0D0
      TR(2) = 0.0D0
      TR(3) = 0.0D0
      TR(4) = 1.0D0
      TR(5) = (XI - X) * RN
      TR(6) = (YI - Y) * RN
C      
      F1 = 1.0D0
      F2 = 1.0D0
      RETURN
C
      END

      SUBROUTINE ALIGNR
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine ALIGNR            version 1.00      861028
C  K. Banse                  ESO - Garching
C  1.10   910205
C
C.KEYWORDS
C  pixels
C
C.PURPOSE
C  scale + rotate image according to output from ALIGN/IMAGE
C
C.ALGORITHM
C  get the names of input + output frames from IN_A + OUT_B
C  get the new dimensions of output frame by rotating first the corner pixels
C  fill output frame with zeroes + rotate rest of input frame
C
C  copy descriptor LHCUTS to output frame to keep same colours at same pixels!
C
C.INPUT/OUTPUT
C  the following keywords are used:
C
C  IN_A/C/1/80                  input frame
C  OUT_A/C/1/80			output frame
C  TRANSFRM/D/1/9		rotation specs + transfromation matrix
C  IN_B/C/1/80			reference frame, if not "+"
C  NULL?R/2/1			User Nullvalue
C
C--------------------------------------------------
C
      IMPLICIT NONE
C      
      INTEGER      IAV,N,NAXISA
      INTEGER*8    PNTRA,PNTRB
      INTEGER      IMNOA,IMNOB,IMNOR,STAT
      INTEGER      NPIXA(3),NPIXB(3)
      INTEGER      NAXISC
      INTEGER      UNI(1),NULO,MADRID(1)
C
      CHARACTER*80   FRAMEA,FRAMEB,FRAMEC
      CHARACTER      CUNITA*64,IDENTA*72,ACTION*2
C      
      REAL         RNULL
C 
      DOUBLE PRECISION STEPA(3),STARTA(3)
      DOUBLE PRECISION STARTB(3),STEPB(3),STARTC(3),END(2)
      DOUBLE PRECISION X1,X2,X3,X4,Y1,Y2,Y3,Y4
      DOUBLE PRECISION ST(2),EN(2),F1,F2,A1,A2,A3,A4
      DOUBLE PRECISION CX,CY,TR(6),CUTS(4)
      DOUBLE PRECISION TOT(9),TRR(6)
C 
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C 
      COMMON  /VMR/  MADRID
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C 
      DATA    IDENTA    /' '/
      DATA    CUNITA    /' '/
C
C  get input frame + map it
C 
      CALL STKRDC('IN_A',1,1,80,IAV,FRAMEA,UNI,NULO,STAT)
      CALL STIGET(FRAMEA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,3,
     +            NAXISA,NPIXA,STARTA,STEPA,      
     +            IDENTA,CUNITA,PNTRA,IMNOA,STAT)
      IF (NAXISA.EQ.1) THEN
         CALL STETER(1,'We need a 2-dim image ...')
      ELSE IF (NAXISA.GT.2) THEN
         NAXISA = 2
         CALL STTPUT('We only work on the 1. plane ...',STAT)
      ENDIF
      IF ((NPIXA(1).EQ.1).OR.(NPIXA(2).EQ.1))
     +   CALL STETER(1,'We need a 2-dim image ...')
C
C  get output frame
      CALL STKRDC('OUT_A',1,1,80,IAV,FRAMEB,UNI,NULO,STAT)
C
C  get transfomation coefficients + user Null
      CALL STKRDD('TRANSFRM',1,9,IAV,TOT,UNI,NULO,STAT)
      F1 = TOT(2)
      F2 = TOT(3)
      A1 = TOT(4)
      A2 = TOT(5)
      A3 = TOT(6)
      A4 = TOT(7)
      CX = TOT(8)
      CY = TOT(9)
      CALL STKRDR('NULL',2,1,IAV,RNULL,UNI,NULO,STAT)
C      
C  to get size of output frame, rotate corners
      END(1) = STARTA(1) + (NPIXA(1)-1)*STEPA(1)
      END(2) = STARTA(2) + (NPIXA(2)-1)*STEPA(2)
C      
      X1 = A1*STARTA(1) + A2*STARTA(2) + CX
      Y1 = A3*STARTA(1) + A4*STARTA(2) + CY
      X2 = A1*STARTA(1) + A2*END(2) + CX
      Y2 = A3*STARTA(1) + A4*END(2) + CY
      X3 = A1*END(1) + A2*STARTA(2) + CX
      Y3 = A3*END(1) + A4*STARTA(2) + CY
      X4 = A1*END(1) + A2*END(2) + CX
      Y4 = A3*END(1) + A4*END(2) + CY
C      
C  get result frame "corners"
      ST(1) = MIN(X1,X2,X3,X4)            !rotated x-start
      EN(1) = MAX(X1,X2,X3,X4)            !rotated x-end
      ST(2) = MIN(Y1,Y2,Y3,Y4)            !rotated y-start
      EN(2) = MAX(Y1,Y2,Y3,Y4)            !rotated y-end
C      
C  check refframe option
      CALL STKRDC('IN_B',1,1,80,IAV,FRAMEC,UNI,NULO,STAT)
      IF (FRAMEC(1:1).NE.'+') THEN
         ACTION(2:2) = 'F'
         CALL STFOPN(FRAMEC,D_OLD_FORMAT,0,1,IMNOR,STAT)
         CALL STDRDI(IMNOR,'NAXIS',1,1,IAV,NAXISC,UNI,NULO,STAT)
         CALL STDRDI(IMNOR,'NPIX',1,3,IAV,NPIXB,UNI,NULO,STAT)
         IF (NAXISC.EQ.1) THEN
            CALL STETER(10,'We need a 2-dim reference image ...')
         ELSE IF (NAXISC.GT.2) THEN
            NAXISC = 2
         ENDIF
         IF ((NPIXB(1).EQ.1).OR.(NPIXB(2).EQ.1))
     +      CALL STETER(10,'We need a 2-dim reference image ...')
         CALL STDRDD(IMNOR,'START',1,2,IAV,STARTC,UNI,NULO,STAT)
         CALL STDRDD(IMNOR,'STEP',1,2,IAV,STEPB,UNI,NULO,STAT)
      ELSE
         ACTION(2:2) = 'Q'
         STEPB(1) = STEPA(1) * F1
         STEPB(2) = STEPA(2) * F2
      ENDIF
C      
      IF (STEPB(1).LT.0.) THEN
         STARTB(1) = EN(1)
      ELSE
         STARTB(1) = ST(1)
      ENDIF
      IF (STEPB(2).LT.0.) THEN
         STARTB(2) = EN(2)
      ELSE
         STARTB(2) = ST(2)
      ENDIF
C
      NPIXB(1) = NINT( (EN(1) - ST(1))/ABS(STEPB(1)) ) + 1
      NPIXB(2) = NINT( (EN(2) - ST(2))/ABS(STEPB(2)) ) + 1
C      
C  I think the following code section was wrong all the time...
C  so take it out (000426)
CC      IF (ACTION(2:2).EQ.'F') THEN
CC         STARTB(1) =
CC     +         STEPB(1) * FLOAT( INT( (STARTB(1)-STARTC(1))/STEPB(1) ) )
CC     +         +   STARTC(1)
CC         STARTB(2) =
CC     +         STEPB(2) * FLOAT( INT( (STARTB(2)-STARTC(2))/STEPB(2) ) )
CC     +         +   STARTC(2)
CC      ENDIF
C      
C  invert transformation matrix
      CALL INVERS(TOT(4),TRR,STAT)      
      DO 1000, N=1,6
         TR(N) = TRR(N)            !R*8 -> R*4
1000  CONTINUE
C
C  and map it...
      CALL STIPUT(FRAMEB,D_R4_FORMAT,F_O_MODE,1,
     +            NAXISA,NPIXB,STARTB,STEPB,
     +            IDENTA,CUNITA,PNTRB,IMNOB,STAT)
C      
C  and do the rotation
      CALL MATROT(MADRID(PNTRA),MADRID(PNTRB),NPIXA,NPIXB,
     +            STARTA,END,STEPA,STARTB,STEPB,TR,RNULL)
C 
C  copy descriptors + LHCUTS
      CALL DSCUPT(IMNOA,IMNOB,' ',STAT)
      CALL STDRDR(IMNOA,'LHCUTS',1,4,IAV,CUTS,UNI,NULO,STAT)
      CALL STDWRR(IMNOB,'LHCUTS',CUTS,1,4,UNI,STAT)
C
      RETURN
C      
      END

      SUBROUTINE INVERS(TRIN,TROUT,STAT)
C      
      IMPLICIT NONE
C      
      INTEGER      STAT
C      
      DOUBLE PRECISION      TRIN(6),TROUT(6)
      DOUBLE PRECISION      DD
C      
      DD = TRIN(1)*TRIN(4) - TRIN(2)*TRIN(3)
      IF (DABS(DD).LT.1.D-20) THEN
         STAT = 1
         RETURN
      ELSE
         STAT = 0
      ENDIF
C      
      TROUT(1) = TRIN(4) / DD
      TROUT(2) = -TRIN(2) / DD
      TROUT(3) = -TRIN(3) / DD
      TROUT(4) = TRIN(1) / DD
      TROUT(5) = -( TROUT(1)*TRIN(5) + TROUT(2)*TRIN(6) )
      TROUT(6) = -( TROUT(3)*TRIN(5) + TROUT(4)*TRIN(6) )
      RETURN
      END

      SUBROUTINE MATROT(A,B,NPIXA,NPIXB,START,END,STEP,
     +                  STARTB,STEPB,TR,ZNULL)
C
C  K. Banse            881028, 910205, 000419
C      
C  do "matrix" rotation, i.e. compute:
C
C      X = XROT*A1 + YROT*A2 + XC
C      Y = YROT*A3 + XROT*A4 + YC
C
C                                     in real world coordinates
C
C      
      IMPLICIT NONE
C
      INTEGER      NPIXA(2),NPIXB(2)
      INTEGER      NX,NY,INDX
      INTEGER      NO1,NO2,NO3,NO4,XDIMA,SIZEA
      INTEGER      KX,KY,KSTX
C      
      REAL         A(*),B(*)
      REAL         ZNULL
C      
      DOUBLE PRECISION TR(6)
      DOUBLE PRECISION Y1,X,Y,DX,DY
      DOUBLE PRECISION B1,B2,B3,B4,XC,YC,BB1,BB3
      DOUBLE PRECISION XT,YT,XFRAC,YFRAC,XST,YST
      DOUBLE PRECISION STARTB(2),STEPB(2),START(2),END(2),STEP(2)
      DOUBLE PRECISION MINI(2), MAXI(2)
C      
C  init
      B1 = TR(1)
      B2 = TR(2)
      B3 = TR(3)
      B4 = TR(4)
      XC = TR(5)
      YC = TR(6)
      DX = B1 * STEPB(1)
      DY = B3 * STEPB(1)
      XDIMA = NPIXA(1)
      SIZEA = NPIXA(1)*NPIXA(2)


      IF (START(1).LT.END(1)) THEN
          MINI(1) = START(1)
          MAXI(1) = END(1)
      ELSE
          MINI(1) = END(1)
          MAXI(1) = START(1)
      ENDIF
C
      IF (START(2).LT.END(2)) THEN
          MINI(2) = START(2)
          MAXI(2) = END(2)
      ELSE
          MINI(2) = END(2)
          MAXI(2) = START(2)
      ENDIF
C      
      XST = 1.D0/STEP(1)
      YST = 1.D0/STEP(2)
      BB1 = B1 * STARTB(1)
      BB3 = B3 * STARTB(1)
      INDX = 0
C      
C  loop through result lines
      Y1 = STARTB(2)                        !init Y1 to start-y
      DO 2000,NY=1,NPIXB(2)
C      
         X = BB1 + B2*Y1 + XC
         Y = BB3 + B4*Y1 + YC
C      
         DO 1000,NX=1,NPIXB(1)
            INDX = INDX + 1                  !loop along result line
            IF ((X.LT.MINI(1)) .OR. (Y.LT.MINI(2)) .OR.
     +          (X.GT.MAXI(1)) .OR. (Y.GT.MAXI(2))) THEN
               B(INDX) = ZNULL
               GOTO 500
            ENDIF
C      
C  move to pixel space
            XT = ( (X-START(1)) * XST ) + 1.D0         !also adjust 0,0 to 1,1
            YT = ( (Y-START(2)) * YST ) + 1.D0
C
C  interpolate...
            KX = INT(XT)
            KY = INT(YT)
            XFRAC = XT - KX
            YFRAC = YT - KY
            KSTX = XDIMA * (KY-1)          !get 1. pixel in this line - 1
            NO1 = KX + KSTX       !get pixel close to int. part of real B(INDX)
C      
            NO2 = NO1 + 1                  !get next pixel in x-direction
            IF (NO2-KSTX.GT.XDIMA) THEN    !are we out of grid in x?
               IF (NO2.GT.SIZEA) THEN      !also out in y?
                  B(INDX) = A(NO1)         !yes.
               ELSE
                  NO3 = NO1 + XDIMA        !no.
                  B(INDX) = A(NO1)*(1.D0-YFRAC) + A(NO3)*YFRAC
               ENDIF
               GOTO 500
            ENDIF
C            
            NO3 = NO1 + XDIMA               !get low pixel in next line up
            IF (NO3.GT.SIZEA) THEN          !are we out of grid in y?
               B(INDX) = A(NO1)*(1.D0-XFRAC) + A(NO2)*XFRAC
               GOTO 500
            ENDIF
C      
            NO4 = NO3 + 1
            B(INDX) =   ( A(NO1)*(1.D0-XFRAC) + A(NO2)*XFRAC ) 
     +                  * (1.D0-YFRAC)
     +                + 
     +                  ( A(NO3)*(1.D0-XFRAC) + A(NO4)*XFRAC ) * YFRAC
CC            B(INDX) = A(NO1) +
CC     +               XFRAC * (A(NO2) - A(NO1)) +
CC     +               YFRAC * (A(NO3) - A(NO1)) +
CC     +               XFRAC * YFRAC * (A(NO1) - A(NO2) - A(NO3) + A(NO4))
 
C      
500         X = X + DX
            Y = Y + DY
1000     CONTINUE
C      
         Y1 = Y1 + STEPB(2)                  !move to next y-coord.
2000  CONTINUE
C      
      RETURN
      END      

C @(#)inters.for	19.1 (ES0-DMD) 02/25/03 13:29:43
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE INTERS(SF,NDIM,NT,NC,NI,IFNM,RMA,NST,FAR,DAT)
C +++
C ---
      IMPLICIT  NONE
      INTEGER   NDIM
      REAL      SF(NDIM,7)
      INTEGER   NT
      INTEGER   NC
      INTEGER   NI
      INTEGER   IFNM
      REAL      RMA
      INTEGER   NST
      REAL      FAR
      REAL      DAT(7,1)
C
      REAL      V(7)
      REAL      DF, DI
      INTEGER   NCS
      INTEGER   I, IFL, IL1, K, LI, J
      REAL      KPRO
      REAL      DX, DY
C
      NCS   = NC
      IFNM  = 1
C
      IF (SF(NI,7).NE.1.AND.SF(NI,7).NE.3) THEN
         DF  = SF(NI,6)+RMA
         I   = SF(NI,1)
         IFL = 0
C
C  20    CONTINUE
         IF (IFL.NE.0 .OR. I.GT.NST) GO TO 10
         I    = I+1
         KPRO = 1
         GO TO 100
C 
   10    CONTINUE
         IF (IFNM.EQ.1) THEN
            IFL = 0
            I   = SF(NI,1)
            CONTINUE
            IF (IFL.NE.0 .OR. I.LE.2) THEN
               RETURN
            ENDIF
            I    = I-1
            KPRO = 2
            GO TO 100
         END IF
      ENDIF
      RETURN
C
C ***
  100 CONTINUE
      IL1 = 0
      K   = 0
   50 CONTINUE
         IF (IL1.NE.0 .OR. K.GE.NC-1) GO TO 60
         K = K+1
         IF (SF(K,1).EQ.I) IL1=1
      GO TO 50
C
   60 CONTINUE
      IF (IL1.EQ.0) THEN
         DO 61 LI=2,7
            V(LI)=DAT(LI,I)
   61    CONTINUE
C
         IF (V(7).NE.2.AND.V(7).NE.1) THEN
            IF (V(4).GT.0..AND.V(6).GT.0.) THEN
               DY = ABS(SF(NI,3)-V(3))
               IF (DY.LE.DF) THEN
                  DX = ABS(SF(NI,2)-V(2))
                  IF (DX.LE.DF) THEN
                     DI = SQRT(DX**2+DY**2)/FAR
                     IF (DI.LT.SF(NI,6)+V(6)) THEN
                        IF (NC-1.LT.NT) THEN
                           DO 62 J=2,7
                              SF(NC,J)=V(J)
   62                      CONTINUE
                           SF(NC,1) = I
                           NC       = NC+1
                        ELSE
                           NC   = NCS
                           IFL  = 1
                           IFNM = 0
                        END IF
                     END IF
                  END IF

               ELSE
                  IFL = 1
               END IF
            END IF
         END IF
      END IF
C
      IF (KPRO.EQ.1) THEN
         IF (IFL.NE.0 .OR. I.GT.NST) GO TO 11
         I    = I+1
         KPRO = 1
         GO TO 100
C
   11    CONTINUE
         IF (IFNM.EQ.1) THEN
            IFL = 0
            I   = SF(NI,1)
            CONTINUE
            IF (IFL.NE.0 .OR. I.LE.2) THEN
               RETURN
            ENDIF
            I    = I-1
            KPRO = 2
            GO TO 100
         END IF
         RETURN

      ELSE
         IF (IFL.NE.0 .OR. I.LE.2) THEN
            RETURN
         ENDIF
         I    = I-1
         KPRO = 2
         GO TO 100
      ENDIF
C
      END

C @(#)plflux.for	19.1 (ES0-DMD) 02/25/03 13:19:39
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION: PLFLUX
C.PURPOSE: Trace d'une courbe XMES(IPL)=FONC(XECH(IPL)) en coordonees 
C          rectangulaires.
C.AUTHOR:
C.VERSION: 790319 C.O. creation
C.VERSION: 830128 L.L. adjusted to RSX
C.VERSION: 880904 RHW  rewritten and adjusted for portable MIDAS
C.VERSION: 910115 RHW IMPLICIT NONE added
C ------------------------------------------------------------------------
      SUBROUTINE PLFLUX(NO,XECH,XMES,NPOINT,
     2                  RADIUS,FOND,XOUT,YOUT,IST)
      IMPLICIT      NONE
C
      INTEGER       NO
      INTEGER       NPOINT
      REAL          XECH(NPOINT)
      REAL          XMES(NPOINT)
      REAL          RADIUS
      REAL          FOND
      REAL          XOUT
      REAL          YOUT
      INTEGER       IST
C
      INTEGER       L, IPL
      INTEGER       IAC
      INTEGER       MADRID(1)
      INTEGER       LTYPE3,LTYPE1
C
      REAL          DXP
      REAL          FRAME(8)
      REAL          XPOS(2),YPOS(2)
      REAL          YPW, XPW
      REAL          XTEXT, YTEXT
      CHARACTER*30  IBUFF
C
      INCLUDE       'MID_INCLUDE:PLTDEC.INC/NOLIST'
      COMMON        /VMR/MADRID
C
      DATA          LTYPE1/1/
      DATA          LTYPE3/3/
C
  631 FORMAT(' *** Computed radius:',F7.1)
C
C *** axis plot
      CALL PTKRDR('XWNDL',4,IAC,FRAME)
      CALL PTKRDR('YWNDL',4,IAC,FRAME(5))
      DXP      = FRAME(2)/FLOAT(NPOINT)
      XPOS(1)  = FRAME(1)
      YPOS(1)  = FOND
      XPOS(2)  = FRAME(2)
      YPOS(2)  = FOND
      LTYPE    = LTYPE1
      CALL PTDATA(0,LTYPE,0,XPOS,YPOS,0.0,2)
C
C *** profile plot
      L = 0
      XPOS(1) = XECH(1)*DXP
      YPOS(1) = XMES(1)
      DO 20 IPL = 2,NPOINT
         XPW = XECH(IPL)*DXP
         YPW = XMES(IPL)
         IF (XPW.GE.FRAME(1) .AND. XPW.LE.FRAME(2) .AND.
     2       YPW.GE.FRAME(5) .AND. YPW.LE.FRAME(6)) THEN
            XPOS(2) = XPW
            YPOS(2) = YPW
            LTYPE   = LTYPE1
            CALL PTDATA(0,LTYPE,0,XPOS,YPOS,0.0,2)
            XPOS(1) = XPOS(2)
            YPOS(1) = YPOS(2)
         ELSE
            XPOS(1) = XPW
            YPOS(1) = YPW
         END IF
   20 CONTINUE
C
C *** plot of "computed" radius
      XPOS(1) = RADIUS
      XPOS(2) = RADIUS
      YPOS(1) = FOND - 0.1*(FRAME(6)-FRAME(5))
      YPOS(2) = FOND + 0.1*(FRAME(6)+FRAME(5))
      LTYPE   = LTYPE3
      CALL PTDATA(0,LTYPE,0,XPOS,YPOS,0.0,2)
      WRITE(IBUFF,631) RADIUS
      XTEXT   = XPOS(1)
      YTEXT   = YPOS(2)
      CALL PTTEXT(IBUFF,XTEXT,YTEXT,0.0,1.0,1)
C
      RETURN
      END

C @(#)necconv.for	19.1 (ES0-DMD) 02/25/03 14:20:22
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  21:03 - 3 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: D.PONZ
C
C.IDENTIFICATION
C
C  program ECHCONV2.FOR
C
C.PURPOSE
C
C  Execute the command
C  CONVERT/ECHELLE input output sampling_domain function parms option
C
C  input            - input image with lines corresponding to 
C			echelle orders
C  output           - output image with lines corresponding to 
C			echelle orders
C  sampling_domain  - start,step or filename defining start,step
C  function         - rebinning function
C  params           - define the transformation coeffs (def 0.,1.)
C  option           - rebinning method as PIX (def)
C                                         LIN
C                                         SPG
C.ALGORITHM
C
C  Linear rebinning
C
C.KEYWORDS
C
C  echelle, flux calibration, rebin
C
C.INPUT/OUTPUT
C
C  P1 - P5    contain input parameters
C
C.MODIFS
C 901024, M Peron , remove list_directed internal I/O
C 901217, P.Ballester, Skip bad orders of extracted standard star spectrum
C-----------------------------------------------------------
C
C
      PROGRAM ECHCV2
      IMPLICIT NONE
C
      INTEGER     NFPAR
      PARAMETER   (NFPAR=12)
      INTEGER     MADRID
      INTEGER     NPTOT1(100),NPIX1(2),NPIXR(2),IDUM(2)
      INTEGER     NPTOT2(100),NPIX2(2),NORDER(100)
      INTEGER*8   PNTR1, PNTR2
      INTEGER     IMNO, NA, KUN, KNUL, ISTAT
      INTEGER     INOP, I, J, NAXIS, NFPACT, NN, NDIM 
      INTEGER     II, NPMAX, STATUS,NFUNC, IMNO1, IMR
      DOUBLE PRECISION STEP1(2),START1(2),WSTR1(100)
      DOUBLE PRECISION STEP2(2),START2(2),WSTR2(100)
      REAL        CUTS(4),RMIN,RMAX,RDUM(2)
      DOUBLE PRECISION RPAR(2)
      DOUBLE PRECISION DPARM(NFPAR),FPARM(NFPAR)
      CHARACTER*8  IMAGE1,IMAGE2,METHOD,OPTION
      CHARACTER*64 IMAGER
      CHARACTER*72 IDENT
      CHARACTER*80 CUNIT
      CHARACTER*3  FUN(9)
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON/VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      DATA FUN/'LIN','POL','INV','EXP','DEX','LOG','DLG','IPO','U01'/
C
C ... get into MIDAS
C
      CALL STSPRO('ECHCV2')
C
C ... get input parameters + default
C
      CALL STKRDC('P1',1,1,8,NA,IMAGE1,KUN,KNUL,ISTAT)
      CALL STKRDC('P2',1,1,8,NA,IMAGE2,KUN,KNUL,ISTAT)
      CALL STKRDC('P3',1,1,64,NA,IMAGER,KUN,KNUL,ISTAT)
      CALL STKRDC('P4',1,1,8,NA,METHOD,KUN,KNUL,ISTAT)
      CALL STKRDC('P6',1,1,8,NA,OPTION,KUN,KNUL,ISTAT)
      CALL STKRDD('INPUTD',1,NFPAR,NA,FPARM,KUN,KNUL,ISTAT) 
      INOP   = 4
      IF (OPTION(1:3).EQ.'PIX') INOP   = 1
      IF (OPTION(1:3).EQ.'LIN') INOP   = 2
      IF (OPTION(1:3).EQ.'SPG') INOP   = 3
C
C ... translate FUNCTION into function number
C
      NFUNC  = 0
      DO 10 I = 1,9
          IF (METHOD(1:3).EQ.FUN(I)) NFUNC  = I
   10 CONTINUE
      IF (NFUNC.EQ.0) THEN
          CALL STTPUT(' Specified function non-existent...',ISTAT)
          GO TO 50
      END IF
C
C ... search for number of active parameters and DOUBLE
C
      DO 20 J = NFPAR,1,-1
          NFPACT = J
          IF (FPARM(J).NE.0.0D0) GO TO 30
   20 CONTINUE
   30 DO 40 J = 1,NFPACT
          DPARM(J) = FPARM(J)
   40 CONTINUE
C
C
C ... read input image
C
      CALL STIGET(IMAGE1,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     .     2,NAXIS,NPIX1,START1,STEP1,IDENT,CUNIT,
     .     PNTR1,IMNO1,ISTAT)
      IF (NAXIS.GT.1 .AND. NPIX1(2).GT.1) THEN
CCCCCCCCCCCCC          CALL SXDFND(IMAGE1,'WSTART',TYPE,NO,NB,ISTAT)
C          IF (TYPE(1:1).EQ.' ') THEN
C              CALL STTPUT(' Wrong input image ',ISTAT)
C              GO TO 50
C          END IF
          CALL STDRDD(IMNO1,'WSTART',1,NPIX1(2),NN,WSTR1,
     .                KUN,KNUL,ISTAT)
          CALL STDRDI(IMNO1,'NPTOT',1,NPIX1(2),NN,NPTOT1,
     .                KUN,KNUL,ISTAT)
          NDIM   = 2
      ELSE
          NPIX1(2) = 1
          NDIM   = 1
          NPTOT1(1) = NPIX1(1)
          WSTR1(1) = START1(1)
      END IF
      START2(1) = START1(1)
      START2(2) = START1(2)
      STEP2(2) = STEP1(2)
C
C ... find start, step, npix for each order in the output image
C
      II     = INDEX('-+.0123456789',IMAGER(1:1))
      IF (II.EQ.0) THEN
          CALL STFOPN(IMAGER,D_R4_FORMAT,0,F_IMA_TYPE,IMR,ISTAT)
          CALL STDRDI(IMR,'NPIX',1,2,NN,NPIXR,KUN,KNUL,ISTAT)
          IF (NPIXR(2).NE.NPIX1(2)) THEN
              CALL STTPUT(' Error in reference image',ISTAT)
              GO TO 50
          END IF
          CALL STDRDD(IMR,'STEP',1,1,NN,STEP2,KUN,KNUL,ISTAT)
          CALL STDRDD(IMR,'WSTART',1,NPIX1(2),NN,WSTR2,
     .                KUN,KNUL,ISTAT)
          CALL STDRDI(IMR,'NPTOT',1,NPIX1(2),NN,NPTOT2,
     .                KUN,KNUL,ISTAT)
          CALL STDRDI(IMR,'NORDER',1,NPIX1(2),NN,NORDER,
     .                KUN,KNUL,ISTAT)
          NPMAX  = NPIXR(1)
      ELSE
          CALL GENCNV(IMAGER,4,2,IDUM,RDUM,RPAR,ISTAT)
          CALL OUTIMA(NPIX1(2),STEP1,WSTR1,NPTOT1,RPAR(1),RPAR(2),
     +            START2,STEP2,WSTR2,NPTOT2,NPMAX)
      END IF
C
C ... map output image
C
      NPIX2(1) = NPMAX
      NPIX2(2) = NPIX1(2)
      CALL STIPUT(IMAGE2,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,NDIM,
     .            NPIX2,START2,STEP2,IDENT,CUNIT,
     +            PNTR2,IMNO,STATUS)
C
C ... rebin image
C
      CALL APPREB(MADRID(PNTR1),NPIX1(1),NPIX1(2),STEP1,WSTR1,NPTOT1,
     +            MADRID(PNTR2),NPIX2(1),NPIX2(2),STEP2,WSTR2,NPTOT2,
     +            NFUNC,NFPAR,NFPACT,DPARM,INOP,RMIN,RMAX)
C
C ... write non standard descriptors
C
CCCCCCCCCCCCCCCCC      CALL SXDCOP(IMAGE1,IMAGE2,3,' ',ISTAT)
      CUTS(1) = RMIN
      CUTS(2) = RMAX
      CUTS(3) = RMIN
      CUTS(4) = RMAX
      CALL STDWRR(IMNO,'LHCUTS',CUTS,1,4,KUN,ISTAT)
      IF (NPIX1(2).GT.1) THEN
          CALL STDWRD(IMNO,'WSTART',WSTR2,1,NPIX2(2),KUN,ISTAT)
          CALL STDWRI(IMNO,'NPTOT',NPTOT2,1,NPIX2(2),KUN,ISTAT)
          CALL STDWRI(IMNO,'NORDER',NORDER,1,NPIX2(2),KUN,ISTAT)
      END IF
C
C ... end
C
   50 IF (ISTAT.NE.0) THEN
          CALL STTPUT(' Error in ECHCONV',STATUS)
      END IF
      CALL STSEPI
      END

      SUBROUTINE OUTIMA(NORDER,STEP1,WSTR1,NPTOT1,STARTR,STEPR,
     +                  START2,STEP2,WSTR2,NPTOT2,NPMAX)
C
C FIND SAMPLING DOMAIN IN THE OUTPUT IMAGE BASED ON THE
C REFERENCE START AND STEP VALUES
C
C INPUT ARGUMENTS
C NORDER  NO OF ORDERS
C STEP1   STEP IN INPUT IMAGE
C WSTR1   START IN INPUT IMAGE
C NPTOT1  NO OF PIXELS/ORDER
C STARTR  START USED AS REFERENCE
C STEPR   STEP USED AS REFERENCE
C OUTPUT ARGUMENTS
C START2  START IN OUTPUT IMAGE IF NORDER = 1
C STEP2   STEP IN OUTPUT IMAGE
C WSTR2   START IN OUTPUT IMAGE IF NORDER > 1
C NPTOT2  NO OF PIXELS/ORDER IF NORDER > 1
C NPMAX   MAX(NPTOT)
C
      IMPLICIT NONE
      DOUBLE PRECISION WSTR1(1),WSTR2(1)
      DOUBLE PRECISION STARTR, STEPR, W, STEP1, STEP2, START2
      INTEGER NPTOT1(1),NPTOT2(1)
      INTEGER I, NPMAX, NORDER, NPOS
C
C ... iterate for each order
C
      NPMAX  = 0
      DO 10 I = 1,NORDER
C
C ...     start, end for each order
C
          NPOS      = NINT((WSTR1(I)-STARTR)/STEPR)
          WSTR2(I)  = STARTR + (NPOS+1)*STEPR
          NPOS      = INT((WSTR1(I)+ (NPTOT1(I)-1)*STEP1-STARTR)/STEPR)
          W         = STARTR + (NPOS-1)*STEPR
          NPTOT2(I) = (W-WSTR2(I))/STEPR + 1
          NPMAX     = MAX(NPMAX,NPTOT2(I))
C   TYPE *,WSTR2(I),NPTOT2(I)
   10 CONTINUE
      STEP2  = STEPR
      IF (NORDER.EQ.1) START2 = WSTR2(1)
      RETURN
      END

      SUBROUTINE APPREB(X,NPIX11,NPIX12,STEP1,WSTR1,NPTOT1,
     +                  Y,NPIX21,NPIX22,STEP2,WSTR2,NPTOT2,
     +                  NFUNC,NFPAR,NFPACT,DPARM,INOP,RMIN,RMAX)
C
C REBIN EACH ORDER
C
      IMPLICIT NONE
      INTEGER NPIX11,NPIX12,NPIX21,NPIX22,NPTOT1(1),NPTOT2(1)
      REAL    X(NPIX11,NPIX12)
      REAL    Y(NPIX21,NPIX22)
      DOUBLE PRECISION WSTR1(1),WSTR2(1), STEP1, STEP2, WX
      REAL    RMIN,RMAX,RMIN1,RMAX1
      DOUBLE PRECISION DPARM(1), X0
      INTEGER   MADRID, NI, NI1, IS
      INTEGER*8 IP1, IP2, IP3
      INTEGER   NO, NO1
      INTEGER*8 JP1, JP2
      INTEGER   I, N1, N2, NINT, NP1, NFUNC,NFPAR
      INTEGER   NFPACT, INOP, J1, J2, J
C
      COMMON/VMR/MADRID(1)
C
C ALLOCATE WORK SPACE
C
      NI     = NPIX11
      NI1    = 8*NI
      CALL TDMGET(NI1,IP1,IS)
      CALL TDMGET(NI1,IP2,IS)
      CALL TDMGET(NI1,IP3,IS)
      NO     = NPIX21
      NO1    = 8*NO
      CALL TDMGET(NO1,JP1,IS)
      CALL TDMGET(NO1,JP2,IS)
      RMIN   = 0.
      RMAX   = 0.
      DO 20 I = 1,NPIX12
C
C   INPUT ARRAYS
C
          X0     = WSTR1(I)
          WX     = STEP1
          N1     = NPTOT1(I)
          CALL IMVAL3(N1,X0,WX,X(1,I),MADRID(IP1),MADRID(IP2),
     +                 MADRID(IP3),NP1)
C
C   OUTPUT ARRAYS
C
          N2     = NPTOT2(I)
          X0     = WSTR2(I)
          WX     = STEP2
          CALL IMVAL2(N2,X0,WX,MADRID(JP1),MADRID(JP2))
C
C         CALL INTERPOLATING (AND INTEGRATING) ROUTINES:
C
C  !!!! Watch out for VECI,VECD arrays in INTERP, 
C	dimension => NINT !!!!!!
C
          NINT   = 8
          CALL REBMET(NP1,MADRID(IP1),MADRID(IP3),MADRID(IP2),N2,
     +                 MADRID(JP1),MADRID(JP2),NFUNC,NFPAR,NFPACT,DPARM,
     +                 INOP,NINT,Y(1,I),RMIN1,RMAX1)
          RMIN   = AMIN1(RMIN1,RMIN)
          RMAX   = AMAX1(RMAX1,RMAX)
          J1     = N2 + 1
          J2     = NPIX21
          DO 10 J = J1,J2
              Y(J,I) = 0.
   10     CONTINUE
   20 CONTINUE
C
C  FREE MEMORY
C
      CALL TDMFRE(NI1,IP1,IS)
      CALL TDMFRE(NI1,IP2,IS)
      CALL TDMFRE(NI1,IP3,IS)
      CALL TDMFRE(NO1,JP1,IS)
      CALL TDMFRE(NO1,JP2,IS)
      RETURN
      END

      SUBROUTINE IMVAL2(NP,XS,WS,X,W)
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C  Subroutine IMVAL2
C
C
C  Fill arrays X,W for image world coordinates and pixel size data
C
      IMPLICIT NONE
      INTEGER  I, NP
      DOUBLE PRECISION X(NP),W(NP),WSS,XSS
      DOUBLE PRECISION WS, XS
C
      WSS    = WS
      XSS    = XS
      DO 10 I = 1,NP
          X(I)   = XSS + WSS* (I-1)
          W(I)   = WSS
   10 CONTINUE
      RETURN
      END

      SUBROUTINE IMVAL3(NP,XS,WS,YY,X,W,Y,NP1)
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C  Subroutine IMVAL3
C
C
C  Fill arrays X,W for image world coordinates and pixel size data
C  Convert YY(real*4) into Y(real*8)
C
      IMPLICIT NONE
      INTEGER  NP
      DOUBLE PRECISION X(NP),W(NP),Y(NP),WSS,XSS
      DOUBLE PRECISION WS, XS
      REAL YY(NP)
      INTEGER NP1, I
C
      NP1    = 0
      WSS    = WS
      XSS    = XS
      DO 10 I = 1,NP
           IF (YY(I).GE.0.0) THEN         ! Modif. 901217 P.B (old .GT.)
              NP1    = NP1 + 1
              X(NP1) = XSS + WSS* (I-1)
              W(NP1) = WSS
              IF (YY(I).GT.1.E30) THEN
                 Y(NP1) = 0.D0
              ELSE 
                 Y(NP1) = YY(I)
              ENDIF
           END IF
   10 CONTINUE
      RETURN
      END

C @(#)tdregr.for	19.1 (ES0-DMD) 02/25/03 14:11:19
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  18:24 - 11 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION        TDREGR.FOR
C.KEYWORDS           TABLE, APPLICATIONS
C.ENVIRONMENT  MIDAS
C.PURPOSE
C LINEAR REGRESSION
C.ALGORITHM
C
C HOUSEHOLDER TRANSFORMATION
C REF.: CH.L.LAWSON AND R.J.HANSON
C       SOLVING LEAST SQUARES PROBLEMS
C       PRENTICE HALL INC. 1974
C
C
C------------------------------------------------------------------

      SUBROUTINE TDSET1(LL,X1,Y,NIND,G,X,N,M)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.PURPOSE
C
C PREPARE DATA IN WORK SPACE FOR MULTIPLE LINEAL REGRESSION
C
C------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER LL
      INTEGER NIND
      DOUBLE PRECISION X1(NIND)
      DOUBLE PRECISION Y
      INTEGER N
      INTEGER M
      DOUBLE PRECISION G(M,M)
      DOUBLE PRECISION X(M)
C
      INTEGER IP,L1

      IP     = 1
      G(LL,IP) = 1.D0
      DO 10 L1 = 1,NIND
          IP     = IP + 1
          G(LL,IP) = G(LL,IP-1)*X1(L1)
   10 CONTINUE
      G(LL,N+1) = Y
      RETURN

      END

      SUBROUTINE TDSET2(LL,X1,X2,Y,K,L,G,X,N,M)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.PURPOSE
C
C PREPARE DATA IN WORK SPACE FOR 1 OR 2D POLYNOMIAL
C
C------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER LL
      DOUBLE PRECISION X1
      DOUBLE PRECISION X2
      DOUBLE PRECISION Y
      INTEGER K
      INTEGER L
      INTEGER N
      INTEGER M
      DOUBLE PRECISION G(M,M)
      DOUBLE PRECISION X(M)
C
      INTEGER IP,L1,K1
      DOUBLE PRECISION DC

      IP     = 0
      DC     = 1.D0
      DO 20 L1 = 0,L
          IP     = IP + 1
          G(LL,IP) = DC
          DO 10 K1 = 1,K
              IP     = IP + 1
              G(LL,IP) = G(LL,IP-1)*X1
   10     CONTINUE
          DC     = DC*X2
   20 CONTINUE
      G(LL,N+1) = Y
      RETURN

      END

      SUBROUTINE TDHHTR(K,L1,G,X,N,M)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.PURPOSE
C
C     Apply a Householder transformation to the two rows K and L1 of G.
C
C------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER K
      INTEGER L1  !   IN : RANK OF THE MATRIX
      INTEGER N
      INTEGER M
      DOUBLE PRECISION G(M,M)
      DOUBLE PRECISION X(M)
C
      INTEGER KH,J
      DOUBLE PRECISION S,H,B
C
C ... CONSTRUCT THE TRANSFORMATION
C
      S      = DSQRT(G(K,K)**2+G(L1,K)**2)
      IF (G(K,K).GE.0.D0) S      = -S
      H      = G(K,K) - S
      G(K,K) = S
      B      = G(K,K)*H
C
C ... APPLY THE TRANSFORMATION TO THE ROWS K AND L1 OF G.
C
      KH     = N + 1 - K
      IF ((KH.NE.0) .AND. (B.NE.0.D0)) THEN
          DO 10 J = 1,KH
              S      = (G(K,K+J)*H+G(L1,K+J)*G(L1,K))/B
              G(K,K+J) = G(K,K+J) + S*H
              G(L1,K+J) = G(L1,K+J) + S*G(L1,K)
   10     CONTINUE
      END IF

      RETURN

      END

      SUBROUTINE TDSOLV(G,X,N,M)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.PURPOSE
C
C
C                Solve the set of linear equations which are
C                represented by the upper triangular part
C                of the matrix G(1:n,1:n+1).
C
C------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER N
      INTEGER M
      DOUBLE PRECISION G(M,M)  
      DOUBLE PRECISION X(M)
C
      INTEGER I,II,J
      DOUBLE PRECISION S
C
      DO 10 I = 1,N
          X(I)   = G(I,N+1)
   10 CONTINUE
      DO 30 II = 1,N
          I      = N - II + 1
          S      = 0.D0
          IF (I.NE.N) THEN
              DO 20 J = 2,N + 1 - I
                  S      = S + G(I,I+J-1)*X(I+J-1)
   20         CONTINUE
          END IF

          X(I)   = (X(I)-S)/G(I,I)
   30 CONTINUE
      RETURN

      END

C @(#)prd.for	19.1 (ES0-DMD) 02/25/03 14:29:02
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
CC
CC  *RANGS* : SORTS A VECTOR OF LENGTH 'NCAS'.
CC
      SUBROUTINE RANGS(AM,LAME)

C       INCLUDE 'MID_REL_INCL:implicit.inc'
C      DIMENSION JLV(30),JRV(30),AM(LAME)

      INTEGER J,JNC,JNDL,JR,JSS,JTWE,LAME
      REAL AMM,XX

      INTEGER JLV(30),JRV(30)
      REAL AM(LAME)

      JSS=1
      JLV(1)=1
      JRV(1)=LAME
  10  JNDL=JLV(JSS)
      JR=JRV(JSS)
      JSS=JSS-1
  20  JNC=JNDL
      J=JR
      JTWE=(JNDL+JR)/2
      XX=AM(JTWE)
  30  IF(AM(JNC).GE.XX)GOTO 40
      JNC=JNC+1
      GOTO 30
  40  IF(XX.GE.AM(J))GOTO 50
      J=J-1
      GOTO 40
  50  IF(JNC.GT.J)GOTO 60
      AMM=AM(JNC)
      AM(JNC)=AM(J)
      AM(J)=AMM
      JNC=JNC+1
      J=J-1
  60  IF (JNC.LE.J) GOTO 30
      IF ((J-JNDL).LT.(JR-JNC)) GOTO 80
      IF (JNDL.GE.J) GOTO 70
      JSS=JSS+1
      JLV(JSS)=JNDL
      JRV(JSS)=J
  70  JNDL=JNC
      GOTO 100
  80  IF (JNC.GE.JR) GOTO 90
      JSS=JSS+1
      JLV(JSS)=JNC
      JRV(JSS)=JR
  90  JR=J
  100 IF (JNDL.LT.JR) GOTO 20
      IF (JSS.NE.0) GOTO 10
      RETURN
      END
CC
CC  *RDUAL* : CALCULATES THE RESIDUALS OF ALL CASES
CC
       SUBROUTINE RDUAL(AA,JKEUS,JDA,NCAS,NVAR,JCST,JPRT,NVAD,LUB,PREC,
     1 JREG,X,Y,RESDU,WEIGHTS,XMED,XMAD,NZWE,AVW,JPLT,AW,NMVAL,
     1 NDXX,NDXY,JHEAD,LAB)

C       INCLUDE 'MID_REL_INCL:implicit.inc'

C       DIMENSION AA(JDA),X(NDXX,NDXY),Y(NDXY),RESDU(NDXY),WEIGHTS(NDXY)
C       DIMENSION XMED(NDXX),XMAD(NDXX),AW(NDXY),NMVAL(NDXY)
       INTEGER J,JCST,JDA,JKEUS,JNC,JPL2,JPLT,JPRT,JREG
       INTEGER NCAS,NDXX,NDXY,NVAD,NVAR,NZWE,LUB
       REAL AL,AVW,BBB,PREC,YJ
 
       REAL AA(JDA),X(NDXX,NDXY),Y(NDXY),RESDU(NDXY),WEIGHTS(NDXY)
       REAL XMED(NDXX),XMAD(NDXX),AW(NDXY)
       INTEGER NMVAL(NDXY)


       CHARACTER*10 LAB(NDXX)
       CHARACTER*60 JHEAD
       JPL2=1
       AL=NCAS
       IF(JPRT.EQ.0) GOTO 10
       IF (NVAR.EQ.1.AND.JCST.EQ.1) THEN
          IF (JKEUS.NE.2) WRITE(LUB,8000) LAB(NVAD)
          IF (JKEUS.EQ.2) WRITE(LUB,8010) LAB(NVAD)
                                    ELSE
          IF (JKEUS.NE.2) WRITE(LUB,8020) LAB(NVAD),LAB(NVAD)
          IF (JKEUS.EQ.2) WRITE(LUB,8030) LAB(NVAD),LAB(NVAD)
       ENDIF
 10    DO 20 JNC=1,NCAS
       IF (.NOT.(NVAR.EQ.1.AND.JCST.EQ.1)) GOTO 40
       BBB=Y(JNC)-AA(1)
       GOTO 60
 40    AW(JNC)=0.0
       DO 30 J=1,NVAR
 30    AW(JNC)=AW(JNC)+AA(J)*(X(J,JNC)*XMAD(J)+XMED(J))
       YJ=Y(JNC)*XMAD(NVAD)+XMED(NVAD)
       BBB=YJ-AW(JNC)
 60    IF (AA(NVAD).GT.PREC) GOTO 70
       IF (ABS(BBB).LT.PREC) BBB=0.0
       RESDU(JNC)=BBB
       GOTO 50
 70    RESDU(JNC)=BBB/AA(NVAD)
 50    IF (JPRT.EQ.0) GOTO 20
       IF (NVAR.EQ.1.AND.JCST.EQ.1) GOTO 80
       IF (AA(NVAD).GT.PREC.AND.JKEUS.NE.2)
     1 WRITE(LUB,8040) YJ,AW(JNC),BBB,NMVAL(JNC),RESDU(JNC)
       IF (AA(NVAD).LE.PREC)
     1 WRITE(LUB,8050) YJ,AW(JNC),BBB,NMVAL(JNC)
       IF (AA(NVAD).GT.PREC.AND.JKEUS.EQ.2)
     1 WRITE(LUB,8040) YJ,AW(JNC),BBB,NMVAL(JNC),RESDU(JNC),
     1 WEIGHTS(JNC)
       GOTO 20
 80    IF (JKEUS.NE.2) WRITE(LUB,8060) Y(JNC),BBB,JNC,RESDU(JNC)
       IF (JKEUS.EQ.2) WRITE(LUB,8060) Y(JNC),BBB,JNC,RESDU(JNC),
     1 WEIGHTS(JNC)
 20    CONTINUE
       IF(JPLT.LT.1) GOTO 90
       IF (AA(NVAD).LE.PREC) JPL2=0
       CALL GRAF(AW,RESDU,NCAS,0,JPL2,JPLT,NMVAL,NDXY,LUB,JREG,
     1 JHEAD,NDXX,NVAD,LAB)
       IF (JPLT.LT.3) GOTO 90
       JPLT=2
       CALL GRAF(AW,RESDU,NCAS,0,JPL2,JPLT,NMVAL,NDXY,LUB,JREG,
     1 JHEAD,NDXX,NVAD,LAB)
       JPLT=3
 90    CONTINUE
 8000  FORMAT(//11X,'OBSERVED',12X,'RESIDUAL',
     1 '   NO','  RES/SC'/9X,A10/)
 8010  FORMAT(//11X,'OBSERVED',12X,'RESIDUAL',
     1 '   NO','  RES/SC',' WEIGHT'/9X,A10/)
 8020  FORMAT(//11X,'OBSERVED',11X,'ESTIMATED',12X,'RESIDUAL',
     1 3X,'NO','  RES/SC'/9X,A10,10X,A10/)
 8030  FORMAT(//11X,'OBSERVED',11X,'ESTIMATED',12X,'RESIDUAL',
     1 3X,'NO','  RES/SC',' WEIGHT'/9X,A10,10X,A10/)
 8040  FORMAT(1X,F18.5,2(1X,F19.5),I5,1X,F7.2,F6.1)
 8050  FORMAT(1X,F18.5,2(1X,F19.5),I5,'   *****')
 8060  FORMAT(1X,F18.5,1X,F19.5,I5,1X,F7.2,F6.1)
       RETURN
       END
CC
CC  *SHHLF* : CALCULATES THE LMS IN THE ONE-DIMENSIONAL CASE.
CC
       SUBROUTINE SHHLF(W,NCAS,JQU,SLUTN,BSTD,PREC)

C       INCLUDE 'MID_REL_INCL:implicit.inc'
C       DIMENSION W(NCAS)
       INTEGER JNC,JPK,JQU,JTEL,K,LNK,NCAS
       REAL ABSW,BSTD,PREC,SLUTN,TEL,VERSC

       REAL W(NCAS)

       K=JQU-1
       VERSC=W(K+1)-W(1)
       SLUTN=(W(1)+W(K+1))/2.0
       BSTD=((W(K+1)-W(1))/2.0)
       IF (NCAS.EQ.2) RETURN
       JTEL=1
       LNK=NCAS-K
       DO 10 JNC=2,LNK
       JPK=JNC+K
       ABSW=W(JPK)-W(JNC)
       IF ( ABS(ABSW-VERSC).GT.PREC) GOTO 20
       JTEL=JTEL+1
       SLUTN=SLUTN+(W(JNC)+W(JPK))/2.0
       GOTO 10
 20    IF (ABSW.LT.VERSC) THEN
       VERSC=ABSW
       JTEL=1
       BSTD=((W(JPK)-W(JNC))/2.0)
       SLUTN=(W(JNC)+W(JPK))/2.0
       ENDIF
 10    CONTINUE
       TEL=JTEL
       SLUTN=SLUTN/TEL
       RETURN
       END
CC
CC  *TRC* : RETRANSFORMATION OF THE VARIANCE-COVARIANCE MATRIX
CC
       SUBROUTINE TRC(H,DA,NMXV,NDXX,NDXY,NVAR,JCST,NVSB,NVAD,
     1 XMED,XMAD)

C       INCLUDE 'MID_REL_INCL:implicit.inc'
C       DIMENSION H(NMXV,NDXX),DA(NMXV)
C       DOUBLE PRECISION H,XMP2,HNN
C       DIMENSION XMED(NDXX),XMAD(NDXX)
       INTEGER  J,JCST,JU,K,K2,NDXX,NDXY,NMXV,NVAD,NVAR,NVSB

       REAL DA(NMXV)
       DOUBLE PRECISION H(NMXV,NDXX),XMP2,HNN
       REAL XMED(NDXX),XMAD(NDXX)

       XMP2=DBLE(XMAD(NVAD))*DBLE(XMAD(NVAD))
       IF (JCST.EQ.0) THEN
          DO 10 J=1,NVAR
          DO 20 K=1,J
          H(J,K)=H(J,K)*(XMP2/(DBLE(XMAD(J))*DBLE(XMAD(K))))
 20          CONTINUE
          DA(J)=DSQRT(H(J,J))
 10          CONTINUE
       ELSE
          DO 25 J=1,NVAR
          H(J,NVAD)=H(J,J)
 25          CONTINUE
          DO 30 J=1,NVAR
          DO 40 K=1,J
          H(J,K)=H(J,K)*XMP2/(DBLE(XMAD(J))*DBLE(XMAD(K)))
 40          CONTINUE
          DA(J)=DSQRT(H(J,J))
 30          CONTINUE
          DO 50 K=1,NVSB
          H(NVAR,K)=H(K,NVAR)*XMP2/DBLE(XMAD(K))
          DO 60 K2=1,NVAR
          IF (K.EQ.K2) THEN
            H(NVAR,K)=H(NVAR,K)-DBLE(XMED(K))*XMP2/
     1                      (DBLE(XMAD(K2))*DBLE(XMAD(K)))*H(K2,NVAD)
            GOTO 60
          ENDIF
          IF (K.LT.K2) THEN
               H(NVAR,K)=H(NVAR,K)-(DBLE(XMED(K2))*XMP2)/
     1                      (DBLE(XMAD(K2))*DBLE(XMAD(K)))*H(K,K2)
                        ELSE
               H(NVAR,K)=H(NVAR,K)-DBLE(XMED(K2))*XMP2/
     1                      (DBLE(XMAD(K2))*DBLE(XMAD(K)))*H(K2,K)
          ENDIF
 60          CONTINUE
 50          CONTINUE
          H(NVAR,NVAR)=H(NVAR,NVAD)*XMP2
          DO 70 K=1,NVAR
          H(NVAR,NVAR)=H(NVAR,NVAR)+
     1            (DBLE(XMED(K))*DBLE(XMED(K)))*XMP2/
     1                         (DBLE(XMAD(K))*DBLE(XMAD(K)))*H(K,NVAD)
 70          CONTINUE
          DO 80 K=1,NVAR
          IF (K.NE.NVAR) THEN
             H(NVAR,NVAR)=H(NVAR,NVAR)-2.0D0*XMP2*DBLE(XMED(K))/
     1                                    (DBLE(XMAD(K)))*H(K,NVAR)
                         ELSE
             H(NVAR,NVAR)=H(NVAR,NVAR)-2.0D0*XMP2*DBLE(XMED(K))/
     1                                    (DBLE(XMAD(K)))*H(NVAR,NVAD)
          ENDIF
 80          CONTINUE
          DO 90 J=1,NVSB
          JU=J+1
          DO 90 K=JU,NVAR
          HNN=2.0D0*DBLE(XMED(J))*DBLE(XMED(K))*XMP2
          H(NVAR,NVAR)=H(NVAR,NVAR)+HNN/
     1                              (DBLE(XMAD(J))*DBLE(XMAD(K)))*H(J,K)
 90          CONTINUE
          DA(NVAR)=DSQRT(H(NVAR,NVAR))
       ENDIF
       RETURN
       END
CC
CC  *SCHCV* : PRINTS THE VARIANCE-COVARIANCE MATRIX OF THE
CC            REGRESSION COEFFICIENTS.
CC
       SUBROUTINE SCHCV(NVAR,NDXX,NMXV,H,LUB)

C       INCLUDE 'MID_REL_INCL:implicit.inc'
       INTEGER J,K,NDXX,NMXV,NVAR,LUB

       DOUBLE PRECISION H(NMXV,NDXX)
       WRITE(LUB,9000)
       DO 10 J=1,NVAR
       WRITE(LUB,9010) (H(J,K),K=1,J)
 10    CONTINUE
 9000  FORMAT(//' VARIANCE - COVARIANCE MATRIX = '/)
 9010  FORMAT(5(5X,D10.4))
       RETURN
       END
CC
CC  *RTRAN* : RETRANSFORMATION OF THE REGRESSION COEFFICIENTS.
CC
       SUBROUTINE RTRAN(NVAR,JCST,NVSB,NVAD,NDXX,XMED,XMAD,AA,JAL,FCKW)

C       INCLUDE 'MID_REL_INCL:implicit.inc'
C       DIMENSION AA(JAL),XMED(NDXX),XMAD(NDXX)

       INTEGER J,JAL,JCST,NDXX,NVAD,NVAR,NVSB
       REAL  FCKW

       REAL AA(JAL),XMED(NDXX),XMAD(NDXX)

       IF (NVAR.LE.1) THEN
         AA(1)=AA(1)*XMAD(NVAD)/XMAD(1)
         GOTO 30
       ENDIF
       DO 10 J=1,NVSB
 10    AA(J)=AA(J)*XMAD(NVAD)/XMAD(J)
       IF (JCST.EQ.0) THEN
         AA(NVAR)=AA(NVAR)*XMAD(NVAD)/XMAD(NVAR)
                      ELSE
         AA(NVAR)=AA(NVAR)*XMAD(NVAD)
         DO 20 J=1,NVSB
 20         AA(NVAR)=AA(NVAR)-AA(J)*XMED(J)
         AA(NVAR)=AA(NVAR)+XMED(NVAD)
       ENDIF
 30    FCKW=FCKW*(XMAD(NVAD)*XMAD(NVAD))
       RETURN
       END
CC
CC  *RANPN* : RANDOM NUMBER GENERATOR .
CC
       SUBROUTINE RANPN(NCAS,NVAR,JNDVC,NDXX,JEY,JLP,MAXRP)
C       INCLUDE 'MID_REL_INCL:implicit.inc'
C       DIMENSION JNDVC(NDXX)
       INTEGER J,JEY,JEYQT,JLP,JNC,JNCM,JRAN,MAXRP,NCAS,NDXX,NVAR
       REAL AL,RNULE,RY

       INTEGER JNDVC(NDXX)

CC     WE PROGRAMMED THIS RANDOM NUMBER GENERATOR OURSELVES BECAUSE
CC     WE WANTED IT TO BE MACHINE INDEPENDENT. IT SHOULD RUN ON MOST
CC     COMPUTERS BECAUSE THE LARGEST INTEGER USED IS LESS THAN 2**30.
CC     THE PERIOD IS 2**16=65536, WHICH IS SUFFICIENT FOR THIS
CC     APPLICATION.
       AL=NCAS
       JLP=JLP+1
       IF (JLP.LE.MAXRP) GOTO 10
       RETURN
 10    DO 20 JNC=1,NVAR
 30    JEY=JEY*5761+999
       JEYQT=JEY/65536
       JEY=JEY-JEYQT*65536
       RY=JEY
       RNULE=RY/65536.0
       JRAN=INT(RNULE*AL)+1
       IF (JNC.EQ.1) GOTO 50
       JNCM=JNC-1
       DO 40 J=1,JNCM
       IF (JNDVC(J).EQ.JRAN) GOTO 30
 40    CONTINUE
 50    JNDVC(JNC)=JRAN
 20    CONTINUE
       RETURN
       END
CC
CC  *GENPN* : GENERATES ALL COMBINATIONS OF 'NVAR' INTEGERS
CC            BETWEEN 1 AND 'NCAS', WHERE NVAR IS AT MOST FIVE.
CC
       SUBROUTINE GENPN(NCAS,NVAR,JNDVC,NDXX,JJJ)

C       INCLUDE 'MID_REL_INCL:implicit.inc'
C       DIMENSION JNDVC(NDXX)
       INTEGER J,JJJ,NDXX,NCAS,NVAR
       INTEGER JNDVC(NDXX)

       IF (JJJ.LE.1) THEN
         DO 5 J=1,NVAR
 5         JNDVC(J)=J
           RETURN
       ENDIF
       IF (JNDVC(NVAR).EQ.NCAS) GOTO 10
       JNDVC(NVAR)=JNDVC(NVAR)+1
       RETURN
 10    IF (JNDVC(NVAR-1).EQ.NCAS-1) GOTO 20
       JNDVC(NVAR-1)=JNDVC(NVAR-1)+1
       JNDVC(NVAR)=JNDVC(NVAR-1)+1
       RETURN
 20    IF(JNDVC(NVAR-2).EQ.NCAS-2) GOTO 30
       JNDVC(NVAR-2)=JNDVC(NVAR-2)+1
       JNDVC(NVAR-1)=JNDVC(NVAR-2)+1
       JNDVC(NVAR)=JNDVC(NVAR-1)+1
       RETURN
 30    IF(JNDVC(NVAR-3).EQ.NCAS-3) GOTO 40
       JNDVC(NVAR-3)=JNDVC(NVAR-3)+1
       JNDVC(NVAR-2)=JNDVC(NVAR-3)+1
       JNDVC(NVAR-1)=JNDVC(NVAR-2)+1
       JNDVC(NVAR)=JNDVC(NVAR-1)+1
       RETURN
 40    IF(JNDVC(NVAR-4).EQ.NCAS-4) GOTO 50
       JNDVC(NVAR-4)=JNDVC(NVAR-4)+1
       JNDVC(NVAR-3)=JNDVC(NVAR-4)+1
       JNDVC(NVAR-2)=JNDVC(NVAR-3)+1
       JNDVC(NVAR-1)=JNDVC(NVAR-2)+1
       JNDVC(NVAR)=JNDVC(NVAR-1)+1
       RETURN
 50    IF(JNDVC(NVAR-5).EQ.NCAS-5) RETURN
       JNDVC(NVAR-5)=JNDVC(NVAR-5)+1
       JNDVC(NVAR-4)=JNDVC(NVAR-5)+1
       JNDVC(NVAR-3)=JNDVC(NVAR-4)+1
       JNDVC(NVAR-2)=JNDVC(NVAR-3)+1
       JNDVC(NVAR-1)=JNDVC(NVAR-2)+1
       JNDVC(NVAR)=JNDVC(NVAR-1)+1
       RETURN
       END
CC
CC  *EQUAT* : SOLVES A SYSTEM OF LINEAR EQUATIONS.
CC
      SUBROUTINE EQUAT(AM,NMXV,NDXX,HVEC,JDMB,NA,NB,NERR,DTEM)

C       INCLUDE 'MID_REL_INCL:implicit.inc'
C      DIMENSION HVEC(JDMB),AM(NMXV,NDXX)
C      DOUBLE PRECISION HVEC,TURN,SWAP,DTEM,DETER
      INTEGER J,JBEGC,JBEGX,JDEL,JENDC,JENDX,JDM,JDMB,JHFD
      INTEGER JMAT,JNC,JNCB,JNCC,JNCD,JNCE,JNCF,JNK,JROW
      INTEGER LCLPL,LDEL,N,NA,NB,NC,NDXX,NEQA,NERR,NMXV,NZNDE

      REAL AM(NMXV,NDXX)
      DOUBLE PRECISION HVEC(JDMB),TURN,SWAP,DTEM,DETER

      JDM=NMXV
      DETER=1.0
      N=NA
      JMAT=N+NB
      JNK=0
      DO 10 J=1,JMAT
      JNK=(J-1)*NMXV
      DO 10 NC=1,NMXV
      JNK=JNK+1
      HVEC(JNK)=AM(NC,J)
 10   CONTINUE
      NZNDE=N-1
      LCLPL=-JDM
      DO 120 JHFD=1,N
      TURN=0.
      LCLPL=LCLPL+JDM+1
      JDEL=LCLPL+N-JHFD
      DO 40 JNCB=LCLPL,JDEL
      IF(DABS(HVEC(JNCB))-DABS(TURN)) 40,40,30
 30   TURN=HVEC(JNCB)
      LDEL=JNCB
 40   CONTINUE
      IF(TURN) 50,170,50
 50   IF(LDEL-LCLPL) 60,80,60
 60   DETER=-DETER
      LDEL=LDEL-JDM
      JNCB=LCLPL-JDM
      DO 70 JNCC=JHFD,JMAT
      LDEL=LDEL+JDM
      JNCB=JNCB+JDM
      SWAP=HVEC(JNCB)
      HVEC(JNCB)=HVEC(LDEL)
 70   HVEC(LDEL)=SWAP
 80   DETER=DETER*TURN
      IF (JHFD.EQ.N)  GOTO 120
      TURN=1./TURN
      JNCB=LCLPL+1
      DO 90 JNCC=JNCB,JDEL
 90   HVEC(JNCC)=HVEC(JNCC)*TURN
      JNCD=LCLPL
      JROW=JHFD+1
      DO 110 JNCB=JROW,N
      JNCD=JNCD+1
      JNCE=LCLPL
      JNCF=JNCD
      DO 100 JNCC=JROW,JMAT
      JNCE=JNCE+JDM
      JNCF=JNCF+JDM
 100  HVEC(JNCF)=HVEC(JNCF)-HVEC(JNCE)*HVEC(JNCD)
 110  CONTINUE
 120  CONTINUE
      DTEM=DETER
      NERR=0
      NEQA=N+1
      JBEGX=NZNDE*JDM+1
      DO 150 JNC=NEQA,JMAT
      JBEGX=JBEGX+JDM
      JENDX=JBEGX+N
      JBEGC=N*JDM+1
      JENDC=JBEGC+NZNDE
      DO 140 JNCB=1,NZNDE
      JENDX=JENDX-1
      JBEGC=JBEGC-JDM
      JENDC=JENDC-JDM-1
      HVEC(JENDX)=HVEC(JENDX)/HVEC(JENDC+1)
      SWAP=HVEC(JENDX)
      JNCD=JBEGX-1
      DO 130 JNCC=JBEGC,JENDC
      JNCD=JNCD+1
 130  HVEC(JNCD)=HVEC(JNCD)-HVEC(JNCC)*SWAP
 140  CONTINUE
      HVEC(JBEGX)=HVEC(JBEGX)/HVEC(1)
 150  CONTINUE
      JNC=-JDM
      JBEGX=NZNDE*JDM+1
      JENDX=JBEGX+NZNDE
      DO 160 JNCB=NEQA,JMAT
      JBEGX=JBEGX+JDM
      JENDX=JENDX+JDM
      JNC=JNC+JDM
      JNCD=JNC
      DO 160 JNCC=JBEGX,JENDX
      JNCD=JNCD+1
 160  HVEC(JNCD)=HVEC(JNCC)
      GOTO 180
 170  NERR=-1
      DTEM=DETER
 180  JNK=0
      DO 190 J=1,JMAT
      DO 190 NC=1,NMXV
      JNK=JNK+1
      AM(NC,J)=HVEC(JNK)
 190  CONTINUE
      RETURN
      END

C @(#)qkdin.for	19.1 (ES0-DMD) 02/25/03 13:23:05
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C @(#)qkdin.for	19.1 (ESO-SDAG) 02/25/03 13:23:05
c----------------------------------------------------------------------
      SUBROUTINE QKDIN(A,N) 
c----------------------------------------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z), INTEGER*4 (I-N)
      DIMENSION A(9,9)

      DO 1 I=1,N
         X=A(I,I)
         A(I,I) = 1.0D0
         DO 2 J=1,N
 2          A(I,J)=A(I,J)/X 
         DO 1 K=1,N
            IF (K-I) 3,1,3

 3          X=A(K,I)
            A(K,I)=0.0D0
            DO 4 J=1,N
 4             A(K,J)=A(K,J)-X*A(I,J)

 1    CONTINUE         
      RETURN
      END 

C @(#)esodstarx.for	19.1 (ES0-DMD) 02/25/03 13:29:08
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
         PROGRAM ESODSTX
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT (c)
C.IDENT         esodstarx.for
C.MODULE
C.AUTHOR        Andrew T. Young
C.KEYWORD
C.LANGUAGE      FORTRAN 77
C.PURPOSE       convert La Silla photometric data files to uniform ascii
C.COMMENTS
C.VERSION       5.2
C.RETURNS
C.ENVIRONMENT
C.
C-----------------------------------------------------------------------------
C*****************************************************************************
C
C       This program reads data recorded in intermixed formats and combines
C       them into a uniform format, in the file 'sdata.dat' that is converted
C       into a MIDAS table-format file, using the *.fmt file 'sdata.fmt'.
C
C       The version you see here is designed to convert data from the ESO
C       1-meter telescope, as described in "The Optical Photometer on the
C       ESO 1m Telescope" by H. Lindgren & F. Gutierrez W. (ESO Operating
C       Manual No. 14, Version No.1, August 1991).  These data come in
C       several different card-image formats, flagged by a digit in col.2.
C       These codes are read and decoded at statements 110-190 in the main
C       program.
C
C       This program extracts ONLY the star names and positions from data
C       cards of types 5 and 6.  These are estimates of the observed apparent
C       positions by the telescope-control system, and may be in error by a
C       minute of arc or more.
C
C       The basic method is to load the data as they are read from different
C       types of cards into the COMMON block /OUTC/, which holds
C       character variables.  When enough card images have been read
C       to make a complete observation, the contents of /OUTC/ are written to
C       the uniform-format file 'sdata.dat'; then the common block is cleared
C       to blanks.
C
C       The MIDAS command CREATE/TABLE can then be used, with the *.fmt file
C       supplied, to convert the uniform 'sdata.dat' file to MIDAS table format.
C       This is done in the command CONVERT/PHOT.
C
C       This program is modified from the "esodcon" program, and may contain
C       fossils from it.
C
C
C*****************************************************************************
C
C
        IMPLICIT NONE
C
C  BEGIN Declarations:
C
        DOUBLE PRECISION DJZ, DJZ1
        DOUBLE PRECISION DNULL
        REAL RNULL
        INTEGER INULL
        COMMON /NULLS/ INULL, RNULL, DNULL
C
        LOGICAL MATCH
        LOGICAL EFLAG, UTWRAP, SIDTIM, TIMSEL
        INTEGER NDATA, NOUTP
C
        INTEGER MXLINE
        PARAMETER (MXLINE=100)
        CHARACTER*80 LINE(MXLINE), DATFIL
        COMMON /LINES/LINE
        INTEGER LENBUF,NOW
        COMMON /BUF/LENBUF, NOW
C
        CHARACTER A*1
        CHARACTER*32 COM1
        CHARACTER*3 MON
C
        INTEGER NLINE,I,I1,I2,M,NTYPE,NSTSK
C
        REAL UT,UT1,UT2,OLDUT,DAY,YEAR
        REAL EQUINOX
C
C    Types for external fcns.:
C
        REAL TIMER
        INTEGER MON2M
C
C    Declarations for the output (must be in WRITER too!):
C
        CHARACTER OBJECT*32
        CHARACTER*10 RASTR, DESTR
        COMMON /OUTC/ OBJECT,RASTR,DESTR
C
C  Set up MIDAS declarations:
C
        INTEGER MADRID(1)
C
        COMMON /VMR/ MADRID
C
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
        INTEGER NACTEL,IUNIT,NULLS,ISTAT
C
C  END Declarations.
C
C
C  BEGIN DATA statements:
C
        INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
        DATA NDATA/7/, NOUTP/8/
C
C  END DATA statements.
C
C
C  ********************  PROLOGUE  ********************
C
        CALL STSPRO ('ESODSTX')
C
C       Because the Sun library barfs on -Inf (which is used as NULL
C       by MIDAS), I define my own "NULL" values here as 3.e33:
C
        RNULL=3.E33
        DNULL=3.D33
C
C  Real program begins here:            (use RUN ESODSTX to test in MIDAS)
C
C
        INQUIRE(FILE='sdata.dat',EXIST=EFLAG)
        IF (EFLAG) THEN
                CALL TV('File "sdata.dat" already exists!')
    1           CALL ASK ('Do you want to write over it?? ',A)
                IF (MATCH(A,'Y')) THEN
                        CONTINUE
                ELSE IF (MATCH(A,'N')) THEN
                        CALL STETER(1,
     1                  'Please move "sdata.dat" to a new name.')
                ELSE
                        CALL TV('Please reply "yes" or "no".')
                        GO TO 1
                END IF
         END IF
C               Open the uniform-format ascii file:
        OPEN(NOUTP,FILE='sdata.dat',STATUS='UNKNOWN')
        REWIND NOUTP
C
C
C       clear data storage:
C
        OBJECT=' '
        RASTR=' '
        DESTR=' '
C
C       *** Prepare input buffer ***
C
        CALL TV(' ')
    5   Call STKRDC ('RAWDAT',1,1,80,  NACTEL,DATFIL,IUNIT,NULLS,ISTAT)
C   5   CALL ASKFIL('What is the name of the file of observed data?',
C    1                  DATFIL)
        INQUIRE(FILE=DATFIL,EXIST=EFLAG)
        IF (.NOT.EFLAG) THEN
                CALL TV('No such file exists!')
                CALL TVN('Please try again:')
                GO TO 5
        END IF
        OPEN(NDATA,FILE=DATFIL,STATUS='UNKNOWN')
        REWIND NDATA
        NOW=0
C
C       Read data.  (READER returns negative NLINE at EOF.)
C
        CALL READER(NLINE)
C
C       Initialize times on first read:
C
        UTWRAP=.FALSE.
        SIDTIM=.FALSE.
        TIMSEL=.FALSE.
        DJZ=0.D0
        DJZ1=0.D0
        OLDUT=-1.
        UT1=0.
        UT2=0.
        UT=-1.
C
        DO 10 I=1,LENBUF
            IF (LINE(I)(:2).EQ.' 8') THEN
C               Look for first day of double date:
                IF (DJZ.EQ.0.D0) THEN
                        CALL GETJDC (I,DJZ)
                        IF (DJZ.GT.0.D0) THEN
C                               found date on card.
                                CALL TV('Date found on:')
                                CALL TVN(LINE(I))
                                DJZ1=DJZ
                        END IF
                END IF
C               Look for UT:
                CALL GETUT(I,UT)
C               Look for "Tim.Out":
                IF (LINE(I)(5:11).EQ.'Tim.Out' .AND.
     1              LINE(I)(13:14).EQ.'SI') THEN
                    CALL TV('Using Local Sidereal Time.')
                    SIDTIM=.TRUE.
                    TIMSEL=.TRUE.
                ELSE IF (LINE(I)(5:11).EQ.'Tim.Out' .AND.
     1              LINE(I)(13:14).EQ.'UT') THEN
                    CALL TV('Using Universal Time.')
                    SIDTIM=.FALSE.
                    TIMSEL=.TRUE.
                END IF
            ELSE IF (LINE(I)(:2).EQ.' 7') THEN
                UT=TIMER(LINE(I)(26:33))
C               Look for JD of 0h UT:
                IF (DJZ.EQ.0.D0) THEN
                        READ(LINE(I)(11:19),'(F9.1)') DJZ
                END IF
            END IF
            IF (UT.GE.0.) GO TO 12
   10   CONTINUE
        CALL TV('Can''t find U.T. in first 100 cards.')
C
   12   UT1=UT
        I1=I
        UT=-1.
C
        DO 20 I=I+1,LENBUF
            IF (LINE(I)(:2).EQ.' 8') THEN
C               Look for first day of double date:
                IF (DJZ.EQ.0.D0) THEN
                        CALL GETJDC (I,DJZ)
                        IF (DJZ.GT.0.D0) THEN
C                               found date on card.
                                CALL TV('Date found on:')
                                CALL TVN(LINE(I))
                                DJZ1=DJZ
                        END IF
                END IF
C               Look for UT:
                CALL GETUT(I,UT)
C               Look for "Tim.Out":
                IF (LINE(I)(5:11).EQ.'Tim.Out' .AND.
     1              LINE(I)(13:14).EQ.'SI') THEN
                    CALL TV('Using Local Sidereal Time.')
                    SIDTIM=.TRUE.
                    TIMSEL=.TRUE.
                ELSE IF (LINE(I)(5:11).EQ.'Tim.Out' .AND.
     1              LINE(I)(13:14).EQ.'UT') THEN
                    CALL TV('Using Universal Time.')
                    SIDTIM=.FALSE.
                    TIMSEL=.TRUE.
                END IF
            ELSE IF (LINE(I)(:2).EQ.' 7') THEN
                UT=TIMER(LINE(I)(26:33))
                IF (DJZ.EQ.0.D0) THEN
                        READ(LINE(I)(11:19),'(F9.1)') DJZ
                        IF (UT.LT.UT1) THEN
                                DJZ=DJZ-1.D0
                        END IF
                END IF
            END IF
            IF (UT.GE.0.) GO TO 22
   20   CONTINUE
C
   22   UT2=UT
        I2=I
C
        IF (UT2.GT.UT1) THEN
C               OK.
        ELSE IF (UT1.GT.21. .AND. UT2.LT.UT1+24.+3.) THEN
C               wrap through 0h U.T.; 3-hr. grace period.
                IF (DJZ.EQ.0.D0) UTWRAP=.TRUE.
        ELSE
                CALL TV('Times are out of order!')
                CALL TV(' ')
                IF (I2.GT.I1 .AND. I2.LT.MXLINE)THEN
                    DO 23 I=I1,I2
                        CALL TVN(LINE(I))
   23               CONTINUE
                    CALL TV(' ')
                    CALL STETER(23,'Please fix data.')
                ELSE
                    CALL STETER(23,'Please fix data.')
                END IF
        END IF
C
        IF (DJZ.EQ.0.D0) THEN
C               read on until we find a type 7 card...
                DO 26 I=I,LENBUF
                    IF (LINE(I)(:2).EQ.' 7') THEN
                        UT=TIMER(LINE(I)(26:33))
                        READ(LINE(I)(11:19),'(F9.1)') DJZ
                        IF (UT.LT.UT1) THEN
                                DJZ=DJZ-1.D0
                        END IF
                        GO TO 30
                    END IF
   26           CONTINUE
C
                IF (DJZ.EQ.0.D0) THEN
C                       still not found, so ask for help:
   28                   CALL ASK ('Please supply UT date at start:',
     1                             COM1)
                        CALL MDYC(COM1,MON,DAY,YEAR)
                        M=MON2M(MON)
                        IF (M.EQ.0 .OR. DAY.LT.0. .OR. DAY.GT.32. .OR.
     1                      YEAR.LT.0. .OR. YEAR.GT.2100. .OR.
     2                      (YEAR.GT.99. .AND. YEAR.LT.1900.)) GOTO 28
                        IF (YEAR.LT.50.) THEN
                                 YEAR=YEAR+2000.
                        ELSE
                                YEAR=YEAR+1900.
                        END IF
C                       compute JD of 0h UT:
                        IF (M.GT.2) GOTO 29
                        M=M+12
                        YEAR=YEAR-1.
   29                   DJZ=AINT(365.25*YEAR) + AINT(30.6001*(M+1)) +
     1                       DAY + 1720981.5D0
                        COM1=' '
                END IF
        ELSE
                IF (UTWRAP) DJZ=DJZ-1.D0
        END IF
   30   CONTINUE
C
        IF(.NOT.TIMSEL .AND. NLINE.LT.25) THEN
            DO 33 I=I,25
                IF (LINE(I)(5:11).EQ.'Tim.Out' .AND.
     1              LINE(I)(13:14).EQ.'SI') THEN
                    CALL TV('Using Local Sidereal Time.')
                    SIDTIM=.TRUE.
                    TIMSEL=.TRUE.
                ELSE IF (LINE(I)(5:11).EQ.'Tim.Out' .AND.
     1              LINE(I)(13:14).EQ.'UT') THEN
                    CALL TV('Using Universal Time.')
                    SIDTIM=.FALSE.
                    TIMSEL=.TRUE.
                END IF
   33       CONTINUE
        END IF
C
        IF(.NOT.TIMSEL) THEN
                CALL TV('ASSUMING Universal Time is used...')
                CALL ASK('               IS this correct???',COM1)
                IF (MATCH(COM1,'Y')) THEN
                        TIMSEL=.TRUE.
                ELSE IF (MATCH(COM1,'N'))THEN
                        CALL TV('Assuming Sidereal Time is used.')
                        TIMSEL=.TRUE.
                        SIDTIM=.TRUE.
                END IF
        END IF
C
C       Decide which date to use:
C               use 1st day of double date.
C
C       Now fix up JD zero-point to make EQUINOX:
        EQUINOX=REAL(DJZ-2451545.D0)/365.25 +2000.
        GO TO 111
C
  110   CALL READER(NLINE)
  111   IF (NLINE.GT.0) THEN
                READ (LINE(NLINE)(:2),'(I2)',ERR=199) NTYPE
                IF (NTYPE.LT.0 .OR. NTYPE.GT.9) GOTO 199
                NTYPE=NTYPE+1
                GO TO (115,110,110,110,110,150,160,110,110,110) NTYPE
C                 type: 0   1   2   3   4   5   6   7   8   9
C
C                 Card Type:
C
C                       0: measurement
C
  115           CONTINUE
                READ (LINE(NLINE),116) NSTSK
  116           FORMAT(30X,I4)
                IF (NSTSK.EQ.0) THEN
C                       Star.
                ELSE IF (NSTSK.EQ.1) THEN
C                       Sky.
                ELSE
                        CALL TV('Unexpected value in STAR/SKY column:')
                        CALL TV(LINE(NLINE))
                        CALL STETER(119,'Fix data and try again.')
                END IF
                GO TO 110
C
C                       1: last integration results if MAGtape,All (??)
C
C                       2: (unused)
C
C                       3 or 4: rejects (should never occur!)
C
C                       5: Object identifier
  150           CONTINUE
                READ (LINE(NLINE),'(2X,A32)') OBJECT
                GO TO 110
C
C                       6: Telescope coordinates
  160           CONTINUE
                READ (LINE(NLINE),'(5X,A10,1X,A10)') RASTR, DESTR
                CALL WRITER(EQUINOX)
                GO TO 110
C
C                       7: measurement number, UT, & JD
C
C                       8: Heading or comment
C
C                       9: End of object
C
C                       other: Illegal card.
  199           CONTINUE
                CALL TV('This card is not in standard format:')
                CALL TV(LINE(NLINE))
                CALL TV('Please fix data and try again.')
                CALL STETER(199,'Data not in std. ESO format')
        END IF
C
C       *** fall through at EOF ***
C
        CLOSE(NOUTP)
C
C       Now make format file:
C
        OPEN (NOUTP,FILE='sdata.fmt',STATUS='UNKNOWN')
        REWIND NOUTP
        WRITE(NOUTP,'(A35)')'! Format file for ESO Star Positions'
  200   FORMAT(A39)
        WRITE(NOUTP,200)'DEFINE/FIELD   1  32 C  A32   :OBJECT '
        WRITE(NOUTP,200)'DEFINE/FIELD  33  48 R  R10.5 :RA     '
        WRITE(NOUTP,200)'DEFINE/FIELD  49  64 R  s9.4  :DEC    '
        WRITE(NOUTP,200)'DEFINE/FIELD  65  75 R  F10.3 :EQUINOX'
        WRITE(NOUTP,'(A3)')'END'
        CLOSE(NOUTP)
C
        CALL TV('STARPOS is finished')
C
C
C       End MIDAS:
C
        CALL STSEPI
        END
        SUBROUTINE WRITER(EQUINOX)
C
C       writes output to uniform ascii file 'sdata.dat'
C
C
        IMPLICIT NONE
C
        REAL EQUINOX
C
        DOUBLE PRECISION DNULL
        REAL RNULL
        INTEGER INULL
        COMMON /NULLS/ INULL, RNULL, DNULL
C
        CHARACTER OBJECT*32, C*74
        CHARACTER*10 RASTR, DESTR
        COMMON /OUTC/ OBJECT,RASTR,DESTR
C
C
        WRITE(C,5) OBJECT,RASTR,DESTR,EQUINOX
    5   FORMAT(A32,2A16,F10.3)
C
        WRITE(8,'(A74)') C
C
C       clear data arrays:
C
        OBJECT=' '
        RASTR=' '
        DESTR=' '
C
        RETURN
        END
        SUBROUTINE READER(NLINE)
C
C       Reads data lines, and returns ptr. to one in buffer each time.
C
C *****************************************************************************
C
C       This subroutine uses a circular buffer to read the data, because the
C       ESO data contain codes for "cancel last star" and "cancel last datum".
C
C       The circular buffer is also used here to look ahead, and interpolate
C       times to assign to comments that lack time information.
C
C *****************************************************************************
C
        IMPLICIT NONE
C
        INTEGER NLINE
C
C
        INTEGER MXLINE
        PARAMETER (MXLINE=100)
C
        CHARACTER*80 LINE(MXLINE)
        COMMON /LINES/LINE
        INTEGER LENBUF,NOW
        COMMON /BUF/LENBUF, NOW
C
        INTEGER NEOF
        INTEGER LAST
C
        SAVE NEOF
C
        DATA NEOF/0/
C
C
        IF (NOW.EQ.0) THEN
C
C       *****   initial entry:  *****
C
                NOW=1
    1           READ (7,'(A80)', END=9) LINE(NOW)
C                       Test for backup (bad data):
                IF (LINE(NOW)(:2).EQ.' 4') THEN
C                       Back up over object:
                        DO 4 NOW=NOW-1,1,-1
                        IF (LINE(NOW)(:2).EQ.' 5') GO TO 6
    4                   CONTINUE
                        NOW=0
                ELSE IF (LINE(NOW)(:2).EQ.' 3') THEN
C                       Back up over last filter:
                        IF (LINE(NOW-1)(:2).EQ.' 0') THEN
                                NOW=NOW-2
                        ELSE IF (LINE(NOW-2)(:2).EQ.' 0') THEN
                                NOW=NOW-3
                        ELSE
                                CALL TV('Did not find bad datum:')
                        END IF
                END IF
C
                NOW=NOW+1
C
C               *** test for full buffer ***
C
    6           IF(NOW.GT.MXLINE) THEN
                        LENBUF=MXLINE
                ELSE
                        GO TO 1
                END IF
C
C               *** return from initial entry ***
C
    8           NOW=1
                NLINE=1
                RETURN
C
C               *** EOF found on initial entry ***
C
    9           LENBUF=NOW
                NEOF=LENBUF
                GOTO 8
C
        ELSE
C
C       *****  normal entry (NOW > 0):  *****
C
                LAST=NOW
   10           IF (NEOF.EQ.0) THEN
C                       overwrite last output line:
   11                   READ (7, '(A80)',END=99) LINE(NOW)
C
C                       Test for backup (bad data):
   13                   IF (LINE(NOW)(:2).EQ.' 4') THEN
C                               back up over object:
                                DO 14 NOW=NOW-1,1,-1
                                IF (LINE(NOW)(:2).EQ.' 5') GOTO 10
   14                           CONTINUE
                                DO 15 NOW=LENBUF,LAST+1,-1
                                IF (LINE(NOW)(:2).EQ.' 5') GOTO 10
   15                           CONTINUE
                                CALL TV('Backed up over entire buffer!')
                                CALL STETER(15,
     1                          'Increase MXLINE and recompile')
C
                        ELSE IF (LINE(NOW)(:2).EQ.' 3') THEN
C                               back up over filter:
                                DO 17 NOW=NOW-1,1,-1
                                IF (LINE(NOW)(:2).EQ.' 0') GOTO 10
   17                           CONTINUE
                                DO 18 NOW=LENBUF,LAST+1,-1
                                IF (LINE(NOW)(:2).EQ.' 0') GOTO 10
   18                           CONTINUE
                                CALL TV('Backed up over entire buffer!')
                                CALL STETER(18,
     1                          'Increase MXLINE and recompile')
                        END IF
                END IF
C
   20           IF (NOW.NE.LAST) THEN
C                       Refill buffer, if needed:
                        NOW=NOW+1
                        IF (NOW.GT.LENBUF) NOW=1
                        GO TO 10
                END IF
C
C               Advance line counter:
                IF (NOW.EQ.LENBUF) THEN
                        NOW=1
                ELSE
                        NOW=NOW+1
                END IF
C
                IF (NOW.EQ.NEOF) THEN
C                       Return negative value at eof:
                        NLINE=-NOW
                        RETURN
                ELSE
                        NLINE=NOW
                END IF
C
                RETURN
C
   99           NEOF=NOW
                IF (NEOF.GT.LENBUF) NEOF=1
                GO TO 20
C
        END IF
C
        END

C @(#)sort.for	19.1 (ES0-DMD) 02/25/03 13:23:50
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE  SORTER (WORK, MAXWRK, SORT, HIGH, LOW, INDEX, 
     .     MAXSTR, WATCH)
C
C=======================================================================
C
C Subroutine to read in any of the data files created by DAOPHOT and
C sort the stars according to magnitude, position, ID number,
C or OTHER.
C
C              OFFICIAL DAO VERSION:  1991 April 18
C
C Argument
C
C  WATCH (INPUT) governs whether information relating to the progress 
C        of the reductions is to be typed on the terminal screen
C        during execution.
C
C WATCH is a user-definable optional parameter.
C
C=======================================================================
C
CC    IMPLICIT NONE
C
C Parameters
C
C    MAX is the number of different sorts which are possible
C        (currently 5: by ID number, by X, by Y, by magnitude, and
C         by OTHER [e.g. SHARP, ROUND, CHI, number of iterations]).
C
C MAXSTR is the maximum number of stars permitted in a data file.
C        It is limited by the size of the WORK array in DAOPHOT:
C        WORK must contain 282 bytes per star:  4 bytes each for SORT,
C        INDEX, NLINE1, and, NLINE2, and 133 bytes each for LINE1 and 
C        LINE2.
C
C MAXITM is the maximum number of output data per line of an output.
C        (currently 15, realized in PHOTOMETRY)
C
      INTEGER MAXWRK, MAXSTR, MAXITM
      PARAMETER (MAXITM=30)
C
      REAL DATUM(MAXITM), WORK(MAXWRK), SORT(MAXSTR)
      INTEGER LOW(MAXSTR), HIGH(MAXSTR), INDEX(MAXSTR)
C
      REAL ABS
      INTEGER NINT
C
      CHARACTER*133 TEXT
      CHARACTER*30 FILE, SWITCH
      CHARACTER CASE*4, ANSWER*1
      REAL LOBAD, HIBAD, THRESH, AP1, PHPADU, READNS, FRAD
      REAL WATCH, WHICH, FLIP
      INTEGER I, J, K, L, N, NL, NCOL, NROW, ISTAT, ITEMS, NSTAR
      INTEGER NLO, MODE, AMODE
C
C-----------------------------------------------------------------------
C
C SECTION 1
C
C Get ready.
C
C Find out how the user wants to sort.
C
      WRITE (6,610) MAXITM
  610 FORMAT (//
     .     11X, '   The following sorts are currently possible:'//
     .     11X, '+/- 1  By increasing/decreasing star ID number'//
     .     11X, '+/- 2  By increasing/decreasing  X  coordinate'//
     .     11X, '+/- 3  By increasing/decreasing  Y  coordinate'//
     .     11X, '+/- 4  By increasing/decreasing magnitude'//
     .     11X, '+/- n  By increasing/decreasing OTHER (n <= ',
     .     I2, ')'///)
      CALL GETDAT ('Which do you want?', WHICH, 1)
      IF (WHICH .LT. -1.E38) RETURN                 ! CTRL-Z was entered
C
      MODE=NINT(WHICH)
      AMODE = MODE
      IF (MODE.LT.0) AMODE = -MODE
      IF ((AMODE .LT. 1) .OR. (AMODE .GT. MAXITM))
     .     RETURN                                     ! Invalid response
C
      FLIP=FLOAT(MODE/AMODE)
      MODE=AMODE
C
C Get input file name, open the file, and read its header.
C
      FILE=' '
  950 CALL GETNAM ('Input file name:', FILE)
      IF ((FILE .EQ. 'END OF FILE') .OR. (FILE .EQ. 'GIVE UP')) RETURN
      CALL INFILE (2, FILE, ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error opening input file '//FILE)
         FILE = 'GIVE UP'
         GO TO 950
      END IF
C
C Get output file name and open the file.
C
      FILE = SWITCH(FILE, CASE('.srt'))
  960 CALL GETNAM ('Output file name:', FILE)
      IF ((FILE .EQ. 'END OF FILE') .OR. (FILE .EQ. 'GIVE UP')) THEN
         CALL CLFILE (2)
         RETURN
      END IF
C
      CALL OUTFIL (3, FILE, ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error opening output file '//FILE)
         FILE = 'GIVE UP'
         GO TO 960
      END IF
C
      CALL GETYN ('Do you want the stars renumbered?', ANSWER)
      IF (ANSWER .EQ. 'E') THEN
         CALL CLFILE (2)
      END IF
C
      NL=-1
      CALL RDHEAD (2, NL, NCOL, NROW, LOBAD, HIBAD, THRESH, AP1, 
     .     PHPADU, READNS, FRAD)
      IF (NL .LE. 0) GO TO 1010                     ! No header in input
      IF (NL .GT. 3) NL=1
C
C Copy input file header to output file.  
C
      ITEMS=6
      IF (FRAD .GT. 0.001) ITEMS=7
      CALL WRHEAD (3, NL, NCOL, NROW, ITEMS, LOBAD, HIBAD, THRESH, 
     .     AP1, PHPADU, READNS, FRAD)
C
 1010 CONTINUE
      IF (WATCH .LT. 0.5) GO TO 1020
      IF (MODE .LE. 4) WRITE (6,611)
  611 FORMAT (/22X, 'STAR', 6X, 'X', 8X, 'Y', 4X, 'MAG.(1)')
      IF (MODE .GE. 5) WRITE (6,612) MODE
  612 FORMAT (/17X, 'STAR', 6X, 'X', 8X, 'Y', 4X, 'MAG.(1)',
     .     3X, 'ITEM', I3)
 1020 CONTINUE
C
C-----------------------------------------------------------------------
C
C SECTION 2
C
C Read the input file in line by line, verbatim.  Pack the contents
C of the line into the REAL array WORK, keeping track of the
C lower and upper limits in the arrays LINELO and LINEHI.  At the
C same time, extract the the particular datum 
C according to which we wish to sort.  Sort these data.  Then write 
C the file out again, line by line, verbatim, but in the new order.
C
      I=0
      NLO = 0
C
 2000 CALL RDCHAR (2, TEXT, N, ISTAT)
      IF (ISTAT .EQ. 1) GO TO 2100             ! END OF FILE
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Unable to read input file.')
         CALL CLFILE (2)
         RETURN
      END IF
C
      IF (N .LE. 1) GO TO 2000                 ! Blank line encountered
      READ (TEXT(2:N), 901, IOSTAT=ISTAT) 
     .     (DATUM(J), J=1,(N-5)/9+1)
  901 FORMAT (F5.0, 14F9.0)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Unable to read data from input file.')
         CALL CLFILE (2)
         RETURN
      END IF
C
      I = I+1
      IF (I .GT. MAXSTR) THEN
         WRITE (TEXT,77) I-1
   77    FORMAT (I10, ' stars is all I have room for.  Sorry!')
         CALL STUPID (TEXT(1:50))
         CALL CLFILE (2)
         RETURN
      END IF
      LOW(I) = NLO+1
      HIGH(I) = NLO + (N-2)/4 + 1
      IF (HIGH(I) .GT. MAXWRK) THEN
         WRITE (TEXT,77) I-1
         CALL STUPID (TEXT(1:50))
         CALL CLFILE (2)
         RETURN
      END IF
C
      NLO = HIGH(I)
      READ (TEXT(2:N),66) (WORK(J), J=LOW(I),NLO)
   66 FORMAT (33A4)
C
      IF (NL .EQ. 2) THEN
 2012    CALL RDCHAR (2, TEXT, N, ISTAT)
         IF (ISTAT .NE. 0) THEN
            CALL STUPID ('Unable to read input file.')
            CALL CLFILE (2)
            RETURN
         END IF
C
         IF (N .LE. 1) GO TO 2012
         READ (TEXT(2:N), 902, IOSTAT=ISTAT)
     .        (DATUM(J), J=16,19+(N-25)/9)
  902    FORMAT (F12.3, 2F6.3, 12(F8.3, 1X))
         IF (ISTAT .NE. 0) THEN
            CALL STUPID ('Unable to read data from input file.')
            CALL CLFILE (2)
            RETURN
         END IF
C
         HIGH(I) = HIGH(I) + (N-2)/4+1
         IF (HIGH(I) .GT. MAXWRK) THEN
            WRITE (TEXT,77) I-1
            CALL STUPID (TEXT(1:50))
            CALL CLFILE (2)
            RETURN
         END IF
         READ (TEXT(2:N),66) (WORK(J), J=NLO+1,HIGH(I))
         NLO = HIGH(I)
      END IF
C
      SORT(I)=FLIP*DATUM(MODE)
      GO TO 2000                                     ! End of input loop
C
C Perform the sort.
C
 2100 NSTAR=I                                        ! Number of stars
      CALL CLFILE (2)
      IF (NSTAR .LE. 0) THEN
         CALL STUPID ('No stars in input file.')
         RETURN
      END IF
      CALL QUICK (SORT, NSTAR, INDEX)
C
C The vector SORT is now arranged in order of increasing or decreasing
C whatever, and the vector INDEX now contains the ordinal position in
C the input file of the stars, in order of increasing or decreasing
C whatever.
C
C Now write the data out again.
C
      DO 2110 I=1,NSTAR
      J = INDEX(I)
      IF (NL .NE. 2) THEN
         NLO = HIGH(J) - LOW(J) + 1
         K = 4*NLO+1
         WRITE (TEXT(1:K),67) (WORK(L), L=LOW(J),HIGH(J))
   67    FORMAT (1X, 33A4)
C
C If ID numbers are to be changed, insert the new ID into the text.
C
         IF (ANSWER .EQ. 'Y') WRITE (TEXT(2:6),68) I
   68    FORMAT (I5)
         WRITE (3,320) TEXT(1:K)
  320    FORMAT (A)
         IF (WATCH .LT. 0.5) GO TO 2110
         IF (MODE .LE. 4) THEN
            WRITE (6,620) TEXT(2:33)
  620       FORMAT (21X, A32)
         ELSE
            WRITE (6,621) TEXT(2:33), FLIP*SORT(I)
  621       FORMAT (16X, A32, 1X, F9.3)
         END IF
      ELSE
         NLO = (HIGH(J) - LOW(J) + 1)/2
         K = 4*NLO+1
         WRITE (TEXT(1:K),67) (WORK(L), L=LOW(J),LOW(J)+NLO-1)
         IF (ANSWER .EQ. 'Y') WRITE (TEXT(2:6),68) I
         WRITE (3,320) TEXT(1:K)
         IF (WATCH .GE. 0.5) THEN
            IF (MODE .LE. 4) THEN
               WRITE (6,620) TEXT(2:33)
            ELSE
               WRITE (6,621) TEXT(2:33), FLIP*SORT(I)
            END IF
         END IF
         WRITE (TEXT(1:K),67) (WORK(L), L=LOW(J)+NLO,HIGH(J))
         WRITE (3,320) TEXT(1:K)
         WRITE (3,320) ' '
      END IF
C
 2110 CONTINUE                                      ! End of output loop
C
C-----------------------------------------------------------------------
C
C Normal return.
C
      CALL CLFILE (3)
      RETURN
C
      END!

C===========================================================================
C Copyright (C) 1995-2011 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENT       irskysub.for
C.AUTHOR      E. Oliva,  Firenze-Arcetri
C.KEYWORDS    Spectroscopy, IRSPEC
C
C.PURPOSE     Determine/apply "factor" and "shift" parameters
C             to optimize "obj-sky" operation.
C             
C
C.ALGORITHM   
C
C
C.INPUT/OUTPUT
C
C
C.VERSION     1.0    Creation     02.09.1992   E. Oliva
C.VERSION     1.1    25.10.1993   E. Oliva
C                      START,STEP=1 tests eliminated (were useless and gave
C                      problems with rounding errors).
C 110829	last modif
C 
C-------------------------------------------------------
C
      PROGRAM SKYBUB
      IMPLICIT REAL(A-H,O-Z)
      IMPLICIT INTEGER(I-N)

      CHARACTER*64 CUNIT
      CHARACTER*72 IDENT
      CHARACTER*60 FOBJ,FSKY,FOUT,REFTAB
C 
      INTEGER NPIX(3)
      INTEGER*8 IPNTR,IAP,IBP,ICP
C 
      DOUBLE PRECISION START(3),STEP(3)
C 
      COMMON/PARAM/NX,NY,IAP,IBP,ICP,NWIND,JLIM(400)
      COMMON /VMR/ SS(1)
      COMMON/TALK/JYBAD(1000),NYBAD,STDX(1000),AVEX(1000),THRSX,IDEBUG
C 

      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'

      DATA MAXDIM/2/

      IRET=1
      CALL STSPRO('SKYSUB')
C
C GET INPUT (OBJ-DARK)/FLAT CLEANED FRAME AND MAP IT
C CHECK ALSO WHETHER IT IS A 2D FRAME.....
C
      CALL STKRDC('obj',1,1,60,IRET,FOBJ,KUNIT,KNUL,ISTAT)
      CALL CLNFRA(FOBJ,FOBJ,0)
      CALL STIGET(FOBJ,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,MAXDIM,
     ,            NAXIS,NPIX,START,STEP,
     ,            IDENT,CUNIT,IPNTR,NOBJ,ISTAT)
      IAP=IPNTR
      IF(NAXIS.NE.2) 
     +   CALL STETER(1,'Input frame must be 2-D')
      NX=NPIX(1)
      NY=NPIX(2)
C
C GET INPUT (SKY-DARK)/FLAT FRAME AND MAP IT
C CHECK ALSO WHETHER IT HAS CORRECT NX,NY
C
      CALL STKRDC('sky',1,1,60,IRET,FSKY,KUNIT,KNUL,ISTAT)
      CALL CLNFRA(FSKY,FSKY,0)
      CALL STIGET(FSKY,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,MAXDIM,
     ,            NAXIS,NPIX,START,STEP,
     ,            IDENT,CUNIT,IPNTR,NSKY,ISTAT)
      IBP=IPNTR
      IF(NPIX(1).NE.NX .OR. NPIX(2).NE.NY) 
     +     CALL STETER(1,'Sky frame has different size than object!')
C
C GET OUTPUT FRAME AND MAP IT
C
      CALL STKRDC('out',1,1,60,IRET,FOUT,KUNIT,KNUL,ISTAT)
      CALL CLNFRA(FOUT,FOUT,0)
      CALL STIPUT(FOUT,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     ,            NAXIS,NPIX,START,STEP,
     ,            IDENT,CUNIT,IPNTR,NOUT,ISTAT)
      ICP=IPNTR
C
C Get "force_sky_to_zero" option
C
      CALL STKRDI('sforce',1,1,IRET,ISFORCE,KUNIT,KNUL,ISTAT)
C
C Check whether a sky_table exists
C
      CALL STKRDI('yestab',1,1,IRET,KKTAB,KUNIT,KNUL,ISTAT)
      IF(KKTAB.GT.0) THEN
C
C GET TABLE NAME (WHERE WINDOWS ARE DEFINED)
C AND OPEN IT
C
        CALL STKRDC('reft',1,1,60,IRET,REFTAB,KUNIT,KNUL,ISTAT)
        IOPEN=0
        CALL TBTOPN(REFTAB,IOPEN,IDETAB,ISTAT)
C
C GET # CORRESPONDING TO XSTART,XEND,YSTART,YEND
C
        CALL TBLSER(IDETAB,'XSTART',IX1,ISTAT)
        CALL TBLSER(IDETAB,'YSTART',IY1,ISTAT)
        CALL TBLSER(IDETAB,'XEND',IX2,ISTAT)
        CALL TBLSER(IDETAB,'YEND',IY2,ISTAT)
C
C GET INFORMATION UPON THE TABLE SIZE (N.B. NROW = # OF BAD PIXELS....)
C
        CALL TBIGET(IDETAB,NCOL,NROW,NSORT,NCALL,NRALL,ISTAT)
        NWIND=NROW
C
C COPY TABLE ELEMENTS INTO VECTOR JLIM
C (as xstart(1),xend(1),ystart(1),yend(1) etc..)
C
        J=0
        DO IROW=1,NWIND
          CALL TBERDR(IDETAB,IROW,IX1,VAL,NULL,ISTAT)
          J=J+1
          JLIM(J)=VAL
          CALL TBERDR(IDETAB,IROW,IX2,VAL,NULL,ISTAT)
          J=J+1
          JLIM(J)=VAL
          CALL TBERDR(IDETAB,IROW,IY1,VAL,NULL,ISTAT)
          J=J+1
          JLIM(J)=VAL
          CALL TBERDR(IDETAB,IROW,IY2,VAL,NULL,ISTAT)
          J=J+1
          JLIM(J)=VAL
        ENDDO
        CALL TBTCLO(IDETAB,ISTAT)

      ELSE
C
C In case no table exists
C
        NWIND=0
      ENDIF
C
C Get "MANUAL" values of fac,sh (if fac=0.0 then automatic)
C
      CALL STKRDR('fac',1,1,IRET,FACT,KUNIT,KNUL,ISTAT)
      CALL STKRDR('sh',1,1,IRET,SHIFT,KUNIT,KNUL,ISTAT)
C
C Get debug flag
C
      CALL STKRDI('debug',1,1,IRET,II,KUNIT,KNUL,ISTAT)
      IDEBUG=II
C
C Call routine which does the operations....
C
      CALL MIN_STD(FACT,SHIFT,ISFORCE)
C
C Store best values in keywords
C
      CALL STKWRR('fac',FACT,1,1,KUNIT,ISTAT)
      CALL STKWRR('sh',SHIFT,1,1,KUNIT,ISTAT)
      CALL STDWRR(NOUT,'AB_FACTOR',FACT,1,1,KUNIT,ISTAT)
      CALL STDWRR(NOUT,'AB_SHIFT',SHIFT,1,1,KUNIT,ISTAT)
C
C RELEASE FILES, UPDATE KEYWORDS AND EXIT
C
      CALL STSEPI
      END
C
C
C
      SUBROUTINE MIN_STD(FAC,SH,ISFORCE)
c
c Used to find the values of shift (on image "A") and factor
c (on image "B") which minimizes the
c standard deviation of the pixels within the [x1,x2:y1,y2]
c window(s). It also forces the average pixel
c value in the windows to 0.
c
      IMPLICIT REAL(A-H,O-Z)
      IMPLICIT INTEGER(I-N)
C 
      INTEGER*8 IAP,IBP,ICP
C 
      COMMON/PARAM/NX,NY,IAP,IBP,ICP,NWIND,JLIM(400)
      COMMON/TALK/JYBAD(1000),NYBAD,STDX(1000),AVEX(1000),THRSX,IDEBUG
      DIMENSION F(3)
      CHARACTER*80 OUTPUT
c
c
c NB FACT>0 means that the user entered manual values for fac and sh
c

c
c set first THRSX value
c
      THRSX=2.0
      CALL DIFF_AB(FAC,SH)
      IF(FAC.GT.0.0) THEN
        IF(NWIND.GT.0) CALL SKY_ZERO(ISFORCE)
        RETURN
      ENDIF
      CALL DEF_YBAD
      FAC=1.0
      SH=0.0
      DF=0.1
      DS=0.1
      FMIN=1E30
      NITER=0
10    CONTINUE
      DO I=1,3
        F(I)=FUNCT(FAC+(I-1)*DF,SH)
      ENDDO
      IF(F(1).GT.F(2) .AND. F(2).GT.F(3)) THEN
        FAC=FAC+2.*DF
        GO TO 10
      ENDIF
      IF(F(1).LT.F(2) .AND. F(2).LT.F(3)) THEN
        FAC=FAC-DF
        GO TO 10
      ENDIF
      IF(F(1).EQ.F(2) .AND. F(2).EQ.F(3)) THEN
        FAC=FAC+DF
      ELSE
        FAC=FAC+2*DF-DF*((F(3)-F(2))/(F(3)-2*F(2)+F(1))+0.50)
      ENDIF
11    CONTINUE
      DO I=1,3
        F(I)=FUNCT(FAC,SH+(I-1)*DS)
      ENDDO
      IF(F(1).GT.F(2) .AND. F(2).GT.F(3)) THEN
        SH=SH+2.*DS
        GO TO 11
      ENDIF
      IF(F(1).LT.F(2) .AND. F(2).LT.F(3)) THEN
        SH=SH-DS
        GO TO 11
      ENDIF
      IF(F(1).EQ.F(2) .AND. F(2).EQ.F(3)) THEN
        SH=SH+DS
      ELSE
        SH=SH+2*DS-DS*((F(3)-F(2))/(F(3)-2*F(2)+F(1))+0.50)
      ENDIF
      FNEW=FUNCT(FAC,SH)
      ERR=ABS(FNEW/FMIN-1.)
      IF(IDEBUG.GT.0) THEN
        WRITE(OUTPUT,*) 'FAC,SH,FNEW',FAC,SH,FNEW
        CALL STTPUT(OUTPUT,ISTAT)
      ENDIF
      IF(ERR.GT.1) THEN
        FMIN=FNEW
        NITER=NITER+1
        IF(NITER.GT.30) THEN
          CALL FAILED(1000)
        ELSE
          GO TO 10
        ENDIF
      ENDIF
      IF(ERR.GT.1E-4) THEN
        DF=DF/2.
        DS=DS/2.
        DF=MAX(DF,1E-4)
        DS=MAX(DS,1E-4)
        FMIN=FNEW
        NITER=NITER+1
        IF(NITER.GT.30) THEN
          CALL FAILED(1000)
        ELSE
          GO TO 10
        ENDIF
      ENDIF
      CALL SKY_ZERO(ISFORCE)

      RETURN
      END


      FUNCTION FUNCT(FAC,SH)
      IMPLICIT REAL(A-H,O-Z)
      IMPLICIT INTEGER(I-N)

      CALL DIFF_AB(FAC,SH)
      CALL STD_WIND(AVEW,STDW)
      FUNCT=STDW
      RETURN
      END


      SUBROUTINE DEF_YBAD
c
c Subroutine which selects, whithin each window, the scan-lines
c (Y=const) which are too noisy (e.g. which contain bad pixels).
c The selection criterium is
c   sigma(Y_scanline) > THRSX*aver_sigma(all_Y_scanlines)
c and go on iteratively.
c
c The positions of the bad scan-lines are stored in a rather weird
c form:
c
c    JYBAD = IY+(NW-1)*NY
c
c where 
c  JYBAD is the stored value
c  IY    is the Y coordinate of the bad scan line within the window NW
c  NW    means that we are dealing with the NW-th window
c  NY    is the number of Y pixels in the image
c
      IMPLICIT REAL(A-H,O-Z)
      IMPLICIT INTEGER(I-N)
C 
      INTEGER*8 IAP,IBP,ICP
C
      COMMON/PARAM/NX,NY,IAP,IBP,ICP,NWIND,JLIM(400)
      COMMON/TALK/JYBAD(1000),NYBAD,STDX(1000),AVEX(1000),THRSX,IDEBUG
      COMMON/VMR/SS(1)
      CHARACTER*80 OUTPUT
      CHARACTER*1 C1


      IF(IDEBUG.GT.0) THEN
        CALL STTPUT('DEF_YBAD: defining bad-scan lines',ISTAT)
      ENDIF
      NYBAD=0
10    CONTINUE
      CALL STD_WIND(AVEW,STDW)
      IF(IDEBUG.GT.0) THEN
        WRITE(OUTPUT,*) 
     +   'Entered with AVEW =',AVEW,' STDW =',STDW
        CALL STTPUT(OUTPUT,ISTAT)
      ENDIF
      NBAD=0
      NSL=0
      DO IW=1,NWIND
        IY1=JLIM(3+4*(IW-1))
        IY2=JLIM(4+4*(IW-1))
        DO IY=IY1,IY2
          JYSHIFT=IY+(IW-1)*NY
          NSL=NSL+1
          DIST=STDX(NSL)/STDW
          IF(DIST.GT.THRSX) THEN
            NBAD=NBAD+1
            JYBAD(NBAD)=JYSHIFT
            IF(IDEBUG.GT.1) THEN
              WRITE(OUTPUT,*) 'Window #',IW,' Bad row at Y=',IY
              CALL STTPUT(OUTPUT,ISTAT)
            ENDIF
          ENDIF
        ENDDO
      ENDDO
      IF(IDEBUG.GT.0) THEN
        WRITE(OUTPUT,*) 
     +   'Entered with NYBAD =',NYBAD,' found NBAD =',NBAD
        CALL STTPUT(OUTPUT,ISTAT)
        IF(IDEBUG.GT.1) THEN
          WRITE(*,*) 'Hit return to continue'
          READ(*,'(A1)') C1
        ENDIF
      ENDIF
      IF(NBAD.GT.NYBAD) THEN
        NYBAD=NBAD
        GO TO 10
      ENDIF
      RETURN
      END


      SUBROUTINE SKY_ZERO(ISFORCE)
c
c Subroutine which selects and excludes, whithin each window, the scan-lines
c (Y=const) which contain signal well above (below) the typical sky noise
c The selection criterium is
c      abs( aver(Y_scanline)-aver(all_Y_scan_lines) > 
c      THRSY*aver_sigma(all_Y_scanlines)
c and go on iteratively.
c If, as sometimes happens, finds that all scan-lines are stars
c retry with THRSY=THRSY*SQRT(2) and so forth.
c
c This routine assumes that image "C" (pointer ICP) was already created.
c
c This routine adds "bad scan lines" to JYBAD and must be called
c only at the end of the program.
c
c This routine modify the image "C" and subtract the "good average"
c of the sky windows from it.
c
c All the above operations are performed only if ISFORCE>1
c
      IMPLICIT REAL(A-H,O-Z)
      IMPLICIT INTEGER(I-N)
C 
      INTEGER*8 IAP,IBP,ICP
      INTEGER*8 IJC
C
      COMMON/PARAM/NX,NY,IAP,IBP,ICP,NWIND,JLIM(400)
      COMMON/TALK/JYBAD(1000),NYBAD,STDX(1000),AVEX(1000),THRSX,IDEBUG
      COMMON/VMR/SS(1)
      CHARACTER*80 OUTPUT
      CHARACTER*1 C1


      IF(ISFORCE.LE.0) RETURN
      IF(IDEBUG.GT.0) THEN
        CALL STTPUT('SKY_ZERO: defining bad and star-Ylines',ISTAT)
      ENDIF
      THRSY=THRSX
100   CONTINUE
      NYBAD=0
10    CONTINUE
      CALL STD_WIND(AVEW,STDW)
      IF(IDEBUG.GT.0) THEN
        WRITE(OUTPUT,*) 
     +   'Entered with AVEW =',AVEW,' STDW =',STDW
        CALL STTPUT(OUTPUT,ISTAT)
      ENDIF
      IF(STDW.LE.0.) THEN
        IF(IDEBUG.GT.0) CALL STTPUT('Expand Y-threshold',ISTAT)
        THRSY=THRSY*SQRT(2.)
        GO TO 100
      ENDIF
      NBAD=0
      NSL=0
      DO IW=1,NWIND
        IY1=JLIM(3+4*(IW-1))
        IY2=JLIM(4+4*(IW-1))
        DO IY=IY1,IY2
          JYSHIFT=IY+(IW-1)*NY
          NSL=NSL+1
          DISTX=STDX(NSL)/STDW
          DISTY=ABS(AVEX(NSL)-AVEW)/STDW
          IF(DISTX.GT.THRSX .OR. DISTY.GT.THRSY) THEN
            NBAD=NBAD+1
            JYBAD(NBAD)=JYSHIFT
            IF(IDEBUG.GT.1) THEN
              IF(DISTX.GT.THRSX) THEN
                WRITE(OUTPUT,*) 'Window #',IW,' Bad row at Y=',IY
                CALL STTPUT(OUTPUT,ISTAT)
              ENDIF
              IF(DISTY.GT.THRSY) THEN
                WRITE(OUTPUT,*) 'Window #',IW,' Star-row at Y=',IY
                CALL STTPUT(OUTPUT,ISTAT)
              ENDIF
            ENDIF
          ENDIF
        ENDDO
      ENDDO
      IF(IDEBUG.GT.0) THEN
        WRITE(OUTPUT,*) 
     +   'Entered with NYBAD =',NYBAD,' found NBAD =',NBAD
        CALL STTPUT(OUTPUT,ISTAT)
        IF(IDEBUG.GT.1) THEN
          WRITE(*,*) 'Hit return to continue'
          READ(*,'(A1)') C1
        ENDIF
      ENDIF
      IF(NBAD.GT.NYBAD) THEN
        NYBAD=NBAD
        GO TO 10
      ENDIF
c
c Subtract the average value of the sky windows
c
      DO IY=1,NY
        DO IX=1,NX
          IJC=IX+NX*(IY-1)+ICP-1
          SS(IJC)=SS(IJC)-AVEW
        ENDDO
      ENDDO

      RETURN
      END


      SUBROUTINE STD_WIND(AVEW,STDW)
c
c
c Define the average of the X-std (computed only along lines with Y=const)
c of a a number of windows of the image "C" (pointer ICP).
c Bad scan-lines (stored in JYBAD) are not considered.
c The average and std of each scan-line are also stored inside STDX
c and AVEX.
c
      IMPLICIT REAL(A-H,O-Z)
      IMPLICIT INTEGER(I-N)
C 
      INTEGER*8 IAP,IBP,ICP
C
      COMMON/PARAM/NX,NY,IAP,IBP,ICP,NWIND,JLIM(400)
      COMMON/TALK/JYBAD(1000),NYBAD,STDX(1000),AVEX(1000),THRSX,IDEBUG
      COMMON/VMR/SS(1)

      STDW=0.
      AVEW=0.
      NSL=0
      DO IW=1,NWIND
        IX1=JLIM(1+4*(IW-1))
        IX2=JLIM(2+4*(IW-1))
        IY1=JLIM(3+4*(IW-1))
        IY2=JLIM(4+4*(IW-1))
        DO IY=IY1,IY2
c
c N.B. JYSHIFT is used to codify the bad scan lines (see DEF_YBAD)
c
          JYSHIFT=IY+(IW-1)*NY
          NSL=NSL+1
          DO JY=1,NYBAD
            IF(JYBAD(JY).EQ.JYSHIFT) GO TO 11
          ENDDO
          STDW=STDW+STDX(NSL)*STDX(NSL)
          AVEW=AVEW+AVEX(NSL)
11        CONTINUE
        ENDDO
      ENDDO
      STDW=SQRT(STDW/NSL)
      AVEW=AVEW/NSL

      RETURN
      END




      SUBROUTINE DIFF_AB(FAC,SH)
c
c Subroutine wich computed and stores into
c the "C" image (i.e. SS(IJC)) the difference
c between "A" (SS(IJA)) and "B" (SS(JJB)) with
c "A" shifted by SH and "B" multiplied times FAC.
c
c N.B. IJA, IJB, IJB are the positions defined by the
c pointers IAP,IBP and ICP
c
c It also computes and stores STDX and AVEX (standard deviation
c and average, row by row, in the sky windows).
c
      IMPLICIT REAL(A-H,O-Z)
      IMPLICIT INTEGER(I-N)
C 
      INTEGER*8 IAP,IBP,ICP
      INTEGER*8 IJ1,IJ2,IJ,IJB,IJC
C 
      COMMON/PARAM/NX,NY,IAP,IBP,ICP,NWIND,JLIM(400)
      COMMON/TALK/JYBAD(1000),NYBAD,STDX(1000),AVEX(1000),THRSX,IDEBUG
      COMMON/VMR/SS(1)			!statt MADRID ...

      DO IY=1,NY
        DO IX=1,NX
          IX1=MAX(IX-1,1)
          IX2=MIN(IX+1,NX)
          IJ1=IX1+NX*(IY-1)+IAP-1
          IJ2=IX2+NX*(IY-1)+IAP-1
          IJ=IX+NX*(IY-1)+IAP-1
          IF(SH.GT.0) ASH=(1-SH)*SS(IJ)+SH*SS(IJ2)
          IF(SH.LE.0) ASH=(1+SH)*SS(IJ)-SH*SS(IJ1)
          IJB=IX+NX*(IY-1)+IBP-1
          IJC=IX+NX*(IY-1)+ICP-1
          SS(IJC)=ASH-FAC*SS(IJB)
        ENDDO
      ENDDO

      NSL=0
      DO IW=1,NWIND
        IX1=JLIM(1+4*(IW-1))
        IX2=JLIM(2+4*(IW-1))
        IY1=JLIM(3+4*(IW-1))
        IY2=JLIM(4+4*(IW-1))
        DO IY=IY1,IY2
c
c N.B. JYSHIFT is used to codify the bad scan lines (see DEF_YBAD)
c
          JYSHIFT=IY+(IW-1)*NY
          SUM=0.0
          SUM2=0.0
          NAVE=0
          DO IX=IX1,IX2
            IJC=IX+NX*(IY-1)+ICP-1
            VAL=SS(IJC)
            SUM=SUM+VAL
            SUM2=SUM2+VAL*VAL
            NAVE=NAVE+1
          ENDDO
          IF(NAVE.LE.1) CALL FAILED(-1)
          NSL=NSL+1
          IF(NSL.GT.1000) CALL FAILED(7777)
          STDX(NSL)=SQRT((SUM2-SUM*SUM/NAVE)/(NAVE-1))
          AVEX(NSL)=SUM/NAVE
        ENDDO
      ENDDO

      RETURN
      END



      SUBROUTINE FAILED(II)

      IMPLICIT REAL(A-H,O-Z)
      IMPLICIT INTEGER(I-N)

c
c Give error message depending on II
c
      IF(II.EQ.7777) THEN
        CALL STTPUT
     +  ('More than 1000 scan-lines in window(s)',ISTAT)
        CALL STTPUT
     +  ('Need to modify skysub.for',ISTAT)
        GO TO 99
      ENDIF
      IF(II.EQ.-1) THEN
        CALL STTPUT
     +  ('Sky-windows must be at least 3 pixels wide in X',ISTAT)
        GO TO 99
      ENDIF
      IF(II.EQ.-2) THEN
        CALL STTPUT
     +  ('No good scan line in sky window(s)',ISTAT)
        GO TO 99
      ENDIF
      IF(II.EQ.1000) THEN
        CALL STTPUT
     +  ('WARNING! No convergency after 30 iterations',ISTAT)
        CALL STTPUT
     +  ('May be better to try manually ',ISTAT)
        RETURN
      ENDIF
99    CONTINUE
      CALL STETER(1,' ')
      RETURN
      END

C @(#)dblsub.for	19.1 (ES0-DMD) 02/25/03 14:29:00
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
        subroutine read1d(IN,NPIX,DATA)

        implicit none

        INTEGER  NPIX
        REAL     IN(NPIX)
        REAL     DATA(NPIX)

        INTEGER  II

        do  II = 1,NPIX
          DATA(II) = IN(II)
        end do

        return
        end


        subroutine read2d(IN,NPIX,DATA,NDATA)

        implicit none

        INTEGER  NPIX(2)
        REAL     IN(1)
        INTEGER  NDATA
        REAL     DATA(NDATA)
        character*80  STRING
        INTEGER  STAT

        INTEGER  II,JJ,KK

C        STRING = ' NPIX = '
C        write (STRING(9:80),101) (NPIX(II),II=1,2)
C        call sttput(STRING,STAT)
 101        format(2I4)

C        STRING = ' IN = '
C        write (STRING(7:80),102) (IN(1,II),II=1,10)
C        call sttput(STRING,STAT)
 102        format(10F5.0)

        KK = 0
        do  JJ = 1,NPIX(2)
          do  II = 1,NPIX(1)
            KK = KK+1
            DATA(KK) = IN(KK)
            if (DATA(KK).eq.0) then
              STRING = ' zero data value read in at pixel '
              write (STRING(35:80),100) KK
              call sttput(STRING,STAT)
            end if
          end do
        end do

 100        format(I2)

        return
        end

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
         PROGRAM INSTRM
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENT         INSTR.FOR
C.MODULE
C.AUTHOR        Andrew T. Young
C.KEYWORD
C.LANGUAGE      FORTRAN 77
C.PURPOSE       Make or check the instrument-description table file.
C.COMMENTS
C.VERSION       0.0
C               0.5     921202, KB
C               4.5     930317. aty
C               5.2     930406. aty
C 100621	last modif
C-----------------------------------------------------------------------------
C
C
C       Notation: table-column variables begin with K.
C
C  BEGIN Declarations:
C
      IMPLICIT NONE
C
      INTEGER MXSLOT, MXDETS
      PARAMETER (MXSLOT=60, MXDETS=20)
C
        CHARACTER*72 INSTNAM
        CHARACTER*8 REPLY, CODE, BAND
        CHARACTER*80 INSTRTBL, ALTNAME, C80, SPRTBL, FILTCAT
        CHARACTER*80 CTEST
        CHARACTER SNUMBER*9, MODE*20
        CHARACTER*12 FMT,DEDTYP,COOLING
        CHARACTER*12 DETNAM(MXSLOT),DTNAM(MXDETS)
C
        LOGICAL NULL, FEXIST, CCD, HASND
C
      DOUBLE PRECISION DNULL
      REAL RNULL
      INTEGER INULL
C
      INTEGER J_CONT,J_LOG,J_DISP
      COMMON/FLAGS/J_CONT,J_LOG,J_DISP
C
      INTEGER LWORD
      EXTERNAL LWORD
C
        LOGICAL MATCH, HELP
        EXTERNAL MATCH, HELP
C
C
      REAL TEMP, DEDTIM, DEDERR, RATEMX, RLSIZE, XNDVAL
C
      INTEGER NCOLS, NROW, NROWS, NSORTC, NWPRAL, NROWSAL,
     1        NVALS, IUNIT, NULLS, NFCDFS, NDET, NDETS, NDETRO,
     2        NFC, NSLOT, NSLOTS, MAXNAME, NUMNAME, NFILT,
     3        KOLS
C
        INTEGER KFLTCD(25)
C
C       Column pointers:
C
      INTEGER KDET, KBAND, KDETNM, KNDET, KCOOLING, KCOOL, KND,
     1        KSNUMB, KMODE, KDEDTYP, KDEDTM, KDEDER, KSPRTBL, KBLURSP,
     2        KDTEMP, KNBAND, KNDETU, KRL, KRLTYP, KMAKER
C
      INTEGER ITBL, ISTAT
C
C
C  Set up MIDAS declarations:
C
        INTEGER MADRID(1)
C
        COMMON /VMR/ MADRID
C
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'
        INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C
C
C  END Declarations.
C
C
C
C
C  ********************  PROLOGUE  ********************
C
        CALL STSPRO ('INSTRM')
C
C     get NULL values:
C
      CALL TBMNUL (INULL, RNULL, DNULL)
C
C     save error settings:
      CALL STECNT('GET', J_CONT,J_LOG,J_DISP)
C     reset error settings:
      CALL STECNT('PUT', 1,2,2)
C
C  Real program begins here:
C
C
C       AskAscii:
    1   CONTINUE
        CALL ASK('Is the instrument already in a MIDAS table file?',
     1                  REPLY)
C       *****
        IF (REPLY(:1) .EQ. 'Y') THEN
C       *****
C
C   AskName:
    2   CONTINUE
        CALL ASKFIL('What is the name of the file?',INSTRTBL)
C
C See if instrum.tbl is available locally...
C
C   Fexist:
    3   CONTINUE
        INQUIRE (FILE=INSTRTBL, EXIST=FEXIST)
C               ***
                IF (.NOT.FEXIST) THEN
C               ***                       Not found.
C
C       Maybe user forgot the suffix:
        ALTNAME=INSTRTBL(:LWORD(INSTRTBL))//'.tbl'
        INQUIRE (FILE=ALTNAME, EXIST=FEXIST)
        IF (FEXIST) THEN
            INSTRTBL=ALTNAME
            C80='(Actually, it''s '//INSTRTBL(:LWORD(INSTRTBL))//
     1                         ' because of the suffix.)'
            CALL TV (C80)
            CALL SPACE2
            GOTO 3
        ENDIF
C
        C80='No file named '//INSTRTBL(:LWORD(INSTRTBL))//
     1                         ' in your local directory.'
        CALL TV(C80)
    5   CONTINUE
        C80='Is '//INSTRTBL(:LWORD(INSTRTBL))//' the correct name?'
        CALL ASK(C80,REPLY)
        IF(REPLY(:1) .EQ. 'N')THEN
            CALL SPACE
            GOTO 2
        ELSEIF(REPLY(:1) .EQ. 'Y')THEN
            CALL TV('Maybe it''s in another directory.')
            CALL TVN('Please find the file, and try again.')
            CALL STECNT('PUT', J_CONT,J_LOG,J_DISP)
            CALL STETER(5,' ')
        ELSE
            CALL TV('Please reply Yes or No.')
            GOTO 5
        ENDIF
C
C               ***
                ELSE
C               ***
C
C       File exists.  Use it:
        CALL TV('Please check this description of the instrument:')
        CALL TBTOPN (INSTRTBL, 1,  ITBL, ISTAT)
        IF (ISTAT.NE.0)THEN
            CALL TERROR(ITBL,5,'Could not open table.')
        END IF
        CALL TBIGET (ITBL,  NCOLS, NROWS, NSORTC, NWPRAL, NROWSAL,ISTAT)
        IF (ISTAT.NE.0)THEN
            CALL TERROR(ITBL,5,'Could not get basic table data.')
        END IF
C
C       READ/TABLE {instrtbl}
        CALL READT(ITBL)
C
C    Read DESCRIPTORS:
C
C       Look at INSTNAM:
        CALL STDRDC (ITBL, 'INSTNAM', 1, 1, 72,
     1                NVALS, INSTNAM, IUNIT, NULLS, ISTAT)
        IF (ISTAT.NE.0) THEN
            CALL TERROR(ITBL,6,'Could not find descriptor INSTNAM')
        END IF
        CALL TV('Instrument is:')
        CALL TV(INSTNAM)
C
C       Look at FILTCAT:
        CALL STDRDC (ITBL, 'FILTCAT', 1, 1, 80,
     1                NVALS, FILTCAT, IUNIT, NULLS, ISTAT)
        IF (FILTCAT(:1).EQ.' ') THEN
C               No catalog.
                CALL TV('No filter catalog.')
        ELSE
                CALL TV('Filter catalog: ')
                CALL TVN(FILTCAT)
        END IF
C
C       Look at NFILTCAR:
        CALL STDRDI (ITBL, 'NFILTCAR', 1, 1,
     1                NVALS, NFCDFS, IUNIT, NULLS, ISTAT)
        WRITE(C80,'(I6,A19)')NFCDFS, ' filter code fields'
C       a singular correction...
        IF (NFCDFS.EQ.1) C80(25:25)=' '
        CALL TV(C80)
C
C       Look at FILTSTAT:
        CALL STDRDC (ITBL, 'FILTSTAT', 1, 1, 9,
     1                NVALS, C80, IUNIT, NULLS, ISTAT)
        IF (C80(:1).EQ.'R') THEN
C               Filter temp. Regulated.
                CALL STDRDR (ITBL, 'FILTTEMP', 1, 1,
     1                   NVALS, TEMP, IUNIT, NULLS, ISTAT)
                WRITE(C80,
     1            '(''Filter temperature regulated at '',F5.1,'' K'')')
     2                  TEMP
                CALL TV(C80)
        ELSE IF (C80(:1).EQ.'M') THEN
C               Filter temp. Measured.
                CALL TV('Filter temperature MEASURED, not regulated.')
        ELSE IF (C80(:1).EQ.'D') THEN
C               Filter temp. = ambient.
                CALL TV('Filters at DOME temperature')
        ELSE
                CALL TV('Unrecognized string in descriptor FILTSTAT:')
                CALL TVN(C80)
        END IF
C
C       Look at NDETS:
        CALL STDRDI (ITBL, 'NDETS', 1, 1,
     1                NVALS, NDETS, IUNIT, NULLS, ISTAT)
        WRITE(C80,'(I6,A18)')NDETS, ' detector channels'
        IF (NDETS.EQ.1) C80(24:24)=' '
        CALL TV(C80)
C
C       Get required-column pointers:
C
        CALL TBLSER (ITBL, 'DET',  KDET, ISTAT)
        CALL TBLSER (ITBL, 'BAND',  KBAND, ISTAT)
        CALL TBLSER (ITBL, 'DETNAME',  KDETNM, ISTAT)
        CALL TBLSER (ITBL, 'NDET',  KNDET, ISTAT)
        CALL TBLSER (ITBL, 'COOLING',  KCOOLING, ISTAT)
C
C       Look at detectors:
C
        DO 9 NDET=1,NDETS
C           find row containing NDET:
            DO 7 NROW=1,NROWS
            CALL TBERDI (ITBL, NROW, KNDET,  NDETRO, NULL, ISTAT)
            IF (.NOT.NULL)THEN
                IF (NDET.EQ.NDETRO) GO TO 8
            END IF
    7       CONTINUE
            WRITE(C80,'(''Could not locate data for NDET ='',I2)') NDET
            CALL TERROR(ITBL,8,C80)
    8       CONTINUE
            IF (NDETS.GT.1)THEN
                IF (KDETNM.GT.0)THEN
                    CALL TBERDC (ITBL, NROW, KDETNM,
     1                           CTEST, NULL, ISTAT)
                    CALL FT_EOS (CTEST,12,DTNAM(NDET), ISTAT)
                    WRITE(C80,'(''   *****  '',A,'' channel  *****'')')
     1                          DTNAM(NDET)(:LWORD(DTNAM(NDET)))
                ELSE
                    WRITE(C80,'(''   *****  detector'',I3,''  *****'')')
     1                          NDET
                END IF
                CALL TV(C80)
            END IF
C
C           Look at DET:
C
            CALL TBERDC (ITBL, NROW, KDET,CTEST, NULL, ISTAT)
            CALL FT_EOS (CTEST,8,REPLY,ISTAT)
            IF (REPLY(:1).EQ.'P') THEN
C               we have DET = PMT
C
                CALL TBLSER (ITBL, 'SNUMBER',  KSNUMB, ISTAT)
                CALL TBERDC (ITBL, NROW, KSNUMB,  CTEST, NULL, ISTAT)
                CALL FT_EOS (CTEST,9,SNUMBER,ISTAT)
C
                CALL TBLSER (ITBL, 'MODE',  KMODE, ISTAT)
                CALL TBERDC (ITBL, NROW, KMODE,  CTEST, NULL, ISTAT)
                CALL FT_EOS (CTEST,20,MODE,ISTAT)
C
                MODE(3:)=' '
                IF (MODE(:2).EQ.'PC') THEN
                        MODE='Pulse-counting'
                ELSE IF (MODE(:2).EQ.'DC') THEN
                ELSE IF (MODE(:2).EQ.'CI') THEN
                        MODE='Charge-integrating'
                ELSE
                        MODE='unrecognized'
                END IF
                WRITE (C80,'(A)') SNUMBER(:LWORD(SNUMBER))//
     1                ' PMT used in '//MODE(:LWORD(MODE))//' mode'
                CALL TV(C80)
                IF (MODE(:1).EQ.'P')THEN
                        CALL TBLSER (ITBL, 'DEADTYPE',  KDEDTYP, ISTAT)
                        CALL TBERDC (ITBL, NROW, KDEDTYP,
     1                                 CTEST, NULL, ISTAT)
                        CALL FT_EOS (CTEST,12,DEDTYP,ISTAT)
C
                        IF (DEDTYP(:1).EQ.'E') THEN
                                DEDTYP='EXTENDING'
                        ELSE IF (DEDTYP(:1).EQ.'N') THEN
                                DEDTYP='NON-EXTENDING'
                        ELSE IF (DEDTYP(:1).EQ.'U') THEN
                                DEDTYP='UNKNOWN type of'
                        ELSE
                                CALL TV('Unrecognized dead-time type.')
                                DEDTYP='incorrectly coded'
                        END IF
C
                        CALL TBLSER (ITBL, 'DEADTIME',  KDEDTM, ISTAT)
                        IF (ISTAT.NE.0) THEN
                            CALL TERROR(ITBL,8,
     1                            'Could not find column DEADTIME')
                        END IF
                        CALL TBERDR (ITBL, NROW, KDEDTM,
     1                                 DEDTIM, NULL, ISTAT)
C
                        CALL TBLSER (ITBL,'DEADTIMEERROR',KDEDER,ISTAT)
                        IF (ISTAT.NE.0) THEN
                            CALL TERROR(ITBL,8,
     1                            'Could not find column DEADTIMEERROR')
                        END IF
                        CALL TBERDR (ITBL, NROW, KDEDER,
     1                                 DEDERR, NULL, ISTAT)
C
                        WRITE(C80,'(''with'',F6.1,'' +/-'',F5.1,A)')
     1                   DEDTIM*1.E9,DEDERR*1.E9,' ns '//
     2                      DEDTYP(:LWORD(DEDTYP))//' dead time'
                        CALL TVN(C80)
                ELSE
                END IF
            ELSE IF (REPLY(:1).EQ.'S' .OR. REPLY(:1).EQ.'O') THEN
C               we have DET = SILICON (or OTHER)
C
                CALL TBLSER (ITBL, 'SPECTRESPTBL',  KSPRTBL, ISTAT)
                IF (ISTAT.NE.0) THEN
                    CALL TERROR(ITBL,8,
     1                  'Could not find column SPECTRESPTBL')
                END IF
C
                IF (REPLY(:1).EQ.'S' .AND. KSPRTBL.EQ.-1) THEN
C                   look for BLUERESP:
                    CALL TBLSER (ITBL, 'BLUERESP',  KBLURSP, ISTAT)
                    IF (ISTAT.NE.0) THEN
                        CALL TERROR(ITBL,8,
     1                         'Could not find column BLUERESP')
                    END IF
                    CALL TBERDC (ITBL, NROW, KBLURSP, CTEST,NULL,ISTAT)
                    CALL FT_EOS (CTEST,8,REPLY,ISTAT)
C
                    IF (REPLY(:1).EQ.'F') THEN
C                       Front:
                        C80='Front-illuminated Silicon detector'
                    ELSE IF (REPLY(:1).EQ.'B') THEN
C                       Back:
                        C80='Back-illuminated Silicon detector'
                    ELSE IF (REPLY(:1).EQ.'P') THEN
C                       Phosphor:
                        C80='Phosphor-coated Silicon detector'
                    ELSE IF (REPLY(:1).EQ.'E') THEN
C                       Enhanced:
                        C80='UV-enhanced Silicon detector'
                    ELSE
                        CALL TV('Unknown code in descriptor BLUERESP:')
                        CALL TVN(REPLY)
                        C80='Silicon detector'
                    END IF
                ELSE IF (REPLY(:1).EQ.'S') THEN
                    C80='Silicon detector'
                ELSE IF (REPLY(:1).EQ.'O') THEN
C                   we have DET = OTHER
                    C80='Non-standard detector type.'
                END IF
C
                CALL TV(C80)
C
                IF (KSPRTBL.GT.0)THEN
                    CALL TBERDC (ITBL, NROW,KSPRTBL,CTEST,NULL,ISTAT)
                    CALL FT_EOS (CTEST,80,SPRTBL,ISTAT)
                    IF (SPRTBL(:1).NE.' ') THEN
                        CALL TVN('spectral response in file:')
                        CALL TVN(SPRTBL)
                    ELSE
                        CALL TVN('without spectral response table,')
                    END IF
                ELSE
                    CALL TVN('without spectral response table,')
                END IF
            ELSE
                CALL TV('Unrecognized string in DET.')
            END IF
C
C       Look at COOLING:
C
        CALL TBLSER (ITBL, 'COOLING',  KCOOL, ISTAT)
        IF (ISTAT.NE.0) THEN
            CALL TERROR(ITBL,8,'Could not find column COOLING')
        END IF
        CALL TBERDC (ITBL, NROW, KCOOL, CTEST, NULL, ISTAT)
        CALL FT_EOS (CTEST,20,MODE,ISTAT)
C
        IF(MODE(:1).EQ.'R') THEN
C           detector temperature Regulated.
            CALL TBLSER (ITBL, 'DETTEMP',  KDTEMP, ISTAT)
            CALL TBERDR (ITBL, NROW, KDTEMP,  TEMP, NULL, ISTAT)
C
            WRITE(C80,
     1            '(''Detector temp. regulated at '',F5.1,'' K'')')
     2                  TEMP
            CALL TVN(C80)
        ELSE IF(MODE(:1).EQ.'U') THEN
C           Unregulated detector cooling.
            CALL TVN('Detector cooled, but not regulated.')
        ELSE IF(MODE(:1).EQ.'D') THEN
C           detector cooled with Dry ice.
            CALL TVN('Detector cooled with DRY ICE.')
        ELSE IF(MODE(:1).EQ.'I') THEN
C           detector cooled with ordinary Ice.
            CALL TVN('Detector cooled with ordinary water ICE.')
        ELSE IF(MODE(:1).EQ.'M') THEN
C           detector temperature Measured.
            CALL TVN('Detector temperature MEASURED.')
        ELSE IF(MODE(:1).EQ.'N') THEN
C           detector Not cooled (at ambient temp.)
            CALL TVN('Detector not cooled; assumed at dome temp.')
        ELSE
            CALL TV('Unrecognized string in COOLING.')
        END IF
C
    9   CONTINUE
C
C       Look at CONDITION:
        MODE=' '
        CALL STDRDC (ITBL, 'CONDITION', 1, 1, 7,
     1                NVALS, MODE, IUNIT, NULLS, ISTAT)
        WRITE(C80,'(A)') 'Optics are in '//MODE(:LWORD(MODE))//
     1                     ' condition.'
        CALL TV(C80)
        CALL SPACE2
C
C               ***
                ENDIF
C               ***
C                       (Finished with existing file here.)
C       .....................................................................
C       *****
        ELSEIF (REPLY(:1) .EQ. 'N') THEN
C       *****                                    *****  MAKE NEW TABLE  *****
C
        CALL SPACE2
        CALL TV ('NOTE:  Help is available here.')
        CALL TVN('If you do not understand a question, reply')
        CALL TV ('     HELP')
        CALL TVN('or')
        CALL TVN('       ?')
        CALL TV ('and help will be provided.  Please refer to')
        CALL TVN('the Appendix on File Formats for details.')
        CALL SPACE2
        CALL ASKFIL('What do you want to call the table file?',INSTRTBL)
C       Create the table:
   10   CONTINUE
        CALL TBTINI (INSTRTBL, 0, 0, 1, 1,  ITBL, ISTAT)
        IF (ISTAT.NE.0) THEN
                CALL TV('Unable to create table...')
                CALL STECNT('PUT', J_CONT,J_LOG,J_DISP)
                CALL STETER(10,' ')
        ENDIF
C
        CALL TVN('   ... new table file created.')
C
        CALL ASKFIL('Enter the name of the instrument: ',INSTNAM)
C
        CALL TBCINI (ITBL, D_I1_FORMAT, 1, 'I5', ' ', 'NBAND',
     1               KNBAND, ISTAT)
        IF (ISTAT.NE.0) THEN
                CALL TERROR(ITBL,10,'Could not create NBAND Column')
        ENDIF
C
        CALL TBCINI (ITBL, D_C_FORMAT, 8, 'A8', ' ', 'BAND',
     1               KBAND, ISTAT)
        IF (ISTAT.NE.0) THEN
                CALL TERROR(ITBL,10,'Could not create BAND Column')
        ENDIF
C
      HASND=.FALSE.
      C80='Does '//INSTNAM(:LWORD(INSTNAM))
      CALL TV(C80)
      CALL ASKN('use "neutral" attenuators (e.g., filters)?',REPLY)
      IF (MATCH(REPLY,'YES')) THEN
         HASND=.TRUE.
         CALL TBCINI (ITBL, D_R4_FORMAT, 1, 'F7.3', ' ', 'NDVALUE',
     1               KND, ISTAT)
         IF (ISTAT.NE.0) THEN
                CALL TERROR(ITBL,10,'Could not create NDVALUE Column')
         ENDIF
      ELSE IF (MATCH(REPLY,'NO')) THEN
C        OK.
      ELSE
C        problem?
         CALL TV('No neutral filters assumed.')
      END IF
C
      CALL SPACE2
      CALL TV('Please supply information about FILTER CODING:')
      CALL TVN('programs must be able to identify passbands in your')
      CALL TVN('MIDAS table-format data files.')
C
      CALL TV('In SINGLE-CHANNEL data, we expect 1 filter-code field')
      CALL TVN('in raw data files, with one filter CODE per passband.')
      CALL TVN('Two filter wheels in series can often be treated as')
      CALL TVN('a single field in data, if their codes are adjacent.')
C
      CALL TV('MULTI-CHANNEL instruments may use separate FILTER-CODE')
      CALL TVN('fields for each detector; then enter the number of')
      CALL TVN('FIELDS used.  But if they put data from different')
      CALL TVN('detectors in different DATA fields, and use no filter')
      CALL TVN('coding at all (one fixed passband per detector, as in')
      CALL TVN('some spectrometric instruments), enter 0.  Remember to')
      CALL TVN('count Dark and Neutral-density filter codes.')
   11   CONTINUE
        CALL ASK('How many FILTER-code FIELDS in raw data?',REPLY)
        IF (HELP(REPLY)) THEN
           CALL TV('This is the number of COLUMNS (not the number of')
           CALL TVN('different data codes) your data files will use')
           CALL TVN('to indicate filter positions.  If the shutter')
            CALL TVN('position is encoded in a different PLACE in the')
           CALL TVN('data, it counts as a separate filter-code field.')
           CALL TVN('Likewise, if there is a separate code field for')
           CALL TVN('neutral-density filters, add that to the count.')
           CALL TVN('But if dark positions are in your regular filter')
           CALL TVN('wheel, they do not count as separate FIELDS.')
           CALL TV ('See Tables 13 - 15 in the Appendix for examples.')
           GO TO 11
        END IF
        READ (REPLY,'(I2)', ERR=11) NFCDFS
        CALL STDWRI (ITBL, 'NFILTCAR', NFCDFS, 1, 1, IUNIT,  ISTAT)
        IF (ISTAT.NE.0) THEN
             CALL TERROR(ITBL,11,'Could not write descriptor NFILTCAR')
        ENDIF
C
        DO 12 NFC=1,NFCDFS
        IF (NFC.LE.9) THEN
            WRITE(MODE,'(''FILTCODE_'',I1)') NFC
        ELSE
            WRITE(MODE,'(''FILTCODE'',I2)') NFC
        END IF
        CALL TBCINI (ITBL, D_C_FORMAT, 8, 'A10', ' ', MODE,
     1               KFLTCD(NFC), ISTAT)
        IF (ISTAT.NE.0) THEN
                C80='Could not create '//MODE(:LWORD(MODE))//' column'
                CALL TERROR(ITBL,12,C80)
        ENDIF
   12   CONTINUE
C
C       13 is error return on reading internal file REPLY.
   13   CONTINUE
        CALL ASK('How many DETECTORS or signal channels?',REPLY)
        READ (REPLY,'(I2)', ERR=13) NDETS
        CALL STDWRI (ITBL,'NDETS',NDETS, 1, 1, IUNIT,  ISTAT)
        IF (ISTAT.NE.0) THEN
             CALL TERROR(ITBL,13,'Could not write descriptor NDETS')
        ENDIF
C
        IF (NDETS.GT.MXDETS) THEN
           C80='Sorry -- program is dimensioned for only'
           WRITE(C80(41:),'(I3)') MXDETS
           C80(44:)='detectors.'
           CALL TV(C80)
           CALL TVN('Raise Parameter MXDETS in instr.for & recompile.')
           CALL TERROR(ITBL,13,'Too many detectors.')
        END IF
C
        IF (NDETS.GT.1) THEN
            CALL TBCINI (ITBL, D_I1_FORMAT, 1, 'I8', ' ', 'NDETUSED',
     1               KNDETU, ISTAT)
            IF (ISTAT.NE.0) THEN
                CALL TERROR(ITBL,13,'Could not create NDETUSED column')
            ENDIF
            CALL TBCINI(ITBL,D_C_FORMAT,12,'A12',' ','DETNAME',
     1                 KDETNM,ISTAT)
            IF (ISTAT.NE.0) THEN
                CALL TERROR(ITBL,14,'Could not create DETNAME column')
            ENDIF
        ELSE
            KNDETU=-1
        END IF
        CALL SPACE2
C
C                       *****  Prepare PASSBAND sub-table  *****
C     ------
      IF (NFCDFS.EQ.1) THEN
C     ------
C               only 1 filter-code FIELD.
C
   14   CONTINUE
        CALL ASK(
     1     'How many distinct FILTER CODES (including ND and dark)?',
     2          REPLY)
        IF (HELP(REPLY)) THEN
          CALLTV('This asks how many differently-coded POSITIONS there')
          CALLTVN('are in the filter mechanism.')
           GO TO 14
        END IF
        READ (REPLY,'(I2)', ERR=14) NSLOTS
C
      DO 18 NSLOT = 1, NSLOTS
        CALL SPACE2
        IF (NSLOT.LE.9)THEN
            WRITE (C80,'(A43,I1,''?'')')
     1        'What is the filter CODE in position number ',NSLOT
        ELSE
            WRITE (C80,'(A43,I2,''?'')')
     1        'What is the filter CODE in position number ',NSLOT
        ENDIF
        CALL ASKFIL(C80, CODE)
        CALL TBEWRC(ITBL, NSLOT, KFLTCD(1), CODE,  ISTAT)
        IF (ISTAT.NE.0) THEN
            CALLTERROR(ITBL,15,'Could not write to FILTCODE_1 Column')
        ENDIF
C
   16   IF (NSLOT.LE.9)THEN
            WRITE (C80,'(A42,I1,''?'')')
     1        '    What is the passband NAME in position ',NSLOT
        ELSE
            WRITE (C80,'(A42,I2,''?'')')
     1        '    What is the passband NAME in position ',NSLOT
        ENDIF
        CALL ASKFIL (C80, BAND)
        IF (HELP(BAND)) THEN
            CALL BNDHLP
            GO TO 16
        ENDIF
        CALL TBEWRI(ITBL, NSLOT, KNBAND, NSLOT,  ISTAT)
        IF (ISTAT.NE.0) THEN
                CALL TERROR(ITBL,16,'Could not write to NBAND Column')
        ENDIF
        CALL TBEWRC(ITBL, NSLOT, KBAND, BAND,  ISTAT)
        IF (ISTAT.NE.0) THEN
                CALL TERROR(ITBL,17,'Could not write to BAND Column')
        ENDIF
        IF (HASND) THEN
C         Get XNDVAL.
          IF (LWORD(BAND).GT.2 .AND.
     1        (INDEX(BAND,'ND').EQ.LWORD(BAND)-1 .OR.
     2         INDEX(BAND,'ND').EQ.LWORD(BAND)-2) ) THEN
   17       CALL TV(
     1         'What is the attenuation factor of this neutral filter?')
            CALL TVN('   (enter 1.0 if no attenuation.)')
            CALL QF('?', XNDVAL)
            IF (XNDVAL.GT.0. .AND. XNDVAL.LT.1.) THEN
              CALL TV('Program expects a value greater than unity.')
              XNDVAL=1./XNDVAL
              WRITE(C80,'(F8.3,'' will be used.  OK?'')') XNDVAL
              CALL ASK(C80,REPLY)
              IF (MATCH(REPLY,'YES') .OR. MATCH(REPLY,'OK')) THEN
C               OK.
              ELSE IF (MATCH(REPLY,'NO') .OR. HELP(REPLY)) THEN
                CALL TV('That''s the reciprocal of what you entered.')
                CALL TV(BAND)
                GO TO 17
              ELSE
                CALL TV(BAND)
                GO TO 17
              END IF
            ELSE IF (XNDVAL.LE.0.) THEN
              CALL TV('Please try again:')
              GO TO 17
            END IF
          ELSE
C           no attenuation.
            XNDVAL=1.0
          END IF
C         Write value to table.
          CALL TBEWRR(ITBL, NSLOT, KND, XNDVAL,  ISTAT)
          IF (ISTAT.NE.0) THEN
                CALL TERROR(ITBL,18,'Could not write to NDVALUE Column')
          ENDIF
        END IF
   18 CONTINUE
C
C      Check table:
C
      CALL READT(ITBL)
C
   20 CONTINUE
      CALL ASK('Is this correct?',REPLY)
C
      IF(REPLY(:1) .EQ. 'Y')THEN
        CALL TVN('Thanks for checking.')
      ELSEIF(REPLY(:1) .EQ. 'N')THEN
        CALL TV('Please correct the table.')
        GOTO 11
      ELSE
        CALL TV('Please answer yes, no, or quit.')
        GOTO 20
      ENDIF
C
      INQUIRE (FILE=INSTRTBL, EXIST=FEXIST)
      IF (.NOT.FEXIST) THEN
C       not found, so add suffix:
        WRITE (ALTNAME,'(A80)') INSTRTBL//'.tbl'
        INSTRTBL=ALTNAME
      ENDIF
C
C     ------
      ELSE IF (NFCDFS.GT.1) THEN
C     ------
C                Multiple filter-code FIELDS:
   21 CONTINUE
      CALL TV('In answering the next question, note that DARK and')
      CALL TVN('ND positions must be counted in the total number of')
      CALL TVN('band codes.')
      CALLASK('How many band or filter positions do you measure?',REPLY)
      READ (REPLY,'(I2)', ERR=21) NSLOTS
C
      IF (NSLOTS.GT.MXSLOT) THEN
        CALL SPACE
         CALL TV('Sorry -- too many possibilities.  Increase Parameter')
        CALL TVN('MXSLOT in incr.for and recompile.')
        CALL TERROR(ITBL,21,'Too many filter positions.')
      END IF
C
      IF (NDETS.GT.1) THEN
        CALL SPACE2
        CALLTV('If one filter-code field goes only with one detector,')
        CALL TVN('and another filter code goes with another detector,')
        CALL TVN('enter "any" for the filter code in the irrelevant')
        CALL TVN('filter code field for a given passband.')
      END IF
C
      MAXNAME=0
C
      DO 29 NSLOT=1,NSLOTS
        CALL SPACE2
        WRITE(C80,
     1 '(''Which is the STANDARD NAME of band number '',I2,'' ?'')')
     2     NSLOT
   22   CALL ASKFIL(C80,BAND)
        IF (HELP(BAND)) THEN
                CALL BNDHLP
                GO TO 22
        ENDIF
        CALL TBEWRI(ITBL, NSLOT, KNBAND, NSLOT,  ISTAT)
        IF (ISTAT.NE.0) THEN
                CALL TERROR(ITBL,22,'Could not write to NBAND Column')
        ENDIF
        CALL TBEWRC(ITBL, NSLOT, KBAND, BAND,  ISTAT)
        IF (ISTAT.NE.0) THEN
                CALL TERROR(ITBL,22,'Could not write to BAND Column')
        ENDIF
C
        DO 23 NFILT=1,NFCDFS
          WRITE(C80,
     1  '(''         What is the CODE for '',A,'' in field'',I2,''?'')')
     2                            BAND(:LWORD(BAND)),     NFILT
          CALL ASKFIL(C80,CODE)
          CALL TBEWRC(ITBL, NSLOT, KFLTCD(NFILT), CODE,  ISTAT)
          IF (ISTAT.NE.0) THEN
            WRITE(C80,
     1        '(''Could not write to FILTCODE_'',I1,'' COLUMN'')') NFILT
            CALLTERROR(ITBL,23,C80)
          ENDIF
   23   CONTINUE
C
        IF (HASND) THEN
C         Get XNDVAL.
          IF (LWORD(BAND).GT.2 .AND.
     1        (INDEX(BAND,'ND').EQ.LWORD(BAND)-1 .OR.
     2         INDEX(BAND,'ND').EQ.LWORD(BAND)-2) ) THEN
   24       CALL TV(
     1         'What is the attenuation factor of this neutral filter?')
            CALL TVN('   (enter 1.0 if no attenuation.)')
            CALL QF('?', XNDVAL)
            IF (XNDVAL.GT.0. .AND. XNDVAL.LT.1.) THEN
              CALL TV('Program expects a value GREATER than unity.')
              XNDVAL=1./XNDVAL
              WRITE(C80,'(F8.3,'' will be used.  OK?'')') XNDVAL
              CALL ASK(C80,REPLY)
              IF (MATCH(REPLY,'YES') .OR. MATCH(REPLY,'OK')) THEN
              ELSE
                CALL TV(BAND)
                GO TO 24
              END IF
            ELSE IF (XNDVAL.LE.0.) THEN
              CALL TV('   Please try again:')
              GO TO 24
            END IF
          ELSE
C           no attenuation.
            XNDVAL=1.0
          END IF
C         Write value to table.
          CALL TBEWRR(ITBL, NSLOT, KND, XNDVAL,  ISTAT)
          IF (ISTAT.NE.0) THEN
                CALL TERROR(ITBL,24,'Could not write to NDVALUE Column')
          ENDIF
        END IF
C
C       Detector names:
C
C       variable DTNAM(n)      holds name of detector #n.
C       variable DETNAM(nband) holds name of detector for n-th band.
C
C       column DETNAME         holds name of det. for n-th band in row NSLOT.
C
   25 IF (NDETS.GT.1) THEN
          IF (MAXNAME.GT.1) THEN
              CALL TV('   Known detector names are:')
              CALL SPACE
              DO 26 NUMNAME=1,MAXNAME
                WRITE(C80,'(I10,'':  '',A)') NUMNAME,DTNAM(NUMNAME)
                CALL TVN(C80)
   26         CONTINUE
              CALL TV('(use one of these names, or a new name)')
              CALL TVN('(If you make a mistake, enter GO BACK )')
              CALL SPACE
          END IF
          WRITE(C80,
     1      '(''Which DETECTOR (name) is used to measure '',A,''?'')')
     2             BAND(:LWORD(BAND))
          CALL ASKFIL(C80,DETNAM(NSLOT))
          IF(DETNAM(NSLOT).EQ.'GO BACK') GO TO 21
C       Do I know you?
          DO 27 NUMNAME=1,MAXNAME
C       Yes. Old name:
              IF(DETNAM(NSLOT).EQ.DTNAM(NUMNAME)) GO TO 28
   27     CONTINUE
C       No. New name:
          MAXNAME=MAXNAME+1
          IF (MAXNAME.GT.NDETS) THEN
              CALL SPACE2
              CALL TV('Oops!  More detector names than detectors!')
              CALL SPACE
              CALL TV('Do you want to:')
              CALL SPACE
              CALL TV('    1:  Start over, or')
              CALL TV('    2:  Correct that last name')
              CALL SPACE
              CALL ASK('?',REPLY)
              CALL SPACE
              IF (REPLY(:1).EQ.'1' .OR. MATCH(REPLY,'START')) THEN
                 GO TO 21
              ELSE IF (REPLY(:1).EQ.'2' .OR. MATCH(REPLY,'CORRECT'))THEN
                 GO TO 25
              ELSE
                 CALL TV('Please try again from the beginning:')
                 GO TO 21
              END IF
          ELSE IF (MAXNAME.GT.MXDETS) THEN
              CALL TV('Too many detectors.  Increase parameter')
              CALL TVN('MXDETS in instr.for and recompile.')
              CALL TERROR(ITBL,27,'Parameter MXDETS exceeded.')
          END IF
          DTNAM(MAXNAME)=DETNAM(NSLOT)
          NUMNAME=MAXNAME
          CALL TBEWRC (ITBL, NUMNAME, KDETNM, DETNAM(NSLOT),  ISTAT)
          IF (ISTAT.NE.0) THEN
                CALL TERROR(ITBL,28,'Could not write to DETNAME Column')
          ENDIF
C       Name known here:
   28     CONTINUE
          CALL TBEWRI (ITBL, NSLOT, KNDETU, NUMNAME,  ISTAT)
          IF (ISTAT.NE.0) THEN
               CALL TERROR(ITBL,29,'Could not write to NDETUSED Column')
          ENDIF
      END IF
   29 CONTINUE
C
C     ------
      ELSE IF (NFCDFS.EQ.0) THEN
C     ------
C               No filter codes in data.
C
C     Just make NBAND, BAND, and NDETUSED columns.
C
        NSLOTS=NDETS
C
   30 CONTINUE
      DO 32 NSLOT=1,NSLOTS
        IF (NSLOT.LE.9)THEN
            WRITE (C80,'(A41,I1,''?'')')
     1        '    What is the passband NAME in channel ',NSLOT
        ELSE
            WRITE (C80,'(A41,I2,''?'')')
     1        '    What is the passband NAME in channel ',NSLOT
        ENDIF
        CALL ASKFIL (C80, BAND)
        IF (HELP(BAND)) THEN
            CALL BNDHLP
            GO TO 30
        ENDIF
        CALL TBEWRI(ITBL, NSLOT, KNBAND, NSLOT,  ISTAT)
        IF (ISTAT.NE.0) THEN
                CALL TERROR(ITBL,31,'Could not write to NBAND Column')
        ENDIF
        CALL TBEWRC(ITBL, NSLOT, KBAND, BAND,  ISTAT)
        IF (ISTAT.NE.0) THEN
                CALL TERROR(ITBL,32,'Could not write to BAND Column')
        ENDIF
        CALL TBEWRI (ITBL, NSLOT, KNDETU, NUMNAME,  ISTAT)
        IF (ISTAT.NE.0) THEN
            CALL TERROR(ITBL,33,'Could not write to NDETUSED Column')
        ENDIF
   32 CONTINUE
C
C      Check table:
C
      CALL READT(ITBL)
C
C
C     ------
      ELSE
C     ------
C
          CALL TV('No negative value makes sense!')
          GO TO 10
C
C     ------
      END IF
C     ------
C
C     If we get here, table is OK.  Add descriptors.
C
      CALL STDWRC (ITBL,'INSTNAM',1,INSTNAM, 1, 72, IUNIT,  ISTAT)
      IF (ISTAT.NE.0) THEN
          CALL TERROR(ITBL,34,'Could not write descriptor INSTNAM')
      END IF
      CALL STDWRC (ITBL,'FILTSTAT',1,'         ', 1, 9, IUNIT,  ISTAT)
      IF (ISTAT.NE.0) THEN
          CALL TERROR(ITBL,35,'Could not write descriptor FILTSTAT')
      END IF
      CALL STDWRC (ITBL,'CONDITION',1,'       ', 1, 7, IUNIT, ISTAT)
      IF (ISTAT.NE.0) THEN
          CALL TERROR(ITBL,36,'Could not write descriptor CONDITION')
      END IF
C
C     make required detector columns.
C
      CALL TBCINI(ITBL,D_I1_FORMAT,1,'I5',' ','NDET',KNDET,ISTAT)
      IF (ISTAT.NE.0) THEN
            CALL TERROR(ITBL,38,'Could not create NDET column')
      ENDIF
      CALL TBCINI (ITBL, D_C_FORMAT, 8, 'A8', ' ', 'DET',KDET,  ISTAT)
      IF (ISTAT.NE.0) THEN
            CALL TERROR(ITBL,39,'Could not create DET column')
      ENDIF
      CALL TBCINI (ITBL, D_C_FORMAT, 12, 'A12', ' ', 'COOLING',
     1                 KCOOL, ISTAT)
      IF (ISTAT.NE.0) THEN
            CALL TERROR(ITBL,40,'Could not create COOLING column')
      ENDIF
C
   40 CONTINUE
      CALL SPACE2
      CALL ASK('Do you have a catalog of filter curves?',REPLY)
      IF(REPLY(:1) .EQ. 'Y')THEN
        CALL ASKFIL('What is the name of the catalog?',FILTCAT)
        CALL STDWRC (ITBL, 'FILTCAT',1,FILTCAT, 1, 80, IUNIT,  ISTAT)
        IF (ISTAT.NE.0) THEN
            CALL TERROR(ITBL,40,'Could not write descriptor FILTCAT')
        END IF
      ELSEIF(REPLY(:1) .EQ. 'N') THEN
        CALL STDWRC (ITBL, 'FILTCAT',1,' ', 1, 80, IUNIT,  ISTAT)
        IF (ISTAT.NE.0) THEN
            CALL TERROR(ITBL,41,'Could not write descriptor FILTCAT')
        END IF
      ELSE
        CALL TV('Please answer yes or no.')
        GOTO 40
      ENDIF
C
      CALL SPACE2
   42 CONTINUE
      CALL ASK('Is the filter temperature CONTROLLED?',REPLY)
      IF (REPLY(:1) .EQ. 'Y') THEN
        CALL STDWRC (ITBL,'FILTSTAT',1,'REGULATED', 1, 9, IUNIT,  ISTAT)
        IF (ISTAT.NE.0) THEN
            CALL TERROR(ITBL,42,'Could not write descriptor FILTSTAT')
        END IF
   44   CALL ASK('At what value (please include K, C, or F): ?',REPLY)
   45   IF (INDEX(REPLY,'C').GT.0) THEN
            KOLS=INDEX(REPLY,'C')-1
            WRITE(FMT,'(''(BN,F'',I1,''.0)'')') KOLS
            READ(REPLY(:KOLS),FMT) TEMP
            TEMP=TEMP+273.15
            WRITE(C80,'(''   That''''s'',F6.1,'' K'')') TEMP
            CALL TV(C80)
        ELSE IF (INDEX(REPLY,'K').GT.0) THEN
            KOLS=INDEX(REPLY,'K')-1
            WRITE(FMT,'(''(BN,F'',I1,''.0)'')') KOLS
            READ(REPLY(:KOLS),FMT) TEMP
        ELSEIF (INDEX(REPLY,'F').GT.0) THEN
            KOLS=INDEX(REPLY,'F')-1
            WRITE(FMT,'(''(BN,F'',I1,''.0)'')') KOLS
            READ(REPLY(:KOLS),FMT) TEMP
            TEMP=(5./9.)*(TEMP+40.)+273.15-40.
            WRITE(C80,'(''   That''''s'',F6.1,'' K'')') TEMP
            CALL TV(C80)
        ELSE
            READ(REPLY,'(F8.0)', ERR=44) TEMP
            CALL ASK('Is that degrees Kelvin?',REPLY)
            IF (REPLY(:1).EQ.'Y') THEN
C               we are OK.
            ELSE IF (REPLY(:1).EQ.'C' .OR. REPLY(:1).EQ.'F')THEN
                FMT=REPLY(:1)
                WRITE(REPLY,'(F5.1,A1)') TEMP,FMT
                GO TO 45
            ELSE
                CALL TV('Please re-enter your response, specifying')
                CALL TVN('the temperature scale:')
                 GO TO 44
            END IF
        ENDIF
C       Temp. is now available, deg.K.
        CALL STDWRR (ITBL, 'FILTTEMP', TEMP, 1, 1, IUNIT,  ISTAT)
        IF (ISTAT.NE.0) THEN
            CALL TERROR(ITBL,47,'Could not write descriptor FILTTEMP')
        END IF
      ELSEIF (REPLY(:1) .EQ. 'N') THEN
        CALL TV('No filter temperature regulation.')
   48   CONTINUE
        CALL ASK('Is the filter temperature MEASURED?',REPLY)
        IF (REPLY(:1) .EQ. 'Y') THEN
            CALL STDWRC (ITBL,'FILTSTAT',1,'MEASURED', 1, 9, IUNIT,
     1                   ISTAT)
            IF (ISTAT.NE.0) THEN
                CALL TERROR(ITBL,48,'Could not write descriptor FILTSTAT
     1')
            END IF
        ELSEIF (REPLY(:1) .EQ. 'N') THEN
            CALL STDWRC (ITBL, 'FILTSTAT',1,'DOME', 1, 9, IUNIT,
     1                   ISTAT)
            IF (ISTAT.NE.0) THEN
            CALL TERROR(ITBL,49,'Could not write descriptor FILTSTAT')
            END IF
            CALL TV('No filter temperature measurements.')
            CALL TVN('Assume filters are at ambient temperature.')
        ELSE
            CALL TV('Please answer yes or no.')
            GOTO 48
        ENDIF
      ELSE
        CALL TV('Please answer yes or no.')
        GOTO 42
      ENDIF
C
C               *****  END Filters;  BEGIN Detectors  *****
C
      DO 78 NDET=1,NDETS
      CALL TBEWRI (ITBL, NDET, KNDET, NDET,  ISTAT)
      IF (ISTAT.NE.0) THEN
           CALL TERROR(ITBL,49,'Could not write to column NDET')
      END IF
      CALL SPACE2
   50 CONTINUE
C
C     Detector names:
C
C       variable DTNAM(n)      holds name of detector #n.
C       variable DETNAM(nband) holds name of detector for n-th band.
C
C       column DETNAME         holds name of det. for n-th band in row NSLOT.
C
      IF (NDETS.EQ.1) THEN
          CALL TV('What kind of DETECTOR is used?')
      ELSE
          WRITE(C80,'(''What kind of DETECTOR is used in channel'',
     +          I2,'' ('',A,'')?'')') 
     +          NDET, DTNAM(NDET)(:LWORD(DTNAM(NDET)))
          CALL TV(C80)
      END IF
C
      CALL TV('       Photomultiplier (PMT)')
      CALL TV('       Silicon diode or CCD')
      CALL TV('       Other')
      CALL ASK('?',REPLY)
C
C                               ******  BEGIN  If-block for DET  ******
C     ***
      IF (REPLY(:1) .EQ. 'P') THEN
C     ***
C                              *** DET = PMT ***
C
        CALL TBEWRC (ITBL, NDET, KDET, 'PMT',  ISTAT)
        IF (ISTAT.NE.0) THEN
            CALL TERROR(ITBL,27,'Could not write to DET column')
        ENDIF
C
   52   CONTINUE
C       see if columns exist; if not, create them.
        CALL TBLSER (ITBL, 'SNUMBER',  KSNUMB, ISTAT)
        IF (ISTAT.NE.0) THEN
            CALL TERROR(ITBL,52,'Could not find column SNUMBER')
        END IF
        IF (KSNUMB.EQ.-1) THEN
          CALL TBCINI (ITBL, D_C_FORMAT, 9, 'A9', ' ', 'SNUMBER',
     1                 KSNUMB, ISTAT)
          IF (ISTAT.NE.0) THEN
                CALL TERROR(ITBL,54,'Could not create SNUMBER column')
          ENDIF
        END IF
        CALL TBLSER (ITBL, 'MODE',  KMODE, ISTAT)
        IF (ISTAT.NE.0) THEN
            CALL TERROR(ITBL,52,'Could not find column SMODE')
        END IF
        IF (KMODE.EQ.-1) THEN
          CALL TBCINI (ITBL, D_C_FORMAT, 9, 'A9', ' ', 'MODE',
     1                 KMODE, ISTAT)
          IF (ISTAT.NE.0) THEN
                CALL TERROR(ITBL,55,'Could not create MODE column')
          ENDIF
        END IF
C
        CALL TV
     2     ('Please enter the S-type or cathode type, if known; e.g.:')
        CALL SPACE
        CALL  TV
     2     ('   Entry    (examples)')
        CALL TVN
     2     ('   -----    ----------')
        CALL  TV
     2     ('   S-4      (1P21)')
        CALL  TV
     2     ('   S-11     (EMI 9502; Cs-Sb end-on cathode on glass)')
        CALL  TV
     2     ('   S-13     (EMI 6256; Cs-Sb end-on cathode on quartz)')
        CALL  TV
     2     ('   BIALKALI (EMI 9789; use QBIALKALI if quartz window)')
        CALL  TV
     2     ('   S-20     (trialkali)')
        CALL  TV
     2     ('   GaAs     (RCA or Hammamatsu)')
        CALL SPACE
        CALL  ASK
     2     ('(please enter S-4, BIALKALI, GaAs, QGaAs, etc.)',SNUMBER)

C       Fix up common error:
        IF (SNUMBER(:1) .EQ. 'S' .AND. SNUMBER(2:2) .NE. '-') THEN
C           Insert missing hyphen.
            C80=SNUMBER(2:8)
            SNUMBER(3:)=C80
            SNUMBER(2:2)='-'
        ENDIF
C
C       write table column.
        CALL TBEWRC (ITBL, NDET, KSNUMB, SNUMBER,  ISTAT)
        IF (ISTAT.NE.0) THEN
            CALL TERROR(ITBL,58,'Could not write column SNUMBER')
        END IF
        C80='    response adopted: '//SNUMBER
        CALL TV(C80)
   60   CONTINUE
        CALL ASK('Is this correct?',REPLY)
C
        IF (REPLY(:1) .EQ. 'Y') THEN
        ELSEIF (REPLY(:1) .EQ. 'N') THEN
            GOTO 52
        ELSE
             GOTO 60
        ENDIF
C
   62   CONTINUE
        C80='What mode of operation is used for '//DTNAM(NDET)
        NFC=LWORD(C80)+1
        C80(NFC:)='?'
        CALL TV(C80)
        CALL TV('      Enter  for....')
        CALL TVN('      -----  -------')
        CALL TV('       DC    DC operation')
        CALL TV('       CI    Charge Integration')
        CALL TV('       PC    Pulse Counting')
        CALL SPACE
        CALL ASK('?',REPLY)
C
        IF (REPLY(:1) .EQ. 'P') THEN
C
C              Pulse-counting:
C
            MODE='PC'
C           use table column.
            CALL TBEWRC (ITBL, NDET, KMODE, MODE(:2),  ISTAT)
            IF (ISTAT.NE.0) THEN
                CALL TERROR(ITBL,63,'Could not write column MODE')
            END IF
C
            CALL TBLSER (ITBL, 'DEADTYPE',  KDEDTYP, ISTAT)
            IF (ISTAT.NE.0) THEN
                CALL TERROR(ITBL,52,'Could not find column DEADTYPE')
            END IF
            IF (KDEDTYP.EQ.-1) THEN
                CALL TBCINI (ITBL, D_C_FORMAT,12,'A12', ' ', 'DEADTYPE',
     1                 KDEDTYP, ISTAT)
                IF (ISTAT.NE.0) THEN
                  CALLTERROR(ITBL,64,'Could not create DEADTYPE column')
                ENDIF
            END IF
C
            CALL TBLSER (ITBL, 'DEADTIME',  KDEDTM, ISTAT)
            IF (ISTAT.NE.0) THEN
                CALL TERROR(ITBL,52,'Could not find column DEADTIME')
            END IF
            IF (KDEDTM.EQ.-1) THEN
                CALL TBCINI (ITBL, D_R4_FORMAT, 1,'E8.3',' ','DEADTIME',
     1                 KDEDTM, ISTAT)
                IF (ISTAT.NE.0) THEN
                  CALLTERROR(ITBL,64,'Could not create DEADTIME column')
                ENDIF
            END IF
C
            CALL TBLSER (ITBL, 'DEADTIMEERROR',  KDEDER, ISTAT)
            IF (ISTAT.NE.0) THEN
              CALL TERROR(ITBL,52,'Could not find column DEADTIMEERROR')
            END IF
            IF (KDEDER.EQ.-1) THEN
                CALL TBCINI(ITBL,D_R4_FORMAT,1,'E13.2',' ',
     1                                  'DEADTIMEERROR',
     2                 KDEDER, ISTAT)
                IF (ISTAT.NE.0) THEN
                    CALL TERROR(ITBL,64,
     1                        'Could not create DEADTTIMEERROR column')
                ENDIF
            END IF
C
   64       CONTINUE
            C80='Do you know the type of dead time for '//DTNAM(NDET)
            NFC=LWORD(C80)+1
            C80(NFC:)='?'
            CALL TV(C80)
            CALL TV('      Enter    if...')
            CALL TVN('      -----    -----')
            CALL TV('    EXTENDING  paralysable counter')
            CALL TV('  NONEXTENDING non-paralysable counter')
            CALL TV('     UNKNOWN   you don''t know which it is')
            CALL ASK('?',REPLY)
C
            IF (REPLY(:1) .EQ. 'E' .OR. REPLY(:1) .EQ. 'X') THEN
                DEDTYP='EXTENDING'
            ELSEIF (REPLY(:1) .EQ. 'N') THEN
                DEDTYP='NONEXTENDING'
            ELSEIF (REPLY(:1) .EQ. 'U') THEN
                DEDTYP='UNKNOWN'
            ELSE IF (HELP(REPLY)) THEN
                CALL TV('See R.D.Evans''s book "The Atomic Nucleus"')
                CALL TVN('for a good explanation.')
                GO TO 64
            ELSE
                CALL TV(
     1              'Please enter EXTENDING, NONEXTENDING, or UNKNOWN.')
                GOTO 64
            ENDIF
C
            CALL TBEWRC (ITBL, NDET, KDEDTYP, DEDTYP, ISTAT)
            IF (ISTAT.NE.0) THEN
                CALL TERROR(ITBL,65,'Could not write column DEADTYPE')
            END IF
C
            IF (MATCH(SNUMBER,'GAAS')) THEN
                RATEMX=0.4
            ELSE
                RATEMX=2.
            END IF
C           Max. counting rate in MHz.
            CALL SETDED(RATEMX, DEDTIM,DEDERR)
C
            CALL TBEWRR (ITBL, NDET, KDEDTM, DEDTIM, ISTAT)
C
            CALL TBEWRR (ITBL, NDET, KDEDER, DEDERR, ISTAT)
C
        ELSEIF (REPLY(:1) .EQ.'D') THEN
C
C           DC mode:
            MODE='DC'
C
        ELSEIF (REPLY(:1) .EQ.'C') THEN
C
C           Charge-integration:
            MODE='CI'
C
        ELSE
C
            CALL TV('Please enter DC, PC, or CI.')
            GOTO 62
C
        ENDIF
C
        IF(MODE.NE.'PC') THEN
             CALL TBEWRC (ITBL, NDET, KMODE, MODE,  ISTAT)
        ENDIF
C
C
C     ***
      ELSEIF (REPLY(:1) .EQ. 'S' .OR. REPLY(:1) .EQ. 'C') THEN
C     ***
C                       *** DET = SILICON ***
C
        CALL TBEWRC (ITBL, NDET, KDET, 'SILICON',  ISTAT)
        CCD=.TRUE.
        GO TO 69
C
C     ***
      ELSEIF (REPLY(:1) .EQ. 'O') THEN
C     ***
C                       *** DET = OTHER ***
C
        CALL TBEWRC (ITBL, NDET, KDET, 'OTHER',  ISTAT)
        IF (ISTAT.NE.0) THEN
            CALL TERROR(ITBL,68,'Could not write to DET column')
        ENDIF
        CCD=.FALSE.
        GO TO 69
C
C     ***
      ELSE
C     ***
        CALL TV('Please reply either PMT, Si or CCD, or OTHER')
        GOTO 50
C
C     ***
      ENDIF
C     ***                       ******  END  If-block for DET  ******
      GO TO 72
C
C               ----  BEGIN Special block for non-PMT detectors  ---
   69 CONTINUE
      CALL ASKFIL('Do you have a spectral-response table?',SPRTBL)
C
      IF (MATCH(SPRTBL,'YES') .OR. MATCH(SPRTBL,'yes')) THEN
         CALL ASKFIL('WHAT IS THE NAME OF THE SPECTRAL-RESPONSE TABLE?',
     1              SPRTBL)
         CALL TBLSER (ITBL, 'SPECTRESPTBL',  KSPRTBL, ISTAT)
         IF (ISTAT.NE.0) THEN
               CALL TERROR(ITBL,52,'Could not find column SPECTRESPTBL')
         END IF
         IF (KSPRTBL.EQ.-1) THEN
             CALL TBCINI (ITBL, D_C_FORMAT,12,'A12', ' ','SPECTRESPTBL',
     1                 KSPRTBL, ISTAT)
             IF (ISTAT.NE.0) THEN
                  CALLTERROR(ITBL,71,
     1                          'Could not create SPECTRESPTBL column')
             ENDIF
         END IF
         CALL TBEWRC (ITBL, NDET, KSPRTBL, SPRTBL,  ISTAT)
         IF (ISTAT.NE.0) THEN
             CALL TERROR(ITBL,71,
     1                'Could not write column SPECTRESPTBL')
         END IF
C
      ELSE IF (MATCH(SPRTBL,'NO') .OR. MATCH(SPRTBL,'no')) THEN
   71   IF (CCD) THEN
            CALL TV('Then, indicate the approximate spectral response:')
            CALL TV('     Enter    if...')
            CALL TVN('     -----    -----')
            CALL TV('    ENHANCED  blue-enhanced CCD or Si diode')
            CALL TV('    PHOSPHOR  phosphor-coated CCD')
            CALL TV('      FRONT   front-side illuminated CCD or diode')
            CALL TV('      BACK    back-side illuminated thinned CCD')
            CALL ASK('?',REPLY)
C
            IF (REPLY(:1).EQ.'E') THEN
C               blue-enhanced.
                REPLY='ENHANCED'
            ELSE IF (REPLY(:1).EQ.'P') THEN
C               Phosphor-coated.
                REPLY='PHOSPHOR'
            ELSE IF (REPLY(:1).EQ.'F') THEN
C               Front (normal) Si detector.
                REPLY='FRONT'
            ELSE IF (REPLY(:1).EQ.'B') THEN
C               Back-side, thinned CCD.
                REPLY='BACK'
            ELSE
                CALL TV('Please enter 1 of the 4 words in caps.')
                GO TO 71
            END IF
C
            CALL TBLSER (ITBL, 'BLUERESP',  KBLURSP, ISTAT)
            IF (ISTAT.NE.0) THEN
                  CALL TERROR(ITBL,72,'Could not find column BLUERESP')
            END IF
            IF (KBLURSP.EQ.-1) THEN
                CALL TBCINI (ITBL, D_C_FORMAT,12,'A12', ' ', 'BLUERESP',
     1                 KBLURSP, ISTAT)
                IF (ISTAT.NE.0) THEN
                  CALLTERROR(ITBL,72,'Could not create BLUERESP column')
                ENDIF
            END IF
                CALL TBEWRC (ITBL, NDET, KBLURSP, REPLY,  ISTAT)
                IF (ISTAT.NE.0) THEN
                    CALL TERROR(ITBL,72,
     1                   'Could not write column BLUERESP')
                END IF
C
        END IF
C
      ELSE
C        assume entry is table name:
         CALL TBLSER (ITBL, 'SPECTRESPTBL',  KSPRTBL, ISTAT)
         IF (ISTAT.NE.0) THEN
               CALL TERROR(ITBL,72,'Could not find column SPECTRESPTBL')
         END IF
         IF (KSPRTBL.EQ.-1) THEN
             CALL TBCINI (ITBL, D_C_FORMAT,12,'A12', ' ','SPECTRESPTBL',
     1                 KSPRTBL, ISTAT)
             IF (ISTAT.NE.0) THEN
                  CALLTERROR(ITBL,72,
     1                          'Could not create SPECTRESPTBL column')
             ENDIF
         END IF
         CALL TBEWRC (ITBL, NDET, KSPRTBL, SPRTBL,  ISTAT)
         IF (ISTAT.NE.0) THEN
             CALL TERROR(ITBL,72,
     1                'Could not write column SPECTRESPTBL')
         END IF
C
      END IF
C
C               ----  END Special block for non-PMT detectors  ---
C
C
   72 CONTINUE
      C80='  We next need information on '//DTNAM(NDET)
      NFC=LWORD(C80)+1
      C80(NFC:)=' COOLING:'
      CALL TV(C80)
      CALL SPACE
      CALL TV('       Enter    if...')
      CALL TV('       -----    -----')
      CALL TV('     REGULATED  actively controlled')
      CALL TV('    UNREGULATED cooled, but not controlled')
      CALL TV(
     1'      DRYICE    cooled with solid CO2, no heat-transfer fluid')
      CALL TV('        ICE     cooled with water ice')
      CALLTV('     MEASURED   temperature measured, but not controlled')
      CALL TV(
     1'       NONE     ambient temperature, detector not measured')
      CALL SPACE
      CALL ASK('(Please see the Appendix for details):',REPLY)
C
      CALL TBLSER (ITBL, 'COOLING',  KCOOL, ISTAT)
      IF (ISTAT.NE.0) THEN
               CALL TERROR(ITBL,72,'Could not find column COOLING')
      END IF
C
      IF (REPLY(:1) .EQ. 'R') THEN
        COOLING='REGULATED'
   74   CALL ASK('At what value (please include K, C, or F): ?',REPLY)
   75   IF (INDEX(REPLY,'C').GT.0) THEN
            KOLS=INDEX(REPLY,'C')-1
            WRITE(FMT,'(''(BN,F'',I1,''.0)'')') KOLS
            READ(REPLY(:KOLS),FMT) TEMP
            TEMP=TEMP+273.15
            WRITE(C80,'(''   That''''s'',F6.1,'' K'')') TEMP
            CALL TV(C80)
        ELSE IF (INDEX(REPLY,'K').GT.0) THEN
            KOLS=INDEX(REPLY,'K')-1
            WRITE(FMT,'(''(BN,F'',I1,''.0)'')') KOLS
            READ(REPLY(:KOLS),FMT) TEMP
        ELSEIF (INDEX(REPLY,'F').GT.0) THEN
            KOLS=INDEX(REPLY,'F')-1
            WRITE(FMT,'(''(BN,F'',I1,''.0)'')') KOLS
            READ(REPLY(:KOLS),FMT) TEMP
            TEMP=(5./9.)*(TEMP+40.)+273.15-40.
            WRITE(C80,'(''   That''''s'',F6.1,'' K'')') TEMP
            CALL TV(C80)
        ELSE
            READ(REPLY,'(F8.0)', ERR=74) TEMP
            CALL ASK('Is that degrees Kelvin?',REPLY)
            IF (MATCH(REPLY,'YES')) THEN
C               we are OK.
            ELSE IF (REPLY(:1).EQ.'C' .OR. REPLY(:1).EQ.'F')THEN
                FMT=REPLY(:1)
                WRITE(REPLY,'(F5.1,A1)') TEMP,FMT
                GO TO 75
            ELSE
                CALL TV('Please re-enter your response, specifying')
                CALL TVN('the temperature scale:')
                GO TO 74
            END IF
        ENDIF
C       Temp. is now available, deg.K.
        CALL TBLSER (ITBL, 'DETTEMP',  KDTEMP, ISTAT)
        IF (ISTAT.NE.0) THEN
               CALL TERROR(ITBL,76,'Could not find column DETTEMP')
        END IF
        IF (KDTEMP.EQ.-1) THEN
             CALL TBCINI (ITBL, D_R4_FORMAT,1,'F7.1', ' ', 'DETTEMP',
     1                 KDTEMP, ISTAT)
             IF (ISTAT.NE.0) THEN
                  CALLTERROR(ITBL,76,
     1                          'Could not create DETTEMP column')
             ENDIF
        END IF
        CALL TBEWRR (ITBL, NDET, KDTEMP, TEMP, ISTAT)
        IF (ISTAT.NE.0) THEN
            CALL TERROR(ITBL,76,'Could not write column DETTEMP')
        END IF
      ELSEIF (REPLY(:1) .EQ. 'U') THEN
         COOLING='UNREGULATED'
      ELSEIF (REPLY(:1) .EQ. 'D') THEN
         COOLING='DRYICE'
      ELSEIF (REPLY(:1) .EQ. 'I') THEN
         COOLING='ICE'
      ELSEIF (REPLY(:1) .EQ. 'M') THEN
         COOLING='MEASURED'
      ELSEIF (REPLY(:1) .EQ. 'N') THEN
         COOLING='NONE'
      ELSE
        CALL TV('Please select one of the entries above.')
        GOTO 72
      ENDIF
C
      CALL TBEWRC (ITBL, NDET, KCOOL, COOLING,  ISTAT)
      IF (ISTAT.NE.0) THEN
             CALL TERROR(ITBL,77,
     1                'Could not write column COOLING')
      END IF
C
   78 CONTINUE
C
C               *****  END Detectors; BEGIN Redleaks  *****
C
C
      CALL SPACE2
      CALL TV('          Now for RED LEAK information...')
      CALL TBCINI (ITBL, D_C_FORMAT, 8, 'A8', ' ', 'REDLEAK',
     1               KRL, ISTAT)
        IF (ISTAT.NE.0) THEN
                CALL TERROR(ITBL,79,'Could not create REDLEAK Column')
        ENDIF
      CALL TBCINI (ITBL, D_C_FORMAT, 8, 'A8', ' ', 'RLTYPE',
     1               KRLTYP, ISTAT)
        IF (ISTAT.NE.0) THEN
                CALL TERROR(ITBL,79,'Could not create RLTYPE Column')
        ENDIF
      CALL TBCINI (ITBL, D_C_FORMAT, 8, 'A8', ' ', 'MAKER',
     1               KMAKER, ISTAT)
        IF (ISTAT.NE.0) THEN
                CALL TERROR(ITBL,79,'Could not create MAKER Column')
        ENDIF
      DO 90 NSLOT = 1, NSLOTS
        CALL SPACE
        CALL TBERDC(ITBL, NSLOT, KBAND, CTEST, NULL, ISTAT)
        CALL FT_EOS (CTEST,8,BAND,ISTAT)
C
        IF ( (INDEX(BAND,'RL').EQ.(LWORD(BAND)-1) .AND.
     1                                            INDEX(BAND,'RL').GT.0)
     2            .OR. BAND(:4).EQ.'DARK')THEN
            C80='   skipping band '//BAND(:LWORD(BAND))//'...'
            CALL TV(C80)
            RLSIZE=0.
        ELSE
            C80='   looking at band '//BAND(:LWORD(BAND))//'...'
            CALL TV(C80)
C          There should be some stuff here to decide whether the leak is
C          big enough to worry about.....
C          For now, force treatment for every band:
            RLSIZE = 0.01
        END IF
C
        IF (RLSIZE .GT. 0.0001) THEN
            C80='How do you treat the red leak in '//BAND(:LWORD(BAND))
     1                   //'?'
            CALL TV(C80)
   80       CONTINUE
            CALL ASK('(Enter MEASURED, BLOCKED, or IGNORED):',REPLY)
            IF (REPLY(:1) .EQ. 'M') THEN
                CALL TBEWRC(ITBL, NSLOT, KRL, 'MEASURED',  ISTAT)
   82           CONTINUE
                CALL SPACE2
                CALL TV('How is the leak filter constructed?')
                CALL TV('       Enter   if...')
                CALL TVN('       -----   -----')
              CALLTV('      CEMENTED  components are cemented together')
                CALL TV('       LOOSE    components are not cemented')
                CALL TV('      UNKNOWN   you don''t know which')
                CALL ASK('?',REPLY)
C
                IF (REPLY(:1) .EQ. 'C') THEN
                    CALL TBEWRC(ITBL, NSLOT, KRLTYP, 'CEMENTED', ISTAT)
                ELSEIF (REPLY(:1) .EQ. 'L') THEN
                    CALL TBEWRC(ITBL, NSLOT, KRLTYP, 'LOOSE',  ISTAT)
                ELSEIF (REPLY(:1) .EQ. 'U') THEN
                    CALL TBEWRC(ITBL, NSLOT, KRLTYP, 'UNKNOWN',  ISTAT)
                ELSE
                    CALL TV('Please enter one of the 3 words above.')
                    GOTO 82
                ENDIF
C
C
   83       C80='What glass type is used in the '//BAND(:LWORD(BAND))//
     1      ' red-leak isolator?'
            CALL TV(C80)
                CALL TV('      Enter     if...')
                CALL TVN('      -----     -----')
                CALL TV(
     1            '     SCHOTT     Schott or other glass clear at leak')
                CALL TV(
     1           '     CORNING    Corning or other Pyrex-like absorber')
                CALL TV(
     1            '     UNKNOWN    you don''t know whose glass is used')
                CALL ASK('?',REPLY)
C
                IF (REPLY(:1) .EQ. 'S') THEN
                    CALL TBEWRC(ITBL, NSLOT, KMAKER, 'SCHOTT',  ISTAT)
                ELSEIF (REPLY(:1) .EQ. 'C') THEN
                    CALL TBEWRC(ITBL, NSLOT, KMAKER, 'CORNING',  ISTAT)
                ELSEIF (REPLY(:1) .EQ. 'U') THEN
                    CALL TBEWRC(ITBL, NSLOT, KMAKER, 'UNKNOWN',  ISTAT)
                ELSEIF (HELP(REPLY)) THEN
                    CALL TV('Pyrex absorbs at 700 nm.')
                    GO TO 83
                ELSE
                    CALL TV('Please enter one of the 3 words above.')
                    GOTO 83
                ENDIF
C
            ELSEIF (REPLY(:1) .EQ. 'B') THEN
                CALL TBEWRC(ITBL, NSLOT, KRL, 'BLOCKED',  ISTAT)
            ELSEIF (REPLY(:1) .EQ. 'I') THEN
                CALL TBEWRC(ITBL, NSLOT, KRL, 'IGNORED',  ISTAT)
C       $$$$$ This is temporary fudge until 'RLsize' is set properly:
            ELSEIF (REPLY(:1) .EQ. 'N'  .OR. REPLY(:1) .EQ. 'A') THEN
                CALL TBEWRC(ITBL, NSLOT, KRL, 'ABSENT',  ISTAT)
            ELSE IF (HELP(REPLY)) THEN
                CALL TV('We really should read the spectral-response')
                CALL TVN('data to judge whether a leak is significant.')
                CALL TVN('Until this lapse is corrected, you can reply')
                CALL TVN('ABSENT to indicate no significant leak.')
                GOTO 80
C       $$$$$ End temporary fudge.
            ELSE
                CALL TV('Please enter MEASURED, BLOCKED, or IGNORED.')
                GOTO 80
            ENDIF
        ELSE
C               Redleak does not apply (here if RLSIZE is small.).
                CALL TBEWRC(ITBL, NSLOT, KRL, 'ABSENT',  ISTAT)
        ENDIF
   90 CONTINUE
C
C     Now ask about condition of optics:
C
   92 CONTINUE
      CALL SPACE2
      CALL TV('How dirty are the telescope optics?')
      CALL TV('     Enter   if...')
      CALL TVN('     -----   -----')
      CALL TV('     CLEAN   freshly aluminized or washed within 2 weeks'
     1)
      CALL TV('    AVERAGE  flashlight beam is plainly visible on optics
     1')
      CALL TVN('             (but they don''t look terribly bad)')
      CALL TV('     DIRTY   surfaces look horrible')
      CALL ASK('?',REPLY)
C
      IF (REPLY(:1).EQ.'C') THEN
C       Clean.
        CALL STDWRC (ITBL, 'CONDITION',1,'CLEAN', 1,7, IUNIT,  ISTAT)
      ELSE IF (REPLY(:1).EQ.'A') THEN
C        Average.
        CALL STDWRC (ITBL, 'CONDITION',1,'AVERAGE', 1,7, IUNIT,  ISTAT)
      ELSE IF (REPLY(:1).EQ.'D') THEN
C       Dirty.
        CALL STDWRC (ITBL, 'CONDITION',1,'DIRTY', 1,7, IUNIT,  ISTAT)
      ELSE IF (HELP(REPLY)) THEN
        CALL TV('Say AVERAGE for now, and check on this later.')
        GO TO 92
      ELSE
        CALL TV('Please reply CLEAN, AVERAGE, or DIRTY.')
        GO TO 92
      END IF
      IF (ISTAT.NE.0) THEN
          CALL TERROR(ITBL,92,'Could not write descriptor CONDITION')
      END IF
      CALL TV('Thanks for describing your instrument.  Please check')
      CALL TVN('the table entries for the filters:')
C
C     Check the table:
C
      CALL TV('Final table contents:')
C     READ/TABLE {instrtbl}
      CALL READT(ITBL)
C
   95 CONTINUE
      CALL ASK('Are these values OK?',REPLY)
      IF (MATCH(REPLY,'NO')) THEN
        CALL TBTCLO(ITBL,ISTAT)
        CALL TV('Please re-make the whole table:')
        CALL SPACE2
        GO TO 10
      ELSE IF (MATCH(REPLY,'YES') .OR. MATCH(REPLY,'OK')) THEN
        CALL TBTCLO(ITBL,ISTAT)
        CALL STSEPI
      ELSE IF (HELP(REPLY)) THEN
        CALL TV('One or two numerical errors can be fixed by using the')
        CALLTVN('EDIT/TABLE command.  Say NO if there are many errors.')
      ELSE
        CALL TV('Please reply YES or NO.')
        GO TO 95
      END IF
C
C       *****
        ELSE
C       *****
C
        CALL TV('Please answer yes or no.')
        GOTO 1
C
C       *****
        ENDIF
C       *****
C
        CALL STSEPI
        END
        SUBROUTINE READT(ITBL)
C
C       Reads MIDAS table file & displays in "READ/TABLE" style.
C       Assumes file is already open.
C               CAUTION: only works with std. FORTRAN fmt specs.!
C
C
      IMPLICIT NONE
C
      INTEGER ITBL, NCOL, NCOLS, NROW, NROWS, NSORTC, NWPRAL, NROWSAL,
     1        ISTAT, NCLBGN, NCLEND, LAST, LFIELD
C
      INTEGER MXCOLS
        PARAMETER (MXCOLS=36)
        CHARACTER*24 COLN(MXCOLS)
        CHARACTER*36 CDATA(MXCOLS)
        CHARACTER*80 C80,HEADER1,HEADER2
        CHARACTER*8 COLFMT(MXCOLS),FMT
C
        INTEGER IDATA(MXCOLS), ITYPE(MXCOLS), NBGN(MXCOLS), NEND(MXCOLS)
        REAL RDATA(MXCOLS)
        DOUBLE PRECISION DDATA(MXCOLS)
C
        LOGICAL NULL
C
      INTEGER LWORD
      EXTERNAL LWORD
C
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'
        INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C
      CALL TBIGET (ITBL,  NCOLS, NROWS, NSORTC, NWPRAL, NROWSAL, ISTAT)
      NCOL=1
C
    1 CONTINUE
      NCLBGN=NCOL
      LAST=10
      HEADER1='Sequence'
      HEADER2='--------'
C       Get column name:
    2   CALL TBLGET (ITBL, NCOL,  COLN(NCOL), ISTAT)
C       Get column format & type:
        CALL TBFGET (ITBL, NCOL,  FMT,LFIELD,ITYPE(NCOL),ISTAT)
        COLFMT(NCOL)='('//FMT(:LWORD(FMT))//')'
C       data for column NCOL begin in NBGN(ncol) and end in NEND(ncol).
        NBGN(NCOL)=LAST
        NEND(NCOL)=LAST+LFIELD-1
C     ***
      IF (NEND(NCOL).LT.80) THEN
C     ***
        HEADER1(NBGN(NCOL):NEND(NCOL))=COLN(NCOL)
        HEADER2(NBGN(NCOL):NEND(NCOL))='---------------------------'
        LAST=LAST+LFIELD+1
        NCOL=NCOL+1
        IF (NCOL.GT.NCOLS) GO TO 10
        GO TO 2
C     ***
      END IF
C     ***
   10 NCLEND=NCOL-1
      IF (NROWS.LT.50) CALL NEED(NROWS+3)
      CALL TV(HEADER1)
      CALL TVN(HEADER2)
      C80=' '
      DO 19 NROW=1,NROWS
        WRITE(C80(:8),'(I8)') NROW
        DO 18 NCOL=NCLBGN,NCLEND
        IF (ITYPE(NCOL).EQ.D_C_FORMAT) THEN
            CALL TBERDC(ITBL, NROW, NCOL,CTEST, NULL, ISTAT)
            CALL FT_EOS(CTEST,36,CDATA(NCOL),ISTAT)
            C80(NBGN(NCOL):NEND(NCOL))=CDATA(NCOL)
        ELSE IF (ITYPE(NCOL).EQ.D_R4_FORMAT) THEN
            CALL TBERDR(ITBL, NROW, NCOL, RDATA(NCOL), NULL, ISTAT)
            IF(NULL) THEN
               WRITE(C80(NBGN(NCOL):NEND(NCOL)),'(A)')' '
            ELSE
               WRITE(C80(NBGN(NCOL):NEND(NCOL)),COLFMT(NCOL))RDATA(NCOL)
            END IF
        ELSE IF (ITYPE(NCOL).EQ.D_I2_FORMAT) THEN
            CALL TBERDI(ITBL, NROW, NCOL, IDATA(NCOL), NULL, ISTAT)
            WRITE(C80(NBGN(NCOL):NEND(NCOL)),COLFMT(NCOL)) IDATA(NCOL)
        ELSE IF (ITYPE(NCOL).EQ.D_I4_FORMAT) THEN
            CALL TBERDI(ITBL, NROW, NCOL, IDATA(NCOL), NULL, ISTAT)
            WRITE(C80(NBGN(NCOL):NEND(NCOL)),COLFMT(NCOL)) IDATA(NCOL)
        ELSE IF (ITYPE(NCOL).EQ.D_I1_FORMAT) THEN
            CALL TBERDI(ITBL, NROW, NCOL, IDATA(NCOL), NULL, ISTAT)
            WRITE(C80(NBGN(NCOL):NEND(NCOL)),COLFMT(NCOL)) IDATA(NCOL)
        ELSE IF (ITYPE(NCOL).EQ.D_R8_FORMAT) THEN
            CALL TBERDD(ITBL, NROW, NCOL, DDATA(NCOL), NULL, ISTAT)
            IF(NULL) THEN
               WRITE(C80(NBGN(NCOL):NEND(NCOL)),'(A)')' '
            ELSE
               WRITE(C80(NBGN(NCOL):NEND(NCOL)),COLFMT(NCOL))DDATA(NCOL)
            END IF
        ELSE
            CALL TV('unknown data format for col.')
            WRITE (C80,*) ITYPE(NCOL)
            CALL TVN(C80)
            CALL STSEPI
        END IF
   18   CONTINUE
        CALL TVN(C80)
   19 CONTINUE
        CALL TVN(HEADER2)
      IF (NCLEND.EQ.NCOLS) RETURN
      NCOL=NCLEND+1
      GO TO 1
C
      END
      SUBROUTINE BNDHLP
C
      IMPLICIT NONE
C
      CALL SPACE
      CALL TV('Standard passband names are:')
      CALL SPACE
      CALL TV('     SYSTEM    Names:')
      CALL TVN('     ------    ------')
      CALL TV('     UBVRI     U, B, V, R, I')
      CALL TV('      uvby     u, v, b, y')
      CALL TV('     Hbeta     betaW, betaN')
      CALL TV('red leak in X  XRL')
      CALL TV('X + ND filter  XND')
      CALL TV('     dark      DARK')
      CALL SPACE
      RETURN
      END
      SUBROUTINE SETDED(RATEMX, DEADT,SDEDT)
C
C
      IMPLICIT NONE
C
      CHARACTER DMS*12, A, PAGE*79
      LOGICAL MATCH
      REAL RATEMX, DEADT, SDEDT
C
C
  205 CALL ASK('Do you know the Dead Time (ns)?',DMS)
       IF(MATCH(DMS,'NO'))THEN
      WRITE(PAGE,
     1'(''  Keep rate below'',F3.0,''MHz to avoid gain shift.'')')
     2  RATEMX
      CALL TV(PAGE)
      DEADT=16.
      SDEDT=DEADT
      GO TO 211
       END IF
      IF(MATCH(DMS,'YES')) CALL ASK('Dead time (nanoseconds) =',DMS)
  210 CALL FINDPM(DMS,DEADT,SDEDT)
      WRITE(PAGE,'('' Dead time ='',F6.1,'' +/-'',F6.1,'' ns'')')DEADT,
     1SDEDT
      CALL TV(PAGE)
      CALL ASK('OK?',A)
      IF(MATCH(A,'N'))GOTO 205
  211 SDEDT=SDEDT*1.E-9
      DEADT=DEADT*1.E-9
      IF(DEADT.EQ.0. .OR. SDEDT.EQ.0.)GOTO 210
C
      RETURN
      END

C @(#)tavertbl.for	13.1.1.1 (ES0-DMD) 06/02/98 18:18:33
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.1  ESO-FORTRAN Conversion, AA  14:09 - 19 NOV 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION:
C  PROGRAM TAVERTBL
C
C.KEYWORDS:
C  LOCAL  STATISTICS
C
C.PURPOSE:
C  calculate the mean value and rms of an area defined by
C  the table positions.
C
C  Implements the command
C
C  AVERAGE/TAB image table x[,y] z [size]
C
C.ALGORITHM:
C
C -------------------------------------------------------------------
C
C
      PROGRAM TAVERT
      IMPLICIT NONE
C
      INTEGER     MADRID
      INTEGER     ICOL(2),OCOL,NPIX(2)
      INTEGER     ISTAT, IAV, NP, TID, NCOL, NROW, NSC, NAC, NAR
      INTEGER*8   PNTR
      INTEGER     IND1, IND2, NINCOL, LEN, NAXIS, I
      INTEGER     IX, IX1, IX2, IY, IY1, IY2, NT
      INTEGER     INDEX,KNUL,KUN, TYPE, TYPE1
C
      REAL VALUE(2),STARTA(2),STEPA(2), BGVL
C
      LOGICAL NULL(2),SELECT
C
      CHARACTER*80 TABLE, LINE
      CHARACTER*16 LABEL, UNIT
      CHARACTER CUNIT*64,IDENT*72
      CHARACTER FRAME*64,ICOLR*17,OCOLR*17
      CHARACTER FORM*8
      CHARACTER FORM1*8
C
      INCLUDE 'MID_INCLUDE:TABLES.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:TABLED.INC'
C
      DATA      UNIT/'DN '/, FORM/'G15.7 '/
C
      TYPE = D_R4_FORMAT
C
C ... INITIALIZE MIDAS
C
      CALL SXSPRO('TAVERTBL')
      CALL STKRDI('INPUTI',1,1,IAV,NP,KUN,KNUL,ISTAT)
C
C ... GET PARAMS
C
      FRAME  = ' '
      LINE   = ' '
      CALL STKRDC('P1',1,1,64,IAV,FRAME,KUN,KNUL,ISTAT)
      CALL STKRDC('P2',1,1,64,IAV,TABLE,KUN,KNUL,ISTAT)
      CALL STKRDC('P3',1,1,36,IAV,LINE,KUN,KNUL,ISTAT)
      CALL STKRDC('P4',1,1,17,IAV,OCOLR,KUN,KNUL,ISTAT)
C
C ... READ TABLE
C
      CALL TBTOPN(TABLE,F_U_MODE,TID,ISTAT)
      CALL TBIGET(TID,NCOL,NROW,NSC,NAC,NAR,ISTAT)
C
C ... DECODE PARAMETERS AND FIND TABLE COLUMNS
C
      IND1   = INDEX(LINE,',') - 1
      IND2   = INDEX(LINE,' ') - 1
      NINCOL = 2
      IF (IND1.EQ.-1) THEN
          IND1   = INDEX(LINE,' ') - 1
          NINCOL = 1
          NPIX(2) = 1
      END IF
      ICOLR = LINE(1:IND1)
      CALL TBCSER(TID,ICOLR,ICOL(1),ISTAT)
      IF (ICOL(1).LE.0) THEN
          CALL SXTPUT(' input column not found ...',ISTAT)
          GO TO 20
      END IF
      CALL TBFGET(TID,ICOL(1),FORM1,LEN,TYPE1,ISTAT)
      IF (TYPE1.EQ.D_C_FORMAT) THEN
          CALL SXTPUT(' wrong input column format ...',ISTAT)
          GO TO 20
      END IF
      IF (NINCOL.EQ.2) THEN
          ICOLR = LINE(IND1+2:IND2)
          CALL TBCSER(TID,ICOLR,ICOL(2),ISTAT)
          IF (ICOL(2).LE.0) THEN
              CALL SXTPUT(' input column not found ...',ISTAT)
              GO TO 20
          END IF
          CALL TBFGET(TID,ICOL(2),FORM1,LEN,TYPE1,ISTAT)
          IF (TYPE1.EQ.D_C_FORMAT) THEN
              CALL SXTPUT(' wrong input column format ...',ISTAT)
              GO TO 20
          END IF
      END IF
      CALL TBCSER(TID,OCOLR,OCOL,ISTAT)
      IF (OCOL.LE.0) THEN
          LABEL  = OCOLR(2:)
          CALL TBCINI(TID,TYPE,1,FORM,UNIT,LABEL,OCOL,ISTAT)
      ELSE
          CALL TBFGET(TID,OCOL,FORM1,LEN,TYPE1,ISTAT)
          IF (TYPE1.EQ.D_C_FORMAT) THEN
              CALL SXTPUT(' wrong output column format ...',ISTAT)
              GO TO 20
          END IF
      END IF
C
C ... READ IMAGE
C
      CALL SXIGET(FRAME,'I',2,NAXIS,NPIX,STARTA,STEPA,IDENT,CUNIT,IPNTR,
     +            ISTAT)
C
C ... ITERATION ON POSITIONS
C
      NULL(2) = .FALSE.
      DO 10 I = 1,NROW
C
C ...     READ VALUES AND SELECT FLAG
C
          CALL TBRRDR(TID,I,NINCOL,ICOL,VALUE,NULL,ISTAT)
          CALL TBSGET(TID,I,SELECT,ISTAT)
          IF (SELECT .AND. (.NOT.NULL(1)) .AND. (.NOT.NULL(2))) THEN
              IX     = (VALUE(1)-STARTA(1))/STEPA(1) + 1
              IX1    = MAX(IX-NP,1)
              IX2    = MIN(IX+NP,NPIX(1))
              IF (NINCOL.EQ.2) THEN
                  IY     = (VALUE(2)-STARTA(2))/STEPA(2) + 1
                  IY1    = MAX(IY-NP,1)
                  IY2    = MIN(IY+NP,NPIX(2))
              ELSE
                  IY     = 1
                  IY1    = 1
                  IY2    = 1
              END IF
C
C ...       COMPUTE MEAN VALUE AND WRITE RESULT
C
              IF (IX.GE.1 .AND. IX.LE.NPIX(1) .AND. IY.GE.1 .AND. IY.LE.
     +            NPIX(2)) THEN
                  NT     = (IX2-IX1+1)* (IY2-IY1+1)
                  CALL MEAN(MADRID(PNTR),NPIX(1),NPIX(2),IX1,IX2,IY1,
     +                      IY2,NT,BGVL)
                  CALL TBEWRR(TID,I,OCOL,BGVL,ISTAT)
              ELSE
                  CALL TBEDEL(TID,I,OCOL,ISTAT)
              END IF

          ELSE
              CALL TBEDEL(TID,I,OCOL,ISTAT)
          END IF
   10 CONTINUE
C
C ... HISTORY AND BYE
C
      CALL TDHSTR(TID,ISTAT)
   20 CONTINUE
      CALL TBTCLO(TID,ISTAT)
      CALL SXSEPI
      STOP ' '
      END

      SUBROUTINE MEAN(A,NPIX1,NPIX2,IXA,IXE,IYA,IYE,NP,VAL)
C
C COMPUTE THE MEAN VALUE OF THE SQUARE CENTERED AT (IX, IY),
C WITH DIMENSION 2*NP+1 PIXELS
C
      IMPLICIT NONE
C
      INTEGER   NPIX1, NPIX2, IXA, IXE, IYA, IYE, NP
      INTEGER   I, J
C
      REAL      VAL, A(NPIX1,NPIX2)
C
      DOUBLE PRECISION SMEAN
C
      SMEAN  = 0.D0
      DO 20 I = IYA,IYE
          DO 10 J = IXA,IXE
              SMEAN  = SMEAN + A(J,I)
   10     CONTINUE
   20 CONTINUE
      VAL    = SMEAN/NP
      RETURN

      END

C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION        ISTFN1.FOR
C.AUTHOR:               J.D.PONZ  ESA-VILSPA        
C.KEYWORDS              IUE, GO FORMAT
C.ENVIRONMENT           VMS
C.PURPOSE
C   \begin{TeX}
C    Generates file name as a function of the
C    Camera, image number, file type and aperture as follows:
C    \begin{itemize}
C \item {\tt filename} = <{\tt camera}><{\tt imano}> 
C                         for {\tt FES,RAW,PHOTOM} and {\tt MEHI}
C \item {\tt filename} = <{\tt camera}><{\tt imano}><{\tt aperture}> 
C                         for {\tt (E)LBL} and {\tt MELO}
C    \end{itemize}
C    where: 
C   \begin{description}
C    \item[{\tt camera}] can be {\tt LWP, LWR, SWP, SWR}
C    \item[{\tt imano}] is a 5 digit integer number
C    \item[{\tt aperture}]  can be  {\tt L, S}
C   \end{description}
C   \end{TeX}
C         
C.LANGUAGE              F77
C.VERSION: 1.0  INITIAL CODING  09 JUL 1990
C------------------------------------------------------------------
      SUBROUTINE ISTFN1(CAMERA,IMANUM,APERTU,FTYPE,FILE)
C
      IMPLICIT NONE
      INTEGER       CAMERA            ! IN: camera code number
      INTEGER       IMANUM            ! IN: image number
      INTEGER       APERTU            ! IN: LAP-SAP code
      INTEGER       FTYPE             ! IN: file type
      CHARACTER*(*) FILE              ! OUT: filename
C
      CHARACTER*4 CAM(4), EXT(6)
      CHARACTER*1 AP(2)
      DATA CAM(1)/'lwp'/, CAM(2)/'lwr'/
      DATA CAM(3)/'swp'/, CAM(4)/'swr'/
      DATA AP(1) /'l'/,   AP(2) /'s'/
      DATA EXT(1)/'.bdf'/
      DATA EXT(2)/'.raw'/
      DATA EXT(3)/'.pho'/
      DATA EXT(4)/'.lbl'/
      DATA EXT(5)/'.tbl'/
      DATA EXT(6)/'.tbl'/
C
C      IF (FTYPE.LE.2) THEN
         WRITE(FILE,100) CAM(CAMERA),IMANUM,EXT(FTYPE+1)
C      ELSE
C         WRITE(FILE,200) CAM(CAMERA),IMANUM,AP(APERTU+1)
C      ENDIF   
 100  FORMAT(A3,I5.5,A4)
C 200  FORMAT(A3,I5.5,A1)
      RETURN
      END

C @(#)poly3d.for	19.1 (ES0-DMD) 02/25/03 13:17:43
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE POLY3D(X,NP,PARAM,Y1,DERIV)                                    
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                  
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  18:01 - 21 DEC 1987                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C--------------------------------------------------------------                 
C*********************************************                                  
C                                                                               
C      IMPLICIT NONE                                                            
C  FIT WITH A THREE-DIMENSIONAL POLYNOMIAL                                      
C                                                                               
C*********************************************                                  
C                                                                               
C Author: O.-G. Richter, ESO Garching                                           
C                                                                               
      INTEGER I,J,K,L,NP,MAX
      REAL X(3),A                                                            
      DOUBLE PRECISION Y1,PARAM(NP),DERIV(NP)                                   
C                                                                               
      PARAMETER (MAX=4)                                                         
      DOUBLE PRECISION B(MAX,MAX,MAX),C(MAX*MAX*MAX)                            
C                                                                               
      A      = 1.0D0                                                            
      DO 10 I = 1,MAX                                                           
          B(1,1,I) = A                                                          
          A      = A*X(1)                                                       
   10 CONTINUE                                                                  
      DO 30 I = 2,MAX                                                           
          DO 20 J = 1,MAX                                                       
              B(1,I,J) = B(1,I-1,J)*X(2)                                        
   20     CONTINUE                                                              
   30 CONTINUE                                                                  
      DO 60 I = 2,MAX                                                           
          DO 50 J = 1,MAX                                                       
              DO 40 K = 1,MAX                                                   
                  B(I,J,K) = B(I-1,J,K)*X(3)                                    
   40         CONTINUE                                                          
   50     CONTINUE                                                              
   60 CONTINUE                                                                  
      L      = 0                                                                
      DO 90 I = 1,MAX                                                           
          DO 80 J = 1,I                                                         
              DO 70 K = 1,J                                                     
                  L      = L + 1                                                
                  C(L)   = B(K,J-K+1,I-J+1)                                     
   70         CONTINUE                                                          
   80     CONTINUE                                                              
   90 CONTINUE                                                                  
      Y1     = 0.0D0                                                            
      DO 100 I = 1,NP                                                           
          DERIV(I) = C(I)                                                       
          Y1     = Y1 + C(I)*PARAM(I)                                           
  100 CONTINUE                                                                  
      RETURN                                                                    
                                                                                
      END                                                                       

C @(#)gd8r.for	19.1 (ES0-DMD) 02/25/03 13:55:09
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
	SUBROUTINE GD8033(DISPLAY,CHAN,COLOUR,XA,YA,XB,YB,ROID,IDST)
C	
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  a) subroutine IIRINR		version 1.00	880614
C  b) subroutine IIRRRI		version 1.00	880121
C  c) subroutine IIRWRI		version 1.00	880614
C  d) subroutine IIRSRV		version 1.00	890119
C  all routines				1.20	880915
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  DeAnza, cursor boards
C
C.PURPOSE
C  fulfill the requirements as described in the IDI document
C
C.ALGORITHM
C  use DeAnza level-0 software
C
C.INPUT/OUTPUT
C  call as
C  a) IIRINR(DISPLAY,CHAN,COLOUR,XA,YA,XB,YB,ROID,IDST)
C  b) IIRRRI(DISPLAY,CHAN,ROID,XA,YA,XB,YB,MEMO,IDST)
C  c) IIRWRI(DISPLAY,CHAN,ROID,XA,YA,XB,YB,IDST)
C  d) IIRSRV(DISPLAY,ROID,VIS,IDST)
C
C  input par:
C  DISPLAY:	I*4		display id.
C  CHAN:	I*4		input memory id (we ignore that...)
C  COLOUR:	I*4		colour
C  XA:		I*4		min x
C  YA:		I*4		min y
C  XB:		I*4		max x
C  YB:		I*4		max y
C
C  VIS:		I*4		1 = visible, 0 = invisible
C
C  in/output par:
C  ROID:	I*4		ROI id  (output par for IIRINR, else input par)
C  IDST:	I*4		return status
C	
C--------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,CHAN,COLOUR,XA,YA,XB,YB,ROID,IDST
	INTEGER*4	XROID
C	
	INTEGER*2	UNIT
	INTEGER*2	CMASK,RESREG,FIX
	INTEGER*2	LCR,RCR,LR,RR,LPA
C	
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
C	
	EXTERNAL	LR,RR,LCR,RCR,LPA
C	
	DATA	CMASK 	/"001460/
	DATA	XROID   /0/
C
C  get unit
	UNIT = DISPLAY
C	
C  start with cursor control register = 0
C	
	IF (COLOUR.EQ.0) THEN
	   FIX = 15
	ELSE
	   FIX = 14
	ENDIF
C
	CURREG(5) = FIX				!insert fixed cursor shape
	CURREG(5) = IOR(CURREG(5),CMASK)	!insert X, Y components
C	
C  send cursor control register to the Deanza
	CALL IP8QW(LCR,UNIT,DZIOSB,,,CURREG(5),2,0,4)
C	
C  allright then...
	ROID = XROID
	XROID = XROID + 1
C 
	IF (XA.GE.0)
     +	   CALL GD8035(DISPLAY,CHAN,ROID,XA,YA,XB,YB,IDST)
C 
	IDST = 0
C	
	RETURN
	END

	SUBROUTINE GD8034(DISPLAY,CHAN,ROID,XA,YA,XB,YB,MEMO,IDST)
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,CHAN,ROID,XA,YA,XB,YB,MEMO,IDST
	INTEGER*4	N1,N,ISS
C		
	INTEGER*2	UNIT,CONTROL,FCREG
	INTEGER*2	RCR,RVR,LPR
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
	INCLUDE	'MID_INCLUDE:IDIDEV.INC'
C	
	EXTERNAL	RCR,RVR,LPR
C	
C  get unit
	UNIT = DISPLAY
C	
C  get cursor registers from the Deanza
	CALL IP8QW(RCR,UNIT,DZIOSB,,,CURREG(1),8,0,0)
C	
C  make sure cursor1 gets minimum
	IF (CURREG(1).GT.CURREG(3)) THEN
	   XA = CURREG(3)
	   XB = CURREG(1)
	ELSE
	   XA = CURREG(1)
	   XB = CURREG(3)
	ENDIF
	IF (CURREG(2).GT.CURREG(4)) THEN
	   YA = CURREG(4)
	   YB = CURREG(2)
	ELSE
	   YA = CURREG(2)
	   YB = CURREG(4)
	ENDIF
C	
C  get X-, Y- split registers + FCRs
1000	CALL IP8QW(RVR,UNIT,DZIOSB,,,VOCREG(1),4,0,0)
	CALL IP8QW(RVR,UNIT,DZIOSB,,,FCR(1),16,0,8)
C	
C  determine relevant FCR
	IF ( (VOCREG(1).EQ.0) .AND. (VOCREG(2).EQ.(QDSZY-1)) ) THEN
	   FCREG = FCR(4)			!no split screen
	ELSE
	   IF (XA.LT.VOCREG(1)) THEN
	      ISS = 1
	      IF (YA.LT.VOCREG(2)) ISS = 2
	   ELSE
	      ISS = 0
	      IF (YA.LT.VOCREG(2)) ISS = 3
	   ENDIF
	   FCREG = FCR(ISS+1)
	ENDIF
C	
C  pull out memory channel from FCR
	MEMO = IAND(FCREG,"17)
C	
C  alright then...
	IDST = 0
	RETURN
	END

	SUBROUTINE GD8035(DISPLAY,CHAN,ROID,XA,YA,XB,YB,IDST)
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,CHAN,ROID,XA,YA,XB,YB,IDST
C		
	INTEGER*2	UNIT
	INTEGER*2	AX,BX,AY,BY
	INTEGER*2	LCR
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
C	
	EXTERNAL	LCR
C
C  get unit
	UNIT = DISPLAY
C	
C  make sure, cursor1 get minimum coords
	IF (XA.GT.XB) THEN
	   AX = XB
	   BX = XA
	ELSE
	   AX = XA
	   BX = XB
	ENDIF
	IF (YA.GT.YB) THEN
	   AY = YB
	   BY = YA
	ELSE
	   AY = YA
	   BY = YB
	ENDIF
C	
	CURREG(1) = AX
	CURREG(2) = AY
	CURREG(3) = BX
	CURREG(4) = BY
C	
C  and send it to the Deanza
	CALL IP8QW(LCR,UNIT,DZIOSB,,,CURREG(1),8,0,0)
C	
C  alright then...
	IDST = 0
	RETURN
	END

	SUBROUTINE GD8036(DISPLAY,ROID,VIS,IDST)
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,ROID,VIS,IDST
C 
	INTEGER*2	UNIT,CMASK
	INTEGER*2	RCR,LCR
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
	INCLUDE	'MID_INCLUDE:IDIDEV.INC'
C	
	EXTERNAL	RCR,LCR
C	
C  get unit
	UNIT = DISPLAY
C
	CALL IP8QW(RCR,UNIT,DZIOSB,,,CURREG(5),2,0,4)
	IF (VIS.NE.0) THEN
           CMASK = "001460
           CURREG(5) = IOR(CURREG(5),CMASK)
        ELSE
           CURREG(5) = 0
	ENDIF
C	
C  send cursor control register to the Deanza
	CALL IP8QW(LCR,UNIT,DZIOSB,,,CURREG(5),2,0,4)
C	
	RETURN
	END

C===========================================================================
C Copyright (C) 1995-2011 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C 
C.VERSION
C 111019		last modif
C 
C===========================================================================
C
      SUBROUTINE ATTACH (IMAGE, OPEN)
C
C Open an image.
C
      IMPLICIT NONE
C 
      CHARACTER OBJECT*72, CASE*4
      CHARACTER*30 IMAGE, COOFIL, MAGFIL, PSFFIL, PROFIL,
     +     GRPFIL, SWITCH
C 
      INTEGER AXLEN(7)
      INTEGER IER, NAXIS, IDTYPE
      INTEGER MADRID, IMDATA, IMCOPY, NCOL, NROW
C 
      LOGICAL OPEN
C
      REAL DNUL, DUN
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C 
      COMMON /VMR/ MADRID
      COMMON /FILNAM/ COOFIL, MAGFIL, PSFFIL, PROFIL, GRPFIL
      COMMON /IMID/ IMDATA, IMCOPY, IDTYPE
      COMMON /SIZE/ NCOL, NROW
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      IF (OPEN) THEN
         CALL CLPIC ('DATA')
      END IF
C
      CALL STFOPN (IMAGE, D_R4_FORMAT, 1, F_IMA_TYPE, IMDATA, IER)
      IF (IER .EQ. 0) THEN
         OPEN = .TRUE.
         CALL STFINF (IMAGE, 2, AXLEN, IER)
         IDTYPE = AXLEN(2)
C
         CALL STDRDC (IMDATA, 'IDENT', 1, 1, 72, NAXIS, OBJECT,
     .        DUN, DNUL, IER)
         IF (IER .EQ. 0) THEN
            WRITE (6,601) OBJECT
  601       FORMAT (/10X, A/)
         END IF
         CALL STDRDI (IMDATA, 'NPIX', 1, 2, NAXIS, AXLEN, DUN,
     .        DNUL, IER)
         IF (NAXIS .EQ. 1) THEN
            NCOL = AXLEN(1)
            NROW = 1
         ELSE
            NCOL = AXLEN(1)
            NROW = AXLEN(2)
         END IF
         WRITE (6,611) NCOL, NROW
  611    FORMAT (38X, 'Picture size: ', 2I5)
         COOFIL = SWITCH(IMAGE, CASE('.coo'))
         MAGFIL = SWITCH(IMAGE, CASE('.ap'))
         PSFFIL = SWITCH(IMAGE, CASE('.psf'))
         PROFIL = SWITCH(IMAGE, CASE('.nst'))
         GRPFIL = SWITCH(IMAGE, CASE('.grp'))
      ELSE
         OPEN = .FALSE.
         CALL STUPID ('          Unable to open image.')
      END IF
      RETURN
      END!
C
C#######################################################################
C
      SUBROUTINE CREPIC (PICTUR, TYPE, NCOL, NROW, IER)
      IMPLICIT NONE
      INTEGER LEN(7)
C
      CHARACTER*30 PICTUR
      CHARACTER*6 TYPE
      INTEGER NCOL, NROW, IDTYPE, IER, MADRID, IMDATA, IMCOPY
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON /VMR/ MADRID
      COMMON /IMID/ IMDATA, IMCOPY, IDTYPE
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      CALL STFINF (PICTUR, 99, LEN, IER)
      IF (IER .EQ. 0) THEN
         CALL STFDEL (PICTUR, IER)
      END IF
C
      LEN(1) = NCOL
      LEN(2) = NROW
      IF ((TYPE(1:1) .EQ. 'S') .OR. (TYPE(1:1) .EQ. 's')) THEN
         IDTYPE = D_I2_FORMAT
      ELSE
         IDTYPE = D_R4_FORMAT
      END IF
      CALL STFCRE (PICTUR, IDTYPE, F_IO_MODE, F_IMA_TYPE, 
     +     NCOL*NROW, IMCOPY, IER)
C 
      RETURN
      END!
C
C#######################################################################
C
      SUBROUTINE RDARAY (TEXT, LX, LY, MX, MY, NX, FUNC, IER)
      IMPLICIT NONE
      INTEGER NX, MIN0, MAX0
      REAL FUNC(NX,*)
C
      CHARACTER*4 TEXT
      INTEGER LX, LY, MX, MY, IER, MADRID, IMDATA, IMCOPY, IDTYPE
      INTEGER JY, KX, ID, NCOL, NROW, J
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON /VMR/ MADRID
      COMMON /SIZE/ NCOL, NROW
      COMMON /IMID/ IMDATA, IMCOPY, IDTYPE
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      IF (TEXT .EQ. 'DATA') THEN
         ID = IMDATA
      ELSE
         ID = IMCOPY
      END IF
C
C Reset LX, LY, MX, and MY, if necessary, to keep them within
C the bounds of the image.
C
      MX = LX+MX-1
      MY = LY+MY-1
      LX = MAX0(1,LX)
      LY = MAX0(1,LY)
      MX = MIN0(NCOL,MX)
      MY = MIN0(NROW,MY)
      MX = MX-LX+1
      MY = MY-LY+1
      DO J=1,MY
         JY = LY+J-1
         CALL STFGET (ID, (JY-1)*NCOL+LX, MX, KX, FUNC(1,J), IER)
      END DO
      RETURN
      END!
C
C#######################################################################
C
      FUNCTION OBJECT (TEXT)
      IMPLICIT NONE
      CHARACTER*(*) OBJECT
      CHARACTER*(*) TEXT
      REAL DUN, DNUL
      INTEGER MADRID, IMDATA, IMCOPY, IDTYPE, I, NAXIS, IER
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON /VMR/ MADRID
      COMMON /IMID/ IMDATA, IMCOPY, IDTYPE
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      IF ((TEXT(1:1) .EQ. 'D') .OR. (TEXT(1:1) .EQ. 'd')) THEN
         I = IMDATA
      ELSE IF ((TEXT(1:1) .EQ. 'C') .OR. (TEXT(1:1) .EQ. 'c')) THEN
         I = IMCOPY
      ELSE
         OBJECT = ' '
         RETURN
      END IF
C
      CALL STDRDC (IMDATA, 'IDENT', 1, 1, 72, NAXIS, OBJECT,
     +     DUN, DNUL, IER)
C
      CALL STDRDC (IMDATA, 'OBJECT', 1, 1, 72, NAXIS, 
     +        OBJECT, DUN, DNUL, IER)
C
      IF (IER .NE. 0) THEN
         CALL STDRDC (IMDATA, 'COMMENT', 1, 1, 72, NAXIS, 
     +        OBJECT, DUN, DNUL, IER)
      END IF
C
      WRITE (6,601) OBJECT
601   FORMAT (/10X, A/)
C
      RETURN
      END!
C
C#######################################################################
C
      SUBROUTINE COPPIC (PICTUR, PIX, NCOL, NROW, IER)
      IMPLICIT NONE
      INTEGER NCOL, NROW
      REAL PIX(NCOL)
C
      CHARACTER*80 DUMMY
      CHARACTER*30 PICTUR
      CHARACTER*6 TYPE
      INTEGER LX, LY, J, NX, NY, LEN
      INTEGER IER, MADRID, IMDATA, IMCOPY, IDTYPE
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON /VMR/ MADRID
      COMMON /IMID/ IMDATA, IMCOPY, IDTYPE
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      CALL STFINF (PICTUR, 99, LEN, IER)
      IF (IER .EQ. 0) THEN
         CALL STFDEL (PICTUR, IER)
      END IF
C
      IF (IDTYPE .EQ. D_R4_FORMAT) THEN
         TYPE = 'REAL'
      ELSE IF (IDTYPE .EQ. D_I4_FORMAT) THEN
         TYPE = 'INT'
      ELSE
         TYPE = 'SHORT'
      END IF
      NX = NCOL
      NY = NROW
      CALL CREPIC (PICTUR, TYPE, NX, NY, IER)
      IF (IER .NE. 0) THEN
         CALL STUPID ('CREPIC: Error creating output image.')
         CALL OOPS
      END IF
C
      CALL STDCOP (IMDATA, IMCOPY, 1, DUMMY, IER)
C
      NY = 1
      DO J = 1,NROW
         LX = 1
         LY = J
         CALL RDARAY ('DATA', LX, LY, NX, NY, NCOL, PIX, IER)
         IF (IER .NE. 0) THEN
            CALL STUPID ('RDARAY:  Error copying image data.')
            CALL OOPS
         END IF
C
         CALL WRARAY ('COPY', LX, LY, NX, NY, NCOL, PIX, IER)
         IF (IER .NE. 0) THEN
            CALL STUPID ('WRARAY:  Error copying image data.')
            CALL OOPS
         END IF
C
      END DO
      RETURN
      END!
C
C#######################################################################
C
      SUBROUTINE WRARAY (TEXT, LX, LY, MX, MY, MAXX, FUNC, IER)
      IMPLICIT NONE
      INTEGER MAXX
C after boosting the size of max image to 10000 x 10500
C we also have to update the max size of the row
C      REAL FUNC(MAXX,*), ROW(4096)
      REAL FUNC(MAXX,*), ROW(12000)
C
      CHARACTER*4 TEXT
      INTEGER MADRID, NCOL, NROW, IMDATA, IMCOPY, IDTYPE, ID
      INTEGER I, J, JY, LX, LY, MX, MY, NX, NY, IER
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON /VMR/ MADRID
      COMMON /SIZE/ NCOL, NROW
      COMMON /IMID/ IMDATA, IMCOPY, IDTYPE
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      IF ((TEXT(1:1) .EQ. 'd') .OR. (TEXT(1:1) .EQ. 'D')) THEN
         ID = IMDATA
      ELSE
         ID = IMCOPY
      END IF
      MX = LX+MX-1
      MY = LY+MY-1
      LX = MAX0(1,LX)
      LY = MAX0(1,LY)
      MX = MIN0(NCOL, MX)
      MY = MIN0(NROW, MY)
      NX = MX-LX+1
C 
      IF (NX .GT. 12000) THEN
         CALL STETER(77,'WRARAY: # of pixels in row > 12000')
      ENDIF
C 
      NY = MY-LY+1
      DO J=1,NY
         JY = LY+J-1
         DO I=1,NX
            IF (IDTYPE .EQ. D_I2_FORMAT) THEN
               ROW(I) = AMAX1(-32768., AMIN1(32767., FUNC(I,J)))
               ROW(I) = ANINT(ROW(I))
            ELSE IF (IDTYPE .EQ. D_UI2_FORMAT) THEN
               ROW(I) = AMAX1(0.0, AMIN1(65535., FUNC(I,J)))
               ROW(I) = ANINT(ROW(I))
            ELSE IF (IDTYPE .EQ. D_I4_FORMAT) THEN
               ROW(I) = AMAX1(-2147483000., AMIN1(2147483000.,
     +              FUNC(I,J)))
               ROW(I) = ANINT(ROW(I))
            ELSE
               ROW(I) = FUNC(I,J)
            END IF
         END DO
         CALL STFPUT (ID, (JY-1)*NCOL+LX, NX, ROW, IER)
      END DO
      MX = NX
      MY = NY
      RETURN
      END!
C
C#######################################################################
C
      SUBROUTINE CLPIC (TEXT)
      IMPLICIT NONE
      CHARACTER*4 TEXT
      INTEGER IDTYPE, MADRID, IER, ID, IMDATA, IMCOPY
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON /VMR/ MADRID
      COMMON /IMID/ IMDATA, IMCOPY, IDTYPE
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      IF ((TEXT(1:1) .EQ. 'D') .OR. (TEXT(1:1) .EQ. 'd')) THEN
         ID = IMDATA
      ELSE
         ID = IMCOPY
      END IF
      CALL STFCLO (ID, IER)
      RETURN
      END!
C
C#######################################################################
C
      SUBROUTINE DELPIC (IMAGE, IER)
      IMPLICIT NONE
      CHARACTER*30 IMAGE
      INTEGER MADRID, IER
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON /VMR/ MADRID
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      CALL STFDEL (IMAGE, IER)
      RETURN
      END!
C
C#######################################################################
C
      SUBROUTINE LIST (FILE)
      IMPLICIT NONE
      CHARACTER*30 FILE
      CALL TBLANK
      WRITE (6,*) 'Image file = ', FILE
      CALL TBLANK
      RETURN
      END!

C @(#)spoext.for	19.1 (ES0-DMD) 02/25/03 14:25:24
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C @(#)spoext.for	19.1  (ESO)  02/25/03  14:25:24 
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++
C .COPYRIGHT   (C) 1993 European Southern Observatory    
C .IDENT       .prg                                      
C .AUTHORS     Pascal Ballester (ESO/Garching)           
C              Cristian Levin   (ESO/La Silla)           
C .KEYWORDS    Spectroscopy, Long-Slit                   
C .PURPOSE                                               
C .VERSION     1.0  Package Creation  17-MAR-1993        
C -------------------------------------------------------

C @(#)spoext.for	4.2 (ESO-IPG) 11/20/92 14:47:36
          PROGRAM SPOEXT
C+
C
C.IDENTIFICATION
C
C  PROGRAM  SPOEXT                VERSION 1.0        880420
C                                        
C  Otmar Stahl                        Landessternwarte Heidelberg
C     M. Peron  , modif suggested by T. Oosterloo                                      900830
C.KEYWORDS
C
C  SPECTRA, CCD, DATA EXTRACTION
C
C.PURPOSE
C
C  EXTRACT STELLAR SPECTRA FROM A CCD IMAGE. THE INDIVIDUAL ROWS OF 
C  THE CCD IMAGE WHICH CONTAIN THE FLUX ARE ADDED. THE WEIGHTS ARE
C  CHOSEN SUCH THAT THE SUMMED SPECTRUM HAS THE OPTIMAL S/N-RATIO.
C  COSMIC RAY HITS ARE LOCATED BY ANALYSING THE PROFILE PERPENDICULAR 
C  TO THE DISPERSION AND MASKED OUT. 
C  
C.ALGORITHM
C
C  THE METHOD IS DESCRIBED IN DETAIL IN THE PAPER BY 
C  Keith Horne in PASP 98, pg. 609. 
C  THE MASK USED TO REMOVE THE COSMIC RAY HITS IS KEPT IN THE
C  MASK FILE cosmics.bdf.
C
C  EXTRACT/SPECTRUM  output input sky order,iter read-out-noise,g,thresh
C
C  OUT_A                output spectrum
C  IN_A                 input image (must be bias and dark subtracted 
C                       (if relevant) and divided by a normalized flat 
C                       field, not sky subtracted)
C  IN_B                 sky image (normally derived from IN_A in advance)
C  INPUTI               fit order for the polynomials, number of 
C                       iterations for cosmic ray removal
C  INPUTR                read-out-noise, conversion factor (e/ADU),
C                       threshold for cosmic ray removal
C
      IMPLICIT NONE
      CHARACTER*60    INFR,SKYFR,OUTFR
      CHARACTER       CUNIT*64,IDENT*72
      CHARACTER       CUNITS*64,IDENTS*72
      CHARACTER*80    OUTPUT
      INTEGER       NPIX(2),MPIX(2),IFIT(2),NUM
      INTEGER       IAV,ISTAT,NAXIS
      INTEGER*8     IPNTRA,IPNTRB,IPNTRC
      INTEGER       NBYTES
      INTEGER*8     IPNTR1,IPNTR2,IPNTR3,IPNTR4,IPNTR5,IPNTR6
      INTEGER       KUN,KNUL,IDI,IDS,IDO,MADRID,IDM,ISS
      REAL          CCD(3)
      DOUBLE PRECISION  START(2),STEP(2),STARTS(2),STEPS(2)
      INCLUDE       'MID_INCLUDE:ST_DEF.INC'
      COMMON/VMR/MADRID(1)
      INCLUDE       'MID_INCLUDE:ST_DAT.INC'
C
      CALL STSPRO('SPOEXT')
C
C get input and map images
C
      CALL STKRDC('IN_A',  1,1,60,IAV,INFR,KUN,KNUL,ISTAT)
      CALL STKRDC('IN_B',  1,1,60,IAV,SKYFR,KUN,KNUL,ISTAT)
      CALL STKRDC('OUT_A', 1,1,60,IAV,OUTFR,KUN,KNUL,ISTAT)
      CALL STKRDI('PUTI',1,2,IAV,IFIT,KUN,KNUL,ISTAT)
      CALL STKRDR('PUTR',1,3,IAV,CCD,KUN,KNUL,ISTAT)
C
      CALL STIGET(INFR,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     .2,NAXIS,NPIX,START,STEP,IDENT,CUNIT,IPNTR1,IDI,ISTAT)
C
      CALL STIGET(SKYFR,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     .2,NAXIS,MPIX,STARTS,STEPS,IDENTS,CUNITS,IPNTR6,IDS,ISTAT)
C
      IF ((MPIX(1).NE.NPIX(1)).OR.(MPIX(2).NE.NPIX(2))) THEN
          WRITE(OUTPUT,100) 
100       FORMAT('OBJECT AND SKY FRS TO NOT MATCH')
          CALL STTPUT(OUTPUT,ISTAT)
          GO TO 999
      ENDIF
C
      CALL STIPUT(OUTFR,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .1,NPIX(1),START(1),STEP(1),IDENT,CUNIT,IPNTR2,IDO,ISTAT)
C
      CALL STIPUT('cosmics',D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .NAXIS,NPIX,START,STEP,IDENT,CUNIT,IPNTR3,IDM,ISTAT)
C
C reserve  space for arrays
C
      NUM = NPIX(1)*NPIX(2)*4
      NBYTES = NPIX(1)*4
      CALL TDMGET(NUM,IPNTR4,ISS)     
      CALL TDMGET(NUM,IPNTR5,ISS)     
      CALL TDMGET(NBYTES,IPNTRA,ISS)
      CALL TDMGET(NBYTES,IPNTRB,ISS)
      CALL TDMGET(NBYTES,IPNTRC,ISS)
C
C DO THE REAL WORK
C
      CALL XTRACT (MADRID(IPNTR1),MADRID(IPNTR2),MADRID(IPNTR3), 
     &MADRID(IPNTR4),MADRID(IPNTR5),MADRID(IPNTR6),MADRID(IPNTRA),
     &MADRID(IPNTRB),MADRID(IPNTRC),NPIX,IFIT,CCD)
C
C COPY HISTORY
C
C      CALL COPYDSC_ST(INFR,OUTFR,4,'HISTORY',ISTAT)
C
      CALL TDMFRE(NUM,IPNTR4,ISS)     
      CALL TDMFRE(NUM,IPNTR5,ISS)     
      CALL TDMFRE(NBYTES,IPNTRA,ISS)
      CALL TDMFRE(NBYTES,IPNTRB,ISS)
      CALL TDMFRE(NBYTES,IPNTRC,ISS)
999   CALL STSEPI
      END
C
C**************************************************************************
      SUBROUTINE XTRACT(IN,OUT,MASK,PROF,VARI,SKY,X,Y,Z,NPIX,IFIT,CCD)
C 
C THIS ROUTINE DOES THE EXTRACTION OF THE SPECTRUM
C
      IMPLICIT NONE
C      INTEGER        MASK(1) ! DECLARED AS INTEGER*2 !!!
      REAL            MASK(1) ! DECLARED AS INTEGER*2 !!!
      INTEGER        NPIX(2),IFIT(2)
      INTEGER        J,K,KK,L,II,M,N,IORD,ITER,IWIND
      REAL           IN(1),OUT(1),PROF(1),VARI(1),SKY(1)
      REAL           A(10),B(10),S(10),W(10)     
      REAL           RON,G,SIGMA,V0,SUM,CHISQ,YY,DIFF,DIFF2,QUOT
      REAL           SUM1,SUM2,RMAX
      REAL           X(1),Y(1),Z(1),CCD(3)
C                                                                       
      M = NPIX(1)
      N = NPIX(2)
C
      IORD = IFIT(1)
      ITER = IFIT(2)
      IWIND = 3
C
      RON   = CCD(1)
      G     = CCD(2)
      SIGMA = CCD(3)
C
      SIGMA = SIGMA*SIGMA
      V0 = RON**2/G**2
C
C  EXTRACT INITIAL SPECTRUM (JUST THE SUM) AND SET mask TO 1
C
      DO 20 J = 1,M
        SUM = 0.
        DO 10 K = 1,N
          II = (K-1)*M+J
          MASK(II) = 1
          SUM = SUM+IN(II)-SKY(II)
10      CONTINUE
        X(J) = J
        OUT(J) = SUM
20    CONTINUE
C
C COMPUTE SPATIAL PROFILE, I.E. THE 2-DIM SPECTRUM 
C IS DIVIDED (ROW BY ROW) BY THE SUM
C                                                 
      DO 40 J = 1,M
        DO 30 K = 1,N
          II = (K-1)*M+J
          IF (OUT(J).EQ.0) OUT(J)=1
          PROF(II) = (IN(II)-SKY(II))/OUT(J)
30      CONTINUE
40    CONTINUE
C
C  FILTER SPATIAL PROFILE AND FIT WITH POLYNOMIAL
C
      DO 70 K = 1,N
        DO 50 J = 1,M
          II = (K-1)*M+J
          Y(J) = PROF(II)
50      CONTINUE
C
C  MEDIAN FILTER OF ROWS
C
        CALL FILTER(Y,Z,M,IWIND)
C 
C  FIT WITH POLYNOMIAL 
C
        CALL LSORTH(X,Y,A,B,S,W,M,CHISQ,IORD)
        DO 60 J = 1,M
          II = (K-1)*M+J
          CALL POLY(X(J),YY,A,B,S,W,IORD)
          PROF(II) = YY
60      CONTINUE
70    CONTINUE
C
C NORMALIZE SPATIAL PROFILE AND ENFORCE POSITIVITY
C
      DO 100 J = 1,M
        SUM=0.
        DO 80 K = 1,N
          II = (K-1)*M+J
          IF(PROF(II).LT.0.) PROF(II)=0.
          SUM = SUM+PROF(II)
80      CONTINUE
        DO 90 K = 1,N
          II = (K-1)*M+J
          PROF(II) = PROF(II)/SUM
90      CONTINUE
100   CONTINUE
C
C ITERATE (in the present version, the spatial profile is not 
C iterated, but only the mask and the variance)
C                                                                       
      DO 160 L = 1,ITER                                                  
C                                                                       
C  compute variance estimate                 
C
        DO 120 J = 1,M                                               
          DO 110 K = 1,N                  
           II = (K-1)*M+J
           VARI(II) = V0 + ABS(OUT(J)*PROF(II)+SKY(II))/G
110       CONTINUE
120     CONTINUE
C                                                                       
C MASK COSMIC RAY HITS (ONLY ONE PER COLUMN AND ITERATION)
C
        DO 150 J = 1,M
          RMAX = 1.
          KK = 0
          DO 130 K = 1,N
            II = (K-1)*M+J                                                     
            DIFF = IN(II)-SKY(II)-OUT(J)*PROF(II)
            DIFF2 = DIFF*DIFF
            QUOT = (DIFF2/(SIGMA*VARI(II)))*MASK(II)
            IF(QUOT.GT.RMAX) THEN
              RMAX = QUOT
              KK = K
            ENDIF
130       CONTINUE
          IF(KK.NE.0) THEN
            II = (KK-1)*M+J
            MASK(II) = 0
          ENDIF
C
C COMPUTE WEIGHTED MEAN WITH COSMICS MASKED
C
          SUM1 = 0.
          SUM2 = 0.            
          DO 140 K = 1,N
            II = (K-1)*M+J
            SUM1 = SUM1 + (MASK(II)*PROF(II)*(IN(II)-SKY(II)))/VARI(II)
            SUM2 = SUM2 + (MASK(II)*PROF(II)*PROF(II))        /VARI(II)
140       CONTINUE
          OUT(J) = SUM1/SUM2
150     CONTINUE
160   CONTINUE
C                                                                       
      RETURN
      END                                                           
C
C****************************************************************************
      SUBROUTINE FILTER(ARR,Z,M,IWIND)
C
      IMPLICIT NONE
      INTEGER     II,IWIND,J,M,K
      REAL        ARR(1),Z(1),Y(50),XMED
C
      II = 2*IWIND+1
C
C  SORT DATA IN ARRAY X AND CALL MEDIAN FILTER
C
      DO 20 J = IWIND+1,M-IWIND
        DO 10 K = 1,II
          Y(K) = ARR(J+K-IWIND-1)
10      CONTINUE
C
        CALL MDIAN1(Y,II,XMED)
C
        Z(J) = XMED
20    CONTINUE
C
C  COPY DATA
C
      DO 30 J = IWIND+1,M-IWIND
         ARR(J) = Z(J) 
30    CONTINUE
C
      RETURN
      END
C
C**************************************************************************
      SUBROUTINE MDIAN1(ARR,N,XMED)
C
C COMPUTE MEDIAN VALUE OF AN ARRAY
C
      IMPLICIT NONE
      INTEGER        N,N2
      REAL           ARR(N),XMED
C
C  SORT DATA
C
      CALL SORT(N,ARR)
C
C  COMPUTE MEDIAN
C
      N2 = N/2
      IF(2*N2.EQ.N) THEN
        XMED = 0.5*(ARR(N2)+ARR(N2+1))
      ELSE
        XMED = ARR(N2+1)
      ENDIF
C
      RETURN
      END
C
C************************************************************************
      SUBROUTINE SORT(N,ARR)
C
C SORTS AN ARRAY
C 
      IMPLICIT NONE
      INTEGER     N,I,J
      REAL        A,ARR(N)
C
      DO 20 J = 2,N
        A = ARR(J)      
        DO 5 I = J-1,1,-1
          IF(ARR(I).LE.A) GOTO 10
          ARR(I+1) = ARR(I)
5       CONTINUE
      I = 0
10    ARR(I+1) = A
20    CONTINUE
C
      RETURN
      END
C
C*****************************************************************************
C        POLY : INPUT: XFIT AND POLYNOMIAL COEFFICIENTS COMPUTED
C              WITH LSORTH
C               OUTPUT: YFIT
C                                                                      
        SUBROUTINE POLY(XFIT,YFIT,A,B,S,W,IORD)  
C
        IMPLICIT NONE
        INTEGER           K,IORD            
        REAL              A(10),B(10),S(10),W(10),P(10) 
        REAL              XFIT,YFIT
C   
        P(1)=1.  
        YFIT=S(1) 
C     
        P(2)=XFIT-A(1)   
        YFIT=YFIT+S(2)*P(2) 
C  
        DO 10 K=3,IORD+1   
          P(K)=(XFIT-A(K-1))*(P(K-1))-B(K-1)*P(K-2)
          YFIT=YFIT+S(K)*P(K)   
10      CONTINUE   
        RETURN     
        END 
C
C***************************************************************************   
C        LSORTH : FITS ORTHOGONAL POLYNOMIAL OF MAXIMUM DEGREE IORD
C                 THROUGH X-Y TABLE. AN F-TEST DECIDES WHETHER THE FIT
C                 STOPS ALREADY AT A LOWER ORDER THAN IORD.
C                 THE ARRAY Y IS RETURNED AS A VECTOR
C                 CONTAINING THE RESIDUALS.
C                 THE ROUTINE IS DESCRIBED IN PASP 91 (1979), PG. 546.    
C 
C                 THE POLYNOMIAL COEFFICIENTS ARE RETURNED
C
        SUBROUTINE LSORTH (X,Y,A,B,S,W,M,CHISQ,IORD)
C
        IMPLICIT  NONE
        INTEGER      IMAX,IMAXST,IFAUTO,IORD,I,N,M,I1,IFF,K,K1
        INTEGER      IFTEST
        REAL         X(1),Y(1),A(10),B(10),S(10),W(10),P(10)
        REAL         CHISQ,DEL,XNU,F,F95,DCHI,P2
C
        DATA IMAXST/10/,IFTEST/2/ 
        IMAX=IMAXST     
        IFAUTO=0   
        IF(IORD .LT. 10) GOTO 110
        IORD=9
        IFAUTO=1
 110    CONTINUE 
        IF(IORD .NE. 0) IMAX=MAX0(IABS(IORD)+1,2) 
        DO 10 I=1,IMAXST
        W(I)=0. 
        S(I)=0. 
        A(I)=0. 
10      B(I)=0.
        P(1)=1.
        DO 20 N=1,M
        W(1)=W(1)+1.   
        S(1)=S(1)+Y(N)  
20      A(1)=A(1)+X(N)
        S(1)=S(1)/W(1)
        A(1)=A(1)/W(1)    
        I=1   
        XNU=M-1
30      IFF=1  
40      I1=I   
        IF(IMAX .GT. I) I = I+1    
        CHISQ=0.  
        DO 70 N=1,M    
        P(2)=X(N)-A(1)    
        IF(I .EQ. 2) GOTO 60 
        DO 50 K=3,I
        K1=K-1    
50      P(K)=(X(N)-A(K1))*P(K1)-B(K1)*P(K-2)  
60      DEL=Y(N)-S(I1)*P(I1)   
        Y(N)=DEL  
        CHISQ=CHISQ+DEL*DEL 
        IF(IMAX .LE. I1) GOTO 70  
        P2=P(I)**2
        S(I)=S(I)+DEL*P(I)                                                     
        A(I)=A(I)+X(N)*P2  
        W(I)=W(I)+P2    
70      CONTINUE       
        IF(IMAX .LE. I1) GOTO 80  
        A(I)=A(I)/W(I)  
        B(I)=W(I)/W(I1)  
        S(I)=S(I)/W(I)      
        XNU=XNU-1.     
        DCHI=S(I)**2*W(I)  
        IF(DCHI .GE. CHISQ) GOTO 30   
        F=XNU*DCHI/(CHISQ-DCHI)   
        F95=3.84+(10.+(12.+(30.+105./XNU/XNU)/XNU)/XNU)/XNU    
        IF(F .GT. F95) GOTO 30  
        IF(IFAUTO.EQ.0) GOTO 30  ! F-TEST OFF
        XNU=XNU+1.   
        IFF=IFF+1      
        S(I)=0.   
        IF(IFF .LE. IFTEST) GOTO 40  
80      IORD=MIN0(IMAX-1,I1)-IFF+1
        RETURN 
        END

C===========================================================================
C Copyright (C) 1982-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine RDKEYINV       version 4         831012
C  Ch. Ounnas                ESO - GARCHING
C  from subroutine RDKWRD    version 2         820618
C  A. Kruszewski             ESO Garching
C  renamed to RDKINV         version 5.0       870803
C  A. Kruszewski             ESO Garching
C.PURPOSE
C  reads keywords INV_INTG and INV_REAL and stores them
C  in arrays "IARR" and "RARR"
C.INPUT/OUTPUT
C  output arguments
C  IARR        integer*4 array     values of integer keywords
C  RARR        real*4 array        values of real keywors
C  ISTAT       integer*4           status
C
C
C  IARR(1)  - DEBUG is used to invoke debuging outputs.
C  IARR(2)  - ANALITER sets number of additional iterations in ANALYSE.
C  IARR(3)  - TBLWRITE controls writing an output table.
C  IARR(4)  - VERIFY switches between VERIFY and NOVERIFY options.
C  IARR(5)  - ISOPHOTR activates the use of fixed isophotal radii.
C  IARR(6)  - OUPROFIL gives number of profile points in output table.
C  IARR(7)  - PHYSICAL tells if searched area is defined by
C                     physical coordinates.
C  IARR(8)  - HALFEDGE sets the size of local subarray.
C  IARR(9)  - FIELDVAR 0 for additive and 1 for multipl. field 
C                     variations.
C  IARR(10) - UNITS switches between background 0 and instrument
C                   units 1.
C  IARR(11) - PRFLCTRL number of standard profile points updated.
C  IARR(12) - IARR(15) - IJBORDER sets limits of investigated area.
C  IARR(16) - SKYDETER sets accuracy of sky background
C                      determination.
C  IARR(17) - IARR(18) - ITERATE controls iterations in CLASSIFY.
C  IARR(19) - MARGINS size in pixels of unused margins.
C  IARR(20) - FULLPSF extend in pixels of 2-dim p.s.f.
C  IARR(21) - UNDRSMPL undersampling factor.
C  IARR(22) - BRGTCTRL controls removal of spurious detections.
C  IARR(23) - NETHEDGE half edge of regions used to determine preliminary
C                      sky background in a net of regions.
C
C  RARR(1)  - RARR(2) - LHCUTS
C  RARR(3)  - TRESHOLD
C  RARR(4)  - FILTER sets level of bright pixel filtering.
C  RARR(5)  - RARR(7) - CLASSPAR controls preliminary classification.
C  RARR(8)  - BRGHTLMT divides objects onto bright and faint ones
C                     for classification purposes.
C  RARR(9)  - DISTANCE limiting distance in the parameters space.
C  RARR(10) - EXPRTIME exposure time in seconds.
C  RARR(11) - ZEROMAGN calibrates magnitudes.
C  RARR(12) - RARR(13) - STMETRIC radii of two fixed apertures in pixels.
C  RARR(14) - RARR(18) - SPROFIL1 differential logarithmic p.s.f.
C  RARR(19) - RARR(23) - SPROFIL2      "            "        "
C  RARR(24) - RARR(28) - SPROFIL3      "            "        "
C  RARR(29) - RARR(33) - SPROFIL4      "            "        "
C  RARR(34) - RARR(38) - SPROFIL5      "            "        "
C  RARR(39) - CTRLMODE controls mode determination.
C  RARR(40) - CVFACTOR controls termination of mode determination.
C  RARR(41) - SGFACTOR sets clipping factor at mode determination.
C  RARR(42) - PAIRSPRT minimum allowable pair separation.
C  RARR(43) - MULTDTCT maximum separation of detections 
C                      of a single object.
C  RARR(44) - ELONGLMT minimum elongation of double object.
C  RARR(45) - YFACTOR ratio of dimensions of scanning rectangle.
C  RARR(46) - DFVALLEY minimal depth of separating two 
C                      components valley.
C  RARR(47) - BRIGHTOB controls cleaning of faint components.
C  RARR(48) - SKYSAMPL controls sampling of sky for background
C                      determination.
C  RARR(49) - RARR(51) - PRFLCLNG controls approximate cleaning.
C  RARR(52) - NEBLIMIT controls detection of extended objects.
C  RARR(53) - ETAFUNCT parameter at Petrosian quantities determination.
C  RARR(54) - RARR(57) - XYBORDER limits of investigated area
C                               in physical units.
C 
C.VERSION
C 100511		last modif
C 
C-----------------------------------------------------------------------
      SUBROUTINE RDKINV(IARR,RARR,ISTAT)
C
      IMPLICIT  NONE
      INTEGER   IARR(32)
      REAL      RARR(64) 
      INTEGER   ISTAT
C
      INTEGER   IACT
      INTEGER   KUN , KNUL
C
      DO 100 IACT=1,32 
         IARR(IACT) = 0
100   CONTINUE
      DO 200 IACT=1,64 
         RARR(IACT) = 0.0
200   CONTINUE
C 
      CALL STKRDI( 'INV_INTG' , 1 , 23 , IACT , IARR , KUN ,
     &                                          KNUL , ISTAT )
      CALL STKRDR( 'INV_REAL' , 1 , 57 , IACT , RARR , KUN ,
     &                                          KNUL , ISTAT )
C
      RETURN
C
      END
C

C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE OPCC(OPCODE,CONSTA,CONSTB,CONSTC)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine OPCC           version 2.00      880202
C  K. Banse                  ESO - Garching
C  source code on file CALC.FOR
C
C.KEYWORDS
C  bulk data frames, arithmetic operations
C
C.PURPOSE
C  perform arithmetic on arrays
C
C.ALGORITHM
C  do it according to opcode ( `, +, -, *, / or =)
C  ` means ** (to the power of)
C  special condition handler is used for division by "zero"
C
C.INPUT/OUTPUT
C  call as OPCC(OPCODE,CONSTA,CONSTB,CONSTC)
C
C  input par:
C  OPCODE:      char.exp.      operation code in postfix notation, e.g. "FF+"
C  A:            R*4 array      1. input array
C  B:            R*4 array      2. input array
C  SCALR:      R*4            scalar value
C  CONSTA:      R*4            1. input scalar
C  CONSTB:      R*4            2. input scalar
C  NDIM:      I*4            size of arrays involved
C
C  output par:
C  C:            R*4 array      result array
C  CONSTC:      R*4            result scalar
C
C.VERSION
C 030710	last modif
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      NCOUNT
C
      REAL     CONSTA,CONSTB,CONSTC
      REAL     USRNUL,EPSP,EPSN
C
      CHARACTER*(*)      OPCODE
C
      COMMON      /NULCOM/NCOUNT,USRNUL
C 
      DATA  EPSP /10.0E-33/, EPSN /-10.0E-33/
C
C  branch according to opcode
C
C  subtract 2. scalar from 1. scalar value
      IF (OPCODE(3:3).EQ.'-') THEN
         CONSTC = CONSTA - CONSTB
C
C  add scalars
      ELSE IF (OPCODE(3:3).EQ.'+') THEN
         CONSTC = CONSTA + CONSTB
C
C  divide 1. scalar by 2. scalar
      ELSE IF (OPCODE(3:3).EQ.'/') THEN
         IF ((CONSTB.LT.EPSP) .AND.
     +       (CONSTB.GT.EPSN)) THEN		!always check divisor...
            CONSTC = USRNUL
            NCOUNT = NCOUNT + 1
         ELSE
            CONSTC = CONSTA / CONSTB
         ENDIF
C
C  multiply scalars
      ELSE IF (OPCODE(3:3).EQ.'*') THEN
         CONSTC = CONSTA * CONSTB
C
C  compute 1. scalar ** 2. scalar
      ELSE IF (OPCODE(3:3).EQ.'`') THEN
C	on OSF/DEC Unix the usual FORTRAN statement:
C	CONSTC = CONSTA ** CONSTB 
C	does not work if CONSTA < 0. - so we have to do it in C ...
         CALL CPOWER(CONSTA,CONSTB,CONSTC)
      ELSE
         WRITE(*,10000)
      ENDIF
      RETURN
C
10000 FORMAT(' OPCC: We should not come here...')
C
      END

      SUBROUTINE FUN1C(CFUNC,AVAL,CVAL)
C
      IMPLICIT NONE
C
      INTEGER    NCOUNT
C
      REAL       AVAL,CVAL
      REAL       TEMP,USRNUL,PI
C
      CHARACTER*5  CFUNC
C
      COMMON      /NULCOM/NCOUNT,USRNUL
C
      DATA     PI /3.141593/                         !Pi
C
C  branch according to function 
C
C  SQRT
      IF (CFUNC.EQ.'SQRT ') THEN
         IF (AVAL.LT.0.) THEN
            CVAL = USRNUL
            NCOUNT = NCOUNT + 1
         ELSE
            CVAL = SQRT(AVAL)
         ENDIF
C
C  LN
      ELSE IF (CFUNC.EQ.'LN   ') THEN
         IF (AVAL.LE.0.) THEN
            CVAL = USRNUL
            NCOUNT = NCOUNT + 1
         ELSE
            CVAL = LOG(AVAL)
         ENDIF
C
C  LOG10 or LOG
      ELSE IF (CFUNC(1:3).EQ.'LOG') THEN
         IF (AVAL.LE.0.) THEN
            CVAL = USRNUL
            NCOUNT = NCOUNT + 1
         ELSE
            CVAL = LOG10(AVAL)
         ENDIF
C
C  EXP
      ELSE IF (CFUNC.EQ.'EXP  ') THEN
         CVAL = EXP(AVAL)
C
C  EXP10
      ELSE IF (CFUNC.EQ.'EXP10') THEN
         CVAL = 10. ** AVAL
C
C  SIN
      ELSE IF (CFUNC.EQ.'SIN  ') THEN
         TEMP = (AVAL / 180.) * PI                !degrees -> radians
         CVAL = SIN(TEMP)
C
C  COS
      ELSE IF (CFUNC.EQ.'COS  ') THEN
         TEMP = (AVAL / 180.) * PI                !degrees -> radians
         CVAL = COS(TEMP)
C
C  TAN
      ELSE IF (CFUNC.EQ.'TAN  ') THEN
         TEMP = (AVAL / 180.) * PI                !degrees -> radians
         CVAL = TAN(TEMP)
C
C  ASIN
      ELSE IF (CFUNC.EQ.'ASIN ') THEN
         TEMP = ASIN(AVAL)
         CVAL = (TEMP * 180.) / PI                !radians -> degrees
C
C  ACOS
      ELSE IF (CFUNC.EQ.'ACOS ') THEN
         TEMP = ACOS(AVAL)
         CVAL = (TEMP * 180.) / PI                !radians -> degrees
C
C  ATAN
      ELSE IF (CFUNC.EQ.'ATAN ') THEN
         TEMP = ATAN(AVAL)
         CVAL = (TEMP * 180.) / PI                !radians -> degrees
C
C  NINT
      ELSE IF (CFUNC.EQ.'INT  ') THEN
         CVAL = FLOAT(NINT(AVAL))
C
C  ABS
      ELSE IF (CFUNC.EQ.'ABS  ') THEN
         CVAL = ABS(AVAL)
C
      ELSE
         WRITE(*,10000)
      ENDIF
      RETURN          
C 
10000 FORMAT(' FUN1C: We should not come here...')
      END

      SUBROUTINE FUN2CC(CFUNC,AVAL,CVAL)
C
      IMPLICIT NONE
C
      REAL          AVAL(2),CVAL,PI
      REAL          TEMP
C
      CHARACTER*5      CFUNC
C
      DATA     PI /3.141593/                         !Pi
C
C  branch according to function
C
C  function ATAN2
      IF (CFUNC.EQ.'ATAN2') THEN
         TEMP = ATAN2(AVAL(1),AVAL(2))
         CVAL = (TEMP * 180.) / PI                !radians -> degrees
C
C  get minimum
      ELSE IF (CFUNC.EQ.'MIN  ') THEN
         CVAL = MIN(AVAL(1),AVAL(2))
C
C  get maximum
      ELSE IF (CFUNC.EQ.'MAX  ') THEN
         CVAL = MAX(AVAL(1),AVAL(2))
C
C  get remainder
      ELSE IF (CFUNC.EQ.'MOD  ') THEN
         CVAL = MOD(AVAL(1),AVAL(2))
C
      ELSE
         WRITE(*,10000)
      ENDIF
      RETURN
C
10000 FORMAT(' FUN2CC: We should not come here...')
C
      END

      SUBROUTINE OPFFW(OPCODE,A,B,C,APIX,BPIX,CPIX,
     +                 NPIXA,NPIXB,NPIXC)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine OPFFW            version 2.00      880202
C             FN2FFW                   2.00      880202
C  K. Banse                        ESO - Garching
C
C.KEYWORDS
C  bulk data frames, arithmetic operations
C
C.PURPOSE
C  perform arithmetic on arrays
C
C.ALGORITHM
C  do it according to opcode ( `, +, -, *, / or =)
C  ` means ** (to the power of)
C  special condition handler is used for division by "zero"
C
C.INPUT/OUTPUT
C  call as OPFFW(OPCODE,A,B,C,APIX,BPIX,CPIX,NPIXA,NPIXB,NPIXC)
C
C  input par:
C  OPCODE:      char.exp.      operation code in postfix notation, e.g. "FF+"
C  A:            R*4 array      1. input array
C  B:            R*4 array      2. input array
C  APIX:      I*4 array      start + end pixels for A
C  BPIX:      I*4 array      start + end pixels for B
C  CPIX:      I*4 array      start + end pixels for C
C  NPIXA:      I*4            no. of pixels per line in A
C  NPIXB:      I*4            no. of pixels per line in B
C  NPIXC:      I*4            no. of pixels per line in C
C
C  output par:
C  C:            R*4 array      result array
C
C.VERSION
C 030710	last modif
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      N,NN,NNN,NCOUNT
      INTEGER      NX,NY,NZ,OFFA,OFFB,OFFC
      INTEGER      XOFFA,XOFFB,XOFFC
      INTEGER      YOFFA,YOFFB,YOFFC
      INTEGER      ZOFFA,ZOFFB,ZOFFC
      INTEGER      APIX(3,2),BPIX(3,2),CPIX(3,2)
      INTEGER      NPIXA(*),NPIXB(*),NPIXC(*)
C
      CHARACTER*(*) OPCODE
C
      REAL     A(*),B(*),C(*)
      REAL     USRNUL,EPSP,EPSN,RR
C
      COMMON      /NULCOM/NCOUNT,USRNUL
C
      DATA  EPSP /10.0E-33/, EPSN /-10.0E-33/
C
C  init
      NX = APIX(1,2) - APIX(1,1) + 1
      NY = APIX(2,2) - APIX(2,1) + 1
      NZ = APIX(3,2) - APIX(3,1) + 1
C
      XOFFA = APIX(1,1) - 1
      XOFFC = CPIX(1,1) - 1
      YOFFA = (APIX(2,1)-1)*NPIXA(1)
      YOFFC = (CPIX(2,1)-1)*NPIXC(1)
      ZOFFA = (APIX(3,1)-1)*NPIXA(1)*NPIXA(2)
      ZOFFC = (CPIX(3,1)-1)*NPIXC(1)*NPIXC(2)
C
C  copy 1. frame into result frame
      IF (OPCODE(3:3).EQ.'=') THEN
         DO 5500, NNN=1,NZ
            OFFA = ZOFFA + YOFFA + XOFFA
            OFFC = ZOFFC + YOFFC + XOFFC
C
            DO 5300, NN = 1,NY
               DO 5200, N=1,NX
                  C(OFFC+N) = A(OFFA+N)
5200           CONTINUE
               OFFA = OFFA + NPIXA(1)
               OFFC = OFFC + NPIXC(1)
5300        CONTINUE
C
            ZOFFA = ZOFFA + NPIXA(1)*NPIXA(2)
            ZOFFC = ZOFFC + NPIXC(1)*NPIXC(2)
5500     CONTINUE
         RETURN
      ENDIF
C
C 
      XOFFB = BPIX(1,1) - 1            	!all other opcodes have 3 operands
      YOFFB = (BPIX(2,1)-1)*NPIXB(1)
      ZOFFB = (BPIX(3,1)-1)*NPIXB(1)*NPIXB(2)
C
C  branch according to opcode
C
C  add frames
      IF (OPCODE(3:3).EQ.'+') THEN
         DO 1500, NNN=1,NZ
            OFFA = ZOFFA + YOFFA + XOFFA
            OFFB = ZOFFB + YOFFB + XOFFB
            OFFC = ZOFFC + YOFFC + XOFFC
C
            DO 1300, NN = 1,NY
               DO 1100, N=1,NX
                  C(OFFC+N) = A(OFFA+N) + B(OFFB+N)
1100           CONTINUE
               OFFA = OFFA + NPIXA(1)
               OFFB = OFFB + NPIXB(1)
               OFFC = OFFC + NPIXC(1)
1300        CONTINUE
C
            ZOFFA = ZOFFA + NPIXA(1)*NPIXA(2)
            ZOFFB = ZOFFB + NPIXB(1)*NPIXB(2)
            ZOFFC = ZOFFC + NPIXC(1)*NPIXC(2)
1500     CONTINUE
C
C  subtract 2. frame from 1. frame
      ELSE IF (OPCODE(3:3).EQ.'-') THEN
         DO 2500, NNN=1,NZ
            OFFA = ZOFFA + YOFFA + XOFFA
            OFFB = ZOFFB + YOFFB + XOFFB
            OFFC = ZOFFC + YOFFC + XOFFC
C
            DO 2300, NN = 1,NY
               DO 2200, N=1,NX
                  C(OFFC+N) = A(OFFA+N) - B(OFFB+N)
2200           CONTINUE
               OFFA = OFFA + NPIXA(1)
               OFFB = OFFB + NPIXB(1)
               OFFC = OFFC + NPIXC(1)
2300        CONTINUE
C
            ZOFFA = ZOFFA + NPIXA(1)*NPIXA(2)
            ZOFFB = ZOFFB + NPIXB(1)*NPIXB(2)
            ZOFFC = ZOFFC + NPIXC(1)*NPIXC(2)
2500     CONTINUE
C
C  multiply frames
      ELSE IF (OPCODE(3:3).EQ.'*') THEN
         DO 3500, NNN=1,NZ
            OFFA = ZOFFA + YOFFA + XOFFA
            OFFB = ZOFFB + YOFFB + XOFFB
            OFFC = ZOFFC + YOFFC + XOFFC
C
            DO 3300, NN = 1,NY
               DO 3200, N=1,NX
                  C(OFFC+N) = A(OFFA+N) * B(OFFB+N)
3200           CONTINUE
               OFFA = OFFA + NPIXA(1)
               OFFB = OFFB + NPIXB(1)
               OFFC = OFFC + NPIXC(1)
3300        CONTINUE
C
            ZOFFA = ZOFFA + NPIXA(1)*NPIXA(2)
            ZOFFB = ZOFFB + NPIXB(1)*NPIXB(2)
            ZOFFC = ZOFFC + NPIXC(1)*NPIXC(2)
3500     CONTINUE
C
C  divide 1. frame by 2. frame
      ELSE IF (OPCODE(3:3).EQ.'/') THEN
C 
         DO 4800, NNN=1,NZ
            OFFA = ZOFFA + YOFFA + XOFFA
            OFFB = ZOFFB + YOFFB + XOFFB
            OFFC = ZOFFC + YOFFC + XOFFC
C
            DO 4700, NN = 1,NY
               DO 4600, N=1,NX
                  RR = B(OFFB+N)
                  IF ((RR .LT. EPSP) .AND. (RR .GT. EPSN)) THEN
                     C(OFFC+N) = USRNUL
                     NCOUNT = NCOUNT + 1
                  ELSE
                     C(OFFC+N) = A(OFFA+N) / RR
                  ENDIF
4600           CONTINUE
               OFFA = OFFA + NPIXA(1)
               OFFB = OFFB + NPIXB(1)
               OFFC = OFFC + NPIXC(1)
4700        CONTINUE
C
            ZOFFA = ZOFFA + NPIXA(1)*NPIXA(2)
            ZOFFB = ZOFFB + NPIXB(1)*NPIXB(2)
            ZOFFC = ZOFFC + NPIXC(1)*NPIXC(2)
4800     CONTINUE
C
C  compute 1. frame ** 2. frame
      ELSE IF (OPCODE(3:3).EQ.'`') THEN
         DO 6500, NNN=1,NZ
            OFFA = ZOFFA + YOFFA + XOFFA
            OFFB = ZOFFB + YOFFB + XOFFB
            OFFC = ZOFFC + YOFFC + XOFFC
C
            DO 6300, NN = 1,NY
               DO 6200, N=1,NX
                  C(OFFC+N) = A(OFFA+N) ** B(OFFB+N)
6200           CONTINUE
               OFFA = OFFA + NPIXA(1)
               OFFB = OFFB + NPIXB(1)
               OFFC = OFFC + NPIXC(1)
6300        CONTINUE
C
            ZOFFA = ZOFFA + NPIXA(1)*NPIXA(2)
            ZOFFB = ZOFFB + NPIXB(1)*NPIXB(2)
            ZOFFC = ZOFFC + NPIXC(1)*NPIXC(2)
6500     CONTINUE
C 
      ELSE
         WRITE(*,10000)
      ENDIF
      RETURN
C
10000 FORMAT(' OPFFW: We should not come here...')
      END

      SUBROUTINE FN2FFW(CFUNC,A,B,C,APIX,BPIX,CPIX,
     +                  NPIXA,NPIXB,NPIXC)
C
      IMPLICIT NONE
C
      INTEGER      N,NN,NNN
      INTEGER      NX,NY,NZ,OFFA,OFFB,OFFC
      INTEGER      XOFFA,XOFFB,XOFFC
      INTEGER      YOFFA,YOFFB,YOFFC
      INTEGER      ZOFFA,ZOFFB,ZOFFC
      INTEGER      APIX(3,2),BPIX(3,2),CPIX(3,2)
      INTEGER      NPIXA(*),NPIXB(*),NPIXC(*)
C
      CHARACTER*5   CFUNC
C
      REAL          A(*),B(*),C(*),FACT,RA,RB
C
      DATA   FACT  /0.0174533/
C
C  init
      NX = APIX(1,2) - APIX(1,1) + 1
      NY = APIX(2,2) - APIX(2,1) + 1
      NZ = APIX(3,2) - APIX(3,1) + 1
C
      XOFFA = APIX(1,1) - 1
      XOFFB = BPIX(1,1) - 1
      XOFFC = CPIX(1,1) - 1
      YOFFA = (APIX(2,1)-1)*NPIXA(1)
      YOFFB = (BPIX(2,1)-1)*NPIXB(1)
      YOFFC = (CPIX(2,1)-1)*NPIXC(1)
      ZOFFA = (APIX(3,1)-1)*NPIXA(1)*NPIXA(2)
      ZOFFB = (BPIX(3,1)-1)*NPIXB(1)*NPIXB(2)
      ZOFFC = (CPIX(3,1)-1)*NPIXC(1)*NPIXC(2)
C
C  branch according to function
C
C  function ATAN2
      IF (CFUNC.EQ.'ATAN2') THEN
         DO 1500, NNN=1,NZ
            OFFA = ZOFFA + YOFFA + XOFFA
            OFFB = ZOFFB + YOFFB + XOFFB
            OFFC = ZOFFC + YOFFC + XOFFC
C
            DO 1300, NN = 1,NY
               DO 1200, N=1,NX
                  RA = A(OFFA+N) * FACT
                  RB = B(OFFB+N) * FACT
                  C(OFFC+N) = ATAN2(RA,RB)
1200           CONTINUE
               OFFA = OFFA + NPIXA(1)
               OFFB = OFFB + NPIXB(1)
               OFFC = OFFC + NPIXC(1)
1300        CONTINUE
C
            ZOFFA = ZOFFA + NPIXA(1)*NPIXA(2)
            ZOFFB = ZOFFB + NPIXB(1)*NPIXB(2)
            ZOFFC = ZOFFC + NPIXC(1)*NPIXC(2)
1500     CONTINUE
C
C  minimum of 2 frames
      ELSE IF (CFUNC.EQ.'MIN  ') THEN
         DO 2500, NNN=1,NZ
            OFFA = ZOFFA + YOFFA + XOFFA
            OFFB = ZOFFB + YOFFB + XOFFB
            OFFC = ZOFFC + YOFFC + XOFFC
C
            DO 2300, NN = 1,NY
               DO 2200, N=1,NX
                  C(OFFC+N) = MIN(A(OFFA+N),B(OFFB+N))
2200           CONTINUE
               OFFA = OFFA + NPIXA(1)
               OFFB = OFFB + NPIXB(1)
               OFFC = OFFC + NPIXC(1)
2300        CONTINUE
C
            ZOFFA = ZOFFA + NPIXA(1)*NPIXA(2)
            ZOFFB = ZOFFB + NPIXB(1)*NPIXB(2)
            ZOFFC = ZOFFC + NPIXC(1)*NPIXC(2)
2500     CONTINUE
C
C  maximum of 2 frames
      ELSE IF (CFUNC.EQ.'MAX  ') THEN
         DO 3500, NNN=1,NZ
            OFFA = ZOFFA + YOFFA + XOFFA
            OFFB = ZOFFB + YOFFB + XOFFB
            OFFC = ZOFFC + YOFFC + XOFFC
C
            DO 3300, NN = 1,NY
               DO 3200, N=1,NX
                  C(OFFC+N) = MAX(A(OFFA+N),B(OFFB+N))
3200           CONTINUE
               OFFA = OFFA + NPIXA(1)
               OFFB = OFFB + NPIXB(1)
               OFFC = OFFC + NPIXC(1)
3300        CONTINUE
C
            ZOFFA = ZOFFA + NPIXA(1)*NPIXA(2)
            ZOFFB = ZOFFB + NPIXB(1)*NPIXB(2)
            ZOFFC = ZOFFC + NPIXC(1)*NPIXC(2)
3500     CONTINUE
C
C  remainder of 1.frame/2. frames
      ELSE IF (CFUNC.EQ.'MOD  ') THEN
         DO 4500, NNN=1,NZ
            OFFA = ZOFFA + YOFFA + XOFFA
            OFFB = ZOFFB + YOFFB + XOFFB
            OFFC = ZOFFC + YOFFC + XOFFC
C
            DO 4300, NN = 1,NY
               DO 4200, N=1,NX
                  C(OFFC+N) = MOD(A(OFFA+N),B(OFFB+N))
4200           CONTINUE
               OFFA = OFFA + NPIXA(1)
               OFFB = OFFB + NPIXB(1)
               OFFC = OFFC + NPIXC(1)
4300        CONTINUE
C
            ZOFFA = ZOFFA + NPIXA(1)*NPIXA(2)
            ZOFFB = ZOFFB + NPIXB(1)*NPIXB(2)
            ZOFFC = ZOFFC + NPIXC(1)*NPIXC(2)
4500     CONTINUE
C 
      ELSE
         WRITE(*,10000)
      ENDIF
      RETURN
C
10000 FORMAT(' FN2FFW: We should not come here...')
      END
C 

      SUBROUTINE DSPNUL(NCC)
C 
      INTEGER     NCC
      INTEGER     NCOUNT,STAT
C 
      CHARACTER   OUTPUT*80
C 
      REAL        USRNUL
      COMMON      /NULCOM/NCOUNT,USRNUL
C      
      IF (NCC.GT.1) THEN
         WRITE(OUTPUT,10000) NCC,USRNUL
      ELSE
         WRITE(OUTPUT,10001) USRNUL
      ENDIF
      CALL STTPUT(OUTPUT,STAT)
      RETURN
C      
C  format
C 
10000 FORMAT(I7,' undefined pixels ... set to "null value" = ',G15.7)
10001 FORMAT('1 undefined pixel ... set to "null value" = ',G15.7)
C      
      END

C @(#)avarea.for	19.1 (ES0-DMD) 02/25/03 14:01:03
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      REAL FUNCTION AVAREA(METHOD,A,NPIX,SUBPIX,NDIM,O)
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C	
C.IDENTIFICATION
C  real function AVAREA		version 2.80	880630
C  K. Banse			ESO - Garching
C 
C.KEYWORDS
C  median filter, average
C 
C.PURPOSE
C  find median value or average
C 
C.ALGORITHM
C  as in [MIDAS.PRIM.SUB1]AVERAGE.FOR
C	
C.INPUT/OUTPUT
C  use as VALUE = AV_AREA(METHOD,A,NPIX,SUBPIX,NDIM,O)
C  
C input par:
C  METHOD:	char. exp.	A for average, M for median
C  A:		R*4 array	input array
C  NPIX:	I*4		no. of pixels per line
C  SUBPIX:	I*4 array	start pixels of area
C  NDIM:	I*4 array	no. of pixels in subarea
C  O:		R*4 array	working buffer
C	
C  AVAREA:	R*4		median value to be returned
C	
C --------------------------------------------------------------------
C
      IMPLICIT NONE
C 
      INTEGER      NPIX,NDIM(*),SUBPIX(*)
      INTEGER      INDX,NH,NN,NNN,NTOT,NX,NY,OFF,TOP
C 
      REAL         A(*),O(*)
C 
      CHARACTER*(*)  METHOD
C 
      DOUBLE PRECISION   SUM
C      
C  point to first pixel (in lower left corner)
      OFF = (SUBPIX(2)-1)*NPIX + SUBPIX(1)
      NTOT = NDIM(1) * NDIM(2)
C      
C  branch according to method
      IF (METHOD(1:1).EQ.'A') GOTO 5000
C      
C  here for median finding
C      
      O(1) = A(OFF)
      TOP = 1
      NH = (NTOT + 1)/2             !index of median
C
C  move through rest of first line
      DO 1200 NX=1,NDIM(1)-1
         INDX = OFF + NX                  !point to "first" pixel in row
C      
C  fill array O only from 1 to NH
         DO 800 NN=1,TOP                  !loop through already ordered set
            IF (A(INDX).LT.O(NN)) THEN
               DO 600 NNN=TOP,NN,-1
                  O(NNN+1) = O(NNN)       !shift up ...
600            CONTINUE
             O(NN) = A(INDX)              !merge value into array O
             GOTO 1000
            ENDIF
800      CONTINUE
C 
         O(TOP+1) = A(INDX)               !add value on top
1000     IF (TOP.LT.NH) TOP = TOP + 1
C      
1200  CONTINUE
C      
C  test, if we are only handling single line
      IF (NDIM(2).LE.1) THEN
         AVAREA = O(NH)
         RETURN
      ELSE
         OFF = OFF + NPIX - 1             !point to next line (start value - 1)
      ENDIF
C      
C  handle remaining lines
      DO 2300 NY=1,NDIM(2)-1
         DO 2200 NX=1,NDIM(1)
            INDX = OFF + NX               !point to "first" pixel in row
C      
C  fill array O only from 1 to NH
            DO 1800 NN=1,TOP              !loop through already ordered set
               IF (A(INDX).LT.O(NN)) THEN
                  DO 1600 NNN=TOP,NN,-1
                     O(NNN+1) = O(NNN)    !shift up ...
1600              CONTINUE
                  O(NN) = A(INDX)         !merge value into array O
                  GOTO 2000
               ENDIF
1800        CONTINUE
C 
            O(TOP+1) = A(INDX)            !add value on top
2000        IF (TOP.LT.NH) TOP = TOP + 1
2200     CONTINUE
         OFF = OFF + NPIX
2300  CONTINUE
C      
C  return median value
      AVAREA = O(NH)
      RETURN
C      
C  here for simple averaging
C      
5000  OFF = OFF - 1
      SUM = 0.D0
      DO 6000 NY=1,NDIM(2)
         DO 5500 NX=1,NDIM(1)
            SUM = SUM + A(OFF+NX)
5500     CONTINUE
         OFF = OFF + NPIX
6000  CONTINUE
C      
C  return average value
      AVAREA = SNGL(SUM/DBLE(NTOT))
      RETURN
C      
      END

C @(#)satbad.for	19.1 (ES0-DMD) 02/25/03 13:25:38
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE SATBAD(A, JAPY, IBUF, I, J, LHED, RARR, MAS)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C
C-----------------------------------------------------------------------
      IMPLICIT    NONE
      INCLUDE     'MID_REL_INCL:INVENT.INC'
C
      REAL        A(1)
      INTEGER     JAPY(1)
      INTEGER     IBUF(4)
      INTEGER     I
      INTEGER     J
      INTEGER     LHED
      REAL        RARR(64)
      INTEGER     MAS((-MAXSUB):MAXSUB,(-MAXSUB):MAXSUB)
C
      INTEGER     JL , JOF , JOFF , K , K1 , K2 , L , L1 , L2
      REAL        HCUT , LCUT , TEMP
C
      LCUT = RARR(1)
      HCUT = RARR(2)
      JOFF = IBUF(2) - 1
C
      K1 = MAX( I-LHED , IBUF(1) )
      L1 = MAX( J-LHED , IBUF(2) )
      K2 = MIN( I+LHED , IBUF(3) )
      L2 = MIN( J+LHED , IBUF(4) )
      DO 10 L = L1 , L2
          JL = L - J
          JOF = JAPY(L-JOFF)
          DO 20 K = K1 , K2
              TEMP = A(JOF+K)
              IF ( TEMP .GE. HCUT ) THEN
                  MAS(K-I,JL) = -1
              ELSE IF ( TEMP .LE. LCUT ) THEN
                  MAS(K-I,JL) = 0
              ELSE
                  MAS(K-I,JL) = 1
              ENDIF
   20     CONTINUE
   10 CONTINUE
C
      RETURN
C
      END

c
c
c
      real function rbfrac(a,b,x)
c implementation of Lentz's continued fraction 
c based on ideas from Numerical Recipes (Press et. al., 1986)
      implicit none
      real a,b,x,zero,one,emmax,em,em2,s1,s2,s3,d2m,d2m1,
     $   p2m,p2m1,p2m0,q2m,q2m1,q2m0,fac,frac,fold,tol
      parameter (zero=0.,one=1.,emmax=100d0,tol=3e-7)
      s1=a+b
      s2=a+one
      s3=a-one
      p2m0=one
      q2m0=one
      frac=one
      fac= one-s1*x/s2
      em=zero
c  Abramovitz & Stegun, 1971 (26.5.8) continued fraction
 1      em=em+one
        em2=em+em
c  d2m fraction
        d2m=em*(b-em)*x/((s3+em2)*(a+em2))
        p2m=frac+d2m*p2m0
        q2m=fac+d2m*q2m0
c  d2m1 fraction
        d2m1=-(a+em)*(s1+em)*x/((a+em2)*(s2+em2))
        p2m1=p2m+d2m1*frac
        q2m1=q2m+d2m1*fac
c  d2m and d2m1 fractions combined
        p2m0=p2m/q2m1
        q2m0=q2m/q2m1
        fold=frac
        frac=p2m1/q2m1
        fac=one
        if(em.lt.emmax.and.
     $     abs(fold-frac).gt.tol*abs(frac)) go to 1
      if (em.ge.emmax) then
        rbfrac = -999999.9
        return
      endif
      rbfrac=frac
      end
c

C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================

C ++++++++++++++++++++++++  TBA.FOR +++++++++++++++++++++++++++++++++++++++
C .LANGUAGE Fortran 77
C .IDENTIFICATION Module TBA.FOR
C  AUTHOR         M. Peron (ESO-IPG))
C  Module contains layer between the table related FORTRAN TBxxxx interfaces
C  and the TC_interfaces written in (hopefully independent) C
C .KEYWORDS       standard interfaces.
C .ENVIRONMENT    FORTRAN and C standards
C .VERSION  [1.00] 871207:  created from SXFTOC.C
C -----------------------------------------------------------------------------
C

      SUBROUTINE TBAWRC(TID,ROW,COL,INDEX,ITEMS,VALUE,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   VALUE
      INTEGER     TID, ROW, COL, INDEX, ITEMS
      INTEGER     STATUS
C 
      CALL TBA1(TID,ROW,COL,INDEX)
      CALL TBWRC(ITEMS,VALUE,STATUS)
C
      RETURN
      END
C
      SUBROUTINE TBAWRD(TID, ROW, COL, INDEX, ITEMS, VALUE,STATUS)
C
      IMPLICIT NONE
C
      DOUBLE PRECISION   VALUE(*)
      INTEGER     TID, ROW, COL, INDEX, ITEMS
      INTEGER     STATUS
C
      CALL TBA1(TID,ROW,COL,INDEX)
      CALL TBWRD(ITEMS,VALUE,STATUS)
C
      RETURN
      END
C

      SUBROUTINE TBAWRI(TID, ROW, COL, INDEX, ITEMS, VALUE,STATUS)
C
      IMPLICIT NONE
C
      INTEGER   VALUE(*)
      INTEGER     TID, ROW, COL, INDEX, ITEMS
      INTEGER     STATUS
C
      CALL TBA1(TID,ROW,COL,INDEX)
      CALL TBWRI(ITEMS,VALUE,STATUS)
C
      RETURN
      END
C
      SUBROUTINE TBAWRR(TID, ROW, COL, INDEX, ITEMS, VALUE,STATUS)
C
      IMPLICIT NONE
C
      REAL   VALUE(*)
      INTEGER     TID, ROW, COL, INDEX, ITEMS
      INTEGER     STATUS
C
      CALL TBA1(TID,ROW,COL,INDEX)
      CALL TBWRR(ITEMS,VALUE,STATUS)
C
      RETURN
      END
C

      SUBROUTINE TBARDC(TID, ROW, COL, INDEX, ITEMS, VALUE,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   VALUE
      INTEGER     TID, ROW, COL, INDEX, ITEMS
      INTEGER     STATUS
C
      CALL TBA1(TID,ROW,COL,INDEX)
      CALL TBRDC(ITEMS,VALUE,STATUS)
C
      RETURN
      END
C

      SUBROUTINE TBARDD(TID, ROW, COL, INDEX, ITEMS, VALUE,STATUS)
C
      IMPLICIT NONE
C
      DOUBLE PRECISION   VALUE(*)
      INTEGER     TID, ROW, COL, INDEX, ITEMS
      INTEGER     STATUS
C
      CALL TBA1(TID,ROW,COL,INDEX)
      CALL TBRDD(ITEMS,VALUE,STATUS)
C
      RETURN
      END
C
      SUBROUTINE TBARDI(TID, ROW, COL, INDEX, ITEMS, VALUE,STATUS)
C
      IMPLICIT NONE
C
      INTEGER   VALUE(*)
      INTEGER     TID, ROW, COL, INDEX, ITEMS
      INTEGER     STATUS
C
      CALL TBA1(TID,ROW,COL,INDEX)
      CALL TBRDI(ITEMS,VALUE,STATUS)
C
      RETURN
      END
C

      SUBROUTINE TBARDR(TID, ROW, COL, INDEX, ITEMS, VALUE,STATUS)
C
      IMPLICIT NONE
C
      REAL   VALUE(*)
      INTEGER     TID, ROW, COL, INDEX, ITEMS
      INTEGER     STATUS
C
      CALL TBA1(TID,ROW,COL,INDEX)
      CALL TBRDR(ITEMS,VALUE,STATUS)
C
      RETURN
      END
C

      SUBROUTINE TBASCC(TID,ROW,COL,INDEX,ITEMS,VALUE,NEXT,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*) VALUE
      INTEGER     TID, ROW, COL, INDEX, ITEMS
      INTEGER     NEXT, STATUS
C
      CALL TBA1(TID,ROW,COL,INDEX)
      CALL TBSCC(ITEMS,VALUE,NEXT,STATUS)
C
      RETURN
      END
C

      SUBROUTINE TBASCD(TID,ROW,COL,INDEX,ITEMS,VALUE,NEXT,STATUS)
C
      IMPLICIT NONE
C
      DOUBLE PRECISION   VALUE(*)
      INTEGER     TID, ROW, COL, INDEX, ITEMS
      INTEGER     NEXT, STATUS
C
      CALL TBA1(TID,ROW,COL,INDEX)
      CALL TBSCD(ITEMS,VALUE,NEXT,STATUS)
C
      RETURN
      END
C

      SUBROUTINE TBASCI(TID,ROW,COL,INDEX,ITEMS,VALUE,NEXT,STATUS)
C
      IMPLICIT NONE
C
      INTEGER   VALUE(*)
      INTEGER     TID, ROW, COL, INDEX, ITEMS
      INTEGER     NEXT, STATUS
C
      CALL TBA1(TID,ROW,COL,INDEX)
      CALL TBSCI(ITEMS,VALUE,NEXT,STATUS)
C
      RETURN
      END
C

      SUBROUTINE TBASCR(TID,ROW,COL,INDEX,ITEMS,VALUE,NEXT,STATUS)
C
      IMPLICIT NONE
C
      REAL   VALUE(*)
      INTEGER     TID, ROW, COL, INDEX, ITEMS
      INTEGER     NEXT, STATUS
C
      CALL TBA1(TID,ROW,COL,INDEX)
      CALL TBSCR(ITEMS,VALUE,NEXT,STATUS)
C
      RETURN
      END
C

C===========================================================================
C Copyright (C) 1995-2011 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM DAOPHOT
C
C======================================================================
C
C This is the mainline program, DAOPHOT.
C
C                OFFICIAL DAO VERSION: 1991 April 18
C
C The purposes of this snatch of code are threefold:
C (1) to type out a message from the local DAOPHOT curator, letting
C     the user know of any recent changes in the code;
C (2) to look for a file named 'daophot.opt' in the current default
C     directory and, if it is found, to read in values for the optional
C     parameters [otherwise set them at default values]; and
C (3) to accept commands from the keyboard and call the appropriate
C     subroutines.
C
C 111019	last modif
C 
C=======================================================================
C
      IMPLICIT NONE
      INTEGER  MAPSIZ
      INTEGER  MAXPIC
      INTEGER  IWORK
      INTEGER  WORK
C 
      PARAMETER (MAXPIC=105000000)	! => 10000 x 10500
C     PARAMETER (MAXPIC=16810000)	! => 4100 x 4100
C
      CHARACTER*80  TXTBUF
      INTEGER*8 PNTRA
      INTEGER MADRID(1)
      INTEGER ISTAT
C 
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'    ! MIDAS
C       
      EQUIVALENCE (WORK,IWORK)     
C
      COMMON /VMR/MADRID                  ! MIDAS
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'    ! MIDAS
C 
C
      CALL STSPRO('DAOPHOT')
      CALL STECNT ('PUT', 1, 0, 0)                          ! MIDAS

      MAPSIZ = MAXPIC
      CALL STFXMP(MAPSIZ,D_R4_FORMAT,PNTRA,ISTAT)
      CALL DAOMAP(MADRID(PNTRA),MAPSIZ)
 
      CALL STSEPI
      END



      SUBROUTINE DAOMAP(WORK,MAXPIC)
C 
      IMPLICIT NONE
C 
      INTEGER MAXPIC
C 
      REAL   WORK(MAXPIC)
C 
      INTEGER NOPT, NCMD, MAXPSF, MAXEXP, MAXBOX, MAXSKY,
     .     MAXPAR, MAPSIZ
C 
      PARAMETER (NOPT=19, NCMD=23, MAXPSF=145,
     .     MAXEXP=6, MAXPAR=6, MAXBOX=13, MAXSKY=10000)

C    for MAXPIC=16810000, 4100 x 4100 will be new limit
C
C Parameters
C
C NOPT is the number of optional parameters which may be altered by the
C      user.
C
C NCMD is the number of commands are recognized by the program.
C
C MAXPIC is the maximum number of pixels  in an image
C e.g. MAXPIC of 2560000 => 1600 x 1600 as max. image
C MAXPIC=16810000    => 4100 x 4100
C MAXPIC=105000000   =>   10000 x 10500
C
C                      WARNING
C
C IF ANY OF THE FOLLOWING THREE PARAMETERS IS CHANGED, IT MUST
C ALSO BE CHANGED IN THE FILE CONTAINING THE ROUTINE GETPSF.
C MAXPAR MUST BE CHANGED IN TWO PLACES IN THAT FILE.
C
C MAXPSF is the maximum size of the PSF arrays.
C
C MAXEXP is the maximum number of PSF lookup tables allowed.
C        MAXEXP must be at least 2, because I use PSF as scratch
C        space in FIND.
C
C MAXPAR is the maximum number of parameters allowed in the analytic
C        part of the model PSF.
C
C                End of WARNING
C
C MAXBOX is the length of the side of the largest box that will
C        be used for convolving the image in FIND.  MAXBOX must
C        be less than MAXPSF, because I use the array PSF as
C        scratch space in FIND.
C
C MAXSKY is the maximum number of pixels that will be used in any
C        sky determination.  This will affect the speed of the
C        sky determinations in the SKY and FIND routines (more
C        pixels means slower, of course).  It will also affect
C        the maximum outer sky radius in the PHOTOMETRY routine.
C
      CHARACTER*26 LBL(NOPT)
      CHARACTER*10 CMD(NCMD)
      CHARACTER*1 ANSWER, SPACE
C      REAL WORK(MAXPIC), PSF(MAXPSF,MAXPSF,MAXEXP), PAR(MAXPAR)


      REAL PSF(MAXPSF,MAXPSF,MAXEXP), PAR(MAXPAR)
      REAL OPT(NOPT), OMIN(NOPT), OMAX(NOPT)
C PN 1/00     SAVE WORK
C
      INTEGER MIN0, ICNVRT
C
      CHARACTER*132 MSGLINE
      CHARACTER*30 FILE, OPTFIL, MSGFIL, CASE
      CHARACTER*80 TXTBUF
      CHARACTER*80 DAOMSG, FNAME
      REAL SKYMN, SKYMED, SKYMOD
      INTEGER I, K, NCOL, NROW, KEY, ISTAT, MAX, MAXCOL
      LOGICAL OPEN
C
      INTEGER MADRID(1), MD               ! MIDAS
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'    ! MIDAS
C       
CC      EQUIVALENCE (WORK,IWORK)     
C
      COMMON /VMR/MADRID                  ! MIDAS
      COMMON /SIZE/ NCOL, NROW
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'    ! MIDAS
C
      DATA DAOMSG/'MID_REL_INCL:daophot.msg'/
      DATA SPACE / ' ' /
C
C Specify default values for the NOPT optional parameters.
C
      DATA LBL/' READ NOISE (ADU; 1 frame)',   !  1
     .         '    GAIN (e-/ADU; 1 frame)',   !  2
     .         'LOW GOOD DATUM (in sigmas)',   !  3
     .         '  HIGH GOOD DATUM (in ADU)',   !  4
     .         '            FWHM OF OBJECT',   !  5
     .         '     THRESHOLD (in sigmas)',   !  6
     .         ' LS (LOW SHARPNESS CUTOFF)',   !  7
     .         'HS (HIGH SHARPNESS CUTOFF)',   !  8
     .         ' LR (LOW ROUNDNESS CUTOFF)',   !  9
     .         'HR (HIGH ROUNDNESS CUTOFF)',   ! 10
     .         '            WATCH PROGRESS',   ! 11
     .         '            FITTING RADIUS',   ! 12
     .         '                PSF RADIUS',   ! 13
     .         '              VARIABLE PSF',   ! 14
     .         'FRACTIONAL-PIXEL EXPANSION',   ! 15
     .         '        ANALYTIC MODEL PSF',   ! 16
     .         ' EXTRA PSF CLEANING PASSES',   ! 17
     .         '      PERCENT ERROR (in %)',   ! 18
     .         '      PROFILE ERROR (in %)'/   ! 19
      DATA OPT / 0., 0., 7., 32766.5, 2.5, 4., 0.2, 1., -1., 1.,
     .           1., 2., 11., 0., 0., 1., 0., 0.75, 5./
      DATA OMIN / 1.E-30, 1.E-30, 0., 0., 0.2 , 0., 0., 0.6, -2.,
     .            0., -2., 1., .5, -1.5, -0.5, 0.5, 0., 0., 0./
      DATA OMAX / 1.E30, 1.E30, 1.E30, 999999.99, 15., 1.E30, 0.6,
     .            2., 0., 2., 2., 10., 35., 2.5, 1.5, 6.5, 9.5,
     .            100., 100./
C
C   LBL contains parameter names for displaying on the terminal.
C  OMIN and OMAX contain the minimum and maximum acceptable values for
C       the parameters.
C
C Define the NCMD legal command names.  Note that since a command is
C recognized by its first two letters, the first two letters of
C each command must be unique.
C
      DATA CMD/ 'HELP', 'OPTION', 'MONITOR', 'NOMONITOR', 'SORT',
     .     'OFFSET', 'GROUP', 'SELECT', 'APPEND', 'EXIT', 'ATTACH',
     .     'LIST', 'SKY', 'FIND', 'PHOTOMETRY', 'PSF', 'PEAK',
     .     'NSTAR', 'SUB*', 'ADD*', 'DUMP', 'FUDGE', 'PICK'/
C
      OPEN = .FALSE.

      MAPSIZ = MAXPIC
      CALL FABORT
C
C
C-------------------------------------------------------------------------
C SECTION 0
C
C
C This section show at start up a short message to the user informing him
C about the maximum size of the frames,
C
      CALL STTPUT('       '//
     2'--------------------------------------------------------------',
     2ISTAT)
      CALL STTPUT('       '//
     2'                        W A R N I N G                         ',
     2ISTAT)
      CALL STTPUT(' ',ISTAT)
      CALL STTPUT('       '//
     2'This version of DAOPHOT can be used for frames with a maximum ',
     2ISTAT)
      WRITE(TXTBUF,12345) MAPSIZ
12345 FORMAT('size of 10000 * 10500 (=',I9,') pixels.')
      CALL STTPUT('       '//TXTBUF,ISTAT)
      CALL STTPUT('       '//
     2'In case your frame is larger than this value,', ISTAT)
      CALL STTPUT('       '//
     2'DAOPHOT will not be able to process it.',ISTAT)
      CALL STTPUT('       '//
     2'In such case, please contact your local MIDAS support person.',
     2ISTAT)
      CALL STTPUT('       '//
     2'--------------------------------------------------------------',
     2ISTAT)
C
C-----------------------------------------------------------------------
C
C SECTION 1
C
C Handle the message file.  Note that in the data statement above, the
C file is described as residing in logical device DAO:.  Therefore,
C this logical device must have been defined before the program is run.
C
C Type out the news headlines from the message file, ask whether the
C user wants to read further, and if he/she does, type out the
C messages.
C
      OPTFIL = CASE('daophot.opt')

C     MSGFIL = CASE('dao:daophot.msg')
      CALL GENLGN(DAOMSG,FNAME,80)
      MD     = INDEX(FNAME,' ') -1
      MSGFIL = CASE(FNAME(1:MD))
      CALL INFILE (2, MSGFIL, ISTAT)
      IF (ISTAT .LT. 0) GO TO 2010
C
C This little section reads in and types out the headlines.  A
C question mark (?) in column 1 of the input marks the query whether the
C user wishes to continue reading.
C
 1010 CALL TBLANK                                    ! Type a blank line
 1020 CALL RDCHAR (2, MSGLINE, K, ISTAT)
      IF (ISTAT .LT. 0) THEN
         GO TO 1020
      ELSE IF (ISTAT .GT. 0) THEN
         GO TO 2010
      END IF
      IF (MSGLINE(1:1) .EQ. '?') GO TO 1030
      IF (K .LE. 0) GO TO 1010
      WRITE (6,610) MSGLINE(1:K)
  610 FORMAT (1X, A)
      GO TO 1020
C
 1030 CALL GETYN (MSGLINE(2:K), ANSWER)
C
C Read the user's answer.  If it is 'Y' or 'y', continue reading in and
C typing out the message file, until another backslash encountered in
C column 1 marks the end of a section.  If the answer is anything
C except 'Y' or 'y', close the message file and go on to the next
C section of the program.
C
      IF (ANSWER .EQ. 'Y') GO TO 1010
      CALL CLFILE (2)
C-----------------------------------------------------------------------
C
C SECTION 2
C
C Set up the values of the optional parameters.
C
C (1) Call OPTION with OPTFIL = 'daophot.opt' to set initial values
C for the optional parameters.  If the file isn't there, the routine
C will check that the default values (specified in the data statement
C above) are valid, and return here with those values intact.
C
 2010 CALL OPTION (OPTFIL, NOPT, LBL, OPT, OMIN, OMAX,
     .     'OPT>', ISTAT)
C
C Set OPTFIL to 'KEYBOARD INPUT' for the next time the user uses the
C 'OPTION' command.
C
      OPTFIL='KEYBOARD INPUT'
C
C-----------------------------------------------------------------------
C
C SECTION 3
C
C Accept and execute commands, one after another.
C
C The 22 commands currently defined are:  (1) HELP, (2) OPT, (3) MON,
C (4) NOMON, (5) SORT, (6) OFFSET, (7) GROUP, (8) SELECT, (9) APPEND,
C (10) EXIT, (11) ATTACH, (12) LIST, (13) SKY, (14) FIND, (15) PHOT,
C (16) PSF, (17) PEAK, (18) NSTAR, (19) SUB*, (20) ADD*, (21) DUMP,
C and (22) FUDGE.
C
C Command 13 is 'open a picture file'.  Commands 1-12 can be executed
C without a picture file open; commands 14-23 require that a picture
C file be open.
C
 3000 CONTINUE
      CALL TBLANK
      CALL INQUIR ('Command:', 8)
      CALL RDCHAR (5, MSGLINE, K, ISTAT)
      IF (ISTAT .GT. 0) THEN
         IF (OPEN) CALL CLPIC ('DATA')
         CALL TBLANK
         CALL BYEBYE
      ELSE IF ((ISTAT .LT. 0) .OR. (K .LT. 2)) THEN
         GO TO 3000
      END IF
C
      KEY=ICNVRT(MSGLINE(1:2))
      IF (KEY .EQ. ICNVRT('HE')) THEN
C
C We use the ICNVRT function here, instead of just checking MSGLINE(1:2)
C against the first two characters of each command, just in case the
C user is using lower case letters.
C
         CALL HELP (CMD, NCMD, WORK, WORK(MAXPIC/2+1))
C
      ELSE IF (KEY .EQ. ICNVRT('OP')) THEN
         CALL TBLANK
         OPTFIL = 'KEYBOARD INPUT'
         CALL GETNAM ('File with parameter values:', OPTFIL)
         CALL OPTION (OPTFIL, NOPT, LBL, OPT, OMIN, OMAX,
     .        'OPT>', ISTAT)
C
      ELSE IF (KEY .EQ. ICNVRT('MO')) THEN
         OPT(11)=1.
C
      ELSE IF (KEY .EQ. ICNVRT('NO')) THEN
         OPT(11)=0.
C
      ELSE IF (KEY .EQ. ICNVRT('SO')) THEN
         MAX = MAXPIC/40
         CALL SORTER (WORK, 36*MAX, WORK(36*MAX+1),
     .        WORK(37*MAX+1), WORK(38*MAX+1), WORK(39*MAX+1),
     .        MAX, OPT(11))
C
      ELSE IF (KEY .EQ. ICNVRT('OF')) THEN
         CALL OFFSET
C
      ELSE IF (KEY .EQ. ICNVRT('SE')) THEN
         MAX = MAXPIC/5
         CALL DAOSLT (WORK, WORK(MAX+1), WORK(2*MAX+1),
     .        WORK(3*MAX+1), WORK(4*MAX+1), MAX)
C
      ELSE IF (KEY .EQ. ICNVRT('AP')) THEN
         CALL APPEND
C
      ELSE IF (KEY .EQ. ICNVRT('PI')) THEN
         MAX = MAXPIC/6
         CALL PCKPSF (WORK, WORK(MAX+1), WORK(2*MAX+1),
     .        WORK(3*MAX+1), WORK(4*MAX+1), WORK(5*MAX+1), MAX,
     .        OPT(12), OPT(13))
C
      ELSE IF (KEY .EQ. ICNVRT('EX')) THEN
         IF (OPEN) CALL CLPIC ('DATA')
         CALL TBLANK
         CALL BYEBYE
C
      ELSE IF (KEY .EQ. ICNVRT('AT')) THEN
C
C This is an ATTACH command.  First, get the file name (if any) out of
C the command line.
C
         FILE=' '
         DO 3100 I=1,K
            IF (MSGLINE(I:I) .EQ. ' ') THEN
               FILE=MSGLINE( I+1 : MIN0(K,132))
               GO TO 3110
            END IF
 3100    CONTINUE
 3110    CONTINUE
         CALL ATTACH (FILE, OPEN)
C
      ELSE IF (KEY .EQ. ICNVRT('LI')) THEN
         IF (OPEN) THEN
            CALL LIST (FILE)
         ELSE
            CALL STUPID ('   No picture file has been ATTACHed.')
         END IF
C
      ELSE IF (KEY .EQ. ICNVRT('SK')) THEN
         IF (OPEN) THEN
            MAX = MIN0(MAXSKY, MAXPIC/3)
CC            CALL SKY (WORK, WORK(MAX+1), IWORK(2*MAX+1), MAX,
CC     .           OPT(4), SKYMN, SKYMED, SKYMOD, K)
            CALL SKY (WORK, WORK(MAX+1), WORK(2*MAX+1), MAX,
     .           OPT(4), SKYMN, SKYMED, SKYMOD, K)
            WRITE (6,6) SKYMN, SKYMED, K
    6       FORMAT ('              Clipped mean and median =', 2F9.1/
     .         '   Number of pixels used (after clip) =', I7)
         ELSE
            CALL STUPID ('   No picture file has been ATTACHed.')
         END IF
C
      ELSE IF (KEY .EQ. ICNVRT('FI')) THEN
         IF (OPEN) THEN
            MAX = MAXPIC/3
            MAXCOL = MAX/MAXBOX
            IF (NCOL .LE. MAXCOL) THEN
               CALL FIND (WORK, WORK(MAX+1), WORK(2*MAX+1),
     .            PSF, PSF(1,1,2), MAX, MAXBOX, MAXCOL,
     .            MAXSKY, OPT, NOPT)
            ELSE
               CALL STUPID ('Sorry, your picture is too wide.')
               WRITE (6,7) MAXCOL
    7          FORMAT (I10, ' is the most columns I can handle.'/)
            END IF
         ELSE
            CALL STUPID ('   No picture file has been ATTACHed.')
         END IF
C
      ELSE IF (KEY .EQ. ICNVRT('PH')) THEN
         IF (OPEN) THEN
            K = MAXEXP/2
            MAX = MAXPSF*MAXPSF*K
            K = K+1
            CALL PHOTSB (WORK, PSF, PSF(1,1,K), MAX, NCOL, NROW,
     .           OPT(11))
         ELSE
            CALL STUPID ('   No picture file has been ATTACHed.')
         END IF
C
      ELSE IF (KEY .EQ. ICNVRT('PS')) THEN
         IF (OPEN) THEN
            CALL GETPSF (WORK, NCOL, NROW, PAR, PSF, OPT, NOPT)
         ELSE
            CALL STUPID ('   No picture file has been ATTACHed.')
         END IF
C
      ELSE IF (KEY .EQ. ICNVRT('GR')) THEN
         IF (OPEN) THEN
            MAX = MAXPIC/8
            CALL GROUP (PAR, MAXPAR, PSF, MAXPSF, MAXEXP,
     .           WORK, WORK(MAX+1), WORK(2*MAX+1),
     .           WORK(3*MAX+1), WORK(4*MAX+1), WORK(5*MAX+1),
     .           WORK(6*MAX+1), WORK(7*MAX+1), MAX,
     .           OPT(12), OPT(13))
         ELSE
            CALL STUPID ('   No picture file has been ATTACHed.')
         END IF
C
      ELSE IF (KEY .EQ. ICNVRT('PE')) THEN
         IF (OPEN) THEN
            CALL DAOPK (PAR, MAXPAR, PSF, MAXPSF, MAXEXP, WORK,
     .           OPT(11), OPT(12), OPT(18), OPT(19))
         ELSE
            CALL STUPID ('   No picture file has been ATTACHed.')
         END IF
C
      ELSE IF (KEY .EQ. ICNVRT('NS')) THEN
         IF (OPEN) THEN
            CALL NSTAR (PAR, MAXPAR, PSF, MAXPSF, MAXEXP, WORK,
     .           NCOL, NROW, OPT(11), OPT(12), OPT(18), OPT(19))
         ELSE
            CALL STUPID ('   No picture file has been ATTACHed.')
         END IF
C
      ELSE IF (KEY .EQ. ICNVRT('SU')) THEN
         IF (OPEN) THEN
            CALL SUBSTR (PAR, MAXPAR, PSF, MAXPSF, MAXEXP,
     .           WORK, NCOL, NROW, OPT(11))
         ELSE
            CALL STUPID ('   No picture file has been ATTACHed.')
         END IF
C
      ELSE IF (KEY .EQ. ICNVRT('AD')) THEN
         IF (OPEN) THEN
            CALL ADDSTR (PAR, MAXPAR, PSF, MAXPSF, MAXEXP,
     .           WORK, NCOL, NROW, OPT(11))
         ELSE
            CALL STUPID ('   No picture file has been ATTACHed.')
         END IF
C
      ELSE IF (KEY .EQ. ICNVRT('DU')) THEN
         IF (OPEN) THEN
            CALL DUMP (WORK, NCOL, NROW)
         ELSE
            CALL STUPID ('   No picture file has been ATTACHed.')
         END IF
C
      ELSE IF (KEY .EQ. ICNVRT('FU')) THEN
         IF (OPEN) THEN
            CALL FUDGE (FILE, WORK)
         ELSE
            CALL STUPID ('   No picture file has been ATTACHed.')
         END IF
      ELSE
C
C Minor problems.
C
         CALL STUPID ('   Unrecognized command.')
      END IF
      GO TO 3000
      END!
C
C#######################################################################
C
      SUBROUTINE  HELP (CMD, NCMD, RCMD, NUMBER)
C
C=======================================================================
C
C This subroutine produces a simple listing on the terminal of all of
C the elements of the character vector CMD.  They are sorted into
C alphabetical order by the first two characters.
C
C             OFFICIAL DAO VERSION:  1991 April 18
C
C Argument
C
C CMD is a character array containing the names of the defined commands.
C
C=======================================================================
C
      IMPLICIT NONE
C
      INTEGER ICNVRT, I, NCMD
      INTEGER INUMBER(NCMD)
C
C NCMD is the total number of defined commands.
C
      CHARACTER*10 CMD(NCMD)
      REAL RCMD(NCMD)
      REAL NUMBER(NCMD)
C
C-----------------------------------------------------------------------
C
      WRITE (6,610)
  610 FORMAT (/' The commands currently recognized are:'/)
C
C Determine the numerical equivalent of the first two characters in each
C of the defined commands.
C
      DO 1010 I=1,NCMD
 1010 RCMD(I)=FLOAT(ICNVRT(CMD(I)(1:2)))
C
C Sort the commands into alphabetical order.
C
      CALL QUICK (RCMD, NCMD, NUMBER)
C
C Now type the command names out on the screen.
C
      DO 1000,I=1,NCMD
         INUMBER(I) = NINT(NUMBER(I))
1000  CONTINUE

      WRITE (6,611) (CMD(INUMBER(I)), I=1,NCMD)
  611 FORMAT (1X, 5A14)
      WRITE (6,612)
  612 FORMAT (/' Any command may be abbreviated down to its first two',
     .     ' characters.')
C
      RETURN
      END!
C
C#######################################################################
C
      SUBROUTINE  SKY  (D, S, INDEX, MAX, HIBAD, SKYMN, SKYMED,
     .     SKYMOD, N)
C
C=======================================================================
C
C This subroutine estimates an average sky value for a picture by taking
C individual pixels scattered over the picture.  The brightness values
C are sorted, and the modal value is estimated using the MMM subroutine.
C
C               OFFICIAL DAO VERSION:  1991 April 18
C
C=======================================================================
C
      IMPLICIT NONE
      INTEGER MAX
C
C MAX    is the maximum number of sky pixels we can deal with,
C        given the limited amount of working space.
C
      REAL S(MAX), D(MAX)
      REAL INDEX(MAX)
C
      REAL HIBAD, SKYMN, SKYMED, SKYMOD, SKYSIG, SKYSKW
      INTEGER NCOL, NROW, ISTEP, LX, LY, NX, NY, IROW, I, N
      INTEGER ISTAT, IFIRST
      COMMON /SIZE/ NCOL, NROW
C
C-----------------------------------------------------------------------
C
C The spacing between pixels that will be included in the sample is
C estimated by the ratio of the total number of pixels in the picture to
C the maximum number of pixels that can be accomodated in the vector S.
C
      ISTEP = NCOL*NROW/MAX+1
C
C Go through the disk file reading a row at a time and extracting every
C ISTEP-th pixel.  If ISTEP is not equal to 1, make sure that the
C starting pixel for each row is staggered.
C
      LX = 1
      NX = NCOL
      NY = 1
      IFIRST = 0
      N = 0
      DO IROW=1,NROW
         LY = IROW
         CALL RDARAY ('DATA', LX, LY, NX, NY, MAX, D, ISTAT)
         IF (ISTAT .NE. 0) RETURN
         IFIRST = IFIRST + 1
         IF (IFIRST .GT. ISTEP) IFIRST = IFIRST - ISTEP
         I = IFIRST
 1010    IF (ABS(D(I)) .LE. HIBAD) THEN
            N = N+1
            S(N) = D(I)
            IF (N .EQ. MAX) GO TO 1100
            I = I + ISTEP
         ELSE
            I = I+1
         END IF
         IF (I .LE. NCOL) GO TO 1010
      END DO
C
C Sort these values, then estimate the mode.
C
 1100 CONTINUE
      CALL QUICK (S, N, INDEX)
      CALL MMM (S, N, HIBAD, SKYMN, SKYMED, SKYMOD, SKYSIG,
     .     SKYSKW, 1.0)
      WRITE (6,610) SKYMOD, SKYSIG
  610 FORMAT (/' Approximate sky value for this frame =', F9.1/
     .         ' Standard deviation of sky brightness =', F10.2/)
C
C Normal return.
C
      RETURN
      END!
C
C#######################################################################
C
      SUBROUTINE  APPEND
C
C=======================================================================
C
C A simple subroutine to append two DAOPHOT stellar data files,
C omitting the superfluous file header.
C
C=======================================================================
C
      IMPLICIT NONE
      CHARACTER*132 LINE
      CHARACTER*30 IFILE1, IFILE2, SWITCH, CASE*4
C      REAL R1, R2, R3, R4, R5, R6, R7, R8
      REAL R1, R2, R3, R4, R5, R6, R7
      INTEGER ISTAT, K, I1, I2, I3
C
C-----------------------------------------------------------------------
C
      CALL TBLANK                                   ! Type a blank line
      IFILE1=' '
      CALL GETNAM ('First input file:', IFILE1)
      IF (IFILE1 .EQ. 'END OF FILE') THEN
         IFILE1 = ' '
         RETURN
      END IF
C
  950 CALL INFILE (1, IFILE1, ISTAT)
      IF ((IFILE1 .EQ. 'END OF FILE') .OR.
     .     (IFILE1 .EQ. 'GIVE UP')) THEN
         IFILE1 = ' '
         RETURN
      END IF
C
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error opening input file '//IFILE1)
         IFILE1 = 'GIVE UP'
         GO TO 950
      END IF
C
      IFILE2=' '
  960 CALL GETNAM ('Second input file:', IFILE2)
      IF ((IFILE2 .EQ. 'END OF FILE') .OR.
     .     (IFILE2 .EQ. 'GIVE UP')) THEN
         CALL CLFILE (1)
         RETURN
      END IF
      CALL INFILE (2, IFILE2, ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error opening input file '//IFILE2)
         IFILE2 = 'GIVE UP'
         GO TO 960
      END IF
C
      IFILE1 = SWITCH(IFILE1, CASE('.cmb'))
  970 CALL GETNAM ('Output file:', IFILE1)
      IF ((IFILE1 .EQ. 'END OF FILE') .OR.
     .     (IFILE1 .EQ. 'GIVE UP')) THEN
         CALL CLFILE (1)
         CALL CLFILE (2)
         RETURN
      END IF
      CALL OUTFIL (3, IFILE1, ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error opening output file '//IFILE1)
         IFILE1 = 'GIVE UP'
         GO TO 970
      END IF
C
C-----------------------------------------------------------------------
C
C Copy first file's header and data verbatim into the output file.
C
 2000 CALL RDCHAR (1, LINE, K, ISTAT)
      IF (ISTAT .GT. 0) GO TO 2900
      IF (ISTAT .LT. 0) GO TO 2000
      IF (K .LE. 0) LINE=' '
      K = MAX0(1,K)
      WRITE (3,310) LINE(1:K)
  310 FORMAT (A)
      GO TO 2000
C
 2900 CALL CLFILE (1)
C
C-----------------------------------------------------------------------
C
C Add to the output file the stellar data, but not the header, from the
C second input file.
C
      I1=-1
      CALL RDHEAD (2, I1, I2, I3, R1, R2, R3, R4, R5, R6, R7)
C
C RDHEAD will leave the pointer positioned at the top of the input
C file's stellar data whether there was a header there or not.  Now
C copy the remainder of the second input file verbatim into the output
C file.
C
 3010 CALL RDCHAR (2, LINE, K, ISTAT)
      IF (ISTAT .GT. 0) THEN
         CALL CLFILE (2)
         CALL CLFILE (3)
         RETURN
      END IF
      IF (ISTAT .LT. 0) GO TO 3010
      K=MAX0(1,K)
      WRITE (3,310) LINE(1:K)
      GO TO 3010
      END!
C
C#######################################################################
C

      SUBROUTINE  DAOSLT (ID, XC, YC, MAG, SKY, MAX)
C
C=======================================================================
C
C This is a simple subroutine which selects groups within a certain
C range of sizes from a group file, and puts them into a new group file.
C
C              OFFICIAL DAO VERSION: 1991 April 18
C
C=======================================================================
C
      IMPLICIT NONE
      INTEGER MAX
C
C MAX is the largest number of stars that can be held in working space.
C
      CHARACTER*30 COOFIL, MAGFIL, PSFFIL, PROFIL, GRPFIL, EXTEND
      CHARACTER CASE*3
      REAL XC(MAX), YC(MAX), MAG(MAX), SKY(MAX)
      REAL SIZE(2)
      REAL ID(MAX)
C
      REAL ALOG10
C
      CHARACTER*4 PLSTR, PLGRP
      REAL LOBAD, HIBAD, THRESH, AP1, PHPADU, RONOIS, DUM, RADIUS
      INTEGER ISTAT, NL, NCOL, NROW, MINGRP, MAXGRP
      INTEGER NGRP, NTOT, I, NSTAR, LENGRP
C
      COMMON /FILNAM/ COOFIL, MAGFIL, PSFFIL, PROFIL, GRPFIL
C
C-----------------------------------------------------------------------
C
C SECTION 1
C
C Setup.
C
C Ascertain the name of the input group file and open it.
C
      CALL TBLANK                                   ! Type a blank line
  950 CALL GETNAM ('Input group file:', GRPFIL)
      IF ((GRPFIL .EQ. 'END OF FILE') .OR.
     .     (GRPFIL .EQ. 'GIVE UP')) THEN
         GRPFIL = ' '
         RETURN
      END IF
C
      CALL INFILE (2, GRPFIL, ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error opening input file '//GRPFIL)
         GRPFIL = 'GIVE UP'
         GO TO 950
      END IF
C
      CALL RDHEAD (2, NL, NCOL, NROW, LOBAD, HIBAD, THRESH, AP1,
     .     PHPADU, RONOIS, DUM)
      IF (NL .NE. 3) THEN
         CALL STUPID ('Not a group file.')
         CALL CLFILE (2)
         GRPFIL = 'GIVE UP'
         GO TO 950
      END IF
C
C Get the desired range of group sizes.
C
      CALL GETDAT ('Minimum, maximum group size:', SIZE, 2)
      IF (SIZE(1) .LT. -1.E38) GO TO 9010           ! CTRL-Z was entered
      MINGRP=NINT(SIZE(1))
      MAXGRP=NINT(SIZE(2))
C
C Get the name of the output group file and open it.
C
      MAGFIL=GRPFIL
  960 CALL GETNAM ('Output group file:', MAGFIL)
      IF ((MAGFIL .EQ. 'END OF FILE') .OR.
     .     (MAGFIL .EQ. 'GIVE UP')) THEN
         CALL CLFILE (2)
         MAGFIL = ' '
         RETURN
      END IF
C
      MAGFIL = EXTEND(MAGFIL, CASE('grp'))
      CALL OUTFIL (3, MAGFIL, ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error opening output file '//MAGFIL)
         MAGFIL = 'GIVE UP'
         GO TO 960
      END IF
      CALL WRHEAD (3, 3, NCOL, NROW, 6, LOBAD, HIBAD, THRESH, AP1,
     .     PHPADU, RONOIS, RADIUS)
      NGRP=0
      NTOT=0
C
C-----------------------------------------------------------------------
C
C SECTION 2
C
C Actually do it.
C
C Read in the next group of stars.
C
 2000 I=0                                       ! Begin loop over groups
 2010 I=I+1                                     ! Begin loop over stars
C
      IF (I .GT. MAX) THEN                 ! Too many stars in group
         CALL STUPID ('/Group too large.')
         WRITE (6,6) MAX
    6    FORMAT (I10, ' is the largest number of stars I can',
     .        ' possibly consider.  I''m throwing it out.'/)
C
C Look for the next blank line.
C
 2015    CALL RDSTAR (2, 3, ID(1), XC(1), YC(1), MAG(1), SKY(1))
         IF (ID(1) .GT. 0) GO TO 2015
         IF (ID(1) .EQ. 0) GO TO 2000
         GO TO 9000
      END IF
C
      CALL RDSTAR (2, 3, ID(I), XC(I), YC(I), MAG(I), SKY(I))
C
      IF (ID(I) .LT. 0) GO TO 2020         ! End-of-file was encountered
      IF (ID(I) .EQ. 0) GO TO 2030         ! Blank line was encountered
      GO TO 2010
C
C Either a blank line or an EOF has been encountered.  If there
C have been some stars read in since the last blank line, we
C want to write out the group, if appropriate.  Otherwise,
C if EOF was encountered, then return; if a blank line, then keep
C trying to start reading a new group.
C
 2020 IF (I .EQ. 1) GO TO 9000        ! EOF and no stars in group
 2030 IF (I .EQ. 1) GO TO 2000        ! Blank line and no stars in group
      NSTAR=I-1
C
C NSTAR is the number of stars in the current group.  If this is outside
C the range of group sizes being selected, start reading the next group.
C Otherwise, write the group into the output file and increment the
C accumulators before reading the next group.
C
      IF ((NSTAR .LT. MINGRP) .OR. (NSTAR .GT. MAXGRP)) GO TO 2000
      NGRP=NGRP+1
      NTOT=NTOT+NSTAR
      DO 2040 I=1,NSTAR
 2040 WRITE (3,320) ID(I), XC(I), YC(I), MAG(I), SKY(I)
  320 FORMAT (1X, I5, 4F9.3)
      WRITE (3,320)                                 ! Write a blank line
      GO TO 2000
C
C-----------------------------------------------------------------------
C
C Normal return.
C
C Type out the number of stars and the number of groups NEATLY.
C
 9000 PLSTR='s in'
      IF (NTOT .EQ. 1) PLSTR=' in '
      PLGRP='s.  '
      IF (NGRP .EQ. 1) PLGRP='.   '
      LENGRP=INT(ALOG10(NGRP+0.5))+2
      IF (NTOT .EQ. 1)LENGRP=LENGRP-1
      WRITE (6,690) NTOT, PLSTR, NGRP, PLGRP
  690 FORMAT (/I6, ' star', A4, I5, ' group', A4/)
      CALL CLFILE (3)
 9010 CALL CLFILE (2)
      RETURN
      END!
C
C#######################################################################
C
      SUBROUTINE  DUMP  (F, NCOL, NROW)
C
C=======================================================================
C
C A trivial subroutine to type the brightness values in a small
C subarray of the picture onto the terminal.
C
C            OFFICIAL DAO VERSION:  1991 April 18
C
C=======================================================================
C
      IMPLICIT NONE
C
      INTEGER NSQUARE, NCOL, NROW
      PARAMETER  (NSQUARE=21)
C
      REAL F(NCOL,NROW)
      REAL COORDS(2), D(NSQUARE*NSQUARE)
C
      REAL AMIN1, AMAX1
      INTEGER NINT
C
 
      REAL SIZE
      INTEGER NBOX, NHALF, LX, LY, ISTAT
      INTEGER I, J, N, NX, NY
C
C Parameter
C
C NSQUARE is the side of the largest square subarray that can be
C         comfortably fit on the terminal screen.  NSQUARE = 21 is
C         for 24-line terminals, to accomodate the array, a two-line
C         header across the top, and and a query at the bottom.  In
C         fact, if the user specifies SIZE = 21, then one of the header
C         lines at the top will be lost.
C         (Terminal must have 132-column capability to prevent
C         wraparound.)
C
C
C-----------------------------------------------------------------------
C
      CALL TBLANK                                   ! Type a blank line
      CALL GETDAT ('Box size:', SIZE, 1)
      IF (SIZE .LT. -1.E38) RETURN                  ! CTRL-Z was entered
      NBOX=MAX0(1, MIN0(NINT(SIZE), NSQUARE))
      NHALF=(NBOX-1)/2
C
 1000 CALL GETDAT ('Coordinates of central pixel:', COORDS, 2)
C
C Return to calling program upon entry of CTRL-Z or invalid coordinates.
C
      IF ((COORDS(1) .LE. 0.5) .OR. (COORDS(2) .LE. 0.5)) RETURN
      IF ((NINT(COORDS(1)) .GT. NCOL) .OR.
     .     (NINT(COORDS(2)) .GT. NROW)) RETURN
C
      LX = NINT(COORDS(1))-NHALF
      LY = NINT(COORDS(2))-NHALF
      NX = NINT(COORDS(1))+NHALF - LX + 1
      NY = NINT(COORDS(2))+NHALF - LY + 1
      CALL RDARAY ('DATA', LX, LY, NX, NY, NCOL, F, ISTAT)
C
C LX and LY are the lower limits of the box in X and Y; NX and NY are
C the number of pixels in the box in X and Y.  They will have been
C modified by RDARAY if the box would have extended outside the
C picture.
C
      WRITE (6,609) (I, I=LX,LX+NX-1)
  609 FORMAT (/7X, 21I6)
      WRITE (6,610) ('------', I=1,NX)
  610 FORMAT (6X, '+', 21A6)
C
      N=0
      DO 1020 J=1,NY
      WRITE (6,611) LY+J-1,
     .     (NINT(AMAX1(-99999.,AMIN1(99999.,F(I,J)))), I=1,NX)
  611 FORMAT (1X, I4, ' |', 21I6)
      DO 1010 I=1,NX
      N=N+1
 1010 D(N)=F(I,J)
 1020 CONTINUE
C
      CALL QUICK (D, N, F)
C
      IF (NBOX .LT. NSQUARE) CALL TBLANK
      WRITE (6,612) NINT(AMAX1(-99999.,AMIN1(99999.,D(1)))),
     .     NINT(AMAX1(-99999.,AMIN1(99999.,
     .     0.5*D((N+1)/2)+0.5*D((N/2)+1)))),
     .     NINT(AMAX1(-99999.,AMIN1(99999.,D(N))))
  612 FORMAT(26X, 'Minimum, median, maximum: ', 3I7)
C
      GO TO 1000
C
      END!
C
C#######################################################################
C
      SUBROUTINE  OFFSET
C
C=======================================================================
C
C A simple routine to read in an arbitrary DAOPHOT stellar data file,
C shift the stars' x,y coordinates by a constant amount, and write
C out an otherwise identical data file.
C
C            OFFICIAL DAO VERSION:  1991 April 18
C
C=======================================================================
C
      IMPLICIT NONE
      CHARACTER*133 LINE1, LINE2
      CHARACTER*30 FILE, SWITCH
      CHARACTER CASE*4
      REAL DELTA(4)
      REAL LOBAD, COLMAX, ROWMAX, HIBAD, THRESH, AP1, PHPADU
      REAL READNS, FRAD, X, Y, AMAG
      INTEGER I, ISTAT, IDDEL, NL, NCOL, NROW, ITEMS, NLINE1
      INTEGER NLINE2, ID
      LOGICAL WROTE
C
C-----------------------------------------------------------------------
C
C SECTION 1
C
C Get ready.
C
      CALL TBLANK                                   ! Type a blank line
C
C Get input file name.
C
      FILE=' '
  950 CALL GETNAM ('Input file name:', FILE)
      IF ((FILE .EQ. 'END OF FILE') .OR. (FILE .EQ. 'GIVE UP')) RETURN
      CALL INFILE (2, FILE, ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error opening input file '//FILE)
         FILE = 'GIVE UP'
         GO TO 950
      END IF
C
C Get offsets.
C
      DO I=1,4
         DELTA(I)=0.
      END DO
      CALL GETDAT ('Additive offsets ID, DX, DY, DMAG:', DELTA, 4)
      IF (DELTA(1) .LT. -1.E38) THEN
         CALL CLFILE (1)
         RETURN
      END IF
      IDDEL = NINT(DELTA(1))
C
C Get output file name.
C
      FILE = SWITCH(FILE, CASE('.off'))
  960 CALL GETNAM ('Output file name:', FILE)
      IF ((FILE .EQ. 'END OF FILE') .OR. (FILE .EQ. 'GIVE UP')) THEN
         CALL CLFILE (2)
         RETURN
      END IF
      CALL OUTFIL (3, FILE, ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error opening output file '//FILE)
         FILE = 'GIVE UP'
         GO TO 960
      END IF
C
C Copy input file's header into output file.
C
      COLMAX=1.E38
      ROWMAX=1.E38
      NL=-1
      CALL RDHEAD (2, NL, NCOL, NROW, LOBAD, HIBAD, THRESH, AP1,
     .     PHPADU, READNS, FRAD)
C
      IF (NL .LE. 0) GO TO 2000                     ! No header in input
C
      ITEMS=6
      IF (FRAD .GT. 0.001) ITEMS=7
      CALL WRHEAD (3, NL, NCOL, NROW, ITEMS, LOBAD, HIBAD, THRESH,
     .     AP1, PHPADU, READNS, FRAD)
      COLMAX=FLOAT(NCOL)+0.5
      ROWMAX=FLOAT(NROW)+0.5
C
C-----------------------------------------------------------------------
C
C SECTION 2
C
C Copy the data file, line by line, altering X and Y as we go.
C
 2000 CALL RDCHAR (2, LINE1, NLINE1, ISTAT)
      IF (ISTAT .GT. 0) GO TO 9000
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error reading data from input file.')
         WRITE (6,*) LINE1(1:NLINE1)
         CALL TBLANK
         RETURN
      END IF
      READ (LINE1(2:33), 220, IOSTAT=ISTAT) ID, X, Y, AMAG
  220 FORMAT (I5, 3F9.3)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error reading data from input file.')
         WRITE (6,*) LINE1(1:NLINE1)
         CALL TBLANK
         RETURN
      END IF
      IF (NLINE1 .LE. 1) THEN
C
C A blank line was encountered.  The toggle, WROTE, prevents more than
C one blank output line in a row from being produced.
C
         IF (WROTE) WRITE (3,*) ' '
         WROTE=.FALSE.
         GO TO 2000
      END IF
C
C Normal continuation.
C
      IF (NL .EQ. 2) CALL RDCHAR (2, LINE2, NLINE2, ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error reading data from input file.')
         WRITE (6,*) LINE1(2:NLINE2)
         CALL TBLANK
         RETURN
      END IF
      ID=ID+IDDEL
      X=X+DELTA(2)
      Y=Y+DELTA(3)
      AMAG=AMAG+DELTA(4)
C
C Any star which winds up outside the picture after offsetting will be
C discarded.  (This implicitly assumes that the user will only be
C offsetting the coordinates in order to match them with another frame
C taken with the same device.  Otherwise the scale and possibly the
C orientation would be different, and a simple offset would not be a
C good enough transformation.)
C
      IF ((X .LT. 0.5) .OR. (X .GT. COLMAX) .OR. (Y .LT. 0.5) .OR.
     .     (Y .GT. ROWMAX)) GO TO 2000
C
      WRITE (LINE1(2:33),220) ID, X, Y, AMAG
      WRITE (3,301) LINE1(1:NLINE1)
  301 FORMAT (A)
      IF (NL .EQ. 2) WRITE (3,301) LINE2(1:NLINE2)
      WROTE=.TRUE.
      GO TO 2000
C
C-----------------------------------------------------------------------
C
C Normal return.
C
 9000 CALL CLFILE (3)
      CALL CLFILE (2)
      RETURN
      END!

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================

C ++++++++++++++++++++++++  ytbe.for +++++++++++++++++++++++++++++++++++++++
C .LANGUAGE Fortran 77
C .IDENTIFICATION Module ytbe.for
C  AUTHOR         K. Banse
C  Module contains layer between the table related FORTRAN TBxxxx interfaces
C  and the TC_interfaces written in (hopefully independent) C
C .KEYWORDS       standard interfaces.
C .ENVIRONMENT    FORTRAN and C standards
C .VERSION  [1.00] 871207:  created from SXFTOC.C
C 
C 100615	last modif
C -----------------------------------------------------------------------------
C
      SUBROUTINE TBERDC(TID, ROW, COL, VALUE, NULL,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   VALUE
      INTEGER     TID, ROW, COL, NULL
      INTEGER     STATUS
C 
      CALL STLOC(1,1,VALUE)                              !blanked CHAR_LOC
C 
      CALL TBE1(TID,ROW,COL,NULL,STATUS)
C
      RETURN
      END
C 
C 
      SUBROUTINE TBEGET(TID, CTYPE, ROW, COL, VALUE, NULL, STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   CTYPE
      INTEGER     TID, ROW, COL, NULL
      INTEGER     VALUE(*)
      INTEGER     STATUS
C
      CALL STSTR(1,CTYPE)                     !STRIPPED_STRING
C 
      CALL TBR3(TID,ROW,COL,VALUE,NULL,STATUS)
C
      RETURN
      END
C
C
      SUBROUTINE TBEPUT(TID, CTYPE, ROW, COL, VALUE, STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   CTYPE
      INTEGER     TID, ROW, COL
      INTEGER     VALUE(*)
      INTEGER     STATUS
C
      CALL STSTR(1,CTYPE)                     !STRIPPED_STRING
C
      CALL TBR4(TID,ROW,COL,VALUE,STATUS)
C
      RETURN
      END
C 
C
      SUBROUTINE TBEWRC(TID, ROW, COL, VALUE, STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   VALUE
      INTEGER     TID, ROW, COL
      INTEGER     STATUS
C
      CALL STLOC(1,0,VALUE)                              !untouched CHAR_LOC
      CALL TBE2(TID,ROW,COL,STATUS)
C
      RETURN
      END
C
      SUBROUTINE TBESRC(TID, COL,VALUE, START, LEN, FIRST, NEXT,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   VALUE
      INTEGER     TID, COL, START, LEN, FIRST, NEXT
      INTEGER     STATUS
C
      CALL STSTR(1,VALUE)   
      CALL TBE5(TID,COL,START,LEN,FIRST,NEXT,STATUS)
C
      RETURN
      END
CC
CC all other TBExyz functions
CC handled directly in tbe.fc
CC 
C 
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine FT_EOS            version 1.00    100611
C  K. Banse                     ESO - Garching
C
C.PURPOSE
C find end of string which is returned the C way ('\0' in the end)
C like e.g. from CALL TBERDC(...)
C
C also a blank is considered to indicate the end_of_string
C 
C return status = 0, it' o.k.
C		  1, invalid param. inlen
C
C.VERSION
C 100723        last modif
C
C-------------------------------------------------------

      SUBROUTINE FT_EOS(instr,inlen,outstr,stat)

      IMPLICIT NONE

      INTEGER INLEN,STAT
      CHARACTER INSTR*1, OUTSTR*1

      INTEGER K,KI

      CHARACTER*1 COMPI



      IF (INLEN .LT. 1) THEN         !must be > 0
         STAT = 1
         RETURN
      ENDIF
      STAT = 0

CC      alphab(1:37) = alpha1(1:37)
CC      alphab(38:63) = alpha2(1:26)

      COMPI = CHAR(0)                !compi = '\0'
      KI = 0

      DO K=1,INLEN
         IF (INSTR(K:K) .EQ. COMPI) THEN
            KI = K                   !'\0' found => end of string
            GOTO 1000
         ELSE
            OUTSTR(K:K) = INSTR(K:K)
         ENDIF
      ENDDO
C
C no Null char. found => we used full input string
      RETURN

1000  DO K=KI,INLEN                  !we pad with blanks 
         OUTSTR(K:K) = ' '
      ENDDO

      RETURN
      END

C @(#)inapsf.for	19.1 (ES0-DMD) 02/25/03 13:25:34
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.INPUT/OUTPUT
C  Input parameters
C  RARR       real*4 array    real keywords
C  MAXSUB     integer*4       maximal subarray half edge
C  Output parameters
C  APSF       real*4 array    one dimensional p.s.f.
C-----------------------------------------------------------------------
      SUBROUTINE INAPSF ( RARR , MAXSUB , APSF )
C
      IMPLICIT  NONE
      REAL      RARR(64)
      INTEGER   MAXSUB
      REAL      APSF(0:MAXSUB)
C
      INTEGER   K , K2
C
      APSF(0) = 1.0
      K2 = MIN( 25 , MAXSUB )
      DO 30 K = 1 , K2
            APSF(K) = APSF(K-1) * 10**(-RARR(13+K))
  30      CONTINUE
        DO 31 K = 26 , MAXSUB
            APSF(K) = APSF(K-1) * 10**(-RARR(38))
  31      CONTINUE
C
      RETURN
C
      END

C @(#)double.for	19.1 (ES0-DMD) 02/25/03 13:25:33
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine DOUBLE         version 1         820521
C  A. Kruszewski             ESO Garching
C  modified for FX           version 1.1       870219
C  A. Kruszewski             Obs. de Geneve
C  modified for MSDOS        version 2.0       880618
C  A. Kruszewski             Warsaw U. Obs.
C.KEYWORDS
C  search, double
C.PURPOSE
C  analyzes a region of multiple detections for presence of
C  two components
C.INPUT/OUTPUT
C  input arguments
C  A           real*4 array      image buffer
C  JAPY        integer*4 array   array of pointers
C  JOFF        integer*4         line offset to buffer start
C  JBE         integer*4         last line in buffer
C  IXYU        integer*4 array   limits of used area
C  IHED        integer*4         half-edge in pixels of used subarray
C  BGRD        real*4            local sky background
C  AVI         real*4            average x-coordinate in pixels
C  AVJ         real*4            average y-coordinate in pixels
C  THETA       real*4            position angle of major axis
C  ISIZ        integer*4         maximum size of an object
C  ADLM        real*4            minimum allowed separation of
C                                components
C  YFCT        real*4            ratio of sizes of rectangle which is
C                                aligned with major axis and used to
C                                scan object's region
C  DVAL        real*4            minimum depth of valley between
C                                components expressed in units
C                                of central value of a brighter
C                                component
C  output arguments
C  IDPM        integer*4 array   contains informations about number
C                                of detected components and theirs
C                                positions
C-----------------------------------------------------------------------
      SUBROUTINE DOUBLE(A, JAPY, JOFF, JBE, IXYU, IHED, BGRD,
     &           AVI, AVJ, THETA, ISIZ, ADLM, YFCT, DVAL,
     &           TRSH, IDPM)
C
      IMPLICIT NONE
      INCLUDE  'MID_REL_INCL:INVENT.INC'
C
      REAL      A(1)
      INTEGER   JAPY(1)
      INTEGER   JOFF
      INTEGER   JBE
      INTEGER   IXYU(4)
      INTEGER   IHED
      REAL      BGRD
      REAL      AVI
      REAL      AVJ 
      REAL      THETA
      INTEGER   ISIZ 
      REAL      ADLM 
      REAL      YFCT
      REAL      DVAL
      REAL      TRSH
      INTEGER   IDPM(5)
C
      INTEGER   I1, I2
      INTEGER   IDLM, IDX
      INTEGER   IHBX, IHXY
      INTEGER   IHBY 
      INTEGER   II 
      INTEGER   J1, J2 
      INTEGER   JDY, JJ 
      INTEGER   K , KK , KK2
      INTEGER   LCTN(3)
      INTEGER   NX(0:MAXSCN)
C
      REAL      CTHT
      REAL      DI, DJ, DX, DY
      REAL      EXTR(3)
      REAL      SCNX(0:MAXSCN), STHT
C
C ******      Define dimensions of scanning rectangle IHBX and IHBY.
C
      IHBX = MIN( (ISIZ/2+2) , MAXSCN/2 )
      IHBY = MIN( IHED , INT( FLOAT(IHBX) * YFCT ) )
      CTHT = COS(THETA)
      STHT = SIN(THETA)
C
C ******      Define region containing scanning rectangle.
C
      IHXY = INT( SQRT( FLOAT( IHBX*IHBX + IHBY*IHBY ) ) ) + 1
      I1 = MAX( IXYU(1) , NINT(AVI)-IHXY )
      I2 = MIN( IXYU(3) , NINT(AVI)+IHXY )
      J1 = MAX( JOFF+1 , NINT(AVJ)-IHXY )
      J2 = MIN( JBE , NINT(AVJ)+IHXY )
      KK = MIN( 2*IHBX , MAXSCN )
      KK2 = KK / 2
      DO 10 K = 0 , KK
          SCNX(K)=0.0
          NX(K)=0
   10      CONTINUE
C
C ******      Perform scanning.
C
      DO 12 JJ = J1 , J2
          DO 11 II = I1 , I2
            DI = FLOAT(II) - AVI
            DJ = FLOAT(JJ) - AVJ
            DX = DI*CTHT + DJ*STHT
            DY = DJ*CTHT - DI*STHT
            IDX = NINT( DX + 0.001 )
            JDY = NINT( DY + 0.001 )
            IF ( IDX. GE. -KK2 .AND. IDX .LE. KK2 .AND.
     &                JDY .GE. -IHBY .AND. JDY .LE. IHBY ) THEN
                     K = IDX + KK2
                SCNX(K) = SCNX(K) + A(JAPY(JJ-JOFF)+II)
                NX(K) = NX(K) + 1
            ENDIF
   11          CONTINUE
   12      CONTINUE 
        DO 14 K = 0 , KK
            IF ( NX(K) .GT. 0 ) THEN
                  SCNX(K) = SCNX(K) / NX(K)
            ELSE IF ( K .GT. 0 ) THEN
                  SCNX(K) = SCNX(K-1)
            END IF
  14      CONTINUE
C
C ******      Search for extrema in obtained scan.
C
      IDLM = INT(ADLM)
      CALL EXTREM( SCNX(0) , KK2 , IDLM , EXTR , LCTN )
C
C ******      Write an output array IDPM.
C
      IF ( ABS( LCTN(1) ) .LT. KK2 ) THEN
          IF ( ABS( LCTN(1)-LCTN(2) ) .GE. INT(ADLM) .AND.
     &                               ABS( LCTN(2) ) .LT. KK2 .AND.
     &                 EXTR(2)-EXTR(3) .GT. DVAL*(EXTR(1)-BGRD)
     &                 .AND. EXTR(2)-EXTR(3) .GT. TRSH ) THEN
              IDPM(1) = 2
              IDPM(4) = NINT( LCTN(2)*CTHT )
              IDPM(5) = NINT( LCTN(2)*STHT )
          ELSE
              IDPM(1)=1
          ENDIF
          IDPM(2) = NINT( LCTN(1)*CTHT )
          IDPM(3) = NINT( LCTN(1)*STHT )
      ELSE IF ( ABS( LCTN(1) ) .EQ. KK2 ) THEN
          IF ( ABS( LCTN(2) ) .LT. KK2 ) THEN 
              IDPM(1) = 1
              IDPM(2) = NINT( LCTN(2)*CTHT )
              IDPM(3) = NINT( LCTN(2)*STHT )
          ELSE
              IDPM(1) = 0
          ENDIF
      ENDIF
C
      RETURN
C
      END

C===========================================================================
C Copyright (C) 1995-2006 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++
C.IDENTIFICATION for_ellips.for
C.LANGUAGE       F77
C.AUTHOR         K. Banse
C.ENVIRONMENT    Any
C.KEYWORDS       FORTRAN, C
C.PURPOSE        Check Fortran to C interface
C.COMMENTS       
C.VERSION  1.0   060315
C 
C 060316	last modif
C 
C 
C this is a Fortran program for the most basic test:
C 1) using COMMON in Fortran and access it from C
C 2) calling an ellips C routine 
C 
C----------------
C 
C 
      INTEGER    NUMB, LS2, MADRID(3)
C 
      CHARACTER*161 S2
C 
      COMMON /VMR/ MADRID
C 
      WRITE(*,995)
      WRITE(*,998)
      WRITE(*,996)
C 
      NUMB = -33
      MADRID(1) = 123456
      MADRID(2) = NUMB
      MADRID(3) = 99
      WRITE(*,2200) MADRID(1),MADRID(2),MADRID(3)
      CALL CSUB()
      WRITE(*,1100) 'CSUB'
C 
      WRITE(*,2100) 99123
      CALL SSN(99123)
      WRITE(*,1100) 'SSN'
      S2 = 'ss<abcdefghijklmnopqrstuvwxyz01234567890>XYZ'
      LS2 = 161
      WRITE(*,1000) S2,LS2
      CALL SSS(s2)
      WRITE(*,1100) 'SSS'
C 
      STOP 0
C 
995   FORMAT
     +(/'*********************************************************')
996   FORMAT
     +('*********************************************************'/)
998   FORMAT(/' Test of calling a C function with ellips',
     +       ' parameter definition from Fortran'/)
999   FORMAT('1 ')
1000  FORMAT('F: calling SSS(str1), str1 = ',A40/
     +'             length = ',I4)
1100  FORMAT('F: returning from ',A,/)
2100  FORMAT('F: calling SSN(n1), n1 = ',I8)
2200  FORMAT('F: calling CSUB(), COMMON = ',I6,',',I6,',',I6)
C 
      END

C @(#)rfotexamin.for	19.1 (ES0-DMD) 02/25/03 13:30:14
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM EXAMIN
C+++
C.IDENTIFICATION: EXAMIN
C.PURPOSE: The examine the quality of the fitted object
C.AUTHOR:  R. Buonanno, G. Buscema, C. Corsi, I. Ferraro, G. Iannicola
C          Osservatorio Astronomico di Roma
C.VERSION: 870328   Created
C.VERSION: 870417   Modified for idi interfaces               M.Pucillo, OAT
C.VERSION: 871216   Modified for integration into MIDAS       Rein Warmels, ESO
C.VERSION: 881028   Modifications for portable MIDAS          R. Buonanno
C.VERSION: 890320   Display part based on MIDAS plot software;
C.                  modifications for portability             Rein H. Warmels
C.VERSION: 890406   Rewritten for portable MIDAS; 
C                   Using MIDAS table interfaces              
C                   Based on MIDAS graphics interfaces        Rein H. Warmels
C---
      IMPLICIT       NONE
      INCLUDE        'MID_REL_INCL:RFOTDECL.INC'
C
      INTEGER        NHIST
      INTEGER        NTO
      PARAMETER      (NHIST=512)
      PARAMETER      (NTO=10000)
C
      INTEGER        MADRID(1)
      INTEGER        IFREQ(NHIST)
      INTEGER        IND(NTO,2)
      INTEGER        ED, EC, EL
      INTEGER        IS, IROW, ID, IDUM
      INTEGER        IHN
      INTEGER        IM, IT, IB
      INTEGER        IX1, IX2
      INTEGER        I
      INTEGER        IX, IXMAX, IYMAX
      INTEGER        ISTAT,IAC
      INTEGER        ICOUNT, ICOL
      INTEGER        K, KWR, KK
      INTEGER        NCP,NHL, NBINS
      INTEGER        NS, NGRP, NONC
      INTEGER        NNN, NACT, NCHAR
      INTEGER        NPIX, NPOS
      INTEGER        KUN,KNUL
      INTEGER        TIDINT
      INTEGER        NCINT,NRINT,NSINT,NACINT,NARINT
      INTEGER        PLMODE,ACCESS,ILOG
      INTEGER        MAX
      INTEGER        GRE
      INTEGER        TINULL
      INTEGER        NORDAT,PLTHST, PLTTBL
        
      DOUBLE PRECISION TDNULL,DDUM

      REAL           TRNULL
      REAL           RFREQ(NHIST)
      REAL           SQ(NTO),SIQ(NTO),H(NTO)
      REAL           SSIQ(NHIST), USC(NHIST), QP(NHIST)
      REAL           SIGMA(2), RMX(2) 
      REAL           XFIT(NHIST),YFIT(NHIST)
      REAL           XPOS(NTO), YPOS(NTO)
      REAL           RINPUT(3), MNMX(2)
      REAL           WIND(8), SCALES(3), OFFSET(2)
      REAL           CINT(NHIST)
      REAL           DINT(NHIST)
      REAL           PAR(3)
      REAL           FOPT(3)
      REAL           XMIN, XMAX, AXMIN, AXMAX, X1, X0
      REAL           STEP
      REAL           XMEAN, XSTD
      REAL           SQR, SL, SQM, FG
      REAL           XCUR, YCUR
      REAL           SQMAX, SMAX, SMIN, SQMIN
      REAL           HMIN, HMAX
      REAL           YOFF, DELTX
      REAL           RSMAX, RSQMAX
      REAL           XT
C    
      CHARACTER*60   INTFIL
      CHARACTER*80   STRING
      CHARACTER*72   CINPUT
      CHARACTER*17   COLUMN
      CHARACTER*60   LABEL1,LABEL2,LABEL3
      CHARACTER*4    XFRAME, YFRAME
      CHARACTER*1    OPTION*1, RET*1, KEY*1
C
      INCLUDE        'MID_INCLUDE:TABLES.INC'
      COMMON         /VMR/MADRID
      INCLUDE        'MID_INCLUDE:TABLED.INC'
C
      DATA           FOPT/0.0,999,0.0/
      DATA           PLMODE/1/
      DATA           ACCESS/0/
      DATA           ILOG/0/
      DATA           YOFF/0.0/
      DATA           XFRAME/'AUTO'/
      DATA           YFRAME/'AUTO'/
      DATA           SCALES/0.0,0.0,0.0/
      DATA           OFFSET/-999., -999./
C
 9001 FORMAT('*** WARNING: Something wrong with component ',
     2                     'in group: ',I8)
 9002 FORMAT('*** INFO: Number of groups found: ',I6)
 9003 FORMAT('          Number of groups used:  ',I6)
C
C  *** start of executable code ***************************************
      CALL STSPRO('EXAMINE')
      CALL TBMNUL(TINULL,TRNULL,TDNULL)
C
      CALL STKRDC('P1',1,1,60,IAC,INTFIL,KUN,KNUL,ISTAT)
      CALL STECNT('GET',EC,ED,EL)
      CALL STECNT('PUT',1,0,0)
      CALL TBTOPN(INTFIL,F_IO_MODE,TIDINT,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING= '*** FATAL: Error opening intermediate table file'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
C
C *** get table info
      CALL TBIGET(TIDINT,NCINT,NRINT,NSINT,NACINT,NARINT,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL: Problems with getting info for '//
     2            ' intermediate table; Try again ... '
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
      IF (NRINT.EQ.0) THEN
         STRING = '*** FATAL: No data points in intermediate table'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
      CALL STECNT('PUT',EC,ED,EL)
C
      CALL STKRDR('INPUTR',1,2,IAC,MNMX,KUN,KNUL,ISTAT)
      HMIN = MNMX(1)
      HMAX = MNMX(2)
      IF (HMAX.EQ.0.0) THEN
         HMIN = 0.0
         HMAX = 10.**15
      ENDIF
C
      RET  = 'Y'
      NS   = 0
      IROW = 1
      NGRP = 0
C
C *** start loop for reading components
 1001 CONTINUE
         CALL INTWRD(TIDINT,IROW,NCP,NHL)
         QP(1) = PARINT(8)
         QP(2) = PARINT(9)
         QP(3) = PARINT(10)
         GRE   = INT(PARINT(14))
         DO 1011 IS = 1,NCP
            QP((IS-1)*4+4) = FITCMP((IS-1)*6+1)
            QP((IS-1)*4+5) = FITCMP((IS-1)*6+2)
            QP((IS-1)*4+6) = FITCMP((IS-1)*6+3)
            QP((IS-1)*4+7) = FITCMP((IS-1)*6+4)
            USC(IS)        = FITCMP((IS-1)*6+5)
            SSIQ(IS)       = FITCMP((IS-1)*6+6)
 1011    CONTINUE
C
         IF (GRE.EQ.1 .OR. GRE.EQ.3) THEN
            DO 1021 K = 1,NCP
               IHN = 4*K
               IF (QP(IHN).GE.HMIN .AND. QP(IHN).LT.HMAX) THEN
                  NONC = FLGCMP(K)
                  IF (NONC.EQ.1 .OR. 
     2               (NONC.EQ.2 .AND. RET.EQ.'N')) THEN
                     NS        = NS+1
                     IND(NS,1) = IROW
                     IND(NS,2) = K
                     SQ(NS)    = USC(K)
                     SIQ(NS)   = SSIQ(K)
                     ID        = 4*K
                     H(NS)     = QP(ID)
                     IF (H(NS).LE.0) THEN
                        WRITE(STRING,9001) IDNGRP
                        CALL STTPUT(STRING,ISTAT)
                        NS = NS - 1
                     ENDIF
                     IF (NONC.EQ.2 .AND. RET.EQ.'N') THEN
                        KWR = 1
                        FLGCMP(K) = 1
                     ENDIF
                  ENDIF
               ENDIF
 1021       CONTINUE
         ENDIF
C
         IF (KWR.EQ.1) THEN
            CALL INTWRD(TIDINT,IROW,NCP,NHL)
         ENDIF
         NGRP = NGRP + 1
         IROW = IROW + NCP + NHL
         IF (IROW.LE.NRINT) THEN 
            GO TO 1001
         ELSE
            WRITE (STRING,9002) NGRP
            CALL STTPUT(STRING,ISTAT)
            WRITE (STRING,9003) NS
            CALL STTPUT(STRING,ISTAT)
         ENDIF
C
      ASSIGN 30011 TO NORDAT
      GO TO 30001
30011 CONTINUE

      ASSIGN 30012 TO PLTHST
      GO TO 30002
30012 CONTINUE

      ASSIGN 30013 TO PLTTBL
      GO TO 30003
30013 CONTINUE
C
C *** terminate AGL operations
      CALL PTCLOS()
      CALL STSEPI
C
C+++
30001 CONTINUE                                         ! Procedure NORDAT
C---
      SQMAX = -10.**15
      SQMIN = -SQMAX
      SMAX  = SQMAX
      SMIN  = SQMIN
      DO 30101 I = 1,NS
C        YY     = SQRT(H(I))
C        SIQ(I) = SIQ(I)/YY
         SQMAX  = AMAX1(SQMAX,SQ(I))
         SQMIN  = AMIN1(SQMIN,SQ(I))
         SMAX   = AMAX1(SMAX,SIQ(I))
         SMIN   = AMIN1(SMIN,SIQ(I))
30101 CONTINUE
C
      RSMAX  = SMAX
      RSQMAX = SQMAX
      GO TO NORDAT

C
C+++
30002 CONTINUE                                         ! Procedure PLTHST
C---
 9004 FORMAT('          Position of maximum and standard deviation: ',
     2        F10.4, '; ', F10.4) 
C
      DO 30102 KK = 1,2
         STEP   = 0.0
         ICOUNT = 0
         IF (KK.EQ.1) THEN
            COLUMN = ':CHI_SQ'
         ELSE
            COLUMN = ':SIQ'
         ENDIF
C
C *** read the table columns
         CALL TBCSER(TIDINT,COLUMN,ICOL,ISTAT)
         IF (ISTAT.NE.0 .OR. ICOL.EQ.-1) THEN
            STRING = '*** FATAL: Problems with finding column'//
     2               COLUMN
            CALL STTPUT(STRING,ISTAT)
            CALL STSEPI
         ENDIF
C
C *** get the minimum and maximum 
         CALL TDUMNX(TIDINT,ICOL,NRINT,0,XMIN,XMAX)
         IF (XMIN.EQ.XMAX) THEN
            XMAX = XMIN + 1.
         ENDIF
         CALL TDSCAL(XMIN,XMAX,1.,X0,X1,IX,XT,NNN)
         IF (AXMIN.EQ.TRNULL) THEN
            AXMIN = X0*10.**IX
         ELSE
            AXMIN = XMIN
         ENDIF
         IF (AXMAX.EQ.TRNULL) THEN
            AXMAX = X1*10.**IX
         ELSE
            AXMAX = XMAX
         ENDIF
         IF (STEP.EQ.0.0) THEN
            STEP = XT
         ENDIF
C
C *** determine the frequency distribution
39802    CONTINUE
         NBINS   = (AXMAX-AXMIN)/STEP+1
         NBINS   = MIN(NHIST,NBINS)
         CINT(1) = AXMIN
         DO 30202 I = 1,NBINS
             CINT(I+1) = CINT(I) + STEP
30202    CONTINUE
         CALL TDRSTA(TIDINT,ICOL,NRINT,NBINS,1,CINT,
     2               IFREQ,NACT,XMEAN,XSTD)
         DO 101 I = 1,NBINS
            RFREQ(I) = FLOAT(IFREQ(I))
  101    CONTINUE
         IF (NACT.EQ.0) THEN
            CALL STTPUT(' *** FATAL: No selected entries '//
     2                  ' or empty column', ISTAT)
            CALL STSEPI
         ENDIF 
C
C *** statistics determined; start the display
         CALL PTKWRR('SCALE',2,SCALES)
         CALL PTKWRR('OFFS',2,OFFSET)
C
C *** calculate frame
         WIND(1) = CINT(1)
         WIND(2) = CINT(NBINS-1)
         WIND(3) = 0.0
         WIND(4) = 0.0
         WIND(5) = 0.0
         WIND(6) = 0.0
         WIND(7) = 0.0
         WIND(8) = 0.0
         DO 30302 I = 1,NBINS
            IYMAX = IFREQ(I)
            IF (IYMAX.GT.WIND(6)) THEN
               WIND(6) = IYMAX
               IXMAX    = I
            ENDIF
30302    CONTINUE
         IF (WIND(5).EQ.WIND(6)) THEN
            WIND(6) = WIND(5) + 1
         ENDIF
C
C *** get the frame ranges in x and y
         CALL GETAXS(XFRAME,WIND(1))
         CALL GETAXS(YFRAME,WIND(5))
         CALL PTKWRR('XWNDL',4,WIND(1))
         CALL PTKWRR('YWNDL',4,WIND(5))
C
C *** do the plot setup
         IF (ICOUNT.GT.0) THEN
            CALL AGVERS                                 ! reset graphics window
            CALL AGWDEF(WIND(1),WIND(2),WIND(5),WIND(6))
         ELSE
            CALL PTOPEN(' ','none',ACCESS,PLMODE)             ! open the device
         ENDIF
C
C *** do the work
         DO 102 IB = 1,NBINS
           DINT(IB) = CINT(IB) - STEP/2.
 102     CONTINUE
         CALL PTHIST(NBINS,DINT,RFREQ,FOPT)
         IF (KK.EQ.1) THEN
            LABEL1 = 'CHI**2'
         ELSE
            LABEL1 = 'SIQ'
         ENDIF
         LABEL2 = 'Frequency'
         LABEL3 = 'TITLE=Table: '//INTFIL
         CALL PTAXES(WIND(1),WIND(5),LABEL1,LABEL2,LABEL3)
C
C *** fit the frequency distribution with a gaussian
         NPIX   = NBINS-1
         MAX = -32000
         DO 30402 IM = 1,NPIX
            IF (IFREQ(IM).GT.MAX) THEN
               MAX = IFREQ(IM)
               IX1 = IM
            ENDIF
30402    CONTINUE
         IX2 = IX1
30502    CONTINUE
         IF (IFREQ(IX2).LE.MAX/2. .OR. IX2 .LE.1) THEN
            GO TO 30602
         ELSE
            IX2 = IX2 - 1
            GO TO 30502
         ENDIF
C
30602    CONTINUE
         PAR(1) = MAX
         PAR(2) = IX1
         PAR(3) = IX2
         SQR    = 10.**15
         SL     = SQR
         IT     = 0
30702    CONTINUE
         IF (SL.LE.0.00001 .OR. IT.GT.100) GO TO 30802
            IT = IT+1
            CALL FIST(IFREQ,NPIX,PAR)
            SQM = 0.
            DO 30902 IB = 1,NPIX
               FG  = PAR(1)*EXP(-4.*ALOG(2.)*((IB-PAR(2))/PAR(3))**2)
               SQM = SQM +(IFREQ(IB)-FG)**2
30902       CONTINUE
            SQM = SQRT(SQM/NPIX)
            SL  = ABS(SQR-SQM)/SQR
            SQR = SQM
            GO TO 30702
30802    CONTINUE
         RMX(KK)   = (PAR(2)-1.5)*STEP+AXMIN
         SIGMA(KK) = PAR(3)*STEP/SQRT(8*ALOG(2.))
         DELTX     = (AXMAX-AXMIN)/NHIST
C
         DO 31002 IB = 1,NHIST
            XFIT(IB) = AXMIN + (IB-1)*DELTX
            YFIT(IB) = PAR(1) * EXP(-4.*ALOG(2.)*
     2                          ((XFIT(IB)-RMX(KK))/(PAR(3)*STEP))**2)
31002    CONTINUE
         CALL PTDATA(0,1,1,XFIT,YFIT,0,NHIST)

C *** satisfied or not ?
         ICOUNT = ICOUNT + 1
         IF (ICOUNT.GE.1) THEN
            IF (KK.EQ.1) THEN
               STRING = '*** INFO: Histogram of chi square values:'
            CALL STTPUT(STRING,ISTAT)
            ELSE
               STRING = '*** INFO: Histogram of semi interq. interval:'
            CALL STTPUT(STRING,ISTAT)
            ENDIF
            WRITE(STRING,9004) RMX(KK),SIGMA(KK)
            CALL STTPUT(STRING,ISTAT)
            STRING = '          Enter new min.,max.,step for '//
     2               'histogram [fit ok]: ' 
            NCHAR = INDEX(STRING,':')+1
            CALL STKPRC(STRING(1:NCHAR),'INPUTC',1,1,60,IAC,CINPUT,
     2                  KUN,KNUL,ISTAT)
            IF (IAC.EQ.0 .OR. CINPUT(1:2).EQ.'OK') THEN
               GO TO 39902
            ELSE
               CALL GENCNV(CINPUT,2,3,IDUM,RINPUT,DDUM,ISTAT)
C              CALL USRINP(RINPUT,3,'R',CINPUT)
               AXMIN = RINPUT(1)
               AXMAX = RINPUT(2)
               STEP  = RINPUT(3)
               GO TO 39802
            ENDIF
         ENDIF
39902    CONTINUE
30102 CONTINUE
      GO TO PLTHST

C
C+++
30003 CONTINUE                                         ! Procedure PLTTBL
C---
      ICOUNT = 0
39903 CONTINUE
C
C
C *** do the display part here
      WIND(1) = SQMIN/SIGMA(1) - 0.5
      WIND(2) = SQMAX/SIGMA(1) + 0.5
      WIND(3) = 0.0
      WIND(4) = 0.0
      WIND(5) = SMIN/SIGMA(2) - 0.5
      WIND(6) = SMAX/SIGMA(2) + 0.5
      WIND(7) = 0.0
      WIND(8) = 0.0
C
C *** statistics determined; start the display
      CALL PTKWRR('SCALE',2,SCALES)
      CALL PTKWRR('OFFS',2,OFFSET)
      CALL GETAXS(XFRAME,WIND(1))
      CALL GETAXS(YFRAME,WIND(5))
      CALL PTKWRR('XWNDL',4,WIND(1))                  ! store the axes def.'s
      CALL PTKWRR('YWNDL',4,WIND(5))
C
C *** do the plot setup
      CALL AGVERS
      CALL AGWDEF(WIND(1),WIND(2),WIND(5),WIND(6))
C
C *** plot the data
      NPOS = 0
      DO 30103 IS = 1,NS
         IF (IND(IS,1).GT.0) THEN
            NPOS       = NPOS + 1
            XPOS(NPOS) = SQ(IS)/SIGMA(1)
            YPOS(NPOS) = SIQ(IS)/SIGMA(2)
         ENDIF
30103 CONTINUE
C 
C *** set the window
      CALL PTDATA(5,0,0,XPOS,YPOS,0.0,NPOS)
C
C *** plot the frame
      LABEL1 = 'CHI**2'
      LABEL2 = 'SIQ'
      LABEL3 = 'TITLE=Table: '//INTFIL
      CALL PTAXES(WIND(1),WIND(5),LABEL1,LABEL2,LABEL3)
C
39803 CONTINUE
      STRING = '*** Enter flag option (X, Y, A, R or E) [H]: '
      NCHAR = INDEX(STRING,':')+1
      OPTION = 'H'
      CALL STKWRC('INPUTC',1,OPTION,1,1,KUN,ISTAT)     ! store the scales
      CALL STKPRC(STRING(1:NCHAR),'INPUTC',1,1,1,IAC,OPTION,
     2            KUN,KNUL,ISTAT)
      CALL UPCAS(OPTION,OPTION)
C
      IF (OPTION.EQ.'F' .OR. OPTION.EQ.'E') THEN
         DO 30203 IS = 1,NS                            ! go through the objects
            IF (IND(IS,1).LT.0) THEN                   ! is the object selected
               IROW = IABS(IND(IS,1))                  ! row number of object
               CALL INTWRD(TIDINT,IROW,NCP,NHL)        ! read object components
               FLGCMP(IND(I,2)) = 2                    ! set the component flag
               CALL INTWWR(TIDINT,IROW,NCP,NHL)        ! write the object back
            ENDIF
30203    CONTINUE
         GO TO PLTTBL

      ELSE IF (OPTION.EQ.'X') THEN
         CALL PTGCUR(XCUR,YCUR,KEY,ISTAT)              ! get the cursor
         XCUR = XCUR*SIGMA(1)
         DO 30303 IS = 1,NS                            ! run through objects
            IF (IND(IS,1).GT.0) THEN                   ! selected ?
               IF (SQ(IS).GT.XCUR) THEN                ! SQ > x_cursor
                  IND(IS,1) = -IND(IS,1)               ! flag the object
               ENDIF
            ENDIF
30303    CONTINUE
         SQMAX  = XCUR                                 ! redefined maximum
         ICOUNT = ICOUNT + 1                           ! increase graph counter
         GO TO 39903

      ELSE IF (OPTION.EQ.'Y') THEN
         CALL PTGCUR(XCUR,YCUR,KEY,ISTAT)              ! get the cursor
         YCUR = YCUR*SIGMA(2)
         DO 30403 IS = 1,NS
            IF (IND(IS,1).GT.0) THEN
               IF (SIQ(IS).GT.YCUR) THEN
                  IND(IS,1) = -IND(IS,1)
               ENDIF
            ENDIF
30403    CONTINUE
         SMAX   = YCUR        
         ICOUNT = ICOUNT + 1
         GO TO 39903

      ELSE IF (OPTION.EQ.'A') THEN
         CALL PTGCUR(XCUR,YCUR,KEY,ISTAT)              ! get the cursor
         XCUR = XCUR*SIGMA(1)
         YCUR = YCUR*SIGMA(2)
         DO 30503 IS = 1,NS                            ! run through objects
            IF (IND(IS,1).GT.0) THEN                   ! selected ?
               IF (SQ(IS).GT.XCUR) THEN                ! SQ > x_cursor
                  IND(IS,1) = -IND(IS,1)               ! flag the object
               ENDIF
               IF (SIQ(IS).GT.YCUR) THEN
                  IND(IS,1) = -IND(IS,1)
               ENDIF
            ENDIF
30503    CONTINUE
         SQMAX  = XCUR                                 ! redefined maximum
         SMAX   = YCUR        
         ICOUNT = ICOUNT + 1                           ! increase graph counter
         GO TO 39903

      ELSE IF (OPTION.EQ.'R') THEN
         DO 30603 IS = 1,NS
            IF (IND(IS,1).LT.0) THEN
               IND(IS,1) = -IND(IS,1)
            ENDIF
30603    CONTINUE
         SMAX   = RSMAX
         SQMAX  = RSQMAX
         ICOUNT = ICOUNT + 1
         GO TO 39903

      ELSE IF (OPTION.EQ.'H' .OR. IAC.EQ.0) THEN
         CALL STTPUT('          A: Flag objects at the right OR '//
     2                'above cursor', ISTAT)
         CALL STTPUT('          X: Flag objects at the right of '//
     2               'vertical cursor', ISTAT)
         CALL STTPUT('          Y: Flag objects above of '//
     2               'horizontal cursor', ISTAT)
         CALL STTPUT('          R: Restore all flags', ISTAT)
         CALL STTPUT('          H: Display this help information', 
     2               ISTAT)
         CALL STTPUT('          F or E: EXIT', ISTAT)
         GO TO 39803

      ELSE
         CALL STTPUT('*** WARNING: Unknown option', ISTAT)
         GO TO 39803
      ENDIF
C
      END

C @(#)ccdhotpix.for	19.1 (ES0-DMD) 02/25/03 14:17:24
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C @(#)ccdhotpix.for	19.1 (ESO-SDAG) 02/25/03 14:17:24
       PROGRAM HOTPIX
C+++
C.IDENTIFICATION: ccdhottab.for
C.PURPOSE: Analayse the bad pixels table from FIND/PIXEL and construct the
C          hot pixel table
C.AUTHOR:  R.H Warmels, ESO-SDAG
C.VERSION: 940531   RHW Creation
C----
      IMPLICIT       NONE
C
      INTEGER        NCOL
      PARAMETER      (NCOL=3)
      INTEGER        NCOL1
      PARAMETER      (NCOL1=2)
      INTEGER        NROW
      PARAMETER      (NROW=100)
C ***
      INTEGER        ISTAT, IAC, IC, IR, IROUT
      INTEGER        COLUMNS(NCOL)
      INTEGER        KUN, KNUL
      INTEGER        MADRID(1)
      INTEGER        NRIN,NCIN,NACIN,NARIN,NSIN
      INTEGER        OUTCOL
      INTEGER        TIDIN,TIDOUT
      INTEGER        LFIELD,CTYPE
C ***
      REAL           CVAL1(NCOL), CVAL2(NCOL)
      REAL           EPS
      LOGICAL        NULL(NCOL)
C ***
      CHARACTER*60   INTAB,OUTTAB
      CHARACTER*16   CUNI,CLAB,CFRM
      CHARACTER*80   STRING
C ***
      INCLUDE        'MID_INCLUDE:TABLES.INC'
      COMMON         /VMR/MADRID
      INCLUDE        'MID_INCLUDE:TABLED.INC'
C ***
      DATA           COLUMNS/1,2,3/
      DATA           EPS/1.0e-12/
C----------------------------------------------------------------------------
      CALL STSPRO('HOTPIX')
C
C *** get the input
      CALL STKRDC('IN_A',1,1,60,IAC,INTAB,KUN,KNUL,ISTAT)
      CALL STKRDC('OUT_A',1,1,60,IAC,OUTTAB,KUN,KNUL,ISTAT)
C
C ***
      CALL TBTOPN(INTAB,F_I_MODE,TIDIN,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL: Error opening input table'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
C
      CALL TBIGET(TIDIN,NCIN,NRIN,NSIN,NACIN,NARIN,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL: Problems with getting table info '//
     2            'of intermediate table'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
      IF (NRIN.EQ.0) THEN
         STRING = '*** FATAL: There are no data in the input table'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
C
C *** create the hot pixel table
      CALL TBTINI(OUTTAB,1,F_O_MODE,NCOL,NROW,TIDOUT,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL:  Problems with opening hot pixel table'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
C
C *** Create the output table
      DO IC = 1, NCOL
          CALL TBFGET(TIDIN,IC,CFRM,LFIELD,CTYPE,ISTAT)
          CALL TBUGET(TIDIN,IC,CUNI,ISTAT)
          CALL TBLGET(TIDIN,IC,CLAB,ISTAT)
          CALL TBCINI(TIDOUT,CTYPE,1,CFRM,CUNI,CLAB,OUTCOL,ISTAT)    
      ENDDO
C
      CALL TBRRDR(TIDIN,1,NCOL,COLUMNS,CVAL1,NULL,ISTAT)
      CALL TBRWRR(TIDOUT,1,NCOL,COLUMNS,CVAL1,ISTAT)
      IROUT = 1
      DO IR = 2,NRIN
         CALL TBRRDR(TIDIN,IR,NCOL,COLUMNS,CVAL2,NULL,ISTAT)
         IF (ABS(CVAL2(1)-CVAL1(1)) .GT. EPS) THEN
            IROUT = IROUT + 1
            CALL TBRWRR(TIDOUT,IROUT,NCOL,COLUMNS,CVAL2,ISTAT)
            DO IC = 1,NCOL
               CVAL1(1) = CVAL2(1)
               CVAL1(2) = CVAL2(2)
               CVAL1(3) = CVAL2(3)
            ENDDO
         ENDIF
      ENDDO
C
C *** read the input and store first entry in output table
      CALL TBTCLO(TIDIN,ISTAT)
      CALL TBTCLO(TIDOUT,ISTAT)
      CALL STSEPI
      END

C @(#)clasfy.for	19.1 (ES0-DMD) 02/25/03 13:25:32
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C.IDENT:    subroutine CLASFY         version 1.2        870707
C           A. Kruszewski             ESO Garching
C.VERSION:  1.0  ESO-FORTRAN Conversion, AA  15:03 - 21 NOV 1987
C.LANGUAGE: F77+ESOext
C.AUTHOR:   A.KRUSZEWSKI
C.PURPOSE:
C.INPUT/OUTPUT:
C  input arguments
C  ICLS        integer*4 array      holds seed and current 
C  PCLA        real*4 array         array holding classifiers
C  BRGT        logical array        array indicating saturated objects
C  M           integer*4            number of objects
C  output arguments
C  PCLA        real*4 array      array holding corrected classifiers
C  ITER        integer*4         number of iteration
C  DONE        logical           convergence indicator
C-----------------------------------------------------------------------
C
      SUBROUTINE CLASFY(PCLA,BRGT,ICLS,M,ITER,DONE)
C
      IMPLICIT NONE
      INCLUDE 'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER      I, IC, IN
      INTEGER      IW(0:MAXCNT)
      INTEGER      ICTL(7)
      INTEGER      ICLS(2,MAXCNT)
      INTEGER      ITLM(2)
      INTEGER      ITER
      INTEGER      IAC
      INTEGER      ICHG
      INTEGER      ISTAT
      INTEGER      IVAR
      INTEGER      M
      INTEGER      MADRID(1)
      INTEGER      J
      INTEGER      K
      INTEGER      KUN, KNUL
      INTEGER      L
      LOGICAL      BRGT(MAXCNT)
      LOGICAL      DONE
      REAL         DVGR(0:MAXCNT)
C     REAL         TINFO(13)
C     REAL         CLPR(3)
      REAL         CLDV(13,MAXCNT)
      REAL         X(0:MAXCNT)
      REAL         Y(0:MAXCNT)
      REAL         COVM(13,13)
      REAL         DIST(2,MAXCNT)
      REAL         PCLA(0:13,MAXCNT)
      REAL         SGLM
      REAL         SIGMA
      REAL         ZRLV
      REAL         GRDT
      REAL         SDIS
      REAL         GDIS
      REAL         TEMP
      CHARACTER*80 OUTPUT
C
      COMMON       /VMR/MADRID
C
      CALL STKRDR( 'INV_REAL' , 9 , 1 , IAC , SGLM , KUN , KNUL , ISTAT)
      CALL STKRDI( 'INV_INTG' , 17 , 2 , IAC , ITLM , KUN , KNUL ,ISTAT)
C
C         Stars and galaxies are treated seperately
C ****    (L=1 stars, L=2 galaxies) using current
C         classification resting in ICLS(2,*).
C
      DO 130 L = 1 , 2
C
C            Perform regression of parameters onto logarithm
C ****       of central brightness. At first the objects
C            of considered class are marked in array IW.
C
      IW(0)  = 0
      IN     = 0
      DO 10 I = 1,M
          IF ( .NOT. BRGT(I) .AND. ICLS(2,I).EQ.L) THEN
              IW(I)  = 1
              IN     = IN + 1

          ELSE
              IW(I)  = 0
          END IF

          X(I)   = PCLA(0,I) - 19.0
   10 CONTINUE
      IF (IN.GT.15) THEN
          DO 40 J = 1,13
              DO 20 I = 1,M
                  Y(I)   = PCLA(J,I)
   20         CONTINUE
              CALL GRADET(M,X,Y,IW,ZRLV,GRDT,DVGR,SIGMA)
              DO 30 I = 1,M
                  CLDV(J,I) = DVGR(I)
   30         CONTINUE
   40     CONTINUE
C
C       calculates covariance matrix COVM of parameter's deviations CLDV
C
          DO 60 J = 1,13
              DO 50 I = 1,13
                  COVM(I,J) = 0.0
   50         CONTINUE
   60     CONTINUE
          DO 90 J = 1,13
              DO 80 I = 1,13
                  IC     = 0
                  DO 70 K = 1,M
                      IF (IW(K).EQ.1) THEN
                          COVM(I,J) = COVM(I,J) + CLDV(I,K)*CLDV(J,K)
                          IC     = IC + 1
                      END IF

   70             CONTINUE
                  IF (L.EQ.1) THEN
                      ICTL(1) = IC

                  ELSE IF (L.EQ.2) THEN
                      ICTL(2) = IC
                  END IF

                  COVM(I,J) = COVM(I,J)/ (IC-13)
   80         CONTINUE
   90     CONTINUE
C            DO6912 I=1,13
C               TINFO(I)=COVM(I,I)
C            END DO
C
C       inverts covariance matrix
C
          CALL INVERT(COVM,13)
C
C       we can now calculate distances of particular objects from
C       the center of L-th class in the parameters space
C
          DO 120 K = 1,M
              IF ( .NOT. BRGT(K)) THEN
                  TEMP   = 0.0
                  DO 110 J = 1,13
                      DO 100 I = 1,13
                          TEMP   = TEMP + COVM(I,J)*CLDV(I,K)*CLDV(J,K)
  100                 CONTINUE
  110             CONTINUE
                  DIST(L,K) = TEMP
              END IF

  120     CONTINUE
      END IF

  130 CONTINUE
C
C classification is performed by comparing distances in parameter space
C    from centers of two classes of objects
C
      ICHG   = 0
      DO 140 K = 1,M
          IF ( .NOT. BRGT(K)) THEN
              SDIS   = DIST(1,K)
              GDIS   = DIST(2,K)
              IVAR   = ICLS(2,K)
              IF (SDIS.GT.SGLM .AND. GDIS.GT.SGLM) THEN
                  ICLS(2,K) = 0

              ELSE
                  IF (SDIS.LT.GDIS) THEN
                      ICLS(2,K) = 1

                  ELSE
                      ICLS(2,K) = 2
                  END IF

              END IF

              IF (ICLS(2,K).NE.IVAR) THEN
                  ICHG   = ICHG + 1
              END IF

          END IF

  140 CONTINUE
      ITER   = ITER + 1
      IF (ICHG.LE.ITLM(1) .OR. ITER.GT.ITLM(2)) THEN
          DONE   = .TRUE.
      END IF

      ICTL(3) = ICHG
      DO 150 I = 4,7
          ICTL(I) = 0
  150 CONTINUE
      WRITE (OUTPUT,'(3(A,I6))') ' Stars: ',ICTL(1),'   Galaxies: ',
     +  ICTL(2),'   Changes: ',ICTL(3)
      CALL STTPUT(OUTPUT,ISTAT)
C
      RETURN

      END

C===========================================================================
C Copyright (C) 1995-2005 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION: BKGRND
C.LANGUAGE:       F77+ESOext
C.AUTHOR:         Capaccioli/Held
C.KEYWORDS:       polinomial fit
C.PURPOSE:        Calculate the coefficients of a 2D polinomial approximation 
C                 of the sky background. Optionally create frames with the 
C                 background subtracted image and the polinomial surface.
C.ALGORITHM:      Coefficients are calculated by an iterative least-squares 
C                 fitting of the pixels in the rebinned image frame. If a 
C                 predefined 'masking frame' is given, only not masked pixels 
C                 are taken in account.
C.INPUT/OUTPUT:   the following keywords are used:
C                 IN_A/C/1/60   name of image data frame
C                 IN_B/C/1/60   name of masking frame
C                 OUT_A/C/1/60  name of output corrected image
C                 OUT_B/C/1/60  name of output background surface
C                 INPUTI/I/1/2  degree, maximum n. of iterations
C                 INPUTR/R/1/1  clipping par. for the 1st iteration
C                 INPUTR/R/2/1  clipping par. for following iter.
C                 INPUTR/R/3/1  upper limit of acceptable skewness
C                 INPUTC/C/1/8  name of the keyword storing coeff.
C.VERSION         840517
C.VERSION:        871124  RHW ESO-FORTRAN Conversion
C 
C 051107	last modif
C 
C ---------------------------------------------------------------------
      PROGRAM BCKGRN

      IMPLICIT NONE
C
      CHARACTER*60 FRAMEA,FRAMEB,FRAMEC,FRAMED
      CHARACTER*8  INPUTC
      CHARACTER    CUNITA*64,IDENTA*72,CUNITB*64,IDENTB*72
      CHARACTER    HISTC*80,HISTD*80
      CHARACTER    MLINE1*40,MLINE2*40,LINE*80

      INTEGER      MADRID,KUN,KNUL,IMFA,IMFB,IMFD,IMFC
      INTEGER      IAV,ISTAT
      INTEGER      JER,MODE,NAXISA,NAXISB,NLOOP
      INTEGER      INPUTI(2)
      INTEGER      NPIXA(3),NPIXB(3),NPIXT(3)
      INTEGER      ICONT,ICONTP
      INTEGER*8      IPNTRA,IPNTRB,IPNTRC,IPNTRD
C
      REAL         AINCR,CONV
      REAL         INPUTR(3)
      REAL         ATEMP(128,128)
      REAL         RKAPPA,REJ,RMEAN,SIGM1,SKEW1,RKURT
      DOUBLE PRECISION STEPA(3),STARTA(3),STEPB(3),STARTB(3)
      DOUBLE PRECISION STEPT(3),STARTT(3)
      DOUBLE PRECISION C(21),DSTORE(7)
C
      LOGICAL      FLMSK,FLGSB,FLGSU,CASEA,CASEB

      INCLUDE      'MID_INCLUDE:ST_DEF.INC/NOLIST'
      COMMON /VMR/MADRID(1)
      INCLUDE      'MID_INCLUDE:ST_DAT.INC/NOLIST'
C
      DATA         MLINE1/'    Iter  Points  Mean (10^6)   Sigma'/
      DATA         MLINE2/'  Skewness  Kurtosis'/
      DATA         LINE/' '/
      DATA         CASEA,CASEB/.FALSE.,.FALSE./
      DATA         REJ/-99999./                      !  minimum relative change
      DATA         CONV/.002/                        !  needed if no mask
      DATA         NPIXB/1,1,1/
C
C *** set up MIDAS environment + enable automatic error abort
      CALL STSPRO('BKGRND')
      CALL STKRDI('MID$MODE',1,1,IAV,MODE,KUN,KNUL,ISTAT)
C
C *** get names of input frame + masking frame
      CALL STKRDC('IN_A',1,1,60,IAV,FRAMEA,KUN,KNUL,ISTAT)
      CALL STKRDC('IN_B',1,1,60,IAV,FRAMEB,KUN,KNUL,ISTAT)
C
C *** setup history update
      HISTC = 'background corrected frame obtained from '//FRAMEA
      HISTD = 'background pol. surface using dimensions from '//
     +         FRAMEA
C
C *** get output frames
      CALL STKRDC('OUT_A',1,1,60,IAV,FRAMEC,KUN,KNUL,ISTAT)
      CALL STKRDC('OUT_B',1,1,60,IAV,FRAMED,KUN,KNUL,ISTAT)
C
C *** read flag keyword INPUTC
      CALL STKRDC('INPUTC',1,1,12,IAV,INPUTC,KUN,KNUL,ISTAT)
C
C *** find out which case
      IF (INPUTC(1:1).EQ.'?') THEN                     ! read useful parameters
         CALL STKRDI('INPUTI',1,2,IAV,INPUTI,KUN,KNUL,ISTAT)
         CALL STKRDR('INPUTR',1,3,IAV,INPUTR,KUN,KNUL,ISTAT)
         CASEA = .TRUE.
      ELSE              ! only create new images reading coeff. from a keyword
         CASEB = .TRUE.
      END IF
C
C *** get input frame and map it
      CALL STIGET(FRAMEA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     2            2,NAXISA,NPIXA,STARTA,STEPA,IDENTA,CUNITA,
     3            IPNTRA,IMFA,ISTAT)
      IF (NAXISA.GT.2) THEN
         CALL STTPUT('*** FATAL: maximum 2 dim. currently supported...',
     +               ISTAT)
         CALL STSEPI
      END IF
C
C *** get masking frame (if exists) and map it
      IF (FRAMEB(1:1).NE.'+') THEN
         FLMSK  = .TRUE.
         CALL STIGET(FRAMEB,D_R4_FORMAT,F_IO_MODE,F_IMA_TYPE,
     2               2,NAXISB,NPIXB,STARTB,STEPB,IDENTB,CUNITB,
     3               IPNTRB,IMFB,ISTAT)
      ELSE
         FLMSK  = .FALSE.
      END IF
C
C *** get output frame for corrected image, map it and set descriptors
      IF (FRAMEC(1:1).NE.'+') THEN
          FLGSB  = .TRUE.
          CALL STIPUT(FRAMEC,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     2                NAXISA,NPIXA,STARTA,STEPA,IDENTA,CUNITA,
     3                IPNTRC,IMFC,ISTAT)
          CALL STDCOP(IMFA,IMFC,4,'HISTORY',ISTAT)
          CALL STDCOP(IMFA,IMFC,4,'LHCUTS',ISTAT)
C         CALL STDWRC(IMFC,'HISTORY',1,HISTC,-1,80,ISTAT)

      ELSE
          FLGSB  = .FALSE.
      END IF
C
C *** get output frame for polinomial surface , map it and set descriptors
      IF (FRAMED(1:1).NE.'+') THEN
          FLGSU  = .TRUE.
          CALL STIPUT(FRAMED,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     2                NAXISA,NPIXA,STARTA,STEPA,IDENTA,CUNITA,
     3                IPNTRD,IMFD,ISTAT)
          CALL STDCOP(IMFA,IMFD,4,'HISTORY',ISTAT)
          CALL STDCOP(IMFA,IMFD,4,'LHCUTS',ISTAT)
C         CALL STDWRC(IMFD,'HISTORY',1,HISTD,-1,80,ISTAT)

      ELSE
          FLGSU  = .FALSE.
      END IF
C
C *** check parameters values
      IF (CASEA) THEN
          IF (INPUTI(1).LE.0 .OR. INPUTI(1).GT.5) THEN
             CALL STTPUT('*** FATAL: Invalid degree: should be 1 to 5',
     +                   ISTAT)
             CALL STSEPI
          END IF

          IF (INPUTI(2).LE.0) THEN
             CALL STTPUT('*** FATAL: Invalid number of iterations: '//
     +                    'should be greater than zero',ISTAT)
             CALL STSEPI
          END IF

          IF (INPUTI(2).GT.20) THEN
             INPUTI(2) = 20
             CALL STTPUT('*** WARNING: Maximum number of iterations '//
     +                    'set to 20 ',ISTAT)
          END IF

          IF (INPUTR(1).LE.0 .OR. INPUTR(2).LE.0) THEN
             CALL STTPUT('*** FATAL: Invalid kappa: should be '//
     +                   'greater than zero',ISTAT)
             CALL STSEPI
          END IF

          IF (INPUTR(3).LE.0) THEN
             CALL STTPUT('*** FATAL: Invalid skewness: should be '//
     +                   'greater than zero',ISTAT)
            CALL STSEPI
         END IF
      END IF
C
C *** if case b jump to section creating output frames
      IF (CASEB) GO TO 20
C
C *** rebin input image to run faster
      CALL SQZTMP(MADRID(IPNTRA),ATEMP,NPIXA(1),NPIXA(2),STARTA(1),
     +                 STARTA(2),STEPA(1),STEPA(2),NPIXT(1),NPIXT(2),
     +                 STARTT(1),STARTT(2),STEPT(1),STEPT(2))
C
C *** write scaling parameters and degree in keyword INPUTC
      DSTORE(1) = NPIXT(1)
      DSTORE(2) = NPIXT(2)
      DSTORE(3) = STARTT(1)
      DSTORE(4) = STARTT(2)
      DSTORE(5) = STEPT(1)
      DSTORE(6) = STEPT(2)
      DSTORE(7) = INPUTI(1)
      CALL STKWRD('BG_COEF',DSTORE,22,7,KUN,ISTAT)
C
C *** main loop : iterations
      RKAPPA = INPUTR(1)
      DO 10 NLOOP = 1,INPUTI(2)
         IF (NLOOP.NE.1) RKAPPA = INPUTR(2)
C
C *** calculate coefficients for this loop and param. of residuals
         CALL FEET(MADRID(IPNTRB),ATEMP,INPUTI(1),FLMSK,REJ,NPIXB(1),
     +             NPIXB(2),STARTB(1),STARTB(2),STEPB(1),STEPB(2),
     +             NPIXT(1),NPIXT(2),STARTT(1),STARTT(2),STEPT(1),
     +             STEPT(2),ICONT,RMEAN,SIGM1,SKEW1,RKURT,C,JER)
C
C *** check interpolation failure
         IF (JER.NE.0) THEN
            CALL STTPUT('*** FATAL: Interpolation failed',ISTAT)
            CALL STSEPI
         END IF
C
C *** write coefficients in keyword INPUTC
         CALL STKWRD('BG_COEF',C,1,21,KUN,ISTAT)
C
C *** write significant parameters on terminal
         IF (NLOOP.EQ.1) THEN
            CALL STTPUT(MLINE1//MLINE2,ISTAT)
         ENDIF
         WRITE(LINE(1:16),'(2I8)') NLOOP,ICONT
         CALL VFL(RMEAN*1.E6,LINE(19:26))
         CALL VFL(SIGM1,LINE(29:36))
         CALL VFL(SKEW1,LINE(39:46))
         CALL VFL(RKURT,LINE(49:56))
         CALL STTPUT(LINE,ISTAT)
C
C *** if skewness low enough , stop iteration
         IF (ABS(SKEW1).LE.INPUTR(3)) THEN
            CALL STSEPI
         ENDIF
C
C *** also if no significant change occurred
         IF (NLOOP.NE.1) THEN
            AINCR  = FLOAT(ICONTP-ICONT)/ICONTP
            IF (AINCR.LT.CONV) THEN
               CALL STTPUT('*** WARNING: iteration stopped: not '//
     +                     '  enough pixels were rejected',ISTAT)
               GO TO 20
            END IF
         END IF  
         ICONTP = ICONT                         !   save n. of processed points
C
C *** if last iteration , skip mask update
         IF (NLOOP.EQ.INPUTI(2)) GO TO 20
C
C *** if not enough pixels , stop iteration
         IF (ICONT.LT.50) THEN
            CALL STTPUT('*** WARNING: Iteration stopped: '//
     2                  'not enough points ',ISTAT)
             GO TO 20
          END IF
C
C *** now update masking frame and temporary buffer for next iteration
          CALL UPDAT(MADRID(IPNTRB),ATEMP,FLMSK,REJ,NPIXB(1),NPIXB(2),
     +               STARTB(1),STARTB(2),STEPB(1),STEPB(2),NPIXT(1),
     +               NPIXT(2),STARTT(1),STARTT(2),STEPT(1),STEPT(2),
     +               INPUTI(1),RKAPPA,SIGM1,C)
C
   10 CONTINUE                                            !   end main loop
C  
   20 CONTINUE                               !   this is the skip out point
C
C *** read coefficients from keyword (case b)
      IF (CASEB) THEN
         CALL STKRDD('BG_COEF',1,21,C,IAV,KUN,ISTAT)
         CALL STKRDD('BG_COEF',22,7,DSTORE,IAV,KUN,ISTAT)
         NPIXT(1)  = DSTORE(1)
         NPIXT(2)  = DSTORE(2)
         STARTT(1) = DSTORE(3)
         STARTT(2) = DSTORE(4)
         STEPT(1)  = DSTORE(5)
         STEPT(2)  = DSTORE(6)
         INPUTI(1) = DSTORE(7)
      END IF
C
C *** create back.corrected and/or pol. surf. image frame (testing flags)
      IF (.NOT.(FLGSB.OR.FLGSU)) THEN
         CALL STSEPI
      ELSE
         CALL SBTRCT(MADRID(IPNTRA),MADRID(IPNTRC),MADRID(IPNTRD),
     +               NPIXA(1),NPIXA(2),STARTA(1),STARTA(2),STEPA(1),
     +               STEPA(2),NPIXT(1),NPIXT(2),STARTT(1),STARTT(2),
     +               STEPT(1),STEPT(2),C,INPUTI(1),FLGSB,FLGSU)
         CALL STSEPI
      ENDIF
C 
      END


      SUBROUTINE SBTRCT(FRAMEA,FRAMEC,FRAMED,NIX,NIY,DXSTR,DYSTR,               
     +                  DXSTP,DYSTP,NSX,NSY,SXSTR,SYSTR,SXSTP,SYSTP,C,          
     +                  IDEG,FLGSB,FLGSU)                                       
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++:           
C.PURPOSE: Create new image frames with the background subtracted image and/or  
C          the polinomial surface ,testing option flags FLGSB and FLGSU:        
C.INPUT:   FRAMEA : INPUT_A is the input image                                  
C          FLGSB  : flag = .TRUE. if you want backgrond subtraction             
C          FLGSU  : flag = .TRUE. if you want a background surface image        
C.OUTPUT:  FRAMEC : OUTPUT_C is the background subtracted image                 
C          FRAMED : OUTPUT_D is the polinomial surface                          
C   ------------------------------------------------------------------          
      IMPLICIT         NONE
      REAL             FRAMEA(1)                        
      REAL             FRAMEC(1)                        
      REAL             FRAMED(1)                        
      INTEGER          NIX
      INTEGER          NIY
      DOUBLE PRECISION DXSTR
      DOUBLE PRECISION DYSTR
      DOUBLE PRECISION DXSTP
      DOUBLE PRECISION DYSTP
      INTEGER          NSX
      INTEGER          NSY
      DOUBLE PRECISION SXSTR
      DOUBLE PRECISION SYSTR
      DOUBLE PRECISION SXSTP
      DOUBLE PRECISION SYSTP
      DOUBLE PRECISION C(21)                                        
      INTEGER          IDEG
      LOGICAL          FLGSB                                        
      LOGICAL          FLGSU                                              
C
      INTEGER          I, IX, IY, IF
      INTEGER          J
      REAL             DCX, DCY
      REAL             POLIN
      REAL             Y1, YSRV
      REAL             X1, XSRV
      DOUBLE PRECISION CC(6)
      DOUBLE PRECISION XD,YD                                        
C                                                                               
C *** initialize variables                                                      
C                                                                               
      DCX    = (NSX-1.)/2.                                                      
      DCY    = (NSY-1.)/2.                                                      
C                                                                               
C *** fill image(S)                                                             
C                                                                               
      IF     = 1                                                                
      DO 20 J = 1,NIY                                                           
         IY     = J - 1                                                         
         Y1     = DYSTR + DYSTP*FLOAT(IY)                                       
C                                                                               
C *** find pixel coord. in temporary array used by fitting routine              
C                                                                               
         YSRV   = (Y1-SYSTR)/SYSTP                                              
         YD     = DCY - YSRV                                                    
C                                                                               
C *** initialize calculation of coefficients                                    
C                                                                               
         CALL COEFY(YD,C,CC,IDEG)                                               
C                                                                               
         DO 10 I = IF,IF + NIX - 1                                              
            IX     = I - IF                                                     
            X1     = DXSTR + DXSTP*FLOAT(IX)                                    
            XSRV   = (X1-SXSTR)/SXSTP                                           
            XD     = XSRV - DCX                                                 
            IF (FLGSB) THEN                                                     
               FRAMEC(I) = FRAMEA(I) - POLIN(XD,CC,IDEG)                        
               IF (FLGSU) THEN
                  FRAMED(I) = POLIN(XD,CC,IDEG)                         
               ENDIF
            ELSE                                                                
               IF (FLGSU) THEN
                  FRAMED(I) = POLIN(XD,CC,IDEG)                         
               ENDIF
            END IF                                                              
   10    CONTINUE                                                               
C                                                                               
         IF     = IF + NIX                                                      
   20 CONTINUE                                                                  
C                                                                               
      RETURN                                                                    
      END                                                                       

C @(#)cattab.for	19.1 (ES0-DMD) 02/25/03 13:29:42
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE CATINI(CATNAM,TID)
C++++
C.PURPOSE: Initialize the catalogue table
C.AUTHOR : Rein H. Warmels
C.VERSION: 200289  Creation
C----
      IMPLICIT     NONE
      CHARACTER*60 CATNAM
      INTEGER      TID
      INTEGER      NWCAT
      INTEGER      NCCAT
      INTEGER      NRCAT
      PARAMETER   (NWCAT=15)
      PARAMETER   (NCCAT=14)
      PARAMETER   (NRCAT=10000)
C
      INTEGER      I
      INTEGER      ISTAT
C
      CHARACTER*80 STRING
      CHARACTER*16 CATFOR(NCCAT)
      CHARACTER*16 CATUNI(NCCAT)
      CHARACTER*16 CATLAB(NCCAT)
      INTEGER      CATTYP(NCCAT)
      INTEGER      CATCOL(NRCAT)
      INCLUDE      'MID_INCLUDE:ST_DEF.INC'
C
      INCLUDE      'MID_INCLUDE:ST_DAT.INC'
      DATA         CATFOR/'I8',
     1                    'E12.4', 'E12.4', 'E12.4', 'E12.4',
     2                    'E12.4', 'E12.4', 'E12.4', 'E12.4',
     3                    'E12.4', 'E12.4', 'E12.4', 'E12.4',
     4                    'E12.4'/
      DATA         CATUNI/'     ',
     1                    '     ', '     ', '     ', '     ',
     2                    '     ', '     ', '     ', '     ',
     3                    '     ', '     ', '     ', '     ',
     4                    '     '/
      DATA         CATLAB/'GROUP',
     1                    'X    ', 'Y    ', 'INT   ', 'MAG1  ',
     2                    'MAG2 ', 'MAG3 ', 'BG    ', 'FLAG  ',
     3                    'SIGMA', 'BETA ', 'SAT   ', 'HEIGHT',
     4                    'THRESH'/
C
C *** create the catalogue table
      CALL TBTINI(CATNAM, 0, F_O_MODE, NWCAT, NRCAT, TID, ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL: problems with creating the catalogue '//
     2            'table; try again ...'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
 
      CATTYP(1) = D_I4_FORMAT
      CALL TBCINI(TID, CATTYP(1), 1, CATFOR(1), CATUNI(1),
     2                 CATLAB(1), CATCOL(1), ISTAT)
      DO 30 I = 2,NCCAT
         CATTYP(I) = D_R4_FORMAT
         CALL TBCINI(TID, CATTYP(I), 1, CATFOR(I), CATUNI(I),
     2                    CATLAB(I), CATCOL(I), ISTAT)
   30 CONTINUE

      RETURN
      END


      SUBROUTINE CATDRD(IDEN,INTG1,INTG2,INTG3,REAL4,REAL5,INTG6,INTG7,
     2                  INTG8,INTG9,REAL10,REAL11,REAL12,REAL13,
     3                  INTG14,INTG15)
C+++
C     INTG1:  numero oggetti trovati da quasar
C     INTG2:  finestre gia' determinate
C     INTG3:  puntatore dell'ultimo oggetto esaminato
C     REAL3:  raggio massimo tra gli nst raggi
C     REAL4:  raggio medio tra gli nst raggi
C     INTG5:  origine x assoluta (colonne) della window di lavoro di quasar
C     INTG6:  origine y assoluta (righe) della window
C     INTG7:  punti per linea della window
C     INTG8:  linee della window
C     REAL9:  sigma della moffattiana
C     REAL10: beta della moffattiana
C     INTG11: origine x del file
C     INTG12: origine y del file
C---
      IMPLICIT NONE
      INTEGER  IDEN
      INTEGER  INTG1,INTG2,INTG3
      REAL     REAL4,REAL5
      INTEGER  INTG6,INTG7,INTG8,INTG9
      REAL     REAL10,REAL11,REAL12,REAL13
      INTEGER  INTG14,INTG15
C
      INTEGER  IOUT(9)
      REAL     ROUT(6)
      INTEGER  IACT, KUN, KNUL, ISTAT
C
      INCLUDE      'MID_INCLUDE:ST_DEF.INC/NOLIST'
      INCLUDE      'MID_INCLUDE:ST_DAT.INC/NOLIST'
C     
      CALL STDRDR(IDEN,'CATPAR_R',1,6,IACT,ROUT,KUN,KNUL,ISTAT)
      REAL4  = ROUT(1)
      REAL5  = ROUT(2)
      REAL10 = ROUT(3)
      REAL11 = ROUT(4)
      REAL12 = ROUT(5)
      REAL13 = ROUT(6)
C
      CALL STDRDI(IDEN,'CATPAR_I',1,9,IACT,IOUT,KUN,KNUL,ISTAT)
      INTG1  =  IOUT(1)
      INTG2  =  IOUT(2)
      INTG3  =  IOUT(3)
      INTG6  =  IOUT(4)
      INTG7  =  IOUT(5)
      INTG8  =  IOUT(6)
      INTG9  =  IOUT(7)
      INTG14 =  IOUT(8)
      INTG15 =  IOUT(9)
    
      RETURN
      END


      SUBROUTINE CATDWR(IDEN,INTG1,INTG2,INTG3,REAL4,REAL5,INTG6,INTG7,
     2                  INTG8,INTG9,REAL10,REAL11,REAL12,REAL13,
     3                  INTG14,INTG15)
C+++
C     INTG1:  numero oggetti trovati da quasar
C     INTG2:  finestre gia' determinate
C     INTG3:  puntatore dell'ultimo oggetto esaminato
C     REAL3:  raggio massimo tra gli nst raggi
C     REAL4:  raggio medio tra gli nst raggi
C     INTG5:  origine x assoluta (colonne) della window di lavoro di quasar
C     INTG6:  origine y assoluta (righe) della window
C     INTG7:  punti per linea della window
C     INTG8:  linee della window
C     REAL9:  sigma della moffattiana
C     REAL10: beta della moffattiana
C     INTG11: origine x del file
C     INTG12: origine y del file
C---
      IMPLICIT NONE
      INTEGER  IDEN
      INTEGER  INTG1,INTG2,INTG3
      REAL     REAL4,REAL5
      INTEGER  INTG6,INTG7,INTG8,INTG9
      REAL     REAL10,REAL11,REAL12,REAL13
      INTEGER  INTG14,INTG15
C
      INTEGER  IOUT(9)
      REAL     ROUT(6)
      INTEGER  KUN, ISTAT
C
      INCLUDE      'MID_INCLUDE:ST_DEF.INC/NOLIST'
      INCLUDE      'MID_INCLUDE:ST_DAT.INC/NOLIST'
C     
      ROUT(1)  = REAL4
      ROUT(2)  = REAL5
      ROUT(3)  = REAL10
      ROUT(4)  = REAL11
      ROUT(5)  = REAL12
      ROUT(6)  = REAL13
      CALL STDWRR(IDEN,'CATPAR_R',ROUT,1,6,KUN,ISTAT)
C
      IOUT(1)  = INTG1
      IOUT(2)  = INTG2
      IOUT(3)  = INTG3
      IOUT(4)  = INTG6
      IOUT(5)  = INTG7
      IOUT(6)  = INTG8
      IOUT(7)  = INTG9
      IOUT(8)  = INTG14
      IOUT(9)  = INTG15
      CALL STDWRI(IDEN,'CATPAR_I',IOUT,1,9,KUN,ISTAT)
C    
      RETURN
      END


      SUBROUTINE CATTRD(TID,IROW,IDENT,REAL1,REAL2,REAL3,REAL4,
     2                  REAL5,REAL6,REAL7,REAL8,REAL9,REAL10,REAL11,
     3                  REAL12,REAL13)
C+++
C---
      IMPLICIT      NONE
      INTEGER       TID
      INTEGER       IROW
      INTEGER       IDENT
      REAL          REAL1,REAL2,REAL3,REAL4,REAL5,REAL6,REAL7,
     2              REAL8,REAL9,REAL10,REAL11,REAL12,REAL13
C
      INTEGER       REACOL(13)
      INTEGER       IDNCOL(1)
      INTEGER       ISTAT
      REAL          ROUT(13)
      LOGICAL       KUNIDN
      LOGICAL       KUNREA(13)

      DATA          IDNCOL/1/
      DATA          REACOL/2,3,4,5,6,7,8,9,10,11,12,13,14/
C
      CALL TBRRDI(TID,IROW,1,IDNCOL,IDENT,KUNIDN,ISTAT)
      CALL TBRRDR(TID,IROW,13,REACOL,ROUT,KUNREA,ISTAT)
      REAL1    = ROUT(1)
      REAL2    = ROUT(2)
      REAL3    = ROUT(3)
      REAL4    = ROUT(4)
      REAL5    = ROUT(5)
      REAL6    = ROUT(6)
      REAL7    = ROUT(7)
      REAL8    = ROUT(8)
      REAL9    = ROUT(9)
      REAL10   = ROUT(10)
      REAL11   = ROUT(11)
      REAL12   = ROUT(12)
      REAL13   = ROUT(13)

      RETURN
      END


      SUBROUTINE CATTWR(TID,IROW,IDENT,REAL1,REAL2,REAL3,REAL4,
     2                  REAL5,REAL6,REAL7,REAL8,REAL9,REAL10,
     3                  REAL11,REAL12,REAL13)
C+++
C---
      IMPLICIT      NONE
      INTEGER       TID
      INTEGER       IROW
      INTEGER       IDENT
      REAL          REAL1,REAL2,REAL3,REAL4,REAL5,REAL6,REAL7
      REAL          REAL8,REAL9,REAL10,REAL11,REAL12,REAL13
C
      INTEGER       IDNCOL(1)
      INTEGER       REACOL(13)
      INTEGER       ISTAT
      REAL          ROUT(13)
C
      DATA          IDNCOL/1/
      DATA          REACOL/2,3,4,5,6,7,8,9,10,11,12,13,14/
C
      ROUT(1)  = REAL1
      ROUT(2)  = REAL2
      ROUT(3)  = REAL3
      ROUT(4)  = REAL4
      ROUT(5)  = REAL5
      ROUT(6)  = REAL6
      ROUT(7)  = REAL7
      ROUT(8)  = REAL8
      ROUT(9)  = REAL9
      ROUT(10) = REAL10
      ROUT(11) = REAL11
      ROUT(12) = REAL12
      ROUT(13) = REAL13
      CALL TBRWRI(TID,IROW,1,IDNCOL,IDENT,ISTAT)
      CALL TBRWRR(TID,IROW,13,REACOL,ROUT,ISTAT)

      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2005 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C     This FORTRAN code is in the file named "ftoc_names.for".
C

      PROGRAM EXAMPLE

      CALL CSUB()                    !call a C routine

      END

C @(#)timdft.for	19.1 (ES0-DMD) 02/25/03 13:32:59
C===========================================================================
C Copyright (C) 1996 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C  @(#)timdft.for	5.1 (ESO-IPG) 28/07/96 15:58:35
C
C   Fourier and normalized Scargle power spectrum
C   (see ApJ 338,277 & ApJ 263,835)
C                               alex schwarzenberg-czerny, JULY 1996
c Tested OK 28.07.1996
C
      SUBROUTINE TIMDFT(T,X,N,P,NFREQ,CMS,CPS,CD,SD,
     $   FREQIN,FSTEP,SCARGL)
C
      INCLUDE 'MID_REL_INCL:TSA_DEF.INC'
      LOGICAL SCARGL
      INTEGER N,NFREQ
      DOUBLE PRECISION  T(N),X(N),CMS(N),CPS(N),CD(N),SD(N),
     $   P(NFREQ,2),FREQIN,FSTEP
C
      LOGICAL NEXT
      INTEGER I,IF
      DOUBLE PRECISION PI2,START,STEP,EN,ANORM,
     $   C,S,XC,XS,A,B,E,F,TERM,EPS
      PARAMETER (EPS=1D-8)
      INCLUDE 'MID_REL_INCL:TSA_CONST.INC'
C  Set up trig functions recurrence
      PI2=   ABS(ATAN2(ZERO,-ONE))*TWO
      START= FREQIN*PI2
      STEP=  FSTEP*PI2
      EN=    N
      XC=    ZERO
      XS=    ZERO
C
      DO 1 I=1,N
        TERM=  T(I)*START
        C=     COS(TERM)
        S=     SIN(TERM)
        CMS(I)=C-S
        CPS(I)=C+S
        TERM=  T(I)*STEP
        S=     SIN(TERM*HALF)
        CD(I)=-TWO*S*S
        SD(I)= SIN(TERM)
        TERM=X(I)
        XC=    TERM+XC
        XS=    TERM*TERM+XS
 1    CONTINUE
C  Normalization
      XC= XC/EN
      XS= (XS-EN*XC*XC)/(EN-ONE)
      IF (SCARGL) THEN
        ANORM= HALF*HALF/XS/EN
      ELSE
        ANORM= HALF/EN/EN
        TERM=  ONE
      ENDIF
C  Compute periodogramme
      DO 2 IF=1,NFREQ
        NEXT=.TRUE.
 4      XC=ZERO
        XS=ZERO
        C= ZERO
        S= ZERO
        DO 3 I=1,N
          A=CMS(I)
          B=CPS(I)
          IF (NEXT) THEN
C Next frequency or ...
            CMS(I)=A*CD(I)-B*SD(I)+A
            CPS(I)=B*CD(I)+A*SD(I)+B
          ELSE
C ... recompute the spectrum at the frequency near the singularity
            E=0.9999*STEP*T(I)
            F=SIN(E)
            E=SIN(E*HALF)
            E=-TWO*E*E
            TERM=A*E+B*F+A
            B=B*E-A*F+B
            A=TERM
          ENDIF
          XC=X(I)*A+XC
          XS=X(I)*B+XS
          C=A*B+C
          S=B*B-ONE+S
 3      CONTINUE          
C  Lomb-Scargle statistics
        IF (SCARGL) THEN
          TERM=SQRT(C*C+S*S)
          C=C/TERM
          S=S/TERM
          E=SQRT((ABS(C)+ONE)*HALF)
          IF (C.GE.ZERO) THEN
            S=S/E*HALF
            C=E
          ELSE
            C=S/E*HALF
            S=E
          ENDIF
          TERM=ONE-TERM/EN
C
          IF (NEXT.AND.TERM.LT.EPS) THEN
            NEXT=.FALSE.
            GOTO 4
          ENDIF
          A=XS+XC
          B=XS-XC
          XC=A*C+B*S
          XS=B*C-A*S
        ENDIF
        P(IF,1)=(XS*XS/TERM+XC*XC/(TWO-TERM))*ANORM
 2    CONTINUE
C  Spectral window
      IF (.NOT.SCARGL) THEN
        DO 11 I=1,N
          CMS(I)=ONE
          CPS(I)=ZERO
 11     CONTINUE
        DO 12 IF=1,NFREQ
          C=ZERO
          S=ZERO
          DO 13 I=1,N
            A=      CMS(I)
            B=      CPS(I)
            CMS(I)= A*CD(I)-B*SD(I)+A
            CPS(I)= B*CD(I)+A*SD(I)+B
            C=      A+C
            S=      B+S
 13       CONTINUE          
          P(IF,2)=  (C*C+S*S)/EN
 12     CONTINUE
      ENDIF
      END
c

C @(#)fppmtr.for	19.1 (ES0-DMD) 02/25/03 13:25:33
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine FPPMTR         version 1.2      830908
C  A. Kruszewski             ESO Garching
C  modified                  version 1.3      870303
C  A. Kruszewski             Obs. de Geneve
C.KEYWORDS
C  classifiers, positions, elongation, position angle
C.PURPOSE
C  provides parameters which can be calculated only with help
C  of full eight octant profile
C.ALGORITHM
C  corrections to the position "DX" and "DY" expressed in pixels
C  are calculated with help of Fourier expansion
C.INPUT/OUTPUT
C  input arguments
C  PRFL        real*4 array      two-dimensional profile
C  ICNT        integer*4 array   numbers of pixels used to calculate PRFL
C  AVPR        real*4 array      one-dimensional profile
C  IAVR        integer*4 array   numbers of used pixels
C  LHED        integer           halfedge of local subarray
C  LIM         integer*4         radial extent of profiles
C  KCLN        integer*4         radial extend of clean profile
C  KSAT        integer*4         extend of saturated part of profile
C  ID          integer*4         identification number of object
C  L0          integer*4         offset to catalog buffers
C  TRSH        real*4            limiting detection treshold
C  IVRF        integer*4         verification flag
C  M0          integer*4         number of objects
C  ITT         integer*4         total number of passes
C  NPAS        integer*4         actual pass number
C  PMTR        real*4            array holding classifiers
C  NP          integer*4         size of catalog buffers
C  TWODIM      logical           not used
C  output parameters
C  PMTR        real*4 array      array holding classifiers
C-----------------------------------------------------------------------
      SUBROUTINE FPPMTR(PRFL, ICNT, AVPR, IAVR, LHED,
     &                  LIM, KCLN, KSAT, ID, L0,
     &                  TRSH, IVRF, M0, ITT, NPAS,
     &                  NCAT, PMTR)
C
      IMPLICIT  NONE
      INCLUDE  'MID_REL_INCL:INVENT.INC/NOLIST'
C
      REAL     PRFL(8, 0:MAXSUB)
      INTEGER  ICNT(8, 0:MAXSUB)
      REAL     AVPR( 0:MAXSUB)
      INTEGER  IAVR(0:MAXSUB)
      INTEGER  LHED
      INTEGER  LIM
      INTEGER  KCLN
      INTEGER  KSAT
      INTEGER  ID
      INTEGER  L0
      REAL     TRSH
      INTEGER  IVRF
      INTEGER  M0
      INTEGER  ITT
      INTEGER  NPAS
      INTEGER  NCAT(NIPAR,MAXCNT)
      REAL     PMTR(NRPAR,MAXCNT)
C
      INTEGER  NP
      INTEGER  KFB, KFE
      INTEGER  K
      INTEGER  LZ
      REAL     SUM0, SUM1, SUM2, SUM3, SUM4
      REAL     DPRF
      REAL     AT
      REAL     TEMP
      REAL     AMPL
      REAL     COEF(7, MAXSUB)
      REAL     FAMP(3, MAXSUB)
C     LOGICAL  TWODIM
C
C ***
      NP = MAXCNT
      LZ = ID - L0
C
C *** Isolate part of profile which is neither saturated nor blended.
      KFB = MAX( KSAT+1 , 1 )
      KFE = MAX( KFB , KCLN )
      KFE = MIN( KFE , LIM , LHED-1 )
C
C *** Calculate Fourier coefficients.
      CALL OCTFRR( PRFL , ICNT , AVPR , LIM , COEF , FAMP )
C
C *** Calculate classifiers.
      SUM0 = 0.0
      SUM1 = 0.0
      SUM2 = 0.0
      SUM3 = 0.0
      SUM4 = 0.0
      DPRF = 0.0
      DO 10 K = KFB , KFE
         SUM0 = SUM0 + AVPR(K)
         SUM1 = SUM1 + COEF(1,K)
         SUM2 = SUM2 + COEF(2,K)
         SUM3 = SUM3 + COEF(3,K)
         SUM4 = SUM4 + COEF(4,K)
         DPRF = DPRF + (AVPR(K-1)-AVPR(K+1)) / 2.0
   10 CONTINUE
C
C *** Calculate corrections to the position.
      IF ( NCAT(9,LZ) .EQ. 0 .AND. DPRF .GT. 0.3*TRSH .AND.
     &               ( .NOT. ( ( IVRF .EQ. 0 .AND. ID .LE. M0 )
     &               .OR. ( ITT .GT. 1 .AND. NPAS .EQ. 1 ) ) ) ) THEN
          TEMP = SUM1 / DPRF
          AT = ABS( TEMP )
          IF ( AT .GT. 1.0 ) THEN
              TEMP = TEMP / AT
          ENDIF
          PMTR(10,LZ) = FLOAT( NINT( PMTR(10,LZ) ) ) + TEMP
          TEMP = SUM2 / DPRF
          AT = ABS( TEMP )
          IF ( AT .GT. 1.0 ) THEN
              TEMP = TEMP / AT
          ENDIF
          PMTR(11,LZ) = FLOAT( NINT( PMTR(11,LZ) ) ) + TEMP
      ENDIF
C
C *** Calculate image elongation and position angle.
      IF ( SUM0 .GT. 0.01*TRSH ) THEN
          AMPL = SQRT( SUM3*SUM3 + SUM4*SUM4 )
          PMTR(8,LZ) = AMPL / SUM0
          IF ( AMPL .GT. 0.01*TRSH ) THEN
              PMTR(9,LZ) = 90.0 * ATAN2( SUM4 , SUM3 )/ 3.14159265
          ELSE
              PMTR(9,LZ) = 90.0
          ENDIF
      ELSE
          PMTR(8,LZ) = 0.0
          PMTR(9,LZ) = 90.0
      ENDIF
C
C *** Convert position angle into astronomical convention.
      PMTR(9,LZ) = 90.0 - PMTR(9,LZ)
      IF ( PMTR(9,LZ) .LT. 0.0 ) THEN
          PMTR(9,LZ) = PMTR(9,LZ) + 180.0
      ENDIF
C
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2006 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE EXPCLE(INSTRG,OUTSTR,MAXSIZ,COUNT,ATOM,LATOM)
C
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C 
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: K.Banse
C
C.IDENTIFICATION
C  subroutine EXPCLE  			version 3.00 	881209
C  K. Banse   				ESO - Garching
C
C.KEYWORDS
C  parsing, arithmetic + logical expression
C
C.PURPOSE
C   replace all constants by 'C', all frame names by 'F',all 
C  1-arg functions by 'P' and all 2-arg functions by 'Q',
C  finally truncate all operators to one character.
C
C.ALGORITHM
C  use routine EXPATM to extract the objects listed above
C  and test for number via GENNUM, for function via LGFUNC
C  everything else is considered a frame name (unless it's a delimiter)
C  only the following operators are converted:
C  ** -> `, .OR. -> |, .AND. -> ~, .NOT. -> -1 .XOR. -> !
C
C.INPUT/OUTPUT
C  call as EXPCLE(INSTRG,OUTSTR,MAXSIZ,COUNT,ATOM,LATOM)
C
C  input par:
C  INSTRG:	char.exp. 	input string
C  MAXSIZ:	I*4		max. length of each ATOM
C
C  output par:
C  OUTSTR: 	char.exp. 	"cleaned" output string
C  COUNT: 	I*4  		no. of operands in expression
C    				should be > 0,
C    				if = -1, wrong syntax !!
C    				if = -2, overflow for ATOM
C  ATOM: 	char. array 	holds extracted operands in original form
C  LATOM: 	I*4 array 	holds length of each ATOM
C
C.VERSION
C  060623	last modif
C 
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      IMPLICIT NONE
C 
      CHARACTER*(*) INSTRG,OUTSTR,ATOM(23)
      CHARACTER MYSTRG*324,DELIM*1,WC*1
C 
      INTEGER MAXSIZ,LATOM(*)
      INTEGER COUNT,OO,II,LL,N,MINFLG
      INTEGER LOGFNC,GENNUM,LGFUNC
C
C  initialize
      II = 1
      N = 1
      LL = LEN(INSTRG)
      IF (LL.GT.320) THEN                      !max. size currently 320
         COUNT = -2
         RETURN
      ENDIF
C 
10    IF (N.GT.LL) GOTO 30   
C 
      IF (INSTRG(N:N).EQ.' ') THEN
         N = N + 1                                    !move on to next char.
         IF ((N.GT.LL) .OR. (INSTRG(N:N).EQ.' '))
     +      GOTO 30                                   !that's the end ...
      ELSE IF (INSTRG(N:N+1).EQ.'**') THEN
         MYSTRG(II:II) = '`'
         II = II + 1
         N = N + 2
      ELSE IF (INSTRG(N:N+1).EQ.'+-') THEN
         MYSTRG(II:II) = '-'
         II = II + 1
         N = N + 2
      ELSE IF (INSTRG(N:N+1).EQ.'-+') THEN
         MYSTRG(II:II) = '-'
         II = II + 1
         N = N + 2
      ELSE IF (INSTRG(N:N+1).EQ.'--') THEN
         MYSTRG(II:II) = '+'
         II = II + 1
         N = N + 2
      ELSE IF (INSTRG(N:N).EQ.'.') THEN
         IF (INSTRG(N:N+3).EQ.'.OR.') THEN
            MYSTRG(II:II) = '|'
            II = II + 1
            N = N + 4
         ELSE IF (INSTRG(N:N+4).EQ.'.AND.') THEN
            MYSTRG(II:II) = '~'
            II = II + 1
            N = N + 5
         ELSE IF (INSTRG(N:N+4).EQ.'.XOR.') THEN
            MYSTRG(II:II) = '!'
            II = II + 1
            N = N + 5
         ELSE IF (INSTRG(N:N+4).EQ.'.NOT.') THEN
            MYSTRG(II:II+2) = '-1!'
            II = II + 3
            N = N + 5
         ELSE
            MYSTRG(II:II) = INSTRG(N:N)
            II = II + 1
            N = N + 1
         ENDIF
C 
      ELSE
         MYSTRG(II:II) = INSTRG(N:N)
         II = II + 1
         N = N + 1
      ENDIF
C 
      GOTO 10
C
C  we reached the end of the input string
30    LL = II
      MYSTRG(LL:LL) = ' '                    !mark the end by a 'blank'
      II = 1
      OO = 1  
      MINFLG = 0
      COUNT = 1
C
C  extract atoms from left to right  
99    IF (II.GT.LL) THEN
         IF (MINFLG.EQ.1) THEN             !append closing parenthesis
            OUTSTR(OO:OO) = ')'
            OO = OO + 1
         ENDIF  
         GOTO 1000
      ENDIF
C 
      CALL EXPATM(MYSTRG(II:),DELIM,ATOM(COUNT),LATOM(COUNT))
      IF (LATOM(COUNT).LT.0) THEN
         GOTO 9900
C
C  in second pass the delimiter only is returned  
      ELSE IF (LATOM(COUNT).EQ.0) THEN
         IF (DELIM.EQ.' ') THEN
            IF (MINFLG.EQ.1) THEN  
               OUTSTR(OO:OO) = ')'
               OO = OO + 1
            ENDIF  
            GOTO 1000                                     !go + finish
         ENDIF
C
         IF (DELIM.EQ.'-') THEN
            IF (OO.EQ.1) THEN
               ATOM(COUNT) = '0 '
               LATOM(COUNT) = 1
               COUNT = COUNT + 1
               OUTSTR(OO:) = 'C'
               OO = OO + 1
C
            ELSE 
               WC = OUTSTR(OO-1:OO-1)
               IF ((WC.EQ.'(') .OR. (WC.EQ.',')) THEN     !look for (- or ,-
                  ATOM(COUNT) = '0 '
                  LATOM(COUNT) = 1
                  COUNT  = COUNT + 1
                  OUTSTR(OO:) = 'C'
                  OO = OO + 1
C
               ELSE IF ((WC.EQ.'*') .OR. (WC.EQ.'/')) THEN
                  OUTSTR(OO:OO) = '('
                  ATOM(COUNT) = '0 '
                  LATOM(COUNT) = 1
                  COUNT = COUNT + 1
                  OUTSTR(OO+1:OO+1) = 'C'
C                                 set minus flag, since ) still to be added
                  OO = OO + 2
                  MINFLG = 1
               ENDIF
            ENDIF
C
         ELSE IF (DELIM.EQ.'+') THEN
            IF ( (OO.EQ.1) .OR.
     +           ( (OO.GT.1) .AND. (OUTSTR(OO-1:OO-1).EQ.'(') ) ) THEN
               II = II + 1
               GOTO 99
            ENDIF
         ENDIF
C
         OUTSTR(OO:OO) = DELIM
         OO = OO + 1
         II = II + 1
C
      ELSE IF (LATOM(COUNT).GT.MAXSIZ) THEN               !check for overflow
         GOTO 9910 
C
C  in first pass the atom + delimiter is returned
      ELSE
         IF (GENNUM(ATOM(COUNT)).EQ.1) THEN               !it's a number
             OUTSTR(OO:OO) = 'C'
         ELSE
            IF (DELIM.NE.'(') THEN                        !it's a frame
               OUTSTR(OO:OO) = 'F'
            ELSE
               LOGFNC = LGFUNC(ATOM(COUNT))
               IF (LOGFNC.EQ.0) THEN
                  GOTO 9900
               ELSE
                  IF (LOGFNC.EQ.1) THEN                !it's 1-arg function
                     OUTSTR(OO:OO) = 'P'
                  ELSE                                 !it's 2-arg function
                     OUTSTR(OO:OO) = 'Q'
                  ENDIF
                  CALL UPCAS(ATOM(COUNT),ATOM(COUNT))
               ENDIF
            ENDIF
         ENDIF
C
         OO = OO + 1
         II = II + LATOM(COUNT) 
         COUNT = COUNT + 1
C
         IF (MINFLG.EQ.1) THEN  
            MINFLG = 0  
            OUTSTR(OO:OO) = ')'
            OO = OO + 1
         ENDIF
      ENDIF
      GOTO 99                                  !pull out next atom
C
C  finished
1000  OUTSTR(OO:) = ' '
      COUNT = COUNT - 1
C
C  now we only have to check, that parentheses match
      IF (COUNT.GT.0) THEN
         LL = 0
         DO 1060 N = 1,OO
            IF (OUTSTR(N:N).EQ.'(') THEN
               LL = LL + 1
            ELSE IF (OUTSTR(N:N).EQ.')') THEN
               LL = LL - 1
            ENDIF
1060     CONTINUE 
         IF (LL.NE.0) GOTO 9900
      ENDIF
      RETURN
C 
9900  COUNT = -1                       !invalid syntax...
      RETURN
C 
9910  COUNT = -2                       !buffer overflow...
      RETURN
      END


      SUBROUTINE EXPATM(INPUT,DELIM,ATOM,LATOM)
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine EXPATM  		version 2.50	880126
C  K. Banse   			ESO - Garching
C  					2.60	890922
C
C.KEYWORDS
C  parsing, atoms of an arithmetic expression
C
C.PURPOSE
C  extract atoms and their delimiters from an arithmetic expression
C
C.ALGORITHM
C  straight forward
C
C.INPUT/OUTPUT
C  call as EXPATM(INPUT,DELIM,ATOM,LATOM)
C
C  input par:
C  INPUT: 	char.exp. 	input string
C
C  output par:
C  DELIM: 	char.exp. 	delimiter of returned atom
C  NOBL: 	I*4  		no. of blanks in front of atom
C  ATOM: 	char.exp	extracted operand
C  LATOM: 	I*4		length of ATOM
C
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      IMPLICIT NONE
C 
      CHARACTER*(*) INPUT,ATOM
      CHARACTER*1 DELIM,SNGC,LIMITS(10)

      INTEGER LATOM
      INTEGER NLIM,N,KK,II
C
      DATA NLIM/10/
      DATA 
     +   LIMITS /' ','*','/','(',')','!','|','~','`',','/
C
      LATOM = 0
      ATOM = ' '
      II = 0
C 
100   II = II + 1
      DELIM = INPUT(II:II)
C 
      IF (DELIM.EQ.'"') THEN                    !if "abc...
         KK = INDEX(INPUT(II+1:),'"')           !move already to "abc... "
         IF (KK.LE.1) GOTO 999
         LATOM = KK + 1
         II = LATOM
         GOTO 100
C 
      ELSE IF (DELIM.EQ.'[') THEN               !if abc[ 
         II = INDEX(INPUT,']')                  !move already to abc[...]
         IF (II.LE.1) GOTO 999
         LATOM = II
         GOTO 100
      ENDIF         
C 
C  first look for ddd.Eeee numbers
      IF ( (DELIM.EQ.'+') .OR. (DELIM.EQ.'-') ) THEN
         IF (LATOM.GT.1) THEN
            SNGC = INPUT(LATOM:LATOM)
            IF ( (SNGC.EQ.'E') .OR. (SNGC.EQ.'e') .OR.
     +           (SNGC.EQ.'D') .OR. (SNGC.EQ.'d') ) THEN
               DO 110,KK=1,LATOM-1
                  SNGC = INPUT(KK:KK)
                  IF ( (SNGC.NE.'.') .AND.
     +                 ((SNGC.LT.'0').OR.(SNGC.GT.'9')) ) GOTO 200
110            CONTINUE
C 
               LATOM = LATOM + 1
               GOTO 100
            ENDIF
         ENDIF
C 
200      IF (LATOM.GT.0) ATOM = INPUT(1:LATOM)//' '
         RETURN
      ENDIF
C 
      DO 300,N=1,NLIM 
         IF (DELIM.EQ.LIMITS(N)) THEN
            IF (LATOM.GT.0) ATOM = INPUT(1:LATOM)//' '
            RETURN
         ENDIF
300   CONTINUE
C
C  no delimiter - loop more
      LATOM = LATOM + 1
      GOTO 100
C
999   LATOM = -1			!problems...
      RETURN
C 
      END


      SUBROUTINE EXPPOL(INSTRG,OUTSTR,STATUS)
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine EXPPOL 		version 2.21 	821103
C  K. Banse   			ESO - Garching
C
C.KEYWORDS
C  polish reverse notation
C
C.PURPOSE
C   convert an expression in "normal" algebraic notation to polish
C   reversed notat
C
C.ALGORITHM
C  use a stack to store temporary data
C  functions as P(A+B) will be converted to PAB+) to indicate 
C  range of function
C
C.INPUT/OUTPUT
C  call as EXPPOL(INSTRG,OUTSTR,STATUS)
C
C  input par:
C  INSTRG: 	char.exp. 	input string
C
C  output par:
C  OUTSTR: 	char.exp. 	output string in polish reversed notation
C  STATUS: 	I*4  		return status
C    				= 0, o.k., else trouble...
C
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      IMPLICIT NONE
C 
      CHARACTER*(*) INSTRG,OUTSTR
      CHARACTER*1 NCHAR,STOP
C 
      INTEGER STATUS
      INTEGER FLAG,INEXT,ONEXT,SRVAL,STAPR,INPR
      INTEGER STVAL,TYPE,LL
C 
      SAVE
C
      LL = INDEX(INSTRG,' ') - 1
      STATUS = 0
C
C  init stack
      CALL EXPSTA
C
C  extract operators and operands from left to right
      INEXT  = 1
      ONEXT  = 1
C                                          end of string reached
10    IF (INEXT.GT.LL) GOTO 70
      NCHAR = INSTRG(INEXT:INEXT)
C                                          classify token
      CALL EXPCLA(NCHAR,TYPE,INPR,STAPR)
      INEXT = INEXT + 1
      GOTO (20,30,60),TYPE
C
C  number/variable
20    OUTSTR(ONEXT:ONEXT) = NCHAR
      ONEXT = ONEXT + 1
      GOTO 10
C
C  operator
C
C  if NCHAR = closing parenthese, unwind stack
C 
30    IF (NCHAR.EQ.')') THEN  
C                                                     pop from stack
40       CALL EXPPOP(STVAL,STOP,FLAG)  
         IF (FLAG.EQ.-1) GOTO 80  
         IF (STOP.EQ.'(') GOTO 10
         IF (STOP.EQ.'[') THEN
C                                               write ')' for end-of-function
            OUTSTR(ONEXT:ONEXT) = NCHAR
            ONEXT  = ONEXT + 1
            GOTO 10
C                                      store stack operator in output string
         ELSE  
            OUTSTR(ONEXT:ONEXT) = STOP
            ONEXT  = ONEXT + 1
            GOTO 40
         ENDIF
      ENDIF
C
C  if NCHAR = closing comma, unwind stack till '['
      IF (NCHAR.EQ.',') THEN
50       CALL EXPPEP(STVAL,STOP,FLAG)              !look at stack
         IF (FLAG.EQ.-1) GOTO 80
         IF (STOP.EQ.'[') THEN  
            GOTO 10
         ELSE                                      !pop stack
            CALL EXPPOP(SRVAL,STOP,FLAG)  
            OUTSTR(ONEXT:ONEXT) = STOP
            ONEXT  = ONEXT + 1
            GOTO 50
         ENDIF
      ENDIF
C
C  all other characters here...            look what's on top of the stack
C 
      CALL EXPPEP(STVAL,STOP,FLAG)  
      IF (FLAG.EQ.-1) THEN
C                                          push on stack always
          CALL EXPPSH(STAPR,NCHAR,FLAG)
          GOTO 10
      ENDIF
C 
C  if input precedence > stack value, push stack precedence on stack
      IF (INPR.GT.STVAL) THEN
         CALL EXPPSH(STAPR,NCHAR,FLAG)
         GOTO 10
      ELSE
         CALL EXPPOP(STVAL,STOP,FLAG)
         OUTSTR(ONEXT:ONEXT) = STOP
         ONEXT  = ONEXT + 1
         GOTO 30
      ENDIF
C
C  function
60    OUTSTR(ONEXT:ONEXT) = NCHAR
      ONEXT  = ONEXT + 1
C                                push symbol '[' on stack to mark function start
      CALL EXPPSH(0,'[',FLAG)
C                                and skip following '(' ...
      INEXT  = INEXT + 1
      GOTO 10
C
C  end of input string reached
C 
70    CALL EXPPOP(STVAL,STOP,FLAG)
C                                          stack empty - we're done
      IF (FLAG.EQ.-1) THEN
         OUTSTR(ONEXT:) = ' '
         RETURN
      ENDIF
C 
      OUTSTR(ONEXT:ONEXT) = STOP
      ONEXT  = ONEXT + 1  
      GOTO 70
C
C  problems, problems,...
80    STATUS = 1
      RETURN
      END

      SUBROUTINE EXPRDC(INPUT,OUTPUT,OPERA,P)
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine EXPRDC
C.AUTHOR
C  K. Banse   ESO - Garching
C
C.KEYWORDS
C  polish notation, arithmetic expression
C
C.PURPOSE
C  extract from a given polish expression the next binary subexpression
C  and reduce the expression accordingly (replace subexpression
C  by result)
C
C.ALGORITHM
C  look for instances of 'X X op' or 'P X )' or 'Q X X )'
C  where X either F or C
C
C.INPUT/OUTPUT
C  call as EXPRDC(INPUT,OUTPUT,OPERA,P)
C
C  input par:
C  INPUT: 	char.exp. 	input string
C
C  output par:
C  OUTPUT: 	char.exp. 	"reduced" output string
C  OPERA: 	char.exp. 	subexpression to execute next
C  P:  		I*4  		starting index of subexpression in input string
C				= -1, if something wrong
C
C.VERSION
C 2.32		830502		original
C 2.50		930211		return error code
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      IMPLICIT NONE
C 
      CHARACTER*(*) INPUT,OUTPUT,OPERA
      CHARACTER TASK*4
C 
      INTEGER P,LL
C
C  start here looking at the string 
      LL = INDEX(INPUT,' ') - 1
      IF (LL.LE.0) LL = LEN(INPUT)
      OUTPUT = ' '
      P = 1
C
20    TASK = INPUT(P:)
C
C  look for 1-arg functions: P X )
      IF (TASK(1:1).EQ.'P') THEN
         IF (TASK(3:3).NE.')') GOTO 40
         IF ((TASK(2:2).NE.'C') .AND. (TASK(2:2).NE.'F')) GOTO 40
         GOTO 30
      ENDIF
C
C  look for 2-arg functions: Q X X )
      IF (TASK(1:1).EQ.'Q') THEN
         IF (TASK(4:4).NE.')') GOTO 40
         IF ((TASK(2:2).NE.'C') .AND. (TASK(2:2).NE.'F')) GOTO 40
         IF ((TASK(3:3).NE.'C') .AND. (TASK(3:3).NE.'F')) GOTO 40
         GOTO 30
      ENDIF
C
C  look for OPERA: X X op
      IF ((TASK(1:1).NE.'C') .AND. (TASK(1:1).NE.'F')) GOTO 40
      IF ((TASK(2:2).NE.'C') .AND. (TASK(2:2).NE.'F')) GOTO 40
      IF ((TASK(3:3).EQ.'C') .OR. (TASK(3:3).EQ.'F')) GOTO 40
      IF ((TASK(3:3).EQ.'P') .OR. (TASK(3:3).EQ.'Q')) GOTO 40
C
C  valid OPERA found - copy first/last part
30    IF (P.GT.1) OUTPUT(1:P-1) = INPUT(1:)  
      IF (TASK(1:1).NE.'Q') THEN
         OUTPUT(P+1:) = INPUT(P+3:)//' '  
         TASK(4:4)  = ' '
      ELSE
         OUTPUT(P+1:) = INPUT(P+4:)//' '
      ENDIF
C
C  replace the OPERA by result
      IF ((TASK(1:2).EQ.'CC') .OR. (TASK(1:2).EQ.'PC') .OR.
     +   (TASK(1:3).EQ.'QCC')) THEN
         OUTPUT(P:P) = 'C'
      ELSE
         OUTPUT(P:P) = 'F'
      ENDIF
C
C  copy TASK into OPERA
      OPERA = TASK//' '
      RETURN
C
C  no valid OPERA, move on
40    P = P + 1
      IF (P.GT.LL) THEN
         P = -1                             !indicate problem to caller...
         RETURN
      ELSE
         GOTO 20
      ENDIF
C
      END

      SUBROUTINE EXPSTA
C
      IMPLICIT NONE
C
      INTEGER OVF,PNTR
      INTEGER IA(40)
C 
      CHARACTER*1 CA(40)
C 
      COMMON /STACKI/IA,PNTR,OVF
      COMMON /STACKC/CA
C
C  pointer to top of stack (max. 40 operands on line of 80 characters...)
      PNTR   = 0  
      OVF    = 40
C
      RETURN
      END

      SUBROUTINE EXPPSH(IVAL,CHAR,FLAG)
C
      IMPLICIT NONE
C 
      INTEGER IVAL,FLAG
      INTEGER IA(40),OVF,PNTR
C 
      CHARACTER*1 CHAR
      CHARACTER*1 CA(40)
C
      COMMON /STACKI/IA,PNTR,OVF
      COMMON /STACKC/CA
C
      IF (PNTR.GE.OVF) THEN
         FLAG   = +1
         RETURN
      ENDIF
C
C  stack o.k.
      PNTR = PNTR + 1
      CA(PNTR) = CHAR
      IA(PNTR) = IVAL
      FLAG   = 0
C 
      RETURN
      END

      SUBROUTINE EXPPOP(IVAL,CHAR,FLAG)
C
      IMPLICIT NONE
C 
      INTEGER IVAL,FLAG,OVF,PNTR
      INTEGER IA(40)
C 
      CHARACTER*1 CHAR
      CHARACTER*1 CA(40)
C
      COMMON /STACKI/IA,PNTR,OVF
      COMMON /STACKC/CA
C
      IF (PNTR.LE.0) THEN
         FLAG   = -1
         RETURN
      ENDIF
C
C  stack o.k.
      IVAL   = IA(PNTR)
      CHAR   = CA(PNTR)
      PNTR   = PNTR - 1
      FLAG   = 0
C 
      RETURN
      END

      SUBROUTINE EXPPEP(IVAL,CHAR,FLAG)
C
      IMPLICIT NONE
C 
      INTEGER IVAL,FLAG,OVF,PNTR
      INTEGER IA(40)
C 
      CHARACTER*1 CHAR
      CHARACTER*1 CA(40)
C
      COMMON /STACKI/IA,PNTR,OVF
      COMMON /STACKC/CA
C
      IF (PNTR.LE.0) THEN
         FLAG   = -1
         RETURN
      ENDIF
C
C  stack o.k.
      IVAL   = IA(PNTR)
      CHAR   = CA(PNTR)
      FLAG   = 0
C 
      RETURN
      END

      SUBROUTINE EXPCLA(INPUT,TYPE,IPR,SPR)
C
      IMPLICIT NONE
C
      INTEGER ILIM,IPR,SPR,TYPE
      INTEGER INPR(11),STPR(11),N
C 
      CHARACTER*(*) INPUT
      CHARACTER*1 OPER(11)
C
      DATA  ILIM /11/
      DATA  OPER /'+','-','*','/','(',')','`','|','~','!',','/
C 
      DATA INPR/1,1,2,2,4,0,3,3*1,0/
      DATA STPR/1,1,2,2,0,4,3,3*1,0/
C
      IPR    = 0
      SPR    = 0
C
C  is it a constant or a frame?
      IF ((INPUT.EQ.'C') .OR. (INPUT.EQ.'F')) THEN
         TYPE   = 1
         RETURN
      ENDIF
C
C  is it a function?
      IF ((INPUT.EQ.'P') .OR. (INPUT.EQ.'Q')) THEN
         TYPE   = 3
         RETURN
      ENDIF
C
C  compare input with operators  
      TYPE   = 2
      DO 10, N = 1,ILIM
         IF (INPUT.EQ.OPER(N)) THEN
            IPR    = INPR(N)
            SPR    = STPR(N)
            RETURN
          ENDIF
10    CONTINUE
C
      END

      INTEGER FUNCTION LGFUNC(STRING)
C
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C 
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: K.Banse
C
C.IDENTIFICATION
C  integer function LGFUNC
C  K. Banse   				ESO - Garching
C  4.00       900702
C
C.KEYWORDS
C  logical expression
C
C.PURPOSE
C  test, if input represents a FORTRAN function
C
C.ALGORITHM
C  compare string with internal function table
C
C.INPUT/OUTPUT
C  use as LGFUNC(STRING)
C
C  input par:
C  STRING: char.exp.      function string
C
C  return status = 1 if 1-arg function, = 2 if 2-arg function
C                = 0 if no valid function
C
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      IMPLICIT NONE
C 
      INTEGER    N,PLIM,QLIM
C 
      CHARACTER*(*)    STRING
      CHARACTER*5      PFUNCS(14),QFUNCS(4),TEST
C
      DATA    PFUNCS 
     +     /'SQRT ','LN   ','LOG10','EXP  ','EXP10',
     +     'SIN  ','COS  ','TAN  ','ASIN ','ACOS ',
     +     'ATAN ','INT  ','ABS  ','LOG  '/
      DATA    QFUNCS      /'ATAN2','MIN  ','MAX  ','MOD  '/
      DATA    PLIM      /14/, QLIM /4/
C
C  init return to 0
      LGFUNC = 0
      CALL UPCAS(STRING(1:5),TEST)
C
C  compare input string with existing 1-arg functions
      DO 500 N=1,PLIM
         IF (PFUNCS(N).EQ.TEST) THEN
            LGFUNC = 1
            RETURN
         ENDIF
500   CONTINUE
C
C  compare input string with existing 2-arg functions
      DO 600 N=1,QLIM
         IF (QFUNCS(N).EQ.TEST) THEN
            LGFUNC = 2
            RETURN
         ENDIF
600   CONTINUE
C
      RETURN
      END

C @(#)gd8m2.for	19.1 (ES0-DMD) 02/25/03 13:55:09
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
	SUBROUTINE GD8011(DISPLAY,CHAN,NOCHAN,VIS,IDST)
C	
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine IIMSMV		version 1.00	880201
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  DeAnza, memory channel, ITT, LUT
C
C.PURPOSE
C  fulfill the requirements as described in the IDI document 
C
C.ALGORITHM
C  use DeAnza level 0 software
C
C.INPUT/OUTPUT
C  call as  IIMSMV(DISPLAY,CHAN,NOCHAN,VIS,IDST)
C
C  input par:
C  DISPLAY:	I*4		display id.
C  CHAN:	I*4 array	memory ids
C  NOCHAN:	I*4 		no. of memories
C  VIS:		I*4 		visibility: 0 = not visible
C					    1 = visible
C  output par:
C  IDST:	I*4		return status
C
C--------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,CHAN(1),NOCHAN,VIS,IDST
	INTEGER*4	KCHAN,KK,N,SPLITMODE
C	
	INTEGER*2	UNIT,FCLEFT,FCRIGHT,BY
	INTEGER*2	CLEAR,CLAN,SETAN
	INTEGER*2	LMC,RVR,LVR
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
	INCLUDE	'MID_INCLUDE:IDIDEV.INC'
C 
	DATA	CLAN /"175777/, SETAN /"002000/
C	
	EXTERNAL	LMC,LVR,RVR
C	
	UNIT = DISPLAY
	CALL IP8QW(RVR,UNIT,DZIOSB,,,VOCREG(3),2,0,2)
	CLEAR = "160
C	
C  get more info from keyword DAZHOLD
	CALL STKRDI('DAZHOLD',3,1,N,SPLITMODE,N,N,N)
C	
C  if CHAN  = overlay channel, we only handle the GE bit in VOC control register
C	
	DO KK=1,NOCHAN
	   KCHAN = CHAN(KK)
C 
C  if overlay channel, clear + set GE bit (8) of register 2, depending upon VIS
	   IF (KCHAN.EQ.QOVCH) THEN	
	      VOCREG(3) = IAND(VOCREG(3),"177377)
	      IF (VIS.GT.0) VOCREG(3) = IOR(VOCREG(3),"400)
	      CALL IP8QW(LVR,UNIT,DZIOSB,,,VOCREG(3),2,0,2)
	      GOTO 1000
C	
C  if alpha channel, clear + set AE bit (10) of register 2, depending upon VIS
	   ELSE IF (KCHAN.GE.QALPNO) THEN
	      VOCREG(3) = IAND(VOCREG(3),CLAN)
	      IF (VIS.GT.0)
     +	         VOCREG(3) = IOR(VOCREG(3),SETAN)	
	      CALL IP8QW(LVR,UNIT,DZIOSB,,,VOCREG(3),2,0,2)
	      GOTO 1000
	   ENDIF
C	
C  for image channels we only have to work in non-split, non-RGB mode ...
C	
	   IF ( (QRGBFL.NE.1) .AND. (SPLITMODE.EQ.0) ) THEN
	      CALL IP8QW(RVR,UNIT,DZIOSB,,,FCR,16,0,8)	!get current FCRs
C	
C  update FCR for screen segment 3 only (that's the one we see)
	      FCRIGHT = IAND(FCR(4),CLEAR)	!get right byte + keep only LUT section
	      FCRIGHT = IOR(FCRIGHT,KCHAN)	!include channel
	      FCLEFT = ISHFT(FCR(4),-8)	!get left byte of FCR3
	      FCLEFT = IAND(FCLEFT,CLEAR)	!only keep LUT section
	      FCLEFT = IOR(FCLEFT,KCHAN)	!include channel
C	
	      FCR(4) = ISHFT(FCLEFT,8)		!put the pieces back together
	      FCR(4) = IOR(FCR(4),FCRIGHT)
C	
	      FCRIGHT = IAND(FCR(8),CLEAR)	!get right byte + keep only LUT section
	      FCRIGHT = IOR(FCRIGHT,KCHAN)	!include channel
	      FCR(8) = IAND(FCR(8),"177400)	!clear right byte completely
	      FCR(8) = IOR(FCR(8),FCRIGHT)	!and add in new right side
C	
C  send the FCRs back to the DeAnza
	      CALL IP8QW(LVR,UNIT,DZIOSB,,,FCR,16,0,8)
	   ENDIF
1000	ENDDO
C	
	IDST = 0
	RETURN
	END

	SUBROUTINE GD8015(DISPLAY,CHAN,LUT,ITT,IDST)
C	
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine IIMSLT	version 1.00	880202
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  DeAnza, memory channel, ITT, LUT
C
C.PURPOSE
C  fulfill the requirements as described in the IDI document
C
C.ALGORITHM
C  use DeAnza level 0 software
C
C.INPUT/OUTPUT
C  call as  IIMSLT(DISPLAY,CHAN,LUT,ITT,IDST)
C
C  input par:
C  DISPLAY:	I*4		display id.
C  CHAN:	I*4		memory id
C  LUT:		I*4		LUT id - (0,1,2,3)
C  ITT:		I*4 		ITT id - (0,1,2,3)
C	
C  output par:
C  IDST:	I*4		return status
C
C--------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,CHAN,ITT,LUT,IDST
	INTEGER*4	N,FOUND,ONCE
C	
	INTEGER*2	UNIT,ITTSECT(4),FCLEFT,FCRIGHT,LUTSECT
	INTEGER*2	RVR,LVR
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
C	
	EXTERNAL	RVR,LVR
C	
	DATA	ITTSECT	/0,"400,"1000,"1400/
C
C  clear + set ITT section bits (9,8) of memory register 3 of channel CHAN
	IF (ITT.GE.0) THEN
	   N = CHAN + 1
	   MEMREG(4,N) = IAND(MEMREG(4,N),"176377)		
	   MEMREG(4,N) = IOR(MEMREG(4,N),ITTSECT(ITT+1))	
	ENDIF
C	
C  now handle the LUT part
	IF (LUT.LT.0) GOTO 8000
C 
	LUTSECT = ISHFT(LUT,5)
	ONCE = 0
	CALL IP8QW(RVR,UNIT,DZIOSB,,,FCR,16,0,8)		!get FCRs
C	
	DO N=1,8
	   FOUND = 0
	   FCLEFT = ISHFT(FCR(N),-8)		!get left byte
	   FCRIGHT = IAND(FCR(N),"377)		!get right byte
	   IF (IAND(FCLEFT,"17).EQ.CHAN) THEN
	      FOUND = 1
	      FCLEFT = IAND(FCLEFT,"37)		!get rid of old LUT section
	      FCLEFT = IOR(FCLEFT,LUTSECT)	!insert new one
	   ENDIF
	   IF (IAND(FCRIGHT,"17).EQ.CHAN) THEN
	      FOUND = 1
	      FCRIGHT = IAND(FCRIGHT,"37)		!get rid of old LUT section
	      FCRIGHT = IOR(FCRIGHT,LUTSECT)	!insert new one
	   ENDIF
C	
	   IF (FOUND.EQ.1) THEN
	      ONCE = 1				!indicate that we changed at least once
	      FCR(N) = ISHFT(FCLEFT,8)
	      FCR(N) = IOR(FCR(N),FCRIGHT)	!put the pieces back together
	   ENDIF
	ENDDO
C	
C  if something modified, send the FCRs back to the DeAnza
	IF (ONCE.EQ.1) THEN
	   UNIT = DISPLAY
	   CALL IP8QW(LVR,UNIT,DZIOSB,,,FCR,16,0,8)
	ENDIF
C	
8000	IDST = 0
	RETURN
	END

	SUBROUTINE GD8047(DISPLAY,MEMIDS,MEMLIM,DELAY,IDST)
C	
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine IIMBL			version 1.00	880502
C  K. Banse             	     	ESO - Garching
C  1.10     890609	1.20	900327
C
C.KEYWORDS
C  DeAnza, memory channels
C
C.PURPOSE
C  fulfill the requirements as described in the IDI document (Feb. 86)
C
C.ALGORITHM
C  use DeAnza level 0 software
C
C.INPUT/OUTPUT
C  call as IIMBLM(DISPLAY,MEMIDS,MEMLIM,DELAY,IDST)
C 
C  input par:
C  DISPLAY:	I*4		display id.
C  MEMIDS:	I*4 array	memory ids
C  MEMLIM:	I*4		dimension of MEMIDS
C  DELAY:	R*4 array	delay in seconds
C  IDST:	I*4		return status
C	
C.VERSIONS
C  1.00		from old IDI_BLME
C  1.10		DELAY is also an array (see doc ...)
C  1.20		use routine DAZWAI for waiting
C--------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,MEMIDS(1),MEMLIM,IDST
	INTEGER*4	N,CHAN,KDELAY,LENC,OFF,IAV,STAT
C
	REAL*4		DELAY(1)
C	
	CHARACTER	INFO*80
C	
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
C	
C  now loop over memory ids
100	DO N=1,MEMLIM				!MEMLIM should be > 0 ...!
	   CHAN = MEMIDS(N)
	   KDELAY = NINT(DELAY(N) * 1000.)      !convert seconds to milliseconds
	   CALL GD8011(DISPLAY,CHAN,1,1,IDST)	!leave ITT + LUT visibility as it is
	   CALL WALPHB(CHAN,0)				!show alpha info...
C	
C  now wait
	   CALL DAZWAI(KDELAY)
	ENDDO
C	
C  now we do it over and over again...
	GOTO 100
C	
C  we don't get out here, but a CTRL/C is used to turn IIMBLM off ...
1000	RETURN
	END

C @(#)tsaint.for	19.1 (ESO-DMD) 02/25/03 13:33:25
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT (c) 1992 European Southern Observatory & Copernicus Astron. Center
C.IDENT     tsaint.for
C.AUTHOR    Alex Schwarzenberg-Czerny, Copernicus Astron. Center, Warsaw
C.KEYWORD   MIDAS, time analysis, INTERPOL/TIME

C.LANGUAGE  FORTRAN 77
C.PURPOSE   Interpolate an unevensampled series using its covariance function
C           Reference:  ApJ 385, 404
C.RETURNS   None
C.ENVIRON   TSA context
C.VERSION   0.0               June 1992
C 
C 021031	last modif
C 
C-----------------------------------------------------------------------------
C
C
      INCLUDE 'MID_REL_INCL:TSA_DEF.INC'
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      CHARACTER*60     INAME1         !  NAME OF 1ST OBSERVATION TABLE
      CHARACTER*60     INAME2         !  NAME OF 2ND (OUTPUT) TABLE
      CHARACTER*3      CFUNC          !  TYPE OF ACF
      DOUBLE PRECISION PARM(12)       !  PARAMETERS OF ACF
      DOUBLE PRECISION ACFLIN,ACFPOL,ACFPOW,ACFEXP,
     $                 ACFLOG,ACFIPO
      EXTERNAL         ACFLIN,ACFPOL,ACFPOW,ACFEXP,
     $                 ACFLOG,ACFIPO
      DOUBLE PRECISION TSADELUR0,TSADELUR1,TSADELUR2,TSADELUR3,
     $                 TSADELUR4,TSADELUR5,TSADELUR6,TSADELUR7,
     $                 TSADELUR8,TSADELUR9
      EXTERNAL         TSADELUR0,TSADELUR1,TSADELUR2,TSADELUR3,
     $                 TSADELUR4,TSADELUR5,TSADELUR6,TSADELUR7,
     $                 TSADELUR8,TSADELUR9
C
      INTEGER           NOBS1, NOBS2, ISIZE, ASIZE
      INTEGER           MODE,  IACTS, KUN,   KNUL
      INTEGER           TID1,  TID2,  ITIME, IDAT, IVAR
      INTEGER           NCOL,  ICOL,  NROW,  ISOR
      INTEGER           LFIELD,TTYP,  DTYP,  VTYP
      INTEGER           ICOBS, INU,   ICT
C 
      INTEGER*8         POBS1T,POBS1D,POBS1V
      INTEGER*8         POBS2T,POBS2D,POBS2V
      INTEGER*8         PCOBS,PNU,PCT
C 
      DOUBLE PRECISION  AVER,VAR
      CHARACTER*10 FORM
      CHARACTER*80 TEXT
C
      INCLUDE 'MID_REL_INCL:TSA_DAT.INC'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C
C   Get parameters
C
      CALL STSPRO ('tsaint')
      CALL STKRDC ('IN_A',  1,1,60,IACTS,INAME1,KUN,KNUL,ISTAT)
      CALL STKRDC ('OUT_A',  1,1,60,IACTS,INAME2,KUN,KNUL,ISTAT)
      CALL STKRDC ('CFUNC',  1,1, 3,IACTS,CFUNC, KUN,KNUL,ISTAT)
      CALL STKRDD ('INPUTD',   1,12,IACTS,PARM,  KUN,KNUL,ISTAT)
C
C   Map input data
C
      CALL TBTOPN (INAME1,F_I_MODE,TID1,ISTAT)
      CALL TBIGET (TID1,NCOL,NOBS1,ISOR,ICOL,NROW,ISTAT)
      CALL TBLSER (TID1,'TIME' ,ITIME,ISTAT)
      IF (ITIME.LT.0) THEN
        CALL STETER(5,'Column :TIME not found in 1st table')
      ENDIF
      CALL TBLSER (TID1,'VALUE',IDAT ,ISTAT)
      IF (IDAT.LT.0) THEN
        CALL STETER(6,'Column :VALUE not found in 1st table')
      ENDIF
      CALL TBLSER (TID1,'VAR'  ,IVAR, ISTAT)
      IF (IVAR.LT.0) THEN
        CALL STETER(7,'Column :VAR not found in 1st table')
      ENDIF
      CALL TBFGET (TID1,ITIME,FORM,LFIELD,TTYP,ISTAT)
      CALL TBFGET (TID1,IDAT, FORM,LFIELD,DTYP,ISTAT)
      CALL TBFGET (TID1,IVAR, FORM,LFIELD,VTYP,ISTAT)
      CALL TBDGET (TID1,ISTORE,ISTAT)
      IF (ISTORE.NE.F_TRANS) THEN
        TEXT='Input table '//INAME1//' stored not transposed'
        CALL STETER(1,TEXT)
      ENDIF
      IF (TTYP.NE.D_R8_FORMAT.OR.DTYP.NE.D_R8_FORMAT.OR.
     $     VTYP.NE.D_R8_FORMAT) THEN
        CALL STETER(2,
     $    'Column(s) in 1st table must be in DOUBLE PRECISION')
      ENDIF
      CALL TBCMAP (TID1,ITIME,POBS1T,ISTAT)
      CALL TBCMAP (TID1,IDAT, POBS1D,ISTAT)
      CALL TBCMAP (TID1,IVAR, POBS1V,ISTAT)
C
C   Map input/output table
C
      CALL TBTOPN (INAME2,F_IO_MODE,TID2,ISTAT)
      CALL TBIGET (TID2,NCOL,NOBS2,ISOR,ICOL,NROW,ISTAT)
      CALL TBLSER (TID2,'TIME' ,ITIME,ISTAT)
      IF (ITIME.LT.0) THEN
        CALL STETER(8,'Column :TIME not found in 2nd table')
      ENDIF
      CALL TBLSER (TID2,'VALUE',IDAT ,ISTAT)
      IF (IDAT.LT.0) THEN
        CALL STETER(9,'Column :VALUE not found in 2nd table')
      ENDIF
      CALL TBLSER (TID2,'VAR'  ,IVAR, ISTAT)
      IF (IVAR.LT.0) THEN
        CALL STETER(10,'Column :VAR not found in 2nd table')
      ENDIF
      CALL TBFGET (TID2,ITIME,FORM,LFIELD,TTYP,ISTAT)
      CALL TBFGET (TID2,IDAT, FORM,LFIELD,DTYP,ISTAT)
      CALL TBFGET (TID2,IVAR, FORM,LFIELD,VTYP,ISTAT)
      CALL TBDGET (TID2,ISTORE,ISTAT)
      IF (ISTORE.NE.F_TRANS) THEN
        TEXT='Input table '//INAME2//' stored not transposed'
        CALL STETER(3,TEXT)
      ENDIF
      IF (TTYP.NE.D_R8_FORMAT.OR.DTYP.NE.D_R8_FORMAT.OR.
     $     VTYP.NE.D_R8_FORMAT) THEN
        CALL STETER(4,
     $    'Column(s) in 2nd table must be in DOUBLE PRECISION')
      ENDIF
      CALL TBCMAP (TID2,ITIME,POBS2T,ISTAT)
      CALL TBCMAP (TID2,IDAT, POBS2D,ISTAT)
      CALL TBCMAP (TID2,IVAR, POBS2V,ISTAT)
C
C   Create and map work tables  COBS,NU,CT
C
      ISIZE=(NOBS1+1)*(NOBS1+1)
      CALL STFCRE('ZZMIDAWORK',D_R8_FORMAT,F_X_MODE,F_IMA_TYPE,
     $   ISIZE,ICOBS,ISTAT)
      CALL STFMAP(ICOBS,F_X_MODE,1,ISIZE,ASIZE,PCOBS,ISTAT)
      ISIZE=NOBS1+1
      CALL STFCRE('ZZMIDBWORK',D_R8_FORMAT,F_X_MODE,F_IMA_TYPE,
     $   ISIZE,INU,  ISTAT)
      CALL STFMAP(INU,  F_X_MODE,1,ISIZE,ASIZE,PNU,ISTAT)
      ISIZE=NOBS1+1
      CALL STFCRE('ZZMIDCWORK',D_R8_FORMAT,F_X_MODE,F_IMA_TYPE,
     $   ISIZE,ICT,  ISTAT)
      CALL STFMAP(ICT,  F_X_MODE,1,ISIZE,ASIZE,PCT,ISTAT)
C
C   Interpolate using covariance function
C
      MODE=2
      IF (LLE(CFUNC,'LIN').AND.LGE(CFUNC,'LIN')) THEN
        CALL INTERPOL(
     $    MADRID(POBS1T),MADRID(POBS1D),MADRID(POBS1V),
     $    MADRID(POBS2T),MADRID(POBS2D),MADRID(POBS2V),
     $    ACFLIN,PARM,NOBS1,NOBS2,MODE,AVER,VAR,
     $    MADRID(PCOBS),MADRID(PNU),MADRID(PCT))
      ELSEIF (LLE(CFUNC,'POL').AND.LGE(CFUNC,'POL')) THEN
        CALL INTERPOL(
     $    MADRID(POBS1T),MADRID(POBS1D),MADRID(POBS1V),
     $    MADRID(POBS2T),MADRID(POBS2D),MADRID(POBS2V),
     $    ACFPOL,PARM,NOBS1,NOBS2,MODE,AVER,VAR,
     $    MADRID(PCOBS),MADRID(PNU),MADRID(PCT))
      ELSEIF (LLE(CFUNC,'POW').AND.LGE(CFUNC,'POW')) THEN
        CALL INTERPOL(
     $    MADRID(POBS1T),MADRID(POBS1D),MADRID(POBS1V),
     $    MADRID(POBS2T),MADRID(POBS2D),MADRID(POBS2V),
     $    ACFPOW,PARM,NOBS1,NOBS2,MODE,AVER,VAR,
     $    MADRID(PCOBS),MADRID(PNU),MADRID(PCT))
      ELSEIF (LLE(CFUNC,'EXP').AND.LGE(CFUNC,'EXP')) THEN
        CALL INTERPOL(
     $    MADRID(POBS1T),MADRID(POBS1D),MADRID(POBS1V),
     $    MADRID(POBS2T),MADRID(POBS2D),MADRID(POBS2V),
     $    ACFEXP,PARM,NOBS1,NOBS2,MODE,AVER,VAR,
     $    MADRID(PCOBS),MADRID(PNU),MADRID(PCT))
      ELSEIF (LLE(CFUNC,'LOG').AND.LGE(CFUNC,'LOG')) THEN
        CALL INTERPOL(
     $    MADRID(POBS1T),MADRID(POBS1D),MADRID(POBS1V),
     $    MADRID(POBS2T),MADRID(POBS2D),MADRID(POBS2V),
     $    ACFLOG,PARM,NOBS1,NOBS2,MODE,AVER,VAR,
     $    MADRID(PCOBS),MADRID(PNU),MADRID(PCT))
      ELSEIF (LLE(CFUNC,'IPO').AND.LGE(CFUNC,'IPO')) THEN
        CALL INTERPOL(
     $    MADRID(POBS1T),MADRID(POBS1D),MADRID(POBS1V),
     $    MADRID(POBS2T),MADRID(POBS2D),MADRID(POBS2V),
     $    ACFIPO,PARM,NOBS1,NOBS2,MODE,AVER,VAR,
     $    MADRID(PCOBS),MADRID(PNU),MADRID(PCT))
      ELSEIF (LLE(CFUNC,'UR0').AND.LGE(CFUNC,'UR0')) THEN
        CALL INTERPOL(
     $    MADRID(POBS1T),MADRID(POBS1D),MADRID(POBS1V),
     $    MADRID(POBS2T),MADRID(POBS2D),MADRID(POBS2V),
     $    TSADELUR0,PARM,NOBS1,NOBS2,MODE,AVER,VAR,
     $    MADRID(PCOBS),MADRID(PNU),MADRID(PCT))
      ELSEIF (LLE(CFUNC,'UR1').AND.LGE(CFUNC,'UR1')) THEN
        CALL INTERPOL(
     $    MADRID(POBS1T),MADRID(POBS1D),MADRID(POBS1V),
     $    MADRID(POBS2T),MADRID(POBS2D),MADRID(POBS2V),
     $    TSADELUR1,PARM,NOBS1,NOBS2,MODE,AVER,VAR,
     $    MADRID(PCOBS),MADRID(PNU),MADRID(PCT))
      ELSEIF (LLE(CFUNC,'UR2').AND.LGE(CFUNC,'UR2')) THEN
        CALL INTERPOL(
     $    MADRID(POBS1T),MADRID(POBS1D),MADRID(POBS1V),
     $    MADRID(POBS2T),MADRID(POBS2D),MADRID(POBS2V),
     $    TSADELUR2,PARM,NOBS1,NOBS2,MODE,AVER,VAR,
     $    MADRID(PCOBS),MADRID(PNU),MADRID(PCT))
      ELSEIF (LLE(CFUNC,'UR3').AND.LGE(CFUNC,'UR3')) THEN
        CALL INTERPOL(
     $    MADRID(POBS1T),MADRID(POBS1D),MADRID(POBS1V),
     $    MADRID(POBS2T),MADRID(POBS2D),MADRID(POBS2V),
     $    TSADELUR3,PARM,NOBS1,NOBS2,MODE,AVER,VAR,
     $    MADRID(PCOBS),MADRID(PNU),MADRID(PCT))
      ELSEIF (LLE(CFUNC,'UR4').AND.LGE(CFUNC,'UR4')) THEN
        CALL INTERPOL(
     $    MADRID(POBS1T),MADRID(POBS1D),MADRID(POBS1V),
     $    MADRID(POBS2T),MADRID(POBS2D),MADRID(POBS2V),
     $    TSADELUR4,PARM,NOBS1,NOBS2,MODE,AVER,VAR,
     $    MADRID(PCOBS),MADRID(PNU),MADRID(PCT))
      ELSEIF (LLE(CFUNC,'UR5').AND.LGE(CFUNC,'UR5')) THEN
        CALL INTERPOL(
     $    MADRID(POBS1T),MADRID(POBS1D),MADRID(POBS1V),
     $    MADRID(POBS2T),MADRID(POBS2D),MADRID(POBS2V),
     $    TSADELUR5,PARM,NOBS1,NOBS2,MODE,AVER,VAR,
     $    MADRID(PCOBS),MADRID(PNU),MADRID(PCT))
      ELSEIF (LLE(CFUNC,'UR6').AND.LGE(CFUNC,'UR6')) THEN
        CALL INTERPOL(
     $    MADRID(POBS1T),MADRID(POBS1D),MADRID(POBS1V),
     $    MADRID(POBS2T),MADRID(POBS2D),MADRID(POBS2V),
     $    TSADELUR6,PARM,NOBS1,NOBS2,MODE,AVER,VAR,
     $    MADRID(PCOBS),MADRID(PNU),MADRID(PCT))
      ELSEIF (LLE(CFUNC,'UR7').AND.LGE(CFUNC,'UR7')) THEN
        CALL INTERPOL(
     $    MADRID(POBS1T),MADRID(POBS1D),MADRID(POBS1V),
     $    MADRID(POBS2T),MADRID(POBS2D),MADRID(POBS2V),
     $    TSADELUR7,PARM,NOBS1,NOBS2,MODE,AVER,VAR,
     $    MADRID(PCOBS),MADRID(PNU),MADRID(PCT))
      ELSEIF (LLE(CFUNC,'UR8').AND.LGE(CFUNC,'UR8')) THEN
        CALL INTERPOL(
     $    MADRID(POBS1T),MADRID(POBS1D),MADRID(POBS1V),
     $    MADRID(POBS2T),MADRID(POBS2D),MADRID(POBS2V),
     $    TSADELUR8,PARM,NOBS1,NOBS2,MODE,AVER,VAR,
     $    MADRID(PCOBS),MADRID(PNU),MADRID(PCT))
      ELSEIF (LLE(CFUNC,'UR9').AND.LGE(CFUNC,'UR9')) THEN
        CALL INTERPOL(
     $    MADRID(POBS1T),MADRID(POBS1D),MADRID(POBS1V),
     $    MADRID(POBS2T),MADRID(POBS2D),MADRID(POBS2V),
     $    TSADELUR9,PARM,NOBS1,NOBS2,MODE,AVER,VAR,
     $    MADRID(PCOBS),MADRID(PNU),MADRID(PCT))
      ELSE
        CALL STETER(5,'Wrong name for ACF type')
      ENDIF
      NCOL=3
      CALL TBIPUT (TID2,NCOL,NOBS2,ISTAT)
C
C   Wind-up
C
      CALL DSCUPT(TID2,TID2,' ',ISTAT)
      CALL STSEPI
C
      END
C
C
C

C @(#)tdformat.for	19.1 (ES0-DMD) 02/25/03 14:11:17
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  12:01 - 15 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C  900219  KB, throw out SX calls...
C
C
C.IDENTIFICATION        TDFORMAT.FOR
C.KEYWORDS           TABLE, APPLICATIONS
C.ENVIRONMENT  MIDAS
C.PURPOSE
C  READ FORMAT FILE AND BUILD INTERNAL FORMAT CONTROL.
C  THE CONTROL INFORMATION IS DESCRIBED IN TABLES.INC
C
C
C------------------------------------------------------------------
      SUBROUTINE TDFFRM(FILE,STATUS)
      IMPLICIT NONE
      CHARACTER*(*) FILE  ! IN  : format file
      INTEGER STATUS      ! OUT : status
C
      INTEGER I,IST,IDOUBL,NCHAR,NCHAN, II
C
      CHARACTER*80 LINE,FILENA
      CHARACTER*8  FORM,FTYPE
      CHARACTER*1  C
      CHARACTER*16 C1
      CHARACTER*3  NN
       INCLUDE 'MID_INCLUDE:TABLES.INC/NOLIST'
       INCLUDE 'MID_INCLUDE:TABLEF.INC/NOLIST'
       INCLUDE 'MID_INCLUDE:TABLED.INC/NOLIST'
C
      DATA NCHAN/13/
C
      FTYPE  = 'fmt '
      CALL TDNAME(FILE,FTYPE,FILENA)
      OPEN (UNIT=NCHAN,FILE=FILENA,ERR=40,STATUS='OLD')
C
      I      = 0
   10 CONTINUE
      I      = I + 1
   20 READ (NCHAN,9010,ERR=50,END=30) LINE
      IF (LINE(1:3).EQ.'END'.OR.LINE(1:3).EQ.'end') GO TO 30
      IF (LINE(1:1).EQ.'C' .OR. LINE(1:1).EQ.'!'.OR.
     .    LINE(1:1).EQ.'c') GO TO 20
      IF (LINE(1:3).NE.'DEF'.AND.LINE(1:3).EQ.'def') GO TO 20
C          STATUS = ERRFMT
C          RETURN
C      END IF
      CALL TDFDEC(LINE,FMFIRS(I),FMLAST(I),C1,FORM,FMLABE(I),FMUNIT(I),
     +            STATUS)
      IF (STATUS.NE.0) THEN
          STATUS = ERRFMT
          RETURN
      END IF
      C      = C1(1:1)
      IF (INDEX('CRDIcrdi',C).EQ.0) THEN
          STATUS = ERRFMT
          RETURN
      END IF
      IDOUBL = INDEX(C1,'8')
      IF (FORM(1:5).EQ.'     ') THEN
          NCHAR  = FMLAST(I) - FMFIRS(I) + 1
          IST    = 3
          IF (NCHAR.GE.10) IST    = 2
          IF (NCHAR.GE.100) IST    = 1
          WRITE (NN,9000) NCHAR
          IF (C.EQ.'C' .OR. C.EQ.'c') THEN
              FMFORM(I) = '(A'//NN(IST:3)//')'
              FMTYPE(I) = 'C*'//NN(IST:3)
          ELSE
              IF (C.EQ.'I' .OR. C.EQ.'i') THEN
                  FMFORM(I) = '(I'//NN(IST:3)//')'
                  FMTYPE(I) = 'I*4'
              ELSE
                  FMFORM(I) = '(G'//NN(IST:3)//'.1)'
                  IF ((C.EQ.'R'.OR.C.EQ.'r').AND. IDOUBL.EQ.0) THEN
                      FMTYPE(I) = 'R*4'
                  ELSE
                      FMTYPE(I) = 'R*8'
                      C      = 'D'
                  END IF
              END IF
          END IF
      ELSE
          II        = INDEX(FORM,' ') - 1
          FMFORM(I) = '('//FORM(1:II)//')'
          IF (C.EQ.'C'.OR.C.EQ.'c') THEN
              IF (FORM(1:1).NE.'A') THEN
                  STATUS = ERRFMT
                  RETURN
              ELSE
                  FMTYPE(I) = 'C*'//FORM(2:)
              END IF

          ELSE
              IF (C.EQ.'I'.OR.C.EQ.'i') THEN
                  IF (FORM(1:1).NE.'I' .AND. FORM(1:1).NE.'O' .AND.
     +                FORM(1:1).NE.'Z' .AND. FORM(1:1).NE.'i' .AND.
     +                FORM(1:1).NE.'o' .AND. FORM(1:1).NE.'z' ) THEN
                      STATUS = ERRFMT
                      RETURN

                  ELSE
                      FMTYPE(I) = 'I*4'
                  END IF

              ELSE
                  IF (FORM(1:1).NE.'F' .AND. FORM(1:1).NE.'G' .AND.
     +                FORM(1:1).NE.'E' .AND. FORM(1:1).NE.'f' .AND.
     +                FORM(1:1).NE.'g' .AND. FORM(1:1).NE.'e' ) THEN
                      STATUS = ERRFMT
                      RETURN
                  ELSE
                      IF (C.EQ.'R'.OR.C.EQ.'r') THEN
                          FMTYPE(I) = 'R*4'

                      ELSE
                          FMTYPE(I) = 'R*8'
                      END IF

                  END IF

              END IF

          END IF

      END IF

      GO TO 10

   30 FMNCOL = I - 1
      FMLLEN = FMLAST(FMNCOL)
      RETURN
   40 CONTINUE
C   40 CALL STTPUT('Error opening format file',STATUS)
   50 STATUS = ERRFMT
      RETURN

 9000 FORMAT (I3)
 9010 FORMAT (A)
      END

C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION        ISDFES.FOR
C.LANGUAGE:             F77 
C.AUTHOR:               J.D.PONZ  ESA-VILSPA        
C.KEYWORDS              IUE, GO FORMAT, FES IMAGE
C.PURPOSE
C  \begin{TeX}
C  Reads FES data.
C  The routine performs the following functions (routine names in brackets):
C  \begin{enumerate}
C  \item Handles the file header (ISDFHD)
C  \item Creates the MIDAS image file on disk (STFCRE). 
C     The format and size of the file is controlled by the 
C     argument DSKFMT (0 - floating point, 1 - byte).
C  \item  Iteration on the number of lines to:
C        \begin{itemize}
C         \item Read  a line (ISDREC)
C         \item Decode the pixel information
C         \item Write the line into disk (STFPUT).
C       \end{itemize}
C  \item Writes standard image descriptors (STDWRx)
C  \item Writes IUE specific descriptors (ISTDES).
C  \item Closes the file on disk (STFCLO)
C  \end{enumerate}
C \end{TeX}
C.COMMENTS
C \begin{TeX}
C  The following extensions are used :
C  \begin{itemize}
C  \item IMPLICIT NONE
C  \item INCLUDE statement
C  \item Long variable names
C  \item Underscore character
C  \end{itemize}
C \end{TeX}
C.VERSION: 1.0  INITIAL CODING  24 JUN 1994
C------------------------------------------------------------------
      SUBROUTINE ISDFES(CHANL,BUFF,FILE,DSKFMT,DSPFLG,
     .                  NRECO,NBYTE,IOFF,STATUS)
C
      IMPLICIT NONE
      INTEGER       CHANL             ! IN: tape channel number
      CHARACTER*(*) BUFF              ! IN: buffer with the ascii header
      CHARACTER*(*) FILE              ! IN: disk file name
      INTEGER       DSKFMT            ! IN: image format (0:float, 1:Byte)
      INTEGER       DSPFLG            ! IN: display flag
      INTEGER       NRECO             ! IN: number of records
      INTEGER       NBYTE             ! IN: number of bytes
      INTEGER       IOFF
      INTEGER       STATUS            ! OUT: status (0 normal return)
C
      INTEGER   DTYPE, NO, SIZE, FELM, NL, NR, LEN, I, J
      INTEGER   NAXIS(1), NPIX(2), DUM(1)
      INTEGER   IBUFF(768)
      REAL      RBUFF(768)
      REAL      CUTS(4)
      DOUBLE PRECISION START(2), STEP(2)
      CHARACTER*72 IDENT, CUNIT
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
      DATA CUNIT/'FESCNT          PIXEL           PIXEL    '/
C
C     NL     = 113
C     NR     = 113
C     SIZE   = 113*113
      NL     = NBYTE
      NR     = NRECO
      SIZE   = NRECO*NBYTE
      STATUS = 0
C
C ... decode full header, print it and put info in common area
C
      CALL ISDFHD(CHANL,BUFF,DSPFLG,IOFF,STATUS)
      IF (STATUS.NE.0) RETURN
      IF (DSKFMT.LT.0) RETURN     ! only displays header
C
C ... create the frame
C
      IF (DSKFMT.EQ.0) THEN
          DTYPE = D_R4_FORMAT
      ELSE
          DTYPE = D_I1_FORMAT
      ENDIF
      CALL STFCRE(FILE,DTYPE,F_O_MODE,F_IMA_TYPE,SIZE,NO,STATUS)
      IF (STATUS.NE.0) RETURN
C
C ... loop to read tape and write into disk
C
      FELM = 1
      IF (DSKFMT.EQ.0) THEN                        ! write with conversion
        DO 10 I = 1, NL
           CALL ISDRBY(CHANL,IBUFF,NR,LEN,IOFF,STATUS)
           IF ((NR+IOFF).NE.LEN .OR. STATUS.NE.0) RETURN
           DO 5 J = 1, NR
              RBUFF(J) = IBUFF(J)
  5        CONTINUE
           CALL STFPUT(NO,FELM,NR,RBUFF,STATUS)
           IF (STATUS.NE.0) RETURN            
           FELM = FELM + NR
 10     CONTINUE
      ELSE                                         ! write without conversion
        DO 20 I = 1, NL
           CALL ISDRB1(CHANL,IBUFF,NR,LEN,IOFF,STATUS)
           IF ((NR+IOFF).NE.LEN .OR. STATUS.NE.0) RETURN
           CALL STFPUT(NO,FELM,NR,IBUFF,STATUS)
           IF (STATUS.NE.0) RETURN            
           FELM = FELM + NR
 20     CONTINUE
      ENDIF
C
C ... write image descriptors
C
      NAXIS(1) = 2
      NPIX(1)  = NBYTE
      NPIX(2)  = NRECO
      START(1) = 1.0D0
      START(2) = 1.0D0
      STEP(1)  = 1.0D0
      STEP(2)  = 1.0D0
      CUTS(1)  = 0.
      CUTS(2)  = 255.
      CUTS(3)  = 0.
      CUTS(4)  = 255.
      IDENT    = BUFF(145:210)
      CALL STDWRI(NO,'NAXIS',NAXIS,1,1,DUM,STATUS)
      CALL STDWRI(NO,'NPIX',NPIX,1,2,DUM,STATUS)
      CALL STDWRD(NO,'START',START,1,2,DUM,STATUS)
      CALL STDWRD(NO,'STEP',STEP,1,2,DUM,STATUS)
      CALL STDWRR(NO,'LHCUTS',CUTS,1,4,DUM,STATUS)
      CALL STDWRC(NO,'IDENT',1,IDENT,1,72,DUM,STATUS)
      CALL STDWRC(NO,'CUNIT',1,CUNIT,1,48,DUM,STATUS)
C
C ... write label descriptors
C
      CALL ISTDES(NO,BUFF,STATUS)
      CALL STFCLO(NO,STATUS)
      RETURN
      END

C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or
C modify it under the terms of the GNU General Public License as
C published by the Free Software Foundation; either version 2 of
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public
C License along with this program; if not, write to the Free
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge,
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C       Internet e-mail: midas@eso.org
C       Postal address: European Southern Observatory
C                       Data Management Division
C                       Karl-Schwarzschild-Strasse 2
C                       D 85748 Garching bei Muenchen
C                       GERMANY
C===========================================================================

      SUBROUTINE IIDSSS(DSPLAY,MEMIDS,XOFFS,YOFFS,SPLITF,SPLX,SPLY,IDST)
C
      IMPLICIT NONE
C
      INTEGER     DSPLAY,MEMIDS,XOFFS,YOFFS
      INTEGER     SPLITF,SPLX,SPLY,IDST
C
      CALL IID1(DSPLAY,MEMIDS,XOFFS,YOFFS,0,0)
      CALL IID2(SPLITF,SPLX,SPLY,IDST)

C
      RETURN
      END

      SUBROUTINE IIDSNP(DSPLAY,COLMODE,NPIXEL,XOFF,YOFF,
     +                  DEPTH,PACKF,DATA,IDST)
C
      IMPLICIT NONE
C
      INTEGER     DSPLAY,COLMODE,NPIXEL,XOFF,YOFF
      INTEGER     DEPTH,PACKF,DATA,IDST
C
      CALL IID1(DSPLAY,COLMODE,NPIXEL,XOFF,0,0)
      CALL IID3(YOFF,DEPTH,PACKF,DATA,IDST)
C
      RETURN
      END

      SUBROUTINE IIDQDC(DSPLAY,CONFNO,MEMTYP,TOTMEM,CONFMD,MEMID,
     +                  MEMSZX,MEMSZY,MEMDEP,ITTDEP,NOMEM,IDST)
C
      IMPLICIT NONE
C
      INTEGER     DSPLAY,CONFNO,MEMTYP,TOTMEM,CONFMD,MEMID
      INTEGER     MEMSZX,MEMSZY,MEMDEP,ITTDEP,NOMEM,IDST
C
      CALL IID1(DSPLAY,CONFNO,MEMTYP,TOTMEM,CONFMD,MEMID)
      CALL IID4(MEMSZX,MEMSZY,MEMDEP,ITTDEP,NOMEM,IDST)
C
      RETURN
      END

      SUBROUTINE IIDQDV(DSPLAY,TOTCNF,SZX,SZY,DEPTH,
     +                  NLUT,NITT,NCURS,IDST)
C
      IMPLICIT NONE
C
      INTEGER     DSPLAY,TOTCNF,SZX,SZY,DEPTH,NLUT,NITT,NCURS,IDST
C
      CALL IID1(DSPLAY,TOTCNF,SZX,SZY,0,0)
      CALL IID5(DEPTH,NLUT,NITT,NCURS,IDST)

C
      RETURN
      END

       PROGRAM IUEDISK
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION        IUEDISK.FOR
C.AUTHOR:               J.D.PONZ  ESA-VILSPA        
C.KEYWORDS              IUE, GO FORMAT, RAW IMAGE
C.PURPOSE
C  \begin{TeX}
C   Main program to convert IUE disk files in GO format into MIDAS.
C   Files are created with the following formats
C   \begin{description}
C      \item[{\tt RAW}]   2-Dimensional image in byte or floating point format.
C      \item[{\tt PHOT}]  2-Dimensional image in byte or floating point format.
C      \item[{\tt LBL}]   2-Dimensional image in byte or floating point format.
C      \item[{\tt MELO}]  table file.
C      \item[{\tt MEHI}]  table file.
C   \end{description}
C
C   The files {\tt MELO} and {\tt MEHI} are tables with the following columns:
C   \begin{description}
C      \item[{\tt WAVELENGTH}]  {\tt R*4}    wavelenghts
C      \item[{\tt EPSILON}]     {\tt I*4}    quality flags
C      \item[{\tt GROSS}]       {\tt R*4}    gross spectrum
C      \item[{\tt BACK}]        {\tt R*4}    background estimation
C      \item[{\tt NET}]         {\tt R*4}    net spectrum
C      \item[{\tt RNET}]        {\tt R*4}    ripple corrected net (only high disp)
C      \item[{\tt FLUX}]        {\tt R*4}    absolute flux
C      \item[{\tt ORDER}]       {\tt I*4}    spectral order number (only high disp)
C  \end{description}
C \end{TeX}
C.ALGORITHM
C \begin{TeX}
C   \begin{enumerate}
C   \item Read parameters defining:
C       \begin{itemize}
C       \item Input filename
C       \item  naming convention
C       \item flags for file format and header listing
C       \end{itemize}
C   \item Read the first header record to find the file type
C   \item Generate the filename according to the naming conventions
C   \end{enumerate}
C \end{TeX}
C
C.LANGUAGE:               F77 
C.COMMENTS
C \begin{TeX}
C   The program is started by the procedure {\tt IUEDISK.PRG}
C
C   The following extensions are used:
C \begin{itemize}
C    \item  IMPLICIT NONE
C    \item  long variable names
C \end{itemize}
C \end{TeX}
C.VERSION: 1.0  INITIAL CODING  24 JUN 1994
C--------------------------------------------------------------------
C
C  data declaration
C
       IMPLICIT NONE
C                                   define data types as parameters
       INTEGER  FESTYP, RAWTYP, PHOTYP, LBLTYP, LOWTYP, HIGTYP
       PARAMETER (FESTYP=0)
       PARAMETER (RAWTYP=1)
       PARAMETER (PHOTYP=2)
       PARAMETER (LBLTYP=3)
       PARAMETER (LOWTYP=4)
       PARAMETER (HIGTYP=5)
C
       INTEGER                IOFF
       INTEGER                STATUS, KUN(1), KNUL, ACTVAL, I
       INTEGER                CHANL, INDEX, DSPFLG
       INTEGER                LFID
       INTEGER                CAMERA
       INTEGER                IMANUM
       INTEGER                APERTU
       INTEGER                DISPER
       INTEGER                NRECO, NBYTE
       INTEGER                FTYPE
       INTEGER                DSKFMT
       INTEGER                NORD, ORDER(100)
       INTEGER                MADRID(1)
C
       CHARACTER*400          BUFF            
       CHARACTER*80           INPUT, OUTPUT, FILE 
       CHARACTER*5            FLAGS, NEWPAG
       CHARACTER*80           LINE
       COMMON/VMR/MADRID
       DATA                    NEWPAG/' '/
C
C ...  MIDAS environment
C
        CALL STSPRO('IUEDISK')
C
C ... init variables for data conversion
C
        CALL ISTCVI
C
C ... get input filename 
C
        INPUT=' '
        CALL STKRDC('P1',1,1,80,ACTVAL,INPUT,KUN,KNUL,STATUS)
        CALL ISDOPN(INPUT,CHANL,STATUS)
        IF (STATUS.NE.0) THEN
          CALL STTPUT('*** Error in input file  ***',STATUS)
          GOTO 9999
        ENDIF  
C
C ... get output filename
C
        OUTPUT=' '
        CALL STKRDC('P2',1,1,80,ACTVAL,OUTPUT,KUN,KNUL,STATUS)
        LFID  = INDEX(OUTPUT,' ') - 1
C
C ... get flags (Integer/Real/X raw+phot,Full/Short label listing)
C
        FLAGS = ' '
        CALL STKRDC('P3',1,1,5,ACTVAL,FLAGS,KUN,KNUL,STATUS)
        CALL ISTUPC(FLAGS,FLAGS)
        DSKFMT = 1                   ! default is integer data on disk
        I = INDEX(FLAGS,'R')
        IF (I.GT.0) DSKFMT = 0       ! real data on disk
        I = INDEX(FLAGS,'X')
        IF (I.GT.0) DSKFMT = -1      ! no disk file
C
        DSPFLG = 1                   ! default is Short listing
        I = INDEX(FLAGS,'N')
        IF (I.GT.0) DSPFLG = 0       ! No listing
        I = INDEX(FLAGS,'F')
        IF (I.GT.0) DSPFLG = 2       ! Full listing
C
C ... process main header
C
       IOFF = 0
       CALL ISDHED(CHANL,BUFF,CAMERA,IMANUM,APERTU,DISPER,
     .             FTYPE,NRECO,NBYTE,IOFF,STATUS)
       IF (STATUS.NE.0) THEN
           CALL ISTFHD(CHANL,BUFF,2,IOFF,STATUS)
           CALL STTPUT('*** Error in file header ***',STATUS)
           GOTO 200
       ENDIF 
C
C ... generate filename
C
       IF (LFID.EQ.3 .AND. OUTPUT(1:3).EQ.'IUE') THEN
          CALL ISTFN1(CAMERA,IMANUM,APERTU,FTYPE,FILE)
       ELSE
          FILE = OUTPUT
       ENDIF
C
C ... process the file if requested
C
       IF (FTYPE.EQ.FESTYP) THEN
         CALL ISDFES(CHANL,BUFF,FILE,DSKFMT,DSPFLG,
     .               NRECO,NBYTE,IOFF,STATUS)                        ! PROCESS FES
         IF (STATUS.NE.0) THEN
           CALL STTPUT('*** Error reading FES file ***',STATUS)
           GOTO 200
         ELSE
           LINE = 'FES image written into file: '// FILE
           IF (DSKFMT.NE.-1) CALL STTPUT(LINE,STATUS)
         ENDIF
       ELSEIF(FTYPE.EQ.RAWTYP) THEN
         CALL ISDRAW(CHANL,BUFF,FILE,DSKFMT,DSPFLG,IOFF,STATUS)       ! PROCESS RAW
         IF (STATUS.NE.0) THEN
           CALL STTPUT('*** Error reading RAW file ***',STATUS)
           GOTO 200
         ELSE
           LINE = 'RAW image written into file: '// FILE
           IF (DSKFMT.NE.-1) CALL STTPUT(LINE,STATUS)
         ENDIF
       ELSEIF(FTYPE.EQ.PHOTYP) THEN
         CALL ISDPHO(CHANL,BUFF,FILE,DSKFMT,DSPFLG,IOFF,STATUS)    ! PROCESS PHOTOM
         IF (STATUS.NE.0) THEN
           CALL STTPUT('*** Error reading PHOT file ***',STATUS)
           GOTO 200
         ELSE
           LINE = 'PHOT image written into file: '// FILE
           IF (DSKFMT.NE.-1) CALL STTPUT(LINE,STATUS)
         ENDIF
       ELSEIF(FTYPE.EQ.LBLTYP) THEN
         CALL ISDLBL(CHANL,BUFF,FILE,DSKFMT,NRECO,NBYTE,
     .                DSPFLG,IOFF,STATUS)       ! PROCESS LBL
         IF (STATUS.NE.0) THEN
           CALL STTPUT('*** Error reading (E)LBL file ***',STATUS)
           GOTO 200
         ELSE
           LINE = '(E)LBL image written into file: '// FILE
           IF (DSKFMT.NE.-1) CALL STTPUT(LINE,STATUS)
         ENDIF
       ELSEIF(FTYPE.EQ.LOWTYP) THEN
         CALL ISDLOW(CHANL,BUFF,FILE,DSKFMT,NRECO,NBYTE,
     .               DSPFLG,IOFF,STATUS)              ! PROCESS LOW DISP
         IF (STATUS.NE.0) THEN
           CALL STTPUT('*** Error reading MELO file ***',STATUS)
           GOTO 200
         ELSE
           LINE = 'MELO spectra written into file: '// FILE
           IF (DSKFMT.NE.-1) CALL STTPUT(LINE,STATUS)
         ENDIF
       ELSEIF(FTYPE.EQ.HIGTYP) THEN
         CALL ISDHIG(CHANL,BUFF,FILE,DSKFMT,NORD,ORDER,NRECO,NBYTE,
     .               DSPFLG,IOFF,STATUS)  ! PROCESS HIGH DISP 
         IF (STATUS.NE.0) THEN
           CALL STTPUT('*** Error reading MEHI file ***',STATUS)
           GOTO 200
         ELSE
           LINE = 'MEHI spectra written into file: '// FILE
           IF (DSKFMT.NE.-1) CALL STTPUT(LINE,STATUS)
         ENDIF
       ENDIF
200    CONTINUE
C
C ... end
C
 9999  CALL STSEPI
10000  FORMAT(I3.3)
C10001  FORMAT(I<SLEN>)
10001  FORMAT(I1)
10002  FORMAT(I2)
10003  FORMAT(I3)
10004  FORMAT(I4)
       END

C
C Copyright (C) 1995-2011 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  18:08 - 6 DEC 1987
C          1.1  read LINTAB to get the name of the line table
C               instead using fixed line.tbl. (SW)
C          1.2  Store the mean RMS in AVRMS descriptor (SW,1999-10-01)
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: P. BALLESTER
C
C
C.IDENTIFICATION
C
C  program ECHIDENEW.FOR
C
C.PURPOSE
C
C  Execute the command
C  CALIBRATE/ECHELLE CALIB-table error [degree]
C
C.KEYWORDS
C
C  echelle, line identification
C
C.ALGORITHM
C
C  SOURCE:
C  Adaptation of ECHIDEN2.FOR to involve the "echelle relation" in the
C  order by order polynomial fitting.
C  INPUT:
C  user- table contains detected lines (LINE.tbl)
C  Wavelengths have been assigned by the procedure ECHIDENEW
C  Coefficients of echelle relation are written in descriptor REGRD in LINE.tbl
C  Degree of the echelle relation fitting is written in keyword ECHI(3)
C  ALGORITHM:
C   This sample is used to find a high order approximation 
C  to the dispersion coeffs.
C
C
C.INPUT/OUTPUT
C
C  P1-P2 contain input parameters
C
C.VERSION
C 110819	last modif
C 
C-----------------------------------------------------------
C
      PROGRAM NECIDEN
      IMPLICIT         NONE
C
C ... parameter definition
C
      INTEGER          STATUS
      INTEGER          IC(2),TID
      INTEGER          MADRID(1)
      INTEGER          IAV, IDEG, IORD, ISTAT, KUN, KNUL
      INTEGER          NCOL1, NROW1, NSC1, NACOL, NAROW
      INTEGER          ICOLX, ICOLW, ICOLO, IC1, IR, IS
      INTEGER*8        IM1, IX, IDNT, K1, IWAV1, IRES
      INTEGER          NN1,IMNOX
      INTEGER          ISS, NACT, NO, IAC
      INTEGER*8        IBUF
      INTEGER          ISEL
      INTEGER*8        SELECT
      CHARACTER*60     TABLE
      CHARACTER*80     LINE
      CHARACTER*16     MSG
      REAL             W(2),ERROR

C******************************************************************************
C**   COMMON BLOCK. Don't forget to update all copies of this block if modified
      INTEGER          DEGMAX,ORDMAX
      PARAMETER        (DEGMAX=7,ORDMAX=500) ! Don't change 7
C     DEGMAX: Max. number of poly. coefficients. ORDMAX: Max. number of orders
      DOUBLE PRECISION A(DEGMAX,ORDMAX)   ! Array of order by order coefficients
      DOUBLE PRECISION A1(0:DEGMAX,0:DEGMAX)! Global 2D solution
C Initial coefficients (global echelle relation)
      INTEGER          IA(ORDMAX)  ! Number of identified values in each order
      INTEGER          ABSORD(ORDMAX) ! Absolute order number
      COMMON   /POLY/  A,A1,IA,ABSORD
C******************************************************************************
C
      DOUBLE PRECISION     AINIT(DEGMAX*DEGMAX+1)
      DOUBLE PRECISION     AVRMS(2)
      INTEGER              LOOP1,LOOP2,IPOS,MODEG

      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON/VMR/MADRID
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      DATA MSG/'ERR:NECIDENxxxx'/
C
C ... get into MIDAS
C
      CALL STSPRO('NECIDEN')
C
C ... Checks pre-defined arrays dimensions
C
      CALL STKRDI('INPUTI',1,1,IAV,IDEG,KUN,KNUL,ISTAT)  ! Degree of polynomial
      CALL STKRDI('INPUTI',2,1,IAV,IORD,KUN,KNUL,ISTAT)  ! Number of orders
      CALL STKRDI('INPUTI',4,1,IAV,MODEG,KUN,KNUL,ISTAT) ! Number of orders
      CALL STKRDR('INPUTR',1,1,IAV,ERROR,KUN,KNUL,ISTAT) ! Allowed residual
      IF (IDEG.GE.DEGMAX) THEN
          WRITE (LINE,9020) IDEG,DEGMAX
          CALL  STETER(9,LINE)
      ENDIF
      IF (IORD.GT.ORDMAX) THEN
          WRITE (LINE,9020) IORD,ORDMAX
          CALL  STETER(9,LINE)
      ENDIF
C
C ... Displays input summary
C
      TABLE  = 'line'
      CALL STKRDC('LINTAB',1,1,60,IAC,TABLE,KUN,KNUL,ISTAT)
      CALL STTPUT(' COMPUTE DISPERSION COEFFICIENTS',ISTAT)
      CALL STTPUT(' -------------------------------',ISTAT)
      CALL STTPUT(' INPUT TABLE : '//TABLE,ISTAT)
      WRITE (LINE,9000) IDEG
      CALL STTPUT(LINE,ISTAT)
C
C ... Init input table
C
      CALL TBTOPN(TABLE,F_U_MODE,TID,ISTAT)
C
      CALL STDRDD(TID,'REGRD',1,50,IAC,AINIT,KUN,KNUL,ISTAT)
      DO 100 LOOP2 = 0,IDEG
      DO 100 LOOP1 = 0,IDEG
         IPOS = LOOP1*(IDEG+1) + LOOP2 + 1
         A1(LOOP1,LOOP2) = AINIT(IPOS)
100   CONTINUE
C
      CALL TBIGET(TID,NCOL1,NROW1,NSC1,NACOL,NAROW,ISTAT)
      CALL TBCSER(TID,':X ',ICOLX,ISTAT)
      CALL TBCSER(TID,':IDENT',ICOLW,ISTAT)
      CALL TBCSER(TID,':ORDER ',ICOLO,ISTAT)
      CALL TBCSER(TID,':WAVEC ',IC1,ISTAT)
      CALL TBCSER(TID,':RESIDUAL ',IR,ISTAT)
      CALL TBCSER(TID,':SELECT ',ISEL,ISTAT)
      IF (ICOLX.EQ.-1 .OR. ICOLW.EQ.-1 .OR. ICOLO.EQ.-1) THEN
          CALL STTPUT(' Column not present ',IS)
          GO TO 10
      END IF
C
      CALL TBCMAP(TID,0,IM1,ISTAT)         ! Select. col.  MADRID(IM1)
      IF (ISTAT.NE.0) GO TO 10
      CALL TBCMAP(TID,ICOLX,IX,ISTAT)      ! :X            MADRID(IX)
      IF (ISTAT.NE.0) GO TO 10
      CALL TBCMAP(TID,ICOLW,IDNT,ISTAT)    ! :IDENT        MADRID(IDNT)
      IF (ISTAT.NE.0) GO TO 10
      CALL TBCMAP(TID,ICOLO,K1,ISTAT)      ! :ORDER        MADRID(K1)    
      IF (ISTAT.NE.0) GO TO 10
      CALL TBCMAP(TID,IC1,IWAV1,ISTAT)     ! :WAVEC        MADRID(IWAV1)
      IF (ISTAT.NE.0) GO TO 10
      CALL TBCMAP(TID,IR,IRES,ISTAT)       ! :RESIDUAL     MADRID(IRES)
      IF (ISTAT.NE.0) GO TO 10
      CALL TBCMAP(TID,ISEL,SELECT,ISTAT)   ! :SELECT       MADRID(SELECT)
      IF (ISTAT.NE.0) GO TO 10
C
CC original code:
CC      NN1 = 6*8*NROW1
CC      CALL TDMGET(NN1,IBUF,ISS)            ! WORK SPACE    MADRID(IBUF)
C 
C changed 110819, KB 
      NN1 = 6*NROW1                    !double prec. array BUF(nrow,6)
      CALL STFCRE('VMDUMM01',D_R8_FORMAT,F_X_MODE,F_IMA_TYPE,
     +            NN1,IMNOX,ISS)
      CALL STFMAP(IMNOX,F_X_MODE,1,NN1,NACT,IBUF,ISS)

C
C ... Loads values in work space
C
      CALL SPCOP3(NROW1,MADRID(IM1),MADRID(K1),MADRID(IX),
     +             MADRID(IDNT),MADRID(IBUF),NACT)
C
C ... Computes coeffs for each order
C
      CALL CCOEF (NROW1,MADRID(IBUF),NACT,IDEG,NO,W(1),W(2),ERROR,MODEG
     $     ,AVRMS(1),ISTAT)

      AVRMS(2) = ISTAT          !save number of bad RMS (2D-fit)
C
C ... Improves solution for undefined orders
C
C      CALL IMPCOE (IORD,IDEG)
C
C ... Computes residuals for each wavelength and unselect those which
C      are bigger than ERROR.
C
      CALL CRES(NROW1,MADRID(IM1),MADRID(IRES),NROW1,MADRID(IBUF),NACT,
     +          MADRID(SELECT),ERROR)

C
C ... Write results
C
      IC(1)  = IDEG
      IC(2)  = NO
      CALL STKWRR('OUTPUTR',W,1,2,KUN,ISTAT)
      CALL STDWRI(TID,'COEFS',IC,1,2,KUN,ISTAT)
      CALL STDWRI(TID,'COEFI',IA,1,NO,KUN,ISTAT)
      NO     = NO*7
      CALL STDWRD(TID,'COEFD',A,1,NO,KUN,ISTAT)
      CALL STDWRD(TID,'AVRMS',AVRMS,1,2,KUN,ISTAT)
C
C ... End
C
      CALL TBTCLO(TID,ISTAT)
   10 IF (ISTAT.NE.0) THEN
          WRITE (MSG(13:16),9010) ISTAT
          CALL TDERRR(ISTAT,MSG,STATUS)
      END IF
      CALL STSEPI
 9000 FORMAT (' POLYNOMIAL DEGREE : ',I3)
 9010 FORMAT (I4)
 9020 FORMAT (' OVERFLOW IN MODULE ECHIDENEW.FOR - VALUE : ',I5,
     +        '>> MAXI : ',I5)
      END

C******************************************************************************
      SUBROUTINE SPCOP3(N,M,Y,X,W,BUF,NACT)
C******************************************************************************
C
C PREPARE WORK SPACE
C
C******************************************************************************

      IMPLICIT NONE
      INTEGER          N, I
      INTEGER          TINULL, NACT, M(N), INTNB

      REAL             Y(N), X(N), TRNULL, YMIN, YMAX, YCURR

      DOUBLE PRECISION TDNULL, BUF(N,6), W(N)
C
      CALL TBMNUL(TINULL,TRNULL,TDNULL)
C 
C New storage procedure
C
      NACT   = 0
      YMIN   = MIN(Y(1),Y(N))
      YMAX   = MAX(Y(1),Y(N))

      YCURR = YMAX
      K1 = NINT(YMAX)
      K2 = NINT(YMIN)

      DO 20,KK = K1,K2,-1
      INTNB  =  0
      DO 10 I = 1, N
          IF (M(I).GT.0.and.Y(I).EQ.YCURR) THEN ! If the row is selected then
              INTNB       = 1
              NACT        = NACT + 1
              BUF(NACT,1) = Y(I)           ! Load ORDER number
              BUF(NACT,2) = X(I)           ! Load X position
              IF (W(I).EQ.TDNULL) THEN
                  BUF(NACT,3) = -1.D0      ! Load Wavelength
              ELSE
                  BUF(NACT,3) = 0.0001*W(I)
              END IF
              BUF(NACT,4) = I              ! Original position
              BUF(NACT,5) = 1.D0           ! Selection flag
              BUF(NACT,6) = 0.D0           ! Residual
          END IF
   10 CONTINUE

      IF (INTNB .EQ. 0) THEN
         NACT = NACT + 1
         BUF(NACT,1)  =  YCURR
         BUF(NACT,2)  =  0.D0
         BUF(NACT,3)  =  0.D0
         BUF(NACT,4)  =  1.D0           !KB, 110819
CC         BUF(NACT,4)  =  0.D0     serves as index of array, so not 0!
         BUF(NACT,5)  =  0.D0           ! Selection flag
         BUF(NACT,6)  =  0.D0           ! Residual
      ENDIF

      YCURR = YCURR - 1
20    CONTINUE

      RETURN
      END
C******************************************************************************
      SUBROUTINE CCOEF(NROW1,BUF,NACT,IDEG,NO,WST,WEN,ERROR,MODEG,AVRMS
     $     ,IBAD)
C******************************************************************************
C
C IDENTIFY DETECTED LINES
C       INPUT STORED IN BUF WITH THE FOLLOWING STRUCTURE
C BUF(I,1) - ORDER NUMBER
C BUF(I,2) - SAMPLE VALUE
C BUF(I,3) - WAVELENGTH
C
C******************************************************************************

      IMPLICIT NONE
      INTEGER          NROW1, IDEG, NO, ISEQ, IBAD, IK, IDEG1
      INTEGER          I, IP, IK1, ND, ISTAT, NACT, NB, MODEG
      REAL             W1, W2, WST, WEN, ERROR
      DOUBLE PRECISION BUF(NROW1,6),TOL,RMS,AVRMS
      CHARACTER*80     LINE
      CHARACTER*80     LINE1
      CHARACTER*80     LINE2
      CHARACTER*80     LINE3,LINE4
C******************************************************************************
C**   COMMON BLOCK. Don't forget to update all copies of this block if modified
      INTEGER          DEGMAX,ORDMAX
      PARAMETER        (DEGMAX=7,ORDMAX=500) ! Don't change 7
C     DEGMAX: Max. number of poly. coefficients. ORDMAX: Max. number of orders
      DOUBLE PRECISION A(DEGMAX,ORDMAX)   ! Array of order by order coefficients
      DOUBLE PRECISION A1(0:DEGMAX,0:DEGMAX)
C Initial coefficients (global echelle relation)
      INTEGER          IA(ORDMAX)  ! Number of identified values in each order
      INTEGER          ABSORD(ORDMAX) ! Absolute order number
      COMMON   /POLY/  A,A1,IA,ABSORD
C******************************************************************************
      INTEGER          IFIRST(ORDMAX), INDATA(ORDMAX), NBLINE
C
      DATA LINE/
     +      ' SEQ.NO  SPECTRAL  NO.LINES  WL START    WL END  STD. DEV.'
     +             /
      DATA LINE1/
     +      '          ORDER                                  ANGSTROEM'
     +             /
      DATA LINE2/
     +      ' ------  --------  --------  --------    ------  ---------'
     +             /
      DATA LINE3/
     +      ' ---------------------------------------------------------'
     +             /
C
      AVRMS  = 0.0
      TOL    = ERROR/10000.D0
      NBLINE = 0
      NO     = 0
      ISEQ   = 0
      IBAD   = 0
      WST    = 0.
      WEN    = 0.
      IDEG1  = IDEG + 1
      IK     = -999
      CALL STTPUT(LINE,ISTAT)
      CALL STTPUT(LINE1,ISTAT)
      CALL STTPUT(LINE2,ISTAT)
      DO 10 I = 1,NACT
          IK1    = BUF(I,1)
          IF (IK.NE.IK1) THEN
              IK     = IK1
              IF (NO.NE.0) THEN
                  IP     = IFIRST(NO)
                  ND     = INDATA(NO)
                  ISEQ   = ISEQ + 1
                  CALL FITPOL(ND,BUF(IP,2),BUF(IP,3),IDEG1,A(1,NO),
     +                 IA(NO),BUF(IP,1),ISEQ,W1,W2,BUF(IP,5),NB,
     +                 TOL,BUF(IP,6),MODEG,RMS)
                  ABSORD(NO) = BUF(IP,1)
                  NBLINE = NBLINE + NB
                  IF (WST.EQ.0)    WST    = W1
                  WEN    = W2
                  IF (RMS .LT. 99.99) THEN
                     AVRMS = AVRMS + RMS
                  ELSE
                     IBAD = IBAD + 1
                  ENDIF
              END IF
              NO     = NO + 1
              IFIRST(NO) = I
              INDATA(NO) = 1
          ELSE
              INDATA(NO) = INDATA(NO) + 1
          END IF
   10 CONTINUE
      ISEQ   = ISEQ + 1
      IP     = IFIRST(NO)
      ND     = INDATA(NO)
      CALL FITPOL(ND,BUF(IP,2),BUF(IP,3),IDEG1,A(1,NO),IA(NO),
     +            BUF(IP,1),ISEQ,W1,W2,BUF(IP,5),NB,TOL,
     +            BUF(IP,6),MODEG,RMS)
      IF (IBAD.NE.ISEQ) THEN
         AVRMS = (AVRMS + RMS)/(ISEQ-IBAD)
      ELSE
         WRITE (LINE4,'(A)') 'BAD RESULT !'
         AVRMS = 99.9999
      ENDIF
      ABSORD(NO) = BUF(IP,1)
      NBLINE = NBLINE + NB
      IF (WST.EQ.0)    WST    = W1
      WEN    = W2
      CALL STTPUT(LINE3,ISTAT)
      WRITE (LINE4,'(39X,A,F9.5)') 'MEAN RMS: ',AVRMS
      CALL STTPUT(LINE4,ISTAT)
      WRITE  (LINE4, 1000) NBLINE
1000  FORMAT ('** TOTAL NUMBER OF LINES : ',I6,' **')
      CALL STTPUT(LINE4,ISTAT)
      RETURN
      END

C******************************************************************************
      SUBROUTINE CRES(N,M,RES,NROW1,BUF,NACT,SELECT,ERROR)
C******************************************************************************
C
C COMPUTE RESIDUALS
C
C******************************************************************************

      IMPLICIT NONE
      INTEGER          N, I
      INTEGER          TINULL, M(N),SELECT(N)
      DOUBLE PRECISION TDNULL
      DOUBLE PRECISION RES(N)
      REAL             TRNULL, ERROR
C
      INTEGER          NROW1,NACT,POS
      DOUBLE PRECISION BUF(NROW1,6)
C
C******************************************************************************
C**   COMMON BLOCK. Don't forget to update all copies of this block if modified
      INTEGER          DEGMAX,ORDMAX 
      PARAMETER        (DEGMAX=7,ORDMAX=500)  ! Don't change 7
C     DEGMAX: Max. number of poly. coefficients. ORDMAX: Max. number of orders
      DOUBLE PRECISION A(DEGMAX,ORDMAX)   ! Array of order by order coefficients
      DOUBLE PRECISION A1(0:DEGMAX,0:DEGMAX)
C Initial coefficients (global echelle relation)
      INTEGER          IA(ORDMAX)  ! Number of identified values in each order
      INTEGER          ABSORD(ORDMAX) ! Absolute order number
      COMMON   /POLY/  A,A1,IA,ABSORD
C******************************************************************************
C
      CALL TBMNUL(TINULL,TRNULL,TDNULL)
C
      DO 15 I=1,N
         SELECT(I) = 0
   15 CONTINUE
C
      DO 20  I = 1,NACT

         POS = NINT(BUF(I,4))
         RES(POS) = BUF(I,6)

         IF (M(POS).GT.0.AND.BUF(I,5).GT.0.D0.AND.
     +       ABS(BUF(I,6)).LT.ERROR)  THEN
             SELECT(POS) = 1
C            if select(i) = 1 or 2, the value is unchanged.
         ENDIF

   20 CONTINUE

      RETURN
      END

C******************************************************************************
      SUBROUTINE FITPOL(N,X,W,IDEG1,COEFF,NOMB,KK,ISEQ,WST,
     +                  WEN,SEL,NUMBER,TOL,RES,MODEG,REF)
C******************************************************************************
C
C COMPUTE COEFFS
C
C******************************************************************************

      IMPLICIT NONE
      INTEGER          N, IDEG1, ISEQ, I, J, NR, NUMBER, ORDER, OUT
      INTEGER          ISTAT,NP,IAV,KUN,KNUL,NOMB,MODEG
      REAL             WST, WEN
      DOUBLE PRECISION X(N), W(N), KK, SEL(N)
      DOUBLE PRECISION TOL,REF
      DOUBLE PRECISION XX, POLEV, WAVE1, WAVE2, STDERR
      CHARACTER*80     LINE
C******************************************************************************
C**   COMMON BLOCK. Don't forget to update all copies of this block if modified
      INTEGER          DEGMAX,ORDMAX
      PARAMETER        (DEGMAX=7,ORDMAX=500) ! Don't change 7
C     DEGMAX: Max. number of poly. coefficients. ORDMAX: Max. number of orders
      DOUBLE PRECISION A(DEGMAX,ORDMAX)   ! Array of order by order coefficients
      DOUBLE PRECISION A1(0:DEGMAX,0:DEGMAX)
C Initial coefficients (global echelle relation)
      INTEGER          IA(ORDMAX)  ! Number of identified values in each order
      INTEGER          ABSORD(ORDMAX) ! Absolute order number
      COMMON   /POLY/  A,A1,IA,ABSORD
C******************************************************************************
      DOUBLE PRECISION COEFF(DEGMAX),X1(ORDMAX),W1(ORDMAX)
      INTEGER          SEL1(ORDMAX)
      DOUBLE PRECISION START, STEP, RES(ORDMAX), IX_IR8
C
      NR     = 0
      ORDER  = KK
      CALL STKRDI('INPUTI',3,1,IAV,NP,KUN,KNUL,ISTAT) ! Number of col.
      CALL STKRDD('INPUTD',1,1,IAV,START,KUN,KNUL,ISTAT) 
      CALL STKRDD('INPUTD',2,1,IAV,STEP,KUN,KNUL,ISTAT) 

      DO 10 I = 1,N
          IF (W(I).GT.0.D0) THEN
              NR       = NR + 1
              X1(NR)   = X(I)
              W1(NR)   = W(I)
              SEL1(NR) = I
          END IF
   10 CONTINUE 

      NOMB   = MIN(NR,IDEG1)
      NUMBER = NR
      IF (NR.GT.IDEG1.AND.MODEG.EQ.1) THEN
          CALL LSOLVE(NR,X1,W1,COEFF,IDEG1,REF)
          OUT = 1
   50     CONTINUE
          IF (NUMBER.GT.(IDEG1+1).AND.OUT.NE.0) THEN

              REF=STDERR(NUMBER,X1,W1,DEGMAX,COEFF,OUT,TOL,RES)
              IF (OUT.NE.0) THEN
                  SEL(SEL1(OUT)) = 0
              ENDIF
              NUMBER = 0
              DO 60 I = 1,N
                 IF (W(I).GT.0.D0.AND.SEL(I).GT.0.5D0) THEN
                     NUMBER     = NUMBER + 1
                     X1(NUMBER) = X(I)
                     W1(NUMBER) = W(I)
                     SEL1(NUMBER) = I
                 END IF
   60         CONTINUE 
              CALL LSOLVE (NUMBER,X1,W1,COEFF,IDEG1,REF)
              GOTO 50
          ENDIF

          REF    = REF*10000.D0
          XX     = IX_IR8(1,START,STEP)
          WAVE1  = POLEV(DEGMAX,COEFF,XX)
          WAVE1  = 10000.D0*WAVE1
          XX     = IX_IR8(NP,START,STEP)
          WAVE2  = POLEV(DEGMAX,COEFF,XX)
          WAVE2  = 10000.D0*WAVE2
          WRITE (LINE,9000) ISEQ,ORDER,NUMBER,WAVE1,WAVE2,REF
          CALL STTPUT(LINE,ISTAT)
          WST    = WAVE1
          WEN    = WAVE2
      ELSE
          DO 25  I = 1,IDEG1
              COEFF(I)   = DBLE(0.)
              DO 20 J=1,IDEG1
              COEFF(I)   = COEFF(I) + A1(J-1,I-1)*(FLOAT(ORDER)**
     +                     FLOAT(J-2))
20        CONTINUE
          COEFF(I) = COEFF(I)/DBLE(10000.)
25        CONTINUE
          XX     = IX_IR8(1,START,STEP)
          WAVE1  = POLEV(DEGMAX,COEFF,XX)
          WAVE1  = 10000.D0*WAVE1
          XX     = IX_IR8(NP,START,STEP)
          WAVE2  = POLEV(DEGMAX,COEFF,XX)
          WAVE2  = 10000.D0*WAVE2
          IF (NR.GT.0) THEN
              REF = STDERR(NR,X1,W1,DEGMAX,COEFF,OUT,TOL,RES)
              OUT    = 0
              REF    = REF*10000.D0
          ELSE
              REF    = 99.99999
          ENDIF

          IF (MODEG.EQ.1) THEN
            WRITE (LINE,9010) ISEQ,ORDER,NR,WAVE1,WAVE2,REF
          ELSE
            WRITE (LINE,9020) ISEQ,ORDER,NR,WAVE1,WAVE2,REF
          ENDIF

          CALL STTPUT(LINE,ISTAT)
          WST    = WAVE1
          WEN    = WAVE2
      END IF
      RETURN
 9000 FORMAT (1X,I6,2X,I8,2X,I8,2X,F8.2,2X,F8.2,2X,F9.5)
 9010 FORMAT (1X,I6,2X,I8,2X,I8,2X,F8.2,2X,F8.2,2X,F9.5,
     +                                           ' *NOT ENOUGH LINES*')
 9020 FORMAT (1X,I6,2X,I8,2X,I8,2X,F8.2,2X,F8.2,2X,F9.5,
     +                                           ' *FROM 2D SOLUTION*')
      END

C******************************************************************************
      DOUBLE PRECISION FUNCTION POLEV(DEGMAX,A,XX)
C******************************************************************************
C
C COMPUTE FUNCTION VALUE
C
C******************************************************************************

      IMPLICIT         NONE
      INTEGER          DEGMAX, I
      DOUBLE PRECISION A(1),XX,YY
C
      YY = DBLE(0.)
      DO 10 I = DEGMAX, 1, -1
         YY = A(I) + XX * YY
10    CONTINUE
C
      POLEV  = YY
      RETURN
      END

C******************************************************************************
      SUBROUTINE LSOLVE(NR,X1,W1,A,IA,REF)
C******************************************************************************
C
C L - S POLYNOMIAL
C
C******************************************************************************

      IMPLICIT NONE
C
      INTEGER NR,IA
      DOUBLE PRECISION X1(NR),W1(NR),A(IA),REF
      DOUBLE PRECISION G(20,20),X(20)
      INTEGER N,L,N1,I,J,M,KMIN,K
      COMMON /LS/G,X,N
C
      L      = 0
      N      = IA
      N1     = N + 1
      DO 30 I = 1,NR
          J      = L + 1
          G(J,1) = 1.D0
          DO 10 M = 2,N
              G(J,M) = G(J,M-1)*X1(I)
   10     CONTINUE
          G(J,N1) = W1(I)
          IF (L.NE.0) THEN
              KMIN   = MIN(L,N1)
              DO 20 K = 1,KMIN
                  CALL HT(K,J)
   20         CONTINUE
          END IF

          L      = MIN(J,N1)
   30 CONTINUE
      CALL SOLVE
      DO 40 I = 1,IA
          A(I)   = X(I)
   40 CONTINUE
C      REF    = DABS(G(N1,N1)) ! Result non normalized. 19.12.90 PB
      REF    = DSQRT(G(N1,N1)*G(N1,N1)/NR)
      RETURN
      END

C******************************************************************************
      SUBROUTINE HT(K,L1)
C******************************************************************************
C     FUNCTION : Apply a Householder transformation to the
C                two rows K and L1 of G.
C
C     INPUT :    * matrix G(1:L1,1:n+1)
C                * numbers L1 and K of the two rows
C                * n : rank of the matrix
C
C     OUTPUT :   modified rows K and L1 of the matrix G.
C******************************************************************************

      IMPLICIT NONE
      INTEGER  K,L1
      DOUBLE PRECISION G,X,S,H,B
      INTEGER N,KH,J
      COMMON /LS/G(20,20),X(20),N
C
C     Construct the transformation
C
      S      = DSQRT(G(K,K)**2+G(L1,K)**2)
      IF (G(K,K).GE.0) THEN
          S      = -S
      END IF
      H      = G(K,K) - S
      G(K,K) = S
      B      = G(K,K)*H
C
C     Apply the transformation to the rows K and L1 of G.
C
      KH     = N + 1 - K
      IF ((KH.NE.0) .AND. (B.NE.0)) THEN
          DO 10 J = 1,KH
              S      = (G(K,K+J)*H+G(L1,K+J)*G(L1,K))/B
              G(K,K+J) = G(K,K+J) + S*H
              G(L1,K+J) = G(L1,K+J) + S*G(L1,K)
   10     CONTINUE
      END IF
      END

C******************************************************************************
      SUBROUTINE SOLVE
C******************************************************************************
C     FUNCTION : Solve the set of linear equations which are
C                represented by the upper triangular part
C                of the matrix G(1:n,1:n+1).
C
C     INPUT :    * matrix G(1:n,1:n+1)
C                * n : rank of the matrix
C
C     OUTPUT :   solution vector x(1:n)
C******************************************************************************

      IMPLICIT NONE
      DOUBLE PRECISION G,X,S
      INTEGER N,I,II,J
      COMMON /LS/G(20,20),X(20),N
C
      DO 10 I = 1,N
          X(I)   = G(I,N+1)
   10 CONTINUE
      DO 30 II = 1,N
          I      = N - II + 1
          S      = 0.D0
          IF (I.NE.N) THEN
              DO 20 J = 2,N + 1 - I
                  S      = S + G(I,I+J-1)*X(I+J-1)
   20         CONTINUE
          END IF
          X(I)   = (X(I)-S)/G(I,I)
   30 CONTINUE

      END
C****************************************************************
C
      DOUBLE PRECISION FUNCTION STDERR (NVAL, X, Y, DIM, 
     +                   COEFF, OUTLIE, TOL,RES)
C
      IMPLICIT NONE
C
      INTEGER          NVAL,DIM
      DOUBLE PRECISION X(1), Y(1), RES(1), COEFF(DIM), STDMAX
      DOUBLE PRECISION YESTIM, SX2, RESIDU, XX, POLEV
      INTEGER          I,OUTLIE,FLAG
      DOUBLE PRECISION TOL
C
      FLAG = 0
      SX2  = DBLE(0.)
      STDMAX =  DBLE(0.)
C
      DO 10 I = 1, NVAL

           XX = X(I)
           YESTIM = POLEV(DIM,COEFF,XX)
           RES(I) = (Y(I)-YESTIM)*10000.D0
           RESIDU = ABS(Y(I)-YESTIM)

           SX2    = SX2 + RESIDU * RESIDU

           IF (RESIDU.GT.TOL) FLAG = 1

           IF (I.EQ.1) THEN
               STDMAX = RESIDU
               OUTLIE = 1
           ELSE IF (RESIDU.GT.STDMAX) THEN
               STDMAX = RESIDU
               OUTLIE = I
           ENDIF

10    CONTINUE

      IF (FLAG.EQ.0) OUTLIE = 0
      STDERR = DSQRT ( SX2 / NVAL )

      RETURN
      END

C******************************************************************************

      SUBROUTINE IMPCOE (NORD,DEG)

      IMPLICIT NONE

      INTEGER  NORD,DEG

      INTEGER    ORDER,POSINF,POSSUP,STAT,DEGREE,NCOE,DEG1
      CHARACTER  LINE*80

C******************************************************************************
C**   COMMON BLOCK. Don't forget to update all copies of this block if modified
      INTEGER          DEGMAX,ORDMAX
      PARAMETER        (DEGMAX=7,ORDMAX=500) ! Don't change 7
C     DEGMAX: Max. number of poly. coefficients. ORDMAX: Max. number of orders
      DOUBLE PRECISION A(DEGMAX,ORDMAX)   ! Array of order by order coefficients
      DOUBLE PRECISION A1(0:DEGMAX,0:DEGMAX)
C Initial coefficients (global echelle relation)
      INTEGER          IA(ORDMAX)  ! Number of identified values in each order
      INTEGER          ABSORD(ORDMAX) ! Absolute order number
      COMMON   /POLY/  A,A1,IA,ABSORD
C******************************************************************************


      DEG1 = DEG + 1

      DO 10 ORDER = 1,NORD

         IF (IA(ORDER).LT.DEG1) THEN

C ...        Looking for the inferior and superior correctly estimated order
             POSINF = ORDER
             POSSUP = ORDER
20           POSINF = POSINF - 1
             IF (POSINF.GT.0.AND.IA(POSINF).LT.DEG1) GOTO 20
30           POSSUP = POSSUP + 1
             IF (POSSUP.LE.NORD.AND.IA(POSSUP).LT.DEG1) GOTO 30

C ...        Computes coefficients from POSINF and from POSSUP (if possible)
             IF (POSINF.GT.0.OR.POSSUP.LE.NORD) THEN

                 NCOE = 0

                 DO 40 DEGREE = 1,DEG1
                       A(DEGREE,ORDER) = 0.D0
40               CONTINUE

                 IF (POSINF.GT.0) THEN
                     NCOE = NCOE + 1
                     DO 50 DEGREE = 1,DEG1
              A(DEGREE,ORDER) = A(DEGREE,POSINF)*ABSORD(POSINF)
     +                                               /ABSORD(ORDER)
50                   CONTINUE
                 ENDIF

                 IF (POSSUP.LE.NORD) THEN
                     NCOE = NCOE + 1
                     DO 60 DEGREE = 1,DEG1
                       A(DEGREE,ORDER) = A(DEGREE,ORDER) +
     +       A(DEGREE,POSSUP)*ABSORD(POSSUP)/ABSORD(ORDER)
60                   CONTINUE
                 ENDIF

                 IF (NCOE.GT.1) THEN
                     DO 70 DEGREE = 1,DEG1
                        A(DEGREE,ORDER) = A(DEGREE,ORDER)/NCOE
70                   CONTINUE
                 ENDIF

                 WRITE (LINE,1000) ABSORD(ORDER)
1000             FORMAT ('Replaced coefficients order : ',I6)
                 CALL   STTPUT(LINE,STAT)

           ENDIF
        ENDIF
10    CONTINUE

      RETURN
      END

C @(#)rectimag.for	19.1 (ESO-DMD) 02/25/03 13:31:23
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C.IDENTIFICATION: RECTIMAG
C.AUTHOR:         D. Baade
C.VERSION:        850809  version 1.2
C.VERSION;        850820  K. Banse  
C.KEYWORDS:       Geometrical rectification of 2-D images, rebinning, 
C                 flux conservation
C.PURPOSE:        Geometrically rectificy distorted 2-D images, rebin but 
C                 roughly maintain the original step sizes, take care that 
C                 flux is conserved
C.LANGUAGE:       F77+ESOext
C.ALGORITHM:      a) rectification: 
C                    The parameters of a bipolynomial regression of 
C		     degree (3,3) have to be calculated first by 
C	             REGRESSION/POLY on TABLE data (e.g. with positions of 
C                    reseaux marks).
C                    They are stored in the keyword COEFFX (1,...,20) and
C                    COEFFY (1,...,20).
C                 b) rebinning:
C                    Each pixel is routinely subdivided into 9 subpixels
C                    (unless SUBFAC=1.). Assuming that
C                    the coordinates of the input pixel refer to its center
C                    and that its contents is the average flux integrated over
C                    its area (no dead space), a simple linear interpolation
C                    with nearest neighboring original pixels is done for each
C                    of the 9 subpixels. After this interpolation the flux
C                    summed over the subpixels is scaled to the flux of the
C                    original pixel so that flux conservation is achieved on a
C                    pixel basis. Finally, each subpixel is imaged to the
C                    rectified coordinate frame and its contents added to the
C                    appropriate pixel(s) (of about the same size as in the 
C                    input frame). Optionally (NREP.GT.1) each subpixel can 
C                    first be subdivided into still smaller units. Sub-subpixels
C                    originating from the same parent-subpixel all contain the
C                    same flux, i.e. no further interpolation is done.
C.RESTRICTIONS:      a) works in pixel space only, i.e STEP(x,y) = (+1,+1)
C                       in BOTH INPUT and OUTPUT frame
C                    b) it is implicitly assumed that the positions of the
C                       reseaux marks, too, are meassured in these same units
C.INPUT/OUTPUT:      The following keywords are used:
C                    IN_A/C/1/60     name of input frame
C                    OUT_A/C/1/60    name of output frame
C                    COEFFX/D/1/20   regression coefficients for X-coordinate
C                    COEFFY/D/1/20   regression coefficients for Y-coordinate
C                    INPUTI/I/1/1    repetition factor (for the further 
C                                    subdivision of subpixe
C                    INPUTR/R/1/1    substepping factor
C.VERSION:           871123   Rein H. Warmels  ESO-FORTRAN Conversion
C 
C 010625		last modif
C 
C -------------------------------------------------------------------
      PROGRAM      RCTFRA
C
      IMPLICIT     NONE
C
      INTEGER      MADRID(1)
      INTEGER      I,IAV
      INTEGER      KUN,KNUL
      INTEGER      AIMF, CIMF, DIMF
      INTEGER      NAXIS,NPIX(2),ISTAT
      INTEGER      NREP,OUTPIX(2),NPIXIP(2)
C 
      INTEGER*8    IPNTRA,IPNTRC,IPNTRD
C
      REAL         OUTSTA(2),SUBFAC
C 
      DOUBLE PRECISION STEP(2),START(2)
      DOUBLE PRECISION COEFFX(20),COEFFY(20)
C 
      CHARACTER    FRAMEA*60,FRAMEC*60
      CHARACTER    IDENT*72,CUNIT*64
C
      COMMON        /VMR/MADRID
C 
      INCLUDE       'MID_INCLUDE:ST_DEF.INC'
C 
      DATA          IDENT /' '/, CUNIT /' '/
C 
      INCLUDE       'MID_INCLUDE:ST_DAT.INC'
C
C *** begin code
C
      CALL STSPRO('RECTIMAG')                       ! get into midas environment
      CALL STKRDC('IN_A',1,1,60,IAV,FRAMEA,KUN,KNUL,ISTAT) ! name of input frame
      CALL STIGET(FRAMEA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,2,
     2            NAXIS,NPIX,START,STEP,IDENT,CUNIT,IPNTRA,
     +            AIMF,ISTAT)                                       ! map frame
C
C *** insist that frame be two-dimensional
      IF (NAXIS.NE.2) 
     +   CALL STETER(1,'*** FATAL: Only 2-d frames allowed ... ')
C
C *** get regression coefficients, repetition factor and substepping flag
      CALL STKRDD('COEFFX',1,20,IAV,COEFFX,KUN,KNUL,ISTAT)
      CALL STKRDD('COEFFY',1,20,IAV,COEFFY,KUN,KNUL,ISTAT)
      CALL STKRDI('INPUTI',1,1,IAV,NREP,KUN,KNUL,ISTAT)
      CALL STKRDR('INPUTR',1,1,IAV,SUBFAC,KUN,KNUL,ISTAT)
C
C *** limit nrep to 5
      IF (NREP.GT.5) THEN
         NREP   = 5
         CALL STTPUT('*** WARNING: Substepping factor set to 5!',
     2               ISTAT)
      END IF
C
C *** calculate values of outsta and outpix for output frame
      CALL OUTDIM(START,STEP,NPIX,COEFFX,COEFFY,OUTSTA,OUTPIX)
C
C *** get name of output frame, map frame
      CALL STKRDC('OUT_A',1,1,60,IAV,FRAMEC,KUN,KNUL,ISTAT)
      CALL STIPUT(FRAMEC,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     2            NAXIS,OUTPIX,OUTSTA,STEP,IDENT,CUNIT,IPNTRC,
     3            CIMF,ISTAT)
C
C *** and initialize its contents to zero
      CALL INTNUL(OUTPIX(1)*OUTPIX(2),MADRID(IPNTRC))
C
C *** copy descriptor lhcuts because the cuts shouldn't change much ...
      CALL STDCOP(AIMF,CIMF,4,'LHCUTS',ISTAT)
C
C *** let subroutines rectinterpol, rectscale, and rectmap do the work
      IF (SUBFAC.GT.1.1) THEN                        ! deconvolution to be done
C
C *** create dummy file to hold intermediate results after deconvolution
         DO 10,I=1,2
            NPIXIP(I) = NPIX(I)*SUBFAC
   10    CONTINUE
         CALL STIPUT('IPOLDUM',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     2            NAXIS,NPIXIP,START,STEP,IDENT,CUNIT,IPNTRD,
     3            DIMF,ISTAT)
         CALL INTNUL(NPIXIP(1)*NPIXIP(2),MADRID(IPNTRD))
         CALL RCTINT(MADRID(IPNTRA),NPIX(1),NPIX(2),MADRID(IPNTRD))
         CALL RCTMAP(MADRID(IPNTRC),OUTPIX(1),OUTPIX(2),START,
     2               MADRID(IPNTRD),NPIXIP(1),NPIXIP(2),COEFFX,COEFFY,
     3               OUTSTA,SUBFAC,NREP)
C  
      ELSE                                                  ! (no deconvolution)
         CALL RCTMAP(MADRID(IPNTRC),OUTPIX(1),OUTPIX(2),START,
     2               MADRID(IPNTRA),NPIX(1),NPIX(2),COEFFX,COEFFY,
     3               OUTSTA,SUBFAC,NREP)
      END IF
C
      CALL STSEPI
      END

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM GENYY1
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C  
C.IDENTIFICATION
C  program  GENYY1			 951012
C  K. Banse                	 	 ESO - Garching
C
C.KEYWORDS
C  image processing functions
C
C.PURPOSE
C  merger of several functions, see description there
C
C.ALGORITHM
C  see local descriptions
C
C.INPUT/OUTPUT
C  the following keys are used:
C
C  ACTION/C/1/2		action flag
C			= GR, for GROW/IMAGE
C			= IM, for converting from image to table
C			= TB, for converting from table to image
C			= CC, for aligning center pixels
C			= SC, for SCALE
C			= WE, for WEIGHT
C			= RG, for ROTGEN
C                       = RO, for ROTATE
C
C.VERSION
C 
C 021212	last modif	25 years ...
C 100319
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER    IAV,STAT
      INTEGER    UNI(1),NULO
C
      CHARACTER  ACTION*3
C
C  set up MIDAS environment + enable automatic error abort
      CALL STSPRO('GENYY1')
C
C  get option
      CALL STKRDC('ACTION',1,1,3,IAV,ACTION,UNI,NULO,STAT)
C 
      IF (ACTION(1:2).EQ.'GR') THEN
         CALL GROW(ACTION(3:3))              !grow/image
      ELSE IF (ACTION(1:2).EQ.'IM') THEN
         CALL IM2TAB(1)                      !image -> table
      ELSE IF (ACTION(1:2).EQ.'TB') THEN
         CALL IM2TAB(2)                      !table -> image 
      ELSE IF (ACTION(1:2).EQ.'CC') THEN
         CALL ALICNT
      ELSE IF (ACTION(1:2).EQ.'SC') THEN
         CALL SUBSCL
      ELSE IF (ACTION(1:2).EQ.'WE') THEN
         CALL SUBWEI
      ELSE IF (ACTION(1:2).EQ.'RG') THEN
         CALL SUBRTG
      ELSE IF (ACTION(1:2).EQ.'RO') THEN
         CALL SUBROT
      ENDIF
C
C  finished
      CALL STSEPI
      END

      SUBROUTINE GROW(OPT)
C 
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C 
C.IDENTIFICATION
C  subroutine  GROW                     version 1.00   871217
C  J.D. Ponz                            ESO - Garching
C
C.KEYWORDS
C  image expansion, pixel replication
C
C.PURPOSE
C  expand input image by replicating a selected row row- or columnwise
C
C.ALGORITHM
C  straight forward
C
C.INPUT/OUTPUT
C  call as GROW(OPT)
C
C  input par:
C  OPT: 	char.	'L' or 'C' for row replication as line or column
C
C.VERSION
C--------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER   MADRID
      INTEGER   KUN,KNUL,IMNOA,IMNOB
      INTEGER   IN1,KK,NAXISA,NAXISB,ACTVAL,SUBLO(3)
      INTEGER   NPIXA(2),NPIXB(2),STATUS
      INTEGER*8 PNTRA,PNTRB,PNTRW
C
      DOUBLE PRECISION STEPA(2),STEPB(2),DPAR(3)
      DOUBLE PRECISION STARTA(2),STARTB(2)
C
      CHARACTER   OPT*1
      CHARACTER*60   FRAMEA,FRAMEB
      CHARACTER   CUNIT*48,IDENT*72,CBUF*40,MOPT*2,NEWSTR*80
C
      COMMON /VMR/MADRID(1)
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      DATA  IDENT /' '/, CUNIT /' '/
      DATA  NPIXA /1,1/
      DATA  STARTA /0.D0,0.D0/
      DATA  STEPA  /1.D0,1.D0/
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C  get input, output frame
C
      CALL STKRDC('IN_A',1,1,60,ACTVAL,FRAMEA,KUN,KNUL,STATUS)
      CALL STKRDC('OUT_A',1,1,60,ACTVAL,FRAMEB,KUN,KNUL,STATUS)
      CALL GENEQF(FRAMEA,FRAMEB,ACTVAL)
      IF (ACTVAL.NE.0)
     +   CALL STETER(9,'inframe and outframe are equal...')
C 
      CALL STIGET(FRAMEA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +            2,NAXISA,NPIXA,STARTA,STEPA,
     +            IDENT,CUNIT,PNTRA,IMNOA,STATUS)
      CALL STKRDD('INPUTD',1,3,ACTVAL,DPAR,KUN,KNUL,STATUS)
C
C  get line/column we want to replicate
C
      CALL STKRDC('P5',1,1,40,ACTVAL,CBUF,KUN,KNUL,STATUS)
      MOPT(2:2) = 'L'                       !default to line input
      IF (NAXISA.EQ.1) THEN
         IN1 = 1
      ELSE
         KK = INDEX(CBUF,',')
         IF (KK.GT.1) THEN
            KK = KK + 1
            IF ((CBUF(KK:KK).EQ.'c') .OR. (CBUF(KK:KK).EQ.'C')) 
     +         MOPT(2:2) = 'C'
         ENDIF
         IF (MOPT(2:2).EQ.'C') THEN
            NEWSTR(1:) = '[ '
            NEWSTR(2:) = CBUF
            KK = INDEX(NEWSTR,' ')
            NEWSTR(KK:) = ',@1] '
            CALL EXTCO1(IMNOA,NEWSTR,2,KK,SUBLO,STATUS)
            IF (STATUS.NE.0) CALL STSEPI
            IN1 = SUBLO(1)
         ELSE
            NEWSTR(1:) = '[@1, '
            NEWSTR(5:) = CBUF
            KK = INDEX(NEWSTR,' ')
            NEWSTR(KK:) = '] '
            CALL EXTCO1(IMNOA,NEWSTR,2,KK,SUBLO,STATUS)
            IF (STATUS.NE.0) CALL STSEPI
            IN1 = SUBLO(2)
         ENDIF
      ENDIF
C 
      NAXISB = 2
      ACTVAL = NINT(DPAR(3))
      IF (ACTVAL.LE.0) ACTVAL = NPIXA(1)
C
C  if we extract a column, some more work necessary
      IF (MOPT(2:2).EQ.'C') THEN
         CALL STFXMP(NPIXA(2),D_R4_FORMAT,PNTRW,STATUS)
         CALL GETCOL(MADRID(PNTRA),NPIXA,IN1,MADRID(PNTRW))
         IN1 = 1
         NPIXA(1) = NPIXA(2)              !simulate 1-dim frame input
         STARTA(1) = STARTA(2)
         STEPA(1) = STEPA(2)
         PNTRA = PNTRW                    !and point to extracted column
      ENDIF
C
C  map output frame
C
      IF ((OPT.EQ.'c') .OR. (OPT.EQ.'C')) THEN   
         NPIXB(1) = ACTVAL             !we replicate the input row as column
         NPIXB(2) = NPIXA(1)
         STARTB(1) = DPAR(1)
         STARTB(2) = STARTA(1)
         STEPB(1) = DPAR(2)
         STEPB(2) = STEPA(1)
         CBUF(1:16) = CUNIT(17:32)
         CUNIT(17:) = 'none '
         CUNIT(33:48) = CBUF(1:16)
         MOPT(1:1) = 'C'
      ELSE                             !we replicate the input row as row
         NPIXB(1) = NPIXA(1)
         NPIXB(2) = ACTVAL
         STARTB(1) = STARTA(1)
         STARTB(2) = DPAR(1)
         STEPB(1) = STEPA(1)
         STEPB(2) = DPAR(2)
         CUNIT(33:) = 'none '
         MOPT(1:1) = 'L'
      ENDIF
C 
      CALL STIPUT(FRAMEB,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +            NAXISB,NPIXB,STARTB,STEPB,
     +            IDENT,CUNIT,PNTRB,IMNOB,STATUS)
C 
C  and do it
      CALL GROWIT
     +     (MOPT(1:1),NPIXA,MADRID(PNTRA),NPIXB,MADRID(PNTRB),IN1)
      CALL STDCOP(IMNOA,IMNOB,4,'LHCUTS',STATUS)
      CALL DSCUPT(IMNOA,IMNOB,' ',STATUS)
C
C  return
      RETURN
      END

      SUBROUTINE GETCOL(A,NPIXA,NO,B)
C
C
      IMPLICIT NONE
C 
      INTEGER     NPIXA(2),NO
      INTEGER     I,KIN
C
      REAL        A(*),B(*)
C
      KIN = NO
      DO 150, I=1,NPIXA(2)
         B(I) = A(KIN)
         KIN = KIN + NPIXA(1)
150   CONTINUE
C 
      RETURN
      END

      SUBROUTINE IM2TAB(FLAG)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine IM2TAB		 version 1.00	891213
C  K. Banse                 	 ESO - Garching
C
C.KEYWORDS
C  image, table conversion
C
C.PURPOSE
C  convert a table holding subareas of an image into a black+white mask
C  and vice versa
C
C.ALGORITHM
C  see below...
C
C.INPUT/OUTPUT
C  call as  IM2TAB(FLAG)
C  
C  Input:
C  FLAG		Integer		1 for imae -> table
C				2 for table -> image
C
C.VERSION
C  1.00		creation 
C
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER MAXDIM
      PARAMETER (MAXDIM=4000)
C
      INTEGER FLAG
      INTEGER MADRID
      INTEGER KUN,KNUL,TID,IMNO,IMNO2,MPIX(2)
      INTEGER KCOUNT,NAXIS,IAV,WSIZE
      INTEGER*8 PNTRW,PNTRV
      INTEGER NPIX(3),STAT
      INTEGER STAX(MAXDIM),STAY(MAXDIM),ENDX(MAXDIM),ENDY(MAXDIM)
      INTEGER TBCLNM(4),NCOLS
C
      REAL THRESH,RBUF(12),FGR,BGR
C
      DOUBLE PRECISION START(3),STEP(3),DBUF(4)
C
      CHARACTER*60   FRAME,TABLE
      CHARACTER      CUNIT*48,IDENT*80,MIDUNI*2,TMPFIL*14
      CHARACTER      TBUNIT*16,TBLABL(4)*16
C
      LOGICAL    TABNUL(4),SELFLG
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      COMMON /VMR/MADRID(1)
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C 
      DATA   NPIX  /1,1,1/, START /0.,0.,0./,  STEP /1.,1.,1./
      DATA   TBUNIT /'WORLD COORD '/
      DATA   TBLABL /'XSTART ','YSTART ','XEND ','YEND '/
      DATA   TBCLNM /0,0,0,0/
C
C  get image frame, table 
      CALL STKRDC('IN_A',1,1,60,IAV,FRAME,KUN,KNUL,STAT)
      CALL STKRDC('IN_B',1,1,60,IAV,TABLE,KUN,KNUL,STAT)
      NCOLS = 4
      CALL STKRDC('MID$SESS',1,11,2,IAV,MIDUNI,KUN,KNUL,STAT)
      TMPFIL = 'imtab'//MIDUNI//'dum.bdf'
C
C  branch according to FLAG
      IF (FLAG.EQ.2) GOTO 5000
C 
C  here we handle building of table from image
C 
      CALL STKRDR('INPUTR',1,1,IAV,THRESH,KUN,KNUL,STAT)
C 
C  open data file
      CALL STFOPN(FRAME,D_R4_FORMAT,0,F_IMA_TYPE,IMNO,STAT)
      CALL STDRDI(IMNO,'NAXIS',1,1,IAV,NAXIS,KUN,KNUL,STAT)
      CALL STDRDI(IMNO,'NPIX',1,NAXIS,IAV,NPIX,KUN,KNUL,STAT)
      CALL STDRDD(IMNO,'START',1,NAXIS,IAV,START,KUN,KNUL,STAT)
      CALL STDRDD(IMNO,'STEP',1,NAXIS,IAV,STEP,KUN,KNUL,STAT)
C 
C  map working space for 50/100 lines and 3 working lines
      IF (NPIX(1).GT.512) THEN
         WSIZE = NPIX(1) * 50
      ELSE
         WSIZE = NPIX(1) * 100
      ENDIF
      CALL STFXMP(WSIZE,D_R4_FORMAT,PNTRW,STAT)
      KCOUNT = 3 * (NPIX(1) + 2)             !1 more pixel in front and the end
      CALL STFXMP(KCOUNT,D_I4_FORMAT,PNTRV,STAT)
C 
      MPIX(1) = NPIX(1) + 2
      MPIX(2) = NPIX(2) + 2
      KCOUNT = MPIX(1) * MPIX(2)
      CALL STFCRE(TMPFIL,D_I4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +            KCOUNT,IMNO2,STAT)
      CALL STDWRI(IMNO2,'NAXIS',NAXIS,1,1,KUN,STAT)
      CALL STDWRI(IMNO2,'NPIX',MPIX,1,2,KUN,STAT)
      CALL STDWRD(IMNO2,'START',START,1,2,KUN,STAT)
      CALL STDWRD(IMNO2,'STEP',STEP,1,2,KUN,STAT)
C 
      KCOUNT = 0
      CALL DOI2T(IMNO,NPIX,MADRID(PNTRW),WSIZE,MADRID(PNTRV),
     +           THRESH,STAX,STAY,ENDX,ENDY,MAXDIM,KCOUNT,IMNO2)
C 
C  now create the table and fill it
      CALL TBTINI(TABLE,0,F_O_MODE,NCOLS,KCOUNT,TID,STAT)
      DO 4000, IAV=1,NCOLS
         CALL TBCINI(TID,D_R4_FORMAT,1,'G12.6',TBUNIT,
     +               TBLABL(IAV),TBCLNM(IAV),STAT)
4000  CONTINUE
C 
      DO 4400, IAV=1,KCOUNT
         RBUF(1) = START(1) + ((STAX(IAV) - 1) * STEP(1))
         RBUF(2) = START(2) + ((STAY(IAV) - 1) * STEP(2))
         RBUF(3) = START(1) + ((ENDX(IAV) - 1) * STEP(1))
         RBUF(4) = START(2) + ((ENDY(IAV) - 1) * STEP(2))
         CALL TBRWRR(TID,IAV,NCOLS,TBCLNM,RBUF,STAT)
4400  CONTINUE
C 
      CALL TBTCLO(TID,STAT)
      WRITE(IDENT,10000) KCOUNT
      CALL STTPUT(IDENT,STAT)
      RETURN
C
C 
C  here we handle building of image from table 
C 
5000  CALL STKRDR('INPUTR',1,2,IAV,RBUF,KUN,KNUL,STAT)   !bgr,fgr
      CALL STKRDD('INPUTD',1,4,IAV,DBUF,KUN,KNUL,STAT)   !start,step
      CALL STKRDI('INPUTI',1,2,IAV,NPIX,KUN,KNUL,STAT)   !NPIX of image
      BGR = RBUF(1)
      FGR = RBUF(2)
      START(1) = DBUF(1)
      START(2) = DBUF(2)
      STEP(1) = DBUF(3)
      STEP(2) = DBUF(4)
      IDENT(1:) = 'Image created from table '
      CUNIT(1:) = ' '
      NAXIS = 2
C 
      CALL STIPUT(FRAME,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +            NAXIS,NPIX,START,STEP,
     +            IDENT,CUNIT,PNTRW,IMNO,STAT)
      KCOUNT = NPIX(1) * NPIX(2)
      CALL OPFC('FC=',0.0,BGR,MADRID(PNTRW),KCOUNT,
     +          BGR,IAV)                     !fill frame with background

C 
      CALL TBTOPN(TABLE,F_I_MODE,TID,STAT)
      DO 6000, IAV=1,NCOLS
         CALL TBLSER(TID,TBLABL(IAV),TBCLNM(IAV),STAT)
         IF (TBCLNM(IAV).LE.0) CALL STETER
     +      (9,'column not found in input table...')
6000  CONTINUE
      CALL TBIGET(TID,IAV,KCOUNT,IAV,IAV,IAV,STAT)    !get no. of rows
C 
      DO 6600, IAV=1,KCOUNT
         CALL TBSGET(TID,IAV,SELFLG,STAT)        !only use selected rows
         IF (.NOT.SELFLG) GOTO 6600
C 
         CALL TBRRDR(TID,IAV,4,TBCLNM,RBUF,TABNUL,STAT)
         STAX(1) = (RBUF(1) - START(1)) / STEP(1) + 1
         STAX(2) = (RBUF(2) - START(2)) / STEP(2) + 1
         ENDX(1) = (RBUF(3) - START(1)) / STEP(1) + 1
         ENDX(2) = (RBUF(4) - START(2)) / STEP(2) + 1
         ENDY(1) = ENDX(1) - STAX(1)
         IF (ENDY(1).LT.0) ENDY(1) = -ENDY(1)
         ENDY(1) = ENDY(1) + 1
         ENDY(2) = ENDX(2) - STAX(2)
         IF (ENDY(2).LT.0) ENDY(2) = -ENDY(2)
         ENDY(2) = ENDY(2) + 1
         CALL COPYF2(FGR,MADRID(PNTRW),NPIX,STAX,ENDY)
6600  CONTINUE
      CALL TBTCLO(TID,STAT)
      WRITE(IDENT,10001) KCOUNT
      CALL STTPUT(IDENT,STAT)
C 
      RETURN
C  
10000 FORMAT(I6,' entries written into output table ...')
10001 FORMAT(I6,' entries processed from input table ...')
      END

      SUBROUTINE DOI2T(IMNO,NPIX,W,WSIZE,IV,THR,
     +                 STAX,STAY,ENDX,ENDY,MAXDIM,KCOUNT,IM2)
C 
      IMPLICIT NONE
C 
      INTEGER   IMNO,NPIX(*),WSIZE,STAX(*),STAY(*),ENDX(*),ENDY(*)
      INTEGER   IV(1500),MAXDIM,KCOUNT,IM2
      INTEGER   XDIM,YDIM,YDIM2,N,NX,NY,K,FELEM,ACTSZ,STAT
      INTEGER   VFIRST,VLAST,NV,VDIM,WOFF,IAV
      INTEGER   FOUT
C 
      REAL      W(*),THR
C 
      XDIM = NPIX(1)
      YDIM = NPIX(2)
      YDIM2 = YDIM - 2
      VDIM = XDIM + 2
C 
      FOUT = 1
C 
      FELEM = 1                                  !get first chunk of data
      CALL STFGET(IMNO,FELEM,WSIZE,IAV,W,STAT)
      FELEM = FELEM + IAV
      ACTSZ = IAV
C 
      VFIRST = 2*VDIM + 1
      VLAST = 3 * VDIM
C 
C  fill first 3 working lines with zero
      DO 500, K=1,VLAST
         IV(K) = 0
500   CONTINUE
C 
      N = VDIM + 1
      DO 700, K=1,XDIM                     !fill lines 2, 3
         IF (W(K).GE.THR) IV(K+N) = 1
         IF (W(K+XDIM).GE.THR) IV(K+VFIRST) = 1
700   CONTINUE
      WOFF = 2 * XDIM
C 
      CALL STFPUT(IM2,FOUT,VDIM,IV,STAT)   !write 1. line of temp file
      FOUT = FOUT + VDIM
C 
C  move line by line
      DO 5000, NY=1,YDIM
C 
         DO 3000, NV=2,VDIM-1   
            N = NV + VDIM                  !move through middle work line
C
            IF (IV(N).EQ.1) THEN
C 
C  test if a candidate for lower left start pixel
               IF (IV(N-1).EQ.0) THEN
                  IAV = N - VDIM
                  IF ((IV(IAV).EQ.0) .OR.
     +                ((IV(IAV).EQ.1).AND.(IV(IAV+1).EQ.0))) THEN
                     KCOUNT = KCOUNT + 1
C 
                     IF (KCOUNT.GT.MAXDIM) 
     +                  CALL STETER(1,
     +                  'Internal data overflow - we abort...')
C 
                     NX = NV - 1
                     STAX(KCOUNT) = NX
                     STAY(KCOUNT) = NY
                     ENDX(KCOUNT) = 0
                     ENDY(KCOUNT) = 0
                  ENDIF
               ENDIF
C 
C  test if a candidate for lower right end pixel
               IF (IV(N+1).EQ.0) THEN
                  IAV = N - VDIM
                  IF ((IV(IAV).EQ.0) .OR.
     +                ((IV(IAV).EQ.1).AND.(IV(IAV-1).EQ.0))) THEN
                     ENDX(KCOUNT) = NV - 1  !last entry...
                  ENDIF
C 
C  test if a candidate for upper right end pixel
                  IAV = N + VDIM
                  IF ((IV(IAV).EQ.0) .OR.
     +                ((IV(IAV).EQ.1).AND.(IV(IAV-1).EQ.0))) THEN
                     NX = NV - 1
                     DO 2000, K=KCOUNT,1,-1      !search for match in NX
                        IF (ENDX(K).EQ.NX) THEN
                           ENDY(K) = NY 
                           GOTO 3000
                        ENDIF
2000                 CONTINUE
                  ENDIF
               ENDIF
            ENDIF
3000     CONTINUE
C 
C  update working lines
         DO 3300, K=1,2*VDIM              !copy line 2,3 -> line 1,2
            IV(K) = IV(K+VDIM)
3300     CONTINUE
         DO 3330, K=VFIRST,VLAST          !and set line 3 to zero
            IV(K) = 0
3330     CONTINUE
C 
         IF (NY .LE. YDIM2) THEN
            DO 3400, K=1,XDIM
               IF (W(K+WOFF).GE.THR) IV(VFIRST+K) = 1
3400        CONTINUE
            WOFF = WOFF + XDIM
         ENDIF
C 
C  test, if we need more data
         IF (NY .LT. YDIM2) THEN
            IF (WOFF.GE.ACTSZ) THEN
               CALL STFGET(IMNO,FELEM,WSIZE,IAV,W,STAT)
               FELEM = FELEM + IAV
               ACTSZ = IAV
               WOFF = 0                     !reset pointer in data buffer
            ENDIF
         ENDIF
C 
         CALL STFPUT(IM2,FOUT,VDIM,IV,STAT)
         FOUT = FOUT + VDIM
C 
5000  CONTINUE
C 
      CALL STFPUT(IM2,FOUT,VDIM,IV(VDIM+1),STAT)   !last middle line
C 
      RETURN
      END

      SUBROUTINE ALICNT
C
C--------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER MADRID
      INTEGER KUN,KNUL,IMNOA,IMNOB
      INTEGER NAXISA,NAXISB,ACTVAL
      INTEGER N,SCPIX(3),FCPIX(3),DIFPIX
      INTEGER NPIXA(3),NPIXB(3),STATUS
C
      DOUBLE PRECISION STEPA(3),STEPB(3)
      DOUBLE PRECISION STARTA(3),STARTB(3),STARTC(3)
C
      CHARACTER*60   FRAMEA,FRAMEB
      CHARACTER      LINE*80
C
      COMMON /VMR/MADRID(1)
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      DATA   STARTC  /-1.D0,-1.D0,-1.D0/
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C  get son and father frame
C
      CALL STKRDC('IN_A',1,1,60,ACTVAL,FRAMEA,KUN,KNUL,STATUS)
      CALL STFOPN(FRAMEA,D_R4_FORMAT,0,F_IMA_TYPE,IMNOA,STATUS)
      CALL STDRDI(IMNOA,'NAXIS',1,1,ACTVAL,NAXISA,KUN,KNUL,STATUS)
      CALL STDRDI(IMNOA,'NPIX',1,NAXISA,ACTVAL,NPIXA,KUN,KNUL,STATUS)
      CALL STDRDD(IMNOA,'START',1,NAXISA,ACTVAL,STARTA,KUN,KNUL,STATUS)
      CALL STDRDD(IMNOA,'STEP',1,NAXISA,ACTVAL,STEPA,KUN,KNUL,STATUS)
C 
      CALL STKRDC('IN_B',1,1,60,ACTVAL,FRAMEB,KUN,KNUL,STATUS)
      CALL STFOPN(FRAMEB,D_R4_FORMAT,0,F_IMA_TYPE,IMNOB,STATUS)
      CALL STDRDI(IMNOB,'NAXIS',1,1,ACTVAL,NAXISB,KUN,KNUL,STATUS)
      IF (NAXISB .LT. NAXISA)
     +   CALL STETER(1,'Father must have at least dimension of son...')
C
      CALL STDRDI(IMNOB,'NPIX',1,NAXISB,ACTVAL,NPIXB,KUN,KNUL,STATUS)
      CALL STDRDD(IMNOB,'START',1,NAXISB,ACTVAL,STARTB,KUN,KNUL,STATUS)
      CALL STDRDD(IMNOB,'STEP',1,NAXISB,ACTVAL,STEPB,KUN,KNUL,STATUS)
C
C get center pixels of son
      CALL STKRDC('P3',1,1,80,ACTVAL,LINE,KUN,KNUL,STATUS)
      CALL EXTCO1(IMNOA,LINE,3,N,SCPIX,STATUS)
      IF (STATUS .NE. 0)
     +   CALL STETER(2,'invalid center coords of son...')
C
C get center pixels of father
      CALL STKRDC('P4',1,1,80,ACTVAL,LINE,KUN,KNUL,STATUS)
      CALL EXTCO1(IMNOB,LINE,3,N,FCPIX,STATUS)
      IF (STATUS .NE. 0)
     +   CALL STETER(2,'invalid center coords of father...')
C 
C  now calculate the relevant offsets
      DO 3000, N=1,NAXISA
         DIFPIX = FCPIX(N) - SCPIX(N)
         STARTC(N) = STARTB(N) + (DIFPIX * STEPB(N))
3000  CONTINUE
C 
C  show results
      IF (NAXISA.EQ.1) THEN
         WRITE(LINE,10000) STARTC(1)
      ELSE IF (NAXISA.EQ.2) THEN
         WRITE(LINE,10001) STARTC(1),STARTC(2)
      ELSE IF (NAXISA.GE.3) THEN
         WRITE(LINE,10002) STARTC(1),STARTC(2),STARTC(3)
      ENDIF
      CALL STTPUT(LINE,STATUS)
      CALL STKWRD('OUTPUTD',STARTC,1,3,KUN,STATUS)
C 
      RETURN
C 
10000 FORMAT('new start in x: ',G20.8)
10001 FORMAT('new start in x,y: ',2G20.8)
10002 FORMAT('new start in x,y,z: ',3G20.8)
C 
      END

      SUBROUTINE SUBSCL
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION:
C  subroutine SUBSCL		version 1.00	881028
C  K. Banse         		ESO - Garching
C
C.KEYWORDS:
C  scaling
C
C.PURPOSE:
C  Scale input image into given interval.
C
C.ALGORITHM:
C  Same as in WIMG + IPACK
C
C.INPUT/OUTPUT:
C  the following keywords are used:
C
C  IN_A/C/1/60			input image
C  OUT_A/C/1/60			output image
C  INPUTR/R/1/2			low,hi (inclusive) end of interval
C
C.VERSIONS
C  1.00 	from version 1.20 as of 870429
C  		use FORTRAN 77 + new ST interfaces
C
C-------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER     STAT,IAV,NAXIS,NPIX(3)
      INTEGER*8   PNTRA,PNTRB
      INTEGER     IMNOA,IMNOB,SIZE
      INTEGER     UNI(1),NULO,MADRID(1)
C
      CHARACTER   FRAMEA*60,FRAMEB*60
      CHARACTER   IDENT*72,CUNIT*64
C
      DOUBLE PRECISION START(3),STEP(3)
C
      REAL        RANGE,F,RIN(2),CUTS(4),RMAP
C
      COMMON   /VMR/  MADRID
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      DATA    IDENT /' '/,  CUNIT /' '/
C
C  get frames + scaling interval
      CALL STKRDC('IN_A',1,1,60,IAV,FRAMEA,UNI,NULO,STAT)
      CALL STKRDC('OUT_A',1,1,60,IAV,FRAMEB,UNI,NULO,STAT)
      CALL STKRDR('INPUTR',1,2,IAV,RIN,UNI,NULO,STAT)
C
C  map the frames
      CALL STIGET(FRAMEA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +            3,NAXIS,NPIX,START,STEP,IDENT,
     +            CUNIT,PNTRA,IMNOA,STAT)
      CALL STIPUT(FRAMEB,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +            NAXIS,NPIX,START,STEP,IDENT,
     +            CUNIT,PNTRB,IMNOB,STAT)
C
C  read cuts of input frame
      CALL STDRDR(IMNOA,'LHCUTS',1,4,IAV,CUTS,UNI,NULO,STAT)
      IF (CUTS(1).GE.CUTS(2)) THEN
         CUTS(1) = CUTS(3)
         CUTS(2) = CUTS(4)
         IF (CUTS(1).GE.CUTS(2))
     +      CALL STETER(1,'invalid cut values...')
      ENDIF
C
C  get dynamic range
      RMAP = RIN(2) - RIN(1)
      IF (RMAP.LE.10.E-25) CALL STETER(2,'invalid mapping interval...')
C
      RANGE = CUTS(2) - CUTS(1)
      IF (RANGE.LT.10.E-25) THEN
         F = 1.0
         CUTS(1) = 0.
      ELSE
         F = RMAP / RANGE
      ENDIF
C
C  now do it
      SIZE = NPIX(1) * NPIX(2) * NPIX(3)
      CALL SCALA(MADRID(PNTRA),MADRID(PNTRB),SIZE,F,CUTS,RIN)
C
C  modify cut values
      CUTS(1) = 0.
      CUTS(2) = 0.
      CUTS(3) = RIN(1)
      CUTS(4) = RIN(2)
      CALL STDWRR(IMNOB,'LHCUTS',CUTS,1,4,UNI,STAT)
C
C  That's it folks...
      RETURN
      END

      SUBROUTINE SCALA(A,B,NDIM,F,CUTS,RIN)
C
      IMPLICIT NONE
C
      INTEGER     NDIM
      INTEGER     N
C
      REAL        A(*),B(*),F,CUTS(4),RIN(2)
C
      DO 1000, N=1,NDIM
         IF (A(N).LE.CUTS(1)) THEN
            B(N) = RIN(1)
         ELSE IF (A(N).GE.CUTS(2)) THEN
            B(N) = RIN(2)
         ELSE
            B(N) = (F * (A(N) - CUTS(1)) ) + RIN(1)
         ENDIF
1000  CONTINUE
C
      RETURN
      END

      SUBROUTINE SUBWEI
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine SUBWEI		version 1.00	890123
C  K. Banse                  	ESO - Garching
C  1.10  910116
C
C.KEYWORDS
C  bulk data frames, statistical weights
C
C.PURPOSE
C  determine statistical weights for frames (e.g. for use in AVERAGE/WEIGHTS)
C
C.ALGORITHM
C  extract input frames either from given parameter string or from catalogue,
C  get mean + std. of "sky-field" of image frames, compute weights for all
C  frames by dividing each mean by max. mean, i.e. frame with max. sky
C  gets weight = 1.
C
C.INPUT/OUTPUT
C  the following keys are used:
C
C  P1/C/1/80		list of frames to be averaged or catalog
C  INPUTC/C/1/80	CURSOR or xsta,ysta,xend,yend of window
C
C.VERSIONS
C  1.00		created from version 3.00 as of 841121
C  		use FORTRAN 77 + new ST interfaces
C  1.10		make it work also for 1-dim frames and pixel coords.
C
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER     BEGIN
      INTEGER     FRMCNT,IAV,LL,N,M,STAT,ISEQ
      INTEGER     NAXIS,ITER,KODE,LEAP,ISTP,ILAST,MINP
      INTEGER     NPIX(2),IMNOA
      INTEGER*8   PNTRA
      INTEGER     APIX(2,2),NPNTS(5)
      INTEGER     PIXEL(2,2),SUBLO(2),SUBHI(2),SUBDIM
      INTEGER     UNI(1),NULO,MADRID(1)
C
      CHARACTER*60  FRAME(50)
      CHARACTER     CUNIT*20,IDENT*20,OUTPUT*80
      CHARACTER     LINE*80,CATFIL*60
      CHARACTER     ERROR1*60,ERROR2*50,ERROR3*40,ERROR4*40
      CHARACTER     ERROR5*40
C
      DOUBLE PRECISION STEP(2),START(2)
      DOUBLE PRECISION OSTART(2),OEND(2)
C
      REAL         DIF,W,BAGR(50),SIGM(50),BMAX
      REAL         BGVL(5),RMSV(5),COORDS(10)
C
      COMMON   /VMR/  MADRID
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      DATA    ERROR1   /'operands do not match in stepsize... '/
      DATA    ERROR2   /'operands do not overlap...'/
      DATA    ERROR3   /'stepsizes of different sign...'/
      DATA    ERROR4   /'catalog empty...'/
      DATA    ERROR5   /'more than 50 entries in catalog ...'/
      DATA    APIX     /4*1/,      BMAX  /-9.E10/
      DATA    SUBLO    /1,1/,      SUBHI /1,1/
      DATA    IDENT    /' '/,      CUNIT /' '/
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C  set up stuff for BGVAL
      KODE = 1
      MINP = 2
      ISTP = 0
      LEAP = 0
      ITER = 0
      ISEQ = 0
C
C  get necessary keys
      CALL STKRDC('P1',1,1,80,IAV,LINE,UNI,NULO,STAT)            !list of frames...
C
C  test, if we have list of frames or catalog
      LL = INDEX(LINE,'.cat')
      IF (LL.LE.0) THEN
         LL = INDEX(LINE,'.CAT')
         IF (LL.LE.0) GOTO 500                     !No. Treat list input...
      ENDIF
C
C  here we handle input from a catalog
C  get name of first image file in catalog
C
      CATFIL(1:) = LINE(1:)
      CALL STCGET(CATFIL,0,FRAME(1),OUTPUT,ISEQ,STAT)
      IF (FRAME(1)(1:1).EQ.' ')              !there must be at least 1 image ...
     +   CALL STETER(4,ERROR4)
C
C  now loop through catalogue
      DO 200, N=2,50                                !max. 50 frames
         CALL STCGET(CATFIL,0,FRAME(N),OUTPUT,ISEQ,STAT)
         IF (FRAME(N)(1:1).EQ.' ') THEN            !indicates the end ...
            FRMCNT = N - 1
            GOTO 1000
         ENDIF
200   CONTINUE
C
      CALL STCGET(CATFIL,0,LINE,OUTPUT,ISEQ,STAT)
      IF (LINE(1:1).NE.' ')
     +   CALL STTPUT
     +   ('Max. 50 frames are used, following frames ignored...',STAT)
      FRMCNT = 50
      GOTO 1000
C
C  here we handle input from single input line
C  pull out operands      (max. 50)
C
500   BEGIN = 1
      DO 800, N=1,50
         CALL EXTRSS(LINE,',',BEGIN,FRAME(N),LL)
         IF (LL.LE.0) THEN
            FRMCNT = N - 1
            GOTO 1000
         ELSE
            CALL CLNFRA(FRAME(N),FRAME(N),0)
         ENDIF
800   CONTINUE
      FRMCNT = 50
C
C  get cursor area
1000  CALL STKRDC('INPUTC',1,1,80,IAV,LINE,UNI,NULO,STAT)
      IF (LINE(1:1).EQ.'C') THEN
         CALL STKRDR('OUTPUTR',10,10,IAV,COORDS,UNI,NULO,STAT)
         OSTART(1) = COORDS(3) 
         OSTART(2) = COORDS(4)
         OEND(1) = COORDS(8)
         OEND(2) = COORDS(9)
         SUBDIM = 2
      ENDIF
C
C  now loop
      DO 3000, N=1,FRMCNT
         CALL STIGET(FRAME(N),D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +               2,NAXIS,NPIX,START,STEP,
     +               IDENT,CUNIT,PNTRA,IMNOA,STAT)
C 
C  if not cursor input, we have to get the window coords now
         IF ((N.EQ.1) .AND. (LINE(1:1).EQ.'[')) THEN
            M = INDEX(LINE,',')
            IF (NAXIS.GT.1) THEN
               IAV = INDEX(LINE(M+1:),',')
               M = IAV + M
            ENDIF
            IF (M.LE.1) CALL STETER(34,'Invalid coordinate string...')
            LINE(M:M) = ':'
            CALL EXTCOO(IMNOA,LINE,NAXIS,SUBDIM,SUBLO,SUBHI,STAT)
            PIXEL(1,1) = SUBLO(1)
            PIXEL(2,1) = SUBLO(2)
            PIXEL(1,2) = SUBHI(1)
            PIXEL(2,2) = SUBHI(2)
            OSTART(1) = START(1) + (PIXEL(1,1)-1) * STEP(1)
            OEND(1) = START(1) + (PIXEL(1,2)-1) * STEP(1)
            IF (SUBDIM.GT.1) THEN
               OSTART(2) = START(2) + (PIXEL(2,1)-1) * STEP(2)
               OEND(2) = START(2) + (PIXEL(2,2)-1) * STEP(2)
            ENDIF
         ENDIF
C
C  convert start + end of cursor region into pixel no.'s
         DIF = (OSTART(1)-START(1))/STEP(1)
         APIX(1,1) = INT(DIF) + 1                  !BGVAL wants xstart, xend
         DIF = (OEND(1)-START(1))/STEP(1)          !+ ystart, yend...!
         APIX(2,1) = INT(DIF) + 1
         IF (SUBDIM.GT.1) THEN
            DIF = (OSTART(2)-START(2))/STEP(2)
            APIX(1,2) = INT(DIF) + 1         
            DIF = (OEND(2)-START(2))/STEP(2)
            APIX(2,2) = INT(DIF) + 1
         ELSE
            APIX(1,2) = 1
            APIX(2,2) = 1
         ENDIF
C
C  and get background stuff
         CALL BGVAL(KODE,MADRID(PNTRA),NPIX(1),NPIX(2),APIX,ITER,
     +              MINP,LEAP,BGVL,RMSV,NPNTS,ISTP,ILAST)
         COORDS(1) = BGVL(1)              !store mean + sigma continuously...
         COORDS(2) = RMSV(1)
         BAGR(N) = BGVL(1)
         IF (BAGR(N).GT.BMAX) BMAX = BAGR(N)          !look for maximum...
         SIGM(N) = RMSV(1)
         IF (SIGM(N).LE.-1.0) THEN                    !check returned sigma
            OUTPUT(1:) = 'routine BGVAL failed on '//FRAME(N)
            CALL STETER(2,OUTPUT)
         ELSE
            LL = INDEX(FRAME(N),' ')
            IF (LL.LE.0) LL = LEN(FRAME(N))
            WRITE(OUTPUT,10001) FRAME(N)
            CALL STTPUT(OUTPUT,STAT)
            WRITE(OUTPUT,10002) COORDS(1),COORDS(2)
            CALL STTPUT(OUTPUT,STAT)
            CALL STDWRR(IMNOA,'FLAT_BKG',COORDS,1,2,UNI,STAT)   
         ENDIF
C
         CALL STFCLO(IMNOA,STAT)                      !and release input frame
3000  CONTINUE
C
C  now calculate weights and write them to descriptor WEIGHT
      DO 3300, N=1,FRMCNT
         W = BAGR(N)/BMAX
         CALL STFOPN(FRAME(N),D_OLD_FORMAT,0,F_IMA_TYPE,IMNOA,STAT)
         CALL STDWRR(IMNOA,'WEIGHT',W,1,1,UNI,STAT)
3300  CONTINUE
C
C  That's it folks...
      RETURN
C
10001 FORMAT('frame: ',A)
10002 FORMAT('mean, sigma of area = ',G12.6,', ',G12.6)
      END

      SUBROUTINE SUBRTG
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine SUBRTG		version 1.00	881028
C  K. Banse			ESO - Garching
C
C.KEYWORDS
C  artificial image
C
C.PURPOSE
C  rotate a 1-dim function around its start point to create a 2-dim image
C
C.ALGORITHM
C  rather straight forward
C
C.INPUT/OUTPUT
C  the following keys are used:
C
C  IN_A/C/1/60			input frame
C  INPUTI/I/1/1			EVEN/ODD (1/0) option
C  OUT_A/C/1/60			output frame
C  NULL/R/1/1			user defined "null value"
C	
C.VERSIONS
C  1.00		from version 1.30 as of 861211
C   		move to FORTAN 77 + new St interfaces
C	
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER     NAXIS
      INTEGER*8   PNTRA,PNTRC
      INTEGER     IMNOA,IMNOC
      INTEGER     STAT,IAV,EVEN
      INTEGER     NPIXA(3),NPIXC(3)
      INTEGER     UNI(1),NULO,MADRID(1)
C
      CHARACTER*60  FRAMEA,FRAMEC
      CHARACTER     CUNIT*48,IDENT*72
C
      REAL        RNULL
C
      DOUBLE PRECISION STEP(3),STARTA(3),STARTC(3)
C
      COMMON   /VMR/  MADRID
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C 
      DATA    IDENT  /' '/,  CUNIT  /' '/
C
C  get input frame + map it
      CALL STKRDC('IN_A',1,1,60,IAV,FRAMEA,UNI,NULO,STAT)
      CALL STIGET(FRAMEA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +            3,NAXIS,NPIXA,STARTA,STEP,
     +            IDENT,CUNIT,PNTRA,IMNOA,STAT)
C
C  make sure, it's a 1-dim frame...
      IF (NAXIS.GT.1)
     +   CALL STETER(1,'input should be 1-dim frame...')
C
C  get  EVEN  or  ODD  option      (variable EVEN = 1 or 0)
      CALL STKRDI('INPUTI',1,1,IAV,EVEN,UNI,NULO,STAT)
C
C  get output frame + check, that it's different from input frame
      CALL STKRDC('OUT_A',1,1,60,IAV,FRAMEC,UNI,NULO,STAT)
      IF (FRAMEA.EQ.FRAMEC) CALL STETER
     +   (2,'input and result frame have to be different...')
C
C  calculate new dimensions + map output file
      NPIXC(1) = (2 * NPIXA(1)) - 1 + EVEN
      NPIXC(2) = NPIXC(1)
      NPIXC(3) = 1
      NAXIS = 2
C
C  start pixel of 1-dim frame is at world coord. = 0.0
      STARTC(1) = STARTA(1) - ( (NPIXA(1) - 1 + EVEN) * STEP(1) )
      STARTC(2) = STARTC(1)
      STARTC(3) = 0.
C
      STEP(2) = STEP(1)
      STEP(3) = 1.
C
      CALL STIPUT(FRAMEC,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +            NAXIS,NPIXC,STARTC,STEP,
     +            IDENT,CUNIT,PNTRC,IMNOC,STAT)
C
C  now do it
      CALL STKRDR('NULL',1,1,IAV,RNULL,UNI,NULO,STAT)
      CALL DOROTA(MADRID(PNTRA),MADRID(PNTRC),NPIXA,NPIXC,EVEN,RNULL)
C
C  update descriptors + add history
      CALL DSCUPT(IMNOA,IMNOC,' ',STAT)
C
      RETURN
      END

      SUBROUTINE DOROTA(A,C,NPIXA,NPIXC,EVEN,RNULL)
C
      IMPLICIT NONE
C
      INTEGER     NPIXA,NPIXC,EVEN
      INTEGER     YOFF,YOFF2,NX,NY,I1,I2,NPX
C
      REAL        A(*),C(*),RNULL
      REAL        DX,DY,DY2,DIST,F
      REAL        SQRT
C
      YOFF = 0
      NPX = NPIXA - 1
C
C ***
C  loop over first  NPIXA - 1  lines
C ***
C
      DO 1000, NY=1,NPX
         DY = NY - NPIXA
         DY2 = DY * DY
C
C  only calculate for NPIXA-1 values
         DO 400, NX=1,NPX
            DX = NX - NPIXA
            DIST = SQRT( (DX*DX) + DY2 ) + 1.            !center pixel = 1 ...
C
C  interpolate function value at coord. DIST
            I1 = INT(DIST)
            IF (I1.LT.NPIXA) THEN
               I2 = I1 + 1
               F = A(I1) + ( (A(I2)-A(I1)) * (DIST-I1) )
            ELSE IF (I1.EQ.NPIXA) THEN
               F = A(I1)
            ELSE
               F = RNULL
            ENDIF
            C(YOFF+NX) = F
400      CONTINUE
C
C  points along center column ...
         DIST = ABS(NY-NPIXA) + 1.
         I1 = INT(DIST)
         I2 = I1 + 1
         F = A(I1) + ( (A(I2)-A(I1)) * (DIST-I1) )
         C(YOFF+NPIXA) = F
C
C  if EVEN flag is set, repeat center column value
         IF (EVEN.EQ.1) C(YOFF+NPIXA+1) = F
C
C  now the right half of each line
         YOFF2 = YOFF + NPIXA + EVEN
         DO 600, NX=1,NPIXA-1
            C(YOFF2+NX) = C(YOFF2-NX-EVEN)
600      CONTINUE
C
         YOFF = YOFF + NPIXC                       !update YOFF
1000  CONTINUE
C
C ***
C  build (upper) center line
C ***
C
      DO 1200, NX=1,NPIXA
         C(YOFF+NX) = A(NPIXA+1-NX)
1200  CONTINUE
C
C  if EVEN flag is set, repeat center column value
      IF (EVEN.EQ.1) C(YOFF+NPIXA+1) = A(1)
C
C  now the right half of this line
      YOFF2 = YOFF + NPIXA + EVEN
      DO 1400, NX=1,NPX
         C(YOFF2+NX) = C(YOFF2-NX-EVEN)
1400  CONTINUE
C
C  if EVEN option - repeat center line
      IF (EVEN.EQ.1) THEN
         YOFF2 = NPIXA * NPIXC                  !point to line (NPIXA+1)
         YOFF = NPX * NPIXC                        !point to line NPIXA
         DO 1600, NX=1,NPIXC
            C(YOFF2+NX) = C(YOFF+NX)
1600     CONTINUE
      ENDIF
C
C ***
C  now repeat lower half of result frame
C ***
C
      YOFF2 = (NPIXA+EVEN) * NPIXC
      YOFF = (NPIXA-2) * NPIXC
      DO 2000, NY=1,NPX
         DO 1800, NX=1,NPIXC
            C(YOFF2+NX) = C(YOFF+NX)
1800     CONTINUE
C
         YOFF2 = YOFF2 + NPIXC
         YOFF = YOFF - NPIXC
2000  CONTINUE
C
      RETURN
      END

      SUBROUTINE SUBROT
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine SUBROT		version 1.00	881028
C  K. Banse			ESO - Garching
C
C.KEYWORDS
C  pixels
C
C.PURPOSE
C  shift + rotate image around its start pixels by given angle
C
C.ALGORITHM
C  get the names of input + output frames from IN_A + OUT_B
C  get the new dimensions of output frame by rotating first the corner pixels
C  fill output frame with zeroes + rotate rest of input frame
C
C  copy descriptor LHCUTS to output frame to keep same colours at same pixels!
C
C.INPUT/OUTPUT
C  the following keywords are used:
C
C  IN_A/C/1/80			input frame
C  OUT_A/C/1/80			output frame
C  INPUTC			rotation angle in degrees,
C				coords. of rotation point (may be = C),
C				scaling factors of stepsizes of input frame
C				or
C				R1,2,3 + P1,2,3 for ROTA/CLOCK + ROTA/COUNT
C  IN_B                         reference frame or "+" if no refframe
C
C.VERSIONS
C  1.00   move to FORTRAN 77 + new interfaces
C         from version 2.40 as of 861029
C	
C 021212	last modif
C 
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      IAV,INTPOL,N,NAXISA
      INTEGER      IMNOA,IMNOB,IMNOC
      INTEGER*8    PNTRA,PNTRC,PNTRD
      INTEGER      NPIXA(3),NPIXB(3),STAT
      INTEGER      N1,NVAL,STRIPE(2),MAPSIZ
      INTEGER      NAXISC,ZOPT(2),CLONY
      INTEGER      UNI(1),NULO,MADRID(1)
C
      CHARACTER*80 FRAMEA,FRAMEB,FRAMEC,LINE
      CHARACTER    CUNITA*64,IDENTA*72,ACTION*2
C
      DOUBLE PRECISION STEPA(3),STARTA(3),STARTB(3),STEPB(3)
      DOUBLE PRECISION DVAL
      DOUBLE PRECISION DIN(4),DOUT(4)
C
      REAL         INPUTR(3),RNULL,RVAL
      REAL         ANGDEG,ANGLE,AC,AS,AA,X1,X2,X3,Y1,Y2,Y3
      REAL         PIXROT(2),ROTOFF(2),ST(2),EN(2),RST(2),FST(2)
      REAL         DIST,PIXSTP(2),QUOT,RQUOT,R1,R2,RROT(2)
      REAL         FACTO
C
      COMMON   /VMR/  MADRID
C
      INCLUDE  'MID_INCLUDE:ST_DEF.INC'
C
      DATA     FACTO  /0.0174533/               !  Pi / 180.
      DATA     INPUTR /1.0,1.0,0.0/
C
      INCLUDE  'MID_INCLUDE:ST_DAT.INC'
C
      ZOPT(1) = 0
      ZOPT(2) = 0
      INTPOL = 0
C
C  get input frame + map it
      CALL STKRDC('IN_A',1,1,80,IAV,FRAMEA,UNI,NULO,STAT)
      CALL STFOPN(FRAMEA,D_R4_FORMAT,0,F_IMA_TYPE,IMNOA,STAT)
      CALL STDRDI(IMNOA,'NAXIS',1,1,IAV,NAXISA,UNI,NULO,STAT)
      CALL STDRDI(IMNOA,'NPIX',1,2,IAV,NPIXA,UNI,NULO,STAT)
      CALL STDRDD(IMNOA,'START',1,2,IAV,STARTA,UNI,NULO,STAT)
      CALL STDRDD(IMNOA,'STEP',1,2,IAV,STEPA,UNI,NULO,STAT)
      CALL STDRDC(IMNOA,'CUNIT',1,1,64,IAV,CUNITA,UNI,NULO,STAT)
      CALL STDRDC(IMNOA,'IDENT',1,1,72,IAV,IDENTA,UNI,NULO,STAT)
      IF (NAXISA.EQ.1) THEN
         CALL STETER(1,'input frame must be at least 2-dim frame...')
      ELSE IF (NAXISA.GT.2) THEN
         NAXISA = 2                          !ignore higher dimensions...
         CALL STTPUT('only x-,y-plane will be processed...',STAT)
      ENDIF
      IF ((NPIXA(1).EQ.1) .OR. (NPIXA(2).EQ.1))
     +   CALL STETER(1,'We need a real 2-dim image ...')
C
C  init frame pixls  <->  world coords conversion
      CALL FPXWCO(0,IMNOA,DIN,DOUT,STAT)
C
C  get name of output frame + User Null
      CALL STKRDC('OUT_A',1,1,80,IAV,FRAMEB,UNI,NULO,STAT)
      CALL STKRDR('NULL',2,1,IAV,RNULL,UNI,NULO,STAT)
C 
C  check, that in, out_frame are different
      CALL GENEQF(FRAMEA,FRAMEB,IAV)
      IF (IAV.NE.0) 
     +   CALL STETER(9,'inframe and outframe are equal...')
C
C  get string with rotation angle + rot_coords + scaling factors
      CALL STKRDC('INPUTC',1,1,60,IAV,LINE,UNI,NULO,STAT)
C 
      IF (LINE(1:1).EQ.'R') THEN
         CALL GENCNV(LINE(2:),1,1,NVAL,RVAL,DVAL,N)
         IF (NVAL.EQ.3) THEN                     !90 degrees counter clockwise
            INTPOL = 1
            NPIXB(1) = NPIXA(2)
            NPIXB(2) = NPIXA(1)
            STEPB(1) = -STEPA(2)
            STEPB(2) = STEPA(1)
            DIN(1) = 1.0
            DIN(2) = NPIXA(2)
            CALL FPXWCO(1,IMNOA,DIN,DOUT,STAT)
            STARTB(1) = DOUT(2)                       !STARTB(1) = ENDA(2)
            STARTB(2) = DOUT(1)                       !STARTB(2) = STARTA(1)
C 
         ELSE IF(NVAL.EQ.2) THEN                 !180 degrees
            INTPOL = 2
            NPIXB(1) = NPIXA(1)
            NPIXB(2) = NPIXA(2)
            STEPB(1) = -STEPA(1)
            STEPB(2) = -STEPA(2)
            DIN(1) = NPIXA(1)
            DIN(2) = NPIXA(2)
            CALL FPXWCO(1,IMNOA,DIN,DOUT,STAT)
            STARTB(1) = DOUT(1)                       !STARTB(1) = ENDA(1)
            STARTB(2) = DOUT(2)                       !STARTB(2) = ENDA(2)
         ELSE                                    !270 degrees
            INTPOL = 3
            NPIXB(1) = NPIXA(2)
            NPIXB(2) = NPIXA(1)
            STEPB(1) = STEPA(2)
            STEPB(2) = -STEPA(1)
            DIN(1) = NPIXA(1)
            DIN(2) = 1
            CALL FPXWCO(1,IMNOA,DIN,DOUT,STAT)
            STARTB(1) = DOUT(2)                       !STARTB(1) = STARTA(2)
            STARTB(2) = DOUT(1)                       !STARTB(2) = ENDA(1)
         ENDIF
         GOTO 3000
      ENDIF
C 
      IAV = 1
      CALL EXTRSS(LINE,',',IAV,FRAMEC,N)
      IF (N.LE.0) THEN
         CALL STETER(2,'Invalid rotation angle ...')
      ELSE
         CALL GENCNV(FRAMEC,2,1,NVAL,ANGDEG,DVAL,N)
         IF (N.LT.1) THEN
            CALL STETER(2,'Invalid rotation angle ...')
         ELSE
            ANGLE = ANGDEG * FACTO          !convert from degrees to radians
         ENDIF
      ENDIF
      IF (LINE(IAV:IAV).EQ.'~') THEN
         N1 = (NPIXA(1) + 1) / 2                  !use center pixel
         PIXROT(1) = N1 - 1
         N1 = (NPIXA(2) + 1) / 2                  !use center pixel
         PIXROT(2) = N1 - 1
         GOTO 800
      ENDIF
C 
      CALL EXTRSS(LINE,',',IAV,FRAMEC,N)
      IF (N.LE.0) THEN
         CALL STETER(3,'Invalid coords. of rotation point ...')
      ELSE
         PIXROT(1) = -9.
         IF ((FRAMEC(1:1).EQ.'C').OR.(FRAMEC(1:1).EQ.'c')) THEN
            N1 = (NPIXA(1) + 1) / 2                  !use center pixel
            PIXROT(1) = N1 - 1
         ELSE IF (FRAMEC(1:1).EQ.'<') THEN
            PIXROT(1) = 0.
         ELSE IF (FRAMEC(1:1).EQ.'>') THEN
            PIXROT(1) = NPIXA(1) - 1.
         ELSE IF (FRAMEC(1:1).EQ.'@') THEN
            CALL GENCNV(FRAMEC(2:),1,1,NVAL,RVAL,DVAL,N)
            PIXROT(1) = NVAL - 1.
         ELSE
            CALL GENCNV(FRAMEC,4,1,NVAL,RVAL,DVAL,N)
            PIXROT(1) = (DVAL - STARTA(1)) / STEPA(1)
         ENDIF
      ENDIF
      CALL EXTRSS(LINE,',',IAV,FRAMEC,N)
      IF (N.LE.0) THEN
         CALL STETER(3,'Invalid coords. of rotation point ...')
      ELSE
         PIXROT(2) = -9.
         IF ((FRAMEC(1:1).EQ.'C').OR.(FRAMEC(1:1).EQ.'c')) THEN
            N1 = (NPIXA(2) + 1) / 2                  !use center pixel
            PIXROT(2) = N1 - 1
         ELSE IF (FRAMEC(1:1).EQ.'<') THEN
            PIXROT(2) = 0.
         ELSE IF (FRAMEC(1:1).EQ.'>') THEN
            PIXROT(2) = NPIXA(2) - 1.
         ELSE IF (FRAMEC(1:1).EQ.'@') THEN
            CALL GENCNV(FRAMEC(2:),1,1,NVAL,RVAL,DVAL,N)
            PIXROT(2) = NVAL - 1.
         ELSE
            CALL GENCNV(FRAMEC,4,1,NVAL,RVAL,DVAL,N)
            PIXROT(2) = (DVAL - STARTA(2)) / STEPA(2)
         ENDIF
      ENDIF
      IF ((PIXROT(1).LT.-0.00001) .OR.
     +    (PIXROT(2).LT.-0.00001)) 
     +   CALL STETER(3,'Invalid coords. of rotation point ...')
C 
      IF (LINE(IAV:IAV).NE.'~') THEN
         CALL GENCNV(LINE(IAV:),2,2,NVAL,INPUTR,DVAL,N)
         IF (N.LT.2) CALL STETER(4,'Invalid scale values ...')
      ENDIF
C 
800   AC = COS(ANGLE)
      AS = SIN(ANGLE)
      AA = MOD(ANGDEG,90.)                 !rotation by N*90 degrees ?
      IF (ABS(AA).LT.0.001) THEN
         IF (AS.LT.-0.1) THEN              !yes. no interpolation needed...
            INTPOL = 3                     !270 degree
            NPIXB(1) = NPIXA(2)
            NPIXB(2) = NPIXA(1)
         ELSE
            IF (AS.LT.0.1) THEN
             IF (AC.LT.-0.1) THEN
                INTPOL = 2                 !180 degrees
             ELSE
                INTPOL = 4                 !360 degrees
             ENDIF
               NPIXB(1) = NPIXA(1)
               NPIXB(2) = NPIXA(2)
            ELSE
             INTPOL = 1                    !90 degrees
               NPIXB(1) = NPIXA(2)
               NPIXB(2) = NPIXA(1)
            ENDIF
         ENDIF
      ENDIF
C
C  to get size of output frame, rotate corners around lower left corner
C  (assumed = 0,0)
C 
      R1 = NPIXA(1) - 1.
      R2 = NPIXA(2) - 1.
      CALL ROTO(R1,R2,AC,AS,X1,Y1)         !(NX-1,NY-1)
      CALL ROTO(0.,R2,AC,AS,X2,Y2)         !(0,NY-1)
      CALL ROTO(R1,0.,AC,AS,X3,Y3)         !(NX-1,0)
C
C  get result frame "corners"
      ST(1) = MIN(0.,X1,X2,X3)             !rotated x-start
      EN(1) = MAX(0.,X1,X2,X3)             !rotated x-end
      ST(2) = MIN(0.,Y1,Y2,Y3)             !rotated y-start
      EN(2) = MAX(0.,Y1,Y2,Y3)             !rotated y-end
C
C  check refframe option
      CALL STKRDC('IN_B',1,1,80,IAV,FRAMEC,UNI,NULO,STAT)
      IF (FRAMEC(1:1).NE.'+') THEN
C        check, if same as input frame (that happens...)
         CALL GENEQF(FRAMEC,FRAMEA,STAT)
         IF (STAT .NE. 0) THEN                          !yes.
            IMNOC = IMNOA
            NAXISC = NAXISA
            DO 900 N=1,NAXISC
               NPIXB(N) = NPIXA(N)
               STARTB(N) = STARTA(N)
               STEPB(N) = STEPA(N)
900         CONTINUE
         ELSE
            CALL STFOPN(FRAMEC,D_OLD_FORMAT,0,F_IMA_TYPE,IMNOC,STAT)
            CALL STDRDI(IMNOC,'NAXIS',1,1,IAV,NAXISC,UNI,NULO,STAT)
            CALL STDRDI(IMNOC,'NPIX',1,3,IAV,NPIXB,UNI,NULO,STAT)
            IF (NAXISC.GT.2) NAXISC = 2
            CALL STDRDD(IMNOC,'START',1,2,IAV,STARTB,UNI,NULO,STAT)
            CALL STDRDD(IMNOC,'STEP',1,2,IAV,STEPB,UNI,NULO,STAT)
         ENDIF
         ACTION(2:2) = 'F'
      ELSE
         ACTION(2:2) = 'Q'
      ENDIF
C
C  from coords. of rotation point determine shift after rotation
      QUOT = 1. - AC
      ROTOFF(1) = PIXROT(1)*QUOT + PIXROT(2)*AS
      ROTOFF(2) = PIXROT(2)*QUOT - PIXROT(1)*AS
C
C  choose sample start in 0,0 pixel space according to option
C
      IF (ACTION(2:2).EQ.'F') THEN
         DO 1000, N=1,2
            PIXSTP(N) = STEPB(N) / STEPA(N)
            FST(N) = (STARTB(N) - STARTA(N)) / STEPA(N) 
            ST(N) = FST(N) - ROTOFF(N)
            EN(N) = ST(N) + ( (NPIXB(N) - 1) * PIXSTP(N) )
1000     CONTINUE
      ELSE
         DO 1500, N=1,2
            PIXSTP(N) = INPUTR(N)
            STEPB(N) = STEPA(N) * PIXSTP(N)
C
C  test, if we want to rotate around a "sample" point or not
            QUOT = PIXROT(N) / PIXSTP(N)
            RQUOT = FLOAT(INT(QUOT))
            DIST = ABS(PIXROT(N) - RQUOT*PIXSTP(N))
            IF (DIST.LE.(0.001*PIXSTP(N))) ZOPT(N) = 1
1500     CONTINUE
C
C  choose corners such, that rotation point is hit ...
         N1 = ZOPT(1) * ZOPT(2)
         IF ( (INTPOL.EQ.0) .AND. (N1.EQ.1) ) THEN
            CALL ROTO(PIXROT(1),PIXROT(2),AC,AS,RROT(1),RROT(2))
            DO 2000, N=1,2
               DIST =            !distance of fixed point to rotation point
     +          RROT(N) - ST(N)  
               QUOT = DIST / PIXSTP(N)            !is forced to
               RQUOT = FLOAT(INT(QUOT)) + 1.            !multiples of steps
               DIST = RQUOT * PIXSTP(N)
               ST(N) = RROT(N) - DIST
               DIST = EN(N) - ST(N)         !distance of start to end point
               QUOT = DIST / PIXSTP(N)            !is forced to
               RQUOT = FLOAT(INT(QUOT)) + 1.            !multiples of steps
               EN(N) = ST(N) + (RQUOT*PIXSTP(N))
               NPIXB(N) = NINT(RQUOT) + 1      !no. of points in new image
2000        CONTINUE
         ELSE
            NPIXB(1) = NINT( (EN(1) - ST(1))/PIXSTP(1) ) + 1
            NPIXB(2) = NINT( (EN(2) - ST(2))/PIXSTP(2) ) + 1
         ENDIF
C
C  now update start of rotated image, so that rotation point stays fixed
         RST(1) = ST(1) + ROTOFF(1)
         RST(2) = ST(2) + ROTOFF(2)
         STARTB(1) = STARTA(1) + ( RST(1)*STEPA(1) )      !we work in 0,0 space
         STARTB(2) = STARTA(2) + ( RST(2)*STEPA(2) )
      ENDIF
C
C  and map it...
3000  N = NPIXB(1)*NPIXB(2)
      CALL GENBLD(IMNOA,FRAMEB,D_R4_FORMAT,N,IMNOB,CLONY,STAT)
      CALL STDWRI(IMNOB,'NAXIS',NAXISA,1,1,UNI,STAT)
      CALL STDWRI(IMNOB,'NPIX',NPIXB,1,NAXISA,UNI,STAT)
      CALL STDWRD(IMNOB,'START',STARTB,1,NAXISA,UNI,STAT)
      CALL STDWRD(IMNOB,'STEP',STEPB,1,NAXISA,UNI,STAT)
C 
      CALL STKRDI('MONITPAR',20,1,IAV,MAPSIZ,UNI,NULO,STAT)
      MAPSIZ = MAPSIZ * MAPSIZ                  !square frame ...
      IF (INTPOL.EQ.0) THEN
         N = NPIXA(1) * NPIXA(2)
         CALL STFMAP(IMNOA,F_I_MODE,1,N,IAV,PNTRA,STAT)
C
C  for output buffer aim at size of the `mapsize frame'
         STRIPE(2) = MAPSIZ / NPIXB(1)
         IF (NPIXB(2).LT.STRIPE(2)) STRIPE(2) = NPIXB(2)
         N = NPIXB(1)*STRIPE(2)                !size of output strip
         CALL STFXMP(N,D_R4_FORMAT,PNTRD,STAT)
C 
         INPUTR(1) = AC
         INPUTR(2) = AS
         INPUTR(3) = RNULL
         CALL ROTAIT(MADRID(PNTRA),MADRID(PNTRD),IMNOB,STRIPE(2),
     +               NPIXA,NPIXB,ST,PIXSTP,INPUTR)
      ELSE                                        !test, if direct disk I/O
C 
C  for each buffer aim at size of the `mapsize frame'
         STRIPE(1) = MAPSIZ / NPIXA(1)
         IF (NPIXA(2).LT.STRIPE(1)) STRIPE(1) = NPIXA(2)
         N = NPIXA(1)*STRIPE(1)                    !size of input strip
         CALL STFXMP(N,D_R4_FORMAT,PNTRC,STAT)
         STRIPE(2) = MAPSIZ / NPIXA(2)
         IF (NPIXA(1).LT.STRIPE(2)) STRIPE(2) = NPIXA(1)
         N = NPIXA(2)*STRIPE(2)                    !size of output strip
         CALL STFXMP(N,D_R4_FORMAT,PNTRD,STAT)
C 
         CALL ROTM90(INTPOL,MADRID(PNTRC),MADRID(PNTRD),
     +               IMNOA,IMNOB,NPIXA,STRIPE)
      ENDIF
C
C  copy descriptors + LHCUTS
      IF (CLONY.EQ.0) THEN
         CALL DSCUPT(IMNOA,IMNOB,' ',STAT)
      ELSE
         CALL DSCUPT(IMNOB,IMNOB,' ',STAT)          !only update history
      ENDIF
      CALL STDCOP(IMNOA,IMNOB,4,'LHCUTS',STAT)
C
      RETURN
C
      END

      SUBROUTINE ROTO(X,Y,AC,AS,XOUT,YOUT)
C
      IMPLICIT NONE
C
      REAL     X,Y,AC,AS,XOUT,YOUT
C
      XOUT = X*AC - Y*AS
      YOUT = X*AS + Y*AC
C
      RETURN
      END

      SUBROUTINE ROTAIT(A,B,IMNOB,STRIPB,NPIXA,NPIXB,
     +                  START,STEP,WORK)
C
C  K. Banse            861029, 880902, 910204, 920306
C
C  do "backward" rotation, i.e. solve the system XROT = X*AC - Y*AS
C                                       YROT = X*AS + Y*AC for X,Y
C  to yield X = XROT*AC + YROT*AS
C          Y = YROT*AC - XROT*AS  which takes AC**2 + AS**2 = 1 into account....
C
      IMPLICIT NONE
C
      INTEGER      IMNOB,STRIPB
      INTEGER      NPIXA(2),NPIXB(2)
      INTEGER      INDXB,KSTX,KX,KY
      INTEGER      INOFF,DATOUT,KSIZE,YLIN
      INTEGER      NO1,NO2,NO3,NO4,STAT
      INTEGER      NX,NY,SIZEA,XDIMA,YDIMA
C
      REAL         A(*),B(*)
      REAL         WORK(3),AC,AS,ZNULL
      REAL         XT,YT,XFRAC,YFRAC,XLAST,YLAST
      REAL         START(2),STEP(2)
      REAL         XF,XSTEP,YSTEP,RX,RY,RYAS,RYAC
C
C  init
      AC = WORK(1)
      AS = WORK(2)
      ZNULL = WORK(3)
      XF = START(1)
      XSTEP = STEP(1)
      YSTEP = STEP(2)
      XDIMA = NPIXA(1)
      YDIMA = NPIXA(2)
      XLAST = XDIMA - 1.
      YLAST = YDIMA - 1.
      SIZEA = XDIMA * YDIMA
      DATOUT = 1
      YLIN = STRIPB
      INOFF = 0
      RY = START(2)                        !init RY to start-y
C 
C 
400   IF ((INOFF+YLIN).GT.NPIXB(2)) YLIN = NPIXB(2) - INOFF
      INDXB = 0
C 
C  loop through result lines
      DO 3000, NY=1,YLIN
C
         RX = XF                           !init RX to start-x
         RYAS = RY * AS
         RYAC = RY * AC
C
         DO 1000, NX=1,NPIXB(1)
            INDXB = INDXB + 1              !loop along result line
            XT = RX*AC + RYAS
            IF ((XT.LT.0.).OR.(XT.GT.XLAST)) THEN
               B(INDXB) = ZNULL
               GOTO 555
            ENDIF
            YT = RYAC - RX*AS
            IF ((YT.LT.0.).OR.(YT.GT.YLAST)) THEN
               B(INDXB) = ZNULL
               GOTO 555
            ENDIF
C
C  interpolate...
            XT = XT + 1.                  !adjust 0,0 to 1,1 ...
            YT = YT + 1.
            KX = INT(XT)
            KY = INT(YT)
            XFRAC = XT - KX
            YFRAC = YT - KY
            KSTX = XDIMA*(KY-1)            !get 1. pixel in this line - 1
            NO1 = KX + KSTX                !get pixel close to integer part of real pixel
C
            NO2 = NO1 + 1                  !get next pixel in x-direction
            IF (NO2-KSTX.GT.XDIMA) THEN    !are we out of grid in x?
               IF (NO2.GT.SIZEA) THEN      !also out in y?
                  B(INDXB) = A(NO1)        !yes.
               ELSE
                  NO3 = NO1 + XDIMA        !no.
C>                pixel = A(NO1)*(1.-YFRAC) + A(NO3)*YFRAC            <C
                  B(INDXB) = A(NO1) + ( YFRAC * (A(NO3) - A(NO1)) )
               ENDIF
               GOTO 555
            ENDIF
C
            NO3 = NO1 + XDIMA               !get low pixel in next line up
            IF (NO3.GT.SIZEA) THEN          !are we out of grid in y?
C>             pixel = A(NO1)*(1.-XFRAC) + A(NO2)*YFRAC               <C
               B(INDXB) = A(NO1) + ( XFRAC * (A(NO2) - A(NO1)) )
               GOTO 555
            ENDIF
C
            NO4 = NO3 + 1
C>          pixel = ( A(NO1)*(1.-XFRAC) + A(NO2)*XFRAC ) * (1.-YFRAC) <C
C> +              + ( A(NO3)*(1.-XFRAC) + A(NO4)*XFRAC ) * YFRAC      <C
            B(INDXB) = A(NO1) +
     +        XFRAC * (A(NO2) - A(NO1)) +
     +        YFRAC * (A(NO3) - A(NO1)) +
     +        XFRAC * YFRAC * (A(NO1) - A(NO2) - A(NO3) + A(NO4))
C
555         RX = RX + XSTEP                     !move to next x-coord
1000     CONTINUE
C
         RY = RY + YSTEP                        !move to next y-coord.
3000  CONTINUE
C 
      KSIZE = YLIN * NPIXB(1)
      CALL STFPUT(IMNOB,DATOUT,KSIZE,B,STAT)
      DATOUT = DATOUT + KSIZE
      INOFF = INOFF + YLIN
      IF (INOFF.LT.NPIXB(2)) GOTO 400           !get next chunk
C 
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2008 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM STATIS
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: K.Banse
C
C.IDENTIFICATION
C  program STATIS	1.00	881028
C  K. Banse                    	ESO - Garching
C
C.KEYWORDS
C  maximum, minimum,mean value, std. dev., histogram
C
C.PURPOSE
C  calculate statistics of given bulk data frame
C
C.ALGORITHM
C  prepare input for options: COLUMN, ROW, TABLE, CURSOR 
C  do the actual calculations in subroutine ZMSTAT 
C  (former main program STATIST)
C
C.INPUT/OUTPUT
C  the following keys are used for I/O:
C
C  IN_A/C/1/120		input frame
C  P2/C/1/120           subframe area [...:...]
C           		+ for complete frame
C			ROW to work on rows of 2-dim frame
C			COLUMN to work on columns of 2-dim frame
C			PLANE to work on planes of 3-dim frame
C			table_name for table input
C			CURSOR for cursor defined subimages
C  DEFAULT/C/1/6	(1) = N, subarea is specified in P2
C                           = M, subareas are specified in P2 
C				 but merge them all together and do the
C				 statistics on that set
C			    = Y, use complete frame
C    			(2) = N, binsize is given in INPUTR(1)
C                           = Y, total no. of bins is given in INPUTR(1)
C			(3,4) = option as defined in command STATIST
C			(5) = Y/N, draw option for rectangles, only used 
C			      for CURSOR above
C    			(6) = P/N, for plotting histogram or not
C  OUT_A/C/1/120	for P2 = ROW, COLUMN, table_name or CURSOR
C			this holds the output_table, append_flag
C
C  OUTPUTR/R/1/12	will receive: Min,Max,Mean,Std,3rdMom,4thMom,Intensity
C                  	and Median,SmallestMode,Nobins,Binsize,Mode
C  OUTPUTI/I/1/7	(1) = no. valid of pixels in window
C               	(2,3,4) = window start pixels, set to 0, if not applic.
C               	(5,6,7) = window end pixels, set to 0, if not applic.
C
C.VERSIONS
C 080730		last modif
C
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      IAV,STAT,N,NLOOP,CURMAX
      INTEGER      ST1,ST2,XY1(2),XY2(2),COOS(4)
      INTEGER      NPIX(3),NAXPIX(4),NMAL,NROW,NCOL1,SIZ(2)
      INTEGER*8    PNTRA,PNTRB,PNTRO
      INTEGER      SPIX(3),EPIX(3)
      INTEGER      TCOLNM(16),ICOLNM(6)
      INTEGER      IACTIO,COOFF,TBAPP
      INTEGER      TABNUL(6)
      INTEGER      UNI(1),NULO,MADRID(1)
      INTEGER      IMNO,IMNOB,IMNOC,INTID,OUTID,OUTNO
      INTEGER      INCOL,KBUF(25)
      INTEGER      NPXO(2),EXAMED
      INTEGER      EC,ED,EL
C
      DOUBLE PRECISION START(3),STEP(3),DVAL
      DOUBLE PRECISION STRTO(2),STPO(2)
      DOUBLE PRECISION DD1(4),DD2(4)
C 
      REAL         RVAL(16),XMEDIA,ZBINS(3)
C
      CHARACTER    ORFILE*120,INTABL*120,OUTTBL*120,OUTFRA*120
      CHARACTER    AREA*120,DEFAUL*6,OUTPUT*120,CCBUF*40
      CHARACTER    OPTION*5,FRMSTR*20,HISTORY*160
      CHARACTER    TABUNT*16,TABLAB(12)*16,CACT*8
      CHARACTER    INTLAB(6)*16
      CHARACTER    IDENT*72,CUNIT*64,MIDUNI*2,TMPFIL*14
C 
      LOGICAL      SELFLG
C 
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C 
      INCLUDE 'MID_INCLUDE:IDIDEV.INC'
      INCLUDE 'MID_INCLUDE:IDIMEM.INC'
C 
      COMMON  /VMR/ MADRID
      COMMON  /PLOTTO/  IDENT,CUNIT
C
      DATA      COOS     /-1,-1,-1,-1/
      DATA      RVAL     /16*0.0/
      DATA      TABUNT   /' '/
      DATA      TABLAB   /'MIN ','MAX ','MEAN ','STD ',
     +                    'MOM3 ','MOM4 ','TOT_INTENS',
     +                    'MEDIAN ','SMAL_MODE ',
     +                    'NO_BINS ','BIN_SIZE ', 'MODE '/
      DATA      INTLAB   /'XSTART ','YSTART ','XEND ','YEND ',
     +                    'ZSTART ','ZEND '/
      DATA      AREA     /' '/
      DATA      IDENT    /' '/, CUNIT /' '/
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C 
C  init MIDAS environment + get current MIDAS unit
C
      CALL STSPRO('STATIST')
      CALL STPSET(F_FITS_PARM,1,STAT)              !ignore ESO.xyz FITS keywds
      CALL STKWRR('OUTPUTR',RVAL,1,14,UNI,STAT)    !clear keyword OUTPUTR
      CALL STKRDC('MID$SESS',1,11,2,IAV,MIDUNI,UNI,NULO,STAT)
      TMPFIL = 'stat'//MIDUNI//'dum.bdf '
C 
      DO 500, N=1,3
         NPIX(N) = 1
         SPIX(N) = 1
         EPIX(N) = 1
         START(N) = 0.D0
         STEP(N) = 1.D0
500   CONTINUE
      OUTID = -999                     !indicate that no output table/image
      OUTNO = -999                     !indicate that no output image/image
      INTID = -1
      FRMSTR(1:) = ' '
      EXAMED = 0
      IACTIO = -1
      KBUF(1) = -1                     !indicates an invalid row/column/plane
C
C  get info about histogram bins + the different options + format string
C 
      CALL STKRDC('DEFAULT',1,1,6,IAV,DEFAUL,UNI,NULO,STAT)
      CALL UPCAS(DEFAUL,DEFAUL)
      OPTION(1:4) = DEFAUL(1:4)
      OUTPUT(1:) = ' '
      CALL STKRDC('P3',1,1,20,IAV,OUTPUT,UNI,NULO,STAT)
      IF (OUTPUT(1:1) .EQ. '#') THEN
         OPTION(2:2) = 'Y'
         CALL GENCNV(OUTPUT(2:),2,1,ICOLNM,ZBINS,DVAL,IAV)
         IF (IAV .NE. 1) CALL STETER(34,'Invalid no. of bins...')
      ELSE
         OPTION(2:2) = 'N'
         CALL GENCNV(OUTPUT(1:),2,1,ICOLNM,ZBINS,DVAL,IAV)
         IF (IAV .NE. 1) CALL STETER(34,'Invalid binsize...')
      ENDIF
      OUTPUT(1:) = ' '
      CALL STKRDC('P4',1,1,120,IAV,OUTPUT,UNI,NULO,STAT)
      CALL GENCNV(OUTPUT,2,2,ICOLNM,ZBINS(2),DVAL,IAV)
      IF (IAV .NE. 2) CALL STETER(35,'Invalid excess bins...')
      CALL STKRDC('P8',1,1,20,IAV,FRMSTR,UNI,NULO,STAT)
C 
C  get name of frame to process + open it + get stand. descr.
C 
      CALL STKRDC('IN_A',1,1,120,IAV,ORFILE,UNI,NULO,STAT)
      IAV = -1
      N = INDEX(ORFILE,'[')
      IF (N .LE. 0) THEN
         N = INDEX(ORFILE,',')
         IF (N .GT. 0) THEN
            N = N + 1
            IF (ORFILE(N:N) .EQ. '#') THEN
               IAV = 0
            ELSE IF (ORFILE(N:N) .EQ. ':') THEN
               IAV = 1
            ENDIF
         ENDIF
      ENDIF
C 
C  check, if this is the table,column input option
      IF (IAV .NE. -1) THEN                !Yes, table column option
         OUTPUT(1:) = ORFILE(N:)           !get column spec
         ORFILE(N-1:) = '            '     !isolate the table name
C 
         IF (IAV.EQ.1) THEN			!look for the given column
            CALL TBTOPN(ORFILE,F_I_MODE,TID,STAT)
            CALL TBLSER(TID,OUTPUT(2:16),ICOLNM(1),STAT)  
            IF (ICOLNM(1).EQ.-1) 
     +         CALL STETER(31,'bad table column label...')
            CALL TBTCLO(TID,STAT)
         ELSE  					!convert no.
            CALL GENCNV(OUTPUT(2:16),1,1,ICOLNM(1),ZBINS,DVAL,IAV) 
            IF (IAV .LT. 1)
     +         CALL STETER(31,'bad table column no....')
         ENDIF
C                                           !store tmp name in OUT_B
         CALL STKWRC('OUT_B',1,'tcol2ima.bdf   ',1,15,UNI,STAT)
         CALL TCOLIM(ORFILE,OUTPUT(1:16),ICOLNM(1),STAT)
         IF (STAT.NE.0) CALL STETER(32,
     +           'problems creating temp. image from table column...')
         ORFILE(1:) = 'tcol2ima.bdf'//' '
         IACTIO = 9
      ENDIF
C
      CALL STFOPN(ORFILE,D_R4_FORMAT,0,F_IMA_TYPE,IMNO,STAT)
      CALL STDRDI(IMNO,'NAXIS',1,1,IAV,NAXPIX,UNI,NULO,STAT)
      IF (NAXPIX(1).GT.3) THEN
         CALL STTPUT('Warning: only 3 dims of frame processed ...',
     +               STAT)
         NAXPIX(1) = 3
      ENDIF
      CALL FPXWCO(0,IMNO,DD1,DD2,STAT)
      IF (STAT .GT. 0) CALL STETER(36,'Problems with WCS of frame...')
C 
      CALL STDRDI(IMNO,'NPIX',1,NAXPIX(1),IAV,NPIX,UNI,NULO,STAT)
      CALL STDRDD(IMNO,'START',1,NAXPIX(1),IAV,START,UNI,NULO,STAT)
      CALL STDRDD(IMNO,'STEP',1,NAXPIX(1),IAV,STEP,UNI,NULO,STAT)
      IAV = 1
      DO 550, N=1,3
         NAXPIX(N+1) = NPIX(N)
         IAV = IAV * NPIX(N)
550   CONTINUE
      ICOLNM(1) = IMNO                          !use ICOLNM as buffer
      CALL STFINF(ORFILE,-4,ICOLNM,STAT)        !ICOLNM(4) = real no. of pixels
      IF ((IAV .GT. ICOLNM(4)).AND.(ICOLNM(3).NE.1))
     +   CALL STETER(37,'reference file with no data...')
C 
      IF (DEFAUL(6:6).EQ.'P') THEN
         IF (INDEX(DEFAUL(3:3),'RXSM') .GT. 0) THEN
            CALL STTPUT
     +      ('No histogram plotting possible for reduced statistics...',
     +       STAT)
            DEFAUL(6:6) = 'N'
         ELSE
            CALL STDRDC(IMNO,'IDENT',1,1,72,IAV,IDENT,UNI,NULO,STAT)
            N = (NAXPIX(1)+1) * 16
            CALL STDRDC(IMNO,'CUNIT',1,1,N,IAV,CUNIT,UNI,NULO,STAT)
         ENDIF
      ENDIF
C 
      IF ((OPTION(3:3).EQ.'G').OR.(OPTION(3:3).EQ.'X')
     +    .OR. (OPTION(3:3).EQ.'W')) THEN
         EXAMED = 1
      ENDIF
C 
C *********************
C
C  test the options: full frame, subframes, intervals,
C                    ROW, COLUMN, PLANE, CURSOR or table
C 
C  IACTIO specifies the different area options:
C    = 0, full frame; 
C    = 1, table;   = 2, rows;   = 3, columns;   = 4, cursor;   = 5, planes; 
C    = 6, subframe;   = 7, covering intervals	= 9, column of table
C 
C *********************
C 
      CALL STKRDC('P2',1,1,120,IAV,OUTPUT,UNI,NULO,STAT)
      OPTION(5:5) = 'N' 
      IF ( (DEFAUL(6:6).EQ.'P') .OR. (DEFAUL(1:1).EQ.'M') ) THEN
         OPTION(5:5) = 'H'             !we also have to fill descr. HISTOGRAM
      ENDIF
      INTABL(1:) = ' '
      CALL UPCAS(OUTPUT,AREA)
C
C  complete frame
C
      IF (DEFAUL(1:1).EQ.'Y') THEN
         IF (IACTIO .NE. 9) IACTIO = 0
         GOTO 1111
      ENDIF
C
C  area option = [...
C 
      IF (OUTPUT(1:1).EQ.'[') THEN
         N = INDEX(ORFILE,']')
         IF (N .GT. 0) THEN
            IAV = LEN(ORFILE)
            IF ((N .EQ. IAV) .OR. (ORFILE(N+1:N+1) .EQ. ' '))
     +         CALL STETER(33,'double subframe option not supported...')
         ENDIF
C
C  test, if subframe or interval option
         N = INDEX(OUTPUT,':')
         IF (N.GT.1) THEN    
            IACTIO = 6                          !for subframe(s)
         ELSE
C 
C  covering intervals 
C 
            IACTIO = 7 
            N = INDEX(AREA,'X')                    !look for 123x456
            IF (N.LT.3) THEN
               N = INDEX(AREA,'*')                 !or for 123*456
               IF (N.LT.3) 
     +            CALL STETER(2,'invalid interval option...')
            ENDIF
            AREA(N:N) = ','
            NMAL = INDEX(AREA,']')
            AREA(NMAL:NMAL) = ','
            CALL GENCNV(AREA(2:),1,2,SIZ,RVAL,DVAL,IAV)
            IF (IAV .NE. 2) 
     +         CALL STETER(34,'Invalid x/ysize of intervals...')
            IF (NPIX(3).GT.1) CALL STTPUT
     +      ('Only 1. plane of 3-dim frame will be processed...',STAT)
            NMAL = (NPIX(1)-1)/SIZ(1) + 1
            NROW = (NPIX(2)-1)/SIZ(2) + 1
         ENDIF
         GOTO 1111
      ENDIF
C 
C  rows
C 
      IF (AREA(1:3).EQ.'ROW') THEN
         IF (AREA(4:4).EQ.' ') THEN
            NROW = NPIX(2)
         ELSE IF (AREA(4:4).EQ.',') THEN
            CALL GENCNV(AREA(5:),1,25,KBUF,RVAL,DVAL,NROW)
            IF (NROW .LT. 1) CALL STETER(34,'Invalid row no.')
            DO 900,N=1,NROW
               IF ((KBUF(N).LT.1).OR.(KBUF(N).GT.NPIX(2)))
     +             CALL STETER(34,'Invalid row no...')
900         CONTINUE
         ELSE
            GOTO 999                         !table name starting with ROW..
         ENDIF
         IACTIO = 2
         IF (NPIX(3).GT.1) CALL STTPUT
     +      ('Only 1. plane of 3-dim frame will be processed...',STAT)
         GOTO 1111
      ENDIF
C 
C  planes
C 
      IF (AREA(1:5).EQ.'PLANE') THEN
         IF (AREA(6:6).EQ.' ') THEN
            NROW = NPIX(3)
         ELSE IF (AREA(6:6).EQ.',') THEN
            CALL GENCNV(AREA(7:),1,25,KBUF,RVAL,DVAL,NROW)
            IF (NROW .LT. 1) CALL STETER(34,'Invalid plane no.')
            DO 930,N=1,NROW
               IF ((KBUF(N).LT.1).OR.(KBUF(N).GT.NPIX(3)))
     +             CALL STETER(34,'Invalid plane no...')
930         CONTINUE
         ELSE
            GOTO 999                         !table name starting with PLANE..
         ENDIF
         IACTIO = 5
         IF (NPIX(3).EQ.1) THEN
            CALL STTPUT
     +      ('Single plane of 2-dim frame will be processed...',STAT)
            NROW = 1
         ENDIF
         GOTO 1111
      ENDIF
C 
C  columns
C 
      IF (AREA(1:6).EQ.'COLUMN') THEN
         IF (AREA(7:7).EQ.' ') THEN
            NROW = NPIX(1)
         ELSE IF (AREA(7:7).EQ.',') THEN
            CALL GENCNV(AREA(8:),1,25,KBUF,RVAL,DVAL,NROW)
            IF (NROW .LT. 1) CALL STETER(34,'Invalid column no.')
            DO 960,N=1,NROW
               IF ((KBUF(N).LT.1).OR.(KBUF(N).GT.NPIX(1)))
     +             CALL STETER(34,'Invalid column no...')
960         CONTINUE
         ELSE
            GOTO 999                         !table name starting with COLUMN..
         ENDIF
         IACTIO = 3
         IF (NPIX(1).EQ.1) 
     +      CALL STETER(34,'Invalid option: 1-dim input frame...')
         IF (NPIX(3).GT.1) CALL STTPUT
     +      ('Only 1. plane of 3-dim frame will be processed...',STAT)
         GOTO 1111
      ENDIF
C 
C  cursor input
C 
      IF ((AREA(1:7).EQ.'CURSOR ') .OR.
     +         (AREA(1:7).EQ.'CURSOR,')) THEN
         IACTIO = 4
         IF (AREA(7:7) .EQ. ',') THEN
            CALL GENCNV(AREA(8:),1,1,CURMAX,RVAL,DVAL,IAV)
            IF ((IAV.LT.1) .OR. (CURMAX.LT.1))
     +         CALL STETER(2,'Invalid no. for max. cursor input...')
            NROW = CURMAX
         ELSE
            CURMAX = 99999
            NROW = 100
         ENDIF
         GOTO 1111
      ENDIF
C 
C  everything else is interpreted as a table name
C 
999   IACTIO = 1                                !indicate table input
      CALL CLNTAB(OUTPUT,INTABL,0)
      CALL TBTOPN(INTABL,F_I_MODE,INTID,STAT)
C
C  get number of rows we'll work on + look for the required columns
      CALL TBIGET(INTID,N,NROW,N,N,N,STAT)
      DO 1000,N=1,4
         CALL TBLSER(INTID,INTLAB(N),ICOLNM(N),STAT)
         IF (ICOLNM(N).LE.0) THEN
            ST1 = INDEX(INTABL,' ')
            IF (ST1.LE.0) ST1 = LEN(INTABL)
            ST2 = INDEX(INTLAB(N),' ')
            IF (ST2.LE.0) ST2 = LEN(INTLAB(N))
            WRITE(OUTPUT,10030) INTLAB(N)(1:ST2),INTABL(1:ST1)
            CALL STETER(3,OUTPUT)
         ENDIF
1000  CONTINUE
C 
C  if NPIX(3) > 1, look for 3-dim table entries
      INCOL = 4
      IF (NPIX(3).GT.1) THEN
         CALL TBLSER(INTID,INTLAB(5),ICOLNM(5),STAT)
         IF (ICOLNM(5).GT.0) THEN
            CALL TBLSER(INTID,INTLAB(6),ICOLNM(6),STAT)
            IF (ICOLNM(6).GT.0) INCOL = 6
         ENDIF
      ENDIF
C 
C ***********
C
C  after the area option let's look for an output table or image
C 
C ***********
C
1111  IF ((DEFAUL(4:4).NE.'N').AND.(IACTIO.NE.4).AND.(IACTIO.NE.9))
     +      CALL FRAMOU(ORFILE)
      CALL STKRDC('OUT_A',1,1,120,IAV,OUTPUT,UNI,NULO,STAT)
      TBAPP = 0                    !point to start of table
      ST2 = 0                      !default append flag to 0
      N = INDEX(OUTPUT,',')
      IF (N.GT.1) THEN
         IF ((OUTPUT(N:N+1).EQ.',i').OR.(OUTTBL(N:N+1).EQ.',I')) THEN
            CALL CLNFRA(OUTPUT(1:N-1),OUTFRA,0)   !save the file name
            OUTTBL(1:) = 'middummXyZ.tbl '
            IF (INTABL.EQ.OUTTBL) OUTTBL(1:) = 'middummXYZ.tbl '
C 
            IAV = INDEX(ORFILE,' ')
            WRITE(HISTORY,20010) ORFILE(1:IAV-1),OUTPUT
            OUTNO = 999
            OUTPUT(1:) = OUTPUT(N+1:)
C 
C  then we also need descr. IDENT + CUNIT
            CALL STDRDC(IMNO,'IDENT',1,1,72,IAV,IDENT,UNI,NULO,STAT)
            N = (NAXPIX(1)+1) * 16
            CALL STDRDC(IMNO,'CUNIT',1,1,N,IAV,CUNIT,UNI,NULO,STAT)
C 
            N = INDEX(OUTPUT,',')        !look for qualifier: name,I,qualif
            IF (N.GT.1) THEN
               CALL UPCAS(OUTPUT(N+1:),CCBUF)
               IF (CCBUF(1:1).EQ.'M') THEN
                  IF (CCBUF(2:2).EQ.'I') THEN
                     OUTNO = 1                           !minimum
                  ELSE IF (CCBUF(2:2).EQ.'A') THEN
                     OUTNO = 2                           !maximum
                  ELSE IF (CCBUF(2:2).EQ.'E') THEN
                     IF (CCBUF(3:3).EQ.'A') THEN
                        OUTNO = 3                        !mean
                     ELSE
                        OUTNO = 8                        !median
                     ENDIF
                  ELSE IF (CCBUF(2:4).EQ.'ODE') THEN
                     IF (CCBUF(5:5).EQ.'1') THEN
                        OUTNO = 9                        !1st mode
                     ELSE
                        OUTNO = 12                       !mode
                     ENDIF
                  ELSE IF (CCBUF(2:3).EQ.'OM') THEN
                     IF (CCBUF(4:4).EQ.'3') THEN
                        OUTNO = 5                        !3rd moment
                     ELSE
                        OUTNO = 6                        !4th moment
                     ENDIF
                  ENDIF
               ELSE IF (CCBUF(1:2).EQ.'ST') THEN
                  OUTNO = 4                             !stddev
               ELSE IF (CCBUF(1:2).EQ.'TO') THEN
                  OUTNO = 7                             !total intensity
               ENDIF
            ENDIF
C 
            GOTO 1490                             !skip the rest
         ENDIF
C 
         IF ((OUTPUT(N:N+1).EQ.',a').OR.(OUTTBL(N:N+1).EQ.',A')) THEN
            ST2 = 1
         ENDIF
         CALL CLNTAB(OUTPUT(1:N-1),OUTTBL,0)
C 
         CALL STECNT('GET',EC,EL,ED)
         CALL STECNT('PUT',1,0,0)            !disable errors ...
         CALL TBTOPN(OUTTBL,F_IO_MODE,OUTID,STAT)
         IF (STAT.NE.0) ST2 = 0              !clear append flag again
         CALL STECNT('PUT',EC,EL,ED)
      ELSE
         CALL CLNTAB(OUTPUT,OUTTBL,0)
      ENDIF
C
C  create NROW * NCOL1 table to have already columns allocated for later use 
1490  IF (OUTTBL(1:1).NE.'+') THEN
         IF (OPTION(3:3).EQ.'M') THEN
            NCOL1 = 2                     !only 2 columns for Minmax
         ELSE IF (OPTION(3:3).EQ.'H') THEN
            NCOL1 = 2                     !only 2 columns for Histogram
         ELSE IF (OPTION(3:3).EQ.'S') THEN
            NCOL1 = 4                     !only 4 columns for Short
         ELSE IF (OPTION(3:3).EQ.'R') THEN
            NCOL1 = 7                     !only 7 columns for Reduced
         ELSE IF (OPTION(3:3).EQ.'X') THEN
            NCOL1 = 8                     !only 8 columns for XReduced
         ELSE
            NCOL1 = 12
         ENDIF
C 
         IF (INTABL.NE.OUTTBL) THEN
            IF (ST2.EQ.0) THEN			!build new table
               CALL TBTINI(OUTTBL,0,F_O_MODE,NCOL1+4,NROW,OUTID,STAT)
               DO 1500 N=1,NCOL1                        !and define the columns
                  CALL TBCINI(OUTID,D_R4_FORMAT,1,'G12.6',TABUNT,
     +                        TABLAB(N),TCOLNM(N),STAT)
1500           CONTINUE
C 
               IF (IACTIO.EQ.4) THEN          !4 more columns for CURSOR option
                  DO 1600 N=1,4
                     IAV = N + NCOL1
                     CALL TBCINI(OUTID,D_R4_FORMAT,1,'G12.6',TABUNT,
     +                           INTLAB(N),TCOLNM(IAV),STAT)
1600              CONTINUE
               ENDIF
            ELSE                                !append to output table
C 
               CALL TBIGET(OUTID,N,TBAPP,N,N,N,STAT)      !get no. of rows
               DO 1700 N=1,NCOL1
                  CALL TBLSER(OUTID,TABLAB(N),TCOLNM(N),STAT)
                  IF (TCOLNM(N).EQ.-1) THEN
                     ST1 = INDEX(OUTTBL,' ')
                     IF (ST1.LE.0) ST1 = LEN(OUTTBL)
                     ST2 = INDEX(TABLAB(N),' ')
                     IF (ST2.LE.0) ST2 = LEN(TABLAB(N))
                     WRITE(OUTPUT,10020) TABLAB(N)(1:ST2),OUTTBL(1:ST1)
                     CALL STETER(3,OUTPUT)
                  ENDIF
1700           CONTINUE
C
               IF (IACTIO.EQ.4) THEN          !4 more columns for CURSOR option
                  DO 1770 N=1,4
                     IAV = N + NCOL1
                     CALL TBLSER(OUTID,INTLAB(N),TCOLNM(IAV),STAT)
                     IF (TCOLNM(IAV).EQ.-1) THEN
                        ST1 = INDEX(OUTTBL,' ')
                        IF (ST1.LE.0) ST1 = LEN(OUTTBL)
                        ST2 = INDEX(INTLAB(N),' ')
                        IF (ST2.LE.0) ST2 = LEN(INTLAB(N))
                        WRITE(OUTPUT,10020) 
     +                       INTLAB(N)(1:ST2),OUTTBL(1:ST1)
                        CALL STETER(3,OUTPUT)
                     ENDIF
1770              CONTINUE
               ENDIF
            ENDIF
C
C  we use same table for input + output
         ELSE
            OUTID = INTID
            DO 1800, N=1,NCOL1
               CALL TBLSER(OUTID,TABLAB(N),TCOLNM(N),STAT)
               IF (TCOLNM(N).EQ.-1)
     +            CALL TBCINI(OUTID,D_R4_FORMAT,1,'G12.6',TABUNT,
     +                        TABLAB(N),TCOLNM(N),STAT)
1800        CONTINUE
         ENDIF
      ENDIF
C 
C ******************
C 
C  now do the statistics for every area option
C 
C ******************
C
C ---------
C
C  1) process complete frame (and table columns)
C
C ---------
C
      IF ((IACTIO.EQ.0).OR.(IACTIO.EQ.9)) THEN
         IF (IACTIO.EQ.0) THEN
            OPTION(5:5) = 'Y'
         ELSE
            OPTION(5:5) = 'N'                 !do not write all the descriptors
         ENDIF
         IF (EXAMED.EQ.1) THEN
            CALL EXMED(0,IMNO,ZBINS(2),NPIX,
     +                 SPIX,EPIX,XMEDIA,STAT)
            IF (STAT.NE.0) CALL STETER(35,
     +         'Problems with exact median calculation...')
         ENDIF
         CALL ZMSTAT(IMNO,AREA,NAXPIX,START,STEP,
     +               ZBINS,FRMSTR,OPTION)
         IF (OUTID.NE.-999) THEN
            N = 1
            CALL STKRDR('OUTPUTR',1,12,IAV,RVAL,UNI,NULO,STAT)
            CALL TBRWRR(OUTID,N+TBAPP,NCOL1,TCOLNM,RVAL,STAT)
         ENDIF
         IF (DEFAUL(6:6).EQ.'P') CALL PLOTI(IMNO)
C 
C ---------
C
C  2) handle subframe(s) mode
C 
C ---------
C
      ELSE IF (IACTIO.EQ.6) THEN
         NROW = 1
         OUTPUT(1:) = AREA(1:) 
700      N = INDEX(OUTPUT,'],[')
         IF (N.GT.1) THEN
            NROW = NROW + 1
            OUTPUT(1:) = OUTPUT(N+2:)
            GOTO 700
         ENDIF
         IF (NROW.EQ.1) OPTION(5:5) = 'Y'        !that's how it was before...
C
C  if Merge option we first get the no. of pixels involved + then create
C  an artificial image with all those pixels
         IF (DEFAUL(1:1).EQ.'M') THEN
            HISTORY(1:100) = AREA(1:)            !save AREA string
            SIZ(1) = 0
            DO 770, NLOOP=1,NROW                 !loop through subframes
               N = INDEX(AREA(1:),']')
               OUTPUT(1:) = AREA(1:N)//' '
               CALL EXTCOO(IMNO,OUTPUT,3,IAV,SPIX,EPIX,STAT)
               SIZ(2) = (EPIX(3) - SPIX(3) + 1) *
     +                  (EPIX(2) - SPIX(2) + 1) *
     +                  (EPIX(1) - SPIX(1) + 1)
               SIZ(1) = SIZ(1) + SIZ(2)
               AREA(1:) = AREA(N+2:)//' '
770         CONTINUE
            CALL ARTIMA(0,IMNO,NPIX,AREA,SIZ(1),IMNOC,STAT)
            AREA(1:) = HISTORY(1:100)
            DO 800, NLOOP=1,NROW
               N = INDEX(AREA(1:),']')
               OUTPUT(1:) = AREA(1:N)//' '
               CALL ARTIMA(1,IMNO,NPIX,OUTPUT,0,IMNOC,STAT)
               CALL STTPUT(OUTPUT,STAT)
               AREA(1:) = AREA(N+2:)//' '
800         CONTINUE
            GOTO 8000                          !now proceed as if full frame
         ENDIF
C
C  loop through all subframes
         DO 850, NLOOP=1,NROW
            N = INDEX(AREA(1:),']')
            OUTPUT(1:) = AREA(1:N)//' '
            IF (EXAMED.EQ.1) THEN
               CALL EXTCOO(IMNO,OUTPUT,3,IAV,SPIX,EPIX,STAT)
               IF (STAT.NE.0) CALL STETER(34,
     +              'Invalid syntax in subframe ...')
               IF (IAV.LT.3) THEN
                  CALL EXMED(IACTIO,IMNO,ZBINS(2),NPIX,SPIX,
     +                       EPIX,XMEDIA,STAT)
                  IF (STAT.NE.0) CALL STETER(35,
     +               'Problems with exact median calculation...')
               ELSE
                  CALL STETER(27,
     +            'G- or X-option not supported for 3-d frames, yet')
               ENDIF
            ENDIF
            CALL ZMSTAT(IMNO,OUTPUT,NAXPIX,START,STEP,
     +                  ZBINS,FRMSTR,OPTION)
           IF (OUTID.NE.-999) THEN
              CALL STKRDR('OUTPUTR',1,12,IAV,RVAL,UNI,NULO,STAT)
              CALL TBRWRR(OUTID,NLOOP+TBAPP,NCOL1,TCOLNM,RVAL,STAT)
            ENDIF
            IF (DEFAUL(6:6).EQ.'P') CALL PLOTI(IMNO)
            AREA(1:) = AREA(N+2:)//' '
850      CONTINUE
C 
C ---------
C
C  3) handle interval mode
C 
C ---------
C
      ELSE IF (IACTIO.EQ.7) THEN
         N = 1
         SPIX(2) = 1
C 
         IF (NAXPIX(1).GE.3) THEN
            NPIX(3) = 1                         !work on 1st plane only
C 
            DO 2200, ST2=1,NROW                   !loop over all intervals
               SPIX(1) = 1
               EPIX(2) = SPIX(2)+SIZ(2)-1
               IF (EPIX(2).GT.NPIX(2)) EPIX(2) = NPIX(2)
C 
               DO 2100, ST1=1,NMAL
                  EPIX(1) = SPIX(1)+SIZ(1)-1
                  IF (EPIX(1).GT.NPIX(1)) EPIX(1) = NPIX(1)
                  IF (EXAMED.EQ.1) THEN
                     CALL EXMED(IACTIO,IMNO,ZBINS(2),NPIX,SPIX,EPIX,
     +                          XMEDIA,STAT)
                     IF (STAT.NE.0) CALL STETER(35,
     +                  'Problems with exact median calculation...')
                  ENDIF
                  WRITE(AREA,10009) SPIX(1),SPIX(2),EPIX(1),EPIX(2)
                  CALL ZMSTAT(IMNO,AREA,NAXPIX,START,
     +                        STEP,ZBINS,FRMSTR,OPTION)
                  IF (OUTID.NE.-999) THEN
                     CALL STKRDR('OUTPUTR',1,12,IAV,RVAL,UNI,NULO,STAT)
                     CALL TBRWRR(OUTID,N+TBAPP,NCOL1,TCOLNM,RVAL,STAT)
                     N = N + 1
                     ENDIF
                  IF (DEFAUL(6:6).EQ.'P') CALL PLOTI(IMNO)
                  SPIX(1) = SPIX(1) + SIZ(1)
2100           CONTINUE
               SPIX(2) = SPIX(2) + SIZ(2)
2200        CONTINUE
C 
         ELSE IF (NAXPIX(1).EQ.2) THEN
            DO 2400, ST2=1,NROW                   !loop over all intervals
               SPIX(1) = 1
               EPIX(2) = SPIX(2)+SIZ(2)-1
               IF (EPIX(2).GT.NPIX(2)) EPIX(2) = NPIX(2)
C 
               DO 2300, ST1=1,NMAL
                  EPIX(1) = SPIX(1)+SIZ(1)-1
                  IF (EPIX(1).GT.NPIX(1)) EPIX(1) = NPIX(1)
                  IF (EXAMED.EQ.1) THEN
                     CALL EXMED(IACTIO,IMNO,ZBINS(2),NPIX,SPIX,EPIX,
     +                          XMEDIA,STAT)
                     IF (STAT.NE.0) CALL STETER(35,
     +                  'Problems with exact median calculation...')
                  ENDIF
                  WRITE(AREA,10008) SPIX(1),SPIX(2),EPIX(1),EPIX(2)
                  CALL ZMSTAT(IMNO,AREA,NAXPIX,START,
     +                        STEP,ZBINS,FRMSTR,OPTION)
                  IF (OUTID.NE.-999) THEN
                     CALL STKRDR('OUTPUTR',1,12,IAV,RVAL,UNI,NULO,STAT)
                     CALL TBRWRR(OUTID,N+TBAPP,NCOL1,TCOLNM,RVAL,STAT)
                     N = N + 1
                  ENDIF
                  IF (DEFAUL(6:6).EQ.'P') CALL PLOTI(IMNO)
                  SPIX(1) = SPIX(1) + SIZ(1)
2300           CONTINUE
               SPIX(2) = SPIX(2) + SIZ(2)
2400        CONTINUE
C 
         ELSE
            SPIX(1) = 1
            SPIX(2) = 1
            EPIX(2) = 1
            DO 2500, ST2=1,NMAL                   !loop over all intervals
               EPIX(1) = SPIX(1)+SIZ(1)-1
               IF (EPIX(1).GT.NPIX(1)) EPIX(1) = NPIX(1)
               IF (EXAMED.EQ.1) THEN
                  CALL EXMED(IACTIO,IMNO,ZBINS(2),NPIX,SPIX,EPIX,
     +                       XMEDIA,STAT)
                  IF (STAT.NE.0) CALL STETER(35,
     +               'Problems with exact median calculation...')
               ENDIF
               WRITE(AREA,10007) SPIX(1),EPIX(1)
               CALL ZMSTAT(IMNO,AREA,NAXPIX,START,
     +                     STEP,ZBINS,FRMSTR,OPTION)
               IF (OUTID.NE.-999) THEN
                  CALL STKRDR('OUTPUTR',1,12,IAV,RVAL,UNI,NULO,STAT)
                  CALL TBRWRR(OUTID,N+TBAPP,NCOL1,TCOLNM,RVAL,STAT)
                  N = N + 1
               ENDIF
               IF (DEFAUL(6:6).EQ.'P') CALL PLOTI(IMNO)
               SPIX(1) = SPIX(1) + SIZ(1)
2500        CONTINUE
         ENDIF
         N = NMAL * NROW
         WRITE(OUTPUT,10011) N             !display no. of intervals processed
         CALL STTPUT(OUTPUT,STAT)
C 
C ---------
C
C  4) handle row modes
C 
C ---------
C
      ELSE IF (IACTIO.EQ.2) THEN
         CACT(1:) = 'RRRR    '
C 
C  if Merge option we first get the no. of pixels involved + then create 
C  an artificial image with all those pixels
         IF (DEFAUL(1:1).EQ.'M') THEN
            SIZ(1) = NROW * NPIX(1)
            CALL ARTIMA(0,IMNO,NPIX,AREA,SIZ(1),IMNOC,STAT)
            DO 2700, NLOOP=1,NROW
               IF (KBUF(1).GT.0) THEN
                  N = KBUF(NLOOP)
               ELSE
                  N = NLOOP 
               ENDIF
               IF (NPIX(3).GT.1) THEN
                  WRITE(AREA,10004) N,N
               ELSE
                  WRITE(AREA,10003) N,N
               ENDIF
               CALL ARTIMA(1,IMNO,NPIX,AREA,0,IMNOC,STAT)
               WRITE(OUTPUT,20101) N
               CALL STTPUT(OUTPUT,STAT)
2700        CONTINUE
            GOTO 8000                           !now proceed as if full frame
         ENDIF
C
C  loop through all rows
         DO 2800, NLOOP=1,NROW
            IF (KBUF(1).GT.0) THEN
               N = KBUF(NLOOP)
            ELSE
               N = NLOOP 
            ENDIF
            WRITE(AREA,10000) CACT(1:1),N,N
            IF (EXAMED.EQ.1) THEN
               SPIX(1) = 1
               SPIX(2) = N
               EPIX(1) = NPIX(1)
               EPIX(2) = N
               CALL EXMED(IACTIO,IMNO,ZBINS(2),NPIX,SPIX,EPIX,
     +                    XMEDIA,STAT)
               IF (STAT.NE.0) CALL STETER(35,
     +            'Problems with exact median calculation...')
            ENDIF
            CALL ZMSTAT(IMNO,AREA,NAXPIX,START,STEP,
     +                  ZBINS,FRMSTR,OPTION)
            IF (OUTID.NE.-999) THEN
               CALL STKRDR('OUTPUTR',1,12,IAV,RVAL,UNI,NULO,STAT) 
               CALL TBRWRR(OUTID,NLOOP+TBAPP,NCOL1,TCOLNM,RVAL,STAT)
            ENDIF
            IF (DEFAUL(6:6).EQ.'P') CALL PLOTI(IMNO)
2800     CONTINUE
C 
C 
C ---------
C
C  5) handle column modes
C 
C ---------
C
      ELSE IF (IACTIO.EQ.3) THEN
         CACT(1:) = 'CCCC    '
C
C  transpose frame + switch descriptors
         SIZ(1) = 1
         DO 2900, N=1,NAXPIX(1)
            SIZ(1) = SIZ(1) * NPIX(N)
2900     CONTINUE
         CALL STFMAP(IMNO,F_I_MODE,1,SIZ(1),IAV,PNTRA,STAT)
         CALL STFCRE(TMPFIL,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +               SIZ(1),IMNOB,STAT)
         CALL STFMAP(IMNOB,F_O_MODE,1,SIZ(1),IAV,PNTRB,STAT)
         SIZ(1) = 128
         SIZ(2) = 256
         CALL LINCOL(MADRID(PNTRA),NPIX,SIZ,MADRID(PNTRB))
         CALL STFUNM(IMNO,STAT)
         CALL STFUNM(IMNOB,STAT)
C
C  we have to write these descriptors to the transposed frame,
C  because of function Convcoo inside Zstats (ZMSTAT)
C 
         CALL STDWRI(IMNOB,'NAXIS',NAXPIX(1),1,1,UNI,STAT)
         N = NAXPIX(2)
         NAXPIX(2) = NAXPIX(3)
         NAXPIX(3) = N
         CALL STDWRI(IMNOB,'NPIX',NAXPIX(2),1,2,UNI,STAT)
         DVAL = START(1)
         START(1) = START(2)
         START(2) = DVAL
         CALL STDWRD(IMNOB,'STEP',STEP,1,2,UNI,STAT)
         DVAL = STEP(1)
         STEP(1) = STEP(2)
         STEP(2) = DVAL
         CALL STDWRD(IMNOB,'START',START,1,2,UNI,STAT)
         NPIX(1) = NAXPIX(2)                 !NAXPIX already swapped
         NPIX(2) = NAXPIX(3)
         OUTPUT(1:) = CUNIT(16:)             !switch CUNIT (needed for Wcoords)
         CUNIT(16:31) = OUTPUT(32:47)
         CUNIT(32:47) = OUTPUT(16:31)
         N = (NAXPIX(1)+1) * 16
         CALL STDWRC(IMNOB,'CUNIT',1,CUNIT,1,N,UNI,STAT)
C
C  if Merge option we first get the no. of pixels involved + then create
C  an artificial image with all those pixels
         IF (DEFAUL(1:1).EQ.'M') THEN
            SIZ(1) = NROW * NPIX(1)
            CALL ARTIMA(0,IMNOB,NPIX,AREA,SIZ(1),IMNOC,STAT)
            DO 2950, NLOOP=1,NROW
               IF (KBUF(1).GT.0) THEN
                  N = KBUF(NLOOP)
               ELSE
                  N = NLOOP
               ENDIF
               IF (NPIX(3).GT.1) THEN
                  WRITE(AREA,10004) N,N
               ELSE
                  WRITE(AREA,10003) N,N
               ENDIF
               CALL ARTIMA(1,IMNOB,NPIX,AREA,0,IMNOC,STAT)
               WRITE(OUTPUT,20102) N
               CALL STTPUT(OUTPUT,STAT)
2950        CONTINUE
            GOTO 8000                           !now proceed as if full frame
         ENDIF
C
C  now loop through rows (columns of original frame)
         DO 3000, NLOOP=1,NROW
            IF (KBUF(1).GT.0) THEN
               N = KBUF(NLOOP)
            ELSE
               N = NLOOP
            ENDIF
            WRITE(AREA,10000) CACT(1:1),N,N
            IF (EXAMED.EQ.1) THEN
               SPIX(1) = 1
               SPIX(2) = N
               EPIX(1) = NAXPIX(2)                  !x-dim
               EPIX(2) = N
               CALL EXMED(IACTIO,IMNOB,ZBINS(2),NPIX,SPIX,EPIX,
     +                    XMEDIA,STAT)
               IF (STAT.NE.0) CALL STETER(35,
     +            'Problems with exact median calculation...')
            ENDIF
            CALL ZMSTAT(IMNOB,AREA,NAXPIX,START,STEP,
     +                  ZBINS,FRMSTR,OPTION)
            IF (OUTID.NE.-999) THEN
               CALL STKRDR('OUTPUTR',1,12,IAV,RVAL,UNI,NULO,STAT) 
               CALL TBRWRR(OUTID,NLOOP+TBAPP,NCOL1,TCOLNM,RVAL,STAT)
            ENDIF
            IF (DEFAUL(6:6).EQ.'P') CALL PLOTI(IMNO)
3000     CONTINUE
         CALL STFDEL(TMPFIL,STAT)
C 
C ---------
C
C  6) in table mode, we need some more table massaging
C 
C ---------
C
      ELSE IF (IACTIO.EQ.1) THEN
C 
C  if Merge option we first have to get the no. of pixels involved
         IF (DEFAUL(1:1).EQ.'M') THEN
            SIZ(1) = 0
            DO 4100, N=1,NROW
               CALL TBSGET(INTID,N,SELFLG,STAT)        !only use selected rows
               IF (SELFLG) THEN
                  CALL TBRRDR(INTID,N,INCOL,ICOLNM(1),RVAL,TABNUL,STAT)
                  IF (INCOL.EQ.4) THEN
                     WRITE(AREA,10001) RVAL(1),RVAL(2),RVAL(3),RVAL(4)
                  ELSE
                     WRITE(AREA,10002) 
     +               RVAL(1),RVAL(2),RVAL(5),RVAL(3),RVAL(4),RVAL(6)
                  ENDIF
                  CALL EXTCOO(IMNO,AREA,3,IAV,SPIX,EPIX,STAT)
                  SIZ(2) = (EPIX(3) - SPIX(3) + 1) * 
     +                     (EPIX(2) - SPIX(2) + 1) *
     +                     (EPIX(1) - SPIX(1) + 1)
                  SIZ(1) = SIZ(1) + SIZ(2)
               ENDIF
4100        CONTINUE
            CALL ARTIMA(0,IMNO,NPIX,AREA,SIZ(1),IMNOC,STAT)
C 
C  then create artificial image with all those pixels
            DO 4200, N=1,NROW
               CALL TBSGET(INTID,N,SELFLG,STAT)        !only use selected rows
               IF (SELFLG) THEN
                  CALL TBRRDR(INTID,N,INCOL,ICOLNM(1),RVAL,TABNUL,STAT)
                  IF (INCOL.EQ.4) THEN
                     WRITE(AREA,10001) RVAL(1),RVAL(2),RVAL(3),RVAL(4)
                  ELSE
                     WRITE(AREA,10002) 
     +               RVAL(1),RVAL(2),RVAL(5),RVAL(3),RVAL(4),RVAL(6)
                  ENDIF
                  CALL BLANKO(AREA)
                  CALL STTPUT(AREA,STAT)
                  CALL ARTIMA(1,IMNO,NPIX,AREA,0,IMNOC,STAT)
               ENDIF
4200        CONTINUE
            GOTO 8000                           !now proceed as if full frame
         ENDIF
C 
C  now loop through input table rows
         NMAL = 0
         DO 4400, N=1,NROW
C 
            CALL TBSGET(INTID,N,SELFLG,STAT)        !only use selected rows
            IF (.NOT.SELFLG) GOTO 4400
C 
            NMAL = NMAL + 1
            AREA(1:) = ' '
            CALL TBRRDR(INTID,N,INCOL,ICOLNM(1),RVAL,TABNUL,STAT)
C
            IF (INCOL.EQ.4) THEN
               WRITE(AREA,10001) RVAL(1),RVAL(2),RVAL(3),RVAL(4)
            ELSE
               WRITE(AREA,10002) 
     +              RVAL(1),RVAL(2),RVAL(5),RVAL(3),RVAL(4),RVAL(6)
            ENDIF
            CALL BLANKO(AREA)
            IF (OPTION(4:4) .NE. 'N') THEN
               OUTPUT(1:) = ' '
               CALL STTPUT(OUTPUT,STAT)
            ENDIF
            IF (EXAMED.EQ.1) THEN
               IF (INCOL.EQ.4) THEN
                  DD1(1) = RVAL(1)                !convert wc -> fp
                  DD1(2) = RVAL(2)
                  CALL FPXWCO(-1,0,DD1,DD2,STAT)
                  IF (STAT .GT. 0) 
     +               CALL STETER(36,'Problems with WCS of frame...')
                  SPIX(1) = DD2(1)
                  SPIX(2) = DD2(2)
                  DD1(1) = RVAL(3)
                  DD1(2) = RVAL(4)
                  CALL FPXWCO(-1,0,DD1,DD2,STAT)
                  IF (STAT .GT. 0) 
     +               CALL STETER(36,'Problems with WCS of frame...')
                  EPIX(1) = DD2(1)
                  EPIX(2) = DD2(2)
                  CALL EXMED(IACTIO,IMNO,ZBINS(2),NPIX,SPIX,EPIX,
     +                       XMEDIA,STAT)
                  IF (STAT.NE.0) CALL STETER(35,
     +               'Problems with exact median calculation...')
               ELSE
                  CALL STETER(27,
     +            'G- or X-option not supported for 3-d frames, yet')
               ENDIF
            ENDIF
            CALL ZMSTAT(IMNO,AREA,NAXPIX,START,STEP,
     +                  ZBINS,FRMSTR,OPTION)
            IF (OUTID.NE.-999) THEN
               CALL STKRDR('OUTPUTR',1,12,IAV,RVAL,UNI,NULO,STAT) 
               CALL TBRWRR(OUTID,N+TBAPP,NCOL1,TCOLNM,RVAL,STAT)
            ENDIF
            IF (DEFAUL(6:6).EQ.'P') CALL PLOTI(IMNO)
4400     CONTINUE
C
         CALL TBTCLO(INTID,STAT)
         WRITE(OUTPUT,10010) NMAL             !display no. of rows processed
         CALL STTPUT(OUTPUT,STAT)
C
C ---------
C
C  7) handle plane modes
C
C ---------
C
      ELSE IF (IACTIO.EQ.5) THEN
         CACT(1:) = 'PPPP    '
C
C  if Merge option we first get the no. of pixels involved + then create
C  an artificial image with all those pixels
         IF (DEFAUL(1:1).EQ.'M') THEN
            SIZ(1) = NROW * NPIX(1)*NPIX(2)
            CALL ARTIMA(0,IMNO,NPIX,AREA,SIZ(1),IMNOC,STAT)
            DO 4700, NLOOP=1,NROW
               IF (KBUF(1).GT.0) THEN
                  N = KBUF(NLOOP)
               ELSE
                  N = NLOOP
               ENDIF
               WRITE(AREA,10005) N,N
               CALL ARTIMA(1,IMNO,NPIX,AREA,0,IMNOC,STAT)
               WRITE(OUTPUT,20100) N
               CALL STTPUT(OUTPUT,STAT)
4700        CONTINUE
            GOTO 8000                           !now proceed as if full frame
         ENDIF
C
C  loop through planes
         DO 5000, NLOOP=1,NROW
            IF (KBUF(1).GT.0) THEN
               N = KBUF(NLOOP)
            ELSE
               N = NLOOP
            ENDIF
            AREA(1:) = ' '
            WRITE(AREA,20000) CACT(1:1),N,N
            IF (EXAMED.EQ.1) THEN
               SPIX(1) = 1
               SPIX(2) = 1
               SPIX(3) = N
               EPIX(1) = NPIX(1)
               EPIX(2) = NPIX(2)
               EPIX(3) = N
               CALL EXMED(IACTIO,IMNO,ZBINS(2),NPIX,SPIX,EPIX,
     +                    XMEDIA,STAT)
               IF (STAT.NE.0) CALL STETER(35,
     +            'Problems with exact median calculation...')
            ENDIF
            CALL ZMSTAT(IMNO,AREA,NAXPIX,START,STEP,
     +                  ZBINS,FRMSTR,OPTION)
            IF (OUTID.NE.-999) THEN
               CALL STKRDR('OUTPUTR',1,12,IAV,RVAL,UNI,NULO,STAT)
               CALL TBRWRR(OUTID,NLOOP+TBAPP,NCOL1,TCOLNM,RVAL,STAT)
            ENDIF
            IF (DEFAUL(6:6).EQ.'P') CALL PLOTI(IMNO)
5000     CONTINUE
C
C ---------
C
C  8) finally process cursor mode
C 
C ---------
C
      ELSE
         CALL DTOPEN(1,STAT)
         CALL STKRDI('AUX_MODE',9,1,IAV,N,UNI,NULO,STAT)
         IF (N.NE.0) CALL CONCHA(QDSPNO,QOVCH,1,0)      !clear overlay channel
         CALL SETCUR(QDSPNO,2,0,0,COOS,STAT)             !set up cursor window
         CACT = 'NNYY?C0 '
         IF (DEFAUL(5:5).NE.'N') CACT(2:2) = 'Y'
         ORFILE(1:) = ' '
         COOFF = 0
C
C  if Merge option we create the art. image with 100 000 pixels first
C  we may have to extend the image later on...
         IF (DEFAUL(1:1).EQ.'M') THEN
            SIZ(1) = 100000
            CALL ARTIMA(0,IMNO,NPIX,AREA,SIZ(1),IMNOC,STAT)
         ENDIF
C 
C  now loop through cursor inputs
         DO 6000, N=1,CURMAX
5800        CALL GETCUR(CACT,ORFILE,
     +                  XY1,RVAL(1),RVAL(13),RVAL(10),ST1,
     +                  XY2,RVAL(3),RVAL(15),RVAL(11),ST2)
C 
            IF ((ST1.EQ.0).AND.(ST2.EQ.0)) THEN
               IF ((N.EQ.1).AND.(COOFF.EQ.0)) THEN
                  COOFF = 1
                  ORFILE(1:) = ' '
                  CALL STTDIS
     +            ('switch cursors on - next time we exit...',99,STAT)
                  GOTO 5800
               ELSE
                  GOTO 6600         !we're finished
               ENDIF
            ENDIF
C 
            AREA(1:) = ' '
            IF (NAXPIX(1) .GT. 2) THEN
               WRITE(AREA,11001) 
     +         RVAL(13),RVAL(14),ZPLANE,RVAL(15),RVAL(16),ZPLANE
            ELSE
               WRITE(AREA,10001) RVAL(13),RVAL(14),RVAL(15),RVAL(16)
            ENDIF
            CALL BLANKO(AREA)                  !get rid of blanks in string
            IF (DEFAUL(1:1).EQ.'M') THEN
               CALL STTPUT(AREA,STAT)
5880           CALL ARTIMA(1,IMNO,NPIX,AREA,0,IMNOC,STAT)
               IF (STAT .EQ. -4) THEN                 !expand art. image
                  SIZ(1) = SIZ(1) + SIZ(1)
                  CALL ARTIMA(2,IMNO,NPIX,OUTPUT,SIZ(1),IMNOC,STAT)
                  GOTO 5880                           !redo last filling
               ENDIF
            ELSE
               IF (EXAMED.EQ.1) THEN
                  SPIX(1) = NINT(RVAL(1))
                  SPIX(2) = NINT(RVAL(2))
                  EPIX(1) = NINT(RVAL(3))
                  EPIX(2) = NINT(RVAL(4))
                  CALL EXMED(IACTIO,IMNO,ZBINS(2),NPIX,
     +                       SPIX,EPIX,XMEDIA,STAT)
                  IF (STAT.NE.0) CALL STETER(35,
     +               'Problems with exact median calculation...')
               ENDIF
               CALL ZMSTAT(IMNO,AREA,NAXPIX,START,STEP,
     +                     ZBINS,FRMSTR,OPTION)
               IF (OUTID.NE.-999) THEN
                  CALL STKRDR('OUTPUTR',1,12,IAV,RVAL,UNI,NULO,STAT) 
                  NROW = N+TBAPP
                  CALL TBRWRR(OUTID,NROW,NCOL1,TCOLNM,RVAL,STAT)
                  IAV = NCOL1 + 1           !first column after statistic stuff
                  CALL TBRWRR(OUTID,NROW,4,TCOLNM(IAV),RVAL(13),STAT)
               ENDIF
               IF (DEFAUL(6:6).EQ.'P') CALL PLOTI(IMNO)
            ENDIF
6000     CONTINUE
C 
6600     CALL DTCLOS(QDSPNO)
C  we have to display channel info again, to clean up last cursor drawing...
         CALL DTOPEN(1,STAT)
         CALL DAZVIS(QDSPNO,QIMCH,2,1)
         CALL DTCLOS(QDSPNO)
C 
         IF (DEFAUL(1:1).EQ.'M') THEN                 !get exact size
            CALL ARTIMA(3,IMNO,NPIX,AREA,SIZ(1),IMNOC,STAT)
            GOTO 8000                                 !do the statistics now 
         ENDIF
C 
      ENDIF
      GOTO 9000
C
C ---------
C
C  here from Merge option - proceed as if full frame
C
C ---------
C
8000  NPIX(1) = SIZ(1)
      NPIX(2) = 1
      NPIX(3) = 1
      IF (EXAMED.EQ.1) THEN
         CALL EXMED(0,IMNOC,ZBINS(2),NPIX,SPIX,EPIX,XMEDIA,STAT)
         IF (STAT.NE.0) 
     +      CALL STETER(35,'Problems with exact median calculation...')
      ENDIF
      NAXPIX(1) = 1
      NAXPIX(2) = NPIX(1)
      NAXPIX(3) = 1
      NAXPIX(4) = 1
      OPTION(5:5) = 'N'                   !don't try to write descr.
      START(1) = 0.D0
      STEP(1) = 1.D0
      CALL ZMSTAT(IMNOC,AREA,NAXPIX,START,STEP,ZBINS,FRMSTR,OPTION)
      IF (OUTID.NE.-999) THEN
         N = 1
         CALL STKRDR('OUTPUTR',1,12,IAV,RVAL,UNI,NULO,STAT)
         CALL TBRWRR(OUTID,N+TBAPP,NCOL1,TCOLNM,RVAL,STAT)
      ENDIF
      IF (DEFAUL(6:6).EQ.'P') CALL PLOTI(IMNO)
C 
C 
C ***********************
C
C  everything joins here
C
C ***********************
C 
C
9000  IF ((OUTID.NE.-999) .AND. (OUTID.NE.INTID)) THEN
         IF (OUTNO .GT. 0) THEN               !copy temp table to outimage
            CALL TBIGET(OUTID,NPXO(1),NPXO(2),N,N,N,STAT)
            STRTO(1) = 0.0
            STPO(1) = 1.0
            IF (OUTNO.EQ.999) THEN
               STRTO(2) = 0.0
               STPO(2) = 1.0
               NAXPIX(1) = 2                       !2dim result image
               N = 1
            ELSE
               NAXPIX(1) = 1                       !1dim result image
               N = 2
            ENDIF
            CALL STIPUT(OUTFRA,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +            NAXPIX(1),NPXO(N),STRTO,STPO,
     +            IDENT,CUNIT,PNTRO,IMNOB,STAT)
            CALL TB2IMA(OUTNO,OUTID,NPXO,MADRID(PNTRO))   !table -> image
            CALL STDWRC(IMNOB,'HISTORY',1,HISTORY,1,80,UNI,STAT)
            IF (IACTIO.EQ.7) THEN                  !save xsize, ysize of intv.
               ICOLNM(1) = SIZ(1)
               ICOLNM(2) = SIZ(2)
               ICOLNM(3) = NMAL
               ICOLNM(4) = NROW
               CALL STDWRI(IMNOB,'INTVALS',ICOLNM,1,4,UNI,STAT)
               CALL STECNT('GET',EC,EL,ED)
               CALL STECNT('PUT',1,0,0)            !disable errors ...
               CALL STKRDC('MYCOMND',1,1,80,IAV,HISTORY,UNI,NULO,STAT)
               IF (STAT.EQ.0) 
     +            CALL STDWRC(IMNOB,'HISTORY',1,HISTORY,1,80,UNI,STAT)
               CALL STECNT('PUT',EC,EL,ED)
            ENDIF
            CALL STFCLO(IMNOB,STAT)
         ELSE
            CALL TBSINI(OUTID,STAT)               !init selection flags
            CALL TBTCLO(OUTID,STAT)               !close table correctly
         ENDIF
      ENDIF
      CALL STSEPI
C
10000 FORMAT(A,'[<,@',I5.5,':>,@',I5.5,'] ')
10001 FORMAT('[',G12.6,',',G12.6,':',G12.6,',',G12.6,'] ')
10002 FORMAT
     +('[',G12.6,',',G12.6,',',G12.6,':',G12.6,',',G12.6,',',G12.6,']')
10003 FORMAT('[<,@',I5.5,':>,@',I5.5,'] ')
10004 FORMAT('[<,@',I5.5,',<:>,@',I5.5,',<] ')
10005 FORMAT('[<,<,@',I5.5,':>,>,@',I5.5,'] ')
10007 FORMAT('[@',I7.7,':@',I7.7,'] ')
10008 FORMAT('[@',I7.7,',@',I7.7,':@',I7.7,',@',I7.7,'] ')
10009 FORMAT('[@',I7.7,',@',I7.7,',<:@',I7.7,'@',I7.7,',<] ')
10010 FORMAT(I7,' table entries processed.')
10011 FORMAT(I7,' intervals processed.')
10020 FORMAT('column :',A,'is missing in output table ',A)
10030 FORMAT('column :',A,'is missing in input table ',A)
11001 FORMAT
     +('[',G12.6,',',G12.6,',@',I4,':',G12.6,',',G12.6,',@',I4,']')
20000 FORMAT(A,'[<,<,@',I5.5,':>,>,@',I5.5,'] ')
20010 FORMAT('from STATIST/IMAGE ',A,' ... ',A)
20100 FORMAT('plane ',I4)
20101 FORMAT('row ',I6)
20102 FORMAT('column ',I6)
C
      END

C 
C  copy all or just one column of the result table
C  to a 2/1-dim image
C 
      SUBROUTINE TB2IMA(OUTNO,TID,NCRO,A)
C 
      IMPLICIT NONE
C 
      INTEGER      OUTNO,TID,NCRO(*)
      INTEGER      INDX,N,NCOL,NROW,STAT
      INTEGER      ICOLNM(12)                !max no. of columns
      INTEGER      TABNUL(12)
C 
      REAL         A(*),RBUF(12)
C 
      NCOL = NCRO(1)
      NROW = NCRO(2)
      DO 500, N=1,NCOL
         ICOLNM(N) = N
500   CONTINUE
C 
      IF (OUTNO.EQ.999) THEN
         INDX = 1
         DO 1000, N=1,NROW
            CALL TBRRDR(TID,N,NCOL,ICOLNM(1),A(INDX),TABNUL,STAT)
            INDX = INDX + NCOL
1000     CONTINUE
C 
      ELSE
         DO 1500, N=1,12
            RBUF(N) = 0.0
1500     CONTINUE
         INDX = 1
         DO 2000, N=1,NROW
            CALL TBRRDR(TID,N,NCOL,ICOLNM(1),RBUF,TABNUL,STAT)
            A(INDX) = RBUF(OUTNO)
            INDX = INDX + 1
2000     CONTINUE
      ENDIF
C 
      RETURN
      END

      SUBROUTINE EXMED(ACTIO,INO,ZBINS,NPIX,SPIX,EPIX,VALMED,STAT)
C 
      INTEGER      ACTIO,INO,NPIX(*),SPIX(*),EPIX(*),STAT
      INTEGER      IAV,N,CHUNKA,CHUNKB,NN
      INTEGER      NA,NB,INSIZ,OUTSIZ,UNI(1),IBUF(7)
      INTEGER*8    PNTRX,PNTRY
      INTEGER      IMNOX,IMNOY,MADRID(1)
C 
      REAL         ZBINS(*),VALMED
      REAL         RBUF(7)
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON  /VMR/ MADRID
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C 
C  plane option
C 
      IF (ACTIO.EQ.5) THEN       
         INSIZ = NPIX(1) * NPIX(2)
         OUTSIZ = INSIZ
         NA = ((SPIX(3)-1)*NPIX(1)*NPIX(2)) + 1
         CALL STFCRE('middstat2',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +               OUTSIZ,IMNOY,STAT)
         CALL STFMAP(IMNOY,F_X_MODE,1,OUTSIZ,IAV,PNTRY,STAT)
         CALL STFGET(INO,NA,INSIZ,IAV,MADRID(PNTRY),STAT)
C 
C  subframe input
C 
      ELSE IF (ACTIO.NE.0) THEN 
         NN = EPIX(2)-SPIX(2)+1
         INSIZ = NPIX(1) * NN                 !size of full Y-strip
         CHUNKA = NPIX(1)
         CHUNKB = EPIX(1) - SPIX(1) + 1
         OUTSIZ = CHUNKB * NN
         NA = (SPIX(2)-1)*NPIX(1) + 1
C 
         CALL STFCRE('middstat1',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +               CHUNKA,IMNOX,STAT)
         CALL STFMAP(IMNOX,F_X_MODE,1,CHUNKA,IAV,PNTRX,STAT)
         CALL STFCRE('middstat2',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +               OUTSIZ,IMNOY,STAT)
         CALL STFMAP(IMNOY,F_X_MODE,1,OUTSIZ,IAV,PNTRY,STAT)
         NB = 1
         DO 500,N=1,NN
            CALL STFGET(INO,NA,CHUNKA,IAV,MADRID(PNTRX),STAT)
            CALL DATMOV(MADRID(PNTRX),NB,CHUNKB,SPIX(1),MADRID(PNTRY))
            NA = NA + CHUNKA
            NB = NB + CHUNKB
500      CONTINUE
         CALL STFCLO(IMNOX,STAT)
C 
C  full frame
C 
      ELSE      
         INSIZ = NPIX(1) * NPIX(2) * NPIX(3)
         OUTSIZ = INSIZ
         CALL STFCRE('middstat2',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +               OUTSIZ,IMNOY,STAT)
         CALL STFMAP(IMNOY,F_X_MODE,1,OUTSIZ,IAV,PNTRY,STAT)
         CALL STFGET(INO,1,INSIZ,IAV,MADRID(PNTRY),STAT)
      ENDIF
C 
C  sort array + return median
C 
      NA = (OUTSIZ+1)/2                             !index of median
      CALL SORTME(MADRID(PNTRY),ZBINS,OUTSIZ,NA,VALMED,STAT)
C 
      IF (STAT.EQ.-1) THEN
         CALL STTPUT('No pixels found with data in given interval...',N)
         DO 900, N=1,7
            RBUF(N) = -1.0
            IBUF(N) = -1
900      CONTINUE
         CALL STKWRR('OUTPUTR',RBUF,1,7,UNI,N)
         CALL STKWRI('OUTPUTI',IBUF,1,7,UNI,N)
         CALL STFCLO(IMNOY,N)                       !keep value of STAT
      ELSE
         CALL STKWRR('OUTPUTR',VALMED,8,1,UNI,STAT)
         CALL STFCLO(IMNOY,STAT)
      ENDIF
C 
      RETURN
      END

      SUBROUTINE PLOTI(IMNO)
C 
      IMPLICIT NONE
C
      INTEGER      IMNO
      INTEGER      UNI(1),NULO,STAT,IAV
C 
      REAL         RV
C 
      CALL STKRDR('OUTPUTR',10,1,IAV,RV,UNI,NULO,STAT) 
      IF (RV.GT.0.99) THEN
         CALL PLOHI(IMNO)          !only if we got a histogram
      ELSE
         CALL STTPUT('No histogram calculated => no plotting...',STAT)
      ENDIF
C 
      RETURN
      END

      SUBROUTINE DATMOV(A,OFF,CHUNK,SPIX,Y)
C 
      IMPLICIT NONE
C 
      INTEGER      OFF,CHUNK,SPIX
C 
      REAL         A(*),Y(*)
C 
      INTEGER   N,NN
C 
      NN = OFF
      DO 500,N=SPIX,SPIX+CHUNK-1
         Y(NN) = A(N)
         NN = NN + 1 
500   CONTINUE
C 
      RETURN
      END

C===========================================================================
C Copyright (C) 1985-2011 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM DATA
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  program DATA            	version 3.30	850719
C  K. Banse     		ESO - Garching
C
C.KEYWORDS
C  bulk data frame
C
C.PURPOSE
C  manipulate pixels of a bulk data frame
C
C.ALGORITHM
C  straight forward
C
C.INPUT/OUTPUT
C  the following keys are used:
C
C  IN_A/C/1/80          name of data frame
C  ACTION/C/1/1         = R, for reading pixel values (max. 4096)
C              		= P, for printing pixel values (max. 4096)
C              		= W, for writing pixel values (max. 20)
C  IN_B/C/1/80          start coordinates (as real coords. or as pixel no's.),
C            		no. of values
C            		or
C            		subarea as [.,.:.,.]
C            		or
C            		= CURSOR, to indicate that we use cursor window
C            		or an ASCII name of a table
C  INPUTC/C/1/80        values to write to pixels (W)
C            		in case of CURSOR window, only one value will
C            		be written to all pixels inside the window
C  HIDEHEAD/C/1/1	hide_header_flag = H or ?, for READ, PRINT/IMAGE
C			to control printing of frame header + lines
C  P4/C/1/1             all_flag = A or ?, for WRITE/IMAGE 
C  PROCESS/C/1/1        process_flag = S(tore), A(dd) or M(ultiply)
C
C  INPUTI/I/1/1		no. of values per line to display (default = 5/3)
C
C			that keyword
C  OUTPUTR/R/1/20       for R, P the first 20 values are also stored in 
C			that keyword
C
C.VERSION
C 
C 110705		last modif
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      IAV,N,STAT,M1,M2,M3,M4
      INTEGER      NAXIS,NPIX(3)
      INTEGER      IMNOW,SIZE,MAPSIZ,MAXNO
      INTEGER*8    WPNTR
      INTEGER      UNIT(1),NULLO,IMNO,DATFMT,CVFLAG
      INTEGER      MADRID(1)
      INTEGER      PRFLAG,IBUF(5),MONSIZ,NOHEAD
C 
      REAL         CUTS(4)
C
      CHARACTER    FRAME*80,CBUF*80
      CHARACTER    TBL*80,INPUTC*80,AC*4
C
      DOUBLE PRECISION START(3),STEP(3)
      DOUBLE PRECISION DMIN,DMAX
C 
      INCLUDE  'MID_INCLUDE:ST_DEF.INC'
C 
      INCLUDE  'MID_INCLUDE:IDIDEV.INC'
      INCLUDE  'MID_INCLUDE:IDIMEM.INC'
C 
      COMMON    /VMR/ MADRID
      COMMON    /SVCUTS/  CUTS,DMIN,DMAX
      COMMON    /WSPACE/  IMNOW,MAPSIZ,NOHEAD
      COMMON    /IMINFO/  IMNO,DATFMT,CVFLAG,MAXNO,NAXIS,NPIX
      COMMON    /ALLOC/  WPNTR
C
      DATA      NPIX      /3*1/
      DATA      INPUTC    /' '/
C
      INCLUDE  'MID_INCLUDE:ST_DAT.INC'
C 
C  get into MIDAS 
      CALL STSPRO('DATA')
C
C  get action flag, frame, boundaries for data + hide_header_flag
      CALL STKRDC('ACTION',1,1,1,IAV,AC,UNIT,NULLO,STAT)
      CALL STKRDC('IN_A',1,1,80,IAV,INPUTC,UNIT,NULLO,STAT)
      CALL CLNFRA(INPUTC,FRAME,0)
      CALL STKRDC('IN_B',1,1,80,IAV,TBL,UNIT,NULLO,STAT)
      CALL UPCAS(TBL,INPUTC)
      CALL STKRDC('HIDEHEAD',1,1,1,IAV,CBUF,UNIT,NULLO,STAT)
      IF ((CBUF(1:1).EQ.'H').OR.(CBUF(1:1).EQ.'h')) THEN
         NOHEAD = 1
      ELSE
         NOHEAD = 0
      ENDIF
      PRFLAG = 0
      IF (AC(1:1).EQ.'W') THEN
         CALL STKRDC('PROCESS',1,1,1,IAV,CBUF,UNIT,NULLO,STAT)
         IF ((CBUF(1:1).EQ.'A').OR.(CBUF(1:1).EQ.'a')) THEN
            PRFLAG = 1            !set the data-proc-flag (set, add, multiply)
         ELSE IF ((CBUF(1:1).EQ.'M').OR.(CBUF(1:1).EQ.'m')) THEN
            PRFLAG = 2
         ENDIF
      ENDIF
      CALL STKRDI('INPUTI',1,1,IAV,MAXNO,UNIT,NULLO,STAT)
C 
C  get info of data frame
      CALL STFINF(FRAME,2,IBUF,STAT)
      IF (STAT .NE. 0)                   !ERR_NORMAL not in ST_DEF header...
     +   CALL STETER(33,'invalid file name')
       
      DATFMT = D_R4_FORMAT
      CVFLAG = 2
      IF (IBUF(2) .EQ. D_I1_FORMAT) THEN
         AC(2:2) = '1'
      ELSE IF (IBUF(2) .EQ. D_I2_FORMAT) THEN
         AC(2:2) = '2'
      ELSE IF (IBUF(2) .EQ. D_I4_FORMAT) THEN
         AC(2:2) = '4'
      ELSE IF (IBUF(2) .EQ. D_R8_FORMAT) THEN
         IF (INPUTC(1:5).EQ.'_CUR_') THEN     !we need single prec. here...
            AC(2:2) = '0'
         ELSE
            DATFMT = D_R8_FORMAT
            AC(2:2) = '8'
            CVFLAG = 4
         ENDIF
      ELSE
         AC(2:2) = '0'                        !default to real data
      ENDIF
      IF (MAXNO.LT.1) THEN                    !test, if nopix-per-line given
         IF (CVFLAG.EQ.2) THEN
            MAXNO = 5
         ELSE
            MAXNO = 3
         ENDIF
      ELSE
         IF (MAXNO.GT.20) MAXNO = 20          !FORMAT supports max. 20 values
      ENDIF
C 
      CALL STFOPN(FRAME,DATFMT,0,F_IMA_TYPE,IMNO,STAT)
      CALL STDRDI(IMNO,'NAXIS',1,1,IAV,NAXIS,UNIT,NULLO,STAT)
      CALL STDRDI(IMNO,'NPIX',1,NAXIS,IAV,NPIX,UNIT,NULLO,STAT)
C 
C  process Rn-m (row n-m) and Cn-m (column n-m)
      IF (INPUTC(1:1).EQ.'R') THEN            !Rn-m (row n till row m)
         M1 = INDEX(INPUTC,'-')
         M2 = INDEX(INPUTC,' ')
         IF (M1.LT.1) THEN                    !single row
            WRITE (CBUF,20123) INPUTC(2:M2-1),INPUTC(2:M2-1)
         ELSE
            WRITE (CBUF,20123) INPUTC(2:M1-1),INPUTC(M1+1:M2-1)
         ENDIF
         INPUTC(1:) = CBUF(1:)
      ELSE IF (INPUTC(1:1).EQ.'C') THEN       !Cn-m (column n till row m)
         M1 = INDEX(INPUTC,'-')
         M2 = INDEX(INPUTC,' ')
         IF (M1.LT.1) THEN                    !single column
            WRITE (CBUF,20124) INPUTC(2:M2-1),INPUTC(2:M2-1)
         ELSE
            WRITE (CBUF,20124) INPUTC(2:M1-1),INPUTC(M1+1:M2-1)
         ENDIF
         INPUTC(1:) = CBUF(1:)
      ENDIF
      IF (NAXIS.GT.3) THEN
         CALL STTPUT('Warning: max 3 dims of frame used ...',STAT)
         NAXIS = 3
         M1 = INDEX(INPUTC,',')
         IF (M1.GT.1) THEN
            INPUTC(M1:M1) = ' '
            M2 = INDEX(INPUTC,',')
            IF (M2.GT.1) THEN
               INPUTC(M2:M2) = ' '
               M3 = INDEX(INPUTC,',')
               IF (M3.GT.1) THEN
                  INPUTC(M3:M3) = ' '
111               M4 = INDEX(INPUTC,',')
                  IF (M4.GT.1) THEN                !get rid of commata...
                     INPUTC(M3+1:) = INPUTC(M4+1:)//' '
                     GOTO 111
                  ENDIF
                  INPUTC(M3:M3) = ','
               ENDIF
               INPUTC(M2:M2) = ','
            ENDIF
            INPUTC(M1:M1) = ','
         ENDIF
      ENDIF
C 
      CALL STDRDD(IMNO,'START',1,NAXIS,IAV,START,UNIT,NULLO,STAT)
      CALL STDRDD(IMNO,'STEP',1,NAXIS,IAV,STEP,UNIT,NULLO,STAT)
      CALL STDRDR(IMNO,'LHCUTS',1,4,IAV,CUTS,UNIT,NULLO,STAT)
      DMIN = DBLE(CUTS(3))
      DMAX = DBLE(CUTS(4))
C 
      SIZE = 1                                      !get total size of frame
      DO 200 N=1,NAXIS
         SIZE = SIZE * NPIX(N)
200   CONTINUE
C 
C  map working space for data windows
      CALL STKRDI('MONITPAR',20,1,IAV,MONSIZ,UNIT,NULLO,STAT)
      MAPSIZ = MONSIZ * MONSIZ
      IF (NPIX(3).GT.1) MAPSIZ = 3 * MAPSIZ
      IF (MAPSIZ.GT.SIZE) MAPSIZ = SIZE
      CALL STFCRE('wworrkfr',DATFMT,F_X_MODE,F_IMA_TYPE,
     +            MAPSIZ,IMNOW,STAT)
      CALL STFMAP(IMNOW,F_X_MODE,1,MAPSIZ,IAV,WPNTR,STAT)
C 
C  branch according to input mode
      IF (INPUTC(1:5).EQ.'_CUR_') THEN
         AC(3:3) = INPUTC(6:6)              !C or 1,2 for no. of cursors
         IF (AC(1:1).EQ.'W') THEN
            IF (CUTS(1).GE.CUTS(2)) THEN
               CUTS(1) = CUTS(3)
               CUTS(2) = CUTS(4)
            ENDIF
         ENDIF
         CALL DATACU(FRAME,SIZE,AC,PRFLAG)
C
      ELSE
         IF ((AC(1:1).NE.'W') .AND.
     +       (NOHEAD.EQ.0)) CALL FRAMOU(FRAME)
         CALL UPCAS(INPUTC(1:80),CBUF)
         IAV = INDEX(CBUF,',T')                  !look for xyz,table
         IF (IAV .GT. 1) THEN
            TBL(IAV:) = ' '                   !clean up table name
            CALL DATATB(FRAME,START,STEP,AC,TBL,PRFLAG)
         ELSE
            IF (INPUTC(1:7).EQ.'<,<,20 ') THEN         !adapt default to NAXIS
               IF (NAXIS.EQ.1) THEN
                  INPUTC(1:) = '<,20 '
               ELSE IF (NAXIS.EQ.3) THEN
                  INPUTC(1:) = '<,<,<,20 '
               ENDIF
            ENDIF
            CALL DATALN(FRAME,START,STEP,SIZE,AC,INPUTC,PRFLAG)
         ENDIF
      ENDIF
C  
C  for WRITE/IMAGE update descr. HISTORY and if necessary LHCUTS 
      IF (AC(1:1).EQ.'W') THEN
         CALL DSCUPT(IMNO,IMNO,' ',STAT)
         CUTS(3) = SNGL(DMIN)
         CUTS(4) = SNGL(DMAX)
         CALL STDWRR(IMNO,'LHCUTS',CUTS(3),3,2,UNIT,STAT)
      ENDIF
C  
C that's it folks ...
C 
      CALL STSEPI
C 
20123 FORMAT('[<,@',A,':>,@',A,']')
20124 FORMAT('[@',A,',<:@',A,',>]')
C 
      END

      SUBROUTINE DATALN(FRAME,START,STEP,SIZE,AC,INPUTC,PRFLAG)
C
      IMPLICIT NONE
C
      INTEGER      PRFLAG,ACTVAL,COPTIO(3)
      INTEGER      IAV,NOVAL,CVFLAG,MAXNO,IBUF(1)
      INTEGER      N,N1,N2,N3,N4,N5
      INTEGER      NAXIS,NLINES,NO,NOOUT,NREM
      INTEGER*8    WPNTR,WPNTR2,WREST
      INTEGER      IMNOW,MAPSIZ,NOHEAD
      INTEGER      OFFSET,REST
      INTEGER      SIZE,SLEN,STA,STAT,SUBDIM
      INTEGER      XOFF,YOFF
      INTEGER      NPIX(3),DATFMT
      INTEGER      PIXELS(3,2),PIXLS1(3,2),PIXLS2(3,2),PIXLS3(3,2),
     +             PIXLS4(3,2),PIXLS5(3,2)
      INTEGER      SUBLO(3),SUBHI(3)
      INTEGER      UNIT(1),NULLO,IMNO
      INTEGER      MADRID(1)
C
      CHARACTER    FRAME*(*),AC*(*),INPUTC*(*)
      CHARACTER    RWOPT*1,NEWSTR*80
      CHARACTER    ALLFLG*1,INSTRM*1,VALBUF*15
      CHARACTER    ATOM(4)*15
C
      DOUBLE PRECISION  START(3),STEP(3)
      DOUBLE PRECISION  DBUF(80),DVAL
C 
      REAL         RBUF(80),RVAL
C
      INCLUDE  'MID_INCLUDE:ST_DEF.INC'
C 
      COMMON    /VMR/ MADRID
      COMMON    /WSPACE/  IMNOW,MAPSIZ,NOHEAD
      COMMON    /IMINFO/  IMNO,DATFMT,CVFLAG,MAXNO,NAXIS,NPIX
      COMMON    /ALLOC/  WPNTR
C
      DATA      SUBLO     /3*1/
      DATA      SUBHI     /3*1/
      DATA      PIXELS    /6*1/
      DATA      PIXLS1    /6*1/, PIXLS2 /6*1/
      DATA      PIXLS3    /6*1/, PIXLS4 /6*1/, PIXLS5 /6*1/
C
      INCLUDE  'MID_INCLUDE:ST_DAT.INC'
C 
C  extract window   or     start coords. + no. of values
C 
      RWOPT = 'W'                                  ! default to window option
      IF (INPUTC(1:1).EQ.'[') THEN
         CALL EXTCOO(IMNO,INPUTC,3,SUBDIM,SUBLO,SUBHI,STAT)
         IF (STAT.NE.0) GOTO 9900
C 
         NOVAL = (SUBHI(1)-SUBLO(1)+1) * (SUBHI(2)-SUBLO(2)+1)
     +                                 * (SUBHI(3)-SUBLO(3)+1)
         DO 400,N=1,3 
            PIXELS(N,1) = SUBLO(N)
            PIXELS(N,2) = SUBHI(N)
400      CONTINUE
C 
      ELSE     
         STA = 1
         CALL EXTRSS(INPUTC,',',STA,ATOM(1),SLEN)
         CALL EXTRSS(INPUTC,',',STA,ATOM(2),SLEN)
         CALL EXTRSS(INPUTC,',',STA,ATOM(3),SLEN)
         IF (SLEN.LE.0) THEN
            SUBDIM = 1                                  !x,value
         ELSE
            CALL EXTRSS(INPUTC,',',STA,ATOM(4),SLEN)
            IF (SLEN.LE.0) THEN
               SUBDIM = 2                               !x,y,value
            ELSE
               SUBDIM = 3                               !x,y,z,value
            ENDIF
         ENDIF
         IF (SUBDIM.NE.NAXIS) THEN
            IF (SUBDIM.EQ.(NAXIS-1)) THEN
               CALL STTPUT
     +         ('No. of values missing, defaulted to 20...',STAT)
               SUBDIM = SUBDIM + 1
               VALBUF = '20 '
            ELSE
               CALL STETER(21,
     +              'No. of start_coords not equal to NAXIS...')
            ENDIF
         ELSE
            VALBUF = ATOM(SUBDIM+1)
         ENDIF
C
C  build [x,y,z] string
         IF (SUBDIM.GT.NAXIS) GOTO 9900
         NEWSTR(1:) = '[ '
         N1 = 1
         DO 770, N=1,SUBDIM
            N1 = N1 + 1
            NEWSTR(N1:) = ATOM(N)
            N1 = INDEX(NEWSTR,' ')
            NEWSTR(N1:N1) = ','
770      CONTINUE
         NEWSTR(N1:) = '] '
C 
         CALL EXTCO1(IMNO,NEWSTR,3,SUBDIM,SUBLO,STAT)
         IF (STAT.NE.0) GOTO 9900
         DO 780, N=1,SUBDIM
            PIXELS(N,1) = SUBLO(N)
            PIXELS(N,2) = SUBLO(N)
780      CONTINUE
C
C  make sure, no. of values remains in limits
         OFFSET = (PIXELS(2,1)-1)*NPIX(1) + PIXELS(1,1) - 1  
         IF (VALBUF.EQ.'ALL') THEN
            NOVAL = SIZE
         ELSE
            CALL GENCNV(VALBUF,1,1,NOVAL,RVAL,DVAL,IAV)
            IF (IAV.LT.1) GOTO 9900
         ENDIF
C                                                keep in right interval...
         IF (NOVAL.LT.1) NOVAL = 1
         N = SIZE - OFFSET
         IF (NOVAL.GT.N) NOVAL = N
C
C  now determine N1, N2, N3, N4, N5
         XOFF = PIXELS(1,1) - 1
         YOFF = PIXELS(2,1) - 1
C                                              remaining pixels on this line
         N1 = NPIX(1) - XOFF                 
         IF (NOVAL.LE.N1) THEN
            PIXELS(1,2) = PIXELS(1,1) + NOVAL - 1
            GOTO 900
         ENDIF
C 
C  sequential reading/writing
C  split up rest into no. of full lines more, pixels on last line, 
C  remaining lines on this plane, full lines on this plane, 
C  number of full planes and full lines on last plane
C 
         RWOPT = 'S'                       
         REST = NOVAL - N1                    
         NLINES = REST/NPIX(1)                 
         N5 = REST - (NLINES*NPIX(1))                 
         YOFF = YOFF + 1
         NREM = NPIX(2) - YOFF                 
         N2 = MIN(NREM,NLINES)                 
         NLINES = NLINES - N2
         REST = NLINES * NPIX(1)
         N3 = NLINES/NPIX(2)                       
         N4 = NLINES - N3*NPIX(2)                 
C
C  set up for 1. line
         PIXLS1(1,1) = PIXELS(1,1)                 
         PIXLS1(2,1) = PIXELS(2,1)
         PIXLS1(3,1) = PIXELS(3,1)
         PIXLS1(1,2) = PIXLS1(1,1) + N1 - 1
         PIXLS1(2,2) = PIXLS1(2,1)
         PIXLS1(3,2) = PIXLS1(3,1)
C
C  use 1. pixel on next line in same plane
         IF (N2.GT.0) THEN
            PIXLS2(1,1) = 1               
            PIXLS2(2,1) = PIXLS1(2,2) + 1 
            PIXLS2(3,1) = PIXELS(3,1)        
            PIXLS2(1,2) = NPIX(1)
            PIXLS2(2,2) = PIXLS1(2,2) + N2
            PIXLS2(3,2) = PIXLS2(3,1)
         ENDIF
C
C  use 1. pixel on first line in next plane
         IF (N3.GT.0) THEN
            PIXLS3(1,1) = 1         
            PIXLS3(2,1) = 1          
            PIXLS3(3,1) = PIXELS(3,1) + 1 
            PIXLS3(1,2) = NPIX(1)
            PIXLS3(2,2) = NPIX(2)
            PIXLS3(3,2) = PIXELS(3,1) + N3
         ENDIF
C
C  use 1. pixel on first line in last plane
         IF (N4.GT.0) THEN
            PIXLS4(1,1) = 1                
            PIXLS4(2,1) = 1               
            PIXLS4(3,1) = PIXELS(3,1) + N3 + 1  
            PIXLS4(1,2) = NPIX(1)
            PIXLS4(2,2) = N4
            PIXLS4(3,2) = PIXLS4(3,1)
         ENDIF
C
         IF (N5.GT.0) THEN
            PIXLS5(1,1) = 1                 
C
C  use 1. pixel on last line
            IF ((N3.GT.0).OR.(N4.GT.0)) THEN      
               PIXLS5(2,1) = N4 + 1                
               PIXLS5(3,1) = PIXELS(3,1) + N3 + 1
            ELSE
               PIXLS5(2,1) = PIXLS1(2,1) + N2 + 1   
               PIXLS5(3,1) = PIXELS(3,1)           
            ENDIF
            PIXLS5(1,2) = N5
            PIXLS5(2,2) = PIXLS5(2,1)
            PIXLS5(3,2) = PIXLS5(3,1)
         ENDIF
C
      ENDIF
C
C  branch according to desired action
900   IF (AC(1:1).EQ.'W') GOTO 2000
C
C  read or print data
C
      IF (CVFLAG.EQ.4) THEN
         IF (RWOPT.EQ.'W') THEN                          !window option?
            CALL R4READ(RBUF,MADRID(WPNTR),PIXELS,SUBDIM,SLEN)
            IF (SLEN.GT.0) THEN             !we need more virtual memory...
               CALL XTNDW(SLEN)
               CALL R4READ(RBUF,MADRID(WPNTR),PIXELS,SUBDIM,SLEN)
            ENDIF
C
         ELSE
            CALL R4READ(RBUF,MADRID(WPNTR),PIXLS1,SUBDIM,SLEN)
            IF (SLEN.GT.0) THEN
               CALL XTNDW(SLEN)
               CALL
     +         R4READ(RBUF,MADRID(WPNTR),PIXLS1,SUBDIM,SLEN)
            ENDIF
            IF (N2.GT.0) THEN
               CALL R4READ(RBUF,MADRID(WPNTR),PIXLS2,SUBDIM,SLEN)
               IF (SLEN.GT.0) THEN
                  CALL XTNDW(SLEN)
                  CALL R4READ(RBUF,MADRID(WPNTR),PIXLS2,SUBDIM,SLEN)
               ENDIF
            ENDIF
            IF (N3.GT.0) THEN
               CALL R4READ(RBUF,MADRID(WPNTR),PIXLS3,SUBDIM,SLEN)
               IF (SLEN.GT.0) THEN
                  CALL XTNDW(SLEN)
                  CALL R4READ(RBUF,MADRID(WPNTR),PIXLS3,SUBDIM,SLEN)
               ENDIF
            ENDIF
            IF (N4.GT.0) THEN
               CALL R4READ(RBUF,MADRID(WPNTR),PIXLS4,SUBDIM,SLEN)
               IF (SLEN.GT.0) THEN
                  CALL XTNDW(SLEN)
                  CALL R4READ(RBUF,MADRID(WPNTR),PIXLS4,SUBDIM,SLEN)
               ENDIF
            ENDIF
            IF (N5.GT.0) THEN
               CALL R4READ(RBUF,MADRID(WPNTR),PIXLS5,SUBDIM,SLEN)
               IF (SLEN.GT.0) THEN
                  CALL XTNDW(SLEN)
                  CALL R4READ(RBUF,MADRID(WPNTR),PIXLS5,SUBDIM,SLEN)
               ENDIF
            ENDIF
         ENDIF
      ELSE
         IF (RWOPT.EQ.'W') THEN                          !window option?
            CALL R4READ(MADRID(WPNTR),DBUF,PIXELS,SUBDIM,SLEN)
            IF (SLEN.GT.0) THEN             !we need more virtual memory...
               CALL XTNDW(SLEN)
               CALL R4READ(MADRID(WPNTR),DBUF,PIXELS,SUBDIM,SLEN)
            ENDIF
C
         ELSE
            CALL R4READ(MADRID(WPNTR),DBUF,PIXLS1,SUBDIM,SLEN)
            IF (SLEN.GT.0) THEN
               CALL XTNDW(SLEN)
               CALL
     +         R4READ(MADRID(WPNTR),DBUF,PIXLS1,SUBDIM,SLEN)
            ENDIF
            IF (N2.GT.0) THEN
               CALL R4READ(MADRID(WPNTR),DBUF,PIXLS2,SUBDIM,SLEN)
               IF (SLEN.GT.0) THEN
                  CALL XTNDW(SLEN)
                  CALL R4READ(MADRID(WPNTR),DBUF,PIXLS2,SUBDIM,SLEN)
               ENDIF
            ENDIF
            IF (N3.GT.0) THEN
               CALL R4READ(MADRID(WPNTR),DBUF,PIXLS3,SUBDIM,SLEN)
               IF (SLEN.GT.0) THEN
                  CALL XTNDW(SLEN)
                  CALL R4READ(MADRID(WPNTR),DBUF,PIXLS3,SUBDIM,SLEN)
               ENDIF
            ENDIF
            IF (N4.GT.0) THEN
               CALL R4READ(MADRID(WPNTR),DBUF,PIXLS4,SUBDIM,SLEN)
               IF (SLEN.GT.0) THEN
                  CALL XTNDW(SLEN)
                  CALL R4READ(MADRID(WPNTR),DBUF,PIXLS4,SUBDIM,SLEN)
               ENDIF
            ENDIF
            IF (N5.GT.0) THEN
               CALL R4READ(MADRID(WPNTR),DBUF,PIXLS5,SUBDIM,SLEN)
               IF (SLEN.GT.0) THEN
                  CALL XTNDW(SLEN)
                  CALL R4READ(MADRID(WPNTR),DBUF,PIXLS5,SUBDIM,SLEN)
               ENDIF
            ENDIF
         ENDIF
      ENDIF
      RETURN
C
C  write data
C
2000  CALL STKRDC('MID$IN',1,1,20,IAV,INPUTC,UNIT,NULLO,STAT)
      INSTRM = INPUTC(1:1)
      COPTIO(1) = 0
      COPTIO(3) = PRFLAG
C
      IF (INSTRM.NE.'F') THEN
         CALL STKRDC('INPUTC',1,1,80,IAV,INPUTC,UNIT,NULLO,STAT)
         CALL GENCNV(INPUTC,CVFLAG,40,IBUF,RBUF,DBUF,ACTVAL)
         IF (ACTVAL.LE.0) CALL STETER(1,'invalid data format...')      
         CALL STKRDC('P4',1,1,1,IAV,ALLFLG,UNIT,NULLO,STAT)
         IF ((ALLFLG.EQ.'A').OR.(ALLFLG.EQ.'a')) COPTIO(1) = 1
         COPTIO(2) = ACTVAL                !save max. input values
         CALL MAXDAT(RBUF,DBUF,ACTVAL)
      ELSE
C
C  get data from file used as input stream in MIDAS into temporary buffer
         CALL STFXMP(NOVAL,DATFMT,WPNTR2,STAT)
         CALL DATFIL(INPUTC(3:),CVFLAG,NOVAL,MADRID(WPNTR2),
     +               MADRID(WPNTR2),0,RBUF(1),RBUF(2))
         COPTIO(2) = NOVAL
         IF (CVFLAG.EQ.2) THEN
            CALL MAXDAT(MADRID(WPNTR2),DBUF,NOVAL)
         ELSE
            CALL MAXDAT(RBUF,MADRID(WPNTR2),NOVAL)
         ENDIF
      ENDIF
C
C  write a window
      IF (RWOPT.EQ.'W') THEN         
         IF(CVFLAG.EQ.2) THEN
            IF (INSTRM.NE.'F') THEN
               CALL R4WRIT(MADRID(WPNTR),PIXELS,RBUF,NOOUT,COPTIO,SLEN)
               IF (SLEN .GT. 0) THEN
                  CALL XTNDW(SLEN)
                  CALL R4WRIT(MADRID(WPNTR),PIXELS,RBUF,NOOUT,
     +                        COPTIO,SLEN)
               ENDIF
            ELSE
               CALL R4WRIT(MADRID(WPNTR),PIXELS,MADRID(WPNTR2),
     +                     NOOUT,COPTIO,SLEN)
               IF (SLEN .GT. 0) THEN
                  CALL XTNDW(SLEN)
                  CALL R4WRIT(MADRID(WPNTR),PIXELS,MADRID(WPNTR2),
     +                        NOOUT,COPTIO,SLEN)
               ENDIF
            ENDIF
         ELSE
            IF (INSTRM.NE.'F') THEN
               CALL R8WRIT(MADRID(WPNTR),PIXELS,DBUF,NOOUT,COPTIO,SLEN)
               IF (SLEN .GT. 0) THEN
                  CALL XTNDW(SLEN)
                  CALL R8WRIT(MADRID(WPNTR),PIXELS,DBUF,NOOUT,
     +                        COPTIO,SLEN)
               ENDIF
            ELSE
               CALL R8WRIT(MADRID(WPNTR),PIXELS,MADRID(WPNTR2),
     +                     NOOUT,COPTIO,SLEN)
               IF (SLEN .GT. 0) THEN
                  CALL XTNDW(SLEN)
                  CALL R8WRIT(MADRID(WPNTR),PIXELS,MADRID(WPNTR2),
     +                        NOOUT,COPTIO,SLEN)
               ENDIF
            ENDIF
         ENDIF
C
C  write sequentially
      ELSE
         IF(CVFLAG.EQ.2) THEN
            IF (INSTRM.NE.'F') THEN                 !data from command line
               NO = 0     
               CALL R4WRIT(MADRID(WPNTR),PIXLS1,RBUF,NOOUT,
     +                        COPTIO,SLEN)
               IF (SLEN .GT. 0) THEN
                  CALL XTNDW(SLEN)
                  CALL R4WRIT(MADRID(WPNTR),PIXLS1,RBUF,NOOUT,
     +                        COPTIO,SLEN)
               ENDIF
               IF (COPTIO(1).EQ.0) NO = NO + NOOUT
               IF (N2.GT.0) THEN
                  CALL R4WRIT(MADRID(WPNTR),PIXLS2,RBUF(NO+1),NOOUT,
     +                        COPTIO,SLEN)
                  IF (SLEN .GT. 0) THEN
                     CALL XTNDW(SLEN)
                     CALL R4WRIT(MADRID(WPNTR),PIXLS2,RBUF(NO+1),NOOUT,
     +                           COPTIO,SLEN)
                  ENDIF
                  IF (COPTIO(1).EQ.0) NO = NO + NOOUT
               ENDIF
               IF (N3.GT.0) THEN
                  CALL R4WRIT(MADRID(WPNTR),PIXLS3,RBUF(NO+1),NOOUT,
     +                        COPTIO,SLEN)
                  IF (SLEN .GT. 0) THEN
                     CALL XTNDW(SLEN)
                     CALL R4WRIT(MADRID(WPNTR),PIXLS3,RBUF(NO+1),NOOUT,
     +                           COPTIO,SLEN)
                  ENDIF
                  IF (COPTIO(1).EQ.0) NO = NO + NOOUT
               ENDIF
               IF (N4.GT.0) THEN
                  CALL R4WRIT(MADRID(WPNTR),PIXLS4,RBUF(NO+1),NOOUT,
     +                        COPTIO,SLEN)
                  IF (SLEN .GT. 0) THEN
                     CALL XTNDW(SLEN)
                     CALL R4WRIT(MADRID(WPNTR),PIXLS4,RBUF(NO+1),NOOUT,
     +                           COPTIO,SLEN)
                  ENDIF
                  IF (COPTIO(1).EQ.0) NO = NO + NOOUT
               ENDIF
               IF (N5.GT.0) THEN
                  CALL R4WRIT(MADRID(WPNTR),PIXLS5,RBUF(NO+1),NOOUT,
     +                        COPTIO,SLEN)
                  IF (SLEN .GT. 0) THEN
                     CALL XTNDW(SLEN)
                     CALL R4WRIT(MADRID(WPNTR),PIXLS5,RBUF(NO+1),NOOUT,
     +                           COPTIO,SLEN)
                  ENDIF
               ENDIF
C
            ELSE                                    !data come from file
               NO = 0                     
               WREST = WPNTR2              
               CALL R4WRIT(MADRID(WPNTR),PIXLS1,MADRID(WREST),NOOUT,
     +                     COPTIO,SLEN)
               IF (SLEN .GT. 0) THEN
                  CALL XTNDW(SLEN)
                  CALL R4WRIT(MADRID(WPNTR),PIXLS1,MADRID(WREST),NOOUT,
     +                        COPTIO,SLEN)
               ENDIF
               IF (COPTIO(1).EQ.0) NO = NO + NOOUT
               IF (N2.GT.0) THEN
                  WREST = WPNTR2 + NO
                  CALL R4WRIT(MADRID(WPNTR),PIXLS2,MADRID(WREST),NOOUT,
     +                        COPTIO,SLEN)
                  IF (SLEN .GT. 0) THEN
                     CALL XTNDW(SLEN)
                     CALL R4WRIT(MADRID(WPNTR),PIXLS2,MADRID(WREST),
     +                           NOOUT,COPTIO,SLEN)
                  ENDIF
                  IF (COPTIO(1).EQ.0) NO = NO + NOOUT
               ENDIF
               IF (N3.GT.0) THEN
                  WREST = WPNTR2 + NO
                  CALL R4WRIT(MADRID(WPNTR),PIXLS3,MADRID(WREST),NOOUT,
     +                        COPTIO,SLEN)
                  IF (SLEN .GT. 0) THEN
                     CALL XTNDW(SLEN)
                     CALL R4WRIT(MADRID(WPNTR),PIXLS3,MADRID(WREST),
     +                           NOOUT,COPTIO,SLEN)
                  ENDIF
                  IF (COPTIO(1).EQ.0) NO = NO + NOOUT
               ENDIF
               IF (N4.GT.0) THEN
                  WREST = WPNTR2 + NO
                  CALL R4WRIT(MADRID(WPNTR),PIXLS4,MADRID(WREST),NOOUT,
     +                        COPTIO,SLEN)
                  IF (SLEN .GT. 0) THEN
                     CALL XTNDW(SLEN)
                     CALL R4WRIT(MADRID(WPNTR),PIXLS4,MADRID(WREST),
     +                           NOOUT,COPTIO,SLEN)
                  ENDIF
                  IF (COPTIO(1).EQ.0) NO = NO + NOOUT
               ENDIF
               IF (N5.GT.0) THEN
                  WREST = WPNTR2 + NO
                  CALL R4WRIT(MADRID(WPNTR),PIXLS5,MADRID(WREST),NOOUT,
     +                        COPTIO,SLEN)
                  IF (SLEN .GT. 0) THEN
                     CALL XTNDW(SLEN)
                     CALL R4WRIT(MADRID(WPNTR),PIXLS5,MADRID(WREST),
     +                           NOOUT,COPTIO,SLEN)
                  ENDIF
               ENDIF
            ENDIF
C
C process double data
C 
         ELSE
            IF (INSTRM.NE.'F') THEN                 !data from command line
               NO = 0
               CALL R8WRIT(MADRID(WPNTR),PIXLS1,DBUF,NOOUT,COPTIO,
     +                     SLEN)
               IF (SLEN .GT. 0) THEN
                  CALL XTNDW(SLEN)
                  CALL R8WRIT(MADRID(WPNTR),PIXLS1,DBUF,NOOUT,COPTIO,
     +                        SLEN)
               ENDIF
               IF (COPTIO(1).EQ.0) NO = NO + NOOUT
               IF (N2.GT.0) THEN
                  CALL R8WRIT(MADRID(WPNTR),PIXLS2,DBUF(NO+1),NOOUT,
     +                        COPTIO,SLEN)
                  IF (SLEN .GT. 0) THEN
                     CALL XTNDW(SLEN)
                     CALL R8WRIT(MADRID(WPNTR),PIXLS2,DBUF(NO+1),
     +                           NOOUT,COPTIO,SLEN)
                  ENDIF
                  IF (COPTIO(1).EQ.0) NO = NO + NOOUT
               ENDIF
               IF (N3.GT.0) THEN
                  CALL R8WRIT(MADRID(WPNTR),PIXLS3,DBUF(NO+1),NOOUT,
     +                        COPTIO,SLEN)
                  IF (SLEN .GT. 0) THEN
                     CALL XTNDW(SLEN)
                     CALL R8WRIT(MADRID(WPNTR),PIXLS3,DBUF(NO+1),NOOUT,
     +                           COPTIO,SLEN)
                  ENDIF
                  IF (COPTIO(1).EQ.0) NO = NO + NOOUT
               ENDIF
               IF (N4.GT.0) THEN
                  CALL R8WRIT(MADRID(WPNTR),PIXLS4,DBUF(NO+1),NOOUT,
     +                        COPTIO,SLEN)
                  IF (SLEN .GT. 0) THEN
                     CALL XTNDW(SLEN)
                     CALL R8WRIT(MADRID(WPNTR),PIXLS4,DBUF(NO+1),NOOUT,
     +                           COPTIO,SLEN)
                  ENDIF
                  IF (COPTIO(1).EQ.0) NO = NO + NOOUT
               ENDIF
               IF (N5.GT.0) THEN
                  CALL R8WRIT(MADRID(WPNTR),PIXLS5,DBUF(NO+1),NOOUT,
     +                        COPTIO,SLEN)
                  IF (SLEN .GT. 0) THEN
                     CALL XTNDW(SLEN)
                     CALL R8WRIT(MADRID(WPNTR),PIXLS5,DBUF(NO+1),NOOUT,
     +                           COPTIO,SLEN)
                  ENDIF
               ENDIF
C
            ELSE                                    !data come from file
               NO = 0
               WREST = WPNTR2
               CALL R8WRIT(MADRID(WPNTR),PIXLS1,MADRID(WREST),NOOUT,
     +                     COPTIO,SLEN)
               IF (SLEN .GT. 0) THEN
                  CALL XTNDW(SLEN)
                  CALL R8WRIT(MADRID(WPNTR),PIXLS1,MADRID(WREST),NOOUT,
     +                        COPTIO,SLEN)
               ENDIF
               IF (COPTIO(1).EQ.0) NO = NO + NOOUT
               IF (N2.GT.0) THEN
                  WREST = WPNTR2 + 2*NO              !double data...
                  CALL R8WRIT(MADRID(WPNTR),PIXLS2,MADRID(WREST),NOOUT,
     +                        COPTIO,SLEN)
                  IF (SLEN .GT. 0) THEN
                     CALL XTNDW(SLEN)
                     CALL R8WRIT(MADRID(WPNTR),PIXLS2,MADRID(WREST),
     +                           NOOUT,COPTIO,SLEN)
                  ENDIF
                  IF (COPTIO(1).EQ.0) NO = NO + NOOUT
               ENDIF
               IF (N3.GT.0) THEN
                  WREST = WPNTR2 + 2*NO              !double data...
                  CALL R8WRIT(MADRID(WPNTR),PIXLS3,MADRID(WREST),NOOUT,
     +                        COPTIO,SLEN)
                  IF (SLEN .GT. 0) THEN
                     CALL XTNDW(SLEN)
                     CALL R8WRIT(MADRID(WPNTR),PIXLS3,MADRID(WREST),
     +                           NOOUT,COPTIO,SLEN)
                  ENDIF
                  IF (COPTIO(1).EQ.0) NO = NO + NOOUT
               ENDIF
               IF (N4.GT.0) THEN
                  WREST = WPNTR2 + 2*NO              !double data...
                  CALL R8WRIT(MADRID(WPNTR),PIXLS4,MADRID(WREST),NOOUT,
     +                        COPTIO,SLEN)
                  IF (SLEN .GT. 0) THEN
                     CALL XTNDW(SLEN)
                     CALL R8WRIT(MADRID(WPNTR),PIXLS4,MADRID(WREST),
     +                           NOOUT,COPTIO,SLEN)
                  ENDIF
                  IF (COPTIO(1).EQ.0) NO = NO + NOOUT
               ENDIF
               IF (N5.GT.0) THEN
                  WREST = WPNTR2 + 2*NO              !double data...
                  CALL R8WRIT(MADRID(WPNTR),PIXLS5,MADRID(WREST),NOOUT,
     +                        COPTIO,SLEN)
                  IF (SLEN .GT. 0) THEN
                     CALL XTNDW(SLEN)
                     CALL R8WRIT(MADRID(WPNTR),PIXLS5,MADRID(WREST),
     +                           NOOUT,COPTIO,SLEN)
                  ENDIF
               ENDIF
            ENDIF
         ENDIF
      ENDIF
      RETURN
C
C  here for syntax errors from reading
9900  CALL STETER
     + (2,'invalid pixel specification - check syntax or dimensions')
      RETURN
C
      END

      SUBROUTINE DATATB(FRAME,START,STEP,AC,INPUTC,PRFLAG)
C 
C   AC(1:1) = W(rite) or R(ead)
C
      IMPLICIT NONE
C
      INTEGER      PRFLAG,COPTIO(3)
      INTEGER      N,COOCNT,COOMAX,COLMX,RWCNT
      INTEGER      IMNO,NAXIS,DATFMT,CVFLAG,MAXNO
      INTEGER*8    WPNTR
      INTEGER      IMNOW,MAPSIZ,NOHEAD
      INTEGER      STAT,NOOUT,FIRTIM,IBUF(1)
      INTEGER      NPIX(3),SUBDIM,SIZFLG
      INTEGER      PIXELS(3,2)
      INTEGER      TID,TABNUL(5),COLNUM(5),SINGLE
      INTEGER      MADRID(1),IAV,UNIT(1),NULLO
C
      CHARACTER    FRAME*(*),INPUTC*(*),AC*(*)
      CHARACTER    OUTPUT*200
      CHARACTER    TABLE*80,TLABL1(4)*16,TLABL2(2)*16
C
      DOUBLE PRECISION START(3),STEP(3)
      DOUBLE PRECISION DBUF(10),DCONST
      DOUBLE PRECISION DMIN,DMAX
C 
      REAL         RBUF(10),RCONST
      REAL         CUTS(4)
C 
      LOGICAL      SELFLG
C 
      INCLUDE  'MID_INCLUDE:ST_DEF.INC'
C 
      COMMON    /VMR/ MADRID
      COMMON    /SVCUTS/  CUTS,DMIN,DMAX
      COMMON    /WSPACE/  IMNOW,MAPSIZ,NOHEAD
      COMMON    /IMINFO/  IMNO,DATFMT,CVFLAG,MAXNO,NAXIS,NPIX
      COMMON    /ALLOC/  WPNTR
C
      DATA      PIXELS    /6*1/
      DATA      TLABL1 /'XSTART ','YSTART ','XEND ','YEND '/
      DATA      TLABL2 /'X_PIX ','Y_PIX '/
C
      INCLUDE  'MID_INCLUDE:ST_DAT.INC'
C 
      COOCNT = 0
      SUBDIM = 2
      FIRTIM = 1
C 
C  subframes are input via table
C 
      CALL CLNTAB(INPUTC(1:80),TABLE,0)
      CALL TBTOPN(TABLE,F_I_MODE,TID,STAT)
      CALL TBIGET(TID,N,COOMAX,N,N,N,STAT)          !COOMAX total no. of rows
C 
      COPTIO(3) = PRFLAG
      CALL TBLSER(TID,TLABL1(1),COLNUM(1),STAT)
      IF (COLNUM(1).LE.0) THEN                     !single pixels?
         DO 200, N=1,2
            CALL TBLSER(TID,TLABL2(N),COLNUM(N),STAT)
            IF (COLNUM(N).LE.0) THEN
               OUTPUT(1:) = 'column '//TLABL2(N)//
     +                      ' missing in table '//TABLE
               CALL STETER(9,OUTPUT)
            ENDIF
200      CONTINUE
         SINGLE = 1
C 
      ELSE
         DO 300, N=1,4
            CALL TBLSER(TID,TLABL1(N),COLNUM(N),STAT)
            IF (COLNUM(N).LE.0) THEN
               OUTPUT(1:) = 'column '//TLABL1(N)//
     +                      ' missing in table '//TABLE
               CALL STETER(9,OUTPUT)
            ENDIF
300      CONTINUE
         SINGLE = 0                                !we have a regionto fill
      ENDIF
C 
      COLMX = 4
      IF (AC(1:1).EQ.'W') THEN                   !check if value column
         CALL STKRDC('INPUTC',1,1,80,IAV,INPUTC,UNIT,NULLO,STAT)
         CALL GENCNV(INPUTC,4,1,IBUF,RBUF,DBUF,IAV)
C 
         IF (IAV.LE.0) THEN                      !no input data, try :VALUE1
            CALL TBLSER(TID,'VALUE1',COLNUM(5),STAT)
            IF (COLNUM(5).GT.0) THEN
               COLMX = 5
            ELSE                                 !try :VALUE
               CALL TBLSER(TID,'VALUE',COLNUM(5),STAT)
               IF (COLNUM(5).GT.0) THEN
                  COLMX = 5
               ELSE
                  CALL STETER(11,'missing column :VALUE1 or :VALUE ...')      
               ENDIF
            ENDIF
         ELSE
            IF (CVFLAG.EQ.2) THEN
               RCONST = SNGL(DBUF(1))
            ELSE
               DCONST = DBUF(1)
            ENDIF
         ENDIF
      ENDIF
C
C  loop to read from table
C
      RWCNT = 0
500   IF (COOCNT.GE.COOMAX) THEN
         CALL TBTCLO(TID,STAT)
         WRITE(OUTPUT,40000) RWCNT
         CALL STTPUT(OUTPUT,STAT)
         CALL STKWRI('OUTPUTI',RWCNT,1,1,OFF,STAT)
         RETURN
      ENDIF

C
C  handle input from a table
      N = COOCNT + 1
      CALL TBSGET(TID,N,SELFLG,STAT)
C 
C  process selected rows
      IF (SELFLG) THEN
         RWCNT = RWCNT + 1
         IF (SINGLE .EQ. 0) THEN                 !x,y coords interval
            CALL TBRRDR(TID,N,COLMX,COLNUM(1),RBUF,TABNUL,STAT)
            PIXELS(1,1) = NINT( (RBUF(1) - START(1)) / STEP(1) ) + 1
            IF ((PIXELS(1,1).LE.0) .OR.(PIXELS(1,1).GT.NPIX(1))) 
     +         GOTO 9090
            PIXELS(1,2) = NINT( (RBUF(3) - START(1)) / STEP(1) ) + 1
            IF ((PIXELS(1,2).LE.0) .OR.(PIXELS(1,2).GT.NPIX(1))) 
     +         GOTO 9090
            PIXELS(2,1) = NINT( (RBUF(2) - START(2)) / STEP(2) ) + 1
            IF ((PIXELS(2,1).LE.0) .OR.(PIXELS(2,1).GT.NPIX(2))) 
     +         GOTO 9090
            PIXELS(2,2) = NINT( (RBUF(4) - START(2)) / STEP(2) ) + 1
            IF ((PIXELS(2,2).LE.0) .OR.(PIXELS(2,2).GT.NPIX(2))) 
     +         GOTO 9090
         ELSE                                    !single x,y pixel
            CALL TBRRDR(TID,N,2,COLNUM(1),RBUF,TABNUL,STAT)
            PIXELS(1,1) = NINT(RBUF(1))
            PIXELS(1,2) = PIXELS(1,1)
            RBUF(3) = RBUF(1)
            PIXELS(2,1) = NINT(RBUF(2))
            PIXELS(2,2) = PIXELS(2,1)
            RBUF(4) = RBUF(2)
            CALL TBRRDR(TID,N,1,COLNUM(5),RBUF(5),TABNUL,STAT)
         ENDIF
C
C  read or print data
C
         IF (AC(1:1).NE.'W') THEN
            CALL R4READ(MADRID(WPNTR),DBUF,PIXELS,SUBDIM,SIZFLG)
            IF (SIZFLG.GT.0) THEN
               CALL XTNDW(SIZFLG)
               CALL R4READ(MADRID(WPNTR),DBUF,PIXELS,SUBDIM,
     +                     SIZFLG)
            ENDIF
C
C  write data
C
         ELSE
            IF (FIRTIM .EQ. 1) THEN
               FIRTIM = 0
               N = INDEX(FRAME,' ')
               IF (N.LT.1) N = 81
               OUTPUT(1:) = 'image '//FRAME(1:(N-1))//
     +                      ' filled from table '//TABLE
               CALL STTPUT(OUTPUT,STAT)
               OUTPUT(1:) = 'row no.   frame pix(x,y) '
               IF (SINGLE .EQ. 0) THEN
                  OUTPUT(28:) = 'world coords(x,y) '
                  OUTPUT(50:) = 'value '
               ELSE
                  OUTPUT(30:) = 'value '
               ENDIF
               CALL STTPUT(OUTPUT,STAT)
            ENDIF
C 
            IF (COLMX.EQ.5) THEN                   !value from table
               IF (CVFLAG.EQ.2) THEN
                  RCONST = RBUF(5)
               ELSE
                  DCONST = DBLE(RBUF(5))
               ENDIF
            ENDIF                                  !else from command line
C 
            IF (SINGLE .EQ. 1) THEN                !write pixel window
               COPTIO(2) = 1
               IF (CVFLAG.EQ.2) THEN
                  WRITE(OUTPUT,20005) 
     +               (COOCNT+1),RBUF(1),RBUF(2),RCONST
                  RBUF(1) = RCONST
               ELSE
                  WRITE(OUTPUT,20015) 
     +               (COOCNT+1),RBUF(1),RBUF(2),DCONST
                  DBUF(1) = DCONST
               ENDIF
               CALL STTPUT(OUTPUT,STAT)
            ELSE                                   !write single pixel 
               RBUF(6) = PIXELS(1,1)
               RBUF(7) = PIXELS(2,1)
               IF (CVFLAG.EQ.2) THEN
                  WRITE(OUTPUT,10005) 
     +            (COOCNT+1),RBUF(6),RBUF(7),RBUF(1),RBUF(2),RCONST
                  RBUF(1) = RCONST
               ELSE
                  WRITE(OUTPUT,10015) 
     +            (COOCNT+1),RBUF(6),RBUF(7),RBUF(1),RBUF(2),DCONST
                  DBUF(1) = DCONST
               ENDIF
               CALL STTPUT(OUTPUT,STAT)
               RBUF(6) = PIXELS(1,2)
               RBUF(7) = PIXELS(2,2)
               WRITE(OUTPUT,10006) RBUF(6),RBUF(7),RBUF(3),RBUF(4)
               CALL STTPUT(OUTPUT,STAT)
            ENDIF
            OUTPUT(1:) = ' '
CC            CALL STTPUT(OUTPUT,STAT)
C 
            COPTIO(1) = 1
            IF (CVFLAG.EQ.2) THEN                !single prec.
               IF (RBUF(1).LT.CUTS(3)) THEN
                  CUTS(3) = RBUF(1)
               ELSE IF (RBUF(1).GT.CUTS(4)) THEN
                  CUTS(4) = RBUF(1)
               ENDIF
            ELSE                                 !double prec.
               IF (DBUF(1).LT.DMIN) THEN
                  DMIN = DBUF(1)
               ELSE IF (DBUF(1).GT.DMAX) THEN
                  DMAX = DBUF(1)
               ENDIF
            ENDIF
            IF (CVFLAG.EQ.2) THEN                !single prec.
               CALL R4WRIT(MADRID(WPNTR),PIXELS,RBUF,NOOUT,COPTIO,
     +                     SIZFLG)
               IF (SIZFLG .GT. 0) THEN
                  CALL XTNDW(SIZFLG)
                  CALL R4WRIT(MADRID(WPNTR),PIXELS,RBUF,NOOUT,
     +                        COPTIO,SIZFLG)
               ENDIF
            ELSE                                 !double prec.
               CALL R8WRIT(MADRID(WPNTR),PIXELS,DBUF,NOOUT,COPTIO,
     +                     SIZFLG)
               IF (SIZFLG .GT. 0) THEN
                  CALL XTNDW(SIZFLG)
                  CALL R8WRIT(MADRID(WPNTR),PIXELS,DBUF,NOOUT,
     +                        COPTIO,SIZFLG)
               ENDIF
            ENDIF
         ENDIF
C
         IF (CVFLAG.EQ.2) THEN                !single prec.
            DMIN = CUTS(3)
            DMAX = CUTS(4)
         ENDIF
      ENDIF
C 
      COOCNT = COOCNT + 1
      GOTO 500
C
C  here for coordinates out of range 
9090  CALL STETER(3,'wrong coordinates in table ...')
      RETURN
C 
10005 FORMAT(I5,3X,2F8.1,4X,2G12.6,1X,G12.6)
10006 FORMAT(2F8.1,4X,2G12.6)
10015 FORMAT(I5,3X,2F8.1,4X,2G12.6,1X,G20.13)
20005 FORMAT(I5,3X,2F8.1,4X,G12.6)
20015 FORMAT(I5,3X,2F8.1,4X,G20.13)
40000 FORMAT('no. of rows processed = ',I5)
      END

      SUBROUTINE DATACU(FRAME,SIZE,AC,PRFLAG)
C
      IMPLICIT NONE
C
      INTEGER      PRFLAG,ACTVAL,COPTIO(3)
      INTEGER      IMNO,NAXIS,NPIX(3),SIZE,IOFF,DATFMT
      INTEGER*8    WPNTR
      INTEGER      IMNOW,MAPSIZ,NOHEAD,CVFLAG,MAXNO
      INTEGER      N,IAV,COOCNT,COOMAX,COOFF
      INTEGER      STAT,LFLAGS(2),ST1,ST2,NOOUT
      INTEGER      FIRTIM,SIZFLG,IBUF(1)
      INTEGER      PIXELS(3,2),NOPIX,NOLIN,INPUTI(3)
      INTEGER      CHNL,XY1(2),XY2(2),WW(4)
      INTEGER      KPIX(2),COOS(4),XFIGU(5),YFIGU(5)
      INTEGER      UNIT(1),NULLO
      INTEGER      MADRID(1)
C
      CHARACTER    FRAME*(*),OUTPUT*200,COCO*8,STR*40
      CHARACTER    INPUTC*80,AC*4,CBUF*60
C
      DOUBLE PRECISION DBUF(10)
      DOUBLE PRECISION DMIN,DMAX
C 
      REAL         RBUF(10)
      REAL         PIXL1(6),PIXL2(6)
      REAL         TEMP(2)
      REAL         CUTS(4)
C 
      INCLUDE  'MID_INCLUDE:ST_DEF.INC'
C 
      INCLUDE  'MID_INCLUDE:IDIDEV.INC'
      INCLUDE  'MID_INCLUDE:IDIMEM.INC'
C 
      COMMON    /VMR/ MADRID
      COMMON    /SVCUTS/  CUTS,DMIN,DMAX
      COMMON    /WSPACE/  IMNOW,MAPSIZ,NOHEAD
      COMMON    /IMINFO/  IMNO,DATFMT,CVFLAG,MAXNO,NAXIS,NPIX
      COMMON    /ALLOC/  WPNTR
C
      DATA      PIXELS   /6*1/
      DATA      CHNL     /0/
      DATA      COOS     /-1,-1,-1,-1/
C
      INCLUDE  'MID_INCLUDE:ST_DAT.INC'
C 
      COOCNT = 0
      FIRTIM = 1
      NOPIX = 1
      NOLIN = 1
      LFLAGS(1) = -99                        !indicate main display window
      LFLAGS(2) = D_R4_FORMAT                !we opened frame as R*4
C 
      CALL STKRDI('INPUTI',1,3,IAV,INPUTI,UNIT,NULLO,STAT)
      IF (INPUTI(1).EQ.0) THEN
         OUTPUT(1:) = 'press ENTER to '
      ELSE
         OUTPUT(1:) = 'move Cursor to '
      ENDIF
      IOFF = 16
      IF (AC(1:1).NE.'W') THEN
         OUTPUT(IOFF:) = 'read '
         IOFF = 21
      ELSE
         OUTPUT(IOFF:) = 'write '
         IOFF = 22
      ENDIF
      CVFLAG = 2                             !always set to single float
C
C  get Image Display unit + attach it, get max. coord readings
      CALL DTOPEN(1,STAT)
      CALL STKRDI('CURSOR',1,1,IAV,COOMAX,UNIT,NULLO,STAT)
      IF (AC(3:3).EQ.'2') THEN
         CALL SETCUR(QDSPNO,2,1,2,COOS,STAT)
         OUTPUT(IOFF:) = 'pixels inside cursor window '
      ELSE
         CALL SETCUR(QDSPNO,0,3,2,COOS,STAT)
         IF (AC(3:3).EQ.'1') THEN
            OUTPUT(IOFF:) = 'pixel with cursor '
         ELSE
            NOPIX = INPUTI(2)           !no of pixels to modify
            IF (NOPIX.LT.1) NOPIX = 1
            NOPIX = NOPIX/2
            ST1 = 2*NOPIX + 1           !make sure it's odd no. of pixels
            IF (ST1.GT.NPIX(1)/2) THEN  !x-size < NPIX(1)/2
               NOPIX = NPIX(1)/4
               ST1 = 2*NOPIX + 1 
            ENDIF
            NOLIN = INPUTI(3)           !no of lines to modify
            IF (NOLIN.LT.1) NOLIN = 1
            NOLIN = NOLIN/2
            ST2 = 2*NOLIN + 1           !make sure it's odd no. of lines
            IF (ST2.GT.NPIX(2)/2) THEN  !y-size < NPIX(2)/2
               NOLIN = NPIX(2)/4
               ST2 = 2*NOLIN + 1
            ENDIF
C
            SIZFLG = ST2*NPIX(1)        !we have a fixed window
            IF (SIZFLG.GT.MAPSIZ) CALL XTNDW(SIZFLG)       !extend if necessary
C 
            WRITE(STR,10007) ST1
            IOFF = 1
            IF (ST1 .LT. 100) IOFF = IOFF + 1
            IF (ST1 .LT. 10) IOFF = IOFF + 1
            IAV = 4 - IOFF + 1          !length of string + 1
            OUTPUT(1:) = STR(IOFF:)
            OUTPUT(IAV:) = ' x '
            IAV = IAV + 3
            WRITE(STR,10007) ST2
            IOFF = 1
            IF (ST2 .LT. 100) IOFF = IOFF + 1
            IF (ST2 .LT. 10) IOFF = IOFF + 1
            OUTPUT(IAV:) = STR(IOFF:)
            IAV = IAV + 4 - IOFF 
            OUTPUT(IAV:) = ' pixel window around cursor '
         ENDIF
      ENDIF
 
      CALL STTDIS(OUTPUT,0,STAT)
      IF (INPUTI(1).EQ.0) THEN
         COCO(1:) = 'NNYY?C0 '                !wait for ENTER button
      ELSE
         COCO(1:) = 'NNYZ?C0 '                !get cursor coord continuously
      ENDIF
C 
      IF (AC(1:1).EQ.'W') THEN
         CALL STKRDC('INPUTC',1,1,80,IAV,INPUTC,UNIT,NULLO,STAT)
         CALL GENCNV(INPUTC,CVFLAG,1,IBUF,RBUF,DBUF,ACTVAL)
         IF (ACTVAL.LE.0) CALL STETER(1,'invalid data format...')      
         COPTIO(1) = 1
         COPTIO(3) = PRFLAG
         IF (RBUF(1).LT.CUTS(3)) THEN
            CUTS(3) = RBUF(1)
         ELSE IF (RBUF(1).GT.CUTS(4)) THEN
            CUTS(4) = RBUF(1)
         ENDIF
         DMIN = CUTS(3)
         DMAX = CUTS(4)
      ENDIF
C 
      COOFF = 0
      CBUF(1:) = ' '
C
C  read cursor positions
C
500   IF (COOCNT.GE.COOMAX) GOTO 9000
      CALL GETCUR(COCO,CBUF,
     +            XY1,PIXL1(3),PIXL1(5),RBUF(10),ST1,
     +            XY2,PIXL2(3),PIXL2(5),RBUF(10),ST2)
C
C  if cursors are not switched on initially, display info message
      IF ((ST1.EQ.0).AND.(ST2.EQ.0)) THEN
         IF ((COOCNT.EQ.0) .AND. (COOFF.EQ.0)) THEN
            CBUF(1:) = ' '                    !reinitialize in GETCUR
            CALL STTPUT
     +      ('switch cursor(s) on - next time we exit...',STAT)
            COOFF = 1
            GOTO 500
         ELSE
            IF ((AC(3:3).EQ.'C').AND.(FIRTIM.NE.1))
     +         CALL IIGPLY(QDSPNO,QOVCH,XFIGU,YFIGU,5,99,1,STAT)
            IF (AC(1:1).NE.'W') 
     +         CALL R4CNTR(MADRID(WPNTR),PIXELS,'X',SIZFLG)
            GOTO 9000
         ENDIF
      ELSE
         COOCNT = COOCNT + 1
      ENDIF
C 
      IF (AC(3:3) .EQ. 'C') THEN 
         IF (FIRTIM.NE.1)
     +      CALL IIGPLY(QDSPNO,QOVCH,XFIGU,YFIGU,5,99,1,STAT)
      ENDIF
      FIRTIM = 0
      ST1 = PIXL1(3)
      ST2 = PIXL1(4)
      IF (AC(3:3) .EQ. 'C') THEN 
         PIXELS(1,1) = ST1 - NOPIX               !NOPIX = npix/2
         IF (PIXELS(1,1).LT.1) PIXELS(1,1) = 1
         PIXELS(2,1) = ST2 - NOLIN               !NOLIN = nlines/2
         IF (PIXELS(2,1).LT.1) PIXELS(2,1) = 1
         PIXELS(1,2) = ST1 + NOPIX
         IF (PIXELS(1,2).GT.NPIX(1)) PIXELS(1,2) = NPIX(1)
         PIXELS(2,2) = ST2 + NOLIN
         IF (PIXELS(2,2).GT.NPIX(2)) PIXELS(2,2) = NPIX(2)
      ENDIF
C 
      IF (AC(1:1).EQ.'W') THEN
         IF (AC(3:3).EQ.'1') THEN
            WRITE(OUTPUT,10004) ST1,ST2
         ELSEIF (AC(3:3).EQ.'C') THEN
            WRITE(OUTPUT,10005) 
     +            PIXELS(1,1),PIXELS(2,1),PIXELS(1,2),PIXELS(2,2)
         ELSE
            WW(1) = PIXL2(3)
            WW(2) = PIXL2(4)
            WRITE(OUTPUT,10005) ST1,ST2,WW(1),WW(2)
         ENDIF
         CALL STTPUT(OUTPUT,STAT)
      ENDIF
C 
C  setup boundaries of data window
      IF (AC(3:3) .EQ. '1') THEN
         PIXELS(1,1) = ST1                  !1 cursor, single pixel
         PIXELS(2,1) = ST2
         PIXELS(1,2) = ST1
         PIXELS(2,2) = ST2
         XFIGU(1) = XY1(1)
         YFIGU(2) = XY1(2)
      ELSEIF (AC(3:3) .EQ. 'C') THEN        !1 cursor, NOPIX*NOLIN window
         IF (SCALX .LT. 0) THEN
            IAV = NOPIX * (-SCALX)
         ELSEIF (SCALX .GT. 1) THEN
            IAV = NOPIX / SCALX
         ELSE 
            IAV = NOPIX
         ENDIF
         COOS(1) = XY1(1) - IAV
         COOS(3) = XY1(1) + IAV
         IF (SCALY .LT. 0) THEN
            IAV = NOLIN * (-SCALX)
         ELSEIF (SCALY .GT. 1) THEN
            IAV = NOLIN / SCALX
         ELSE 
            IAV = NOLIN
         ENDIF
         COOS(2) = XY1(2) - IAV
         COOS(4) = XY1(2) + IAV
         TEMP(1) = -1.0                     !not used...
         TEMP(2) = -1.0
         CALL BLDGRA('REC',COOS,TEMP,XFIGU,YFIGU,5,IAV)
      ELSE
         PIXELS(1,1) = ST1                  !2 cursors => pixel window
         PIXELS(2,1) = ST2
         PIXELS(1,2) = PIXL2(3)  
         PIXELS(2,2) = PIXL2(4)
         XFIGU(1) = XY1(1)
         YFIGU(1) = XY1(2)
      ENDIF
C
C  read or print data
C
      IF (AC(1:1).NE.'W') THEN
         IF (AC(3:3) .EQ. 'C') 
     +      CALL IIGPLY(QDSPNO,QOVCH,XFIGU,YFIGU,5,99,1,STAT)
         CALL R4CNTR(MADRID(WPNTR),PIXELS,AC(3:3),SIZFLG)
         IF (SIZFLG.GT.0) THEN
            CALL XTNDW(SIZFLG)
            CALL R4CNTR(MADRID(WPNTR),PIXELS,AC(3:3),SIZFLG)
         ENDIF
         FIRTIM = 0
C
C  write data
C
      ELSE
         CALL R4WRIT(MADRID(WPNTR),PIXELS,RBUF,NOOUT,COPTIO,SIZFLG)
         IF (SIZFLG .GT. 0) THEN
            CALL XTNDW(SIZFLG)
            CALL R4WRIT(MADRID(WPNTR),PIXELS,RBUF,NOOUT,COPTIO,SIZFLG)
         ENDIF
         KPIX(1) = PIXELS(1,2) - PIXELS(1,1) + 1
         KPIX(2) = PIXELS(2,2) - PIXELS(2,1) + 1
         XY2(1) = PIXELS(1,1)
         XY2(2) = PIXELS(2,1)
         WW(1) = XFIGU(1)
         WW(2) = YFIGU(1)
         WW(3) = SCALX
         WW(4) = SCALY
         CALL LOADWN(LFLAGS,IMNO,NPIX,XY2,KPIX,WW,CUTS)
         IF (AC(3:3) .EQ. 'C')  
     +      CALL IIGPLY(QDSPNO,QOVCH,XFIGU,YFIGU,5,99,1,STAT)
      ENDIF
      GOTO 500
C
9000  CALL DTCLOS(QDSPNO)
      RETURN
C 
10004 FORMAT('frame pixels(x,y): ',I6,',',I6)
10005 FORMAT('frame pixels(x,y): ',I6,',',I6,' to: ',I6,',',I6)
10006 FORMAT('central line =',I6,', central pixel = ',I6)
10007 FORMAT(I3)
      END

      SUBROUTINE XTNDW(SIZFLG)
C
      IMPLICIT NONE
C
      INTEGER      NAXIS,NPIX(3)
      INTEGER      SIZFLG,IMNO,DATFMT,CVFLAG,MAXNO
      INTEGER*8    WPNTR
      INTEGER      STAT,IAV,IMNOW,MAPSIZ,NOHEAD
C
      INCLUDE  'MID_INCLUDE:ST_DEF.INC'
C
      COMMON    /WSPACE/  IMNOW,MAPSIZ,NOHEAD
      COMMON    /IMINFO/  IMNO,DATFMT,CVFLAG,MAXNO,NAXIS,NPIX
      COMMON    /ALLOC/  WPNTR
C
      INCLUDE  'MID_INCLUDE:ST_DAT.INC'
C
      CALL STFCLO(IMNOW,STAT)
      MAPSIZ = SIZFLG
      CALL STFCRE('wworrkfr',DATFMT,F_X_MODE,F_IMA_TYPE,
     +            MAPSIZ,IMNOW,STAT)
      CALL STFMAP(IMNOW,F_X_MODE,1,MAPSIZ,IAV,WPNTR,STAT)
C 
      RETURN
      END

      SUBROUTINE R4CNTR(ARRAY,PIX,FLAG,SIZFLG)
C
      IMPLICIT NONE
C
      INTEGER      IMNO,NAXIS,PIX(3,2),NPIX(3),SIZFLG,DATFMT,CVFLAG
      INTEGER      HIX,LOWX,HIY,LOWY,CNTY,LOWZ,N,NN,NNN,NX,NY,NZ
      INTEGER      LINBEG,K,M,OFF,STAT
      INTEGER      IMNOW,MAPSIZ,NOHEAD,MAXNO
C
      REAL         ARRAY(*)
      REAL         TEMP(5)
C
      CHARACTER    FLAG*1
      CHARACTER*80 OUTPUT
C 
      COMMON    /WSPACE/  IMNOW,MAPSIZ,NOHEAD
      COMMON    /IMINFO/  IMNO,DATFMT,CVFLAG,MAXNO,NAXIS,NPIX
C
C  init + setup bounds
      NX = PIX(1,2) - PIX(1,1) + 1
      NY = PIX(2,2) - PIX(2,1) + 1
      NZ = PIX(3,2) - PIX(3,1) + 1
      LOWX = PIX(1,1)
      HIX = LOWX + NX - 1
      LOWY = PIX(2,1)
      CNTY = LOWY + NY/2
      LOWZ = PIX(3,1)
      HIY = LOWY + NY - 1
C 
C  check for cleanup 
      IF (FLAG.EQ.'X') THEN
         IF (NX.GT.20) NX = 20
         OFF = 0                                   !just set it to something...
         CALL STKWRR('OUTPUTR',ARRAY,1,NX,OFF,STAT)
         RETURN
      ENDIF
C
C  total size we have to read in
      NNN = NY*NPIX(1) + (NZ-1)*NPIX(1)*NPIX(2)
      IF (NNN.GT.MAPSIZ) THEN
         SIZFLG = NNN
         RETURN
      ELSE
         SIZFLG = 0
      ENDIF
C
      IF (FLAG.EQ.'1') THEN
         WRITE(OUTPUT,10001) HIY,HIX
      ELSE
         WRITE(OUTPUT,10002) HIY,LOWY,LOWX,HIX
      ENDIF
      CALL STTPUT(OUTPUT,STAT)
C 
      OFF = LOWX + (LOWY-1)*NPIX(1) + (LOWZ-1)*NPIX(1)*NPIX(2)
      CALL STFGET(IMNO,OFF,NNN,K,ARRAY,STAT)
      IF (FLAG.EQ.'C') THEN
         GOTO 2000
      ELSEIF (FLAG.EQ.'1') THEN
         WRITE(OUTPUT,10003) ARRAY(1)
         CALL STTPUT(OUTPUT,STAT)
         RETURN
      ENDIF
C
C  display contents of 2-dim ARRAY
      OFF = (NY-1) * NPIX(1)
      IF (NX.GT.5) THEN
         NNN = 1
      ELSE
         NNN = 0
      ENDIF
      DO 1200, NN=HIY,LOWY,-1
         K = 0
         LINBEG = NNN
         DO 1100, N=1,NX
            K = K + 1
            TEMP(K) = ARRAY(OFF+N)
            IF (K.EQ.5) THEN
               IF (LINBEG.EQ.1) THEN
                  WRITE(OUTPUT,10004) (TEMP(M),M=1,5)
                  LINBEG = 0
               ELSE
                  WRITE(OUTPUT,10000) (TEMP(M),M=1,5)
               ENDIF
               CALL STTPUT(OUTPUT,STAT)
               K = 0
            ENDIF
1100     CONTINUE
         IF (K.GT.0) THEN
            WRITE(OUTPUT,10000) (TEMP(M),M=1,K)
            CALL STTPUT(OUTPUT,STAT)
            K = 0
         ENDIF
         OFF = OFF - NPIX(1)
1200  CONTINUE
      RETURN
C 
C  display contents of 2-dim ARRAY
2000  OFF = (NY-1) * NPIX(1)
      DO 2200, NN=HIY,CNTY+1,-1
         DO 2100, N=1,5
            TEMP(N) = ARRAY(OFF+N)
2100     CONTINUE
         WRITE(OUTPUT,10000) (TEMP(K),K=1,5)
         CALL STTPUT(OUTPUT,STAT)
         OFF = OFF - NPIX(1)
2200  CONTINUE
C 
      DO 2500, N=1,5                      !handle central line
         TEMP(N) = ARRAY(OFF+N)
2500  CONTINUE
      WRITE(OUTPUT,10010) (TEMP(K),K=1,5)
      CALL STTPUT(OUTPUT,STAT)
      OFF = OFF - NPIX(1)
C 
      DO 3200, NN=CNTY-1,LOWY,-1
         DO 3100, N=1,5
            TEMP(N) = ARRAY(OFF+N)
3100     CONTINUE
         WRITE(OUTPUT,10000) (TEMP(K),K=1,5)
         CALL STTPUT(OUTPUT,STAT)
         OFF = OFF - NPIX(1)
3200  CONTINUE
      RETURN
C 
10000 FORMAT(5G15.7)
10001 FORMAT('line',I5,', pixel',I5)
10002 FORMAT('line',I5,' -> ',I4,',   pixels',I5,' -> ',I4)
10003 FORMAT(G15.7)
10004 FORMAT('>',G14.7,4G15.7)
10010 FORMAT(2G15.7,'>',G14.7,'<',G14.7,G15.7)
      END

      SUBROUTINE R4READ(ARRAY,DARRAY,PIX,SUBDIM,SIZFLG)
C
      IMPLICIT NONE
C
      INTEGER      IMNO,NAXIS,SUBDIM,SIZFLG,DATFMT,CVFLAG
      INTEGER      PIX(3,2),NPIX(3)
      INTEGER      HIX,K,LOWX,LOWY,LOWZ,N,NN,NNN,NX,NY,NZ
      INTEGER      OFF,OFF1,STAT,MAXNO
      INTEGER      IFIRST,UNIT(1)
      INTEGER      IMNOW,MAPSIZ,NOHEAD
C
      REAL         ARRAY(*),TEMP(20),FIRST(25)
C
      DOUBLE PRECISION DARRAY(*),DTEMP(20),DFIRST(25)
C
      CHARACTER*200 OUTPUT
C 
      COMMON    /WSPACE/  IMNOW,MAPSIZ,NOHEAD
      COMMON    /IMINFO/  IMNO,DATFMT,CVFLAG,MAXNO,NAXIS,NPIX
C
C  init + setup bounds
      NX = PIX(1,2) - PIX(1,1) + 1
      NY = PIX(2,2) - PIX(2,1) + 1
      NZ = PIX(3,2) - PIX(3,1) + 1
      LOWX = PIX(1,1)
      HIX = LOWX + NX - 1
      LOWY = PIX(2,1)
      LOWZ = PIX(3,1)
C 
C  total size we have to read in
      NNN = NY*NPIX(1) + (NZ-1)*NPIX(1)*NPIX(2)
      IF (NNN.GT.MAPSIZ) THEN
         SIZFLG = NNN
         RETURN
      ELSE
         SIZFLG = 0
      ENDIF
C 
      OFF = (LOWX-1) + (LOWY-1)*NPIX(1) + (LOWZ-1)*NPIX(1)*NPIX(2)
      IF (CVFLAG.EQ.4) THEN                     !double prec. data
         CALL STFGET(IMNO,OFF+1,NNN,IFIRST,DARRAY,STAT)
      ELSE
         CALL STFGET(IMNO,OFF+1,NNN,IFIRST,ARRAY,STAT)
      ENDIF
      IFIRST = 1                                !reset IFIRST
C
C  branch according to dimension of subframe
      GOTO (1000,2000,3000),SUBDIM
C
C  display contents of 1-dim ARRAY
1000  IF (NOHEAD.EQ.0) THEN
         IF (HIX .GT. LOWX) THEN
            WRITE(OUTPUT,10021) LOWX,HIX
         ELSE
            WRITE(OUTPUT,10022) LOWX
         ENDIF
         CALL STTPUT(OUTPUT,STAT)
      ENDIF
      K = 0
      IF (CVFLAG.EQ.2) THEN
         DO 1100, N=1,NX
            K = K + 1
            TEMP(K) = ARRAY(N)
            IF (K.EQ.MAXNO) CALL R4WROU(TEMP,K,FIRST,IFIRST)
1100     CONTINUE
         IF (K.GT.0) CALL R4WROU(TEMP,K,FIRST,IFIRST)
      ELSE
         DO 1200, N=1,NX
            K = K + 1
            DTEMP(K) = DARRAY(N)
            IF (K.EQ.MAXNO) CALL R8WROU(DTEMP,K,DFIRST,IFIRST)
1200     CONTINUE
         IF (K.GT.0) CALL R8WROU(DTEMP,K,DFIRST,IFIRST)
      ENDIF
      GOTO 5000
C
C  display contents of 2-dim ARRAY
2000  OFF = 0
      DO 2200, NN=1,NY
         IF (NOHEAD.EQ.0) THEN
            IF (HIX .GT. LOWX) THEN
               WRITE(OUTPUT,10011) LOWY,LOWX,HIX
            ELSE
               WRITE(OUTPUT,10012) LOWY,LOWX
            ENDIF
            CALL STTPUT(OUTPUT,STAT)
         ENDIF
         K = 0
         IF (CVFLAG.EQ.2) THEN
            DO 2100, N=1,NX
               K = K + 1
               TEMP(K) = ARRAY(OFF+N)
               IF (K.EQ.MAXNO) CALL R4WROU(TEMP,K,FIRST,IFIRST)
2100        CONTINUE
            IF (K.GT.0) CALL R4WROU(TEMP,K,FIRST,IFIRST)
         ELSE
            DO 2120, N=1,NX
               K = K + 1
               DTEMP(K) = DARRAY(N)
               IF (K.EQ.MAXNO) CALL R8WROU(DTEMP,K,DFIRST,IFIRST)
2120        CONTINUE
            IF (K.GT.0) CALL R8WROU(DTEMP,K,DFIRST,IFIRST)
         ENDIF
         OFF = OFF + NPIX(1)
         LOWY = LOWY + 1
2200  CONTINUE
      GOTO 5000
C
C  display contents of 3-dim ARRAY
3000  OFF1 = 0
      DO 3300, NNN=1,NZ
         OFF = OFF1
         DO 3200, NN=1,NY
            IF (NOHEAD.EQ.0) THEN
               WRITE(OUTPUT,10001) LOWZ,LOWY,LOWX,HIX
               CALL STTPUT(OUTPUT,STAT)
            ENDIF
            K = 0
            IF (CVFLAG.EQ.2) THEN
               DO 3100, N=1,NX
                  K = K + 1
                  TEMP(K) = ARRAY(OFF+N)
                  IF (K.EQ.MAXNO) CALL R4WROU(TEMP,K,FIRST,IFIRST)
3100           CONTINUE
               IF (K.GT.0) CALL R4WROU(TEMP,K,FIRST,IFIRST)
            ELSE
               DO 3120, N=1,NX
                  K = K + 1
                  DTEMP(K) = DARRAY(N)
                  IF (K.EQ.MAXNO) CALL R8WROU(DTEMP,K,DFIRST,IFIRST)
3120           CONTINUE
               IF (K.GT.0) CALL R8WROU(DTEMP,K,DFIRST,IFIRST)
            ENDIF
            OFF = OFF + NPIX(1)
            LOWY = LOWY + 1
3200     CONTINUE
         OFF1 = OFF1 + NPIX(1)*NPIX(2)
         LOWZ = LOWZ + 1
3300  CONTINUE
C
C  save first 20 values in keyword OUTPUTR or OUTPUTD
5000  IFIRST = IFIRST - 1
      IF (IFIRST.GT.20) IFIRST = 20
      IF (IFIRST.GT.0) THEN
         IF (CVFLAG.EQ.2) THEN
            CALL STKWRR('OUTPUTR',FIRST,1,IFIRST,UNIT,STAT)
         ELSE
            DO 5500, N=1,IFIRST          !for backwards compatibility...
               FIRST(N) = REAL(DFIRST(N))
5500        CONTINUE
            CALL STKWRR('OUTPUTR',FIRST,1,IFIRST,UNIT,STAT)
            CALL STKWRD('OUTPUTD',DFIRST,1,IFIRST,UNIT,STAT)
         ENDIF
      ENDIF
      RETURN
C
10001      FORMAT('plane =',I6,', line =',I6,', 1.pixel =',I6,
     +             ', last pixel =',I6)
10011      FORMAT('line =',I6,', 1.pixel =',I6,', last pixel =',I6)
10012      FORMAT('line =',I6,', pixel =',I6,'              ')
10021      FORMAT('1.pixel =',I6,', last pixel =',I6)
10022      FORMAT('pixel =',I6,'              ')
      END

      SUBROUTINE R4WROU(TEMP,LIM,FIRST,IFIRST)
C
      IMPLICIT NONE
C
      INTEGER      LIM,IFIRST                  !LIM is max. = 20
      INTEGER      STAT,M
C
      REAL         TEMP(*),FIRST(*)
C
      CHARACTER    OUTPUT*200
C 
      IF (IFIRST.LE.20) THEN
         DO 100, M=1,LIM
            FIRST(IFIRST) = TEMP(M)
            IFIRST = IFIRST + 1
100      CONTINUE
      ENDIF
C
C  reset counter
      WRITE(OUTPUT,10000) (TEMP(M),M=1,LIM)
      CALL STTPUT(OUTPUT,STAT)
      LIM = 0  
C
      RETURN
C
10000 FORMAT(20G15.7)
      END

      SUBROUTINE R8WROU(TEMP,LIM,FIRST,IFIRST)
C
      IMPLICIT NONE
C
      INTEGER      LIM,IFIRST                  !LIM is max. = 20
      INTEGER      STAT,M
C
      DOUBLE PRECISION TEMP(*),FIRST(*)
C
      CHARACTER    OUTPUT*200
C
      IF (IFIRST.LE.20) THEN
         DO 100, M=1,LIM
            FIRST(IFIRST) = TEMP(M)
            IFIRST = IFIRST + 1
100      CONTINUE
      ENDIF
C
C  reset counter
      WRITE(OUTPUT,10000) (TEMP(M),M=1,LIM)
      CALL STTPUT(OUTPUT,STAT)
      LIM = 0 
C
      RETURN
C
10000 FORMAT(20G24.14)
      END

      SUBROUTINE R4WRIT(ARRAY,PIX,DATAS,NOVAL,COPTIO,TOTSIZ)
C
C  COPTIO		(1) = 1 or 0, if ALL or not ALL
C  			(2) = actual no. of data values given
C  			(3) = 1 or 0, if ADD or not ADD
C
      IMPLICIT NONE
C
      INTEGER      IMNO,NAXIS,NPIX(3),DATFMT,CVFLAG,MAXNO
      INTEGER      NOVAL,COPTIO(3),TOTSIZ
      INTEGER      PIX(3,2)
      INTEGER      K,N,NN,NNN,NX,NY,NZ,STAT
      INTEGER      OFFSET,OFF,OFF1,LOWX,LOWY,LOWZ
      INTEGER      IMNOW,MAPSIZ,NOHEAD
C
      REAL         ARRAY(*),DATAS(*)
      REAL         RR,RCONST
      REAL         CUTS(4)
C 
      DOUBLE PRECISION DMIN,DMAX
C 
      COMMON    /SVCUTS/  CUTS,DMIN,DMAX
      COMMON    /WSPACE/  IMNOW,MAPSIZ,NOHEAD
      COMMON    /IMINFO/  IMNO,DATFMT,CVFLAG,MAXNO,NAXIS,NPIX
C 
C  init + setup bounds
      NX = PIX(1,2) - PIX(1,1) + 1
      NY = PIX(2,2) - PIX(2,1) + 1
      NZ = PIX(3,2) - PIX(3,1) + 1
      OFF1 = 0
      LOWX = PIX(1,1)
      LOWY = PIX(2,1)
      LOWZ = PIX(3,1)
C 
C  total size we have to write out
      TOTSIZ = NX + (NY-1)*NPIX(1) + (NZ-1)*NPIX(1)*NPIX(2)
      IF (TOTSIZ.GT.MAPSIZ) RETURN          !tell caller we need more memory
C 
      OFFSET = (LOWX-1) + (LOWY-1)*NPIX(1) + (LOWZ-1)*NPIX(1)*NPIX(2)
      OFFSET = OFFSET + 1                     !point to first pixel
      CALL STFGET(IMNO,OFFSET,TOTSIZ,N,ARRAY,STAT)
C
C  branch according to constant option
      IF (COPTIO(1).NE.0) GOTO 1000
C  
      K = 0
      IF (COPTIO(3).EQ.0) THEN              !store, add or multiply data
C
C  write contents of ARRAY (up to 3 dimensions)
         DO 300, NNN=1,NZ
            OFF = OFF1
            DO 200, NN=1,NY
               DO 100, N=1,NX
                  K = K + 1
                  RR = DATAS(K)
                  ARRAY(OFF+N) = RR
                  IF (RR.LT.CUTS(3)) THEN             !check min + max
                     CUTS(3) = RR
                  ELSE IF (RR.GT.CUTS(4)) THEN
                     CUTS(4) = RR
                  ENDIF
                  IF (K.EQ.COPTIO(2)) GOTO 2000
100            CONTINUE
               OFF = OFF + NPIX(1)
200         CONTINUE
            OFF1 = OFF1 + NPIX(1)*NPIX(2)
300      CONTINUE
C 
      ELSE IF (COPTIO(3).EQ.1) THEN
C
         DO 600, NNN=1,NZ
            OFF = OFF1
            DO 500, NN=1,NY
               DO 400, N=1,NX
                  K = K + 1
                  RR = ARRAY(OFF+N) + DATAS(K)
                  ARRAY(OFF+N) = RR
                  IF (RR.LT.CUTS(3)) THEN             !check min + max
                     CUTS(3) = RR
                  ELSE IF (RR.GT.CUTS(4)) THEN
                     CUTS(4) = RR
                  ENDIF
                  IF (K.EQ.COPTIO(2)) GOTO 2000
400            CONTINUE
               OFF = OFF + NPIX(1)
500         CONTINUE
            OFF1 = OFF1 + NPIX(1)*NPIX(2)
600      CONTINUE
C
      ELSE 
C
         DO 900, NNN=1,NZ
            OFF = OFF1
            DO 800, NN=1,NY
               DO 700, N=1,NX
                  K = K + 1
                  RR = ARRAY(OFF+N) * DATAS(K)
                  ARRAY(OFF+N) = RR
                  IF (RR.LT.CUTS(3)) THEN             !check min + max
                     CUTS(3) = RR
                  ELSE IF (RR.GT.CUTS(4)) THEN
                     CUTS(4) = RR
                  ENDIF
                  IF (K.EQ.COPTIO(2)) GOTO 2000
700            CONTINUE
               OFF = OFF + NPIX(1)
800         CONTINUE
            OFF1 = OFF1 + NPIX(1)*NPIX(2)
900      CONTINUE
      ENDIF
C
      GOTO 2000
C
C  fill contents of ARRAY (up to 3 dimensions) with constant
1000  RCONST = DATAS(1)
      K = NZ * NY * NX
      IF (COPTIO(3).EQ.0) THEN
         DO 1300, NNN=1,NZ
            OFF = OFF1
            DO 1200, NN=1,NY
               DO 1100, N=1,NX
                  ARRAY(OFF+N) = RCONST
1100           CONTINUE
               OFF = OFF + NPIX(1)
1200        CONTINUE
            OFF1 = OFF1 + NPIX(1)*NPIX(2)
1300     CONTINUE
C 
         IF (RCONST.LT.CUTS(3)) THEN                  !check min + max
            CUTS(3) = RCONST
         ELSE IF (RCONST.GT.CUTS(4)) THEN
            CUTS(4) = RCONST
         ENDIF
C 
      ELSE IF (COPTIO(3).EQ.1) THEN
         DO 1600, NNN=1,NZ
            OFF = OFF1
            DO 1500, NN=1,NY
               DO 1400, N=1,NX
                  RR = ARRAY(OFF+N) + RCONST
                  ARRAY(OFF+N) = RR
                  IF (RR.LT.CUTS(3)) THEN             !check min + max
                     CUTS(3) = RR
                  ELSE IF (RR.GT.CUTS(4)) THEN
                     CUTS(4) = RR
                  ENDIF
1400           CONTINUE
               OFF = OFF + NPIX(1)
1500        CONTINUE
            OFF1 = OFF1 + NPIX(1)*NPIX(2)
1600     CONTINUE
C 
      ELSE 
         DO 1900, NNN=1,NZ
            OFF = OFF1
            DO 1800, NN=1,NY
               DO 1700, N=1,NX
                  RR = ARRAY(OFF+N) * RCONST
                  ARRAY(OFF+N) = RR
                  IF (RR.LT.CUTS(3)) THEN             !check min + max
                     CUTS(3) = RR
                  ELSE IF (RR.GT.CUTS(4)) THEN
                     CUTS(4) = RR
                  ENDIF
1700           CONTINUE
               OFF = OFF + NPIX(1)
1800        CONTINUE
            OFF1 = OFF1 + NPIX(1)*NPIX(2)
1900     CONTINUE
      ENDIF
C 
C 
2000  DMIN = CUTS(3)
      DMAX = CUTS(4)
      NOVAL = K
      CALL STFPUT(IMNO,OFFSET,TOTSIZ,ARRAY,STAT)
      TOTSIZ = 0
      RETURN
C
      END

      SUBROUTINE R8WRIT(ARRAY,PIX,DATAS,NOVAL,COPTIO,TOTSIZ)
C
C  COPTIO               (1) = 1 or 0, if ALL or not ALL
C                       (2) = actual no. of data values given
C                       (3) = 1 or 0, if ADD or not ADD
C
      IMPLICIT NONE
C
      INTEGER      IMNO,NAXIS,NPIX(3),DATFMT,CVFLAG,MAXNO
      INTEGER      NOVAL,COPTIO(3),TOTSIZ
      INTEGER      PIX(3,2)
      INTEGER      K,N,NN,NNN,NX,NY,NZ,STAT
      INTEGER      OFFSET,OFF,OFF1,LOWX,LOWY,LOWZ
      INTEGER      IMNOW,MAPSIZ,NOHEAD
C
      REAL         CUTS(4)
C 
      DOUBLE PRECISION ARRAY(*),DATAS(*)
      DOUBLE PRECISION DD,DCONST
      DOUBLE PRECISION DMIN,DMAX
C
      COMMON    /SVCUTS/  CUTS,DMIN,DMAX
      COMMON    /WSPACE/  IMNOW,MAPSIZ,NOHEAD
      COMMON    /IMINFO/  IMNO,DATFMT,CVFLAG,MAXNO,NAXIS,NPIX
C
C  init + setup bounds
      NX = PIX(1,2) - PIX(1,1) + 1
      NY = PIX(2,2) - PIX(2,1) + 1
      NZ = PIX(3,2) - PIX(3,1) + 1
      OFF1 = 0
      LOWX = PIX(1,1)
      LOWY = PIX(2,1)
      LOWZ = PIX(3,1)
C
C  total size we have to write out
      TOTSIZ = NX + (NY-1)*NPIX(1) + (NZ-1)*NPIX(1)*NPIX(2)
      IF (TOTSIZ.GT.MAPSIZ) RETURN            !tell caller we need more memory
C
      OFFSET = (LOWX-1) + (LOWY-1)*NPIX(1) + (LOWZ-1)*NPIX(1)*NPIX(2)
      OFFSET = OFFSET + 1                     !point to first pixel
      CALL STFGET(IMNO,OFFSET,TOTSIZ,N,ARRAY,STAT)
C
C  branch according to constant option
      IF (COPTIO(1).NE.0) GOTO 1000
C 
      K = 0
      IF (COPTIO(3).EQ.0) THEN                 !store, add or multiply data
C
C  write contents of ARRAY (up to 3 dimensions)
         DO 300, NNN=1,NZ
            OFF = OFF1
            DO 200, NN=1,NY
               DO 100, N=1,NX
                  K = K + 1
                  DD = DATAS(K)
                  ARRAY(OFF+N) = DD
                  IF (DD.LT.DMIN) THEN             !check min + max
                     DMIN = DD
                  ELSE IF (DD.GT.DMAX) THEN
                     DMAX = DD
                  ENDIF
                  IF (K.EQ.COPTIO(2)) GOTO 2000
100            CONTINUE
               OFF = OFF + NPIX(1)
200         CONTINUE
            OFF1 = OFF1 + NPIX(1)*NPIX(2)
300      CONTINUE
C
      ELSE IF (COPTIO(3).EQ.1) THEN
C
         DO 600, NNN=1,NZ
            OFF = OFF1
            DO 500, NN=1,NY
               DO 400, N=1,NX
                  K = K + 1
                  DD = ARRAY(OFF+N) + DATAS(K)
                  ARRAY(OFF+N) = DD
                  IF (DD.LT.DMIN) THEN             !check min + max
                     DMIN = DD
                  ELSE IF (DD.GT.DMAX) THEN
                     DMAX = DD
                  ENDIF
                  IF (K.EQ.COPTIO(2)) GOTO 2000
400            CONTINUE
               OFF = OFF + NPIX(1)
500         CONTINUE
            OFF1 = OFF1 + NPIX(1)*NPIX(2)
600      CONTINUE
C
      ELSE
C
         DO 900, NNN=1,NZ
            OFF = OFF1
            DO 800, NN=1,NY
               DO 700, N=1,NX
                  K = K + 1
                  DD = ARRAY(OFF+N) * DATAS(K)
                  ARRAY(OFF+N) = DD
                  IF (DD.LT.DMIN) THEN             !check min + max
                     DMIN = DD
                  ELSE IF (DD.GT.DMAX) THEN
                     DMAX = DD
                  ENDIF
                  IF (K.EQ.COPTIO(2)) GOTO 2000
700            CONTINUE
               OFF = OFF + NPIX(1)
800         CONTINUE
            OFF1 = OFF1 + NPIX(1)*NPIX(2)
900      CONTINUE
      ENDIF
C
      GOTO 2000
C
C  fill contents of ARRAY (up to 3 dimensions) with constant
1000  DCONST = DATAS(1)
      K = NZ * NY * NX
      IF (COPTIO(3).EQ.0) THEN
         DO 1300, NNN=1,NZ
            OFF = OFF1
            DO 1200, NN=1,NY
               DO 1100, N=1,NX
                  ARRAY(OFF+N) = DCONST
1100           CONTINUE
               OFF = OFF + NPIX(1)
1200        CONTINUE
            OFF1 = OFF1 + NPIX(1)*NPIX(2)
1300     CONTINUE
C
         IF (DD.LT.DMIN) THEN             !check min + max
            DMIN = DD
         ELSE IF (DD.GT.DMAX) THEN
            DMAX = DD
         ENDIF
C
      ELSE IF (COPTIO(3).EQ.1) THEN
         DO 1600, NNN=1,NZ
            OFF = OFF1
            DO 1500, NN=1,NY
               DO 1400, N=1,NX
                  DD = ARRAY(OFF+N) + DCONST
                  ARRAY(OFF+N) = DD
                  IF (DD.LT.DMIN) THEN             !check min + max
                     DMIN = DD
                  ELSE IF (DD.GT.DMAX) THEN
                     DMAX = DD
                  ENDIF
1400           CONTINUE
               OFF = OFF + NPIX(1)
1500        CONTINUE
            OFF1 = OFF1 + NPIX(1)*NPIX(2)
1600     CONTINUE
C
      ELSE
         DO 1900, NNN=1,NZ
            OFF = OFF1
            DO 1800, NN=1,NY
               DO 1700, N=1,NX
                  DD = ARRAY(OFF+N) * DCONST
                  ARRAY(OFF+N) = DD
                  IF (DD.LT.DMIN) THEN             !check min + max
                     DMIN = DD
                  ELSE IF (DD.GT.DMAX) THEN
                     DMAX = DD
                  ENDIF
1700           CONTINUE
               OFF = OFF + NPIX(1)
1800        CONTINUE
            OFF1 = OFF1 + NPIX(1)*NPIX(2)
1900     CONTINUE
      ENDIF
C
C
2000  NOVAL = K
      CALL STFPUT(IMNO,OFFSET,TOTSIZ,ARRAY,STAT)
      TOTSIZ = 0
      RETURN
C
      END

      SUBROUTINE MAXDAT(ARRAY,DARRAY,NP)
C 
      IMPLICIT NONE
C 
      INTEGER   NP,N
      INTEGER   IMNO,DATFMT,NAXIS,NPIX(3),CVFLAG,MAXNO
C 
      REAL      ARRAY(*),CUTS(4)
C 
      DOUBLE PRECISION   DARRAY(*)
      DOUBLE PRECISION DMIN,DMAX
C 
      COMMON    /SVCUTS/  CUTS,DMIN,DMAX
      COMMON    /IMINFO/  IMNO,DATFMT,CVFLAG,MAXNO,NAXIS,NPIX
C 
C  double precision data
      IF (CVFLAG.EQ.4) THEN
         DO 100, N=1,NP
            IF (DARRAY(N).LT.DMIN) THEN
               DMIN = DARRAY(N)
            ELSE IF (DARRAY(N).GT.DMAX) THEN
               DMAX = DARRAY(N)
            ENDIF
100      CONTINUE
C 
C  single precision data
      ELSE
         DO 1000, N=1,NP
            IF (ARRAY(N).LT.CUTS(3)) THEN
               CUTS(3) = ARRAY(N)
            ELSE IF (ARRAY(N).GT.CUTS(4)) THEN
               CUTS(4) = ARRAY(N)
            ENDIF
1000     CONTINUE
         DMIN = DBLE(CUTS(3))
         DMAX = DBLE(CUTS(4))
      ENDIF
C 
      RETURN
      END

C @(#)usrinp.for	13.1.1.1 (ES0-DMD) 06/02/98 18:30:08
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE USRINP(A,N,TYPE,CHARST) 

C.PURPOSE:  Decode a character string into integer or real array
C.AUTHOR:   J.P. Terlouw, Kapteynlab, Groningen
C.COMMENTS: none
C.VERSION:  ?????? RHW implementation
C.VERSION:  910115 RHW IMPLICIT NONE added
C---  
      IMPLICIT     NONE
C 
      INTEGER      NR8
      PARAMETER    (NR8=512)                                           
      INTEGER      MAXLP
      PARAMETER    (MAXLP=10)
C
      INTEGER      IREAL, ILOOP
      INTEGER      N, I, II
      INTEGER      IPOS, ITYPE
      INTEGER      IA, IIN 
      INTEGER      NREAL
      INTEGER      NI, NLOOP
      INTEGER      NCH, NREST
      INTEGER      NWORD, INSERT
      INTEGER      DOLOOP(2,MAXLP)
      INTEGER      NEL
C 
      REAL         A(NR8)	
      REAL         AA
      REAL         B8(NR8)
      REAL         INCR
      REAL         LOW                                      
      REAL         RA                                                    
      REAL         UPP
C 
      LOGICAL      LOOP,SEP,ERR                                                 
C 
      CHARACTER    TYPE
      CHARACTER    CHARST(72)
      CHARACTER    B1(72)                                            
      CHARACTER    ATYPE(2),LPSYM                                          
C 
      EXTERNAL     NEL	
C                                                                               
      EQUIVALENCE  (RA,IA,AA)                                                   
C
      DATA         ATYPE     /'R','I'/ 
C 
C ***
      ERR    = .FALSE.               ! error in do-loop                         
      LPSYM  = ':'                   ! loop symbol                              
      NI     = 0                     ! initial number of used words for array   
      IPOS   = 0                     ! starting for array pointer               
      ITYPE  = 1                     ! default type is real                     
                                                                                
      DO 10 I = 1,72                                                            
         B1(I)  = ' '                                                           
   10 CONTINUE                                                                  
      CALL ALPHA(CHARST,72,NCH,NREST)                                           
                                                                                
      DO 20 II = 1,NCH                                                          
         B1(II) = CHARST(II)                                                    
   20 CONTINUE                                                                  
                                                                                
      DO 30 I = 1,2                                                             
         IF (TYPE.EQ.ATYPE(I)) THEN                                 ! what type?
            ITYPE  = I                                                          
         END IF                                                                 
   30 CONTINUE                                                                  
C                                                                               
C *** GET INPUT PARAMETERS IF PRESENT                                           
C                                                                               
      IF (NCH.NE.0) THEN                                                        
         ERR    = .FALSE.                                     ! reset error flag
         NLOOP  = 0                                                             
         IF ((ITYPE.EQ.1) .OR. (ITYPE.EQ.3)) THEN                  ! decode loop
            DO 40 I = 1,MAXLP                                                   
               DOLOOP(1,I) = 0                                                  
               DOLOOP(2,I) = 0                                                  
   40       CONTINUE                                                            
            NLOOP  = 1                                                          
            NWORD  = 1                              ! startword of do-loop in b1
            INSERT = 0                                                          
            LOOP   = .FALSE.                                                    
            SEP    = .TRUE.                                                     
            DO 50 I = 1,NCH                                                     
               IF (B1(I).EQ.LPSYM) THEN                                         
                  IF (B1(I-1).EQ.' ' .OR. B1(I+1).EQ.' ') THEN      ! bad syntax
                     ERR    = .TRUE.                                            
                     GO TO 60                                                   
                  END IF                                                        
                  IF (DOLOOP(2,NLOOP).EQ.1) THEN                                
                     DOLOOP(2,NLOOP) = 2               ! increment value present
                     INSERT = INSERT + 1                                        
                                                                                
                  ELSE IF (DOLOOP(2,NLOOP).EQ.2) THEN                           
                     ERR    = .TRUE.             ! error in do-loop input string
                     NCH    = 0                                                 
                     GO TO 60                                     ! back to inpu
                  ELSE                                     ! upper value present
                     DOLOOP(1,NLOOP) = NWORD + INSERT                           
                     DOLOOP(2,NLOOP) = 1                                        
                     INSERT = INSERT + 1                                        
                  END IF                                                        
                  LOOP   = .TRUE.                                               
                  B1(I)  = ','                                                  
               ELSE                                                             
                  IF (B1(I).EQ.' ' .OR. B1(I).EQ.',') THEN        ! sep. symbols
                     IF ( .NOT. SEP) THEN                                       
                        NWORD  = NWORD + 1                                      
                        SEP    = .TRUE.                                         
                     END IF                                                     
C                                                                               
                     IF (LOOP) THEN                                             
                        NLOOP  = NLOOP + 1                                      
                        LOOP   = .FALSE.                                        
                     END IF                                                     
                  ELSE                                                          
                     SEP    = .FALSE.                                           
                  END IF                                                        
               END IF                                                           
   50       CONTINUE                                                            
C                                                                               
   60       CONTINUE                                                            
            IF ((.NOT.LOOP) .AND. (.NOT.ERR)) THEN                              
               NLOOP  = NLOOP - 1                                               
            END IF                                                              
         END IF                                                                 
      END IF                                                                    
C                                                                               
      IF ((NCH.GT.0) .AND. (.NOT.ERR)) THEN    ! decode input into real or char.
         CALL DECUSR(B1,NCH,B8,NR8)           ! decodes input array into b8(nr8)
         NI     = NEL(B8,NR8)         ! actual number of words (=array elements)
      END IF                                                                    
C                                                                               
C  *** CONSTRUCT THE OUTPUT ARRAY ************************************          
C                                                                               
      IPOS   = 0   ! position in a                                              
      ILOOP  = 1   ! next loop (if present)                                     
      IIN    = 0   ! position in b8                                             
      IF (NI.GT.0) THEN                                                         
   70    CONTINUE                                                               
         IIN    = IIN + 1                                                       
         RA     = B8(IIN)                                                       
         IF (ITYPE.EQ.3) THEN                          ! real+integer conversion
            IA     = NINT(RA)                                                   
         END IF                                                                 
         IF (IPOS+1.LE.N) THEN                ! conversion if ipos+1<# array el.
            A(IPOS+1) = RA                                                      
         END IF                                                                 
         IPOS   = IPOS + 1                            ! increase position by one
         IF (IIN.EQ.DOLOOP(1,ILOOP)) THEN                                       
            LOW    = B8(IIN)                                                    
            IIN    = IIN + 1                                                    
            UPP    = B8(IIN)                                                    
            IF (DOLOOP(2,ILOOP).EQ.1) THEN              ! no increment was given
               INCR   = 1.                                                      
            ELSE                                                                
               IIN    = IIN + 1                                                 
               INCR   = B8(IIN)                                                 
            END IF                                                              
            AA     = ((UPP-LOW)/INCR)              ! # of reals to be added in A
            NREAL  = ANINT(AA)                                                  
            IF (NREAL.GT.0) THEN                                                
               DO 80 IREAL = 1,NREAL                                            
                  LOW    = LOW + INCR                                           
                  RA     = LOW                                                  
                  IF (ITYPE.EQ.3) THEN                ! real+integer conversion 
                     IA     = NINT(RA)                                          
                  END IF                                                        
                  IF (IPOS+1.LE.N) THEN       ! conversion if ipos+1<# array el.
                     A(IPOS+1) = RA                                             
                  END IF                                                        
                  IPOS   = IPOS + 1                   ! increase position by one
   80         CONTINUE                                                          
            END IF                                                              
            ILOOP  = ILOOP + 1                                                  
         END IF                                                                 
         IF (IIN.LT.NI) GO TO 70                                                
      END IF                                                                    
C                                                                               
      IF (IPOS.LT.N) THEN                                                       
         CALL SETEND(A(IPOS+1))                                                 
      END IF                                                                    
                                                                                
      RETURN                                                                    
      END                                                                       
C 
      SUBROUTINE DECUSR(SS,L,ARRAY,NIN)                                         
C+++                                                                            
C.PURPOSE:  Subroutine to decode input string into a real array
C.AUTHOR:   J.P. Terlouw, Kapteynlab Groningen
C.COMMENTS: none
C.VERSION:  87???? RHW adjustments for and implementation in MIDAS
C.VERSION:  910115 RHW IMPLICIT NONE added
C---                                                                            
      IMPLICIT   NONE
      INTEGER    L                            ! IN: length of character string
      CHARACTER  SS(L)                        ! IN: character string
      REAL       ARRAY(*)                    ! OUT: real array  
      INTEGER    NIN                          ! OUT: length of the array
C
      INTEGER    IPOINT, IEPOW, ISIGN
      INTEGER    I, II, IARR, IFMT
      INTEGER    J
      INTEGER    NOUT, N1 
      INTEGER    LF, LD
      REAL       ENDLN
C
      CHARACTER  FMT*150,SSS*150                                                
      LOGICAL    RREAL,EPOW,XSIGN,XCHAR,SEP    
C 
 9000 FORMAT ('A',I1)                                                           
 9010 FORMAT (I2.2,'X')                                                         
 9020 FORMAT ('F',I2.2,'.',I2.2)                                                
C                                                                               
C *** start                                                                     
      RREAL   = .FALSE.
      EPOW   = .FALSE. 
      XSIGN   = .FALSE. 
      XCHAR   = .FALSE. 
      SEP    = .TRUE. 
      IPOINT = 0     
      IEPOW  = 0    
      ISIGN  = 0   
C                                                                               
      DO 10 II = 1,L                          !  put ss(1 --> l) into sss(1:l)  
         SSS(II:II) = SS(II)                                                    
   10 CONTINUE                                                                  
      DO 20 II = L+1,150                                                      
         SSS(II:II) = ' '                                                       
   20 CONTINUE                                                                  
C                                                                               
      I      = 1                                 !   index used for ss(1 ---> l)
      NOUT   = 0                                !  # of elements filled in array
      FMT(1:1) = '('                                                            
      IFMT   = 2                                                                
      N1     = 1                                !   first position of next field
      CALL SETEND(ENDLN)                                                        
      DO 30 IARR = 1,NIN       
         ARRAY(IARR) = ENDLN  
   30 CONTINUE               
C                                                                               
   40 CONTINUE              
      IF (I.LE.L .AND. NOUT.LT.NIN) THEN  
         IF ((SS(I).EQ.' ') .OR. (SS(I).EQ.',')
     +      .OR. (SS(I).EQ.':')) THEN         
            IF ( .NOT. SEP) THEN             
               LF     = I - N1                              !   character string
               IF (XCHAR) THEN               
                  LF = MIN(((NIN-NOUT)*1),LF)         !   max space in array
   50             CONTINUE 
                  IF (LF.GT.0) THEN  
                     WRITE (FMT(IFMT:),9000) MIN(1,LF)
                     LF     = LF - 1    
                     IFMT   = IFMT + 2 
                     FMT(IFMT:IFMT) = ','   
                     IFMT   = IFMT + 1     
                     NOUT   = NOUT + 1    
                     GO TO 50            
                  END IF                
               ELSE                    
                  IF (IEPOW.EQ.0) THEN 
                     IEPOW  = I       
                  END IF             
                  IF (IPOINT.EQ.0) THEN     
                     IPOINT = I            
                  END IF                  
                  LD     = MAX((IEPOW-IPOINT-1),0)  
                  WRITE (FMT(IFMT:IFMT+5),9020) LF,LD      
                  IFMT   = IFMT + 6                       
                  FMT(IFMT:IFMT) = ','                   
                  IFMT   = IFMT + 1                     
                  NOUT   = NOUT + 1                    
               END IF                                 
               N1     = I                            
C                                                                               
               RREAL   = .FALSE.                    
               EPOW   = .FALSE.                    
               XSIGN   = .FALSE.                   
               XCHAR   = .FALSE.                  
               SEP    = .TRUE.                  
               IPOINT = 0                      
               IEPOW  = 0                     
               ISIGN  = 0                    
            END IF                          
         ELSE                              
            IF (SEP) THEN                 
               LF     = I - N1           
               IF (LF.GT.0) THEN        
                  WRITE (FMT(IFMT:IFMT+2),9010) LF 
                  IFMT   = IFMT + 3               
                  FMT(IFMT:IFMT) = ','           
                  IFMT   = IFMT + 1             
               END IF                          
               N1     = I                     
C                                                                               
C *** input element is real                                                     
               IF (SS(I).GE.'0' .AND. SS(I).LE.'9' .OR. SS(I).EQ.  
     +            '+' .OR. SS(I).EQ.'-') THEN                     
                  RREAL   = .TRUE.                               
               ELSE                                             
                  IF (SS(I).EQ.'.') THEN                       !   decimal point
                     RREAL   = .TRUE.                          
                     IPOINT = I                               
                  ELSE                                       
                     XCHAR   = .TRUE.               !  input element is character
                  END IF                                    
               END IF                                      
               SEP    = .FALSE.                           
            ELSE                                         
               IF ( .NOT. XCHAR) THEN                    
                  IF (EPOW) THEN                       
                     IF ( .NOT. XSIGN) THEN            
                        IF (SS(I).EQ.'+' .OR. SS(I).EQ.'-') THEN  
                           ISIGN  = 1                            
                           XSIGN   = .TRUE.                      
                        ELSE                                   
                           IF (SS(I).GE.'0' .AND. SS(I).LE.'9') THEN   
                              XSIGN   = .TRUE.                         
                           ELSE                                      
                              XCHAR   = .TRUE.                       
                           END IF                                  
                        END IF                                    
                     ELSE  
                        IF (SS(I).LT.'0' .OR. SS(I).GT.'9' .OR.  
     +                     ((IEPOW+ISIGN+2).LT.I)) THEN         
                           XCHAR   = .TRUE.                     
                        END IF                                
                     END IF                                  
                  ELSE                                      
                     IF (SS(I).EQ.'E') THEN                
                        EPOW   = .TRUE.                   
                        IEPOW  = I                       
                     ELSE                               
                        IF (SS(I).EQ.'.') THEN         
                           IF (IPOINT.GT.0) THEN      
                              XCHAR   = .TRUE.        
                           ELSE                     
                              IPOINT = I           
                           END IF                 
                        ELSE                     
                           IF (SS(I).LT.'0' .OR. SS(I).GT.'9') THEN  
                              XCHAR   = .TRUE.                       
                           ENDIF                                   
                        ENDIF                                     
                     ENDIF                                       
                  ENDIF                                         
               ENDIF                                           
            ENDIF                                             
         ENDIF                                               
         I = I + 1                                          
         GO TO 40                                         
      END IF                                             
C                                                       
      IF (I.GT.N1) THEN                                
         IF ( .NOT. SEP) THEN                         
            LF     = I - N1                          
            IF (XCHAR) THEN                             !   character string
               LF     = MIN((NIN-NOUT),LF)            !   max space in array
60             CONTINUE                             
               IF (LF.GT.0) THEN                   
                  WRITE (FMT(IFMT:),9000) MIN(1,LF)
                  LF = LF - 1                         
                  IFMT   = IFMT + 2                      
                  FMT(IFMT:IFMT) = ','                  
                  IFMT   = IFMT + 1                    
                  NOUT   = NOUT + 1                   
                  GO TO 60                           
               ENDIF                                
            ELSE                                   
               IF (IEPOW.EQ.0) THEN               
                  IEPOW  = I                     
               ENDIF                            
               IF (IPOINT.EQ.0) THEN           
                  IPOINT = I                  
               ENDIF                         
               LD     = MAX((IEPOW-IPOINT-1),0) 
               WRITE (FMT(IFMT:),9020) LF,LD   
               IFMT   = IFMT + 6                    
               FMT(IFMT:IFMT) = ','                
               IFMT   = IFMT + 1                  
               NOUT   = NOUT + 1                 
            ENDIF                               
            N1 = I                             
         ENDIF                                
      ENDIF                                  
C                                                                               
      FMT(IFMT-1:IFMT-1) = ')'              
      IF (NOUT.GT.0) THEN                  
          READ (SSS(1:L),FMT=FMT(1:IFMT-1)) (ARRAY(J),J=1,NOUT)   
      END IF                                                     
C                                                                               
      RETURN                                                    
      END                                                      
C 
      INTEGER FUNCTION NEL(A,N)
C+++
C.PURPOSE:  Count the number of words in the input array of dimension
C           N by testing the array on -0 value
C.AUTHOR:   Rein H. Warmels
C.COMMENTS: none
C.VERSION:  890117 RHW Documented
C.VERSION:  910115 RHW IMPLICIT NONE added
C---
      IMPLICIT NONE
      INTEGER  N
      REAL     A(N)
C
      INTEGER  I 
      REAL     END
C
      DATA     END   /-32768./
C
C ***
      DO 10 I = 1,N
         IF (A(I).EQ.END) THEN
            GO TO 20
        END IF
   10 CONTINUE
      I = N + 1
C 
20    NEL = I - 1
C 
      RETURN
      END
C 
      SUBROUTINE SETEND(X)                                                      
C+++                                                                            
C.PURPOSE:  put an end of array word in X    
C.COMMENTS: none
C---                                                                            
      REAL   X
C
      REAL   END	
      DATA   END   /-32768./
C
C ***
      X = END                                                              
C 
      RETURN                                                                    
      END                                                                       

C @(#)densbr.for	19.1 (ES0-DMD) 02/25/03 13:27:14
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION:
C      DENDR VERSION 1                       85.01.21
C      F. MURTAGH   ST-ECF, MUNICH.
C
C.KEYWORDS:
C      APPLICATIONS, STATISTICS, CLUSTERING.
C
C.PURPOSE:
C      CONSTRUCT A DENDROGRAM (TREE) REPRESENTATION OF A
C      HIERARCHIC CLUSTERING.
C
C.ALGORITHM:
C      TAKE AS INPUT: THE ORDERING OF OBJECTS ALONG THE BOTTOM
C      OF THE DENDROGRAM ("IORDER"); THE HEIGHT OF THE VERTICAL
C      ABOVE EACH OBJECT, IN ORDINAL VALUES ("HEIGHT"), AND IN
C      REAL VALUES ("CRITVAL").
C      BUILD UP THE DENDROGRAM IN ARRAY "OUT".
C
C.INPUT/OUTPUT:
C      PARAMETERS:
C      IORDER, HEIGHT, CRITVAL : VECTORS DEFINING THE DENDROGRAM.
C      *** NOTE *** THE IJKLMN VARIABLE TYPE CONVENTION IS USED.
C
C---------------------------------------------------------------
C
      SUBROUTINE DENDR(IORDER,HEIGHT,CRITVAL)
C
      CHARACTER*80 LINE
      INTEGER IORDER(9),HEIGHT(9)
      REAL CRITVAL(9)
      INTEGER I,J,K,I2,J2,I3,IC,IDUM
      INTEGER ISTAT,L
      CHARACTER*1 OUT(27,27),UP,ACROSS,BLANK
      DATA UP,ACROSS,BLANK/'|','-',' '/
C
C
      DO I=1,27
        DO J=1,27
          OUT(I,J)=BLANK
        ENDDO
      ENDDO
C
C
      DO I=3,27,3
         I2=I/3
C
         J2=28-3*HEIGHT(I2)
         DO J=27,J2,-1
            OUT(J,I)=UP
         ENDDO
C
         DO K=I,3,-1
            I3=INT((K+2)/3)
            IF ( (28-HEIGHT(I3)*3).LT.J2) GOTO 100
            OUT(J2,K)=ACROSS
         ENDDO
  100    CONTINUE
C
      ENDDO
C
C
      IC=3
      DO I=1,27
      IF (I.EQ.IC+1) THEN
                   IDUM=IC/3
                   IDUM=9-IDUM
                   DO L=1,9
                      IF (HEIGHT(L).EQ.IDUM) GOTO 190
                   ENDDO
  190              IDUM=L
                   LINE = ' '
                   WRITE(LINE,200) CRITVAL(IDUM),(OUT(I,J),J=1,27)
                   CALL STTPUT(LINE,ISTAT)
                   IC=IC+3
                   ELSE
                   LINE = ' '
                   WRITE(LINE,210) (OUT(I,J),J=1,27)
                   CALL STTPUT(LINE,ISTAT)
      ENDIF
  200 FORMAT(1X,8X,F16.2,27A1)
  210 FORMAT(1X ,24X,27A1)
      ENDDO
      LINE = ' '
      CALL STTPUT(LINE,ISTAT)
      WRITE(LINE,220)(IORDER(J),J=1,9)
      CALL STTPUT(LINE,ISTAT)
  220 FORMAT(1X ,24X,9I3)
      LINE = ' '
      CALL STTPUT(LINE,ISTAT)
      WRITE(LINE,230)
      CALL STTPUT(LINE,ISTAT)
  230 FORMAT(1X ,13X,'CRITERION        CLUSTERS 1 TO 9')
      LINE = ' '
      WRITE(LINE,240)
      CALL STTPUT(LINE,ISTAT)
  240 FORMAT(1X ,13X,'VALUES.      (TOP 8 LEVELS OF HIERARCHY).')
C
C
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2005 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FTINTR(YY,W1,N1,N2,N3,NITER,RELAX,PREC,V1,V2,NACT,             
     +                  ACTCH,ISTAT)                                            
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                   
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C.IDENTIFICATION                                                                
C                                                                               
C  FITLIB.FOR   VERSION 1.0  27 MAR 1984                                        
C                                                                               
C.PURPOSE                                                                       
C                                                                               
C  INTERFACE ROUTINES FOR THE FITTING STRUCTURES                                
C ITERATE ON THE FITTING PROCESS FOT IMAGE DATA                                 
C THE ITERATION IS FINISHED IF                                                  
C - NITER IS REACHED OR                                                         
C - CHISQ IS REACHED                                                            
C - CONVERGENCE IS ACHIEVED                                                     
C                                                                               
C.ALGORITHM                                                                     
C                                                                               
C  USE MIDAS I/O INTERFACES TO FRAMES AND TABLES                                
C                                                                               
C.KEYWORDS                                                                      
C                                                                               
C  NON LINEAR FITTING                                                           
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:25 - 13 JAN 1988                 
C 051109	last modif
C                                                                               
C----------------------------------------------------------------               
C                                                                               
C                                                                               
C INPUT PARAMETERS                                                              
C YY REAL MAPPED VALUES OF THE IMAGE                                            
C W1 REAL OPTIONAL WEIGHTS                                                      
C NITER INTG NO. OF ITERATIONS TO BE DONE                                       
C RELAX REAL RELAXATION FACTOR.                                                 
C                       AUTOMATIC COMPUTATION IF NEGATIVE                       
C PREC REAL PRECISION                                                           
C V1,V2 REAL OPTIONAL FITTING INTERVAL (IF V1.NE.V2)                            
C                                                                               
C OUTPUT PARAMETERS                                                             
C NACT INTG ACTUAL NUMBER OF ITERATIONS                                         
C ACTCH REAL ACTUAL CHI SQ.                                                     
C ISTAT INTG STATUS RETURN                                                      
C                                                                               
      INTEGER N1,N2,N3,NITER,NACT,ISTAT,IPRINT,J,K
      INTEGER NITER1,I,I1,I2,KZ6901,ICOUNT
      INTEGER IX1,IX2,NOFFSET,IFUN,IP,NN,NP,NNP,IX3,NILAST 

      CHARACTER*80 LINE                                                         

      DOUBLE PRECISION CHI,PP,Q,Y,Y1,Y2,YOUT,CORRNM                            

      REAL X(3),YY(N1,N2,N3),W1(N1,N2,N3)                                       
      REAL RELAX,PREC,V1,V2,ACTCH,V11,V22,CHIOLD,FSUMSQ
      REAL AC1,AC2,AC3,DELTA,C1,C2,W,CHIPERC

      LOGICAL AUTO,VCMATR                                                      

      INCLUDE 'MID_INCLUDE:FITI.INC/NOLIST'                                     
      DOUBLE PRECISION FZDERIV(FZPARMAX)                                    
      DOUBLE PRECISION AL,B(FZPARMAX),A(FZPARMAX,FZPARMAX)
      INCLUDE 'MID_INCLUDE:FITC.INC/NOLIST'                                     
C                                                                                
      CALL STTPUT(' ',ISTAT)                                                    
      CALL STTPUT('Non-linear Least Square Fitting :'//                         
     +            ' Newton-Raphson Method (defaulted)',ISTAT)                   
      CALL STTPUT('_______'//                                                   
     +     '___________________________________________________________'        
     +            ,ISTAT)                                                       
      CALL STTPUT(' ',ISTAT)                                                    
      CALL STTPUT(' ',ISTAT)                                                    
      CALL STTPUT(                                                              
     +         ' Print   Max. Fct. eval.  Prec. on Param.  Relax. Fact.'        
     +            ,ISTAT)                                                       
      WRITE (LINE,9000) NINT(FZMETPAR(1)),NINT(FZMETPAR(2)),                
     +  FZMETPAR(3),FZMETPAR(4)                                             
      CALL STTPUT(LINE,ISTAT)                                                   
      CALL STTPUT(' ',ISTAT)                                                    
      VCMATR = FZMETPAR(1) .LE. 0.1                                          
      IPRINT = NINT(ABS(FZMETPAR(1)))                                         
      IF (IPRINT.EQ.0) IPRINT = ABS(NITER)                                      
      AUTO   = RELAX .LT. 0.                                                    
      RELAX  = ABS(RELAX)                                                       
      IF (NITER.GT.0) THEN                                                      
          DO 10, J = 1,FZNPTOT                                                 
              FZVALUE(J) = FZGUESS(J)                                       
   10     CONTINUE                                                              
          FZNITER = 0                                                         
          NITER1 = NITER                                                        
                                                                                
      ELSE                                                                      
          NITER1 = -NITER                                                       
      END IF                                                                    
                                                                                
      IF (V1.NE.V2) THEN                                                        
          V11    = MAX(V1,FZSTART(1))                                         
          V22    = MIN(V2,FZSTART(1)+ (FZNPIX(1)-1)*FZSTEP(1))            
          I1     = (V11-FZSTART(1))/FZSTEP(1) + 1                           
          I2     = (V22-FZSTART(1))/FZSTEP(1) + 1                           
                                                                                
      ELSE                                                                      
          I1     = 1                                                            
          I2     = FZNPIX(1)                                                  
      END IF                                                                    
                                                                                
      FZCCHIS = 9999.                                                         
      FZCHISQ = 1.D6                                                          
      FZRELAX = RELAX                                                         
      CHI    = 0.D0                                                             
      ICOUNT = 0                                                                
      CORRNM = 1.D6                                                            
      KZ6901 = 0
99    KZ6901 = KZ6901 + 1
      IF ( .NOT. (ICOUNT.LT.NITER1 .AND. CORRNM.GT.PREC)) GO TO 166            
      DO 30, I = 1,FZPARMAX                                                            
          DO 20, J = 1,FZPARMAX                                                        
              A(J,I) = 0.D0                                                     
   20     CONTINUE                                                              
          B(I)   = 0.D0                                                         
   30 CONTINUE                                                                  
      CHIOLD = CHI                                                              
      CHI    = 0.D0                                                             
C                                                                               
C ITERATION ON IMAGE DATA                                                       
C                                                                               
      DO 100 IX3 = 1,FZNPIX(3)                                                
          X(3)   = FZSTART(3) + (IX3-1)*FZSTEP(3)                           
          DO 90, IX2 = 1,FZNPIX(2)                                             
              X(2)   = FZSTART(2) + (IX2-1)*FZSTEP(2)                       
              DO 80, IX1 = I1,I2 
                  X(1)   = FZSTART(1) + (IX1-1)*FZSTEP(1)                   
                  IF (FZWEIGHT.EQ.0) THEN                                     
                      W      = 1.                                               
                                                                                
                  ELSE                                                          
                      W      = W1(IX1,IX2,IX3)                                  
                      W      = 1./ (W*W)                                        
                  END IF                                                        
                                                                                
                  Y      = YY(IX1,IX2,IX3)                                      
C                                                                               
C ...       COMPUTE FUNCTION VALUES AND DERIVATIVES (0 IF FIXED PARAM)          
C                                                                               
                  Y1     = 0.D0                                                 
                  NOFFSET = 1                                                   
                  DO 40, IFUN = 1,FZNFUN                                       
                      CALL FTFUNC(FZFCODE(IFUN),FZNIND,X,                   
     +                            FZACTPAR(IFUN),FZVALUE(NOFFSET),          
     +                            YOUT,FZDERIV(NOFFSET))                      
                      Y1     = Y1 + YOUT                                        
                      NOFFSET = NOFFSET + FZACTPAR(IFUN)                      
   40             CONTINUE                                                      
                  DO 50, J = 1,FZNPTOT                                         
                      IP     = FZFIXED(J)                                     
                      IF (IP.EQ.0) FZDERIV(J) = 0.                            
                      IF (IP.GT.0) THEN                                         
                          FZDERIV(IP) = FZDERIV(IP) +                       
     +                                    FZDERIV(J)/FZPFAC(J)              
                          FZDERIV(J) = 0.                                     
                      END IF                                                    
                                                                                
   50             CONTINUE                                                      
C                                                                               
C ...       COMPUTE RESIDUALS, WEIGHTED RESIDUALS AND CHI**2                    
C                                                                               
                  Y2     = Y - Y1                                               
                  PP     = DBLE(W)                                              
                  IF (FZFLAG.EQ.1) PP     = 1.D0/AMAX1(1.0,SNGL(Y1))          
                  Q      = Y2                                                   
                  CHI    = CHI + Q*Q*PP                                         
C                                                                               
C ...       BUILD NORMAL EQUATION MATRIX                                        
C                                                                               
                  DO 70, J = 1,FZNPTOT                                         
                      AL     = FZDERIV(J)                                     
                      DO 60, K = 1,FZNPTOT                                     
                          A(J,K) = A(J,K) + AL*PP*FZDERIV(K)                  
   60                 CONTINUE                                                  
                      B(J)   = B(J) + PP*Q*AL                                   
   70             CONTINUE                                                      
   80         CONTINUE                                                          
   90     CONTINUE                                                              
  100 CONTINUE                                                                  
C                                                                               
C ...     ADD (PROBABILISTIC) PARAMETER CONSTRAINTS                             
C                                                                               
      NN     = N1*N2*N3                                                         
      NP     = 0                                                                
      DO 110, I = 1,FZNPTOT                                                    
          IF (FZFIXED(I).GE.0) THEN                                           
              A(I,I) = 1.0D0                                                    
                                                                                
          ELSE                                                                  
              NP     = NP + 1                                                   
              IF (FZUNCER(I).GT.0.) THEN                                      
                  NN     = NN + 1                                               
                  Q      = 1.0D0/DBLE(FZUNCER(I)*FZUNCER(I))                
                  A(I,I) = A(I,I) + Q                                           
                  B(I)   = B(I) + Q* (FZGUESS(I)-FZVALUE(I))                
              END IF                                                            
                                                                                
          END IF                                                                
                                                                                
  110 CONTINUE                                                                  
C                                                                               
C ...     INVERT NORMAL EQUATION MATRIX TO GET THE COVARIANCE MATRIX            
C                                                                               
      NNP    = FZNPTOT                                                        
      CALL DMATIN(A,FZNPTOT,FZPARMAX,FZFIXED,ISTAT)                               
      IF (ISTAT.NE.0) THEN                                                      
          CALL STTPUT('*** ERR-NR  : Problems inverting matrix ***',            
     +                ISTAT)                                                    
          RETURN                                                                
                                                                                
      END IF                                                                    
C                                                                               
C ... COMPUTE REDUCED CHI**2 AND CORRECTIONS FOR THE UNKNOWNS                   
C                                                                               
      FSUMSQ = CHI                                                              
      CHI    = DMAX1(CHI/DBLE(NN-NP),0.D0)                                    
      CORRNM = 0.D0                                                            
      DO 130, I = 1,FZNPTOT                                                    
          Q      = 0.0D0                                                        
          DO 120, J = 1,FZNPTOT                                                
              Q      = Q + A(I,J)*B(J)                                          
  120     CONTINUE                                                              
C                                                                               
C ... COMPUTE ERRORS OF THE CORRECTIONS (I.E. THE UNKNOWNS)                     
C ... AND APPLY CORRECTIONS (DO THE ADJUSTMENT!)                                
C                                                                               
          IF (FZFIXED(I).GE.0) THEN                                           
              FZERROR(I) = 0.D0                                               
                                                                                
          ELSE                                                                  
              Q      = RELAX*Q                                                  
              CORRNM = CORRNM + Q*Q                                           
              FZERROR(I) = DSQRT(A(I,I)*CHI)                                  
              FZVALUE(I) = FZVALUE(I) + Q                                   
          END IF                                                                
                                                                                
  130 CONTINUE                                                                  
      CORRNM = DSQRT(CORRNM)                                                  
C                                                                               
C ... LINEAR CONSTR. BETWEEN TWO PARAMS                                         
C                                                                               
      DO 140, I = 1,FZNPTOT                                                    
          IP     = FZFIXED(I)                                                 
          IF (IP.GT.0) THEN                                                     
              FZERROR(I) = FZPFAC(I)*FZERROR(IP)                          
              FZVALUE(I) = FZPFAC(I)*FZVALUE(IP)                          
          END IF                                                                
                                                                                
  140 CONTINUE                                                                  
      ICOUNT = ICOUNT + 1                                                       
      FZNITER = FZNITER + 1                                                 
      FZCCHIS = SNGL(CHI)                                                     
      IF (MOD(ICOUNT,IPRINT).EQ.0) THEN                                         
          CALL STTPUT(' ',ISTAT)                                                
          CALL STTPUT(                                                          
     +        ' Iter  Fct. Eval.  Sum of Squares  Red. Chisq.   % Decr.'        
     +                ,ISTAT)                                                   
          IF (ICOUNT.GT.1) THEN                                                 
              CHIPERC = 100.* (CHIOLD-CHI)/CHIOLD                               
              WRITE (LINE,9010) FZNITER,FZNITER,FSUMSQ,FZCCHIS,           
     +          CHIPERC                                                         
                                                                                
          ELSE                                                                  
              WRITE (LINE,9010) FZNITER,FZNITER,FSUMSQ,FZCCHIS            
          END IF                                                                
                                                                                
          CALL STTPUT(LINE,ISTAT)                                               
          CALL STTPUT(' ',ISTAT)                                                
          CALL STTPUT('        Parameters   ',ISTAT)                            
          DO 150, I = 1,FZNPTOT                                                
              WRITE (LINE,9020) FZVALUE(I)                                    
              CALL STTPUT(LINE,ISTAT)                                           
  150     CONTINUE                                                              
          CALL STTPUT(' ',ISTAT)                                                
      END IF                                                                    
C                                                                               
C ... STORE THE CHISQ                                                           
C                                                                               
      IF (FZNITER.LE.100) THEN                                                
          FZCHI(FZNITER) = CHI                                              
          NILAST = FZNITER                                                    
                                                                                
      ELSE                                                                      
          DO 160 I = 1,99                                                       
              FZCHI(I) = FZCHI(I+1)                                         
  160     CONTINUE                                                              
          FZCHI(100) = CHI                                                    
          NILAST = 100                                                          
      END IF                                                                    
C                                                                               
      IF (AUTO) THEN                                                            
          IF (NILAST.GT.10) THEN                                                
C                                                                               
C ... CHECK FOR CONVERGENCE                                                     
C                                                                               
              IF (FZCHI(NILAST-1).EQ.FZCHI(NILAST)) GO TO 170               
              AC1    = ALOG(AMAX1(FZCHI(NILAST-2),0.0001))                    
              AC2    = ALOG(AMAX1(FZCHI(NILAST-1),0.0001))                    
              AC3    = ALOG(AMAX1(FZCHI(NILAST),0.0001))                      
              C1     = AC1 - AC2                                                
              C2     = AC2 - AC3                                                
              IF (ABS(C2).LE.1.E-5) GO TO 170                                   
              DELTA  = ABS((C1-C2)/C2)                                          
              IF (C2.GT.0.0 .AND. DELTA.LE.0.25) RELAX  = (1.0-DELTA)**4        
          END IF                                                                
                                                                                
      END IF                                                                    
      GOTO 99
  166 CONTINUE                                                                  
  170 CALL STTPUT(' ',ISTAT)                                                    
      NACT   = FZNITER                                                        
      ACTCH  = FZCCHIS                                                        
      FZNDAT = N1*N2*N3                                                       
      IF (V1.NE.V2) THEN                                                        
          FZNPIX(1) = I2 - I1 + 1                                             
          FZSTART(1) = FZSTART(1) + (I1-1)*FZSTEP(1)                      
      END IF                                                                    
                                                                                
      IF (CORRNM.LE.PREC) THEN                                                 
          CALL STTPUT('  --> NR  : Convergence achieved <--',ISTAT)             
                                                                                
      ELSE                                                                      
          CALL STTPUT('*** WARN-NR  : No convergence reached ***',ISTAT)        
      END IF                                                                    
C                                                                               
C ... PRINT CORREL. MATRIX                                                      
C                                                                               
      IF (VCMATR) CALL DCPRIN(A,NNP,FZPARMAX)
      RETURN                                                                    
                                                                                
 9000 FORMAT (I6,7X,I7,7X,1PE9.1,8X,0PF4.2)                                     
 9010 FORMAT (I5,6X,I5,3X,1PE12.4,2X,1PE12.4,5X,0PF5.2)                         
 9020 FORMAT (2X,1PE15.7)                                                       
      END                                                                       

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
       PROGRAM POS1b
C---------------------------------------------------------------------------
C      THIS PROGRAM COMPUTES (ALFA,DELTA) FOR OBJECTS 
C      MEASURED ON PHOTOGRAPHIC PLATES.
C      
C---------------------------------------------------------------------------
C    Performs the RA,DEC <--> X,Y conversions. The transformation
C    parameters must have been previously computed by POS1A
C
C    Mode No. 
C      (1) STANDARD REDUCTION OF SCHMIDT PLATE, i.e. measurement
c          file contains the four crosses, as described above.
c          the coordinates of the plate center are given. 
c          after interactive reduction, the computed (alpha,
c          delta) values for a number of objects are printed
c          at the end. it is also possible to get the mean
c          (alpha,delta) of two eachother following positions 
c          (e.g. mp and comet trails).
c      (2) MEASUREMENT FILE DOES NOT CONTAIN THE FOUR CROSSES,
C          but otherwise as mode (1). this mode is the most common.
C      (3) CALCULATION OF (ALPHA,DELTA)1950 FOR SINGLE (X,Y)-VALUES,
C          which are input from terminal one by one.
C      (4) Inverse of mode (3). CALCULATION OF (X,Y)-VALUE FOR GIVEN
C          (ALPHA,DELTA)1950 VALUE, input from terminal. this part
c          uses a iteration procedure, and result is better than
c          1.0 micron. this mode is useful for finding objects
c          on a schmidt plate still on-place in measuring machine.
c      (5) Same as (4), except that the (A,D) INPUT IS TAKEN FROM 
C          A DISC FILE that contains a number of (a,d)-values for 
c          a series of objects. This file is created by program 
c          POS15 (for details, consult that program). This mode is
c          particularly useful for identification of moving objects 
c          within the plate limits. 
c      (6) REPEAT <POS1>
C      (7) END 
C 
C     Refer to pos1a.f for the history...
C 
C #Version: Sat Sep 17 18:11:03 1994
C.VERSION   1995-Mar-26 : Use PARAMETER and increase buffer to 10001, PJG
C 
C 100615	last modif
c----------------------------------------------------------------------------
C
      IMPLICIT REAL*8 (A-H,O-Z), INTEGER*4 (I-N)
C 
      PARAMETER   (MAXOBJ=100001)
C 
      CHARACTER*1 YESNO,SCHMIDT,BLINK
      CHARACTER*2 ITEGN1,FLAGS
      CHARACTER*19 STRING_TERM
      CHARACTER*16 DFILE,ADXYFILE,XYFILE,OUTFILE
      CHARACTER*50 HEADER
      CHARACTER*16 ACUR, AFOR, CTEST
      CHARACTER*250 MSG

      INTEGER TIDD, NCOLD,NROWD,NSC,ACOL,AROW,ISTAT,NCDIDENT
      INTEGER ILOOP, TIDO

      LOGICAL  NULL

      DIMENSION MNOST(MAXOBJ),NOST1(MAXOBJ)
      DIMENSION KK(9),X(10),AR(MAXOBJ,4),BX(9),BY(9),IDX(9),IDY(9) 
      DIMENSION A0(3),D0(3),XY(MAXOBJ,2),ALFA(3),DELTA(3),
     >SSX(10,10),S(10,10),R(10,10),SLSSC(9),SDC(9),PRXY(MAXOBJ,2), 
     >VBI(9),B(9),SV(10),SIGMA(10),XBAR(10)

      DIMENSION XTEMP(20),YTEMP(20),RESA(3),RESB(3) 
      DIMENSION IA1(2),ID1(2),KICK(100),XEST(2,2),YEST(2,2)


      EQUIVALENCE 
     >     (SSX,S,R),
     >     (S(2,1),B),
     >     (S(3,2),DEV),
     >     (S(4,2),SW,V),
     >     (S(5,2),SSR,RSW),
     >     (S(6,2),CONST),
     >     (S(7,2),SSDR,SUM),
     >     (S(8,2),RSQD),
     >     (S(9,2),CHG,ROFF),
     >     (S(4,3),XMSDR),
     >     (S(5,3),XMSDD),
     >     (S(6,3),VE),
     >     (S(7,3),SDE),
     >     (S(1,4),SLSSC),
     >     (S(1,5),TSQDC),
     >     (S(1,6),SDC),
     >     (S(1,7),VBI),
     >     (SV,SIGMA),
     >     (X,XBAR)
 
c---------------------------------------------------------------------
C---  MIDAS...
c---------------------------------------------------------------------
      INCLUDE          'MID_INCLUDE:ST_DEF.INC'
      COMMON           /VMR/MADRID
      INCLUDE          'MID_INCLUDE:ST_DAT.INC'
c---------------------------------------------------------------------
c--   init
      CALL STSPRO('POS1B')
c---------------------------------------------------------------------
      LU = 30
      DO0 = 0.0D0 
      DO1 = 1.0D0 
      DO12 = 1.2D1
      DO24 = 2.4D1
      DO60 = 6.0D1
      DO180 = 1.8D2 
      DO3600 = 3.6D3
      PI = 4.0D0*DATAN(1.0D0)
      DOPI18 = PI/DO180 
      FOC = 3.054D2/3.6D3
      DFILE = ' '
      ADXYFILE = ' '
      XYFILE = ' '
      OUTFILE = ' '
C 
      DO 5, J=1,100 
    5   KICK(J) = 0 
      NKICK = 0 

      ITRY = 0

c     initialize the ASCII log file
c      LU_LOG = 30
c      OPEN(UNIT=LU_LOG,FILE='pos1.log')

C     Option selected?
      CALL STKRDI('OPT',1,1,N1,IOTYP,IDUM1,IDUM2,ISTAT)

C     Serach the input table
      CALL STKRDC('IN_MES',1,1,20,N1,DFILE,IDUM1,IDUM2,ISTAT)
C     open the table      
      CALL TBTOPN(DFILE,F_I_MODE,TIDD,ISTAT)

c---------------------------------------------------------------------
c---  open the input files
c---------------------------------------------------------------------
C---  Reads the descriptors: 
C     Read the instrument flags:
      CALL STDRDC(TIDD,'FLAGS',1,1,2,N1,FLAGS,IDUM1,IDUM2,ISTAT)
      IF (FLAGS(1:1) .EQ. 'S' .OR. FLAGS(1:1) .EQ. 's' ) THEN
         SCHMIDT = 'Y'
      ELSE
         SCHMIDT = 'N'
      ENDIF
      IF (FLAGS(2:2) .EQ. 'y' .OR. FLAGS(2:2) .EQ. 'Y' 
     >     .OR. FLAGS(2:2) .EQ. 'B' .OR. FLAGS(2:2) .EQ. 'b' ) THEN
         BLINK = 'Y'
      ELSE
         BLINK = 'N'
      ENDIF

C     Read the plate and catalogue epochs:
      CALL STDRDD(TIDD,'EPO_PLA',1,1,N1,EPOCH,IDUM1,IDUM2,ISTAT)
      CALL STDRDD(TIDD,'EPO_CAT',1,1,N1,EP1,IDUM1,IDUM2,ISTAT)

C     Get the permitted permitted RMS
      CALL STDRDD(TIDD,'SIG',1,1,N1,SIG,IDUM1,IDUM2,ISTAT)

C     Get the xy transformation terms used:
      CALL STDRDC(TIDD,'TERMS',1,1,19,N1,STRING_TERM,IDUM1,IDUM2,ISTAT)
C     *decode the xy transformation terms flags
 150  NX = 0
      NY = 0
      DO I = 1,9
         READ(STRING_TERM(I:I),*)IDX(I)
         READ(STRING_TERM(I+10:I+10),*)IDY(I)
         IF (IDX(I).NE.0) NX=NX+1
         IF (IDY(I).NE.0) NY=NY+1
      ENDDO
  165 FORMAT(1X,'  CHECK ',9I2,1X,9I2) 

C     Reads the transformation parameter from the descriptor
      CALL STDRDD(TIDD,'BX',1,9,N1,BX,IDUM1,IDUM2,ISTAT)
      CALL STDRDD(TIDD,'BY',1,9,N1,BY,IDUM1,IDUM2,ISTAT)
      CALL STDRDD(TIDD,'CX',1,1,N1,CX,IDUM1,IDUM2,ISTAT)
      CALL STDRDD(TIDD,'CY',1,1,N1,CY,IDUM1,IDUM2,ISTAT)
      CALL STDRDI(TIDD,'NX',1,1,N1,NX,IDUM1,IDUM2,ISTAT)
      CALL STDRDI(TIDD,'NY',1,1,N1,NY,IDUM1,IDUM2,ISTAT)
      CALL STDRDD(TIDD,'AL_DE0',1,1,N1,ALFA0,IDUM1,IDUM2,ISTAT)
      CALL STDRDD(TIDD,'AL_DE0',2,1,N1,DELTA0,IDUM1,IDUM2,ISTAT)
      CALL STDRDD(TIDD,'AL_DE0',3,1,N1,COSD0,IDUM1,IDUM2,ISTAT)
      CALL STDRDD(TIDD,'AL_DE0',4,1,N1,SIND0,IDUM1,IDUM2,ISTAT)

    
c---------------------------------------------------------------------
C---  Reads the measurements (X,Y)
c---------------------------------------------------------------------
C     needs the measurements only for option 1&2 
C     (conversion of measured XY -> alpha,delta)
      IF (IOTYP.EQ.1 .OR. IOTYP.EQ.2 ) THEN

C        check the numbers of rows and columns of the table
         CALL TBIGET(TIDD,NCOLD,NROWD,NSC,ACOL,AROW,ISTAT)      

C        check if the columns exists
C        PPM identifier
         CALL TBCSER(TIDD,':IDENT',NCDIDENT,ISTAT)
         IF (NCDIDENT.LE.0) THEN
            CALL STTPUT('*error* Input column IDENT not found',ISTAT)
            STOP
         ENDIF

C        x position
         CALL TBCSER(TIDD,':XCEN',NCDX,ISTAT)
         IF (NCDX.LE.0) THEN
            CALL STTPUT('*error* Input column XCEN not found',ISTAT)
            STOP
         ENDIF

C        y position
         CALL TBCSER(TIDD,':YCEN',NCDY,ISTAT)
         IF (NCDY.LE.0) THEN
            CALL STTPUT('*error* Input column YCEN not found',ISTAT)
            STOP
         ENDIF



 55      DO I = 1,3
            RESA(I) = 0.0
            RESB(I) = 0.0
         ENDDO

         IN = 0
         ITOT = 0
         IRES = 0
         IRESNO = 0
         
         DO 62 ILOOP = 1, NROWD
            CALL TBERDC(TIDD,ILOOP,NCDIDENT,CTEST,NULL,ISTAT)
            CALL FT_EOS(CTEST,16,ACUR,ISTAT)         !get clean Fortran string

C           *(x/ycen are r*4 read as r*8)
            CALL TBERDD(TIDD,ILOOP,NCDX,XCUR,NULL,ISTAT)
            CALL TBERDD(TIDD,ILOOP,NCDY,YCUR,NULL,ISTAT)

            IF (BLINK.EQ.'Y'.OR.BLINK.EQ.'y') THEN
C           *blink funny format: conversion to (+,-) microns
               XBLINK = XCUR
               YBLINK = YCUR
               CALL BLINKXY(XBLINK,YBLINK,XCUR,YCUR,1)
            ENDIF

            MEND = 0
            IN = IN+ 1


C---        Compute mean (x,y) for each object and R.M.S. in X,Y,R
            IF (IN .LE. 1) THEN
C           *first (X,Y)
               AFOR = ACUR
               XTEMP(1) = XCUR
               YTEMP(1) = YCUR
               IX = 1
               GO TO 62
            ENDIF

            IF (ACUR .EQ. AFOR) THEN
C           *still same object
               IX = IX + 1
               XTEMP(IX) = XCUR
               YTEMP(IX) = YCUR
               GO TO 62
            ENDIF


c-          new object read, do means for the one before
            CALL MEAN(XTEMP,YTEMP,IX,XMEAN,YMEAN,NOUT,RESA,SIG)
            IF (IX.GT.2) THEN
               DO I = 1,3
                  RESB(I) = RESB(I) + RESA(I)
               ENDDO
               IRES = IRES + IX
               IRESNO = IRESNO + 1
            ENDIF
            XTEMP(1) = XCUR
            YTEMP(1) = YCUR


C           *Maximum # of objects is MAXOBJ
            ITOT = ITOT + 1
            IF (ITOT.GT.MAXOBJ) THEN
               WRITE(MSG,9074)
               CALL STTPUT(MSG,ISTAT)
 9074          FORMAT('*error* too many objects ! ')
               CALL STSEPI
               STOP
            ENDIF
 
            PRXY(ITOT,1) = XMEAN/1.0D3
            PRXY(ITOT,2) = YMEAN/1.0D3

C           *conversion Text ident --> Nr ident
            IID = 0
 628        IF (IID .LT. 16) THEN
               IID = IID+1
            ELSE
               WRITE(MSG,*) '*warning* identiers must contain numbers'
               CALL STTPUT(MSG,ISTAT)
               WRITE(MSG,*) '          identifier set to 0'
               CALL STTPUT(MSG,ISTAT)
               NFOR = 0
               GOTO 629
            ENDIF
            READ(AFOR(IID:16),*,err=628) NFOR

 629        MNOST(ITOT) = NFOR
            AFOR = ACUR
            IX = 1

C           *go to read next line
 62      CONTINUE

C        *file is finished
 63      NOBJ = ITOT
         WRITE(MSG,9080) NOBJ
         CALL STTPUT(MSG,ISTAT)
 9080    FORMAT('   No. of objects in (X,Y)-file: ',I5)


C        CALCULATE MEAN R.M.S. FOR MEASURED (X,Y) IN MICRONS

         IF (IRES.GT.0) THEN
            DO I = 1,3
               RESB(I) = RESB(I)/FLOAT(IRESNO)
            ENDDO
            WRITE(MSG,9082) RESB
            CALL STTPUT(MSG,ISTAT)
 9082       FORMAT('   Mean R.M.S. (Microns) in (X,Y,R) :',3f8.2)
            WRITE(MSG,9182) IRES,IRESNO
            CALL STTPUT(MSG,ISTAT)
 9182       FORMAT('   (pix or microns) based on ',i3,
     $           ' (X,Y) measurements of ',
     $           i3,' objects ')
         ELSE
            WRITE(MSG,9083)
 9083       FORMAT('   Not enough measurements of same object to ',
     >           ' calculate mean r.m.s. values ')
         ENDIF
      ENDIF


C----------------------------------------------------------------------
C---  Start the real work
C----------------------------------------------------------------------
C      write(6,*) 'start the real work'
C      ERX = SNGL(SUMD1) 
C      ERY = SNGL(SUMD2) 


c mode:  IOTYP 
c (1) Calculate (A,D) for plate center and several (X,Y)-values'/ 
c (2) Calculate (A,D) for several (X,Y)-values only'/ 
c (3) Calculate (A,D) for one (X,Y)-value'/ 
c (4) Calculate (X,Y) for one (A,D)-position'/
c (5) Calculate (X,Y) for several (A,D)s in disc file'/
c (6) NEW RUN OF POS1'/ 
c (7) EXIT PROGRAMME'// 

      IF (IOTYP.EQ.1) GO TO 1040 
      IF (IOTYP.EQ.2) GO TO 1040
      IF (IOTYP.EQ.3) GO TO 1070
      IF (IOTYP.EQ.4) GO TO 1500 
      IF (IOTYP.EQ.5) GO TO 1600 
      IF (IOTYP.GE.6) GO TO 2000
      GO TO 1010

C-----ENTRY FOR MODE 1
C-----ENTRY FOR MODE 2
C     * Mean positions (e.g. of trail ends)? 
 1040 CALL STKRDC('FLAG',1,1,1,N1,YESNO,IDUM1,IDUM2,ISTAT)

      LMEAN = 0 
      IF (YESNO.EQ.'Y'.OR.YESNO.EQ.'y') LMEAN = 1
C     IF (IOTYP-1) 1120,1100,1120 	obsolete IF, replaced by code below
      IF (IOTYP .EQ. 1) THEN
         GOTO 1100
      ELSE
         GOTO 1120
      ENDIF

C-----ENTRY FOR MODE 3
 1070 IF (BLINK.EQ.'Y'.OR.BLINK.EQ.'y')  THEN
         WRITE(MSG,1075)
         CALL STTPUT(MSG,ISTAT)
 1075    FORMAT('  Use *BLINK* Coordinates. ',
     $        'Give identification No., X, Y: ')
         READ(*,*) NOST1(1),XBLINK,YBLINK
         CALL BLINKXY(XBLINK,YBLINK,XCUR,YCUR,1)
      ELSE
         WRITE(MSG,1080) 
         CALL STTPUT(MSG,ISTAT)
 1080    FORMAT('  Give identification Number, X, Y: ') 
         READ(*,*) NOST1(1),XCUR,YCUR
      ENDIF
      XY(1,1) = XCUR/1.0D3 
      XY(1,2) = YCUR/1.0D3 
      PRXY(1,1) = XY(1,1)
      PRXY(1,2) = XY(1,2)
      IST = 0 
      IEX = 1 
      GO TO 1270 

C---- entry
 1100 WRITE(MSG,9110)
      CALL STTPUT(MSG,ISTAT)
      WRITE(MSG,9111)
      CALL STTPUT(MSG,ISTAT)
      WRITE(MSG,9112)
      CALL STTPUT(MSG,ISTAT)
 9110 FORMAT(' *info* Standard Schmidt plate reduction: ')
 9111 FORMAT('        First 4 non-standard stars(X,Y) are supposed ')
 9112 FORMAT('        to be those of the four crosses.')
C---- entry
 1120 IST = 0 
C     Read the output file name
      CALL STKRDC('OUT_MES',1,1,16,N1,OUTFILE,IDUM1,IDUM2,ISTAT)
C     create the output table
      CALL TBTINI(OUTFILE,F_TRANS,F_O_MODE,6,1000,TIDO,ISTAT)
C     create the columns
      CALL TBCINI(TIDO,D_I4_FORMAT,1,'I7'   ,' ','PPM',NSCPPM,ISTAT)
      CALL TBCINI(TIDO,D_R8_FORMAT,1,'F5.2' ,' ','MAG',NSCMAG,ISTAT)
      CALL TBCINI(TIDO,D_R8_FORMAT,1,'R12.7',' ','R_A',NSCR_A,ISTAT)
      CALL TBCINI(TIDO,D_R8_FORMAT,1,'S12.6',' ','DEC',NSCDEC,ISTAT)
      CALL TBCINI(TIDO,D_R8_FORMAT,1,'F8.4' ,' ','PMA',NSCPMA,ISTAT)
      CALL TBCINI(TIDO,D_R8_FORMAT,1,'F8.4' ,' ','PMD',NSCPMD,ISTAT)


 1200 DO 1240 I = 1,NOBJ
            XY(I,1) = PRXY(I,1) 
            XY(I,2) = PRXY(I,2) 
            NOST1(I) = MNOST(I) 
 1240    CONTINUE
      IEX = NOBJ
 1250 WRITE(MSG,9255) IEX
      WRITE(MSG,*) IEX, nobj
      CALL STTPUT(MSG,ISTAT)
 9255 FORMAT(2X,I5,'    (X,Y)-values read ')

      IF (IOTYP.EQ.1) THEN 
C        plate center
         SUMD1=(XY(3,1)-XY(1,1))*(XY(2,2)-XY(4,2))-
     1         (XY(3,2)-XY(1,2))*(XY(2,1)-XY(4,1)) 
         SUMD2=(XY(2,1)-XY(1,1))*(XY(2,2)-XY(4,2))-
     1         (XY(2,2)-XY(1,2))*(XY(2,1)-XY(4,1)) 
         SUMD3=(XY(3,1)-XY(1,1))*(XY(2,2)-XY(1,2))-
     1         (XY(3,2)-XY(1,2))*(XY(2,1)-XY(1,1)) 
         XCEN = XY(1,1)+(SUMD2/SUMD1)*(XY(3,1)-XY(1,1)) 
         YCEN = XY(2,2)+(SUMD3/SUMD1)*(XY(4,2)-XY(2,2)) 
         NCEN = 0 
         XXCEN = XCEN*1.0D3
         YYCEN = YCEN*1.0D3
         WRITE(MSG,9260) XXCEN,YYCEN 
         CALL STTPUT(MSG,ISTAT)
 9260    FORMAT('   Plate center: X = ',F7.3,'  Y = ',F7.3,'  microns') 
         IEX = IEX + 1
         XY(IEX,1) = XCEN
         XY(IEX,2) = YCEN
      ENDIF

C---entry
 1270 DO 1280 I = 1,IEX
         AR(I,1) = PRXY(I,1)
         AR(I,2) = PRXY(I,2)
         AR(I,3) = DO0 
         AR(I,4) = DO0 
 1280    CONTINUE


C     Conversion of the coord
C     X:
      IXY = 1 
      DO 1300 I16= 1,IEX 
         N = NX+1
         CALL RAR(I16,0,N,KK,IXY,IDX,IDY,X,AR)
         V = DO0 
         DO 1290 I17 = 1,NX
 1290       V = V+BX(I17)*X(I17)
         XY(I16,IXY) = V + CX
 1300    CONTINUE

C     Y:
      IXY = 2 
      DO 1320 I16 = 1,IEX
         N = NY+1
         CALL RAR(I16,0,N,KK,IXY,IDX,IDY,X,AR)
         L=NY
         V=DO0 
         DO 1310 I17=1,L
 1310       V=V+BY(I17)*X(I17)
         XY(I16,IXY) = V + CY
 1320    CONTINUE




      DO 1440 I = 1,IEX
         AKSI = XY(I,1)
         ANU = XY(I,2) 
         CALL XYAD(AKSI,ANU,IA1,ID1,DA1S,DD1S,ITEGN1,ALFAS,DELTS,
     *        COSD0,SIND0,ALFA0)

         IF (I.EQ.1) THEN
            CALL STTPUT(' ',ISTAT)
            CALL STTPUT(' ',ISTAT) 
            CALL STTPUT(' ',ISTAT)
            Write(MSG,9340)
            CALL STTPUT(MSG,ISTAT)
            WRITE(MSG,9341)
            CALL STTPUT(MSG,ISTAT)
            WRITE(MSG,9342)
            CALL STTPUT(MSG,ISTAT)
            WRITE(MSG,9343)
            CALL STTPUT(MSG,ISTAT)
            WRITE(MSG,9344)
            CALL STTPUT(MSG,ISTAT)
         ENDIF
 9340 FORMAT('   The *EQUINOX* of the computed coordinates is that of')
 9341 FORMAT('               the standard stars catalogue')
 9342 FORMAT('   Computed positions for measured objects:')
 9343 FORMAT('      No.      R.A.           Dec. ') 
 9344 FORMAT('    <----> <---------->   <---------->') 

C        IF((I.EQ.1.AND.IRUN.EQ.1).AND.IOTYP.EQ.1) THEN
         IF (I.EQ.1 .AND. IOTYP.EQ.1) THEN
            WRITE(MSG,9352) 
            CALL STTPUT(MSG,ISTAT)
         ENDIF
 9352    FORMAT('Crosses N(1),W(2),S(3),E(4)')

C        IF((I.EQ.1.AND.IRUN.EQ.1).AND.IOTYP.EQ.2) THEN
         IF (I.EQ.1 .AND. IOTYP.EQ.2) THEN
            WRITE(MSG,9360) 
            CALL STTPUT(MSG,ISTAT)
         ENDIF

C        IF((I.EQ.5.AND.IRUN.EQ.1).AND.IOTYP.EQ.1) THEN
         IF (I.EQ.5 .AND. IOTYP.EQ.1) THEN
            WRITE(MSG,9360) 
            CALL STTPUT(MSG,ISTAT)
         ENDIF
 9360    FORMAT('Other objects:')
         
         IF(I.EQ.IEX.AND.IOTYP.EQ.1) THEN
            WRITE(MSG,9370)
            CALL STTPUT(MSG,ISTAT)
         ENDIF
 9370    FORMAT('Plate center coordinates:')
         
         WRITE(MSG,9380) NOST1(I),IA1(1),IA1(2),DA1S,ITEGN1,ID1(1),
     >        ID1(2),DD1S
         CALL STTPUT(MSG,ISTAT)
 9380    FORMAT(I10,2I3,F7.3,2X,A2,I2,I3,F6.2)


C---     OPTION 3
         IF (IOTYP.EQ.3) THEN
C           *only one xy
            WRITE(MSG,9381) NOST1(I),IA1(1),IA1(2),DA1S,ITEGN1,
     >           ID1(1),ID1(2),DD1S 
            CALL STTPUT(MSG,ISTAT)
 9381       FORMAT(' (R.A., DEC) for object',I8,' :',2I3,F7.3,2X,
     >           A2,I2,I3,F6.2)
         ELSE
C        *NOT options 3:
C           *a whole set of xy
            IF (LMEAN.NE.1) THEN
C              *not  measurement of trails
               CALL TBEWRI(TIDO, I, NSCPPM, NOST1(I), ISTAT)
               ALFAS = ALFAS/DOPI18
               CALL TBEWRD(TIDO, I, NSCR_A, ALFAS, ISTAT)
               DELTS = DELTS/DOPI18
               CALL TBEWRD(TIDO, I, NSCDEC, DELTS, ISTAT)
            ELSE
C              *measurement of trails
               IF (MOD(I,2).NE.1)THEN 
                  STAL = (ALFAS + STAL)/2D0 
                  STDE = (DELTS + STDE)/2D0 
                  CALL ADCON(STAL,STDE,ALFA,DELTA)
                  
                  DO J = 1,2
                     IA1(J) = IDINT(ALFA(J) + 1.0D-3)
                     ID1(J) = IDINT(DELTA(J) + DSIGN(1.0D-3,DELTA(J))) 
                  ENDDO
                  
                  DA1S = ALFA(3)
                  DD1S = DELTA(3) 
                  ITEGN1 = ' +' 
                  IF (STDE.LT.DO0) ITEGN1 = ' -'
                  ID1(1) = IABS(ID1(1)) 
                  WRITE(MSG,1420) 
     >                 IA1(1),IA1(2),DA1S,ITEGN1,ID1(1),ID1(2),DD1S
                  CALL STTPUT(MSG,ISTAT)
 1420             FORMAT(20X,'Mean',1X,2I3,F7.3,1X,A2,I2,I3,F6.2) 
               ELSE                  
                  STAL = ALFAS
                  STDE = DELTS
               ENDIF
            ENDIF
         ENDIF       

 1440 CONTINUE

      GO TO 1010



C-----ENTRY FOR MODE 4
 1500 WRITE(MSG,1501)
      CALL STTPUT(MSG,ISTAT)
 1501 FORMAT('  Give (alpha(H,M,S),delta(DEG,M,S)): ')
      READ(5,*) A0,D0 

      CALL ADXY(A0,D0,XEST,YEST,NITER,INEX,COSD0,SIND0,ALFA0, 
     *     NX,NY,KK,IXY,IDX,IDY,BX,BY,CX,CY,SCHMIDT)


      IF (INEX.EQ.1) GO TO 1010
      IF (BLINK.EQ.'Y'.OR.BLINK.EQ.'y') THEN
         XCUR = XEST(2,1)
         YCUR = YEST(2,1)
         CALL BLINKXY(XBLINK,YBLINK,XCUR,YCUR,2)
         XEST(2,1) = XBLINK
         YEST(2,1) = YBLINK
         WRITE(MSG,1502)
         CALL STTPUT(MSG,ISTAT)
 1502    FORMAT(' NB! Blink coordinates !')
      ENDIF
      DO 1505 J = 1,2
         IA1(J) = IDINT(A0(J) + 1.0D-3)
 1505    ID1(J) = IDINT(D0(J) + DSIGN(1.0D-3,D0(J))) 
      WRITE(MSG,1510) NITER,XEST(2,1),YEST(2,1)
      CALL STTPUT(MSG,ISTAT)
 1510 FORMAT(I5,' iterations; ( X , Y ) = ',2F12.2) 
C     WRITE(MSG,1520) IA1,A0(3),ID2,D0(3),XEST(2,1),YEST(2,1)
      WRITE(MSG,1520) IA1,A0(3),ID1,D0(3),XEST(2,1),YEST(2,1) 
      CALL STTPUT(MSG,ISTAT)
 1520 FORMAT(1X,2I3,F7.3,2I4,F6.2,' : (X,Y) = ',2F12.2) 
      WRITE(MSG,1530)
      CALL STTPUT(MSG,ISTAT)
 1530 FORMAT(' More positions ? ') 
      READ(*,9016) YESNO
      IF (YESNO.EQ.'Y'.OR.YESNO.EQ.'y') GO TO 1500
      GO TO 1010




C-----ENTRY FOR MODE 5
 1600 WRITE(*,1630)
 1630 FORMAT('***SOOORRRY*** this part works on plain ASCII, not MIDAS'/
     $     '  GIVE NAME OF DISC FILE WITH (A,D)-VALUES: ',$)
      READ(*,1640) ADXYFILE
 1640 FORMAT(A16) 
      OPEN(UNIT=50,FILE=ADXYFILE,STATUS='old',ERR=1600)
      WRITE(*,1650)
 1650 FORMAT('  GIVE MAX.DISTANCE FROM PLATE CENTER IN MICRONS: ',$) 
      READ(*,*) DMAX
      IST = 0 
      I1 = 0
      WRITE(*,1670)
 1670 FORMAT('  STORE THE (X,Y)-VALUES IN A DISC FILE? ',$)
      READ(*,9016) YESNO
      IF (YESNO.EQ.'Y'.OR.YESNO.EQ.'y') IST = 1
      IF (IST.NE.1) GO TO 1710 
 1675 WRITE(*,1680)
 1680 FORMAT('  GIVE FILE NAME: ',$) 
      READ(*,1640) XYFILE
      OPEN(UNIT=60,FILE=XYFILE,STATUS='NEW',ERR=1675)
      ITOT = 0
 1710 READ(50,1720) HEADER
 1720 FORMAT(A50)
C      WRITE(LU_LOG,1730) ADXYFILE,HEADER
      WRITE(*,1730) ADXYFILE,HEADER
 1730 FORMAT(/,1X,'  (A,D)-POSITIONS FROM FILE: ',A16,
     1/,1X,'  IDENT: ',A50       // 
     21X,'    NO.       X            Y') 
 1740 READ(50,*,END=1010) IANO,A0,D0
 1760 CALL ADXY(A0,D0,XEST,YEST,NITER,INEX,COSD0,SIND0,ALFA0, 
     *NX,NY,KK,IXY,IDX,IDY,BX,BY,CX,CY,SCHMIDT)
      IF (BLINK.EQ.'Y'.OR.BLINK.EQ.'y') THEN
         XCUR = XEST(2,1)
         YCUR = YEST(2,1)
         CALL BLINKXY(XBLINK,YBLINK,XCUR,YCUR,2)
         XEST(2,1) = XBLINK
         YEST(2,1) = YBLINK
         WRITE(*,1502)
      ENDIF
      WRITE(*,1775) IANO,XEST(2,1),YEST(2,1)
C      WRITE(LU_LOG,1775) IANO,XEST(2,1),YEST(2,1) 
 1775 FORMAT(1X,I6,2F12.2) 
 1785 IF (IST.NE.1) GO TO 1740 
      WRITE(60,1775) IANO,XEST(2,1),YEST(2,1)
 1790 FORMAT(4F8.0) 
      GO TO 1740 

C---- Error messages
C 8018 WRITE(MSG,*) '*ERROR* cannot open standard file ',PSFILE
C      CALL STTPUT(MSG,ISTAT)
C      STOP
C
C 8019 WRITE(MSG,*) '*ERROR* cannot open positions file ',DFILE
C      CALL STTPUT(MSG,ISTAT)
C      STOP

C-----ENTRY FOR MODE 6
C-----ENTRY FOR MODE 7
 2000 CONTINUE 
 3000 WRITE(MSG,3001) 
      CALL STTPUT(MSG,ISTAT)
 3001 FORMAT('   ')
 1010 CALL STSEPI
 9045 FORMAT(A50)
 9050 FORMAT(2X,A50)
 9999 Format(80a)
 9076 FORMAT(I8,2F12.3,I5,3F8.3,I5)
 9085 FORMAT(I4,I4,I3,F7.3,I5,I4,F7.2,2F8.2)
 9115 FORMAT(I6,F6.2,2I3,F7.3,A2,I2,I3,F6.2,2I6)
 9016 FORMAT(A1)

      END

C @(#)fitread.for	19.1 (ES0-DMD) 02/25/03 13:18:46
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  15:59 - 20 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION
C
C  program FITREAD.FOR
C
C.PURPOSE
C
C  Execute the commands
C  READ/FIT  [fitname]
C  PRINT/FIT [fitname]
C
C.KEYWORDS
C
C  FIT, READ, PRINT
C
C.INPUT/OUTPUT
C
C  P1 - P8     contain input parameters
C
C
C.ALGORITHM
C
C  Use fit interface routines
C
C-----------------------------------------------------------
C
      IMPLICIT NONE
C
C ... define parameters
C
      INTEGER IVAR(16),FIX(20),STATUS,I,II,ISTAT,N,NP,J
      INTEGER NL,NPAR,NFUN,NDAT,NIND,KUN,KNUL,IDVAR
      INTEGER ITER,MADRID(1),NAMLEN
C
      REAL    CHISQ,RELAX
C
      DOUBLE PRECISION ERR(20),PAR(20)
C
      CHARACTER*80 LINE,HEAD,OUT
      CHARACTER*80 NAME,FILE,FNAME
      CHARACTER*4  TYPE
      CHARACTER*30 AUX,AUX1
      CHARACTER*16 MSG
C
       INCLUDE 'MID_INCLUDE:FITI.INC/NOLIST'
       INCLUDE 'MID_INCLUDE:FITC.INC/NOLIST'
C
      COMMON/VMR/MADRID
C
      DATA NAMLEN/80/
      DATA MSG/'ERR:FITREADxxxx'/
      DATA HEAD/
     +     ' Parameter Initial Guess      Actual Value       Error '/
C
C ... get into MIDAS
C
      CALL STSPRO('FITREAD')
      CALL FITBL
C      CALL STKRDC('MID$CMND',1,1,1,I,I,KUN,KNUL,ISTAT)
      FZTYPE = ' '
C
C ... list fit
C
C IF (IAC.EQ.'P') CALL MIDOUT
C
C ... read params
C
      CALL STKRDC('P1',1,1,NAMLEN,I,NAME,KUN,KNUL,ISTAT)
      IF (NAME(1:1).EQ.'?') THEN
          CALL STKRDC('FITNAME',1,1,NAMLEN,I,NAME,KUN,KNUL,ISTAT)
      ELSE
          CALL STKWRC('FITNAME',1,NAME,1,NAMLEN,KUN,ISTAT)
      END IF
C
C ... read fit information
C
      CALL FTINIT(NAME,ISTAT)
      CALL FTINFO(FILE,TYPE,IDVAR,NIND,NFUN,NDAT,ISTAT)
      IF (TYPE.EQ.'BDF ') THEN
          LINE   = ' Fit on image '//FILE
          CALL STTPUT(LINE,ISTAT)
      ELSE
          IF (TYPE.EQ.'TBL ') THEN
              LINE   = ' Fit on table '//FILE
              CALL STTPUT(LINE,ISTAT)
          ELSE
              CALL STTPUT(' Fit on one dep. variable',ISTAT)
          END IF
      END IF
      LINE   = ' No. of data points '
      WRITE (LINE(25:32),9030) NDAT
      CALL STTPUT(LINE,ISTAT)
C
      CALL STTPUT(' ',ISTAT)
      IF (TYPE.EQ.'TBL ') THEN
          LINE   = ' Dependent variable '
          WRITE (LINE(25:28),9000) IDVAR
          CALL STTPUT(LINE,ISTAT)
      END IF
      LINE   = ' No. of ind. variables '
      WRITE (LINE(25:28),9000) NIND
      CALL STTPUT(LINE,ISTAT)
C
C ... read fit variables
C
      IF (NIND.GT.0) THEN
          CALL FTRDIN(NIND,IVAR,N,ISTAT)
          IF (TYPE.EQ.'BDF ') THEN
              LINE   = ' variable .... is axis   ....'
          ELSE
              IF (TYPE.EQ.'TBL ') THEN
                  LINE   = ' variable .... is column ....'
              ELSE  !   DO NOT PRINT IVAR
                  NIND   = 0
              END IF
          END IF
          DO 10 I = 1,NIND
              WRITE (LINE(11:14),9000) I
              WRITE (LINE(26:29),9000) IVAR(I)
              CALL STTPUT(LINE,ISTAT)
   10     CONTINUE
      END IF
C
C ... read coeffs
C
      CALL STTPUT(' ',ISTAT)
      LINE   = ' No. of functions '
      WRITE (LINE(25:28),9000) NFUN
      CALL STTPUT(LINE,ISTAT)
      NP     = 0
      DO 30 I = 1,NFUN
          CALL STTPUT(' ',ISTAT)
          CALL FTRDFN(I,LINE,ISTAT)
          II     = INDEX(LINE,')')
          CALL STTPUT(LINE(1:II),ISTAT)
          CALL STTPUT(HEAD,ISTAT)
          CALL FTRDPR(I,FNAME,NPAR,PAR,ERR,FIX,ISTAT)
          LINE   = FZSPEC(I)
          IF (NPAR.GT.0) THEN
              DO 20 J = 1,NPAR
                  NP     = NP + 1
                  NL     = FZPLEN(NP)
                  AUX    = FZPTOKEN(NP)
                  AUX1   = AUX(1:NL)//'='
                  II     = INDEX(LINE,AUX1(1:NL+1))
                  IF (II.EQ.0) THEN
                      AUX1   = '-'
                  ELSE
                      AUX    = LINE(II+NL+1:)
                      II     = INDEX(AUX,' ') - 1
                      AUX1   = AUX(1:II)
                  END IF
                  WRITE (OUT,9010) FZPTOKEN(NP),AUX1(1:16),PAR(J),
     +              ERR(J)
                  CALL STTPUT(OUT,ISTAT)
   20         CONTINUE
          END IF
   30 CONTINUE
C
C ... read fit results
C
      CALL STTPUT(' ',ISTAT)
      CALL FTSTAT(CHISQ,RELAX,ITER,ISTAT)
      WRITE (LINE,9020) CHISQ,RELAX,ITER
      CALL STTPUT(LINE,ISTAT)
C
C ... end
C
      IF (ISTAT.NE.0) THEN
          WRITE (MSG(13:16),9000) ISTAT
          CALL TDERRR(ISTAT,MSG,STATUS)
      END IF
      CALL STSEPI
 9000 FORMAT (I4)
 9010 FORMAT (1X,A,2X,A,1X,E14.6,1X,E14.6)
 9020 FORMAT (' Chi sq. = ',E13.4,' relaxation factor = ',F7.3,' itera',
     +       'tions = ',I4)
 9030 FORMAT (I8)
      END

C===========================================================================
C Copyright (C) 1995-2006 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================

C ++++++++++++++++++++++++  ysts.for +++++++++++++++++++++++++++++++++++++++
C .LANGUAGE Fortran 77
C .IDENTIFICATION Module ysts.for
C .COMMENTS
C Module contains layer between the keyword related FORTRAN STxxxx interfaces
C and the SC_interfaces written in (hopefully independent) C
C .AUTHOR         K. Banse        ESO - Garching
C .KEYWORDS       standard interfaces.
C .ENVIRONMENT    FORTRAN and C standards
C .VERSION  [1.00] 871207:  
C 
C 060327		last modif
C -----------------------------------------------------------------------------
C
      SUBROUTINE STSKIN(KEYFILE,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   KEYFILE
      INTEGER    STATUS
C 
      CALL STSTR(1,KEYFILE)                          !STRIPPED_STRING
C 
      CALL STS1(STATUS)
C
      RETURN
      END

C   SUBROUTINE STSPRO(PROG)
CC   directly done in sts.fc ...

CC   SUBROUTINE STSEPI
CC   directly done in sts.fc ...

CC   SUBROUTINE STPSET(PARNO,PVALS,STATUS)
CC   directly done in sts.fc ...

C @(#)afido.for	19.1 (ES0-DMD) 02/25/03 13:18:58
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE AFIDO(NX,NY,MT,IN,H0,H1,HG,HL,OUT,M,ORD,TYP,
     >                 FORM,NOI,K,YMT)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C  execution of the algorithm.
C
C  NX,NY       : number of pixels in line and column resp.
C  IN          : input frame (IN_A)
C  MT          : mask frame for noise statistics (IN_B)
C  OUT         : output frame (OUT_A)
C  H0,H1,HG,HL : internal work frames
C  M           : internal work frame; holds the order at wich
C                a pixel becomes significant
C  ORD         : highest order to be applied (determined by the
C                largest filtersize AFISIZ)
C  TYPE        : filter type (AFITYP)
C  FORM        : filter shape (AFISHA)
C  NOI         : noise model (AFINOI)
C  K           : threshold for significance (AFIK)
C  YMT         : swich if mask for statistics is given (='Y') 
C                or not (='N')
C---------------------------------------------------------------------------
      IMPLICIT NONE
C
      CHARACTER*80    B
      CHARACTER*1     TYP,FORM,YMT,NOI
      REAL            IN(1),H0(1),H1(1),HG(1),HL(1),OUT(1),A,
     >                EG,SG,EL,SL,K,M(1),MT(1),C,OG,OL,UL,MOG,MOL,MUL
      INTEGER         NSG,NSL,NREST,NX,NY,ORD,OE,V,N,I,NN
C
      COMMON          /TEST/EG(16),SG(16),EL(16),SL(16),
     >                      NSG(16),NSL(16),NREST,MOG,MOL,MUL
C
 100  FORMAT(' *** WARNING:',I6,' PIXELS NEGATIVE ! ***')

      NN=0
      OE=0
      NREST=0
      N=NX*NY
      C=3./8.
C
      DO I=1,N
         OUT(I)=0
         M(I)=0
      ENDDO
C
      IF (NOI.EQ.'A') THEN
         CALL AINI(NX,NY,MT,IN,H0,HG,HL,EG(2),EL(2),SG(2),SL(2),YMT)
      ELSE
         DO I=1,N                  ! Anscombe-transform
            A=IN(I)
            IF (A.LE.0.) THEN
               H1(I)=0.
               IF (A.LT.0.) NN=NN+1
            ELSE
               H1(I)=SQRT(A+C)
            ENDIF
         ENDDO
         IF (NN.NE.0) THEN
            WRITE(B,100) NN
           CALL STTPUT(B,NN)
         ENDIF
         CALL AINI(NX,NY,MT,H1,H0,HG,HL,EG(2),EL(2),SG(2),SL(2),YMT)
      ENDIF

      OG=EG(2)+K*SG(2)              ! threshold for gradient
      OL=EL(2)+K*SL(2)              ! upper threshold for Laplace
      UL=EL(2)-K*SL(2)              ! lower threshold for Laplace
      MOG=OG
      MOL=OL
      MUL=UL

C
      IF (NOI.EQ.'A') THEN
        CALL ATEST(NX,NY,IN,HG,HL,OUT,M,OG,UL,OL,
     >          NSG(2),NSL(2),2,TYP)
      ELSE
        CALL ATEST(NX,NY,H1,HG,HL,OUT,M,OG,UL,OL,
     >          NSG(2),NSL(2),2,TYP)
      ENDIF

      IF (ORD.LE.2) GOTO 90

C
      DO I=3,16
         IF (FORM.EQ.'B') V=(2**I)/4
         IF (FORM.EQ.'P') V=(2**((I+1)/2))/2
         OE=I-(I/2)*2
         IF (OE.EQ.1) CALL ABOX(NX,NY,MT,H0,H1,HG,HL,EG(I),EL(I),
     >                          SG(I),SL(I),V,YMT)
         IF (OE.EQ.0) CALL ABOX(NX,NY,MT,H1,H0,HG,HL,EG(I),EL(I),
     >                          SG(I),SL(I),V,YMT)
         OG=EG(I)+K*SG(I)
         OL=EL(I)+K*SL(I)
         UL=EL(I)-K*SL(I)
         MOG=AMAX1(MOG,OG)
         MOL=AMAX1(MOL,OL)
         MUL=AMIN1(MUL,UL)
         IF (OE.EQ.1) CALL ATEST(NX,NY,H0,HG,HL,OUT,M,OG,UL,
     >                           OL,NSG(I),NSL(I),I,TYP)
         IF (OE.EQ.0) CALL ATEST(NX,NY,H1,HG,HL,OUT,M,OG,UL,
     >                           OL,NSG(I),NSL(I),I,TYP)
         IF (ORD.EQ.I) GOTO 90
      ENDDO
C
C *** fill the not jet significant pixels in the output frame
   90 DO I=1,N
         IF (M(I).EQ.0) THEN
            IF (TYP.EQ.'S') THEN
               IF (OE.EQ.1) OUT(I)=H1(I)
               IF (OE.EQ.0) OUT(I)=H0(I)
            ELSE
               IF (TYP.EQ.'G') OUT(I)=HG(I)
               IF (TYP.EQ.'L') OUT(I)=HL(I)
            ENDIF
            NREST=NREST+1
         ENDIF
      ENDDO

C
      IF (NOI.EQ.'A' .OR. TYP.NE.'S') RETURN

      DO I=1,N
         OUT(I)=OUT(I)**2-C                ! inverse Anscombe-transform
      ENDDO

      RETURN
      END

C @(#)dtom.for	19.1 (ES0-DMD) 02/25/03 13:31:22
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
	PROGRAM DTOM
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENT  program DTOM				A. Lauberts	ESO  890710
C
C.KEYWORDS  characteristic curve, Schmidt plates, standard galaxies,
C	    sensitometer spots
C
C.PURPOSE
C
C  Find least squares fit of
C  MPG = photographic magnitude/2.5 (in rings between circular apertures)
C                                    + innermost aperture
C  to
C  MEL = photoelectric magnitude/2.5 (in same rings as MPG)
C                                     curve fitted
C  and simultaneously
C
C   F  = A*log(D-DF) + B*log(DS-D) + CM (the D to log I function)
C  to  
C   E  = log I + CS (versus the spot densities D)
C
C  Minimize  S = Sum (MPG-MEL)**2 + Sum (F-E)**2
C      over   min0:max9 rings       min0:max21 spots
C  where 
C
C   D = Density measured by PDS (divide by 200 or 800!) 
C  DF = Density of the chemical fog  = X(1) = XX(1)  
C  DS = Density at saturation        = X(2) = XX(2)
C   G = Gamma = dD/d(log I)
C  RG = ln10/Gamma at infl           = X(3) = XX(7)       
C  DI = Density at inflexion point   = X(4) = XX(8)
C  DB = Density at sky background
C  CM = Zero point for mag/2.5       = X(5)
C       Zero point in sky units             = XX(5)
C  CS = Zero point for spots         = X(6) = XX(9)
C   A = RG*(DI-DF)**2/(DS-DF)               = XX(3)                     
C   B =-RG*(DS-DI)**2/(DS-DF)               = XX(4)
C  SM = Sky magnitude/20 micron aperture    = XX(6)
C
C.USAGE  MIDAS applic program
C	 execute as @@ DTOM
C
C.PARAMETERS
C
C Input: promted by inquire statements 
C
C  TABLEA    C*8	standard galaxy photoel table file
C			(format same as BVRLA.TBL used for the 
C			automated ESOLV procedures)
C  TABLEC    C*8	table file with calibration parameters
C  FRAMEA    C*8	image frame with central galaxy
C  FRAMEB    C*8	table file with sensitometer spots:
C  			SE   R*4 array  log I	intensity
C  			SD   R*4 array	D	density
C  NES	     R*4 array  1st elem, no of spots wanted
C  SPOTE     R*4	constant log I difference (option)
C  NA, NR    I*4	no of apertures (rings)
C  ESO	     R*4	ESO ident = (field.object no) = ESO.OBJ
C  SCAL	     R*4	plate scale arcseq/mm
C  WT	     R*4 array	weights of innermost, outermost, internal rings
C  SM	     R*4	sky mag/20 microns aperture (option)
C  XX	     R*4 array	initial calibration values (4 first elems)
C  FIX	     I*4 array	1/0 for fix/no-fix calibr parameters
C
C Descriptors:
C
C  BVR	     R*4 array 	ident ESO.OBJ + BVR vs log A coefficients read from 
C			TABLEA (format same as BVRLA.TBL used for the
C			automated ESOLV procedures).
C  GALCEN    R*4 array	Galaxy centre computed in program COMSKY
C			or set by interactive cursor
C  SKYBGR    R*4 array  Sky background computed in COMSKY
C			= command COMUTE/SKY
C
C Output:
C
C  CAL	     R*4 array	ident ESO.OBJ + calibration parameters -> TABLEC
C
C.COMMENTS
C
C Note: In case of non-existing V-R (all coeffs = 0's), a substitute
C	is taken as
C
C	V-R = 0.134 + 0.453 * (B-V)  at BS = 22 mags/sqarcs
C	d(V-R)/dlogA = -0.025 = constant,
C
C	being a good approximation (R.M.S. err = 0.02)
C	for 0.8 < B-V < 1.2 (E and S0's)
C 
C	The photoelectric values are reduced to outside the atmosphere
C	(airmass zero). Therefore, the present 'sky parameter' becomes 
C	brighter than the true sky. The magnitude difference is simply
C	the actual extinction. Whenever needed we take Bext = 0.20 (ESO
C	manual 1978) and Rext = 0.10 (ESO manual gives 0.08, own observ
C	0.12 after 1982) per unit airmass.
C
C	This program calls former NAGLIB subroutine E04GAF, 
C	which - together with supplementary smaller routines -
C	presently resides in module MNAG
C
C-------------------------------------------------------------------------------
	COMMON /VMR/MADRID(1)
	COMMON /DENS/ID(4096,9),MAXD,NR,WT(30),NS,DB,SM,A,B,XX,STEP,
     +  	SD(21),SE(21),EL(9),ORG,FIX
	DOUBLE PRECISION  RR,F,X(6),X02AAF,XTOL(6),SCALE(6),R(33),W(100),
     +		A,B,DB,ORG(6)
	REAL  XX(9),APER(9),MEL(9),RADA(9),WEIGHT(9),CEL(9),
     +		STEPA(2),STARTA(2),CEN(2),LOGA(9),BVR(31),CAL(9),SEL(9)
	INTEGER  NPIXA(2),STAT,PNTRA,NES(2),COLA(31),COLC(9),FIX(6)
	CHARACTER*1   CALC,CHR
	CHARACTER*60  FRAMEA,FRAMEB,SKYMAG,TABLEA,TABLEC,LABEL(2)
	CHARACTER*20  IDENTA
	CHARACTER*24  CUNITA
	CHARACTER*9   FSSQ
	CHARACTER*72  CALIB,RESIDS,SURFB
	CHARACTER*3   ERRNO,RIN,SPO
	LOGICAL	      NULL(31),IFL
C
	PARAMETER     NCOLA=31, NCOLC=9
	DATA          COLC/1,2,3,4,5,6,7,8,9/,
     +		      LABEL/'DENSITY','LOG_INT'/
C
	EXTERNAL  RESID,LSQ,MONIT
C
	G(D)=C3*ALOG10(D-C1)+C4*ALOG10(C2-D)+C5
C
	DO I=1,31
	  COLA(I)=I
	ENDDO
C
C  set up MIDAS environment, access tables (already existing)
C
	CALL SXSPRO('DTOM',STAT)
	CALL SXKGET('TABLEA','C',1,60,IAV,TABLEA,STAT)
	CALL SXKGET('TABLEC','C',1,60,IAV,TABLEC,STAT)
	CALL TXTOPN(TABLEA,STAT)
	CALL TXTOPN(TABLEC,STAT)
C  get plate info
	CALL SXKGET('INPUTC','C',1,1,IAV,CHR,STAT)
	CALL SXKGET('SCALE','R',1,1,IAV,SCAL,STAT)
	SKY=0.
	DB=0.
	DO 40 J=1,30
	WT(J)=1.
40	CONTINUE
	CALL SXKGET('IN_B','C',1,60,IAV,FRAMEB,STAT)
	CALL TXTOPN(FRAMEB,STAT)
	CALL TXIGET(FRAMEB,NCOLB,NROWB,IAV,STAT)
	NS=NROWB
	DO I=1,NS
	  CALL TXRGET(FRAMEB,'R',I,2,COLA,XX,NULL,STAT)
	  SE(I)=XX(1)
	  SD(I)=XX(2)
	ENDDO
	WRITE(6,111) (SD(I),I=1,NS)
111	FORMAT(' SPOTD',10F7.3)
48	WRITE(6,*) ' first element, no of spots: '
	READ(5,*) NES
	NE=NES(1)
	NS=NES(2)
	IF(NS.EQ.1.OR.NS.GT.21) THEN
	  CALL SXTPUT('NO OF SPOTS MUST BE 0 OR 2-21',STAT)
	  GOTO 48
	ENDIF
	IF(NS.EQ.0) GOTO 55
	WRITE(6,*) ' const log intensity difference 
     + (if =0 then 1st col in Cxxx): '
	READ(5,*) SPOTE
49	CONTINUE
	IF(NE.NE.1) THEN
	  NE=NE-1
	  DO I=1,NS
	    SD(I)=SD(I+NE)
	    SE(I)=SE(I+NE)
	  ENDDO
	ENDIF
	IF(SPOTE.GT.0.) THEN
	  DO I=1,NS
	    SE(I)=SPOTE*FLOAT(I)
	  ENDDO
	  S=-0.5
	  DO I=1,NROWB
	    CALL TXEPUT(FRAMEB,'R',I,1,S,STAT)
	    S=S+SPOTE
	  ENDDO
	ENDIF
	WRITE(6,112) (SE(I),I=1,NS)
112	FORMAT(' SPOTE',10F7.3)
	CALL TXTCLO(FRAMEB,STAT)
	NR=0
55	CALL SXKGET('NAPE','I',1,1,IAV,NA,STAT)
	IF(NA.GT.9) THEN
	  CALL SXTPUT(' >9 APERTURES/OBJECT',STAT)
	  GOTO 55
	ENDIF
C  get image frame 
	CALL SXKGET('IN_A','C',1,60,IAV,FRAMEA,STAT)
	CALL SXIGET(FRAMEA,'I',2,NAXISA,NPIXA,STARTA,STEPA,
     +              IDENTA,CUNITA,PNTRA,STAT)
	IF(NA.NE.0) CALL SXDGET(FRAMEA,'GALCEN','R',1,2,IAV,CEN,STAT)
	CALL SXDGET(FRAMEA,'SKYBGR','R',1,1,IAV,SKY,STAT)
	CALL SXDGET(FRAMEA,'O_TIME','R*8',1,1,IAV,A,STAT)
	IF(A.GT.1983.5D0) THEN
	  MAXD=4096
	  DB=SKY/800.
	 ELSE
	  MAXD=1024
	  DB=SKY/200.
	ENDIF
C  convert sky to mags/(20*20) square micron aperture
	STEP=STEPA(1)
	IF(NA.EQ.0) THEN
	  CALL SXKGET('SKYMAG','R',1,1,IAV,SM,STAT)
	  SM=SM-5.*ALOG10(SCAL*0.020)
	ENDIF
	NDIM=NPIXA(1)*NPIXA(2)
	IF(NA.EQ.0) GOTO 100
	NA1=9
	S=5000./SCAL
	A1=10.**0.1
	DO I=1,NA1
	  RADA(I)=S
	  S=S*A1
	ENDDO
	A1=0.9
	M=100*MAXD/1024
	CALL INTEGR(NDIM,MADRID(PNTRA),STARTA,STEPA,NPIXA,CEN,RADA,
     +              NA1)
	CALL SXTPUT(' D-UP    0.5  1.0  1.5  2.0  2.5  3.0  3.5  
     +4.0  4.5  5.0',STAT)
	DO J=1,NA1
	  DO I=1,M*10,M
	    DO K=1,M-1
	      ID(I,J)=ID(I,J)+ID(I+K,J)
	    ENDDO
	  ENDDO
	  A1=A1+0.1
	  WRITE(SURFB,204) A1, (ID(I,J), I=1,M*10,M)
	  CALL SXTPUT(SURFB,STAT)
	ENDDO
	S=RADA(NA1)
	NA1=5
	A1=10.**0.1
	DO I=1,NA1
	  RADA(I)=S
	  S=S*A1
	ENDDO
	A1=1.8
	CALL INTEGR(NDIM,MADRID(PNTRA),STARTA,STEPA,NPIXA,CEN,RADA,
     +              NA1)
	DO J=2,NA1
	  DO I=1,M*10,M
	    DO K=1,M-1
	      ID(I,J)=ID(I,J)+ID(I+K,J)
	    ENDDO
	  ENDDO
	  A1=A1+0.1
	  WRITE(SURFB,204) A1, (ID(I,J), I=1,M*10,M)
	  CALL SXTPUT(SURFB,STAT)
	ENDDO
	WRITE(6,*) ' first, last log aperture: '
	READ(5,*) LOGA(1),LOGA(2)
C  specify table entry
60	CALL SXKGET('ESOOBJ','R',1,1,IAV,ESO,STAT)
	APER(1)=10.**LOGA(1)
	RADA(1)=APER(1)*500./SCAL
       IF(NA.GT.1) THEN
	 S=(LOGA(2)-LOGA(1))/FLOAT(NA-1)
	 A1=10.**S
	DO I=2,NA
	 APER(I)=APER(I-1)*A1
	 LOGA(I)=LOGA(I-1)+S
	 RADA(I)=RADA(I-1)*A1
	ENDDO
       ENDIF
C  store density distribution in common block /DENS/ID
C  new RADA out!
	CALL INTEGR(NDIM,MADRID(PNTRA),STARTA,STEPA,NPIXA,CEN,RADA,
     +              NA)
C  refine apertures considering actual no of pixels
	DO I=1,NA
	  APER(I)=RADA(I)*SCAL*0.002
	  LOGA(I)=ALOG10(APER(I))
	ENDDO
C  read BVR vs log A polynomial fit coefficients 
C  BVR(1) = ESO ident in the fld.obj no form 
C  Example: 271.012 means ESO field = 271, 12 = object no in ESO/Upp cat
C
	ERR=0.0005
	CALL TXESER(TABLEA,'R*4',1,ESO,ERR,1,NSEQ,STAT)
	CALL TXRGET(TABLEA,'R*4',NSEQ,NCOLA,COLA,BVR,NULL,STAT)
C  compute array of U,B,V or R values vs aperture A
C  as well as surface brightness in mags/sqarcsec
	CALL POLY('B',BVR,LOGA,MEL,SEL,NA)
	CALL SXTPUT('B SURFBR MAGS/SQARCSEC',STAT)
	WRITE(SURFB,201) (SEL(I), I=1,NA)
	CALL SXTPUT(SURFB,STAT)
	IF(CHR.NE.'B') THEN
	  CALL POLY(CHR,BVR,LOGA,MEL,CEL,NA)
	  CALL SXTPUT(' B-'//CHR,STAT)
	  DO I=1,NA
	    CEL(I)=SEL(I)-CEL(I)
	  ENDDO
	  WRITE(SURFB,201) (CEL(I), I=1,NA)
	  CALL SXTPUT(SURFB,STAT)
	ENDIF
	CALL SXTPUT(' AT APERTURES ARCSEC',STAT)
	WRITE(SURFB,201) (APER(I), I=1,NA)
	CALL SXTPUT(SURFB,STAT)
C  take .4 times magnitude of inner aperture
	EL(1)=.4*MEL(1)
C  transform magnitudes to intensities
	DO 80 I=1,NA
80	MEL(I)=10.**(-.4*MEL(I))
	IF(NA.EQ.1) GOTO 100
C  take negative log of intensities in rings bound by apertures
	DO 90 I=2,NA
90	EL(I) = - ALOG10(MEL(I)-MEL(I-1))
100	NR=NA
C  free this area for next input
	CALL SXFCLO(FRAMEA,STAT)
120	N=6
	M=NR+NS
	IF(NR.EQ.0) GOTO 125
	CALL SXKGET('WEIGHT','R',1,9,IAV,WEIGHT,STAT)
	WT(1)=WEIGHT(1)
	WT(NA)=WEIGHT(2)
	DO I=2,NA-1
	  WT(I)=WEIGHT(I+1)
	ENDDO
C  equal importance photoel vs photographic
	S=1.
	IF(NS.NE.0) S=NS/FLOAT(NR)
	DO I=1,NR
	  WT(I)=WT(I)*S
	ENDDO
C  get initial values XX
125	CALL SXKGET('INPUTR','R',1,4,IAV,XX,STAT)
	CALL SXKGET('INPUTI','I',1,N,IAV,FIX,STAT)
      DO I=1,4
	X(I)=XX(I)
      ENDDO
	X(5)=0.
	X(6)=0.
	CALL RESID(M,N,X,R,IFL)
	IF(NR.EQ.0) GOTO 130
      A1=0.
      DO I=1,NR
	A1=A1+WT(I)
	X(5)=X(5)-R(I)
      ENDDO
	X(5)=X(5)/A1
130	CONTINUE
      A1=0.
      DO I=NR+1,M
	A1=A1+WT(I)
	X(6)=X(6)-R(I)
      ENDDO
	IF(NS.NE.0) X(6)=X(6)/A1
        XTOL(1)=DSQRT(X02AAF(RR))
      DO I=1,N
	ORG(I)=X(I)
      ENDDO
      DO I=2,N
	XTOL(I)=XTOL(1)
      ENDDO
        METHOD=1
        IW=N*(N+4)+M    
        IPRINT=1    
        MAXCAL=20      
        IFAIL=0
	CALL SXTPUT('E04GAF RESULTS:',STAT)
        CALL E04GAF(M,N,X,R,F,XTOL,METHOD,SCALE,W,IW,RESID,LSQ,   
     +              MONIT,IPRINT,MAXCAL,IFAIL)
160	WRITE(ERRNO,202) IFAIL
	CALL SXTPUT('THIS HAS ERROR NUMBER'//ERRNO,STAT)
C  update calibration parameters in TABLEC (one row only)
	CALL SXKGET('ESOFLD','I',1,1,IAV,NSEQ,STAT)
	IF(NA.NE.0.) THEN
	  CAL(1)=ESO
	  ELSE
	  CAL(1)=NSEQ
	ENDIF
	I=ESO
	IF(I.NE.NSEQ) TYPE *,ESO,' not in field ',NSEQ
       DO I=1,8
	CAL(I+1)=XX(I)
       ENDDO
	CALL TXRPUT(TABLEC,'R',1,NCOLC,COLC,CAL,STAT)
999	CALL TXTCLO(TABLEA,STAT)
	CALL TXTCLO(TABLEC,STAT)
	CALL SXSEPI
200	FORMAT(E9.3)
201	FORMAT(9F8.3)
202	FORMAT(I3)
203	FORMAT(F8.2)
204	FORMAT(1X,F3.1,3X,10I5)
	END                                                     
C   
C    
      SUBROUTINE RESID(M,N,XC,RC,IFL)     
C  CALLED BY EO4GAF AND LSQ 
C  CALCULATES THE VALUES OF THE RESIDUALS RC AT XC
     	COMMON /DENS/ID(4096,9),MAXD,NR,WT(30),NS,DB,SM,A,B,XX,STEP,
     +		SD(21),SE(21),EL(9),ORG,FIX
      LOGICAL IFL        
      DOUBLE PRECISION  XC,RC,Q,X41,X24,XC1,XC2,XC4,X,A,B,IP,DB,ORG(6)
      DIMENSION XC(N),RC(M),XX(9)
      INTEGER FIX(6)
C
	F(X) = A*DLOG10(X-XC1) + B*DLOG10(XC2-X)
	DO I=1,N
	  IF(FIX(I)) XC(I)=ORG(I)
	ENDDO
	XC1=XC(1)
	XC2=XC(2)
	XC4=XC(4)
	Q=XC(3)/(XC2-XC1)
	X41=XC4-XC1
	X24=XC2-XC4
      IF(XC1.GT.DB*.1) GOTO 3
      IF(X41.GT.0.D0.AND.X24.GT.0.D0) GOTO 4
	GOTO 3
4	A= Q*X41**2
	B=-Q*X24**2
	IF(NR.EQ.0) THEN
	  XC(5)=0.D0
	  GOTO 11
	ENDIF
      DO 1 I=1,NR
	CALL INTRING(XC,I,IP,IFL)
	IF(IFL.EQ..TRUE.) RETURN
1     RC(I) = ( DLOG10(IP) + EL(I) + XC(5) ) * WT(I)
11	CONTINUE
      DO 2 I=1,NS
	X=SD(I)
        IF(X.GT.XC1.AND.X.LT.XC2) GOTO 2
	GOTO 3
2     RC(I+NR) = ( F(X) - SE(I) +XC(6) ) * WT(I+NR)
        IFL=.FALSE.
        RETURN
3	IFL=.TRUE.
	CALL SXTPUT('IFL=.TRUE. FROM RESID',STAT)
	RETURN              
        END                                                                  
C  
C   
      SUBROUTINE LSQ(M,N,XC,RC,AJTJC,GC)    
C  CALCULATES THE JACOBIAN RC AT XC   
C  CALLED FROM E04GAF    
      DOUBLE PRECISION  XC,RC,AJTJC,GC,AJC,SUM,DELTA,DELTA2,XJ,YFIT
      DIMENSION XC(N),RC(M),GC(N),AJTJC(N,N),AJC(30,6),YFIT(30)     
      LOGICAL IFL
      PARAMETER (DELTA=.001D0)
      PARAMETER (DELTA2=.002D0)
C  NON ANALYTICAL DERIVATIVE
      DO 3 J=1,N
      XJ=XC(J)
      XC(J)=XJ+DELTA
      CALL RESID(M,N,XC,RC,IFL)
      DO 1 I=1,M
1     YFIT(I)=RC(I)
      XC(J)=XJ-DELTA
      CALL RESID(M,N,XC,RC,IFL)
      DO 2 I=1,M
2     AJC(I,J)=(YFIT(I)-RC(I))/DELTA2
3     XC(J)=XJ
      DO 80 I=1,N    
         SUM=0.    
         DO 20 K=1,M   
            SUM=SUM+AJC(K,I)*RC(K)     
20       CONTINUE     
         GC(I)=SUM      
         II=I    
         DO 60 J=1,II   
            SUM=0.  
            DO 40 K=1,M  
               SUM=SUM+AJC(K,I)*AJC(K,J)  
40          CONTINUE  
            AJTJC(J,I)=SUM  
60       CONTINUE  
80    CONTINUE     
      RETURN   
      END    
C     
C   
      SUBROUTINE MONIT(M,N,XC,RC,FC,GC,NCALL)     
C  CALLED BY E04GAF   
C  PRINTS THE VALUES EVERY PRINT ITERATIONS
	COMMON /DENS/ID(4096,9),MAXD,NR,WT(30),NS,DB,SM,A,B,XX,STEP
	DOUBLE PRECISION  XC,GC,RC,FC,DB,A,B                         
	DIMENSION XC(N),GC(N),RC(M),R(30),XX(9)
	CHARACTER*3   CALL,RIN,SPO
	CHARACTER*9   SSQ
	CHARACTER*72  CALIB,RESIDS
	WRITE(CALL,200) NCALL
200	FORMAT(I3)
	WRITE(SSQ,201) FC
201	FORMAT(E9.3)
	CALL SXTPUT('AFTER'//CALL//' CALLS OF RESID, THE SUM OF
     + SQUARES IS '//SSQ//' AT',STAT)
	CALL SXTPUT('   DF      DS      A       B       CM
     +      SM      RG      DI',STAT)
      DO 1 I=1,5
1     XX(I)=XC(I)
        XX(3)=A
        XX(4)=B
	XX(9)=XC(6)
C  scale intensities to sky units through adjusting XX(5)
	S=DB
	IF(S.LE.XX(1)) THEN
	  WRITE(6,*) ' SKYBGR < FOG!'
	  RETURN
	ENDIF
	S=A*ALOG10(S-XX(1))+B*ALOG10(XX(2)-S)+XX(5)
	XX(5)=XX(5)-S
C  sky magnitude/20 micron aperture
	IF(NR.NE.0) THEN
	  XX(6)=-2.5*(S - 2.*ALOG10(STEP/20.))
	 ELSE
	  XX(6)=SM
	ENDIF
	XX(7)=XC(3)
	XX(8)=XC(4)
	WRITE(CALIB,202) (XX(I),I=1,8)
202	FORMAT(9F8.3)
	CALL SXTPUT(CALIB,STAT)
	WRITE(RIN,200) NR
	WRITE(SPO,200) NS
	CALL SXTPUT('WITH RESIDUES OF'//RIN//' RINGS AND'
     +//SPO//' SPOTS',STAT)
      DO I=1,M
	R(I)=RC(I)/WT(I)
      ENDDO
	IF(NR.NE.0) THEN
	  WRITE(RESIDS,202) (R(I), I=1,NR)
	  CALL SXTPUT(RESIDS,STAT)
	ENDIF
	DO 20 I1=NR+1,37,9
	IF(M.LT.I1) GOTO 30
	I2=I1+8
	IF(M.LT.I2) I2=M
	WRITE(RESIDS,202) (R(I), I=I1,I2)
20	CALL SXTPUT(RESIDS,STAT)
30	CONTINUE
      RETURN
      END
C
C
	SUBROUTINE INTRING(X,IR,IP,IFL)
C  called from RESID
C  computes integrated intensities in rings
	COMMON /DENS/ID(4096,9),MAXD,NR,WT(30),NS,DB,SM,A,B
	DOUBLE PRECISION  X(6),A,B,DB,DF,DF1,DS,DS1,DK,DI,IP,IB,IT
	LOGICAL IFL
C
	IF(MAXD.EQ.4096) THEN
	  DI=0.00125D0
	ELSE
	  DI=0.005D0
	ENDIF
	DF=X(1)
	DS=X(2)
	DF1=DF+.01D0
	DS1=DS-.01D0
	IF(DB.GT.DF1.AND.DB.LT.DS1) GOTO 4
	GOTO 2
4       IB = (DB-DF)**A * (DS-DB)**B
	IP=0.
	DK=0.
      DO 1 I=1,MAXD
	II=ID(I,IR)
	IF(II.EQ.0) GOTO 1
	IF(DK.GT.DF1.AND.DK.LT.DS1) GOTO 3
	GOTO 2
3	IT = (DK-DF)**A * (DS-DK)**B
        IP = IP + (IT-IB)*FLOATJ(II)
1     DK=DK+DI
	IFL=.FALSE.
	IF(IP.GT.0.D0) RETURN
2	IFL=.TRUE.
	CALL SXTPUT('IFL=.TRUE. FROM INTRING',STAT)
	RETURN
	END
C
C
	SUBROUTINE INTEGR(NDIM,AA,STARTA,STEPA,NPIXA,CEN,RADA,NA)
C  called from DTOM
C  calculates distribution of densities in ring-shaped regions
	COMMON /DENS/ID(4096,9),MAXD
	REAL  AA(NDIM),STARTA(2),STEPA(2),CEN(2),RADA(9),RAD2(9)
	INTEGER   NPIXA(2),NUMR(9)
	DO J=1,NA
	  DO I=1,MAXD
	    ID(I,J)=0
	  ENDDO
	  NUMR(J)=0
	ENDDO
      DO I=1,NA
	RAD2(I)=RADA(I)**2
      ENDDO
C  put restrictions on max region to search
	X0=CEN(1)
	Y0=CEN(2)
	RAD=RADA(NA)
	X1=X0-RAD
	X2=X0+RAD
	Y1=Y0-RAD
	Y2=Y0+RAD
	S=1.
	J1=(Y1-STARTA(2))/STEPA(2) -S
	J2=(Y2-STARTA(2))/STEPA(2) +S +2.
	IF(J1.LT.1) J1=1
	IF(J2.GT.NPIXA(2)) J2=NPIXA(2)
	IF(J1.GE.J2) RETURN
	Y1=STARTA(2)+(J1-1)*STEPA(2)
	I1=(X1-STARTA(1))/STEPA(1) -S
	I2=(X2-STARTA(1))/STEPA(1) +S +2.
	IF(I1.LT.1) I1 = 1
	IF(I2.GT.NPIXA(1)) I2 = NPIXA(1)
	IF(I1.GE.I2) RETURN
	X1=STARTA(1)+(I1-1)*STEPA(1)
	Y=Y1
	DO 3 J = J1,J2
	LOC=(J-1)*NPIXA(1)+I1
	YY=(Y-Y0)**2
	X=X1
	DO 2 I = I1,I2
	D2=(X-X0)**2 + YY
	DO 4 IR=1,NA
	IF(D2.GT.RAD2(IR)) GOTO 4
	IL=JIFIX(AA(LOC)+1.)
	IL=JMIN0(IL,MAXD)
C  form distribution of densities in ringshaped regions
	ID(IL,IR)=ID(IL,IR)+1
	NUMR(IR)=NUMR(IR)+1
	GOTO 1
4	CONTINUE
1	LOC=LOC+1
2	X=X+STEPA(1)
3	Y=Y+STEPA(2)
C  refine radii considering actual no of pixels
	IF(NA.GT.1) THEN
	  DO I=NA,2,-1
	    DO J=1,I-1
		NUMR(I)=NUMR(I)+NUMR(J)
	    ENDDO
	  ENDDO
	ENDIF
	DO I=1,NA
	  RADA(I)=SQRT(NUMR(I)/3.141592)*STEPA(1)
	ENDDO
	RETURN
	END
C
	SUBROUTINE POLY ( T,C,LOGA,MEL,SEL,NA )
C  compute magnitudes MEL and mean surface brightess SEL
C
	CHARACTER*1  T
	REAL	     C(1),MEL(NA),SEL(NA),LOGA(9)
	DO I=1,NA
	  X=LOGA(I)
	  IF(T.EQ.'B') THEN
	    IF(C(18).EQ.0.) THEN
		C(14)=-0.3456+C(20)*2.2502
		C(15)=-0.0344+C(21)*2.1358
		C(16)= 0.0451+C(22)*2.1070
		C(17)=-0.0143+C(23)*2.0661
	    ENDIF
	    MEL(I)=C(2)+C(14) + X*(C(3)+C(15) + X*(C(4)+C(16) +
     +		   X*(C(5)+C(17))))
	   ELSE IF(T.EQ.'R') THEN
	    IF(C(24).EQ.0.) THEN
		C(20)= 0.1536+C(14)*0.4444
		C(21)= 0.0161+C(15)*0.4682
		C(22)=-0.0214+C(16)*0.4746
		C(23)= 0.0069+C(17)*0.4840
	    ENDIF
	    MEL(I)=C(2)-C(20) + X*(C(3)-C(21) + X*(C(4)-C(22) +
     +		   X*(C(5)-C(23))))
	   ELSE IF(T.EQ.'U') THEN
	    MEL(I)=C(2)+C(8)+C(14)+X*(C(3)+C(9)+C(15)+
     +             X*(C(4)+C(10)+C(16)+X*(C(5)+C(11)+C(17))))
	   ELSE IF(T.EQ.'V') THEN
	    MEL(I)=C(2)+X*(C(3)+X*(C(4)+X*C(5)))
	   ELSE
	    CALL SXTPUT(' LEADING CHAR MUST BE U, B, V or R !',STAT)
	    RETURN
	  ENDIF
	  IF(I.NE.1.AND.MEL(I).LT.MEL(I1)) THEN
	    SEL(I)= MEL(I) +5.*X -0.262
     +		   -2.5*ALOG10(1.-10.**(-.4*(MEL(I1)-MEL(I))))
     +		   +2.5*ALOG10(1.-10.**(2.*(X1-X)))
	   ELSE
	    SEL(I)=MEL(I) +5.*X -0.262
	  ENDIF
	  I1=I
	  X1=X
	ENDDO
	END

C  @(#)avwndw.for	19.1 (ESO-DMD) 02/25/03 14:01:40 
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM AVWNDW
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  program AVWNDW			version 1.00	890123
C  K. Banse                  		ESO - Garching
C  1.20	      890529	1.30	900130
C
C.KEYWORDS
C  bulk data frames, average
C
C.PURPOSE
C  average a no. of image frames, take only values which don't differ too much
C  from the median value (at each pixel), the result will either be a frame with
C  size equal to common area of all frames involved or size equal to union of
C  all frame areas
C
C.ALGORITHM
C  extract input frames either from given parameter string or from catalogue,
C  add up all frames + divide in the end
C  max. 20 frames may be averaged at one time !
C
C.INPUT/OUTPUT
C  the following keys are used:
C
C  ACTION/C/1/3			= WIN, MED, MIN or MAX
C  OUT_A/C/1/60			result frame
C  P3/C/1/80			list of frames to be averaged
C  INPUTR/R/1/2			BGERR,SNOISE - Poisson + Gaussian errors
C				for WINDOW option
C
C  the following descriptors are used with WINDOW option:
C  LHCUTS/R/5/2			low, high cuts for calculations
C  FLAT_BKG/R/1/1		background value
C  O_TIME/D/7/1			exposure time
C	
C.VERSIONS
C 
C 010802		last modif
C	
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER     BEGIN,FRMCNT,IAV,ISEQ
      INTEGER     L,LL,LP,M,IOFF
      INTEGER     N,NAXIS,NAXISC,NCHECK,NIN,NP,NPERC,NTL
      INTEGER*8   PNTRC,PNTRT
      INTEGER     SIZEC,STAT
      INTEGER     IMNOC,IMN(20)
      INTEGER     NPIX(3),NPIXC(3)
      INTEGER     OFX(20),OFY(20),POFF(20),NPNTS(20)
      INTEGER     IORD(20),NORD(20),REJ(20),TNP(4)
      INTEGER     EC,EL,ED
      INTEGER     UNI(1),NULO,MADRID(1)
      INTEGER     LEN,INDEX            !system functions
C
      CHARACTER   FRAME(20)*60,FRAMEC*60,CATFIL*60
      CHARACTER   CUNIT*64,IDENT*72,OUTPUT*80
      CHARACTER   NOCUTS*60,LINE*80,ACTION*3
      CHARACTER   ERROR1*60,ERROR2*50,ERROR3*40,ERROR4*40,ERROR6*40
      CHARACTER   ERROR7*40,ERROR9*60
C
      DOUBLE PRECISION STEP(2,20),STEPC(2)
      DOUBLE PRECISION START(2,20),STARTC(2),OSTART(2),OEND(2)
C
      REAL        EPS(3),CUTS(4)
      REAL        VAL(20),BGV(20),RMS(20),RFC(20)
      REAL        AJCUL(20),AJCUH(20),AJCU(2),SNOISE,BGERR
      REAL        INPUTR(2),EXPTI(20)
C
      DOUBLE PRECISION      EXPTIM
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      COMMON   /VMR/     MADRID
      COMMON   /MYREAL/  VAL,BGV,RMS,RFC,AJCUL,AJCUH,SNOISE,BGERR,EXPTI
      COMMON   /MYINT/   IORD,NORD,REJ,TNP
C
      DATA    IDENT    /'average frame '/
      DATA    ERROR1   /'operands do not match in stepsize... '/
      DATA    ERROR2   /'operands do not overlap...'/
      DATA    ERROR3   /'stepsizes of different sign...'/
      DATA    ERROR4   /'catalogue empty...'/
      DATA    ERROR6   /'no. of input frames < 2 ...'/
      DATA    ERROR7   /'more than 20 entries in catalogue...'/
      DATA    ERROR9   /'no. of axes do not match... '/
      DATA    NOCUTS   /'LHCUTS(5,6) not there - use LHCUTS(3,4)... '/
      DATA    STARTC   /2*0.D0/,    STEPC  /2*1.D0/
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C  set up MIDAS environment + enable automatic error abort
      CALL STSPRO('AVWNDW')
C 
C  init COMMON variables
      DO 50 N=1,20
         REJ(N) = 0
50    CONTINUE
      DO 60 N=1,4
         TNP(N) = 0
60    CONTINUE
C
C  get necessary keys
      CALL STKRDC('ACTION',1,1,3,IAV,ACTION,UNI,NULO,STAT)    !get option
      CALL STKRDC('OUT_A',1,1,60,IAV,FRAMEC,UNI,NULO,STAT)    !get result frame
      CALL STKRDC('P3',1,1,80,IAV,LINE,UNI,NULO,STAT)         !list of frames
      CALL UPCAS(ACTION,ACTION)
      IF (ACTION(1:1).EQ.'W') THEN                        !only for real window option
         CALL STKRDR('INPUTR',1,2,IAV,INPUTR,UNI,NULO,STAT)
         BGERR = INPUTR(1) * INPUTR(1)                   !take square of errors
         SNOISE = INPUTR(2) * INPUTR(2)
      ENDIF
C
C  test, if we have list of frames or catalogue
      LL = INDEX(LINE,'.cat')
      IF (LL.LE.0) THEN
         LL = INDEX(LINE,'.CAT')
         IF (LL.LE.0) GOTO 500                     !No. Treat list input
      ENDIF
C
C  here we handle input from a catalog
C  get name of first image file in catalog
C
      ISEQ = 0
      CATFIL(1:) = LINE(1:)
      CALL STCGET(CATFIL,0,FRAME(1),OUTPUT,ISEQ,STAT)
      IF (FRAME(1)(1:1).EQ.' ')                 !there must be at least 1 image
     +   CALL STETER(4,ERROR4)
C
C  now loop through catalogue
      DO 200 N=2,20                                !max. 20 frames
         CALL STCGET(CATFIL,0,FRAME(N),OUTPUT,ISEQ,STAT)
         IF (FRAME(N)(1:1).EQ.' ') THEN            !indicates the end ...
            FRMCNT = N - 1
            GOTO 1000
         ENDIF
200   CONTINUE
C
      CALL STCGET(CATFIL,0,LINE,OUTPUT,ISEQ,STAT)
      IF (LINE(1:1).NE.' ')
     +   CALL STTPUT
     +   ('Max. 20 frames are used, following frames ignored...',STAT)
      FRMCNT = 20
      GOTO 1000
C
C  here we handle input from single inout line
C  pull out operands      (max. 20)
C
500   BEGIN = 1
      DO 800 N=1,21                             !max. of 20 frames...!
         CALL EXTRSS(LINE,',',BEGIN,FRAME(N),LL)
         IF (LL.LE.0) THEN
            FRMCNT = N - 1
            GOTO 1000
         ELSE
            CALL CLNFRA(FRAME(N),FRAME(N),0)
         ENDIF
800   CONTINUE
C
C  check no. of input frames
1000  IF (FRMCNT.LT.2) CALL STETER(6,ERROR6)
C
      DO 1200 N=1,FRMCNT
         DO 1100 M=1,2                        !init values...
            START(M,N) = 0.D0
            STEP(M,N) = 1.D0
            NPIX(M) = 1
1100     CONTINUE
1200  CONTINUE
C
C  get initial area from 1. frame
      DO 1400 M=1,2                  !init values...
         OSTART(M) = 0.D0
         OEND(M) = 0.D0
         NPIX(M) = 1
1400  CONTINUE
C
      CALL STFOPN(FRAME(1),D_R4_FORMAT,0,F_IMA_TYPE,IMN(1),STAT)
      CALL STDRDI(IMN(1),'NAXIS',1,1,IAV,NAXISC,UNI,NULO,STAT)
      IF (NAXISC.GT.2) THEN                !we only work on max 2-dim. frames
         NAXISC = 2
         OUTPUT(1:) = 'currently only 1 or 2-dim frames supported... '
         CALL STTPUT(OUTPUT,STAT)
      ENDIF
C
      CALL STDRDI(IMN(1),'NPIX',1,2,IAV,NPIX,UNI,NULO,STAT)
      NPNTS(1) = NPIX(1)
      CALL STDRDD(IMN(1),'START',1,2,IAV,START(1,1),UNI,NULO,STAT)
      OSTART(1) = START(1,1)
      OSTART(2) = START(2,1)
      CALL STDRDD(IMN(1),'STEP',1,2,IAV,STEP(1,1),UNI,NULO,STAT)
      STEPC(1) = STEP(1,1)
      STEPC(2) = STEP(2,1)
      CALL STDRDC(IMN(1),'CUNIT',1,1,64,IAV,CUNIT,UNI,NULO,STAT)
C
C  for "real" window option get exposure-time, low + high cuts and background
      IF (ACTION(1:1).EQ.'W') THEN
         CALL STECNT('GET',EC,EL,ED)            !disable error abort
         CALL STECNT('PUT',1,0,0)
C
         CALL STDRDD(IMN(1),'O_TIME',7,1,IAV,EXPTIM,UNI,NULO,STAT)
         IF (STAT.NE.0) THEN
            EXPTI(1) = 1.0                      !default to 1 second
         ELSE
            EXPTI(1) = EXPTIM
         ENDIF
C
C  get LHCUTS(5,6) - if not there use LHCUTS(3,4)
         CALL STDRDR(IMN(1),'LHCUTS',5,2,IAV,AJCU,UNI,NULO,STAT)
         IF (STAT.NE.0) THEN
            CALL STTPUT(NOCUTS,STAT)
            CALL STDRDR(IMN(1),'LHCUTS',3,2,IAV,AJCU,UNI,NULO,STAT)
         ENDIF
         IF (AJCU(2).LE.AJCU(1))
     +      CALL STETER(43,'invalid LHCUTS: LHCUTS(6).LE.LHCUTS(5)...')
         AJCUL(1) = AJCU(1)
         AJCUH(1) = AJCU(2)
C
         CALL STDRDR(IMN(1),'FLAT_BKG',1,1,IAV,BGV(1),UNI,NULO,STAT)
         IF (STAT.NE.0) BGV(1) = 0.             !default to background = 0.
         CALL STECNT('PUT',EC,EL,ED)
      ENDIF
C
      DO 2000 M=1,2
         EPS(M) = 0.0001 * ABS(STEPC(M))        !0.01% of stepsize as epsilon
         OEND(M) = OSTART(M) + (NPIX(M)-1)*STEPC(M)
2000  CONTINUE
C
C  now loop through the other input frames
      DO 3000 N=2,FRMCNT
         CALL STFOPN(FRAME(N),D_R4_FORMAT,0,F_IMA_TYPE,IMN(N),STAT)
C
         CALL STDRDI(IMN(N),'NAXIS',1,1,IAV,NAXIS,UNI,NULO,STAT)
         IF (NAXISC.NE.NAXIS) CALL STETER(1,ERROR9)
C
         CALL STDRDI(IMN(N),'NPIX',1,2,IAV,NPIX,UNI,NULO,STAT)
         NPNTS(N) = NPIX(1)
         CALL STDRDD(IMN(N),'START',1,2,IAV,START(1,N),UNI,NULO,STAT)
         CALL STDRDD(IMN(N),'STEP',1,2,IAV,STEP(1,N),UNI,NULO,STAT)
C
         IF (ACTION(1:1).EQ.'W') THEN
            CALL STECNT('GET',EC,EL,ED)            !disable error abort
            CALL STECNT('PUT',1,0,0)
C
            CALL STDRDD(IMN(N),'O_TIME',7,1,IAV,EXPTIM,UNI,NULO,STAT)
            IF (STAT.NE.0) THEN
               EXPTI(N) = 1.0                      !default to 1 second
            ELSE
               EXPTI(N) = EXPTIM
            ENDIF
C
            CALL STDRDR(IMN(N),'LHCUTS',5,2,IAV,AJCU,UNI,NULO,STAT)
            IF (STAT.NE.0)
     +         CALL STDRDR(IMN(N),'LHCUTS',3,2,IAV,AJCU,UNI,NULO,STAT)
            AJCUL(N) = AJCU(1)
            AJCUH(N) = AJCU(2)
C
            CALL STDRDR(IMN(N),'FLAT_BKG',1,1,IAV,BGV(N),UNI,NULO,STAT)
            IF (STAT.NE.0) BGV(N) = 0.            !default to background = 0.
            CALL STECNT('PUT',EC,EL,ED)
         ENDIF
C
C  create new result frame with dimension as intersection of input frames
C  stepsizes should have same sign and not differ too much...
         DO 2400 M=1,NAXISC
            IF (STEPC(M)*STEP(M,N).LE.0.) CALL STETER(1,ERROR3)
            IF (ABS(STEP(M,N)-STEPC(M)).GT.EPS(M))
     +         CALL STTPUT(ERROR1,STAT)                 !just warning message
2400     CONTINUE
C
C  get intersection of image areas
         DO 2600 M=1,NAXISC
            IF (STEPC(M).GT.0.) THEN
               OSTART(M) = MAX(OSTART(M),START(M,N))
               OEND(M) = MIN(OEND(M),START(M,N) + (NPIX(M)-1)*STEP(M,N))
            ELSE
               OSTART(M) = MIN(OSTART(M),START(M,N))
               OEND(M) = MAX(OEND(M),START(M,N) + (NPIX(M)-1)*STEP(M,N))
            ENDIF
2600     CONTINUE
C
C  compute individual offsets
         DO 2800 NIN=1,N
            OFX(NIN) = NINT((OSTART(1)-START(1,NIN))/STEP(1,NIN)) + 1
            OFY(NIN) = NINT((OSTART(2)-START(2,NIN))/STEP(2,NIN)) + 1
2800     CONTINUE
C
3000  CONTINUE
C
C  test, if something is left...
C
      DO 3300 M=1,NAXISC
         IF (STEPC(M)*(OEND(M)-OSTART(M)).LT.0.) CALL STETER(2,ERROR2)
3300  CONTINUE
C
C  set up standard stuff for result frame
      SIZEC = 1
      NPIXC(2) = 1
      DO 3600 M=1,NAXISC
         STARTC(M) = OSTART(M)
         NPIXC(M) = NINT((OEND(M)-OSTART(M))/STEPC(M)) + 1
         SIZEC = SIZEC * NPIXC(M)
3600  CONTINUE
      LP = NPIXC(2)
      NP = NPIXC(1)
C
C  map result frame
      CALL STIPUT(FRAMEC,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +            NAXISC,NPIXC,STARTC,STEPC,
     +            IDENT,CUNIT,PNTRC,IMNOC,STAT)
C
C  initialize some working variables
      DO 3900 N=1,FRMCNT
         IF (ACTION(1:1).EQ.'W') RFC(N) = 1./EXPTI(N)
         POFF(N) = (OFY(N)-1)*NPNTS(N) + OFX(N)      !determine 1.pixel no.
3900  CONTINUE
C
C  and allocate working space
      NTL = NP * FRMCNT
      IF (NTL.LT.512) NTL = 512
      CALL STFXMP(NTL,D_R4_FORMAT,PNTRT,STAT)
C
C  set up counters for calculation of progress
      NTL = INT(FLOAT(LP)*.2)                  !20% of total no. of lines
      IF (NTL.LE.2) THEN
         NCHECK = LP + 1                       !not worth it...
      ELSE
         NPERC = 20
         NCHECK = NTL
      ENDIF
C
C  now, loop through lines
      DO 5000 L=1,LP
C
C  and loop through frames
         IOFF = 1
         DO 4200 N=1,FRMCNT
            CALL COPULA(IOFF,IMN(N),POFF(N),MADRID(PNTRT),NP)
            POFF(N) = POFF(N) + NPNTS(N)                  !move to next line
            IOFF = IOFF + NP
4200     CONTINUE
C
C  and do it ...
         IF (ACTION(1:1).EQ.'W') THEN
            CALL AVWIN1(MADRID(PNTRT),FRMCNT,NP)
         ELSE
            CALL AVWIN2(ACTION,MADRID(PNTRT),FRMCNT,NP)
         ENDIF
         CALL COPUL(MADRID(PNTRT),MADRID(PNTRC),L,NP)    !save resulting line
C
C  display progress
         IF (L.GE.NCHECK) CALL PROGRS(20,NTL,NPERC,NCHECK)
5000  CONTINUE
C
C  display more info
      IF (ACTION(1:1).EQ.'W') THEN
         DO 5500 N=1,FRMCNT
            WRITE(OUTPUT,10000) AJCUL(N),AJCUH(N)
            L = INDEX(FRAME(N),' ') - 1
            IF (L.LE.0) L = LEN(FRAME(N))
            LINE(1:) = FRAME(N)(1:L)//OUTPUT(1:)
            CALL STTPUT(LINE,STAT)
            WRITE(OUTPUT,10001) EXPTI(N),BGV(N),REJ(N)
            CALL STTPUT(OUTPUT,STAT)
5500     CONTINUE
         WRITE(OUTPUT,10002) TNP(1),TNP(2),TNP(3),TNP(4)
         CALL STTPUT(OUTPUT,STAT)
      ENDIF
C
C  copy descriptors + calculate new dynamic range of result frame
      CALL DSCUPT(IMN(1),IMNOC,' ',STAT)
      CALL MYMX(MADRID(PNTRC),SIZEC,CUTS(3))
      CUTS(1) = CUTS(3)
      CUTS(2) = CUTS(4)
      CALL STDWRR(IMNOC,'LHCUTS',CUTS,1,4,UNI,STAT)
C
      CALL STSEPI
C
C  Formats
10000 FORMAT(' low and high cuts',G12.5,' ,',G12.5)
10001 FORMAT('         EXPTIM',G12.5,', BGV',G12.5,', rej_pix',I8)
10002 FORMAT('pixels with N=0:',I8,', N=1:',I8,', N=2:',I8,', N>2:',I8)
      END

      SUBROUTINE COPULA(IOFF,IMNO,OFFSET,A,NP)
C
      IMPLICIT NONE
C
      INTEGER     IOFF,IMNO,OFFSET,NP
      INTEGER     IAV,STAT
C
      REAL        A(1)
C
      CALL STFGET(IMNO,OFFSET,NP,IAV,A(IOFF),STAT)
      RETURN
      END

      SUBROUTINE COPUL(A,B,NLINE,NP)
C
      IMPLICIT NONE
C
      INTEGER     IOFF,N,NLINE,NP
C
      REAL        A(1),B(1)
C
      IOFF = (NLINE-1) * NP
      DO 800 N=1,NP
         B(N+IOFF) = A(N)
800   CONTINUE
C
      RETURN
      END

      SUBROUTINE AVWIN1(T,TOTAL,NP)
C
      IMPLICIT NONE
C
      REAL        T(1)
      REAL        V,VM,ER,ERR,WG,AM,ALP,F
      REAL        VAL(20),BGV(20),RMS(20),RFC(20)
      REAL        AJCUL(20),AJCUH(20),SNOISE,BGERR
      REAL        EXPTI(20)
      REAL        SQRT                        !system function
C
      LOGICAL     NOK(20)
C
      INTEGER     TOTAL,NP
      INTEGER     IORD(20),NORD(20),REJ(20),TNP(4)
      INTEGER     I,IDX,II,IM1,IO
      INTEGER     N1,N2,NH,NN,NX
      INTEGER     TNP1,TNP2,TNP3,TNP4
C
      COMMON  /MYREAL/  VAL,BGV,RMS,RFC,AJCUL,AJCUH,SNOISE,BGERR,EXPTI
      COMMON  /MYINT/   IORD,NORD,REJ,TNP
C
      EQUIVALENCE    (NORD(1),N1),(NORD(2),N2)
      EQUIVALENCE    (TNP(1),TNP1),(TNP(2),TNP2),
     +               (TNP(3),TNP3),(TNP(4),TNP4)
C
      ALP = 0.
C
C  loop through pixels in each line
      DO 5000 NX=1,NP
         NN = 0                          !init no. of valid pixels
         IDX = NX                        !init offset in working area
C
         DO 400 I=1,TOTAL
            V = T(IDX)
            NOK(I) = V.LT.AJCUL(I) .OR. V.GT.AJCUH(I)      !set NOK, if outside
C
            IF (.NOT.NOK(I)) THEN
               V = V - BGV(I)
               VAL(I) = RFC(I) * V       !fill value stack
             NN = NN + 1                 !increment no. of valid pixels
             IF (V.LT.0.) THEN
                F = 0.
             ELSE
                F = SNOISE * V
             ENDIF
             RMS(I) = RFC(I) * SQRT(BGERR + F)      !estimate deviation
            ENDIF
C
            IDX = IDX + NP                          !increase offset
400      CONTINUE
C
C  order pixel values + find median
         IF (NN.GE.3) THEN
            GOTO 2000                       !more than 2 pixels o.k.
         ELSE
            GOTO (1400,1410,1450),NN+1      !branch acc. to no. of good pixels
         ENDIF
C
C  no good pixels, take 1. frame
1400     NOK(1) = .FALSE.
         TNP1 = TNP1 + 1
         GOTO 3900
C
C  only one good pixel, take it
1410     TNP2 = TNP2 + 1
         GOTO 3900
C
C  two good pixels, test them
1450     II = 1
         DO 1600 I=1,TOTAL
            IF (.NOT.NOK(I)) THEN
               NORD(II) = I
               II = II + 1
            ENDIF
1600     CONTINUE
C
         IF (ABS(VAL(N1)-VAL(N2)).LE.RMS(N1)+RMS(N2)) THEN
            TNP3 = TNP3 + 1
         ELSE
            TNP2 = TNP2 + 1
            IF (ABS(VAL(N1)-ALP).LE.ABS(VAL(N2)-ALP)) THEN
               NOK(N2) = .TRUE.
            ELSE
               NOK(N1) = .TRUE.
            ENDIF
         ENDIF
         GOTO 3900
C
C  more than 2 pixels, compare them
2000     DO 2500 I=1,TOTAL
            IF (.NOT.NOK(I)) THEN
               V = VAL(I)
               IO = 0
               IF (I.EQ.1) GOTO 2400
               IM1 = I - 1
               DO 2200 II=1,IM1
                  IF (.NOT.NOK(II)) THEN
                     IF (V.GT.VAL(II)) THEN
                        IO = IO + 1
                     ELSE
                        IORD(II) = IORD(II) + 1
                     ENDIF
                  ENDIF
2200           CONTINUE
2400           IORD(I) = IO
            ENDIF
2500     CONTINUE
C
C  update NORD
         DO 2600 I=1,TOTAL
            IF (.NOT.NOK(I)) THEN
               II = IORD(I) + 1
               NORD(II) = I
            ENDIF
2600     CONTINUE
C
C  and get median
         NH = (NN+1) / 2
         IM1 = NH - 1
         I = NORD(NH)
         VM = VAL(I)
         ER = RMS(I)
         NH = NN
C
C  now remove all pixels with high residuals (not close to median...)
         DO 3000 I=1,IM1
            II = NORD(I)                                !start at bottom...
            ERR = RMS(II) + ER
            IF (ABS(VAL(II)-VM).GT.ERR) THEN    !discard, if value differs much
               NN = NN - 1
               NOK(II) = .TRUE.
            ENDIF
            II = NORD(NH)                               !and move to top...
            NH = NH - 1
            ERR = RMS(II) + ER
            IF (ABS(VAL(II)-VM).GT.ERR) THEN
               NN = NN - 1
               NOK(II) = .TRUE.
            ENDIF
3000     CONTINUE
C
         NN = MIN(4,NN+1)
         TNP(NN) = TNP(NN) + 1
C
C  calculate final flux
3900     WG = 0.
         AM = 0.
         DO 4000 I=1,TOTAL
            IF (.NOT.NOK(I)) THEN
               WG = WG + EXPTI(I)
               AM = AM + EXPTI(I)*VAL(I)
            ELSE
               REJ(I) = REJ(I) + 1
            ENDIF
4000     CONTINUE
         ALP = AM / WG
         T(NX) = ALP
C
5000  CONTINUE                               !end of loop through pixels
      RETURN
      END

      SUBROUTINE AVWIN2(ACTION,T,TOTAL,NP)
C
      IMPLICIT NONE
C
      REAL        T(1)
      REAL        VAL(20),V,O(11),RVAL
      REAL        VVAL(122)                         !just to pad the COMMON ...
C
      INTEGER     TOTAL,NP
      INTEGER     I,IDX,NN
      INTEGER     NH,NX,NH1
C
      CHARACTER   ACTION*3
C
      COMMON   /MYREAL/  VAL,VVAL
C
C ***
C
C  handle maximum search
C
C ***
C
      IF (ACTION(1:2).EQ.'MA') THEN
C
C  loop through pixels in each line
         DO 800 NX=1,NP
C
            IDX = NX                           !init offset in working area
            DO 200 I=1,TOTAL
               VAL(I) = T(IDX)
               IDX = IDX + NP                  !increase offset
200         CONTINUE
C
            V = VAL(1)
            DO 400 I=2,TOTAL
               IF (V.LT.VAL(I)) V = VAL(I)
400         CONTINUE
            T(NX) = V
800      CONTINUE
C
C ***
C
C  handle minimum search
C
C ***
C
      ELSE IF (ACTION(1:2).EQ.'MI') THEN
C
C  loop through pixels in each line
         DO 1800 NX=1,NP
C
            IDX = NX                           !init offset in working area
            DO 1200 I=1,TOTAL
               VAL(I) = T(IDX)
               IDX = IDX + NP                  !increase offset
1200        CONTINUE
C
            V = VAL(1)
            DO 1400 I=2,TOTAL
               IF (V.GT.VAL(I)) V = VAL(I)
1400        CONTINUE
            T(NX) = V
1800     CONTINUE
C
C ***
C
C  handle median search
C
C ***
C
      ELSE
C
C  loop through pixels in each line
         NH = (TOTAL+1) / 2
         NH1 = NH + 1
         DO 5000 NX=1,NP
C
            IDX = NX                           !init offset in working area
            DO 2200 I=1,TOTAL
               VAL(I) = T(IDX)
               IDX = IDX + NP                  !increase offset
2200        CONTINUE
C
C  order pixel values
            O(1) = VAL(1)
C
C  build up lower half of ordered array (including median index)
            DO 3600 I=2,NH
               NN = I
               RVAL = VAL(NN)
C
3100           IF ((NN.LE.1) .OR. (O(NN-1).LE.RVAL) ) GOTO 3200
               O(NN) = O(NN-1)
               NN = NN - 1
               GOTO 3100
C
3200           O(NN) = RVAL
3600        CONTINUE
C
C  now only merge upper half of array VAL into ordered array O if necessary
            DO 4000 I=NH1,TOTAL
               RVAL = VAL(I)
               NN = NH
               IF (RVAL.GE.O(NN)) GOTO 4000
C
3700           IF ( (NN.LE.1) .OR. (O(NN-1).LE.RVAL) ) GOTO 3800
               O(NN) = O(NN-1)
               NN = NN - 1
               GOTO 3700
C
3800           O(NN) = RVAL
4000        CONTINUE
C
            T(NX) = O(NH)
5000  CONTINUE
      ENDIF
C
      RETURN
      END

C @(#)cmdsif.for	19.1 (ES0-DMD) 02/25/03 13:27:32
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C-----------------------------------------------------------------------
C
C.IDENTIFICATION
C
C  Program CMDSIF
C
C.AUTHOR
C
C  F. Murtagh, ST-ECF, Garching.             Version 1.0  17 June 1986
C  F. Murtagh                                Version 2.0  Oct. 1988
C                                            (New std. ifs.)
C
C.PURPOSE
C
C  Pass parameters to, and execute, CMDS
C  (Classical - Torgerson's, Gower's - Multidimensional Scaling,
C  Factor Analysis of a Distances Matrix, Principal Coordinates Analysis).
C
C.INPUT/OUTPUT
C
C  P1 - P3 contain parameters; these are: input table name, output
C  table name, number of principal coordinates wanted (optional, - default
C  = 3).
C
C.ALGORITHM
C
C . uses Midas Table interface routines;
C . input table is assumed to contain entries in single precision;
C . no select or null values 
C . all input table is sent to the CMDS routine;
C . description of the CMDS routine is in the corresponding program;
C . the output produced consists of a table, and descriptors associated
C   with this (eigenvalues): view with
C   READ/DESC outtable.TBL *
C . storage is limited only by the Midas Table system, and by the
C   overall system limitations;
C
C.MODIFICATIONS
C   NEW STANDARD INTERFACES, F. MURTAGH, AUG. 88
C   New Table File System,   M. Peron , SEP91
C
C-----------------------------------------------------------------------
        PROGRAM CMDSIF
C
        CHARACTER*60     NAMEIN, NAMEOUT
        CHARACTER*6     FORM 
        CHARACTER*16    UNIT, LABEL, LABEL2
        INTEGER         MADRID, KUN, KNUL, DTYPE
        INTEGER         NACTV,ISTAT,TID1,NROW,NCOL,NSORTC
        INTEGER         NAC,NAR,IPTR,I,LEN,NSEL,NTOT,INULL
        INTEGER         IACTV,NCOLOUT,TID,IPTROUT
        INTEGER         IADD0,IADD1,IADD2,IADD3,KUNIT
        INCLUDE         'MID_INCLUDE:TABLES.INC/NOLIST'
        COMMON          /VMR/MADRID(1)
        INCLUDE         'MID_INCLUDE:TABLED.INC/NOLIST'
        DATA            FORM/'G14.6'/, UNIT/' '/
C
C ...   Assuming this is our first action ...
C
        CALL STSPRO('CMDSIF')
        DTYPE = D_R4_FORMAT
C
C ...   Get table name as a keyword passed in the command line.
C
        CALL STKRDC('P1',1,1,60,NACTV,NAMEIN,KUN,KNUL,ISTAT)
C
C ...   Read input table.
C
        CALL TBTOPN(NAMEIN,0,TID1,ISTAT)
        CALL TBIGET(TID1,NCOL,NROW,NSORTC,NAC,NAR,ISTAT)
        CALL TBCMAP(TID1,0,IPTR,ISTAT)
C
C ...   Some error checking on input.
C
        IF (NROW.LT.1.OR.NCOL.LT.1) THEN
           CALL STTPUT(' Nos. of rows/columns are less than 1.',ISTAT)
           CALL STTPUT(' What sort of a table is this ??',ISTAT)
           STOP
        ENDIF
C
        DO I = 1, NCOL
           CALL TBFGET(TID1,I,FORM,LEN,DTYPE,ISTAT)
           IF (DTYPE.NE.D_R4_FORMAT) THEN
              CALL STTPUT(' Illegal format:',ISTAT)
              CALL STTPUT(' Only R*4 column type allowed.',ISTAT)
              STOP
           ENDIF
        ENDDO
C
        CALL CHSEL(MADRID(IPTR),NROW,NSEL)
        IF (NSEL.NE.NROW) THEN
           CALL STTPUT(' Not all rows are SELECTed. ',ISTAT)
           CALL STTPUT(' In current implementation, MUST select all.',
     X                                                     ISTAT)
           STOP
        ENDIF
C
        CALL TBCMAP(TID1,1,IPTR,ISTAT)
        NTOT = NROW*NCOL
        CALL CHNULL(MADRID(IPTR),NTOT,INULL)
        IF (INULL.NE.0) THEN
           CALL STTPUT
     X     (' Null entries in the table are not allowed.',ISTAT)
           CALL STTPUT
     X     (' Use SELECT, and then construct another table.',
     X                                                    ISTAT)
           STOP
        ENDIF
C
C ...   OUTPUT TABLE - PREPARE
C
C ...   First get the output table name and no. cols. via keywords.
C
        CALL STKRDC('P2',1,1,60,IACTV,NAMEOUT,KUN,KNUL,ISTAT)
        CALL STKRDI('INPUTI',1,1,IACTV,NCOLOUT,KUN,KNUL,ISTAT)
C
C ...   Now create the table.
C
        CALL TBTINI(NAMEOUT,F_TRANS,17,NCOLOUT,NROW,TID,ISTAT)
        LABEL = 'NEW00'
        LABEL2 = '10001'
        DO I = 1, NCOLOUT
           WRITE (LABEL2(1:5),100) I+10000
           LABEL(4:5) = LABEL2(4:5)
           CALL TBCINI(TID,DTYPE,1,FORM,UNIT,LABEL,NSORTC,ISTAT)
        ENDDO
  100   FORMAT(I5)
C
        CALL TBCMAP(TID,1,IPTROUT,ISTAT)
C
C ...   ALLOCATE STORAGE
C
        CALL GETSTOR(NROW*NROW,IADD0)
        CALL GETSTOR(NROW*NROW,IADD1)
        CALL GETSTOR(NROW,IADD2)
        CALL GETSTOR(NROW,IADD3)
C
C ...   DO THE WORK
C
        CALL APPL(NROW,NCOL,NCOLOUT,MADRID(IPTR),MADRID(IPTROUT),
     X  MADRID(IADD0),MADRID(IADD1),MADRID(IADD2),MADRID(IADD3))
C
C ...   WRITE DESCRIPTORS
C
        CALL DSCROUT(NAMEOUT,NROW,MADRID(IADD2),TID,KUNIT)
C
C ...   FINISH UP
C
C
        CALL RELSTOR(NROW*NROW,IADD0)
        CALL RELSTOR(NROW*NROW,IADD1)
        CALL RELSTOR(NROW,IADD2)
        CALL RELSTOR(NROW,IADD3)
C
        CALL TBTCLO(TID1,ISTAT)
C
        CALL TBIPUT(TID,NCOLOUT,NROW,ISTAT)
        CALL TBSINI(TID,ISTAT)
        CALL TBTCLO(TID,ISTAT)
C
        CALL STSEPI
C
        END
C----------------------------------------------------------------------
        SUBROUTINE APPL(NR,NC1,NC2,AIN,AOUT,ACREA,A,W1,W2)
        INTEGER NR,NC1,NC2,IERR,IPRINT,I,J,ISTAT
        REAL*4  AIN(NR,NC1), AOUT(NR,NC2), ACREA(NR,NR),A(NR,NR),
     X                  W1(NR),W2(NR)
        IERR = 0
        IPRINT = 1
        DO I = 1, NR
           DO J = 1, NC1
              ACREA(I,J) = AIN(I,J)
           ENDDO
        ENDDO
C
        IF (NR.NE.NC1) THEN
           CALL STTPUT
     X          (' A symmetric distances matrix is expected.',ISTAT)
           CALL STTPUT(' The input matrix is not symmetric !',ISTAT)
           STOP
        ENDIF
C
        CALL CMDS(NR,ACREA,IPRINT,W1,W2,A,IERR)
C
        IF (IERR.NE.0) THEN
           CALL STTPUT(' IERR not 0 on return from CMDS.',ISTAT)
           STOP
        ENDIF
C
        DO I = 1, NR
           DO J = 1, NC2
              AOUT(I,J) = ACREA(I,J)
           ENDDO
        ENDDO
C
        RETURN
        END
C-------------------------------------------------------------------------
        SUBROUTINE CHSEL(MASK,NROW,NSEL)
C ...   Count table rows which are SELECTed.
        INTEGER I,NSEL,NROW
        REAL*4  MASK(NROW),TBLSEL
        DOUBLE PRECISION TDTRUE,TDFALS
        CALL TBMCON(TBLSEL,TDTRUE,TDFALS)
        NSEL = 0
        DO I = 1, NROW
           IF (MASK(I).EQ.TBLSEL) NSEL = NSEL + 1
        ENDDO
        RETURN
        END
C-------------------------------------------------------------------------
        SUBROUTINE CHNULL(X,NT,NULL)
C ...   Check if null values are present.
        INTEGER I,NULL,NT
        REAL*4  X(NT), TRNULL
        INTEGER TINULL
        DOUBLE PRECISION TDNULL
        CALL TBMNUL(TINULL,TRNULL,TDNULL)
        NULL = 0
        DO I = 1, NT
           IF (X(I).EQ.TRNULL) NULL = NULL + 1
           IF (NULL.GT.0) RETURN
        ENDDO
        RETURN
        END
C---------------------------------------------------------------------
        SUBROUTINE GETSTOR(NVALS,IPTR)
C ...   Allocate storage space for NVALS real values.
        INTEGER NVALS,IPTR,ISTAT
        CALL TDMGET(4*NVALS,IPTR,ISTAT)
        RETURN
        END
C---------------------------------------------------------------------
        SUBROUTINE RELSTOR(NVALS,IPTR)
C ...   Release storage space of NVALS real values.
        INTEGER NVALS,IPTR,ISTAT
        CALL TDMFRE(4*NVALS,IPTR,ISTAT)
        RETURN
        END
C---------------------------------------------------------------------
        SUBROUTINE DSCROUT(TAB,N,VALS,TID,KUNIT)
C ...   Output descriptors, with table.
        INTEGER I,N,TID,KUNIT,INDX,ISTAT
        REAL*4 VALS(N),V
        CHARACTER*8  TAB 
        CHARACTER*12 TABNAME
C
        DO I = 1,(N-1)/2
           V = VALS(I)
           VALS(I) = VALS(N-I)
           VALS(N-I) = V
        ENDDO
        INDX = INDEX(TAB//' ',' ')-1
        TABNAME = TAB(1:INDX)//'.TBL'
        CALL STDWRR(TID,'EIGENVALUES',VALS,1,N-1,KUNIT,ISTAT)
        RETURN
        END

C @(#)flstbd.for	19.1 (ES0-DMD) 02/25/03 13:25:33
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  subroutine FLSTBD         version 1.0         880901
C  A. Kruszewski             Warsaw U. Obs.
C.PURPOSE
C.INPUT/OUTPUT
C  Input arguments
C  NREG      integer*4         number of regional linked lists
C  ITOB      integer*4 array   limits of objects area
C  Output arguments
C  LSTP      integer*4 array   borders of regions
C-----------------------------------------------------------------------
      SUBROUTINE FLSTBD ( NREG , LSTP , ITOB )
C
      IMPLICIT  NONE
C
      INTEGER   NREG
      INTEGER   LSTP(0:4,0:NREG)
      INTEGER   ITOB(4)
C
      INTEGER   ISIDE
      INTEGER   KX, KY
      INTEGER   ICNT
      INTEGER   L, K
      INTEGER   K1, L1
C
C ******      Initialize pointers and find regions' borders.
      ISIDE = LSTP(0,0)
      KX = LSTP(1,0)
      KY = LSTP(2,0)
      ICNT = 0
      DO 10 L = 1 , KY
            L1 = L * ISIDE
            DO 20 K = 1 , KX
                  K1 = K * ISIDE
                  ICNT = ICNT + 1
                  LSTP(0,ICNT) = 0
                  LSTP(1,ICNT) = ITOB(1) + K1 - ISIDE
                  LSTP(2,ICNT) = ITOB(2) + L1 - ISIDE
                  LSTP(3,ICNT) = MIN( ITOB(1) + K1-1 , ITOB(3) )
                  LSTP(4,ICNT) = MIN( ITOB(2) + L1-1 , ITOB(4) )
   20            CONTINUE
   10      CONTINUE
C
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2008 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION: FUTILS
C.PURPOSE:        subroutines used by centerrow.for
C.LANGUAGE:       F77+ESOext
C.AUTHOR:         J.D.Ponz
C.KEYWORDS:       Line, centre
C.ALGORITHM:      Line center is found by:
C                 maximum/minimum - position of the maximum/minimum value
C                 gaussian        - center of the fitted gaussian
C                 gravity         - gravity center of the 2 highest pixels
C                                   with respect to the third one
C 
C.VERSION: 840328  JDP  Creation   
C.VERSION: 071016  KB   copied from ../src/centerrow.for
C 
C 080724	last modif
C-----------------------------------------------------------------
C 
      SUBROUTINE PLFIND(X,XSTR,XSTP,IPL1,IPL2,IMODE,IMETH,
     +                XCENTR,PEAK,IFAIL,W1,W2,ACOE,Y1,Y2)
C++++
C. PURPOSE: Find center
C---
      IMPLICIT NONE
      INTEGER          IPL1,IPL2,IMODE,IMETH
      INTEGER          IFAIL,NPX

      REAL             X(*)
      DOUBLE PRECISION XSTR,XSTP
      DOUBLE PRECISION XCENTR,PEAK,CHICHK,XSP,XGO
      DOUBLE PRECISION W1(*),W2(*),ACOE(*),Y1,Y2
C
      CHICHK = 0.005
      XSP    = XSTP
      XGO    = XSTR + (IPL1-1)*XSP
      NPX    = IPL2 - IPL1 + 1
      Y1     = DBLE(X(IPL1))
      Y2     = DBLE(X(IPL2))
      IF (IMETH.LT.0) THEN                                    ! gaussian center
         CALL SGAUS(X(IPL1),W1,W2,IMODE,NPX,IFAIL,XGO,XSP,
     +              XCENTR,CHICHK,0,PEAK,ACOE)
      ELSE IF (IMETH.EQ.0) THEN
         CALL GRAVT(X(IPL1),NPX,IMODE,IFAIL,XGO,XSP,XCENTR,PEAK)
      ELSE
         CALL CNTRH(X(IPL1),NPX,IMODE,IFAIL,XGO,XSP,XCENTR,PEAK)
      ENDIF
C 
      RETURN
      END

C 
      SUBROUTINE GRAVT(WINDOW,NPIX,IWID,IWERR,XGO,DXSTP,XCNTR,AM)       
C                                                                              
C line centering by finding the center of gravity of 2 highest                 
C points of 3 points                                                           
C the 2 highest points have values relatives to the third                      
C only applicable in emission mode                                             
C PARAMETERS :                                                                 
C WINDOW buffer with expected line center in middle                            
C NPIX number of samples in WINDOW                                             
C IWID code 0 absorption, 1 emission                                           
C IWERR  error return, 0 ok, 1 error                                           
C XGO xcoordinate first element in WINDOW                                      
C DXSTP step in x                                                              
C XCNTR return x center calculated                                             
C AM intensity center pixel                                                    
C                                                                              
      IMPLICIT NONE
C
      INTEGER  NPIX, IWID, IWERR, I, K

      REAL             WINDOW(*)
      DOUBLE PRECISION AM, AL, AH, DR
      DOUBLE PRECISION XGO, DXSTP, XCNTR, A, B, XSHIFT
C
      IF (IWID.NE.1) GO TO 20                                                  
C                                                                              
C find maximum                                                                 
C                                                                              
      AM     = WINDOW(1)                                                       
      I      = 1                                                               
      DO 10 K = 2,NPIX                                                         
          IF (WINDOW(K).GT.AM) THEN                                            
              AM     = WINDOW(K)                                               
              I      = K                                                       
          END IF                                                               
   10 CONTINUE                                                                 
C                                                                              
C check not boundary                                                           
C                                                                              
      IF (I.EQ.1 .OR. I.EQ.NPIX) GO TO 20                                      
      XCNTR  = XGO + (I-1)*DXSTP                                               
C                                                                              
C find lowest of the flanking pixels                                           
C                                                                              
      AL     = WINDOW(I-1)                                                     
      AH     = WINDOW(I+1)                                                     
      DR     = 1.                                                              
      IF (AL.GE.AH) THEN                                                       
          AL     = WINDOW(I+1)                                                 
          AH     = WINDOW(I-1)                                                 
          DR     = -1.                                                         
      END IF                                                                   
      AM     = WINDOW(I)                                                       
      A      = AM - AL                                                         
      B      = AH - AL                                                         
      XSHIFT = (B/ (A+B))*DXSTP                                                
      XCNTR  = XCNTR + XSHIFT*DR                                               
      IWERR  = 0                                                               
      RETURN                                                                   
C                                                                              
C error return                                                                 
C                                                                              
   20 IWERR  = 1                                                               
      RETURN                                                                   
                                                                               
      END


      SUBROUTINE CNTRH(WINDOW,NPIX,IWID,IWERR,XGO,DXSTP,XCNTR,AM)              
C                                                                              
C center of line found by simple maximum within a window                       
C                                                                              
C PARAMETERS :                                                                 
C WINDOW buffer with expected line center in middle                            
C NPIX number of samples in WINDOW                                             
C IWID code 0 absorption, 1 emission                                           
C IWERR  error return, 0 ok, 1 error                                           
C XGO xcoordinate first element in WINDOW                                      
C DXSTP step in x                                                              
C XCNTR return x center calculated                                             
C AM intensity center pixel                                                    
C                                                                              
      IMPLICIT NONE
C
      INTEGER           NPIX, IWID, IWERR
      REAL              WINDOW(*)
      DOUBLE PRECISION  AM, XGO, DXSTP, XCNTR
C
      INTEGER IPN, I
C
      IWERR  = 0                                                               
      AM     = WINDOW(1)                                                       
      IPN    = 1                                                               
      IF (IWID.NE.1) THEN                                                      
C                                                                              
C find minimum                                                                 
C                                                                              
          DO 10 I = 2,NPIX                                                     
              IF (WINDOW(I).LT.AM) THEN                                        
                  AM     = WINDOW(I)                                           
                  IPN    = I                                                   
              END IF                                                           
   10     CONTINUE                                                             
      ELSE                                                                     
C                                                                              
C find maximum                                                                 
C                                                                              
          DO 20 I = 2,NPIX                                                     
              IF (WINDOW(I).GT.AM) THEN                                        
                  AM     = WINDOW(I)                                           
                  IPN    = I                                                   
              END IF                                                           
   20     CONTINUE                                                             
      END IF                                                                   
C                                                                              
C check result                                                                 
C                                                                              
      IF (IPN.EQ.1 .OR. IPN.EQ.NPIX) GO TO 30                                  
      XCNTR  = XGO + (IPN-1)*DXSTP                                             
      RETURN                                                                   
C                                                                              
C error return                                                                 
C                                                                              
   30 IWERR  = 1                                                               
      RETURN                                                                   
      END                                                                      

      SUBROUTINE SGAUS(WINDOW,XBUF,YFIT,IWID,NPIX,IWERR,XGO,DXSTP,
     2                 XCNTR,CHICHK,IOUTPT,AM,A)                              
C                                                                              
C line center finding with gaussian fit                                        
C                                                                              
C PARAMETERS :                                                                 
C WINDOW buffer with expected line center in middle                            
C XBUF work buffer                                                             
C YFIT work buffer                                                             
C IWID code 0 absorption, 1 emission                                           
C NPIX number of samples in WINDOW                                             
C IWERR  error return, 0 ok, 1 error                                           
C XGO xcoordinate first element in WINDOW                                      
C DXSTP step in x                                                              
C XCNTR return x center calculated                                             
C CHICHK check chisquare                                                       
C IOUTPT display intermediate results 0 no, 1 yes                              
C AM intensity center pixel                                                    
C A array(4) coefficients                                                      
C                                                                              
      INTEGER          I,K1,K2,NPIX,IWID,IWERR,IOUTPT
      INTEGER          ITCNT,ITCHK,JER,IBRK

      REAL             WINDOW(*)
      DOUBLE PRECISION XBUF(*),YFIT(*),A(*)          
      DOUBLE PRECISION DELTAA(4),SIGMAA(4),XCNTR,XGO,CHICHK
      DOUBLE PRECISION DXSTP,CHISQR,FLAMDA,OLDCH,DIF,HALF,WIDTH
      DOUBLE PRECISION AM,X,STOP,TOPM
C                                                                              
C buffer with x values                                                         
C                                                                              
      X      = XGO                                                             
      DO 10 I = 1,NPIX                                                         
          XBUF(I) = XGO + (I-1)*DXSTP                                          
   10 CONTINUE                                                                 
C                                                                              
C find initial guess                                                           
C                                                                              
      CALL CNTRH(WINDOW,NPIX,IWID,IWERR,XGO,DXSTP,A(2),AM)                     
      IF (IWERR.NE.0) GO TO 120                                                
      A(4)   = (WINDOW(1)+WINDOW(NPIX))/2.                                     
      A(1)   = AM - A(4)                                                       
C                                                                              
C calculate half width                                                         
C                                                                              
      HALF   = A(1)/2. + A(4)                                                  
C                                                                              
C calculation of FWHM depends on sign of the line                              
C                                                                              
      IF (IWID.NE.1) THEN                                                      
          DO 20 I = 1,NPIX                                                     
              IF (WINDOW(I).LT.HALF) GO TO 30                                  
   20     CONTINUE                                                             
   30     K1     = I                                                           
          DO 40 I = K1,NPIX                                                    
              IF (WINDOW(I).GT.HALF) GO TO 50                                  
   40     CONTINUE                                                             
   50     K2     = I                                                           
                                                                               
      ELSE                                                                     
          DO 60 I = 1,NPIX                                                     
              IF (WINDOW(I).GT.HALF) GO TO 70                                  
   60     CONTINUE                                                             
   70     K1     = I                                                           
          DO 80 I = K1,NPIX                                                    
              IF (WINDOW(I).LT.HALF) GO TO 90                                  
   80     CONTINUE                                                             
   90     K2     = I                                                           
      END IF                                                                   
                                                                               
      WIDTH  = ABS(FLOAT(K2-K1)*DXSTP)                                         
      A(3)   = WIDTH/2.35482                !sigma = fwhm/2.35482
      OLDCH  = 9.E16                                                           
C                                                                              
C call fitting routine                                                         
C iterate 50 times                                                             
C                                                                              
      ITCNT  = 0                                                               
      ITCHK  = 50                                                              
  100 FLAMDA = 0.001                                                           
      IBRK   = 0                                                               
C                                                                              
      CALL CURFI(XBUF,WINDOW,SIGMAA,NPIX,4,0,A,DELTAA,FLAMDA,YFIT,             
     +           CHISQR,JER)                                                   
      IF (JER.NE.0) GO TO 120                                                  
C                                                                              
C calc and display intermediate results                                        
C                                                                              
      IF (IBRK.EQ.-1) GO TO 110                                                
C                                                                              
C see if CHISQR has changed significantly                                      
C                                                                              
      DIF    = OLDCH - CHISQR                                                  
      STOP   = DIF/CHISQR                                                      
      OLDCH  = CHISQR                                                          
      ITCNT  = ITCNT + 1                                                       
      IF (ITCNT.GT.ITCHK) GO TO 120                                            
      IF (STOP.GT.CHICHK) GO TO 100                                            
  110 XCNTR  = A(2)                                                            
C                                                                              
C last check that we are within the window                                     
C                                                                              
      TOPM   = XBUF(NPIX)                                                      
      IF (DXSTP.LT.0.) THEN                                                    
          IF ((XCNTR.GT.XGO) .OR. (XCNTR.LT.TOPM)) GO TO 120                   
                                                                               
      ELSE                                                                     
          IF ((XCNTR.LT.XGO) .OR. (XCNTR.GT.TOPM)) GO TO 120                   
      END IF                                                                   
                                                                               
      IWERR  = 0                                                               
      A(3)   = A(3)*2.35482                  !fwhm = sigma * 2.35482
      RETURN                                                                   
C                                                                              
C error return                                                                 
C                                                                              
  120 IWERR  = 1                                                               
      RETURN                                                                   
                                                                               
      END                                                                      

      SUBROUTINE CURFI(X,Y,SIGMAY,NPTS,NTERMS,MODE,A,DELTAA,FLAMDA,YFIT,       
     +                 CHISQR,IERR)                                            
C                                                                              
C least squares fit to a non-linear function                                   
C                                                                              
C PARAMETERS:                                                                  
C X array of data points ind. var.                                             
C Y array of data points dep. var.                                             
C SIGMAY array of std dev for Y data points                                    
C NPTS number of pairs of data points                                          
C MODE determines method of weighting least-squares fit                        
C  +1 (instrumental) weight = 1./sigmay(i)**2                                  
C   0 (no weighting) weight = 1.                                               
C  -1 (statistical ) weight = 1./y(i)                                          
C A array of parameters                                                        
C DELTAA array of increments for parameters A                                  
C SIGMAA array of standard deviations for parameters A                         
C FLAMDA proportion of gradient search included                                
C YFIT array of calculated values of Y                                         
C CHISQR reduced chi square for fit                                            
C IERR error return 0 ok, 1 not converging                                     
C                                                                              
C dimension statement valid for NTERMS up to 10                                
C set FLAMDA to 0.001 at the beginning of the search                           
C     
      INTEGER I,J,K,NPTS,NFREE ,NTERMS,IERR  
      INTEGER MODE ,ICNT, ISTAT                               

      REAL             Y(*)
      DOUBLE PRECISION X(*), SIGMAY(*), DELTAA(*), YFIT(*) 
      DOUBLE PRECISION A(*), DET, FLAMDA, CHISF, FUNCT 
      DOUBLE PRECISION WEIGHT(2048), ALPHA(10,10), BETA(10) 
      DOUBLE PRECISION DERIV(10), B(10), CHISQR, CHISQ1 
      DOUBLE PRECISION ARRAY(10,10)
      EXTERNAL FUNCT
C                                                                              
      ICNT   = 0                                                               
      IERR   = 1                                                               
      NFREE  = NPTS - NTERMS                                                   
      IF (NFREE) 20,20,30                                                      
   20 CHISQR = 0.                                                              
      RETURN                                                                   
C                                                                              
C evaluate weights                                                             
C                                                                              
   30 CONTINUE                                                                 
      IERR   = 0                                                               
      DO 100 I = 1,NPTS                                                        
          IF (MODE) 40,70,80                                                   
   40     IF (Y(I)) 60,70,50                                                   
   50     WEIGHT(I) = 1./Y(I)                                                  
          GO TO 90                                                             
                                                                               
   60     WEIGHT(I) = 1./ (-Y(I))                                              
          GO TO 90                                                             
                                                                               
   70     WEIGHT(I) = 1.                                                       
          GO TO 90                                                             
                                                                               
   80     WEIGHT(I) = 1./SIGMAY(I)**2                                          
   90     CONTINUE                                                             
  100 CONTINUE                                                                 
C                                                                              
C evaluate alpha and beta matrices                                             
C                                                                              
      DO 120 J = 1,NTERMS                                                      
          BETA(J) = 0.                                                         
          DO 110 K = 1,J
              ALPHA(J,K) = 0.                                                  
  110     CONTINUE                                                             
  120 CONTINUE                                                                 
      DO 150 I = 1,NPTS                                                        
          CALL FDERI(X,I,A,DELTAA,NTERMS,DERIV)                                
          DO 140 J = 1,NTERMS                                                  
              BETA(J) = BETA(J) + WEIGHT(I)* (Y(I)-FUNCT(X,I,A))*              
     +                  DERIV(J)                                               
              DO 130 K = 1,J                                                   
                  ALPHA(J,K) = ALPHA(J,K) + WEIGHT(I)*DERIV(J)*DERIV(K)        
  130         CONTINUE                                                         
  140     CONTINUE                                                             
  150 CONTINUE                                                                 
      DO 170 J = 1,NTERMS                                                      
          DO 160 K = 1,J                                                       
              ALPHA(K,J) = ALPHA(J,K)                                          
  160     CONTINUE                                                             
  170 CONTINUE                                                                 
C                                                                              
C evaluate chi square at starting point                                        
C                                                                              
      DO 180 I = 1,NPTS                                                        
          YFIT(I) = FUNCT(X,I,A)                                               
  180 CONTINUE                                                                 
      CHISQ1 = CHISF(Y,SIGMAY,NPTS,NFREE,MODE,YFIT)                            
C                                                                              
C invert matrix                                                                
C                                                                              
  190 DO 210 J = 1,NTERMS                                                      
          DO 200 K = 1,NTERMS                                                  
              IF (ABS(ALPHA(J,J)).LT.1.E-30 .OR.
     +                ABS(ALPHA(K,K)).LT.1.E-30) THEN
                 CALL STTPUT
     +                ('*** WARNING: Insufficient accuracy: NO RESULT',
     +                ISTAT)
                 CALL STTPUT
     +                ('              Scale your input data first', 
     +                ISTAT)
                 GOTO 987
              ENDIF
              ARRAY(J,K) = ALPHA(J,K)/SQRT(ALPHA(J,J)*ALPHA(K,K))              
  200     CONTINUE                                                             
          ARRAY(J,J) = 1. + FLAMDA                                             
  210 CONTINUE                                                                 
      CALL INVMAT(ARRAY,NTERMS,DET)                                            
      DO 230 J = 1,NTERMS                                                      
          B(J)   = A(J)                                                        
          DO 220 K = 1,NTERMS                                                  
              B(J)   = B(J) + BETA(K)*ARRAY(J,K)/                              
     +                 SQRT(ALPHA(J,J)*ALPHA(K,K))                             
  220     CONTINUE                                                             
  230 CONTINUE                                                                 
C                                                                              
C if chi square increased, increase FLAMDA and try again                       
C                                                                              
      DO 240 I = 1,NPTS                                                        
          YFIT(I) = FUNCT(X,I,B)                                               
  240 CONTINUE                                                                 
      CHISQR = CHISF(Y,SIGMAY,NPTS,NFREE,MODE,YFIT)                            
      IF (CHISQ1-CHISQR) 250,270,270                                           
C                                                                              
C check loops                                                                  
C                                                                              
  250 ICNT   = ICNT + 1                                                        
      IF (ICNT.LT.60) GO TO 260                                                
  987 IERR   = 1                                                               
      RETURN                                                                   
                                                                               
  260 FLAMDA = 10.*FLAMDA                                                      
      GO TO 190                                                                
C                                                                              
C evaluate parameters                                                          
C                                                                              
  270 DO 280 J = 1,NTERMS                                                      
          A(J)   = B(J)                                                        
  280 CONTINUE                                                                 
      FLAMDA = FLAMDA/10.                                                      
      RETURN                                                                   
                                                                               
      END                                                                      

      DOUBLE PRECISION FUNCTION FUNCT(X,I,A)
C
C evaluate terms of function for non-linear least-squares search
C with form of gaussian peak
C
C PARAMETERS:
C X array of data points
C I index of data points
C A array of parameters
C
      INTEGER I
      DOUBLE PRECISION X(*),A(*),Z,XI,Z2

      XI     = X(I)
      FUNCT  = A(4)
      Z      = (XI-A(2))/A(3)
      Z2     = Z*Z
      IF (Z2-50.) 40,50,50
   40 FUNCT  = FUNCT + A(1)*EXP(-Z2*0.5)
   50 RETURN

      END

      DOUBLE PRECISION FUNCTION CHISF(Y,SIGMAY,NPTS,NFREE,MODE,YFIT)
C
C evaluate reduced chi square for fit to data
C chisf = sum((y-yfit)**2/sigma**2)/nfree
C
C PARAMETERS:
C Y array of data points
C SIGMAY array of standard deviations
C NPTS number of data points
C NFREE number of degrees of freedom
C MODE determines method of weighting least-squares fit
C  +1 (instrumental) weight = 1./SIGMAY(i)**2
C   0 (no weighting) weight = 1.
C  -1 (statistical ) weight = 1./Y(i)
C YFIT array of calculated values of Y
C
      INTEGER NFREE,MODE,NPTS,I
      REAL             Y(1)
CC      DOUBLE PRECISION SIGMAY(1),YFIT(1),CHISF
      DOUBLE PRECISION SIGMAY(1),YFIT(1)
      DOUBLE PRECISION CHISQ,WEIGHT
C
      CHISQ  = 0.
      IF (NFREE) 30,30,40
   30 CHISF  = 0.
      RETURN
C
C accumulate chi square
C
   40 DO 110 I = 1,NPTS
          IF (MODE) 50,80,90
   50     IF (Y(I)) 70,80,60
   60     WEIGHT = 1./Y(I)
          GO TO 100

   70     WEIGHT = 1./ (-Y(I))
          GO TO 100

   80     WEIGHT = 1.
          GO TO 100

   90     WEIGHT = 1./SIGMAY(I)**2
  100     CHISQ  = CHISQ + WEIGHT* (Y(I)-YFIT(I))**2
  110 CONTINUE
C
C divide by number of degrees of freedom
C
      CHISF  = CHISQ/NFREE
      RETURN

      END

      SUBROUTINE FDERI(X,I,A,DELTAA,NTERMS,DERIV)                              
C                                                                              
C evaluates derivatives of function for least squares search                   
C with form of gaussian peak                                                   
C                                                                              
C PARAMETERS:                                                                  
C X array of data points of independent variable                               
C I index of data points                                                       
C A array of parameters                                                        
C DELTAA array of parameter increments                                         
C NTERMS number of parameters                                                  
C DERIV derivatives of function                                                
C                                                                              
      INTEGER I,J,NTERMS

      DOUBLE PRECISION X(*),A(*),DELTAA(*),DERIV(*) 
      DOUBLE PRECISION Z,Z2,XI
                                                                               
      XI     = X(I)                                                            
      Z      = (XI-A(2))/A(3)                                                  
      Z2     = Z*Z                                                             
      IF (Z2-50.) 40,20,20                                                     
   20 DO 30 J = 1,3                                                            
          DERIV(J) = 0.                                                        
   30 CONTINUE                                                                 
      GO TO 50                                                                 
C                                                                              
C analytical expression for derivatives                                        
C                                                                              
   40 DERIV(1) = EXP(-Z2/2.)                                                   
      DERIV(2) = A(1)*DERIV(1)*Z/A(3)                                          
      DERIV(3) = DERIV(2)*Z                                                    
   50 DERIV(4) = 1.                                                            
      RETURN                                                                   
                                                                               
      END                                                                      

      SUBROUTINE INVMAT(ARR,N,DET)
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  0:26 - 4 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: D.PONZ
C         inverts a symmetric matrix and calculates its determinant
C         using a gauss-jordan elimination method. the degree n of
C         the matrix must not be greater than 10.
C         the inversion is in double precision, and
C         the array ARR must be double. the determinant is allways real.
C
C   PARAMS :
C         ARR :  array containing the (n*n) matrix to be inverted.
C                the inverted matrix is returned in ARR.
C         N   :  degree of matrix
C         DET :  determinant of input-matrix
C
C      IMPLICIT NONE
                                         
      DOUBLE PRECISION DET
      DOUBLE PRECISION ARR(10,10),AMAX,SAVE,DDET
      INTEGER IK(10),JK(10),I,J,K,N,L
C
      DET    = 1.0
      DDET   = 1.0D0
      DO 210 K = 1,N
          AMAX   = 0.0D0
C
C  find largest element ARR(i,j) in rest of matrix
C
   10     DO 40 I = K,N
              DO 30 J = K,N
                  IF (DABS(AMAX)-DABS(ARR(I,J))) 20,20,30
   20             AMAX   = ARR(I,J)
                  IK(K)  = I
                  JK(K)  = J
   30         CONTINUE
   40     CONTINUE
C  ----------------------------------------------------
C  interchange rows and columns to put AMAX in ARR(k,k)
C  ----------------------------------------------------
          IF (AMAX) 60,50,60
   50     DET    = 0.
          GO TO 280

   60     I      = IK(K)
          IF (I-K) 10,90,70
   70     DO 80 J = 1,N
              SAVE   = ARR(K,J)
              ARR(K,J) = ARR(I,J)
              ARR(I,J) = -SAVE
   80     CONTINUE
C
   90     J      = JK(K)
          IF (J-K) 10,120,100
  100     DO 110 I = 1,N
              SAVE   = ARR(I,K)
              ARR(I,K) = ARR(I,J)
              ARR(I,J) = -SAVE
  110     CONTINUE
C  -------------------------------------
C  accumulate elements of inverse matrix
C  -------------------------------------
  120     DO 140 I = 1,N
              IF (I-K) 130,140,130
  130         ARR(I,K) = -ARR(I,K)/AMAX
  140     CONTINUE
C
          DO 180 I = 1,N
              DO 170 J = 1,N
                  IF (I-K) 150,170,150
  150             IF (J-K) 160,170,160
  160             ARR(I,J) = ARR(I,J) + ARR(I,K)*ARR(K,J)
  170         CONTINUE
  180     CONTINUE
C
          DO 200 J = 1,N
              IF (J-K) 190,200,190
  190         ARR(K,J) = ARR(K,J)/AMAX
  200     CONTINUE
          ARR(K,K) = 1.0/AMAX
          DET    = DET*AMAX
          DDET   = DDET*AMAX
C
  210 CONTINUE
C  --------------------------
C  restore ordering of matrix
C  --------------------------
      DO 270 L = 1,N
          K      = N - L + 1
          J      = IK(K)
          IF (J-K) 240,240,220
  220     DO 230 I = 1,N
              SAVE   = ARR(I,K)
              ARR(I,K) = -ARR(I,J)
              ARR(I,J) = SAVE
  230     CONTINUE
C
  240     I      = JK(K)
          IF (I-K) 270,270,250
  250     DO 260 J = 1,N
              SAVE   = ARR(K,J)
              ARR(K,J) = -ARR(I,J)
              ARR(I,J) = SAVE
  260     CONTINUE
C
  270 CONTINUE
      DET    = DDET
      RETURN
C  -------------------
C  determinant is zero
C  -------------------
  280 DET    = 0.0
      RETURN

      END

C @(#)rfotsearch.for	19.1 (ES0-DMD) 02/25/03 13:30:15
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
       PROGRAM SEARCH   
C+++
C.IDENTIFICATION: RFOTSEARCH
C.PURPOSE: Search for objects above a certain threshold in a frame
C.AUTHOR:  R. Buonanno, G. Buscema, C. Corsi, I. Ferraro, G. Iannicola
C          Osservatorio Astronomico di Roma
C.VERSION: 870906 RXB First running version at ESO (outside MIDAS)
C          871217 RHW Installation in MIDAS
C          880929 RHW New version
C          880104 RHW Include MIDAS for background values
C          8901?? RHW Rewritten for the portable MIDAS version 
C                     Inclusion of MIDAS tables 
C.VERSION: 910122 RHW IMPLICIT NONE added; all variables defined
C----
       IMPLICIT    NONE
C
       INTEGER     NX
       INTEGER     NDSAT
       INTEGER     IDFS
       PARAMETER   (NX=10000)
       PARAMETER   (NDSAT=50000)
       PARAMETER   (IDFS=1000)

       DOUBLE PRECISION BEGIN(2),STEP(2)

       INTEGER      AREA(6)
       INTEGER      EC, ED, EL
       INTEGER      I, I2
       INTEGER      IXW, IYW
       INTEGER      IX0, IY0
       INTEGER      IXR, IYR
       INTEGER      IST(2000)
       INTEGER      ISTAT,IAC
       INTEGER*8    IPNTR
       INTEGER      IMF
       INTEGER      IACOL, IAROW
       INTEGER      IDX, IDY
       INTEGER      IMX, IMY
       INTEGER      I1, IB, IA1, IA5, IA6
       INTEGER      IM, IK, IW, INL, ILA
       INTEGER      IDUM, IGRP
       INTEGER      J, J1
       INTEGER      KUN, KNUL
       INTEGER      KOSTE, KLIN, KSAT
       INTEGER      KR, KN, KR1, KK
       INTEGER      LN(3)
       INTEGER      LK, LF
       INTEGER      L, LL
       INTEGER      MADRID(1)
       INTEGER      MTS(NDSAT,4)
       INTEGER      NLN(3)
       INTEGER      NPIX(2)
       INTEGER      NAXIS, NPL, NL
       INTEGER      NLI, NI
       INTEGER      NCX, NCY
       INTEGER      NDUM, NCO, NCHAR, NTRY
       INTEGER      NCSKY, NRSKY, NN, NSF
       INTEGER      N3, NYM, NY2
       INTEGER      SKYCOL(256)
       INTEGER      TIDCAT,TIDSKY
C       
       REAL         A, A1, A2, A3, A4, A5, A6, A7
       REAL         AIN, AB1, RA
       REAL         BETA
       REAL         BACKGR(256)
       REAL         DICI, DICS
       REAL         FON(IDFS)
       REAL         FLB, FONM, FL, F
       REAL         H 
       REAL         P(5000,6)
       REAL         PRX, PRY, PR, PESO
       REAL         RINPUT(3)
       REAL         RIJ, RISI, RAG, R
       REAL         RAMA, RAME
       REAL         SGL(IDFS)
       REAL         SINC, SINR
       REAL         SIGMA, SAT, SUPE
       REAL         XCEN, YCEN
       REAL         XBAR, YBAR
       REAL         X,Y
       REAL         ZMA(NX,3)
C
       DOUBLE PRECISION    DDUM
C
       LOGICAL      FDX,FDY,VLO,NULL(256)
C
       CHARACTER    IDENT*72,CUNIT*80
       CHARACTER    FRAME*60, SKYFIL*60, CATFIL*60
       CHARACTER    SPF*1
       CHARACTER    STRING*80, CVALUE*80
C	
       INCLUDE      'MID_INCLUDE:ST_DEF.INC/NOLIST'
       COMMON      /PRONE/KR,DICI,DICS,RIJ,ZMA,RISI,IXW,IYW,SGL,FON,
     *                    SAT,XCEN,YCEN,IX0,IY0,IM,NCX,NCY,IDX,IDY,
     *                    AIN,RAMA,RAME,FONM,MTS,KSAT,I1,NYM,LN,
     *                    BETA,SIGMA,KN,PR,NY2
       COMMON       /VMR/MADRID
       INCLUDE      'MID_INCLUDE:ST_DAT.INC/NOLIST'
C
       DATA         NLN/2,3,1/
C
 9001  FORMAT('*** INFO: Area in pixel units: [', 
     2            I5, ',', I5, ':', I5, ',', I5, ']')
 9010  FORMAT('          Minimum threshold for star detection:',E12.5)
 9020  FORMAT('          Number of objects found: ',I6,
     2        '; saturated: ',I6)
C
C *** START 
       CALL STSPRO('SEARCH')
       LN(1) = 1
       LN(2) = 2
       LN(3) = 3
       KSAT  = 0
C
C *** input parameters
       CALL STKRDC('IN_A',1,1,60,IAC,FRAME,KUN,KNUL,ISTAT)      ! name of image
       CALL STKRDC('IN_B',1,1,60,IAC,SKYFIL,KUN,KNUL,ISTAT)  ! sky backgr table
       CALL STKRDC('OUTPUTC',1,1,60,IAC,CATFIL,KUN,KNUL,ISTAT)  ! catalog table
C
       CALL STIGET(FRAME,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     2             2,NAXIS,NPIX,BEGIN,STEP,IDENT,CUNIT,IPNTR,IMF,ISTAT)
       NPL = NPIX(1)
       NL  = NPIX(2)
       IXW = BEGIN(1)
       IYW = BEGIN(2)
C
C *** read the background values from the sky table
      CALL STECNT('GET',EC,ED,EL)
      CALL STECNT('PUT',1,0,0)
      CALL TBTOPN(SKYFIL,F_I_MODE,TIDSKY,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL: problems with opening the sky '//
     2            'background table; try again ...'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
C
      CALL STDRDI(IMF,'SKY_AREA',1,6,IAC,AREA,KUN,KNUL,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL: No information about the background'//
     2            ' determination'
         CALL STTPUT(STRING,ISTAT)
         STRING = '           Did you run SKY/ROMAFOT before ?'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
      CALL STECNT('PUT',EC,ED,EL)
C
      CALL STKRDC('INPUTC',1,1,40,IAC,STRING,KUN,KNUL,ISTAT)        ! user area
      IF (STRING(1:3).EQ.'SKY') THEN
         IX0  = AREA(1)
         IY0  = AREA(2)
         IDX  = AREA(3) - AREA(1) + 1
         IDY  = AREA(4) - AREA(2) + 1
      ELSE
         CALL EXTCOO(IMF,STRING,NAXIS,NDUM,AREA(1),AREA(3),ISTAT)
         IX0  = AREA(1)
         IY0  = AREA(2)
         IDX  = AREA(3) - AREA(1) + 1
         IDY  = AREA(4) - AREA(2) + 1
      ENDIF

      NCX = AREA(5)
      NCY = AREA(6)
      NCO = NCX*NCY
      IF (IX0.LT.1) IX0 = 1
      IF (IY0.LT.1) IY0 = 1
      IF ((IX0+IDX-1).GT.NPL) IDX = NPL-IX0+1
      IF ((IY0+IDY-1).GT.NL)  IDY = NL-IY0+1
C
      WRITE (STRING,9001) AREA(1),AREA(2),AREA(3),AREA(4)
      CALL STTPUT(STRING,ISTAT)
C
C *** get the PSF values
      CALL STKRDR('INPUTR',1,3,IAC,RINPUT,KUN,KNUL,ISTAT)
      SIGMA = RINPUT(1)
      BETA  = RINPUT(2)
      SAT   = RINPUT(3)
C
C *** get photometric option, threshold
      STRING = ' '
      CALL STKRDC('INPUTC',1,41,40,IAC,STRING,KUN,KNUL,ISTAT)
      CALL UPCAS(STRING,STRING)
      IF (STRING(1:3).EQ.'PRO') THEN
         CALL STKPRC('Enter photom. option and threshold: ',
     2               'INPUTC',1,41,40,IAC,STRING,KUN,KNUL,ISTAT)
      ENDIF
      SPF    = STRING(1:1)
      NCHAR  = INDEX(STRING,',')
      CVALUE = STRING(NCHAR+1:)
      CALL GENCNV(CVALUE,2,1,IDUM,RINPUT,DDUM,ISTAT)
C     CALL USRINP(RINPUT,1,'R',CVALUE)       
      IF (SPF.EQ.'C') THEN                       !constant photometric treshold
         SINC = RINPUT(1)
      ELSE IF (SPF.EQ.'R') THEN                      !N times the Sky Stan. Dev
         SINR = INT(RINPUT(1))
      ELSE
         STRING = '*** FATAL: Unknown option; try again ...'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      END IF
C
C *** min. height to determine influence of star
      CALL STKRDR('INPUTR',4,1,IAC,AIN,KUN,KNUL,ISTAT) 
      NTRY = 0
   12 CONTINUE
      IF (AIN.EQ.0 .AND. NTRY.EQ.0) THEN
         CALL STKPRR('Enter minimum height: ',
     2               'INPUTR',4,1,IAC,AIN,KUN,KNUL,ISTAT)
         NTRY = NTRY + 1
         GO TO 12

      ELSE IF (AIN.EQ.0 .AND. NTRY.GE.1) THEN
         STRING = '*** WARNING: Minimum can not be 0.0; try again ...'
         CALL STTPUT(STRING,ISTAT)
         CALL STKPRR('Enter minimum height: ',
     2               'INPUTR',4,1,IAC,AIN,KUN,KNUL,ISTAT)
         NTRY = NTRY + 1
         GO TO 12
      ENDIF
C
C *** get the info from the sky table
      CALL TBIGET(TIDSKY, NCSKY, NRSKY, NN, IACOL, IAROW, ISTAT)
      DO 19 I = 1,NCSKY
         SKYCOL(I) = I
   19 CONTINUE
      DO 20 J = 1,NRSKY
         CALL TBRRDR(TIDSKY,J,NCSKY,SKYCOL,BACKGR,NULL,ISTAT)
         DO 21 I = 1,NCSKY
            FON((J-1)*NCSKY+I) = BACKGR(I)
   21    CONTINUE
   20 CONTINUE
C
C *** create the catalogue table
      CALL CATINI(CATFIL,TIDCAT)
C
C *** get the threshold
      FONM = 2000000000.
      DO 50 LL = 1,NCO
         IF (SPF.EQ.'C' .OR. SPF.EQ.'c') THEN
            SGL(LL) = SINC
         ELSE
            SGL(LL) = SINR*SQRT(FON(LL))
         END IF
         FONM = MIN(FONM,SGL(LL))
   50 CONTINUE

      RAMA = 0.
      RAME = 0.
      NYM  = 3
      NY2  = NYM/2
      N3   = 1
      KN   = 0
      PR   = (DICS-DICI)/NCO
      WRITE (STRING,9010) FONM
      CALL STTPUT(STRING,ISTAT)
C
C *** search for objects
       DO 110 I = 1,NYM
          INL = I
          KLIN = I + IY0 - 1
          CALL REALIN(NPL,NL,KLIN,IX0,IDX,MADRID(IPNTR),ZMA(1,LN(INL)))
  110  CONTINUE
       KR = 0
       DO 120 I1 = 1,NY2+1
          CALL PROONE(TIDCAT)
  120  CONTINUE
C
       I1  = NY2+1
       INL = 3
       DO 130 I = 4,IDY
C         IF (MOD(I,100).EQ.0) THEN
C            WRITE(STRING,9025) I
C            CALL STTPUT(STRING,ISTAT)
C         END IF
C
          DO 131 L = 1,NYM
             LN(L) = NLN(LN(L))
  131     CONTINUE
          KLIN = I + IY0 - 1
          CALL REALIN(NPL,NL,KLIN,IX0,IDX,MADRID(IPNTR),ZMA(1,LN(INL)))
          CALL PROONE(TIDCAT)
  130  CONTINUE
C
       DO 140 I = 1,NYM-NY2-1
          I1 = I1+1
          CALL PROONE(TIDCAT)
  140  CONTINUE
C
       NSF  = 0.
       RAME = RAME/KN
       IXR  = IX0+IXW-1
       IYR  = IY0+IYW-1
       IA1  = 0
       AB1  = 0.
       CALL CATDWR(TIDCAT,KN,NSF,IA1,RAMA,RAME,IXR,IYR,IDX,IDY,
     2             AB1,AB1,AB1,AB1,IXW,IYW)
C
C ***
       IF (KSAT.GT.0) THEN             
          KOSTE = 0
          RA    = 0
C
          DO 210 I = 1,KSAT
             IF (MTS(I,4).EQ.0) THEN
                NLI      = 1
                MTS(I,4) = 1
                NI       = 1
                IST(NI)  = I
  211           CONTINUE
                IF (NI.GT.NLI) GO TO 212
                CALL INTSAT(MTS,NDSAT,4,NI,IST,NLI,KSAT)
                NI = NI+1
                GO TO 211
  212           CONTINUE
                KOSTE = KOSTE+1
C
C *** start procedure PARSAT
                XBAR = 0
                YBAR = 0
                SUPE = 0
     
                DO 213 I1 = 1,NLI
                   PESO = MTS(IST(I1),3)-MTS(IST(I1),1)+1
                   XBAR = XBAR+(MTS(IST(I1),3)+MTS(IST(I1),1))/2*PESO
                   YBAR = YBAR+MTS(IST(I1),2)*PESO
                   SUPE = SUPE+PESO
  213           CONTINUE

                P(KOSTE,1) = XBAR/SUPE+IX0+IXW-2
                P(KOSTE,2) = YBAR/SUPE+IY0+IYW-2

                IF (BETA.GT.0) THEN
                  P(KOSTE,3) = SAT*(1+SUPE/(3.14159*SIGMA**2))**BETA
                ELSE
                  P(KOSTE,3) = SAT*(EXP(4*ALOG(2.)*SUPE/
     2                             (3.14159*SIGMA**2)))
                END IF

                J1  = NINT(P(KOSTE,1))+0.5
                KR1 = NINT(P(KOSTE,2))+0.5
                J   = J1-IX0-IXW+2
                KR  = KR1-IY0-IYW+2
C 
C *** start procedure CALCOR
                PRX = FLOAT(IDX)/FLOAT(NCX)
                PRY = FLOAT(IDY)/FLOAT(NCY)
                IF (PRX-INT(PRX).EQ.0.) THEN
                   IMX = (J-1)/INT(PRX)+1
                ELSE
                   IMX = (J-1)/PRX+1
                END IF
                IF (PRY-INT(PRY).EQ.0.) THEN
                   IMY = (KR-1)/INT(PRY)+1
                ELSE
                   IMY = (KR-1)/PRY+1
                END IF
                IM = NCX*(IMY-1)+IMX
C *** end procedure CALCOR
C
                P(KOSTE,4) = FON(IM)
                IF (BETA.GT.0) THEN
                   RAG = SIGMA*SQRT((AIN/P(KOSTE,3))**(-1./BETA)-1.)
                ELSE
                   RAG = SIGMA*SQRT(ALOG(P(KOSTE,3)/AIN)/(4*ALOG(2.)))
                END IF
                RAMA       = AMAX1(RAMA,RAG)
                RA         = RA+RAG
                P(KOSTE,5) = RAG
                FLB        = 0
                FDX        = J.EQ.1.OR.J.EQ.IDX
                FDY        = KR.EQ.1.OR.KR.EQ.IDY
                IF (FDX.OR.FDY) FLB = 2
                P(KOSTE,6) = FLB
C *** end procedure PARSAT
C
             END IF
  210     CONTINUE
          IK = KOSTE-1
  215     CONTINUE    
          LF = 0
C
          DO 220 I = 1,IK
             VLO = P(I,2).GT.P(I+1,2)
             IF (VLO .OR. (P(I,2).EQ.P(I+1,2) .AND. 
     2          P(I,1).GT.P(I+1,1))) THEN
                DO 221 KK = 1,6
                   A         = P(I,KK)
                   P(I,KK)   = P(I+1,KK)
                   P(I+1,KK) = A
 221            CONTINUE
                LK = I
                LF = 1
             END IF
 220      CONTINUE
          IK = LK
          IF (LF.EQ.1) THEN
             GO TO 215
          ENDIF
C
C ***  ordina stelle
          IF (KOSTE.GT.0) THEN
             ILA = 0
             J   = KOSTE
             CALL CATDRD(TIDCAT,KN,NSF,IB,A,RAME,IXR,IYR,IDX,IDY,A1,
     2                   A2,A3,A4,IA5,IA6)
             I   = KN
             IW  = I+J
             WRITE(STRING,9020) IW,J 
             CALL STTPUT(STRING,IST)
C
  301        CONTINUE
             IF (I.LT.1.OR.ILA.NE.0) GO TO 300
                CALL CATTRD(TIDCAT,I,IGRP,X,Y,H,F,R,FL,A1,A2,A3,A4,
     2                      A5,A6,A7)
                I = I-1
                IF (Y.GT.P(J,2).OR.(Y.EQ.P(J,2).AND.X.GT.P(J,1))) THEN
                   IGRP = IW
                   IF (H.GT.999999.) H = 999999.
                   CALL CATTWR(TIDCAT,IW,IGRP,X,Y,H,F,R,FL,F,AB1,
     2                         SIGMA,BETA,SAT,AIN,FONM)
                   IW = IW-1

                ELSE
  302              CONTINUE
                      IF (P(J,2).LE.Y .AND. (P(J,2).NE.Y .OR. 
     2                   P(J,1).LE.X) .OR. ILA.NE.0) GO TO 303
                      IGRP = IW
                      IF (P(J,3).GT.999999.) P(J,3) = 999999.
                      CALL CATTWR(TIDCAT,IW,IGRP,P(J,1),P(J,2),P(J,3),
     2                            P(J,4),P(J,5),P(J,6),P(J,4),AB1,
     2                            SIGMA,BETA,SAT,AIN,FONM)
                      IW = IW-1
                      J  = J-1
                      IF (J.EQ.0) ILA = 1
                   GO TO 302
C
  303              CONTINUE
                   IGRP = IW
                   IF (H.GT.999999.) H = 999999.
                   CALL CATTWR(TIDCAT,IW,IGRP,X,Y,H,F,R,FL,F,AB1,
     2                         SIGMA,BETA,SAT,AIN,FONM)
                   IW = IW-1
                END IF
             GO TO 301

  300        CONTINUE
             IF (J.GT.0) THEN
                DO 310 I2 = 1,J
                   IGRP = I2
                   IF (P(I2,3).GT.999999.) P(I2,3)=999999.
                   CALL CATTWR(TIDCAT,I2,IGRP,P(I2,1),P(I2,2),P(I2,3),
     2                         P(I2,4),P(I2,5),P(I2,6),P(I2,4),AB1,
     3                         SIGMA,BETA,SAT,AIN,FONM)
  310          CONTINUE
             END IF
             RAME = (RAME*KN+RA)/(KN+KOSTE)
             KN   = KN+KOSTE
             IDUM = 0
             CALL CATDWR(TIDCAT,KN,NSF,IDUM,RAMA,RAME,IXR,IYR,IDX,IDY,
     2                          A1,A2,A3,A4,IXW,IYW)
          END IF
       END IF
C
C *** close files
       CALL TBTCLO(TIDSKY,ISTAT)
       CALL TBSINI(TIDCAT,ISTAT)
       CALL TBTCLO(TIDCAT,ISTAT)
       CALL STSEPI
       END

C @(#)necexor.for	19.1 (ESO-DMD) 02/25/03 14:20:22
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  21:13 - 3 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: D.PONZ
C
C.IDENTIFICATION
C  program  ECHEXOR  version 1.2 840114
C
C.KEYWORDS
C
C  ECHELLE, CASPEC, DATA EXTRACTION
C
C.PURPOSE
C
C  EXTRACT ECHELLE ORDERS IN CASPEC IMAGES. ORDER POSITION ARE DEFINED
C  BY COEFFICIENTS OF A REGRESSION. SLIT WIDTH, ANGLE AND OFFSET
C  ARE DEFINED BY PARAMETERS
C            WIDTH,ANGLE,OFFSET
C
C.ALGORITHM
C
C   ORDERS ARE EXTRACTED BY PASSING A NUMERICAL SLIT OF GIVEN WIDTH 
C  AND ANGLE IN POSITIONS DEFINED BY THE REGRESSION COEFFS. THE SLIT
C  WILL SAMPLE AT INCREMENTS OF ONE STEP IN X.
C
C  THERE ARE THREE METHODS :
C   LINEAR   - PIXEL VALUES ARE ADDED, LINEAR INTERPOLATION
C   AVERAGE  - PIXEL VALUES ARE AVERAGED, LINEAR INTERPOLATION
C   WEIGHTED - PIXEL VALUES ARE WEIGHTD PROPORTIONALLY TO THE
C              PROFI PERPENDICULAR TO THE DISPERSION DIRECTION
C.INPUT/OUTPUT
C
C   EXTRACT/ORDER output = input width,angle,offset 
C				 table coeffs [ord1,ord2]
C  the connection file contains
C  IN_A   input FRM
C  IN_B   input table with coeffs
C  OUT_A  output FRM
C  INPUTR  width,angle
C  INPUTC  coeffs
C  INPUTI  ord1,ord2
C  ACTION               T - table option
C                       B - batch order by order
C 
C 
C 010123		last modif
C 
C------------------------------------------------------------------
C
      PROGRAM ECHEXO
C 
      IMPLICIT NONE
C 
      INTEGER NDIM
      PARAMETER (NDIM=2)
      INTEGER MADRID, NAC, NAR, IMNO
      INTEGER NWDTH
      INTEGER I,IAV,INDX,IORD,IORD1
      INTEGER IORD2,ISTAT,NA,NAXISA,NAXISB
      INTEGER NCOL,NPAR,NROW,NSORT
      INTEGER*8 PNTRA
      INTEGER*8 PNTRB
      INTEGER*8 PNTRC
      INTEGER   STATUS,TID,INO,TMPID
      INTEGER NPIXA(3),NPIXB(3),IPAR(10),KUN,KNUL
C
      DOUBLE PRECISION STEPA(3),STEPB(3), STARTA(3),STARTB(3)
      REAL  RPAR(10)
      REAL  CUTS(6)
      REAL XMIN,XMAX,XMIN1,XMAX1
      REAL PARAMS(12)
C
      DOUBLE PRECISION DPAR(100)
C
      CHARACTER*72   IDENA,IDENB
      CHARACTER*64   CUNITA,CUNITB,DESNAM
      CHARACTER*1    METH
      CHARACTER*60   FRMIN,FRMOUT,INA1,INA2
      CHARACTER*60   TABLE,NAME,TYPE
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      DATA CUNITB/
     +     'FLUX            PIXEL                           ORDER'/
C
C  initialize system
C
      CALL STSPRO('ECHEXO')
      CALL STKRDC('IN_A',1,1,60,I,INA1,KUN,KNUL,STATUS)
      CALL STKRDC('IN_B',1,1,60,I,TABLE,KUN,KNUL,STATUS)
      CALL STKRDC('IN_C',1,1,1,I,METH,KUN,KNUL,STATUS)
      CALL STKRDC('OUT_A',1,1,60,I,INA2,KUN,KNUL,STATUS)
      CALL STKRDC('INPUTC',1,1,60,I,NAME,KUN,KNUL,STATUS)
      CALL STKRDR('INPUTR',1,3,I,RPAR,KUN,KNUL,STATUS)
      CALL STKRDI('INPUTI',1,2,I,IPAR,KUN,KNUL,STATUS)
      IORD1  = IPAR(1)
      IORD2  = IPAR(2)
      FRMIN = INA1
      FRMOUT = INA2
      IF (METH(1:1) .EQ. 'l') METH = 'L'
      IF (METH(1:1) .EQ. 'a') METH = 'A'
      IF (METH(1:1) .EQ. 'm') METH = 'M'
C
C  input parameters in table
C
      CALL TBTOPN(TABLE,F_U_MODE,TID,STATUS)
      CALL TBIGET(TID,NCOL,NROW,NSORT,NAC,NAR,STATUS)
C
C  map input FRM
C
      CALL STIGET(FRMIN,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     .            NDIM,NAXISA,NPIXA,STARTA,STEPA,IDENA,
     +            CUNITA,PNTRA,IMNO,STATUS)
      PARAMS(1) = RPAR(1)/ABS(STEPA(2))
      PARAMS(2) = RPAR(2)
      PARAMS(3) = RPAR(3)/ABS(STEPA(2))

      IF (METH(1:1) .EQ. 'M') THEN
         NWDTH = PARAMS(1) + 2
         CALL STFCRE('column',D_R4_FORMAT,F_X_MODE,1,NWDTH,TMPID,STATUS)
         CALL STFMAP(TMPID,F_X_MODE,1,NWDTH,IAV,PNTRC,STATUS)
      ENDIF
C
C  read coeffs
C
      NAME   = NAME(1:59)//' '
      INDX   = INDEX(NAME,' ') - 1
      DESNAM = NAME(1:INDX)//'C'
      CALL STDRDC(TID,DESNAM,1,17,4,IAV,TYPE,KUN,KNUL,ISTAT)
      TYPE   = 'MULT'
      IF (TYPE.EQ.'MULT') THEN
         DESNAM = NAME(1:INDX)//'I'
         CALL STDRDI(TID,DESNAM,4,4,IAV,IPAR,KUN,KNUL,ISTAT)
         NA     = (IPAR(3)+1)* (IPAR(4)+1)
         DESNAM = NAME(1:INDX)//'R'
         CALL STDRDR(TID,DESNAM,1,4,IAV,PARAMS(4),KUN,KNUL,ISTAT)
         DESNAM = NAME(1:INDX)//'D'
         CALL STDRDD(TID,DESNAM,1,NA,IAV,DPAR,KUN,KNUL,ISTAT)
         CALL TBTCLO(TID,STATUS)
C
C ... map output FRM
C
         IF (IORD1.EQ.IORD2 .AND. IORD1.EQ.0) THEN
            IORD1  = PARAMS(6)
            IORD2  = PARAMS(7)
         END IF
         STARTB(1) = STARTA(1)
         STARTB(2) = IORD1
         STEPB(1)  = STEPA(1)
         STEPB(2)  = 1.
         IDENB     = IDENA
         NAXISB    = 2
         NPIXB(1)  = NPIXA(1)
         NPIXB(2)  = IORD2 - IORD1 + 1
         CALL STIPUT(FRMOUT,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +        NAXISB,NPIXB,STARTB,
     +        STEPB,IDENB,CUNITB,PNTRB,INO,STATUS) 
C     
C  extract order
C
         NPAR      = 10
         PARAMS(8) = IPAR(3)
         PARAMS(9) = IPAR(4)
         XMIN      = 1.E30
         XMAX      = -XMIN
         DO 10 I = IORD1,IORD2
            
            PARAMS(10) = I
            IORD       = I - IORD1 + 1
            
            IF (METH(1:1) .EQ. 'M') THEN
               CALL EXTR2M(MADRID(PNTRA),NPIXA(1),NPIXA(2),
     +              MADRID(PNTRB),NPIXB(1),NPIXB(2),MADRID(PNTRC),NWDTH,
     +              IORD,NPAR,PARAMS,NA,DPAR,XMIN1,XMAX1,METH,
     +              STARTA,STEPA)
            ELSE
               CALL EXTR1M(MADRID(PNTRA),NPIXA(1),NPIXA(2),
     +              MADRID(PNTRB),NPIXB(1),NPIXB(2),
     +              IORD,NPAR,PARAMS,NA,DPAR,XMIN1,XMAX1,METH,
     +              STARTA,STEPA)
            ENDIF

            XMIN   = AMIN1(XMIN,XMIN1)
            XMAX   = AMAX1(XMAX,XMAX1)
 10      CONTINUE
      ELSE
         CALL STTPUT(' Error in dispersion coefficients ')
         GO TO 20
      END IF
C
C  descriptor handling
C
      CUTS(1) = XMIN
      CUTS(2) = XMAX
      CUTS(3) = XMIN
      CUTS(4) = XMAX
      CUTS(5) = 0.
      CUTS(6) = 0.
      CALL DSCUPT(IMNO,INO,' ',STATUS)
      CALL STDWRR(INO,'LHCUTS',CUTS,1,6,KUN,STATUS)
C
C  free data
C
C      CALL STFCLO(INO,STATUS)
 20   CALL STSEPI
      END

      SUBROUTINE EXTR1M(IN,NPIXA1,NPIXA2,OUT,NB1,NB2,INDX,NPAR,PAR,ND,
     +     DPAR,XMIN,XMAX,METH,STARTA,STEPA)
C
C       EXTRACTION ROUTINE - BILINEAR INTERPOLATION
C
C   ARGUMENTS
C IN     REAL*4  INPUT IMAGE
C NPIXA1 INTG*4  NO. OF SAMPLES
C NPIXA2 INTG*4  NO. OF LINES
C OUT    REAL*4  EXTRACTED ORDERS
C NB1    INTG*4  NO. OF SAMPLES
C NB2    INTG*4  NO. OF ORDERS
C INDX   INTG*4  SEQUENTIAL NO. OF THE ORDER
C NPAR   INTG*4  NO. OF EXTRACTION PARAMETERS
C PAR    REAL*4  EXTRACTION PARAMETERS
C ND     INTG*4  NO. OF COEFFS.
C DPAR   REAL*8  COEFFS. TO DEFINE ORDER POSITION
C XMIN   REAL*4  MINIMUM VALUE
C XMAX   REAL*4  MAXIMUMVALUE
C
      IMPLICIT NONE
C 
      INTEGER  NB1, NB2, NPAR, NPIXA1, NPIXA2, ND
      INTEGER  LOSLIT, HISLIT
      INTEGER  NWW, IWIDTH, IYLIM, NX, N1, N2, K, L, IX, INDX
      INTEGER  IX1, IP, L1, K1, IW
C 
      REAL OUT(NB1,NB2),PAR(NPAR)
      REAL IN(NPIXA1,NPIXA2)
      REAL XMIN,XMAX
C 
      DOUBLE PRECISION DPAR(ND),STARTA(2),STEPA(2)
      DOUBLE PRECISION XVAL,YVAL,AX
      DOUBLE PRECISION WIDTH,SKEW,HWIDTH,OFFSET,DC
      DOUBLE PRECISION YV,WW(50)
      DOUBLE PRECISION SKWDX,SKWDY,SKWOF,SUM
      DOUBLE PRECISION DEGREE,DD,DSIN,DCOS
      DOUBLE PRECISION YLOW, YHIGH, WSUM
C 
      LOGICAL IF1D
C 
      CHARACTER*1      METH
C 
      DOUBLE PRECISION IX_R8R8, XI_R8R8
C
C     DEGREE = RAD / DEGREE
C
      DATA DEGREE/0.017453292519943295769237D+0/
C

      NWW    = 50
C
C ... define extraction constants
C
      WIDTH  = PAR(1)
      IWIDTH = WIDTH
      HWIDTH = 0.5*WIDTH
      SKEW   = PAR(2)
      SKWDX  = 0.0
      SKWDY  = 1.0
      SKWOF  = 0.0
      XMIN   = 0.0
      XMAX   = XMIN
C      OFFSET = PAR(3) - HWIDTH + 0.5
      OFFSET = PAR(3)
      IF (SKEW.NE.0.0) THEN       
         DD      = SKEW*DEGREE
         SKWDX  = -DSIN(DD)     !   DX PER PIXEL
         SKWDY  = DCOS(DD)      !   DY PER PIXEL
         SKWOF  = -SKWDX*HWIDTH !   2D INTERPOLATION
         IF1D   = .FALSE.
      END IF
      AX     = 1.D0 + SKWOF
      IYLIM  = NPIXA2 - IWIDTH
      NX     = SKWOF
      N1     = NX
      N2     = NPIXA1 - NX
C
C ... get ordinate values
C
      K      = PAR(8)
      L      = PAR(9)
      YV     = PAR(10)
C
C ... loop over the samples
C
      DO 10 IX = 1,N1
         OUT(IX,INDX) = 0.
 10   CONTINUE

      DO 100 IX = N2 + 1,NPIXA1
         OUT(IX,INDX) = 0.
 100  CONTINUE

      DO 50 IX1 = N1 + 1,N2

         IP     = 0
         DC     = 1.D0
         YVAL   = 0.D0
         XVAL   = IX_R8R8(AX,STARTA(1),STEPA(1))

C Computes position of the center of the slit from the coefficients of
C the bivariate polynomial stored in table order.

         DO 30 L1 = 0,L
            IP     = IP + 1
            WW(IP) = DC
            YVAL   = YVAL + WW(IP)*DPAR(IP)
            DO 20 K1 = 1,K
               IP     = IP + 1
               WW(IP) = WW(IP-1)*XVAL
               YVAL   = YVAL + WW(IP)*DPAR(IP)
 20         CONTINUE
            DC     = DC*YV
 30      CONTINUE
C
C Corrects the central position for the offset
C OFFSET does not take into account HWIDTH 
C
         YVAL   = XI_R8R8(YVAL,STARTA(2),STEPA(2)) + OFFSET
C     
         YLOW   = YVAL - HWIDTH
         YHIGH  = YVAL + HWIDTH
         LOSLIT = INT(YLOW)
         HISLIT = INT(YHIGH)

         IF (LOSLIT.LT.1)      LOSLIT = 1
         IF (HISLIT.GT.NPIXA2) HISLIT = NPIXA2

         SUM    = 0.D0
         WSUM   = 0.D0
         IX     = INT(AX)
C
         IF (LOSLIT.EQ.HISLIT) THEN
            SUM = (YHIGH-YLOW)*IN(IX,LOSLIT)
C
         ELSE
C
            DO 40 IW = LOSLIT,HISLIT
               
               IF (IW.EQ.LOSLIT) THEN
                  SUM = SUM + IN(IX,IW)*(LOSLIT+1.-YLOW)
                  
               ELSE IF (IW.EQ.HISLIT) THEN
                  SUM = SUM + IN(IX,IW)*(YHIGH-HISLIT)

               ELSE
                  SUM = SUM + IN(IX,IW)

               ENDIF


 40         CONTINUE
C
         ENDIF
C
         IF (METH(1:1) .EQ. 'L') THEN ! Linear extraction
            OUT(IX1,INDX) = SUM
         ELSE                   ! Average extraction
            OUT(IX1,INDX) = SUM/WIDTH
         ENDIF
         XMIN   = AMIN1(XMIN,OUT(IX1,INDX))
         XMAX   = AMAX1(XMAX,OUT(IX1,INDX))
         AX     = AX + 1.D0
 50   CONTINUE

      RETURN

      END



      SUBROUTINE EXTR2M(IN,NPIXA1,NPIXA2,OUT,NB1,NB2,COL,NWDTH,INDX,NPAR
     $     ,PAR,ND,DPAR,XMIN,XMAX,METH,STARTA,STEPA)
C
C       EXTRACTION ROUTINE - MEDIAN
C
C   ARGUMENTS
C IN     REAL*4  INPUT IMAGE
C NPIXA1 INTG*4  NO. OF SAMPLES
C NPIXA2 INTG*4  NO. OF LINES
C OUT    REAL*4  EXTRACTED ORDERS
C NB1    INTG*4  NO. OF SAMPLES
C NB2    INTG*4  NO. OF ORDERS
C INDX   INTG*4  SEQUENTIAL NO. OF THE ORDER
C NPAR   INTG*4  NO. OF EXTRACTION PARAMETERS
C PAR    REAL*4  EXTRACTION PARAMETERS
C ND     INTG*4  NO. OF COEFFS.
C DPAR   REAL*8  COEFFS. TO DEFINE ORDER POSITION
C XMIN   REAL*4  MINIMUM VALUE
C XMAX   REAL*4  MAXIMUMVALUE
C
      IMPLICIT NONE
C 
      INTEGER  NB1, NB2, NPAR, NPIXA1, NPIXA2, NWDTH, NWDTH2, ND
      INTEGER  NWW, IWIDTH, IYLIM, NX, N1, N2, K, L, IX, INDX
      INTEGER  IX1, IP, L1, K1, IW
      INTEGER  LOSLIT, HISLIT
C 
      REAL OUT(NB1,NB2),PAR(NPAR)
      REAL IN(NPIXA1,NPIXA2),COL(NWDTH)
      REAL XMIN,XMAX,LIMITS(2)
C 
      DOUBLE PRECISION DPAR(ND),STARTA(2),STEPA(2)
      DOUBLE PRECISION XVAL,YVAL,AX
      DOUBLE PRECISION WIDTH,SKEW,HWIDTH,OFFSET,DC
      DOUBLE PRECISION YV,WW(50)
      DOUBLE PRECISION SKWDX,SKWDY,SKWOF,SUM
      DOUBLE PRECISION DEGREE,DD,DSIN,DCOS
      DOUBLE PRECISION YLOW, YHIGH, WSUM
      DOUBLE PRECISION IX_R8R8, XI_R8R8
C 
      LOGICAL IF1D
C 
      CHARACTER*1      METH
      CHARACTER*80   OUTPUT
C
C     DEGREE = RAD / DEGREE
C
      DATA DEGREE/0.017453292519943295769237D+0/
      DATA LIMITS/0.0,0.0/
C     

      NWW    = 50
C
C ... define extraction constants
C
      WIDTH  = PAR(1)
      IWIDTH = WIDTH
      HWIDTH = 0.5*WIDTH
      NWDTH2 = HWIDTH
      SKEW   = PAR(2)
      SKWDX  = 0.0
      SKWDY  = 1.0
      SKWOF  = 0.0
      XMIN   = 0.0
      XMAX   = XMIN
C      OFFSET = PAR(3) - HWIDTH + 0.5
      OFFSET = PAR(3)
      IF (SKEW.NE.0.0) THEN       
          DD      = SKEW*DEGREE
          SKWDX  = -DSIN(DD)      !   DX PER PIXEL
          SKWDY  = DCOS(DD)       !   DY PER PIXEL
          SKWOF  = -SKWDX*HWIDTH  !   2D INTERPOLATION
          IF1D   = .FALSE.
      END IF
      AX     = 1.D0 + SKWOF
      IYLIM  = NPIXA2 - IWIDTH
      NX     = SKWOF
      N1     = NX
      N2     = NPIXA1 - NX
C
C ... get ordinate values
C
      K      = PAR(8)
      L      = PAR(9)
      YV     = PAR(10)
C
C ... loop over the samples
C
      DO 10 IX = 1,N1
         OUT(IX,INDX) = 0.
 10   CONTINUE

      DO 100 IX = N2 + 1,NPIXA1
         OUT(IX,INDX) = 0.
 100  CONTINUE

      DO 50 IX1 = N1 + 1,N2

         IP     = 0
         DC     = 1.D0
         YVAL   = 0.D0
         XVAL   = IX_R8R8(AX,STARTA(1),STEPA(1))

C Computes position of the center of the slit from the coefficients of
C the bivariate polynomial stored in table order.

         DO 30 L1 = 0,L
            IP     = IP + 1
            WW(IP) = DC
            YVAL   = YVAL + WW(IP)*DPAR(IP)
            DO 20 K1 = 1,K
               IP     = IP + 1
               WW(IP) = WW(IP-1)*XVAL
               YVAL   = YVAL + WW(IP)*DPAR(IP)
 20         CONTINUE
            DC     = DC*YV
 30      CONTINUE
C
C Corrects the central position for the offset
C OFFSET does not take into account HWIDTH 
C
         YVAL   = XI_R8R8(YVAL,STARTA(2),STEPA(2)) + OFFSET
C     
         YLOW   = YVAL - HWIDTH
         YHIGH  = YVAL + HWIDTH
         LOSLIT = INT(YLOW)
         HISLIT = INT(YHIGH)

         IF (LOSLIT.LT.1)      LOSLIT = 1
         IF (HISLIT.GT.NPIXA2) HISLIT = NPIXA2

         SUM    = 0.D0
         WSUM   = 0.D0
         IX     = INT(AX)
C
         IF (LOSLIT.EQ.HISLIT) THEN
            OUT(IX1,INDX) = IN(IX,LOSLIT)
         ELSE
            K1 = 0
            DO 40 IW = LOSLIT,HISLIT
               K1 = K1 + 1
               IF (IW.EQ.LOSLIT) THEN
                  COL(K1) = IN(IX,IW)!*(LOSLIT+1.-YLOW)
               ELSE IF (IW.EQ.HISLIT) THEN
                  COL(K1) = IN(IX,IW)!*MIN(1.0,YHIGH-HISLIT)
               ELSE
                  COL(K1) = IN(IX,IW)
               ENDIF
 40         CONTINUE            !determine MEDIAN:
            L1 = K1 / 2
            IF (K1.GT.0) THEN
               CALL GET_MEDIAN(COL,NWDTH,K1,L1,OUT(IX1,INDX),IW)
               IF (IW.LT.0) THEN
                  WRITE(OUTPUT,12345) IX1,INDX
                  CALL STTPUT(OUTPUT)
               ENDIF
            ELSE
               OUT(IX1,INDX) = -1.0
            ENDIF
         ENDIF
C
         XMIN   = AMIN1(XMIN,OUT(IX1,INDX))
         XMAX   = AMAX1(XMAX,OUT(IX1,INDX))
         AX     = AX + 1.D0
 50   CONTINUE
C
      RETURN
C 
12345 FORMAT('ERROR at ',I5,',',I5,' occurred')
C
      END

      SUBROUTINE GET_MEDIAN(RA,N,NUSE,LL,VALU,STATUS)

      IMPLICIT NONE
C 
      INTEGER   N,LL,STATUS
      INTEGER   NUSE
C 
      REAL      RA(N),VALU
C 
      VALU = 0.0
      STATUS = 0
C 
      IF (NUSE.LE.3) THEN
         IF (NUSE.LT.1) THEN
            STATUS = -1
            RETURN
         ELSE IF (NUSE.LE.2) THEN
            STATUS = 2
            VALU = RA(1)
c            VALU = (RA(1) + RA(2))/2.0               !for ndim = 1,2, median is 1st elem.
            RETURN
         ELSE 
            STATUS = 3
            VALU = RA(2)               !for ndim = 3, median is 2nd elem.
            RETURN
         ENDIF
      ENDIF
C 
      CALL NSORT(RA,NUSE,LL,VALU)
      RETURN
C 
      END

C===========================================================================
C Copyright (C) 1995-2008 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C.VERSION
C 080724	last modif
C 
C
      SUBROUTINE INTFRI(VAL,NPL,IMAGE,SX,XS,NCUR,NDEG)             
C+++
C---
      IMPLICIT      NONE
      INTEGER       NPL
      REAL          VAL(NPL)
      REAL          IMAGE(4)          
      REAL          SX
      REAL          XS
      INTEGER       NCUR
      INTEGER       NDEG
C
      INTEGER       MAXC
      INTEGER       MAXT
      PARAMETER     (MAXC=100)
      PARAMETER     (MAXT=100000)
      INTEGER       IBAR
      INTEGER       BNMOD
      INTEGER       IAC
      INTEGER       ISTAT
      INTEGER       I
      INTEGER       INNER
      INTEGER       KA
      INTEGER       KUN
      INTEGER       LINET3
      INTEGER       MADRID(1)
      INTEGER       NPL1,NPL2,NPL3 
      INTEGER       NP1, NP2, NP3, NP4
      INTEGER       NPIX
      INTEGER       NPT
      REAL          AEQW
      REAL          ALICO3, ACONT3
      REAL          ALICO4, ACONT4
      REAL          ALINE, ALICO, ACONT 
      REAL          ALINT, AITKEN
      REAL          FLXFRC
      REAL          OUTP(10)  
      REAL          RC3, XC3, DX3
      REAL          RC4, XC4, DX4
      REAL          SX3, SX4
      REAL          XARG
      REAL          XCUR, YCUR
      REAL          XRANG
      REAL          XPC(MAXC),YPC(MAXC) 
      REAL          X(MAXT),Y(MAXT)
      REAL          WORK(MAXT)
      CHARACTER*80  TEXT,HEADER 
      CHARACTER     BIN*4
      LOGICAL       FIRST 
      INCLUDE       'MID_INCLUDE:PLTDEC.INC/NOLIST' 
      COMMON        /VMR/MADRID 
C
      DATA IBAR/1/
      DATA LINET3/3/
C
 9010 FORMAT(1X,5G13.6)
C
C *** start of executable code **********************************************
C     Now do the looping for cursers and interpolations
C     NCUR positions are asked for
      NPL1  = INT(MIN(IMAGE(1),IMAGE(2))) 
      NPL2  = INT(MAX(IMAGE(1),IMAGE(2))) 
      NPL3  = 1
      NPT   = ABS(NPL1-NPL2) + 1
C
C *** Now do the looping for cursers and integration
C     Actions: NCUR cursors are asked for
C     A space bar terminates this loop
      FIRST = .TRUE.

   30 CONTINUE
      DO 50 I = 1,NCUR
         CALL PTGCUR(XCUR,YCUR,KA,ISTAT)
         IF (KA.EQ.32) THEN                                 ! exit on space bar
            GO TO 120
         ELSE                                 ! correct input; store data point
            XPC(I) = XCUR
            YPC(I) = YCUR
            CALL PTDATA(5,0,0,XPC(I),YPC(I),0.0,1)
         END IF 
   50 CONTINUE
      CALL SORT2(XPC,YPC,NCUR)
C
C *** Determine the range effective for change (= the EXTREME cursors) 
      NP1 = NINT((XPC(1)-XS)/SX) + 1             ! pixel number corr. to cursor
      NP2 = NINT((XPC(NCUR)-XS)/SX) + 1
 
      IF (NP1.LT.NPL1) THEN
         NP1 = NPL1
      ENDIF
C
C *** Do the interpolation here and plot the line 
      IF (NDEG.LT.2) THEN
         DO 70 I = NP1,NP2
            XARG    = XS + FLOAT(I-1)*SX
            WORK(I) = ALINT(XPC,YPC,NCUR,XARG,1,NCUR) 
   70    CONTINUE
      ELSE

         DO 80 I = NP1,NP2 
            XARG    = XS + FLOAT(I-1)*SX
            WORK(I) = AITKEN(XPC,YPC,NCUR,XARG,1,NCUR,NDEG)               
   80    CONTINUE
      END IF
C
C *** get the bin option, plot and write the results
      CALL PTKRDC('BINMOD',4,IAC,BIN)
      IF (BIN(1:2).EQ.'ON') THEN
         BNMOD = 1
      ELSE
         BNMOD = 0
      ENDIF
      NPIX = NP2 - NP1 + 1
      DO 90 I = NP1,NP2
         X(I) = XS + FLOAT(I-1)*SX
         Y(I) = WORK(I)
   90 CONTINUE 
      CALL PTDATA(0,LINET3,BNMOD,X(NP1),Y(NP1),0.0,NPIX)
C
C *** Do the integration
C     FIRST compute the flux density in the first bin.
C     The bin limits are the input cursor position and the middle between
C     the first and second image pixel. We compute the interpolated values
C     at these points and make the integral in the first bin.
      INNER  = NCUR/2                               ! first inner pixel
      XC3    = XPC(INNER)                           ! real cursor position
      RC3    = (XC3-XS)/SX+1.0                      ! real cursor pixel
      NP3    = NINT((XC3-XS)/SX)+1                  ! nearest image pixel
      DX3    = FLOAT(NP3)-RC3
      SX3    = (DX3+0.5)*SX
      ACONT3 = SX3*WORK(NP3)
      ALICO3 = SX3*VAL(NP3)
C
C *** SECOND compute the flux density in the last bin.
C     The bin limits are the last cursor position and the middle between
C     the last and one but last image pixel. We compute the interpolated 
C     values at these points and make the integral in the last bin.
C     and then do the integration.
      XC4    = XPC(INNER+1)
      RC4    = (XC4-XS)/SX+1.0
      NP4    = NINT((XC4-XS)/SX)+1
      DX4    = RC4-FLOAT(NP4)
      SX4    = (DX4+0.5)*SX 
      ACONT4 = SX4*WORK(NP4)
      ALICO4 = SX4*VAL(NP4)
C
C *** do the pixel summation for continuum and line
      ACONT  = 0.
      ALICO  = 0.
      DO 110 I = NP3+1,NP4-1 
          ACONT = WORK(I)*SX + ACONT                                          
          ALICO = VAL(I)*SX + ALICO
  110 CONTINUE                  
      ACONT    = ACONT + ACONT3 + ACONT4
      ALICO    = ALICO + ALICO3 + ALICO4
      XRANG    = XPC(INNER+1)-XPC(INNER)
      ALINE    = ALICO - ACONT                                      
      AEQW     = -1.0*(ALINE/ACONT)*XRANG                          
      FLXFRC   = ALINE/ACONT
C ***
C
      IF (FIRST) THEN
          HEADER = '   X_start (pix/world)          '//
     2             ' X_end (pix/world)      Pixel sep. '
          CALL STTPUT(HEADER,ISTAT)
          HEADER = '  Line+Cont.   Continuum        '//
     2             'Line       Line/Cont    Equiv. w.  '
          CALL STTPUT(HEADER,ISTAT)
          HEADER = ' ---------------------------------------'//
     2             '-------------------------'
          CALL STTPUT(HEADER,ISTAT) 
          FIRST  = .FALSE.
      END IF 
      WRITE(TEXT,9010) XC3,RC3,XC4,RC4,SX
      CALL STTPUT(TEXT,ISTAT)

      WRITE(TEXT,9010) ALICO,ACONT,ALINE,FLXFRC,AEQW
      CALL STTPUT(TEXT,ISTAT)
C ***
C
      OUTP(1)  = RC3                                      ! first NUMBER
      OUTP(2)  = RC4                                      ! last pixel
      OUTP(3)  = XC3                                      ! first cursor 
      OUTP(4)  = XC4                                      ! last cursor 
      OUTP(5)  = SX                                       ! step in x
      OUTP(6)  = ALICO                                    ! line + cont
      OUTP(7)  = ACONT                                    ! continuum
      OUTP(8)  = ALINE                                    ! line
      OUTP(9)  = FLXFRC                                   ! flux fraction
      OUTP(10) = AEQW                                     ! equivalent width
      CALL STKWRR('OUTPUTR',OUTP,1,10,KUN,ISTAT)
      GO TO 30 

  120 CONTINUE
      RETURN
      END


      SUBROUTINE INTFRB(VAL,NPL,IMAGE,SX,XS,NCUR,NDEG,             
     2                  DELTAX,XPC)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.AUTHOR:   F. Murtagh, ST-ECF                                                 
C.VERSION:  860321 FM Creation
C.VERSION:  880607 RHW Restructured and recoded for portable MIDAS
C.VERSION:  900430 RHW Make code similar to INTFRI 
C.VERSION:  900430 RHW Store more output in the keyword OUTPUTR
C.VERSION:  900629 RHW Integration over subpixel included
C.VERSION:  910115 RHW IMPLICIT NONE added
C----------------------------------------------------------------------------
      IMPLICIT  NONE
      INTEGER   MAXC
      PARAMETER (MAXC=100)
C
      INTEGER   NPL
      REAL      VAL(NPL)
      REAL      IMAGE(4)          
      REAL      SX
      REAL      XS
      INTEGER   NCUR
      INTEGER   NDEG
      REAL      DELTAX
      REAL      XPC(MAXC)
C
      INTEGER   MAXT
      PARAMETER (MAXT=100000)
      INTEGER   ISTAT
      INTEGER   KUN
      INTEGER   I, I2, INNER
      INTEGER   NP1, NP2, NP3, NP4
      INTEGER   NPL1, NPL2, NPL3, NPT
      REAL      AITKEN, ALINE, ALINT
      REAL      ACONT, ALICO
      REAL      ACONT3, ACONT4, ALICO3, ALICO4
      REAL      AEQW
      REAL      DX3, DX4
      REAL      FLXFRC
      REAL      OUTP(10)                                            
      REAL      RC3, RC4
      REAL      SX3, SX4
      REAL      WORK(MAXT)
      REAL      XARG
      REAL      Y
      REAL      XC3, XC4
      REAL      XRANG
      REAL      YPC(MAXC) 
C
C *** start of executable code **********************************************
C     Now do the looping for cursers and interpolations.
C     NCUR positions are asked for.
      NPL1  = INT(MIN(IMAGE(1),IMAGE(2)))
      NPL2  = INT(MAX(IMAGE(1),IMAGE(2))) 
      NPL3  = 1 
      NPT   = ABS(NPL1-NPL2) + 1 
C
C *** loop through cursor position and determine nearest pixels
      DO 10 I = 1, NCUR 
         NP1 = NINT((XPC(I)-DELTAX-XS)/SX) + 1                             
         NP2 = NINT((XPC(I)+DELTAX-XS)/SX) + 1                             
         IF (NP1.LT.NPL1 .OR. NP1.GT.NPL2 .OR.
     2       NP2.LT.NPL1 .OR. NP2.GT.NPL2) THEN
             CALL STTPUT('*** FATAL: Cursor position(s) outside'//
     2                   ' frame; try again', ISTAT)
             CALL STSEPI
         ENDIF
         Y   = 0.0
         DO 20 I2 = NP1, NP2 
            Y = Y + VAL(I2)
   20    CONTINUE
         Y     = Y/FLOAT(NP2-NP1+1)
         YPC(I) = Y 
   10 CONTINUE 
      CALL SORT2(XPC,YPC,NCUR)
C
C *** Determine effective range of cursor positions
      NP1 = NINT((XPC(1)-XS)/SX) + 1                    ! first cursor position
      NP2 = NINT((XPC(NCUR)-XS)/SX) + 1                 ! last cursor position
C
C *** Do the interpolation here
      IF (NDEG.LT.2) THEN                              !compute the continuum
         DO 30 I = NP1,NP2
            XARG    = XS + FLOAT(I-1)*SX
            WORK(I) = ALINT(XPC,YPC,NCUR,XARG,1,NCUR)
   30    CONTINUE
     
       ELSE
         DO 40 I = NP1,NP2
            XARG    = XS + FLOAT(I-1)*SX             
            WORK(I) = AITKEN(XPC,YPC,NCUR,XARG,1,NCUR,NDEG)
   40    CONTINUE
      ENDIF
C
C *** Do the integration 
C     FIRST compute the flux density in the first bin.
C     The bin limits are the input cursor position and the middle between
C     the first and second image pixel. We compute the interpolated values
C     at these points and make the integral in the first bin.
      INNER  = NCUR/2                               ! first inner pixel
      XC3    = XPC(INNER)                           ! real cursor position
      RC3    = (XC3-XS)/SX+1.0                      ! real cursor pixel
      NP3    = NINT((XC3-XS)/SX)+1                  ! nearest image pixel
      DX3    = FLOAT(NP3)-RC3
      SX3    = (DX3+0.5)*SX
      ACONT3 = SX3*WORK(NP3)
      ALICO3 = SX3*VAL(NP3)
C
C *** SECOND compute the flux density in the last bin.
C     The bin limits are the last cursor position and the middle between
C     the last and one but last image pixel. We compute the interpolated 
C     values at these points and make the integral in the last bin.
C     and then do the integration.
      XC4    = XPC(INNER+1)
      RC4    = (XC4-XS)/SX+1.0
      NP4    = NINT((XC4-XS)/SX)+1
      DX4    = RC4-FLOAT(NP4)
      SX4    = (DX4+0.5)*SX 
      ACONT4 = SX4*WORK(NP4)
      ALICO4 = SX4*VAL(NP4)
C
C *** do the pixel summation for continuum and line
      ACONT  = 0.
      ALICO  = 0.
      DO 50 I = NP3+1,NP4-1                                                    
          ACONT = WORK(I)*SX + ACONT                                          
          ALICO = VAL(I)*SX + ALICO
   50 CONTINUE                  
      ACONT    = ACONT + ACONT3 + ACONT4
      ALICO    = ALICO + ALICO3 + ALICO4
      XRANG    = XPC(INNER+1)-XPC(INNER)
      ALINE    = ALICO - ACONT                                      
      AEQW     = -1.0*(ALINE/ACONT)*XRANG                          
      FLXFRC   = ALINE/ACONT
C ***
C
      OUTP(1)  = RC3                                      ! first NUMBER
      OUTP(2)  = RC4                                      ! last pixel
      OUTP(3)  = XC3                                      ! first cursor
      OUTP(4)  = XC4                                      ! last cursor 
      OUTP(5)  = SX                                       ! step in x
      OUTP(6)  = ALICO                                    ! line + cont
      OUTP(7)  = ACONT                                    ! continuum
      OUTP(8)  = ALINE                                    ! line
      OUTP(9)  = FLXFRC                                   ! flux fraction
      OUTP(10) = AEQW                                     ! equivalent width
      CALL STKWRR('OUTPUTR',OUTP,1,10,KUN,ISTAT)
C
      RETURN
      END 

C @(#)fitbl.for	19.1 (ES0-DMD) 02/25/03 13:17:30
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
       SUBROUTINE FITBL
       INCLUDE 'MID_INCLUDE:FITI.INC'
       INCLUDE 'MID_INCLUDE:FITC.INC'
      
       FZFNAM(1) = 'POLY'
       FZFNAM(2) = 'LOG'
       FZFNAM(3) = 'EXP'
       FZFNAM(4) = 'SIN'
       FZFNAM(5) = 'TAN'
       FZFNAM(6) = 'SINH'
       FZFNAM(7) = 'TANH'
       FZFNAM(8) = 'ASIN'
       FZFNAM(9) = 'ATAN'
       FZFNAM(10) = 'ASINH'
       FZFNAM(11) = 'ATANH'
       FZFNAM(12) = 'BOX'
       FZFNAM(13) = 'TRIANG'
       FZFNAM(14) = 'POISSON'
       FZFNAM(15) = 'GAUSS'
       FZFNAM(16) = 'CAUCHY'
       FZFNAM(17) = 'LORENTZ'
       FZFNAM(18) = 'VOIGT'
       FZFNAM(19) = 'LOGPROF'
       FZFNAM(20) = 'EXPPROF' 
       FZFNAM(21) = 'FEXPINT'
       FZFNAM(22) = 'ERF'
       FZFNAM(23) = 'SINC'
       FZFNAM(24) = 'SINCS'
       FZFNAM(25) = 'FRANZ'
       FZFNAM(26) = 'HUBBLE'
       FZFNAM(27) = 'KING'
       FZFNAM(28) = 'RQUART'
       FZFNAM(29) = 'BRAND'
       FZFNAM(30) = 'USER00'
       FZFNAM(31) = 'USER01'
       FZFNAM(32) = 'USER02'
       FZFNAM(33) = 'USER03'
       FZFNAM(34) = 'USER04'
       FZFNAM(35) = 'USER05'
       FZFNAM(36) = 'USER06'
       FZFNAM(37) = 'USER07'
       FZFNAM(38) = 'USER08'
       FZFNAM(39) = 'USER09'
       FZFNAM(40) = 'LAPLACE'
       FZFNAM(41) = 'LOGISTIC'
       FZFNAM(42) = 'SEMILOG'
       FZFNAM(43) = 'LOGNORM'
       FZFNAM(44) = 'PARETO'
       FZFNAM(45) = 'GAMMA'
       FZFNAM(46) = 'DIPOLE'
       FZFNAM(47) = 'IGAUSS'
       FZFNAM(48) = 'GAUSSA'
       FZFNAM(49) = 'IGAUSSA'
       FZFNAM(50) = 'MOFFAT'
       FZFPAR(1) = 0
       FZFPAR(2) = 3
       FZFPAR(3) = 3
       FZFPAR(4) = 3
       FZFPAR(5) = 3
       FZFPAR(6) = 3
       FZFPAR(7) = 3
       FZFPAR(8) = 3
       FZFPAR(9) = 3
       FZFPAR(10) = 3
       FZFPAR(11) = 3
       FZFPAR(12) = 3
       FZFPAR(13) = 3
       FZFPAR(14) = 2
       FZFPAR(15) = 0
       FZFPAR(16) = 3
       FZFPAR(17) = 4
       FZFPAR(18) = 3
       FZFPAR(19) = 3
       FZFPAR(20) = 3
       FZFPAR(21) = 3
       FZFPAR(22) = 2
       FZFPAR(23) = 3
       FZFPAR(24) = 3
       FZFPAR(25) = 0
       FZFPAR(26) = 3
       FZFPAR(27) = 3
       FZFPAR(28) = 3
       FZFPAR(29) = 3
       FZFPAR(30) = 0
       FZFPAR(31) = 0
       FZFPAR(32) = 0
       FZFPAR(33) = 0
       FZFPAR(34) = 0
       FZFPAR(35) = 0
       FZFPAR(36) = 0
       FZFPAR(37) = 0
       FZFPAR(38) = 0
       FZFPAR(39) = 0
       FZFPAR(40) = 3
       FZFPAR(41) = 3
       FZFPAR(42) = 3
       FZFPAR(43) = 4
       FZFPAR(44) = 4
       FZFPAR(45) = 4
       FZFPAR(46) = 3
       FZFPAR(47) = 3
       FZFPAR(48) = 0
       FZFPAR(49) = 3
       FZFPAR(50) = 7
       FERPAR = -600 
       FERFUN = -601       ! non defined function name
       FERTAB = -602       ! inp/out on different tables
       FERDAT = -603       ! data not available
       FERPFU = -604       ! error in function params.
       FERDUP = -605       ! duplicated param name
       FERCON = -606
       FZPPRN = 21
       FZIWGT = 13
       FZIBND = 14
       FZIMET = 15
       FZNAME =' '
       FZTYPE = ' '

       END

C  @(#)fitcon.for	19.1 (ESO-DMD) 02/25/03 13:17:46 
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FITCON(ALGOR,BNDTYP,ISTAT)                                    
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++        
C                                                                               
C.MODULE                                                                        
C       FIT                                                                     
C                                                                               
C.NAME                                                                          
C       FIT_CON                                                                 
C                                                                               
C.PURPOSE                                                                       
C   makes the interface between the MIDAS data structures and the NAG           
C   routines for non linear LSQ problems with constraints                       
C                                                                               
C.KEYWORDS                                                                      
C  Constrained Non-linear Least Square, Constrained Non-linear Fitting,         
C  Constrained Non-linear Regression, FIT/TABLE, FIT/IMAGE,                     
C  Corrected Gauss-Newton Method, Quasi-Newton Method, Modified                 
C  Gauss-Newton.                                                                
C                                                                               
C.DESCRIPTION                                                                   
C       Recovers qualifiers and parameters from MIDAS keywords;                 
C       Recovers bounds;                                                        
C       Give virtual memory for calculations in NAG routines;                   
C       Call the NAG routines for non-linear least squares problems;            
C       Display information messages;                                           
C       Compute errors on parameters.                                           
C ****
C CHECK CALLING SEQUENCE OF E04KAF,E04KBF,E04KCF,E04KDF
C     LAST TWO ARGUMENTS...
C ****
C                                                                               
C.RESTRICTIONS                                                                  
C       ...                                                                     
C                                                                               
C.LANGUAGE                                                                      
C       FORTRAN                                                                 
C                                                                               
C.CALLING SEQUENCE                                                              
C       CALL FITCON(ALGOR,BNDTYP,ISTAT)                                        
C                                                                               
C.INPUT PARAMETERS                                                              
C       ALGOR    (*)        CHARACTER   algorithm to be used.                   
C                           (CGNND,QN,MGN)                                      
C       BNDTYP   (*)        CHARACTER   Bounds types                            
C                           (P,G,I)                                             
C       ISTAT               INTEGER     exit status                             
C                                                                               
C.MODIFIED PARAMETERS                                                           
C       None                                                                    
C                                                                               
C.OUTPUT PARAMETERS                                                             
C       None                                                                    
C                                                                               
C.FILES                                                                         
C       FIT_NAG.INC/NOLIST                                                      
C                                                                               
C.MODULES CALLED                                                                
C       NAG library     (E04___)                                                
C       MINMSQ          (message display)                                       
C                                                                               
C.AUTHOR                                                                        
C       Ph. DEFERT,      Feb 1986                                               
C        M. Peron        Jul 1992                                             
C.MODIFICATIONS                                                                 
C                                                                               
C                                                                               
C.BIBLIOGRAPHY                                                                  
C       NAG Mark II Vol 3 (E04)                                                 
C       Algorithms for the Solution of non-linear least squares problem         
C          SIAM J. on Num. An.,15,977-992,1978                                  
C.VERSION
C 021122	last modif
C                                                                               
C-----------------------------------------------------------------------        
C 
C      IMPLICIT NONE                                                            
C     .. Scalar Arguments ..                                                    
      CHARACTER ALGOR* (*),BNDTYP* (*)                                          
      INTEGER ISTAT ,KUN,KNUL,TID,TID1
C     ..                                                                        
C     .. Scalars in Common ..                                                   
      INTEGER NRCOL,ISTAR                                                       
      CHARACTER WGTTYP*1                                                        
C     ..                                                                        
C     .. Arrays in Common ..                                                    
      INTEGER ICOL(10)                 
      INTEGER MADRID(1)                 
C     ..                                                                        
C     .. Local Scalars ..                                                       
      INTEGER I,IDAT,IFAIL1,IFAIL3,J,K,LIW,LW,NC,NROW,NRFEVA,           
     +        NRVM,NS,STATUS
      INTEGER IBOUND,LHSL,IMIN,IMAX,NRBND,ROUTIN                     
      INTEGER NAC,NAR,STAT,NAC1,NAR1,NBYT
      INTEGER*8 PTRW,PTRIW,PTRDLT,PTRHSL,PTRHSD,PTRSTA,PTRGRD

      DOUBLE PRECISION FSUMSQ
      DOUBLE PRECISION HMIN,HMAX

      LOGICAL VALID,ISEL,NOMPAR,VCMATPR                                         
      CHARACTER WGTKEY*10,LINE*78,BNDTAB*60                           

C     ..                                                                        
C     .. Local Arrays ..                                                        
      REAL XVAL(10)                                                             
      LOGICAL NULL(10)                                                          
C     ..                                                                        
C     ..                                                                        
C     .. External Files ..                                                      
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      INCLUDE 'MID_INCLUDE:FITNAGI.INC'                                 
      COMMON/VMR/MADRID
      COMMON /LSQFUN/ICOL,NRCOL,ISTAR,WGTTYP 
      INCLUDE 'MID_INCLUDE:FITNAGC.INC'                                 
      EXTERNAL E04LBS,E04JBQ,FUNCT3,FUNCT4,MINMON

      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
      DATA WGTKEY(1:10)/'FITCHAR   '/                                           

C                                                                               
C  Executable Statements                                                        
C                                                                               
C  Initialize parameters and compute number of fixed parameters                 
C                                                                               
      VCMATPR = METPAR(1) .LT. 0.                                               
      METPAR(1) = ABS(METPAR(1))                                                
      WRITE(6,*)METPAR(1)
      NRPFIX = 0                                                                
      DO 10 J = 1,NRPARAM                                                       
          IF (METPAR(2).GE.0) PARAM(J) = PARINI(J)                              
          IF (FIXPAR(J).GE.0) NRPFIX = NRPFIX + 1                               
   10 CONTINUE                                                                  
      METPAR(2) = ABS(METPAR(2))                                                
C                                                                               
C  Get the type of weighting from FITCHAR 13:13                                 
C                                                                               
      CALL STKRDC(WGTKEY,1,FZIWGT,1,K,WGTTYP,
     +    KUN,KNUL,ISTAT)
      CALL UPCAS(WGTTYP,WGTTYP)
      IF (WGTTYP(1:1).NE.'C' .AND. WGTTYP(1:1).NE.'W' .AND.                     
     +    WGTTYP(1:1).NE.'I' .AND. WGTTYP(1:1).NE.'S') CALL STETER(12,          
     +    'FIT/TABLE: Weight type mismatch')                                    
C                                                                               
      IF (FILTYP(1:1).EQ.'T') THEN                                              
C                                                                               
C  Get the selected columns for indep and dep variables                         
C                                                                               
          IF (WGTCOL.EQ.0) THEN                                                 
              ISTAR  = 2                                                        
              NRCOL  = NRIND + 1                                                
              ICOL(1) = 0                                                       
                                                                                
          ELSE                                                                  
              ISTAR  = 1                                                        
              NRCOL  = NRIND + 2                                                
              ICOL(1) = WGTCOL                                                  
          END IF                                                                
                                                                                
          ICOL(2) = DEPCOL                                                      
          NULL(1) = .FALSE.                                                     
          DO 20 I = 1,NRIND                                                     
              ICOL(I+2) = INDCOL(I)                                             
   20     CONTINUE                                                              
C                                                                               
C  Get number of selected rows in the table (nr of residuals)                   
C                                                                               
          NRDATA = 0                                                            
          CALL TBIGET(FZIDEN,NC,NROW,NS,NAC,NAR,STAT)                                 
          DO 40 IDAT = 1,NROW                                                   
              CALL TBSGET(FZIDEN,IDAT,ISEL,ISTAT)                              
              IF ( .NOT. ISEL) GO TO 40                                         
              CALL TBRRDR(FZIDEN,IDAT,NRCOL,ICOL(ISTAR),                  
     +                    XVAL(ISTAR),NULL,ISTAT)                              
              VALID  = ISEL                                                     
              DO 30 K = 1,NRCOL                                                 
                  VALID  = VALID .AND. ( .NOT. NULL(K))                         
   30         CONTINUE                                                          
              IF (VALID) NRDATA = NRDATA + 1                                    
   40     CONTINUE                                                              
                                                                                
      ELSE                                                                      
C                                                                               
C  Get the number of residuals for FIT/IMAG                                     
C                                                                               
          NRDATA = NRPIX(1)*NRPIX(2)*NRPIX(3)                                   
          NROW   = NRDATA                                                       
      END IF                                                                    
C                                                                               
C     Get qualifiers of the FIT command : PRINT,MAX. NR. Of F. EVAL,            
C     PRECISION,ETA and STEP. NOMPAR detects if method parameters               
C     have been given or are all to be defaulted.                               
C                                                                               
      NOMPAR = METPAR(1) .LT. 0.1                                               
      IF (ABS(ABS(METPAR(3))-999999.).LT.1.E-6) THEN                            
          METPAR(3) = 0.0                                                       
                                                                                
      ELSE                                                                      
          NOMPAR = .FALSE.                                                      
      END IF                                                                    
                                                                                
      IF (ABS(ABS(METPAR(2))-999999.).LT.1.E-6) THEN                            
          IF (ALGOR(1:5).EQ.'CGNND') THEN                                       
              METPAR(2) = 40*NRPARAM* (NRPARAM+5)                               
                                                                                
          ELSE IF (ALGOR(1:2).EQ.'QN') THEN                                     
              METPAR(2) = 100*NRPARAM                                           
                                                                                
          ELSE IF (ALGOR(1:3).EQ.'MGN') THEN                                    
              METPAR(2) = 50*NRPARAM                                            
          END IF                                                                
                                                                                
      ELSE                                                                      
          NOMPAR = .FALSE.                                                      
      END IF                                                                    
                                                                                
      IF (ABS(ABS(METPAR(4))-999999.).LT.1.E-6) THEN                            
          IF (NRPARAM.EQ.1) THEN                                                
              METPAR(4) = 0.                                                    
                                                                                
          ELSE                                                                  
              IF (ALGOR(1:5).EQ.'CGNND') THEN                                   
                  METPAR(4) = 0.5                                               
                                                                                
              ELSE IF (ALGOR(1:2).EQ.'QN') THEN                                 
                  METPAR(4) = 0.9                                               
                                                                                
              ELSE IF (ALGOR(1:3).EQ.'MGN') THEN                                
                  IF (NRPARAM.LT.10) THEN                                       
                      METPAR(4) = 0.5                                           
                                                                                
                  ELSE IF (NRPARAM.LE.20) THEN                                  
                      METPAR(4) = 0.1                                           
                                                                                
                  ELSE                                                          
                      METPAR(4) = 0.01                                          
                  END IF                                                        
                                                                                
              END IF                                                            
                                                                                
          END IF                                                                
                                                                                
      ELSE                                                                      
          NOMPAR = .FALSE.                                                      
      END IF                                                                    
                                                                                
      IF (ABS(ABS(METPAR(5))-999999.).LT.1.E-6) THEN                            
          METPAR(5) = 1.E05                                                     
                                                                                
      ELSE                                                                      
          NOMPAR = .FALSE.                                                      
      END IF                                                                    
C                                                                               
C   Get the bounds and store them in PARLOW and PARUPP                          
C                                                                               
      IF (BNDTYP(1:1).EQ.'G') THEN                                              
          IBOUND = 3                                                            
          CALL STKRDC('BNDTAB',1,1,60,K,BNDTAB,KUN,KNUL,ISTAT)                  
          IF (BNDTAB(1:1).EQ.'+') THEN
            CALL STTPUT('Bounds table not defined',ISTAT)
            CALL STSEPI
          ENDIF 
          CALL TBTOPN(BNDTAB,F_IO_MODE,TID,ISTAT)                             
          CALL TBIGET(TID,NC,NRBND,NS,NAC1,NAR1,ISTAT)                           
          IF (NC.LT.2) THEN                                                     
              CALL STETER(12,'FIT/... : Error in bounds table')                 
                                                                                
          ELSE IF (NC.GT.2) THEN                                                
              CALL STTPUT('*** WARN-FIT : Bounds table more than'//             
     +                    ' 2 columns, take first ones ***',ISTAT)
          END IF                                                                
                                                                                
          IF (NRBND.NE.1) THEN                                                  
              CALL STTPUT('*** WARN-FIT : Bounds table more than'//             
     +                    ' 1 row, global bounds taken as first one ***'        
     +                    ,ISTAT)                                              
          END IF                                                                
                                                                                
          CALL TBSGET(TID,1,ISEL,ISTAT)                                     
          ICOL(1) = 1                                                           
          ICOL(2) = 2                                                           
          CALL TBRRDR(TID,1,2,ICOL,                  
     +                    XVAL,NULL,ISTAT)                        
          VALID  = ISEL .AND. ((.NOT.NULL(1)) .OR. (.NOT.NULL(2)))              
          IF ( .NOT. VALID) CALL STETER(8,                                      
     +                           ' FIT/TABLE : Global bounds not founds'        
     +                                  )                                       
          IF ( .NOT. NULL(1)) THEN                                              
              PARLOW(1) = XVAL(1)                                               
                                                                                
          ELSE                                                                  
              PARLOW(1) = -1.D+6                                                
          END IF                                                                
                                                                                
          IF ( .NOT. NULL(2)) THEN                                              
              PARUPP(1) = XVAL(2)                                               
                                                                                
          ELSE                                                                  
              PARUPP(1) = 1.D+6                                                 
          END IF                                                                
                                                                                
          PARLOW(1) = XVAL(1)                                                   
          PARUPP(1) = XVAL(2)                                                   
          CALL STTPUT('   Lower Bound     Upper Bound',ISTAT)
          WRITE (LINE,9000) PARLOW(1),PARUPP(1)                                 
          CALL STTPUT(LINE,ISTAT)                                              
          CALL STTPUT(' ',ISTAT)                                               
                                                                                
      ELSE IF (BNDTYP(1:1).EQ.'I') THEN                                         
          IBOUND = 0                                                            
          CALL STKRDC('BNDTAB',1,1,60,K,BNDTAB,KUN,KNUL,ISTAT)   
          IF (BNDTAB(1:1).EQ.'+') THEN
            CALL STTPUT('Bounds table not defined',ISTAT)
            CALL STSEPI
          ENDIF 
          CALL TBTOPN(BNDTAB,F_IO_MODE,TID1,ISTAT)                          
          CALL TBIGET(TID1,NC,NRBND,NS,NAC1,NAR1,ISTAT)
          IF (NC.LT.2) THEN                                                     
              CALL STETER(12,'FIT/... : Error in bounds table')                 
                                                                                
          ELSE IF (NC.GT.2) THEN                                                
              CALL STTPUT('*** WARN-FIT : Bounds table more than'//             
     +                    ' 2 columns, take first ones ***',STATUS)             
          END IF                                                                
                                                                                
          IF (NRBND.GT.NRPARAM) THEN                                            
              CALL STTPUT('*** WARN-FIT : Bounds table has more '//             
     +                    'rows than parameters, take first ones ***',          
     +                    STATUS)                                               
          END IF                                                                
                                                                                
          DO 50 IDAT = 1,MIN0(NRBND,NRPARAM)                                    
              CALL TBSGET(TID1,IDAT,ISEL,STATUS)                              
              IF (ISEL) THEN                                                    
                  ICOL(1) = 1                                                   
                  ICOL(2) = 2                                                   
                  CALL TBRRDR(TID1,IDAT,2,ICOL,                  
     +                    XVAL,NULL,ISTAT)                        
               IF ( .NOT. NULL(1)) THEN                                      
                      PARLOW(IDAT) = XVAL(1)                                    
                                                                                
                  ELSE                                                          
                      PARLOW(IDAT) = -1.D+6                                     
                  END IF                                                        
                                                                                
                  IF ( .NOT. NULL(2)) THEN                                      
                      PARUPP(IDAT) = XVAL(2)                                    
                                                                                
                  ELSE                                                          
                      PARUPP(IDAT) = 1.D+6                                      
                  END IF                                                        
                                                                                
              ELSE                                                              
                  PARLOW(IDAT) = -1.D+6                                         
                  PARUPP(IDAT) = 1.D+6                                          
              END IF                                                            
                                                                                
   50     CONTINUE                                                              
          IF (NRBND.LT.NRPARAM) THEN                                            
              DO 60 IDAT = NRBND + 1,NRPARAM                                    
                  PARLOW(IDAT) = -1.D+6                                         
                  PARUPP(IDAT) = 1.D+6                                          
   60         CONTINUE                                                          
          END IF                                                                
                                                                                
          CALL STTPUT(                                                          
     +             '   Initial values     Lower Bounds     Upper Bounds'        
     +                ,STATUS)                                                  
          DO 70 K = 1,NRPARAM                                                   
              WRITE (LINE,9010) PARAM(K),PARLOW(K),PARUPP(K)                    
              CALL STTPUT(LINE,STATUS)                                          
   70     CONTINUE                                                              
          CALL STTPUT(' ',STATUS)                                               
                                                                                
      ELSE IF (BNDTYP(1:1).EQ.'P') THEN                                         
          CALL STTPUT(' Parameters must be positive',STATUS)                    
          IBOUND = 2                                                            
      END IF                                                                    
C                                                                               
C  Call to the NAG routines after having displayed the parameters and           
C  get the necessary V.M. space.                                                
C                                                                               
      IFAIL1 = 1                                                                
      XVAL(1) = 1.                                                              
      IF (ALGOR(1:5).EQ.'CGNND') THEN                                           
          CALL STTPUT(' ',STATUS)                                               
          CALL STTPUT(                                                          
     +          ' Constrained Non-linear Least Squares Fitting : Corr. '        
     +                //'Gauss-Newton M. (no der)',STATUS)                      
          CALL STTPUT(                                                          
     +          ' _____________________________________________________'        
     +                //'________________________',STATUS)                      
          CALL STTPUT(' ',STATUS)                                               
          CALL STTPUT(' ',STATUS)                                               
          CALL STTPUT(                                                          
     +  ' Print   Max. Fct. eval.  Prec. on Param.  Lin. Search  Domain'        
     +                //'  Weight',STATUS)                                      
          WRITE (LINE,9020) NINT(METPAR(1)),NINT(METPAR(2)),METPAR(3),          
     +      METPAR(4),METPAR(5),WGTTYP                                          
          CALL STTPUT(LINE,STATUS)                                              
          CALL STTPUT(' ',STATUS)                                               
                                                                                
          IF (NOMPAR) THEN                                                      
              ROUTIN = 1                                                        
              IF (NRPARAM.EQ.1) THEN                                            
                  LW     = 13                                                   
                                                                                
              ELSE                                                              
                  LW     = 12*NRPARAM + NRPARAM* (NRPARAM-1)/2                  
              END IF                                                            
                                                                                
              LIW    = NRPARAM + 2                                              
                                                                                
              NRVM   = 2*LW + LIW                                               
              NBYT = 4*NRVM
              CALL TDMGET(NBYT,PTRW,STATUS)
              PTRIW  = PTRW + 2*LW                                              
                                                                                
              CALL E04JAF(NRPARAM,IBOUND,PARLOW,PARUPP,PARAM,FSUMSQ,            
     +                    MADRID(PTRIW),LIW,MADRID(PTRW),LW,IFAIL1)             
                                                                                
          ELSE                                                                  
              ROUTIN = 2                                                        
              LW     = 9*NRPARAM                                                
              LHSL   = MAX0(NRPARAM* (NRPARAM-1)/2,1)                           
              LIW    = 10                                                       
                                                                                
              NRVM   = 2* (LW+LHSL+4*NRPARAM) + LIW                             

C             CALL STIPUT('WORK ',10,9,1,1,NRVM,1.,XVAL,' ',' ',PTRW,            
C    +                    STATUS)                                               
              NBYT = 4*NRVM
              CALL TDMGET(NBYT,PTRW,STATUS)
              PTRDLT = PTRW + 2*LW                                              
              PTRHSL = PTRDLT + 2*NRPARAM                                       
              PTRHSD = PTRHSL + 2*LHSL                                          
              PTRSTA = PTRHSD + 2*NRPARAM                                       
              PTRGRD = PTRSTA + NRPARAM                                       
              PTRIW  = PTRGRD + 2*NRPARAM                                       
                                                                                
              IFAIL3 = 1                                                        
              CALL E04HBF(NRPARAM,FUNCT3,PARAM,NRFEVA,MADRID(PTRDLT),          
     +                    MADRID(PTRHSL),LHSL,MADRID(PTRHSD),FSUMSQ,            
     +                    MADRID(PTRGRD),MADRID(PTRIW),LIW,MADRID(PTRW),        
     +                    LW,IFAIL3)                                            
                                                                                
                                                                                
              CALL MNMX(MADRID(PTRHSD),NRPARAM,HMIN,HMAX,IMIN,IMAX)             
              IF (HMAX.LT.1.D+4*HMIN) THEN                                      
                  WRITE (LINE,9030) HMIN,HMAX                                   
                  CALL STETER(21,LINE)                                          
              END IF                                                            
                                                                                
              CALL E04JBF(NRPARAM,FUNCT3,MINMON,NINT(METPAR(1)),.TRUE.,         
     +                    1,E04JBQ,NINT(METPAR(2)),DBLE(METPAR(4)),             
     +                    DBLE(METPAR(3)),DBLE(METPAR(5)),0.D0,                 
     +                    MADRID(PTRDLT),IBOUND,PARLOW,PARUPP,PARAM,            
     +                    MADRID(PTRHSL),LHSL,MADRID(PTRHSD),                   
     +                    MADRID(PTRSTA),FSUMSQ,MADRID(PTRGRD),                 
     +                    MADRID(PTRIW),LIW,MADRID(PTRW),LW,IFAIL1)             
                                                                                
          END IF                                                                
                                                                                
      ELSE IF (ALGOR(1:2).EQ.'QN') THEN                                         
          CALL STTPUT(' ',STATUS)                                               
          CALL STTPUT(                                                          
     +   ' Constrained Non-linear Least Squares Fitting : Quasi-Newton '        
     +                //'Method',STATUS)                                        
          CALL STTPUT(                                                          
     +   ' ____________________________________________________________'        
     +                //'______',STATUS)                                        
          CALL STTPUT(' ',STATUS)                                               
          CALL STTPUT(' ',STATUS)                                               
          CALL STTPUT(                                                          
     +  ' Print   Max. Fct. eval.  Prec. on Param.  Lin. Search  Domain'        
     +                //'  Weight',STATUS)                                      
          WRITE (LINE,9020) NINT(METPAR(1)),NINT(METPAR(2)),METPAR(3),          
     +      METPAR(4),METPAR(5),WGTTYP                                          
          CALL STTPUT(LINE,STATUS)                                              
          CALL STTPUT(' ',STATUS)                                               
                                                                                
          IF (NOMPAR) THEN                                                      
              ROUTIN = 3                                                        
              IF (NRPARAM.EQ.1) THEN                                            
                  LW     = 11                                                   
                                                                                
              ELSE                                                              
                  LW     = 10*NRPARAM + NRPARAM* (NRPARAM-1)/2                  
              END IF                                                            
                                                                                
              LIW    = NRPARAM                                              
              NRVM   = LW*2 + LIW+ 2*NRPARAM                                               
C              CALL STIPUT('WORK ',10,9,1,1,NRVM,1.,XVAL,' ',' ',PTRW,            
C     +                    STATUS)                                               
              NBYT=NRVM*4
              CALL TDMGET(NBYT,PTRW,STATUS)
              PTRIW  = PTRW + 2*LW                                              
              PTRGRD = PTRIW + 2*NRPARAM
              CALL E04KAF(NRPARAM,IBOUND,PARLOW,PARUPP,PARAM,FSUMSQ,            
     +                    MADRID(PTRGRD),MADRID(PTRIW),LIW,MADRID(PTRW),        
     +                    LW,IFAIL1)                                            
                                                                                
          ELSE                                                                  
              ROUTIN = 4                                                        
              LW     = 9*NRPARAM                                                
              LIW    = 10                                                       
              LHSL   = MAX(NRPARAM* (NRPARAM-1)/2,1)                            
                                                                                
              NRVM   = (LW+3*NRPARAM+LHSL+1)*2 + LIW + NRPARAM                  
              NBYT = NRVM*4
              CALL TDMGET(NBYT,PTRW,STATUS)
C              CALL STIPUT('WORK ',10,9,1,1,NRVM,1.,XVAL,' ',' ',PTRW,            
C     +                    STATUS)                                               
              PTRHSL = PTRW + 3*NRPARAM                                         
              PTRHSD = PTRHSL + 2*LHSL                                          
              PTRSTA = PTRHSD + 2*NRPARAM                                       
              PTRGRD = PTRSTA + NRPARAM                                       
              PTRIW  = PTRGRD + 2*NRPARAM                                       
                                                                                
                                                                                
              IFAIL3 = 1                                                        
              CALL E04HCF(NRPARAM,FUNCT4,PARINI,FSUMSQ,MADRID(PTRGRD),          
     +                    MADRID(PTRIW),LIW,MADRID(PTRW),LW,IFAIL3)             
                                                                                
              IF (IFAIL3.EQ.2) THEN                                             
                  CALL MINMSG(ALGOR(1:5),ROUTIN,10)                             
                  GO TO 100                                                     
                                                                                
              END IF                                                            
                                                                                
              CALL SETZER(MADRID(PTRHSL),LHSL)                                 
              CALL SETONE(MADRID(PTRHSD),NRPARAM)                               
                                                                                
              CALL E04KBF(NRPARAM,FUNCT4,MINMON,NINT(METPAR(1)),.TRUE.,         
     +                    1,E04LBS,NINT(METPAR(2)),DBLE(METPAR(4)),             
     +                    DBLE(METPAR(3)),DBLE(METPAR(5)),0.D0,IBOUND,          
     +                    PARLOW,PARUPP,PARAM,MADRID(PTRHSL),LHSL,              
     +                    MADRID(PTRHSD),MADRID(PTRSTA),FSUMSQ,                 
     +                    MADRID(PTRGRD),MADRID(PTRIW),LIW,MADRID(PTRW),        
     +                    LW,IFAIL1)                                            
                                                                                
          END IF                                                                
                                                                                
      ELSE IF (ALGOR(1:3).EQ.'MGN') THEN                                        
          CALL STTPUT(' ',STATUS)                                               
          CALL STTPUT(                                                          
     +       ' Constrained Non-linear Least Squares Fitting : Modified '        
     +                //'Gauss-Newton Method',STATUS)                           
          CALL STTPUT(                                                          
     +       ' ________________________________________________________'        
     +                //'___________________',STATUS)                           
          CALL STTPUT(' ',STATUS)                                               
          CALL STTPUT(' ',STATUS)                                               
          CALL STTPUT(                                                          
     +  ' Print   Max. Fct. eval.  Prec. on Param.  Lin. Search  Domain'        
     +                //'  Weight',STATUS)                                      
          WRITE (LINE,9020) NINT(METPAR(1)),NINT(METPAR(2)),METPAR(3),          
     +      METPAR(4),METPAR(5),WGTTYP                                          
          CALL STTPUT(LINE,STATUS)                                              
          CALL STTPUT(' ',STATUS)                                               
                                                                                
          IF (NOMPAR) THEN                                                      
              ROUTIN = 5                                                        
              IF (NRPARAM.EQ.1) THEN                                            
                  LW     = 11                                                   
                                                                                
              ELSE                                                              
                  LW     = 10*NRPARAM + NRPARAM* (NRPARAM-1)/2                  
              END IF                                                            
                                                                                
              LIW    = NRPARAM + 4                                              
              NRVM   = LW*2 + LIW                                               
C             CALL STIPUT('WORK ',10,9,1,1,NRVM,1.,XVAL,' ',' ',PTRW,            
C     +                    STATUS)                  
              NBYT = NRVM*4
              CALL TDMGET(NBYT,PTRW,STATUS)                             
              PTRIW  = PTRW + 2*LW                                              
              PTRGRD = PTRIW + 2 + NRPARAM
              CALL E04KCF(NRPARAM,IBOUND,PARLOW,PARUPP,PARAM,FSUMSQ,            
     +                    MADRID(PTRGRD),MADRID(PTRIW),LIW,MADRID(PTRW),        
     +                    LW,IFAIL1)                                            
                                                                                
          ELSE                                                                  
              ROUTIN = 6                                                        
              IF (NRPARAM.EQ.1) THEN                                            
                  LW     = 8                                                    
                                                                                
              ELSE                                                              
                  LW     = 7*NRPARAM + NRPARAM* (NRPARAM-1)/2                   
              END IF                                                            
                                                                                
              LIW    = 10                                                       
              LHSL   = MAX(NRPARAM* (NRPARAM-1)/2,1)                            
                                                                                
              NRVM   = (LW+3*NRPARAM+LHSL+1)*2 + LIW + NRPARAM                  
              NBYT = NRVM*4
              CALL TDMGET(NBYT,PTRW,STATUS)
C              CALL STIPUT('WORK ',10,9,1,1,NRVM,1.,XVAL,' ',' ',PTRW,            
C     +                    STATUS)                                               
              PTRHSL = PTRW + 2*LW                                              
              PTRHSD = PTRHSL + 2*LHSL                                          
              PTRSTA = PTRHSD + 2*NRPARAM                                       
              PTRGRD = PTRSTA + NRPARAM                                       
              PTRIW  = PTRGRD + 2*NRPARAM                                       
                                                                                
                                                                                
              IFAIL3 = 1                                                        
              CALL E04HCF(NRPARAM,FUNCT4,PARINI,FSUMSQ,MADRID(PTRGRD),          
     +                    MADRID(PTRIW),LIW,MADRID(PTRW),LW,IFAIL3)             
                                                                                
              IF (IFAIL3.EQ.2) THEN                                             
                  CALL MINMSG(ALGOR(1:5),ROUTIN,10)                             
                  GO TO 100                                                     
                                                                                
              END IF                                                            
                                                                                
              CALL E04KDF(NRPARAM,FUNCT4,MINMON,NINT(METPAR(1)),                
     +                    NINT(METPAR(2)),DBLE(METPAR(4)),                      
     +                    DBLE(METPAR(3)),0.D0,DBLE(METPAR(5)),IBOUND,          
     +                    PARLOW,PARUPP,PARAM,MADRID(PTRHSL),LHSL,              
     +                    MADRID(PTRHSD),MADRID(PTRSTA),FSUMSQ,                 
     +                    MADRID(PTRGRD),MADRID(PTRIW),LIW,MADRID(PTRW),        
     +                    LW,IFAIL1)                                            
                                                                                
          END IF                                                                
                                                                                
      END IF                                                                    
                                                                                
      CALL MINMSG(ALGOR(1:5),ROUTIN,IFAIL1)                                     
      CALL STTPUT(' ',STATUS)                                                   
                                                                                
      IF (IFAIL1.NE.1 .AND. IFAIL1.NE.4 .AND. IFAIL1.NE.9) THEN                 
          IF (NOMPAR) THEN                                                      
              IF (ALGOR(1:5).EQ.'CGNND') THEN                                   
                  PTRHSD = PTRW + 8* (6*NRPARAM+2*NRDATA+NRDATA*NRPARAM+        
     +                     MAX0(1, (NRPARAM* (NRPARAM-1)/2)))                   
                  PTRHSD = PTRHSD + 8*NRPARAM                                   
                                                                                
              ELSE                                                              
                  PTRHSD = PTRW + 8* (7*NRPARAM+2*NRDATA+NRDATA*NRPARAM+        
     +                     NRPARAM* (NRPARAM+1)/2+                              
     +                     MAX0(1, (NRPARAM* (NRPARAM-1)/2)))                   
                  PTRHSD = PTRHSD + 8*NRPARAM                                   
                                                                                
              END IF                                                            
                                                                                
          END IF                                                                
                                                                                
                                                                                
      ELSE                                                                      
          CALL STTPUT(                                                          
     +        ' *** Unable to evaluate the errors on the parameters ***'        
     +                ,STATUS)                                                  
      END IF                                                                    
                                                                                
  100 CONTINUE                                                                  
C                                                                               
C  Pass the final reduced chi squares to the COMMON block                       
C                                                                               
      NRITER = NRFEVA                                                          
      FINCHI = FSUMSQ/DBLE(NRDATA-NRPARAM+NRPFIX)                             
C                                                                               
C  Exit                                                                         
C                                                                               
      RETURN                                                                    
                                                                                
 9000 FORMAT (5X,G12.5,10X,G12.5)                                               
 9010 FORMAT (5X,G12.5,10X,G12.5,10X,G12.5)                                     
 9020 FORMAT (I6,8X,I7,7X,1PE9.1,8X,0PF4.2,6X,0PF8.0,5X,A1)                     
 9030 FORMAT ('FIT/TABLE : Bad Scaling of the problem ','HSD from ',            
     +       1PD9.2,' to ',1PD9.2)                                              
 9040 FORMAT ('*** Detected only ',I3,' linear independent parameters ',        
     +       'on the total of ',I3,' ***')                                      
      END                                                                       

C @(#)tkstest.for	19.1 (ESO-DMD) 02/25/03 13:21:26
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  1 JUL 1989
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: M.PERON
C
C.IDENTIFICATION
C
C  Program TKSTEST
C
C.KEYWORDS
C
C KOLMOGOROV TEST
C
C.PURPOSE
C
C Comparaison of one data set to a known distribution using Kolmogorov TEST
C 
C The distribution available are :
C  --Uniform Distribution (UNI)
C  --Gaussian Distribution (GAUS)
C --
C
C
C The application calculates the KS statistic D as well as the probability
C of exceeding D under the Null hypothesis which is :
C Data follow the selectedn distribution
C References: Numerical Recipes p 472
C 
C.VERSION
C 
C 010621		last modif
C 
C-----------------------------------------------------------
C
       PROGRAM TKSTEST
C 
       IMPLICIT NONE
C 
       REAL*4 D,PROB,PARA(2)
C 
       INTEGER*8   ADDRIN(1)
C 
       INTEGER MADRID,IACT,KUN,KNUL,STAT,NSC,NBYTES
       INTEGER PARVAL,NPAR,ISTAT,TID,NCOL,NROW,NACOL,NAROW,COL
       INTEGER NREAL
C 
       CHARACTER*80 INTAB
       CHARACTER*1 DISTRI
       CHARACTER*17 COLIND
       CHARACTER*80 OUTPUT1,OUTPUT2,OUT,OUTPUT0,OUTPUT3
C 
       INCLUDE 'MID_INCLUDE:TABLES.INC'
       COMMON/VMR/MADRID(1)
C 
       INCLUDE 'MID_INCLUDE:TABLED.INC'
       DATA PARVAL/8/, TID /-1/
       DATA OUTPUT0 
     1    /' Null Hypothesis : Data follow the given distribution'/
       DATA OUTPUT1
     1    /'Kolmogorov-Smirnov D Statistic  '/
       DATA OUTPUT2
     2    /'-----------------------------------------------------  '/
       DATA OUTPUT3
     3   /'Probability of exceeding D under Null Hypothesis'/
C
C      get into MIDAS
       CALL STSPRO('TKSTEST')

C      read parameters of the command
       CALL TDPGET(PARVAL,NPAR,ISTAT)
       IF  (ISTAT.NE.0) GOTO 80
       INTAB = TPARBF(1)
       COLIND = TPARBF(2)

c      read name of the distribution used

       CALL STKRDC('INPUTC',1,1,1,IACT,DISTRI,KUN,KNUL,STAT)
       CALL UPCAS(DISTRI,DISTRI)
C
c      read parameters of this distribution
       CALL STKRDR('INPUTR',1,2,IACT,PARA,KUN,KNUL,STAT)       

c      open the input table

       CALL TBTOPN(INTAB,F_I_MODE,TID,ISTAT)       
       IF(ISTAT.NE.0) GOTO 80
       CALL TBIGET(TID,NCOL,NROW,NSC,NACOL,NAROW,ISTAT)
        CALL TBCSER(TID,COLIND,COL,ISTAT)
         IF (COL.LT.0) THEN
         CALL STTPUT('Column not found...',ISTAT)
          GOTO 80
        ENDIF


c      prepare work space

       NBYTES = 4*NROW
       CALL TDMGET(NBYTES,ADDRIN(1),ISTAT)
       CALL TMAP(TID,NROW,COL,MADRID(ADDRIN(1)),NREAL)
        CALL SORT (MADRID(ADDRIN(1)),NREAL)

c      calculate the KS Statistic

       CALL KOLM1D(MADRID(ADDRIN(1)),NREAL,DISTRI,PARA,D,PROB)
       CALL STTPUT(OUTPUT0,ISTAT)
       CALL STTPUT(OUTPUT2,ISTAT)
       CALL STTPUT(OUTPUT1,ISTAT)
        WRITE(OUT,100)D
       CALL STTPUT(OUT,ISTAT)
       CALL STTPUT(OUTPUT2,ISTAT)
       CALL STTPUT(OUTPUT3,ISTAT)
        WRITE(OUT,100)PROB
       CALL STTPUT(OUT,ISTAT)
       CALL STTPUT(OUTPUT2,ISTAT)
       CALL STKWRR('OUTPUTR',D,1,1,KUN,STAT)
       CALL STKWRR('OUTPUTR',PROB,2,1,KUN,ISTAT)
        CALL TBTCLO(TID,ISTAT)

C      that's folks

       CALL STSEPI
80      CONTINUE
100     FORMAT(1X,G15.6,15X,G15.6)
        END

C @(#)gd8i.for	19.1 (ES0-DMD) 02/25/03 13:55:25
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE 
     +  GD8037(DSPLAY,INTTYPE,INTID,OBJTYPE,OBJID,INTOP,EXTRIG,IDST)
C      
      IMPLICIT NONE
C      
      INTEGER      DSPLAY,INTTYPE,INTID,OBJTYPE,OBJID
      INTEGER      INTOP,EXTRIG,IDST
C 
      IDST = 0
      RETURN
      END

      SUBROUTINE GD8038(DSPLAY,TRIGSTAT,IDST)
C 
      IMPLICIT NONE
C      
      INTEGER      DSPLAY,TRIGSTAT(1),IDST
C 
      IDST = 0
      RETURN
      END

      SUBROUTINE GD8039(DSPLAY,IDST)
C
      IMPLICIT NONE
C 
      INTEGER      DSPLAY,IDST
C 
      IDST = 0
      RETURN
      END

      SUBROUTINE GD8040(DSPLAY,INTTYPE,INTID,DEVDSC,LL,IDST)
C      
      IMPLICIT NONE
C 
      INTEGER      DSPLAY,INTTYPE,INTID,LL,IDST
C 
      CHARACTER*(*)  DEVDSC
C 
      IDST = 0
      RETURN
      END

      SUBROUTINE GD8041(DSPLAY,LOCNO,JX,JY,IDST)
C      
      IMPLICIT NONE
C      
      INTEGER      DSPLAY,LOCNO,JX,JY,IDST
C 
      IDST = 0
      RETURN
      END

      SUBROUTINE GD8044(DSPLAY,EVAL,JJ,IDST)
C 
      IMPLICIT NONE
C 
      INTEGER      DSPLAY,EVAL,JJ,IDST
C 
      IDST = 0
      RETURN
      END

	SUBROUTINE GD8045(DISPLAY,EVAL,OUTSTR,JJ,IDST)
C 
	IMPLICIT NONE
C 
	INTEGER*4	DISPLAY,EVAL,JJ,IDST
C 
	CHARACTER*(*)   OUTSTR
C 
	IDST = 0
	RETURN
	END

C @(#)ftddvt.for	19.1 (ES0-DMD) 02/25/03 13:17:33
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FTDDVT(NAME,DVAR,ISTAT)                                        
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                   
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:25 - 13 JAN 1988                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C.IDENTIFICATION                                                                
C                                                                               
C  FITLIB.FOR   VERSION 1.0  27 MAR 1984                                        
C                                                                               
C.PURPOSE                                                                       
C                                                                               
C  INTERFACE ROUTINES FOR THE FITTING STRUCTURES                                
C DEFINE DEPENDENT VARIABLE AS COLUMN IN A TABLE                                
C                                                                               
C.ALGORITHM                                                                     
C                                                                               
C  USE MIDAS I/O INTERFACES TO FRAMES AND TABLES                                
C                                                                               
C.KEYWORDS                                                                      
C                                                                               
C  NON LINEAR FITTING                                                           
C                                                                               
C                                                                               
C----------------------------------------------------------------               
C                                                                               
C      IMPLICIT NONE                                                            
C                                                                               
C INPUT PARAMETERS                                                              
C NAME CHAR TABLE NAME                                                          
C DVAR CHAR COLUMN ACTING AS DEPENDENT VARIABLE                                 
C   AND OPTIONAL ERROR COLUMN                                                   
C                                                                               
C OUTPUT PARAMETERS                                                             
C ISTAT INTG STATUS RETURN                                                      
C                       
      INTEGER       TYPE,ISTAT,IND1,IND2                                                        
      CHARACTER*(*) NAME,DVAR                                                   
      CHARACTER*8 NAME1,FORM                                               
      CHARACTER*17 LAB1,LAB2                                                    
      CHARACTER*16 LABEL,UNIT                                                   
C
       INCLUDE 'MID_INCLUDE:TABLES.INC/NOLIST'                                     
       INCLUDE 'MID_INCLUDE:FITI.INC/NOLIST'                                     
       INCLUDE 'MID_INCLUDE:FITC.INC/NOLIST'                                     
       INCLUDE 'MID_INCLUDE:TABLED.INC/NOLIST'                                     
C
      DATA UNIT/' '/                                                            
      DATA FORM/'G14.7 '/                                            
C
      TYPE = D_R4_FORMAT
C                                                                               
C READ TABLE                                                                    
C                                                                               
      NAME1  = NAME                                                             
      IF (FZMAPPED.EQ.1 .AND. FZTYPE.EQ.'TBL ') THEN                        
          IF (FZNAME(1:8).NE.NAME1) THEN  !   TABLE MUST BE THE SAME          
              ISTAT  = FERTAB                                               
              RETURN                                                            
          END IF                                                                
      ELSE                                                                      
          IF (FZMAPPED.EQ.0) THEN                                             
              CALL TBTOPN(NAME,2,FZIDEN,ISTAT)                                           
              FZMAPPED = 1                                                    
              FZNAME = NAME                                                   
              FZTYPE = 'TBL '                                                 
          END IF                                                                
      END IF                                                                    
C                                                                               
C LAB1 CONTAINS THE COLUMN ACTING AS DEP VAR                                    
C LAB2 OPTIONAL WEIGHT                                                          
C                                                                               
      IND1   = INDEX(DVAR,',')                                                  
      IND2   = INDEX(DVAR,' ')                                                  
      IF (IND1.EQ.0) THEN                                                       
          LAB1   = DVAR(1:IND2-1)                                               
          LAB2   = ' '                                                          
      ELSE                                                                      
          LAB1   = DVAR(1:IND1-1)                                               
          LAB2   = DVAR(IND1+1:IND2-1)                                          
      END IF                                                                    
      CALL TBCSER(FZIDEN,LAB1,FZDVAR,ISTAT)                                     
      IF (FZDVAR.EQ.-1) THEN                                                  
          LABEL  = LAB1(2:)                                                     
          CALL TBCINI(FZIDEN,TYPE,1,FORM,UNIT,LABEL,FZDVAR,ISTAT)                 
      END IF                                                                    
      IF (LAB2(1:1).EQ.' ') THEN                                                
          FZWEIGHT = 0                                                        
      ELSE                                                                      
          CALL TBCSER(FZIDEN,LAB2,FZWEIGHT,ISTAT)                               
          IF (FZWEIGHT.EQ.-1) THEN                                            
              LABEL  = LAB2(2:)                                                 
              CALL TBCINI(FZIDEN,TYPE,1,FORM,UNIT,LABEL,FZWEIGHT,ISTAT)           
          END IF                                                                
                                                                                
      END IF                                                                    
                                                                                
      RETURN                                                                    
                                                                                
      END                                                                       

C @(#)tsasin.for	19.1 (ESO-DMD) 02/25/03 13:33:26
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT (c) 1992 European Southern Observatory & Copernicus Astron. Center
C.IDENT     tsasin.for
C.AUTHOR    Alex Schwarzenberg-Czerny, Copernicus Astron. Center, Warsaw
C.KEYWORD   MIDAS, time series, SINEFIT/TSA
C.LANGUAGE  FORTRAN 77
C.PURPOSE   Fit sine (Fourier) series
C.VERSION   0.0               June 1992
C.RETURNS   None
C.ENVIRON   TSA context
C 
C 021205	last modif
C 
C-----------------------------------------------------------------------------
C
C
      INCLUDE 'MID_REL_INCL:TSA_DEF.INC'
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      INTEGER      MXORDER
      PARAMETER   (MXORDER=20)          !  DEPENDS ON LENGTH OF OUTD
      REAL*8       FREQU                !  INITIAL PERIOD VALUE
      INTEGER      NORDER               !  NUMBER OF HARMONICS
      INTEGER      ITER                 !  NUMBER OF ITERATIONS
      CHARACTER*60 INAME                !  NAME OF INPUT TABLE
      CHARACTER*60 ONAME                !  NAME OF OUTPUT TABLE
      REAL*8       COEF(MXORDER+3)      !  NORDER COEFFICIENTS
C
      INTEGER      MODE,IACTS,KUN,KNUL
      INTEGER      TID,OTID,ITIME,IVAL
      INTEGER      NCOL,ICOL,NROW,IROW,ISOR
      INTEGER      LFIELD,TTYP,VTYP
      INTEGER*8     PTIME,PVAL,POTIME,POVAL
C 
      CHARACTER*10 FORM
      CHARACTER*80 TEXT
C 
      DOUBLE PRECISION E(MXORDER+3)           ! WORK TABLES
      DOUBLE PRECISION B(MXORDER+3,MXORDER+3) ! WORK TABLES
C
      INCLUDE 'MID_REL_INCL:TSA_DAT.INC'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      DATA MODE/1/
C
C   Get parameters
C
      CALL STSPRO ('tsasin')
      CALL STKRDC ('IN_A', 1,1,60,IACTS,INAME, KUN,KNUL,ISTAT)
      CALL STKRDC ('OUT_A',1,1,60,IACTS,ONAME, KUN,KNUL,ISTAT)
      CALL STKRDD ('STARTTSA', 1, 1,IACTS,FREQU, KUN,KNUL,ISTAT)
      CALL STKRDI ('ORDERTSA',  1, 1,IACTS,NORDER,KUN,KNUL,ISTAT)
      NORDER=2*NORDER+2
      IF (NORDER.GT.MXORDER+1) THEN
        NORDER=(MXORDER-1)/2*2+1
        WRITE(TEXT,'(A,I4)') 
     $   'Will use max. permitted ORDER of', 
     $    (MXORDER-1)/2
        CALL STTPUT(TEXT,ISTAT)
      ENDIF
      CALL STKRDI ('ITER',  1, 1, IACTS,ITER,KUN,KNUL,ISTAT)
      IF (ITER.LT.0) THEN
        CALL STKRDD ('OUTPUTD',1,NORDER-1,IACTS,COEF(1),
     $    KUN,KNUL,ISTAT)
      ENDIF
C
C   Map input/output data
C
      CALL TBTOPN (INAME,F_IO_MODE,TID,ISTAT)
      OTID=TID
      CALL TBIGET (TID,NCOL,NROW,ISOR,ICOL,IROW,ISTAT)
      CALL TBLSER (TID,'TIME',ITIME,ISTAT)
      IF (ITIME.LT.0) THEN
        CALL STETER(3,'Column :TIME not found')
      ENDIF
      CALL TBLSER (TID,'VALUE',IVAL,ISTAT)
      IF (IVAL.LT.0) THEN
        CALL STETER(4,'Column :VALUE not found')
      ENDIF
      CALL TBFGET (TID,ITIME,FORM,LFIELD,TTYP,ISTAT)
      CALL TBFGET (TID,IVAL, FORM,LFIELD,VTYP,ISTAT)
      CALL TBDGET (TID,ISTORE,ISTAT)
      IF (ISTORE.NE.F_TRANS) THEN
        TEXT='Input table '//INAME//' stored not transposed'
        CALL STETER(1,TEXT)
      ENDIF
      IF (TTYP.NE.D_R8_FORMAT.OR.VTYP.NE.D_R8_FORMAT) THEN
        CALL STETER(2,
     $    'Data column(s) must be of DOUBLE PRECISION type')
      ENDIF
      CALL TBCMAP (TID,ITIME,PTIME,ISTAT)
      POTIME=PTIME
      CALL TBCMAP (TID,IVAL, PVAL, ISTAT)
      POVAL=PVAL
C
C   Map output data
C
C M. Peron 22-02-93
C A. Schwarzenberg-Czerny 07-05-93
C
C   Perform single nonlinear fit iteration, store coeficients and residuals
C
      COEF(NORDER)=FREQU
      CALL TIMFIT(MADRID(PTIME),MADRID(PVAL),MADRID(POVAL),NROW,
     $   MODE,NORDER,ITER,MXORDER,COEF,E,B)
      FREQU=COEF(NORDER)
      CALL STKWRD ('STARTTSA',  FREQU,  1,       1,KUN,ISTAT)
      CALL STKWRD ('OUTPUTD',COEF(1),1,NORDER-1,KUN,ISTAT)
C
C   Wind-up
C
      CALL DSCUPT(OTID,OTID,' ',ISTAT)
      CALL STSEPI
C
      END
C
C
C
C
C
C
C                 Subroutine  FIT
C
C     Purpose: Given a trial period, fit a Fourier series by non-linear
C        least squares method.
C
C     Data: an ASCII file containing 3 columns (number of line(integer),
C        time, value (both real*4)) and less than maxm-2 rows.
C        A trial value of the period, an order of the series (<maxo/2-1)
C        and a name of the data file are prompted for.
C
C     Results: Correlation coefficients of the fitted parameters, their
C        values and errors are displayed on the screen after each
C        iteration. Finish iterations by typing 0 when changes in
C        the parameters and std.dev. are negligible. After the final
C        iteration values of the series are subtracted from the data and
C        output as fitsin.res file.
C
C     Method: The data are fitted by the following series:
C        f(1)+f(2)*sin(w*t)+f(3)*cos(w*t)+...+f(2*ord+1)*cos(2*ord*w*t)
C        by least squares. After the initial solution
C        the value of the frequency w is varied as well as the coefficients so
C        that due to nonlinearity of the problem several iterations are
C        required. To continue iterations type 1.
C
C     A. Schwarzenberg-Czerny                      June, 1987
C
      SUBROUTINE TIMFIT(T,X,OX,NX,MODE,NORD,NITER,MXORD,F,E,B)
C
      INCLUDE 'MID_REL_INCL:TSA_DEF.INC'
C

      INTEGER NX                 !  NUMBER OF DATA
      DOUBLE PRECISION  CRACOW             !  EXTERNAL FUNCTION
      DOUBLE PRECISION  T(NX)              !  TIME VECTOR
      DOUBLE PRECISION  X(NX)              !  INPUT DATA VECTOR
      DOUBLE PRECISION  OX(NX)             !  OUTPUT DATA VECTOR
      INTEGER MODE               !  MODE OF WORK
      INTEGER NORD               !  ORDER OF THE SERIES
      INTEGER MXORD              !  TABLE SIZE-3
      INTEGER NITER              !  NUMBER OF ITERATIONS
      DOUBLE PRECISION  F(MXORD+3)         !  FIT COEFFICIENTS (INCL. FREQ)
      DOUBLE PRECISION E(MXORD+3),B(MXORD+3,MXORD+3)   ! WORK TABLES
C
      DOUBLE PRECISION  FREQ
      LOGICAL START
      CHARACTER*80 MSG
      DOUBLE PRECISION TM,XM,TMX,TMI,DFREQ,PI2,CORRMX
      DOUBLE PRECISION PHMT,DPHMT,EPMAX, FREQSTEP
      INTEGER N,NP,I,N1,J,K,ITER
C
      INCLUDE 'MID_REL_INCL:TSA_CONST.INC'
C
C    get data
C
      PI2=TWO*TWO*TWO*ATAN(ONE)
      START=NITER.GT.0
      NITER=ABS(NITER)
      ITER=0
      TM=ZERO
      XM=ZERO
      TMX=T(1)
      TMI=TMX
      DO 1 I=1,NX
        TMX=MAX(TMX,T(I))
        TMI=MIN(TMI,T(I))
        TM=TM+T(I)
 1      XM=XM+X(I)
      TM=TM/NX
      XM=XM/NX
C
C    input parameters and output results of previous iteration
C
      IF (MODE.EQ.1) THEN
        IF (NORD.LT.1) CALL STETER(5,'Wrong parameter')
        F(NORD)=PI2*F(NORD)
        NP=2
        IF (START) THEN
           WRITE(MSG,'(a,1pg20.6,a,i4)')
     $         ' START: frequency=',F(NORD)/PI2,' order=',(NORD-2)/2
           CALL STTPUT(MSG,ISTAT)
           N=NORD-1
           DFREQ=ZERO
        ELSE
          N=NORD
        ENDIF
      ELSE
        CALL STETER(2,' Wrong mode')
      ENDIF
      IF (START) THEN
        DO 5 I=1,N
 5         F(I)=ZERO
      ENDIF
C
C    iterations for non-linear fit
C
 100  CONTINUE
C
C           freq - current frequency
C           dfreq - its error
C           tm - mean time of obserwation
C           phmt - phase of base sinusoid at mean time
C           dphmt - its error
C           epmax - epoch of maximum of the base sinusoid
C           The harmonics are ignored by phase calculation
C
C
C     set condition and normal equations
C
        N1=N+1
        ITER=ITER+1
        DO 60 I=1,N1
          DO 60 J=1,N1
 60         B(J,I)=ZERO
        DO 3 I=1,NX
          F(NORD+1)=T(I)-TM
          F(NORD+2)=X(I)-XM
          IF (MODE.EQ.1) THEN
            CALL FITSIN(E,N1,F,NP)
          ENDIF
C  *** prevent overwriting data before end of iterations, A.S-C, 07-05-93
          IF (ITER.GT.NITER) THEN
            OX(I)=E(N1)
          ENDIF
          DO 3 J=1,N1
            DO 3 K=1,N1
 3            B(K,J)=B(K,J)+E(J)*E(K)
C
C     solve normal equations and evaluate results
C
        IF (ITER.LE.NITER) THEN
          IF (CRACOW(B,N1,MXORD+3,NX).NE.ZERO) THEN
C
C   Update and output coefficients
C
            CORRMX=ZERO
            DO 7 J=1,N
              F(J)=F(J)+B(J,N1)
              DO 7 I=1,J-1
 7              CORRMX=MAX(CORRMX,ABS(B(I,J)/SQRT(B(J,J)*B(I,I))))
            IF (ITER.LE.1) THEN
              CALL STTPUT(
     $        '   iter.        freq.       std.dev.,     max. corr.',
     $          ISTAT)
            ELSE
              FREQSTEP=B(NORD,N1)/PI2
              IF (FREQSTEP*(TMX-TMI).GT.TWO) THEN
                CALL STTPUT(
     $            '*** Large frequency step, divergence?',ISTAT)
              ENDIF
            ENDIF
            WRITE(MSG,'(1x,i7,3(1pe15.7),'' '')')
     $         ITER,F(NORD)/PI2,SQRT(MAX(B(N1,N1),ZERO)),CORRMX
            CALL STTPUT(MSG,ISTAT)
            IF (ITER.EQ.NITER) THEN
              CALL STTPUT('   coefficients     errors',ISTAT)
              F(1)=F(1)+XM
              DO 6 J=1,N
                WRITE(MSG,'(1x,2(1pe15.7),'' '')')
     $                F(J),SQRT(MAX(B(J,J),ZERO))
 6            CALL STTPUT(MSG,ISTAT)
              F(1)=F(1)-XM
C
C   Output ephemeris for base sinusoid
C
              IF (NORD.GT.ZERO.AND.MODE.EQ.1) THEN
                FREQ=F(NORD)/PI2
                IF(.NOT.START) DFREQ=SQRT(MAX(B(N,N),ZERO))/PI2
                PHMT=ATAN2(F(3),F(2))/PI2
                DPHMT=SQRT(F(2)*F(2)*B(3,3)+F(3)*F(3)*B(2,2))/
     $             (F(2)*F(2)+F(3)*F(3))
                EPMAX=(HALF*HALF-PHMT)/FREQ+TM
                IF (PHMT.LT.ZERO) PHMT=PHMT+ONE
                MSG='   frequency        error         '//
     $            'phase at m.t.  error        '
                CALL STTPUT(MSG,ISTAT)
                WRITE(MSG,'(1x,5(1pe15.7))') FREQ,DFREQ,PHMT,DPHMT
                CALL STTPUT(MSG,ISTAT)
                CALL STTPUT(
     $          '   epoch of max.    mean time    ',ISTAT)
                WRITE(MSG,'(1x,5(1pe15.7))') EPMAX,TM
                CALL STTPUT(MSG,ISTAT)
              ENDIF
            ENDIF
C
C      next iterations with period correction
            N=NORD
            START=.FALSE.
            GOTO 100
          ELSE
            CALL STETER(4,
     $          ' Singular equations, or wrong dimensions ')
          ENDIF
        ENDIF
C        end loop 100
      IF (MODE.EQ.1) THEN
        F(NORD)=F(NORD)/PI2
      ENDIF
      END
C
C
C
      SUBROUTINE FITSIN(E,N1,P,NP)
C
C    condition equations for fit of Fourier series,
C    last term contains residuals
C
      INCLUDE 'MID_REL_INCL:TSA_DEF.INC'
C
      INTEGER N1,NP
      DOUBLE PRECISION E(N1),P(N1-1+NP)
C
      INTEGER J,NORD,NFR,L
      REAL SJ,CJ,T,X,FR,S,C,RHS,SAVE
C
      INCLUDE 'MID_REL_INCL:TSA_CONST.INC'
      NORD=(N1-2)/2
      NFR=2*(NORD+1)
      T=P(NFR+1)
      X=P(NFR+2)
      FR=P(NFR)
      S=SIN(T*FR)
      C=COS(T*FR)
      SJ=S
      CJ=C
      E(NFR)=ZERO
      E(1)=ONE
      RHS=X-P(1)
      DO 4 J=1,NORD
        L=2*J
        E(L)=SJ
        E(L+1)=CJ
        E(NFR)=E(NFR)+J*T*(P(L)*CJ-P(L+1)*SJ)
        RHS=RHS-P(L)*SJ-P(L+1)*CJ
        SAVE=CJ*C-SJ*S
        SJ=CJ*S+SJ*C
 4      CJ=SAVE
      E(N1)=RHS
      END
C
C
C
C
C
C
C
C
C

C @(#)mode.for	19.1 (ES0-DMD) 02/25/03 13:30:47
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine MODE         version 3         820518
C  A. Kruszewski           ESO - Garching
C.PURPOSE
C  calculates mode of data contained in array "A"
C.ALGORITHM
C  mode is calculated with use of relation between mean, median
C  and mode, see:  Kendall, M., Stuart, A. 1977, The Advanced Theory
C  of Statistics, 4-th edition, p. 40
C  as this relation is valid only for mildly assymetric distributions
C  the data is repeatedly clipped around previous value of mode
C  first truncation is made around starting value of mean
C  if the dimension "N" of array "A" is greater than 5000 then only
C  every II-th element is used where II=N/5000+1
C
C  control array "CRMD" holds three parameters:
C  "CRMD(1)" introduces possibility of choice between mode and mean
C  subroutine returns mode when "CRMD(1)=3.0"
C  subroutine returns clipped mean when "CRMD(1)=0.0"
C  other values of "CRMD(1)" can be used when necessary
C  "CRMD(3)" is a clipping factor - data is clipped by "SIGMA*CRMD(3)"
C  from both sides of recent value of "AMODE"
C  iterations are terminated when the difference between two last
C  values of mode divided by last value of sigma is smaller than
C  "CRMD(2)"
C  maximum number of iterations is 10
C.INPUT/OUTPUT
C  input arguments:
C  A           real array        data array
C  N           integer           number of values in "A"
C  CRMD        real array        values of control parameters
C  output arguments:
C  AMODE       real              mode of array "A"
C  SIGMA       real              sigma of "A" after last clipping
C-----------------------------------------------------------------------
      SUBROUTINE MODE(A,N,CRMD,AMODE,SIGM)
C
      IMPLICIT NONE
      INTEGER  N
      REAL     A(N)
      REAL     CRMD(3)
      REAL     SIGM
C
      INTEGER  I, IC, II, IN, INN, L
      REAL     ALC, AHC, AMEAN, AMED, AMODE
      REAL     B(5000), C(5000), CFTR
      REAL     DFTR, SCR, SIGMA, SFTR
C
C
      DFTR = CRMD(1)
      CFTR = CRMD(2)
      SFTR = CRMD(3)
C
C *** Define array B of dimension IN.
      IF (N.GT.5000) THEN
         II = (N-1) / 5000 + 1
         IN = N / II
         INN = II * IN
         DO 10 I = II , INN , II
            B(I/II) = A(I)
   10    CONTINUE
      ELSE
         DO 11 I = 1 , N
            B(I) = A(I)
   11    CONTINUE  
         IN = N
      ENDIF
C
C *** Calculate mean of non truncated data and
C *** set it as a first approximation for mode.
      CALL MEAN(B, IN, AMODE, SIGMA)
      SIGM = SIGMA
C
C *** Set iteration control.
      IC = 9
C
C *** Perform iterations.
   12 CONTINUE 
C
C *** Save recent value of mode.
      SCR = AMODE
C
C *** Set limits of truncation.
      ALC = AMODE - SFTR * SIGMA
      AHC = AMODE + SFTR * SIGMA
C
C *** Continue iterations.
      L=0
      DO 13 I = 1 , IN
         IF ( B(I) .GT. ALC .AND. B(I) .LT. AHC ) THEN
            L = L + 1
            C(L) = B(I)
         ENDIF
   13 CONTINUE 
C
C *** Stops iterations if number of data points
C *** after recent truncation is less than 2.
      IF ( L .LT. 2 ) THEN
         IC = 0
      ELSE
         CALL MEAN(C, L, AMEAN, SIGMA)
C
C *** Replaces mode with mean when DFTR.LE.0.1.
         IF ( DFTR .GT. 0.1 ) THEN
            CALL MEDIAN(C, L, ALC, AHC, AMED)
            IF ( L .GE. 10 ) THEN
               AMODE = DFTR * AMED - (DFTR-1.0) * AMEAN
            ELSE
               AMODE = AMED
            ENDIF
         ELSE
            AMODE=AMEAN
         ENDIF
C   
C *** Compare two most recent values of mode and
C *** stop iterations if they differ by less than
C *** expected mean error of the mean of truncated
C *** distribution multiplied by factor 'SGFACTOR'.
         SCR = MAX( ABS(SCR-AMODE) , ABS(AMODE-AMEAN) )
C
C *** Stops iterations if sigma is not positive.
         IF (SIGMA.LE.0.0) THEN
            IC=0
         ELSE
            SCR = SCR / ( SQRT( (SIGMA*SIGMA)/L ) )
            IF ( SCR .LT. CFTR ) THEN
               IC = 0
            ELSE
               IC = IC - 1
            ENDIF
         ENDIF
      ENDIF
      IF (IC.GT.0) GOTO 12
C
      RETURN
      END

C @(#)rfotregist.for	19.1 (ES0-DMD) 02/25/03 13:30:15
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
       PROGRAM REGIST
C+++
C.IDENTIFICATION: RFOTREGIST
C.PURPOSE: Compute the absolute quantities and store the results in the final
C          MIDAS table
C.AUTHOR:  R. Buonanno, G. Buscema, C. Corsi, I. Ferraro, G. Iannicola
C          Osservatorio Astronomico di Roma
C.VERSION: 16.09.87 First running version at ESO (outside MIDAS)   R. Buonanno
C          17.12.87 Installation in MIDAS                          R.H. Warmels
C          24.10.88 New version                                    R. Buonanno
C          14.06.89 Rewritten for the portable MIDAS version 
C                   Inclusion of MIDAS tables                      R.H. Warmels
C----
      IMPLICIT       NONE
      INCLUDE        'MID_REL_INCL:RFOTDECL.INC'
C
      INTEGER        NMAX
      INTEGER        NCPAR
      INTEGER        NRREG
      PARAMETER      (NMAX=256)
      PARAMETER      (NCPAR=12)
      PARAMETER      (NRREG=10000)
C ***
      INTEGER        ED, EC, EL
      INTEGER        ICPAR(NCPAR)
      INTEGER        IDENT(NRREG)
      INTEGER        IROW, ICIDN, IREGI, IGRP
      INTEGER        ISTAT, IAC, IAV
      INTEGER        I, IS, IH, IC, IK, IVN
      INTEGER        KUN, KNUL, KONT
      INTEGER        IPX, IPY
      INTEGER        JC
      INTEGER        K7, K8
      INTEGER        LF9
      INTEGER        MADRID(1)
      INTEGER        NRINT,NCINT
      INTEGER        NACINT,NARINT,NSINT
      INTEGER        NOBJ, NGRP, NSR
      INTEGER        NCP, NHL, NCOM
      INTEGER        NCREG
      INTEGER        REGTYP, REGCOL
      INTEGER        TIDINT
      INTEGER        TIDREG
C ***
      REAL           ABC
      REAL           ALTMIN
      REAL           B, BETA
      REAL           BU(NMAX)
      REAL           DATR(NCPAR,NRREG)
      REAL           D1, D2, D3, D4, D6, D7
      REAL           FOG, FAT, FONDF, FOND
      REAL           GRE
      REAL           P(NMAX)
      REAL           SIGMA, SOFOT, SAT 
      REAL           PP1, PP2
      REAL           SQM(NMAX), SIQ(NMAX)
      REAL           U
      REAL           V
      REAL           VOL
C ***
      CHARACTER*60   INTFIL
      CHARACTER*60   REGFIL
      CHARACTER*80   STRING
      CHARACTER*16   LABEL(NCPAR),REGLAB
      CHARACTER*16   UNIT(NCPAR),REGUNI
      CHARACTER*16   REGFOR
      CHARACTER*16   FORMR4,FORMI4
      CHARACTER*1    SST, CAR
C ***
      INCLUDE        'MID_INCLUDE:TABLES.INC'
      COMMON         /VMR/MADRID
      INCLUDE        'MID_INCLUDE:TABLED.INC'
C ***
      DATA           ICIDN/1/
      DATA           FORMI4/'I6'/
      DATA           FORMR4/'E12.4'/
      DATA     LABEL /'X      ', 'Y      ', 'INT    ', 'BG      ', 
     2                'MAG1   ', 'MAG2   ', 'MAG3   ', 'MAG_CNV ', 
     3                'SIGMA  ', 'BETA   ', 'SIQ    ', 'CHI_SQ  '/
      DATA     UNIT  /'PIXEL  ', 'PIXEL  ', '       ', '        ',
     2                'MAG.   ', 'MAG.   ', 'MAG.   ', 'MAG.    ',
     3                '       ', '       ', '       ', '        '/
C ***
 9001  FORMAT('*** INFO: Window ',I5,' not fitted')
 9002  FORMAT('*** INFO: Window ',I5,' not registered (no conv. ',
     *        'or already regist.)')
C----------------------------------------------------------------------------
      CALL STSPRO('REGISTER')
C
C *** get the input
      CALL STKRDC('IN_A',1,1,60,IAC,INTFIL,KUN,KNUL,ISTAT)
      CALL STKRDC('OUT_A',1,1,60,IAC,REGFIL,KUN,KNUL,ISTAT)
C
C ***
      CALL STECNT('GET',EC,ED,EL)
      CALL STECNT('PUT',1,0,0)
      CALL TBTOPN(INTFIL,F_I_MODE,TIDINT,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL: Error opening intermediate table'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
C
      CALL TBIGET(TIDINT,NCINT,NRINT,NSINT,NACINT,NARINT,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL: Problems with getting table info '//
     2            'of intermediate table'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
      IF (NRINT.EQ.0) THEN
         STRING = '*** FATAL: There are no data in the intermediate '//
     2            'table'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
C
C *** create the registration table
      NCREG = NCPAR + 1
      CALL TBTINI(REGFIL,0,F_O_MODE,NCREG,NRREG,TIDREG,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL:  Problems with opening a new '//
     2            'registration table'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
      CALL STECNT('PUT',EC,ED,EL)
C
      REGTYP = D_I4_FORMAT
      REGFOR = FORMI4
      REGUNI = '   '
      REGLAB = 'IDENT'
      CALL TBCINI(TIDREG,REGTYP,1,REGFOR,REGUNI,
     2                   REGLAB,REGCOL,ISTAT)       ! create the ident column
C
      DO 101 I = 1,NCPAR
         ICPAR(I) = I + 1
         REGTYP   = D_R4_FORMAT
         REGFOR   = FORMR4
         REGUNI   = UNIT(I)
         REGLAB   = LABEL(I)
         CALL TBCINI(TIDREG,REGTYP,1,REGFOR,REGUNI,
     2                      REGLAB,REGCOL,ISTAT)  ! create the data columns
  101 CONTINUE
C
C *** read the window and object option
      CALL STKRDC('INPUTC',1,1,1,IAV,CAR,KUN,KNUL,ISTAT)
      CALL STKRDC('INPUTC',1,2,1,IAV,SST,KUN,KNUL,ISTAT)
C
C *** read the table descriptor
      CALL INTDRD(TIDINT,NGRP,NOBJ,NSR,SAT,FAT,SIGMA,BETA,SOFOT,
     2                   ALTMIN,FOG)
C
C *** do the work
      KONT = 0
      IROW = 1
      IGRP = 1
C
 1001 CONTINUE
         CALL INTWRD(TIDINT,IROW,NCP,NHL)
         D1   = PARINT(1)
         D2   = PARINT(2)
         V    = PARINT(3)
         B    = PARINT(4)
         U    = PARINT(5)
         D3   = PARINT(6)
         D4   = PARINT(7)
         P(1) = PARINT(8)
         P(2) = PARINT(9)
         P(3) = PARINT(10)
         BETA = PARINT(11)
         D7   = PARINT(12)
         D6   = PARINT(13)
         GRE  = PARINT(14)
C 
         DO 1011 IS = 1,NCP
            P((IS-1)*4+4) = FITCMP((IS-1)*6+1)
            P((IS-1)*4+5) = FITCMP((IS-1)*6+2)
            P((IS-1)*4+6) = FITCMP((IS-1)*6+3)
            P((IS-1)*4+7) = FITCMP((IS-1)*6+4)
            SQM(IS)       = FITCMP((IS-1)*6+5)
            SIQ(IS)       = FITCMP((IS-1)*6+6)
 1011    CONTINUE
C
         DO 1012 IH = 1,NHL
            BU((IH-1)*3+1) = FITHOL((IH-1)*3+1) 
            BU((IH-1)*3+2) = FITHOL((IH-1)*3+2) 
            BU((IH-1)*3+3) = FITHOL((IH-1)*3+3) 
 1012    CONTINUE
C
C ***********************************************************

         IREGI = 0
         IF (CAR.EQ.'A') THEN
            IREGI = 1
         ENDIF
         IF (CAR.EQ.'F' .AND. GRE.NE.2) THEN
            IREGI = 1
         ENDIF
C
         IF (IREGI.EQ.1) THEN
            IPX  = INT(D1)
            IPY  = INT(D2)
            NCOM = 0
            LF9  = 0
C
            DO 1013 IC = 1,NCP
               K7 = (IC-1)*4 + 4
               IVN  = FLGCMP(IC)
               IF (IVN.EQ.1 .OR. CAR.EQ.'A' .OR. IVN.EQ.2) THEN
C*** 
C                           CAR=F                       CAR=A
C                             |                           |
C                       ______|______               ______|______
C                      |             |             |             |
C                      |             |             |             |
C                   F.R.:NO      F.R.:NO       F.R.:VOL=0    F.R.:VOL=0
C                 TESTEF:VOL   TESTEF:VOL=0    TESTEF:VOL   TESTEF:VOL=0
C ***
                  IF (IVN.EQ.1 .OR. (IVN.EQ.2 .AND. SST.EQ.'Y')) THEN
                     LF9   = 1
                     KONT  = KONT+1
                     FOND  = P(1)*P(K7+1)+P(2)*P(K7+2)+P(3)
                     FONDF = 0.
C
                     DO 1014 JC = 1,NCP
                        K8 = (JC-1)*4+4
                        IF (K8.NE.K7) THEN
                           IF (FLGCMP(JC).EQ.1) THEN
                              ABC = ((P(K7+1)-P(K8+1))**2 + 
     2                               (P(K7+2)-P(K8+2))**2)/P(K8+3)**2
                              IF (BETA.EQ.0.) THEN
                                 ABC = P(K8)*EXP(-ABC*4*ALOG(2.))
                              ELSE
                                 ABC = P(K8)*(1+ABC)**(-BETA)
                              END IF
                              FONDF = FONDF + ABC
                           END IF
                        END IF
 1014                CONTINUE
                     FOND = FOND+FONDF
C
                     IF (BETA.EQ.0.) THEN
                        IF (P(K7).LE.0.) THEN
                           VOL = 0.
                        ELSE
                           VOL = -2.5*ALOG10(P(K7+3)**2*
     2                               P(K7)*3.1416/(4*ALOG(2.)))
                        END IF
                     ELSE
                        IF (P(K7).LE.0.) THEN
                           VOL = 0.
                        ELSE
                           VOL = -2.5*ALOG10(3.14159*
     2                               P(K7+3)**2*P(K7)/(BETA-1))
                        END IF
                     END IF
C
                  ELSE
                     KONT = KONT+1
                     VOL  = 0
                  END IF
C
                  PP1      = P(K7+1)+IPX-1
                  PP2      = P(K7+2)+IPY-1
C
                  IDENT(KONT)   = IDNGRP*100+(IDNCMP(IC)-100)
                  DATR(1,KONT)  = PP1
                  DATR(2,KONT)  = PP2
                  DATR(3,KONT)  = P(K7)
                  DATR(4,KONT)  = FOND
                  DATR(5,KONT)  = V
                  DATR(6,KONT)  = B
                  DATR(7,KONT)  = U
                  DATR(8,KONT)  = VOL
                  DATR(9,KONT)  = P(K7+3)
                  DATR(10,KONT) = BETA
                  DATR(11,KONT) = SIQ(IC)
                  DATR(12,KONT) = SQM(IC)
               END IF
 1013       CONTINUE
C
         ELSE
            IF (GRE.EQ.0) THEN
               WRITE (STRING,9001) IC
            ELSE
               WRITE(STRING,9002) IC
            END IF
            CALL STTPUT(STRING,ISTAT)
         END IF
         IROW = IROW + NCP + NHL
         IF (IROW.LE.NRINT) then
            GO TO 1001
         ENDIF
C
C *** fill the table
      DO 102 IK = 1,KONT
         CALL TBRWRI(TIDREG,IK,1,ICIDN,IDENT(IK),ISTAT)
         CALL TBRWRR(TIDREG,IK,NCPAR,ICPAR,DATR(1,IK),ISTAT)
  102 CONTINUE
      CALL TBSINI(TIDREG,ISTAT)
      CALL TBTCLO(TIDREG,ISTAT)
      CALL STSEPI
      END

C @(#)spec2.for	19.1 (ES0-DMD) 02/25/03 13:24:48
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
       PROGRAM SPEC2
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C
C  Program SPEC2                  version 1.00   860806
C                                 version 2.00   890424 (pMIDAS)
C  F. Murtagh                            STECF              
C  M. Peron                              IPG     890901 add include files
C  P. Ballester                          IPG     910313 Compil. option -u
C                                                       and more
C
C.KEYWORDS
C  Simulated images, test images.
C
C.PURPOSE
C  Create sloping "ripple" image, given the slope, amplitude, period, 
C  phase, and dimensions of the image; and the deviates from the mean
C  of each pixel.
C
C.OUTPUT
C
C  Keys:  OUT_A/C/1/60       output data array
C         INPUTR/R/1/1       slope
C         INPUTI/I/1/1       phase
C         INPUTI/I/2/1       frame dimensions
C         INPUTI/I/3/1       period
C         RIPVALS/I/1/10     ripple values (pixel deviates from mean)
C
C-----------------------------------------------------------
C
C
       IMPLICIT NONE
C
       REAL                     RMIN,RMAX
       REAL                     STEPO(3),STARTO(3),CUTS(4)
       DOUBLE PRECISION         DSTEP(3),DSTART(3)
       INTEGER                  NPIXO(3),PERIOD,IVALS(10),PHASE
       INTEGER                  MADRID,KUN,KNUL
       CHARACTER*1              TYPE
       CHARACTER*60             OUTIMA
       CHARACTER*80             IDENTO
       CHARACTER*80             CUNITO
C
       INTEGER                  IACT,ISTAT,IDIM,IBYT,NDIMO
       INTEGER*8                JPNTR
       INTEGER                  IMNO,KUNIT
       REAL                     SLOPE
C
        INCLUDE                 'MID_INCLUDE:ST_DEF.INC/NOLIST'
        COMMON                  /VMR/MADRID(1)
        INCLUDE                 'MID_INCLUDE:ST_DAT.INC/NOLIST'

C
C
C ... get into MIDAS
C
       CALL STSPRO('SPEC2')
C
C ... get name of output frame
C
        CALL STKRDC('OUT_A',1,1,60,IACT,OUTIMA,KUN,KNUL,ISTAT)
C
C ... get slope, amplitude, period, phase and frame dimensions.
C
        CALL STKRDR('INPUTR',  1,1,IACT,SLOPE, KUN,KNUL,ISTAT)
        CALL STKRDI('INPUTI',  1,1,IACT,PHASE, KUN,KNUL,ISTAT)
        CALL STKRDI('INPUTI',  2,1,IACT,IDIM,  KUN,KNUL,ISTAT)
        CALL STKRDI('INPUTI',  3,1,IACT,PERIOD,KUN,KNUL,ISTAT)
       IF (PERIOD.LE.0) THEN
          CALL STTPUT(' The period must be > 0.',ISTAT)
          CALL STTPUT(' Using period = 10.',ISTAT)
          PERIOD = 10
       ENDIF
       IF (PERIOD.GT.20) THEN
          PERIOD = MOD(PERIOD,20)
          CALL STTPUT(' The period is > 20.',ISTAT)
          CALL STTPUT(' Using period = mod(period,20).',ISTAT)
       ENDIF
C
C ... get deviates of pixels from mean.
C
        CALL STKFND('RIPVALS',TYPE,IACT,IBYT,ISTAT)
       IF (TYPE.EQ.' ') THEN     
C          (KEYWORD NOT PRESENT)
          IVALS(1) = 4
          IVALS(2) = 5
          IVALS(3) = 6
          IVALS(4) = 3
          IVALS(5) = 2
          IVALS(6) = 7
          IVALS(7) = 1
          IVALS(8) = 4
          IVALS(9) = 5
          IVALS(10) = 0
       ELSE
           CALL STKRDI('RIPVALS',1,PERIOD,IACT,IVALS,KUN,KNUL,ISTAT)
       ENDIF
C
C ... map output image
C
       NDIMO = 1
       NPIXO(1)  = IDIM
       STARTO(1) = 1
       STEPO(1)  = 1.0
       CUNITO    = ' NONE'
       IDENTO    = ' ARTIFICIAL RIPPLE 1-D IMAGE' 
        DSTART(1) = STARTO(1) 
        DSTEP(1)  = STEPO(1)
        CALL STIPUT(OUTIMA,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,NDIMO,
     .               NPIXO,DSTART,DSTEP,
     .               IDENTO,CUNITO,JPNTR,IMNO,ISTAT)
C
C ... now do the work
C
       CALL PATTRN(MADRID(JPNTR),RMIN,RMAX,SLOPE,PERIOD,PHASE,
     X      IDIM,IVALS,ISTAT)
C
C ... write cuts
C
       CUTS(1) = RMIN
       CUTS(2) = RMAX
       CUTS(3) = RMIN
       CUTS(4) = RMAX
        CALL STDWRR(IMNO,'LHCUTS',CUTS,1,4,KUNIT,ISTAT)
C
C ... end
C
        CALL STSEPI
       END

C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C
C  Program PATTRN    
C  F. MURTAGH                                 ST-ECF  Version 1.0 860411
C
C.KEYWORDS
C
C  Test patterns, simulated images.
C
C
C.OUTPUT PARAMETERS
C 
C  ARR  = the frame,
C  RMIN, RMAX = cut values (max. and min. flux values).
C
C----------------------------------------------------------------------
       SUBROUTINE PATTRN(ARR,RMIN,RMAX,SLOPE,PERIOD,PHASE,IDIM,
     X                          IVALS,ISTAT)
C
       IMPLICIT NONE
C
       INTEGER              IDIM,ISTAT,NDIM1,I,IVAL,ILOC
       REAL                 ARR(IDIM)
       INTEGER              IVALS(10),PERIOD,PHASE
C
       REAL                 MEAN,RMIN,RMAX,SLOPE
C
C
C
       NDIM1 = IDIM
       MEAN = 0.0
       DO I = 1, IDIM
          ARR(I) = MEAN
       ENDDO
C
       IVAL = PHASE
       DO I = 1, IDIM
          ILOC = MOD(I+IVAL-1,PERIOD)
          IF (ILOC.EQ.0) ILOC = PERIOD
          ARR(I) = ARR(I) + IVALS(ILOC)
          ARR(I) = ARR(I)+SLOPE*FLOAT(I)                 ! Slope this.  
       ENDDO
C
C ------DETERMINE CUTS (I.E. MAX AND MIN VALUES)---------------------
C
       RMIN = 1000000.
       RMAX = -100000.
       DO I = 1, NDIM1
          IF (ARR(I).LT.RMIN) RMIN = ARR(I)
          IF (ARR(I).GT.RMAX) RMAX = ARR(I)
       ENDDO
C
C
       RETURN
C
       END

C===========================================================================
C Copyright (C) 1995-2008 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM GENXX1
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  program  GENXX1			 version 1.00	890704
C  K. Banse                 		 ESO - Garching
C  1.10	891124		
C
C.KEYWORDS
C  image processing functions
C
C.PURPOSE
C  merger of several functions, see description there
C
C.ALGORITHM
C  see local descriptions
C
C.INPUT/OUTPUT
C  the following keys are used:
C
C  ACTION/C/1/2		action flag
C			= ED, for edge detection
C			= EX, for general extract routines
C			= EZ, for reference frame extraction
C			= IN, for inserting an image
C			= MP, for mapping images
C			= MA, for matrix operations
C
C.VERSION
C  1.00		merge former individual main programmes
C
C 080122	last modif
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER    IAV,STAT
      INTEGER    UNI(1),NULO
C
      CHARACTER  ACTION*4
C
C  set up MIDAS environment + enable automatic error abort
      CALL STSPRO('GENXX1')
C
C  get option
      CALL STKRDC('ACTION',1,1,3,IAV,ACTION,UNI,NULO,STAT)
C 
      IF (ACTION(1:2).EQ.'ED') THEN
         CALL SUBEDG
      ELSE IF (ACTION(1:2).EQ.'EX') THEN
         CALL SUBEXT
      ELSE IF (ACTION(1:2).EQ.'IN') THEN
         CALL SUBINS
      ELSE IF (ACTION(1:2).EQ.'MP') THEN
         CALL SUBMAP
      ELSE IF (ACTION(1:2).EQ.'MA') THEN
         CALL SUBMAT
      ELSE IF (ACTION(1:2).EQ.'EZ') THEN
         IF (ACTION(3:3).EQ.'O') THEN
            IAV = -1
         ELSE IF (ACTION(3:3).EQ.'I') THEN
            IAV = 1
         ELSE
            IAV = 0			!old single value threshold 
         ENDIF
         CALL SUBEZT(IAV)
      ENDIF
C
C  get away 
      CALL STSEPI
      END

      SUBROUTINE SUBEDG
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine SUBEDG         	 version 1.00	881028
C  K. Banse                 	 ESO - Garching
C
C.KEYWORDS
C  edge detection
C
C.PURPOSE
C  detect edges in a given data frame
C
C.ALGORITHM
C  get the names of input + output frames from IN_A + OUT_A
C  get the threshold for algorithm from INPUTR
C  and calculate edge pixels via subroutine FNDEDGE (see description
C  of algorithm there)
C
C.INPUT/OUTPUT
C  the following keys are used:
C
C  IN_A/C/1/80			input data frame
C  P4/C/1/1			edge detection method
C				= B, use band - method
C				= S, use Sobel operator
C  OUT_A/C/1/80			output data frame
C  DEFAULT/C/1/1		default flag, if = Y, use half of dynamic range of input frame
C				as threshold, else read it from INPUTR
C  INPUTR/R/1/1			threshold for edge detection
C
C.VERSION
C  1.00		from version 2.00 as of 841120
C		move to FORTRAN 77 + new ST interfaces
C
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER    NAXISA,IAV,STAT
      INTEGER*8  PNTRA,PNTRC
      INTEGER    IMNOA,IMNOC
      INTEGER    NPIXA(3)
      INTEGER    UNI(1),NULO,MADRID(1)
C
      CHARACTER*80   FRAMEA,FRAMEC
      CHARACTER      CUNITA*64,IDENTA*72
      CHARACTER      DEFAUL*1,ACTION*1
C
      REAL       THRESH,LHCUTS(2)
      REAL       OLDCUT(2)
C
      DOUBLE PRECISION STEPA(3),STARTA(3)
C
      COMMON /VMR/ MADRID
C
      INCLUDE  'MID_INCLUDE:ST_DEF.INC'
C
      DATA       LHCUTS    /0.,1./
      DATA       IDENTA    /' '/,   CUNITA  /' '/
C
      INCLUDE  'MID_INCLUDE:ST_DAT.INC'
C
C  get input frame + map it
      CALL STKRDC('IN_A',1,1,80,IAV,FRAMEA,UNI,NULO,STAT)
      CALL STIGET(FRAMEA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +            3,NAXISA,NPIXA,STARTA,STEPA,
     +            IDENTA,CUNITA,PNTRA,IMNOA,STAT)
C
C  get output frame + map it (=edge file) + copy standard descriptors
      CALL STKRDC('OUT_A',1,1,80,IAV,FRAMEC,UNI,NULO,STAT)
      CALL STIPUT(FRAMEC,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +            NAXISA,NPIXA,STARTA,STEPA,
     +            IDENTA,CUNITA,PNTRC,IMNOC,STAT)
C
C  get threshold + method
      CALL STKRDC('DEFAULT',1,1,1,IAV,DEFAUL,UNI,NULO,STAT)
      IF ( (DEFAUL.EQ.'Y') .OR. (DEFAUL.EQ.'y') ) THEN
         CALL STDRDR(IMNOA,'LHCUTS',3,2,IAV,OLDCUT,UNI,NULO,STAT)
         THRESH = (OLDCUT(2) - OLDCUT(1)) * .5
      ELSE
         CALL STKRDR('INPUTR',1,1,IAV,THRESH,UNI,NULO,STAT)
      ENDIF
      CALL STKRDC('P4',1,1,1,IAV,ACTION,UNI,NULO,STAT)
      CALL UPCAS(ACTION,ACTION)
C
C  now do the edge detection
      CALL FNDEDG(ACTION,MADRID(PNTRA),NPIXA(1),NPIXA(2),
     +            THRESH,MADRID(PNTRC))
      CALL STDWRR(IMNOC,'LHCUTS',LHCUTS,3,2,UNI,STAT)
C
      RETURN
      END

      SUBROUTINE SUBEXT
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine SUBEXT			version 1.00	881028
C  K. Banse            		 	ESO - Garching
C  981016
C
C.KEYWORDS
C  bulk data frames
C
C.PURPOSE
C  extract a subframe from a given frame
C
C.ALGORITHM
C  get output frame from OUT_A
C  get relevant coordinates as character data from INPUTC or via cursor
C
C.INPUT/OUTPUT
C  the following keys are used:
C  
C  IN_A/C/1/80		input frame
C  OUT_A/C/1/80		result frame
C  ACTION/C/3/2		action flag
C  action flag = IM: extract subframe from coord interval
C              = IC: extract subframe around center coord
C              = LI: extract a line in any direction from a higher
C                    dimensioned frame
C  if action flag = IM
C  INPUTC/C/1/80	character string of coordinates
C			in the form: [x1,y1,z1:x2,y2,z2] 
C			x,y,z according to the MIDAS standard for 
C			specifying coordinates
C  or if centered extract
C  INPUTC/C/1/80	[xc,yc,zc]
C  INQXI/I/I/1/3	xl,yl,zl        (0,...,NPIX)
C  INQXI/I/I/4/3	xr,yr,zr        (0,...,NPIX)

C  if action flag = LI
C  INPUTC/C/1/80	character string of coordinates
C			in the form: [x1,y1,z1:x2,y2,z2] 
C  INPUTD/D/1/1		stepsize for line
C	
C.VERSIONS
C 
C 021212	last modif	25 years ...
C 
C--------------------------------------------------
C
      IMPLICIT NONE
C      
      INTEGER      IAV,IAX,N,NINDX,NN,REFSET
      INTEGER      NAXISA,NAXISC,STAT
      INTEGER*8    PNTRA,PNTRC,PNTRX,PNTRY
      INTEGER      NPIXA(3),NPIXC(3)
      INTEGER      RETBUF(3),SUBLO(3),SUBHI(3)
      INTEGER      MADRID(1),UNI(1),NULO
      INTEGER      IMNOA,IMNOC
      INTEGER      NPXY,K2,RMAIND,CHUCHO,CHUCHI
      INTEGER      NOLIN,TRUSIZ,CHUNKI,CHUNKO,K1,KOFF,MOFF,LOOPLM
      INTEGER      PXOFF(6),PCENT(3),CLONY
C
      CHARACTER*80   FRAMEA,FRAMEC,EQUAL
      CHARACTER      CUNITA*64,ACTION*2
      CHARACTER      INPUTC*80
      CHARACTER      ERROR1*40,ERROR2*40,ERROR3*40
      CHARACTER*72   IDENTA
C      
      DOUBLE PRECISION STARTA(3),STARTC(3),STEPA(3),STEPC(3),STEPLN
      DOUBLE PRECISION DIN(4),DOUT(4)
C 
      REAL           CUTS(4),RM,DIST,WW(2)
      REAL           XA,XB,YA,YB
C 
      INCLUDE  'MID_INCLUDE:ST_DEF.INC'
C 
      INCLUDE  'MID_INCLUDE:IDIDEV.INC'
      INCLUDE  'MID_INCLUDE:IDIMEM.INC'
C 
      COMMON   /VMR/  MADRID
C
      DATA      ERROR1   /'invalid coordinate string ... '/
      DATA      ERROR2   /'problems with dynamic range... '/
      DATA      ERROR3   /'max. 3-dim images supported... '/
      DATA      STEPA    /3*1.D0/, STARTA /3*0.D0/
      DATA      STEPC    /3*1.D0/, STARTC /3*0.D0/
      DATA      NPIXA    /3*1/,    NPIXC /3*1/
      DATA      SUBLO    /1,1,1/,  SUBHI /1,1,1/
      DATA      CUTS     /0.,0.,0.,0./
      DATA      IDENTA   /' '/
      DATA      CUNITA   /' '/
      DATA      PXOFF    /6*0/
C 
      INCLUDE  'MID_INCLUDE:ST_DAT.INC'
C
C  get name of input frame, result frame, descr_copy_flag + action flag
      CALL STKRDC('IN_A',1,1,80,IAV,FRAMEA,UNI,NULO,STAT)
      CALL CLNFRA(FRAMEA,FRAMEA,0)
      CALL STKRDC('OUT_A',1,1,80,IAV,FRAMEC,UNI,NULO,STAT)
      CALL STKRDC('ACTION',1,3,2,IAV,ACTION,UNI,NULO,STAT)
      CLONY = 0
C      
C  get string with coordinates
      REFSET = 0                     !set to 1, if we update REFPIX descr.
      CALL STKRDC('INPUTC',1,1,80,IAV,INPUTC,UNI,NULO,STAT)
C
C  check if we shrink same frame
      CALL GENEQF(FRAMEA,FRAMEC,STAT)
      IF (STAT.EQ.1) THEN                !if same name, use temporary one
         EQUAL(1:) = FRAMEC(1:)
         FRAMEC(1:) = 'middummeq.bdf '
      ELSE
         EQUAL(1:) = '  '
      ENDIF
C      
C  and open input frame or open + already map it
      IF (ACTION(1:1).EQ.'I') THEN
         CALL STFOPN(FRAMEA,D_R4_FORMAT,0,F_IMA_TYPE,IMNOA,STAT)
         CALL STDRDI(IMNOA,'NAXIS',1,1,IAV,NAXISA,UNI,NULO,STAT)
         IF (NAXISA.GT.3) CALL STETER(44,ERROR3)
         CALL STDRDI(IMNOA,'NPIX',1,NAXISA,IAV,NPIXA,UNI,NULO,STAT)
         CALL STDRDD(IMNOA,'START',1,NAXISA,IAV,STARTA,UNI,NULO,STAT)
         CALL STDRDD(IMNOA,'STEP',1,NAXISA,IAV,STEPA,UNI,NULO,STAT)
         CALL STDRDC(IMNOA,'IDENT',1,1,72,IAV,IDENTA,UNI,NULO,STAT)
         N = (NAXISA+1) * 16
         CALL STDRDC(IMNOA,'CUNIT',1,1,N,IAV,CUNITA,UNI,NULO,STAT)
C  
C  check if centered extract
         IF (ACTION(2:2).EQ.'C') THEN             !Yes, centered extraction
            CALL STKRDI('INQXI',1,6,IAV,PXOFF,UNI,NULO,STAT)
            CALL EXTCO1(IMNOA,INPUTC,NAXISA,NAXISC,PCENT,STAT)
            IF (STAT.NE.0) CALL STETER(1,ERROR1)
            SUBLO(1) = PCENT(1) - PXOFF(1)
            SUBHI(1) = PCENT(1) + PXOFF(4)
            IF (NAXISC.GT.1) THEN
               SUBLO(2) = PCENT(2) - PXOFF(2)
               SUBHI(2) = PCENT(2) + PXOFF(5)
               IF (NAXISC.GT.2) THEN
                  SUBLO(3) = PCENT(3) - PXOFF(3)
                  SUBHI(3) = PCENT(3) + PXOFF(6)
               ENDIF
            ENDIF
            DO 440, N=1,NAXISC
               IF ( (SUBLO(N).LT.1) .OR.
     +              (SUBLO(N).GT.SUBHI(N)) .OR.
     +              (SUBHI(N).GT.NPIXA(N)) )
     +            CALL STETER(4,'invalid pixel offsets ... ')
440         CONTINUE
            GOTO 480
         ENDIF
      ELSE
         CALL STIGET(FRAMEA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,3,
     +            NAXISA,NPIXA,STARTA,STEPA,
     +            IDENTA,CUNITA,PNTRA,IMNOA,STAT)
         IF (NAXISA.GT.3) CALL STETER(44,ERROR3)
      ENDIF
      CALL FPXWCO(0,IMNOA,DIN,DOUT,STAT)               !init wcs conversion
C 
C  copy subframe or extract a line
      CALL EXTCOO(IMNOA,INPUTC,NAXISA,NAXISC,SUBLO,SUBHI,STAT)
      IF (STAT.NE.0) CALL STETER(1,ERROR1)
C      
C  get start + end pixels of subframe within father frame 
480   DO 500 N=1,NAXISC
         DIN(N) = SUBLO(N)                             !in fp's
         NPIXC(N) = SUBHI(N) - SUBLO(N) + 1
500   CONTINUE
      CALL FPXWCO(1,0,DIN,DOUT,STAT)                   !fp -> wc
      DO 510 N=1,NAXISC
         STARTC(N) = STARTA(N) + (SUBLO(N)-1)*STEPA(N)
510   CONTINUE
      CALL STDFND(IMNOA,'REFPIX',INPUTC,N,NN,STAT)
      IF (INPUTC(1:1).EQ.'D') THEN
         CALL STDRDD(IMNOA,'REFPIX',1,NAXISA,IAV,DOUT,UNI,NULO,STAT)
         DO 8080, N=1,NAXISA
            DOUT(N) =  DOUT(N) + 1.0D0 - DIN(N)
8080     CONTINUE
         REFSET = 1
      ENDIF
      CALL STDRDR(IMNOA,'LHCUTS',1,4,IAV,CUTS,UNI,NULO,STAT)
C 
C  branch according to line or subframe extraction...
      IF (ACTION(1:1).EQ.'L') GOTO 5000
C  
C -------------------------------------------------------
C  
C  here to extract a subframe
C      
C -------------------------------------------------------
C  
      TRUSIZ = 1                           !get size of input frame
      DO 600 N=1,NAXISA
         TRUSIZ = TRUSIZ * NPIXA(N)
600   CONTINUE
C 
C  get buffersize of at least one line but no more than total size
      CALL HACKUP(NPIXA,D_R4_FORMAT,RETBUF)
      NOLIN = RETBUF(1)                      !buffer = NOLIN * NPIXA(1)
      IF (NOLIN.GT.NPIXC(2)) NOLIN = NPIXC(2)
      CHUNKI = NOLIN * NPIXA(1)
      CHUNKO = NOLIN * NPIXC(1)
      LOOPLM = NPIXC(2) / NOLIN              !get no. of passes through loop
      RMAIND = NPIXC(2) - (LOOPLM*NOLIN)     !and remainder
C 
      CALL STFXMP(CHUNKI,D_R4_FORMAT,PNTRX,STAT)
      CALL STFXMP(CHUNKO,D_R4_FORMAT,PNTRY,STAT)
C 
      TRUSIZ = 1
      DO 800 N=1,NAXISC
         TRUSIZ = TRUSIZ * NPIXC(N)
800   CONTINUE
      CALL GENBLD(IMNOA,FRAMEC,D_R4_FORMAT,TRUSIZ,IMNOC,CLONY,STAT)
C  
C  now we loop through input frame
      NPXY = NPIXA(1) * NPIXA(2)
      K2 = (SUBLO(3)-1) * NPXY                   !skip unused planes
      K1 = (SUBLO(2)-1) * NPIXA(1) + 1           !point to 1. used y-lines
      MOFF = 1                                   !pointer for output frame
C 
      CUTS(3) = 999999.
      CUTS(4) = -999999.
C 
      DO 4000 IAX=1,NPIXC(3)                     !loop over all planes
         KOFF = K2 + K1
         IF (LOOPLM.LE.0) GOTO 3000
C 
         DO 2000 N=1,LOOPLM
            CALL STFGET(IMNOA,KOFF,CHUNKI,TRUSIZ,MADRID(PNTRX),STAT)  !data in
            CALL GXMOVIT(MADRID(PNTRX),MADRID(PNTRY),SUBLO(1),1,
     +               NPIXA(1),NOLIN,NPIXA(1),NPIXC(1),CUTS(3))   !rearrange data
            CALL STFPUT(IMNOC,MOFF,CHUNKO,MADRID(PNTRY),STAT)         !data out
            KOFF = KOFF + CHUNKI                     !follow with indices...
            MOFF = MOFF + CHUNKO
2000     CONTINUE
C 
3000     IF (RMAIND.GT.0) THEN
            CHUCHI = RMAIND * NPIXA(1)
            CHUCHO = RMAIND * NPIXC(1)
            CALL STFGET(IMNOA,KOFF,CHUCHI,TRUSIZ,MADRID(PNTRX),STAT) 
            CALL GXMOVIT(MADRID(PNTRX),MADRID(PNTRY),SUBLO(1),1,
     +               NPIXA(1),RMAIND,NPIXA(1),NPIXC(1),CUTS(3))      
            CALL STFPUT(IMNOC,MOFF,CHUCHO,MADRID(PNTRY),STAT)  
            MOFF = MOFF + CHUCHO
         ENDIF
C 
         K2 = K2 + NPXY                                !move to next plane
4000  CONTINUE
C 
C  compress NAXISC + write descriptors
4200  IF (NAXISC.GT.1) THEN
         IF (NPIXC(1).EQ.1) THEN
            NPIXC(1) = NPIXC(2)
            NPIXC(2) = NPIXC(3)
            NPIXC(3) = 1
            STARTC(1) = STARTC(2)
            STARTC(2) = STARTC(3)
            STARTC(3) = 0.D0
            STEPA(1) = STEPA(2)
            STEPA(2) = STEPA(3)
            STEPA(3) = 1.D0
            CUNITA(17:) = CUNITA(33:)//' '
            NAXISC = NAXISC - 1
            GOTO 4200
         ENDIF
         IF (NPIXC(2).EQ.1) THEN
            NPIXC(2) = NPIXC(3)
            NPIXC(3) = 1
            STARTC(2) = STARTC(3)
            STARTC(3) = 0.D0
            STEPA(2) = STEPA(3)
            STEPA(3) = 1.D0
            CUNITA(33:) = CUNITA(49:)//' '
            NAXISC = NAXISC - 1
            GOTO 4200
         ENDIF
         IF (NPIXC(NAXISC).EQ.1) NAXISC = NAXISC - 1
      ENDIF
      IF (NAXISC.LT.3) NPIXC(3) = 1
      IF (NAXISC.LT.2) NPIXC(2) = 1
C 
      CALL STDWRI(IMNOC,'NAXIS',NAXISC,1,1,UNI,STAT)
      CALL STDWRI(IMNOC,'NPIX',NPIXC,1,NAXISA,UNI,STAT)      !still use NAXISA
      CALL STDWRD(IMNOC,'START',STARTC,1,NAXISA,UNI,STAT)
      CALL STDWRD(IMNOC,'STEP',STEPA,1,NAXISA,UNI,STAT)
C 
      GOTO 8000
C  
C -------------------------------------------------------
C  
C  here to extract a line
C      
C -------------------------------------------------------
C  
5000  IF ( (NAXISA.GT.2) .AND.         !test that input frame is a 2-d frame...
     +     (NPIXA(3).GT.1) ) THEN
         NN = INDEX(FRAMEA,' ') - 1
         IF (NN.LE.0) NN = LEN(FRAMEA)
         INPUTC(1:) = 'Input frame '//FRAMEA(1:NN)//
     +                ' has to be 2-dim frame... '
         CALL STETER(3,INPUTC)
      ENDIF
C 
C  get stepsize for line
      CALL STKRDD('INPUTD',1,1,IAV,STEPLN,UNI,NULO,STAT)
      XA = SUBLO(1)
      YA = SUBLO(2)
      XB = SUBHI(1)
      YB = SUBHI(2)
C      
C  determine main axis (depends upon orientation of line in real space)
      IF (ABS(XA-XB).LT.10.E-5) THEN
         IAX = 2                                 !parallel to y-axis...
      ELSE
         RM = (YB-YA) / (XB-XA)
         IF (ABS(RM).GT.1.0001) THEN
            IAX = 2                              !steep ramp, so we use y..
         ELSE
            IAX = 1                              !low ramp, so we use x...
         ENDIF
      ENDIF
      IF (ABS(STEPLN).LE.10.E-20) THEN        !use orig_step if = 0.0
         STEPLN = STEPA(IAX)
         RM = 1.                              !RM holds scaled stepsieze
      ELSE
         RM = STEPLN/STEPA(IAX)
      ENDIF
C  
C  get no. of points and map index arrays as dummy frame
      WW(1) = XB - XA     
      WW(2) = YB - YA
      DIST = SQRT( (WW(1)*WW(1)) + (WW(2)*WW(2)) )
      WW(1) = DIST/RM
      IF (WW(1).LT.0.) WW(1) = -WW(1)
      NN = IFIX( WW(1) )
      WW(1) = 0.01 * WW(1)
      IF (WW(1).GT.3.0) THEN
         NN = NN + IFIX( WW(1) )                  !add 1 %  for safety check
      ELSE
         NN = NN + 3                                !add 3 for safety check
      ENDIF
C      
      CALL STFXMP(NN,D_R4_FORMAT,PNTRX,STAT)
      CALL STFXMP(NN,D_R4_FORMAT,PNTRY,STAT)
C      
C  extract the indices of the complete line from input frame
      CALL PIXLIN(XA,YA,XB,YB,RM,MADRID(PNTRX),MADRID(PNTRY),NN,NINDX)
      IF (NINDX.GE.NN) 
     +   CALL STETER(3,'too many elements in index array...')
C  
C  create 1-dim output file + get z-values for pixels recorded in XINDX + YINDX
      CALL STIPUT(FRAMEC,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +            1,NINDX,STARTC,STEPLN,
     +            IDENTA,CUNITA,PNTRC,IMNOC,STAT)
      CALL ZIMA(MADRID(PNTRA),NPIXA,MADRID(PNTRX),MADRID(PNTRY),NINDX,
     +          MADRID(PNTRC),CUTS(3),CUTS(4))
C 
C  also save the Y-start coordinate
      STARTC(2) = STARTA(2) + (SUBLO(2)-1)*STEPA(2)
      CALL STDWRD(IMNOC,'START',STARTC,1,2,UNI,STAT)  !STIPUT only fills 1 value
C 
C  common section
C  
C  copy non-standard descriptors, update LHCUTS + append HISTORY
8000  IF (CLONY.EQ.0) THEN
         CALL DSCUPT(IMNOA,IMNOC,' ',STAT)
      ELSE
         CALL DSCUPT(IMNOC,IMNOC,' ',STAT)
      ENDIF
      CALL STDWRR(IMNOC,'LHCUTS',CUTS,1,4,UNI,STAT)
C
      IF (REFSET.EQ.1) THEN          !don't forget to update REFPIX
         CALL STDWRD(IMNOC,'REFPIX',DOUT,1,NAXISA,UNI,STAT)
      ENDIF
C
      IF (EQUAL(1:).NE.' ') THEN
         CALL STFCLO(IMNOA,STAT)
         CALL STFCLO(IMNOC,STAT)
         NN = INDEX(EQUAL,' ') - 1
         IF (NN.LT.1) NN = LEN(EQUAL)
         IDENTA(1:) = ' '                   !IDENTA is at least 4 chars. longer
         IDENTA(1:) = EQUAL(1:)
         DO 8400 N=NN,1,-1
            IF (EQUAL(N:N).EQ.'.') GOTO 8800
            IF ((EQUAL(N:N).EQ.'/') .OR.
     +          (EQUAL(N:N).EQ.']')) GOTO 8440
8400     CONTINUE
8440     IDENTA(NN+1:) = '.bdf'
8800     CALL STFRNM(FRAMEC,IDENTA,STAT)
      ENDIF
C      
      RETURN
      END

      SUBROUTINE SUBEZT(INOUT)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine SUBEZT		version 1.00	881028
C  K. Banse			ESO - Garching
C
C.KEYWORDS
C  bulk data frames
C
C.PURPOSE
C  extract only "referenced" pixels from a frame
C
C.ALGORITHM
C  Pull out only those pixels from inframe which are indicated in
C  a reference frame. Result frame will be a 1-dim frame.
C
C.INPUT/OUTPUT
C 
C   INOUT = 1, check inside interval
C         = -1, check outside interval
C 
C  the following keys are used:
C
C  IN_A/C/1/80			input frame
C  IN_B/C/1/80			reference frame
C  OUT_A/C/1/80			result frame
C  THR/R/1/1			threshold values in reference frame
C  or
C  INTVAL/C/1/60		interval
C
C.VERSIONS
C  1.0		from version 1.00 as of 860110
C               move to FORTRAN 77 + new ST-Interfaces
C 
C  080122	last modif
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER    INOUT
C 
      INTEGER    IAV,N,NAXISA,NAXISB
      INTEGER*8  PNTRA,PNTRB,PNTRC
      INTEGER    IMNOA,IMNOB,STAT
      INTEGER    SIZE,TRUESZ,XFLAG
      INTEGER    NPIXA(3),NPIXB(3)
      INTEGER    UNI(1),NULO,MADRID(1)
C
      CHARACTER*80 FRAMEA,FRAMEB,FRAMEC
      CHARACTER    IDENTA*72,IDENTB*72,CUNITA*64,CUNITB*64
      CHARACTER    CBUF*100
C
      DOUBLE PRECISION STARTA(3),STARTB(3),STEPA(3),STEPB(3)
C
      REAL       THR(2)
      REAL       CUTS(2)
C
      COMMON  /VMR/  MADRID
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      DATA    NPIXA   /1,1,1/,     NPIXB  /1,1,1/
      DATA    STARTA  /3*0.D0/,    STEPA  /3*1.D0/
      DATA    STARTB  /3*0.D0/,    STEPB  /3*1.D0/
      DATA    IDENTA  /' '/,       CUNITA /' '/
      DATA    IDENTB  /' '/,       CUNITB /' '/
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      CALL STKRDC('IN_A',1,1,80,IAV,FRAMEA,UNI,NULO,STAT)
      CALL STKRDC('IN_B',1,1,80,IAV,FRAMEB,UNI,NULO,STAT)
      CALL STKRDC('OUT_A',1,1,80,IAV,FRAMEC,UNI,NULO,STAT)
C
C  map input + reference
      CALL STIGET(FRAMEA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +            3,NAXISA,NPIXA,STARTA,STEPA,
     +            IDENTA,CUNITA,PNTRA,IMNOA,STAT)
      IF (FRAMEA.NE.FRAMEB) THEN
         CALL STIGET(FRAMEB,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +               3,NAXISB,NPIXB,STARTB,STEPB,
     +               IDENTB,CUNITB,PNTRB,IMNOB,STAT)
      ELSE
         IMNOB = IMNOA
         PNTRB = PNTRA
         NAXISB = NAXISA
         DO 20 N=1,NAXISA
            NPIXB(N) = NPIXA(N)
20       CONTINUE
      ENDIF
C
      IF (INOUT .EQ. 0) THEN		!old version: single threshold
         CALL STKRDR('THR',1,1,IAV,THR,UNI,NULO,STAT)
         THR(2) = 0.
      ELSE
         CALL STKRDC('INTVAL',1,1,60,IAV,CBUF,UNI,NULO,STAT)
         XFLAG = 0                                 !check interval
         IF (CBUF(1:2).EQ.'<,') THEN
            IF (CBUF(3:3).EQ.'>') THEN
               XFLAG = 3                           !  <,>
            ELSE
               XFLAG = 1                           !  <,m
               CALL GENCNV(CBUF(3:),2,1,IDUM,THR(2),DDUM,N)
               IF (N.NE.1) CALL STETER(3,'Bad syntax for interval...')
            ENDIF
         ELSE
            N = INDEX(CBUF,',')
            IF (N.LT.2) CALL STETER(3,'Bad syntax for interval...')
            N = N + 1
            IF (CBUF(N:N).EQ.'>') THEN
               XFLAG = 2                           !  n,>
               CALL GENCNV(CBUF,2,1,IDUM,THR(1),DDUM,N)
               IF (N.NE.1) CALL STETER(3,'Bad syntax for interval...')
            ELSE
               CALL GENCNV(CBUF,2,2,IDUM,THR,DDUM,N)
               IF (N.NE.2) CALL STETER(3,'Bad syntax for interval...')
            ENDIF
         ENDIF
C 
         IF (XFLAG .NE. 0) THEN
            CALL STDRDR(IMNOB,'LHCUTS',3,2,IAV,CUTS,UNI,NULO,STAT)
            IF (XFLAG .EQ. 3) THEN
               THR(1) = CUTS(1)
               THR(2) = CUTS(2)
            ELSE IF (XFLAG .EQ. 1) THEN
               THR(1) = CUTS(1)
            ELSE 					!can only be 2
               THR(2) = CUTS(2)
            ENDIF
         ENDIF
      ENDIF
C 
C  get total size + map intermediate frame of that size
      SIZE = 1
      DO 200 N=1,NAXISA
         SIZE = SIZE * NPIXA(N)
200   CONTINUE
      TRUESZ = 1
      DO 300 N=1,NAXISB
         TRUESZ = TRUESZ * NPIXB(N)
300   CONTINUE
      IF (TRUESZ.LT.SIZE) CALL STETER
     +    (8,'refframe smaller than input frame - we abort ...')
C 
      CALL STFXMP(SIZE,D_R4_FORMAT,PNTRC,STAT)
C
C  now do the actual operation
      CALL GXDOIT(MADRID(PNTRA),MADRID(PNTRB),MADRID(PNTRC),
     +          THR,INOUT,SIZE,TRUESZ)
      IF (IMNOA.NE.IMNOB)
     +   CALL STFCLO(IMNOB,STAT)            !we don't need the refframe anymore
C 
      IF (TRUESZ.LE.0) THEN
         CALL STTPUT
     +   ('no pixels found in given interval => no result frame...',
     +    STAT)
         GOTO 9900
      ENDIF
C
      CALL STIPUT(FRAMEC,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +            1,TRUESZ,STARTA,STEPA,	!reuse IMNOB, PNTRB ...
     +            IDENTA,CUNITA,PNTRB,IMNOB,STAT)
      CALL COPYF(MADRID(PNTRC),MADRID(PNTRB),TRUESZ)
C
C  update descriptors
      CALL DSCUPT(IMNOA,IMNOB,' ',STAT)
      CALL STFCLO(IMNOB,STAT)			!close result frame
      N = INDEX(FRAMEC//' ',' ') - 1
      WRITE(CBUF,10000) FRAMEC(1:N),TRUESZ
      CALL STTPUT(CBUF,STAT)
C 
9900  CALL STKWRI('OUTPUTI',TRUESZ,15,1,UNI,STAT)
      CALL STFCLO(IMNOA,STAT)
C
C  that's it folks
      RETURN
C
10000 FORMAT('frame ',A,' created with',I10,' pixels ...')
      END

      SUBROUTINE SUBINS
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine SUBINS		version 1.00	881028
C  K. Banse			ESO - Garching
C
C.KEYWORDS
C  bulk data frames
C
C.PURPOSE
C  insert a frame into another one
C
C.ALGORITHM
C  straight forward
C
C.INPUT/OUTPUT
C  the following keys are used:
C
C  IN_A/C/1/80			input frame
C  OUT_A/C/1/80			result frame
C  P3/C/1/80			string with start pixels
C
C.VERSIONS
C  1.00		from version 1.20 as of 860109
C  		move to FORTRAN 77 + new ST Interfaces
C	
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      IAV,LSUB,N,NAXISA,NAXISC
      INTEGER*8    PNTRX,PNTRY
      INTEGER      NPIXA(3),NPIXC(3),IMNOA,IMNOC,STAT
      INTEGER      SUBLO(3),IAX,NN
      INTEGER      UNI(1),NULO,MADRID(1)
      INTEGER      NPXY,K2,RMAIND,CHUCHO,CHUCHI,IDIM(3)
      INTEGER      NOLIN,TRUSIZ,CHUNKI,CHUNKO,K1
      INTEGER      LOFF,KOFF,MOFF,ZOFF,LOOPLM,NPA(3),PXOFA(3)
C
      CHARACTER*80 FRAMEA,FRAMEC
      CHARACTER    PARM*80,OUTPUT*80
      CHARACTER    SUBSTR*30,ERROR3*40
C
      DOUBLE PRECISION STARTA(3),STARTC(3),STEPA(3),STEPC(3)
      DOUBLE PRECISION EPS,STA(3)
C 
      REAL         CUTS(4),CUTVLS(2),RBUF
C
      COMMON   /VMR/ MADRID
C
      INCLUDE  'MID_INCLUDE:ST_DEF.INC'
C
      DATA      ERROR3   /'max. 3-dim images supported... '/
      DATA      SUBLO   /1,1,1/,   IDIM   /1,1,1/
      DATA      PARM    /' '/     
      DATA      NPIXA   /1,1,1/,   NPIXC  /1,1,1/
      DATA      NPA     /1,1,1/,   PXOFA  /0,0,0/
      DATA      CUTVLS  /+99999.,-99999./
      DATA      STARTA  /3*0.0D0/, STEPA  /3*1.0D0/
C
      INCLUDE  'MID_INCLUDE:ST_DAT.INC'
C
C  open son + father frame          (or daughter + mother if you prefer...)
      CALL STKRDC('IN_A',1,1,80,IAV,FRAMEA,UNI,NULO,STAT)
      CALL STKRDC('OUT_A',1,1,80,IAV,FRAMEC,UNI,NULO,STAT)
C
      CALL STFOPN(FRAMEA,D_R4_FORMAT,0,F_IMA_TYPE,IMNOA,STAT)     !son
      CALL STDRDI(IMNOA,'NAXIS',1,1,IAV,NAXISA,UNI,NULO,STAT)
      IF (NAXISA.GT.3) CALL STETER(44,ERROR3)
      CALL STDRDI(IMNOA,'NPIX',1,NAXISA,IAV,NPIXA,UNI,NULO,STAT)
      CALL STDRDD(IMNOA,'START',1,NAXISA,IAV,STARTA,UNI,NULO,STAT)
      CALL STDRDD(IMNOA,'STEP',1,NAXISA,IAV,STEPA,UNI,NULO,STAT)
C 
      CALL STFOPN(FRAMEC,D_R4_FORMAT,0,F_IMA_TYPE,IMNOC,STAT)     !father
      CALL STDRDI(IMNOC,'NAXIS',1,1,IAV,NAXISC,UNI,NULO,STAT)
      IF (NAXISC.GT.3) CALL STETER(44,ERROR3)
      CALL STDRDI(IMNOC,'NPIX',1,NAXISC,IAV,NPIXC,UNI,NULO,STAT)
      CALL STDRDD(IMNOC,'START',1,NAXISC,IAV,STARTC,UNI,NULO,STAT)
      CALL STDRDD(IMNOC,'STEP',1,NAXISC,IAV,STEPC,UNI,NULO,STAT)
C 
C  if son has less dimensions, copy stuff from father
      IF (NAXISA.LT.NAXISC) THEN
         DO 300, N=NAXISA+1,NAXISC
            NPIXA(N) = 1
            STARTA(N) = STARTC(N)
            STEPA(N) = STEPC(N)
300      CONTINUE
         NAXISA = NAXISC
      ENDIF
C
C  stepsizes of son should not differ from father
      DO 400, N=1,NAXISA
         EPS = ABS(0.001 * STEPA(N))
         IF (ABS(STEPA(N)-STEPC(N)).GT.EPS) THEN
            CALL STTPUT
     +      ('Warning: stepsizes do not match...',STAT)
            GOTO 1000
         ENDIF
400   CONTINUE
C
C  get start of insertion in FRAMEC
1000  DO 1020 N=1,NAXISC
         STA(N) = STARTC(N)
1020  CONTINUE
C 
      CALL STKRDC('P3',1,1,80,IAV,PARM,UNI,NULO,STAT)
      IF (PARM(1:1).NE.'?') THEN
         IAX = 1
         DO 1100 N=1,NAXISC
            CALL EXTRSS(PARM,',',IAX,SUBSTR,LSUB)
            IF (LSUB.LE.0) GOTO 1200
            IF (SUBSTR(1:1).EQ.'@') THEN
               CALL GENCNV(SUBSTR(2:),1,1,SUBLO(N),RBUF,STA(N),IAV)
               IF (IAV.LE.0)
     +            CALL STETER(46,'Invalid syntax in start coords. ')
               STA(N) = STARTC(N) + ((SUBLO(N)-1)*STEPC(N))
            ELSE IF (SUBSTR(1:1).EQ.'<') THEN
               STA(N) = STARTC(N)
            ELSE IF (SUBSTR(1:1).EQ.'>') THEN
               STA(N) = STARTC(N) + ((NPIXC(N)-1)*STEPC(N))
            ELSE
               CALL GENCNV(SUBSTR(1:),4,1,IAV,RBUF,STA(N),IAV)
               IF (IAV.LE.0)
     +            CALL STETER(46,'Invalid syntax in start coords. ')
            ENDIF
1100     CONTINUE
C
C  if no start values given, use descriptor START of FRAMEA
      ELSE
         DO 1150 N=1,NAXISA                   !note, NAXISA = NAXISC
            STA(N) = STARTA(N)
1150     CONTINUE
      ENDIF
C 
C  find offsets inside FRAMEA
1200  DO 1300 N=1,NAXISA
         IF (ABS(STEPC(N)).LT.1.E-20) THEN
            WRITE(OUTPUT,10123) N,STEPC(N)
            CALL STTPUT(OUTPUT,STAT)
            SUBLO(N) = 0
         ELSE
            SUBLO(N) = NINT( (STA(N) - STARTC(N))/STEPC(N) ) 
         ENDIF
         IF (SUBLO(N).GE.0) THEN
            SUBLO(N) = SUBLO(N) + 1
         ELSE
            PXOFA(N) = - SUBLO(N)
            SUBLO(N) = 1
         ENDIF
         NPA(N) = NPIXA(N) - PXOFA(N)
1300  CONTINUE
C 
C  check, if subframe overlaps with result frame
      DO 2500 N=1,NAXISA
         IF (SUBLO(N).GT.NPIXC(N))
     +      CALL STETER(3,
     +      'invalid coords.: sub- and modframe do not overlap...')
         NN = SUBLO(N) + NPA(N) - 1          !check for overflow
         IF ( NN.GT.NPIXC(N) ) THEN
            IDIM(N) = NPIXC(N) - SUBLO(N) + 1
            CALL STTPUT
     +      ('Warning: son does not fit completely in father...',STAT)
         ELSE
            IDIM(N) = NPA(N)
         ENDIF
2500  CONTINUE
C 
C  get buffersize of at least one line but no more than total size in y
      TRUSIZ = NPIXA(1)*IDIM(2)  
      IAX = 20000                              !first guess ...
      NN = IAX   
      IF (NN.LT.NPIXA(1)) NN = NPIXA(1)
      IF (NN.GT.TRUSIZ) NN = TRUSIZ
      NOLIN = NN / NPIXA(1)                    !buffer = NOLIN * NPIXA(1)
      IF (NOLIN.GT.IDIM(2)) NOLIN = IDIM(2)    !avoid overflow in y ...
C 
3500  CHUNKI = NOLIN * NPIXA(1)
      CHUNKO = NOLIN * NPIXC(1)
      IF ((NOLIN.GT.1).AND.(CHUNKO.GT.IAX*2)) THEN
         NOLIN = NOLIN - 1
         GOTO 3500
      ENDIF
      LOOPLM = IDIM(2) / NOLIN                 !get no. of passes through loop
      RMAIND = IDIM(2) - (LOOPLM * NOLIN)
C 
      CALL STFXMP(CHUNKI,D_R4_FORMAT,PNTRX,STAT)
      CALL STFXMP(CHUNKO,D_R4_FORMAT,PNTRY,STAT)
C 
C  now we loop through input (son) frame
      NPXY = NPIXC(1) * NPIXC(2)
      K2 = (SUBLO(3)-1) * NPXY                   !skip unused planes
      K1 = (SUBLO(2)-1) * NPIXC(1) + 1           !point to 1. used y-lines
      ZOFF = PXOFA(3)*NPIXA(2)*NPIXA(1)
      LOFF = PXOFA(1) + 1                        !first pixel in x-line
      TRUSIZ = NPIXA(1) - LOFF + 1               !no. of pixels per line to move
C 
      DO 5000 IAX=1,IDIM(3)                      !loop over all planes
         MOFF = ZOFF + (PXOFA(2)*NPIXA(1)) + 1   !pointer for input frame
         KOFF = K2 + K1
         IF (LOOPLM.LE.0) GOTO 4400
C 
         DO 4000 N=1,LOOPLM
            CALL STFGET(IMNOA,MOFF,CHUNKI,NN,MADRID(PNTRX),STAT)     !son in
            CALL STFGET(IMNOC,KOFF,CHUNKO,IAV,MADRID(PNTRY),STAT)    !father in
            CALL GXMOVIT(MADRID(PNTRX),MADRID(PNTRY),LOFF,SUBLO(1),
     +              TRUSIZ,NOLIN,NPIXA(1),NPIXC(1),CUTVLS)      !rearrange data
            CALL STFPUT(IMNOC,KOFF,IAV,MADRID(PNTRY),STAT)           !father out
            MOFF = MOFF + CHUNKI
            KOFF = KOFF + CHUNKO                     !follow with indices...
4000     CONTINUE
C 
4400     IF (RMAIND.GT.0) THEN
            CHUCHI = RMAIND * NPIXA(1)
            CHUCHO = RMAIND * NPIXC(1)
            CALL STFGET(IMNOA,MOFF,CHUCHI,NN,MADRID(PNTRX),STAT)
            CALL STFGET(IMNOC,KOFF,CHUCHO,IAV,MADRID(PNTRY),STAT)  
            CALL GXMOVIT(MADRID(PNTRX),MADRID(PNTRY),LOFF,SUBLO(1),
     +               TRUSIZ,RMAIND,NPIXA(1),NPIXC(1),CUTVLS)                
            CALL STFPUT(IMNOC,KOFF,IAV,MADRID(PNTRY),STAT)     
            MOFF = MOFF + CHUCHI
         ENDIF
C 
         K2 = K2 + NPXY                                !move to next plane
         ZOFF = ZOFF + (NPIXA(1)*NPIXA(2))
5000  CONTINUE
C
C  do not copy all descriptors, just update descr HISTORY
      CALL DSCUPT(IMNOC,IMNOC,' ',STAT)
C 
C  and LHCUTS also
      CALL STDRDR(IMNOC,'LHCUTS',1,4,IAV,CUTS,UNI,NULO,STAT)
      IAX = 0
      IF (CUTVLS(1).LT.CUTS(3)) THEN
         CUTS(3) = CUTVLS(1)
         IAX = 1
      ENDIF
      IF (CUTVLS(2).GT.CUTS(4)) THEN
         CUTS(4) = CUTVLS(2)
         IAX = 1
      ENDIF
      IF (IAX.EQ.1) CALL STDWRR(IMNOC,'LHCUTS',CUTS,1,4,UNI,STAT)
C
C  that's it folks
      RETURN
C 
10123 FORMAT('Warning: step(',I1,') of father frame = ',G10.5,
     +       ' result may be corrupted ...')
C 
      END

      SUBROUTINE SUBMAP
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine SUBMAP		version 1.00	881028
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  bulk data frame, mapping
C
C.PURPOSE
C  map an image via another one (which acts like a LUT)
C
C.ALGORITHM
C  straight forward
C
C.INPUT/OUTPUT
C  the following keywords are used:
C
C  IN_A/C/1/80				name of input frame
C  IN_B/C/1/80				name of map frame
C  OUT_A/C/1/80				name of result frame
C  INPUTI/I/1/2				map flag:
C					(1) = 0, indices outside map space go to
C					         start + end
C					(1) = 1, indices outside avoid mapping,
C					         i.e output pixel = input pixel
C					(2) = 0, map frame is 1-dim and has
C						 equidistant coord space
C					(2) = 1, map frame is 2-dim and has
C						 pixel coords stored in 1. line,
C						 pixel intensities in 2. line
C
C.VERSIONS
C
C  1.00		from version 1.00 s of 871112	
C 		move to FORTRAN 77 + new ST Interfaces
C
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      N,IAV,NAXISA,NAXISB
      INTEGER*8    PNTRA,PNTRB,PNTRC
      INTEGER      IMNOA,IMNOB,IMNOC,STAT
      INTEGER      NPIXA(3),NPIXB(3),KMAP(2)
      INTEGER      UNI(1),NULO,MADRID(1)
C
      DOUBLE PRECISION STARTA(3),STEPA(3),STARTB(3),STEPB(3)
C
      CHARACTER    CUNITA*64,IDENTA*72,CUNITB*10,IDENTB*10
      CHARACTER    FRAMEA*80,FRAMEB*80,FRAMEC*80
C
      COMMON  /VMR/  MADRID
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      DATA    IDENTA  /' '/,  CUNITA  /' '/
C
C  get name of input image, map image + output image
      CALL STKRDC('IN_A',1,1,80,IAV,FRAMEA,UNI,NULO,STAT)
      CALL STKRDC('IN_B',1,1,80,IAV,FRAMEB,UNI,NULO,STAT)
      CALL STKRDC('OUT_A',1,1,80,IAV,FRAMEC,UNI,NULO,STAT)
      CALL STKRDI('INPUTI',1,2,IAV,KMAP,UNI,NULO,STAT)
C
      DO 400 N=1,3
         NPIXA(N) = 1
         STARTA(N) = 0.D0
         STEPA(N) = 1.D0
         NPIXB(N) = 1
         STARTB(N) = 0.D0
         STEPB(N) = 1.D0
400   CONTINUE
C
C  map input frame + map frame for reading
      CALL STIGET(FRAMEA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +            2,NAXISA,NPIXA,STARTA,STEPA,IDENTA,
     +            CUNITA,PNTRA,IMNOA,STAT)
      CALL STIGET(FRAMEB,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +            2,NAXISB,NPIXB,STARTB,STEPB,IDENTB,
     +            CUNITB,PNTRB,IMNOB,STAT)
      IF (KMAP(2).GT.0) THEN
         IF (NPIXB(2).LE.1)
     +      CALL STETER(1,'we need 2-dim map for this option...')
      ENDIF
C
      CALL STIPUT(FRAMEC,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +            NAXISA,NPIXA,STARTA,STEPA,IDENTA,
     +            CUNITA,PNTRC,IMNOC,STAT)
C
C  execute algorithm in a subroutine
      CALL GXIZAMAP(NPIXA,NPIXB,STARTB,STEPB,
     +            MADRID(PNTRA),MADRID(PNTRB),MADRID(PNTRC),KMAP)
C
C  that's it folks...
      RETURN
      END

      SUBROUTINE SUBMAT
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine SUBMAT		version 1.00	881028
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  bulk data frame, matrix ops
C
C.PURPOSE
C  do the usual matrix operations on an image
C
C.ALGORITHM
C  straight forward
C
C.INPUT/OUTPUT
C  the following keywords are used:
C
C  IN_A/C/1/80				name of input frame
C  ACTION/C/3/2				action
C					= 'TR ', transpose a matrix
C 					         around major diagonal
C					= 'LC ', transpose a matrix
C 					         around minor diagonal
C					         i.e. change lines into columns
C  OUT_A/C/1/80				name of result frame
C  INPUTI/I/1/2				xsize,ysize for 'LC'
C
C.VERSIONS
C  1.00		from version 1.20 as of 870105
C	
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER*8    PNTRA,PNTRC
      INTEGER      IAV,NAXIS,STAT
      INTEGER      IMNOA,IMNOC
      INTEGER      NPIX(2),NPIXC(2),ISIZE(2)
      INTEGER      UNI(1),NULO,MADRID(1)
C
      DOUBLE PRECISION START(2),STEP(2),DTMP
C
      CHARACTER    CUNIT*48,IDENT*72
      CHARACTER    FRAMEA*80,FRAMEC*80,ACTION*2
C
      COMMON  /VMR/  MADRID
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      DATA    IDENT  /' '/,  CUNIT  /' '/
C
C  get name of input, ouput image + action flags
      CALL STKRDC('IN_A',1,1,80,IAV,FRAMEA,UNI,NULO,STAT)
      CALL STKRDC('OUT_A',1,1,80,IAV,FRAMEC,UNI,NULO,STAT)
      CALL STKRDC('ACTION',1,3,2,IAV,ACTION,UNI,NULO,STAT)
      CALL UPCAS(ACTION,ACTION)
C
C  map input frame
      CALL STIGET(FRAMEA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +            2,NAXIS,NPIX,START,STEP,IDENT,
     +            CUNIT,PNTRA,IMNOA,STAT)
C
C  check dimensions...
      IF (NAXIS.NE.2)
     +   CALL STETER(1,'input must be a 2-dim frame ...')
C
C  exchange NPIX, adjust START, STEP + map output frame
      NPIXC(1) = NPIX(2)
      NPIXC(2) = NPIX(1)
      IF (ACTION.EQ.'TR') THEN
         DTMP = START(1) + (NPIX(1)-1) * STEP(1)          !end in X
         START(1) = START(2) + (NPIX(2)-1) * STEP(2)      !end in Y
         START(2) = DTMP
         DTMP = - STEP(1)
         STEP(1) = - STEP(2)
         STEP(2) = DTMP
      ELSE
         DTMP = START(1)
         START(1) = START(2)
         START(2) = DTMP
         DTMP = STEP(1)
         STEP(1) = STEP(2)
         STEP(2) = DTMP
      ENDIF
      CALL STIPUT(FRAMEC,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +            NAXIS,NPIXC,START,STEP,IDENT,
     +            CUNIT,PNTRC,IMNOC,STAT)
C
C  execute algorithm in a subroutine
      IF (ACTION.EQ.'TR') THEN
         CALL GXMATRX(MADRID(PNTRA),NPIX,MADRID(PNTRC))
      ELSE
         CALL STKRDI('INPUTI',1,2,IAV,ISIZE,UNI,NULO,STAT)
         CALL LINCOL(MADRID(PNTRA),NPIX,ISIZE,MADRID(PNTRC))
      ENDIF
      CALL DSCUPT(IMNOA,IMNOC,' ',STAT)
C
C  that's it folks...
      RETURN
      END

C @(#)tdforlib.for	19.1 (ES0-DMD) 02/25/03 14:11:17
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
        INTEGER FUNCTION FORLOC(SA,SB)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  19:55 - 11 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C.IDENTIFICATION        FORLOC.FOR
C.KEYWORDS              FORTRAN FUNCTION
C.ENVIRONMENT  MIDAS
C.PURPOSE
C       Locates a character in a string.
C       Corresponds to LIB$LOCC in VAX 11 FORTRAN.
C
C------------------------------------------------------------------
        IMPLICIT  NONE
        CHARACTER*(*)   SA       ! IN : character to be found	
        CHARACTER*(*)   SB       ! IN : string to be searched
C
        INTEGER   N,KLEN,LEN
C  
C ... check string length
C
        FORLOC = 0
        KLEN   = LEN(SA)
        IF (KLEN.EQ.0) RETURN
        KLEN   = LEN(SB)
        IF (KLEN.EQ.0) RETURN
C 
C ... compare each input character with lowercase alphabet
C
        DO 100 N=1,KLEN
            IF (SA(1:1).EQ.SB(N:N)) THEN
                FORLOC = N
                RETURN
            END IF
100     CONTINUE
        RETURN
        END
        SUBROUTINE FORUPC(SA,SB)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  19:55 - 11 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: K.BANSE
C.IDENTIFICATION        FORUPC.FOR
C.KEYWORDS              FORTRAN FUNCTION
C.ENVIRONMENT  MIDAS
C.PURPOSE
C       Really converts characters in the input string into uppercase.
C       The routine corresponds to STR$UPCASE in VAX 11 FORTRAN
C
C------------------------------------------------------------------
        IMPLICIT  NONE
        CHARACTER*(*)   SA      ! IN  : Input string 
        CHARACTER*(*)   SB      ! OUT : Destination string
C
        INTEGER   N,KLEN,LEN,M
        CHARACTER*26    ALPHU,ALPHL
C 
        DATA   ALPHU  /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
        DATA   ALPHL  /'abcdefghijklmnopqrstuvwxyz'/
C 
        KLEN = LEN(SA)
C 
C  compare each input character with lowercase alphabet
        DO 100 N=1,KLEN
C 
           SB(N:N) = SA(N:N)
           DO 50 M=1,26
              IF (SA(N:N).EQ.ALPHL(M:M)) SB(N:N) = ALPHU(M:M)
50         CONTINUE
C 
100     CONTINUE
C 
        RETURN
        END

        INTEGER FUNCTION FORSKP(SA,SB)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  19:55 - 11 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C.IDENTIFICATION        FORSKP.FOR
C.KEYWORDS              FORTRAN FUNCTION
C.ENVIRONMENT  MIDAS
C.PURPOSE
C       Compares a string with a given character and returns the 
C       relative position of the first nonequal character as an index.
C       The character is compared until and inequality is found or 
C       the string is exhausted. The relative position of the 
C       unequal character or zero is returned.
C       If the source string has a zero length, then zero is returned.
C       Corresponds to LIB$SKPC in VAX 11 FORTRAN.
C
C------------------------------------------------------------------
        IMPLICIT  NONE
        CHARACTER*(*)   SA       ! IN : character to be found	
        CHARACTER*(*)   SB       ! IN : string to be searched
C
        INTEGER   N,KLEN,LEN
C  
C ... check string length
C
        FORSKP = 0
        KLEN = LEN(SA)
        IF (KLEN.EQ.0) RETURN
        KLEN = LEN(SB)
        IF (KLEN.EQ.0) RETURN
C 
C ... compare each input character with lowercase alphabet
C
        DO 100 N=1,KLEN
            IF (SA(1:1).NE.SB(N:N)) THEN
                FORSKP = N
                RETURN
            END IF
100     CONTINUE
        RETURN
        END

C @(#)acf.for	19.1 (ES0-DMD) 02/25/03 13:32:57
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C  @(#)acf.for	5.1 (ESO-IPG) 4/5/93 15:58:26
C
C
C
      DOUBLE PRECISION FUNCTION ACFLIN(TLAG,PARM)
      DOUBLE PRECISION TLAG,PARM(12)
      ACFLIN=PARM(1)+PARM(2)*ABS(TLAG)
      END
C
C
C
      DOUBLE PRECISION FUNCTION ACFPOL(TLAG,PARM)
      DOUBLE PRECISION TLAG,PARM(12),SAV
      INTEGER I
      SAV=0.
      DO 1 I=12,1,-1
        SAV=SAV*ABS(TLAG)+PARM(I)
 1    CONTINUE
      ACFPOL=SAV
      END
C
C
C
      DOUBLE PRECISION FUNCTION ACFPOW(TLAG,PARM)
      DOUBLE PRECISION TLAG,PARM(12)
      ACFPOW=PARM(1)+PARM(2)*ABS(TLAG)**PARM(3)
      END
C
C
C
      DOUBLE PRECISION FUNCTION ACFEXP(TLAG,PARM)
      DOUBLE PRECISION TLAG,PARM(12)
      ACFEXP=PARM(1)+PARM(2)*EXP(PARM(3)*ABS(TLAG))
      END
C
C
C
      DOUBLE PRECISION FUNCTION ACFLOG(TLAG,PARM)
      DOUBLE PRECISION TLAG,PARM(12)
      ACFLOG=PARM(1)+PARM(2)*LOG(PARM(3)*ABS(TLAG))
      END
C
C
C
      DOUBLE PRECISION FUNCTION ACFIPO(TLAG,PARM)
      DOUBLE PRECISION TLAG,PARM(12),SAV,X
      INTEGER I
      X=1./(ABS(TLAG)-PARM(1))
      SAV=0.
      DO 1 I=12,2,-1
        SAV=SAV*X+PARM(I)
 1    CONTINUE
      ACFIPO=SAV
      END
C
C
C

C @(#)getpix.for	19.1 (ES0-DMD) 02/25/03 13:19:39
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE EXTRA2(A,NPIX,IMAGE,DATA,MXPIX,ISM,IFLAG,ISI)                  
C+++                                                                            
C.AUTHOR:         Rein H. Warmels, ESO-Garching, based on existing code by 
C                 Ch.Ounnas
C.PURPOSE:        extract a subimage from a MIDAS frame , smoothes it (option)  
C                 Finally fills a transmitted array (1 dimension)               
C.ALGORITHM:      extracts a subimage from a MIDAS frame and fills an array     
C                 if required  smoothes the subframe before with a running      
C                 2-d average.                                                  
C.COMMENTS:       none
C.VERSION:        890117 RHW  Adjusted for portable version
C.VERSION:        910115 RHW  IMPLICIT NONE added
C---  
      IMPLICIT NONE 
C
      REAL     A(1)                      ! IN: entry to the frame               
      INTEGER  NPIX(3)                   ! IN: standard descriptor of frame 
      INTEGER  IMAGE(4)                  ! IN: contains in pixels units
      INTEGER  MXPIX                     ! IN: max size                         
      REAL     DATA(MXPIX,MXPIX)         ! OUT: data array
      INTEGER  ISM                       ! IN: smooth. parameter (if .le. 1 np) 
      INTEGER  IFLAG                     ! IN: 0: no rot.; 1: 90 deg. rotation  
      INTEGER  ISI                       ! IN: total size of the data array     

C
      INTEGER  MADRID(1)
      INTEGER  NX1, NX2, NY1, NY2
      INTEGER  NX, NY
      INTEGER  ILIS, IOFF
      INTEGER  IX, IY, KX, KY, ISX, ISY, IXG, IYG
      INTEGER  II
      INTEGER  NAV
      REAL     AVER
C                                                                               
      COMMON   /VMR/MADRID                                                  
C                                                                               
C *** check correct input                                                       
      NX1      = MIN(IMAGE(1),IMAGE(2))                                         
      NX2      = MAX(IMAGE(1),IMAGE(2))                                         
      IMAGE(1) = NX1                                                            
      IMAGE(2) = NX2                                                            
      NY1      = MIN(IMAGE(3),IMAGE(4))                                         
      NY2      = MAX(IMAGE(3),IMAGE(4))                                         
      IMAGE(3) = NY1                                                            
      IMAGE(4) = NY2                                                            
C                                                                               
C ***
      NX     = IMAGE(2) - IMAGE(1) + 1                                          
      IF (NX.EQ.1) THEN                       !  1-dim image rotate over 90 deg.
         IFLAG  = 1                                                             
      END IF                                                                    
      NY     = IMAGE(4) - IMAGE(3) + 1                                          
C                                                                               
C *** check image input                                                         
      IF (NX.LE.1) THEN                                                         
         RETURN                                                                 
      END IF                                                                    
C                                                                               
      IF (NY.LE.1) THEN                                                         
         RETURN                                                                 
      END IF                                                                    
C                                                                               
C *** set and correct smoothing parameter                                       
      IF (ISM.EQ.0) THEN                                                        
         ISM    = 1                                                             
      END IF                                                                    
      ILIS   = 2 * (ISM/2) + 1                                                  
      IOFF   = ILIS/2                                                           
C                                                                               
C *** smoothes and read frame                                                   
      IF (ISM.GE.2) THEN                                                        
         DO 40 IX = IMAGE(1),IMAGE(2)                                           
            DO 30 IY = IMAGE(3),IMAGE(4)                                        
               AVER   = 0.                                                      
               NAV    = 0                                                       
               DO 20 ISX = 1,ILIS                                               
                  DO 10 ISY = 1,ILIS                                            
                     IXG    = IX + ISX - IOFF - 1                               
                     IYG    = IY + ISY - IOFF - 1                               
C                                                                               
C *** check if no reading out of the frame is done                              
                     IF (IXG.LE.0 .OR. IXG.GT.NPIX(1)) THEN                     
                        GO TO 20                                                
                     END IF                                                     
                     IF (IYG.LE.0 .OR. IYG.GT.NPIX(2)) THEN                     
                        GO TO 10                                                
                     END IF                                                     
                     NAV    = NAV + 1                                           
                     II     = (IYG-1)*NPIX(1) + IXG                             
                     AVER   = AVER + A(II)                                      
   10             CONTINUE                                                      
   20          CONTINUE                                                         
               AVER   = AVER/FLOAT(NAV)                                         
               KX     = IX - IMAGE(1) + 1                                       
               KY     = IY - IMAGE(3) + 1                                       
C                                                                               
C *** rotate over 90 deg. in equired                                            
               IF (IFLAG.EQ.0) THEN                                             
                  DATA(KX,KY) = AVER                                            
               ELSE                                                             
                  DATA(KY,NX-KX+1) = AVER                                       
               END IF                                                           
   30       CONTINUE                                                            
   40    CONTINUE                                                               
C                                                                               
      ELSE                                                                      
         DO 60 IY = IMAGE(3),IMAGE(4)                                           
            KY     = IY - IMAGE(3) + 1                                          
            DO 50 IX = IMAGE(1),IMAGE(2)                                        
               KX     = IX - IMAGE(1) + 1                                       
               II     = IX + (IY-1)*NPIX(1)                                     
C                                                                               
C *** rotate over 90 deg. in equired                                            
               IF (IFLAG.EQ.0) THEN                                             
                  DATA(KX,KY) = A(II)                                           
               ELSE                                                             
                  DATA(KY,NX-KX+1) = A(II)                                      
               END IF                                                           
   50       CONTINUE                                                            
   60    CONTINUE                                                               
      END IF                                                                    
                                                                                
      RETURN                                                                    
      END                                                                       

      SUBROUTINE PIXVAL(FMES,ISI,NPL,IPL,IL,VAL)                                
C+++                                                                            
C.PURPOSE:   Read a pixel in a frame into an real variable
C.AUTHOR:    Rein H. Warmels, ESO-Garching
C.VERSION:   ?????? RHW Creation
C.VERSION:   890117 RHW documented
C.COMMENTS:  none
C---                                                                            
      IMPLICIT NONE
      REAL     FMES(1)                                                       
      INTEGER  ISI
      INTEGER  NPL
      INTEGER  IPL
      INTEGER  IL
      REAL     VAL
C
      INTEGER  MADRID(1)
      INTEGER  INDEX
      COMMON  /VMR/MADRID
C ***
      IF (IPL.GT.NPL) THEN                                                      
          VAL    = 0.                                                           
      ELSE                                                                      
          INDEX  = (IL-1)*NPL + IPL                                             
          VAL    = FMES(INDEX)                                                  
      END IF                                                                    
C                                                                               
      RETURN                                                                    
      END                                                                       


      SUBROUTINE LIBA(NL,NPL,NPL1,NPL2,NPL3,FMES,RMES)                          
C+++                                                                            
C.PURPOSE:  Write an array into a frame
C.AUTHOR:   ???
C.VERSION:  ?????? ??? created
C.VERSION:  890117 RHW documented
C.COMMENTS: none
C---
      IMPLICIT   NONE
      INTEGER    NL
      INTEGER    NPL
      INTEGER    NPL1
      INTEGER    NPL2
      INTEGER    NPL3
      REAL       FMES(1)
      REAL       RMES(1)                                                

      INTEGER    MADRID(1)
      INTEGER    NPD, NPF
      INTEGER    K, I
C
      COMMON     /VMR/MADRID                                                 
C 
C ***
      NPD = NPL* (NL-1) + NPL1                                                  
      NPF = NPD + NPL2 - NPL1                                                   
      K   = 0                                                                   
C                                                                               
      DO 10 I = NPD,NPF,NPL3                                                    
         K      = K + 1                                                         
         FMES(I) = RMES(K)                                                      
   10 CONTINUE                                                                  
C                                                                               
      RETURN                                                                    
      END                                                                       

      SUBROUTINE LIRE(NL,NPL,NPL1,NPL2,NPL3,FMES,RMES)                          
C+++                                                                            
C.PURPOSE:  Write part of a frame into an array
C.AUTHOR:   ???
C.VERSION:  ?????? ??? created
C.VERSION:  890117 RHW documented
C.COMMENTS: none
C---
      IMPLICIT   NONE
      INTEGER    NL
      INTEGER    NPL
      INTEGER    NPL1
      INTEGER    NPL2
      INTEGER    NPL3
      REAL       FMES(1)
      REAL       RMES(1)                                                

      INTEGER    MADRID(1)
      INTEGER    NPD, NPF, K, I 
C
      COMMON     /VMR/MADRID                                                 
C
C ***
      NPD = NPL* (NL-1) + NPL1                                                  
      NPF = NPD + NPL2 - NPL1                                                   
      K   = 0                                                                   
C                                                                               
      DO 10 I = NPD,NPF,NPL3                                                    
         K       = K + 1                                                        
         RMES(K) = FMES(I)                                                      
   10 CONTINUE                                                                  
C                                                                               
      RETURN                                                                    
      END                                                                       

C @(#)sgfpi.for	19.1 (ESO-DMD) 02/25/03 13:31:24
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION:
C  PROGRAM SGFPI               VERSION 1.4                FEB   9, 1988
C  P.GROSBOL                   ESO - GARCHING
C
C.PURPOSE:
C  PROGRAM FITS THE POSITION AND INCLINATION ANGLE OF A GALAXY SO
C  THAT THE PHASES OF 2ND AND 4TH HARMONIC HAVE THE MINIMUM SIGMA.
C
C.INPUT/OUTPUT:
C  THE PROGRAM RUNS UNDER MIDAS AND USES THE FOLLOWING KEYWORDS:
C      IN_A      :  NAME OF IMAGE FILE                               (I)
C      POSI(4)   :  REAL INPUT PARAMETERS DEFINING GALAXY POSITION  (I/O)
C                   1:X CENTER POSITION, 2:Y CENTER POSITION,
C                   3:POSITON ANGLE (DEG), 4:INCLINATION ANGLE (DEG)
C      RANGE(3)  :  REAL INPUT PARAMETERS DEFINING RADIAL RANGE      (I)
C                   1:INNER RADIUS, 2:OUTER RADIUS, 3:RADIAL STEP
C      REGION(2) :  THE REGION OF PA AND I TO SEARCH FOR A MINIMUM   (I)
C                   1:PA REGION (DEG),  2:I REGION (DEG)
C
C.VERSION
C 
C 021031	last modif
C 
C---------------------------------------------------------------------
      PROGRAM SGFPI
C
      IMPLICIT   NONE
      INTEGER    MR
      INTEGER    MS
      INTEGER    MFC
      PARAMETER  (MR=100)
      PARAMETER  (MS=7)
      PARAMETER  (MFC=5)
C
      INTEGER    NPIX(3),IMNO,KUNIT(4),INULL
      INTEGER    MADRID(1)
      INTEGER    IERR, IAV, IP, II, I
      INTEGER    IX, IDF
      INTEGER    MC, NR, NA
      INTEGER*8  PNTR
C
      REAL       AMP(MFC),PHA(MFC),PH(MFC),
     ,           RANGE(3),POSI(4),REG(2),
     ,           RL(MR),P2(MR),P4(MR),W(MR),
     ,           A(MS,MS),V(MS,MS),S(MS,MS),DA(MS,MS),DB(MS,MS),
     ,           SA(MS,MS),SB(MS,MS),RR(MS,MS),DIA(MS)
      REAL       PIQ, PI, PAS, PA, PAR, PI2, PIH
      REAL       DTR, DR, DPA, DAI, DIF
      REAL       RI, RO, RM, R, RP, RD
      REAL       XC, YC
      REAL       AIS, AIR
      REAL       A2, A4
      REAL       AN, AI, AD
      REAL       B2, B4
      REAL       R2, R4
      REAL       BD
      REAL       SM
      REAL       SA2, SB2, SA4, SB4
      REAL       SAD, SBD, SS2, SS4
      REAL       XM, WM
C
      DOUBLE PRECISION START(3),STEP(3)
C
      LOGICAL    LFPHA
C
      CHARACTER*60 INAME
      CHARACTER*64 UNIT
      CHARACTER*72 IDEN
      CHARACTER*80 MSG
C
      INCLUDE    'MID_INCLUDE:ST_DEF.INC'
      COMMON     /VMR/MADRID
      INCLUDE    'MID_INCLUDE:ST_DAT.INC'
C
C     INITIATE MIDAS
C
      CALL STSPRO('SGFPI')
C
C     READ PARAMETERS
C
      CALL STKRDC('IN_A',1,1,60,IAV,INAME,KUNIT,INULL,IERR)
      CALL STKRDR('INPUTR',5,3,IAV,RANGE,KUNIT,INULL,IERR)
      CALL STKRDR('INPUTR',1,4,IAV,POSI,KUNIT,INULL,IERR)
      CALL STKRDR('INPUTR',8,2,IAV,REG,KUNIT,INULL,IERR)
C
C     OPEN IMAGE FRAME
C
      CALL STIGET(INAME,D_R4_FORMAT,F_I_MODE,1,3,NA,NPIX,START,
     2            STEP,IDEN,UNIT,PNTR,IMNO,IERR)
      IF (NA.NE.2 .OR. IERR.NE.0 .OR.
     .    ABS(SNGL(STEP(1))/SNGL(STEP(2))-1.0).GT.1E-5) THEN
         CALL STTPUT('*** FATAL: Wrong image format',IERR)
         CALL STSEPI
      ENDIF
C
C     CHECK PARAMETERS AND CONVERT TO PIXEL VALUES
C
      LFPHA = .TRUE.
      PIQ = ATAN(1.0)
      PIH = 2.0 * PIQ
      PI  = 4.0 * PIQ
      PI2 = 8.0 * PIQ
      DTR = PI / 180.0
      RI  = MAX( 0.0,ABS(RANGE(1)) )
      RO  = MAX( RI,ABS(RANGE(2)) )
      RM  = MIN( ABS(POSI(1)-SNGL(START(1))), 
     ,           ABS(POSI(2)-SNGL(START(2))) )
      RM  = MIN( RM,ABS(POSI(1)-SNGL(START(1))-NPIX(1)*SNGL(STEP(1))) )
      RM  = MIN( RM,ABS(POSI(2)-SNGL(START(2))-NPIX(2)*SNGL(STEP(2))) )
      RO  = MIN( RM-2.0*ABS(SNGL(STEP(1))),RO )
      DR  = ABS( RANGE(3) )
      XC  = (POSI(1)-SNGL(START(1)))/SNGL(STEP(1)) + 1.0
      YC  = (POSI(2)-SNGL(START(2)))/SNGL(STEP(2)) + 1.0
      NR  = MIN( MR,INT((RO-RI)/DR) )
      DPA = REG(1) / (MS-1)
      DAI = REG(2) / (MS-1)
      PAS = POSI(3) - 0.5*REG(1)
      AIS = POSI(4) - 0.5*REG(2)
      DO 60, I = 1,MS
         DIA(I) = AIS + (I-1)*DAI
   60 CONTINUE
C
C     GO THROUGH ALL POINTS IN THE MESH
C
      PA  = PAS
      DO 1000, IP = 1,MS
         AI  = AIS
         DO 1100, II = 1,MS
C
C     GET FOURIER COEFFICIENTS FROM EACH RADIUS
C
            XM = 0.0
            SM = 0.0
            WM = 0.0
            R  = RI
            PAR = DTR * PA
            AIR = DTR * AI
            DO 1200, I = 1,NR
               RP = R / SNGL(STEP(1))
               RL(I) = LOG(R)
               P2(I) = 0.0
               P4(I) = 0.0
               W(I)  = 0.0
               CALL APFFTC(MADRID(PNTR),NPIX(1),NPIX(2),XC,YC,
     ,                     RP,PAR,AIR,MFC,MC,AMP,PHA,AN)
               IF (MC.GE.MFC) THEN
                  IF (LFPHA) THEN
                     LFPHA = .FALSE.
                     PH(1) = 0.0
                     DO 1250, IX = 2, MFC
                        DIF = PI2 / FLOAT(IX-1)
                        IDF = INT((PHA(IX)-PH(IX-1))/DIF+100.5)-100
                        PH(IX) = PHA(IX) - FLOAT(IDF)*DIF
 1250                CONTINUE
                  ENDIF
                  CALL PHAMOD(PHA,PH,MFC)
                  P2(I)  = PHA(3)
                  P4(I)  = PHA(5)
                  W(I)   = 1.0
                  DIF = ATAN(TAN(2.0*(P2(I)-P4(I)))) / DTR
                  XM  = XM + DIF
                  SM  = SM + DIF*DIF
                  WM  = WM + 1.0
               ENDIF
               R  = R + DR
 1200       CONTINUE
C
C     COMPUTE MEAN AND RMS 
C
            CALL LFIT(RL,P2,W,NR,1,A2,SA2,B2,SB2,R2)
            CALL LFIT(RL,P4,W,NR,1,A4,SA4,B4,SB4,R4)
            CALL LFIT(P2,P4,W,NR,1,AD,SAD,BD,SBD,RD)
            XM = XM / WM
            SM = SQRT( MAX(0.0,SM/WM - XM*XM) )
            A(IP,II) = XM
            S(IP,II) = SM
            DA(IP,II) = AD
            DB(IP,II) = BD
            V(IP,II) = RD
            SS2 = 0.0
            SS4 = 0.0
            DO 1300, I = 1,NR
               SS2 = SS2 + (P2(I)-A2-B2*RL(I))**2
               SS4 = SS4 + (P4(I)-A4-B4*RL(I))**2
 1300       CONTINUE
            SA(IP,II) = SQRT(SS2/NR)
            SB(IP,II) = SQRT(SS4/NR)
            RR(IP,II) = R2
            AI = AI + DAI
 1100    CONTINUE
         PA = PA + DPA
 1000 CONTINUE
C
C     ESTIMATE POSITION OF MINIMUM
C
      WRITE(MSG,620) DIA
  620 FORMAT(' INCL. : ',5X,7F8.2)
      CALL STTPUT(MSG,IERR)
      PA = PAS
      CALL STTPUT('REGR. COEF. P2-P4',IERR)
      DO 2000, IP = 1,MS
         WRITE(MSG,640) PA,(V(IP,II),II=1,MS)
  640    FORMAT(' PA : ',F7.1,3X,7F8.4)
  642    FORMAT(' PA : ',F7.1,3X,7F8.2)
         CALL STTPUT(MSG,IERR)
         PA = PA + DPA
 2000 CONTINUE
      CALL STTPUT('SIGMA(DIF.)',IERR)
      PA = PAS
      DO 2100, IP = 1,MS
         WRITE(MSG,642) PA,(S(IP,II),II=1,MS)
         CALL STTPUT(MSG,IERR)
         PA = PA + DPA
 2100 CONTINUE
      CALL STTPUT('MEAN(DIF.)',IERR)
      PA = PAS
      DO 2200, IP = 1,MS
         WRITE(MSG,642) PA,(A(IP,II),II=1,MS)
         CALL STTPUT(MSG,IERR)
         PA = PA + DPA
 2200 CONTINUE
      CALL STTPUT('B(P2-P4)',IERR)
      PA = PAS
      DO 2300, IP = 1,MS
         WRITE(MSG,640) PA,(DB(IP,II),II=1,MS)
         CALL STTPUT(MSG,IERR)
         PA = PA + DPA
 2300 CONTINUE
      CALL STTPUT('SIGMA P2',IERR)
      PA = PAS
      DO 2400, IP = 1,MS
         WRITE(MSG,640) PA,(SA(IP,II),II=1,MS)
         CALL STTPUT(MSG,IERR)
         PA = PA + DPA
 2400 CONTINUE
      CALL STTPUT('SIGMA P4',IERR)
      PA = PAS
      DO 2500, IP = 1,MS
         WRITE(MSG,640) PA,(SB(IP,II),II=1,MS)
         CALL STTPUT(MSG,IERR)
         PA = PA + DPA
 2500 CONTINUE
      CALL STTPUT('REGR. COEF. R2',IERR)
      PA = PAS
      DO 2600, IP = 1,MS
         WRITE(MSG,640) PA,(RR(IP,II),II=1,MS)
         CALL STTPUT(MSG,IERR)
         PA = PA + DPA
 2600 CONTINUE
C
C     FINISHED - EXIT
C
      CALL STSEPI
      END

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or
C modify it under the terms of the GNU General Public License as
C published by the Free Software Foundation; either version 2 of
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public
C License along with this program; if not, write to the Free
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C       Internet e-mail: midas@eso.org
C       Postal address: European Southern Observatory
C                       Data Management Division
C                       Karl-Schwarzschild-Strasse 2
C                       D 85748 Garching bei Muenchen
C                       GERMANY
C===========================================================================
C
      PROGRAM TLOADTBL
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.Ponz, K. Banse
C
C.IDENTIFICATION:
C  program TLOADTBL
C
C.KEYWORDS:
C  display, table subsystem
C
C.PURPOSE:
C  Display table positions in the overlay plane of the display window
C  rows with coordinates falling outside the displayed image are skipped
C  the no. of skipped rows is stored in OUTPUTI(11)
C 
C  INPUTI(20) serves as print flag:  99 = show skipped rows
C				          and show coord conversion per row
C 
C  Execute the command
C
C  LOAD/TABLE table column1 column2 [column3] [symbol [size [level]]]
C
C.ALGORITHM:
C  plot table entries as : square    (0,2)
C                          circles     (1)
C                          triangle up (3), triangle down (4)
C                          cross       (5), open cross    (6)
C                          diamond     (7)
C                          X shaped cross (8)
C  for squares, triangles, circles and diamonds exist a filled option (add 100)
C  thus filled diamonds have value (107)
C
C.INPUT/OUTPUT:
C  the following keywords are used:
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  20:55 - 16 DEC 1987
C		881118  KB
C               891213  MP
C 101022	last modif
C 
C-------------------------------------------------------------------
C
C
      IMPLICIT NONE
C 
      INTEGER MADRID(1)
      INTEGER IC,I,J,ILEN
      INTEGER SELROW             ! index for selected rows 
      INTEGER NROW,NSC,IAV,NVAL
      INTEGER ISYMBOL,NODRAW,FILL
      INTEGER NCOL,NACOL,NAROW
      INTEGER INTEN,OVCON,MAXDL
      INTEGER ICOL(6),INPAR(3)
      INTEGER STAT,IMNO,PRFLAG
      INTEGER CONN                ! connection flag, P8
      INTEGER TINULL, TID, KUN, KNUL
      INTEGER NBYTE,TYPE,MY
      INTEGER IX(512),IY(512),NPOS(2),LASTP(2)
      INTEGER COLSYM,COLSIZ,COLCOL
      INTEGER SSX,SSY,LSX,LSY,SKIPD
C
      REAL RBUF(6),XY1(2),XY2(2)
      REAL VALUE(3)
      REAL TRNULL,RINFO(8),RDUM
C
      DOUBLE PRECISION TDNULL
C
      CHARACTER*80  FRAME,LINE,CTEST
      CHARACTER*80  TABLE
      CHARACTER*16  UNIT1,UNIT2
      CHARACTER     IFLAG*3,DLINE*40,LASTLINE*40,FORM*16
      CHARACTER*30  COLUMN(6)
      CHARACTER*2   PARM(6)
C
      LOGICAL ISEL,IPLOT,NULL(3)
C
      INCLUDE 'MID_INCLUDE:TABLES.INC/NOLIST'
      INCLUDE 'MID_INCLUDE:IDIDEV.INC/NOLIST'
      INCLUDE 'MID_INCLUDE:IDIMEM.INC/NOLIST'
C
      COMMON /VMR/MADRID
C
      INCLUDE 'MID_INCLUDE:TABLED.INC/NOLIST'
C
       DATA LINE/' '/,  DLINE /' '/
       DATA LASTLINE/' '/, FRAME /' '/, TABLE /' '/
       DATA PARM /'P2','P3','P4','P5','P6','P7'/
       DATA LASTP /0,0/, MAXDL /40/
C
C  initialize MIDAS + attach ImageDisplay
      CALL STSPRO('TLOADTBL')
      CALL DTOPEN(1,STAT)
C
C   get info for relevant memory board + scroll overlay channel
C   accordingly then clear scroll values, so we also start 
C   plotting at the lower left corner
C
      CALL STKRDI('DAZHOLD',13,1,IAV,OVCON,KUN,KNUL,STAT)
      CALL DTGICH(QDSPNO,QIMCH,FRAME,RINFO,STAT)
      IF (FRAME(1:1).EQ.' ')
     +   CALL STETER(14,'We need an image in the display...!')
      CALL STFOPN(FRAME,D_R4_FORMAT,0,F_IMA_TYPE,IMNO,STAT)
      IF (OVCON.EQ.QIMCH)
     +   CALL DAZZSC(QDSPNO,QOVCH,ZOOMX,SCROLX,SCROLY,STAT)
C 
C  INPUTI(20) serves as printflag for debugging
      CALL STKRDI('INPUTI',20,1,IAV,PRFLAG,KUN,KNUL,STAT)
      CALL STKRDI('IDIMEMI',2,4,IAV,IX,KUN,KNUL,STAT)
      SSX = IX(1)                             !1st screen x-pixel
      SSY = IX(2)                             !1st screen y-pixel
      LSX = SSX + IX(3) -1                    !last screen x-pixel
      LSY = SSY + IX(4) -1                    !last screen y-pixel
C
C ... get parameters
C
      CALL TBMNUL(TINULL,TRNULL,TDNULL)
      CALL STKRDC('IN_A',1,1,80,IAV,TABLE,KUN,KNUL,STAT)
      DO 10, I=1,6
         CALL STKRDC(PARM(I),1,1,30,IAV,COLUMN(I),KUN,KNUL,STAT)
10    CONTINUE
      NODRAW = 0
      IF (COLUMN(3)(1:1) .EQ. '+') THEN
          IC = 2                             !no IDENT column
      ELSE 
          IC = 3
          CALL UPCAS(COLUMN(3),LINE)         !check for NOdraw option
          I = INDEX(LINE,',NO')
          IF (I.GT.1) THEN
             NODRAW = 1
             COLUMN(3)(I:) = ' '             !clean column label
          ENDIF
      ENDIF 
      FILL = 0
      IF ((COLUMN(4)(1:1).EQ.'#').OR.(COLUMN(4)(1:1).EQ.':')) THEN
         COLSYM = 1                          !variable symbol from column
      ELSE
         COLSYM = 0                          !constant symbol
         CALL GENCNV(COLUMN(4),1,1,INPAR(1),RDUM,RDUM,IAV)
         IF (IAV.NE.1) INPAR(1) = 0
         IF (INPAR(1).GE.100) THEN
            FILL = 1
            INPAR(1) = INPAR(1) - 100
         ENDIF
         ISYMBOL = INPAR(1) + 1
      ENDIF
      IF ((COLUMN(5)(1:1).EQ.'#').OR.(COLUMN(5)(1:1).EQ.':')) THEN
         COLSIZ = 1                          !variable size from column
      ELSE
         COLSIZ = 0                          !constant size 
         CALL GENCNV(COLUMN(5),1,1,INPAR(2),RDUM,RDUM,IAV)
         IF (IAV.NE.1) INPAR(2) = 3
      ENDIF
      IF ((COLUMN(6)(1:1).EQ.'#').OR.(COLUMN(6)(1:1).EQ.':')) THEN
         COLCOL = 1                          !variable color from column
      ELSE
         COLCOL = 0                          !constant color
         CALL TSCOLR(COLUMN(6),INTEN)        !color string -> color no.
      ENDIF
C      
      CALL STKRDI('INPUTI',1,1,IAV,CONN,KUN,KNUL,STAT)
                               ! this will put P8 into CONN
C
C ... read table
C
      CALL TBTOPN(TABLE,F_I_MODE,TID,STAT)
      CALL TBIGET(TID,NCOL,NROW,NSC,NACOL,NAROW,STAT)
      DO 20, I=1,IC                               !search for x, y, ident cols
         CALL TBCSER(TID,COLUMN(I),ICOL(I),STAT)
         IF (ICOL(I).EQ.-1) CALL STETER(11,'Column not present')
20    CONTINUE
      IF (IC .EQ. 3) THEN                       ! if there is an ident col ...
         CALL TBFGET(TID,ICOL(3),FORM,ILEN,TYPE,STAT) ! get type, format
         IF (PRFLAG.EQ.99) WRITE(*,40090) TYPE,FORM
      ENDIF
      CALL TBUGET(TID,ICOL(1),UNIT1,STAT)
      CALL TBUGET(TID,ICOL(2),UNIT2,STAT)
      CALL UPCAS(UNIT1,UNIT1)
      I = INDEX(UNIT1,'PIX')                 !that catches also "Frame Pixels"
      CALL UPCAS(UNIT2,UNIT2)
      J = INDEX(UNIT2,'PIX')
      IF ((I.GT.0).AND.(J.GT.0)) THEN
          IFLAG  = '_RS'
      ELSE
          IFLAG  = 'WRS'
      ENDIF
      IF (COLSYM.EQ.1) THEN
         CALL TBCSER(TID,COLUMN(4),ICOL(4),STAT)
         IF (ICOL(4).EQ.-1) CALL STETER(11,'Symbol column not present')
      ENDIF
      IF (COLSIZ.EQ.1) THEN
         CALL TBCSER(TID,COLUMN(5),ICOL(5),STAT)
         IF (ICOL(5).EQ.-1) CALL STETER(11,'Size column not present')
      ENDIF
      IF (COLCOL.EQ.1) THEN
         CALL TBCSER(TID,COLUMN(6),ICOL(6),STAT)
         IF (ICOL(6).EQ.-1) CALL STETER(11,'Color column not present')
      ENDIF
C
C  set up PIXXCV
      CALL PIXXCV('INIT',IMNO,RBUF,STAT)
      IF (STAT.NE.0)
     +   CALL STETER(12,'PIXXCV initialization failed...')
C
C ... display values
C
      NVAL = 0
      SELROW = 0
      SKIPD = 0                         !no. of skipped rows
C 
      DO 100, I=1,NROW                   !step through all rows
         CALL TBSGET(TID,I,ISEL,STAT)   !read row selection flag
         CALL TBRRDR(TID,I,2,ICOL,VALUE,NULL,STAT)
         IPLOT  = ISEL .AND. ( .NOT. NULL(1)) .AND. ( .NOT. NULL(2))
         IF (IPLOT) THEN
            SELROW = SELROW + 1   
            IF (COLSYM.EQ.1) THEN
               FILL = 0
               CALL TBRRDI(TID,I,1,ICOL(4),INPAR(1),NULL,STAT)
               IF (INPAR(1).GT.100) THEN
                  FILL = 1
                  INPAR(1) = INPAR(1) - 100
               ENDIF
               ISYMBOL = INPAR(1) + 1
            ENDIF
            IF (COLSIZ.EQ.1) 
     +         CALL TBRRDI(TID,I,1,ICOL(5),INPAR(2),NULL,STAT)
            IF (COLCOL.EQ.1) 
     +         CALL TBRRDI(TID,I,1,ICOL(6),INTEN,NULL,STAT)
C
            RBUF(1) = VALUE(1)
            RBUF(2) = VALUE(2)
            CALL PIXXCV(IFLAG,0,RBUF,STAT)
            IF (STAT.NE.0) THEN
               IF (PRFLAG.EQ.99) WRITE(*,10077) I
               SKIPD = SKIPD + 1
               GOTO 100               !coord conversion failed - skip this row
            ENDIF
            IF (PRFLAG.EQ.99) WRITE(*,10078) (RBUF(J),J=1,6)
C 
C  test, if we'd draw outside the display...
            KUN = 0
            J = NINT(RBUF(5))                          !screen x-pixel
            IF ((J.LT.SSX).OR.(J.GT.LSX)) KUN = KUN + 1
            J = NINT(RBUF(6))                          !screen y-pixel
            IF ((J.LT.SSY).OR.(J.GT.LSY)) KUN = KUN + 10
            IF (KUN.GT.0) THEN
               IF (PRFLAG.EQ.99) THEN
                  IF (KUN.EQ.1) THEN
                     WRITE(*,10090) I
                  ELSE IF (KUN.EQ.10) THEN
                     WRITE(*,10091) I
                  ELSE 
                     WRITE(*,10092) I
                  ENDIF
               ENDIF
               SKIPD = SKIPD + 1
               GOTO 100                 !screen pixels outside - skip this row
            ENDIF
C 
            LINE(1:) = ' '
            IF (CONN.EQ.1) THEN        !yes, connect the symbols 
               NVAL   = NVAL + 1
               IF (NVAL.GT.512) THEN                      !flush line buffer
                  CALL IIGPLY(QDSPNO,QOVCH,IX,IY,512,INTEN,1,STAT)
                  IX(1) = IX(512)
                  IY(1) = IY(512)
                  NVAL = 2
               ENDIF
               IX(NVAL) = NINT(RBUF(5))
               IY(NVAL) = NINT(RBUF(6))
            ENDIF
C 
            IF (ISYMBOL.GT.0) THEN
               XY1(1) = RBUF(5) - INPAR(2)
               XY1(2) = RBUF(6) - INPAR(2)
               XY2(1) = RBUF(5) + INPAR(2)
               XY2(2) = RBUF(6) + INPAR(2)
               CALL DRAWME(ISYMBOL,FILL,XY1,XY2,INTEN)
            ENDIF
C 
            IF (IC.EQ.3) THEN           ! yes, there is a third column as ident 
               IF (TYPE .EQ. D_C_FORMAT) THEN         !type is character
                  CALL TBERDC(TID,I,ICOL(3),CTEST,NULL(3),STAT)
                  CALL FT_EOS(CTEST,80,LINE,STAT)
                  NBYTE = INDEX(LINE,' ') - 1
                  IF (NBYTE.GT.39) NBYTE = 39         !DLINE is 40 chars.
                  DLINE(1:) = LINE(1:NBYTE)          
               ELSE                          !type of 3rd column is not char..
                  CALL TBERDR(TID,I,ICOL(3),VALUE(3),NULL(3),STAT)
                  IF ((TYPE .EQ. D_I1_FORMAT) .OR.
     +                (TYPE .EQ. D_I2_FORMAT) .OR.
     +                (TYPE .EQ. D_I4_FORMAT)) THEN     !integer type 
                     MY = NINT(VALUE(3))
                     IAV = 1
                  ELSE                                  !float type
                     IAV = 2
                  ENDIF
C
                  CALL W1FORM(FORM,IAV,MY,VALUE(3),TDNULL,DLINE)
                  IAV = 1
                  MY = MAXDL - 1                        !avoid overrun of DLINE
35                IF (DLINE(1:1) .EQ. ' ') THEN         !remove leading blanks
                     IAV = IAV + 1
                     IF (IAV.LT.MY) THEN
                        DLINE(1:) = DLINE(2:)
                        GOTO 35
                     ELSE
                        DLINE(1:1) = 'x'
                        NBYTE = 1
                        GOTO 40
                     ENDIF
                  ENDIF
C 
                  NBYTE = INDEX(DLINE,' ') - 1
               ENDIF
C 
40             DLINE(NBYTE+1:) = '^'                    !mark the end
               NPOS(1) = NINT(RBUF(5)) + 5
               NPOS(2) = NINT(RBUF(6))

               IF (CONN.NE.0) THEN    ! connection flag P8 is +1 or -1
                  IF (NODRAW.EQ.0)
     +               CALL IIGTXT(QDSPNO,QOVCH,DLINE(1:NBYTE),
     +                           NPOS(1),NPOS(2),0,0,INTEN,0,STAT)
C 
               ELSE                   ! CONN (P8) is zero (default)
                  IF (SELROW.EQ.1) THEN     ! in first row of table
                     LASTP(1) = NPOS(1)
                     LASTP(2) = NPOS(2)
                     LASTLINE(1:) = DLINE(1:)    !LASTLINE set to DLINE
                  ENDIF
C	  
                  IF (LASTLINE.EQ.DLINE) THEN	!true, at least for first row
                     NVAL = NVAL + 1
                     IF (NVAL.GT.512) THEN	!flush line buffer
                        CALL IIGPLY(QDSPNO,QOVCH,IX,IY,512,INTEN,1,STAT) 
                        IX(1) = IX(512)
                        IY(1) = IY(512)
                        NVAL = 2
                     ENDIF
                  ELSE				!LASTLINE not equal DLINE
                     IF (NVAL.GT.1) 
     +                  CALL IIGPLY(QDSPNO,QOVCH,IX,IY,NVAL,
     +                              INTEN,1,STAT)
                     NVAL = 1
                     NBYTE = INDEX(LASTLINE,'^') - 1
                     IF ((NBYTE.GT.0).AND.(NODRAW.EQ.0))
     +                  CALL IIGTXT(QDSPNO,QOVCH,LASTLINE(1:NBYTE),
     +                              LASTP(1),LASTP(2),0,0,INTEN,0,STAT)
                     LASTLINE(1:) = DLINE(1:)
                     LASTP(1) = NPOS(1)
                     LASTP(2) = NPOS(2)
                  ENDIF
C	  
                  IX(NVAL) = NINT(RBUF(5))
                  IY(NVAL) = NINT(RBUF(6))
               ENDIF
C 
            ENDIF
         ENDIF
100   CONTINUE
C 
      IF (IC.EQ.3) THEN
         IF ((CONN.NE.-1) .AND. (NODRAW.EQ.0)) THEN
            NBYTE = INDEX(LASTLINE,'^') - 1
            CALL IIGTXT(QDSPNO,QOVCH,LASTLINE(1:NBYTE),
     +                  LASTP(1),LASTP(2),0,0,INTEN,0,STAT)
         ENDIF
      ENDIF
C 
      IF (NVAL.GT.1) THEN
         CALL IIGPLY(QDSPNO,QOVCH,IX,IY,NVAL,INTEN,1,STAT)
      ENDIF
C 
C  write no. of skipped rows into OUTPUTI(11)
      CALL STKWRI('OUTPUTI',SKIPD,11,1,KUN,STAT)
C
C ... end
C
      CALL TBTCLO(TID,STAT)
      CALL DTCLOS(QDSPNO)
C refresh the overlay:      
      CALL REFOVR(STAT) 
      CALL STSEPI
C
C  Formats
10077 FORMAT('row no.',I5,' contains bad coord(s) - we skip ...')
10078 FORMAT('RBUF(1-6)',6F10.4)
10090 FORMAT('screen x-pixel outside - skip row no. ',I5)
10091 FORMAT('screen y-pixel outside - skip row no. ',I5)
10092 FORMAT('screen x- and y-pixel outside - skip row no. ',I5)
40090 FORMAT('refcolumn: type = ',I3,', format = ',A)
      END

      SUBROUTINE DRAWME(FLAG,FILL,XY1,XY2,INTENS)
C
C
      IMPLICIT NONE
C 
      INTEGER INTENS,N,NOP,IK,SW,N1,N2,M(2),IX,IY
      INTEGER XFIG(513),YFIG(513)
      INTEGER FLAG,FILL,RADIUS,RADX,RADY,NCX,NCY
      INTEGER CENTER(2)
C
      REAL XY1(2),XY2(2)
      REAL CONST,ANGLE,FACTO,AA
C
      INCLUDE 'MID_INCLUDE:IDIDEV.INC/NOLIST'
      INCLUDE 'MID_INCLUDE:IDIMEM.INC/NOLIST'
C
C  branch according to flag
      GO TO (100,200,100,500,600,700,800,900,1000),FLAG
C
C  construct coordinates for a rectangle
100   IF (FILL.NE.1) THEN
         XFIG(1) = XY1(1)
         YFIG(1) = XY1(2)
         XFIG(2) = XFIG(1)                      !move up
         YFIG(2) = XY2(2)
         XFIG(3) = XY2(1)                       !move right
         YFIG(3) = YFIG(2)
         XFIG(4) = XFIG(3)                       !move down
         YFIG(4) = YFIG(1)
         XFIG(5) = XFIG(1)
         YFIG(5) = YFIG(1)
         NOP = 5
      ELSE
         N1 = XY1(2)
         N2 = XY2(2)
         M(1) = XY1(1)
         M(2) = XY2(1)
         IK = 1
         SW = 1
         DO 150, N=N1,N2
            XFIG(IK) = M(SW)
            YFIG(IK) = N
            SW = 3 - SW                         !oscillate between 1 and 2
            IK = IK + 1
            XFIG(IK) = M(SW)
            YFIG(IK) = N
            IK = IK + 1
150      CONTINUE
         NOP = IK - 1
      ENDIF
      GO TO 10000
C
C  construct coordinates of a circle
200   CENTER(1) = NINT((XY1(1)+XY2(1))*0.5)
      CENTER(2) = NINT((XY1(2)+XY2(2))*0.5)
      RADX   = ABS(XY1(1)-CENTER(1))
      RADY   = ABS(XY1(2)-CENTER(2))
      RADIUS = NINT((RADX+RADY)*0.5)            !get no. of points to draw
      NOP    = MIN(512,6*RADIUS)
      CONST  = 6.27/NOP
      FACTO = 0.017453                          !Pi / 180.
C
C  construct points on circle
      IF (FILL.NE.1) THEN
         DO 300, N=1,NOP+1
            ANGLE = (N-1)*CONST
            XFIG(N) = CENTER(1) + NINT(RADIUS*COS(ANGLE))
            YFIG(N) = CENTER(2) + NINT(RADIUS*SIN(ANGLE))
300      CONTINUE
         NOP = NOP + 1
      ELSE
         M(1) = CENTER(2) - RADIUS                !low y
         M(2) = CENTER(2) + RADIUS                !high y
         NCX = CENTER(1)
         NCY = CENTER(2)
         XFIG(1) = NCX
         YFIG(1) = M(1)
         IK = 2
         SW = -900                             !start at -90 degs */
         AA = 0.1 * FACTO
         DO 350, N=M(1),M(2)
C 
330         SW = SW + 1
            IF (SW.GT.900) GOTO 355            !avoid infinite loop
            ANGLE = SW * AA
            IY = NINT(RADIUS*SIN(ANGLE))
            N1 = NCY + IY                      !test y-value of circle
            IF (N1.LT.N) GOTO 330
C 
            IX = NINT(RADIUS*COS(ANGLE))
            XFIG(IK) = NCX + IX
            YFIG(IK) = NCY + IY
            IK = IK + 1
            XFIG(IK) = NCX - IX
            YFIG(IK) = YFIG(IK-1)
            IK = IK + 1
            XFIG(IK) = NCX + IX
            YFIG(IK) = YFIG(IK-1)
            IK = IK + 1
350      CONTINUE
355      XFIG(IK) = NCX
         YFIG(IK) = M(2)
         NOP = IK 
      ENDIF
      GOTO 10000
C
C  construct coordinates of a triangle
500   IF (FILL.NE.1) THEN
         XFIG(1) = XY1(1)
         YFIG(1) = XY1(2)
         CENTER(1) = NINT((XY1(1)+XY2(1))*0.5)
         XFIG(2) = CENTER(1)
         YFIG(2) = XY2(2)
         XFIG(3) = XY2(1)
         YFIG(3) = XY1(2)
         XFIG(4) = XY1(1)
         YFIG(4) = XY1(2)
         NOP = 4
      ENDIF
      GO TO 10000
C
C  construct coordinates of a triangle
600   XFIG(1) = XY1(1)
      YFIG(1) = XY2(2)
      CENTER(1) = NINT((XY1(1)+XY2(1))*0.5)
      XFIG(2) = CENTER(1)
      YFIG(2) = XY1(2)
      XFIG(3) = XY2(1)
      YFIG(3) = XY2(2)
      XFIG(4) = XY1(1)
      YFIG(4) = XY2(2)
      NOP = 4
      GOTO 10000
C
C  construct coordinates of a cross
700   CENTER(1) = NINT((XY1(1)+XY2(1))*0.5)
      CENTER(2) = NINT((XY1(2)+XY2(2))*0.5)
      XFIG(1) = XY1(1)
      YFIG(1) = CENTER(2)
      XFIG(2) = XY2(1)
      YFIG(2) = YFIG(1)
      XFIG(3) = CENTER(1)
      YFIG(3) = YFIG(2)
      XFIG(4) = XFIG(3)
      YFIG(4) = XY2(2)
      XFIG(5) = XFIG(4)
      YFIG(5) = XY1(2)
      NOP = 5
      GOTO 10000
C
C  construct coordinates of an open cross
800   CENTER(1) = NINT((XY1(1)+XY2(1))*0.5)
      CENTER(2) = NINT((XY1(2)+XY2(2))*0.5)
      IK = (XY2(1) - CENTER(1))/2
      IF (IK.LT.1) IK = 1
C 
      XFIG(1) = XY1(1)
      YFIG(1) = CENTER(2)
      XFIG(2) = CENTER(1) - IK
      YFIG(2) = YFIG(1)
      NOP = 2
      CALL IIGPLY(QDSPNO,QOVCH,XFIG,YFIG,NOP,INTENS,1,N)
      XFIG(1) = CENTER(1) + IK
      XFIG(2) = XY2(1)
      CALL IIGPLY(QDSPNO,QOVCH,XFIG,YFIG,NOP,INTENS,1,N)
      XFIG(1) = CENTER(1)
      YFIG(1) = XY1(2)
      XFIG(2) = XFIG(1)
      YFIG(2) = CENTER(2) - IK
      CALL IIGPLY(QDSPNO,QOVCH,XFIG,YFIG,NOP,INTENS,1,N)
      YFIG(1) = CENTER(2) + IK
      YFIG(2) = XY2(2)
      CALL IIGPLY(QDSPNO,QOVCH,XFIG,YFIG,NOP,INTENS,1,N)
      RETURN
C
C  construct coordinates of a diamond
900   CENTER(1) = NINT((XY1(1)+XY2(1))*0.5)
      CENTER(2) = NINT((XY1(2)+XY2(2))*0.5)
      XFIG(1) = CENTER(1)
      YFIG(1) = XY1(2)
      XFIG(2) = XY2(1)
      YFIG(2) = CENTER(2)
      XFIG(3) = XFIG(1)
      YFIG(3) = XY2(2)
      XFIG(4) = XY1(1)
      YFIG(4) = YFIG(2)
      XFIG(5) = XFIG(1)
      YFIG(5) = YFIG(1)
      NOP = 5
      GOTO 10000
C
C  construct coordinates of an X shaped cross
1000  XFIG(1) = XY1(1)
      YFIG(1) = XY1(2)
      XFIG(2) = XY2(1)
      YFIG(2) = XY2(2)
      NOP = 2
      CALL IIGPLY(QDSPNO,QOVCH,XFIG,YFIG,NOP,INTENS,1,N)
      YFIG(1) = XY2(2)
      XFIG(2) = XY2(1)
      YFIG(2) = XY1(2)
      CALL IIGPLY(QDSPNO,QOVCH,XFIG,YFIG,NOP,INTENS,1,N)
      RETURN
C
C  now draw the shape
10000 CALL IIGPLY(QDSPNO,QOVCH,XFIG,YFIG,NOP,INTENS,1,N)
C
      RETURN
      END

C @(#)deconv.for	13.1.1.1 (ES0-DMD) 06/02/98 18:17:32
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM DECONV
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  program DECONV           version 1.0		881028
C  P. GROSBOL               ESO - GARCHING
C  K. Banse (streamlined for MIDAS)
C  M Peron    900118, change the dimension of NPSF and the test for the
C PSF centered at the origin
C.KEYWORDS:
C  deconvolution
C
C.PURPOSE:
C  deconvolve an image with a point spread function
C  images may have up to 3 dimensions
C
C.ALGORITHM:
C  an iterative deconvolution method as published by L.B. Lucy
C  REF.: LUCY,.L.B 1974, A.J. VOL.79 , P.745
C
C.INPUT/OUTPUT:
C
C  the following keywords are used:
C  IN_A/C/1/60			input frame
C  IN_B/C/1/60			point spread function
C  OUT_A/C/1/60			output frame
C  INPUTI/I/1/2			(1) = no. of iterations
C				if no_iter = 0, a convolution will be done !
C				(2) = continue_flag
C.VERSIONS
C  1.00		from version 3.80 as of 870327
C  		use FORTRAN 77 + new ST interfaces
C	
C------------------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER    I,IAV
      INTEGER*8  PNTRB,PNTRI,PNTRO,PNTRP,PSFPTR,PNTRX
      INTEGER    IMNOI,IMNOO,IMNOP,IMNPSF
      INTEGER    ISIZE,ISTAT
      INTEGER    N,NAXI,NAXO,NAXP,NOI
      INTEGER    NPIXI(3),NPIXO(3),NPIXP(3),INPUTI(2)
      INTEGER    NPSF(3),LOW(3),OUTLOW(3),HIGH(3)
      INTEGER    N0X,N0Y,MAXPSF
      INTEGER    UNI(1),NULO,MADRID(1)
C
      CHARACTER*60   INFRM,OUTFRM,PSFFRM
      CHARACTER      CUNITI*64,CUNITO*64,CUNITP*64,MYACT*80
      CHARACTER      TEXT*72,IDENT*72
      CHARACTER*80   ERMES3,ERMES4,ERMES5,ERMES6
      CHARACTER      TIME*40,MIDUNI*2,TMPFIL*14
C
      DOUBLE PRECISION STRI(3),STRO(3),STRP(3),T
      DOUBLE PRECISION STEPI(3),STEPO(3),STEPP(3),END
C
      REAL        CUTS(4)
      REAL        RELC,EPSI
      REAL        DECNVL                                    !function
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON   /VMR/  MADRID
C
      DATA    CUTS   /4*0./
      DATA    ERMES3
     +        /'Point Spread Function higher dimensioned than image '/
      DATA    ERMES4 
     +        /'Point Spread Function not centered at origin (in x) '/
      DATA    ERMES6 
     +        /'Point Spread Function not centered at origin (in y) '/
      DATA    ERMES5 /'Point Spread Function has different stepsize '/
      DATA    NPIXI  /1,1,1/,   NPIXO  /1,1,1/, NPIXP  /1,1,1/
      DATA    MAXPSF /10201/                       !that's a 101*101 PSF
      DATA    LOW /1,1,1/,      OUTLOW /1,1,1/, HIGH   /1,1,1/
      DATA    IDENT  /' '/,  CUNITI  /' '/,  CUNITP  /' '/
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C  get into  MIDAS environment
      CALL STSPRO('DECONV')
      CALL STKRDC('MID$SESS',1,11,2,IAV,MIDUNI,UNI,NULO,ISTAT)
      TMPFIL(1:) = 'deco'//MIDUNI//'dum.bdf '
C
C  get input image and check dimensions
      CALL STKRDC('IN_A',1,1,60,IAV,INFRM,UNI,NULO,ISTAT)
      CALL STIGET(INFRM,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +            2,NAXI,NPIXI,STRI,STEPI,IDENT,CUNITI,
     +            PNTRI,IMNOI,ISTAT)
      IF (NAXI.GT.2) NAXI = 2                  !force to max. 2-dim frame
C
C  get PSF and check it
      CALL STKRDC('IN_B',1,1,60,IAV,PSFFRM,UNI,NULO,ISTAT)
      CALL STIGET(PSFFRM,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +            2,NAXP,NPIXP,STRP,STEPP,TEXT,CUNITP,
     +            PNTRP,IMNOP,ISTAT)
      IF (NAXP.GT.NAXI) CALL STETER(1,ERMES3)
C
C  handle x-dimension
      IF ( ABS(STEPP(1)-STEPI(1)) .GT. 0.1E-5*ABS(STEPI(1)) )
     +   CALL STETER(2,ERMES5)
C
      END = STRP(1) + ( (NPIXP(1) - 1) * STEPP(1) )
      T = ABS(STRP(1))-ABS(END)
      EPSI = 10.E-7 * ABS(STEPP(1))
      IF (ABS(T).GT.EPSI)CALL STETER(3,ERMES4) 
      T = MIN(ABS(STRP(1)),ABS(END))
C
      NPSF(1) = INT(T / ABS(STEPP(1)))         !no. of pixels to left of center
      N0X = NINT( - (STRP(1)/STEPP(1)) ) + 1   !pixel no. of 0.0
C
C  for 1-dim files we are done already
      IF ( (NAXI.EQ.1).OR.(NAXP.EQ.1) ) THEN
         NPSF(2) = 1
         LOW(1) = N0X - NPSF(1)                !starting pixel in x
         HIGH(1) = N0X + NPSF(1)
         GOTO 2000
      ENDIF
C
C  handle y-dimension
      IF ( ABS(STEPP(2)-STEPI(2)) .GT. 0.1E-5*ABS(STEPI(2)) )
     +   CALL STETER(4,ERMES5)
C
      END = STRP(2) + ( (NPIXP(2) - 1) * STEPP(2) )
      T = ABS(STRP(2))-ABS(END)
      EPSI = 10.E-7 * ABS(STEPP(2))
      IF (ABS(T).GT.EPSI)CALL STETER(5,ERMES6) 
      T = MIN(ABS(STRP(2)),ABS(END))
C
      NPSF(2) = INT(T / ABS(STEPP(2)))          !no. of pixels to left of center
      N0Y = NINT( - (STRP(2)/STEPP(2)) ) + 1        !pixel no. of 0.0
C
C  make minimum square PSF
      NPSF(1) = MIN(NPSF(1),NPSF(2))
      NPSF(2) = NPSF(1)
      LOW(1) = N0X - NPSF(1)                        !starting pixel in x
      HIGH(1) = N0X + NPSF(1)
      LOW(2) = N0Y - NPSF(2)                        !starting pixel in y
      HIGH(2) = N0Y + NPSF(2)
C
C  allocate virtual memory for working area = one line
2000  CALL STFXMP(NPIXI(1),D_R4_FORMAT,PNTRX,ISTAT)
C
C  create PSF temporary
      STRP(1) = STRP(1) + ( (LOW(1)-1)*STEPP(1) )
      STRP(2) = STRP(2) + ( (LOW(2)-1)*STEPP(2) )
      NPSF(1) = HIGH(1) - LOW(1) + 1                !now really the dimensions...
      NPSF(2) = HIGH(2) - LOW(2) + 1
      NPSF(3) = 1
      MYACT(1:) = 'centered + normalized PSF '
      CALL STIPUT(TMPFIL,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +            NAXP,NPSF,STRP,STEPP,MYACT,
     +            CUNITP,PSFPTR,IMNPSF,ISTAT)
      CALL COPWND(MADRID(PNTRP),NPIXP,MADRID(PSFPTR),NPSF,
     +            LOW,OUTLOW,HIGH)
      ISIZE = NPSF(1) * NPSF(2)
      IF (ISIZE.GT.MAXPSF)
     +   CALL STTPUT('more than 10201 pixels in PSF...!',ISTAT)
C 
C normalize termporary PSF
      CALL NORMFR(MADRID(PSFPTR),MADRID(PSFPTR),ISIZE)  
C
C  get result frame + check for continued iteration
      CALL STKRDC('OUT_A',1,1,60,IAV,OUTFRM,UNI,NULO,ISTAT)
      CALL STKRDI('INPUTI',1,2,IAV,INPUTI,UNI,NULO,ISTAT)
      NOI = INPUTI(1)
      IF (INPUTI(2).NE.1)  THEN                        !iter_cont flag set ?
         CALL STIPUT(OUTFRM,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +               NAXI,NPIXI,STRI,STEPI,IDENT,CUNITI,
     +               PNTRO,IMNOO,ISTAT)
         CALL STDWRR(IMNOO,'LHCUTS',CUTS,1,4,UNI,ISTAT)
         CALL INITFR(MADRID(PNTRI),NAXI,NPIXI,
     +               MADRID(PSFPTR),NAXP,NPSF,
     +               MADRID(PNTRO),MADRID(PNTRX))
      ELSE
         CALL STIGET(OUTFRM,D_R4_FORMAT,F_IO_MODE,F_IMA_TYPE,
     +               3,NAXO,NPIXO,STRO,STEPO,IDENT,
     +               CUNITO,PNTRO,IMNOO,ISTAT)
      ENDIF
C
C  update descriptors of result frame
      CALL DSCUPT(IMNOI,IMNOO,' ',ISTAT)
      IF (NOI.LT.0) GOTO 9000                     !leave after one convolution
C
C  create a temporary buffer frame
      ISIZE = 1
      DO 5050, I=1,NAXI
         ISIZE = ISIZE * NPIXI(I)
5050  CONTINUE
      CALL STFXMP(ISIZE,D_R4_FORMAT,PNTRB,ISTAT)
C
C  do the deconvolution + show processing times
      DO 6000, I=1,NOI
         RELC = DECNVL(MADRID(PNTRI),NAXI,NPIXI,
     +                 MADRID(PSFPTR),NAXP,NPIXP,
     +                 MADRID(PNTRO),MADRID(PNTRB),
     +                 MADRID(PNTRX))
         CALL GENTIM(TIME)
         DO 5100, N=40,2,-1
            IF (TIME(N:N).NE.' ') THEN
               IAV = N
               GOTO 5200
            ENDIF
5100     CONTINUE
         IAV = 1
5200     WRITE(TEXT,10000) I,RELC
         MYACT(1:) = TEXT(1:36)//TIME(1:IAV)//' '
         CALL STTPUT(MYACT,ISTAT)
6000  CONTINUE
C
C  That's it folks...
C
9000  CALL STSEPI
C
10000 FORMAT('no.',I3,', rel. change: ',F10.3)
      END

      SUBROUTINE NORMFR(F,G,NO)
C
      IMPLICIT NONE
C
      INTEGER    NO
      INTEGER    I
C
      REAL       F(*),G(*)
      REAL       R
C
      DOUBLE PRECISION    SUM
C
      SUM = 0.D0
C
      DO 200 I=1,NO
         SUM = SUM + F(I)
200   CONTINUE
C
      IF (ABS(SUM) .GT. 10.D-30) THEN
         R = SNGL( 1.D0/SUM )
         DO 400 I=1,NO
            G(I) = F(I) * R
400      CONTINUE
      ELSE
         CALL STTPUT('Warning: Total flux = 0.0 !!!',I)
      ENDIF
C
      RETURN
      END

      SUBROUTINE INITFR(F,NAF,NPF,PSF,NAP,NPP,RES,DUM)
C
      IMPLICIT NONE
C
      INTEGER    NAF,NPF(*),NAP,NPP(*)
      INTEGER    I,IDX,II,IX,IXP,IXX
      INTEGER    J,JJ,K
      INTEGER    NCY,NCZ,NPX,NPY,NPZ,NX,NY,NZ
C
      REAL       F(*),PSF(*),RES(*),DUM(*)
C
C  init
      NX = NPF(1)
      IF (NAF.GE.2) THEN
         NY = NPF(2)
      ELSE
         NY = 1
      ENDIF
      IF (NAF.GE.3) THEN
         NZ = NPF(3)
      ELSE
         NZ = 1
      ENDIF
      NPX = NPP(1)
      IF (NAP.GE.2) THEN
         NPY = NPP(2)
      ELSE
         NPY = 1
      ENDIF
      NCY = NPY / 2 + 1
      IF (NAP.GE.3) THEN
         NPZ = NPP(3)
      ELSE
         NPZ = 1
      ENDIF
      NCZ = NPZ / 2 + 1
C
C  for speed reasons use different code for 1, 2, 3-dimensions
      IF (NZ.EQ.1) GOTO 3000
C
C  3-dim convolution
      IXX = 1
      DO 2000, II=1,NZ
C
         DO 1500, I=1,NY
            IX = IXX
            DO 400, K=1,NX
               RES(IX) = 0.0
               IX = IX + 1
400         CONTINUE
            IXP = 1
C
            DO 1000, JJ=1,NPZ
               DO 800, J=1,NPY
                  IDX = 1 + NX*(MAX(1,MIN(NY,J+I-NCY))-1 +
     +                  NY*(MAX(1,MIN(NZ,JJ+II-NCZ))-1) )
                  CALL CONVL1(F(IDX),NX,PSF(IXP),NPX,RES(IXX))
                  IXP = IXP + NPX
800            CONTINUE
1000        CONTINUE
            IXX = IXX + NX
1500     CONTINUE
C
2000  CONTINUE
C
C  we're done
      RETURN
C
3000  IF (NY.EQ.1) GOTO 5000
C
C  handle 2-dim convolution
      IXX = 1
      DO 4000, I=1,NY
           IX = IXX
           DO 3300, K = 1,NX
              RES(IX) = 0.0
              IX = IX + 1
3300       CONTINUE
           IXP = 1
           DO 3600 J=1,NPY
              IDX = 1 + NX*(MAX(1,MIN(NY,J+I-NCY))-1)
              CALL CONVL1(F(IDX),NX,PSF(IXP),NPX,RES(IXX))
              IXP = IXP + NPX
3600        CONTINUE
            IXX = IXX + NX
4000     CONTINUE
C
C  we're done
      RETURN
C
C  handle 1-dim convolution
5000  IX = 1
      DO 5500, K=1,NX
           RES(IX) = 0.0
           IX = IX + 1
5500  CONTINUE
      CALL CONVL1(F,NX,PSF,NPX,RES)
C
C  we're done
      RETURN
C
      END

      SUBROUTINE CONVL1(F,NF,PSF,NP,C)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION:
C  subroutine CONVL1        version 1.00	880916
C  P. GROSBOL               ESO - GARCHING
C  K. Banse (streamlined for MIDAS)
C
C.KEYWORDS:
C  convolution
C
C.PURPOSE:
C  convoles two one dimensional arrays with each other
C
C.ALGORITHM:
C  a one dimensional array is convoled with a one dimensional
C  point spread function. outside the limits of the function
C  array the first/last value is taken.
C
C.INPUT/OUTPUT:
C  the subroutine is called as CONVL1(F,NF,PSF,NP,C)
C
C  F(NF)   :  function array                          (INPUT)
C  NF      :  dimension of function array             (INPUT)
C  PSF(NP) :  point spread function array             (INPUT)
C  NP      :  dimension of point spread functon       (INPUT)
C  C(NF)   :  convolved result array                  (OUTPUT)
C
C  NOTE :  the result is added to the output array 'C'.
C
C---------------------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER    NF,NP
      INTEGER    I,K,NL1,NL2,NL3
      INTEGER    NOS,NR
C
      REAL       F(NF),C(NF),PSF(NP)
      REAL       FACT,R
C
C  initialize
      NOS = NP/2
      NL1 = NOS + 1
      NL2 = NF - NOS
      NL3 = NL2 + 1
C
C  if NP = 1, we only use middle section
      IF (NOS.EQ.0) THEN
         DO 1000, I=NL1,NL2
            NR = I - NOS
            R = C(I)
            DO 400, K=1,NP
               R = R + PSF(K)*F(NR)
               NR = NR + 1
400         CONTINUE
            C(I) = R
1000     CONTINUE
         RETURN
      ENDIF
C
C  for NP > 1, handle 1. section, where values before F(1) would be needed
      FACT = F(1)
      DO 2000, I=1,NOS
         R = C(I)
         DO 1400 K=1,1+NOS-I
            R = R + PSF(K)*FACT
1400     CONTINUE
         NR = 1
C
         DO 1600, K=2+NOS-I,NP
            R = R + PSF(K)*F(NR)
            NR = NR + 1
1600     CONTINUE
         C(I) = R
2000  CONTINUE
C
C  in the middle no problems
      DO 3000 I=NL1,NL2
         NR = I - NOS
         R = C(I)
         DO 2400, K=1,NP
            R = R + PSF(K)*F(NR)
            NR = NR + 1
2400     CONTINUE
         C(I) = R
3000  CONTINUE
C
C  last section, values after F(NF) would be needed
      FACT = F(NF)
      DO 4000, I=NL3,NF
         NR = I - NOS
         R = C(I)
         DO 3300, K=1,NF+NOS-I
            R = R + PSF(K)*F(NR)
            NR = NR + 1
3300     CONTINUE
C
         DO 3600, K=NF+NOS-I+1,NP
            R = R + PSF(K)*FACT
3600     CONTINUE
         C(I) = R
4000  CONTINUE
C
      RETURN
      END

      REAL FUNCTION DECNVL(F,NAF,NPF,PSF,NAP,NPP,RES,BUF,DUM)
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION:
C  function DECNVL               version 2.10      840116
C  P. GROSBOL                    ESO - GARCHING
C  K. Banse (streamlined for MIDAS)
C
C.KEYWORDS:
C  DECONVOLUTION
C
C.PURPOSE:
C  deconvolve an image with its point spread function
C
C.ALGORITHM:
C  the iterative method of lucy is used for deconvolving upto
C  three dimensional images with their point spread function.
C  each call will performe one iterative step only.
C  REF.: LUCY,L.B. 1974 , A.J. VOL. 79, P. 745
C
C.INPUT/OUTPUT:
C  call as DECNVL(F,NAF,NPF,PSF,NAP,NPP,RES,BUF,DUM)
C
C  DECNVL  :  max. relative change applied
C  F       :  original image                           (INPUT)
C  NAF     :  dimension of F,RES and BUF               (INPUT)
C  NPF()   :  no. of pixels in F,RES and BUF           (INPUT)
C  PSF     :  point spread function                    (INPUT)
C  NAP     :  dimension of PSF                         (INPUT)
C  NPP     :  no. of pixels in PSF                     (INPUT)
C  RES     :  deconvolved image                        (INPUT/OUTPUT)
C  BUF     :  correction buffer                        (OUTPUT)
C  DUM()   :  dummy array                              (OUTPUT)
C
C---------------------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER    NAF,NAP,NPF(*),NPP(*)
      INTEGER    I,IDX,II,IX,IXP,IXX
      INTEGER    J,JJ,K,NCY,NCZ
      INTEGER    NPX,NPY,NPZ,NX,NY,NZ
C
      REAL       F(*),RES(*),BUF(*),PSF(*),DUM(*)
      REAL       ADUM,RELC
C
C  init
      NX = NPF(1)
      IF (NAF.GE.2) THEN
         NY = NPF(2)
      ELSE
         NY = 1
      ENDIF
      IF (NAF.GE.3) THEN
         NZ = NPF(3)
      ELSE
         NZ = 1
      ENDIF
      NPX = NPP(1)
      IF (NAP.GE.2) THEN
         NPY = NPP(2)
      ELSE
         NPY = 1
      ENDIF
      NCY = NPY / 2 + 1
      IF (NAP.GE.3) THEN
         NPZ = NPP(3)
      ELSE
         NPZ = 1
      ENDIF
      NCZ = NPZ / 2 + 1
      RELC = 0.0
C
C  for speed reasons use different code for 1, 2, 3-dimensions
      IF (NZ.EQ.1) GOTO 3000
C
C  first convolution for 3-dim image
      IXX = 1
      DO 1000, II=1,NZ
         DO 800, I=1,NY
            IX = IXX
            DO 200, K=1,NX
               BUF(IX) = 0.0
               IX = IX + 1
200         CONTINUE
            IXP = 1
            DO 600, JJ=1,NPZ
               DO 400, J=1,NPY
                  IDX = 1 + NX*(MAX(1,MIN(NY,J+I-NCY))-1 +
     +                  NY*(MAX(1,MIN(NZ,JJ+II-NCZ))-1) )
                  CALL CONVL1(RES(IDX),NX,PSF(IXP),NPX,BUF(IXX))
                  IXP = IXP + NPX
400            CONTINUE
600         CONTINUE
            IX = IXX
            DO 700, K=1,NX
               BUF(IX) = F(IX) / BUF(IX)
               IX = IX + 1
700         CONTINUE
            IXX = IXX + NX
800      CONTINUE
1000  CONTINUE
C
C  second convolution for 3-dim image
      DO 2400, II=1,NZ
         DO 2000, I=1,NY
            DO 1200, K=1,NX
               DUM(K) = 0.0
1200        CONTINUE
            IXP = 1
            DO 1600, JJ=1,NPZ
               DO 1400, J=1,NPY
                  IDX = 1 + NX*(MAX(1,MIN(NY,J+I-NCY))-1 +
     +                  NY*(MAX(1,MIN(NZ,JJ+II-NCZ))-1) )
                  CALL CONVL1(BUF(IDX),NX,PSF(IXP),NPX,DUM)
                  IXP = IXP + NPX
1400           CONTINUE
1600        CONTINUE
            IX = IXX
            DO 1800, K=1,NX
               ADUM = ABS(1.-DUM(K))
               IF (ADUM.GT.RELC) RELC = ADUM
               RES(IX) = DUM(K) * RES(IX)
               IX = IX + 1
1800        CONTINUE
            IXX = IXX + NX
2000     CONTINUE
2400  CONTINUE
C
C  we're done, return
      DECNVL = RELC
      RETURN
C
C  check y-dimension
3000  IF (NY.EQ.1) GOTO 6000
C
C  first convolution for 2-dim image
      IXX = 1
      DO 4000, I=1,NY
         IX = IXX
         DO 3200, K=1,NX
            BUF(IX) = 0.0
            IX = IX + 1
3200     CONTINUE
         IXP = 1
         DO 3400, J=1,NPY
            IDX = 1 + NX*(MAX(1,MIN(NY,J+I-NCY))-1)
            CALL CONVL1(RES(IDX),NX,PSF(IXP),NPX,BUF(IXX))
            IXP = IXP + NPX
3400     CONTINUE
         IX = IXX
         DO 3600, K=1,NX
            BUF(IX) = F(IX) / BUF(IX)
            IX = IX + 1
3600     CONTINUE
         IXX = IXX + NX
4000  CONTINUE
C
C  second convolution for 2-dim image
      IXX = 1
      DO 5000, I=1,NY
         DO 4200, K=1,NX
            DUM(K) = 0.0
4200     CONTINUE
         IXP = 1
         DO 4400, J=1,NPY
            IDX = 1 + NX*(MAX(1,MIN(NY,J+I-NCY))-1)
            CALL CONVL1(BUF(IDX),NX,PSF(IXP),NPX,DUM)
            IXP = IXP + NPX
4400     CONTINUE
         IX = IXX
         DO 4600, K=1,NX
            ADUM = ABS(1.-DUM(K))
            IF (ADUM.GT.RELC) RELC = ADUM
            RES(IX) = DUM(K) * RES(IX)
            IX = IX + 1
4600     CONTINUE
         IXX = IXX + NX
5000  CONTINUE
C
C  we're done, return
      DECNVL = RELC
      RETURN
C
C  first convolution for 1-dim image
6000  DO 6200, K=1,NX
         BUF(K) = 0.0
6200  CONTINUE
      CALL CONVL1(RES,NX,PSF,NPX,BUF)
      DO 6400, K=1,NX
         BUF(K) = F(K) / BUF(K)
6400  CONTINUE
C
C  second convolution for 1-dim image
      DO 6600, K=1,NX
         DUM(K) = 0.0
6600  CONTINUE
C
      CALL CONVL1(BUF,NX,PSF,NPX,DUM)
      DO 6800, K=1,NX
         ADUM = ABS(1.-DUM(K))
         IF (ADUM.GT.RELC) RELC = ADUM
         RES(K) = DUM(K) * RES(K)
6800  CONTINUE
C
C  we're done, return
      DECNVL = RELC
      RETURN
C
      END

C @(#)colmean.for	19.1 (ESO-IPG) 02/25/03 14:22:15
      PROGRAM COLMEA
C+
C
C.IDENTIFICATION
C
C  program colmea                       version 1.0             900703
C
C  Otmar Stahl                           Landessternwarte Heidelberg
C
C  rowmean          inframe, list of columns
C
C  OUT_A                normalized output frame
C  INPUTI               list of columns
C
      IMPLICIT NONE
      INTEGER         NPIX(2),IAV,ISTAT,NAXIS,NUM(10)
      INTEGER         IMNO1,I
      INTEGER*8       IPNTR1
      INTEGER         MADRID,KUN,KNUL
C 
      CHARACTER*40    INFRAME
      CHARACTER       CUNIT*64,IDENT*72
C 
      DOUBLE PRECISION  START(2),STEP(2)
C                                       
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      CALL STSPRO('COLMEA')
C
C get input and map images
C
      CALL STKRDC('IN_A',1,1,40,IAV,INFRAME,KUN,KNUL,ISTAT)
      CALL STKRDI('INPUTI',1,10,IAV,NUM,KUN,KNUL,ISTAT)
      CALL STIGET(INFRAME,D_R4_FORMAT,F_IO_MODE,F_IMA_TYPE,
     &2,NAXIS,NPIX,START,STEP,IDENT,CUNIT,
     &IPNTR1,IMNO1,ISTAT)
C
      DO I = 1,10
         IF (NUM(I).GT.0) IAV = I
      ENDDO
C
C   compute mean
C
      CALL COLMEAN(MADRID(IPNTR1),NPIX,IAV,NUM,NPIX(1),NPIX(2))
C
      CALL STSEPI
      STOP
      END
C
C*************************************************************************
      SUBROUTINE COLMEAN(IN,NPIX,IAV,NUM,NPIX1,NPIX2)
C
C compute mean of adjacent columns
C
      IMPLICIT  NONE
      INTEGER         NPIX(2),IAV,NUM(10),I,J
      INTEGER         NUM1(10),NUM2(10),NPIX1,NPIX2
      REAL            IN(NPIX1,NPIX2)
C
C      TYPE *,NPIX(1),NPIX(2)
      DO I = 1,IAV
C        type *,num(i)
         NUM1(I) = NUM(I)-1
         NUM2(I) = NUM(I)+1
      ENDDO
C
      DO J = 1,NPIX(2)
         DO I = 1,IAV
C                 TYPE *,J,I,num(i),num1(i),num2(i)
            IN(NUM(I),J) = (IN(NUM1(I),J)+IN(NUM2(I),J))/2.
         ENDDO
      ENDDO
C
      RETURN
      END

C @(#)interpol.for	19.1 (ES0-DMD) 02/25/03 13:32:57
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C  @(#)interpol.for	5.1 (ESO-IPG) 4/5/93 15:58:36
C
C
C
C   INTERPOLATE
C
C   Interpolate an unevensampled time series using its correlation matrix
C           Reference:  ApJ 385, 404
C
C   Input:
C   OBS1T(NOBS1)               - observation  matrix (time)
C   OBS1D(NOBS1)               - observation  matrix (value)
C   OBS1V(NOBS1)               - observation  matrix (variance)
C   OBS2T(NOBS2)               - interpolated matrix (time)     input
C   ACFUNC(TLAG,PARM)          - autocorrelation function
C   PARM(12)                   - its parameters
C   COBS(NOBS1+1,NOBS1+1)        - work file
C   NU(NOBS1)                 - work file
C   CT(NOBS1)                 - work file
C   Output:
C   OBS2D(NOBS2)               - interpolated matrix (value)    output
C   OBS2V(NOBS2)               - interpolated matrix (variance) output
C
      SUBROUTINE INTERPOL(OBS1T,OBS1D,OBS1V,OBS2T,OBS2D,OBS2V,
     $    ACFUNC,PARM,NOBS1,NOBS2,MODE,AVERT,VART,COBS,NU,CT)
      INCLUDE 'MID_REL_INCL:TSA_DEF.INC'
      INTEGER            NOBS1,NOBS2,MODE
      DOUBLE PRECISION   OBS1T(NOBS1),OBS1D(NOBS1),OBS1V(NOBS1)
      DOUBLE PRECISION   OBS2T(NOBS2),OBS2D(NOBS2),OBS2V(NOBS2)
      DOUBLE PRECISION   ACFUNC,CRACOW                    ! EXTERNAL FUNCTIONS
      DOUBLE PRECISION   PARM(12)
      DOUBLE PRECISION   AVERT,VART
      DOUBLE PRECISION   COBS(NOBS1+1,NOBS1+1)
      DOUBLE PRECISION   NU(NOBS1)
      DOUBLE PRECISION   CT(NOBS1)
      EXTERNAL ACFUNC
      EXTERNAL CRACOW
C
      INTEGER            IOBS,JOBS,KOBS
      DOUBLE PRECISION   AVER1,VAR1,ACFCOR
      DOUBLE PRECISION   SAV,WORK,VAR,COUNT,TINY
      INCLUDE 'MID_REL_INCL:TSA_CONST.INC'
      DATA TINY/1D-25/
C
C   Determine global characteristics of input data
C
      AVERT=ZERO
      VART= ZERO
      COUNT=ZERO
      DO 1 IOBS=1,NOBS1
        IF (OBS1T(IOBS).GE.OBS2T(1).AND.
     $      OBS1T(IOBS).LE.OBS2T(NOBS2)) THEN
          IF (MODE.EQ.1) THEN
            AVERT=AVERT+OBS1D(IOBS)
            VART=VART+OBS1D(IOBS)*OBS1D(IOBS)
            COUNT=COUNT+ONE
          ELSEIF (MODE.EQ.2) THEN
            AVERT=AVERT+OBS1D(IOBS)*OBS1V(IOBS)
            VART=VART+OBS1D(IOBS)*OBS1D(IOBS)*OBS1V(IOBS)
            COUNT=COUNT+OBS1V(IOBS)
          ENDIF
        ENDIF
 1    CONTINUE
      AVER1=AVERT/COUNT
      VAR1=VART/COUNT-AVER1*AVER1
      ACFCOR=VAR1-ACFUNC(TINY,PARM)
C
C   Build correlation matrix of observations C
C
      DO 9 IOBS=1,NOBS1
        DO 8 JOBS=IOBS,NOBS1
          SAV=ABS(OBS1T(IOBS)-OBS1T(JOBS))+TINY
C          COBS(JOBS,IOBS)=ACFUNC(SAV,PARM)+ACFCOR
          COBS(JOBS,IOBS)=ACFUNC(SAV,PARM)
          IF (IOBS.EQ.JOBS) THEN
            COBS(IOBS,IOBS)=COBS(IOBS,IOBS)+OBS1V(IOBS)
          ENDIF
 8      CONTINUE
 9    CONTINUE
C
C   Get its triangle inverse square root C**(-1/2)
C
      IF ( CRACOW(COBS,NOBS1+1,NOBS1+1,0).EQ.ZERO) THEN
        CALL STETER(110,
     $    'INTERPOL: Correlation matrix of observations singular')
      ENDIF
C
C   Compute the interpolation vector NU = C**(-1/2)*C**(-1/2)*OBS1D
C
      DO 11 IOBS=1,NOBS1
        SAV=ZERO
        DO 12 JOBS=IOBS,NOBS1
          SAV=SAV+COBS(IOBS,JOBS)*OBS1D(JOBS)
 12     CONTINUE
        NU(IOBS)=SAV
 11   CONTINUE
      DO 14 IOBS=1,NOBS1
        SAV=ZERO
        DO 15 JOBS=IOBS,NOBS1
          SAV=SAV+COBS(IOBS,JOBS)*NU(JOBS)
 15     CONTINUE
        NU(IOBS)=SAV
 14   CONTINUE
C
C   Do actual interpolation OBS2D = NU**T*CT  OBS2V=VAR2-(C**(-1/2)*CT)**2
C
      DO 21 IOBS=1,NOBS2
        SAV=ZERO
        WORK=OBS2T(IOBS)
        IF (WORK.GE.OBS1T(1).AND.WORK.LE.OBS1T(NOBS1)) THEN
          DO 22 JOBS=1,NOBS1
            CT(JOBS)=ACFUNC(OBS1T(JOBS)-WORK,PARM)
            SAV=SAV+NU(JOBS)*CT(JOBS)
 22       CONTINUE
C          OBS2D(IOBS)=SAV
          OBS2D(IOBS)=-SAV
C
C   Determine global characteristics of all data
C
          IF (MODE.EQ.1) THEN
            AVERT=AVERT+OBS2D(IOBS)
            VART= VART+ OBS2D(IOBS)*OBS2D(IOBS)
            COUNT=COUNT+ONE
          ELSEIF (MODE.EQ.2) THEN
            VAR=ZERO
            DO 31 KOBS=1,NOBS1
              SAV=ZERO
              DO 32 JOBS=1,KOBS
                SAV=SAV+COBS(JOBS,KOBS)*CT(JOBS)
 32           CONTINUE
              VAR=VAR+SAV*SAV
 31         CONTINUE
C            OBS2V(IOBS)=VAR1-VAR
            OBS2V(IOBS)=ACFUNC(TINY,PARM)-VAR
            AVERT=AVERT+OBS2D(IOBS)*OBS2V(IOBS)
            VART= VART+ OBS2D(IOBS)*OBS2D(IOBS)*OBS2V(IOBS)
            COUNT=COUNT+OBS2V(IOBS)
          ENDIF
        ENDIF
 21   CONTINUE
      AVERT=AVERT/COUNT
      VART=VART/COUNT-AVERT*AVERT
      END

C @(#)truncy.for	19.1 (ES0-DMD) 02/25/03 13:30:49
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE TRUNCY(A,NPIX,TRUNC)
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.AUTHOR:  K. Banse                                                             
C.VERSION: 830601  KB  Creation                                                 
C----------------------------------------------------------------------         
      IMPLICIT  NONE
      REAL      A(1)
      INTEGER   NPIX(2) 
      REAL      TRUNC(2)
C
      REAL      TMIN
      REAL      TMAX
      INTEGER   N
C                                                                               
C *** move down through frame, since we should be positioned at the end...!     
C                                                                               
      TMIN   = TRUNC(1)                                                         
      TMAX   = TRUNC(2)                                                         
C                                                                               
      DO 10 N = NPIX(1)*NPIX(2),1,-1                                            
         IF (A(N).LT.TMIN) THEN                                                 
            A(N)   = TMIN                                                       
         ELSE                                                                   
           IF (A(N).GT.TMAX) A(N)   = TMAX                                      
         END IF                                                                 
   10 CONTINUE                                                                  
C                                                                               
      RETURN                                                                    
      END

C @(#)arthmz.for	19.3 (ESO-DMD) 05/20/03 09:41:53 
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE ARTHMZ(ZDEFA,ZRESFR,ZLINE)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine ARTHMZ			951011
C  K. Banse            		      	ESO - Garching
C
C.KEYWORDS
C  arithmetic operations, bulk data frames
C
C.PURPOSE
C  evaluate an arithmetic expression involving frames, constants and functions
C  and store the result into a data frame or key OUTPUTR(1), 
C  if used as pocket calculator
C
C.ALGORITHM
C  "clean" the expression by replacing all frame names by F, all constants by C
C  and all functions by P, convert it to polish (postfix) notation and evaluate it piecewise
C  establish special condition handler for arithmetic traps...
C  copy all descriptors of first frame operand to result frame.
C
C.INPUT/OUTPUT
C  call as ARTHMZ(ZDEFA,ZRESFR,ZLINE)
C  
C  input par:
C  ZDEFA:	char.		2 char. default string
C				(1) Y or N for result frame or not
C				(2) P, I, X for COMPUTE/PIXEL, /IMAGE, /PLANE
C  ZRESFR:	char.		name of result frame
C  ZLINE:	char.		char.string with arithmetic expression
C	
C.VERSIONS
C 030519	last modif
C  
C-------------------------------------------------------------------------
C
      IMPLICIT NONE
C
C  important parameter: WORKLM = 45
C
      CHARACTER*(*)  ZRESFR,ZLINE
      CHARACTER      ZDEFA*2
      CHARACTER      INFRAM(23)*80                   !MAXFRAM = WORKLM/2 + 1
      CHARACTER      ATOM(23)*80,OPER(23)*5          !size = MAXFRAM
      CHARACTER      RESFRA*80,DSCFRA*80
      CHARACTER      CUNIT*80,IDENT*72
      CHARACTER      WORK*50,WORK1*50,OUTPU*80,WORKY*1
      CHARACTER      ERROR3*50,ERROR4*30,ERROR5*30
C      
      REAL         CONST,CUTS(4)
      REAL         DATTA(23),RDUM(1)                 !size = MAXFRAM
      REAL         USRNUL
C 
      DOUBLE PRECISION STEP(6),START(6),STEPA(6),STARTA(6)
      DOUBLE PRECISION EPS,DIF,DDUM(1)
C      
      INTEGER      NULCNT
      INTEGER      LATOM(23),FELEM(23),WORKLM        !size = MAXFRAM
      INTEGER      APNTRS(48)                        !size = WORKLM + 3
      INTEGER*8    PNTR(27)                          !size = MAXFRAM + 4
      INTEGER*8    RPNTR
      INTEGER      PIDX(23),PPP(23),IMNO(23)         !size = MAXFRAM
      INTEGER      FRACNT,NPIX(6),NAXISA,NPIXA(6)
      INTEGER      COUNT,IAV,K,M,LL
      INTEGER      N,NAXIS,TOTAL
      INTEGER      SIZE,INFO(5),DATFMT
      INTEGER      RFELEM,OPCNT
      INTEGER      MAPSIZ,STAT
      INTEGER      TRSIZE,NNULL,UNIT(1),INPU(1)
      INTEGER      RIMNO,WIMNO,MADRID(1)
      INTEGER      UPDA,DSCORG,OPTFLG(2)
      INTEGER      CLONY,EC,EL,ED
C 
      INCLUDE  'MID_INCLUDE:ST_DEF.INC'
C      
      COMMON      /NULCOM/ NULCNT,USRNUL
      COMMON      /IPOOL/  FRACNT
      COMMON      /VMR/ MADRID
C 
      SAVE
C 
      DATA      WORKLM      /45/
      DATA      CUNIT       /' '/,  IDENT       /' '/
      DATA      ERROR3
     +          /'wrong syntax in arithmetic expression ...'/
      DATA      ERROR4      /'too many operands...'/
      DATA      ERROR5      /'invalid plane no...'/
C      
      INCLUDE  'MID_INCLUDE:ST_DAT.INC'
C      
C  init variables
      CUTS(1) = 0.
      CUTS(2) = 0.
      CUTS(3) = + 999999.9
      CUTS(4) = - 999999.9
      RIMNO = -1
      RFELEM = 1
      OPTFLG(1) = 0
      CLONY = 1                               !default = try to clone
C 
      DO 120, N=1,6
         NPIX(N) = 1
         START(N) = 0.D0
         STEP(N) = 1.D0
120   CONTINUE
C 
      DO 130, N=1,23
         DATTA(N) = 0.0
         FELEM(N) = 1
130   CONTINUE
      DO 140, N=1,48
         APNTRS(N) = -1
140   CONTINUE
C 
C  reduce expression... (clean up + fill ATOM, LATOM)
200   SIZE = 80                                !length of ATOM(i) strings
      CALL EXPCLE(ZLINE,WORK,SIZE,COUNT,ATOM,LATOM)      
      IF (COUNT.EQ.-1) THEN
         CALL STETER(1,ERROR3)     
      ELSE IF (COUNT.EQ.-2) THEN
         CALL STETER(5,'arithmetic expression too long...')
C      
C  take care of operand without operation   (extend F or C to F+C or C+C)
      ELSE IF (COUNT.EQ.1) THEN    
         ATOM(2) = '0.'    
         LATOM(2) = 2
         WORK(2:3) = '+C'
         COUNT = 2
      ENDIF
C      
C  convert cleaned algebraic expression to polish postfix
      ZLINE(1:) = ' '
      CALL EXPPOL(WORK,ZLINE,STAT)                 
      IF (STAT.NE.0) CALL STETER(2,ERROR3)     
      LL = INDEX(ZLINE,' ') - 1
      IF (LL.GT.WORKLM) 
     +   CALL STETER(8,'Too many operands - reduce expression...')
C      
C  fill pointers for atoms
      DATFMT = D_R4_FORMAT                   !that's what we use currently
      K = 1
      DO 220, N=1,LL
         WORKY = ZLINE(N:N)
         IF ( (WORKY.EQ.'C').OR. (WORKY.EQ.'F').OR.
     +        (WORKY.EQ.'Q').OR. (WORKY.EQ.'P') ) THEN
            APNTRS(N) = K
            K = K + 1
         ENDIF
220   CONTINUE
C 
C  check for descriptor-origin-frame (other than 1. frame)
C  but be careful of frame[.. , ..:.. , ..] syntax
C 
      DSCFRA(1:) = ' '
      LL = 0
      K = INDEX(ZRESFR,']')
      IF (K.GT.1) THEN                          !abc[...],descframe possible
         K = K + 1
         IF (ZRESFR(K:K).EQ.',') LL = K
      ELSE
         LL = INDEX(ZRESFR,',')                 !abc,descframe possible
      ENDIF
      IF (LL.GT.1) THEN
         OUTPU(1:) = ZRESFR(LL+1:)
         CALL CLNFRA(OUTPU,DSCFRA,0)
         ZRESFR(LL:) = ' '
      ENDIF
C 
C  if COMPUTE/PLANE we have to work more
      IF (ZDEFA(2:2).EQ.'X') THEN
         M = INDEX(ZRESFR,'.P')                 !we know it's there...
         CALL GENCNV(ZRESFR(M+2:),1,1,INPU,RDUM,DDUM,STAT)
         IF (STAT.LT.1) CALL STETER(24,ERROR5)
         RFELEM = INPU(1)
         IF (RFELEM.LT.1) CALL STETER(24,ERROR5)
         ZRESFR(M:) = ' '
      ENDIF
      CALL CLNFRA(ZRESFR,RESFRA,0)
C      
C  find frames + constants
      LL = 0                        !counter in ATOM
      K = 0
C 
      DO 250, N=1,WORKLM
         WORKY = WORK(N:N)
         IF (WORKY.EQ.' ') GOTO 300
C 
         IF (WORKY.EQ.'F') THEN
            K = K + 1                   !not more than 23 frames possible
            LL = LL + 1
C 
            IF (ZDEFA(2:2).EQ.'X') THEN
               M = INDEX(ATOM(LL),'.P')
               IF (M.LT.2) M = INDEX(ATOM(LL),'.p')
               IF (M.LT.2) THEN                       !check, if it's p#
                  IF ((ATOM(LL)(1:1).EQ.'P').OR.
     +                (ATOM(LL)(1:1).EQ.'p')) THEN
                     CALL GENCNV(ATOM(LL)(2:),1,1,INPU,RDUM,DDUM,STAT)
                     IF (STAT.EQ.1) THEN
                        FELEM(K) = INPU(1)
                        INFRAM(K) = RESFRA
                        GOTO 240
                     ENDIF
                  ENDIF
               ELSE                                   !it's frame.p#
                  CALL GENCNV(ATOM(LL)(M+2:),1,1,INPU,RDUM,DDUM,STAT)
                  IF (STAT.LT.1) CALL STETER(24,ERROR5)
                  FELEM(K) = INPU(1)
                  ATOM(LL)(M:) = ' '
               ENDIF
            ENDIF
C 
            CALL CLNFRA(ATOM(LL),INFRAM(K),0)
240         PIDX(LL) = K                !we'll use PIDX instead of ATOM later
C      
         ELSE IF (WORKY.EQ.'C') THEN
            LL = LL + 1                 !we'll use DATTA instead of ATOM later
            CALL UPCAS(ATOM(LL),ATOM(LL))
            STAT = INDEX(ATOM(LL),'D')
            IF (STAT.GT.1) THEN
               DATFMT = D_R8_FORMAT     !explicit double constant...
               CALL GENCNV(ATOM(LL),4,1,INPU,RDUM,DDUM,STAT)
               DATTA(LL) = SNGL(DDUM(1))
            ELSE
               CALL GENCNV(ATOM(LL),2,1,INPU,RDUM,DDUM,STAT)
               DATTA(LL) = RDUM(1)
            ENDIF
            IF (STAT.LE.0) CALL STETER
     +         (10,'conversion error of ASCII -> number ...')
C
         ELSE IF ((WORKY.EQ.'P').OR.(WORKY.EQ.'Q')) THEN
            LL = LL + 1
         ENDIF
250   CONTINUE
C      
C  extract 1-arg, 2-arg operations and save them (with offsets)
300   WORK1(1:) = ZLINE(1:)
      LL = (WORKLM+1) / 2
      DO 350, N=1,999
         CALL EXPRDC(WORK1,WORK,OPER(N),PPP(N))
         IF (PPP(N).LT.1) CALL STETER(1,ERROR3)
         IF (WORK(2:2).NE.' ') THEN
            WORK1 = WORK
         ELSE
            IF (N.GT.LL) CALL STETER
     +         (11,'too many operations in expression - split it up...')
            OPCNT = N 
            GOTO 1000
         ENDIF
350   CONTINUE
C 
C  compute/plane needs special attention
1000  IF (ZDEFA(2:2).EQ.'X') THEN               !we must have a result frame
         CALL STFOPN(RESFRA,D_R4_FORMAT,0,F_IMA_TYPE,RIMNO,STAT)
         CALL STDRDI(RIMNO,'NAXIS',1,1,IAV,NAXIS,UNIT,NNULL,STAT)
         IF (NAXIS.LT.3) 
     +      CALL STETER(25,'invalid 2-dim result frame...')
         CALL STDRDI(RIMNO,'NPIX',1,3,IAV,NPIX,UNIT,NNULL,STAT)
         IF (RFELEM.GT.NPIX(3)) CALL STETER(24,ERROR5)
         SIZE = NPIX(1)*NPIX(2)
         RFELEM = (RFELEM-1)*SIZE+ 1               !now first elem
         NAXIS = 2
         CALL STDRDR(RIMNO,'LHCUTS',1,4,IAV,CUTS,UNIT,NNULL,STAT)
      ENDIF
C      
C  if no frames involved ... do it right now + skip the loop
C      
      IF (K.LE.0) THEN
         CALL COMPUA(PNTR,OPER,PPP,OPCNT,APNTRS,ATOM,DATTA,PIDX,
     +               COUNT,NPIX(1),RPNTR,CUTS(3))
         CONST = CUTS(3)
         IF (ZDEFA(1:1).EQ.'N') THEN    !put resulting constant into OUTPUTR(1)
            CALL STKWRR('OUTPUTR',CONST,1,1,UNIT,STAT)
            WRITE(OUTPU,10000) CONST
            CALL STTPUT(OUTPU,STAT)
         ELSE
            IF (ZDEFA(2:2).NE.'X') THEN 
               CALL STIGET(RESFRA,D_R4_FORMAT,F_IO_MODE,F_IMA_TYPE,
     +                     6,NAXIS,NPIX,START,STEP,IDENT,
     +                     CUNIT,RPNTR,RIMNO,STAT)
               CALL STDRDR(RIMNO,'LHCUTS',1,4,IAV,CUTS,UNIT,NNULL,STAT)
               SIZE = 1
               DO 1100, N=1,NAXIS
                  SIZE = SIZE * NPIX(N)
1100           CONTINUE
               CALL OPFC('FC=',0.0,CONST,MADRID(RPNTR),SIZE,
     +                   USRNUL,NNN)                  !copy constant to frame
               CUTS(4) = CONST
            ELSE
               CALL STFCRE('WORK',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +                     SIZE,WIMNO,STAT)
               CALL STFMAP(WIMNO,F_X_MODE,1,SIZE,IAV,RPNTR,STAT)
               CALL OPFC('FC=',0.0,CONST,MADRID(RPNTR),SIZE,
     +                   USRNUL,NNN)                  !copy constant to frame
               CALL STFPUT(RIMNO,RFELEM,SIZE,MADRID(RPNTR),STAT)
               IF (CONST.LT.CUTS(3)) THEN
                  CUTS(3) = CONST
               ELSEIF (CONST.GT.CUTS(4)) THEN
                  CUTS(4) = CONST
               ELSE
                  GOTO 9000
               ENDIF
            ENDIF
            CALL STDWRR(RIMNO,'LHCUTS',CUTS,1,4,UNIT,STAT)
            CALL DSCUPT(RIMNO,RIMNO,' ',STAT)
         ENDIF
         GOTO 9000
      ENDIF
C      
C  at least one frame involved ...
C      
      FRACNT = K
      CALL ISSUBF(RESFRA,K)
      IF (K.GT.0) THEN
         UPDA = 1
      ELSE 
         UPDA = 0
      ENDIF
C 
      IF (DSCFRA(1:1).NE.' ') THEN
         DSCORG = 0
      ELSE
         DSCORG = 1
      ENDIF
C 
C  loop over all input frames to check, if we update result frame
C 
      DO 1250, N=1,FRACNT
         CALL STFINF(INFRAM(N),2,INFO,STAT)
         IF (INFO(2).EQ.D_R8_FORMAT) DATFMT = D_R8_FORMAT
         CALL STFOPN(INFRAM(N),D_R4_FORMAT,0,F_IMA_TYPE,IMNO(N),STAT)
C 
         IF (ZDEFA(2:2).NE.'X')THEN
            IF (UPDA.EQ.0) 
     +         CALL GENEQF(INFRAM(N),RESFRA,UPDA)   !input_frame = res_frame?
            IF (DSCORG.EQ.0)  THEN
               CALL GENEQF(INFRAM(N),DSCFRA,LL)
               IF (LL.NE.0) DSCORG = N
            ENDIF
         ENDIF
1250  CONTINUE
C 
      IF (ZDEFA(2:2).EQ.'X')THEN
         UPDA = 1
         DSCORG = 0
         CLONY = 0
      ELSE 
         IF (DSCORG.EQ.0) DSCORG = 1         !if not found take 1. frame
         M = INDEX(INFRAM(DSCORG),'@')
         IF (M.GT.0) THEN
            CLONY = 0
         ELSE
            M = INDEX(INFRAM(DSCORG),'[')
            IF (M.GT.0) CLONY = 0
         ENDIF
      ENDIF
      CALL STKRDI('AUX_MODE',10,1,LL,M,UNIT,NNULL,STAT)
      IF (M.EQ.123) CLONY = 0               !no cloning with old descr. format
C 
C  we use R*4 data currently
      IF (DATFMT.EQ.D_R8_FORMAT) THEN
         CUNIT(1:) = 
     +   'Warning: double operand found - result will be single! '
         CALL STTPUT(CUNIT,STAT)
         DATFMT = D_R4_FORMAT
      ENDIF
C 
C  if no frame is equal to result frame, we create it
C
      IF (UPDA.EQ.0) THEN                !get standard descr. from DSCORG frame
         CALL STDRDI(IMNO(DSCORG),
     +               'NAXIS',1,1,IAV,NAXIS,UNIT,NNULL,STAT)
         CALL STDRDI(IMNO(DSCORG),
     +               'NPIX',1,NAXIS,IAV,NPIX,UNIT,NNULL,STAT)
         CALL STDRDD(IMNO(DSCORG),
     +               'START',1,NAXIS,IAV,START,UNIT,NNULL,STAT)
         CALL STDRDD(IMNO(DSCORG),
     +               'STEP',1,NAXIS,IAV,STEP,UNIT,NNULL,STAT)
         CALL STDRDC(IMNO(DSCORG),
     +               'IDENT',1,1,72,IAV,IDENT,UNIT,NNULL,STAT)
         M = (NAXIS+1) * 16
         CALL STDRDC(IMNO(DSCORG),
     +               'CUNIT',1,1,M,IAV,CUNIT,UNIT,NNULL,STAT)
C      
         SIZE = 1
         DO 1300, N=1,NAXIS
            SIZE = SIZE*NPIX(N)
1300     CONTINUE
C 
C  try to clone descriptors of input frame
C  only possible, if same data type
C 
         IF (CLONY.EQ.1) THEN
            OPTFLG(1) = 1
            OPTFLG(2) = IMNO(DSCORG)
            CALL STECNT('GET',EC,EL,ED)            !disable error abort
            CALL STECNT('PUT',1,0,0)
            CALL STFXCR(RESFRA,DATFMT,F_O_MODE,F_IMA_TYPE,
     +                  SIZE,OPTFLG,RIMNO,STAT)
            CALL STECNT('PUT',EC,EL,ED)
         ELSE                                !it's an extracted frmae
            STAT = 40                        !force fresh descriptors
         ENDIF
C
         IF (STAT.GT.0) THEN     !could NOT clone descriptors...
            CLONY = 0
            CALL STFCRE(RESFRA,DATFMT,F_O_MODE,F_IMA_TYPE,
     +                  SIZE,RIMNO,STAT)
            CALL STDWRI(RIMNO,'NAXIS',NAXIS,1,1,UNIT,STAT)
            CALL STDWRI(RIMNO,'NPIX',NPIX,1,NAXIS,UNIT,STAT)
            CALL STDWRD(RIMNO,'START',START,1,NAXIS,UNIT,STAT)
            CALL STDWRD(RIMNO,'STEP',STEP,1,NAXIS,UNIT,STAT)
            CALL STDWRC(RIMNO,'IDENT',1,IDENT,1,72,UNIT,STAT)
            CALL STDWRC(RIMNO,'CUNIT',1,CUNIT,1,M,UNIT,STAT)
         ENDIF
C 
C  else we just open the frame
C 
      ELSE
         IF (ZDEFA(2:2).NE.'X') THEN
            CALL STFOPN(RESFRA,DATFMT,0,F_IMA_TYPE,RIMNO,STAT)
            CALL STDRDI(RIMNO,'NAXIS',1,1,IAV,NAXIS,UNIT,NNULL,STAT)
            CALL STDRDI(RIMNO,'NPIX',1,NAXIS,IAV,NPIX,UNIT,NNULL,STAT)
            SIZE = 1
            DO 1330, N=1,NAXIS
               SIZE = SIZE*NPIX(N)
1330        CONTINUE
         ENDIF
         CALL STFINF(RESFRA,2,INFO,STAT)
         IF ( (INFO(2).NE.D_R8_FORMAT) .AND.
     +        (INFO(2).NE.D_R4_FORMAT) ) THEN
            CUNIT(1:) =
     +      'Warning: Result frame is not real - '//
     +      'you may get truncation errors... '
            CALL STTPUT(CUNIT,STAT)
         ENDIF
         CALL STDRDD(RIMNO,'START',1,NAXIS,IAV,START,UNIT,NNULL,STAT)
         CALL STDRDD(RIMNO,'STEP',1,NAXIS,IAV,STEP,UNIT,NNULL,STAT)
         DSCORG = 0
      ENDIF
C 
C  here we determine, if we have to use windows or take the complete frames
C  also COMPUTE/PIX command or if just one frame ...
C      
      IF (ZDEFA(2:2).EQ.'X') THEN
         DO 1600, N=1,FRACNT
            CALL STDRDI(IMNO(N),
     +                  'NAXIS',1,1,IAV,NAXISA,UNIT,NNULL,STAT)
            CALL STDRDI(IMNO(N),
     +                  'NPIX',1,NAXISA,IAV,NPIXA,UNIT,NNULL,STAT)
            IF (FELEM(N).GT.1) THEN
               IF ((NAXISA.LT.3) .OR. (NPIXA(3).LT.FELEM(N)))
     +            CALL STETER(27,ERROR5)
               FELEM(N) = (FELEM(N)-1)*SIZE + 1
            ELSE IF (NAXISA.LT.2)THEN
               CALL STETER(26,'1-dim input frame not supported...')
            ENDIF
            DO 1500, K=1,NAXIS
               IF (NPIX(K).NE.NPIXA(K)) 
     +            CALL STETER(26,'non-matching NPIX...')
1500        CONTINUE
1600     CONTINUE
C 
      ELSE IF (ZDEFA(2:2).EQ.'P') THEN
         DO 1800, N=1,FRACNT
            IF (N.NE.DSCORG) THEN
               CALL STDRDI(IMNO(N),
     +                     'NAXIS',1,1,IAV,NAXISA,UNIT,NNULL,STAT)
               IF (NAXISA.NE.NAXIS)
     +            CALL STETER(26,'non-matching NAXIS...')
               CALL STDRDI(IMNO(N),
     +                     'NPIX',1,NAXISA,IAV,NPIXA,UNIT,NNULL,STAT)
               DO 1700, K=1,NAXIS
                  IF (NPIX(K).NE.NPIXA(K)) 
     +               CALL STETER(26,'non-matching NPIX...')
1700           CONTINUE
            ENDIF
1800     CONTINUE
C      
      ELSE
         DO 2000, N=1,FRACNT
            IF (N.NE.DSCORG) THEN
               CALL STDRDI(IMNO(N),
     +                     'NPIX',1,NAXIS,IAV,NPIXA,UNIT,NNULL,STAT)
               CALL STDRDD(IMNO(N),
     +                     'START',1,NAXIS,IAV,STARTA,UNIT,NNULL,STAT)
               CALL STDRDD(IMNO(N),
     +                     'STEP',1,NAXIS,IAV,STEPA,UNIT,NNULL,STAT)
               DO 1900, K=1,NAXIS
                  IF (NPIX(K).NE.NPIXA(K)) GOTO 3000
                  EPS = 0.0001 * ABS(STEP(K))              !0.01 % of step
                  DIF = ABS(STEP(K) - STEPA(K))
                  IF (DIF.GT.EPS) GOTO 3000
                  EPS = 0.01 * ABS(STEP(K))                !1.0 % of step
                  DIF = ABS(START(K) - STARTA(K))
                  IF (DIF.GT.EPS) GOTO 3000
1900           CONTINUE
            ENDIF
2000     CONTINUE
         GOTO 5000
C      
C  frames are not of same size or unaligned
C  so we only work on overlapping area (done in COMPUB)
C  but open DESCR originator frame again, so we can use DSCUPT after
C  
3000     CALL COMPUB(DATFMT,ZLINE,ATOM,APNTRS,UPDA,RESFRA,CUTS(3))
         CALL STFOPN(RESFRA,DATFMT,0,F_IMA_TYPE,RIMNO,STAT)
         IF (DSCORG.NE.0) THEN
            CALL STFOPN(INFRAM(DSCORG),
     +                  DATFMT,0,F_IMA_TYPE,IMNO(DSCORG),STAT)
            CALL DSCUPT(IMNO(DSCORG),RIMNO,' ',STAT)
         ELSE
            CALL DSCUPT(RIMNO,RIMNO,' ',STAT)
         ENDIF
         CALL STDWRR(RIMNO,'LHCUTS',CUTS,1,4,UNIT,STAT)
         GOTO 9000
      ENDIF
C      
C  here we can work in pixel space
C      
5000  CALL STKRDI('MONITPAR',20,1,LL,MAPSIZ,UNIT,NNULL,STAT)
      IF (MAPSIZ.LT.100) MAPSIZ = 100               !default chunk size
      MAPSIZ = MAPSIZ*MAPSIZ
      IF (FRACNT.GT.3) MAPSIZ = MAPSIZ/2
      IF (MAPSIZ.GT.SIZE) THEN
         MAPSIZ = SIZE
         TOTAL = 1
      ELSE
         TOTAL = SIZE / MAPSIZ
         IF ( (TOTAL*MAPSIZ) .LT. SIZE) TOTAL = TOTAL + 1
      ENDIF
C 
C  map virtual memory for input files, 4 working buffers + result frame
      K = (FRACNT + 5) * MAPSIZ
      CALL STFCRE('WORK',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +            K,WIMNO,STAT)
      CALL STFMAP(WIMNO,F_X_MODE,1,K,IAV,PNTR(1),STAT)
      IF (FRACNT.GT.1) THEN
         DO 5200, N=2,FRACNT                  !no more pointers,
            PNTR(N) = PNTR(N-1) + MAPSIZ     !but indices of MADRID ...
5200     CONTINUE
      ENDIF
C 
      RPNTR = PNTR(FRACNT) + MAPSIZ
C 
C  get pointers for 4 working chunks
      DO 5250, N=1,4
         PNTR(N+23) = RPNTR + (N*MAPSIZ)
5250  CONTINUE
C      
C  loop over all chunks
C
      DO 5800, N=1,TOTAL
         DO 5600, K=1,FRACNT
            CALL STFGET(IMNO(K),FELEM(K),MAPSIZ,TRSIZE,
     +                  MADRID(PNTR(K)),STAT)
            FELEM(K) = FELEM(K) + TRSIZE
5600     CONTINUE
C      
         CALL COMPUA(PNTR,OPER,PPP,OPCNT,APNTRS,ATOM,DATTA,PIDX,
     +               COUNT,TRSIZE,RPNTR,CUTS(3))
C      
         CALL STFPUT(RIMNO,RFELEM,TRSIZE,MADRID(RPNTR),STAT)
         RFELEM = RFELEM + TRSIZE
5800  CONTINUE
C  
C  ***
C  we're done - set dynamic range of result frame
C  ***
C      
C  take care of descriptors
      IF (DSCORG.NE.0) THEN
         IF (CLONY.EQ.1) THEN
            CALL DSCUPT(RIMNO,RIMNO,' ',STAT)
         ELSE
            CALL DSCUPT(IMNO(DSCORG),RIMNO,' ',STAT)
         ENDIF
      ELSE IF (UPDA.EQ.1) THEN                       !just update history
         CALL DSCUPT(RIMNO,RIMNO,' ',STAT)
      ENDIF
      CALL STDWRR(RIMNO,'LHCUTS',CUTS,1,4,UNIT,STAT)
C      
C  That's it folks...
9000  RETURN
C
C  formats...
10000 FORMAT(G15.7)
      END

      SUBROUTINE COMPUA(PNTR,OPER,PPP,OPCNT,APNTRS,ATOM,DATTA,PIDX,
     +                     COUNT,MAPSIZ,RPNTR,CUTS)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine COMPUA			951011
C  K. Banse				ESO - Garching
C
C.KEYWORDS
C  arithmetic operations
C
C.PURPOSE
C  evaluate the arithmetic expression specified in the main module
C  for the currently mapped section of the complete data space
C
C.ALGORITHM
C  straight forward but rather tricky - we have to juggle pointers like hell...
C
C.INPUT/OUTPUT
C  call as COMPUA(PNTR,OPER,PPP,OPCNT,APNTRS,ATOM,DATTA,PIDX,
C               COUNT,MAPSIZ,RPNTR,CUTS)
C  input par:
C  PNTR:	I*8 array	data pointers
C  OPER:	char. array	holds the individual operations
C  				which make up the complete expression
C  PPP:		I*4 array	points to the first atom to be used 
C  				with OPER(n)
C  OPCNT:	I*4		size of OPER + PPP
C  APNTRS:	I*4 array	initial array of pointers to ATOM
C  ATOM:	char. array 	holds names of frames, names of functions
C  				and constants in ASCII
C  				only needed for function names...
C  DATTA:	R*4 array	holds constants already as reals
C  PIDX:	I*4 array	array of pointers to frames
C  COUNT:	I*4		total no. of operands in original expression
C  MAPSIZ:	I*4		size of mapped chunks
C  RPNTR:	I*8		pointer to result frame
C  
C  output par:
C  CUTS:	R*4 array	cut values for result frame
C      
C.VERSIONS
C  see SCCS
C      
C-------------------------------------------------------------------------
C      
      IMPLICIT NONE
C
      CHARACTER      ATOM(23)*80,OPER(23)*5
      CHARACTER      BTOM(23)*80
      CHARACTER      OPERA*5
C      
      REAL         DATTA(*)
      REAL         CUTS(2),CNSTAB(2),CONST
      REAL         BDATA(23),FMIN,FMAX,USRNUL
C      
      INTEGER      NULCNT,NNN
      INTEGER      PPP(*),OPCNT,APNTRS(*),PIDX(*),COUNT
      INTEGER      BPNTRS(48),BPIDX(23)
      INTEGER*8    RPNTR,OUTPTR,KPNTR,LPNTR,PNTR(27)
      INTEGER      MAPSIZ,FRACNT
      INTEGER      N,IDUMMY
      INTEGER      NBRA,P1,P2,P3,PP
      INTEGER      OPINDX,NOUT
      INTEGER      MADRID(1)
C      
      COMMON      /NULCOM/ NULCNT,USRNUL
      COMMON      /IPOOL/  FRACNT
C 
      COMMON      /VMR/ MADRID
C      
C  first initialize pointers for ATOM
      OPINDX = 0
      DO 100 N=1,COUNT
         BTOM(N) = ATOM(N)
         BDATA(N) = DATTA(N)
         BPIDX(N) = PIDX(N)
100   CONTINUE
      FMIN = CUTS(1)
      FMAX = CUTS(2)
C 
      DO 150, N=1,48
         BPNTRS(N) = APNTRS(N)
150   CONTINUE
      IDUMMY = 0                        !init DUMMY counter
C      
C  extract basic OPERAs
1000  OPINDX = OPINDX + 1
      OPERA = OPER(OPINDX)
      PP = PPP(OPINDX)
C      
C  extract operands
      P1 = BPNTRS(PP)
      P2 = BPNTRS(PP+1)
      P3 = BPNTRS(PP+2)
C      
C  find out what kind of OPERA to do
      IF (INDEX(OPERA,'C').GT.0) THEN
         IF (INDEX(OPERA,'F').GT.0) GOTO 1600            !also F involved...?
      ELSE
         IF (OPERA(1:1).EQ.'P') THEN
            GOTO 1600                              !handle PF)
         ELSE
            GOTO 2000                              !handle FF or QFF)
         ENDIF
      ENDIF
C      
C  ***
C  only constants involved, do it right now
C  ***
C      
      IF (OPERA(1:2).EQ.'CC') THEN
         CALL OPCC(OPERA,BDATA(P1),BDATA(P2),CONST)
      ELSE
         IF (OPERA(1:1).EQ.'P') THEN                  !1-arg functions
            CALL FUN1C(BTOM(P1)(1:5),BDATA(P2),CONST)
         ELSE                                          !2-arg functions
            CNSTAB(1) = BDATA(P2)
            CNSTAB(2) = BDATA(P3)
            CALL FUN2CC(BTOM(P1)(1:5),CNSTAB,CONST)
         ENDIF
      ENDIF
C
C  put resulting constant back into relevant BTOM + goto loopend
      IF (OPCNT.NE.OPINDX) THEN
         BDATA(P1) = CONST
         GOTO 5000
      ELSE                        !we're done already...
         CUTS(1) = CONST
         GOTO 8000
      ENDIF
C
C  ***
C  one operand is a file
C  ***
C      
1600  IF (OPERA(1:2).EQ.'FC') THEN
         KPNTR = PNTR(BPIDX(P1))
         CONST = BDATA(P2)
         NBRA = 1                                    !no function
      ELSE IF (OPERA(1:2).EQ.'CF') THEN
         KPNTR = PNTR(BPIDX(P2))
         CONST = BDATA(P1)
         NBRA = 1                                    !no function
      ELSE IF (OPERA(1:2).EQ.'PF') THEN
         KPNTR = PNTR(BPIDX(P2))
         NBRA = 2                                    !1-arg function
      ELSE
         NBRA = 3                                    !2-arg function
         IF (OPERA(1:2).NE.'QC') THEN
            KPNTR = PNTR(BPIDX(P2))
            CONST = BDATA(P3)
         ELSE
            KPNTR = PNTR(BPIDX(P3))
            CONST = BDATA(P2)
         ENDIF
      ENDIF
C      
C determine where result should go to
C      
      IF (OPCNT.EQ.OPINDX) THEN            !last OPERA ?
         OUTPTR = RPNTR
      ELSE
         DO 1700, N=24,27                  !24,25,26,27 are the dummy pointers
            IF (KPNTR.EQ.PNTR(N)) THEN     !operand is one of the dummy frames
               OUTPTR = PNTR(N)
               NOUT = N
               GOTO 1900
            ENDIF
1700     CONTINUE
C                                    !we have to use up one of the dummy frames
         IF (IDUMMY.LE.3) THEN
            IDUMMY = IDUMMY + 1
            NOUT = 23 + IDUMMY            !keep no. of dummy area used 
            OUTPTR = PNTR(NOUT)           !for output
         ELSE
            CALL STETER(99,'error in internal logic ...!')
         ENDIF
      ENDIF
C
C  now do the actual OPERA
1900  IF (NBRA.EQ.1) THEN
         CALL OPFC(OPERA,MADRID(KPNTR),CONST,
     +                 MADRID(OUTPTR),MAPSIZ,USRNUL,NNN)
      ELSE IF (NBRA.EQ.2) THEN
         CALL FUN1F(BTOM(P1)(1:5),MADRID(KPNTR),
     +                  MADRID(OUTPTR),MAPSIZ,USRNUL,NNN)
      ELSE
         CALL FUN2FC(BTOM(P1)(1:5),MADRID(KPNTR),CONST,
     +                   MADRID(OUTPTR),MAPSIZ,USRNUL,NNN)
      ENDIF
C      
      NULCNT = NULCNT + NNN                 !update null count
      IF (OPCNT.NE.OPINDX) THEN
         GOTO 4400                              !goto loopend
      ELSE
         GOTO 7700
      ENDIF
C
C  ***
C  both operands are files 
C  ***
C      
2000  IF (OPERA(1:1).NE.'Q') THEN
         KPNTR = PNTR(BPIDX(P1))
         LPNTR = PNTR(BPIDX(P2))
      ELSE
         KPNTR = PNTR(BPIDX(P2))
         LPNTR = PNTR(BPIDX(P3))
      ENDIF
C      
C determine where result should go to
C      
      IF (OPCNT.EQ.OPINDX) THEN            !last OPERA ?
         OUTPTR = RPNTR
      ELSE
         DO 2100, N=24,27                  !24,25,26,27 are the dummy pointers
            IF ( (KPNTR.EQ.PNTR(N)) .OR.   !operand is one of the dummy frames
     +           (LPNTR.EQ.PNTR(N)) ) THEN      
               OUTPTR = PNTR(N)
               NOUT = N
               GOTO 4000
            ENDIF
2100     CONTINUE
C                              !we have to use up one of the dummy frames
         IF (IDUMMY.LE.3) THEN
            IDUMMY = IDUMMY + 1
            NOUT = 23 + IDUMMY            !keep no. of dummy area used 
            OUTPTR = PNTR(NOUT)           !for output
         ELSE
            CALL STETER(99,'error in internal logic ...!')
         ENDIF
      ENDIF
C
C  now do the actual OPERA
4000  IF (OPERA(1:1).NE.'Q') THEN
         CALL OPFF(OPERA,MADRID(KPNTR),MADRID(LPNTR),
     +                   MADRID(OUTPTR),MAPSIZ,USRNUL,NNN)
      ELSE
         CALL FUN2FF(BTOM(P1)(1:5),MADRID(KPNTR),MADRID(LPNTR),
     +                   MADRID(OUTPTR),MAPSIZ,USRNUL,NNN)
      ENDIF
      NULCNT = NULCNT + NNN               !update null count
C      
      IF (OPCNT.EQ.OPINDX) GOTO 7700
C
C  put resulting frame pointer back into relevant BPIDX, if we are not finished yet
4400  BPIDX(P1) = NOUT
C      
C  loopend for all basic OPERAs
5000  IF (OPERA(1:1).NE.'Q') THEN
         NBRA = 2
      ELSE
         NBRA = 3
      ENDIF
      DO 5100, N=PP+1,45                        !update pointers for BTOM
         BPNTRS(N) = BPNTRS(N+NBRA)
5100  CONTINUE
      GOTO 1000                        !get next OPERA
C      
C  finally get min + max
7700  CALL MYMX(MADRID(RPNTR),MAPSIZ,CUTS)
      IF (CUTS(1).GT.FMIN) CUTS(1) = FMIN
      IF (CUTS(2).LT.FMAX) CUTS(2) = FMAX
C      
C  that's it folks...
8000  RETURN
C      
      END

C @(#)histo.for	19.1 (ESO-DMD) 02/25/03 13:30:45
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE HISTO(ARRAY,NAXIS,NPIX,PIXELS,F,CUTS,NSLOT,SLOT)
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.COPYRIGHT: Copyright (c) 1988 European Southern Observatory,
C                                         all rights reserved
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: K.Banse
C
C.IDENTIFICATION
C  subroutine HISTO		version 2.02	830615
C             HSTVLS			2.00841130
C             HISTEQ			1.90	830331
C  K. Banse                        ESO - Garching
C
C.KEYWORDS
C  histogram
C
C.PURPOSE
C  1) calculate histogram of given array
C  2) equalize histogram
C
C.ALGORITHM
C  straigth forward + from Gonzalez,Wintz: "Digital Image Processing"
C
C.INPUT/OUTPUT
C  call as HISTO(ARRAY,NAXIS,NPIX,PIXELS,F,CUTS,NSLOT,SLOT)
C
C 1)
C  input par:
C  ARRAY:      R*4 array      input data
C  NAXIS:      I*4            no. of axes of ARRAY
C  NPIX:      I*4 array      original size of each axis
C  PIXELS:      I*4 array      start + end pixels in each axis
C  F:            R*4            scaling factor
C  CUTS:      R*4 array      low + high cuts of ARRAY
C  NSLOT:      I*4            no. of bins (without excess bins...)
C
C  output par:
C  SLOT:      I*4 array      bins for histogram
C
C 2)
C  input par:
C  BINS:      I*4 array      histogram
C  LEVEL:      I*4            no. of levels in histogram (= dim. of BINS)
C  FSIZE:      R*4            no. of pixels in image
C  KBINS:      I*4 array      equalized histogram
C  ITT:            I*2 array      ITT table to realize the equalized histogram on the DeAnza
C
C------------------------------------------------------------------------
C 
      IMPLICIT NONE
C
      INTEGER      NAXIS,NPIX(3),PIXELS(2,2),NSLOT,SLOT(1)
      INTEGER      LOWX,LOWY,HIX,HIY,NX,NY,N,IOFF,X,NOPIX
C 
      REAL         ARRAY(1)
      REAL         F,CUTS(2)
C
C  clear slots
      DO 100 N=1,NSLOT+2
         SLOT(N) = 0
100   CONTINUE
C
C  determine subarea
      LOWX = PIXELS(1,1)
      HIX = PIXELS(1,2)
      IF (NAXIS.GE.2) THEN
         LOWY = PIXELS(2,1)
         HIY = PIXELS(2,2)
      ELSE
         LOWY = 1
         HIY = 1
      ENDIF
C
C  main loop over all pixels in given area
      NOPIX = NPIX(3)
      IOFF = (LOWY - 1) * NOPIX
C 
      DO 1000 NY=LOWY,HIY
         DO 600 NX=LOWX,HIX
            N = IOFF + NX
            IF (ARRAY(N).GT.CUTS(2)) THEN
               X = NSLOT                        !high excess bin
               GOTO 500
            ENDIF
            IF (ARRAY(N).LT.CUTS(1)) THEN
               X = 1                        	!low excess bin
               GOTO 500
            ENDIF
C
            X = INT(F*(ARRAY(N) - CUTS(1))) + 2
500         SLOT(X) = SLOT(X) + 1
            IOFF = IOFF + NOPIX
600      CONTINUE
1000  CONTINUE
C
C  that's it folks...
      RETURN
      END

      SUBROUTINE
     +HSTVLS(ARRAY,NAXIS,NPIX,SUBLO,SUBHI,CUTS,SLTSIZ,NSLOT,SLOT)
C
      IMPLICIT NONE
C 
      INTEGER      NAXIS,NPIX(3),SUBLO(3),SUBHI(3),NSLOT,SLOT(1)
      INTEGER      LOWX,LOWY,LOWZ,HIX,HIY,HIZ
      INTEGER      N,OFF,YOFFA,YOFF,ZOFF,NX,NY,NZ
      INTEGER      NPX,NPXY,X
C 
      REAL         ARRAY(1)
      REAL         SLTSIZ,CUTS(2),F,R
C
C  clear slots
      DO 100 N=1,NSLOT
         SLOT(N) = 0
100   CONTINUE
      F = 1./SLTSIZ
C
C  determine subarea
      LOWX = SUBLO(1)
      HIX = SUBHI(1)
      NPX = NPIX(1)
      IF (NAXIS.GE.2) THEN
         LOWY = SUBLO(2)
         HIY = SUBHI(2)
         NPXY = NPX * NPIX(2)
      ELSE
         LOWY = 1
         HIY = 1
         NPXY = NPX
      ENDIF
      IF (NAXIS.GE.3) THEN
         LOWZ = SUBLO(3)
         HIZ = SUBHI(3)
      ELSE
         LOWZ = 1
         HIZ = 1
      ENDIF
C
      ZOFF = (LOWZ-1) * NPXY
      YOFFA = (LOWY-1) * NPX
C
C  test, if we have excess bins
      IF (CUTS(2).LE.CUTS(1)) GOTO 1000
C
C  main loop over all pixels in given area with excess bins
      DO 800 NZ=LOWZ,HIZ
         YOFF = YOFFA                           !reset Y offset for each z-loop
C
         DO 600 NY=LOWY,HIY
            OFF = ZOFF + YOFF
C
            DO 500 NX=LOWX,HIX
               N = OFF + NX
               IF (ARRAY(N).GT.CUTS(2)) THEN
                  X = NSLOT                     !high excess bin
               ELSE
                  R = ARRAY(N) - CUTS(1)
                  IF (R.LT.0.) THEN
                     X = 1                  	!low excess bin
                  ELSE
                     X = INT(F*R) + 2           !valid bin
                  ENDIF
               ENDIF
               SLOT(X) = SLOT(X) + 1
500         CONTINUE
C
            YOFF = YOFF + NPX
600      CONTINUE
C
         ZOFF = ZOFF + NPXY
800   CONTINUE
C
C  that's it
      RETURN
C
C  main loop over all pixels in given area without excess bins
1000  DO 1800 NZ=LOWZ,HIZ
         YOFF = YOFFA                           !reset Y offset for each z-loop
C
         DO 1600 NY=LOWY,HIY
            OFF = ZOFF + YOFF
C
            DO 1500 NX=LOWX,HIX
               N = OFF + NX
               X = INT(F*(ARRAY(N)-CUTS(1))) + 1
               SLOT(X) = SLOT(X) + 1
1500        CONTINUE
C
            YOFF = YOFF + NPX
1600     CONTINUE
C
         ZOFF = ZOFF + NPXY
1800  CONTINUE
C
C  that's it folks...
      RETURN
      END

      SUBROUTINE HISTEQ(BINS,LEVEL,FSIZE,KBINS,ITT)
C
      IMPLICIT NONE
C 
      INTEGER     BINS(1),LEVEL,KBINS(1),ITT(1)
      INTEGER     IS(512)
      INTEGER     N,NN,NST
C 
      REAL        T(512),S(512),RLEVL,FSIZE
C
      RLEVL = FLOAT((LEVEL-1) * 2)
      T(1) = 1./RLEVL                        !T(n) will be set to midpoints between intervals
      S(1) = FLOAT(BINS(1))/FSIZE            !S(n) is the transfer function
C
      DO 100 N=2,LEVEL
         T(N) = (2*N-1)/RLEVL
         S(N) = S(N-1) + FLOAT(BINS(N))/FSIZE
100   CONTINUE
C
C  assign values of transfer function to nearest slot
      NST = 1                        	!start at slot 1
      DO 1000 N=1,LEVEL
C
         IF (NST.EQ.LEVEL) THEN            !if last slot already reached,
            IS(N) = LEVEL                  !index must be the last possible one...
         ELSE
C
            DO 500 NN=NST,LEVEL             !use T(n), to find nearest slot
               IF (S(N).LT.T(NN)) THEN      !in increasing order
                  IS(N) = NN
                  NST = NN
                  GOTO 1000
               ENDIF
500         CONTINUE
         ENDIF
1000  CONTINUE
C
C  calculate equalized histogram
      DO 2100 N=1,LEVEL
         KBINS(N) = 0
2100  CONTINUE
C
      DO 2500 N=1,LEVEL
         NN = IS(N)
         KBINS(NN) = KBINS(NN) + BINS(N)
         ITT(N) = NN - 1
2500  CONTINUE
C
      RETURN
      END

C @(#)clpmtr.for	19.1 (ES0-DMD) 02/25/03 13:25:32
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENT:   subroutine CLPMTR         version 1.2        870729
C          A. Kruszewski             ESO Garching
C.PURPOSE: classifies objects into stars, galaxies and image defects
C.INPUT/OUTPUT
C  input arguments
C  PMTR        real*4 array      array holding classifiers
C  M           integer*4         number of objects
C  STPR        real*4 array      one-dimensional point spread function
C                                of stellar objects
C  TRSH        real*4            detection treshold above the sky 
C  output arguments
C  ICLS        integer*4 array   array holding the classification
C  PMTR        real*4 array      modified array holding classifiers
C  FAIL        logical           fail flag
C-----------------------------------------------------------------------
      SUBROUTINE CLPMTR(PMTR,ICLS,M,STPR,TRSH,FAIL)
C
      IMPLICIT NONE
      INCLUDE 'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER ICTL(7)
      INTEGER ICLS(2,MAXCNT)
      INTEGER IAC
      INTEGER ISTAT
      INTEGER I, IB, IF
      INTEGER KUN, KNUL
      INTEGER M
      INTEGER MADRID(1)
C
      REAL    BLMT
      REAL    PMTR(30,MAXCNT)
      REAL    STPR(MAXSUB)
      REAL    TRSH
C
      LOGICAL BRGT(MAXCNT)
      LOGICAL FAIL
C
      COMMON /VMR/MADRID
C
      CALL STKRDR('INV_REAL', 8, 1, IAC, BLMT, KUN, KNUL, ISTAT)
C
C ****    Set corresponding elements of BRGT to true for bright objects.
C
      IB     = 0
      IF     = 0
      DO 10 I = 1,M
          IF (PMTR(5,I).LT.BLMT) THEN
              BRGT(I) = .TRUE.
              IB     = IB + 1
          ELSE
              BRGT(I) = .FALSE.
              IF     = IF + 1
          END IF

   10 CONTINUE
      ICTL(1) = IF
      ICTL(2) = IB
      DO 20 I = 3,7
          ICTL(I) = 0
   20 CONTINUE
C
C classifies bright objects
C
      CALL CLBRGT(PMTR, BRGT, ICLS, M)
C
C classifies faint objects
C
      CALL CFAINT(PMTR, BRGT, ICLS, M, STPR, TRSH, FAIL)
C
C          Elements of ICLS(1,*) are coded: 0-unclassified, 1-star,
C	  2-galaxy
C ****    and they describe the classification of seed objects.
C         Elements of ICLS(2,*) are coded: 0-defect, 1-star, 2-galaxy
C         and they describe current classification of objects.
C
      RETURN
      END

C @(#)elmoi.for	19.1 (ESO-DMD) 02/25/03 13:29:42
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE ELMIF(IVX,IVY,VZ,NP,VP,FS,VPES,NC,BETA,SQM,LG,WEI,
     2                 SIG,MX,MY)
C+++
C.PURPOSE: MOFFAT o Gauss sigma fisso - piano fisso
C---
      IMPLICIT     NONE
      INTEGER      NST
      INTEGER      NIND
      PARAMETER    (NST=40)
      PARAMETER    (NIND=4*NST+3)
C
      INTEGER      IVX(1)
      INTEGER      IVY(1)
      REAL         VZ(1)
      INTEGER      NP
      REAL         VP(1)
      REAL         FS
      REAL         VPES(7)
      INTEGER      NC
      REAL         BETA
      REAL         SQM
      INTEGER      LG, THREE
      REAL         WEI(1)
      REAL         SIG
      INTEGER      MX(1),MY(1)
C
      REAL         RMT
      REAL         VTN, VC, VPI, VFU, VMO, VG, VTP
      REAL         XT, YT
      REAL         HH
      REAL         EPES, EP, EPE, EP2, EEE
      REAL         DIX, DIY
      REAL         CO
      INTEGER      N, NIN, N1, NCD
      INTEGER      INK, INK1
      INTEGER      I, J, K, L, LL
      INTEGER      II, JJ
      REAL         FK(NST)
      REAL         PAS(6,6),H(6,6)
C
      COMMON       /SUFR/RMT(NIND,NIND),VTN(NIND),VC(NIND)
      DATA  PAS/
     2   0.0,       0.0,       0.0,      0.0,      0.0,      0.0,     
     2  -0.577350,  0.577350,  0.0,      0.0,      0.0,      0.0,
     *  -0.774597,  0.0,       0.774597, 0.0,      0.0,      0.0,
     *  -0.861136, -0.339981,  0.339981, 0.861136, 0.0,      0.0,
     *  -0.906179, -0.538469,  0.0,      0.538469, 0.906179, 0.0,
     *  -0.932469, -0.661209, -0.238619, 0.238619, 0.661209, 0.932469/
      DATA   H/
     2  2.0,       0.0,       0.0,      0.0,      0.0,      0.0,
     3  1.0,       1.0,       0.0,      0.0,      0.0,      0.0,
     4  0.555555,  0.888889,  0.555555, 0.0,      0.0,      0.0,
     5  0.347855,  0.652145,  0.652145, 0.347855, 0.0,      0.0,
     6  0.236927,  0.478629,  0.568889, 0.478629, 0.236927, 0.0,
     7  0.171324,  0.360762,  0.467914, 0.467914, 0.360762, 0.171324/
C
C ***
      THREE = 3
      NIN = NC*3
      DO 10 I=1,NIN
         VC(I)=0
         DO 11 J=1,NIN
            RMT(I,J)=0
  11     CONTINUE
  10  CONTINUE
C
      DO 20 I=1,NC
         IF (BETA.LE.0.) THEN
            FK(I) = -4*ALOG(2.)/(VP(4*I+3)**2)
         ELSE
            FK(I) = 1./(VP(4*I+3)**2)
         END IF
   20 CONTINUE
C
      VPI     = VP(THREE)
      VTN(1)  = 1.
      DO 30  K=1,NP
         VFU=0.
         DO 31 LL=2,NIN
            VTN(LL)=0.
   31    CONTINUE
C
         DO 32 L=1,NC
            N  = L*3-2
            N1 = L*4
            DO 33 I = 1,MX(K)
               XT = .5*PAS(I,MX(K))+IVX(K)
               DO 34 J = 1,MY(K)
                  HH   = H(I,MX(K))*H(J,MY(K))
                  YT   = .5*PAS(J,MY(K))+IVY(K)
                  DIX  = XT-VP(N1+1)
                  DIY  = YT-VP(N1+2)
                  EPES = DIX*DIX+DIY*DIY
C
                  IF (BETA.LE.0) THEN
                     EP = EXP(EPES*FK(L))
                     CO = -VP(N1)*EP*2.*FK(L)
                  ELSE
                     EPE = 1.+EPES*FK(L)
                     EP  = EPE**(-BETA)
                     EP2 = EPE**(-BETA-1.)
                     CO  = VP(N1)*BETA*EP2*2*FK(L)
                  END IF
                  VTN(N)   = EP*HH+VTN(N)
                  VTN(N+1) = CO*DIX*HH+VTN(N+1)
                  VTN(N+2) = CO*DIY*HH+VTN(N+2)
                  VFU      = VP(N1)*EP*HH+VFU
   34          CONTINUE
   33       CONTINUE
            VTN(N)   = VTN(N)/4
            VTN(N+1) = VTN(N+1)/4
            VTN(N+2) = VTN(N+2)/4
   32    CONTINUE
   30 CONTINUE
C
      VFU = VFU/4+VPI
      DO 41 I = 1,NIN
         VTP   = VTN(I)*WEI(K)
         VC(I) = VC(I)+(VZ(K)-VFU)*VTP
         DO 42 J = 1,I
            RMT(I,J)=RMT(I,J)+VTN(J)*VTP
   42    CONTINUE
   41 CONTINUE
C
      DO 51 I = 2,NIN
         DO 52 J=1,I-1
            RMT(J,I)=RMT(I,J)
   52    CONTINUE
   51 CONTINUE
C
      DO 61 I=1,NIN
         RMT(I,I)=RMT(I,I)*(1+FS**2)
   61 CONTINUE
C
      NCD= NIND
      CALL LISIB(RMT,VC,NIN,NCD,SIG)
      IF (NCD.GT.0) THEN
         DO 71 I=1,NC
            DO 72 J=4,6
               INK     = J+4*(I-1)
               INK1    = J+3*(I-2)
               VMO     = VC(INK1)*VPES(J)
               VP(INK) =VMO+VP(INK)
               IF (ABS(VP(INK)).GT.1000..AND.J.NE.4) NCD=-1
   72       CONTINUE
   71    CONTINUE
C
         IF (NCD.GT.0) THEN
            SQM=0.
            DO 81 I = 1,NP
               VG=0
               DO 82 J = 1,NC
                  N = J*4
                  DO 83 II = 1,MX(I)
                     XT = .5*PAS(II,MX(I))+IVX(I)
                     DO 84 JJ=1,MY(I)
                        YT  = .5*PAS(JJ,MY(I))+IVY(I)
                        EEE = ((VP(N+1)-XT)**2+(VP(N+2)-YT)**2)/
     2                        (VP(N+3)**2)
                        IF (BETA.LE.0.) THEN
                           VG = VG+H(II,MX(I))*H(JJ,MY(I))*VP(N)*
     *                          EXP(-EEE*4*ALOG(2.))
                        ELSE
                           VG = VG+H(II,MX(I))*H(JJ,MY(I))*VP(N)*
     2                          (1+EEE)**(-BETA)
                        END IF
   84                CONTINUE
   83             CONTINUE
   82          CONTINUE
C
               VG  = VG/4.+VP(THREE)
               SQM = SQM+(VZ(I)-VG)**2*WEI(I)
   81       CONTINUE
            SQM = SQM/(NP-NIN)
         END IF
      END IF
      IF (NCD.LT.1) LG=1
      RETURN
      END


      SUBROUTINE ELMIFV(IVX,IVY,VZ,NP,VP,FS,VPES,NC,BETA,SQM,LG,WEI,
     2                 SIG,MX,MY)
C+++
C.PURPOSE: MOFFAT o Gauss sigma fisso - piano orizzontale
C---
      IMPLICIT     NONE
      INTEGER      NST
      INTEGER      NIND
      PARAMETER    (NST=40)
      PARAMETER    (NIND=4*NST+3)
C
      INTEGER      IVX(1)
      INTEGER      IVY(1)
      REAL         VZ(1)
      INTEGER      NP
      REAL         VP(1)
      REAL         FS
      REAL         VPES(7)
      INTEGER      NC
      REAL         BETA
      REAL         SQM
      INTEGER      LG, THREE
      REAL         WEI(1)
      REAL         SIG
      INTEGER      MX(1),MY(1)
C
      REAL         RMT
      REAL         VTN, VC, VPI, VFU, VMO, VG, VTP
      REAL         XT, YT
      REAL         HH
      REAL         EPES, EP, EPE, EP2, EEE
      REAL         DIX, DIY
      REAL         CO
      INTEGER      N, NIN, N1, NCD
      INTEGER      INK, INK1
      INTEGER      I, J, K, L, LL
      INTEGER      II, JJ
      REAL         FK(NST)
      REAL         PAS(6,6),H(6,6)
C
      COMMON       /SUFR/RMT(NIND,NIND),VTN(NIND),VC(NIND)
      DATA  PAS/
     2   0.0,       0.0,       0.0,      0.0,      0.0,      0.0,     
     2  -0.577350,  0.577350,  0.0,      0.0,      0.0,      0.0,
     *  -0.774597,  0.0,       0.774597, 0.0,      0.0,      0.0,
     *  -0.861136, -0.339981,  0.339981, 0.861136, 0.0,      0.0,
     *  -0.906179, -0.538469,  0.0,      0.538469, 0.906179, 0.0,
     *  -0.932469, -0.661209, -0.238619, 0.238619, 0.661209, 0.932469/
      DATA   H/
     2  2.0,       0.0,       0.0,      0.0,      0.0,      0.0,
     3  1.0,       1.0,       0.0,      0.0,      0.0,      0.0,
     4  0.555555,  0.888889,  0.555555, 0.0,      0.0,      0.0,
     5  0.347855,  0.652145,  0.652145, 0.347855, 0.0,      0.0,
     6  0.236927,  0.478629,  0.568889, 0.478629, 0.236927, 0.0,
     7  0.171324,  0.360762,  0.467914, 0.467914, 0.360762, 0.171324/
C
C ***
      THREE = 3
      NIN = NC*4
      DO 10 I=1,NIN
         VC(I)=0
         DO 11 J=1,NIN
            RMT(I,J)=0
  11     CONTINUE
  10  CONTINUE
C
      DO 20 I=1,NC
         IF (BETA.LE.0.) THEN
            FK(I) = -4*ALOG(2.)/(VP(4*I+3)**2)
         ELSE
            FK(I) = 1./(VP(4*I+3)**2)
         END IF
   20 CONTINUE
C
      VPI     = VP(THREE)
      VTN(1)  = 1.
      DO 30  K=1,NP
         VFU=0.
         DO 31 LL=2,NIN
            VTN(LL)=0.
   31    CONTINUE
C
         DO 32 L=1,NC
            N  = L*4-3
            N1 = L*4
            DO 33 I = 1,MX(K)
               XT = 0.5*PAS(I,MX(K))+IVX(K)
               DO 34 J = 1,MY(K)
                  HH   = H(I,MX(K))*H(J,MY(K))
                  YT   = 0.5*PAS(J,MY(K))+IVY(K)
                  DIX  = XT-VP(N1+1)
                  DIY  = YT-VP(N1+2)
                  EPES = DIX*DIX+DIY*DIY
C
                  IF (BETA.LE.0) THEN
                     EP = EXP(EPES*FK(L))
                     CO = -VP(N1)*EP*2.*FK(L)
                  ELSE
                     EPE = 1.+EPES*FK(L)
                     EP  = EPE**(-BETA)
                     EP2 = EPE**(-BETA-1.)
                     CO  = VP(N1)*BETA*EP2*2*FK(L)
                  END IF
                  VTN(N)   = EP*HH+VTN(N)
                  VTN(N+1) = CO*DIX*HH+VTN(N+1)
                  VTN(N+2) = CO*DIY*HH+VTN(N+2)
                  VTN(N+3) = CO*EPES*HH/VP(N1+3)+VTN(N+3)
                  VFU      = VP(N1)*EP*HH+VFU
   34          CONTINUE
   33       CONTINUE
            VTN(N)   = VTN(N)/4
            VTN(N+1) = VTN(N+1)/4
            VTN(N+2) = VTN(N+2)/4
            VTN(N+3) = VTN(N+3)/4
   32    CONTINUE
C
         VFU = VFU/4+VPI
         DO 41 I = 1,NIN
            VTP   = VTN(I)*WEI(K)
            VC(I) = VC(I)+(VZ(K)-VFU)*VTP
            DO 42 J = 1,I
               RMT(I,J)=RMT(I,J)+VTN(J)*VTP
   42       CONTINUE
   41    CONTINUE
   30 CONTINUE
C
      DO 51 I = 2,NIN
         DO 52 J=1,I-1
            RMT(J,I)=RMT(I,J)
   52    CONTINUE
   51 CONTINUE
C
      DO 61 I=1,NIN
         RMT(I,I)=RMT(I,I)*(1+FS**2)
   61 CONTINUE
C
      NCD= NIND
      CALL LISIB(RMT,VC,NIN,NCD,SIG)
      IF (NCD.GT.0) THEN
         VP(THREE) = VC(1)*VPES(3)*VP(THREE)
         DO 71 I=1,NC
            DO 72 J=4,7
               INK     = J+4*(I-1)
               INK1    = INK-3
               VMO     = VC(INK1)*VPES(J)
               VP(INK) = VMO+VP(INK)
               IF (ABS(VP(INK)).GT.1000..AND.J.NE.4) NCD=-1
   72       CONTINUE
   71    CONTINUE
C
         IF (NCD.GT.0) THEN
            SQM=0.
            DO 81 I = 1,NP
               VG=0
               DO 82 J = 1,NC
                  N = J*4
                  DO 83 II = 1,MX(I)
                     XT = .5*PAS(II,MX(I))+IVX(I)
                     DO 84 JJ=1,MY(I)
                        YT  = .5*PAS(JJ,MY(I))+IVY(I)
                        EEE = ((VP(N+1)-XT)**2+(VP(N+2)-YT)**2)/
     2                        (VP(N+3)**2)
                        IF (BETA.LE.0.) THEN
                           VG = VG+H(II,MX(I))*H(JJ,MY(I))*VP(N)*
     *                          EXP(-EEE*4*ALOG(2.))
                        ELSE
                           VG = VG+H(II,MX(I))*H(JJ,MY(I))*VP(N)*
     2                          (1+EEE)**(-BETA)
                        END IF
   84                CONTINUE
   83             CONTINUE
   82          CONTINUE
C
               VG  = VG/4.+VP(THREE)
               SQM = SQM+(VZ(I)-VG)**2*WEI(I)
   81       CONTINUE
            SQM = SQM/(NP-NIN)
         END IF
      END IF
      IF (NCD.LT.1) LG=1
      RETURN
      END


      SUBROUTINE ELMIR(IVX,IVY,VZ,NP,VP,FS,VPES,NC,BETA,SQM,LG,WEI,
     2                 SIG,MX,MY)
C+++
C.PURPOSE: MOFFAT o Gauss sigma fisso - piano fisso
C---
      IMPLICIT     NONE
      INTEGER      NST
      INTEGER      NIND
      PARAMETER    (NST=40)
      PARAMETER    (NIND=4*NST+3)
C
      INTEGER      IVX(1)
      INTEGER      IVY(1)
      REAL         VZ(1)
      INTEGER      NP
      REAL         VP(1)
      REAL         FS
      REAL         VPES(7)
      INTEGER      NC
      REAL         BETA
      REAL         SQM
      INTEGER      LG, THREE
      REAL         WEI(1)
      REAL         SIG
      INTEGER      MX(1),MY(1)
C
      REAL         RMT
      REAL         VTN, VC, VPI, VFU, VMO, VG, VTP, VVV
      REAL         XT, YT
      REAL         HH
      REAL         EPES, EP, EPE, EP2, EEE
      REAL         DIX, DIY
      REAL         CO
      INTEGER      N, NIN, N1, NCD
      INTEGER      INK, INK1
      INTEGER      I, J, K, L, LL
      INTEGER      II, JJ
      REAL         FK(NST)
      REAL         PAS(6,6),H(6,6)
C
      COMMON       /SUFR/RMT(NIND,NIND),VTN(NIND),VC(NIND)
      DATA  PAS/
     2   0.0,       0.0,       0.0,      0.0,      0.0,      0.0,     
     2  -0.577350,  0.577350,  0.0,      0.0,      0.0,      0.0,
     *  -0.774597,  0.0,       0.774597, 0.0,      0.0,      0.0,
     *  -0.861136, -0.339981,  0.339981, 0.861136, 0.0,      0.0,
     *  -0.906179, -0.538469,  0.0,      0.538469, 0.906179, 0.0,
     *  -0.932469, -0.661209, -0.238619, 0.238619, 0.661209, 0.932469/
      DATA   H/
     2  2.0,       0.0,       0.0,      0.0,      0.0,      0.0,
     3  1.0,       1.0,       0.0,      0.0,      0.0,      0.0,
     4  0.555555,  0.888889,  0.555555, 0.0,      0.0,      0.0,
     5  0.347855,  0.652145,  0.652145, 0.347855, 0.0,      0.0,
     6  0.236927,  0.478629,  0.568889, 0.478629, 0.236927, 0.0,
     7  0.171324,  0.360762,  0.467914, 0.467914, 0.360762, 0.171324/
C
C ***
      THREE = 3
      NIN = NC*3+1
      DO 10 I=1,NIN
         VC(I)=0
         DO 11 J=1,NIN
            RMT(I,J)=0
  11     CONTINUE
  10  CONTINUE
C
      DO 20 I=1,NC
         IF (BETA.LE.0.) THEN
            FK(I) = -4*ALOG(2.)/(VP(4*I+3)**2)
         ELSE
            FK(I) = 1./(VP(4*I+3)**2)
         END IF
   20 CONTINUE
C
      VPI     = VP(THREE)
      VTN(1)  = 1.
      DO 30  K=1,NP
         VFU = 0.0
         VVV = 0.0
         DO 31 LL=2,NIN
            VTN(LL)=0.
   31    CONTINUE
C
         DO 32 L=1,NC
            N  = L*3-1
            N1 = L*4
            DO 33 I = 1,MX(K)
               XT = .5*PAS(I,MX(K))+IVX(K)
               DO 34 J = 1,MY(K)
                  HH   = H(I,MX(K))*H(J,MY(K))
                  YT   = .5*PAS(J,MY(K))+IVY(K)
                  DIX  = XT-VP(N1+1)
                  DIY  = YT-VP(N1+2)
                  EPES = DIX*DIX+DIY*DIY
C
                  IF (BETA.LE.0) THEN
                     EP = EXP(EPES*FK(L))
                     CO = -VP(N1)*EP*2.*FK(L)
                  ELSE
                     EPE = 1.+EPES*FK(L)
                     EP  = EPE**(-BETA)
                     EP2 = EPE**(-BETA-1.)
                     CO  = VP(N1)*BETA*EP2*2*FK(L)
                  END IF
                  VTN(N)   = EP*HH+VTN(N)
                  VTN(N+1) = CO*DIX*HH+VTN(N+1)
                  VTN(N+2) = CO*DIY*HH+VTN(N+2)
                  VFU      = VP(N1)*EP*HH+VFU
   34          CONTINUE
   33       CONTINUE
            VTN(N)   = VTN(N)/4
            VTN(N+1) = VTN(N+1)/4
            VTN(N+2) = VTN(N+2)/4
   32    CONTINUE
C
         VFU = VFU/4+VPI
         DO 41 I = 1,NIN
            VTP   = VTN(I)*WEI(K)
            VC(I) = VC(I)+(VZ(K)-VFU)*VTP
            DO 42 J = 1,I
               RMT(I,J)=RMT(I,J)+VTN(J)*VTP
   42       CONTINUE
   41    CONTINUE
   30 CONTINUE
C
      DO 51 I = 2,NIN
         DO 52 J=1,I-1
            RMT(J,I)=RMT(I,J)
   52    CONTINUE
   51 CONTINUE
C
      DO 61 I=1,NIN
         RMT(I,I)=RMT(I,I)*(1+FS**2)
   61 CONTINUE
C
      NCD=NIND
      CALL LISIB(RMT,VC,NIN,NCD,SIG)
      IF (NCD.GT.0) THEN
         VP(THREE) = VC(1)*VPES(3)+VP(THREE)
         DO 71 I=1,NC
            DO 72 J=4,6
               INK     = J+4*(I-1)
               INK1    = J+3*(I-2)-2
               VMO     = VC(INK1)*VPES(J)
               VP(INK) = VMO+VP(INK)
               IF (ABS(VP(INK)).GT.1000..AND.J.NE.4) NCD=-1
   72       CONTINUE
   71    CONTINUE
C
         IF (NCD.GT.0) THEN
            SQM = 0.
            DO 81 I = 1,NP
               VG = 0
               DO 82 J = 1,NC
                  N = J*4
                  DO 83 II = 1,MX(I)
                     XT = .5*PAS(II,MX(I))+IVX(I)
                     DO 84 JJ=1,MY(I)
                        YT  = .5*PAS(JJ,MY(I))+IVY(I)
                        EEE = ((VP(N+1)-XT)**2+(VP(N+2)-YT)**2)/
     2                        (VP(N+3)**2)
                        IF (BETA.LE.0.) THEN
                           VG = VG+H(II,MX(I))*H(JJ,MY(I))*
     *                          VP(N)*EXP(-EEE*4*ALOG(2.))
                        ELSE
                           VG = VG+H(II,MX(I))*H(JJ,MY(I))*
     2                          VP(N)*(1+EEE)**(-BETA)
                        END IF
   84                CONTINUE
   83             CONTINUE
   82          CONTINUE
               VG  = VG/4.+VP(THREE)
               SQM = SQM+(VZ(I)-VG)**2*WEI(I)
   81       CONTINUE
            SQM = SQM/(NP-NIN)
         END IF
      END IF
      IF (NCD.LT.1) LG=1
      RETURN
      END


      SUBROUTINE ELMIRV(IVX,IVY,VZ,NP,VP,FS,VPES,NC,BETA,SQM,LG,WEI,
     2                 SIG,MX,MY)
C+++
C.PURPOSE: MOFFAT o Gauss sigma fisso - piano orizzontale
C---
      IMPLICIT     NONE
      INTEGER      NST
      INTEGER      NIND
      PARAMETER    (NST=40)
      PARAMETER    (NIND=4*NST+3)
C
      INTEGER      IVX(1)
      INTEGER      IVY(1)
      REAL         VZ(1)
      INTEGER      NP
      REAL         VP(1)
      REAL         FS
      REAL         VPES(7)
      INTEGER      NC
      REAL         BETA
      REAL         SQM
      INTEGER      LG, THREE
      REAL         WEI(1)
      REAL         SIG
      INTEGER      MX(1),MY(1)
C
      REAL         RMT
      REAL         VTN, VC, VPI, VFU, VMO, VG, VTP
      REAL         XT, YT
      REAL         HH
      REAL         EPES, EP, EPE, EP2, EEE
      REAL         DIX, DIY
      REAL         CO
      INTEGER      N, NIN, N1, NCD
      INTEGER      INK, INK1
      INTEGER      I, J, K, L, LL
      INTEGER      II, JJ
      REAL         FK(NST)
      REAL         PAS(6,6),H(6,6)
C
      COMMON       /SUFR/RMT(NIND,NIND),VTN(NIND),VC(NIND)
      DATA  PAS/
     2   0.0,       0.0,       0.0,      0.0,      0.0,      0.0,     
     2  -0.577350,  0.577350,  0.0,      0.0,      0.0,      0.0,
     *  -0.774597,  0.0,       0.774597, 0.0,      0.0,      0.0,
     *  -0.861136, -0.339981,  0.339981, 0.861136, 0.0,      0.0,
     *  -0.906179, -0.538469,  0.0,      0.538469, 0.906179, 0.0,
     *  -0.932469, -0.661209, -0.238619, 0.238619, 0.661209, 0.932469/
      DATA   H/
     2  2.0,       0.0,       0.0,      0.0,      0.0,      0.0,
     3  1.0,       1.0,       0.0,      0.0,      0.0,      0.0,
     4  0.555555,  0.888889,  0.555555, 0.0,      0.0,      0.0,
     5  0.347855,  0.652145,  0.652145, 0.347855, 0.0,      0.0,
     6  0.236927,  0.478629,  0.568889, 0.478629, 0.236927, 0.0,
     7  0.171324,  0.360762,  0.467914, 0.467914, 0.360762, 0.171324/
C
C ***
      THREE = 3
      NIN = NC*4+1
      DO 10 I=1,NIN
         VC(I)=0
         DO 11 J=1,NIN
            RMT(I,J)=0
  11     CONTINUE
  10  CONTINUE
C
      DO 20 I=1,NC
         IF (BETA.LE.0.) THEN
            FK(I) = -4*ALOG(2.)/(VP(4*I+3)**2)
         ELSE
            FK(I) = 1./(VP(4*I+3)**2)
         END IF
   20 CONTINUE
C
      VPI     = VP(THREE)
      VTN(1)  = 1.
      DO 30  K=1,NP
         VFU=0.
         DO 31 LL=2,NIN
            VTN(LL)=0.
   31    CONTINUE
C
         DO 32 L=1,NC
            N  = L*4-2
            N1 = L*4
            DO 33 I = 1,MX(K)
               XT = 0.5*PAS(I,MX(K))+IVX(K)
               DO 34 J = 1,MY(K)
                  HH   = H(I,MX(K))*H(J,MY(K))
                  YT   = 0.5*PAS(J,MY(K))+IVY(K)
                  DIX  = XT-VP(N1+1)
                  DIY  = YT-VP(N1+2)
                  EPES = DIX*DIX+DIY*DIY
C
                  IF (BETA.LE.0) THEN
                     EP = EXP(EPES*FK(L))
                     CO = -VP(N1)*EP*2.*FK(L)
                  ELSE
                     EPE = 1.+EPES*FK(L)
                     EP  = EPE**(-BETA)
                     EP2 = EPE**(-BETA-1.)
                     CO  = VP(N1)*BETA*EP2*2*FK(L)
                  END IF
                  VTN(N)   = EP*HH+VTN(N)
                  VTN(N+1) = CO*DIX*HH+VTN(N+1)
                  VTN(N+2) = CO*DIY*HH+VTN(N+2)
                  VTN(N+3) = CO*EPES*HH/VP(N1+3)+VTN(N+3)
                  VFU      = VP(N1)*EP*HH+VFU
   34          CONTINUE
   33       CONTINUE
            VTN(N)   = VTN(N)/4
            VTN(N+1) = VTN(N+1)/4
            VTN(N+2) = VTN(N+2)/4
            VTN(N+3) = VTN(N+3)/4
   32    CONTINUE
   30 CONTINUE
C
      VFU = VFU/4+VPI
      DO 41 I = 1,NIN
         VTP   = VTN(I)*WEI(K)
         VC(I) = VC(I)+(VZ(K)-VFU)*VTP
         DO 42 J = 1,I
            RMT(I,J)=RMT(I,J)+VTN(J)*VTP
   42    CONTINUE
   41 CONTINUE
C
      DO 51 I = 2,NIN
         DO 52 J=1,I-1
            RMT(J,I)=RMT(I,J)
   52    CONTINUE
   51 CONTINUE
C
      DO 61 I=1,NIN
         RMT(I,I)=RMT(I,I)*(1+FS**2)
   61 CONTINUE
C
      NCD= NIND
      CALL LISIB(RMT,VC,NIN,NCD,SIG)
      IF (NCD.GT.0) THEN
         VP(THREE) = VC(1)*VPES(3)*VP(THREE)
         DO 71 I=1,NC
            DO 72 J=4,7
               INK     = J+4*(I-1)
               INK1    = INK-2
               VMO     = VC(INK1)*VPES(J)
               VP(INK) = VMO+VP(INK)
               IF (ABS(VP(INK)).GT.1000..AND.J.NE.4) NCD=-1
   72       CONTINUE
   71    CONTINUE
C
         IF (NCD.GT.0) THEN
            SQM=0.
            DO 81 I = 1,NP
               VG=0
               DO 82 J = 1,NC
                  N = J*4
                  DO 83 II = 1,MX(I)
                     XT = .5*PAS(II,MX(I))+IVX(I)
                     DO 84 JJ=1,MY(I)
                        YT  = .5*PAS(JJ,MY(I))+IVY(I)
                        EEE = ((VP(N+1)-XT)**2+(VP(N+2)-YT)**2)/
     2                        (VP(N+3)**2)
                        IF (BETA.LE.0.) THEN
                           VG = VG+H(II,MX(I))*H(JJ,MY(I))*VP(N)*
     *                          EXP(-EEE*4*ALOG(2.))
                        ELSE
                           VG = VG+H(II,MX(I))*H(JJ,MY(I))*VP(N)*
     2                          (1+EEE)**(-BETA)
                        END IF
   84                CONTINUE
   83             CONTINUE
   82          CONTINUE
C
               VG  = VG/4.+VP(THREE)
               SQM = SQM+(VZ(I)-VG)**2*WEI(I)
   81       CONTINUE
            SQM = SQM/(NP-NIN)
         END IF
      END IF
      IF (NCD.LT.1) LG=1
      RETURN
      END


      SUBROUTINE ELMIPF(IVX,IVY,VZ,NP,VP,FS,VPES,NC,BETA,SQM,LG,WEI,
     2                 SIG,MX,MY)
C+++
C.PURPOSE: MOFFAT o Gauss sigma fisso - piano fisso
C---
      IMPLICIT     NONE
      INTEGER      NST
      INTEGER      NIND
      PARAMETER    (NST=40)
      PARAMETER    (NIND=4*NST+3)
C
      INTEGER      IVX(1)
      INTEGER      IVY(1)
      REAL         VZ(1)
      INTEGER      NP
      REAL         VP(1)
      REAL         FS
      REAL         VPES(7)
      INTEGER      NC
      REAL         BETA
      REAL         SQM
      INTEGER      LG, THREE
      REAL         WEI(1)
      REAL         SIG
      INTEGER      MX(1),MY(1)
C
      REAL         RMT
      REAL         VTN, VC, VFU, VG
      REAL         XT, YT
      REAL         HH
      REAL         EPES, EP, EPE, EEE
      REAL         DIX, DIY
      INTEGER      N, NIN, N1, NCD
      INTEGER      I, J, K, L, LL
      INTEGER      II, JJ
      REAL         FK(NST)
      REAL         PAS(6,6),H(6,6)
C
      COMMON       /SUFR/RMT(NIND,NIND),VTN(NIND),VC(NIND)
      DATA  PAS/
     2   0.0,       0.0,       0.0,      0.0,      0.0,      0.0,     
     2  -0.577350,  0.577350,  0.0,      0.0,      0.0,      0.0,
     *  -0.774597,  0.0,       0.774597, 0.0,      0.0,      0.0,
     *  -0.861136, -0.339981,  0.339981, 0.861136, 0.0,      0.0,
     *  -0.906179, -0.538469,  0.0,      0.538469, 0.906179, 0.0,
     *  -0.932469, -0.661209, -0.238619, 0.238619, 0.661209, 0.932469/
      DATA   H/
     2  2.0,       0.0,       0.0,      0.0,      0.0,      0.0,
     3  1.0,       1.0,       0.0,      0.0,      0.0,      0.0,
     4  0.555555,  0.888889,  0.555555, 0.0,      0.0,      0.0,
     5  0.347855,  0.652145,  0.652145, 0.347855, 0.0,      0.0,
     6  0.236927,  0.478629,  0.568889, 0.478629, 0.236927, 0.0,
     7  0.171324,  0.360762,  0.467914, 0.467914, 0.360762, 0.171324/
C
C ***
      THREE = 3
      NIN = NC+1
      DO 10 I=1,NIN
         VC(I)=0
         DO 11 J=1,NIN
            RMT(I,J)=0
  11     CONTINUE
  10  CONTINUE
C
      DO 20 I=1,NC
         IF (BETA.LE.0.) THEN
            FK(I) = -4*ALOG(2.)/(VP(4*I+3)**2)
         ELSE
            FK(I) = 1./(VP(4*I+3)**2)
         END IF
   20 CONTINUE
C
      VTN(1)  = 1.
      DO 30  K=1,NP
         VFU=0.
         DO 31 LL=2,NIN
            VTN(LL)=0.
   31    CONTINUE
C
         DO 32 L=1,NC
            N1 = L*4
            DO 33 I = 1,MX(K)
               XT = .5*PAS(I,MX(K))+IVX(K)
               DO 34 J = 1,MY(K)
                  HH   = H(I,MX(K))*H(J,MY(K))
                  YT   = 0.5*PAS(J,MY(K))+IVY(K)
                  DIX  = XT-VP(N1+1)
                  DIY  = YT-VP(N1+2)
                  EPES = DIX*DIX+DIY*DIY
C
                  IF (BETA.LE.0) THEN
                     EP = EXP(EPES*FK(L))
                  ELSE
                     EPE = 1.+EPES*FK(L)
                     EP  = EPE**(-BETA)
                  END IF
                  VTN(L+1) = EP*HH+VTN(L+1)
   34          CONTINUE
   33       CONTINUE
            VTN(L+1) = VTN(L+1)/4
   32    CONTINUE
C
         DO 41 I = 1,NIN
            VC(I) = VC(I)+VZ(K)*VTN(I)
            DO 42 J = 1,I
               RMT(I,J)=RMT(I,J)+VTN(I)*VTN(J)
   42       CONTINUE
   41    CONTINUE
   30 CONTINUE
C
      DO 51 I = 2,NIN
         DO 52 J=1,I-1
            RMT(J,I)=RMT(I,J)
   52    CONTINUE
   51 CONTINUE
C
      NCD= NIND
      CALL LISIB(RMT,VC,NIN,NCD,SIG)
      IF (NCD.GT.0) THEN
         VP(THREE) = VC(1)
         DO 71 I=1,NC
            VP(I*4) = VC(I+1)
   71    CONTINUE
C
         SQM=0.
         DO 81 I = 1,NP
            VG=0
            DO 82 J = 1,NC
               N = J*4
               DO 83 II = 1,MX(I)
                  XT = .5*PAS(II,MX(I))+IVX(I)
                  DO 84 JJ=1,MY(I)
                     YT  = .5*PAS(JJ,MY(I))+IVY(I)
                     EEE = ((VP(N+1)-XT)**2+(VP(N+2)-YT)**2)/
     2                     (VP(N+3)**2)
                     IF (BETA.LE.0.) THEN
                        VG = VG+H(II,MX(I))*H(JJ,MY(I))*VP(N)*
     *                       EXP(-EEE*4*ALOG(2.))
                     ELSE
                        VG = VG+H(II,MX(I))*H(JJ,MY(I))*VP(N)*
     2                       (1+EEE)**(-BETA)
                     END IF
   84             CONTINUE
   83          CONTINUE
   82       CONTINUE
C
            VG  = VG/4.+VP(THREE)
            SQM = SQM+(VZ(I)-VG)**2*WEI(I)
   81    CONTINUE
         SQM = SQM/(NP-NIN)
      END IF
      IF (NCD.LT.1) LG=1
      RETURN
      END


      SUBROUTINE ELMIPV(IVX,IVY,VZ,NP,VP,FS,VPES,NC,BETA,SQM,LG,WEI,
     2                 SIG,MX,MY)
C+++
C.PURPOSE: MOFFAT o Gauss sigma fisso - piano orizzontale
C---
      IMPLICIT     NONE
      INTEGER      NST
      INTEGER      NIND
      PARAMETER    (NST=40)
      PARAMETER    (NIND=4*NST+3)
C
      INTEGER      IVX(1)
      INTEGER      IVY(1)
      REAL         VZ(1)
      INTEGER      NP
      REAL         VP(1)
      REAL         FS
      REAL         VPES(7)
      INTEGER      NC
      REAL         BETA
      REAL         SQM
      INTEGER      LG, THREE, TWO
      REAL         WEI(1)
      REAL         SIG
      INTEGER      MX(1),MY(1)
C
      REAL         RMT
      REAL         VTN, VC, VPI, VFU, VG, VTP
      REAL         XT, YT
      REAL         HH
      REAL         EPES, EP, EPE, EP2, EEE
      REAL         DIX, DIY
      REAL         CO
      INTEGER      N, NIN, N1, NCD
      INTEGER      INK, INK1
      INTEGER      I, J, K, L, LL
      INTEGER      II, JJ
      REAL         FK(NST)
      REAL         PAS(6,6),H(6,6)
C
      COMMON       /SUFR/RMT(NIND,NIND),VTN(NIND),VC(NIND)
      DATA  PAS/
     2   0.0,       0.0,       0.0,      0.0,      0.0,      0.0,     
     2  -0.577350,  0.577350,  0.0,      0.0,      0.0,      0.0,
     *  -0.774597,  0.0,       0.774597, 0.0,      0.0,      0.0,
     *  -0.861136, -0.339981,  0.339981, 0.861136, 0.0,      0.0,
     *  -0.906179, -0.538469,  0.0,      0.538469, 0.906179, 0.0,
     *  -0.932469, -0.661209, -0.238619, 0.238619, 0.661209, 0.932469/
      DATA   H/
     2  2.0,       0.0,       0.0,      0.0,      0.0,      0.0,
     3  1.0,       1.0,       0.0,      0.0,      0.0,      0.0,
     4  0.555555,  0.888889,  0.555555, 0.0,      0.0,      0.0,
     5  0.347855,  0.652145,  0.652145, 0.347855, 0.0,      0.0,
     6  0.236927,  0.478629,  0.568889, 0.478629, 0.236927, 0.0,
     7  0.171324,  0.360762,  0.467914, 0.467914, 0.360762, 0.171324/
C
C ***
      THREE = 3
      TWO = 2
      NIN = NC*2+1
      DO 10 I=1,NIN
         VC(I)=0
         DO 11 J=1,NIN
            RMT(I,J)=0
  11     CONTINUE
  10  CONTINUE
C
      DO 20 I=1,NC
         IF (BETA.LE.0.) THEN
            FK(I) = -4*ALOG(2.)/(VP(4*I+3)**2)
         ELSE
            FK(I) = 1./(VP(4*I+3)**2)
         END IF
   20 CONTINUE
C
      VPI     = VP(THREE)
      VTN(3)  = 1.
      DO 30 K=1,NP
         VTN(1) = IVX(K)
         VTN(2) = IVY(K)
         VPI    = VP(1)*IVX(K)+VP(TWO)*IVY(K)+VP(THREE)
         VFU=0.
         DO 31 LL=2,NIN
            VTN(LL)=0.
   31    CONTINUE
C
         DO 32 L=1,NC
            N  = L*2                              ! addition for initialization
            N1 = L*4
            DO 33 I = 1,MX(K)
               XT = 0.5*PAS(I,MX(K))+IVX(K)
               DO 34 J = 1,MY(K)
                  HH   = H(I,MX(K))*H(J,MY(K))
                  YT   = 0.5*PAS(J,MY(K))+IVY(K)
                  DIX  = XT-VP(N1+1)
                  DIY  = YT-VP(N1+2)
                  EPES = DIX*DIX+DIY*DIY
C
                  IF (BETA.LE.0) THEN
                     EP = EXP(EPES*FK(L))
                     CO = -VP(N1)*EP*2.*FK(L)
                  ELSE
                     EPE = 1.+EPES*FK(L)
                     EP  = EPE**(-BETA)
                     EP2 = EPE**(-BETA-1.)
                     CO  = VP(N1)*BETA*EP2*2*FK(L)
                  END IF
                  VTN(N)   = EP*HH+VTN(N)
                  VTN(N+1) = CO*EPES*HH+VP(N1+3)+VTN(N+1)
                  VFU      = VP(N1)*EP*HH+VFU
   34          CONTINUE
   33       CONTINUE
            VTN(N)   = VTN(N)/4
            VTN(N+1) = VTN(N+1)/4
   32    CONTINUE
C
         VFU = VFU/4+VPI
         DO 41 I = 1,NIN
            VTP   = VTN(I)*WEI(K)
            VC(I) = VC(I)+(VZ(K)-VFU)*VTP
            DO 42 J = 1,I
               RMT(I,J)=RMT(I,J)+VTN(J)*VTP
   42       CONTINUE
   41    CONTINUE
   30 CONTINUE
C
      DO 51 I = 2,NIN
         DO 52 J=1,I-1
            RMT(J,I)=RMT(I,J)
   52    CONTINUE
   51 CONTINUE
C
      DO 61 I=1,NIN
         RMT(I,I)=RMT(I,I)*(1+FS**2)
   61 CONTINUE
C
      NCD= NIND
      CALL LISIB(RMT,VC,NIN,NCD,SIG)
      IF (NCD.GT.0) THEN
         VP(THREE) = VC(1)*VPES(3)+VP(THREE)
         DO 71 I=1,NC
            DO 72 J=4,7
               INK     = J+4*(I-1)
               INK1    = INK/2
               VP(INK) = VC(INK1)*VPES(J)+VP(INK)
               IF (ABS(VP(INK)).GT.1000..AND.J.NE.4) NCD=-1
   72       CONTINUE
   71    CONTINUE
C
         IF (NCD.GT.0) THEN
            SQM=0.
            DO 81 I = 1,NP
               VG=0
               DO 82 J = 1,NC
                  N = J*4
                  DO 83 II = 1,MX(I)
                     XT = 0.5*PAS(II,MX(I))+IVX(I)
                     DO 84 JJ=1,MY(I)
                        YT  = .5*PAS(JJ,MY(I))+IVY(I)
                        EEE = ((VP(N+1)-XT)**2+(VP(N+2)-YT)**2)/
     2                        (VP(N+3)**2)
                        IF (BETA.LE.0.) THEN
                           VG = VG+H(II,MX(I))*H(JJ,MY(I))*VP(N)*
     *                          EXP(-EEE*4*ALOG(2.))
                        ELSE
                           VG = VG+H(II,MX(I))*H(JJ,MY(I))*VP(N)*
     2                          (1+EEE)**(-BETA)
                        END IF
   84                CONTINUE
   83             CONTINUE
   82          CONTINUE
C
               VG  = VG/4.+VP(THREE)
               SQM = SQM+(VZ(I)-VG)**2*WEI(I)
   81       CONTINUE
            SQM = SQM/(NP-NIN)
         END IF
      END IF
      IF (NCD.LT.1) LG=1
      RETURN
      END


      SUBROUTINE ELMIV(IVX,IVY,VZ,NP,VP,FS,VPES,NC,BETA,SQM,LG,WEI,
     2                 SIG,MX,MY)
C+++
C.PURPOSE: MOFFAT o Gauss sigma fisso - piano orizzontale
C---
      IMPLICIT     NONE
      INTEGER      NST
      INTEGER      NIND
      PARAMETER    (NST=40)
      PARAMETER    (NIND=4*NST+3)
C
      INTEGER      IVX(1)
      INTEGER      IVY(1)
      REAL         VZ(1)
      INTEGER      NP
      REAL         VP(1)
      REAL         FS
      REAL         VPES(7)
      INTEGER      NC
      REAL         BETA
      REAL         SQM
      INTEGER      LG, THREE, TWO
      REAL         WEI(1)
      REAL         SIG
      INTEGER      MX(1),MY(1)
C
      REAL         RMT
      REAL         VTN, VC, VPI, VFU, VMO, VG, VTP
      REAL         XT, YT
      REAL         HH
      REAL         EPES, EP, EPE, EP2, EEE
      REAL         DIX, DIY
      REAL         CO
      INTEGER      N, NIN, N1, NCD
      INTEGER      INK
      INTEGER      I, J, K, L, LL
      INTEGER      II, JJ
      REAL         FK(NST)
      REAL         PAS(6,6),H(6,6)
C
      COMMON       /SUFR/RMT(NIND,NIND),VTN(NIND),VC(NIND)
      DATA  PAS/
     2   0.0,       0.0,       0.0,      0.0,      0.0,      0.0,     
     2  -0.577350,  0.577350,  0.0,      0.0,      0.0,      0.0,
     *  -0.774597,  0.0,       0.774597, 0.0,      0.0,      0.0,
     *  -0.861136, -0.339981,  0.339981, 0.861136, 0.0,      0.0,
     *  -0.906179, -0.538469,  0.0,      0.538469, 0.906179, 0.0,
     *  -0.932469, -0.661209, -0.238619, 0.238619, 0.661209, 0.932469/
      DATA   H/
     2  2.0,       0.0,       0.0,      0.0,      0.0,      0.0,
     3  1.0,       1.0,       0.0,      0.0,      0.0,      0.0,
     4  0.555555,  0.888889,  0.555555, 0.0,      0.0,      0.0,
     5  0.347855,  0.652145,  0.652145, 0.347855, 0.0,      0.0,
     6  0.236927,  0.478629,  0.568889, 0.478629, 0.236927, 0.0,
     7  0.171324,  0.360762,  0.467914, 0.467914, 0.360762, 0.171324/
C
C ***
      THREE = 3
      TWO = 2
      NIN = NC*4+3
      DO 10 I=1,NIN
         VC(I)=0
         DO 11 J=1,NIN
            RMT(I,J)=0
  11     CONTINUE
  10  CONTINUE
C
      DO 20 I=1,NC
         IF (BETA.LE.0.) THEN
            FK(I) = -4*ALOG(2.)/(VP(4*I+3)**2)
         ELSE
            FK(I) = 1./(VP(4*I+3)**2)
         END IF
   20 CONTINUE
C
      VTN(3)  = 1.
      DO 30 K=1,NP
         VTN(1) = IVX(K)
         VTN(2) = IVY(K)
         VPI    = VP(1)*IVX(K)+VP(TWO)*IVY(K)+VP(THREE)
         VFU=0.
         DO 31 LL=2,NIN
            VTN(LL)=0.
   31    CONTINUE
C
         DO 32 L=1,NC
            N1 = L*4
            DO 33 I = 1,MX(K)
               XT = 0.5*PAS(I,MX(K))+IVX(K)
               DO 34 J = 1,MY(K)
                  HH   = H(I,MX(K))*H(J,MY(K))
                  YT   = 0.5*PAS(J,MY(K))+IVY(K)
                  DIX  = XT-VP(N1+1)
                  DIY  = YT-VP(N1+2)
                  EPES = DIX*DIX+DIY*DIY
C
                  IF (BETA.LE.0) THEN
                     EP = EXP(EPES*FK(L))
                     CO = -VP(N1)*EP*2.*FK(L)
                  ELSE
                     EPE = 1.+EPES*FK(L)
                     EP  = EPE**(-BETA)
                     EP2 = EPE**(-BETA-1.)
                     CO  = VP(N1)*BETA*EP2*2*FK(L)
                  END IF
                  VTN(N1+1) = CO*DIX*HH+VTN(N1+1)
                  VTN(N1+2) = CO*DIY*HH+VTN(N1+2)
                  VTN(N1+3) = CO*EPES*HH/VP(N1+3)+VTN(N1+3)
                  VFU      = VP(N1)*EP*HH+VFU
   34          CONTINUE
   33       CONTINUE
            VTN(N1)   = VTN(N1)/4
            VTN(N1+1) = VTN(N1+1)/4
            VTN(N1+2) = VTN(N1+2)/4
            VTN(N1+3) = VTN(N1+3)/4
   32    CONTINUE
   30 CONTINUE
C
      VFU = VFU/4+VPI
      DO 41 I = 1,NIN
         VTP   = VTN(I)*WEI(K)
         VC(I) = VC(I)+(VZ(K)-VFU)*VTP
         DO 42 J = 1,I
            RMT(I,J)=RMT(I,J)+VTN(J)*VTP
   42    CONTINUE
   41 CONTINUE
C
      DO 51 I = 2,NIN
         DO 52 J=1,I-1
            RMT(J,I)=RMT(I,J)
   52    CONTINUE
   51 CONTINUE
C
      DO 61 I=1,NIN
         RMT(I,I)=RMT(I,I)*(1+FS**2)
   61 CONTINUE
C
      NCD= NIND
      CALL LISIB(RMT,VC,NIN,NCD,SIG)
      IF (NCD.GT.0) THEN
         DO 70 I = 1,3
            VP(I) = VC(I)*VPES(I)*VP(I)
   70    CONTINUE
         DO 71 I=1,NC
            DO 72 J=4,7
               INK     = J+4*(I-1)
               VMO     = VC(INK)*VPES(J)
               VP(INK) = VMO+VP(INK)
               IF (ABS(VP(INK)).GT.1000..AND.J.NE.4) NCD=-1
   72       CONTINUE
   71    CONTINUE
C
         IF (NCD.GT.0) THEN
            SQM=0.
            DO 81 I = 1,NP
               VG=0
               DO 82 J = 1,NC
                  N = J*4
                  DO 83 II = 1,MX(I)
                     XT = 0.5*PAS(II,MX(I))+IVX(I)
                     DO 84 JJ=1,MY(I)
                        YT  = .5*PAS(JJ,MY(I))+IVY(I)
                        EEE = ((VP(N+1)-XT)**2+(VP(N+2)-YT)**2)/
     2                        (VP(N+3)**2)
                        IF (BETA.LE.0.) THEN
                           VG = VG+H(II,MX(I))*H(JJ,MY(I))*VP(N)*
     *                          EXP(-EEE*4*ALOG(2.))
                        ELSE
                           VG = VG+H(II,MX(I))*H(JJ,MY(I))*VP(N)*
     2                          (1+EEE)**(-BETA)
                        END IF
   84                CONTINUE
   83             CONTINUE
   82          CONTINUE
C
               VG  = VG/4.+VP(1)*IVX(I)+VP(TWO)*IVY(I)+VP(THREE)
               SQM = SQM+(VZ(I)-VG)**2*WEI(I)
   81       CONTINUE
            SQM = SQM/(NP-NIN)
         END IF
      END IF
      IF (NCD.LT.1) LG=1
      RETURN
      END


      SUBROUTINE ELMIH(IVX,IVY,VZ,NP,VP,FS,VPES,NC,BETA,SQM,LG,WEI,
     2                 SIG,MX,MY)
C+++
C.PURPOSE: MOFFAT o Gauss sigma fisso - piano fisso
C---
      IMPLICIT     NONE
      INTEGER      NST
      INTEGER      NIND
      PARAMETER    (NST=40)
      PARAMETER    (NIND=4*NST+3)
C
      INTEGER      IVX(1)
      INTEGER      IVY(1)
      REAL         VZ(1)
      INTEGER      NP
      REAL         VP(1)
      REAL         FS
      REAL         VPES(7)
      INTEGER      NC
      REAL         BETA
      REAL         SQM
      INTEGER      LG, THREE
      REAL         WEI(1)
      REAL         SIG
      INTEGER      MX(1),MY(1)
C
      REAL         RMT
      REAL         VTN, VC, VFU, VG
      REAL         XT, YT
      REAL         HH
      REAL         EPES, EP, EPE, EEE
      REAL         DIX, DIY
      INTEGER      N, NIN, N1, NCD
      INTEGER      I, J, K, L, LL
      INTEGER      II, JJ
      REAL         FK(NST)
      REAL         PAS(6,6),H(6,6)
C
      COMMON       /SUFR/RMT(NIND,NIND),VTN(NIND),VC(NIND)
      DATA  PAS/
     2   0.0,       0.0,       0.0,      0.0,      0.0,      0.0,     
     2  -0.577350,  0.577350,  0.0,      0.0,      0.0,      0.0,
     *  -0.774597,  0.0,       0.774597, 0.0,      0.0,      0.0,
     *  -0.861136, -0.339981,  0.339981, 0.861136, 0.0,      0.0,
     *  -0.906179, -0.538469,  0.0,      0.538469, 0.906179, 0.0,
     *  -0.932469, -0.661209, -0.238619, 0.238619, 0.661209, 0.932469/
      DATA   H/
     2  2.0,       0.0,       0.0,      0.0,      0.0,      0.0,
     3  1.0,       1.0,       0.0,      0.0,      0.0,      0.0,
     4  0.555555,  0.888889,  0.555555, 0.0,      0.0,      0.0,
     5  0.347855,  0.652145,  0.652145, 0.347855, 0.0,      0.0,
     6  0.236927,  0.478629,  0.568889, 0.478629, 0.236927, 0.0,
     7  0.171324,  0.360762,  0.467914, 0.467914, 0.360762, 0.171324/
C
C ***
      THREE = 3
      NIN = NC
      DO 10 I=1,NIN
         VC(I)=0
         DO 11 J=1,NIN
            RMT(I,J)=0
  11     CONTINUE
  10  CONTINUE
C
      DO 20 I=1,NC
         IF (BETA.LE.0.) THEN
            FK(I) = -4*ALOG(2.)/(VP(4*I+3)**2)
         ELSE
            FK(I) = 1./(VP(4*I+3)**2)
         END IF
   20 CONTINUE
C
      DO 30  K=1,NP
         VFU=0.
         DO 31 LL=2,NIN
            VTN(LL)=0.
   31    CONTINUE
C
         DO 32 L=1,NC
            N1 = L*4
            DO 33 I = 1,MX(K)
               XT = .5*PAS(I,MX(K))+IVX(K)
               DO 34 J = 1,MY(K)
                  HH   = H(I,MX(K))*H(J,MY(K))
                  YT   = 0.5*PAS(J,MY(K))+IVY(K)
                  DIX  = XT-VP(N1+1)
                  DIY  = YT-VP(N1+2)
                  EPES = DIX*DIX+DIY*DIY
C
                  IF (BETA.LE.0) THEN
                     EP = EXP(EPES*FK(L))
                  ELSE
                     EPE = 1.+EPES*FK(L)
                     EP  = EPE**(-BETA)
                  END IF
                  VTN(L) = EP*HH+VTN(L)
   34          CONTINUE
   33       CONTINUE
            VTN(L) = VTN(L)/4
   32    CONTINUE
C
         DO 41 I = 1,NIN
            VC(I) = VC(I)+VZ(K)*VTN(I)*WEI(K)
            DO 42 J = 1,I
               RMT(I,J)=RMT(I,J)+VTN(I)*VTN(J)*WEI(K)
   42       CONTINUE
   41    CONTINUE
   30 CONTINUE
C
      DO 51 I = 2,NIN
         DO 52 J=1,I-1
            RMT(J,I)=RMT(I,J)
   52    CONTINUE
   51 CONTINUE
C
      NCD= NIND
      CALL LISIB(RMT,VC,NIN,NCD,SIG)
      IF (NCD.GT.0) THEN
         VP(THREE) = VC(1)
         DO 71 I=1,NC
            VP(I*4) = VC(I)
   71    CONTINUE
C
         SQM=0.
         DO 81 I = 1,NP
            VG=0
            DO 82 J = 1,NC
               N = J*4
               DO 83 II = 1,MX(I)
                  XT = .5*PAS(II,MX(I))+IVX(I)
                  DO 84 JJ=1,MY(I)
                     YT  = .5*PAS(JJ,MY(I))+IVY(I)
                     EEE = ((VP(N+1)-XT)**2+(VP(N+2)-YT)**2)/
     2                     (VP(N+3)**2)
                     IF (BETA.LE.0.) THEN
                        VG = VG+H(II,MX(I))*H(JJ,MY(I))*VP(N)*
     *                       EXP(-EEE*4*ALOG(2.))
                     ELSE
                        VG = VG+H(II,MX(I))*H(JJ,MY(I))*VP(N)*
     2                       (1+EEE)**(-BETA)
                     END IF
   84             CONTINUE
   83          CONTINUE
   82       CONTINUE
C
            VG  = VG/4.+VP(THREE)
            SQM = SQM+(VZ(I)-VG)**2*WEI(I)
   81    CONTINUE
         SQM = SQM/(NP-NIN)
      END IF
      IF (NCD.LT.1) LG=1
      RETURN
      END


      SUBROUTINE ELMIX(IVX,IVY,VZ,NP,VP,FS,VPES,NC,BETA,SQM,LG,WEI,
     2                 SIG,MX,MY)
C+++
C.PURPOSE: MOFFAT o Gauss sigma fisso - piano orizzontale
C---
      IMPLICIT     NONE
      INTEGER      NST
      INTEGER      NIND
      PARAMETER    (NST=40)
      PARAMETER    (NIND=4*NST+3)
C
      INTEGER      IVX(1)
      INTEGER      IVY(1)
      REAL         VZ(1)
      INTEGER      NP
      REAL         VP(1)
      REAL         FS
      REAL         VPES(7)
      INTEGER      NC
      REAL         BETA
      REAL         SQM
      INTEGER      LG, THREE, TWO
      REAL         WEI(1)
      REAL         SIG
      INTEGER      MX(1),MY(1)
C
      REAL         RMT
      REAL         VTN, VC, VPI, VFU, VMO, VG, VTP
      REAL         XT, YT
      REAL         HH
      REAL         EPES, EP, EPE, EP2, EEE
      REAL         DIX, DIY
      REAL         CO
      INTEGER      N, NIN, N1, NCD
      INTEGER      INK, INK1
      INTEGER      I, J, K, L, LL
      INTEGER      II, JJ
      REAL         FK(NST)
      REAL         PAS(6,6),H(6,6)
C
      COMMON       /SUFR/RMT(NIND,NIND),VTN(NIND),VC(NIND)
      DATA  PAS/
     2   0.0,       0.0,       0.0,      0.0,      0.0,      0.0,     
     2  -0.577350,  0.577350,  0.0,      0.0,      0.0,      0.0,
     *  -0.774597,  0.0,       0.774597, 0.0,      0.0,      0.0,
     *  -0.861136, -0.339981,  0.339981, 0.861136, 0.0,      0.0,
     *  -0.906179, -0.538469,  0.0,      0.538469, 0.906179, 0.0,
     *  -0.932469, -0.661209, -0.238619, 0.238619, 0.661209, 0.932469/
      DATA   H/
     2  2.0,       0.0,       0.0,      0.0,      0.0,      0.0,
     3  1.0,       1.0,       0.0,      0.0,      0.0,      0.0,
     4  0.555555,  0.888889,  0.555555, 0.0,      0.0,      0.0,
     5  0.347855,  0.652145,  0.652145, 0.347855, 0.0,      0.0,
     6  0.236927,  0.478629,  0.568889, 0.478629, 0.236927, 0.0,
     7  0.171324,  0.360762,  0.467914, 0.467914, 0.360762, 0.171324/
C
C ***
      THREE = 3
      TWO = 2
      NIN = NC*3+3
      DO 10 I=1,NIN
         VC(I)=0
         DO 11 J=1,NIN
            RMT(I,J)=0
  11     CONTINUE
  10  CONTINUE
C
      DO 20 I=1,NC
         IF (BETA.LE.0.) THEN
            FK(I) = -4*ALOG(2.)/(VP(4*I+3)**2)
         ELSE
            FK(I) = 1./(VP(4*I+3)**2)
         END IF
   20 CONTINUE
C
      VTN(3)  = 1.
      DO 30 K=1,NP
         VTN(1) = IVX(K)
         VTN(2) = IVY(K)
         VPI    = VP(1)*IVX(K)+VP(TWO)*IVY(K)+VP(THREE)
         VFU=0.
         DO 31 LL=2,NIN
            VTN(LL)=0.
   31    CONTINUE
C
         DO 32 L=1,NC
            N  = L*3 + 1
            N1 = L*4
            DO 33 I = 1,MX(K)
               XT = 0.5*PAS(I,MX(K))+IVX(K)
               DO 34 J = 1,MY(K)
                  HH   = H(I,MX(K))*H(J,MY(K))
                  YT   = 0.5*PAS(J,MY(K))+IVY(K)
                  DIX  = XT-VP(N1+1)
                  DIY  = YT-VP(N1+2)
                  EPES = DIX*DIX+DIY*DIY
C
                  IF (BETA.LE.0) THEN
                     EP = EXP(EPES*FK(L))
                     CO = -VP(N1)*EP*2.*FK(L)
                  ELSE
                     EPE = 1.+EPES*FK(L)
                     EP  = EPE**(-BETA)
                     EP2 = EPE**(-BETA-1.)
                     CO  = VP(N1)*BETA*EP2*2*FK(L)
                  END IF
                  VTN(N)   = EP*HH+VTN(N)
                  VTN(N+1) = CO*DIX*HH+VTN(N+1)
                  VTN(N+2) = CO*DIY*HH+VTN(N+2)
                  VFU      = VP(N1)*EP*HH+VFU
   34          CONTINUE
   33       CONTINUE
            VTN(N)   = VTN(N)/4
            VTN(N+1) = VTN(N+1)/4
            VTN(N+2) = VTN(N+2)/4
   32    CONTINUE
C
         VFU = VFU/4+VPI
         DO 41 I = 1,NIN
            VTP   = VTN(I)*WEI(K)
            VC(I) = VC(I)+(VZ(K)-VFU)*VTP
            DO 42 J = 1,I
               RMT(I,J)=RMT(I,J)+VTN(J)*VTP
   42      CONTINUE
   41    CONTINUE
   30 CONTINUE
C
      DO 51 I = 2,NIN
         DO 52 J=1,I-1
            RMT(J,I)=RMT(I,J)
   52    CONTINUE
   51 CONTINUE
C
      DO 61 I=1,NIN
         RMT(I,I)=RMT(I,I)*(1+FS**2)
   61 CONTINUE
C
      NCD= NIND
      CALL LISIB(RMT,VC,NIN,NCD,SIG)
      IF (NCD.GT.0) THEN
         DO 70 I = 1,3
            VP(I) = VC(I)*VPES(I)*VP(I)
   70    CONTINUE
         DO 71 I=1,NC
            DO 72 J=4,6
               INK     = J+4*(I-1)
               INK1    = J+3*(I-1)
               VMO     = VC(INK1)*VPES(J)
               VP(INK) = VMO+VP(INK)
               IF (ABS(VP(INK)).GT.1000..AND.J.NE.4) NCD=-1
   72       CONTINUE
   71    CONTINUE
C
         IF (NCD.GT.0) THEN
            SQM=0.
            DO 81 I = 1,NP
               VG=0
               DO 82 J = 1,NC
                  N = J*4
                  DO 83 II = 1,MX(I)
                     XT = 0.5*PAS(II,MX(I))+IVX(I)
                     DO 84 JJ=1,MY(I)
                        YT  = .5*PAS(JJ,MY(I))+IVY(I)
                        EEE = ((VP(N+1)-XT)**2+(VP(N+2)-YT)**2)/
     2                        (VP(N+3)**2)
                        IF (BETA.LE.0.) THEN
                           VG = VG+H(II,MX(I))*H(JJ,MY(I))*VP(N)*
     *                          EXP(-EEE*4*ALOG(2.))
                        ELSE
                           VG = VG+H(II,MX(I))*H(JJ,MY(I))*VP(N)*
     2                          (1+EEE)**(-BETA)
                        END IF
   84                CONTINUE
   83             CONTINUE
   82          CONTINUE
C
               VG  = VG/4.+VP(1)*IVX(I)+VP(TWO)*IVY(I)+VP(THREE)
               SQM = SQM+(VZ(I)-VG)**2*WEI(I)
   81       CONTINUE
            SQM = SQM/(NP-NIN)
         END IF
      END IF
      IF (NCD.LT.1) LG=1
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2008 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM COPIER
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  program COPIER 
C  K. Banse 			ESO - Garching
C
C.KEYWORDS
C  copy, descriptors, keys
C
C.PURPOSE
C  copy objects from one MIDAS structure to another one
C  possible structures are: keyword, descriptor, image
C
C.ALGORITHM
C  use MIDAS interfaces to do the job
C
C.INPUT/OUTPUT
C  the following keywords are used:
C
C  ACTION/C/1/2		qualifier indicating the copy direction
C                    	= XY, for X -> Y copy
C                  	where X,Y any of K,D,I for key,descr,image
C
C  Pi/C/1/120		input/output object as object/type/1.elem./novals
C			or object only
C  i depends on type of copy, since descriptors need 2 tokens to be specified...
C
C.VERSIONS
C  
C  080322		last modif
C
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      BYTELA,BYTELB,CUNLEN
      INTEGER      FIRSTA,FIRSTB,IAV,ITYPE,KNEXT
      INTEGER      N,NN,NAXISA,NOVALA,NOVALB
      INTEGER*8    PNTRA,PNTRB
      INTEGER      PRGLVL,SIZE,STAT
      INTEGER      NPIXA(4),HNC
      INTEGER      IMNOA,IMNOB,FILESW,KBUF(4)
      INTEGER      UNIT(1),NULLO,MADRID(1)
C
      INTEGER      IBUF(8192)                          !data buffers
      REAL         RBUF(8192)
      CHARACTER    CBUF*32764
      DOUBLE PRECISION  DBUF(4096)
C
      CHARACTER    STRING*120,FRAMEA*120,FRAMEB*120
      CHARACTER    KEYA*15,KEYB*15,DSCRA*80,DSCRB*80
      CHARACTER    TYPEA*12,TYPEB*12,TYPEX*12
      CHARACTER    CUNITA*120,IDENTA*72
      CHARACTER    ACTION*4,PNEXT(3)*4,HTEXT*72
      CHARACTER    ERROR1*30,ERROR2*30
      CHARACTER    RECORD*120,ASCFIL*120,PP1*120,PP2*120
      CHARACTER    OBJA*120, OBJB*120
C
      DOUBLE PRECISION  STARTA(4),STEPA(4)             !=> STIGET,maxdim = 4
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      COMMON  /VMR/ MADRID
C
      DATA  PNEXT   /'P2  ','P3  ','P4  '/
      DATA  ERROR1  /'descriptor does not exist... '/
      DATA  ERROR2  /'key does not exist... '/
      DATA  NAXISA  /1/,   NPIXA  /4*1/
      DATA  STARTA  /4*0.D0/, STEPA /4*1.D0/
      DATA  IDENTA  /' '/,  CUNITA  /' '/
      DATA  OBJA    /' '/,  OBJB  /' '/
      DATA  FRAMEA  /' '/,  FRAMEB  /' '/, IMNOA /-1/
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C  get into MIDAS
      CALL STSPRO('COPIER')
      CALL STKRDI('MID$MODE',7,1,IAV,PRGLVL,UNIT,NULLO,STAT)   !save proc. level
      CALL STKRDI('PCOUNT',1,1,IAV,N,UNIT,NULLO,STAT)      !get parameter count
      FILESW = 0
      HNC = 0
C
C  get action
      KNEXT = 1
      CALL STKRDC('ACTION',1,1,4,IAV,ACTION,UNIT,NULLO,STAT)
      CALL UPCAS(ACTION,ACTION)
C 
C  check for list option - COPY/LSDD, /LSKD or /LSDK
      IF (ACTION(1:2).EQ. 'LS') THEN
         ACTION(1:2) = ACTION(3:4)             !shift copy_action
         CALL STKRDC('P1',1,1,120,IAV,ASCFIL,UNIT,NULLO,STAT)
         CALL STKRDC('P2',1,1,120,IAV,FRAMEA,UNIT,NULLO,STAT)
         IF (ACTION(1:2).EQ.'DD') THEN
            CALL STKRDC('P3',1,1,120,IAV,FRAMEB,UNIT,NULLO,STAT)
         ELSE
            FRAMEB(1:) = FRAMEA(1:)
         ENDIF
         CALL GENLGN(ASCFIL,CUNITA,118)             !handle LOGICAL:filename
         CUNITA(119:119) = ' '
         N = INDEX(CUNITA,' ') - 1
         OPEN(UNIT=33,FILE=CUNITA(1:N),STATUS='OLD',ERR=99000)
         FILESW = 1                       !indicate, that we have file input
      ELSE
         GOTO 180
      ENDIF
C 
C  reading loop for file input
100   RECORD(1:) = ' '
      READ(33,10000,END=95000) RECORD
      N = 1
      PP1(1:) = ' '                           !PP1, PP2 hold key/descriptor
      CALL EXTRSS(RECORD,' ',N,PP1,IAV)
      IF (IAV.LE.0) GOTO 100                  !skip empty records
      PP2(1:) = ' '
      CALL EXTRSS(RECORD,' ',N,PP2,IAV)
      IF (IAV.LE.0) PP2(1:) = PP1(1:)         !use same descriptor
C 
C                                                            !handle input
180   IF (ACTION(1:1).EQ.'D') THEN
         GOTO 1000
      ELSE IF (ACTION(1:1).EQ.'K') THEN
         GOTO 2000
      ELSE IF (ACTION(1:1).EQ.'I') THEN
         GOTO 5000
      ELSE IF (ACTION(1:1).EQ.'A') THEN
         GOTO 6000
      ELSE
         GOTO 90000
      ENDIF
C                                                            !handle output
200   IF (ACTION(2:2).EQ.'D') THEN
         GOTO 3000
      ELSE IF (ACTION(2:2).EQ.'K') THEN
         GOTO 4000
      ELSE IF (ACTION(2:2).EQ.'I') THEN
         GOTO 5500
      ELSE IF (ACTION(2:2).EQ.'A') THEN
         GOTO 7000
      ELSE
         GOTO 90000
      ENDIF
C ---
C
C  descriptor input...
C
C ---
1000  KNEXT = 2                              !descriptor input needs 2 params...
      IF (FILESW.NE.1) 
     +   CALL STKRDC('P1',1,1,120,IAV,FRAMEA,UNIT,NULLO,STAT)
      CALL CLNFRA(FRAMEA,FRAMEA,0)
      CALL STFINF(FRAMEA,9,KBUF,STAT) 
      IF (KBUF(2).EQ.F_TBL_TYPE) THEN
         CALL TBTOPN(FRAMEA,F_I_MODE,IMNOA,STAT)
      ELSE
         CALL STFOPN(FRAMEA,D_OLD_FORMAT,0,F_OLD_TYPE,IMNOA,STAT)
      ENDIF
      IF (FILESW.EQ.1) THEN
         STRING(1:) = PP1(1:)
      ELSE
         CALL STKRDC('P2',1,1,120,IAV,STRING,UNIT,NULLO,STAT)
         N = INDEX(STRING,',')               !check for list of descr.
         IF (N.GT.1) THEN                    !remove first descr + write back
            FILESW = 2
            DSCRA(1:) = STRING(N+1:)//' '
            CALL STKWRC('P2',1,DSCRA,1,80,UNIT,STAT)
            STRING(N:) = ' '
         ELSE
            FILESW = 0
         ENDIF
      ENDIF
      CALL EXTRA(1,STRING,DSCRA,TYPEA,FIRSTA,NOVALA,BYTELA)
      OBJA(1:) = DSCRA(1:)
C
C  check, if defaults are used...
      IF (TYPEA(1:1).NE.' ') THEN
         CALL STDFND(IMNOA,DSCRA,TYPEX,N,NN,STAT)
         CALL FULTYP(TYPEX,NN)
         IF (TYPEA.EQ.TYPEX) GOTO 1500              !same type, so that's o.k.
      ELSE
         CALL STDFND(IMNOA,DSCRA,TYPEA,NOVALA,BYTELA,STAT)
         IF (TYPEA(1:1).NE.' ') THEN
            CALL FULTYP(TYPEA,BYTELA)
            GOTO 1500
         ENDIF
      ENDIF
C 
C  Trouble ... descriptor not found or type mismatch
      N = INDEX(DSCRA,' ') - 1
      IF (N.LT.1) N = LEN(DSCRA)
      STRING(1:) = DSCRA(1:N)//': '//ERROR1
      CALL STTPUT(STRING,STAT)
      GOTO 90000
C
C  check types + lengths
1500  CALL LIMTST(TYPEA,NOVALA,BYTELA,ITYPE)
      GOTO (1600,1633,1666,1699,1622),ITYPE
      GOTO 89000                              !wrong type
C
C  read integer descr
1600  CALL STDRDI(IMNOA,DSCRA,FIRSTA,NOVALA,IAV,IBUF,UNIT,
     +            NULLO,STAT)
      GOTO 1700
C
C  read logical descr                        !use integer buffer
1622  CALL STDRDL(IMNOA,DSCRA,FIRSTA,NOVALA,IAV,IBUF,UNIT,
     +            NULLO,STAT)
      GOTO 1700
C
C  real descriptor
1633  CALL STDRDR(IMNOA,DSCRA,FIRSTA,NOVALA,IAV,RBUF,UNIT,
     +            NULLO,STAT)
      GOTO 1700
C
C  character descriptor
1666  CALL STDRDC(IMNOA,DSCRA,BYTELA,FIRSTA,NOVALA,IAV,CBUF,UNIT,
     +            NULLO,STAT)
      GOTO 1700
C
C  double precision descriptor
1699  CALL STDRDD(IMNOA,DSCRA,FIRSTA,NOVALA,IAV,DBUF,UNIT,
     +            NULLO,STAT)
C
1700  NOVALA = MIN(NOVALA,IAV)
      FIRSTA = 1                        !now input is stored from the beginning
      IF (ACTION(2:2).EQ.'I') THEN                    !define frame stuff,
         IDENTA(1:) = ' '                             !if we copy to image
         IDENTA(1:) = 'copy of descriptor '//DSCRA//
     +                'of frame '//FRAMEA
         NAXISA = 1
         NPIXA(1) = NOVALA
         CUNLEN = 32                              !for 1-dim frame
         STARTA(1) = 0.D0
         STEPA(1) = 1.D0
      ENDIF
C 
      CALL STDRDH(IMNOA,DSCRA,1,72,IAV,HTEXT,HNC,STAT)
      GOTO 200                              !go + work on output now
C ---
C
C  keyword input
C
C ---
2000  IF (FILESW.EQ.1) THEN
         STRING(1:) = PP1(1:)
      ELSE
         CALL STKRDC('P1',1,1,120,IAV,STRING,UNIT,NULLO,STAT)
         N = INDEX(STRING,',')               !check for list of keywords
         IF (N.GT.1) THEN                    !remove first descr + write back
            FILESW = 2
            DSCRA(1:) = STRING(N+1:)//' '
            CALL STKWRC('P1',1,DSCRA,1,80,UNIT,STAT)
            STRING(N:) = ' '
         ELSE
            FILESW = 0
         ENDIF
      ENDIF
      CALL EXTRA(1,STRING,KEYA,TYPEA,FIRSTA,NOVALA,BYTELA)
      N = PRGLVL - 1
      CALL STKWRI('MID$MODE',N,7,1,UNIT,STAT)       !necessary for local keys...
      OBJA(1:) = KEYA(1:)
C
C  check, if defaults are used...
      IF (TYPEA(1:1).NE.' ') THEN
         CALL STKFND(KEYA,TYPEX,N,NN,STAT)
         CALL FULTYP(TYPEX,NN)
         IF (TYPEA.EQ.TYPEX) GOTO 2500              !same type, so that's o.k.
      ELSE
         CALL STKFND(KEYA,TYPEA,NOVALA,BYTELA,STAT)
         IF (TYPEA(1:1).NE.' ') THEN
            CALL FULTYP(TYPEA,BYTELA)
            GOTO 2500
         ENDIF
      ENDIF
C 
C  key not found or type mismatch
      N = INDEX(KEYA,' ') - 1
      IF (N.LT.1) N = LEN(KEYA)
      STRING(1:) = KEYA(1:N)//': '//ERROR2
      CALL STTPUT(STRING,STAT)
      GOTO 90000
C
2500  CALL LIMTST(TYPEA,NOVALA,BYTELA,ITYPE)
      GOTO (2600,2633,2666,2699),ITYPE
      GOTO 89000                              !wrong type
C
C  read integer key
2600  CALL STKRDI(KEYA,FIRSTA,NOVALA,IAV,IBUF,UNIT,NULLO,STAT)
      GOTO 2700
C  real key
2633  CALL STKRDR(KEYA,FIRSTA,NOVALA,IAV,RBUF,UNIT,NULLO,STAT)
      GOTO 2700
C  character key
2666  CALL STKRDC(KEYA,BYTELA,FIRSTA,NOVALA,IAV,CBUF,UNIT,NULLO,STAT)
      GOTO 2700
C  double precision key
2699  CALL STKRDD(KEYA,FIRSTA,NOVALA,IAV,DBUF,UNIT,NULLO,STAT)
C
2700  NOVALA = MIN(IAV,NOVALA)
      FIRSTA = 1
      IF (ACTION(2:2).EQ.'I') THEN                !define frame stuff,
         IDENTA = 'copy of key '//KEYA//' '       !if we copy to image or mask...
         NPIXA(1) = NOVALA
         NAXISA = 1
         CUNLEN = 32                              !for 1-dim frame
         STARTA(1) = 0.D0
         STEPA(1) = 1.D0
      ENDIF
      CALL STKWRI('MID$MODE',PRGLVL,7,1,UNIT,STAT)    !reset procedure level
      GOTO 200                              !go + work on output now...
C ---
C
C  descriptor output...
C
C ---
3000  IF (FILESW.NE.1)
     +   CALL STKRDC(PNEXT(KNEXT),1,1,120,IAV,FRAMEB,UNIT,NULLO,STAT)
      CALL CLNFRA(FRAMEB,FRAMEB,0)
      CALL GENEQF(FRAMEA,FRAMEB,STAT)
      IF ((STAT.EQ.1).and.(IMNOA.NE.-1)) THEN 
         IMNOB = IMNOA               		 !if equal, use same IMNO
      ELSE
         CALL STFINF(FRAMEB,9,KBUF,STAT) 
         IF (KBUF(2).EQ.F_TBL_TYPE) THEN
            CALL TBTOPN(FRAMEB,F_IO_MODE,IMNOB,STAT)
         ELSE
            CALL STFOPN(FRAMEB,D_OLD_FORMAT,0,F_OLD_TYPE,IMNOB,STAT)
         ENDIF
      ENDIF
      IF (FILESW.EQ.1) THEN
         STRING(1:) = PP2(1:)
      ELSE
         CALL STKRDC(PNEXT(KNEXT+1),1,1,120,IAV,STRING,UNIT,NULLO,STAT)
         N = INDEX(STRING,',')               !check for list of descr.
         IF (N.GT.1) THEN                    !remove first descr + write back
            FILESW = 2
            DSCRB(1:) = STRING(N+1:)//' '
            CALL STKWRC(PNEXT(KNEXT+1),1,DSCRB,1,80,UNIT,STAT)
            STRING(N:) = ' '
         ELSE
            FILESW = 0
         ENDIF
      ENDIF
      CALL EXTRA(1,STRING,DSCRB,TYPEB,FIRSTB,NOVALB,BYTELB)
      OBJB(1:) = DSCRB(1:)
C
C  check types
      IF (TYPEB(1:1).EQ.' ') THEN            !see, if descriptor exists already
         CALL STDFND(IMNOB,DSCRB,TYPEB,NOVALB,BYTELB,STAT)
         IF (TYPEB(1:1).EQ.' ') THEN
            TYPEB = TYPEA
            NOVALB = NOVALA
            BYTELB = BYTELA
         ELSE
            CALL FULTYP(TYPEB,BYTELB)
         ENDIF
      ENDIF
C
C  handle the different type combinations
      IF ( (TYPEA(1:1).EQ.'C') .OR. (TYPEB(1:1).EQ.'C') ) THEN
         NOVALB = MIN(NOVALB,(NOVALA*BYTELA)/BYTELB)
         GOTO 3700                                 !copy character data...
      ENDIF
C 
      NOVALB = MIN(NOVALB,NOVALA)            !take minimum of both lengths
      IF ((TYPEA(1:1).EQ.'I') .OR. (TYPEA(1:1).EQ.'L')) GOTO 3100
      IF (TYPEA(1:1).EQ.'R') GOTO 3120
      IF (TYPEA(1:1).EQ.'D') GOTO 3130
      GOTO 89000                              !invalid type...
C
3100  IF ((TYPEB(1:1).EQ.'I').OR.(TYPEB(1:1).EQ.'L')) THEN
         GOTO 3400
      ELSE IF (TYPEB(1:1).EQ.'R') THEN
         CALL CC(7,DBUF,RBUF,IBUF,DBUF,RBUF,IBUF,FIRSTA,1,NOVALB)
         GOTO 3500
      ELSE IF (TYPEB(1:1).EQ.'D') THEN
         CALL CC(6,DBUF,RBUF,IBUF,DBUF,RBUF,IBUF,FIRSTA,1,NOVALB)
         GOTO 3600
      ELSE
         GOTO 89000                              !invalid type...
      ENDIF
C
3120  IF (TYPEB(1:1).EQ.'R') THEN
         GOTO 3500
      ELSE IF ((TYPEB(1:1).EQ.'I').OR.(TYPEB(1:1).EQ.'L')) THEN
         CALL CC(2,DBUF,RBUF,IBUF,DBUF,RBUF,IBUF,FIRSTA,1,NOVALB)
         GOTO 3400
      ELSE IF (TYPEB(1:1).EQ.'D') THEN
         CALL CC(4,DBUF,RBUF,IBUF,DBUF,RBUF,IBUF,FIRSTA,1,NOVALB)
         GOTO 3600
      ELSE
         GOTO 89000                              !invalid type...
      ENDIF
C
3130  IF (TYPEB(1:1).EQ.'D') THEN
         GOTO 3600
      ELSE IF ((TYPEB(1:1).EQ.'I').OR.(TYPEB(1:1).EQ.'L')) THEN
         CALL CC(12,DBUF,RBUF,IBUF,DBUF,RBUF,IBUF,FIRSTA,1,NOVALB)
         GOTO 3400
      ELSE IF (TYPEB(1:1).EQ.'R') THEN
         CALL CC(13,DBUF,RBUF,IBUF,DBUF,RBUF,IBUF,FIRSTA,1,NOVALB)
         GOTO 3500
      ELSE
         GOTO 89000                              !invalid type...
      ENDIF
C
C  write integer/logical descr
3400  IF (TYPEB(1:1).EQ.'I') THEN
         CALL STDWRI(IMNOB,DSCRB,IBUF,FIRSTB,NOVALB,UNIT,STAT)
      ELSE
         CALL STDWRL(IMNOB,DSCRB,IBUF,FIRSTB,NOVALB,UNIT,STAT)
      ENDIF
      GOTO 3990
C
C  real descriptor
3500  CALL STDWRR(IMNOB,DSCRB,RBUF,FIRSTB,NOVALB,UNIT,STAT)
      GOTO 3990
C
C  double precision descriptor
3600  CALL STDWRD(IMNOB,DSCRB,DBUF,FIRSTB,NOVALB,UNIT,STAT)
      GOTO 3990
C
C  character descriptor
3700  IF (TYPEA(1:1).NE.TYPEB(1:1)) THEN
         GOTO 89000
      ELSE
         CALL STDWRC(IMNOB,DSCRB,BYTELB,CBUF,FIRSTB,NOVALB,UNIT,STAT)
      ENDIF
3990  IF (HNC.GT.0) THEN
         CALL STDWRH(IMNOB,DSCRB,HTEXT,1,HNC,STAT)
         HNC = 0
      ENDIF
      GOTO 90000
C ---
C
C  keyword output
C
C ---
4000  IF (FILESW.EQ.1) THEN
         STRING(1:) = PP2(1:)
      ELSE
         CALL STKRDC(PNEXT(KNEXT),1,1,120,IAV,STRING,UNIT,NULLO,STAT)
         N = INDEX(STRING,',')               !check for list of descr.
         IF (N.GT.1) THEN                    !remove first descr + write back
            FILESW = 2
            DSCRB(1:) = STRING(N+1:)//' '
            CALL STKWRC(PNEXT(KNEXT),1,DSCRB,1,80,UNIT,STAT)
            STRING(N:) = ' '
         ELSE
            FILESW = 0
         ENDIF
      ENDIF
      CALL EXTRA(1,STRING,KEYB,TYPEB,FIRSTB,NOVALB,BYTELB)
      N = PRGLVL - 1
      CALL STKWRI('MID$MODE',N,7,1,UNIT,STAT)      !necessary for local keys...
      OBJB(1:) = KEYB(1:)
C
C  if only keyname, get related info via STKFND
      IF (TYPEB(1:1).EQ.' ') THEN
         CALL STKFND(KEYB,TYPEB,NOVALB,BYTELB,STAT)
         IF (TYPEB(1:1).EQ.' ') THEN
            N = INDEX(KEYB,' ') - 1
            IF (N.LT.1) N = LEN(KEYB)
            STRING(1:) = KEYB(1:N)//': '//ERROR2
            CALL STTPUT(STRING,STAT)
            GOTO 90000
         ELSE
            CALL FULTYP(TYPEB,BYTELB)
         ENDIF
      ENDIF
C
C  handle the different type combinations
      IF ( (TYPEA(1:1).EQ.'C') .OR. (TYPEB(1:1).EQ.'C') ) THEN
         NOVALB = MIN(NOVALB,(NOVALA*BYTELA)/BYTELB)
         GOTO 4700
      ENDIF
C
      NOVALB = MIN(NOVALB,NOVALA)
      IF ((TYPEA(1:1).EQ.'I').OR.(TYPEA(1:1).EQ.'L')) GOTO 4100
      IF (TYPEA(1:1).EQ.'R') GOTO 4120
      IF (TYPEA(1:1).EQ.'D') GOTO 4150
      GOTO 89000                              !invalid type...
C
4100  IF (TYPEB(1:1).EQ.'I') THEN
         GOTO 4400
      ELSE IF (TYPEB(1:1).EQ.'R') THEN
         CALL CC(7,DBUF,RBUF,IBUF,DBUF,RBUF,IBUF,FIRSTA,1,NOVALB)
         GOTO 4500
      ELSE IF (TYPEB(1:1).EQ.'D') THEN
         CALL CC(6,DBUF,RBUF,IBUF,DBUF,RBUF,IBUF,FIRSTA,1,NOVALB)
         GOTO 4600
      ELSE
         GOTO 89000                              !invalid type...
      ENDIF
C
4120  IF (TYPEB(1:1).EQ.'R') THEN
         GOTO 4500
      ELSE IF (TYPEB(1:1).EQ.'I') THEN
         CALL CC(2,DBUF,RBUF,IBUF,DBUF,RBUF,IBUF,FIRSTA,1,NOVALB)
         GOTO 4400
      ELSE IF (TYPEB(1:1).EQ.'D') THEN
         CALL CC(4,DBUF,RBUF,IBUF,DBUF,RBUF,IBUF,FIRSTA,1,NOVALB)
         GOTO 4600
      ELSE
         GOTO 89000                              !invalid type...
      ENDIF
C
4150  IF (TYPEB(1:1).EQ.'D') THEN
         GOTO 4600
      ELSE IF (TYPEB(1:1).EQ.'I') THEN
         CALL CC(12,DBUF,RBUF,IBUF,DBUF,RBUF,IBUF,FIRSTA,1,NOVALB)
         GOTO 4400
      ELSE IF (TYPEB(1:1).EQ.'R') THEN
         CALL CC(13,DBUF,RBUF,IBUF,DBUF,RBUF,IBUF,FIRSTA,1,NOVALB)
         GOTO 4500
      ELSE
         GOTO 89000                              !invalid type...
      ENDIF
C
C  write integer key
4400  CALL STKWRI(KEYB,IBUF,FIRSTB,NOVALB,UNIT,STAT)
      GOTO 90000
C
C  real key
4500  CALL STKWRR(KEYB,RBUF,FIRSTB,NOVALB,UNIT,STAT)
      GOTO 90000
C
C  double precision key
4600  CALL STKWRD(KEYB,DBUF,FIRSTB,NOVALB,UNIT,STAT)
      GOTO 90000
C
C  character key
4700  IF (TYPEA(1:1).NE.TYPEB(1:1)) THEN
         GOTO 89000
      ELSE
         CALL STKWRC(KEYB,BYTELB,CBUF,FIRSTB,NOVALB,UNIT,STAT)
         GOTO 90000
      ENDIF
C ---
C
C  image frame input
C
C ---
5000  CALL STKRDC('P1',1,1,120,IAV,STRING,UNIT,NULLO,STAT)
      CALL EXTRA(2,STRING,FRAMEA,TYPEA,FIRSTA,NOVALA,BYTELA)
      CALL CLNFRA(FRAMEA,FRAMEA,0)
      CALL STIGET(FRAMEA,D_R4_FORMAT,F_I_MODE,1,4,NAXISA,NPIXA,
     +            STARTA,STEPA,IDENTA,CUNITA,PNTRA,IMNOA,STAT)
      IF (TYPEA(1:1).EQ.' ') THEN                        !handle default
         NOVALA = 1
         DO 5050, N=1,NAXISA
            NOVALA = NOVALA * NPIXA(N)
5050     CONTINUE
      ENDIF
      CUNLEN = (NAXISA+1) * 16                  !compute length of CUNIT
C
C  check limits 
      CALL LIMTST('R',NOVALA,1,N)            !truncate, if necessary
      CALL CC(1,DBUF,MADRID(PNTRA),IBUF,DBUF,RBUF,IBUF,
     +        FIRSTA,1,NOVALA)
      TYPEA(1:) = 'R '
      GOTO 200                              !go + get destination object
C ---
C
C  image frame output
C
C ---
5500  CALL STKRDC(PNEXT(KNEXT),1,1,120,IAV,STRING,UNIT,NULLO,STAT)
      CALL EXTRA(2,STRING,FRAMEB,TYPEB,FIRSTB,NOVALB,BYTELB)
      CALL CLNFRA(FRAMEB,FRAMEB,0)
      IF (TYPEB(1:1).EQ.' ') THEN
         NOVALB = NOVALA
      ELSE
         NOVALB = MIN(NOVALA,NOVALB)
      ENDIF
C
C  create new image frame...
      IF (CUNLEN.LT.112) CUNITA(CUNLEN+1:) = ' '
      CALL STIPUT(FRAMEB,D_R4_FORMAT,F_O_MODE,1,NAXISA,NPIXA,STARTA,
     +            STEPA,IDENTA,CUNITA,PNTRB,IMNOB,STAT)
      SIZE = 1
      DO 5550, N=1,NAXISA
         SIZE = SIZE*NPIXA(N)
5550  CONTINUE
      IF (SIZE.GT.NOVALB) CALL ICLEAR(MADRID(PNTRB),SIZE)      !clear frame...
C
C  now proceed according to source input
      IF ((TYPEA(1:1).EQ.'I').OR.(TYPEA(1:1).EQ.'L')) THEN
         CALL CC(7,DBUF,RBUF,IBUF,DBUF,MADRID(PNTRB),IBUF,
     +           1,FIRSTB,NOVALB)
      ELSE IF (TYPEA(1:1).EQ.'R') THEN            !R -> R
         CALL CC(1,DBUF,RBUF,IBUF,DBUF,MADRID(PNTRB),IBUF,
     +           1,FIRSTB,NOVALB)
      ELSE IF (TYPEA(1:1).EQ.'D') THEN            !D -> R
         CALL CC(13,DBUF,RBUF,IBUF,DBUF,MADRID(PNTRB),IBUF,
     +           1,FIRSTB,NOVALB)
      ELSE
         GOTO 89000
      ENDIF
      GOTO 90000                        !goto common endpoint...
C ---
C
C  ASCII file input - only output to descr is supported
C
C ---
C 
6000  CALL STKRDC('P1',1,1,120,IAV,STRING,UNIT,NULLO,STAT)
      N = INDEX(STRING,' ') - 1
      IF (N.LE.0) N = LEN(STRING)
      CALL STKRDI('INPUTI',1,1,IAV,SIZE,UNIT,NULLO,STAT)   !get max length
      IF ((SIZE.LT.1) .OR. (SIZE.GT.100)) SIZE = 100
C 
C  first loop to get max. record size
      OPEN(UNIT=34,FILE=STRING(1:N),STATUS='OLD',ERR=98000)
      BYTELA = 1
      NOVALA = 0
6060  RECORD(1:) = ' '
      READ(34,10000,END=6300) RECORD
      DO 6260, N=100,1,-1
         IF (RECORD(N:N).NE.' ') THEN
            IF (N.GT.BYTELA) BYTELA = N           !no. of bytes per element
            GOTO 6060
         ENDIF
6260  CONTINUE
      GOTO 6060
C 
6300  REWIND(UNIT=34)                            !2nd loop - we really read
      IF (SIZE.GT.BYTELA) SIZE = BYTELA          !minimize byte count 
      IAV = SIZE - 1
      NN = 1
C 
6360  RECORD(1:) = ' '
      READ(34,10000,END=6600) RECORD(1:BYTELA)
      DO 6460, N=BYTELA,1,-1
         IF (RECORD(N:N).NE.' ') THEN
            NOVALB = N
            GOTO 6480
         ENDIF
6460  CONTINUE
      GOTO 6360
C 
6480  IF (NN.GT.32664) THEN
         CLOSE(UNIT=34)
         CALL STETER(3,'ASCII file too big ( > 32664 chars.) ...')
      ENDIF
C 
      IF (NOVALB.LE.SIZE) THEN
         CBUF(NN:NN+IAV) = RECORD(1:SIZE)
         NN = NN + SIZE
         NOVALA = NOVALA + 1
      ELSE
6490     CBUF(NN:NN+IAV) = RECORD(1:SIZE)
         NOVALA = NOVALA + 1
         NN = NN + SIZE
         NOVALB = NOVALB - SIZE
         IF (NOVALB.GT.0) THEN
            RECORD(1:) = RECORD(SIZE+1:)//' '        !fill with blanks
            GOTO 6490
         ENDIF
      ENDIF
      GOTO 6360
C
C  end-of-file reached
6600  BYTELA = SIZE
      CLOSE(UNIT=34)
C 
      TYPEA = 'C'
      GOTO 200
C ---
C
C  ASCII file output 
C
C ---
C
7000  IF (TYPEA(1:1).NE.'C') THEN
         NN = 1
         IF ((TYPEA(1:1).EQ.'I').OR.(TYPEA(1:1).EQ.'L')) THEN
            BYTELA = 10
            IAV = BYTELA - 1
            DO 7100, N=1,NOVALA
               WRITE(CBUF(NN:NN+IAV),20000) IBUF(N)
               NN = NN + BYTELA
7100        CONTINUE
         ELSEIF (TYPEA(1:1).EQ.'R') THEN
            BYTELA = 15
            IAV = BYTELA - 1
            DO 7200, N=1,NOVALA
               WRITE(CBUF(NN:NN+IAV),20001) RBUF(N)
               NN = NN + BYTELA
7200        CONTINUE
         ELSE
            BYTELA = 25
            IAV = BYTELA - 1
            DO 7300, N=1,NOVALA
               WRITE(CBUF(NN:NN+IAV),20002) DBUF(N)
               NN = NN + BYTELA
7300        CONTINUE
         ENDIF
      ENDIF
      CALL STKRDC('P3',1,1,120,IAV,STRING,UNIT,NULLO,STAT)
      N = INDEX(STRING,' ') - 1
      IF (N.LE.0) N = LEN(STRING)
      NN = 1
      OPEN(UNIT=34,FILE=STRING(1:N),STATUS='NEW',ERR=98000)
      IAV = BYTELA - 1
      NN = 1
      DO 7700, N=1,NOVALA
         WRITE(34,10000) CBUF(NN:NN+IAV)
         NN = NN + BYTELA
7700  CONTINUE
      CLOSE(UNIT=34)
C
      GOTO 90000                        !goto common endpoint...
C 
C  --------------------------------------------
C
C  types of input + output object don't match
C 
89000 N = INDEX(OBJA,' ') - 1
      IF (N.LT.1) N = LEN(OBJA)
      NN = INDEX(OBJB,' ') - 1
      IF (NN.LT.1) NN = LEN(OBJB)
      WRITE(STRING,10001) OBJA(1:N),OBJB(1:NN)
      CALL STTPUT(STRING,STAT)
C
C  we're done - unless we use the `list' option
C
90000 IF (FILESW.EQ.1) THEN
         GOTO 100
      ELSEIF (FILESW.EQ.2) THEN
         GOTO 180
      ENDIF
C 
      CALL STKWRI('MID$MODE',PRGLVL,7,1,UNIT,STAT)      !reset procedure level
      CALL STSEPI
C
C  file loop terminated
95000 CLOSE(UNIT=33)
      FILESW = 0
      GOTO 90000                        !terminate normally
C
C  file open error
98000 IF (NN.EQ.0) THEN
         RECORD(1:) = 'Problems opening ASCII file: '//STRING(1:N)
      ELSE
         RECORD(1:) = 'Problems creating ASCII file: '//STRING(1:N)
      ENDIF
      CALL STETER(1,RECORD)
C 
99000 RECORD(1:) = 'Problems with ASCII list: '//ASCFIL(1:)
      CALL STETER(1,RECORD)
C 
10000 FORMAT(A)
10001 FORMAT
     +('types of "',A,'" (input) + "',A,'" (output) do not match...')
20000 FORMAT(I10)
20001 FORMAT(E15.8)
20002 FORMAT(E25.12)
C 
      END

      SUBROUTINE FULTYP(TYPE,BYTVAL)
C
      IMPLICIT NONE
C
      INTEGER    BYTVAL
C
      CHARACTER*(*)  TYPE
C
      IF (TYPE(1:1).EQ.'C') THEN
         IF (BYTVAL.GT.1) THEN
            WRITE(TYPE,10100) BYTVAL                !build CHAR*00005
         ELSE
            TYPE(2:) = ' '
         ENDIF
      ELSE
         TYPE(2:) = ' '
      ENDIF
      RETURN
C 
10100 FORMAT('CHAR*',I5.5)
      END

      SUBROUTINE EXTRA(FLAG,STRING,NAME,TYPE,FIRST,NOVAL,BYTVAL)
C
      IMPLICIT NONE
C
      INTEGER    FLAG,FIRST,NOVAL,BYTVAL
      INTEGER    START,M,LL,SLEN
C 
C  TYPE is returned as 'I', 'R', 'D', 'C' or 'CHAR*nnnnn'
C
      CHARACTER*(*)  STRING,NAME,TYPE
      CHARACTER      CC*10
C
C  test, if default is used
      TYPE(1:) = ' '
      NAME(1:) = ' '                              !clear output name first
      LL = INDEX(STRING,'/')
      IF (LL.LE.0) THEN
         NAME(1:) = STRING(1:)
         FIRST = 1
         RETURN
      ENDIF
C
C  extract info
      START = 1
      CALL EXTRSS(STRING,'/',START,NAME,SLEN)
C 
      IF (FLAG.EQ.1) THEN                         !descr + key have type 
         CALL EXTRSS(STRING,'/',START,TYPE,SLEN)
         CALL UPCAS(TYPE,TYPE)
         IF (TYPE(1:1).EQ.'I') THEN
            BYTVAL = 4
            TYPE(2:) = ' '
         ELSE IF (TYPE(1:1).EQ.'R') THEN
            BYTVAL = 4
            M = INDEX(TYPE,'*')                   !look for R*8
            IF (M.GT.1) THEN
               M = M + 1
               CALL GENCNV(TYPE(M:),1,1,FIRST,FIRST,FIRST,SLEN)
               IF ((SLEN.EQ.1) .AND. (FIRST.EQ.8)) THEN
                  BYTVAL = 8
                  TYPE(1:1) = 'D'
               ENDIF
            ENDIF
            TYPE(2:) = ' '
         ELSE IF (TYPE(1:1).EQ.'D') THEN
            BYTVAL = 8
            TYPE(2:) = ' '
         ELSE IF (TYPE(1:1).EQ.'C') THEN
            M = INDEX(TYPE,'*')
            IF (M.GT.1) THEN
               M = M + 1
               CALL GENCNV(TYPE(M:),1,1,BYTVAL,BYTVAL,BYTVAL,SLEN)
               IF (SLEN.EQ.1) THEN
                  WRITE(TYPE,11000) BYTVAL
               ELSE
                  TYPE(1:1) = ' '
                  RETURN
               ENDIF
            ELSE
               BYTVAL = 1
               TYPE(2:) = ' '
            ENDIF
         ELSE
            TYPE(1:1) = ' '
            RETURN                                !no type there ...
         ENDIF
      ELSE
         TYPE(1:) = 'X '
      ENDIF
C 
      CALL EXTRSS(STRING,'/',START,CC,SLEN)
      IF (SLEN.GT.0)
     +   CALL GENCNV(CC,1,1,FIRST,FIRST,FIRST,SLEN)
      IF (SLEN.LE.0) GOTO 9000
      IF (FIRST.LE.0) FIRST = 1
C
      CALL EXTRSS(STRING,'/',START,CC,SLEN)
      IF (SLEN.GT.0)
     +   CALL GENCNV(CC,1,1,NOVAL,NOVAL,NOVAL,SLEN)
      IF ((SLEN.LE.0) .OR. (NOVAL.LE.0)) GOTO 9000
C
      RETURN
C
C  format errors
9000  CALL STETER(7,'wrong syntax... ')
      RETURN
C 
11000 FORMAT('CHAR*',I5.5)
      END

      SUBROUTINE LIMTST(TYPE,IVAL,BYTVAL,ITYPE)
C
      IMPLICIT NONE
C
      INTEGER     IVAL,BYTVAL,ITYPE,N,STAT
      INTEGER     LIMITS(5)
C
      CHARACTER*(*)   TYPE
      CHARACTER     MESSA*60,TT(5)*1
C
      DATA  LIMITS  /8192,8192,32764,4096,8192/
      DATA  TT      /'I','R','C','D','L'/
C
      IF (IVAL.LE.0)
     +   CALL STETER(2,'no. of elements < 1 ...')
C 
      DO 1520, N=1,5
         IF (TYPE(1:1).EQ.TT(N)) THEN
            ITYPE = N
            GOTO 1600
         ENDIF
1520  CONTINUE
      ITYPE = -1
      RETURN
C 
1600  IF (TYPE(1:1).EQ.'C') THEN
         N = IVAL * BYTVAL
         IF (LIMITS(ITYPE).LT.N) THEN
            IVAL = (LIMITS(ITYPE)/BYTVAL) * BYTVAL
            IF (IVAL.LE.0)
     +         CALL STETER(3,'nobytes per element too large ...')
            WRITE(MESSA,10010) IVAL,BYTVAL
            CALL STTPUT(MESSA,STAT)
         ENDIF
      ELSE
         IF (LIMITS(ITYPE).LT.IVAL) THEN
            IVAL = LIMITS(ITYPE)
            WRITE(MESSA,10000) IVAL
            CALL STTPUT(MESSA,STAT)
         ENDIF
      ENDIF
C
      RETURN
C
10000 FORMAT('no. of values truncated to ',I6)
10010 FORMAT('no. of values truncated to ',I6,' *',I5,' bytes')
      END

      SUBROUTINE CC(FLAG,DA,A,IA,DB,B,IB,FIRSTA,FIRSTB,NDIM)
C
      IMPLICIT NONE
C
      INTEGER      FLAG,FIRSTA,FIRSTB,NDIM
      INTEGER      IA(*),IB(*)
      INTEGER      OFFA,OFFB,I
C
C
      REAL         A(*),B(*)
C
      DOUBLE PRECISION   DA(*),DB(*)
C
C  branch according to FLAG:
C  1 = A -> B                           A: key, descr, image
C  2 = A -> IB                         IA: key, descr, LUT, ITT
C  4 = A -> DB                         DA: key
C                 12 = DA -> IB            - same for B -
C  6 = IA -> DB   13 = DA -> B
C  7 = IA -> B
C
      OFFA = FIRSTA - 1
      OFFB = FIRSTB - 1
      GOTO (100,200,9000,400,9000,600,700,
     +      9000,9000,9000,9000,1200,1300),FLAG
      GOTO 9000                                  !wrong option ...
C
C  copy A to B
100   DO 120, I=1,NDIM
         B(OFFB+I) = A(OFFA+I)
120   CONTINUE
      RETURN
C
C  copy A to IB
200   DO 220, I=1,NDIM
         IB(OFFB+I) = NINT(A(OFFA+I))
220   CONTINUE
      RETURN
C  copy A to DB
C 
400   DO 420, I=1,NDIM
         DB(OFFB+I) = A(OFFA+I)
420   CONTINUE
      RETURN
C
C  copy IA to DB
600   DO 620, I=1,NDIM
         DB(OFFB+I) = IA(OFFA+I)
620   CONTINUE
      RETURN
C
C  copy IA to B
700   DO 720, I=1,NDIM
         B(OFFB+I) = IA(OFFA+I)
720   CONTINUE
      RETURN
C
C  copy DA to IB
1200  DO 1220, I=1,NDIM
         IB(OFFB+I) = NINT(DA(OFFA+I))
1220  CONTINUE
      RETURN
C
C  copy DA to B
1300  DO 1320, I=1,NDIM
         B(OFFB+I) = DA(OFFA+I)
1320  CONTINUE
      RETURN
C
9000  RETURN
      END

      SUBROUTINE ICLEAR(A,NDIM)
C
      IMPLICIT NONE
C
      INTEGER     NDIM
      INTEGER     N
C
      REAL        A(NDIM)
C
      DO 100, N=1,NDIM
         A(N) = 0.
100   CONTINUE
C
      RETURN
      END

C @(#)usrinp.for	19.1 (ES0-DMD) 02/25/03 13:30:49
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE USRINP(A,N,TYPE,CHARST)                                        
C+++                                                                            
C.PURPOSE:  Decode a character string into integer or real array
C.AUTHOR:   J.P. Terlouw, Kapteynlab, Groningen
C.COMMENTS: none
C.VERSION:  ?????? RHW implementation
C.VERSION:  910115 RHW IMPLICIT NONE added
C---  
      IMPLICIT     NONE
      INTEGER      NR8
      PARAMETER    (NR8=512)                                           
      REAL         A(NR8)	
      INTEGER      N
      CHARACTER    TYPE
      CHARACTER    CHARST(72)
                                                                          
      INTEGER      MAXLP
      PARAMETER    (MAXLP=10)
C
      INTEGER      IREAL, ILOOP
      INTEGER      I, II
      INTEGER      IPOS, ITYPE
      INTEGER      IA, IIN                                                      
      INTEGER      NREAL
      INTEGER      NI, NLOOP
      INTEGER      NCH, NREST
      INTEGER      NWORD, INSERT
      INTEGER      DOLOOP(2,MAXLP)
      INTEGER      NEL
      REAL         AA
      REAL         B8(NR8)
      REAL         INCR
      REAL         LOW                                      
      REAL         RA                                                    
      REAL         UPP
      LOGICAL      LOOP,SEP,ERR                                                 
      CHARACTER    B1(72)                                            
      CHARACTER    ATYPE(2),LPSYM                                          
      EXTERNAL     NEL	
C                                                                               
      EQUIVALENCE  (RA,IA,AA)                                                   
      DATA         ATYPE/'R','I'/                                               
C
C ***
      ERR    = .FALSE.               ! error in do-loop                         
      LPSYM  = ':'                   ! loop symbol                              
      NI     = 0                     ! initial number of used words for array   
      IPOS   = 0                     ! starting for array pointer               
      ITYPE  = 1                     ! default type is real                     
                                                                                
      DO 10 I = 1,72                                                            
         B1(I)  = ' '                                                           
   10 CONTINUE                                                                  
      CALL ALPHA(CHARST,72,NCH,NREST)                                           
                                                                                
      DO 20 II = 1,NCH                                                          
         B1(II) = CHARST(II)                                                    
   20 CONTINUE                                                                  
                                                                                
      DO 30 I = 1,2                                                             
         IF (TYPE.EQ.ATYPE(I)) THEN                                 ! what type?
            ITYPE  = I                                                          
         END IF                                                                 
   30 CONTINUE                                                                  
C                                                                               
C *** GET INPUT PARAMETERS IF PRESENT                                           
C                                                                               
      IF (NCH.NE.0) THEN                                                        
         ERR    = .FALSE.                                     ! reset error flag
         NLOOP  = 0                                                             
         IF ((ITYPE.EQ.1) .OR. (ITYPE.EQ.3)) THEN                  ! decode loop
            DO 40 I = 1,MAXLP                                                   
               DOLOOP(1,I) = 0                                                  
               DOLOOP(2,I) = 0                                                  
   40       CONTINUE                                                            
            NLOOP  = 1                                                          
            NWORD  = 1                              ! startword of do-loop in b1
            INSERT = 0                                                          
            LOOP   = .FALSE.                                                    
            SEP    = .TRUE.                                                     
            DO 50 I = 1,NCH                                                     
               IF (B1(I).EQ.LPSYM) THEN                                         
                  IF (B1(I-1).EQ.' ' .OR. B1(I+1).EQ.' ') THEN      ! bad syntax
                     ERR    = .TRUE.                                            
                     GO TO 60                                                   
                  END IF                                                        
                  IF (DOLOOP(2,NLOOP).EQ.1) THEN                                
                     DOLOOP(2,NLOOP) = 2               ! increment value present
                     INSERT = INSERT + 1                                        
                                                                                
                  ELSE IF (DOLOOP(2,NLOOP).EQ.2) THEN                           
                     ERR    = .TRUE.             ! error in do-loop input string
                     NCH    = 0                                                 
                     GO TO 60                                     ! back to inpu
                  ELSE                                     ! upper value present
                     DOLOOP(1,NLOOP) = NWORD + INSERT                           
                     DOLOOP(2,NLOOP) = 1                                        
                     INSERT = INSERT + 1                                        
                  END IF                                                        
                                                                                
                  LOOP   = .TRUE.                                               
                  B1(I)  = ','                                                  
                                                                                
               ELSE                                                             
                  IF (B1(I).EQ.' ' .OR. B1(I).EQ.',') THEN        ! sep. symbols
                                                                                
                     IF ( .NOT. SEP) THEN                                       
                        NWORD  = NWORD + 1                                      
                        SEP    = .TRUE.                                         
                     END IF                                                     
C                                                                               
                     IF (LOOP) THEN                                             
                        NLOOP  = NLOOP + 1                                      
                        LOOP   = .FALSE.                                        
                     END IF                                                     
                                                                                
                  ELSE                                                          
                     SEP    = .FALSE.                                           
                  END IF                                                        
               END IF                                                           
   50       CONTINUE                                                            
C                                                                               
   60       CONTINUE                                                            
            IF ((.NOT.LOOP) .AND. (.NOT.ERR)) THEN                              
               NLOOP  = NLOOP - 1                                               
            END IF                                                              
         END IF                                                                 
      END IF                                                                    
C                                                                               
      IF ((NCH.GT.0) .AND. (.NOT.ERR)) THEN    ! decode input into real or char.
         CALL DECUSR(B1,NCH,B8,NR8)           ! decodes input array into b8(nr8)
         NI     = NEL(B8,NR8)         ! actual number of words (=array elements)
      END IF                                                                    
C                                                                               
C  *** CONSTRUCT THE OUTPUT ARRAY ************************************          
C                                                                               
      IPOS   = 0   ! position in a                                              
      ILOOP  = 1   ! next loop (if present)                                     
      IIN    = 0   ! position in b8                                             
                                                                                
      IF (NI.GT.0) THEN                                                         
   70    CONTINUE                                                               
         IIN    = IIN + 1                                                       
         RA     = B8(IIN)                                                       
         IF (ITYPE.EQ.3) THEN                          ! real+integer conversion
            IA     = NINT(RA)                                                   
         END IF                                                                 
         IF (IPOS+1.LE.N) THEN                ! conversion if ipos+1<# array el.
            A(IPOS+1) = RA                                                      
         END IF                                                                 
         IPOS   = IPOS + 1                            ! increase position by one
                                                                                
         IF (IIN.EQ.DOLOOP(1,ILOOP)) THEN                                       
            LOW    = B8(IIN)                                                    
            IIN    = IIN + 1                                                    
            UPP    = B8(IIN)                                                    
            IF (DOLOOP(2,ILOOP).EQ.1) THEN              ! no increment was given
               INCR   = 1.                                                      
            ELSE                                                                
               IIN    = IIN + 1                                                 
               INCR   = B8(IIN)                                                 
            END IF                                                              
            AA     = ((UPP-LOW)/INCR)              ! # of reals to be added in A
            NREAL  = ANINT(AA)                                                  
                                                                                
            IF (NREAL.GT.0) THEN                                                
               DO 80 IREAL = 1,NREAL                                            
                  LOW    = LOW + INCR                                           
                  RA     = LOW                                                  
                  IF (ITYPE.EQ.3) THEN                ! real+integer conversion 
                     IA     = NINT(RA)                                          
                  END IF                                                        
                  IF (IPOS+1.LE.N) THEN       ! conversion if ipos+1<# array el.
                     A(IPOS+1) = RA                                             
                  END IF                                                        
                  IPOS   = IPOS + 1                   ! increase position by one
   80         CONTINUE                                                          
            END IF                                                              
            ILOOP  = ILOOP + 1                                                  
         END IF                                                                 
                                                                                
         IF (IIN.LT.NI) GO TO 70                                                
      END IF                                                                    
C                                                                               
      IF (IPOS.LT.N) THEN                                                       
         CALL SETEND(A(IPOS+1))                                                 
      END IF                                                                    
                                                                                
      RETURN                                                                    
      END                                                                       



      SUBROUTINE DECUSR(SS,L,ARRAY,NIN)                                         
C+++                                                                            
C.PURPOSE:  Subroutine to decode input string into a real array
C.AUTHOR:   J.P. Terlouw, Kapteynlab Groningen
C.COMMENTS: none
C.VERSION:  87???? RHW adjustments for and implementation in MIDAS
C.VERSION:  910115 RHW IMPLICIT NONE added
C---                                                                            
      IMPLICIT   NONE
      INTEGER    L                            ! IN: length of character string
      CHARACTER  SS(L)                        ! IN: character string
      REAL       ARRAY(50)                    ! OUT: real array  
      INTEGER    NIN                          ! OUT: length of the array
C
      INTEGER    IPOINT, IEPOW, ISIGN
      INTEGER    I, II, IARR, IFMT
      INTEGER    J
      INTEGER    NOUT, N1 
      INTEGER    LF, LD
      REAL       ENDLN
C
      CHARACTER  FMT*150,SSS*150                                                
      LOGICAL    REAL,EPOW,SIGN,CHAR,SEP                                        
                                                                                
 9000 FORMAT ('A',I1)                                                           
 9010 FORMAT (I2.2,'X')                                                         
 9020 FORMAT ('F',I2.2,'.',I2.2)                                                
C                                                                               
C *** start                                                                     
      REAL   = .FALSE.                                                          
      EPOW   = .FALSE.                                                          
      SIGN   = .FALSE.                                                          
      CHAR   = .FALSE.                                                          
      SEP    = .TRUE.                                                           
      IPOINT = 0                                                                
      IEPOW  = 0                                                                
      ISIGN  = 0                                                                
C                                                                               
      DO 10 II = 1,L                          !  put ss(1 --> l) into sss(1:l)  
         SSS(II:II) = SS(II)                                                    
   10 CONTINUE                                                                  
      DO 20 II = L + 1,150                                                      
         SSS(II:II) = ' '                                                       
   20 CONTINUE                                                                  
C                                                                               
      I      = 1                                 !   index used for ss(1 ---> l)
      NOUT   = 0                                !  # of elements filled in array
      FMT(1:1) = '('                                                            
      IFMT   = 2                                                                
      N1     = 1                                !   first position of next field
      CALL SETEND(ENDLN)                                                        
      DO 30 IARR = 1,NIN                                                        
         ARRAY(IARR) = ENDLN                                                    
   30 CONTINUE                                                                  
C                                                                               
   40 CONTINUE                                                                  
      IF (I.LE.L .AND. NOUT.LT.NIN) THEN                                        
         IF (SS(I).EQ.' ' .OR. SS(I).EQ.',' .OR. SS(I).EQ.':') THEN             
            IF ( .NOT. SEP) THEN                                                
               LF     = I - N1                              !   character string
               IF (CHAR) THEN                                                   
                  LF     = MIN(((NIN-NOUT)*1),LF)         !   max space in array
   50             CONTINUE                                                      
                  IF (LF.GT.0) THEN                                             
                     WRITE (FMT(IFMT:IFMT+1),9000) MIN(1,LF)                    
                     LF     = LF - 1                                            
                     IFMT   = IFMT + 2                                          
                     FMT(IFMT:IFMT) = ','                                       
                     IFMT   = IFMT + 1                                          
                     NOUT   = NOUT + 1                                          
                     GO TO 50                                                   
                  END IF                                                        
                                                                                
               ELSE                                                             
                  IF (IEPOW.EQ.0) THEN                                          
                     IEPOW  = I                                                 
                  END IF                                                        
                                                                                
                  IF (IPOINT.EQ.0) THEN                                         
                     IPOINT = I                                                 
                  END IF                                                        
                                                                                
                  LD     = MAX((IEPOW-IPOINT-1),0)                              
                  WRITE (FMT(IFMT:IFMT+5),9020) LF,LD                           
                  IFMT   = IFMT + 6                                             
                  FMT(IFMT:IFMT) = ','                                          
                  IFMT   = IFMT + 1                                             
                  NOUT   = NOUT + 1                                             
               END IF                                                           
                                                                                
               N1     = I                                                       
C                                                                               
               REAL   = .FALSE.                                                 
               EPOW   = .FALSE.                                                 
               SIGN   = .FALSE.                                                 
               CHAR   = .FALSE.                                                 
               SEP    = .TRUE.                                                  
               IPOINT = 0                                                       
               IEPOW  = 0                                                       
               ISIGN  = 0                                                       
            END IF                                                              
                                                                                
         ELSE                                                                   
            IF (SEP) THEN                                                       
               LF     = I - N1                                                  
               IF (LF.GT.0) THEN                                                
                  WRITE (FMT(IFMT:IFMT+2),9010) LF                              
                  IFMT   = IFMT + 3                                             
                  FMT(IFMT:IFMT) = ','                                          
                  IFMT   = IFMT + 1                                             
               END IF                                                           
               N1     = I                                                       
C                                                                               
C *** input element is real                                                     
               IF (SS(I).GE.'0' .AND. SS(I).LE.'9' .OR. SS(I).EQ.               
     +            '+' .OR. SS(I).EQ.'-') THEN                                   
                  REAL   = .TRUE.                                               
               ELSE                                                             
                  IF (SS(I).EQ.'.') THEN                       !   decimal point
                     REAL   = .TRUE.                                            
                     IPOINT = I                                                 
                  ELSE                                                          
                     CHAR   = .TRUE.               !  input element is character
                  END IF                                                        
               END IF                                                           
               SEP    = .FALSE.                                                 
                                                                                
            ELSE                                                                
               IF ( .NOT. CHAR) THEN                                            
                  IF (EPOW) THEN                                                
                     IF ( .NOT. SIGN) THEN                                      
                        IF (SS(I).EQ.'+' .OR. SS(I).EQ.'-') THEN                
                           ISIGN  = 1                                           
                           SIGN   = .TRUE.                                      
                        ELSE                                                    
                           IF (SS(I).GE.'0' .AND. SS(I).LE.'9') THEN            
                              SIGN   = .TRUE.                                   
                           ELSE                                                 
                              CHAR   = .TRUE.                                   
                           END IF                                               
                        END IF                                                  
                                                                                
                     ELSE                                                       
                        IF (SS(I).LT.'0' .OR. SS(I).GT.'9' .OR.                 
     +                     ((IEPOW+ISIGN+2).LT.I)) THEN                         
                           CHAR   = .TRUE.                                      
                        END IF                                                  
                     END IF                                                     
                                                                                
                  ELSE                                                          
                     IF (SS(I).EQ.'E') THEN                                     
                        EPOW   = .TRUE.                                         
                        IEPOW  = I                                              
                                                                                
                     ELSE                                                       
                        IF (SS(I).EQ.'.') THEN                                  
                           IF (IPOINT.GT.0) THEN                                
                              CHAR   = .TRUE.                                   
                           ELSE                                                 
                              IPOINT = I                                        
                           END IF                                               
                        ELSE                                                    
                           IF (SS(I).LT.'0' .OR. SS(I).GT.'9') THEN             
                              CHAR   = .TRUE.                                   
                           END IF                                               
                        END IF                                                  
                     END IF                                                     
                  END IF                                                        
               END IF                                                           
            END IF                                                              
         END IF                                                                 
                                                                                
         I      = I + 1                                                         
         GO TO 40                                                               
      END IF                                                                    
C                                                                               
      IF (I.GT.N1) THEN                                                         
         IF ( .NOT. SEP) THEN                                                   
            LF     = I - N1                                                     
            IF (CHAR) THEN                                  !   character string
               LF     = MIN(((NIN-NOUT)*1),LF)            !   max space in array
   60          CONTINUE                                                         
               IF (LF.GT.0) THEN                                                
                  WRITE (FMT(IFMT:IFMT+1),9000) MIN(1,LF)                       
                  LF     = LF - 1                                               
                  IFMT   = IFMT + 2                                             
                  FMT(IFMT:IFMT) = ','                                          
                  IFMT   = IFMT + 1                                             
                  NOUT   = NOUT + 1                                             
                  GO TO 60                                                      
               END IF                                                           
                                                                                
            ELSE                                                                
               IF (IEPOW.EQ.0) THEN                                             
                  IEPOW  = I                                                    
               END IF                                                           
                                                                                
               IF (IPOINT.EQ.0) THEN                                            
                  IPOINT = I                                                    
               END IF                                                           
                                                                                
               LD     = MAX((IEPOW-IPOINT-1),0)                                 
               WRITE (FMT(IFMT:IFMT+5),9020) LF,LD                              
               IFMT   = IFMT + 6                                                
               FMT(IFMT:IFMT) = ','                                             
               IFMT   = IFMT + 1                                                
               NOUT   = NOUT + 1                                                
            END IF                                                              
                                                                                
            N1     = I                                                          
         END IF                                                                 
      END IF                                                                    
C                                                                               
      FMT(IFMT-1:IFMT-1) = ')'                                                  
      IF (NOUT.GT.0) THEN                                                       
          READ (SSS(1:L),FMT=FMT(1:IFMT-1)) (ARRAY(J),J=1,NOUT)                 
      END IF                                                                    
C                                                                               
      RETURN                                                                    
      END                                                                       



      INTEGER FUNCTION NEL(A,N)
C+++
C.PURPOSE:  Count the number of words in the input array of dimension
C           N by testing the array on -0 value
C.AUTHOR:   Rein H. Warmels
C.COMMENTS: none
C.VERSION:  890117 RHW Documented
C.VERSION:  910115 RHW IMPLICIT NONE added
C---
      IMPLICIT NONE
      INTEGER  N
      REAL     A(N)
C
      INTEGER  I 
      REAL     END
C
      DATA     END/-32768/
C
C ***
      DO 10 I = 1,N
         IF (A(I).EQ.END) THEN
            GO TO 20
        END IF
   10 CONTINUE

   20 CONTINUE
      NEL    = I - 1

      RETURN
      END



      SUBROUTINE SETEND(X)                                                      
C+++                                                                            
C.PURPOSE:  put an end of array word in X    
C.COMMENTS: none
C.VERSION:  910115 RHW IMPLICIT NONE added
C---                                                                            
      REAL   X
C
      REAL   END	
      DATA   END/-32768/
C
C ***
      X      = END                                                              
                                                                                
      RETURN                                                                    
      END                                                                       
      SUBROUTINE ALPHA(A,LENGTH,NCHAR,NREST)
C+++                                        
C.PURPOSE:  Alphanumeric handling routine
C.AUTHOR:   Rein H. Warmels
C.COMMENTS: none
C.VERSION:  87???? RHW  creation
C.VERSION:  910115 RHW  IMPLICIT NONE added
C---
      IMPLICIT     NONE
      CHARACTER*(*) A                  ! IN: input array of dimension n        
      INTEGER      LENGTH              ! IN: max length of the character string
      INTEGER      NCHAR               ! OUT: number of actual characters
      INTEGER      NREST               ! OUT: number of remaining characters
C
      CHARACTER    X
      INTEGER      I
C
C***
      NCHAR  = 0 
      DO 10 I = 1,LENGTH 
         X      = A(LENGTH-I+1:LENGTH-I+1)
         IF (X.NE.' ') THEN 
            NCHAR  = LENGTH + 1 - I 
            NREST  = LENGTH - NCHAR
            RETURN
         END IF
   10 CONTINUE 
      RETURN 
      END

C===========================================================================
C Copyright (C) 1995-2007 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FTDDVI(NAME,MASK,ISTAT)                                        
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:25 - 13 JAN 1988                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C.IDENTIFICATION                                                                
C                                                                               
C  FITLIB.FOR   VERSION 1.0  27 MAR 1984                                        
C                                                                               
C.PURPOSE                                                                       
C                                                                               
C  INTERFACE ROUTINES FOR THE FITTING STRUCTURES                                
C DEFINE NEW DEPENDENT VARIABLE FOR OUTPUT                                      
C DEPENDENT VARIABLE IS THE IMAGE DATA                                          
C INDEPENDENT VARIABLES ARE IMAGE AXES ALREADY DEFINED                          
C                                                                               
C.ALGORITHM                                                                     
C                                                                               
C  USE MIDAS I/O INTERFACES TO FRAMES AND TABLES                                
C                                                                               
C.KEYWORDS                                                                      
C                                                                               
C  NON LINEAR FITTING                                                           
C                                                                               
C.VERSION
C 071015	last modif
C                                                                               
C----------------------------------------------------------------               
C                                                                               
C                                                                               
C INPUT PARAMETERS                                                              
C NAME CHAR IMAGE NAME                                                          
C MASK CHAR OPTIONAL WEIGHTING MASK                                             
C   BLANKS IF NOT USED                                                          
C                                                                               
C OUTPUT PARAMETERS                                                             
C ISTAT INTG STATUS RETURN                                                      
C                                                                               
      IMPLICIT NONE                                                            

      CHARACTER*(*) NAME,MASK                                                   
      CHARACTER UNIT*72,IDENT*72                                                
C
      INTEGER   ISTAT, J
      INTEGER*8   IPTR
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC/NOLIST'  
      INCLUDE 'MID_INCLUDE:FITI.INC/NOLIST'   
      INCLUDE 'MID_INCLUDE:FITC.INC/NOLIST'  
      INCLUDE 'MID_INCLUDE:ST_DAT.INC/NOLIST' 
C                                                                               
C CREATE OPTIONAL MASK                                                          
C                                                                               
      UNIT = ' '
      IF (MASK(1:1).EQ.' ') THEN                                                
          FZPTRM = 0                                                          
      ELSE                                                                      
          IDENT  = ' WEIGHT MASK '                                              
          CALL STIPUT(MASK,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .     FZNAXIS,FZNPIX,FZSTART,FZSTEP,IDENT,         
     .            UNIT,IPTR,FZIDEN,ISTAT) 
          FZPTRM = IPTR                                                       
      END IF                                                                    
C                                                                               
C Write image                                                                   
C                                                                               
      IDENT  = ' FITTED IMAGE'                                                  
      CALL STIPUT(NAME,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .     FZNAXIS,FZNPIX,FZSTART,FZSTEP,IDENT,         
     .            UNIT,IPTR,FZIDEN,ISTAT)  
      FZPTRI = IPTR                                                           
C                                                                               
C Change variables in the COMMON area                                           
C                                                                               
      FZNAME = NAME                                                           
      FZTYPE = 'BDF '                                                         
      FZMAPPED = 1                                                            
      RETURN                                                                    
      END    

C @(#)tsatab.for	19.1 (ES0-DMD) 02/25/03 13:33:26
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C  @(#)tsatab.for	5.1 (ESO-IPG) 4/5/93 15:58:45
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT (c) 1992 European Southern Observatory & Copernicus Astron. Center
C.IDENT     tsatab.for
C.AUTHOR    Alex Schwarzenberg-Czerny, Copernicus Astron. Center, Warsaw
C.KEYWORD   MIDAS, time series, TABLE/TSA
C.LANGUAGE  FORTRAN 77
C.PURPOSE   Create a MIDAS table from an ASCII file
C           More flexible than CREATE/TABLE
C.VERSION   0.0               June 1992
C.RETURNS   None
C.ENVIRON   TSA context
C-----------------------------------------------------------------------------
C
C
      INCLUDE 'MID_REL_INCL:TSA_DEF.INC'
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      CHARACTER*60 INAME                !  NAME OF ASCII TABLE
      CHARACTER*60 ONAME                !  NAME OF MIDAS TABLE
      CHARACTER*1  TYPE                 !  TYPE OF CONVERDSION (R,D,I)
      INTEGER      MXCOL                !  MAXIMUM NUMBER OF COLUMNS
      INTEGER      LENCH                !  EXTERNAL FUNCTION
C
      INTEGER      MAXCOL
      PARAMETER    (MAXCOL=99)
      INTEGER      IVAL(MAXCOL),IDCOL(MAXCOL)
      REAL*4       RVAL(MAXCOL)
      REAL*8       DVAL(MAXCOL)
      INTEGER      NROW,IROW,NCOL,ICOL,I,NCOLOLD
      INTEGER      MXPRINT,IPRINT,LENGTH,JSTAT
      INTEGER      IACTS, KUN,   KNUL, D_FORMAT
      INTEGER      OTID
      CHARACTER*132 LINE
      CHARACTER*10  FORM,LABEL
C
      INCLUDE 'MID_REL_INCL:TSA_DAT.INC'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C   Get parameters
C
      CALL STSPRO ('timtab')
      CALL STKRDC ('IN_A',  1,1,60,IACTS,INAME,KUN,KNUL,ISTAT)
      CALL STKRDC ('OUT_A', 1,1,60,IACTS,ONAME,KUN,KNUL,ISTAT)
      CALL STKRDC ('TYPE',  1,1, 1,IACTS,TYPE, KUN,KNUL,ISTAT)
      CALL STKRDI ('MXCOL', 1,1,   IACTS,MXCOL,KUN,KNUL,ISTAT)
      IF (MXCOL.GT.MAXCOL) THEN
        MXCOL=MAXCOL
        WRITE(LINE,'(a,i5)') 'Max column number trimmed to',MXCOL
        CALL STTPUT(LINE(1:LENCH(LINE)),ISTAT)
      ENDIF
C
C   Get format of input table: first open file, ...
C
      INAME=INAME(1:LENCH(INAME))//'.dat'
      OPEN(1,FILE=INAME(1:LENCH(INAME)),
     $   STATUS='OLD',ACCESS='SEQUENTIAL',FORM='FORMATTED')
      IF (ISTAT.NE.0) THEN
        CALL STETER(1,'Wrong name or other input file attributes')
      ENDIF
C
C   ... than scan each line, ...
C
      MXPRINT=10
      IPRINT=0
      NCOLOLD=0
      NROW=0
 1    CONTINUE
        READ(1,'(A)',IOSTAT=JSTAT) LINE
        LENGTH=LENCH(LINE)
C
C   ... and find number of columns by trial-and-error
C
          NCOL=0
          DO 2 ICOL=1,MXCOL
            IF (TYPE.EQ.'R') THEN
              READ(LINE(1:LENGTH),*,IOSTAT=ISTAT)
     $            (RVAL(I),I=1,ICOL)
            ELSEIF (TYPE.EQ.'D') THEN
              READ(LINE(1:LENGTH),*,IOSTAT=ISTAT)
     $            (DVAL(I),I=1,ICOL)
            ELSEIF (TYPE.EQ.'I') THEN
              READ(LINE(1:LENGTH),*,IOSTAT=ISTAT)
     $            (IVAL(I),I=1,ICOL)
            ELSE
              CALL STETER(2,'Wrong conversion type (must be R or D)')
            ENDIF
            IF (ISTAT.EQ.0) THEN
              NCOL=ICOL
            ELSE
C   Break loop 2
              GOTO 29
            ENDIF
 2        CONTINUE
C
C   Do some check on consistency of valid lines with the first valid line
C
 29       IF (NCOL.GT.0) THEN
            IF (NCOLOLD.EQ.0) THEN
              NCOLOLD=NCOL
            ENDIF
            IF (NCOLOLD.NE.NCOL) THEN
              IF (IPRINT.LE.MXPRINT) THEN
                CALL STTPUT(LINE(1:LENGTH),ISTAT)
                WRITE(LINE,'(A,I10)')
     $ 'Column inconsistency near row',NROW
                CALL STTPUT(LINE(1:LENGTH),ISTAT)
                IPRINT=IPRINT+1
              ENDIF
            ELSE
              NROW=NROW+1
            ENDIF
          ELSE
            CALL STTPUT(LINE(1:LENCH(LINE)),ISTAT)
          ENDIF
        IF (JSTAT.EQ.0) THEN
          GOTO 1
        ENDIF
      NCOL=NCOLOLD
C
C   Test for some errors
C
      IF (JSTAT.GT.0) THEN
         CALL STTPUT(LINE(1:LENGTH),ISTAT)
         WRITE(LINE,'(A,I10)') 'Fatal input error near row',NROW
         CALL STETER(3,LINE(1:LENGTH))
      ENDIF
      IF (NCOL.LE.0) THEN
         CALL STETER(4,'No valid columns found or MXCOL wrong')
      ENDIF
C
C   Define some type dependent attributes of columns
C
      IF (TYPE.EQ.'R') THEN
        LENGTH=NCOL
        D_FORMAT=D_R4_FORMAT
        FORM='E15.6'
        LABEL='RVAL'
      ELSEIF (TYPE.EQ.'D') THEN
        LENGTH=NCOL*2
        D_FORMAT=D_R8_FORMAT
        FORM='D15.6'
        LABEL='DVAL'
      ELSEIF (TYPE.EQ.'I') THEN
        LENGTH=NCOL
        D_FORMAT=D_I2_FORMAT
        FORM='I12'
        LABEL='IVAL'
      ELSE
        CALL STETER(5,'Conversion types coded inconsistently')
      ENDIF

C
C   Create and map output table
C
      CALL TBTINI (ONAME,F_TRANS,F_O_MODE,LENGTH,NROW,OTID,ISTAT)
      DO 10 ICOL=1,NCOL
        IF (NCOL.LT.10) THEN
          WRITE(LABEL(5:6),'(I1,A1)') ICOL,' '
        ELSE
          WRITE(LABEL(5:6),'(I2)') ICOL
        ENDIF
        CALL TBCINI
     $    (OTID,D_FORMAT,1,FORM,' ',LABEL(1:6),IDCOL(ICOL),ISTAT)
 10   CONTINUE
C
C   Copy data:
C
      REWIND 1
      IROW=0
 11   CONTINUE
C
C   ... Read ASCII input row and ...
C
        READ(1,'(A)',IOSTAT=JSTAT) LINE
        LENGTH=LENCH(LINE)
            IF (TYPE.EQ.'R') THEN
              READ(LINE(1:LENGTH),*, IOSTAT=ISTAT)
     $            (RVAL(I),I=1,NCOL)
            ELSEIF (TYPE.EQ.'D') THEN
              READ(LINE(1:LENGTH),*,IOSTAT=ISTAT)
     $            (DVAL(I),I=1,NCOL)
            ELSEIF (TYPE.EQ.'I') THEN
              READ(LINE(1:LENGTH),*,   IOSTAT=ISTAT)
     $            (IVAL(I),I=1,NCOL)
            ELSE
              CALL STETER(6,'WrongLy coded conversion type')
            ENDIF
C
C   ... write into MIDAS table row
C
            IF (ISTAT.EQ.0) THEN
              IROW=IROW+1
              IF (IROW.LE.NROW) THEN
                IF (TYPE.EQ.'R') THEN
                  CALL TBRWRR(OTID,IROW,NCOL,IDCOL,RVAL,ISTAT)
                ELSEIF (TYPE.EQ.'D') THEN
                  CALL TBRWRD(OTID,IROW,NCOL,IDCOL,DVAL,ISTAT)
                ELSEIF (TYPE.EQ.'I') THEN
                  CALL TBRWRI(OTID,IROW,NCOL,IDCOL,IVAL,ISTAT)
                ELSE
                  CALL STETER(7,'WrongLy coded conversion type')
                ENDIF
              ELSE
                CALL STETER(8,'Wrongly coded row count')
              ENDIF
            ENDIF
        IF (JSTAT.EQ.0) THEN
            GOTO 11
        ENDIF
C
C   Loop over file finished, test for errors
C
      IF (JSTAT.GT.0) THEN
         CALL STTPUT(LINE(1:LENGTH),ISTAT)
         WRITE(LINE,'(A,I10)') 'Fatal input error near row',NROW
         CALL STETER(10,LINE(1:LENGTH))
      ENDIF
C
C   Wind-up
C
      LINE='ASCI table '//INAME(1:LENCH(INAME))//
     $   ' converted into MIDAS table '//ONAME(1:LENCH(ONAME))//'.tbl'
      CALL STTPUT(LINE(1:LENCH(LINE)),ISTAT)
      CALL STTPUT('           ... Enjoy it!',ISTAT)
      CALL DSCUPT(OTID,OTID,' ',ISTAT)
      CALL STSEPI
C
      END
C
C
C

C @(#)mathsubs.for	19.1 (ES0-DMD) 02/25/03 13:23:50
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C
C This file contains subroutines that are not I/O related, but rather
C involve arithmetic or character operations that my be somewhat
C machine-specific-- it may be necessary or desirable to make some
C changes to optimize the code to run on your computer.
C
C              OFFICIAL DAO VERSION:  1991 April 18
C
C***********************************************************************
C
C Current contents:
C
C   INVERS  inverts a square matrix.
C
C     VMUL  multiplies a square matrix (on the left) by a column vector
C           (on the right) yielding a new column vector.
C
C    QUICK  does a quicksort on a vector of data.
C
C     SHOW  produces what is effectively an eleven-level gray scale plot
C           of a rectangular data array on the terminal.
C
C***********************************************************************
C
      SUBROUTINE  INVERS (A, MAX, N, IFLAG)
C
C Although it seems counter-intuitive, the tests that I have run
C so far suggest that the 180 x 180 matrices that NSTAR needs can
C be inverted with sufficient accuracy if the elements are REAL
C rather than DOUBLE PRECISION
C
C Arguments
C
C     A (INPUT/OUTPUT) is a square matrix of dimension N.  The inverse
C       of the input matrix A is returned in A.
C
C   MAX (INPUT) is the size assigned to the matrix A in the calling
C       routine.  It's needed for the dimension statement below.
C
C IFLAG (OUTPUT) is an error flag.  IFLAG = 1 if the matrix could not
C       be inverted; IFLAG = 0 if it could.
C
      IMPLICIT NONE
      INTEGER MAX
      REAL A(MAX,MAX)
C
      INTEGER N, IFLAG, I, J, K
C
C-----------------------------------------------------------------------
C
      IFLAG=0
      I=1
  300 IF(A(I,I).EQ.0.0E0)GO TO 9100
      A(I,I)=1.0E0/A(I,I)
      J=1
  301 IF(J.EQ.I)GO TO 304
      A(J,I)=-A(J,I)*A(I,I)
      K=1
  302 IF(K.EQ.I)GO TO 303
      A(J,K)=A(J,K)+A(J,I)*A(I,K)
  303 IF(K.EQ.N)GO TO 304
      K=K+1
      GO TO 302
  304 IF(J.EQ.N)GO TO 305
      J=J+1
      GO TO 301
  305 K=1
  306 IF(K.EQ.I)GO TO 307
      A(I,K)=A(I,K)*A(I,I)
  307 IF(K.EQ.N)GO TO 308
      K=K+1
      GO TO 306
  308 IF(I.EQ.N)RETURN                                   ! Normal return
      I=I+1
      GO TO 300
C
C-----------------------------------------------------------------------
C
C Error:  zero on the diagonal.
C
 9100 IFLAG=I
      RETURN
C
      END!
C
C#######################################################################
C
      SUBROUTINE  VMUL (A, MAX, N, V, X)
C
C Multiply a matrix by a vector:
C
C                    A * V = X
C
C Arguments
C
C    A(column,row)  (INPUT) is a square matrix of dimension N.
C
C              MAX  (INPUT) is the size assigned to the array in the
C                           calling routine.
C
C           V(row)  (INPUT) is a column vector of dimension N.
C
C           X(row) (OUTPUT) is a column vector of dimension N.
C
      IMPLICIT NONE
      INTEGER MAX
      REAL A(MAX,MAX), V(MAX)
      REAL X(MAX)
C
      DOUBLE PRECISION DBLE
      REAL SNGL
C
      DOUBLE PRECISION SUM
      INTEGER N, I, J
C
C-----------------------------------------------------------------------
C
      I=1
  200 SUM=0.0D0
      J=1
  201 SUM=SUM+DBLE(A(J,I))*DBLE(V(J))
      IF (J .EQ. N) GO TO 203
      J=J+1
      GO TO 201
  203 X(I)=SNGL(SUM)
      IF (I .EQ. N) RETURN                               ! Normal return
      I=I+1
      GO TO 200
      END!
C
C#######################################################################
C
      SUBROUTINE  DINVRS (A, MAX, N, IFLAG)
      IMPLICIT NONE
      INTEGER MAX
      DOUBLE PRECISION A(MAX,MAX)
C
      INTEGER I, J, K, N, IFLAG
C
C-----------------------------------------------------------------------
C
      IFLAG=0
      I=1
  300 IF(A(I,I).EQ.0.0D0)GO TO 9100
      A(I,I)=1.0D0/A(I,I)
      J=1
  301 IF(J.EQ.I)GO TO 304
      A(J,I)=-A(J,I)*A(I,I)
      K=1
  302 IF(K.EQ.I)GO TO 303
      A(J,K)=A(J,K)+A(J,I)*A(I,K)
  303 IF(K.EQ.N)GO TO 304
      K=K+1
      GO TO 302
  304 IF(J.EQ.N)GO TO 305
      J=J+1
      GO TO 301
  305 K=1
  306 IF(K.EQ.I)GO TO 307
      A(I,K)=A(I,K)*A(I,I)
  307 IF(K.EQ.N)GO TO 308
      K=K+1
      GO TO 306
  308 IF(I.EQ.N)RETURN                                   ! Normal return
      I=I+1
      GO TO 300
C
C-----------------------------------------------------------------------
C
C Error:  zero on the diagonal.
C
 9100 IFLAG=I
      RETURN
C
      END!
C
C#######################################################################
C
      SUBROUTINE  DVMUL (A, MAX, N, V, X)
      IMPLICIT NONE
      INTEGER MAX
      DOUBLE PRECISION A(MAX,MAX), V(MAX), X(MAX)
C
      DOUBLE PRECISION SUM
      INTEGER I, J, N
C
C-----------------------------------------------------------------------
C
      I=1
  200 SUM=0.0D0
      J=1
  201 SUM=SUM+A(J,I)*V(J)
      IF (J .EQ. N) GO TO 203
      J=J+1
      GO TO 201
  203 X(I)=SUM
      IF (I .EQ. N) RETURN                               ! Normal return
      I=I+1
      GO TO 200
      END!
C
C#######################################################################
C
      SUBROUTINE  QUICK (DATUM, N, INDEX)
C
C=======================================================================
C
C A quick-sorting algorithm suggested by the discussion on pages 114-119
C of THE ART OF COMPUTER PROGRAMMING, Vol. 3, SORTING AND SEARCHING, by
C D.E. Knuth, which was referenced in Don Wells' subroutine QUIK.  This
C is my own attempt at encoding a quicksort-- PBS.
C
C Arguments
C
C DATUM (INPUT/OUTPUT) is a vector of dimension N containing randomly
C        ordered real data upon input.  Upon output the elements of
C        DATUM will be in order of increasing value.
C
C
C INDEX (OUTPUT) is an integer vector of dimension N.  Upon return to
C       the calling program the i-th element of INDEX will tell where
C       the i-th element of the sorted vector DATUM had been BEFORE
C       DATUM was sorted.
C
C=======================================================================
C
      IMPLICIT NONE
      INTEGER MAXSTK, N
      PARAMETER (MAXSTK=28)
C
C Parameter
C
C MAXSTK is the maximum number of entries the stack can contain.
C         A limiting stack length of 14 restricts this quicksort
C         subroutine to vectors of maximum length of order 32,768
C         (= 2**15).
 
      REAL DATUM(N)
      INTEGER INDEX(N), STKLO(MAXSTK), STKHI(MAXSTK)
C
      REAL DKEY
      INTEGER I, HI, LO, NSTAK, LIMLO, LIMHI, IKEY
C
C Initialize INDEX.
C
      DO 50 I=1,N
   50 INDEX(I)=I
C
C Initialize the pointers.
C
      NSTAK=0
      LIMLO=1
      LIMHI=N
C
  100 DKEY=DATUM(LIMLO)
      IKEY=INDEX(LIMLO)
CD     TYPE *, 'LO =', LIMLO, '   HI =', LIMHI
C
C Compare all elements in the sub-vector between LIMLO and LIMHI with
C the current key datum.
C
      LO=LIMLO
      HI=LIMHI
  101 CONTINUE
C
      IF (LO .EQ. HI)GO TO 200
C
      IF (DATUM(HI) .LE. DKEY) GO TO 109
      HI=HI-1
C
C The pointer HI is to be left pointing at a datum SMALLER than the
C key, which is intended to be overwritten.
C
      GO TO 101
C
  109 DATUM(LO)=DATUM(HI)
      INDEX(LO)=INDEX(HI)
      LO=LO+1
  110 CONTINUE
C
      IF (LO .EQ. HI) GO TO 200
C
      IF (DATUM(LO) .GE. DKEY) GO TO 119
C
      LO=LO+1
      GO TO 110
C
  119 DATUM(HI)=DATUM(LO)
      INDEX(HI)=INDEX(LO)
      HI=HI-1
C
C The pointer LO is to be left pointing at a datum LARGER than the
C key, which is intended to be overwritten.
C
      GO TO 101
C
  200 CONTINUE
C
C LO and HI are equal, and point at a value which is intended to
C be overwritten.  Since all values below this point are less than
C the key and all values above this point are greater than the key,
C this is where we stick the key back into the vector.
C
      DATUM(LO)=DKEY
      INDEX(LO)=IKEY
CD     DO 1666 I=LIMLO,LO-1
CD1666 TYPE *, DATUM(I)
CD     TYPE *, DATUM(LO), ' KEY'
CD     DO 2666 I=LO+1,LIMHI
CD2666 TYPE *, DATUM(I)
C
C At this point in the subroutine, all data between LIMLO and LO-1,
C inclusive, are less than DATUM(LO), and all data between LO+1 and
C LIMHI are larger than DATUM(LO).
C
C If both subarrays contain no more than one element, then take the most
C recent interval from the stack (if the stack is empty, we're done).
C If the larger of the two subarrays contains more than one element, and
C if the shorter subarray contains one or no elements, then forget the
C shorter one and reduce the other subarray.  If the shorter subarray
C contains two or more elements, then place the larger subarray on the
C stack and process the subarray.
C
      IF (LIMHI-LO .GT. LO-LIMLO) GO TO 300
C
C Case 1:  the lower subarray is longer.  If it contains one or no
C elements then take the most recent interval from the stack and go
C back and operate on it.
C
      IF (LO-LIMLO .LE. 1) GO TO 400
C
C If the upper (shorter) subinterval contains one or no elements, then
C process the lower (longer) one, but if the upper subinterval contains
C more than one element, then place the lower (longer) subinterval on
C the stack and process the upper one.
C
      IF (LIMHI-LO .GE. 2) GO TO 250
C
C Case 1a:  the upper (shorter) subinterval contains no or one elements,
C so we go back and operate on the lower (longer) subinterval.
C
      LIMHI=LO-1
      GO TO 100
C
  250 CONTINUE
C
C Case 1b:  the upper (shorter) subinterval contains at least two
C elements, so we place the lower (longer) subinterval on the stack and
C then go back and operate on the upper subinterval.
C
      NSTAK=NSTAK+1
      STKLO(NSTAK)=LIMLO
      STKHI(NSTAK)=LO-1
      LIMLO=LO+1
CD     DO 3666 I=1,NSTAK
CD3666 TYPE *, 'STACK: ', I, STKLO(I), STKHI(I)
      GO TO 100
C
  300 CONTINUE
C
C Case 2:  the upper subarray is longer.  If it contains one or no
C elements then take the most recent interval from the stack and
C operate on it.
C
      IF (LIMHI-LO .LE. 1) GO TO 400
C
C If the lower (shorter) subinterval contains one or no elements, then
C process the upper (longer) one, but if the lower subinterval contains
C more than one element, then place the upper (longer) subinterval on
C the stack and process the lower one.
C
      IF (LO-LIMLO .GE. 2) GO TO 350
C
C Case 2a:  the lower (shorter) subinterval contains no or one elements,
C so we go back and operate on the upper (longer) subinterval.
C
      LIMLO=LO+1
      GO TO 100
C
  350 CONTINUE
C
C Case 2b:  the lower (shorter) subinterval contains at least two
C elements, so we place the upper (longer) subinterval on the stack and
C then go back and operate on the lower subinterval.
C
      NSTAK=NSTAK+1
      STKLO(NSTAK)=LO+1
      STKHI(NSTAK)=LIMHI
      LIMHI=LO-1
CD     DO 4666 I=1,NSTAK
CD4666 TYPE *, 'STACK: ', I, STKLO(I), STKHI(I)
      GO TO 100
C
  400 CONTINUE
C
C Take the most recent interval from the stack.  If the stack happens
C to be empty, we are done.
C
      IF (NSTAK .LE. 0) RETURN                           ! Normal return
CD     TYPE *, 'POP: ', NSTAK, STKLO(NSTAK), STKHI(NSTAK)
      LIMLO=STKLO(NSTAK)
      LIMHI=STKHI(NSTAK)
      NSTAK=NSTAK-1
      GO TO 100
C
      END!
C
C#######################################################################
C
      SUBROUTINE RECTFY (X, NSTAR, INDEX, HOLD)
      IMPLICIT NONE
C
      REAL X(*), HOLD(*)
      INTEGER INDEX(*)
C
      INTEGER I, NSTAR
C
      DO I=1,NSTAR
         HOLD(I)=X(I)
      END DO
      DO I=1,NSTAR
         X(I)=HOLD(INDEX(I))
      END DO
      RETURN
      END!
C
C#######################################################################
C
      SUBROUTINE IRECTFY (IX, NSTAR, INDEX, HOLD)
      IMPLICIT NONE
C
      INTEGER IX(*)
      REAL  HOLD(*)
      INTEGER INDEX(*)
C
      INTEGER I, NSTAR
C
      DO I=1,NSTAR
         HOLD(I)=IX(I)
      END DO
      DO I=1,NSTAR
         IX(I)=HOLD(INDEX(I))
      END DO
      RETURN
      END!
C
C#######################################################################
C
      REAL FUNCTION PCTILE(DATUM,N,NPCT)
C
C=======================================================================
C
C This is a modification of a quick-sorting algorithm, which is intended
C to take in a vector of numbers, and return the value of the PCT-th
C percentile in that vector:
C
C    DATUM (input real vector)     containing real data.
C    N     (input integer)         number of elements in DATUM.
C    NPCT  (input integer)         element of sorted vector whose value
C                                  is desired.
C    PCTILE (output real)          the value of the NPCT-th element
C                                  in the sorted vector DATUM.
C
C-----------------------------------------------------------------------
C
C The quick-sorting algorithm was suggested by the discussion on pages
C 114-119 of THE ART OF COMPUTER PROGRAMMING, Vol. 3, SORTING AND
C SEARCHING, by D.E. Knuth, which was referenced in Don Wells'
C subroutine QUIK.  This is my own attempt at encoding a quicksort--
C                                                             PBS.
C
C The array DATUM contains randomly ordered data.
C
      IMPLICIT NONE
      INTEGER MAXSTK
      PARAMETER (MAXSTK=25)
      REAL DATUM(*)
C
      INTEGER MIN0, MAX0
C
      REAL DKEY
      INTEGER LO, HI, N, NPCT, LIMLO, LIMHI
C
C Which element of the sorted array will we be interested in?
C
      NPCT=MAX0(1,MIN0(N,NPCT))
C
C Initialize the pointers.
C
      LIMLO=1
      LIMHI=N
C
  100 DKEY=DATUM(LIMLO)
CD     TYPE *,'LOW=',LIMLO,' HIGH=',LIMHI,' KEY=',DKEY
C
C Compare all elements in the sub-vector between LIMLO and LIMHI with
C the current key datum.
C
      LO=LIMLO
      HI=LIMHI
  101 CONTINUE
C
C If LO equals HI, we have tested all the elements in the current search
C interval.
C
      IF(LO.EQ.HI)GO TO 200
      IF(DATUM(HI).LE.DKEY)GO TO 109
      HI=HI-1
C
C The pointer HI is to be left pointing at a datum SMALLER than the
C key, which is intended to be overwritten.
C
      GO TO 101
C
  109 DATUM(LO)=DATUM(HI)
      LO=LO+1
  110 CONTINUE
      IF(LO.EQ.HI)GO TO 200
      IF(DATUM(LO).GE.DKEY)GO TO 119
      LO=LO+1
      GO TO 110
C
  119 DATUM(HI)=DATUM(LO)
      HI=HI-1
C
C The pointer LO is to be left pointing at a datum LARGER than the
C key, which is intended to be overwritten.
C
      GO TO 101
C
  200 CONTINUE
C
C LO and HI are equal, and point at a value which is intended to
C be overwritten.  Since all values below this point are less than
C the key and all values above this point are greater than the key,
C this is where we stick the key back into the vector.
C
      DATUM(LO)=DKEY
CD     DO 1666 I=LIMLO,LO-1
CD1666 TYPE *,DATUM(I)
CD     TYPE *,DATUM(LO),' KEY'
CD     DO 2666 I=LO+1,LIMHI
CD2666 TYPE *,DATUM(I)
C
C At this point in the subroutine, all data between LIMLO and LO-1,
C inclusive, are less than DATUM(LO), and all data between LO+1 and
C LIMHI are larger than DATUM(LO).  If LO = NPCT, then DATUM(LO) is
C the value we are looking for.  If NPCT < LO, then we want to sort the
C values of DATUM from LIMLO to LO-1, inclusive, whereas if NPCT > LO,
C then we want to sort the values of DATUM from LO+1 to LIMHI,
C inclusive.
C
CD     TYPE *,'NPCT=',NPCT,' LO=',LO
      IF(NPCT-LO)300,900,400
  300 LIMHI=LO-1
      GO TO 100
  400 LIMLO=LO+1
      GO TO 100
  900 PCTILE=DATUM(LO)
      RETURN
      END!
C
C#######################################################################
C
      REAL FUNCTION SMLLST (DATUM, N, M)
      IMPLICIT NONE
      REAL DATUM(*)
      INTEGER I, J, N, M, LEAST
      DO J=1,M
         SMLLST = DATUM(J)
         LEAST = J
         DO I=J,N
            IF (DATUM(I) .LT. SMLLST) THEN
               SMLLST = DATUM(I)
               LEAST = I
            END IF
         END DO
         DATUM(LEAST) = DATUM(J)
         DATUM(J) = SMLLST
      END DO
      RETURN
      END!
C
C#######################################################################
C
      REAL FUNCTION BIGGST (DATUM, N, M)
      IMPLICIT NONE
      REAL DATUM(*)
      INTEGER I, J, N, M, MOST
      DO J=N,N-M+1,-1
         MOST = J
         BIGGST = DATUM(MOST)
         DO I=1,J
            IF (DATUM(I) .GT. BIGGST) THEN
               BIGGST = DATUM(I)
               MOST = I
            END IF
         END DO
         DATUM(MOST) = DATUM(J)
         DATUM(J) = BIGGST
      END DO
      RETURN
      END!
C
C#######################################################################
C
      SUBROUTINE  MMM (SKY, NSKY, HIBAD, SKYMN, SKYMED,
     .     SKYMOD, SIGMA, SKEW)
C
C=======================================================================
C
C               Official DAO version:  1988 July 1
C
C This version of MMM (modified by PBS 1984.IV.10ff) assumes that
C the sky brightnesses in the one-dimensional array SKY are already
C sorted on entering this routine, and that pixels outside the "bad"
C limits have already been eliminated.
C
C This particular version of MMM also takes cognizance of the fact that,
C pixels falling below the LOBAD threshold already having been
C eliminated, the contaminated sky pixels values overwhelmingly display
C POSITIVE departures from the true value.
C
C If for some reason it is impossible to obtain the mode of the sky
C distribution, this will be flagged by setting SIGMA = -1.0.
C
C Arguments
C
C     SKY (INPUT) is a real vector containing actual sorted sky values.
C    NSKY (INPUT) is the number of defined elements in SKY.
C  SKYMOD (OUTPUT) is the estimated mode of the sky values.
C   SIGMA (OUTPUT) is the computed standard deviation of the peak in
C         the sky histogram.
C    SKEW (OUTPUT) is the computed skewness of the peak in the sky
C         histogram.
C
C=======================================================================
C
      IMPLICIT NONE
      INTEGER NSKY
      REAL SKY(NSKY)
C
      DOUBLE PRECISION DSQRT, DBLE
      REAL ALOG10, AMIN1, AMAX1
C
      DOUBLE PRECISION SUM,SUMSQ
      REAL CUT, CUT1, CUT2, DELTA, SKYMID, SKYMED, SKYMN, SKYMOD
      REAL SIGMA, SKEW, R, SIGN, X, HIBAD, CENTER, SIDE
      INTEGER I, MINIMM, MAXIMM, NITER, ISTEP, MAXIT, MINSKY, JSTEP
      LOGICAL REDO
      DATA MAXIT / 30 /, MINSKY / 20 /
C
C-----------------------------------------------------------------------
C
C SECTION 1
C
      IF (NSKY .LE. 0) GO TO 9900
      SKYMID=0.5*(SKY((NSKY+1)/2)+SKY(NSKY/2+1))
C
C SKYMID is the median value for the whole ensemble of sky pixels.
C Notice that if NSKY is odd, then (NSKY+1)/2 and (NSKY/2)+1 will be the
C same number, whereas if NSKY is even, they will be different numbers.
C This same trick will be used again later.
C
C Initialize the variables for accumulating the mean and standard
C deviation, and initialize the rejection limits.
C
      SUM=0.D0
      SUMSQ=0.D0
      CUT1=AMIN1(SKYMID-SKY(1), SKY(NSKY)-SKYMID, HIBAD-SKYMID)
C
C For the first pass we will consider only pixels in a symmetric
C interval of brightness values about the median value.  This exploits
C the assumption that all the bad pixels are already rejected from the
C lower end of the brightness range.
C
      CUT2=SKYMID + CUT1
      CUT1=SKYMID - CUT1
C
      MINIMM=0
      DO 1010 I=1,NSKY
         IF (SKY(I) .LT. CUT1) THEN
            MINIMM=I
            GO TO 1010
         END IF
         IF (SKY(I) .GT. CUT2) GO TO 1020
         DELTA=SKY(I)-SKYMID
         SUM=SUM+DELTA
         SUMSQ=SUMSQ+DELTA**2
         MAXIMM=I
 1010 CONTINUE
C
C Henceforth in this subroutine, MINIMM will point to the highest value
C rejected at the lower end of the vector, and MAXIMM will point to the
C highest value accepted at the upper end of the vector.
C MAXIMM-MINIMM is the number of pixels within the acceptance range.
C
C Compute mean and sigma (from the first pass).
C
 1020 CONTINUE
      SKYMED=0.5*(SKY((MINIMM+MAXIMM+1)/2)+SKY((MINIMM+MAXIMM)/2+1))
      SKYMN=SUM/DBLE(MAXIMM-MINIMM)
      SIGMA=DSQRT(SUMSQ/DBLE(MAXIMM-MINIMM)-SKYMN**2)
      SKYMN=SKYMN+SKYMID
C
C The middle sky value, SKYMID, was subtracted off up above and added
C back in down here to reduce the truncation error in the computation
C of SIGMA.
C Note that this definition of SIGMA is incorrect by a factor of
C SQRT [NSKY/(NSKY-1.)], but for all but pathological cases (where none
C of this can be trusted anyway), it's close enough.
C
      SKYMOD=SKYMN
      IF (SKYMED .LT. SKYMN) SKYMOD=3.*SKYMED-2.*SKYMN
C
C If the mean is less than the mode, that means the contamination is
C slight, and the mean value is what we really want.  Note that this
C introduces a slight bias toward underestimating the sky when
C the scatter in the sky is caused by random fluctuations rather than
C by contamination, but I think this bias is negligible compared to the
C problem of contamination.
C
C-----------------------------------------------------------------------
C
C SECTION 2
C
C Rejection and recomputation loop:
C
      NITER=0
 2000 NITER=NITER+1
      IF ((NITER .GT. MAXIT) .OR. (MAXIMM-MINIMM .LT. MINSKY))
     .     GO TO 9900
C
C Compute Chauvenet rejection criterion.
C
      R=ALOG10(FLOAT(MAXIMM-MINIMM))
      R=AMAX1(2., (-.1042*R+1.1695)*R+.8895)
C
C Compute rejection limits (symmetric about the current mode).
C
      CUT=R*SIGMA+0.5*ABS(SKYMN-SKYMOD)
      CUT=AMAX1(1.5,CUT)
      CUT1=SKYMOD-CUT
      CUT2=SKYMOD+CUT
C
C Recompute mean and sigma by adding and/or subtracting sky values
C at both ends of the interval of acceptable values.
C
C At each end of the interval, ISTEP will show the direction we have to
C step through the vector to go from the old partition to the new one.
C Pixels are added or subtracted depending upon whether the limit is
C moving toward or away from the mode.
C
      REDO=.FALSE.
C
C Is CUT1 above or below the minimum currently-accepted value?
C
      ISTEP=INT(SIGN(1.0001, CUT1-SKY(MINIMM+1)))
      JSTEP=(ISTEP+1)/2
C
C If ISTEP = +1, JSTEP = 1.  If ISTEP = -1, JSTEP=0.  If ISTEP = +1,
C then we know that at least one pixel must be deleted at the low end.
C
      IF (ISTEP .GT. 0) GO TO 2120
 2100 IF ((ISTEP .LT. 0) .AND. (MINIMM .LE. 0)) GO TO 2150
C
C Quit when SKY(MINIMM) < CUT1 <= SKY(MINIMM+1)
C
      IF ((SKY(MINIMM) .LE. CUT1) .AND. (SKY(MINIMM+1) .GE. CUT1))
     .     GO TO 2150
C
C If ISTEP is positive, subtract out the sky value at MINIMM+1; if
C ISTEP is negative, add in the sky value at MINIMM.
C
 2120 CONTINUE
      DELTA=SKY(MINIMM+JSTEP)-SKYMID
      SUM=SUM-REAL(ISTEP)*DELTA
      SUMSQ=SUMSQ-REAL(ISTEP)*DELTA**2
      MINIMM=MINIMM+ISTEP
      REDO=.TRUE.                                 ! A change has occured
      GO TO 2100
C
 2150 CONTINUE
C
C Is CUT2 above or below the current maximum?
C
      ISTEP=INT(SIGN(1.0001, CUT2-SKY(MAXIMM)))
      JSTEP=(ISTEP+1)/2
C
C If ISTEP = +1, JSTEP = 1.  If ISTEP = -1, JSTEP=0.  If ISTEP = -1,
C then we know that we must subtract at least one pixel from the high
C end.
C
      IF (ISTEP .LT. 0) GO TO 2220
 2200 IF ((ISTEP .GT. 0) .AND. (MAXIMM .GE. NSKY)) GO TO 2250
C
C Quit when SKY(MAXIMM) <= CUT2 < SKY(MAXIMM+1)
C
      IF ((SKY(MAXIMM) .LE. CUT2) .AND. (SKY(MAXIMM+1) .GE. CUT2))
     .     GO TO 2250
C
C If ISTEP is positive, add in the sky value at MAXIMM+1; if ISTEP is
C negative, subtract off the sky value at MAXIMM.
C
 2220 DELTA=SKY(MAXIMM+JSTEP)-SKYMID
      SUM=SUM+REAL(ISTEP)*DELTA
      SUMSQ=SUMSQ+REAL(ISTEP)*DELTA**2
      MAXIMM=MAXIMM+ISTEP
      REDO=.TRUE.                                 ! A change has occured
      GO TO 2200
C
 2250 CONTINUE
C
C Compute mean and sigma (from this pass).
C
      SKYMN=SUM/DBLE(MAXIMM-MINIMM)
      SIGMA=DSQRT(SUMSQ/DBLE(MAXIMM-MINIMM)-SKYMN**2)
      SKYMN=SKYMN+SKYMID
C
C Obtain the median.  To first approximation, the median would be the
C value of the sky in the middle pixel in the sorted data (if the
C total number is odd) or the mean of the two pixels straddling
C the middle (if the total number of pixels is even).
C
C     SKYMED=0.5*(SKY((MINIMM+MAXIMM+1)/2)+SKY((MINIMM+MAXIMM)/2+1))
C
C However, this is not good enough.  If you look at the estimator for
C the mode, you will note that a tiny change in the list of sky pixels,
C just sufficient to alter the median value of the sky brightness by
C one unit, will change the estimator of the mode by three units.  We
C really want something more robust than this.  As a first attempt
C at a more robust median estimator, I propose to estimate the median
C of the distribution by the mean of the central five percent of sky
C values.  This involves considerable care to make sure you get
C a perfectly symmetric sample of pixels about the median, whether
C there is an even or an odd number of pixels within the acceptance
C interval.
C
      SKYMED=0.0
      X=0.0
      CENTER = REAL(MINIMM+1 + MAXIMM)/2.
      SIDE = REAL(NINT(0.05*REAL(MAXIMM-MINIMM)))/2. + 0.25
C
      DO 2310 I=NINT(CENTER-SIDE),NINT(CENTER+SIDE)
      SKYMED=SKYMED+SKY(I)
 2310 X=X+1.
C
      SKYMED=SKYMED/X
      SKYMOD=SKYMN
      IF (SKYMED .LT. SKYMN) SKYMOD=3.*SKYMED-2.*SKYMN
C
C If the mean is less than the mode, that means the contamination is
C slight, and the mean value is what we really want.  Note that this
C introduces a slight bias toward underestimating the sky when
C the scatter in the sky is caused by random fluctuations rather than
C by contamination, but I think this bias is negligible compared to the
C problem of contamination.
C
C If the limits have not yet stopped moving, try again.
C
      IF (REDO) GO TO 2000
C
C-----------------------------------------------------------------------
C
C Normal return.
C
      SKEW=(SKYMN-SKYMOD)/AMAX1(1., SIGMA)
      NSKY=MAXIMM-MINIMM
      RETURN
C
C-----------------------------------------------------------------------
C
C An error condition has been detected.
C
 9900 SIGMA=-1.0
      SKEW=0.0
      RETURN
C
      END!
C
C#######################################################################
C
 	SUBROUTINE  SHOW (F, FMAX, FZERO, NX, NY, NCOL)
C
C=======================================================================
C
C A simple subroutine to use alphanumeric characters to produce a 2-D
C gray-scale plot on an alphanumeric terminal.
C
C=======================================================================
C
      IMPLICIT NONE
      INTEGER NCHAR, MAXPLT, NCOL
      PARAMETER  (NCHAR=11, MAXPLT=36)
C
C Parameters
C
C   NCHAR is the number of discrete gray levels we wish to produce.
C
C MAXPLT is the widest plot that can be produced on the terminal
C         screen.  Since two characters will be typed out per pixel (to
C         make the overall plot more nearly square) MAXPLT should be
C         equal to (N-2)/2 where N is the number of character positions
C         per line on the screen; the extra two characters will be used
C         for vertical bars ('|') to delimit the picture.  Arrays
C         which are more than MAXPLT pixels on a side will be
C         rebinned before display.
C
      REAL F(NCOL,*), FF(MAXPLT)
C
      REAL SQRT
      INTEGER MIN0
C
      CHARACTER BLANK*80, DASH*2
      CHARACTER*2 CHAR(NCHAR)
      REAL SUM, PIXELS, FMAX, FZERO, S
      INTEGER I, ISTEP, NX, MX, IX, IY, KX, JX, JY, NY, LOW
      DATA BLANK /' '/, DASH/'--'/
      DATA CHAR / '  ', '- ', '--', '::', '==', 'll',
     .     'II', '%%', '00', 'HH', '##' /
C
C-----------------------------------------------------------------------
C
      ISTEP=((NX-1)/MAXPLT)+1
C
C ISTEP is the number of pixels in each row of the input array which
C will have to be averaged for each pixel of the display.
C
      MX=(NX+ISTEP-1)/ISTEP
C
C MX is the number of pixels per row which will be produced on the
C output display.
C
      LOW=MAXPLT-MX+1
      S=SQRT(AMAX1(FLOAT(NCHAR), FMAX-FZERO))
      WRITE (6,610) BLANK(1:LOW), (DASH, I=1,MX), '+ '
  610 FORMAT (A, '+', 80A2)
C
      DO 1010 IY=1,NY,ISTEP
      KX=0
      DO 1007 IX=1,NX,ISTEP
      KX=KX+1
      PIXELS=0.0
      SUM=0.0
      DO 1005 JY=IY,MIN0(NY,IY+ISTEP-1)
      DO 1003 JX=IX,MIN0(NX,IX+ISTEP-1)
      PIXELS=PIXELS+1.0
 1003 SUM=SUM+F(JX,JY)
 1005 CONTINUE
 1007 FF(KX)=SUM/PIXELS
 1010 WRITE (6,602) BLANK(1:LOW), '|', (CHAR(MIN0(
     .     NCHAR,
     .     IFIX( NCHAR*SQRT(AMAX1(0., FF(IX)-FZERO)  )/S )+1)),
     .     IX=1,MX), '|'
  602 FORMAT ( 80A )
      WRITE (6,610) BLANK(1:LOW), (DASH, I=1,MX), '+ '
      RETURN                                             ! Normal return
C
      END!
C
C#######################################################################
C
      INTEGER FUNCTION  RDPSF  (PSFFIL, IPSTYP, PAR, MAXPAR, NPAR,
     .     PSF, MAXPSF, MAXEXP, NPSF, NEXP, NFRAC,
     .     PSFMAG, BRIGHT, XPSF, YPSF)
C
C Read in the point-spread function
C
      IMPLICIT NONE
      INTEGER MAXPSF, MAXTYP, MAXPAR, MAXEXP
      PARAMETER (MAXTYP=6)
C
      REAL PAR(MAXPAR), PSF(MAXPSF,MAXPSF,MAXEXP)
C
      CHARACTER*30 PSFFIL
      CHARACTER*8 LABEL, CHECK
      REAL PSFMAG, BRIGHT, XPSF, YPSF
      INTEGER I, J, K, IPSTYP, NPSF, NPAR, NEXP, NFRAC, ISTAT
      INTEGER NTERM, NPARAM
C
      CALL INFILE (3, PSFFIL, ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error opening PSF file '//PSFFIL)
         RDPSF = -1
         RETURN
      END IF
C
      READ (3,302,IOSTAT=ISTAT) LABEL, NPSF, NPAR, NEXP, NFRAC, PSFMAG,
     .     BRIGHT, XPSF, YPSF
  302 FORMAT (1X, A8, 4I5, F9.3, F15.3, 2F9.1)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error reading PSF.')
         CALL CLFILE (3)
         RDPSF = -1
         RETURN
      END IF
      DO IPSTYP=1,MAXTYP
         I = NPARAM(IPSTYP, 1., CHECK, PAR, MAXPAR)
         IF ((LABEL .EQ. CHECK) .AND. (I .EQ. NPAR)) GO TO 1100
      END DO
      CALL STUPID ('Inappropriate PSF: '//LABEL)
      CALL CLFILE (3)
      RDPSF = -1
      RETURN
C
 1100 READ (3,301,IOSTAT=ISTAT) (PAR(I), I=1,NPAR)
  301 FORMAT (1X, 6E13.5)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error reading PSF.')
         RDPSF = -1
         CALL CLFILE (3)
         RETURN
      END IF
      NTERM = NEXP+NFRAC
      IF (NTERM .GE. 1) THEN
         DO K=1,NTERM
            READ (3,311,IOSTAT=ISTAT) ((PSF(I,J,K), I=1,NPSF), J=1,NPSF)
  311       FORMAT (1X, 6E13.6)
            IF (ISTAT .NE. 0) THEN
               CALL CLFILE (3)
               RDPSF = -1
               RETURN
            END IF
         END DO
      END IF
      CALL CLFILE (3)
      RDPSF = 0
      RETURN
      END!
C
C#######################################################################
C
      REAL  FUNCTION  DAOERF (XIN, XO, BETA, DFDXO, DFDBET)
C
C Numerically integrate a Gaussian function
C
C          F = EXP {-0.5*[(x-XO)/SIGMA]**2 },
C
C from XIN-0.5 to XIN+0.5 using Gauss-Legendre integration.  BETA
C is the half-width at half-maximum, which is equal to 1.17741 * SIGMA.
C Thus,
C
C          F = EXP {-0.6931472*[(x-XO)/BETA]**2 }.
C
C Also: provide the first derivative of the integral with respect to
C Xo and BETA.  Use Gauss-Legendre integration.
C
C-----------------------------------------------------------------------
C
      IMPLICIT NONE
      INTEGER MAXPT
      PARAMETER (MAXPT=4)
C
      REAL DX(MAXPT,MAXPT), WT(MAXPT,MAXPT)
C
      REAL EXP
C
      REAL X, XSQ
      REAL XIN, XO, BETA, DFDXO, DFDBET, BETASQ, DELTAX, F, WF
      INTEGER NPT, I
C
      DATA DX / 0.00000000,  0.0,        0.0       , 0.0       ,
     .         -0.28867513,  0.28867513, 0.0       , 0.0       ,
     .         -0.38729833,  0.00000000, 0.38729833, 0.0       ,
     .         -0.43056816, -0.16999052, 0.16999052, 0.43056816/
      DATA WT / 1.00000000,  0.0       , 0.0       , 0.0       ,
     .          0.50000000,  0.50000000, 0.0       , 0.0       ,
     .          0.27777778,  0.44444444, 0.27777778, 0.0       ,
     .          0.17392742,  0.32607258, 0.32607258, 0.17392742/
      DAOERF = 0.
      DFDXO = 0.
      DFDBET = 0.
      BETASQ=BETA**2
      DELTAX = XIN-XO
C
      XSQ = DELTAX**2
      F = XSQ/BETASQ
      IF (F .GT. 34.) RETURN
      F = EXP(-0.6931472*F)
      IF (F .GE. 0.046) THEN
         NPT = 4
      ELSE IF (F .GE. 0.0022) THEN
         NPT = 3
      ELSE IF (F .GE. 0.0001) THEN
         NPT = 2
      ELSE IF (F .GE. 1.E-10) THEN
         DAOERF = F
         DFDXO = 1.3862944 * DELTAX * F / BETASQ
         DFDBET = 1.3862944 * XSQ * F / (BETASQ*BETA)
         RETURN
      ELSE
         RETURN
      END IF
C
      DO I=1,NPT
         X = DELTAX + DX(I,NPT)
         XSQ = X**2
         F = EXP(-0.6931472*XSQ/BETASQ)
         WF = WT(I,NPT)*F
         DAOERF = DAOERF+WF
         DFDXO = DFDXO + X*WF
         DFDBET = DFDBET + XSQ*WF
      END DO
      DFDXO = 1.3862944*DFDXO/BETASQ
      DFDBET = 1.3862944*DFDBET/(BETASQ*BETA)
C
      RETURN
      END!
C
C#######################################################################
C
      REAL  FUNCTION  USEPSF (IPSTYP, DX, DY, BRIGHT, PAR, PSF,
     .     NPSF, NPAR, NEXP, NFRAC, DELTAX, DELTAY, DVDXC, DVDYC)
C
C Evaluate the PSF for a point distant DX, DY from the center of a
C star located at relative frame coordinates DELTAX, DELTAY.
C
      IMPLICIT NONE
      INTEGER MAXPSF, MAXPAR, MAXEXP
      PARAMETER (MAXPSF=145, MAXPAR=6, MAXEXP=11)
C
      REAL PAR(*), PSF(MAXPSF,MAXPSF,*), JUNK(MAXEXP)
C
      REAL PROFIL, BICUBC
C
      REAL MIDDLE, BRIGHT, DVDXC, DVDYC, DELTAX, DELTAY, XX, YY
      REAL DX, DY, CORR, DFDX, DFDY
      INTEGER J, K, LX, LY, IPSTYP
      INTEGER NFRAC, NTERM, NPSF, NEXP, NPAR
C
      NTERM = NEXP + NFRAC
      USEPSF = BRIGHT*PROFIL(IPSTYP, DX, DY, PAR, DVDXC, DVDYC,
     .     JUNK, 0)
CD     TYPE *, USEPSF, ' ANALYTIC '
      DVDXC = BRIGHT*DVDXC
      DVDYC = BRIGHT*DVDYC
      IF (NTERM .LT. 0) RETURN
      MIDDLE = (NPSF+1)/2
C
C The PSF look-up tables are centered at (MIDDLE, MIDDLE).
C
      IF (NEXP .GE. 0) THEN
         JUNK(1) = 1.
         IF (NEXP .GE. 1) THEN
            JUNK(2) = DELTAX
            JUNK(3) = DELTAY
            IF (NEXP .GE. 2) THEN
               JUNK(4) = 1.5*DELTAX**2-0.5
               JUNK(5) = DELTAX*DELTAY
               JUNK(6) = 1.5*DELTAY**2-0.5
            END IF
         END IF
      END IF
C
      IF (NFRAC .GT. 0) THEN
         J = NEXP+1
         JUNK(J) = -2.*(DX - REAL(NINT(DX)))
         J = J+1
         JUNK(J) = -2.*(DY - REAL(NINT(DY)))
         J = J+1
         JUNK(J) = 1.5*JUNK(J-2)**2 - 0.5
         J = J+1
         JUNK(J) = JUNK(J-3)*JUNK(J-2)
         J = J+1
         JUNK(J) = 1.5*JUNK(J-3)**2 - 0.5
      END IF
      XX = 2.*DX+MIDDLE
      LX = INT(XX)
      YY = 2.*DY+MIDDLE
      LY = INT(YY)
C
C This point in the stellar profile lies between columns LX and LX+1,
C and between rows LY and LY+1 in the look-up tables.
C
      DO K=1,NTERM
         CORR = BICUBC(PSF(LX-1,LY-1,K), MAXPSF,
     .        XX-REAL(LX), YY-REAL(LY), DFDX, DFDY)
         USEPSF = USEPSF + JUNK(K)*CORR
CD        TYPE *, USEPSF, ' CORRECTED ', JUNK(K), CORR
         DVDXC = DVDXC-JUNK(K)*DFDX
         DVDYC = DVDYC-JUNK(K)*DFDY
      END DO
      RETURN
      END!
C
C#######################################################################
C
      REAL  FUNCTION  BICUBC  (F, NBOX, DX, DY, DFDX, DFDY)
C
C Perform a type of bicubic interpolation in a grid of values.
C For a point located DX, DY distant from the corner of the grid
C (defined to be 1,1), return both the interpolated value and
C its first derivatives with respect to x and y.
C
      IMPLICIT NONE
      INTEGER NBOX
      REAL F(NBOX,NBOX), TEMP(4), DFDXT(4)
C
      REAL DX, DY, DFDX, DFDY, C1, C2, C3
      INTEGER JY
C
C By construction, the point at which we want to estimate the function
C will lie between the second and third columns, and between the second
C and third rows of F, at a distance of (DX,DY) from the (2,2) element
C of F.
C
      DO JY=1,4
         C1 = 0.5*(F(3,JY)-F(1,JY))
         C2 = 3.*(F(3,JY)-F(2,JY)-C1) - 0.5*(F(4,JY)-F(2,JY)) + C1
         C3 = F(3,JY) - F(2,JY) - C1 - C2
         TEMP(JY) = DX*(DX*(DX*C3+C2)+C1)+F(2,JY)
         DFDXT(JY)= DX*(DX*C3*3.+2.*C2)+C1
      END DO
      C1 = 0.5*(TEMP(3)-TEMP(1))
      C2 = 3.*(TEMP(3)-TEMP(2)-C1) - 0.5*(TEMP(4)-TEMP(2)) + C1
      C3 = TEMP(3) - TEMP(2) - C1 - C2
      BICUBC = DY*(DY*(DY*C3+C2)+C1)+TEMP(2)
      DFDY = DY*(DY*C3*3.+2.*C2)+C1
      C1 = 0.5*(DFDXT(3)-DFDXT(1))
      C2 = 3.*(DFDXT(3)-DFDXT(2)-C1) - 0.5*(DFDXT(4)-DFDXT(2)) + C1
      C3 = DFDXT(3) - DFDXT(2) - C1 - C2
      DFDX = DY*(DY*(DY*C3+C2)+C1)+DFDXT(2)
      RETURN
      END!
C
C#######################################################################
C
      REAL  FUNCTION  PROFIL  (IPSTYP, DX, DY, PAR, DHDXC, DHDYC,
     .     TERM, IDERIV)
C
C Compute the value of an ANALYTIC prfile for a point DX,DY distant
C from the centroid.  Return both the computed value and its
C first derivatives with respect to x and y.  If IDERIV .NE. 0,
C return also the first derivatives with respect to all the parameters
C defining the profile.
C
      IMPLICIT NONE
      INTEGER MAXPAR, MAXPT
      PARAMETER (MAXPAR=6, MAXPT=4)
C
      REAL PAR(MAXPAR), TERM(MAXPAR)
      REAL D(MAXPT,MAXPT), W(MAXPT,MAXPT)
      REAL X(MAXPT), XSQ(MAXPT), P1XSQ(MAXPT)
C
      REAL EXP, DAOERF
C
      REAL DX, DY, DHDXC, DHDYC, WFSQ, Y, WT, WF, ONEMP3
      REAL RSQ, E, TALPHA, P1SQ, P2SQ, XY, DENOM
      REAL FUNC, YSQ, WP4FOD, P4FOD, F, P1P2, ERFX, DHDSX, ERFY
      REAL DEBY, DFBY, DBYX0, DBYY0
      REAL DHDSY, ALPHA, P2YSQ
      INTEGER I, IPSTYP, IDERIV, IX, IY, NPT
C
      DATA D / 0.00000000,  0.0,        0.0       , 0.0       ,
     .        -0.28867513,  0.28867513, 0.0       , 0.0       ,
     .        -0.38729833,  0.00000000, 0.38729833, 0.0       ,
     .        -0.43056816, -0.16999052, 0.16999052, 0.43056816/
      DATA W / 1.00000000,  0.0       , 0.0       , 0.0       ,
     .         0.50000000,  0.50000000, 0.0       , 0.0       ,
     .         0.27777778,  0.44444444, 0.27777778, 0.0       ,
     .         0.17392742,  0.32607258, 0.32607258, 0.17392742/
C
      PROFIL = 0.
      DHDXC = 0.
      DHDYC = 0.
C
      IF (IDERIV .GT. 0) THEN
         DO I=1,MAXPAR
            TERM(I) = 0.
         END DO
      END IF
C
C
      IF (IPSTYP .EQ. 1) THEN
C
C GAUSSIAN
C
C     F = ERFX * ERFY / (PAR(1) * PAR(2))
C
C PAR(1) is the HWHM in X; sigma(x) = 0.8493218 * HWHM
C PAR(2) is the HWHM in Y; ditto
C
         P1P2 = PAR(1)*PAR(2)
         ERFX = DAOERF(DX, 0., PAR(1), DHDXC, DHDSX)
         ERFY = DAOERF(DY, 0., PAR(2), DHDYC, DHDSY)
         PROFIL = ERFX*ERFY/P1P2
         DHDXC = DHDXC*ERFY/P1P2
         DHDYC = DHDYC*ERFX/P1P2
         IF (IDERIV .GT. 0) THEN
            TERM(1) = (DHDSX-ERFX/PAR(1))*ERFY/P1P2
            TERM(2) = (DHDSY-ERFY/PAR(2))*ERFX/P1P2
         END IF
      ELSE IF (IPSTYP .EQ. 4) THEN
C
C MOFFAT FUNCTION  BETA = 2.5
C                            BETA-1
C F = --------------------------------------------------------
C      Ax * Ay * [1 + (X/Ax)**2 + (Y/Ay)**2 + (XY*Axy)]**BETA
C
C PAR(1) is the HWHM in x at y = 0:
C
C             1/2 = 1/[1 + (PAR(1)/Ax)**2]**BETA
C so
C             2**(1/BETA) - 1 = (PAR(1)/Ax)**2
C
C             Ax**2 = PAR(1)**2/[2**(1/BETA) - 1]
C
C When BETA = 2.5, Ax**2 = 3.129813 * PAR(1)**2
C
C Hence, let us use
C
C                                  1
C F = ---------------------------------------------------------------
C     P(1)*P(2)*{1+0.3195079*[(X/P(1))**2+(Y/P(2))**2+(XY*P(3))]**2.5
C
C neglecting a constant of proportionality.
C
         ALPHA = 0.3195079
         TALPHA = 0.6390158                 ! 2.*ALPHA
         P1SQ = PAR(1)**2
         P2SQ = PAR(2)**2
         P1P2 = PAR(1)*PAR(2)
         XY = DX*DY
C
         DENOM = 1. + ALPHA*(DX**2/P1SQ + DY**2/P2SQ + XY*PAR(3))
         IF (DENOM .GT. 1.E4) RETURN
         FUNC = 1. / (P1P2 * DENOM**PAR(4))
         IF (FUNC .GE. 0.046) THEN
            NPT = 4
         ELSE IF (FUNC .GE. 0.0022) THEN
            NPT = 3
         ELSE IF (FUNC .GE. 0.0001) THEN
            NPT = 2
         ELSE IF (FUNC .GE. 1.E-10) THEN
            PROFIL = (PAR(4) - 1.) * FUNC
            P4FOD = PAR(4)*ALPHA*PROFIL/DENOM
            DHDXC = P4FOD*(2.*DX/P1SQ + DY*PAR(3))
            DHDYC = P4FOD*(2.*DY/P2SQ + DX*PAR(3))
            IF (IDERIV .GT. 0) THEN
               TERM(1) = (2.*P4FOD*DX**2/P1SQ-PROFIL)/PAR(1)
               TERM(2) = (2.*P4FOD*DY**2/P2SQ-PROFIL)/PAR(2)
               TERM(3) = - P4FOD*XY
C              TERM(4) = PROFIL*(1./(PAR(4)-1.)-ALOG(DENOM))
            END IF
            RETURN
         ELSE
            RETURN
         END IF
C
         DO IX=1,NPT
            X(IX) = DX+D(IX,NPT)
            XSQ(IX) = X(IX)**2
            P1XSQ(IX) = XSQ(IX)/P1SQ
         END DO
C
         DO IY=1,NPT
            Y = DY+D(IY,NPT)
            YSQ = Y**2
            P2YSQ = YSQ/P2SQ
            DO IX=1,NPT
               WT = W(IY,NPT)*W(IX,NPT)
               XY=X(IX)*Y
               DENOM = 1. + ALPHA*(P1XSQ(IX) + P2YSQ + XY*PAR(3))
               FUNC = (PAR(4) - 1.) / (P1P2 * DENOM**PAR(4))
               P4FOD = PAR(4)*ALPHA*FUNC/DENOM
               WP4FOD = WT*P4FOD
               WF = WT*FUNC
               PROFIL = PROFIL + WF
               DHDXC = DHDXC + WP4FOD*(2.*X(IX)/P1SQ + Y*PAR(3))
               DHDYC = DHDYC + WP4FOD*(2.*Y/P2SQ + X(IX)*PAR(3))
               IF (IDERIV .GT. 0) THEN
                  TERM(1) = TERM(1) +
     .                     (2.*WP4FOD*P1XSQ(IX)-WF)/PAR(1)
                  TERM(2) = TERM(2) +
     .                     (2.*WP4FOD*P2YSQ-WF)/PAR(2)
                  TERM(3) = TERM(3) - WP4FOD*XY
C                 TERM(4) = TERM(4) + WF*(1./(PAR(4)-1.)-ALOG(DENOM))
               END IF
            END DO
         END DO
      ELSE IF (IPSTYP .EQ. 5) THEN
C
C Penny function --- Gaussian core plus Lorentzian wings.  The Lorentzian
C is elongated along the x or y axis, the Gaussian may be tilted.
C
         P1SQ = PAR(1)**2
         P2SQ = PAR(2)**2
         ONEMP3 = 1.-PAR(3)
         XY = DX*DY
C
         RSQ = DX**2/P1SQ + DY**2/P2SQ
         IF (RSQ .GT. 1.E10) RETURN
C
         F = 1./(1.+RSQ)
         RSQ = RSQ + XY*PAR(4)
         IF (RSQ .LT. 34.) THEN
            E = EXP(-0.6931472*RSQ)
            FUNC = PAR(3)*E + ONEMP3*F
         ELSE
            E = 0.
            FUNC = ONEMP3*F
         END IF
C
         IF (FUNC .GE. 0.046) THEN
            NPT = 4
         ELSE IF (FUNC .GE. 0.0022) THEN
            NPT = 3
         ELSE IF (FUNC .GE. 0.0001) THEN
            NPT = 2
         ELSE IF (FUNC .GE. 1.E-10) THEN
            PROFIL = FUNC
            DFBY = ONEMP3*F**2
            DEBY = 0.6931472*PAR(3)*E
            DBYX0 = 2.*DX/P1SQ
            DBYY0 = 2.*DY/P2SQ
            DHDXC = DEBY*(DBYX0 + DY*PAR(4)) + DFBY*DBYX0
            DHDYC = DEBY*(DBYY0 + DX*PAR(4)) + DFBY*DBYY0
            IF (IDERIV .GT. 0) THEN
               DBYX0 = DBYX0*DX/PAR(1)
               DBYY0 = DBYY0*DY/PAR(2)
               DFBY = DFBY + DEBY
               TERM(1) = DFBY * DBYX0
               TERM(2) = DFBY * DBYY0
               TERM(3) = E - F
               TERM(4) = - DEBY * XY
            END IF
            RETURN
         ELSE
            RETURN
         END IF
C
         DO IX=1,NPT
            X(IX) = DX+D(IX,NPT)
            P1XSQ(IX) = X(IX)/P1SQ
         END DO
C
         DO IY=1,NPT
            Y = DY+D(IY,NPT)
            P2YSQ = Y/P2SQ
            DO IX=1,NPT
               WT = W(IY,NPT)*W(IX,NPT)
               XY = X(IX)*Y
               RSQ = P1XSQ(IX)*X(IX) + P2YSQ*Y
               F = 1./(1.+RSQ)
               RSQ = RSQ + XY*PAR(4)
               IF (RSQ .LT. 34.) THEN
                  E = EXP(-0.6931472*RSQ)
                  FUNC = PAR(3)*E + ONEMP3*F
                  DEBY = 0.6931472*WT*PAR(3)*E
               ELSE
                  E = 0.
                  FUNC = ONEMP3*F
                  DEBY = 0.
               END IF
               PROFIL = PROFIL + WT*FUNC
               DFBY = WT*ONEMP3*F**2
               DBYX0 = 2.*P1XSQ(IX)
               DBYY0 = 2.*P2YSQ
               DHDXC = DHDXC +
     .              DEBY*(DBYX0 + DY*PAR(4)) + DFBY*DBYX0
               DHDYC = DHDYC +
     .              DEBY*(DBYY0 + DX*PAR(4)) + DFBY*DBYY0
               IF (IDERIV .GT. 0) THEN
                  DBYX0 = DBYX0*DX/PAR(1)
                  DBYY0 = DBYY0*DY/PAR(2)
                  TERM(1) = TERM(1) + (DFBY+DEBY)*DBYX0
                  TERM(2) = TERM(2) + (DFBY+DEBY)*DBYY0
                  TERM(3) = TERM(3) + WT*(E-F)
                  TERM(4) = TERM(4) - DEBY * XY
               END IF
            END DO
         END DO
      ELSE IF (IPSTYP .EQ. 6) THEN
C
C Penny function --- Gaussian core plus Lorentzian wings.
C The Lorentzian and Gaussian may be tilted in different
C directions.
C
         P1SQ = PAR(1)**2
         P2SQ = PAR(2)**2
         ONEMP3 = 1.-PAR(3)
         XY = DX*DY
C
         RSQ = DX**2/P1SQ + DY**2/P2SQ
         DFBY = RSQ + PAR(5)*XY
         IF (DFBY .GT. 1.E10) RETURN
         F = 1./(1.+DFBY)
C
         DEBY = RSQ + PAR(4)*XY
         IF (DEBY .LT. 34.) THEN
            E = EXP(-0.6931472*DEBY)
         ELSE
            E = 0.
         END IF
C
         FUNC = PAR(3)*E + ONEMP3*F
         IF (FUNC .GE. 0.046) THEN
            NPT = 4
         ELSE IF (FUNC .GE. 0.0022) THEN
            NPT = 3
         ELSE IF (FUNC .GE. 0.0001) THEN
            NPT = 2
         ELSE IF (FUNC .GE. 1.E-10) THEN
            PROFIL = FUNC
            DFBY = ONEMP3*F**2
            DEBY = 0.6931472*PAR(3)*E
            DBYX0 = 2.*DX/P1SQ
            DBYY0 = 2.*DY/P2SQ
            DHDXC = DEBY*(DBYX0 + DY*PAR(4)) +
     .              DFBY*(DBYX0 + DY*PAR(5))
            DHDYC = DEBY*(DBYY0 + DX*PAR(4)) +
     .              DFBY*(DBYY0 + DX*PAR(5))
            IF (IDERIV .GT. 0) THEN
               DBYX0 = DBYX0*DX/PAR(1)
               DBYY0 = DBYY0*DY/PAR(2)
               TERM(5) = -DFBY * XY
               DFBY = DFBY + DEBY
               TERM(1) = DFBY * DBYX0
               TERM(2) = DFBY * DBYY0
               TERM(3) = E - F
               TERM(4) = - DEBY * XY
            END IF
            RETURN
         ELSE
            RETURN
         END IF
C
         DO IX=1,NPT
            X(IX) = DX+D(IX,NPT)
            P1XSQ(IX) = X(IX)/P1SQ
         END DO
C
         DO IY=1,NPT
            Y = DY+D(IY,NPT)
            P2YSQ = Y/P2SQ
            DO IX=1,NPT
               WT = W(IY,NPT)*W(IX,NPT)
               XY = X(IX)*Y
               RSQ = P1XSQ(IX)*X(IX) + P2YSQ*Y
               F = 1./(1.+RSQ+PAR(5)*XY)
               DEBY = RSQ + PAR(4)*XY
               IF (DEBY .LT. 34.) THEN
                  E = EXP(-0.6931472*DEBY)
                  FUNC = PAR(3)*E + ONEMP3*F
                  DEBY = 0.6931472*WT*PAR(3)*E
               ELSE
                  E = 0.
                  FUNC = ONEMP3*F
                  DEBY = 0.
               END IF
               PROFIL = PROFIL + WT*FUNC
               DFBY = WT*ONEMP3*F**2
               DBYX0 = 2.*P1XSQ(IX)
               DBYY0 = 2.*P2YSQ
               DHDXC = DHDXC +
     .              DEBY*(DBYX0 + DY*PAR(4)) +
     .              DFBY*(DBYX0 + DY*PAR(5))
               DHDYC = DHDYC +
     .              DEBY*(DBYY0 + DX*PAR(4)) +
     .              DFBY*(DBYY0 + DX*PAR(5))
               IF (IDERIV .GT. 0) THEN
                  DBYX0 = DBYX0*DX/PAR(1)
                  DBYY0 = DBYY0*DY/PAR(2)
                  TERM(1) = TERM(1) + (DFBY+DEBY)*DBYX0
                  TERM(2) = TERM(2) + (DFBY+DEBY)*DBYY0
                  TERM(3) = TERM(3) + WT*(E-F)
                  TERM(4) = TERM(4) - DEBY * XY
                  TERM(5) = TERM(5) - DFBY * XY
               END IF
            END DO
         END DO
      ELSE IF (IPSTYP .EQ. 3) THEN
C
C MOFFAT FUNCTION   BETA = 1.5
C
C                            BETA-1
C F = --------------------------------------------------------
C      Ax * Ay * [1 + (X/Ax)**2 + (Y/Ay)**2 + (XY*Axy)]**BETA
C
C PAR(1) is the HWHM in x at y = 0:
C
C             1/2 = 1/[1 + (PAR(1)/Ax)**2]**BETA
C so
C             2**(1/BETA) - 1 = (PAR(1)/Ax)**2
C
C             Ax**2 = PAR(1)**2/[2**(1/BETA) - 1]
C
C When BETA = 1.5, Ax**2 = 1.7024144 * PAR(1)**2
C
C Hence, let us use
C
C                                  1
C F = ---------------------------------------------------------------
C     P(1)*P(2)*{1+0.5874011*[(X/P(1))**2+(Y/P(2))**2+(XY*P(3))]**1.5
C
C neglecting a constant of proportionality.
C
         ALPHA = 0.5874011
         TALPHA = 1.1748021  ! 2.*ALPHA
         P1SQ = PAR(1)**2
         P2SQ = PAR(2)**2
         P1P2 = PAR(1)*PAR(2)
         XY = DX*DY
C
         DENOM = 1. + ALPHA*(DX**2/P1SQ + DY**2/P2SQ + XY*PAR(3))
         IF (DENOM .GT. 5.E6) RETURN
         FUNC = 1. / (P1P2 * DENOM**PAR(4))
         IF (FUNC .GE. 0.046) THEN
            NPT = 4
         ELSE IF (FUNC .GE. 0.0022) THEN
            NPT = 3
         ELSE IF (FUNC .GE. 0.0001) THEN
            NPT = 2
         ELSE IF (FUNC .GE. 1.E-10) THEN
            PROFIL = (PAR(4) - 1.) * FUNC
            P4FOD = PAR(4)*ALPHA*PROFIL/DENOM
            DHDXC = P4FOD*(2.*DX/P1SQ + DY*PAR(3))
            DHDYC = P4FOD*(2.*DY/P2SQ + DX*PAR(3))
            IF (IDERIV .GT. 0) THEN
               TERM(1) = (2.*P4FOD*DX**2/P1SQ-PROFIL)/PAR(1)
               TERM(2) = (2.*P4FOD*DY**2/P2SQ-PROFIL)/PAR(2)
               TERM(3) = - P4FOD*XY
C              TERM(4) = PROFIL*(1./(PAR(4)-1.)-ALOG(DENOM))
            END IF
            RETURN
         ELSE
            RETURN
         END IF
C
         DO IX=1,NPT
            X(IX) = DX+D(IX,NPT)
            XSQ(IX) = X(IX)**2
            P1XSQ(IX) = XSQ(IX)/P1SQ
         END DO
C
         DO IY=1,NPT
            Y = DY+D(IY,NPT)
            YSQ = Y**2
            P2YSQ = YSQ/P2SQ
            DO IX=1,NPT
               WT = W(IY,NPT)*W(IX,NPT)
               XY=X(IX)*Y
               DENOM = 1. + ALPHA*(P1XSQ(IX) + P2YSQ + XY*PAR(3))
               FUNC = (PAR(4) - 1.)/ (P1P2 * DENOM**PAR(4))
               P4FOD = PAR(4)*ALPHA*FUNC/DENOM
               WP4FOD = WT*P4FOD
               WF = WT*FUNC
               PROFIL = PROFIL + WF
               DHDXC = DHDXC + WP4FOD*(2.*X(IX)/P1SQ + Y*PAR(3))
               DHDYC = DHDYC + WP4FOD*(2.*Y/P2SQ + X(IX)*PAR(3))
               IF (IDERIV .GT. 0) THEN
                  TERM(1) = TERM(1) +
     .                     (2.*WP4FOD*P1XSQ(IX)-WF)/PAR(1)
                  TERM(2) = TERM(2) +
     .                     (2.*WP4FOD*P2YSQ-WF)/PAR(2)
                  TERM(3) = TERM(3) - WP4FOD*XY
C                 TERM(4) = TERM(4) + WF*(1./(PAR(4)-1.)-ALOG(DENOM))
               END IF
            END DO
         END DO
      ELSE IF (IPSTYP .EQ. 2) THEN
C
C LORENTZ FUNCTION
C                      1
C F = --------------------------------------
C     [1 + (X/Ax)**2 + (Y/Ay)**2 + (XY*Axy)]
C
C PAR(1) is the HWHM in x at y = 0.
C
         P1SQ = PAR(1)**2
         P2SQ = PAR(2)**2
         P1P2 = PAR(1)*PAR(2)
         XY = DX*DY
C
         DENOM = 1. + DX**2/P1SQ + DY**2/P2SQ + XY*PAR(3)
C        DENOM = 1. + P1XSQ(IX) + P2YSQ + XY*PAR(3)
         IF (DENOM .GT. 1.E10) RETURN
         FUNC = 1. / DENOM
         IF (FUNC .GE. 0.046) THEN
            NPT = 4
         ELSE IF (FUNC .GE. 0.0022) THEN
            NPT = 3
         ELSE IF (FUNC .GE. 0.0001) THEN
            NPT = 2
         ELSE IF (FUNC .GE. 1.E-10) THEN
            PROFIL = FUNC
            WFSQ = FUNC**2
            DHDXC = WFSQ*(2.*DX/P1SQ + DY*PAR(3))
            DHDYC = WFSQ*(2.*DY/P2SQ + DX*PAR(3))
            IF (IDERIV .GT. 0) THEN
               TERM(1) = WFSQ*(2.*DX**2/P1SQ)/PAR(1)
               TERM(2) = WFSQ*(2.*DY**2/P2SQ)/PAR(2)
               TERM(3) = - WFSQ*XY
            END IF
            RETURN
         ELSE
            RETURN
         END IF
C
         DO IX=1,NPT
            X(IX) = DX+D(IX,NPT)
            XSQ(IX) = X(IX)**2
            P1XSQ(IX) = XSQ(IX)/P1SQ
         END DO
C
         DO IY=1,NPT
            Y = DY+D(IY,NPT)
            YSQ = Y**2
            P2YSQ = YSQ/P2SQ
            DO IX=1,NPT
               WT = W(IY,NPT)*W(IX,NPT)
               XY=X(IX)*Y
               DENOM = 1. + P1XSQ(IX) + P2YSQ + XY*PAR(3)
               FUNC = 1. / DENOM
               WF = WT*FUNC
               WFSQ = WF*FUNC
               PROFIL = PROFIL + WF
               DHDXC = DHDXC + WFSQ*(2.*X(IX)/P1SQ + Y*PAR(3))
               DHDYC = DHDYC + WFSQ*(2.*Y/P2SQ + X(IX)*PAR(3))
               IF (IDERIV .GT. 0) THEN
                  TERM(1) = TERM(1) + WFSQ*(2.*P1XSQ(IX))/PAR(1)
                  TERM(2) = TERM(2) + WFSQ*(2.*P2YSQ)/PAR(2)
                  TERM(3) = TERM(3) - WFSQ*XY
               END IF
            END DO
         END DO
      ELSE
         CALL STUPID ('Invalid PSF type.')
         CALL BYEBYE
      END IF
      RETURN
      END!
C
C=======================================================================
C
      INTEGER FUNCTION NPARAM  (IPSTYP, FWHM, LABEL, PAR, MAXPAR)
      IMPLICIT NONE
C
      INTEGER      IPSTYP
      REAL         FWHM
      CHARACTER*8  LABEL
      INTEGER      MAXPAR
      REAL         PAR(MAXPAR)
C
      PAR(1) = FWHM/2.
      PAR(2) = PAR(1)
      IF (IPSTYP .EQ. 1) THEN
         NPARAM = 2
         LABEL = 'GAUSSIAN'
      ELSE IF (IPSTYP .EQ. 4) THEN
         NPARAM = 3
         PAR(3) = 0.
         PAR(4) = 2.5
         LABEL = 'MOFFAT25'
      ELSE IF (IPSTYP .EQ. 5) THEN
         NPARAM = 4
         PAR(3) = 0.75
         PAR(4) = 0.0
         LABEL = 'PENNY1  '
      ELSE IF (IPSTYP .EQ. 6) THEN
         NPARAM = 5
         PAR(3) = 0.75
         PAR(4) = 0.0
         PAR(5) = 0.0
         LABEL = 'PENNY2  '
      ELSE IF (IPSTYP .EQ. 3) THEN
         NPARAM = 3
         PAR(3) = 0.
         PAR(4) = 1.5
         LABEL = 'MOFFAT15'
      ELSE IF (IPSTYP .EQ. 2) THEN
         NPARAM = 3
         PAR(3) = 0.
         LABEL = 'LORENTZ '
      ELSE
         CALL STUPID ('Invalid PSF type: '//CHAR(IPSTYP+48))
      END IF
      RETURN
      END!

C @(#)twodim.for	19.1 (ES0-DMD) 02/25/03 13:25:40
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C
C-----------------------------------------------------------------------
      SUBROUTINE TWODIM(AS, MAS, JAPYS, IBUFS, LZ,
     &                  APSF, FPSF, IPSF, NCAT, PMTR,
     &                  PRCT, NCT, PMT, PRC, IARR,
     &                  RARR, SIGMA)
C
      IMPLICIT    NONE
      INCLUDE    'MID_REL_INCL:INVENT.INC/NOLIST'
C
      REAL        AS(1)
      INTEGER     MAS((-MAXSUB):MAXSUB,(-MAXSUB):MAXSUB)
      INTEGER     JAPYS(1)
      INTEGER     IBUFS(4)
      INTEGER     LZ
      REAL        APSF(0:MAXSUB)
      REAL        FPSF(1)
      INTEGER     IPSF(1)
      INTEGER     NCAT(NIPAR,MAXCNT)
      REAL        PMTR(NRPAR,MAXCNT)
      REAL        PRCT(0:MAXSUB,MAXCNT)
      INTEGER     NCT(NIPAR)
      REAL        PMT(NRPAR)
      REAL        PRC(0:MAXSUB)
      INTEGER     IARR(32)
      REAL        RARR(64)
      REAL        SIGMA
C
      INTEGER   NP
      INTEGER   LPXL
      INTEGER   LSBP

      INTEGER   IC
      INTEGER   ICM
      INTEGER   IDF
      INTEGER   ISC
      INTEGER   IOFF, IOFF1, IOFF0, IOFFI, IOFF2, IOFFC
      INTEGER   IS, ISOLD
      INTEGER   ISTART, IACT
      INTEGER   JCM
      INTEGER   JDF
      INTEGER   JSTART, JACT
      INTEGER   I0, I0OLD
      INTEGER   J0, J0OLD
      INTEGER   JSC
      INTEGER   JS, JSOLD
      INTEGER   KCLN
      INTEGER   KSAT
      INTEGER   LPLIM
      INTEGER   MSBP2, MSBP
      INTEGER   MPXL, MPXL2
      INTEGER   MPRF
      INTEGER   NNOR
      INTEGER   NPAS
      INTEGER   NPX, NPXOLD
C     REAL      TMP(5)
      REAL      BGRD
      REAL      CORX, CORY
      REAL      SCA, SCC, SCAA
      REAL      SIGM, SHLM, SIGM1
      REAL      XDF
      REAL      YDF
      DOUBLE PRECISION   AR(25) , X(5) , S(5)
      LOGICAL   CENTER , COMP , LAST , STAR
C     LOGICAL   JCNTR

      NP = MAXCNT
      LPXL = IARR(20)
      LSBP = IARR(21)
      BGRD = PMTR(1,LZ)
      KCLN = NCAT(4,LZ)
      KSAT = NCAT(6,LZ)
      IF ( NCAT(10,LZ) .GT. 0 ) THEN
          COMP = .TRUE.
      ELSE
          COMP = .FALSE.
      ENDIF
      IF ( KSAT .EQ. -1 .AND. ABS(PMTR(3,LZ)) .LT. RARR(5) ) THEN
          STAR = .TRUE.
      ELSE
          STAR = .FALSE.
      ENDIF
      MSBP = 2 * LSBP + 1
      MPXL = 2 * LPXL + 1
      MSBP2 = MSBP * MSBP
      MPXL2 = MPXL * MPXL
      IOFF = MSBP2 * MPXL2
      MPRF = NOSP + MSBP2
C
C *** Determine scaling parameter SCA for object and SCC for component.
C
      CALL SCLDET( LZ, NCAT , PMTR , PRCT , NCT ,
     &             PMT , PRC , APSF , NPAS , SCA ,
     &             SCC )
      IF ( SCA .LE. 5.0*RARR(3) ) THEN
          STAR = .FALSE.
      ENDIF
C
C *** Save starting object coordinates.
C
      ISTART = NCAT(1,LZ)
      JSTART = NCAT(2,LZ)
C
C *** Start loop.
C
      I0 = 0
      J0 = 0
      I0OLD = 0
      J0OLD = 0
      IS    = 0                            ! addition for initialization 
      JS    = 0                            ! addition for initialization 
      ISOLD = IS
      JSOLD = JS
      NPX = 0
      NPXOLD = -1
      IC = 1
      LAST = .FALSE.
      SIGM = BGRD
      SIGM1 = 0.0
C
   10 CONTINUE
          IF ( IC .GT. 6 ) GOTO 11
C
          IF ( IC .EQ. 1 ) THEN
              SHLM = 0.6
          ELSE
              SHLM = MIN( 0.6 , 1.0 / FLOAT(MSBP) )
          ENDIF
C
C ***     Identify object coordinates and subpixel.
C
          CALL SUBPXL( NCAT(1,LZ) , PMTR(1,LZ) , LSBP , IACT , JACT ,
     &                 IS , JS )
          I0 = IACT - ISTART
          J0 = JACT - JSTART
          IF ( IC .EQ. 6 .OR. ( IC .GT. 1 .AND. I0 .EQ. I0OLD .AND.
     &             J0 .EQ. J0OLD .AND. IS .EQ. ISOLD .AND.
     &             JS .EQ. JSOLD .AND. NPX .EQ. NPXOLD ) ) THEN
              LAST = .TRUE.
              IC = 6
          ENDIF
          NPXOLD = NPX
C
C ***     Check component's distance.
C
          IF ( COMP ) THEN
              XDF = PMT(10) - FLOAT(NCAT(1,LZ))
              YDF = PMT(11) - FLOAT(NCAT(2,LZ))
              IDF = NCT(1) - NCAT(1,LZ)
              JDF = NCT(2) - NCAT(2,LZ)
              IF ( ABS(IDF) .LE. LPXL .AND. ABS(JDF) .LE. LPXL ) THEN
                  CENTER = .TRUE.
C
C ***             Identify component's subpixel.
C
                  CALL SUBPXL( NCT , PMT , LSBP , ICM , JCM ,
     &                         ISC , JSC )
              ELSE
                  CENTER = .FALSE.
              ENDIF
          ELSE
              CENTER = .FALSE.
          ENDIF
C
C ***     IOFF0 - adress of psf for central pixel at given IS and JS.
C
          IOFF0 = ( (LSBP+JS) * MSBP + LSBP + IS ) * MPXL2 +
     &               LPXL * ( MPXL + 1 ) + 1
C
C ***     IOFFC - difference of adress of central
C ***     pixel at ISC and JSC minus IOFF0.
C
          IF ( CENTER ) THEN
              IOFFC = ( (JSC-JS) * MSBP + ISC - IS ) * MPXL2
          ENDIF
C
C ***     IOFF1 and IOFF2 - corresponding adresses of x and y gradients.
C
          IOFF1 = IOFF0 + IOFF
          IOFF2 = IOFF1 + IOFF
C
C ***     Check if this object can serve as standard star.
C
          LPLIM = INT( FLOAT(LPXL) * SQRT(2.0) )
          IF ( STAR .AND. LAST .AND. KCLN .GT. LPLIM
     &                         .AND. NNOR .EQ. 4 ) THEN
              IF ( SIGM1 .GT. 0.0 ) THEN
                  SCAA = SCA / SIGM1
              ELSE
                  SCAA = 0.0
              ENDIF
              CALL IFSTAR( IBUFS , SCAA , LPXL , LSBP , IS ,
     &                     JS , MPRF , IPSF , FPSF , IOFF0 ,
     &                     IOFF , STAR , IOFFI )
              IC = 7
          ENDIF
C
C ***     Calculate normal equations.
C
          CALL NRMLEQ( AS , MAS , JAPYS , IBUFS , LPXL ,
     &                 APSF , FPSF , IOFF0 , IOFF1 , IOFF2 ,
     &                 IOFFI , BGRD , I0 , J0 , SCA ,
     &                 COMP , SCC , CENTER , IDF , JDF ,
     &                 XDF , YDF , IOFFC , IC , SIGM ,
     &                 NPX , AR )
C
C ***     Solve normal equations if there is enough of good points.
C
          IF ( COMP ) THEN
              NNOR = 5
          ELSE
              NNOR = 4
          ENDIF
          IF ( NPX .GT. NNOR .AND. ( .NOT. LAST ) ) THEN
              CALL LSQSOL ( NNOR , AR , NPX , X , S )
              SIGM = SNGL(S(NNOR))
              SCA = SCA + SNGL(X(1))
              CORX = SNGL(X(2))
C
C ***         Save sigma from the first, non trimmed
C ***         determination of object intensity.
C
              IF ( IC .EQ. 1 ) THEN
                  SIGM1 = SNGL(S(1))
              ENDIF
              IF ( ABS(CORX) .GT. SHLM ) THEN
                  CORX = SHLM * CORX / ABS(CORX)
              ENDIF
              PMTR(10,LZ) = FLOAT(NCAT(1,LZ)) +
     &                      FLOAT(IS) / FLOAT(MSBP) - CORX
              PMTR(22,LZ) = SNGL(S(2))
              NCAT(1,LZ) = NINT(PMTR(10,LZ))
              CORY = SNGL(X(3))
              IF ( ABS(CORY) .GT. SHLM ) THEN
                  CORY = SHLM * CORY / ABS(CORY)
              ENDIF
              PMTR(11,LZ) = FLOAT(NCAT(2,LZ)) +
     &                      FLOAT(JS) / FLOAT(MSBP) - CORY
              PMTR(23,LZ) = SNGL(S(3))
              NCAT(2,LZ) = NINT(PMTR(11,LZ))
              IF ( COMP ) THEN
                  SCC = SCC + SNGL(X(4))
              ENDIF
          ENDIF
C
          ISOLD = IS
          JSOLD = JS
          I0OLD = I0
          J0OLD = J0
C
          IC = IC + 1
          GOTO 10
   11 CONTINUE
C
C *** Apply corrections.
C
      IF ( NPXOLD .GT. NNOR ) THEN
          PMTR(12,LZ) = SCA
          IF ( SCA .GT. 0.0 ) THEN
              PMTR(24,LZ) = 1.086 * SNGL(S(1)) / SCA
          ELSE
              PMTR(24,LZ) = 1.0
          ENDIF
          NCAT(9,LZ) = 1
          IF ( NCAT(10,LZ) .GT. 0 ) THEN
              PMT(2) = SCC / ( 9.0 / ( 1.0 + 8.0 * APSF(1) ) )
              PMT(12) = SCC
          ENDIF
      ELSE
          NCAT(9,LZ) = 0
      ENDIF
      SIGMA = SNGL(S(NNOR))
C
      RETURN
C
      END

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C       Internet e-mail: midas@eso.org
C       Postal address: European Southern Observatory
C                       Data Management Division 
C                       Karl-Schwarzschild-Strasse 2
C                       D 85748 Garching bei Muenchen 
C                       GERMANY
C===========================================================================
C
C.VERSION
C 
C 100701	last modif  KB
C 

C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
      SUBROUTINE GetIDN(TblNam,inum,iok)
C
C     Reads the highest IDnumer in a table  "TblNam"
C     iok=0 if ok
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        implicit none
        character*(*)TblNam
        integer iok,inum

        include 'MID_REL_INCL:fit_var.inc'
        integer TabID,ist,icol
        integer i,j,k1,k2,n,in,i1,i2,i3
        logical inull,isel

        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'

        i1=1                    !doesn't stop on errors
        i2=0
        i3=0
        call STECNT('PUT',i1,i2,i3)

        call TBTOPN(TblNam,F_IO_MODE,TabID,ist)   !open
        if (ist.ne.0) then
           iok=1
           return
        end if 

        call TBLSER(TabID,'ID',icol,ist)

        call TBCSRT(TabID,1,icol,1,ist)  ! sort

        call TBIGET(TabID,I,J,K1,k2,n,ist)      !n. of written rows

        do j=n,1,-1
           call TBSGET(TabID,j,isel,ist)   ! checks selection
           call TBERDI(TabID,j,icol,in,inull,ist)
           if (ist.ne.0) then
              iok=1
              return
           end if
           if (.not.inull.and.isel) then
              inum=in
              CALL TBTCLO(TabID,ist)
              i1=0              !doesn't stop on errors
              i2=2
              i3=1
              call STECNT('PUT',i1,i2,i3)
              return
           end if
        end do

        CALL TBTCLO(TabID,ist)
        i1=0                    !doesn't stop on errors
        i2=2
        i3=1
        call STECNT('PUT',i1,i2,i3)
        return

        end



C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
      SUBROUTINE SavRes(TblNam,iok)
C
C     Saves the results on the output table "TblNam"
C     iok=0 if ok
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        character*(*)TblNam
        integer iok

        include 'MID_REL_INCL:fit_var.inc'

        integer j,i1,i2,i3,i,k1,k2,n
        integer TabID,ist
        integer icol(25)
        integer itot

        logical inull

        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'

C!!!!!!!
C       Creates/opens the table and reads the column numbers
C!!!!!!!
        i1=1                    !doesn't stop on errors
        i2=0
        i3=0
        call STECNT('PUT',i1,i2,i3)

        call TBTOPN(TblNam,F_IO_MODE,TabID,ist)   !open

      if (ist.ne.0) then      !not found, creates
        call TBTINI(TblNam,F_TRANS,F_O_MODE,21,1,TabID,ist)
        call TBCINI(TabID,D_C_FORMAT,14,'A14',' ','Element',icol(1),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F7.2',' ','LamCen',icol(2),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F7.2',' ','Dlam',icol(3),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F9.7',' ','Redshift',icol(22)
     1       ,i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F7.2',' ','ColDen',icol(4),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F7.2',' ','DCol',icol(5),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F7.2',' ','B',icol(6),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F7.2',' ','DB',icol(7),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F7.2',' ','BTur',icol(8),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F7.2',' ','DBtur',icol(9),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F7.0',' ','Temperature',
     1       icol(23),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F8.2',' ','Eq_Width',icol(10),
     1       i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F7.2',' ','chi2',icol(11),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F7.2',' ','Prob',
     1       icol(12) ,i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F7.2',' ','Dlam_p',icol(13),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F7.2',' ','Dlam_n',icol(14),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F7.2',' ','DCol_p',icol(15),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F7.2',' ','DCol_n',icol(16),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F7.2',' ','DB_p',icol(17),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F7.2',' ','DB_n',icol(18),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F7.2',' ','DBTur_p',icol(19)
     1       ,i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F7.2',' ','DBTur_n',icol(20),
     1       i)
        call TBCINI(TabID,D_I4_FORMAT,1,'I5',' ','ID',icol(21),i)

      else 

        call TBLSER(TabID,'Element',icol(1),ist)
        call TBLSER(TabID,'LamCen',icol(2),ist)
        call TBLSER(TabID,'DLam',icol(3),ist)
        call TBLSER(TabID,'Redshift',icol(22),ist)
        if (icol(22).eq.-1) then
           call TBCINI(TabID,D_R8_FORMAT,1,'F9.7',' ',
     1       'Redshift',icol(22),i)
        end if
        call TBLSER(TabID,'ColDen',icol(4),ist)
        call TBLSER(TabID,'DCol',icol(5),ist)
        call TBLSER(TabID,'B',icol(6),ist)
        call TBLSER(TabID,'DB',icol(7),ist)
        call TBLSER(TabID,'BTur',icol(8),ist)
        call TBLSER(TabID,'DBTur',icol(9),ist)
        call TBLSER(TabID,'Temperature',icol(23),ist)
        if (icol(23).eq.-1) then
           call TBCINI(TabID,D_R8_FORMAT,1,'F7.0',' ',
     1       'Temperature',icol(23),i)
        end if
        call TBLSER(TabID,'Eq_Width',icol(10),ist)
        call TBLSER(TabID,'chi2',icol(11),ist)
        call TBLSER(TabID,'Prob',icol(12),ist)
        call TBLSER(TabID,'Dlam_p',icol(13),ist)
        call TBLSER(TabID,'Dlam_n',icol(14),ist)
        call TBLSER(TabID,'DCol_p',icol(15),ist)
        call TBLSER(TabID,'DCol_n',icol(16),ist)
        call TBLSER(TabID,'DB_p',icol(17),ist)
        call TBLSER(TabID,'DB_n',icol(18),ist)
        call TBLSER(TabID,'DBtur_p',icol(19),ist)
        call TBLSER(TabID,'DBtur_n',icol(20),ist)
        call TBLSER(TabID,'ID',icol(21),ist)

        call TBIGET(TabID,I,J,K1,k2,n,ist)      !n. of written rows
        itot=0
        do j=1,n
           call TBERDI(TabID,j,icol(21),i,inull,ist)
           if (.not.inull) itot=itot+1
        end do
      end if  

C!!!!!!!
C       Writes the variables
C!!!!!!!
      IF (NROWS.GT.0) THEN
        do j=itot+1,itot+nrows
           call TBEWRC(TabID,j,icol(1),ElmtNm(j-itot),ist)
           call TBEWRR(TabID,j,icol(2),LamCen(j-itot),ist)
           call TBEWRR(TabID,j,icol(3),ErLaPa(j-itot),ist)
           call TBEWRR(TabID,j,icol(22),Redshi(j-itot),ist)
           call TBEWRR(TabID,j,icol(4),NHfit(j-itot),ist)
           call TBEWRR(TabID,j,icol(5),ErNnPa(j-itot),ist)
           call TBEWRR(TabID,j,icol(6),BDopp(j-itot),ist)
           call TBEWRR(TabID,j,icol(7),ErBbPa(j-itot),ist)
           call TBEWRR(TabID,j,icol(8),BTur(j-itot),ist)
           call TBEWRR(TabID,j,icol(9),ErBtPa(j-itot),ist)
           call TBEWRR(TabID,j,icol(23),Temper(j-itot),ist)
           call TBEWRR(TabID,j,icol(10),w(j-itot),ist)
           call TBEWRR(TabID,j,icol(11),chi,ist)
           call TBEWRR(TabID,j,icol(12),prob,ist)
           call TBEWRR(TabID,j,icol(13),ErLaPo(j-itot),ist)
           call TBEWRR(TabID,j,icol(14),ErLaNe(j-itot),ist)
           call TBEWRR(TabID,j,icol(15),ErNnPo(j-itot),ist)
           call TBEWRR(TabID,j,icol(16),ErNnNe(j-itot),ist)
           call TBEWRR(TabID,j,icol(17),ErBbPo(j-itot),ist)
           call TBEWRR(TabID,j,icol(18),ErBbNe(j-itot),ist)
           call TBEWRR(TabID,j,icol(19),ErBtPo(j-itot),ist)
           call TBEWRR(TabID,j,icol(20),ErBtNe(j-itot),ist)
           call TBEWRI(TabID,j,icol(21),IDnum,ist)
        end do

      END IF

        CALL TBTCLO(TabID,ist)

        i1=0                    !doesn't stop on errors
        i2=2
        i3=1
        call STECNT('PUT',i1,i2,i3)

        return
        end



C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
      SUBROUTINE FitWin(nconv,iflag)
C     
C     Calcola la finestra su cui eseguire il fit,
C     e salva la porzione corrispondente dello spettro
C     sul file 'fdummy.spe'
C     
C     
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
      
      IMPLICIT NONE
      integer nconv,iflag
      
      INCLUDE 'MID_REL_INCL:fit_var.inc'
      integer ind_low,ind_up,old_up
      integer ij,ik,is
      
      real xmin,xmax,var
      real fwhmth               ! threshold in FWHM!!!!!
      
      INTEGER MADRID(1)
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      
      COMMON/VMR/MADRID
      
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'

      fwhmth=8.
      iflag=0                   ! default: no error
      nconv=0
      old_up=1
      
c!!!!!!!
C     Apre file fdummy.spe
C!!!!!!!
      open(10,file='fdummy.spe',status='old',iostat=is) !
      close(10,status='DELETE')
      
      open(10,file='fdummy.spe',status='new',iostat=is) !
      if (is.ne.0) then
         call ErrMsg('Error in opening fdummy.spe')
         iflag=-1
         return
      end if
      
      
      do ij = 1,NINTFT
C!!!!!!!
C     Cerca gli indici del primo ed ultimo punto della finestra ij-esima
C!!!!!!!
         xmin=FITMIN(ij)
         xmax=FITMAX(ij)
         
         do ik=1,NPUNTI
            if (XLAMBD(ik).gt.xmin) goto 100
         end do
 100     ind_low=ik             ! indice inferiore
         
         do ik=ind_low,NPUNTI
            if (XLAMBD(ik).gt.xmax) goto 200
         end do
 200     ind_up=ik              ! indice superiore
         
         xmin = FITMIN(ij) - fwhmth * FWHM(ind_low)
         xmax = FITMAX(ij) + fwhmth * FWHM(ind_up)
         
         do ik=1,NPUNTI
            if (XLAMBD(ik).gt.xmin) goto 300
         end do
 300     ind_low=ik             ! indice inferiore
         
         do ik=ind_low,NPUNTI
            if (XLAMBD(ik).gt.xmax) goto 400
         end do
 400     ind_up=ik              ! indice superiore
      
   
         if (ind_low.lt.old_up) then
            ind_low = old_up + 1
         end if
c         old_up = ind_low
         old_up = ind_up
         
         if (ind_low.lt.ind_up) then
            do ik = ind_low,ind_up
               var=SIGNOI(ik)*SIGNOI(ik)
               write(10,'(5G20.12)')XLAMBD(ik),PIXSIZ(ik),SPECTR(ik),
     +              var,FWHM(ik)
c               write(10,'(5G20.12)')XLAMBD(ik),SPECTR(ik),var,FWHM(ik)
               nconv = nconv +1
            end do
            if (nconv.gt.NMXWRK) then
               iflag=-1
               return
            end if
         end if
      end do
      
      close(10)
      
      
      return
      end
      
      

C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE SMINUI(TblNam,nrun,IER)
C
C     
C       Saves the MINUIT INSTRUCTIONS on a table.
C     nrun is the IDNumber of the run. If nrun=1 a new table
C     is created.
C     On error in creating the table,  ier=1
C     otherwise ier=0
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

        implicit none

        character*(*) TblNam
        integer ier,nrun

        include 'MID_REL_INCL:fit_var.inc'

        integer j,i1,i2,i3,i4,nlines
        integer TabID,ist
        integer icol(2)
C
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'

        i1=1                    !doesn't stop at errors..
        i2=0
        i3=0
        call STECNT('PUT',i1,i2,i3)

        if (nrun.lt.1) then
           ier=-1
           return
        end if

        if (nrun.gt.1) then
           call TBTOPN(TblNam,F_IO_MODE,TabID,ist) !open
           if (ist .ne. 0 ) then ! if it doesn't exist, create
              call TBTINI(TblNam,F_TRANS,F_O_MODE,1,10,TabID,ist)
              if (ist .ne. 0 ) then
                 ier=1
                 return
              end if   
              call TBCINI(TabID,D_C_FORMAT,50,'A50',' ','MINUIT'
     1             ,icol(1),ist)
              call TBCINI(TabID,D_I4_FORMAT,1,'i9',' ','ID',
     1             icol(2),ist)
           end if
        end if
        if (nrun.eq.1) then
           call TBTINI(TblNam,F_TRANS,F_O_MODE,1,10,TabID,ist)
           if (ist .ne. 0 ) then
              ier=1
              return
           end if
           call TBCINI(TabID,D_C_FORMAT,50,'A50',' ','MINUIT',icol(1)
     1          ,ist)
           call TBCINI(TabID,D_I4_FORMAT,1,'i9',' ','ID',icol(2)
     1          ,ist)
        end if
        
        call TBIGET(TabID,i1,nlines,i3,i4,i2,ist) !n. of written lines

        do j=1+nlines,NMINCM+nlines
           call TBEWRC(TabID,j,icol(1),MINCOM(j-nlines),ist)
           call TBEWRI(TabID,j,icol(2),nrun,ist)
        end do
        
        CALL TBTCLO(TabID,ist)
        
        i1=0                    !reset standard values..
        i2=2
        i3=1
        call STECNT('PUT',i1,i2,i3)
        
        return
        end








C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE RMINUI(TblNam,nrun,IER)
C
C     
C       Reads the MINUIT INSTRUCTIONS from a table.
C     Onerror in reading the table,  ier=1
C     otherwise ier=0
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        implicit none

        character*(*) TblNam
        integer ier,nrun

        include 'MID_REL_INCL:fit_var.inc'

        logical inull,isel
        integer i,j,i1,i2,i3,i4,ntest,in
        integer TabID,ist
        integer icol(2)
        character*50 ctest

        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'

        if (nrun.lt.1) then
           ier=-1
           return
        end if

        do i=1,NMXLIN
           MINCOM(i)=' '
        end do
        NMINCM=0
        if (TblNam.eq.'SCRATCH') return

        i1=1                    !doesn't stop at errors..
        i2=0
        i3=0
        call STECNT('PUT',i1,i2,i3)

        call TBTOPN(TblNam,F_IO_MODE,TabID,ist)   !open
        if (ist .ne. 0 ) then       ! if it doesn't exist, return err
           call seterr('ON')
           ier=1
           return
        end if
        call TBLSER(TabID,'MINUIT',icol(1),ist)
        call TBLSER(TabID,'ID',icol(2),ist)
        call TBIGET(TabID,i1,i2,i3,i4,ntest,ist)

        
        i=0
        do j=1,ntest
           call TBSGET(TabID,j,isel,ist)   ! checks selection
           call TBERDI(TabID,j,icol(2),in,inull,ist)
           if (ist.ne.0) then
              ier=1
              return
           end if
           if (.not.inull.and.isel) then
              if (in.eq.nrun) then
                 call TBERDC(TabID,j,icol(1),ctest,inull,ist)
                 i = i +1 
                 CALL FT_EOS(ctest,50,MINCOM(i),ist)
              end if
           end if
        end do

        NMINCM=i
        
        CALL TBTCLO(TabID,ist)

        i1=0                    !reset standard values..
        i2=2
        i3=1
        call STECNT('PUT',i1,i2,i3)

        return
        end





C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE SINTVL(TblNam,nrun,IER)
C
C     
C       Saves the intervals for the fit on a table.
C     Onerror in creating the table,  ier=1
C     otherwise ier=0
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        implicit none

        character*(*) TblNam
        integer ier,nrun

        include 'MID_REL_INCL:fit_var.inc'

        integer j,i1,i2,i3,i4,nlines
        integer TabID,ist
        integer icol(3)

C        include 'MID_REL_INCL:fit_mid.inc'
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'

        i1=1                    !reset standard values..
        i2=0
        i3=0
        call STECNT('PUT',i1,i2,i3)

        if (nrun.lt.1) then
           ier=-1
           return
        end if

C
C     opens or creates...
C
        if (nrun.gt.1) then
           call TBTOPN(TblNam,F_IO_MODE,TabID,ist) !open
           if (ist .ne. 0 ) then ! if it doesn't exist, create
              call TBTINI(TblNam,F_TRANS,F_O_MODE,2,10,TabID,ist)
              if (ist .ne. 0 ) then
                 ier=1
                 return
              end if
              call TBCINI(TabID,D_R8_FORMAT,1,'F8.2',' ','FITMIN'
     1             ,icol(1),ist)
              call TBCINI(TabID,D_R8_FORMAT,1,'F8.2',' ','FITMAX'
     1             ,icol(2),ist)
              call TBCINI(TabID,D_I4_FORMAT,1,'i9',' ','ID',
     1             icol(3),ist)
           end if
        end if

        if (nrun.eq.1) then
           call TBTINI(TblNam,F_TRANS,F_O_MODE,1,10,TabID,ist)
           if (ist .ne. 0 ) then
              ier=1
              return
           end if
           call TBCINI(TabID,D_R8_FORMAT,1,'F8.2',' ','FITMIN'
     1          ,icol(1),ist)
           call TBCINI(TabID,D_R8_FORMAT,1,'F8.2',' ','FITMAX'
     1          ,icol(2),ist)
           call TBCINI(TabID,D_I4_FORMAT,1,'i9',' ','ID',
     1             icol(3),ist)
        end if

        call TBIGET(TabID,i1,nlines,i3,i4,i2,ist) !n. of written lines

c
c     writes..
c
        do j=1+nlines,NINTFT+nlines
           call TBEWRD(TabID,j,icol(1),FITMIN(j-nlines),ist)
           call TBEWRD(TabID,j,icol(2),FITMAX(j-nlines),ist)
           call TBEWRI(TabID,j,icol(3),nrun,ist)
        end do

        CALL TBTCLO(TabID,ist)

        i1=0                    !reset standard values..
        i2=2
        i3=1
        call STECNT('PUT',i1,i2,i3)

        return
        end








C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE RINTVL(TblNam,nrun,IER)
C
C     
C       Reads the intervals for the fit from a table.
C     Onerror in reading the table,  ier=1
C     otherwise ier=0
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        implicit none

        character*(*) TblNam
        integer ier,nrun

        include 'MID_REL_INCL:fit_var.inc'

        logical inull,isel
        integer i,j,i1,i2,i3,i4,ntest
        integer TabID,ist,in
        integer icol(3)

C        include 'MID_REL_INCL:fit_mid.inc'
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'

        if (nrun.lt.1) then
           ier=-1
           return
        end if

        do i=1,NMXLIN
           FITMIN(i)=0.
           FITMAX(i)=0.
        end do
        NINTFT=0
        if (TblNam.eq.'SCRATCH') return

        call seterr('OFF')

        call TBTOPN(TblNam,F_IO_MODE,TabID,ist)   !open
        if (ist .ne. 0 ) then       ! if it doesn't exist, return err
           call seterr('ON')
           ier=1
           return
        end if
        call TBLSER(TabID,'FITMIN',icol(1),ist)
        call TBLSER(TabID,'FITMAX',icol(2),ist)
        call TBLSER(TabID,'ID',icol(3),ist)
        call TBIGET(TabID,i1,i2,i3,i4,ntest,ist)

        
        i=0
        do j=1,ntest
           call TBSGET(TabID,j,isel,ist)   ! checks selection
           call TBERDI(TabID,j,icol(3),in,inull,ist)
           if (ist.ne.0) then
              ier=1
              return
           end if
           if (.not.inull.and.isel) then
              if (in.eq.nrun) then
                 i = i +1 
                 call TBERDD(TabID,j,icol(1),FITMIN(i),inull,ist)
                 call TBERDD(TabID,j,icol(2),FITMAX(i),inull,ist)
                 if (ist.ne.0) then
                    ier=1
                    return
                 end if
              end if
           end if
        end do

        NINTFT=i
        
        CALL TBTCLO(TabID,ist)

        call seterr('ON')

        return
        end



C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE F_TBLR(TblNam,nrun,ier)
C
C     
C       Reads the "lypar" table and store the values in the 
C       COMMON variables
C       On error then ier =-1
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        implicit none

        character*(*) TblNam
        integer ier,nrun
        

        include 'MID_REL_INCL:fit_var.inc'

        logical inull,isel
        integer i,j,k,itest
        integer TabID,ist
        integer icol(COLTBL)
        integer i1,i2,i3

        CHARACTER*14  ctest
 
C        include 'MID_REL_INCL:fit_mid.inc'
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'

        ier = 0
C!!!!!!!
C       reset  the variables to defaults
C!!!!!!!
        do i=1,NMXLIN
           ElmtNm(i)=' '
           LamIni(i)=0.
           BIni(i)=0.
           BtuIni(i)=0.
           NIni(i)=0.
           CPAR(1,i)=' '
           CPAR(2,i)=' '
           CPAR(3,i)=' '
           CPAR(4,i)=' '
           LamMin(i)=0.
           LamMax(i)=0.
           BMin(i)=0.
           BMax(i)=0.
           BtuMin(i)=0.
           BtuMax(i)=0.
           NMin(i)=0.
           NMax(i)=0.
           LamSte(i)=0.005
           BSte(i)=0.01
           BtuSte(i)=0.01
           NSte(i)=0.01
           CoefL(i)=0.
           CoefB(i)=0.
           CoefN(i)=0.
           CoefBT(i)=0.
           Class(i)=' '
           grID(i)=0
           AtmLam(i)=0.
           AtmFos(i)=0.
           AtmGam(i)=0.
           AtmMas(i)=0.
        end do
        NROWS=0

        if (TblNam.eq.'SCRATCH') return


C!!!!!!!
C       Opens the tables and reads the column numbers
C!!!!!!!

        i1=1                    !doesn't stop at errors..
        i2=0
        i3=0
        call STECNT('PUT',i1,i2,i3)

        call TBTOPN(TblNam,F_IO_MODE,TabID,ist)   !open
        if (ist .ne. 0 ) then       ! if it doesn't exist, create
           ier=-1
           return
        end if

        call TBIGET(TabID,I,J,K,k,nrows,ist)      !n. of rows


        call TBLSER(TabID,'Element',icol(1),ist)
        call TBLSER(TabID,'L_ini',icol(2),ist)
        call TBLSER(TabID,'P_l',icol(3),ist)
        call TBLSER(TabID,'N_ini',icol(4),ist)
        call TBLSER(TabID,'P_n',icol(5),ist)
        call TBLSER(TabID,'b_ini',icol(6),ist)
        call TBLSER(TabID,'P_b',icol(7),ist)
        call TBLSER(TabID,'bt_ini',icol(8),ist)
        call TBLSER(TabID,'P_bt',icol(9),ist)
        call TBLSER(TabID,'L_min',icol(10),ist)
        call TBLSER(TabID,'L_max',icol(11),ist)
        call TBLSER(TabID,'N_min',icol(12),ist)
        call TBLSER(TabID,'N_max',icol(13),ist)
        call TBLSER(TabID,'b_min',icol(14),ist)
        call TBLSER(TabID,'b_max',icol(15),ist)
        call TBLSER(TabID,'bt_min',icol(16),ist)
        call TBLSER(TabID,'bt_max',icol(17),ist)
        call TBLSER(TabID,'L_step',icol(18),ist)
        call TBLSER(TabID,'n_step',icol(19),ist)
        call TBLSER(TabID,'b_step',icol(20),ist)
        call TBLSER(TabID,'bt_step',icol(21),ist)
        call TBLSER(TabID,'Coef_l',icol(22),ist)
        call TBLSER(TabID,'Coef_n',icol(23),ist)
        call TBLSER(TabID,'Coef_b',icol(24),ist)
        call TBLSER(TabID,'Coef_bt',icol(25),ist)
        call TBLSER(TabID,'Class',icol(26),ist)
        call TBLSER(TabID,'grp',icol(27),ist)
        call TBLSER(TabID,'atm_lam',icol(28),ist)
        call TBLSER(TabID,'atm_fos',icol(29),ist)
        call TBLSER(TabID,'atm_gam',icol(30),ist)
        call TBLSER(TabID,'atm_mas',icol(31),ist)
        call TBLSER(TabID,'ID',icol(32),ist)

   
C!!!!!!!
C       Reads the variables
C for char. elements we read the table elements into ctest,
C and get the end of the string,
C and then convert to a clean (blank terminated) Fortran char. string
C - not needed for Class(i), it's a single char.
C 
C!!!!!!!

        i=0
        do j=1,nrows
           call TBSGET(TabID,j,isel,ist)   ! checks selection
           call TBERDI(TabID,j,icol(32),itest,inull,ist)
           if (.not.inull.and.isel) then
            if (itest.eq.nrun) then  
             i = i +1 
             call TBERDC(TabID,j,icol(1),ctest,inull,ist)
             call FT_EOS(ctest,14,ElmtNm(i),ist)
             call TBERDD(TabID,j,icol(2),LamIni(i),inull,ist)
             call TBERDC(TabID,j,icol(3),ctest,inull,ist)
             call FT_EOS(ctest,4,CPar(1,i),ist)
             call TBERDD(TabID,j,icol(4),NIni(i),inull,ist)
             call TBERDC(TabID,j,icol(5),ctest,inull,ist)
             call FT_EOS(ctest,4,CPar(2,i),ist)
             call TBERDD(TabID,j,icol(6),BIni(i),inull,ist)
             call TBERDC(TabID,j,icol(7),ctest,inull,ist)
             call FT_EOS(ctest,4,CPar(3,i),ist)
             call TBERDD(TabID,j,icol(8),BtuIni(i),inull,ist)
             call TBERDC(TabID,j,icol(9),ctest,inull,ist)
             call FT_EOS(ctest,4,CPar(4,i),ist)
             call TBERDD(TabID,j,icol(10),LamMin(i),inull,ist)
             call TBERDD(TabID,j,icol(11),LamMax(i),inull,ist)
             call TBERDD(TabID,j,icol(12),NMin(i),inull,ist)
             call TBERDD(TabID,j,icol(13),NMax(i),inull,ist)
             call TBERDD(TabID,j,icol(14),BMin(i),inull,ist)
             call TBERDD(TabID,j,icol(15),BMax(i),inull,ist)
             call TBERDD(TabID,j,icol(16),BtuMin(i),inull,ist)
             call TBERDD(TabID,j,icol(17),BtuMax(i),inull,ist)
             call TBERDD(TabID,j,icol(18),LamSte(i),inull,ist)
             call TBERDD(TabID,j,icol(19),NSte(i),inull,ist)
             call TBERDD(TabID,j,icol(20),BSte(i),inull,ist)
             call TBERDD(TabID,j,icol(21),BtuSte(i),inull,ist)
             call TBERDD(TabID,j,icol(22),CoefL(i),inull,ist)
             call TBERDD(TabID,j,icol(23),CoefN(i),inull,ist)
             call TBERDD(TabID,j,icol(24),CoefB(i),inull,ist)
             call TBERDD(TabID,j,icol(25),CoefBt(i),inull,ist)
C  Class(i) is 1 char., so  we don't need to use ctest and then FT_EOS()
             call TBERDC(TabID,j,icol(26),Class(i),inull,ist)
             call TBERDI(TabID,j,icol(27),grID(i),inull,ist)
             call TBERDD(TabID,j,icol(28),AtmLam(i),inull,ist)
             call TBERDD(TabID,j,icol(29),AtmFos(i),inull,ist)
             call TBERDD(TabID,j,icol(30),AtmGam(i),inull,ist)
             call TBERDD(TabID,j,icol(31),AtmMas(i),inull,ist)

            end if 
           end if  
        end do

        nrows=i

        CALL TBTCLO(TabID,ist)

        i1=0                    !stop on errors
        i2=2
        i3=1
        call STECNT('PUT',i1,i2,i3)

        return
        end

C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE ShPar1(header)
C     
C
C       Prints on the screen the content of lypar.tbl more 
C       frequently accessed by the user.
C
C       if header = 'NORMAL" the columns are well explained;
C       if header = 'EDITPARAM" only column symbols are written
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        implicit none
        character*(*) header

        include 'MID_REL_INCL:fit_var.inc'
        
        integer ifound(NMXLIN) 
        integer i,ist,j,ni,is
        character a
        character*80 strout
        character*9Parcar(4,NMXLIN)

C
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'

        do i=1,NMXLIN
           ifound(i)=0
        end do
        
        do i=1,4
           do j=1,NROWS
              call CnvrtP(CPar(i,j),ni,a,is)
              if (ifound(ni).eq.0.and.a.ne.'Z'.and.a.ne.'T') then 
                                     !never found yet nor constrained
                 ifound(ni) =1
                 if(i.eq.1) write(ParCar(i,j),97) ' ',LamIni(j),' ' 
                 if(i.eq.2) write(ParCar(i,j),98) '  ',NIni(j),' ' 
                 if(i.eq.3) write(ParCar(i,j),99) '  ',BIni(j),' ' 
                 if(i.eq.4) write(ParCar(i,j),99) '  ',BtuIni(j),' ' 
              else
                 if(i.eq.1) write(ParCar(i,j),97) '(',LamIni(j) ,')'
                 if(i.eq.2) write(ParCar(i,j),98) ' (',NIni(j),')' 
                 if(i.eq.3) write(ParCar(i,j),99) ' (',BIni(j),')' 
                 if(i.eq.4) write(ParCar(i,j),99) ' (',BtuIni(j),')' 
              end if   
 97           format(a1,f7.2,a1)
 98           format(a2,f6.3,a1)
 99           format(a2,f6.2,a1)

           end do
        end do



        call sttdis(' ',0,ist)
        write(strout,'(25x,a30)')'** Current Parameter Table **'
        call sttdis(strout,0,ist)
        call sttdis(' ',0,ist)

c        write(strout,*)' # ','   Element    '
        if (header.eq.'NORMAL') then
           write(strout,*)'  #', '  Element     ','   lambda'
     1          ,'       ','   column',' den.  ','     b  ',
     2          '      ','     bT  ','      ' 
        end if
        if (header.eq.'EDITPARAM') then
           write(strout,*)'  #', '  E           ','      L  '
     1          ,'   PL  ','     N   ','  PN   ','     B  ',
     2          '  PB  ','     BT  ','  PT  ' 
        end if

        call sttdis(strout,0,ist)  
        call sttdis(' ',0,ist)
        do i=1,nrows
          write(strout,100)i,ElmtNm(i),ParCar(1,i),CPar(1,i),
     1         ParCar(2,i),CPar(2,i),ParCar(3,i),CPar(3,i),ParCar(4,i)
     2          ,CPar(4,i)
           call sttdis(strout,0,ist)
        end do   

 100    format (i3,1x,A14,A9,'[',A4,']',A9,'[',A4,']',
     1       A9,'[',A4,']',A9,'[',A4,']')


        return
        end
           


C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE F_TBLW(TblNam,nrun,ier)
C
C     
C       Writes  the initial parameters  on a table 
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        implicit none

        character*(*) TblNam
        integer ier,nrun

        include 'MID_REL_INCL:fit_var.inc'

        integer j,i,i1,i2,i3,k1,k2,nlines
        integer TabID,ist
        integer icol(COLTBL)
        
C
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'


C!!!!!!!
C       Creates the table and reads the column numbers
C!!!!!!!
      i1=1                    !doesn't stop on errors
      i2=0
      i3=0
      call STECNT('PUT',i1,i2,i3)
      
      if (nrun.lt.1) then
         ier=-1
         return
      end if      
      
      if (nrun.gt.1) then
         call TBTOPN(TblNam,F_IO_MODE,TabID,ist) !open
      end if

      if (ist.ne.0.or.nrun.eq.1) then
         call TBTINI(TblNam,F_TRANS,F_O_MODE,COLTBL,1,TabID,ist)
         if (ist.ne.0) then
            ier=1
            return
         end if
         call TBCINI(TabID,D_C_FORMAT,14,'A14',' ','Element',icol(1),i)
         call TBCINI(TabID,D_R8_FORMAT,1,'F7.2',' ','L_ini',icol(2),i)
         call TBCINI(TabID,D_C_FORMAT,4,'A4',' ','P_l',icol(3),i)
         call TBCINI(TabID,D_R8_FORMAT,1,'F5.2',' ','N_ini',icol(4),i)
         call TBCINI(TabID,D_C_FORMAT,4,'A4',' ','P_n',icol(5),i)
         call TBCINI(TabID,D_R8_FORMAT,1,'F6.2',' ','b_ini',icol(6),i)
         call TBCINI(TabID,D_C_FORMAT,4,'A4',' ','P_b',icol(7),i)
         call TBCINI(TabID,D_R8_FORMAT,1,'F6.2',' ','bt_ini',icol(8),i)
         call TBCINI(TabID,D_C_FORMAT,4,'A4',' ','P_bt',icol(9),i)
         call TBCINI(TabID,D_R8_FORMAT,1,'F7.2',' ','l_min',icol(10),i)
         call TBCINI(TabID,D_R8_FORMAT,1,'F7.2',' ','l_max',icol(11),i)
         call TBCINI(TabID,D_R8_FORMAT,1,'F5.2',' ','N_min',icol(12),i)
         call TBCINI(TabID,D_R8_FORMAT,1,'F5.2',' ','N_max',icol(13),i)
         call TBCINI(TabID,D_R8_FORMAT,1,'F6.2',' ','b_min',icol(14),i)
         call TBCINI(TabID,D_R8_FORMAT,1,'F6.2',' ','B_max',icol(15),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F6.2',' ','bt_min',icol(16),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F6.2',' ','bt_max',icol(17),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F7.3',' ','l_step',icol(18),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F6.3',' ','n_step',icol(19),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F6.3',' ','b_step',icol(20),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F7.3',' ',
     1       'bt_step',icol(21),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'E12.6',' ','Coef_l',
     1       icol(22),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F3.1',' ','Coef_n',icol(23),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'E12.6',' ','Coef_b',
     1       icol(24),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F3.1',' ','Coef_bt',
     1       icol(25),i)
        call TBCINI(TabID,D_C_FORMAT,1,'A1',' ','Class',icol(26),i)
        call TBCINI(TabID,D_I4_FORMAT,1,'I2',' ','grp',icol(27),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F10.4',' ',
     1       'atm_lam',icol(28),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F7.5',' ',
     1       'atm_fos',icol(29),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'E10.5',' ',
     1       'atm_gam',icol(30),i)
        call TBCINI(TabID,D_R8_FORMAT,1,'F7.5',' ',
     1       'atm_mas',icol(31),i)
        call TBCINI(TabID,D_I4_FORMAT,1,'i9',' ','ID',
     1             icol(32),ist)

      else 

         call TBLSER(TabID,'Element',icol(1),ist)
         call TBLSER(TabID,'L_ini',icol(2),ist)
         call TBLSER(TabID,'P_l',icol(3),ist)
         call TBLSER(TabID,'N_ini',icol(4),ist)
         call TBLSER(TabID,'P_n',icol(5),ist)
         call TBLSER(TabID,'b_ini',icol(6),ist)
         call TBLSER(TabID,'P_b',icol(7),ist)
         call TBLSER(TabID,'bt_ini',icol(8),ist)
         call TBLSER(TabID,'P_bt',icol(9),ist)
         call TBLSER(TabID,'L_min',icol(10),ist)
         call TBLSER(TabID,'L_max',icol(11),ist)
         call TBLSER(TabID,'N_min',icol(12),ist)
         call TBLSER(TabID,'N_max',icol(13),ist)
         call TBLSER(TabID,'b_min',icol(14),ist)
         call TBLSER(TabID,'b_max',icol(15),ist)
         call TBLSER(TabID,'bt_min',icol(16),ist)
         call TBLSER(TabID,'bt_max',icol(17),ist)
         call TBLSER(TabID,'L_step',icol(18),ist)
         call TBLSER(TabID,'n_step',icol(19),ist)
         call TBLSER(TabID,'b_step',icol(20),ist)
         call TBLSER(TabID,'bt_step',icol(21),ist)
         call TBLSER(TabID,'Coef_l',icol(22),ist)
         call TBLSER(TabID,'Coef_n',icol(23),ist)
         call TBLSER(TabID,'Coef_b',icol(24),ist)
         call TBLSER(TabID,'Coef_bt',icol(25),ist)
         call TBLSER(TabID,'Class',icol(26),ist)
         call TBLSER(TabID,'grp',icol(27),ist)
         call TBLSER(TabID,'atm_lam',icol(28),ist)
         call TBLSER(TabID,'atm_fos',icol(29),ist)
         call TBLSER(TabID,'atm_gam',icol(30),ist)
         call TBLSER(TabID,'atm_mas',icol(31),ist)
         call TBLSER(TabID,'ID',icol(32),ist)

c         if (nrun.eq.1) then    ! delete all rows
c            call TBIGET(TabID,I,j,K1,k2,nlines,ist) !n. of rows
c            do j=1,nlines
c               call TBRDEL(TabID,j,ist)
c               call TBSPUT(TabID,j,.false.,ist)
c            end do
c         end if
      end if

      call TBIGET(TabID,I,nlines,K1,k2,j,ist) !n. of rows


C!!!!!!!
C       Writes the variables
C!!!!!!!

      IF (NROWS.GT.0) THEN
        do j=1+nlines,nrows+nlines
             call TBEWRC(TabID,j,icol(1),ElmtNm(j-nlines),ist)
             call TBEWRD(TabID,j,icol(2),LamIni(j-nlines),ist)
             call TBEWRC(TabID,j,icol(3),CPar(1,j-nlines),ist)
             call TBEWRD(TabID,j,icol(4),NIni(j-nlines),ist)
             call TBEWRC(TabID,j,icol(5),CPar(2,j-nlines),ist)
             call TBEWRD(TabID,j,icol(6),BIni(j-nlines),ist)
             call TBEWRC(TabID,j,icol(7),CPar(3,j-nlines),ist)
             call TBEWRD(TabID,j,icol(8),BtuIni(j-nlines),ist)
             call TBEWRC(TabID,j,icol(9),CPar(4,j-nlines),ist)
             call TBEWRD(TabID,j,icol(10),LamMin(j-nlines),ist)
             call TBEWRD(TabID,j,icol(11),LamMax(j-nlines),ist)
             call TBEWRD(TabID,j,icol(12),NMin(j-nlines),ist)
             call TBEWRD(TabID,j,icol(13),NMax(j-nlines),ist)
             call TBEWRD(TabID,j,icol(14),BMin(j-nlines),ist)
             call TBEWRD(TabID,j,icol(15),BMax(j-nlines),ist)
             call TBEWRD(TabID,j,icol(16),BtuMin(j-nlines),ist)
             call TBEWRD(TabID,j,icol(17),BtuMax(j-nlines),ist)
             call TBEWRD(TabID,j,icol(18),LamSte(j-nlines),ist)
             call TBEWRD(TabID,j,icol(19),NSte(j-nlines),ist)
             call TBEWRD(TabID,j,icol(20),BSte(j-nlines),ist)
             call TBEWRD(TabID,j,icol(21),BtuSte(j-nlines),ist)
             call TBEWRD(TabID,j,icol(22),CoefL(j-nlines),ist)
             call TBEWRD(TabID,j,icol(23),CoefN(j-nlines),ist)
             call TBEWRD(TabID,j,icol(24),CoefB(j-nlines),ist)
             call TBEWRD(TabID,j,icol(25),CoefBt(j-nlines),ist)
             call TBEWRC(TabID,j,icol(26),Class(j-nlines),ist)
             call TBEWRI(TabID,j,icol(27),grID(j-nlines),ist)
             call TBEWRD(TabID,j,icol(28),AtmLam(j-nlines),ist)
             call TBEWRD(TabID,j,icol(29),AtmFos(j-nlines),ist)
             call TBEWRD(TabID,j,icol(30),AtmGam(j-nlines),ist)
             call TBEWRD(TabID,j,icol(31),AtmMas(j-nlines),ist)
             call TBEWRI(TabID,j,icol(32),nrun,ist)
        end do

      END IF
      
      CALL TBTCLO(TabID,ist)

      i1=0                      !stop on errors
      i2=2
      i3=1
      call STECNT('PUT',i1,i2,i3)
      
      return
      end

C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE CnvrtP(PmtCar,PmtInt,Link,ist)
C       (ConvertParameter)
C     
C       Analizes a Parameter definition (char*4) and returns
C       the relative parameter number, the kind of link 
C       converted to uppercase (if it exists),
C       and sets ist=1 if link exists, 0 if it doesn't
C       -1 if any error occurs
C
C     PmtCar    IN     Parameter character  (e.g. 10.T)
C     PmtInt    OUT    Parameter number     (e.g. 10)
C     Link      OUT    link (if exists)     (e.g. T)
C     ist       OUT    Exists the link?(Y=1)(e.g. 1)
C                                      (N=0)
C                                   (err=-1)
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        implicit none

        character*4 PmtCar
        integer PmtInt,ist
        character Link

        character*4 App
        integer idx

        ist=0
        Link=' '

        idx=index(PmtCar,'.T')
        if (idx.ne.0) then
           App=PmtCar
           App(idx:idx+1)='  '
           read(App,'(I4)')PmtInt
           Link='T'
           ist=1
           return
        end if
        idx=index(PmtCar,'.t')
        if (idx.ne.0) then
           App=PmtCar
           App(idx:idx+1)='  '
           read(App,'(I4)')PmtInt
           Link='T'
           ist=1
           return
        end if

        idx=index(PmtCar,'.Z')
        if (idx.ne.0) then
           App=PmtCar
           App(idx:idx+1)='  '
           read(App,'(I4)')PmtInt
           Link='Z'
           ist=1
           return
        end if
        idx=index(PmtCar,'.z')
        if (idx.ne.0) then
           App=PmtCar
           App(idx:idx+1)='  '
           read(App,'(I4)')PmtInt
           Link='Z'
           ist=1
           return
        end if           

        idx=index(PmtCar,'.F')
        if (idx.ne.0) then
           App=PmtCar
           App(idx:idx+1)='  '
           read(App,'(I4)')PmtInt
           Link='F'
           ist=1
           return
        end if
        idx=index(PmtCar,'.f')
        if (idx.ne.0) then
           App=PmtCar
           App(idx:idx+1)='  '
           read(App,'(I4)')PmtInt
           Link='F'
           ist=1
           return
        end if

        if (ist.ne.1) then
           read(PmtCar,'(I4)',err=100)PmtInt
           return                  ! RETURN OK
        end if


 100    ist=-1
        return
        end


           
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE ChkPar(ErrMsg,ist)
c       
C       Checks the consistency of the parameter definition
C       stored in memory. First looks for unrecoverable (SEVERE)
C       errors (ist=1), then for recoverable errors (ist=2)
C       or general warnings (ist=2)
C       and tries to correct them.
C       In case of severe errors returns a message in ErrMsg;
C       in case of recoverable messages displays a warning.
C
C       Kind and classification of errors investigated:
C      
C  Severe: 1- Unidentified symbols (e.g. 10.j, or 10T, or 10.)
C          2- Same parameter number in different columns
C            (e.g. parm. n. 10 is both a wavelength and a b-value.
C          3- Wrong parameter link (e.g. 10.T on a wave. col.) 
C          4- Prameter number negative
C          5- Parameter numbers not contiguous
C
C  Recover:1- Parameters fixed only sometimes (10 and 10.F)
C          2-
C          3
C     
C  Warning:1-  
C
C  Further actions: if TURBLN.eq.0 writes the correct CPar(4,j)
C   
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        character*(*) ErrMsg
        integer ist

        include 'MID_REL_INCL:fit_var.inc'

        integer IPar(4,NMXLIN)
        
        integer i,j,is,np(NMXFRE),fp(NMXFRE),ni,nmx
        character a

C        include 'MID_REL_INCL:fit_mid.inc'
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'


        ist=0
        ErrMsg=' '
C!!!!!!!
C       ** 1 SEVERE ERROR:  Unidentified symbols (meanwhile
C       converts parameter definition in parameter numbers)
C!!!!!!!
        
        do i=1,4
           do j=1,NROWS
              call CnvrtP(CPar(i,j),IPar(i,j),a,is)
              if (is.eq.-1) then
                 write(ErrMsg,101)CPar(i,j),i,j
                 ist=1
                 return
              end if                
           end do
        end do
 101    format('SEVERE ERROR: UNIDENTIFIED SYMBOL ',A4,i3,i3)

C!!!!!!!
C       ** 2 SEVERE ERROR:  same par. number in different columns
C!!!!!!!

        do j=1,NROWS
           do i=1,NROWS                  
              if (IPar(1,j).eq.IPar(2,i).and.(j.ne.i)) then
                 write(ErrMsg,102)IPar(1,j)
                 ist=1
                 return
              end if
           END DO
        end do   


 102    format('SEVERE ERROR: PARAMETER ',I3,' 
     1       DEFINED ON MORE COLUMNS')


C!!!!!!!
C       ** 3 SEVERE ERROR:  Wrong parameter constraint on columns
C!!!!!!!

                 ! Column of wavelengths
        do j=1,NROWS
           call CnvrtP(CPar(1,j),i,a,is)
           if (is .eq.1) then
              if (a.ne.'Z'.and.a.ne.'F') then
                 write(ErrMsg,103)CPar(1,j)
                 ist=1
                 return
              end if
           end if   
        end do

                 ! Column of Column densities
        do j=1,NROWS
           call CnvrtP(CPar(2,j),i,a,is)
           if (is .eq.1) then
              if (a.ne.'F') then
                 write(ErrMsg,103)CPar(2,j)
                 ist=1
                 return
              end if
           end if   
        end do

                 ! Column of b-values
        do j=1,NROWS
           call CnvrtP(CPar(3,j),i,a,is)
           if (is .eq.1) then
              if (a.ne.'T'.and.a.ne.'F') then
                 write(ErrMsg,103)CPar(3,j)
                 ist=1
                 return
              end if
           end if   
        end do

                 ! Column of b-turbolence values
        do j=1,NROWS
           call CnvrtP(CPar(4,j),i,a,is)
           if (is .eq.1) then
              if (a.ne.'F') then
                 write(ErrMsg,103)CPar(4,j)
                 ist=1
                 return
              end if
           end if   
        end do


 103  format('SEVERE ERROR: WRONG CONSTRAINT ON PARAMETER ',A4)
   

C!!!!!!!
C       ** 4 SEVERE ERROR:  parameter number < 1
C!!!!!!!

        do i=1,4    
           do j=1,NROWS
              if (IPar(i,j).lt. 1) then
                 write(ErrMsg,104)CPar(i,j)
                 ist=1
                 return
              end if
           end do
        end do

   
 104    format('SEVERE ERROR: PARAMETER NUMBER: ',A4,' IS LESS THAN 0')


C!!!!!!!
C       ** 5 SEVERE ERROR:  parameter numbers not contiguous
C       (BYPRODUCT: total parameter number nmx, vector of
C       parameter numbers np() and parameter links cp())
C!!!!!!!

 
        do i=1,NMXFRE
           np(i)=0
        end do
   
        nmx=0

        do i=1,4
           do j=1,NROWS
              call CnvrtP(CPar(i,j),ni,a,is)
              np(ni)=ni
              if (ni.gt.nmx) nmx=ni
           end do
        end do

        do i=1,nmx
           if (np(i).eq.0) then
                 write(ErrMsg,105)i
                 ist=1
                 return
           end if
        end do
   
 105    format('SEVERE ERROR:  PARAMETER',I3,' MISSING')


C!!!!!!!
C       ** 1 RECOVERABLE ERROR:  parameter fixed only sometimes
C!!!!!!!

        do i=1,NMXFRE
           fp(i)=0
        end do
   
        do i=1,4                ! Looks for fixed param
           do j=1,NROWS
              call CnvrtP(CPar(i,j),ni,a,is)
              if (is .eq.1 .and. a.eq.'F') fp(ni)=1
           end do
        end do
       
        do i=1,4                ! writes .F on the fixed param 
           do j=1,NROWS
              call CnvrtP(CPar(i,j),ni,a,is)
              if (fp(ni).eq.1 .and. is.eq.0) then
                 write(ErrMsg,201)ni,i,j
                 call sttdis(ErrMsg,0,is)
                 write(CPar(i,j),202)ni
              end if   
           end do
        end do

 201    format('WARNING: PARAMETER ',I3,' FIXED AT POSITION ',I3,I3)
 202    format(I2,'.F')


        NTOTPA=nmx

C!!!!!!!
C       ** 1 FURTHER ACTIONS: WRITES the correct CPar(4,j) if TURBLN=0
C!!!!!!!

        if (TURBLN.eq.0) then
           do j=1,NROWS
              if(IPar(4,j).eq.0) write(CPar(4,j),'(i2,a2)')nmx+1,'.F'
           end do
        end if

 
        return
        end



C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE AddAtP(ist)
C
C       Uses the element name of the table to fill
C       the columns of the atomic parameters.
C       Atompar must have already been read!!
C
C       Ist (OUT) =1 if error (wrong paramname), otherwise 0
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

        implicit none

        include 'MID_REL_INCL:fit_var.inc'

        integer ist,i,j,iflag
        
C        include 'MID_REL_INCL:fit_mid.inc'
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'


        ist=0

        do i=1,NROWS
           iflag=0
           do j=1,AT_N
                if (ElmtNm(i).eq.AT_NAM(j)) then
                  iflag=1
                  AtmLam(i)=AT_LAM(j)
                  AtmFos(i)=AT_FOS(j)
                  AtmGam(i)=AT_GAM(j)
                  AtmMas(i)=AT_MAS(j)
                end if
            end do  
            if (iflag.eq.0) then
               ist=1
               return
            end if   
        end do
           
        return
        end

C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE AtmRD(Iflag)
C
C       Legge il file atompar.tbl
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

        implicit none
        integer iflag,i,TABID,icol(5),i1,i2,i3,i4,nj,njj,ist
        logical la,isel
        character  natom*14              !must have same length as AT_NAM(i)
         
        INCLUDE 'MID_REL_INCL:fit_var.inc'

        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'

C&&&&&&&
C&        Legge il file atompar.tbl con i parametri atomici
C&&&&&&&
        call seterr('OFF')
        call TBTOPN('atompar',F_IO_MODE,TABID,i)
        if (i.ne.0) then
           iflag=1
           call ERRMSG('FATAL: atompar.tbl not found')
           return
        end if
        
        call TBLSER(TABID,'transition',icol(1),i)
        if (i.ne.0) then
           iflag=1
           call ERRMSG('FATAL: :TRANSITION not found in atompar.tbl')
           return
        end if
        call TBLSER(TABID,'lambda',icol(2),i)
        if (i.ne.0) then
           iflag=1
           call ERRMSG('FATAL: column LAMBDA not found in atompar.tbl')
           return
        end if
        call TBLSER(TABID,'gamma',icol(3),i)
        if (i.ne.0) then
           iflag=1
           call ERRMSG('FATAL: column GAMMA not found in atompar.tbl')
           return
        end if
        call TBLSER(TABID,'fosc',icol(4),i)
        if (i.ne.0) then
           iflag=1
           call ERRMSG('FATAL: column FOSC not found in atompar.tbl')
           return
        end if
        call TBLSER(TABID,'mass',icol(5),i)
        if (i.ne.0) then
           iflag=1
           call ERRMSG('FATAL: column MASS not found in atompar.tbl')
           return
        end if

C        call TBIGET(TABID,i1,i2,i3,i4,nj,ist) !n. of rows
        call TBIGET(TABID,i1,nj,i2,i4,i3,ist) !n. of rows

        call seterr('ON')

        njj = 0
        isel = .FALSE.

        do 1000,i=1,nj
           call TBSGET(TABID,i,isel,ist)     !check if row is selected
           if (.NOT. isel) goto 1000

           njj = njj + 1                !get true no. of atoms listed
           call TBERDC(TABID,i,icol(1),natom,la,ist)
           CALL FT_EOS(natom,14,AT_NAM(i),ist)
           if (ist .ne. 0) then
              CALL STTPUT('bad atom label in table atompar!',ist)
              iflag = 99
              return
           endif

CC        write(*,12345) i,AT_NAM(i)
CC12345   format('AT_NAM(',i3,') = ',A14,']')

           call TBERDD(TABID,i,icol(2),AT_LAM(i),la,ist)
           call TBERDD(TABID,i,icol(3),AT_GAM(i),la,ist)
           call TBERDD(TABID,i,icol(4),AT_FOS(i),la,ist)
           call TBERDD(TABID,i,icol(5),AT_MAS(i),la,ist)
1000    continue

        call TBTCLO(TABID,ist)
        AT_N=njj

        iflag=0
        return
        end
 
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE AtmRDold(Iflag)
C
C       Legge il file atompar.tbl
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

        implicit none

        INCLUDE 'MID_REL_INCL:fit_var.inc'

        character*14 intestazione,app
        integer iflag,i
        real a,b,c,d

C&&&&&&&
C&        Legge il file atompar.dat con i parametri atomici
C&&&&&&&
        open(12,file='atompar.dat',status='old',iostat=iflag)
                
        if (iflag.ne.0) then
                iflag=1
c                call ERRORMSG('FATAL: atompar.dat not found')
                call sttdis('FATAL: atompar.dat not found',0,i)
                return
        end if

        i=1
        read(12,'(a14)')Intestazione
99      read(12,'(1x,a14,5x,f9.4,3x,f7.5,4x,e7.3)',end=100)App,a,b,c,d
        AT_LAM(i)= a
        AT_FOS(i)=b
        AT_GAM(i)=c
        AT_NAM(i)=App
        AT_MAS(I)=d
        i=i+1
        goto 99
100     continue

        close(12)
        AT_N=i-1
        iflag=0


        return

        end
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE AdPLim
C
C       Adds the internal limits on the parameters.
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

        implicit none

        include 'MID_REL_INCL:fit_var.inc'

        integer i
        
C        include 'MID_REL_INCL:fit_mid.inc'
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'


        do i=1,NROWS
           if (LAMLIM(1).eq.0) then
              LamMin(i)=0.0
           else
              LamMin(i)=LamIni(i) - LAMLIM(1)
           end if
           if (LAMLIM(2).eq.0) then
              LamMax(i)=0.0
           else
              LamMax(i)=LamIni(i) + LAMLIM(2)
           end if
           BMin(i)=BLIM(1)
           BMax(i)=BLIM(2)
           BtuMin(i)=BTULIM(1)
           BtuMax(i)=BTULIM(2)
           NMin(i)=NLIM(1)
           NMax(i)=NLIM(2)
           LamSte(i)=LAMLIM(3)
           BSte(i)=BLIM(3)
           BtuSte(i)=BTULIM(3)
           NSte(i)=NLIM(3)
        end do
           
        return
        end

C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE MinuHd
C
C       Writes an ascii file with the header instruction
C       for minuit (i.e. parameter definition and fix)
C       using lypar values as stored in memory
C       and lymin values as stored in memory
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

        implicit none

        include 'MID_REL_INCL:fit_var.inc'

        integer ifound(NMXLIN),ifix(NMXLIN),ix(NMXLIN),jx(NMXLIN)
        integer i,j,ni,is,nmx,ista
        character a
        character*5 suffix(4)
        character*20 name 
        real valmin,valmax,valini,valste

C        include 'MID_REL_INCL:fit_mid.inc'
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'


        suffix(1)='''lam['
        suffix(3)='''  b['
        suffix(2)='''  N['
        suffix(4)='''btu['

        do i=1,NMXLIN
           ifound(i)=0
           ifix(i)=0
           ix(i)=0
           jx(i)=0
        end do
   
        nmx=0
        do i=1,4
           do j=1,NROWS
              call CnvrtP(CPar(i,j),ni,a,is)
              if (ifound(ni).eq.0.and.a.ne.'Z'.and.a.ne.'T') then 
                                     !never found yet nor constrained
                 ifound(ni) =1
                 ix(ni)=i
                 jx(ni)=j
              end if   
              if(a.eq.'F') ifix(ni)=1      ! in any case if fixed..
              if (ni.gt.nmx) nmx=ni
           end do
        end do

 
C!!!!!!!
C        Apre il file fdummy.MIN cancellando il vecchio
C!!!!!!!
40        continue
        open(20,file='fdummy.min',status='old',iostat=ista)
        close(20,status='delete')
        open(20,file='fdummy.min',status='new',iostat=ista)


C!!!!!!!
C        Comincia a scrivere
C!!!!!!!
        write(20,'(A34)')'FITLYMAN Minimization  - ESO Midas'
        
        do i=1,nmx
           
           write(name,'(A5,i2,A2)')suffix(ix(i)),jx(i),']'' '          
           if (ix(i).eq.1) valini = LamIni(jx(i))
           if (ix(i).eq.3) valini = BIni(jx(i))
           if (ix(i).eq.2) valini = NIni(jx(i))
           if (ix(i).eq.4) valini = BtuIni(jx(i))

           if (ix(i).eq.1) valste = LamSte(jx(i))
           if (ix(i).eq.3) valste = BSte(jx(i))
           if (ix(i).eq.2) valste = NSte(jx(i))
           if (ix(i).eq.4) valste = BtuSte(jx(i))

           if (ix(i).eq.1) valmin = LamMin(jx(i))
           if (ix(i).eq.3) valmin = BMin(jx(i))
           if (ix(i).eq.2) valmin = NMin(jx(i))
           if (ix(i).eq.4) valmin = BtuMin(jx(i))

           if (ix(i).eq.1) valmax = LamMax(jx(i))
           if (ix(i).eq.3) valmax = BMax(jx(i))
           if (ix(i).eq.2) valmax = NMax(jx(i))
           if (ix(i).eq.4) valmax = BtuMax(jx(i))

           if (ifix(i).eq.1) then
              write(20,101)i,name,valini ! parameter fixed
           else
              if (valmin.lt.1e-5.or.valmax.lt.1e-5) then
                 write(20,102)i,name,valini,valste ! parameter free
              else
                 write(20,103)i,name,valini,valste,valmin,valmax
              end if
           end if
        end do
 101    format(I3,3x,A10,G14.7)
 102    format(I3,3x,A10,2G14.7)
 103    format(I3,3x,A10,4G14.7)

        write(20,*)     !!  IMPORTANT: END OF HEADER

        IMINOS=0
        do i=1,NMINCM
           write(20,*)MINCOM(i)
           if (MINCOM(i).eq.'MINOS') IMINOS=1
        end do

        close(20)
        return
        end



C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE AdCoef
C
C       Using the values of lypar.tbl loaded in memory,
C       computes the coefficients of proportionality for
C       constrained parameters. Now working only
C       on lambda and b parameters. (N not constrained!!
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

        implicit none

        include 'MID_REL_INCL:fit_var.inc'

        integer ifound(NMXLIN),ix(NMXLIN),jx(NMXLIN)
        integer i,j,ni,is
        character a

C        include 'MID_REL_INCL:fit_mid.inc'
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'


        do i=1,NMXLIN
           ifound(i)=0
           ix(i)=0
           jx(i)=0
           CoefL(i)=1.
           CoefN(i)=1.
           CoefB(i)=1.
           CoefBt(i)=1.
        end do
   

        i=1       ! Lambda
        do j=1,NROWS
           call CnvrtP(CPar(i,j),ni,a,is)
           if (ifound(ni).eq.0.and.a.ne.'Z'.and.a.ne.'T') then 
                                     !never found yet nor constrained
              ifound(ni) =1
              ix(ni)=i
              jx(ni)=j
           end if
        end do
        do j=1,NROWS
           call CnvrtP(CPar(i,j),ni,a,is)
           if (a.eq.'Z') CoefL(j)=AtmLam(j)/AtmLam(jx(ni))
        end do

   
        i=3       ! b-values
        do j=1,NROWS
           call CnvrtP(CPar(i,j),ni,a,is)
           if (ifound(ni).eq.0.and.a.ne.'Z'.and.a.ne.'T') then 
                                     !never found yet nor constrained
              ifound(ni) =1
              ix(ni)=i
              jx(ni)=j
           end if
        end do
        do j=1,NROWS
           call CnvrtP(CPar(i,j),ni,a,is)
           if (a.eq.'T') Coefb(j)=sqrt(AtmMas(jx(ni))/AtmMas(j))
        end do

   
        return
        end
   
      
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE AddInP
C
C       Computes the values of the initial constrained parameters
C       using the values of lypar.tbl loaded in memory,
C       and the coefficients of proportionality 
C       
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

       implicit none

        include 'MID_REL_INCL:fit_var.inc'

        integer ifound(NMXLIN),ix(NMXLIN),jx(NMXLIN)
        integer IPar(4,NMXLIN)
        integer i,j,ni,is
        character a

C        include 'MID_REL_INCL:fit_mid.inc'
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'


        do i=1,NMXLIN
           ifound(i)=0
           ix(i)=0
           jx(i)=0
           do j=1,4
              IPar(j,i)=0
           end do
        end do
   

        do i=1,4
           do j=1,NROWS
              call CnvrtP(CPar(i,j),IPar(i,j),a,is)
              ni=IPar(i,j)
              if (ifound(ni).eq.0.and.a.ne.'Z'.and.a.ne.'T') then 
                                     !never found yet nor constrained
                 ifound(ni) =1
                 jx(ni)=j
              end if   
           end do
        end do   

        do j=1,NROWS
           LamIni(j)=LamIni(jx(IPar(1,j)))*CoefL(j) 
           NIni(j)=NIni(jx(IPar(2,j)))*CoefN(j) 
           BIni(j)=BIni(jx(IPar(3,j)))*CoefB(j) 
           BtuIni(j)=BtuIni(jx(IPar(4,j)))*CoefBt(j) 
        end do   

        return
        end
   
      

C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE FCNHd
C
C       Writes an ascii file 'fdummy.fcn' 
C       with the information required
C       by FCN to convert MINUIT parameters into line
C       parameters. 
C
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&


        implicit none

        include 'MID_REL_INCL:fit_var.inc'

        integer i,j,Ipar(4,NMXLIN),ista
        character a

C        include 'MID_REL_INCL:fit_mid.inc'
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'


C!!!!!!!
C       gets parameter numbers
C!!!!!!!
        do i=1,4
           do j=1,NROWS
              call CnvrtP(CPar(i,j),IPar(i,j),a,ista)
           end do
        end do


C!!!!!!!
C        Apre il file fdummy.fcn cancellando il vecchio
C!!!!!!!
40        continue
        open(20,file='fdummy.fcn',status='old',iostat=ista)
        close(20,status='delete')
        open(20,file='fdummy.fcn',status='new',iostat=ista)

        write(20,*)NROWS
        do j=1,NROWS
           write(20,101)(IPar(i,j),i=1,4),CoefL(j),CoefN(j),CoefB(j),
     1          CoefBt(j),AtmLam(j),AtmFos(j),AtmGam(j)
        end do

        write(20,*)NINTFT
        do j=1,NINTFT
           write(20,*)FITMIN(j),FITMAX(j)
        end do


        close(20)
c 101    format(4I3,x2,G16.8,x2,F4.1,x2,G16.8E2,x2,F4.1,x2,F11.4,x2,
c     1       F9.5,x2,G13.5)
 101    format(4I3,7G16.8)

        return
        end


C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE SETERR(choice)
c
c       sets error behaviour
c
c     choice:  ON
C              OFF
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

        character*(*) choice
        integer i1,i2,i3

        if (choice.eq.'OFF') then

           i1=1                 !doesn't stop on errors
           i2=0
           i3=0
           call STECNT('PUT',i1,i2,i3)

        endif


        if (choice.eq.'ON') then
           i1=0                 !stop on errors
           i2=2
           i3=1
           call STECNT('PUT',i1,i2,i3)
        endif

        return
        end




S

C @(#)tsabnd.for	19.1 (ESO-DMD) 02/25/03 13:33:25
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT (c) 1992 European Southern Observatory & Copernicus Astron. Center
C.IDENT     tsabnd.for
C.AUTHOR    Alex Schwarzenberg-Czerny, Copernicus Astron. Center, Warsaw
C.KEYWORD   MIDAS, time series analysis, BAND/TIME
C.LANGUAGE  FORTRAN 77
C.PURPOSE   Evaluate suitable frequency band for time analysis
C.RETURNS   None
C.ENVIRON   TSA context
C.VERSION   0.0               June 1992
C 
C 021031	last modif
C 
C-----------------------------------------------------------------------------
C
C
      INCLUDE 'MID_REL_INCL:TSA_DEF.INC'
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      CHARACTER*60 INAME                !  NAME OF INPUT TABLE
      INTEGER      MAXOBS               !  MAXIMUM NUMBER OF SCANNED OBSERV.
C
      REAL*8       START,STEP           !  OUTPUT FREQUENCY GRID
      INTEGER      NSTEPS
C
      INTEGER      IACTS,KUN,KNUL
      INTEGER      TID,IWORK,ITIME
      INTEGER      NCOL,ICOL,NROW,IROW,ISOR
      INTEGER      LFIELD,TTYP
C 
      INTEGER*8    PTIME,PWORK
C 
      CHARACTER*10 FORM
      CHARACTER*80 TEXT
C
      INCLUDE 'MID_REL_INCL:TSA_DAT.INC'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C
C   Get parameters
C
      CALL STSPRO ('tsabnd')
      CALL STKRDC ('IN_A',   1,1,60,IACTS,INAME ,KUN,KNUL,ISTAT)
      CALL STKRDI ('MAXOBS',   1, 1,IACTS,MAXOBS,KUN,KNUL,ISTAT)
C
C   Map input data
C
      CALL TBTOPN (INAME,F_I_MODE,TID,ISTAT)
      CALL TBIGET (TID,NCOL,NROW,ISOR,ICOL,IROW,ISTAT)
      CALL TBLSER (TID,'TIME',ITIME,ISTAT)
      IF (ITIME.LT.0) THEN
        CALL STETER(3,'Column :TIME not found')
      ENDIF
      CALL TBFGET (TID,ITIME,FORM,LFIELD,TTYP,ISTAT)
      CALL TBDGET (TID,ISTORE,ISTAT)
      IF (ISTORE.NE.F_TRANS) THEN
        TEXT='Input table '//INAME//' stored not transposed'
        CALL STETER(1,TEXT)
      ENDIF
      IF (TTYP.NE.D_R8_FORMAT) THEN
        CALL STETER(2,'Column :TIME must be in DOUBLE PRECISION')
      ENDIF
      CALL TBCMAP (TID,ITIME,PTIME,ISTAT)
C
C   Create work table
C
      CALL STFCRE('ZZMIDWORK',D_R8_FORMAT,F_X_MODE,F_IMA_TYPE,
     $    NROW,IWORK,ISTAT)
      CALL STFMAP(IWORK,F_X_MODE,1,NROW,IACTS,PWORK,ISTAT)
C
C   Evaluate frequency band
C
      CALL TIMBAND(MADRID(PTIME),MADRID(PWORK),NROW,MAXOBS,
     $    START,STEP,NSTEPS)
C
C   Return keyword values
C
      CALL STKWRD('STARTTSA', START, 1,1,KUN,ISTAT)
      CALL STKWRD('STEPTSA',  STEP,  1,1,KUN,ISTAT)
      CALL STKWRI('NSTEPS',NSTEPS,1,1,KUN,ISTAT)
      CALL STTPUT(
     $   'Keywords STARTTSA,STEPTSA and NSTEPS are set now.'
     $   ,ISTAT)
C
C   Wind-up
C
      CALL STSEPI
C
      END
C
C
C
      SUBROUTINE TIMBAND(TIM,DEL,NOBS,MAXOBS,START,STEP,NSTEPS)
      INCLUDE 'MID_REL_INCL:TSA_DEF.INC'
      INTEGER      NOBS,NSTEPS,MAXOBS
      DOUBLE PRECISION       TIM(NOBS),DEL(NOBS)
      REAL*8       START,STEP
C
      INTEGER      NOBS1,IOBS,MAXSTEPS
      REAL*8       FINISH,STEPS,SIZE
      CHARACTER*80 TEXT
      INCLUDE 'MID_REL_INCL:TSA_CONST.INC'
      DATA         MAXSTEPS/30000/
C
      IF (MAXOBS.EQ.0) MAXOBS=NOBS
      NOBS1=MIN(NOBS-1,MAXOBS)
      IF (NOBS1.LT.5) THEN
        CALL STETER(10,'Too few observations or MAXOBS too small')
      ENDIF
C
      DO 1 IOBS=1,NOBS1
        DEL(IOBS)=TIM(IOBS+1)-TIM(IOBS)
        IF (DEL(IOBS).LT.ZERO) THEN
          CALL STETER(14,':TIME must be sorted in ascending order')
        ENDIF
 1    CONTINUE
      CALL SORT(NOBS1,DEL)
C
      STEP=TIM(NOBS)-TIM(1)
      IF (STEP.LE.ZERO) THEN
        CALL STETER(11,'Input table has wrong :TIME numbers')
      ENDIF
      STEP=0.3/STEP
C
      SIZE=LOG(ONE*NOBS*ONE)
      IOBS=NOBS1*(ONE/(6.+0.3*SIZE)+0.05)+1
      FINISH=DEL(IOBS)
      IF (FINISH.LE.ZERO) THEN
        CALL STETER(12,
     $ 'Too finely spaced observations: bin them coarsly')
      ENDIF
      FINISH=HALF/FINISH*(DEL(NOBS1/2)/FINISH)**(0.6)
C
      STEPS=FINISH/STEP
C
      CALL STTPUT(' RESULTS OF FREQUENCY BAND EVALUATION:',ISTAT)
      WRITE(TEXT,'(2(A,1PE10.1))') 'Max. Frequency: ',FINISH,
     $   '  Resolution: ',STEP
      CALL STTPUT(TEXT,ISTAT)
      WRITE(TEXT,'(A,1PE10.1)') 'No. of points:  ',STEPS
      CALL STTPUT(TEXT,ISTAT)
      IF (STEPS.GT.MAXSTEPS) THEN
        STEPS=MAXSTEPS
        TEXT='*** DANGER *** Data span too long interval'//
     $     ' for good sampling of periodogrammes.'
        CALL STTPUT(TEXT,ISTAT)
        TEXT='Analysing data split into shorter'//
     $        'intervals and taking'//
     $       ' average of periodogrammes '//
     $       'will help by reducing resolution.'
        CALL STTPUT(TEXT,ISTAT)
      ENDIF
C
      NSTEPS=STEPS
      STEP=FINISH/STEPS
      START=ZERO
      END
C
C
C

C===========================================================================
C Copyright (C) 1995-2012 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  19:23 - 11 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION        TDSTAT.FOR
C.KEYWORDS           TABLE, APPLICATIONS
C.ENVIRONMENT  MIDAS
C
C.COMMENTS 
C    SOURCE HAS TO BE MODIFIED TO USE THE TABLE TURBO VERSION
C MODIF : M Peron 30JAN91 sigma = SQRT(sum(Xi-MEAN)/(N-1))
C 
C 120130	last modif   KB
C------------------------------------------------------------------

      SUBROUTINE TDISTA
     . (TID,ICOL,N,K2,ICLASS,CINT,IFREQ,NACT,XMEAN,XSTD)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.PURPOSE
C COMPUTE FREQUENCY DISTRIBUTION FOR VALUES IN THE ARRAY.
C OTHER STATISTICAL PARAMETERS RETURNED BY THE ROUTINE ARE
C MEAN, STD.DEV., MINIMUM AND MAXIMUM.
C       INTEGER VERSION
C
C
C------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER TID        ! IN  : TABLE IDENTIFIER
      INTEGER ICOL       ! IN  : COLUMN INDEX
      INTEGER N          ! IN  : NUMBER OF INPUT DATA
      INTEGER K2         ! IN  : NUMBER OF CLASSES
      INTEGER ICLASS     ! IN  :
      REAL CINT(K2)      ! IN  :
      INTEGER IFREQ(K2)  ! IN  :
      INTEGER NACT       ! OUT : ACTUAL NUMBER OF POINTS
      REAL XMEAN         ! OUT : MEAN VALUE
      REAL XSTD          ! OUT : STANDARD DEVIATION
C
      LOGICAL LK0, INULL, ISEL
      INTEGER I,NUP,NDN,K0
      INTEGER JJ,IERR,NOB,LDN
      INTEGER LUP,J, IVAL
      INTEGER STATUS
      REAL    XMIN,XMAX,XTEMP,CR,ALPHA
      REAL    STEP
      DOUBLE PRECISION YSTD,YMEAN,YWORK
    
C
      NACT   = 0
      XMIN   = 0.0
      XMAX   = 0.0
      YSTD   = 0.00D+0
      YMEAN  = 0.00D+0
      IF (K2.GE.2) THEN                  ! was:    IF (K2-2) 290,10,10
         IF (N.GE.1) THEN                !      10 IF (N-1) 300,20,20
            GOTO 20
         ELSE
            GOTO 300
         ENDIF
      ELSE
         GOTO 290
      ENDIF
C
C ... ZERO  FREQUENCIES
C
   20 CONTINUE
      DO 30 I = 1,K2
          IFREQ(I) = 0
   30 CONTINUE
      NUP    = 0
      NDN    = 0
      K0     = K2 - 2
      LK0    = K0 .EQ. 0
C
C ... DETERMINE  MIN  AND  MAX, MEAN AND STD DEV.
C
      I      = 1
      CALL TBSGET(TID,I,ISEL,STATUS)
      CALL TBERDI(TID,I,ICOL,IVAL,INULL,STATUS)
      XTEMP = IVAL
   40     CONTINUE
          IF (.NOT.INULL .AND. ISEL) GO TO 50
          I      = I + 1
          IF (I.GT.N) GOTO 65
          CALL TBSGET(TID,I,ISEL,STATUS)
          CALL TBERDI(TID,I,ICOL,IVAL,INULL,STATUS)
          XTEMP = IVAL
          GO TO 40 
   50 CONTINUE
      XMIN   = XTEMP
      XMAX   = XTEMP
      DO 60 J = I,N
          CALL TBSGET(TID,J,ISEL,STATUS)
          CALL TBERDI(TID,J,ICOL,IVAL,INULL,STATUS)
          XTEMP = IVAL
          IF (.NOT.INULL .AND. ISEL) THEN
              NACT   = NACT + 1
              YMEAN  = YMEAN + XTEMP
              IF (XTEMP.LT.XMIN) XMIN   = XTEMP
              IF (XTEMP.GT.XMAX) XMAX   = XTEMP
          END IF
   60 CONTINUE
   65 CONTINUE
      IF (NACT.EQ.0) THEN
          XMEAN  = 0.
          XSTD   = 0.
          RETURN
      ELSE
          YMEAN  = YMEAN/DBLE(NACT)
      END IF
      IF (ICLASS.EQ.1) GO TO 120
      IF (LK0) GO TO 260
C
C ... CALCULATE CLASS INTERVALS WITH EQUAL SPACING
C
      CR     = XMAX - XMIN
      ALPHA  = 0.001
      IF (CR.GT.0.0) GO TO 100
      IF (XMIN .NE. 0.0) THEN                   !was  IF (XMIN) 80,90,80
         CR = XMIN*ALPHA                        !  80 CR     = XMIN*ALPHA
      ELSE                                      !     GO TO 100
         CR = ALPHA                             !  90 CR     = ALPHA
      ENDIF                                     !bad idea to test on 0.0, but that was
                                                !the original code ...  
   90 CR     = ALPHA
  100 STEP   = CR* (1.00+ALPHA)/FLOAT(K0)
      CR     = XMIN - 0.50*ALPHA*CR
      CINT(1) = CR
      DO 110 I = 1,K0
          XTEMP  = CR
          CR     = XTEMP + STEP
          CINT(I+1) = CR
  110 CONTINUE
      GO TO 150
C
C ... CLASS INTERVALS SUPPLIED--CHECK IN ASCENDING ORDER
C
  120 CR     = CINT(1)
      IF (LK0) GO TO 270
      JJ     = K0 + 1
      DO 140 I = 2,JJ
          XTEMP  = CINT(I)
          IF (CR.LT.XTEMP) GO TO 130
          IERR   = 3
          GO TO 310
  130     CR     = XTEMP
  140 CONTINUE
C
C ... DETERMINE CLASS TO WHICH EACH CASE BELONGS
  150 NOB    = K2/2
      CR     = CINT(NOB)
      LDN    = NOB + 1
      LUP    = K2 - 1
      K0     = NOB - 1
      LK0    = K0 .EQ. 0
      DO 240 I = 1,N
          CALL TBSGET(TID,I,ISEL,STATUS)
          CALL TBERDI(TID,I,ICOL,IVAL,INULL,STATUS)
          XTEMP = IVAL
          IF (INULL .OR. (.NOT.ISEL)) GO TO 230
          YWORK  = XTEMP
          YWORK  = YWORK - YMEAN
          YSTD   = YSTD + YWORK*YWORK
          IF (XTEMP.GE.CR) THEN                 !was  IF (XTEMP-CR) 190,160,160
             GOTO 160
          ELSE
             GOTO 190
          ENDIF
C
C ... VARIATE VALUE ABOVE MIDDLE  INTERVAL
C
  160     DO 180 J = LDN,LUP
              IF (XTEMP.GE.CINT(J)) GO TO 170
              IFREQ(J) = IFREQ(J) + 1
              GO TO 230
  170         CONTINUE
  180     CONTINUE
          NUP    = NUP + 1
          GO TO 230
C
C ... VARIATE VALUE BELOW MIDDLE  INTERVAL
C
  190     IF (LK0) GO TO 220
          DO 210 J = 1,K0
              JJ     = NOB - J
              IF (XTEMP.LT.CINT(JJ)) GO TO 200
              JJ     = JJ + 1
              IFREQ(JJ) = IFREQ(JJ) + 1
              GO TO 230
  200         CONTINUE
  210     CONTINUE
  220     NDN    = NDN + 1
  230     CONTINUE
  240 CONTINUE
  250 IFREQ(1) = NDN
      IFREQ(K2) = NUP
      XMEAN  = YMEAN
      IF (NACT.EQ.1) THEN
         YSTD = 0
      ELSE
         YSTD   = DSQRT(YSTD/(NACT-1))
      ENDIF
      XSTD   = YSTD
      RETURN
  260 CR     = (XMAX+XMIN)*0.50
      CINT(1) = CR
  270 CONTINUE
      DO 280 I = 1,N
          CALL TBERDI(TID,I,ICOL,IVAL,INULL,STATUS)
          IF (IVAL.LT.CR) NDN    = NDN + 1
  280 CONTINUE
      NUP    = N - NDN
      GO TO 250
  290 IERR   = 1
      GO TO 310
  300 IERR   = 2
  310 NACT   = 0
      RETURN
      END

      SUBROUTINE TDRSTA
     . (TID,ICOL,N,K2,ICLASS,CINT,IFREQ,NACT,XMEAN,XSTD)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.PURPOSE
C COMPUTE FREQUENCY DISTRIBUTION FOR VALUES IN THE ARRAY.
C OTHER STATISTICAL PARAMETERS RETURNED BY THE ROUTINE ARE
C MEAN, STD.DEV., MINIMUM AND MAXIMUM.
C       SINGLE PRECISION VERSION
C
C
C------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER TID        ! IN  : TABLE IDENTIFIER
      INTEGER ICOL       ! IN  : COLUMN INDEX
      INTEGER N          ! IN  : NUMBER OF INPUT DATA
      INTEGER K2         ! IN  : NUMBER OF CLASES
      INTEGER ICLASS     ! IN  :
      REAL CINT(K2)      ! IN  :
      INTEGER IFREQ(K2)  ! IN  :
      INTEGER NACT       ! OUT : ACTUAL NUMBER OF POINTS
      REAL XMEAN         ! OUT : MEAN VALUE
      REAL XSTD          ! OUT : STANDARD DEVIATION
C
      LOGICAL LK0
      LOGICAL INULL
      LOGICAL ISEL
C      
      INTEGER I,NUP,NDN,K0
      INTEGER JJ,IERR,NOB,LDN
      INTEGER LUP,J
      INTEGER STATUS
C
      REAL    XMIN,XMAX,XTEMP
      REAL    CR         ! ???
      REAL    ALPHA
      REAL    STEP
      DOUBLE PRECISION YSTD,YMEAN,YWORK
      INTEGER ISTAT    
C
C     set to zero
      NACT   = 0
      XMIN   = 0.0
      XMAX   = 0.0
      YSTD   = 0.00D+0
      YMEAN  = 0.00D+0
      IF (K2.GE.2) THEN                  ! was:    IF (K2-2) 290,10,10
         IF (N.GE.1) THEN                !      10 IF (N-1) 300,20,20
            GOTO 20
         ELSE
            GOTO 300
         ENDIF
      ELSE
         GOTO 290
      ENDIF
C
C ... ZERO  FREQUENCIES
C
   20 CONTINUE
      DO 30 I = 1,K2
          IFREQ(I) = 0
   30 CONTINUE
      NUP    = 0
      NDN    = 0
      K0     = K2 - 2
      LK0    = K0 .EQ. 0
C
C ... DETERMINE  MIN  AND  MAX, MEAN AND STD DEV.
C
C-     CALL STTPUT('START WITH THE CALCULATION',ISTAT)
      I      = 1
      CALL TBSGET(TID,I,ISEL,STATUS)
      CALL TBERDR(TID,I,ICOL,XTEMP,INULL,STATUS)
   40     CONTINUE
          IF (.NOT.INULL .AND. ISEL) GO TO 50
          I      = I + 1
          IF (I.GT.N) GOTO 65
          CALL TBSGET(TID,I,ISEL,STATUS)
          CALL TBERDR(TID,I,ICOL,XTEMP,INULL,STATUS)
          GO TO 40 
   50 CONTINUE
      XMIN   = XTEMP
      XMAX   = XTEMP
      DO 60 J = I,N
          CALL TBSGET(TID,J,ISEL,STATUS)
          CALL TBERDR(TID,J,ICOL,XTEMP,INULL,STATUS)
          IF (.NOT.INULL .AND. ISEL) THEN
              NACT   = NACT + 1
C              CALL STTPUT('Increase NACT by one',ISTAT)
              YMEAN  = YMEAN + XTEMP
              IF (XTEMP.LT.XMIN) XMIN   = XTEMP
              IF (XTEMP.GT.XMAX) XMAX   = XTEMP
          END IF
   60 CONTINUE
   65 CONTINUE
      IF (NACT.EQ.0) THEN
          CALL STTPUT
     +    ('No selected rows, set mean and standard dev. to 0.0',ISTAT)
          XMEAN  = 0.
          XSTD   = 0.
          RETURN
      ELSE
          YMEAN  = YMEAN/DBLE(NACT)
      END IF
      IF (ICLASS.EQ.1) GO TO 120
      IF (LK0) GO TO 260
C
C ... CALCULATE CLASS INTERVALS WITH EQUAL SPACING
C
C      write(6,*) XMAX,XMIN
      CR     = XMAX - XMIN
      ALPHA  = 0.001
      IF (CR.GT.0.0) GO TO 100

      IF (XMIN .NE. 0.0) THEN                   !was  IF (XMIN) 80,90,80
         CR = XMIN*ALPHA                        !  80 CR     = XMIN*ALPHA
      ELSE                                      !     GO TO 100
         CR = ALPHA                             !  90 CR     = ALPHA
      ENDIF                                     !bad idea to test on 0.0, but that was
                                                !the original code ...  
  100 STEP   = CR*(1.00+ALPHA)/FLOAT(K0)
      CR     = XMIN - 0.50*ALPHA*CR
      CINT(1) = CR
      DO 110 I = 1,K0
          XTEMP  = CR
          CR     = XTEMP + STEP
          CINT(I+1) = CR
  110 CONTINUE
      GO TO 150
C
C ... CLASS INTERVALS SUPPLIED--CHECK IN ASCENDING ORDER
C
  120 CR     = CINT(1)
      IF (LK0) GO TO 270
      JJ     = K0 + 1
C      write(6,*) JJ,CINT(1),CINT(2)
      DO 140 I = 2,JJ
          XTEMP  = CINT(I)
C
C Typo origin of error for similar column entries? PN 12/98
C          IF (CR.LT.XTEMP) GO TO 130
C  LE. instead of LT.?
          IF (CR.LE.XTEMP) GO TO 130
          CALL STTPUT('Warning: CR larger XTEMP!',ISTAT)
          IERR   = 3
          GO TO 310
  130     CR     = XTEMP
  140 CONTINUE
C
C ... DETERMINE CLASS TO WHICH EACH CASE BELONGS
  150 NOB    = K2/2
      CR     = CINT(NOB)
      LDN    = NOB + 1
      LUP    = K2 - 1
      K0     = NOB - 1
      LK0    = K0 .EQ. 0
      DO 240 I = 1,N
          CALL TBSGET(TID,I,ISEL,STATUS)
          CALL TBERDR(TID,I,ICOL,XTEMP,INULL,STATUS)
          IF (INULL .OR. (.NOT.ISEL)) GO TO 230
          YWORK  = XTEMP
          YWORK  = YWORK - YMEAN
          YSTD   = YSTD + YWORK*YWORK
          IF (XTEMP.GE.CR) THEN                 !was  IF (XTEMP-CR) 190,160,160
             GOTO 160
          ELSE
             GOTO 190
          ENDIF
C
C ... VARIATE VALUE ABOVE MIDDLE  INTERVAL
C
  160     DO 180 J = LDN,LUP
              IF (XTEMP.GE.CINT(J)) GO TO 170
              IFREQ(J) = IFREQ(J) + 1
              GO TO 230
  170         CONTINUE
  180     CONTINUE
          NUP    = NUP + 1
          GO TO 230
C
C ... VARIATE VALUE BELOW MIDDLE  INTERVAL
C
  190     IF (LK0) GO TO 220
          DO 210 J = 1,K0
              JJ     = NOB - J
              IF (XTEMP.LT.CINT(JJ)) GO TO 200
              JJ     = JJ + 1
              IFREQ(JJ) = IFREQ(JJ) + 1
              GO TO 230
  200         CONTINUE
  210     CONTINUE
  220     NDN    = NDN + 1
  230     CONTINUE
  240 CONTINUE
  250 IFREQ(1) = NDN
      IFREQ(K2) = NUP
      XMEAN  = YMEAN
      IF (NACT.EQ.1) THEN
         YSTD = 0
      ELSE
         YSTD   = DSQRT(YSTD/(NACT-1))
      ENDIF
      XSTD   = YSTD
      
C      CALL STTPUT('Usually routine ends here',ISTAT)
C      WRITE(6,*) NACT
C      WRITE(6,*) XMEAN, XSTD
     
      
      RETURN
  260 CR     = (XMAX+XMIN)*0.50
      CINT(1) = CR
  270 CONTINUE      
      DO 280 I = 1,N
          CALL TBERDR(TID,I,ICOL,XTEMP,INULL,STATUS)
          IF (XTEMP.LT.CR) NDN    = NDN + 1
  280 CONTINUE
      NUP    = N - NDN
      GO TO 250
  290 IERR   = 1 
      GO TO 310
  300 IERR   = 2 
  310 NACT   = 0
C      CALL STTPUT('NACT set to 0',ISTAT)      
C      CALL STTPUT('END OF THIS ROUTINE REACHED',ISTAT)
C      WRITE(6,*) NACT
C      WRITE(6,*) XMEAN, XSTD

      RETURN
      END

      SUBROUTINE TDDSTA
     .  (TID,ICOL,N,K2,ICLASS,CINT,IFREQ,NACT,XMEAN,XSTD)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.PURPOSE
C COMPUTE FREQUENCY DISTRIBUTION FOR VALUES IN THE ARRAY.
C OTHER STATISTICAL PARAMETERS RETURNED BY THE ROUTINE ARE
C MEAN, STD.DEV., MINIMUM AND MAXIMUM.
C       DOUBLE PRECISION VERSION
C
C
C------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER TID        ! IN : TABLE IDENT
      INTEGER ICOL       ! IN : COLUMN INDEX
      INTEGER N          ! IN : number of input data
      INTEGER K2         ! IN : number of classes
      INTEGER ICLASS     !  IN :
      REAL CINT(K2)      !  IN :
      INTEGER IFREQ(K2)  ! IN  :
      INTEGER NACT       ! OUT : actual number of points
      REAL XMEAN         ! OUT : mean value
      REAL XSTD          ! OUT : standard deviation
C
      LOGICAL LK0
      INTEGER I,NUP,NDN,K0,STATUS
      INTEGER JJ,IERR,NOB,LDN
      INTEGER LUP,J
      LOGICAL ISEL, INULL
      REAL XMIN          ! Why real in double version?
      REAL XMAX          ! Why real in double version?
      REAL CR            ! Why real in double version?
      REAL ALPHA         ! Why real in double version?
      REAL STEP          ! Why real in double version?
      DOUBLE PRECISION YSTD
      DOUBLE PRECISION YMEAN
      DOUBLE PRECISION YWORK
      DOUBLE PRECISION XTEMP
C
      NACT   = 0
      XMIN   = 0.0
      XMAX   = 0.0
      YSTD   = 0.00D+0
      YMEAN  = 0.00D+0
      IF (K2.GE.2) THEN                  ! was:    IF (K2-2) 290,10,10
         IF (N.GE.1) THEN                !      10 IF (N-1) 300,20,20
            GOTO 20
         ELSE
            GOTO 300
         ENDIF
      ELSE
         GOTO 290
      ENDIF
C
C ... ZERO  FREQUENCIES
C
   20 CONTINUE
      DO 30 I = 1,K2
          IFREQ(I) = 0
   30 CONTINUE
      NUP    = 0
      NDN    = 0
      K0     = K2 - 2
      LK0    = K0 .EQ. 0
C
C ... DETERMINE  MIN  AND  MAX, MEAN AND STD DEV.
C
      I      = 1
      CALL TBSGET(TID,I,ISEL,STATUS)
      CALL TBERDD(TID,I,ICOL,XTEMP,INULL,STATUS)
   40     CONTINUE
          IF (.NOT.INULL .AND. ISEL) GO TO 50
          I      = I + 1
          IF (I.GT.N) GOTO 65
          CALL TBSGET(TID,I,ISEL,STATUS)
          CALL TBERDD(TID,I,ICOL,XTEMP,INULL,STATUS)
          GO TO 40 
   50 CONTINUE
      XMIN   = XTEMP
      XMAX   = XTEMP
      DO 60 J = I,N
          CALL TBSGET(TID,J,ISEL,STATUS)
          CALL TBERDD(TID,J,ICOL,XTEMP,INULL,STATUS)
          IF (.NOT.INULL .AND. ISEL) THEN
              NACT   = NACT + 1
              YMEAN  = YMEAN + XTEMP
              IF (XTEMP.LT.XMIN) XMIN   = XTEMP
              IF (XTEMP.GT.XMAX) XMAX   = XTEMP
          END IF
   60 CONTINUE
   65 CONTINUE
      IF (NACT.EQ.0) THEN
          XMEAN  = 0.
          XSTD   = 0.
          RETURN
      ELSE
          YMEAN  = YMEAN/DBLE(NACT)
      END IF
      IF (ICLASS.EQ.1) GO TO 120
      IF (LK0) GO TO 260
C
C ... CALCULATE CLASS INTERVALS WITH EQUAL SPACING
C
      CR     = XMAX - XMIN
      ALPHA  = 0.001
      IF (CR.GT.0.0) GO TO 100

      IF (XMIN .NE. 0.0) THEN                   !was  IF (XMIN) 80,90,80
         CR = XMIN*ALPHA                        !  80 CR     = XMIN*ALPHA
      ELSE                                      !     GO TO 100
         CR = ALPHA                             !  90 CR     = ALPHA
      ENDIF                                     !bad idea to test on 0.0, but that was
                                                !the original code ...  
  100 STEP   = CR* (1.00+ALPHA)/FLOAT(K0)
      CR     = XMIN - 0.50*ALPHA*CR
      CINT(1) = CR
      DO 110 I = 1,K0
          XTEMP  = CR
          CR     = XTEMP + STEP
          CINT(I+1) = CR
  110 CONTINUE
      GO TO 150
C
C ... CLASS INTERVALS SUPPLIED--CHECK IN ASCENDING ORDER
C
  120 CR     = CINT(1)
C      write(6,*) XMAX,XMIN
      IF (LK0) GO TO 270
      JJ     = K0 + 1
      DO 140 I = 2,JJ
          XTEMP  = CINT(I)
C 
C Typo origin of error? PN 12/98
C          IF (CR.LT.XTEMP) GO TO 130
C  LE. instead of LT.?
          IF (CR.LE.XTEMP) GO TO 130
          IERR   = 3
          GO TO 310

  130     CR     = XTEMP
  140 CONTINUE
C
C ... DETERMINE CLASS TO WHICH EACH CASE BELONGS
  150 NOB    = K2/2
      CR     = CINT(NOB)
      LDN    = NOB + 1
      LUP    = K2 - 1
      K0     = NOB - 1
      LK0    = K0 .EQ. 0
      DO 240 I = 1,N
          CALL TBSGET(TID,I,ISEL,STATUS)
          CALL TBERDD(TID,I,ICOL,XTEMP,INULL,STATUS)
          IF (INULL .OR. (.NOT.ISEL)) GOTO 230
          YWORK  = XTEMP
          YWORK  = YWORK - YMEAN
          YSTD   = YSTD + YWORK*YWORK
          IF (XTEMP.GE.CR) THEN                 !was  IF (XTEMP-CR) 190,160,160
             GOTO 160
          ELSE
             GOTO 190
          ENDIF
C
C ... VARIATE VALUE ABOVE MIDDLE  INTERVAL
C
  160     DO 180 J = LDN,LUP
              IF (XTEMP.GE.CINT(J)) GO TO 170
              IFREQ(J) = IFREQ(J) + 1
              GO TO 230
  170         CONTINUE
  180     CONTINUE
          NUP    = NUP + 1
          GO TO 230
C
C ... VARIATE VALUE BELOW MIDDLE  INTERVAL
C
  190     IF (LK0) GO TO 220
          DO 210 J = 1,K0
              JJ     = NOB - J
              IF (XTEMP.LT.CINT(JJ)) GO TO 200
              JJ     = JJ + 1
              IFREQ(JJ) = IFREQ(JJ) + 1
              GO TO 230

  200         CONTINUE
  210     CONTINUE
  220     NDN    = NDN + 1
  230     CONTINUE
  240 CONTINUE
  250 IFREQ(1) = NDN
      IFREQ(K2) = NUP
      XMEAN  = YMEAN
      IF (NACT.EQ.1) THEN
         YSTD = 0
      ELSE
         YSTD   = DSQRT(YSTD/(NACT-1))
      ENDIF
      XSTD   = YSTD
      RETURN
  260 CR     = (XMAX+XMIN)*0.50
      CINT(1) = CR
  270 CONTINUE
      DO 280 I = 1,N
          CALL TBERDD(TID,I,ICOL,XTEMP,INULL,STATUS)
          IF (XTEMP.LT.CR) NDN    = NDN + 1
  280 CONTINUE
      NUP    = N - NDN
      GO TO 250
  290 IERR   = 1
      GO TO 310
  300 IERR   = 2
  310 NACT   = 0
      RETURN
      END

C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION        ISTLBL.FOR
C.AUTHOR:               J.D.PONZ  ESA-VILSPA        
C.KEYWORDS              IUE, GO FORMAT, LINE-BY-LINE IMAGE
C.PURPOSE
C  \begin{TeX}
C   Reads the low dispersion line-by-line LBL and extended LBL files 
C   from tape and stores the infoprmation into a MIDAS image.
C
C   The routine performs the following functions (routine names in brackets):
C   \begin{enumerate}
C   \item Handles the file header (ISTFHD)
C   \item Creates the MIDAS image file on disk (STFCRE)
C      Format and size of the file is controlled by the argument
C      DSKFMT.
C   \item Iterates on pseudo-orders to:
C         \begin{itemize}
C           \item Read wavelength record (ISTREA)
C           \item Decode first and last wavelength if it is the first pseudo-order
C           \item Read epsilon record (ISTREA)
C           \item Read record with pixel values (ISTREA)
C           \item Decode pixel values
C           \item Write into the disk file (STFPUT)
C         \end{itemize}
C   \item Writes standard image descriptors (STDWRx)
C   \item Writes IUE specific descriptors (ISTDES)
C   \item Closes the image file (STFCLO)
C   \end{enumerate}
C \end{TeX}
C.LANGUAGE:             F77 
C.COMMENTS
C \begin{TeX}
C   The following extensions are used:
C    \begin{itemize}
C    \item IMPLICIT NONE
C    \item INCLUDE statement
C    \item long variable names
C    \item Underscore character
C    \end{itemize}
C \end{TeX}
C.VERSION: 1.0  INITIAL CODING  09 JUL 1990
C.VERSION: 1.1  REMOVE VMS EXTENSIONS
C------------------------------------------------------------------
      SUBROUTINE ISTLBL(CHANL,BUFF,FILE,DSKFMT,
     .                  NRECO,NBYTE,DSPFLG,STATUS)
C
      IMPLICIT NONE
      INTEGER       CHANL             ! IN: tape channel number
      CHARACTER*(*) BUFF              ! IN: buffer with the ascii header
      CHARACTER*(*) FILE              ! IN: file name
      INTEGER       DSKFMT            ! IN: disk format (-1 no file)
      INTEGER       NRECO             ! IN: number of records
      INTEGER       NBYTE             ! IN: number of bytes per record
      INTEGER       DSPFLG            ! IN: display flag
      INTEGER       STATUS            ! OUT: status
C
      INTEGER   DTYPE, NO, SIZE, FELM, NL, LEN, I, J, IP
      INTEGER   NAXIS(1), NPIX(2), DUM(1), NP, NORDER, RPERGR
      INTEGER   KG, JG
      INTEGER   IBUFF(1024), IZERO(1024)
      INTEGER   LAMB0(100), IORD(100), NVAL(100)
      INTEGER   BBUFF(1024), BZERO(1024)
      REAL      RBUFF(1024)
      REAL      CUTS(4), XMIN, XMAX, SCG
      DOUBLE PRECISION START(2), STEP(2), W0, W1
      CHARACTER*72 IDENT, CUNIT
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      EQUIVALENCE  (IBUFF(1),BBUFF(1))
      EQUIVALENCE  (IZERO(1), BZERO(1))
      EQUIVALENCE  (IZERO(103), LAMB0(1))
      EQUIVALENCE  (IZERO(203), IORD(1))
      EQUIVALENCE  (IZERO(303), NVAL(1))
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
      DATA   CUNIT/'FN              ANGSTROM        PIXEL'/
C
C ... decode full header, print it and put info in common area
C
      STATUS = 0
      XMIN   = 0.
      XMAX   = 0.
      CALL ISTFHD(CHANL,BUFF,DSPFLG,STATUS)
      IF (STATUS.NE.0) RETURN
      IF (DSKFMT.LT.0) RETURN       ! only displays header
C
C ... reads data record 0
C
      CALL ISTRHW(CHANL,BZERO,NBYTE,LEN,STATUS)
      IF (NBYTE.NE.LEN. OR. STATUS.NE.0) THEN
          STATUS = 1
          RETURN
      ENDIF
C
C ... define file dimensions and other parameters
C
      NORDER = IZERO(5)
      RPERGR = IZERO(8)
      JG     = IZERO(23)
      KG     = IZERO(24)
      SCG    = FLOAT(JG)/(2.**KG)
C 
C ... check info
C
      IF (NORDER.NE.(NRECO-1)/RPERGR) THEN
          CALL STTPUT('Problem with NORDER in LBL ***',STATUS)
          STATUS = 1
          RETURN
      ENDIF
      NP     = NVAL(1)
      NL     = NORDER
      SIZE   = NP*NL
C
C
C ... create the frame
C
      DTYPE = D_R4_FORMAT
      CALL STFCRE(FILE,DTYPE,F_O_MODE,F_IMA_TYPE,SIZE,NO,STATUS)
      IF (STATUS.NE.0) RETURN
C
C ... loop to read tape and write into disk
C
      FELM = 1
      DO 20 I = 1, NL
           CALL ISTRHW(CHANL,BBUFF,NBYTE,LEN,STATUS)    ! read lambda
           IF (I.EQ.1) THEN
             W0 = IBUFF(3) * 0.2  + LAMB0(1)
             W1 = IBUFF(NP+2)*0.2 + LAMB0(1)
           ENDIF
           IF (NBYTE.NE.LEN .OR. STATUS.NE.0) RETURN
           CALL ISTRHW(CHANL,BBUFF,NBYTE,LEN,STATUS)    ! read epsilon
           IF (NBYTE.NE.LEN .OR. STATUS.NE.0) RETURN
           CALL ISTRHW(CHANL,BBUFF,NBYTE,LEN,STATUS)    ! read data
           IF (NBYTE.NE.LEN .OR. STATUS.NE.0) RETURN
           IP = 1
           DO 15 J = 5, NBYTE, 2
               RBUFF(IP)  = IBUFF(IP+2)*SCG
               XMAX       = AMAX1(XMAX,RBUFF(IP))
               XMIN       = AMIN1(XMIN,RBUFF(IP))
               IP         = IP + 1
               IF (IP.GT.NP) GO TO 17
  15       CONTINUE
  17       CALL STFPUT(NO,FELM,NP,RBUFF,STATUS)
           IF (STATUS.NE.0) RETURN            
           FELM = FELM + NP
 20   CONTINUE
C
C ... write image descriptors
C
      NAXIS(1) = 2
      NPIX(1)  = NP
      NPIX(2)  = NL
      START(1) = W0
      START(2) = 1.0D0
      STEP(1)  = (W1 - W0)/(NP-1)
      STEP(2)  = 1.0D0
      CUTS(1)  = XMIN
      CUTS(2)  = XMAX
      CUTS(3)  = XMIN
      CUTS(4)  = XMAX
      IDENT    = BUFF(145:210)
      CALL STDWRI(NO,'NAXIS',NAXIS,1,1,DUM,STATUS)
      CALL STDWRI(NO,'NPIX',NPIX,1,2,DUM,STATUS)
      CALL STDWRD(NO,'START',START,1,2,DUM,STATUS)
      CALL STDWRD(NO,'STEP',STEP,1,2,DUM,STATUS)
      CALL STDWRR(NO,'LHCUTS',CUTS,1,4,DUM,STATUS)
      CALL STDWRC(NO,'IDENT',1,IDENT,1,72,DUM,STATUS)
      CALL STDWRC(NO,'CUNIT',1,CUNIT,1,48,DUM,STATUS)
C
C ... write label descriptors
C
      CALL ISTDES(NO,BUFF,STATUS)
      CALL STFCLO(NO,STATUS)
      RETURN
      END

c                                   
c                                   
c                                                                               
      real function gamlog(x0) 
c implementation of Lanczos approximation, 
c based on ideas from Numerical Recipes (Press et. al., 1986)
      implicit none
      integer i
      real x0
      double precision lancz(6),one,half,x,scal,sav 
      parameter (one=1d0,half=0.5d0)
      data lancz/
     $     76.18009173d+0,-86.50532033d+0,24.01409822d0, 
     $    -1.231739516d+0, 0.120858003d-2,-0.536382d-5/
      x=x0
      scal=x+4.5d0
      sav=one
      do 1 i=1,6
        sav=sav+lancz(i)/x
        x=x+one
 1    continue
      gamlog=log(scal)*(x0-half)-scal
     $  +log(sav*2.50662827465d0)
      end
c
c
c

C @(#)necford.for	19.1 (ESO-DMD) 02/25/03 14:20:23
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM ECHFOR
C
C+
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  21:22 - 3 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: D.PONZ
C
C.IDENTIFICATION
C
C  program  ECHSORD  version 1.6 830310
C
C.MODIFICATIONS
C
C   910128   P. Ballester   Define and set variables for mmake -i
C
C.KEYWORDS
C
C  ECHELLE, CASPEC
C
C.PURPOSE
C
C SEARCH FOR ORDERS IN AN IMAGE. TYPE ECHELLE - FLAT FIELD
C OUTPUT IS A TABLE WITH THE FOLLOWING COLUMNS :
C COLUMN NO.  LABEL   UNIT      DESCRIPTION
C    1        :ORDER  -         ORDER NUMBER
C    2        :X      PIXEL     SAMPLE NUMBER
C    3        :Y      PIXEL     1. MOMENT AS SUM(F*Y)/SUM(F)
C    4        :YBKG   PIXEL     POSITION OF THE BACKGROUND
C    5        :BKG    DN        BACKGROUND LEVEL
C
C.ALGORITHM
C
C  MAXIMA FOLLOWING ALGORITHM IS USED
C
C  CONSTRAINS : MAXIMUM NUMBER OF ORDERS IN THE IMAGE IS 100
C               FOR EACH ORDER 19 POINTS ARE FOUND
C
C.INPUT/OUTPUT
C
C  COMMAND :
C  SEARCH/ORDER INPUT W,T,S OUTPUT METH
C  input keywords are
C  ECHC(1:8)   INPUT   - IMAGE NAME
C  ECHC(21:28)  OUTPUT  - TABLE NAME
C         W,T,S   - PARAMETERS WHERE :
C  ECHR(2)              T THRESHOLD IN THE DETECTION
C
C 010226		last modif
C 
C----------------------------------------------------------

      IMPLICIT  NONE
      INTEGER   MADRID
      INTEGER   ACTVAL,I
      INTEGER   IXSTR
      INTEGER   NACOL,NAXIS,NDIM,NORDER,NP,NPOINT
      INTEGER   NTOT
      INTEGER   STATUS,WINDOW,IACOL,ID
      INTEGER   NPIX(3),ICOL(7),KUN,KNUL,IMNI
      INTEGER   UPPER(100),LOWER(100),ORDPOS(100)
      INTEGER*8 IADD
      INTEGER*8 PNTRA
C 
      REAL    RPAR(4),LEVEL
C 
      DOUBLE PRECISION    START(3),STEP(3)
C 
      CHARACTER*8 FRMIN,TABLE
      CHARACTER*72 IDENA
      CHARACTER*80 LINE
      CHARACTER*64 CUNITA
      CHARACTER*2 METH
      CHARACTER*16 LABCOL(5),UNIT(5)
      CHARACTER*6 FORM(5)
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C 
      DATA LABCOL(1)/'ORDER'/,FORM(1)/'I6'/
      DATA LABCOL(2)/'X'/,FORM(2)/'F7.1'/
      DATA LABCOL(3)/'Y'/,FORM(3)/'F7.1'/
      DATA LABCOL(4)/'YBKG'/,FORM(4)/'F7.1'/
      DATA LABCOL(5)/'BKG'/,FORM(5)/'E12.3'/
      DATA UNIT(1)/'UNITLESS'/
      DATA UNIT(2)/'PIXEL'/
      DATA UNIT(3)/'PIXEL'/
      DATA UNIT(4)/'PIXEL'/
      DATA UNIT(5)/'DN'/
      DATA NACOL/5/
C
      NDIM   = 3
C
C ... initialize system and read parameters
C
      CALL STSPRO('ECHFOR')
      CALL STKRDC('ECHC',1,1,8,ACTVAL,FRMIN,KUN,KNUL,STATUS)
      CALL STKRDC('ECHC',1,17,4,ACTVAL,METH,KUN,KNUL,STATUS)
      TABLE  = 'ORDER'
      CALL STKRDR('ECHR',1,4,ACTVAL,RPAR,KUN,KNUL,STATUS)
      LEVEL  = RPAR(2)
      IF (METH.EQ.'CO') THEN
          LABCOL(3) = 'YBKG'
          LABCOL(4) = 'Y'
      END IF
      CALL STTPUT(' ECHELLE DEFINITION',STATUS)
      CALL STTPUT(' ------------------',STATUS)
      CALL STTPUT(' INPUT IMAGE  : '//FRMIN,STATUS)
      CALL STTPUT(' OUTPUT TABLE : '//TABLE,STATUS)
      CALL STTPUT(' PARAMETERS  ',STATUS)
      WRITE (LINE,9010) RPAR(2)
      CALL STTPUT(LINE,STATUS)
C
C ... read frame
C
      CALL STIGET(FRMIN,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     .            NDIM,NAXIS,NPIX,START,STEP,IDENA,
     .            CUNITA,PNTRA,IMNI,STATUS)
C
C ... find order positions in the middle of the image
C
      NORDER = 0
      IXSTR  = NPIX(1)/2
      WINDOW = RPAR(1)
      NP     = NPIX(2) - 2*WINDOW
      CALL FINDM1(MADRID(PNTRA),NPIX(1),NPIX(2),IXSTR,WINDOW,NP,LEVEL,
     +            NORDER,ORDPOS,UPPER,LOWER)
      IF (NORDER.EQ.0) THEN
          CALL STTPUT('Order detection failed',STATUS)
          CALL STTPUT('Use a lower threshold',STATUS)
          GO TO 20
      END IF
      WRITE (LINE,9030) NORDER
      CALL STTPUT(LINE,STATUS)
C
C ... allocate table
C
      NTOT   = (NORDER+1)*NPIX(1)/10
      IACOL  = 12
      CALL TBTINI(TABLE,F_TRANS,F_O_MODE,IACOL,NTOT,ID,STATUS)
      DO 10 I = 1,NACOL
          CALL TBCINI(ID,D_R4_FORMAT,1,FORM(I),
     .                UNIT(I),LABCOL(I),ICOL(I),
     +                STATUS)
   10 CONTINUE
      CALL TBCMAP(ID,0,IADD,STATUS)
C
C ... follow orders
C
      CALL FOLLOW(MADRID(PNTRA),NPIX(1),NPIX(2),NORDER,ORDPOS,UPPER,
     +            LOWER,WINDOW,LEVEL,MADRID(IADD),NTOT,NACOL,NPOINT)
C
C ... update number of elements
C
      NTOT   = NPOINT
      CALL STKWRI('ECHI',NORDER,4,1,KUN,STATUS)
      CALL STKWRI('ECHI',NPIX,7,2,KUN,STATUS)
      CALL TBIPUT(ID,NACOL,NTOT,STATUS)
      IDENA = 'ORDER POSITION'
C      CALL SXDPUT(TABLEFULL,'IDENT','C',IDENA,1,72,STATUS)
C      CALL DSCUPD(TABLEFULL,TABLEFULL,' ',STATUS)
      CALL TBSINI(ID,STATUS)
      CALL TBTCLO(ID,STATUS)
C
C ... free data
C
   20 CALL STSEPI
C 9000 FORMAT ('  ORDER WIDTH : ',F6.1)
 9010 FORMAT ('    THRESHOLD : ',F6.1)
C 9020 FORMAT ('        SLOPE : ',F6.3)
 9030 FORMAT (' NUMBER OF DETECTED ORDERS : ',I4)
      END

      SUBROUTINE FOLLOW(X,N1,N2,NORDER,ORDPOS,UPPER,LOWER,WINDOW,THRES,
     +                  TAB,NTOT,NACOL,NP)
C
C  DEFINE ORDER POSTIONS BY FOLLOWING STRUCTURES ABOVE A GIVEN THRESHOLD
C      IMPLICIT NONE
C  INPUT ARGUMENTS
C
C  X(N1, N2) REAL*4 INPUT ARRAY
C  N1, N2       INTG*4 DIMENSIONS OF X
C  NORDER INTG*4 NUMBER OF ORDERS
C  ORDPOS INTG*4 Y POSITION OF THE ORDERS IN PIXELS
C  LOWER,UPPER  INTG*4 LOWER AND UPPER ORDER POSITIONS
C  WINDOW INTG*4 NUMBER OF PIXELS IN THE EXCLUDING WINDOW
C  THRES REAL THRESHOLD
C  NTOT  INTG*4 ALLOCATED SPACE
C
C  OUTPUT ARGUMENTS
C
C  TAB   REAL ARRAY WITH THE LOCATED POSITIONS IN FORMAT
C                   (NTOT,0:NACOL) 1 - ORDER NUMBER
C               2 - SAMPLE
C       3 - MOMENT ORDER 1
C                            4 - position of back.
C       5 - BACKGROUND
C  NP  INTG NUMBER OF LOCATED POSITIONS
C
C-------------------------------------------------------------
C
C
      IMPLICIT NONE

      INTEGER       N1,N2,NORDER,NTOT,NP,NACOL
      INTEGER       NSAMP,ISTAT,IORD,IRL,IL
      REAL          THRES
      REAL          X(N1,N2)
      INTEGER       ORDPOS(NORDER),LOWER(NORDER),UPPER(NORDER)
      INTEGER       ICPOS(20),ILPOS(20),IUPOS(20),WINDOW
      INTEGER       TINULL
      DOUBLE PRECISION TDNULL
      REAL          TAB(NTOT,0:NACOL),TRNULL
      CHARACTER*80  LINE
      LOGICAL       NEXT
      INTEGER       NF,IHW,IXSTR,IBACK,ISTEP,IX,IY,I1,IU
      INTEGER       KZ6902,NPTS,NFOUND
C
      CALL TBMNUL(TINULL,TRNULL,TDNULL)
      NSAMP  = 10
      IXSTR = N1/2
C
C ... DISPLAY RESULTS
C
      CALL STTPUT(' ',ISTAT)
      WRITE (LINE,9020)
      CALL STTPUT(LINE,ISTAT)
      WRITE (LINE,9030)
      CALL STTPUT(LINE,ISTAT)
C
C ... ITERATION ON ORDERS
C
      NP     = 0
      DO 40 IORD = 1,NORDER
C
C ... INCLUDE START + END POINTS
C
          NF     = 0
          IF (IORD.NE.NORDER) IHW    = (ORDPOS(IORD+1)-ORDPOS(IORD))/2
          NP     = NP + 1
          TAB(NP,1) = IORD
          TAB(NP,2) = 1.
          TAB(NP,3) = TRNULL
          TAB(NP,4) = TRNULL
          TAB(NP,5) = TRNULL
          NP     = NP + 1
          TAB(NP,1) = IORD
          TAB(NP,2) = N1
          TAB(NP,3) = TRNULL
          TAB(NP,4) = TRNULL
          TAB(NP,5) = TRNULL
          NP     = NP + 1
          TAB(NP,1) = IORD
          TAB(NP,2) = IXSTR
          TAB(NP,3) = ORDPOS(IORD)
          IBACK  = ORDPOS(IORD) + IHW
          IF (IBACK.LT.N2-WINDOW) THEN
              TAB(NP,4) = IBACK
              TAB(NP,5) = X(IXSTR,IBACK)

          ELSE
              TAB(NP,4) = TRNULL
              TAB(NP,5) = TRNULL
          END IF
C
C ... LEFT/RIGHT  PART OF THE IMAGE
C
          DO 30 IRL = 1,2
              IF (IRL.EQ.1) THEN
                  ISTEP  = 1

              ELSE
                  ISTEP  = -1
              END IF

              IX     = IXSTR
              IL     = LOWER(IORD)
              IU     = UPPER(IORD)
              NEXT   = .TRUE.
99            KZ6902 = 1
                  IF ( .NOT. (NEXT)) GO TO 20
                  IX     = IX + ISTEP
                  IY     = MAX(IL-3,WINDOW)
                  I1     = MIN(N2-WINDOW,IU+3)
                  NPTS   = I1 - IY + 1
                  CALL FINDM1(X,N1,N2,IX,IY,NPTS,THRES,NFOUND,ICPOS,
     +                        IUPOS,ILPOS)
C
C ... CHECK IF ONE ORDER FOUND
C
                  IF (NFOUND.EQ.1) THEN
C
C ... STORE INTO TABLE
C
                      IF (MOD(IX,NSAMP).EQ.0) THEN
                          NF     = NF + 1
                          NP     = NP + 1
                          TAB(NP,1) = IORD
                          TAB(NP,2) = IX
                          TAB(NP,3) = ICPOS(1)
                          IBACK  = ICPOS(1) + IHW
                          IF (IBACK.LT.N2-WINDOW) THEN
                              TAB(NP,4) = IBACK
                              TAB(NP,5) = X(IXSTR,IBACK)

                          ELSE
                              TAB(NP,4) = TRNULL
                              TAB(NP,5) = TRNULL
                          END IF

                      END IF

                      IL     = ILPOS(1)
                      IU     = IUPOS(1)
                      NEXT   = IL .GT. WINDOW .AND. IU .LT.
     +                         (N2-WINDOW) .AND. IX .GT. WINDOW .AND.
     +                         IX .LT. (N1-WINDOW)

                  ELSE
                      NEXT   = .FALSE.
                  END IF

              GOTO 99
   20         CONTINUE
   30     CONTINUE
          WRITE (LINE,9010) IORD,IXSTR,ORDPOS(IORD),IHW,NF
          CALL STTPUT(LINE,ISTAT)
   40 CONTINUE
      WRITE (LINE,9040)
      CALL STTPUT(LINE,ISTAT)
      RETURN

C 9000 FORMAT (I4)
 9010 FORMAT (1X,I7,2X,I8,2X,I8,2X,I10,2X,I8)
 9020 FORMAT (' SEQ.NO.  X CENTER  Y CENTER  INTERORDER  TEMPLA')
 9030 FORMAT (' -------  --------  --------  ----------  --------')
 9040 FORMAT (' -------------------------------------------------')
      END

      SUBROUTINE FINDM1(X,N1,N2,IX,IY,NP,THRES,NORDER,ORDPOS,UPPER,
     +                  LOWER)
C
      IMPLICIT NONE
C 
C  FIND CENTER OF THE ORDERS IN THE MIDDLE OF THE IMAGE
C
C  INPUT ARGUMENTS
C  X(N1,N2) REAL INPUT ARRAY
C  N1,N2 INTG ARRAY DIMENSION
C  IX, IY INTG    STARTING PIXEL POSITIONS
C  NP  INTG    NUMBER OF PIXELS TO SEARCH
C  THRES REAL THRESHOLD
C
C  OUTPUT ARGUMENTS
C  NORDER INTG NUMBER OD ORDERS
C  ORDPOS INTG    POSITION OF THE ORDER (UPPER-LOWER)/2
C  UPPER INTG UPPER ORDER LIMIT
C  LOWER INTG LOWER ORDER LIMIT
C
      INTEGER    N1,N2,IX,IY,NP,NORDER,ISTART,NO,I,NFIRST,NPIX
      INTEGER ORDPOS(1),UPPER(1),LOWER(1),WIDTH,WIDTH1,STATUS
C 
      REAL       THRES
      REAL X(N1,N2)
C 
      LOGICAL FIRST
C
C 
C 
      ISTART = IX
      WIDTH  = 0
C
C ... FIND UPPER LEVEL
C
      FIRST  = .TRUE.
      NO     = 0
      DO 10, I = IY,IY + NP - 1
          IF (X(ISTART,I).GT.THRES) THEN
C
C ... ABOVE THE THRESHOLD
C
              IF (FIRST) THEN
C
C ... FIRST VALUE ABOVE THE THRESHOLD
C
                  FIRST  = .FALSE.
                  NFIRST = I
                  NPIX   = 1
              END IF

          ELSE
C
C ... BELOW THE THRESHOLD
C
              IF ( .NOT. FIRST) THEN
C
C ... FIRST VALUE BELOW THE THRESHOLD
C
                  FIRST  = .TRUE.
                  NO     = NO + 1
                  UPPER(NO) = I - 1
                  LOWER(NO) = NFIRST
                  ORDPOS(NO) = LOWER(NO) + (UPPER(NO)-LOWER(NO))/2
                  IF (WIDTH.EQ.0) THEN
                      WIDTH  = UPPER(NO) - LOWER(NO)

                  ELSE
                      WIDTH1 = UPPER(NO) - LOWER(NO)
                      IF (ABS(WIDTH1-WIDTH).GT.0.1*WIDTH) 
     +                   CALL STTPUT(
     +                  'Warning: Order width changes',STATUS)
                      WIDTH  = WIDTH1
                  END IF

              END IF

          END IF

   10 CONTINUE
      NORDER = NO
      RETURN

      END

C @(#)smosub2.for	19.1 (ES0-DMD) 02/25/03 14:00:30
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE AVER2A(METH,A,B,NX,NY,RADIUS,TR,ALL,V,SUM,CUTS)
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine AVER2A  		version 1.00	861216
C  K. Banse                     ESO - Garching
C  1.10	870227	  1.20	870302		1.50	880224
C  1.60	910521
C
C.KEYWORDS
C  smoothing, neighbourhood
C
C.PURPOSE
C remove spot noise
C
C.ALGORITHM
C  a) smooth image by taking the average A(x,y)of all points in neighbourhood
C     of x,y with given radius, and replace original value I(x,y) by A(x,y),
C     if average differs more than THRESH*I(x,y) from original value
C  b) as a) but take median instead of average
C
C.INPUT/OUTPUT
C  call as   AVER2A(METH,A,B,NX,NY,RADIUS,TR,ALL,V,SUM)
C
C input par:
C  METH:	char.exp.	(1:1) = method to use: always A for average
C                        	(2:2) = A for absolute,
C					R for relative threshold,
C					F for fixed threshold interval
C  A:		R*4 array	input array
C  B:		R*4 array	output array
C  NX:		I*4		no. of pixels per line
C  NY:		I*4		no. of lines in input array
C  RADIUS:	I*4 array	"radius" of neighbourhood in x and y,
C				i.e. no. of pixels in horizontal and vertical
C				direction to include
C  TR:		R*4 (array)	threshold(s) for center point to determine
C				replacement
C  ALL:		I*4		flag for inclusion of center point in averaging
C				= 1: include center point
C				= 0: do not include center point
C  V:		R*8		working buff. of initial rowsums (RADIUS(2)*2+1)
C  SUM:		R*8		working buff. of sums (NPIX(1))
C
C.VERSIONS
C  1.00       has been built on 2.80 of old module AVERAGE
C  1.10       fix bug with index DIFX in relative threshold option
C             (it was 1 too low...)
C  1.20       add fixed threshold interval option
C  1.50       move to FORTRAN 77
C  1.60       also filter the borders (input frame larger now)
C
C --------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      NX,NY,ALL
      INTEGER      DIFX,ICOUNT
      INTEGER      INDX,BINDX
      INTEGER      N,NN,NL,NO,NOZ
      INTEGER      NP,NRL,NXMRX
      INTEGER      OFF,RX,RX1,RXM1,RY,RYNX,TOP
      INTEGER      RADIUS(2),NW1,NW2,NOSUM
C
      REAL         A(*),B(*),TR(*),CUTS(*)
      REAL         W,TEST,COUNT,FACTOR,THRESH
C
      DOUBLE PRECISION   V(*),SUM(NX)
      DOUBLE PRECISION   VNEW
C
      CHARACTER*(*)      METH
C
C  initialize
C
      BINDX = 1
      RX = RADIUS(1)
      RY = RADIUS(2)
      NW1 = RX*2 + 1                  !no. of values on row of filter
      NW2 = RY*2 + 1                  !no. of values on column of filter
      ICOUNT = NW1 * NW2
      COUNT = FLOAT(ICOUNT)          !no. of pixels in neighbourhood with center
C
      RYNX = RY * NX
      NXMRX = NX - RX
      RX1 = RX + 1
      RXM1 = RX - 1
      OFF = RYNX                        !offset for center row
C
      IF (ALL.EQ.0) THEN
         FACTOR = 1. / (COUNT-1.)
      ELSE
         FACTOR = 1. / COUNT
      ENDIF
C
C  fork according to test criterion (for speed reasons)
      IF (METH(2:2).EQ.'F') THEN
         GOTO 4000
      ELSE
         THRESH = TR(1)
      ENDIF
      IF (THRESH.GT.0.) GOTO 2000
C
C
C --------------------------
C
C  here we handle boxcar filtering without thresholding
C
C --------------------------
C
C
C  set up first row sums
      NOZ = 0                        		!offset for lower left
C
      DO 300 N=1,NW2                        	!we have NW2 row sums
         V(N) = 0.D0
         DO 200 NP=NOZ+1,NOZ+NW1
            V(N) = V(N) + A(NP)
200      CONTINUE
         NOZ = NOZ + NX                        !follow with offset...
300   CONTINUE
C
C                 ***
C  do average calculations for first "center" line
C                 ***
C
C  average in the inner part
      TOP = 1                        !init to lower left corner of matrix
      NOSUM = 1                        !point for array of average values
C
      IF (ALL.EQ.0) THEN
         DO 700 INDX=OFF+RX1,OFF+NXMRX
            DIFX = TOP                  !moving offset along line
            SUM(NOSUM)= 0.D0 
C
C  sum over neighbourhood + update the row sums on the fly
C  [ if RX = 0, there should be no out-of-range problem,
C    just spill over into the next lines  (RX = 0 and RY = 0  is not allowed!) ]
C
            DO 500 NRL=1,NW2
               SUM(NOSUM) = SUM(NOSUM) + V(NRL)
               V(NRL) = V(NRL) - A(DIFX) + A(DIFX+NW1)
               DIFX = DIFX + NX
500         CONTINUE
C
C  replace pixel in question by average value
            TEST = (SUM(NOSUM) - A(INDX)) * FACTOR
            B(BINDX) = TEST 
            BINDX = BINDX + 1
            TOP = TOP + 1
            NOSUM = NOSUM + 1
700      CONTINUE
C
      ELSE
         DO 900 INDX=OFF+RX1,OFF+NXMRX
            DIFX = TOP                  !moving offset along line
            SUM(NOSUM) = 0.D0 
C
            DO 800 NRL=1,NW2
               SUM(NOSUM) = SUM(NOSUM) + V(NRL)
               V(NRL) = V(NRL) - A(DIFX) + A(DIFX+NW1)
               DIFX = DIFX + NX
800         CONTINUE
C
            TEST = SUM(NOSUM) * FACTOR
            B(BINDX) = TEST
            BINDX = BINDX + 1
            TOP = TOP + 1
            NOSUM = NOSUM + 1
900      CONTINUE
      ENDIF
C
      OFF = OFF + NX                        !update offset of center line
C
C                 ***
C  now handle average calculations for all following lines
C                 ***
C
      NO = 0                        	!pointer to elements which are out...
      DO 1600 NL=RY+2,NY-RY
C
C  copy first row sums + set up the diff-row sum
         VNEW = 0.D0
         NN = NO - NOZ
         DO 1200 NP=NOZ+1,NOZ+NW1
            VNEW = VNEW + A(NP) - A(NP+NN)
1200     CONTINUE
         TOP = NOZ + 1                  !init to lower left corner of matrix
         NOZ = NOZ + NX                  !follow with offset...
C
C  average in the inner part
         NOSUM = 1
         DIFX = NO + 1
C
         IF (ALL.EQ.0) THEN
            DO 1300 INDX=OFF+RX1,OFF+NXMRX-1
C
C  sum over neighbourhood + update the diff-row sum on the fly
               SUM(NOSUM) = SUM(NOSUM) + VNEW
               VNEW = VNEW - A(TOP) + A(TOP+NW1)
     +                     + A(DIFX) - A(DIFX+NW1)
               TEST = (SUM(NOSUM) - A(INDX)) * FACTOR
C
C  replace pixel in question by average value
               B(BINDX) = TEST 
               BINDX = BINDX + 1
               TOP = TOP + 1
               DIFX = DIFX + 1
               NOSUM = NOSUM + 1
1300        CONTINUE
C
C  handle last pixel on line specially to avoid out_of_bounds for (TOP+NW1)
            SUM(NOSUM) = SUM(NOSUM) + VNEW
            TEST = (SUM(NOSUM) - A(OFF+NXMRX)) * FACTOR
         ELSE
            DO 1400 INDX=OFF+RX1,OFF+NXMRX-1
C
               SUM(NOSUM) = SUM(NOSUM) + VNEW
               VNEW = VNEW - A(TOP) + A(TOP+NW1)
     +                     + A(DIFX) - A(DIFX+NW1)
               TEST = SUM(NOSUM) * FACTOR
               B(BINDX) = TEST
C
C  replace pixel in question by average value
               BINDX = BINDX + 1
               TOP = TOP + 1
               DIFX = DIFX + 1
               NOSUM = NOSUM + 1
1400        CONTINUE
C
C  handle last pixel on line specially to avoid out_of_bounds for (TOP+NW1)
            SUM(NOSUM) = SUM(NOSUM) + VNEW
            TEST = SUM(NOSUM) * FACTOR
         ENDIF
C
         B(BINDX) = TEST                       !for last pixel...
         BINDX = BINDX + 1
         OFF = OFF + NX                        !update offset of center line
         NO = NO + NX
C
1600  CONTINUE
C
C finally update the cuts
      CALL CHCUTS(B,BINDX,CUTS)
      RETURN
C
C  check, if absolute or relative thresholding
C
2000  IF (METH(2:2).NE.'A') GOTO 3000
C
C
C
C --------------------------
C
C  here we handle boxcar filtering with absolute thresholding
C
C --------------------------
C
C
C
C  set up first row sums
      NOZ = 0                        		!offset for lower left
C
      DO 2100 N=1,NW2                        	!we have NW2 row sums
         V(N) = 0.D0
         DO 2060 NP=NOZ+1,NOZ+NW1
            V(N) = V(N) + A(NP)
2060     CONTINUE
         NOZ = NOZ + NX                        !follow with offset...
2100  CONTINUE
C
C                 ***
C  do average calculations for first "center" line
C                 ***
C
C  average in the inner part
      TOP = 1                        !init to lower left corner of matrix
      NOSUM = 1                        !point for array of average values
C
      IF (ALL.EQ.0) THEN
         DO 2200 INDX=OFF+RX1,OFF+NXMRX
            DIFX = TOP                  !moving offset along line
            W = A(INDX)
            SUM(NOSUM)= 0.D0 
C
            DO 2180 NRL=1,NW2
               SUM(NOSUM) = SUM(NOSUM) + V(NRL)
               V(NRL) = V(NRL) - A(DIFX) + A(DIFX+NW1)
               DIFX = DIFX + NX
2180        CONTINUE
C
C  replace pixel in question by average value
            TEST = (SUM(NOSUM) - W) * FACTOR
            IF (ABS(TEST-W).LE.THRESH) TEST = W
            B(BINDX) = TEST
            BINDX = BINDX + 1
            TOP = TOP + 1
            NOSUM = NOSUM + 1
2200     CONTINUE
C
      ELSE
         DO 2300 INDX=OFF+RX1,OFF+NXMRX
            DIFX = TOP                  !moving offset along line
            W = A(INDX)
            SUM(NOSUM) = 0.0
C
            DO 2250 NRL=1,NW2
               SUM(NOSUM) = SUM(NOSUM) + V(NRL)
               V(NRL) = V(NRL) - A(DIFX) + A(DIFX+NW1)
               DIFX = DIFX + NX
2250        CONTINUE
C
            TEST = SUM(NOSUM) * FACTOR
            IF (ABS(TEST-W).LE.THRESH) TEST = W
            B(BINDX) = TEST
            BINDX = BINDX + 1
            TOP = TOP + 1
            NOSUM = NOSUM + 1
2300     CONTINUE
      ENDIF
C
      OFF = OFF + NX                        !update offset of center line
C
C                 ***
C  now handle average calculations for all following lines
C                 ***
C
      NO = 0                        	!offset for elements which are out...
      DO 2900 NL=RY+2,NY-RY
C
C  copy first row sums + set up the diff-row sum
         VNEW = 0.D0
         NN = NO - NOZ
         DO 2450 NP=NOZ+1,NOZ+NW1
            VNEW = VNEW + A(NP) - A(NP+NN)
2450     CONTINUE
         TOP = NOZ + 1                  !init to lower left corner of matrix
         NOZ = NOZ + NX                  !follow with offset...
C
C  average in the inner part
         NOSUM = 1
         DIFX = NO + 1
C
         IF (ALL.EQ.0) THEN
            DO 2600 INDX=OFF+RX1,OFF+NXMRX-1
               W = A(INDX)
               SUM(NOSUM) = SUM(NOSUM) + VNEW
               VNEW = VNEW - A(TOP) + A(TOP+NW1)
     +                     + A(DIFX) - A(DIFX+NW1)
               TEST = (SUM(NOSUM) - W) * FACTOR
C
C  replace pixel in question by average value
               IF (ABS(TEST-W).LE.THRESH) TEST = W
               B(BINDX) = TEST
               BINDX = BINDX + 1
               TOP = TOP + 1
               NOSUM = NOSUM + 1
               DIFX = DIFX + 1
2600        CONTINUE
C
C  handle last pixel on line specially to avoid out_of_bounds for (TOP+NW1)
            W = A(OFF+NXMRX)
            SUM(NOSUM) = SUM(NOSUM) + VNEW
            TEST = (SUM(NOSUM) - W) * FACTOR
            IF (ABS(TEST-W).LE.THRESH) TEST = W
         ELSE
            DO 2700 INDX=OFF+RX1,OFF+NXMRX-1
               W = A(INDX)
               SUM(NOSUM) = SUM(NOSUM) + VNEW
               VNEW = VNEW - A(TOP) + A(TOP+NW1)
     +                     + A(DIFX) - A(DIFX+NW1)
               TEST = SUM(NOSUM) * FACTOR
C
C  replace pixel in question by average value
               IF (ABS(TEST-W).LE.THRESH) TEST = W
               B(BINDX) = TEST
               BINDX = BINDX + 1
               TOP = TOP + 1
               NOSUM = NOSUM + 1
               DIFX = DIFX + 1
2700        CONTINUE
C
C  handle last pixel on line specially to avoid out_of_bounds for (TOP+NW1)
            W = A(OFF+NXMRX)
            SUM(NOSUM) = SUM(NOSUM) + VNEW
            TEST = SUM(NOSUM) * FACTOR
            IF (ABS(TEST-W).LE.THRESH) TEST = W
         ENDIF
C
         B(BINDX) = TEST                       !for last pixel...
         BINDX = BINDX + 1
         OFF = OFF + NX                        !update offset of center line
         NO = NO + NX
C
2900  CONTINUE
C
C finally update the cuts
      CALL CHCUTS(B,BINDX,CUTS)
      RETURN
C
C
C --------------------------
C
C  here we handle boxcar filtering with relative thresholding
C
C --------------------------
C
C
C  set up first row sums
3000  NOZ = 0                        		!offset for lower left
C
      DO 3100 N=1,NW2                        	!we have NW2 row sums
         V(N) = 0.D0
         DO 3060 NP=NOZ+1,NOZ+NW1
            V(N) = V(N) + A(NP)
3060     CONTINUE
         NOZ = NOZ + NX                        !follow with offset...
3100  CONTINUE
C
C                 ***
C  do average calculations for first "center" line
C                 ***
C
C  average in the inner part
      TOP = 1                        !init to lower left corner of matrix
      NOSUM = 1                        !point for array of average values
C
      IF (ALL.EQ.0) THEN
         DO 3300 INDX=OFF+RX1,OFF+NXMRX
            W = A(INDX)
            DIFX = TOP                  !moving offset along line
            SUM(NOSUM)= 0.D0          
C
            DO 3200 NRL=1,NW2
               SUM(NOSUM) = SUM(NOSUM) + V(NRL)
               V(NRL) = V(NRL) - A(DIFX) + A(DIFX+NW1)
               DIFX = DIFX + NX
3200        CONTINUE
C
C  replace pixel in question by average value
            TEST = (SUM(NOSUM) - W) * FACTOR
            IF (ABS(TEST-W).LE.ABS(THRESH*W)) TEST = W
            B(BINDX) = TEST
            BINDX = BINDX + 1
            TOP = TOP + 1
            NOSUM = NOSUM + 1
3300     CONTINUE
C
      ELSE
         DO 3500 INDX=OFF+RX1,OFF+NXMRX
            W = A(INDX)
            DIFX = TOP                  !moving offset along line
            SUM(NOSUM) = 0.D0     
C
            DO 3400 NRL=1,NW2
               SUM(NOSUM) = SUM(NOSUM) + V(NRL)
               V(NRL) = V(NRL) - A(DIFX) + A(DIFX+NW1)
               DIFX = DIFX + NX
3400        CONTINUE
C
            TEST = SUM(NOSUM) * FACTOR
            IF (ABS(TEST-W).LE.ABS(THRESH*W)) TEST = W
            B(BINDX) = TEST
            BINDX = BINDX + 1
            TOP = TOP + 1
            NOSUM = NOSUM + 1
3500     CONTINUE
      ENDIF
C
      OFF = OFF + NX                        !update offset of center line
C
C                 ***
C  now handle average calculations for all following lines
C                 ***
C
      NO = 0                        	!offset for elements which are out...
      DO 3900 NL=RY+2,NY-RY
C
C  copy first row sums + set up the diff-row sum
         VNEW = 0.D0
         NN = NO - NOZ
         DO 3650 NP=NOZ+1,NOZ+NW1
            VNEW = VNEW + A(NP) - A(NP+NN)
3650     CONTINUE
         TOP = NOZ + 1                  !init to lower left corner of matrix
         NOZ = NOZ + NX                  !follow with offset...
C
C  average in the inner part
         NOSUM = 1
         DIFX = NO + 1
C
         IF (ALL.EQ.0) THEN
            DO 3700 INDX=OFF+RX1,OFF+NXMRX-1
               W = A(INDX)
               SUM(NOSUM) = SUM(NOSUM) + VNEW
               VNEW = VNEW - A(TOP) + A(TOP+NW1)
     +                     + A(DIFX) - A(DIFX+NW1)
               TEST = (SUM(NOSUM) - W) * FACTOR
C
C  replace pixel in question by average value
               IF (ABS(TEST-W).LE.ABS(THRESH*W)) TEST = W
               B(BINDX) = TEST
               BINDX = BINDX + 1
               TOP = TOP + 1
               NOSUM = NOSUM + 1
               DIFX = DIFX + 1
3700        CONTINUE
C
C  handle last pixel on line specially to avoid out_of_bounds for (TOP+NW1)
            W = A(OFF+NXMRX)
            SUM(NOSUM) = SUM(NOSUM) + VNEW
            TEST = (SUM(NOSUM) - W) * FACTOR
            IF (ABS(TEST-W).LE.ABS(THRESH*W)) TEST = W
         ELSE
            DO 3800 INDX=OFF+RX1,OFF+NXMRX-1
               W = A(INDX)
               SUM(NOSUM) = SUM(NOSUM) + VNEW
               VNEW = VNEW - A(TOP) + A(TOP+NW1)
     +                     + A(DIFX) - A(DIFX+NW1)
               TEST = SUM(NOSUM) * FACTOR
C
C  replace pixel in question by average value
               IF (ABS(TEST-W).LE.ABS(THRESH*W)) TEST = W
               B(BINDX) = TEST
               BINDX = BINDX + 1
               TOP = TOP + 1
               NOSUM = NOSUM + 1
               DIFX = DIFX + 1
3800        CONTINUE
C
C  handle last pixel on line specially to avoid out_of_bounds for (TOP+NW1)
            W = A(OFF+NXMRX)
            SUM(NOSUM) = SUM(NOSUM) + VNEW
            TEST = SUM(NOSUM) * FACTOR
            IF (ABS(TEST-W).LE.ABS(THRESH*W)) TEST = W
         ENDIF
C
         B(BINDX) = TEST                       !for last pixel...
         BINDX = BINDX + 1
         OFF = OFF + NX                        !update offset of center line
         NO = NO + NX
C
3900  CONTINUE
C
C finally update the cuts
      CALL CHCUTS(B,BINDX,CUTS)
      RETURN
C
C
C --------------------------
C
C  here we handle boxcar filtering with fixed thresholding interval
C
C --------------------------
C
C
C  set up first row sums
4000  NOZ = 0                        		!offset for lower left
C
      DO 4100 N=1,NW2                        	!we have NW2 row sums
         V(N) = 0.D0
         DO 4060 NP=NOZ+1,NOZ+NW1
            V(N) = V(N) + A(NP)
4060     CONTINUE
         NOZ = NOZ + NX                        !follow with offset...
4100  CONTINUE
C
C                 ***
C  do average calculations for first "center" line
C                 ***
C
C  average in the inner part
      TOP = 1                        !init to lower left corner of matrix
      NOSUM = 1                        !point for array of average values
C
      IF (ALL.EQ.0) THEN
         DO 4300 INDX=OFF+RX1,OFF+NXMRX
            TEST = A(INDX)
            DIFX = TOP                  !moving offset along line
            SUM(NOSUM)= 0.D0   
C
            DO 4200 NRL=1,NW2
               SUM(NOSUM) = SUM(NOSUM) + V(NRL)
               V(NRL) = V(NRL) - A(DIFX) + A(DIFX+NW1)
               DIFX = DIFX + NX
4200        CONTINUE
C
C  replace pixel in question by average value
            IF ( (TEST.GE.TR(1)) .AND. (TEST.LE.TR(2)) ) 
     +         TEST = (SUM(NOSUM) - TEST) * FACTOR
            B(BINDX) = TEST
            BINDX = BINDX + 1
            TOP = TOP + 1
            NOSUM = NOSUM + 1
4300     CONTINUE
C
      ELSE
         DO 4500 INDX=OFF+RX1,OFF+NXMRX
            TEST = A(INDX)
            DIFX = TOP                  !moving offset along line
            SUM(NOSUM) = 0.D0  
C
            DO 4400 NRL=1,NW2
               SUM(NOSUM) = SUM(NOSUM) + V(NRL)
               V(NRL) = V(NRL) - A(DIFX) + A(DIFX+NW1)
               DIFX = DIFX + NX
4400        CONTINUE
C
            IF ( (TEST.GE.TR(1)) .AND. (TEST.LE.TR(2)) )
     +         TEST = SUM(NOSUM) * FACTOR
            B(BINDX) = TEST
            BINDX = BINDX + 1
            TOP = TOP + 1
            NOSUM = NOSUM + 1
4500     CONTINUE
      ENDIF
C
      OFF = OFF + NX                        !update offset of center line
C
C                 ***
C  now handle average calculations for all following lines
C                 ***
C
      NO = 0                        	!offset for elements which are out...
      DO 4900 NL=RY+2,NY-RY
C
C  copy first row sums + set up the diff-row sum
         VNEW = 0.D0
         NN = NO - NOZ
         DO 4650 NP=NOZ+1,NOZ+NW1
            VNEW = VNEW + A(NP) - A(NP+NN)
4650     CONTINUE
         TOP = NOZ + 1                  !init to lower left corner of matrix
         NOZ = NOZ + NX                  !follow with offset...
C
C  average in the inner part
         NOSUM = 1
         DIFX = NO + 1
C
         IF (ALL.EQ.0) THEN
            DO 4700 INDX=OFF+RX1,OFF+NXMRX-1
               TEST = A(INDX)
               SUM(NOSUM) = SUM(NOSUM) + VNEW
               VNEW = VNEW - A(TOP) + A(TOP+NW1)
     +                     + A(DIFX) - A(DIFX+NW1)
C
C  replace pixel in question by average value
               IF ( (TEST.GE.TR(1)) .AND. (TEST.LE.TR(2)) )
     +            TEST = (SUM(NOSUM) - TEST) * FACTOR
               B(BINDX) = TEST
               BINDX = BINDX + 1
               TOP = TOP + 1
               NOSUM = NOSUM + 1
               DIFX = DIFX + 1
4700        CONTINUE
C
C  handle last pixel on line specially to avoid out_of_bounds for (TOP+NW1)
            TEST = A(OFF+NXMRX)
            SUM(NOSUM) = SUM(NOSUM) + VNEW
            IF ( (TEST.GE.TR(1)) .AND. (TEST.LE.TR(2)) )
     +         TEST = (SUM(NOSUM) - TEST) * FACTOR
         ELSE
            DO 4800 INDX=OFF+RX1,OFF+NXMRX-1
               TEST = A(INDX)
               SUM(NOSUM) = SUM(NOSUM) + VNEW
               VNEW = VNEW - A(TOP) + A(TOP+NW1)
     +                     + A(DIFX) - A(DIFX+NW1)
C
C  replace pixel in question by average value
               IF ( (TEST.GE.TR(1)) .AND. (TEST.LE.TR(2)) )
     +            TEST = SUM(NOSUM) * FACTOR
               B(BINDX) = TEST
               BINDX = BINDX + 1
               TOP = TOP + 1
               NOSUM = NOSUM + 1
               DIFX = DIFX + 1
4800        CONTINUE
C
C  handle last pixel on line specially to avoid out_of_bounds for (TOP+NW1)
            TEST = A(OFF+NXMRX)
            SUM(NOSUM) = SUM(NOSUM) + VNEW
            IF ( (TEST.GE.TR(1)) .AND. (TEST.LE.TR(2)) )
     +         TEST = SUM(NOSUM) * FACTOR
         ENDIF
C
         B(BINDX) = TEST                       !for last pixel...
         BINDX = BINDX + 1
         OFF = OFF + NX                        !update offset of center line
         NO = NO + NX
C
4900  CONTINUE
C 
C finally update the cuts
      CALL CHCUTS(B,BINDX,CUTS)
      RETURN
C 
      END

      SUBROUTINE BVER2A(METH,A,B,NX,NY,RADIUS,TR,ALL,V,SUM,CUTS)
C
      IMPLICIT NONE
C
      INTEGER      NX,NY,ALL
      INTEGER      DIFX,ICOUNT
      INTEGER      INDX,BINDX
      INTEGER      N,NN,NL,NO,NOZ
      INTEGER      NP,NRL,NXMRX
      INTEGER      OFF,RX,RX1,RXM1,RY,RYNX,TOP
      INTEGER      RADIUS(2),NW1,NW2,NOSUM
C
      REAL         A(*),B(*),TR(*),CUTS(*)
      REAL         W,TEST,COUNT,FACTOR,THRESH
C
      DOUBLE PRECISION   V(*),SUM(*)
      DOUBLE PRECISION   VNEW
C
      CHARACTER*(*)      METH
C
C  initialize
C
      BINDX = 1
      RX = RADIUS(1)
      RY = RADIUS(2)
      NW1 = RX*2 + 1                  !no. of values on row of filter
      NW2 = RY*2 + 1                  !no. of values on column of filter
      ICOUNT = NW1 * NW2
      COUNT = FLOAT(ICOUNT)          !no. of pixels in neighbourhood with center
C
      RYNX = RY * NX
      NXMRX = NX - RX
      RX1 = RX + 1
      RXM1 = RX - 1
      OFF = RYNX                        !offset for center row
C
      IF (ALL.EQ.0) THEN
         FACTOR = 1. / (COUNT-1.)
      ELSE
         FACTOR = 1. / COUNT
      ENDIF
C
C  fork according to test criterion (for speed reasons)
      IF (METH(2:2).EQ.'F') THEN
         GOTO 4000
      ELSE
         THRESH = TR(1)
      ENDIF
      IF (THRESH.GT.0.) GOTO 2000
C
C
C --------------------------
C
C  here we handle boxcar filtering without thresholding
C
C --------------------------
C
C
C  set up first row sums
      NOZ = 0                        		!offset for lower left
C
      DO 300 N=1,NW2                        	!we have NW2 row sums
         V(N) = 0.D0
         DO 200 NP=NOZ+1,NOZ+NW1
            V(N) = V(N) + A(NP)
200      CONTINUE
         NOZ = NOZ + NX                        !follow with offset...
300   CONTINUE
C
C                 ***
C  do average calculations for first "center" line
C                 ***
C
C  average in the inner part
      TOP = 1                        !init to lower left corner of matrix
      NOSUM = 1                        !point for array of average values
C
      IF (ALL.EQ.0) THEN
         DO 700 INDX=OFF+RX1,OFF+NXMRX
            DIFX = TOP                  !moving offset along line
            SUM(NOSUM)= 0.D0  
C
C  sum over neighbourhood + update the row sums on the fly
C  [ if RX = 0, there should be no out-of-range problem,
C    just spill over into the next lines  (RX = 0 and RY = 0  is not allowed!) ]
C
            DO 500 NRL=1,NW2
               SUM(NOSUM) = SUM(NOSUM) + V(NRL)
               V(NRL) = V(NRL) - A(DIFX) + A(DIFX+NW1)
               DIFX = DIFX + NX
500         CONTINUE
C
C  replace pixel in question by average value
            TEST = (SUM(NOSUM) - A(INDX)) * FACTOR
            B(BINDX) = TEST 
            BINDX = BINDX + 1
            TOP = TOP + 1
            NOSUM = NOSUM + 1
700      CONTINUE
C
      ELSE
         DO 900 INDX=OFF+RX1,OFF+NXMRX
            DIFX = TOP                  !moving offset along line
            SUM(NOSUM) = 0.D0  
C
            DO 800 NRL=1,NW2
               SUM(NOSUM) = SUM(NOSUM) + V(NRL)
               V(NRL) = V(NRL) - A(DIFX) + A(DIFX+NW1)
               DIFX = DIFX + NX
800         CONTINUE
C
            TEST = SUM(NOSUM) * FACTOR
            B(BINDX) = TEST
            BINDX = BINDX + 1
            TOP = TOP + 1
            NOSUM = NOSUM + 1
900      CONTINUE
      ENDIF
C
      OFF = OFF + NX                        !update offset of center line
C
C                 ***
C  now handle average calculations for all following lines
C                 ***
C
      NO = 0                        	!pointer to elements which are out...
      DO 1600 NL=RY+2,NY-RY
C
C  copy first row sums + set up the diff-row sum
         VNEW = 0.D0
         NN = NO - NOZ
         DO 1200 NP=NOZ+1,NOZ+NW1
            VNEW = VNEW + A(NP) - A(NP+NN)
1200     CONTINUE
         TOP = NOZ + 1                  !init to lower left corner of matrix
         NOZ = NOZ + NX                  !follow with offset...
C
C  average in the inner part
         NOSUM = 1
         DIFX = NO + 1
C
         IF (ALL.EQ.0) THEN
            DO 1300 INDX=OFF+RX1,OFF+NXMRX
C
C  sum over neighbourhood + update the diff-row sum on the fly
               SUM(NOSUM) = SUM(NOSUM) + VNEW
               VNEW = VNEW - A(TOP) + A(TOP+NW1)
     +                     + A(DIFX) - A(DIFX+NW1)
               TEST = (SUM(NOSUM) - A(INDX)) * FACTOR
C
C  replace pixel in question by average value
               B(BINDX) = TEST 
               BINDX = BINDX + 1
               TOP = TOP + 1
               DIFX = DIFX + 1
               NOSUM = NOSUM + 1
1300        CONTINUE
C
         ELSE
            DO 1400 INDX=OFF+RX1,OFF+NXMRX
C
               SUM(NOSUM) = SUM(NOSUM) + VNEW
               VNEW = VNEW - A(TOP) + A(TOP+NW1)
     +                     + A(DIFX) - A(DIFX+NW1)
               TEST = SUM(NOSUM) * FACTOR
               B(BINDX) = TEST
               BINDX = BINDX + 1
C
C  replace pixel in question by average value
               TOP = TOP + 1
               DIFX = DIFX + 1
               NOSUM = NOSUM + 1
1400        CONTINUE
         ENDIF
C
         OFF = OFF + NX                        !update offset of center line
         NO = NO + NX
C
1600  CONTINUE
C
C finally update the cuts
      CALL CHCUTS(B,BINDX,CUTS)
      RETURN
C
C
C  check, if absolute or relative thresholding
C
2000  IF (METH(2:2).NE.'A') GOTO 3000
C
C
C
C --------------------------
C
C  here we handle boxcar filtering with absolute thresholding
C
C --------------------------
C
C
C
C  set up first row sums
      NOZ = 0                        		!offset for lower left
C
      DO 2100 N=1,NW2                        	!we have NW2 row sums
         V(N) = 0.D0
         DO 2060 NP=NOZ+1,NOZ+NW1
            V(N) = V(N) + A(NP)
2060     CONTINUE
         NOZ = NOZ + NX                        !follow with offset...
2100  CONTINUE
C
C                 ***
C  do average calculations for first "center" line
C                 ***
C
C  average in the inner part
      TOP = 1                        !init to lower left corner of matrix
      NOSUM = 1                        !point for array of average values
C
      IF (ALL.EQ.0) THEN
         DO 2200 INDX=OFF+RX1,OFF+NXMRX
            DIFX = TOP                  !moving offset along line
            W = A(INDX)
            SUM(NOSUM)= 0.D0
C
            DO 2180 NRL=1,NW2
               SUM(NOSUM) = SUM(NOSUM) + V(NRL)
               V(NRL) = V(NRL) - A(DIFX) + A(DIFX+NW1)
               DIFX = DIFX + NX
2180        CONTINUE
C
C  replace pixel in question by average value
            TEST = (SUM(NOSUM) - W) * FACTOR
            IF (ABS(TEST-W).LE.THRESH) TEST = W
            B(BINDX) = TEST
            BINDX = BINDX + 1
            TOP = TOP + 1
            NOSUM = NOSUM + 1
2200     CONTINUE
C
      ELSE
         DO 2300 INDX=OFF+RX1,OFF+NXMRX
            DIFX = TOP                  !moving offset along line
            W = A(INDX)
            SUM(NOSUM) = 0.D0
C
            DO 2250 NRL=1,NW2
               SUM(NOSUM) = SUM(NOSUM) + V(NRL)
               V(NRL) = V(NRL) - A(DIFX) + A(DIFX+NW1)
               DIFX = DIFX + NX
2250        CONTINUE
C
            TEST = SUM(NOSUM) * FACTOR
            IF (ABS(TEST-W).LE.THRESH) TEST = W
            B(BINDX) = TEST
            BINDX = BINDX + 1
            TOP = TOP + 1
            NOSUM = NOSUM + 1
2300     CONTINUE
      ENDIF
C
      OFF = OFF + NX                        !update offset of center line
C
C                 ***
C  now handle average calculations for all following lines
C                 ***
C
      NO = 0                        	!offset for elements which are out...
      DO 2900 NL=RY+2,NY-RY
C
C  copy first row sums + set up the diff-row sum
         VNEW = 0.D0
         NN = NO - NOZ
         DO 2450 NP=NOZ+1,NOZ+NW1
            VNEW = VNEW + A(NP) - A(NP+NN)
2450     CONTINUE
         TOP = NOZ + 1                  !init to lower left corner of matrix
         NOZ = NOZ + NX                  !follow with offset...
C
C  average in the inner part
         NOSUM = 1
         DIFX = NO + 1
C
         IF (ALL.EQ.0) THEN
            DO 2600 INDX=OFF+RX1,OFF+NXMRX
               W = A(INDX)
               SUM(NOSUM) = SUM(NOSUM) + VNEW
               VNEW = VNEW - A(TOP) + A(TOP+NW1)
     +                     + A(DIFX) - A(DIFX+NW1)
               TEST = (SUM(NOSUM) - W) * FACTOR
C
C  replace pixel in question by average value
               IF (ABS(TEST-W).LE.THRESH) TEST = W
               B(BINDX) = TEST
               BINDX = BINDX + 1
               TOP = TOP + 1
               NOSUM = NOSUM + 1
               DIFX = DIFX + 1
2600        CONTINUE
C
         ELSE
            DO 2700 INDX=OFF+RX1,OFF+NXMRX
               W = A(INDX)
               SUM(NOSUM) = SUM(NOSUM) + VNEW
               VNEW = VNEW - A(TOP) + A(TOP+NW1)
     +                     + A(DIFX) - A(DIFX+NW1)
               TEST = SUM(NOSUM) * FACTOR
C
C  replace pixel in question by average value
               IF (ABS(TEST-W).LE.THRESH) TEST = W
               B(BINDX) = TEST
               TOP = TOP + 1
               NOSUM = NOSUM + 1
               DIFX = DIFX + 1
2700        CONTINUE
         ENDIF
C
         OFF = OFF + NX                        !update offset of center line
         NO = NO + NX
C
2900  CONTINUE
C
C finally update the cuts
      CALL CHCUTS(B,BINDX,CUTS)
      RETURN
C
C
C --------------------------
C
C  here we handle boxcar filtering with relative thresholding
C
C --------------------------
C
C
C  set up first row sums
3000  NOZ = 0                        		!offset for lower left
C
      DO 3100 N=1,NW2                        	!we have NW2 row sums
         V(N) = 0.D0
         DO 3060 NP=NOZ+1,NOZ+NW1
            V(N) = V(N) + A(NP)
3060     CONTINUE
         NOZ = NOZ + NX                        !follow with offset...
3100  CONTINUE
C
C                 ***
C  do average calculations for first "center" line
C                 ***
C
C  average in the inner part
      TOP = 1                        !init to lower left corner of matrix
      NOSUM = 1                        !point for array of average values
C
      IF (ALL.EQ.0) THEN
         DO 3300 INDX=OFF+RX1,OFF+NXMRX
            W = A(INDX)
            DIFX = TOP                  !moving offset along line
            SUM(NOSUM)= 0.D0       
C
            DO 3200 NRL=1,NW2
               SUM(NOSUM) = SUM(NOSUM) + V(NRL)
               V(NRL) = V(NRL) - A(DIFX) + A(DIFX+NW1)
               DIFX = DIFX + NX
3200        CONTINUE
C
C  replace pixel in question by average value
            TEST = (SUM(NOSUM) - W) * FACTOR
            IF (ABS(TEST-W).LE.ABS(THRESH*TEST)) TEST = W
            B(BINDX) = TEST
            BINDX = BINDX + 1
            TOP = TOP + 1
            NOSUM = NOSUM + 1
3300     CONTINUE
C
      ELSE
         DO 3500 INDX=OFF+RX1,OFF+NXMRX
            W = A(INDX)
            DIFX = TOP                  !moving offset along line
            SUM(NOSUM) = 0.D0
C
            DO 3400 NRL=1,NW2
               SUM(NOSUM) = SUM(NOSUM) + V(NRL)
               V(NRL) = V(NRL) - A(DIFX) + A(DIFX+NW1)
               DIFX = DIFX + NX
3400        CONTINUE
C
            TEST = SUM(NOSUM) * FACTOR
            IF (ABS(TEST-W).LE.ABS(THRESH*TEST)) TEST = W
            B(BINDX) = TEST
            BINDX = BINDX + 1
            TOP = TOP + 1
            NOSUM = NOSUM + 1
3500     CONTINUE
      ENDIF
C
      OFF = OFF + NX                        !update offset of center line
C
C                 ***
C  now handle average calculations for all following lines
C                 ***
C
      NO = 0                        	!offset for elements which are out...
      DO 3900 NL=RY+2,NY-RY
C
C  copy first row sums + set up the diff-row sum
         VNEW = 0.D0
         NN = NO - NOZ
         DO 3650 NP=NOZ+1,NOZ+NW1
            VNEW = VNEW + A(NP) - A(NP+NN)
3650     CONTINUE
         TOP = NOZ + 1                  !init to lower left corner of matrix
         NOZ = NOZ + NX                  !follow with offset...
C
C  average in the inner part
         NOSUM = 1
         DIFX = NO + 1
C
         IF (ALL.EQ.0) THEN
            DO 3700 INDX=OFF+RX1,OFF+NXMRX
               W = A(INDX)
               SUM(NOSUM) = SUM(NOSUM) + VNEW
               VNEW = VNEW - A(TOP) + A(TOP+NW1)
     +                     + A(DIFX) - A(DIFX+NW1)
               TEST = (SUM(NOSUM) - W) * FACTOR
C
C  replace pixel in question by average value
               IF (ABS(TEST-W).LE.ABS(THRESH*TEST)) TEST = W
               B(BINDX) = TEST
               BINDX = BINDX + 1
               TOP = TOP + 1
               NOSUM = NOSUM + 1
               DIFX = DIFX + 1
3700        CONTINUE
C
         ELSE
            DO 3800 INDX=OFF+RX1,OFF+NXMRX
               W = A(INDX)
               SUM(NOSUM) = SUM(NOSUM) + VNEW
               VNEW = VNEW - A(TOP) + A(TOP+NW1)
     +                     + A(DIFX) - A(DIFX+NW1)
               TEST = SUM(NOSUM) * FACTOR
C
C  replace pixel in question by average value
               IF (ABS(TEST-W).LE.ABS(THRESH*TEST)) TEST = W
               B(BINDX) = TEST
               BINDX = BINDX + 1
               TOP = TOP + 1
               NOSUM = NOSUM + 1
               DIFX = DIFX + 1
3800        CONTINUE
         ENDIF
C
         OFF = OFF + NX                        !update offset of center line
         NO = NO + NX
C
3900  CONTINUE
C
C finally update the cuts
      CALL CHCUTS(B,BINDX,CUTS)
      RETURN
C
C
C
C --------------------------
C
C  here we handle boxcar filtering with fixed thresholding interval
C
C --------------------------
C
C
C  set up first row sums
4000  NOZ = 0                        		!offset for lower left
C
      DO 4100 N=1,NW2                        	!we have NW2 row sums
         V(N) = 0.D0
         DO 4060 NP=NOZ+1,NOZ+NW1
            V(N) = V(N) + A(NP)
4060     CONTINUE
         NOZ = NOZ + NX                        !follow with offset...
4100  CONTINUE
C
C                 ***
C  do average calculations for first "center" line
C                 ***
C
C  average in the inner part
      TOP = 1                        !init to lower left corner of matrix
      NOSUM = 1                        !point for array of average values
C
      IF (ALL.EQ.0) THEN
         DO 4300 INDX=OFF+RX1,OFF+NXMRX
            TEST = A(INDX)
            DIFX = TOP                  !moving offset along line
            SUM(NOSUM)= 0.D0  
C
            DO 4200 NRL=1,NW2
               SUM(NOSUM) = SUM(NOSUM) + V(NRL)
               V(NRL) = V(NRL) - A(DIFX) + A(DIFX+NW1)
               DIFX = DIFX + NX
4200        CONTINUE
C
C  replace pixel in question by average value
            IF ( (TEST.GE.TR(1)) .AND. (TEST.LE.TR(2)) ) 
     +         TEST = (SUM(NOSUM) - TEST) * FACTOR
            B(BINDX) = TEST
            TOP = TOP + 1
            NOSUM = NOSUM + 1
4300     CONTINUE
C
      ELSE
         DO 4500 INDX=OFF+RX1,OFF+NXMRX
            TEST = A(INDX)
            DIFX = TOP                  !moving offset along line
            SUM(NOSUM) = 0.D0
C
            DO 4400 NRL=1,NW2
               SUM(NOSUM) = SUM(NOSUM) + V(NRL)
               V(NRL) = V(NRL) - A(DIFX) + A(DIFX+NW1)
               DIFX = DIFX + NX
4400        CONTINUE
C
            IF ( (TEST.GE.TR(1)) .AND. (TEST.LE.TR(2)) )
     +         TEST = SUM(NOSUM) * FACTOR
            B(BINDX) = TEST
            BINDX = BINDX + 1
            TOP = TOP + 1
            NOSUM = NOSUM + 1
4500     CONTINUE
      ENDIF
C
      OFF = OFF + NX                        !update offset of center line
C
C                 ***
C  now handle average calculations for all following lines
C                 ***
C
      NO = 0                        	!offset for elements which are out...
      DO 4900 NL=RY+2,NY-RY
C
C  copy first row sums + set up the diff-row sum
         VNEW = 0.D0
         NN = NO - NOZ
         DO 4650 NP=NOZ+1,NOZ+NW1
            VNEW = VNEW + A(NP) - A(NP+NN)
4650     CONTINUE
         TOP = NOZ + 1                  !init to lower left corner of matrix
         NOZ = NOZ + NX                  !follow with offset...
C
C  average in the inner part
         NOSUM = 1
         DIFX = NO + 1
C
         IF (ALL.EQ.0) THEN
            DO 4700 INDX=OFF+RX1,OFF+NXMRX
               TEST = A(INDX)
               SUM(NOSUM) = SUM(NOSUM) + VNEW
               VNEW = VNEW - A(TOP) + A(TOP+NW1)
     +                     + A(DIFX) - A(DIFX+NW1)
C
C  replace pixel in question by average value
               IF ( (TEST.GE.TR(1)) .AND. (TEST.LE.TR(2)) )
     +            TEST = (SUM(NOSUM) - TEST) * FACTOR
               B(BINDX) = TEST
               BINDX = BINDX + 1
               TOP = TOP + 1
               NOSUM = NOSUM + 1
               DIFX = DIFX + 1
4700        CONTINUE
C
         ELSE
            DO 4800 INDX=OFF+RX1,OFF+NXMRX
               TEST = A(INDX)
               SUM(NOSUM) = SUM(NOSUM) + VNEW
               VNEW = VNEW - A(TOP) + A(TOP+NW1)
     +                     + A(DIFX) - A(DIFX+NW1)
C
C  replace pixel in question by average value
               IF ( (TEST.GE.TR(1)) .AND. (TEST.LE.TR(2)) )
     +            TEST= SUM(NOSUM) * FACTOR
               B(BINDX) = TEST
               BINDX = BINDX + 1
               TOP = TOP + 1
               NOSUM = NOSUM + 1
               DIFX = DIFX + 1
4800        CONTINUE
         ENDIF
C
         OFF = OFF + NX                        !update offset of center line
         NO = NO + NX
C
4900  CONTINUE
C
C finally update the cuts
      CALL CHCUTS(B,BINDX,CUTS)
      RETURN
C
      END

C @(#)irsbadpix.for	19.1 (ES0-DMD) 02/25/03 14:23:42
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.COPYRIGHT   (C) 1992 European Southern Observatory
C.IDENT       irsbadpix.for
C.AUTHOR      E. Oliva,  Firenze-Arcetri
C.KEYWORDS    Spectroscopy, IRSPEC
C
C.PURPOSE     Modify values of badpixels in a image (FRAMEI).
C             The coordinates of badpixels is contained inside an input
C             table (REFTAB) in the columns X_COORD,Y_COORD.
C             These coordinates are intended as -- pixel coordinates ---
C             => this program will not work if one define the 'badpixel'
C             table in a 'not-original' frame (i.e. a frame with starts
C             and steps not equl to unity)!
C             The output frame is FRAMEO 
C             This fortran code is called by "irsbadix.prg"
C
C.ALGORITHM   Define the value of each badpixel as the average
C             of either:
C             x: the two neighbouring pixels in X
C             y: the two neighbouring pixels in Y
C             b: the four neighbouring pixels in X+Y
C             In each mode the program uses only the good pixels =>
C             => if the bad-pixels are clustered some of them will
C             not be substituted, in which case a warning message
C             (with pixel coordinates) is printed.
C             The choice between x,y,b is done automatically if the input
C             keyword direct is set to "a" (the default), in this case
C             "b" is used whenever the gradients along X and Y do not
C             different by more than a factor of 2, otherwise take
C             the direction with the smaller gradient.
C             The 'direction option' can also be forced manually to
C             "x","y" or "b.
C
C
C.INPUT/OUTPUT keyword IN_A  --> name of input frame
C              keyword OUT_A --> name of output frame
C              keyword IN_B  --> name of output frame
C              local keyword direct/c/1/1 --> 'direction option', see above
C              local keyword debug/i/1/1 --> if >0 prints many details
C                                            (to be used in case of problems)
C
C
C.VERSION     1.0    Creation     02.09.1992   E. Oliva
C
C-------------------------------------------------------
C
      PROGRAM BADPIX
      IMPLICIT REAL(A-H,O-Z)
      IMPLICIT INTEGER(I-N)

      CHARACTER*60 FRAMEI,FRAMEO,REFTAB
      CHARACTER*1 DIRECT
      CHARACTER*64 CUNIT
      CHARACTER*72 IDENT
      LOGICAL    NULL
      INTEGER*8  INPNTR,OUPNTR
      INTEGER    MMPIX(2)
      INTEGER    NPIX(2),IXBAD(500),IYBAD(500)
      DOUBLE PRECISION START(2),STEP(2)
      REAL CUTS(2)
      COMMON /VMR/ MADRID(1)

      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'

      DATA MAXDIM/2/

      IRET=1
      CALL STSPRO('BADPIX')
C
C GET NAME OF INPUT FRAME AND MAP IT
C CHECK ALSO WHETHER IT IS A 2D FRAME.....
C
      CALL STKRDC('IN_A',1,1,60,IRET,FRAMEI,KUNIT,KNUL,ISTAT)
      CALL CLNFRA(FRAMEI,FRAMEI,0)
      CALL STIGET(FRAMEI,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,MAXDIM,
     ,            NAXIS,NPIX,START,STEP,
     ,            IDENT,CUNIT,INPNTR,NIN,ISTAT)
      IF(NAXIS.NE.2) 
     +     CALL STETER(1,'Input frame must be 2-D')
C
C GET NAME OF OUTPUT FRAME AND MAP IT
C
      CALL STKRDC('OUT_A',1,1,60,IRET,FRAMEO,KUNIT,KNUL,ISTAT)
      CALL CLNFRA(FRAMEO,FRAMEO,0)
      CALL STIPUT(FRAMEO,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     ,            NAXIS,NPIX,START,STEP,
     ,            IDENT,CUNIT,OUPNTR,NOU,ISTAT)
C
C GET FLAG TO DEFINE WHICH NEIGHBOURING PIXELS HAVE TO BE CONSIDERED
C
      CALL STKRDC('direct',1,1,1,IRET,DIRECT,KUNIT,KNUL,ISTAT)
C
C get debug option
C
      CALL STKRDI('debug',1,1,IRET,IDEBUG,KUNIT,KNUL,ISTAT)
C
C OPEN  FOR READING (IOPEN=0)
C THE TABLE CONTAINING THE COORDINATES OF THE
C BAD PIXELS WHICH MUST BE SUBSTITUTED BY THE AVERAGE OF THE
C 2 NEIGHBOURING PIXELS ALONG X (DIRECT=X) Y (DIRECT=Y), 
C THE 4 X+Y PIXELS (DIRECT=B) OR THE AUTOMATIC MODE
C
C
      CALL STKRDC('IN_B',1,1,60,IRET,REFTAB,KUNIT,KNUL,ISTAT)
      CALL CLNTAB(REFTAB,REFTAB,0)
      IOPEN=0
      CALL TBTOPN(REFTAB,IOPEN,IDETAB,ISTAT)
C
C GET NUMBERS CORRESPONDING TO XCOL AND YCOL
C
      CALL TBLSER(IDETAB,'X_COORD',NXCOL,ISTAT)
      CALL TBLSER(IDETAB,'Y_COORD',NYCOL,ISTAT)
C
C GET INFORMATION UPON THE TABLE SIZE (N.B. NROW = # OF BAD PIXELS....)
C
      CALL TBIGET(IDETAB,NCOL,NROW,NSORT,NCALL,NRALL,ISTAT)
      NBAD=NROW
C
C COPY TABLE ELEMENTS INTO VECTORS IXBAD,IYBAD
C
      DO IROW=1,NROW
        CALL TBERDR(IDETAB,IROW,NXCOL,RVAL,NULL,ISTAT)
        IXBAD(IROW)=RVAL
        CALL TBERDR(IDETAB,IROW,NYCOL,RVAL,NULL,ISTAT)
        IYBAD(IROW)=RVAL
      ENDDO
      CALL TBTCLO(IDETAB,ISTAT)
C
C CALL ROUTINE WHICH SUBSTITUTES THE BAD PIXELS LISTED IN THE
C
      CALL SUBSTI(MADRID(INPNTR),MADRID(OUPNTR),
     ,                NPIX(1),NPIX(2),IXBAD,IYBAD,NBAD,DIRECT,IDEBUG)
C
C Define and write cuts of output file
C
      CALL MNMX(MADRID(OUPNTR),NPIX,CUTS,MMPIX)
      CALL STDWRR(NOU,'LHCUTS',CUTS,3,2,KUNIT,ISTAT)
C
C RELEASE FILES, UPDATE KEYWORDS AND EXIT
C
      CALL STSEPI
      END
C
C
C
      SUBROUTINE SUBSTI(A,B,NX,NY,IXBAD,IYBAD,NBAD,DIRECT,IDEBUG)
C
C SUBSTITUTE THE VALUE OF THE BAD PIXELS HAVING (PIXEL) COORDINATES
C (IXBAD(J),IYBAD(J)),J=1,NBAD WITH THE AVERAGE VALUE OF THE 2 NEIGHBOURING
C PIXELS ALONG X (DIRECT=X), ALONG Y (DIRECT=Y) OR OF THE 4 PIXELS ALONG X+Y
C (DIRECT=B).
C In case direct=a makes automatic choice.
C WARNING! THE ROUTINE ASSUMES THAT THE BAD PIXELS ARE MOSTLY ISOLATED.
C IT CAN ALSO DEAL WITH 2-3 CONTIGUOS BAD PIXELS BUT IT MUST NOT BE 
C USED WHEN THE BAD PIXELS ARE CLUSTERED. IN PARTICULAR IT MUST NOT BE USED 
C WHEN MORE THAN 2 BAD PIXELS ARE ALIGNED.
C
      IMPLICIT REAL(A-H,O-Z)
      IMPLICIT INTEGER(I-N)
      CHARACTER*1 DIRECT,DMODE(4),CMODE(4)
      DIMENSION A(NX,NY),B(NX,NY)
      DIMENSION IXBAD(NBAD),IYBAD(NBAD)
      CHARACTER*80 OUTPUT
C
      DATA DMODE/'x','y','b','a'/
      DATA CMODE/'X','Y','B','A'/
C
C COPY INPUT IMAGE (A) INTO OUTPUT IMAGE (B)
C
      TOTVAL=0.0
      NGOOD=0
      NOZERO=0
      DO J=1,NY
        DO I=1,NX
          B(I,J)=A(I,J)
          IFLAG=GOODP(I,J,IXBAD,IYBAD,NBAD,NX,NY)
          IF(IFLAG.GT.0) THEN
            TOTVAL=TOTVAL+A(I,J)
            NGOOD=NGOOD+1
            IF(A(I,J).NE.0) NOZERO=1
          ENDIF
        ENDDO
      ENDDO
      IF(NGOOD.LE.0) THEN
        WRITE(OUTPUT,191)
191     FORMAT(
     + 'No good pixel in image, check your reference table')
         CALL STTPUT(OUTPUT,ISTAT)
        RETURN
      ENDIF
      IF(NOZERO.EQ.0) THEN
        WRITE(OUTPUT,192)
192     FORMAT(
     + 'All good pixel in image have intensities =0, check it please')
        CALL STTPUT(OUTPUT,ISTAT)
        RETURN
      ENDIF
      AVER_PIX=TOTVAL/NGOOD
C
      DO I=1,4
        IMODE=I
        IF(DIRECT.EQ.DMODE(I) .OR. DIRECT.EQ.CMODE(I)) GO TO 10
      ENDDO
      CALL STETER
     +(1,'Invalid direction option, only a x y b are recognized')
10    CONTINUE
      IF(AVER_PIX.EQ.0 .AND. IMODE.EQ.4) THEN
        IMODE=3
        WRITE(OUTPUT,193)
193     FORMAT(
     + 'Average=0, option=b used')
        CALL STTPUT(OUTPUT,ISTAT)
      ENDIF
      DO IBAD=1,NBAD
        I=IXBAD(IBAD)
        J=IYBAD(IBAD)
        CALL SIGXY(A,NX,NY,I,J,IXBAD,IYBAD,NBAD,SIGX,SIGY)
        IF(I.LT.1 .OR. J.LT.1 .OR. I.GT.NX .OR. J.GT.NY) GO TO 20
C
C STORE VALUES OF CONTIGUOS PIXELS AND TAKE CARE OF EDGE EFFECTS
C AND OF CONTIGUOS BAD PIXELS
C
        TOTX=0.
        GX1=GOODP(I-1,J,IXBAD,IYBAD,NBAD,NX,NY)
        TOTX=TOTX+GX1
        X1=0.
        IF(GX1.GT.0.) X1=A(I-1,J)
        GX2=GOODP(I+1,J,IXBAD,IYBAD,NBAD,NX,NY)
        TOTX=TOTX+GX2
        X2=0.
        IF(GX2.GT.0.) X2=A(I+1,J)
        TOTY=0.
        GY1=GOODP(I,J-1,IXBAD,IYBAD,NBAD,NX,NY)
        TOTY=TOTY+GY1
        Y1=0.
        IF(GY1.GT.0.) Y1=A(I,J-1)
        GY2=GOODP(I,J+1,IXBAD,IYBAD,NBAD,NX,NY)
        TOTY=TOTY+GY2
        Y2=0.
        IF(GY2.GT.0.) Y2=A(I,J+1)
        IF(IMODE.LE.3) THEN
          JMODE=IMODE
        ELSE
          IF(TOTX.LE.1 .AND. TOTY.LE.1) THEN
            JMODE=3
            GO TO 11
          ENDIF
          IF(TOTX.LE.1) THEN
            JMODE=2
            GO TO 11
          ENDIF
          IF(TOTY.LE.1) THEN
            JMODE=1
            GO TO 11
          ENDIF
          JMODE=3
          IF(SIGX.GT.(4*SIGY)) JMODE=2
          IF(SIGY.GT.(4*SIGX)) JMODE=1
        ENDIF
11      CONTINUE
        IF(IDEBUG.GT.0) THEN
          WRITE(OUTPUT,119) I,J,DMODE(JMODE)
119       FORMAT('Badpixel (' , I3 , ',' , I3 , ') dir= ', A)
          CALL STTPUT(OUTPUT,ISTAT)
        ENDIF
        IF(JMODE.EQ.1) THEN
          IF(TOTX.EQ.0.) THEN
            WRITE(OUTPUT,101) 
101         FORMAT(
     + '>2 bad pixels along X, (',I2,',',I2,') not modified')
            CALL STTPUT(OUTPUT,ISTAT)
          ELSE
            B(I,J)=(X1+X2)/TOTX
          ENDIF
        ENDIF
        IF(JMODE.EQ.2) THEN
          IF(TOTY.EQ.0.) THEN
            WRITE(OUTPUT,102) I,J
102         FORMAT(
     + '>2 bad pixels along Y, (',I2,',',I2,') not modified')
            CALL STTPUT(OUTPUT,ISTAT)
          ELSE
            B(I,J)=(Y1+Y2)/TOTY
          ENDIF
        ENDIF
        IF(JMODE.EQ.3) THEN
          TOT=TOTX+TOTY
          IF(TOT.EQ.0.) THEN
            WRITE(OUTPUT,103) I,J
103         FORMAT(
     + 'region crowded with bad pixels, (',I2,',',I2,') not modified')
            CALL STTPUT(OUTPUT,ISTAT)
          ELSE
            B(I,J)=(X1+X2+Y1+Y2)/TOT
          ENDIF
        ENDIF
20    CONTINUE
      ENDDO
C
      RETURN
      END
C
C
C
      FUNCTION GOODP(I,J,IBAD,JBAD,NBAD,NX,NY)
C
C CHECK WHETHER PIXEL (I,J) IS A BAD PIXEL...
C   GOODP = 0  BAD PIXEL
C   GOODP = 1  GOOD PIXEL
C N.B. GOODP=0 ALSO WHEN I OR J ARE OUTSIDE THE IMAGE
C
      IMPLICIT REAL(A-H,O-Z)
      IMPLICIT INTEGER(I-N)
      INTEGER IBAD(NBAD),JBAD(NBAD)

      GOODP=1
      IF(I.LT.1 .OR. J.LT.1 .OR. I.GT.NX .OR. J.GT.NY) THEN
        GOODP=0
        RETURN
      ENDIF
      DO K=1,NBAD
        IF(I.EQ.IBAD(K).AND.J.EQ.JBAD(K)) THEN
          GOODP=0
          RETURN
        ENDIF
      ENDDO
      RETURN
      END


      SUBROUTINE SIGXY(A,NX,NY,IX,IY,IXBAD,IYBAD,NBAD,SIGX,SIGY)

      IMPLICIT REAL(A-H,O-Z)
      IMPLICIT INTEGER(I-N)
      REAL A(NX,NY)
      INTEGER IXBAD(NBAD),IYBAD(NBAD)

C
C sigma of the neighbouring 10 pixels along Y --> SIGY
C
      SUM=0.0
      SUM2=0.0
      NTOT=0
      I=IX
      NPT=0
      DO J=IY+1,NY
        IFLAG=GOODP(I,J,IXBAD,IYBAD,NBAD,NX,NY)
        IF(IFLAG.GT.0) THEN
          VAL=A(I,J)
          SUM=SUM+VAL
          SUM2=SUM2+VAL*VAL
          NTOT=NTOT+1
          NPT=NPT+1
          IF(NPT.GE.5) GO TO 10
        ENDIF
      ENDDO
10    CONTINUE
      NPT=0
      DO J=IY-1,1,-1
        IFLAG=GOODP(I,J,IXBAD,IYBAD,NBAD,NX,NY)
        IF(IFLAG.GT.0) THEN
          VAL=A(I,J)
          SUM=SUM+VAL
          SUM2=SUM2+VAL*VAL
          NTOT=NTOT+1
          NPT=NPT+1
          IF(NPT.GE.5) GO TO 11
        ENDIF
      ENDDO
11    CONTINUE
      IF(NTOT.GT.0) THEN
        SIGY=SQRT((SUM2-SUM*SUM/NTOT)/(NTOT-1))
      ELSE
        SIGY=1e20
      ENDIF

C
C sigma of the neighbouring 10 pixels along X --> SIGX
C
      SUM=0.0
      SUM2=0.0
      NTOT=0
      J=IY
      NPT=0
      DO I=IX+1,NX
        IFLAG=GOODP(I,J,IXBAD,IYBAD,NBAD,NX,NY)
        IF(IFLAG.GT.0) THEN
          VAL=A(I,J)
          SUM=SUM+VAL
          SUM2=SUM2+VAL*VAL
          NTOT=NTOT+1
          NPT=NPT+1
          IF(NPT.GE.5) GO TO 20
        ENDIF
      ENDDO
20    CONTINUE
      NPT=0
      DO I=IX-1,1,-1
        IFLAG=GOODP(I,J,IXBAD,IYBAD,NBAD,NX,NY)
        IF(IFLAG.GT.0) THEN
          VAL=A(I,J)
          SUM=SUM+VAL
          SUM2=SUM2+VAL*VAL
          NTOT=NTOT+1
          NPT=NPT+1
          IF(NPT.GE.5) GO TO 21
        ENDIF
      ENDDO
21    CONTINUE
      IF(NTOT.GT.0) THEN
        SIGX=SQRT((SUM2-SUM*SUM/NTOT)/(NTOT-1))
      ELSE
        SIGX=1e20
      ENDIF

      RETURN
      END

C @(#)chorec.for	19.1 (ES0-DMD) 02/25/03 13:17:29
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE CHOREC(A,N,NDIM,ISTAT)                                         
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                   
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:25 - 13 JAN 1988                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C.IDENTIFICATION                                                                
C                                                                               
C  FITLIB.FOR   VERSION 1.0  27 MAR 1984                                        
C                                                                               
C.PURPOSE                                                                       
C                                                                               
C  INTERFACE ROUTINES FOR THE FITTING STRUCTURES                                
C                                                                               
C.ALGORITHM                                                                     
C                                                                               
C  USE MIDAS I/O INTERFACES TO FRAMES AND TABLES                                
C                                                                               
C.KEYWORDS                                                                      
C                                                                               
C  NON LINEAR FITTING                                                           
C                                                                               
C                                                                               
C----------------------------------------------------------------               
C                                                                               
C INVERSION OF A SYMMETRIC POSITIVE MATRIX                                      
C      IMPLICIT NONE                                                            
C USING THE CHOLESKY ALGORITHM                                                  
C                                                                               
C INPUT PARAMS                                                                  
C A DBLE INPUT MATRIX                                                           
C N INTG ACTUAL MATRIX RANGE                                                    
C NDIM INTG TRUE DIMENSION IN MATRIX                                            
C                                                                               
C OUTPUT PARAMS                                                                 
C ISTAT INTG 0 - NO ERROR                                                       
C                                                                               
C THE MATRIX IS INVERTED IN-PLACE                                               
C                                                                               
C                                                                               
      INTEGER NDIM,N,ISTAT,I,J,K,KK
      DOUBLE PRECISION A(NDIM,NDIM)                                             
C                                                                               
      DOUBLE PRECISION P,Q,H(400)                                               
C REAL*8 X,Y,Z                                                                  
C                                                                               
      ISTAT  = 0                                                                
      IF (N.GT.NDIM) GO TO 70                                                   
C                                                                               
C MATRIX INVERSION USING THE GAUSS-JORDAN METHOD                                
C  MODIFIED VERSION BY F.L. BAUER AND C. REINSCH                                
C                                                                               
      DO 40 K = 1,N                                                             
          IF (A(1,1).LE.0.0D0) THEN                                             
              ISTAT  = 1                                                        
              GO TO 70                                                          
                                                                                
          END IF                                                                
                                                                                
          KK     = N + 1 - K                                                    
          P      = 1.0D0/A(1,1)                                                 
          DO 20 I = 2,N                                                         
              Q      = A(I,1)                                                   
              H(I)   = Q*P                                                      
              IF (I.LE.KK) H(I)   = -H(I)                                       
              DO 10 J = 2,I                                                     
                  A(I-1,J-1) = A(I,J) + Q*H(J)                                  
   10         CONTINUE                                                          
   20     CONTINUE                                                              
          A(N,N) = P                                                            
          DO 30 I = 2,N                                                         
              A(N,I-1) = H(I)                                                   
   30     CONTINUE                                                              
   40 CONTINUE                                                                  
      DO 60 I = 2,N                                                             
          DO 50 J = 1,I                                                         
              A(J,I) = A(I,J)                                                   
   50     CONTINUE                                                              
   60 CONTINUE                                                                  
C                                                                               
C  ... Routine below does not work !                                            
C                                                                               
C DO I = 1,N                                                                    
C   DO J = I,N                                                                  
C     X = A(I,J)                                                                
C     IF (I.NE.1) THEN                                                          
C       DO K = 1,I-1                                                            
C         X = X-A(J+1,I-K)*A(I+1,I-K)                                           
C       ENDDO                                                                   
C     ENDIF                                                                     
C     IF (I.NE.J) THEN                                                          
C       A(J+1,I) = X*Y                                                          
C     ELSE                                                                      
C       IF (X.LE.0.0D0) THEN                                                    
C  ISTAT = 1                                                                    
C  GO TO 1000                                                                   
C       ENDIF                                                                   
C       Y = 1.0D0/DSQRT(X)                                                      
C       A(I+1,I) = Y                                                            
C     ENDIF                                                                     
C   ENDDO                                                                       
C ENDDO                                                                         
C DO I = 2,N                                                                    
C   DO J = I,N                                                                  
C     Z = 0.0D0                                                                 
C     DO K = I,J-1                                                              
C       Z = Z-A(J+1,K)*A(K+1,I-1)                                               
C     ENDDO                                                                     
C     A(J+1,I-1) = Z*A(J+1,J)                                                   
C   ENDDO                                                                       
C ENDDO                                                                         
C DO I = 1,N                                                                    
C   DO J = I,N                                                                  
C     Z = 0.0D0                                                                 
C     DO K = J,N                                                                
C       Z = Z+A(K+1,J)*A(K+1,I)                                                 
C     ENDDO                                                                     
C     A(J+1,I) = Z                                                              
C   ENDDO                                                                       
C ENDDO                                                                         
C DO I = 2,N                                                                    
C   DO J = I,N                                                                  
C     A(I-1,J) = A(J,I-1)                                                       
C   ENDDO                                                                       
C ENDDO                                                                         
      RETURN                                                                    
                                                                                
   70 ISTAT  = ISTAT + 1                                                        
      RETURN                                                                    
                                                                                
      END                                                                       

C @(#)extrss.for	19.1 (ES0-DMD) 02/25/03 14:01:06
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
        SUBROUTINE EXTRSS(STRING,DELIM,START,SS,SLEN)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine EXTRSS         	version 2.50	880201
C  K. Banse                      ESO - Garching
C
C.KEYWORDS
C  character string , parsing
C
C.PURPOSE
C  from a given string extract a substring limited by given
C  delimiters 
C
C.ALGORITHM
C  find the given delimiter in the string 
C  copy the relevant part into the substring
C  spaces in front or after delimiters are ignored
C
C.INPUT/OUTPUT
C  call as  EXTRSS(STRING,DELIM,START,SS,SLEN)
C
C  input par:
C  STRING:        char. exp.        character string which is to be parsed
C  DELIM:        char. exp.        delimiter string
C
C  input/output par:
C  START:        I*4                starting index within the input
C                                string - will be set to the position
C                                just following the next delimiter
C                                upon return
C
C  output par:
C  SS:                char. exp.        extracted substring
C                                will be set to spaces, if nothing there
C  SLEN:        I*4                length of extracted substring in bytes
C
C--------------------------------------------------
C
      INTEGER   START,SLEN
      INTEGER   SOSS,EOSS,SKIP,NEXTD
      INTEGER   KOFF,KLEN,N
      INTEGER   MM
C 
      CHARACTER*(*)   STRING,DELIM,SS
C
      SS = ' ' 
      SLEN = 0
C
C  see, if already the end of string reached
      KLEN = LEN(STRING)
      IF (KLEN.LT.START) GOTO 3000
C
C  skip leading blanks
      SKIP = 0
      KOFF = START - 1
C 
      DO 100 N=1,KLEN
         IF (STRING(KOFF+N:KOFF+N).NE.' ') THEN
            SKIP = N
            GOTO 150
         ENDIF
100   CONTINUE
      SKIP = KLEN
C 
150   IF (SKIP.LE.0) GOTO 3000                
C 
C  find begin of substring + next delimiter
      SOSS = START + SKIP - 1
      MM = INDEX(STRING(SOSS:KLEN),DELIM) 
      IF (MM.LE.0) MM = KLEN - SOSS + 2
      NEXTD = MM + SOSS - 2
      IF (NEXTD.LT.SOSS) GOTO 500                
C
C  cut off trailing blanks
      IF (DELIM.EQ.' ') THEN
         EOSS = NEXTD
      ELSE
         MM = INDEX(STRING(SOSS:NEXTD),DELIM) 
         IF (MM.LE.0) MM = NEXTD - SOSS + 2
         EOSS = MM + SOSS - 2
      ENDIF
C        
C  look for character constants with embedded blanks, ".. .."
      IF ((DELIM.NE.' ').OR.(STRING(SOSS:SOSS).NE.'"')) GOTO 400
      IF ((SOSS.EQ.EOSS).OR.
     +    (STRING(EOSS:EOSS).NE.'"')) THEN
         MM = INDEX(STRING(SOSS+1:KLEN),'"') 
         IF (MM.GT.0) THEN
            IF ( (STRING(SOSS+MM+1:SOSS+MM+1).EQ.' ') .OR.
     +           ((SOSS + MM).EQ.KLEN) ) THEN
C  update end of substring
               EOSS = MM + SOSS                
               NEXTD = EOSS                        
            ENDIF
         ENDIF
      ENDIF
C        
C  copy string
400   SS(1:) = STRING(SOSS:EOSS)
      SLEN = EOSS - SOSS + 1
500   START = NEXTD + LEN(DELIM) + 1
      RETURN
C
3000  START = 0
      RETURN
      END

C @(#)irasubs.for	19.1 (ES0-DMD) 02/25/03 13:23:49
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      character*(*) function object (text)
      character*132 line
      character*(*) text
      common /imid/ imdata, imcopy, dtype
      if ((text(1:1) .eq. 'd') .or. (text(1:1) .eq. 'D')) then
         i = imdata
      else if ((text(1:1) .eq. 'c') .or. (text(1:1) .eq. 'C')) then
         i = imcopy
      else
         object = ' '
         return
      end if
      call imgkwc (i, 'title', line, ier)
      if (ier .ne. 0) then
         call imgkwc (imdata, 'OBJECT', line, ier)
      end if
      if (ier .ne. 0) then
         call imgkwc (i, 'COMMENT', line, ier)
      end if
      if (ier .ne. 0) then
         object = ' '
         return
      end if
      do i=1,132
         if (line(i:i) .ne. ' ') then
            object = line(i:132)
            return
         end if
      end do
      object = ' '
      return
      end
c
c
c
      subroutine attach (image, open)
      character expand*100, message*64, object*64
      character*30 image, coofil, magfil, psffil, profil,
     .     grpfil, switch, extend
      integer axlen(7), dtype
      logical*1 open
      common /filnam/ coofil, magfil, psffil, profil, grpfil
      common /imid/ imdata, imcopy, dtype
      common /size/ ncol, nrow
      call imopen (expand(extend(image,'imh')), 1, imdata, ier)
      if (ier .eq. 0) then
         open = .true.
         call imgkwc (imdata, 'title', object, ier)
         if (ier .ne. 0) then
            call imgkwc (imdata, 'OBJECT', object, ier)
         end if
         if (ier .ne. 0) then
            call imgkwc (imdata, 'COMMENT', object, ier)
         end if
         if (ier .eq. 0) then
            write (6,601) object
  601       format (/10x, a/)
         end if
         call imgsiz (imdata, axlen, naxis, dtype, ier)
         if (ier .ne. 0) then
            call stupid (message(ier))
            open = .false.
            return
         else if (naxis .eq. 1) then
            ncol = axlen(1)
            nrow = 1
         else
            ncol = axlen(1)
            nrow = axlen(2)
         end if
         write (6,611) ncol, nrow
  611    format (38x, 'Picture size: ', 2i5)
         coofil = switch(image, '.coo')
         magfil = switch(image, '.ap')
         psffil = switch(image, '.psf')
         profil = switch(image, '.nst')
         grpfil = switch(image, '.grp')
      else
         open = .false.
         call stupid (message(ier))
      end if
      return
      end
c
c
c
      character*80 function message (ier)
      character*80 error
      call imemsg (ier,error)
      message = error
      return
      end
c
c
c
      subroutine crepic (picture, type, ncol, nrow, ier)
      character*100 expand
      character*80 message
      character*30 picture, extend
d     character*30 new
      character*6 type
      integer*4 len(7)
      common /imid/ imdata, imcopy, idtype
      call imopen (expand(extend(picture, 'imh')), 1, imcopy, ier)
      if (ier .eq. 0) then
d        call stupid ('Output image already exists')
d        new = 'OVERWRITE'
d        call getname ('New output file name:', new)
d        if (new .eq. 'OVERWRITE') then
            call imdele (picture, ier)
d        else
d           picture = new
d        end if
d        call tblank
      end if
c
      len(1) = ncol
      len(2) = nrow
      if ((type(1:1) .eq. 'R') .or. (type(1:1) .eq. 'r')) 
     .     idtype = 6
      call imcrea (picture, len, 2, idtype, ier)
      if (ier .ne. 0) call stupid (message(ier))
      call imopen (picture, 3, imcopy, ier)
      if (ier .ne. 0) call stupid (message(ier))
      call imhcpy (imdata, imcopy, ier)
      if (ier .ne. 0) call stupid (message(ier))
      return
      end
c
c
c
      subroutine coppic (picture, pix, ncol, nrow, ier)
      character*80 message
      character*30 picture
d     character*30 new
      real*4 pix(ncol)
      common /imid/ imdata, imcopy, idtype
c
      call imopen (picture, 3, j, ier)
      if (ier .eq. 0) then
d        call stupid ('Output image already exists')
d        new = 'OVERWRITE'
d        call getname ('New output file name:', new)
d        if (new .eq. 'OVERWRITE') then
            call imdele (picture, ier)
d        else
d           picture = new
d        end if
d        call tblank
      end if
c
      call imopnc (picture, imdata, imcopy, ier)
      if (ier .ne. 0) call stupid(message(ier))
      do j = 1,nrow
         call imgl2r (imdata, pix, j, ier)
         if (ier .ne. 0) call stupid(message(ier))
         call impl2r (imcopy, pix, j, ier)
         if (ier .ne. 0) call stupid(message(ier))
      end do
      return
      end
c
c
c
      subroutine rdaray (text, lx, ly, mx, my, nx, func, ier)
      character*80 message
      character*4 text
      real*4 func(nx,*)
      common /size/ ncol, nrow
      common /imid/ imdata, imcopy, idtype
      if (text .eq. 'DATA') then
         id = imdata
      else
         id = imcopy
      end if
      mx = lx+mx-1
      my = ly+my-1
      lx = max(1,lx)
      ly = max(1,ly)
      mx = min(ncol,mx)
      my = min(nrow,my)
      my = my-ly+1
      do j=1,my
         jy = ly+j-1
         call imgs2r (id, func(1,j), lx, mx, jy, jy, ier)
         if (ier .ne. 0) then 
            call stupid(message(ier))
            write (6,*) 'rdaray:  x =', lx, ' to', mx, 
     .           '  y =', jy
         end if
      end do
      mx = mx-lx+1
      return
      end
c
c
c
      subroutine wraray (text, lx, ly, mx, my, maxx, func, ier)
      character*80 message
      character*4 text
      real*4 func(maxx,*), row(4096)
      common /size/ ncol, nrow
      common /imid/ imdata, imcopy, idtype
      if (text .eq. 'DATA') then
         id = imdata
      else
         id = imcopy
      end if
      mx = lx+mx-1
      my = ly+my-1
      lx = max(1,lx)
      ly = max(1,ly)
      mx = min(ncol, mx)
      my = min(nrow, my)
      nx = mx-lx+1
      ny = my-ly+1
      do j=1,ny
         jy = ly+j-1
         do i=1,nx
            if (idtype .le. 3) then
               row(i) = max(-32768., min(32767., func(i,j)))
            else
               row(i) = func(i,j)
            end if
            if (idtype .le. 5) then
               row(i) = anint(row(i))
            end if
         end do
         call imps2r (id, row, lx, mx, jy, jy, ier)
         if (ier .ne. 0) then
            call stupid(message(ier))
            write (6,*) 'wraray:  x =', lx, ' to', mx, 
     .           ' y =', jy
         end if
      end do
      mx = nx
      my = ny
      return
      end
c
c
c
      subroutine clpic (text)
      character*4 text
      common /imid/ imdata, imcopy, idtype
      if (text .eq. 'DATA') then
         id = imdata
      else
         id = imcopy
      end if
      call imclos (id, ier)
      return
      end
c
c
c
      subroutine delpic (image, ier)
      character*30 image
      call imdele (image, ier)
      return
      end
c
c
c
      subroutine  writem  (picture, label, type, string)
      real*8 double
c     real*4 single
c     integer*4 long
c     integer*2 short
      integer*4 dtype
      character expand*100, picture*30, extend*30, 
     .     label*8, type*1, string*(*)
      common /imid/ imdata, imcopy, dtype
      call imopen (expand(extend(picture,'imh')), 3, imdata, istat)
      if (istat .ne. 0) then
         call stupid ('Error opening image.')
         write (6,*) istat
         call oops
      end if
c
      if ((type .eq. 'D') .or. (type .eq. 'd')) then
         read (string,*,iostat=istat) double
         if (istat .ne. 0) then
            call stupid ('Error reading datum from string:')
            write (6,*) string
            call oops
         end if
         call imakwd (imdata, label, double, ' ', istat)
         if (istat .ne. 0) then
            call stupid ('Error writing header item:')
            write (6,*) label, '= ', double
         end if
      end if
      call imclos (imdata, istat)
      return
      end
C
C
C
      SUBROUTINE LIST (FILE)
      CHARACTER*30 FILE
      CALL TBLANK
      WRITE (6,*) 'Image file = ', FILE
      CALL TBLANK
      RETURN
      END

C @(#)tdname.for	19.1 (ES0-DMD) 02/25/03 14:11:18
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:58 - 11 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C.IDENTIFICATION        TDNAME.FOR
C.KEYWORDS           TABLE, APPLICATIONS
C.ENVIRONMENT  MIDAS
C.PURPOSE
C  Transfroms the short name (optionally without file type),
C  into the long name with type appended
C
C
C------------------------------------------------------------------
      SUBROUTINE TDNAME(INNAME,TYPE,OUTNAM)
      IMPLICIT NONE
      CHARACTER*(*) INNAME ! IN  : short name
      CHARACTER*(*) TYPE   ! IN  : file type   
      CHARACTER*(*) OUTNAM ! OUT : long name
C
      CHARACTER*80  SDUM
C
      INTEGER I1,I2,I3
C
C ... search for end of name
C
      SDUM   = INNAME//' '
      I1     = INDEX(SDUM,' ') - 1
C
C ... search for VMS directory path
C
      I2     = INDEX(INNAME(1:I1),']')
C
C ... search for filename type
C
      I3     = INDEX(INNAME(I2+1:I1),'.')
C
C ... append file type if required
C
      IF (I3.EQ.0) THEN
          OUTNAM = INNAME(1:I1)//'.'//TYPE

      ELSE
          OUTNAM = INNAME
      END IF

      RETURN

      END

C @(#)arthmy.for	19.2 (ESO-DMD) 05/20/03 09:41:53
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE ARTHMY(PLADIR,ZDEFA,ZRESFR,ZLINE)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine ARTHMY			version 1.00	950803
C  K. Banse            		      	ESO - Garching
C
C.KEYWORDS
C  arithmetic operations, bulk data frames
C
C.PURPOSE
C  evaluate an arithmetic expression involving frames, constants and functions
C  and store the result into a data frame or key OUTPUTR(1), if used as pocket calculator
C
C.ALGORITHM
C  "clean" the expression by replacing all frame names by F, all constants by C
C  and all functions by P, convert it to polish (postfix) notation and evaluate it piecewise
C  establish special condition handler for arithmetic traps...
C  copy all descriptors of first frame operand to result frame.
C
C.INPUT/OUTPUT
C  call as ARTHMY(PLADIR,ZDEFA,ZRESFR,ZLINE)
C  
C  input par:
C  PLADIR:	I*4		plane direction 
C				X_Z_PLANE, X_Y_PLANE or Z_Y_PLANE
C  ZDEFA:	char.		2 char. default string
C				(1) Y or N for result frame or not
C  ZRESFR:	char.		name of result frame
C  ZLINE:	char.		char.string with arithmetic expression
C	
C.VERSIONS
C 030519	last modif
C	
C-------------------------------------------------------------------------
C
      IMPLICIT NONE
C
C  important parameter: WORKLM = 45
C
      CHARACTER*(*)  ZDEFA,ZRESFR,ZLINE
      CHARACTER      INFRAM(23)*80                   !MAXFRAM = WORKLM/2 + 1
      CHARACTER      ATOM(23)*80,OPER(23)*5          !size = MAXFRAM
      CHARACTER      RESFRA*80,DSCFRA*80
      CHARACTER      CUNIT*80,IDENT*72
      CHARACTER      WORK*50,WORK1*50,OUTPU*80,WORKY*1
      CHARACTER      ERROR3*50,ERROR4*40
C      
      REAL         CONST,CUTS(4),USRNUL
      REAL         DATTA(23),RDUM(1)                 !size = MAXFRAM
C 
      DOUBLE PRECISION STEP(3),START(3),DDUM(1)
C      
      INTEGER      NULCNT,NNN
      INTEGER      LATOM(23),WORKLM                  !size = MAXFRAM
      INTEGER      APNTRS(48)                        !size = WORKLM + 3
      INTEGER*8    PNTR(27)                          !size = MAXFRAM + 4
      INTEGER*8    XPNTR,RPNTR
      INTEGER      IMNO(23),IPLANE(23)               !size = MAXFRAM
      INTEGER      DIM3(23),PIDX(23),PPP(23)         !size = MAXFRAM
      INTEGER      PLADIR,OPLANE,PLINDX
      INTEGER      FRACNT,NPIX(3),NPIXA(3),YPIX(2)
      INTEGER      COUNT,IAV,K,LL,DIM1ON
      INTEGER      N,NAXIS,NAXISA,TOTAL
      INTEGER      SIZE,INFO(5),DATFMT
      INTEGER      MAPSIZ,STAT
      INTEGER      NNULL,UNIT(1),INPU(1),OPCNT
      INTEGER      RIMNO,WIMNO,MADRID(1)
      INTEGER      UPDA,DSCORG,XIMNO
C 
      INCLUDE  'MID_INCLUDE:ST_DEF.INC'
C      
      COMMON      /NULCOM/ NULCNT,USRNUL
      COMMON      /IPOOL/  FRACNT
      COMMON      /VMR/ MADRID
C 
      DATA      WORKLM      /45/
      DATA      CUNIT       /' '/,  IDENT       /' '/
      DATA      ERROR3
     +          /'wrong syntax in arithmetic expression ...'/
      DATA      ERROR4      /'too many operands...'/
C      
      INCLUDE  'MID_INCLUDE:ST_DAT.INC'
C      
C  init variables
      TOTAL = 0
      MAPSIZ = 0
      DIM1ON = 0
      CUTS(1) = 0.
      CUTS(2) = 0.
      CUTS(3) = + 999999.9
      CUTS(4) = - 999999.9
C 
      DO 130, N=1,23
         DATTA(N) = 0.0
130   CONTINUE
      DO 140, N=1,48
         APNTRS(N) = -1
140   CONTINUE
      DO 150, N=1,3
         NPIX(N) = 1
         START(N) = 0.D0
         STEP(N) = 1.D0
150   CONTINUE
C 
C  reduce expression... (clean up + fill ATOM, LATOM)
200   SIZE = 80                                !length of ATOM(i) strings
      CALL EXPCLE(ZLINE,WORK,SIZE,COUNT,ATOM,LATOM)      
      IF (COUNT.EQ.-1) THEN
         CALL STETER(1,ERROR3)     
      ELSE IF (COUNT.EQ.-2) THEN
         CALL STETER(5,'arithmetic expression too long...')
C      
C  take care of operand without operation   (extend F or C to F+C or C+C)
      ELSE IF (COUNT.EQ.1) THEN    
         ATOM(2) = '0.'    
         LATOM(2) = 2
         WORK(2:3) = '+C'
         COUNT = 2
      ENDIF
C      
C  convert cleaned algebraic expression to polish postfix
      ZLINE(1:) = ' '
      CALL EXPPOL(WORK,ZLINE,STAT)                 
      IF (STAT.NE.0) CALL STETER(2,ERROR3)     
      LL = INDEX(ZLINE,' ') - 1
      IF (LL.GT.WORKLM) 
     +   CALL STETER(8,'Too many operands - reduce expression...')
C      
C  fill pointers for atoms
      DATFMT = D_R4_FORMAT                   !that's what we use currently
      K = 1
      DO 220, N=1,LL
         WORKY = ZLINE(N:N)
         IF ( (WORKY.EQ.'C').OR. (WORKY.EQ.'F').OR.
     +        (WORKY.EQ.'Q').OR. (WORKY.EQ.'P') ) THEN
            APNTRS(N) = K
            K = K + 1
         ENDIF
220   CONTINUE
C 
C  check for descriptor-origin-frame (other than 1. frame)
C  but be careful because of frame[.. , ..:.. , ..] syntax
C 
      DSCFRA(1:) = ' '
      LL = 0
      K = INDEX(ZRESFR,']')
      IF (K.GT.1) THEN                          !abc[...],descframe possible
         K = K + 1
         IF (ZRESFR(K:K).EQ.',') LL = K
      ELSE
         LL = INDEX(ZRESFR,',')                 !abc,descframe possible
      ENDIF
      IF (LL.GT.1) THEN
         OUTPU(1:) = ZRESFR(LL+1:)
         CALL CLNFRA(OUTPU,DSCFRA,0)
         ZRESFR(LL:) = ' '
      ENDIF
      CALL CLNFRA(ZRESFR,RESFRA,0)
C      
C  find frames + constants
      LL = 0                        !counter in ATOM
      K = 0
C 
      DO 250, N=1,WORKLM
         WORKY = WORK(N:N)
         IF (WORKY.EQ.' ') GOTO 300
C 
         IF (WORKY.EQ.'F') THEN
            K = K + 1                   !not more than 23 frames possible
            LL = LL + 1
            CALL CLNFRA(ATOM(LL),INFRAM(K),0)
            PIDX(LL) = K               !we'll use PIDX instead of ATOM later 
C      
         ELSE IF (WORKY.EQ.'C') THEN
            LL = LL + 1                !we'll use DATTA instead of ATOM later 
            CALL UPCAS(ATOM(LL),ATOM(LL))
            STAT = INDEX(ATOM(LL),'D')
            IF (STAT.GT.1) THEN
               DATFMT = D_R8_FORMAT     !explicit double constant...
               CALL GENCNV(ATOM(LL),4,1,INPU,RDUM,DDUM,STAT)
               DATTA(LL) = SNGL(DDUM(1))
            ELSE
               CALL GENCNV(ATOM(LL),2,1,INPU,RDUM,DDUM,STAT)
               DATTA(LL) = RDUM(1)
            ENDIF
            IF (STAT.LE.0) CALL STETER
     +         (10,'conversion error of ASCII -> number ...')
C
         ELSE IF ((WORKY.EQ.'P').OR.(WORKY.EQ.'Q')) THEN
            LL = LL + 1
         ENDIF
250   CONTINUE
C      
C  extract 1-arg, 2-arg operations and save them (with offsets)
300   WORK1(1:) = ZLINE(1:)
      LL = (WORKLM+1) / 2
      DO 350, N=1,999
         CALL EXPRDC(WORK1,WORK,OPER(N),PPP(N))
         IF (PPP(N).LT.1) CALL STETER(1,ERROR3)
         IF (WORK(2:2).NE.' ') THEN
            WORK1 = WORK
         ELSE
            IF (N.GT.LL) CALL STETER
     +         (11,'too many operations in expression - split it up...')
            OPCNT = N 
            GOTO 1000
         ENDIF
350   CONTINUE
C      
C  if no frames involved ... do it right now + skip the loop
C      
1000  IF (K.LE.0) THEN
         CALL COMPUA(PNTR,OPER,PPP,OPCNT,APNTRS,ATOM,DATTA,PIDX,
     +                     COUNT,NPIX(1),RPNTR,CUTS(3))
         CONST = CUTS(3)
         IF (ZDEFA(1:1).EQ.'N') THEN    !put resulting constant into OUTPUTR(1)
            CALL STKWRR('OUTPUTR',CONST,1,1,UNIT,STAT)
            WRITE(OUTPU,10000) CONST
            CALL STTPUT(OUTPU,STAT)
         ELSE
            CALL STIGET(RESFRA,D_R4_FORMAT,F_IO_MODE,F_IMA_TYPE,
     +                  3,NAXIS,NPIX,START,STEP,IDENT,
     +                  CUNIT,RPNTR,RIMNO,STAT)
            SIZE = NPIX(1) * NPIX(2) * NPIX(3)
            CALL OPFC('FC=',0.0,CONST,MADRID(RPNTR),SIZE,
     +                USRNUL,NNN)                  !copy constant to frame
            CUTS(4) = CONST
         ENDIF
         GOTO 9000
      ENDIF
C      
C  at least one frame involved ...
C      
      FRACNT = K
      CALL ISSUBF(RESFRA,K)
      IF (K.GT.0) THEN
         UPDA = 1
      ELSE
         UPDA = 0
      ENDIF
      IF (DSCFRA(1:1).NE.' ') THEN
         DSCORG = 0
      ELSE
         DSCORG = 1
      ENDIF
C 
      DO 1200, N=1,FRACNT
         CALL STFINF(INFRAM(N),2,INFO,STAT)
         IF (INFO(2).EQ.D_R8_FORMAT) DATFMT = D_R8_FORMAT
         CALL STFOPN(INFRAM(N),D_R4_FORMAT,0,F_IMA_TYPE,IMNO(N),STAT)
         IF (UPDA.EQ.0) THEN
            CALL GENEQF(INFRAM(N),RESFRA,UPDA)       !test, if frames are equal
            IF (UPDA.NE.0) UPDA = N                  !Yes. Save the index
         ENDIF
         IF (DSCORG.EQ.0)  THEN
            CALL GENEQF(INFRAM(N),DSCFRA,LL)
            IF (LL.NE.0) DSCORG = N
         ENDIF
1200  CONTINUE
C 
      IF (PLADIR.EQ.X_Y_PLANE) THEN
         PLINDX = 3                              !index of `looping' plane 
      ELSE IF (PLADIR.EQ.X_Z_PLANE) THEN
         PLINDX = 2
      ELSE
         PLINDX = 1
      ENDIF
C 
C  we use R*4 data currently
      IF (DATFMT.EQ.D_R8_FORMAT) THEN
         CUNIT(1:) = 
     +   'Warning: double operand found - result will be single! '
         CALL STTPUT(CUNIT,STAT)
         DATFMT = D_R4_FORMAT
      ENDIF
C 
C  work on first file operand 
      CALL STDRDI(IMNO(1),'NAXIS',1,1,IAV,INPU,UNIT,NNULL,STAT)
      NAXIS = INPU(1)
      CALL STDRDI(IMNO(1),'NPIX',1,NAXIS,IAV,NPIX,UNIT,NNULL,STAT)
      IF (NAXIS.LT.2) THEN
         DIM3(1) = -1
         DIM1ON = 1                        !so we know later on...
      ELSE IF (NAXIS.EQ.2) THEN
         IPLANE(1) = X_Y_PLANE
         TOTAL = 1
         DIM3(1) = 1
         MAPSIZ = NPIX(1) * NPIX(2)
      ELSE
         IPLANE(1) = PLADIR
         TOTAL = NPIX(PLINDX)
         DIM3(1) = TOTAL
         SIZE = NPIX(1) * NPIX(2) * NPIX(3)
         MAPSIZ = SIZE / NPIX(PLINDX)
         CALL STDRDD(IMNO(1),'START',1,NAXIS,IAV,START,UNIT,NNULL,STAT)
         CALL STDRDD(IMNO(1),'STEP',1,NAXIS,IAV,STEP,UNIT,NNULL,STAT)
         CALL STDRDC(IMNO(1),'IDENT',1,1,72,IAV,IDENT,UNIT,NNULL,STAT)
         CALL STDRDC(IMNO(1),'CUNIT',1,1,64,IAV,CUNIT,UNIT,NNULL,STAT)
         IF (DSCORG.EQ.0) DSCORG = 1
      ENDIF
C 
C  loop over all file operands
      IF (FRACNT.GT.1) THEN
         DO 1500, N=2,FRACNT
            CALL STDRDI(IMNO(N),'NAXIS',1,1,IAV,NAXISA,UNIT,NNULL,STAT)
            CALL 
     +      STDRDI(IMNO(N),'NPIX',1,NAXISA,IAV,NPIXA,UNIT,NNULL,STAT)
            IF (NAXISA.LT.2) THEN
               DIM3(N) = -1
               DIM1ON = 1                        !so we know later on...
               GOTO 1500                         !avoid size check
            ELSE IF (NAXISA.EQ.2) THEN
               IPLANE(N) = X_Y_PLANE
               DIM3(N) = 1
               K = NPIXA(1) * NPIXA(2)
            ELSE
               IPLANE(N) = PLADIR
               DIM3(N) = NPIXA(PLINDX)
               IF (TOTAL.LE.1) THEN
                  TOTAL = DIM3(N)
                  NPIX(1) = NPIXA(1)
                  NPIX(2) = NPIXA(2)
                  NPIX(3) = NPIXA(3)
                  SIZE = NPIX(1) * NPIX(2) * NPIX(3)
                  CALL STDRDD(IMNO(N),'STEP',1,NAXIS,IAV,START,UNIT,
     +                        NNULL,STAT)
                  CALL STDRDD(IMNO(N),'STEP',1,NAXIS,IAV,STEP,UNIT,
     +                        NNULL,STAT)
                  CALL STDRDC(IMNO(N),'IDENT',1,1,72,IAV,IDENT,UNIT,
     +                        NNULL,STAT)
                  CALL STDRDC(IMNO(N),'CUNIT',1,1,64,IAV,CUNIT,UNIT,
     +                        NNULL,STAT)
                  IF (DSCORG.EQ.0) DSCORG = N
               ELSE IF (DIM3(N).NE.TOTAL) THEN
                  CALL STETER (67,
     +            'No. of planes must be the same for all frames')
               ENDIF
               K = (NPIXA(1) * NPIXA(2) * NPIXA(3)) / NPIXA(PLINDX)
            ENDIF
            IF (MAPSIZ.EQ.0) THEN
               MAPSIZ = K
            ELSE
               IF (K.NE.MAPSIZ) THEN
                  CALL STETER(66,
     +            'All relevant planes must have equal size')
               ENDIF
            ENDIF
1500     CONTINUE
      ENDIF
C      
      YPIX(1) = NPIX(1)                  !maybe we need it 
      YPIX(2) = NPIX(2)
      IF (TOTAL.EQ.0) THEN               !only 1-dim frames involved
         CALL STETER(68,
     +   'Only 1-dim files involved - use COMPUTE/IMAGE instead.')
      ENDIF
      IF (TOTAL.EQ.1) THEN               !only 2-dim frames involved
         SIZE = NPIX(1) * NPIX(2)
         OPLANE = X_Y_PLANE
         NAXIS = 2
      ELSE
         OPLANE = PLADIR
         NAXIS = 3
         IF (DIM1ON.EQ.1) THEN           !we have 1-dime operands
            IF (OPLANE.EQ.X_Z_PLANE) THEN
               YPIX(2) = NPIX(3)
            ELSE IF (OPLANE.EQ.Z_Y_PLANE) THEN
               YPIX(1) = NPIX(3)
               YPIX(2) = NPIX(2)
            ENDIF                        !YPIX for X_Y_PLANE already set
         ENDIF 
      ENDIF
C 
C  for 1-dim operands we need one more dimension check
      IF (DIM1ON.EQ.1) THEN
         DO 2000, N=1,FRACNT
            IF (DIM3(N).EQ.-1) THEN
               CALL STDRDI(IMNO(N),'NPIX',1,1,IAV,NPIXA,UNIT,
     +                     NNULL,STAT)
               IF (NPIXA(1).NE.YPIX(1)) THEN
                  CALL STETER(69,
     +       '1-dim frames must have same size as first plane dim.')
               ENDIF
            ENDIF
2000     CONTINUE
C 
         CALL STFCRE('Work1',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +               YPIX(1),XIMNO,STAT)
         CALL STFMAP(XIMNO,F_X_MODE,1,YPIX(1),IAV,XPNTR,STAT)
      ENDIF
C      
C  if no frame is equal to result frame, we create it
      IF (UPDA.EQ.0) THEN
         CALL STFCRE(RESFRA,DATFMT,F_O_MODE,F_IMA_TYPE,
     +               SIZE,RIMNO,STAT)
         INPU(1) = NAXIS
         CALL STDWRI(RIMNO,'NAXIS',INPU,1,1,UNIT,STAT)
         CALL STDWRI(RIMNO,'NPIX',NPIX,1,NAXIS,UNIT,STAT)
         CALL STDWRD(RIMNO,'START',START,1,NAXIS,UNIT,STAT)
         CALL STDWRD(RIMNO,'STEP',STEP,1,NAXIS,UNIT,STAT)
         CALL STDWRC(RIMNO,'IDENT',1,IDENT,1,72,UNIT,STAT)
         N = (NAXIS+1)*16
         CALL STDWRC(RIMNO,'CUNIT',1,CUNIT,1,N,UNIT,STAT)
      ELSE
         IF (IPLANE(UPDA).NE.OPLANE) THEN
            CALL STETER(69,
     +  'We cannot update result frame with different plane directions')
         ENDIF
         CALL STFOPN(RESFRA,DATFMT,0,F_IMA_TYPE,RIMNO,STAT)
         CALL STFINF(RESFRA,2,INFO,STAT)
         IF ( (INFO(2).NE.D_R8_FORMAT) .AND.
     +        (INFO(2).NE.D_R4_FORMAT) ) THEN
            CUNIT(1:) = 
     +      'Warning: Result frame is not real - '//
     +      'you may get truncation errors... '
            CALL STTPUT(CUNIT,STAT)
         ENDIF
      ENDIF
C 
C  map virtual memory for input files + result frame
      K = (FRACNT + 5) * MAPSIZ
      CALL STFCRE('Work2',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +            K,WIMNO,STAT)
      CALL STFMAP(WIMNO,F_X_MODE,1,K,IAV,PNTR(1),STAT)
      IF (FRACNT.GT.1) THEN
         DO 5200, N=2,FRACNT                  !no more pointers,
            PNTR(N) = PNTR(N-1) + MAPSIZ      !but indices of MADRID ...
5200     CONTINUE
      ENDIF
C 
      RPNTR = PNTR(FRACNT) + MAPSIZ            !result pointer
C 
C  get pointers for 4 working chunks
      DO 5250, N=1,4
         PNTR(N+23) = RPNTR + (N*MAPSIZ)
5250  CONTINUE
C      
C  loop over all planes
C
      DO 5800, N=1,TOTAL
         DO 5600, K=1,FRACNT
            IF (DIM3(K).GE.N) THEN
               CALL STPGET(IMNO(K),IPLANE(K),N,MADRID(PNTR(K)),STAT)
            ELSE IF (DIM3(K).EQ.-1) THEN           !build 2-dim frame
               CALL STFGET(IMNO(K),1,YPIX(1),IAV,MADRID(XPNTR),STAT)
               CALL GROWIT('L',YPIX,MADRID(XPNTR),YPIX,
     +                     MADRID(PNTR(K)),1)
               DIM3(K) = 1
            ENDIF
5600     CONTINUE
C      
         CALL COMPUA(PNTR,OPER,PPP,OPCNT,APNTRS,ATOM,DATTA,PIDX,
     +               COUNT,MAPSIZ,RPNTR,CUTS(3))
C      
         CALL STPPUT(RIMNO,OPLANE,N,MADRID(RPNTR),STAT)
5800  CONTINUE
C  
C  ***
C  we're done - set dynamic range of result frame
C  ***
C      
C  take care of descriptors
8000  IF (FRACNT.GE.1) THEN
         CALL DSCUPT(IMNO(DSCORG),RIMNO,' ',STAT)
      ELSE
         CALL DSCUPT(RIMNO,RIMNO,' ',STAT)
      ENDIF
      CALL STDWRR(RIMNO,'LHCUTS',CUTS,1,4,UNIT,STAT)
C      
C  That's it folks...
9000  RETURN
C
C  formats...
10000 FORMAT(G15.7)
      END

C @(#)ftfunc.for	19.1 (ES0-DMD) 02/25/03 13:17:34
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FTFUNC(NF,IND,X,NP,PARAM,Y1,DERIV)                             
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                  
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  18:01 - 21 DEC 1987                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C. feb1992 add the MOFFAT function. M.Peron                                                                               
C--------------------------------------------------------------                 
C                                                                               
C FUNCTION DEFINITION                                                           
C                                                                               
C INPUT PARAMS                                                                  
C NF INTG FUNCTION CODE                                                         
C IND INTG NO. OF IND. VARS                                                     
C X REAL IND.VARS                                                               
C NP INTG NO. OF PARAMS                                                         
C PARAM DBLE FUNCTION PARAMETERS                                                
C                                                                               
C OUTPUT PARAMS                                                                 
C Y1 DBLE COMPUTED FUNCTION VALUE                                               
C DERIV DBLE COMPUTED DERIVATIVE VALUE                                          
C
C      IMPLICIT NONE                                                            
C                                                                               
      INTEGER NP,IND,NF
      DOUBLE PRECISION Y1,PARAM(NP),DERIV(NP)                                   
      REAL X(IND)                                                          
                                                                                
      GO TO (10,20,30,40,50,60,70,390,390,                                      
     +       390,390,390,80,90,100,110,120,390,                                 
     +       390,390,390,130,140,150,160,390,390,                               
     +       390,170,180,190,200,210,220,230,240,                               
     +       250,260,270,280,290,300,310,320,330,                               
     +       340,350,360,370,380),NF                                                
                                                                                
      GO TO 390                                                                 
                                                                                
   10 CALL POLY(IND,X,NP,PARAM,Y1,DERIV)                                        
      RETURN                                                                    
                                                                                
   20 CALL FLOG(X,NP,PARAM,Y1,DERIV)                                            
      RETURN                                                                    
                                                                                
   30 CALL FEXP(X,NP,PARAM,Y1,DERIV)                                            
      RETURN                                                                    
                                                                                
   40 CALL FSIN(X,NP,PARAM,Y1,DERIV)                                            
      RETURN                                                                    
                                                                                
   50 CALL FTAN(X,NP,PARAM,Y1,DERIV)                                            
      RETURN                                                                    
                                                                                
   60 CALL FSINH(X,NP,PARAM,Y1,DERIV)                                           
      RETURN                                                                    
                                                                                
   70 CALL FTANH(X,NP,PARAM,Y1,DERIV)                                           
      RETURN                                                                    
                                                                                
   80 CALL TRIANG(IND,X,NP,PARAM,Y1,DERIV)                                      
      RETURN                                                                    
                                                                                
   90 CALL POISSN(IND,X,NP,PARAM,Y1,DERIV)                                     
      RETURN                                                                    
                                                                                
  100 CALL GAUSS(IND,X,NP,PARAM,Y1,DERIV)                                       
      RETURN                                                                    
                                                                                
  110 CALL CAUCHY(IND,X,NP,PARAM,Y1,DERIV)                                      
      RETURN                                                                    
                                                                                
  120 CALL LORENZ(IND,X,NP,PARAM,Y1,DERIV)                                     
      RETURN                                                                    
                                                                                
  130 CALL ERFUNC(X,NP,PARAM,Y1,DERIV)                                          
      RETURN                                                                    
                                                                                
  140 CALL SINC(X,NP,PARAM,Y1,DERIV)                                            
      RETURN                                                                    
                                                                                
  150 CALL SINC2(X,NP,PARAM,Y1,DERIV)                                           
      RETURN                                                                    
                                                                                
  160 CALL FRANZ(IND,X,NP,PARAM,Y1,DERIV)                                       
      RETURN                                                                    
                                                                                
  170 CALL BRAND(IND,X,NP,PARAM,Y1,DERIV)                                       
      RETURN                                                                    
                                                                                
  180 CALL USER00(IND,X,NP,PARAM,Y1,DERIV)                                      
      RETURN                                                                    
                                                                                
  190 CALL USER01(IND,X,NP,PARAM,Y1,DERIV)                                      
      RETURN                                                                    
                                                                                
  200 CALL USER02(IND,X,NP,PARAM,Y1,DERIV)                                      
      RETURN                                                                    
                                                                                
  210 CALL USER03(IND,X,NP,PARAM,Y1,DERIV)                                      
      RETURN                                                                    
                                                                                
  220 CALL USER04(IND,X,NP,PARAM,Y1,DERIV)                                      
      RETURN                                                                    
                                                                                
  230 CALL USER05(IND,X,NP,PARAM,Y1,DERIV)                                      
      RETURN                                                                    
                                                                                
  240 CALL USER06(IND,X,NP,PARAM,Y1,DERIV)                                      
      RETURN                                                                    
                                                                                
  250 CALL USER07(IND,X,NP,PARAM,Y1,DERIV)                                      
      RETURN                                                                    
                                                                                
  260 CALL USER08(IND,X,NP,PARAM,Y1,DERIV)                                      
      RETURN                                                                    
                                                                                
  270 CALL USER09(IND,X,NP,PARAM,Y1,DERIV)                                      
      RETURN                                                                    
                                                                                
  280 CALL LAPLAC(IND,X,NP,PARAM,Y1,DERIV)                                     
      RETURN                                                                    
                                                                                
  290 CALL LOGIST(IND,X,NP,PARAM,Y1,DERIV)                                    
      RETURN                                                                    
                                                                                
  300 CALL SEMILG(IND,X,NP,PARAM,Y1,DERIV)                                     
      RETURN                                                                    
                                                                                
  310 CALL LOGNRM(IND,X,NP,PARAM,Y1,DERIV)                                     
      RETURN                                                                    
                                                                                
  320 CALL PARETO(IND,X,NP,PARAM,Y1,DERIV)                                      
      RETURN                                                                    
                                                                                
  330 CALL GAMMDS(IND,X,NP,PARAM,Y1,DERIV)                                     
      RETURN                                                                    
                                                                                
  340 CALL DIPOLE(IND,X,NP,PARAM,Y1,DERIV)                                      
      RETURN                                                                    
                                                                                
  350 CALL IGAUSS(IND,X,NP,PARAM,Y1,DERIV)                                      
      RETURN                                                                    
                                                                                
  360 CALL GAUSSA(IND,X,NP,PARAM,Y1,DERIV)                                      
      RETURN                                                                    
                                                                                
  370 CALL IGAUSA(IND,X,NP,PARAM,Y1,DERIV)                                     
      RETURN                                                                    
                                                                                
  380 CALL MOFFAT(X,NP,PARAM,Y1,DERIV)
      RETURN

  390 CALL NULLF(IND,X,NP,PARAM,Y1,DERIV)                                       
      RETURN                                                                    
                                                                                
      END                                                                       

C===========================================================================
C Copyright (C) 1995-2005 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE DMATIN(A,N,NDIM,FIXED,ISTAT)                                   
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                   
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C.IDENTIFICATION                                                                
C                                                                               
C  FITLIB.FOR   VERSION 1.0  27 MAR 1984                                        
C                                                                               
C.PURPOSE                                                                       
C                                                                               
C  INTERFACE ROUTINES FOR THE FITTING STRUCTURES                                
C                                                                               
C.ALGORITHM                                                                     
C                                                                               
C  USE MIDAS I/O INTERFACES TO FRAMES AND TABLES                                
C                                                                               
C.KEYWORDS                                                                      
C                                                                               
C  NON LINEAR FITTING                                                           
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:25 - 13 JAN 1988   
C 051109	last modif
C                                                                               
C----------------------------------------------------------------               
C                                                                               
C Special matrix inversion routine to cope with constraint                      
C      IMPLICIT NONE                                                            
C parameters in the normal equation matrix.                                     
C The matrix is first compressed to ignore non-significant                      
C columns and rows. Then it is inverted usind the Cholesky                      
C algorithm. Afterwards it is expanded back to the original                     
C structure.                                                                    
C                                                                               
C                                                                               
      INTEGER NDIM,N,ISTAT,NN,M,I,J,K,L
      INTEGER FIXED(N)                                                          

      DOUBLE PRECISION A(NDIM,NDIM)                                             
C                                                                               
C ... Test for fixed parameters                                                 
C                                                                               
      NN     = N                                                                
      M      = 0                                                                
      DO 10, I = 1,N  
          M      = M + FIXED(I)                                                 
   10 CONTINUE                                                                  
      IF (M.EQ.-N) GO TO 80                                                     
C                                                                               
C ... First compress the matrix                                                 
C                                                                               
      ISTAT  = 3                                                                
      L      = N                                                                
   20 IF (FIXED(L).GE.0) THEN                                                   
          L      = L - 1                                                        
          IF (L.GT.0) GO TO 20                                                  
      END IF                                                                    
                                                                                
      IF (L.EQ.0) RETURN                                                        
      NN     = L                                                                
      IF (L.EQ.1) GO TO 80                                                      
      DO 70, I = L - 1,1,-1  
          IF (FIXED(I).GE.0) THEN                                               
              NN     = NN - 1                                                   
              DO 40, J = I,NN    
                  DO 30, K = 1,NN + 1 
                      A(K,J) = A(K,J+1)                                         
   30             CONTINUE                                                      
   40         CONTINUE                                                          
              DO 60, J = I,NN   
                  DO 50, K = 1,NN  
                      A(J,K) = A(J+1,K)                                         
   50             CONTINUE                                                      
   60         CONTINUE                                                          
          END IF                                                                
                                                                                
   70 CONTINUE                                                                  
C                                                                               
C ... Now invert it                                                             
C                                                                               
   80 CALL CHOREC(A,NN,NDIM,ISTAT)                                                
      IF (ISTAT.NE.0 .OR. M.EQ.-N .OR. L.EQ.NN) RETURN                          
C                                                                               
C ... Finally expand it back again                                              
C                                                                               
      DO 140, I = 1,L - 1          
          IF (FIXED(I).GE.0) THEN                                               
              DO 100, J = L - 1,I,-1
                  DO 90, K = 1,L   
                      A(K,J+1) = A(K,J)                                         
   90             CONTINUE                                                      
  100         CONTINUE                                                          
              DO 120, J = L - 1,I,-1
                  DO 110 K = 1,L 
                      A(J+1,K) = A(J,K)                                         
  110             CONTINUE                                                      
  120         CONTINUE                                                          
              DO 130, J = 1,L
                  A(I,J) = 0.0D0                                                
                  A(J,I) = 0.0D0                                                
  130         CONTINUE                                                          
              A(I,I) = 1.0D0                                                    
          END IF                                                                
                                                                                
  140 CONTINUE                                                                  
C                                                                               
      RETURN                                                                    
                                                                                
      END                                                                       

C===========================================================================
C Copyright (C) 1995,2004 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.PROGRAM:   MIDDAO ("Tables - Midas to Daophot")
C.AUTHOR:    F. Figon, LAS Marselle
C.ALGORITHM: - Read in MIDAS table.
C            - Determine col. nos. corresponding to labels :X_COORD 
C              and :Y_COORD
C            - Get pointers to beg. of these columns.
C            - Then simply output the values in these two columns.
C.VERSION:   8704?? FM  Keyw. TRANSF, etc.
C.VERSION:   910510 RHW rewritten for portable MIDAS
C 040722	last modif
C 
C------------------------------------------------------------------
C 
      PROGRAM MIDDAO
C
      IMPLICIT NONE
C 
      DOUBLE PRECISION  STASTE(4)
C 
      CHARACTER*4       TYPE
      CHARACTER*80      NAME
      CHARACTER*84      TABLE
      CHARACTER*120     STRING
C 
      INTEGER           I,IST
      INTEGER           NCARA, NACT
      INTEGER           KUN,KNUL
      INTEGER           MADRID(1)
      INTEGER           NELEM,BYTEL
      INTEGER           PIXO,TID
      INTEGER           NCOL,NROW,NSC,NACOL,NAROW
      INTEGER           NOCOL1, NOCOL2
C 
      INTEGER*8         IPTR1, IPTR2
C
      INCLUDE           'MID_INCLUDE:ST_DEF.INC/NOLIST'
      COMMON            /VMR/MADRID
      INCLUDE           'MID_INCLUDE:ST_DAT.INC/NOLIST'
C
C *** get the connection
      CALL STSPRO('MIDDAO')
C
C *** get the table name
      CALL STKRDC('IN_A',1,1,80,NCARA,NAME,KUN,KNUL,IST)
C 
C assumed to be without .tbl in the end
      I = INDEX(NAME,' ')
      IF (I.EQ.0) I = LEN(NAME) + 1            !no blanks...
      TABLE=NAME(1:I-1)//'.COO'
      CALL LOWCAS(TABLE,TABLE)
C
C *** Open daophot table
      OPEN(UNIT=20,FILE=TABLE,STATUS='UNKNOWN',ERR=101)
C
C *** get info from MIDAS table, use 1) pixel, 2) world coords.
      CALL TBTOPN(NAME,F_I_MODE,TID,IST)
      CALL TBIGET(TID,NCOL,NROW,NSC,NACOL,NAROW,IST)
      CALL TBCSER(TID,':X_COORDPIX',NOCOL1,IST)
      IF (NOCOL1 .GE. 0) THEN                       !we already have pixels
         CALL TBCSER(TID,':Y_COORDPIX',NOCOL2,IST)
         PIXO = 1
      ELSE
         CALL TBCSER(TID,':X_COORD',NOCOL1,IST)
         CALL TBCSER(TID,':Y_COORD',NOCOL2,IST)
         PIXO = 0
      ENDIF
C 
      IF ((NOCOL1.LT.0).OR.(NOCOL2.LT.0))
     +   CALL STETER(11,'No coord columns found...')
C
C  if world coords, get start and step values from keyword TRANSF
      IF (PIXO.EQ.0) THEN
         CALL STKFND('TRANSF',TYPE,NELEM,BYTEL,IST)
         IF (NELEM.EQ.0) THEN 
            CALL STTPUT(' *** INFO: Keyword TRANSF missing; world '//
     +               'and pixel coords. assumed identical',IST)
            STASTE(1) = 0.0
            STASTE(2) = 0.0
            STASTE(3) = 1.0
            STASTE(4) = 1.0
         ELSE
            CALL STTPUT(' *** Getting start/step values from keyword '//
     +               'TRANSF...assume linear world_coord_system',IST)
            CALL STKRDD('TRANSF',1,4,NACT,STASTE,KUN,KNUL,IST)
         ENDIF
      ENDIF
C 
      CALL TBCMAP(TID,NOCOL1,IPTR1,IST)
      CALL TBCMAP(TID,NOCOL2,IPTR2,IST)
      CALL DOIT(PIXO,MADRID(IPTR1),MADRID(IPTR2),NROW,STASTE)
C 
      I = INDEX(TABLE,' ')
      IF (I.LT.2) I = LEN(TABLE)
      WRITE(STRING,12345) TABLE(1:I-1)
12345 FORMAT('DAOPHOT table ',A,' (ASCII) created')
      CALL STTPUT(STRING,IST)
C
      CLOSE(20)
      CALL STSEPI                      !closes table also

101   CONTINUE
      CALL STTPUT
     + ('*** WARNING: Something wrong with output table; I quit',IST)
      CALL STSEPI
      END


      SUBROUTINE DOIT(PXFLAG,A,B,N,SS)
C +++
C ---
      INTEGER          PXFLAG,N
      REAL             A(N),B(N)
      DOUBLE PRECISION SS(4)
C 
      INTEGER          I
C 
C
      IF (PXFLAG.EQ.0) THEN
         DO 1000,I=1,N
            A(I) = (A(I)-SS(1))/SS(3)         !Transf. coords. from WORLD
            B(I) = (B(I)-SS(2))/SS(4)         !coords. to PIXEL coords.
            WRITE(20,100) I,A(I),B(I)
1000     CONTINUE
C 
      ELSE
         DO 2000,I=1,N                        !already pixel coords
            WRITE(20,100) I,A(I),B(I)
2000     CONTINUE
      ENDIF
      RETURN
C 
100   FORMAT(1X,I5,2F9.2)
      END
 

C @(#)knn.for	19.1 (ES0-DMD) 02/25/03 13:27:14
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                 C
C  Carry out a K-NN DISCRIMINANT ANALYSIS,                        C
C  with two groups defined in a training set, and with            C
C  assignment of members of a test set.                           C
C                                                                 C
C  Parameters:                                                    C
C                                                                 C
C  TRAIN(N,M)     training set, where first N1 rows relate to the C
C                 first group, and the next N2 rows to the second C
C                 group.  Must have N1 + N2 = N.                  C
C  TEST(N3,M)     test set;                                       C
C  K              number of nearest neighbours to consider;       C
C  KLIST(K), DK(K), KPOP(K)   are used for storing the K NNs,     C
C                 their distances to the object under consider-   C
C                 ation, and the group to which the NNs belong.   C
C                                                                 C
C  NOTE: this routine is written in VAX-11 Fortran and not in     C
C  Fortran-77.                                                    C
C  It also contains MIDAS STTPUT calls.                       C
C                                                                 C
C  F. Murtagh, ESA/ESO/STECF, Garching.  February 1986.           C
C                                                                 C
C-----------------------------------------------------------------C
        SUBROUTINE KNN(TRAIN,N1,N2,N,TEST,N3,M,K,KLIST,DK,KPOP,IERR)
        REAL TRAIN(N,M),TEST(N3,M),DK(K),D
        INTEGER KLIST(K),KPOP(K)
        INTEGER I,IX,N1,N2,N3,N,M,K,IERR,ISTAT
        INTEGER IND,I2,IK,IK2,NUM1,NUM2
        CHARACTER*80 LINE
C
        WRITE(LINE,20)
        CALL STTPUT(LINE,ISTAT)
   20   FORMAT(' Object  -->  group with probability')
        WRITE(LINE,30)
        CALL STTPUT(LINE,ISTAT)
   30   FORMAT(' ')
C
        DO I = 1, N3
        DO IX = 1, K
        KLIST(IX) = 0
        DK(IX) = 1.E+15
        KPOP(IX) = 0
        ENDDO
        IND = 0
                DO I2 = 1, N1
                CALL DISTK(I2,TRAIN,I,TEST,N,N3,M,D)
                IF (IND.GT.0) THEN
                   DO IK = 1, K
                        IF (D.LT.DK(IK)) THEN
                           IF (IK.LT.K) THEN
                              DO IK2 = K, IK+1, -1
                                 DK(IK2) = DK(IK2-1)
                                 KLIST(IK2) = KLIST(IK2-1)
                                 KPOP(IK2) = KPOP(IK2-1)
                              ENDDO
                           ENDIF
                           DK(IK) = D
                           KLIST(IK) = I2
                           KPOP(IK) = 1
                           GOTO 100
                        ENDIF
                    ENDDO
                ELSE
                    IND = IND + 1
                    DK(IND) = D
                    KLIST(IND) = I2
                    KPOP(IND) = 1
                ENDIF
  100           CONTINUE
                ENDDO
C
C
C
                DO I2 = N1+1, N
                CALL DISTK(I2,TRAIN,I,TEST,N,N3,M,D)
                IF (IND.GT.0) THEN
                   DO IK = 1, K
                        IF (D.LT.DK(IK)) THEN
                           IF (IK.LT.K) THEN
                              DO IK2 = K, IK+1, -1
                                 DK(IK2) = DK(IK2-1)
                                 KLIST(IK2) = KLIST(IK2-1)
                                 KPOP(IK2) = KPOP(IK2-1)
                              ENDDO
                           ENDIF
                           DK(IK) = D
                           KLIST(IK) = I2
                           KPOP(IK) = 2
                           GOTO 200
                        ENDIF
                    ENDDO
                ELSE
                    IND = IND + 1
                    DK(IND) = D
                    KLIST(IND) = I2
                    KPOP(IND) = 2
                ENDIF
  200           CONTINUE
                ENDDO
C
        NUM1 = 0
        NUM2 = 0
        DO IX = 1, K
           IF (KPOP(IX).EQ.1) NUM1 = NUM1 + 1
           IF (KPOP(IX).EQ.2) NUM2 = NUM2 + 1
        ENDDO
C       (Error check:)
        IF ((NUM1+NUM2).NE.K) THEN
           LINE(1:) = ' Total assignments to gp. 1 and to gp. 2 '
     X                //'dont equal K; is K too large ? '
           CALL STTPUT(LINE,ISTAT)
           IERR = 1
           RETURN
        ENDIF
        IF (NUM1.GT.NUM2) THEN
           WRITE (LINE,500) I,FLOAT(NUM1)*100./FLOAT(K)
           CALL STTPUT(LINE,ISTAT)
        ENDIF
        IF (NUM2.GT.NUM1) THEN
           WRITE (LINE,525) I,FLOAT(NUM2)*100./FLOAT(K)
           CALL STTPUT(LINE,ISTAT)
        ENDIF
        IF (NUM1.EQ.NUM2) THEN
           WRITE (LINE,550) I,FLOAT(NUM1)*100./FLOAT(K)
           CALL STTPUT(LINE,ISTAT)
        ENDIF
  500   FORMAT(I6,6X,'    1   ',F8.2,'%')
  525   FORMAT(I6,6X,'    2   ',F8.2,'%')
  550   FORMAT(I6,6X,' 1 or 2 ',F8.2,'%   (equiprobable).')
        ENDDO
C
        RETURN
        END
C
        SUBROUTINE DISTK(I,ARR1,J,ARR2,NR1,NR2,NC,D)
        INTEGER NC,NR1,NR2,K,J,I
        REAL ARR1(NR1,NC),ARR2(NR2,NC),D
C
        D = 0.0
        DO K = 1, NC
        D = D + (ARR1(I,K)-ARR2(J,K))**2
        ENDDO
C
        RETURN
        END

C @(#)prflch.for	19.1 (ES0-DMD) 02/25/03 13:25:37
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine PRFLCH         version 2.0       870725
C  A. Kruszewski             ESO Garching
C.KEYWORDS
C  profiles
C.PURPOSE
C  It checks if an average profile AVPR goes down with the increasing
C  radius K at least as steep as p.s.f. multiplied by a factor DNEB.
C  If not then a value of an image size LIM is adjusted.
C.INPUT/OUTPUT
C  input arguments
C  AVPR        real*4 array      one-dimensional profile
C  LIM         integer*4         number of significant profile rings
C  KSAT        integer*4         number of saturated profile rings
C  HCUT        real*4            saturation level
C  STPR        real*4 array      logarithmic p.s.f.
C  DNEB        integer*4         rejection factor
C  output arguments
C  LIM         integer*4         number of significant profile rings
C-----------------------------------------------------------------------
       SUBROUTINE PRFLCH(AVPR, IHED, KSAT, HCUT, APSF, DNEB , LIM)
C
       IMPLICIT NONE
C
       INTEGER   IHED
       REAL      APSF(0:IHED)
       INTEGER   KSAT
       REAL      HCUT
       REAL      AVPR(0:IHED)
       REAL      DNEB
       INTEGER   LIM
C
       INTEGER   IC
       INTEGER   KK, KL
       REAL      TEMP
C
       IC = 0
       KK = MAX(KSAT+2,3)
       IF (KK .GE. LIM) THEN
          RETURN
       ENDIF
       KL = KK - 1
       IF (KL .LT. 0) THEN
          RETURN
       ENDIF
C
10     CONTINUE
       IF (.NOT.(KK.LE.LIM .AND. AVPR(KK).GT.0.0 .AND. IC.EQ.0)) THEN
          GOTO 20
       ENDIF
       TEMP   = (AVPR(KL)/AVPR(KK)) - DNEB*(APSF(KL)/APSF(KK))
       IF (TEMP .LT. 0.0) THEN
          IC = 1
       ENDIF
       KK = KK + 1
       GOTO 10
C
20     CONTINUE
       IF (IC .EQ. 1) THEN
           LIM = MAX(KK-1, 4)
       ENDIF
C
       RETURN
       END

C===========================================================================
C Copyright (C) 1995,2004 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE  ADDSTR  (PAR, MAXPAR, PSF, MAXPSF, MAXEXP,
     .     F, NCOL, NROW, WATCH)
C
C=======================================================================
C
C This subroutine generates random x,y coordinates and magnitudes,
C appropriately scales the point-spread function, and adds these
C artificial stars into a copy of the original picture at the
C appropriate locations.  As an alternative, it will read positions
C and magnitudes in from a disk file, and add synthetic stars with
C simulated photon noise.
C
C             OFFICIAL DAO VERSION:  1991 April 18
C
C.VERSIONS
C 040721	last modif
C 
C=======================================================================
C
      IMPLICIT NONE
      INTEGER MAXPSF, MAXPAR, MAXEXP, NCOL, NROW
C
C Parameters
C
C MAXPSF is the largest permissible number of elements in the look-up
C        table for the point-spread function.
C
      REAL F(NCOL,NROW), PSF(MAXPSF,MAXPSF,MAXEXP)
      REAL PAR(MAXPAR), RMAG(2)
      INTEGER ISEED(3)
C
      REAL SQRT, AMAX1, DAORAN, USEPSF
      INTEGER RDPSF, MIN0, MAX0, NINT
C
      CHARACTER*80 LINE
      CHARACTER*30 ADDPIC, OUTSTM, ADDFIL, EXTEND
      CHARACTER*30 COOFIL, MAGFIL, PSFFIL, PROFIL, GRPFIL, SWITCH
      CHARACTER CASE*5, NTOCHR*2
      DOUBLE PRECISION SUMPHOT, SUMERR
      REAL LOBAD, NRML, STRMAG, X, Y, DIFMAX, DIFSQ, DX, DY, DYSQ
      REAL DIFF, SCALE, DELTAX, DELTAY, DVDXC, DVDYC, ERR
      REAL HIBAD, THRESH, AP1, DUMMY, READNS, FRAD, XWIDE, YWIDE
      REAL PSFRSQ, WATCH, PSFMAG, BRIGHT, XPSF, YPSF, PSFRAD, PHPADU
      REAL DATUM, SKY
      INTEGER I, J, ID, ISTAR, IDUM, IFRAME, LX, LY, NX, NY, ISTAT
      INTEGER IPSTYP, NPSF, NPAR, NEXP, NFRAC, NSTAR
      INTEGER NFRAME, NL
      LOGICAL RANDOM
C
      COMMON /FILNAM/ COOFIL, MAGFIL, PSFFIL, PROFIL, GRPFIL
C
C-----------------------------------------------------------------------
C
      CALL TBLANK                                   ! Type a blank line
  950 CALL GETNAM ('File with the PSF:', PSFFIL)
      IF ((PSFFIL .EQ. 'END OF FILE') .OR.
     .     (PSFFIL .EQ. 'GIVE UP')) THEN
         PSFFIL = ' '
         RETURN
      END IF
      PSFFIL=EXTEND(PSFFIL, CASE('psf'))
C
C Read in the PSF.
C
      ISTAT = RDPSF(PSFFIL, IPSTYP, PAR, MAXPAR, NPAR,
     .     PSF, MAXPSF, MAXEXP, NPSF, NEXP, NFRAC,
     .     PSFMAG, BRIGHT, XPSF, YPSF)
      IF (ISTAT .NE. 0) THEN
         PSFFIL = 'GIVE UP'
         GO TO 950
      END IF
C
      PSFRAD = (REAL(NPSF-1)/2. - 1.)/2.
      PSFRSQ = PSFRAD**2
      CALL SEED3 (ISEED)
      CALL GETDAT ('Photons per ADU:', PHPADU,1)
      IF (PHPADU .LE. 0) RETURN
      ADDFIL='RANDOM STARS'
 1015 CALL GETNAM ('Input data file:', ADDFIL)
      IF ((ADDFIL .EQ. 'END OF FILE') .OR. (ADDFIL .EQ. 'EXIT') .OR.
     .     (ADDFIL .EQ. 'GIVE UP')) THEN
         RETURN
      ELSE IF (ADDFIL .EQ. 'RANDOM STARS') THEN
         RANDOM=.TRUE.
         WRITE (6,610) PSFMAG
  610    FORMAT (/' Magnitude of PSF star is', F7.3/)
         CALL GETDAT ('Minimum, maximum magnitudes desired:', RMAG, 2)
         IF (RMAG(1) .LT. -1.E38) RETURN            ! CTRL-Z was entered
C
         CALL GETDAT ('Number of stars to add to each frame:',
     .        DATUM, 1)
         IF (DATUM .LT. -1.E38) RETURN             ! CTRL-Z was entered
         NSTAR=MAX0(1, NINT(DATUM))
C
         CALL GETDAT ('Number of new frames:', DATUM, 1)
         IF (DATUM .LT. -1.E38) RETURN              ! CTRL-Z was entered
         NFRAME=MAX0(1, MIN0(NINT(DATUM), 99))
         OUTSTM=' '
         CALL GETNAM ('File-name stem:', OUTSTM)
         IF (OUTSTM .EQ. 'END OF FILE') RETURN     ! CTRL-Z was entered
         OUTSTM=EXTEND(OUTSTM, CASE('add'))
C
      ELSE
         ADDFIL = EXTEND(ADDFIL, CASE('add'))
         CALL INFILE (2, ADDFIL, ISTAT)
         IF (ISTAT .NE. 0) THEN
            CALL STUPID ('Error opening input file '//ADDFIL)
            ADDFIL = 'GIVE UP'
            GO TO 1015
         END IF
         ADDPIC=SWITCH(ADDFIL, ' ')
         CALL GETNAM ('Output picture name:', ADDPIC)
         NL=-1
         CALL RDHEAD (2, NL, IDUM, IDUM, LOBAD, HIBAD, THRESH, AP1,
     .        DUMMY, READNS, FRAD)
         IF (NL .LE. 0) NL=1
      END IF
C
C-----------------------------------------------------------------------
C
C SECTION 2
C
C Do it.
C
      IF (RANDOM) THEN
         IF (WATCH .GT. 0.5) THEN
            CALL TBLANK
            CALL OVRWRT (
     .      '  Star       Picture                         Data file', 1)
         END IF
C
C Beginning of loop over output frames.
C
         DO 2900 IFRAME=1,NFRAME
C
C Build up output stellar-data filename, and open file.
C
         ADDFIL=NTOCHR(IFRAME)//CASE('.add')
         ADDFIL=SWITCH(OUTSTM,ADDFIL)
  952    CALL OUTFIL (3, ADDFIL, ISTAT)
         IF (ISTAT .NE. 0) THEN
            CALL STUPID ('Error opening output file '//ADDFIL)
            ADDFIL = 'GIVE UP'
            CALL GETNAM ('New output file name:', ADDFIL)
            IF ((ADDFIL .EQ. 'END OF FILE') .OR.
     .           (ADDFIL .EQ. 'GIVE UP')) RETURN
            ADDFIL = EXTEND(ADDFIL, CASE('add'))
            GO TO 952
         END IF
         CALL WRHEAD (3, 1, NCOL, NROW, 7, 0., 0., 0., 0., 0., 0., 0.)
C
C Create output picture filename.
C
         ADDPIC=SWITCH(ADDFIL, ' ')
C
C Copy the input picture verbatim into the output picture.
C
         CALL COPPIC (ADDPIC, F, NCOL, NROW, ISTAT)
         IF (ISTAT .NE. 0) THEN
            CALL STUPID ('Error creating output picture.')
            RETURN
         END IF
         LX = 1
         LY = 1
         NX = NCOL
         NY = NROW
         CALL RDARAY ('COPY', LX, LY, NX, NY, NCOL, F, ISTAT)
C
C Beginning of loop over artificial stars.
C
         XWIDE = REAL(NCOL)-1.
         YWIDE = REAL(NROW)-1.
         DO 2500 ISTAR=1,NSTAR
C
C Make up centroid and magnitude.
C
         X=1.+XWIDE*DAORAN(ISEED(1))
         Y=1.+YWIDE*DAORAN(ISEED(2))
         STRMAG=RMAG(1)+DAORAN(ISEED(3))*(RMAG(2)-RMAG(1))
C
C Write them to the data file.
C
         WRITE (3,320) ISTAR+8999, X, Y, STRMAG
  320    FORMAT (1X, I5, 14F9.3)
         IF (WATCH .GT. 0.5) THEN
            WRITE (LINE,622) ISTAR, ADDPIC, ADDFIL
  622       FORMAT (I6, 7X, A30, 2X, A30)
            CALL OVRWRT (LINE(1:75), 2)
         END IF
         DELTAX=(X-1.)/XPSF - 1.
         DELTAY=(Y-1.)/YPSF - 1.
         LX = MAX0( 1, INT(X-PSFRAD)+1 )
         LY = MAX0( 1, INT(Y-PSFRAD)+1 )
         NX = MIN0( NCOL, INT(X+PSFRAD) )
         NY = MIN0( NROW, INT(Y+PSFRAD) )
         SCALE=10.**(0.4*(PSFMAG-STRMAG))
         DIFMAX=0.
         DIFSQ=0.
C
C Beginning of double loop over pixels in the subarray.
C
         SUMPHOT = 0.0D0
         SUMERR = 0.0D0
         DO 2210 J=LY,NY
            DY=FLOAT(J)-Y
            DYSQ=DY**2
C
            DO 2200 I=LX,NX
               DX=FLOAT(I)-X
               IF (DX**2+DYSQ .GE. PSFRSQ) THEN
                  IF (DX .GT. 0.) GO TO 2210
               ELSE
                  DIFF=SCALE*USEPSF(IPSTYP, DX, DY, BRIGHT, PAR, PSF,
     .                 NPSF, NPAR, NEXP, NFRAC, DELTAX, DELTAY, DVDXC,
     .                 DVDYC)
C
C DIFF represents the value of the stellar profile at this pixel.
C Compute a Poisson random error using a normal approximation,
C sigma(DIFF)=sqrt(DIFF/PHPADU).
C
                  ERR=SQRT(AMAX1(0.,DIFF/PHPADU))*
     .                 NRML(DAORAN(ISEED(MOD(I+J,3)+1)))
                  SUMPHOT = SUMPHOT + DBLE(DIFF)
                  SUMERR = SUMERR + DBLE(ERR)
                  F(I,J)=F(I,J)+DIFF+ERR
               END IF
 2200       CONTINUE
 2210    CONTINUE
 2500    CONTINUE                              ! End of loop over stars
         LX = 1
         LY = 1
         NX = NCOL
         NY = NROW
         CALL WRARAY ('COPY', LX, LY, NX, NY, NCOL, F, ISTAT)
         CALL CLPIC ('COPY')                   ! Close copy
         CALL CLFILE (3)
         CALL OVRWRT (' ', 1)
C
 2900    CONTINUE                              ! End of loop over frames
      ELSE
         CALL COPPIC (ADDPIC, F, NCOL, NROW, ISTAT)
         IF (ISTAT .NE. 0) THEN
            CALL STUPID ('Error creating output picture.')
            RETURN
         END IF
         IF (WATCH .GT. 0.5) THEN
            CALL TBLANK
            CALL OVRWRT ('  Star', 1)
         END IF
         LX = 1
         LY = 1
         NX = NCOL
         NY = NROW
         CALL RDARAY ('COPY', LX, LY, NX, NY, NCOL, F, ISTAT)
C
C Loop over stars.
C
         ISTAR=0
 3000    ISTAR=ISTAR+1
 3010    CALL RDSTAR (2, NL, ID, X, Y, STRMAG, SKY)
         IF (ID .LT. 0) GO TO 3900             ! End-of-file encountered
         IF (ID .EQ. 0) GO TO 3010             ! Ignore a blank line
         IF (STRMAG .GE. 99.) GO TO 3000       ! Ignore a bad star
         IF (WATCH .GT. 0.5) THEN
            WRITE (LINE,622) ISTAR
            CALL OVRWRT (LINE(1:6), 2)
         END IF
         DELTAX=(X-1.)/XPSF-1.
         DELTAY=(Y-1.)/YPSF-1.
         SCALE=10.**(0.4*(PSFMAG-STRMAG))
C
C Add the shifted scaled PSF
C
         LX = MAX0(1, INT(X-PSFRAD)+1 )
         LY = MAX0(1, INT(Y-PSFRAD)+1 )
         NX = MIN0(NCOL, INT(X+PSFRAD) )
         NY = MIN0(NROW, INT(Y+PSFRAD) )
         SUMPHOT = 0.0D0
         SUMERR = 0.0D0
         DO 3030 J=LY,NY
            DY=FLOAT(J)-Y
            DYSQ=DY**2
            DO 3020 I=LX,NX
               DX=FLOAT(I)-X
               IF (DX**2+DYSQ .GE. PSFRSQ) THEN
                  IF (DX .GT. 0.) GO TO 3030
               ELSE
                  DIFF=SCALE*USEPSF(IPSTYP, DX, DY, BRIGHT, PAR, PSF,
     .                 NPSF, NPAR, NEXP, NFRAC, DELTAX, DELTAY, DVDXC,
     .                 DVDYC)
C
C DIFF represents the value of the stellar profile at this pixel.
C Compute a Poisson random error using a normal approximation,
C sigma(DIFF)=sqrt(DIFF/PHPADU).
C
                  ERR=DAORAN(ISEED(MOD(I+J,3)+1))
                  ERR=SQRT(AMAX1(0.,DIFF/PHPADU))*NRML(ERR)
                  SUMPHOT = SUMPHOT + DBLE(DIFF)
                  SUMERR = SUMERR + DBLE(ERR)
                  F(I,J)=F(I,J)+DIFF+ERR
               END IF
 3020       CONTINUE
 3030    CONTINUE
         GO TO 3000                           ! Go to next star
C
 3900    LX = 1
         LY = 1
         NX = NCOL
         NY = NROW
         CALL WRARAY ('COPY', LX, LY, NX, NY, NCOL, F, ISTAT)
         CALL CLPIC ('COPY')
         CALL CLFILE (2)
         ADDFIL='EXIT'
         CALL OVRWRT (' ', 1)
         GO TO 1015
      END IF
C
      RETURN
C
      END!
C
C#######################################################################
C
      CHARACTER*2  FUNCTION  NTOCHR (N)
C
C Converts an integer in the range 1-99 to two characters representing
C the number.
C
      IMPLICIT NONE
      INTEGER N, ITENS
      IF ((N .GT. 0) .AND. (N .LT. 100)) GO TO 1010
      NTOCHR='00'
      RETURN
C
 1010 ITENS=N/10
      NTOCHR=CHAR(48+ITENS)//CHAR(48+N-10*ITENS)
      RETURN
C
      END!
C
C###################################################################
C
      SUBROUTINE  SEED3 (ISEED)
C
C Seed the random number generator, based on a floating-point number
C entered by the user.
C
      IMPLICIT NONE
      INTEGER ISEED(3)
C
      REAL DAORAN
      INTEGER INT
C
      REAL SEED
      INTEGER I
C
      CALL GETDAT ('Seed (any integer):', SEED, 1)
      I = NINT(SEED)
      ISEED(1) = INT(524288.*DAORAN(I)) + 1
      ISEED(2) = INT(524288.*DAORAN(I)) + 1
      ISEED(3) = INT(524288.*DAORAN(I)) + 1
      RETURN
C
      END!
C
C######################################################################
C
      REAL  FUNCTION  NRML  (RANNUM)
C
C Convert a uniform probability distribution to a Gaussian distribution
C with mean zero and standard deviation unity.
C
      IMPLICIT NONE
C
      REAL SQRT, ALOG
C
      REAL P, RANNUM, SIGN, T
 1000 P=RANNUM
      SIGN=-1.
      IF (P .GT. 0.5) THEN
         P=P-0.5
         SIGN=1.
      ELSE IF (P .LE. 0.) THEN
         NRML = -1.E20
         GO TO 1000
      END IF
      T=SQRT(ALOG(1/P**2))
      NRML=SIGN*(T- (2.30753+.27061*T) / (1.+T*(.99229+T*.04481)) )
      RETURN
      END!
C
C#######################################################################
C
      REAL FUNCTION DAORAN (IDUM)
      IMPLICIT NONE
C
C RAN2 from Numerical Recipes
C
      INTEGER IDUM
      INTEGER IFF
      INTEGER IY
      INTEGER M
      INTEGER IA, IC
      INTEGER J
      REAL    RM
      INTEGER IR(97)
C 
      SAVE    IY
      SAVE    IFF
      SAVE    IR
C
      DATA    IFF /0/
      DATA    M/714025/
      DATA    IA/1366/
      DATA    IC/150889/
      DATA    RM/1.400511E-6/
C
1000  CONTINUE
      IF ((IDUM .LT. 0) .OR. (IFF .EQ. 0)) THEN
         IFF = 1
         IDUM = MOD(IABS(IC-IDUM), M)
         DO J=1,97
            IDUM = MOD(IA*IDUM+IC,M)
            IR(J) = IDUM
         END DO
         IDUM = MOD(IA*IDUM+IC,M)
         IY = IDUM
      END IF
C 
      J = 1+(97*IY)/M
      IF ((J .GT. 97) .OR. (J .LT. 1)) 
     +   CALL STETER(33,'Problems in random number generator DAORAN')

CC    was:   IF ((J .GT. 97) .OR. (J .LT. 1)) PAUSE

      IY = IR(J)
      DAORAN = IY*RM
      IDUM = MOD(IA*IDUM+IC,M)
      IR(J) = IDUM
      IF (DAORAN .LE. 0.) GO TO 1000             ! Stetson's modification
C
      RETURN
      END

C @(#)tdregt.for	19.1 (ESO-DMD) 02/25/03 14:11:20
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  16:14 - 19 NOV 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION
C
C  program TDREGT
C
C.PURPOSE
C
C  POLYNOMIAL FIT OF ONE OR TWO VARIABLES BETWEEN TWO TABLES
C  THE PROGRAM CAN BE USED TO FIND CORRESPONDENCES BETWEEN
C  ENTRIES IN THE TWO TABLES
C
C  REGRESSION/TABLE TABLE X1[,X2] CATAL Y1[,Y2] DEGREE TOL [COEFFS]
C
C  THE METHOD IS NOT YET IMPLEMENTED FOR TWO VARIABLES
C
C.KEYWORDS
C
C  TABLES, REGRESSION, IDENTIFICATIONS
C
C.ALGORITHM
C
C  THERE ARE TWO MODES OF OPERATION :
C  1. INITIAL GUESS FOR THE CORRESPONDENCE IS DEFINED BY THE
C     REFERENCE COLUMNS OF BOTH TABLES
C     IN THIS CASE REFERNCE COLUMN IN SECOND OUT HAS TO BE SORTED
C  2. INITIAL GUESS IS DEFINED BY A SET OF COEFFS. WITH THE
C     GEOMETRIC TRANSFORMATION
C  THE RESULT IS
C  1. THE SET OF COEFFS. OF THE TRANSFORMATION
C     X1 <- Y1    OR
C     X1 <- Y1,Y2
C
C  2. THE CORRESPONDENCE BETWEEN THE TWO TABLES IS DEFINED BY
C     UPDATING THE REFERENCE COLUMN OF THE FIRST INPUT TABLE
C
C  3. If two columns of the problem table are specified, the
C     second column defines the iteration variable.
C
C.VERSION
C 020807	last modif
C
C-----------------------------------------------------------
C
      SUBROUTINE TDREGT
      IMPLICIT NONE
C
C ... PARAMETER DEFINITION
C
      CHARACTER    LINE1*64,KEY*64
      CHARACTER*17 COLX1,COLX2,COLY1,COLY2
      CHARACTER*8  FORM
      CHARACTER*8  FORM1,FORM2
      CHARACTER*16 LABEL1,LABEL2,UNIT1,UNIT2
      CHARACTER*64 TABLE,CATAL
      CHARACTER*80 OUTPUT1, OUTPUT2, OUTPUT3
C
      INTEGER     MADRID
      INTEGER DTYPE1, DTYPE2, DTYPE, DTYPR1, DTYPR2
      INTEGER IDEG(2),ICOL1(3),ICOL2(3),ICOL3(2)
      INTEGER NPIX(2),INDX1(400),INDX2(400)
      INTEGER IACT,STATUS,INDX,NINC,NINC1,NINC2
      INTEGER NOUTC, TID, TID1, LEN, NACT, NRCOL, IST, I, J
      INTEGER NSTART, NORD, NCOL2, NROW2, NSC2, NAC2, NAR2
      INTEGER*8  IBUF
      INTEGER NCOL1, NROW1, NSC1, NAC, NAR, NBYTES, IS
      INTEGER INDEX, KUN, KNUL
C
      REAL TOL
      REAL START(2)
      REAL STEP(2)
C
      DOUBLE PRECISION ERROR,COEFF(30),COEFFR(30)
C
       INCLUDE 'MID_INCLUDE:TABLES.INC'
      COMMON /VMR/MADRID(1)
       INCLUDE 'MID_INCLUDE:TABLED.INC'
C
      DATA STEP/1.,1./
      DATA START/0.,0./
      DATA OUTPUT1
     ./'  scan         total  unid.  ident.  abs(res)    '/
      DATA OUTPUT2
     ./'  no.  iterat. lines  lines  lines   >3*std.dev.    stdev.'/
      DATA OUTPUT3
     ./'  ---- ------  -----  -----  -----   -----------    ------'/
C
C ... GET INPUT PARAMETERS + DEFAULT
C
      CALL STKRDC('P1',1,1,64,IACT,TABLE,KUN,KNUL,STATUS)
      CALL STKRDC('P2',1,1,64,IACT,LINE1,KUN,KNUL,STATUS)
      INDX   = INDEX(LINE1,',')
      IF (INDX.EQ.0) THEN
          NINC = 1
          COLX1  = LINE1
      ELSE
          NINC = 2
          COLX1  = LINE1(1:INDX-1)
          COLX2  = LINE1(INDX+1:)
      END IF
      CALL STKRDC('P3',1,1,64,IACT,CATAL,KUN,KNUL,STATUS)
      CALL STKRDC('P4',1,1,64,IACT,LINE1,KUN,KNUL,STATUS)
      INDX   = INDEX(LINE1,',')
      IF (INDX.EQ.0) THEN
          NOUTC = 1
          COLY1  = LINE1
      ELSE
          NOUTC = 2
          COLY1  = LINE1(1:INDX-1)
          COLY2  = LINE1(INDX+1:)
          CALL STTPUT(' Not yet implemented ',STATUS)
          GO TO 50
      END IF
      CALL STKRDI('INPUTI',1,2,IACT,IDEG,KUN,KNUL,STATUS)
      CALL STKRDR('INPUTR',1,1,IACT,TOL,KUN,KNUL,STATUS)
      CALL STKRDC('P7',1,1,64,IACT,KEY,KUN,KNUL,STATUS)
C
C ... INIT INPUT TABLE
C
      TID = -1
      CALL TBTOPN(TABLE,F_U_MODE,TID,STATUS)
      CALL TBIGET(TID,NCOL1,NROW1,NSC1,NAC,NAR,STATUS)
      CALL TBKGET(TID,ICOL1(1),STATUS)
      IF (ICOL1(1).LE.0) THEN
          CALL STTPUT(' There is no REFERENCE column in first table',
     +                STATUS)
          GO TO 50
      END IF
      CALL TBFGET(TID,ICOL1(1),FORM,LEN,DTYPR1,STATUS)
      CALL TBCSER(TID,COLX1,ICOL1(2),STATUS)
      CALL TBFGET(TID,ICOL1(2),FORM,LEN,DTYPE,STATUS)
      IF (DTYPE.EQ.D_C_FORMAT) THEN
          CALL STTPUT(' Illegal column type in first table',STATUS)
          GO TO 50
      END IF
      IF (NINC.EQ.2) THEN
          CALL TBCSER(TID,COLX2,ICOL1(3),STATUS)
          CALL TBFGET(TID,ICOL1(3),FORM,LEN,DTYPE,STATUS)
          IF (DTYPE.EQ.D_C_FORMAT) THEN
              CALL STTPUT(' Illegal column type in first table',STATUS)
              GO TO 50
          END IF
      END IF
      IF (ICOL1(2).EQ.-1 .OR. ICOL1(3).EQ.-1) THEN
          CALL STTPUT(' Column in first table not found',STATUS)
          GO TO 50
      END IF
C
C ... INIT REFERENCE TABLE
C
      TID1 = -1
      CALL TBTOPN(CATAL,F_I_MODE,TID1,STATUS)
      CALL TBIGET(TID1,NCOL2,NROW2,NSC2,NAC2,NAR2,STATUS)
      CALL TBKGET(TID1,ICOL2(1),STATUS)
      IF (ICOL2(1).LE.0) THEN
          CALL STTPUT(' There is no REFERENCE column in second table',
     +                STATUS)
          GO TO 50
      END IF
      IF (NSC2 .NE. ICOL2(1)) THEN
        CALL STTPUT(' Second table is not sorted by REFERENCE column',
     +                STATUS)
          GO TO 50
      END IF
      CALL TBFGET(TID1,ICOL2(1),FORM,LEN,DTYPR2,STATUS)
      IF (DTYPR1.NE.DTYPR2) THEN
          CALL STTPUT(' Warning: columns with different types',STATUS)
C          GO TO 50
      END IF
      CALL TBCSER(TID1,COLY1,ICOL2(2),STATUS)
      CALL TBFGET(TID1,ICOL2(2),FORM1,LEN,DTYPE1,STATUS)
      IF (DTYPE1.EQ.D_C_FORMAT) THEN
          CALL STTPUT(' Illegal column type in second table',STATUS)
          GO TO 50
      END IF
      IF (NOUTC.EQ.2) THEN
          CALL TBCSER(TID1,COLY2,ICOL2(3),STATUS)
          CALL TBFGET(TID1,ICOL2(3),FORM2,LEN,DTYPE2,STATUS)
          IF (DTYPE2.EQ.D_C_FORMAT) THEN
              CALL STTPUT(' Illegal column type in second table',STATUS)
              GO TO 50
          END IF
      END IF
      IF (ICOL2(2).EQ.-1 .OR. ICOL2(3).EQ.-1) THEN
          CALL STTPUT(' Column in second table not found',STATUS)
          GO TO 50
      END IF
C
C ... IDENTIFY FEATURES(iteration on equal order numbers )
C
      NINC1 = NINC + 1
      NINC2 = NOUTC + 1
      NPIX(1) = NROW1
      NPIX(2) = 6*2
C
C ... PREPARE WORK SPACE
C
      NBYTES = NPIX(1)*NPIX(2)*4
      CALL TDMGET(NBYTES,IBUF,IS)
      CALL SPCOP1(NROW1,TID,NINC1,ICOL1,TID1,NINC2,ICOL2,
     +             MADRID(IBUF),NACT,NORD,INDX1,INDX2,NSTART)
C
C ... HEADER
C
      CALL STTPUT(OUTPUT1, STATUS)
      CALL STTPUT(OUTPUT2, STATUS)
      CALL STTPUT(OUTPUT3, STATUS)
C
C ... IDENTIFICATION OF MAIN REFERENCE ORDER
C
      NRCOL  = NINC2 - 1
      ERROR  = TOL
      CALL IDENTB(NROW1,MADRID(IBUF),INDX1(NSTART),INDX2(NSTART),
     +     TID1,NROW2,NRCOL,ICOL2(2),ERROR,COEFF,IDEG,NSTART,IST)
      DO 10 I = 1,30
         COEFFR(I) = COEFF(I)
   10 CONTINUE
C
C ... IDENTIFICATION OF PREVIOUS ORDERS
C
      IF (NSTART.NE.1) THEN
          DO 20 I = NSTART - 1,1,-1
              DO 15 J = 1,30
                 COEFF(J) = COEFFR(J)
   15         CONTINUE
              CALL IDENTA(NROW1,MADRID(IBUF),INDX1(I),INDX2(I),
     +        TID1,NROW2,NRCOL,ICOL2(2),ERROR,COEFF,IDEG,I,IST)
   20     CONTINUE
      END IF
C
C ... IDENTIFICATION OF NEXT ORDERS
C
      IF (NSTART.NE.NORD) THEN
          DO 40 I = NSTART + 1,NORD
              DO 30 J = 1,30
                 COEFF(J) = COEFFR(J)
   30         CONTINUE
              CALL IDENTA(NROW1,MADRID(IBUF),INDX1(I),INDX2(I),
     +        TID1,NROW2,NRCOL,ICOL2(2),ERROR,COEFF,IDEG,I,IST)
   40     CONTINUE
      END IF
C
C ... COPY FINAL RESULTS WITH THE IDENTIFICATIONS IN OUT TABLE
C
      CALL TBCSER(TID,COLY1,ICOL3(1),STATUS)
      IF (ICOL3(1).LE.0) THEN
        CALL TBFGET(TID1,ICOL2(2),FORM1,LEN,DTYPE1,STATUS)
        CALL TBUGET(TID1,ICOL2(2),UNIT1,STATUS)
        CALL TBLGET(TID1,ICOL2(2),LABEL1,STATUS)
        CALL TBCINI(TID,DTYPE1,1,FORM1,UNIT1,LABEL1,ICOL3(1),STATUS)
      ENDIF
      IF (NOUTC.EQ.2) THEN
          CALL TBCSER(TID,COLY2,ICOL3(2),STATUS)
          IF (ICOL3(1).LE.0) CALL TBCINI(TID,DTYPE2,1,FORM2,UNIT2,
     +                                   LABEL2,ICOL3(2),STATUS)
      END IF
      CALL SPCOP2(NROW1,MADRID(IBUF),TID,NOUTC,ICOL3)
C
C ... end
C
   50 CALL TBTCLO(TID,STATUS)
      CALL TBTCLO(TID1,STATUS)
      CALL TDMFRE(NBYTES,IBUF,IS)
      RETURN
      END

      SUBROUTINE IDENTA(NROW1,BUF,I1,I2,TID,NROW2,NC,IC,ERROR,
     +                  COEFF,IDEG,INDX,IST)
C
C IDENTIFY DETECTED LINES
C INITIAL GUESSES DEFINED BY THE COEFFS
C       INPUT STORED IN BUF WITH THE FOLLOWING STRUCTURE
C BUF(I,1) - X1 (SAMPLE)
C BUF(I,2) - X2 (ORDER)
C BUF(I,3) - Y1 (IDENTIFIED WAVELENGTH)
C BUF(I,4) - Y2 (SECOND VARIABLE)
C BUF(I,5) - LINE WEIGHT AS    1 MANUAL IDENTIFICATION
C                              0 NOT IDENTIFIED
C                             -1 AUTOMATIC IDENTIFICATION
C BUF(I,6) - RESIDUALS
C
      IMPLICIT NONE
C
      INTEGER NROW1, I1, I2, NROW2, NC, IST, NSTEP, NV, NTOT
      INTEGER NTOTAL, NTOTU, NTOTI, NTOTR1,NTOTR2, I, TID, ISTAT
      INTEGER IC(2),IDEG(2),INDX
C
      DOUBLE PRECISION ERROR,BUF(NROW1,6),COEFF(30)
      DOUBLE PRECISION STDEV,STDEV1,STDEV3
C
      CHARACTER*80 OUT
C
      STDEV1 = -1.D20
      IST    = 0
C
C ITERATION
C
      DO 20 NSTEP = 1,10
          NV     = (IDEG(1)+1)* (IDEG(2)+1)
C
C   BUILD L - S MATRIX AND SOLVE SYSTEM
C
          IF (NSTEP.GT.1) CALL LSOLVE(NROW1,BUF,I1,I2,IDEG,NV,COEFF)
C
C   IDENTIFY FEATURES
C
          CALL LSIDEN(IDEG,NV,COEFF,NROW1,BUF,I1,I2,TID,NROW2,NC,
     +                IC,ERROR,NTOT,STDEV)
C
C   SELECT LINES WITH LOW RESIDUALS
C
          STDEV3 = STDEV*3.D0
          IF (NTOT.EQ.0) THEN
              OUT = ' '
              CALL STTPUT(' Wrong identifications in input table',ISTAT)
              IST    = 1
              RETURN
          END IF
C
C STATISTICS ON THE IDENTIFICATIONS
C  !   TOTAL NUMBER OF LINES
          NTOTAL = 0  !   TOTAL NUMBER OF UNIDENTIFIED LINES
          NTOTU  = 0  !   TOTAL NUMBER OF IDENTIFIED LINES
          NTOTI  = 0  !   TOTAL NUMBER OF LINES WITH RESIDUALS .LT. 0.1 PIXEL
          NTOTR1 = 0  !   TOTAL NUMBER OF LINES WITH RESIDUALS .GT.3*STDEV
          NTOTR2 = 0
          DO 10 I = I1,I2
              NTOTAL = NTOTAL + 1
              IF (DABS(BUF(I,5)).GT.0.5D0) THEN
                  NTOTI  = NTOTI + 1
                  IF (DABS(BUF(I,6)).GT.STDEV3) THEN
                      BUF(I,4) = 0.0D0
                      BUF(I,5) = 0.0D0
                      BUF(I,6) = 0.0D0
                      NTOTR2   = NTOTR2 + 1
                  END IF
              END IF
   10     CONTINUE
          NTOTU  = NTOTAL - NTOTI
          IF (NTOTI.LT.NV) THEN
              CALL STTPUT(' Error : not enough  identified entries',
     +                    ISTAT)
              IST    = 1
              RETURN
          END IF
          IF (DABS((STDEV-STDEV1)/STDEV).LE.0.005D0) GOTO 100
          STDEV1 = STDEV
   20 CONTINUE
      RETURN
100   WRITE(OUT,300) INDX,NSTEP,NTOTAL,NTOTU,NTOTI,NTOTR2,STDEV
      CALL STTPUT(OUT,ISTAT)
      RETURN
300   FORMAT(1X,I5,I6,2X,I5,2X,I5,2X,I6,2X,I8,5X,E10.3)
      END

      SUBROUTINE IDENTB(NROW1,BUF,I1,I2,TID,NROW2,NC,IC,ERROR,
     +                  COEFF,IDEG,INDX,IST)
C
C IDENTIFY DETECTED LINES
C INITIAL GUESSES DEFINED BY THE IDENTIFICATIONS IN BUF(I,3)
C       INPUT STORED IN BUF WITH THE FOLLOWING STRUCTURE
C BUF(I,1) - X1 (SAMPLE)
C BUF(I,2) - X2 (ORDER)
C BUF(I,3) - Y1 (IDENTIFIED WAVELENGTH)
C BUF(I,4) - Y2 (SECOND VARIABLE)
C BUF(I,5) - LINE WEIGHT AS    1 MANUAL IDENTIFICATION
C                              0 NOT IDENTIFIED
C                             -1 AUTOMATIC IDENTIFICATION
C BUF(I,6) - RESIDUALS
C
      IMPLICIT NONE
C
      INTEGER NROW1, I1, I2, NROW2, NC, IST, NSTEP, NV, NTOT
      INTEGER NTOTAL, NTOTU, NTOTI, NTOTR1,NTOTR2, I, TID
      INTEGER ISTAT,INDX
      INTEGER IC(2),IDEG(2)
C
      DOUBLE PRECISION ERROR,BUF(NROW1,6),COEFF(30)
      DOUBLE PRECISION STDEV,STDEV1,STDEV3
C
      CHARACTER*80 OUT
C
      STDEV1 = -1.D20
      IST    = 0
C
C ITERATION
C
      DO 20 NSTEP = 1,10
          NV     = (IDEG(1)+1)* (IDEG(2)+1)
C
C   BUILD L - S MATRIX AND SOLVE SYSTEM
C
          CALL LSOLVE(NROW1,BUF,I1,I2,IDEG,NV,COEFF)
C
C   IDENTIFY FEATURES
C
          CALL LSIDEN(IDEG,NV,COEFF,NROW1,BUF,I1,I2,TID,NROW2,NC,
     +                 IC,ERROR,NTOT,STDEV)
C
C   SELECT LINES WITH LOW RESIDUALS
C
          STDEV3 = STDEV*3.D0
          IF (NTOT.EQ.0) THEN
              OUT = ' '
              CALL STTPUT(' Wrong identifications in input table',ISTAT)
              IST    = 1
              RETURN
          END IF
C
C STATISTICS ON THE IDENTIFICATIONS
C  !   TOTAL NUMBER OF LINES
          NTOTAL = 0  !   TOTAL NUMBER OF UNIDENTIFIED LINES
          NTOTU  = 0  !   TOTAL NUMBER OF IDENTIFIED LINES
          NTOTI  = 0  !   TOTAL NUMBER OF LINES WITH RESIDUALS .LT. 0.1 PIXEL
          NTOTR1 = 0  !   TOTAL NUMBER OF LINES WITH RESIDUALS .GT.3*STDEV
          NTOTR2 = 0
          DO 10 I = I1,I2
              NTOTAL = NTOTAL + 1
              IF (DABS(BUF(I,5)).GT.0.5D0) THEN
                  NTOTI  = NTOTI + 1
                  IF (DABS(BUF(I,6)).GT.STDEV3) THEN
                      BUF(I,4) = 0.0D0
                      BUF(I,5) = 0.0D0
                      BUF(I,6) = 0.0D0
                      NTOTR2   = NTOTR2 + 1
                  END IF
              END IF
   10     CONTINUE
          NTOTU  = NTOTAL - NTOTI
          IF (NTOTI.LT.NV) THEN
              CALL STTPUT(' Error : not enough  identified entries',
     +                    ISTAT)
              IST    = 1
              RETURN
          END IF
          IF (DABS((STDEV-STDEV1)/STDEV).LE.0.005D0) GOTO 100
          STDEV1 = STDEV
   20 CONTINUE
      RETURN
100   WRITE(OUT,300) INDX,NSTEP,NTOTAL,NTOTU,NTOTI,NTOTR2,STDEV
      CALL STTPUT(OUT,ISTAT)
      RETURN
300   FORMAT(1X,I5,I6,2X,I5,2X,I5,2X,I6,2X,I8,5X,E10.3)
      END

      SUBROUTINE LSIDEN(IDEG,NV,COEFF,NROW1,BUF,I1,I2,TID,NROW2,
     +                   NC,IC,ERROR,NTOT,STDEV)
C
C IDENTIFY DETECTED LINES USING DISPERSION COEFFS
C
      IMPLICIT NONE
C
      INTEGER NTOT, NV, NROW1, I1, I2, TID, NROW2, NC
      INTEGER K, L, NACT, I, IPOINT, STATUS, ISTART
      INTEGER IC(NC),IDEG(2)
C
      LOGICAL NULL(2)
C
      DOUBLE PRECISION COEFF(NV),BUF(NROW1,6),ERROR,SAMPLE
      DOUBLE PRECISION DD(2),STDEV, POLEV
C
      DATA DD/0.D0,0.D0/
      DATA NULL/.FALSE.,.FALSE./
C
C LOOP ON THE LINES IN THE CATAL
C
      NTOT   = 0
      STDEV  = 0.D0
C      K      = IDEG(1) + 1
C      L      = IDEG(2) + 1
      K      = IDEG(1)
      L      = IDEG(2)
      NACT   = I2 - I1 + 1
      ISTART = 1
      DO 10 I = 1,NROW2
C
C ... USE ONLY SUITABLE RANGE !!
C
          CALL TBRRDD(TID,I,NC,IC,DD,NULL,STATUS)
          IF ( .NOT. NULL(1) .AND. .NOT. NULL(2)) THEN
              SAMPLE = POLEV(K,L,NV,COEFF,DD)
C
              CALL SEABAD(BUF(I1,1),NACT,SAMPLE,ERROR,ISTART,IPOINT)
C
C ... LINE IDENTIFIED
C
              IF (IPOINT.GT.0) THEN
                  IPOINT = IPOINT + I1 - 1
                  BUF(IPOINT,3) = DD(1)
                  BUF(IPOINT,4) = DD(1)
                  BUF(IPOINT,5) = -1.D0
                  BUF(IPOINT,6) = BUF(IPOINT,1) - SAMPLE
                  STDEV  = STDEV + BUF(IPOINT,6)*BUF(IPOINT,6)
                  NTOT   = NTOT + 1
              END IF
          END IF
   10 CONTINUE
      IF (NTOT.GT.0) STDEV  = DSQRT(STDEV/NTOT)
      RETURN
      END
C
      SUBROUTINE LSOLVE(NROW1,BUF,I1,I2,IDEG,NV,COEFF)
C
C SOLVE THE L-S FIT TO THE DATA
      IMPLICIT NONE
C
      INTEGER NROW1, I1, I2, NV, K, L, NTOTAL, LL, N, I
      INTEGER KMIN, N1, K1, ISTAT, LL1
      INTEGER IDEG(2)
C
      DOUBLE PRECISION BUF(NROW1,6),COEFF(NV)
      DOUBLE PRECISION G(20,20)
C
C BUILD INPUT ARRAYS
C
      K      = IDEG(1)
      L      = IDEG(2)
      NTOTAL = 0
      LL     = 0
      N      = NV
      N1     = N + 1
      DO 20 I = I1,I2
        IF (DABS(BUF(I,5)).GT.0.5D0) THEN
          NTOTAL = NTOTAL + 1
          LL1    = LL+1
          CALL TDSET2(LL1,BUF(I,3),BUF(I,4),BUF(I,1),K,L,G,COEFF,N,20)
            IF (LL.NE.0) THEN
              KMIN   = MIN(LL,N1)
               DO 10 K1 = 1,KMIN
                  CALL TDHHTR(K1,LL1,G,COEFF,N,20)
   10          CONTINUE
            END IF
          LL     = MIN(LL1,N1)
        END IF
   20 CONTINUE
C
C SOLVE THE LINEAR SYSTEM
C
      IF (NTOTAL.LT.NV) THEN
          CALL STTPUT(' Not enough identified features',ISTAT)
          RETURN
      END IF
      CALL TDSOLV(G,COEFF,N,20)
      RETURN
      END

      DOUBLE PRECISION FUNCTION POLEV(K,L,NV,DPAR,VAL)
C
C COMPUTE FUNCTION VALUE
C
      IMPLICIT NONE
C
      INTEGER K, L, NV, IP, L1, K1
C
      DOUBLE PRECISION DPAR(NV),VAL(2)
      DOUBLE PRECISION DC,RESULT,WORK(30)
C
      IP     = 0
      DC     = 1.D0
      RESULT = 0.D0
      DO 20 L1 = 0, L
          IP     = IP + 1
          WORK(IP) = DC
          RESULT = RESULT + WORK(IP)*DPAR(IP)
          DO 10 K1 = 1,K
              IP     = IP + 1
              WORK(IP) = WORK(IP-1)*VAL(1)
              RESULT   = RESULT + WORK(IP)*DPAR(IP)
   10     CONTINUE
          DC     = DC*VAL(2)
   20 CONTINUE
      POLEV  = RESULT
      RETURN
      END

      SUBROUTINE SPCOP1(N,TID,NC1,IC1,TID1,NC2,IC2,BUF,NACT,
     +                   NORD,INDX1,INDX2,NSTART)
C
C PREPARE WORK SPACE
C
      IMPLICIT NONE
C
      INTEGER NACT, TID, TID1, N, NC1, NC2, NORD
      INTEGER NSTART, NC, LEN, STATUS, NIDENT, NMAX, I, I1
      INTEGER IC1(NC1),IC2(NC2)
      INTEGER INDX1(1),INDX2(1)
      INTEGER DTYPE, NEXT
C
      LOGICAL SEL,NULL1(3),NULL2(3), NULL3
C
      REAL RVAL1,RVAL2,RERR
C
      DOUBLE PRECISION BUF(N,6)
      DOUBLE PRECISION DERR
      DOUBLE PRECISION VAL1(3)
      DOUBLE PRECISION VAL2(3)
      DOUBLE PRECISION REF
C
      CHARACTER FORM*10
C
       INCLUDE 'MID_INCLUDE:TABLES.INC'
       INCLUDE 'MID_INCLUDE:TABLED.INC'
C
      DATA VAL1/0.D0,0.D0,0.D0/
      DATA VAL2/0.D0,0.D0,0.D0/
      DATA REF/1.E30/
      DATA NULL1/.FALSE.,.FALSE.,.FALSE./
      DATA NULL2/.FALSE.,.FALSE.,.FALSE./
C
      I1     = 1
      NACT   = 0
      DERR   = .1D0
      NC     = NC2 - 1
      NORD   = 0
C
C ... CHECK FORMAT IN CATAL
C
      CALL TBFGET(TID1,IC2(1),FORM,LEN,DTYPE,STATUS)
      IF (DTYPE.EQ.D_R4_FORMAT) RERR   = DERR
C
      NSTART = 1
      NIDENT = 0
      NMAX   = 0
      DO 10 I = 1,N
          CALL TBSGET(TID,I,SEL,STATUS)
          IF (SEL) THEN
              CALL TBRRDD(TID,I,NC1,IC1,VAL1,NULL1,STATUS)
              IF ( .NOT. NULL1(2) .AND. .NOT. NULL1(3)) THEN
                  NACT   = NACT + 1  !   ASSIGN X1
                  BUF(NACT,1) = VAL1(2)  !   ASSIGN X2 (OPTIONAL)
                  BUF(NACT,2) = VAL1(3)  !   NEW ORDER
                  IF (VAL1(3).NE.REF) THEN
                      REF    = VAL1(3)
                      NORD   = NORD + 1
                      INDX1(NORD) = NACT  !   CHECK NO. OF IDENTIFICATIONS
                      IF (NIDENT.GT.NMAX) THEN
                          NMAX   = NIDENT
                          NSTART = NORD
                      END IF
                      NIDENT = 0
                      IF (NORD.GT.1) INDX2(NORD-1) = NACT - 1
                  END IF  !   ASSIGN Y1
                  BUF(NACT,3) = 0.D0  !   ASSIGN Y2 (OPTIONAL)
                  BUF(NACT,4) = 0.D0  !   FLAG AS NON-EXISTING
                  BUF(NACT,5) = 0.D0  !   RESIDUAL (X1-FIT(Y1,Y2))
                  BUF(NACT,6) = 0.D0
                  IF ( .NOT. NULL1(1)) THEN
                      NIDENT = NIDENT + 1
                      IF (DTYPE.EQ.D_R4_FORMAT) THEN
                          RVAL1  = VAL1(1)
                          CALL TBESRR(TID1,IC2,RVAL1,RERR,I1,NEXT,
     +                                STATUS)
                          CALL TBERDR(TID1,NEXT,IC2,RVAL2,
     +                                       NULL3,STATUS)
                          VAL2(3) = RVAL2
                      ELSE
                          CALL TBESRD(TID1,IC2,VAL1(1),DERR,I1,NEXT,
     +                                STATUS)
                          CALL TBERDD(TID1,NEXT,IC2,VAL2(3),NULL3,
     +                                STATUS)
                      END IF
                      IF (NEXT.GT.0) THEN
                          CALL TBSGET(TID1,NEXT,SEL,STATUS)
                          IF (SEL) THEN
                              CALL TBRRDD(TID1,NEXT,NC,IC2(2),
     .                        VAL2,NULL2,STATUS)
                              IF (.NOT.NULL2(1).AND..NOT.NULL2(2)) THEN !ASSIGN Y1
                                  BUF(NACT,3) = VAL2(1)  !   ASSIGN Y2 (OPTIONAL)
                                  BUF(NACT,4) = VAL2(2)  !   FLAG AS EXISTING
                                  BUF(NACT,5) = 1.D0
                                  I1 = NEXT              ! ASSUMES SORTED TABLES
                              END IF
                          END IF
                      END IF
                  END IF
              END IF
          END IF
   10 CONTINUE
      IF (NIDENT.GT.NMAX) NSTART = NORD
      NSTART = NSTART-1
      INDX2(NORD) = NACT
      RETURN
      END

      SUBROUTINE SPCOP2(N,BUF,TID,NC,IC)
C
C COPY FINAL IDENTIFICATIONS
C
      IMPLICIT NONE
C
      INTEGER N, TID, NC, I, NACT, STATUS
      INTEGER IC(2)
C
      LOGICAL SEL
C
      DOUBLE PRECISION BUF(N,6),VAL(3)
C
      INCLUDE 'MID_INCLUDE:TABLES.INC'
       INCLUDE 'MID_INCLUDE:TABLED.INC'
C
      NACT   = 0
      DO 10 I = 1,N
          CALL TBSGET(TID,I,SEL,STATUS)
          IF (SEL) THEN
              NACT   = NACT + 1
              IF (DABS(BUF(NACT,5)).GT.0.5D0) THEN
                  VAL(1) = BUF(NACT,3)
                  VAL(2) = BUF(NACT,4)
                  CALL TBRWRD(TID,I,NC,IC,VAL,STATUS)
              ELSE
                  CALL TBEDEL(TID,I,IC(1),STATUS)
                  IF (NC.EQ.2) CALL TBEDEL(TID,I,IC(2),STATUS)
              END IF
          END IF
   10 CONTINUE
      RETURN
      END

       SUBROUTINE SEABAD(ARRAY, N, VALUE, ERROR, IFIRST,IPOS)
C
C       BINARY SEARCH OF ELEMENTS IN THE ARRAY
C       DOUBLE  PRECISION VERSION
C       ASCENDING ORDER
C
       IMPLICIT NONE
       INTEGER   N
       DOUBLE PRECISION ARRAY(N)
       DOUBLE PRECISION VALUE
       DOUBLE PRECISION ERROR
       INTEGER   IFIRST
       INTEGER   IPOS
C
       INTEGER I, LOWER, UPPER
C
C ... INITIALIZE COUNTERS
C
       LOWER = IFIRST
       UPPER = N
       IPOS  = 0
C
C ... LOOP
C
5      CONTINUE
         I = (LOWER + UPPER)/2
C
C ... COMPARE KEYS
C
         IF (DABS(VALUE-ARRAY(I)).LE.ERROR) THEN
           IPOS = I
           GO TO 10
         ELSE
           IF (VALUE.LT.ARRAY(I)) THEN
             UPPER = I - 1
           ELSE
             LOWER = I + 1
           ENDIF
         ENDIF
       IF (LOWER.LE.UPPER) GO TO 5
C
C ... FIND FIRST ENTRY IN A SET OF EQUAL KEYS
C
10     IF (IPOS.LE.IFIRST) RETURN
       IF (DABS(VALUE-ARRAY(IPOS-1)).GT.ERROR) RETURN
20     CONTINUE
         IPOS = IPOS - 1
         IF (IPOS.EQ.IFIRST) RETURN
       IF (DABS(VALUE-ARRAY(IPOS-1)).LE.ERROR) GOTO 20
       RETURN
       END

C @(#)edistif.for	19.1 (ES0-DMD) 02/25/03 13:27:32
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C-----------------------------------------------------------------------
C
C.IDENTIFICATION
C
C  Program EDIST
C
C.AUTHOR
C
C  F. Murtagh, ST-ECF, Garching.             Version 1.0  9 May 1986
C  F. Murtagh                                Version 2.0  Oct. 1988
C
C.PURPOSE
C
C  Determine interrow distances (standardized).
C
C.INPUT/OUTPUT
C
C  P1 - P2 contain parameters; these are: input table name, output
C  table name.
C
C.ALGORITHM
C
C . uses Midas Table interface routines;
C . input table is assumed to contain entries in single precision;
C . no select or null values 
C . all columns of the input table are sent to the DIST routine;
C . description of the DIST routine is in the corresponding program;
C . storage is limited only by the Midas Table system, and by the
C   overall system limitations;
C
C.MODIFICATIONS
C
C  STANDARD INTERFACES, F. MURTAGH, AUG. 88
C  New Table File System, M. Peron , SEP91
C
C-----------------------------------------------------------------------
        PROGRAM EDIST
C
        CHARACTER*60     NAMEIN, NAMEOUT
        CHARACTER*6     FORM
        CHARACTER*16    UNIT, LABEL, LABEL2
        INTEGER         MADRID, KUN, KNUL
        INTEGER         DTYPE,NACTV,ISTAT,TID1,NCOLIN,NROW
        INTEGER         NSORTC,NAC,NAR,IPTRIN,I,LEN
        INTEGER         NSEL,NTOT,INULL,IACTV,TID,IPTROUT
        INTEGER         IADD1,IADD2
        INCLUDE         'MID_INCLUDE:TABLES.INC/NOLIST'
        COMMON          /VMR/MADRID(1)
        INCLUDE         'MID_INCLUDE:TABLED.INC/NOLIST'
C
C
C ...   Assuming this is our first action ...
C
        CALL STSPRO('EDIST')
        DTYPE = D_R4_FORMAT
C
C ...   Get table name as a keyword passed in the command line.
C
        CALL STKRDC('P1',1,1,60,NACTV,NAMEIN,KUN,KNUL,ISTAT)
C
C ...   Read input table.
C
        CALL TBTOPN(NAMEIN,0,TID1,ISTAT)
        CALL TBIGET(TID1,NCOLIN,NROW,NSORTC,NAC,NAR,ISTAT)
        CALL TBCMAP(TID1,0,IPTRIN,ISTAT)
C
C ...   Some error checking on input.
C
        IF (NROW.LT.1.OR.NCOLIN.LT.1) THEN
           CALL STTPUT(' Nos. of rows/columns are less than 1.',ISTAT)
           CALL STTPUT(' What sort of a table is this ??',ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
C
        DO I = 1, NCOLIN
           CALL TBFGET(TID1,I,FORM,LEN,DTYPE,ISTAT)
           IF (DTYPE.NE.D_R4_FORMAT) THEN
              CALL STTPUT(' Illegal format:',ISTAT)
              CALL STTPUT(' Only R*4 column type allowed.',ISTAT)
              CALL STTPUT(' Aborting.',ISTAT)
              GOTO 9000
           ENDIF
        ENDDO
C
        CALL CHSEL(TID1,NROW,NSEL)
        IF (NSEL.NE.NROW) THEN
           CALL STTPUT(' Not all rows are SELECTed. ',ISTAT)
           CALL STTPUT(' In current implementation, MUST select all.',
     X                                                         ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
C
        CALL TBCMAP(TID1,1,IPTRIN,ISTAT)
        NTOT = NROW*NCOLIN
        CALL CHNULL(MADRID(IPTRIN),NTOT,INULL)
        IF (INULL.NE.0) THEN
           CALL STTPUT
     X     (' Null entries in the table are not allowed.',ISTAT)
           CALL STTPUT
     X     (' Use SELECT, and then construct another table.',
     X                                                    ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
C
C
C ...   Get the output table name.
C
        CALL STKRDC('P2',1,1,60,IACTV,NAMEOUT,KUN,KNUL,ISTAT)
C
C ...   Now create the output (distances) table.
C
        CALL TBTINI(NAMEOUT,F_TRANS,17,NROW,NROW,TID,ISTAT)
        FORM = 'G14.6'
        UNIT = ' '
C       (The messing around with LABEL2 which follows is so that
C       leading zeros in a column label appear as such, and not as
C       blanks.)
        LABEL = 'ROW00'
        LABEL2 = '10001'
        DO I = 1, NROW
           WRITE (LABEL2(1:5),100) I+10000
           LABEL(4:5) = LABEL2(4:5)
           CALL TBCINI(TID,DTYPE,1,FORM,UNIT,LABEL,NSORTC,ISTAT)
        ENDDO
  100   FORMAT(I5)
C
        CALL TBCMAP(TID,1,IPTROUT,ISTAT)
C
C ...   Allocate storage.
C
        CALL GETSTOR(NROW,IADD1)
        CALL GETSTOR(NROW,IADD2)
C
        CALL DIST(NROW,NCOLIN,MADRID(IPTRIN),MADRID(IPTROUT),
     X              MADRID(IADD1),MADRID(IADD2))
C
C ...   Finish up: write output file to disk, and release memory space.
C
        CALL RELSTOR(NROW,IADD1)
        CALL RELSTOR(NROW,IADD2)
C
        CALL TBTCLO(TID1,ISTAT)
C
        CALL TBIPUT(TID,NROW,NROW,ISTAT)
        CALL TBSINI(TID,ISTAT)
        CALL TBTCLO(TID,ISTAT)
C
 9000   CONTINUE
        CALL STSEPI
C
        END
C-------------------------------------------------------------------------
        SUBROUTINE CHNULL(X,NT,NULL)
C ...   Check if null values are present.
        INTEGER I,NULL,NT
        REAL*4  X(NT), TRNULL
        INTEGER TINULL
        DOUBLE PRECISION TDNULL
        CALL TBMNUL(TINULL,TRNULL,TDNULL)
        NULL = 0
        DO I = 1, NT
           IF (X(I).EQ.TRNULL) NULL = NULL + 1
           IF (NULL.GT.0) RETURN
        ENDDO
        RETURN
        END
C-------------------------------------------------------------------------
        SUBROUTINE GETSTOR(NVALS,IPTR)
C ...   Allocate storage space for NVALS real values.
        INTEGER NVALS,IPTR,ISTAT
        CALL TDMGET(4*NVALS, IPTR, ISTAT)
        RETURN
        END
C-------------------------------------------------------------------------
        SUBROUTINE RELSTOR(NVALS,IPTR)
C ...   Release storage space (already allocated) for NVALS real values.
        INTEGER NVALS,IPTR,ISTAT
        CALL TDMFRE(4*NVALS, IPTR, ISTAT)
        RETURN
        END

C @(#)ifnear.for	19.1 (ES0-DMD) 02/25/03 13:25:34
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C
C-----------------------------------------------------------------------
      SUBROUTINE IFNEAR(NREG, LSTP, IREG, I, J, LDIS, NEAR)
C
      IMPLICIT  NONE
      INTEGER   NREG
      INTEGER   LSTP(0:4,0:NREG)
      INTEGER   IREG
      INTEGER   I
      INTEGER   J
      INTEGER   LDIS
      LOGICAL   NEAR
C
      INTEGER   IDIS2
      INTEGER   LDIS2
C
      INTEGER   IR1, IR2, IR3, IR4
C
      NEAR = .FALSE.
      IR1 = LSTP(1,IREG)
      IF ( IR1 .GT. I + LDIS ) RETURN
      IR2 = LSTP(2,IREG)
      IF ( IR2 .GT. J + LDIS ) RETURN
      IR3 = LSTP(3,IREG)
      IF ( IR3 .LT. I - LDIS ) RETURN
      IR4 = LSTP(4,IREG)
      IF ( IR4 .LT. J - LDIS ) RETURN
c      IF ( IR1 .LE. I .AND. IR3 .GE. I .AND.
c     &                      IR2 .LE. J .AND. IR4 .GE. J ) THEN
c          NEAR = .TRUE.
c          RETURN
c      ENDIF
      IF ( IR1 .LE. I .AND. IR3 .GE. I ) THEN
          IF ( IR2 .GT. J+LDIS .OR. IR4 .LT. J-LDIS ) THEN
              NEAR = .FALSE.
              RETURN
          ELSE
              NEAR = .TRUE.
              RETURN
          ENDIF
      ENDIF
      IF ( IR2 .LE. J .AND. IR4 .GE. J ) THEN
          IF ( IR1 .GT. I+LDIS .OR. IR3 .LT. I-LDIS ) THEN
              NEAR = .FALSE.
              RETURN
          ELSE
              NEAR = .TRUE.
              RETURN
          ENDIF
      ENDIF
      LDIS2 = LDIS * LDIS
      IF ( IR1 .GT. I .AND. IR2 .GT. J ) THEN
          IDIS2 = (IR1-I)*(IR1-I) + (IR2-J)*(IR2-J)
          IF ( IDIS2 .LE. LDIS2 ) THEN
              NEAR = .TRUE.
          ENDIF
          RETURN
      ELSE IF ( IR1 .GT. I .AND. IR4 .LT. J ) THEN
          IDIS2 = (IR1-I)*(IR1-I) + (J-IR4)*(J-IR4)
          IF ( IDIS2 .LE. LDIS2 ) THEN
              NEAR = .TRUE.
          ENDIF
          RETURN
      ELSE IF ( IR3 .LT. I .AND. IR2 .GT. J ) THEN
          IDIS2 = (I-IR3)*(I-IR3) + (IR2-J)*(IR2-J)
          IF ( IDIS2 .LE. LDIS2 ) THEN
              NEAR = .TRUE.
          ENDIF
          RETURN
      ELSE IF ( IR3 .LT. I .AND. IR4 .LT. J ) THEN
          IDIS2 = (I-IR3)*(I-IR3) + (J-IR4)*(J-IR4)
          IF ( IDIS2 .LE. LDIS2 ) THEN
              NEAR = .TRUE.
          ENDIF
          RETURN
      ENDIF
C
      RETURN
C
      END 

C @(#)radcnv.for	19.1 (ES0-DMD) 02/25/03 13:31:23
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM RADCNV
C 
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT:      Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C.IDENTIFICATION: RADCNV
C.PURPOSE:        compute the size of an aperture in screen coordinates
C.AUTHOR:         Ch. Ounnas                  ESO - Garching
C.LANGUAGE:       F77+ESO      ext
C.KEYWORDS:       DEANZA display
C.ALGORITHM:      use the keywords DEANZA,DAZMEMI nad the routine PIXCNV
C.INPUT/OUTPUT:   the procedure file should contain:
C                 INPUTR/R/1/1                 radius of the aperture
C                 AP/I/1/4   local keyword to store screen pixels
C.VERSION:        2.6 upgrade to mod. DeAnza stuff (1K memory, 512 display...)
C.VERSION:        871216  RHW  ESO-FORTRAN Conversion
C.VERSION:        900319  put into real ST interfaces and close image display 
C			  correctly  KB
C -------------------------------------------------------------------
C 
      IMPLICIT    NONE
C
      INTEGER     MADRID
      INTEGER     XY(4),KUNI(1),KNUL,IMNO
      INTEGER     STAT,IAV,IMA
C
      CHARACTER   FRAME*60
C
      REAL        RINF(6),PIXEL1(6),PIXEL2(6),RS
      REAL        RAYON
C
      DOUBLE PRECISION  START(2)
C
      INCLUDE     'MID_INCLUDE:ST_DEF.INC'
C
      COMMON /VMR/MADRID(1)
C
      INCLUDE     'MID_INCLUDE:IDIMEM.INC/NOLIST'
      INCLUDE     'MID_INCLUDE:IDIDEV.INC/NOLIST'
C
      INCLUDE     'MID_INCLUDE:ST_DAT.INC'
C
C ***
C
      CALL STSPRO('RADCNV')                          !get into MIDAS environment
      CALL DTOPEN(1,STAT)                            !open image display
C
C *** get the radius of the aperture in user unit
      CALL STKRDR('INPUTR',1,1,IAV,RAYON,KUNI,KNUL,STAT)
C
      CALL DTGICH(QDSPNO,QIMCH,FRAME,RINF,STAT)
      IF (SOURCE.NE.1) THEN                          !no image loaded...
         CALL STETER(1,'RADCNV: No image loaded - we abort... ')
      ELSE
         IMA = 1
         IF (RAYON.EQ.-1.) GO TO 20
      END IF
C
C *** get necessary descriptors of frame
      CALL STFOPN(FRAME,D_OLD_FORMAT,0,F_IMA_TYPE,IMNO,STAT)
      CALL STDRDD(IMNO,'START',1,2,IAV,START,KUNI,KNUL,STAT)
      CALL PIXXCV('INIT',IMNO,RINF,STAT)
C
C *** now convert world coordinates to screen pixels
      PIXEL1(1) = START(1)
      PIXEL1(2) = START(2)
      CALL PIXXCV('WRS',0,PIXEL1,STAT)
      IF (START(2).GT.0.) THEN
         PIXEL2(1) = PIXEL1(1) + RAYON
      ELSE
         PIXEL2(1) = PIXEL1(1) - RAYON
      END IF
      PIXEL2(2) = START(2)
      CALL PIXXCV('WRS',0,PIXEL2,STAT)
      RS = ABS(PIXEL2(5)-PIXEL1(5))
      XY(1) = 200
      XY(2) = 200
      XY(3) = 200 + IFIX(2.*RS) + 1
      XY(4) = 200 + IFIX(2.*RS) + 1
      CALL STKWRI('AP',XY,1,4,KUNI,STAT)
C
20    CALL STKWRI('IMA',IMA,1,1,KUNI,STAT)
C 
      CALL DAZCLO(QDSPNO)
      CALL STSEPI
      END

C @(#)mda.for	19.1 (ES0-DMD) 02/25/03 13:27:14
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                       C
C  Carry out a MULTIPLE DISCRIMINANT ANALYSIS                           C
C              (DISCRIMINANT FACTOR ANALYSIS,                           C
C               CANONICAL DISCRININANT ANALYSIS).                       C
C                                                                       C
C                                                                       C
C  To call:   CALL MDA(N,M,NG,DATA,GP,IPRINT,NOG,MEAN,MGP,TOTAL,        C
C                      BETWEEN,BETW2,CPROJ,W1,W2,IERR)     where        C
C                                                                       C
C                                                                       C
C  N, M  : integer dimensions of ...                                    C
C  DATA  : input data (real).                                           C
C          On output the first NG-1 columns of DATA contain projections C
C          of the N items on the discriminant factors.                  C
C  NG    : (integer) number of groups.                                  C
C  GP    : Integer vector of length N giving group assignments.         C
C          Must be specified correctly - no 0s or values > NG.          C
C  IPRINT: integer; print options (= 3: full; otherwise none).          C
C  NOG   : integer vector of length NG (to contain group cardinalities).C
C  MEAN  : real vector of length M (number of attributes or variables). C
C  MGP   : real array of dimensions 2 by M.                             C
C  TOTAL : real array of dimensions M by M; on output contains inverse  C
C          of total variance/covariance matrix.                         C
C  BETWEEN: real array of dimensions NG by NG.                          C
C  BETW2 : real array of dimensions NG by NG.                           C
C  CPROJ : real array of dimensions M by NG; on output contains the     C
C          coefficients of the discriminant factors in terms of the     C
C          original variables.                                          C
C  W1, W2: real vectors of length M.                                    C
C  IERR  : initially 0; = 1 if there is no convergence in the TQL2      C
C          eigenroutine; = 2 if the total variance-covariance to be     C
C          inverted is singular, - in this case, check that there are   C
C          no columns with identical values, that N > M > NG, etc.      C
C                                                                       C
C                                                                       C
C  Inputs here are N, M, NG, DATA, GP, IPRINT (and IERR).               C
C  The principle output information is contained in DATA and CPROJ; and C
C  W1(NG-1), W1(NG-2) ... contain the eigenvalues in decreasing order.  C
C                                                                       C
C  Notes: we require that N > M > NG (otherwise, an error is likely in  C
C         the matrix inversion routine due to singularity).             C
C         NG-1 eigenvalues eigenvectors are output.                     C
C                                                                       C
C                                                                       C
C  F. Murtagh, ST-ECF/ESA/ESO, Garching-bei-Muenchen, January 1986.     C
C                                                                       C
C-----------------------------------------------------------------------C
        SUBROUTINE MDA(N,M,NG,DATA,GP,IPRINT,NOG,MEAN,MGP,TOTAL,
     X                                  BETWEEN,BETW2,CPROJ,W1,W2,IERR)
        REAL    DATA(N,M),TOTAL(M,M),MEAN(M),MGP(NG,M),BETWEEN(NG,NG)
        REAL    W1(M), W2(M), BETW2(NG,NG), CPROJ(M,NG)
        REAL    D,D1,D2,D3,D4
        INTEGER GP(N), NOG(NG), G,IMAT,IERR,NG2
        INTEGER N,M,NG,IPRINT,I,J,J1,J2,K
        INTEGER K1,K2
C
C          Form global mean.
C
        DO 200 J = 1, M
           MEAN(J) = 0.0
           DO 100 I = 1, N
              MEAN(J) = MEAN(J) + DATA(I,J)
  100      CONTINUE
           MEAN(J) = MEAN(J)/FLOAT(N)
  200   CONTINUE
C
C          Form (total) variance-covariance matrix.
C
        DO 500 J1 = 1, M
           DO 400 J2 = 1, M
              TOTAL(J1,J2) = 0.0
              DO 300 I = 1, N
                 TOTAL(J1,J2) = TOTAL(J1,J2) +
     X           (DATA(I,J1)-MEAN(J1))*(DATA(I,J2)-MEAN(J2))
  300         CONTINUE
              TOTAL(J1,J2) = TOTAL(J1,J2)/FLOAT(N)
  400      CONTINUE
  500   CONTINUE
C
        IMAT = 1
C       CALL OUTMTM(IMAT,M,TOTAL)
C
C          Form group means.
C
        DO 700 J = 1, M
           DO 600 K = 1, NG
              MGP(K,J) = 0.0
  600      CONTINUE
  700   CONTINUE
C
        DO 900 I = 1, N
           G = GP(I)
           IF (G.EQ.0) GOTO 9000
           NOG(G) = NOG(G) + 1
           DO 800 J = 1, M
              MGP(G,J) = MGP(G,J) + DATA(I,J)
  800      CONTINUE
  900   CONTINUE
C
        DO 1100 K = 1, NG
           DO 1000 J = 1, M
              MGP(K,J) = MGP(K,J)/NOG(K)
 1000      CONTINUE
 1100   CONTINUE
C
C          Invert variance-covariance matrix.
C
        CALL MINVM(M,TOTAL,D,W1,W2)
        IF (D.GT.0.000001) GOTO 1150
           IERR = 2
           GOTO 9000
 1150   CONTINUE
        IMAT = 2
C       CALL OUTMTM(IMAT,M,TOTAL)
C
C          Form the symmetric variant of the between-groups
C          variance-covariance matrix for diagonalization.
C
        DO 1200 K1 = 1, NG
         DO 1200 K2 = 1, NG
         BETWEEN(K1,K2) = 0.0
          DO 1200 J1 = 1, M
           DO 1200 J2 = 1, M
            D1 = MGP(K1,J1) - MEAN(J1)
            D2 = FLOAT(NOG(K1))/FLOAT(N)
            D2 = SQRT(D2)
            D3 = MGP(K2,J2) - MEAN(J2)
            D4 = FLOAT(NOG(K2))/FLOAT(N)
            D4 = SQRT(D4)
            BETWEEN(K1,K2) = BETWEEN(K1,K2) +
     X                       (D1*D2)*TOTAL(J1,J2)*(D3*D4)
 1200   CONTINUE
C
        IMAT = 4
C       CALL OUTMTM(IMAT,M,TOTAL)
C
C          Carry out eigenreduction.
C
        NG2 = NG
        CALL TRED2M(NG,NG2,BETWEEN,W1,W2,BETW2)
        CALL TQL2M(NG,NG2,W1,W2,BETW2,IERR)
        IF (IERR.NE.0) GOTO 9000
C
C          Output eigenvalues and eigenvectors.
C
        IF (IPRINT.GT.1) CALL OUTEVM(N,M,NG,W1)
        IF (IPRINT.GT.1) CALL OUTVCM(N,M,NG,BETW2,NG-1)
C
C          Convert eigenvectors in NG-space to those in M-space.
C
        DO 1300 J = 1, M
           DO 1300 K = 1, NG
              CPROJ(J,K) = 0.0
              DO 1300 J2 = 1, M
                 DO 1300 K2 = 1, NG
                    D1 = MGP(K2,J2) - MEAN(J2)
                    D2 = FLOAT(NOG(K2))/FLOAT(N)
                    D1 = D1*SQRT(D2)
                    CPROJ(J,K)=CPROJ(J,K)+
     X              TOTAL(J,J2)*D1*BETW2(K2,NG-K+1)
 1300   CONTINUE
        IF (IPRINT.GT.1) CALL OUTVCM(N,NG,M,CPROJ,NG-1)
C
C          Determine projections and output them.
C
        CALL PROJXM(N,M,NG,DATA,MEAN,CPROJ,W2,TOTAL)
        IF (IPRINT.EQ.3) CALL OUTPXM(N,M,NG,DATA)
C
C
C
 9000   CONTINUE
        RETURN
        END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        SUBROUTINE OUTMTM(IMAT,M,ARRAY)
        INTEGER M,K1,K2,IMAT
        REAL ARRAY(M,M)
C
        WRITE (6,900) IMAT
        DO 100 K1 = 1, M
           WRITE (6,1000) (ARRAY(K1,K2),K2=1,M)
  100   CONTINUE
C
  900   FORMAT(' IMAT =',I6)
 1000   FORMAT(10(2X,F8.4))
        RETURN
        END
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                      C
C  Invert a symmetric matrix and calculate its determinant.            C
C                                                                      C
C                                                                      C
C  To call:      CALL MATINV(M,ARRAY,DET,W1,W2)   where                C
C                                                                      C
C                                                                      C
C  M       : dimension of ...                                          C
C  ARRAY   : input matrix which is replaced by its inverse.            C
C  NORDER  : degree of matrix (order of determinant)                   C
C  DET     : determinant of input matrix.                              C
C  W1, W2  : work vectors of dimension M.                              C
C                                                                      C
C                                                                      C
C  Reference: Philip B Bevington, "Data Reduction and Error Analysis   C
C             for the Physical Sciences", McGraw-Hill, New York, 1969, C
C             pp. 300-303.                                             C
C                                                                      C
C                                                                      C
C  F. Murtagh, ST-ECF, Garching-bei-Muenchen, January 1986.            C
C                                                                      C
C----------------------------------------------------------------------C
        SUBROUTINE MINVM(M,ARRAY,DET,IK,JK)
        INTEGER M,K,I,J,L
        REAL    ARRAY(M,M), IK(M), JK(M)
        REAL    DET,AMAX,SAVE
C
        DET = 1.0
        DO 100 K = 1, M
C       Find largest element ARRAY(I,J) in rest of matrix.
        AMAX = 0.0
   21      DO 30 I = K, M
              DO 30 J = K, M
                 IF (ABS(AMAX)-ABS(ARRAY(I,J))) 24,24,30
   24            AMAX = ARRAY(I,J)
                 IK(K) = I
                 JK(K) = J
   30      CONTINUE
C          Interchange rows and columns to put AMAX in ARRAY(K,K).
           IF (AMAX) 41,32,41
   32      DET = 0.0
           GOTO 140
   41      I = IK(K)
           IF (I-K) 21,51,43
   43      DO 50 J = 1, M
              SAVE = ARRAY(K,J)
              ARRAY(K,J) = ARRAY(I,J)
   50      ARRAY(I,J) = -SAVE
   51      J = JK(K)
           IF (J-K) 21,61,53
   53      DO 60 I = 1, M
              SAVE = ARRAY(I,K)
              ARRAY(I,K) = ARRAY(I,J)
   60      ARRAY(I,J) = -SAVE
C          Accumulate elements of inverse matrix.
   61      DO 70 I = 1, M
              IF (I-K) 63,70,63
   63         ARRAY(I,K) = -ARRAY(I,K)/AMAX
   70      CONTINUE
           DO 80 I = 1, M
              DO 80 J = 1, M
                 IF (I-K) 74,80,74
   74            IF (J-K) 75,80,75
   75            ARRAY(I,J) = ARRAY(I,J) + ARRAY(I,K)*ARRAY(K,J)
   80      CONTINUE
           DO 90 J = 1, M
              IF (J-K) 83,90,83
   83         ARRAY(K,J) = ARRAY(K,J)/AMAX
   90      CONTINUE
           ARRAY(K,K) = 1.0/AMAX
  100   DET = DET * AMAX
C       Restore ordering of matrix.
        DO 130 L = 1, M
           K = M - L + 1
           J = IK(K)
           IF (J-K) 111,111,105
  105      DO 110 I = 1, M
              SAVE = ARRAY(I,K)
              ARRAY(I,K) = -ARRAY(I,J)
  110      ARRAY(I,J) = SAVE
  111      I = JK(K)
           IF (I-K) 130,130,113
  113      DO 120 J = 1, M
              SAVE = ARRAY(K,J)
              ARRAY(K,J) = -ARRAY(I,J)
  120      ARRAY(I,J) = SAVE
  130   CONTINUE
  140   RETURN
        END
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                            C
C Reduce a real, symmetric matrix to a symmetric, tridiagonal                C
C matrix.                                                                    C
C                                                                            C
C To call:    CALL TRED2(NM,N,A,D,E,Z)    where                              C
C                                                                            C
C NM = row dimension of A and Z;                                             C
C N = order of matrix A (will always be <= NM);                              C
C A = symmetric matrix of order N to be reduced to tridiagonal form;         C
C D = vector of dim. N containing, on output, diagonal elts. of trid. matrix;C
C E = working vector of dim. at least N-1 to contain subdiagonal elts.;      C
C Z = matrix of dims. NM by N containing, on output, orthogonal              C
C                    transformation matrix producting the reduction.         C
C                                                                            C
C Normally a call to TQL2 will follow the call to TRED2 in order to          C
C produce all eigenvectors and eigenvalues of matrix A.                      C
C                                                                            C
C Algorithm used: Martin et al., Num. Math. 11, 181-195, 1968.               C
C                                                                            C
C Reference: Smith et al., Matrix Eigensystem Routines - EISPACK             C
C Guide, Lecture Notes in Computer Science 6, Springer-Verlag, 1976,         C
C pp. 489-494.                                                               C
C                                                                            C
C F. Murtagh, ST-ECF Garching-bei-Muenchen, January 1986.                    C
C                                                                            C
C----------------------------------------------------------------------------C
        SUBROUTINE TRED2M(NM,N,A,D,E,Z)
C
        INTEGER N,NM,I,J,II,L,K,JP1,HH
        REAL A(NM,N),D(N),E(N),Z(NM,N)
        REAL SCALE,F,G,H
C
        DO 100 I = 1, N
           DO 100 J = 1, I
              Z(I,J) = A(I,J)
  100   CONTINUE
        IF (N.EQ.1) GOTO 320
        DO 300 II = 2, N
           I = N + 2 - II
           L = I - 1
           H = 0.0
           SCALE = 0.0
           IF (L.LT.2) GOTO 130
           DO 120 K = 1, L
              SCALE = SCALE + ABS(Z(I,K))
  120      CONTINUE
           IF (SCALE.NE.0.0) GOTO 140
  130      E(I) = Z(I,L)
           GOTO 290
  140      DO 150 K = 1, L
              Z(I,K) = Z(I,K)/SCALE
              H = H + Z(I,K)*Z(I,K)
  150      CONTINUE
C
           F = Z(I,L)
           G = -SIGN(SQRT(H),F)
           E(I) = SCALE * G
           H = H - F * G
           Z(I,L) = F - G
           F = 0.0
C
           DO 240 J = 1, L
              Z(J,I) = Z(I,J)/H
              G = 0.0
C             Form element of A*U.
              DO 180 K = 1, J
                 G = G + Z(J,K)*Z(I,K)
  180         CONTINUE
              JP1 = J + 1
              IF (L.LT.JP1) GOTO 220
              DO 200 K = JP1, L
                 G = G + Z(K,J)*Z(I,K)
  200         CONTINUE
C             Form element of P where P = I - U U' / H .
  220         E(J) = G/H
              F = F + E(J) * Z(I,J)
  240      CONTINUE
           HH = F/(H + H)
C          Form reduced A.
           DO 260 J = 1, L
              F = Z(I,J)
              G = E(J) - HH * F
              E(J) = G
              DO 250 K = 1, J
                 Z(J,K) = Z(J,K) - F*E(K) - G*Z(I,K)
  250         CONTINUE
  260      CONTINUE
  290      D(I) = H
  300   CONTINUE
  320   D(1) = 0.0
        E(1) = 0.0
C       Accumulation of transformation matrices.
        DO 500 I = 1, N
           L = I - 1
           IF (D(I).EQ.0.0) GOTO 380
           DO 360 J = 1, L
              G = 0.0
              DO 340 K = 1, L
                 G = G + Z(I,K) * Z(K,J)
  340         CONTINUE
              DO 350 K = 1, L
                 Z(K,J) = Z(K,J) - G * Z(K,I)
  350         CONTINUE
  360      CONTINUE
  380      D(I) = Z(I,I)
           Z(I,I) = 1.0
           IF (L.LT.1) GOTO 500
           DO 400 J = 1, L
              Z(I,J) = 0.0
              Z(J,I) = 0.0
  400      CONTINUE
  500   CONTINUE
C
        RETURN
        END
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                            C
C Determine eigenvalues and eigenvectors of a symmetric,                     C
C tridiagonal matrix.                                                        C
C                                                                            C
C To call:    CALL TQL2(NM,N,D,E,Z,IERR)    where                            C
C                                                                            C
C NM = row dimension of Z;                                                   C
C N = order of matrix Z;                                                     C
C D = vector of dim. N containing, on output, eigenvalues;                   C
C E = working vector of dim. at least N-1;                                   C
C Z = matrix of dims. NM by N containing, on output, eigenvectors;           C
C IERR = error, normally 0, but 1 if no convergence.                         C
C                                                                            C
C Normally the call to TQL2 will be preceded by a call to TRED2 in           C
C order to set up the tridiagonal matrix.                                    C
C                                                                            C
C Algorithm used: QL method of Bowdler et al., Num. Math. 11,                C
C 293-306, 1968.                                                             C
C                                                                            C
C Reference: Smith et al., Matrix Eigensystem Routines - EISPACK             C
C Guide, Lecture Notes in Computer Science 6, Springer-Verlag, 1976,         C
C pp. 468-474.                                                               C
C                                                                            C
C F. Murtagh, ST-ECF Garching-bei-Muenchen, January 1986.                    C
C                                                                            C
C----------------------------------------------------------------------------C
        SUBROUTINE TQL2M(NM,N,D,E,Z,IERR)
C
        INTEGER N,NM,IERR,I,L,J,M,L1,MML,II,K
        REAL    D(N), E(N), Z(NM,N)
        REAL    EPS,F,B,H,P,R,G,C,S
        DATA    EPS/1.E-12/
C
        IERR = 0
        IF (N.EQ.1) GOTO 1001
        DO 100 I = 2, N
           E(I-1) = E(I)
  100   CONTINUE
        F = 0.0
        B = 0.0
        E(N) = 0.0
C
        DO 240 L = 1, N
           J = 0
           H = EPS * (ABS(D(L)) + ABS(E(L)))
           IF (B.LT.H) B = H
C          Look for small sub-diagonal element.
           DO 110 M = L, N
              IF (ABS(E(M)).LE.B) GOTO 120
C             E(N) is always 0, so there is no exit through the bottom
C             of the loop.
  110      CONTINUE
  120      IF (M.EQ.L) GOTO 220
  130      IF (J.EQ.30) GOTO 1000
           J = J + 1
C          Form shift.
           L1 = L + 1
           G = D(L)
           P = (D(L1)-G)/(2.0*E(L))
           R = SQRT(P*P+1.0)
           D(L) = E(L)/(P+SIGN(R,P))
           H = G-D(L)
C
           DO 140 I = L1, N
              D(I) = D(I) - H
  140      CONTINUE
C
           F = F + H
C          QL transformation.
           P = D(M)
           C = 1.0
           S = 0.0
           MML = M - L
C
           DO 200 II = 1, MML
              I = M - II
              G = C * E(I)
              H = C * P
              IF (ABS(P).LT.ABS(E(I))) GOTO 150
              C = E(I)/P
              R = SQRT(C*C+1.0)
              E(I+1) = S * P * R
              S = C/R
              C = 1.0/R
              GOTO 160
  150         C = P/E(I)
              R = SQRT(C*C+1.0)
              E(I+1) = S * E(I) * R
              S = 1.0/R
              C = C * S
  160         P = C * D(I) - S * G
              D(I+1) = H + S * (C * G + S * D(I))
C             Form vector.
              DO 180 K = 1, N
                 H = Z(K,I+1)
                 Z(K,I+1) = S * Z(K,I) + C * H
                 Z(K,I) = C * Z(K,I) - S * H
  180         CONTINUE
  200      CONTINUE
           E(L) = S * P
           D(L) = C * P
           IF (ABS(E(L)).GT.B) GOTO 130
  220      D(L) = D(L) + F
  240   CONTINUE
C
C       Order eigenvectors and eigenvalues.
        DO 300 II = 2, N
           I = II - 1
           K = I
           P = D(I)
           DO 260 J = II, N
              IF (D(J).GE.P) GOTO 260
              K = J
              P = D(J)
  260      CONTINUE
           IF (K.EQ.I) GOTO 300
           D(K) = D(I)
           D(I) = P
           DO 280 J = 1, N
              P = Z(J,I)
              Z(J,I) = Z(J,K)
              Z(J,K) = P
  280      CONTINUE
  300   CONTINUE
C
        GOTO 1001
C       Set error - no convergence to an eigenvalue after 30 iterations.
 1000   IERR = 1
 1001   RETURN
        END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                       C
C  Output eigenvalues in order of decreasing value.                     C
C                                                                       C
C-----------------------------------------------------------------------C
        SUBROUTINE OUTEVM(N,M,NG,VALS)
        INTEGER N,M,NG,K
        REAL    VALS(NG),TOT,CUM,VPC,VCPC
C
        TOT = 0.0
        DO 100 K = 2, NG
           TOT = TOT + VALS(K)
  100   CONTINUE
C
        WRITE (6,1000)
        CUM = 0.0
        K = NG + 1
        WRITE (6,1010)
        WRITE (6,1020)
  200   CONTINUE
        K = K - 1
        CUM = CUM + VALS(K)
        VPC = VALS(K) * 100.0 / TOT
        VCPC = CUM * 100.0 / TOT
        WRITE (6,1030) VALS(K),VPC,VCPC
        IF (K.GT.2) GOTO 200
C
        RETURN
 1000 FORMAT(1H0,'EIGENVALUES FOLLOW.',/)
 1010 FORMAT(' Eigenvalues       As Percentages    Cumul. Percentages')
 1020 FORMAT(' -----------       --------------    ------------------')
 1030 FORMAT(F10.4,9X,F10.4,10X,F10.4)
        END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                       C
C  Output FIRST SEVEN eigenvectors associated with eigenvalues in       C
C  decreasing order.                                                    C
C                                                                       C
C-----------------------------------------------------------------------C
        SUBROUTINE OUTVCM(N1,N2,N3,VECS,N4)
        INTEGER N1,N2,N3,N4,NUM,K1,K2
        REAL   VECS(N3,N3)
C
        NUM = MIN0(N4,7)
        WRITE (6,1000)
        WRITE (6,1010)
        WRITE (6,1020)
        DO 100 K1 = 1, N3
        WRITE (6,1030) K1,(VECS(K1,K2),K2=1,NUM)
  100   CONTINUE
C
        RETURN
 1000   FORMAT(1H0,'EIGENVECTORS FOLLOW.',/)
 1010   FORMAT('  VBLE.   EV-1    EV-2    EV-3    EV-4    EV-5    EV-6
     X   EV-7')
 1020   FORMAT(' ------  ------  ------  ------  ------  ------  ------
     X------')
 1030   FORMAT(I5,2X,7F8.4)
        END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                       C
C  Output projections on discriminant factors.                          C
C                                                                       C
C-----------------------------------------------------------------------C
        SUBROUTINE OUTPXM(N,M,NG,PRJN)
        INTEGER N,M,NUM,NG,K,J
        REAL    PRJN(N,M)
C
        NUM = MIN0(N,M,NG,7)
        WRITE (6,1000)
        WRITE (6,1010)
        WRITE (6,1020)
        DO 100 K = 1, N
           WRITE (6,1030) K,(PRJN(K,J),J=1,NUM-1)
  100   CONTINUE
C
 1000   FORMAT(1X,'PROJECTIONS OF ROW-POINTS FOLLOW.',/)
 1010   FORMAT(' OBJECT  PROJ-1  PROJ-2  PROJ-3  PROJ-4  PROJ-5  PROJ-6
     X  PROJ-7')
 1020   FORMAT(' ------  ------  ------  ------  ------  ------  ------
     X  ------')
 1030   FORMAT(I5,2X,7F8.4)
        RETURN
        END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                       C
C  Output projections of column points on up to first 7 discriminant    C
C  axes.                                                                C
C                                                                       C
C-----------------------------------------------------------------------C
        SUBROUTINE OUTPYM(N,M,NG,PRJNS)
        INTEGER N,M,NG,K,NUM,J
        REAL    PRJNS(NG,NG)
C
        NUM = MIN0(N,M,NG,7)
        WRITE (6,1000)
        WRITE (6,1010)
        WRITE (6,1020)
        DO 100 K = 1, M
           WRITE (6,1030) K,(PRJNS(K,J),J=1,NUM)
  100   CONTINUE
C
 1000   FORMAT(1H0,'PROJECTIONS OF COLUMN-POINTS FOLLOW.',/)
 1010   FORMAT('  VBLE.  PROJ-1  PROJ-2  PROJ-3  PROJ-4  PROJ-5  PROJ-6
     X  PROJ-7')
 1020   FORMAT(' ------  ------  ------  ------  ------  ------  ------
     X  ------')
 1030   FORMAT(I5,2X,7F8.4)
        RETURN
        END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                       C
C  Form projections of row-points on (up to) first 7 factors.           C
C                                                                       C
C-----------------------------------------------------------------------C
        SUBROUTINE PROJXM(N,M,NG,DATA,MEAN,EVEC,VEC,TOTINV)
        INTEGER N,M,K,L,I,J1,NG,NUM
        REAL    DATA(N,M), EVEC(M,M), VEC(M), TOTINV(M,M), MEAN(M)
C
        NUM = MIN0(N,M,NG,7)
        DO 300 K = 1, N
           DO 50 L = 1, M
              VEC(L) = DATA(K,L)
   50      CONTINUE
           DO 200 I = 1, NUM
              DATA(K,I) = 0.0
              DO 100 J1 = 1, M
CC                DO 75 J2 = 1, M
                    DATA(K,I) = DATA(K,I) + (VEC(J1) - MEAN(J1))*
     X                          EVEC(J1,I)
CC   75            CONTINUE
  100         CONTINUE
  200      CONTINUE
  300   CONTINUE
C
        RETURN
        END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                       C
C  Determine projections of column points on (up to) 7 factors.         C
C                                                                       C
C-----------------------------------------------------------------------C
        SUBROUTINE PROJYM(N,M,NG,EVALS,A,Z,VEC)
        INTEGER M,N,NG,NUM,L,J1,J2,J3
        REAL    EVALS(M), A(M,M), Z(M,M), VEC(M)
C
        NUM = MIN0(N,M,NG,7)
        DO 300 J1 = 1, M
           DO 50 L = 1, M
              VEC(L) = A(J1,L)
   50      CONTINUE
           DO 200 J2 = 1, NUM
              A(J1,J2) = 0.0
              DO 100 J3 = 1, M
                 A(J1,J2) = A(J1,J2) + VEC(J3)*Z(J3,M-J2+1)
  100         CONTINUE
              IF (EVALS(M-J2+1).GT.0.0) A(J1,J2) =
     X                                  A(J1,J2)/SQRT(EVALS(M-J2+1))
              IF (EVALS(M-J2+1).EQ.0.0) A(J1,J2) = 0.0
  200      CONTINUE
  300   CONTINUE
C
        RETURN
        END

C===========================================================================
C Copyright (C) 1995-2009 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================

C ++++++++++++++++++++++++  ystd.for +++++++++++++++++++++++++++++++++++++++
C .LANGUAGE Fortran 77
C .IDENTIFICATION Module ystd.for
C .COMMENTS
C Module contains layer between the keyword related FORTRAN STxxxx interfaces
C and the SC_interfaces written in (hopefully independent) C
C .AUTHOR         K. Banse        ESO - Garching
C .KEYWORDS       standard interfaces.
C .ENVIRONMENT    FORTRAN and C standards
C .VERSION  [1.00] 871207:  
C 
C 090323	last modif
C -----------------------------------------------------------------------------
C
      SUBROUTINE STDRDI(NO,DESCR,FELEM,MAXVALS,ACTVALS,VALUES,DUNIT,
     +                  DNULL,STATUS)
C
      IMPLICIT NONE
C
      INTEGER     NO
      CHARACTER*(*)   DESCR        
      INTEGER     FELEM, MAXVALS, ACTVALS
      INTEGER     VALUES(*)
      INTEGER     DUNIT, DNULL
      INTEGER    STATUS
C 
      DUNIT = 0
      DNULL = 0
C
      CALL STSTR(1,DESCR)                          !STRIPPED_STRING
C 
      CALL STD1(NO,FELEM,MAXVALS,ACTVALS,VALUES,STATUS)
C
      RETURN
      END
C


      SUBROUTINE STDRDL(NO,DESCR,FELEM,MAXVALS,ACTVALS,VALUES,DUNIT,
     +                  DNULL,STATUS)
C
      IMPLICIT NONE
C
      INTEGER     NO
      CHARACTER*(*)   DESCR        
      INTEGER     FELEM, MAXVALS, ACTVALS
      INTEGER     VALUES(*)
      INTEGER     DUNIT, DNULL
      INTEGER    STATUS
C 
      DUNIT = 0
      DNULL = 0
C
      CALL STSTR(1,DESCR)                          !STRIPPED_STRING
C
      CALL STD2(NO,FELEM,MAXVALS,ACTVALS,VALUES,STATUS)
C
      RETURN
      END
C
C 
      SUBROUTINE STDRDR(NO,DESCR,FELEM,MAXVALS,ACTVALS,VALUES,DUNIT,
     +                  DNULL,STATUS)
C
      IMPLICIT NONE
C
      INTEGER     NO
      CHARACTER*(*)   DESCR        
      INTEGER     FELEM, MAXVALS, ACTVALS
      REAL     VALUES(*)
      INTEGER     DUNIT, DNULL
      INTEGER    STATUS
C 
      DUNIT = 0
      DNULL = 0
C 
      CALL STSTR(1,DESCR)                          !STRIPPED_STRING
C
      CALL STD3(NO,FELEM,MAXVALS,ACTVALS,VALUES,STATUS)
C
      RETURN
      END
C
C 
      SUBROUTINE STDRDD(NO,DESCR,FELEM,MAXVALS,ACTVALS,VALUES,DUNIT,
     +                  DNULL,STATUS)
C
      IMPLICIT NONE
C
      INTEGER     NO
      CHARACTER*(*)   DESCR        
      INTEGER     FELEM, MAXVALS, ACTVALS
      DOUBLE PRECISION     VALUES(*)
      INTEGER     DUNIT, DNULL
      INTEGER    STATUS
C 
      DUNIT = 0
      DNULL = 0
C 
      CALL STSTR(1,DESCR)                          !STRIPPED_STRING
C
      CALL STD4(NO,FELEM,MAXVALS,ACTVALS,VALUES,STATUS)
C
      RETURN
      END
C 
C
      SUBROUTINE STDRDS(NO,DESCR,FELEM,MAXVALS,ACTVALS,VALUES,DUNIT,
     +                  DNULL,STATUS)
C
      IMPLICIT NONE
C
      INTEGER     NO
      CHARACTER*(*)   DESCR        
      INTEGER     FELEM, MAXVALS, ACTVALS
      INTEGER*8     VALUES(*)
      INTEGER     DUNIT, DNULL
      INTEGER    STATUS
C 
      DUNIT = 0
      DNULL = 0
C 
      CALL STSTR(1,DESCR)                          !STRIPPED_STRING
C
      CALL STD4a(NO,FELEM,MAXVALS,ACTVALS,VALUES,STATUS)
C
      RETURN
      END
C 
C
      SUBROUTINE STDRDC(NO,DESCR,NOELM,FELEM,MAXVALS,ACTVALS,VALUES,
     +                  DUNIT,DNULL,STATUS)
C
      IMPLICIT NONE
C
      INTEGER     NO
      CHARACTER*(*)   DESCR, VALUES
      INTEGER     NOELM, FELEM, MAXVALS, ACTVALS
      INTEGER     DUNIT, DNULL
      INTEGER    STATUS
C 
      DUNIT = 0
      DNULL = 0
C
      CALL STSTR(1,DESCR)                          !STRIPPED_STRING
      CALL STLOC(1,1,VALUES)                       !blanked CHAR_LOC
C
      CALL STD5(NO,NOELM,FELEM,MAXVALS,ACTVALS,STATUS)
C
      RETURN
      END
C 
C
      SUBROUTINE STDRDH(NO,DESCR,FELEM,MAXVALS,ACTVALS,VALUES,
     +                  TOTAL,STATUS)
C
      IMPLICIT NONE
C
      INTEGER     NO
      CHARACTER*(*)   DESCR, VALUES
      INTEGER     TOTAL, FELEM, MAXVALS, ACTVALS
      INTEGER    STATUS
C 
      CALL STSTR(1,DESCR)                          !STRIPPED_STRING
      CALL STLOC(1,1,VALUES)                       !blanked CHAR_LOC
C
      CALL STD6(NO,FELEM,MAXVALS,ACTVALS,TOTAL,STATUS)
C
      RETURN
      END
C 

      SUBROUTINE STDFND(NO,DESCR,CTYPE,NOELEM,BYTELEM,STATUS)
C 
      IMPLICIT NONE
C
      INTEGER     NO
      CHARACTER*(*)   DESCR, CTYPE
      INTEGER     NOELEM, BYTELEM
      INTEGER     STATUS
C
      CALL STSTR(1,DESCR)                          !STRIPPED_STRING
      CALL STLOC(1,1,CTYPE)                        !blanked CHAR_LOC
C
      CALL STD7(NO,NOELEM,BYTELEM,STATUS)
C
      RETURN
      END
C
C 
      SUBROUTINE STDINF(NO,NPOS,FIELD,BUF,NUMBUF,STATUS)
C 
      IMPLICIT NONE
C
      INTEGER     NO
      CHARACTER*(*)   BUF
      INTEGER     NPOS, FIELD, NUMBUF
      INTEGER     STATUS
C
      CALL STLOC(1,1,BUF)                          !blanked CHAR_LOC
C
      CALL STD8(NO,NPOS,FIELD,NUMBUF,STATUS)
C
      RETURN
      END
C
C
      SUBROUTINE STDRDX(NO,FLAG,DESCR,CTYPE,BYTEL,NOEL,HNC,STATUS)
C
      IMPLICIT NONE
C
      INTEGER     NO
      CHARACTER*(*)   DESCR, CTYPE
      INTEGER     FLAG, BYTEL, NOEL, HNC
      INTEGER     STATUS
C
      CALL STLOC(1,1,DESCR)                          !blanked CHAR_LOC
      CALL STLOC(2,1,CTYPE)                          !blanked CHAR_LOC
C
      CALL STD9(NO,FLAG,BYTEL,NOEL,HNC,STATUS)
C
      RETURN
      END


      SUBROUTINE STDWRC(NO,DESCR,NOELM,VALUES,FELEM,MAXVALS,
     +                  DUNIT,STATUS)
C
      IMPLICIT NONE
C
      INTEGER     NO
      CHARACTER*(*)   DESCR, VALUES
      INTEGER     NOELM, FELEM, MAXVALS
      INTEGER     DUNIT
      INTEGER     STATUS
C
      CALL STSTR(1,DESCR)                          !STRIPPED_STRING
      CALL STLOC(1,0,VALUES)                       !untouched CHAR_LOC
C 
      CALL STD10(NO,NOELM,FELEM,MAXVALS,STATUS)
C
      RETURN
      END


      SUBROUTINE STDWRD(NO,DESCR,VALUES,FELEM,MAXVALS,DUNIT,STATUS)
C
      IMPLICIT NONE
C
      INTEGER     NO
      CHARACTER*(*)   DESCR
      INTEGER     FELEM, MAXVALS
      DOUBLE PRECISION     VALUES(*)
      INTEGER     DUNIT
      INTEGER     STATUS
C
      CALL STSTR(1,DESCR)                          !STRIPPED_STRING
C 
      CALL STD11(NO,VALUES,FELEM,MAXVALS,STATUS)
C
      RETURN
      END


      SUBROUTINE STDWRH(NO,DESCR,VALUES,FELEM,MAXVALS,STATUS)
C
      IMPLICIT NONE
C
      INTEGER     NO
      CHARACTER*(*)   DESCR, VALUES
      INTEGER     FELEM, MAXVALS
      INTEGER     STATUS
C
      CALL STSTR(1,DESCR)                          !STRIPPED_STRING
      CALL STSTR(2,VALUES)           !STRIPPED_STRING (not too long)
C
      CALL STD12(NO,FELEM,MAXVALS,STATUS)
C
      RETURN
      END


      SUBROUTINE STDWRI(NO,DESCR,VALUES,FELEM,MAXVALS,DUNIT,STATUS)
C
      IMPLICIT NONE
C
      INTEGER     NO
      CHARACTER*(*)   DESCR
      INTEGER     FELEM, MAXVALS
      INTEGER     VALUES(*)
      INTEGER     DUNIT
      INTEGER     STATUS
C
      CALL STSTR(1,DESCR)                          !STRIPPED_STRING
C 
      CALL STD13(NO,VALUES,FELEM,MAXVALS,STATUS)
C
      RETURN
      END


      SUBROUTINE STDWRL(NO,DESCR,VALUES,FELEM,MAXVALS,DUNIT,STATUS)
C
      IMPLICIT NONE
C
      INTEGER     NO
      CHARACTER*(*)   DESCR
      INTEGER     FELEM, MAXVALS
      INTEGER     VALUES(*)
      INTEGER     DUNIT
      INTEGER     STATUS
C
      CALL STSTR(1,DESCR)                          !STRIPPED_STRING
C
      CALL STD14(NO,VALUES,FELEM,MAXVALS,STATUS)
C
      RETURN
      END


      SUBROUTINE STDWRR(NO,DESCR,VALUES,FELEM,MAXVALS,DUNIT,STATUS)
C
      IMPLICIT NONE
C
      INTEGER     NO
      CHARACTER*(*)   DESCR
      INTEGER     FELEM, MAXVALS
      REAL     VALUES(*)
      INTEGER     DUNIT
      INTEGER     STATUS
C
      CALL STSTR(1,DESCR)                          !STRIPPED_STRING
C
      CALL STD15(NO,VALUES,FELEM,MAXVALS,STATUS)
C
      RETURN
      END

      SUBROUTINE STDDEL(NO,DESCR,STATUS)
C
      IMPLICIT NONE
C
      INTEGER     NO
      CHARACTER*(*)   DESCR
      INTEGER     STATUS
C
      CALL STSTR(1,DESCR)                          !STRIPPED_STRING
C
      CALL STD16(NO,STATUS)
C
      RETURN
      END

      SUBROUTINE STDCOP(FROM,TO,MASK,DESCR,STATUS)
C
      IMPLICIT NONE
C
      INTEGER     FROM,TO,MASK
      CHARACTER*(*)   DESCR
      INTEGER     STATUS
C
      CALL STSTR(1,DESCR)                          !STRIPPED_STRING
C
      CALL STD17(FROM,TO,MASK,STATUS)
C
      RETURN
      END

C @(#)comsky.for	19.1 (ES0-DMD) 02/25/03 13:31:21
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
	PROGRAM COMSKY
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENT	 program  COMSKY   		A. Lauberts     ESO  890707
C	 revised from COMB

C.KEYWORDS
C
C
C  bulk data frames, restitution, sky background
C
C.PURPOSE
C
C  Given two image frames A and B (= subset of A) and a table file with 
C  preliminary calibration coefficients.
C  Get:
C
C  SKYBGR - Sky backgr plane through intensity mean levels left of highest
C           bins x SKYF in histogram of frame A, at 8 rectangles surrounding
C           frame B and inside two concentric circles,
C  GALPOP - Start PDS density of upper 5% and 10% populations in histogram 
C	    of B,
C  GALCEN - Centroid of region 10% to 5% highest PDS density population in B.
C
C  Replace (option) intersection of A and B with B.
C
C  Note: if A = B then only part of these operations are done
C
C.USAGE  MIDAS applic program
C	 execute as @@ COMSKY P1 P2 P3 P4 P5
C
C.PARAMETERS
C Input:
C
C P1	FRAMEA	C*8	first  frame A 
C P2	FRAMEB	C*8	second frame B (= centred subset of A)
C P3	TABLEC	C*8	table file (one row, 9 columns) with preliminary
C			calibration coefficients for the characteristic curve 
C			(derived in DTOM according to Llebaria from spots only)
C P4	METH	I*4	method 2 (PDS scan before 14.4.1984,
C			method 1 (PDS scan after  13.4.1984, 
C				  descriptor O_TIME set = 1984.5) 
C			method 0 (same as 1, but no pixel replacement)
C			method 3 (only one frame, 2nd frame set = 1st frame,
C				  only write new descriptor SKYBGR to A,
C				  default)
C P5	SKYF	R*4	sky factor, default=1.4
C
C Output:  Restituted image files + new descriptors
C
C.COMMENTS  Note PDS was not working well at slow speed (<=10) 1987-88.
C-----------------------------------------------------------------------
	IMPLICIT  INTEGER  (A-Z)
C
	CHARACTER*60  FRAMEA,FRAMEB,TABLEC
	CHARACTER*24 CUNITA,CUNITB
	INTEGER      HIST(4096),NPIXA(2),NPIXB(2),ISEQ(8),COL(10)
        INTEGER      MADRID
	REAL         T(4096),STEPA(2),STEPB(2),STARTA(2),STARTB(2),
     +		     SKY(4),GAL(2),CEN(9),STARTO(2),
     +		     A,B,C,D,DI,D1,D2,C1,C2,C3,C4,CONST(9),
     +               X(8),Y(8),Z(8),SKYF,
     +		     XX(8),YY(8),ZZ(8),DEV(8),DLIM
	DOUBLE PRECISION OTIME
        CHARACTER*21 IDENTA,IDENTB
	CHARACTER    HISTORY*19, SKYVAL*80
	LOGICAL      NULL(10)
C
        COMMON       /VMR/MADRID(1)
	COMMON       /COM/T,HIST,MAXD,I00,J00,IJ1,IJ2
C
C  set up MIDAS environment 
C
	CALL SXSPRO('COMSKY')
	DO I=1,10
	  COL(I)=I
	ENDDO
C
C  get keywords
C
	CALL SXKGET('IN_A','C',1,60,IAV,FRAMEA,STAT)
	CALL SXKGET('IN_B','C',1,60,IAV,FRAMEB,STAT)
	CALL SXKGET('INPUTC','C',1,60,IAV,TABLEC,STAT)
	CALL SXKGET('INPUTI','I',1,1,IAV,METH,STAT)
	CALL SXKGET('INPUTR','R',1,1,IAV,SKYF,STAT)
C
C  read calibration coefficients from one row table file
C
	CALL TXTOPN(TABLEC,STAT)
	CALL TXRGET(TABLEC,'R*4',1,9,COL,CONST,NULL,STAT)
C+
C
C  get method of pixel restoration
C  METH=0: no pix replacement (new amplifier)
C  METH=1: pixel replacement (new amplifier on PDS)
C  METH=2: pixel replacement + interpolation 
C  METH=3: (default) FRAMEB = FRAMEA (only frame A needed)
C  DLIM upper limit of PDS density units
C  SKYF sky background computation < approx sky*SKYF (default=1.4)
C
C-
	IF(METH.EQ.2.OR.METH.EQ.3) THEN
	  CALL SXDGET(FRAMEA,'O_TIME','R*8',1,1,IAV,OTIME,STAT)
	 ELSE
	  OTIME=1984.5D0
	ENDIF
	IF(OTIME.GT.1983.5D0) THEN
	  IF(METH.NE.0.AND.METH.NE.3) METH=1
	  MAXD=4096
	  DLIM=4096.
	  DI=.00125
	 ELSE
	  IF(METH.NE.0.AND.METH.NE.3) METH=2
	  MAXD=1024.
	  DI=.005
	  DLIM=800.
	ENDIF
C
C  look-up table D to I according to the Llebaria formula
C  with coefficients C1-C5 derived in DTOM with spots only:
C
C  log I = C3 log(D-C1) + C4 log(C2-D) + C5,
C
C  where
C  C1 = fog density
C  C2 = saturation density
C  C3 = A factor
C  C4 = B factor
C  C5 = zeropoint (not used here)
C
	C1=CONST(2)
	C2=CONST(3)
	C3=CONST(4)
	C4=CONST(5)
	D1=C1+.05
	D2=C2-.05
	DO I=1,MAXD
	  D=(I-1)*DI
	  D=AMIN1(D2,AMAX1(D1,D))
	  T(I)=(D-C1)**C3*(C2-D)**C4
	ENDDO
	IF(METH.EQ.3.OR.FRAMEA.EQ.FRAMEB) THEN
	  METH=3
	  FRAMEB=FRAMEA
	ENDIF
	WRITE(6,101) METH,MAXD,DLIM,SKYF
101	FORMAT('  METH=',I2,' MAXD=',I5,' DLIM=',F6.0,' SKYF=',F4.1)
	CALL SXIGET(FRAMEA,'IO',2,NAXISA,NPIXA,STARTA,STEPA,IDENTA,
     +			CUNITA,PNTRA,STAT)
	CALL SXTPUT(IDENTA,STAT)
	NDIMA=NPIXA(1)*NPIXA(2)
	IF(METH.EQ.0.OR.METH.EQ.3) THEN
	  DO I=1,2
	    NPIXB(I)=NPIXA(I)/3
	    STEPB(I)=STEPA(I)
	    GAL(I)=MAXD/2
	  ENDDO
	  IF(METH.EQ.3) GOTO 30
	ENDIF
	HISTORY(1:8)=FRAMEA
	IF(METH.NE.0) THEN
	  HISTORY(9:11)=' + '
	  HISTORY(12:19)=FRAMEB
	  ELSE
	  HISTORY(9:19)='           '
	ENDIF
	CALL SXIGET(FRAMEB,'I',2,NAXISB,NPIXB,STARTB,STEPB,
     +              IDENTB,CUNITB,PNTRB,STAT)
	NDIMB=NPIXB(1)*NPIXB(2)
	IF(IDENTA.EQ.IDENTB) GOTO 20
	CALL SXTPUT(' *** NOT SAME OBJECTS',STAT)
	GOTO 999
20	IF(NPIXA(1).GT.NPIXB(1)) GOTO 30
	CALL SXTPUT(' *** A <= B',STAT)
	GOTO 999
C+
C
C  map output file 
C  centre coords in STARTO
C  set temporarily new origo at centre by redefining STARTA and STARTB
C
C-
30	X(1)=STARTA(1)
	Y(2)=STARTA(2)
	STARTA(1)=-FLOATJ(NPIXA(1)-1)*STEPA(1)/2.
	STARTA(2)=-FLOATJ(NPIXA(2)-1)*STEPA(2)/2.
	STARTO(1)=X(1)-STARTA(1)
	STARTO(2)=Y(2)-STARTA(2)
	STARTB(1)=-FLOATJ(NPIXB(1)-1)*STEPB(1)/2.
	STARTB(2)=-FLOATJ(NPIXB(2)-1)*STEPB(2)/2.
C  update descriptors
40	CALL SXDPUT(FRAMEA,'HISTORY','C',HISTORY,-1,30,STAT)
	IF (METH.NE.2) THEN
           CALL SXDPUT(FRAMEA,'O_TIME','R*8',OTIME,1,1,STAT)
        ENDIF
C+
C
C  compute sky background in 8 rectangles surrounding frame B,
C  also inside two concentric circles with diams (NPIXB+3*NPIXA)/4
C  and NPIXA
C
C  I0J3    I1J3    I2J3    I3J3
C      X7Y7    X6Y6    X5Y5
C  I0J2    I1J2    I2J2    I3J2
C    X8Y8      X0Y0      X4Y4
C  I0J1    I1J1    I2J1    I3J1
C      X1Y1    X2Y2    X3Y3
C  I0J0    I1J0    I2J0    I3J0
C
C-
45	I0= 1
	I1=(NPIXA(1)-NPIXB(1))/2+1
	I2= NPIXA(1)-I1
	I3= NPIXA(1)
	J0= 1
	J1=(NPIXA(2)-NPIXB(2))/2+1
	J2= NPIXA(2)-J1
	J3= NPIXA(2)
C  centre
	I00=I3/2+1
	J00=J3/2+1
C  squared radii of concentric circles
	IJ1=((I2+I3)**2+(J2+J3)**2)/32
	IJ2=(I3**2+J3**2)/8
C  compute mean x,y coordinates in rectangles
	X(1)=(STARTA(1)+STARTB(1))/2.
	Y(1)=(STARTA(2)+STARTB(2))/2.
	X(2)=0.
	Y(2)=(STARTA(2)+Y(1))/2.
	X(3)=-X(1)
	Y(3)=Y(1)
	X(4)=-(STARTA(1)+X(1))/2.
	Y(4)=0.
	X(5)=X(3)
	Y(5)=-Y(3)
	X(6)=0.
	Y(6)=-Y(2)
	X(7)=X(1)
	Y(7)=Y(5)
	X(8)=-X(4)
	Y(8)=0.
	CALL SKYBAK(NDIMA,NPIXA,MADRID(PNTRA),Z(1),SKYF,I0,J0,I1,J1)
	CALL SKYBAK(NDIMA,NPIXA,MADRID(PNTRA),Z(2),SKYF,I1,J0,I2,J1)
	CALL SKYBAK(NDIMA,NPIXA,MADRID(PNTRA),Z(3),SKYF,I2,J0,I3,J1)
	CALL SKYBAK(NDIMA,NPIXA,MADRID(PNTRA),Z(4),SKYF,I2,J1,I3,J2)
	CALL SKYBAK(NDIMA,NPIXA,MADRID(PNTRA),Z(5),SKYF,I2,J2,I3,J3)
	CALL SKYBAK(NDIMA,NPIXA,MADRID(PNTRA),Z(6),SKYF,I1,J2,I2,J3)
	CALL SKYBAK(NDIMA,NPIXA,MADRID(PNTRA),Z(7),SKYF,I0,J2,I1,J3)
	CALL SKYBAK(NDIMA,NPIXA,MADRID(PNTRA),Z(8),SKYF,I0,J1,I1,J2)
	WRITE(SKYVAL,201) Z
201	FORMAT(' SKYVALUES: ',8F8.1)
	CALL SXTPUT(SKYVAL,STAT)
	M=8
	DO I=1,8
	  ISEQ(I)=1
	ENDDO
50	II=0
	DO I=1,8
	    IF(ISEQ(I).EQ.1) THEN
	      II=II+1
	      XX(II)=X(I)
	      YY(II)=Y(I)
	      ZZ(II)=Z(I)
	    ENDIF
	ENDDO
	CALL PLANE(XX,YY,ZZ,SKY,M,DEV)
	IF(SKY(4).LT.SKY(1)*0.01) GOTO 53
	IF(M.LE.6) GOTO 52
	DEV1=0.
	J=1
	DO I=1,8
	  IF(ISEQ(I).EQ.1.AND.DEV(I).GT.DEV1) THEN
	    J=I
	    DEV1=DEV(I)
	  ENDIF
	ENDDO
	ISEQ(J)=0
	WRITE(SKYVAL,203) Z(J)
203	FORMAT(' *** BAD SKY, EXCLUDE VALUE',F8.1)
	CALL SXTPUT(SKYVAL,STAT)
	M=M-1
	GOTO 50
52	CALL SEQUENCE(ZZ,ISEQ,M)
	SKY(1)=ZZ(ISEQ(3))
	SKY(2)=0.
	SKY(3)=0.
	WRITE(SKYVAL,202) SKY(1)
202	FORMAT(' *** TAKE ONLY MEDIAN SKY =',F8.1)
	CALL SXTPUT(SKYVAL,STAT) 
53	CALL SXDPUT(FRAMEA,'SKYBGR','R',SKY,1,3,STAT)
	IF(METH.EQ.3) GOTO 999
C
C  get location of central galaxy and replace inner region of A with B
C
	CALL EXCHANGE(NDIMA,NDIMB,NPIXA,NPIXB,STARTA,STARTB,STEPA,STEPB,
     +               MADRID(PNTRA),MADRID(PNTRB),SKY,GAL,CEN,DLIM,METH)
	DO I=1,2	
	  CEN(I)=CEN(I)+STARTO(I)
	ENDDO
	CALL SXDPUT(FRAMEA,'GALPOP','R',GAL,1,2,STAT)
	CALL SXDPUT(FRAMEA,'GALCEN','R',CEN,1,9,STAT)
C
999	CALL SXSEPI
	END
C
	SUBROUTINE SKYBAK(NDIMA,NPIXA,A,SKY,SKYF,I1,J1,I2,J2)
C+
C
C  compute sky background in region A[I1,J1,I2,J2]
C  also inside two concentric circles with squared radii IJ1 and IJ2
C
C-
	COMMON /COM/T,HIST,MAXD,I00,J00,IJ1,IJ2
	INTEGER  HIST(4096),NPIXA(2),HJ,HN
	REAL     A(NDIMA),T(4096)
C+
C  form histogram of subframe
C-
	DO 11 N=1,MAXD
11	HIST(N)=0
	DO 3 J=J1,J2
	IJ0=(J-J00)**2
	LOCA=(J-1)*NPIXA(1)+I1
	DO 2 I=I1,I2
	IJ=IJ0+(I-I00)**2
	IF(IJ.LT.IJ1.OR.IJ.GT.IJ2) GOTO 2
	N=MIN0(MAXD,JIFIX(A(LOCA)+1.))
	HIST(N)=HIST(N)+1
2	LOCA=LOCA+1
3	CONTINUE
C+
C  find highest bin
C-
	MAX=0
	DO 4 J=1,MAXD
	HJ=HIST(J)
	IF(MAX.GT.HJ) GOTO 4
	MAX=HJ
	HN=J
4	CONTINUE
C+
C  sky = intensity mean of bins left of highest bin x SKYF
C-
	X=T(HN)*SKYF
	DO L=1,MAXD
	  IF(T(L).GT.X) GOTO 5
	ENDDO
5	SKY=0.
	N=0
	DO J=1,L
	  HJ=HIST(J)
	  SKY=SKY+HJ*T(J)
	  N=N+HJ
	ENDDO
	SKY=SKY/FLOATJ(N)
C
C  convert back to density 
C
	DO J=1,L
	  IF(T(J).GT.SKY) GOTO 6
	ENDDO
	J=L
6	IF(T(J).NE.T(J-1)) THEN
	  SKY=J-(T(J)-SKY)/(T(J)-T(J-1))-1.
	  ELSE
	  SKY=AMAX1(0.,J-1.5)
	ENDIF
	RETURN
	END
C
	SUBROUTINE EXCHANGE(NDIMA,NDIMB,NPIXA,NPIXB,STARTA,STARTB,
     +                      STEPA,STEPB,A,B,SKY,GAL,CEN,DLIM,METH)
	COMMON /COM/T,HIST,MAXD
	CHARACTER OFFC*80
	INTEGER HIST(4096),NPIXA(2),NPIXB(2),H(7),HN(7),COUNT,STAT
	REAL    A(NDIMA),B(NDIMB),T(4096),STARTA(2),STARTB(2),STEPA(2),
     +          STEPB(2),CEN(9),GAL(2),SKY(4)
C
C  form histogram of B
C
	DO 8 N=1,MAXD
8	HIST(N)=0
	DO 22 I=1,NDIMB
	N=MIN0(MAXD,JIFIX(B(I)+1.))
	HIST(N)=HIST(N)+1
22	CONTINUE
C
C  find max non-zero bin
C
	DO MAX=MAXD,1,-1
	  IF(HIST(MAX).NE.0) GOTO 24
	ENDDO
C
C  find start position of upper 10% population in histogram of B
C
24	J=NDIMB*0.9
	K=0
	DO 9 N=1,MAXD
	K=K+HIST(N)
	IF(K.GT.J) GOTO 10
9	CONTINUE
10	GAL1=FLOATJ(N)
	N1=N+1
C  find start position of upper 5% population in histogram of B
	J=NDIMB*0.95
	DO 91 N=N1,MAXD
	K=K+HIST(N)
	IF(K.GT.J) GOTO 101
91	CONTINUE
101	GAL2=FLOATJ(N)
	GAL(1)=GAL2
	GAL(2)=GAL1
C
C  find unweighted centroid of pixels of values GAL1 to GAL2 in B
C
	MX=0
	MY=0
	N=0
	LOCB=1
	DO 13 NY=1,NPIXB(2)
	DO 12 NX=1,NPIXB(1)
	BL=B(LOCB)
	IF(BL.LT.GAL1.OR.BL.GT.GAL2) GOTO 12
	MX=MX+NX
	MY=MY+NY
	N=N+1
12	LOCB=LOCB+1
13	CONTINUE
C
C  world coordinates in microns (populations 1,2) related to frame A
C
	DO I=1,9
	  CEN(I)=0.
	ENDDO
	IF(N.GT.9) THEN
	  GAL1 = FLOATJ(MX)/FLOATJ(N)
	  GAL2 = FLOATJ(MY)/FLOATJ(N)
	  J1 = (GAL1-1.)*STEPB(1)+STARTB(1)
	  J2 = (GAL2-1.)*STEPB(2)+STARTB(2)
	  IF(J1*J1+J2*J2.GT.10000.OR.GAL(1).LT.SKY(1)+50.) THEN
	  WRITE(OFFC,200) J1,J2,MAX,GAL
200	  FORMAT(' OFF CENTER',I5,',',I5,' MAX PDS',I5,' GALPOP',2F8.1,
     + 17X,'*****')
	  ELSE
	  CEN(1)=J1
	  CEN(2)=J2
	  WRITE(OFFC,201) J1,J2,MAX,GAL
201	  FORMAT(' OFF CENTER',I5,',',I5,' MAX PDS',I5,' GALPOP',2F8.1)
	  ENDIF
          CALL SXTPUT(OFFC,STAT)
	 ELSE
	  WRITE(OFFC,202)
202	  FORMAT(' CENTROID ILL DEFINED',54X,'*****')
	  CALL SXTPUT(OFFC,STAT)
	ENDIF
	IF(METH.EQ.0.OR.METH.EQ.3) RETURN
	LSKIP=4
	LSKIP1=LSKIP+1
	GOTO (25,26) METH
C+
C
C  replace inner square region of A with B
C  no interpolation across pixels
C  skip four first (usually bad) scan lines in frame B
C  also skip last (bad) line in B
C
C-
25	LOCB=1+NPIXB(1)*LSKIP
	J1=(NPIXA(2)-NPIXB(2))/2+LSKIP1
	J2=J1+NPIXB(2)-LSKIP1
	I1=(NPIXA(1)-NPIXB(1))/2+1
	LOC1=(J1-1)*NPIXA(1)+I1
	LOC2=LOC1+NPIXB(1)-1
	DO J=J1,J2
	  DO LOCA=LOC1,LOC2
	    A(LOCA)=B(LOCB)
	    LOCB=LOCB+1
	  ENDDO
	  LOC1=LOC1+NPIXA(1)
	  LOC2=LOC2+NPIXA(1)
	ENDDO
	RETURN
C+
C
C  Restore part of high densities asymmetrically displaced 
C  at too high scan speed; fill in valleys under straight
C  lines connecting two maxima, again replacing A with B.
C  Weak point: interference with nearby bright stars
C
C-
26	L1=1+NPIXB(1)*LSKIP
	L2=NPIXB(1)*LSKIP1
	LOC1=L1-NPIXB(1)
	LOC2=L1+NPIXB(1)
	J1=(NPIXA(2)-NPIXB(2))/2+LSKIP1
	J2=J1+NPIXB(2)-LSKIP1-1
	I1=(NPIXA(1)-NPIXB(1))/2+1
	DO J=J1,J2
	  LOCA=(J-1)*NPIXA(1)+I1
	  BM1=0.
	  BM2=0.
	  LM1=0
	  LM2=0
	  DO L=L1,L2
	    BL=B(L)
	    IF(BL.GT.DLIM) THEN
C  find 1st max on original line
		IF(BL.GT.BM1) THEN
		  BM1=BL
		  LM1=LOCA
		ENDIF
		B1=B(LOC1)
		B2=B(LOC2)
		IF(BL.LT.AMIN1(B1,B2)) THEN
C  interpolate between scan lines
		  BL=(B1+B2)/2.
C  find 2nd max on interpolated line
		  IF(BL.GT.BM2) THEN
		    BM2=BL
		    LM2=LOCA
		  ENDIF
		ENDIF
	    ENDIF
	    A(LOCA)=BL
	    LOC1=LOC1+1
	    LOC2=LOC2+1
	    LOCA=LOCA+1
	  ENDDO
C  if valley exists, fill in depression
	  IF(LM1.NE.0.AND.LM2.NE.0.AND.LM1.NE.LM2
     +		     .AND.JIABS(LM1-LM2).LT.15) THEN
	    R=(BM2-BM1)/(LM2-LM1)
	    I=1
	    IF(LM1.GT.LM2) I=-1
	    DO L=LM1+I,LM2-I,I
		A(L)=BM1+R*(L-LM1)
	    ENDDO
	  ENDIF
	  L1=L2+1
	  L2=L2+NPIXB(1)
	ENDDO
	RETURN
	END
C
C
      SUBROUTINE PLANE(X,Y,Z,A,M,DEV)
        DOUBLE PRECISION  B(4,4)
        REAL              X(8),Y(8),Z(8), A(8),DEV(8)
	CHARACTER*44      APPROX
C  
C LSQ fitting of plane
C         Z = A1 + A2*X + A3*Y
C through M points
C
	N=3
	N1=N+1
	DO 2 I=1,4
	DO 1 J=1,4
1	B(I,J)=0.
2	CONTINUE
	DO 3 K=1,M
        A(1)=1.
        A(2)=X(K)                 
        A(3)=Y(K)              
        A(4)=Z(K)
        DO 31 I=1,4
	DO 32 J=1,4
32      B(I,J)=B(I,J)+A(I)*A(J)
31      CONTINUE     
3	CONTINUE
	B44=B(4,4)
	B34=B(3,4)
	B24=B(2,4)
	B14=B(1,4)
        CALL SIMUL(N,N1,B,A)
	A(4)=SQRT(ABS(B44-B34*A(3)-B24*A(2)-B14*A(1))/FLOATJ(M))
	WRITE(APPROX,200) (A(I), I=1,4)
200	FORMAT(4E11.3)
	CALL SXTPUT(' PLANE APPROX'//APPROX,ISTAT)
	DO I=1,M
	  DEV(I)=ABS(Z(I)-A(1)-A(2)*X(I)-A(3)*Y(I))
	ENDDO
      RETURN
      END   
C           
C           
      SUBROUTINE SIMUL(N,N1,A,X)
C   THE GAUSS-JORDAN COMPLETE ELIMINATION METHOD IS EMPLOYED
C   WITH THE MAXIMUM PIVOT STRATEGY.
      DOUBLE PRECISION    A, EPS, AIJCK, PIVOT
      DIMENSION           IROW(6), JCOL(6),  Y(6), A(4,4), X(N)
      MAX=N1
      EPS=1.E-20                  
C   BEGIN ELIMINATION PROCEDURE   
5     DETER=1.                    
      DO 18 K=1,N                 
      KM1=K-1                     
C   SEARCH FOR THE PIVOT ELEMENT  
      PIVOT=0.                    
      DO 10 I=1,N                 
      DO 11 J=1,N                 
C   SEARCH IROW AND JCOL ARRAYS FOR INVALID PIVOT SUBSCRIPTS
      IF(K.EQ.1)GOTO 9            
      DO 8 ISCAN=1,KM1            
      DO 7 JSCAN=1,KM1            
      IF(I.EQ.IROW(ISCAN))GOTO 11 
      IF(J.EQ.JCOL(JSCAN))GOTO 11 
7     CONTINUE                    
8     CONTINUE                    
9     CONTINUE                    
      IF(DABS(A(I,J)).LE.DABS(PIVOT))GOTO 11
      PIVOT=A(I,J)
      IROW(K)=I   
      JCOL(K)=J   
11    CONTINUE    
10    CONTINUE    
C   INSURE THAT SELECTED PIVOT IS LARGER THAN EPS
      IF(DABS(PIVOT).GT.EPS)GOTO 13
	CALL SXTPUT(' WARNING! SINGULAR MATRIX',ISTAT)
      RETURN                      
C   UPDATE THE DETERMINANT VALUE  
13    IROWK=IROW(K)               
      JCOLK=JCOL(K)               
      DETER=DETER*PIVOT           
C   NORMALIZE PIVOT ROW ELEMENTS  
      DO 14 J=1,MAX               
14    A(IROWK,J)=A(IROWK,J)/PIVOT 
C   CARRY OUT ELIMINATION         
      A(IROWK,JCOLK)=1./PIVOT     
      DO 18 I=1,N                 
      AIJCK=A(I,JCOLK)            
      IF(I.EQ.IROWK)GOTO 18       
      A(I,JCOLK)=-AIJCK/PIVOT     
      DO 17 J=1,MAX               
      IF(J.NE.JCOLK) A(I,J)=A(I,J)-AIJCK*A(IROWK,J) 
17    CONTINUE              
18    CONTINUE              
C   ORDER SOLUTION VALUES   
      DO 20 I=1,N           
      IROWI=IROW(I)         
      JCOLI=JCOL(I)         
      X(JCOLI)= A(IROWI,MAX)
20    CONTINUE
      RETURN
      END
C
	SUBROUTINE SEQUENCE(SEQ,ISEQ,N)
C
C  returns integer array ISEQ of indices for
C  N first values according to descending order
C  in real*4 array SEQ
C
	REAL     SEQ(N), T
	INTEGER  ISEQ(N),JSEQ(8)
C
	IF(N.GT.8) RETURN
	DO I=1,N
	  JSEQ(I)=0
	ENDDO
	DO J=1,N
	    T=-1.E10
	    DO I=1,N
		IF(JSEQ(I).EQ.0.AND.T.LT.SEQ(I)) THEN
		  T=SEQ(I)
		  ISEQ(J)=I
		ENDIF
	    ENDDO
	    JSEQ(ISEQ(J))=J
	ENDDO
	RETURN
	END

C @(#)getut.for	19.1 (ES0-DMD) 02/25/03 13:29:08
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
         SUBROUTINE GETUT (NLINE, UT)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT (c)
C.IDENT         getut.for
C.MODULE
C.AUTHOR        Andrew T. Young
C.KEYWORD
C.LANGUAGE      FORTRAN 77
C.PURPOSE       gets U.T. from a comment line LINE(NLINE), or returns -1
C.COMMENTS
C.VERSION       5.2
C.RETURNS
C.ENVIRONMENT
C.
C-----------------------------------------------------------------------------
C
C  BEGIN Declarations:
C
        IMPLICIT NONE
C
        INTEGER MXLINE
        PARAMETER(MXLINE=100)
        CHARACTER*80 LINE(MXLINE)
        COMMON /LINES/LINE
C
        INTEGER I, J, K,KMAX,KMIN,LASTCOL
        INTEGER MCOL
        INTEGER NCOL,NCOLON,NLINE,NOFF,NTIMES,NUTS,NLSTS
        REAL TIMES(5)
        REAL UT
        CHARACTER*4 TYPES(5), TSTRING*12
C
        PARAMETER (NUTS=9, NLSTS=9)
        CHARACTER*8 UTS(NUTS), LSTS(NLSTS), CARD*81, CHAR*1
        CHARACTER*12 FMT, DUM*80
C
C
        LOGICAL MATCH
        INTEGER LWORD
        REAL TIMER
C
C
C
C  END Declarations.
C
C
C  BEGIN DATA statements:
C
        DATA UTS/' UT=', ' UT =', ' U.T.=', ' U.T. =',
     1          'UT:', 'U.T.:', 'U.T.', 'UT', ' U T'/
        DATA LSTS/' LST=', ' LST =', ' L.S.T.=', 'L.S.T. =',
     1          'LST:', 'L.S.T.:', 'L.S.T.', 'LST', '.ST:'/
C
C  END DATA statements.
C
C *****************************************************************
C
C  Program begins here:
C
        CARD=' '//LINE(NLINE)
        DO 1 LASTCOL=81,2,-1
        IF (CARD(LASTCOL:LASTCOL).NE.' ') GO TO 2
    1   CONTINUE
C               empty card; quit.
        UT=-1.
        RETURN
C
    2   NTIMES=0
        TSTRING=' '
        NCOL=INDEX(CARD,' IS ')
        IF (NCOL.GT.0) CARD(NCOL:NCOL+3)='='
        DO 20 I=1,NUTS
        NCOL=INDEX(CARD,UTS(I)(:LWORD(UTS(I))))
        NOFF=1
    3   IF (NCOL.NE.0) THEN
C       key found. Look for time string:
                NCOL=NCOL+NOFF-1
C               start in col. AFTER key:
                MCOL=NCOL+LWORD(UTS(I))
                DO 8 J=MCOL,LASTCOL-3
                    CHAR=CARD(J:J)
C                   skip blanks:
                    IF (CHAR.EQ.' ') GO TO 8
                    IF (CHAR.GE.'0' .AND. CHAR.LE.'9') THEN
C                        digit found;
C                        look for reasonable string after key:
                        KMAX=MIN(J+12, LASTCOL)
                        DO 4 K=J+1,KMAX
                            CHAR=CARD(K:K)
                            IF((CHAR.GE.'0'.AND.CHAR.LE.'9') .OR.
     1                         CHAR.EQ.'H' .OR. CHAR.EQ.'M' .OR.
     2                         CHAR.EQ.'S' .OR. CHAR.EQ.':' .OR.
     3                         CHAR.EQ.' ' .OR. CHAR.EQ.'.') GO TO 4
C                           quit if unacceptable char:
                            GO TO 5
    4                   CONTINUE
                        K=KMAX+1
    5                   K=K-1
                        TSTRING=CARD(J:K)
                        NTIMES=NTIMES+1
                        TIMES(NTIMES)=TIMER(TSTRING)
                        IF (TIMES(NTIMES).EQ.-1.) THEN
                                NTIMES=NTIMES-1
                                GO TO 10
                        ELSE
                                TYPES(NTIMES)='UT'
                                GO TO 30
                        END IF
                    ELSE
C                       try next key.
                        IF (INDEX(UTS(I),'=').NE.0) GO TO 19
                        IF (INDEX(UTS(I),':').NE.0) GO TO 19
C                       digit not found; look BEFORE key if no "=" or ":".
                        GO TO 10
                    END IF
    8           CONTINUE
C
C               scan cols. BEFORE key:
   10           DO 18 J=NCOL-1,1,-1
                    CHAR=CARD(J:J)
C                   skip blanks:
                    IF (CHAR.EQ.' ') GO TO 18
C                       look for reasonable string before key:
                        KMIN=MAX(J-12, 1)
                        DO 14 K=J,KMIN,-1
                            CHAR=CARD(K:K)
                            IF((CHAR.GE.'0'.AND.CHAR.LE.'9') .OR.
     1                         CHAR.EQ.'H' .OR. CHAR.EQ.'M' .OR.
     2                         CHAR.EQ.'S' .OR. CHAR.EQ.':' .OR.
     3                         CHAR.EQ.' ' .OR. CHAR.EQ.'.') GO TO 14
C                       quit if unacceptable char:
                        GO TO 15
   14                   CONTINUE
                        K=KMIN-1
   15                   K=K+1
C                       trim leading blanks:
                        DO 16 K=K,J
                        IF (CARD(K:K).NE.' ') GO TO 17
   16                   CONTINUE
   17                   TSTRING=CARD(K:J)
                        NTIMES=NTIMES+1
                        TIMES(NTIMES)=TIMER(TSTRING)
                        IF (TIMES(NTIMES).EQ.-1.) THEN
                                NTIMES=NTIMES-1
                                GO TO 19
                        ELSE
                                TYPES(NTIMES)='UT'
                                GO TO 30
                        END IF
   18           CONTINUE
C
C               Not found; so see if key appears later:
C
   19           NOFF=NCOL+1
                NCOL=INDEX(CARD(NOFF:),UTS(I)(:LWORD(UTS(I))))
                IF (NCOL.NE.0) THEN
                        GO TO 3
                ELSE
                END IF
        END IF
   20   CONTINUE
C
C       Nothing found.  Try without keys:
C
        NCOLON=INDEX(CARD,':')
        NOFF=1
   22   IF (NCOLON.GT.0) THEN
                NCOLON=NCOLON+NOFF-1
                IF (CARD(NCOLON-1:NCOLON-1).GE.'0' .AND.
     1              CARD(NCOLON-1:NCOLON-1).LE.'9' .AND.
     2              CARD(NCOLON+2:NCOLON+2).GE.'0' .AND.
     3              CARD(NCOLON+2:NCOLON+2).LE.'9') THEN
C                       found a colon flanked by digits.
                        TSTRING=CARD(NCOLON-2:NCOLON+5)
                        NTIMES=NTIMES+1
                        TIMES(NTIMES)=TIMER(TSTRING)
C
                        IF (TIMES(NTIMES).EQ.-1.) THEN
                                NTIMES=NTIMES-1
                                GO TO 30
                        ELSE
   25                           CALL TV(LINE(NLINE))
                                WRITE(FMT,'(''('',I2,''X,A5)'')')
     1                               NCOLON-4
                                WRITE(DUM,FMT) '^^^^^'
                                CALL TVN(DUM)
                                CALL ASK('Is this UT?',CHAR)
                                IF (MATCH (CHAR,'Y')) THEN
                                        TYPES(NTIMES)='UT'
                                        GO TO 30
                                ELSE IF (CHAR.EQ.'N') THEN
                                        NTIMES=NTIMES-1
C                                       Look for another colon:
                                        NOFF=NCOLON+4
                                        NCOLON=INDEX(CARD(NOFF:),':')
                                        IF (NCOLON.NE.0) GO TO 22
                                ELSE
                                        CALL TV('Please reply Y or N.')
                                        GO TO 25
                                END IF
                        END IF
                ELSE
C                       Look for another colon:
                        NOFF=NCOLON+1
                        NCOLON=INDEX(CARD(NOFF:),':')
                        IF (NCOLON.NE.0) GO TO 22
                END IF
        END IF
   30   CONTINUE
C
C       Assess results:
C
        IF (NTIMES.EQ.1) THEN
                UT=TIMES(1)
        ELSE IF (NTIMES.EQ.0) THEN
                UT=-1.
        ELSE
C               compare times:
                UT=TIMES(1)
        END IF
C
C
C
C
        RETURN
        END
        REAL FUNCTION TIMER(TSTRING)
C
C       extracts time (hours) from tstring.
C
        IMPLICIT NONE
C
        CHARACTER TSTRING*12, FMT*9, SUBSTRING*8, FSEP*1, STR2*12
C
        INTEGER NH,NCOLON, NM,NS
C
        REAL HOURS, TMIN,SECS
C
        INTEGER LWORD
C
C
        IF (TSTRING(:1).EQ.'S' .OR. TSTRING(:1).EQ.':') THEN
C               trim leading junk:
                STR2=TSTRING(2:)
                IF (STR2(:1).EQ.' ') THEN
                        TSTRING=STR2(2:)
                ELSE
                        TSTRING=STR2
                END IF
        END IF
C       Trim trailing nulls:
        NM=INDEX(TSTRING,CHAR(0))
        IF (NM.NE.0) TSTRING(NM:)=' '
        NH=INDEX(TSTRING,'H')
        NCOLON=INDEX(TSTRING,':')
C
        IF (NCOLON.NE.0) THEN
                FSEP=':'
        ELSE
                FSEP=' '
        END IF
C
        IF (NH.EQ.0) THEN
C               delimited string (colons or blanks)
                NH=INDEX(TSTRING,FSEP)
                WRITE (FMT,'(''(BN,F'',I1,''.0)'')') NH-1
                READ (TSTRING(1:NH-1),FMT, ERR=99) HOURS
                IF (HOURS.GT.24.) GO TO 99
                IF (TSTRING(NH+1:NH+1).EQ.' ') NH=NH+1
                SUBSTRING=TSTRING(NH+1:)
                NM=INDEX(SUBSTRING,FSEP)
                IF (NM.EQ.0) NM=LWORD(SUBSTRING)+1
                WRITE (FMT,'(''(BN,F'',I1,''.0)'')') NM-1
                READ (SUBSTRING(1:NM-1),FMT, ERR=99) TMIN
                FMT=SUBSTRING(NM+1:)
                SUBSTRING=FMT
                NS=LWORD(SUBSTRING)
                IF (NS.NE.0) THEN
C                       seconds are present.
                        WRITE (FMT,'(''(BN,F'',I1,''.0)'')') NS
                        READ (SUBSTRING(1:NS),FMT, ERR=99) SECS
                ELSE
                        SECS=0.
                END IF
                TIMER=HOURS+(TMIN+SECS/60.)/60.
                RETURN
        ELSE
C               NOT a field-separator-delimited string; look for H M S
                NM=INDEX(TSTRING,'M')
                NS=INDEX(TSTRING,'S')
C               assume H M S separators
                WRITE (FMT,'(''(BN,F'',I1,''.0)'')') NH-1
                READ (TSTRING(1:NH-1),FMT, ERR=99) HOURS
                WRITE (FMT,'(''(BN,F'',I1,''.0)'')') NM-NH-1
                READ (TSTRING(NH+1:NM-1),FMT, ERR=99) TMIN
                IF (NS.NE.0) THEN
C                       seconds are present.
                        WRITE (FMT,'(''(BN,F'',I1,''.0)'')') NS-NM-1
                        READ (TSTRING(NM+1:NS-1),FMT, ERR=99) SECS
                ELSE
                        SECS=0.
                END IF
                TIMER=HOURS+(TMIN+SECS/60.)/60.
                RETURN
        END IF
C
C       Error:
C
   99   TIMER=-1.
        RETURN
        END
      SUBROUTINE GETJDC(NLINE,DJ)
C
C  GETS DP JULIAN DAY FROM EXTERNAL COMMON BLOCK
C
C       Copyright (C) Andrew T. Young, 1990
C       Copyright (C) European Southern Observatory, 1992
C
C
      IMPLICIT NONE
C
      INTEGER NLINE
      DOUBLE PRECISION DJ
C
        INTEGER MXLINE
        PARAMETER (MXLINE=100)
        CHARACTER*80 LINE(MXLINE)
        COMMON /LINES/ LINE
C
      INTEGER IDCOL,I,M,MCOL,MXBACK,NCOL,K,MEND
      REAL DDAY,Y
C
      INTEGER MON2M
      LOGICAL MATCH
C
      CHARACTER*3 MON, MONTHS(12), LMONTH(12)
      CHARACTER*20 DATSTR, CH*1
C
        DATA LMONTH/'Jan','Feb','Mar','Apr','May','Jun','Jul',
     1              'Aug','Sep','Oct','Nov','Dec'/
        DATA MONTHS/'JAN','FEB','MAR','APR','MAY','JUN','JUL',
     1              'AUG','SEP','OCT','NOV','DEC'/
C
C
C    MON is 1st 3 letters of month,  M is integer.
C    YEAR is full year,  Y is internal.
C
C
      DATSTR=' '
      IDCOL=INDEX(LINE(NLINE),'DATE')
      IF (IDCOL.EQ.0) IDCOL=INDEX(LINE(NLINE),'Date')
      IF (IDCOL.NE.0) THEN
           DO 1 I=IDCOL+4,80
C               skip over delimiters:
                IF (LINE(NLINE)(I:I).EQ.' ' .OR.
     1              LINE(NLINE)(I:I).EQ.'=' .OR.
     2              LINE(NLINE)(I:I).EQ.':') THEN
                        GO TO 1
                ELSE
C                       Date begins.
                        DATSTR=LINE(NLINE)(I:)
                        GO TO 2
                END IF
    1      CONTINUE
    2      CONTINUE
      ELSE
C       Look for month name:
        DO 5 M=1,12
                MCOL=INDEX(LINE(NLINE),MONTHS(M))
                IF (MCOL.EQ.0) MCOL=INDEX(LINE(NLINE),LMONTH(M))
                IF (MCOL.NE.0)THEN
                        NCOL=MCOL
                        MXBACK=MIN(6,MCOL-1)
C                       see if numbers precede month...
    4                   DATSTR=LINE(NLINE)(NCOL-MXBACK:)
                        IF (DATSTR(:1).GE.'0'.AND.DATSTR(:1).LE.'9')THEN
                                GO TO 6
                        ELSE
                                NCOL=NCOL+1
                                IF (NCOL-MXBACK.LE.MCOL) GO TO 4
                        END IF
                        GO TO 6
                END IF
    5   CONTINUE
C       month not found, either;quit.
        RETURN
C
    6   CONTINUE
C       Find end of month name:
        DO 8 K=6-NCOL+MCOL+4,20
        CH=DATSTR(K:K)
        IF ( (CH.GE.'A' .AND. CH.LE.'Z') .OR.
     1       (CH.GE.'a' .AND. CH.LE.'z') ) THEN
C               still in month...
                GO TO 8
        ELSE
                MEND=K
                GO TO 9
        END IF
    8   CONTINUE
        MEND=20+1
    9   CONTINUE
C       Now try to trim superfluous junk from end of string:
        IF (DATSTR(:1).GE.'0'.AND. DATSTR(:1).LE.'9') THEN
C               date string starts with digits; allow only 1 numerical field
                IF (CH.EQ.' ' .OR. CH.EQ.'.') MEND=MEND+1
                DO 10 K=MEND,20
                CH=DATSTR(K:K)
                IF ((CH.GE.'0'.AND.CH.LE.'9')) GO TO 10
                DATSTR(K:)=' '
                GO TO 11
   10           CONTINUE
        ELSE
C               date string starts with month; allow 2 fields
                IF (INDEX(DATSTR(MEND+1:),',').EQ.0) THEN
C                       no commas in date
                        MEND=INDEX(DATSTR(MEND+7:),' ')
                        IF (MEND.GT.0) DATSTR(MEND:)=' '
                ELSE
C                        commas in date
                        MEND=INDEX(DATSTR(MEND+8:),' ')
                        IF (MEND.GT.0) DATSTR(MEND:)=' '
                END IF
        END IF
   11   CONTINUE
      END IF
C
      IF(DATSTR.NE.' ')THEN
C         analyse date string to get date fields.
   17     CALL MDYC(DATSTR,MON,DDAY,Y)
C         (returns XXX in MON if it can't identify month)
          IF (MON.EQ.'XXX' .OR. DDAY.GT.32. .OR. DDAY.LT.0. .OR.
     1        Y.LT.0. .OR.
     2        (Y.LT.1800. .AND. Y.GT.99.) .OR. Y.GT.2100.) THEN
                IF (IDCOL.EQ.0) RETURN
                CALL TV ('Ambiguous date string found:')
   18           CALL TV(DATSTR)
                CALL ASK ('Does this contain a date?',MON)
                IF (MATCH(MON,'Y'))THEN
                        CALL TV ('Please enter it more clearly,')
                        CALL ASKN ('spelling month correctly:',DATSTR)
                        GO TO 17
                ELSE IF (MATCH(MON,'N'))THEN
                        RETURN
                ELSE
                        CALL TV('Please reply "y" or "n".')
                        GO TO 18
                END IF
          END IF
      ELSE
C         nothing found, so do nothing.
          RETURN
C
      END IF
C
C     Convert month name to integer:
      M=MON2M(MON)
C
C    CHECK YEAR.
      IF(Y.LT.100.) THEN
C           ...about 2048 AD you can remove the first branch, or else
C          nudge the "50" along every decade or so...
           IF (Y.GT.50.)THEN
C               assume no data before 1950:
                Y=Y+1900.
           ELSE
                Y=Y+2000.
           END IF
      END IF
C  J.D.: see SKY & TEL.61,312 (1981).
      IF(M.GT.2)GO TO 416
      M=M+12
      Y=Y-1
  416 DJ=AINT(365.25*Y) + AINT(30.6001*(M+1)) + DDAY + 1720981.5D0
C
      RETURN
      END
      SUBROUTINE MDYC(CDIN,MONTH,DAY,YEAR)
C
C       Copyright (C) Andrew T. Young, 1990
C       Copyright (C) European Southern Observatory, 1992
C
C  EXTRACTS 3-CHAR.MONTH, FLOATING DAY & YEAR FROM STRING CDIN.   3 JAN.87
C
C  (modified to handle ESO data cards, May 1992)
C
      IMPLICIT NONE
C
      CHARACTER*(*) CDIN
      CHARACTER CARD*80, MONTH*3, FIELD*5, CHAR
      INTEGER NEXT,LAST,LENCD,I,I1,J
      REAL DAY,YEAR
C
      INTEGER LWORD
C
    1 FORMAT(A4)
C    SET ILLEGAL VALUES TO FLAG ERROR RETURNS.
      MONTH='XXX'
      DAY=99.
      YEAR=-1.
      CARD=CDIN
      LENCD=LWORD(CARD)
C       skip leading blanks...
      DO 2 I=1,LENCD
      IF(CARD(I:I).NE.' ') GO TO 5
    2 CONTINUE
      RETURN
C
    4 FORMAT(BN,F4.0)
C
C  FIRST NON-BLANK...
    5 ASSIGN 25 TO NEXT
      ASSIGN 21 TO LAST
      IF(CARD(I:I).GT.'9' .OR. CARD(I:I).LT.'0') GO TO 14
C   FIRST FIELD NUMERIC, SO MONTH SECOND.
      I1=I
      DO 6 I=I,LENCD
      CHAR=CARD(I:I)
      IF(CHAR.GT.'9' .OR. CHAR.LT.'0') GO TO 10
    6 CONTINUE
      RETURN
C
C   FIRST FIELD ENDS AT (I-1), I NON-NUM.
   10 WRITE(FIELD,1) CARD(I1:I-1)
      IF(I-I1-3) 11,24,20
C    1ST FIELD IS DAY.
   11 READ(FIELD,4)DAY
      ASSIGN 18 TO LAST
C     MONTH STARTS W.LETTER.
   12 DO 13 I=I,LENCD
      CHAR=CARD(I:I)
      IF(CHAR.GE.'A' .AND. CHAR.LE.'Z') GO TO 14
   13 CONTINUE
      RETURN
C
C      GET MONTH.
   14 MONTH=CARD(I:I+2)
      I=I+3
C     FIND LAST NUMERIC FIELD.
   15 DO 16 I=I,LENCD
      CHAR=CARD(I:I)
      IF(CHAR.GE.'0' .AND. CHAR.LE.'9') GO TO LAST,(18,21)
   16 CONTINUE
      RETURN
C    YEAR LAST.
   18 J=I+3
      IF(CARD(I+2:J).EQ.'  ')J=I+1
      WRITE(FIELD,1) CARD(I:J)
      READ(FIELD,4,ERR=19)YEAR
   19 RETURN
C
C    YEAR FIRST.
   20 READ(FIELD,4,ERR=24)YEAR
      ASSIGN 24 TO NEXT
      GO TO 12
C     (TO DO MONTH.)
C
C    DAY LAST. ENDS AT NON-NUM.I1.
   21 DO 22 I1=I+1,LENCD
      CHAR=CARD(I1:I1)
      IF(CHAR.GT.'9' .OR. CHAR.LT.'0') GO TO 23
   22 CONTINUE
      RETURN
C
   23 WRITE(FIELD,1) CARD(I:I1-1)
      READ(FIELD,4,ERR=24) DAY
C     Ridiculous statement needed to fool idiot MIDAS preprocessor:
      IF(.TRUE.)GO TO NEXT,(24,25)
   24 RETURN
C
C     SKIP 2ND PART OF DOUBLE DATE.
   25 I=I1+1
      ASSIGN 18 TO LAST
      IF(CARD(I1:I1).NE.'/' .AND. CARD(I1:I1).NE.'-') GO TO 15
C     DOUBLE DATE.  SKIP TO SEPARATOR.
      I=INDEX(CARD(I1:I1+3),',')
      IF(I.EQ.0) I=INDEX(CARD(I1:I1+3),' ')
      IF(I.EQ.0) GO TO 24
      I=I+I1
      GO TO 15
      END
      REAL FUNCTION STUTZROT(DJ)
C
C  Sets STUTZ in fractional days for given Julian Date.
C
      IMPLICIT NONE
C
      DOUBLE PRECISION DJ, DSTUTZ
C
      REAL T,STUTZ
C
C
      T=(DJ-2451545.0D0)/36525.D0
      DSTUTZ=(24110.54841D0+T*(8640184.812866D0+T*(.093104-T*6.21E-6)))
     1 /86400.
      STUTZ=DSTUTZ-DINT(DSTUTZ)
      IF(STUTZ.LT.0.)STUTZ=STUTZ+1.
      STUTZROT=STUTZ
      RETURN
      END

C @(#)rankcorr.for	19.1 (ESO-DMD) 02/25/03 13:21:26
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  1 JUL 1989
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: M.PERON
C
C.IDENTIFICATION
C
C  Program RANKCORR
C
C.KEYWORDS
C
C KENDALL, SPEARMANN COEFFICIENT
C RANK CORRELATION
C.PURPOSE
C calculates the Spearman and Kendall rank correlation coefficients and 
C the significance level of the test
C
C 
C 010621		last modif
C 
C-----------------------------------------------------------
C
       PROGRAM RANKCORR
C 
       IMPLICIT NONE
C 
       REAL D,PROB,PROBD,PROBRS,TAU,Z,ZD,RS
C 
       INTEGER*8  ADDRIN(4)
C 
       INTEGER MADRID
       INTEGER PARVAL,NPAR,ISTAT,TID1,NCOL,NROW1,NACOL,NAROW,COL1,COL2
       INTEGER IAV,NREAL       
       INTEGER NSC,UNI,NULO,NBYTES,KUN
C 
       CHARACTER*80 INTAB
       CHARACTER*17 COLIND,COLDEP
       CHARACTER*80 OUTPUT1,OUTPUT2,OUTPUT3,OUT,OUTPUT0,OUTPUT4
       CHARACTER*1 ACTION
C 
       INCLUDE 'MID_INCLUDE:TABLES.INC'
       COMMON/VMR/MADRID(1)
C 
       INCLUDE 'MID_INCLUDE:TABLED.INC'
       DATA PARVAL/8/, TID1 /-1/
        DATA OUTPUT0
     1  /' Null Hypothesis: The two data sets are not associated'/
        DATA OUTPUT1
     1  /' Kendall Rank-Order coeff  '/
        DATA OUTPUT2
     1  /' Spearman Rank-Order coeff '/
        DATA OUTPUT3
     2  /'  ---------------------------------------------------------'/
        DATA OUTPUT4
     3  /'Probability of exceeding this value under the 
     4  Null Hypothesis'/
        
C 
        CALL STSPRO('RANKCORR')

c       get the parameters
        
        CALL TDPGET(PARVAL,NPAR,ISTAT)
        IF  (ISTAT.NE.0) GOTO 80
        INTAB = TPARBF(1)
        COLIND = TPARBF(2)
        COLDEP = TPARBF(3)

c       open the table

        CALL TBTOPN(INTAB,F_I_MODE,TID1,ISTAT)       
        IF(ISTAT.NE.0) GOTO 80
        CALL TBIGET(TID1,NCOL,NROW1,NSC,NACOL,NAROW,ISTAT)
        CALL TBCSER(TID1,COLIND,COL1,ISTAT)
         IF (COL1.LT.0) THEN
         CALL STTPUT('Column not found...',ISTAT)
          GOTO 80
        ENDIF
        CALL TBCSER(TID1,COLDEP,COL2,ISTAT)
        IF (COL2.LT.0) THEN
          CALL STTPUT('Column not found...',ISTAT)
          GOTO 80
        ENDIF

c       Choose between Kendall and Spearman

        CALL STKRDC('ACTION',1,1,1,IAV,ACTION,UNI,NULO,ISTAT)
        CALL UPCAS(ACTION,ACTION)


        IF (ACTION.EQ.'K')THEN                          !KEndall coeff
         NBYTES = 4*NROW1
         CALL TDMGET(NBYTES,ADDRIN(1),ISTAT)
         CALL TDMGET(NBYTES,ADDRIN(2),ISTAT)
         CALL TMAP2(TID1,NROW1,COL1,COL2,MADRID(ADDRIN(1)),
     1             MADRID(ADDRIN(2)),NREAL)

c        calculates the coefficient and the proba
         CALL KEND(MADRID(ADDRIN(1)),MADRID(ADDRIN(2)),NREAL,TAU,Z,PROB)
         WRITE(OUT,100)TAU
         CALL STTPUT(OUTPUT0,ISTAT)       
         CALL STTPUT(OUTPUT3,ISTAT)       
         CALL STTPUT(OUTPUT1,ISTAT)
         CALL STTPUT(OUT,ISTAT)     
         CALL STTPUT(OUTPUT3,ISTAT)
         CALL STTPUT(OUTPUT4,ISTAT)       
         CALL STTPUT(OUTPUT3,ISTAT)
         WRITE(OUT,100)PROB
         CALL STTPUT(OUT,ISTAT)        

c         write results in keyword

         CALL STKWRR('OUTPUTR',TAU,1,1,KUN,ISTAT)
         CALL STKWRR('OUTPUTR',Z,2,1,KUN,ISTAT)
         CALL STKWRR('OUTPUTR',PROB,3,1,KUN,ISTAT)

        ELSE                                          !Spearmann coeff

         NBYTES = 4*NROW1
         CALL TDMGET(NBYTES,ADDRIN(1),ISTAT)
         CALL TDMGET(NBYTES,ADDRIN(2),ISTAT)
         CALL TDMGET(NBYTES,ADDRIN(3),ISTAT)
         CALL TDMGET(NBYTES,ADDRIN(4),ISTAT)
         CALL TMAP2(TID1,NROW1,COL1,COL2,MADRID(ADDRIN(1)),
     1             MADRID(ADDRIN(2)),NREAL)

c        calculates the coefficient and the proba
         CALL SPEAR(MADRID(ADDRIN(1)),MADRID(ADDRIN(2)),NREAL,
     1        MADRID(ADDRIN(3)),MADRID(ADDRIN(4)),D,ZD,PROBD,RS,PROBRS)
         WRITE(OUT,100)RS
         CALL STTPUT(OUTPUT0,ISTAT)       
         CALL STTPUT(OUTPUT3,ISTAT)       
         CALL STTPUT(OUTPUT2,ISTAT)
         CALL STTPUT(OUT,ISTAT)     
         CALL STTPUT(OUTPUT3,ISTAT)
         CALL STTPUT(OUTPUT4,ISTAT)       
         WRITE(OUT,100)PROBRS
         CALL STTPUT(OUT,ISTAT)                
         CALL STTPUT(OUTPUT3,ISTAT)
c        write results in keyword

         CALL STKWRR('OUTPUTR',RS,1,1,KUN,ISTAT)
         CALL STKWRR('OUTPUTR',ZD,2,1,KUN,ISTAT)
         CALL STKWRR('OUTPUTR',PROBRS,3,1,KUN,ISTAT)          
        ENDIF
        CALL TBTCLO(TID1,ISTAT)

C       That's all

        CALL STSEPI
80      CONTINUE
100     FORMAT(1X,G15.7)
        END




       SUBROUTINE KEND(X,Y,N,TAU,Z,PROB)
       INTEGER IS,J,K,N1,N2,N
       REAL X(N),Y(N),TAU,Z,PROB,A1,A2,AA
       REAL VAR,ERFCC
       N1 = 0
       N2 = 0
       IS = 0
       DO 10 J = 1,N-1
             DO 20 K = J+1,N
                 A1 = X(J)-X(K)
                 A2 = Y(J)-Y(K)
                 AA = A1*A2
                 IF (AA.NE.0)THEN
                    N1 = N1+1
                    N2 = N2+1
                    IF (AA.GT.0.)THEN
                       IS = IS+1
                    ELSE
                        IS = IS-1
                     ENDIF
                 ELSE
                     IF (A1.NE.0.) N1 = N1+1
                    IF (A2.NE.0.) N2 = N2+1
                 ENDIF
20            CONTINUE
10      CONTINUE
       TAU = FLOAT(IS)/SQRT(FLOAT(N1)*FLOAT(N2))
       VAR = (4.*N+10.)/(9.*N*(N-1.))
       Z = TAU/SQRT(VAR)
       PROB = ERFCC(ABS(Z/SQRT(2.)))
       END       

       SUBROUTINE SPEAR(X,Y,N,WX,WY,D,ZD,PROBD,RS,PROBRS)
       INTEGER J,N
       REAL X(N),Y(N),WX(N),WY(N),D,ZD,PROBD,PROBRS,SF,SG,IRANKX(100)
       REAL IRANKY(100),RS,AVED,EN,EN3N,X2,Y2,VARD,BETAI,ERF
       REAL DF,T,FAC,RS1
       DO 10 J=1,N
          WX(J) = X(J)
          WY(J) = Y(J)
10       CONTINUE
       CALL INDEXX(N,X,WX)
       CALL CRANK(N,X,WX,IRANKX,SF)
       CALL INDEXX(N,Y,WY)
       CALL CRANK(N,Y,WY,IRANKY,SG)
       D=0.
       DO 20 J=1,N
          D = D+(IRANKX(J)-IRANKY(J))**2
20       CONTINUE
       EN = N
       EN3N = EN**3-EN
       AVED = EN3N/6.-(SF+SG)/12.
       FAC = (1.-SF/EN3N)*(1.-SG/EN3N)
       X2 = EN3N/12.-SF/12.
       Y2 = EN3N/12 -SG/12.
       RS = 0.5*(AVED-D)/SQRT(X2*Y2)
       VARD = ((EN-1.)*EN**2*(EN+1.)**2/36.)*FAC
       ZD = (D-AVED)/SQRT(VARD)
       PROBD = ERF(ABS(ZD))
       RS1 = (1.-(6./EN3N)*(D+0.5*(SF+SG)))/FAC
       T = RS*SQRT((EN-2.)/((1.+RS)*(1.-RS)))
       DF = EN-2
       PROBRS = BETAI(0.5*DF,0.5,DF/(DF+T**2))
       RETURN
       END

C @(#)gcurve.for	19.1 (ES0-DMD) 02/25/03 14:25:40
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM GCURVE
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT      (c) 1988 European Southern Observatory
C.IDENT          GCURVE
C.LANGUAGE       ESO-FOR
C.AUTHOR         Preben Grosbol (ESO-IPG)
C.KEYWORDS       Growth curve, photometry, galaxies
C.ENVIRONMENT    MIDAS
C.COMMENT        MIDAS command similar to the IHAP GCURVE command
C.PURPOSE        The command computes a growth curve for an object.
C.VERSION        1.0    1988-Sep-30 : Creation,      PJG
C---------------------------------------------------------------------
C
      IMPLICIT NONE
C
      CHARACTER*40  INAME,TNAME
      INTEGER       IAV,IERR,NX,NY,NA,N,I,ILAB
      INTEGER       NPIX(2),IDT,IDF,KUNIT(4),INULL
      INTEGER       IXF,IXL,IYF,IYL,I,I1,I2,NX,NY
      INTEGER       IDF,IDT,IMEM,IDX,IOFF
      REAL          CI,CP,SP,X,Y,XS,YS,DX,DY,XC,YC,XT,YT
      REAL          RL,R,SC,AMP,EL,ELIM,RQCNST
      REAL          POSI(2),PROJ(2),STEP(2),START(2),PARM(10)
      REAL          VMADD(1)
C
      COMMON /VMR/VMADD
C
      EQUIVALENCE (NX,NPIX(1)),(NY,NPIX(2))
      EQUIVALENCE (XS,START(1)),(YS,START(2))
      EQUIVALENCE (DX,STEP(1)),(DY,STEP(2))
      EQUIVALENCE (XC,POSI(1)),(YC,POSI(2))
C
      INCLUDE  'MID_REL_INCL:MIDAS_DEF.INC'
C
C     INITIATE MIDAS
C
      CALL STSPRO('GCURVE ',IERR)
C
C     READ FRAME NAME AND OPEN IT
C
      CALL STKRDC('IN_A ',1,1,40,IAV,INAME,KUNIT,INULL,IERR)
      CALL STFOPN(INAME,D_R4_FORMAT,0,1,IDF,IERR)
C
C     READ FRAME DESCRIPTORS
C
      CALL STDRDI(IDF,'NAXIS ',1,1,IVA,NA,KUNIT,INULL,IERR)
      IF (NA.NE.2 .OR. IERR.NE.0) THEN
         CALL STTPUT('WRONG IMAGE DIMENSION, MUST BE 2 ',IERR)
         GOTO 90000
      ENDIF
      CALL STDRDI(IDF,'NPIX ',1,2,IVA,NPIX,KUNIT,INULL,IERR)
      CALL STDRDR(IDF,'START ',1,2,IVA,START,KUNIT,INULL,IERR)
      CALL STDRDR(IDF,'STEP ',1,2,IVA,STEP,KUNIT,INULL,IERR)
C
C     READ PARAMETERS 
C
      CALL STKRDR('POSITION ',1,2,IAV,POSI,KUNIT,INULL,IERR)
      CALL STKRDR('PARM ',1,10,IAV,PARM,KUNIT,INULL,IERR)
      CALL STKRDR('ITERATION ',1,2,IAV,RITER,KUNIT,INULL,IERR)
C
C     INITIATE VARIABLES
C
      IYF = 1
      IYL = NY
      IXF = 1
      IXL = NX
C
C     READ AND INITIATE PROJECTION 
C
      CALL STKRDR('PROJECT ',1,2,IAV,PROJ,KUNIT,INULL,IERR)
      DTR = ATAN(1.0D0)/45.0D0
      CI = COS(DTR*PROJ(1))
      CP = COS(DTR*PROJ(2))
      SP = SIN(DTR*PROJ(2))
C
C     GET MEMORY AND INITIATE VARIABLES
C
      CALL STFCRE('DUMMY ',D_R4_FORMAT,F_X_MODE,1,NX,IMEM,IERR)
      CALL STFMAP(IMEM,F_X_MODE,1,NX,IVA,IDX,IERR)
      IOFF = NX*(IYF-1) + 1
C
C     GO THROUGH FRAME LINE BY LINE
C
      Y = YS - YC + (IYF-1)*DY
      I1 = IDX + IXF - 1
      I2 = IDX + IXL - 1
      DO 100, IY = IYF,IYL
         CALL STFGET(IDF,IOFF,NX,IVA,IDX,IERR)
         X = XS - XC + (IXF-1)*DX
         DO 300, I = I1,I2
            XT = SP*X - CP*Y
            YT = CI * (CP*X + SP*Y)
            R = SQRT(XT*XT + YT*YT)
            VMADD(I) = VMADD(I) + AMP*EXP(R*SC)
            X = X + DX
  300    CONTINUE
         Y = Y + DY
         CALL STFPUT(IDF,IOFF,NX,IVA,IDX,IERR)
         IOFF = IOFF + NX
  100 CONTINUE
C
C     FINISHED - EXIT
C
90000 CALL STFCLO(IDF,IERR)
      CALL STFCLO(IMEM,IERR)
      CALL STSEPI(IERR)
      END

C @(#)dtoi.for	19.1 (ES0-DMD) 02/25/03 13:31:22
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
	PROGRAM DTOI
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENT
C
C  program  DTOI			A. Lauberts     ESO	890711
C
C.KEYWORDS 
C
C  Density, intensity, calibrated Schmidt plates
C
C.PURPOSE
C
C  transform density D to intensity I according to the Llebaria formula
C
C	log I = C3*log(D-C1) + C4*log(C2-D) + C5
C
C  with calibration parameters C1 - C5 read from a one row table file
C
C.USAGE  MIDAS applic program
C	 execute as @@ DTOI P1 P2
C
C.PARAMETERS
C
C P1	FRAMEA	C*8	name of input image frame in PDS density units
C P2	TABLEC	C*8	name of table file with calibration parameters
C P3	FRAMEC	C*8	name of output image frame in calibrated intensity
C			scaled with sky background = 1
C
C.DESCRIPTORS (special attention)
C
C 	HISTORY C       checked for and appended with 'INTE' 
C 	O_TIME  R*8     year,month,day of PDS scan 
C			Note: Different prestanda before/after 1984.1.14
C			NOT automatically set by PDS; updated in COMSKY
C 	SKYBGR  R*4	array, computed in program COMSKY (mean and x,y terms,
C                   	4th element contains sky magnitude/20 micron aperture
C
C.RESTRICTIONS  Input digitized image in PDS units 
C		(new dynyamic range since 19841.14!)
C		Prepared by first running program COMSKY
C
C.COMMENTS  note that on output the 4th element in desc SKYBGR now contains
C	    sky mag/pixel !
C
C---------------------------------------------------------------------------
	IMPLICIT  INTEGER  (A-Z)
C
	COMMON/VMR/MADRID(1)
	CHARACTER*60     FRAMEA,FRAMEC,TABLEC
	CHARACTER*200    HISTORY
	CHARACTER*21     IDENTA
	CHARACTER*24     CUNITA
	INTEGER          NPIXA(2),COL(9),PNTRA,PNTRC
	REAL             STEPA(2),STARTA(2),SKY(4),CONST(9),ESO
	DOUBLE PRECISION TIME
	LOGICAL          NULL(9)
C
	DATA COL/1,2,3,4,5,6,7,8,9/
	PARAMETER NCOL=9
C
C  set up MIDAS environment 
C
	CALL SXSPRO('DTOI',STAT)
C
C  get keywords
C
	CALL SXKGET('IN_A','C',1,60,IAV,FRAMEA,STAT)
	CALL SXKGET('IN_B','C',1,60,IAV,TABLEC,STAT)
	CALL SXKGET('OUT_A','C',1,60,IAV,FRAMEC,STAT)
C
C  activate I/O images; note FRAMEC initially copy of FRAMEA
C
	CALL SXIGET(FRAMEA,'I',2,NAXISA,NPIXA,STARTA,STEPA,
     +              IDENTA,CUNITA,PNTRA,STAT)
	CALL SXIGET(FRAMEC,'IO',2,NAXISA,NPIXA,STARTA,STEPA,
     +              IDENTA,CUNITA,PNTRC,STAT)
C
C  get calibration parameters from table file, first row
C
	CALL TXTOPN(TABLEC,STAT)
	CALL TXRGET(TABLEC,'R',1,NCOL,COL,CONST,NULL,STAT)
C
C  read descriptors 
C
	CALL SXDGET(FRAMEA,'HISTORY','C',1,200,IAV,HISTORY,STAT)
	IF(INDEX(HISTORY,'DENSITY TO INTENSITY').NE.0) THEN
	  CALL SXTPUT(' ALREADY INTENSITY',STAT)
	  GOTO 999
	ENDIF
	CALL SXDGET(FRAMEA,'O_TIME','R*8',1,1,IAV,TIME,STAT)
	IF(TIME.GT.1983.5D0) THEN
	  MAXD=4096
	  SKY(1)=800.
	 ELSE
	  MAXD=1024
	  SKY(1)=200.
	ENDIF
	DO I=2,4
	  SKY(I)=0.
	ENDDO
	CALL SXDGET(FRAMEA,'SKYBGR','R',1,3,IAV,SKY,STAT)
C
	SIZE=NPIXA(1)*NPIXA(2)
C
C  do the D to I transformation
C
	CALL DENS(SIZE,MADRID(PNTRA),MADRID(PNTRC),CONST,SKY,MAXD)
C
	SKY(4)=SKY(4)-5.*ALOG10(STEPA(1)/20.)
	CALL SXDPUT(FRAMEC,'SKYBGR','R',SKY,1,4,STAT)
C  free data
999	CALL SXSEPI
	END
C
C
	SUBROUTINE DENS(NDIM,A,C,CONST,SKY,MAXD)
C
	REAL A(NDIM),C(NDIM),T(4096),CONST(9),SKY(4)
C
	F(X) = C3*ALOG10(X-C1) + C4*ALOG10(C2-X) + C5
C
	C1=CONST(2)
	C2=CONST(3)
	C3=CONST(4)
	C4=CONST(5)
	C5=CONST(6)
	D1=C1+.05
	D2=C2-.05
	IF(MAXD.EQ.4096) THEN
	  DI=0.00125
	 ELSE
	  DI=0.005
	ENDIF
	DO I=1,3
	  SKY(I)=SKY(I)*DI
	ENDDO
	FS=F(SKY(1))
C+
C  make look-up table to speed up transformation,
C  intensity in sky units
C-
       DO I=1,MAXD
	D = (I-1)*DI
	D = AMIN1(D2,AMAX1(D1,D))
	T(I) = 10.**(F(D)-FS)
       ENDDO
C
C  transform D to I
C
       DO N=1,NDIM
	C(N)=T(JINT(A(N)+1.))
       ENDDO
C
C  DIDD=dI/dD normalized to unit sky
C
	DIDD=(C3/(SKY(1)-C1)-C4/(C2-SKY(1)))/(10.**FS*ALOG(10.))
	SKY(1)=1.
	SKY(2)=SKY(2)*DIDD
	SKY(3)=SKY(3)*DIDD
	SKY(4)=CONST(7)-2.5*FS
	END
C

C @(#)plotree.for	19.1 (ES0-DMD) 02/25/03 13:27:33
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,TKLAB
C                                         all rights reserved
C.IDENTIFICATION: PLOTREE
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  12:54 - 16 NOV 1987
C.LANGUAGE: F77+ESOext
C.PURPOSE:  Plots table tree
C.AUTHOR:   J.D. Ponz, ESO Garching
C.NOTE:     PLOTTBL uses the plotting routines available in the plot library
C           which again uses the low level AGL routines.
C.VERSION:  860625 J.D. Ponz  creation
C.VERSION:  870515 R.H. Warmels  general update of code;  new plot library
C.VERSION:  880420 R.H. Warmels  addapted to portable version of MIDAS
C ---------------------------------------------------------------------
C
      PROGRAM      PLTTRE                   !  program PLTTRE   *** main body ***
C
      INTEGER      MADRID
      INTEGER      ILOG,PMODE,FMODE
      INTEGER      NCOLUM,NROW,INADD(5),COL(4),TID
      REAL         FRAME(8),SCALES(2)
      CHARACTER    XFRAME*4,YFRAME*4
      CHARACTER    TABLE*60,SEL*64
      CHARACTER    LABEL1*80,LABEL2*80,LABEL3*80,TEXT*80
      CHARACTER*16 LABEL(4),UNIT(4),OLAB
      CHARACTER*40 COLUMN(4)
C
      COMMON       /VMR/MADRID(1)
      INCLUDE      'MID_INCLUDE:PLTDEC.INC/NOLIST'
      INCLUDE      'MID_INCLUDE:TABLES.INC/NOLIST'
C
      INCLUDE      'MID_INCLUDE:PLTDAT.INC/NOLIST'
      INCLUDE      'MID_INCLUDE:TABLED.INC/NOLIST'
C
      DATA         SEL/' '/
      DATA         ILOG/0/
      DATA         NCOLUM/4/
      DATA         PMODE/0/
C
9000  FORMAT (I4)
C
C *** start executable code
      CALL STSPRO('PLOTTRE')                            !start comm. with MIDAS
      CALL STKRDI('PLISTAT',1,1,IAC,FMODE,KUN,KNUL,IST)      !get the plot mode
      CALL STKRDC('PLCSTAT',1,5,4,IAC,XFRAME,KUN,KNUL,IST)          !frame in x
      CALL STKRDC('PLCSTAT',1,9,4,IAC,YFRAME,KUN,KNUL,IST)          !frame in y
C
C *** read parameters
      CALL STKRDC('P1',1,1,60,ITBL,TABLE,KUN,KNUL,ISTAT)        !get table name
      IF (ISTAT.NE.0) THEN                    ! take action in case of trouble
          TEXT = '*** FATAL: Problems with table parameter '//TABLE
          CALL STTPUT(TEXT,ISTAT)
          CALL STSEPI                          !  stop communication with MIDAS
          STOP
      END IF
C
C *** read columns
      CALL STKRDC('P3',1,1,40,NCOL1,COLUMN(1),KUN,KNUL,ISTAT)   !  first column
      CALL STKRDC('P2',1,1,40,NCOL2,COLUMN(2),KUN,KNUL,ISTAT)  !  second column
      CALL STKRDC('P5',1,1,40,NCOL3,COLUMN(3),KUN,KNUL,ISTAT)   !  third column
      CALL STKRDC('P4',1,1,40,NCOL4,COLUMN(4),KUN,KNUL,ISTAT)   !  forth column
C
C *** this procedure read the table
      CALL TBTOPN(TABLE,F_I_MODE,TID,ISTAT)
      IF (ISTAT.NE.0) THEN                           ! problems during execution
          TEXT = '*** FATAL: Problems with opening table '//TABLE
          CALL STTPUT(TEXT,ISTAT)
          CALL STSEPI
          STOP
      END IF
C
      CALL TBIGET(TID,NCOL,NROW,NSC,NAC,NAR,ISTAT)      ! read table information
      IF (ISTAT.NE.0) THEN                           ! problems during execution
          TEXT = '*** FATAL: Problems with getting table info'
          CALL STTPUT(TEXT,ISTAT)
          CALL STSEPI
          STOP
      END IF
C
      IF (NROW.LE.0) THEN
          CALL STTPUT(' No points in the table ... ',ISTAT)
          CALL STSEPI
          STOP
      END IF
C
      CALL TDRSEL(TID,SEL,ISTAT)                            !  table selection
C
C *** get column adresses
      DO 10 I = 1,NCOLUM
          CALL TBCSER(TID,COLUMN(I),COL(I),ISTAT)              ! find column no.
          IF (ISTAT.NE.0) THEN                       ! problems during execution
             TEXT = '*** FATAL: Problems with finding column'
             CALL STTPUT(TEXT,ISTAT)
             CALL STSEPI
             STOP
          END IF

          IF (COL(I).EQ.-1) THEN                     ! problems during execution
             TEXT = '*** FATAL: Problems with finding column'
             CALL STTPUT(TEXT,ISTAT)
             CALL STSEPI
             STOP
          END IF
C
          CALL TBCMAP(TID,COL(I),INADD(I),ISTAT)             ! get column adress
          IF (ISTAT.NE.0) THEN                       ! problems during execution
             TEXT = '*** FATAL: Problems with mapping column'
             CALL STTPUT(TEXT,ISTAT)
             CALL STSEPI
             STOP
          END IF

          IF (COL(I).NE.0) THEN                                     ! read label
              CALL TBLGET(TID,COL(I),LABEL(I),ISTAT)
              IF (ISTAT.NE.0) THEN                   ! problems during execution
                 TEXT = '*** FATAL: Problems with reading column'
                 CALL STTPUT(TEXT,ISTAT)
                 CALL STSEPI
                 STOP
              END IF
C
              CALL TBUGET(TID,COL(I),UNIT(I),ISTAT)                !  read units
              IF (ISTAT.NE.0) THEN                   ! problems during execution
                 TEXT = '*** FATAL: Problems with reading units'
                 CALL STTPUT(TEXT,ISTAT)
                 CALL STSEPI
                 STOP
              END IF
          END IF
   10 CONTINUE
C
      CALL TBCMAP(TID,0,INADD(5),ISTAT)              !  select mask of the table
      IF (ISTAT.NE.0) THEN                           ! problems during execution
         TEXT = '*** FATAL: Problems with the table selection'
         CALL STTPUT(TEXT,ISTAT)
         CALL STSEPI
         STOP
      END IF
C
C ... set up labels
      OLAB   = 'COLUMN '
      IF (LABEL(1) (1:2).EQ.'  ') THEN
         WRITE (OLAB(7:10),9000) COL(1)
      ELSE
         OLAB   = LABEL(1)
      END IF
      LABEL1 = OLAB
      LABEL1(31:50) = ' ('//UNIT(1)//')'
C
C *** the y axis
      OLAB   = 'COLUMN '
      IF (LABEL(2) (1:2).EQ.'  ') THEN
         WRITE (OLAB(7:10),9000) COL(2)
      ELSE
         OLAB   = LABEL(2)
      END IF
      LABEL2 = OLAB
      LABEL2(31:50) = ' ('//UNIT(2)//')'
C
C *** get the scales
      CALL STKRDR('INPUTR',1,2,NVAL,SCALES,KUN,KNUL,ISTAT)
      SCALES(1) = ABS(SCALES(1))
      SCALES(2) = ABS(SCALES(2))
      CALL STKWRR('PLRSTAT',SCALES,19,2,KUN,ISTAT)
C
C *** calculate frame
      IF (XFRAME(1:4).EQ.'MANU') THEN                            !  man. scaling
         CALL STKRDR('PLRSTAT',11,4,NVAL,FRAME,KUN,KNUL,ISTAT) !  get frame par.
      ELSE                                                       !  auto scaling
         XFRAME = 'AUTO'
         CALL TDMXRS(NROW,MADRID(INADD(2)),MADRID(INADD(5)),  !  min and max
     +               ILOG,XMIN1,XMAX1)
         CALL TDMXRS(NROW,MADRID(INADD(4)),MADRID(INADD(5)),  !  min and max
     +               ILOG,XMIN2,XMAX2)
         FRAME(1) = MIN(XMIN1,XMIN2)
         FRAME(2) = MAX(XMAX1,XMAX2)
         IF (FRAME(1).EQ.FRAME(2)) THEN
            FRAME(2) = FRAME(1) + 1.
         END IF
      END IF
C
      IF (YFRAME(1:4).EQ.'MANU') THEN                            !  man. scaling
         CALL STKRDR('PLRSTAT',15,4,NVAL,FRAME(5),KUN,KNUL,ISTAT)   !  get frame
      ELSE                                                       !  auto scaling
         YFRAME = 'AUTO'
         CALL TDMXRS(NROW,MADRID(INADD(1)),MADRID(INADD(5)),  !  min and max
     +               ILOG,YMIN1,YMAX1)
         CALL TDMXRS(NROW,MADRID(INADD(3)),MADRID(INADD(5)),  !  min and max
     +               ILOG,YMIN2,YMAX2)
         FRAME(5) = MIN(YMIN1,YMIN2)
         FRAME(6) = MAX(YMAX1,YMAX2)
         IF (FRAME(5).EQ.FRAME(6)) THEN
             FRAME(6) = FRAME(5) + 1
         END IF
      END IF
C
C *** get the scales
      CALL GETFRM(FRAME(1),FRAME(2),FRAME(3),FRAME(4),XFRAME)
      CALL GETFRM(FRAME(5),FRAME(6),FRAME(7),FRAME(8),YFRAME)
      CALL STKWRR('PLRSTAT',FRAME,11,8,KUN,ISTAT)
C
C *** do the plot setup
      CALL PLOPN(TABLE,PMODE,FMODE)
C
C *** do the work
      CALL PLTRE(NCOLUM,MADRID(INADD(1)),MADRID(INADD(2)),
     2           MADRID(INADD(3)),MADRID(INADD(4)),MADRID(INADD(5)),
     3           NROW)
C
      IF (FMODE.GE.1) THEN
         CALL PLFRAM(FRAME(1),FRAME(2),FRAME(3),FRAME(4),
     2               FRAME(5),FRAME(6),FRAME(7),FRAME(8))
         IF (PMODE.EQ.1 .OR. PMODE.EQ.3) THEN
            LABEL3 = 'Table: '//TABLE
            CALL PLLABL(LABEL2,LABEL1,LABEL3,SEL)

          ELSE
            CALL PLLABL(LABEL1,LABEL2,' ',' ')
            CALL PLTREI(TABLE,COLUMN(2),COLUMN(1),COLUMN(4),
     2                  COLUMN(3),SEL)
         END IF
      END IF
C
C *** good bye and finish
      CALL TBTCLO(TID,ISTAT)
      CALL PLCLS
      CALL STSEPI                            !  stop communication with MIDAS
      END


      SUBROUTINE PLTRE(NCOLUM,V1,V2,V3,V4,V5,NROW)                              
C+++                                                                            
C.PURPOSE:        Low level routine to plot a table treee                       
C.AUTHOR:         Rein H. Warmels                                               
C.VERSION:        86???? JDP Creation                                           
C.VERSION:        860625 RHW new routine based on Daniel's work                 
C.VERSION:        861216 RHW inclusion of neg. increments                       
C.VERSION:        87???? RHW restructure of code
C.VERSION:        890118 RHW ST interfaces implemented
C.COMMENTS:       none                                                          
C---                                                                            
      INTEGER     NCOLUM            ! # of columns to be plotted                
      REAL        V1(NROW)          ! adress of first column to be plotted     
      REAL        V2(NROW)          ! adress of second column to be plotted    
      REAL        V3(NROW)          ! adress of third column to be plotted     
      REAL        V4(NROW)          ! adress of fourth column to be plotted    
      REAL        V5(NROW)          ! adress                                   
      INTEGER     NROW              ! number of row                             
C                                                                               
      INTEGER     TINULL                                                 
      REAL        XX(2),YY(2)                                                   
      REAL        TBLSEL, TRNULL                                                
      DOUBLE PRECISION TDNULL, TDTRUE, TDFALS                                   
      LOGICAL     IPLOT                                                         
C                                                                               
      INCLUDE     'MID_INCLUDE:TABLES.INC/NOLIST'                               
      INCLUDE     'MID_INCLUDE:PLTDEC.INC/NOLIST'                               
      COMMON      /VMR/MADRID(1)                                                
      INCLUDE     'MID_INCLUDE:TABLED.INC/NOLIST'                               
C                                                                               
C *** get machine constants                                                     
      CALL TBMNUL(TINULL, TRNULL, TDNULL)                                       
      CALL TBMCON(TBLSEL, TDTRUE, TDFALS)                                       
C                                                                               
C *** do the work
      DO 10 I = 1,NROW                                                          
         IPLOT  = .TRUE.                                                        
         IF (V5(I).EQ.TBLSEL) THEN                                              
            YY(1)  = V1(I)                                                     
            IF (YY(1).EQ.TRNULL) IPLOT  = .FALSE.                              
            XX(1)  = V2(I)                                                     
            IF (XX(1).EQ.TRNULL) IPLOT  = .FALSE.                              
            YY(2)  = V3(I)                                                     
            IF (YY(2).EQ.TRNULL) IPLOT  = .FALSE.                              
            XX(2)  = V4(I)                                                     
            IF (XX(2).EQ.TRNULL) IPLOT  = .FALSE.                              
            IF (IPLOT) THEN                                                    
               CALL PLLINW(XX,YY,2)                                      
            END IF                                                             
         END IF                                                                
   10 CONTINUE                                                                  
C                                                                               
      RETURN                                                                    
      END                                                                       

      SUBROUTINE PLTREI(FILE,COL1,COL2,COL3,COL4,SEL)                           
C+++                                                                            
C.PURPOSE:        Produce plot information for a table tree plot                
C.AUTHOR:         Rein H. Warmels                                               
C.COMMENTS:       none                                                          
C.VERSION:        880420  RHW  Update for portable MIDAS                        
C.VERSION:        890118  RHW  ST interfaces implemented
C.COMMENTS:       none
C---                                                                            
      CHARACTER*(*) FILE                             !name of the table         
      CHARACTER*(*) COL1                             !name of x column          
      CHARACTER*(*) COL2                             !name of x column          
      CHARACTER*(*) COL3                             !name of x column          
      CHARACTER*(*) COL4                             !name of y column          
      CHARACTER*(*) SEL                              !selection string          
C                                                                               
      CHARACTER     BUF*80                                                      
      CHARACTER     NUMB5*10,NUMB6*10                                           
      REAL          SCALES(2)                                                   
      REAL          XL(3),YL(3)
      INCLUDE       'MID_INCLUDE:PLTDEC.INC/NOLIST'                             
C                                                                              
 9010 FORMAT (G10.3)                                                            
C
C ***
      X1     = GX2 + 0.01                                                       
      X2     = 1.0                                                              
      Y1     = 0.0                                                              
      Y2     = GY2                                                              
      CALL AGSSET('LINX')                                                       
      CALL AGSSET('LINY')                                                       
      CALL AGCDEF(X1,X2,Y1,Y2)                                                  
      CALL AGWDEF(0.0,1.0,0.0,1.0)                                              
C                                                                               
      CALL PLLOGI(XT,YT)                                  ! plot the MIDAS LOGO
C
C *** get character size
      CALL AGTGET('M',XL,YL)
      YH = 2.0*YL(2)
C
C *** table name                                                                
      BUF    = 'Table:'                                                         
      CALL LENBUF(BUF,L)                                                        
      CALL AGGTXT(XT,YT,BUF(1:L),1)                                             
      YT  = YT - YH                                                            
      BUF    = FILE                                                             
      CALL LENBUF(BUF,L)                                                        
      CALL AGGTXT(XT,YT,BUF(1:L),1)                                             
C                                                                               
C *** columns                                                                   
      YT  = YT - 2*YH                                                          
      BUF    = 'Columns: '                                                      
      CALL LENBUF(BUF,L)                                                        
      CALL AGGTXT(XT,YT,BUF(1:L),1)                                             
      YT  = YT - YH                                                            
      BUF    = 'X1: '//COL1                                                     
      CALL LENBUF(BUF,L)                                                        
      CALL AGGTXT(XT,YT,BUF(1:L),1)                                             
      YT  = YT - YH                                                            
      BUF    = 'Y1: '//COL2                                                     
      CALL LENBUF(BUF,L)                                                        
      CALL AGGTXT(XT,YT,BUF(1:L),1)                                             
      YT  = YT - YH                                                            
      BUF    = 'X2: '//COL3                                                     
      CALL LENBUF(BUF,L)                                                        
      CALL AGGTXT(XT,YT,BUF(1:L),1)                                             
      YT  = YT - YH                                                            
      BUF    = 'Y2: '//COL4                                                     
      CALL LENBUF(BUF,L)                                                        
      CALL AGGTXT(XT,YT,BUF(1:L),1)                                             
C                                                                               
C *** scales                                                                    
      YT  = YT - 2*YH                                                          
      BUF    = 'Scales: '                                                       
      CALL LENBUF(BUF,L)                                                        
      CALL AGGTXT(XT,YT,BUF(1:L),1)                                             
      YT  = YT - YH                                                            
      NUMB5  = '          '                                                     
      NUMB6  = '          '                                                     
      CALL STKRDR('PLRSTAT',19,2,IAC,SCALES,KUN,KNUL,IST)
      WRITE (NUMB5(1:10),9010) SCALES(1)                                        
      WRITE (NUMB6(1:10),9010) SCALES(2)                                        
      BUF    = 'X: '//NUMB5                                                     
      CALL LENBUF(BUF,L)                                                        
      CALL AGGTXT(XT,YT,BUF(1:L),1)                                             
      YT  = YT - YH                                                            
      BUF    = 'Y: '//NUMB6                                                     
      CALL LENBUF(BUF,L)                                                        
      CALL AGGTXT(XT,YT,BUF(1:L),1)                                             
C                                                                               
C *** selection                                                                 
      YT  = YT - 2*YH                                                          
      BUF    = 'Selection:'                                                     
      CALL LENBUF(BUF,L)                                                        
      CALL AGGTXT(XT,YT,BUF(1:L),1)                                             
C                                                                               
      IF ((SEL(1:1).EQ.'-') .OR. (SEL(1:1).EQ.' ')) THEN         !  no selection
         BUF    = 'all'                                                         
         CALL LENBUF(BUF,L)                                                     
         YT  = YT - YH                                                         
         CALL AGGTXT(XT,YT,BUF(1:L),1)                                          
                                                                                
      ELSE                                                                      
         ISTART = 1                                                             
   10    CONTINUE                                          !  check for logicals
         IDXOR  = INDEX(SEL(ISTART:),'.OR.')                                    
         IF (IDXOR.NE.0) THEN                                                   
            IDXOR  = ISTART + IDXOR + 2                                         
         ELSE                                                                   
            IDXOR  = 999                                                        
         END IF                                                                 
                                                                                
         IDXAND = INDEX(SEL(ISTART:),'.AND.')                                   
         IF (IDXAND.NE.0) THEN                                                  
            IDXAND = ISTART + IDXAND + 3                                        
         ELSE                                                                   
            IDXAND = 999                                                        
         END IF                                                                 
                                                                                
         IEND   = MIN(IDXOR,IDXAND)                                             
         IF (IEND.EQ.999) THEN                       !  no logicals in selection
            CALL LENBUF(SEL(ISTART:),LSEL)         !  length of the whole string
            NLINE  = LSEL/20                           !  number of lines needed
            NREST  = LSEL - NLINE*20           !  number of remaining characters
            DO 20 I = 1,NLINE                              !  loop through lines
               IS     = ISTART + (I-1)*20                         !  start index
               IE     = IS + 19                                     !  end index
               BUF    = SEL(IS:IE)                            !  store in buffer
               CALL LENBUF(BUF,L)                  !  length of string in buffer
               YT  = YT - YH                                                   
               CALL AGGTXT(XT,YT,BUF(1:L),1)                         !  put text
   20       CONTINUE                                                 !  end loop
                                                                                
            BUF    = SEL(ISTART+NLINE*20:)                                      
            CALL LENBUF(BUF,L)                               !  length of buffer
            YT  = YT - YH                                                      
            CALL AGGTXT(XT,YT,BUF(1:L),1)                        !  put the text
            GO TO 40                                                            
                                                                                
         ELSE                                     !  selection includes logicals
            CALL LENBUF(SEL(ISTART:IEND),L)              !  length of the buffer
            NLINE  = L/20                                !  number of full lines
            NREST  = L - NLINE*20              !  number of remaining characters
            DO 30 I = 1,NLINE                              !  loop through lines
               IS     = ISTART + (I-1)*20                         !  start index
               IE     = IS + 19                                     !  end index
               BUF    = SEL(IS:IE)                                !  fill buffer
               CALL LENBUF(BUF,L)                            !  length of buffer
               YT  = YT - YH                                                   
               CALL AGGTXT(XT,YT,BUF(1:L),1)                     !  put the text
   30       CONTINUE                                              !  end of loop
                                                                                
            BUF    = SEL(ISTART+NLINE*20:IEND)                                  
            CALL LENBUF(BUF,L)                               !  length of buffer
            YT  = YT - YH                                                      
            CALL AGGTXT(XT,YT,BUF(1:L),1)                        !  put the text
            ISTART = IEND + 1                           !  determine next string
            GO TO 10                                                            
         END IF                                                                 
      END IF                                                                    
                                                                                
   40 CONTINUE 
C
      YT = YT - 2.0*YH
      CALL PLDATI(XT,YT)                                          
      RETURN                                                                    
      END                                                                       

C @(#)mean.for	19.1 (ES0-DMD) 02/25/03 13:25:35
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine MEAN           version 2         810727
C  A. Kruszewski             ESO - Garching
C.PURPOSE
C  calculates mean value "AMEAN" and sigma "SIGMA" of random
C  variable basing on a sample presented in form of an array
C.INPUT/OUTPUT
C  input arguments
C  A           real*4 array        data array
C  N           integer*4           number of values in "A"
C  output arguments
C  AMEAN       real*4              mean of data in "A"
C  SIGMA       real*4              sigma of data in "A"
C-----------------------------------------------------------------------
      SUBROUTINE MEAN(A,N,AMEAN,SIGMA)
C
      IMPLICIT  NONE
      INTEGER   N
      REAL      A(N)
      REAL      AMEAN
      REAL      SIGMA
C
      INTEGER   K
      REAL      SUM
      REAL      SSUM
      REAL      X
C
C
      SUM=0.0
      SSUM=0.0
C
C *** Calculates mean and sigma.
C
      DO 10 K=1,N
         SUM=SUM+A(K)
         SSUM=SSUM+A(K)*A(K)
10    CONTINUE
      AMEAN=SUM/N
      SSUM=SSUM/N
      X=AMEAN
         SSUM=SSUM-X*X
C
C *** Checks if "SSUM" is positive.
C
      IF (SSUM.GT.0.00001) THEN
         SIGMA=SQRT(SSUM*(N/FLOAT(N-1)))
      ELSE
         SIGMA=0.0
      END IF
      RETURN
      END 

C @(#)tdscale.for	19.1 (ES0-DMD) 02/25/03 14:11:20
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  18:30 - 11 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION        TDSCALE.FOR
C.KEYWORDS           TABLE, APPLICATIONS
C.ENVIRONMENT  MIDAS
C.PURPOSE
C  FINDS NICE LIMITS, DISTANCE BETWEEN TICS AND NUMBER OF TIC MARKS
C  FOR PLOTTING AND OTHER DISPLAY PURPOSES.
C
C
C------------------------------------------------------------------
      SUBROUTINE TDSCAL(DMIN,DMAX,SCAL,XLOW,XUPP,ID,DTIC,NLAB)
      IMPLICIT NONE
      REAL DMIN  !   IN : minimum value
      REAL DMAX  !   IN : maximum value
      REAL SCAL  !   IN : scaling factor
      REAL XLOW  !   OUT: mantisa of lower limit 
      REAL XUPP  !   OUT: mantisa of upper limit
      INTEGER ID  !   OUT: exponent of XLOW and XUPP
      REAL DTIC  !   OUT: distance between tic marks
      INTEGER NLAB   ! OUT : number of tic marks
C
      REAL DELTA,XMIN,XMAX,XDIF
      REAL OFFSET,SCALE,POTFAC
      REAL RLMIN,RLMAX
      INTEGER LMIN,LMAX,LDIF
      DATA DELTA/0.00001/
C
      NLAB   = -1
      XMIN   = MIN(DMIN,DMAX)
      XMAX   = MAX(DMIN,DMAX)
      SCALE  = SCAL
      IF (DMIN.GT.DMAX) SCALE  = -SCALE
      IF (XMIN.EQ.XMAX .OR. SCALE.EQ.0.) RETURN
      XDIF   = XMAX - XMIN
      OFFSET = XDIF/ABS(SCALE*2.0) - 0.5*XDIF
      XMIN   = XMIN - OFFSET
      XMAX   = XMAX + OFFSET
      POTFAC = ALOG10(XDIF/2.0)
      IF (POTFAC.LT.0.) POTFAC = POTFAC - 1.0 + DELTA
      ID     = INT(POTFAC)
      POTFAC = 10.0**ID
      RLMIN  = XMIN/POTFAC
      IF (RLMIN.LT.0.) RLMIN  = RLMIN - 1.0 + DELTA
      LMIN   = INT(RLMIN)
      RLMAX  = XMAX/POTFAC + 1.0 - DELTA
      IF (RLMAX.LT.0.) RLMAX  = RLMAX - 1.0 + DELTA
      LMAX   = INT(RLMAX)
      LDIF   = LMAX - LMIN
      IF (LDIF.GT.5) GO TO 10
      DTIC   = 0.2
      NLAB   = 5
      GO TO 30

   10 IF (LDIF.GT.10) GO TO 20
      IF (LMIN.LT.0) LMIN   = LMIN - 1
      LMIN   = (LMIN/2)*2
      IF (LMAX.LT.0) LMAX   = LMAX - 1
      LMAX   = (LMAX/2+1)*2
      DTIC   = 0.5
      NLAB   = 4
      GO TO 30

   20 IF (LMIN.LT.0) LMIN   = LMIN - 4
      LMIN   = INT(LMIN/5)*5
      IF (LMAX.LT.0) LMAX   = LMAX - 4
      LMAX   = INT((LMAX+4)/5)*5
      DTIC   = 1.0
      NLAB   = 5
   30 IF (SCALE.LT.0) GO TO 40
      XLOW   = LMIN - DTIC
      XUPP   = LMAX + DTIC
      DTIC   = POTFAC*DTIC
      RETURN

   40 CONTINUE
      XLOW   = LMAX + DTIC
      XUPP   = LMIN - DTIC
      DTIC   = -POTFAC*DTIC
      RETURN

      END

C @(#)alint.for	19.1 (ES0-DMD) 02/25/03 13:19:38
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      REAL FUNCTION ALINT(X,Y,N,ARG,N1,N2)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.PURPOSE: linear interpolation over a range in values
C.VERSION: 910115 RHW IMPLICIT NONE added
C-------------------------------------------------------------------
      IMPLICIT          NONE
      INTEGER           N
      REAL              X(N)
      REAL              Y(N)
      REAL              ARG
      INTEGER           N1
      INTEGER           N2
C
      INTEGER           I, I0, I1
      DOUBLE PRECISION  DX0,DX1,DY0,DY1
      DOUBLE PRECISION  DARG
C
C *** Select effective interval
      DO 10 I = N1,N2
         I1 = I
         IF (X(I1).GT.ARG) THEN
            GOTO 2
         ENDIF
  10  CONTINUE
C
   2  CONTINUE
      IF (I1.EQ.N1) THEN
         I1 = I1 + 1
      ENDIF
C
C  2  CONTINUE
      I0    = I1 - 1
      DX0   = X(I0)
      DX1   = X(I1)
      DY0   = Y(I0)
      DY1   = Y(I1)
      DARG  = ARG
      ALINT = DY0+(DY1-DY0)*(DARG-DX0)/(DX1-DX0)

      RETURN
      END

      

      REAL FUNCTION AITKEN(X,Y,N,ARG,N1,N2,IDEG)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.PURPOSE: Polynomial interpolation
C.VERSION: 910115 RHW IMPLICIT NONE added
C-------------------------------------------------------------------
      IMPLICIT          NONE
      INTEGER           N
      REAL              X(N)
      REAL              Y(N)
      REAL             	ARG
      INTEGER           N1
      INTEGER           N2
      INTEGER           IDEG
C
      INTEGER           I, ID, IP
      INTEGER           J
      INTEGER           K
      INTEGER           NE, NS
C
      DOUBLE PRECISION  DA
      DOUBLE PRECISION  DX(10),DY(10)
C
      DA = ARG
      DO 10 I = N1,N2-1
         IP = I + 1
         IF (ARG.GE.X(I).AND.ARG.LT.X(IP)) THEN
            GOTO 2
         ENDIF
   10 CONTINUE
C
2     NS = MAX(N1,IP-IDEG+1)
      NE = NS + IDEG
      IF (NE.LE.N2) THEN
         GOTO 3
      ENDIF  
      NE = N2
      NS = NE - IDEG
C
3     ID = 0
      DO 20 K = NS,NE
         ID = ID + 1
         DX(ID) = X(K)
         DY(ID) = Y(K)
  20  CONTINUE
C
      DO 30 I = 1,ID
         DO 40 J = I,ID
            DY(J+1) = DY(I) + (DA-DX(I))*(DY(J+1)-DY(I))/(DX(J+1)-DX(I))
  40     CONTINUE
  30  CONTINUE
      AITKEN = DY(ID+1) 

      RETURN
      END

C @(#)igauss.for	19.1 (ES0-DMD) 02/25/03 13:17:39
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE IGAUSS(INDEP,X,NP,PARAM,Y1,DERIV)                              
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                  
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  18:01 - 21 DEC 1987                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C--------------------------------------------------------------                 
C***************************************************                            
C  FIT WITH AN INTEGRATED GAUSSIAN                                              
C      IMPLICIT NONE                                                            
C***************************************************                            
C                                                                               
C  Y1 = P(1) * INTEGRAL [ EXP(-LN(2)*(2*(X-P(2))/P(3))**2) ]                    
C              from -infinity to X                                              
C                                                                               
C***************************************************                            
C                                                                               
C Authors: M. Rosa and O.-G. Richter, ESO Garching                              
C                                                                               
      INTEGER INDEP,NP
      REAL X(INDEP)                                                        
      DOUBLE PRECISION Y1,PARAM(NP),DERIV(NP)                                   
      DOUBLE PRECISION A,A2,A3                                                  
      DOUBLE PRECISION ERF                                                      
C                                                                               
      A      = 2.0D0* (X(1)-PARAM(2))/PARAM(3)                                  
      A2     = A*8.32554611D-1                                                  
      A3     = A2*A2                                                            
      DERIV(1) = PARAM(3)*1.064467019D0*ERF(A2*1.414213562D0)                   
      Y1     = DERIV(1)*PARAM(1)                                                
      DERIV(2) = -PARAM(1)*DEXP(-A3)                                            
      DERIV(3) = Y1/PARAM(3) + DERIV(2)*A*0.5D0                                 
      RETURN                                                                    
                                                                                
      END                                                                       

C @(#)tsawdt.for	19.1 (ESO-DMD) 02/25/03 13:33:26
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT (c) 1992 European Southern Observatory & Copernicus Astron. Center
C.IDENT     tsawdt.for
C.AUTHOR    Alex Schwarzenberg-Czerny, Copernicus Astron. Center, Warsaw
C.KEYWORD   MIDAS, time series analysis, WIDTH/TIME
C.LANGUAGE  FORTRAN 77
C.PURPOSE   Evaluate width of a spectral line
C.VERSION   0.0               June 1992
C.RETURNS   None
C.ENVIRON   TSA context
C 
C 010625		last modif
C 
C-----------------------------------------------------------------------------
C
C
      PROGRAM TSAWDT
C 
      INCLUDE 'MID_REL_INCL:TSA_DEF.INC'
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      INTEGER      NAXIS,NVALUES
      PARAMETER   (NAXIS=2,NVALUES=5)
      INTEGER      NSTEPS(NAXIS),IBUF(5)
      INTEGER      IACTS,KNUL,KUN,IFLAG,ITYP,IAXIS
      INTEGER      IWORK,IPER
      INTEGER*8      PPER,PWORK
C 
      DOUBLE PRECISION       BANDW                !  INPUT BAND WIDTH
      DOUBLE PRECISION       BANDC                !  INPUT BAND CENTRE
      DOUBLE PRECISION       START(NAXIS),STEP(NAXIS)
      DOUBLE PRECISION       WIDTH(NVALUES,2)
C
      CHARACTER*60 IDENT
      CHARACTER*60 INAME                !  NAME OF INPUT FRAME
      CHARACTER*64 CUNIT
C
C
      INCLUDE 'MID_REL_INCL:TSA_DAT.INC'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C
C   Get parameters
C
      CALL STSPRO ('tsawdt')
      CALL STKRDC ('IN_A', 1,1,60,IACTS,INAME,KUN,KNUL,ISTAT)
      CALL STKRDD ('WIDTH',  1,1, IACTS,BANDW,KUN,KNUL,ISTAT)
      CALL STKRDD ('CENTRE', 1,1, IACTS,BANDC,KUN,KNUL,ISTAT)
C
C   Map input data
C
      IFLAG=2
      CALL STFINF (INAME,IFLAG,IBUF,ISTAT)
      ITYP=IBUF(2)
      IF (ITYP.NE.D_R8_FORMAT) THEN
        CALL STETER(1,'Input spectrum must be in DOUBLE PRECISION')
      ENDIF
      CALL STIGET(INAME,D_OLD_FORMAT,F_I_MODE,F_IMA_TYPE,NAXIS,
     $   IAXIS,NSTEPS,START,STEP,IDENT,CUNIT,PPER,IPER,ISTAT)
C
C   Create work table
C
      CALL STFCRE('ZZMIDWORK',D_R8_FORMAT,F_X_MODE,F_IMA_TYPE,NSTEPS(1),
     $    IWORK,ISTAT)
      CALL STFMAP(IWORK,F_X_MODE,1,NSTEPS(1),IACTS,PWORK,ISTAT)
C
C   Evaluate frequency band
C
      CALL TIMWIDTH(MADRID(PPER),MADRID(PWORK),
     $    NSTEPS(1),START(1),STEP(1),BANDW,BANDC,NVALUES,WIDTH)
C
C   Return keyword values (NOT IMPLEMENTED)
C
      CALL STKWRD('OUTPUTD',WIDTH(1,1), 1,NVALUES*2,KUN,ISTAT)
      CALL STKWRD('STARTTSA',  BANDC,      1,        1,KUN,ISTAT)
C      CALL STKWRD('STEPTSA',  STEP,  1,1,KUN,ISTAT)
C      CALL STKWRI('NSTEPS',NSTEPS,1,1,KUN,ISTAT)
      CALL STTPUT('Kywords START and OUTPUTD are set now.',ISTAT)
C
C   Wind-up
C
      CALL STSEPI
C
      END
C
C
C
      SUBROUTINE  TIMWIDTH(PER,WORK,
     $    NSTEPS,START,STEP,BANDW,BANDC,NVALUES,WIDTH)
C
      INCLUDE 'MID_REL_INCL:TSA_DEF.INC'
      DOUBLE PRECISION       CRACOW
      INTEGER      NSTEPS,NVALUES
      DOUBLE PRECISION       PER(NSTEPS,2),WORK(NSTEPS)
      REAL*8       START,STEP,BANDW,BANDC
      DOUBLE PRECISION       WIDTH(NVALUES,2)
C
      INTEGER      NPAR1
      PARAMETER   (NPAR1=4)
      REAL*8       FINISH
      DOUBLE PRECISION       COND(NPAR1),COVAR(NPAR1,NPAR1)
      DOUBLE PRECISION       VALPEAK,VALLINE,VALCONT,VALHALF,VAL
      DOUBLE PRECISION       PEAKC,LINEC,PEAKW,LINEW,X
      INTEGER      IPEAKC,IPEAKW
      INTEGER      ISTART,NBAND
      INTEGER      I,J,K,ITER,MXITER,IVAL,MODE
      CHARACTER*80 TEXT
      INCLUDE 'MID_REL_INCL:TSA_CONST.INC'
      DATA         MXITER/10/
C
C      Get (trimmed) range of pixels
C
      IF (STEP.EQ.ZERO) THEN
        CALL STETER(10,'Zero step: check descriptor STEP(1)')
      ENDIF
      FINISH=STEP*NSTEPS
      VAL=BANDC-START
      ISTART= MIN(NSTEPS,MAX(1,NINT(
     $     MIN(FINISH,MAX(ZERO,VAL-BANDW))/STEP)))-1
      NBAND= MIN(NSTEPS,MAX(1,NINT(
     $     MIN(FINISH,MAX(ZERO,VAL+BANDW))/STEP)))
      NBAND=NBAND-ISTART
      IF (NBAND.LT.10) THEN
        CALL STETER(11,'Too narrow band')
      ENDIF
C
C   Compute pixel histogramme and find continuum as median value
C
      DO 1 I=1,NBAND
        WORK(I)=PER(ISTART+I,1)
 1    CONTINUE
      CALL SORT(NBAND,WORK)
      VALPEAK=WORK(NBAND)
      VALCONT=WORK(NBAND/2+1)
      CALL STTPUT('   ---    Line Parameters    ---',ISTAT)
      CALL STTPUT(
     $   'Component    Level      Frequency                Width',
     $   ISTAT)
      WRITE(TEXT,'(A,1PE10.2,1PE13.5,11X,1PE10.2)')
     $     'Continuum ',VALCONT,BANDC,BANDW
      CALL STTPUT(TEXT,ISTAT)
C
C   Find approximate parameters of the line
C
      VALHALF=(VALPEAK+VALCONT)*HALF
      IPEAKC=0
      DO 2 I=1,NBAND
        IF (PER(ISTART+I,1).EQ.VALPEAK) THEN
          IPEAKC=ISTART+I
        ENDIF
        IF (WORK(I).LT.VALHALF) THEN
          IPEAKW=I
        ENDIF
 2    CONTINUE
      PEAKW=(VALHALF-WORK(IPEAKW))/(WORK(IPEAKW+1)-WORK(IPEAKW))
      PEAKW=(NBAND-(IPEAKW*(ONE-PEAKW)+(IPEAKW+1)*PEAKW))*STEP*HALF
      IF (IPEAKC.EQ.0) THEN
        CALL STETER(12,'Coding error: condition should not occure')
      ENDIF
      PEAKC=START+STEP*IPEAKC
      WRITE(TEXT,'(A,1PE10.2,1PE13.5,A,1PE7.1,1PE10.2,A,1PE7.1)')
     $    'Peak      ',VALPEAK,PEAKC,' +/-',STEP,PEAKW,' +/-',STEP
      CALL STTPUT(TEXT,ISTAT)
      BANDC=PEAKC
C
C   Fit a line by nonlinear least squares iterations
C
      LINEC=PEAKC
      LINEW=PEAKW
      VALLINE=VALPEAK
      ITER=0
 19   CONTINUE
        ITER=ITER+1
        IF (ITER.EQ.1) THEN
          VAL=LINEC-START
          ISTART= MIN(NSTEPS,MAX(1,NINT(
     $       MIN(FINISH,MAX(ZERO,VAL-TWO*LINEW))/STEP)))-1
          I     = MIN(NSTEPS,MAX(1,NINT(
     $       MIN(FINISH,MAX(ZERO,VAL+TWO*LINEW))/STEP)))
          NBAND=  I-ISTART
          IF (NBAND.LT.4) THEN
            CALL STTPUT('Line very narrow: poor results',ISTAT)
            ISTART= MIN(NSTEPS,MAX(1,(ISTART+I)/2-2))
            NBAND=4
          ENDIF
        ENDIF
        DO 10 J=1,NPAR1
          DO 11 K=1,NPAR1
            COVAR(J,K)=ZERO
 11       CONTINUE
 10     CONTINUE
        MODE=1
        DO 15 I=1,NBAND
          J=ISTART+I
          X=START+J*STEP-LINEC
          CALL PROFILE(LINEW,VALLINE-VALCONT,X,PER(J,1)-VALCONT,
     $         COND,NPAR1,MODE)
          DO 16 J=1,NPAR1
            DO 17 K=1,NPAR1
              COVAR(J,K)=COVAR(J,K)+COND(J)*COND(K)
 17         CONTINUE
 16       CONTINUE
 15     CONTINUE
        IF (CRACOW(COVAR,NPAR1,NPAR1,NBAND).EQ.ZERO) THEN
          CALL STETER(15,'Singular conditions for profile')
        ENDIF
C
C   Take care of initial convergence
C
        VAL= EXP(-(ZERO+ITER-ONE)/ONE)
        VAL= 0.1*VAL+ONE*(ONE-VAL)
        LINEC=   LINEC  +    COVAR(1,NPAR1)*VAL
        LINEW=   LINEW  *EXP(COVAR(2,NPAR1)*VAL)
        VALLINE= VALLINE*EXP(COVAR(3,NPAR1)*VAL)
        VAL=COVAR(1,NPAR1)*COVAR(1,NPAR1)+COVAR(2,NPAR1)*COVAR(2,NPAR1)
      IF (SQRT(VAL).GT.ONE/NSTEPS*0.1 .AND. ITER.LT.MXITER) GOTO 19
      VAL=COVAR(NPAR1,NPAR1)/VALCONT/VALCONT
      IF (VAL.GT.ONE) THEN
        WRITE(TEXT,'(A,F12.2,A)')
     $    '*** Warning: Poor fit (RMS= ',SQRT(VAL),'*Cont.)'
        CALL STTPUT(TEXT,ISTAT)
      ENDIF
C
C   Print report
C
      IF (ITER.GE.MXITER) THEN
         CALL STTPUT('*** Warning: No convergence of fit',ISTAT)
      ELSE
        BANDC=LINEC
      ENDIF
      WRITE(TEXT,'(A,1PE10.2,1PE13.5,A,1PE7.1,1PE10.2,A,1PE7.1)')
     $  'Fit       ',VALLINE,
     $   LINEC,' +/-',SQRT(COVAR(1,1)*COVAR(NPAR1,NPAR1)),
     $   LINEW,' +/-',SQRT(COVAR(2,2)*COVAR(NPAR1,NPAR1))
      CALL STTPUT(TEXT,ISTAT)
C
C   Compute profile width at NVALUES levels
C
      MODE=2
      CALL STTPUT('   ---  Fitted Line Profile  ---',ISTAT)
      CALL STTPUT('    Width      Level     Fraction',ISTAT)
      DO 20 IVAL=1,NVALUES
        VAL=(IVAL-ONE)/(NVALUES-ONE)
        VAL=((ONE-VAL)*(VALLINE-VALCONT-VALCONT)+VAL*VALCONT)
        WIDTH(IVAL,2)=VAL+VALCONT
        CALL PROFILE(LINEW,VALLINE-VALCONT,WIDTH(IVAL,1),VAL,
     $     COND,NPAR1,MODE)
        WRITE(TEXT,'(4(1PE11.2))') WIDTH(IVAL,1),WIDTH(IVAL,2),
     $    (VALLINE-WIDTH(IVAL,2))/(VALLINE-VALCONT)
        CALL STTPUT(TEXT,ISTAT)
 20   CONTINUE
      END
C
C
C
      SUBROUTINE PROFILE(W,H,X,Y,COND,NPAR1,MODE)
C
      INCLUDE 'MID_REL_INCL:TSA_DEF.INC'
      INTEGER      NPAR1,MODE
      DOUBLE PRECISION       COND(NPAR1)
      DOUBLE PRECISION       W,H,X,Y
C
      DOUBLE PRECISION       PI,FI,DFIDX,H2,DFDFI,F,WEIGHT
      INTEGER      I
      INCLUDE 'MID_REL_INCL:TSA_CONST.INC'
C
      PI=TWO*TWO*ATAN(ONE)
      IF (MODE.EQ.1) THEN
        DFIDX=PI*HALF/W
        FI=MAX(-PI,MIN(PI,DFIDX*X))
        H2=H*HALF
        F=(COS(FI)+ONE)*H2
        DFDFI=-H2*SIN(FI)
        COND(1)=-DFDFI*DFIDX
        COND(2)=DFDFI*(-FI/W)*W
        COND(3)=F/H*F
        COND(NPAR1)=Y-F
        WEIGHT=F/H
        DO 1 I=1,NPAR1
          COND(I)=COND(I)*WEIGHT
 1      CONTINUE
      ELSEIF (MODE.EQ.2) THEN
        X=TWO*W/PI*ACOS(MIN(ONE,MAX(-ONE,(TWO*Y/H-ONE))))
      ELSE
        CALL STETER(20,'Wrong mode')
      ENDIF
      END
C
C
C

C @(#)fit_user.for	10.7 (ESO-IPG) 2/13/96 16:33:51
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C       Internet e-mail: midas@eso.org
C       Postal address: European Southern Observatory
C                       Data Management Division 
C                       Karl-Schwarzschild-Strasse 2
C                       D 85748 Garching bei Muenchen 
C                       GERMANY
C===========================================================================
C


C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE  EdtPar(iflag)
C        
C       Edit parameter table. 
C       iflag=0 ok
C       iflag=-1 quit
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

          implicit none
          include 'MID_REL_INCL:fit_var.inc'
          integer ipos
          integer iflag
          integer ist,nline,jj,kk,iexist
          character*20 com1,com2,com3,com4,command
          character*80 helpstr
          character test
          character*4 cvalue
          real value
          logical reval,iok,inewl

 100      continue              !starts loop

          call sttdis(' ',0,ist)
          call sttdis(' ',0,ist)
          call sttdis(' ',0,ist)
          call ShPar1('EDITPARAM')
          call sttdis(' ',0,ist)
          command = ' '
          call AskC('Input command (e.g. ''B #3 25.3'', ''help'' )',
     1         command,ist)
          
          if (command.eq.' ') goto 100
C
C     Reads, checks and processes first string of command
C

          if (command.eq.'help'.or.command.eq.'HELP') then
           call sttdis(' ',0,ist)
           call sttdis(' ** HELP Edit Parameter   **',0,ist)
           call sttdis(' ',0,ist)
           call sttdis(' * To modify the value of a  parameter enter:'
     1          ,0,ist)
           call sttdis('           <Col.name>  #<Row number>  <value>',
     1          0,ist)
           write(helpstr,*)'    Where: Col.name is the name of the '
     1          ,'column desired (E, L, PL, N ....)'
           call sttdis(helpstr,0,ist)
           write(helpstr,*)'       Row number is the number of the row'
           call sttdis(helpstr,0,ist)
           write(helpstr,*)'       value is the new value to input'
           write(helpstr,*)'Examples:'
           call sttdis(helpstr,0,ist)
           write(helpstr,*)'          E  #2  CIV_1548   '
           call sttdis(helpstr,0,ist)
           write(helpstr,*)'          N  #1  13.5       '
           call sttdis(helpstr,0,ist)
           write(helpstr,*)'          PB #3  5.F        '
           call sttdis(helpstr,0,ist)

           call sttdis(' ',0,ist)
           call sttdis(' To delete a line: ',0,ist)
           call sttdis('          D   #<Row number>',0,ist)
           call sttdis(' ',0,ist)
           call sttdis(' To exit:          ',0,ist)
           call sttdis('          EXIT (saving)',0,ist)
           call sttdis('          QUIT (not saving)',0,ist)

           goto 100
          end if

          if (command.eq.'exit'.or.command.eq.'EXIT') then
             iflag=0
             return
          end if

          if (command.eq.'quit'.or.command.eq.'QUIT') then
             iflag=-1
             return
          end if


                                ! parameter name
          com1=command(1:2)
          iok=.false.
          if (com1.eq.'l '.or.com1.eq.'L ') then
             com1='L '
             iok=.true.
             reval=.true.
          end if
          if (com1.eq.'n '.or.com1.eq.'N ') then
             com1='N '
             iok=.true.
             reval=.true.
          end if
          if (com1.eq.'b '.or.com1.eq.'B ') then
             com1='B '
             iok=.true.
             reval=.true.
          end if
          if (com1.eq.'bt'.or.com1.eq.'BT') then
             com1='BT'
             iok=.true.
             reval=.true.
          end if

          if (com1.eq.'pl'.or.com1.eq.'PL') then
             com1='PL'
             iok=.true.
             reval=.false.
          end if
          if (com1.eq.'pn'.or.com1.eq.'PN') then
             com1='PN'
             iok=.true.
             reval=.false.
          end if
          if (com1.eq.'pb'.or.com1.eq.'PB') then
             com1='PB'
             iok=.true.
             reval=.false.
          end if
          if (com1.eq.'pt'.or.com1.eq.'PT') then
             com1='PT'
             iok=.true.
             reval=.false.
          end if

          if (com1.eq.'d '.or.com1.eq.'D ') then
             com1='D '
             iok=.true.
          end if
          if (com1.eq.'e '.or.com1.eq.'E ') then
             com1='E '
             iok=.true.
          end if


          if (.not.iok) then
             call ErrMsg('Parameter name not found')
             goto 100
          end if

C
C       Gets line number (this is always needed)
C
                                !line number
          ipos=index(command,'#')
          if (ipos.eq.0) then
            call ErrMsg('Error in line specification (# is missing)')
            goto 100
          end if
          com2=command(ipos+1:20)
          read(com2,*)nline    
          if (nline.gt.(NROWS+1)) then !Errors in line number
             call ErrMsg('Line number too large')
             goto 100
          end if
          if (nline.lt.1) then 
             call ErrMsg('Line number too small')
             goto 100
          end if

                                !add a new line          
          if (nline.eq.(NROWS+1)) then
             inewl=.false.
             ist=0              !waits for reply
             call AskYN('Create new line?',inewl,ist)
             if (inewl) then
                NROWS = NROWS + 1
                ElmtNm(NROWS)='             '
                LamIni(NROWS)=0.
                NIni(NROWS)=0.
                BIni(NROWS)=0.
                BtuIni(NROWS)=0.
                do jj=1,4
                   CPar(jj,NROWS)='    '
                end do
             end if
                                ! here doesn't goto100 to process the command
          end if

          
                                ! delete a line
          if (com1.eq.'D ') then
             inewl=.false.
             ist=0              !waits for reply
             call AskYN('Confirm deletion of line?',inewl,ist)
             if (inewl) then
                do jj=nline+1,NROWS
                   ElmtNm(JJ-1)= ElmtNm(JJ)
                   LamIni(JJ-1)=LamIni(JJ)
                   NIni(JJ-1)=NIni(JJ)
                   BIni(JJ-1)=BIni(JJ)
                   BtuIni(JJ-1)=BtuIni(JJ)
                   do kk=1,4
                      CPar(kk,JJ-1)=CPar(kk,jj)
                   end do
                end do
                ElmtNm(NROWS)='             '
                LamIni(NROWS)=0.
                NIni(NROWS)=0.
                BIni(NROWS)=0.
                BtuIni(NROWS)=0.
                do jj=1,4
                   CPar(jj,NROWS)='    '
                end do
                NROWS = NROWS - 1
             end if
             goto 100
          end if
             

C
C     reads the third command end processes it. 
C
                                ! Element
          if (com1.eq.'E ') then
             ipos=index(com2,' ')
             com3=com2(ipos:20)
             ipos=0
 102         ipos=ipos+1
             test=com3(ipos:ipos)
             if (test.eq.' ') goto 102
             com4=com3(ipos:14)
             do jj=1,AT_N
                if (com4.eq.AT_NAM(jj))  iexist=1
             end do  
             if (iexist.eq.0) then
                call ErrMsg('Element not found')
                goto 100
             end if
             write(ElmtNm(nline),'(a14)')com4 ! converts to c*14
             goto 100
          end if


                                ! new value
          ipos=index(com2,' ')
          com3=com2(ipos:20)
          if (reval) then
             read(com3,*)value
          else
             ipos=0
 101         ipos=ipos+1
             test=com3(ipos:ipos)
             if (test.eq.' ') goto 101
             com4=com3(ipos:20)
             write(cvalue,'(a4)')com4 ! converts to c*4 and flushright
             call CnvrtP(cvalue,ipos,test,ist)
             if (ist.eq.1) write(cvalue,'(i2,a1,a1)')ipos,'.',test
             if (ist.eq.0) write(cvalue,'(i4)')ipos
          end if


          if (com1.eq.'L ') LamIni(nline)=value
          if (com1.eq.'N ') NIni(nline)=value
          if (com1.eq.'B ') BIni(nline)=value
          if (com1.eq.'BT') BtuIni(nline)=value
          if (com1.eq.'PL') CPar(1,nline)=cvalue
          if (com1.eq.'PN') CPar(2,nline)=cvalue
          if (com1.eq.'PB') CPar(3,nline)=cvalue
          if (com1.eq.'PT') CPar(4,nline)=cvalue

          GOTO 100              ! asks for a new input

          end


C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE  ShoRes
C        Stampa sullo schermo i risultati del fit
C        leggendo il file 'fdummy.res'
C       Plots the fitted spectrum    
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        implicit none

        include 'MID_REL_INCL:fit_var.inc'

        character*79 sttapp
        integer istt,i


C        include 'MID_REL_INCL:fit_mid.inc'
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'

C!!!!!!!
C        Legge il file 'fdummy.res' e stampa i risultati
C!!!!!!!
        call sttdis(' ',0,istt)
        call sttdis(' ',0,istt)
        call sttdis('***** Result of the fit: *****',0,istt)
        call sttdis(' ',0,istt)
        open(10,file='fdummy.res',status='old')
        read(10,*)chi,prob
        write(sttapp,'(A20,f6.2,f6.2)')'Reduced chi2, prob:',chi,prob
        call sttdis(sttapp,0,istt)
        call sttdis(' ',0,istt)
        call sttdis(' ',0,istt)
        if (IMINOS.eq.0) then
           write(sttapp,'(A8,A5,A7,A6,A6,A5,A8,A5)')'LamCen','+/-',
     1          'N  ','+/-','b  ','+/-','  b tur.','+/-'
           call sttdis(sttapp,0,istt)
        else
           write(sttapp,'(A8,A5,A7,A6,A6,A5,A8,A5)')'LamCen',' + ',
     1          'N  ',' + ','b  ',' + ','  b tur.',' + '
           call sttdis(sttapp,0,istt)
           write(sttapp,'(A8,A5,A7,A6,A6,A5,A8,A5)')'      ',' - ',
     1          '   ',' - ','   ',' - ','        ',' - '
           call sttdis(sttapp,0,istt)
        end if
        call sttdis(' ',0,istt)
        
        do i=1,nrows
         read(10,'(17G19.9E3)')LamCen(i),NHfit(i),BDopp(i),BTur(i),
     1        w(i),ErLaPa(i),ErNnPa(i),ErBbPa(i),ErBtPa(i),
     2        ErLaPo(i),ErLaNe(i),ErNnPo(i),ErNnNe(i),
     3        ErBbPo(i),ErBbNe(i),ErBtPo(i),ErBtNe(i)
         Redshi(i) = LamCen(i) / AtmLam(i) - 1.
         Temper(i) = AtmMas(i) * BDopp(i)* BDopp(i) * 60.137
         if (BDopp(i).lt.0) BDopp(i)=-BDopp(i)
         if (Btur(i).lt.0)Btur(i)=-Btur(i)
         if (IMINOS.eq.0) then
            write(sttapp,98)LamCen(i),ErLaPa(i),NHfit(i),ErNnPa(i),
     1           BDopp(i),ErBbPa(i),BTur(i),ErBtPa(i),ElmtNm(i)
            call sttdis(sttapp,0,istt)
          else
            write(sttapp,98)LamCen(i),ErLaPo(i),NHfit(i),ErNnPo(i),
     1           BDopp(i),ErBbPo(i),BTur(i),ErBtPo(i),ElmtNm(i)
            call sttdis(sttapp,0,istt)
            write(sttapp,99)ErLaNe(i),ErNnNe(i),
     1           ErBbNe(i),ErBtNe(i)
            call sttdis(sttapp,0,istt)
         end if
        end do
  
 98     format(f8.2,f5.2,f7.2,f6.2,f6.1,f5.1,f6.1,f5.1,3x,a14)
 99     format(8x,f5.2,7x,f6.2,6x,f5.1,6x,f5.1)

        close(10)

        NGRALI=nrows
        return
        end

C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE  ReaRes
C       Versione semplificata di ShoRes
C       Si limita a leggere il file fdummy.res 
C       Utile per ITERATE
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        implicit none

        include 'MID_REL_INCL:fit_var.inc'

        integer i


C        include 'MID_REL_INCL:fit_mid.inc'
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'

C!!!!!!!
C        Legge il file 'fdummy.res'
C!!!!!!!
        open(10,file='fdummy.res',status='old',err=100)
        read(10,*)chi,prob
        
        i=0
 10     continue
         i = i + 1
         read(10,'(17G19.9E3)',end=100,err=100)LamCen(i),NHfit(i),
     1        BDopp(i),BTur(i),
     2        w(i),ErLaPa(i),ErNnPa(i),ErBbPa(i),ErBtPa(i),
     3        ErLaPo(i),ErLaNe(i),ErNnPo(i),ErNnNe(i),
     4        ErBbPo(i),ErBbNe(i),ErBtPo(i),ErBtNe(i)
         Redshi(i) = LamCen(i) / AtmLam(i) - 1.
         Temper(i) = AtmMas(i) * BDopp(i)* BDopp(i) * 60.137
         if (BDopp(i).lt.0) BDopp(i)=-BDopp(i)
         if (Btur(i).lt.0)Btur(i)=-Btur(i)
        goto 10

 100     continue
        NGRALI = i - 1
        
        close(10)

        return
        end




C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
      SUBROUTINE AskStp(command,iok)
C
C     Asks for setup parameters
C
C     iok    integer    (out)   =0 if ok, =-1 if quit
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
           implicit none
           character*(*)command
           integer iok
           include 'MID_REL_INCL:fit_var.inc'
           
           integer istt
           logical logtur
           character*40 Mes
           character*80 strout
           character Risp1
           character*20 Option(10)


           Option(1)='(P)rogram set-up'
           Option(2)='(D)ata set-up'
           Option(3)='(G)raphic set-up'
           Option(4)='(E)nd'
           Option(5)='(Q)uit'

           if (Command.eq.'PROGRAM') then
              Risp1='P'
              goto 101
           end if
           if (Command.eq.'DATA') then
              Risp1='D'
              goto 101
           end if
           if (Command.eq.'GRAPHIC') then
              Risp1='G'
              goto 101
           end if

 100       Mes ='************'
           write(strout,'(18x,A12,3x,A14,3x,A12)')Mes,'SET-UP  MENU',
     1          Mes
           call sttdis(strout,0,istt)
           call sttdis(' ',0,istt)
           call sttdis(' ',0,istt)
           write(strout,'(10x,A20,10x,a20)')Option(1),Option(4)
           call sttdis(strout,0,istt)
           write(strout,'(10x,A20,10x,a20)')Option(2),Option(5)
           call sttdis(strout,0,istt)
           write(strout,'(10x,a20)')Option(3)
           call sttdis(strout,0,istt)

           
           Risp1=' '
           istt=-2
           call AskC(' ',Risp1,istt)

 101       if (Risp1.eq.'E'.or.Risp1.eq.'e') then
              iok=0
              return
           end if

           if (Risp1.eq.'Q'.or.Risp1.eq.'q') then
              iok=-1
              return
           end if

           istt=0
           iok=0
           if (Risp1.eq.'P'.or.Risp1.eq.'p') then
              call AskC('Spectrum table',FILSPE,istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99) return

              call AskC('Output table',FILOUT,istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99) return

              call AskC('Log name',FILLOG,istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99)  return

              istt=1            !DON'T wait for reply
              call AskYN('Graphic output?',I_GRAP,istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99)  return

              if (TURBLN .eq. 1) logtur = .true.
              if (TURBLN .eq. 0) logtur = .false.
              istt=1            !DON'T wait for reply
              call AskYN('Show turbolence parameter?',logtur,istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99)  return
              if (logtur) TURBLN =1
              if (.not. logtur) TURBLN =0
           end if

           if (Risp1.eq.'D'.or.Risp1.eq.'d') then
              call AskD('Positive range for lambda (Angst, 0=free)',
     1             LamLim(1),istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99)  return
              call AskD('Negative range for lambda (Angst, 0=free)',
     1             LamLim(2),istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99)  return
              
              call AskD('Minimum N allowed (0=free)',NLim(1),istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99)  return
              call AskD('Maximum N allowed (0=free)',NLim(2),istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99)  return
              
              call AskD('Minimum b allowed (0=free)',BLim(1),istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99)  return
              call AskD('Maximum b allowed (0=free)',BLim(2),istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99)  return
              
              call AskD('Minimum b turb. allowed (0=free)',
     1             BtuLim(1),istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99)  return
              call AskD('Maximum b turb.allowed (0=free)',
     1             BtuLim(2),istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99)  return
              
              call AskD('Initial step for lambda (A)',
     1             LamLim(3),istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99)  return
              
              call AskD('Initial step for N',NLim(3),istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99)  return
              
              call AskD('Initial step for b',BLim(3),istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99)  return
              
              call AskD('Initial step for b turb.',BtuLim(3),istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99)  return

           end if

           if (Risp1.eq.'G'.or.Risp1.eq.'g') then

              istt=1            !DON'T wait for reply
              call AskYN('Graphic output?',I_GRAP,istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99)  return

              call AskD('Space below spectrum',GR_BOT,istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99)  return

              call AskD('Space over spectrum',GR_TOP,istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99)  return

              call AskD('Offset for labels',GR_LAB,istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99)  return

              call AskD('Y-position of line ticks',GR_TIC,istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99)  return

              istt=1            !DON'T wait for reply
              call AskYN('Plot residuals?',I_RESD,istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99)  return

              istt=1            !DON'T wait for reply
              call AskYN('Plot variance?',I_VAR,istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99)  return

              call AskI('Color for plot ',GCOLOR(1),istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99)  return

              call AskI('Color for fitted profile ',GCOLOR(3),istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99)  return

              call AskI('Color for reference lines ',GCOLOR(2),istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99)  return

              call AskI('Color for residuals ',GCOLOR(4),istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99)  return

              call AskI('Color for variance ',GCOLOR(5),istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99)  return

              call AskI('Color for labels ',GCOLOR(6),istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99)  return

              call AskI('Color for line ticks ',GCOLOR(7),istt)
              if (istt.eq.-1)  goto 100
              if (istt.eq.-99)  return
           end if

           goto 100

        end


C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE AskMin(ierr)
C
C        Imposta la configurazione per la minimizzazione        
C        Presenta dapprimaun menu generale per :
C        a) scegliere la procedura standard (MINIMIZE+HESSE)
C        b) choose the current set of instructions
C        c) impostare a piacere un set di istruzioni MINUIT
C
C        prima vengono definiti i comandi, poi viene scritto  
C        il file
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

        implicit none
        integer ierr
        
        include 'MID_REL_INCL:fit_var.inc'

        character*1 risp
        character*10 lett
        character*20 Menu1(10),Menu2(10),Menu3(10),Menu4(10)
        character*60 stt_ap,Mes
        character*80 strout
        integer istt,i,j,numcom,nparf,nparf2
        real up

        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'

        Menu1(1)='(M)inimize'
        Menu1(2)='(I)mprove'
        Menu1(3)='see(K)'
        Menu1(4)='(F)ix'
        Menu1(5)='(R)elease'

        Menu2(1)='(H)esse'
        Menu2(2)='mi(N)os'
        Menu2(3)='(S)can'
        Menu2(4)='(C)ontour'

        Menu3(1)='set err(O)r'
        Menu3(2)='set prin(T)'
        Menu3(3)='set ran(D)om'
        Menu3(4)='set strate(G)y'

        Menu4(1)='(E)nd'
        Menu4(2)='(Q)uit'

C!!!!!!!
C     main menu
C!!!!!!!
        
 10     risp = ' '
        lett = ' '  
        call sttdis(' ',0,istt)
        call sttdis(' ',0,istt)
        call sttdis(' ',0,istt)
        call sttdis('  *** Current instruction set: ***',0,istt)
        call sttdis(' ',0,istt)
        if (NMINCM.gt.0) then
           do i=1,NMINCM
              call sttdis(MINCOM(i),0,istt)
           end do
        end if
        call sttdis(' ',0,istt)
        call sttdis(' ',0,istt)
        call sttdis('*********** FIT Options ************',0,istt)
        call sttdis(' ',0,istt)
        call sttdis('(S)tandard procedure (MINIMIZE+HESSIAN ERRORS)'
     +       ,0,istt)
        call sttdis(' ',0,istt)
        call sttdis('(C)urrent instruction set',0,istt)
        call sttdis(' ',0,istt)
        call sttdis('(I)nput commands',0,istt)
        call sttdis(' ',0,istt)
        call sttdis('(Q)uit (back to Fitlyman Menu)',0,istt)
        call sttdis(' ',0,istt)
        istt=-2
        call AskC(' ',lett,istt)
        
c     read(5,'(a)')lett
        risp=lett
        
        if (risp.eq.'c'.or.risp.eq.'C') then
           ierr=0
           return
        end if
        
        if (risp.ne.'i'.and.risp.ne.'I'.and.risp.ne.'s'.and.risp.ne.'S'
     +       .and. risp .ne.'Q' .and. risp.ne.'q') goto 10
        
        if (risp.eq.'q'.or.risp.eq.'Q') then 
           ierr = -1
           return
        end if
        do i=1,NMXLIN
           MINCOM(i)=' '
        end do
        
C!!!!!!!
C     Comandi per la procedura standard
C!!!!!!!
        if (risp.eq.'s'.or.risp.eq.'S') then
           NMINCM=4
           MINCOM(1)='SET ERRORDEF 1.'
           MINCOM(2)='MINIMIZE'
           MINCOM(3)='HESSE'
           MINCOM(4)='RETURN'
           ierr=0
          return
       end if        
       
C!!!!!!!
C     Procedura a scelta
C!!!!!!!
       if (risp.eq.'i'.or.risp.eq.'I') then
 
          NumCom=0
 20       call sttdis(' ',0,istt)
          call sttdis(' ',0,istt)
          call sttdis(' ',0,istt)
          if (NumCom.gt.0) then
             call sttdis('  ***Current instruction set: ***',0,istt)
             do i=1,NumCom
                call sttdis(MINCOM(i),0,istt)
             end do
          end if

          call sttdis(' ',0,istt)
          Mes ='************'
           write(strout,'(18x,A16,3x,A14,3x,A12)')Mes,
     1          'MINUIT  COMMANDS',Mes
           call sttdis(strout,0,istt)
           call sttdis(' ',0,istt)
           call sttdis(' ',0,istt)
           do j=1,5
              write(strout,'(4A20)')Menu1(j),Menu2(j),Menu3(j),Menu4(j)
              call sttdis(strout,0,istt)
           end do
          call sttdis(' ',0,istt)

          istt=-2
          call AskC('--- ? ---',stt_ap,istt)
          read(stt_ap,'(a1)')lett
          risp=lett
          
                                !MINIMIZE
          if (risp.eq.'m'.or.risp.eq.'M') then
             NumCom=NumCom+1
             MINCOM(NumCom)='MINIMIZE'
             goto 20
          end if
          
                                !IMPROVE  
          if (risp.eq.'i'.or.risp.eq.'I') then
             NumCom=NumCom+1
             MINCOM(NumCom)='IMPROVE'
             goto 20
          end if
          
                                 !SEEK     
          if (risp.eq.'k'.or.risp.eq.'K') then
             NumCom=NumCom+1
             MINCOM(NumCom)='SEEK'
             goto 20
          end if
          
                                !FIX
          if (risp.eq.'f'.or.risp.eq.'F') then
             call ShPar1('NORMAL')
             call AskI('  --> Parameter to fix:', NParF,istt)
             if (istt .eq. -1) goto 20 ! redo
             NumCom=NumCom+1
             write(MINCOM(NumCom),301)NParF
             goto 20
          end if
 301      format('FIX',3x,i2)

                                !RELEASE
          if (risp.eq.'r'.or.risp.eq.'R') then
             call AskI('  --> Parameter to release:', NParF,istt)
             if (istt .eq. -1) goto 20 ! redo
             NumCom=NumCom+1
             write(MINCOM(NumCom),302)NParF
             goto 20
          end if
 302      format('RELEASE',3x,i2)

                               !HESSE
          if (risp.eq.'h'.or.risp.eq.'H') then
             NumCom=NumCom+1
             MINCOM(NumCom)='HESSE'
             goto 20
          end if
          
                                !MINOS  
          if (risp.eq.'n'.or.risp.eq.'N') then
             NumCom=NumCom+1
             MINCOM(NumCom)='MINOS'
             goto 20
          end if


                                !SCAN   
          if (risp.eq.'s'.or.risp.eq.'S') then
             call AskI('  --> Parameter to scan:', NParF,istt)
             if (istt .eq. -1) goto 20 ! redo
             NumCom=NumCom+1
             write(MINCOM(NumCom),101)NParF
             goto 20
          end if
 101      format('SCAN',5x,i2)


                                !CONTOUR
          if (risp.eq.'c'.or.risp.eq.'C') then
             call AskI('  --> Parameter on x axis:',NParF,istt)
             if (istt .eq. -1) goto 20 ! redo
             call AskI('  --> Parameter on y axis:',NParF2,istt)
             if (istt .eq. -1) goto 20 ! redo
             NumCom=NumCom+1
             write(MINCOM(NumCom),102)NParF,NParF2
             goto 20
          end if
 102      format('CONTOUR',5x,i3,1x,i3)

                                !SET ERROR
          if (risp.eq.'o'.or.risp.eq.'O') then
             call AskR('  --> Error level:',up,istt)
             if (istt .eq. -1) goto 20 ! redo
             NumCom=NumCom+1
             write(MINCOM(NumCom),201)up
             goto 20
          end if
 201      format('SET ERRORDEF',5x,f6.2)

                                !SET PRINT
          if (risp.eq.'t'.or.risp.eq.'T') then
             call AskI('  --> Number of columns:',NParF,istt)
             if (istt .eq. -1) goto 20 ! redo
             NumCom=NumCom+1
             write(MINCOM(NumCom),202)NParF
             goto 20
          end if
 202      format('SET PRINT',5x,i3)

                                !SET RANDOM
          if (risp.eq.'d'.or.risp.eq.'D') then
             call AskI('  --> Random seed:',NParF,istt)
             if (istt .eq. -1) goto 20 ! redo
             NumCom=NumCom+1
             write(MINCOM(NumCom),204)NParF
             goto 20
          end if
 204      format('SET RANDOM',5x,i8)

                                !SET STRATEGY
          if (risp.eq.'g'.or.risp.eq.'G') then
             call AskI('  --> Strategy level',NParF,istt)
             if (istt .eq. -1) goto 20 ! redo
             NumCom=NumCom+1
             write(MINCOM(NumCom),205)NParF
             goto 20
          end if
 205      format('SET STRATEGY',5x,i2)
          
          if (risp.eq.'e'.or.risp.eq.'E') then
                                !END
             call sttdis('END',0,istt)
             NumCom=NumCom+1
             MINCOM(NumCom)='RETURN'
             NMINCM=NumCom
             ierr=0
             return
          end if
          
                                !QUIT
          if (risp.eq.'q'.or.risp.eq.'Q') then 
             ierr = -1
             return
          end if
          
          goto 20
       end if
       
       return
       end
      
      
      
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE AskI(Commnt,Valore,ier)
C
C        Routine di I/O per leggere una variabile da tastiera.
C        Presenta all'utente una descrizione della variabile (Commnt)
C        e un valore di default (Valore).
C        Se l'utente risponde REDO  ier=-1
C        Se l'utente risponde GO  ier=-99
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

        IMPLICIT INTEGER (I-K)

        character*(*) Commnt
        character*20 a
        character t(1),a1
        character*300 stt_ap
        integer Valore,ier
        integer myslen

        ier=0
10        write(stt_ap,'(1x,a,a,I13,a)')Commnt(1:myslen(Commnt)),' [',
     >       Valore,' ]'
        t(1)=' '
        call sttdis(stt_ap(1:myslen(stt_ap)),0,ist)
        call stkwrc('INPUTC',1,t,1,20,i,i) 
        call stkprc(' ','INPUTC',1,1,20,iletti,a,ikun,ik,is)

        if (a(1:4).eq.'redo'.or.a(1:4).eq.'REDO') then
                ier=-1
                return
        end if

        if (a(1:2).eq.'go'.or.a(1:2).eq.'GO') then
                ier=-99
                return
        end if


        a1=a
         if (a1.ne.' ') read(a,*,err=10)valore

        ier=0


        return
        end



C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE AskD(Commnt,Valore,ier)
C
C       Routine di I/O per leggere una variabile da tastiera.
C       Presenta all'utente una descrizione della variabile (Commnt
C       e un valore di default (Valore).
C       Se l'utente risponde negativo ier<0
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

        IMPLICIT INTEGER (I-K)

        character*(*) Commnt
        DOUBLE PRECISION Valore
        character t(1),a1
        character*20 a
        character*300 stt_ap
        integer ier
        integer myslen

        ier=0
10      write(stt_ap,'(1x,a,a,F9.4,a)')Commnt(1:myslen(Commnt)),' ['
     >       ,Valore,' ]'
        t(1)=' '
        call sttdis(stt_ap(1:myslen(stt_ap)),0,ist)
        call stkwrc('INPUTC',1,t,1,20,i,i)                           

        call stkprc(' ','INPUTC',1,1,20,iletti,a,ikun,ik,is)

        if (a(1:4).eq.'redo'.or.a(1:4).eq.'REDO') then
                ier=-1
                return
        end if

        if (a(1:2).eq.'go'.or.a(1:2).eq.'GO') then
                ier=-99
                return
        end if

        if (a(1:1).eq.'c'.or.a(1:1).eq.'C') then
                ier=-98
                return
        end if


        a1=a
        if (a1.ne.' ') read(a,*,err=10)Valore

        return
        end

C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE AskR(Commnt,Valore,ier)
C  
C       Routine di I/O per leggere una variabile da tastiera.
C        Presenta all'utente una descrizione della variabile (Commnt)
C        e un valore di default (Valore).
C        Se l'utente risponde negativo ier<0
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

        IMPLICIT INTEGER (I-K)

        character*(*) Commnt
        real Valore
        character*300 stt_ap
        character*20 a
        character t(1),a1
        integer ier
        integer myslen

        ier=0
10        write(stt_ap,'(1x,a,a,F9.4,a)')Commnt(1:myslen(Commnt)),' ['
     >       ,Valore,' ]'
        call sttdis(stt_ap(1:myslen(stt_ap)),0,ifl)        
        t(1)=' ' 
        call stkwrc('INPUTC',1,t,1,1,i,i) 
        call stkprc(' ','INPUTC',1,1,20,iletti,a,ikun,ik,is)

        if (a(1:4).eq.'redo'.or.a(1:4).eq.'REDO') then
                ier=-1
                return
        end if

        if (a(1:2).eq.'go'.or.a(1:2).eq.'GO') then
                ier=-99
                return
        end if

        
        if (a(1:1).eq.'c'.or.a(1:1).eq.'C') then
                ier=-98
                return
        end if

        a1=a
        if (a1.ne.' ') read(a,*,err=10)Valore

        return
        end




C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE AskYN(Commnt,Valore,ier)
C
C        Routine di I/O per leggere una variabile da tastiera.
C        Presenta all'utente una descrizione della variabile (Commnt)
C        e un valore di default (Valore).
C        if ier in input=0, wait for a reply.
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

        IMPLICIT INTEGER (I-K)

        character*(*) Commnt
        logical Valore
        character*20 a,val
        integer ier
        character*300 stt_ap
        character t(1),a1
        integer myslen

        val='N'
        if (Valore) val='Y'
10        write(stt_ap,'(1x,a,a,a1,a)')Commnt(1:myslen(Commnt)),' [',
     >       Val,' ]'
        t(1)=' '
        call sttdis(stt_ap(1:myslen(stt_ap)),0,ist)
        call stkwrc('INPUTC',1,t,1,20,i,i) 
        call stkprc(' ','INPUTC',1,1,20,iletti,a,ikun,ik,is)

        if (iletti.eq.0) then
           if (ier.eq.0) goto 10
           ier=0
           return
        end if

        if (a(1:4).eq.'redo'.or.a(1:4).eq.'REDO') then
           ier=-1
           return
        end if


        if (a(1:2).eq.'go'.or.a(1:2).eq.'GO') then
           ier=-99
           return
        end if

        a1=a
        if (a1.ne.'Y'.and.a1.ne.'y'.and.a1.ne.'N'.and.a1.ne.'n')goto 10
        if (a1.eq.'Y'.or.a1.eq.'y') Valore=.true.
        if (a1.eq.'N'.or.a1.eq.'n') Valore=.false.

        ier=0

        return
        end


      
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
      SUBROUTINE AskC(Commnt,Valore,ier)
C     
C     Routine di I/O per leggere una variabile da tastiera.
C     Presenta all'utente una descrizione della variabile (Commnt)
C     e un valore di default (Valore).
C     ier = -2 in input: non mostra valore di default
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
      
        IMPLICIT INTEGER (I-K)

        character*(*) Commnt,Valore
        character*20 a
        integer ier
        character*300 stt_ap
        character t(1),a1
        integer myslen

 10     if (ier.eq.-2) then
           write(stt_ap,'(1x,a)')Commnt
        else 
           write(stt_ap,'(1x,a,a2,a,a2)')Commnt(1:myslen(Commnt)),' ['
     >          ,Valore(1:myslen(Valore)),' ]'
        end if
        t(1)=' '
        
        call sttdis(stt_ap(1:myslen(stt_ap)),0,ist)
        call stkwrc('INPUTC',1,t,1,20,i,i) 
        call stkprc(' ','INPUTC',1,1,20,iletti,a,ikun,ik,is)
        
        if (a(1:4).eq.'redo'.or.a(1:4).eq.'REDO') then
           ier=-1
           return
        end if
        
        
        if (a(1:2).eq.'go'.or.a(1:2).eq.'GO') then
           ier=-99
           return
        end if
        
        a1=a
        if (a1.ne.' ') Valore = a
        ier=0
        return
        end

C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE AskPar(iflag)
C        Ask all'utente una configurazione di righe,
C
Cccc        Nomefile :  char*(*)        Nome del file da aprire
C        iflag:            integer        error flag: if 0 ok, 
C                                if <0 user quitted
C
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
CC        implicit none
        integer iflag

        INCLUDE 'MID_REL_INCL:fit_var.inc'                ! Variabili globali

        character*30 Commnt 
        character*80 stt_ap

        integer iredo,ngroup,i,j,iclin,icpar,ist,itmp
        integer iexist,jold,jj,nj,ij,ik
        integer nli(100),icur
        character kli(100),a
        real xdum,ydum,z,vel

C        include 'MID_REL_INCL:fit_mid.inc'
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'


 100    iflag = 0
        iclin = 0
        icpar = 0

        
        if (NROWS.gt.0) then
           ngroup= 0
           do j=1,NROWS
              if (grID(j).gt.ngroup) then
                 ngroup=ngroup+1 
                 kli(ngroup)=Class(j)
                 if (ngroup.ne.1) nli(ngroup-1)=j-jold
                 jold=j
              end if
           end do
           nli(ngroup)=NROWS-jold+1
        end if
   
                 
        continue                        !inizio
        stt_ap='          ******* Line Configuration ******* '
        call sttdis(stt_ap,0,ist)
        call sttdis(' ',0,ist)
        call AskI('--> Number of groups of lines',ngroup,iredo)
        if (iredo.eq.-1) then
           iflag  = -1
           return
        end if
        if (iredo.eq.-99) then
c           iflag  = 0
           call sttdis('GO DISABLED, value unchanged',0,ist)
c           return
        end if
        if(ngroup.eq.0) goto 100

        do i=1,ngroup
           write(stt_ap,'(A5,I3,A9)')'  ###',i,'  group:'
           call sttdis(stt_ap,0,ist)
           call sttdis(' ',0,ist)
           itmp=nli(i)
 101       call AskI('  --> Number of lines: ',itmp,iredo)
           if (iredo.eq.-1)    goto 100
           if (iredo.eq.-99) then
c              iflag  = 0
              call sttdis('GO DISABLED, value unchanged',0,ist)
c              return
           end if
           nli(i)=itmp
           if (nli(i).eq.0) goto 101
           if (nli(i).eq.1) then
              kli(i)='S'
              goto 1000
           end if

 201       call AskC('  --> Kind of group (S,M,z,b,T)',kli(i),iredo)
           if (iredo.eq.-1)     goto 101
           if (iredo.eq.-99) then
              iflag  = 0
              return
           end if
           if (kli(i).eq.'s') kli(i)='S'
           if (kli(i).eq.'m') kli(i)='M'
           if (kli(i).eq.'Z') kli(i)='z'
           if (kli(i).eq.'B') kli(i)='b'
           if (kli(i).eq.'t') kli(i)='T'

 1000           continue
                do j=1,nli(i)
              iclin=iclin+1

 1001         write(stt_ap,'(A7,I3,A8)')'    ###',j,'  line:'
              call sttdis(stt_ap,0,ist)
 1002              Commnt='    --> Element name: (help)'
              Call AskC(Commnt,ElmtNm(iclin),iredo) 
              if (iredo.eq.-1)      goto 100
              if (iredo.eq.-99) then
                 iflag  = 0
                 return
              end if
                                ! help
          if (ElmtNm(iclin).eq.'help'.or.ElmtNm(iclin).eq.'HELP') then
                call sttdis('*** List of elements: **',0,ist)
                nj=nint(AT_N/5.)+1
                do ij=1,nj
                  write(stt_ap,'(1x,5A14)')(AT_NAM(ij+ik*nj),ik=0,4)
                  call sttdis(stt_ap,0,ist)
                end do
          end if
              iexist=0        ! Checks whether it exists.
              do jj=1,AT_N
                 if (ElmtNm(iclin).eq.AT_NAM(jj))  iexist=1
              end do  
              if (iexist.eq.0) goto 1002

 1101         if ((J.EQ.1).or.(j.gt.1.and.kli(i).eq.'S')) then
                 Commnt='    --> Central wavelength: '
                 Call AskD(Commnt,LamIni(iclin),iredo)
                 if (iredo.eq.-1)   goto 100
                 if (iredo.eq.-99) then
                    iflag  = 0
                    return
                 end if
                 if (I_GRAP.and.iredo.eq.-98) then ! legge cursore
                    call GetXCr(xdum,ydum,z,vel,icur)
                    LamIni(iclin)=xdum
                 end if
                 if (.not.I_GRAP.and.iredo.eq.-98) then ! legge cursore
                    call ErrMsg('Graphics not enabled')
                    goto 1101         
                 end if
                 icpar = icpar+1
                 write(CPar(1,iclin),'(i4)')icpar
              else
                 call CnvrtP(CPar(1,iclin-1),itmp,a,ist)
                 write(CPar(1,iclin),'(i2,A2)')itmp,'.z'
              end if
               
 1201         if ((J.EQ.1).or.(j.gt.1.and.kli(i).ne.'M')) then
                 Commnt='    --> Column density: '
                 Call AskD(Commnt,NIni(iclin),iredo)
                 if (iredo.eq.-1)    goto 100
                 if (iredo.eq.-99) then
                    iflag  = 0
                    return
                 end if
                 icpar = icpar+1
                 write(CPar(2,iclin),'(i4)')icpar
              else
                 call CnvrtP(CPar(2,iclin-1),itmp,a,ist)
                 write(CPar(2,iclin),'(i4)')itmp
              end if
          
 1301         if ((J.EQ.1).or.(j.gt.1.and.
     1             (kli(i).eq.'S'.or.kli(i).eq.'z'))) then
                 Commnt='    --> Doppler parameter: '
                 Call AskD(Commnt,BIni(iclin),iredo)
                 if (iredo.eq.-1)     goto 100
                 if (iredo.eq.-99) then
                    iflag  = 0
                    return
                 end if
                 icpar = icpar+1
                 write(CPar(3,iclin),'(i4)')icpar
                 
 1401            if (TURBLN.eq.1) then
                    Commnt='    --> Turbolence parameter: '
                    Call AskD(Commnt,BtuIni(iclin),iredo)
                    if (iredo.eq.-1)   goto 100
                    if (iredo.eq.-99) then
                       iflag  = 0
                       return
                    end if
                    icpar = icpar+1
                    write(CPar(4,iclin),'(i4)')icpar
                 end if
              else

                 call CnvrtP(CPar(3,iclin-1),itmp,a,ist)
                 if (kli(i).eq.'T') then
                    write(CPar(3,iclin),'(i2,A2)')itmp,'.T'
                 else
                    write(CPar(3,iclin),'(i4)')itmp
                 end if

                 if (TURBLN.eq.1) then
                    call CnvrtP(CPar(4,iclin-1),itmp,a,ist)
                    write(CPar(4,iclin),'(i4)')itmp
                 end if

              end if


           end do


        end do
        
        NROWS = iclin

        if (TURBLN.eq.0) then
           icpar = icpar+1
           do j=1,iclin
              write(CPar(4,j),'(i2,a2)')icpar,'.F'
              BTuIni(iclin) = 0.
           end do
        end if

        itmp=0
        do i=1,ngroup
           do j=1,nli(i)
              itmp=itmp+1
              Class(itmp)=kli(i)
              grId(itmp)=i
           end do
        end do

        return
        end




C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE AskFIn(iflag)
C        Ask all'utente una serie di intervalli fit
C
Cccc        Nomefile :  char*(*)        Nome del file da aprire
C        iflag:            integer        error flag: if 0 ok, 
C                                if <0 user quitted
C
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

CC        implicit none

        integer iflag

        INCLUDE 'MID_REL_INCL:fit_var.inc'                ! Variabili globali

        character*50 Commnt
        character*70 stt_ap

        integer iredo,i,istt,icurer
        real estrem,ydum,z,vel

C        include 'MID_REL_INCL:fit_mid.inc'
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'

        
C&&&&&&&
C     &        Chiede limiti su cui effettuare il fit
C&&&&&&&
 1000   continue                ! fine input parametri innesco
        
        call sttdis(' ',0,istt)
        call sttdis('             ******* Fit Intervals ******* ',
     1       0,istt)
        call sttdis(' ',0,istt)
        Commnt='### Number of intervals:'
        if (NINTFT .eq. 0) NINTFT = 1
        call AskI(Commnt,NINTFT,iredo)
        if (iredo.eq.-1) return
        if (iredo.eq.-99) goto 1100 ! salta altri input
        
        
        do i  = 1,NINTFT
           write(stt_ap,'(a,i2,a)')'  Input limits of ',i,' ^ interval'
           Commnt='    Minimum wavelength'
           call sttdis(stt_ap,0,istt)
           call AskD(Commnt,FITMIN(i),iredo)
           if (iredo.eq.-1) goto 1000
           if (iredo.eq.-99) goto 1100 ! salta altri input
           
           if (iredo.eq.-98) then ! legge cursore
              if (I_GRAP) then  
                 estrem =   FITMIN(i) 
                 call GetXCr(estrem,ydum,z,vel,icurer)
                 FITMIN(i) = estrem
                 Commnt='    Maximum wavelength'
                 write(stt_ap,'(1x,a,a,F9.4,a)')Commnt,' [',
     1                FITMAX(i),' ]'
                 call sttdis(stt_ap,0,istt)
                 estrem=FITMAX(i)
                 call GetXCr(estrem,ydum,z,vel,icurer)
                 FITMAX(i) = estrem
                 goto 510
              else
                 call ErrMsg('Graphic not enabled')
                 goto 1000
              end if
           end if 
           
           Commnt='    Maximum wavelength'
           call AskD(Commnt,FITMAX(i),iredo)
           if (iredo.eq.-1) goto 1000
           if (iredo.eq.-99) goto 1100 ! salta altri input
           
           if (iredo.eq.-98) then ! legge cursore
              if (I_GRAP) then  
                 call GetXCr(estrem,ydum,z,vel,icurer)                 
                 FITMAX(i) = estrem
              else
                 call Errmsg('Graphic not enabled')
                 goto 1000
              end if  
           end if
           
 510       continue
        end do        
        
 1100   call piksr2(NINTFT,FITMIN,FITMAX) ! sorting!!!
        
        iflag=0
        close (10)
        
        return
        end
      



C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE MMenu(Scelta)
C
C        Presenta il menu principale e ritorna una stringa
C        con l'opzione scelta TUTTA IN MAIUSCOLO
C        indipendentemente da come viene scritta.
C        Per fornire una risposta valida bisogna inviare
C        il carattere scritto in maiuscolo nel menu
C
C        Scelta        char*(*) out        Risposta valida
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        
        character*(*) Scelta
C        implicit none

        INCLUDE 'MID_REL_INCL:fit_var.inc'                ! Variabili globali
        
        character*1  Risp1
c        character*20 Risposta
        character*70 Mes
        CHARACTER*80 STROUT
        integer istt,j
        character*20 FilMen(10),DefMen(10),ManMen(10),GraMen(10)

C        include 'MID_REL_INCL:fit_mid.inc'
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'


C&&&&&&&
C     &        Presentazione menu
C&&&&&&&
        FilMen(1)='FILE'
        FilMen(2)=' '
        FilMen(3)='sa(V)e session '
        FilMen(4)='(R)ecover session'
        FilMen(5)='se(T)up'
        FilMen(6)='(E)ND'
        FilMen(7)=' '

        DefMen(1)='PARAMETERS'
        DefMen(2)=' '
        DefMen(3)='(N)ew'
        DefMen(4)='(I)terate'
        DefMen(5)='load from lo(G)'
        DefMen(6)=' '
        DefMen(7)=' '

        ManMen(1)='OPERATIONS'
        ManMen(3)='(S)TANDARD MINIM.'
        ManMen(4)='edit (P)aram'
        ManMen(5)='edit (L)imits'
        ManMen(6)='edit (M)inuit'
        ManMen(7)='(D)irect minimize'
        ManMen(2)=' '

        GraMen(1)='GRAPHICS'
        GraMen(2)=' '
        GraMen(3)='define (W)indow'
        GraMen(4)='plot (B)ackwards'
        GraMen(5)='plot (F)orward'
        GraMen(6)='(C)ursor'
        GraMen(7)=' '
        
 100    continue
                          !  Clear page?

           call sttdis(' ',0,istt)
           call sttdis(' ',0,istt)
           write(Mes,'(A14,F8.2,A4,F8.2,a2,i6,a8)')'Spectrum from ' 
     1          ,XLAMBD(1),' to ',XLAMBD(NPUNTI), ' (',NPUNTI,
     2          ' points)'
           call DisMsg(Mes)
           call sttdis(' ',0,istt)
           
           Mes ='************'
           write(strout,'(18x,A12,3x,A14,3x,A12)')Mes,'FITLYMAN  MENU',
     1          Mes
           call sttdis(strout,0,istt)
           call sttdis(' ',0,istt)
           call sttdis(' ',0,istt)
           do j=1,7
              write(strout,'(4A20)')FilMen(j),DefMen(j),ManMen(j),
     1             GraMen(j)
              call sttdis(strout,0,istt)
           end do

           Risp1=' '
           istt=-2
           call AskC(' ',Risp1,istt)
c           Risp1=Risposta
           if (Risp1.eq.'W'.or.Risp1.eq.'w') then
              Scelta='DEFINEWINDOW'
              return
           end if
           if (Risp1.eq.'b'.or.Risp1.eq.'B') then
              Scelta='GOBACK'
              return
           end if
           if (Risp1.eq.'f'.or.Risp1.eq.'F') then
              Scelta='GOFORW'
              return
           end if
           if (Risp1.eq.'c'.or.Risp1.eq.'C') then
              Scelta='CURSOR'
              return
           end if
           if (Risp1.eq.'n'.or.Risp1.eq.'N') then
              Scelta='NEWLINE'
              return
           end if
           if (Risp1.eq.'i'.or.Risp1.eq.'I') then
              Scelta='ITERATE'
              return
           end if
           if (Risp1.eq.'g'.or.Risp1.eq.'G') then
              Scelta='HISTORY'
              return
           end if
           if (Risp1.eq.'V'.or.Risp1.eq.'v') then
              Scelta='SAVESESSION'
              return
           end if
           if (Risp1.eq.'r'.or.Risp1.eq.'R') then
              Scelta='RECOVER'
              return
           end if
           if (Risp1.eq.'T'.or.Risp1.eq.'t') then
              Scelta='SET-UP'
              return
           end if
           if (Risp1.eq.'e'.or.Risp1.eq.'E') then
              Scelta='END'
              return
           end if
           if (Risp1.eq.'s'.or.Risp1.eq.'S') then
              Scelta='STANDARD'
              return
           end if
           if (Risp1.eq.'p'.or.Risp1.eq.'P') then
              Scelta='EDITPARAM'
              return
           end if
           if (Risp1.eq.'l'.or.Risp1.eq.'L') then
              Scelta='EDITLIM'
              return
           end if
           if (Risp1.eq.'M'.or.Risp1.eq.'m') then
              Scelta='EDITMINUIT'
              return
           end if
           if (Risp1.eq.'d'.or.Risp1.eq.'D') then
              Scelta='DIRECTMINI'
              return
           end if
        goto 100
        
        end
      


C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE ERRMSG(Messaggio)
C
C        Stampa un messaggio d'errore
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

        IMPLICIT INTEGER (I-K)

        character*(*) Messaggio
        character*80 a

        call bell(1)
        write(a,'(20x,a34)')'************ ERROR ***************'
        call sttdis(a,0,istt)
        call sttdis(' ',0,istt)
        call sttdis(Messaggio,0,istt)
        call sttdis(' ',0,istt)
        write(a,'(20x,a34)')'**********************************'
        call sttdis(a,0,istt)
        call stkprc('   Press <Return> to continue *****','INPUTC',
     1       1,1,20,iletti,a,ikun,ik,is)              
 
        return
        end        

C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE WRNMSG(Messaggio)
C
C        Stampa un messaggio d'errore
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

        IMPLICIT INTEGER (I-K)

        character*(*) Messaggio
        character*80 a

c        call bell(1)
        write(a,'(20x,a34)')'************ WARNING ***************'
        call sttdis(a,0,istt)
        call sttdis(Messaggio,0,istt)
        call sttdis(' ',0,istt)
 
        return
        end        
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE DISMSG(Messaggio)
C
C        Stampa un messaggio generico
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

        IMPLICIT INTEGER (I-K)

        character*(*) Messaggio
        character*79 MesDis
        character*73 Mes2

        Mes2 = Messaggio
        write(MesDis,'(A6,A)')' --->  ',Mes2
        call sttdis(MesDis,0,istt)

        return
        end        
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE bell(n)
C
C        manda n ring
C        
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

        INTEGER I,N,IER

        character b(1)
        b(1) = char(7)
                
        do i=1,n
                call sttdis(b,0,ier)
c                write(6,*)b
        end do
        return
        end



      function myslen(car1)
      
      character*(*) car1
      integer myslen

      integer i,clen


      clen = len(car1)
      do i = clen,1,-1
         if (car1(i:i).ne.' ') goto 99
      enddo

 99   continue
      myslen=i

      return
      end

C @(#)pcacif.for	19.1 (ES0-DMD) 02/25/03 13:27:33
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C-----------------------------------------------------------------------
C
C.IDENTIFICATION
C
C  Program PCACIF
C
C.AUTHOR
C
C  F. Murtagh, ST-ECF, Garching.             Version 1.0  9 May 1986
C  F. Murtagh                                Version 2.0  Oct. 1988
C                                            (New std. ifs.)
C  M. Peron                                  Version 3.0  Sep 91
C.PURPOSE
C
C  Pass parameters to, and execute, PCA (Principal Components Analysis).
C  The columns, only, are studied (i.e. in the objects space).
C
C.INPUT/OUTPUT
C
C  P1 - P5 contain parameters; these are: input table name, output
C  table name, PCA option (3 = on correlations, 2 = on covariances, 1 =
C  on SSCPs), number of principal components wanted (optional, - default
C  = 3), and whether or not a second output table is required, to store
C  the eigenvectors.
C
C.ALGORITHM
C
C . uses Midas Table interface routines;
C . input table is assumed to contain entries in single precision;
C . no select or nulls;
C . all columns of the input table are sent to the PCA routine;
C . description of the PCA routine is in the corresponding program;
C . the output produced consists of one (or two) tables, and descriptors
C   to the first of these (eigenvalues): view with
C   READ/DESC outtable.TBL *
C . storage is limited only by the Midas Table system, and by the
C   overall system limitations;
C . assumed is: NROW > 7 or NCOLIN (this isn't a restrictive assumption).
C
C.MODIFICATIONS
C
C   New MIDAS interface calls, F. Murtagh August 1988.
C
C-----------------------------------------------------------------------
        PROGRAM PCACIF
C
        CHARACTER*60     NAMEIN, NAMEOUT, TABEVEC
        CHARACTER*6     FORM
        CHARACTER*16    UNIT, LABEL, LABEL2
        INTEGER         MADRID, KUN, KNUL, DTYPE
        INTEGER         NACTV,ISTAT,TID1,NCOLIN,NROW,NSORTC
        INTEGER         NAC,NAR,I,LEN,NSEL,IWPTRIN,IPTRIN
        INTEGER         NTOT,INULL,IACTV,IERR,TID,TID2
        INTEGER         IADD0,IADD1,IADD2,IADD3,IADD4
        INTEGER         IPTROUT,IWPTROUT,IWPTROUT2
        INTEGER         NNCOL,NNROW,NSC1,NAROUT,IEVEC
        INTEGER         NCOLOUT,IOPTION,IPTROUT2,NNAC
        INTEGER         NAROUT2 
        INCLUDE 'MID_INCLUDE:TABLES.INC/NOLIST'
        COMMON /VMR/MADRID(1)
        INCLUDE 'MID_INCLUDE:TABLED.INC/NOLIST'
C
C
C ...   Assuming this is our first action ...
C
        CALL STSPRO('PCACIF')
        DTYPE = D_R4_FORMAT
C
C ...   Get table name as a keyword passed in the command line.
C
        CALL STKRDC('P1',1,1,60,NACTV,NAMEIN,KUN,KNUL,ISTAT)
C
C ...   Read input table.
C
        CALL TBTOPN(NAMEIN,16,TID1,ISTAT)
        CALL TBIGET(TID1,NCOLIN,NROW,NSORTC,NAC,NAR,ISTAT)
C        CALL TBCMAP(TID1,0,IPTRIN,ISTAT)
C
C ...   Some error checking on input.
C
        IF (NROW.LT.1.OR.NCOLIN.LT.1) THEN
           CALL STTPUT(' Nos. of rows/columns are less than 1.',ISTAT)
           CALL STTPUT(' What sort of a table is this ??',ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
C
        DO I = 1, NCOLIN
           CALL TBFGET(TID1,I,FORM,LEN,DTYPE,ISTAT)
           IF (DTYPE.NE.D_R4_FORMAT) THEN
              CALL STTPUT(' Illegal format:',ISTAT)
              CALL STTPUT(' Only R*4 column type allowed.',ISTAT)
              CALL STTPUT(' Aborting.',ISTAT)
              GOTO 9000
           ENDIF
        ENDDO

        CALL CHSEL(TID1,NROW,NSEL)
        IF (NSEL.NE.NROW) THEN
           CALL STTPUT(' Not all rows are SELECTed. ',ISTAT)
           CALL STTPUT(' In current implementation, MUST select all.',
     X                                                      ISTAT)
          CALL STTPUT(' Aborting.',ISTAT)
          GOTO 9000
       ENDIF
C
        CALL TDMGET(4*NROW*NCOLIN,IWPTRIN,ISTAT)
        CALL TBCMAP(TID1,1,IPTRIN,ISTAT)
        CALL MAPSM(MADRID(IPTRIN),MADRID(IWPTRIN),
     1              NAR,NROW,NCOLIN) 
        NTOT = NROW*NCOLIN
        CALL CHNULL(MADRID(IWPTRIN),NTOT,INULL)
        IF (INULL.NE.0) THEN
           CALL STTPUT
     X     (' Null entries in the table are not allowed.',ISTAT)
           CALL STTPUT
     X     (' Use SELECT, and then construct another table.',
     X                                                    ISTAT)
          CALL STTPUT(' Aborting.',ISTAT)
          GOTO 9000
       ENDIF
C
C
C ...   Get the output table name and no. cols. via keywords.
C
        CALL STKRDC('P2',1,1,60,IACTV,NAMEOUT,KUN,KNUL,ISTAT)
        CALL STKRDI('INPUTI',1,1,IACTV,IOPTION,KUN,KNUL,ISTAT)
        CALL STKRDI('INPUTI',2,1,IACTV,NCOLOUT,KUN,KNUL,ISTAT)
C
C ...   Now create the output (projections) table.
C
        CALL TBTINI(NAMEOUT,F_TRANS,17,NCOLOUT,NCOLIN,TID,ISTAT)
        FORM = 'G14.6'
        UNIT = ' '
C       (The messing around with LABEL2 which follows is so that
C       leading zeros in a column label appear as such, and not as
C       blanks.)
        LABEL = 'NEW00'
        LABEL2 = '10001'
        DO I = 1, NCOLOUT
           WRITE (LABEL2(1:5),100) I+10000
           LABEL(4:5) = LABEL2(4:5)
           CALL TBCINI(TID,DTYPE,1,FORM,UNIT,LABEL,I,ISTAT)
        ENDDO
  100   FORMAT(I5)
C
        CALL TBIGET(TID,NNCOL,NNROW,NSC1,NAC,NAROUT,ISTAT)
        CALL TDMGET(4*NCOLOUT*NCOLIN,IWPTROUT,ISTAT)
        CALL TBCMAP(TID,1,IPTROUT,ISTAT)
        CALL MAPSM(MADRID(IPTROUT),MADRID(IWPTROUT),
     1              NAROUT,NCOLIN,NCOLOUT)
C
        IEVEC = 0
        CALL STKRDC('INPUTC',1,1,60,IACTV,TABEVEC,KUN,KNUL,ISTAT)
        IF (TABEVEC.NE.'NO') THEN
           IEVEC = 1
           IF (NROW.LT.NCOLIN) THEN
           CALL STTPUT(' Warning.',ISTAT)
           CALL STTPUT
     X     (' Number of rows is usually > number of columns;',ISTAT)
           CALL STTPUT
     X     (' Eigenvector coords. in NCOLIN-dimension space are filed.',
     X                                                          ISTAT)
           CALL STTPUT('  ',ISTAT)
           ENDIF
C
C ...      Create the output (eigenvectors) table.
C
           CALL TBTINI(TABEVEC,F_TRANS,17,NCOLOUT,NCOLIN,TID2,ISTAT)
C          (The messing around with LABEL2 which follows is so that
C          leading zeros in a column label appear as such, and not as
C          blanks.)
           LABEL = 'EVC00'
           LABEL2 = '10001'
           DO I = 1, NCOLOUT
              WRITE (LABEL2(1:5),100) I+10000
              LABEL(4:5) = LABEL2(4:5)
              CALL TBCINI(TID2,DTYPE,1,FORM,UNIT,LABEL,I,ISTAT)
           ENDDO
C
           CALL TBIGET(TID2,NNCOL,NNROW,NSC1,NNAC,NAROUT2,ISTAT)
           CALL TDMGET(4*NCOLOUT*NCOLIN,IWPTROUT2,ISTAT)
           CALL TBCMAP(TID2,1,IPTROUT2,ISTAT)
           CALL MAPSM(MADRID(IPTROUT2),MADRID(IWPTROUT2),
     1                NAROUT2,NCOLIN,NCOLOUT) 
        ENDIF
C

C
C ...   Allocate storage.
C
        CALL GETSTOR(NROW*NCOLIN,IADD0)
        CALL GETSTOR(NCOLIN*NCOLIN,IADD1)
        CALL GETSTOR(NCOLIN*NCOLIN,IADD2)
        CALL GETSTOR(NCOLIN,IADD3)
        CALL GETSTOR(NCOLIN,IADD4)
C
C ...   We now have all the storage we need; APPL will look after
C       a few further odds and ends - e.g. setting a few hard-wired
C       options, rearranging output, etc.  Then it will call the
C       application program.
C
        IERR = 0
        IF (IEVEC.EQ.0) THEN
        CALL APPL1(NROW,NCOLIN,NCOLOUT,MADRID(IWPTRIN),MADRID(IWPTROUT),
     X     MADRID(IADD0),MADRID(IADD1),MADRID(IADD2),MADRID(IADD3),
     X     MADRID(IADD4),IOPTION,IERR)
        CALL MAPBG(MADRID(IWPTROUT),MADRID(IPTROUT),
     1             NAROUT,NCOLIN,NCOLOUT)
        ELSE
        CALL APPL2(NROW,NCOLIN,NCOLOUT,MADRID(IWPTRIN),MADRID(IWPTROUT),
     X     MADRID(IADD0),MADRID(IADD1),MADRID(IADD2),MADRID(IADD3),
     X     MADRID(IADD4),MADRID(IWPTROUT2),IOPTION,IERR)
        CALL MAPBG(MADRID(IWPTROUT),MADRID(IPTROUT),
     1             NAROUT,NCOLIN,NCOLOUT)
        CALL MAPBG(MADRID(IWPTROUT2),MADRID(IPTROUT2),
     1             NAROUT2,NCOLIN,NCOLOUT)
        ENDIF
        IF (IERR.NE.0) THEN
           CALL STTPUT(' IERR not 0 on return from PCA.',ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
C
C ...   Write out descriptors with output table.
C
        CALL DSCROUT(NAMEOUT,NROW,NCOLIN,MADRID(IADD3),TID)
C
C ...   Finish up: write output file to disk, and release memory space.
C
        CALL RELSTOR(NROW*NCOLIN,IADD0)
        CALL RELSTOR(NCOLIN*NCOLIN,IADD1)
        CALL RELSTOR(NCOLIN*NCOLIN,IADD2)
        CALL RELSTOR(NCOLIN,IADD3)
        CALL RELSTOR(NCOLIN,IADD4)
C
        CALL TBTCLO(TID1,ISTAT)
C
        CALL TBIPUT(TID,NCOLOUT,NCOLIN,ISTAT)
        CALL TBSINI(TID,ISTAT)
        CALL TBTCLO(TID,ISTAT)
        IF (IEVEC.NE.0) THEN
           CALL TBIPUT(TID2,NCOLOUT,NCOLIN,ISTAT)
           CALL TBSINI(TID2,ISTAT)
           CALL TBTCLO(TID2,ISTAT)
        ENDIF
C
 9000   CONTINUE
        CALL STSEPI
C
        END
C----------------------------------------------------------------------
        SUBROUTINE APPL1(NR,NC1,NC2,AIN,AOUT,ACREA,A1,A2,W1,W2,
     X                  METHOD,IERR)
C
C ...   This is now the application routine - note the setting of
C       parameters, which in a future epoch may be passed if desired
C       on the command line.
C
        INTEGER NR,NC1,NC2,METHOD,IERR,IPRINT,I,J
        REAL*4  AIN(NR,NC1), AOUT(NC1,NC2), ACREA(NR,NC1),A1(NC1,NC1),
     X          A2(NC1,NC1),W1(NC1),W2(NC1)
C
        IPRINT = 3
C
        DO I = 1, NR
           DO J = 1, NC1
              ACREA(I,J) = AIN(I,J)
           ENDDO
        ENDDO
C
        CALL PCA(NR,NC1,ACREA,METHOD,IPRINT,A1,W1,W2,A2,IERR)
C
        IF (IERR.NE.0) RETURN
C
        DO I = 1, NC1
           DO J = 1, NC2
              AOUT(I,J) = A1(I,J)
           ENDDO
        ENDDO
C
        RETURN
        END
C----------------------------------------------------------------------
        SUBROUTINE APPL2(NR,NC1,NC2,AIN,AOUT,ACREA,A1,A2,W1,W2,
     X             EVEC,METHOD,IERR)
C
C ...   This is now the application routine - note the setting of
C       parameters, which in a future epoch may be passed if desired
C       on the command line.
C
        INTEGER NR,NC1,NC2,I,J,IERR,IPRINT,METHOD
        REAL*4  AIN(NR,NC1), AOUT(NC1,NC2), ACREA(NR,NC1),A1(NC1,NC1),
     X          A2(NC1,NC1),W1(NC1),W2(NC1),EVEC(NC1,NC2)
C
        IPRINT = 1
C
        DO I = 1, NR
           DO J = 1, NC1
              ACREA(I,J) = AIN(I,J)
           ENDDO
        ENDDO
C
        CALL PCA(NR,NC1,ACREA,METHOD,IPRINT,A1,W1,W2,A2,IERR)
C
        IF (IERR.NE.0) RETURN
C
        DO I = 1, NC1
           DO J = 1, NC2
              AOUT(I,J) = A1(I,J)
           ENDDO
        ENDDO
C
        DO I = 1, NC1
           DO J = 1, NC2
              EVEC(I,J) = A2(I,NC1-J+1)
           ENDDO
        ENDDO
C
        RETURN
        END
C-------------------------------------------------------------------------
        SUBROUTINE CHNULL(X,NT,NULL)
C ...   Check if null values are present.
        REAL*4  X(NT), TRNULL
        INTEGER TINULL,NULL,NT,I
        DOUBLE PRECISION TDNULL
        CALL TBMNUL(TINULL,TRNULL,TDNULL)
        NULL = 0
        DO I = 1, NT
           IF (X(I).EQ.TRNULL) NULL = NULL + 1
           IF (NULL.GT.0) RETURN
        ENDDO
        RETURN
        END
C-------------------------------------------------------------------------
        SUBROUTINE GETSTOR(NVALS,IPTR)
C ...   Allocate storage space for NVALS real values.
        INTEGER NVALS,IPTR,ISTAT
        CALL TDMGET(4*NVALS,IPTR,ISTAT)
        RETURN
        END
C-------------------------------------------------------------------------
        SUBROUTINE RELSTOR(NVALS,IPTR)
C ...   Release storage space (already allocated) for NVALS real values.
        INTEGER NVALS,IPTR,ISTAT
        CALL TDMFRE(4*NVALS,IPTR,ISTAT)
        RETURN
        END
C---------------------------------------------------------------------
        SUBROUTINE DSCROUT(TAB,N,M,VALS,TID2)
C ...   Output descriptors, with table.
        INTEGER N,M,TID2,I,INDX,MM
        INTEGER KUNIT,ISTAT
        REAL*4 VALS(M),V
        CHARACTER TAB*8, TABNAME*12
C
C ...   The following values are rearranged in decreasing rather
C       than increasing order.
        DO I = 1, M/2
           V = VALS(I)
           VALS(I) = VALS(M-I+1)
           VALS(M-I+1) = V
        ENDDO
C
        INDX = INDEX(TAB//' ',' ')-1
        TABNAME = TAB(1:INDX)//'.TBL'
C
        MM = MIN0(N,M)
        CALL STDWRR(TID2,'EIGENVALUES',VALS,1,MM,KUNIT,ISTAT)
C
        RETURN
        END

C @(#)adjpsf.for	19.1 (ES0-DMD) 02/25/03 13:25:31
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C
C-----------------------------------------------------------------------
      SUBROUTINE ADJPSF(RARR, LPXL, LSBP, CPSF)
      IMPLICIT  NONE
C
      REAL      RARR(64)           ! IN: Real keywords
      INTEGER   LPXL               ! IN: Half-number of p.s.f. pixels
      INTEGER   LSBP               ! IN: Half-number of subpixels
      REAL      CPSF((-LPXL):LPXL,(-LPXL):LPXL,
     &               (-LSBP):LSBP,(-LSBP):LSBP)   ! MOD: Two dimensional p.s.f.
C
      INTEGER   I
      INTEGER   ITMP
      INTEGER   I1, I2
      INTEGER   J
      INTEGER   J1, J2
      INTEGER   K
      INTEGER   K1, K2
      INTEGER   L
      INTEGER   L1, L2
C
      REAL      A1
      REAL      CORR
      REAL      TEMP, TEMP1, TEMP2
C
C *** Calculate average of two first points in
C *** one-dimensional point spread function.
      A1 = 10.0 ** (-RARR(14))
      TEMP1 = ( 1.0 + 8.0 * ( 10.0 ** (-RARR(14)) ) ) / 9.0
      TEMP2 = 0
C
C *** Select matching region of two-dimensional p.s.f.
C
      I1 = MAX( -1 , -LPXL )
      I2 = MIN( 1 , LPXL )
      J1 = MAX( -1 , -LPXL )
      J2 = MIN( 1 , LPXL )
      K1 = -LSBP
      K2 = LSBP
      L1 = -LSBP
      L2 = LSBP
C
C *** Calculate corresponding average of two-dimensional p.s.f.
C
      TEMP = 0.0
      DO 10 L = L1 , L2 
          DO 20 K = K1 , K2
              DO 30 J = J1 , J2
                  DO 40 I = I1 , I2
                      TEMP2 = TEMP2 + CPSF(I,J,K,L)
   40             CONTINUE
   30         CONTINUE
   20     CONTINUE
   10 CONTINUE
      ITMP = ( ( (2*LSBP+1)**2 ) * (J2-J1+1) * (I2-I1+1) )
      TEMP2 = TEMP2 / FLOAT(ITMP)
      IF ( TEMP2 .LE. 0.0 ) RETURN
      IF ( LPXL .EQ. 0 ) THEN
          CORR = 1.0 / TEMP2
      ELSE
          CORR = TEMP1 / TEMP2
      ENDIF
C
C *** Correct two-dimensional point spread function.
C
      DO 50 L = L1 , L2
          DO 60 K = K1 , K2
              DO 70 J = -LPXL , LPXL
                  DO 80 I = -LPXL , LPXL
                      CPSF(I,J,K,L) = CPSF(I,J,K,L) * CORR
   80             CONTINUE
   70         CONTINUE
   60     CONTINUE
   50 CONTINUE
C
      RETURN
      END

C @(#)rfotaddst.for	19.1 (ES0-DMD) 02/25/03 13:30:13
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
       PROGRAM ADDST
C+++
C.IDENTIFICATION: RFOTADDST
C.PURPOSE: Create an artifial image identical to the original with inserted
C          subframes
C.AUTHOR:  R. Buonanno, G. Buscema, C. Corsi, I. Ferraro, G. Iannicola
C          Osservatorio Astronomico di Roma
C.VERSION: 880922 RXB First version in MIDAS
C          890217 RHW Converted to ST intercafes, standard code
C          890808 RHW MIDAS table file system implemented 
C.VERSION  900122 RHW IMPLICIT NONE added; all variables defiend	
C----
      IMPLICIT     NONE
      INCLUDE     'MID_REL_INCL:RFOTDECL.INC'
C
      INTEGER      MXDIM
      INTEGER      MXCMP
      INTEGER      MXWND
      PARAMETER    (MXDIM=1024)
      PARAMETER    (MXCMP=500)
      PARAMETER    (MXWND=100)
C
      INTEGER      ICOL(12)
      INTEGER      IDUM2, IDUM3
      INTEGER      IDUM6, IDUM7, IDUM8, IDUM9, IDUM14, IDUM15
      INTEGER      IXA(MXCMP), IYA(MXCMP)
      INTEGER      ISTAT, IAV
      INTEGER      I, IY, IDX, IDY, IGRP, IRN, IROW
      INTEGER      IBO, IBA
      INTEGER      IMFO
      INTEGER*8    IPOU
      INTEGER      IX1, IY1
      INTEGER      IDIFX, IDIFY, INDX, INDY
      INTEGER      JX, JY
      INTEGER      J, JBO
      INTEGER      KVI(3)
      INTEGER      KUN, KNUL
      INTEGER      K, KW
      INTEGER      LX0, LY0, LX, LY, IX0, IY0
      INTEGER      MADRID(1)
      INTEGER      NPIX(3)
      INTEGER      NAXIS, NPL, NL
      INTEGER      NCOMP, NCO, NRO, NSC, NSTOT
      INTEGER      NSA, ICROW, NUMST
      INTEGER      TIDCAT, TIDREG
      INTEGER      TINULL
C
      DOUBLE PRECISION BEGIN(3),STEP(3)
      DOUBLE PRECISION TDNULL,TDTRUE,TDFALS
      REAL         PLX, PLY
      REAL         PPP, SAV
      REAL         RVV(MXWND,MXWND)
      REAL         RXV(MXWND)
      REAL         RMV(MXDIM)
      REAL         RDUM4, RDUM5, RDUM6, RDUM7, RDUM8
      REAL         RDUM9, RDUM10, RDUM11, RDUM12, RDUM13
      REAL         TAB(12)
      REAL         TRNULL
      REAL         TBLSEL
      REAL         VIV(MXWND,MXWND)
      REAL         XXX, YYY
      REAL         XQ(MXCMP)
      REAL         YQ(MXCMP)
      REAL         RAN3
C
      CHARACTER    IDENT*72,CUNIT*80
      CHARACTER    FRAMO*60,REGFIL*60,CATFIL*60
C     CHARACTER    VET*8
      CHARACTER    STRING*80
      LOGICAL      SFLAG
      LOGICAL      NUL(12)
C
      INCLUDE     'MID_INCLUDE:ST_DEF.INC'
      COMMON      /VMR/MADRID
      INCLUDE     'MID_INCLUDE:ST_DAT.INC'
      DATA         ICOL/2,3,4,5,6,7,8,9,10,11,12,13/
C
C *** Hello, is MIDAS out there?
      CALL STSPRO('ADDST')
C
C *** get the frame and read all relevant descriptors
      CALL STKRDC('OUT_A',1,1,60,IAV,FRAMO,KUN,KNUL,ISTAT)
      CALL STIGET(FRAMO,D_R4_FORMAT,F_IO_MODE,F_IMA_TYPE,
     2            3,NAXIS,NPIX,BEGIN,STEP,IDENT,CUNIT,IPOU,IMFO,ISTAT)
      NPL = NPIX(1)
      NL  = NPIX(2)
C
C *** Input table
      CALL STKRDC('IN_B',1,1,60,IAV,REGFIL,KUN,KNUL,ISTAT)
      CALL TBTOPN(REGFIL,0,TIDREG,ISTAT)
C
C *** Output cat_file
      CALL STKRDC('OUT_B',1,1,60,IAV,CATFIL,KUN,KNUL,ISTAT)
      CALL CATINI(CATFIL,TIDCAT)
C
C *** number of position and the subarray dimensions
      CALL STKRDI('INPUTI',1,2,IAV,KVI,KUN,KNUL,ISTAT)
      IDX   = KVI(1)
      IDY   = KVI(2)
      PLX   = NPL-IDX-2
      PLY   = NL -IDY-2
      CALL STKRDI('INPUTI',3,1,IAV,NCOMP,KUN,KNUL,ISTAT)
C
C *** get the registration table opened
      CALL TBMNUL(TINULL,TRNULL,TDNULL)
      CALL TBMCON(TBLSEL,TDTRUE,TDFALS)
      CALL TBIGET(TIDREG,NCO,NRO,NSC,KW,NSA,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL: Problems with opening '//
     2            'the registration file'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
C
      ICROW = 0
      NUMST = 0
      IRN   = 0
C
      DO 100 IROW = 1,NRO
         CALL TBSGET(TIDREG,IROW,SFLAG,ISTAT)
         IF (SFLAG) THEN
            NUMST = NUMST + 1
            CALL TBRRDR(TIDREG,IROW,12,ICOL,TAB,NUL,ISTAT)
            IX0 = TAB(1)-IDX/2-BEGIN(1)+1
            IY0 = TAB(2)-IDY/2-BEGIN(2)+1
            LX  = IDX
            LY  = IDY
            JX  = LX/2
            JY  = LY/2
            IF (IX0.LT.1) THEN
               LX  = LX+IX0-1
               IX0 = 1
               JX  = TAB(1)-BEGIN(1)
            END IF
C
            IF (IX0+LX-1.GT.NPL) THEN
               LX  = NPL-IX0+1
            ENDIF
            IF (IY0.LT.1) THEN
               LY  = LY+IY0-1
               IY0 = 1
               JY  = TAB(2)-BEGIN(2)
            END IF
            IF (IY0+LY-1.GT.NL) THEN
               LY  = NL-IY0+1
            ENDIF
C
            DO 110 IBO = 1,LY
               IY = IY0+IBO-1 
               CALL REALIN(NPL,NL,IY,IX0,LX,MADRID(IPOU),RXV)
               DO 111 JBO = 1,LX
                  RVV(JBO,IBO) = RXV(JBO)-TAB(4)           ! subtract background
  111          CONTINUE
  110       CONTINUE
C
            LX0 = LX
            LY0 = LY
C
            DO 120 IBA=1,NCOMP 
               IRN      = IRN + IX0 + IY0
               XXX      = RAN3(IRN)
               YYY      = RAN3(IRN)
               XQ(IBA)  = XXX*PLX+IDX/2+1
               YQ(IBA)  = YYY*PLY+IDY/2+1
               IXA(IBA) = XQ(IBA)                          ! get randow position
               IYA(IBA) = YQ(IBA)
C
               ICROW = ICROW + 1
               IGRP  = ICROW  
C
               IX1   = IXA(IBA)-JX
               IY1   = IYA(IBA)-JY
               IF (IX1.LT.1) THEN
                  LX  = LX+IX1-1
                  IX1 = 1
               END IF
C
               IF (IX1+LX-1.GT.NPL) THEN
                  LX  = NPL-IX1+1
               ENDIF
               IF (IY1.LT.1) THEN
                  LY  = LY+IY1-1
                  IY1 = 1
               END IF
               IF (IY1+LY-1.GT.NL) THEN
                  LY  = NL-IY1+1
               ENDIF
               XQ(IBA) = XQ(IBA)+BEGIN(1)-1                      ! position in x
               YQ(IBA) = YQ(IBA)+BEGIN(2)-1                      ! position in y
               CALL CATTWR(TIDCAT,ICROW,IGRP,XQ(IBA),YQ(IBA),TAB(3),
     2                            TAB(8),RDUM5,RDUM6,RDUM7,RDUM8,RDUM9,
     3                            RDUM10,RDUM11,RDUM12,RDUM13)
C
C *** determine the value of the array VIV(i,j) where i=1 corresponds
C     with IX1 and j=1 corresponds with IY1
               IDIFX    = LX-LX0
               IDIFY    = LY-LY0
               DO 121 J = 1,LY
                  DO 122 K = 1,LX
                     VIV(K,J) = RVV(K-IDIFX,J-IDIFY)         ! input window data
  122             CONTINUE
  121          CONTINUE
C
               DO 200 J = IY1,IY1+LY-1
                  INDY = J-IY1+1
                  CALL REALIN(NPL,NL,J,1,NPL,MADRID(IPOU),RMV)    !output window
                  DO 210 I = IX1, IX1+LX-1
                     INDX = I-IX1+1
                     PPP = RMV(I) + VIV(INDX,INDY)               ! add component
C                    PPP = VIV(INDX,INDY)                
                     IF (PPP.LT.0) THEN
                        PPP = 0.
                     ENDIF
                     RMV(I) = PPP
                     IF (RMV(I).GT.0.) SAV    = RMV(I)
                     IF (RMV(I).LE.0.) RMV(I) = SAV
  210             CONTINUE
                  CALL WRILIN(NPL,NL,J,1,NPL,MADRID(IPOU),RMV)
  200          CONTINUE
  120       CONTINUE
         ENDIF
  100 CONTINUE
C
C *** write the number of objects in the catalogue descriptor
      NSTOT = NUMST*NCOMP
      CALL CATDWR(TIDCAT,NSTOT,IDUM2,IDUM3,RDUM4,RDUM5,IDUM6,IDUM7,
     2                   IDUM8,IDUM9,RDUM10,RDUM11,RDUM12,RDUM13,
     3                   IDUM14,IDUM15)
      CALL TBSINI(TIDCAT,ISTAT)
      CALL TBTCLO(TIDCAT,ISTAT)
      CALL TBTCLO(TIDREG,ISTAT)
      CALL STSEPI
      END

C @(#)neczebpar.for	19.1 (ES0-DMD) 02/25/03 14:20:26
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1991 Special Astrophisical Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, 26 Aug 1991
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: A.Yu.Kniazev, V.Shergin
C
C.IDENTIFICATION
C                  ZEB_PAR.FOR
C
C.KEYWORDS
C  echelle (ZEBRA), parameters
C
C.PURPOSE
C Determination of the parameters for echelle images (ZEBRA)
C in single observation set.
C
C
C.ALGORITHM
C
C.INPUT/OUTPUT
C  input keywords are:
C  ZEBRAC(1:8)   INPUT   - IMAGE NAME
C  ZEBRAC(20)    INPUT   - PLOT KEY
C  ZEBRAI(1)     INPUT   - the number of column for begin work
C  ZEBRAI(2)     INPUT   - the half of zone for begin work
C
C Program output parameters in keywords:
C   ZEBRAR(1)  -    the mean slope of echelle spectra
C   ZEBRAR(2)  -    the mean width of orders
C
C  COMMAND :
C  DETERMIN/ZEB INPUT
C
C-----------------------------------------------------------------
      PROGRAM ZEBPAR

      IMPLICIT NONE
      INTEGER   ISLOST, LWORD
      REAL      ACCUR
      PARAMETER (ISLOST = 12)
      PARAMETER (ACCUR  = 0.005)
      INTEGER MADRID(1)
      INTEGER ACTVAL,I,K,ISTAT
      INTEGER NAXIS,NDIM
      INTEGER IVEC1, IVEC2
      INTEGER PNTRA,STATUS,WINDOW
      INTEGER NPIX(3), KUN, KNUL, IMNO, IJ
      DOUBLE PRECISION START(3),STEP(3)
      DOUBLE PRECISION ST
      CHARACTER*80 CA
      CHARACTER*72 IDENA
      CHARACTER*80 LINE
      CHARACTER*64 CUNITA
      CHARACTER*8  FRMIN
      CHARACTER*1  PLOT
C
      REAL INCL, XINCL  !  orders inclination coefficient
      REAL SINCL        !  step of change INCL
      INTEGER ORDWID    !  average width of ORDER
      INTEGER COLUMN(2) !  number of column for begin work
      INTEGER IDIR, FLAG
      REAL    AM        !  amplitude
      REAL    XC        !
      REAL    HWHI      !  average width of ORDER (It's main)
C      REAL    CUTS(2)   !  minimum, maximum
C      INTEGER PIX(2)    !  index of minimum and maximum pixel
      REAL    TMP(-1:1) !  output value width of order
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      CA = 'COUNTS'
      ST = 1.D0
      NDIM   = 3
C
C ... initialize system and read parameters
C
      CALL STSPRO('ZEBPAR')
      CALL STKRDC('IN_A',1,1,60,ACTVAL,FRMIN,KUN,KNUL,STATUS)
      CALL STKRDI('INPUTI',1,2,ACTVAL,COLUMN,KUN,KNUL,STATUS)
      CALL STKRDC('INPUTC',1,1,1,ACTVAL,PLOT,KUN,KNUL,STATUS)
C
      CALL STTPUT(' ZEBRA PARAMETERS DETERMINATION',ISTAT)
      CALL STTPUT(' ------------------------------',ISTAT)
      CALL STTPUT(' INPUT IMAGE  : '//FRMIN,ISTAT)
      WRITE (LINE,9040) COLUMN(1)
      CALL STTPUT(LINE ,ISTAT)
      WRITE (LINE,9050) COLUMN(2)
      CALL STTPUT(LINE ,ISTAT)
      CALL STTPUT(' PLOT FLAG  : '//PLOT,ISTAT)
C
C ... read frame
C
      CALL STIGET(FRMIN,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     .NDIM,NAXIS,NPIX,START,STEP,IDENA,CUNITA,PNTRA,IMNO,STATUS)
C
C ... generate working space
C
      CALL STIPUT('ZEBRA.TMP',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,1,
     .            NPIX(2)*4,ST,ST,CA,CA,IVEC1,IJ,STATUS)
      IVEC2 = IVEC1 + NPIX(2)
C
C ... start step-by-step fitting process to find optimal inclination
C ... coefficient corresponding to minimum order width
      WINDOW  = NPIX(2)/5
      FLAG    = 0
      IDIR    = 0
      INCL    = 0.
      XINCL   = 0.
      SINCL   = 0.1
C
C ... next step  (or 3 steps when IDIR = 0)
 10   DO I = -1, 1, 1
        IF (IDIR .EQ. I .OR. IDIR .EQ. 0) THEN
        IF (I .NE. 0 .OR. FLAG .EQ. 0) THEN
           INCL = XINCL + SINCL*I
C ... extract and plot "averaging" column
C23456789012345678901234567890123456789012345678901234567890123456789012345678
           CALL EXTRAV(MADRID(PNTRA),NPIX(1),NPIX(2),COLUMN(1),
     .                 COLUMN(2),INCL,MADRID(IVEC1))
         IF (PLOT(1:1) .EQ. 'Y' .OR. PLOT(1:1) .EQ. 'y')
     .    CALL PLTARR(MADRID(IVEC1),NPIX(2),100,(NPIX(2)-150),FRMIN,0)
C ...   calculate  "autocorrelation"
          CALL CONVL(MADRID(IVEC1),1,NPIX(2),1,1,MADRID(IVEC2),WINDOW)
           IF (PLOT(1:1) .EQ. 'Y' .OR. PLOT(1:1) .EQ. 'y') THEN
               K = NPIX(2)/2-WINDOW
               CALL PLTARR(MADRID(IVEC2),NPIX(2),K,K+WINDOW*2,FRMIN,1)
           ENDIF
C ... determine order width
           ORDWID = LWORD(MADRID(IVEC2),NPIX(2),NPIX(2)/2,AM,XC,HWHI)
           TMP(I) = HWHI
        ENDIF
        ENDIF
      ENDDO
C
      IF ((TMP(-1) .LT. TMP(0)) .AND. (TMP(-1) .LT. TMP(1))) THEN
        IDIR   = -1
        TMP(1) = TMP (0)
        TMP(0) = TMP (-1)
        XINCL  = INCL - 2*SINCL
      ELSE IF ((TMP(1) .LT. TMP(0)) .AND. (TMP(1) .LT. TMP(-1))) THEN
        IDIR   =  1
        TMP(-1)= TMP (0)
        TMP(0) = TMP (1)
        XINCL  = INCL
      ELSE
        IDIR   = 0
        FLAG   = 1
        SINCL  = SINCL/2
        WRITE (*,*) 'New step =',SINCL
      ENDIF
C
C      WRITE (LINE,9000) TMP(0)*2
C      CALL STTPUT(LINE,ISTAT)
      WRITE (LINE,9010) XINCL
      CALL STTPUT(LINE,ISTAT)
      CALL STTPUT(' ------------------------------',ISTAT)
      IF (SINCL .GT. ACCUR) GOTO 10
C
      CALL STKWRR('OUTPUTR',XINCL,1,1,KUN,STATUS)
      CALL STKWRR('OUTPUTR',TMP(0)*2,2,1,KUN,STATUS)
      CALL STTPUT('--------------------',ISTAT)
      WRITE (LINE,9020) TMP(0)*2
      CALL STTPUT(LINE,ISTAT)
      WRITE (LINE,9030) XINCL
      CALL STTPUT(LINE,ISTAT)
C ... that's all ...
C ... free data
      CALL STSEPI
 9000 FORMAT ('OrderWidth: ',F8.4)
 9010 FORMAT ('Inclination_ of_Order: ',F8.4)
 9020 FORMAT ('Min_Order_Width: ',F8.4)
 9030 FORMAT ('Optimum_Inclination_of_Order: ',F8.4)
 9040 FORMAT ('Center_Column: ',I6)
 9050 FORMAT ('Half_of_width: ',I6)

      END

C*****************************************************************
      SUBROUTINE EXTRAV(X,N1,N2,I,WIDTH,INCL,OUT)
C
C       Extract (with averaging) 2*WIDHT+1 vertical columns
C       from image array X(N1,N2) centered at I-column
C
      INTEGER N1            ! IN
      INTEGER N2            ! IN
      REAL    X(N1, N2)     ! IN - input image
      INTEGER I             ! IN - position of center column
      INTEGER WIDTH         ! IN - +- from I-column
      REAL    INCL          ! IN - orders inclination coefficient
      REAL    OUT(N2)       ! OUT- output trace
C
      INTEGER J, J1, K, K1
C
      DO 10 J = 1, N2
         OUT(J) = 0.
         DO 20 K = I-WIDTH,I+WIDTH
            J1 = MAX(1, MIN(N2, INT(J + (K-I)*INCL + 0.5)))
            IF (K .LT. 1)  THEN
                K1 = -(K-1)
            ELSE IF (K .GT. N1) THEN
                K1 = N1-(K-N1)
            ELSE
                K1 = K
            ENDIF
            OUT(J) = OUT(J) + X(K1,J1)
20       CONTINUE
         OUT(J) = OUT(J)/(2*WIDTH+1)
10    CONTINUE
      RETURN
      END


C*****************************************************************
      SUBROUTINE CONVL(X,N1,N2,I1,I2,OUT,NSTEP)
C
C       Perform "convolution" of two vertical columns: I1, I2
C       of image array X(N1,N2)
C
      INTEGER N1                ! IN
      INTEGER N2                ! IN
      REAL    X(N1, N2)         ! IN
      INTEGER I1, I2            ! IN - NUMERICS OF COLUMN
      REAL    OUT(N2)           ! OUT
      INTEGER NSTEP             ! IN
C
      INTEGER J, K, N, N22
      REAL S, S1
C
      N22 = N2/2
      N = MIN0(NSTEP,N22-1)
      S1 = 0.
      DO 10 K = 1, N2
         OUT(K) = 0.
         S1 = S1 + X(I1,K)
10    CONTINUE
      DO 30 J = -N, N
         S = 0.
         DO 20 K = 1, N2
            S = S + X(I1,K)*X(I2,MOD(N2+K+J-1,N2)+1)
20       CONTINUE
         OUT(N22+J) = S/S1
30    CONTINUE
      RETURN
      END

C*****************************************************************
      INTEGER FUNCTION LWORD(INP,NP,CENTER,AM,XC,HWHI)
C
C      Determine new order width
C
      INTEGER NP                   ! IN arr.length
      REAL    INP(NP)              ! IN input array
      INTEGER CENTER               ! IN center pixel of contour
      REAL    AM, XC, HWHI         ! OUT output params
C
      INTEGER I, K, WND, IC
      REAL    A, B, D, A11, A12, A22, B1, B2
      REAL    X, Y, Y1, Y2
C
C ... at first - rough estimation of HWHI
      K = NP
      DO I = CENTER+1,NP-1
        IF (INP(I) .LE. INP(CENTER)/2.) THEN
            K = I
            GO TO 10
        ENDIF
        IF ((INP(I-1).GE.INP(I)) .AND. (INP(I+1).GE.INP(I))) THEN
            K = I-2
            GO TO 10
        ENDIF
      ENDDO
C
10    WND = K - CENTER
      LWORD = WND
C
C ... and then try to determine parameters with more precision
      AM = INP(CENTER)
      IC = CENTER
C ... make sure that we stay at maximum
      DO I = CENTER-WND+1, CENTER+WND
        IF (INP(I) .GT. AM) THEN
            AM = INP(I)
            IC = I
        ENDIF
      ENDDO
C ... redefine window of interest
      Y1 = AM
      Y  = (INP(IC+1) + INP(IC-1))/2.
      DO I = 1, WND
        Y2  = (INP(IC+I+1) + INP(IC-I-1))/2.
        IF (Y1-Y .GE. Y-Y2) THEN
            WND = I+1
            GO TO 20
        ENDIF
        Y1 = Y
        Y  = Y2
      ENDDO
C ... perform very simple fit
20    A11 = 0.
      A12 = 0.
      A22 = WND*2.
      B1 = 0.
      B2 = 0.
      DO I = IC-WND+1, IC+WND
        AM = MAX(AM, INP(I))
        X = I - 0.5
        Y = INP(I) - INP(I-1)
        A11 = A11 + X**2
        A12 = A12 + X
        B1  = B1  + X*Y
        B2  = B2  + Y
      ENDDO
      D = (A11*A22 - A12*A12)
      A = (B1*A22  - B2*A12)/D
      B = (B2*A11  - B1*A12)/D
      XC = -B/A
      HWHI = SQRT( MAX(0., -AM/A))
      WRITE (*,9000) AM, XC, HWHI*2.
C
      RETURN
 9000 FORMAT ('Am=',F7.1,'  Xc=',F6.1,'  FWHI=',F6.3)
      END

C*****************************************************************

      SUBROUTINE PLTARR(OUT,N2,NB,NE,NAME,OVR)
C
C       Plot elemets from NB to NE of array OUT(N2) with identifier NAME
C       (for debuging)
C
      INTEGER N2                    ! total length of data array
      REAL    OUT(N2)               ! array with data to plot
      INTEGER NB, NE                ! edges of plotting part of array
      INTEGER OVR                   ! overplot?
      CHARACTER*(*) NAME            ! label
C
      INTEGER   ISTAT, IAC, KUN, KNUL
      INTEGER   FMODE, IMAGE(4), NPL
      REAL      XS, SX, YOFF
      REAL      CUTS(2)
      REAL      FRAME(8)
      REAL      MUDAKI(2)
      CHARACTER LABEL1*80, LABEL2*80, LABEL3*80, LABEL4*80
      CHARACTER XFRAME*4, YFRAME*4
C
      INCLUDE 'MID_INCLUDE:PLTDEC.INC/NOLIST'
      INCLUDE 'MID_INCLUDE:PLTDAT.INC/NOLIST'
C
      DATA PMODE/-1/
      DATA MUDAKI/0.,0./
C
      CALL STKWRR('PLRSTAT',MUDAKI,19,2,KUN,ISTAT)
C
      CALL STKRDI('PLISTAT',1,1,IAC,FMODE,KUN,KNUL,ISTAT)
      FMODE = MIN0(FMODE,1)       ! we need not too complicated legenda
      CALL STKRDC('PLCSTAT',1,5,4,IAC,XFRAME,KUN,KNUL,ISTAT)
      CALL STKRDC('PLCSTAT',1,9,4,IAC,YFRAME,KUN,KNUL,ISTAT)
      IF (PMODE.LT.0 .OR. OVR.EQ.0) THEN
         PMODE = 0
      ELSE
         PMODE = 2
      ENDIF
C
      IMAGE(1) = MAX( 1, NB)
      IMAGE(2) = MIN(N2, NE)
      IMAGE(3) = 1
      IMAGE(4) = 1
      NPL = MAX( 2,  IMAGE(2) - IMAGE(1) + 1 )
      XS = 1.
      SX = 1.
C
C *** only for plot command
      IF (PMODE.EQ.0) THEN
         YOFF = 0.0
C
C *** find min and max of the data values
C         CALL MINMAX(OUT,N2,CUTS(1),CUTS(2))
C
C*** get the frame parameters
         IF (XFRAME(1:4).EQ.'MANU') THEN                        
            CALL STKRDR('PLRSTAT',11,4,IAC,FRAME(1),KUN,KNUL,ISTAT)
C            CALL BOXWTP(FRAME(1),NPL,XS,SX,IMAGE(1))
         ELSE
            XFRAME   = 'AUTO'
            FRAME(1) = FLOAT(IMAGE(1))
            FRAME(2) = FLOAT(IMAGE(2))
         END IF
C
         IF (YFRAME(1:4).EQ.'MANU') THEN
             CALL STKRDR('PLRSTAT',15,4,IAC,FRAME(5),KUN,KNUL,ISTAT)
         ELSE
             YFRAME   = 'AUTO'
             FRAME(5) = CUTS(1)
             FRAME(6) = CUTS(2)
         END IF

C         CALL GETFRM(FRAME(1),FRAME(2),FRAME(3),FRAME(4),XFRAME)
C         CALL GETFRM(FRAME(5),FRAME(6),FRAME(7),FRAME(8),YFRAME)
C
C        WRITE(*,*) 'XFRAME=', XFRAME
C        WRITE(*,*) 'YFRAME=', YFRAME
C        WRITE(*,*) 'FRAME=', FRAME(1), FRAME(2), FRAME(3), FRAME(4)
C        WRITE(*,*) 'FRAME=', FRAME(5), FRAME(6), FRAME(7), FRAME(8)
C
         CALL STKWRR('PLRSTAT',FRAME,11,8,KUN,ISTAT)
C
C     ELSE                                                       ! overplot mode
C        YOFF = YOFF + ABS(CUTS(1) - CUTS(2))/10.
C        CALL STKRDR('INPUTR',1,1,IAC,YOFF,KUN,KNUL,ISTAT)
      ENDIF
C
C *** do the plot setup
C      CALL PLOPN(NAME,PMODE,FMODE)
C
C *** do the work
C      CALL PLKEY(OUT(IMAGE(1)),NPL,IMAGE,XS,SX,YOFF)
C
C *** plot the legenda
      IF (FMODE.EQ.1 .AND. PMODE.EQ.0) THEN
C         CALL PLFRAM(FRAME(1),FRAME(2),FRAME(3),FRAME(4),
C     2               FRAME(5),FRAME(6),FRAME(7),FRAME(8))
         LABEL1 = 'Sequence Number'
         LABEL2 = 'Value'
C
         IF (FMODE.EQ.1) THEN
            LABEL3 = 'Array: '//NAME
            LABEL4 = ' '
C            CALL PLLABL(LABEL1,LABEL2,LABEL3,LABEL4)
         END IF
      END IF
C
C
C *** good bye and return
C      CALL PLCLS
C
      RETURN
      END

C @(#)substar.for	19.1 (ES0-DMD) 02/25/03 13:23:51
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE  SUBSTR  (PAR, MAXPAR, PSF, MAXPSF, MAXEXP, 
     .     F, NCOL, NROW, WATCH)
C
C=======================================================================
C
C This subroutine scales and shifts the point-spread function according
C to each star's magnitude and centroid, and subtracts the resulting
C profile from a copy of the original picture.
C
C             OFFICIAL DAO VERSION:  1991 April 18
C
C Arguments
C
C  WATCH (INPUT) governs whether information relating to the progress 
C        of the reductions is to be typed on the terminal screen
C        during execution.
C
C=======================================================================
C
      IMPLICIT NONE
      INTEGER MAXBOX, MAXPSF, MAXPAR, MAXEXC, MAXEXP
      PARAMETER  (MAXBOX=69, MAXEXC=200)
C
C Parameters
C
C MAXBOX is the side of the square subarray containing the largest
C        (circular) PSF that can be subtracted from the picture.
C
C MAXPSF is the largest permissible number of elements on a side of the
C        (square) look-up table for the point-spread function.
C
C        MAXBOX = (MAXPSF-7)/2.
C
      INTEGER NCOL, NROW
      REAL PAR(MAXPAR)
      REAL F(NCOL,NROW), PSF(MAXPSF,MAXPSF,MAXEXP)
      INTEGER IEXC(MAXEXC)
C
      REAL USEPSF
      INTEGER RDPSF, MAX0, MIN0, INT
C
      CHARACTER*80 LINE
      CHARACTER*30 SUBPIC
      CHARACTER*30 COOFIL, MAGFIL, PSFFIL, PROFIL, GRPFIL, SWITCH
      CHARACTER CASE*5, ANSWER*1
      REAL LOBAD, X, Y, STRMAG, SKY, DX, DY, DYSQ, SCALE, COL, ROW
      REAL DELTAX, DELTAY, DVDXC, DVDYC, XPSF, YPSF, PSFRAD, DUM
      REAL HIBAD, THRESH, AP1, PHPADU, READNS, FRAD, WATCH, PSFMAG
      REAL BRIGHT, PSFRSQ
      INTEGER I, J, L, NL, IDUM, NEXC, LX, LY, NX, NY, ISTAR, ID
      INTEGER ISTAT, IPSTYP, NPSF, NPAR, NEXP, NFRAC
C
      COMMON /FILNAM/ COOFIL, MAGFIL, PSFFIL, PROFIL, GRPFIL
C
C-----------------------------------------------------------------------
C
C SECTION 1
C
C Get file names and set up the needed numerical constants.
C
      CALL TBLANK                                   ! Type a blank line
  950 CALL GETNAM ('File with the PSF:', PSFFIL)
      IF ((PSFFIL .EQ. 'END OF FILE') .OR.
     .     (PSFFIL .EQ. 'GIVE UP')) THEN
         PSFFIL = ' '
         RETURN
      END IF
      ISTAT = RDPSF (PSFFIL, IPSTYP, PAR, MAXPAR, NPAR,
     .     PSF, MAXPSF, MAXEXP, NPSF, NEXP, NFRAC, 
     .     PSFMAG, BRIGHT, XPSF, YPSF)
      IF (ISTAT .LT. 0) THEN
         PSFFIL = 'GIVE UP'
         GO TO 950
      END IF
C
      PSFRAD=(REAL(NPSF-1)/2. - 1.)/2.
      PSFRSQ=PSFRAD**2
      COL=FLOAT(NCOL)
      ROW=FLOAT(NROW)
C
      CALL CLFILE (2)
C
 1015 CALL GETNAM ('File with photometry:', PROFIL)
      IF ((PROFIL .EQ. 'END OF FILE') .OR.
     .     (PROFIL .EQ. 'GIVE UP')) THEN
         PROFIL = ' '
         RETURN
      END IF
      CALL INFILE (2, PROFIL, ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error opening input file '//PROFIL)
         PROFIL = 'GIVE UP'
         GO TO 1015
      END IF
C
      CALL GETYN ('Do you have stars to leave in?', ANSWER)
      IF (ANSWER .EQ. 'Y') THEN
         SUBPIC = SWITCH(PROFIL, CASE('.lst'))
 1025    CALL GETNAM ('File with star list:', SUBPIC)
         IF ((SUBPIC .EQ. 'END OF FILE') .OR. (SUBPIC .EQ.
     .        'GIVE UP')) THEN
            CALL CLFILE (2)
            RETURN
         END IF
         CALL INFILE (3, SUBPIC, ISTAT)
         IF (ISTAT .NE. 0) THEN
            CALL STUPID ('Error opening file '//SUBPIC)
            SUBPIC = 'GIVE UP'
            GO TO 1025
         END IF
         NL = -1
         CALL RDHEAD (3, NL, IDUM, IDUM, DUM, DUM, DUM, DUM,
     .        DUM, DUM, DUM)
         NEXC = 0
 1035    NEXC = NEXC+1
 1036    CALL RDSTAR (3, NL, IEXC(NEXC), DUM, DUM, DUM, DUM)
         IF (IEXC(NEXC) .EQ. 0) GO TO 1036
         IF (IEXC(NEXC) .LT. 0) THEN
            NEXC = NEXC-1
         ELSE
            IF (NEXC .LT. MAXEXC) GO TO 1035
         END IF
         IF (NEXC .LE. 0) ANSWER = 'N'
         CALL CLFILE (3)
      END IF
C
      CALL RDHEAD (2, NL, IDUM, IDUM, LOBAD, HIBAD, THRESH, AP1, 
     .     PHPADU, READNS, FRAD)
C
      SUBPIC=SWITCH(PROFIL, CASE('s'))
      CALL GETNAM ('Name for subtracted image:', SUBPIC)
      IF (SUBPIC .EQ. 'END OF FILE') GO TO 9010    ! CTRL-Z was entered
C
C Copy the input picture verbatim into the output picture.
C
      CALL COPPIC (SUBPIC, F, NCOL, NROW, ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error creating output image.')
         CALL CLFILE (2)
         RETURN
      END IF
C
      IF (WATCH .GT. 0.5) THEN
         CALL TBLANK
         CALL OVRWRT (' Star', 1)
      END IF
C
C Read the entire image in from the copy.
C
      LX = 1
      LY = 1
      NX = NCOL
      NY = NROW
      CALL RDARAY ('COPY', LX, LY, NX, NY, NCOL, F, ISTAT)
C
C-----------------------------------------------------------------------
C
C SECTION 2
C
C Loop over stars.
C
      ISTAR=0
 2000 ISTAR=ISTAR+1
 2010 CALL RDSTAR (2, NL, ID, X, Y, STRMAG, SKY)
      IF (ID .LT. 0) GO TO 9000                ! End-of-file encountered
      IF (ID .EQ. 0) GO TO 2010                ! Ignore a blank line
      IF ((1.-X .GT. PSFRAD) .OR. (X-COL .GT. PSFRAD) .OR.
     .    (1.-Y .GT. PSFRAD) .OR. (Y-ROW .GT. PSFRAD)) GO TO 2000
      IF (ANSWER .EQ. 'Y') THEN
         L = NEXC
         DO I=1,L
            IF (ID .EQ. IEXC(I)) THEN
               IEXC(I) = IEXC(NEXC)
               NEXC = NEXC-1
               IF (NEXC .EQ. 0) ANSWER = 'N'
               GO TO 2010
            END IF
         END DO
      END IF
      IF (STRMAG .GE. 99.) GO TO 2000          ! Ignore a bad star
      IF (WATCH .GT. 0.5) THEN
         WRITE (LINE,620) ISTAR
  620    FORMAT (I5)
         CALL OVRWRT (LINE(1:5), 2)
      END IF
      DELTAX=(X-1.)/XPSF-1.
      DELTAY=(Y-1.)/YPSF-1.
      LX=MAX0(1, INT(X-PSFRAD)+1)
      LY=MAX0(1, INT(Y-PSFRAD)+1)
      NX=MIN0(NCOL, INT(X+PSFRAD))
      NY=MIN0(NROW, INT(Y+PSFRAD))
      SCALE=10.**(0.4*(PSFMAG-STRMAG))
C
C Subtract the shifted scaled PSF
C
      DO 2030 J=LY,NY
         DY=FLOAT(J)-Y
         DYSQ=DY**2
         DO 2020 I=LX,NX
            IF (F(I,J) .GT. HIBAD) GO TO 2020
            DX=FLOAT(I)-X
            IF (DX**2+DYSQ .GE. PSFRSQ) THEN
               IF (DX .GT. 0.) GO TO 2030
            ELSE
               F(I,J)=F(I,J)-SCALE*USEPSF(IPSTYP, DX, DY, BRIGHT, PAR, 
     .              PSF, NPSF, NPAR, NEXP, NFRAC, DELTAX, DELTAY, 
     .              DVDXC, DVDYC)
            END IF
 2020    CONTINUE
 2030 CONTINUE
      GO TO 2000                              ! Go to next star
C
C-----------------------------------------------------------------------
C
C Normal return.
C
 9000 CONTINUE
      IF (WATCH .GT. 0.5) CALL OVRWRT (' ', 4)
C
C Write the modified image back into the copy.
C
      LX = 1
      LY = 1
      NX = NCOL
      NY = NROW
      CALL WRARAY ('COPY', LX, LY, NX, NY, NCOL, F, ISTAT)
      CALL CLPIC ('COPY')
      CALL STUPID ('    Done.  ')
 9010 CALL CLFILE (2)
      RETURN
C
      END!

C @(#)iir.for	19.1 (ES0-DMD) 02/25/03 13:55:01
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE IIRINR(DSPLAY,CHAN,COLOUR,XA,YA,XB,YB,ROID,IDST)
C 
      IMPLICIT NONE
C      
      INTEGER      DSPLAY,CHAN,COLOUR,XA,YA,XB,YB,ROID,IDST
C      
      INCLUDE      'MID_INCLUDE:IDIDEV.INC'
C      
      IF (IDINUM.EQ.0) THEN
         CALL GD8033(DSPLAY,CHAN,COLOUR,XA,YA,XB,YB,ROID,IDST)
      ELSE IF (IDINUM.EQ.10) THEN
         CALL MXW033(DSPLAY,CHAN,COLOUR,XA,YA,XB,YB,ROID,IDST)
      ELSE      
         IDST = 0
      ENDIF
C      
      RETURN
      END
C 
C      
C--------------------------------------------------
C
C
      SUBROUTINE IICINR(DSPLAY,CHAN,COLOUR,XA,YA,XB,YB,ZB,ROID,IDST)
C
      IMPLICIT NONE
C
      INTEGER      DSPLAY,CHAN,COLOUR,XA,YA,XB,YB,ZB,ROID,IDST
C
      IDST = -1               !no support for DeAnza
C
      RETURN
      END
C
C
C--------------------------------------------------
C 
C
      SUBROUTINE IIRRRI(DSPLAY,CHAN,ROID,XA,YA,XB,YB,MEMO,IDST)
C
      IMPLICIT NONE
C      
      INTEGER      DSPLAY,CHAN,ROID,XA,YA,XB,YB,MEMO,IDST
C 
      INCLUDE      'MID_INCLUDE:IDIDEV.INC'
C      
      IF (IDINUM.EQ.0) THEN
         CALL GD8034(DSPLAY,CHAN,ROID,XA,YA,XB,YB,MEMO,IDST)
      ELSE IF (IDINUM.EQ.10) THEN
         CALL MXW034(DSPLAY,CHAN,ROID,XA,YA,XB,YB,MEMO,IDST)
      ELSE      
         IDST = 0
      ENDIF
C      
      RETURN
      END
C
C
C--------------------------------------------------
C
C
      SUBROUTINE IICRRI(DSPLAY,CHAN,ROID,XA,YA,XB,YB,ZB,MEMO,IDST)
C
      IMPLICIT NONE
C
      INTEGER      DSPLAY,CHAN,ROID,XA,YA,XB,YB,ZB,MEMO,IDST
C
      IDST = -1               !no support for DeAnza
C
      RETURN
      END
C
C
C--------------------------------------------------
C
C
      SUBROUTINE IIRWRI(DSPLAY,CHAN,ROID,XA,YA,XB,YB,IDST)
C
      IMPLICIT NONE
C      
      INTEGER      DSPLAY,CHAN,ROID,XA,YA,XB,YB,IDST
      INCLUDE      'MID_INCLUDE:IDIDEV.INC'
C      
      IF (IDINUM.EQ.0) THEN
         CALL GD8035(DSPLAY,CHAN,ROID,XA,YA,XB,YB,IDST)
      ELSE IF (IDINUM.EQ.10) THEN
         CALL MXW035(DSPLAY,CHAN,ROID,XA,YA,XB,YB,IDST)
      ELSE      
         IDST = 0
      ENDIF
C      
      RETURN
      END
C
C
C--------------------------------------------------
C
C
      SUBROUTINE IICWRI(DSPLAY,CHAN,ROID,XA,YA,XB,YB,ZB,IDST)
C
      IMPLICIT NONE
C
      INTEGER      DSPLAY,CHAN,ROID,XA,YA,XB,YB,ZB,IDST
C 
      IDST = -1               !no support for DeAnza
C
      RETURN
      END
C 
C      
C--------------------------------------------------
C 
C
      SUBROUTINE IIRSRV(DSPLAY,ROID,VIS,IDST)
C
      IMPLICIT NONE
C      
      INTEGER      DSPLAY,ROID,VIS,IDST
C
      INCLUDE      'MID_INCLUDE:IDIDEV.INC'
C      
      IF (IDINUM.EQ.0) THEN
         CALL GD8036(DSPLAY,ROID,VIS,IDST)
      ELSE IF (IDINUM.EQ.10) THEN
         CALL MXW036(DSPLAY,ROID,VIS,IDST)
      ELSE      
         IDST = 0
      ENDIF
C      
      RETURN
      END

C===========================================================================
C Copyright (C) 1995,2004 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.PROGRAM:  DAOMID 
C.AUTHOR:   P. Figon, LAS Marseille 4eme trimestre 1985
C.Purpose:  Convert DAOPHOT tables into MIDAS tables
C.VERSION:  F. Murtagh, ST-ECF, July 1987  (Allow for .ADD files).
C.VERSION:  910510 RHW rewriten for portable version
C.VERSION:  910815 RHW change column names to :X_COORD and :YCOORD (was :X, :Y)
C 040722	last modif
C 
C------------------------------------------------------------------
C 
      PROGRAM DAOMID
C
      IMPLICIT         NONE
C 
      DOUBLE PRECISION STASTE(4)
C 
      CHARACTER*3      EXT
      CHARACTER*4      TYPE
      CHARACTER*12     XLAB,YLAB
      CHARACTER*80     NAME,BID,BL
      CHARACTER*84     TABLE 
      CHARACTER*120    STRING
C 
      REAL             X,Y,MG,SH,R0,ST,CHI,MS,IT
C 
      INTEGER          MADRID(1)
      INTEGER          I, J, IST, ICOL, NACT
      INTEGER          PIXO,TID
      INTEGER          ITYP, RTYP
      INTEGER          NROW, NROW2, NCOL
      INTEGER          KUN, KNUL, NCARA, NELEM, BYTEL
C
      INCLUDE          'MID_INCLUDE:ST_DEF.INC/NOLIST'
      COMMON           /VMR/MADRID
      INCLUDE          'MID_INCLUDE:ST_DAT.INC/NOLIST'
C
C *** initialize the MIDAS environment
      CALL STSPRO('DAOMID')
C
C *** get the table name to convert
      CALL STKRDC('IN_A',1,1,80,NCARA,NAME,KUN,KNUL,IST)
C
C *** check the name of the table
      I = INDEX(NAME,'.')
      IF (I.EQ.0) 
     +   CALL STETER(11,'*** FATAL: Table name requires extension')
C
      EXT=NAME(I+1:I+3)
      CALL UPCAS(EXT,EXT)
      IF (EXT.NE.'COO' .AND. EXT.NE.'PK '.AND. EXT.NE.'NST' .AND.
     +    EXT.NE.'ADD'.AND.EXT.NE.'ALS') THEN
          CALL STETER(12,'*** FATAL: Only .COO, .PK, .ALS, .ADD '//
     +                'and .NST tables')
      END IF
C 
      TABLE = NAME(1:I-1)//EXT
      CALL LOWCAS(TABLE,TABLE)
C
C *** Get start and step values from keyword TRANSF
      CALL STKFND('TRANSF',TYPE,NELEM,BYTEL,IST)
      IF (NELEM.EQ.0) THEN
         PIXO = 1
      ELSE
         CALL STTPUT('*** INFO: Get start/step values from '//
     +               ' keyword TRANSF...',IST)
         CALL STKRDD('TRANSF',1,4,NACT,STASTE,KUN,KNUL,IST)
         PIXO = 0
      ENDIF
C
C *** open the daophot table
      OPEN(UNIT=20,FILE=NAME,STATUS='OLD',ERR=9999)
C
C *** open scratch file
      OPEN(UNIT=30,STATUS='SCRATCH')
C
C *** get the useful line and their number
      BL='   '
      DO 200, I=1,3
         READ(20,'(A)') BID
200   CONTINUE
      NROW=0
C 
2010  READ(20,'(A)',END=2020) BID
      IF  (BID.NE.BL) THEN
         NROW=NROW+1
         WRITE(30,'(A)') BID
      END IF
      GO TO 2010
C 
2020  CONTINUE                                     !EOF reached
      REWIND 30
C
C *** number of columns
      IF (EXT.EQ.'COO') THEN
         NCOL=6
      ELSE IF(EXT.EQ.'PK '.OR. EXT.EQ.'NST'.OR. EXT.EQ.'ALS') THEN
         NCOL=9
      ELSE IF(EXT.EQ.'ADD') THEN
         NCOL=4
      END IF
C
C *** create MIDAS tables
      NROW2 = NROW*2
      CALL TBTINI(TABLE,0,F_O_MODE,NCOL,NROW2,TID,IST)
C
C *** define the columns
      ITYP = D_I4_FORMAT
      RTYP = D_R4_FORMAT
      IF (PIXO.EQ.0) THEN
         XLAB = 'X_COORD '
         YLAB = 'Y_COORD '
      ELSE
         XLAB = 'X_COORDPIX'
         YLAB = 'Y_COORDPIX'
      ENDIF
      IF (EXT.EQ.'COO') THEN
         CALL TBCINI(TID,ITYP,1,'I4',   ' ','I',  ICOL,IST)
         CALL TBCINI(TID,RTYP,1,'F10.2',' ',XLAB,  ICOL,IST)
         CALL TBCINI(TID,RTYP,1,'F10.2',' ',YLAB,  ICOL,IST)
         CALL TBCINI(TID,RTYP,1,'F10.3',' ','MG', ICOL,IST)
         CALL TBCINI(TID,RTYP,1,'F10.3',' ','SH', ICOL,IST)
         CALL TBCINI(TID,RTYP,1,'F10.3',' ','R0', ICOL,IST)
      ELSE IF(EXT.EQ.'ADD') THEN
         CALL TBCINI(TID,ITYP,1,'I4',   ' ','I',  ICOL,IST)
         CALL TBCINI(TID,RTYP,1,'F10.2',' ',XLAB,  ICOL,IST)
         CALL TBCINI(TID,RTYP,1,'F10.2',' ',YLAB,  ICOL,IST)
         CALL TBCINI(TID,RTYP,1,'F10.3',' ','MG', ICOL,IST)
      ELSE IF(EXT.EQ.'PK '.OR.EXT.EQ.'NST'.OR.EXT.EQ.'ALS') THEN
         CALL TBCINI(TID,ITYP,1,'I4',   ' ','I',  ICOL,IST)
         CALL TBCINI(TID,RTYP,1,'F10.2',' ',XLAB,  ICOL,IST)
         CALL TBCINI(TID,RTYP,1,'F10.2',' ',YLAB,  ICOL,IST)
         CALL TBCINI(TID,RTYP,1,'F10.3',' ','MG', ICOL,IST)
         CALL TBCINI(TID,RTYP,1,'F10.3',' ','ST', ICOL,IST)
         CALL TBCINI(TID,RTYP,1,'F10.3',' ','MS', ICOL,IST)
         CALL TBCINI(TID,RTYP,1,'F10.0',' ','IT', ICOL,IST)
         CALL TBCINI(TID,RTYP,1, 'F5.2',' ','CHI',ICOL,IST)
         CALL TBCINI(TID,RTYP,1,'F10.3',' ','SH', ICOL,IST)
      END IF
C
C *** write the table
      IF (EXT.EQ.'COO') THEN
         DO J=1,NROW
            READ(30,*) I,X,Y,MG,SH,R0
            IF (PIXO.EQ.0) THEN
               X = X*STASTE(3) + STASTE(1)      ! Transf. coords. from pix.
               Y = Y*STASTE(4) + STASTE(2)      ! coords. to world coords.
            ENDIF
            CALL TBEWRI(TID,J,1,I, IST)    
            CALL TBEWRR(TID,J,2,X, IST)
            CALL TBEWRR(TID,J,3,Y, IST) 
            CALL TBEWRR(TID,J,4,MG,IST)
            CALL TBEWRR(TID,J,5,SH,IST)
            CALL TBEWRR(TID,J,6,R0,IST)
         END DO
      ELSE IF(EXT.EQ.'ADD') THEN
         DO J=1,NROW
            READ(30,*) I,X,Y,MG
            IF (PIXO.EQ.0) THEN
               X = X*STASTE(3) + STASTE(1)      ! Transf. coords. from pix.
               Y = Y*STASTE(4) + STASTE(2)      ! coords. to world coords.
            ENDIF
            CALL TBEWRI(TID,J,1,I, IST)    
            CALL TBEWRR(TID,J,2,X, IST)
            CALL TBEWRR(TID,J,3,Y, IST) 
            CALL TBEWRR(TID,J,4,MG,IST)
         ENDDO
      ELSE IF(EXT.EQ.'PK '.OR.EXT.EQ.'NST'.OR.EXT.EQ.'ALS') THEN
         DO J=1,NROW
            READ(30,*) I,X,Y,MG,ST,MS,IT,CHI,SH	
            IF (PIXO.EQ.0) THEN
               X = X*STASTE(3) + STASTE(1)      ! Transf. coords. from pix.
               Y = Y*STASTE(4) + STASTE(2)      ! coords. to world coords.
            ENDIF
            CALL TBEWRI(TID,J,1,I, IST)    
            CALL TBEWRR(TID,J,2,X, IST)
            CALL TBEWRR(TID,J,3,Y, IST) 
            CALL TBEWRR(TID,J,4,MG,IST)
            CALL TBEWRR(TID,J,5,ST,IST)
            CALL TBEWRR(TID,J,6,MS,IST)
            CALL TBEWRR(TID,J,7,IT,IST)
            CALL TBEWRR(TID,J,8,CHI,IST)
            CALL TBEWRR(TID,J,9,SH,IST)
         END DO
      END IF
C 
      I = INDEX(TABLE,' ')
      IF (I.LT.2) I = LEN(TABLE)
      WRITE(STRING,12345) TABLE(1:I-1)
12345 FORMAT('Midas table ',A,'.tbl created')
      CALL STTPUT(STRING,IST)
C
C *** close the files
      CLOSE(20)
      CLOSE(30)
C
C *** exit 
      CALL STSEPI                             !also closes the Midas table
C 
9999  CALL STTPUT
     + ('*** WARNING: could not open DAOPHOT table...; I quit',IST)
      CALL STSEPI

      END

C @(#)rfotcbase.for	19.1 (ES0-DMD) 02/25/03 13:30:13
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM CBASE
C+++
C.IDENTIFICATION: RFOTCBASE
C.PURPOSE: Create two tables for coordinate transformation between two frames
C.AUTHOR:  R. Buonanno, G. Buscema, C. Corsi, I. Ferraro, G. Iannicola
C          Osservatorio Astronomico di Roma, and
C.         R.H. Warmels, ESO-IPG
C.VERSION: 881119 RB   First installation in MIDAS
C          890913 RHW  Rewritten on the basis on MCL and MIDAS tables
C----
      IMPLICIT       NONE
      INCLUDE        'MID_REL_INCL:RFOTDECL.INC'
C
      INTEGER        NCPAR
      PARAMETER      (NCPAR=12)
      INTEGER        ICBASE(2)
      INTEGER        IVX(9)
      INTEGER        NAXIS1,NPIX1(2)
      INTEGER        NAXIS2,NPIX2(2)
      INTEGER        MADRID(1)
      INTEGER        LX(2),LY(2)
      INTEGER        ED, EC, EL
      INTEGER        ICIDN
      INTEGER*8      IPNR
      INTEGER        IAV, ISTAT
      INTEGER        I, IR, IROW, INX, IT
      INTEGER        J
      INTEGER        KUN, KNUL
      INTEGER        KK, KL
      INTEGER        NCTAB, NRTAB, NSTAB, NACTAB, NARTAB
      INTEGER        NPL0, NL0
      INTEGER        NLIV, NC
      
      INTEGER        IPNTR1,IPNTR2,IMF1,IMF2
      INTEGER        TIDI,TIDO1,TIDO2
      INTEGER        NCOL, NROW
      INTEGER        REGTYP,REGCOL
      INTEGER        ICPAR(NCPAR)
      INTEGER        FIT
C
      DOUBLE PRECISION BEGIN1(2),STEP1(2)
      DOUBLE PRECISION BEGIN2(2),STEP2(2)
C
      REAL           COO(2)
      REAL           FO1(1000,2)
      REAL           H1(1000,2)
      REAL           PAR(4),PARS(4)
      REAL           RX(100),RY(100)
      REAL           TAB(NCPAR)
      REAL           VET(100)
      REAL           X1(1000,2),Y1(1000,2)
      REAL           FG
      REAL           RME, VME
      REAL           SQR, SL, SQM
C
      CHARACTER*60   IDENT1,CUNIT1,IDENT2,CUNIT2
      CHARACTER      TABI*60,TABO1*60,TABO2*60
      CHARACTER*60   IMAG1, IMAG2
      CHARACTER*16   LABEL(NCPAR),REGLAB
      CHARACTER*16   UNIT(NCPAR),REGUNI
      CHARACTER*80   STRING
      CHARACTER*16   REGFOR
      CHARACTER*16   FORMR4,FORMI4
C
      LOGICAL        NUL(2)
C
      INCLUDE        'MID_INCLUDE:ST_DEF.INC'
      COMMON         /VMR/MADRID
      INCLUDE        'MID_INCLUDE:ST_DAT.INC'
C
      DATA           ICIDN/1/
      DATA           ICBASE/1,2/
      DATA           FORMI4/'I6'/
      DATA           FORMR4/'E12.4'/
      DATA           LABEL /'X      ', 'Y      ', 'INT    ', 'LOC_BGD ', 
     2                      'MAG1   ', 'MAG2   ', 'MAG3   ', 'MAG_CNV ', 
     3                      'SIGMA  ', 'BETA   ', 'SIQ    ', 'CHI_SQ  '/
      DATA           UNIT  /'PIXEL  ', 'PIXEL  ', '       ', '        ',
     2                      'MAG.   ', 'MAG.   ', 'MAG.   ', 'MAG.    ',
     3                      '       ', '       ', '       ', '        '/
      DATA           IVX/1,2,3,4,5,6,7,8,9/
C
C *** Is MIDAS out there
      CALL STSPRO('CBASE')
C
C *** get the frame names
      CALL STKRDC('IN_A',1,1,60,IAV,IMAG1,KUN,KNUL,ISTAT)
      CALL STKRDC('IN_B',1,1,60,IAV,IMAG2,KUN,KNUL,ISTAT)
      CALL STIGET(IMAG1,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,2,NAXIS1,
     2            NPIX1,BEGIN1,STEP1,IDENT1,CUNIT1,IPNTR1,IMF1,ISTAT)
      CALL STIGET(IMAG2,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,2,NAXIS2,
     2            NPIX2,BEGIN2,STEP2,IDENT2,CUNIT2,IPNTR2,IMF2,ISTAT)
C
C *** get the input coordinate and output 
      CALL STKRDC('INPUTC',1,1,60,IAV,TABI,KUN,KNUL,ISTAT)
      CALL STKRDC('P3',1,1,60,IAV,TABO1,KUN,KNUL,ISTAT)
      CALL STKRDC('P4',1,1,60,IAV,TABO2,KUN,KNUL,ISTAT)
C
C *** read the input table 
      CALL TBTOPN(TABI,F_I_MODE,TIDI,ISTAT)
      CALL STECNT('GET',EC,ED,EL)
      CALL STECNT('PUT',1,0,0)
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL: No input coordinate table available'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
C
      CALL TBIGET(TIDI,NCTAB,NRTAB,NSTAB,NACTAB,NARTAB,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL: Problems with input coordinate table'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
C
      IF (NRTAB.EQ.0) THEN
         STRING = '*** FATAL: No points in coordinate table'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
      CALL STECNT('PUT',EC,ED,EL)
C
C *** create the output tables
      NROW  = NRTAB/2
      NCOL  = NCPAR + 1
C
      CALL TBTINI(TABO1,0,F_O_MODE,NCOL,NROW,TIDO1,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL:  Problems with opening first'//
     2            'transformation table'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
      CALL TBTINI(TABO2,0,F_O_MODE,NCOL,NROW,TIDO2,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL:  Problems with opening second '//
     2            'tranformation table'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
C
      REGTYP = D_I4_FORMAT
      REGFOR = FORMI4
      REGUNI = '   '
      REGLAB = 'IDENT'
      CALL TBCINI(TIDO1,REGTYP,1,REGFOR,REGUNI,
     2                  REGLAB,REGCOL,ISTAT)           ! create the ident column
      CALL TBCINI(TIDO2,REGTYP,1,REGFOR,REGUNI,
     2                  REGLAB,REGCOL,ISTAT)           ! create the ident column
C
      DO 101 I = 1,NCPAR
         ICPAR(I) = I + 1
         REGTYP   = D_R4_FORMAT
         REGFOR   = FORMR4
         REGUNI   = UNIT(I)
         REGLAB   = LABEL(I)
         CALL TBCINI(TIDO1,REGTYP,1,REGFOR,REGUNI,
     2                     REGLAB,REGCOL,ISTAT)        ! create the data columns
         CALL TBCINI(TIDO2,REGTYP,1,REGFOR,REGUNI,
     2                     REGLAB,REGCOL,ISTAT)        ! create the data columns
  101 CONTINUE
C
C *** do the fitting
      DO 10 IR = 1,NROW
         IROW  = IR
         CALL TBRRDR(TIDI,IROW,2,ICBASE,COO,NUL,ISTAT)
         LX(1) = INT((COO(1)-BEGIN1(1))/STEP1(1)) + 1
         LY(1) = INT((COO(2)-BEGIN1(2))/STEP1(2)) + 1
         IROW  = IR + NROW
         CALL TBRRDR(TIDI,IROW,2,ICBASE,COO,NUL,ISTAT)
         LX(2) = INT((COO(1)-BEGIN2(1))/STEP2(1)) + 1
         LY(2) = INT((COO(2)-BEGIN2(2))/STEP2(2)) + 1
C
C *** fit the data; get first image
         KK   = 1
         IPNR = IPNTR1
         NPL0 = NPIX1(1)
         NL0  = NPIX1(2)
         ASSIGN 9001 TO FIT
         GO TO 9000
 9001    CONTINUE
C
C *** get the input of the second image
         KK   = 2 
         IPNR = IPNTR2
         NPL0 = NPIX2(1)
         NL0  = NPIX2(2)
         ASSIGN 9002 TO FIT
         GO TO 9000
 9002    CONTINUE
   10 CONTINUE
C
C *** write tables
      DO 40 IR = 1,NROW
         TAB(1)  = X1(IR,1)
         TAB(2)  = Y1(IR,1)
         TAB(3)  = H1(IR,1)
         TAB(4)  = FO1(IR,1)
         CALL TBEWRI(TIDO1,IR,ICIDN,IR,ISTAT)
         CALL TBRWRR(TIDO1,IR,12,ICPAR,TAB,ISTAT)
         TAB(1)  = X1(IR,2)
         TAB(2)  = Y1(IR,2)
         TAB(3)  = H1(IR,2)
         TAB(4)  = FO1(IR,2)
         CALL TBEWRI(TIDO2,IR,ICIDN,IR,ISTAT)
         CALL TBRWRR(TIDO2,IR,12,ICPAR,TAB,ISTAT)
   40 CONTINUE
C
      CALL TBTCLO(TIDO1,ISTAT)
      CALL TBTCLO(TIDO2,ISTAT)
      CALL STSEPI
C
C+++++
 9000 CONTINUE                                                     ! FIT DATA
C----
      DO 9110 J=1,9
         RX(J) = 0
         RY(J) = 0
 9110 CONTINUE
C
      NC = 0
      H1(IR,KK) = -10.E15
      DO 9120 I = LY(KK)-4,LY(KK)+4
         NC  = NC+1
         INX = LX(KK)-4
         CALL REALIN(NPL0,NL0,I,INX,9,MADRID(IPNR),VET)
         RME = 0
         DO 9121 J = 1,9
            H1(IR,KK)  = AMAX1(H1(IR,KK),VET(J))
            RME        = RME + VET(J)
            RX(J)      = RX(J) + VET(J)
 9121    CONTINUE
         RY(NC) = RME/9.
 9120 CONTINUE
C
      PAR(1) = 0.
      PAR(4) = 10.E15
      DO 9130 J = 1,9
         RX(J) = RX(J)/9.
         IF (RX(J).GT.PAR(1)) THEN
            PAR(1) = RX(J)
            PAR(2) = J
         END IF
         IF (RX(J).LT.PAR(4)) THEN
            PAR(4) = RY(J)
         ENDIF
 9130 CONTINUE
C
      PAR(1) = PAR(1)-PAR(4)
      KL     = PAR(2)
      VME    = (RX(KL-1)+RX(KL+1))/2.
      IF (VME.GE.PAR(1)) THEN
         VME = PAR(1)/2.
      ENDIF
      PAR(3) = SQRT(4*ALOG(2.)/ALOG(PAR(1)/VME))
      SQR    = 10.**15
      SL     = SQR
      IT     = 0
      NLIV   = 9
C
      DO 9140 J=1,4
         PARS(J) = PAR(J)
 9140 CONTINUE
C
 9201 CONTINUE
      IF (SL.LE.0.0001 .OR. IT.GT.20) GO TO 9200
      IT = IT+1
      CALL MONO4(IVX,RX,NLIV,PAR,.7)
      IF (PAR(1).LT..1 .OR. ABS(PAR(2)-PARS(2)).GT.4 .OR.
     2    PAR(3).LE.0. .OR. PAR(3).GT.20.) THEN
         DO 9141 J=1,4
            PAR(J) = PARS(J)
 9141    CONTINUE
         GO TO 9200
      END IF
C
      SQM = 0.
      DO 9150 I=1,NLIV
         FG  = PAR(1)*EXP(-4*ALOG(2.)*((I-PAR(2))/PAR(3))**2)
         SQM = SQM+(RX(I)-FG-PAR(4))**2
 9150 CONTINUE
      SQM = SQRT(SQM/NLIV)
      SL  = ABS(SQR-SQM)/SQR
      SQR = SQM
      GO TO 9201
C
 9200 CONTINUE
      X1(IR,KK)  = PAR(2)+LX(KK)-5
      FO1(IR,KK) = PAR(4)
      PAR(1)     = 0
      PAR(4)     = 10.E15
      DO 9160 J = 1,9
         IF (RY(J).GT.PAR(1)) THEN
            PAR(1) = RY(J)
            PAR(2) = J
         END IF
         IF (RY(J).LT.PAR(4)) THEN
            PAR(4) = RY(J)
         ENDIF
 9160 CONTINUE
C
      PAR(1) = PAR(1)-PAR(4)
      KL     = PAR(2)
      VME    = (RY(KL-1)+RY(KL+1))/2.
      IF (VME.GE.PAR(1)) VME = PAR(1)/2.
      PAR(3) = SQRT(4*ALOG(2.)/ALOG(PAR(1)/VME))
      SQR    = 10.**15
      SL     = SQR
      IT     = 0
      NLIV   = 9
C
      DO 9170 J=1,4
         PARS(J) = PAR(J)
 9170 CONTINUE
C
 9301 CONTINUE
      IF (SL.LE.0.0001.OR.IT.GT.20) GO TO 9300
      IT = IT+1
      CALL MONO4(IVX,RY,NLIV,PAR,.7)
      IF (PAR(1).LT..1 .OR. ABS(PAR(2)-PARS(2)).GT.4 .OR. 
     2    PAR(3).LE.0. .OR. PAR(3).GT.20.) THEN
         DO 9171 J=1,4
            PAR(J) = PARS(J)
 9171    CONTINUE
         GO TO 9300
      END IF
      SQM = 0.
      DO 9180 I=1,NLIV
         FG  = PAR(1)*EXP(-4*ALOG(2.)*((I-PAR(2))/PAR(3))**2)
         SQM = SQM+(RY(I)-FG-PAR(4))**2
 9180 CONTINUE
      SQM = SQRT(SQM/NLIV)
      SL  = ABS(SQR-SQM)/SQR
      SQR = SQM
      GO TO 9301
C
 9300 CONTINUE
      Y1(IR,KK)  = PAR(2)+LY(KK)-5
      FO1(IR,KK) = (FO1(IR,KK)+PAR(4))/2.
      H1(IR,KK)  = H1(IR,KK)-FO1(IR,KK)
C 
      GO TO FIT
      END

C @(#)cmds.for	19.1 (ES0-DMD) 02/25/03 13:27:14
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                         C
C  Carry out a PRINCIPAL COORDINATES ANALYSIS                             C
C              (CLASSICAL MULTIDIMENSIONAL SCALING).                      C
C                                                                         C
C  To call:   CALL PCA(N,A,IPRINT,W1,W2,A2,IERR)    where                 C
C                                                                         C
C                                                                         C
C  N     : integer number of objects.                                     C
C  A     : input distances array, real, of dimensions N by N.             C
C          On output, A contains in the first 7 columns the projections   C
C          of the objects on the first 7 principal components.            C
C  IPRINT: print options.                                                 C
C          = 3: full printing of items calculated.                        C
C          = 2: printing of everything except the input distance matrix.  C
C          Otherwise: no printing.                                        C
C  W1,W2 : real vectors of dimension M (see called routines for use).     C
C          On output, W1 contains the eigenvalues (in increasing order of C
C          magnitude).                                                    C
C  A2    : real array of dimensions M * M (see called routines for use).  C
C  IERR  : error indicator (normally zero).                               C
C                                                                         C
C                                                                         C
C  Inputs here are N, A, IPRINT (and IERR).                               C
C  Output information is contained in A, and W1.                          C
C  All printed outputs are carried out in easily recognizable subroutines C
C  called from the first subroutine following.                            C
C                                                                         C
C                                                                         C
C  F. Murtagh, ST-ECF/ESA/ESO, Garching-bei-Muenchen, January 1986.       C
C                                                                         C
C-------------------------------------------------------------------------C
        SUBROUTINE CMDS(N,A,IPRINT,W,FV1,Z,IERR)
        INTEGER N,I1,I2,IPRINT,IERR,N2
        REAL    A(N,N), W(N), FV1(N), Z(N,N)
        REAL    TOT
C
        IF (IPRINT.EQ.3) CALL OUTMAT(N,A)
C
        TOT = 0.0
        DO 200 I1 = 1, N
           W(I1) = 0.0
           DO 100 I2 = 1, N
              W(I1) = W(I1) + A(I1,I2)
              TOT = TOT + A(I1,I2)
  100      CONTINUE
           W(I1) = W(I1)/FLOAT(N)
  200   CONTINUE
        TOT = TOT/(FLOAT(N)*FLOAT(N))
C
        DO 300 I1 = 1, N
           DO 300 I2 = 1, N
              A(I1,I2) = -0.5 * (A(I1,I2) - W(I1) - W(I2) - TOT)
  300   CONTINUE
C
C          Carry out the eigenreduction.
C
        N2 = N
        CALL TRED2(N,N2,A,W,FV1,Z)
        CALL TQL2(N,N2,W,FV1,Z,IERR)
        IF (IERR.NE.0) GOTO 9000
C
C          Output eigenvalues and eigenvectors.
C
        IF (IPRINT.GE.2) CALL OUTEVL(N,W)
        IF (IPRINT.GE.2) CALL OUTEVC(N,Z)
C
C          Determine projections and output them.
C
        CALL PROJN(N,W,A,Z,FV1)
        IF (IPRINT.GE.2) CALL OUTPR(N,A)
C
 9000   RETURN
        END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                         C
C Reduce a real, symmetric matrix to a symmetric, tridiagonal matrix.     C
C                                                                         C
C To call:    CALL TRED2(NM,N,A,D,E,Z)    where                           C
C                                                                         C
C NM = row dimension of A and Z;                                          C
C N = order of matrix A (will always be <= NM);                           C
C A = symmetric matrix of order N to be reduced to tridiagonal form;      C
C D = vector of dim. N containing, on output, diagonal elts. of trid.     C
C     matrix.                                                             C
C E = working vector of dim. at least N-1 to contain subdiagonal elts.;   C
C Z = matrix of dims. NM by N containing, on output, orthogonal           C
C     transformation matrix producing the reduction.                      C
C                                                                         C
C Normally a call to TQL2 will follow the call to TRED2 in order to       C
C produce all eigenvectors and eigenvalues of matrix A.                   C
C                                                                         C
C Algorithm used: Martin et al., Num. Math. 11, 181-195, 1968.            C
C                                                                         C
C Reference: Smith et al., Matrix Eigensystem Routines - EISPACK          C
C Guide, Lecture Notes in Computer Science 6, Springer-Verlag, 1976,      C
C pp. 489-494.                                                            C
C                                                                         C
C F. Murtagh, ST-ECF/ESA/ESO, Garching-bei-Muenchen, January 1986.        C
C                                                                         C
C-------------------------------------------------------------------------C
        SUBROUTINE TRED2(NM,N,A,D,E,Z)
        INTEGER NM,N,I,J,L,II,K,JP1
        REAL A(NM,N),D(N),E(N),Z(NM,N)
        REAL SCALE,F,G,H,HH
C
        DO 100 I = 1, N
           DO 100 J = 1, I
              Z(I,J) = A(I,J)
  100   CONTINUE
        IF (N.EQ.1) GOTO 320
        DO 300 II = 2, N
           I = N + 2 - II
           L = I - 1
           H = 0.0
           SCALE = 0.0
           IF (L.LT.2) GOTO 130
           DO 120 K = 1, L
              SCALE = SCALE + ABS(Z(I,K))
  120      CONTINUE
           IF (SCALE.NE.0.0) GOTO 140
  130      E(I) = Z(I,L)
           GOTO 290
  140      DO 150 K = 1, L
              Z(I,K) = Z(I,K)/SCALE
              H = H + Z(I,K)*Z(I,K)
  150      CONTINUE
C
           F = Z(I,L)
           G = -SIGN(SQRT(H),F)
           E(I) = SCALE * G
           H = H - F * G
           Z(I,L) = F - G
           F = 0.0
C
           DO 240 J = 1, L
              Z(J,I) = Z(I,J)/H
              G = 0.0
C             Form element of A*U.
              DO 180 K = 1, J
                 G = G + Z(J,K)*Z(I,K)
  180         CONTINUE
              JP1 = J + 1
              IF (L.LT.JP1) GOTO 220
              DO 200 K = JP1, L
                 G = G + Z(K,J)*Z(I,K)
  200         CONTINUE
C             Form element of P where P = I - U U' / H .
  220         E(J) = G/H
              F = F + E(J) * Z(I,J)
  240      CONTINUE
           HH = F/(H + H)
C          Form reduced A.
           DO 260 J = 1, L
              F = Z(I,J)
              G = E(J) - HH * F
              E(J) = G
              DO 250 K = 1, J
                 Z(J,K) = Z(J,K) - F*E(K) - G*Z(I,K)
  250         CONTINUE
  260      CONTINUE
  290      D(I) = H
  300   CONTINUE
  320   D(1) = 0.0
        E(1) = 0.0
C       Accumulation of transformation matrices.
        DO 500 I = 1, N
           L = I - 1
           IF (D(I).EQ.0.0) GOTO 380
           DO 360 J = 1, L
              G = 0.0
              DO 340 K = 1, L
                 G = G + Z(I,K) * Z(K,J)
  340         CONTINUE
              DO 350 K = 1, L
                 Z(K,J) = Z(K,J) - G * Z(K,I)
  350         CONTINUE
  360      CONTINUE
  380      D(I) = Z(I,I)
           Z(I,I) = 1.0
           IF (L.LT.1) GOTO 500
           DO 400 J = 1, L
              Z(I,J) = 0.0
              Z(J,I) = 0.0
  400      CONTINUE
  500   CONTINUE
C
        RETURN
        END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                         C
C Determine eigenvalues and eigenvectors of a symmetric,                  C
C tridiagonal matrix.                                                     C
C                                                                         C
C To call:    CALL TQL2(NM,N,D,E,Z,IERR)    where                         C
C                                                                         C
C NM = row dimension of Z;                                                C
C N = order of matrix Z;                                                  C
C D = vector of dim. N containing, on output, eigenvalues;                C
C E = working vector of dim. at least N-1;                                C
C Z = matrix of dims. NM by N containing, on output, eigenvectors;        C
C IERR = error, normally 0, but 1 if no convergence.                      C
C                                                                         C
C Normally the call to TQL2 will be preceded by a call to TRED2 in        C
C order to set up the tridiagonal matrix.                                 C
C                                                                         C
C Algorithm used: QL method of Bowdler et al., Num. Math. 11,             C
C 293-306, 1968.                                                          C
C                                                                         C
C Reference: Smith et al., Matrix Eigensystem Routines - EISPACK          C
C Guide, Lecture Notes in Computer Science 6, Springer-Verlag, 1976,      C
C pp. 468-474.                                                            C
C                                                                         C
C F. Murtagh, ST-ECF/ESA/ESO, Garching-bei-Muenchen, January 1986.        C
C                                                                         C
C-------------------------------------------------------------------------C
        SUBROUTINE TQL2(NM,N,D,E,Z,IERR)
        INTEGER N,NM,I,J,IERR,M,L1,L
        INTEGER II,K,MML
        REAL    D(N), E(N), Z(NM,N),EPS,F,B,H
        REAL    G,P,R,C,S
        DATA    EPS/1.E-12/
C
        IERR = 0
        IF (N.EQ.1) GOTO 1001
        DO 100 I = 2, N
           E(I-1) = E(I)
  100   CONTINUE
        F = 0.0
        B = 0.0
        E(N) = 0.0
C
        DO 240 L = 1, N
           J = 0
           H = EPS * (ABS(D(L)) + ABS(E(L)))
           IF (B.LT.H) B = H
C          Look for small sub-diagonal element.
           DO 110 M = L, N
              IF (ABS(E(M)).LE.B) GOTO 120
C             E(N) is always 0, so there is no exit through the
C             bottom of the loop.
  110      CONTINUE
  120      IF (M.EQ.L) GOTO 220
  130      IF (J.EQ.30) GOTO 1000
           J = J + 1
C          Form shift.
           L1 = L + 1
           G = D(L)
           P = (D(L1)-G)/(2.0*E(L))
           R = SQRT(P*P+1.0)
           D(L) = E(L)/(P+SIGN(R,P))
           H = G-D(L)
C
           DO 140 I = L1, N
              D(I) = D(I) - H
  140      CONTINUE
C
           F = F + H
C          QL transformation.
           P = D(M)
           C = 1.0
           S = 0.0
           MML = M - L
C
           DO 200 II = 1, MML
              I = M - II
              G = C * E(I)
              H = C * P
              IF (ABS(P).LT.ABS(E(I))) GOTO 150
              C = E(I)/P
              R = SQRT(C*C+1.0)
              E(I+1) = S * P * R
              S = C/R
              C = 1.0/R
              GOTO 160
  150         C = P/E(I)
              R = SQRT(C*C+1.0)
              E(I+1) = S * E(I) * R
              S = 1.0/R
              C = C * S
  160         P = C * D(I) - S * G
              D(I+1) = H + S * (C * G + S * D(I))
C             Form vector.
              DO 180 K = 1, N
                 H = Z(K,I+1)
                 Z(K,I+1) = S * Z(K,I) + C * H
                 Z(K,I) = C * Z(K,I) - S * H
  180         CONTINUE
  200      CONTINUE
           E(L) = S * P
           D(L) = C * P
           IF (ABS(E(L)).GT.B) GOTO 130
  220      D(L) = D(L) + F
  240   CONTINUE
C
C       Order eigenvectors and eigenvalues.
        DO 300 II = 2, N
           I = II - 1
           K = I
           P = D(I)
           DO 260 J = II, N
              IF (D(J).GE.P) GOTO 260
              K = J
              P = D(J)
  260      CONTINUE
           IF (K.EQ.I) GOTO 300
           D(K) = D(I)
           D(I) = P
           DO 280 J = 1, N
              P = Z(J,I)
              Z(J,I) = Z(J,K)
              Z(J,K) = P
  280      CONTINUE
  300   CONTINUE
C
        GOTO 1001
C       Set error - no convergence to an eigenvalue after 30 iterations.
 1000   IERR = L
 1001   RETURN
        END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                         C
C  Output array.                                                          C
C                                                                         C
C-------------------------------------------------------------------------C
        SUBROUTINE OUTMAT(N,ARRAY)
        INTEGER N,K1,K2
        REAL ARRAY(N,N)
C
        DO 100 K1 = 1, N
           WRITE (6,1000) (ARRAY(K1,K2),K2=1,N)
  100   CONTINUE
C
 1000   FORMAT(10(2X,F8.4))
        RETURN
        END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                         C
C  Output eigenvalues in order of decreasing value.                       C
C  Ignore first (trivial) eigenvalue.                                     C
C                                                                         C
C-------------------------------------------------------------------------C
        SUBROUTINE OUTEVL(NVALS,VALS)
        INTEGER K,NVALS
        REAL VALS(NVALS),CUM,VPC,VCPC,TOT
C
        TOT = 0.0
        DO 100 K = 1, NVALS-1
           TOT = TOT + VALS(K)
  100   CONTINUE
C
        WRITE (6,1000)
        CUM = 0.0
        K = NVALS
        WRITE (6,1010)
        WRITE (6,1020)
  200   CONTINUE
        K = K - 1
        CUM = CUM + VALS(K)
        VPC = VALS(K) * 100.0 / TOT
        VCPC = CUM * 100.0 / TOT
        WRITE (6,1030) VALS(K),VPC,VCPC
        IF (K.GT.1) GOTO 200
C
        RETURN
 1000   FORMAT(1H0,'EIGENVALUES FOLLOW.',/)
 1010   FORMAT
     X  (' Eigenvalues       As Percentages    Cumul. Percentages')
 1020   FORMAT
     X  (' -----------       --------------    ------------------')
 1030   FORMAT(F10.4,9X,F10.4,10X,F10.4)
        END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                         C
C         Output FIRST SEVEN eigenvectors associated with eigenvalues     C
C         in descending order.                                            C
C         Ignore first (trivial) eigenvector.                             C
C                                                                         C
C-------------------------------------------------------------------------C
        SUBROUTINE OUTEVC(NDIM,VECS)
        INTEGER NDIM,K1,K2,NUM,KDUM
        REAL  VECS(NDIM,NDIM)
C
        NUM = MIN0(NDIM,7)
        WRITE (6,1000)
        WRITE (6,1010)
        WRITE (6,1020)
        DO 100 K1 = 1, NDIM
           KDUM = NDIM - K2
           WRITE (6,1030) K1,(VECS(K1,KDUM),K2=1,NUM)
  100   CONTINUE
C
        RETURN
 1000   FORMAT(1H0,'EIGENVECTORS FOLLOW.',/)
 1010   FORMAT('  VBLE.   EV-1    EV-2    EV-3    EV-4    EV-5    EV-6
     X   EV-7')
 1020   FORMAT(' ------  ------  ------  ------  ------  ------  ------
     X------')
 1030   FORMAT(I5,2X,7F8.4)
        END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                         C
C  Output projections of objects on first 7 principal components.         C
C                                                                         C
C-------------------------------------------------------------------------C
        SUBROUTINE OUTPR(N,PRJNS)
        INTEGER N,K,J,NUM
        REAL    PRJNS(N,N)
C
        NUM = MIN0(N,7)
        WRITE (6,1000)
        WRITE (6,1010)
        WRITE (6,1020)
        DO 100 K = 1, N
           WRITE (6,1030) K,(PRJNS(K,J),J=1,NUM)
  100   CONTINUE
C
 1000   FORMAT(1H0,'PROJECTIONS OF OBJECTS FOLLOW.',/)
 1010   FORMAT('  VBLE.  PROJ-1  PROJ-2  PROJ-3  PROJ-4  PROJ-5  PROJ-6
     X  PROJ-7')
 1020   FORMAT(' ------  ------  ------  ------  ------  ------  ------
     X  ------')
 1030   FORMAT(I5,2X,7F8.4)
        RETURN
        END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                         C
C  Determine projections of objects on 7 principal components.            C
C  Ignore first (trivial) axis.                                           C
C                                                                         C
C-------------------------------------------------------------------------C
        SUBROUTINE PROJN(N,EVALS,A,Z,VEC)
        INTEGER N,J1,J2,L,NUM,J3,JDUM
        REAL    EVALS(N), A(N,N), Z(N,N), VEC(N)
C
        NUM = MIN0(N,7)
        DO 300 J1 = 1, N
           DO 50 L = 1, N
              VEC(L) = A(J1,L)
   50      CONTINUE
           DO 200 J2 = 1, NUM
              A(J1,J2) = 0.0
              JDUM = N - J2
              DO 100 J3 = 1, N
                 A(J1,J2) = A(J1,J2) + VEC(J3)*Z(J3,JDUM)
  100         CONTINUE
              IF (EVALS(N-J2).GT.0.0) A(J1,J2) =
     X                                  A(J1,J2)/SQRT(EVALS(JDUM))
              IF (EVALS(N-J2).LE.0.0) A(J1,J2) = 0.0
  200      CONTINUE
  300   CONTINUE
C
        RETURN
        END

C @(#)filtfl.for	19.1 (ESO-DMD) 02/25/03 13:31:22
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM FILTFL
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  program    FILTFL  			version 1.00	   881010
C  D. Baade       			ESO - Garching
C  						1.10	   890518
C
C.KEYWORDS
C  filtering, noise reduction
C
C.PURPOSE
C  (Partly) fill up pixels having a flux below a user-supplied threshold with 
C  the flux above the threshold in neighbouring pixels.
C
C.ALGORITHM
C  Get the names of input + output frames from IN_A + OUT_A (both 2-D). 
C  Search for pixels with flux below threshold. Search box around each 
C  such pixel for pixels with flux above threshold. Search box around each 
C  such high-flux pixel for additional low-flux pixels. Now redistribute 
C  flux from high pixels into central low pixel in such a fashion that 
C  a) all high pixels contribute the same amount to the central low pixel,
C  b) a given high pixel gives the same flux to all its neighboring low 
C     pixels, and 
C  c) no high pixel drops below the threshold. 
C	
C.INPUT/OUTPUT
C  the following keys are used:
C
C  IN_A/C/1/60			input frame
C  OUT_A/C/1/60			output frame
C  INPUTI/I/1/2			x and y dimensions of search box
C  INPUTR/R/1/1			threshold
C
C.VERSIONS
C	
C 010201		last modif
C 
C --------------------------------------------------------------------
C
      IMPLICIT NONE
C      
      INTEGER   STAT,NAXIS,NPIX(2),IAV
      INTEGER   INNO,OUTNO
      INTEGER   RADIUS(2),THRESH
      INTEGER   UNI(1),NULO,MADRID(1)
      INTEGER*8   INPT,OUTPT
C
      CHARACTER INFRM*60,OUTFRM*60,CUNIT*64,IDENT*72
C      
      DOUBLE PRECISION  START(2),STEP(2)
C 
      INCLUDE  'MID_INCLUDE:ST_DEF.INC'
C 
      COMMON   /VMR/  MADRID
C 
      INCLUDE  'MID_INCLUDE:ST_DAT.INC'
C      
C  set up MIDAS environment + enable automatic error abort
      CALL STSPRO('FILTFL')
C
C  get name of input image  + map frame 
      CALL STKRDC('IN_A',1,1,60,IAV,INFRM,UNI,NULO,STAT)
      CALL STIGET(INFRM,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +            2,NAXIS,NPIX,START,STEP,
     +            IDENT,CUNIT,INPT,INNO,STAT)
      IF (NAXIS.NE.2) 
     +   CALL STETER(1,'Currently only 2-D frames supported!')
C
C  Get name of output frame, map it for writing
      CALL STKRDC('OUT_A',1,1,60,IAV,OUTFRM,UNI,NULO,STAT)
      IF (OUTFRM.EQ.INFRM)             ! in- and output frame must be different
     +   CALL STETER
     +   (2,'Names of input + output frames must be different!')
      CALL STIPUT(OUTFRM,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +            NAXIS,NPIX,START,
     +            STEP,IDENT,CUNIT,OUTPT,OUTNO,STAT)
C 
C  copy input frame to output
      IAV = NPIX(1) * NPIX(2)
      CALL COPYF(MADRID(INPT),MADRID(OUTPT),IAV)
C
C  Get dimensions of filter box and the filtering threshold
      CALL STKRDI('INPUTI',1,2,IAV,RADIUS,UNI,NULO,STAT)
      CALL STKRDR('INPUTR',1,1,IAV,THRESH,UNI,NULO,STAT)
C      
C  Now comes the real thing:
      CALL FILLPIT(MADRID(INPT),MADRID(OUTPT),NPIX(1),NPIX(2),
     +             RADIUS(1),RADIUS(2),THRESH)
C
C  Update descriptor HISTORY
      CALL DSCUPT(INNO,OUTNO,' ',STAT)
C
C  Free data
      CALL STSEPI
      END

      SUBROUTINE FILLPIT(IN,OUT,NX,NY,RX,RY,TR)
C
      IMPLICIT NONE
C      
      INTEGER    NX,NY,RX,RY,DX,DY,I,J,K,L,M,N,IK,JL,IM,JN
      INTEGER    XSTART,XEND,YSTART,YEND,NHI1,NLO2,N20,NPERC
      INTEGER    NCHECK
C      
      REAL       IN(NX,NY),OUT(NX,NY),TR,SURPLUS,TAKE,GIVE
C
      DX=2*RX+1
      DY=2*RY+1
      XSTART=DX+1
      XEND=NX-DX
      YSTART=DY+1
      YEND=NY-DY
C
C  Prepare for progress messages
C
      N20=NX/5
      IF (N20.LT.10) THEN 
         NCHECK=999999                  ! not worth the effort
      ELSE
         NCHECK=N20
         NPERC=20
      ENDIF
C      
C  First treat all pixels farther than DX (DY) from frame boundaries 
C  in X (Y). 
C
      DO 2000 I=XSTART,XEND
         DO 1800 J=YSTART,YEND
            IF (IN(I,J).LT.TR) THEN
               NHI1=0
               GIVE=1.E+12
C
C  Consider all pixels within NX x NY box centered on the pixel to be filled 
C
                DO 1600 K=1,DX
                   IK=I+K-RX-1
                   DO 1400 L=1,DY
                      JL=J+L-RY-1
                      IF (IN(IK,JL).GT.TR) THEN 
                         NHI1=NHI1+1
                         NLO2=0
C
C  For all pixels with a flux above the threshold, check if there are 
C  other low-value pixels in their respective NX x NY neighborhood boxes:
C
                         DO 1200 M=1,DX      
                            IM=IK+M-RX-1
                            DO 1000 N=1,DY
                               JN=JL+N-RY-1
                               IF (IN(IM,JN).LT.TR) NLO2=NLO2+1
1000                        CONTINUE               ! Counted all secondary 
1200                     CONTINUE                  ! low-flux pixels ...
C
C  Pixel (IK,JL) can donate at most SURPLUS. However, it may have to divide 
C  its donation potential among NLO2 low-flux pixels. Therefore, earmark only 
C  an accordingly smaller fraction for donation to current low pixel (I,J). 
C  Furthermore, no pixel shall give more than it can afford.
C
                         SURPLUS=IN(IK,JL)-TR
                         IF (NLO2.GT.1) SURPLUS=SURPLUS/NLO2
                         IF (GIVE.GT.SURPLUS) GIVE=SURPLUS        ! always give maximimum 
                      ENDIF                  ! ... around this high-flux pixel
1400               CONTINUE
1600            CONTINUE
C
C  If no high-flux pixel has been found in the box, skip to next pixel in 
C  input image.
C
                IF (NHI1.EQ.0) GOTO 1800
C
C  All flux donations available for pixel (I,J) have been summed up, now 
C  work out if they really have to give all they can. 
C
                TAKE=NHI1*GIVE
                IF ((TAKE+IN(I,J)).GT.TR) THEN 
                   TAKE=TR-IN(I,J)
                   GIVE=TAKE/NHI1
                ENDIF
C
C  Do the donation: 
C
                DO 1700 K=1,DX
                   IK=I+K-RX-1
                   DO 1660 L=1,DY
                      JL=J+L-RY-1
                      IF (IN(IK,JL).GT.TR) 
     +                   OUT(IK,JL)=OUT(IK,JL)-GIVE 
1660               CONTINUE                  ! all donations 
1700            CONTINUE                     ! made
                OUT(I,J)=OUT(I,J)+TAKE       ! and received
            ENDIF                            ! this low pixel filled
C
1800     CONTINUE                              ! all inner pixels 
C
C  Issue progress messages
C
         IF (I.GE.NCHECK) CALL PROGRS (20,N20,NPERC,NCHECK)
C
2000  CONTINUE                                     ! dealt with
C
C  Next, consider outer pixels close to frame boundaries. Begin at left:
C
      XSTART=1
      XEND=DX
C 
      DO 6000 I=XSTART,XEND
         DO 4000 J=YSTART,YEND
            IF (IN(I,J).LT.TR) THEN
               NHI1=0
               GIVE=1.E+12
               DO 3600 K=1,DX
                  IK=I+K-RX-1
                  IF (IK.LT.1) GOTO 3600
C 
                  DO 3400 L=1,DY
                     JL=J+L-RY-1
                     IF (IN(IK,JL).GT.TR) THEN 
                        NHI1=NHI1+1
                        NLO2=0
                        DO 3200 M=1,DX      
                           IM=IK+M-RX-1
                           IF (IM.LT.1) GOTO 3200
                           DO 3000 N=1,DY
                              JN=JL+N-RY-1
                              IF (IN(IM,JN).LT.TR) NLO2=NLO2+1
3000                       CONTINUE                ! Counted all secondary 
3200                    CONTINUE                   ! low-flux pixels ...
                        SURPLUS=IN(IK,JL)-TR
                        IF (NLO2.GT.1) SURPLUS=SURPLUS/NLO2
                        IF (SURPLUS.LT.GIVE) GIVE=SURPLUS
                     ENDIF                  ! ... around this high-flux pixel
3400              CONTINUE
3600           CONTINUE
C 
               IF (NHI1.EQ.0) GOTO 4000
C 
               TAKE=NHI1*GIVE
               IF ((TAKE+IN(I,J)).GT.TR) THEN 
                  TAKE=TR-IN(I,J)
                  GIVE=TAKE/NHI1
               ENDIF
C 
               DO 3800 K=1,DX
                  IK=I+K-RX-1
                  IF (IK.LT.1) GOTO 3800
                  DO 3660 L=1,DY
                     JL=J+L-RY-1
                     IF (IN(IK,JL).GT.TR) OUT(IK,JL)=OUT(IK,JL)-GIVE
3660              CONTINUE                  ! all donations 
3800           CONTINUE                        !      made
               OUT(I,J)=OUT(I,J)+TAKE                  ! and received 
            ENDIF                        ! this low pixel filled
C
4000     CONTINUE
6000  CONTINUE
C
C  Continue at right edge:
C
      XSTART=NX-DX+1
      XEND=NX
C 
      DO 8000 I=XSTART,XEND
         DO 7800 J=YSTART,YEND
            IF (IN(I,J).LT.TR) THEN
               NHI1=0
               GIVE=1.E+12
               DO 7600 K=1,DX
                  IK=I+K-RX-1
                  IF (IK.GT.NX) GOTO 7600
C 
                  DO 7400 L=1,DY
                     JL=J+L-RY-1
C 
                     IF (IN(IK,JL).GT.TR) THEN 
                        NHI1=NHI1+1
                        NLO2=0
                        DO 7200 M=1,DX      
                           IM=IK+M-RX-1
                           IF (IM.GT.NX) GOTO 7200
C 
                           DO 7000 N=1,DY
                              JN=JL+N-RY-1
                              IF (IN(IM,JN).LT.TR) NLO2=NLO2+1
7000                       CONTINUE            ! Counted all secondary 
7200                    CONTINUE                  ! low-flux pixels ... 
                        SURPLUS=IN(IK,JL)-TR
                        IF (NLO2.GT.1) SURPLUS=SURPLUS/NLO2
                        IF (SURPLUS.LT.GIVE) GIVE=SURPLUS
                     ENDIF                  ! ... around this high-flux pixel
7400              CONTINUE
7600           CONTINUE
               IF (NHI1.EQ.0) GOTO 7800
C 
               TAKE=NHI1*GIVE
               IF ((TAKE+IN(I,J)).GT.TR) THEN 
                  TAKE=TR-IN(I,J)
                  GIVE=TAKE/NHI1
               ENDIF
               DO 7700 K=1,DX
                  IK=I+K-RX-1
                  IF (IK.GT.NX) GOTO 7700
C 
                  DO 7660 L=1,DY
                     JL=J+L-RY-1
                     IF (IN(IK,JL).GT.TR) OUT(IK,JL)=OUT(IK,JL)-GIVE
7660              CONTINUE                  ! all donations 
7700           CONTINUE                        !      made
               OUT(I,J)=OUT(I,J)+TAKE            ! and received
            ENDIF                        ! this low pixel filled
C
7800     CONTINUE
8000  CONTINUE
C
C  Switch to bottom:
C
      XSTART=DX+1
      XEND=NX-DX
      YSTART=1
      YEND=DY
C 
      DO 9000 I=XSTART,XEND
         DO 8900 J=YSTART,YEND
C 
            IF (IN(I,J).LT.TR) THEN
               NHI1=0
               GIVE=1.E+12
C 
               DO 8500 K=1,DX
                  IK=I+K-RX-1
                  DO 8400 L=1,DY
                     JL=J+L-RY-1
                     IF (JL.LT.1) GOTO 8400
C 
                     IF (IN(IK,JL).GT.TR) THEN 
                        NHI1=NHI1+1
                        NLO2=0
                        DO 8300 M=1,DX      
                           IM=IK+M-RX-1
                           DO 8200 N=1,DY
                              JN=JL+N-RY-1
                              IF (JN.LT.1) GOTO 8200
                              IF (IN(IM,JN).LT.TR) NLO2=NLO2+1
8200                       CONTINUE            ! Counted all secondary 
8300                    CONTINUE                  ! low-flux pixels ... 
                        SURPLUS=IN(IK,JL)-TR
                        IF (NLO2.GT.1) SURPLUS=SURPLUS/NLO2
                        IF (SURPLUS.LT.GIVE) GIVE=SURPLUS
                     ENDIF                  ! ... around this high-flux pixel
8400              CONTINUE
C 
8500           CONTINUE
C 
               IF (NHI1.EQ.0) GOTO 8900
               TAKE=NHI1*GIVE
               IF ((TAKE+IN(I,J)).GT.TR) THEN 
                  TAKE=TR-IN(I,J)
                  GIVE=TAKE/NHI1
               ENDIF
C 
               DO 8700 K=1,DX
                  IK=I+K-RX-1
                  DO 8600 L=1,DY
                     JL=J+L-RY-1
                     IF (JL.LT.1) GOTO 8600
                     IF (IN(IK,JL).GT.TR) OUT(IK,JL)=OUT(IK,JL)-GIVE
8600              CONTINUE                       ! all donations 
8700           CONTINUE                          ! made
               OUT(I,J)=OUT(I,J)+TAKE            ! and received 
            ENDIF                                ! this low pixel filled
8900     CONTINUE
C
9000  CONTINUE
C
C  Finish at top:
C
      YSTART=NY-DY+1
      YEND=NY
C 
      DO 10000 I=XSTART,XEND
         DO 9900 J=YSTART,YEND
            IF (IN(I,J).LT.TR) THEN
               NHI1=0
               GIVE=1.E+12
               DO 9500 K=1,DX
                  IK=I+K-RX-1
                  DO 9400 L=1,DY
                     JL=J+L-RY-1
                     IF (JL.GT.NY) GOTO 9400
                     IF (IN(IK,JL).GT.TR) THEN 
                        NHI1=NHI1+1
                        NLO2=0
                        DO 9300 M=1,DX      
                           IM=IK+M-RX-1
                           DO 9200 N=1,DY
                              JN=JL+N-RY-1
                              IF (JN.GT.NY) GOTO 9200
                              IF (IN(IM,JN).LT.TR) NLO2=NLO2+1
9200                       CONTINUE            ! Counted all secondary 
9300                    CONTINUE                  ! low-flux pixels ... 
                        SURPLUS=IN(IK,JL)-TR
                        IF (NLO2.GT.1) SURPLUS=SURPLUS/NLO2
                        IF (SURPLUS.LT.GIVE) GIVE=SURPLUS
                     ENDIF                  ! ... around this high-flux pixel
9400              CONTINUE
9500           CONTINUE
C 
               IF (NHI1.EQ.0) GOTO 9900
               TAKE=NHI1*GIVE
               IF ((TAKE+IN(I,J)).GT.TR) THEN 
                  TAKE=TR-IN(I,J)
                  GIVE=TAKE/NHI1
               ENDIF
C 
               DO 9700 K=1,DX
                  IK=I+K-RX-1
                  DO 9600 L=1,DY
                     JL=J+L-RY-1
                     IF (JL.GT.NY) GOTO 9600
                     IF (IN(IK,JL).GT.TR) OUT(IK,JL)=OUT(IK,JL)-GIVE
9600              CONTINUE                       ! all donations 
9700           CONTINUE                          ! made
               OUT(I,J)=OUT(I,J)+TAKE            ! and received 
            ENDIF                                ! this low pixel filled
9900     CONTINUE
C
10000 CONTINUE
C
      RETURN
      END

C @(#)inttab.for	19.1 (ES0-DMD) 02/25/03 13:29:43
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE INTINI(INTNAM,TIDINT)
C++
C.Purpose: Create the intermediate table with the following columns
C.         col 1       : group identification                 format = I
C.         col 2:      : component identification (star or hole)       I
C.         col 3 to 18 : general window paremeters                     R
C.         col 19      : flag parameter                                C*2
C.         col 20 to 25: fit parameters                                R
C.Author:  Rein Warmels, ESO Garching
C.Version: 890812  RHW  Type column taken out
C--
      IMPLICIT        NONE
      CHARACTER*60    INTNAM
      INTEGER         TIDINT
C
      INTEGER         NGRP
      INTEGER         NIDN
      INTEGER         NGEN
      INTEGER         NFLG
      INTEGER         NPAR
      INTEGER         NRINT
      PARAMETER       (NGRP=1)
      PARAMETER       (NIDN=1)
      PARAMETER       (NGEN=16)
      PARAMETER       (NFLG=1)
      PARAMETER       (NPAR=6)
      PARAMETER       (NRINT=10000)
      INTEGER         NROW
      INTEGER         NCINT
      INTEGER         ISTAT
      INTEGER         I

      CHARACTER*80    STRING
      CHARACTER*16    FORMI2
      CHARACTER*16    FORMI6
      CHARACTER*16    FORMR4
      CHARACTER*16    UNIT
C
      CHARACTER*16    LABGRP
      CHARACTER*16    LABIDN
      CHARACTER*16    LABGEN(16)
      CHARACTER*16    LABFLG
      CHARACTER*16    LABPAR(6)
C
      INTEGER         INTTYP
      INTEGER         INTCOL
      CHARACTER*16    INTFOR
      CHARACTER*16    INTUNI
      CHARACTER*16    INTLAB

      INCLUDE         'MID_INCLUDE:ST_DEF.INC'
      INCLUDE         'MID_INCLUDE:ST_DAT.INC'
C
      DATA            NROW/1000/
      DATA            FORMI2/'I2'/
      DATA            FORMI6/'I6'/
      DATA            FORMR4/'E12.4'/
      DATA            UNIT/'    '/
      DATA            LABGRP/'GROUP '/
      DATA            LABIDN/'IDENT'/
      DATA            LABGEN/'WND_XSTA', 'WND_YSTA', 'MAG1    ', 
     2                       'MAG2    ', 'MAG3    ', 'WND_XDIM', 
     3                       'WND_YDIM', 'BG_XCOEF', 'BG_YCOEF', 
     4                       'BG      ', 'BETA    ', 'VARIANCE',
     4                       'FIT_ITER', 'WND_FL  ', 'N_CMP   ', 
     5                       'N_HOL   '/
      DATA            LABFLG/'CMP_FL  '/
      DATA            LABPAR/'INT_FIT ', 'X_FIT    ', 'Y_FIT  ',
     2                       'SIGMA   ', 'CHI_SQ   ', 'SIQ    '/

C
C *** create a new intermediate table
      NCINT = NGRP + NIDN + NGEN + NFLG + NPAR 
      CALL TBTINI(INTNAM,0,F_O_MODE,NCINT,NRINT,TIDINT,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** INFO: Problems with opening a new intermediate'//
     2            ' table'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ELSE
C 
C *** intialize the column for the group number
         INTTYP = D_I4_FORMAT
         INTFOR = FORMI6
         INTUNI = UNIT
         INTLAB = LABGRP
         CALL TBCINI(TIDINT,INTTYP,NGRP,INTFOR,INTUNI,
     2                      INTLAB,INTCOL,ISTAT)
C 
C *** intialize the column for the name of the component
         INTTYP = D_I4_FORMAT
         INTFOR = FORMI6
         INTUNI = UNIT
         INTLAB = LABIDN
         CALL TBCINI(TIDINT,INTTYP,NIDN,INTFOR,INTUNI,
     2                      INTLAB,INTCOL,ISTAT)
C 
C *** initialize the column for the standard data        
         DO 10 I = 1,NGEN
            INTTYP = D_R4_FORMAT
            INTFOR = FORMR4
            INTUNI = UNIT
            INTLAB = LABGEN(I)
            CALL TBCINI(TIDINT,INTTYP,1,INTFOR,INTUNI,
     2                         INTLAB,INTCOL,ISTAT)
  10     CONTINUE
C
C *** initialize the column for the component flag
         INTTYP = D_I4_FORMAT
         INTFOR = FORMI2
         INTUNI = UNIT
         INTLAB = LABFLG
         CALL TBCINI(TIDINT,INTTYP,NFLG,INTFOR,INTUNI,
     2                      INTLAB,INTCOL,ISTAT)
C
C *** initialize the column for the object parameters
         DO 20 I = 1,NPAR
            INTTYP = D_R4_FORMAT
            INTFOR = FORMR4
            INTUNI = UNIT
            INTLAB = LABPAR(I)
            CALL TBCINI(TIDINT,INTTYP,1,INTFOR,INTUNI,
     2                         INTLAB,INTCOL,ISTAT)
  20     CONTINUE
      ENDIF
C
      RETURN
      END


      SUBROUTINE INTDRD(IDEN,INTG1,INTG2,INTG3,
     2                  REAL1,REAL2,REAL3,REAL4,REAL5,REAL6,REAL7)
C+++
C.PURPOSE: Write the table info into the descriptor
C---
      IMPLICIT NONE	
      INTEGER  IDEN
      INTEGER  INTG1,INTG2,INTG3
      REAL     REAL1,REAL2,REAL3,REAL4,REAL5,REAL6,REAL7
C
      INTEGER  ISTAT, IACT, KUN, KNUL
C
      INTEGER IOUT(3)
      REAL    ROUT(7)
C
      INCLUDE      'MID_INCLUDE:ST_DEF.INC/NOLIST'
      INCLUDE      'MID_INCLUDE:ST_DAT.INC/NOLIST'
C     
      CALL STDRDR(IDEN,'INTPAR_R',1,7,IACT,ROUT,KUN,KNUL,ISTAT)
      REAL1  = ROUT(1)                                    !
      REAL2  = ROUT(2)                                    !
      REAL3  = ROUT(3)                                    !
      REAL4  = ROUT(4)                                    !
      REAL5  = ROUT(5)                                    !
      REAL6  = ROUT(6)                                    !
      REAL7  = ROUT(7)                                    !
C
      CALL STDRDI(IDEN,'INTPAR_I',1,3,IACT,IOUT,KUN,KNUL,ISTAT)
      INTG1  = IOUT(1)                                    ! number of groups
      INTG2  = IOUT(2)                                    ! number of components
      INTG3  = IOUT(3)                                    ! number of iterations
C
      RETURN
      END


      SUBROUTINE INTDWR(IDEN,INTG1,INTG2,INTG3,
     2                  REAL1,REAL2,REAL3,REAL4,REAL5,REAL6,REAL7)
C+++
C---
      IMPLICIT NONE
      INTEGER  IDEN
      INTEGER  INTG1,INTG2,INTG3
      REAL     REAL1,REAL2,REAL3,REAL4,REAL5,REAL6,REAL7
C
      INTEGER  KUN, ISTAT
C
      INTEGER  IOUT(3)
      REAL     ROUT(7)
C
      INCLUDE      'MID_INCLUDE:ST_DEF.INC/NOLIST'
      INCLUDE      'MID_INCLUDE:ST_DAT.INC/NOLIST'
C     
      ROUT(1)  = REAL1                                    !
      ROUT(2)  = REAL2                                    !
      ROUT(3)  = REAL3                                    !
      ROUT(4)  = REAL4                                    !
      ROUT(5)  = REAL5                                    !
      ROUT(6)  = REAL6                                    !
      ROUT(7)  = REAL7                                    !
      CALL STDWRR(IDEN,'INTPAR_R',ROUT,1,7,KUN,ISTAT)
C
      IOUT(1)  = INTG1                                    ! number of groups
      IOUT(2)  = INTG2                                    ! number of components
      IOUT(3)  = INTG3                                    ! number of iterations
      CALL STDWRI(IDEN,'INTPAR_I',IOUT,1,3,KUN,ISTAT)
C    
      RETURN
      END


      SUBROUTINE INTWRD(TID,IROW,NCOMPS,NHOLES)
C+++
C.Purpose: Reads the intermediate table starting from row = IROW.
C.         The data will be stores in a THREE common blocks to be read by
C.         calling program.
C---
      IMPLICIT      NONE
      INTEGER       TID                         ! table identification
      INTEGER       IROW                        ! row indication where to start
      INTEGER       NCOMPS                      ! number of components in window
      INTEGER       NHOLES                      ! number of holes in window
C
      INCLUDE       'MID_REL_INCL:RFOTDECL.INC/NOLIST'
C
      INTEGER       ISTAT
      INTEGER       IR, IS, IH
      INTEGER       ICGRP
      INTEGER       ICIDN
      INTEGER       ICGEN(NINTP)
      INTEGER       ICFLG
      INTEGER       ICPAR(NINTC)
      INTEGER       TINULL
C
      DOUBLE PRECISION TDNULL,TDTRUE,TDFALS
C
      REAL          RNST, RNHL
      REAL          ROUT(NINTC)
      REAL          TRNULL,TBLSEL
C
      LOGICAL       NULL(NINTP)
C
C
      DATA          ICGRP/1/
      DATA          ICIDN/2/
      DATA          ICGEN/3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18/
      DATA          ICFLG/19/
      DATA          ICPAR/20,21,22,23,24,25/
C
C *** start the code; first define the columns
      CALL TBMNUL(TINULL,TRNULL,TDNULL)
      CALL TBMCON(TBLSEL,TDTRUE,TDFALS)
C
C *** read general parameters
      CALL TBERDI(TID,IROW,ICGRP,IDNGRP,NULL,ISTAT)            ! group number
      CALL TBRRDR(TID,IROW,NINTP,ICGEN,PARINT,NULL,ISTAT)      ! gen. parameters
C
C *** read the star parameters
      CALL TBERDR(TID,IROW,ICGEN(15),RNST,NULL,ISTAT)          ! # stars
      CALL TBERDR(TID,IROW,ICGEN(16),RNHL,NULL,ISTAT)          ! # holes
      NCOMPS = INT(RNST)
      NHOLES = INT(RNHL)
C
C *** get the identification and fit parameters for the stars
      IF (NCOMPS.GT.0) THEN
         DO 100 IS = 1, NCOMPS
            IR = IROW + IS - 1
            CALL TBERDI(TID,IR,ICIDN,IDNCMP(IS),NULL,ISTAT)    ! ident comp.
            CALL TBERDI(TID,IR,ICFLG,FLGCMP(IS),NULL,ISTAT)    ! flag
            CALL TBRRDR(TID,IR,NINTC,ICPAR,ROUT,NULL,ISTAT)    ! comp. par.
            FITCMP((IS-1)*6+1) = ROUT(1)
            FITCMP((IS-1)*6+2) = ROUT(2)
            FITCMP((IS-1)*6+3) = ROUT(3)
            FITCMP((IS-1)*6+4) = ROUT(4)
            FITCMP((IS-1)*6+5) = ROUT(5)
            FITCMP((IS-1)*6+6) = ROUT(6)
 100     CONTINUE
      ENDIF
C
C*** get the hole parameters
      IF (NHOLES.GT.0) THEN
         DO 200 IH = 1, NHOLES
            IR = IROW + NCOMPS + IH - 1
            CALL TBERDI(TID,IR,ICIDN,IDNHOL(IH),NULL,ISTAT)    ! ident
            CALL TBERDI(TID,IR,ICFLG,FLGHOL(IH),NULL,ISTAT)    ! flag
            CALL TBRRDR(TID,IR,NINTH,ICPAR,ROUT,NULL,ISTAT)    ! hole par.
            FITHOL((IH-1)*3+1) = ROUT(1)
            FITHOL((IH-1)*3+2) = ROUT(2)
            FITHOL((IH-1)*3+3) = ROUT(3)
  200    CONTINUE
      ENDIF
C
      RETURN
      END


      SUBROUTINE INTWWR(TID,IROW,NCOMP,NHOLES)
C+++
C.Purpose: Writes the intermediate table starting from row = IROW.
C.         The data will be stores in a THREE common blocks to be read by
C.         calling program.
C---
      IMPLICIT      NONE
      INTEGER       TID                         ! table identification 
      INTEGER       IROW                        ! row indication where to start
      INTEGER       NCOMP                       ! number of components
      INTEGER       NHOLES                      ! number of holes
C
      INCLUDE       'MID_REL_INCL:RFOTDECL.INC/NOLIST'     ! array dimensions
C
      INTEGER       IR, IS, IH
      INTEGER       ISTAT
      INTEGER       ICGRP
      INTEGER       ICIDN
      INTEGER       ICGEN(NINTP)
      INTEGER       ICFLG
      INTEGER       ICPAR(NINTC)
      REAL          ROUT(NINTC)
C
      DATA          ICGRP/1/
      DATA          ICIDN/2/
      DATA          ICGEN/3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18/
      DATA          ICFLG/19/
      DATA          ICPAR/20,21,22,23,24,25/
C
C *** write the star parameters
      DO 100 IS = 1,NCOMP
         IR   = IROW + IS - 1
         CALL TBEWRI(TID,IR,ICGRP,IDNGRP,ISTAT)          ! write group number
         CALL TBEWRI(TID,IR,ICIDN,IDNCMP(IS),ISTAT)      ! write sort object
         CALL TBRWRR(TID,IR,NINTP,ICGEN,PARINT,ISTAT)    ! write gen. pars.
         CALL TBEWRI(TID,IR,ICFLG,FLGCMP(IS),ISTAT)      ! write the flag
C 
         ROUT(1) = FITCMP((IS-1)*6+1)
         ROUT(2) = FITCMP((IS-1)*6+2)
         ROUT(3) = FITCMP((IS-1)*6+3)
         ROUT(4) = FITCMP((IS-1)*6+4)
         ROUT(5) = FITCMP((IS-1)*6+5)
         ROUT(6) = FITCMP((IS-1)*6+6)
         CALL TBRWRR(TID,IR,NINTC,ICPAR,ROUT,ISTAT)      ! write object par.
  100 CONTINUE
C
C*** write the hole parameters
      IF (NHOLES.GT.0) THEN
         DO 200 IH = 1, NHOLES
            IR = IROW + NCOMP + IH - 1
            CALL TBEWRI(TID,IR,ICGRP,IDNGRP,ISTAT)       ! write group number
            CALL TBEWRI(TID,IR,ICIDN,IDNHOL(IH),ISTAT)   ! write the sort object
            CALL TBRWRR(TID,IR,NINTP,ICGEN,PARINT,ISTAT) ! write gen. pars.
            CALL TBEWRI(TID,IR,ICFLG,FLGHOL(IH),ISTAT)   ! write the flag
C
            ROUT(1) = FITHOL((IH-1)*3+1)
            ROUT(2) = FITHOL((IH-1)*3+2)
            ROUT(3) = FITHOL((IH-1)*3+3)
            CALL TBRWRR(TID,IR,NINTH,ICPAR,ROUT,ISTAT)
  200    CONTINUE
      ENDIF
C
      RETURN
      END


      SUBROUTINE INTCWR(TID,IROW,INDEX)
C+++
C.Purpose: Writes a ro in the intermediate table at row = IROW.
C.         The data will be stores in a THREE common blocks to be read by
C.         calling program.
C---
      IMPLICIT      NONE
      INTEGER       TID                      ! table identification 
      INTEGER       IROW                     ! row indication where to start
      INTEGER       INDEX                    ! start index of component in table
C
      INCLUDE       'MID_REL_INCL:RFOTDECL.INC/NOLIST'          ! declarations
C
      INTEGER       ISTAT
      INTEGER       ICGRP
      INTEGER       ICIDN
      INTEGER       ICGEN(NINTP)
      INTEGER       ICFLG
      INTEGER       ICPAR(NINTC)
      REAL          ROUT(NINTC)
C
      DATA          ICGRP/1/
      DATA          ICIDN/2/
      DATA          ICGEN/3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18/
      DATA          ICFLG/19/
      DATA          ICPAR/20,21,22,23,24,25/
C
C *** write the component parameters
      CALL TBEWRI(TID,IROW,ICGRP,IDNGRP,ISTAT)           ! write group number
      CALL TBEWRI(TID,IROW,ICIDN,IDNCMP(INDEX),ISTAT)    ! write the sort object
      CALL TBRWRR(TID,IROW,NINTP,ICGEN,PARINT,ISTAT)     ! write gen. parameters
      CALL TBEWRI(TID,IROW,ICFLG,FLGCMP(INDEX),ISTAT)    ! write the flag
C 
      ROUT(1) = FITCMP((INDEX-1)*6+1)                    ! copy comp. parameters
      ROUT(2) = FITCMP((INDEX-1)*6+2)
      ROUT(3) = FITCMP((INDEX-1)*6+3)
      ROUT(4) = FITCMP((INDEX-1)*6+4)
      ROUT(5) = FITCMP((INDEX-1)*6+5)
      ROUT(6) = FITCMP((INDEX-1)*6+6)
      CALL TBRWRR(TID,IROW,NINTC,ICPAR,ROUT,ISTAT)       ! write component par.
C
      RETURN
      END


      SUBROUTINE INTHWR(TID,IROW,INDEX)
C+++
C.Purpose: Writes a ro in the intermediate table at row = IROW.
C.         The data will be stores in a THREE common blocks to be read by
C.         calling program.
C---
      IMPLICIT      NONE
      INTEGER       TID                      ! table identification 
      INTEGER       IROW                     ! row indication where to start
      INTEGER       INDEX                    ! start index of component in table
C
      INCLUDE       'MID_REL_INCL:RFOTDECL.INC/NOLIST'
C
      INTEGER       ISTAT
      INTEGER       ICGRP
      INTEGER       ICIDN
      INTEGER       ICGEN(NINTP)
      INTEGER       ICFLG
      INTEGER       ICPAR(NINTH)
      REAL          ROUT(NINTH)
C
      DATA          ICGRP/1/
      DATA          ICIDN/2/
      DATA          ICGEN/3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18/
      DATA          ICFLG/19/
      DATA          ICPAR/20,21,22/
C
C *** write the component parameters
      CALL TBEWRI(TID,IROW,ICGRP,IDNGRP,ISTAT)           ! write group number
      CALL TBEWRI(TID,IROW,ICIDN,IDNHOL(INDEX),ISTAT)    ! write the sort object
      CALL TBRWRR(TID,IROW,NINTP,ICGEN,PARINT,ISTAT)     ! write gen. parameters
      CALL TBEWRI(TID,IROW,ICFLG,FLGHOL(INDEX),ISTAT)    ! write the flag
C 
      ROUT(1) = FITHOL((INDEX-1)*3+1)                    ! copy comp. parameters
      ROUT(2) = FITHOL((INDEX-1)*3+2)
      ROUT(3) = FITHOL((INDEX-1)*3+3)
      CALL TBRWRR(TID,IROW,NINTH,ICPAR,ROUT,ISTAT)       ! write component par.
C
      RETURN
      END

C @(#)subpxl.for	19.1 (ES0-DMD) 02/25/03 13:25:40
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C
C-----------------------------------------------------------------------
      SUBROUTINE SUBPXL ( NCT , PMT , LSBP , IACT , JACT , IS , JS )
C
      IMPLICIT  NONE
      INCLUDE   'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER   NCT(NIPAR)                   ! IN: Integer parameters
      REAL      PMT(NRPAR)                   ! IN: Real parameters
      INTEGER   LSBP                         ! IN: Subpixel extend
      INTEGER   IACT                         ! OUT: X pixel number
      INTEGER   JACT                         ! OUT: Y pixel number
      INTEGER   IS                           ! OUT: X subpixel number
      INTEGER   JS                           ! OUT: Y subpixel number
C
      INTEGER   MSBP
C
      IACT = NCT(1)
      JACT = NCT(2)
C
      MSBP = 2 * LSBP + 1
      IS = NINT( ( PMT(10) - FLOAT(IACT) ) * FLOAT(MSBP) )
      IF ( IS .GT. LSBP ) THEN
          IS = LSBP
      ELSE IF ( IS .LT. (-LSBP) ) THEN
          IS = -LSBP
      ENDIF
      JS = NINT( ( PMT(11) - FLOAT(JACT) ) * FLOAT(MSBP) )
      IF ( JS .GT. LSBP ) THEN
          JS = LSBP
      ELSE IF ( JS .LT. (-LSBP) ) THEN
          JS = -LSBP
      ENDIF
C
      RETURN
C
      END
C

C @(#)comp2sam.for	19.1 (ES0-DMD) 02/25/03 13:21:26
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  5 JUL 1989
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: M.PERON
C
C.IDENTIFICATION
C
C  Program COMP2SAM
C
C.KEYWORDS
C
C KOLMOGOROV, SIGN, WILCOXON
C
C.PURPOSE
C
C Comparaison of two data sets using 
C   - Kolmogorov Test 
C   - Sign Test  - NOT IMPLEMENTED YET-
C   - Wilcoxon Test - NOT IMPLEMENTED YET-
C   - Mann-Whitney U test -NOT IMPLEMENTED YET-
C-----------------------------------------------------------
C
       PROGRAM   COMP2SAM
       REAL      D,PROB
       INTEGER   MADRID
       INTEGER*8 ADDRIN(4)
       INTEGER   NSC,KUN
       INTEGER*4 PARVAL,NPAR,ISTAT,TID,NCOL,NROW,NACOL,NAROW,COL1,COL2
       INTEGER*4 NBYTES,NREAL
       CHARACTER*80 INTAB,OUTPUT1,OUTPUT2,OUTPUT3,OUT,OUTPUT0
       CHARACTER*17 COLIND,COLDEP
       INCLUDE 'MID_INCLUDE:TABLES.INC'
       COMMON/VMR/MADRID(1)
       INCLUDE 'MID_INCLUDE:TABLED.INC'
       DATA PARVAL/8/
       DATA OUTPUT0
     1 /' Null Hypothesis: the two data sets come 
     2   from the same distribution'/
       DATA OUTPUT1
     3    /'Kolmogorov-Smirnov D Statistic '/
       DATA OUTPUT2
     4   /'Probability of exceeding D under Null Hypothesis'/
       DATA OUTPUT3
     5 /'----------------------------------------------------------'/
       CALL STSPRO('COMP2SAM')
       CALL TDPGET(PARVAL,NPAR,ISTAT)
       IF  (ISTAT.NE.0) GOTO 80
       INTAB = TPARBF(1)
       COLIND = TPARBF(2)
       COLDEP = TPARBF(3)
       CALL TBTOPN(INTAB,F_U_MODE,TID,ISTAT)       
       IF(ISTAT.NE.0) GOTO 80
       CALL TBIGET(TID,NCOL,NROW,NSC,NACOL,NAROW,ISTAT)
        CALL TBCSER(TID,COLIND,COL1,ISTAT)
         IF (COL1.LT.0) THEN
         CALL STTPUT('Column not found...',ISTAT)
          GOTO 80
        ENDIF
        CALL TBCSER(TID,COLDEP,COL2,ISTAT)
        IF (COL2.LT.0) THEN
          CALL STTPUT('Column not found...',ISTAT)
          GOTO 80
        ENDIF
       NBYTES = 4*NROW
       CALL TDMGET(NBYTES,ADDRIN(1),ISTAT)
       CALL TDMGET(NBYTES,ADDRIN(2),ISTAT)
       CALL TMAP2(TID,NROW,COL1,COL2,MADRID(ADDRIN(1)),
     1        MADRID(ADDRIN(2)),NREAL)
           CALL SORT (MADRID(ADDRIN(1)),NREAL)
           CALL SORT (MADRID(ADDRIN(2)),NREAL)
                CALL KOLM2DIS(MADRID(ADDRIN(1)),NROW,MADRID(ADDRIN(2)),
     1              NREAL,D,PROB)
          CALL STKWRR('OUTPUTR',D,1,1,KUN,ISTAT)
          CALL STKWRR('OUTPUTR',PROB,2,1,KUN,ISTAT)
          CALL STTPUT(OUTPUT0,ISTAT)
          CALL STTPUT(OUTPUT3,ISTAT)
          WRITE(OUT,100)D
          CALL STTPUT(OUTPUT1,ISTAT)
          CALL STTPUT(OUT,ISTAT)
          CALL STTPUT(OUTPUT3,ISTAT)
          CALL STTPUT(OUTPUT2,ISTAT)
          WRITE(OUT,100)PROB
          CALL STTPUT(OUT,ISTAT)
          CALL STTPUT(OUTPUT3,ISTAT)

C       IF (ACTION.EQ.'SIGN') THEN
C          CALL SIGN(MADRID(ADDRIN(1)),MADRID(ADDRIN(2)),NROW)
C       ENDIF
C       IF (ACTION.EQ.'WILC') THEN
C          CALL TDMGET(NBYTES,ADDRIN(3),ISTAT)
C          CALL TDMGET(NBYTES,ADDRIN(4),ISTAT)
C          CALL WILC(MADRID(ADDRIN(1)),MADRID(ADDRIN(2)),MADRID(ADDRIN(3)),
C     1          MADRID(ADDRIN(4)),NROW,S)
C          MEAN = NROW*(NROW+1)/4
C          SIGMA = NROW*(NROW+1)*(2*NROW+1)/24
C           PROB = ERFCC((S-MEAN)/SQRT(2.*SIGMA))
C          CALL STKWRR('OUTPUTR',S,1,1,KUN,ISTAT)
C          CALL STKWRR('OUTPUTR',PROB,2,1,KUN,ISTAT)
C          WRITE(OUT,100)S,PROB
C          CALL STTPUT(OUTPUT2,ISTAT)
C          CALL STTPUT(OUTPUT3,ISTAT)
C          CALL STTPUT(OUT,ISTAT)
C       ENDIF
        CALL TBTCLO(TID,ISTAT)
       CALL STSEPI
80      CONTINUE
100     FORMAT(1X,G15.6,15X,G15.6)
        END

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
        PROGRAM PLAN
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT (c) Andrew T. Young, 1990
C.COPYRIGHT (c) European Southern Observatory, 1992
C.IDENT         program plan
C.MODULE        plantop.for
C.AUTHOR        Andrew T. Young
C.KEYWORD
C.LANGUAGE      FORTRAN 77
C.PURPOSE       Makes a photometric observing schedule
C.COMMENTS
C.VERSION       0.0
C               0.5     921202, KB
C               4.4     930212, ATY
C               4.6     930322, ATY
C               4.7     930327, ATY
C               4.8     930401, ATY
C               5.2     930429, ATY
C.RETURNS       error numbers correspond to nearby statement numbers
C.ENVIRONMENT   MIDAS
C 
C 100618	last modif
C-----------------------------------------------------------------------------
C
      IMPLICIT NONE
C
C  BEGIN Declarations:
C
C
C  Set up MIDAS declarations:
C
        INTEGER MADRID(1)
C
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
        COMMON /VMR/ MADRID
C
C
C                   JULY 2, 1987 -- PARTLY CLEANED OF REDUNDANT SUBROUTINES.
C
C  PLANS PHOTOMETRIC OBSERVATIONS, USING STANDARD STARS FROM STDFIL.
C
C *** SYSTEM-DEPENDENT FEATURES ARE FLAGGED BY *** COMMENTS LIKE THIS.
C
C   F I L E S :
C   -----------
C
      CHARACTER*80 STDFIL, CATFIL, OBSFIL
      CHARACTER*80 SAVFIL
C *** LENGTH OF FILE NAMES MAY BE SYSTEM-DEPENDENT.
C     FULL SET FOR SUBROUTINE COMPATIBILITY.
      INTEGER KB, KTV, K2, K3, K4, K7, K8, K9
      COMMON /FILNOS/ KB, KTV, K2, K3, K4, K7, K8, K9
C *** UNITS MAY BE SYSTEM-DEPENDENT.
C
C
C    N A M I N G   C O N V E N T I O N S :
C    ------------------------------------
C                                        EXTERNAL NAME          SAMPLE
C    QUANTITY       VARIABLE      TYPE   FOR DATA FILE           VALUE
C    --------       --------      ----   -------------          ------
C
C  NAMES:
C
C    PLACE NAME       PLACE       CH*20                      KITT PEAK
C    BAND NAME        BAND        CH*6
C    STAR NAME        STAR        CH*20      STAR              HR 8832
C    STAR CODE       STRCDS       CH*20     STARCD                  17
C    INDICES        CNAMES(1,NB)  CH*6     V, B-V, M1, ...       -0.20
C    GAIN CONTROL  GCONTR(NGAIN)  CH*20                         COARSE
C    GAIN SETTING   GANCOD(I,N)   CH*20   GAINS1, ... ,GAINS4        2
C
C  COORDINATES IN RADIANS:
C
C    LONGITUDE        ELONG       REAL
C    LATITUDE         ALAT        REAL
C    HOUR ANGLE       HA          REAL
C    RIGHT ASCENSION  RA          REAL
C    DECLINATION      DEC         REAL
C    UNIVERSAL TIME   UT          REAL
C    ZONE TIME        ZT          REAL
C    SIDEREAL TIME    ST          REAL
C
C      EXTERNAL SUB-UNITS ARE NAMED AS FOLLOWS:            TYPE
C                                                          ----
C      DEGREES      1ST 2 LETTERS OF REAL VARIABLE//'DEG'  REAL
C       HOURS        "  "    "    "   "      "    //'HRS'  REAL
C      MINUTES       "  "    "    "   "      "    //'MIN'  REAL
C      SECONDS       "  "    "    "   "      "    //'SEC'  REAL
C
C   SPECIAL FORMS:
C      ROTATIONS     "  "    "    "   "      "    //'ROT'  REAL
C     CHAR.STRING    "  "    "    "   "      "    //'STR'  CHARACTER*20
C        SIGN        "  "    "    "   "      "    //'SGN'  CHARACTER*20
C
C      EXAMPLES: RAHRS, UTMIN, ELSEC, ALDEG, DESTR, DESGN
C
C
C   P E P S Y S   S Y S T E M   V A R I A B L E S
C   ---------------------------------------------
C
      INTEGER MOBS
      PARAMETER (MOBS=10)
      CHARACTER *20  PLACE*72, PLACES(MOBS)
      REAL ELDEGS,ALDEGS,HIGHS
      DIMENSION ELDEGS(MOBS),ALDEGS(MOBS),HIGHS(MOBS)
C
      INCLUDE 'MID_REL_INCL:mstars.inc'
C     PARAMETER (MSTARS=1650)
C       commons for star catalog:
      CHARACTER *32 STARS
      COMMON /SCATA/ STARS(MSTARS)
      REAL RAS, DECS, EQUINX, COLORS
      COMMON /SCAT/ RAS(MSTARS), DECS(MSTARS), EQUINX(MSTARS), COLORS
C
C    CAUTION -- MBANDS IS IN SUBROUTINES RDLIST, OPNFIL, DECOLR, & EPHEM.
      INCLUDE 'MID_REL_INCL:mbands.inc'
C     PARAMETER (MBANDS=9)
      REAL COLORM, COLRIN,  XINV,YINV
      INTEGER NBANDS,LENB,LENC,KX,KY
      COMMON /CMAGS1/ COLORM(MBANDS,MBANDS),COLRIN(MBANDS,MBANDS),
     1 XINV,YINV,NBANDS,LENB,LENC,KX,KY
C
      REAL PHOMAG,FAINTS,BRITES,SZMAX,
     1 SZMIN,EXTIN,SIGTOT,TINT1,TSUGG
      COMMON /CMAGS2/PHOMAG(MBANDS),FAINTS(MBANDS),BRITES(MBANDS),SZMAX,
     1 SZMIN,EXTIN(MBANDS),SIGTOT,TINT1,TSUGG
      SAVE /CMAGS1/,/CMAGS2/
C
      CHARACTER *8 BAND, BANDS(3*MBANDS), CNAMES(2,MBANDS)
      REAL TRANS,WLS,WIDTHS
      DIMENSION
     1 TRANS(MBANDS),WLS(MBANDS),WIDTHS(MBANDS),COLORS(MBANDS,MSTARS)
      INTEGER KOLR
      DIMENSION KOLR(MBANDS)
      INTEGER MBM1,MBM2,MBM3,MBM4,MBM5,MBM6,MBM7
      PARAMETER(MBM1=MBANDS-1,MBM2=MBANDS-2,MBM3=MBANDS-3,MBM4=MBANDS-4)
      PARAMETER(MBM5=MBANDS-5,MBM6=MBANDS-6,MBM7=MBANDS-7)
C
      INTEGER MSYS
      PARAMETER (MSYS=8)
      CHARACTER*6 SYSTEM,SYSTMS(MSYS),STDFLS(MSYS),BNDS(MBANDS,MSYS)
     1 ,BNDVAR(MBANDS,MSYS)
      INTEGER JBANDS,LENBS,LENCS, KXS,KYS
      REAL XINVS,YINVS,STDWLS,FWHMS,TRANSS
      DIMENSION JBANDS(MSYS),LENBS(MSYS),LENCS(MSYS),
     1 KXS(MSYS),KYS(MSYS),XINVS(MSYS),YINVS(MSYS)
      DIMENSION STDWLS(MBANDS,MSYS),FWHMS(MBANDS,MSYS),
     1TRANSS(MBANDS,MSYS)
C
C
C  PARAMETERS FOR RDLIST/RDBLOK.
C
      INTEGER MGAINS,MG2,MA,MCAT,MN,MV,MGRPS,MAREST,MNREST
      PARAMETER (MGAINS=4, MG2=2*MGAINS)
      PARAMETER (MA=21+MG2+5)
      PARAMETER (MCAT=12+2*MBANDS,MN=MCAT+30, MV=MA+MN, MGRPS=8)
      PARAMETER (MAREST=MA-21-MG2, MNREST=MN-MCAT-15)
C
C  MA = MAX. ALPHABETIC (CHARACTER) VARIABLES,  AVAR  IN /NAMES/
C  MN = MAX. NUMERIC VARIABLES,                 VAR   IN /VALUES/
C  MV = MAX. VARIABLE NAMES,                    NAMES IN /NAMES/
C
C   COMMONS FOR RDLIST/RDBLOK.  NOTE RENAMING OF ELEMENTS OF AVAR.
C
C   THESE MA CHARACTER VARIABLES REPLACE AVAR(MA):
C     CHARACTER NAMES(MV)*6,TITLE*80, AVAR(MA)*20  <--REPLACED BY LIST.
C
      CHARACTER NAMES(MV)*6,TITLE*80
      CHARACTER*32 STAR
      CHARACTER*20 RASTR,DESTR,BAYER,CONSTL,FLAMST,BSHR,HD,DM,
     1 SPECT,DESGN,DATSTR,MONTH,REM1,REM2,STSTR,ZTSTR,UTSTR,
     2 FILTCD,STARCD,STRSKY,ASPARE(MAREST),GANCDN(MGAINS),DIMCDN(MGAINS)
C
C     COMMON /NAMES/NAMES,TITLE, AVAR
      COMMON /NAMES/NAMES,TITLE, RASTR,DESTR,STAR,BAYER,CONSTL,FLAMST,
     1 BSHR,HD,DM,SPECT,DESGN,DATSTR,MONTH,REM1,REM2,STSTR,ZTSTR,UTSTR,
     2 FILTCD,STARCD,STRSKY,ASPARE,GANCDN,DIMCDN
      EQUIVALENCE (CNAMES,NAMES(13))
C     13 BECAUSE CVARS IS VAR(13).
C
C   REAL VARIABLES THAT REPLACE VAR(MN):
C     COMMON /VALUES/ NAM1(MGRPS),NAM2(MGRPS),NGRPS,VAR(MN)
C
      INTEGER NAM1,NAM2,NGRPS,MURAT,MURAA,MUDEC
      REAL RAHRS,RAMIN,RASEC,
     1 DEDEG,DEMIN,DESEC,EPOCH,SIGNAL,TINT,
     2 CVARS,FMM,DD,YY,YEAR,DAY,
     3 UTHRS,UTMIN,UTSEC,CLKERR,STHRS,STMIN,STSEC,
     4 ZTHRS,ZTMIN,ZTSEC,VSPARE
      COMMON /VALUES/ NAM1(MGRPS),NAM2(MGRPS),NGRPS,RAHRS,RAMIN,RASEC,
     1 DEDEG,DEMIN,DESEC,EPOCH,MURAT,MURAA,MUDEC,SIGNAL,TINT,
     2 CVARS(2,MBANDS),FMM,DD,YY,YEAR,DAY,
     3 UTHRS,UTMIN,UTSEC,CLKERR,STHRS,STMIN,STSEC,
     4 ZTHRS,ZTMIN,ZTSEC,VSPARE(MNREST)
C
C
C   COMMONS FOR SPHERICAL TRIG.:
C
      REAL SINPHI,COSPHI,ELONG,ELROT,UTROT,STUTZ,TWOPI,ST2UT,
     1 TNOON1,TNOON2,PI,DEGRAD,ALAT
      COMMON /SPHERE/ SINPHI,COSPHI,ELONG,ELROT,UTROT,STUTZ,TWOPI,ST2UT,
     1 TNOON1,TNOON2,PI,DEGRAD,ALAT
C
C   COMMONS FOR SUN.
C
      REAL COSOB,SINOB,RASUN,DESUN,HASUN,SOLONG,ELMOON,BMOON
      COMMON /CSUN/ COSOB,SINOB,RASUN,DESUN,HASUN,SOLONG,ELMOON,BMOON
C
C   CAUTION -- THESE APPEAR IN SUBROUTINE FILL ALSO:
      INTEGER MSET,MROOM,MSG,MTIM
      PARAMETER (MSET=MSTARS-100,MROOM=2,MSG=14,MTIM=MROOM*MSET+MSG)
C
C  MSET IS MAX.LENGTH OF SUBSET CHOSEN FOR EXT./STD. STARS.
C  MTIM IS MAX.LENGTH OF EVENT TIMES.
C
      SAVE /CFILL/,/SPHERE/,/CSUN/,/HELPS/
C
      REAL UTBGN,UTEND,DARKT,TIMES
      INTEGER NOBJS,NT
      COMMON /CFILL/ UTBGN,UTEND,DARKT,TIMES(MTIM),NOBJS(MTIM),NT
C
C  TIMES(NT)  IS  EVENT TIME IN SCHEDULE.
C  NOBJS(NT)  IS  OBJECT NUMBER IN SUBSET OF EXT./STD.STARS.
C
C   COMMON FOR ANNOTATIONS:
      CHARACTER COMENT(MSTARS)*32,SPTYPE(MSTARS)*12,EMAG(MSTARS)*16
      COMMON /NOTES/COMENT,SPTYPE,EMAG
C
C   COMMON FOR HELP COUNT:
      COMMON /HELPS/ NEEDH,NASSMP
      CHARACTER ASSMPS(8)*40,ASSUME(8)*40
      COMMON /ASSUME/ ASSMPS,ASSUME
      CHARACTER*13  F361
      COMMON /FMT361/ F361
      CHARACTER*79 PAGE(21)
      COMMON /SCREEN/PAGE
      INTEGER JCONT,JLOG,JDISP
      COMMON /FLAGS/JCONT,JLOG,JDISP
C
      LOGICAL PC,DC,CI,CANNED,NEEDIM,CODEDS,MOVING,DARK,FUNK,FCORN,
     1        COOLED
C
        COMMON /LOGIC/ NEEDED,DIMMED,PC,DC,CI,NEEDIM,CODEDS,DARK,FUNK,
     1                 FCORN,COOLED
C
C
C  CODEDS IS.TRUE.IF STARS ARE CODED IN DATA.
C  PC     IS.TRUE.IF DATA ARE PULSE COUNTS.
C  DC     IS.TRUE.IF DATA ARE CURRENTS.
C  CI     IS.TRUE.IF DATA ARE CHARGE INTEGRATIONS.
C  CANNED IS.TRUE.IF PLACE OR STDFIL IS BUILT-IN.
C  NEEDIM IS.TRUE.IF OPTICAL DIMMER IS NEEDED.
C  MOVING IS.TRUE.IF EPHEMERIS OBJECTS EXIST.
C
C
C   L O C A L   V A R I A B L E S
C   -----------------------------
C
      CHARACTER A,CARD*80,DMS*32,PNAMES(10)*20,MON*3,TL*4,FL(2)*5,
     1 TWILIT(MSG+1)*27,INSTNAM*72,
     2 DAT*30,ELABEL(2)*8,WLABEL(2)*8,ASSUM4(2)*40,ASSUM6(2)*40
      EQUIVALENCE (ASSUM4,ASSUME(4)),(ASSUM6,ASSUME(6))
      CHARACTER TEMPRH*34, RALBL*22,DECLBL*7, FILTSTAT*9
CC 
      CHARACTER   CTEST*80
CC
C
C  MSET IS MAX.LENGTH OF SUBSET CHOSEN FOR EXT./STD. STARS.
C
C
      INTEGER LOCS(10)
      REAL SALTS(MSG),DJS(2),XS(MSET),YS(MSET),
     1 RALIMS(2),DECLIM(2)
C
      DOUBLE PRECISION DJD
C
      LOGICAL SYSSET,DEDSET,NEEDED,DIMMED, FEXIST,NULL
      LOGICAL BACK1
      REAL DUM, TELCM,
     1 HIGH, ELDEG, ALDEG, ELHRS, DEG10, PRAT, DRAT, SCALE, AREA,
     2 SIGSQ, DECDEG, RADEG, EPHEM1, EPHEM2, DEADT, SDEDT, RATE, ZONE,
     3 DDAY, YR, OLDYR, Y, DJ
C
      INTEGER NEEDH, NASSMP, NROWSAL, KEQUINOX, KMUALPHA, KMUDELTA,
     1 MTYPE, I, IOBS, ISTAT, NVALS, IUNIT, NULLS, L, KSPTYPE, KVB,
     2 NCOLS, NROWS, NSORTC, NWPRAL, KTEL, KDIAM, NROW, KLON,
     3 KLAT, KHI, J, JOLD, K, NEEDST, JSYS, NB, NSTAR, LASTD, ISTD,
     4 KOBJ, KRA, KDEC, KEPOCH, KMAG, KCOMMENT, KVI, KUV,
     5 KDATE, KMJD, LEN, NSTARS, I1, I2, INST,
     6 KDET, KBAND, KDETNM, KNDET, KCOOL, KRL, KRLTYP, KMODE, KDEDT,
     7 KDEDER, ITIME, NDIG, N, M
C
C
C   INTEGER FCNS.:
C   -------------
      INTEGER LWORD, MON2M
C
C   CHARACTER FCNS.:
C   ----------------
      CHARACTER DEG2MS*13
C
C   LOGICAL FCNS.:
C   -------------
      LOGICAL HELP,MATCH
C
C  END Declarations.
C
C
C  BEGIN DATA statements:
        INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C
C   D A T A :
C   ---------
C
C  NUMERICAL VARIABLE NAMES ... (REALLY IN BLOCK DATA)
C
C       NAMX() =    1       2       3       4       5       6       7
C     DATA NAMES/'RAHRS','RAMIN','RASEC','DEDEG','DEMIN','DESEC','EPOCH'
C
C         8       9      10      11      12
C    1,'MURAT','MURAA','MUDEC','SIGNAL','TINT',
C
C        13 TO MCAT....        +1   +2   +3    +4    +5
C    2  MBANDS*' ',MBANDS*' ','MM','DD','YY','YEAR','DAY',
C
C   MCAT + 6      +7      +8      +9      +10     +11    +12
C    3 'UTHRS','UTMIN','UTSEC','CLKERR','STHRS','STMIN','STSEC',
C
C   MCAT+13      +14     +15     +16  TO  MCAT +30
C    4 'ZTHRS','ZTMIN','ZTSEC',     MNREST*' ',
C
C  CHARACTER VARIABLE NAMES...
C
C       MN+1    MN+2    MN+3   MN+4     MN+5     MN+6    MN+7  MN+8 MN+9
C    5 'RASTR','DESTR','STAR','BAYER','CONSTL','FLAMST','BSHR','HD','DM'
C
C        MN+10   MN+11   MN+12    MN+13  MN+14  MN+15   MN+16   MN+17
C    6 ,'SPECT','DESGN','DATSTR','MONTH','REM1','REM2','STSTR','ZTSTR',
C
C        MN+18   MN+19    MN+20    MN+21   MN+22  TO
C    7  'UTSTR','FILTCD','STARCD','STRSKY',MGAINS*' ',MGAINS*' ',
C
C        MN+
C    8  MAREST*' '/
C
C
C  PLACE DATA:
C
      DATA PLACES/'MT.LAGUNA','KITT PEAK','LOWELL','LICK','MT.WILSON',
     1  'PALOMAR','CERRO TOLOLO','LAS CAMPANAS','ESO','MCDONALD'/
      DATA ELDEGS/-116.4258,-111.5947,-111.6633,-121.6455,-118.0597,
     1 -116.8640,-70.8059,-70.7020,-70.7296,-104.0223/
      DATA ALDEGS/32.8400 ,31.95842,35.20167,37.34036,34.21653,
     1 33.35622,-30.16894,-29.00361,-29.25717,30.67158/
      DATA HIGHS/1859.,2064.,2210.,1283.,1742.,
     1 1706.,2399.,2282.,2400.,2081./
      DATA PNAMES/'MT. LAGUNA','KPNO','FLAGSTAFF','MT. LOCKE',
     1 'CTIO','MT.LOCKE','MT. WILSON','MT.HAMILTON','MT. HAMILTON',
     2 'MOUNT HAMILTON'/
      DATA LOCS/1,2,3,10,7,10,5,4,4,4/
C
C  SYSTEM DATA:
C
      DATA SYSTMS/'UBV','UBVRI','UVBY','H-BETA','UVBYHB','GENEVA','DDO',
     1 'OTHER'/
      DATA JBANDS/ 3,      5,      4,      2,      6,      7,      6,
     1   0/
C
      DATA STDFLS/'UBVSTD','UBVSTD','UVBYST','UVBYST','UVBYST','GENSTD',
     1 'DDOSTD',' '/
C
      DATA LENBS/1,1,1,5,5,2,2,1/,LENCS/3,3,3,4,4,5,6,0/
C
C   BAND NAMES.
      DATA BNDS/'U','B','V','RL',MBM4*' ',
     2  'U','B','V','R','I','RL',MBM6*' ',
     3  'u','v','b','y',MBM4*' ',
     4  'betaW','betaN',MBM2*' ',
     5  'u','v','b','y','betaW','betaN',MBM6*' ',
     6  'U','B','V','B1','B2','V1','G',MBM7*' ',
     7  '48','45','42','41','38','35',MBM6*' '     ,MBANDS*' '/
C
C   MAGNITUDE AND COLOR NAMES FOR EXTERNAL LISTS.
      DATA BNDVAR/'V','U-B','B-V',MBM3*' ',
     2  'V','U-B','B-V','V-R','R-I',MBM5*' ',
     3  'V','b-y','m1','c1',MBM4*' ',
     4  'BETA',MBM1*' ',
     5  'V','b-y','m1','c1','BETA',MBM5*' ',
     6  'VM','U-B','B-V','U-B2','B1-B2','B2-V1','V1-G',MBM7*' ',
     7 'M48','C45-48','C42-45','C41-42','C38-41','C35-38',MBM6*' ',
     8 MBANDS*' '/
C
C   EFF.WAVELENGTHS.
C     UBV:Buser,A.&Ap.62,411(1979); others from Dudley Obs.rept.
      DATA STDWLS/3652.,4417.,5505.,7000.,MBM4*0.,
     2  3652.,4417.,5505.,6400.,8000.,7000.,MBM6*0.,
     3  3425.,4110.,4670.,5510.,MBM4*0.,
     4  4861.,4861.,MBM2*0.,
     5  3425.,4110.,4670.,5510.,4861.,4861.,MBM6*0.,
     6  3458.,4248.,5508.,4022.,4480.,5408.,5814.,MBM7*0.,
     7  4886.,4517.,4257.,4166.,3815.,3460.,MBM6*0.     ,MBANDS*0./
C
C   WIDTHS.  THESE ARE ABOUT 2.64 X MU2.
      DATA FWHMS/535.,980.,800.,300.,MBM4*0.,
     2  535.,980.,800.,1400.,1700.,600.,MBM6*0.,
     3  375.,200.,175.,250.,MBM4*0.,
     4  150.,30.,MBM2*0.,
     5  375.,200.,175.,250.,150.,30.,MBM6*0.,
     6  450.,800.,800.,450.,440.,530.,540.,MBM7*0.,
     7  186.,76.,73.,83.,330.,383.,MBM6*0.     ,MBANDS*0./
C   PEAK TRANSMISSIONS.
      DATA TRANSS/.86,.73,.9,.9,MBM4*0.,
     2  .86,.73,.9,.77,.86,.9,MBM6*0.,
     3  .39,.49,.48,.53,MBM4*0.,
     4  .75,.6,MBM2*0.,
     5  .39,.49,.48,.53,.75,.6,MBM6*0.,
     6  .65,.65,.5,.5,.34,.3,.3,MBM7*0.,
     7  .56,.55,.53,.49,.65,.41,MBM6*0.,     MBANDS*0./
C
C   2-COLOR DIAGRAMS.                 O
C                   U  U  B  4  G     T
C                U  .  V  E  +  E  D  H
C                B  .  B  T  H  N  D  E
C                V  I  Y  A  B  V  O  R
      DATA  KYS /2, 2, 4, 0, 4, 4, 2, 0/
      DATA  KXS /3, 3, 2, 0, 2, 6, 3, 0/
      DATA YINVS/1.,1.,0.,0.,0.,1.,0.,0./
      DATA XINVS/0.,0.,0.,0.,0.,0.,0.,0./
C
      DATA FL/'FIRST',' LAST'/
C
C  DATA FOR SUN/MOON SET/RISE AND TWILIGHTS:
C
      DATA SALTS/-.0145,-.1045,-.208,-.309,-.309,-.208,-.1045,-.0145,
C   SUN ABOVE, MOON BELOW.
     1 -.0145,-.0145,-.12,-.12,+.3,+.3/
C
      DATA TWILIT/'SUN SETS','END CIVIL TWILIGHT',
     1   'END NAUTICAL TWILIGHT'
     2,'END ASTRONOMICAL TWILIGHT','BEGIN ASTRONOMICAL TWILIGHT',
     3'BEGIN NAUTICAL TWILIGHT','BEGIN CIVIL TWILIGHT','SUN RISES',
C
     4'MOONRISE - FAST SKY CHANGES','MOONSET -- SKY CHANGES FAST',
     5'BEGIN LUNAR TWILIGHT','END LUNAR TWILIGHT',
     6'SKY CHANGES MORE SLOWLY','BEGIN RAPID SKY CHANGES',
     7'CHECK DARK LEVEL'/
C
      DATA ELABEL/' RISING','  EAST'/,WLABEL/' SETTING','  WEST'/
C
      DATA DECLBL/'   DEC.'/,
     1 TEMPRH/'TEMP.=        R.H. =        U.T. ='/,
     2 RALBL/'       <----  R.A.    '/
C
      DATA RALIMS/24.,0./,DECLIM/0.,0./
C
C  END DATA statements.
C
C  ********************  PROLOGUE  ********************
C
        CALL STSPRO ('PLAN')
C
C  Real program begins here:
C
C  PROLOGUE:
C
C ***
      F361='(I7.2,2X,A32)'
      DUM=KTV
      CALL PLOT(0,DUM,0.,'U')
      CALL PLOT(0,79.,23.,'P')
      NASSMP=0
      NEEDH=0
      MTYPE=0
      ST2UT=0.99726956633
      PI=3.14159265358979D0
      TWOPI=PI+PI
      DEGRAD=PI/180.
      SZMIN=1.1
      SZMAX=2.36
C
C       Reset error flags:
C
      CALL STECNT('GET',JCONT,JLOG,JDISP)
      CALL STECNT('PUT',1,2,2)
C
C  BEGIN DIALOG.
C
      CALL SPACE2
      CALL CENTER('Welcome to PEPSYS3''s PLANNER.')
      CALL SPACE2
      CALL ASK('Do you want Instructions?',A)
      IF(MATCH(A,'N')) GO TO 50
C
      NEEDH=2
      WRITE(PAGE,3)
    3 FORMAT(/
     1' PEPSYS needs information on the stars and instrument used.'/
     2' It will ask you to supply this by asking you questions.'///
     3' If you don''t understand a question, try typing "HELP" or "?"'/
     4' -- some on-line help is available.'//)
      DO 4 I=1,10
    4 CALL TVN(PAGE(I))
      WRITE(PAGE,12)
   12 FORMAT(/' You can abbreviate most answers  --  e.g.,'//
     1 5X,' you can answer yes/no questions with just "Y" or "N".'//
     2' If you want to abandon a run, reply "QUIT" to any request for'/
     3' non-numeric input.'//)
      DO 13 I=1,10
   13 CALL TVN(PAGE(I))
   20 CALL ASK('Do you need to set up a new STAR FILE?',A)
      IF(MATCH(A,'Y')) CALL FILHLP
C
       IF(HELP(A)) THEN
      CALL TV('Star files exist for UBV and uvby standards.')
      CALL TVN('You may need to set up new files for other systems, or f
C     convert next line to lower case:
     1OR PROGRAM STARS.')
      GO TO 20
       END IF
C
C  LOCATE OBSERVATORY.
C
   50 CONTINUE
      OBSFIL='esotel.tbl'
      INQUIRE (FILE=OBSFIL,EXIST=FEXIST)
   51 IF (FEXIST) THEN
        CALL TBTOPN (OBSFIL, 1,  IOBS, ISTAT)
        CALL STDRDC (IOBS, 'OBSERVATORY', 1, 1, 72,
     1                NVALS, PLACE, IUNIT, NULLS, ISTAT)
            IF(ISTAT.NE.0)THEN
                CALL TV('Could not find OBSERVATORY descriptor.')
                CALL TERROR(IOBS,51,'Please fix table file.')
            ELSE
            END IF
      ELSE
        CALL TV('The required observatory table file, "esotel.tbl",')
        CALL TVN('is not available.  Please make sure all required')
        CALL TVN('files are available in your current directory.')
        CALL STETER(52,'Missing observatory file "esotel.tbl"')
      END IF
      L=LWORD(PLACE)
      IF (L.GT.42) THEN
        CALL SPACE
        CALL TV('Will the observations be made at ')
        TITLE=PLACE(:L)//'?'
      ELSE
        TITLE='Will the observations be made at '//PLACE(:L)//'?'
      END IF
      CALL ASK(TITLE,CARD)
      IF(MATCH(CARD,'NO')) THEN
        CALL TBTCLO(IOBS, ISTAT)
        IF(ISTAT.NE.0) CALL TERROR(IOBS,55,'Could not close obs. file.')
        CALL TV(' ')
   55   CALL TV('Do you have a table file for the OBSERVATORY')
        CALL ASKFIL('      where the observations will be made?',OBSFIL)
        IF (MATCH(OBSFIL,'yes') .OR. MATCH(OBSFIL,'YES'))THEN
   56      CALL ASKFIL('Please enter the observatory FILE name:',OBSFIL)
           IF(INDEX(OBSFIL,'.tbl').EQ.0) THEN
               I=LWORD(OBSFIL)
               OBSFIL(I+1:)='.tbl'
           END IF
           INQUIRE (FILE=OBSFIL,EXIST=FEXIST)
           IF(FEXIST) GO TO 51
           CALL TV('File not found.  (Enter Q to quit, if necessary.)')
           GO TO 56
        ELSE IF (MATCH(OBSFIL,'no') .OR. MATCH(OBSFIL,'NO'))THEN
           GO TO 103
        ELSE
           IF(INDEX(OBSFIL,'.tbl').EQ.0) THEN
               I=LWORD(OBSFIL)
               OBSFIL(I+1:)='.tbl'
           END IF
           INQUIRE (FILE=OBSFIL,EXIST=FEXIST)
           IF(FEXIST) GO TO 51
           CALL TV('File not found.')
           GO TO 55
        END IF
        GO TO 103
      END IF
      IF(.NOT.MATCH(CARD,'YES'))GO TO 104
      IF(PLACE(:6).EQ.'MOUNT ' .OR. PLACE(:6).EQ.'Mount')THEN
          CARD='Mt.'//PLACE(7:)
          PLACE=CARD
      END IF
C   Right OBSERVATORY.  Read info from OBSFIL:
      CALL TBIGET (IOBS,  NCOLS, NROWS, NSORTC, NWPRAL, NROWSAL, ISTAT)
      CALL TBLSER (IOBS, 'TELESCOP',  KTEL, ISTAT)
      IF(KTEL.EQ.-1) CALL TERROR(IOBS,53,'Could not find TELESCOP col')
      CALL TBLSER (IOBS, 'DIAM',  KDIAM, ISTAT)
      IF(KDIAM.EQ.-1) CALL TERROR(IOBS,54,'Could not find DIAM col')
      CALL TV(' ')
      CALL TV('Please choose the telescope to be used:')
      DO 60 NROW=1,NROWS
      CALL TBERDC (IOBS, NROW, KTEL, CTEST, NULL, ISTAT)
      CALL FT_EOS (CTEST,80,CARD,ISTAT)
      CALL TBERDR (IOBS, NROW, KDIAM,  TELCM, NULL, ISTAT)
      WRITE(TITLE,'(6X,I2,'':  '',A8,F6.2,'' m'')')nrow,card(:8),telcm
      CALL TV(TITLE)
   60 CONTINUE
      WRITE(TITLE,'(6X,I2,'':  None of these'')') NROWS+1
      CALL TV(TITLE)
   61 CALL QF('Enter the NUMBER (not the aperture) of your choice:',
     1         HIGH)
      NROW=HIGH
      IF (NROW.LT.1 .OR. HIGH-FLOAT(NROW).NE.0.) GO TO 61
      IF (NROW.GT.NROWS) GO TO 103
      CALL TBLSER (IOBS, 'LON',  KLON, ISTAT)
      IF(KLON.EQ.-1) CALL TERROR(IOBS,61,'Could not find LON col')
      CALL TBERDR (IOBS, NROW, KLON,  ELDEG, NULL, ISTAT)
      CALL TBLSER (IOBS, 'LAT',  KLAT, ISTAT)
      IF(KLAT.EQ.-1) CALL TERROR(IOBS,64,'Could not find LAT col')
      CALL TBERDR (IOBS, NROW, KLAT,  ALDEG, NULL, ISTAT)
      CALL TBLSER (IOBS, 'HEIGHT',  KHI, ISTAT)
      IF(KHI.EQ.-1) CALL TERROR(IOBS,66,'Could not find HEIGHT col.')
      CALL TBERDR (IOBS, NROW, KHI,  HIGH, NULL, ISTAT)
      CALL TBERDR (IOBS, NROW, KDIAM,  TELCM, NULL, ISTAT)
      TELCM=TELCM*100.
      CALL TBTCLO(IOBS, ISTAT)
      CANNED=.TRUE.
      GO TO 120
C
C   NOT HOME. TRY AGAIN.
  103 CALL ASKFIL('Observatory name?',PLACE)
  104 J=INDEX(PLACE,'OBS')
      IF(J.GT.1) PLACE(J:)=' '
      IF(PLACE(:6).EQ.'MOUNT ' .OR. PLACE(:6).EQ.'Mount')THEN
          CARD='Mt.'//PLACE(7:)
          PLACE=CARD
      END IF
      DO 106 J=1,MOBS
      IF(PLACE.EQ.PLACES(J)) GO TO 109
  106 CONTINUE
      DO 107 J=1,10
      IF(PLACE.EQ.PNAMES(J)) GO TO 108
  107 CONTINUE
      GO TO 110
C
  108 J=LOCS(J)
  109 PLACE=PLACES(J)
      ELDEG=ELDEGS(J)
      ALDEG=ALDEGS(J)
      HIGH=HIGHS(J)
      TELCM=0.
      CANNED=.TRUE.
      GO TO 120
C
C
C   NOT IN LIST, SO ASK FOR COORDS.
  110 CALL TV('Enter (East) LONGITUDE in time or degrees:')
      CALL TV('    h  m  s         o  ''  "')
      CALL ASK(' ',DMS)
      CANNED=.FALSE.
      IF(DMS(:10).EQ.' ') GO TO 113
C   LONGITUDE IN HOURS.
      ELHRS=DEG10(DMS(:13))
      IF(ELHRS.EQ.3.E33)GO TO 110
      IF(INDEX(DMS,'W').NE.0) ELHRS=-ELHRS
      GO TO 116
C   LONGITUDE IN DEGREES. CONVERT TO DECIMAL, HOURS.
  113 ELDEG=DEG10(DMS(16:32))
      IF(ELDEG.EQ.3.E33)GO TO 110
      IF(INDEX(DMS,'W').NE.0) ELDEG=-ELDEG
      ELHRS=ELDEG/15.
C    CONVERT HOURS TO DEGREES.
  116 ELDEG=ELHRS*15.
  117 CALL TV('Enter LATITUDE:')
      CALL TV('    o  ''  "')
      CALL ASK(' ',DMS)
      ALDEG=DEG10(DMS(:20))
      IF(ALDEG.EQ.3.E33)GOTO 117
      IF(INDEX(DMS,'S').NE.0) ALDEG=-ALDEG
      CALL QF('Enter height (meters) above sea level:',HIGH)
C
C    CONVERT FROM DEGREES TO RADIANS.
  120 ELHRS=ELDEG/15.
      ELROT=ELHRS/24.
      ELONG=ELDEG*DEGRAD
      WRITE(CARD,*) 'Longitude = ',ELDEG,' deg. = ',ELONG,' radians'
      CALL TV(CARD)
      TNOON1=-ELROT-.5
      TNOON2=-ELROT+.5
      ALAT=ALDEG*DEGRAD
      WRITE(CARD,*) 'Latitude  = ',ALDEG,' deg. = ', ALAT,' radians'
      CALL TVN(CARD)
      COSPHI=COS(ALAT)
      SINPHI=SIN(ALAT)
      PRAT=EXP(-HIGH/8.E3)
      DRAT=PRAT*PRAT
C   DIP OF HORIZON (P.401 OF EXPL.SUPP.)
      DO 121 I=1,12
  121 SALTS(I)=SALTS(I)-6.16E-4*SQRT(HIGH)
      IF(CANNED)GO TO 125
C
        CARD(1:13)=DEG2MS(ELHRS)
        CARD(21:33)=DEG2MS(ALDEG)
      WRITE(PAGE,122)PLACE,CARD(1:13),CARD(21:33),HIGH
  122 FORMAT(/4X,A//'    LONGITUDE      LATITUDE'/'     h  m  s        O
     1  ''  "'/2X,A13,2X,A13//' HEIGHT =',F6.0,' METERS')
      DO 123 I=1,8
  123 CALL TVN(PAGE(I))
      CALL ASK('OK?',A)
      IF(MATCH(A,'N')) GOTO 104
C
C  TELESCOPE.
C
  125 CONTINUE
      SYSSET=.FALSE.
      DIMMED=.FALSE.
      NEEDED=.FALSE.
      DEDSET=.FALSE.
      IF(TELCM.GT.0.) GO TO 128
      CALL ASK('Telescope aperture?',CARD)
      SCALE=1.
      JOLD=0
  126 J=INDEX(CARD,'CM')
      IF(J.EQ.0)J=INDEX(CARD,'CENTIMET')
C
       IF(J.EQ.0)THEN
      J=INDEX(CARD,'MET')
      IF(J.EQ.0)J=INDEX(CARD,'M.')
      IF(J.EQ.0)J=INDEX(CARD,'M ')
      IF(J.NE.0)SCALE=100.
       END IF
C
       IF(J.EQ.0)THEN
      J=INDEX(CARD,'IN')
      IF(J.NE.0)SCALE=2.54
       END IF
C
        IF(HELP(CARD))THEN
        CALL TV('Give number and units.')
        GOTO 125
        END IF
C
       IF(J.EQ.0)THEN
  127 CALL ASK('UNITS?',DMS)
      NEEDH=NEEDH+1
        IF(HELP(DMS))THEN
       CALL TV('cm, meters, or inches, please.')
       GO TO 127
        END IF
      J=INDEX(CARD,'      ')
      IF(JOLD.EQ.0)JOLD=J
      CARD(JOLD:)=DMS
      GO TO 126
       END IF
C
      K=INDEX(CARD,'-')
      IF(K.NE.0)J=MIN(J,K)
      CARD(J:)=' '
      READ(CARD,'(BN,F12.0)',ERR=125)TELCM
      IF(TELCM.LE.0.)GO TO 125
      TELCM=TELCM*SCALE
      WRITE(PAGE,'(/F9.1,'' cm.'')')TELCM
      CALL TV(PAGE(2))
  128 AREA=PI*TELCM*TELCM/4.
C
C  PRECISION.
C
      CALL TV(' ')
      CALL QF('What RMS precision (mags.) do you want?',SIGTOT)
        IF(SIGTOT.LT.0.003)THEN
          CALL TV(
     1    'Errors below 0.003 cannot be reached with existing systems.')
          CALL QF('Please re-enter RMS error goal.',SIGTOT)
        END IF
      IF(SIGTOT.LE.0.) GO TO 128
        IF(SIGTOT.LT.0.01)THEN
        NASSMP=NASSMP+1
        ASSMPS(NASSMP)='Transformation error may limit precision'
        CALL TV(ASSMPS(NASSMP))
        END IF
      SIGSQ=SIGTOT*SIGTOT
C   Assume transformation error = .015/star.
      NEEDST=9.E-4/SIGSQ + 4.
C   LET SCINT.NOISE AMPL.= HALF OF SIGTOT AT SECZ=SZMAX=2.36.
      TINT1=8.1E-3*DRAT/(SIGSQ*TELCM**(4./3.))
C    (8.1E-3 = .09**2)
C  SCINT.NOISE = SIGTOT/2 IN TINT1 SEC.AT ZENITH.  (SEE 173; 213.5)
      TINT=TINT1*(SZMAX**4)
      TSUGG=INT(TINT/5.)*5.+5.
      WRITE(PAGE,129)TINT,TSUGG
  129 FORMAT(/' Use',F4.0,' sec minimum integrations for bright stars.'/
     1/4X,'Suggested integration =',F4.0,' sec')
      CALL TV(PAGE(2))
      CALL TV(PAGE(4))
      CALL ASK('OK?',A)
C
      IF(MATCH(A,'Y')) THEN
C         we are OK.
      ELSE IF(MATCH(A,'N')) THEN
          CALL QF('How many sec.do you want?',TSUGG)
          IF(TSUGG.LT.TINT/SQRT(SZMAX))THEN
C             revise specs.
              TELCM=TELCM*(TINT/TSUGG)**0.75
              SIGTOT=SIGTOT*SQRT(TINT/TSUGG)
C             convert next line to lower case:
              WRITE(PAGE,'(/'' Raise error to'',F6.3,
     +        '' mag''/'' OR USE AT LEAST'',F6.1,'' CM TELESCOPE.'')')
     +        SIGTOT,TELCM
              CALL TV(PAGE(2))
              CALL TVN(PAGE(3))
              GO TO 51
          END IF
      ELSE
          CALL TV('Please answer "Yes" or "No".')
          GOTO 128
      END IF
C
C  SYSTEM.
C
  130 IF(SYSSET)GOTO 160
      CALL TV(' ')
      CALL ASK('Name of Standard System?',SYSTEM)
      CANNED=.FALSE.
      DO 131 JSYS=1,MSYS
      IF(SYSTEM.EQ.SYSTMS(JSYS)) GO TO 132
  131 CONTINUE
      JSYS=0
      NEEDST=0
      IF(MATCH(SYSTEM,'NONE')) THEN
         CALL ASKFIL('What file has extinction-star positions?',STDFIL)
         GO TO 142
      END IF
      NEEDH=NEEDH+1
      CALL TV('Choose "NONE" or one of:')
      WRITE(PAGE,'(10(1X,A6))') SYSTMS
      CALL TVN(PAGE(1))
      GO TO 130
C
  132 STDFIL=STDFLS(JSYS)
      NBANDS=JBANDS(JSYS)
C     to 140 for "other".
      IF(JSYS.EQ.MSYS)GO TO 140
      IF (INDEX(SYSTEM,'RI').GT.0) THEN
          CALL TV('*******************  CAUTION  *******************')
          CALL TV('The R and I bands of the Johnson UBVRI system are')
          CALL TVN('NOT the same as those of the Kron-Cousins system.')
          CALL TV('    BE SURE you know which system you are using!')
          CALL TV('    NEVER mix standard stars from the two systems!!')
      END IF
      DO 133 NB=1,NBANDS
      WLS(NB)=STDWLS(NB,JSYS)
      WIDTHS(NB)=FWHMS(NB,JSYS)
      TRANS(NB)=TRANSS(NB,JSYS)
C    SET 2-COLOR DIAGRAM.
      KX=KXS(JSYS)
      KY=KYS(JSYS)
      XINV=XINVS(JSYS)
      YINV=YINVS(JSYS)
      LENB=LENBS(JSYS)
      LENC=LENCS(JSYS)
      CNAMES(1,NB)=BNDVAR(NB,JSYS)
      CNAMES(2,NB)='S'//BNDVAR(NB,JSYS)
  133 BANDS(NB)=BNDS(NB,JSYS)
      CANNED=.TRUE.
      GO TO 150
C
C  OTHER.
C
  140 CALL ASK('Name of System?',SYSTEM)
      CALL ASKFIL('Name of STD.star file?',STDFIL)
  142 CALLQF('Number of bands =',DUM)
      NBANDS=DUM
      LENB=0
      LENC=0
       IF(NBANDS.LE.0)THEN
      WRITE(PAGE,'(I5,'' is not legal'')')NBANDS
      CALL TVN(PAGE(1))
      GO TO 142
       END IF
      IF(NBANDS.LE.MBANDS) GO TO 145
      CALL EXCEED(NBANDS,'MBANDS',MBANDS)
      CALL STETER(144, 'MBANDS EXCEEDED')
C
  145 DO 148 K=1,NBANDS
      WRITE(DMS,'(''Name of band ('',I1,'')?'')')K
  146 CALL ASK(DMS,BANDS(K))
      LENB=MAX(LENB,LWORD(BANDS(K)))
      IF(LENB.EQ.0)GOTO146
      CALL QF('Center Wavelength (A)?',WLS(K))
      CALL QF('Full width (A) at half peak response?',WIDTHS(K))
      CALL QF('Peak transmission?',TRANS(K))
  147 CALL ASKFIL('Name of associated magnitude or color?',CNAMES(1,K))
C    SET FOR FILES WITH S.D.'S OF STD.VALUES:
      CNAMES(2,K)='S'//CNAMES(1,K)
      LENC=MAX(LENC,LWORD(CNAMES(1,K)))
      IF(LENC.EQ.0)GOTO147
  148 CONTINUE
      LENB=MIN(LENB,6)
      LENC=MIN(LENC,6)
C
C   2-COLOR DIAGRAM.
      IF(MATCH(SYSTEM,'NONE') .OR. NBANDS.LT.3)GOTO150
      CALL TV('Set up 2-color diagram:')
      CALL ASK('Color on HORIZONTAL axis:',BAND)
      CALL ASK('Color on VERTICAL axis:',UTSTR)
      DO 149 K=1,NBANDS
      IF(CNAMES(1,K).EQ.BAND)KX=K
      IF(CNAMES(1,K).EQ.UTSTR)KY=K
  149 CONTINUE
      XINV=0.
      YINV=0.
      PAGE(1)='Does '//CNAMES(1,KX)(:LENC)//' increase to right?'
      CALL ASK(PAGE(1),A)
      IF(MATCH(A,'N'))XINV=1.
      PAGE(1)='Does '//CNAMES(1,KY)(:LENC)//' increase upward?'
      CALL ASK(PAGE(1),A)
      IF(MATCH(A,'N'))YINV=1.
C
C  DECODE COLORS.
C
  150 CALL DECOLR(COLORS,CNAMES,BANDS,SYSTEM,CANNED)
C
C  ESTIMATE PHOTON NOISE.
C
  160 DO 168 NB=1,NBANDS
C   Allow for extinction.
      DUM=5.E3/WLS(NB)
      EXTIN(NB)=0.15*PRAT*DUM**4 + DRAT*0.1*DUM
C     .05 IS DQE.
      PHOMAG(NB) = 15.5 + 2.5*LOG10(SIGSQ*AREA*.05*TINT1*WIDTHS(NB)*
     1 TRANS(NB)/WLS(NB))
C   PHOTON NOISE = SIGSQ/4. at PHOMAG for TINT1 sec. outside atmosphere.
      FAINTS(NB)=3.E33
  168 BRITES(NB)=-3.E33
      CALL MAGSET(BANDS)
      IF(SYSSET)GO TO 200
C
C  READ STDFIL.
C
      SYSSET=.TRUE.
      SAVFIL=STDFIL
  170 NSTAR=1
      LASTD=0
      NAM1(1)=1
      NAM2(1)=12+2*NBANDS
      NAM1(2)=MN+1
      NAM2(2)=MN+11
      NGRPS=2
C    NGRPS CANNOT EXCEED PARAMETER (MGRPS=8).
      MOVING=.FALSE.
C       special for uvby only:
      IF (SYSTEM(:4).EQ.'UVBY') SYSTEM(:4)='uvby'
C
C       OPEN Standard-star file:
C
  175 INQUIRE (FILE=STDFIL,EXIST=FEXIST)
      IF (FEXIST) THEN
          CALL TBTOPN(STDFIL,1,  ISTD,ISTAT)
          IF(ISTAT.NE.0)CALLTERROR(IOBS,175,'Could not open star file.')
          CARD='  ... reading '//STDFIL
          CALL TV(CARD)
          IF(LASTD.EQ.0)THEN
C             display SYSTEM descriptor of std.-star file:
              CALL STDRDC (ISTD, 'SYSTEM', 1, 1, 32,
     1                   NVALS, CARD, IUNIT, NULLS, ISTAT)
              CALL TVN(CARD)
              IF (INDEX(CARD,SYSTEM(:LWORD(SYSTEM))).EQ.0 .AND.
     1          .NOT.(SYSTEM.EQ.'H-BETA'.AND.INDEX(CARD,'HB').NE.0))THEN
                  CALL TV(
     1                'CAREFUL: this does not appear to be the right')
                  CALL TVN('photometric system.  Please check:')
                  CALL TV('Is this REALLY a standard-star file for')
                  CARD=SYSTEM(:LWORD(SYSTEM))//' ?'
                  CALL ASKN(CARD,A)
                  IF (A.EQ.'Y')THEN
                  ELSE
                      CALL ASKFIL('Enter the correct file name:',STDFIL)
                      IF (MATCH(STDFIL,'no').OR.MATCH(STDFIL,'NO'))THEN
                          GO TO 188
                      ELSE
                          GO TO 175
                      END IF
                  END IF
              END IF
          END IF
      ELSE
        IF(INDEX(STDFIL,'.tbl').EQ.0) THEN
            CARD=STDFIL(:LWORD(STDFIL))//'.tbl'
            STDFIL=CARD
            GO TO 175
        END IF
        CARD='The requested star table file '//STDFIL
        CALL TV(CARD)
        CALL TVN('is not available.  Please make sure all required')
        CALL TVN('files are available in your current directory.')
        CARD='Is '//STDFIL(:LWORD(STDFIL))//' the correct file name?'
        CALL ASKFIL(CARD,STDFIL)
        IF (MATCH(STDFIL,'YES') .OR. MATCH(STDFIL,'yes'))THEN
            CALL STETER(175,'Missing standard-star file')
        ELSEIF (MATCH(STDFIL,'NO') .OR. MATCH(STDFIL,'no'))THEN
            CALL ASKFIL('Please enter the correct file name:',STDFIL)
            GO TO 175
        ELSE
            GO TO 175
        END IF
      END IF
C
C       Get columns:
C
      CALL TBIGET(ISTD,  NCOLS,NROWS,NSORTC,NWPRAL,NROWSAL,ISTAT)
      IF(ISTAT.NE.0) CALL TERROR(IOBS,175,'Could not get file info.')
      CALL TBLSER(ISTD,'OBJECT', KOBJ,ISTAT)
      IF(ISTAT.NE.0) CALL TERROR(IOBS,176,'ERROR finding OBJECT col.')
      IF(KOBJ.EQ.-1) CALL TERROR(IOBS,176,'Could not find OBJECT col.')
      CALL TBLSER(ISTD,'RA', KRA,ISTAT)
      IF(ISTAT.NE.0) CALL TERROR(IOBS,177,'ERROR finding RA col.')
      IF(KRA.EQ.-1) CALL TERROR(IOBS,177,'Could not find RA col.')
      CALL TBLSER(ISTD,'DEC', KDEC,ISTAT)
      IF(ISTAT.NE.0) CALL TERROR(IOBS,178,'ERROR finding DEC col.')
      IF(KDEC.EQ.-1) CALL TERROR(IOBS,178,'Could not find DEC col.')
      CALL TBLSER(ISTD,'EQUINOX', KEQUINOX,ISTAT)
      IF(ISTAT.NE.0) CALL TERROR(IOBS,179,'ERROR finding EQUINOX col.')
      IF(KEQUINOX.EQ.-1) THEN
          IF (LASTD.EQ.0) THEN
              CALL TERROR(IOBS,179,'Could not find EQUINOX col.')
          ELSE
C             assume moving object, referred to equinox of date.
              CALL TV('No EQUINOX column in this file.')
              CALL TVN(
     1           'Assume this is an ephemeris file for moving objects.')
              MOVING=.TRUE.
          END IF
      END IF
      CALL TBLSER(ISTD,'MUALPHA', KMUALPHA,ISTAT)
      IF(ISTAT.NE.0) CALL TERROR(IOBS,179,'ERROR finding MUALPHA col.')
      CALL TBLSER(ISTD,'MUDELTA', KMUDELTA,ISTAT)
      IF(ISTAT.NE.0) CALL TERROR(IOBS,179,'ERROR finding MUDELTA col.')
      CALL TBLSER(ISTD,'EPOCH', KEPOCH,ISTAT)
      IF(ISTAT.NE.0) CALL TERROR(IOBS,179,'ERROR finding EPOCH col.')
      CALL TBLSER(ISTD,'SPTYPE', KSPTYPE,ISTAT)
      IF(ISTAT.NE.0) CALL TERROR(IOBS,179,'ERROR finding SPTYPE col.')
      CALL TBLSER(ISTD,'MAG', KMAG,ISTAT)
      IF(ISTAT.NE.0) CALL TERROR(IOBS,179,'ERROR finding MAG col.')
      CALL TBLSER(ISTD,'COMMENT', KCOMMENT,ISTAT)
      IF(ISTAT.NE.0) CALL TERROR(IOBS,179,'ERROR finding COMMENT col.')
      DO 180 K=1,NBANDS
          DMS=CNAMES(1,K)
C         special fudge for dumb MIDAS table system:
          IF (INDEX(DMS,'-').NE.0)DMS(INDEX(DMS,'-'):INDEX(DMS,'-'))='_'
C         DMS holds MIDAS-readable name; CNAMES has human-readable name.
          IF (CNAMES(1,K).EQ.' ') THEN
             KOLR(K)=-1
          ELSE
             CALL TBLSER(ISTD,DMS, KOLR(K),ISTAT)
             IF(ISTAT.NE.0) THEN
                   CARD='ERROR finding column for '//CNAMES(1,K)
                   CALL TERROR(ISTD,180,CARD)
             END IF
          END IF
          IF(KOLR(K).EQ.-1) THEN
C             look for special cases:
              IF (INDEX(SYSTEM,'VRI').GT.0) THEN
C                 special for V-I:
                  IF (CNAMES(1,K).EQ.'R-I')THEN
                      CALL TBLSER(ISTD,'V_I', KVI,ISTAT)
                      IF(ISTAT.NE.0)CALL TERROR(ISTD,180,
     1                             'ERROR finding column V-I')
                      IF(KVI.EQ.-1)THEN
C                         could not find V-I either.
                          CALL TV('Could not find column R-I or V-I')
                      ELSE
C                         found V-I.
                          GO TO 180
                      END IF
                  END IF
              ELSE IF (INDEX(SYSTEM,'uvby').GT.0) THEN
C                 special for u-v and v-b:
                  IF (CNAMES(1,K).EQ.'m1')THEN
                      CALL TBLSER(ISTD,'v_b', KVB,ISTAT)
                      IF(ISTAT.NE.0)CALL TERROR(ISTD,180,
     1                             'ERROR finding column v-b')
                      IF(KVB.EQ.-1)THEN
C                         could not find v-b either.
                          CALL TV('Could not find column m1 or v-b')
                      ELSE
C                         found v-b.
                           GO TO 180
                      END IF
                  ELSE IF (CNAMES(1,K).EQ.'c1')THEN
                      CALL TBLSER(ISTD,'u_v', KUV,ISTAT)
                      IF(ISTAT.NE.0)CALL TERROR(ISTD,180,
     1                             'ERROR finding column u-v')
                      IF(KUV.EQ.-1)THEN
C                         could not find u-v either.
                          CALL TV('Could not find column c1 or u-v')
                      ELSE
C                         found u-v.
                          GO TO 180
                      END IF
                  ELSE IF (CNAMES(1,K).EQ.'V')THEN
C                 special for Vmag:
                      CALL TBLSER(ISTD,'Vmag', KOLR(K),ISTAT)
                      IF(ISTAT.NE.0)CALL TERROR(ISTD,180,
     1                             'ERROR finding column Vmag')
                      IF(KOLR(K).EQ.-1)THEN
C                         could not find Vmag either.
                          CALL TV('Could not find column V or Vmag')
                      ELSE
C                         found Vmag.
                          CALL TVN('      file has Vmag, not V')
                          GO TO 180
                      END IF
                  END IF
                  IF(INDEX(SYSTEM,'HB').GT.0)THEN
C                     special for H-beta:
                      IF (CNAMES(1,K).EQ.' ') THEN
                          GO TO 180
                      END IF
                  END IF
              ELSE IF(SYSTEM.EQ.'H-BETA')THEN
C                 special for H-beta:
                  IF (CNAMES(1,K).EQ.' ') THEN
                      GO TO 180
                  END IF
              END IF
              IF(LASTD.EQ.0) THEN
C               we are in standard stars; serious error.
                CARD='Could not find column for '//CNAMES(1,K)
                CALL TERROR(IOBS,180,CARD)
              ELSE
C               we are in program stars; forget it.
              END IF
          END IF
  180 CONTINUE
C
      IF (LASTD.GT.0) THEN
C         Look for ephemeris data:
          CALL TBLSER(ISTD,'DATE', KDATE,ISTAT)
          IF(ISTAT.NE.0) CALL TERROR(IOBS,180,'ERROR finding DATE col.')
          IF(KDATE.EQ.-1) THEN
              CALL TBLSER(ISTD,'MJD_OBS', KMJD,ISTAT)
              IF(ISTAT.NE.0) CALL TERROR(IOBS,180,
     1                          'ERROR finding DATE col.')
              IF(KMJD.EQ.-1) THEN
              ELSE
                  CALL TV('MJD_OBS column found; ephemeris file.')
                  MOVING=.TRUE.
              END IF
          ELSE
              WRITE(CARD,*)'DATE found in col.',KDATE
              CALL TV(CARD)
              MOVING=.TRUE.
          END IF
      ELSE
      END IF
C
C       READ Standard-star file:
C
      DO 181 NROW=1,NROWS
C
      BACK1=.FALSE.
C   Here to examine data read from STDFIL.
      CALL TBERDR (ISTD, NROW, KDEC,  DECDEG, NULL, ISTAT)
      IF(ISTAT.NE.0) CALL TERROR(IOBS,181,'Could not read DEC col.')
C   Skip any stars that never rise.
      IF(ABS(ALDEG-DECDEG).GT.90.)GO TO 181
C    OK, add to list.
      NSTAR=NSTAR+1
       IF(NSTAR.GT.MSTARS) THEN
          CALL EXCEED(NSTAR,'MSTARS',MSTARS)
          CALL ASK('Do you wish to continue?',A)
          NSTAR=MSTARS
          IF(LASTD.EQ.0)LASTD=MSTARS
          IF(MATCH(A,'Y')) GO TO 190
          CALL TERROR(ISTD,184, 'CATALOG OVERLFOW')
       END IF
C     Get R.A.
      CALL TBERDR (ISTD, NROW, KRA,  RADEG, NULL, ISTAT)
      IF(ISTAT.NE.0) CALL TERROR(IOBS,182,'Could not read RA col.')
      IF(NULL) BACK1=.TRUE.
C     note that MIDAS stores it as *degrees*!
      RAS(NSTAR)=RADEG*DEGRAD
      DECS(NSTAR)=DECDEG*DEGRAD
C
C     Look for equinox, to precess:
        IF (KEQUINOX.GT.0) THEN
      CALL TBERDR (ISTD, NROW, KEQUINOX,  EQUINX(NSTAR), NULL, ISTAT)
      IF(ISTAT.NE.0) CALL TERROR(IOBS,183,'Could not read EQUINOX col.')
        ELSE
      EQUINX(NSTAR)=0.
        END IF
      IF(NULL) BACK1=.TRUE.
C
C   GET STAR NAME.
C
      CALL TBERDC (ISTD, NROW, KOBJ,CTEST, NULL, ISTAT)
      CALL FT_EOS (CTEST,32,STARS(NSTAR),ISTAT)
      IF(NULL) BACK1=.TRUE.
C
      IF(LASTD.EQ.0) THEN
C    TRANSFER MAG. & COLORS.
       DO 185 K=1,NBANDS
          IF(KOLR(K).EQ.-1) THEN
C             look for special cases:
              IF (INDEX(SYSTEM,'VRI').GT.0) THEN
C                 special for V-I:
                  IF (CNAMES(1,K).EQ.'R-I' .AND. KVI.GT.0)THEN
                      CALL TBERDR (ISTD, NROW, KVI,
     1                            COLORS(K,NSTAR), NULL, ISTAT)
                      IF(ISTAT.NE.0)CALL TERROR(ISTD,185,
     1                             'Could not read column V-I')
                      IF (NULL) COLORS(K,NSTAR)=3.E33
C                     convert to expected index:
C                     R-I = (V-I) - (V-R)
                      COLORS(K,NSTAR)=COLORS(K,NSTAR)-COLORS(K-1,NSTAR)
                      GO TO 185
                  END IF
              ELSE IF (INDEX(SYSTEM,'uvby').GT.0) THEN
C                 special for u-v and v-b:
                  IF (CNAMES(1,K).EQ.'m1' .AND. KVB.GT.0)THEN
                      CALL TBERDR (ISTD, NROW, KVB,
     1                            COLORS(K,NSTAR), NULL, ISTAT)
                      IF(ISTAT.NE.0)CALL TERROR(ISTD,185,
     1                             'Could not read column v-b')
                      IF (NULL) COLORS(K,NSTAR)=3.E33
                      GO TO 185
C                     postpone action until u-v is read:
                  ELSE IF (CNAMES(1,K).EQ.'c1' .AND. KUV.GT.0)THEN
                      CALL TBERDR (ISTD, NROW, KUV,
     1                            COLORS(K,NSTAR), NULL, ISTAT)
                      IF(ISTAT.NE.0)CALL TERROR(ISTD,185,
     1                             'Could not read column u-v')
                      IF (NULL) COLORS(K,NSTAR)=3.E33
C                     now convert to expected indices:
C                     c1 = (u-v) - (v-b)
                      COLORS(4,NSTAR)=COLORS(4,NSTAR) - COLORS(3,NSTAR)
C                     m1 = (v-b) - (b-y)
                      COLORS(3,NSTAR)=COLORS(3,NSTAR) - COLORS(2,NSTAR)
                      GO TO 185
                  END IF
                  IF(INDEX(SYSTEM,'HB').GT.0)THEN
C                     special for H-beta:
                      IF (CNAMES(1,K).EQ.' ') THEN
                          GO TO 185
                      END IF
                  END IF
              ELSE IF(SYSTEM.EQ.'H-BETA')THEN
C                 special for H-beta:
                  IF (CNAMES(1,K).EQ.' ') THEN
                      GO TO 185
                  END IF
              END IF
                CARD='Missing column: '//CNAMES(1,K)
                CALL TV(CARD)
          ELSE
C             normal case:
              CALL TBERDR (ISTD, NROW, KOLR(K),
     1                            COLORS(K,NSTAR), NULL, ISTAT)
              IF(ISTAT.NE.0) THEN
                  CARD='Could not read '//CNAMES(1,K)//' column'
                  CALL TERROR(IOBS,185,CARD)
              END IF
              IF (NULL) COLORS(K,NSTAR)=3.E33
          END IF
  185  CONTINUE
      ELSE
C         fill in dummy values for pgm.objects.
          COLORS(1,NSTAR)=3.E33
          COLORS(2,NSTAR)=3.E33
          COLORS(3,NSTAR)=3.E33
          COLORS(4,NSTAR)=3.E33
      END IF
C
C   DO EPHEMERIS FILES.
C
           IF(KDATE.GT.0 .OR. KMJD.GT.0)THEN
C          This is an ephemeris file.
C
        IF (KDATE.GT.0) THEN
      CALL TBERDC (ISTD, NROW, KDATE, CTEST, NULL, ISTAT)
      CALL FT_EOS (CTEST,20,DATSTR,ISTAT)
C     DATE exists.  Get it.
      IF(DATSTR.NE.' ') CALL GETJD(DJD)
      DJD=DJD-2400000.D0
        ELSE IF (KMJD.GT.0) THEN
C     MJD exists.  Get it.
      CALL TBERDD (ISTD, NROW, KMJD,  DJD, NULL, ISTAT)
      DJD=DJD+0.5D0
        END IF
C
C   PUT MJD IN COLORS(MBANDS).
      COLORS(MBANDS,NSTAR)=DJD
C   PUT X,Y,Z IN COLORS(MBM1,MBM2,MBM3)...
      COLORS(MBM1,NSTAR)=COS(RAS(NSTAR))*COS(DECS(NSTAR))
      COLORS(MBM2,NSTAR)=SIN(RAS(NSTAR))*COS(DECS(NSTAR))
      COLORS(MBM3,NSTAR)=SIN(DECS(NSTAR))
C    POINT TO END OF TABLE.
      DO 186 I=NSTAR-1,1,-1
      IF(STARS(I).NE.STARS(NSTAR)) GO TO 187
  186 CONTINUE
      I=0
  187 COLORS(MBM4,I+1)=NSTAR
C
           END IF
C
C   END EPHEMERIS FILE.
C
C     Now get COMMENTS, etc.
C
      IF (KCOMMENT.NE.-1) THEN
          CALL TBERDC(ISTD, NROW, KCOMMENT, CTEST, NULL, ISTAT)
          CALL FT_EOS (CTEST,32,COMENT(NSTAR),ISTAT)
      ELSE
          COMENT(NSTAR)=' '
      END IF
C
      LEN=LWORD(COMENT(NSTAR))
      IF (LASTD.EQ.0)THEN
C         std.star
          IF (LEN.EQ.0) THEN
              COMENT(NSTAR)='Standard star ******************'
          ELSE
              COMENT(NSTAR)(LEN:)='   STD.* ************'
          END IF
      ELSE
C         pgm.star
          IF (LEN.EQ.0) THEN
              COMENT(NSTAR)='Program star ...................'
          ELSE
              COMENT(NSTAR)(LEN:)='   Pgm.* ............'
          END IF
      END IF
C
      IF (KSPTYPE.NE.-1) THEN
          CALL TBERDC (ISTD, NROW, KSPTYPE,CTEST, NULL, ISTAT)
          CALL FT_EOS (CTEST,12,SPTYPE(NSTAR),ISTAT)
      ELSE
          SPTYPE(NSTAR)=' '
      END IF
C
      IF (KMAG.NE.-1) THEN
          CALL TBERDC (ISTD, NROW, KMAG, CTEST, NULL, ISTAT)
          CALL FT_EOS (CTEST,16,EMAG(NSTAR),ISTAT)
      ELSE
          EMAG(NSTAR)=' '
      END IF
C
      IF(BACK1) NSTAR=NSTAR-1
  181 CONTINUE
C
      CALL TBTCLO(ISTD, ISTAT)
      CARD='Closing star file '//STDFIL
      CALL TV(CARD)
C
C   END CATALOG.
C
  188 WRITE(PAGE,'(/I8,'' TOTAL STARS''/I8,'' SLOTS FREE'')')NSTAR,
     1MSTARS-NSTAR
      CALL TV(PAGE(2))
      CALL TVN(PAGE(3))
C   IS CAT.FULL?
      IF(NSTAR.EQ.MSTARS)GO TO 190
C---
      IF(LASTD.EQ.0)THEN
C
          IF(JSYS.NE.0)THEN
              IF(NEEDH.GT.3)CALL TV('   Additional Standards:')
              CALL ASKFIL('Any other STANDARD-star files?',CATFIL)
          ELSE
              CALL ASKFIL('Any more EXTINCTION-star files?',CATFIL)
          END IF
C
C         Y: goes to end of outer IF-block.
          IF(MATCH(CATFIL,'NO').OR.MATCH(CATFIL,'no'))THEN
C             transition to pgm.stars.
              LASTD=NSTAR
              MOVING=.FALSE.
              IF(NEEDH.GT.1)CALL TV('   Program Stars:')
              CALL ASKFIL('Any PROGRAM-star files?',CATFIL)
              IF(MATCH(CATFIL,'NO').OR.MATCH(CATFIL,'no'))GO TO 190
C             EXPAND GROUPS TO INCLUDE EPHEMERIS VARIABLES.
              NAM2(1)=MN
              NAM2(2)=MN+13
          END IF
C
      ELSE
C
              CALL ASKFIL('More PROGRAM-star files?',CATFIL)
              IF(MATCH(CATFIL,'NO').OR.MATCH(CATFIL,'no'))GO TO 190
C
      END IF
C---
      IF(MATCH(CATFIL,'YES').OR.MATCH(CATFIL,'yes'))
     1 CALL ASKFIL('Name of supplemental star file?',CATFIL)
C
C     Enter "keyboard" or "keys" to read from keyboard:
      IF(MATCH(CATFIL,'KEY').OR.MATCH(CATFIL,'key'))THEN
C             MANUAL ENTRY.
              NSTAR=NSTAR+1
              CALL ASKFIL('Enter Star name:',STARS(NSTAR))
              CALL ADDSTR(EQUINX(NSTAR),RAS(NSTAR),DECS(NSTAR))
C             flag missing Equinox.
              IF(EQUINX(NSTAR).EQ.0.) EQUINX(NSTAR)=3.E33
              DO 189 I=1,NBANDS
C $$$ NEEDS TO READ COLOR DATA.
  189         COLORS(I,NSTAR)=3.E33
              GO TO 188
      END IF
C
C   SET UP NEXT CATALOG FILE.
       IF(HELP(CATFIL))THEN
           CALL TV('If you made a mistake, you can re-start catalogs.')
           CALL ASK('Do you want to re-do the star catalogs?',A)
           IF (A.EQ.'Y') THEN
               CALL TV('Re-enter catalog data.')
               STDFIL=SAVFIL
               GO TO 170
           ELSE IF (A.EQ.'N') THEN
C               go on.
           ELSE
               CALL TV('   ... ambiguous reply ...')
               GOTO 188
           END IF
       END IF
      STDFIL=CATFIL
      GO TO 175
C
  190 NSTARS=NSTAR
C
C  CHECK INTERPOLATION TABLES:
       IF(MOVING)THEN
      EPHEM1=0.
      EPHEM2=3.E33
      I1=1
  191 DO 192 I=I1,NSTARS
      IF(EQUINX(I).NE.3.E33 .AND. EQUINX(I).GT.3.E3) GO TO 193
  192 CONTINUE
      GO TO 200
C   HERE FOR MOVER.
  193 STAR=STARS(I)
      I1=I
      I2=COLORS(MBM4,I)
C    FIND LATEST START, FIRST END.
      EPHEM1=MAX(EPHEM1,EQUINX(I1))
      EPHEM2=MIN(EPHEM2,EQUINX(I2))
      IF(I2.LT.I1+4) GO TO 199
      CALL TV('Please check plots for jumps due to bad data.')
C   PLOT RA(TIME).
      J=0
      DO 194 I=I1,I2
      J=J+1
      XS(J)=EQUINX(I)-EQUINX(I1)
  194 YS(J)=RAS(I)-RAS(I1)
      CARD='   R.A. of '//STAR
      CALL TV(CARD)
      CALL JD2DAT(EQUINX(I1)+2400000.,DAT)
      WRITE(CARD,'(8X,''days from '',A30)')DAT
      DO 196 K=1,2
      CALL PLOT(J,XS,YS,'*')
      CALL RTNCON(CARD,40)
C    DEC(TIME).
      J=0
      DO 195 I=I1,I2
      J=J+1
  195 YS(J)=DECS(I)-DECS(I1)
  196 CARD='   Dec.of '//STAR
      CALL TV(CARD)
C   PLOT ON SKY.
      CALL PLOT(0,1.,0.,'I')
      DO 197 J=1,40
      DUM=EQUINX(I1)+J*(EQUINX(I2)-EQUINX(I1))/40.
      CALL EPHEM(I1,DUM,COLORS,XS(J),YS(J))
      IF(XS(J).LT.0.) XS(J)=XS(J)+TWOPI
      XS(J)=XS(J)-RAS(I1)
  197 YS(J)=YS(J)-DECS(I1)
      CALL PLOT(40,XS,YS,'*')
      J=INDEX(STAR//'     ','     ')
      WRITE(CARD,'(5X,''PATH OF '',A,''ON SKY'')') STAR(:J)
      CALL RTNCON(CARD,40)
C    RESTORE NORMAL X-AXIS.
      CALL PLOT(0,0.,0.,'I')
  199 I1=I2+1
      GO TO 191
       END IF
C
C  MEASUREMENT TECHNIQUE.
C
  200 CONTINUE
      PC=.FALSE.
      DC=.FALSE.
      CI=.FALSE.
      CALL TV(' ')
      CALL ASKFIL('What MIDAS table file describes the instrument?',
     1             STDFIL)
      IF (MATCH(STDFIL,'none') .OR. MATCH(STDFIL,'NONE')) GO TO 201
      IF(INDEX(STDFIL,'.tbl').EQ.0) THEN
          I=LWORD(STDFIL)
          STDFIL(I+1:)='.tbl'
      END IF
C       Open instrument file:
      INQUIRE (FILE=STDFIL,EXIST=FEXIST)
      IF (FEXIST) THEN
C       OK.
      ELSE
        CARD='The requested instrument table file '//STDFIL
        CALL TV(CARD)
        CALL TVN('is not available.  Please make sure all required')
        CALL TVN('files are available in your current directory.')
        CARD='Is '//STDFIL(:LWORD(STDFIL))//' the correct file name?'
        CALL ASK(CARD,STDFIL)
        IF (MATCH(STDFIL,'YES'))THEN
            CALL STETER(200,'Missing instrument file')
        ELSE
            GO TO 200
        END IF
      END IF
      CALL TBTOPN(STDFIL,1,  INST,ISTAT)
      IF(ISTAT.NE.0) CALL TERROR(INST,200,
     1          'Could not open instrument-description file.')
      CALL TBIGET (INST,  NCOLS, NROWS, NSORTC, NWPRAL, NROWSAL, ISTAT)
      IF(ISTAT.NE.0) CALL TERROR(INST, 200,
     1                    'Could not get basic table data.')
      CALL STDRDC (INST, 'INSTNAM', 1, 1, 72,
     1              NVALS, INSTNAM, IUNIT, NULLS, ISTAT)
      IF(ISTAT.NE.0)THEN
          CALL TV('Could not find INSTNAM descriptor.')
          CALL TERROR(INST,200,'Please fix instrument table file.')
      END IF
      CALL TV('Instrument identification:')
      CALL TV(INSTNAM)
      CALL TVN(' ')
      CALL STDRDC (INST, 'FILTSTAT', 1, 1, 9,
     1              NVALS, FILTSTAT, IUNIT, NULLS, ISTAT)
      IF(ISTAT.NE.0)THEN
          CALL TV('Could not find FILTSTAT descriptor.')
          CALL TERROR(INST,200,'Please fix instrument table file.')
      END IF
C
C       Get required-column pointers:
C
      CALL TBLSER (INST, 'DET',  KDET, ISTAT)
      IF (ISTAT.NE.0 .OR. KDET.EQ.-1)
     1    CALL TERROR(INST,200,'Could not find column DET')
      CALL TBLSER (INST, 'BAND',  KBAND, ISTAT)
      IF (ISTAT.NE.0) CALL TERROR(INST,200,'Could not find column BAND')
      CALL TBLSER (INST, 'DETNAME',  KDETNM, ISTAT)
      IF(ISTAT.NE.0)CALLTERROR(INST,200,'Could not find column DETNAME')
      CALL TBLSER (INST, 'NDET',  KNDET, ISTAT)
      IF (ISTAT.NE.0) CALL TERROR(INST,200,'Could not find column NDET')
      CALL TBLSER (INST, 'COOLING',  KCOOL, ISTAT)
      IF(ISTAT.NE.0)CALLTERROR(INST,200,'Could not find column COOLING')
C
C     see if we need to check DARK:
      CALL TBESRC (INST, KCOOL, 'REGULATED', 1, 12, 1,  NROW, ISTAT)
      IF(ISTAT.NE.0) CALL TERROR(INST,200,
     1                'Could not search COOLING column for "REGULATED"')
      IF (NROW.GT.0) THEN
          DARK=.FALSE.
      ELSE
          DARK=.TRUE.
      END IF
C
C     see if we need to remind user about cooling:
      CALL TBESRC (INST, KCOOL, 'NONE', 1, 12, 1,  NROW, ISTAT)
      IF(ISTAT.NE.0) CALL TERROR(INST,200,
     1                'Could not search COOLING column for "NONE"')
      IF (NROW.GT.0) THEN
          COOLED=.FALSE.
      ELSE
          COOLED=.TRUE.
      END IF
C
      FUNK=.FALSE.
      FCORN=.FALSE.
C     see if we measure redleaks:
      CALL TBLSER (INST, 'REDLEAK',  KRL, ISTAT)
      IF (ISTAT.NE.0)
     1       CALL TERROR(INST,200,'Could not find column REDLEAK')
      CALL TBESRC (INST, KRL, 'MEASURED', 1, 3, 1,  NROW, ISTAT)
      IF(ISTAT.NE.0) CALL TERROR(INST,200,
     1                'Could not search REDLEAK column for "MEASURED"')
      IF (NROW.GT.0) THEN
C         see if we know RLTYPE:
          CALL TBLSER (INST, 'RLTYPE',  KRLTYP, ISTAT)
          IF (ISTAT.NE.0)
     1       CALL TERROR(INST,200,'Could not find column RLTYPE')
          CALL TBESRC (INST, KRLTYP, 'UNKNOWN', 1, 3, 1,  NROW, ISTAT)
          IF(ISTAT.NE.0) CALL TERROR(INST,200,
     1                'Could not search RLTYPE column for "UNKNOWN"')
          IF (NROW.GT.0) THEN
              FUNK=.TRUE.
          END IF
C         see if we know MAKER:
          CALL TBLSER (INST, 'MAKER',  KRLTYP, ISTAT)
          IF (ISTAT.NE.0)
     1       CALL TERROR(INST,200,'Could not find column MAKER')
          CALL TBESRC (INST, KRLTYP, 'UNKNOWN', 1, 3, 1,  NROW, ISTAT)
          IF(ISTAT.NE.0) CALL TERROR(INST,200,
     1                'Could not search MAKER column for "UNKNOWN"')
          IF (NROW.GT.0) THEN
              FCORN=.TRUE.
          END IF
      END IF
C
C
C       Look at detectors:
C
C     see if PMT is used:
      CALL TBESRC (INST, KDET, 'PMT', 1, 3, 1,  NROW, ISTAT)
      IF(ISTAT.NE.0) CALL TERROR(INST,200,
     1                       'Could not search DET column for "PMT"')
      IF(NROW.GT.0) THEN
C         get mode:
          CALL TBLSER (INST, 'MODE',  KMODE, ISTAT)
          IF(ISTAT.NE.0 .OR. KMODE.EQ.-1)THEN
              CALL TV('Could not find MODE column.')
              CALL TERROR(INST,200,'Please fix instrument table file.')
          END IF
          CALL TBERDC (INST, NROW, KMODE, CTEST, NULL, ISTAT)
          IF(ISTAT.NE.0 .OR. NULL)
     1        CALL TERROR(INST,200,'Could not read MODE column.')
          CALL FT_EOS (CTEST,32,DMS,ISTAT)
C         DMS now holds mode.
          IF (DMS(:2).EQ.'PC') THEN
C               Pulse-counting.  Get dead-time:
              CALL TBLSER (INST, 'DEADTIME',  KDEDT, ISTAT)
              IF(ISTAT.NE.0 .OR. KDEDT.EQ.-1)THEN
                  CALL TV('Could not find DEADTIME column.')
                  CALL TERROR(INST,200,
     1                      'Please fix instrument table file.')
              END IF
              CALL TBERDR (INST, NROW, KDEDT,  DEADT, NULL, ISTAT)
              IF(ISTAT.NE.0 .OR. NULL)
     1            CALLTERROR(INST,200,'Could not read DEADTIME column.')
C              nd deadtime error:
              CALL TBLSER (INST, 'DEADTIMEERROR',  KDEDER, ISTAT)
              IF(ISTAT.NE.0 .OR. KDEDER.EQ.-1)THEN
                  CALL TV('Could not find DEADTIMEERROR column.')
                  CALL TERROR(INST,200,
     1                      'Please fix instrument table file.')
              END IF
              CALL TBERDR (INST, NROW, KDEDER,  SDEDT, NULL, ISTAT)
              IF(ISTAT.NE.0 .OR. NULL)
     1            CALL TERROR(INST,200,
     2            'Could not read DEADTIMEERROR column.')
              PC=.TRUE.
              MTYPE=1
              GOTO 212
          ELSE IF (DMS(:2).EQ.'DC') THEN
C               PMT, DC.
              CALL TBTCLO(INST, ISTAT)
              GO TO 220
          ELSE IF (DMS(:2).EQ.'CI') THEN
C               PMT, CI.
              CALL TBTCLO(INST, ISTAT)
              GO TO 222
          ELSE
              MTYPE=0
              CALL TV('Mode of operation not given in table file.')
          END IF
C
      END IF
      CALL TBTCLO(INST, ISTAT)
  201 IF(MTYPE.NE.0) GOTO 265
      CALL TV(' ')
      CALLASK('Are data Pulse Counts, DC, Charge Integration, or mixed?'
     1,A)
      IF(MATCH(A,'P')) GO TO 204
      IF(MATCH(A,'D')) GO TO 220
      IF(MATCH(A,'C')) GO TO 222
      IF(MATCH(A,'M')) GO TO 240
      GO TO 201
C
C  PULSE COUNTS.
C
  204 MTYPE=1
      IF(DEDSET)GO TO 213
  205 CALL ASK('Do you know the Dead Time (ns)?',DMS)
      PC=.TRUE.
       IF(MATCH(DMS,'NO'))THEN
      CALL TV(ASSUME(2))
      NASSMP=NASSMP+1
      ASSMPS(NASSMP)=ASSUME(2)
      WRITE(PAGE,
     1'(/''  Keep rate below'',F3.0,''MHz to avoid gain shift.'')')
     2  SIGTOT/.0016
      CALL TV(PAGE(2))
      DEADT=16.
      SDEDT=DEADT
      GO TO 211
       END IF
      IF(MATCH(DMS,'YES')) CALL ASK('Dead time (nanoseconds) =',DMS)
  210 CALL FINDPM(DMS,DEADT,SDEDT)
      WRITE(PAGE,'(/'' Dead time ='',F6.1,'' +/-'',F6.1,'' ns'')')DEADT,
     1SDEDT
      CALL TV(PAGE(2))
      CALL ASK('OK?',A)
      IF(MATCH(A,'N'))GOTO 205
  211 SDEDT=SDEDT*1.E-9
      DEADT=DEADT*1.E-9
  212 DEDSET=.TRUE.
      IF(DEADT.EQ.0. .OR. SDEDT.EQ.0.)GOTO 210
C
      IF(SDEDT/DEADT.GT.0.1)THEN
C         allow D.T.corrections to be 10 x precision.
          NASSMP=NASSMP+1
          ASSMPS(NASSMP)=ASSUME(3)
          CALL TV(ASSUME(3))
          SDEDT=0.1*DEADT
          NEEDED=.TRUE.
          CALL TV(' EXTRA STARS will be added to allow improvement.')
      END IF
C
  213 CALL TV(
     1  'Uncertainty of dead-time correction = half of total error at:')
      NEEDIM=.FALSE.
      RATE=1./(SIGSQ*TINT1)
      DO 215 NB=1,NBANDS
        BRITES(NB)=PHOMAG(NB)-2.5*LOG10(SIGTOT/(2.*SDEDT*RATE))
C       count rate at phomag is 'RATE'.
        WRITE(PAGE,214)BRITES(NB),BANDS(NB)
  214   FORMAT(/3X,F5.1,' IN ',A6)
        CALL TV(PAGE(2))
        IF(BRITES(NB).GT.FAINTS(NB) .AND. .NOT.DC)THEN
          CALL TV('TOO MANY PHOTONS -- You need an optical attenuator.')
          NEEDIM=.TRUE.
        END IF
  215 CONTINUE
      IF(DC) GO TO 265
      IF(NEEDIM)GO TO 217
  216 CALL ASK('No BRIGHTER stars will be used.  OK?',A)
      IF(MATCH(A,'Y') .OR. MATCH(A,'O')) GO TO 265
C
C    Ask for dimmer & return to 216 after revising BRITES.
  217 CALL BRITEN(BANDS,DIMMED)
C    here if revision failed, or not needed.
      IF(DIMMED .OR. .NOT.NEEDIM)GO TO 216
C
        WRITE(ASSMPS(8),'(''Requested precision is'',F6.3,'' mag.'')')
     1  SIGTOT
        CALL TV(ASSMPS(8))
      CALL ASK('Will you accept larger errors?',A)
      MTYPE=0
      NEEDH=NEEDH-1
      IF(MATCH(A,'Y') .OR. MATCH(A,'O'))GO TO 128
      CALL TV('You require a SMALLER TELESCOPE, or a DC photometer.')
      NASSMP=0
      CALL TVN(' ')
      CALL TV('Starting over...')
      GO TO 51
C
C  DC.
  220 MTYPE=2
      DC=.TRUE.
      CALL TV(
     1'  Use double integrations to allow for chart-reading error.')
      GO TO 265
C
C  CHARGE INTEGRATION.
  222 MTYPE=3
      CI=.TRUE.
C   READ GAINS.
      GO TO 265
C
C  MIXED.
  240 MTYPE=4
      DC=.TRUE.
      CALL ASK('Any Pulse-Counting?',A)
      IF(MATCH(A,'Y'))GO TO 205
C  MTYPE=5 IF NO PC.
      MTYPE=5
      CI=.TRUE.
C
C       Time scale?
C
  265 CALL ASK('Do you want UT, Zone Time, or Local Sidereal Time?',A)
C              ITIME =      1       2              3
      ITIME=0
      ZONE=0.
C
       IF(MATCH(A,'U')) THEN
      ITIME=1
      TL='U.T.'
       ELSE IF(MATCH(A,'Z')) THEN
C   ZONE TIME.
      ITIME=2
      CALL ASK('Name of Time Zone?  (MST, PDT,...-- 4 letters max.)',TL)
      CALL QF('What U.T. is Zero hours Zone Time?',ZONE)
C    UT = STD.time + Zone; convert to rotations.
      ZONE=ZONE/24.
       ELSE IF(MATCH(A,'L') .OR. MATCH(A,'S')) THEN
C   LST.
      ITIME=3
      TL='LST'
       ELSE
      GO TO 265
       END IF
C
      TEMPRH(29:32)=TL
C
C       Names or codes?
C
  270 CALL TV('Will your data files identify stars by')
      CALL ASKN('Full Names, or Codes?',A)
      CODEDS=.FALSE.
C
      IF(MATCH(A,'C')) THEN
         CODEDS=.TRUE.
  275    CALL QF('How many digits in your star code?',DUM)
         NDIG=DUM
         IF(NDIG.LT.1 .OR. NDIG.GT.6)THEN
             CALL TV('Sorry, PEPSYS uses only 1 to 6.')
             GO TO 275
         END IF
         WRITE(F361(5:5),'(I1)')NDIG
      ELSE IF(A.EQ.'F' .OR. A.EQ.'N')THEN
C        no action needed.
      ELSE
         CALL TV(
     1       'If your data system uses numerical labels, say "Codes".')
         GO TO 270
      END IF
C
C   DATE:
C
       IF(MOVING)THEN
      CALL JD2DAT(2400000.+EPHEM1,DATSTR)
      CALL JD2DAT(2400000.+EPHEM2,MONTH)
      WRITE(PAGE,'(/4X,''Ephemeris data span only '',A11,'' to '',A11)')
     1 DATSTR,MONTH
      CALL TV(PAGE(2))
       END IF
C
      CALL TVN(' ')
      CALL TV('Enter dates (please spell month name):')
      IF(NEEDH.GT.2)CALL TV('  Use double date  -  e.g., May 8/9, 1986')
C
  305 DO 320 N=1,2
  311 PAGE(1)='Enter '//FL(N)//' date of run:'
      CALL ASK(PAGE(1),CARD)
      IF(N.EQ.2 .AND. CARD.EQ.'SAME') GO TO 315
      CALL MDY(CARD,MON,DDAY,YR)
      IF(YR.EQ.0.)THEN
         IF(N.EQ.2)THEN
C           user forgot year on 2nd date:
            YR=OLDYR
         ELSE
            CALL QF('Year?',YR)
         END IF
      END IF
      IF(YR.LT.100.)YR=YR+1900.
      OLDYR=YR
      CALL TV('   Night begins on')
      WRITE(PAGE,'(4X,A3,I3,'','',I5)')MON,INT(DDAY),INT(YR)
      CALL TVN(PAGE(1))
      IF(DDAY.GT.33.)GOTO 313
      DDAY=DDAY+1.
C    NEAREST UT DATE TO LOCAL MIDNIGHT.
      M=MON2M(MON)
      IF(M.GT.0)GO TO 315
      WRITE(PAGE,*)MON,' is not the name of a month.'
      CALL TVN(PAGE(1))
  313 CALL TV('  Please correct DATE:')
      GO TO 311
C  J.D.: SEE SKY & TEL.61,312 (1981).
  315 Y=YR
      IF(M.GT.2)GO TO 316
      M=M+12
      Y=Y-1
  316 DJ=AINT(365.25*Y) + AINT(30.6001*(M+1)) + DDAY + 1720981.5D0
  320 DJS(N)=DJ
C
       IF(DJS(2).LT.DJS(1))THEN
          CALL TV('Days are in wrong order.')
          GO TO 305
       ELSE IF(DJS(2)-DJS(1).GT.10.)THEN
          WRITE(PAGE,'(/F8.0,'' day interval'')')DJS(2)-DJS(1)
          CALL TV(PAGE(2))
          CALL TV('Please keep interval less than 1 week.')
          GO TO 305
       END IF
C
       CALL PLANBOT(DJS,LASTD,NSTARS,NEEDST,JSYS,DRAT,BANDS,SALTS,
     1 PLACE(:20),TELCM,TL,ITIME,ZONE)
C
        END

C @(#)rebdec.for	19.1 (ESO-DMD) 02/25/03 13:31:23
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM REBDEC
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  program    REBDEC			version 1.00	   880930
C  Basic algorithm: L. Lucy		ESO - Garching
C  MIDAS implementation: D. Baade       ESO - Garching
C  K. Banse					1.10	   890517
C  1.20	    900220
C
C.KEYWORDS
C  (nonlinear) rebinning, deconvolution, point spread function, undersampling
C
C.PURPOSE
C  Rebin an image to smaller stepsize to remove effects of coarse PSF sampling 
C  ("pixelation"). Optionally deconvolve with PSD. 
C
C.ALGORITHM
C  Get the names of input + output frames from IN_A + OUT_A (both 2-D)
C  Do the rebinning (which is nonlinear in the way the flux is redistributed 
C  whereas the spatial coordinate transformation is strictly linear) while 
C  simultaneously deconvolving with user-supplied point spread function. 
C	
C.INPUT/OUTPUT
C  the following keys are used:
C
C  IN_A/C/1/60			input frame
C  IN_B/C/1/60			point spread function 
C  OUT_A/C/1/60			output frame
C  INPUTI/I/1/2			zoom factors in x and y
C  INPUTI/I/3/1			number of iterations 
C
C.VERSIONS
C  1.10		convert to Portable Midas
C  1.20		fix bug in STIPUT (missing NAXIS..)
C 
C 010201		last modif
C	
C --------------------------------------------------------------------
C
      IMPLICIT NONE
C      
      INTEGER    STAT,ZOOM(2),NITER,NAXIN,NPXIN(2)
      INTEGER    INNO,PSFNO,OUTNO,DUMNO,D0NO,D1NO,D2NO,D3NO,D4NO
      INTEGER    NAXPSF,NPXPSF(2),IAV,OFF(2)
      INTEGER    NPXPSR(4),NAXPSR,I,SUBLO(2),GS
      INTEGER    NPXOUT(2),RESPIX(2),SIZE,NAXOUT,NPIXL(2)
      INTEGER    NPIXZ(2),MSIZ,INPUTI(4)
      INTEGER    UNI(1),NULO,MADRID(1)
      INTEGER*8    INPTR,PSFPTR,OUTPTR,DUMPTR,D0PTR,D1PTR,D2PTR,
     +             D3PTR,D4PTR
C
      CHARACTER  INFRM*60,OUTFRM*60,PSF*60
      CHARACTER  CUNIN*64,CUNPSF*64,IDENT*72
      CHARACTER  IDENTP*72,CUNOUT*64,IDENTO*72
C      
      DOUBLE PRECISION   STAIN(2),STPIN(2),STAPSF(2)
      DOUBLE PRECISION   STPPSF(2),STPOUT(2),STPPSR(4)
      DOUBLE PRECISION   STAPSR(4),STAOUT(2),TEST,EPS
C 
      REAL       CUTS(2),CUTVALS(4)
C 
      INCLUDE    'MID_INCLUDE:ST_DEF.INC'
C 
      COMMON   /VMR/  MADRID
C 
      DATA    CUTVALS /4*0./,  SUBLO /1,1/
C      
      INCLUDE    'MID_INCLUDE:ST_DAT.INC'
C 
C  set up MIDAS environment + enable automatic error abort
      CALL STSPRO('REBDEC')
C
C  get name of input image  + map frame 
      CALL STKRDC('IN_A',1,1,60,IAV,INFRM,UNI,NULO,STAT)
      CALL STIGET(INFRM,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +            2,NAXIN,NPXIN,STAIN,STPIN,
     +            IDENT,CUNIN,INPTR,INNO,STAT)
      IF (NAXIN.NE.2) CALL STETER
     +   (1,'ERROR: Currently only 2-D frames supported!')
C      
C  get and check zoom factors in x + y ... and the number of iterations 
      CALL STKRDI('INPUTI',1,4,IAV,INPUTI,UNI,NULO,STAT)
      ZOOM(1) = INPUTI(1)
      ZOOM(2) = INPUTI(2)
      NITER = INPUTI(3)
      GS = INPUTI(4)
C
      IF ((((ZOOM(1)*ZOOM(2))/2)*2).EQ.(ZOOM(1)*ZOOM(2))) 
     +   CALL STETER
     +     (2,'ERROR: Both zoom factors need to be odd!')
      IF ((ZOOM(1).LT.1).OR.(ZOOM(2).LT.1))
     +   CALL STETER
     +     (3,'ERROR: Zoom factors less than unity are illegal!')
C
      IF (NITER.LT.1) CALL STETER 
     +     (4,'ERROR: Number of iterations must at least be 1!')
C      
C  get name of point spread function frame + map it
      CALL STKRDC('IN_B',1,1,60,IAV,PSF,UNI,NULO,STAT)
      CALL STIGET(PSF,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +            2,NAXPSF,NPXPSF,STAPSF,
     +            STPPSF,IDENTP,CUNPSF,PSFPTR,PSFNO,STAT)
C
C  Further error traps: make sure dimensions are the same ... 
      IF (NAXPSF.NE.NAXIN)
     +   CALL STETER
     +   (5,'Dimensions of inframe and PSF must be the same!')
C
C  ... steps have the right relative proportions, 
        IF ((NINT(STPIN(1)/STPPSF(1)).NE.ZOOM(1)).OR.
     +      (NINT(STPIN(2)/STPPSF(2)).NE.ZOOM(2)))
     +     CALL STETER
     +     (6,'Steps of inframe and PSF must differ by zoom fact!')
C
C  ... the zoom factor is not even when the number of pixels in the input PSF 
C  is odd (check both X and Y) 
      DO 100 I=1,2
         IF ((NPXPSF(I)/2)*2.EQ.NPXPSF(I)) 
     +      CALL STETER
     +        (7,'NPIX(PSF) must be odd in both X and Y!') 
100   CONTINUE
C
C  Get name of output frame, ...
         CALL STKRDC('OUT_A',1,1,60,IAV,OUTFRM,UNI,NULO,STAT)
         IF (OUTFRM.EQ.INFRM)             ! in- and output frame must be different
     +      CALL STETER
     +      (8,'Names of inframe + outframe must be different!')
C
C  ... depending on its existence or not, 
C
C  ... open it for reading and writing or create it for writing to it 
C
      IF (GS.EQ.0) THEN             ! we start without an initial guess
C
C  Calculate further defining parameters of output frame ...
         STPOUT(1)=STPIN(1)/ZOOM(1)
         STPOUT(2)=STPIN(2)/ZOOM(2)
         NPXOUT(1)=NPXIN(1)*ZOOM(1)
         NPXOUT(2)=NPXIN(2)*ZOOM(2)
C
C  The zooming
         STAOUT(1)=STAIN(1)-STPOUT(1)*(ZOOM(1)/2)
         STAOUT(2)=STAIN(2)-STPOUT(2)*(ZOOM(2)/2)
C      
C  ... and map it:
         IDENTO(1:) = IDENT(1:)
         CUNOUT(1:) = CUNIN(1:)
         NAXOUT = 2
         CALL STIPUT(OUTFRM,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +               NAXOUT,NPXOUT,STAOUT,
     +               STPOUT,IDENT,CUNIN,OUTPTR,OUTNO,STAT)
C
      ELSE                        ! there is a guess
C
C  If there is a guess, we first map the frame ...
         CALL STIGET(OUTFRM,D_R4_FORMAT,F_IO_MODE,F_IMA_TYPE,
     +               2,NAXOUT,NPXOUT,STAOUT,
     +               STPOUT,IDENTO,CUNOUT,OUTPTR,OUTNO,STAT)
C
C  ... and then check if it is technically compatible with the 
C  input frame and the zoom factors:
C 
         IF (NAXOUT.NE.2) CALL STETER
     +      (9,'Output frame, too, must be 2-dimensional!')
         IF ((NPXIN(1)*NPXIN(2)*ZOOM(1)*ZOOM(2)).NE.
     +       (NPXOUT(1)*NPXOUT(2))) 
     +      CALL STETER
     +      (10,'NPIX(OUT) incompatible with NPIX(IN) + zoom factors!')
         TEST = (STAOUT(1)+STPOUT(1)*(ZOOM(1)/2))*
     +          (STAOUT(2)+STPOUT(2)*(ZOOM(2)/2))
         EPS = STPIN(1)*STPIN(2)*0.01
         IF (ABS(TEST-(STAIN(1)*STAIN(2))).GT.EPS)
     +      CALL STETER
     +      (11,'START values of in- and outframe differ!')
         EPS = STPIN(1)*STPIN(2)*0.0001
         IF (ABS((STPOUT(1)*ZOOM(1)*STPOUT(2)*ZOOM(2))-
     +       (STPIN(1)*STPIN(2))).GT.EPS)
     +      CALL STETER
     +      (12,'steps of in- and outframe must differ by factor ZOOM!')
      ENDIF                        ! guess or no guess?
C
C  We also need six working buffers for ... 
C
C  a) the output frame with extrapolation beyond its edges
      DO 400 I=1,2
C
C  The radius of the PSF determines the width of the margin to be added 
C  around inframe, for outframe additionally the zoom factor must be considered:
         OFF(I) = NPXPSF(I)/(2*ZOOM(I)) + 2
         NPIXL(I) = NPXIN(I)+2*OFF(I)
         NPIXZ(I) = NPIXL(I)*ZOOM(I)
400   CONTINUE
C 
      MSIZ = NPIXZ(1) * NPIXZ(2)
      CALL STFCRE('DUMMY',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +            MSIZ,DUMNO,STAT)
      CALL STFMAP(DUMNO,F_X_MODE,1,MSIZ,IAV,DUMPTR,STAT)
C
C  If there is a guess, we transfer it right away to the enlarged frame:
      IF (GS.EQ.1) 
     +   CALL EXTND(MADRID(OUTPTR),MADRID(DUMPTR),
     +              NPXOUT(1),NPXOUT(2),NPIXZ(1),NPIXZ(2),OFF,
     +              ZOOM(1),ZOOM(2))
C
C  In order not to waste virtual memory space, we temporarily close OUTFRM
      CALL STFCLO(OUTNO,STAT)
C
C  b) the input frame after extrapolation beyond its edges
      MSIZ = NPIXL(1) * NPIXL(2)
      CALL STFCRE('DUMMY0',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +            MSIZ,D0NO,STAT)
      CALL STFMAP(D0NO,F_X_MODE,1,MSIZ,IAV,D0PTR,STAT)
C
C  We do the enlargement here and then close inframe (no longer needed)
C 
      CALL EXTND (MADRID(INPTR),MADRID(D0PTR),NPXIN(1),NPXIN(2),
     +            NPIXL(1),NPIXL(2),OFF,1,1)
      CALL STFCLO(INNO,STAT)
C 
C  c) ratio of observed to calculated image
      MSIZ = NPIXL(1) * NPIXL(2)
      CALL STFCRE('DUMMY1',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +            MSIZ,D1NO,STAT)
      CALL STFMAP(D1NO,F_X_MODE,1,MSIZ,IAV,D1PTR,STAT)
C
C  d) correction factors to be applied to previous intermediate result
      MSIZ = NPIXZ(1) * NPIXZ(2)
      CALL STFCRE('DUMMY2',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +            MSIZ,D2NO,STAT)
      CALL STFMAP(D2NO,F_X_MODE,1,MSIZ,IAV,D2PTR,STAT)
C
C  e) re-calculated frame on coarse grid
      MSIZ = NPIXL(1) * NPIXL(2)
      CALL STFCRE('DUMMY3',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +            MSIZ,D3NO,STAT)
      CALL STFMAP(D3NO,F_X_MODE,1,MSIZ,IAV,D3PTR,STAT)
C
C  f) PSF, but re-sampled on coarse grid for various centerings. 
C
C  First, the dimension of this new PSF need to be properly determined:
      NAXPSR = 4
      DO 1000 I=1,2
C
C  The number of pixels of the coarse PSF (see subroutine PSFRESAMP) must be 
C  odd. If ZOOM divides NPIX(PSF), this is automatically fulfilled because 
C  both numers are odd. 
         NPXPSR(2*I-1) = NPXPSF(I) / ZOOM(I)
C
C  Otherwise, we just make it odd:
         IF (((NPXPSF(I)/ZOOM(I))*ZOOM(I)).NE.NPXPSF(I))
     +      NPXPSR(2*I-1) = (NPXPSR(2*I-1)/2)*2 + 1
C
C  Finally, an additional margin of 1 is added at either limit in order 
C  to avoid truncations of input-PSF:
         NPXPSR(2*I-1) = NPXPSR(2*I-1)+2
         NPXPSR(2*I) = ZOOM(I)
         STPPSR(2*I-1) = STPPSF(I)
         STPPSR(2*I) = 1.D0/ZOOM(I)
         STAPSR(2*I-1) = STAPSF(I)
         STAPSR(2*I) = 1.D0/ZOOM(I)
1000  CONTINUE
C
      MSIZ = NPXPSR(1) * NPXPSR(2) * NPXPSR(3) * NPXPSR(4)
      CALL STFCRE('DUMMY4',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +            MSIZ,D4NO,STAT)
      CALL STFMAP(D4NO,F_X_MODE,1,MSIZ,IAV,D4PTR,STAT)
C
C  Do the resampling of the PSF here and then close the input PSF 
C  because it's no longer used
      CALL PSFRES(NPXPSF(1),NPXPSF(2),NPXPSR(1),NPXPSR(3),
     +            ZOOM(1),ZOOM(2),MADRID(PSFPTR),MADRID(D4PTR))
      CALL STFCLO(PSFNO,STAT)
C      
C  Now comes the real thing:
      CALL REBDC(NPIXL(1),NPIXL(2),NPIXZ(1),NPIXZ(2),NITER,
     +           NPXPSR(1),NPXPSR(3),ZOOM(1),ZOOM(2),GS,
     +           MADRID(D0PTR),MADRID(D1PTR),MADRID(D2PTR),
     +           MADRID(D3PTR),MADRID(D4PTR),MADRID(DUMPTR))
C
C  Close dispensible intermediate files and re-open outframe . Cut off 
C  extrapolated regions of intermediate result as to match size of OUTFRM, 
C  insert into outframe:
C 
      CALL STFCLO(D0NO,STAT)
      CALL STFCLO(D1NO,STAT)
      CALL STFCLO(D2NO,STAT)
      CALL STFCLO(D3NO,STAT)
      CALL STFCLO(D4NO,STAT)
C 
      CALL STIGET(OUTFRM,D_R4_FORMAT,F_IO_MODE,F_IMA_TYPE,
     +            2,NAXOUT,NPXOUT,STAOUT,
     +            STPOUT,IDENTO,CUNOUT,OUTPTR,OUTNO,STAT)
      CALL TRUNC(MADRID(DUMPTR),MADRID(OUTPTR),NPIXZ(1),NPIXZ(2),
     +           NPXOUT(1),NPXOUT(2),OFF,ZOOM(1),ZOOM(2))
C
C  Last, we determine physical minimum and maximum of OUTFRM
      CALL STVALS('MIN',MADRID(OUTPTR),2,NPXOUT,SUBLO,
     +            NPXOUT,CUTVALS,CUTS,RESPIX,SIZE,STAT)
C
C  Copy descriptors and update LHCUTS + HISTORY
      CALL DSCUPT(INNO,OUTNO,' ',STAT)
      CALL STDWRR(OUTNO,'LHCUTS',CUTS,3,2,UNI,STAT)
C
C  Bye, Bye
      CALL STSEPI
      END

      SUBROUTINE REBDC(ICX,ICY,I1X,I1Y,NITER,OPSFX,OPSFY,ZX,ZY,GS,
     1                 PHT,RT,CF,PHI,PSF,PSI)
C
C      Removal of pixel grid from CCD data plus seeing by appropriate 
C      rebinning (including 2-D deconvolution) to smaller step size. 
C      The deconvolution algorithm follows the description given in 
C      The Astronomical Journal, Vol. 79, p. 745-754 (1974) but the 
C      rebinning to a smaller step is an extra feature. 
C
C      L.B. Lucy              ESO - Garching        1988 August
C      Modifications applied for MIDAS version (incl. generalisation 
C      to non-square images and PSF's):
C       
C      D. Baade               ESO - Garching        880930
C
      IMPLICIT NONE
C
      INTEGER   ICX,ICY,GS,ZX,ZY,NITER,STAT,I1X,I1Y,IT,I,J
      INTEGER   OPSFX,OPSFY
C
      REAL      PHT(ICX,ICY),PHI(ICX,ICY),CD,CD1,RT(ICX,ICY)
      REAL      PSF(OPSFX,ZX,OPSFY,ZY),CF(I1X,I1Y),PSI(I1X,I1Y)
C
      CHARACTER  TIME*25,CBUF*80
C
C     PHT        inframe, but extrapolated beyond edges, dims: ICX x ICY 
C     PHI        calculated frame in coarse grid
C     RT         basically, the ratio observed/calculated in coarse grid
C     CF         correction factor to be applied to current fine-grid result
C     PSI        fine-grid output frame, STAINg from some trivial guess
C     IC         dimensions of input frame: ICX x ICY
C     Z          zoom factors coarse -> fine grid: ZX, ZY
C     I1         dimensions of output frame: ZX*ICX x ZY*ICY
C
C
C ...      If an initial guess has not been provided, we start with a 
C ...      smooth trial-image
C
      CD = ZX*ZY
      IF (GS.EQ.0) THEN 
         CD1 = CD/(I1X*I1Y)
         DO 200 I=1,I1X                              
            DO 100 J=1,I1Y
               PSI(I,J) = CD1                  ! initial smooth trial - image
100         CONTINUE
200      CONTINUE
      ENDIF                                    ! start frame prepared 
C
      DO 1000 IT=1,NITER                       ! iteration loop
C
C  Form PSF-mapped coarse-grid image of guess PSI (result in frame PHI):
         CALL INTEGD(I1X,I1Y,ICX,ICY,ZX,ZY,OPSFX,OPSFY,
     +               PSF,PSI,PHI) 
C
C  Compute ratio of observed to calculated (guessed) image 
C
         DO 400 I=1,ICX
            DO 300 J=1,ICY
               RT(I,J) = 1.0                     ! initialize
               IF (PHI(I,J).NE.0.0) 
     +            RT(I,J) = CD*PHT(I,J)/PHI(I,J) ! obs/calc
300         CONTINUE
400      CONTINUE
C
C  Determine correction factor to current intermediate result
         CALL INTEGF(I1X,I1Y,ICX,ICY,ZX,ZY,OPSFX,OPSFY,
     +               PSF,RT,CF)  
C
C  Apply the correction, thereby completing this iteration
         DO 600 I=1,I1X
            DO 500 J=1,I1Y
               PSI(I,J) = PSI(I,J)*CF(I,J)       ! apply correc factor
500         CONTINUE
600      CONTINUE
C
C  The code is slow. Progress messages seem a good idea:
         CALL GENTIM(TIME)
         WRITE (CBUF,10000) TIME,IT
         CALL STTPUT(CBUF,STAT)
C
1000  CONTINUE
C
      RETURN
C 
10000 FORMAT (A,'  ',I2,'. iteration completed')
      END

      SUBROUTINE EXTND (RAW,PHT,IRX,IRY,ICX,ICY,OFF,ZX,ZY)
C
C     To avoid ugly effects at the frame limits, repeat the outermost 
C     columns (rows) RX (RY) times, i.e. by the halfwidth of the 
C     PSF resampled on the coarse grid.
C
      IMPLICIT NONE
C
      INTEGER     IRX,IRY,ICX,ICY,I,J,IQ,JQ,OFF(2),ZX,ZY,OFX,OFY
C
      REAL        RAW(IRX,IRY),PHT(ICX,ICY)
C
      OFX = OFF(1)*ZX
      OFY = OFF(2)*ZY
C
C  Insert raw frame at center of output frame 
C 
      DO 200 I=1,IRX
         IQ = I+OFX
         DO 100 J=1,IRY
            JQ = J+OFY
            PHT(IQ,JQ) = RAW(I,J)
100      CONTINUE
200   CONTINUE
C
C ...      Do the extrapolation, first in X:
C
      DO 500 I=1,OFX
         DO 300 J=1,IRY
            PHT(I,J+OFY) = RAW(1,J)
            PHT(IRX+OFX+I,J+OFY) = RAW(IRX,J)
300      CONTINUE
C
C  Here we also deal with the four corners
C
         DO 400 J=1,OFY
            PHT(I,J) = RAW(1,1)
            PHT(IRX+OFX+I,J) = RAW(IRX,1)
            PHT(I,IRY+OFY+J) = RAW(1,IRY)
            PHT(IRX+OFX+I,IRY+OFY+J) = RAW(IRX,IRY)
400      CONTINUE
500   CONTINUE
C
C  The continuation in Y:
C
      DO 700 I=1,IRX
         DO 600 J=1,OFY
            PHT(I+OFX,J) = RAW(I,1)
            PHT(I+OFX,IRY+OFY+J) = RAW(I,IRY)
600      CONTINUE
700   CONTINUE
C
      RETURN
      END

      SUBROUTINE PSFRES (IPSFX,IPSFY,OPSFX,OPSFY,ZX,ZY,PSFIN,PSF)
C
C       Author: L. Lucy                   ESO - Garching     1988 August
C       Modifications:        D. Baade    ESO - Garching     880930
C
C      The subroutine resamples the user-supplied high-resolution PSF 
C      on the coarser grid of the image to be deconvolved. The array 
C      holding the resulting PSF is four-dimensional because the resampling 
C      is done ZX x ZY times where each time the input PSF is 
C      shifted by 1/ZX and/or 1/ZY as to cover all cases of the 
C      relative positioning of the two PSF grids. 
C
      IMPLICIT NONE
C
      INTEGER   II,JJ,IP,JP,K,L,ZX,ZY,INDX,INDY,IPSFX,IPSFY
      INTEGER   OPSFX,OPSFY,DX,DY,OFFX,OFFY,CX,CY
C
      REAL      PSFIN(IPSFX,IPSFY),PSFBUF,CD,PSF(OPSFX,ZX,OPSFY,ZY)
C
      CD = 1./(ZX*ZY)
      DX = (OPSFX*ZX-IPSFX)/2       ! the excess in width of the resampled PSF
      DY = (OPSFY*ZY-IPSFY)/2      ! is always an even number of small pixels. 
C
C  Shift by one small pixel in X ...
C
      DO 1000 II=1,ZX
         OFFX = II-(ZX+1)/2+DX
C
C  and/or Y
         DO 800 JJ=1,ZY
            OFFY = JJ-(ZY+1)/2+DY
C
C  For all coarse-grid pixels ... 
            DO 600 IP=1,OPSFX
               CX = (IP-1)*ZX
               DO 500 JP=1,OPSFY
                  CY = (JP-1)*ZY
                  PSFBUF = 0.                        ! initialize 
C
C  co-add all fine-grid pixels covered by them at the current offsets
                  DO 400 K=1,ZX
                     INDX = CX+K-OFFX
C
C  Skip fine-grid pixels for which the input-PSF is undefined:
                     IF ( (INDX.LT.1) .OR. (INDX.GT.IPSFX) ) GOTO 400
                     DO 300 L=1,ZY
                        INDY = CY+L-OFFY
                        IF ( (INDY.GE.1) .AND. (INDY.LE.IPSFY) )
     +                     PSFBUF = PSFBUF + PSFIN(INDX,INDY)
300                  CONTINUE
400               CONTINUE 
C 
                  PSF(IP,II,JP,JJ) = PSFBUF*CD
500            CONTINUE
600         CONTINUE
C 
800      CONTINUE
1000  CONTINUE
C
      RETURN
      END

      SUBROUTINE INTEGD(I1X,I1Y,ICX,ICY,ZX,ZY,OPSFX,OPSFY,
     +                  PSF,PSI,PHI)
C
C       Author: L. Lucy                   ESO - Garching     1988 August
C       Modifications: D. Baade           ESO - Garching     880930
C
C      This subroutine maps the current fine-grid guess, PSI, 
C      on to the coarse grid (result in array PHI). The mapping 
C      uses the stack of PSF's that have been constructed by 
C      re-sampling the input PSF onto the coarse grid, i.e. basically 
C      a convolution with the psf is done.
C
      IMPLICIT NONE
C
      INTEGER   ICX,ICY,I1X,I1Y,OPSFX,OPSFY,IMIN,IMAX,JMIN,JMAX
      INTEGER   ID,ID0,ID1,ID2,II,IP,JD,JD0,JD1,JD2,JP,JJ,ZX,ZY
      INTEGER   I,J,CX(10000),CY(10000),RX,RY,RX1,RY1,RX1I,RY1J
      INTEGER   AUXX(2000),AUXY(2000)
C
      REAL      PSF(OPSFX,ZX,OPSFY,ZY),PSI(I1X,I1Y),PHIBUF,PHI(ICX,ICY) 
C
      RX = OPSFX/2                        ! 'radius' of re-sampled PSF, 
      RY = OPSFY/2                        !  full diameter is 2*R+1
      RX1 = RX+1
      RY1 = RY+1
C
C  For all fine pixels, determine X and Y coordinates on the coarse grid.
C  Also, introduce auxiliary array to further save computing time.
C
      DO 100 I=1,I1X
         CX(I) = (I-1)/ZX + 1
         AUXX(I) = (CX(I)-1)*ZX
100   CONTINUE
      DO 200 J=1,I1Y
         CY(J) = (J-1)/ZY + 1
         AUXY(J) = (CY(J)-1)*ZY
200   CONTINUE
C
C  Proceed pixel by pixel on the coarse grid
C
      IMIN = RX1
      IMAX = ICX-RX
      JMIN = RY1
      JMAX = ICY-RY
      ID0 = 1-RX1*ZX
      JD0 = 1-RY1*ZY
C
      DO 2000 I=IMIN,IMAX                         ! pixel of coarse grid
         ID1=ID0+I*ZX
         ID2=(I+RX)*ZX
         RX1I=RX1-I
         DO 1800 J=JMIN,JMAX                   ! pixel of coarse grid
            JD1=JD0+J*ZY
            JD2=(J+RY)*ZY
            RY1J=RY1-J
C
C  Then sum over all relevant pixels in fine grid. the PSF serves as 
C  the weighting function. For a small pixel (II,JJ) within a given large 
C  pixel (I,J) the value PSF(IP,II,JP,JJ) is taken. IP and JP point 
C  to the coarse pixels contributing (via the PSF) to the currently 
C  treated coarse pixel. IP and JP are no absolute coordinates but 
C  rather are the distances of the contributing large pixels from the 
C  large pixel whose flux is just being computed. II and JJ are also 
C  relative indices and only range from 1 to ZX and ZY, respectively.
C
            PHIBUF = 0.                        ! initialize 
C
            DO 1600 ID=ID1,ID2                 ! relevant range in fine grid
               II=ID-AUXX(ID)                  ! position within large pixel
               IP=CX(ID)+RX1I                  ! position of large pixel in PSF
               DO 1500 JD=JD1,JD2              ! relevant range in fine grid 
                  JJ = JD-AUXY(JD)             ! position within large pixel
                  JP = CY(JD)+RY1J             ! position of large pixel in PSF
                  PHIBUF = PHIBUF+PSF(IP,II,JP,JJ)*PSI(ID,JD)  ! off we go
1500           CONTINUE
1600        CONTINUE
            PHI(I,J) = PHIBUF                  ! this coarse bin finished 
C
1800     CONTINUE
2000  CONTINUE
C
C  Now extrapolate solution achieved so far to edges of frame by 
C  constant extrapolation
C
      DO 3000 I=1,RX
         DO 2200 J=JMIN,JMAX
            PHI(I,J)=PHI(IMIN,J)
            PHI(IMAX+I,J)=PHI(IMAX,J)
2200     CONTINUE
         DO 2400 J=1,RY
            PHI(I,J)=PHI(IMIN,JMIN)
            PHI(IMAX+I,J)=PHI(IMAX,JMIN)
            PHI(I,JMAX+J)=PHI(IMIN,JMAX)
            PHI(IMAX+I,JMAX+J)=PHI(IMAX,JMAX)
2400     CONTINUE
3000  CONTINUE
      DO 4000 I =IMIN,IMAX
         DO 3300 J=1,RY
            PHI(I,J)=PHI(I,JMIN)
            PHI(I,JMAX+J)=PHI(I,JMAX)
3300     CONTINUE
4000  CONTINUE
C
      RETURN
      END

      SUBROUTINE INTEGF(I1X,I1Y,ICX,ICY,ZX,ZY,OPSFX,OPSFY,PSF,RT,CF)  
C
C       Author: L. Lucy                   ESO - Garching     1988 August
C       Modifications: D. Baade            ESO - Garching     880930
C
C  Here the correction factors (pixelwise on the fine grid, array CF) 
C  are computed as the PSF-mapped ratio (pixelwise on the coarse grid, 
C  array RT) of the observed image to the result of the last iteration 
C  after its re-sampling on the coarse grid. 
C
      IMPLICIT NONE 
C
      INTEGER   I,J,I1X,I1Y,ICX,ICY,II,ID1,ID2,IMIN,IMAX,JMIN,JMAX
      INTEGER   JJ,JD1,JD2,ID,IP,JD,JP,OPSFX,OPSFY,ZX,ZY,RX,RY
      INTEGER   CX(10000),CY(10000),AUXX1(10000),AUXY1(10000)
      INTEGER   AUXX2(10000),AUXY2(10000)
C
      REAL      PSF(OPSFX,ZX,OPSFY,ZY),CF(I1X,I1Y),RT(ICX,ICY)
      REAL      CFBUF
C
      RX=OPSFX/2                        ! 'radius' of coarse PSF, 
      RY=OPSFY/2                        ! full diameter is 2*R+1
C
      IMIN=RX*ZX+1
      IMAX=I1X-RX*ZX
      JMIN=RY*ZY+1
      JMAX=I1Y-RY*ZY
C
C  Determine for all fine pixels coordinates on coarse grid (taking 
C  into account that the input frame has been enlarged). 
C  Also, introduce auxiliary arrays to further reduce computing time. 
C
      DO 100 I=IMIN,IMAX
         CX(I)=(I-1)/ZX+1                  ! X-coordinates on coarse grid 
         AUXX1(I)=RX-CX(I)+1
         AUXX2(I)=(CX(I)-1)*ZX
100   CONTINUE
      DO 200 J=JMIN,JMAX
         CY(J)=(J-1)/ZY+1                  ! Y-coordinates on coarse grid
         AUXY1(J)=RY-CY(J)+1
         AUXY2(J)=(CY(J)-1)*ZY
200   CONTINUE
C
      DO 1000 I=IMIN,IMAX                        ! pixel on fine grid
         II=I-AUXX2(I)                  ! pixel-# within coarse pixel
         ID1=CX(I)-RX
         ID2=CX(I)+RX
C
         DO 900 J=JMIN,JMAX                  ! pixel on fine grid
            JJ=J-AUXY2(J)                  ! pixel-# within coarse pixel
            JD1=CY(J)-RY
            JD2=CY(J)+RY
C
            CFBUF = 0.                     ! initialize 
C
            DO 800 ID=ID1,ID2                  ! relevant coarse-grid pixels 
               IP=AUXX1(I)+ID                  ! X-position within coarse PSF
               DO 700 JD=JD1,JD2                  ! relevant coarse-grid pixels 
                  JP=AUXY1(J)+JD            ! Y-position within coarse PSF
                  CFBUF=CFBUF+PSF(IP,II,JP,JJ)*RT(ID,JD)      ! the correction
700            CONTINUE
800         CONTINUE
            CF(I,J) = CFBUF
C
C  At this point the corrections for fine-grid pixel (I,J) to the 
C  ratios at positions (ID,JD) on the coarse grid have been fully 
C  evaluated for all pixels (ID,JD) concerned by pixel (I,J). 
C
900      CONTINUE
1000  CONTINUE
C
C  Fill up rest of frame by constant extrapolation of the edges
C
      DO 2000 I=1,RX*ZX
         DO 1100 J=JMIN,JMAX
            CF(I,J)=CF(IMIN,J)
            CF(IMAX+I,J)=CF(IMAX,J)
1100     CONTINUE
         DO 1200 J=1,RY*ZY
            CF(I,J)=CF(IMIN,JMIN)
            CF(IMAX+I,J)=CF(IMAX,JMIN)
            CF(I,JMAX+J)=CF(IMIN,JMAX)
            CF(IMAX+I,JMAX+J)=CF(IMAX,JMAX)
1200     CONTINUE
2000  CONTINUE
      DO 3000 I =IMIN,IMAX
         DO 2500 J=1,RY*ZY
            CF(I,J)=CF(I,JMIN)
            CF(I,JMAX+J)=CF(I,JMAX)
2500     CONTINUE
3000  CONTINUE
C
      RETURN
      END

      SUBROUTINE TRUNC(PSI,OUT,I1X,I1Y,IOX,IOY,OFF,ZX,ZY) 
C
C  This subroutine truncates the result frame such as to correspond 
C  to the true dimensions (in world coordinates) of the input frame.
C
      IMPLICIT NONE
C
      INTEGER   I1X,I1Y,IOX,IOY,I,J,IQ,JQ,OFF(2),ZX,ZY,OFX,OFY
C
      REAL      PSI(I1X,I1Y),OUT(IOX,IOY)
C
      OFX = OFF(1)*ZX
      OFY = OFF(2)*ZY
C
      DO 100 I=1,IOX
         IQ=I+OFX
         DO 50 J=1,IOY
            JQ = J+OFY
            OUT(I,J) = PSI(IQ,JQ)
50       CONTINUE
100   CONTINUE
C
      RETURN
      END

C @(#)starsa.for	19.1 (ES0-DMD) 02/25/03 13:25:40
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C-----------------------------------------------------------------------
      SUBROUTINE STARSA(IOPC, AS, JAPYS, IBUFS, I,
     &                  J, LPXL, LSBP, NCT, PMT,
     &                  PRC, APSF, FPSF, NPAS, SCALE,
     &                  CINT)
C
      IMPLICIT  NONE
      INCLUDE   'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER   IOPC               ! IN: -1 subtract , 1 add
      REAL      AS(1)              ! MOD: Data array
      INTEGER   JAPYS(1)           ! IN: Pointers to data lines
      INTEGER   IBUFS(4)           ! IN: Limits of data region
      INTEGER   I                  ! IN: Object x coordinate
      INTEGER   J                  ! IN: Object y coordinate
      INTEGER   LPXL               ! IN: Pixels extend
      INTEGER   LSBP               ! IN: Subpixels extend
      INTEGER   NCT(NIPAR)         ! IN: Component integer parameters
      REAL      PMT(NRPAR)         ! IN: Component real parameters
      REAL      PRC(0:MAXSUB)      ! IN: Object profile
      REAL      APSF(0:MAXSUB)     ! IN: One dimensional p.s.f.
      REAL      FPSF(1)            ! IN: Two dimensional p.s.f.
      INTEGER   NPAS               ! IN: Iteration count
      REAL      SCALE              ! IN: Central point scaling
      REAL      CINT               ! OUT: Component contribution
C
      INTEGER   IADR , IADR0 , IARG , IDIS , IK , IK1 , IK2 , IN , IS
      INTEGER   JADR , JK , JK1 , JK2 , JN , JOFF , JOFS , JS
      INTEGER   KSAT , LN , MPXL , MPXL2 , MSBP
C
      REAL   ADIS , AI , AJ , ATMP , CORR , DIST , SCA
C
      LOGICAL   CENTER , UNDER
C     LOGICAL   CENTR
C
      CINT = 0.0
      IN = NCT(1)
      JN = NCT(2)
      LN = NCT(5)
      KSAT = NCT(6)
      IK1 = MAX( IN-LN , IBUFS(1)+I )
      IK2 = MIN( IN+LN , IBUFS(3)+I )
      JK1 = MAX( JN-LN , IBUFS(2)+J )
      JK2 = MIN( JN+LN , IBUFS(4)+J )
      AI = PMT(10)
      AJ = PMT(11)
      IF ( NPAS .GT. 2 ) THEN
          SCA = PMT(12)
      ELSE
          IF ( KSAT .EQ. -1 ) THEN
              SCA = SCALE * PMT(2)
          ELSE
              ATMP = APSF(KSAT+2)
              IF ( ATMP .GT. 0.0 ) THEN
                  SCA = PRC(KSAT+2) / ATMP
              ELSE
                  SCA = 0.0
              ENDIF
          ENDIF
      ENDIF
C
      MPXL = 2 * LPXL + 1
      MSBP = 2 * LSBP + 1
      MPXL2 = MPXL * MPXL
C
      IF ( LPXL .GT. 0 .OR. LSBP .GT. 0 ) THEN
          UNDER = .TRUE.
          IS = NINT( ( AI - FLOAT(IN) ) * FLOAT(MSBP) )
          JS = NINT( ( AJ - FLOAT(JN) ) * FLOAT(MSBP) )
          IF ( IS .LT. (-LSBP) ) THEN
              IS = -LSBP
          ELSE IF ( IS .GT. LSBP ) THEN
              IS = LSBP
          ENDIF
          IF ( JS .LT. (-LSBP) ) THEN
              JS = LSBP
          ELSE IF ( JS .GT. LSBP ) THEN
              JS = LSBP
          ENDIF
          IADR0 = ( (LSBP+JS) * MSBP + LSBP + IS ) * MPXL2 +
     &                   LPXL * (MPXL+1) + 1
      ELSE
          UNDER = .FALSE.
      ENDIF
C
      JOFF = J + IBUFS(2) - 1
      DO 40 JK = JK1 , JK2
          IF ( UNDER .AND. IABS(JK-JN) .LE. LPXL ) THEN
              CENTER = .TRUE.
              JADR = IADR0 + (JK-JN)*MPXL
          ELSE
              CENTER = .FALSE.
          ENDIF
          JOFS = JAPYS(JK-JOFF) - I
          DO 50 IK = IK1 , IK2
              IF ( CENTER .AND. IABS(IK-IN) .LE. LPXL ) THEN
                  IADR = JADR + IK-IN
                  CORR = FPSF(IADR) * SCA
              ELSE
                  DIST = SQRT( (AI-FLOAT(IK))**2.0 +
     &                              (AJ-FLOAT(JK))**2.0 )
                  IDIS = INT( DIST )
                  ADIS = DIST - IDIS
                  CORR = ( APSF(IDIS)*(1.0-ADIS) +
     &                             APSF(IDIS+1)*ADIS ) * SCA
              ENDIF
              IARG = JOFS + IK
              IF ( IOPC .EQ. -1 ) THEN
                  AS(IARG) = AS(IARG) - CORR
              ELSE IF ( IOPC .EQ. 1 ) THEN
                  AS(IARG) = AS(IARG) + CORR
              ENDIF
              IF ( JK .EQ. J .AND. IK .EQ. I ) THEN
                  CINT = CORR
              ENDIF
   50     CONTINUE
   40 CONTINUE
C
      RETURN
C
      END

C @(#)fndedg.for	19.1 (ES0-DMD) 02/25/03 14:01:06
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FNDEDG(METHOD,A,NX,NY,THR,E)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C
C  subroutine FNDEDG		version 1.00	880912
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C
C  edge detection
C
C.PURPOSE
C
C  find edges in a frame
C
C.ALGORITHM
C
C  method = Band, see Gonzalez + Wintz: "Digital Image Processing", chapter 7
C         = Sobel, see Pratt: "Digital Image Processing", chapter 17.4.2
C
C.INPUT/OUTPUT
C
C  call as FNDEDG(METHOD,A,NX,NY,THR,E)
C
C  input par:
C  METHOD:	char. exp.	method for edge detection
C				= B, compare neighbours "above" + "behind"
C				= S, use Sobel 3x3 edge operator
C  A:		R*4 array	input data frame
C  NX:		I*4		no. of rows
C  NY:		I*4		no. of columns
C  THR:		R*4		threshold for different bands
C
C  output par:
C  E:		R*4 array	output frame
C
C.VERSIONS
C  1.00		from version 2.02 as of 830506
C  		move to FORTRAN 77 + new St interfaces
C 
C--------------------------------------------------
C
      IMPLICIT NONE
C 
      CHARACTER*(*)   METHOD
C 
      REAL        THR,A(*),E(*)
      REAL        X1,Y1,X2,Y2,XGRAD,YGRAD,C1,C2
C 
      INTEGER     NX,NY
      INTEGER     NIN,NOUT
      INTEGER     OFF,ABOVE,BELOW
C      
C  branch on method
      IF (METHOD(1:1).EQ.'S') GOTO 5000
C
C  handle 1. line specially
      E(1) = 0.0
      C1 = A(1)
C 
      DO 400 NIN=2,NX
         C2 = A(NIN)
         IF (C1.LT.THR) THEN
            IF (C2.GE.THR) THEN
               E(NIN) = 1.0
            ELSE
               E(NIN) = 0.0
            ENDIF
         ELSE
            IF (C2.LT.THR) THEN
               E(NIN) = 1.0
            ELSE
               E(NIN) = 0.0
            ENDIF
         ENDIF
         C1 = C2
400   CONTINUE
C
C  for the other lines look for edges "behind" + "above"
C 
      OFF = NX + 1
      DO 1000 NOUT=2,NY
         E(OFF) = 0.0
         C1 = A(OFF)
C
C  1. inner loop along each row
         DO 600 NIN=OFF+1,NOUT*NX
            C2 = A(NIN)
            IF (C1.LT.THR) THEN
               IF (C2.GE.THR) THEN
                  E(NIN) = 1.0
               ELSE
                  E(NIN) = 0.0
               ENDIF
            ELSE
               IF (C2.LT.THR) THEN
                  E(NIN) = 1.0
               ELSE
                  E(NIN) = 0.0
               ENDIF
            ENDIF
            C1 = C2
600      CONTINUE
C  
C  2. inner loop along two adjacent rows
         DO 800 NIN=OFF,NOUT*NX
            C1 = A(NIN-NX)
            C2 = A(NIN)
            IF (C1.LT.THR) THEN
               IF (C2.GE.THR) E(NIN) = 1.0
            ELSE
               IF (C2.LT.THR) E(NIN) = 1.0
            ENDIF
800      CONTINUE
C
         OFF = OFF + NX
1000  CONTINUE
C
C  that's it folks...
      RETURN
C      
C ------------------------------------------------------
C      
C  use Sobel edge detector: 1  2  1  for y-gradient and 1  0 -1 for x-gradient
C                           0  0  0                     2  0 -2
C                          -1 -2 -1                     1  0 -1
C  grad = abs(grady) + abs(gradx)
C      
C ------------------------------------------------------
C      
C    handle 1. line specially...
5000  E(1) = 0.0
      E(NX) = 0.0
C 
      DO 5400 NIN=2,NX-1
         XGRAD = ABS(A(NIN-1)-A(NIN+1))
         IF (XGRAD.GT.THR) THEN
            E(NIN) = 1.0
         ELSE
            E(NIN) = 0.0
         ENDIF
CCC         E(NIN) = XGRAD
5400  CONTINUE
C      
C  handle last line specially...
      OFF = (NY-1)*NX + 1
      E(OFF) = 0.0
      E(NX*NY) = 0.0
C 
      DO 5600 NIN=OFF+1,OFF+NX-1
         XGRAD = ABS(A(NIN-1)-A(NIN+1))
         IF (XGRAD.GT.THR) THEN
            E(NIN) = 1.0
         ELSE
            E(NIN) = 0.0
         ENDIF
CCC         E(NIN) = XGRAD
5600  CONTINUE
C      
C  now work on the "safe" part of the image
      OFF = NX
      DO 7000 NOUT=2,NY-1
         ABOVE = OFF + NX
         BELOW = OFF - NX
         E(OFF+1) = 0.0
         E(OFF+NX) = 0.0
C      
         DO 6000 NIN = 2,NX-1
            X1 = A(BELOW+NIN-1) + 2.*A(OFF+NIN-1) + A(ABOVE+NIN-1)
            X2 = A(BELOW+NIN+1) + 2.*A(OFF+NIN+1) + A(ABOVE+NIN+1)
            XGRAD = ABS(X1-X2)
            Y1 = A(BELOW+NIN-1) + 2.*A(BELOW+NIN) + A(BELOW+NIN+1)
            Y2 = A(ABOVE+NIN-1) + 2.*A(ABOVE+NIN) + A(ABOVE+NIN+1)
            YGRAD = ABS(Y1-Y2)
            IF (MAX(XGRAD,YGRAD).GT.THR) THEN
               E(NIN+OFF) = 1.0
            ELSE
               E(NIN+OFF) = 0.0
            ENDIF
CCC            E(NIN) = XGRAD+YGRAD
6000     CONTINUE
C  
         OFF = OFF + NX
7000  CONTINUE
C
C  that's it folks...
      RETURN
      END

C @(#)lsfun1t.for	19.1 (ES0-DMD) 02/25/03 13:17:40
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE LSFU1T(NRRES,NRPRM,PRM,FCTVEC)                               
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++        
C                                                                               
C.MODULE                                                                        
C       FIT                                                                     
C                                                                               
C.NAME                                                                          
C       LSFUN1_T                                                                
C                                                                               
C.PURPOSE                                                                       
C       Function to compute the approximating function at each point,           
C       for FIT/TABLE                                                           
C                                                                               
C.KEYWORDS                                                                      
C       Approximating Function.                                                 
C                                                                               
C.DESCRIPTION                                                                   
C       Read the TABLE row by row, and compute the fitting function by          
C       calling MIDAS functions                                                 
C                                                                               
C.LANGUAGE                                                                      
C       FORTRAN                                                                 
C                                                                               
C.CALLING SEQUENCE                                                              
C      CALL LSFUN1_T(NRRES,NRPRM,PRM,FCTVEC)                                    
C                                                                               
C.INPUT PARAMETERS                                                              
C       NRRES               INTEGER  Number of residuals                        
C       NRPRM             INTEGER  Number of parameters                         
C       PRM (NRPRM)       DOUBLE   Parameters                                   
C                                                                               
C.MODIFIED PARAMETERS                                                           
C       none                                                                    
C                                                                               
C.OUTPUT PARAMETERS                                                             
C       FCTVEC (NRRES)      DOUBLE   Approximating values                       
C                                                                               
C.FILES                                                                         
C       FIT_NAG.INC/NOLIST                                                      
C                                                                               
C.MODULES CALLED                                                                
C       FTFUNC                                                                  
C                                                                               
C.AUTHOR                                                                        
C       Ph. DEFERT,      Feb 1986                                               
C       M. Peron     apr 92 fit on tables for Apollo and VAX                   
C.MODIFICATIONS                                                                 
C                                                                               
C                                                                               
C-----------------------------------------------------------------------        
C                                                                               
C      IMPLICIT NONE                                                            
C     .. Scalar Arguments ..                                                    
      INTEGER NRPRM,NRRES                                                       
C     ..                                                                        
C     .. Array Arguments ..                                                     
      DOUBLE PRECISION FCTVEC(NRRES),PRM(NRPRM)                                 
C     ..                                                                        
C     .. Scalars in Common ..                                                   
      INTEGER NRCOL,ISTAR                                                       
      CHARACTER WGTTYP*1                                                        
C     ..                                                                        
C     .. Arrays in Common ..                                                    
      INTEGER ICOL(10),ACOL,AROW                                          
C     ..                                                                        
C     .. Local Scalars ..                                                       
      DOUBLE PRECISION W,Y,Y1,YOUT,YY                                           
      INTEGER IDAT,IFUN,IPNT,ISTAT,K,NC,NROW,NS,BEGFCT,IP                       
      LOGICAL ISEL,VALID                                                        
C     ..                                                                        
C     .. Local Arrays ..                                                        
      DOUBLE PRECISION DUMMY(10)                                                
      REAL XVAL(10),X(10)                                                       
      LOGICAL NULL(10)                                                          
C     ..                                                                        
C     .. Common blocks ..                                                       
C     ..                                                                        
C     .. External Files ..                                                      
       INCLUDE 'MID_INCLUDE:FITNAGI.INC/NOLIST'                                 
       INCLUDE 'MID_INCLUDE:FITNAGC.INC/NOLIST'                                 
      COMMON /LSQFUN/ICOL,NRCOL,ISTAR,WGTTYP                                    
C     ..                                                                        
C     .. Executable Statements ..                                               
C                                                                               
C  deal with linear simple constraints                                          
C                                                                               
      DO 10 K = 1,NRPRM                                                         
          IP     = FIXPAR(K)                                                    
          IF (IP.EQ.0) PRM(K) = PARINI(K)                                       
          IF (IP.GT.0) THEN                                                     
              PRM(K) = PRM(IP)*PRPFAC(K)                                        
              PARAM(K) = PRM(K)                                                 
          END IF                                                                
                                                                                
   10 CONTINUE                                                                  
C                                                                               
C  Go through the table                                                         
C                                                                               
      CALL TBIGET(FZIDEN,NC,NROW,NS,ACOL,AROW,ISTAT)                    
      IPNT   = 0                                                                
      DO 50 IDAT = 1,NROW                                                       
          CALL TBSGET(FZIDEN,IDAT,ISEL,ISTAT)                                   
          IF ( .NOT. ISEL) GO TO 50                                             
          CALL TBRRDR(FZIDEN,IDAT,NRCOL,ICOL(ISTAR),XVAL(ISTAR),          
     +                NULL(ISTAR),ISTAT)                                      
          VALID  = ISEL                                                         
          DO 20 K = 1,NRCOL                                                     
              VALID  = VALID .AND. ( .NOT. NULL(K+ISTAR-1))                             
   20     CONTINUE                                                              
          IF ( .NOT. VALID) GO TO 50                                            
          Y      = XVAL(2)                                                      
          W      = XVAL(1)                                                      
          DO 30 K = 1,NRCOL                                                     
              X(K)   = XVAL(K+2)                                                
   30     CONTINUE                                                              
C                                                                               
C  Compute the weighting factors                                                
C                                                                               
          IF (WGTTYP(1:1).NE.'W') THEN                                          
              IF (WGTTYP(1:1).EQ.'C') THEN                                      
                  W      = 1.                                                   
                                                                                
              ELSE IF (WGTTYP(1:1).EQ.'S') THEN                                 
                  YY     = ABS(Y)                                               
                  IF (YY.LT.1.E-12) THEN                                        
                      W      = 1.                                               
                                                                                
                  ELSE                                                          
                      W      = 1./YY                                            
                  END IF                                                        
                                                                                
              ELSE IF (WGTTYP(1:1).EQ.'I') THEN                                 
                  W      = 1./W**2                                              
                                                                                
              END IF                                                            
                                                                                
          END IF                                                                
C                                                                               
C  Compute the fitting values                                                   
C                                                                               
          Y1     = 0.D0                                                         
          BEGFCT = 1                                                            
          DO 40 IFUN = 1,NRFUN                                                  
              CALL FTFUNC(FCTCOD(IFUN),NRIND,X,ACTPAR(IFUN),PRM(BEGFCT),        
     +                    YOUT,DUMMY)           
              Y1     = Y1 + YOUT                                                
              BEGFCT = BEGFCT + ACTPAR(IFUN)                                    
   40     CONTINUE                                                              
          IPNT   = IPNT + 1                                                     
          FCTVEC(IPNT) = SQRT(W)* (Y1-Y)                                        
   50 CONTINUE                                                                  
      RETURN                                                                    
                                                                                
      END                                                                       

C @(#)mtablv.for	19.1 (ESO-DMD) 02/25/03 13:24:28
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENT:    program MTABLV                             A. Lauberts  ESO  890713
C.KEYWORDS: ESOLV data base evaluation, table file, diameter
C.PURPOSE:  get semidiameter for specified magnitude interpolated
C           from photometric parameters stored in ESOLV table file
C.USAGE:    MIDAS application program
C           execute as @@ MTABLV P1 P2 P3 P4 P5
C.PARAMETERS:
C           P1  PCAT   C*12  name of input table file; default PCAT
C           P2  MCOL   I     col no of 1st mag value in array of max 13 elems
C           P3  TCOL   I     col no of reference mag (normally total mag)
C           P4  FRAC   R     fractional (total) light wanted
C           P5  FCOL   I     col no of output semidiameter corresp to FRAC
C.OUTPUT:   semidiameter in column no FCOL
C.COMMENTS: Undefined semidiameters are set to NULL.
C           Algorithm tested against ESOLV values at 50% total light;
C           systematic difference about 1% in radius is due to different
C           interpolation techniques.
C.NOTE:     Uses MATHLIB rotines E01BAF and E02BCF.
C.VERSION:  910207 RHW IMPLICIT NONE added
C-----------------------------------------------------------------------------
       PROGRAM MTABLV
C
       IMPLICIT     NONE
       INTEGER      ACOL, AROW
       INTEGER      COL(256)
       INTEGER      FCOL
       INTEGER      I, IACT, ISTAT
       INTEGER      IFAIL
       INTEGER      J
       INTEGER      KNUL,KUN
       INTEGER      MADRID(1)
       INTEGER      M,MCOL
       INTEGER      NCOL, NROW, NSC, NSEQ
       INTEGER      TCOL
       INTEGER      TID
       INTEGER      TINULL
C
       DOUBLE PRECISION TDNULL
       REAL         FRAC
       REAL         MAG
       REAL         LMD     
       REAL         ROW(256)
       REAL         SMD
       REAL         TRNULL
C
       LOGICAL      NULL(256)
C
       CHARACTER*60 PCAT
       CHARACTER*80 STRING
       CHARACTER*60 TABLE
C
       INCLUDE      'MID_INCLUDE:ST_DEF.INC/NOLIST'
       COMMON       /VMR/MADRID
       INCLUDE      'MID_INCLUDE:ST_DAT.INC/NOLIST'
C
C *** start 
       CALL STSPRO('MTABLV')
C
       DO I=1,256
         COL(I) = I
       ENDDO
C
C  get keywords
       CALL STKRDC('IN_A',1,1,60,IACT,PCAT,KNUL,KUN,ISTAT)
       CALL STKRDI('INPUTI',1,1,IACT,MCOL,KNUL,KUN,ISTAT)
       CALL STKRDI('INPUTI',2,1,IACT,TCOL,KNUL,KUN,ISTAT)
       CALL STKRDI('INPUTI',3,1,IACT,FCOL,KNUL,KUN,ISTAT)
       CALL STKRDR('INPUTR',1,1,IACT,FRAC,KNUL,KUN,ISTAT)
       CALL TBMNUL(TINULL,TRNULL,TDNULL)
C
       FRAC = 2.5*ALOG10(FRAC)
       IF (FCOL.LT.183.OR.FCOL.GT.189) THEN
          STRING = '*** FATAL: Output column not in scratch '//
     2             'interval 183-189'
          CALL STTPUT(STRING,ISTAT)
          CALL STSEPI
       ENDIF
       M = 0
C
C open PCAT table file; don't count last (ascii) column
       CALL TBTOPN(TABLE,F_IO_MODE,TID,ISTAT)
       CALL TBIGET(TID,NCOL,NROW,NSC,ACOL,AROW,ISTAT)
       NCOL = NCOL-1
C
C read PCAT
       DO NSEQ=1,NROW
          M=M+1
          IF (M.EQ.1000) THEN
             M=0
C             WRITE(6,*) NSEQ
          ENDIF
          CALL TBRRDR(TID,NSEQ,NCOL,COL,ROW,NULL,ISTAT)
          IF (.NOT.NULL(TCOL)) THEN
             MAG = ROW(TCOL)-FRAC
             DO I=1,13
                J = MCOL+I-1
                IF (NULL(J)) ROW(J)=-99.
             ENDDO
             CALL IPOL(ROW(MCOL),MAG,LMD,IFAIL)
             IF (IFAIL.EQ.0) THEN
                SMD = 0.5*10.**LMD
             ELSE
                SMD = TRNULL
             ENDIF
          ELSE
             SMD = TRNULL
          ENDIF
          CALL TBEWRR(TID,NSEQ,FCOL,SMD,ISTAT)
       ENDDO
C
C *** finish
       CALL TBTCLO(TID,ISTAT)
       CALL STSEPI
       END



       SUBROUTINE IPOL(AC,MAG,LMD,IFAIL)
C+
C.IDENT:    subroutine IPOL                            A. Lauberts  ESO  881216
C.KEYWORDS  galaxy photometry, database
C.PURPOSE:  extracts interpolated photom data from table file
C.USAGE:    MIDAS application subroutine called from MTABLV
C.PARAMETERS (arguments)
C           input:
C           AC    R   array    magnitudes in 1 to 13 element
C           MAG   R            magnitude
C           output:
C           LMD   R            log major diam corresp to MAG
C           other:
C           DL    R   array    log major diameters
C           BM    R   array    magnitudes
C-
      IMPLICIT         NONE
      REAL             AC(1)
      REAL             MAG
      REAL             LMD
      INTEGER          IFAIL
C
      INTEGER          K
      INTEGER          LCK
      INTEGER          LWRK
      INTEGER          N
      INTEGER          NB
C
      REAL             A
      REAL             BM(13)
      REAL             DL(13)
      REAL             X, X0, X1
      DOUBLE PRECISION CIB(17)
      DOUBLE PRECISION KIB(17)
      DOUBLE PRECISION KLA(13)
      DOUBLE PRECISION KBM(13)
      DOUBLE PRECISION SDIF(4)
      DOUBLE PRECISION WRK(94)
      DOUBLE PRECISION XX
C
      X=1.
      N=0
      DO K=1,13
         IF (AC(K).NE.-99.) THEN
            N=N+1
            DL(N)=X
            BM(N)=AC(K)
         ENDIF
         X=X+0.2
      ENDDO
C
C fill KLA and KBM with data; skip if MAG outside interval or N < 2
C
      IF (MAG.LT.BM(N).OR.MAG.GT.BM(1)) THEN
         IFAIL=1
         CALL FAIL(IFAIL)
         RETURN
      ENDIF
      IF (N.LT.2) THEN
         IFAIL=2
         CALL FAIL(IFAIL)
         RETURN
      ENDIF
      NB=N
      CALL PREPARE(NB,DL,BM,KLA,KBM)
C+
C interpolate with cubic splines on B mags
C (if N<4 then linear or parabolic interpol only,
C  if N=1 then skip interpolation)
C the independent variable is log a, a = major diam
C arr  dim      contains
C input:
C KLA  13       log a
C KBM  13       B integr mag
C output:
C KIB  17       =KBM + 4 extra points
C CIB  17       cubic spline coeffs for KBM
C SDIF  4       value + first three derivatives
C i/o:
C WRK  94       work area for cubic splines
C-
C interpol coeffs
C
      LCK=NB+4
      LWRK=6*NB+16
      IFAIL=0
      IF (NB.GT.3) THEN
         CALL E01BAF(NB,KLA,KBM,KIB,CIB,LCK,WRK,LWRK,IFAIL)
      ELSE
         CALL NEWTON1(NB,KLA,KBM,CIB,IFAIL)
      ENDIF
      IF (IFAIL.NE.0) THEN
        CALL FAIL(IFAIL)
        RETURN
      ENDIF
C
C  value (derivatives not used) found by bisection method
C  return if mag error < 0.01 or no of iterations > 20 (failed)
C
      X0=KLA(1)
      X1=KLA(NB)
      IFAIL=0
      N=0
10    N=N+1
      X=(X0+X1)/2.
      XX=X
      IF (NB.GT.3) THEN
         CALL E02BCF(NB+4,KIB,CIB,XX,0,SDIF,IFAIL)
      ELSE
         CALL NEWTON2(NB,KLA,CIB,XX,SDIF)
      ENDIF
      IF (IFAIL.NE.0.) THEN
         CALL FAIL(IFAIL)
         RETURN
      ENDIF
      A=SDIF(1)
      IF (ABS(A-MAG).LT.0.001) THEN
         LMD=X
         RETURN
      ELSE IF(N.GT.20) THEN
         IFAIL=20
         CALL FAIL(IFAIL)
         RETURN
      ENDIF
      IF (A.LT.MAG) THEN
         X1=X
      ELSE
         X0=X
      ENDIF
      GOTO 10
      END



      SUBROUTINE NEWTON1(N,KLA,KBM,CIB,IFAIL)
C+
C  Newtons interpolation formulas for 2 and 3 points (1st and 2nd degree)
C     P1(X) = FX0 + (X-X0)*(FX1-FX0)/(X1-X0)
C           = CIB(1) + (X-X0)*CIB(2)
C       P1' = CIB(2)
C
C     P2(X) = FX0 + (X-X0)*(FX1-FX0)/(X1-X0) +
C             (X-X0)*(X-X1)*((FX2-FX1)/(X2-X1)-(FX1-FX0)/(X1-X0))/(X2-X0)
C           = CIB(1) + (X-X0)*CIB(2) + (X-X0)*(X-X1)*CIB(3)
C       P2' = CIB(2) + (2X-X0-X1)*CIB(3)
C       P2''= 2*CIB(3) 
C
C determine coefficients CIB for later use in NEWTON2
C case N=2: linear interpolation
C-
      IMPLICIT NONE
      INTEGER  N
      DOUBLE PRECISION  KLA(13)
      DOUBLE PRECISION  KBM(13)
      DOUBLE PRECISION  CIB(3)
      DOUBLE PRECISION  X0,X1,X2,FX0,FX1,FX2
      INTEGER  IFAIL
C
      IF (N.EQ.2) THEN
         X0=KLA(1)
         X1=KLA(2)
         FX0=KBM(1)
         FX1=KBM(2)
         IF (FX0.LT.FX1) THEN
            IFAIL=-2
            RETURN
         ENDIF
         CIB(1)=FX0
         CIB(2)=(FX1-FX0)/(X1-X0)
         RETURN
      ENDIF
C case N=3: parabolic interpolation
      IF (N.GE.3) THEN
         X0=KLA(1)
         X1=KLA(2)
         X2=KLA(3)
         FX0=KBM(1)
         FX1=KBM(2)
         FX2=KBM(3)
         IF (FX0.LT.DMIN1(FX1,FX2)) THEN
            IFAIL=-3
            RETURN
         ENDIF
         CIB(1)=FX0
         CIB(2)=(FX1-FX0)/(X1-X0)
         CIB(3)=((FX2-FX1)/(X2-X1)-CIB(2))/(X2-X0)
         RETURN
      ENDIF
      END



      SUBROUTINE NEWTON2(N,KLA,CIB,X,SDIF)
C+
C  using coeffs CIB from NEWTON1
C  output value + derivatives to SDIF array
C-
      INTEGER           N
      DOUBLE PRECISION  KLA(13)
      DOUBLE PRECISION  CIB(3)
      DOUBLE PRECISION  SDIF(4)
      DOUBLE PRECISION  X,X0,X1
C
      IF (N.EQ.2) THEN
         X0=KLA(1)
         SDIF(1)=CIB(1)+(X-X0)*CIB(2)
         SDIF(2)=CIB(2)
         SDIF(3)=0.
         SDIF(4)=0.
         RETURN
      ENDIF
      IF (N.GE.3) THEN
         X0=KLA(1)
         X1=KLA(2)
         SDIF(1)=CIB(1)+(X-X0)*(CIB(2)+(X-X1)*CIB(3))
         SDIF(2)=CIB(2)+(X*2.-X0-X1)*CIB(3)
         SDIF(3)=CIB(3)*2.
         SDIF(4)=0.
         RETURN
      ENDIF
      END



      SUBROUTINE PREPARE(NB,DL,BM,KLA,KBM)
C
      IMPLICIT   NONE
      INTEGER    NB
      REAL       DL(1)
      REAL       BM(1)
      DOUBLE PRECISION KLA(13)
      DOUBLE PRECISION KBM(13)
C
      INTEGER    I
C
      DO I=1,NB
         KBM(I)=BM(I)
         KLA(I)=DL(I)
      ENDDO
      END



      SUBROUTINE FAIL(IFAIL)
      IMPLICIT      NONE
      INTEGER       IFAIL
C
      INTEGER       ISTAT
      CHARACTER*80  STRING
C
  100 FORMAT('*** WARNING: IPOL--->IFAIL=',I2)

      WRITE(STRING,100) IFAIL
      CALL STTPUT(STRING,ISTAT)
      END

C @(#)fttabl.for	19.1 (ES0-DMD) 02/25/03 13:17:37
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FTTABL(NAME,DVAR,IVAR,ISTAT)                                   
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                   
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:25 - 13 JAN 1988                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C.IDENTIFICATION                                                                
C                                                                               
C  FITLIB.FOR   VERSION 1.0  27 MAR 1984                                        
C                                                                               
C.PURPOSE                                                                       
C                                                                               
C  INTERFACE ROUTINES FOR THE FITTING STRUCTURES                                
C INITIALIZE DATA STRUCTURE TO FIT TABLE DATA                                   
C VARIABLES ARE COLUMNS IN A TABLE                                              
C                                                                               
C.ALGORITHM                                                                     
C                                                                               
C  USE MIDAS I/O INTERFACES TO FRAMES AND TABLES                                
C                                                                               
C.KEYWORDS                                                                      
C                                                                               
C  NON LINEAR FITTING                                                           
C                                                                               
C                                                                               
C----------------------------------------------------------------               
C                                                                               
C                                                                               
C INPUT PARAMETERS                                                              
C NAME CHAR TABLE NAME                                                          
C DVAR CHAR COLUMN ACTING AS DEPENDENT VARIABLE                                 
C   AND OPTIONAL ERROR COLUMN                                                   
C IVAR CHAR COLUMNS ACTING AS IND.VARS                                          
C                                                                               
C OUTPUT PARAMETERS                                                             
C ISTAT INTG STATUS RETURN                                                      
C                                                                               
      INTEGER ISTAT,IND1,IND2,I,KZ6904
      CHARACTER*(*) NAME,DVAR,IVAR                                              
      CHARACTER*80 LINE,LINE1                                                   
      CHARACTER*17 LAB1,LAB2                                                    
      LOGICAL NEXT                                                              
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
       INCLUDE 'MID_INCLUDE:FITI.INC/NOLIST'                                     
       INCLUDE 'MID_INCLUDE:FITC.INC/NOLIST'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'                                     
C                                                                               
C READ TABLE                                                                    
C                                                                               
      CALL TBTOPN(NAME,F_IO_MODE,FZIDEN,ISTAT)                                                   
C                                                                               
C LAB1 CONTAINS THE COLUMN ACTING AS DEP VAR                                    
C LAB2 OPTIONAL WEIGHT                                                          
C                                                                               
      IND1   = INDEX(DVAR,',')                                                  
      IND2   = INDEX(DVAR,' ')                                                  
      IF (IND1.EQ.0) THEN                                                       
          LAB1   = DVAR(1:IND2-1)                                               
          LAB2   = ' '                                                          
                                                                                
      ELSE                                                                      
          LAB1   = DVAR(1:IND1-1)                                               
          LAB2   = DVAR(IND1+1:IND2-1)                                          
      END IF                                                                    
                                                                                
      CALL TBCSER(FZIDEN,LAB1,FZDVAR,ISTAT)                                     
      IF (FZDVAR.EQ.-1) THEN                                                  
          ISTAT  = FERPAR                                                   
          RETURN                                                                
                                                                                
      END IF                                                                    
                                                                                
      IF (LAB2(1:1).EQ.' ') THEN                                                
          FZWEIGHT = 0                                                        
                                                                                
      ELSE                                                                      
          CALL TBCSER(FZIDEN,LAB2,FZWEIGHT,ISTAT)                               
          IF (FZWEIGHT.EQ.-1) THEN                                            
              ISTAT  = FERPAR                                               
              RETURN                                                            
                                                                                
          END IF                                                                
                                                                                
      END IF                                                                    
C                                                                               
C DECODE INDEPENDENT VARIABLES                                                  
C                                                                               
      IND2   = INDEX(IVAR,' ') - 1                                              
      LINE   = IVAR(1:IND2)//',,'                                               
      IND2   = INDEX(LINE,',') - 1                                              
      NEXT   = .TRUE.                                                           
      FZNIND = 0                                                              
      KZ6904 = 0
99    KZ6904 = KZ6904 +1
          IF ( .NOT. (NEXT)) GO TO 20                                           
C                                                                               
C   LAB1 CONTAINS NEXT LABEL                                                    
C                                                                               
          LAB1   = LINE(1:IND2)                                                 
          LINE1  = LINE(IND2+2:)                                                
          LINE   = LINE1                                                        
          FZNIND = FZNIND + 1                                               
          CALL TBCSER(FZIDEN,LAB1,FZIVAR(FZNIND),ISTAT)                       
          IF (FZIVAR(FZNIND).EQ.-1) THEN                                    
              ISTAT  = FERPAR                                               
              RETURN                                                            
                                                                                
          END IF                                                                
                                                                                
          IND2   = INDEX(LINE,',') - 1                                          
          NEXT   = IND2 .NE. 0                                                  
      GOTO 99
   20 CONTINUE                                                                  
C                                                                               
C INITIALIZE VARIABLES IN THE COMMON AREA                                       
C                                                                               
      FZNAME = NAME                                                           
      FZTYPE = 'TBL '                                                         
      FZNFUN = 0                                                              
      FZNDAT = 0                                                              
      FZNPTOT = 0                                                             
      FZNITER = 0                                                             
      FZRELAX = 0.                                                            
      FZCHISQ = 0.                                                            
      FZCCHIS = 0.                                                            
      DO 30 I = 1,FZFUNMAX                                                        
          FZFCODE(I) = 0                                                      
          FZACTPAR(I) = 0                                                     
          FZSPEC(I) = ' '                                                     
   30 CONTINUE                                                                  
      DO 40 I = 1,FZPARMAX                                                    
          FZERROR(I) = 0.D0                                                   
          FZVALUE(I) = 0.D0                                                   
          FZGUESS(I) = 0.D0                                                   
          FZUNCER(I) = 0.                                                     
          FZFIXED(I) = -1                                                     
   40 CONTINUE                                                                  
      FZMAPPED = 1                                                            
      RETURN                                                                    
                                                                                
      END                                                                       

C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.COPYRIGHT   (C) 1992 European Southern Observatory
C.IDENT       .for
C.AUTHOR      E. Oliva,  Firenze-Arcetri
C.KEYWORDS    Spectroscopy, IRSPEC
C
C.PURPOSE     Execute command  ...
C
C.ALGORITHM
C
C
C.INPUT/OUTPUT
C
C.VERSION     1.0    Creation     02.09.1992   E. Oliva
C 030714	last modif
C-------------------------------------------------------
C
      PROGRAM DEFBAD
      IMPLICIT REAL(A-H,O-Z)
      IMPLICIT INTEGER(I-N)

      CHARACTER*60 FRAMEI,TABLEO
      CHARACTER*1 SMODE
      CHARACTER*64 CUNIT
      CHARACTER*72 IDENT
      REAL RTH(2)
      INTEGER*8 INPNTR,OUPNTR
      INTEGER NPIX(2)
      DOUBLE PRECISION START(2),STEP(2)
      COMMON /VMR/ MADRID(1)

      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'

      DATA MAXDIM/2/

      IRET=1
      CALL STSPRO('DEFBAD')
C
C GET NAME OF INPUT FRAME AND MAP IT
C CHECK ALSO WHETHER IT IS A 2D FRAME.....
C
      CALL STKRDC('framei',1,1,60,IRET,FRAMEI,KUNIT,KNUL,ISTAT)
      CALL STIGET(FRAMEI,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,MAXDIM,
     ,            NAXIS,NPIX,START,STEP,
     ,            IDENT,CUNIT,INPNTR,NIN,ISTAT)
      IF(NAXIS.NE.2) 
     +     CALL STETER(1,'Input frame must be 2-D')
C
C Create dummy image wich will contain badpixels.
C
      CALL STIPUT('middumma',D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     ,            NAXIS,NPIX,START,STEP,
     ,            IDENT,CUNIT,OUPNTR,NOU,ISTAT)
C
C GET FLAG TO DEFINE the selection mode
C
      CALL STKRDC('smode',1,1,1,IRET,SMODE,KUNIT,KNUL,ISTAT)
C
C Get threshold value(s)
C
      CALL STKRDR('thres',1,2,IRET,RTH,KUNIT,KNUL,ISTAT)
C
C GET KEY TO DEFINE the number of subframes
C
      CALL STKRDI('nsub',1,1,IRET,NSUB,KUNIT,KNUL,ISTAT)
C
C GET THE NAME OF THE OUTPUT TABLE WHICH WILL CONTAIN THE COORDINATES OF THE
C BAD PIXELS 
C
      CALL STKRDC('tableo',1,1,60,IRET,TABLEO,KUNIT,KNUL,ISTAT)
C
C OPEN TABLE FOR UPDATE (IOPEN=2)
C
      IOPEN=2
      CALL TBTOPN(TABLEO,IOPEN,IDETAB,ISTAT)
C
C GET NUMBERS CORRESPONDING TO COLUMNS
C
      CALL TBLSER(IDETAB,'X_COORD',NXCOL,ISTAT)
      CALL TBLSER(IDETAB,'Y_COORD',NYCOL,ISTAT)
      CALL TBLSER(IDETAB,'AVALUE',NAVAL,ISTAT)
      CALL TBLSER(IDETAB,'RVALUE',NRVAL,ISTAT)
C
C CALL ROUTINE WHICH DEFINE BAD_PIXELS AND WRITE THEM IN THE TABLE
C
      CALL FIND(MADRID(INPNTR),MADRID(OUPNTR),
     ,          NPIX(1),NPIX(2),NSUB,
     ,          IDETAB,NXCOL,NYCOL,NAVAL,NRVAL,SMODE,RTH)
C
C Close table
C
      CALL TBTCLO(IDETAB,ISTAT)
C
C RELEASE FILES, UPDATE KEYWORDS AND EXIT
C
      CALL STSEPI
      END
C
C
C
      SUBROUTINE FIND (A,B,NX,NY,NSUB,
     ,                 IDETAB,NXCOL,NYCOL,NAVAL,NRVAL,SMODE,RTH)
C
      IMPLICIT REAL(A-H,O-Z)
      IMPLICIT INTEGER(I-N)
C
      CHARACTER*1 SMODE,DMODE(2),CMODE(2)
      DIMENSION A(NX,NY),B(NX,NY),RTH(2)
      CHARACTER*200 OUTPUT
C
      DATA DMODE/'r','a'/
      DATA CMODE/'R','A'/
C
C Check INPUT IMAGE (A) 
C
      SUM=0.0
      SUM2=0.0
      DO J=1,NY
        DO I=1,NX
          SUM=SUM+A(I,J)
          SUM2=SUM2+A(I,J)*A(I,J)
        ENDDO
      ENDDO
      STD=SUM2-SUM*SUM/(NX*NY)
      IF(STD.LE.0) THEN
        WRITE(OUTPUT,192)
192     FORMAT('Input image is a constant, check it please')
        CALL STTPUT(OUTPUT,ISTAT)
        RETURN
      ENDIF
C
      DO I=1,2
        IMODE=I
        IF(SMODE.EQ.DMODE(I) .OR. SMODE.EQ.CMODE(I)) GO TO 10
      ENDDO
      CALL STETER
     +(1,'Invalid selection mode, only -r-, -a- are recognized')
10    CONTINUE

C
C Set badpixel_image (B) to zero
C
      DO J=1,NY
        DO I=1,NX
          B(I,J)=0.
        ENDDO
      ENDDO
      NBAD=0
C
C Divide image in 16 quadrants and define standard deviation in
C each of them.
C
      IX1=1
      IX2=NX/NSUB
      DO IXQ=1,NSUB
        IY1=1
        IY2=NY/NSUB
        DO IYQ=1,NSUB
          CALL STD_ITER(A,NX,NY,IX1,IX2,IY1,IY2,AVE,STD)
          DO IY=IY1,IY2
            DO IX=IX1,IX2
              VAL=A(IX,IY)
              RVAL=(VAL-AVE)/STD
              IF(IMODE.EQ.1) THEN
                IF(ABS(RVAL).GT.RTH(1)) THEN
                  NBAD=NBAD+1
                  R4=IX
                  CALL TBRWRR(IDETAB,NBAD,1,NXCOL,R4,ISTAT)
                  R4=IY
                  CALL TBRWRR(IDETAB,NBAD,1,NYCOL,R4,ISTAT)
                  CALL TBRWRR(IDETAB,NBAD,1,NAVAL,VAL,ISTAT)
                  CALL TBRWRR(IDETAB,NBAD,1,NRVAL,RVAL,ISTAT)
                  B(IX,IY)=A(IX,IY)
                ENDIF
              ENDIF
              IF(IMODE.EQ.2) THEN
                IF(VAL.LT.RTH(1).OR.VAL.GT.RTH(2)) THEN
                  NBAD=NBAD+1
                  R4=IX
                  CALL TBRWRR(IDETAB,NBAD,1,NXCOL,R4,ISTAT)
                  R4=IY
                  CALL TBRWRR(IDETAB,NBAD,1,NYCOL,R4,ISTAT)
                  CALL TBRWRR(IDETAB,NBAD,1,NAVAL,VAL,ISTAT)
                  CALL TBRWRR(IDETAB,NBAD,1,NRVAL,RVAL,ISTAT)
                  B(IX,IY)=A(IX,IY)
                ENDIF
              ENDIF
            ENDDO
          ENDDO
          IY1=IY2+1
          IY2=IY1+NY/NSUB
          IY2=MIN(IY2,NY)
        ENDDO
        IX1=IX2+1
        IX2=IX1+NX/NSUB
        IX2=MIN(IX2,NX)
      ENDDO
      WRITE(OUTPUT,195) NBAD
195   FORMAT(I5,' bad pixels found and stored in table.')
      CALL STTPUT(OUTPUT,ISTAT)
      RETURN
      END



      SUBROUTINE STD_ITER(A,NX,NY,IX1,IX2,IY1,IY2,AVE,STD)
C
C Define the std of a given region of the image (IX1,IX2:IY1,IY2)
C by iteratively eliminating the points which are more than 3 
C sigma from the average
C
      IMPLICIT REAL(A-H,O-Z)
      IMPLICIT INTEGER(I-N)

      DIMENSION A(NX,NY)
      DIMENSION IXOUT(5000),IYOUT(5000)

      NOUT=0
      IXOUT(1)=0
      IYOUT(1)=0

10    CONTINUE
      SUM=0.0
      SUM2=0.0
      NAVE=0
      DO IY=IY1,IY2
        DO IX=IX1,IX2
          DO J=1,NOUT
            IF(IX.EQ.IXOUT(J) .AND. IY.EQ.IYOUT(J)) GO TO 11
          ENDDO
          VAL=A(IX,IY)
          SUM=SUM+VAL
          SUM2=SUM2+VAL*VAL
          NAVE=NAVE+1
11        CONTINUE
        ENDDO
      ENDDO
      IF(NAVE.LE.0) THEN
        CALL STTPUT('---------------------------------------',ISTAT)
        CALL STTPUT('  NAVE=0, problems in STD_ITER',ISTAT)
        CALL STTPUT(' You probably chose too many sub_frames.',ISTAT)
        CALL STTPUT('---------------------------------------',ISTAT)
        CALL STETER(1,'Aborted')
      ENDIF
      AVE=SUM/NAVE 
      STD=SQRT((SUM2-NAVE*AVE*AVE)/(NAVE-1))
      IF(STD.LE.0) CALL STETER(1,'STD<=0, problems in STD_ITER')
      N=0
      DO IY=IY1,IY2
        DO IX=IX1,IX2
          DIST=ABS((A(IX,IY)-AVE)/STD)
          IF(DIST.GT.3) THEN
            N=N+1
            IXOUT(N)=IX
            IYOUT(N)=IY
          ENDIF
        ENDDO
      ENDDO
      IF(N.GT.NOUT) THEN
        NOUT=N
        GO TO 10
      ENDIF
      RETURN
      END

C @(#)spehpcntr.for	13.1.1.1 (ES0-DMD) 06/02/98 18:18:12
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT:      Copyright (c) 1987 European Southern Observatory,
C                            all rights reserved
C.IDENTIFICATION: SPEHPCNTR
C.PURPOSE:        Interactive line centering. output stored in a table
C.LANGUAGE:       F77+ESOext
C.AUTHOR:         J.D.Ponz
C.KEYWORDS:       Line, centre
C.ALGORITHM:      Line center is found by:
C                 maximum/minimum - position of the maximum/minimum value
C                 gaussian        - center of the fitted gaussian
C                 gravity         - gravity center of the 2 highest pixels
C                                   with respect to the third one
C.INPUT/OUTPUT:   Interactive input via the cursor
C                 table columns :
C                 :XSTART - first cursor input
C                 :XEND   - second cursor input
C                 :XCEN   - computed center
C                 :YSTART - image value for first cursor input
C                 :YEND   - image value for second cursor input
C                 :PEAK   - maximum value
C                 :YFIT   - fitted maximum in gaussian method only
C                 :FWHM   - fwhm in gaussian method only
C.VERSION: 840328  JDP  Creation   
C.VERSION: 870115  JDP  ??   
C.VERSION: 880703  RHW  ESO-FORTRAN Conversion 
C.VERSION: 900430  RHW  Map plotted line separately 
C-----------------------------------------------------------------
      PROGRAM   SPCNTR

      IMPLICIT  NONE

      INTEGER   MADRID
      INTEGER   I1,I2,IAC,IACT,IAV,IFAIL,II,II1,IMETH,NPTS
      INTEGER   IMODE,IPL1,IPL2,ISEQ,ISORT,ISTAT
      INTEGER   L,NAXIS,NCOLS,NCOUNT,NNCOL,NPL,NL
      INTEGER   NVAL, NSIZE(2)
      INTEGER*8 PNTRI, PNTRW, PNTRT
      INTEGER   IMNOI, IMNOT, IMNOW
      INTEGER   IMAGE(4)
      INTEGER   NPIX(2),NN
      INTEGER   KEY
      INTEGER   APPFLG
      INTEGER   STATUS,IC(8)
      INTEGER   KUN, KNUL, TID,ACOL, AROW

      REAL      SXY,X1,X2,XYS
      REAL      XCUR,YCUR,PXVL
      REAL      VALUE(8),W1(1024),W2(1024),ACOE(4)
      DOUBLE PRECISION START(2),STEP(2)
      DOUBLE PRECISION DXYS, DSXY
 
      CHARACTER NAME*20,INFO*20,METH*2
      CHARACTER TABLE*64,TABU(8)*16,TABL(8)*16,IEA*1
      CHARACTER CLINE*72,HEAD1*72,HEAD2*72,FORM(8)*6,PROMPT*72,IAPP*1
      CHARACTER IDENT*72,CUNIT*48,COML*80

      INCLUDE   'MID_INCLUDE:ST_DEF.INC/NOLIST' 
      INCLUDE   'MID_INCLUDE:PLTDEC.INC/NOLIST' 
      COMMON    /VMR/MADRID(1)
      INCLUDE   'MID_INCLUDE:ST_DAT.INC/NOLIST' 
C
      DATA      NCOLS/6/
      DATA      TABU/' ',' ',' ',' ',' ',' ',' ',' '/
      DATA      TABL/'START','END','CENTER','INT_START','INT_END',
     2               'INT_PEAK','INT_FIT','FWHM'/
      DATA      FORM/'F10.3','F10.3','F10.3','G15.5','G15.5','G15.5',
     2               'G15.5','F10.3'/
      DATA      HEAD1/
     2  '     start         end        center     pixel_value    FWHM'/
      DATA      HEAD2/
     2  '     start         end        center     pixel_value'/

      DATA      PROMPT/' Ready for cursor input ...'/
C
 9000 FORMAT(3F13.3,G13.5,G13.5)
C9010 FORMAT(4G13.5)
C9020 FORMAT(A)
C
C  *** start of executable code ***************************************
      CALL STSPRO('SPCNTR')                                       !  initialize
      CALL STKRDC('PLCURSOR',1,1,20,IACT,INFO,KUN,KNUL,STATUS)
      L      = INDEX(INFO//' ',' ') - 1
      NAME  = INFO(1:L)
C
      CALL STKRDC('P3',1,1,1,IACT,IEA,KUN,KNUL,STATUS)
      CALL UPCAS(IEA,IEA)
      IF (IEA.EQ.'E') THEN
         IMODE  = 1
      ELSE
         IMODE  = 0
      END IF
C
      CALL STKRDC('MID$CMND',1,1,80,IACT,COML,KUN,KNUL,STATUS)
      METH   = COML(11:12)
      IF (METH.EQ.'GA') THEN
         IMETH  = -1
         NCOLS  = 8
      ELSE
         IF (METH.EQ.'GR') THEN
            IMETH  = 0
         ELSE
            IMETH  = 1
         END IF
      END IF
C
      CALL STKRDC('P4',1,1,1,IACT,IAPP,KUN,KNUL,STATUS)
      CALL UPCAS(IAPP,IAPP)
      IF (IAPP.EQ.'A') THEN
         APPFLG = 1
      ELSE
         APPFLG = 0
      END IF
      ISEQ   = 0
C
C *** read image
      CALL STFOPN(NAME,D_R4_FORMAT,0,F_IMA_TYPE,IMNOI,ISTAT)
      CALL STDRDI(IMNOI,'NAXIS',1,1,IAC,NAXIS,KUN,KNUL,ISTAT)
      CALL STDRDI(IMNOI,'NPIX',1,NAXIS,IAC,NPIX,KUN,KNUL,ISTAT)
      CALL STDRDD(IMNOI,'START',1,NAXIS,IAC,START,KUN,KNUL,ISTAT)
      CALL STDRDD(IMNOI,'STEP',1,NAXIS,IAC,STEP,KUN,KNUL,ISTAT)
      CALL STDRDC(IMNOI,'IDENT',1,1,72,IAC,IDENT,KUN,KNUL,ISTAT)
      CALL STDRDC(IMNOI,'CUNIT',1,1,64,IAC,CUNIT,KUN,KNUL,ISTAT)
C
      NPL     = NPIX(1)
      NL      = NPIX(2)
      II1     = 16*NAXIS
C
C *** allocate virtual memory for a single line of the frame
      CALL STKRDI('PLISTAT',11,4,IAC,IMAGE,KUN,KNUL,ISTAT)
      IF (IMAGE(3).EQ.IMAGE(4)) THEN
         II = (IMAGE(3)-1)*NPL + 1
         CALL STFMAP(IMNOI,F_I_MODE,II,NPL,IAC,PNTRW,ISTAT)
         SXY = STEP(1)
         XYS = START(1)
         DSXY = STEP(1)
         DXYS = START(1)
      ELSE
C                                                        ! here for the columns
         NN = NPIX(1)*NPIX(2)   
         CALL STFMAP(IMNOI,F_I_MODE,1,NN,IAC,PNTRI,ISTAT)
         CALL STFCRE('MIDTRAN',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     2               NVAL,IMNOT,ISTAT)
         CALL STFMAP(IMNOT,F_X_MODE,1,NN,IAV,PNTRT,ISTAT)
         NSIZE(1) = 128
         NSIZE(2) = 256
         CALL LINCOL(MADRID(PNTRI),NPIX,NSIZE,MADRID(PNTRT))  ! transpose frame
         CALL STFUNM(IMNOI,ISTAT)
C
         IF (NVAL.LT.512) NVAL = 512
         CALL STFCRE('PLOTWORK', D_R4_FORMAT,F_X_MODE, F_IMA_TYPE,
     2               NVAL,IMNOW,ISTAT)                   ! create scratch frame	
         CALL STFMAP(IMNOW,F_X_MODE,1,NVAL,IAC,PNTRW,ISTAT)
         II = (IMAGE(1)-1)*NL
         PNTRT = PNTRT + II
         CALL COPYF(MADRID(PNTRT),MADRID(PNTRW),NVAL)       ! copy right column
         CALL STFUNM(IMNOT,ISTAT)
         SXY = STEP(2)
         XYS = START(2)
         DSXY = STEP(2)
         DXYS = START(2)
      ENDIF
C
      TABU(1) = CUNIT(II1+1:II1+16)
      TABU(2) = TABU(1)
      TABU(3) = TABU(1)
      TABU(4) = CUNIT(1:16)
      TABU(5) = TABU(4)
      TABU(6) = TABU(4)
      TABU(7) = TABU(4)
      TABU(8) = TABU(1)
C
C *** get table name for storage of data
      CALL STKRDC('P2',1,1,64,IACT,TABLE,KUN,KNUL,STATUS)
      IF (APPFLG.EQ.0) THEN
         CALL TBTINI(TABLE,F_TRANS,F_O_MODE,10,200,TID,STATUS)
         DO 10 IAV = 1,NCOLS
            CALL TBCINI(TID,D_R4_FORMAT,1,FORM(IAV),TABU(IAV),
     +                  TABL(IAV),IC(IAV),STATUS)
   10    CONTINUE
      ELSE
         CALL TBTOPN(TABLE,F_U_MODE,TID,STATUS)
         CALL TBIGET(TID,NNCOL,ISEQ,ISORT,ACOL,AROW,STATUS)
         DO 20 IAV = 1,NCOLS
            CALL TBLSER(TID,TABL(IAV),IC(IAV),STATUS)
            IF (IC(IAV).EQ.-1) THEN
               CALL STTPUT('*** FATAL: Wrong input table ',STATUS)
               CALL TBTCLO(TID,STATUS)
               CALL STSEPI
            END IF
   20    CONTINUE
      END IF
C
C *** restore the graphics display
C      CALL GCINI
      CALL AGSSET('USER')
      LTYPE = 2
C
C *** loop on input - pairs of points
      IF (IMETH.EQ.-1) THEN
         CALL STTPUT(HEAD1,STATUS)
      ELSE
         CALL STTPUT(HEAD2,STATUS)
      END IF
      CALL STTPUT(' ',STATUS)
      NCOUNT = 0
C
   30 CONTINUE
      CALL AGVLOC(XCUR,YCUR,KEY,PXVL)
      IF ((KEY.EQ.13) .OR. (KEY.EQ.11)) THEN
         CALL STTPUT('*** WARNING: do NOT use the return key',ISTAT)
         GO TO 30
      ELSE IF (KEY.EQ.32) THEN
         CALL TBTCLO(TID,STATUS)
         CALL PTCLOS
         CALL STSEPI
      ELSE
         CALL AGGPLM(XCUR,YCUR,1,4)
         X1       = XCUR
         VALUE(1) = XCUR
         IPL1     = NINT((X1-XYS)/SXY) + 1
      END IF
C
   40 CONTINUE
      CALL AGVLOC(XCUR,YCUR,KEY,PXVL)
      IF ((KEY.EQ.13) .OR. (KEY.EQ.11)) THEN
         CALL STTPUT('*** WARNING: do NOT use the return key',ISTAT)
         GO TO 40
      ELSE IF (KEY.EQ.32) THEN
         CALL TBTCLO(TID,STATUS)
         CALL PTCLOS
         CALL STSEPI
      ELSE
         CALL AGGPLM(XCUR,YCUR,1,4)
         X2       = XCUR
         VALUE(2) = XCUR
         IPL2     = NINT((X2-XYS)/SXY) + 1
      ENDIF
C
C *** find center
      I1     = MIN(IPL1,IPL2)
      I2     = MAX(IPL1,IPL2)
      CALL FIND(MADRID(PNTRW),DXYS,DSXY,I1,I2,IMODE,IMETH,
     2          VALUE(3),VALUE(6),IFAIL,W1,W2,ACOE,VALUE(4),VALUE(5))
      VALUE(7) = ACOE(1)
      VALUE(8) = ACOE(3)
C
      IF (IFAIL.EQ.0) THEN
         ISEQ   = ISEQ + 1
         CALL TBRWRR(TID,ISEQ,NCOLS,IC,VALUE,STATUS)
         IF (IMETH.EQ.-1) THEN
            WRITE (CLINE,9000) VALUE(1),VALUE(2),VALUE(3),VALUE(6),
     +                         VALUE(8)
         ELSE
             WRITE (CLINE,9000) VALUE(1),VALUE(2),VALUE(3),VALUE(6)
         END IF
C
         CALL STTPUT(CLINE,STATUS)
         NCOUNT = NCOUNT + 1
         IF (IMETH.EQ.-1) THEN
            NPTS = I2 - I1 + 1
            IF( LTYPE .GT. 0 ) CALL AGGPLL(W1,W2,NPTS)
         END IF
      END IF
C
      GO TO 30
      END


      SUBROUTINE FIND(X,XSTR,XSTP,IPL1,IPL2,IMODE,IMETH,
     +                XCENTR,PEAK,IFAIL,W1,W2,ACOE,Y1,Y2)
C++++
C. PURPOSE: Find center
C---
      IMPLICIT NONE
      REAL             X(1)
      DOUBLE PRECISION XSTR,XSTP
      INTEGER          IPL1,IPL2,IMODE,IMETH
      REAL             XCENTR,PEAK,CHICHK,XSP,XGO
      INTEGER          IFAIL,NPX
      REAL             W1(1),W2(1),ACOE(4),Y1,Y2
C
      CHICHK = 0.005
      XSP    = REAL(XSTP)
      XGO    = REAL(XSTR) + (IPL1-1)*XSP
      NPX    = IPL2 - IPL1 + 1
      Y1     = X(IPL1)
      Y2     = X(IPL2)
      IF (IMETH.LT.0) THEN                                     ! gaussian center
         CALL SGAUS(X(IPL1),W1,W2,IMODE,NPX,IFAIL,XGO,XSP,
     +              XCENTR,CHICHK,0,PEAK,ACOE)
      ELSE IF (IMETH.EQ.0) THEN
         CALL GRAVT(X(IPL1),NPX,IMODE,IFAIL,XGO,XSP,XCENTR,PEAK)
      ELSE
         CALL CNTRH(X(IPL1),NPX,IMODE,IFAIL,XGO,XSP,XCENTR,PEAK)
      ENDIF

      RETURN
      END

      SUBROUTINE GRAVT(WINDOW,NPIX,IWID,IWERR,XGO,DXSTP,XCNTR,AM)       
C                                                                              
C LINE CENTERING BY FINDING THE CENTER OF GRAVITY OF 2 HIGHEST                 
C POINTS OF 3 POINTS                                                           
C THE 2 HIGHEST POINTS HAVE VALUES RELATIVES TO THE THIRD                      
C ONLY APPLICABLE IN EMISSION MODE                                             
C PARAMETERS :                                                                 
C WINDOW BUFFER WITH EXPECTED LINE CENTER IN MIDDLE                            
C NPIX NUMBER OF SAMPLES IN WINDOW                                             
C IWID CODE 0 ABSORPTION, 1 EMISSION                                           
C IWERR  ERROR RETURN, 0 OK, 1 ERROR                                           
C XGO XCOORDINATE FIRST ELEMENT IN WINDOW                                      
C DXSTP STEP IN X                                                              
C XCNTR RETURN X CENTER CALCULATED                                             
C AM INTENSITY CENTER PIXEL                                                    
C                                                                              
      IMPLICIT NONE
C
      REAL     AM, WINDOW(1), AL, AH, DR
      INTEGER  NPIX, IWID, IWERR, I, K
C      modified MP 900119 , 
C      DOUBLE PRECISION XGO, DXSTP, XCNTR, A, B, XSHIFT
       REAL XGO, DXSTP, XCNTR, A, B, XSHIFT
C
      IF (IWID.NE.1) GO TO 20                                                  
C                                                                              
C FIND MAXIMUM                                                                 
C                                                                              
      AM     = WINDOW(1)                                                       
      I      = 1                                                               
      DO 10 K = 2,NPIX                                                         
          IF (WINDOW(K).GT.AM) THEN                                            
              AM     = WINDOW(K)                                               
              I      = K                                                       
          END IF                                                               
   10 CONTINUE                                                                 
C                                                                              
C CHECK NOT BOUNDARY                                                           
C                                                                              
      IF (I.EQ.1 .OR. I.EQ.NPIX) GO TO 20                                      
      XCNTR  = XGO + (I-1)*DXSTP                                               
C                                                                              
C FIND LOWEST OF THE FLANKING PIXELS                                           
C                                                                              
      AL     = WINDOW(I-1)                                                     
      AH     = WINDOW(I+1)                                                     
      DR     = 1.                                                              
      IF (AL.GE.AH) THEN                                                       
          AL     = WINDOW(I+1)                                                 
          AH     = WINDOW(I-1)                                                 
          DR     = -1.                                                         
      END IF                                                                   
      AM     = WINDOW(I)                                                       
      A      = AM - AL                                                         
      B      = AH - AL                                                         
      XSHIFT = (B/ (A+B))*DXSTP                                                
      XCNTR  = XCNTR + XSHIFT*DR                                               
      IWERR  = 0                                                               
      RETURN                                                                   
C                                                                              
C ERROR RETURN                                                                 
C                                                                              
   20 IWERR  = 1                                                               
      RETURN                                                                   
                                                                               
      END

      SUBROUTINE CNTRH(WINDOW,NPIX,IWID,IWERR,XGO,DXSTP,XCNTR,AM)              
C                                                                              
C CENTER OF LINE FOUND BY SIMPLE MAXIMUM WITHIN A WINDOW                       
C                                                                              
C PARAMETERS :                                                                 
C WINDOW BUFFER WITH EXPECTED LINE CENTER IN MIDDLE                            
C NPIX NUMBER OF SAMPLES IN WINDOW                                             
C IWID CODE 0 ABSORPTION, 1 EMISSION                                           
C IWERR  ERROR RETURN, 0 OK, 1 ERROR                                           
C XGO XCOORDINATE FIRST ELEMENT IN WINDOW                                      
C DXSTP STEP IN X                                                              
C XCNTR RETURN X CENTER CALCULATED                                             
C AM INTENSITY CENTER PIXEL                                                    
C                                                                              
      IMPLICIT NONE
C
      REAL    WINDOW(1), AM
      INTEGER NPIX, IWID, IWERR
      REAL    XGO, DXSTP, XCNTR
C
      INTEGER IPN, I
C
      IWERR  = 0                                                               
      AM     = WINDOW(1)                                                       
      IPN    = 1                                                               
      IF (IWID.NE.1) THEN                                                      
C                                                                              
C FIND MINIMUM                                                                 
C                                                                              
          DO 10 I = 2,NPIX                                                     
              IF (WINDOW(I).LT.AM) THEN                                        
                  AM     = WINDOW(I)                                           
                  IPN    = I                                                   
              END IF                                                           
   10     CONTINUE                                                             
      ELSE                                                                     
C                                                                              
C FIND MAXIMUM                                                                 
C                                                                              
          DO 20 I = 2,NPIX                                                     
              IF (WINDOW(I).GT.AM) THEN                                        
                  AM     = WINDOW(I)                                           
                  IPN    = I                                                   
              END IF                                                           
   20     CONTINUE                                                             
      END IF                                                                   
C                                                                              
C CHECK RESULT                                                                 
C                                                                              
      IF (IPN.EQ.1 .OR. IPN.EQ.NPIX) GO TO 30                                  
      XCNTR  = XGO + (IPN-1)*DXSTP                                             
      RETURN                                                                   
C                                                                              
C ERROR RETURN                                                                 
C                                                                              
   30 IWERR  = 1                                                               
      RETURN                                                                   
      END                                                                      
                                                                     

      SUBROUTINE SGAUS(WINDOW,XBUF,YFIT,IWID,NPIX,IWERR,XGO,DXSTP,
     2                 XCNTR,CHICHK,IOUTPT,AM,A)                              
C                                                                              
C LINE CENTER FINDING WITH GAUSSIAN FIT                                        
C                                                                              
C PARAMETERS :                                                                 
C WINDOW BUFFER WITH EXPECTED LINE CENTER IN MIDDLE                            
C XBUF WORK BUFFER                                                             
C YFIT WORK BUFFER                                                             
C IWID CODE 0 ABSORPTION, 1 EMISSION                                           
C NPIX NUMBER OF SAMPLES IN WINDOW                                             
C IWERR  ERROR RETURN, 0 OK, 1 ERROR                                           
C XGO XCOORDINATE FIRST ELEMENT IN WINDOW                                      
C DXSTP STEP IN X                                                              
C XCNTR RETURN X CENTER CALCULATED                                             
C CHICHK CHECK CHISQUARE                                                       
C IOUTPT DISPLAY INTERMEDIATE RESULTS 0 NO, 1 YES                              
C AM INTENSITY CENTER PIXEL                                                    
C A ARRAY(4) COEFFICIENTS                                                      
C                                                                              
      INTEGER I,K1,K2,NPIX,IWID,IWERR,IOUTPT
      INTEGER ITCNT,ITCHK,JER,IBRK
      REAL WINDOW(1),XBUF(1),YFIT(1),A(1)                                  
      REAL DELTAA(4),SIGMAA(4),XCNTR,XGO,CHICHK
      REAL DXSTP,CHISQR,FLAMDA,OLDCH,DIF,HALF,WIDTH                            
      REAL AM,X,STOP,TOPM
      CHARACTER*70 IHDD                                                        
      DATA IHDD/'  CHISQ      FWHM     CENTER'/                                
C                                                                              
C BUFFER WITH X VALUES                                                         
C                                                                              
      X      = XGO                                                             
      DO 10 I = 1,NPIX                                                         
          XBUF(I) = XGO + (I-1)*DXSTP                                          
   10 CONTINUE                                                                 
C                                                                              
C FIND INITIAL GUESS                                                           
C                                                                              
      CALL CNTRH(WINDOW,NPIX,IWID,IWERR,XGO,DXSTP,A(2),AM)                     
      IF (IWERR.NE.0) GO TO 120                                                
      A(4)   = (WINDOW(1)+WINDOW(NPIX))/2.                                     
      A(1)   = AM - A(4)                                                       
C                                                                              
C CALCULATE HALF WIDTH                                                         
C                                                                              
      HALF   = A(1)/2. + A(4)                                                  
C                                                                              
C CALCULATION OF FWHM DEPENDS ON SIGN OF THE LINE                              
C                                                                              
      IF (IWID.NE.1) THEN                                                      
          DO 20 I = 1,NPIX                                                     
              IF (WINDOW(I).LT.HALF) GO TO 30                                  
   20     CONTINUE                                                             
   30     K1     = I                                                           
          DO 40 I = K1,NPIX                                                    
              IF (WINDOW(I).GT.HALF) GO TO 50                                  
   40     CONTINUE                                                             
   50     K2     = I                                                           
                                                                               
      ELSE                                                                     
          DO 60 I = 1,NPIX                                                     
              IF (WINDOW(I).GT.HALF) GO TO 70                                  
   60     CONTINUE                                                             
   70     K1     = I                                                           
          DO 80 I = K1,NPIX                                                    
              IF (WINDOW(I).LT.HALF) GO TO 90                                  
   80     CONTINUE                                                             
   90     K2     = I                                                           
      END IF                                                                   
                                                                               
      WIDTH  = ABS(FLOAT(K2-K1)*DXSTP)                                         
      A(3)   = WIDTH/2.354                                                     
      OLDCH  = 9.E16                                                           
C                                                                              
C OPTIONAL OUTPUT                                                              
C                                                                              
C IF (IOUTPT .NE. 0) CALL WRUSER(0,IHDD,' ',' ',ISTAT)                         
C                                                                              
C CALL FITTING ROUTINE                                                         
C ITERATE 50 TIMES                                                             
C                                                                              
      ITCNT  = 0                                                               
      ITCHK  = 50                                                              
  100 FLAMDA = 0.001                                                           
      IBRK   = 0                                                               
C                                                                              
      CALL CURFI(XBUF,WINDOW,SIGMAA,NPIX,4,0,A,DELTAA,FLAMDA,YFIT,             
     +           CHISQR,JER)                                                   
      IF (JER.NE.0) GO TO 120                                                  
C                                                                              
C CALC AND DISPLAY INTERMEDIATE RESULTS                                        
C                                                                              
      IF (IBRK.EQ.-1) GO TO 110                                                
C IF (IOUTPT.NE.0) THEN                                                        
C     TYPE *,NPIX                                                              
C     WRITE(LABL, 100) CHISQR,A(3)*2.345,A(2)                                  
C     CALL STTPUT(LABL,ISTAT)                                                  
C ENDIF                                                                        
C                                                                              
C SEE IF CHISQR HAS CHANGED SIGNIFICANTLY                                      
C                                                                              
      DIF    = OLDCH - CHISQR                                                  
      STOP   = DIF/CHISQR                                                      
      OLDCH  = CHISQR                                                          
      ITCNT  = ITCNT + 1                                                       
      IF (ITCNT.GT.ITCHK) GO TO 120                                            
      IF (STOP.GT.CHICHK) GO TO 100                                            
  110 XCNTR  = A(2)                                                            
C                                                                              
C LAST CHECK THAT WE ARE WITHIN THE WINDOW                                     
C                                                                              
      TOPM   = XBUF(NPIX)                                                      
      IF (DXSTP.LT.0.) THEN                                                    
          IF ((XCNTR.GT.XGO) .OR. (XCNTR.LT.TOPM)) GO TO 120                   
                                                                               
      ELSE                                                                     
          IF ((XCNTR.LT.XGO) .OR. (XCNTR.GT.TOPM)) GO TO 120                   
      END IF                                                                   
                                                                               
      IWERR  = 0                                                               
      A(3)   = A(3)*2.345                                                      
      RETURN                                                                   
C                                                                              
C ERROR RETURN                                                                 
C                                                                              
  120 IWERR  = 1                                                               
      RETURN                                                                   
                                                                               
C9000 FORMAT (E10.3,E10.3,F9.3)                                                
      END                                                                      


      SUBROUTINE CURFI(X,Y,SIGMAY,NPTS,NTERMS,MODE,A,DELTAA,FLAMDA,YFIT,       
     +                 CHISQR,IERR)                                            
C                                                                              
C LEAST SQUARES FIT TO A NON-LINEAR FUNCTION                                   
C                                                                              
C PARAMETERS:                                                                  
C X ARRAY OF DATA POINTS IND. VAR.                                             
C Y ARRAY OF DATA POINTS DEP. VAR.                                             
C SIGMAY ARRAY OF STD DEV FOR Y DATA POINTS                                    
C NPTS NUMBER OF PAIRS OF DATA POINTS                                          
C MODE DETERMINES METHOD OF WEIGHTING LEAST-SQUARES FIT                        
C  +1 (INSTRUMENTAL) WEIGHT = 1./SIGMAY(I)**2                                  
C   0 (NO WEIGHTING) WEIGHT = 1.                                               
C  -1 (STATISTICAL ) WEIGHT = 1./Y(I)                                          
C A ARRAY OF PARAMETERS                                                        
C DELTAA ARRAY OF INCREMENTS FOR PARAMETERS A                                  
C SIGMAA ARRAY OF STANDARD DEVIATIONS FOR PARAMETERS A                         
C FLAMDA PROPORTION OF GRADIENT SEARCH INCLUDED                                
C YFIT ARRAY OF CALCULATED VALUES OF Y                                         
C CHISQR REDUCED CHI SQUARE FOR FIT                                            
C IERR ERROR RETURN 0 OK, 1 NOT CONVERGING                                     
C                                                                              
C DIMENSION STATEMENT VALID FOR NTERMS UP TO 10                                
C SET FLAMDA TO 0.001 AT THE BEGINNING OF THE SEARCH                           
C     
      INTEGER I,J,K,NPTS,NFREE ,NTERMS,IERR  
      INTEGER MODE ,ICNT                                  
      REAL X(1),Y(1),SIGMAY(1),DELTAA(1),YFIT(1)                           
      REAL A(1),DET,FLAMDA,CHISF,FUNCT                                         
      REAL WEIGHT(400),ALPHA(10,10),BETA(10)                               
      REAL DERIV(10),B(10),CHISQR ,CHISQ1                                   
      DOUBLE PRECISION ARRAY(10,10)
      EXTERNAL FUNCT
C                                                                              
      ICNT   = 0                                                               
      IERR   = 1                                                               
      NFREE  = NPTS - NTERMS                                                   
      IF (NFREE) 20,20,30                                                      
   20 CHISQR = 0.                                                              
      RETURN                                                                   
C                                                                              
C EVALUATE WEIGHTS                                                             
C                                                                              
   30 CONTINUE                                                                 
      IERR   = 0                                                               
      DO 100 I = 1,NPTS                                                        
          IF (MODE) 40,70,80                                                   
   40     IF (Y(I)) 60,70,50                                                   
   50     WEIGHT(I) = 1./Y(I)                                                  
          GO TO 90                                                             
                                                                               
   60     WEIGHT(I) = 1./ (-Y(I))                                              
          GO TO 90                                                             
                                                                               
   70     WEIGHT(I) = 1.                                                       
          GO TO 90                                                             
                                                                               
   80     WEIGHT(I) = 1./SIGMAY(I)**2                                          
   90     CONTINUE                                                             
  100 CONTINUE                                                                 
C                                                                              
C EVALUATE ALPHA AND BETA MATRICES                                             
C                                                                              
      DO 120 J = 1,NTERMS                                                      
          BETA(J) = 0.                                                         
          DO 110 K = 1,J                                                       
              ALPHA(J,K) = 0.                                                  
  110     CONTINUE                                                             
  120 CONTINUE                                                                 
      DO 150 I = 1,NPTS                                                        
          CALL FDERI(X,I,A,DELTAA,NTERMS,DERIV)                                
          DO 140 J = 1,NTERMS                                                  
              BETA(J) = BETA(J) + WEIGHT(I)* (Y(I)-FUNCT(X,I,A))*              
     +                  DERIV(J)                                               
              DO 130 K = 1,J                                                   
                  ALPHA(J,K) = ALPHA(J,K) + WEIGHT(I)*DERIV(J)*DERIV(K)        
  130         CONTINUE                                                         
  140     CONTINUE                                                             
  150 CONTINUE                                                                 
      DO 170 J = 1,NTERMS                                                      
          DO 160 K = 1,J                                                       
              ALPHA(K,J) = ALPHA(J,K)                                          
  160     CONTINUE                                                             
  170 CONTINUE                                                                 
C                                                                              
C EVALUATE CHI SQUARE AT STARTING POINT                                        
C                                                                              
      DO 180 I = 1,NPTS                                                        
          YFIT(I) = FUNCT(X,I,A)                                               
  180 CONTINUE                                                                 
      CHISQ1 = CHISF(Y,SIGMAY,NPTS,NFREE,MODE,YFIT)                            
C                                                                              
C INVERT MATRIX                                                                
C                                                                              
  190 DO 210 J = 1,NTERMS                                                      
          DO 200 K = 1,NTERMS                                                  
              IF (ABS(ALPHA(J,J)).LT.1.E-10.OR.
     .                  ABS(ALPHA(K,K)).LT.1.E-10) GOTO 987
              ARRAY(J,K) = ALPHA(J,K)/SQRT(ALPHA(J,J)*ALPHA(K,K))              
  200     CONTINUE                                                             
          ARRAY(J,J) = 1. + FLAMDA                                             
  210 CONTINUE                                                                 
      CALL INVMAT(ARRAY,NTERMS,DET)                                            
      DO 230 J = 1,NTERMS                                                      
          B(J)   = A(J)                                                        
          DO 220 K = 1,NTERMS                                                  
              B(J)   = B(J) + BETA(K)*ARRAY(J,K)/                              
     +                 SQRT(ALPHA(J,J)*ALPHA(K,K))                             
  220     CONTINUE                                                             
  230 CONTINUE                                                                 
C                                                                              
C IF CHI SQUARE INCREASED, INCREASE FLAMDA AND TRY AGAIN                       
C                                                                              
      DO 240 I = 1,NPTS                                                        
          YFIT(I) = FUNCT(X,I,B)                                               
  240 CONTINUE                                                                 
      CHISQR = CHISF(Y,SIGMAY,NPTS,NFREE,MODE,YFIT)                            
      IF (CHISQ1-CHISQR) 250,270,270                                           
C                                                                              
C CHECK LOOPS                                                                  
C                                                                              
  250 ICNT   = ICNT + 1                                                        
      IF (ICNT.LT.60) GO TO 260                                                
  987 IERR   = 1                                                               
      RETURN                                                                   
                                                                               
  260 FLAMDA = 10.*FLAMDA                                                      
      GO TO 190                                                                
C                                                                              
C EVALUATE PARAMETERS                                                          
C                                                                              
  270 DO 280 J = 1,NTERMS                                                      
          A(J)   = B(J)                                                        
  280 CONTINUE                                                                 
      FLAMDA = FLAMDA/10.                                                      
      RETURN                                                                   
                                                                               
      END                                                                      

      REAL FUNCTION FUNCT(X,I,A)
C
C EVALUATE TERMS OF FUNCTION FOR NON-LINEAR LEAST-SQUARES SEARCH
C WITH FORM OF GAUSSIAN PEAK
C
C PARAMETERS:
C X ARRAY OF DATA POINTS
C I INDEX OF DATA POINTS
C A ARRAY OF PARAMETERS
C
      REAL X(1),A(1),Z,XI,Z2
      INTEGER I
      XI     = X(I)
      FUNCT  = A(4)
      Z      = (XI-A(2))/A(3)
      Z2     = Z*Z
      IF (Z2-50.) 40,50,50
   40 FUNCT  = FUNCT + A(1)*EXP(-Z2*0.5)
   50 RETURN

      END

      FUNCTION CHISF(Y,SIGMAY,NPTS,NFREE,MODE,YFIT)
C
C EVALUATE REDUCED CHI SQUARE FOR FIT TO DATA
C CHISF = SUM((Y-YFIT)**2/SIGMA**2)/NFREE
C
C PARAMETERS:
C Y ARRAY OF DATA POINTS
C SIGMAY ARRAY OF STANDARD DEVIATIONS
C NPTS NUMBER OF DATA POINTS
C NFREE NUMBER OF DEGREES OF FREEDOM
C MODE DETERMINES METHOD OF WEIGHTING LEAST-SQUARES FIT
C  +1 (INSTRUMENTAL) WEIGHT = 1./SIGMAY(I)**2
C   0 (NO WEIGHTING) WEIGHT = 1.
C  -1 (STATISTICAL ) WEIGHT = 1./Y(I)
C YFIT ARRAY OF CALCULATED VALUES OF Y
C
      INTEGER NFREE,MODE,NPTS,I
      REAL Y(1),SIGMAY(1),YFIT(1),CHISF
      DOUBLE PRECISION CHISQ,WEIGHT
C
      CHISQ  = 0.
      IF (NFREE) 30,30,40
   30 CHISF  = 0.
      RETURN
C
C ACCUMULATE CHI SQUARE
C
   40 DO 110 I = 1,NPTS
          IF (MODE) 50,80,90
   50     IF (Y(I)) 70,80,60
   60     WEIGHT = 1./Y(I)
          GO TO 100

   70     WEIGHT = 1./ (-Y(I))
          GO TO 100

   80     WEIGHT = 1.
          GO TO 100

   90     WEIGHT = 1./SIGMAY(I)**2
  100     CHISQ  = CHISQ + WEIGHT* (Y(I)-YFIT(I))**2
  110 CONTINUE
C
C DIVIDE BY NUMBER OF DEGREES OF FREEDOM
C
      CHISF  = CHISQ/NFREE
      RETURN

      END


      SUBROUTINE FDERI(X,I,A,DELTAA,NTERMS,DERIV)                              
C                                                                              
C EVALUATES DERIVATIVES OF FUNCTION FOR LEAST SQUARES SEARCH                   
C WITH FORM OF GAUSSIAN PEAK                                                   
C                                                                              
C PARAMETERS:                                                                  
C X ARRAY OF DATA POINTS OF INDEPENDENT VARIABLE                               
C I INDEX OF DATA POINTS                                                       
C A ARRAY OF PARAMETERS                                                        
C DELTAA ARRAY OF PARAMETER INCREMENTS                                         
C NTERMS NUMBER OF PARAMETERS                                                  
C DERIV DERIVATIVES OF FUNCTION                                                
C                                                                              
      INTEGER I,J,NTERMS
      REAL X(1),A(1),DELTAA(1),DERIV(1)                                    
      REAL Z,Z2,XI
                                                                               
      XI     = X(I)                                                            
      Z      = (XI-A(2))/A(3)                                                  
      Z2     = Z*Z                                                             
      IF (Z2-50.) 40,20,20                                                     
   20 DO 30 J = 1,3                                                            
          DERIV(J) = 0.                                                        
   30 CONTINUE                                                                 
      GO TO 50                                                                 
C                                                                              
C ANALYTICAL EXPRESSION FOR DERIVATIVES                                        
C                                                                              
   40 DERIV(1) = EXP(-Z2/2.)                                                   
      DERIV(2) = A(1)*DERIV(1)*Z/A(3)                                          
      DERIV(3) = DERIV(2)*Z                                                    
   50 DERIV(4) = 1.                                                            
      RETURN                                                                   
                                                                               
      END                                                                      


      SUBROUTINE INVMAT(ARR,N,DET)
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  0:26 - 4 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: D.PONZ
C         INVERTS A SYMMETRIC MATRIX AND CALCULATES ITS DETERMINANT
C         USING A GAUSS-JORDAN ELIMINATION METHOD. THE DEGREE N OF
C         THE MATRIX MUST NOT BE GREATER THAN 10.
C         THE INVERSION IS IN DOUBLE PRECISION, AND
C         THE ARRAY ARR MUST BE D-P. THE DETERMINANT IS ALLWAYS REAL.
C
C   PARAMS :
C         ARR :  ARRAY CONTAINING THE (N*N) MATRIX TO BE INVERTED.
C                THE INVERTED MATRIX IS RETURNED IN ARR.
C         N   :  DEGREE OF MATRIX
C         DET :  DETERMINANT OF INPUT-MATRIX
C
C      IMPLICIT NONE
      REAL DET
      DOUBLE PRECISION ARR(10,10),AMAX,SAVE,DDET
      INTEGER IK(10),JK(10),I,J,K,N,L
C
      DET    = 1.0
      DDET   = 1.0D0
      DO 210 K = 1,N
          AMAX   = 0.0D0
C
C  FIND LARGEST ELEMENT ARR(I,J) IN REST OF MATRIX
C
   10     DO 40 I = K,N
              DO 30 J = K,N
                  IF (DABS(AMAX)-DABS(ARR(I,J))) 20,20,30
   20             AMAX   = ARR(I,J)
                  IK(K)  = I
                  JK(K)  = J
   30         CONTINUE
   40     CONTINUE
C  ----------------------------------------------------
C  INTERCHANGE ROWS AND COLUMNS TO PUT AMAX IN ARR(K,K)
C  ----------------------------------------------------
          IF (AMAX) 60,50,60
   50     DET    = 0.
          GO TO 280

   60     I      = IK(K)
          IF (I-K) 10,90,70
   70     DO 80 J = 1,N
              SAVE   = ARR(K,J)
              ARR(K,J) = ARR(I,J)
              ARR(I,J) = -SAVE
   80     CONTINUE
C
   90     J      = JK(K)
          IF (J-K) 10,120,100
  100     DO 110 I = 1,N
              SAVE   = ARR(I,K)
              ARR(I,K) = ARR(I,J)
              ARR(I,J) = -SAVE
  110     CONTINUE
C  -------------------------------------
C  ACCUMULATE ELEMENTS OF INVERSE MATRIX
C  -------------------------------------
  120     DO 140 I = 1,N
              IF (I-K) 130,140,130
  130         ARR(I,K) = -ARR(I,K)/AMAX
  140     CONTINUE
C
          DO 180 I = 1,N
              DO 170 J = 1,N
                  IF (I-K) 150,170,150
  150             IF (J-K) 160,170,160
  160             ARR(I,J) = ARR(I,J) + ARR(I,K)*ARR(K,J)
  170         CONTINUE
  180     CONTINUE
C
          DO 200 J = 1,N
              IF (J-K) 190,200,190
  190         ARR(K,J) = ARR(K,J)/AMAX
  200     CONTINUE
          ARR(K,K) = 1.0/AMAX
          DET    = DET*AMAX
          DDET   = DDET*AMAX
C
  210 CONTINUE
C  --------------------------
C  RESTORE ORDERING OF MATRIX
C  --------------------------
      DO 270 L = 1,N
          K      = N - L + 1
          J      = IK(K)
          IF (J-K) 240,240,220
  220     DO 230 I = 1,N
              SAVE   = ARR(I,K)
              ARR(I,K) = -ARR(I,J)
              ARR(I,J) = SAVE
  230     CONTINUE
C
  240     I      = JK(K)
          IF (I-K) 270,270,250
  250     DO 260 J = 1,N
              SAVE   = ARR(K,J)
              ARR(K,J) = -ARR(I,J)
              ARR(I,J) = SAVE
  260     CONTINUE
C
  270 CONTINUE
      DET    = DDET
      RETURN
C  -------------------
C  DETERMINANT IS ZERO
C  -------------------
  280 DET    = 0.0
      RETURN

      END

C @(#)knnif.for	19.1 (ES0-DMD) 02/25/03 13:27:32
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C-----------------------------------------------------------------------
C
C.IDENTIFICATION
C
C  Program KNNIF
C
C.AUTHOR
C
C  F. Murtagh, ST-ECF, Garching.             Version 1.0  16 June 1986
C  F. Murtagh                                Version 2.0  Oct. 1988
C                                            (New std. ifs.)
C
C.PURPOSE
C
C  Pass parameters to, and execute, KNN (K-NNs Discriminant Analysis).
C
C.INPUT/OUTPUT
C
C  P1 to P4 contain parameters; these are: input table name, cardinality
C  of group 1 of the training set; test set table name; and number of
C  nearest neighbours.
C
C.ALGORITHM
C
C . uses Midas Table interface routines;
C . input table is assumed to contain entries in single precision;
C . no select or null values;
C . all columns of the input table are sent to the KNN routine;
C . description of the KNN  routine is in the corresponding program;
C . the output produced is to the screen only;
C . storage is limited only by the Midas Table system, and by the
C   overall system limitations;
C
C.MODIFICATIONS
C
C   NEW STANDARD INTERFACES, F. MURTAGH, AUG. 88
C   New Table File Interface M.Peron     SEP91
C
C-----------------------------------------------------------------------
        PROGRAM KNNIF
C
        CHARACTER*6     FORM
        CHARACTER*60     TRAIN, TEST
        INTEGER         NACTV,ISTAT,N1,N,M,K,TID1,NSORTC
        INTEGER         NAC,NAR1,IPTR1,TID2,I,N3,M3,IPTR2
        INTEGER         LEN,NSEL,IWPTR1,IWPTR2,NAR,NAR3,NTOT
        INTEGER         INULL,IADD0,IADD1,IADD2,IERR,N2
        INTEGER         MADRID, KUN, KNUL, DTYPE
        INCLUDE         'MID_INCLUDE:TABLES.INC/NOLIST'
        COMMON          /VMR/MADRID(1)
        INCLUDE         'MID_INCLUDE:TABLED.INC/NOLIST'
C
C
C ...   Assuming this is our first action ...
C
        CALL STSPRO('KNNIF')
        DTYPE = D_R4_FORMAT
C
C ...   Get input parameters, passed as keywords with the command.
C
        CALL STKRDC('P1',1,1,60,NACTV,TRAIN,KUN,KNUL,ISTAT)
        CALL STKRDI('INPUTI',1,1,NACTV,N1,KUN,KNUL,ISTAT)
        CALL STKRDC('P3',1,1,60,NACTV,TEST,KUN,KNUL,ISTAT)
        CALL STKRDI('INPUTI',2,1,NACTV,K,KUN,KNUL,ISTAT)
C
C ...   Read input tables.
C
        CALL TBTOPN(TRAIN,16,TID1,ISTAT)
        CALL TBIGET(TID1,M,N,NSORTC,NAC,NAR1,ISTAT)
        CALL TBCMAP(TID1,0,IPTR1,ISTAT)
C
        CALL TBTOPN(TEST,16,TID2,ISTAT)
        CALL TBIGET(TID2,M3,N3,NSORTC,NAC,NAR1,ISTAT)
        CALL TBCMAP(TID2,0,IPTR2,ISTAT)
C
C ...   Some error checking on input.
C
        IF (N.LT.1.OR.M.LT.1.OR.M3.LT.1.OR.N3.LT.1) THEN
           CALL STTPUT(' Nos. of rows/columns are less than 1.',ISTAT)
           CALL STTPUT(' What sort of a table is this ??',ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
C
        IF (M3.NE.M) THEN
           CALL STTPUT
     X     (' Dimension of training and test sets different.',ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
C
        DO I = 1, M
           CALL TBFGET(TID1,I,FORM,LEN,DTYPE,ISTAT)
           IF (DTYPE.NE.D_R4_FORMAT) THEN
              CALL STTPUT(' Illegal format:',ISTAT)
              CALL STTPUT(' Only R*4 column type allowed.',ISTAT)
              CALL STTPUT(' Aborting.',ISTAT)
              GOTO 9000
           ENDIF
        ENDDO
        DO I = 1, M3
           CALL TBFGET(TID2,I,FORM,LEN,DTYPE,ISTAT)
           IF (DTYPE.NE.D_R4_FORMAT) THEN
              CALL STTPUT(' Illegal format:',ISTAT)
              CALL STTPUT(' Only R*4 column type allowed.',ISTAT)
              CALL STTPUT(' Aborting.',ISTAT)
              GOTO 9000
           ENDIF
        ENDDO
C
        CALL CHSEL(TID1,N,NSEL)
        IF (NSEL.NE.N) THEN
           CALL STTPUT(' Not all rows are SELECTed. ',ISTAT)
           CALL STTPUT(' In current implementation, MUST select all.',
     X                                                         ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
C
        CALL CHSEL(TID2,N3,NSEL)
        IF (NSEL.NE.N3) THEN
           CALL STTPUT(' Not all rows are SELECTed. ',ISTAT)
           CALL STTPUT(' In current implementation, MUST select all.',
     X                                                         ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
C
        CALL TDMGET(4*M*N,IWPTR1,ISTAT)
        CALL TBCMAP(TID1,1,IPTR1,ISTAT)
        CALL MAPSM(MADRID(IPTR1),MADRID(IWPTR1),
     1              NAR,N,M)
        CALL TDMGET(4*M3*N3,IWPTR2,ISTAT)
        CALL TBCMAP(TID2,1,IPTR2,ISTAT)
        CALL MAPSM(MADRID(IPTR2),MADRID(IWPTR2),
     1              NAR3,N3,M3)
        NTOT = N*M
        CALL CHNULL(MADRID(IWPTR1),NTOT,INULL)
        IF (INULL.NE.0) THEN
           CALL STTPUT
     X     (' Null entries in the table are not allowed.',ISTAT)
           CALL STTPUT
     X     (' Use SELECT, and then construct another table.',
     X                                                    ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
C
        NTOT = N3*M
        CALL CHNULL(MADRID(IWPTR2),NTOT,INULL)
        IF (INULL.NE.0) THEN
           CALL STTPUT
     X     (' Null entries in the table are not allowed.',ISTAT)
           CALL STTPUT
     X     (' Use SELECT, and then construct another table.',
     X                                                   ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
C
C ...   Allocate storage.
C
        N2 = N - N1
        CALL GETSTOR(K,IADD0)
        CALL GETSTOR(K,IADD1)
        CALL GETSTOR(K,IADD2)
C
C ...   We now have all the storage we need; APPL will look after
C       a few further odds and ends - e.g. setting a few hard-wired
C       options, rearranging output, etc.  Then it will call the
C       application program.
C
        IERR = 0
        CALL APPL(MADRID(IWPTR1),N1,N2,N,MADRID(IWPTR2),N3,M,K,
     X  MADRID(IADD0),MADRID(IADD1),MADRID(IADD2),IERR)
        IF (IERR.NE.0) THEN
           CALL STTPUT(' IERR not 0 on return from KNN.',ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
C
C ...   Finish up: write output file to disk, and release memory space.
C
        CALL RELSTOR(K,IADD0)
        CALL RELSTOR(K,IADD1)
        CALL RELSTOR(K,IADD2)
C
        CALL TBTCLO(TID1,ISTAT)
        CALL TBTCLO(TID2,ISTAT)
C
 9000   CONTINUE
        CALL STSEPI
C
        END
C----------------------------------------------------------------------
        SUBROUTINE APPL(TRAIN,N1,N2,N,TEST,N3,M,K,DK,
     X                          KLIST,KPOP,IERR)
C
        INTEGER N,M,K,N1,N2,N3,IERR
        REAL*4  TRAIN(N,M), TEST(N3,M), DK(K), KPOP(K), KLIST(K)
C
        CALL KNN(TRAIN,N1,N2,N,TEST,N3,M,K,KLIST,DK,KPOP,IERR)
        IF (IERR.NE.0) RETURN
C
        RETURN
        END
C-------------------------------------------------------------------------
        SUBROUTINE CHNULL(X,NT,NULL)
C ...   Check if null values are present.
        REAL*4  X(NT), TRNULL
        INTEGER TINULL,I,NULL,NT
        DOUBLE PRECISION TDNULL
        CALL TBMNUL(TINULL,TRNULL,TDNULL)
        NULL = 0
        DO I = 1, NT
           IF (X(I).EQ.TRNULL) NULL = NULL + 1
           IF (NULL.GT.0) RETURN
        ENDDO
        RETURN
        END
C-------------------------------------------------------------------------
        SUBROUTINE TBL_CHGP(X,NT,IL,IH)
C ...   Check if unacceptable group membership values are present.
        INTEGER NT,IL,IH,I
        REAL*4  X(NT)
        IL = 0
        IH = 0
        DO I = 1, NT
           IF (X(I).LT.0.0) IL = IL + 1
           IF (X(I).GT.2.0) IH = IH + 1
           IF (IL.GT.0.OR.IH.GT.0) RETURN
        ENDDO
        RETURN
        END
C-------------------------------------------------------------------------
        SUBROUTINE GETSTOR(NVALS,IPTR)
C ...   Allocate storage space for NVALS real values.
        INTEGER NVALS,IPTR,ISTAT
        CALL TDMGET(4*NVALS,IPTR,ISTAT)
        RETURN
        END
C-------------------------------------------------------------------------
        SUBROUTINE RELSTOR(NVALS,IPTR)
C ...   Release storage space (already allocated) for NVALS real values.
        INTEGER NVALS,IPTR,ISTAT
        CALL TDMFRE(4*NVALS,IPTR,ISTAT)
        RETURN
        END

C @(#)rar.for	19.1 (ESO-DMD) 02/25/03 13:23:05
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C----------------------------------------------------------------------
      SUBROUTINE RAR(I,K,N,KK,IXY,IDX,IDY,X,AR)
C----------------------------------------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z), INTEGER*4 (I-N)
C 
      PARAMETER   (MAXOBJ=100001)
C 
      DIMENSION X(10),X1(10),AR(MAXOBJ,4),KK(9),IDX(9),IDY(9)
C 
      DO0 = 0.0D0
      DO1 = 1.0D0
C 
      IF (K.EQ.0) THEN
C     *this one is used by pos1-2
          X1(1) = AR(I,1) 
          X1(2) = AR(I,2) 
          X1(3) = AR(I,1)*AR(I,2) 
          X1(4) = AR(I,1)**2
          X1(5) = AR(I,2)**2
          X1(6) = AR(I,1)**3
          X1(7) = AR(I,2)**3
          X1(8) = AR(I,1)*AR(I,2)**2
          X1(9) = AR(I,2)*AR(I,1)**2
          ENDIF

      IF (K.EQ.1) THEN
          X1(1) = DO1 
          X1(2) = DO0 
          X1(3) = AR(I,2) 
          X1(4) = 2.0D0*AR(I,1) 
          X1(5) = DO0 
          X1(6) = 3.0D0*AR(I,1)**2
          X1(7) = DO0 
          X1(8) = AR(I,2)**2
          X1(9) = 2.0D0*AR(I,2)*AR(I,1) 
          ENDIF

      IF (K.EQ.2) THEN
          X1(1) = DO0 
          X1(2) = DO1 
          X1(3) = AR(I,1) 
          X1(4) = DO0 
          X1(5) = 2.0D0*AR(I,2) 
          X1(6) = DO0 
          X1(7) = 3.0D0*AR(I,2)**2
          X1(8) = 2.0D0*AR(I,1)*AR(I,2) 
          X1(9) = AR(I,1)**2
          ENDIF

    5 IF(IXY.EQ.1) X1(10) = AR(I,3) 
      IF(IXY.EQ.2) X1(10) = AR(I,4) 

      DO 6 L = 1,9
    6   KK(L) = 0 

      IF (IXY .NE. 2) THEN
C     *IX=1
         I1 = 0 

         DO 10 J=1,9 
            IF (IDX(J).NE.0) THEN
               I1 = I1+1 
               X(I1) = X1(J) 
               KK(I1) = J
            ENDIF
 10      CONTINUE
         
        
         IF (N-I1.NE.1) THEN
            WRITE(6,9060) N,I1
 9060       FORMAT(1X,'COEFF TROUBLE',2I6)
            STOP
         ENDIF
         
         X(I1+1) = X1(10)
         RETURN
      ELSE
C     *ixy=2
 20      I1= 0 
         DO 30 J=1,9 
            IF (IDY(J).EQ.0) GOTO 30 
            I1 = I1+1 
            X(I1) = X1(J) 
            KK(I1) = J
 30      CONTINUE
      
         IF ( N-I1 .EQ. 1) THEN
            X(I1+1) = X1(10)
            RETURN
         ENDIF
      ENDIF
      RETURN
C 
      END 

C @(#)fllgrd.for	19.1 (ES0-DMD) 02/25/03 13:30:45
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FLLGRD(DATA,ALPHA0)                                            
C +++                                                                           
C --- 
      IMPLICIT    NONE	
      INTEGER     NDIM
      INTEGER     NSEP
      PARAMETER  (NDIM=510) 
      PARAMETER  (NSEP= 60)                                                                          
      REAL       DATA(NDIM*NDIM)
      REAL       ALPHA0                                           
C
      INTEGER    I,J
      INTEGER    IXD,IYD                                                    
      REAL       ALPHA
      REAL       X,Y
      REAL       RSQUAR                                              
      REAL       XORIG,YORIG                                                    
C                                                                               
      DATA       XORIG/100./
      DATA       YORIG/255./                                        
C                                                                               
      DO 10 I = 1,NDIM*NDIM            ! first fill the entire frame with zero's
         DATA(I) = 0.                                                           
   10 CONTINUE                                                                  
C                                                                               
C *** then define the grid with NSEP pixels spacing
C     begin with the vertical lines                                             
      DO 30 I = 1,9                                                             
         X      = (I-1)*NSEP + 15 - XORIG 
         DO 20 J = 1,NDIM     
            Y      = J - YORIG                              !   rotate pixel by
            RSQUAR = X**2 + Y**2                                ! alpha radians
            ALPHA  = RSQUAR*ALPHA0                              ! about xorig 
            IXD    = NINT(X*COS(ALPHA)-Y*SIN(ALPHA)+XORIG)          ! and yorig
            IYD    = NINT(X*SIN(ALPHA)+Y*COS(ALPHA)+YORIG)                     
            IF ((IXD.GE.1) .AND. (IXD.LE.NDIM) .AND. (IYD.GE.1) .AND.
     +          (IYD.LE.NDIM)) THEN 
               DATA((IYD-1)*NDIM+IXD) = 100. 
            ENDIF                                                               
   20    CONTINUE                                                               
   30 CONTINUE                                                                  
C                                                                               
C *** and now for the horizontal lines                                          
      DO 50 J = 1,9                                                             
         Y = (J-1)*NSEP + 15 - YORIG 
         DO 40 I = 1,NDIM
            X      = I - XORIG                                                 
            RSQUAR = X**2 + Y**2                                               
            ALPHA  = RSQUAR*ALPHA0                                            
            IXD    = NINT(X*COS(ALPHA)-Y*SIN(ALPHA)+XORIG)                     
            IYD    = NINT(X*SIN(ALPHA)+Y*COS(ALPHA)+YORIG)                     
            IF ((IXD.GE.1) .AND. (IXD.LE.NDIM) .AND. (IYD.GE.1) .AND.
     +          (IYD.LE.NDIM)) THEN 
               DATA((IYD-1)*NDIM+IXD) = 100. 
            ENDIF                                                               
   40    CONTINUE                                                               
   50 CONTINUE                                                                  
C                                                                               
C *** job done                                                                  
      RETURN                                                                    
      END                                                                       

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                        all rights reserved
C.IDENTIFICATION: SEARCH.FOR
C.PURPOSE:        Searches image frame for objects and write found
C                 objects into array ACAT.
C
C.ALGORITHM:      Described in additional documentation.
C
C.LANGUAGE:       ESO-FOR
C.AUTHOR:         A. Kruszewski
C.KEYWORDS:       GALAXIES, IMAGES, SEARCH, STARS
C.ENVIRONMENT:    Portable MIDAS
C.COMMENTS:       Subroutines SEARCH and SEAREG used by program INVSEARCH
C.VERSION:        1.0     JUL 1981  Creation                  ESO-Garching
C.VERSION:        1.1  16 AUG 1983  Modification              ESO-Garching
C.VERSION:        2.0   6 SEP 1983  Modified by Ch. Ounnas    ESO-Garching
C.VERSION:             22 MAY 1984  Modified by Ch. Ounnas    ESO-Garching
C.VERSION:        2.1  19 FEB 1987  Modified for FX           Obs. de Geneve
C.VERSION:        3.0     JUN 1987  Indirect pixel addresing and SEAREG
C                                   added                     ESO-Garching
C.VERSION:        4.0  18 OCT 1988  Modified for portability  Warsaw U. Obs.
C.VERSION:              2 MAY 1989  Few minor changes         ESO-Garching
C-----------------------------------------------------------------------
      SUBROUTINE SEARCH(IMF, A, JAPY, NX, NY,
     &                  ACAT, IDET, IDA, IARR, RARR, MM)
C
      IMPLICIT NONE
      INCLUDE  'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER   IMF                ! IN:  Image file
      REAL      A(1)               ! LOC: Image data buffer
      INTEGER   JAPY(1)            ! LOC: Pointers to image lines
      INTEGER   NX                 ! IN:  Image X-dimension
      INTEGER   NY                 ! IN:  Image Y-dimension
      REAL      ACAT(5,MAXCNT)     ! OUT: Catalog of objects
      INTEGER   IDET(1)            ! LOC: Detection mapping array
      INTEGER   IDA(1)             ! LOC: Multiple detections limits
      INTEGER   IARR(32)           ! IN:  Integer INVENTORY keywords
      REAL      RARR(64)           ! IN:  Real INVENTORY keywords
      INTEGER   MM                 ! OUT: Number of detected objects
C
      INTEGER   IBUF(4)
      INTEGER   IHED, ILIM, ISTAT
CKB      INTEGER   INET(0:MAXNET)
      INTEGER   INET0,INET(MAXNET)
      INTEGER   ITMP
      INTEGER   IUSD(4), IXYU(4)
      INTEGER   JEND, JMSG, JS, JSRCHD
      INTEGER   JSTART, K, M
      INTEGER   NC, NH1, NHED, NL
      INTEGER   MCAT(4,MAXDET)
C     INTEGER   MMB
      INTEGER   NHSEG, NLPB, NVSEG
      INTEGER   NXS, NXU, NYS, NYU
C
      REAL      SKYNET0(2)
      REAL      BCAT(2,MAXDET), CRMD(3), DLIM, SKYNET(2,MAXNET)
C
      CHARACTER*80 TEXT
C
C *** Recall keywords.
C
      NC = MAXCNT
      NL = MAXDET
      CRMD(1) = RARR(39)
      CRMD(2) = RARR(40)
      CRMD(3) = RARR(41)
      IHED = IARR(8)
      NHED = IARR(23)
      SKYNET0(1) = 0.0
      SKYNET0(2) = 0.0
      INET0 = 0
      do 99 m = 1,MAXNET
         SKYNET(1,M) = 0.0
         SKYNET(2,M) = 0.0
         INET(M) = 0
99    continue
C
C *** Define used part of frame IXYU.
C
      IXYU(1) = MAX( 1 , IARR(12)-IHED )
      IXYU(2) = MAX( 1 , IARR(13)-IHED )
      IXYU(3) = MIN( NX , IARR(14)+IHED )
      IXYU(4) = MIN( NY , IARR(15)+IHED )
C
C *** Part of frame in buffer is limited by IBUF.
C
c      IBUF(1) = IXYU(1)
c      IBUF(3) = IXYU(3)
C
C *** Presently buffer is identical with the frame.
C
      IBUF(1) = 1
      IBUF(2) = 1
      IBUF(3) = NX
      IBUF(4) = NY
C
C *** Analysed part of frame shall be divided onto vertical
C *** segments. Borders of actual segment are set by IUSD.
C
      IUSD(1) = IXYU(1)
      IUSD(3) = IXYU(3)
cC
cC *** Find number of lines in buffer.
cC
c      NPPL = IXYU(3) - IXYU(1) + 1
c      NLPB = MIN ( NYBUF , NIBUF/NPPL )
      NLPB = NY
C
C *** Searched part of frame is defined by IARR(12)-IARR(15)
C
      NXU = IXYU(3) - IXYU(1) + 1
      NYU = IXYU(4) - IXYU(2) + 1
      NXS = IARR(14) - IARR(12) + 1
      NYS = IARR(15) - IARR(13) + 1
C
C *** Set array for combining detections.
C
      DLIM = RARR(43)
      ILIM = INT( DLIM )
      CALL LMTDET( ILIM , DLIM , IDA )
C
C *** Initialize detection array.
C
      ITMP = (ILIM+1) * NXS
      DO 40 K = 1 , ITMP
          IDET(K) = 0
   40 CONTINUE
C
C *** Calculate number of vertical segments.
C
      NVSEG = INT( RARR(48) * FLOAT(NYS) / FLOAT(2*NHED+1) ) + 1
cC
cC *** Make segments small enough to fit buffer.
cC
c      IF ( (NYS/NVSEG+1+2*IHED)*NXU .GT. NIBUF .OR.
c     &                  NYS/NVSEG+1+2*IHED .GT. NYBUF ) THEN
c            NLPB = NIBUF / NXU
c            IF ( NLPB-2*IHED .GT. IHED .AND. NLPB .LE.
c     &                        NYBUF ) THEN
c                  NVSEG = NYS / (NLPB-2*IHED) + 1
c            ELSE
c               CALL STTPUT('Check connection and include files',ISTAT)
c                  RETURN
c            ENDIF
c      ENDIF
C
C *** Divide searched part of a frame into horizontal segments.
C
      NHSEG = MIN ( INT( RARR(48)*FLOAT(NXS) / FLOAT(2*NHED+1) ) + 1 ,
     &                                                MAXNET )
      INET0 = IARR(12)
      INET(NHSEG) = IARR(14)
      NH1 = NHSEG-1
      DO 10 K = 1 , NH1
          INET(K) = INET0 + ( K*NXS ) / NHSEG
   10 CONTINUE
C
C *** Initialize counters.
C
      M = 0
      MM = 0
C
C ***  Start loop over vertical segments
C
c      IBUF(2) = 0
c      JBS = 0
c      IBUF(4) = 0
c      JBE = 0
      JSRCHD = IARR(13) - 1
      CALL STTPUT( 'Search started' , ISTAT )
      DO 20 JS = 1 , NVSEG
C
C *** Find vertical limits of searched area.
C
          JSTART = JSRCHD + 1
          IF ( JS .LT. NVSEG ) THEN
              JEND = IARR(13) + ( JS*NYS ) / NVSEG
          ELSE
              JEND = IARR(15)
          ENDIF
cC
cC ***     Find vertical limits of used area.
cC
c          IEXT = ( NLPB - JEND + JSTART ) / 2
c          IEXT = MAX( NHED , IEXT ) 
c          JUS = MAX( JSTART-IEXT , IXYU(2) )
c          JUE = MIN( JEND+IEXT , IXYU(4) , JUS+NLPB-1 )
C
C ***     Take care of image buffers.
C
c          IF ( JBE .LT. JUE ) THEN
c              IUSD(2) = JUS
c              IUSD(4) = JUE
          IF ( JS .EQ. 1 ) THEN
              CALL FILBUF( IMF , A , JAPY , NX , IXYU , IUSD , IBUF )
          ENDIF
c          JBS = IBUF(2)
c          JBE = IBUF(4)
c          ENDIF
C
C ***     Update sky background net.
C
          CALL SBGNET ( A , JAPY , IBUF , IXYU , JS ,
     &                  JSTART , JEND , inet0, INET , skynet0,
     +                  SKYNET , NHSEG ,
     &                  CRMD , NHED )

C
C ***     Search JS-th vertical segment.
C
          CALL SEAREG ( A , JAPY , IBUF , IXYU , JSTART ,
     &                  JEND , NHSEG , inet0, INET , skynet0,
     +                  SKYNET , ACAT ,
     &                  BCAT , MCAT , IDET , IDA , IARR ,
     &                  RARR , M , MM )
C
C ***     Mark last searched line.
C
          JSRCHD = JEND
          JMSG = ( 100 * (JSRCHD-IARR(13)+1) ) / NYS
C
C ***     Write message.
C
          WRITE(TEXT,'(I4,A,I8,A)')
     &              JMSG,'% of frame searched ',MM,' objects detected'
          CALL STTPUT( TEXT , ISTAT )

  20      CONTINUE
cC
cC ******      Write down objects left in ACAT.
cC
c      MMB = MOD( MM-1 , NC ) + 1
c      IF ( MMB .GT. 0 ) THEN
c          CALL CTLG( ITF , ACAT , NC , START , STEP , MM , MMB )
c      END IF
C

      RETURN
C
      END
C



C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.PURPOSE:        Searches horizontal image segment
C
C.ALGORITHM:      Described in additional documentation
C
C.REMARKS:
C-----------------------------------------------------------------------
      SUBROUTINE SEAREG(A, JAPY, IBUF, IXYU, JSTART,
     &                  JEND, NHSEG, inet0, INET, skynet0,SKYNET, ACAT,
     &                  BCAT, MCAT, IDET, IDA, IARR,
     &                  RARR, M, MM)
C
      IMPLICIT NONE
      INCLUDE  'MID_REL_INCL:INVENT.INC/NOLIST'
C
      REAL      A(1)                ! IN:  Image buffer
      INTEGER   JAPY(1)             ! IN:  Pointers to image lines
      INTEGER   IBUF(4)             ! IN:  Limits of image buffer
      INTEGER   IXYU(4)             ! IN:  Limits of investigated area
      INTEGER   JSTART              ! IN:  First searched line
      INTEGER   JEND                ! IN:  Last searched line
      INTEGER   NHSEG               ! IN:  Number of horizontal segments
      INTEGER   INET0  
      INTEGER   INET(NHSEG)       ! IN:  Horizontal segments limits
      REAL      SKYNET0(2)
      REAL      SKYNET(2,NHSEG)   ! IN:  Net of sky values
      REAL      ACAT(5,MAXCNT)      ! MOD: Array with objects data
      REAL      BCAT(2,MAXDET)      ! MOD: Real detection data
      INTEGER   MCAT(4,MAXDET)      ! MOD: Integer detection data
      INTEGER   IDET(1)             ! MOD: Rolling array with detections
      INTEGER   IDA(1)              ! MOD: Definition of nearby pixels
      INTEGER   IARR(32)            ! IN:  Integer INVENTORY keywords
      REAL      RARR(64)            ! IN:  Real INVENTORY keywords
      INTEGER   M                   ! MOD: Number of actual detections
      INTEGER   MM                  ! MOD: Number of actual objects
C
      INTEGER   I , IARG , IB
      INTEGER   IEND , IFLD , IFULL , IHED
      INTEGER   IL , ILIM
      INTEGER   IOF , IOFF
      INTEGER   IP , IPLIM(MAXNET)
      INTEGER   IS , ISDET , ISTART, ISTAT
      INTEGER   IUNIT
      INTEGER   J , JBS , JBE , JXY(4)
      INTEGER   JOF , JOFF
C     INTEGER   KREC, KCOR
      INTEGER   MINCR , MK
      INTEGER   NC , NL , NXS
C
      REAL   AVER
C     REAL   AR
      REAL   BGRD , BLIM , BLIME , BLIMS
      REAL   CRMD(3)
      REAL   FLTR , FRCTI1 , FRCTI2 , FRCTJ1 , FRCTJ2
      REAL   HCUT , LCUT
      REAL   PLIM , PLIML , PRLIM(MAXNET)
      REAL   RTRSH
      REAL   SB2 , SKYMIN , SKYMAX
      REAL   TRSH
C     REAL   TRLM
C
      LOGICAL   DETECT , OBJECT
C
C
      NC = MAXCNT
      NL = MAXDET
      JBS = IBUF(2)
      JBE = IBUF(4)
C
C ******      Recall keywords. Sky variations are additive,
C ******      limiting threshold RTRSH=RARR(3) is in
C ******      measurement units: IFLD=1. Sky variations are
C ******      multiplicative, limiting threshold RTRSH=RARR(3)
C ******      is expressed in units of local sky: IFLD=0.
C
      BLIME = 0.0
      BLIMS = 0.0
      IHED = IARR(8)
      IFLD = IARR(9)
      IUNIT = IARR(10)
      NXS = IARR(14) - IARR(12) + 1
      MINCR = IARR(22)
      LCUT = RARR(1)
      HCUT = RARR(2)
      RTRSH = RARR(3)
      FLTR = RARR(4)
      CRMD(1) = RARR(39)
      CRMD(2) = RARR(40)
      CRMD(3) = RARR(41)
      ILIM = INT( RARR(43) )
C
C *** Local sky determination is less accurate when ISDET=0,
C *** more accurate when ISDET=1, and most accurate when ISDET=2.
C
      ISDET = IARR(16)
C
C *** Calculate offsets.
C
      JOFF = JBS - 1
      IOFF = IBUF(1) - 1
      IOF = IARR(12) - 1
C
C *** Find preliminary detection limits.
C
          SKYMIN = MIN( SKYNET0(1) , SKYNET0(2) ,
     &                        SKYNET(1,1) , SKYNET(2,1) )
          SKYMAX = MAX( SKYNET0(1) , SKYNET0(2) ,
     &                        SKYNET(1,1) , SKYNET(2,1) )
          IF ( IFLD .EQ. 1 ) THEN
              PRLIM(1) = SKYMIN + RTRSH
              TRSH = RTRSH
          ELSE
              PRLIM(1) = SKYMIN * (1.0+RTRSH)
              TRSH = PRLIM(1) - SKYMIN
          ENDIF
C
C ***     Mark segments with disprepant sky determinations.
C
          IF ( SKYMAX-SKYMIN .GT. TRSH ) THEN
              IPLIM(1) = 1
          ELSE
              IPLIM(1) = 0
          ENDIF


      DO 5 IS = 2 , NHSEG
          SKYMIN = MIN( SKYNET(1,IS-1) , SKYNET(2,IS-1) ,
     &                        SKYNET(1,IS) , SKYNET(2,IS) )
          SKYMAX = MAX( SKYNET(1,IS-1) , SKYNET(2,IS-1) ,
     &                        SKYNET(1,IS) , SKYNET(2,IS) )
          IF ( IFLD .EQ. 1 ) THEN
              PRLIM(IS) = SKYMIN + RTRSH
              TRSH = RTRSH
          ELSE
              PRLIM(IS) = SKYMIN * (1.0+RTRSH)
              TRSH = PRLIM(IS) - SKYMIN
          ENDIF
C
C ***     Mark segments with disprepant sky determinations.
C
          IF ( SKYMAX-SKYMIN .GT. TRSH ) THEN
              IPLIM(IS) = 1
          ELSE
              IPLIM(IS) = 0
          ENDIF
    5 CONTINUE
C
C *** Search by lines.
C
      DO 10 J = JSTART , JEND
          JOF = JAPY(J-JOFF)
          FRCTJ1 = FLOAT(JEND-J) / FLOAT(JEND-JSTART)
          FRCTJ2 = 1.0 - FRCTJ1
C
C ***     Search by horizontal segments.
C
          DO 20 IS = 1 , NHSEG
              IP = IPLIM(IS)
              IF ( IS .GT. 1 ) THEN
                  ISTART = INET(IS-1) + 1
              ELSE
CKB                  ISTART = INET(IS-1)
                  ISTART = INET0
              ENDIF
              IEND = INET(IS)
C
C ***         Find preliminary detection limit.
C
              PLIM = PRLIM(IS)
              PLIML = MAX( LCUT , PLIM - 4.0*TRSH )
              IF ( ISDET .EQ. 2 ) THEN
                  PLIM = PLIM - 0.3 * TRSH
              ENDIF
              IB = 0
C
C ***         Search by pixels.
C
              DO 30 I = ISTART , IEND
                  DETECT = .FALSE.
                  OBJECT = .FALSE.
                  IARG = JOF + I
                  AVER = A(IARG)
C
C ***             Pixel lower than preliminary
C ***             limit is no longer considered.
C
                  IF ( AVER .LT. PLIM ) THEN
c                      IF ( AVER .LT. PLIML ) THEN
c                          MA(IARG) = 0
c                      ENDIF
                      GOTO 30
                  ENDIF
C
C ***             Pixels higher than HCUT get special treatment. 
C
                  IF ( AVER .GE. HCUT ) THEN
c                      MA(IARG) = 2
                      CALL SATOBJ( A , JAPY , JOFF , I , J ,
     &                             HCUT , AVER )
                      IF ( ISDET .EQ. 2 ) THEN
                          BGRD = PLIM - 0.7 * TRSH
                      ELSE
                          BGRD = PLIM - TRSH
                      ENDIF                      
                      CALL FLTRBP( A , JAPY , IBUF , I , J ,
     &                             BGRD , FLTR , AVER )
                      IF ( AVER .GT. 0.9*HCUT ) THEN
                          GOTO 55
                      ELSE
                          GOTO 56
                      ENDIF
                  ENDIF
C
C***********************************************************************
C
C ******                This part of code depends on
C ******                the detection criterium used.
C
                  CALL SRHOBJ( A , JAPY , JOFF , I , J ,
     &                                          DETECT , AVER )
                  IF ( .NOT. DETECT ) GOTO 30
C
C ******                Pixel is higher than 8 neighbours.
C
C***********************************************************************
C
   56             CONTINUE
                  IF ( IB .EQ. 0 ) THEN
C
C ******                  Find background on borders.
C
                      if (is .eq. 1) then
                      BLIMS = SKYNET0(1)*FRCTJ1 +
     &                              SKYNET0(2)*FRCTJ2 + TRSH
                      BLIME = SKYNET(1,1)*FRCTJ1 +
     &                              SKYNET(2,1)*FRCTJ2 + TRSH
                      else
                      BLIMS = SKYNET(1,IS-1)*FRCTJ1 +
     &                              SKYNET(2,IS-1)*FRCTJ2 + TRSH
                      BLIME = SKYNET(1,IS)*FRCTJ1 +
     &                              SKYNET(2,IS)*FRCTJ2 + TRSH
                      endif
                      IB = 1
                  ENDIF
C
C ******                        Calculate interpolated background.
C
                  FRCTI1 = FLOAT(I-ISTART) / FLOAT(IEND-ISTART)
                  FRCTI2 = 1.0 - FRCTI1
                  BLIM = BLIMS*FRCTI1 + BLIME*FRCTI2
                  IF ( ISDET .EQ. 2 ) THEN
                      BLIM = BLIM - 0.3 * TRSH
                  ENDIF
                  IF ( AVER .GT. BLIM ) THEN
                      IF ( ISDET .EQ. 2 ) THEN
                          BGRD = BLIM - 0.7 * TRSH
                      ELSE
                          BGRD = BLIM - TRSH
                      ENDIF
                      GOTO 40
                  ENDIF
C
C ******                Calculate approximate background.
C
                  JXY(1) = MAX( IBUF(1) , I-IHED )
                  JXY(2) = MAX( IBUF(2) , J-IHED )
                  JXY(3) = MIN( IBUF(3) , I+IHED )
                  JXY(4) = MIN( IBUF(4) , J+IHED )
                  CALL APRBGR ( A , JAPY , JOFF , JXY , SB2 )
                  IF ( AVER .LT. SB2+TRSH ) THEN
                      GOTO 30
                  ELSE
                      BGRD = SB2
                  ENDIF
   40         CONTINUE
C
C ******                The pixel has passed approximate
C ******                criteria. Now the final criterium
C ******                will be applied if necessary.
C
                IF ( IP .EQ. 1 .OR. ISDET .EQ. 1 ) THEN
                  IFULL = 0
                  CALL SKYMOD( A , JAPY , IBUF , I , J , CRMD ,
     &                                    IHED , IFULL , BGRD )
                     IF ( AVER .LE. BGRD+TRSH ) GOTO 30
                     IF ( A(JAPY(J-JOFF)+I) .GT.
     &                                 BGRD + (FLTR-1.0)*TRSH ) THEN
                         CALL FLTRBP( A , JAPY , IBUF , I , J ,
     &                                    BGRD , FLTR , AVER )
                     ENDIF
                     IF ( AVER .LE. BGRD+TRSH ) GOTO 30
                 ENDIF
C  50            CONTINUE
C
C ***            One more check.
C
c                 TRLM = BGRD + TRSH
c                 CALL RADDET( A , JAPY , IBUF , I , J ,
c     &                        MINCR , TRLM , AVER , TRSH , AR )
c                 IF ( AR .LT. 0.0 .AND. AVER .LT. 0.9*HCUT ) GOTO 30
   55            CONTINUE
C
C ******                This is a detection.
C
                  M = M + 1
                  IF (M.GE.NL) THEN
                     CALL STTPUT
     +               ('*** FATAL: Internal buffer overflow; ',ISTAT)
                     CALL STTPUT
     +               ('    Restrict our search to smaller subframe',
     +               ISTAT)
                     CALL STTPUT
     +               ('    or modify parameter setup fro detection',
     +               ISTAT)
                    CALL STSEPI
                  ENDIF
C
C ******                Save arrays MCAT and BCAT
C ******                if they are full of new data.
C
c                 IF ( MOD( M , NL ) .EQ. 1 .AND. M .GT. NL ) THEN
c                     KCOR = M - NL - 1 
c                     DO 60 K = 1 , NL
c                         KREC = K + KCOR
c                         WRITE ( ISF , REC=KREC ) MCAT(1,K) ,
c     &                            MCAT(2,K) , MCAT(3,K) , MCAT(4,K) ,
c     &                                    BCAT(1,K) , BCAT(2,K)
c   60                CONTINUE
c                 ENDIF
C
C ***             Record data for new detection.
C
                  MK = MOD( M-1 , NL ) + 1
                  MCAT(1,MK) = I
                  MCAT(2,MK) = J
                  MCAT(3,MK) = 0
                  MCAT(4,MK) = 0
                  BCAT(1,MK) = BGRD
                  BCAT(2,MK) = AVER
                  IP = I - IOF
C
C ***             Update linked list of detections.
C
                  CALL UPDTLL( MCAT , NL , IDET ,
     &                              NXS , ILIM , IDA , IP , M )

   30         CONTINUE
   20     CONTINUE
C
C ***     Join multiple detections and update array IDET.
C
          CALL JOINMD( A , JAPY , IBUF , IXYU , ACAT ,
     &                 NC , BCAT , MCAT , NL , IDET ,
     &                 NXS , ILIM , IARR , RARR , M ,
     &                 MM )
          IF ( J .EQ. IARR(15) ) THEN
              DO 70 IL = 1 , ILIM
                  CALL JOINMD( A , JAPY , IBUF , IXYU , ACAT ,
     &                         NC , BCAT , MCAT , NL , IDET ,
     &                         NXS , ILIM , IARR , RARR , M ,
     &                         MM )
   70         CONTINUE

          ENDIF
   10 CONTINUE
C
      RETURN
C
      END

C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine EXTREM         version 1         820521
C  A. Kruszewski             ESO Garching
C.KEYWORDS
C  extrema
C.PURPOSE
C  selects two maxima and a minimum between them in an array "SCNX"
C.INPUT/OUTPUT
C  input arguments
C  SCNX        real*4 array      array to be analysed for extrema
C  M           integer*4         number of elements in array "SCNX"
C                                is equal to "2*M+1"
C  IDLM        integer*4 array   minimal distance between components
C  output arguments
C  EXTR        real*4 array      values of array "SCNX" in extremal
C                                points
C  LCTN        integer*4 array   locations of extremal points
C-----------------------------------------------------------------------
      SUBROUTINE EXTREM(SCNX, M, IDLM, EXTR, LCTN)
C
      IMPLICIT NONE
      INTEGER  M
      REAL     SCNX((-M):M)
      INTEGER  IDLM
      REAL     EXTR(3)
      INTEGER  LCTN(3)
C
      INTEGER  IVAR , IVAR1
      INTEGER  K, K1, K2, K3, L, MM
      REAL     VAR , VAR1
      REAL     DFMM, DIFF
      LOGICAL   DOWN
C
      VAR = SCNX(0)
      IVAR = 0
      IVAR1 = 0
      EXTR(2) = 0.0
      EXTR(3) = 0.0
      LCTN(2) = 0
      LCTN(3) = 0
C
C ******      Searches for highest maximum.
C
      MM = -M
      DO 10 K = MM , M
          IF ( SCNX(K) .GT. VAR ) THEN
            VAR = SCNX(K)
            IVAR = K
          ENDIF
  10      CONTINUE
C
C ******      Store value of the highest maximum
C ******      as EXTR(1) and its position as LCTN(1).
C
      EXTR(1) = VAR
      LCTN(1) = IVAR
C
C ******      Search an array SCNX for another maximum
C ******      in interval from -M to LCTN(1)-IDLM.
C
      DOWN = .FALSE.
      DFMM = 0.0
      K1 = -M + 1
      K2 = LCTN(1) - IDLM + 1
      DO 11 K = K1 , K2
          IF ( SCNX(K) .LT. SCNX(K-1) ) THEN
            IF ( .NOT. DOWN ) THEN
                DOWN = .TRUE.
                VAR1 = SCNX(K-1)
                K3 = K2 + IDLM - 2
                DO 12 L = K , K2
                  IF ( SCNX(L) .LT. VAR1 ) THEN
                      VAR1 = SCNX(L)
                      IVAR1 = L
                  ENDIF
   12                CONTINUE
                  DIFF = SCNX(K-1) - VAR1
                IF ( DIFF .GT. DFMM ) THEN
                  EXTR(2) = SCNX(K-1)
                  EXTR(3) = VAR1
                  LCTN(2) = K-1
                  LCTN(3) = IVAR1
                  DFMM = DIFF
                ENDIF
            ENDIF
          ELSE
            DOWN = .FALSE.
          ENDIF
   11      CONTINUE 
C
C ******      Search array SCNX for another maximum
C ******      in interval from LCTN(1)+IDLM to M.
C
      DOWN = .FALSE.
      K1 = M - 1
      K2 = LCTN(1) + IDLM - 1
      DO 13 K = K1 , K2 , -1
          IF ( SCNX(K) .LT. SCNX(K+1) ) THEN
            IF ( .NOT. DOWN ) THEN
                DOWN = .TRUE.
                VAR1 = SCNX(K+1)
                K3 = K2 - IDLM + 2
                DO 14 L = K3 , K
                  IF( SCNX(L) .LT. VAR1 ) THEN
                      VAR1 = SCNX(L)
                      IVAR1 = L
                  ENDIF
   14                CONTINUE 
                  DIFF = SCNX(K+1) - VAR1
                IF ( DIFF .GT. DFMM ) THEN
                  EXTR(2) = SCNX(K+1)
                  EXTR(3) = VAR1
                  LCTN(2) = K + 1
                  LCTN(3) = IVAR1
                  DFMM = DIFF
                ENDIF
            ENDIF
          ELSE
            DOWN = .FALSE.
          ENDIF
   13      CONTINUE
C
      RETURN
C
      END

C @(#)tdcopyima.for	13.1.1.1 (ES0-DMD) 06/02/98 18:19:02
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  14:33 - 19 NOV 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION
C
C  TCOPYIMA
C
C.PURPOSE
C
C  Execute the commands
C  COPY/IT  IMAGE TABLE
C  COPY/TI  TABLE IMAGE
C
C.KEYWORDS
C
C  copier, tables
C
C.ALGORITHM
C
C  Use MIDAS interface routines
C  900711 Add test on NULL values M.Peron
C  901012 Take care of the REAL number of rows
C  910306 Put reasonable labels in table MP
C  910318 Open the input table in F_MAP_FORCE|F_IMODE MPeron
C  910403 Take in account the number of allocated rows MP
C-----------------------------------------------------------
C
      SUBROUTINE TDCPIM
      IMPLICIT NONE
C
      INTEGER MADRID
      INTEGER*8   PNTR, TADD
      INTEGER NPIX(2), IAV, ISTAT, ICOL1, NAXIS, NCOL, NROW
      INTEGER ISIZE,   TID, I,     IC,    NSC,  NAC,  NAR
      INTEGER STATUS,  ID,  KUN,   KNUL,  TYPE, IMNO,NR
C
      DOUBLE PRECISION DSTART(2), DSTEP(2)
C
      REAL*4       RMIN,RMAX,CUTS(4)
      CHARACTER*16 MSG
      CHARACTER*60 TABLE, IMAGE, COLUMN
      CHARACTER*48 CUNIT
      CHARACTER*8  FORM
      CHARACTER*16 TUNIT, TLABEL
      CHARACTER*72 IDENT
      CHARACTER*1  ACTION
C
      INCLUDE 'MID_INCLUDE:TABLES.INC'
C
      COMMON /VMR/MADRID(1)
C
      INCLUDE 'MID_INCLUDE:TABLED.INC'
C
      DATA MSG/'ERR:TCOPYIMAxxxx'/
      DATA TUNIT/' '/, TLABEL/' '/
      DATA FORM/'G14.6 '/
C
      TYPE = D_R4_FORMAT
C
C ... get into MIDAS
C
      CALL STKRDC('ACTION',1,1,1,IAV,ACTION,KUN,KNUL,ISTAT)
      IF (ACTION.EQ.'I') THEN
          CALL STKRDC('IN_A',1,1,60,IAV,IMAGE,KUN,KNUL,ISTAT)
          CALL STKRDC('OUT_A',1,1,60,IAV,TABLE,KUN,KNUL,ISTAT)
          CALL STKRDC('P3',1,1,60,IAV,COLUMN,KUN,KNUL,ISTAT)
          IF (COLUMN(1:1).EQ.'?') THEN
              ICOL1  = 0
          ELSE
              ICOL1  = 1
          END IF
C
C ... copy image to table
          CALL STIGET(IMAGE,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     .    2,NAXIS,NPIX,DSTART,DSTEP,IDENT,CUNIT,PNTR,IMNO,ISTAT)
C
C ... create table
C
          IF (NPIX(2).LE.0) NPIX(2) = 1
          NCOL   = NPIX(2) + ICOL1
          NROW   = NPIX(1)
          ISIZE  = NPIX(1)*NPIX(2)
          CALL TBTINI(TABLE,F_TRANS,F_IO_MODE,NCOL,NROW,TID,ISTAT)
          IF (ICOL1.EQ.1) THEN
             TLABEL = COLUMN
          ELSE
             TLABEL = 'LAB001'
          ENDIF
          CALL TBCINI(TID,TYPE,1,FORM,TUNIT,TLABEL,IC,ISTAT)
          DO 10 I = 2,NCOL
              WRITE (TLABEL,9010) I
              CALL TBCINI(TID,TYPE,1,FORM,TUNIT,TLABEL,IC,ISTAT)
   10     CONTINUE
          IF (ICOL1.EQ.1) THEN
              CALL GENCOL(TID,1,NPIX(1),DSTART(1),DSTEP(1))
          END IF
          CALL TBCMAP(TID,ICOL1+1,TADD,ISTAT)
          CALL TBIGET(TID,NCOL,NR,NSC,NAC,NAR,ISTAT)
          CALL BICOPY(MADRID(PNTR),MADRID(TADD),ISIZE,NROW,NAR,NCOL)
          CALL TBIPUT(TID,NCOL,NROW,ISTAT)
          CALL TBSINI(TID,ISTAT)
          CALL TDHSTR(TID,ISTAT)
          CALL DSCUPT(TID,TID,' ',ISTAT)
          CALL TBTCLO(TID,ISTAT)
      ELSE
C
C ... copy table to image
C
          CALL STKRDC('IN_A',1,1,60,IAV,TABLE,KUN,KNUL,ISTAT)
          CALL STKRDC('OUT_A',1,1,60,IAV,IMAGE,KUN,KNUL,ISTAT)
          CALL TBTOPN(TABLE,16,TID,ISTAT)
          CALL TBIGET(TID,NCOL,NROW,NSC,NAC,NAR,ISTAT)
          CALL TBCMAP(TID,1,TADD,ISTAT)
C          NROW   = NAR                  ! ON REQUEST 
          NPIX(2) = NCOL
          NPIX(1) = NROW
          ISIZE  = NCOL*NROW
          CUNIT  = ' '
          IDENT  = TABLE
          DSTART(1) = 0.D0
          DSTART(2) = 0.D0
          DSTEP(1) = 1.D0
          DSTEP(2) = 1.D0
          CALL STIPUT(IMAGE,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,2,NPIX,
     +            DSTART,DSTEP,IDENT,CUNIT,PNTR,ID,ISTAT)
          CALL BTCOPY(MADRID(TADD),MADRID(PNTR),NCOL,NROW,NAR,
     +            RMIN,RMAX)
          CUTS(1) = 0
          CUTS(2) = 0
          CUTS(3) = RMIN
          CUTS(4) = RMAX
          CALL STDWRR(ID,'LHCUTS',CUTS,1,4,KUN,ISTAT)
          CALL TDHSTR(ID,ISTAT)
          CALL DSCUPT(ID,ID,' ',ISTAT)
      END IF
C ... end
C
      CONTINUE
      IF (ISTAT.NE.0) THEN
          WRITE (MSG(13:16),9000) ISTAT
          CALL TDERRR(ISTAT,MSG,STATUS)
      END IF
 9000 FORMAT (I4)
 9010 FORMAT ('LAB',I3.3)
      END

      SUBROUTINE GENCOL(TID,ICOL,N,START,STEP)
C
C GENERATE FIRST COLUMN
C
      IMPLICIT NONE
      INTEGER  TID, ICOL
      INTEGER N, I, ISTAT
C
      DOUBLE PRECISION    START, STEP, T
C
      DO 10 I = 1,N
          T   = (I-1)*STEP + START
          CALL TBEWRD(TID,I,ICOL,T,ISTAT)
   10 CONTINUE
      RETURN
      END


      SUBROUTINE BICOPY(IN,OUT,N,NROW,NAR,NCOL)
C
C  COPY ARRAY
C
      IMPLICIT NONE
      INTEGER N, I,J,NROW,NCOL,NAR
C
      REAL    IN(N), OUT(NAR,NCOL)
C
      DO 20 J=1,NCOL
      DO 10 I = 1,NROW
          OUT(I,J) = IN(I+(J-1)*NROW)
   10 CONTINUE
   20 CONTINUE
      RETURN

      END

      SUBROUTINE BTCOPY(IN,OUT,NCOL,NROW,NAR,RMIN,RMAX)
  
      IMPLICIT NONE
      INTEGER I,J,TINULL,IAV,KUN,KNUL,ISTAT,NROW,NCOL,NAR
      REAL IN(NAR,NCOL),OUT(NROW,NCOL),TRNULL,NULL
      REAL RMIN,RMAX
      DOUBLE PRECISION TDNULL

      CALL STKRDR('NULL',2,1,IAV,NULL,KUN,KNUL,ISTAT)
      CALL TBMNUL(TINULL,TRNULL,TDNULL)
      RMIN = IN(1,1)
      RMAX = RMIN
      DO 20 J=1,NCOL
         DO 10 I=1,NROW
         IF (IN(I,J).EQ.TRNULL) THEN
             OUT(I,J) = NULL
         ELSE
             OUT(I,J) = IN(I,J)
             RMIN = MIN(RMIN,IN(I,J))
             RMAX = MAX(RMAX,IN(I,J))
         ENDIF
10       CONTINUE
20    CONTINUE
      RETURN
      END

C @(#)rarthm.for	19.2 (ESO-DMD) 05/13/03 16:05:29
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM RARTHM
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  program    RARTHM			version 1.00	881028
C  K. Banse                  		ESO - Garching
C
C.KEYWORDS
C  arithmetic operations, rows, columns
C
C.PURPOSE
C  evaluate an arithmetic expression involving rows (columns) of a frame,
C  constants and functions
C  and store the result into a row (column) of same data frame
C
C.ALGORITHM
C  "clean" the expression by replacing all rows by F, all constants by C
C  and all functions by P and Q, convert it to polish (postfix) notation
C  and evaluate it piecewise;
C  intermediate results are stored in OUTPUTR(1) or rows (columns) of
C  temporary frame
C  establish special condition handler for arithmetic traps...
C
C.INPUT/OUTPUT
C  the following keywords are used:
C
C  P1/C/1/80			holds input/result frame + row (column
C				e.g IMAGE.R210 (IMAGE.C12)
C  INPLINE/C/1/160		arithmetic expression,
C				may contain up to 15 operands
C  DEFAULT/C/16/1		R or C, for work on rows or columns
C
C.VERSIONS
C 030513	last modif
C
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      N,NN,LL,NAXIS,NCN
      INTEGER      NULCNT,COUNT
      INTEGER      IAV,STAT,NSIZE(2),RESROW
      INTEGER*8    PNTRC,PNTRW,PNTRD,PNTR1,PNTR2,ZPNTRA,ZPNTRB
      INTEGER*8    APNTR,BPNTR,RESP,XPNTR,QPNTR(24)
      INTEGER      QIMNO(24)
      INTEGER      IMNOA,IMNOB,IMNOC,OFF
      INTEGER      PP,P1,P2,P3,LOPA,LOPB,LOPC
      INTEGER      IDUM,IDUMMY,K,NBRA
      INTEGER      ROWNOA,ROWNOB
      INTEGER      NPIXW(2),NPIXC(2),NPIXA(2),NPIXB(2)
      INTEGER      LATOM(23),APNTRS(48)                !cf. ARTHMZ subroutine
      INTEGER      APIX(3,2),BPIX(3,2),CPIX(3,2)
      INTEGER      ROWSIZ,ROWLIM,IX,IFA,IFB
      INTEGER      UNI(1),NULO,MADRID(1)
C
      CHARACTER*60   FRAMEC,ROWA,ROWB
      CHARACTER*60   ATOM(23),OPERA,OPERB,OPERC
      CHARACTER      WORK(2)*50
      CHARACTER      OPERAT*4,LINE*256
      CHARACTER      PARMS(8)*2,CBUF*80
      CHARACTER      ERROR1*60,ERROR3*40,ERROR4*40
      CHARACTER      RC*1,RCUP*1,RCT*2,LLINE*256
      CHARACTER      IDENT*20,CUNIT*20
C
      REAL         RDUM,CONSTA(2),CONST,CUTS(4)
      REAL         RNULL(2),USRNUL
C 
      DOUBLE PRECISION  DDUM
C
      COMMON   /NULCOM/  NULCNT,USRNUL
      COMMON   /VMR/  MADRID
      COMMON   /TIMNOS/  QIMNO
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      DATA
     + ERROR1  /'operands do not match in stepsize or origin... '/
      DATA    ERROR3  /'wrong syntax...'/
      DATA    ERROR4  /'too many operands - reduce expression '/
      DATA    APNTRS  /48*-1/
      DATA    APIX    /6*1/,    BPIX /6*1/,    CPIX /6*1/
      DATA    PARMS   /'P1','P2','P3','P4','P5','P6','P7','P8'/
      DATA    IDENT   /' '/,  CUNIT /' '/
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C  set up MIDAS environment + init
      CALL STSPRO('RARTHM')
      DO 50, N=1,24
         QIMNO(N) = -1
50    CONTINUE
C
C  get null data + row/column option
      CALL STKRDR('NULL',2,2,IAV,RNULL,UNI,NULO,STAT)
      NULCNT = 0
      USRNUL = RNULL(1)
      CALL STKRDC('DEFAULT',1,16,1,IAV,RC,UNI,NULO,STAT)
      CALL LOWCAS(RC,RC)                        !need it in lower + upper case
      CALL UPCAS(RC,RCUP)
C
C  get result frame + result row (column)
      CALL STKRDC('P1',1,1,80,IAV,LINE,UNI,NULO,STAT)
      OPERAT(1:4) = '.   '
      OPERAT(2:2) = RC
      N = INDEX(LINE,OPERAT(1:2))
      IF (N.LE.0) THEN
         OPERAT(2:2) = RCUP
         N = INDEX(LINE,OPERAT(1:2))
         IF (N.LE.0) CALL STETER(3,ERROR3)             !invalid result string
      ENDIF
C
      FRAMEC(1:) = LINE(1:N-1)//' '                    !extract frame
      CALL CLNFRA(FRAMEC,FRAMEC,0)                     !and clean it
      CALL STFOPN(FRAMEC,D_R4_FORMAT,0,F_IMA_TYPE,IMNOC,STAT)
      CALL STDRDI(IMNOC,'NAXIS',1,1,IAV,NAXIS,UNI,NULO,STAT)
      CALL STDRDI(IMNOC,'NPIX',1,2,IAV,NPIXC,UNI,NULO,STAT)
C
C  check dimensions + get physical min,max into CUTS(3,4)
      IF (NAXIS.LT.2) NPIXC(2) = 1
      CALL STDRDR(IMNOC,'LHCUTS',3,2,IAV,CUTS(3),UNI,NULO,STAT)
C 
      IF (RC.EQ.'r') THEN
         IX = 2
         RCT = '.r'
         ROWSIZ = NPIXC(1)
      ELSE
         IX = 1
         RCT = '.c'
         ROWSIZ = NPIXC(2)
      ENDIF
      ROWLIM = NPIXC(IX)
C 
C  get working space for two input rows
      CALL STFXMP(ROWSIZ,D_R4_FORMAT,PNTR1,STAT)
      CALL STFXMP(ROWSIZ,D_R4_FORMAT,PNTR2,STAT)
C
C  set up working variables depending upon row/column option
      IF (RC.EQ.'r') THEN
         CALL STFXMP(ROWSIZ,D_R4_FORMAT,PNTRC,STAT)
         RESP = PNTRC
      ELSE
         IF (NAXIS.LT.2) CALL STETER(1,
     +      'COMPUTE/COLUMN does not work with 1-dim result frame ...')
         NN = NPIXC(1) * NPIXC(2)
         CALL STFMAP(IMNOC,F_IO_MODE,1,NN,IAV,PNTRC,STAT)    !map all data
         CALL STFXMP(NN,D_R4_FORMAT,PNTRD,STAT)
         NSIZE(1) = 128                          !transpose rows/columns
         NSIZE(2) = 256
         CALL LINCOL(MADRID(PNTRC),NPIXC,NSIZE,MADRID(PNTRD))
         RESP = PNTRD
      ENDIF
C
C  set APIX, BPIX + CPIX last pixels
      APIX(1,2) = ROWSIZ
      BPIX(1,2) = ROWSIZ
      CPIX(1,2) = ROWSIZ
C
C  check dimension and result row (column) no.
      RESROW = 0
      CALL GENCNV(LINE(N+2:60),1,1,RESROW,RDUM,DDUM,LL)
      CALL TSTROW(1,RESROW,ROWLIM,RC)
C
C  get arithmetic expression
      OFF = 1
      DO 400, N=3,8
         CALL STKRDC(PARMS(N),1,1,80,IAV,CBUF,UNI,NULO,STAT)
         IF (CBUF(1:1).EQ.'?') GOTO 500
C
         IF (N.EQ.8) THEN                  !P8 may have embedded blanks
            LINE(OFF:) = CBUF(1:)//' '
            GOTO 510
         ENDIF
C
         IAV = INDEX(CBUF,' ')             !no blanks in here ...
         IF (IAV.LE.1) IAV = 80
         LINE(OFF:) = CBUF(1:)
         OFF = OFF + IAV - 1
400   CONTINUE
C 
500   LINE(OFF:) = ' '
C
C  check for rows/columns from other frames
510   LLINE(1:) = LINE(1:)
      CALL LOWCAS(LLINE,LLINE)
530   K = INDEX(LLINE,RCT)
      IF (K.GT.1) THEN                     !mark for later 
         LLINE(K:K) = '^'
         LINE(K:K) = '^'
         GOTO 530
      ENDIF
C
C  reduce expression...
      IDUMMY = 60
      CALL EXPCLE(LINE,WORK(2),IDUMMY,COUNT,ATOM,LATOM)  !clean up + fill ATOMS
C
      IF (COUNT.EQ.-1) THEN
         CALL STETER(5,'invalid syntax...')
      ELSE IF (COUNT.EQ.-2) THEN
         CALL STETER(6,'buffer overflow...')
C
C  take care of operand without operation
      ELSE IF (COUNT.EQ.1) THEN
         ATOM(2) = '0.'                            !extend F or C to F+C or C+C
         LATOM(2) = 2
         WORK(2)(2:3) = '+C'
         COUNT = 2
      ENDIF
C
      CALL EXPPOL(WORK(2),WORK(1),STAT)             !convert to polish notation
      IF (STAT.NE.0) CALL STETER(3,ERROR3)
      LL = INDEX(WORK(1),' ') - 1
      IF (LL.GT.45) CALL STETER(8,ERROR4)
C
C  now initialize pointers for ATOM
      K = 1
      DO 800,N=1,LL
         IF ((WORK(1)(N:N).EQ.'C').OR.
     +       (WORK(1)(N:N).EQ.'F').OR.
     +       (WORK(1)(N:N).EQ.'Q').OR.
     +       (WORK(1)(N:N).EQ.'P')) THEN
            APNTRS(N) = K
            K = K + 1
         ENDIF
800   CONTINUE
      IDUMMY = 0                                       !init dummy row counter
C
C  create intermediate work file
      NPIXW(1) = ROWSIZ
      NPIXW(2) = 24                        !max. 24 temporary values...
      NN = NPIXW(1) * NPIXW(2)
      CALL STFXMP(NN,D_R4_FORMAT,PNTRW,STAT)
C
C  extract basic operations
1000  CALL EXPRDC(WORK(1),WORK(2),OPERAT,PP)
      IF (PP .LT. 1) CALL STETER(3,ERROR3)
C
C  extract operands
      P1 = APNTRS(PP)
      P2 = APNTRS(PP+1)
      OPERA = ATOM(P1)
      OPERB = ATOM(P2)
      LOPA = LATOM(P1)
      LOPB = LATOM(P2)
      IF (OPERAT(1:1).EQ.'Q') THEN                !treat 2-arg functions...
         P3 = APNTRS(PP+2)
         OPERC = ATOM(P3)
         LOPC = LATOM(P3)
      ENDIF
C
C  find out what kind of operation to do
      N = INDEX(OPERAT,'C')                       !look for constants
      IF (N.GT.0) THEN
         N = INDEX(OPERAT,'F')                    !also F involved...?
         IF (N.GT.0) THEN
            NBRA = -1                             !yes. indicate C,F via N=-1
         ELSE
            GOTO 1200
         ENDIF
      ELSE
         IF (OPERAT(1:1).EQ.'P') THEN
            NBRA = -1                             !indicate PF)
         ELSE
            NBRA = +1                             !indicate F,F via N = +1
         ENDIF
      ENDIF
C
C  determine next dummy row no.
      IDUMMY = IDUMMY + 1                         !increment dummy file counter
      IF (IDUMMY.GT.24) CALL STETER(4,ERROR4)     !check operand count
C
      XPNTR = PNTRW + (IDUMMY-1)*ROWSIZ
      IF (NBRA.EQ.1) THEN                         !now use NBRA from above...
         GOTO 2000
      ELSE
         GOTO 1600                                !everything else: FC, CF, PF
      ENDIF
C
C  only constants involved, do it right now
1200  IF (OPERAT(1:2).EQ.'CC') THEN
         LINE(1:33) = OPERA(1:LOPA)//','//OPERB(1:LOPB)//', '
         CALL GENCNV(LINE(1:33),2,2,IDUM,CONSTA,DDUM,LL)
         IF (LL.LE.0) CALL STETER(2,'invalid number...')
         CALL OPCC(OPERAT,CONSTA(1),CONSTA(2),CONST)
      ELSE
         IF (OPERAT(1:1).EQ.'P') THEN                  !1-arg functions
            CALL GENCNV(OPERB(1:LOPB),2,1,IDUM,CONSTA,DDUM,LL)
            IF (LL.LE.0) CALL STETER(2,'invalid number...')
            CALL FUN1C(OPERA(1:5),CONSTA,CONST)
         ELSE                                          !2-arg functions
            LINE(1:33) = OPERB(1:LOPB)//','//OPERC(1:LOPC)//', '
            CALL GENCNV(LINE(1:33),2,2,IDUM,CONSTA,DDUM,LL)
            IF (LL.LE.0) CALL STETER(2,'invalid number...')
            CALL FUN2CC(OPERA(1:5),CONSTA,CONST)
         ENDIF
      ENDIF
C
C  put resulting constant back into relevant ATOM + goto loopend
      WRITE(ATOM(P1),10000) CONST
      LATOM(P1) = 15
      GOTO 5000
C
C  constant + row involved
1600  IF (OPERAT(1:2).EQ.'FC') THEN
         ROWA = OPERA(1:LOPA)//' '
         LINE(1:17) = OPERB(1:LOPB)//', '
         NBRA = 1                                    !no function
         GOTO 1700
      ENDIF
      IF (OPERAT(1:2).EQ.'CF') THEN
         ROWA = OPERB(1:LOPB)//' '
         LINE(1:17) = OPERA(1:LOPA)//', '
         NBRA = 1                                    !no function
         GOTO 1700
      ENDIF
      IF (OPERAT(1:2).EQ.'PF') THEN
         ROWA = OPERB(1:LOPB)//' '
         NBRA = 2                                    !1-arg function
         GOTO 1700
      ENDIF
      NBRA = 3                                       !2-arg function
      IF (OPERAT(1:2).NE.'QC') THEN
         ROWA = OPERB(1:LOPB)//' '
         LINE(1:17) = OPERC(1:LOPC)//', '
      ELSE
         ROWA = OPERC(1:LOPC)//' '
         LINE(1:17) = OPERB(1:LOPB)//', '
      ENDIF
C 
C  so we have the row definition in ROWA
1700  IFA = INDEX(ROWA,'^')
      IF (IFA .GT. 1) THEN                     !row from a different frame
         CBUF(1:) = ROWA(1:IFA-1)//' '
         ROWA = ROWA(IFA+1:)//' '
         CALL CLNFRA(CBUF,CBUF,0)               !clean frame name
         CALL STFOPN(CBUF,D_R4_FORMAT,0,F_IMA_TYPE,IMNOA,STAT)
         CALL TRANSP(QPNTR,RC,ROWSIZ,CBUF,IMNOA,NAXIS,NPIXA,ZPNTRA)
         ROWLIM = NPIXA(IX)
      ELSE
         IFA = -1                                    !row of result frame
         IMNOA = IMNOC
         ROWLIM = NPIXC(IX)
         ZPNTRA = RESP
      ENDIF
C 
      IF (NBRA.NE.2) THEN
         CALL GENCNV(LINE(1:17),2,1,IDUM,CONST,DDUM,LL)
         IF (LL.LE.0) CALL STETER(2,'invalid number...')
      ENDIF
C
      ROWNOA = 0
      CALL GENCNV(ROWA(2:),1,1,ROWNOA,RDUM,DDUM,LL)
      CALL TSTROW(0,ROWNOA,ROWLIM,RC)
      NN = (ROWNOA-1)*ROWSIZ                       !get offset for row/column
      IF ((ROWA(1:1).EQ.RC) .OR. (ROWA(1:1).EQ.RCUP)) THEN
         IF (RC.EQ.'c') THEN
            APNTR = ZPNTRA + NN
         ELSE
            APNTR = PNTR1
            NN = NN + 1
            CALL STFGET(IMNOA,NN,ROWSIZ,IAV,MADRID(APNTR),STAT)
         ENDIF
      ELSE
         APNTR = PNTRW + NN             !work row, e.g. x0003
      ENDIF
C
C  now do the actual OPERATion
      GOTO (1850,1860,1870),NBRA                        !branch accordingly...
1850  CALL OPFC(OPERAT,MADRID(APNTR),CONST,MADRID(XPNTR),
     +          ROWSIZ,USRNUL,NCN)
      GOTO 4400
1860  CALL FUN1F(OPERA(1:5),MADRID(APNTR),MADRID(XPNTR),
     +          ROWSIZ,USRNUL,NCN)
      GOTO 4400
1870  CALL FUN2FC(OPERA(1:5),MADRID(APNTR),CONST,MADRID(XPNTR),
     +          ROWSIZ,USRNUL,NCN)
      GOTO 4400
C
C  both operands are rows
2000  IF (OPERAT(1:1).NE.'Q') THEN
         ROWA = OPERA(1:LOPA)//' '
         ROWB = OPERB(1:LOPB)//' '
      ELSE
         ROWA = OPERB(1:LOPB)//' '
         ROWB = OPERC(1:LOPC)//' '
      ENDIF
C 
      IFA = INDEX(ROWA,'^')
      IF (IFA .GT. 1) THEN                     !row from a different frame
         CBUF(1:) = ROWA(1:IFA-1)//' '
         ROWA = ROWA(IFA+1:)//' '
         CALL CLNFRA(CBUF,CBUF,0)               !clean frame name
         CALL STFOPN(CBUF,D_R4_FORMAT,0,F_IMA_TYPE,IMNOA,STAT)
         CALL TRANSP(QPNTR,RC,ROWSIZ,CBUF,IMNOA,NAXIS,NPIXA,ZPNTRA)
         ROWLIM = NPIXA(IX)
      ELSE
         IFA = -1
         IMNOA = IMNOC
         ROWLIM = NPIXC(IX)
         ZPNTRA = RESP
      ENDIF
C
      ROWNOA = 0
      CALL GENCNV(ROWA(2:),1,1,ROWNOA,RDUM,DDUM,LL)
      CALL TSTROW(0,ROWNOA,ROWLIM,RC)
      NN = (ROWNOA-1)*ROWSIZ                       !get offset for row/column
      IF ((ROWA(1:1).EQ.RC) .OR. (ROWA(1:1).EQ.RCUP)) THEN
         IF (RC.EQ.'c') THEN
            APNTR = ZPNTRA + NN
         ELSE
            APNTR = PNTR1
            NN = NN + 1
            CALL STFGET(IMNOA,NN,ROWSIZ,IAV,MADRID(APNTR),STAT)
         ENDIF
      ELSE
         APNTR = PNTRW + NN                           !work row, e.g. x0003
      ENDIF
C 
      IFB = INDEX(ROWB,'^')
      IF (IFB .GT. 1) THEN                     !row from a different frame
         CBUF(1:) = ROWB(1:IFB-1)//' '
         ROWB = ROWB(IFB+1:)//' '
         CALL CLNFRA(CBUF,CBUF,0)               !clean frame name
         CALL STFOPN(CBUF,D_R4_FORMAT,0,F_IMA_TYPE,IMNOB,STAT)
         CALL TRANSP(QPNTR,RC,ROWSIZ,CBUF,IMNOB,NAXIS,NPIXB,ZPNTRB)
         ROWLIM = NPIXB(IX)
      ELSE
         IFB = -1
         IMNOB = IMNOC
         ROWLIM = NPIXC(IX)
         ZPNTRB = RESP
      ENDIF
C 
      ROWNOB = 0
      CALL GENCNV(ROWB(2:),1,1,ROWNOB,RDUM,DDUM,LL)
      CALL TSTROW(0,ROWNOB,ROWLIM,RC)
      NN = (ROWNOB-1)*ROWSIZ                       !get offset for row/column
      IF ((ROWB(1:1).EQ.RC) .OR. (ROWB(1:1).EQ.RCUP)) THEN
         IF (RC.EQ.'c') THEN
            BPNTR = ZPNTRB + NN
         ELSE
            BPNTR = PNTR2
            NN = NN + 1
            CALL STFGET(IMNOB,NN,ROWSIZ,IAV,MADRID(BPNTR),STAT)
         ENDIF
      ELSE
         BPNTR = PNTRW + NN                           !work row, e.g. x0003
      ENDIF
C
C  let CPIX reflect the affected row in the working buffer
      CPIX(2,1) = IDUMMY
      CPIX(2,2) = IDUMMY
C
C  now do the actual OPERAT
      IF (OPERAT(1:1).NE.'Q') THEN
         CALL OPFFW(OPERAT,MADRID(APNTR),MADRID(BPNTR),
     +              MADRID(PNTRW),APIX,BPIX,CPIX,
     +              NPIXA,NPIXB,NPIXC)
      ELSE
         CALL FN2FFW(OPERA(1:5),MADRID(APNTR),MADRID(BPNTR),
     +               MADRID(PNTRW),APIX,BPIX,CPIX,
     +               NPIXA,NPIXB,NPIXC)
      ENDIF
C
C  put resulting row back into relevant ATOM
4400  WRITE(LINE,10001) IDUMMY
      ATOM(P1)(1:) = 'x'//LINE(1:4)
      LATOM(P1) = 5
      NULCNT = NULCNT + NCN
C
C  loopend for all basic operations
C 
5000  IF (WORK(2)(2:).EQ.' ') GOTO 9000            !finished...
C 
      IF (OPERAT(1:1).NE.'Q') THEN
         NBRA = 2
      ELSE
         NBRA = 3
      ENDIF
      DO 5300,N=PP+1,45                            !update pointers for ATOM
         APNTRS(N) = APNTRS(N+NBRA)
5300  CONTINUE
      WORK(1) = WORK(2)
      GOTO 1000                                    !get next operation
C
C  We made it... test, if frame or constant
C
9000  IF (RC.EQ.'r') THEN
         IF (WORK(2)(1:1).EQ.'C') THEN
            CALL OPFC('FC=',0.,CONST,MADRID(RESP),ROWSIZ,USRNUL,NCN)
         ELSE
            APNTR = PNTRW + (IDUMMY-1)*ROWSIZ
            CALL COPYF(MADRID(APNTR),MADRID(RESP),ROWSIZ)
         ENDIF
         NN = (RESROW-1)*ROWSIZ + 1                   !write result row back 
         CALL STFPUT(IMNOC,NN,ROWSIZ,MADRID(RESP),STAT)
C 
      ELSE
         BPNTR = RESP + (RESROW-1)*ROWSIZ 
         IF (WORK(2)(1:1).EQ.'C') THEN
            CALL OPFC('FC=',0.,CONST,MADRID(BPNTR),ROWSIZ,USRNUL,NCN)
         ELSE
            APNTR = PNTRW + (IDUMMY-1)*ROWSIZ
            CALL COPYF(MADRID(APNTR),MADRID(BPNTR),ROWSIZ)
         ENDIF
      ENDIF
C
C  calculate new dynamic range of result frame
      CALL MYMX(MADRID(RESP),ROWSIZ,CUTS(1))
      IF (CUTS(1).LT.CUTS(3)) CUTS(3) = CUTS(1)
      IF (CUTS(2).GT.CUTS(4)) CUTS(4) = CUTS(2)
      CALL STDWRR(IMNOC,'LHCUTS',CUTS(3),3,2,UNI,STAT)
C 
C  update descr. HISTORY
      LINE(1:) = ' '
      CALL DSCUPT(IMNOC,IMNOC,LINE,STAT)
C
C  if we worked on columns, transpose result frame back
      IF (RC.EQ.'c') THEN
         NPIXW(1) = NPIXC(2)
         NPIXW(2) = NPIXC(1)
         CALL LINCOL(MADRID(PNTRD),NPIXW,NSIZE,MADRID(PNTRC))
      ENDIF
C
      RNULL(1) = FLOAT(NULCNT)
      CALL STKWRR('NULL',RNULL,1,1,UNI,STAT)
      CALL STSEPI
C
C  formats...
10000 FORMAT(G15.7)
10001 FORMAT(I4.4)
      END

      SUBROUTINE TRANSP(QPNTR,CC,SIZE,FRAME,IMNOA,NAXIS,NPIX,PNTR)
C 
      IMPLICIT NONE
C 
      INTEGER   NAXIS,NPIX(2),SIZE,IMNOA
      INTEGER   IMNO,NS(2),STAT,MM,MQ,N,IAV
      INTEGER*8 PNTR,XPNTR,QPNTR(24)
      INTEGER   QIMNO(24)
      INTEGER   UNI(1),NULO,MADRID(1)
C 
      DOUBLE PRECISION  START(2),STEP(2)
C 
      CHARACTER     CC*1,FRAME*(*)
      CHARACTER     IDENT*20,CUNIT*20
C 
      COMMON   /VMR/  MADRID
      COMMON   /TIMNOS/  QIMNO
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      DATA    IDENT /' '/, CUNIT /' '/
C 
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C 
      CALL STDRDI(IMNOA,'NAXIS',1,1,IAV,NAXIS,UNI,NULO,STAT)
      CALL STDRDI(IMNOA,'NPIX',1,2,IAV,NPIX,UNI,NULO,STAT)
C 
      IF (CC.EQ.'r') THEN
         IF (NAXIS.EQ.1) NPIX(2) = 1
         IF (NPIX(1).NE.SIZE)
     +      CALL STETER(11,'non-matching row size...')
      ELSE
         IF (NAXIS.EQ.1) THEN
            IF (NPIX(1).NE.SIZE)
     +         CALL STETER(11,'non-matching column size...')
C 
            DO 100, N=1,24
               IF (QIMNO(N).LT.0) THEN
                  MQ = N
                  GOTO 200
               ELSE IF (QIMNO(N).EQ.IMNOA) THEN
                  PNTR = QPNTR(N)
                  RETURN
               ENDIF
100         CONTINUE
            CALL STETER(12,'Too many frames in expression...')
C 
200         CALL STIGET(FRAME,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +                  1,NAXIS,NPIX,START,STEP,
     +                  IDENT,CUNIT,PNTR,IMNO,STAT)
            NPIX(2) = NPIX(1)
         ELSE
            IF (NPIX(2).NE.SIZE)
     +         CALL STETER(11,'non-matching column size...')
C 
            DO 400, N=1,24
               IF (QIMNO(N).LT.0) THEN
                  MQ = N
                  GOTO 500
               ELSE IF (QIMNO(N).EQ.IMNOA) THEN
                  PNTR = QPNTR(N)
                  RETURN
               ENDIF
400         CONTINUE
            CALL STETER(12,'Too many frames in expression...')
C 
500         CALL STIGET(FRAME,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +                  2,NAXIS,NPIX,START,STEP,
     +                  IDENT,CUNIT,XPNTR,IMNO,STAT)
            QIMNO(MQ) = IMNO
C 
            MM = NPIX(1)*NPIX(2)
            CALL STFXMP(MM,D_R4_FORMAT,PNTR,STAT)
            NS(1) = 128
            NS(2) = 256
            CALL LINCOL(MADRID(XPNTR),NPIX,NS,MADRID(PNTR))
            QPNTR(MQ) = PNTR
         ENDIF
      ENDIF
C 
      RETURN
      END

      SUBROUTINE TSTROW(FLAG,RNO,ROWMAX,CC)
C 
      IMPLICIT NONE
C 
      INTEGER   FLAG,RNO,ROWMAX
      INTEGER   EFLAG
C 
      CHARACTER*1   CC
      CHARACTER     BUBI*80
C 
      IF ( (RNO.LT.1).OR.(RNO.GT.ROWMAX) ) THEN
         EFLAG = 7
C 
         IF (CC.EQ.'r') THEN                      !problems with rows
            IF (FLAG.EQ.0) THEN
               IF (RNO .EQ. 0) THEN
                  EFLAG = 3
                  BUBI(1:) = 'Invalid row specification... '
               ELSE
                  WRITE(BUBI,10001) RNO
               ENDIF
            ELSE                                  !concerns result row
               IF (RNO .EQ. 0) THEN
                  EFLAG = 3
                  BUBI(1:) = 'Invalid result row specification... '
               ELSE
                  WRITE(BUBI,20001) RNO
               ENDIF
            ENDIF
C 
         ELSE                                     !problems with columns
            IF (FLAG.EQ.0) THEN
               IF (RNO .EQ. 0) THEN
                  EFLAG = 3
                  BUBI(1:) = 'Invalid  column specification... '
               ELSE
                  WRITE(BUBI,10002) RNO
               ENDIF
            ELSE                                  !concerns result column
               IF (RNO .EQ. 0) THEN
                  EFLAG = 3
                  BUBI(1:) = 'Invalid result column specification... '
               ELSE
                  WRITE(BUBI,20002) RNO
               ENDIF
            ENDIF
         ENDIF
C 
         CALL STETER(EFLAG,BUBI)
      ENDIF
C 
      RETURN
C
10001 FORMAT('row ',I4,' not inside frame... ')
10002 FORMAT('column ',I4,' not inside frame... ')
20001 FORMAT('result row ',I4,' not inside frame... ')
20002 FORMAT('result column ',I4,' not inside frame... ')
C 
      END

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C       Internet e-mail: midas@eso.org
C       Postal address: European Southern Observatory
C                       Data Management Division 
C                       Karl-Schwarzschild-Strasse 2
C                       D 85748 Garching bei Muenchen 
C                       GERMANY
C===========================================================================
C


      program fitlyman
      
      implicit none
      include 'MID_REL_INCL:fit_var.inc'
      
                                ! copies of keywords coming from line
      character*80 SPESYS,SESSYS,OUTSYS,HISSYS
      integer GRASYS


      character*30 choice
      character*70 sjunk,ErrMes
      character*60 filnam


      integer ifla,ist,i,ijk,icur,IDold,iok
      real xdum,ydum,zdum,vdum,c
      parameter (c=2.997e5)
      logical la

C      include 'MID_REL_INCL:fit_mid.inc'
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'

C!!!!!!!
C     MIDAS SET-UP
C!!!!!!!
      call STSPRO('fitlyman')
      
      call STKRDC('SPECTAB',1,1,80,i,SPESYS,ijk,ijk,iok)
      call STKRDC('OUTTAB',1,1,80,i,OUTSYS,ijk,ijk,iok)
      call STKRDC('HISTAB',1,1,80,i,HISSYS,ijk,ijk,iok)
      call STKRDC('SESSNAM',1,1,80,i,SESSYS,ijk,ijk,iok)
      call STKRDI('GRAWIN',1,1,i,GRASYS,ijk,ijk,iok)


C!!!!!!!
C     Videata iniziale
C!!!!!!!
      choice = ' '
      do i=1,4
         call sttdis(choice,0,ist)
      end do
      
      sjunk = '      - FitLyman-   Lyman clouds fitting procedure'
      do i=1,2
         call sttdis(' ',0,ist)
      end do
      call DisMsg('Loading & initializing data...')
      call DisMsg('Wait please..')
      
C!!!!!!!
C     Inizializzazione programma
C!!!!!!!
      if (SESSYS.ne.'NULL') then
         i=index(SESSYS,' ')
         sjunk=SESSYS(1:i-1)//PARTBL
      else
         sjunk=PARTBL
      end if
      call rsetup(sjunk,ist)  ! read set-up 

      if (ist.ne.0) then        ! on error, default values
         
         call WrnMsg('Error in reading set-up: using defaults')
                                ! copy syskeys into variables
         if (SPESYS.ne.'NULL') then
            FILSPE=SPESYS
         else
           call ErrMsg('Missing input spectrum file')
           call STSEPI() 
           stop
         end if   

         if (OUTSYS.ne.'NULL') then
            FILOUT=OUTSYS
         else
            i=index(FILSPE,' ')
            FILOUT=FILSPE(1:i-1)//'FIT'
         end if   

         if (HISSYS.ne.'NULL') then
            FILLOG=HISSYS
         else
            FILLOG=FILSPE
         end if   
         
         TURBLN=0
         i_grap = .false.
         if (GRASYS.ne.0) i_grap = .true.

         call F_TBLR('SCRATCH',1,ist) !initializes lypar (in memory!)

      else
         call f_tblr(sjunk,1,ist) !read init. param.
         if (SPESYS.ne.'NULL') FILSPE=SPESYS ! overrides values read
         if (OUTSYS.ne.'NULL') FILOUT=OUTSYS
         if (HISSYS.ne.'NULL') FILLOG=HISSYS
         if (GRASYS.ne.-1) then
            if (GRASYS .eq.1) then
               i_grap = .true.
            else
               i_grap = .false.
            end if
         end if

      end if

      call f_tblw(PARTBL,1,ist)
c     call AskStp('PROGRAM',ist)
      call ssetup(PARTBL,ist)
      if (ist.ne.0) then
         call ErrMsg('Error in writing set-up: check disk space')
         call STSEPI() 
         stop
      end if   

      call AtmRD(ist)            !read atompar.dat
      NPUNTI=NMXSPE
      call reaspe(FILSPE,NPUNTI)    !read spectrum
      if (NPUNTI.lt.1) then
         call STSEPI() 
         stop
      endif
      i=index(FILLOG,' ')
      filnam=fillog(1:i-1)//PARTBL
      call GETIDN(filnam,IDnum,ist) 
      if (ist.ne.0) then
         call WrnMsg('Log files not found: starting from scratch')
         IDnum=0
      end if
                                ! read fit limits
      if (SESSYS.ne.'NULL') then
         i=index(SESSYS,' ')
         sjunk=SESSYS(1:i-1)//LIMTBL
      else
         sjunk=LIMTBL
      end if   
      call rintvl(sjunk,1,ist)  
      call sintvl(sjunk,1,ist) 

                                ! read minuit instructions
      if (SESSYS.ne.'NULL') then
         i=index(SESSYS,' ')
         sjunk=SESSYS(1:i-1)//MINTBL
      else
         sjunk=MINTBL
      end if   
      call rminui(sjunk,1,ist) 
      call sminui(sjunk,1,ist)

      call ReaRes
      call GraMai(ist)          ! plot 


      call DisMsg('        ..done')
      call sttdis(' ',0,ist)
      
C!!!!!!!
C     Menu pricipale
C!!!!!!!
     
 1001 continue 
      
         choice = ' '
         call MMenu(choice)
         
C####
C     SAVESESSION
C####
         if (choice.eq.'SAVESESSION') then ! saves a session 
            ifla=-2
            call AskC('Session name',sjunk,ifla)
            i=index(sjunk,' ')
            filnam=sjunk(1:i-1)//PARTBL
            call f_tblw(filnam,1,ifla)
            call ssetup(filnam,ifla)

            filnam=sjunk(1:i-1)//LIMTBL
            call sintvl(filnam,1,ifla)

            filnam=sjunk(1:i-1)//MINTBL
            call sminui(filnam,1,ifla)
         end if


C####
C     RECOVER
C####
         if (choice.eq.'RECOVER') then ! load a session 
            ifla=-2
            call AskC('Session name',sjunk,ifla)
            i=index(sjunk,' ')
            filnam=sjunk(1:i-1)//PARTBL
            call f_tblr(filnam,1,ifla)
            call rsetup(filnam,ifla)

            filnam=sjunk(1:i-1)//LIMTBL
            call rintvl(filnam,1,ifla)

            filnam=sjunk(1:i-1)//MINTBL
            call rminui(filnam,1,ifla)

            call GraMai(ifla)

            call ShPar1('NORMAL')
            call f_tblw(PARTBL,1,ifla)
            call ssetup(PARTBL,ifla) ! saves on std tbl
            call sintvl(LIMTBL,1,ifla)
            call sminui(MINTBL,1,ifla)
         end if


C####
C     SETUP
C####
         if (choice.eq.'SET-UP') then ! ASK FOR SETUP VALUES
            call AskStp(' ',ifla)
            if (ifla.eq.0) then
               call ssetup(PARTBL,ifla) !saves new setup
            else
               call rsetup(PARTBL,ifla) ! load old setup
            end if
            call GraMai(ifla)
         end if



C####
C     END
C####
        if (choice.eq.'END') then 
            if (I_GRAP) then
               call PTCLOS ()
            end if
c            close(IHFILE_LOG)
            call STSEPI() 
            stop
         end if   

C####
C     NEW
C####
         if (choice.eq.'NEWLINE') then ! load a scratch session 
            call f_tblr('SCRATCH',1,ifla)
            call rintvl('SCRATCH',1,ifla)
            call rminui('SCRATCH',1,ifla)

            call f_tblw(PARTBL,1,ifla) ! saves on std tbl
            call ssetup(PARTBL,ist)
            call sintvl(filnam,1,ifla)
            call sminui(filnam,1,ifla)

         end if


C####
C     ITERATE
C####
         if (choice.eq.'ITERATE') then ! load from results
            call ShoRes         ! Carica l'ultimo fit
            do i=1,NROWS
               LamIni(i)=LamCen(i)
               NIni(i)=NHfit(i)
               BIni(i)=BDopp(i)
               BTuIni(i)=BTur(i)
            end do
            call ShPar1('NORMAL')
            call f_tblw(PARTBL,1,ifla) ! saves on std tbl
            call ssetup(PARTBL,ist)
            call sintvl(LIMTBL,1,ifla)
            call sminui(MINTBL,1,ifla)
         end if

C####
C     HISTORY
C####
         if (choice.eq.'HISTORY') then ! load from logfiles
            call AskI('Input ID number to be loaded:',IDold,iok)
            if (iok.ne.-1)  then

               i=index(FILLOG,' ')
               filnam=FILLOG(1:i-1)//PARTBL !reads from logfile
               call f_tblr(filnam,IDold,ist)
               if (ist.ne.0) then
                  call ErrMsg('Error in reading parameter table')
                  call f_tblr(PARTBL,1,ist) ! reads standard tables
                  call rminui(MINTBL,1,ist)
                  call rintvl(LIMTBL,1,ist)
                  goto 1001
               end if   

               filnam=FILLOG(1:i-1)//MINTBL !reads from logfile
               call rminui(filnam,IDold,ist)
               if (ist.ne.0) then
                  call ErrMsg('Error in reading minuit command table')
                  call f_tblr(PARTBL,1,ist) ! reads standard tables
                  call rminui(MINTBL,1,ist)
                  call rintvl(LIMTBL,1,ist)
                  goto 1001
               end if   

               filnam=FILLOG(1:i-1)//LIMTBL !reads from logfile
               call rintvl(filnam,IDold,ist)
               if (ist.ne.0) then
                  call ErrMsg('Error in reading interval table')
                  call f_tblr(PARTBL,1,ist) ! reads standard tables
                  call rminui(MINTBL,1,ist)
                  call rintvl(LIMTBL,1,ist)
                  goto 1001
               end if   

               call ShPar1('NORMAL') !Shows new parameters

               call f_tblw(PARTBL,1,ist) ! save on standard tables
               call ssetup(PARTBL,ist)
               call sminui(MINTBL,1,ist)
               call sintvl(LIMTBL,1,ist)

            end if
         end if

         
C####
C    STANDARD 
C####
         
         if (choice.eq.'STANDARD') then 

 501        call AskPar(ifla)
            if (ifla.ne.0) then     !quit
               call f_tblr(PARTBL,1,ifla)
               if (ifla.ne.0) call ErrMsg('Error in reading lypar.tbl')
               goto 1001
           end if

            call ChkPar(ErrMes,ifla)
            if (ifla.ne.0) then
               call ErrMsg(ErrMes)
               goto 1001
            end if
            call AddAtP(ifla)
            if (ifla.ne.0) then
               call ErrMsg('Atomic parameter not found')
               goto 1001
            end if

            call AdCoef()
            call AddInp()
            call AdPLim()
            call f_tblw(PARTBL,1,ifla)
            if (ifla.ne.0) then
               call ErrMsg('Error in writing lypar.tbl')
               goto 1001
            end if
            call ssetup(PARTBL,ist)

 511        call AskFIn(ifla)
            if (ifla.ne.0) then     !quit
               call rintvl(LIMTBL,1,ifla)
               goto 501
            else
               call sintvl(LIMTBL,1,ifla)
            end if

            call AskMin(ifla)
            if (ifla.ne.0) then     !quit
               call rminui(MINTBL,1,ifla)
               goto 1001 !goes back to main menu
            else
               call sminui(MINTBL,1,ifla)
            end if
            
            call sttdis('  ',0,ifla)
            call DisMsg('Preparing minimization data...')
            call FitWin(i,ifla) ! create data for FCN
            if (ifla.lt.0) then
               call ErrMsg('Error in initial condition for fit')
               goto 1001         ! torna al menu' principale
            end if
            call FCNHd()
            call MinuHd()
            call DisMsg('...Done')
            write(sjunk,'(a25,i6)')'Number of pixel selected:',i
            call DisMsg(sjunk)

C       Esegue il fit
            call DisMsg('Executing fitting procedures...')
            call Minmze()
            call DisMsg('...Done')

C       Presenta e salva i risultati
            call ShoRes
            call GraMai(ifla)

C       SAVE?
            call sttdis(' ',0,ist)
            call AskYN('Save results in work & log  files? [Y/N]',
     1           la,ist)
            if (la) then               
               IDnum=IDNum+1
               call SavRes(FILOUT,ist)

               i=index(FILLOG,' ') !saves on history file 
               filnam=FILLOG(1:i-1)//PARTBL
               call f_tblw(filnam,IDNum,ist)

               filnam=FILLOG(1:i-1)//MINTBL
               call sminui(filnam,IDNum,ist)

               filnam=FILLOG(1:i-1)//LIMTBL
               call sintvl(filnam,IDNum,ist)
            
               write(sjunk,'(a17,i6)')'Saved with ID =  ',IDnum
               call DisMsg(sjunk)

            end if
            
         end if

C####
C    EDITPARAM
C####
         if (choice.eq.'EDITPARAM') then 
 601        call EdtPar(ifla)
            if (ifla.ne.0) then       !quit
               call f_tblr(PARTBL,1,ifla)
               if (ifla.ne.0) then
                  call ErrMsg('Error in reading lypar')
                  goto 1001
               end if               
            else
               call sttdis('  ** Checking consistency of lypar.tbl...',
     1              0,ist)
               call ChkPar(ErrMes,ifla)
               if (ifla.ne.0) then
                  call ErrMsg(ErrMes)
                  goto 601      ! edit again..
               end if
            call sttdis('                                      ...done'
     1           ,0,ist)

               call AddAtP(ifla)
               if (ifla.ne.0) then
                  call ErrMsg('Atomic parameter not found')
                  goto 601      ! edit again..
               end if

               call AdCoef()

               call AddInP()

               call AdPLim()
               call f_tblw(PARTBL,1,ifla)
               if (ifla.ne.0) then
                  call ErrMsg('Error in writing lypar')
                  goto 1001
               end if               
               call ssetup(PARTBL,ist)
            end if
         end if

C####
C    EDITLIM
C####
         if (choice.eq.'EDITLIM') then 
            call AskFIn(ifla)
            if (ifla.ne.0) then
               call rintvl(LIMTBL,1,ifla)
            else
               call sintvl(LIMTBL,1,ifla)
            end if
         end if

C####
C    EDITMINUIT
C####
         if (choice.eq.'EDITMINUIT') then 
            call AskMin(ifla)
            if (ifla.ne.0) then
               call rminui(MINTBL,1,ifla)
            else
               call sminui(MINTBL,1,ifla)
            end if
         end if

C####
C    DIRECTMINI
C####
         if (choice.eq.'DIRECTMINI') then 
            call DisMsg('Preparing minimization data...')

            call f_tblr(PARTBL,1,ifla)
            if (ifla.ne.0) then
               call ErrMsg('Error in reading lypar')
               goto 1001
            end if               
                       
            call rintvl(LIMTBL,1,ifla)
            if (ifla.ne.0)  then
               call ErrMsg('Error in reading lypar')
               goto 1001
            end if

            call rminui(MINTBL,1,ifla)
            if (ifla.ne.0)  then
               call ErrMsg('Error in reading lypar')
               goto 1001
            end if
            
            call FitWin(i,ifla) ! create data for FCN
            if (ifla.lt.0) then
               call ErrMsg('Error in initial condition for fit')
               goto 1001         ! torna al menu' principale
            end if
            call FCNHd()
            call MinuHd()
            call DisMsg('...Done')
            write(sjunk,'(a25,i6)')'Number of pixel selected:',i
            call DisMsg(sjunk)

C       Esegue il fit
            call DisMsg('Executing fitting procedures...')
            call Minmze()
            call DisMsg('...Done')

C       Presenta e salva i risultati
            call ShoRes
            call GraMai(ifla)

C       SAVE?
            call sttdis(' ',0,ist)
            call AskYN('Save results in work & log  files? [Y/N]',
     1           la,ist)
            if (la) then               
               IDnum=IDNum+1
               call SavRes(FILOUT,ist)

               i=index(FILLOG,' ') !saves on history file 
               filnam=FILLOG(1:i-1)//PARTBL
               call f_tblw(filnam,IDNum,ist)

               filnam=FILLOG(1:i-1)//MINTBL
               call sminui(filnam,IDNum,ist)

               filnam=FILLOG(1:i-1)//LIMTBL
               call sintvl(filnam,IDNum,ist)

               write(sjunk,'(a17,i6)')'Saved with ID =  ',IDnum
               call DisMsg(sjunk)

            end if

         end if


C####
C    DEFINEWINDOW
C####
         if (choice.eq.'DEFINEWINDOW') then
            call DefGrW(ifla)
            if (ifla.eq.0) then
               call ssetup(PARTBL,ifla)
               call GraMai(ifla)
            end if
         endif
         
C####
C    CURSOR
C####
         if (choice.eq.'CURSOR') then
            call GetXCr(xdum,ydum,zdum,vdum,icur)
         end if         
         
         
C####
C    GOBACK
C####
         if (choice.eq.'GOBACK') then
            if (I_Z) then
               REDSH=(-2.*VELRAN*4./5.-REDSH*VELRAN*4./5.+2.*c*REDSH)
     1              /(2.*c + VELRAN*4./5.)
            else
               do ijk = 1,NREGIO
                  REGMIN(ijk) = REGMIN(ijk) - WINSTE(ijk)*4./5.
                  REGMAX(ijk) = REGMAX(ijk) - WINSTE(ijk)*4./5.
               end do
            end if
            call GraMai(ifla)
            call ssetup(PARTBL,ifla) !saves new setup
         endif
         
C####
C    GOFORW
C####
         if (choice.eq.'GOFORW') then
            if (I_Z) then
               REDSH=(2.*VELRAN*4./5.+REDSH*VELRAN*4./5.+2.*c*REDSH)
     1              /(2.*c - VELRAN*4./5.)
            else
               do ijk = 1,NREGIO
                  REGMIN(ijk) = REGMIN(ijk) + WINSTE(ijk)*4./5.
                  REGMAX(ijk) = REGMAX(ijk) + WINSTE(ijk)*4./5.
               end do
            end if
            call GraMai(ifla)
            call ssetup(PARTBL,ifla) !saves new setup
         end if
         
      goto 1001
      end
      

C @(#)setup.for	10.1 (ESO-IPG) 2/9/96 13:56:59
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C       Internet e-mail: midas@eso.org
C       Postal address: European Southern Observatory
C                       Data Management Division 
C                       Karl-Schwarzschild-Strasse 2
C                       D 85748 Garching bei Muenchen 
C                       GERMANY
C===========================================================================
C
C

C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE SSETUP(TblNam,IER)
C
C     
C       Saves the system parameters on the descriptors 
C       of the table
C     Onerror in creating the table,  ier=1
C     otherwise ier=0
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        implicit none

        character*(*) TblNam
        integer ier

        include 'MID_REL_INCL:fit_var.inc'

        integer i1,i2,i3,i
        integer TabID,ist
        CHARACTER*20 CDESCN(50)
        CHARACTER*20 IDESCN(50)
        CHARACTER*20 RDESCN(50)
        CHARACTER*20 appogg

        integer NIDESC,NCDESC,nrdesc

C        include 'MID_REL_INCL:fit_mid.inc'
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'

        CDESCN(1)='SPECTRUMTABLE'
        CDESCN(2)='OUTTAB'
        CDESCN(3)='LOGNAME'
        CDESCN(4)='GRALAB'
        CDESCN(5)='ZPLOT'
        NCDESC=5

        IDESCN(1)='TURBOLENCE'
        IDESCN(2)='GRAPHWIN'
        IDESCN(3)='I_MINOS'
        IDESCN(4)='GCOLOR'
        IDESCN(5)='I_RESIDUALS'
        IDESCN(6)='I_STDEV'
        IDESCN(7)='GREGION'
        NIDESC=7

        RDESCN(1)='LAMBDA_LIM'
        RDESCN(2)='COLDEN_LIM'
        RDESCN(3)='BTEMP_LIM'
        RDESCN(4)='BTURB_LIM'
        RDESCN(5)='GRAPH_BOTTOM'
        RDESCN(6)='GRAPH_TOP'
        RDESCN(7)='GRAPH_MIN'
        RDESCN(8)='GRAPH_MAX'
        RDESCN(9)='GRAPH_STEP'
        RDESCN(10)='GRAPH_LABEL'
        RDESCN(11)='GRAPH_TICK'
        RDESCN(12)='REDSHIFT'
        RDESCN(13)='VELRANGE'
        NRDESC=13

        i1=1                    !doesn't stop at errors..
        i2=0
        i3=0
        call STECNT('PUT',i1,i2,i3)

        call TBTOPN(TblNam,F_IO_MODE,TabID,ist)   !open
        if (ist .ne. 0 ) then       ! if it doesn't exist, create
           ier=1
           return
        end if

        do i=1,NCDESC           ! delete descriptors
           call STDDEL(TabID,CDESCN(i),IST)
        end do
        do i=1,NIDESC
           call STDDEL(TabID,IDESCN(i),IST)
        end do
        do i=1,NRDESC
           call STDDEL(TabID,RDESCN(i),IST)
        end do

        call STDWRC(TabID,CDESCN(1),1,FILSPE,1,60,I1,ist)
        call STDWRC(TabID,CDESCN(2),1,FILOUT,1,60,I1,ist)
        call STDWRC(TabID,CDESCN(3),1,FILLOG,1,60,I1,ist)
        if (NREGIO.gt.0) then
           do i=1,NREGIO
              write(appogg,'(a6,i2.2)')CDESCN(4),i
              call STDWRC(TabID,appogg,1,LLABEL(i),1,60,I1,ist)
           end do
        end if
c        call STDWRC(TabID,CDESCN(4),1,FILLOG,1,60,I1,ist)
        if (I_Z) then
           call STDWRC(TabID,CDESCN(5),1,'TRUE',1,60,I1,ist)
        else
           call STDWRC(TabID,CDESCN(5),1,'FALSE',1,60,I1,ist)
        endif
        call STDWRI(TabID,IDESCN(1),TURBLN,1,1,I1,ist)
        I2=0
        IF (I_GRAP) I2=1
        call STDWRI(TabID,IDESCN(2),I2,1,1,I1,ist)
        call STDWRI(TabID,IDESCN(3),IMINOS,1,1,I1,ist)
        call STDWRI(TabID,IDESCN(4),GCOLOR,1,7,I1,ist)
        I2=0
        IF (I_RESD) I2=1
        call STDWRI(TabID,IDESCN(5),I2,1,1,I1,ist)
        I2=0
        IF (I_VAR) I2=1
        call STDWRI(TabID,IDESCN(6),I2,1,1,I1,ist)
        call STDWRI(TabID,IDESCN(7),NREGIO,1,1,I1,ist)

        call STDWRD(TabID,RDESCN(1),LAMLIM,1,3,I1,ist)
        call STDWRD(TabID,RDESCN(2),NLIM,1,3,I1,ist)
        call STDWRD(TabID,RDESCN(3),BLIM,1,3,I1,ist)
        call STDWRD(TabID,RDESCN(4),BTULIM,1,3,I1,ist)
        call STDWRD(TabID,RDESCN(5),GR_BOT,1,1,I1,ist)
        call STDWRD(TabID,RDESCN(6),GR_TOP,1,1,I1,ist)
        if (NREGIO.gt.0) then
           call STDWRD(TabID,RDESCN(7),REGMIN,1,NREGIO,I1,ist)
           call STDWRD(TabID,RDESCN(8),REGMAX,1,NREGIO,I1,ist)
           call STDWRD(TabID,RDESCN(9),WINSTE,1,NREGIO,I1,ist)
        end if
        call STDWRD(TabID,RDESCN(10),GR_LAB,1,1,I1,ist)
        call STDWRD(TabID,RDESCN(11),GR_TIC,1,1,I1,ist)
        call STDWRD(TabID,RDESCN(12),REDSH,1,1,I1,ist)
        call STDWRD(TabID,RDESCN(13),VELRAN,1,1,I1,ist)
        CALL TBTCLO(TabID,ist)

        i1=0                    !reset standard values
        i2=2
        i3=1
        call STECNT('PUT',i1,i2,i3)


        return
        end



C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        SUBROUTINE RSETUP(TblNam,IER)
C
C     
C       READS the system parameters from the descriptors 
C       of the table TblNam
C       On error in opening the table or reading filenames,  ier=1
C       On less severe errors, ier=2, and param. are set to defaults
C       otherwise ier=0
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        implicit none

        character*(*) TblNam
        integer ier

        include 'MID_REL_INCL:fit_var.inc'

        integer i1,i2,i3,itmp,i
        integer TabID,ist

        CHARACTER*20 CDESCN(50)
        CHARACTER*20 IDESCN(50)
        CHARACTER*20 RDESCN(50)
        CHARACTER*20 appogg
        character*60 app2

        integer NIDESC,NCDESC,nrdesc

C        include 'MID_REL_INCL:fit_mid.inc'
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'

        ier=0
        CDESCN(1)='SPECTRUMTABLE'
        CDESCN(2)='OUTTAB'
        CDESCN(3)='LOGNAME'
        CDESCN(4)='GRALAB'
        CDESCN(5)='ZPLOT'
        NCDESC=5

        IDESCN(1)='TURBOLENCE'
        IDESCN(2)='GRAPHWIN'
        IDESCN(3)='I_MINOS'
        IDESCN(4)='GCOLOR'
        IDESCN(5)='I_RESIDUALS'
        IDESCN(6)='I_STDEV'
        IDESCN(7)='GREGION'
        NIDESC=7

        RDESCN(1)='LAMBDA_LIM'
        RDESCN(2)='COLDEN_LIM'
        RDESCN(3)='BTEMP_LIM'
        RDESCN(4)='BTURB_LIM'
        RDESCN(5)='GRAPH_BOTTOM'
        RDESCN(6)='GRAPH_TOP'
        RDESCN(7)='GRAPH_MIN'
        RDESCN(8)='GRAPH_MAX'
        RDESCN(9)='GRAPH_STEP'
        RDESCN(10)='GRAPH_LABEL'
        RDESCN(11)='GRAPH_TICK'
        RDESCN(12)='REDSHIFT'
        RDESCN(13)='VELRANGE'
        NRDESC=13

                    !doesn't stop at errors..
        call seterr('OFF')

        TURBLN=0
        I_GRAP=.false.
        I_Z=.false.
        I_RESD=.TRUE.
        I_VAR=.TRUE.
        IMINOS=0
        GCOLOR(1)=1             ! spectrum
        GCOLOR(2)=4             ! continuum
        GCOLOR(3)=2             ! fitted profile
        GCOLOR(4)=3             ! residuals
        GCOLOR(5)=6             ! stdev
        GCOLOR(6)=1             ! label
        GCOLOR(7)=2             ! line ticks
        LAMLIM(1)=0.
        LAMLIM(2)=0.
        LAMLIM(3)=0.005
        NLIM(1)=0.
        NLIM(2)=0.
        NLIM(3)=0.01
        BLIM(1)=0.
        BLIM(2)=0.
        BLIM(3)=0.01
        BTULIM(1)=.0
        BTULIM(2)=0.
        BTULIM(3)=0.01
        GR_BOT=0.5
        GR_TOP=0.5
        GR_LAB=0.2
        GR_TIC=1.2
        REDSH=0.D0
        VELRAN=0.D0
        do itmp = 1, NMXLIN
           LLABEL(itmp)=' '
        end do
        if (TblNam.eq.'SCRATCH') return

        call TBTOPN(TblNam,F_IO_MODE,TabID,ist)   !open
        if (ist .ne. 0 ) then       ! if it doesn't exist..           
           ier=1
           return
        end if

        ier=1
        call STDRDC(TabID,CDESCN(1),1,1,60,I2,FILSPE,I1,I3,ist)
        if (ist.ne.0) return
        call STDRDC(TabID,CDESCN(2),1,1,60,I2,FILOUT,I1,I3,ist)
        if (ist.ne.0) return
        call STDRDC(TabID,CDESCN(3),1,1,60,I2,FILLOG,I1,I3,ist)
        if (ist.ne.0) return

        i = index(FILSPE,' ') ! empty input filename
        if (i .eq. 1) return   

        i = index(FILOUT,' ') ! no out and log, using defaults
        if (i .eq. 1) then
           i=index(FILSPE,' ')
           FILOUT=FILSPE(1:i-1)//'FIT'
        end if   
        i = index(FILLOG,' ')
        if (i .eq. 1) then
           FILLOG=FILSPE
        endif

        ier=2
        call STDRDC(TabID,CDESCN(5),1,1,60,I2,app2,I1,I3,ist)
        if (ist.ne.0) I_Z=.false. !Backward compatibility
        if (app2.eq.'TRUE') I_Z = .true.
        if (app2.eq.'FALSE') I_Z = .false.

        call STDRDI(TabID,IDESCN(1),1,1,I2,TURBLN,I3,I1,ist)
        if (ist.ne.0) return

        call STDRDI(TabID,IDESCN(2),1,1,I2,ITMP,I3,I1,ist)
        if (ist.ne.0) return
        if (ITMP.eq.1) I_GRAP=.true.
        if (ITMP.eq.0) I_GRAP=.false.

        call STDRDI(TabID,IDESCN(3),1,1,I2,IMINOS,I3,I1,ist)
        if (ist.ne.0) return
        call STDRDI(TabID,IDESCN(4),1,7,I2,GCOLOR,I3,I1,ist)
        if (ist.ne.0) return
        call STDRDI(TabID,IDESCN(5),1,1,I2,ITMP,I3,I1,ist)
        if (ist.ne.0) return
        if (ITMP.eq.1) I_RESD=.true.
        if (ITMP.eq.0) I_RESD=.false.
        call STDRDI(TabID,IDESCN(6),1,1,I2,ITMP,I3,I1,ist)
        if (ist.ne.0) return
        if (ITMP.eq.1) I_VAR=.true.
        if (ITMP.eq.0) I_VAR=.false.

        call STDRDD(TabID,RDESCN(1),1,3,I2,LAMLIM ,I3,I1,ist)
        if (ist.ne.0) return
        call STDRDD(TabID,RDESCN(2),1,3,I2,NLIM ,I3,I1,ist)
        if (ist.ne.0) return
        call STDRDD(TabID,RDESCN(3),1,3,I2,BLIM ,I3,I1,ist)
        if (ist.ne.0) return
        call STDRDD(TabID,RDESCN(4),1,3,I2,BTULIM ,I3,I1,ist)
        if (ist.ne.0) return
        call STDRDD(TabID,RDESCN(5),1,1,I2, GR_BOT,I3,I1,ist)
        if (ist.ne.0) return
        call STDRDD(TabID,RDESCN(6),1,1,I2,GR_TOP ,I3,I1,ist)
        if (ist.ne.0) return
        call STDRDI(TabID,IDESCN(7),1,1,I2,NREGIO,I3,I1,ist)
        if (ist.ne.0) then  ! backward compatibility
         call STDRDD(TabID,RDESCN(9),1,NMXLIN,NREGIO,WINSTE ,I3,I1,ist)
         I_Z=.false.
        endif
        if (NREGIO .gt. 0) then
           call STDRDD(TabID,RDESCN(7),1,NREGIO,itmp,REGMIN ,I3,I1,ist)
           if (ist.ne.0) return
           call STDRDD(TabID,RDESCN(8),1,NREGIO,itmp,REGMAX ,I3,I1,ist)
           if (ist.ne.0) return
           call  STDRDD(TabID,RDESCN(9),1,NREGIO,itmp,WINSTE,I3,I1,ist)
        endif
        call STDRDD(TabID,RDESCN(10),1,1,I2,GR_LAB,I3,I1,ist)
c       if (ist.ne.0) return   ! to maintain compatibility with 94NOV
        call STDRDD(TabID,RDESCN(11),1,1,I2,GR_TIC,I3,I1,ist)
c       if (ist.ne.0) return   ! to maintain compatibility with 94NOV
        if (ist.ne.0) GR_TIC = 1.2  ! to maintain compatibility with 94NOV
        call STDRDD(TabID,RDESCN(12),1,1,I2,REDSH,I3,I1,ist)
        call STDRDD(TabID,RDESCN(13),1,1,I2,VELRAN,I3,I1,ist)

        if (NREGIO.gt.0) then   !legge labels
           do i=1,NREGIO
              write(appogg,'(a6,i2.2)')CDESCN(4),i
              call STDRDC(TabID,appogg,1,1,60,I2,LLABEL(i),I1,I3,ist)
              if (ist.ne.0) LLABEL(i)=' '
           end do
        end if

        CALL TBTCLO(TabID,ist)
        ier=0

        i1=0                    !reset standard values
        i2=2
        i3=1
        call STECNT('PUT',i1,i2,i3)


        return
        end

C @(#)smain.for	19.1 (ES0-DMD) 02/25/03 13:29:45
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE SMAIN (ARRAY,NP,NORDER,DET)
C+++
C.PURPOSE:
C.INPUT/OUTPUT: ARRAY  : input matrix which is replaced by its inverse
C.              NP     : matrix array dimension
C.              NORDER : degree of matrix (order of determinant)
C.              DET    : determinant of input matrix
C.              DIMENSION STATEMENT VALID FOR NORDER UP TO 500
C.VERSION:      870617
C---
      IMPLICIT  NONE
      INTEGER   NP
      REAL      ARRAY(NP,NP)
      INTEGER   NORDER
      REAL      DET
C
      INTEGER   IK(500),JK(500)
      INTEGER   I, J, K, L
      REAL      AMAX
      REAL      SAVE
C
C ***
      DET = 1.
      K   = 0
   20 CONTINUE
      IF (K.GE.NORDER.OR.DET.EQ.0.) GO TO 10
      K   = K+1
C
C *** find larger element array(i,j) in rest of matrix
      J    = 0
      I    = 0
      AMAX = 0.
C
   30 CONTINUE
      IF (J-K.GE.0) GO TO 40
   50 CONTINUE
      IF (I-K.GE.0) GO TO 60
      DO 901 I=K,NORDER
         DO 911 J=K,NORDER
            IF (ABS(ARRAY(I,J)).GE.ABS(AMAX)) THEN
               AMAX  = ARRAY(I,J)
               IK(K) = I
               JK(K) = J
             END IF
  911    CONTINUE
  901 CONTINUE
C
C *** interchange rows and columns to put amax in array(k,k)
      IF (AMAX.EQ.0.) THEN
         DET=0.
         RETURN
      ELSE
         I = IK(K)
      END IF
      IF (I-K.GT.0) THEN
         DO 902 J=1,NORDER
            SAVE       = ARRAY(K,J)
            ARRAY(K,J) = ARRAY(I,J)
            ARRAY(I,J) = -SAVE
  902    CONTINUE
      END IF
      GO TO 50
C
   60 CONTINUE
      J = JK(K) 
      IF (J-K.GT.0) THEN
         DO 903 I=1,NORDER
            SAVE       = ARRAY(I,K)
            ARRAY(I,K) = ARRAY(I,J) 
            ARRAY(I,J) = -SAVE
  903    CONTINUE
C
C *** accumulate elements of inverse matrix
      END IF
      GO TO 30
C
   40 CONTINUE
      DO 904 I = 1,NORDER
         IF (I-K.NE.0) THEN
            ARRAY(I,K) = -ARRAY(I,K)/AMAX
         END IF
  904 CONTINUE
C
      DO 905 I=1,NORDER
         DO 915 J=1,NORDER
            IF (I-K.NE.0.AND.J-K.NE.0) THEN
               ARRAY(I,J)=ARRAY(I,J)+ARRAY(I,K)*ARRAY(K,J)
            END IF
  915    CONTINUE
  905 CONTINUE
C
      DO 906 J = 1,NORDER
         IF (J-K.NE.0) THEN
            ARRAY(K,J) = ARRAY(K,J)/AMAX
         END IF
  906 CONTINUE
      ARRAY(K,K) = 1./AMAX
C     DET        = DET*AMAX
      GO TO 20
C
C *** restore ordering of matrix
   10 CONTINUE
      DO 907 L = 1,NORDER
         K = NORDER-L+1
         J = IK(K)
         IF (J-K.GT.0) THEN
            DO 917 I=1,NORDER
               SAVE       = ARRAY(I,K) 
               ARRAY(I,K) = -ARRAY(I,J)
               ARRAY(I,J) = SAVE
  917       CONTINUE
         END IF
C
         I = JK(K)
         IF (I-K.GT.0) THEN
            DO 927 J=1,NORDER
               SAVE       = ARRAY(K,J)
               ARRAY(K,J) = -ARRAY(I,J)
               ARRAY(I,J) = SAVE
  927       CONTINUE
         END IF
  907 CONTINUE
C
      RETURN
      END

C @(#)rfotresid.for	19.1 (ES0-DMD) 02/25/03 13:30:15
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
       PROGRAM RESIDU
C+++
C.IDENTIFICATION: RFOTRESID
C.PURPOSE: Compute reconstructed image and the difference with the original
C.AUTHOR:  R. Buonanno, G. Buscema, C. Corsi, I. Ferraro, G. Iannicola
C          Osservatorio Astronomico di Roma
C.VERSION: 881024 Creation                                                R.B.
C          890808 ST interfaces, MIDAS table file system implemented    R.H.W.
C----
      IMPLICIT     NONE
C
      INTEGER      NX
      INTEGER      NY
      PARAMETER    (NX=2048)
      PARAMETER    (NY=2048)
C
      INTEGER      MADRID(1)
      INTEGER      IAV, ISTAT
      INTEGER      LX, LY
      INTEGER      KUN, KNUL
      INTEGER      NPL, NL
      INTEGER      EC,ED, EL
      INTEGER      IROW
      INTEGER      TIDREG
      INTEGER      IMFI,IMFA
      INTEGER      IPI
      INTEGER*8    IPA
      INTEGER      LD, LC
      INTEGER      IX0, IY0
      INTEGER      I, J, K 
      INTEGER      NAXIS
      INTEGER      NPIX(3)
      INTEGER      TINULL
      INTEGER      ICOL(12)
      INTEGER      NCO,NRO,NSC,KW,NSA
C
      DOUBLE PRECISION TDNULL,TDTRUE,TDFALS
      DOUBLE PRECISION BEGIN(3),STEP(3)
C
      REAL         VIV(NX,NY)
      REAL         RIV(NX)
      REAL         AL
      REAL         DX2, DY2
      REAL         BETA, SIG, SI2
      REAL         TAB(12)
      REAL         TRNULL
      REAL         TBLSEL
C
      CHARACTER    IDENT*72,CUNIT*80
      CHARACTER    FRAMI*60,FRAMA*60
      CHARACTER    REGFIL*60
      CHARACTER    STRING*80
C
      LOGICAL      SFLAG
      LOGICAL      NUL(12)
C
      INCLUDE     'MID_INCLUDE:TABLES.INC'
      COMMON      /VMR/MADRID
      INCLUDE     'MID_INCLUDE:TABLED.INC'
C
      DATA         ICOL/2,3,4,5,6,7,8,9,10,11,12,13/
C
C *** Hello, is MIDAS out there?
      CALL STSPRO('RESIDU')
C 
C *** get the input frame
      CALL STKRDC('IN_A',1,1,60,IAV,FRAMI,KUN,KNUL,ISTAT)
C
C *** get the frame and read all relevant descriptors
      CALL STIGET(FRAMI,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     2            3,NAXIS,NPIX,BEGIN,STEP,IDENT,CUNIT,IPI,IMFI,ISTAT)
      NPL = NPIX(1)
      NL  = NPIX(2)
C
C  create constructed frame
      CALL STKRDC('OUT_A',1,1,60,IAV,FRAMA,KUN,KNUL,ISTAT)
      IDENT = 'Reconstructed frame'
      CALL STIPUT(FRAMA,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +                 NAXIS,NPIX,BEGIN,STEP,IDENT,
     +                 CUNIT,IPA,IMFA,ISTAT)
C
C *** Input table
      CALL STKRDC('IN_B',1,1,60,IAV,REGFIL,KUN,KNUL,ISTAT)
      CALL STECNT('GET',EC,ED,EL)
      CALL STECNT('PUT',1,0,0)
      CALL TBTOPN(REGFIL,0,TIDREG,ISTAT)
C
C *** get the registration table opened
      CALL TBMNUL(TINULL,TRNULL,TDNULL)
      CALL TBMCON(TBLSEL,TDTRUE,TDFALS)
      CALL TBIGET(TIDREG,NCO,NRO,NSC,KW,NSA,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL: Problems with opening '//
     2            'the registration file'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
      CALL STECNT('PUT',EC,ED,EL)
C
      AL = 4*ALOG(2.)
C
      DO 100 IROW = 1,NRO
         CALL TBSGET(TIDREG,IROW,SFLAG,ISTAT)
         IF (SFLAG) THEN
            CALL TBRRDR(TIDREG,IROW,12,ICOL,TAB,NUL,ISTAT)
            BETA = TAB(10)
            IF (TAB(8).LT.0.) THEN
               SIG = TAB(9)
               SI2 = SIG**2
               IF (BETA.GT.0) THEN
                  LD = SI2*SQRT(ABS((.5/TAB(3))**(-1./BETA)-1))+.5
               ELSE
                  LD = SI2*SQRT(ABS(ALOG(2*TAB(3))))/AL+.5
               END IF
C
C	       Convert from world to pixel coordinates
C
               IX0 = ((TAB(1)-BEGIN(1))/STEP(1)+1.)-LD
               IY0 = ((TAB(2)-BEGIN(2))/STEP(2)+1.)-LD
               LX  = 2*LD+1
               LY  = 2*LD+1
               IF (IX0.LT.1) THEN
                  LX  = LX+IX0-1
                  IX0 = 1
               END IF
               IF (IX0+LX-1.GT.NPL) THEN
                  LX = NPL-IX0+1
               ENDIF
               IF (IY0.LT.1) THEN
                  LY  = LY+IY0-1
                  IY0 = 1
               END IF
               IF (IY0+LY-1.GT.NL) THEN
                  LY=NL-IY0+1
               ENDIF                
               DO 110 J = IY0,LY+IY0
                  LC  =  2
                  DY2 = (J-((TAB(2)-BEGIN(2))/STEP(2)+1.))**2
                  DO 120 K = IX0,LX+IX0
                     DX2 = (K-((TAB(1)-BEGIN(1))/STEP(1)+1.))**2
                     IF (BETA.GT.0) THEN
                        VIV(K,J) = VIV(K,J)+
     2                      (TAB(3)*(1+(DX2+DY2)/SI2)**(-BETA))
                     ELSE
                        VIV(K,J) = VIV(K,J)+
     2                      (TAB(3)*EXP(-AL*(DX2+DY2)/SI2))
                     END IF
  120             CONTINUE
                  LC = 1
  110          CONTINUE
            END IF
         ENDIF
  100 CONTINUE
C
      DO 200 I = 1,NL
        DO 210 J = 1,NPL
          RIV(J) = VIV(J,I)
  210   CONTINUE
        CALL WRILIN(NPL,NL,I,1,NPL,MADRID(IPA),RIV)
  200 CONTINUE
C
      CALL STDCOP(IMFI,IMFA,3,' ',ISTAT)
      CALL STSEPI
      END

C @(#)vt125drv.for	19.1 (ES0-DMD) 02/25/03 13:53:09
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C  @(#)vt125drv.for	19.1 (OAA-ASTRONET) 02/25/03 13:53:09
C*
C* HEADER : vt125drv.for   - Vers 3.6.000  - Oct 1991 -  L. Fini, Oss. Arcetri
C*
C*
C
C  AGL device driver for the DEC VT125 graphic terminal.
C  This driver has been designed to work under VAX/VMS only and is
C  not expected to be portable to other O.S.
C
C  AGL 3.0 version - L. Fini May 1987
C
C  Note: this version is mostly based on the Version 2.0 driver code
C        developed at ASTRONET node in Trieste.
C
C  Driver entry points:
C
C     Initialize  AGLIN125
C     Cursor en.  AGLCU125
C     Erase       AGLER125
C     Escape      AGLES125
C     Flush buff. AGLSE125
C     Finish      AGLTE125
C     Polyline    AGLPL125
C
	SUBROUTINE AGLCU125(DVCOM)
C
	COMMON /AGLVT125/ CBUF(80),BUFPNT
	BYTE  CBUF
	INTEGER BUFPNT
C
	STRUCTURE /STRUC/
	  REAL    VECTX(0:0)
	  REAL    VECTY(0:0)
	  REAL    FLTB(0:9)
	  INTEGER INTB(0:19)
	  INTEGER ERRCOD
	  INTEGER CHANNL
	  BYTE    BYTBUF(132)
	END STRUCTURE
C
	RECORD /STRUC/ DVCOM
C
	CHARACTER*132 CHRBUF
C
	INCLUDE 'MID_INCLUDE:AGLERROR.INC'
C
	INTEGER AGLC2FOR
	INTEGER INTERACTIVE  
	INTEGER RETPIXVAL    
	INTEGER PLNSELECT    
	INTEGER PARTERASE    
	INTEGER UPDOSCROLL  
	INTEGER LFRGSCROLL  
	INTEGER SEPALPHA    
	INTEGER ERASABLE   
C
	PARAMETER( INTERACTIVE =1)  ! Device interactive flag mask
	PARAMETER( RETPIXVAL   =2)  ! Can return locator pixel value
	PARAMETER( PARTERASE   =4)  ! Partial erase flag mask
	PARAMETER( SEPALPHA    =8)  ! Separated alpha plane flag mask
	PARAMETER( ERASABLE   =16)  ! Erasable device flag mask
	PARAMETER( EXECOMMND  =32)  ! Execute command at close flag mask
C
	INTEGER FLAGS  
	INTEGER PLANES 
	INTEGER XPIXEL 
	INTEGER YPIXEL 
	INTEGER VERSCODE
	PARAMETER ( VERSCODE =  36 )
C
	PARAMETER ( FLAGS  =  INTERACTIVE .OR. ERASABLE .OR.
     .	 		      PARTERASE .OR. SEPALPHA )
	PARAMETER ( PLANES =  1 )         
	PARAMETER ( XPIXEL =  800 )
	PARAMETER ( YPIXEL =  480 )
C
	REAL SMCHAR
	REAL BSCHAR
	REAL MDCHAR
	REAL LGCHAR
	REAL XLENG
	REAL YLENG
	REAL XMAXL
	REAL YMAXL
C
	PARAMETER ( SMCHAR =  2.0 )
	PARAMETER ( BSCHAR =  3.0 )        
	PARAMETER ( MDCHAR =  4.0 )
	PARAMETER ( LGCHAR =  6.0 )
	PARAMETER ( XLENG  =  18.6 )
	PARAMETER ( YLENG  =  12.8 )
	PARAMETER ( XMAXL  =  0.0 )
	PARAMETER ( YMAXL  =  0.0 )
C
C					AUXILIARY VARIABLES
	INTEGER INTERR
	INTEGER IX0,IY0
	INTEGER NDISPL
	INTEGER IDX, J, K
	REAL XXSEL,XYSEL,YYSEL,YXSEL
	INTEGER AUX
	INTEGER END
C
	CHARACTER CHFLAG*1
	CHARACTER AUXSTR*13
C
	INTEGER*4 F_READ, F_WRITE, F_RCURS
	INTEGER*4 NCHARS
	INTEGER*2 IOSB(4)
C
	INTEGER IO$_READVBLK  
	INTEGER IO$M_NOECHO   
	INTEGER IO$_TTYREADALL
	INTEGER IO$_WRITEVBLK 
	INTEGER IO$M_NOFORMAT 
	INTEGER IO$M_ESCAPE
	INTEGER NORET
	INTEGER SS$_NORMAL
C
	PARAMETER ( IO$_READVBLK    = '00000031'X )
	PARAMETER ( IO$M_NOECHO     = '00000040'X )
	PARAMETER ( IO$_TTYREADALL  = '0000003A'X )
	PARAMETER ( IO$_WRITEVBLK   = '00000030'X )
	PARAMETER ( IO$M_NOFORMAT   = '00000100'X )
	PARAMETER ( SS$_NORMAL      = '00000001'X )
	PARAMETER ( IO$M_PURGE      = '00000800'X )
	PARAMETER ( IO$M_ESCAPE     = '00004000'X )
	PARAMETER ( NORET	    = '0'X )
	PARAMETER ( F_READ  = IO$_READVBLK .OR.
     .	                      IO$M_NOECHO  .OR.
     .	                      IO$_TTYREADALL .OR.
     .	                      IO$M_PURGE          )
	PARAMETER ( F_WRITE = IO$_WRITEVBLK .OR. IO$M_NOFORMAT )
	PARAMETER ( F_RCURS = IO$_READVBLK .OR.
     .	                      IO$M_NOECHO  .OR.
     .	                      IO$M_ESCAPE .OR.
     .	                      IO$M_PURGE          )
C
	INTEGER*4 SYS$ASSIGN,SYS$DASSGN
	INTEGER*4 SYS$QIOW
	INTEGER*2 VSSTAT(4)
C
	REAL VT1_FACT_X, VT1_FACT_Y
	REAL VT1_INP_X,  VT1_INP_Y
	PARAMETER ( VT1_FACT_X = 799. )		! NORM. TO DEVICE COORDINATES
	PARAMETER ( VT1_FACT_Y = 479. )		! CONVERSION FACTORS
C
	PARAMETER ( VT1_INP_X  = 1.25156E-3)	! DEVICE INPUT TO NOR. COORD.
	PARAMETER ( VT1_INP_Y  = 2.08768E-3)	! CONVERSION FACTORS
C
	INTEGER CURR_X, CURR_Y			! ABSOLUTE CURRENT POSITION
C
C						AUXILIARY VT125 VARIABLES
C
	INTEGER IXX, IYY			
	INTEGER*2 IO_STATUS(4), IO_MASK(2)
	INTEGER*4 JO_STATUS, JMOV(2), JO_MASK(2), TERMINATOR(4)
	EQUIVALENCE (IO_MASK(1),JO_MASK(1))
	BYTE IPUF(2), IBUF(16), OBUF(128)
C
C
C						DEFINE SOME VT 125 COMMANDS
C
	CHARACTER VTSTART*51			! STARTING SEQUENCE
	BYTE BVTSTART(51)
	EQUIVALENCE ( VTSTART, BVTSTART )
C
	CHARACTER ERASE*9			! ERASE SCREEN
	BYTE BERASE(9)
     .		/27,80,112,83,40,69,41,27,92/	! <ESC>PpS(E)<ESC>\
	EQUIVALENCE ( ERASE, BERASE )
C
	CHARACTER INIT*4			! CLEAR ALPHA SCREEN
	BYTE BINIT(4) /27,91,50,74/		! <ESC>[2J
	EQUIVALENCE ( INIT, BINIT )
C
	BYTE MOVCUR(7) 				! MOVE CURSOR MACRO
	DATA MOVCUR /27,80,112,64,90,27,92/	! <ESC>Pp@Z<ESC>\
C
C---------------------------------------------------------------------
C
	DVCOM.ERRCOD = AGLNOERR
C
	IO_MASK(1) = 16
	IO_MASK(2) = 0
	JO_MASK(2) = %LOC (TERMINATOR)
	TERMINATOR(1) = '37777760377'O
	TERMINATOR(2) = '37777777777'O
	TERMINATOR(3) = '37777777777'O
	TERMINATOR(4) = '37777777777'O
	JUMP = 10
	JMOV(1) = NINT(DVCOM.FLTB(0)*VT1_FACT_X)
	JMOV(2) = NINT(DVCOM.FLTB(1)*VT1_FACT_Y)
C
C					ENABLE THE SOFTWARE CURSOR
C
	CALL AGLVT1PSC (JMOV,OBUF,NB)
	INTERR = SYS$QIOW (,%VAL(DVCOM.CHANNL),%VAL(F_WRITE),IO_STATUS,,,
	1		   OBUF,%VAL(NB),,,,)
	INTERR = SYS$QIOW (,%VAL(DVCOM.CHANNL),%VAL(F_WRITE),IO_STATUS,,,
	1		   MOVCUR,%VAL(7),,,,)
C
	INTERR = SYS$QIOW (,%VAL(DVCOM.CHANNL),%VAL(F_RCURS),IO_STATUS,,,
	1		   IBUF,%VAL(6),,JO_MASK,,)
	IF( INTERR .NE. SS$_NORMAL .OR. .NOT. IO_STATUS(1) ) THEN
	    DVCOM.ERRCOD = DEVIOERR
	    GOTO 9999
	ELSE 
	    DVCOM.ERRCOD = AGLNOERR
	ENDIF
C
	DO WHILE (IO_STATUS(3) .EQ. 27)
C
		IF (IBUF(IO_STATUS(2)+3) .EQ. 65) THEN
			JMOV(2) = JMOV(2) + JUMP
			IF (JMOV(2) .GT. 479) JMOV(2) = JMOV(2) - 480
			CALL AGLVT1PC (JMOV,OBUF,NB)
			INTERR = SYS$QIOW (,%VAL(DVCOM.CHANNL),
     ,			                    %VAL(F_WRITE),
     ,			                    IO_STATUS,,,
     ,					    OBUF,%VAL(NB),,,,)
C
		ELSE IF (IBUF(IO_STATUS(2)+3) .EQ. 66) THEN
			JMOV(2) = JMOV(2) - JUMP
			IF (JMOV(2) .LT. 0) JMOV(2) = 480 + JMOV(2)
			CALL AGLVT1PC (JMOV,OBUF,NB)
			INTERR = SYS$QIOW (,%VAL(DVCOM.CHANNL),
     ,					    %VAL(F_WRITE),
     ,					    IO_STATUS,,,
     ,					    OBUF,%VAL(NB),,,,)
C
		ELSE IF (IBUF(IO_STATUS(2)+3) .EQ. 67) THEN
			JMOV(1) = JMOV(1) + JUMP
			IF (JMOV(1) .GT. 799 ) JMOV(1) = JMOV(1) - 800
			CALL AGLVT1PC (JMOV,OBUF,NB)
			INTERR = SYS$QIOW (,%VAL(DVCOM.CHANNL),
     ,	                                    %VAL(F_WRITE),
     ,	                                    IO_STATUS,,,
     ,					    OBUF,%VAL(NB),,,,)
C
		ELSE IF (IBUF(IO_STATUS(2)+3) .EQ. 68) THEN
			JMOV(1) = JMOV(1) - JUMP
			IF (JMOV(1) .LT. 0 ) JMOV(1) = 800 + JMOV(1)
			CALL AGLVT1PC (JMOV,OBUF,NB)
			INTERR = SYS$QIOW (,%VAL(DVCOM.CHANNL),
     ,					    %VAL(F_WRITE),
     ,					    IO_STATUS,,,
     ,					    OBUF,%VAL(NB),,,,)
C
		ELSE IF (IBUF(IO_STATUS(2)+3) .EQ. 80) THEN
			JUMP = 1
C
		ELSE IF (IBUF(IO_STATUS(2)+3) .EQ. 81) THEN
			JUMP = 5
C
		ELSE IF (IBUF(IO_STATUS(2)+3) .EQ. 82) THEN
			JUMP = 10
C
		ELSE IF (IBUF(IO_STATUS(2)+3) .EQ. 83) THEN
			JUMP = 50
		END IF
C
		INTERR = SYS$QIOW (,%VAL(DVCOM.CHANNL),
     ,	                            %VAL(F_RCURS),IO_STATUS,,,
     ,				   IBUF,%VAL(6),,JO_MASK,,)
		IF( INTERR .NE. SS$_NORMAL .OR. .NOT. IO_STATUS(1) ) THEN
		    DVCOM.ERRCOD = DEVIOERR
		    GOTO 9999
		ELSE 
		    DVCOM.ERRCOD = AGLNOERR
		ENDIF
	END DO
C
C						READ KEYBOARD AND POSITION
C
	IX = JMOV(1)
	IY = JMOV(2)
	IPUF(1) = IBUF(1)
	CALL AGLVT1PC (JMOV,OBUF,NB)
	INTERR = SYS$QIOW (,%VAL(DVCOM.CHANNL),%VAL(F_WRITE),IO_STATUS,,,
	1		   OBUF,%VAL(NB),,,,)
	INTERR = SYS$QIOW (,%VAL(DVCOM.CHANNL),%VAL(F_WRITE),IO_STATUS,,,
	1		   MOVCUR,%VAL(7),,,,)

C
C						CONVERT COORDINATES
C
	DVCOM.FLTB(0) = REAL(IX)*VT1_INP_X
	DVCOM.FLTB(1) = REAL(IY)*VT1_INP_Y
	DVCOM.INTB(1) = IPUF(1)
C
C						RETURN PIXEL VALUE
C						UNSUPPORTED
C
	DVCOM.INTB(2) = 0
	GOTO 9999
C
C ------------------------------- AGLER125 ------------------------------
C
	ENTRY AGLER125(DVCOM)
C
	DVCOM.ERRCOD = AGLNOERR
C						PARTIAL ERASE UNSUPPORTED YET
1000	CONTINUE
C
     	INTERR = SYS$QIOW ( ,%VAL(DVCOM.CHANNL), %VAL(F_WRITE),IOSB,,,
     ,	                   BERASE, %VAL(LEN(ERASE)),,
     ,	                   %VAL(NORET),,)
C
	DVCOM.ERRCOD = AGLNOERR
	GOTO 9999
C
C ------------------------------- AGLES125 ------------------------------
C
	ENTRY AGLES125(DVCOM)
	DVCOM.ERRCOD = UNSFEATINF
	GOTO 9999
C
C------------------------- AGLIN125 -------------------------------
C
	ENTRY AGLIN125(DVCOM)
C
	DVCOM.ERRCOD = AGLNOERR
C
	IF ( DVCOM.INTB(0) .EQ. 0 ) THEN
C						GET I/O CHANNEL
	  K = AGLC2FOR ( DVCOM.BYTBUF, CHRBUF )
	  INTERR = SYS$ASSIGN ( CHRBUF(1:K), DVCOM.CHANNL,,)
	  IF ( INTERR .NE. SS$_NORMAL ) THEN
	    DVCOM.ERRCOD = DEVOPNERR
	    GOTO 9999
	  ENDIF
C						CLEAR ALPHA SCREEN
C
     	  INTERR = SYS$QIOW ( ,%VAL(DVCOM.CHANNL), %VAL(F_WRITE),IOSB,,,
     ,	                     BINIT, %VAL(LEN(INIT)),,
     ,	                     %VAL(NORET),,)
C
C						SET UP CORRECT SCREEN
C							APPEARANCE
C
	  VTSTART = ' PpS(A[0,479][799,0]) \'
	  VTSTART ( 1: 1) = CHAR (27)
  	  VTSTART (22:22) = CHAR (27)
     	  INTERR = SYS$QIOW ( ,%VAL(DVCOM.CHANNL), %VAL(F_WRITE),IOSB,,,
     ,	                     BVTSTART, %VAL(23),,
     ,	                     %VAL(NORET),,)
C
C						SET UP CURSOR MACROGRAPH
C
	  VTSTART = ' Pp@:ZW(C,M255)V22P6666V22000P444444V000W(V,M1)@; \'
	  VTSTART ( 1: 1) = CHAR (27)
	  VTSTART (50:50) = CHAR (27)
     	  INTERR = SYS$QIOW ( ,%VAL(DVCOM.CHANNL), %VAL(F_WRITE),IOSB,,,
     ,	                     BVTSTART, %VAL(51),,
     ,	                     %VAL(NORET),,)
C
	  DVCOM.INTB(0) = DVCOM.CHANNL
C
	  BUFPNT=0
C						SET INITIAL COLOR CODE
	  CALL AGLPUTB ( 'W(I3)', DVCOM )
C
	ELSE IF (DVCOM.INTB(0) .EQ. 1) THEN
C						SET DEVICE CHARACT. PARAMS
	  DVCOM.ERRCOD=AGLNOERR
	  DVCOM.FLTB(0) = XLENG
	  DVCOM.FLTB(1) = YLENG
C
	  DVCOM.FLTB(2) = 1.0
	  DVCOM.FLTB(3) = 0.0
	  DVCOM.FLTB(4) = 0.0
	  DVCOM.FLTB(5) = 0.0
	  DVCOM.FLTB(6) = XLENG
	  DVCOM.FLTB(7) = YLENG
	  DVCOM.FLTB(8) = XMAXL
	  DVCOM.FLTB(9) = YMAXL  
C
	  DVCOM.INTB(1) = FLAGS  
	  DVCOM.INTB(2) = PLANES 
	  DVCOM.INTB(3) = XPIXEL 
	  DVCOM.INTB(4) = YPIXEL 
	  DVCOM.INTB(5) = VERSCODE
	  DVCOM.INTB(6) = 0
	  DVCOM.INTB(7) = 0
	  DVCOM.INTB(8) = 3
	  DVCOM.INTB(9) = 0
C
	  DVCOM.INTB(10) = 1
	  DVCOM.INTB(11) = 2
	  DVCOM.INTB(12) = 3
	  DVCOM.INTB(13) = 1
	  DVCOM.INTB(14) = 2
	  DVCOM.INTB(15) = 3
	  DVCOM.INTB(16) = 3
C
	  DVCOM.ERRCOD=AGLNOERR
C
	ELSE IF ( DVCOM.INTB(0) .EQ. 2 ) THEN
C						SET COLOR CODE (UNSUPP)
C	  END = 5
C	  WRITE(AUXSTR(:END),FMT='(3HW(I,I1,1H))') DVCOM.INTB(1)
C	  CALL AGLPUTB ( AUXSTR(:END), DVCOM )
	  DVCOM.ERRCOD=AGLNOERR
	ELSE 
C						SET LINE STYLE (UNSUPP)
C						SET LINE WIDTH UNSUPPORTED
	  DVCOM.ERRCOD=AGLNOERR
	ENDIF
C
	GOTO 9999
C
C---------------------------- AGLMV125 -----------------------------
C
	ENTRY AGLMV125(DVCOM)
C
	DVCOM.ERRCOD = AGLNOERR
C
	IX0 = NINT(DVCOM.FLTB(0)*VT1_FACT_X)
	IY0 = NINT(DVCOM.FLTB(1)*VT1_FACT_Y)
C
	MX = 3
	IF (IX0.LT.100) MX = 2
	IF (IX0.LT.10)  MX = 1
	MY = 3
	IF (IY0.LT.100) MY = 2
	IF (IY0.LT.10)  MY = 1
	END = MX+MY+4
	WRITE(AUXSTR(:END),FMT='(2HP[,I<MX>,1H,,I<MY>,1H])') IX0,IY0
	CALL AGLPUTB (AUXSTR(:END), DVCOM)
C
	CURR_X = IX0
	CURR_Y = IY0
C
	GOTO 9999
C
C-------------------------  AGLTE125 -------------------------------
C
	ENTRY AGLTE125 (DVCOM)
C
	DVCOM.ERRCOD = AGLNOERR
C
	CALL SYS$DASSGN ( DVCOM.CHANNL )
	GOTO 9999
C
C-------------------------  AGLTR125 -------------------------------
C
	ENTRY AGLTR125 (DVCOM)
C
	DVCOM.ERRCOD = AGLNOERR
C
	IX0 = NINT( DVCOM.FLTB(0)*VT1_FACT_X )
	IY0 = NINT( DVCOM.FLTB(1)*VT1_FACT_Y )
	MX = 3
	IF (IX0.LT.100) MX = 2
	IF (IX0.LT.10)  MX = 1
	MY = 3
	IF (IY0.LT.100) MY = 2
	IF (IY0.LT.10)  MY = 1
	END = MX+MY+6
	WRITE(AUXSTR(:END),FMT='(4HV[][,I<MX>,1H,,I<MY>,1H])') IX0,IY0
	CALL AGLPUTB (AUXSTR(:END), DVCOM )
C
	DVCOM.ERRCOD = AGLNOERR
C
9999	CONTINUE
	END
C
C
C-------------------------  AGLPL125 -------------------------------
C
	SUBROUTINE AGLPL125 (DVCOM)
C
	COMMON /AGLVT125/ CBUF(80),BUFPNT
	BYTE  CBUF
	INTEGER BUFPNT
C
	STRUCTURE /STRUC/
	  REAL    VECTX(0:0)
	  REAL    VECTY(0:0)
	  REAL    FLTB(0:9)
	  INTEGER INTB(0:19)
	  INTEGER ERRCOD
	  INTEGER CHANNL
	  BYTE    BYTBUF(132)
	END STRUCTURE
C
	RECORD /STRUC/ DVCOM
C
C
C
	CALL AGLPL125B(DVCOM,%VAL(DVCOM.VECTX(0)),%VAL(DVCOM.VECTY(0)))
	END
C-------------------------  AGLPL125 -------------------------------
C
	SUBROUTINE AGLPL125B (DVCOM,VX,VY)
C
	STRUCTURE /STRUC/
	  REAL    VECTX(0:0)
	  REAL    VECTY(0:0)
	  REAL    FLTB(0:9)
	  INTEGER INTB(0:19)
	  INTEGER ERRCOD
	  INTEGER CHANNL
	  BYTE    BYTBUF(132)
	END STRUCTURE
C
	RECORD /STRUC/ DVCOM
C
	REAL VX(1),VY(1)
C
	IF(DVCOM.INTB(0) .LT. 2) RETURN
C
	DVCOM.FLTB(0) = VX(1)
	DVCOM.FLTB(1) = VY(1)
	CALL AGLMV125(DVCOM)
C
	DO 1000 I=2,DVCOM.INTB(0)
	DVCOM.FLTB(0) = VX(I)
	DVCOM.FLTB(1) = VY(I)
	CALL AGLTR125(DVCOM)
1000	CONTINUE
9999	CONTINUE
	END
C
C--------------------------- AGLSE125 -----------------------------
C
	SUBROUTINE AGLSE125(DVCOM)
C
	COMMON /AGLVT125/ CBUF(80),BUFPNT
	BYTE  CBUF
	INTEGER BUFPNT
C
	STRUCTURE /STRUC/
	  REAL    VECTX(0:0)
	  REAL    VECTY(0:0)
	  REAL    FLTB(0:9)
	  INTEGER INTB(0:19)
	  INTEGER ERRCOD
	  INTEGER CHANNL
	  BYTE    BYTBUF(132)
	END STRUCTURE
C
	RECORD /STRUC/ DVCOM
C
C
	INCLUDE 'MID_INCLUDE:AGLERROR.INC'
C
	INTEGER*4 F_WRITE
	INTEGER*2 IOSB(4)
C
	INTEGER IO$_WRITEVBLK 
	INTEGER IO$M_NOFORMAT 
	INTEGER NORET
	INTEGER SS$_NORMAL
C
	PARAMETER ( IO$_WRITEVBLK   = '00000030'X )
	PARAMETER ( IO$M_NOFORMAT   = '00000100'X )
	PARAMETER ( SS$_NORMAL      = '00000001'X )
	PARAMETER ( NORET	    = '0'X )
	PARAMETER ( F_WRITE = IO$_WRITEVBLK .OR. IO$M_NOFORMAT )
C
	INTEGER*4 SYS$QIOW
C
	CHARACTER PROLOG*3			! VT125 PROLOG
	BYTE BPROLOG(3)	/27,80,112/		! <ESC>Pp
	EQUIVALENCE ( PROLOG, BPROLOG )
C
	CHARACTER EPILOG*2			! VT125 EPILOG
	BYTE BEPILOG(2)	/27,92/			! <ESC>\
	EQUIVALENCE ( EPILOG, BEPILOG )
C
	DVCOM.ERRCOD = AGLNOERR
C
	IF ( BUFPNT .GT. 0 ) THEN
C
C					SEND PROLOG
C
	  INTERR = SYS$QIOW ( ,%VAL(DVCOM.CHANNL), %VAL(F_WRITE),IOSB,,,
     ,	                     BPROLOG, %VAL(LEN(PROLOG))
     ,	                     ,,%VAL(NORET),,)
C
C					SEND THE BUFFER
C
     	  INTERR = SYS$QIOW ( ,%VAL(DVCOM.CHANNL), %VAL(F_WRITE),IOSB,,,
     ,	                     CBUF, %VAL(BUFPNT)
     ,	                     ,,%VAL(NORET),,)
C
C					RESET DEVICE IN ALPHA MODE
C
	  INTERR = SYS$QIOW ( ,%VAL(DVCOM.CHANNL), %VAL(F_WRITE),IOSB,,,
     ,	                      BEPILOG, %VAL(LEN(EPILOG))
     ,	                      ,,%VAL(NORET),,)
C
	  BUFPNT = 0
C
	  IF( INTERR .NE. SS$_NORMAL ) THEN
	    DVCOM.ERRCOD = DEVIOERR
	  ELSE 
	    DVCOM.ERRCOD = AGLNOERR
	  END IF
	ENDIF
C
	END
C
	SUBROUTINE AGLPUTB ( CHSTRG, DVCOM )
C
	CHARACTER*(*) CHSTRG
C
C
	STRUCTURE /STRUC/
	  REAL    VECTX(0:0)
	  REAL    VECTY(0:0)
	  REAL    FLTB(0:9)
	  INTEGER INTB(0:19)
	  INTEGER ERRCOD
	  INTEGER CHANNL
	  BYTE    BYTBUF(132)
	END STRUCTURE
C
	RECORD /STRUC/ DVCOM
C
C
	COMMON /AGLVT125/ CBUF(80),BUFPNT
	BYTE  CBUF
	INTEGER BUFPNT
C
	IF ( (LEN(CHSTRG)+BUFPNT) .GT. 80 ) THEN
	  CALL AGLSE125(DVCOM)			!	SEND THE OUTPUT BUFFER
	ENDIF
C
	DO 1000 I = 1, LEN(CHSTRG)
	  BUFPNT = BUFPNT+1
	  CBUF ( BUFPNT ) = ICHAR(CHSTRG(I:I))
1000	CONTINUE
C
	END
C
	INTEGER FUNCTION AGLC2FOR(BUF,CHR)
C
C  CONVERTS A C-LIKE STRING INTO A FORTRAN CHARACTER STRING
C  AND RETURNS STRING LENGTH
C
	BYTE BUF(1)
	CHARACTER*(*) CHR
C
	N=0
	CHR=' '
	DO 1000 I=1,LEN(CHR)
	IF(BUF(I).EQ.0) GOTO 1010
	CHR(I:I)=CHAR(BUF(I))
	N=N+1
1000	CONTINUE
1010	CONTINUE
	AGLC2FOR=N
	END

C @(#)world.for	19.1 (ES0-DMD) 02/25/03 14:29:03
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C Module: world.for
C Provides functions for the manipulation of world
C coordinates in spectroscopy packages
C

C-----------------------------------------------------
        FUNCTION XI_R8R8 (X, START, STEP)

         DOUBLE PRECISION XI_R8R8
         DOUBLE PRECISION X, START(1),STEP(1)

         XI_R8R8 = (X-START(1))/step(1) + 1.D0

        RETURN
        END

C----------------------------------------------------
        FUNCTION IX_IR8(I,START,STEP)

        DOUBLE  PRECISION IX_IR8, START(1),STEP(1)
        INTEGER I

          IX_IR8 = START(1) + (I-1.)*STEP(1)

        RETURN
        END

C----------------------------------------------------
        FUNCTION IX_R8R8(I,START,STEP)

        DOUBLE  PRECISION I, IX_R8R8, START(1),STEP(1)

          IX_R8R8 = START(1) + (I-1.)*STEP(1)

        RETURN
        END

C @(#)dblgc.for	19.1 (ES0-DMD) 02/25/03 14:29:41
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                    all rights reserved
C.IDENTIFICATION: Program DBLGC
C.PURPOSE:   Extract the coordinates and pixel values: the coordinates can be
C            included/appended in the descriptor, table or keyword.
C.AUTHOR:    Ch. Ounnas   ESO - Garching
C.LANGUAGE:  F77+ESOext
C.KEYWORDS:  Graphics, cursor, table descriptor
C.ALGORITHM: The outines uses the standard interface and AGL plotting routines.
C.VERSION:   850513 K. Banse     ???
C.VERSION:   850925 Ch. Ounnas   ???
C.VERSION:   851125 J.D. Ponz    ???
C.VERSION:   8602?? L.Fini       implementation of the AGL plotting routines
C.VERSION:   86???? R.H. Warmels Completely restructured
C.VERSION:   870211 R.H. Warmels corr. default for the maximum number of input
C.VERSION:   870629 R.H. Warmels include of facilitity to read contour plots
C.VERSION:   871113 R.H. Warmels ESO-FORTRAN Conversion
C.VERSION:   DBLGC from GCURSOR M.Bell adaptation for DBLEND routine
C -----------------------------------------------------------------
        program dblgc
C
        integer       MADRID

        REAL        CLIP(4)   !something for graphics display
        character*36  CUNIT     !image descriptor
        integer       DUM       !number of continuum points to be marked
        integer       FAC       !number of parameters per line to be marked
        character*1   FOPT      !fit option specified in DBLEND command
        integer       IC        !column number
        character*72  IDENT     !image descriptor
        real          IMAGE(4)  !image names
        real          WINDX(4),WINDY(4)
        integer       IMF       !file number of image frame
        character*60  INFO      !plotting keyword
        character*1   IOPT      !input option specified in DBLEND command
        integer*8       IP        !pointer to image frame
        integer       IROW      !table row to be written
        integer       ISI       !total number of pixels in image
        integer       ISTAT     !status indicator
        integer       LIM       !maximum number of useful cursor values in tabl
        integer       MSTAT     !internal error status indicator        

        integer       NAXIS     !dimensionality of input image
        integer       NCOLS     !number of columns output table is to have
        integer       NPIX(3)   !size of input image
        integer       NREAD     !number of cursor values actually read in
        integer       NRMAX     !maximum number of lines for output table
        character*20  PLNAME    !name of image frame that has been plotted
        integer       PLMODE    !output plot mode        
        integer       PLACC     !plot access mode

        character*1   RFLAG     !continuum option specified in DBLEND command
        DOUBLE PRECISION        START(3)  !zero points of world coordinates
        DOUBLE PRECISION        STEP(3)   !pixel size of world coordinates
        character*80  STRING*80 !output message holder
        REAL        SX,SY       !single precision versions of step(1,2)
        character*16  TABFOR(7) !table column formats
        character*16  TABLAB(7) !table column labels
        character*64  TABLE     !name of output table of cursor positions
        character*16  TABUNI(7) !table column units
        integer       TID       !table id number
        REAL          XS,YS     !single precision versions of start(1,2)
        INTEGER       NPL, IAC, KUN, L, IAV, NL, NTRY, KNUL
C
        integer       NNEW,NROLD  !dummy value holders
C
        INCLUDE         'MID_INCLUDE:ST_DEF.INC'
        common    /MYINFO/ SX,SY,XS,YS,NPL,ISI
        common    /VMR/    MADRID(1)
        INCLUDE         'MID_INCLUDE:ST_DAT.INC'
C
C
        DATA      TABUNI/' ',' ',' ',' ',' ',' ',' '/
        DATA      TABLAB/'X_AXIS','Y_AXIS','LINE_NO','PIXEL_NO',
     2                 'X_POSITION','Y_POSITION','PIXEL_VALUE'/
        DATA      TABFOR/'G13.6','G13.6','I5','I5',
     2                 'G13.6','G13.6','G13.6'/
        data      MSTAT /0/
        data      PLACC/-1/
        data      PLMODE/-1/
C
C *** start of executable code
        CALL STSPRO('DBLGC')
C
C *** get the needed keyword contents
        CALL PTKRDC('DNAME',60,IAC,INFO)
        L      = INDEX(INFO//' ',' ') - 1
        PLNAME = INFO(1:L)                                   ! type of the date
        call stkrdc('P5',1,1,1,IAC,RFLAG,KUN,KNUL,ISTAT)
        call upcas(RFLAG,RFLAG)
        if (RFLAG.eq.'R') then
          RFLAG = '4'
          DUM = 4
        else
          RFLAG = '2'
          DUM = 2
        end if
        call stkrdc('FITOPT',1,1,1,IAC,FOPT,KUN,KNUL,ISTAT)
        call upcas(FOPT,FOPT)
        call stkrdc('P6',1,1,1,IAC,IOPT,KUN,KNUL,ISTAT)
        call upcas(IOPT,IOPT)
C
C *** get table name for storage of data
        CALL STKRDC('IN_B',1,1,64,IAC,TABLE,KUN,KNUL,ISTAT)
C
        NRMAX = 24
        NCOLS  = 7                                                  ! 6 columns
C
        CALL TBTINI(TABLE,0,F_O_MODE,NCOLS,NRMAX,TID,ISTAT)      ! create table
        DO  IAV = 1,NCOLS                                      ! define columns
          CALL TBCINI(TID,D_R4_FORMAT,1,TABFOR(IAV),TABUNI(IAV),
     2                     TABLAB(IAV),IC,ISTAT)
        end do
        IROW   = 1
C
C *** restore the graphics display
        CALL PTOPEN(' ', ' ', PLACC, PLMODE)
        CALL PTKRDR('CLPL',4,IAC,CLIP)
C
C *** Image files
        CALL STIGET(PLNAME,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,3,
     2               NAXIS,NPIX,START,STEP,IDENT,CUNIT,IP,IMF,ISTAT)
        SX     = real(STEP(1))
        SY     = real(STEP(2))
        XS     = real(START(1))
        YS     = real(START(2))
        NPL    = NPIX(1)
        NL     = NPIX(2)
        ISI    = NPIX(1)*NPIX(2)
        CALL PTKRDR('XWNDL',4,IAC,WINDX)
        CALL PTKRDR('YWNDL',4,IAC,WINDY)
        IMAGE(1) = WINDX(1)
        IMAGE(2) = WINDX(2)
        IMAGE(3) = WINDY(1)
        IMAGE(4) = WINDY(2)
C
C *** get the cursor positions
C
        NTRY = 1
 30        STRING = 'Mark beginning and end of region to be fit'
        call sttput(STRING,ISTAT)
        CALL STTPUT('   X-axis       Y-axis     Line Pixel '//
     2               '  X-position   Y-position  Pixel_value',
     3                ISTAT)
        NREAD = 0
        call curpos(MADRID(IP),TID,2,IMAGE,IROW,NREAD)
        if (NREAD.ne.2) then
          STRING = 'ERROR: wrong number of positions read in'
          call sttput(STRING,ISTAT)
          NTRY = NTRY + 1
          if (NTRY.le.3) then
            go to 30
          else
            MSTAT = 4
            go to 100
          end if
        end if
C
        NTRY = 1
 40        STRING = 'Mark continuum on both sides: '//RFLAG//' points'
        call sttput(STRING,ISTAT)
        CALL STTPUT('   X-axis       Y-axis     Line Pixel '//
     2               '  X-position   Y-position  Pixel_value',
     3                ISTAT)
        LIM = NREAD + DUM
        call curpos(MADRID(IP),TID,DUM,IMAGE,IROW,NREAD)
        if (NREAD.ne.LIM) then
          STRING = 'ERROR: wrong number of positions read in'
          call sttput(STRING,ISTAT)
          NTRY = NTRY + 1
          if (NTRY.le.3) then
            NREAD = 2
            go to 40
          else
            MSTAT = 4
            go to 100
          end if
        end if

        NTRY = 1
        NROLD = NREAD
 50        if (FOPT.eq.'W'.and.IOPT.eq.'B') then
          STRING = 'Mark left and right half max points'
          call sttput(STRING,ISTAT)
          STRING = ' for each line indicated'
          call sttput(STRING,ISTAT)
          FAC = 2
        else if ((FOPT.eq.'S'.or.FOPT.eq.'A').and.IOPT.eq.'B') then
          STRING = 'Mark line centers'
          call sttput(STRING,ISTAT)
          FAC = 1
        else
          STRING = 'Mark left half max point, center, and right'
          call sttput(STRING,ISTAT)
          STRING = ' half max point for each line.'
          call sttput(STRING,ISTAT)
          FAC = 3
        end if
        STRING = 'Press space bar or middle mouse button when finished'
        call sttput(STRING,ISTAT)
        CALL STTPUT('   X-axis       Y-axis     Line Pixel '//
     2               '  X-position   Y-position  Pixel_value',
     3                ISTAT)
        call curpos(MADRID(IP),TID,18,IMAGE,IROW,NREAD)
        NNEW = NREAD - NROLD
        if (NNEW.gt.18) then
          MSTAT = 2
          go to 100
        end if
        if (NREAD.eq.0.or.mod(NNEW,FAC).ne.0) then
          STRING = 'ERROR: wrong number of values read in'
          call sttput(STRING,ISTAT)
          NTRY = NTRY + 1
          if (NTRY.le.3) then
            NREAD = LIM
            go to 50
          else
            MSTAT = 4
            go to 100
          end if
        end if
C
C  That's it folks...
C
 100        if (MSTAT.eq.1) then
          STRING = 'ERROR: wrong number of cursor positions read in'
          call sttput(STRING,ISTAT)
        else if (MSTAT.eq.2) then
          STRING = ' Too many lines marked; only first 6 will be used'
          call sttput(STRING,ISTAT)
        else if (MSTAT.eq.3) then
          STRING = 'ERROR: no cursor values read in'
          call sttput(STRING,ISTAT)
        else if (MSTAT.eq.4) then
          STRING = ' DBLGC exiting on input errors'
          call sttput(STRING,ISTAT)
        end if
        CALL TBSINI(TID,ISTAT)
        CALL TBTCLO(TID,ISTAT)
C
        CALL PTCLOS
        CALL STSEPI
        END

        subroutine curpos(DATA,TID,NITER,IMAGE,IROW,NREAD)

        INTEGER   NCR
        PARAMETER (NCR=1)

        integer NITER,KEY,NREAD,IPLX,IPLY,ISI,NPL,KUN
        INTEGER   ISTAT
        REAL      IMAGE(4)
        INTEGER   IC(7)
        REAL      X(NCR),Y(NCR),VALUE(7), DATA(1)
        real PXVL,XD,XP,YD,XS,YS,SX,SY,VAL,YP
        CHARACTER L1*13,L2*13,L3*6,L4*6,L5*13,L6*13,L7*15

        integer II, IROW, TID

        COMMON /MYINFO/ SX,SY,XS,YS,NPL,ISI
        DATA   IC /1,2,3,4,5,6,7/

 9000        FORMAT (I4)
 9010        FORMAT (G13.6)

        do  II = 1,NITER

   30     CONTINUE
          CALL AGVLOC(X(1),Y(1),KEY,PXVL)
          IF (KEY.EQ.13) THEN
            CALL STTPUT('*** WARNING: do not use return key',ISTAT)
            GO TO 30
          ELSE IF (KEY.EQ.32) THEN
            return
          ELSE
            XD     = X(1)
            IPLX   = NINT((XD-XS)/SX) + 1
            XP     = FLOAT(IPLX-1)*SX + XS
            YD     = Y(1)
            IF (IMAGE(3).NE.IMAGE(4)) THEN
              IPLY   = NINT((YD-YS)/SY) + 1
              YP     = FLOAT(IPLY-1)*SY + YS
            ELSE
              IPLY   = IMAGE(3)
              YP     = FLOAT(IPLY-1)*SY + YS
            END IF
C
            IF ((XD.LT.IMAGE(1)) .OR. (XD.GT.IMAGE(2)) .OR.
     2          (YD.LT.IMAGE(3)) .OR. (YD.GT.IMAGE(4))) THEN
              CALL STTPUT('*** WARNING: Graphic cursor outside '//
     2                     'plotted area',ISTAT)
              GO TO 30
            ELSE
              CALL PIXVAL(DATA,ISI,NPL,IPLX,IPLY,VAL)
            END IF
C
            NREAD = NREAD + 1
            CALL PTDATA(0,1,0,X,Y,0.0,NCR)
            VALUE(1) = XD
            VALUE(2) = YD
            VALUE(3) = float(IPLX)
            VALUE(4) = float(IPLY)
            VALUE(5) = XP
            VALUE(6) = YP
            VALUE(7) = VAL

            CALL STKWRR('OUTPUTR',VALUE,1,7,KUN,ISTAT)! fill keyword OUTPUTR
            CALL TBRWRR(TID,IROW,7,IC,VALUE,ISTAT)
            IROW = IROW + 1
C
C *** prepare the outputs
            WRITE (L1,9010) VALUE(1)
            WRITE (L2,9010) VALUE(2)
            WRITE (L3,9000) IPLX
            WRITE (L4,9000) IPLY
            WRITE (L5,9010) VALUE(5)
            WRITE (L6,9010) VALUE(6)
            WRITE (L7,9010) VALUE(7)

            CALL STTPUT(L1//L2//' '//L4//L3//'  '//L5//L6//L7,ISTAT)
          end if
C
        end do
        return
        end

C @(#)limitx.for	19.1 (ES0-DMD) 02/25/03 13:29:44
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE LIMITX(V,IS,NN,KC,IX,IY,LX,LY)
C +++
C ---
      IMPLICIT  NONE
      INTEGER   NN
      REAL      V(7)
      REAL      IS(NN,4)
      INTEGER   KC
      INTEGER   IX
      INTEGER   IY
      INTEGER   LX
      INTEGER   LY
C
      IF (V(2)-V(6).LE.IX+LX-1.AND.V(2)+V(6).GE.IX) THEN
        IF (V(3)-V(6).LE.IY+LY-1.AND.V(3)+V(6).GE.IY) THEN
           KC       = KC+1
           IS(KC,1) = V(2)
           IS(KC,2) = V(3)
           IS(KC,3) = V(6)
           IS(KC,4) = V(7)
        END IF
      END IF
C
      RETURN
      END

C @(#)mxwd.for	19.1 (ES0-DMD) 02/25/03 13:55:18
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE MXW001(DEVICE,DSPLAY,IDST)
C
      IMPLICIT NONE
C      
      INTEGER*4       CHANL,DSPLAY,IDST
C      
      CHARACTER*(*)      DEVICE
C       
      IDST = 0
      RETURN
      END

      SUBROUTINE MXW002(DSPLAY,IDST)
C
      IMPLICIT NONE
C      
      INTEGER*4       DSPLAY,IDST
C       
      IDST = 0
      RETURN
      END

      SUBROUTINE MXW003(DSPLAY,IDST)
C 
      INTEGER*4  DSPLAY,IDST
C 
      IDST = 0
      RETURN
      END

      SUBROUTINE MXW004(DSPLAY,IDST)
C 
      INTEGER*4  DSPLAY,IDST
C 
      IDST = 0
      RETURN
      END

      SUBROUTINE MXW010(DSPLAY,CONFNO,IDST)
C      
      IMPLICIT NONE
C      
      INTEGER*4      DSPLAY,CONFNO,IDST
C       
      IDST = 0
      RETURN
      END

      SUBROUTINE MXW016(DSPLAY,CHANS,NOCHAN,LUTF,ITTF,IDST)
C      
      IMPLICIT NONE
C      
      INTEGER*4      DSPLAY,CHANS(1),NOCHAN,LUTF(1),ITTF(1),IDST
C       
      IDST = 0
      RETURN
      END

      SUBROUTINE MXW050(DSPLAY,LUNO,IDST)
C
      IMPLICIT NONE
C      
      INTEGER*4       DSPLAY,LUNO,IDST
C       
      IDST = 0
      RETURN
      END

      SUBROUTINE
     +      MXW006(DSPLAY,TOTCONF,SZX,SZY,DEPTH,NLUT,NITT,NCURS,IDST)
C      
      IMPLICIT NONE
C      
      INTEGER*4      DSPLAY,TOTCONF,SZX,SZY,DEPTH,
     +                  NLUT,NITT,NCURS,IDST
C       
      IDST = 0
      RETURN
      END

      SUBROUTINE MXW009(DSPLAY,CONFNO,MEMTYP,TOTMEM,
     +                    CONFMODE,MEMID,MEMSZX,MEMSZY,MEMDEP,
     +                        ITTDEP,NOMEM,IDST)
C 
      IMPLICIT NONE
C      
      INTEGER*4      DSPLAY,CONFNO,MEMTYP,TOTMEM
      INTEGER*4      CONFMODE,MEMID(1),MEMSZX(1),MEMSZY(1),MEMDEP(1)
      INTEGER*4      ITTDEP(1),NOMEM,IDST
C       
      IDST = 0
      RETURN
      END

      SUBROUTINE MXW007(DSPLAY,CAPA,OUTSIZ,OUTDAT,TOTAL,IDST)
C      
      IMPLICIT NONE
C      
      INTEGER*4      DSPLAY,CAPA,OUTSIZ,OUTDAT(1),TOTAL,IDST
C       
      IDST = 0
      RETURN
      END

      SUBROUTINE MXW048(DSPLAY,MEMIDS,XOFFS,YOFFS,SPLFLG,
     +                    SPLX,SPLY,IDST)
C      
      IMPLICIT NONE
C      
      INTEGER*4      DSPLAY,MEMIDS(1),SPLFLG,XOFFS(1),YOFFS(1)
      INTEGER*4      SPLX,SPLY,IDST
C       
      IDST = 0
      RETURN
      END

      SUBROUTINE MXW005(ERNO,ERSTR,LSTR)
C
      IMPLICIT NONE
C      
      INTEGER*4      ERNO,LSTR
C 
      CHARACTER*(*)      ERSTR
C       
      RETURN
      END

C @(#)rfotfclean.for	19.1 (ES0-DMD) 02/25/03 13:30:14
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM FCLEAN
C++++
C.PURPOSE: Select window in the intermediate table which are also present
C          in the catalogue table. Put the selection flag on these components.
C.AUTHORS: R. Buonanno, G. Buscema, C. Corsi, I. Ferraro, G. Iannicola
C          Osservatorio Astronomico di Roma
C.VERSION: 880921  First running version in MIDAS               R. Buonanno
C          890809  Rewritten on basis of MIDAS tables;
C                  implementation of ST interfaces              R.H. Warmels
C---
      IMPLICIT     NONE
      INCLUDE      'MID_REL_INCL:RFOTDECL.INC'
C
      INTEGER      IDB
      PARAMETER    (IDB=256)
C
      INTEGER      TIDCAT, TIDIN,TIDOUT
      INTEGER      IAV
      INTEGER      ISTAT
      INTEGER      EC, ED, EL
      INTEGER      IA3
      INTEGER      NGRP
      INTEGER      IRIN, IROUT
      INTEGER      NCP, NHL
      INTEGER      IPX, IPY
      INTEGER      NP, NC
      INTEGER      IH
      INTEGER      LFWT
      INTEGER      LI
      INTEGER      JK, JKR
      INTEGER      LFW
      INTEGER      ICB
      INTEGER      KUN, KNUL
      INTEGER      NST,NCCAT,NRCAT,NSCAT,NACCAT,NARCAT
      INTEGER      NCINT,NRINT,NSINT,NACINT,NARINT
      INTEGER      IA1,IA2,IA4,IA5,IA6,IA7,IA8
      INTEGER      TINULL
      INTEGER      MADRID
      INTEGER      IKT,NSR
      INTEGER      ICAT,IDENT,KGR,KCP
      INTEGER      IXE, IYE
      
C
      DOUBLE PRECISION TDNULL,TDTRUE,TDFALS
C
      REAL         D1,D2,RMA,V,B,U,PPP,FLCO
      REAL         SAT,FAT,SIGMA,BETA,SIV,AIN,FOG
      REAL         BA1,BA2,BA3,BA4,BA5,BA6
      REAL         TRNULL, TBLSEL
      REAL         XM(NINTO),YM(NINTO),KM(NINTO)
      REAL         PB(IDB)
      REAL         RR
      REAL         XR, YR
C
      CHARACTER    CATFIL*60, INTIN*60, INTOUT*60
      CHARACTER    STRING*80
C
      LOGICAL      SFLAG
C       
      INCLUDE      'MID_INCLUDE:ST_DEF.INC'
      COMMON       /VMR/MADRID
      INCLUDE      'MID_INCLUDE:ST_DAT.INC'
C
999   FORMAT('*** INFO: Number of objects in the catalogue table: ',I5)
998   FORMAT('          Number of groups in intermediate table:   ',I5)
997   FORMAT('          Number of components:                     ',I5)
996   FORMAT('          Final number of groups selected:          ',I5)
C
C *** start here 
      CALL STSPRO('FCLEAN')                              ! is somebody out there
      CALL TBMCON(TBLSEL,TDTRUE,TDFALS)
      CALL TBMNUL(TINULL,TRNULL,TDNULL)
      SFLAG = .TRUE.
C
C *** get the catalogue table
      CALL STKRDC('IN_A',1,1,60,IAV,CATFIL,KUN,KNUL,ISTAT)   !get catalogue name
C
C *** open the catalogue table
      CALL STECNT('GET',EC,ED,EL)
      CALL STECNT('PUT',1,0,0)
      CALL TBTOPN(CATFIL,F_IO_MODE,TIDCAT,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL: Problems with opening the catalogue'//
     2            ' table; Try again ...'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
C
      CALL TBIGET(TIDCAT,NCCAT,NRCAT,NSCAT,NACCAT,NARCAT,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL: Problems with getting info for'//
     2            ' catalogue table; Try again ...'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
      IF (NRCAT.EQ.0) THEN
         STRING = '*** FATAL: No data in the catalogue table'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
      CALL STECNT('PUT',EC,ED,EL)
C
C *** read the descriptor data
      CALL CATDRD(TIDCAT,NST,IA1,IA2,BA1,BA2,IA3,IA4,IA5,IA6,
     2                   BA3,BA4,BA5,BA6,IA7,IA8)          ! read the descriptor
C
C *** get the intermediate input table
      CALL STKRDC('IN_B',1,1,60,IAV,INTIN,KUN,KNUL,ISTAT)   ! get interm. name
C
C *** get intermediate file info
      CALL TBTOPN(INTIN,F_IO_MODE,TIDIN,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL: Intermediate table not present; '//
     2            'will create a new one ...'
         CALL STTPUT(STRING,ISTAT)

      ELSE
         CALL TBIGET(TIDIN,NCINT,NRINT,NSINT,NACINT,NARINT,ISTAT)
         IF (ISTAT.NE.0) THEN
            STRING = '*** FATAL: Problems with getting info for '//
     2               'intermediate table ...'
            CALL STTPUT(STRING,ISTAT)
            CALL STSEPI
         ENDIF
C
         IF (NRINT.EQ.0) THEN
            STRING = 'FATAL: No points in the intermediate table'
            CALL STTPUT(STRING,ISTAT)
            CALL STSEPI
         ENDIF
C
C *** get the intermediate table parameters
         CALL INTDRD(TIDIN,NGRP,IKT,NSR,SAT,FAT,SIGMA,
     2                                BETA,SIV,AIN,FOG)         ! get descriptor
      ENDIF
C
C *** get the intermediate input table
      CALL STKRDC('OUT_A',1,1,60,IAV,INTOUT,KUN,KNUL,ISTAT)   ! get interm. name
      IF (INTOUT(1:4).NE.'NONE') THEN
         CALL INTINI(INTOUT,TIDOUT)
      ENDIF
C
C *** get information to user
      WRITE(STRING,999) NST
      CALL STTPUT(STRING,ISTAT)
      WRITE(STRING,998) NGRP
      CALL STTPUT(STRING,ISTAT)
      WRITE(STRING,997) IKT
      CALL STTPUT(STRING,ISTAT)
C
C *** do the work
      DO 100 ICAT = 1,NST
         CALL CATTRD(TIDCAT,ICAT,IDENT,D1,D2,RMA,V,B,U,PPP,
     2                      FLCO,BA1,BA2,BA3,BA4,BA5)
         XM(ICAT) = D1
         YM(ICAT) = D2
         KM(ICAT) = 0
  100 CONTINUE
C
      KGR   = 0                        ! initialize the found-components-counter
      KCP   = 0
      IRIN  = 1
      IROUT = 1
C
  200 CONTINUE
          CALL INTWRD(TIDIN,IRIN,NCP,NHL)
          IPX   = INT(PARINT(1))
          IPY   = INT(PARINT(2))
          NP    = INT(PARINT(6))
          NC    = INT(PARINT(7))
          PB(1) = PARINT(8)
          PB(2) = PARINT(9)
          PB(3) = PARINT(10)
          IXE   = IPX+NP-1
          IYE   = IPY+NC-1
C
          DO 201 IH = 1,NHL
             PB((IH-1)*3+1) = FITCMP((IH-1)*3+1)
             PB((IH-1)*3+2) = FITCMP((IH-1)*3+2)
             PB((IH-1)*3+3) = FITCMP((IH-1)*3+3)
  201     CONTINUE
C
          LFWT=0
C
          DO 210 JK = 1,NST
             IF (KM(JK).EQ.0) THEN
                IF (XM(JK).GE.IPX .AND. XM(JK).LE.IXE) THEN
                   IF (YM(JK).GE.IPY .AND. YM(JK).LE.IYE) THEN
                      LI  = 0
                      LFW = 0
220                   CONTINUE
                      IF (LFW.NE.0 .OR. LI.GE.NHL) GO TO 221
                         LI  = LI+1
                         ICB = (LI-1)*3
                         RR  = PB(ICB+3)**2
                         XR  = ((XM(JK)-IPX+1)-PB(ICB+1))**2
                         YR  = ((YM(JK)-IPY+1)-PB(ICB+2))**2
                         IF (XR+YR.LE.RR) THEN
                            LFW = 1
                         END IF
                      GO TO 220
C
  221                 CONTINUE
                      IF (LFW.EQ.0) THEN
                         KM(JK)  = 1
                         JKR     = JK
                         LFWT    = 1
                      END IF
                   END IF
                END IF
             END IF
  210     CONTINUE
C
          IF (LFWT.EQ.1) THEN
             KGR = KGR+1
             IF (INTOUT(1:4).NE.'NONE') THEN              ! write to ouput table
                CALL INTWWR(TIDOUT,IROUT,NCP,NHL)
                KCP = KCP + NCP
                IROUT = IROUT+NCP+NHL
C            ELSE
C               DO 230 IR = IRIN,IRIN+NCP+NHL-1          ! set selection flag on
C                  CALL TBSPUT(TIDIN,IR,SFLAG,ISTAT)
C 230           CONTINUE
             ENDIF
          ENDIF
C
C *** end of loop
          IRIN = IRIN + NCP+NHL
          IF (IRIN.LE.NRINT) THEN
             GO TO 200
          ENDIF
C
C *** put info on screen
      WRITE(STRING,996) KGR
      CALL STTPUT(STRING,ISTAT)
C
C *** finish up
      IF (INTOUT(1:4).NE.'NONE') THEN
         CALL INTDWR(TIDOUT,KGR,KCP,NSR,SAT,FAT,SIGMA,
     2                                BETA,SIV,AIN,FOG)         ! get descriptor
         CALL TBSINI(TIDOUT,ISTAT)
         CALL TBTCLO(TIDOUT,ISTAT)
      ENDIF
      CALL TBTCLO(TIDIN,ISTAT)
      CALL TBTCLO(TIDCAT,ISTAT)
      CALL STSEPI
      END

C @(#)echidena.for	19.1 (ESO-IPG) 02/25/03 14:22:16
      PROGRAM ECHIDA
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  21:52 - 3 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: D.PONZ
C
C.IDENTIFICATION:  ECHIDENA.FOR
C
C.KEYWORDS:
C  Tables
C
C.PURPOSE:
C  Identify features in an echelle spectrum
C     1.0     10-JAN-1988
C     1.1     11-JUl-1990  M.Peron
C     1.2      2-FEB-1995  O.Stahl
C-------------------------------------------------------------------
C
C
      IMPLICIT NONE
C
      INTEGER MADRID
      INTEGER KNUL
      INTEGER IDTID,IDNCOL,IDNROW,IDNS,IDACOL,IDAROW
      INTEGER IDCX,IDCY,IDCW,IDCO
      INTEGER IROW,ISTAT,NCOL,I,NULL
      INTEGER NPOS,NROW,NS,STAT
      INTEGER KUN,TID,ACOL,AROW
      INTEGER ICW,ICX,ICYN
C 
      INTEGER*8 IAW,IAX,IAYN
C
      REAL ORDER,X,Y,WID
C
      CHARACTER TABLE*80,IDTAB*8,TUNIT1*16,TUNIT2*16,FORM1*6,FORM2*6
      CHARACTER LINE*80
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C 
      DATA ORDER/0./
      DATA TUNIT1/'UNITLESS'/
      DATA TUNIT2/'ANGSTROM'/
      DATA FORM1/'I8'/
      DATA FORM2/'F9.2'/
C
C  initialize MIDAS
      CALL STSPRO('ECHIDA')
C
C  get descriptor or table name for storage of data

      CALL STKRDC('P1',1,1,80,I,TABLE,KUN,KNUL,ISTAT)
      
      CALL TBTOPN(TABLE,F_U_MODE,TID,STAT)

      CALL TBIGET(TID,NCOL,NROW,NS,ACOL,AROW,STAT)
      CALL TBCSER(TID,':X ',ICX,STAT)
      CALL TBCSER(TID,':MABS ',ICYN,STAT)
      IF (ICX.EQ.-1 .OR.ICYN.EQ.-1) THEN
         ISTAT  = 1
         GO TO 70
      END IF
      CALL TBCSER(TID,':WAVE',ICW,STAT)
      IF (ICW.EQ.-1) THEN
         CALL TBCINI(TID,D_R8_FORMAT,1,FORM2,TUNIT2,
     .        'WAVE',ICW,STAT)
      END IF
C
      CALL TBCMAP(TID,ICX,IAX,STAT)
      CALL TBCMAP(TID,ICYN,IAYN,STAT)
      CALL TBCMAP(TID,ICW,IAW,STAT)

      CALL SETNULL(MADRID(IAW),NROW)
C
      IDTAB = 'IDTAB'
      CALL TBTOPN(IDTAB,F_I_MODE,IDTID,STAT)
      CALL TBIGET(IDTID,IDNCOL,IDNROW,IDNS,IDACOL,IDAROW,STAT)
      CALL TBCSER(IDTID,':X',IDCX,STAT)
      CALL TBCSER(IDTID,':Y',IDCY,STAT)
      CALL TBCSER(IDTID,':IDENT',IDCW,STAT)
      CALL TBCSER(IDTID,':ORDER',IDCO,STAT)

      DO NPOS = 1, IDNROW
C     
         CALL TBERDR(IDTID,NPOS,IDCX,X,NULL,STAT)
         CALL TBERDR(IDTID,NPOS,IDCY,Y,NULL,STAT)
         CALL TBERDR(IDTID,NPOS,IDCW,WID,NULL,STAT)
         CALL TBERDR(IDTID,NPOS,IDCO,ORDER,NULL,STAT)
C     
C  search for the value on the table
C
         CALL SEARCH(X,ORDER,NROW,MADRID(IAX),MADRID(IAYN),IROW)
         IF(IROW.EQ.0) THEN 
            WRITE(LINE,100) X,Y,WID 
            CALL STTPUT(LINE,STAT)
         ELSE
            CALL GET(NROW,MADRID(IAW),IROW,WID)
         ENDIF
      ENDDO
C     
   70 CONTINUE
      IF (ISTAT.NE.0) THEN
          CALL STTPUT(' Columns :X :MABS are not present',ISTAT)
      END IF

      CALL TBTCLO(TID,STAT)
      CALL TBTCLO(IDTID,STAT)
      CALL STSEPI
C
 100  FORMAT('X = ',F7.2,'Y = ',F5.2,'  LAMBDA = ',F7.2,' not found')
      END

      SUBROUTINE GET(N,WAVE,IPOINT,WID)
C
C ASSIGN WAVELENGTH
C
      IMPLICIT NONE
C 
      INTEGER  IPOINT,N
      INTEGER      TINULL
C 
      REAL     TRNULL, WID
C 
      DOUBLE PRECISION WAVE(N)
      DOUBLE PRECISION TDNULL
C
      CALL TBMNUL(TINULL,TRNULL,TDNULL)

      IF (WID.LE.2.0) THEN
         WAVE(IPOINT) = TDNULL
      ELSE
         WAVE(IPOINT) = WID
      END IF
C 
      RETURN
      END

      SUBROUTINE SEARCH(XN,YN,N,X,Y,IPOINT)
C
C FIND FEATURE
C
      IMPLICIT NONE
C 
      INTEGER  N,IPOINT,I
C 
      REAL X(N),Y(N),DIST,X1,D,XN,YN
C
      IPOINT = 0
      DIST   = 0.1
      DO 10 I = 1,N
         IF (ABS(YN - Y(I)) .LT. 0.1) THEN
            X1     = XN - X(I)
            D      = ABS(X1)
            IF (D.LT.DIST) THEN
               DIST   = D
               IPOINT = I
            ELSE
               IF (IPOINT.NE.0) RETURN
            END IF
         ENDIF
 10   CONTINUE
      RETURN
      END

      SUBROUTINE SETNULL(WAVE,N)
C
C SET ALL WAVELENGTHS TO NULL
C
      IMPLICIT NONE
C 
      INTEGER  I,N
      INTEGER      INULL
C 
      REAL     RNULL
C 
      DOUBLE PRECISION WAVE(N)
      DOUBLE PRECISION DNULL
C
      CALL TBMNUL(INULL,RNULL,DNULL)

      DO I = 1,N
         WAVE(I) = DNULL
      ENDDO
C 
      RETURN
      END

C @(#)extell.for	19.1 (ES0-DMD) 02/25/03 13:30:45
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION:
C  SUBROUTINE  EXTELL            VERSION 1.0             MAY  24, 1985
C  P.GROSBOL                     ESO-GARCHING
C
C.PURPOSE
C  EXTRACE A AZIMUTHAL PROFILE OF A GALAXY ALONG AN ELLIPSE 
C
C.ALGORITHM
C  POINTS A INTERPOLATED BILINEAR ALONG AN ELLIPSE. THE NO. OF POINTS
C  IS A POWER OF 2 IN ORDER TO USE A FFT. 
C
C.INPUT/OUTPUT
C  THE SUBROUTINE IS CALLED AS
C
C     CALL EXTELL( AR, NX, NY, XC, YC, R, PA, AI, NM, PROF, NP)
C
C  WHERE THE PARAMETERS ARE
C     AR(NX,NY) :  ARRAY CONTAINING THE IMAGE                      (I)
C     NX        :  NO. OF X PIXELS                                 (I)
C     NY        :  NO. OF Y PIXELS                                 (I)
C     XC        :  X CENTER OF ELLIPSE IN PIXELS                   (I)
C     YC        :  Y CENTER OF ELLIPSE IN PIXELS                   (I)
C     R         :  MAJOR AXIS OF ELLIPSE IN PIXELS                 (I)
C     PA        :  POSITION ANGLE (MATH) IN RAD.                   (I)
C     AI        :  INCLINATION ANGLE IN RAD.                       (I)
C     NM        :  MAX. NO. OF POINTS TO EXTRACT                   (I)
C     PROF(NM)  :  THE EXTRACTED AZIMUTHAL PROFILE                 (O)
C     NP        :  NO. OF POINTS EXTRACTED                         (O)
C
C----------------------------------------------------------------------
      SUBROUTINE EXTELL(AR,NX,NY,XC,YC,R,PA,AI,NM,PROF,NP)
C
      IMPLICIT  NONE
      INTEGER   NX
      INTEGER   NY
      REAL      AR(NX,NY)
      REAL      XC
      REAL      YC
      REAL      R
      REAL      PA
      REAL      AI
      INTEGER   NM	
      REAL      PROF(NM)
      INTEGER   NP
C
      INTEGER   I, IX, IY
      INTEGER   NP2
      REAL      A, A1, A2, A3, A4
      REAL      DF, CF, SF
      REAL      XS, YS
      REAL      F, FX, FY
      REAL      B
      REAL      V1, V2
C
C     CHECK IF ELLIPSE IS FULLY WITHIN IMAGE - ELSE ERROR : NP=0
C
      NP = 0
      IF (NX.LE.0 .OR. NY.LE.0) RETURN
      IF (R-1.0.GE.MIN(XC,NX-XC) .OR.
     .    R-1.0.GE.MIN(YC,NY-YC)) RETURN
C
C     COMPUTE NO. OF POINTS :  NP = 2**(NP2)
C
      NP  = MIN( NM , MAX( 8 , INT(8.0*R*ATAN(1.0)) ) ) - 1
      NP2 = INT( LOG(FLOAT(NP))/LOG(2.0) ) + 1
      NP  = 2**(NP2)
C
C     SETUP TRANSFORMATION PARAMETERS
C
      A  =  R
      B  =  R * COS( AI )
      A1 =  A * COS( PA )
      A2 = -B * SIN( PA )
      A3 =  A * SIN( PA )
      A4 =  B * COS( PA )
C
C     DO BILINEAR INTERPOLATION ALONG ELLIPSE
C
      F  =  0.0
      DF =  8.0 * ATAN(1.0) / FLOAT(NP)
      DO 100, I = 1,NP
         CF = COS( F )
         SF = SIN( F )
         XS = A1*CF + A2*SF + XC 
         YS = A3*CF + A4*SF + YC 
         IX = INT( XS )
         IY = INT( YS )
         FX = XS - FLOAT(IX)
         FY = YS - FLOAT(IY)
         V1 = AR(IX,IY) + FX * (AR(IX+1,IY) - AR(IX,IY))
         V2 = AR(IX,IY+1) + FX * (AR(IX+1,IY+1) - AR(IX,IY+1))
         PROF(I) = V1 + FY * (V2 - V1)
         F  = F + DF
  100 CONTINUE
      RETURN
      END

C  @(#)fitunc.for	19.1 (ESO-DMD) 02/25/03 13:17:31 
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FITUNC(ALGOR1,ISTAT)                                           
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++        
C                                                                               
C.MODULE                                                                        
C       FIT                                                                     
C                                                                               
C.NAME                                                                          
C       FIT_UNC                                                                 
C                                                                               
C.PURPOSE                                                                       
C   makes the interface between the MIDAS data structures and the NAG           
C   routines for non linear LSQ problems without constraints                    
C                                                                               
C.KEYWORDS                                                                      
C   Non-linear Least Square, Non-linear Fitting, Non-linear Regression          
C   FIT/TABLE,FIT/IMAGE, Newton Method, Corrected Gauss-Newton Method,          
C   Quasi-Newton Method, Modified Gauss-Newton.                                 
C                                                                               
C.DESCRIPTION                                                                   
C       Recovers qualifiers and parameters from MIDAS keywords;                 
C       Give virtual memory for calculations in NAG routines;                   
C       Call the NAG routines for non-linear least squares problems;            
C       Display information messages;                                           
C       Compute errors on parameters.                                           
C                                                                               
C.LANGUAGE                                                                      
C       FORTRAN                                                                 
C                                                                               
C.CALLING SEQUENCE                                                              
C                                                                               
C                                                                               
C.INPUT PARAMETERS                                                              
C       ALGOR    (*)        CHARACTER   algorithm to be used.                   
C                           (CGNND,QN,MGN)                                      
C       ISTAT               INTEGER     exit status                             
C                                                                               
C.MODIFIED PARAMETERS                                                           
C       None                                                                    
C                                                                               
C.OUTPUT PARAMETERS                                                             
C       None                                                                    
C                                                                               
C.FILES                                                                         
C       FIT_NAG.INC/NOLIST                                                      
C                                                                               
C.MODULES CALLED                                                                
C       NAG library        (E04...)                                             
C       LSQMSQ             (message display)                                    
C       Standard Interface (....._ST)                                           
C                                                                               
C.AUTHOR                                                                        
C       Ph. DEFERT,      Feb 1986                                               
C                                                                               
C.BIBLIOGRAPHY                                                                  
C       Algorithms for the Solution of non-linear least squares problem         
C          SIAM J. on Num. An.,15,977-992,1978                                  
C                                                                               
C.VERSION
C 020904	last update
C                                                                               
C--------------------------------------------------------------------

C      IMPLICIT NONE                                                            
C     ..                                                                        
C     .. Scalar Arguments ..                                                    
      CHARACTER*(*)  ALGOR1
      INTEGER ISTAT                                                             
C     ..                                                                        
C     .. Scalars in Common ..                                                   
      INTEGER NRCOL,ISTAR,NAC,NAR,NBYT,IFAIM2 
C     ..                                                                        
C     .. Arrays in Common ..                                                    
      INTEGER MADRID(1),ICOL(10)
C     ..                                                                        
C     .. Local Scalars ..                                                       
      INTEGER I,IDAT,IFAIL1,IFAIL2,J,K,LIW,LW,NC,NROW,NRVM,NS,STATUS,           
     +        NRFEVAL,JOB
      INTEGER KUN,KNUL
      INTEGER*8  PTRW,PTRIW,PTRSV,PTRSVD,PTRFJA,PTRFVC
C 
      DOUBLE PRECISION FSUMSQ
 
      LOGICAL VALID,ISEL,NOMPAR,VCMATPR                                         
      LOGICAL NULL(10)                                                          
 
      CHARACTER WGTTYP*1                                                        
      CHARACTER ALGOR*10
      CHARACTER WGTKEY*10,LINE*78                                               
C     ..                                                                        
C     .. Local Arrays ..                                                        
      REAL XVAL(10)                                                             
C
       INCLUDE 'MID_INCLUDE:FITNAGI.INC/NOLIST'                                 
C     ..                                                                        
C     .. Common blocks ..                                                       
      COMMON /LSQFUN/ICOL,NRCOL,ISTAR,WGTTYP                                    
      COMMON/VMR/MADRID
C     ..                                                                        
C     ..                                                                        
C     .. External Files ..                                                      
      INCLUDE 'MID_INCLUDE:FITNAGC.INC/NOLIST'                                 
C 
      EXTERNAL LSFUN3,LSQMON,E04HEV,LSFUN4
C 
      DATA WGTKEY(1:10)/'FITCHAR  '/                                            
C                                                                               
C  Executable Statements                                                        
C                                                                               
C                                                                               
C  Initialize parameters and compute number of fixed parameters                 
C                             
      ALGOR = ALGOR1                                                  
      CALL FORUPC(ALGOR,ALGOR)
      VCMATPR = METPAR(1) .LT. 0.                                               
      METPAR(1) = ABS(METPAR(1))                                                
      NRPFIX = 0                                                                
      DO 10 J = 1,NRPARAM                                                       
          IF (METPAR(2).GE.0) PARAM(J) = PARINI(J)                              
          IF (FIXPAR(J).GE.0) NRPFIX = NRPFIX + 1                               
   10 CONTINUE                                                                  
      METPAR(2) = ABS(METPAR(2))                                                
C                                                                               
C  Get the type of weighting from FITCHAR 13:13                                 
C                                                                               
      CALL STKRDC(WGTKEY,1,FZIWGT,1,K,WGTTYP,KUN,KNUL,STATUS)                              
      CALL UPCAS(WGTTYP,WGTTYP)
      IF (WGTTYP(1:1).NE.'C' .AND. WGTTYP(1:1).NE.'W' .AND.                     
     .    WGTTYP(1:1).NE.'I' .AND. WGTTYP(1:1).NE.'S') 
     .    CALL STETER(12,'FIT/TABLE: Weight type mismatch')                                    
C                                                                               
      IF (FILTYP(1:1).EQ.'T') THEN                                              
C                                                                               
C  Get columns of indep and dep variables, of the weight if needed              
C                                                                               
          IF (WGTCOL.EQ.0) THEN                                                 
              ISTAR  = 2                                                        
              NRCOL  = NRIND + 1                                                
              ICOL(1) = 0                                                       
          ELSE                                                                  
              ISTAR  = 1                                                        
              NRCOL  = NRIND + 2                                                
              ICOL(1) = WGTCOL                                                  
          END IF                                                                
          ICOL(2) = DEPCOL                                                      
          NULL(1) = .FALSE.                                                     
          DO 20 I = 1,NRIND                                                     
              ICOL(I+2) = INDCOL(I)                                             
   20     CONTINUE                                                              
C                                                                               
C  Get number of selected rows in the table (nr of residuals)                   
C                                                                               
          NRDATA = 0                                                            
          CALL TBIGET(FZIDEN,NC,NROW,NS,NAC,NAR,STATUS)                                 
          DO 40 IDAT = 1,NROW                                                   
              CALL TBSGET(FZIDEN,IDAT,ISEL,STATUS)                              
              IF ( .NOT. ISEL) GO TO 40                                         
              CALL TBRRDR(FZIDEN,IDAT,NRCOL,ICOL(ISTAR),                  
     +                    XVAL(ISTAR),NULL,STATUS)                              
              VALID  = ISEL                                                     
              DO 30 K = 1,NRCOL                                                 
                  VALID  = VALID .AND. ( .NOT. NULL(K))                         
   30         CONTINUE                                                          
              IF (VALID) NRDATA = NRDATA + 1                                    
   40     CONTINUE                                                              
      ELSE                                                                      
C                                                                               
C  Get the number of residuals for FIT/IMAG                                     
C                                                                               
          NRDATA = NRPIX(1)*NRPIX(2)*NRPIX(3)                                   
          NROW   = NRDATA                                                       
      END IF                                                                    
C                                                                               
C     Get qualifiers of the FIT command : PRINT,MAX. NR. Of F. EVAL,            
C     PRECISION,ETA and STEP. NOMPAR detects if method parameters               
C     have been given or are all to be defaulted.                               
C                                                                               
      NOMPAR = METPAR(1) .LT. 0.1                                               
      IF (ABS(ABS(METPAR(3))-999999.0).LT.1.E-6) THEN                           
          METPAR(3) = 1.E-5                                                     
      ELSE                                                                      
          NOMPAR = .FALSE.                                                      
      END IF                                                                    
      IF (ABS(ABS(METPAR(2))-999999.0).LT.1.E-6) THEN                           
          METPAR(2) = 400*NRPARAM                                               
      ELSE                                                                      
          NOMPAR = .FALSE.                                                      
      END IF                                                                    
      IF (ABS(ABS(METPAR(4))-999999.0).LT.1.E-6) THEN                           
          IF (NRPARAM.EQ.1) THEN                                                
              METPAR(4) = 0.                                                    
          ELSE                                                                  
              IF (ALGOR(1:5).EQ.'CGNND') THEN                                   
                  METPAR(4) = 0.5                                               
              ELSE IF (ALGOR(1:3).EQ.'MGN' .OR. ALGOR(1:2).EQ.'QN') THEN        
                  METPAR(4) = 0.9                                               
              END IF                                                            
                                                                                
          END IF                                                                
                                                                                
      ELSE                                                                      
          NOMPAR = .FALSE.                                                      
      END IF                                                                    
                                                                                
      IF (ABS(ABS(METPAR(5))-999999.0).LT.1.E-6) THEN                           
          METPAR(5) = 1.E05                                                     
      ELSE                                                                      
          NOMPAR = .FALSE.                                                      
      END IF                                                                    
C                                                                               
C  Call to the NAG routines after having displayed the parameters and           
C  get the necessary V.M. space.                                                
C                                                                               
      IFAIL1 = 1                                                                
      XVAL(1) = 1.                                                              
      IF (ALGOR(1:5).EQ.'CGNND') THEN                                           
          CALL STTPUT(' ',STATUS)                                               
          CALL STTPUT(                                                          
     +     ' Non-linear Least Squares Fitting : Corrected Gauss-Newton '        
     +                //'Method (no der)',STATUS)                               
          CALL STTPUT(                                                          
     +     ' __________________________________________________________'        
     +                //'_______________',STATUS)                               
          CALL STTPUT(' ',STATUS)                                               
          CALL STTPUT(' ',STATUS)                                               
                                                                                
          CALL STTPUT(                                                          
     +  ' Print   Max. Fct. eval.  Prec. on Param.  Lin. Search  Domain'        
     +                //'  Weight',STATUS)                                      
          WRITE (LINE,9000) NINT(METPAR(1)),NINT(METPAR(2)),METPAR(3),          
     +      METPAR(4),METPAR(5),WGTTYP                                          
          CALL STTPUT(LINE,STATUS)                                              
          CALL STTPUT(' ',STATUS)                                               
          IF (NOMPAR) THEN                                                      
              IF (NRPARAM.EQ.1) THEN                                            
                  LW     = 9 + 5*NROW                                           
              ELSE                                                              
                  LW     = (7+NRPARAM+2*NROW+NRPARAM/2)*NRPARAM +               
     +                     3*NROW + 1                                           
              END IF                                                            
              LIW    = 100                                                      
              NRVM   = 2*LW + LIW                                               
              NBYT   = NRVM*4
              CALL TDMGET(NBYT,PTRW,STATUS)
              PTRIW  = PTRW + 2*LW                                              
              CALL E04FDF(NRDATA,NRPARAM,PARAM,FSUMSQ,MADRID(PTRIW),
     +                    LIW,MADRID(PTRW),LW,IFAIL1)                               
          ELSE                                                                  
              IF (NRPARAM.EQ.1) THEN                                            
                  LW     = 7 + 3*NRPARAM                                        
              ELSE                                                              
                  LW     = (6+NROW+NRPARAM/2)*NRPARAM + 2*NROW + 1              
              END IF                                                            
              LIW    = 100                                                      
              NRVM   = 2* (LW+ (NROW+NRPARAM)* (NRPARAM+1)) + LIW               
              NBYT   = NRVM*4
              CALL TDMGET(NBYT,PTRW,STATUS)
              PTRFVC = PTRW   + 2*LW                                              
              PTRFJA = PTRFVC + 2*NROW                                          
              PTRSV  = PTRFJA + 2*NROW*NRPARAM                                  
              PTRSVD = PTRSV  + 2*NRPARAM                                        
              PTRIW  = PTRSVD + 2*NRPARAM*NRPARAM                               
              CALL E04FCF(NRDATA,NRPARAM,LSFUN3,LSQMON,NINT(METPAR(1)),         
     +                    NINT(METPAR(2)),DBLE(METPAR(4)),                      
     +                    DBLE(METPAR(3)),DBLE(METPAR(5)),PARAM,FSUMSQ,         
     +                    MADRID(PTRFVC),MADRID(PTRFJA),NRDATA,                 
     +                    MADRID(PTRSV),MADRID(PTRSVD),NRPARAM,NRITER,          
     +                    NRFEVAL,MADRID(PTRIW),LIW,MADRID(PTRW),LW,            
     +                    IFAIL1)                                               
          END IF                                                                
      ELSE IF (ALGOR(1:2).EQ.'QN') THEN                                         
          CALL STTPUT(' ',STATUS)                                               
          CALL STTPUT(                                                          
     +         ' Non-linear Least Squares Fitting : Quasi-Newton Method'        
     +                ,STATUS)                                                  
          CALL STTPUT(                                                          
     +         ' ______________________________________________________'        
     +                ,STATUS)                                                  
          CALL STTPUT(' ',STATUS)                                               
          CALL STTPUT(' ',STATUS)                                               
          CALL STTPUT(                                                          
     +  ' Print   Max. Fct. eval.  Prec. on Param.  Lin. Search  Domain'        
     +                //'  Weight',STATUS)                                      
          WRITE (LINE,9000) NINT(METPAR(1)),NINT(METPAR(2)),METPAR(3),          
     +      METPAR(4),METPAR(5),WGTTYP                                          
          CALL STTPUT(LINE,STATUS)                                              
          CALL STTPUT(' ',STATUS)                                               
          IF (NOMPAR) THEN                                                      
              IF (NRPARAM.EQ.1) THEN                                            
                  LW     = 11 + 5*NROW + 1                                      
              ELSE                                                              
                  LW     = (8+2*NRPARAM+2*NROW)*NRPARAM + 3*NROW + 1            
              END IF                                                            
              LIW    = 100                                                      
              NRVM   = LW*2 + LIW                                               
              NBYT   = NRVM*4
              CALL TDMGET(NBYT,PTRW,STATUS)
              PTRIW  = PTRW + 2*LW                                              
              CALL E04GCF(NRDATA,NRPARAM,PARAM,FSUMSQ,MADRID(PTRIW),
     +                    LIW,MADRID(PTRW),LW,IFAIL1)                               
          ELSE                                                                  
              IF (NRPARAM.EQ.1) THEN                                            
                  LW     = 9 + 3*NRPARAM                                        
              ELSE                                                              
                  LW     = (7+NROW+NRPARAM)*NRPARAM + 2*NROW + 1                
              END IF                                                            
              LIW    = 100                                                      
              NRVM   = (LW+ (NROW+NRPARAM)* (NRPARAM+1))*2 + LIW                
              NBYT   = NRVM*4
              CALL TDMGET(NBYT,PTRW,STATUS)
              PTRFVC = PTRW   + 2*LW                                              
              PTRFJA = PTRFVC + 2*NROW                                          
              PTRSV  = PTRFJA + 2*NROW*NRPARAM                                  
              PTRSVD = PTRSV  + 2*NRPARAM                                        
              PTRIW  = PTRSVD + 2*NRPARAM*NRPARAM                               
              CALL E04GBF(NRDATA,NRPARAM,E04HEV,LSFUN4,LSQMON,                  
     +                    NINT(METPAR(1)),NINT(METPAR(2)),                      
     +                    DBLE(METPAR(3)),DBLE(METPAR(4)),                      
     +                    DBLE(METPAR(5)),PARAM,FSUMSQ,MADRID(PTRFVC),          
     +                    MADRID(PTRFJA),NRDATA,MADRID(PTRSV),                  
     +                    MADRID(PTRSVD),NRPARAM,NRITER,NRFEVAL,                
     +                    MADRID(PTRIW),LIW,MADRID(PTRW),LW,IFAIL1)               
          END IF                                                                
      ELSE IF (ALGOR(1:3).EQ.'MGN') THEN                                        
          CALL STTPUT(' ',STATUS)                                               
          CALL STTPUT(                                                          
     +' Non-linear Least Squares Fitting : Modified Gauss-Newton Method'        
     +                ,STATUS)                                                  
          CALL STTPUT(                                                          
     +' _______________________________________________________________'        
     +                ,STATUS)                                                  
          CALL STTPUT(' ',STATUS)                                               
          CALL STTPUT(' ',STATUS)                                               
          CALL STTPUT(                                                          
     +  ' Print   Max. Fct. eval.  Prec. on Param.  Lin. Search  Domain'        
     +                //'  Weight',STATUS)                                      
          WRITE (LINE,9000) NINT(METPAR(1)),NINT(METPAR(2)),METPAR(3),          
     +      METPAR(4),METPAR(5),WGTTYP                                          
          CALL STTPUT(LINE,STATUS)                                              
          CALL STTPUT(' ',STATUS)                                               
          IF (NOMPAR) THEN                                                      
              IF (NRPARAM.EQ.1) THEN                                            
                  LW     = 11 + 5*NROW + 1                                      
              ELSE                                                              
                  LW     = (8+2*NRPARAM+2*NROW)*NRPARAM + 3*NROW + 1            
              END IF                                                            
              LIW    = 100                                                      
              NRVM   = LW*2 + LIW                                               
              NBYT   = NRVM*4
              CALL TDMGET(NBYT,PTRW,STATUS)
              PTRIW  = PTRW + 2*LW                                              
              CALL E04GEF(NRDATA,NRPARAM,PARAM,FSUMSQ,MADRID(PTRIW),
     +                    LIW,MADRID(PTRW),LW,IFAIL1)                               
          ELSE                                                                  
              IF (NRPARAM.EQ.1) THEN                                            
                  LW     = 9 + 3*NRPARAM                                        
              ELSE                                                              
                  LW     = (7+NROW+NRPARAM)*NRPARAM + 2*NROW + 1                
              END IF                                                            
              LIW    = 100                                                      
              NRVM   = (LW+ (NROW+NRPARAM)* (NRPARAM+1))*2 + LIW                
              NBYT   = NRVM*4
              CALL TDMGET(NBYT,PTRW,STATUS)
              PTRFVC = PTRW   + 2*LW                                              
              PTRFJA = PTRFVC + 2*NROW                                          
              PTRSV  = PTRFJA + 2*NROW*NRPARAM                                  
              PTRSVD = PTRSV  + 2*NRPARAM                                        
              PTRIW  = PTRSVD + 2*NRPARAM*NRPARAM                               
              CALL E04GDF(NRDATA,NRPARAM,LSFUN4,LSQMON,NINT(METPAR(1)),         
     +                    NINT(METPAR(2)),DBLE(METPAR(3)),                      
     +                    DBLE(METPAR(4)),DBLE(METPAR(5)),PARAM,FSUMSQ,         
     +                    MADRID(PTRFVC),MADRID(PTRFJA),NRDATA,                 
     +                    MADRID(PTRSV),MADRID(PTRSVD),NRPARAM,NRITER,          
     +                    NRFEVAL,MADRID(PTRIW),LIW,MADRID(PTRW),LW,            
     +                    IFAIL1)                                               
          END IF                                                                
      END IF                                                                    
C                                                                               
C  Display message after NAG call                                               
C                                                                               
      CALL LSQMSG(ALGOR(1:5),IFAIL1)                                            
      CALL STTPUT(' ',STATUS)                                                   
C                                                                               
C  Call to the NAG routine to compute the errors on parameters after            
C  having computed the address of the relevant information to pass.             
C                                                                               
      IF (IFAIL1.NE.1 .AND. IFAIL1.NE.4 .AND. IFAIL1.NE.9) THEN                 
          IF (NOMPAR) THEN                                                      
              IF (ALGOR(1:5).EQ.'CGNND') THEN                                   
               PTRSV  = PTRW + 2* (6*NRPARAM+2*NRDATA+NRDATA*NRPARAM+        
     +                     MAX0(1, (NRPARAM* (NRPARAM-1)/2)))                   
               PTRSVD = PTRSV + 2*NRPARAM                                    
              ELSE                                                              
               PTRSV  = PTRW + 2* (7*NRPARAM+2*NRDATA+NRDATA*NRPARAM+        
     +                     NRPARAM* (NRPARAM+1)/2+                              
     +                     MAX0(1, (NRPARAM* (NRPARAM-1)/2)))                   
               PTRSVD = PTRSV + 2*NRPARAM                                    
              END IF                                                            
          END IF                                                                
          IFAIL2 = 1                                                            
          IF (VCMATPR) THEN                                                     
              JOB    = -1                                                       
          ELSE                                                                  
              JOB    = 0                                                        
          END IF                                                                
          CALL E04YCF(JOB,NRDATA,NRPARAM,FSUMSQ,MADRID(PTRSV),                  
     +                MADRID(PTRSVD),NRPARAM,ERROR,MADRID(PTRW),IFAIL2)         
          IF (IFAIL2.NE.0) THEN                                                 
              CALL STTPUT(' ',STATUS)  
              IFAIM2 = IFAIL2-2                                         
              WRITE (LINE,9010) IFAIM2,NRPARAM                              
              CALL STTPUT(LINE,STATUS)                                          
              CALL STTPUT(' ',STATUS)                                           
          END IF                                                                
          IF (VCMATPR) THEN                                                     
              CALL DCPRIN(MADRID(PTRSVD),NRPARAM,NRPARAM)                       
              CALL MATDIA(MADRID(PTRSVD),ERROR,NRPARAM,NRPARAM)                
          END IF                                                                
          DO 50 K = 1,NRPARAM                                                   
              ERROR(K) = SQRT(ERROR(K))                                         
   50     CONTINUE                                                              
                                                                                
      ELSE                                                                      
          CALL STTPUT(                                                          
     +        ' *** Unable to evaluate the errors on the parameters ***'        
     +                ,STATUS)                                                  
      END IF                                                                    
C                                                                               
C  Pass the final reduced chi squares to the COMMON block                       
C                                                                               
      NRITER = NRFEVAL                                                          
      FINCHI = FSUMSQ/DBLE(NRDATA-NRPARAM+NRPFIX)                             
C                                                                               
C  Exit                                                                         
C                                                                               
      CALL TDMFRE(NBYT,PTRW,STATUS)
      RETURN                                                                    
 9000 FORMAT (I6,8X,I7,7X,1PE9.1,8X,0PF4.2,6X,0PF8.0,5X,A1)                     
 9010 FORMAT ('*** Detected only ',I3,' linear independent parameters ',        
     +       'on the total of ',I3,' ***')                                      
      END                                                                       

C @(#)ftsval.for	19.1 (ES0-DMD) 02/25/03 13:17:36
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FTSVAL(NAME,LEN,FLAG,GUESS,ERROR,FACTOR,ISTAT)                 
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                   
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:25 - 13 JAN 1988                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C.IDENTIFICATION                                                                
C                                                                               
C  FITLIB.FOR   VERSION 1.0  27 MAR 1984                                        
C                                                                               
C.PURPOSE                                                                       
C                                                                               
C  INTERFACE ROUTINES FOR THE FITTING STRUCTURES                                
C SEARCH INITIAL VALUES OF THE PARAMETER                                        
C                                                                               
C.ALGORITHM                                                                     
C                                                                               
C  USE MIDAS I/O INTERFACES TO FRAMES AND TABLES                                
C                                                                               
C.KEYWORDS                                                                      
C                                                                               
C  NON LINEAR FITTING                                                           
C                                                                               
C                                                                               
C----------------------------------------------------------------               
C                                                                               
C                                                                               
C INPUT ARGUMENTS                                                               
C NAME CHAR PARAMETER NAME                                                      
C LEN INTG NUMBER OF BYTES IN NAME                                              
C                                                                               
C OUTPUT PARAMETERS                                                             
C FLAG INTG CONSTRAIN FLAG AS                                                   
C   <0 FREE PARAMETER                                                           
C    0 FIXED PARAMETER                                                          
C   >0 POINTER TO THE PROPORTIONAL PARAMETER                                    
C GUESS DBLE GUESS                                                              
C ERROR REAL OPTIONAL ERROR WEIGHT                                              
C FACTOR REAL OPTIONAL FACTOR FOR PROPORTIONAL PARAMETERS                       
C ISTAT INTG STATUS RETURN                                                      
C                                                                               
      CHARACTER*(*) NAME                                                        
      INTEGER FLAG,LEN,ISTAT,LEN1,I,II,II1,II2,ICASE                            
      INTEGER IAC,L2,J,IB,L1
      REAL ERROR,FACTOR,VALUE
      DOUBLE PRECISION DB,GUESS                                                 
      CHARACTER*20 TOKEN1,TOKEN2,TEST1,TEST2
      CHARACTER LINE*80,LINE1*80,C*1,NAME1*10                                   
       INCLUDE 'MID_INCLUDE:FITI.INC/NOLIST'                                     
       INCLUDE 'MID_INCLUDE:FITC.INC/NOLIST'                                     
C                                                                               
C ITERATION ON THE FUNCTION SPECIFICATION                                       
C                                                                               
      LEN1   = LEN + 1                                                          
      NAME1  = NAME(1:LEN)//'='                                                 
      DO 10 I = 1,FZNFUN                                                      
          LINE   = FZSPEC(I)                                                  
          II     = INDEX(LINE,NAME1(1:LEN1))                                    
          IF (II.NE.0) GO TO 20                                                 
   10 CONTINUE                                                                  
C                                                                               
C PARAMETER NOT INITIALIZED                                                     
C                                                                               
      FLAG   = -1                                                               
      GUESS  = 0.D0                                                             
      ERROR  = 0.                                                               
      FACTOR = 0.                                                               
      RETURN                                                                    
C                                                                               
C DECODE THE PARAMETER VALUE OR CONSTRAIN                                       
C                                                                               
   20 II     = II + LEN1                                                        
      LINE1  = LINE(II:)                                                        
      DO 30 I = 1,80                                                            
          C      = LINE1(I:I)                                                   
          IF (C.EQ.' ') GO TO 40                                                
   30 CONTINUE                                                                  
   40 II     = I - 1                                                            
C                                                                               
C CHECK ONE OF THE FOLLOWING RULES                                              
C LINE1(1:II) = value                                                           
C        value@                                                                 
C        value*param                                                            
C        param*value                                                            
C        param/value                                                            
C        param                                                                  
C  !   value@                                                                   
      IF (LINE1(II:II).EQ.'@') THEN                                             
          TOKEN1 = LINE1(1:II-1)                                                
          L1     = II - 1                                                       
          ICASE  = 1                                                            
      ELSE                                                                      
          II1    = INDEX(LINE1(1:II),'*')  !   value*param or param*value       
          IF (II1.NE.0) THEN                                                    
              TOKEN1 = LINE1(1:II1-1)                                           
              L1     = II1 - 1                                                  
              TOKEN2 = LINE1(II1+1:II)                                          
              L2     = II - II1                                                 
              ICASE  = 3                                                        
          ELSE                                                                  
              II2    = INDEX(LINE1(1:II),'/')  !   param/value                  
              IF (II2.NE.0) THEN                                                
                  TOKEN1 = LINE1(1:II2-1)                                       
                  L1     = II2 - 1                                              
                  TOKEN2 = LINE1(II2+1:II)                                      
                  L2     = II - II2                                             
                  ICASE  = 4                                                    
              ELSE                                                              
                  II1    = INDEX('-+.0123456789',LINE1(1:1))  !   param         
                  IF (II1.EQ.0) THEN                                            
                      ICASE  = 5                                                
                      VALUE  = 1.                                               
                  ELSE  !   value                                               
                      ICASE  = 2                                                
                  END IF                                                        
                  TOKEN1 = LINE1                                                
                  L1     = II                                                   
              END IF                                                            
          END IF                                                                
      END IF                                                                    
      IF (ICASE.LE.2) THEN                                                      
          CALL GENCNV(TOKEN1(1:L1),2,1,IB,VALUE,DB,IAC)                         
          GUESS  = VALUE                                                        
          IF (IAC.LT.0) GO TO 60                                                
          ERROR  = 0.                                                           
          FLAG   = -1                                                           
          FACTOR = 0.                                                           
          IF (ICASE.EQ.1) FLAG   = 0                                            
      ELSE                                                                      
          II     = INDEX('+-1234567890.',TOKEN1(1:1))  !   TOKEN1 is parameter  
          IF (II.EQ.0) THEN                                                     
              IF (ICASE.NE.5) 
     .           CALL GENCNV(TOKEN2(1:L2),2,1,IB,VALUE,DB,IAC)
              IF (IAC.LT.0) GO TO 60                                            
              ERROR  = 0.                                                       
              IF (ICASE.EQ.3 .OR. ICASE.EQ.5) THEN                              
                  FACTOR = VALUE                                                
              ELSE                                                              
                  IF (VALUE.EQ.0.) GO TO 60                                     
                  FACTOR = 1./VALUE                                             
              END IF                                                            
          ELSE  !   value/param not supported                                   
              IF (ICASE.EQ.4) GO TO 60                                          
              CALL GENCNV(TOKEN1(1:L1),2,1,IB,VALUE,DB,IAC)                     
              IF (IAC.LT.0) GO TO 60                                            
              FACTOR = VALUE                                                    
              TOKEN1 = TOKEN2                                                   
              L1     = L2                                                       
          END IF                                                                
C                                                                               
C SEARCH FOR PARAMETER TOKEN1                                                   
C                                                                               
          TEST1 = TOKEN1
          CALL FORUPC(TEST1, TEST1)
          DO 50 J = 1,FZNPTOT                      
              TEST2 = FZPTOKEN(J)
              CALL FORUPC(TEST2, TEST2)                           
              IF (TEST2(1:FZPLEN(J)).EQ.TEST1(1:L1)) THEN           
                  IF (FZFIXED(J).GT.0) GO TO 60                               
                  FLAG   = J                                                    
                  RETURN                                                        
              END IF                                                            
   50     CONTINUE                                                              
          ISTAT  = FERCON                                                   
      END IF                                                                    
      RETURN                                                                    
   60 ISTAT  = FERCON                                                       
      RETURN                                                                    
      END                                                                       

C @(#)tdazident.for	19.1 (ES0-DMD) 02/25/03 13:17:06
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  15:18 - 18 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ, K.BANSE
C
C.IDENTIFICATION: TDAZIDENT.FOR      
C
C.KEYWORDS:
C  image display, cursor, tables, identification
C
C.PURPOSE:
C  Identify table entries via the cursor
C  read the position of the cursor on the DeAnza
C  ask for identification
C  store the information on a column
C
C.ALGORITHM:
C   Use enabled cursor(s) and read screen pixels, get real pixels
C  and world coord
C  when the ENTER button is pressed on the cursor board.
C  Exit by pressing ENTER with enabled cursor(s) off.
C   Max. no. of coords is read from CURSOR(1), if this max. is reached,
C  we exit automatically!
C  MODIFIED VERSION OF COORD
C
C.INPUT/OUTPUT:
C  the following keywords are used:
C
C  DEANZA/I/1/6   main display info
C  DAZHOLD/I/1/3  cursor(s) enabled, cursor form(s) + split screen mode
C
C  P1/C/1/15   optional descriptor name where world coordinates
C    + pixel values should be stored
C    or table name, if data should go to a table
C    = ?, if data only to be displayed on terminal
C
C  OUTPUTR/R/10/10  receives real pixels, world coords + intensities 
C    for each cu
C  OUTPUTI/I/1/1  receives total no. of coordinates obtained
C  CURSOR/I/1/4   (1) holds max. no. of coords reading on input
C    (1,,,4) will be filled with cursor pos. on output
C
C.VERSIONS
C  1.50  use IMPLICT NONE and use IDI interfaces + new cursor interface  GETCUR
C
C-------------------------------------------------------------------
C
C
      PROGRAM TDAZID
      IMPLICIT NONE
C
      LOGICAL IFIRST
      LOGICAL IHEAD
      LOGICAL STUPID
C
      INTEGER MADRID
      INTEGER COOCNT,COOMAX
      INTEGER IAV,ICR,ICX,ICY
      INTEGER IL,IROW,J,N,NBYT2,NC
      INTEGER NCOL,NROW,NINCOL,NN,NOC,NOREC,NPOS
      INTEGER STAT,ST1,ST2
      INTEGER XY1(2),XY2(2)
      INTEGER IC(7)
      INTEGER TID,NAC,NAR,DTYPEX,DTYPEY,DTYPER,KUN,KNUL
C
      CHARACTER OUTPUT*1
      CHARACTER INFO*24,HEAD*80
      CHARACTER FRAME*60
      CHARACTER TABLE*64,COLM1*17,COLM2*17,COLM3*17
      CHARACTER ERROR*17,FORM*8
      CHARACTER PROMPT*18,LINE*80,LINE1*27
      CHARACTER CVAL*80
      CHARACTER IEXT*10,TNULL*10
C
      REAL RBUF,RERR,RVAL(2)
      REAL FPIX(4),WCOO(4)
C
      DOUBLE PRECISION DDUM(2),DVAL(2),DERR
C
      INCLUDE 'MID_INCLUDE:TABLES.INC'
      INCLUDE 'MID_INCLUDE:IDIDEV.INC'
      INCLUDE 'MID_INCLUDE:IDIMEM.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:TABLED.INC'
C
      DATA IFIRST/.FALSE./
      DATA IHEAD/.TRUE./
      DATA INFO/'switch cursor(s) on...'/
      DATA IEXT/'^%&$*#(@)!'/
      DATA TNULL/'*         '/
C
C ...  INITIALIZE MIDAS
C
      CALL STSPRO('TDAZIDENT')
C
C ... GET DISPLAY UNIT FOR DEANZA + ATTACH IT
C
      CALL DTOPEN(1,STAT)
C
C ...  GET CURSORS INVOLVED
C
      CALL STKRDI('DAZHOLD',1,1,IAV,NOC,KUN,KNUL,STAT)  !  NOC = 1,2,3 for cursor 1,2 or both
      NOC    = NOC + 1
C
C ...  GET PARAMETERS
C
      NOREC  = 1
      CALL STKRDC('P1',1,1,64,IAV,TABLE,KUN,KNUL,STAT)
      CALL STKRDC('P2',1,1,17,IAV,COLM1,KUN,KNUL,STAT)
      CALL STKRDC('P3',1,1,17,IAV,COLM2,KUN,KNUL,STAT)
      CALL STKRDC('P4',1,1,17,IAV,COLM3,KUN,KNUL,STAT)
      CALL STKRDC('P5',1,1,17,IAV,ERROR,KUN,KNUL,STAT)
      IF (COLM3(1:1).EQ.':' .OR. COLM3(1:1).EQ.'#') THEN
          NINCOL = 2
      ELSE
          NINCOL = 1
          ERROR  = COLM3
      END IF
      IF (ERROR(1:1).EQ.'?') THEN
          RERR   = 2.
      ELSE
          CALL GENCNV(ERROR,2,1,N,RERR,DERR,NN)
      END IF
C
C ... READ TABLE
C
      NC     = 0
      CALL TBTOPN(TABLE,F_U_MODE,TID,STAT)
      CALL TBIGET(TID,NCOL,NROW,N,NAC,NAR,STAT)
      CALL TBCSER(TID,COLM1,ICR,STAT)
      IF (ICR.EQ.-1) 
     .CALL TBCINI(TID,D_R4_FORMAT,'E14.6','  ',COLM1(2:17),ICR,STAT)
      NC     = NC + 1
      IC(NC) = ICR
      CALL TBCSER(TID,COLM2,ICX,STAT)
      IF (ICX.EQ.-1) THEN
          CALL STETER(1,'COLM not found ... ')
      ELSE
          CALL TBFGET(TID,ICX,FORM,IL,DTYPEX,STAT)
          IF (DTYPEX.EQ.D_C_FORMAT) 
     +        CALL STETER(2,'Wrong COLM format ... ')
          NC     = NC + 1
          IC(NC) = ICX
      END IF
      IF (NINCOL.EQ.2) THEN
          CALL TBCSER(TID,COLM3,ICY,STAT)
          IF (ICY.EQ.-1) THEN
              CALL STETER(1,'COLM not found ... ')
          ELSE
              CALL TBFGET(TID,ICY,FORM,IL,DTYPEY,STAT)
              IF (DTYPEY.EQ.D_C_FORMAT) 
     .            CALL STETER(2,'Wrong COLM format ... ')
              IF (DTYPEX.NE.DTYPEY) 
     .            CALL STETER(3,'Incompatible COLM format ... ')
          END IF
          NC     = NC + 1
          IC(NC) = ICY
      END IF
      CALL TBLGET(TID,ICR,PROMPT,STAT)
      PROMPT(17:18) = '?:'
      CALL TBFGET(TID,ICR,FORM,IL,DTYPER,STAT)
      IF (DTYPER.EQ.D_R4_FORMAT) THEN
          NBYT2 = -4
      ELSE IF (DTYPER.EQ.D_R8_FORMAT) THEN
          NBYT2 = -8
      ELSE
          NBYT2 = IL
      END IF
C
C ... INIT + GET MAX. COORD READINGS
C
      NPOS   = 0
      CALL STTPUT(' - Position the cursor ',STAT)
      CALL STTPUT(' - Press ENTER',STAT)
      OUTPUT = CHAR(07)
      CALL STTPUT(OUTPUT,STAT)
      CALL STKRDI('CURSOR',1,1,IAV,COOMAX,KUN,KNUL,STAT)
      COOCNT = 0
C !necessary to tell GETCUR, that it's first time...
      FRAME  = ' '
C
C ... READ CURSOR POSITION(S)
C
C !'NN' = no drawing, no pixel value
   10 CALL GETCUR('NNYY',FRAME,XY1,FPIX(1),WCOO(1),RBUF,
     .            ST1,XY2,FPIX(3),WCOO(3),RBUF,ST2)
      GO TO (20,30,40),NOC
C
   20 IF (ST1.EQ.0) THEN
          GO TO 50
      ELSE
          GO TO 60
      END IF
   30 IF (ST2.EQ.0) THEN
          GO TO 50
      ELSE
          GO TO 60
      END IF
   40 IF ((ST1.EQ.0) .AND. (ST2.EQ.0)) THEN
          GO TO 50
      ELSE
          GO TO 60
      END IF
C
C ... IF CURSORS ARE NOT SWITCHED ON INITIALLY, DISPLA INFO MESSAGE
C
   50 IF (COOCNT.EQ.0) THEN
          CALL STTPUT(INFO,STAT)
          GO TO 10
      ELSE
          GO TO 110
      END IF
C  !  update coordinate counter
   60 COOCNT = COOCNT + 1
C
C ... SEARCH FOR THE VALUE ON THE TABLE
C
      IF (NINCOL.EQ.1) THEN
          IF (DTYPEX.EQ.D_R4_FORMAT) THEN
              CALL TBES1R(TID,ICX,FPIX,IROW,RVAL,STAT)
          ELSE
              DDUM(1) = FPIX(1)
              DERR   = RERR
              CALL TBES1D(TID,ICX,DDUM,IROW,DVAL,STAT)
          END IF
      ELSE
          IF (DTYPEX.EQ.D_R4_FORMAT) THEN
              CALL TBES2R(TID,ICX,ICY,FPIX,IROW,RVAL,STAT)
          ELSE
              DDUM(1) = FPIX(1)
              DDUM(2) = FPIX(2)
              DERR   = RERR
              CALL TBES2D(TID,ICX,ICY,DDUM,IROW,DVAL,STAT)
          END IF
      END IF
      IF (IROW.EQ.0) THEN
          WRITE (LINE1,9010) FPIX(1),FPIX(2)
          CALL STTPUT(LINE1//' Feature not found, try again',STAT)
      ELSE
C
C ... GET FPIX(1), FPIX(2), IDENT, X, (Y)
C
          CALL TDLIS2(TID,NC,IC,IROW,LINE,IHEAD,HEAD,STAT)
          IF (IHEAD) THEN
              IHEAD  = .FALSE.
              CALL STTPUT('  X COORD.   Y COORD.   '//HEAD,STAT)
          END IF
          WRITE (LINE1,9010) FPIX(1),FPIX(2)
          CALL STTPUT(LINE1//LINE,STAT)
C
C ... WRITE PROMPT FPIX(1), FPIX(2), IDENT, X, (Y),
C ... AND ENTER VALUE IN THE TID
C
          STUPID = .FALSE.             ! standard update identification
  100     IF (STUPID) CALL STTPUT('Error in input. ',STAT)
          STUPID = .TRUE.
   70     CVAL   = IEXT
          STAT   = 0
          CALL STKPRC(PROMPT,'INPUTC',1,1,80,IAV,CVAL,KUN,KNUL,STAT)
          IF (CVAL(1:10).NE.IEXT) THEN
              IF (CVAL(1:10).EQ.TNULL) THEN
                  CALL TBEDEL(TID,IROW,ICR,STAT)
              ELSE
                  DO 80 J = 80,1,-1
                      IF (CVAL(J:J).NE.' ') GO TO 90
   80             CONTINUE
                  J      = 80
   90             CONTINUE
C       CALL TZCV1C(CVAL,J,1,TYPER,NBYT2,RVAL,RVAL,
C     .         DVAL,CVAL1,STAT)
                  IF (STAT.NE.0) GO TO 70
                  IF (DTYPER.EQ.D_R4_FORMAT) THEN
                      READ (CVAL(1:J),9000,ERR=100) RVAL(1)
                      CALL TBEWRR(TID,IROW,ICR,RVAL,STAT)
                  ELSE IF (DTYPER.EQ.D_R8_FORMAT) THEN
                      READ (CVAL(1:J),9000,ERR=100) DVAL(1)
                      CALL TBEWRD(TID,IROW,ICR,DVAL,STAT)
                  ELSE
                      CALL TBEWRC(TID,IROW,ICR,CVAL,STAT)
                  END IF
              END IF
          END IF
          STUPID = .FALSE.
      END IF  !  look for more
      GO TO 10
C
C ... END
C
  110 CALL TBTCLO(TID,STAT)
C
      CALL DTCLOS(QDSPNO)
      CALL STSEPI
C
C  Formats
 9000 FORMAT (BN,F4.0)
 9010 FORMAT (' ',E12.6,' ',E12.6,' ')
      END

C @(#)pair.for	19.1 (ES0-DMD) 02/25/03 13:31:23
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
       PROGRAM PAIR
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENT  program PAIR                       A. Lauberts  ESO, Garching  890712
C
C.KEYWORDS  table files, coordinates, alignment, matching
C
C.PURPOSE
C  Match (pair) two point sets with coordinates in table files INA and INB,
C  common set of points form new table file OUTA with added columns,
C  excluded points are appended to the common set,
C  copy of coordinates also in missing places of both sets.
C  Alt 1: coordinates in their own systems
C      2: 2nd system coords transformed to 1st system
C
C.ALGORITHM  common translation vector estimated as
C            mode of histogram of X,Y separations.
C            2nd iteration does small coordinate rotation.
C
C.USAGE  MIDAS application program
C        execute as @@ PAIR P1 P2 P3 P4 P5 P6
C
C.PARAMETERS  input/output
C
C P1  INA  C*8         name of first table file
C P2  INB  C*8         name of second table 
C P3  OUTA C*8         name of output table
C P4  CXY  I*4 array   column nos of coordinates:
C                     1st table (X,Y), 2nd table (X,Y)
C P5  SEP  R*4 array   estimated separations in X, Y between 1st and 2nd tables,
C                           max residual distance after coordinate translation, 
C                           max residual distance after coordinate rotation
C P6  SYS  I*4              0: coordinates in their own systems
C                     1: 2nd system transformed to 1st system
C
C.COMMENTS  Second set of labels have characters 14-16 replaced with
C           column numbers in order to avoid repeated label names;
C           embedded blanks are replaced with underscore (_).
C
C           Max no of objects in each table is limited to 50000.
C
C---------------------------------------------------------------------
       IMPLICIT   NONE
C
       INTEGER      IB(50000), HX(200),HY(200),COL(256),COLA(256)
       INTEGER      JA(50000),JB(50000),CXY(4),STAT,SYS,KUN,KNUL
       INTEGER      MADRID,TID1,TID2,TID3,ACOL,AROW
       REAL         XA(50000),YA(50000),XB(50000),YB(50000)
       REAL         ROW(256),ROWA(256)
       REAL         XAB(50000),YAB(50000),A(4),B(4),SEP(4)
       CHARACTER*60 INA,INB,OUTA
       CHARACTER*8  TYPE
       CHARACTER*80 TEXT*80
       CHARACTER*16 LABEL, FMT, UNIT
       LOGICAL      NULL(256)
C
       INTEGER      IACT
       INTEGER      I, J, L, N, II, JJ
       INTEGER      NCA, NSC, NCB, NC, NS
       INTEGER      NSA, NSB
       INTEGER      NA1, NA2
       INTEGER      NB1, NB2
       INTEGER      NC1
       INTEGER      MA, MB
       REAL         DET
       REAL         S, SS, S1, S2
       REAL         X, Y
       REAL         XM, YM
       REAL         XX, YY
       REAL         XAX, YAY
       INTEGER      IX, IY
       INTEGER      NX, NY
       INTEGER      NX1, NY1
       INTEGER      NX2, NY2
       INTEGER      IEL 	
       INTEGER      LEN
C        
       INCLUDE      'MID_INCLUDE:ST_DEF.INC'
       COMMON       /VMR/MADRID(1)
       INCLUDE      'MID_INCLUDE:ST_DAT.INC'
       DATA         UNIT/' '/
C
       CALL STSPRO('PAIR')
C  get keywords
       CALL STKRDC('IN_A',1,1,60,IACT,INA,KUN,KNUL,STAT)
       CALL STKRDC('IN_B',1,1,60,IACT,INB,KUN,KNUL,STAT)
       CALL STKRDC('OUT_A',1,1,60,IACT,OUTA,KUN,KNUL,STAT)
       CALL STKRDI('INPUTI',1,4,IACT,CXY,KUN,KNUL,STAT)
       CALL STKRDR('INPUTR',1,4,IACT,SEP,KUN,KNUL,STAT)
       CALL STKRDI('INPUTI',5,1,IACT,SYS,KUN,KNUL,STAT)
C
C  read tables
C
       CALL TBTOPN(INA,F_IO_MODE,TID1,STAT)
       CALL TBTOPN(INB,F_IO_MODE,TID2,STAT)
       CALL TBIGET(TID1,NCA,MA,NSC,ACOL,AROW,STAT)
       CALL TBIGET(TID2,NCB,MB,NSC,ACOL,AROW,STAT)
       NC=NCA+NCB
       IF(NC.GT.256) THEN
         CALL STTPUT(' SUM OF COLUMNS > 256',STAT)
         GOTO 999
       ENDIF
       IF(MA.GT.50000.OR.MB.GT.50000) THEN
         CALL STTPUT(' NO OF ROWS > 50000',STAT)
         GOTO 999
       ENDIF
       J=0
       DO I=1,MA
         CALL TBRRDR(TID1,I,2,CXY,ROW,NULL,STAT)
         IF(.NOT.NULL(1).AND..NOT.NULL(2)) THEN
           J=J+1
           JA(J)=I
           XA(J)=ROW(1)
           YA(J)=ROW(2)
         ENDIF
       ENDDO
       MA=J
       J=0
       DO I=1,MB
         CALL TBRRDR(TID2,I,2,CXY(3),ROW,NULL,STAT)
         IF(.NOT.NULL(1).AND..NOT.NULL(2)) THEN
           J=J+1
           JB(J)=I
           XB(J)=ROW(1)
           YB(J)=ROW(2)
         ENDIF
       ENDDO
       MB=J
C+
C
C  estimate projection vector B -> A
C  first form histograms of X and Y differences
C
C-
       S=4./SEP(3)
       DO I=1,200
         HX(I)=0
         HY(I)=0
       ENDDO
       DO J=1,MB
         X=(XB(J)-SEP(1))*S-100.
         Y=(YB(J)-SEP(2))*S-100.
         DO I=1,MA
           IX=XA(I)*S-X
           IF(IX.GT.0.AND.IX.LT.201) THEN
              IY=YA(I)*S-Y
              IF(IY.GT.0.AND.IY.LT.201) THEN
                HX(IX)=HX(IX)+1
                HY(IY)=HY(IY)+1
              ENDIF
           ENDIF
         ENDDO
       ENDDO
C
C  then find highest peak
C
       IX=0
       IY=0
       NX=0
       NY=0
       DO I=2,199
         IF(NX.LT.HX(I)) THEN
           NX=HX(I)
           IX=I
         ENDIF
         IF(NY.LT.HY(I)) THEN
           NY=HY(I)
           IY=I
         ENDIF
       ENDDO
       IF(IX.EQ.2.OR.IX.EQ.199.OR.IY.EQ.2.OR.IY.EQ.199) THEN
         CALL STTPUT(
     1 ' PROJECTION VECTOR TOO LARGE - assume another translation',
     2 STAT)
         GOTO 50
       ENDIF
       S=1./S
       X=(IX-99.5)*S-SEP(1)
       Y=(IY-99.5)*S-SEP(2)
       NX1=HX(IX-1)
       NX2=HX(IX+1)
       NY1=HY(IY-1)
       NY2=HY(IY+1)
       NX=NX1+NX+NX2
       NY=NY1+NY+NY2
       IF(NX.EQ.0.OR.NY.EQ.0) THEN
         CALL STTPUT(' HISTOGRAM ILL DEFINED',STAT)
         N=0
         GOTO 50
       ENDIF
       X=X+S*FLOAT(NX2-NX1)/FLOAT(NX)
       Y=Y+S*FLOAT(NY2-NY1)/FLOAT(NY)
C20    WRITE(6,*) ' finds common points - please wait!'
C+
C
C  find common points.
C  save residual vectors in XAB, YAB arrays
C  first find min residual distance
C
C-
       DO J=1,MB
         IB(J)=0
       ENDDO
       SS=SEP(3)**2
       N=0
       DO I=1,MA
         S1=1.E9
         XAX=XA(I)-X
         YAY=YA(I)-Y
         DO J=1,MB
           S2=(XAX-XB(J))**2 + (YAY-YB(J))**2
           IF(S1.GT.S2) THEN
              S1=S2
              JJ=J
           ENDIF
         ENDDO
         IF(S1.GT.SS.OR.IB(JJ).NE.0) GOTO 40
           IB(JJ)=I
           N=N+1
40         CONTINUE
         XAB(I)=XAX-XB(JJ)
         YAB(I)=YAY-YB(JJ)
       ENDDO

50     CALL STTPUT(' Input table 1: '//INA,STAT)
       CALL STTPUT(' Input table 2: '//INB,STAT)
       CALL STTPUT(' Results: ',STAT)
       WRITE(TEXT,200) X,Y,MA,MB,N
200    FORMAT(' Table 1 - Table 2: (', 2F8.3, ')  ', I5,' +',I5,
     2           ' objects =>',I5,' pairs')
       CALL STTPUT(TEXT,STAT)
       IF(N.LT.2) THEN
         CALL STTPUT(' < 2 COMMON OBJECTS!',STAT)
         GOTO 999
       ENDIF
       IF(N.LT.3) THEN
         CALL STTPUT(' < 3 COMMON OBJECTS - NO ROTATION!',STAT)
         GOTO 60
       ENDIF
C
C  solve for rotation and rescaling
C
       CALL LSQ(XA,YA,XAB,IB,MB,A)
       CALL LSQ(XA,YA,YAB,IB,MB,B)
       WRITE(TEXT,204) (A(I),I=1,3)
204    FORMAT(' residual : DX=',E13.5,' +',E11.3,' * X +',E11.3,' * Y')
       CALL STTPUT(TEXT,STAT)
       WRITE(TEXT,205) (B(I),I=1,3)
205    FORMAT(' rotation : DY=',E13.5,' +',E11.3,' * X +',E11.3,' * Y')
       CALL STTPUT(TEXT,STAT)
       CONTINUE
C+
C
C  Find common points 2nd time;
C  first find min residual distance 
C  with X,Y = individual translation after rotation
C
C-
       DO J=1,MB
         IB(J)=0
       ENDDO
       SS=SEP(4)**2
       N=0
       XM=0.
       YM=0.
       XX=X+A(1)
       YY=Y+B(1)
       DO I=1,MA
         S1=1.E9
         X = XX + A(2)*XA(I) + A(3)*YA(I)
         Y = YY + B(2)*XA(I) + B(3)*YA(I)
         XAX = XA(I)-X
         YAY = YA(I)-Y
         XM = XM+X
         YM = YM+Y
         DO J=1,MB
           S2=(XAX-XB(J))**2 + (YAY-YB(J))**2
           IF(S1.GT.S2) THEN
              S1=S2
              JJ=J
           ENDIF
         ENDDO
         IF(S1.GT.SS.OR.IB(JJ).NE.0) GOTO 55
           IB(JJ)=I
           N=N+1
55         CONTINUE
       ENDDO
       X=XM/MA
       Y=YM/MA
       WRITE(TEXT,200) X,Y,MA,MB,N
       CALL STTPUT(TEXT,STAT)
       IF(N.LT.2) THEN
         CALL STTPUT(' < 2 COMMON OBJECTS!',STAT)
         GOTO 999
       ENDIF
C+
C
C  write merged table with common set of columns
C  second set of labels with column nos in characters 14-16;
C  embedded blanks are replaced by underscore (_).
C
C-
60       N=MA+MB
       CALL STTPUT('*** INFO: writing output table - please wait', 
     2             STAT)
       CALL TBTINI(OUTA,0,F_O_MODE,NC,N,TID3,STAT)
       DO I=1,NCA
         CALL TBLGET(TID1,I,LABEL,STAT)
         CALL TBFGET(TID1,I,FMT,LEN,TYPE,STAT)
         J=INDEX(LABEL,' ')
         IF (J.GT.0 .AND. J.LT.16) THEN
            LABEL(J:J+1)='_A'
         ENDIF 
         CALL TBCINI(TID3,TYPE,1,FMT,UNIT,LABEL,IEL,STAT)
       ENDDO
C
       DO I=1,NCB
         CALL TBLGET(TID2,I,LABEL,STAT)
         CALL TBFGET(TID2,I,FMT,LEN,TYPE,STAT)
         J=INDEX(LABEL,' ')
         IF (J.GT.0 .AND. J.LT.16) THEN
            LABEL(J:J+1)='_B'
         ENDIF 
         CALL TBCINI(TID3,TYPE,1,FMT,UNIT,LABEL,IEL,STAT)
       ENDDO
       DO I=1,NC
         COL(I)=I
       ENDDO
       DET=(1.-A(2))*(1.-B(3))-A(3)*B(2)
       NX=NCA+CXY(3)
       NY=NCA+CXY(4)
       NA1=NCA+1
       NA2=NCA+2
       NS=0
       DO J=1,MB
         I=IB(J)
         IF(I.NE.0) THEN
         II=JA(I)
         JA(I)=-II
         JJ=JB(J)
           CALL TBRRDR(TID1,II,NCA,COL,ROW,NULL,STAT)
           CALL TBRRDR(TID2,JJ,NCB,COL,ROW(NA1),NULL(NA1),STAT)
           IF(SYS.EQ.1) THEN
             X=ROW(NX)+XX
             Y=ROW(NY)+YY
             ROW(NX)=(X*(1.-B(3))+Y*A(3))/DET
             ROW(NY)=(Y*(1.-A(2))+X*B(2))/DET
           ENDIF
           NS=NS+1
           NC1=0
           DO L=1,NC
             IF(.NOT.NULL(L)) THEN
              NC1=NC1+1
              COLA(NC1)=L
              ROWA(NC1)=ROW(L)
             ENDIF
           ENDDO
           CALL TBRWRR(TID3,NS,NC1,COLA,ROWA,STAT)
         ENDIF
       ENDDO
       NSA=NS
       DO I=1,MA
         II=JA(I)
         IF(II.GT.0) THEN
           CALL TBRRDR(TID1,II,NCA,COL,ROW,NULL,STAT)
           X=ROW(CXY(1))
           Y=ROW(CXY(2))
           IF(SYS.EQ.1) THEN
             ROW(NA1)=X*(1.-A(2))-Y*A(3)-XX
             ROW(NA2)=Y*(1.-B(3))-X*B(2)-YY
           ELSE
             ROW(NA1)=X
             ROW(NA2)=Y
           ENDIF
           NSA=NSA+1
           NC1=0
           DO L=1,NCA
             IF(.NOT.NULL(L)) THEN
              NC1=NC1+1
              COLA(NC1)=L
              ROWA(NC1)=ROW(L)
             ENDIF
           ENDDO
           NC1=NC1+1
           COLA(NC1)=NX
           ROWA(NC1)=ROW(NA1)
           NC1=NC1+1
           COLA(NC1)=NY
           ROWA(NC1)=ROW(NA2)
           CALL TBRWRR(TID3,NSA,NC1,COLA,ROWA,STAT)
         ENDIF
       ENDDO
       NX=CXY(3)
       NY=CXY(4)
       NB1=NCB+1
       NB2=NCB+2
       NSB=NSA
       DO J=1,MB
         I=IB(J)
         IF(I.EQ.0) THEN
           JJ=JB(J)
           CALL TBRRDR(TID2,JJ,NCB,COL,ROW,NULL,STAT)
           X=ROW(NX)+XX
           Y=ROW(NY)+YY
           ROW(NB1)=(X*(1.-B(3))+Y*A(3))/DET
           ROW(NB2)=(Y*(1.-A(2))+X*B(2))/DET
           IF(SYS.EQ.1) THEN
             ROW(NX)=ROW(NB1)
             ROW(NY)=ROW(NB2)
           ENDIF
           NSB=NSB+1
           NC1=0
           DO L=1,NCB
             IF(.NOT.NULL(L)) THEN
              NC1=NC1+1
              COLA(NC1)=L+NCA
              ROWA(NC1)=ROW(L)
             ENDIF
           ENDDO
           NC1=NC1+1
           COLA(NC1)=CXY(1)
           ROWA(NC1)=ROW(NB1)
           NC1=NC1+1
           COLA(NC1)=CXY(2)
           ROWA(NC1)=ROW(NB2)
           CALL TBRWRR(TID3,NSB,NC1,COLA,ROWA,STAT)
         ENDIF
       ENDDO
       CALL TBTCLO(TID3,STAT)
999    CALL STSEPI
       END
C
       SUBROUTINE LSQ(X,Y,AB,IB,MB,B)
C+++
C  LSQ fit of residuals
C  AB = B1 + B2*X + B3*Y
C  to <= MB points (X,Y)
C----
       IMPLICIT   NONE       
       REAL       X(1)
       REAL       Y(1)
       REAL       AB(1)
       INTEGER    IB(1)
       INTEGER    MB
       REAL       B(1)
C     
       INTEGER    I, J, K, L, N
       INTEGER    N1
C
       DOUBLE PRECISION  A(4,4)
       DOUBLE PRECISION  C(4)
C
       N=3
       N1=N+1
       DO I=1,N1
         DO J=1,N1
           A(I,J)=0.D0
         ENDDO
         B(I)=0.
       ENDDO
       DO K=1,MB
         L=IB(K)
         IF(L.NE.0) THEN
           C(1)=1.
           C(2)=X(L)
           C(3)=Y(L)
           C(4)=AB(L)
           DO I=1,N1
             DO J=1,N1
              A(I,J)=A(I,J)+C(I)*C(J)
             ENDDO
           ENDDO
         ENDIF
       ENDDO
       CALL SIMUL(N,A,B)
       RETURN
       END

C @(#)bgval.for	19.1 (ESO-DMD) 02/25/03 14:01:03
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE BGVAL(MODE,AIMG,NP,NL,IAREA,ITER,IMIN,LEAP,BGVLS,RMNS,
     +                 NPON,ISTOP,ILAST)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION         
C subroutine BGVAL		version 2.00	880630
C K. Banse (cleaned version of H. Waldthausen)
C
C.KEYWORDS     
C kap*sig  clipping
C
C.PURPOSE
C
C  this routine computes a constant background value (bgval) of
C  rows or subimages
C
C.ALGORITHM     
C  iterarate on bgval using a kap*sig clipping
C
C.INPUT/OUTPUT   parameters
C
C	Using mode 0 or -1 the routine can quickly select the most probable 
C	bgvals of an image if LEAP is set.  
C
C	-> MODE   operation mode
C		  :0 background of rows
C		  :1 background of an area
C	-> AIMG   input image 
C	-> NP     x-pixels and
C	-> NL     y-pixels of AIMG
C	-> IAREA  pixel indices of selected image area :
C                 x-start,x-end,y-start,y-end
C	-> ITER   number of iterations
C	-> IMIN   minimum number of points to derive bgval
C	-> ISTOP  resticts  execution of BGVAL to ISTOP   
C	          consistent and consecutive background scanlines.
C		  if neg. or 0 bgval is calculated for all rows.	
C	-> LEAP   number of rows to jump when  the present
C		  row-bgval exeeds the last min-bgval+3*sig threshold.
C		  this will happen if a row has to many/extended sources. 
C   		  if neg. or 0 no jumping;if ISTOP neg no jumping. 	
C		  ouput MODE = 0		  
C	<- BGVLS  background values of rows
C	          : -99. if outside IAREA or 
C		   iteration deleted all points (idap).
C	<- RMNS   standard deviation of bgval points 
C	          : -1. if outside IAREA or idap.
C	<- NPON   number of bgval points found
C		  : -1  if outside IAREA or idap.  
C	<- ILAST  column index of last computed bgval.
C
C		  output MODE = 1
C	<-BGVLS(1) background value of  area : -99. if idap
C	<-RMNS(1) standard deviation of bgval points : -1 if idap
C	<-NPON(1) number of bgval points found : -1 if idap
C	<- ILAST  number of iterations used	 
C
C-------------------------------------------------------------------------
C
      IMPLICIT NONE
C 
      INTEGER  MODE,NP,NL,IAREA(4),ITER,IMIN,LEAP,NPON(*),ISTOP,ILAST
      INTEGER  IXA,IXE,IYA,IYE
      INTEGER  K,KL,JUMP,ISTOR,NPA,J,I
      INTEGER  IX,IY,NPP,NPC,IXP,IYP
C 
      REAL     BGVLS(*),RMNS(*),AIMG(NP,NL)
      REAL     SM,DUMMY,SMIN,HCUT,AKAP
      REAL     SMEAN,S,SQ,V,AP,DEL,DELS,DELA,DELV,ARG,RM,BG
      REAL     SMSQ,RMS,CLIP
C      
C.. initialize
C 
      IXA = IAREA(1)
      IXE = IAREA(2)
      IYA = IAREA(3)
      IYE = IAREA(4)
      ILAST = 0
      JUMP = 0
      ISTOR = 0
      SM = 0.
      DUMMY = 1.0E37
      SMIN = DUMMY
      HCUT = DUMMY
      IF (ISTOP.EQ.0) ISTOP = -1
      IF (LEAP.LT.0) LEAP = 0
      KL = 1
      IF (MODE.EQ.0) KL = NL
      IF (MODE.EQ.-1) KL = NP
C 
      DO 20, K=1,KL
         BGVLS(K) = -99.
         RMNS(K) = -1.
         NPON(K) = -1
20    CONTINUE
C 
      IF (MODE.EQ.0) GOTO 2000
      IF (MODE.EQ.1) GOTO 4000
C
C***      MODE = -1 compute background levels and  rms of columns
C 
      DO 1000, IX=IXA,IXE
         IF (ISTOR.EQ.ISTOP) RETURN
C 
         ILAST = ILAST + 1
         IF (SM.GT.HCUT) THEN
            IF ( (JUMP.EQ.LEAP) .OR. (ISTOP.LT.0) ) GOTO 50
            JUMP = JUMP + 1
            GOTO 1000
         ENDIF
C 
50       ISTOR = ISTOR + 1
         JUMP = 0
         SMEAN = 0.
         AKAP = 1.E37
         NPA = 0
C
C..  iterate
         DO 500, J=1,ITER
            S = 0.
            SQ = 0.
            NPP = 0
            DO 200, IY=IYA,IYE
               V = AIMG(IX,IY)
               IF (ABS(V-SMEAN) .LE. AKAP) THEN
                  NPP = NPP + 1
                  S = S + V
                  SQ = SQ + V*V
               ENDIF
200         CONTINUE
C
            IF (NPP.GT.IMIN) THEN
               AP = FLOAT(NPP)
               SMEAN = S/AP
               DEL = (SQ/AP) - (SMEAN*SMEAN)
               ARG = MAX(1.E-37,DEL)
               RM = SQRT(ARG)
               BG = SMEAN
               AKAP = RM + RM
               IF (NPA.EQ.NPP) GOTO 600
               NPA = NPP
            ELSE
               NPON(IX) = NPP
               AP = 0.
               ISTOR = 0
               GOTO 1000
            ENDIF
500      CONTINUE
C
600      SM = SMEAN
         BGVLS(IX) = BG
         RMNS(IX)  = RM
         NPON(IX)  = NPP
         IF (SM.LT.SMIN) THEN
            ISTOR = 0
            SMIN = SM
            HCUT = SMIN + (3.*RM)
         ENDIF
1000  CONTINUE
      RETURN
C
C***      MODE = 0 compute background levels and  rms of rows
C 
2000  DO 3000, IY=IYA,IYE
         IF (ISTOR.EQ.ISTOP) RETURN
         ILAST = ILAST + 1
         IF (SM.GT.HCUT) THEN
            IF ( (JUMP.EQ.LEAP) .OR. (ISTOP.LT.0) ) GOTO 2100
            JUMP = JUMP + 1
            GOTO 3000
         ENDIF
C 
2100     ISTOR = ISTOR + 1
         JUMP = 0
         SMEAN = 0.
         AKAP = 1.E37
         NPA = 0
C
C.. iterate
C 
         DO 2600, J=1,ITER
            S = 0.
            SQ = 0.
            NPP = 0
            DO 2300, IX=IXA,IXE
               V = AIMG(IX,IY)
               IF (ABS(V-SMEAN) .LE. AKAP) THEN
                  NPP = NPP + 1
                  S = S + V
                  SQ = SQ + V*V
               ENDIF
2300        CONTINUE
C
            IF (NPP.GT.IMIN) THEN
               AP = FLOAT(NPP)
               SMEAN = S/AP
               DEL = (SQ/AP) - (SMEAN*SMEAN)
               ARG = MAX(1.E-37,DEL)
               RM = SQRT(ARG)
               BG = SMEAN
               AKAP = RM + RM
               IF (NPA.EQ.NPP) GOTO 2900
               NPA = NPP
            ELSE
               NPON(IY) = NPP
               AP = 0.
               ISTOR = 0
               GOTO 3000
            ENDIF
2600     CONTINUE
C
2900     SM = SMEAN
         BGVLS(IY) = BG
         RMNS(IY)  = RM
         NPON(IY)  = NPP
         IF (SM.LT.SMIN) THEN
            ISTOR = 0
            SMIN = SM
            HCUT = SMIN + (3.*RM)
         ENDIF
3000  CONTINUE
      RETURN
C
C***      MODE = 1  background value of an area
C
C.. get initial smean 
C 
4000  SMEAN = 0.
      DO 4100, IY=IYA,IYE
         DO 4040 IX=IXA,IXE
            SMEAN = SMEAN + AIMG(IX,IY)
4040     CONTINUE
4100  CONTINUE
C 
      IXP = IXE - IXA + 1
      IYP = IYE - IYA + 1
      NPC = IXP*IYP
      SMEAN = SMEAN/FLOAT(NPC)
C
C.. get initial rms
      DELS = 0.
      SMSQ = SMEAN*SMEAN 
C 
      DO 4300, IY=IYA,IYE
         DO 4200, IX=IXA,IXE
            V = AIMG(IX,IY)
            DELV = V*V + SMSQ - 2.*V*SMEAN
            IF (DELV.LT.0.) DELV = 0.
            DELS = DELS + DELV
4200     CONTINUE
4300  CONTINUE
C
      IF (NPC.NE.1) THEN
         DELA = DELS/FLOAT(NPC-1)
         RMS = SQRT(DELA)
         AKAP = 2.0
         CLIP = AKAP*RMS
      ELSE
         BGVLS(1) = SMEAN
         RMNS(1) = -1.0
         NPON(1) = NPC
         RETURN
      ENDIF
C
C.. exit if no iter
      BGVLS(1) = SMEAN
      RMNS(1) = RMS
      NPON(1) = NPC
      IF (ITER.LE.0) RETURN
C
C..  iterate
C 
      NPA = NPC
      DO 5000, I=1,ITER
         S = 0.
         NPP = 0
         DELS = 0.
         SMSQ = SMEAN*SMEAN
         DO 4600, IY=IYA,IYE
            DO 4500, IX=IXA,IXE
               V = AIMG(IX,IY)
               IF ( ABS(V-SMEAN) .LT. CLIP ) THEN
                  NPP = NPP + 1
                  S = S + V
                  DELV = (V*V) + SMSQ - (2.*SMEAN*V)
                  IF (DELV.LT.0.) DELV = 0.
                  DELS = DELS + DELV
               ENDIF
4500        CONTINUE
4600     CONTINUE
C
C..      calculate new CLIP
C 
         IF (NPP.GT.IMIN) THEN
            IF (NPA.EQ.NPP) GOTO 6500
            NPA = NPP
            DELA = DELS/FLOAT(NPP-1)
            RMS = SQRT(DELA)
            SMEAN = S/FLOAT(NPP)
            CLIP = AKAP*RMS
         ELSE
            NPON(1) =  NPA
            RMNS(1) = -1.
            BGVLS(1) = SMEAN
            RETURN
         ENDIF
5000  CONTINUE
C
C..      store results
6500  ILAST = I
      IF (ILAST.GT.ITER) ILAST = ITER 
      BGVLS(1) = SMEAN
      RMNS(1) = RMS
      NPON(1) = NPA
C
      RETURN
      END

      SUBROUTINE LINFOL(A,NDIM,START,STEP,TAB)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine LINFOL version 3.30	850729
C  K. Banse      			ESO - Garching
C
C.KEYWORDS
C
C.PURPOSE
C
C.ALGORITHM
C
C.INPUT/OUTPUT
C  call as LINFOL(A,NDIM,START,STEP,TAB)
C
C.VERSIONS
C
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      NDIM
      INTEGER      N,NEXT,NROW,NCOL,NMAL
      INTEGER      STAT
      INTEGER      TID,TBCLNM(2)
      INTEGER      TABNUL(2)
C
      CHARACTER*(*)   TAB
      CHARACTER      CBUF*80
      CHARACTER      TLABL(2)*16
C
      DOUBLE PRECISION STEP,START
      DOUBLE PRECISION RM,XA,XB,YA,YB,XD,XN
C 
      REAL         A(NDIM)
      REAL         RBUF(2)
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C 
      DATA    TLABL     /'X ','Y '/
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C 
C  init
      XN = START
      NEXT = 1
C
C  table 
      CALL TBTOPN(TAB,'I ',TID,STAT)
      CALL TBIGET(TID,NCOL,NROW,N,N,N,STAT)         !get no. of rows + columns
      IF (NROW.LE.1) THEN
         CALL STTPUT('Not enough rows in table...',STAT)
         GOTO 8000
      ENDIF
      CALL TBLSER(TID,TLABL(1),TBCLNM(1),STAT)
      IF (TBCLNM(1).LE.0) THEN
         CBUF(1:) = 'column :'//TLABL(1)//'is missing ... '
         CALL STTPUT(CBUF,STAT)
         GOTO 8000
      ENDIF
      CALL TBLSER(TID,TLABL(2),TBCLNM(2),STAT)
      IF (TBCLNM(2).LE.0) THEN
         CBUF(1:) = 'column :'//TLABL(2)//'is missing ... '
         CALL STTPUT(CBUF,STAT)
         GOTO 8000
      ENDIF
C
C  get first row of values
      NMAL = 1
      CALL TBRGET(TID,'R*4 ',NMAL,2,TBCLNM,RBUF,TABNUL,STAT)
      XA = RBUF(1)
      YA = RBUF(2)
C 
500   A(NEXT) = YA
      NEXT = NEXT + 1
      IF (NEXT.GT.NDIM) GOTO 7000            !already all points filled up
C 
      XN = XN + STEP
      IF (XN.LE.XA) GOTO 500                 !set all pixels before XA to YA
C
C  get next row of values
1000  NMAL = NMAL + 1
      IF (NMAL.GT.NROW) GOTO 5000
C 
      CALL TBRGET(TID,'R*4 ',NMAL,2,TBCLNM,RBUF,TABNUL,STAT)
      XB = RBUF(1)
      YB = RBUF(2)
      XD = XB - XA
      IF (XB.LT.XN) THEN                     !we need XA < XN < XB
         IF (XD.LT.1.D-30) THEN              
            WRITE(*,10001) NMAL              !should be XB > XA
         ELSE
            XA = XB
            YA = YB
         ENDIF
         GOTO 1000                           !omit that pair X,Y
      ENDIF
      RM = (YB - YA) / XD
C 
C  here we loop and fill the data
1500  A(NEXT) = SNGL(RM*(XN - XA) + YA)
      NEXT = NEXT + 1
      IF (NEXT.GT.NDIM) GOTO 7000            !already all points filled up
C 
      XN = XN + STEP
      IF (XN.LE.XB) GOTO 1500
C
C  move to next pair
      XA = XB
      YA = YB
      GOTO 1000
C 
C  here, if table processed
5000  IF (NEXT.LT.NDIM) THEN                 !missing values set to last one
         DO 5500, N=NEXT,NDIM
            A(N) = A(NEXT-1)
5500     CONTINUE
      ENDIF
C 
C  that's it folks
7000  CALL TBTCLO(TID,STAT)
      RETURN
C 
C  Problems with table
8000  DO 8080, N=1,NDIM
         A(N) = 0.0
8080  CONTINUE
      RETURN
C 
10001 FORMAT('invalid x,y value in row ',I4)
      END

C @(#)necripcor.for	19.1 (ESO-DMD) 02/25/03 14:20:25
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C 
C.COPYRIGHT: Copyright (c) 1991 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0          23-JULY-1991
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: P.BALLESTER
C
C.IDENTIFICATION
C
C.KEYWORDS
C
C  ECHELLE, CASPEC, BLAZE FUNCTION
C
C.PURPOSE
C
C  compute the ECHELLE constants to set successive orders at the same level
C
C.ALGORITHM
C
C  IN DEVELOPMENT ...
C
C.VERSION
C 
C 010706		last modif
C C 
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      PROGRAM RIPPLE

      IMPLICIT  NONE

      INTEGER   NAXISA,NPIXA(2),IAV,STAT,ACTVAL,MAXORD
      INTEGER   IMNOA
      INTEGER   KNULL,KUNIT(1),BOUND(3)
      INTEGER   MADRID(1)
C 
      INTEGER*8   PNTRA
C
      PARAMETER (MAXORD=500)
C
      CHARACTER FRAMEA*60
      CHARACTER CUNIT*64,IDENTA*72
C
      INTEGER          NPTOT(MAXORD)
      INTEGER          ORDSTA(MAXORD),ORDEND(MAXORD)
C 
      REAL             CONST(MAXORD)
C 
      DOUBLE PRECISION STEPA(2),STARTA(2),WSTART(MAXORD)
C 
      INCLUDE 'MID_INCLUDE:st_def.inc'
      COMMON /VMR/ MADRID
      INCLUDE 'MID_INCLUDE:st_dat.inc'
C
      CALL STSPRO('RIPPLE')
      CALL STKRDC('IN_A',1,1,60,IAV,FRAMEA,KUNIT,KNULL,STAT)

      CALL STIGET(FRAMEA,D_R4_FORMAT,F_IO_MODE,F_IMA_TYPE,
     +            2,NAXISA,NPIXA,STARTA,STEPA,IDENTA,CUNIT,
     +            PNTRA,IMNOA,STAT)

      IF (NPIXA(2).LT.MAXORD) THEN
          CALL STDRDD(IMNOA,'WSTART',1,NPIXA(2),ACTVAL,WSTART,
     +                                       KUNIT,KNULL,STAT)
          CALL STDRDI(IMNOA,'NPTOT',1,NPIXA(2),ACTVAL,NPTOT,
     +                                       KUNIT,KNULL,STAT)
          CALL STDRDI(IMNOA,'ORDSTA',1,NPIXA(2),ACTVAL,ORDSTA,
     +                                       KUNIT,KNULL,STAT)
          CALL STDRDI(IMNOA,'ORDEND',1,NPIXA(2),ACTVAL,ORDEND,
     +                                       KUNIT,KNULL,STAT)
      ELSE
          CALL STETER(10,'Buffer overflow in RIPPLE.')
      ENDIF

      CALL STKRDI('INPUTI',1,3,IAV,BOUND,KUNIT,KNULL,STAT)

      CALL NORM(MADRID(PNTRA),NPIXA(1),NPIXA(2),STARTA(1),STEPA(1),
     +            WSTART,BOUND,CONST,ORDSTA,ORDEND)

      CALL STSEPI

      END

C ======================Normalization Routine====================

      SUBROUTINE NORM(INPFRAM,NX,NY,START,STEP,
     +                WST,BOUND,CONST,ORDSTA,ORDEND)

      IMPLICIT   NONE

      INTEGER    NX,NY,BOUND(3),ROW,COL
      INTEGER    PIXSTA,PIXEND,NPIX,MIDORD
      INTEGER    ORDSTA(NY),ORDEND(NY)

      REAL       INPFRAM(NX,NY)

      REAL       SN,SN1,CONST(NY),FACTOR

      DOUBLE PRECISION  WST(NY),START,STEP,LAMBST,LAMBED


C --- LOOP ON ORDERS

      DO 10 ROW = 1,(NY-1)


C ---    Determine lambda start, lambda end and pixel width in overlap.

         PIXSTA = ORDSTA(ROW+1) + BOUND(1) + 1
         LAMBST = WST(ROW+1)+(PIXSTA-1)*STEP      !  Lambda Start

         PIXEND = ORDEND(ROW) - BOUND(2)
         LAMBED = WST(ROW)+(PIXEND-1)*STEP        !  Lambda End

         NPIX   = (LAMBED-LAMBST)/STEP ! Assume linear step in wavelength
C         TYPE*,'Order, nb pix., delta wav.',ROW,NPIX,LAMBST,LAMBED

C ---    Estimate normalization constant.

         SN  = 0.
         SN1 = 0.

         DO 40 COL = PIXEND , PIXEND-NPIX, -1
               SN = SN + INPFRAM(COL,ROW)
40       CONTINUE

         DO 50 COL = PIXSTA, PIXSTA+NPIX
               SN1 = SN1 + INPFRAM(COL,ROW+1)
50       CONTINUE

         CONST(ROW) = SN1/SN

10    CONTINUE


C --- Constant for the central order is set to 1. and the frames 
C --- are normalized.

      CONST(NY) = 1.0

      DO 90 ROW = NY-1,1,-1

         CONST(ROW) = CONST(ROW)*CONST(ROW+1)

90    CONTINUE

      MIDORD = NY/2
      FACTOR = CONST(MIDORD)

      DO 60 ROW = 1,NY

         CONST(ROW) = CONST(ROW)/FACTOR
C         TYPE*,'Order,const.',ROW,CONST(ROW)

60    CONTINUE

      DO 70  ROW = 1,NY

         PIXSTA = ORDSTA(ROW) + BOUND(1) + 1
         PIXEND = ORDEND(ROW) - BOUND(2)

         DO 75  COL = 1 , PIXSTA-1

             INPFRAM(COL,ROW) = 0.

75       CONTINUE

         DO 80  COL = PIXSTA,PIXEND

             INPFRAM(COL,ROW) = INPFRAM(COL,ROW) * CONST(ROW)

80       CONTINUE

         DO 85 COL = PIXEND+1,NX

             INPFRAM(COL,ROW) = 0.

85       CONTINUE

70    CONTINUE

      RETURN
      END

C @(#)partit.for	19.1 (ES0-DMD) 02/25/03 13:28:47
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C  @(#)partit.for	19.1  (ESO-IPG)  02/25/03  13:28:47
      SUBROUTINE PARTIT(A,N,X,NBLOKS,MBLOK,*)
C
C       Copyright (C) Andrew T. Young, 1990, 1991
C
C
C  Inverts compact sym.pos.def.matrix  A (N X N) by partitioning.
C  See Frazer, Duncan & Collar "Elementary Matrices" p.113
C
C  Assume upper left  NP = (NBLOKS * MBLOK) is block-diagonal,
C  with  (NBLOKS)  blocks, each  (MBLOK X MBLOK).
C
C  :     U        V     : -1      :  -1       -1            -1 :
C  :  (P X P)  (P X Q)  :         : U   + X TH  Y     - X TH   :
C  :                    :    =    :                            :
C  :      T             :         :       -1             -1    :
C  :     V        W     :         :   - TH  Y          TH      :
C  :  (Q X P)  (Q X Q)  :         :                            :
C
C  WHERE      -1            T -1       T
C        X = U  V ,    Y = V U   ,   (X  = Y)
C
C                                    T T
C       TH = W - YV = W - S,    S = V Y
C
C                -1      T   -1
C        P = X(TH  Y) = Y (TH  Y)
C
C
c     IMPLICIT NONE
      IMPLICIT INTEGER(I-N)
C
      DOUBLE PRECISION A,X
      INTEGER N,NBLOKS,MBLOK
C
      DIMENSION A(N*(N+1)/2), X(N)
      CHARACTER*60 CARD
C
C   X IS SCRATCH VECTOR.
C
      INTEGER M1
      COMMON/ROWS/ M1
C
      INTEGER NP,NPP1,LVTZ,NROW, J, KR,
     1    NBLOK, MAXK, LRZ, LWR, KROW, K, NRUZ, KOL, LY, NROWU, LYZ, LW 
C
C
      NP=NBLOKS*MBLOK
      NPP1=NP+1
      LVTZ=NP*(NPP1)/2
C
C  COMPUTE U-1, Y, AND THETA.
C
      NROW=1
      DO 20 NBLOK=1,NBLOKS
C   INVERT BLOCK.
      CALL BLKINV(A,MBLOK,NROW,X,*999)
      IF(NP.EQ.N) GO TO 20
C   M1, NROWZ NOW SET FOR THIS BLOCK.
C
C  COMPUTE VT(U-1).
C
C  METHOD:
C   SAVE COLS.(NROW-MAXK) OF VT IN X.  CLEAR SPACE IN VT.
C   COL. KOL OF THIS ROW OF VT(U-1) IS DOT PRODUCT
C   OF THIS ROW (SAVED IN X) WITH COL. KOL OF (U-1),
C   WHICH IS BENT BY TRIANGULAR STORAGE.  1ST PART
C   OF THIS COL. IS IN ROW (KOL-NROW) OF A.
C
      MAXK=NROW+MBLOK-1
      LRZ=LVTZ
      LWR=LVTZ+NPP1
      DO 10 KROW=NPP1,N
C
C   SAVE PART OF NEXT ROW OF VT (KROW OF A) IN X.
      DO 2 K=NROW,MAXK
      X(K)=A(LRZ+K)
    2 A(LRZ+K)=0.
C
      NRUZ=M1-NROW
      DO 7 KOL=NROW,MAXK
      LY=LRZ+KOL
C   COMPUTE 1ST PART OF (KROW,KOL) ELEMENT OF (VT.U-1) VIA ROW OF (U-1).
      DO 4 K=NROW,KOL
    4 A(LY)=A(LY) +  X(K) * A(NRUZ+K)
C   2ND PART OF ROW.  USE COL.OF (U-1).
      NROWU=NRUZ+KOL
      DO 5 K=KOL+1,MAXK
      A(LY)=A(LY) +  X(K) * A(NROWU+KOL)
C     Y(KROW,KOL)   VT(KROW,K)*(U-1)(K,KOL)
    5 NROWU=NROWU+K
    7 NRUZ=NRUZ+KOL
C
C  NOW GET S = (VT)(YT).
C
C   WE STILL HAVE COLS.NCOL TO MAXK OF VT IN X.
C   DOT IT INTO ROW J OF Y TO GET SOME OF S(KROW,J).
C   N.B.:  J .LE. KROW.    EACH BLOCK ADDS TO ALL OF W.
      LYZ=LVTZ
      LW=LWR
      DO 9 J=NPP1,KROW
C   LOOP OVER J = ROWS OF Y = COLS.OF S.
      DO 8 KOL=NROW,MAXK
    8 A(LW)=A(LW)-X(KOL)*A(LYZ+KOL)
C     THETA = W  - (VT) * (YT)
      LYZ=LYZ+J
    9 LW=LW+1
      LWR=LWR+KROW
   10 LRZ=LRZ+KROW
C    THIS ENDS BLOCK NBLOK.
   20 NROW=NROW+MBLOK
      IF(NP.EQ.N) RETURN
C
C   WE NOW HAVE Y AND THETA.  INVERT THETA.
C
      CALL BLKINV(A,N-NP,NPP1,X,*998)
      IF(NP.EQ.0) RETURN
C
C  COMPUTE -(THETA-1)*Y AND P.
C
C   DO COLUMNS.
      DO 30 KOL=1,NP
C   SAVE COL. KOL OF Y IN X.
      LRZ=LVTZ
      DO 21 KR=NPP1,N
      X(KR)=A(LRZ+KOL)
      A(LRZ+KOL)=0.
   21 LRZ=LRZ+KR
C
C   COMPUTE COL.OF (THETA-1)*Y.
      LRZ=LVTZ
      DO 25 KROW=NPP1,N
C   (KROW,KOL) ELEMENT.
      LY=LRZ+KOL
C   1ST PART.
      DO 22 KR=NPP1,KROW
   22 A(LY)=A(LY) - X(KR)*A(LRZ+KR)
C      P(KR,KOL)      Y * (THETA-1)
      LWR=LRZ+KROW+KROW
C   2ND PART.
      DO 23 KR=KROW+1,N
      A(LY)=A(LY) - X(KR)*A(LWR)
C      P(KR,KOL)      Y * (THETA-1)
   23 LWR=LWR+KR
   25 LRZ=LRZ+KROW
C  - (THETA-1)*Y NOW DONE.
C
C  COMPUTE -P = (YT)*((THETA-1)*Y) AND SUBTRACT FROM (U-1).
C
C   X-ARRAY STILL HAS KOL OF Y.  DOT INTO COL.KOL OF -(THETA-1)*Y
C   TO GET -P(KOL,KOL).  USE COL.K (.GT.KOL) OF Y TO GET ROW K OF -P.
C
      LY=KOL*(KOL+1)/2
      LRZ=LVTZ
      DO 27 J=NPP1,N
      A(LY)=A(LY) - X(J)*A(LRZ+KOL)
   27 LRZ=LRZ+J
      LY=LY+KOL
      DO 29 K=KOL+1,NP
      LRZ=LVTZ
      DO 28 J=NPP1,N
      A(LY)=A(LY) - A(LRZ+K)*A(LRZ+KOL)
C    (U-1)(K,KOL)    Y(J,K) * -(THETA-1)*Y (J,KOL)
   28 LRZ=LRZ+J
   29 LY=LY+K
   30 CONTINUE
      RETURN
C
  998 CALL TV('Final block singular:')
      NBLOK=NBLOKS+1
  999 WRITE(CARD,'(A,I3,A,I3,A)')
     1   'PARTIT failed for nblok = ',NBLOK,' of ',NP,' parameters'
      CALL TV(CARD)
      RETURN 1
      END
      SUBROUTINE BLKINV(A,N,NROW1,X,*)
C
C  Alg.9 of Nash, to invert a triang.pos.def.sym.matrix in situ, p.84.
C  modified to invert submatrix of size N starting in row  NROW1.
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION A,X
      INTEGER N, NROW1
C
      DIMENSION A((N+NROW1)*(N+NROW1-1)/2), X(N)
C
C   X IS SCRATCH SPACE.
C
      INTEGER M1
      COMMON/ROWS/ M1
C
      DOUBLE PRECISION S,T
      INTEGER NROWZ, K, M, I, LQ, LP, J
C
C
      M1=NROW1*(NROW1+1)/2
      NROWZ=NROW1-1
      DO 12 K=N,1,-1
      S=A(M1)
      IF(S.LE.0.) RETURN 1
      M=M1
      DO 9 I=2,N
      LQ=M+NROWZ
      M=LQ+I
C   M IS END OF ROW I; LQ IS JUST BEFORE ROW I.
      T=A(LQ+1)
      X(I)=-T/S
      IF(I.GT.K) X(I)=-X(I)
      LP=NROWZ+I
      DO 8 J=LQ+2,M
    8 A(J-LP)=A(J)+T*X(J-LQ)
    9 CONTINUE
      LQ=LQ-1
      A(M)=1./S
      DO 11 I=2,N
   11 A(LQ+I)=X(I)
   12 CONTINUE
      RETURN
      END

C @(#)ftdfun.for	19.1 (ES0-DMD) 02/25/03 13:17:33
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FTDFUN(ISEQ,FSPEC,ISTAT)                                       
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                   
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:25 - 13 JAN 1988                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C.IDENTIFICATION                                                                
C                                                                               
C  FITLIB.FOR   VERSION 1.0  27 MAR 1984                                        
C                                                                               
C.PURPOSE                                                                       
C                                                                               
C  INTERFACE ROUTINES FOR THE FITTING STRUCTURES                                
C DEFINE FUNCTION TO BE FITTED                                                  
C                                                                               
C.ALGORITHM                                                                     
C                                                                               
C  USE MIDAS I/O INTERFACES TO FRAMES AND TABLES                                
C                                                                               
C.KEYWORDS                                                                      
C                                                                               
C  NON LINEAR FITTING                                                           
C                                                                               
C                                                                               
C----------------------------------------------------------------               
C                                                                               
C      IMPLICIT NONE                                                            
C                                                                               
C INPUT PARAMETERS                                                              
C ISEQ INTG SEQUENCE NUMBER OF THE FUNCTION                                     
C FSPEC CHAR FUNCTION SPECIFICATION                                             
C                                                                               
C OUTPUT PARAMETERS                                                             
C ISTAT INTG STATUS RETURN                                                      
C                                                                               
      INTEGER I,II,II1,ISTAT,ISEQ
      CHARACTER*(*) FSPEC                                                       
      CHARACTER*80  UPFUN,MESS
       INCLUDE 'MID_INCLUDE:FITI.INC/NOLIST'                                     
       INCLUDE 'MID_INCLUDE:FITC.INC/NOLIST'                                     
C                                                                               
C CHECK FUNCTION                                                                
C                                                                               

      UPFUN = FSPEC
      CALL FORUPC(UPFUN,UPFUN)
      II     = INDEX(FSPEC,'(') - 1                                             
      IF (II.LE.0) GO TO 20                                                     
      DO 10 I = 1,FZDEFMAX                                                    
          IF (UPFUN(1:II).EQ.FZFNAM(I) (1:II)) GO TO 30                       
   10 CONTINUE                                                                  
      MESS = 'Wrong Function: '//UPFUN(1:II)
      CALL STTPUT(MESS,ISTAT)
   20 ISTAT  = FERFUN                                                       
      RETURN                                                                    
   30 CONTINUE                                                                  
      II1    = INDEX(FSPEC,')') - 1                                             
C                                                                               
C PRODUCE INTERMEDIATE TABLE WITH PARAMETER NAMES                               
C     
                                                                          
     
      CALL FTPARS(FSPEC(II+2:II1),FZNIND,FZACTPAR(ISEQ),ISTAT)              
      IF (ISTAT.NE.0) RETURN                                                    
C                                                                               
C CHECK NUMBER OF PARAMTERS                                                     
C                                                                               
      IF (FZACTPAR(ISEQ).NE.FZFPAR(I) .AND. FZFPAR(I).NE.0) THEN          
          ISTAT  = FERPFU                                                   
          RETURN                                                                
      END IF                                                                    
      FZNPTOT = FZNPTOT + FZACTPAR(ISEQ)                                  
      FZFCODE(ISEQ) = I                                                       
      FZSPEC(ISEQ) = FSPEC                                                    
      FZNFUN = MAX(ISEQ,FZNFUN)                                             
      RETURN                                                                    
      END                                                                       

C @(#)rfotdiaphr.for	19.1 (ES0-DMD) 02/25/03 13:30:14
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM DIAFRA    
C+++
C.IDENTIFICATION: RFOTDIAPHR
C.PURPOSE: Do aperture photometry at positions read from a registration table
C.AUTHOR:  R. Buonanno, G. Buscema, C. Corsi, I. Ferraro, G. Iannicola
C          Osservatorio Astronomico di Roma, and
C.         R.H. Warmels, ESO-IPG
C.VERSION: 881116 RB   First installation in MIDAS
C.VERSION: 890918 RHW  Rewritten for MIDAS tables
C.VERSION: 891222 RHW  Input obtained from registration table 
C----
      IMPLICIT       NONE
      INCLUDE        'MID_REL_INCL:RFOTDECL.INC'
C
      INTEGER        NCPAR
      PARAMETER      (NCPAR=12)
C ***
      INTEGER        NAXIS,NPIX(2)
      INTEGER        ICPAR(NCPAR)
      INTEGER        MADRID(1)
      INTEGER        IDNT
      INTEGER*8      IPNTR
      INTEGER        IMF
      INTEGER        TIDOUT
      INTEGER        KUN,KNUL
      INTEGER        NRREG,NCREG,NACREG,NARREG,NSREG
      INTEGER        OUTTYP
      INTEGER        TIDREG
      INTEGER        TINULL
      INTEGER        ICIDN
      INTEGER        IAV, ISTAT
      INTEGER        EC, ED, EL
      INTEGER        NPL, NL
      INTEGER        NCOUT, NROUT
      INTEGER        OUTCOL
      INTEGER        IC, IR, IROW
      INTEGER        IX, IY, IX0, IY0
      INTEGER        LF, LD, I1, I2, I1O
C
      DOUBLE PRECISION BEGIN(2),STEP(2)
      DOUBLE PRECISION TDNULL,TDTRUE,TDFALS
C
      REAL           TAB(NCPAR)
      REAL           RV(5000)
      REAL           TRNULL, TBLSEL
      REAL           FON, AP, S, DS 
C
      CHARACTER*60   FRAME
      CHARACTER*72   IDENT,CUNIT
      CHARACTER*60   REGFIL
      CHARACTER*60   OUTFIL
      CHARACTER*80   STRING
      CHARACTER*16   LABEL(NCPAR),OUTLAB
      CHARACTER*16   UNIT(NCPAR),OUTUNI
      CHARACTER*16   OUTFOR
      CHARACTER*16   FORMR4,FORMI4
C
      LOGICAL        LOG, NUL(NCPAR)
      LOGICAL        SFLAG
C
      INCLUDE        'MID_INCLUDE:TABLES.INC'
      COMMON         /VMR/MADRID
      INCLUDE        'MID_INCLUDE:TABLED.INC'
C ***
      DATA           ICIDN/1/
      DATA           FORMI4/'I6'/
      DATA           FORMR4/'E12.4'/
      DATA     LABEL /'X      ', 'Y      ', 'INT        ', 'LOC_BGD ', 
     2                'MAG1   ', 'MAG2   ', 'MAG3       ', 'MAG_CNV ', 
     3                'SIGMA  ', 'BETA   ', 'SIQ        ', 'CHI_SQ  '/
      DATA     UNIT / 'PIXEL  ', 'PIXEL  ', '           ', '        ',
     2                'MAG.   ', 'MAG.   ', 'MAG.       ', 'MAG.    ',
     3                '       ', '       ', '           ', '        '/
C
C *** Is MIDAS out there?
      CALL STSPRO('DIAFRAGM')
      CALL TBMNUL(TINULL,TRNULL,TDNULL)
      CALL TBMCON(TBLSEL,TDTRUE,TDFALS)
C
C *** get the frame name
      CALL STKRDC('IN_A',1,1,60,IAV,FRAME,KUN,KNUL,ISTAT)
      CALL STIGET(FRAME,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,2,NAXIS,
     2            NPIX,BEGIN,STEP,IDENT,CUNIT,IPNTR,IMF,ISTAT)
C 
      NPL = NPIX(1)
      NL  = NPIX(2)
C
C *** get the catalogue table
      CALL STKRDC('IN_B',1,1,60,IAV,REGFIL,KUN,KNUL,ISTAT)  !input register name
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL: Error opening registration table'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
C
C *** open the input register table
      CALL STECNT('GET',EC,ED,EL)
      CALL STECNT('PUT',1,0,0)
      CALL TBTOPN(REGFIL,F_IO_MODE,TIDREG,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL: Problems with opening registration'//
     2            ' table; Try again ...'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
C
      CALL TBIGET(TIDREG,NCREG,NRREG,NSREG,NACREG,NARREG,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL: Problems with getting info for'//
     2            ' registration table; Try again ...'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
      IF (NRREG.EQ.0) THEN
         STRING = '*** FATAL: No data in the registration table'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
C
C *** get output table
      CALL STKRDC('OUT_A',1,1,60,IAV,OUTFIL,KUN,KNUL,ISTAT)    ! get output name
C
C *** create the output table
      CALL TBTINI(OUTFIL,0,F_O_MODE,NCOUT,NROUT,TIDOUT,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL:  Problems with opening a new '//
     2            'registration table'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
      CALL STECNT('PUT',EC,ED,EL)
C
      OUTTYP = D_I4_FORMAT
      OUTFOR = FORMI4
      OUTUNI = '   '
      OUTLAB = 'IDENT'
      CALL TBCINI(TIDOUT,OUTTYP,1,OUTFOR,OUTUNI,
     2                   OUTLAB,OUTCOL,ISTAT)          ! create the ident column
C
      DO 101 IC = 1,NCPAR
         ICPAR(IC) = IC + 1
         OUTTYP    = D_R4_FORMAT
         OUTFOR    = FORMR4
         OUTUNI    = UNIT(IC)
         OUTLAB    = LABEL(IC)
         CALL TBCINI(TIDOUT,OUTTYP,1,OUTFOR,OUTUNI,
     2                      OUTLAB,OUTCOL,ISTAT)       ! create the data columns
  101 CONTINUE
C
C *** radius for integration
      CALL STKRDI('INPUTI',1,1,IAV,IR,KUN,KNUL,ISTAT)   ! get integration radius
C
C *** do the work
      DO 100 IROW=1,NRREG
         CALL TBSGET(TIDREG,IROW,SFLAG,ISTAT)
         IF (SFLAG) THEN
            CALL TBERDI(TIDREG,IROW,ICIDN,IDNT,NUL,ISTAT)
            CALL TBRRDR(TIDREG,IROW,NCPAR,ICPAR,TAB,NUL,ISTAT)
C
            IX  = INT((TAB(1)-BEGIN(1))/STEP(1)+1)
            IY  = INT((TAB(2)-BEGIN(2))/STEP(2)+1)
            FON = TAB(4)
            LOG = (IX+IR.LE.NPL) .AND. (IY+IR.LE.NL)
            IF (IX-IR.GT.0 .AND. IY-IR.GT.0 .AND. LOG) THEN
               LF  = 0
               IX0 = IX-IR
               IY0 = IY-IR
               LD  = IR*2+1
               S   = 0.
               IC  = LD/2+1
               DO 110 I1=IY0,IY0+LD-1
                  CALL REALIN(NPL,NL,I1,IX0,LD,MADRID(IPNTR),RV)
                  I1O = I1-IY0+1
                  DO 111 I2=1,LD
                     DS = (I1O-IC)**2+(I2-IC)**2
                     IF (SQRT(DS).LE.IR) THEN
                        AP = RV(I2)
                        S  = S+AP-FON
                     ENDIF
  111            CONTINUE
  110          CONTINUE
C
               IF (S.GT.0) THEN
                  S = -2.5*ALOG10(S)
               ELSE
                  S = 0.
               END IF
               TAB(8) =  S
C
               CALL TBEWRI(TIDOUT,IROW,ICIDN,IDNT,ISTAT)
               CALL TBRWRR(TIDOUT,IROW,NCPAR,ICPAR,TAB,ISTAT)
            END IF
         ENDIF
100   CONTINUE

      CALL TBSINI(TIDOUT,ISTAT)
      CALL TBTCLO(TIDOUT,ISTAT)
      CALL TBTCLO(TIDREG,ISTAT)
      CALL STSEPI
      END

C @(#)proone.for	19.1 (ES0-DMD) 02/25/03 13:29:44
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE PROONE(TID)
C+++
C---
      IMPLICIT  NONE
      INTEGER   TID
C
      INTEGER   NX
      INTEGER   NDSAT
      INTEGER   IDFS
      PARAMETER (NX=10000)
      PARAMETER (NDSAT=50000)
      PARAMETER (IDFS=1000)
      INTEGER   J, J1, KS, K1, K2, KR1 
      INTEGER   IMX, IMY, LKM, ISTAT
      INTEGER   IGRP
      REAL      PRX, PRY, RAG, FLB, DUM
      LOGICAL   FDX, FDY
      CHARACTER OUTP*60

      REAL      DICI, DICS, RIJ, RISI, SAT, XCEN, YCEN
      REAL      BETA, SIGMA, PR
      REAL      ZMA(NX,3), FON(IDFS)
      REAL      SGL(IDFS)
      REAL      AIN, RAMA, RAME, FONM
      INTEGER   IXW, IYW, IX0, IY0, IM, NCX, NCY, IDX, IDY
      INTEGER   KR, KN
      INTEGER   KSAT, I1, NYM, NY2 
      INTEGER   MTS(NDSAT,4), LN(3)
C
      COMMON    /PRONE/ KR,DICI,DICS,RIJ,ZMA,RISI,IXW,IYW,SGL,FON,
     *                  SAT,XCEN,YCEN,IX0,IY0,IM,NCX,NCY,IDX,IDY,
     *                  AIN,RAMA,RAME,FONM,MTS,KSAT,I1,NYM,LN,
     *                  BETA,SIGMA,KN,PR,NY2
C
      KR=KR+1
      DO 10 J=1,IDX
C      
C *** start procedure 
         PRX = FLOAT(IDX)/FLOAT(NCX)
         PRY = FLOAT(IDY)/FLOAT(NCY)
         IF (PRX-INT(PRX).EQ.0.) THEN
           IMX = (J-1)/INT(PRX)+1
         ELSE
           IMX = (J-1)/PRX+1
         END IF
C
         IF (PRY-INT(PRY).EQ.0.) THEN
            IMY = (KR-1)/INT(PRY)+1
         ELSE
            IMY = (KR-1)/PRY+1
         END IF
         IM  =NCX*(IMY-1)+IMX
C *** end procedure CALCOLA CORONA
C      
         RIJ  = ZMA(J,LN(I1))
         RISI = SGL(IM)+FON(IM)
         IF (RIJ.GE.SAT) THEN
C        
C *** start procedure procedura sature 1
            IF (KSAT.EQ.0) THEN
               KSAT        = KSAT+1
               MTS(KSAT,1) = J
               MTS(KSAT,2) = KR
               MTS(KSAT,3) = J
               MTS(KSAT,4) = 0
            ELSE
               IF (MTS(KSAT,2).EQ.KR.AND.MTS(KSAT,3).EQ.J-1) THEN
                  MTS(KSAT,3)=J
               ELSE
                  KSAT=KSAT+1
                  IF (KSAT.GT.NDSAT) THEN
                     OUTP='*** ERROR: Too many pixels above '//
     2                    'saturation level '
                     CALL STTPUT(OUTP,ISTAT)
                  END IF
                  MTS(KSAT,1) = J
                  MTS(KSAT,2) = KR
                  MTS(KSAT,3) = J
                  MTS(KSAT,4) = 0
               END IF
           END IF
C *** end procedure SATURE 1
C        
        ELSE
           IF (RIJ.GE.RISI) THEN
C          
C *** start procedure R MAX
              KS  = 0
              LKM = 0
              DO 20 K1=I1-1,I1+1
                 IF (K1.GT.0.AND.K1.LE.NYM) THEN
                    DO 30 K2=J-NY2,J+NY2
                       IF (K2.GT.0.AND.K2.LE.IDX) THEN
                          IF (ZMA(K2,LN(K1)).GE.RISI) LKM=LKM+1
                          IF (KS.EQ.0) THEN
                             IF (ZMA(K2,LN(K1)).GT.RIJ) KS=-1
                             IF (ZMA(K2,LN(K1)).EQ.RIJ) THEN
                                IF (K1.NE.I1.OR.K2.NE.J) THEN
                                   IF (K1.LE.I1 .AND. K2.LE.J .OR. 
     *                                 K1.LT.I1 .AND. K2.GT.J) KS=-1
                                END IF
                             END IF
                          END IF
                       END IF
   30               CONTINUE
                 END IF
   20         CONTINUE
C
              IF (LKM.LE.1) KS=-1
              IF (KS.EQ.0) THEN
                 KN  = KN+1
                 RIJ = RIJ-FON(IM)
                 J1  = J+IX0+IXW-2
                 KR1 = KR+IY0+IYW-2
                 IF (BETA.GT.0) THEN
                    RAG = SIGMA*SQRT((AIN/RIJ)**(-1./BETA)-1.)
                 ELSE
                    RAG = SIGMA*SQRT(ALOG(RIJ/AIN)/(4*ALOG(2.)))
                 END IF
                 RAMA = AMAX1(RAMA,RAG)
                 RAME = RAME+RAG
                 FLB  = 0
                 FDX  = J.EQ.1.OR.J.EQ.IDX
                 FDY  = KR.EQ.1.OR.KR.EQ.IDY
                 IF (FDX.OR.FDY) FLB=2
                 IGRP = KN
                 DUM       = 0.0
                 CALL CATTWR(TID,KN,IGRP,FLOAT(J1),FLOAT(KR1),RIJ,
     *                      FON(IM),RAG,FLB,FON(IM),DUM,SIGMA,BETA,SAT,
     *                      AIN,FONM)
              END IF
C          
C *** end procedure R MAX
           END IF
        END IF
   10 CONTINUE
C
      RETURN
      END

CC  
CC   This is a template for a short
CC   FORTRAN program which runs in 
CC   the MIDAS enviroment
CC
CC   Use the procedure my_for.prg to
CC   call this program
CC
CC    
CC
CC   P.Nass 11/19/1999
CC 
CC   090806		last modif
CC 
CC
      PROGRAM FTEMPL
      IMPLICIT NONE

      CHARACTER OLDNAME*60, NEWNAME*60
      CHARACTER CBUF*80

      INTEGER STAT
      INTEGER ACTS
      INTEGER KUN
      INTEGER KNUL

      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON /VMR/  MADRID
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'

      CALL STSPRO('FTEMPL')          ! start communication with MIDAS     
      
CC    read character keyword:
      CALL STKRDC('INPUT',1,1,60,ACTS,OLDNAME,KUN,KNUL,STAT)

CC    again read character keyword:
      CALL STKRDC('OUTPUT',1,1,60,ACTS,NEWNAME,KUN,KNUL,STAT)

CC    rename a frame on disk:
      CALL STFRNM(OLDNAME, NEWNAME,STAT)

CC    produce some output:
      WRITE (CBUF,10000) OLDNAME
      CALL STTPUT(CBUF)
      WRITE (CBUF,10000)
      CALL  STTPUT (CBUF)
C
      CALL STSEPI                     ! stop communication with MIDAS
C
10000 FORMAT('Rename frame: ',A)
10001 FORMAT('to: ',A)
      END

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C       Internet e-mail: midas@eso.org
C       Postal address: European Southern Observatory
C                       Data Management Division 
C                       Karl-Schwarzschild-Strasse 2
C                       D 85748 Garching bei Muenchen 
C                       GERMANY
C===========================================================================
C
C

      program complyman
      
      implicit none
      include 'MID_REL_INCL:fit_var.inc'
      
                                ! copies of keywords coming from line
      character*80 SPESYS,LINSYS,SINSYS
      character SELSYS
      real NOISYS(3)

      character*14 cctest
 
      character*14 Elem(1000)
      double precision lam_lin(1000),nh_lin(1000)
      double precision bk_lin(1000),bt_lin(1000)
      double precision outflx(NMXSPE),noivar(NMXSPE),inppxs(NMXSPE)
      double precision inpwav(NMXSPE),inpfwh(NMXSPE),fluxun(NMXSPE)
      double precision dnoi1, dnoi2
      double precision gasdev

      integer ist,i,ijk,iok,nj,j
      integer TabID,i1,i2,i3,i4,icol(20)
      logical la
      double precision d1
      character*2 des
      character*14 ENam

      
C      include 'MID_REL_INCL:fit_mid.inc'
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'

C!!!!!!!
C     MIDAS SET-UP
C!!!!!!!
      call STSPRO('fitlyman')
      
      call STKRDC('SPECTAB',1,1,80,i,SPESYS,ijk,ijk,iok)
      if (iok.ne.0) then
         call ErrMsg('Error in reading keywords: check context..')
         call STSEPI() 
         stop
      end if   
      call STKRDC('OUTTAB',1,1,80,i,LINSYS,ijk,ijk,iok)
      if (iok.ne.0) then
         call ErrMsg('Error in reading keywords: check context..')
         call STSEPI() 
         stop
      end if   
      call STKRDC('SINTTAB',1,1,80,i,SINSYS,ijk,ijk,iok)
      if (iok.ne.0) then
         call ErrMsg('Error in reading keywords: check context..')
         call STSEPI() 
         stop
      end if   
      call STKRDC('INPUTC',1,1,1,i,SELSYS,ijk,ijk,iok)
      if (SELSYS.eq.'l') SELSYS = 'L'
      if (SELSYS.eq.'a') SELSYS = 'A'
      if (SELSYS.eq.'m') SELSYS = 'M'

      call STKRDR('INPUTR',1,3,i,NOISYS,ijk,ijk,iok)
      if (iok.ne.0) then
         call ErrMsg('Error in reading keywords: check context..')
         call STSEPI() 
         stop
      end if   

      

C!!!!!!!
C     Videata iniziale
C!!!!!!!
      call DisMsg('Loading data...')
      call DisMsg('Wait please..')
      
C!!!!!!!
C     Inizializzazione programma
C!!!!!!!
      call AtmRD(ist)            !read atompar.dat
      NPUNTI=NMXSPE
      call reaspe(SPESYS,NPUNTI)    !read spectrum
      if (NPUNTI.lt.1) goto 666
      do i=1,NPUNTI
         inpwav(i)=XLAMBD(i)
         inpfwh(i)=FWHM(i)
         inppxs(i)=PIXSIZ(i)
      end do
      
      call TBTOPN(LINSYS,F_IO_MODE,TabID,ist) !open line table
      call TBLSER(TabID,'Element',icol(1),ist)
      call TBLSER(TabID,'LamCen',icol(2),ist)
      call TBLSER(TabID,'ColDen',icol(3),ist)
      call TBLSER(TabID,'B',icol(4),ist)
      call TBLSER(TabID,'BTur',icol(5),ist)


      i1=1                      !doesn't stop on errors
      i2=0
      i3=0
      call STECNT('PUT',i1,i2,i3)

      call TBIGET(TABID,i1,i2,i3,i4,nj,ist) !n. of rows


      j=0
      do i=1,nj
         call TBSGET(TABID,i,la,ist) ! selected?
         if (la) then
            call TBERDC(TABID,i,icol(1),cctest,la,ist) !reads element
            call FT_EOS(cctest,14,ENam,ist) 
            if (.not.la) then
               la = .false.
               des=ENam(1:2)
               if (SELSYS.eq.'A') then
                  la =.true.
               else
                  if (des.eq.'Ly'.and.SELSYS.eq.'L') la =.true.
                  if (des.ne.'Ly'.and.SELSYS.eq.'M') la =.true.
               end if
               if (la) then
                  j=j+1
                  Elem(j)=ENam
                  call TBERDD(TABID,i,icol(2),d1,la,ist)
                  if (la) then
                     j=j-1
                     goto 1011
                  end if
                  lam_lin(j)=d1

                  call TBERDD(TABID,i,icol(3),d1,la,ist)
                  if (la) then
                     j=j-1
                     goto 1011
                  end if
                  nh_lin(j)=d1

                  call TBERDD(TABID,i,icol(4),d1,la,ist)
                  if (la) then
                     j=j-1
                     goto 1011
                  end if
                  bk_lin(j)=d1

                  call TBERDD(TABID,i,icol(5),d1,la,ist)
                  if (la) then
                     j=j-1
                     goto 1011
                  end if
                  bt_lin(j)=d1

               end if

            end if

         end if
 1011    continue
      end do

      call TBTCLO(TABID,ist)


c     computes new spectrum

      call DisMsg('...done')
      call DisMsg('Computing spectrum....')

      do i=1,j
         bk_lin(i) = dsqrt(bk_lin(i)*bk_lin(i)+bt_lin(i)*bt_lin(i))
      end do

      d1=0.                     ! tau gunn-peterson. = 0
      call CHECK(d1,Elem,lam_lin,bk_lin,NH_lin,inpfwh,j,inpwav,inppxs,
     1    NPUNTI,outflx,fluxun)


c     add noise

                                ! NOISYS(1)= noise of sky, (stdev)
                                ! NOISYS(2)= total noise 
                                ! NOISYS(3)=idum
      ijk=NOISYS(3)
      if (ijk .gt.0) ijk=-ijk
      dnoi2 = abs(NOISYS(2)*NOISYS(2)-NOISYS(1)*NOISYS(1))
      dnoi1 =NOISYS(1)*NOISYS(1)
      do i=1,npunti
         noivar(i)=dsqrt(dnoi2*outflx(i) + dnoi1)
         outflx(i)=outflx(i) +noivar(i)*gasdev(ijk)
      end do

C     Saves new spectrum

      call TBTINI(SINSYS,F_TRANS,F_O_MODE,5,10,TABID,ist)
      call TBCINI(TabID,D_R8_FORMAT,1,'F8.3',' ','WAVE',icol(1),ist)
      call TBCINI(TabID,D_R8_FORMAT,1,'F8.5',' ','NORMFLUX',icol(2),
     1     ist)
      call TBCINI(TabID,D_R8_FORMAT,1,'F6.3',' ','FWHM',icol(3),ist)
      call TBCINI(TabID,D_R8_FORMAT,1,'F8.5',' ','STDEV',icol(4),ist)
      call TBCINI(TabID,D_R8_FORMAT,1,'F8.5',' ','FLUX_UNCONV',icol(5)
     1     ,ist)
      
      do i=1,NPUNTI
         call TBEWRD(TABID,i,icol(1),inpwav(i),ist)
         call TBEWRD(TABID,i,icol(2),outflx(i),ist)
         call TBEWRD(TABID,i,icol(3),inpfwh(i),ist)
         call TBEWRD(TABID,i,icol(4),noivar(i),ist)
         call TBEWRD(TABID,i,icol(5),fluxun(i),ist)
      end do

      call TBTCLO(TABID,ist)


      call DisMsg('...done')

 666  continue
      call STSEPI()
      end

C @(#)scldet.for	19.1 (ES0-DMD) 02/25/03 13:25:39
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C
C-----------------------------------------------------------------------
      SUBROUTINE SCLDET(LZ, NCAT, PMTR, PRCT, NCT,
     &                  PMT, PRC, APSF, NPAS, SCA,
     &                  SCC)
C
      IMPLICIT  NONE
      INCLUDE   'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER   LZ                          ! IN: Object number
      INTEGER   NCAT(NIPAR,MAXCNT)           ! IN: Object integer parameters
      REAL      PMTR(NRPAR,MAXCNT)           ! IN: Object real parameters
      REAL      PRCT(0:MAXSUB,MAXCNT)        ! IN: Object profile
      INTEGER   NCT(NIPAR)                   ! IN: Component integer parameters 
      REAL      PMT(NRPAR)                   ! IN: Component real parameters
      REAL      PRC(0:MAXSUB)                ! IN: Component profile 
      REAL      APSF(0:MAXSUB)               ! IN: One dimensional p.s.f.
      INTEGER   NPAS                         ! IN: Iteration number
      REAL      SCA                          ! OUT: Object intensity
      REAL      SCC                          ! OUT: Component intensity
C
      INTEGER   KSAT
      REAL      ATMP , SCALE
C
      SCALE = 9.0 / ( 1.0 + 8.0*APSF(1) )
      IF ( NPAS .GT. 2 ) THEN
          SCA = PMTR(12,LZ)
          SCC = PMT(12)
      ELSE
          KSAT = NCAT(6,LZ)
          IF ( KSAT .EQ. -1 ) THEN
              SCA = SCALE * PMTR(2,LZ)
          ELSE
              ATMP = APSF(KSAT+2)
              IF ( ATMP .GT. 0.0 ) THEN
                  SCA = PRCT(KSAT+2,LZ) / ATMP
              ELSE
                  SCA = 0.0
              ENDIF
          ENDIF
          KSAT = NCT(6)
          IF ( KSAT .EQ. -1 ) THEN
              SCC = SCALE * PMT(2)
          ELSE
              ATMP = APSF(KSAT+2)
              IF ( ATMP .GT. 0.0 ) THEN
                  SCC = PRC(KSAT+2) / ATMP
              ELSE
                  SCC = 0.0
              ENDIF
          ENDIF
      ENDIF
      SCC = 0.0
C
      RETURN
C
      END

C @(#)renmbr.for	19.1 (ES0-DMD) 02/25/03 13:25:38
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine RENMBR         version 1         820723
C  A. Kruszewski             ESO Garching
C  modified                  version 1.1       870303
C  A. Kruszewski             Obs. de Geneve
C.PURPOSE
C  removes from arrays "NCAT", "ACAT", "PMTR", "PRCT" objects for
C  which a value PMTR(2,*) is smaller than "TRSH"
C  renumbers remaining objects
C.INPUT/OUTPUT
C  input arguments
C
C  NCAT        integer*4 array   integer parameters of objects
C  ACAT        real*4 array      real parameters of objects
C  PMTR        real*4 array      array holding classifiers
C  PRCT        real*4 array      array holding profiles
C  IVRF        integer*4         verification flag
C  M0          integer*4         initial number of objects
C  MM          integer*4         input number of entries
C  TRSH        real*4            limiting treshold
C  output parameters
C  NCAT        integer*4 array   integer parameters of objects
C  ACAT        real*4 array      real parameters of objects
C  PMTR        real*4 array      array holding classifiers
C  PRCT        real*4 array      array holding profiles
C  M           integer*4         outputed number of entries
C-----------------------------------------------------------------------
      SUBROUTINE RENMBR(L0, L1, LW, NREG, LSTP,
     &                  NCAT, PMTR, PRCT, IVRF, TRSH,
     &                  M0, MM, M)
C 
      IMPLICIT  NONE
      INCLUDE  'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER   L0
      INTEGER   L1
      INTEGER   LW
      INTEGER   NREG
      INTEGER   LSTP(0:4,0:NREG)
      INTEGER   NCAT(NIPAR,MAXCNT)
      REAL      PMTR(NRPAR,MAXCNT)
      REAL      PRCT(0:MAXSUB,MAXCNT)
      INTEGER   IVRF
      REAL      TRSH
      INTEGER   M0
      INTEGER   MM
      INTEGER   M
C
      INTEGER   NP
      INTEGER   K, K0, KM
      INTEGER   LL0, L01
      INTEGER   LL, LL1, LB
     
C
C *** Initialize constants and variables.
C
      NP = MAXCNT
      IF (IVRF.EQ.0) THEN
          L01 = M0
      ELSE
          L01 = 0
      ENDIF
      M = 0
      K0 = 0
      LL0 = 0
      LSTP(3,0) = 0
      DO 5 LL = 1 , NREG
          LSTP(0,LL) = 0
    5 CONTINUE
C
C *** Set initial limits of buffers.
C
      LL1 = MIN( MM , NP )
      LB = LL1
C
C *** Refill buffers if necessary.
C
C      IF ( L0 .GT. LL0 .OR. L1 .NE. LL1 ) THEN
C          DO 10 LL = 1 , LB
C              READ ( ISF , REC=LL ) ( NCAT(KK,LL) , KK=1,NIPAR ) ,
C     &                                 ( PMTR(KK,LL) , KK=1,NRPAR ) ,
C     &                                 ( PRCT(KK,LL) , KK=0,MAXSUB )
C   10     CONTINUE
C      ENDIF
C
C *** Start renumbering.
C
C  20 CONTINUE
C
C ***     Process current content of buffers.
C
          KM = 0
          DO 30 LL = 1 , LB
              NCAT(7,LL) = 0
              NCAT(8,LL) = 0
              IF ( L0+LL .LE. L01 ) THEN
                  M = M + 1
                  KM = KM + 1
                  CALL PUTLSS( K0+KM , NREG , LSTP , NCAT , PMTR ,
     &                         PRCT )
              ELSE IF ( PMTR(2,LL) .GT. TRSH ) THEN
                  M = M + 1
                  KM = KM + 1
                  DO 40 K = 1 , NIPAR
                      NCAT(K,KM) = NCAT(K,LL)
   40             CONTINUE
                  DO 50 K = 1 , NRPAR
                      PMTR(K,KM) = PMTR(K,LL)
   50             CONTINUE
                  DO 60 K = 0 , MAXSUB
                      PRCT(K,KM) = PRCT(K,LL)
   60             CONTINUE
                  CALL PUTLSS( K0+KM , NREG , LSTP , NCAT , PMTR ,
     &                         PRCT )
              ENDIF
   30     CONTINUE
C
C ***     Save buffers.
C
C          DO 70 K = 1 , KM
C               WRITE ( ISF , REC=K0+K ) ( NCAT(KK,K) , KK=1,NIPAR ) ,
C     &                                 ( PMTR(KK,K) , KK=1,NRPAR ) ,
C     &                                 ( PRCT(KK,K) , KK=0,MAXSUB )
C   70     CONTINUE
C          LL0 = LL1
C          LL1 = MIN( LL0+NP , LW )
C          LB = LL1 - LL0
C          K0 = K0 + KM
C          IF ( LL0 .LT. LW ) THEN
CC
CC ***         Fill buffers and repeat the loop.
CC
C              DO 80 LL = 1 , LB
C                  READ ( ISF , REC=LL0+LL )
C     &                               ( NCAT(KK,LL) , KK=1,NIPAR ) ,
C     &                               ( PMTR(KK,LL) , KK=1,NRPAR ) ,
C     &                               ( PRCT(KK,LL) , KK=0,MAXSUB )
C   80         CONTINUE
C              GOTO 20
C          ENDIF
C
C *** Loop terminate here.
C
      CONTINUE
C
      LW = M
      L0 = LL0
      L1 = K0+KM
C
      RETURN
C
      END
C

C===========================================================================
C Copyright (C) 1995, 2003 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE ODSCLS(IMNO,INDSC,IVALS,RVALS,CVALS,DVALS,FLAG)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: K.Banse
C
C.IDENTIFICATION
C  subroutine ODSCLS			version 3.30	850926
C  K. Banse                  		ESO - Garching
C
C.KEYWORDS
C  descriptors
C
C.PURPOSE
C  display contents of one or all descriptors of a bulk data frame
C
C.ALGORITHM
C  read all existing descriptor names + display their contents
C
C.INPUT/OUTPUT
C  call as DSCLIS(IMNO,INDSC,IVALS,RVALS,CVALS,DVALS,FLAG)
C
C  IMNO:      I*4         frame no. of data frame
C  INDSC:     char.exp.   descriptor to be displayed
C                   	  if = ' ', all descriptors are displayed
C  IVALS:     I*4 array   integer buffer
C  RVALS:     R*4 array   real buffer
C  CVALS:     char.exp.   character buffer
C  DVALS:     R*8 array   double precision buffer
C  FLAG:      char.exp.   2-char. flag:
C			  (1) = R(ead), P(rint) or S(how)
C			  (2) = F(ull), B(rief) or H(idden)
C-------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      IMNO,IVALS(*)
      INTEGER      LIM(6)
      INTEGER      BYTELM,NOELEM,NPOS
      INTEGER      DSCNO(2),DSCLEN,IAV,IOFF,ITY,L,LL,M,MM,N,KCASE
      INTEGER      NDOFF,NDI,NDLIM,STAT,IJK(5),NPT
      INTEGER      EL1,NEL2,NOTDS,HNC
      INTEGER      DIROFF,OPTIO,UNIT(1),NULLO,XLONG
C
      CHARACTER*(*)  INDSC
      CHARACTER*(*)  CVALS
      CHARACTER*(*)  FLAG
      CHARACTER      DIRBUF*32760
      CHARACTER      LF*1,TYPE*1
      CHARACTER      DISCR*80,DSCDIR*24,DSCTYP*24
      CHARACTER      NOTDSC(4)*72,OUTPUT*80,CCC*14,CBUF*80
      CHARACTER      CC(6)*12,CTYPE*4,CHTYP*14,BLANK*20
C
      REAL           RVALS(*)
C
      DOUBLE PRECISION DVALS(*)
C 
      DATA      CC/'integer ','real ','character ','double prec.',
     +		   ' ','logical '/
      DATA      CHTYP /'character* '/
      DATA      LIM      /6,4,60,2,1,10/
      DATA      BLANK /' '/, CCC /' '/
C
      LF = CHAR(10)                   !LineFeed character ( \n in C)
      DSCNO(1) = 0                    !for descriptor
      DSCNO(2) = -1                   !for help text of descriptor
      NPOS = 1
      NDI = 0
      DSCDIR = 'DIRECTORY.MIDAS'
      EL1 = 1
      NEL2 = 0
C
C  clean + convert to uppercase
      DISCR(1:) = ' '
      CALL UPCAS(INDSC,DISCR)
      IF (DISCR.EQ.DSCDIR) THEN
         OPTIO = -1                   !descr. directory
         NOELEM = 0
C
            NDLIM = 1500             !process old descr format
            NDOFF = 1
88          CALL STDRDC(IMNO,DSCDIR,1,NDOFF,NDLIM,LL,
     +                  DIRBUF,UNIT,NULLO,STAT)
            NOELEM = NOELEM + LL
            IAV = LL/30
            DSCNO(1) = DSCNO(1) + IAV
C
            IF (NOELEM.GT.0) THEN
               DO 100, N=1,NOELEM,60
                  IF (N+30.GT.NOELEM) THEN
                     OUTPUT(1:) = '   '//DIRBUF(N:N+14)//'   '
     +                               //DIRBUF(N+15:N+15)//' '
                  ELSE
                     OUTPUT(1:) = '   '//DIRBUF(N:N+14)//'   '
     +                               //DIRBUF(N+15:N+15)//'       '
     +                               //DIRBUF(N+30:N+44)//'   '
     +                               //DIRBUF(N+45:N+45)//' '
                  ENDIF
                  CALL STTPUT(OUTPUT,STAT)
100            CONTINUE
            ENDIF
C
            IF (NOELEM.EQ.NDLIM) THEN
               NDOFF = NDOFF + NDLIM
               GOTO 88                              !look for more
            ELSE
               WRITE(OUTPUT,33000) NOELEM,DSCNO(1)
               CALL STTPUT(OUTPUT,STAT)
               RETURN
            ENDIF
C
      ELSE IF (DISCR(1:1).EQ.' ') THEN
         IF ((DISCR(2:2).EQ.',') .OR.              !descriptor NOT to display
     +       (DISCR(2:2).EQ.'|')) THEN
            NOTDS = 1
            DISCR(2:2) = ' '
110         N = INDEX(DISCR,',')
            IF (N.GT.1) THEN
               NOTDSC(NOTDS)(1:) = DISCR(3:N-1)//' ' 
               DISCR(3:) = DISCR(N+1:)
               IF (NOTDS.LT.4) THEN
                  NOTDS = NOTDS + 1
                  GOTO 110 
               ENDIF
            ELSE
               NOTDSC(NOTDS)(1:) = DISCR(3:)
               IF (NOTDS.EQ.1) THEN
                  N = INDEX(NOTDSC(1),'*')
                  IF (N.GT.0) THEN
                     CALL PATTST(1,NOTDSC(1),STAT)
                     NOTDS = -1
                  ENDIF
               ENDIF
            ENDIF
         ELSE
            NOTDS = 0
         ENDIF
         OPTIO = 1                    !all descriptors
         DISCR(1:) = ' '
            NDLIM = 32760       !old descr format, only for max. 32760 descr...
            CALL STDRDC(IMNO,DSCDIR,1,1,NDLIM,NOELEM,
     +                  DIRBUF,UNIT,NULLO,STAT)
            IAV = NOELEM/30
            DSCNO(1) = DSCNO(1) + IAV
C
            DIROFF = 31                  !omit directory output
            NDI = NDI + 1
            DISCR(1:) = DIRBUF(DIROFF:DIROFF+14)//' '
            CALL STDFND(IMNO,DISCR,DSCTYP,NOELEM,BYTELM,STAT)
C 
      ELSE
         N = INDEX(DISCR,'*') 
         IF (N.GT.0) THEN                  !we have a pattern
            N = INDEX(DISCR,'|')
            IF (N.GT.1) THEN               !is it incl-patrn | excl-patrn?
               OPTIO = 3
               CALL PATTST(1,DISCR(1:N-1),STAT)    !save the two patterns
               CALL PATTST(11,DISCR(N+1:),STAT)
            ELSE
               OPTIO = 2
               CALL PATTST(1,DISCR,STAT)
            ENDIF
            NPT = 0
C 
               NDLIM = 32760    !old descr format, only for max. 32760 descr...
               CALL STDRDC(IMNO,DSCDIR,1,1,NDLIM,NOELEM,
     +                     DIRBUF,UNIT,NULLO,STAT)
               IAV = NOELEM/30
               DSCNO(1) = DSCNO(1) + IAV
               DIROFF = 1
C 
            NPOS = 0
            GOTO 8000
         ENDIF
C 
         OPTIO = 0                 !single descriptor 
         DSCNO(1) = 1         
         N = INDEX(DISCR,'/')                  !see, if it's descr/type/f/no
         IF (N.GT.1) THEN
            CBUF(1:) = DISCR(N+1:)
            DISCR(N:) = ' '
         ENDIF
         CALL STDFND(IMNO,DISCR,DSCTYP,NOELEM,BYTELM,STAT)
C 
         IF (N.GT.1) THEN
            N = INDEX(CBUF,'/')               !skip type
            IF (N.GT.1) THEN
               CBUF(1:) = CBUF(N+1:)
               DO 440,N=1,30
                  IF (CBUF(N:N).EQ.'/') THEN
                     CBUF(N:N) = ','
                     CALL GENCNV(CBUF,1,2,IVALS,RVALS,DVALS,LL)
                     IF (LL.EQ.2) THEN
                        EL1 = IVALS(1)
                        NEL2 = IVALS(2)
                        GOTO 500
                     ENDIF
                  ENDIF
440            CONTINUE
            ENDIF
         ENDIF
C 
      ENDIF
C
C
C  loop through descr. list
C
500   IF (OPTIO.GE.2) THEN                          !we have pattern(s)
         CALL PATTST(2,DISCR,STAT)
         IF (STAT.EQ.0) GOTO 8000                   !no match
C 
         IF (OPTIO.EQ.3) THEN
            CALL PATTST(12,DISCR,STAT)
            IF (STAT.EQ.1) GOTO 8000                !it's an excluded descr
         ENDIF
         NPT = NPT + 1                              !matching descr. found
C 
      ELSE IF (OPTIO.EQ.1) THEN
         IF (NOTDS.NE.0) THEN 
            IF (NOTDS.GT.0) THEN                    !loop thru excluded descrs
               DO 550, N=1,NOTDS
                  IF (DISCR.EQ.NOTDSC(N)) THEN
                     DSCNO(1) = DSCNO(1) - 1
                     GOTO 8000
                  ENDIF
550            CONTINUE
            ELSE 
               CALL PATTST(2,DISCR,STAT)
               IF (STAT.EQ.1) THEN
                  DSCNO(1) = DSCNO(1) - 1
                  GOTO 8000
               ENDIF
            ENDIF
         ENDIF
      ENDIF
C 
      IF (NEL2.GT.0) NOELEM = NEL2
C 
      DSCLEN = INDEX(DISCR,' ') - 1              !real length of descr name
      TYPE = DSCTYP(1:1)
      IF (TYPE.EQ.' ') THEN
         IJK(1) = 0
         IF (FLAG(2:2).NE.'H') THEN
            OUTPUT(1:) = 'descriptor '//DISCR(1:DSCLEN)//
     +                   ' not present... '
            CALL STTPUT(OUTPUT,STAT)
         ENDIF
         GOTO 8000
      ENDIF
C 
      IJK(1) = 1
      STAT = 0
      XLONG = 0
      IF (NOELEM.GT.65535) THEN
         XLONG = NOELEM - 65535
         NOELEM = 65535                   !ojo: synchronize with MAIN ...
      ENDIF
C
C  get integer data
700   IF (TYPE.EQ.'I') THEN
         ITY = 1
         IF (FLAG(1:1).NE.'S') CALL STDRDI
     +   (IMNO,DISCR,EL1,NOELEM,IAV,IVALS,UNIT,NULLO,STAT)
C
C  get real data
      ELSE IF (TYPE.EQ.'R') THEN
         ITY = 2
         IF (FLAG(1:1).NE.'S') CALL STDRDR
     +   (IMNO,DISCR,EL1,NOELEM,IAV,RVALS,UNIT,NULLO,STAT)
C
C  get character data
      ELSE IF (TYPE.EQ.'C') THEN
         IF (BYTELM.GT.1) THEN
            ITY = 5
            WRITE(CTYPE,30000) BYTELM
C                                                     omit leading blanks...
            DO 800 LL=1,3
               IF (CTYPE(LL:LL).NE.' ') GOTO 1000
800         CONTINUE
            LL = 4
1000        CHTYP(11:) = CTYPE(LL:)
            IF (FLAG(1:1).NE.'S')
     +         CALL STDRDC(IMNO,DISCR,BYTELM,EL1,NOELEM,
     +                     IAV,CVALS,UNIT,NULLO,STAT)
         ELSE
            ITY = 3
            IF (FLAG(1:1).NE.'S')
     +         CALL STDRDC(IMNO,DISCR,1,EL1,NOELEM,
     +                     IAV,CVALS,UNIT,NULLO,STAT)
         ENDIF
C
C  get double prec. data
      ELSE IF (TYPE.EQ.'D') THEN
         ITY = 4
         IF (FLAG(1:1).NE.'S') 
     +      CALL STDRDD(IMNO,DISCR,EL1,NOELEM,
     +                  IAV,DVALS,UNIT,NULLO,STAT)
C
C  get logical data
      ELSE IF (TYPE.EQ.'L') THEN
         ITY = 6
         IF (FLAG(1:1).NE.'S') 
     +      CALL STDRDL(IMNO,DISCR,EL1,NOELEM,
     +                  IAV,IVALS,UNIT,NULLO,STAT)
      ENDIF
C 
C  return, if problems with reading descriptors
      IF (STAT.NE.0) THEN
         WRITE(OUTPUT,10000) DISCR(1:DSCLEN)
         CALL STTPUT(OUTPUT,STAT)
         GOTO 8000
      ENDIF
C
C  fill header line
      IF (ITY.NE.5) THEN
         IJK(2) = ITY
         CCC = CC(ITY)
      ELSE
         IJK(2) = 3
         CCC = CHTYP
      ENDIF
C
C  display header line - except for display_flag = H or B
      IF (FLAG(2:2).EQ.'H') THEN
         IF (FLAG(1:1) .EQ. 'S') THEN 
            GOTO 8000                !nothing to do for SHOW/DESCR
         ELSE
            GOTO (5500,5600,5700,5800,5700,5900),ITY      !only display data
         ENDIF
C 
      ELSE IF (FLAG(2:2).NE.'B') THEN
         IF (DSCLEN .LE. 15) THEN
            WRITE(OUTPUT,10001) DISCR(1:15)        !help text begins at 15
         ELSE
            WRITE(OUTPUT,10001) DISCR(1:DSCLEN)
         ENDIF
         MM = INDEX(OUTPUT,'( ') + 1               !find end of text
         IF (MM .GT. 72) THEN
            OUTPUT(MM-1:) = '    '
            CALL STTPUT(OUTPUT,STAT)
            OUTPUT(1:) = '( '
            MM = 2
         ENDIF
         LL = 77 - MM                              !LL = 53 for short descr
C 
         CALL STDRDH(IMNO,DISCR,1,72,IAV,CBUF,HNC,STAT)
         IF (HNC.GT.0) THEN                     !Yes, there is help
            DO 1600, M=IAV,1,-1                 !get rid of trailing blanks
               IF (CBUF(M:M) .NE. ' ') THEN
                  IAV = M
                  GOTO 1660
               ENDIF
1600        CONTINUE
1660        IF (IAV.GT.LL) THEN
               OUTPUT(MM-1:) = '    '
               CALL STTPUT(OUTPUT,STAT)         !print name on one line
               OUTPUT(1:) = '( '                !help text on next line
               MM = 2
            ENDIF
            OUTPUT(MM:) = CBUF(1:IAV)//') '
         ELSE
            OUTPUT(MM:) = '...) '
         ENDIF
         DSCNO(2) = HNC                         !save size of help text
         CALL STTPUT(OUTPUT,STAT)
         IF (NOELEM .GT. 99999) THEN
            WRITE(OUTPUT,10004) CCC,NOELEM
         ELSE
            WRITE(OUTPUT,10005) CCC,NOELEM
         ENDIF
         CALL STTPUT(OUTPUT,STAT)
C
         IF (FLAG(1:1).EQ.'S') THEN                !SHOW/DESCR
            GOTO 8000
         ELSE                                      !READ/DESCR
            GOTO (5500,5600,5700,5800,5700,5900),ITY
         ENDIF
      ELSE
C
C  short display
         IF ((TYPE.EQ.'C') .AND.
     +       (DISCR(1:6).EQ.'IDENT ')) THEN        !truncate IDENT
            MM = 0
            LL = MIN(NOELEM,72)
            DO 3000, M=LL,1,-1
               IF (CVALS(M:M).NE.' ') THEN
                  MM = M                           !mark last char.
                  GOTO 3050
               ENDIF
3000        CONTINUE
3050        IF (MM.EQ.0) THEN                      !only blanks
               NOELEM = 1
            ELSE
               NOELEM = MM
            ENDIF
         ENDIF
C
         DISCR(DSCLEN+1:) = ': '
         IF ( (DSCLEN .GT. 15) .OR.
     +        (NOELEM.GT.LIM(ITY)) .OR.
     +        (ITY.EQ.5) ) THEN
             CALL STTPUT(DISCR,STAT)
             GOTO (5500,5600,5700,5800,5700,5900),ITY
         ELSE                                      !brief display
             GOTO (5550,5650,5790,5850,5790,5950),ITY
         ENDIF
      ENDIF
C
C here the output of the descr. values
C 
5500  DO 5510, M=1,NOELEM,8
         MM = MIN(NOELEM,M+7)
         WRITE(OUTPUT,10002) (IVALS(L),L=M,MM)
         CALL STTPUT(OUTPUT,STAT)
5510  CONTINUE
      GOTO 7700
C
5550  WRITE(OUTPUT,10002) (IVALS(L),L=1,NOELEM)
      LL = NOELEM*10
      CBUF(1:) = DISCR(1:17)//OUTPUT(1:LL)//' '
      CALL STTPUT(CBUF,STAT)
      GOTO 7700
C
5600  DO 5610, M=1,NOELEM,5
         MM = MIN(NOELEM,M+4)
         WRITE(OUTPUT,20002) (RVALS(L),L=M,MM)
         CALL STTPUT(OUTPUT,STAT)
5610  CONTINUE
      GOTO 7700
C
5650  WRITE(OUTPUT,20002) (RVALS(L),L=1,NOELEM)
      LL = NOELEM*15
      CBUF(1:) = DISCR(1:17)//OUTPUT(1:LL)//' '
      CALL STTPUT(CBUF,STAT)
      GOTO 7700
C
C  character data has to be treated specially
5700  IF (BYTELM.GT.1) THEN
         LL = 1
         MM = BYTELM
         DO 5720, L=1,NOELEM
            DO 5710, IOFF=LL,MM,80
               M = IOFF + 79
               IF (M.GT.MM) M = MM
               OUTPUT(1:) = CVALS(IOFF:M)//' '
               CALL STTPUT(OUTPUT,STAT)
5710        CONTINUE
            LL = LL + BYTELM
            MM = MM + BYTELM
5720     CONTINUE
      ELSE
C 
         M = 1                            !chop up in pieces of 80 chars
5730     MM = M + 79
         IF (MM.GE.NOELEM) THEN
            KCASE = 0                     !indicate that we reached the end
            MM = NOELEM
         ELSE
            KCASE = 1
         ENDIF
C
C  look for \n character in string
         LL = MM - M + 1
         DO 5740, N=1,LL
            L = M + N - 1
            IF (CVALS(L:L).EQ.LF) THEN
               MM = L
               KCASE = 1
               IF (N.EQ.1) THEN
                  GOTO 5760
               ELSE
                  OUTPUT(1:) = CVALS(M:L-1)//' '
                  GOTO 5750
               ENDIF
            ENDIF
5740     CONTINUE
         OUTPUT(1:) = CVALS(M:MM)//' '
5750     CALL STTPUT(OUTPUT,STAT)
5760     IF (KCASE.EQ.1) THEN
            M = MM + 1                     !move to after current end
            IF (M.LE.NOELEM) GOTO 5730
         ENDIF
      ENDIF
      GOTO 7700
C
5790  OUTPUT(1:) = DISCR(1:17)//CVALS(1:NOELEM)//' '
      CALL STTPUT(OUTPUT,STAT)
      GOTO 7700
C
5800  DO 5810, M=1,NOELEM,3
         MM = MIN(NOELEM,M+2)
         WRITE(OUTPUT,20003) (DVALS(L),L=M,MM)
         CALL STTPUT(OUTPUT,STAT)
5810  CONTINUE
      GOTO 7700
C
5850  WRITE(OUTPUT,20004) (DVALS(L),L=1,NOELEM)
      LL = NOELEM*24
      CBUF(1:) = DISCR(1:17)//OUTPUT(1:LL)//' '
      CALL STTPUT(CBUF,STAT)
      GOTO 7700
C 
5900  DO 5910, M=1,NOELEM,8
         MM = MIN(NOELEM,M+7)
         WRITE(OUTPUT,10002) (IVALS(L),L=M,MM)
         CALL STTPUT(OUTPUT,STAT)
5910  CONTINUE
      GOTO 7700
C
5950  WRITE(OUTPUT,10002) (IVALS(L),L=1,NOELEM)
      LL = NOELEM*10
      CBUF(1:) = DISCR(1:17)//OUTPUT(1:LL)//' '
      CALL STTPUT(CBUF,STAT)
      GOTO 7700
C 
7700  IF (XLONG.GT.0) THEN
         EL1 = EL1 + 65535
         IF (XLONG.LE.65535) NOELEM = XLONG
         XLONG = XLONG - 65535
         DISCR(DSCLEN+1:) = '  '             !remove ':' again
         GOTO 700
      ENDIF
C
C  increment counter + loop if there are more descriptors
C 
8000  DISCR(1:) = ' '
         NDI = NDI + 1
8080     IF (NDI.LT.DSCNO(1)) THEN
            DIROFF = DIROFF + 30
            IF (DIRBUF(DIROFF+15:DIROFF+15) .EQ. 'H') THEN
               DSCNO(1) = DSCNO(1) - 1
               GOTO 8080
            ELSE
               DISCR(1:) = DIRBUF(DIROFF:DIROFF+14)//' '
               CALL STDFND(IMNO,DISCR,DSCTYP,NOELEM,BYTELM,STAT)
               GOTO 500                      !display next descriptor
            ENDIF
         ENDIF
C
C
9000  IF (OPTIO.EQ.0) THEN                   !single descriptor
         IF (IJK(1).EQ.1) THEN
            IJK(3) = NOELEM
            IJK(4) = BYTELM
            IJK(5) = DSCNO(2)
         ENDIF
         CALL STKWRI('OUTPUTI',IJK,1,5,UNIT,STAT) 
      ELSE   
         IF (OPTIO.EQ.1) THEN                !all descr's
            DSCNO(1) = DSCNO(1) - 1          !avoid descr. directory itself
         ELSE 
            DSCNO(1) = NPT
         ENDIF
         WRITE(OUTPUT,40000) DSCNO(1)
         CALL STTPUT(OUTPUT,STAT)
         CALL STKWRI('OUTPUTI',DSCNO,1,1,UNIT,STAT) 
      ENDIF
C
C  That's it folks ...
      RETURN
C
C  formats
10000 FORMAT('Problems reading descriptor: ',A)
10001 FORMAT('name: ',A,' ( ')
10002 FORMAT(8I10)
10004 FORMAT('type: ',A,'  no. of elements:',I8)
10005 FORMAT('type: ',A,'  no. of elements:',I5)
20002 FORMAT(5G15.7)
20003 FORMAT(3G24.14)
20004 FORMAT(2G24.14)
30000 FORMAT(I4)
33000 FORMAT('Descriptor directory: total length =',I8,
     +       '   => no. of decriptors =',I6)   
40000 FORMAT('total no. of descriptors:',I6)
      END

      SUBROUTINE ODSCDL(IMNO,INDSC,DELCNT)
C
C+++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine ODSCDL                    990114
C  K. Banse                             ESO - Garching
C
C.KEYWORDS
C  descriptors
C
C.PURPOSE
C  delete descriptors matching a pattern
C
C.ALGORITHM
C  read all existing descriptors + delete if pattern match
C
C.INPUT/OUTPUT
C  call as DSCDEL(IMNO,INDSC,DELCNT)
C
C input:
C  IMNO:      I*4         frame no. of data frame
C  INDSC:     char.exp.   pattern of descriptors to be deleted
C output:
C  DELCNT:    I*4         no. of deleted descriptors
C
C-------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      IMNO,DELCNT
      INTEGER      DSCNO,IAV,NPOS
      INTEGER      NDI,NDLIM,STAT,NOELEM
      INTEGER      DIROFF,UNIT(1),NULLO
C 
      CHARACTER*(*)  INDSC
      CHARACTER      DIRBUF*32762
      CHARACTER      DISCR*80
C 
      NPOS = 0
      DISCR(1:) = ' '
      CALL UPCAS(INDSC,DISCR)
C 
      CALL PATTST(1,DISCR,STAT)                !store the pattern(s)
      DELCNT = 0
C
         NDI = 0
         NDLIM = 32760    !old descr format, only for max. 32760 descr...
         CALL STDRDC(IMNO,'DIRECTORY.MIDAS',1,1,NDLIM,NOELEM,
     +               DIRBUF,UNIT,NULLO,STAT)
         IAV = NOELEM/30
         DSCNO = IAV                           !max available descrs
         DIROFF = 1
      GOTO 8000
C
C  prepare loop through descr. list
C
500   CALL PATTST(2,DISCR,STAT)
      IF (STAT.NE.0) THEN    
         DELCNT = DELCNT + 1                   !matching descr. found
         CALL STDDEL(IMNO,DISCR,STAT)
         NPOS = NPOS - 1                       !it's updated internally
      ENDIF
C 
C  increment counter + loop if there are more descriptors
C
8000     NDI = NDI + 1
8080     IF (NDI.LT.DSCNO) THEN
            DIROFF = DIROFF + 30
            IF (DIRBUF(DIROFF+15:DIROFF+15) .EQ. 'H') THEN
               DSCNO = DSCNO - 1
               GOTO 8080
            ELSE
               DISCR(1:) = DIRBUF(DIROFF:DIROFF+14)//' '
               GOTO 500                      !check next descriptor
            ENDIF
         ENDIF
C
C  That's it folks ...
      RETURN
      END

C @(#)serch.for	19.1 (ES0-DMD) 02/25/03 13:30:48
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++              
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C.LANGUAGE:       F77+ESOext                                                    
C.AUTHOR:         P.Stetsan                                                     
C.IDENTIFICATION: SERCH                                                         
C.KEYWORDS:       photometry,astrometry                                         
C.PURPOSE:        Subroutine to search for a star from a marginal distribution. 
C.ALGORITHM;      see Stetson, P.B.,  1979   Astron.  J.,  84  1149             
C.INPUT/OUPUT:    ->  KRX     marginal data REAL*8                              
C                 ->  NX      dimension of KRX                                  
C                 ->  KK      number of points ignored at each end of KRX       
C                             ( greater than or equal to 2)                     
C                 <-  XO      output estimate of the image centre               
C                 <-  SX      output estimate of the image with                 
C                 <-> JX      Low-side local minimum (stepped in by one)        
C                 <-> LX      High-side local minimum (stepped in by one)       
C                 ->  KDRX    work array dimension as KRX, REAL*8               
C                 ->  ICROWD  0  if no other star is detected in the field      
C                             -1  if a brighter star is found on the low side   
C                             +1  if a brighter star is found on the high side  
C.VERSION:    8212??   A.P. Stetson    Creation                                 
C.VERSION:    ??????   H.Waldthausen   VAX-implementation                       
C.VERSION:    871123   Rein H. Warmels ESO-FORTRAN Conversion                   
C -------------------------------------------------------------------           
      SUBROUTINE SERCH(KRX,NX,KK,XO,SX,JX,LX,KDRX,ICROWD)                       
C                                                                               
      IMPLICIT         NONE
      DOUBLE PRECISION KRX(1)
      INTEGER          NX
      INTEGER          KK
      REAL             XO
      REAL             SX
      INTEGER          JX
      INTEGER          LX
      DOUBLE PRECISION KDRX(1)                           
      INTEGER          ICROWD
C
      INTEGER          I, IBEG, IEND
      INTEGER          IMIN, IMAX
      INTEGER          J
      INTEGER          L
      INTEGER          M
      INTEGER          N
C    
      DOUBLE PRECISION KDRMX                           
      DOUBLE PRECISION KDRMN                           
      DOUBLE PRECISION KKS                           
C                                                                               
      ICROWD = 0                                                                
      IBEG   = KK + 1                                                           
      IEND   = NX - KK                                                          
      N      = NX - 2                                                           
      KDRMX  = 0                                                                
      KDRMN  = 0                                                                
C                                                                               
C *** find maximum and minimum derivative of KRX                                
C                                                                               
      DO 10 I = IBEG,IEND                                                       
         KKS    = KRX(I+1) - KRX(I-1)                                           
         KDRX(I) = KRX(I+2) - KRX(I-2) + KKS + KKS                              
         IF (KDRX(I).GE.KDRMX) THEN                                             
            KDRMX  = KDRX(I)                                                    
            IMAX   = I                                                          
         END IF                                                                 
                                                                                
         IF (KDRX(I).LE.KDRMN) THEN                                             
            KDRMN  = KDRX(I)                                                    
            IMIN   = I                                                          
         END IF                                                                 
                                                                                
   10 CONTINUE                                                                  
C                                                                               
C *** crowded ?                                                                 
C     bright source to left, compute right a new minima = KDRMN                 
                                                                                
      IF (IMIN.LE.IMAX) THEN                                                    
         IF ((NX-IMAX).GE. (IMIN-1)) THEN                                       
            ICROWD = -1                                                         
            KDRMN  = KDRMX                                                      
            J      = IMAX + 1                                                   
            DO 20 I = J,IEND                                                    
                IF (KDRX(I).LE.KDRMN) THEN                                      
                   KDRMN  = KDRX(I)                                             
                   IMIN   = I                                                   
                END IF                                                          
   20       CONTINUE                                                            
C                                                                               
C *** brigt source to the right, compute left a new maxima = KDRMX              
C                                                                               
         ELSE                                                                   
            ICROWD = 1                                                          
            KDRMX  = KDRMN                                                      
            J      = IMIN - 1                                                   
            DO 30 I = IBEG,J                                                    
               IF (KDRX(I).GE.KDRMX) THEN                                       
                  KDRMX  = KDRX(I)                                              
                  IMAX   = I                                                    
               END IF                                                           
   30       CONTINUE                                                            
         END IF                                                                 
      END IF                                                                    
C                                                                               
C *** compute estimates of image centre and width                               
C                                                                               
      KKS    = 0                                                                
      SX     = IMIN - IMAX                                                      
      DO 40 I = IMAX,IMIN                                                       
         KKS    = KKS + KDRX(I)                                                 
   40 CONTINUE                                                                  
C                                                                               
      XO     = 0.5* (IMAX+IMIN) + KKS*SX/ ((SX+1.0)* (KDRMX-KDRMN))             
      SX     = 0.5*SX                                                           
      J      = IFIX(XO+0.5)                                                     
C                                                                               
C *** find low- (left-) side local minimum                                      
      L      = J - 2                                                            
      JX     = 1                                                                
   50 L      = L - 1                                                            
C                                                                               
      GO TO (100,90,80,70,60),L                                                 
   60 IF (KRX(L).GT.KRX(L-4)) GO TO 50                                          
   70 IF (KRX(L).GT.KRX(L-3)) GO TO 50                                          
   80 IF (KRX(L).GT.KRX(L-2)) GO TO 50                                          
   90 IF (KRX(L).GT.KRX(L-1)) GO TO 50                                          
      JX     = L + 1                                                            
C                                                                               
C *** find high- (right-) side local minimum\                                   
C                                                                               
  100 L      = J + 2                                                            
      LX     = NX                                                               
      M      = NX + 1                                                           
  110 L      = L + 1                                                            
C                                                                               
      GO TO (160,150,140,130,120),M - L                                         
  120 IF (KRX(L).GT.KRX(L+4)) GO TO 110                                         
  130 IF (KRX(L).GT.KRX(L+3)) GO TO 110                                         
  140 IF (KRX(L).GT.KRX(L+2)) GO TO 110                                         
  150 IF (KRX(L).GT.KRX(L+1)) GO TO 110                                         
      LX     = L - 1                                                            
C                                                                               
C *** exit                                                                      
C                                                                               
  160 RETURN                                                                    
      END                                                                       

C @(#)fdummy.for	19.1 (ES0-DMD) 02/25/03 14:25:40
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM FDUMMY
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT        (c) 1988 European Southern Observatory
C.IDENTIFICATION   FDUMMY
C.LANGUAGE         ESO-FOR
C.AUTHOR           Preben Grosbol (ESO-IPG)
C.KEYWORDS         Create image
C.ENVIRONMENT      MIDAS
C.COMMENT          MIDAS command similar to the IHAP FDUMMY command
C.PURPOSE          Create a dummy frame with constant value.
C.VERSION          1.0    1988-Nov-18 : Creation      (PJG)
C---------------------------------------------------------------------
C
      IMPLICIT NONE
      INTEGER	MEM
      PARAMETER  (MEM=10240)
C
      CHARACTER*10      TYPE
      CHARACTER*16      UNIT
      CHARACTER*40      INAME
      CHARACTER*72      IDEN
      INTEGER           IAV,IERR,NA,N,I,ISIZE
      INTEGER           NPIX(16),KUNIT(4),INULL
      INTEGER           IDF,IOFF,NDIM(17)
      REAL              DATA(MEM),CONST
      REAL              PARM(32)
      DOUBLE PRECISION  START(16),STEP(16)
      REAL              CUTS(6),VMADD(1)
C
      COMMON /VMR/VMADD
C
      INCLUDE  'MID_REL_INCL:MIDAS_DEF.INC'
C
C     INITIATE MIDAS
C
      CALL STSPRO('FDUMMY ',IERR)
C
C     READ PARAMETERS
C
      CALL STKRDC('IN_A ',1,1,40,IAV,INAME,KUNIT,INULL,IERR)
      CALL STKRDC('INPUTC ',1,1,10,IAV,TYPE,KUNIT,INULL,IERR)
      CALL STKRDI('INPUTI ',1,17,IAV,NDIM,KUNIT,INULL,IERR)
      CALL STKRDR('PARM ',1,32,IAV,PARM,KUNIT,INULL,IERR)
      CALL STKRDR('INPUTR ',1,1,IAV,CONST,KUNIT,INULL,IERR)
      NA = MAX(1,MIN(16,NDIM(1)))
      ISIZE = 1
      DO 100, N = 1,NA
         NPIX(N) = MAX(1,NDIM(N+1))
         I = 2*(N-1) + 1
         START(N) = PARM(I)
         STEP(N)  = PARM(I+1)
         ISIZE = ISIZE * NPIX(N)
  100 CONTINUE
C
C     CREATE FRAME AND WRITE STANDARD DESCRIPTORS
C
      CALL STFCRE(INAME,D_R4_FORMAT,F_O_MODE,1,ISIZE,IDF,IERR)
C
      IDEN = 'TEST IMAGE'
      UNIT = ' '
      CALL STDWRC(IDF,'IDENT ',1,IDEN,1,72,KUNIT,IERR)
      CALL STDWRI(IDF,'NAXIS ',NA,1,1,KUNIT,IERR)
      CALL STDWRI(IDF,'NPIX ',NPIX,1,NA,KUNIT,IERR)
      CALL STDWRD(IDF,'START ',START,1,NA,KUNIT,IERR)
      CALL STDWRD(IDF,'STEP ',STEP,1,NA,KUNIT,IERR)
      CALL STDWRC(IDF,'CUNIT ',16,UNIT,1,1,KUNIT,IERR)
      DO 200, N = 1,NA
         CALL STDWRC(IDF,'CUNIT ',16,UNIT,N+1,1,KUNIT,IERR)
  200 CONTINUE
C
C     INITIATE VARIABLES AND MEMORY
C
      IOFF = 1
      DO 300, N = 1,6
         CUTS(N) = CONST
  300 CONTINUE
      DO 400, N = 1,MEM
         DATA(N) = CONST
  400 CONTINUE
C
C     GO THROUGH FRAME BUFFER BY BUFFER
C
 1000 N = MIN( MEM, ISIZE-IOFF+1)
      IF (N.LE.0) GOTO 2000
      CALL STFPUT(IDF,IOFF,N,DATA,IERR)
      IOFF = IOFF + N
      GOTO 1000
C
C     FINISHED - EXIT
C
 2000 CONTINUE
      CALL STDWRR(IDF,'LHCUTS ',CUTS,1,6,KUNIT,IERR)
90000 CALL STFCLO(IDF,IERR)
      CALL STSEPI(IERR)
      END

C @(#)plansubs.for	19.1 (ES0-DMD) 02/25/03 13:28:47
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C  @(#)plansubs.for	4.5  (ESO-IPG)  3/26/93  15:40:54
      BLOCK DATA
C					Copyright (C) by Andrew T. Young 1990
C                     MAR.5,1987
C
C
      IMPLICIT NONE
      INTEGER  KB, KTV, K2, K3, K4, K7, K8, K9
      INTEGER  NAM1,NAM2,NGRPS,MURAT,MURAA,MUDEC
      REAL RAHRS,RAMIN,RASEC,DEDEG,DEMIN,DESEC,EPOCH,SIGNAL,TINT
      REAL CVARS,FMM,DD,YY,YEAR,DAY,UTHRS,UTMIN,UTSEC,CLKERR
      REAL STHRS,STMIN,STSEC,ZTHRS,ZTMIN,ZTSEC,VSPARE
C
C   F I L E S :
C   -----------
C
C *** LENGTH OF FILE NAMES MAY BE SYSTEM-DEPENDENT.
C     FULL SET FOR SUBROUTINE COMPATIBILITY.
      COMMON /FILNOS/ KB, KTV, K2, K3, K4, K7, K8, K9
C *** UNITS MAY BE SYSTEM-DEPENDENT.
C
C
      INCLUDE 'MID_REL_INCL:mbands.inc'
C     PARAMETER (MBANDS=9)
C
C  Declare integer parameters for stupid compilers:
C
      INTEGER MGAINS,MG2,MA,MCAT,MN,MV,MGRPS,MAREST,MNREST
C
C  PARAMETERS FOR RDLIST/RDBLOK.
C
      PARAMETER (MGAINS=4, MG2=2*MGAINS)
      PARAMETER (MA=21+MG2+5)
      PARAMETER (MCAT=12+2*MBANDS,MN=MCAT+30, MV=MA+MN, MGRPS=8)
      PARAMETER (MAREST=MA-21-MG2, MNREST=MN-MCAT-15)
C           (21 & 15 ARE LAST ASSIGNED SLOTS IN AVAR & VALUES)
C
C  MA = MAX. ALPHABETIC (CHARACTER) VARIABLES,  AVAR  IN /NAMES/
C  MN = MAX. NUMERIC VARIABLES,                 VAR   IN /VALUES/
C  MV = MAX. VARIABLE NAMES,                    NAMES IN /NAMES/
C
C   COMMONS FOR RDLIST/RDBLOK.  NOTE RENAMING OF ELEMENTS OF AVAR.
C
C   CHARACTER VARIABLES THAT REPLACE AVAR(MA).
C     CHARACTER NAMES(MV)*6,TITLE*80, AVAR(MA)*20  <--REPLACED BY LIST.
C
      CHARACTER NAMES(MV)*6,TITLE*80
      CHARACTER*32 STAR
      CHARACTER*20 RASTR,DESTR,BAYER,CONSTL,FLAMST,BSHR,HD,DM,
     1 SPECT,DESGN,DATSTR,MONTH,REM1,REM2,STSTR,ZTSTR,UTSTR,
     2 FILTCD,STARCD,STRSKY,ASPARE(MAREST),GANCDN(MGAINS),DIMCDN(MGAINS)
C
C     COMMON /NAMES/NAMES,TITLE, AVAR
      COMMON /NAMES/NAMES,TITLE, RASTR,DESTR,STAR,BAYER,CONSTL,FLAMST,
     1 BSHR,HD,DM,SPECT,DESGN,DATSTR,MONTH,REM1,REM2,STSTR,ZTSTR,UTSTR,
     2 FILTCD,STARCD,STRSKY,ASPARE,GANCDN,DIMCDN
C
C   REAL VARIABLES THAT REPLACE VAR(MN):
C     COMMON /VALUES/ NAM1(MGRPS),NAM2(MGRPS),NGRPS,VAR(MN)
C
      COMMON /VALUES/ NAM1(MGRPS),NAM2(MGRPS),NGRPS,RAHRS,RAMIN,RASEC,
     1 DEDEG,DEMIN,DESEC,EPOCH,MURAT,MURAA,MUDEC,SIGNAL,TINT,
     2 CVARS(2,MBANDS),FMM,DD,YY,YEAR,DAY,
     3 UTHRS,UTMIN,UTSEC,CLKERR,STHRS,STMIN,STSEC,
     4 ZTHRS,ZTMIN,ZTSEC,VSPARE(MNREST)
C
      CHARACTER ASSMPS(8)*40,ASSUME(8)*40
      COMMON /ASSUME/ ASSMPS,ASSUME
c
C   D A T A :
C   =========
C
C *** UNITS:
      DATA KB/5/, KTV/6/, K2/2/, K3/3/, K4/4/, K7/7/, K8/8/, K9/9/
C
C
C  NUMERICAL VARIABLE NAMES ...
C
C       NAMX() =    1       2       3       4       5       6       7
      DATA NAMES/'RAHRS','RAMIN','RASEC','DEDEG','DEMIN','DESEC','EPOCH'
C
C         8       9      10      11      12
     1,'MURAT','MURAA','MUDEC','SIGNAL','TINT',
C
C        13 TO MCAT....        +1   +2   +3    +4    +5
     2  MBANDS*' ',MBANDS*' ','MM','DD','YY','YEAR','DAY',
C
C   MCAT + 6      +7      +8      +9      +10     +11    +12
     3 'UTHRS','UTMIN','UTSEC','CLKERR','STHRS','STMIN','STSEC',
C
C   MCAT+13      +14     +15     +16  TO  MCAT +30
     4 'ZTHRS','ZTMIN','ZTSEC',     MNREST*' ',
C
C  CHARACTER VARIABLE NAMES...
C
C       MN+1    MN+2    MN+3   MN+4     MN+5     MN+6    MN+7  MN+8 MN+9
     5 'RASTR','DESTR','STAR','BAYER','CONSTL','FLAMST','BSHR','HD','DM'
C
C        MN+10   MN+11   MN+12    MN+13  MN+14  MN+15   MN+16   MN+17
     6 ,'SPECT','DESGN','DATSTR','MONTH','REM1','REM2','STSTR','ZTSTR',
C
C        MN+18   MN+19    MN+20    MN+21   MN+22  TO
     7  'UTSTR','FILTCD','STARCD','STRSKY',MGAINS*' ',MGAINS*' ',
C
C        MN+
     8  MAREST*' '/
C
C
      DATA ASSUME/'NEGLECT RED-LEAK CORRECTIONS.',
     2 '           DEAD TIME UNKNOWN.',
C       0987654321098765432112345678901234567890
     3 ' ASSUME dead time will be known to 10%.',
     4 ' ',' ',' ',' ',' '/
      END
      SUBROUTINE FINDPM(STRING,VALUE,SVAL)
C
C  READ DATA LIKE:  VALUE +/- SVAL          (02 JAN.'87)
C
      IMPLICIT NONE
C
      REAL VALUE,SVAL
      INTEGER IPM
C
      CHARACTER STRING*(*),FMT*9,CARD*20,A
C
      CARD=STRING
    1 IPM=INDEX(CARD,'+/-')
      IF(IPM.EQ.0) GO TO 3
      FMT='(BN,F9.0)'
      IF(IPM.GT.9) GO TO 2
      WRITE(A,'(I1)')IPM-1
      FMT(6:6)=A
    2 READ(CARD(:IPM-1),FMT,ERR=9)VALUE
      READ(CARD(IPM+3:),'(BN,F9.0)',ERR=9)SVAL
      RETURN
C
    3 READ(CARD,'(BN,F9.0)',ERR=9)VALUE
      CALL QF('+/- what Std. Error?',SVAL)
      RETURN
C
    9 CALL TV('BAD DATA; Please re-enter value:')
      CALL ASK('?',CARD)
      GO TO 1
      END
      SUBROUTINE STUTZR(T)
C
C  SETS STUTZ IN RADIANS FOR T IN JULIAN CENTURIES FROM 2000.
C
C
      IMPLICIT NONE
C
      DOUBLE PRECISION DSTUTZ
C
      REAL T, SINPHI, COSPHI, ELONG, ELROT, UTROT, STUTZ, TWOPI, ST2UT, 
     1         TNOON1, TNOON2, PI, DEGRAD, ALAT
C
      COMMON /SPHERE/ SINPHI,COSPHI,ELONG,ELROT,UTROT,STUTZ,TWOPI,ST2UT,
     1 TNOON1,TNOON2,PI,DEGRAD,ALAT
      SAVE /SPHERE/
C
      DSTUTZ=(24110.54841D0+T*(8640184.812866D0+T*(.093104-T*6.21E-6)))
     1 /86400.
      STUTZ=DSTUTZ-INT(DSTUTZ)
      IF(STUTZ.LT.0.)STUTZ=STUTZ+1.
      STUTZ=STUTZ*TWOPI
      RETURN
      END
      SUBROUTINE SUN(DAYN)
C
C  DAYN IS DAYS FROM J2000.0 -- SEE P. C24 OF 1984 A.A.
C  GENERATES SOLAR POSITION (APPROX.) -- CERTIFIED BY ATY, 18 MARCH'84.
C
C
      IMPLICIT NONE
C
      REAL DAYN, COSOB, SINOB, RASUN, DESUN, HASUN, SOLONG, ELMOON, 
     1         BMOON, SINPHI, COSPHI, ELONG, ELROT, UTROT, STUTZ, TWOPI, 
     2         ST2UT, TNOON1, TNOON2, PI, DEGRAD, ALAT, G
C
C   COMMONS FOR SUN.
C
      COMMON /CSUN/ COSOB,SINOB,RASUN,DESUN,HASUN,SOLONG,ELMOON,BMOON
      COMMON /SPHERE/ SINPHI,COSPHI,ELONG,ELROT,UTROT,STUTZ,TWOPI,ST2UT,
     1 TNOON1,TNOON2,PI,DEGRAD,ALAT
C
      SAVE /SPHERE/, /CSUN/
C
C
      G=(357.528+0.9856003*DAYN)*DEGRAD
      SOLONG=(280.46+0.9856474*DAYN+1.915*SIN(G)+.02*SIN(G+G))*DEGRAD
      RASUN=ATAN(COSOB*TAN(SOLONG))
      IF(RASUN.LT.0.)RASUN=RASUN+TWOPI
      IF(ABS(RASUN-STUTZ).GT.3.0 .AND. ABS(RASUN-STUTZ).LT.3.5)GO TO 3
      IF(RASUN.LT.PI)THEN
       RASUN=RASUN+PI
      ELSE
       RASUN=RASUN-PI
      END IF
  3   DESUN=ASIN(SINOB*SIN(SOLONG))
      RETURN
      END
      SUBROUTINE UTSUN(DAYN,SALTS,I,*)
C
C  CONVERTS SALTS(I) TO UTROT AND HASUN ON DAYN.     9 FEB.'85
C   ALT.RETURN IF SUN DOES NOT REACH SALTS(I).
C
C
      IMPLICIT NONE
C
      REAL DAYN, SALTS, COSOB, SINOB, RASUN, DESUN, HASUN, SOLONG, 
     1     ELMOON, BMOON, SINPHI, COSPHI, ELONG, ELROT, UTROT, STUTZ, 
     2     TWOPI, ST2UT, TNOON1, TNOON2, PI, DEGRAD, ALAT, COSHA, UT
      INTEGER I,J
C
      COMMON /CSUN/ COSOB,SINOB,RASUN,DESUN,HASUN,SOLONG,ELMOON,BMOON
      COMMON /SPHERE/ SINPHI,COSPHI,ELONG,ELROT,UTROT,STUTZ,TWOPI,ST2UT,
     1 TNOON1,TNOON2,PI,DEGRAD,ALAT
      INTEGER MSG
      PARAMETER (MSG=14)
C
      SAVE /SPHERE/, /CSUN/
C
      DIMENSION SALTS(MSG)
C
      UTROT=-ELROT
      DO 425 J=1,2
      CALL SUN(UTROT+DAYN)
      COSHA=(SALTS(I)-SIN(DESUN)*SINPHI)/(COSPHI*COS(DESUN))
      IF(COSHA.LT.-1.)RETURN 1
      HASUN=ACOS(COSHA)
      IF(I.GT.4)HASUN=TWOPI-HASUN
      UT=MOD(HASUN+RASUN-STUTZ-ELONG,TWOPI)*ST2UT
  425 UTROT=UT/TWOPI
      IF(UTROT+ELROT.GT.0.5) UTROT=UTROT-ST2UT
      IF(UTROT+ELROT.LT.-.5) UTROT=UTROT+ST2UT
      RETURN
      END
      SUBROUTINE MOON(T,TLST)
C
C  USE MOON LOW-PRECISION FORMULA, P.D46, AA 1985.
C  INPUT: T (JULIAN CENTURIES FROM B2000.0), LST (RADIANS).   10 FEB.'85
C  OUTPUT: RASUN, DESUN (VIA /CSUN/) ARE TOPOCENTRIC.
C
C
      IMPLICIT NONE
C
      REAL T, TLST, COSOB, SINOB, RASUN, DESUN, HASUN, SOLONG, ELMOON, 
     1       BMOON, SINPHI, COSPHI, ELONG, ELROT, UTROT, STUTZ, TWOPI, 
     2       ST2UT, TNOON1, TNOON2, PI, DEGRAD, ALAT, ARG1, ARG2, ARG3, 
     3       ARG4, PAR, R, COSB, SINB, CBSL, ELL, EMM, ENN, X, Y, Z
C
      COMMON /CSUN/ COSOB,SINOB,RASUN,DESUN,HASUN,SOLONG,ELMOON,BMOON
      COMMON /SPHERE/ SINPHI,COSPHI,ELONG,ELROT,UTROT,STUTZ,TWOPI,ST2UT,
     1 TNOON1,TNOON2,PI,DEGRAD,ALAT
C
      SAVE /SPHERE/, /CSUN/
C
      ARG1=2.354+8328.6912*T
      ARG2=4.5239-7214.0633*T
      ARG3=4.114+15542.7544*T
      ARG4=4.711+16657.3823*T
C   GEOCENTRIC ECLIPTIC COORDS.
      ELMOON=3.8104 + 8399.70915*T + .1098*SIN(ARG1) -.0222*SIN(ARG2)
     2 +.0115*SIN(ARG3) +.0037*SIN(ARG4)
     3 -.0033*SIN(6.24+628.302*T) -.0019*SIN(3.257+16866.9326*T)
      BMOON=.0895*SIN(1.628+8433.4664*T) +.0049*SIN(3.983+16762.1573*T)
     1 -.0049*SIN(5.555+104.7753*T) -.003*SIN(3.798-7109.288*T)
      PAR=.016595 + .000904*COS(ARG1) +.000166*COS(ARG2)
     2 +.000136*COS(ARG3) +.000049*COS(ARG4)
      R=1./SIN(PAR)
      COSB=COS(BMOON)
      SINB=SIN(BMOON)
      CBSL=COSB*SIN(ELMOON)
C   DIRECTION COSINES:
      ELL=COSB*COS(ELMOON)
      EMM=0.9175*CBSL-0.3978*SINB
      ENN=0.3978*CBSL+0.9175*SINB
C
C   TOPOCENTRIC REDUCTION.
      X=R*ELL-COSPHI*COS(TLST)
      Y=R*EMM-COSPHI*SIN(TLST)
      Z=R*ENN-SINPHI
      R=SQRT(X*X+Y*Y+Z*Z)
C   STORE RESULTS IN SUN SLOTS.
      RASUN=ATAN2(Y,X)
      DESUN=ASIN(Z/R)
      RETURN
      END
      SUBROUTINE UTMOON(T,SALTS,I,*)
C
C  CONVERTS SALTS(I) TO UTROT AND HASUN AT DAY T.
C   ALT.RETURN IF MOON DOES NOT REACH SALTS(I).     9 FEB.'85
C
C
      IMPLICIT NONE
C
      REAL T, SALTS, COSOB, SINOB, RASUN, DESUN, HASUN, SOLONG, ELMOON, 
     1         BMOON, SINPHI, COSPHI, ELONG, ELROT, UTROT, STUTZ, TWOPI, 
     2         ST2UT, TNOON1, TNOON2, PI, DEGRAD, ALAT, TLST, COSHA, UT
      INTEGER I,J
C
      COMMON /CSUN/ COSOB,SINOB,RASUN,DESUN,HASUN,SOLONG,ELMOON,BMOON
      COMMON /SPHERE/ SINPHI,COSPHI,ELONG,ELROT,UTROT,STUTZ,TWOPI,ST2UT,
     1 TNOON1,TNOON2,PI,DEGRAD,ALAT
      INTEGER MSG
      PARAMETER (MSG=14)
C
      SAVE /SPHERE/, /CSUN/
C
      DIMENSION SALTS(MSG)
      LOGICAL UP,DOWN
C
      UP=.FALSE.
      DOWN=.FALSE.
C   Start at local Midnight.
      TLST=STUTZ-ELONG
C     STUTZ was set by STUTZR.
      UTROT=-ELROT
      DO 425 J=1,4
      CALL MOON(T+UTROT/36525.,TLST)
C     MOON puts lunar coords. at TLST in RASUN & DESUN.
      COSHA=(SALTS(I)-SIN(DESUN)*SINPHI)/(COSPHI*COS(DESUN))
      IF(ABS(COSHA).GT.1.)RETURN 1
      HASUN=ACOS(COSHA)
C     East (rise) if I is odd, West (set) if even.
      IF(MOD(I,2).EQ.1)HASUN=-HASUN
      TLST=RASUN+HASUN
      UT=MOD(TLST-STUTZ-ELONG,TWOPI)*ST2UT
      UTROT=UT/TWOPI
C      TNOON1 and TNOON2 (-ELROT+/-.5 rotations) must be set by calling pgm.
       IF(UTROT.LT.TNOON1)THEN
         UTROT=UTROT+ST2UT
C    Prevent oscillations if no event in time window.
         IF(UP.AND.DOWN) RETURN1
         UP=.TRUE.
       ELSE IF(UTROT.GT.TNOON2)THEN
         UTROT=UTROT-ST2UT
         IF(UP.AND.DOWN) RETURN1
         DOWN=.TRUE.
       END IF
  425 CONTINUE
      RETURN
      END
      FUNCTION DEG2M1(DEG)
C
C  CONVERTS DECIMAL DEGREES TO DEG MIN.1
C
C $$$ CAUTION: USE ONLY WITH POSITIVE ARGUMENTS.  SEE DEG2MS FOR
C              CORRECT TREATMENT OF -00 ZONE.
C
C
      IMPLICIT NONE
C
      REAL DEG,FMIN
      INTEGER LDEG
C
      CHARACTER*8 DEG2M1,dum
C
      LDEG=DEG
      FMIN=ABS(DEG-(LDEG))*60.
      WRITE(dum,'(I3,F5.1)')LDEG,FMIN
      DEG2M1=dum
      RETURN
      END
      SUBROUTINE FILL(TLST,NOBJ,*)
C
C  FILLS EMPTY SLOTS IN TIMES().     26 JAN.'87
C
C
      IMPLICIT NONE
C
      REAL TLST, UTBGN, UTEND, DARKT, TIMES, SINPHI, COSPHI, ELONG, 
     1   ELROT, UTROT, STUTZ, TWOPI, ST2UT, TNOON1, TNOON2, PI, DEGRAD, 
     2   ALAT, UT
      INTEGER NOBJ, NOBJS, NT
C
      INCLUDE 'MID_REL_INCL:mstars.inc'
C     PARAMETER (MSTARS=1650)
      INTEGER MSET,MROOM,MSG,MTIM
      PARAMETER (MSET=MSTARS-100,MROOM=2,MSG=14,MTIM=MROOM*MSET+MSG)
      COMMON /CFILL/ UTBGN,UTEND,DARKT,TIMES(MTIM),NOBJS(MTIM),NT
      COMMON /SPHERE/ SINPHI,COSPHI,ELONG,ELROT,UTROT,STUTZ,TWOPI,ST2UT,
     1 TNOON1,TNOON2,PI,DEGRAD,ALAT
C
      SAVE /CFILL/,/SPHERE/
C
      UT=MOD(TLST-STUTZ-ELONG,TWOPI)*ST2UT
C
      UTROT=UT/TWOPI
      IF(UTROT+ELROT.GT.0.5) UTROT=UTROT-ST2UT
      IF(UTROT+ELROT.LT.-.5) UTROT=UTROT+ST2UT
C    WATCH FOR STD.STARS IN EXTENSIONS.
      IF ((UTBGN.LT.UTEND .AND. (UTROT.GT.UTEND.OR.UTROT.LT.UTBGN)) .OR.
     1 (UTBGN.GT.UTEND .AND. UTROT.GT.UTEND .AND. UTROT.LT.UTBGN))
     2 RETURN 1
      NT=NT+1
      TIMES(NT)=UTROT
      NOBJS(NT)=NOBJ
      RETURN
      END
      SUBROUTINE RTNCON(STRING,L)
C
C  PRINTS 'STRING' AND 'HIT RETURN TO CONTINUE'.
C
C
      IMPLICIT NONE
C
      INTEGER L, N, IUNIT, NULLS, ISTAT
C
      CHARACTER STRING*40,A, C80*79
C
C
      C80=STRING(:L)//'   (Hit RETURN to continue.)'
      CALL STKPRC(C80,'INPUTC',1,1,1,N,A,IUNIT,NULLS,ISTAT)
      RETURN
      END
      SUBROUTINE REHEAD(NDIG,DAT,CODEDS)
C
C  REWINDS FILES 7 & 9 AND RE-HEADS THEM.    (1 DEC. '84)
C
C
      IMPLICIT NONE
C
C     Note: this routine refers to K7 and K9.
      INTEGER NDIG, KB, KTV, K2, K3, K4, K7, K8, K9
C
      COMMON /FILNOS/ KB, KTV, K2, K3, K4, K7, K8, K9
      CHARACTER*30 DAT
      LOGICAL CODEDS
C
      REWIND K9
C     WRITE(K9,'(1H1)')
      IF(.NOT.CODEDS) RETURN
      REWIND K7
      WRITE(K7,3)DAT,7-NDIG,NDIG
  3   FORMAT('STAR IDENTIFICATION TABLE FOR ',A/'STARCD,STAR'/'(',I1,'X,
     1 A',I1,', 2X, A20)'/)
C  THIS GENERATES FILE-HEAD FORMAT TO MATCH DATA WRITTEN AT 370 IN PLAN.
      RETURN
      END
      SUBROUTINE SXB(NUNIT,MSG,NL)
C
C  WRITES NL (UP TO 9) LINES OF MSG, ON UNIT NUNIT.      AUG.16,1985
C
C
      IMPLICIT NONE
C
      INTEGER NUNIT, NL, I, J
C
      CHARACTER*40 MSG(NL),BLANK*1
      CHARACTER*79 PAGE(21)
      COMMON /SCREEN/ PAGE
C
      DATA BLANK/' '/
C
    1 FORMAT(15X,9('X'),28X,A15/11X,17('X'),24X,15('-')/9X,21('X'),8X/
     X9X,'XXXX',4X,5('X'),4X,4('X'),9X,A/9X,'XXX',6X,'XXX',6X,'XXX',8X/
     X10X,'XXX',4X,5('X'),4X,'XXX',10X,A/12X,7('X'),1X,7('X')/14X,'XXXX'
     X,3X,4('X'),14X,A/14X,11('X'),13X/15X,'X I I I X',15X,A/'   XXX',
     X9X,'XI I I IX',9X,'XXX  '/'   XXXX',9X,7('X'),9X,'XXXX   ',A/
     X2X,8('X'),19X,8('X')/1X,13('X'),11X,13('X'),1X,A/' XXX',6X,8('X'),
     X3X,8('X'),6X,'XXX'/14X,11('X'),14X,A/13X,13('X'),12X/'  XXX',4X,
     X8('X'),5X,8('X'),4X,'XXX  ',A/3X,10('X'),13X,10('X'),2X/4X,5('X'),
     X21X,5('X'),4X,A/4X,'XXXX',23X,'XXXX')
      IF (NUNIT.EQ.6)THEN
        WRITE(PAGE,1) 'D A N G E R  !!',(MSG(I),I=1,NL),(BLANK,J=1,9-NL)
        DO 5 I=1,21
    5   CALL TVN(PAGE(I))
      ELSE
        WRITE(NUNIT,1)'D A N G E R  !!',(MSG(I),I=1,NL),(BLANK,J=1,9-NL)
      END IF
      RETURN
      END
      SUBROUTINE MAGSET(BANDS)
C
C  ALTERS FAINTS.
C
C
      IMPLICIT NONE
C
      REAL COLORM, COLRIN, XINV, YINV, PHOMAG, FAINTS, BRITES, SZMAX, 
     1         SZMIN, EXTIN, SIGTOT, TINT1, TSUGG, XMAGS, DIMMAG
      INTEGER NBANDS, LENB, LENC, 
     1         KX, KY, NEEDH, NASSMP, NPASS, N, LINE, NB, I, NEW
C
      INCLUDE 'MID_REL_INCL:mbands.inc'
C     PARAMETER (MBANDS=9)
      COMMON /CMAGS1/ COLORM(MBANDS,MBANDS),COLRIN(MBANDS,MBANDS),
     1 XINV,YINV,NBANDS,LENB,LENC,KX,KY
      COMMON /CMAGS2/PHOMAG(MBANDS),FAINTS(MBANDS),BRITES(MBANDS),SZMAX,
     1 SZMIN,EXTIN(MBANDS),SIGTOT,TINT1,TSUGG
C
      COMMON /HELPS/ NEEDH,NASSMP
      CHARACTER ASSMPS(8)*40,ASSUME(8)*40
      COMMON /ASSUME/ ASSMPS,ASSUME
      CHARACTER*79 PAGE(21)
      COMMON /SCREEN/ PAGE
C
      SAVE /CMAGS1/,/CMAGS2/,/HELPS/, NPASS
C
      CHARACTER*8 BANDS(MBANDS),A
C
      DIMENSION XMAGS(MBANDS,5)
      LOGICAL CHANGE,SAME,  HELP
C
      DATA NPASS/0/
C
      SAME=.TRUE.
      DO 4 N=1,NBANDS
      XMAGS(N,1)=PHOMAG(N)-EXTIN(N)*SZMAX+10.*LOG10(SZMAX)
      XMAGS(N,2)=PHOMAG(N)-EXTIN(N)*SZMAX+7.5*LOG10(SZMAX)
      XMAGS(N,3)=PHOMAG(N)-EXTIN(N)*SZMIN+10.*LOG10(SZMIN)
      XMAGS(N,4)=PHOMAG(N)-EXTIN(N)*SZMIN+7.5*LOG10(SZMIN)
      XMAGS(N,5)=PHOMAG(N)-EXTIN(N)*SZMAX+2.5*LOG10(TSUGG/TINT1)
      IF(FAINTS(N).EQ.3.E33) FAINTS(N)=XMAGS(N,4)-1.5
    4 CONTINUE
C
         IF(NEEDH.GT.2+NPASS) THEN
      WRITE(PAGE,7)
    7 FORMAT(/4X,'PEPSYS suggests that extinction stars be limited only 
     Xby'/4X,'scintillation noise.  It offers a suitable faint limit for
     X'/4X,'each band.  You may decline any and propose another limit.'/
     X)
      DO 8 LINE=1,5
    8 CALL TVN(PAGE(LINE))
         END IF
      NPASS=NPASS+1
C
C     Changed to cater to brain-damaged f2c library:
   10 CALL BRAINDEAD(BANDS, XMAGS)
      NEW=4
C   new counts new lines on screen, to flag refresh.
      DO 30 NB=1,NBANDS
      NEW=NEW+3
      PAGE(1)= 'Change '//BANDS(NB)(:LENB)//' limit?'
      CALL ASK(PAGE(1),A)
      IF(A(:1).EQ.'N')GO TO 26
       IF(HELP(A))THEN
      CALL TV('Too complicated to explain on-line.')
      CALL TV('Please see User''s Guide for details.')
      WRITE(PAGE,7)
      DO 23 LINE=1,5
   23 CALL TVN(PAGE(LINE))
      GO TO 10
       END IF
c  get new limit.
      SAME=.FALSE.
      READ(A,'(F6.0)',ERR=24)FAINTS(NB)
      GOTO 25
   24 CALL QF('New limit?',FAINTS(NB))
      NEW=NEW+3
   25  IF(FAINTS(NB).GT.XMAGS(NB,5))THEN
      CALL TV('Photon noise exceeds error budget; limit will be used.')
      FAINTS(NB)=XMAGS(NB,5)
      NEW=NEW+2
       END IF
   26  IF(NEW.GE.24-NB .AND. NB.NE.NBANDS)THEN
C   REFRESH SCREEN.
      CALL BRAINDEAD(BANDS, XMAGS)
      NEW=4
       END IF
   30 CONTINUE
      IF(SAME) GO TO 99
C
      CALL BRAINDEAD(BANDS, XMAGS)
      CALL ASK('OK?',A)
      IF(A(:1).EQ.'N')GO TO 10
      GO TO 99
C
C
      ENTRY BRITEN(BANDS,CHANGE)
C
C  REVISE BRIGHT LIMITS.
C
      CALL ASK('Do you have an attenuator (e.g., neutral filter)?',A)
       IF(A(:1).EQ.'Y')THEN
      CHANGE=.TRUE.
      CALL QF('How many magnitudes of dimming?',DIMMAG)
      CALL TV('New BRIGHT limits:')
      DO 50 NB=1,NBANDS
      BRITES(NB)=BRITES(NB)-DIMMAG
      WRITE(PAGE,46)BRITES(NB),BANDS(NB)
   46 FORMAT(/3X,F5.1,' IN ',A6)
      DO 48 I=1,2
   48 CALL TVN(PAGE(I))
        IF(BRITES(NB).GT.FAINTS(NB))THEN
       CALL TV('Not enough dimming available.')
       CHANGE=.FALSE.
        END IF
   50 CONTINUE
       END IF
C   HERE IF NO DIMMER.
C
   99 RETURN
      END
      SUBROUTINE BRAINDEAD(BANDS, XMAGS)
C
C     Caters to brain-damaged f2c library.
C
      IMPLICIT NONE
C
      INCLUDE 'MID_REL_INCL:mbands.inc'
      REAL COLORM, COLRIN, XINV, YINV, PHOMAG, FAINTS, BRITES, SZMAX, 
     1         SZMIN, EXTIN, SIGTOT, TINT1, TSUGG, XMAGS
      INTEGER NBANDS, LENB, LENC, 
     1         KX, KY, NB, I
      COMMON /CMAGS1/ COLORM(MBANDS,MBANDS),COLRIN(MBANDS,MBANDS),
     1 XINV,YINV,NBANDS,LENB,LENC,KX,KY
      COMMON /CMAGS2/PHOMAG(MBANDS),FAINTS(MBANDS),BRITES(MBANDS),SZMAX,
     1 SZMIN,EXTIN(MBANDS),SIGTOT,TINT1,TSUGG
C
      CHARACTER*79 PAGE(21)
      COMMON /SCREEN/ PAGE
C
      CHARACTER*8 BANDS(MBANDS)
C
      DIMENSION XMAGS(MBANDS,5)
C
C
   10 WRITE(PAGE,11) SZMAX,SZMIN,TSUGG,SIGTOT*.5
   11 FORMAT(/6X,'SCINTILLATION = PHOTON NOISE   Photon Noise   Present'
     1/4X,'at',2('  secZ =',F5.2,1X),'  of',F4.0,'sec.int.   FAINT'/3X,
     22(7X,'between'),5X,'is',F5.3,' mag.at   limit')
      DO 12 I=1,4
   12 CALL TVN(PAGE(I))
C     Changed to cater to brain-damaged f2c library:
      DO 14 NB=1,NBANDS
      WRITE(PAGE,13) BANDS(NB)(:LENB),(XMAGS(NB,I),I=1,5),FAINTS(NB)
   13 FORMAT(1X,A6,2(F5.1,' &',F5.1,2X),F10.1,F12.1)
   14 CALL TVN(PAGE)
      RETURN
      END

C @(#)erf.for	19.1 (ES0-DMD) 02/25/03 13:17:30
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      DOUBLE PRECISION FUNCTION ERF(X)
C****************************************************************
C Error integral function
C
C ERF(x) = 1/sqrt(2*pi) * INTEGRAL [ exp(-0.5*u**2) du ]
C     from (-infinity) to x
C
C Reference: Ibbetson,D., 1963, Communications A.C.M. 6 (10), 616
C     1964, ibid. 7 (3), 148
C****************************************************************
C
C Authors: M. Rosa and O.-G. Richter, ESO Garching
C
      DOUBLE PRECISION Z,X,W,Y

      Z      = 0.0D0
      IF (X.EQ.0.0D0) GO TO 20
      Y      = 0.5D0*DABS(X)
      Z      = 1.0D0
      IF (Y.GE.3.0D0) GO TO 20
      IF (Y.GE.1.0D0) GO TO 10
      W      = Y*Y
      Z      = ((((((((0.000124818987*W-0.001075204047)*W+
     +         0.005198775019)*W-0.019198292004)*W+0.059054035642)*W-
     +         0.151968751364)*W+0.319152932694)*W-0.531923007300)*W+
     +         0.797884560593)*Y*2.0
      GO TO 20

   10 Y      = Y - 2.0D0
      Z      = (((((((((((((-0.000045255659*Y+0.000152529290)*Y-
     +         0.000019538132)*Y-0.000676904986)*Y+0.001390604284)*Y-
     +         0.000794620820)*Y-0.002034254874)*Y+0.006549791214)*Y-
     +         0.010557625006)*Y+0.011630447319)*Y-0.009279453341)*Y+
     +         0.005353579108)*Y-0.002141268741)*Y+0.000535310849)*Y +
     +         0.999936657524D0
   20 IF (X.GT.0.0D0) THEN
          ERF    = (Z+1.0D0)*0.5D0

      ELSE
          ERF    = (1.0D0-Z)*0.5D0
      END IF

      RETURN

      END

C @(#)tdhilist.for	19.1 (ES0-DMD) 02/25/03 14:11:17
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  12:12 - 15 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C    900219   KB, replace SX calls by ST calls
C
C
C.IDENTIFICATION        TDHILIST.FOR
C.KEYWORDS           TABLE, APPLICATIONS
C.ENVIRONMENT  MIDAS
C.PURPOSE
C  LIST HISTOGRAM
C
C
C------------------------------------------------------------------
      SUBROUTINE TDHLIS(N,X,IFR,TSTAT,LAB1,LAB2,LAB3,UNIT,STATUS)
      IMPLICIT NONE
      INTEGER N           !   IN : number of points
      REAL X(N)           !   IN : classes
      INTEGER IFR(N)      !   IN : counts
      REAL TSTAT(8)       !   IN : statistics
      CHARACTER*(*) LAB1  !   IN : label 1
      CHARACTER*(*) LAB2  !   IN : label 2
      CHARACTER*(*) LAB3  !   IN : label 3
      CHARACTER*(*) UNIT  !   OUT: units
      INTEGER STATUS      !   OUT: status
C
      INTEGER I1,I2,I
      CHARACTER*80 LINE0
      CHARACTER*80 LINE1,LINE2,LINE3,LINE4,LINE5
      CHARACTER*80 LINE6,LINE7,LINE8,LINE9,LINEA
C
      DATA LINE1/
     +     ' NO. OF DATA    :                                     '/
      DATA LINE2/
     +     ' MEAN VALUE     :                                     '/
      DATA LINE3/
     +     ' STD. DEVIATION :                                     '/
      DATA LINE4/
     +     ' MINIMUM VALUE  :                                     '/
      DATA LINE5/
     +     ' MAXIMUM VALUE  :                                     '/
      DATA LINE6/
     +     ' INTERVAL       :                                     '/
      DATA LINE7/
     +     '  UP  TO                            :                 '/
      DATA LINE8/
     +     '                 TO                 :                 '/
      DATA LINE9/
     +     '                      AND ON        :                 '/
C
      I1     = 1
      I2     = N - 1
C
C ... LIST DATA
C
      LINEA = LAB3
      CALL STTPUT(LINEA,STATUS)
      WRITE (LINE1(21:35),9000) TSTAT(2)
      CALL STTPUT(LINE1,STATUS)
      WRITE (LINE2(21:35),9000) TSTAT(3)
      CALL STTPUT(LINE2,STATUS)
      WRITE (LINE3(21:35),9000) TSTAT(4)
      CALL STTPUT(LINE3,STATUS)
      WRITE (LINE4(21:35),9000) TSTAT(5)
      CALL STTPUT(LINE4,STATUS)
      WRITE (LINE5(21:35),9000) TSTAT(6)
      CALL STTPUT(LINE5,STATUS)
      WRITE (LINE6(21:35),9000) X(2) - X(1)
      LINE0  = LINE6(1:37)//UNIT
      CALL STTPUT(LINE0,STATUS)
      LINE0  = LAB2//UNIT//LAB1
      CALL STTPUT(LINE0,STATUS)
      WRITE (LINE7(21:35),9000) X(I1)
      WRITE (LINE7(39:53),9010) IFR(I1)
      CALL STTPUT(LINE7,STATUS)
      DO 10 I = I1 + 1,I2
          WRITE (LINE8(2:16),9000) X(I-1)
          WRITE (LINE8(21:35),9000) X(I)
          WRITE (LINE8(39:53),9010) IFR(I)
          CALL STTPUT(LINE8,STATUS)
   10 CONTINUE
      WRITE (LINE9(2:16),9000) X(I2)
      WRITE (LINE9(39:53),9010) IFR(I2+1)
      CALL STTPUT(LINE9,STATUS)
      RETURN

 9000 FORMAT (G15.7)
 9010 FORMAT (I7)
      END

C @(#)lincol.for	19.1 (ES0-DMD) 02/25/03 14:01:07
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE LINCOL(A,NPIX,SIZE,B)
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine LINCOL            version 1.0      870109
C  K. Banse                        ESO - Garching
C
C.KEYWORDS
C  lines to columns
C
C.PURPOSE
C  transposition of a matrix around minor diagonal
C  that is, the lines of an image are changed to columns
C
C.ALGORITHM
C  the input + result image must be completely mapped into memory
C  in order to minimize paging, this transposition is done in pieces
C
C.INPUT/OUTPUT
C  call as   LINCOL(A,NPIX,SIZE,B)
C
C  input par:
C  A:         R*4 array      input image
C  NPIX:      I*4 array      no. of pixels per line, no. of lines  in A
C  SIZE:      I*4 array      size of chunk we work with in x,y
C
C  output par:
C  B:         R*4 array      output image
C
C -------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      NPIX(2),SIZE(2)
      INTEGER      NX,NY,N,K,M
      INTEGER      XDIM,YDIM
      INTEGER      XNO1,YNO1,NKK,YMULT,XMULT
      INTEGER      OFFA,OFFB,AUX1
C
      REAL         A(*),B(*)
C
C
      XDIM = NPIX(1)
      YDIM = NPIX(2)
      AUX1 = SIZE(2) - 1
      YMULT = SIZE(1) * YDIM
      XMULT = SIZE(2) * XDIM
C
C  loop through complete frame in chunks
C
      NKK = 0
      XNO1 = SIZE(1) - 1
      DO 800,NX=1,XDIM,SIZE(1)
         YNO1 = AUX1
         N = XDIM - NX
         IF (XNO1.GT.N) XNO1 = N
C
         M = NX
         DO 600,NY=1,YDIM,SIZE(2)
            N = YDIM - NY
            IF (YNO1.GT.N) YNO1 = N
C
C was       N = (NX-1)*YDIM + NY
C before    M = (NY-1)*XDIM + NX 
C 
            N = NKK + NY 
C
C  loop through pixels in input image
            DO 400,K=M,M+XNO1
               OFFA = K
C
               DO 200,OFFB=N,N+YNO1
                  B(OFFB) = A(OFFA)
                  OFFA = OFFA + XDIM
200            CONTINUE
C
               N = N + YDIM
400         CONTINUE
C 
            M = M + XMULT
600      CONTINUE
C 
         NKK = NKK + YMULT
800   CONTINUE
C
      RETURN
      END

      SUBROUTINE ROTM90(INTPOL,A,B,IMNI,IMNO,NPIX,STRIP)
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine ROTM90			version 1.0      920311
C  K. Banse				ESO - Garching
C    1.1	930902
C
C.KEYWORDS
C  rotation, transposition
C
C.PURPOSE
C  rotation by multiples of 90. degrees of 2-D frames
C
C.ALGORITHM
C  chunks of input + result frame are processed, so this routine works for
C  any size frames
C
C.INPUT/OUTPUT
C  call as   ROTM90(INTPOL,A,B,IMNI,IMNO,NPIX,STRIP)
C
C  input par:
C  INTPOL:	I*4		= -1, for transposing lines to columns
C				      (around minor diagonal)
C				   1, for 90 degrees counter clockwise
C				   2, for 180 degrees counter clockwise
C				   3, for 270 degrees counter clockwise
C				   4, for 360 degrees counter clockwise
C  A:		R*4 array	working buffer for input
C  B:		R*4 array	working buffer for output
C  IMNI:	I*4		file no. of input image
C  IMNO:	I*4		file no. of output image
C  NPIX:	I*4 array	x-, y-dim of input frame
C  STRIP:	I*4 array	chunk size for input + output frame
C
C.VERSIONS
C  1.1		fix 180 degree rotation for non-square files
C 
C -------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      INTPOL
      INTEGER      IMNI,IMNO,NPIX(2),STRIP(2)
      INTEGER      INDXA,INDXB,KY,KY1,KYY,ISTRIP,OSTRIP
      INTEGER      IOFFA,IOFFB,NN,DATIN,DATOUT
      INTEGER      HYI,HYO,INOFF,OUTOFF
      INTEGER      KOUT,IOUT,KSIZE,IAV,STAT
C
      REAL         A(*)                 !size = NPIX(1) * STRIP(1) (input)
      REAL         B(*)                 !size = NPIX(2) * STRIP(2) (output)
C
C  init
      ISTRIP = STRIP(1)
      OSTRIP = STRIP(2)
      IOUT = 1                          !x-start for input
C 
C  branch on INTPOL flag
      IF (INTPOL.LE.0) GOTO 8000
      GOTO (100,4000,6000,7000),INTPOL
C
C  handle 90. degrees
C  ------------------
C 
100   OUTOFF = 0                           !y-offset of output
C 
1100  HYI = NPIX(2)                        !high y-index of input
      INOFF = HYI - ISTRIP                 !y-offset of input
C 
      HYO = OUTOFF + OSTRIP                !high y-index of output
      IF (HYO.GT.NPIX(1)) HYO = NPIX(1)
      KYY = HYO - OUTOFF                   !no. of output lines
      KOUT = 1                             !x-start for output
C
1200  IF (INOFF.LT.0) INOFF = 0
      DATIN = (INOFF*NPIX(1)) + 1          !offset for input read
      KY = HYI - INOFF                     !no. of input lines
      KY1 = KY - 1
      KSIZE = KY * NPIX(1)
      CALL STFGET(IMNI,DATIN,KSIZE,IAV,A,STAT)
C
      IOFFA = KY1*NPIX(1) + IOUT
      IOFFB = KOUT
C 
      DO 2000, NN=1,KYY
         INDXA = IOFFA
C 
         DO 1500, INDXB=IOFFB,IOFFB+KY1
            B(INDXB) = A(INDXA)
            INDXA = INDXA - NPIX(1)
1500     CONTINUE
C 
         IOFFA = IOFFA + 1
         IOFFB = IOFFB + NPIX(2)
2000  CONTINUE
C 
C  we've done a KY * KYY piece - check further progress
      HYI = HYI - KY
      IF (HYI.GT.0) THEN
         KOUT = KOUT + KY
         INOFF = HYI - ISTRIP 
         GOTO 1200                       !get next y-strip of input frame
      ENDIF
C 
C  so HYI must be 0  - write output strip to disk
C 
      KSIZE = KYY * NPIX(2)
      DATOUT = (OUTOFF*NPIX(2)) + 1
      CALL STFPUT(IMNO,DATOUT,KSIZE,B,STAT)
      OUTOFF = OUTOFF + KYY
      IF (OUTOFF.LT.NPIX(1)) THEN
         IOUT = IOUT + KYY
         GOTO 1100                       !set up things for next output strip
      ENDIF
C 
      RETURN
C
C  handle 180. degrees
C  -------------------
C 
4000  INOFF = 0                              !y-offset for in/output
      HYO = NPIX(2)
      KYY = NPIX(1) - 1
C 
4100  HYI = INOFF + ISTRIP                   !high y-index of in/output
      IF (HYI.GT.NPIX(2)) HYI = NPIX(2)
      KY = HYI - INOFF 
      KY1 = KY - 1
      KSIZE = KY * NPIX(1) 
      DATIN = (INOFF*NPIX(1)) + 1            !disk pointer for in/output
      CALL STFGET(IMNI,DATIN,KSIZE,IAV,A,STAT)
      OUTOFF = HYO - KY 
C
      IOFFA = 1
      IOFFB = (KY1*NPIX(1)) + 1
C
      DO 4600, NN=1,KY
         INDXA = IOFFA + KYY
C
         DO 4500, INDXB=IOFFB,IOFFB+KYY
            B(INDXB) = A(INDXA)
            INDXA = INDXA - 1
4500     CONTINUE
C
         IOFFA = IOFFA + NPIX(1)
         IOFFB = IOFFB - NPIX(1)
4600  CONTINUE
C
C  we've done a KY strip 
      DATOUT = (OUTOFF*NPIX(1)) + 1
      CALL STFPUT(IMNO,DATOUT,KSIZE,B,STAT)
      INOFF = HYI 
      IF (INOFF.LT.NPIX(2)) THEN
         HYO = HYO - KY
         GOTO 4100
      ENDIF
C
      RETURN
C
C  handle 270. degrees
C  -------------------
C
6000  HYO = NPIX(1)                         !high y-index of output
C
6100  INOFF = 0                             !y-offset of input
      OUTOFF = HYO - OSTRIP                 !y-offset of output
      IF (OUTOFF.LT.0) OUTOFF = 0
      KYY = HYO - OUTOFF                    !no. of output lines
      KOUT = 1                              !x-start for output
C
6200  HYI = INOFF + ISTRIP                  !high y-index of input
      IF (HYI.GT.NPIX(2)) HYI = NPIX(2)
      DATIN = (INOFF*NPIX(1)) + 1           !offset for input read
      KY = HYI - INOFF                      !no. of input lines
      KY1 = KY - 1
      KSIZE = KY * NPIX(1)
      CALL STFGET(IMNI,DATIN,KSIZE,IAV,A,STAT)
C
      IOFFA = IOUT
      IOFFB = (KYY-1)*NPIX(2) + KOUT
C
      DO 6800, NN=1,KYY
         INDXA = IOFFA
C
         DO 6500, INDXB=IOFFB,IOFFB+KY1
            B(INDXB) = A(INDXA)
            INDXA = INDXA + NPIX(1)
6500     CONTINUE
C
         IOFFA = IOFFA + 1
         IOFFB = IOFFB - NPIX(2)
6800  CONTINUE
C
C  we've done a KY * KYY piece - check further progress
      INOFF = INOFF + KY
      IF (INOFF.LT.NPIX(2)) THEN
         KOUT = KOUT + KY
         GOTO 6200                       !get next y-strip of input frame
      ENDIF
C
C  so INOFF must be >= NPIX(2)  - write output strip to disk
C
      KSIZE = KYY * NPIX(2)
      DATOUT = (OUTOFF*NPIX(2)) + 1
      CALL STFPUT(IMNO,DATOUT,KSIZE,B,STAT)
      HYO = HYO - KYY
      IF (HYO.GT.0) THEN
         IOUT = IOUT + KYY
         GOTO 6100                       !set up things for next output strip
      ENDIF
C
      RETURN
C
C
C  handle 360. degrees (= simple copy...)
C  --------------------------------------
C
7000  CALL STTPUT('No rotation - file is just copied...',STAT)
      CALL COPYFX(A,IMNI,IMNO,NPIX,STRIP(1))
      RETURN
C
C  handle transposition of lines + columns
C  ---------------------------------------
C
8000  OUTOFF = 0                            !y-offset of output
C
8100  INOFF = 0                             !y-offset of input
      HYO = OUTOFF + OSTRIP                 !high y-index of output
      IF (HYO.GT.NPIX(1)) HYO = NPIX(1)
      KYY = HYO - OUTOFF                    !no. of output lines
      KOUT = 1                              !x-start for output
C
8200  HYI = INOFF + ISTRIP 
      IF (HYI.GT.NPIX(2)) HYI = NPIX(2)
      DATIN = (INOFF*NPIX(1)) + 1           !offset for input read
      KY = HYI - INOFF                      !no. of input lines
      KY1 = KY - 1
      KSIZE = KY * NPIX(1)
      CALL STFGET(IMNI,DATIN,KSIZE,IAV,A,STAT)
C
      IOFFA = IOUT
      IOFFB = KOUT
C
      DO 8800, NN=1,KYY
         INDXA = IOFFA
C
         DO 8500, INDXB=IOFFB,IOFFB+KY1
            B(INDXB) = A(INDXA)
            INDXA = INDXA + NPIX(1)
8500     CONTINUE
C
         IOFFA = IOFFA + 1
         IOFFB = IOFFB + NPIX(2)
8800  CONTINUE
C
C  we've done a KY * KYY piece - check further progress
      INOFF = INOFF + KY
      IF (INOFF.LT.NPIX(2)) THEN
         KOUT = KOUT + KY
         GOTO 8200                       !get next y-strip of input frame
      ENDIF
C
C  so INOFF must be >= NPIX(2)  - write output strip to disk
C
      KSIZE = KYY * NPIX(2)
      DATOUT = (OUTOFF*NPIX(2)) + 1
      CALL STFPUT(IMNO,DATOUT,KSIZE,B,STAT)
      OUTOFF = OUTOFF + KYY
      IF (OUTOFF.LT.NPIX(1)) THEN
         IOUT = IOUT + KYY
         GOTO 8100                        !set up things for next output strip
      ENDIF
C
      RETURN
      END

C @(#)necripp.for	19.1 (ESO-DMD) 02/25/03 14:20:25
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM ECHRIP
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C 
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  19:01 - 6 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: D.PONZ
C
C.IDENTIFICATION
C
C  ECHRIPP  version 1.5 840820
C           version 1.6 901009  P.Ballester   Option to freeze K,Alpha
C
C.KEYWORDS
C
C  ECHELLE, CASPEC, BLAZE FUNCTION
C
C.PURPOSE
C
C  COMPUTE THE ECHELLE CONSTANTS ALPHA AND K FOR EACH ECHELLE ORDER
C  (only if the flag is not set to FREEZE)
C
C.ALGORITHM
C
C  IN DEVELOPMENT ...
C
C.INPUT/OUTPUT
C
C   RIPPL/ECHELLE INPUT OUTPUT  LAMBDA_MIN,DELTA_LAMBDA,K0,A0 
C                   -- in overlapping region
C   RIPPL/ECHELLE INPUT OUTPUT  K0,A0   -- fit SINC SQ.
C
C.VERSION
C 
C 010706	last modif 
C 
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C 
      IMPLICIT NONE
C 
      INTEGER        MADRID
      INTEGER        I,ISTAT
      INTEGER        METHOD,NAXISA,OUTIMA,KUN,KNUL,INIMA
      INTEGER        NPIXA(2),NPTOT(100),NORDER(100)
C 
      INTEGER*8      IPNTRA,IPNTRB
C 
      DOUBLE PRECISION  WSTR(100),STEPA(2),STARTA(2)
      DOUBLE PRECISION  WDELTA,WINIT,K0,ALPHA0
C 
      REAL              CUT(4),XMIN,XMAX,PARS(4)
C 
      CHARACTER*8       TABLE
      CHARACTER*60      INFRA,OUTFRE
      CHARACTER         IDENTA*72,CUNITA*64,FREEZE*12
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C ... INITIALIZE SYSTEM
C
      CALL STSPRO('ECHRIPP')
      CALL STKRDC('P1',1,1,60,I,INFRA,KUN,KNUL,ISTAT)
      CALL STKRDC('P2',1,1,60,I,OUTFRE,KUN,KNUL,ISTAT)
      CALL CLNFRA(INFRA,INFRA,0)
      CALL CLNFRA(OUTFRE,OUTFRE,0)
      CALL STKRDR('INPUTR',1,4,I,PARS,KUN,KNUL,ISTAT)
      TABLE = 'riptab'
      CALL STKRDC ('P5',1,1,12,I,FREEZE,KUN,KNUL,ISTAT)
      IF (PARS(3).LT.1.0) THEN
          K0     = PARS(1)
          ALPHA0 = PARS(2)
          METHOD = 0
          CALL STTPUT(' Ripple correction. Method: SINC',ISTAT)          
      ELSE
          WINIT  = PARS(1)
          WDELTA = PARS(2)
          K0     = PARS(3)
          ALPHA0 = PARS(4)
          METHOD = 1
          CALL STTPUT(' Ripple correction. Method: OVER',ISTAT)          
      END IF
C
C ... MAP INPUT/OUTPUT FRAMES
C
      CALL STIGET(INFRA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     .            3,NAXISA,NPIXA,STARTA,STEPA,IDENTA,CUNITA,
     .            IPNTRA,INIMA,ISTAT)
      CALL STDRDR(INIMA,'LHCUTS',1,4,I,CUT,KUN,KNUL,ISTAT)
      CALL STDRDD(INIMA,'WSTART',1,NPIXA(2),I,WSTR,
     .            KUN,KNUL,ISTAT)
      CALL STDRDI(INIMA,'NPTOT',1,NPIXA(2),I,NPTOT,
     .            KUN,KNUL,ISTAT)
      CALL STDRDI(INIMA,'NORDER',1,NPIXA(2),I,NORDER,
     .            KUN,KNUL,ISTAT)
      CALL STIPUT(OUTFRE,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .            NAXISA,NPIXA,STARTA,STEPA,IDENTA,
     +            CUNITA,IPNTRB,OUTIMA,ISTAT)
      IF (METHOD.EQ.0) THEN
          CALL RIPPL0(NPIXA(1),NPIXA(2),MADRID(IPNTRA),MADRID(IPNTRB),
     +                 WSTR,STEPA(1),NPTOT,NORDER,K0,ALPHA0,XMIN,XMAX,
     +                 TABLE,FREEZE)

      ELSE
          CALL RIPPL1(NPIXA(1),NPIXA(2),MADRID(IPNTRA),MADRID(IPNTRB),
     +                 WSTR,STEPA(1),NPTOT,NORDER,WINIT,WDELTA,K0,
     +                 ALPHA0,XMIN,XMAX,TABLE,FREEZE)
          XMIN   = CUT(3)
          XMIN   = CUT(4)
      END IF
C
C ... WRITE PROCESS DESCRIPTORS
C
      CUT(1) = XMIN
      CUT(2) = XMAX
      CUT(3) = XMIN
      CUT(4) = XMAX
      CALL DSCUPT(INIMA,OUTIMA,' ',ISTAT)
      CALL STDWRR(OUTIMA,'LHCUTS',CUT,1,4,KUN,ISTAT)
      CALL STSEPI
      END

      SUBROUTINE RIPPL1(NX,NY,X,Y,WS,WSTEP,NP,NO,W1,DW,K0,A0,XMIN,XMAX,
     +                   TABLE,FZ)
C
C CORRECT FOR BLAZE EFFECT USING THE OVERLAPPING REGION
C
C INPUT ARGUMENTS
C NX MAXIMUM NUMBER OF SAMPLES PER ORDER
C NY NUMBER OF ORDERS
C X  INPUT IMAGE
C WS STARTING WAVELENGTH PER EACH ORDER
C WSTEP WAVELENGTH STEP
C NP NUMBER OF USEFUL SAMPLES PER ORDER
C NO SPECTRAL ORDER NUMBER
C W1 STARTING OFFSET PER ORDER TO DEFINE THE OVERLAPPING REGION
C DW INTERVAL OF THE OVERLAPPING REGION
C K0 INITIAL GUESS FOR THE CONSTANT K
C A0 INITIAL GUESS FOR ALPHA
C FZ FLAG TO FREEZE THE VALUES OF K and ALPHA
C
C OUTPUT ARGUMENTS
C Y    CORRECTED IMAGE
C XMIN MINIMUN AND
C XMAX MAXIMUM VALUES
C
      IMPLICIT NONE
C
      INTEGER          NX, NY
      INTEGER          NP(NY),NO(NY),IERR(2),ICOL(7), ISEQ
      INTEGER          I, TID, ISTAT, IORDER, I1, ILR, I2
      INTEGER          NN, NK
      REAL             X(NX,NY), Y(NX,NY)
      REAL             VAL(7), XMIN, XMAX
      DOUBLE PRECISION WS(NY), WSTEP, K0, A0
      DOUBLE PRECISION W1, DW, K(2), KM, A(2), AM
      CHARACTER*16     LABEL(7),UNIT(7),FORM
      CHARACTER*12     FZ
      CHARACTER*80     LINE
      CHARACTER*(*)    TABLE
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      DATA FORM/'G12.4'/
      DATA LABEL(1)/'ORDER'/,UNIT(1)/'UNITLESS'/
      DATA LABEL(2)/'K'/,UNIT(2)/'UNITLESS'/
      DATA LABEL(3)/'ALPHA'/,UNIT(3)/'UNITLESS'/
      DATA LABEL(4)/'KFIT'/,UNIT(4)/'UNITLESS'/
      DATA LABEL(5)/'AFIT'/,UNIT(5)/'UNITLESS'/
      DATA LABEL(6)/'YMAX'/,UNIT(6)/'FLUX'/
      DATA LABEL(7)/'STATUS'/,UNIT(7)/'UNITLESS'/

C
      ISEQ   = 0
      XMIN   = 1.E30
      XMAX   = -XMIN
C
C ... INITIALIZE TEMPORARY OUTPUT
C
      CALL TBTINI(TABLE,F_TRANS,F_O_MODE,8,NY,TID,ISTAT)
      DO 10 I = 1,6
          CALL TBCINI(TID,D_R4_FORMAT,1,FORM,UNIT(I),
     .                LABEL(I),ICOL(I),ISTAT)
   10 CONTINUE
C
C ... ITERATION ON ALL CONSECUTIVE PAIRS OF ORDERS
C
      CALL STTPUT(' ORDER NUMER  FITTED K ',ISTAT)
      CALL STTPUT(' ----------- ----------',ISTAT)
      DO 30 IORDER = 2,NY - 1

      IF (FZ(1:1).EQ.'F'.OR.FZ(1:1).EQ.'f') THEN

          KM = K0
          AM = A0

      ELSE

          I1     = IORDER - 2
C
C ... CONSIDER LEFT AND RIGHT OVERLAPPING REGIONS
C
          DO 20 ILR = 0,1
              I1     = I1 + 1
              I2     = I1 + 1
              CALL DELTAK(WS(I1),WSTEP,NP(I1),X(1,I1),NO(I1),WS(I2),
     +                    NP(I2),X(1,I2),NO(I2),W1,DW,K0,A0,K(ILR+1),
     +                    A(ILR+1),IERR(ILR+1))
   20     CONTINUE
C
C ... COMPUTE MEAN VALUE
C
          KM     = 0.5* (K(1)+K(2))
          AM     = 0.5* (A(1)+A(2))

      ENDIF   ! End of the test on FZ

C   WRITE(*,*) IORDER,KM,AM
C
C ... CORRECT FOR RIPPL
C
          CALL RIPCOR(WS(IORDER),WSTEP,NP(IORDER),X(1,IORDER),
     +                Y(1,IORDER),NO(IORDER),KM,AM)
          NN = NP(IORDER)
          DO 35 NK = 1, NN
             IF (XMAX.LT.Y(NK,IORDER)) XMAX = Y(NK,IORDER)
             IF (XMIN.GT.Y(NK,IORDER)) XMIN = Y(NK,IORDER)
35        CONTINUE
          IF (IORDER.EQ.2) THEN
              CALL RIPCOR(WS(1),WSTEP,NP(1),X(1,1),Y(1,1),NO(1),KM,AM)
              VAL(1) = NO(1)
              VAL(2) = KM
              VAL(3) = AM
              VAL(4) = KM
              VAL(5) = AM
              ISEQ   = ISEQ + 1
              CALL TBRWRR(TID,ISEQ,6,ICOL,VAL,ISTAT)
          END IF
          VAL(1) = NO(IORDER)
          VAL(2) = KM
          VAL(3) = AM
          VAL(4) = KM
          VAL(5) = AM
          ISEQ   = ISEQ + 1
          CALL TBRWRR(TID,ISEQ,6,ICOL,VAL,ISTAT)
          IF (IORDER.EQ.NY-1) THEN
              CALL RIPCOR(WS(NY),WSTEP,NP(NY),X(1,NY),Y(1,NY),NO(NY),KM,
     +                    AM)
              VAL(1) = NO(NY)
              VAL(2) = KM
              VAL(3) = AM
              VAL(4) = KM
              VAL(5) = AM
              ISEQ   = ISEQ + 1
              CALL TBRWRR(TID,ISEQ,6,ICOL,VAL,ISTAT)
          END IF
C
C ... WRITE OUT RESULTS
C
          WRITE (LINE,9000) NO(IORDER),KM
          CALL STTPUT(LINE,ISTAT)
   30 CONTINUE
      CALL TBSINI(TID,ISTAT)
      CALL TBTCLO(TID,ISTAT)
      RETURN
 9000 FORMAT (4X,I8,F12.2)
      END

      SUBROUTINE RIPPL0(NX,NY,X,Y,WS,WSTEP,NP,NO,K0,A0,XMIN,XMAX,
     +                                                  TABLE,FZ)
C
C CORRECT FOR BLAZE EFFECT BY FITTING SINC SQ. FUNCTION
C
C INPUT ARGUMENTS
C NX MAXIMUM NUMBER OF SAMPLES PER ORDER
C NY NUMBER OF ORDERS
C X  INPUT IMAGE
C WS STARTING WAVELENGTH PER EACH ORDER
C WSTEP WAVELENGTH STEP
C NP NUMBER OF USEFUL SAMPLES PER ORDER
C NO SPECTRAL ORDER NUMBER
C K0 INITIAL GUESS FOR THE CONSTANT K
C A0 INITIAL GUESS FOR ALPHA
C FZ FLAG TO FREEZE THE VALUES OF K AND ALPHA
C
C OUTPUT ARGUMENTS
C Y    CORRECTED IMAGE
C XMIN MINIMUN AND
C XMAX MAXIMUM VALUES
C
      IMPLICIT NONE
C
      INTEGER          NX, NY
      INTEGER          NP(NY),NO(NY),IERR(100),ICOL(7)
      INTEGER          ISEQ, TID, ISTAT, I, IORDER, NNN, I1, N
      INTEGER          NN, NK
      REAL             X(NX,NY), Y(NX,NY), XMIN, XMAX
      REAL             VAL(7), YMAX(100)
      DOUBLE PRECISION WS(NY), WSTEP, K0, A0, W1
      DOUBLE PRECISION A(100), AFIT(100), K(100), KFIT(100)
      CHARACTER*12     FZ
      CHARACTER*16     LABEL(7),UNIT(7),FORM
      CHARACTER*(*)    TABLE
C
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      DATA FORM/'G12.4'/
      DATA LABEL(1)/'ORDER'/,UNIT(1)/'UNITLESS'/
      DATA LABEL(2)/'K'/,UNIT(2)/'UNITLESS'/
      DATA LABEL(3)/'ALPHA'/,UNIT(3)/'UNITLESS'/
      DATA LABEL(4)/'KFIT'/,UNIT(4)/'UNITLESS'/
      DATA LABEL(5)/'AFIT'/,UNIT(5)/'UNITLESS'/
      DATA LABEL(6)/'YMAX'/,UNIT(6)/'FLUX'/
      DATA LABEL(7)/'STATUS'/,UNIT(7)/'UNITLESS'/
C
      ISEQ   = 0
      XMIN   = 1.E30
      XMAX   = -XMIN
C
C ... INITIALIZE TEMPORARY OUTPUT
C
      CALL TBTINI(TABLE,F_TRANS,F_O_MODE,8,NY,TID,ISTAT)
      DO 10 I = 1,6
          CALL TBCINI(TID,D_R4_FORMAT,1,FORM,UNIT(I),
     .                LABEL(I),ICOL(I),ISTAT)
   10 CONTINUE
C
C ... ITERATION ON ORDERS
C
      DO 20 IORDER = 1,NY
          NNN    = 10./WSTEP
          I1     = 1 + NNN/2
          W1     = WS(IORDER) + (I1-1)*WSTEP
          N      = NP(IORDER) - NNN

          CALL FITPAR(W1,WSTEP,N,X(I1,IORDER),NO(IORDER),K0,A0,
     +                K(IORDER),A(IORDER),YMAX(IORDER),IERR(IORDER))

          IF (FZ(1:1).EQ.'F'.OR.FZ(1:1).EQ.'f') THEN
             K(IORDER) = K0
             A(IORDER) = A0
          ENDIF

   20 CONTINUE
C
C ... COMPUTE FITTED RESULTS
C
      CALL COMFIT(NY,NO,K,IERR,KFIT,1)
      CALL COMFIT(NY,NO,A,IERR,AFIT,0)
C
C ... CORRECT FOR BLAZE FUNCTION
C
      DO 30 IORDER = 1,NY
          CALL RIPCOR(WS(IORDER),WSTEP,NP(IORDER),X(1,IORDER),
     +                Y(1,IORDER),NO(IORDER),KFIT(IORDER),AFIT(IORDER))
          VAL(1) = NO(IORDER)
          VAL(2) = K(IORDER)
          VAL(3) = A(IORDER)
          VAL(4) = KFIT(IORDER)
          VAL(5) = AFIT(IORDER)
          VAL(6) = YMAX(IORDER)
          VAL(7) = IERR(IORDER)
          ISEQ   = ISEQ + 1
          CALL TBRWRR(TID,ISEQ,6,ICOL,VAL,ISTAT)
          NN = NP(IORDER)
          DO 35 NK = 1, NN
             IF (XMAX.LT.Y(NK,IORDER)) XMAX = Y(NK,IORDER)
             IF (XMIN.GT.Y(NK,IORDER)) XMIN = Y(NK,IORDER)
35        CONTINUE
C
C ... WRITE OUT RESULTS
C
   30 CONTINUE
      CALL TBSINI(TID,ISTAT)
      CALL TBTCLO(TID,ISTAT)
      RETURN
      END

      SUBROUTINE RIPCOR(W1,WS,NP,X,Y,M,K,A)
C
C CORRECT FOR RIPPL FUNCTION
C
C INPUT ARGUMENTS
C W1 INITIAL WAVELENGTH
C WS WAVELENGTH STEP
C NP NO. OF POINTS
C X INPUT FLUX
C M ORDER NUMBER
C K CONSTANT
C A ALPHA CONSTANT
C
C OUTPUT ARGUMENTS
C Y CORRECTED FLUX
C
      IMPLICIT NONE
C
      INTEGER          NP, M
      REAL             X(NP),Y(NP)
      DOUBLE PRECISION W1, WS, K, A
      DOUBLE PRECISION PI,DK,DA,DW,DM,R,DX,PA,DC
C
      INTEGER          I
      DATA PI/3.1415926535897932D0/
C
      DK     = K
      DA     = A
      DM     = M
      PA     = PI*A
      DC     = DM/DK
      DO 10 I = 1,NP
          DW     = W1 + (I-1)*WS
          DX     = (PA*DM*DC)* (DW-1.D0/DC)
          IF (DABS(DX).LT.1.E-10) THEN
              Y(I)   = X(I)
          ELSE
              R      = DSIN(DX)/DX
              Y(I)   = X(I)/ (R*R)
          END IF
   10 CONTINUE
      RETURN
      END

      SUBROUTINE DELTAK(WSTR1,WSTEP,N1,X1,NO1,WSTR2,N2,X2,NO2,W1,DW,
     +                  K0,A0,K,A,IERR)
C
C COMPUTE CONTANT K
C
C INPUT ARGUMENTS
C WSTEP REAL*4 WAVELENGTH STEP
C WSTR1 REAL*4 STARTING WAVELENGTH ORDER M+1
C N1 INTG*4 NUMBER OF POINTS IN ORDER M+1
C X1 REAL*4 FLUX IN ORDER M+1
C NO1 INTG*4 ORDER M+1
C WSTR2 REAL*4 STARTING WAVELENGTH ORDER M
C N2 INTG*4 NUMBER OF POINTS IN ORDER M
C X2 REAL*4 FLUX IN ORDER M
C NO2 INTG*4 ORDER M
C W1 OVERLAPPING OFFSET
C DW OVERLAPPING INTERVAL
C K0 INITIAL K VALUE
C A0 ALPHA
C
C OUTPUT ARGUMENTS
C K FINAL K VALUE
C A FINAL A VALUE
C IERR CONVERGENCE FLAG 0 - GOOD VALUE
C      OTHERWISE ITT DOES NOT CONVERGE
C
C
      IMPLICIT NONE
C
      INTEGER          N1, N2, NO1, NO2, NPIX, I1, I2, I, IERR
      INTEGER          NCOUNT
      REAL             X1(N1), X2(N2)
      DOUBLE PRECISION K0, K, A, A0
      DOUBLE PRECISION WSTR1, WSTEP, WSTR2, W1, DW
      DOUBLE PRECISION KVAL,AVERP,AVERM,WL,XP,RP,XM,RM
      DOUBLE PRECISION FRAT,R1,R2,PA,PI
      DOUBLE PRECISION XX1,XX2,S1,S2,C1,C2,DK
      DOUBLE PRECISION DM1,DM2,C11,C12,C21,C22
      DOUBLE PRECISION AVAL
      DATA PI/3.1415926535897932D0/
C
      NPIX   = DW/WSTEP
      I1     = (WSTR2+W1-WSTR1)/WSTEP
      I2     = W1/WSTEP
      AVAL   = A0
      PA     = AVAL*PI
      KVAL   = K0
      DM1    = NO1
      DM2    = NO2
      NCOUNT = 0
   10 CONTINUE
      AVERP  = 0.D0
      AVERM  = 0.D0
      C11    = PA*DM1* (DM1/KVAL)
      C12    = PA*DM2* (DM2/KVAL)
      C21    = KVAL/DM1
      C22    = KVAL/DM2
C
C ... COMPUTE RATIO OF THE AVERAGED CORRECTED FLUXES
C
      DO 20 I = 1,NPIX
          WL     = WSTR2 + (I2+I)*WSTEP
          XP     = C12* (WL-C22)
          RP     = DSIN(XP)/XP
          AVERP  = AVERP + X2(I2+I)/ (RP*RP)/NPIX
          XM     = C11* (WL-C21)
          RM     = DSIN(XM)/XM
          AVERM  = AVERM + X1(I1+I)/ (RM*RM)/NPIX
   20 CONTINUE
      FRAT   = AVERP/AVERM
C
C ... COMPUTE INCREMENT IN K
C
      WL     = WSTR2 + W1 + DW*0.5
      XX1    = C11* (WL-C21)
      S1     = DSIN(XX1)
      C1     = DCOS(XX1)
      R1     = 2.D0* (1.D0-XX1*C1/S1)*WL/ (KVAL* (WL-KVAL/NO1))
C T1  = 2.D0*(XX1*C1/S1-1.D0)/AVAL
      XX2    = C12* (WL-C22)
      S2     = DSIN(XX2)
      C2     = DCOS(XX2)
      R2     = 2.D0* (1.D0-XX2*C2/S2)*WL/ (KVAL* (WL-KVAL/NO2))
C T2  = 2.D0*(XX2*C2/S2-1.D0)/AVAL
      DK     = (FRAT-1.0)/ (R2-FRAT*R1)
C DA  = (FRAT-1.0)/(T2-FRAT*T1)
      KVAL   = KVAL + DK
C AVAL   = AVAL + DA
      NCOUNT = NCOUNT + 1
C WRITE(*,*) NCOUNT,KVAL,DK
      IF (DABS(DK).GT.1.D0 .AND. NCOUNT.LT.10) GO TO 10
      IF (NCOUNT.GE.10) THEN
          IERR   = 1
          K      = K0
          A      = A0
      ELSE
          IERR   = 0
          K      = KVAL
          A      = AVAL
      END IF
      RETURN
      END

      SUBROUTINE FITPAR(FSTART,FSTEP,FNPIX,YY,NORDER,K0,A0,K,
     +                  A1,FMAX,IERR)
C
C ITERATE ON THE FITTING PROCESS FOT IMAGE DATA
C THE ITERATION IS FINISHED IF
C - NITER IS REACHED OR
C - CHISQ IS REACHED
C - CONVERGENCE IS ACHIEVED
C
C INPUT PARAMETERS
C YY VALUES OF THE IMAGE
C K0 GUESS FOR K
C A0 INPUT GUESS FOR ALPHA
C
C OUTPUT PARAMETERS
C K  ACTUAL K
C A1 ACTUAL ALPHA
C IERR STATUS RETURN
C
      IMPLICIT NONE
C
      INTEGER          FNPTOT,FNITER,FNPIX
      INTEGER          NITER, NITER1, I, I2, I1, ISTAT, ICOUNT
      INTEGER          J, NACT, IX1, KK, NN, NP, NNP, IERR, NORDER
      REAL             X,YY(FNPIX), FMAX, ACTCH
      REAL             CHISQ, RELAX, XM, CHIPER, CHIOLD
      DOUBLE PRECISION CHI,PP,Q,Y,Y1,Y2, FSTART, FSTEP
      DOUBLE PRECISION AL,B(10),A(10,10), W, K, K0, A1, A0
      DOUBLE PRECISION FDERIV(3),PI
      DOUBLE PRECISION FVALUE(3),FCHISQ,FCCHIS,FRELAX
      CHARACTER*80     LINE
      DATA PI/3.1415926535897932D0/
C
      NITER  = 20
      CHISQ  = 0.
      RELAX  = 0.8
      NITER1 = NITER
      FNPTOT = 3
C
C      WRITE (*,*) ' *** ORDER ',NORDER,' ***'
      XM     = -9999.
      DO 10 I = 1,FNPIX
          XM     = MAX(XM,YY(I))
   10 CONTINUE  
      FVALUE(1) = XM  
      FVALUE(2) = -PI*A0*NORDER  
      FVALUE(3) = -(FVALUE(2)*NORDER)/K0
      I1     = 1
      I2     = FNPIX
      FCCHIS = 9999.
      FCHISQ = CHISQ
      FRELAX = RELAX
      CHI    = 0.D0
      ICOUNT = 0
      CALL STTPUT(' ITERATION  CHI SQ. PERC.CHANGE',ISTAT)
      CALL STTPUT(' ---------  ------- -----------',ISTAT)
      CHIPER = 100.
   15 CONTINUE
          IF ( .NOT. (ICOUNT.LT.NITER1.AND.CHIPER.GT.0.1)) GO TO 100
          DO 30 I = 1,10
              DO 20 J = 1,10
                  A(J,I) = 0.D0
   20         CONTINUE
              B(I)   = 0.D0
   30     CONTINUE
          CHIOLD = CHI
          CHI    = 0.D0
C
C ITERATION ON IMAGE DATA
C
          W      = 1.
          DO 60 IX1 = I1,I2
              X      = FSTART + (IX1-1)*FSTEP
              Y      = YY(IX1)
C
C ...       COMPUTE FUNCTION VALUES AND DERIVATIVES (0 IF FIXED PARAM)
C
              CALL FTFUNC(X,FNPTOT,FVALUE,Y1,FDERIV)
C
C ...       COMPUTE RESIDUALS, WEIGHTED RESIDUALS AND CHI**2
C
              Y2     = Y - Y1
              PP     = DBLE(W)
              Q      = Y2
              CHI    = CHI + Q*Q*PP
C
C ...       BUILD NORMAL EQUATION MATRIX
C
              DO 50 J = 1,FNPTOT
                  AL     = FDERIV(J)
                  DO 40 KK = 1,FNPTOT
                      A(J,KK) = A(J,KK) + AL*PP*FDERIV(KK)
   40             CONTINUE
                  B(J)   = B(J) + PP*Q*AL
   50         CONTINUE
   60     CONTINUE
          NN     = FNPIX
          NP     = FNPTOT
C
C ...     INVERT NORMAL EQUATION MATRIX TO GET THE COVARIANCE MATRIX
C
          NNP    = FNPTOT
          CALL DMATIN(A,FNPTOT,10,ISTAT)
          IF (ISTAT.NE.0) THEN
              CALL STTPUT(' Problems inverting matrix ... ',ISTAT)
              IERR   = 2
              K      = K0
              A1     = A0
              FMAX   = FVALUE(1)
              RETURN
          END IF
C
C ... COMPUTE REDUCED CHI**2 AND CORRECTIONS FOR THE UNKNOWNS
C
          CHI    = DMAX1(CHI/DBLE(NN-NP),0.D0)
          DO 80 I = 1,FNPTOT
              Q      = 0.0D0
              DO 70 J = 1,FNPTOT
                  Q      = Q + A(I,J)*B(J)
   70         CONTINUE
C
C ... COMPUTE ERRORS OF THE CORRECTIONS (I.E. THE UNKNOWNS)
C ... AND APPLY CORRECTIONS (DO THE ADJUSTMENT!)
C
              FVALUE(I) = FVALUE(I) + RELAX*Q
   80     CONTINUE
          ICOUNT = ICOUNT + 1
          FNITER = FNITER + 1
          FCCHIS = SNGL(DSQRT(CHI))
          IF (ICOUNT.GT.1) THEN
              CHIPER = 100.* (CHIOLD-CHI)/CHIOLD
              WRITE (LINE,9000) ICOUNT,FCCHIS,CHIPER
          ELSE
              WRITE (LINE,9000) ICOUNT,FCCHIS
          END IF
          CALL STTPUT(LINE,ISTAT)
      GOTO 15
  100 CONTINUE
      CALL STTPUT(' ',ISTAT)
      NACT   = FNITER
      ACTCH  = FCCHIS
      A1     = -FVALUE(2)/ (PI*NORDER)
      K      = - (FVALUE(2)*NORDER)/FVALUE(3)
      FMAX   = FVALUE(1)
      IERR   = 0
      IF (CHIPER.GT.0.1) IERR   = 1
      RETURN
 9000 FORMAT (I10,1X,G12.4,3X,F7.3)
C 9010 FORMAT (I10,1X,G12.4,1X,G12.4)
      END

      SUBROUTINE DMATIN(A,N,NDIM,ISTAT)
C
C MATRIX INVERSION USING THE GAUSS-JORDAN METHOD
C  MODIFIED VERSION BY F.L. BAUER AND C. REINSCH
C
      IMPLICIT NONE
      INTEGER N, NDIM, ISTAT
      DOUBLE PRECISION A(NDIM,NDIM)
C
      INTEGER K, KK, I, J
      DOUBLE PRECISION P,Q,H(400)

C
      ISTAT  = 0
      DO 40 K = 1,N
          IF (A(1,1).LE.0.0D0) GO TO 70
          KK     = N + 1 - K
          P      = 1.0/A(1,1)
          DO 20 I = 2,N
              Q      = A(I,1)
              H(I)   = Q*P
              IF (I.LE.KK) H(I)   = -H(I)
              DO 10 J = 2,I
                  A(I-1,J-1) = A(I,J) + Q*H(J)
   10         CONTINUE
   20     CONTINUE
          A(N,N) = P
          DO 30 I = 2,N
              A(N,I-1) = H(I)
   30     CONTINUE
   40 CONTINUE
      DO 60 I = 2,N
          DO 50 J = 1,I
              A(J,I) = A(I,J)
   50     CONTINUE
   60 CONTINUE
      RETURN
   70 ISTAT  = 1
      RETURN
      END

      SUBROUTINE FTFUNC(X,NP,PARAM,Y1,DERIV)
C
C FUNCTION DEFINITION
C
C INPUT PARAMS
C IND INTG NO. OF IND. VARS
C X REAL IND.VARS
C NP INTG NO. OF PARAMS
C PARAM DBLE FUNCTION PARAMETERS
C
C OUTPUT PARAMS
C Y1 DBLE COMPUTED FUNCTION VALUE
C DERIV DBLE COMPUTED DERIVATIVE VALUE
C
      IMPLICIT NONE
      INTEGER          NP
      REAL             X
      DOUBLE PRECISION Y1,PARAM(NP),DERIV(NP)
C
C SINC**2
C Y = P(1)*SINC(P(2)+P(3)*X)**2
C
      DOUBLE PRECISION W, W2
C
      W      = PARAM(3)*X + PARAM(2)
      IF (DABS(W).LT.10.E-20) THEN
          Y1     = PARAM(1)
          DERIV(1) = 1.D0
          DERIV(2) = 0.D0
          DERIV(3) = 0.D0
      ELSE
          W2       = DSIN(W)/W
          DERIV(1) = W2*W2
          Y1       = DERIV(1)*PARAM(1)
          DERIV(2) = 2.D0*PARAM(1)*W2* (DCOS(W)-W2)/W
          DERIV(3) = X*DERIV(2)
      END IF
      RETURN
      END

      SUBROUTINE COMFIT(N,IX,Y,IERR,YFIT,IDEG)
C
C COMPUTE LINEAR FIT
C
C INPUT ARGUMENTS
C N INTG*4 NUMBER OF VALUES
C IX INTG*4 ARRAY WITH THE INDEPENDENT VARIABLE
C Y REAL*4 ARRAY WITH THE DEPENDENT VARIABLE
C IERR INTG*4 ERROR FLAG
C IDEG INTG*4 DEGREE 0 OR 1
C
C OUTPUT ARGUMENTS
C YFIT REAL*4 FITTED VALUES
C
      IMPLICIT NONE
      INTEGER          N, I, NN, IDEG
      INTEGER          IX(N),IERR(N)
      DOUBLE PRECISION Y(N),YFIT(N)
      DOUBLE PRECISION SY,SX,SX2,SXY,B0,B1,YF,YRES,YSIG,THRES
C
      SX     = 0.D0
      SY     = 0.D0
      SX2    = 0.D0
      SXY    = 0.D0
      NN     = 0
C
C ... FIRST ITERATION
C
      DO 10 I = 1,N
          IF (IERR(I).EQ.0) THEN
              NN     = NN + 1
              SY     = SY + Y(I)
              IF (IDEG.EQ.1) THEN
                  SXY    = SXY + IX(I)*Y(I)
                  SX     = SX + IX(I)
                  SX2    = SX2 + IX(I)*IX(I)
              END IF
          END IF
   10 CONTINUE
C
C ... COMPUTE FIRST APPROX
C
      IF (IDEG.EQ.1) THEN
          B1     = (NN*SXY-SX*SY)/ (NN*SX2-SX*SX)
      ELSE
          B1     = 0.D0
      END IF
      B0     = SY/NN - B1* (SX/NN)
C
C ... COMPUTE RESIDUALS
C
      SX     = 0.D0
      SX2    = 0.D0
      DO 20 I = 1,N
          YF     = B1*IX(I) + B0
          YFIT(I) = (Y(I)-YF)/YF
          SX     = SX + YFIT(I)
          SX2    = SX2 + YFIT(I)*YFIT(I)
   20 CONTINUE
      YRES   = SX/N
      YSIG   = DSQRT((SX2-N*YRES*YRES)/ (N-1))
C
C ... SECOND ITERATION
C
      SX     = 0.D0
      SY     = 0.D0
      SX2    = 0.D0
      SXY    = 0.D0
      NN     = 0
      THRES  = 2.D0*YSIG
      DO 30 I = 1,N
          IF (DABS(YFIT(I)-YRES).LE.THRES) THEN
              NN     = NN + 1
              SY     = SY + Y(I)
              IF (IDEG.EQ.1) THEN
                  SXY    = SXY + IX(I)*Y(I)
                  SX     = SX + IX(I)
                  SX2    = SX2 + IX(I)*IX(I)
              END IF
          END IF
   30 CONTINUE
C
C ... COMPUTE FIRST APPROX
C
      IF (IDEG.EQ.1) THEN
          B1     = (NN*SXY-SX*SY)/ (NN*SX2-SX*SX)
      ELSE
          B1     = 0.D0
      END IF
      B0     = SY/NN - B1* (SX/NN)
C
C ... COMPUTE FINAL VALUES
C
      DO 40 I = 1,N
          YFIT(I) = B1*IX(I) + B0
   40 CONTINUE
      RETURN
      END

C @(#)averpr.for	19.1 (ES0-DMD) 02/25/03 13:25:31
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C
C  subroutine AVERPR         version 1.2       830914
C  A. Kruszewski             ESO Garching
C
C  modified                  version 1.3       870303
C  A. Kruszewski             Obs. de Geneve
C
C.KEYWORDS
C
C  profiles
C
C.PURPOSE
C
C  using a two-dimensional profile "PRFL" it calculates average
C  one-dimensional profile "AVPR" and a number of significant
C  profile rings "LIM"
C
C.INPUT/OUTPUT
C
C  input arguments
C
C  PRFL        real*4 array      two-dimensional profile
C  IHED        integer*4         radial dimension of profile in pixels
C  TRSH        real*4            limiting treshold for object detection
C  ICNT        integer*4 array   numbers of used pixels at calculating
C                                profile points
C
C  output arguments
C
C  AVPR        real*4 array      one-dimensional profile
C  LIM         integer*4         number of significant profile rings
C
C-----------------------------------------------------------------------
      SUBROUTINE AVERPR(IHED, PRFL, TRSH, ICNT, AVPR,
     &                  IAPR, KCLN, KSAT, LIM)
C
      IMPLICIT   NONE
      INCLUDE   'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER   IHED
      REAL      PRFL(8,0:IHED)
      REAL      TRSH
      INTEGER   ICNT(8,0:IHED)
      REAL      AVPR(0:MAXSUB)
      INTEGER   IAPR(0:MAXSUB)
      INTEGER   KCLN
      INTEGER   KSAT
      INTEGER   LIM
C
C     INTEGER   IK(8)
      INTEGER   K, K1
      INTEGER   L
      INTEGER   NK
      REAL      TEMP
      REAL      TRSH3
     
C
      LOGICAL   VOID
C
C *** Calculates averaged over octants profile AVPR.
C
      DO 5 K = 0 , MAXSUB
          IAPR(K) = 0
    5 CONTINUE
      AVPR(0) = PRFL(1,0)
      IAPR(0) = ICNT(1,0)
      DO 10 K = 1 , IHED
          NK = 0
          TEMP = 0.0
          DO 20 L = 1 , 8
              IF ( ICNT(L,K) .EQ. -1 ) THEN
                  IAPR(K) = -1
                  AVPR(K) = PRFL(L,K)
                  GOTO 30
              ELSE        
                  TEMP = TEMP + ICNT(L,K) * PRFL(L,K)
                  NK = NK + ICNT(L,K)
              ENDIF
   20     CONTINUE
          IF ( NK .GT. 0 ) THEN
              AVPR(K) = TEMP / NK
              IAPR(K) = NK
          ELSE
              AVPR(K) = 0.0
              IAPR(K) = 0
          ENDIF
   30     CONTINUE
   10 CONTINUE
C
C *** Check how many profile rings are significantly above
C *** the sky background. Two profile rings with average
C *** less than 0.3*TRSH are a condition for terminating
C *** the profile. Skip invalid central points first.
C
      TRSH3 = 0.3 * TRSH
      IF ( IAPR(0) .EQ. 0 ) THEN
          VOID = .TRUE.
      ELSE
          VOID = .FALSE.
      ENDIF
      K = 0
   50 CONTINUE
          K = K + 1
          IF ( VOID ) THEN
              IF ( IAPR(K) .EQ. 0 ) THEN
                  GOTO 50
              ELSE
                  VOID = .FALSE.
              ENDIF
          ENDIF
      IF ( ( K .LT. IHED )
     &     .AND.
     &     ( MAX( AVPR(K-1) , AVPR(K) ) .GT. TRSH3 )
     &     .AND.
     &     ( .NOT. ( ( AVPR(K) .GT. AVPR(K-1) )
     &               .AND.
     &               ( AVPR(K-1) .LT. TRSH3 )
     &               .AND.
     &               (IAPR(K-1) .GT. 0 ) ) )
     &    .AND.
     &    ( AVPR(K+1) .GT. (-TRSH) ) ) GOTO 50
C
C *** Number of significant profile rings is defined as LIM.
C
      IF ( VOID ) THEN
          LIM = 0
      ELSE
          LIM = MIN( IHED , K )
          LIM = MAX( LIM , 4 )
      ENDIF
C
C *** Find extend of saturation KSAT.
C
      L = -1
   60 CONTINUE
          L = L + 1
      IF ( IAPR(L) .EQ. -1 .OR. IAPR(L) .EQ. 0 ) GOTO 60
      KSAT = L - 1
C
C *** Find extend of non-cleaned profile.
C
c      L = KSAT
c   70 CONTINUE
c         L = L + 1
c      IF ( IAPR(L) .GT. 0 .AND. L .LT. LIM ) GOTO 70
c      KCLN = L - 1
c      IF ( KCLN . EQ. KSAT ) THEN
c          KCLN = 0
c      ENDIF
C
C *** Set the remaining values to zero.
C
      IF ( LIM .LT. MAXSUB ) THEN
          K1 = LIM + 1
          DO 80 L = K1 , MAXSUB
              AVPR(L) = 0.0
              IAPR(L) = 0
   80     CONTINUE
      ENDIF
C
      RETURN
C
      END
C

C===========================================================================
C Copyright (C) 1995-2005 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  13:19 - 15 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C. Modif 30-Jul-90 P.Ballester
C 
C.VERSION
C 051017		last modif
C 
C-------------------------------------------------------------------

      SUBROUTINE SMOOT(X,Y,W,Q,M,XB,XE,K,S,N,T,C,FP,IOPT,IER,NRDATA,
     +                 FP0,FPOLD,NPLUS)
C
       IMPLICIT NONE
C
C  GIVEN THE SET OF DATA POINTS (X(I),Y(I)) AND THE SET OF POSITIVE
C  NUMBERS W(I),I=1,2,...M, SMOOT DETERMINES A SMOOTH SPLINE
C  APPROXIMATION OF DEGREE K FOR THE INTERVAL XB <= X <= XE.
C  THE NUMBER OF KNOTS OF THIS SPLINE S(X) AND THE POSITION
C  T(J),J=1,...N IS CHOSEN AUTOMATICALLY BY THE ROUTINE.
C  THE SMOOTHNESS OF S(X) IS ACHIEVED BY MINIMALIZING THE SUM(D(R)**2)
C  WHERE D(R) STANDS FOR THE DISCONTINUITY JUMP OF THE KTH DERIVATIVE
C  OF S(X) AT THE KNOT T(R),R=K+2,...,N-K-1. THE AMOUNT OF SMOOTH-
C  NESS IS DETERMINED BY THE CONDITION THAT F(P)=SUM(W(I)*(Y(I)-
C  S(X(I)))**2) BE <= S, WITH S A GIVEN NON-NEGATIVE CONSTANT.
C  THE FIT S(X) IS GIVEN IN ITS B-SPLINE REPRESENTATION ( B-SPLINE
C  COEFFICIENTS C(J),J=1,2,...N-K-1) AND CAN BE EVALUATED BY MEANS
C  OF FUNCTION DERIV.
C
C  CALLING SEQUENCE:
C     CALL SMOOT(X,Y,W,Q,M,XB,XE,K,S,N,T,C,FP,IOPT,IER)
C
C  INPUT PARAMETERS:
C    X   : ARRAY,MINIMUM LENGTH M,CONTAINING THE DATA POSITIONS X(I).
C    Y   : ARRAY,MINIMUM LENGTH M,CONTAINING THE DATA VALUES Y(I).
C    W   : ARRAY,MINIMUM LENGTH M,CONTAINING THE WEIGHTS W(I).
C    M   : INTEGER VALUE,CONTAINING THE NUMBER OF DATA POINTS.
C    XB,XE:REAL VALUES, CONTAINING THE BOUNDARIES OF THE APPR. INTERVAL
C    K   : INTEGER VALUE,CONTAINING THE DEGREE OF S(X).
C    S   : REAL VALUE,CONTAINING THE SMOOTHING FACTOR.
C    IOPT: INTEGER VALUE WHICH TAKES THE VALUE 0 OR 1.
C      IOPT=0: THE ROUTINE WILL RESTART ALL COMPUTATIONS.
C      IOPT=1: THE ROUTINE WILL START WITH THE KNOTS FOUND AT THE
C               LAST CALL OF THE ROUTINE. IF IOPT=1 THE OUTPUT
C               PARAMETERS T AND N ARE INPUT PARAMETERS AS WELL.
C
C  OUTPUT PARAMETERS:
C    T   : ARRAY,LENGTH NEST (SEE DATA INITIALIZATION STATEMENT),
C          WHICH CONTAINS THE POSITION OF THE KNOTS,I.E. THE POSITION
C          OF THE INTERIOR KNOTS T(K+2),...T(N-K-1), AS WELL AS THE
C          POSITION OF THE KNOTS T(1)=T(2)=...=T(K+1)=XB AND XE =
C          T(N-K)=...=T(N) WHICH ARE NEEDED FOR THE B-SPLINE REPRESENT.
C    C   : ARRAY,LENGTH NEST,WHICH CONTAINS THE B-SPLINE COEFFICIENTS.
C    N   : INTEGER VALUE,CONTAINING THE TOTAL NUMBER OF KNOTS.
C    FP  : REAL VALUE,WHICH CONTAINS THE SUM(WI*(YI-S(XI))**2),I=1,...M
C    IER : ERROR CODE
C      IER=0: NORMAL RETURN.
C      IER=-1:NORMAL RETURN, S(X) IS AN INTERPOLATING SPLINE.
C      IER=-2:NORMAL RETURN, S(X) IS A POLYNOMIAL OF DEGREE K.
C      IER>0 :ABNORMAL TERMINATION.
C        IER=1:THE REQUIRED STORAGE SPACE EXCEEDS THE AVAILABLE
C              STORAGE SPACE,SPECIFIED BY THE PARAMETER NEST.
C              PROBABLY CAUSES:NEST OR S TOO SMALL.
C        IER=2:A THEORETICALLY IMPOSSIBLE RESULT WAS FOUND DURING
C              THE ITERATION PROCESS.
C              PROBABLY CAUSES:TOL TOO SMALL
C        IER=3:THE MAXIMAL NUMBER OF ITERATIONS MAXIT HAS BEEN
C              REACHED.
C              PROBABLY CAUSES:MAXIT OR TOL TOO SMALL.
C        IER=10:SOME OF THE INPUTDATA ARE INVALID(SEE RESTRICTIONS).
C
C
C   INPUT/OUTPUT PARAMETERS:
C     NRDATA : ARRAY, LENGTH NEST KEEP INFO BETWEEN ITERATIONS
C     FPO    : REAL, KEEP INFO
C     FPOLD  : REAL, KEEP INFO
C     NPLUS  : REAL, KEEP INFO
C
C  RESTRICTIONS:
C    1) M > K > 0
C    2) XB <= X(R) < X(R+1) <= XE, R=1,2,...M-1.
C    3) W(R) > 0, R=1,2,...M.
C    4) S >= 0.
C    5) NEST >= 2*K+2.
C
C  OTHER SUBROUTINES REQUIRED:
C    BSPLIN,COSSIN,ROTATE,BACK,NKNOT,DISCO AND RATION.
      INTEGER MXP
      PARAMETER (MXP=1000)
      INTEGER M,N,IOPT,IER,K,I,J,L,NMAX,NEST,MAXIT,NEW,ICHECK,N8
      INTEGER NPLUS,MK1,K2,K3,K1,NMIN,ITER,NRINT,NK1,IT,I1,I2,I3
      INTEGER NPL1,L0,NRDATA(MXP)
      REAL X(M),Y(M),W(M),T(MXP),C(MXP),FPINT(MXP),
     +          Z(MXP),DIAG(MXP),DPRIME(MXP),A(MXP,5),G(MXP,6),B(MXP,7),
     +          Q(M,6),H(7),FP,XE,XB,S,FP0,FPOLD,TOL
      REAL ACC,XI,YI,WI,PIV,FPART,TERM,STORE,P1
      REAL PINV,P,COS,SIN,FPMS,F1,F2,F3,P2,P3,RATION
C
C    NRDATA: INTEGER ARRAY,LENGTH NEST,WHICH GIVES THE NUMBER OF
C            DATA POINTS INSIDE EACH KNOT INTERVAL.
C    FP0   : REAL VALUE,WHICH CONTAINS THE WEIGHTED SUM OF SQUARES
C            OF RESIDUAL RIGHT HAND SIDES, FOR THE LEAST SQUARES
C            POLYMOMIAL OF DEGREE K.
C    FPOLD : REAL VALUE,WHICH CONTAINS THE WEIGHTED SUM OF RESIDUAL
C            RIGHT HAND SIDES FOR THE LEAST SQUARES SPLINE WHICH
C            CORRESPONDS TO THE LAST  FOUND SET OF KNOTS BUT ONE.
C    NPLUS : INTEGER VALUE,GIVING THE NUMBER OF KNOTS OF THE LAST
C            SET MINUS THE NUMBER OF THE LAST SET BUT ONE.
C
C  DATA INITIALIZATION STATEMENT TO SPECIFY
C    TOL  : THE REQUESTED RELATIVE ACCURACY FOR THE ROOT OF F(P) = S.
C    MAXIT: THE MAXIMAL NUMBER OF ITERATIONS ALLOWED.
C    NEST : AN OVER-ESTIMATE OF THE NUMBER OF KNOTS N. THIS PARAMETER
C          MUST BE SET BY THE USER TO INDICATE THE STORAGE SPACE
C          AVAILABLE TO THE SUBROUTINE. THE DIMENSION SPECIFICATIONS
C          OF THE ARRAYS   T,C,NRDATA,FPINT,Z,DIAG,DPRIME(N),A(N,K),
C          Q(M,K+1),G(N,K+1),B(N,K+2) AND H(K+2)   DEPEND
C          ON N,M AND K. SINCE N IS UNKNOWN AT THE TIME THE
C          USER SETS UP THE DIMENSION INFORMATION AN OVER-ESTIMATE
C          OF THESE ARRAYS WILL GENERALLY BE MADE. THE FOLLOWING
C          REMARKS ARE INTENDED TO HELP THE USER
C            1) 2*K+2 <= N <= M+K+1
C            2) THE SMALLER THE VALUE OF S, THE GREATER N WILL BE.
C            3) NORMALLY N = M/2 IS AN OVER-ESTIMATE.
      DATA TOL/0.001/,MAXIT/40/,NEST/MXP/ ! Old values TOL=0.001 and MAXIT=40
C  BEFORE STARTING COMPUTATIONS A DATA CHECK IS MADE. IF THE INPUT
C  DATA ARE INVALID CONTROLE IS IMMEDIATELY REPASSED TO THE DRIVER
C  PROGRAM (IER=10).
 
      FPMS = 0.0
   10 IER    = 0
      K1     = K + 1
      K2     = K1 + 1
      NMIN   = 2*K1
      IF (K.LE.0) IER    = 10
      IF (M.LT.K1 .OR. NEST.LT.NMIN) IER    = 10
      IF (S.LT.0.) IER    = 10
      IF (XB.GT.X(1) .OR. XE.LT.X(M) .OR. W(1).LE.0.) IER    = 10
      IF (IER.NE.0) GO TO 400
C  CALCULATION OF ACC, THE ABSOLUTE TOLERANCE FOR THE ROOT OF F(P)=S.
      ACC    = TOL*S
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  PART 1: DETERMINATION OF THE NUMBER OF KNOTS AND THEIR POSITION     C
C  **************************************************************      C
C  GIVEN A SET OF KNOTS WE COMPUTE THE LEAST-SQUARES SPLINE SINF(X).   C
C  IF THE SUM F(P=INF) <= S WE ACCEPT THE CHOICE OF KNOTS.             C
C  OTHERWISE WE HAVE TO INCREASE THEIR NUMBER.                         C
C  THE INITIAL CHOICE OF KNOTS DEPENDS ON THE VALUE OF S AND IOPT.     C
C    IF S=0 WE HAVE SPLINE INTERPOLATION; IN THAT CASE THE NUMBER OF   C
C    KNOTS EQUALS NMAX = M+K+1.                                        C
C    IF S > 0 AND                                                      C
C      IOPT=0 WE FIRST COMPUTE THE LEAST-SQUARES POLYNOMIAL OF         C
C      DEGREE K; N = NMIN = 2*K+2                                      C
C      IOPT=1 WE START WITH THE SET OF KNOTS FOUND AT THE LAST         C
C      CALL OF THE ROUTINE, EXCEPT FOR THE CASE THAT S > FP0; THEN     C
C      WE COMPUTE DIRECTLY THE LEAST-SQUARES POLYNOMIAL OF DEGREE K.   C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  DETERMINE NMAX, THE NUMBER OF KNOTS FOR SPLINE INTERPOLATION.
      NMAX   = M + K1
      IF (S.GT.0.) GO TO 50
C  IF S=0, S(X) IS AN INTERPOLATING SPLINE.
      N      = NMAX
C  TEST WHETHER THE REQUIRED STORAGE SPACE EXCEEDS THE AVAILABLE ONE.
      IF (N.GT.NEST) GO TO 380
C  FIND THE POSITION OF THE INTERIOR KNOTS IN CASE OF INTERPOLATION.
      MK1    = M - K1
      IF (MK1.EQ.0) GO TO 70
      K3     = K/2
      I      = K2
      J      = K3 + 2
      IF (K3*2.EQ.K) GO TO 30
      DO 20 L = 1,MK1
          T(I)   = X(J)
          I      = I + 1
          J      = J + 1
   20 CONTINUE
      GO TO 70

   30 DO 40 L = 1,MK1
          T(I)   = (X(J)+X(J-1))*0.5    ! 30-JUl-90
          I      = I + 1
          J      = J + 1
   40 CONTINUE
      GO TO 70
C  IF S>0 OUR INITIAL CHOICE OF KNOTS DEPENDS ON THE VALUE OF IOPT.
C  IF IOPT=0 OR IOPT=1 AND S>=FP0, WE START COMPUTING THE LEAST-SQUARES
C  POLYNOMIAL OF DEGREE K WHICH IS A SPLINE WITHOUT INTERIOR KNOTS.
C  IF IOPT=1 AND FP0>S WE START COMPUTING THE LEAST SQUARES SPLINE
C  ACCORDING TO THE SET OF KNOTS FOUND AT THE LAST CALL OF THE ROUTINE.
   50 IF (IOPT.LE.0) GO TO 60
      IF (FP0.GT.S) GO TO 70
   60 N      = NMIN
      NRDATA(1) = M - 2
C  MAIN LOOP FOR THE DIFFERENT SETS OF KNOTS. M IS A SAVE UPPER BOUND
C  FOR THE NUMBER OF TRIALS.
   70 DO 220 ITER = 1,M
          IF (N.EQ.NMIN) IER    = -2
C  FIND NRINT, TNE NUMBER OF KNOT INTERVALS.
          NRINT  = N - NMIN + 1
C  FIND THE POSITION OF THE ADDITIONAL KNOTS WHICH ARE NEEDED FOR
C  THE B-SPLINE REPRESENTATION OF S(X).
          NK1    = N - K1
          I      = N
          DO 80 J = 1,K1
              T(J)   = XB
              T(I)   = XE
              I      = I - 1
   80     CONTINUE
C  COMPUTE THE B-SPLINE COEFFICIENTS OF THE LEAST-SQUARES SPLINE
C  SINF(X). THE OBSERVATION MATRIX A IS BUILT UP ROW BY ROW AND
C  REDUCED TO UPPER TRIANGULAR FORM BY GIVENS TRANSFORMATIONS
C  WITHOUT SQUARE ROOTS. AT THE SAME TIME FP=F(P=INF) IS COMPUTED.
          FP     = 0.
C  INITIALIZE THE OBSERVATION MATRIX A.
          DO 100 I = 1,NK1
              DIAG(I) = 0.
              Z(I)   = 0.
              DO 90 J = 1,K
                  A(I,J) = 0.
   90         CONTINUE
  100     CONTINUE
          L      = K1
          DO 150 IT = 1,M
C  FETCH THE CURRENT DATA POINT X(IT),Y(IT).
              XI     = X(IT)
              YI     = Y(IT)
              WI     = W(IT)
C  SEARCH FOR KNOT INTERVAL T(L) <= XI < T(L+1).
              IF (XI.GE.T(L+1) .AND. L.NE.NK1) L      = L + 1
C  EVALUATE THE (K+1) NON-ZERO B-SPLINES AT XI AND STORE THEM IN Q.
              CALL BSPLIN(T,N,K,XI,L,H)
              DO 110 I = 1,K1
                  IF (H(I).LT.0.1E-07) H(I)   = 0.
                  Q(IT,I) = H(I)
  110         CONTINUE
C  ROTATE THE NEW ROW OF THE OBSERVATION MATRIX INTO TRIANGLE BY
C  GIVENS TRANSFORMATIONS WITHOUT SQUARE ROOTS.
              J      = L - K1
              DO 130 I = 1,K1
                  IF (WI.LE.1.E-30) GO TO 150
                  J      = J + 1
                  PIV    = H(I)
                  IF (PIV.EQ.0.) GO TO 130
C  CALCULATE THE PARAMETERS OF THE GIVENS TRANSFORMATION.
                  CALL COSSIN(PIV,WI,DIAG(J),COS,SIN)
C  TRANSFORMATIONS TO RIGHT HAND SIDE.
                  CALL ROTATE(PIV,COS,SIN,YI,Z(J))
                  IF (I.EQ.K1) GO TO 140
                  I2     = 0
                  I3     = I + 1
                  DO 120 I1 = I3,K1
                      I2     = I2 + 1
C  TRANSFORMATIONS TO LEFT HAND SIDE.
                      CALL ROTATE(PIV,COS,SIN,H(I1),A(J,I2))
  120             CONTINUE
  130         CONTINUE
C  ADD CONTRIBUTION OF THIS ROW TO THE SUM OF SQUARES OF RESIDUAL
C  RIGHT HAND SIDES.
  140         FP     = FP + WI*YI**2
  150     CONTINUE
          IF (IER.EQ.-2) FP0    = FP
C  BACKWARD SUBSTITUTION TO OBTAIN THE B-SPLINE COEFFICIENTS.
          CALL BACK(A,Z,NK1,K,C)
C  TEST WHETHER THE APPROXIMATION SINF(X) IS AN ACCEPTABLE SOLUTION.
          FPMS   = FP - S
          IF (ABS(FPMS).LT.ACC) GO TO 400
C  IF F(P=INF) < S ACCEPT THE CHOICE OF KNOTS.
          IF (FPMS.LT.0.) GO TO 230
C  IF N = NMAX, SINF(X) IS AN INTERPOLATING SPLINE.
          IF (N.EQ.NMAX) GO TO 390
C  INCREASE THE NUMBER OF KNOTS.
C  IF N=NEST WE CANNOT INCREASE THE NUMBER OF KNOTS BECAUSE OF
C  THE STORAGE CAPACITY LIMITATION.
          IF (N.EQ.NEST) GO TO 380
C  DETERMINE THE NUMBER OF KNOTS NPLUS WE ARE GOING TO ADD.
          IF (IER.EQ.0) GO TO 160
          NPLUS  = 1
          IER    = 0
          GO TO 170

  160     NPL1   = NPLUS*2
          IF (FPOLD-FP.GT.ACC) NPL1   = FLOAT(NPLUS)*FPMS/ (FPOLD-FP)
          NPLUS  = MIN0(NPLUS*2,MAX0(NPL1,NPLUS/2,1))
  170     FPOLD  = FP
C  COMPUTE THE SUM(W(I)*(Y(I)-S(X(I)))**2) FOR EACH KNOT INTERVAL
C  T(J+K) <= X(I) <= T(J+K+1) AND STORE IT IN FPINT(J),J=1,2,...NRINT.
          FPART  = 0.
          I      = 1
          L      = K2
          NEW    = 0
          DO 200 IT = 1,M
              IF (X(IT).LT.T(L) .OR. L.GT.NK1) GO TO 180
              NEW    = 1
              L      = L + 1
  180         TERM   = 0.
              L0     = L - K2
              DO 190 J = 1,K1
                  L0     = L0 + 1
                  TERM   = TERM + C(L0)*Q(IT,J)
  190         CONTINUE
              TERM   = W(IT)* (TERM-Y(IT))**2
              FPART  = FPART + TERM
              IF (NEW.EQ.0) GO TO 200
              STORE  = TERM*0.5
              FPINT(I) = FPART - STORE
              I      = I + 1
              FPART  = STORE
              NEW    = 0
  200     CONTINUE
          FPINT(NRINT) = FPART
          DO 210 L = 1,NPLUS
C  ADD A NEW KNOT.
              CALL NKNOT(X,M,T,N,FPINT,NRDATA,NRINT)
C  TEST WHETHER WE CANNOT FURTHER INCREASE THE NUMBER OF KNOTS.
              IF (N.EQ.NMAX .OR. N.EQ.NEST) GO TO 220
  210     CONTINUE
C  RESTART THE COMPUTATIONS WITH THE NEW SET OF KNOTS.
  220 CONTINUE
C  TEST WHETHER THE LEAST-SQUARES KTH DEGREE POLYNOMIAL IS A SOLUTION
C  OF OUR APPROXIMATION PROBLEM.
  230 IF (IER.EQ.-2) GO TO 400
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  PART 2: DETERMINATION OF THE SMOOTHING SPLINE SP(X).                C
C  ***************************************************                 C
C  WE HAVE DETERMINED THE NUMBER OF KNOTS AND THEIR POSITION.          C
C  WE NOW COMPUTE THE B-SPLINE COEFFICIENTS OF THE SMOOTHING SPLINE    C
C  SP(X). THE OBSERVATION MATRIX A IS EXTENDED BY THE ROWS OF MATRIX   C
C  B EXPRESSING THAT THE KTH DERIVATIVE DISCONTINUITIES OF SP(X) AT    C
C  THE INTERIOR KNOTS T(K+2),...T(N-K-1) MUST BE ZERO. THE CORRES-     C
C  PONDING WEIGHTS OF THESE ADDITIONAL ROWS ARE SET TO 1/SQRT(P).      C
C  ITERATIVELY WE THEN HAVE TO DETERMINE THE VALUE OF P SUCH THAT      C
C  F(P)=SUM(W(I)*(Y(I)-SP(X(I)))**2) BE = S. WE ALREADY KNOW THAT      C
C  THE LEAST-SQUARES KTH DEGREE POLYNOMIAL CORRESPONDS TO P=0, AND     C
C  THAT THE LEAST-SQUARES SPLINE CORRESPONDS TO P=INFINITY. THE        C
C  ITERATION PROCESS WHICH IS PROPOSED HERE, MAKES USE OF RATIONAL     C
C  INTERPOLATION. SINCE F(P) IS A CONVEX AND STRICTLY DECREASING       C
C  FUNCTION OF P, IT CAN BE APPROXIMATED BY A RATIONAL FUNCTION        C
C  R(P) = (U*P+V)/(P+W). THREE VALUES OF P(P1,P2,P3) WITH CORRESPOND-  C
C  ING VALUES OF F(P) (F1=F(P1)-S,F2=F(P2)-S,F3=F(P3)-S) ARE USED      C
C  TO CALCULATE THE NEW VALUE OF P SUCH THAT R(P)=S. CONVERGENCE IS    C
C  GUARANTEED BY TAKING F1>0 AND F3<0.                                 C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  EVALUATE THE DISCONTINUITY JUMP OF THE KTH DERIVATIVE OF THE
C  B-SPLINES AT THE KNOTS T(L),L=K+2,...N-K-1 AND STORE IN B.
      CALL DISCO(T,N,K2,B)
C  INITIAL VALUE FOR P.
      P1     = 0.
      P2     = 0.
      F1     = FP0 - S
      P3     = -1.
      F3     = FPMS
      P      = -F1/F3
      ICHECK = 0
      N8     = N - NMIN
C  ITERATION PROCESS TO FIND THE ROOT OF F(P) = S.
      DO 350 ITER = 1,MAXIT
C  THE ROWS OF MATRIX B WITH WEIGHT 1/SQRT(P) ARE ROTATED INTO
C  THE TRIANGULARISED OBSERVATION MATRIX A WHICH IS STORED IN G.
          IF (ABS(P).LT.1.0E-30) THEN     !P = 0   => PINV = 1/P is in trouble
             GOTO 360                     !indicate that iteration failed
          ENDIF   
C 
          PINV   = 1.0/P
          DO 250 I = 1,NK1
              DPRIME(I) = DIAG(I)
              C(I)   = Z(I)
              G(I,K1) = 0.
              DO 240 J = 1,K
                  G(I,J) = A(I,J)
  240         CONTINUE
  250     CONTINUE
          DO 290 IT = 1,N8
C*PL*ERROR* Comment line too long
C   THE ROW OF MATRIX B IS ROTATED INTO TRIANGLE BY GIVENS TRANSFORMATIONS
              DO 260 I = 1,K2
                  H(I)   = B(IT,I)
  260         CONTINUE
              YI     = 0.
              WI     = PINV
              DO 280 J = IT,NK1
                  IF (WI.LE.1E-30) GO TO 290
                  PIV    = H(1)
C  CALCULATE THE PARAMETERS OF THE GIVENS TRANSFORMATION.
                  CALL COSSIN(PIV,WI,DPRIME(J),COS,SIN)
C  TRANSFORMATIONS TO RIGHT HAND SIDE.
                  CALL ROTATE(PIV,COS,SIN,YI,C(J))
                  IF (J.EQ.NK1) GO TO 290
                  I2     = K1
                  IF (J.GT.N8) I2     = NK1 - J
                  DO 270 I = 1,I2
C  TRANSFORMATIONS TO LEFT HAND SIDE.
                      CALL ROTATE(PIV,COS,SIN,H(I+1),G(J,I))
                      H(I)   = H(I+1)
  270             CONTINUE
                  H(I2+1) = 0.
  280         CONTINUE
  290     CONTINUE
C  BACKWARD SUBSTITUTION TO OBTAIN THE B-SPLINE COEFFICIENTS.
          CALL BACK(G,C,NK1,K1,C)
C  COMPUTATION OF F(P).
          FP     = 0.
          L      = K2
          DO 320 IT = 1,M
              IF (X(IT).LT.T(L) .OR. L.GT.NK1) GO TO 300
              L      = L + 1
  300         L0     = L - K2
              TERM   = 0.
              DO 310 J = 1,K1
                  L0     = L0 + 1
                  TERM   = TERM + C(L0)*Q(IT,J)
  310         CONTINUE
              FP     = FP + W(IT)* (TERM-Y(IT))**2
  320     CONTINUE
C  TEST WHETHER THE APPROXIMATION SP(X) IS AN ACCEPTABLE SOLUTION.
          FPMS   = FP - S
C          TYPE*,ITER,FPMS,ACC
          IF (ABS(FPMS).LT.ACC) GO TO 400
C  TEST WHETHER THE MAXIMAL NUMBER OF ITERATIONS IS REACHED.
          IF (ITER.EQ.MAXIT) GO TO 360
C  CARRY OUT ONE MORE STEP OF THE ITERATION PROCESS.
          P2     = P
          F2     = FPMS
          IF (ICHECK.NE.0) GO TO 340
          IF ((F2-F3).GT.ACC) GO TO 330
C  OUR INITIAL CHOICE OF P IS TOO LARGE.
          P      = P*0.1E-02
          P3     = P2
          F3     = F2
          GO TO 350

  330     IF ((F1-F2).GT.ACC) GO TO 340
C  OUR INITIAL CHOICE OF P IS TOO SMALL
          P      = P*0.1E+04
          P1     = P2
          F1     = F2
          GO TO 350
C  TEST WETHER THE ITERATION PROCESS PROCEEDS AS THEORETICALLY
C  EXPECTED.
  340     IF (F2.GE.F1 .OR. F2.LE.F3) THEN
              TOL    = TOL*4.
              IF (TOL.GT.1.5) GO TO 370
              GO TO 10
          END IF
C 
          ICHECK = 1
C  FIND THE NEW VALUE FOR P.
          P = RATION(P1,F1,P2,F2,P3,F3)
C 
  350 CONTINUE
C  ERROR CODES AND MESSAGES.
  360 IER    = 3
      GO TO 400

  370 IER    = 2
      GO TO 400

  380 IER    = 1
      GO TO 400

  390 IER    = -1
  400 RETURN
C 
C 
      END

      SUBROUTINE BSPLIN(T,N,K,X,L,H)
C  SUBROUTINE BSPLIN EVALUATES THE (K+1) NON-ZERO B-SPLINES OF
C  DEGREE K AT T(L) <= X < T(L+1) USING THE STABLE RECURRENCE
C  RELATION OF DE BOOR AND COX.
C  THE DIMENSION SPECIFICATIONS OF THE FOLLOWING ARRAYS MUST BE
C  AT LEAST H(K+1),HH(K).

      IMPLICIT NONE
      INTEGER N,J,K,I,L,LJ,LI
      REAL T(N),H(6),HH(5),X,F

      H(1)   = 1.
      DO 30 J = 1,K
          DO 10 I = 1,J
              HH(I)  = H(I)
   10     CONTINUE
          H(1)   = 0.
          DO 20 I = 1,J
              LI     = L + I
              LJ     = LI - J
              F      = HH(I)/ (T(LI)-T(LJ))
              H(I)   = H(I) + F* (T(LI)-X)
              H(I+1) = F* (X-T(LJ))
   20     CONTINUE
   30 CONTINUE
      RETURN

      END

      SUBROUTINE COSSIN(PIV,WI,WW,COS,SIN)
C  SUBROUTINE COSSIN CALCULATES THE PARAMETERS OF A GIVENS
C  TRANSFORMATION WITHOUT SQUARE ROOTS.
      IMPLICIT NONE
      REAL COS,SIN,PIV,WI,WW,STORE,DD
      STORE  = PIV*WI
      DD     = WW + STORE*PIV
      COS    = WW/DD
      SIN    = STORE/DD
      WW     = DD
      WI     = COS*WI
      RETURN

      END

      SUBROUTINE ROTATE(PIV,COS,SIN,A,B)
C  SUBROUTINE ROTATE APPLIES A GIVENS ROTATION TO A AND B.
      IMPLICIT NONE
      REAL PIV,COS,SIN,A,B,STORE

      STORE  = B
      B      = COS*STORE + SIN*A
      A      = A - PIV*STORE
      RETURN

      END

      SUBROUTINE BACK(A,Z,N,K,C)
      IMPLICIT NONE
      INTEGER MXP
      PARAMETER (MXP=1000)
      INTEGER I,J,I1,M,L,N,K
      REAL A,Z,C,STORE
C  SUBROUTINE BACK CALCULATES THE SOLUTION OF THE SYSTEM OF
C  EQUATIONS A*C = Z WITH A A N X N UNIT UPPER TRIANGULAR MATRIX
C  OF BANDWIDTH K+1.
C  ATTENTION: THE FIRST DIMENSION SPECIFICATION OF MATRIX A MUST
C  BE THE SAME AS IN THE CALLING PROGRAM.
      DIMENSION A(MXP,K),Z(N),C(N)

      C(N)   = Z(N)
      I      = N - 1
      IF (I.EQ.0) GO TO 30
      DO 20 J = 2,N
          STORE  = Z(I)
          I1     = K
          IF (J.LE.K) I1     = J - 1
          M      = I
          DO 10 L = 1,I1
              M      = M + 1
              STORE  = STORE - C(M)*A(I,L)
   10     CONTINUE
          C(I)   = STORE
          I      = I - 1
   20 CONTINUE
   30 RETURN

      END

      SUBROUTINE NKNOT(X,M,T,N,FPINT,NRDATA,NRINT)
      IMPLICIT NONE
      INTEGER MXP
      PARAMETER (MXP=1000)
      INTEGER K,J,M,N,NRINT,JBEGIN,JPOINT,NUMBER,NRDATA(MXP)
      INTEGER MAXPT,MAXBEG,NEXT,JJ,JK,IHALF,NRX
      REAL X(M),T(MXP),FPINT(MXP),FPMAX
C  SUBROUTINE NKNOT LOCATES AN ADDITIONAL KNOT FOR A SPLINE OF DEGREE
C  K AND ADJUSTS THE CORRESPONDING PARAMETERS,I.E.
C    T     : THE POSITION OF THE KNOTS.
C    N     : THE NUMBER OF KNOTS.
C    NRINT : THE NUMBER OF KNOTINTERVALS.
C    FPINT : THE SUM OF SQUARES OF RESIDUAL RIGHT HAND SIDES
C            FOR EACH KNOT INTERVAL.
C    NRDATA: THE NUMBER OF DATA POINTS INSIDE EACH KNOT INTERVAL.
C  THE ARRAYS T,FPINT AND NRDATA MUST HAVE THE SAME DIMENSION
C  SPECIFICATIONS AS IN THE CALLING PROGRAM.

      K      = (N-NRINT-1)/2
C  SEARCH FOR KNOT INTERVAL T(NUMBER+K) <= X <= T(NUMBER+K+1) WHERE
C  FPINT(NUMBER) IS MAXIMAL ON THE CONDITION THAT NRDATA(NUMBER)
C  NOT EQUALS ZERO.

      FPMAX  = 0.
      MAXPT = 0
      MAXPBEG = 0
      NUMBER = 0
      JBEGIN = 1
      DO 20 J = 1,NRINT
          JPOINT = NRDATA(J)
          IF (FPMAX.GE.FPINT(J) .OR. JPOINT.EQ.0) GO TO 10
          FPMAX  = FPINT(J)
          NUMBER = J
          MAXPT  = JPOINT
          MAXBEG = JBEGIN
   10     JBEGIN = JBEGIN + JPOINT + 1
   20 CONTINUE
C  LET COINCIDE THE NEW KNOT T(NUMBER+K+1) WITH A DATA POINT X(NRX)
C  INSIDE THE OLD KNOT INTERVAL T(NUMBER+K) <= X <= T(NUMBER+K+1).
      IHALF  = MAXPT/2 + 1
      NRX    = MAXBEG + IHALF
      NEXT   = NUMBER + 1
      IF (NEXT.GT.NRINT) GO TO 40
C  ADJUSTS THE DIFFERENT PARAMETERS.
      DO 30 J = NEXT,NRINT
          JJ     = NEXT + NRINT - J
          FPINT(JJ+1) = FPINT(JJ)
          NRDATA(JJ+1) = NRDATA(JJ)
          JK     = JJ + K
          T(JK+1) = T(JK)
   30 CONTINUE
   40 NRDATA(NUMBER) = IHALF - 1
      NRDATA(NEXT) = MAXPT - IHALF
      FPINT(NUMBER) = FPMAX*FLOAT(NRDATA(NUMBER))/FLOAT(MAXPT)
      FPINT(NEXT) = FPMAX*FLOAT(NRDATA(NEXT))/FLOAT(MAXPT)
      JK     = NEXT + K
      T(JK)  = X(NRX)
      N      = N + 1
      NRINT  = NRINT + 1
      RETURN

      END

      SUBROUTINE DISCO(T,N,K2,B)
      IMPLICIT NONE
      INTEGER MXP
      PARAMETER (MXP=1000)
      INTEGER N,K1,K2,K,L,NK1,J,LP,LMK,IK,LJ,LK,JK,I
      REAL T(N),B(MXP,K2),H(12),PROD
C  SUBROUTINE DISCO CALCULATES THE DISCONTINUITY JUMPS OF THE KTH
C  DERIVATIVE OF THE B-SPLINES OF DEGREE K AT THE KNOTS T(K+2)..T(N-K-1)
C  THE FIRST DIMENSION SPECIFICATION OF THE MATRIX B MUST BE THE SAME AS
C  IN THE CALLING PROGRAM; H MUST HAVE A DIMENSION SPECIFICATION AT
C  LEAST 2*K+2.

      K1     = K2 - 1
      K      = K1 - 1
      NK1    = N - K1
      DO 40 L = K2,NK1
          LMK    = L - K1
          DO 10 J = 1,K1
              IK     = J + K1
              LJ     = L + J
              LK     = LJ - K2
              H(J)   = T(L) - T(LK)
              H(IK)  = T(L) - T(LJ)
   10     CONTINUE
          LP     = LMK
          DO 30 J = 1,K2
              JK     = J + K
              PROD   = 1.
              DO 20 I = J,JK
                  PROD   = PROD*H(I)
   20         CONTINUE
              LK     = LP + K1
              B(LMK,J) = (T(LK)-T(LP))/PROD
              LP     = LP + 1
   30     CONTINUE
   40 CONTINUE
      RETURN

      END

      REAL FUNCTION RATION(P1,F1,P2,F2,P3,F3)
      IMPLICIT NONE
      REAL P,P1,F1,P2,F2,P3,F3,H1,H2,H3
C  GIVEN THREE POINTS (P1,F1),(P2,F2) AND (P3,F3), FUNCTION RATION
C  GIVES THE VALUE OF P SUCH THAT THE RATIONAL INTERPOLATING FUNCTION
C  OF THE FORM R(P) = (U*P+V)/(P+W) EQUALS ZERO AT P.
      IF (P3.GT.0.) GO TO 10
C  VALUE OF P IN CASE P3 = INFINITY.
      P      = (P1* (F1-F3)*F2-P2* (F2-F3)*F1)/ ((F1-F2)*F3)
      GO TO 20
C  VALUE OF P IN CASE P3 ^= INFINITY.
   10 H1     = F1* (F2-F3)
      H2     = F2* (F3-F1)
      H3     = F3* (F1-F2)
      P      = - (P1*P2*H3+P2*P3*H1+P3*P1*H2)/ (P1*H1+P2*H2+P3*H3)
C  ADJUST THE VALUE OF P1,F1,P3 AND F3 SUCH THAT F1 > 0 AND F3 < 0.
   20 IF (F2.LT.0.) GO TO 30
      P1     = P2
      F1     = F2
      GO TO 40

   30 P3     = P2
      F3     = F2
   40 RATION = P
      RETURN

      END


      REAL FUNCTION DERIV(T,N,C,NK1,NU,ARG,L)
C  FUNCTION DERIV EVALUATES A SPLINE S(X) OF DEGREE K WHICH IS
C  GIVEN IN ITS NORMALIZED B-SPLINE REPRESENTATION OR CALCULATES
      IMPLICIT NONE
C  DERIVATIVES OF ANY SPECIFIED ORDER NU.
C
C  CALLING SEQUENCE
C     VALUE = DERIV(T,N,C,NK1,NU,ARG,L)
C
C  INPUT PARAMETERS:
C    T    : ARRAY,MINIMUM LENGTH N, WHICH CONTAINS THE POSITION
C           OF THE KNOTS OF S(X),I.E. THE POSITION OF THE INTERIOR
C           KNOTS T(K+2),...T(N-K-1) AS WELL AS THE POSITION OF THE
C           KNOTS T(1),...T(K+1) AND T(N-K),...T(N) WHICH ARE NEEDED
C           FOR THE B-SPLINE REPRESENTATION.
C    N    : INTEGER VALUE GIVING THE TOTAL NUMBER OF KNOTS OF S(X).
C    C    : ARRAY,LENGTH NK1, CONTAINING THE B-SPLINE COEFFICIENTS.
C    NK1  : INTEGER VALUE,GIVING THE DIMENSION OF S(X),I.E.NK1 = N-K-1.
C    NU   : INTEGER VALUE WHICH GIVES THE ORDER OF THE DERIVATIVE.
C    ARG  : REAL VALUE,GIVING THE VALUE OF THE ARGUMENT.
C    L    : INTEGER VALUE WHICH SPECIFIES THE POSITION OF THE ARGUMENT
C           I.E.   T(L) <= ARG <  T(L+1)   OR
C                  L = NK1 IF ARG = T(NK1+1).
C
C  OUTPUT PARAMETER:
C    VALUE: REAL VALUE,GIVING THE VALUE OF THE NUTH DERIVATIVE OF
C           S(X) AT X = ARG.
C
C  OTHER SUBROUTINES REQUIRED: NONE.
C
C  RESTRICTIONS:
C    1) NU >= 0
C    2) T(K+1) <= ARG <= T(NK1+1)
C  THE DIMENSION SPECIFICATION OF THE ARRAY H MUST BE AT LEAST K+1.
      INTEGER N,NK1,NU,L,I,J,K1,IK,JJ,NU1,NU2,LI,LJ
      REAL T(N),C(NK1),H(6),ARG

      DERIV  = 0.
      K1     = N - NK1
      IF (NU.LT.0 .OR. NU.GE.K1) RETURN
      DO 10 I = 1,K1
          IK     = L + I - K1
          H(I)   = C(IK)
   10 CONTINUE
      IF (NU.EQ.0) GO TO 40
      NU1    = NU + 1
      DO 30 J = 2,NU1
          DO 20 JJ = J,K1
              I      = J + K1 - JJ
              LI     = L + I - K1
              LJ     = L + I - J + 1
              H(I)   = (H(I)-H(I-1))/ (T(LJ)-T(LI))
   20     CONTINUE
   30 CONTINUE
      IF (NU.EQ.K1-1) GO TO 70
   40 NU2    = NU + 2
      DO 60 J = NU2,K1
          DO 50 JJ = J,K1
              I      = J + K1 - JJ
              LI     = L + I - K1
              LJ     = L + I - J + 1
              H(I)   = ((ARG-T(LI))*H(I)+ (T(LJ)-ARG)*H(I-1))/
     +                 (T(LJ)-T(LI))
   50     CONTINUE
   60 CONTINUE
   70 DERIV  = H(K1)
      IF (NU.EQ.0) RETURN
      DO 80 I = 1,NU
          DERIV  = DERIV*FLOAT(K1-I)
   80 CONTINUE
      RETURN

      END
 
      SUBROUTINE IERSPL (IER,LEVEL)
C
C. IDENTIFICATION
C
C     Author : P. BALLESTER    ESO-Garching
C
C     Versions :      1.00     27.06.90
C
C. PURPOSE
C
C     This subroutine displays error messages using MIDAS interface
C        STTPUT, depending on the error code returned by SMOSPL (IER)
C        and a level (LEVEL)
C
C. INPUTS :
C
C     IER   : Error code returned by the subroutine SMOSPL
C
C     LEVEL : = 0     No messages
C             = 1     Only severe error messages
C             = 2     Severe error messages and diagnosis
C             = 3     Maximum of information
C
C --- 
      IMPLICIT NONE
C
      INTEGER IER,LEVEL,STAT
      CHARACTER*80 STRING
C
      IF (IER.GT.0) THEN

         IF (LEVEL.GT.0) THEN
           STRING = 'Error while interpolating:'
           CALL STTPUT (STRING,STAT)
         ENDIF

         IF (LEVEL.GT.1) THEN

         IF (IER.EQ.1) THEN
            STRING = '--> Insufficient storage space'
            CALL STTPUT (STRING,STAT)
         ELSE IF (IER.EQ.2) THEN
            STRING = '--> Theoretically impossible result'
            CALL STTPUT (STRING,STAT)
            STRING = 
     + '    The requested relative accuracy is probably too small'
            CALL STTPUT (STRING,STAT)
         ELSE IF (IER.EQ.3) THEN
            STRING = '--> Maximal number of iterations has been reached'
            CALL STTPUT (STRING,STAT)
         ELSE IF (IER.EQ.10) THEN
            STRING = '--> Invalid input data'
            CALL STTPUT (STRING,STAT)
         ENDIF

         ENDIF

       ENDIF

       IF (IER.LE.0.AND.LEVEL.GT.2) THEN

          STRING = 'Warning : Normal return from spline interpolation'
          CALL STTPUT (STRING,STAT)

          IF (IER.EQ.-1) THEN
             STRING = 'S(x) is an interpolating spline'
             CALL STTPUT (STRING,STAT)
          ELSE IF (IER.EQ.-2) THEN
             STRING = 'S(x) is a polynomial of degree k'
             CALL STTPUT (STRING,STAT)
          ENDIF

       ENDIF
       RETURN
       END




       SUBROUTINE SORSPL (TAB,AUX1,AUX2,NP,SENSE)

C
C. IDENTIFICATION
C
C      Author : P. BALLESTER      ESO-Garching
C
C      Versions :        1.00       27.06.90
C                        1.10       17.07.90
C
C. PURPOSE
C
C      Sort values by increasing values in a 1D real array (TAB).
C      Elements of the auxiliary arrays AUX1 and AUX2 are also moved.
C      This subroutine is intended to be used before the SMOSPL routine
C      to sort the data, if necessary. The syntax is :
C                  CALL SORSPL (X,Y,W,NP,SENS)
C
C. INPUT/OUTPUT :
C
C      TAB     Real array   Address of the reference array
C      AUX1    Real array   Address of the first auxiliary array
C      AUX2    Real array   Address of the second auxiliary array
C      NP      Integer      Number of significant values in TAB,AUX1,AUX2
C      SENSE   Integer      >=0 = sort by increasing values
C                           <0 = sort by decreasing values
C
C. VERSIONS
C
C    1.00    Sort reference and auxiliary arrays by increasing values
C    1.10    Sort by increasing or decreasing values.
C
C. VERSION
C 051017	last modif
C -------------------------------------------------------------------------
C
       IMPLICIT NONE
C
       INTEGER FLAG,NP,PTR,SENSE
       REAL    TAB(NP),AUX1(NP),AUX2(NP),BUFFER,SS

       IF (SENSE.GE.0) SS =  1.0	! Sort by increasing values
       IF (SENSE.LT.0) SS = -1.0	! Sort by decreasing values

100    FLAG = 0
       DO 200 PTR = 1,NP-1

          IF ((SS*TAB(PTR)).GT.(SS*TAB(PTR+1))) THEN

              FLAG = 1

              BUFFER = TAB (PTR)
              TAB (PTR) = TAB (PTR+1)
              TAB (PTR+1) = BUFFER

              BUFFER = AUX1 (PTR)
              AUX1 (PTR) = AUX1 (PTR+1)
              AUX1 (PTR+1) = BUFFER

              BUFFER = AUX2 (PTR)
              AUX2 (PTR) = AUX2 (PTR+1)
              AUX2 (PTR+1) = BUFFER

          ENDIF
200    CONTINUE

       IF (FLAG.NE.0) GOTO 100

       RETURN
       END         




         SUBROUTINE ARGSPL (ARG,KNOTS,NBKNOT,DEGREE,PREPOS,POSARG,NK1)

         IMPLICIT NONE
         INTEGER  NBKNOT,DEGREE,POSARG
         REAL     ARG,KNOTS(NBKNOT)
         INTEGER   NK1,PREPOS,STAT
         CHARACTER STRING*80

         NK1 = NBKNOT - DEGREE - 1

         IF (ARG.EQ.KNOTS(NK1+1)) THEN
             POSARG = NK1
             GOTO 550
         ENDIF

         DO 500 POSARG = PREPOS , NK1
            IF (KNOTS(POSARG).LE.ARG.AND.ARG.LT.KNOTS(POSARG+1)) THEN
cd               WRITE (STRING,5500) POSARG,KNOTS(POSARG),ARG,KNOTS(POSARG+1)
cd               CALL STTPUT (STRING,STAT)
                 PREPOS = POSARG  
                GOTO 550
            ENDIF
500      CONTINUE

C
C --- 5.1.2. Cannot find argument position
C
         STRING = '*** Argument position not defined'
         CALL STTPUT (STRING,STAT)
         WRITE (STRING,5500) POSARG,KNOTS(POSARG),ARG,KNOTS(POSARG+1)
5500     FORMAT ('Pos : ',I5,' Relation : ',F6.1,' <',F6.1,' <',F6.1)
         CALL STTPUT (STRING,STAT)

550      RETURN
         END

C @(#)syst.for	19.1 (ES0-DMD) 02/25/03 13:30:49
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE SYST(N,A,C,JER)                                                
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++     
C.PURPOSE: System solution for polynomial of degree ideg=(sqrt(8*n+1)-2)/2      
C ----------------------------------------------------------------------        
      IMPLICIT         NONE
      INTEGER          N
      DOUBLE PRECISION A(21,22)
      DOUBLE PRECISION C(21)
      INTEGER          JER
C
      DOUBLE PRECISION B,P 
      INTEGER          I, I1
      INTEGER          K
      INTEGER          L
      INTEGER          J, J1
      INTEGER          N1, N2
                                                                                
      N1 = N - 1                                                                
      N2 = N + 1                                                                
      DO 60 I = 1,N1                                                            
         B      = DABS(A(I,I))                                                  
         I1     = I + 1                                                         
         K      = I                                                             
                                                                                
         DO 10 J = I1,N                                                         
            IF (B.GT.DABS(A(J,I))) GO TO 10                                     
            B      = DABS(A(J,I))                                               
            K      = J                                                          
   10    CONTINUE                                                               
         IF (B.EQ.0.0D0) GO TO 90                                               
         IF (K.EQ.I) GO TO 30                                                   
                                                                                
         DO 20 J = I,N2                                                         
            P      = A(K,J)                                                     
            A(K,J) = A(I,J)                                                     
            A(I,J) = P                                                          
   20    CONTINUE                                                               
                                                                                
   30    DO 50 J = I,N1                                                         
            J1     = J + 1                                                      
            P      = A(J1,I)/A(I,I)                                             
            DO 40 L = I1,N2                                                     
               A(J1,L) = A(J1,L) - P*A(I,L)                                     
   40       CONTINUE                                                            
   50    CONTINUE                                                               
   60 CONTINUE                                                                  
                                                                                
      IF (A(N,N).EQ.0.0D0) GO TO 90                                             
      C(N)   = A(N,N2)/A(N,N)                                                   
      DO 80 I = 1,N1                                                            
         J      = N - I                                                         
         P      = A(J,N2)                                                       
         DO 70 L = 1,I                                                          
            K      = N2 - L                                                     
            P      = P - C(K)*A(J,K)                                            
   70    CONTINUE                                                               
         C(J)   = P/A(J,J)                                                      
   80 CONTINUE                                                                  
                                                                                
      JER    = 0                                             ! no error         
      RETURN                                                                    
                                                                                
   90 CONTINUE                                                                  
      JER    = 1                                             ! error return     
      RETURN                                                                    
                                                                                
      END                                                                       

C @(#)avbgrd.for	19.1 (ES0-DMD) 02/25/03 13:25:31
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C
C
C-----------------------------------------------------------------------
      SUBROUTINE AVBGRD(L0, L2, PMTR, CRMD, ABGRD)
C
      IMPLICIT  NONE
      INCLUDE   'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER   L0
      INTEGER   L2
      REAL      PMTR(NRPAR,MAXCNT)
      REAL      CRMD(3)
      REAL      ABGRD
C
      INTEGER   L
      INTEGER   NOBJ
      REAL      SIGMA , TEMP(MAXCNT)
C
      NOBJ = L2 - L0
      DO 10 L = 1 , NOBJ
          TEMP(L) = PMTR(1,L)
   10 CONTINUE
C
      CALL MODE( TEMP , NOBJ , CRMD , ABGRD , SIGMA )
C
      RETURN
C
      END
C

C @(#)surface.for	19.1 (ES0-DMD) 02/25/03 14:25:41
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM SURFACE
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT        (c) 1988 European Southern Observatory
C.IDENTIFICATION   SURFACE
C.LANGUAGE         ESO-FOR
C.AUTHOR           Preben Grosbol (ESO-IPG)
C.KEYWORDS         Artificial objects, simulation
C.ENVIRONMENT      MIDAS
C.COMMENT          MIDAS command similar to the IHAP SURFACE command
C.PURPOSE          The command add an artificial object or mathematical
C                  surface to an existing frame
C.VERSION          1.0    1989-Feb-13 : Creation      (PJG)
C---------------------------------------------------------------------
C
      IMPLICIT NONE
      INTEGER MTROW
      PARAMETER  (MTROW=512)
C
      CHARACTER*2       METH
      CHARACTER*40      INAME,TNAME
      INTEGER           IAV,IERR,NA,ILAB
      INTEGER           NPIX(2),KUNIT(4),INULL
      INTEGER           IXF,IXL,IYF,IYL,I,I1,I2,NX,NY
      INTEGER           IDF,IMEM,IDX,IOFF,IA,IB,IX,IY,IVA
      REAL              CI,CP,SP,X,Y,XS,YS,DX,DY,XC,YC,XT,YT
      REAL              RL,R,SC,AMP,EL,ELIM,RQCNST,DTR
      REAL              FX,FY,FXX,FYY,FXY,FXXX,FYYY,FXXY,FYYX
      REAL              GA2RAN
      REAL              POSI(2),PROJ(2),PARM(10)
      REAL              VMADD(1)
C     REAL              SAMP(MTROW),SPHA(MTROW)
      DOUBLE PRECISION  START(2),STEP(2)
C
      COMMON /VMR/VMADD
C
      EQUIVALENCE (NX,NPIX(1)),(NY,NPIX(2))
      EQUIVALENCE (XS,START(1)),(YS,START(2))
      EQUIVALENCE (DX,STEP(1)),(DY,STEP(2))
      EQUIVALENCE (XC,POSI(1)),(YC,POSI(2)),(AMP,PARM(1))
C
      INCLUDE 'MID_REL_INCL:MIDAS_DEF.INC'
C
C     INITIATE MIDAS
C
      CALL STSPRO('SURFACE ',IERR)
C
C     INITIATE VARIABLES
C
      ELIM = -20.0
      RQCNST = -3.33
C
C     READ FRAME NAME AND OPEN IT
C
      CALL STKRDC('IN_A ',1,1,40,IAV,INAME,KUNIT,INULL,IERR)
      CALL STFOPN(INAME,D_R4_FORMAT,0,1,IDF,IERR)
C
C     READ FRAME DESCRIPTORS
C
      CALL STDRDI(IDF,'NAXIS ',1,1,IAV,NA,KUNIT,INULL,IERR)
      IF (NA.GT.2 .OR. IERR.NE.0) THEN
         CALL STTPUT('WRONG IMAGE DIMENSION >2 ',IERR)
         GOTO 90000
      ENDIF
      CALL STDRDI(IDF,'NPIX ',1,2,IAV,NPIX,KUNIT,INULL,IERR)
      CALL STDRDD(IDF,'START ',1,2,IAV,START,KUNIT,INULL,IERR)
      CALL STDRDD(IDF,'STEP ',1,2,IAV,STEP,KUNIT,INULL,IERR)
C
C     READ PARAMETERS 
C
      CALL STKRDR('POSITION ',1,2,IAV,POSI,KUNIT,INULL,IERR)
      CALL STKRDR('PARM ',1,10,IAV,PARM,KUNIT,INULL,IERR)
C
C     INITIATE VARIABLES
C
      IF (NA.LE.1) THEN
         NY = 1
         YS = 0.0
         DY = 1.0
         YC = 0.0
      ENDIF
      IYF = 1
      IYL = NY
      IXF = 1
      IXL = NX
      EL = ALOG(10.0) * ELIM
C
C     READ AND CHECK METHOD
C
      CALL STKRDC('METH ',1,1,2,IAV,METH,KUNIT,INULL,IERR)
      IF (METH.EQ.'PO') THEN
         ASSIGN 1000 TO ILAB
         FX = PARM(2)
         FY = PARM(3)
         FXX = PARM(4)
         FYY = PARM(5)
         FXY = PARM(6)
         FXXX = PARM(7)
         FYYY = PARM(8)
         FXXY = PARM(9)
         FYYX = PARM(10)
      ELSEIF (METH.EQ.'GA') THEN
         ASSIGN 2000 TO ILAB
         IF (PARM(2).LE.0.0) PARM(2) = 1.0E-10
         SC = -2.772589/(PARM(2)*PARM(2))
         RL = 0.7 * SQRT(EL/SC)
         IXF = MAX(1,MIN(NX,INT((XC-RL-XS)/DX)+1))
         IXL = MAX(1,MIN(NX,INT((XC+RL-XS)/DX)+1))
         IYF = MAX(1,MIN(NY,INT((YC-RL-YS)/DY)+1))
         IYL = MAX(1,MIN(NY,INT((YC+RL-YS)/DY)+1))
      ELSEIF (METH.EQ.'DI') THEN
         ASSIGN 3000 TO ILAB
         IF (PARM(2).LE.0.0) PARM(2) = 1.0E-10
         SC = -1.0/PARM(2)
         RL = 0.7 * EL/SC
         IXF = MAX(1,MIN(NX,INT((XC-RL-XS)/DX)+1))
         IXL = MAX(1,MIN(NX,INT((XC+RL-XS)/DX)+1))
         IYF = MAX(1,MIN(NY,INT((YC-RL-YS)/DY)+1))
         IYL = MAX(1,MIN(NY,INT((YC+RL-YS)/DY)+1))
      ELSEIF (METH.EQ.'EL') THEN
         ASSIGN 4000 TO ILAB
         IF (PARM(2).LE.0.0) PARM(2) = 1.0E-10
         SC = 1.0/PARM(2)
         RL = 0.7 * ((ELIM/RQCNST)**4)/SC
         IXF = MAX(1,MIN(NX,INT((XC-RL-XS)/DX)+1))
         IXL = MAX(1,MIN(NX,INT((XC+RL-XS)/DX)+1))
         IYF = MAX(1,MIN(NY,INT((YC-RL-YS)/DY)+1))
         IYL = MAX(1,MIN(NY,INT((YC+RL-YS)/DY)+1))
      ELSEIF (METH.EQ.'SP') THEN
         ASSIGN 5000 TO ILAB
         CALL STKRDC('IN_B ',1,1,40,IAV,TNAME,KUNIT,INULL,IERR)
      ELSEIF (METH.EQ.'NO') THEN
         ASSIGN 6000 TO ILAB
         IF (0.0.GT.PARM(2)) THEN
            IA = PARM(2)
            IB = PARM(3)
            IX = PARM(4)
         ELSE
            IA = 173
            IB = 3297
            IX = 11321
         ENDIF
         CALL USEED(IA,IB,IX)
      ELSE
         CALL STTPUT('METHOD NOT SUPPORTED ',IERR)
         GOTO 90000
      ENDIF
C
C     READ AND INITIATE PROJECTION 
C
      CALL STKRDR('PROJECT ',1,2,IAV,PROJ,KUNIT,INULL,IERR)
      DTR = ATAN(1.0D0)/45.0D0
      CI = COS(DTR*PROJ(1))
      CP = COS(DTR*PROJ(2))
      SP = SIN(DTR*PROJ(2))
C
C     GET MEMORY AND INITIATE VARIABLES
C
      CALL STFCRE('DUMMY ',D_R4_FORMAT,F_X_MODE,1,NX,IMEM,IERR)
      CALL STFMAP(IMEM,F_X_MODE,1,NX,IVA,IDX,IERR)
      IOFF = NX*(IYF-1) + 1
C
C     GO THROUGH FRAME LINE BY LINE
C
      Y = YS - YC + (IYF-1)*DY
      DO 100, IY = IYF,IYL
         CALL STFGET(IDF,IOFF,NX,IVA,VMADD(IDX),IERR)
         I1 = IDX + IXF - 1
         I2 = IDX + IXL - 1
         X = XS - XC + (IXF-1)*DX
         DO 300, I = I1,I2
            GOTO ILAB
C
C     POLYNOMIUM
C
 1000       CONTINUE
            VMADD(I) = VMADD(I) + AMP + X*(FX+X*(FXX+X*FXXX+Y*FXXY)) +
     +                 Y*(FY+X*FXY+Y*(FYY+Y*FYYY+X*FYYX))
            GOTO 200
C
C     GAUSSIAN
C
 2000       CONTINUE
            R = X*X + Y*Y
            VMADD(I) = VMADD(I) + AMP*EXP(SC*R)
            GOTO 200
C
C     EXPONENIAL DISK
C
 3000       CONTINUE
            XT = SP*X - CP*Y
            YT = CI * (CP*X + SP*Y)
            R = SQRT(XT*XT + YT*YT)
            VMADD(I) = VMADD(I) + AMP*EXP(R*SC)
            GOTO 200
C
C     ELLIPTICAL GALAXY : R**1/4 LAW
C
 4000       CONTINUE
            XT = SP*X - CP*Y
            YT = CI * (CP*X + SP*Y)
            R = SQRT(XT*XT + YT*YT)
            VMADD(I) = VMADD(I) + AMP*10.0**(RQCNST*(R*SC)**(0.25))
            GOTO 200
C
C     SPIRAL PATTERN
C
 5000       CONTINUE
            XT = SP*X - CP*Y
            YT = CI * (CP*X + SP*Y)
            R = SQRT(XT*XT + YT*YT)
            VMADD(I) = VMADD(I) + AMP
            GOTO 200
C
C     GAUSSIAN NOISE
C
 6000       CONTINUE
            VMADD(I) = VMADD(I) + AMP*GA2RAN()
C
  200       CONTINUE
            X = X + DX
  300    CONTINUE
         Y = Y + DY
         CALL STFPUT(IDF,IOFF,NX,VMADD(IDX),IERR)
         IOFF = IOFF + NX
  100 CONTINUE
C
C     FINISHED - EXIT
C
90000 CALL STFCLO(IDF,IERR)
      CALL STFCLO(IMEM,IERR)
      CALL STSEPI(IERR)
      END

C @(#)fmt.for	19.1 (ES0-DMD) 02/25/03 13:28:46
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
       SUBROUTINE SKYEQN(PG, SP, CARD)
C
C   Now display fitted equation:
C
C
      DOUBLE PRECISION SP(12)
      REAL PG(12)
C
      CHARACTER FMT*93, CARD*80
C
C
C
      CALL SPACE2
      CALL NEED(12)
      CALL CENTER('Representation of sky brightness:')
      CALL SPACE
C
C     Dark-sky term:
C
      CALL TV('      dark-sky term:')
C     Numerator exponent:
      CARD=' '
      CARD(70:)='2'
      CALL TV(CARD)
C     Numerator:
      FMT(:44)='(''('',1PE8.2,'' +/-'',E9.2,'') * M  +  ('')'
      FMT(36:)='('',1PE8.2,'' +/-'',E9.2,'') * M'')'
      WRITE(CARD(11:),FMT) PG(2),SP(2), PG(3),SP(3)
      CALL TVN(CARD)
C     Center line:
      CARD='SKY ='
      WRITE (CARD(7:),'(64(''-''),''   +'')')
      CALL TVN(CARD)
C     Denominator exponent:
      CARD=' '
      CARD(70:)='2'
      CALL TVN(CARD)
C     Denominator:
      CARD(7:11)='1 +'
      FMT(:44)='(''('',  F8.4,'' +/-'',F9.4,'') * M  +  ('')'
      FMT(36:)='('',  F8.4,'' +/-'',F9.4,'') * M'')'
      WRITE(CARD(11:),FMT) PG(4),SP(4), PG(5),SP(5)
      CALL TVN(CARD)
      CALL SPACE2
C
C     Moonlight term:
C
      CALL NEED(7)
      CALL TV('      moonlight term:')
      CALL SPACE2
C     First factor:
      FMT(:44)='(''M * [('',1PE8.2,''+/-'',E8.2,'')/E + ('')'
      FMT(36:)='('',1PE8.2,''+/-'',E8.2,'') + ('')'
      FMT(62:)='('',1PE8.2,''+/-'',E8.2,'')*E]'')'
      IF (PG(7).LT.0.) FMT(34:34)='-'
      WRITE(CARD,FMT) PG(6),SP(6), ABS(PG(7)),SP(7), PG(8),SP(8)
      CALL TVN(CARD)
C     Second factor:
      FMT(:44)='(2X,''* {exp[-('',  F7.4,'' +/-'',F8.4,'')*S] + ('')'
      FMT(44:)='('',F7.4,'' +/-'',F8.4,'')/P}   +'')'
      WRITE(CARD(1:),FMT) PG(9),SP(9), PG(10),SP(10)
      CALL TV(CARD)
      CALL SPACE2
C
C     Instrumental term:
C
      CALL NEED(4)
      CALL TV('      instrumental term:')
      FMT=
     1'(2X,''('',1PE8.2,'' +/-'',E9.2,'') * (signal of nearest star)'')'
      WRITE(CARD(1:),FMT) PG(11),SP(11)
      CALL TV(CARD)
C
C     Explanation:
C
      CALL SPACE
      CALL NEED(10)
      CALL TV('where')
      CALL TV('      M  is the airmass at the piece of sky observed')
      CALL TV(
     1   '      E  is its angular elongation (radians) from the Moon')
      CALL TV('      S  is the Sum of lunar and sky airmasses')
      CALL TV('      P  is the Product of lunar and sky airmasses')
      CALL SPACE
      CALL TV(
     1 'Note:  Moonlight term applies only when Moon is above horizon.')
      CALL SPACE
C
      END

C @(#)tsasca.for	19.1 (ESO-DMD) 02/25/03 13:33:26
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT (c) 1992 European Southern Observatory & Copernicus Astron. Center
C.IDENT     tsasca.for
C.AUTHOR    Alex Schwarzenberg-Czerny, Copernicus Astron. Center, Warsaw
C.KEYWORD   MIDAS, time series, SCARGLE/TSA
C.LANGUAGE  FORTRAN 77
C.PURPOSE   Compute discrete or Scargle power spectra
C.RETURNS   None
C.ENVIRON   TSA context
C.VERSION   0.0               June 1992
C 
C 021031	last modif
C 
C-----------------------------------------------------------------------------
C
C
      INCLUDE 'MID_REL_INCL:TSA_DEF.INC'
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      REAL*8       START(2)             !  START FREQUENCY
      REAL*8       STEP(2)              !  STEP IN FREQUENCY
      INTEGER      LENGTH(2)            !  NUMBER OF FREQUENCIES
      CHARACTER*60 INAME                !  NAME OF INPUT TABLE
      CHARACTER*60 ONAME                !  NAME OF OUTPUT IMAGE
C
      LOGICAL      SCARGL
      INTEGER      IACTS,KUN,KNUL
      INTEGER      TID,ITIME,IVAL
      INTEGER      NCOL,ICOL,NROW,IROW,ISOR
      INTEGER      LFIELD,TTYP,VTYP
      INTEGER      IDPER
      INTEGER      IDCMS,IDCPS,IDCD,IDSD,ASIZE
      INTEGER*8    PCMS,PCPS,PCD,PSD
      INTEGER*8    PTIME,PVAL,PPER
C 
      CHARACTER*10 FORM
      CHARACTER*80 TEXT
C
      INCLUDE 'MID_REL_INCL:TSA_DAT.INC'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      DATA SCARGL/.TRUE./
C
C   Get parameters
C
      CALL STSPRO ('tsasca')
      CALL STKRDC ('IN_A',  1,1,60,IACTS,INAME    ,KUN,KNUL,ISTAT)
      CALL STKRDC ('OUT_A', 1,1,60,IACTS,ONAME    ,KUN,KNUL,ISTAT)
      CALL STKRDD ('STARTTSA',   1, 1,IACTS,START(1) ,KUN,KNUL,ISTAT)
      CALL STKRDD ('STEPTSA',    1, 1,IACTS,STEP(1)  ,KUN,KNUL,ISTAT)
      CALL STKRDI ('NSTEPS',  1, 1,IACTS,LENGTH(1),KUN,KNUL,ISTAT)
C
C   Map input data
C
      CALL TBTOPN (INAME,F_I_MODE,TID,ISTAT)
      CALL TBIGET (TID,NCOL,NROW,ISOR,ICOL,IROW,ISTAT)
      CALL TBLSER (TID,'TIME',ITIME,ISTAT)
      IF (ITIME.LT.0) THEN
        CALL STETER(3,'Column :TIME not found')
      ENDIF
      CALL TBLSER (TID,'VALUE',IVAL,ISTAT)
      IF (IVAL.LT.0) THEN
        CALL STETER(4,'Column :VALUE not found')
      ENDIF
      CALL TBFGET (TID,ITIME,FORM,LFIELD,TTYP,ISTAT)
      CALL TBFGET (TID,IVAL, FORM,LFIELD,VTYP,ISTAT)
      CALL TBDGET (TID,ISTORE,ISTAT)
      IF (ISTORE.NE.F_TRANS) THEN
        TEXT='Input table '//INAME//' stored not transposed'
        CALL STETER(2,TEXT)
      ENDIF
      IF (TTYP.NE.D_R8_FORMAT.OR.VTYP.NE.D_R8_FORMAT) THEN
        CALL STETER(1,
     $    'Data column(s) must be of DOUBLE PRECISION type')
      ENDIF
      CALL TBCMAP (TID,ITIME,PTIME,ISTAT)
      CALL TBCMAP (TID,IVAL, PVAL, ISTAT)
C
C   Map temporary tables CMS,CPS,CD,SD
C
      CALL STFCRE('ZZMIDCMS',D_R8_FORMAT,F_X_MODE,F_IMA_TYPE,
     $   NROW,IDCMS, ISTAT)
      CALL STFMAP(IDCMS, F_X_MODE,1,NROW,ASIZE,PCMS, ISTAT)
C
      CALL STFCRE('ZZMIDCPS',D_R8_FORMAT,F_X_MODE,F_IMA_TYPE,
     $   NROW,IDCPS, ISTAT)
      CALL STFMAP(IDCPS, F_X_MODE,1,NROW,ASIZE,PCPS, ISTAT)
C
      CALL STFCRE('ZZMIDCD', D_R8_FORMAT,F_X_MODE,F_IMA_TYPE,
     $   NROW,IDCD,  ISTAT)
      CALL STFMAP(IDCD,  F_X_MODE,1,NROW,ASIZE,PCD,  ISTAT)
C
      CALL STFCRE('ZZMIDSD',D_R8_FORMAT,F_X_MODE,F_IMA_TYPE,
     $   NROW,IDSD,ISTAT)
      CALL STFMAP(IDSD,  F_X_MODE,1,NROW,ASIZE,PSD,  ISTAT)
C
C   Map output data
C
      LENGTH(2)=2
      START(2)=0.
      STEP(2)=1.
      CALL STIPUT (ONAME,D_R8_FORMAT,F_IO_MODE,
     $    F_IMA_TYPE,2,LENGTH,
     $   START,STEP,ONAME,
     $   'AXIS: 1/TIME DATA: UNITLESS',PPER,IDPER,ISTAT)
C
C   Compute Scargle periodogramme
C
      CALL TIMDFT(MADRID(PTIME),MADRID(PVAL),NROW,
     $    MADRID(PPER),LENGTH(1),MADRID(PCMS),MADRID(PCPS),
     $    MADRID(PCD),MADRID(PSD),START(1),STEP(1),SCARGL)
C
C   Wind-up
C
      CALL DSCUPT(IDPER,IDPER,' ',ISTAT)
      CALL STSEPI
C
      END
C
C
C
C
C

C @(#)spec3g.for	19.1 (ES0-DMD) 02/25/03 13:24:48
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
       PROGRAM SPEC3G
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C
C  Program SPEC3G           version 1.00        860908
C                           version 1.01        870609
C                                (Allow any no. of i/p lines.)
C                           version 2.00        890424 (pMIDAS)
C  F. Murtagh               STECF              
C  M. Peron                 IPG            890901 add include files
C  P. Ballester             IPG            910313 Compil. option -u
C                                                 and more
C
C.KEYWORDS
C  Simulated images, test images.
C
C.PURPOSE
C  Create spectrum of specified lines, each a gaussian in form.
C
C.OUTPUT
C
C  Keys:  OUT_A/C/1/60       output data array
C         INPUTR/R/1/1       centring relative to pixel centre
C         IN_TAB/C/1/60       table of positions of lines
C         INPUTR/R/2/1       full width half max. 
C
C-----------------------------------------------------------
C
C
       IMPLICIT NONE
C
       REAL                     RMIN,RMAX
       REAL                     STEPO(3),STARTO(3),CUTS(4)
       DOUBLE PRECISION         DSTEP(3),DSTART(3)
       INTEGER                  NPIXO(3),KUN,KNUL
       INTEGER                  MADRID
       CHARACTER*60              OUTIMA,INTAB
       CHARACTER*72              IDENTO
       CHARACTER*80              CUNITO
C
       INTEGER                  IACT,ISTAT,NDIMO,IDIM
       INTEGER*8                JPNTR
       INTEGER                  IMNO,TID
       INTEGER                  IACTV,NC,NR,NS,NAC,NAR
       INTEGER*8                IPTR
       INTEGER                  KUNIT
       REAL                     CENTR,FWHM
C
        INCLUDE                 'MID_INCLUDE:ST_DEF.INC/NOLIST'
        COMMON                  /VMR/MADRID(1)
        INCLUDE                 'MID_INCLUDE:ST_DAT.INC/NOLIST'

C
C
C ... get into MIDAS
C
       CALL STSPRO('SPEC3G')
C
C ... get name of output frame
C
        CALL STKRDC('OUT_A',1,1,60,IACT,OUTIMA,KUN,KNUL,ISTAT)
C
C ... get centring.
C
        CALL STKRDR('INPUTR',1,1,IACT,CENTR,KUN,KNUL,ISTAT)
C
C ... get gaussian fwhm.
C
        CALL STKRDR('INPUTR',2,2,IACT,FWHM,KUN,KNUL,ISTAT)
       IF (FWHM.LT.0.2) THEN
          CALL STTPUT(' The half maximum is too small (< 0.2).',ISTAT)
          CALL STTPUT(' Aborting.',ISTAT)
          GOTO 1000
       ENDIF
C
C ... map output image
C
       NDIMO = 1
       IDIM  = 660
       NPIXO(1)  = IDIM
       STARTO(1) = 1.0
       STEPO(1)  = 1.0
       CUNITO    = ' NONE'
       IDENTO    = ' ARTIFICIAL SPECTRUM' 
        DSTART(1) = STARTO(1)
        DSTEP(1)  = STEPO(1)
        CALL STIPUT(OUTIMA,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .                   NDIMO,NPIXO,DSTART,DSTEP,
     .                   IDENTO,CUNITO,JPNTR,IMNO,ISTAT)
C
C ... get line positions from table.
C
        CALL STKRDC('IN_TAB',1,1,60,IACTV,INTAB,KUN,KNUL,ISTAT)
        CALL TBTOPN(INTAB,0,TID,ISTAT)
        CALL TBIGET(TID,NC,NR,NS,NAC,NAR,ISTAT)
       IF (NC.LT.1.OR.NR.LT.1) THEN
          CALL STTPUT(' Invalid nos. of rows or columns.',ISTAT)
          CALL STTPUT(' in table specifying lines.',ISTAT)
          CALL STTPUT(' Aborting.',ISTAT)
          GOTO 1000
       ENDIF
       CALL TBCMAP(TID,1,IPTR,ISTAT)
C
C ... now do the work
C
       CALL PATTERN(MADRID(JPNTR),RMIN,RMAX,NR,MADRID(IPTR),CENTR,FWHM,
     X      ISTAT)
C
C ... write cuts
C
       CUTS(1) = RMIN
       CUTS(2) = RMAX
       CUTS(3) = RMIN
       CUTS(4) = RMAX
        CALL STDWRR(IMNO,'LHCUTS',CUTS,1,4,KUNIT,ISTAT)
C
C ... end
C
        CALL STFCLO(IMNO,ISTAT)
1000       CONTINUE
        CALL STSEPI
       END

C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C
C  Program PATTERN    
C  F. MURTAGH                                 ST-ECF  Version 1.0 860411
C
C.KEYWORDS
C
C  Test patterns, simulated images.
C
C
C.OUTPUT PARAMETERS
C 
C  ARR  = the frame,
C  RMIN, RMAX = cut values (max. and min. flux values).
C
C----------------------------------------------------------------------
       SUBROUTINE PATTERN(ARR,RMIN,RMAX,N,VALS,CENTR,FWHM,
     X                          ISTAT)
C
       IMPLICIT NONE
C
       REAL                ARR(660),VALS(1)
       REAL                GAUSS1(220),GAUSS2(220),GAUSS3(220)
C
       INTEGER             N,ISTAT,I,II,IVAL,III
       REAL                RMIN,RMAX,CENTR,FWHM,ZL,ZU,Y,SD,VAL,SCAL
C
C
C
       DO I = 1, 220
          GAUSS1(I) = 0.0             ! Initialize
          GAUSS2(I) = 0.0             ! Initialize
          GAUSS3(I) = 0.0             ! Initialize
       ENDDO
       SD = FWHM/2.354                ! Det. std. dev. from half width.
       DO I = 1, 660
          ARR(I) = 0.0                ! Initialize
       ENDDO
C
C ...   Det. flux for a Gaussian, with mean at (of offset from) 110.0.
C
       DO I = 1,220
          ZL = FLOAT(I)-0.5                   ! Pixel extremity (lower).
          ZU = FLOAT(I)+0.5                   ! Pixel extremity (upper).
          Y = 110.0                           ! Mean. 
          CALL AG(ZL,ZU,Y,SD,VAL)             ! Det. flux in given pixel.
          GAUSS1(I) = VAL
          Y = 110.5                           ! Mean offset by 0.5 pix. unit
          CALL AG(ZL,ZU,Y,SD,VAL)
          GAUSS2(I) = VAL
          Y = 110.0+CENTR                     ! Mean offset by user-def'd. val.
          CALL AG(ZL,ZU,Y,SD,VAL)
          GAUSS3(I) = VAL
       ENDDO
C
C ...   Do for segments 1-220,221-440,441-660 of ARR.
C
          DO II = 1,N
             IVAL = VALS(II)
C
             DO I = 1, 220
                III = I-110+IVAL
                IF (III.LE.0) GOTO 100
                IF (III.GT.220) GOTO 100
                   ARR(III) = ARR(III) + GAUSS1(I)         ! Segment 1-200
                   ARR(III+220) = ARR(III+220) + GAUSS2(I) ! Segment 201-440
                   ARR(III+440) = ARR(III+440) + GAUSS3(I) ! Segment 441-660
  100                CONTINUE
             ENDDO
C
          ENDDO
C
C ------DETERMINE CUTS (I.E. MAX AND MIN VALUES)---------------------
C
       RMIN = 10000.0
       RMAX = 0.0
       SCAL = 0.3989422804/SD                   ! For scaling to given height.
       DO I = 1, 660
          ARR(I) = ARR(I)/SCAL
          IF (ARR(I).GT.RMAX) RMAX = ARR(I) 
          IF (ARR(I).LT.RMIN) RMIN = ARR(I) 
       ENDDO
C 
C
       RETURN
C
       END
C-----------------------------------------------------------------------
       SUBROUTINE AG(X1,X2,M,SD,XINTOT) ! Driver for the integr. routine
C
       IMPLICIT NONE
C
       REAL       X1,X2,M,SD,INTG1,INTG2
C
       INTEGER    II
       REAL       XINTOT,X,XL,AGAUSS,XU,XINT
C
       XINTOT = 0.0
       X = (X2-X1)/100.0     ! Intervals in which integr. will take place.
       DO II = 1, 100
          XL = X1 + FLOAT(II-1)*X
          XU = X1 + FLOAT(II)*X
          INTG1 = 100.0*AGAUSS(XL,M,SD)
          INTG2 = 100.0*AGAUSS(XU,M,SD)
          IF (ABS(ABS(XL-M)-ABS(XU-M)).LE.1.0E-5) THEN 
C             Here, XL and XU are equally distanced from the mean.
             XINT = INTG1
             ELSE IF (XL.LE.M.AND.XU.GT.M) THEN
C                Here, XL is on one side, and XU on the other side of the mean.
                XINT = 0.5*ABS(INTG1-INTG2) + MIN(INTG2,INTG1)
             ELSE
                XINT = 0.5*ABS(INTG1-INTG2)       
          ENDIF
       XINTOT = XINTOT + XINT
       ENDDO
       RETURN
       END
C-------------------------------------------------------------------------
       FUNCTION AGAUSS(X,AVERAG,SIGMA)        ! (FROM BEVINGTON, P. 48)
C
       IMPLICIT NONE
C
       DOUBLE PRECISION Z,Y2,TERM,SUM,DENOM,SQR2
C
       REAL   X,AVERAG,SIGMA,AGAUSS
C
       SQR2 = DSQRT(2.D0)/2.0
       Z = ABS(X-AVERAG)/SIGMA
       AGAUSS = 0.0
       IF (Z.GT.5.0) THEN                       ! Precise enough ?
          AGAUSS = 1.0
          RETURN
       ENDIF
       IF (Z) 42,42,21
  21   TERM = SQR2 * Z
       SUM = TERM
       Y2 = (Z**2)/2.0
       DENOM = 1.0
  31    DENOM = DENOM + 2.0
       TERM = TERM*(Y2*2.0/DENOM)
       SUM = SUM + TERM
       IF (TERM/SUM -1.0E-10) 41,41,31
  41       AGAUSS = 1.128379167*SUM*DEXP(-Y2)
  42       RETURN
       END       

C @(#)planbot.for	19.1 (ES0-DMD) 02/25/03 13:29:09
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE PLANBOT(DJS,LASTD,NSTARS,NEEDST,JSYS,DRAT,BANDS,SALTS,
     1 PLACE,TELCM,TL,ITIME,ZONE)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT (c) Andrew T. Young, 1990
C.COPYRIGHT (c) European Southern Observatory, 1992
C.IDENT         program plan
C.MODULE        planbot.for
C.AUTHOR        Andrew T. Young
C.KEYWORD
C.LANGUAGE      FORTRAN 77
C.PURPOSE       Makes a photometric observing schedule
C.COMMENTS
C.VERSION       4.5
C.RETURNS       error numbers correspond to nearby statement numbers
C.ENVIRONMENT   MIDAS
C-----------------------------------------------------------------------------
C
C       Second half of old "plan" program.
C
C               Copyright (C) by Andrew T. Young, 1990
C
C
      IMPLICIT NONE
C
C *** SYSTEM-DEPENDENT FEATURES ARE FLAGGED BY *** COMMENTS LIKE THIS.
C
C   F I L E S :
C   -----------
C
      CHARACTER*80  DATFIL
C *** LENGTH OF FILE NAMES MAY BE SYSTEM-DEPENDENT.
C     FULL SET FOR SUBROUTINE COMPATIBILITY.
      INTEGER KB, KTV, K2, K3, K4, K7, K8, K9
      COMMON /FILNOS/ KB, KTV, K2, K3, K4, K7, K8, K9
C *** UNITS MAY BE SYSTEM-DEPENDENT.
C
C
C    N A M I N G   C O N V E N T I O N S :
C    ------------------------------------
C                                        EXTERNAL NAME          SAMPLE
C    QUANTITY       VARIABLE      TYPE   FOR DATA FILE           VALUE
C    --------       --------      ----   -------------          ------
C
C  NAMES:
C
C    PLACE NAME       PLACE       CH*20                      KITT PEAK
C    BAND NAME        BAND        CH*6
C    STAR NAME        STAR        CH*20      STAR              HR 8832
C    STAR CODE       STRCDS       CH*20     STARCD                  17
C    INDICES        CNAMES(1,NB)  CH*6     V, B-V, M1, ...       -0.20
C    GAIN CONTROL  GCONTR(NGAIN)  CH*20                         COARSE
C    GAIN SETTING   GANCOD(I,N)   CH*20   GAINS1, ... ,GAINS4        2
C
C  COORDINATES IN RADIANS:
C
C    LONGITUDE        ELONG       REAL
C    LATITUDE         ALAT        REAL
C    HOUR ANGLE       HA          REAL
C    RIGHT ASCENSION  RA          REAL
C    DECLINATION      DEC         REAL
C    UNIVERSAL TIME   UT          REAL
C    ZONE TIME        ZT          REAL
C    SIDEREAL TIME    ST          REAL
C
C      EXTERNAL SUB-UNITS ARE NAMED AS FOLLOWS:            TYPE
C                                                          ----
C      DEGREES      1ST 2 LETTERS OF REAL VARIABLE//'DEG'  REAL
C       HOURS        "  "    "    "   "      "    //'HRS'  REAL
C      MINUTES       "  "    "    "   "      "    //'MIN'  REAL
C      SECONDS       "  "    "    "   "      "    //'SEC'  REAL
C
C   SPECIAL FORMS:
C      ROTATIONS     "  "    "    "   "      "    //'ROT'  REAL
C     CHAR.STRING    "  "    "    "   "      "    //'STR'  CHARACTER*20
C        SIGN        "  "    "    "   "      "    //'SGN'  CHARACTER*20
C
C      EXAMPLES: RAHRS, UTMIN, ELSEC, ALDEG, DESTR, DESGN
C
C
C   P E P S Y S   S Y S T E M   V A R I A B L E S
C   ---------------------------------------------
C
      INTEGER MOBS
      PARAMETER (MOBS=10)
      CHARACTER *20  PLACE
C
      INCLUDE 'MID_REL_INCL:mstars.inc'
C     PARAMETER (MSTARS=1650)
C       commons for star catalog:
      CHARACTER *32 STARS
      COMMON /SCATA/ STARS(MSTARS)
      REAL RAS, DECS, EQUINX, COLORS
      COMMON /SCAT/ RAS(MSTARS), DECS(MSTARS), EQUINX(MSTARS), COLORS
C
C    CAUTION -- MBANDS IS IN SUBROUTINES RDLIST, OPNFIL, DECOLR, & EPHEM.
      INCLUDE 'MID_REL_INCL:mbands.inc'
C     PARAMETER (MBANDS=9)
      REAL COLORM, COLRIN,  XINV,YINV
      INTEGER NBANDS,LENB,LENC,KX,KY
      COMMON /CMAGS1/ COLORM(MBANDS,MBANDS),COLRIN(MBANDS,MBANDS),
     1 XINV,YINV,NBANDS,LENB,LENC,KX,KY
C
      REAL PHOMAG,FAINTS,BRITES,SZMAX,
     1 SZMIN,EXTIN,SIGTOT,TINT1,TSUGG
      COMMON /CMAGS2/PHOMAG(MBANDS),FAINTS(MBANDS),BRITES(MBANDS),SZMAX,
     1 SZMIN,EXTIN(MBANDS),SIGTOT,TINT1,TSUGG
      SAVE /CMAGS1/,/CMAGS2/
C
      CHARACTER *8  BANDS(3*MBANDS), CNAMES(2,MBANDS)
      DIMENSION COLORS(MBANDS,MSTARS)
      INTEGER MBM1,MBM2,MBM3,MBM4,MBM5,MBM6,MBM7
      PARAMETER(MBM1=MBANDS-1,MBM2=MBANDS-2,MBM3=MBANDS-3,MBM4=MBANDS-4)
      PARAMETER(MBM5=MBANDS-5,MBM6=MBANDS-6,MBM7=MBANDS-7)
C
      INTEGER MSYS
      PARAMETER (MSYS=8)
C
C
C  PARAMETERS FOR RDLIST/RDBLOK.
C
      INTEGER MGAINS,MG2,MA,MCAT,MN,MV,MGRPS,MAREST,MNREST
      PARAMETER (MGAINS=4, MG2=2*MGAINS)
      PARAMETER (MA=21+MG2+5)
      PARAMETER (MCAT=12+2*MBANDS,MN=MCAT+30, MV=MA+MN, MGRPS=8)
      PARAMETER (MAREST=MA-21-MG2, MNREST=MN-MCAT-15)
C
C  MA = MAX. ALPHABETIC (CHARACTER) VARIABLES,  AVAR  IN /NAMES/
C  MN = MAX. NUMERIC VARIABLES,                 VAR   IN /VALUES/
C  MV = MAX. VARIABLE NAMES,                    NAMES IN /NAMES/
C
C   COMMONS FOR RDLIST/RDBLOK.  NOTE RENAMING OF ELEMENTS OF AVAR.
C
C   THESE MA CHARACTER VARIABLES REPLACE AVAR(MA):
C     CHARACTER NAMES(MV)*6,TITLE*80, AVAR(MA)*20  <--REPLACED BY LIST.
C
      CHARACTER NAMES(MV)*6,TITLE*80
      CHARACTER*32 STAR
      CHARACTER*20 RASTR,DESTR,BAYER,CONSTL,FLAMST,BSHR,HD,DM,
     1 SPECT,DESGN,DATSTR,MONTH,REM1,REM2,STSTR,ZTSTR,UTSTR,
     2 FILTCD,STARCD,STRSKY,ASPARE(MAREST),GANCDN(MGAINS),DIMCDN(MGAINS)
C
C     COMMON /NAMES/NAMES,TITLE, AVAR
      COMMON /NAMES/NAMES,TITLE, RASTR,DESTR,STAR,BAYER,CONSTL,FLAMST,
     1 BSHR,HD,DM,SPECT,DESGN,DATSTR,MONTH,REM1,REM2,STSTR,ZTSTR,UTSTR,
     2 FILTCD,STARCD,STRSKY,ASPARE,GANCDN,DIMCDN
      EQUIVALENCE (CNAMES,NAMES(13))
C     13 BECAUSE CVARS IS VAR(13).
C
C   REAL VARIABLES THAT REPLACE VAR(MN):
C     COMMON /VALUES/ NAM1(MGRPS),NAM2(MGRPS),NGRPS,VAR(MN)
C
      INTEGER NAM1,NAM2,NGRPS,MURAT,MURAA,MUDEC
      REAL RAHRS,RAMIN,RASEC,
     1 DEDEG,DEMIN,DESEC,EPOCH,SIGNAL,TINT,
     2 CVARS,FMM,DD,YY,YEAR,DAY,
     3 UTHRS,UTMIN,UTSEC,CLKERR,STHRS,STMIN,STSEC,
     4 ZTHRS,ZTMIN,ZTSEC,VSPARE
      COMMON /VALUES/ NAM1(MGRPS),NAM2(MGRPS),NGRPS,RAHRS,RAMIN,RASEC,
     1 DEDEG,DEMIN,DESEC,EPOCH,MURAT,MURAA,MUDEC,SIGNAL,TINT,
     2 CVARS(2,MBANDS),FMM,DD,YY,YEAR,DAY,
     3 UTHRS,UTMIN,UTSEC,CLKERR,STHRS,STMIN,STSEC,
     4 ZTHRS,ZTMIN,ZTSEC,VSPARE(MNREST)
C
C
C   COMMONS FOR SPHERICAL TRIG.:
C
      REAL SINPHI,COSPHI,ELONG,ELROT,UTROT,STUTZ,TWOPI,ST2UT,
     1 TNOON1,TNOON2,PI,DEGRAD,ALAT
      COMMON /SPHERE/ SINPHI,COSPHI,ELONG,ELROT,UTROT,STUTZ,TWOPI,ST2UT,
     1 TNOON1,TNOON2,PI,DEGRAD,ALAT
C
C   COMMONS FOR SUN.
C
      REAL COSOB,SINOB,RASUN,DESUN,HASUN,SOLONG,ELMOON,BMOON
      COMMON /CSUN/ COSOB,SINOB,RASUN,DESUN,HASUN,SOLONG,ELMOON,BMOON
C
C   CAUTION -- THESE APPEAR IN SUBROUTINE FILL ALSO:
      INTEGER MSET,MROOM,MSG,MTIM
      PARAMETER (MSET=MSTARS-100,MROOM=2,MSG=14,MTIM=MROOM*MSET+MSG)
C
C  MSET IS MAX.LENGTH OF SUBSET CHOSEN FOR EXT./STD. STARS.
C  MTIM IS MAX.LENGTH OF EVENT TIMES.
C
      SAVE /CFILL/,/SPHERE/,/CSUN/,/HELPS/
C
      REAL UTBGN,UTEND,DARKT,TIMES
      INTEGER NOBJS,NT
      COMMON /CFILL/ UTBGN,UTEND,DARKT,TIMES(MTIM),NOBJS(MTIM),NT
C
C  TIMES(NT)  IS  EVENT TIME IN SCHEDULE.
C  NOBJS(NT)  IS  OBJECT NUMBER IN SUBSET OF EXT./STD.STARS.
C
C   COMMON FOR HELP COUNT:
      COMMON /HELPS/ NEEDH,NASSMP
      CHARACTER ASSMPS(8)*40,ASSUME(8)*40
      COMMON /ASSUME/ ASSMPS,ASSUME
      CHARACTER*13  F361
      COMMON /FMT361/ F361
      CHARACTER*79 PAGE(21)
      COMMON /SCREEN/PAGE
      INTEGER JCONT,JLOG,JDISP
      COMMON /FLAGS/JCONT,JLOG,JDISP
C
      LOGICAL PC,DC,CI,NEEDIM,CODEDS,DARK,FUNK,FCORN,
     1        COOLED
C
        COMMON /LOGIC/ NEEDED,DIMMED,PC,DC,CI,NEEDIM,CODEDS,DARK,FUNK,
     1                 FCORN,COOLED
C
C
C  CODEDS IS.TRUE.IF STARS ARE CODED IN DATA.
C  PC     IS.TRUE.IF DATA ARE PULSE COUNTS.
C  DC     IS.TRUE.IF DATA ARE CURRENTS.
C  CI     IS.TRUE.IF DATA ARE CHARGE INTEGRATIONS.
C  CANNED IS.TRUE.IF PLACE OR STDFIL IS BUILT-IN.
C  NEEDIM IS.TRUE.IF OPTICAL DIMMER IS NEEDED.
C  MOVING IS.TRUE.IF EPHEMERIS OBJECTS EXIST.
C
C
C   L O C A L   V A R I A B L E S
C   -----------------------------
C
      CHARACTER A,DMS*32,TL*4,FL(2)*5,
     1 TWILIT(MSG+2)*27,IDS(MTIM)*8,OSTAR*32,FF,
     2 DAT*30,ELABEL(2)*8,WLABEL(2)*8,ASSUM4(2)*40,ASSUM6(2)*40
      EQUIVALENCE (ASSUM4,ASSUME(4)),(ASSUM6,ASSUME(6))
      CHARACTER TEMPRH*34, RALBL*22,DECLBL*7
C
C  MSET IS MAX.LENGTH OF SUBSET CHOSEN FOR EXT./STD. STARS.  STORAGE:
C
C   NCAT(NOBJ)   IS  STAR-CATALOG INDEX OF OBJECT  NOBJ  IN SUBSET.
C   KTYPE(NOBJ)  IS  TYPE OF OBJECT.
C
C   XS(NOBJ) & YS(NOBJ)  ARE PLOTTING ARRAYS.
C
      REAL SALTS, DJS, XS,YS, RALIMS,DECLIM,REDS,BLUES
      INTEGER KTYPE
      DIMENSION SALTS(MSG),DJS(2),NCAT(MSET),XS(MSET),YS(MSET),
     1 KTYPE(MSET),RALIMS(2),DECLIM(2),REDS(2),BLUES(2)
C
C
      LOGICAL REDUCD,NEEDED,BAD,DIMMED
C
      INTEGER LASTD, NSTARS, NEEDST, JSYS, ITIME,
     1   NEEDH, NASSMP,
     2   NCAT, J, LD, NDIG, I, NEEDEX, NEEDS, NEXCES, NSET,
     3   NUMEXT, NB, K, NOBJ, NTYPE, N, NIGHT, LOOP, I1, NTIMES,
     4         LPP, LINE
C
      REAL DRAT, TELCM, ZONE, DJ,
     1    DAYN, T, OLDEQ, DATEP, OBLIQ, COSMIN, ZDMIN, SINDH, DH, STBGN,
     2    RABGN, STEND, RAEND, DELMAX, DELMIN, DEXMAX, DEXMIN, DUM,
     3    COSANG, AMAG, STZROT, PHASE, DMAG, SIND, COSD, COSZ, ARG,
     4         OLDCOS, RA, DEC, COSHA, HA, UT2ST
C
C   CHARACTER FCNS.:
C   ----------------
      CHARACTER DEG2MS*13, DEG2M1*8
C
C   LOGICAL FCNS.:
C   -------------
      LOGICAL HELP
C
C   INTEGER FCNS.:
C   -------------
      INTEGER LWORD
C
C
C   D A T A :
C   ---------
C
C  NUMERICAL VARIABLE NAMES ... (REALLY IN BLOCK DATA)
C
C       NAMX() =    1       2       3       4       5       6       7
C     DATA NAMES/'RAHRS','RAMIN','RASEC','DEDEG','DEMIN','DESEC','EPOCH'
C
C         8       9      10      11      12
C    1,'MURAT','MURAA','MUDEC','SIGNAL','TINT',
C
C        13 TO MCAT....        +1   +2   +3    +4    +5
C    2  MBANDS*' ',MBANDS*' ','MM','DD','YY','YEAR','DAY',
C
C   MCAT + 6      +7      +8      +9      +10     +11    +12
C    3 'UTHRS','UTMIN','UTSEC','CLKERR','STHRS','STMIN','STSEC',
C
C   MCAT+13      +14     +15     +16  TO  MCAT +30
C    4 'ZTHRS','ZTMIN','ZTSEC',     MNREST*' ',
C
C  CHARACTER VARIABLE NAMES...
C
C       MN+1    MN+2    MN+3   MN+4     MN+5     MN+6    MN+7  MN+8 MN+9
C    5 'RASTR','DESTR','STAR','BAYER','CONSTL','FLAMST','BSHR','HD','DM'
C
C        MN+10   MN+11   MN+12    MN+13  MN+14  MN+15   MN+16   MN+17
C    6 ,'SPECT','DESGN','DATSTR','MONTH','REM1','REM2','STSTR','ZTSTR',
C
C        MN+18   MN+19    MN+20    MN+21   MN+22  TO
C    7  'UTSTR','FILTCD','STARCD','STRSKY',MGAINS*' ',MGAINS*' ',
C
C        MN+
C    8  MAREST*' '/
C
C
C
C  SYSTEM DATA:
C
C     DATA SYSTMS/'UBV','UBVRI','UVBY','H-BETA','UVBYHB','GENEVA','DDO',
C    1 'OTHER'/
C     DATA JBANDS/ 3,      5,      4,      2,      6,      7,      6,
C    1   0/
C
C     DATA STDFLS/'UBVSTD','UBVSTD','UVBYST','UVBYST','UVBYST','GENSTD',
C    1 'DDOSTD',' '/
C
C     DATA LENBS/2,2,1,6,6,2,2,1/,LENCS/3,3,3,4,4,5,6,0/
C
C   BAND NAMES.
C     DATA BNDS/'U','B','V','RL',MBM4*' ',
C    2  'U','B','V','R','I','RL',MBM6*' ',
C    3  'U','V','B','Y',MBM4*' ',
C    4  'WIDE','NARROW',MBM2*' ',
C    5  'U','V','B','Y','WIDE','NARROW',MBM6*' ',
C    6  'U','B','V','B1','B2','V1','G',MBM7*' ',
C    7  '48','45','42','41','38','35',MBM6*' '     ,MBANDS*' '/
C
C   MAGNITUDE AND COLOR NAMES FOR EXTERNAL LISTS.
C     DATA BNDVAR/'V','U-B','B-V',MBM3*' ',
C    2  'V','U-B','B-V','V-R','R-I',MBM5*' ',
C    3  'V','B-Y','M1','C1',MBM4*' ',
C    4  'BETA','M4861',MBM2*' ',
C    5  'V','B-Y','M1','C1','BETA','M4861',MBM6*' ',
C    6  'VM','U-B','B-V','U-B2','B1-B2','B2-V1','V1-G',MBM7*' ',
C    7 'M48','C45-48','C42-45','C41-42','C38-41','C35-38',MBM6*' ',
C    8 MBANDS*' '/
C
C   EFF.WAVELENGTHS.
C     UBV:BUSER,A.&AP.62,411(1979); OTHERS FROM DUDLEY OBS.REPT.
C     DATA STDWLS/3652.,4417.,5505.,7000.,MBM4*0.,
C    2  3652.,4417.,5505.,6400.,8000.,7000.,MBM6*0.,
C    3  3425.,4110.,4670.,5510.,MBM4*0.,
C    4  4861.,4861.,MBM2*0.,
C    5  3425.,4110.,4670.,5510.,4861.,4861.,MBM6*0.,
C    6  3458.,4248.,5508.,4022.,4480.,5408.,5814.,MBM7*0.,
C    7  4886.,4517.,4257.,4166.,3815.,3460.,MBM6*0.     ,MBANDS*0./
C
C   WIDTHS.  THESE ARE ABOUT 2.64 X MU2.
C     DATA FWHMS/535.,980.,800.,300.,MBM4*0.,
C    2  535.,980.,800.,1400.,1700.,600.,MBM6*0.,
C    3  375.,200.,175.,250.,MBM4*0.,
C    4  150.,30.,MBM2*0.,
C    5  375.,200.,175.,250.,150.,30.,MBM6*0.,
C    6  450.,800.,800.,450.,440.,530.,540.,MBM7*0.,
C    7  186.,76.,73.,83.,330.,383.,MBM6*0.     ,MBANDS*0./
C   PEAK TRANSMISSIONS.
C     DATA TRANSS/.86,.73,.9,.9,MBM4*0.,
C    2  .86,.73,.9,.77,.86,.9,MBM6*0.,
C    3  .39,.49,.48,.53,MBM4*0.,
C    4  .75,.6,MBM2*0.,
C    5  .39,.49,.48,.53,.75,.6,MBM6*0.,
C    6  .65,.65,.5,.5,.34,.3,.3,MBM7*0.,
C    7  .56,.55,.53,.49,.65,.41,MBM6*0.,     MBANDS*0./
C
C   2-COLOR DIAGRAMS.                 O
C                   U  U  B  4  G     T
C                U  .  V  E  +  E  D  H
C                B  .  B  T  H  N  D  E
C                V  I  Y  A  B  V  O  R
C     DATA  KYS /2, 2, 4, 0, 4, 4, 2, 0/
C     DATA  KXS /3, 3, 2, 0, 2, 6, 3, 0/
C     DATA YINVS/1.,1.,0.,0.,0.,1.,0.,0./
C     DATA XINVS/0.,0.,0.,0.,0.,0.,0.,0./
C
C
      DATA FL/'FIRST',' LAST'/
C
C  DATA FOR SUN/MOON SET/RISE AND TWILIGHTS: (set in plantop)
C
C     DATA SALTS/-.0145,-.1045,-.208,-.309,-.309,-.208,-.1045,-.0145,
C   SUN ABOVE, MOON BELOW.
C    1 -.0145,-.0145,-.12,-.12,+.3,+.3/
C
      DATA TWILIT/'SUN SETS','END CIVIL TWILIGHT',
     1   'END NAUTICAL TWILIGHT'
     2,'END ASTRONOMICAL TWILIGHT','BEGIN ASTRONOMICAL TWILIGHT',
     3'BEGIN NAUTICAL TWILIGHT','BEGIN CIVIL TWILIGHT','SUN RISES',
C
     4'MOONRISE - FAST SKY CHANGES','MOONSET -- SKY CHANGES FAST',
     5'BEGIN LUNAR TWILIGHT','END LUNAR TWILIGHT',
     6'SKY CHANGES MORE SLOWLY','BEGIN RAPID SKY CHANGES',
     7'CHECK DARK LEVEL', 'BE SURE COOLING IS ON'/
C
      DATA ELABEL/' RISING','  EAST'/,WLABEL/' SETTING','  WEST'/
C
      DATA  DECLBL/'   DEC.'/,
     1 TEMPRH/'TEMP.=        R.H. =        U.T. ='/,
     2 RALBL/'       <----  R.A.    '/
C
      DATA RALIMS/24.,0./,DECLIM/0.,0./
C
C
C...................... EXECUTION resumes HERE ...............................
C
C
C  DJ IS JULIAN DATE FOR 0.HOURS U.T.
C
      DJ=DJS(1)+(INT(DJS(2)-DJS(1))/2)
C    PICK DAY IN MIDDLE OF RUN.
      CALL JD2DAT(DJ,DAT)
      PAGE(1)='MIDDLE U.T. DATE = '//DAT
      CALL TV(PAGE(1))
C   CREATE DATFIL.
       IF(CODEDS)THEN
      J=5
      IF(DAT(5:5).EQ.' ')J=6
      LD=12-J
      DATFIL=DAT(:3)//DAT(J:6)//'ID'
      OPEN(K7,FILE=DATFIL,STATUS='UNKNOWN')
       END IF
      OPEN(K9,FILE='PROUT',STATUS='UNKNOWN')
      CALL REHEAD(NDIG,DAT,CODEDS)
C     hope we use ASCII collating sequence...
      FF=CHAR(12)
C
      DAYN=DJ-2451545.0
C    DAYS FROM J2000.0 (SEE P.C24 OF 1984 A.A.).
      T=DAYN/36525.
C
C  PRECESS STARS HERE.
C
      OLDEQ=0.
      DATEP=2000.+T*100.
      DO 325 I=1,NSTARS
       IF(EQUINX(I).EQ.3.E33)THEN
C   MISSING EPOCH.
      IF(OLDEQ.EQ.0.)CALLTV('NO START EPOCH; stars cannot be precessed.'
     1)
      OLDEQ=3.E33
      GO TO 324
       END IF
C   Data referred to equinox of date:
      IF(EQUINX(I).EQ.0.)GOTO 325
C   PRECESS.
       IF(EQUINX(I).NE.OLDEQ)THEN
C    SET UP NEW INTERVAL.
      CALL PRECEP(EQUINX(I),DATEP,RAS(I),DECS(I))
      OLDEQ=EQUINX(I)
       ELSE
C    USE OLD INTERVAL.
      CALL PRECST(RAS(I),DECS(I))
       END IF
  324 EQUINX(I)=DATEP
  325 CONTINUE
C
       IF(OLDEQ.NE.3.E33)THEN
      WRITE(PAGE,328)DATEP
      CALL TV(PAGE(1))
      CALL TVN(' ')
      WRITE(K9,328)DATEP
  328 FORMAT(14X,'STARS HAVE BEEN PRECESSED TO',F9.2/)
       END IF
      OBLIQ=(23.43929-T*(1.30042E-2+T*(1.639E-7-T*5.036E-7)))*DEGRAD
      COSOB=COS(OBLIQ)
      SINOB=SIN(OBLIQ)
C    SET STUTZ (RADIANS).
      CALL STUTZR(T)
C
  330 SZMIN=1.1
      REDUCD=.FALSE.
C
C   HERE after SZMIN reset.
  331 IF(SZMIN.GT.1.2)WRITE(ASSUME(8),'(11X,''MIN.SEC Z ='',F6.3)')SZMIN
      COSMIN=1./SZMIN
      ZDMIN=ACOS(COSMIN)
      SINDH=SIN(ZDMIN)/COSPHI
C
      IF(SINDH.LE.1.)THEN
C   DH is the hour angle tangent to SZMIN almucantar.
        DH=ASIN(SINDH)
      ELSE
C   DH flags limit.
        DH=TWOPI
      END IF
C
C
C   Find STBGN,STEND & RABGN, RAEND.
      DO 340 I=3,6,3
        CALL UTSUN(DAYN,SALTS,I,*340)
C    UTROT is passed via /SPHERE/, HASUN via /CSUN/.
        IF(I.EQ.3)THEN
          UTBGN=UTROT
          STBGN=MOD(RASUN+HASUN+TWOPI,TWOPI)
          RABGN=MOD(RASUN+HASUN+TWOPI-DH,TWOPI)
        ELSE
          STEND=MOD(RASUN+HASUN+TWOPI,TWOPI)
          RAEND=MOD(RASUN+HASUN+TWOPI+DH,TWOPI)
          UTEND=UTROT
        END IF
  340 CONTINUE
C         STBGN is LST at start (end of nautical twilight); etc.
      IF(DH.EQ.TWOPI)THEN
        STBGN=0.
        STEND=TWOPI
      END IF
C
      DARKT=MOD(UTEND-UTBGN+1.,1.)
C    FEWER EXT.STARS NEEDED AT HIGH ELEVATIONS.
      NEEDEX=40.*DARKT*DRAT
C    ADD EXTRAS TO GET DEAD TIME.
      IF(NEEDED)NEEDEX=NEEDEX+4
      NEEDS=MAX(NEEDST,NEEDEX)
      NEXCES=(NEEDS*3)/2
C
C  SELECT EXTINCTION STARS.
C
      DELMAX=MIN(ALAT+ZDMIN,PI/2.)
      DELMIN=MAX(ALAT-ZDMIN,-PI/2.)
C   DELs limit stds.zone; DEXs limit ext.star zone.
      IF(JSYS.EQ.0)THEN
C   all ext.if no std.system.
         NEEDST=NEEDEX
      END IF
C
      XS(1)=SIN(DELMAX)
      XS(2)=SIN(DELMIN)
C===
      IF(NEEDEX.GE.NEEDST)THEN
          DEXMAX=DELMAX
          DEXMIN=DELMIN
      ELSE
C         DUM is zone height needed.
          DUM=((XS(1)-XS(2))*NEEDEX)/NEEDST
C         sines first.
          DEXMAX=(SINPHI+DUM)/2.
          DEXMIN=(SINPHI-DUM)/2.
C
          IF(DEXMAX.GT.XS(1))THEN
              DEXMAX=XS(1)
              DEXMIN=XS(1)-DUM
          ELSE IF(DEXMIN.LT.XS(2))THEN
              DEXMAX=XS(2)+DUM
              DEXMIN=XS(2)
          END IF
C
C         back to angles.
          DEXMAX=ASIN(DEXMAX)
          DEXMIN=ASIN(DEXMIN)
       END IF
C===
C
C   HERE AFTER FAINTS RESET.
  342 NSET=0
      NUMEXT=0
C
      DO 350 I=1,LASTD
C
C   Tests for POSITION:
C
C                  increasing R.A. -->
C
C  RA =  RABGN  STBGN            STEND  RAEND
C            |  |                    |  |
C            +-  --------------------  -+        <-- DELMAX
C            : /:                    :\ :
C            :/ :                    : \:
C      West  |  +                    +  |  East  <-- Delta = Phi
C            :\ :                    : /:
C            : \:                    :/ :
C            +-  --------------------  -+        <-- DELMIN
C
C   First, REJECT all OUTside "Bounding Box":
C        DEC limits violated...
      IF(DECS(I).GT.DELMAX .OR. DECS(I).LT.DELMIN  .OR.
C        ...or V.E. outside box and RA limits violated...
     1 (RABGN.LT.RAEND .AND. (RAS(I).LT.RABGN .OR. RAS(I).GT.RAEND))
C        ...or V.E. inside box and RA limits violated.
     2 .OR. (RAS(I).GT.RAEND .AND. RAS(I).LT.RABGN) ) GO TO 350
C       (note that this guarantees RABGN.GT.RAEND.)
C
C   Next, ACCEPT all INside "inscribed rectangle":
C        V.E. outside box and ST limits safe...
      IF ( (RAS(I).GT.STBGN .AND. RAS(I).LT.STEND)  .OR.
C        or V.E. inside box and ST limits safe.
     1 (STBGN.GT.STEND .AND. (RAS(I).LT.STEND .OR. RAS(I).GT.STBGN) )
     2  ) GO TO 343
C
C   We are now left with only the ends.
C     West end:
C        V.E. outside box and star between RABGN and STBGN...
      IF ( (RAS(I).GT.RABGN .AND. RAS(I).LT.STBGN)  .OR.
C        or V.E. inside box and ST limits safe.
     1 (RABGN.GT.STBGN .AND. (RAS(I).LT.STBGN .OR. RAS(I).GT.RABGN) )
     2  ) THEN
C       Check distance from Western pivot, at R.A.=STBGN, Dec.=Phi:
        COSANG=SIN(DECS(I))*SINPHI+COS(DECS(I))*COSPHI*COS(RAS(I)-STBGN)
        IF (COSANG.LT.COSMIN) GO TO 350
      ELSE
C     East end:
C       Check distance from Eastern pivot, at R.A.=STEND, Dec.=Phi:
        COSANG=SIN(DECS(I))*SINPHI+COS(DECS(I))*COSPHI*COS(RAS(I)-STEND)
        IF (COSANG.LT.COSMIN) GO TO 350
      END IF
C     Whatever falls through here is IN the semicircles at ends.
C
C   Test for MAGNITUDES.
  343 DO 345 NB=1,NBANDS
      AMAG=0.
      DO 344 K=1,NBANDS
  344 AMAG=AMAG+COLORS(K,I)*COLRIN(K,NB)
      IF(AMAG.GT.FAINTS(NB) .OR.
     1(.NOT.DC .AND.  AMAG.LT.BRITES(NB)))GO TO 350
  345 CONTINUE
      NSET=NSET+1
C   Is subset full?
      IF(NSET.GT.MSET)THEN
          CALL EXCEED(NSET,'MSET',MSET)
          CALL TV('REDUCE ACCEPTABLE RANGE.')
          NSET=MSET
          GO TO 385
      END IF
C   NO. File in list.
      XS(NSET)=RAS(I)*12./PI
      YS(NSET)=DECS(I)/DEGRAD
      DECLIM(1)=MIN(DECLIM(1),YS(NSET))
      DECLIM(2)=MAX(DECLIM(2),YS(NSET))
C    KTYPE =1 for STD., 2 for regular EXT., 3 for Special stars.
      KTYPE(NSET)=1
C    NCAT is catalog number.
      NCAT(NSET)=I
      IF(DECS(I).LT.DEXMAX .AND. DECS(I).GT.DEXMIN)THEN
         NUMEXT=NUMEXT+1
         KTYPE(NSET)=2
      END IF
C
       IF(.NOT.REDUCD .AND. NSET.GT.NEXCES)THEN
C    SHRINK ZONE IF TOO MANY STDS.
      SZMIN=(1.+3.*SZMIN)/4.
      REDUCD=.TRUE.
      GO TO 331
       END IF
  350 CONTINUE
C
      IF(NSET.LT.2 .OR. JSYS.EQ.0)GOTO356
C   GET COLOR RANGES.
      REDS(1)=COLORS(KY,NCAT(1))
      BLUES(1)=COLORS(KY,NCAT(1))
      REDS(2)=COLORS(KX,NCAT(1))
      BLUES(2)=COLORS(KX,NCAT(1))
      DO 351 NOBJ=2,NSET
      I=NCAT(NOBJ)
      REDS(1)=MAX(REDS(1),COLORS(KY,I))
      BLUES(1)=MIN(BLUES(1),COLORS(KY,I))
      REDS(2)=MAX(REDS(2),COLORS(KX,I))
  351 BLUES(2)=MIN(BLUES(2),COLORS(KX,I))
C    TEST NON-EXTINCTION STDS. FOR EXTREME COLORS.
      DO 352 NOBJ=1,NSET
      I=NCAT(NOBJ)
       IF(COLORS(KY,I).EQ.REDS(1) .OR. COLORS(KX,I).EQ.REDS(2) .OR.
     1 COLORS(KY,I).EQ.BLUES(1) .OR. COLORS(KX,I).EQ.BLUES(2))THEN
C    USE EXTREME-COLOR STAR FOR EXTINCTION.
      IF(KTYPE(NOBJ).EQ.1)NUMEXT=NUMEXT+1
      KTYPE(NOBJ)=3
       END IF
  352 CONTINUE
       IF(NEEDED)THEN
C$$$USE BRIGHTEST STARS TO IMPROVE DEAD TIME. (SET KTYPE=3)
       END IF
C
C   ENOUGH EXT.STARS?
C===
  356 IF(NUMEXT.LT.NEEDEX .OR. NSET.LT.NEEDST)THEN
C   NO. WIDEN ZONE.
C --
       IF(SZMIN.LT.1.25)THEN
      SZMIN=SZMIN+.05
      WRITE(PAGE,'(''  ONLY'',I3,'' STARS.  Expand min.secz to'',F6.3)')
     1 NSET,SZMIN
      CALL TV(PAGE(1))
      GO TO 331
C --
       ELSE
C --
       IF(NUMEXT.LT.NEEDEX)THEN
      WRITE(ASSUM4,358) NEEDEX,' EXTINCTION ',NUMEXT
      CALL TV(ASSUME(4))
      CALL TV(ASSUME(5))
       END IF
       IF(NSET.LT.NEEDST)THEN
      WRITE(ASSUM6,358) NEEDST,'TRANSFORMATION',NSET
      CALL TV(ASSUME(6))
      CALL TV(ASSUME(7))
       END IF
  358 FORMAT('You need about ',I2,1X,A,' stars,'/7X,'but only ',I2,
     1' are available.')
C    REVISE BRITES IF IT WILL HELP.
       IF(PC .AND. .NOT.(DC .OR. NEEDIM .OR. DIMMED))THEN
      NEEDIM=.TRUE.
      CALL BRITEN(BANDS,DIMMED)
      IF(DIMMED)GO TO 330
      NEEDIM=.FALSE.
       END IF
      CALL TV(' You need more STD.stars.')
      CALL ASK('Give up?',A)
      IF(A.EQ.'Y' .OR. A.EQ.'O')THEN
         IF(CODEDS)CLOSE(K7,STATUS='DELETE')
         CLOSE(K9,STATUS='DELETE')
         CALL TV('Too few stds. -- ABANDONED')
         CALL STSEPI
      END IF
C
       END IF
C --
      END IF
C===
C
      WRITE(PAGE,359)SZMIN,NUMEXT,NSET
  359 FORMAT(4X,'min.airmass =',F6.3,/I6,' Extinction stars,',I6,
     1' Total standards.')
      CALL TVN(PAGE(1))
      CALL TVN(PAGE(2))
      CALL TVN(' ')
      CALL RTNCON(' ',1)
C   LIST STDS.
      IF(NSET.EQ.0) GO TO 387
C
       IF(CODEDS)THEN
      WRITE(K9,360)'STANDARD'
  360 FORMAT(/4X,'CODE',2X,A8,' STARS'/)
      DO 370 NOBJ=1,NSET
      I=NCAT(NOBJ)
C     WRITE(K7,F361)NOBJ,STARS(I)
        CALL OUT361(K7,F361,NOBJ,STARS,I)
  370 CALL OUT361(K9,F361,NOBJ,STARS,I)
       END IF
C
      IF(NSET.LT.(3*NEEDST)/4)GO TO 387
C
      CALL PLOT(0,RALIMS,DECLIM,'L')
      CALL PLOT(0,79.,21.,'P')
      IF(NEEDH.GT.1)CALL TV('Standard Stars on sky  --   $  = overlaps')
      CALL TV(DECLBL)
      CALL PLOT(NSET,XS,YS,'*')
      CALL RTNCON(RALBL,22)
C   Plot on PROUT.
      DUM=K9
      CALL PLOT(0,DUM,DUM,'U')
      CALL PLOT(0,RALIMS,DECLIM,'L')
C     CALL PLOT(0,103.,(DECLIM(2)-DECLIM(1))/6.+6.,'P')
      CALL PLOT(0,79.,(DECLIM(2)-DECLIM(1))/6.+6.,'P')
      WRITE(K9,'(/1X,A)')DECLBL
      CALL PLOT(NSET,XS,YS,'*')
      WRITE(K9,'(A)')RALBL
      DUM=KTV
      CALL PLOT(0,DUM,DUM,'U')
C
      IF(NBANDS.LE.2)GO TO 385
      IF(NEEDH.GT.1) CALL TV(
     1'            X = EXTINCTION,  S = STD.STAR    $ = OVERLAP')
      WRITE(PAGE,381)CNAMES(1,KY)(:LENC),CNAMES(1,KX)(:LENC)
  381 FORMAT(/4X,A,'  vs. ',A,'  two-color diagram')
      CALL TV(PAGE(2))
      CALL PLOT(0,60.,23.,'P')
      CALL PLOT(0,XINV,YINV,'I')
      A='X'
C    MUST DO X FIRST TO SET LIMITS.
      DO 384 NTYPE=1,2
      N=0
      DO 382 NOBJ=1,NSET
      J=NCAT(NOBJ)
       IF(NTYPE.NE.2)THEN
      IF(KTYPE(NOBJ).LT.2) GO TO 382
       ELSE
      IF(KTYPE(NOBJ).GE.2) GO TO 382
       END IF
      N=N+1
      XS(N)=COLORS(KX,J)
      YS(N)=COLORS(KY,J)
  382 CONTINUE
      IF(N.NE.0) CALL PLOT(-N,XS,YS,A)
  384 A='S'
      CALL PLOT(1,99.,99.,A)
      TITLE='            ('//CNAMES(1,KX)(:LENC)//')'
      CALL RTNCON(TITLE,LENC+14)
C
  385 WRITE(PAGE,359)SZMIN,NUMEXT,NSET
      CALL TVN(PAGE(1))
      CALL TVN(PAGE(2))
       IF(NSET.GT.NEXCES)THEN
      WRITE(PAGE,'(/'' only'',I3,'' Stds.needed.'')')NEEDS
      CALL TV(PAGE(2))
      IF(NSET.GT.NEXCES+NEXCES)GO TO 387
       END IF
  386 CALL ASK('Are these stars OK?',A)
      IF(A.EQ.'Y' .OR. A.EQ.'O') GO TO 400
C
C  REVISE STAR LIST.
C
  387 IF(NEEDH.GT.0) THEN
          CALL TVN(' ')
          CALL TV(
     1      '(Reply "NO" to the next question if you want no changes.)')
      END IF
      CALL ASK('Change Sky Area or Magnitude Limits?',A)
C
C===
       IF(A.EQ.'S' .OR. A.EQ.'A')THEN
C
C   SKY AREA.
C --
       IF(NSET.LT.NEEDST)THEN
      A='E'
      CALL TV('TOO FEW Stds., so expand.')
       ELSE IF(NSET.GT.NEXCES)THEN
      A='S'
      CALL TV('TOO MANY Stds.,so shrink.')
       ELSE
      CALL ASK('Shrink or Expand?',A)
       END IF
C --
      IF(A.EQ.'S')THEN
       SZMIN=(1.+2.*SZMIN)/3.
      ELSE IF(A.EQ.'E')THEN
       SZMIN=SZMIN+.05
      ELSE
       GO TO 385
      END IF
C --
      WRITE(PAGE,'(/'' Try min.airmass ='',F6.3/)')SZMIN
      CALL TV(PAGE(2))
      IF(SZMIN.GE.1.2)CALL TV('CAUTION -- Should not exceed 1.25')
      CALL REHEAD(NDIG,DAT,CODEDS)
      IF(OLDEQ.NE.3.E33)WRITE(K9,328)DATEP
      GO TO 331
C =
       ELSE IF(A.EQ.'M' .OR. A.EQ.'L')THEN
C =
C   MAG.LIMITS.
C
      CALL MAGSET(BANDS)
      CALL REHEAD(NDIG,DAT,CODEDS)
      IF(OLDEQ.NE.3.E33)WRITE(K9,328)DATEP
      GO TO 342
C =
       ELSE IF(A.EQ.'N')THEN
      GO TO 386
C =
       ELSE IF(HELP(A))THEN
      CALL TV(
     1'You can expand sky area or set fainter limits to get more stars.'
     2)
      GO TO 387
C =
       ELSE
      GO TO 385
C =
       END IF
C===
C
  400 IF(NSTARS.EQ.LASTD)GO TO 405
C
C  ADD PROGRAM STARS.
C
      IF(CODEDS)WRITE(K9,360)'PROGRAM'
      J=NSET
      OSTAR=' '
      DO 402 I=LASTD+1,NSTARS
      IF(COLORS(MBANDS,I).GT.100. .AND. STARS(I).EQ.OSTAR) GO TO 402
C   USE 1ST EPHEMERIS ENTRY.
      J=J+1
C
       IF(J.GT.MSET)THEN
         CALL EXCEED(J,'MSET',MSET)
         CALL STETER(401, 'NOT ENOUGH ROOM FOR PGM.STARS')
       END IF
C
       IF(CODEDS .AND. STARS(I).NE.STARS(I-1))THEN
C          use 1st entry for ephemeris object.
           CALL OUT361(K7,F361,J,STARS,I)
           CALL OUT361(K9,F361,J,STARS,I)
       END IF
C
      KTYPE(J)=0
      NCAT(J)=I
  402 OSTAR=STARS(I)
      NSET=J
C
  405 IF(NBANDS.LE.2)GO TO 410
C
C       plot 2-color diagram on printed o/p.
C
      WRITE(K9,'(//18X,A)')'X = Extinction,  S = Std.star,  $ = overlap'
      WRITE(K9,381)CNAMES(1,KY)(:LENC),CNAMES(1,KX)(:LENC)
        DUM=K9
        CALL PLOT(0,DUM,DUM,'U')
      CALL PLOT(0,60.,32.,'P')
      CALL PLOT(0,XINV,YINV,'I')
      A='X'
C    MUST DO X FIRST TO SET LIMITS.
      DO 407 NTYPE=1,2
      N=0
      DO 406 NOBJ=1,NSET
      J=NCAT(NOBJ)
       IF(NTYPE.NE.2)THEN
      IF(KTYPE(NOBJ).LT.2) GO TO 406
       ELSE
      IF(KTYPE(NOBJ).GE.2) GO TO 406
       END IF
      N=N+1
      XS(N)=COLORS(KX,J)
      YS(N)=COLORS(KY,J)
  406 CONTINUE
      IF(N.NE.0) CALL PLOT(-N,XS,YS,A)
  407 A='S'
      CALL PLOT(1,99.,99.,A)
      TITLE='                               ('//CNAMES(1,KX)(:LENC)//')'
      WRITE (K9,'(A)')TITLE
C
      WRITE (K9,'(A)')FF
C       Generate "Special Instructions" page:
      WRITE(K9,'(10X,''S P E C I A L   I N S T R U C T I O N S :'')')
      WRITE(K9,'(10X,''-----------------------------------------''//)')
      IF (FUNK)
     1    WRITE(K9,'(10X,''FIND OUT if RED-LEAK filter is cemented''/)')
      IF (FCORN)
     1    WRITE(K9,'(10X,''FIND OUT if RED-LEAK filter is Pyrex''/)')
      WRITE(K9,'(10X,''FIND OUT the ACTUAL condition of the optics:'')')
      WRITE(K9,'(54X,''.............''/)')
C
  410 CONTINUE
C
C   SUMMARIZE FINAL CONDITIONS.
C
       IF(NUMEXT.LT.NEEDEX)THEN
      NASSMP=NASSMP+2
      ASSMPS(NASSMP-1)=ASSUME(4)
      ASSMPS(NASSMP)=ASSUME(5)
       END IF
       IF(NSET.LT.NEEDST)THEN
      NASSMP=NASSMP+2
      ASSMPS(NASSMP-1)=ASSUME(6)
      ASSMPS(NASSMP)=ASSUME(7)
       END IF
       IF(SZMIN.GT.1.25)THEN
      NASSMP=NASSMP+1
      ASSMPS(NASSMP)=ASSUME(8)
       END IF
C
      IF(DC) TSUGG=TSUGG+TSUGG
      WRITE(K9,412)INT(TSUGG),SIGTOT
  412 FORMAT(//' Use integrations of AT LEAST',I3,' SECONDS to get',F6.3
     1,' mag.precision.'/)
C
      WRITE(K9,
     1 '(/'' BE SURE to fill in Temp. & R.H. data when you start a page.
     2'')')
C
C
C  *****  BEGIN LOOP OVER NIGHTS.
C
      DO 700 NIGHT=1,INT(DJS(2)-DJS(1)+1.5)
C
      DJ=(NIGHT-1)+DJS(1)
C   assemble double date.
      CALL JD2DAT(DJ-1.,DAT)
      CALL JD2DAT(DJ,DMS)
C   same YEAR?
      IF(DMS(8:11).EQ.DAT(8:11))THEN
C    same MONTH?
       IF(DMS(:3).EQ.DAT(:3))THEN
        DAT(7:)='-'//DMS(5:11)
C    Different MONTHS.
       ELSE
        DAT(7:)='/'//DMS(:11)
       END IF
C   Different YEARS.
      ELSE
       DAT(12:)='/'//DMS
      END IF
C
        PAGE(1)='Working on: '//DAT
        CALL TV(PAGE(1))
      DAYN=DJ-2451545.0
      T=DAYN/36525.
      CALL STUTZR(T)
      STZROT=STUTZ/TWOPI
C
C  SUN & MOON AT MIDNIGHT.
      CALL SUN(DAYN-ELROT)
C   STORED SOLONG; MOON NEXT.
      CALL MOON(T-ELROT/36525.,0.)
C    DOT PROD. IS COS(PHASE).
      PHASE=ACOS(COS(ELMOON)*COS(BMOON)*COS(SOLONG+PI) +
     1 SIN(ELMOON)*COS(BMOON)*SIN(SOLONG+PI))
C    ROUGIER'S PHASE FCN.(P&S,P.289), IN RAD.
      DMAG=PHASE*(1.748+PHASE*(-.335+PHASE*.197))
      NT=10
C
       IF(DMAG.LT.6.8)THEN
C   TWILIGHT LIMIT.
      SALTS(11)=.0154*DMAG-.12
      SALTS(12)=SALTS(11)
      NT=12
       END IF
C
       IF(PHASE.GT.2.)GO TO 425
C   AIR-MASS CHANGES .04/MIN.=9.17/RAD.  N.B.:MOON IN SOLAR SLOTS.
      SIND=SIN(DESUN)
      COSD=COS(DESUN)
C   STARTING VALUE: ASSUME SIN H = 1.
      COSZ=SQRT(COSD*COSPHI/9.17)
      BAD=.FALSE.
  420 DO 423 LOOP=1,9
      ARG=COSD*COSD*COSPHI*COSPHI-(COSZ-SIND*SINPHI)**2
       IF(ARG.LT.0.)THEN
      IF(BAD) GO TO 425
      BAD=.TRUE.
      COSZ=0.09
      GO TO 420
       ELSE
      OLDCOS=COSZ
      COSZ=SQRT(SQRT(ARG)/9.17)
      IF(BAD)COSZ=(COSZ+OLDCOS)*.5
       END IF
      IF(ABS(COSZ-OLDCOS).LT..001)GO TO 424
  423 CONTINUE
  424 NT=14
C    ALT.IS COMP.OF Z.
      SALTS(13)=ASIN(COSZ)
      SALTS(14)=SALTS(13)
C
  425 UTBGN=0.
      UTEND=0.
      DO 430 I=1,NT
      TIMES(I)=3.E33
C
       IF(I.LE.8)THEN
C   SUN.
      CALL UTSUN(DAYN,SALTS,I,*430)
      IF(I.EQ.3)UTBGN=UTROT
      IF(I.EQ.6)UTEND=UTROT
       ELSE
C   MOON.
      CALL UTMOON(T,SALTS,I,*430)
      IF(UTROT.LT.UTBGN .OR. UTROT.GT.UTEND) GO TO 430
       END IF
C
C  STORE EVENTS IN LOG.
      TIMES(I)=UTROT
C    NEG.NOBJS FLAGS NONSTELLAR EVENT.
      NOBJS(I)=-I
  430 CONTINUE
C
      IF(UTEND.EQ.UTBGN)THEN
          CALL TV('TWILIGHT ALL NIGHT')
          CALL STETER(431, 'NO DARKNESS.')
      END IF
      DARKT=MOD(UTEND-UTBGN+1.,1.)
C    NEEDED BY FILL.
C
      IF (DARK) THEN
C   DO N DARKS.
          N=72.*DARKT+2.
          DUM=DARKT/(N-1)
          I1=NT+1
          NT=NT+N
          DO 432 I=I1,NT
          TIMES(I)=UTBGN+DUM*(I-I1)
  432     NOBJS(I)=-15
      END IF
C
C     add reminder about cooling...
      IF(COOLED)THEN
          NT=NT+1
          NOBJS(NT)=-16
          TIMES(NT)=UTBGN-1./8.
      END IF
C
C  LOOP OVER STARS.
C
      DO 450 NOBJ=1,NSET
      I=NCAT(NOBJ)
       IF(COLORS(MBANDS,I).LT.100.)THEN
C   NORMAL STAR.
      RA=RAS(I)
      DEC=DECS(I)
       ELSE
C   EPHEMERIS OBJECT AT MIDNIGHT.
      CALL EPHEM(I,(DJ-2400000.)-ELROT,COLORS,RA,DEC)
       END IF
C
C   SET UP FOR RISE/SET FIRST.
      COSZ=0.423
C    FIND HA FOR SECZ=2.36
C
      DO 443 J=1,2
      COSHA=(COSZ-SIN(DEC)*SINPHI)/(COSPHI*COS(DEC))
      IF(ABS(COSHA).GT.1.0)GOTO445
      HA=ACOS(COSHA)
C    USE TRANSIT ONLY, IF E/W ARE CLOSE.
      IF(HA.LT.0.1)GO TO 445
C    EAST.
      CALL FILL(RA-HA,NOBJ,*442)
C    FINDS NT; STORES UTROT IN TIMES(NT) IF UT IS OK;
C    GOES TO 442 IF UT NOT IN (UTBGN,UTEND).
      IDS(NT)=ELABEL(J)
C    WEST.
  442 CALL FILL(RA+HA,NOBJ,*443)
      IDS(NT)=WLABEL(J)
C
C    SET FOR ZENITH STARS.
  443 COSZ=COSMIN
C
      IF(HA.GT.0.1)GO TO 450
C    SKIP TRANSIT IF EAST/WEST ZENITH ALREADY.
C
C   TRANSIT.
  445 CALL FILL(RA,NOBJ,*450)
      IDS(NT)=' TRANSIT'
  450 CONTINUE
      NTIMES=NT
        CALL SORTBL(NTIMES,TIMES,NOBJS,IDS)
C
C  LIST FINAL RESULTS.
C
      N=INDEX(PLACE,'Obs')
      IF (N.GT.0) PLACE(N:)=' '
      N=LWORD(PLACE)
      IF(N.LE.12) WRITE(PLACE(N+1:),'(I5,''-cm'')') INT(TELCM)
C
      UT2ST=1./ST2UT
C     lines/page:
      LPP=55
C     page heading:
      WRITE(K9,640)FF,DAT,DJ,PLACE,TEMPRH,TL,(CNAMES(1,NB),NB=1,NBANDS)
  640 FORMAT(A1/1X,A28,'  Julian Date ',F10.1,3X,'at',2X,A20//17X,A34/
     1 23X,'......',8X,'......',8X,'..........'//
     2 3X,A4,10X,'EVENT',27X,'R.A.',10X,'DEC.',7X,A6/' -------',3X,
     3 '----------------------------',7X,'----------',4X,'----------',
     4 3X,A6/(73X,1A6))
      LINE=NBANDS+5
C
C               ****  BEGIN output loop over stars  ****
C
      DO 670 I=1,NTIMES
      IF(TIMES(I).EQ.3.E33)GO TO 670
C   Page Heading:
C    Zone time.
      IF(ITIME.EQ.2) TIMES(I)=TIMES(I)-ZONE
C    LST.
      IF(ITIME.EQ.3) TIMES(I)=TIMES(I)*UT2ST+STZROT+ELROT
      UTSTR=DEG2M1(MOD(TIMES(I)+2.,1.)*24.)
C=====
      IF(NOBJS(I).GT.0) GOTO 660
      IF(LINE.GT.LPP-3) THEN
          WRITE(K9,640)FF,DAT,DJ,PLACE,TEMPRH,TL,
     1                 (CNAMES(1,NB),NB=1,NBANDS)
          LINE=NBANDS+5
      END IF
C   Do SUN & MOON.
      WRITE(K9,650) UTSTR,TWILIT(-NOBJS(I))
  650 FORMAT(3X,'h  m'/A9,1X,A28/)
C =
      LINE=LINE+3
      GOTO 670
C =
C   Here for other objects.
  660 J=NCAT(NOBJS(I))
      IF(LINE.GT.LPP-(NBANDS+2)) THEN
          WRITE(K9,640)FF,DAT,DJ,PLACE,TEMPRH,TL,
     1                 (CNAMES(1,NB),NB=1,NBANDS)
          LINE=NBANDS+5
      END IF
C --
      IF(COLORS(MBANDS,J).GT.100.)GOTO 663
C    FIXED STAR.
      RASTR=DEG2MS(RAS(J)/DEGRAD/15.)
      DESTR=DEG2MS(DECS(J)/DEGRAD)
       GOTO 665
C    Moving.
  663 CALL EPHEM(J,(DJ-2400000.)+TIMES(I),COLORS,RA,DEC)
      RASTR=DEG2MS(MOD(RA/TWOPI+1.,1.)*24.)
      DESTR=DEG2MS(DEC/DEGRAD)
C --
  665 CALL OUTP(UTSTR,STARS,I,J,IDS,NOBJS,RASTR,DESTR,COLORS,NBANDS)
      LINE=LINE+NBANDS+2
C=====
  670 CONTINUE
C
C               ****  END output loop over stars  ****
C
      WRITE(K9,'(/17X,A34)')TEMPRH
C
C  END LOOP OVER NIGHTS.
C
  700 CONTINUE
C
C
C  EPILOGUE:
C
      CALL TVN(' ')
       IF(NASSMP.LE.NEEDH+2)THEN
      WRITE(K9,'(//'' END OF RUN.'')')
      CALL TV('Thanks for using PEPSYS3''s Planner.')
       END IF
C
      CALL TV('DON''T FORGET to send (PROUT) to the printer.')
      CALL TVN(' ')
C
      NOBJ=3+(NSET/NEEDST)+(NUMEXT/NEEDEX)
       IF(NASSMP.NE.0 .AND. NASSMP.LT.NOBJ)THEN
      CALL TV('     * * *   C A U T I O N :   * * *')
      CALL TVN(' ')
      WRITE(K9,'(///6X,''C A U T I O N :''/)')
C     WRITE(PAGE,'(A40,A39)')(ASSMPS(I),I=1,NASSMP)
      CALL TV(' ')
      DO 997 I=1,NASSMP
  997 CALL TVN(ASSMPS(I))
      WRITE(K9,'(1X,A40/)')(ASSMPS(I),I=1,NASSMP)
      CALL TVN(' ')
       ELSE IF(NASSMP.GE.NOBJ)THEN
C    NEW PAGE IF NEEDED.
      IF(LINE.GT.LPP-NASSMP*2-3)WRITE(K9,640)
      WRITE(K9,'(//)')
      CALL SXB(K9,ASSMPS,NASSMP)
      CALL SXB(KTV,ASSMPS,NASSMP)
       END IF
C
      REWIND K9
      CLOSE(K9,STATUS='KEEP')
      IF(CODEDS)CLOSE(K7,STATUS='KEEP')
C
      CALL TV('NORMAL END of PLANNER')
C       Restore flags:
      CALL STECNT('PUT',JCONT,JLOG,JDISP)
      CALL STSEPI
C  return code = 0 if no argument.
      END
        SUBROUTINE OUT361(KUNIT,FMT,NOBJ,STARS,I)
C
      IMPLICIT NONE
C
      INTEGER KUNIT, NOBJ, I
C
        CHARACTER FMT*13 ,STARS(I)*32
        WRITE(KUNIT,FMT)NOBJ,STARS(I)
        RETURN
        END
      SUBROUTINE SORTBL(NTIMES,TIMES,NOBJS,IDS)
C
      IMPLICIT NONE
C
      REAL TIMES,DUM
      INTEGER NTIMES,NOBJS,I,M,J,JJ
C
      DIMENSION TIMES(NTIMES),NOBJS(NTIMES)
        CHARACTER*8 IDS(NTIMES), STR8
C
C  SORT ENTRIES.
C
      I=1
  453 I=I+I
      IF(I.LE.NTIMES)GO TO 453
      M=I-1
  455 M=M/2
      IF(M.EQ.0) RETURN
      DO 460 JJ=1,NTIMES-M
      DO 458 I=JJ,1,-M
      IF(TIMES(I+M).GE.TIMES(I)) GO TO 460
      DUM=TIMES(I)
      TIMES(I)=TIMES(I+M)
      TIMES(I+M)=DUM
      J=NOBJS(I)
      NOBJS(I)=NOBJS(I+M)
      NOBJS(I+M)=J
      STR8=IDS(I)
      IDS(I)=IDS(I+M)
      IDS(I+M)=STR8
  458 CONTINUE
  460 CONTINUE
      GO TO 455
      END
      SUBROUTINE OUTP(UTSTR,STARS,I,J,ID,NOBJ,RA,DE,COLORS,NBANDS)
C
      IMPLICIT NONE
      INTEGER I, J, NOBJ, NBANDS, KB, KTV, K2, K3, K4, K7, K8, K9, LEN,
     1         LOWER, KBR, K
      REAL COLORS
C
      INCLUDE 'MID_REL_INCL:mstars.inc'
      INCLUDE 'MID_REL_INCL:mbands.inc'
C     PARAMETER (MBANDS=9,MSTARS=1650)
      DIMENSION NOBJ(I),COLORS(MBANDS,MSTARS)
      CHARACTER*32 STARS(J)
      CHARACTER*20 STAR1,STAR2,RA,DE
      CHARACTER*8 UTSTR,ID(I)
      CHARACTER COMENT(MSTARS)*32,SPTYPE(MSTARS)*12,EMAG(MSTARS)*16
      COMMON /NOTES/COMENT,SPTYPE,EMAG
      COMMON /FILNOS/ KB, KTV, K2, K3, K4, K7, K8, K9
C
C     check name for >20 chars:
      DO 5 LEN=32,19,-1
      IF(STARS(J)(LEN:LEN).NE.' ') GO TO 8
    5 CONTINUE
      LEN=19
    8 CONTINUE
      IF (LEN.LE.20)THEN
          STAR1=STARS(J)
          STAR2=' '
      ELSE
C         split name to fit:
          LOWER=MAX(6,LEN-20)
          KBR=INDEX(STARS(J)(LOWER:21),'=')
          IF(KBR.EQ.0) THEN
              KBR=INDEX(STARS(J)(LOWER:23),'   ')
              IF (KBR.EQ.0)THEN
                  KBR=INDEX(STARS(J)(LOWER:22),'  ')
                  IF (KBR.EQ.0) THEN
                      KBR=INDEX(STARS(J)(LEN-20:21),'=')
                      IF(KBR.EQ.0) KBR=INDEX(STARS(J)(LEN-20:21),':')
                      IF(KBR.EQ.0) KBR=INDEX(STARS(J)(LEN-20:21),',')
                      IF(KBR.EQ.0) KBR=INDEX(STARS(J)(LEN-20:21),'.')
                      IF(KBR.EQ.0) KBR=INDEX(STARS(J)(LEN-20:21),' ')
                      KBR=KBR+LEN-21
                  ELSE
                      KBR=KBR+LOWER-1
                  END IF
              ELSE
                  KBR=KBR+LOWER-1
              END IF
          ELSE
              KBR=KBR+LOWER-1
          END IF
          STAR1=STARS(J)(:KBR-1)
          STAR2=STARS(J)(KBR:)
      END IF
C
      WRITE(K9,666) UTSTR,STAR1,ID(I),NOBJ(I),RA,DE,COLORS(1,J),
     1 STAR2, COLORS(2,J),
     2 COMENT(J),EMAG(J),SPTYPE(J), (COLORS(K,J),K=3,NBANDS)
  666 FORMAT(3X,'h  m',34X,'No.',4X,'h  m  s       o  ''  "'/
     1 A8,3X,A20,A8,I4,2(2X,A12),1X,F5.2/11X,A20,41X,F5.2/11X,A32,A16,
     2 1X,A12,F5.2/(72X,F5.2))
      IF (NBANDS.LT.3) WRITE(K9,'(1X)')
        RETURN
         END

C @(#)rfotmodel.for	19.1 (ES0-DMD) 02/25/03 13:30:15
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM MODEL
C+++
C.PURPOSE: Interpolation program for undersampling problem in ROMAFOT
C.AUTHOR:  R. Buonnanno
C.REVISED: R.H. Warmels
C.VERSION:  
C---------------
      IMPLICIT         NONE
C
      INTEGER          MTG(55,55)
      DOUBLE PRECISION DX,DY
      DOUBLE PRECISION IN,ER
      DOUBLE PRECISION DX0,DY0
      DOUBLE PRECISION VOLU,VOLG,TNOIS
      INTEGER          IAV, ISTAT
      INTEGER          IDX, IDY
      INTEGER          I, J, II
      INTEGER          INCR
      INTEGER          KUN, KNUL
      INTEGER          KVX, KVY
      INTEGER          KVM1, KVM2, KVM3, KVM
      INTEGER          MC, MR
      INTEGER          NCHAR
      INTEGER          NP3, NPUG, NSA
      INTEGER          NPX, NPY
      INTEGER          NTOT, NPXS, NPYS
C
      REAL             AMD, AML
      REAL             BAF
      REAL             BET, DITE, EFF, FCON
      REAL             COSTMA
      REAL             ERROLD, ERR
      REAL             FX, FY, FLUSSO, FSP
      REAL             H
      REAL             PMA, PPO, PG, PSF
      REAL             QS
      REAL             RINPUT(15)
      REAL             RMA, RON, RNOIS
      REAL             SEEING, SIG, SKYL
      REAL             TESP, TET
      REAL             XB, YB
      REAL             X0, Y0
      REAL             XA, YA
      REAL             VM, VX, VY, VT, VF
      REAL             VFCG, VFCGS
      REAL             GALE2
C
      CHARACTER        FRE*1,STRING*80,FILE*60
C
      DATA             PG/3.14159/
      DATA             SKYL/3.18E-06/
C
  999 FORMAT('*** INFO: Ratio FWHM over Pixel size =', E11.6)
  998 FORMAT(2X,I3,2X,I3,2X,A1)
  997 FORMAT(2X,F5.3,3(2X,F6.2),2X,F9.4)
  996 FORMAT(2(2X,F3.1),2X,F6.2)
  995 FORMAT(25I3)
C
C *** See in MIDAS a alive
      CALL STSPRO('MODEL')
C
C *** the default setting:
C                           DEFAULT:
C  SKYL=3.18E-06            photon surface brightness of the sky in 
C                           photons cm**-2 s**-1 A**-1 arcsec**-2
C                           corresponding to V=21.3 at 5500 A
C  SEEING1 = 1              seeing (in arcsec)
C  BET1    = 3              beta
C  DITE1   = 2.2            diameter of the telescope (metres)
C  BAF1    = 800.           bandwidth
C  EFF1    = .3             total efficiency 
C  FCON1   = 10             photons-to-ADU conversion factor
C  TESP1   = 1000.          exposure time
C  TET1    = .35            pixel size (in arcsec) 
C  RON     = 35             read out noise of the detector  
C  AMD1    = 23.            limiting magnitude (faint end)
C  AML1    = 18.            limiting magnitude (bright end)
C  PMA1    = .5             sampling in magnitude
C  PPO     = .1             positional accuracy??
C
C *** get the input parameters
      CALL STKRDR('INPUTR',1,13,IAV,RINPUT,KUN,KNUL,ISTAT)
      SEEING = RINPUT(1)                                            ! seeing
      BET    = RINPUT(2)
      DITE   = RINPUT(3)*100.
      BAF    = RINPUT(4)
      EFF    = RINPUT(5)
      FCON   = RINPUT(6)
      TESP   = RINPUT(7)
      TET    = RINPUT(8)
      RON    = RINPUT(9)
      AMD    = RINPUT(10)
      AML    = RINPUT(11)
      PMA    = RINPUT(12)
      QS     = RINPUT(13)
C
      FSP    = SEEING/TET
      SIG    = (SEEING/TET)/(2*SQRT(2**(1./BET)-1))
      PPO    = .1
      COSTMA = -2.5*ALOG10(FCON/(DITE**2*BAF*TESP*EFF*PG/4.))+7.5
      MR     = 7+INT(FSP/1.4+.7)*2
      IF (MR.GT.15) THEN
         MR = 15
      ENDIF
      MC     = MR
      IDX    = 0
      IDY    = 0
      X0     = MC/2
      Y0     = MR/2
      FRE    = 'N'
      XA     = INT(X0)-MC/2+IDX
      YA     = INT(Y0)-MR/2+IDY
      XB     = XA+MC
      YB     = YA+MR
C
C ***
      WRITE(STRING,999) FSP
      CALL STTPUT(STRING,ISTAT)
      CALL STKRDC('INPUTC',1,1,60,IAV,FILE,KUN,KNUL,ISTAT)
      NCHAR = INDEX(FILE,' ')-1
      FILE = FILE(1:NCHAR)//'.dat'
      OPEN(UNIT=1,STATUS='NEW',ACCESS='SEQUENTIAL',FORM='FORMATTED',
     2     FILE=FILE)
C
C *** write the output table
      WRITE(1,998) MR,MC,FRE
      WRITE(1,997) PPO,AMD,AML,PMA,COSTMA
C
      INCR = -INT(PPO*100+0.5)
      DO 1000 KVX = 50,0,INCR
         VX   = FLOAT(KVX)/100.
         X0   = MC/2+VX
         INCR = -INT(PPO*100+0.5)
         DO 1100 KVY = 50,KVX,INCR
            VY = FLOAT(KVY)/100.
            Y0 = MR/2+VY
            KVM1 = INT(100*AML+0.5)
            KVM2 = INT(100*AMD+0.5)
            KVM3 = INT(100*PMA+0.5)
            DO 1200 KVM = KVM1,KVM2,KVM3
               VM     =  FLOAT(KVM)/100.
               RMA    = VM
               FLUSSO = 10.**(-(RMA-7.5)/2.5)
               H      = (BET-1)*FLUSSO*DITE**2*BAF*TESP*EFF/
     2                  (4*SIG**2*FCON)
               FX     = X0-INT(X0)
               FY     = Y0-INT(Y0)
               WRITE(1,996) FX,FY,RMA
C
C *** calcuate matrix
               NP3   = 0
C              NPUG  = NPU
               VOLU  = 0.
               VOLG  = 0.
               TNOIS = 0.
               DO 1300 I=1,MR
                  YA=INT(Y0)-MR/2+I-1+IDY
                  DO 1400 J=1,MC
                     XA=INT(X0)-MC/2+J-1+IDX
C
C *** calcualte int vero
                     IF (BET.EQ.1.5) THEN
                        DX  = XA+1-X0
                        DY  = YA+1-Y0
                        DX0 = DX-1.
                        DY0 = DY-1.
                        ER  = SIG
                        VT  = H*(IN(DX,DY,ER)-IN(DX,DY0,ER)-
     2                          IN(DX0,DY,ER)+IN(DX0,DY0,ER))*ER**2
                     ELSE
                        VT  = GALE2(4,4,H,SIG,BET,XA,YA,X0,Y0)
                     END IF
                     FLUSSO = VT*FCON/(EFF*DITE**2*BAF*TESP*PG/4.)
                     RNOIS  = SQRT((FLUSSO+SKYL*TET**2.)*EFF*TESP*
     2                        BAF*DITE**2.*PG/4+RON**2)
C
                     TNOIS  = TNOIS+RNOIS**2
                     VOLU   = VOLU+VT
                     VF     = PSF(H,XA+.5,YA+.5,X0,Y0,SIG,BET)
C
                     IF (FRE.EQ.'N') THEN
                        VFCG = VF
                        ERR  = RNOIS*QS/FCON
                        NPUG = 1
 1401                   IF (ABS(VT-VFCG).LE.ERR.OR.NPUG.GT.5) GO TO 1402
                           NPUG = NPUG+1
                           VFCG = GALE2(NPUG,NPUG,H,SIG,BET,XA,YA,X0,Y0)
                           GO TO 1401
 1402                   CONTINUE
                        VOLG     = VOLG+VFCG 
                        MTG(I,J) = NPUG**2
                        NP3      = NP3+NPUG**2
                     ELSE
                        ERR      = RNOIS*QS/FCON
                        NSA      = 1000
                        ERROLD   = 10.E15
                        DO 1500 NPX=1,4
                           DO 1600 NPY=1,4
                              VFCG=GALE2(NPX,NPY,H,SIG,BET,XA,YA,X0,Y0)
                              IF (ABS(VT-VFCG).LT.ERR) THEN
                                 NTOT=NPX*NPY
                                 IF (NTOT.LE.NSA) THEN
                                    IF (ERR.LT.ERROLD. OR. 
     2                                  NTOT.NE.NSA) THEN
                                        NSA    = NTOT
                                        NPXS   = NPX
                                        NPYS   = NPY
                                        VFCGS  = VFCG
                                        ERROLD = ERR
                                     END IF
                                  END IF
                              END IF
 1600                      CONTINUE
 1500                   CONTINUE
C
                        VFCG     = VFCGS
                        VOLG     = VOLG+VFCG
                        MTG(I,J) = 10*NPXS+NPYS
                        NP3      = NP3+NSA
                     END IF 
 1400             CONTINUE
 1300          CONTINUE
C 
               DO 1201 II=1,MR
                  WRITE(1,995) (MTG(II,J),J=1,MC)
 1201          CONTINUE
 1200       CONTINUE
 1100    CONTINUE
 1000 CONTINUE
C
      CLOSE(UNIT=1)
      CALL STSEPI
      END


      REAL FUNCTION PSF(H,X,Y,X0,Y0,SIG,BET)
C
      REAL  H
      REAL  X
      REAL  Y
      REAL  X0
      REAL  Y0
      REAL  SIG
      REAL  BET
C
      PSF = H * (1+((X-X0)**2 + (Y-Y0)**2)/SIG**2)**(-BET)
C
      RETURN
      END


      DOUBLE PRECISION FUNCTION IN(DX,DY,ER)
C
      DOUBLE PRECISION DX
      DOUBLE PRECISION DY
      DOUBLE PRECISION ER
C
      IN = DATAN(DX*DY/(ER*DSQRT(DX**2+DY**2+ER**2)))
C
      RETURN
      END

C @(#)delnod.for	19.1 (ES0-DMD) 02/25/03 14:29:00
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE DELNOD(NODE,FA,LINK,NAUX)                                      
      IMPLICIT NONE                                                            
      INTEGER NAUX,LINK(NAUX),NODE,CURR,NEXT
      REAL FA(NAUX)                                                             
C                                                                               
C  CURR GETS LOC OF LISTHEAD                                                    
C                                                                               
      CURR   = 1                                                                
C                                                                               
C   WHILE NEXT NOT THE NODE TO DELETE DO GET NEXT NODE                          
C                                                                               
   10 NEXT   = LINK(CURR)                                                       
      IF (NEXT.EQ.0) GO TO 30                                                   
      IF (NEXT.EQ.NODE) GO TO 20                                                
      CURR   = NEXT                                                             
      GO TO 10                                                                  
C             DELETE NODE FROM LIST                                             
   20 LINK(CURR) = LINK(NEXT)                                                   
      RETURN                                                                    
C                                                                               
C   ERROR EXIT, SHOULDN'T GET HERE                                              
C   ELEMENT NOT FOUND                                                           
C                                                                               
   30 CONTINUE                                                                  
      RETURN                                                                    
                                                                                
      END                                                                       

C @(#)intell.for	19.1 (ESO-DMD) 02/25/03 13:31:23
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C.IDENTIFICATION: INTELL
C.PURPOSE:   Integrate pixel intensities within ellipse in a 2-dim image
C.LANGUAGE:  F77+ESOext
C.AUTHOR:    Andris Lauberts
C.KEYWORDS:  Integration, ellipse 
C.ALGORITHM: Search for pixel centers selected within ellipse,
C            compare two cases with slightly different ellipses,
C            derive flux by linear interpolation in differential flux
C.VERSION:   890717 AL   creation
C 
C 010201		last modif
C 
C ---------------------------------------------------------------------
 
      PROGRAM INTELL
C
      IMPLICIT  NONE
C
      INTEGER   MADRID(1)
      INTEGER   IAV
      INTEGER   IMF
      INTEGER   NAXIS
      INTEGER   ISTAT
      INTEGER   KUN,KNUL
      INTEGER   NPIX(2),FLAG
      INTEGER*8 IP
C
      REAL      ELLPAR(6),FLUX
      REAL      STA(2), STE(2)
      DOUBLE PRECISION STEP(2),START(2)
C
      CHARACTER IDENT*72,CUNIT*64,TEXT*80
      CHARACTER INFR*60
C
      INCLUDE   'MID_INCLUDE:ST_DEF.INC/NOLIST'
      COMMON    /VMR/MADRID
      INCLUDE   'MID_INCLUDE:ST_DAT.INC/NOLIST'
C
C *** start code
      CALL STSPRO('INTELL')                          ! set up Midas environment
C
C ** get keywords
      CALL STKRDC('IN_A',1,1,60,IAV,INFR,KUN,KNUL,ISTAT)   !  get inframe name
      CALL STKRDR('INPUTR',1,5,IAV,ELLPAR,KUN,KNUL,ISTAT)  !  ellipse params
      CALL STKRDI('INPUTI',1,1,IAV,FLAG,KUN,KNUL,ISTAT)    !  flag
C
C *** get the image
      CALL STIGET(INFR,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     2            2,NAXIS,NPIX,START,STEP,IDENT,CUNIT,IP,IMF,ISTAT)
C
C ** get descriptor
      IF (FLAG.EQ.1) THEN
         CALL STDRDR(IMF,'ELLPAR',1,5,IAV,ELLPAR,KUN,KNUL,ISTAT)
      ENDIF
C
      STA(1) = START(1)
      STA(2) = START(2)
      STE(1) = STEP(1)
      STE(2) = STEP(2)
C
C *** Search for pixel centers (points) within ellipse
C     Simultaneous search for points within slightly larger ellipse
C     Study differential increase in pixel area, ellipse area and flux
C     Linear interpolation to get flux from pixels covering same total
C     area (approx same region) as the nominal ellipse.
C
      CALL INTEGR(MADRID(IP),NPIX,STA,STE,ELLPAR,FLUX)
C
C *** Print table
      CALL STTPUT(' ',ISTAT)
      CALL STTPUT('*** Summary of the Results ***',ISTAT)
      CALL STTPUT('Center                    Semi-diameters  '//
     +'Posangle           Flux',ISTAT)
      ELLPAR(6)=FLUX
      WRITE (TEXT,9000) ELLPAR
9000  FORMAT (5F10.2,G15.5)
      CALL STTPUT(TEXT,ISTAT)
C
C ** update ELLPAR with FLUX in 6th position
      CALL STDWRR(IMF,'ELLPAR',ELLPAR,1,6,KUN,ISTAT)
C
999   CALL STSEPI
      END
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION: INTEGR
C.AUTHOR:   A. Lauberts
C.PURPOSE:  Integrates image pixel intensities within limiting ellipse
C.INPUT     PIX     inframe image intensities                   
C           NPIX    number of pixels/axis
C           START   start X, Y coords
C           STEP    step size in X, Y
C           ELLPAR  ellipse parameters: 
C                   center X,Y, semi-diams, posangle
C           FLUX    integrated intensit output
C---------------------------------------------------------------------
      SUBROUTINE INTEGR (PIX,NPIX,START,STEP,ELLPAR,FLUX)
      IMPLICIT  NONE
C
      INTEGER   I, J, ISTAT
      INTEGER   NPIX(2),MF,MG,N
      REAL      PIX(1)
      REAL      START(2),STEP(2),ELLPAR(6),FLUX
      REAL      A,A1,A2,ABF,ABG,AF,AG
      REAL      B,B1,B2,C1,C2,C3,D1,D2,D3
      REAL      F,FI,G,GI
      REAL      P,P2,PI,PI2,PIH,PN
      REAL      R2,S2,X,Y,Y2
      REAL      STC1,STC2,STP1,STP2
      CHARACTER TEXT*80
C
C **  define two ellipse equation functions
C
      F(X,Y) = C1*X*X + C2*X*Y + C3*Y*Y
      G(X,Y) = D1*X*X + D2*X*Y + D3*Y*Y
C
C  Let ellipse equation in quadratic form be
C
C     C1*X*X + C2*X*Y + C3*Y*Y = 1
C
C  Let ellipse equation in normal form be
C
C     r*U*U + s*V*V = 1
C
C  with  1/r = A*A  and  1/s = B*B.
C
C  (U,V) and (X,Y) coordinate systems are transformed by relative rotation
C
C     U = X cos P + Y sin P
C     V =-X sin P + Y cos P
C
C  using this transformation and identifying the two ellipse equation forms
C  gives C's expressed in A, B and P:
C
C     2*C1 = r+s + (r-s) cos 2P
C       C2 = (r-s) sin 2P
C     2*C3 = r+s - (r-s) cos 2P
C
C **  initialize parameters
C
      PI=3.1415926
      PIH=PI/2.
      PI2=PI*2.
C
      A        = ELLPAR(3)
      B        = ELLPAR(4)
      P        = ELLPAR(5)
      P2       = P*PI/90.
C
C also try slightly larger concentric ellipse G 
C with semi-major diameter increased 0.5 pixel
C
      A1 = A+STEP(1)/2.
      B1 = B*A1/A
C
C areas of ellipses F and G
C
      ABF = A*B*PI
      ABG = A1*B1*PI
C
C constants C's of ellipse F in quadratic form
C
      A2 = 1./A**2
      B2 = 1./B**2
      R2 = A2+B2
      S2 = A2-B2
      C1 = (R2 + S2*COS(P2))/2.
      C2 = S2*SIN(P2)
      C3 = (R2 - S2*COS(P2))/2.
C
C constants D's of ellipse G
C
      A2 = 1./A1**2
      B2 = 1./B1**2
      R2 = A2+B2
      S2 = A2-B2
      D1 = (R2 + S2*COS(P2))/2.
      D2 = S2*SIN(P2)
      D3 = (R2 - S2*COS(P2))/2.
C
C *** search pixels within specified ellipses F and G
C
      MF = 0
      MG = 0
      N = 0
      FI= 0.
      GI= 0.
      STC1=START(1)-ELLPAR(1)
      STC2=START(2)-ELLPAR(2)
      STP1=STEP(1)
      STP2=STEP(2)
      DO J = 1,NPIX(2)
         Y = STC2+(J-1)*STP2
         Y2= Y**2
         DO I = 1,NPIX(1)
            X = STC1+(I-1)*STP1
            N = N+1
            IF (G(X,Y).LT.1.) THEN
               MG = MG + 1
               PN = PIX(N)
               GI = GI + PN
               IF (F(X,Y).LT.1.) THEN
                  MF = MF + 1
                  FI = FI + PN
               ENDIF
            ENDIF
          ENDDO
      ENDDO
      AF = MF*STEP(1)*STEP(2)
      AG = MG*STEP(1)*STEP(2)
C
C  interpolate flux at approx pixel area = nominal ellipse area
C
      FLUX = FI + (GI-FI)*((ABF-AF)/(AG-AF))
C
      WRITE (TEXT,9000) AF,ABF,FI
      CALL STTPUT(TEXT,ISTAT)
      WRITE (TEXT,9000) AG,ABG,GI
      CALL STTPUT(TEXT,ISTAT)
      WRITE (TEXT,9001) FLUX
      CALL STTPUT(TEXT,ISTAT)
 9000 FORMAT ('Pix area=',G12.5,', Ell area=',G12.5,', Flux=',G12.5)
 9001 FORMAT ('Interpolated flux=',G12.5)
      END

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM HOLESID
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION: HOLESID.FOR
C.PURPOSE:   Draw identification of holes to be drilled on OPTOPUS plate.
C.ALGORITHM: Use the routines of the AGL library
C.AUTHOR:    Alessandra Gemmo            Padova Department of Astronomy
C.VERSION:   050691 AG Creation
C 
C 100616	last modif
C------------------------------------------------------------------------------
 
      IMPLICIT NONE
C
      INTEGER    MADRID,TID,KUN,KNUL
      INTEGER    NPAR,ISTAT,ILEN,ILAB
      INTEGER    I,NACT
      INTEGER    NCOLUM,NCOL,NROW,NSC
      INTEGER    NLAB
      INTEGER    COL(4)
      INTEGER    PARNEV
      INTEGER    DTYPE,NACOL,NAROW
      INTEGER    IIDENT, PLMODE, ACCESS
C
C ***
      REAL       VX,VY,RIDENT
      REAL       X(1000),Y(1000)
      REAL       XMIN,XMAX,YMIN,YMAX
C
C ***
      DOUBLE PRECISION    DIDENT
C
C ***
      CHARACTER*64  TABLE
      CHARACTER*80  TEXT
      CHARACTER*17  COLUMN(4)
      CHARACTER*8   AFORM
      CHARACTER*16  FORM
      CHARACTER*20  IDENT1 
      CHARACTER*20  IDENT, CTEST
C
C ***
      LOGICAL NULL1,NULL2,NULL3,ISEL
C
C ***
      INCLUDE    'MID_INCLUDE:TABLES.INC/NOLIST'
      COMMON     /VMR/MADRID(1)
      INCLUDE    'MID_INCLUDE:TABLED.INC/NOLIST'
C
C ***
      DATA        PARNEV/5/
      DATA        ACCESS/1/
      DATA        PLMODE/1/
C
C *** start the code
C
      CALL STSPRO('HOLESID')
C
C *** read parameters
      CALL TDPGET(PARNEV,NPAR,ISTAT)
      IF(ISTAT.NE.0)THEN
        TEXT = '*** FATAL: Problems with parameters input table'
        CALL STETER(9,TEXT)
      ENDIF
C
      TABLE     = TPARBF(1)
      COLUMN(1) = TPARBF(2)
      COLUMN(2) = TPARBF(3)
      COLUMN(3) = TPARBF(4)
      NCOLUM    = 3
C
C
C
C *** read table
      CALL TBTOPN(TABLE,F_I_MODE,TID,ISTAT)
      IF(ISTAT.NE.0)THEN
        TEXT = '*** FATAL: Failed to open table: '//TABLE
        CALL STETER(9,TEXT)
      ENDIF
C
      CALL TBIGET(TID,NCOL,NROW,NSC,NACOL,NAROW,ISTAT)
      IF(ISTAT.NE.0)THEN
        TEXT = '*** FATAL: Failed to get table info '//TABLE
        CALL STETER(9,TEXT)
      ENDIF
C
C *** get column adresses
      DO I = 1,NCOLUM
          CALL TBCSER(TID,COLUMN(I),COL(I),ISTAT)
          IF(ISTAT.NE.0)THEN
            TEXT = '*** FATAL: Failed to get table column'
            CALL STETER(9,TEXT)
          ENDIF
C
          IF(COL(I).EQ.-1)THEN
            TEXT = '*** FATAL: Failed to get table column'
            CALL STETER(9,TEXT)
          ENDIF
      ENDDO
C
      CALL TBFGET(TID,COL(3),AFORM,ILEN,DTYPE,ISTAT)
      CALL LENBUF(AFORM,I)
      FORM   = '('//AFORM(1:I)//')'
C
C ... plot - AGL window
      CALL PTOPEN(' ','none',ACCESS,PLMODE)
      CALL AGSSET('LFRG')
      CALL AGSSET('CHSM')
C
C *** first iteration to find label positions
      NLAB=0
      DO I=1,NROW
         CALL TBSGET(TID,I,ISEL,ISTAT)
         IF(ISEL)THEN
           CALL TBERDR(TID,I,COL(1),VX,NULL1,ISTAT)
           CALL TBERDR(TID,I,COL(2),VY,NULL2,ISTAT)
           CALL STKRDR('PLRSTAT',11,1,NACT,XMIN,KUN,KNUL,ISTAT)
           CALL STKRDR('PLRSTAT',12,1,NACT,XMAX,KUN,KNUL,ISTAT)
           CALL STKRDR('PLRSTAT',15,1,NACT,YMIN,KUN,KNUL,ISTAT)
           CALL STKRDR('PLRSTAT',16,1,NACT,YMAX,KUN,KNUL,ISTAT)
           IF(.NOT.NULL1)THEN
            IF(.NOT.NULL2)THEN
             NLAB = NLAB+1
             X(NLAB) = VX 
             Y(NLAB) = VY
            ENDIF
           ENDIF
          ENDIF
       ENDDO
C
C *** second iteration to plot labels
       ILAB=0
       DO I=1,NROW
          CALL TBSGET(TID,I,ISEL,ISTAT)
          IF (ISEL)THEN
             CALL TBERDR(TID,I,COL(1),VX,NULL1,ISTAT)
             CALL TBERDR(TID,I,COL(2),VY,NULL2,ISTAT)
             IF (.NOT.NULL1) THEN
                IF (.NOT.NULL2) THEN
                   IF (DTYPE.EQ.D_C_FORMAT) THEN
                      CALL TBERDC(TID,I,COL(3),CTEST,NULL3,ISTAT)
                      CALL FT_EOS(CTEST,20,IDENT,ISTAT)

                   ELSE IF (DTYPE.EQ.D_I4_FORMAT) THEN

                      CALL TBERDI(TID,I,COL(3),IIDENT,NULL3,ISTAT)
                      IF (.NOT.NULL3) THEN
C                        WRITE(IDENT,FORM,ERR=30) IIDENT
                         WRITE(IDENT,FORM) IIDENT
                      ENDIF  

                   ELSE IF (DTYPE.EQ.D_R4_FORMAT) THEN
                      CALL TBERDR(TID,I,COL(3),RIDENT,NULL3,ISTAT)
                      IF (.NOT.NULL3) THEN
C                        WRITE(IDENT,FORM,ERR=30) RIDENT
                         WRITE(IDENT,FORM) RIDENT
                      ENDIF

                   ELSE IF (DTYPE.EQ.D_R8_FORMAT) THEN
                       CALL TBERDD(TID,I,COL(3),DIDENT,NULL3,ISTAT)
                      IF (.NOT.NULL3) THEN
C                        WRITE(IDENT,FORM,ERR=30) DIDENT
                         WRITE(IDENT,FORM) DIDENT
                      ENDIF   
                   ENDIF
                ENDIF
             ENDIF
C
 30          CONTINUE
             ILAB = ILAB+1
             IDENT1 = '~_~_'//IDENT
             CALL LENBUF(IDENT1,ILEN)
             CALL AGGTXT(X(ILAB),Y(ILAB),IDENT1(1:ILEN),22)
          ENDIF
       ENDDO
C
C *** over and out
      CALL TBTCLO(TID,ISTAT)
      CALL PTCLOS()
      CALL STSEPI
      END

C @(#)tdfreq.for	19.1 (ESO-DMD) 02/25/03 14:11:17
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.1  ESO-FORTRAN Conversion, AA  14:13 - 19 NOV 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION:
C               TDFREQ.FOR
C
C.KEYWORDS
C    HISTOGRAM, TABLES
C
C.PURPOSE
C
C  EXECUTE THE COMMAND
C  COMP/HIST OUTPUT = TABLE COLUMN-REF [STEP [MIN-VAL  [MAX-VAL]]]
C  WHERE 'OUTPUT' CAN BE EITHER 'frame' OR 'name/TABLE'
C
C.ALGORITHM
C
C  USE TABLE INTERFACE ROUTINES
C
C-----------------------------------------------------------
C

      SUBROUTINE RFREQU(NROW,X,M,NPIX,F,START,STEP,RMIN,RMAX)
C
C COMPUTE THE FREQUENCY
C SINGLE PRECISION VERSION
C
      IMPLICIT NONE
      INTEGER  NROW, NPIX
      REAL X(NROW),M(NROW),F(NPIX)
      REAL START, STEP, RMIN, RMAX
C
      INTEGER  I, J
C 
      INTEGER TINULL
      REAL    TRNULL, TBLSEL
      DOUBLE PRECISION TDNULL, TDTRUE, TDFALS
C
C ... GET MACHINE CONSTANTS
C
      CALL TBMNUL(TINULL, TRNULL, TDNULL)
      CALL TBMCON(TBLSEL, TDTRUE, TDFALS)
C
C
      DO 10 I = 1,NPIX
          F(I)   = 0.
   10 CONTINUE
      RMIN   = 0.
      RMAX   = 0.
      DO 20 I = 1,NROW
          IF (M(I).EQ.TBLSEL .AND. X(I).NE.TRNULL) THEN
              J      = (X(I)-START)/STEP + 1
              IF (J.GE.1 .AND. J.LE.NPIX) THEN
                  F(J)   = F(J) + 1
                  RMAX   = AMAX1(RMAX,F(J))
              END IF
          END IF
   20 CONTINUE
      RETURN
      END

      SUBROUTINE DFREQU(NROW,X,M,NPIX,F,START,STEP,RMIN,RMAX)
C
C COMPUTE THE FREQUENCY
C DOUBLE PRECISION VERSION
C
      IMPLICIT NONE
      INTEGER          NROW, NPIX
      REAL             M(NROW),F(NPIX)
      DOUBLE PRECISION X(NROW)
      REAL             START, STEP, RMIN, RMAX
C
      INTEGER          I, J
C 
      INTEGER TINULL
      REAL    TRNULL, TBLSEL
      DOUBLE PRECISION TDNULL, TDTRUE, TDFALS
C
C ... GET MACHINE CONSTANTS
C
      CALL TBMNUL(TINULL, TRNULL, TDNULL)
      CALL TBMCON(TBLSEL, TDTRUE, TDFALS)
C
C
      DO 10 I = 1,NPIX
          F(I)   = 0.
   10 CONTINUE
      RMIN   = 0.
      RMAX   = 0.
      DO 20 I = 1,NROW
          IF (M(I).EQ.TBLSEL .AND. X(I).NE.TDNULL) THEN
              J      = (X(I)-START)/STEP + 1
              IF (J.GE.1 .AND. J.LE.NPIX) THEN
                  F(J)   = F(J) + 1
                  RMAX   = AMAX1(RMAX,F(J))
              END IF
          END IF
   20 CONTINUE
      RETURN
      END

      SUBROUTINE TDHSTM(TID,ICOL,NROW,NPIX,F,START,STEP,RMIN,RMAX)
C
C COMPUTE HISTOGRAM FOR A TABLE COLUMN
C
      IMPLICIT NONE
      INTEGER  TID, ICOL, NROW, NPIX
      REAL     F(NPIX)
      REAL     START, STEP, RMIN, RMAX, XX
C
      LOGICAL  ISEL, NULL
      INTEGER  I, J, STATUS
C 
      DO 10 I = 1, NPIX
          F(I)   = 0.
   10 CONTINUE
      RMIN   = 0.
      RMAX   = 0.
      DO 20 I = 1,NROW
          CALL TBSGET(TID, I, ISEL, STATUS)
          IF (ISEL) THEN
             CALL TBERDR(TID, I, ICOL, XX, NULL, STATUS)
             IF (.NOT.NULL) THEN
                  J      = (XX-START)/STEP + 1
                  IF (J.GE.1 .AND. J.LE.NPIX) THEN
                      F(J)   = F(J) + 1
                      RMAX   = AMAX1(RMAX,F(J))
                  ENDIF
             ENDIF
          ENDIF
   20 CONTINUE
      RETURN
      END


      SUBROUTINE
     .TDIHST(ARRAY,NAXIS,NPIX,SUBLO,SUBHI,CUTS,SLTSIZ,NSLOT,SLOT,
     .RMIN,RMAX)
C
      IMPLICIT NONE
C 
      INTEGER      NAXIS,NPIX(*),SUBLO(*),SUBHI(*),NSLOT
      INTEGER      LOWX,LOWY,LOWZ,HIX,HIY,HIZ
      INTEGER      N,OFF,YOFF,ZOFF,NX,NY,NZ
      INTEGER      NPX,NPXY,X
C 
      REAL         ARRAY(*),SLOT(*)
      REAL         SLTSIZ,CUTS(2),F,R, RMIN, RMAX
C
C  clear slots
      RMIN = 0.
      RMAX = 0.
      DO 100, N=1,NSLOT
         SLOT(N) = 0
100   CONTINUE
      F = 1./SLTSIZ
C
C  determine subarea
      LOWX = SUBLO(1)
      HIX = SUBHI(1)
      NPX = NPIX(1)
      IF (NAXIS.GE.2) THEN
         LOWY = SUBLO(2)
         HIY = SUBHI(2)
         NPXY = NPX * NPIX(2)
      ELSE
         LOWY = 1
         HIY = 1
         NPXY = NPX
      ENDIF
      IF (NAXIS.GE.3) THEN
         LOWZ = SUBLO(3)
         HIZ = SUBHI(3)
      ELSE
         LOWZ = 1
         HIZ = 1
      ENDIF
C
      ZOFF = (LOWZ-1) * NPXY
      YOFF = (LOWY-1) * NPX
C
C  test, if we have excess bins
      IF (CUTS(2).LE.CUTS(1)) GOTO 1000
C
C  main loop over all pixels in given area with excess bins
      DO 800, NZ=LOWZ,HIZ
C
         DO 600, NY=LOWY,HIY
            OFF = ZOFF + YOFF
C
            DO 500, NX=LOWX,HIX
               N = OFF + NX
               IF (ARRAY(N).GT.CUTS(2)) THEN
                  X = NSLOT                        !high excess bin
               ELSE
                  R = ARRAY(N) - CUTS(1)
                  IF (R.LT.0.) THEN
                     X = 1                  	!low excess bin
                  ELSE
                     X = INT(F*R) + 2                  !valid bin
                  ENDIF
               ENDIF
               SLOT(X) = SLOT(X) + 1
               RMAX    = AMAX1(RMAX, SLOT(X))
500         CONTINUE
C
            YOFF = YOFF + NPX
600      CONTINUE
C
         ZOFF = ZOFF + NPXY
800   CONTINUE
C
C  that's it
      RETURN
C
C  main loop over all pixels in given area without excess bins
1000  DO 1800, NZ=LOWZ,HIZ
C
         DO 1600, NY=LOWY,HIY
            OFF = ZOFF + YOFF
C
            DO 1500, NX=LOWX,HIX
               N = OFF + NX
               X = INT(F*(ARRAY(N)-CUTS(1))) + 1
               SLOT(X) = SLOT(X) + 1
               RMAX    = AMAX1(RMAX, SLOT(X))
1500        CONTINUE
C
            YOFF = YOFF + NPX
1600     CONTINUE
C
         ZOFF = ZOFF + NPXY
1800  CONTINUE
C
      RETURN
      END

C @(#)minmsg.for	19.1 (ES0-DMD) 02/25/03 13:17:42
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE MINMSG(METHOD,ROUTIN,IFAIL)                                    
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++        
C                                                                               
C.MODULE                                                                        
C       FIT                                                                     
C                                                                               
C.NAME                                                                          
C       MINMSG                                                                  
C                                                                               
C.PURPOSE                                                                       
C       Decode exit status from NAG minimization routines and display           
C       appropriate message.                                                    
C                                                                               
C.KEYWORDS                                                                      
C       Status message.                                                         
C                                                                               
C.DESCRIPTION                                                                   
C       trivial                                                                 
C                                                                               
C.LANGUAGE                                                                      
C       FORTRAN                                                                 
C                                                                               
C.CALLING SEQUENCE                                                              
C       CALL MINMSG(METHOD,IFAIL)                                               
C                                                                               
C.INPUT PARAMETERS                                                              
C       METHOD    (*)      CHARACTER  method used                               
C       IFAIL              INTEGER    Exit status.                              
C                                                                               
C.MODIFIED PARAMETERS                                                           
C       none                                                                    
C                                                                               
C.OUTPUT PARAMETERS                                                             
C       none                                                                    
C                                                                               
C.FILES                                                                         
C       none                                                                    
C                                                                               
C.MODULES CALLED                                                                
C       STTPUT                                                                  
C                                                                               
C.AUTHOR                                                                        
C       Ph. DEFERT,      Feb 1986                                               
C                                                                               
C.MODIFICATIONS                                                                 
C                                                                               
C                                                                               
C-----------------------------------------------------------------------        
C      IMPLICIT NONE                                                            
C     .. Scalar Arguments ..                                                    
      INTEGER IFAIL,ROUTIN                                                      
      CHARACTER METHOD* (*)                                                     
C     ..                                                                        
C     .. Local Scalars ..                                                       
      INTEGER ISTAT                                                             
      CHARACTER LINE*75                                                         
C     ..                                                                        
C     .. Executable Statements ..                                               
      IF (IFAIL.EQ.0) THEN                                                      
          LINE   = '  --> '//METHOD//' : Convergence achieved <--'              
                                                                                
      ELSE IF (IFAIL.EQ.1) THEN                                                 
          LINE   = '*** ERR-1-'//METHOD//                                       
     +             ' : Bad initializations ... Aborting ***'                    
                                                                                
      ELSE IF (IFAIL.EQ.2) THEN                                                 
          LINE   = '*** WARN-2-'//METHOD//                                      
     +             ' : No convergence reached ***'                              
                                                                                
      ELSE IF (IFAIL.EQ.3) THEN                                                 
          LINE   = '*** WARN-3-'//METHOD//                                      
     +             ' : Final parameters not really satisfory ***'               
                                                                                
      ELSE IF (IFAIL.EQ.4) THEN                                                 
          LINE   = '*** ERR-4-'//METHOD//                                       
     +             ' : Overflow in computations ***'                            
                                                                                
      ELSE IF (IFAIL.EQ.9) THEN                                                 
          LINE   = '*** ERR-9-'//METHOD//                                       
     +         ' : No finite solutions or bad scaling of parameters ***'        
                                                                                
      ELSE IF (IFAIL.EQ.10) THEN                                                
          LINE   = '*** ERR-10-'//METHOD//                                      
     +             ' : Likely an error in forming the derivatives ***'          
                                                                                
      ELSE IF (IFAIL.GT.4) THEN                                                 
          IF (ROUTIN.EQ.1 .OR. ROUTIN.EQ.3 .OR. ROUTIN.EQ.5) THEN               
              WRITE (LINE,9000) IFAIL,METHOD                                    
                                                                                
          ELSE                                                                  
              LINE   = '*** ERR-5-'//METHOD//                                   
     +                 ' : Failure in the local search ***'                     
          END IF                                                                
                                                                                
      END IF                                                                    
                                                                                
      CALL STTPUT(LINE,ISTAT)                                                   
      IF (IFAIL.GT.4 .AND. IFAIL.LT.9) CALL STTPUT                              
     +    ('          suggest a retry with other initial values',ISTAT)         
      RETURN                                                                    
                                                                                
 9000 FORMAT ('*** ERR-',I1,'-',A5,' : Final parameters are not satisf',        
     +       'actory ***')                                                      
      END                                                                       

C @(#)ftpars.for	19.1 (ES0-DMD) 02/25/03 13:17:35
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FTPARS(PAR1,NIND,NPAR,ISTAT)                                   
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                   
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:25 - 13 JAN 1988                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C.IDENTIFICATION                                                                
C                                                                               
C  FITLIB.FOR   VERSION 1.0  27 MAR 1984                                        
C                                                                               
C.PURPOSE                                                                       
C                                                                               
C  INTERFACE ROUTINES FOR THE FITTING STRUCTURES                                
C PARSE FUNCTION DEFINITION AND SET UP TABLE WITH PARAMETER NAMES               
C                                                                               
C.ALGORITHM                                                                     
C                                                                               
C  USE MIDAS I/O INTERFACES TO FRAMES AND TABLES                                
C                                                                               
C.KEYWORDS                                                                      
C                                                                               
C  NON LINEAR FITTING                                                           
C                                                                               
C                                                                               
C----------------------------------------------------------------               
C                                                                               
C      IMPLICIT NONE                                                            
C                                                                               
C INPUT ARGUMENTS                                                               
C PAR1 CHAR FUNCTION ARGS (x1,...;p1,...)                                       
C                                                                               
C OUTPUT ARGUMENTS                                                              
C NIND INTG NUMBER OF INDEPENDENT VARIABLES                                     
C NPAR INTG NUMBER OF FUNCTION PARAMETERS                                       
C ISTAT INTG STATUS RETURN                                                      
C                                                                               
      INTEGER NIND,NPAR,ISTAT,I,I1 
      INTEGER II,KZ6967,LENGTH,NP1,II1
      CHARACTER*(*) PAR1                                                        
      CHARACTER LINE1*80,LINE2*80,C*1,EOFMARK*1,DELIM*1                         
      CHARACTER*20 TOKEN                                                        
      CHARACTER*20 TEST1, TEST2
      LOGICAL EOF                                                               
       INCLUDE 'MID_INCLUDE:FITI.INC/NOLIST'                                     
       INCLUDE 'MID_INCLUDE:FITC.INC/NOLIST'                                     
      LINE1  = PAR1//',?'                                                       
C                                                                               
C ... SEARCH FOR INDEP VARS                                                     
C                                                                               
      II     = INDEX(LINE1,'?') - 2                                             
      NIND   = 0                                                                
      DO 10 I = 1,II                                                            
          C      = LINE1(I:I)                                                   
          IF (C.EQ.',') NIND   = NIND + 1                                       
          IF (C.EQ.';') THEN                                                    
              NIND   = NIND + 1                                                 
              GO TO 20                                                          
          END IF                                                                
   10 CONTINUE                                                                  
      ISTAT  = FERPFU                                                       
C                                                                               
C ... GET TOKENS CORRESPONDING TO PARAMS                                        
C                                                                               
   20 I1     = I + 1                                                            
      NPAR   = 0                                                                
      LINE2  = LINE1(I1:)                                                       
      EOF    = .FALSE.                                                          
      EOFMARK = '?'                                                             
      DELIM  = ','                                                              
      KZ6967 = 0
99    KZ6967 = KZ6967 + 1
          IF ( .NOT. (.NOT.EOF)) GO TO 50                                       
          CALL FTTOKN(LINE2,EOFMARK,DELIM,TOKEN,LENGTH,EOF)                     
          IF ( .NOT. EOF) THEN                                                  
              NPAR   = NPAR + 1                                                 
              NP1    = NPAR + FZNPTOT                                         
              FZPTOKEN(NP1) = TOKEN                                           
              FZPLEN(NP1) = LENGTH                                            
C                                                                               
C     CHECK THAT PARAMETER NAME IS NOT DUPLICATED                               
C                                                                               
              TEST1 = TOKEN
              CALL FORUPC(TEST1, TEST1)
              DO 30 I = 1,NP1 - 1                                               
                  II1    = FZPLEN(I)                                          
                  TEST2 = FZPTOKEN(I)
                  CALL FORUPC(TEST2, TEST2)
C                  IF (TEST1(1:II1).EQ.TEST2(1:II1)) THEN              
C                      ISTAT  = FERDUP                                       
C                      RETURN                     
C                  END IF                      
   30         CONTINUE                                                          
          END IF                                                                
          I1     = LENGTH + 2                                                   
          LINE1  = LINE2                                                        
          LINE2  = LINE1(I1:)                                                   
      GOTO 99
   50 CONTINUE                                                                  
      RETURN                                                                    
      END                                                                       

       PROGRAM IUEIN
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION        IUEIN.FOR
C.AUTHOR:               J.D.PONZ  ESA-VILSPA        
C.KEYWORDS              IUE, GO FORMAT, RAW IMAGE
C.PURPOSE
C  \begin{TeX}
C   Main program to read IUE tapes in GO format.
C   Files are created with the following formats
C   \begin{description}
C      \item[{\tt RAW}]   2-Dimensional image in byte or floating point format.
C      \item[{\tt PHOT}]  2-Dimensional image in byte or floating point format.
C      \item[{\tt LBL}]   2-Dimensional image in byte or floating point format.
C      \item[{\tt MELO}]  table file.
C      \item[{\tt MEHI}]  table file.
C   \end{description}
C
C   The files {\tt MELO} and {\tt MEHI} are tables with the following columns:
C   \begin{description}
C      \item[{\tt WAVELENGTH}]  {\tt R*4}  wavelenghts
C      \item[{\tt EPSILON}]     {\tt I*4}    quality flags
C      \item[{\tt GROSS}]       {\tt R*4}    gross spectrum
C      \item[{\tt BACK}]        {\tt R*4}    background estimation
C      \item[{\tt NET}]         {\tt R*4}    net spectrum
C      \item[{\tt RNET}]        {\tt R*4}    ripple corrected net (only high disp)
C      \item[{\tt FLUX}]        {\tt R*4}    absolute flux
C      \item[{\tt ORDER}]       {\tt I*4}    spectral order number (only high disp)
C  \end{description}
C \end{TeX}
C.ALGORITHM
C \begin{TeX}
C   \begin{enumerate}
C   \item Read parameters defining:
C       \begin{itemize}
C       \item file specifications
C       \item  naming convention
C       \item tape device 
C       \item selection by file type
C       \item flags for file format and header listing
C       \end{itemize}
C   \item Position the device for tape input
C   \item Read the first header record to find the file type
C   \item Generate the filename according to the naming conventions
C   \item Process the file if the file type agrees with the requested one(s)
C   \item Skip the EOF for tape input
C   \end{enumerate}
C \end{TeX}
C
C.LANGUAGE:               F77 
C.COMMENTS
C \begin{TeX}
C   The program is started by the procedure {\tt IUEIN.PRG}, 
C   command {\tt IUEIN}.
C
C   The following extensions are used:
C \begin{itemize}
C    \item  IMPLICIT NONE
C    \item  long variable names
C \end{itemize}
C \end{TeX}
C.VERSION: 1.0  INITIAL CODING  09 JUL 1990
C.VERSION: 1.1  24 Sep 1991. Include several FES sizes and modify error
C                            handling. On read/decode error displays the
C                            full header if possible and skips the file.
C.VERSION: 1.2  14 Apr 1992. Remove VMS extensions.
C--------------------------------------------------------------------
C
C  data declaration
C
       IMPLICIT NONE
C                                   define data types as parameters
       INTEGER  FESTYP, RAWTYP, PHOTYP, LBLTYP, LOWTYP, HIGTYP
       PARAMETER (FESTYP=0)
       PARAMETER (RAWTYP=1)
       PARAMETER (PHOTYP=2)
       PARAMETER (LBLTYP=3)
       PARAMETER (LOWTYP=4)
       PARAMETER (HIGTYP=5)
C
       INTEGER                STATUS, KUN(1), KNUL, ACTVAL, I
       INTEGER                CHANL, INDEX, DSPFLG
       INTEGER                LFID, SCANFLAG, SPECEND, L, N
       INTEGER                SPECOFF, FSTART, FHERE, INTINDX
       INTEGER                LENINT, ENDINDX
       INTEGER                LENF, LENL, SLEN, FEND, SKIP
       INTEGER                CAMERA
       INTEGER                IMANUM
       INTEGER                APERTU
       INTEGER                DISPER
       INTEGER                NRECO, NBYTE
       INTEGER                FTYPE
       INTEGER                DSKFMT
       INTEGER                NORD, ORDER(100)
       INTEGER                MADRID(1)
C
       LOGICAL                FES, RAW, PHO, LBL, LOW, HIG
C
       CHARACTER*10           INTVAL
       CHARACTER*4            FFILE, LFILE
       CHARACTER*400          BUFF            
       CHARACTER*80           INPUT, FID, FILE, IMATYP, FSPECS, FIDEL
       CHARACTER*72           TEXT0, TEXT1
       CHARACTER*5            FLAGS, NEWPAG
       CHARACTER*10           NOFIL
       CHARACTER*80           LINE
       COMMON/VMR/MADRID
       DATA                   TEXT0/' '/
       DATA                   TEXT1/'  File number : '/
       DATA                    NEWPAG/' '/
C
C ...  MIDAS environment
C
        CALL STSPRO('IUEIN')
C
C ... init variables for data conversion
C
        CALL ISTCVI
C
C ... get tape unit 
C
        INPUT=' '
        CALL STKRDC('P3',1,1,80,ACTVAL,INPUT,KUN,KNUL,STATUS)
        CALL ISTOPN(INPUT,CHANL,STATUS)
        IF (STATUS.NE.0) THEN
          CALL STTPUT('*** Error in tape allocation ***',STATUS)
          GOTO 9999
        ENDIF  
        CALL ISTREW(CHANL,STATUS)
        IF (STATUS.NE.0) THEN
          CALL STTPUT('*** Error rewinding tape ***',STATUS)
          GOTO 9999
        ENDIF  
C
C ... get file identification
C
        INPUT=' '
        CALL STKRDC('P2',1,1,80,ACTVAL,INPUT,KUN,KNUL,STATUS)
        LFID  = INDEX(INPUT,' ') - 1
        FID   = INPUT
        FIDEL = FID
        CALL ISTUPC(FID,FID)

C ... get IUE data type selection
C
       CALL STKRDC('P4',1,1,80,ACTVAL,IMATYP,KUN,KNUL,STATUS)
       CALL ISTUPC(IMATYP,IMATYP)
       IF (IMATYP(1:1).EQ.'A') THEN   ! Select all data types by default
           FES = .TRUE.
           RAW = .TRUE.
           PHO = .TRUE.
           LBL = .TRUE.
           LOW = .TRUE.
           HIG = .TRUE.
       ELSE                        ! Types explicitly selected
           FES = .FALSE.
           RAW = .FALSE.
           PHO = .FALSE.
           LBL = .FALSE.
           LOW = .FALSE.
           HIG = .FALSE.
           I = INDEX(IMATYP,'F')          ! FES DATA
           IF (I.GT.0) FES = .TRUE.
           I = INDEX(IMATYP,'R')          ! RAW DATA
           IF (I.GT.0) RAW = .TRUE.
           I = INDEX(IMATYP,'P')          ! PHOTOM DATA
           IF (I.GT.0) PHO = .TRUE.
           I = INDEX(IMATYP,'E')          ! (EXTENDED) LBL DATA
           IF (I.GT.0) LBL = .TRUE.
           I = INDEX(IMATYP,'L')          ! LOW DISPERSION SPEC. DATA
           IF (I.GT.0) LOW = .TRUE.
           I = INDEX(IMATYP,'H')          ! HIGH DISPERSION SPEC. DATA
           IF (I.GT.0) HIG = .TRUE.
       ENDIF
C
C ... get flags (Integer/Real/X raw+phot,Full/Short label listing)
C
        FLAGS = ' '
        CALL STKRDC('P5',1,1,5,ACTVAL,FLAGS,KUN,KNUL,STATUS)
        CALL ISTUPC(FLAGS,FLAGS)
        DSKFMT = 1                   ! default is integer data on disk
        I = INDEX(FLAGS,'R')
        IF (I.GT.0) DSKFMT = 0       ! real data on disk
        I = INDEX(FLAGS,'X')
        IF (I.GT.0) DSKFMT = -1      ! no disk file
C
        DSPFLG = 1                   ! default is Short listing
        I = INDEX(FLAGS,'N')
        IF (I.GT.0) DSPFLG = 0       ! No listing
        I = INDEX(FLAGS,'F')
        IF (I.GT.0) DSPFLG = 2       ! Full listing
C
C ... get file specs
C
       CALL STKRDC('P1',1,1,80,ACTVAL,INPUT,KUN,KNUL,STATUS)
       SCANFLAG  = 0
       SPECEND   = INDEX(INPUT,' ')
       INPUT(SPECEND:SPECEND+1) = ',,'
       IF (SPECEND.LE.0) SPECEND = ACTVAL
C
C ... remove blanks
       L = 1
       DO 10 N = 1, SPECEND
          IF(INPUT(N:N).NE.' ') THEN
             FSPECS(L:L) = INPUT(N:N)
             L = L + 1
          ENDIF
 10    CONTINUE
       SPECEND = L
C
C ... initialize offset in FSPECS and pointer to current index in magtape
C
       SPECOFF = 1
       FSTART  = 1
C
C ... loop here between different specs
 80    FHERE   = FSTART
       INTINDX = INDEX(FSPECS(SPECOFF:),',')
       LENINT  = INTINDX - 1
       IF (LENINT.LE.0) GO TO 9999
C
       INTVAL  = FSPECS(SPECOFF:SPECOFF+INTINDX-2)//' '
       SPECOFF = SPECOFF + INTINDX
       ENDINDX = INDEX(INTVAL,'-')
C
       IF (ENDINDX.LE.0) THEN
          FFILE = INTVAL
          LENF  = LENINT
          LFILE = INTVAL
          LENL  = LENINT
       ELSE
          FFILE = INTVAL(1:ENDINDX-1)
          LENF  = ENDINDX - 1
          LFILE = INTVAL(ENDINDX+1:)
          LENL  = LENINT - ENDINDX
       ENDIF
       SLEN = LENF
       IF      (SLEN.EQ.1) THEN
          READ(FFILE,10001) FSTART
       ELSE IF (SLEN.EQ.2) THEN
          READ(FFILE,10002) FSTART
       ELSE IF (SLEN.EQ.3) THEN
          READ(FFILE,10003) FSTART
       ELSE IF (SLEN.EQ.4) THEN
          READ(FFILE,10004) FSTART
       ELSE
          CALL STTPUT('*** Error in FILESPEC ***',STATUS)
          GOTO 9999
       ENDIF  
       SLEN = LENL
       IF      (SLEN.EQ.1) THEN
          READ(LFILE,10001) FEND
       ELSE IF (SLEN.EQ.2) THEN
          READ(LFILE,10002) FEND
       ELSE IF (SLEN.EQ.3) THEN
          READ(LFILE,10003) FEND
       ELSE IF (SLEN.EQ.4) THEN
          READ(LFILE,10004) FEND
       ELSE
          CALL STTPUT('*** Error in FILESPEC ***',STATUS)
          GOTO 9999
       ENDIF  
C
C ... move to start file.
C
       SKIP = FSTART - FHERE
       IF (SKIP .GT. 0) THEN
          CALL ISTSKP(CHANL,SKIP,STATUS)
          IF (STATUS.NE.0) THEN
             CALL STTPUT(' *** Error in file skip ***',STATUS)
             GOTO 9999
          ENDIF
       ELSE
          IF (SKIP.LT.0) GO TO 9999
       ENDIF
 100   CONTINUE
C
C ... display a few lines
C
       WRITE(NOFIL,10000) FSTART
       CALL STTPUT(NEWPAG,STATUS)
       TEXT1(18:22) = NOFIL
       CALL STTPUT(TEXT1,STATUS)
       CALL STTPUT(TEXT0,STATUS)
C
C ... process main header
C
       CALL ISTHED(CHANL,BUFF,CAMERA,IMANUM,APERTU,DISPER,
     .             FTYPE,NRECO,NBYTE,STATUS)
       IF (STATUS.NE.0) THEN
           CALL ISTFHD(CHANL,BUFF,2,STATUS)
           CALL STTPUT('*** Error in file header ***',STATUS)
           GOTO 200
       ENDIF 
C
C ... generate filename
C
       IF (LFID.EQ.3 .AND. FID(1:3).EQ.'IUE') THEN
          CALL ISTFN1(CAMERA,IMANUM,APERTU,FTYPE,FILE)
       ELSE
          CALL ISTFN2(FIDEL,FSTART,FILE)
       ENDIF
C
C ... process the file if requested
C
       IF (FES .AND. FTYPE.EQ.FESTYP) THEN
         CALL ISTFES(CHANL,BUFF,FILE,DSKFMT,DSPFLG,
     .               NRECO,NBYTE,STATUS)                        ! PROCESS FES
         IF (STATUS.NE.0) THEN
           CALL STTPUT('*** Error reading FES file ***',STATUS)
           GOTO 200
         ELSE
           LINE = 'FES image written into file: '// FILE
           IF (DSKFMT.NE.-1) CALL STTPUT(LINE,STATUS)
         ENDIF
       ELSEIF(RAW .AND. FTYPE.EQ.RAWTYP) THEN
         CALL ISTRAW(CHANL,BUFF,FILE,DSKFMT,DSPFLG,STATUS)       ! PROCESS RAW
         IF (STATUS.NE.0) THEN
           CALL STTPUT('*** Error reading RAW file ***',STATUS)
           GOTO 200
         ELSE
           LINE = 'RAW image written into file: '// FILE
           IF (DSKFMT.NE.-1) CALL STTPUT(LINE,STATUS)
         ENDIF
       ELSEIF(PHO .AND. FTYPE.EQ.PHOTYP) THEN
         CALL ISTPHO(CHANL,BUFF,FILE,DSKFMT,DSPFLG,STATUS)    ! PROCESS PHOTOM
         IF (STATUS.NE.0) THEN
           CALL STTPUT('*** Error reading PHOT file ***',STATUS)
           GOTO 200
         ELSE
           LINE = 'PHOT image written into file: '// FILE
           IF (DSKFMT.NE.-1) CALL STTPUT(LINE,STATUS)
         ENDIF
       ELSEIF(LBL .AND. FTYPE.EQ.LBLTYP) THEN
         CALL ISTLBL(CHANL,BUFF,FILE,DSKFMT,NRECO,NBYTE,
     .                DSPFLG,STATUS)       ! PROCESS LBL
         IF (STATUS.NE.0) THEN
           CALL STTPUT('*** Error reading (E)LBL file ***',STATUS)
           GOTO 200
         ELSE
           LINE = '(E)LBL image written into file: '// FILE
           IF (DSKFMT.NE.-1) CALL STTPUT(LINE,STATUS)
         ENDIF
       ELSEIF(LOW .AND. FTYPE.EQ.LOWTYP) THEN
         CALL ISTLOW(CHANL,BUFF,FILE,DSKFMT,NRECO,NBYTE,
     .               DSPFLG,STATUS)              ! PROCESS LOW DISP
         IF (STATUS.NE.0) THEN
           CALL STTPUT('*** Error reading MELO file ***',STATUS)
           GOTO 200
         ELSE
           LINE = 'MELO spectra written into file: '// FILE
           IF (DSKFMT.NE.-1) CALL STTPUT(LINE,STATUS)
         ENDIF
       ELSEIF(HIG .AND. FTYPE.EQ.HIGTYP) THEN
         CALL ISTHIG(CHANL,BUFF,FILE,DSKFMT,NORD,ORDER,NRECO,NBYTE,
     .               DSPFLG,STATUS)  ! PROCESS HIGH DISP 
         IF (STATUS.NE.0) THEN
           CALL STTPUT('*** Error reading MEHI file ***',STATUS)
           GOTO 200
         ELSE
           LINE = 'MEHI spectra written into file: '// FILE
           IF (DSKFMT.NE.-1) CALL STTPUT(LINE,STATUS)
         ENDIF
       ENDIF
C
C ... skip the EOF
C
200    CONTINUE
       CALL ISTSKP(CHANL,1,STATUS)   
       IF (STATUS.NE.0) THEN
           CALL STTPUT('*** Error in file skip ***',STATUS)
           GOTO 9999
       ENDIF
C
C ... next file
C
       FSTART = FSTART + 1
       IF (FSTART.LE.FEND) THEN
           GOTO 100
       ELSE
           GOTO 80
       ENDIF
C
C ... end
C
 9999  CALL STSEPI
10000  FORMAT(I3.3)
C10001  FORMAT(I<SLEN>)
10001  FORMAT(I1)
10002  FORMAT(I2)
10003  FORMAT(I3)
10004  FORMAT(I4)
       END

C @(#)inilst.for	19.1 (ES0-DMD) 02/25/03 13:25:34
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.INPUT/OUTPUT
C  Input arguments
C  LSTP      integer*4 array    limits of regions
C  ITOB      integer*4 array    limits of object area
C  NREG      integer*4          number of regional linked lists
C  NCAT      integer*4 array    integer catalog
C  PMTR      real*4 array       real catalog
C  PRCT      real*4 array       catalog of profiles
C  M         integer*4          number of objects
C  MS        integer*4          maximal subarray half edge
C  Output arguments
C  LSTP      integer*4 array    limits of regions
C  NCAT      integer*4 array    integer catalog
C-----------------------------------------------------------------------
      SUBROUTINE INILST ( LSTP , ITOB , NREG , NCAT , PMTR , PRCT , M )
C
      IMPLICIT  NONE
      INCLUDE   'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER   NREG
      INTEGER   LSTP(0:4,0:NREG)
      INTEGER   ITOB(4)
      INTEGER   NCAT(NIPAR,MAXCNT)
      REAL      PMTR(NRPAR,MAXCNT)
      REAL      PRCT(0:MAXSUB,MAXCNT)
      INTEGER   M 
C
      INTEGER   I, II
      INTEGER   J, JJ
      INTEGER   K
C
      DO 10 II = 1 , NREG
          LSTP(0,II) = 0
   10 CONTINUE
      DO 20 II = 1 , M
          NCAT(7,II) = 0
          NCAT(8,II) = 0
   20 CONTINUE
      JJ = 0
      DO 30 II = 1 , M
          I = NCAT(1,II)
          J = NCAT(2,II)
          IF ( I .GE. ITOB(1) .AND. J .GE. ITOB(2) .AND. I .LE. ITOB(3)
     &                                      .AND. J .LE. ITOB(4) ) THEN
              JJ = JJ + 1
              DO 40 K = 1 , NIPAR
                  NCAT(K,JJ) = NCAT(K,II)
   40         CONTINUE
              DO 50 K = 1 , NRPAR
                  PMTR(K,JJ) = PMTR(K,II)
   50         CONTINUE
              CALL PUTLSS( JJ , NREG , LSTP , NCAT , PMTR , PRCT )
          ENDIF
   30 CONTINUE
C
      M = JJ
C
      RETURN
C
      END

C @(#)cloudabs.for	19.1 (ESO-DMD) 02/25/03 13:23:29
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C

       PROGRAM CLABS
C*************************************************************
C        M.PIERRE 1-88                                       *
C                                                            *
C       CALCULATION OF A SYNTHTETIC ABSORPTION SPECTRUM      *
C                                                            * 
C              50 ABSORPTION LINES MAX                       *       
C           VOIGTIAN OR MAXWELLIAN PROFILES                  *
C                                                            *
C       MAIN PROGRAM :ABS                                    *
C       SUBROUTINES  :ABSCOF absorption coefficient          *
C                   :IMAGE  final image                      *
C                   :CONVL1 1D convolution                   * 
C       Modified - START, STEP in/out in double precision    *
C*************************************************************
C
       IMPLICIT NONE
C 
       CHARACTER*60 TBLP,TBLC,IMA,NOMP,NOMI,NOMO,NOMOC
       CHARACTER*72 IDENTI,IDENTO,IDENTP
       CHARACTER*48 CUNIT
C 
       INTEGER    I,NPIXI(1),NPIXO(1),IST,NCARA
       INTEGER    NPIXP
       INTEGER    NPARAM,NCLD,NAXIS,IPROF
       INTEGER    KNUL,KUN,IMNP,IMNI,IMNO,IMNOC,NAC,NAR
       INTEGER    MADRID, TIDP, TIDC, I1
       INTEGER*8  PNTRO,PNTRI,PNTROC,PNTRP
C 
       REAL Z
       REAL ABSA(500),ABSBL(500),ABSC(500)
       REAL START,STEPI,STEPO,ALAM(5000)
       REAL STARTP,STEPP,X1,X2,X3,X4
       REAL PROFPS(5000),YO(5000)
C 
       DOUBLE PRECISION DSTA,DSTP
C 
       LOGICAL NULL,NULL1,NULL2,NULL3,NULL4,ISEL
C
C DEFINITION DES PARAMETRES ATOMIQUES
C       50 transitions max , multiplicite max 6
C       valeur actuelle du nb de transitions :NTR
       INTEGER Q1(500,6),QK(500,6),MUL(500),NAT(500)
       REAL    WAVEO(500,6),SAKI(500,6),F1K(500,6),XNAT(500)
       INCLUDE 'MID_INCLUDE:TABLES.INC'
       COMMON/VMR/MADRID(1)
       INCLUDE 'MID_INCLUDE:TABLED.INC'
C
C       
       CALL STSPRO('CLABS')
C
C******** ENTREE DES DONNEES  ***********
C
       CALL STKRDC('IN_A',1,1,60,NCARA,NOMI, KUN,KNUL,IST)
       CALL STKRDC('IN_B',1,1,60,NCARA,IMA,  KUN,KNUL,IST)
       CALL STKRDC('IN_C',1,1,60,NCARA,TBLC, KUN,KNUL,IST)
       CALL STKRDC('IN_D',1,1,60,NCARA,TBLP, KUN,KNUL,IST)
       CALL STKRDC('IN_E',1,1,60,NCARA,NOMP, KUN,KNUL,IST)
       CALL STKRDR('CLDZ',  1,1, NCARA,Z,    KUN,KNUL,IST)
       CALL STKRDI('CLDOP', 1,1, NCARA,IPROF,KUN,KNUL,IST)
C
       CALL STIGET(NOMP,10,0,1,1,NAXIS,NPIXP,DSTA,DSTP,
     :  IDENTP,CUNIT,PNTRP,IMNP,IST)
       STARTP = DSTA
       STEPP  = DSTP
C
C******** INITIALISATION DE L'ENVIRONEMENT MIDAS *******
C
       CALL TBTOPN(TBLP,F_I_MODE,TIDP,IST)
       CALL TBTOPN(TBLC,F_U_MODE,TIDC,IST)
       CALL TBIGET(TIDP,I,NPARAM,I,NAC,NAR,IST)
       CALL TBIGET(TIDC,I,NCLD,I,NAC,NAR,IST)
C
C******** LECTURE DES FICHIERS ********
C
C       IMAGE:
       CALL STIGET(NOMI,10,0,1,1,NAXIS,NPIXI,DSTA,DSTP,
     :       IDENTI,CUNIT,PNTRI,IMNI,IST)
       START = DSTA
       STEPI = DSTP
C
       IF((STEPI.GT.STEPP).OR.(STEPI.LT.STEPP)) THEN
          CALL STTPUT(
     :    'ERROR :IMAGE AND PSF HAVE DIFFERENT STEPSIZE',IST)
          GO TO 1111
       ENDIF
C
C       Absorption:
       I1 = 0
       DO 10 I=1,NCLD
          CALL TBSGET(TIDC,I,ISEL,IST)
          IF (ISEL) THEN
             CALL TBERDR(TIDC,I,2,X1,NULL1,IST)
             CALL TBERDR(TIDC,I,3,X2,NULL2,IST)
             CALL TBERDR(TIDC,I,4,X3,NULL3,IST)
             CALL TBERDR(TIDC,I,5,X4,NULL4,IST)
             IF (NULL1 .OR. NULL2 .OR. NULL3 .OR. NULL4) GOTO 5
               I1        = I1 + 1
               ABSA(I1)  = X1
               ABSBL(I1) = X2
               ABSC(I1)  = X3
               XNAT(I1)  = X4
               NAT(I1)   = INT(XNAT(I1))
5            CONTINUE
          ENDIF
10     CONTINUE
       NCLD = I1
C
C       TABLE DES PARAMETRES PHYSIQUES
       DO 20 I=1,NPARAM
          CALL TBERDI(TIDP,I,2, MUL(I),    NULL,IST)
          CALL TBERDR(TIDP,I,3, WAVEO(I,1),NULL,IST)
          CALL TBERDR(TIDP,I,4, WAVEO(I,2),NULL,IST)
          CALL TBERDI(TIDP,I,5, Q1(I,1),   NULL,IST)
          CALL TBERDI(TIDP,I,6, Q1(I,2),   NULL,IST)
          CALL TBERDI(TIDP,I,7, QK(I,1),   NULL,IST)
          CALL TBERDI(TIDP,I,8, QK(I,2),   NULL,IST)
          CALL TBERDR(TIDP,I,9, SAKI(I,1), NULL,IST)
          CALL TBERDR(TIDP,I,10,SAKI(I,2), NULL,IST)
          CALL TBERDR(TIDP,I,11,F1K(I,1),  NULL,IST)
          CALL TBERDR(TIDP,I,12,F1K(I,2),  NULL,IST)
20     CONTINUE
C 
C******* CALCUL DE L'IMAGE DE SORTIE *********
C
       STEPO=STEPI
       NPIXO(1)=NPIXI(1)
       DO 30 I=1,NPIXO(1)
          PROFPS(I)=START+(FLOAT(I)-1.)*STEPO
30     CONTINUE
       I=INDEX(IMA,' ')-1
       IF (IPROF.GT.0.) THEN 
         NOMO=IMA(1:I)//'1'
         NOMOC=IMA(1:I)//'1c'
C        NOMO='SYN1'
C        NOMOC='SYN1C'
         IDENTO='MAXWELL + DAMPING'
       ELSE
         NOMO=IMA(1:I)//'0'
         NOMOC=IMA(1:I)//'0c'
         IDENTO='MAXWELL SEUL'
       ENDIF
C
       DSTA = START
       DSTP = STEPO
       CALL STIPUT(NOMO,10,1,1,NAXIS,NPIXO,DSTA,DSTP,IDENTO,CUNIT,
     :        PNTRO,IMNO,IST)
       CALL STIPUT(NOMOC,10,1,1,NAXIS,NPIXO,DSTA,DSTP,IDENTO,CUNIT,
     :        PNTROC,IMNOC,IST)
C
C       Coefficient d'absorption
       CALL ABSCOF(TIDC,ABSC,ABSBL,ABSA,
     :       Z,NCLD,IPROF,NAT,MUL, 
     :       NPIXO(1),PROFPS,ALAM,
     :       WAVEO,Q1,QK,F1K,SAKI)       
C
C       Image finale
       CALL IMAGE(MADRID(PNTRI),MADRID(PNTRO),ALAM,NPIXO(1))
       CALL IMAGE(MADRID(PNTRI),YO,ALAM,NPIXO(1))
       CALL CONVL1(YO,NPIXO(1),MADRID(PNTRP),NPIXP,MADRID(PNTROC))
C      CALL PUTKEY_ST('NOM','C',NOMO,1,60,IST)
C
C****** LIBERATION DES FICHIERS ET SORTIE DE L'ENVIRONEMENT MIDAS
       CALL STTPUT('   ',IST)
       CALL STTPUT('RESULTING ABSORPTION SPECTRA :',IST)
       CALL STTPUT(NOMO,IST)
       CALL STTPUT(NOMOC,IST)
       CALL TBTCLO(TIDC,IST)
       CALL TBTCLO(TIDP,IST)
1111   CALL STSEPI
       STOP
       END
C
C********************************
C******* SOUS PROGRAMMES ********
C********************************
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
       SUBROUTINE ABSCOF (TIDC,B,VR,WEI,
     :  Z,NCLD,IPROF,NAT,MUL,
     :  NPTS,PROFPS,ALAM,
     :  WLO,Q1,QK,F1K,SAKI)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C+
C        Subroutine to compute the absorption
C        coefficient for an array of given
C        wavelengths.
C
C        Given;
C        B - Array of "B" values for cloud model.
C         (VR - Array of radial velcities for cloud model.)
C  ICI VR  position observee de l'absorption (en Angstroms)
C        WEI - Array of weights for cloud model.
C        WLO  :position centrale  des raies
C        F1K - F value.
C        QK
C        Q1
C        NAT :nature de la transition
C        MUL :multiplicite de la transition
C        AKI :valeurs des Aki
C        SAKI:some des Aki
C        NPTS - No. of pts. in profile.
C        PROFPS - Array of wavelength positions.
C        MAXPROF - Size of arrays PROFPS & ALAM.
C
C        Returned;
C        ALAM - Absorption coeff. evaluated at each wavelength.
C
C        Function called: VOIGT
C
C        A C Davenhall. /ROE/                            28/10/81.
C
C        Based on a routine by A C Davenhall /UCL/      Spring 1977.
C
C-
       IMPLICIT NONE
       INTEGER  TIDC
       REAL     PROFPS(5000),ALAM(5000)
       REAL     WAVE1,WAVE4,WAVEI,WAVE
       INTEGER  NPTS,I,J,K,N
       REAL     B(500),VR(500),WEI(500),ZA(500)
       INTEGER  NCLD
       REAL     CO1,CO2,C,DUMMY,Z
       REAL     DELTAM,VNU,BB,WW,AA
C
       INTEGER IST,IPROF
       INTEGER QK(500,6),Q1(500,6),MUL(500),NAT(500)
       REAL WLO(500,6),SAKI(500,6),F1K(500,6)
       REAL AK1(500,6),CONST(500,6),DELTA(500,6)
       REAL LAM,BETA,R,VITES,XX1,XX2,CONV
       REAL VOIGT
C
C        Speed of light in Km/sec.
C
        DATA C/2.9979251E5/
C
       DATA CO1/2.654418269E-20/
       DATA CO2/7.487975686E-37/
       DATA CONV/1.499E-16/
C
C
       DO 20 J=1,NCLD
          N=NAT(J)
          LAM=VR(J) !voir definition de VR 
          ZA(J)=LAM/WLO(N,1)-1.
          R=(1.+Z)/(1.+ZA(J))
          BETA=(R**2-1.)/(R**2+1.)
          VITES=BETA*C
          CALL TBEWRR(TIDC,J,6,VITES,IST)       
          CALL TBEWRR(TIDC,J,7,ZA(J),IST)       
          DO 10 K=1,MUL(N)                    ! constantes atomiques
            AK1(N,K)=F1K(N,K)*FLOAT(Q1(N,K))
     :       /(FLOAT(QK(N,K))*(WLO(N,K)**2)*CONV)
            CONST(N,K)=CO2*AK1(N,K)*FLOAT(QK(N,K))/FLOAT(Q1(N,K))
            DELTA(N,K)=CO1*SAKI(N,K)
10        CONTINUE
20     CONTINUE
C*        

       DO 70 I=1,NPTS             !calcul du coefficient d'absorption
         DUMMY=0.0E0
         WAVEI=PROFPS(I)

C
         IF (IPROF.EQ.1) THEN
C CAS MAXWELL+ DAMPING WINGS
            DO 40  J=1,NCLD
               N=NAT(J)
               WW=WEI(J)
               WAVE=WAVEI/(1.+ZA(J))
               WAVE4=WAVE**4
               DO 30 K=1,MUL(N)
                   WAVE1=C/WLO(N,K)
                   BB=WAVE1/B(J) 
                   DELTAM=DELTA(N,K)*(WAVE**2)
                   AA=DELTAM*BB
                   VNU=(WAVE-WLO(N,K))*BB
                   DUMMY=DUMMY+
     :                   (WW*CONST(N,K)*WAVE4*VOIGT(VNU,AA)*BB)
30             CONTINUE
40          CONTINUE
         ELSE
C CAS MAXWELL SEUL
            DO 60 J=1,NCLD
               WW=WEI(J)
               BB=B(J)
               N=NAT(J)       
               WAVE=WAVEI/(1.+ZA(J))
               DO 50 K=1,MUL(N) 
                  XX1=WW*WLO(N,K)/BB*(1.495E-15)*F1K(N,K)
                  XX2=C*(WLO(N,K)-WAVE)/WAVE/BB
                  DUMMY=DUMMY+XX1*EXP(-XX2*XX2)
50             CONTINUE
60          CONTINUE
         ENDIF
C
         ALAM(I)=DUMMY
70     CONTINUE
C
       RETURN
       END
C
C***************************************************************
C
       REAL FUNCTION VOIGT(V,A)
C
C        Subroutine to evaluate a Voigtian.
C
C        Obtained from; S L Wright /UCL/              Spring 1977.
C
      IMPLICIT NONE
C
      REAL   V,A
      INTEGER N,N1
      REAL    V0,V1,V2
      REAL   H0(41),H1(81),H2(41)
      DATA H0/
     1 1.0000000, 0.9900500, 0.9607890, 0.9139310, 0.8521440, 0.7788010,
     2 0.6976760, 0.6126260, 0.5272920, 0.4448580, 0.3678790, 0.2984970,
     3 0.2369280, 0.1845200, 0.1408580, 0.1053990, 0.0773050, 0.0555760,
     4 0.0391640, 0.0270520, 0.0183156, 0.0121552, 0.0079071, 0.0050418,
     5 0.0031511, 0.0019305, 0.0011592, 0.0006823, 0.0003937, 0.0002226,
     6 0.0001234, 0.0000671, 0.0000357, 0.0000186, 0.0000095, 0.0000048,
     7 0.0000024, 0.0000011, 0.0000005, 0.0000002, 0.0000001/
      DATA H1/
     1-1.1283800,-1.1059600,-1.0404800,-0.9370300,-0.8034600,-0.6494500,
     2-0.4855200,-0.3219200,-0.1677200,-0.0301200, 0.0859400, 0.1778900,
     3 0.2453700, 0.2898100, 0.3139400, 0.3213000, 0.3157300, 0.3009400,
     4 0.2802700, 0.2564800, 0.2317260, 0.2075280, 0.1848820, 0.1643410,
     5 0.1461280, 0.1302360, 0.1165150, 0.1047390, 0.0946530, 0.0860050,
     6 0.0785650, 0.0721290, 0.0665260, 0.0616150, 0.0572810, 0.0534300,
     7 0.0499880, 0.0468940, 0.0440980, 0.0415610, 0.0392500, 0.0351950,
     8 0.0317620, 0.0288240, 0.0262880, 0.0240810, 0.0221460, 0.0204410,
     9 0.0189290, 0.0175820, 0.0163750, 0.0152910, 0.0143120, 0.0134260,
     A 0.0126200, 0.0118860, 0.0112145, 0.0105990, 0.0100332, 0.0095119,
     B 0.0090306, 0.0085852, 0.0081722, 0.0077885, 0.0074314, 0.0070985,
     C 0.0067875, 0.0064967, 0.0062243, 0.0059688, 0.0057287, 0.0055030,
     D 0.0052903, 0.0050898, 0.0049006, 0.0047217, 0.0045526, 0.0043924,
     E 0.0042405, 0.0040964, 0.0039595/
      DATA H2/
     1 1.0000000, 0.9702000, 0.8839000, 0.7494000, 0.5795000, 0.3894000,
     2 0.1953000, 0.0123000,-0.1476000,-0.2758000,-0.3679000,-0.4234000,
     3-0.4454000,-0.4392000,-0.4113000,-0.3689000,-0.3185000,-0.2657000,
     4-0.2146000,-0.1683000,-0.1282100,-0.0950500,-0.0686300,-0.0483000,
     5-0.0331500,-0.0222000,-0.0145100,-0.0092700,-0.0057800,-0.0035200,
     6-0.0021000,-0.0012200,-0.0007000,-0.0003900,-0.0002100,-0.0001100,
     7-0.0000600,-0.0000300,-0.0000100,-0.0000100, 0.0000000/
      V=ABS(V)
      V0=V*10.E0
      N=V0
      IF(N.LT.40) GO TO 1
      IF(N.LT.120)GO TO 2
      VOIGT=(0.56419E0+0.846E0/(V*V))/(V*V)*A
      RETURN
    1 V1=N
      N=N+1
      V2=V0-V1
      N1=N+1
      VOIGT=V2*(H0(N1)-H0(N)+A*(H1(N1)-H1(N)+A*(H2(N1)-H2(N))))+
     1 H0(N)+A*(H1(N)+A*H2(N))
      RETURN
    2 N=N/2+20
      V1=(N-20)*2
      N=N+1
      V2=(V0-V1)/2.E0
      N1=N+1
      VOIGT=A*((H1(N1)-H1(N))*V2+H1(N))
      RETURN
      END
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
       SUBROUTINE IMAGE(YI,YO,ALAM,NPIXO)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C       Calcul de l'image synthetique + absorption
C
       IMPLICIT NONE
C
       INTEGER NPIXO
       REAL YO(1),YI(1),ALAM(5000)
       INTEGER I
C
       DO 10 I=1,NPIXO
         YO(I)=YI(I)*EXP(-ALAM(I))   
10     CONTINUE
       RETURN 
       END
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CONVL1(F,NF,PSF,NP,C)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION:
C  subroutine CONVL1        version 2.00       840116
C  P. GROSBOL               ESO - GARCHING
C  K. Banse (streamlined for MIDAS)
C
C.KEYWORDS:
C  CONVOLUTION
C
C.PURPOSE:
C  CONVOLES TWO ONE DIMENSIONAL ARRAYS WITH EACH OTHER
C
C.ALGORITHM:
C  A ONE DIMENSIONAL ARRAY IS CONVOLED WITH A ONE DIMENSIONAL
C  POINT SPREAD FUNCTION. OUTSIDE THE LIMITS OF THE FUNCTION
C  ARRAY THE FIRST/LAST VALUE IS TAKEN.
C
C.INPUT/OUTPUT:
C  THE SUBROUTINE IS CALLED AS
C      CALL CONVL1(F,NF,PSF,NP,C)
C  WHERE THE PARAMETERS ARE
C  F(NF)   :  FUNCTION ARRAY                          (INPUT)
C  NF      :  DIMENSION OF FUNCTION ARRAY             (INPUT)
C  PSF(NP) :  POINT SPREAD FUNCTION ARRAY             (INPUT)
C  NP      :  DIMENSION OF POINT SPREAD FUNCTON       (INPUT)
C  C(NF)   :  CONVOLVED RESULT ARRAY                  (OUTPUT)
C
C  NOTE :  THE RESULT IS ADDED TO THE OUTPUT ARRAY 'C'.
C
C---------------------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER NF, NP
      REAL F(NF),C(NF),PSF(NP)
C
      INTEGER NOS, NL1, NL2, NL3, I, NR, K
      REAL    R, FACT
C
C  initialize
      NOS = NP/2
      NL1 = NOS + 1
      NL2 = NF - NOS
      NL3 = NL2 + 1
C
C  if NP = 1, we only use middle section
       IF (NOS.EQ.0) THEN
          DO 20 I = NL1,NL2
             NR = I - NOS
             R = 0.
             DO 10 K = 1,NP
               R = R + PSF(K)*F(NR)
               NR = NR + 1
10           CONTINUE
             C(I) = R
20        CONTINUE
          RETURN
       ENDIF
C       
C  for NP > 1, handle 1. section, where values before F(1) would be needed
       FACT = F(1)
       DO 50 I = 1,NOS
           R = 0.
          DO 30 K=1,1+NOS-I
             R = R + PSF(K)*FACT
30        CONTINUE
          NR = 1
           DO 40 K=2+NOS-I,NP
              R = R + PSF(K)*F(NR)
              NR = NR + 1
40         CONTINUE
           C(I) = R
50     CONTINUE
C
C  in the middle no problems
       DO 70 I = NL1,NL2
          NR = I - NOS
          R = 0.
          DO 60 K = 1,NP
             R = R + PSF(K)*F(NR)
             NR = NR + 1
60        CONTINUE
          C(I) = R
70     CONTINUE
C
C  last section, values after F(NF) would be needed
       FACT = F(NF)
       DO 100 I = NL3,NF
          NR = I - NOS
           R = 0.
          DO 80 K=1,NF+NOS-I
             R = R + PSF(K)*F(NR)
              NR = NR + 1
80        CONTINUE
          DO 90 K=NF+NOS-I+1,NP
              R = R + PSF(K)*FACT
90        CONTINUE
          C(I) = R
100    CONTINUE
C
       RETURN
       END

c
      real function riembi(p,q,x)
c implementation of Lentz's continued fraction 
c based on ideas from Numerical Recipes (Press et. al., 1986)
      implicit none
      real p,q,x,gamlog,rbfrac,zero,one,two,sav
      parameter (zero=0.,one=1.,two=2.)
c Abramovitz & Stegun 1971 (26.5.8)
      if (x.lt.zero.or.x.gt.one) then
cc obsolete Fortran statement: PAUSE
cc        pause 'riembi: argument X out of range'
        riembi = -999999.
        return
      elseif (x.eq.zero.or.x.eq.one) then
        sav=zero
      else
c Abramovitz & Stegun 1971 (6.2.2)
        sav=exp(gamlog(p+q)
     $-gamlog(p)-gamlog(q)+p*log(x)+q*log(one-x))
      endif
c Abramovitz & Stegun 1971 (26.5.8)
      if ((p+one)/(p+q+two).gt.x) then
        riembi=sav*rbfrac(p,q,x)/p
      else
c Abramovitz & Stegun 1971 (26.5.2)
        riembi=one-sav*rbfrac(q,p,one-x)/q
      endif
      end
c
c                                   
c                                                                               

C @(#)tdlist2.for	19.1 (ES0-DMD) 02/25/03 14:11:18
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA 12:00 - 11 JUL 1988
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C  900219  KB, throw out SX calls...
C  910130  MP  replace TBFSET by another stuff
C.IDENTIFICATION:    TDLIST2.FOR
C
C.KEYWORDS:          TABLE, APPLICATIONS
C
C.ENVIRONMENT:      MIDAS
C
C.PURPOSE
C
C  GET TABLE ENTRIES WITH INTRINSIC FORMAT
C  MODIFIED VERSION OF TDLIS1
C
C------------------------------------------------------------------
       SUBROUTINE TDLIS2(TABLE,NCOL,ICOL,IROW,CVAL,IHEAD,HEADER,STATUS)
C
C       List information from table.
C       Format is defined according to data type
C
       IMPLICIT        NONE
       INTEGER    TABLE           ! IN : table ident
       INTEGER    NCOL            ! IN : number of columns
       INTEGER    ICOL(NCOL)      ! IN : column index
       INTEGER    IROW            ! IN : row number
       CHARACTER*(*) CVAL         ! OUT: row values
       LOGICAL    IHEAD           ! IN : header flag
       CHARACTER*(*) HEADER       ! OUT: table header
       INTEGER    STATUS          ! OUT: status
C
       INTEGER          LIMIT
       PARAMETER       (LIMIT=30)
       LOGICAL          NULL(LIMIT)
C       LOGICAL          SELECT
       INTEGER          COL(LIMIT), ILAST
       INTEGER          I, NCOL1, I1, I2, II, ISTAT, ERNORM
       INTEGER          TYPE,LENGTH
       CHARACTER*128    LINE
       CHARACTER*72     ERRMSG
       CHARACTER*18     LABCOL
       CHARACTER*8      FORM
C
       INCLUDE          'MID_INCLUDE:TABLES.INC/NOLIST'
       INCLUDE          'MID_INCLUDE:TABLED.INC/NOLIST'
C
       DATA             ERRMSG/' *** Format conversion error ***'/
C
C ... DEFINE FORMAT AND HEADERS
C
       ERNORM = 0
       DO 10 I = 1, NCOL
           COL(I+1) = ICOL(I)
10     CONTINUE
       COL(1) = 0
       NCOL1 = NCOL+1
C
       IF (IHEAD) THEN
         HEADER    = ' Seq.no.'
         ILAST  = 0
C         CALL TBFSET(TABLE,NCOL1,COL,IFIRST,ILAST,STATUS)
C
C ... SET UP LABELS
C
         DO 20 I = 1, NCOL1
           CALL TBFGET(TABLE,COL(I),FORM,LENGTH,TYPE,STATUS)
           CALL TBLGET(TABLE,COL(I),LABCOL,STATUS)
           I1 = ILAST + 1
           I2 = ILAST + LENGTH + 1
           ILAST = I2
           IF (LABCOL.EQ.' ') THEN
             LABCOL = ' Column #'
             WRITE(LABCOL(10:12),9000) ICOL(I)
             II = 12
           ELSE IF (COL(I).EQ.0) THEN
             II = 9
           ELSE
             II = INDEX(LABCOL,' ') - 1 
           ENDIF
           IF (I2-I1+1.GE.II) THEN
             I1 = I1+(I2-I1+1-II)/2
             I2 = I1 + II - 1
             HEADER(I1:I2) = LABCOL(1:II)
           ELSE
              HEADER(I1:I1) = '#'
              WRITE(HEADER(I1+1:I1+3),9000) ICOL(I)
           ENDIF
20       CONTINUE
       ENDIF
C
C ... LIST ROW
C
C       CALL TBSGET(TABLE,I,SELECT,STATUS)
C       IF (SELECT) THEN
       CALL TBRRDC(TABLE,IROW,NCOL1,COL,LINE,NULL,ISTAT)
       IF (ISTAT.NE.ERNORM) CALL STTPUT(ERRMSG,ISTAT)
       CVAL = LINE
       RETURN
9000   FORMAT(I3)
       END

C @(#)fudge.for	19.1 (ES0-DMD) 02/25/03 13:23:49
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE  FUDGE (FILE, F)
C
C=======================================================================
C
C This subroutine permits the user to fudge the input image by inserting
C brightness values into rectangular subarrays, or by interpolating
C polynomials inward from the edge of the regions.
C
C             OFFICIAL DAO VERSION:  1991 April 18
C
C=======================================================================
C
      IMPLICIT NONE
      INTEGER MAXCOL, MAXPOL, MTERM
      PARAMETER  (MAXCOL=1024, MAXPOL=3, MTERM=10)
C
C Parameters
C
C MAXCOL is the width of the largest picture that can be accomodated.
C
C MAXPOL is the largest permitted polynomial order (0 = constant, 
C         1 = linear = plane, 2 = quadratic, ...)
C
C MTERM = (MAXPOL+1)*(MAXPOL+2)/2
C
      REAL F(MAXCOL,*), DATA(2)
      REAL C(MTERM,MTERM), V(MTERM), T(MTERM), A(MTERM)
C
      REAL AMAX1, AMIN1
      INTEGER MIN0, MAX0
C
      CHARACTER*30 FILE, NEWFIL, SWITCH
      CHARACTER CASE*1
      REAL X, DX, DY, DYSQ, W
      INTEGER I, J, K, L, LBX, LBY, MBX, MBY, ISTAT, NBORD, NPOLY
      INTEGER NCOL, NROW, N1, N2, LX, LY, NX, NY, NTERM, MX, MY, M
C
      COMMON /SIZE/ NCOL, NROW
C
C-----------------------------------------------------------------------
C
      CALL TBLANK
      NEWFIL=SWITCH(FILE, CASE('f'))
      CALL GETNAM ('Name for output picture:', NEWFIL)
      IF (NEWFIL .EQ. 'END OF FILE') RETURN        ! CTRL-Z was entered
      CALL COPPIC (NEWFIL, F, NCOL, NROW, ISTAT)
      IF (ISTAT .NE. 0) RETURN                  ! Error creating picture
      CALL TBLANK
      CALL GETDAT ('Border (pixels):', X, 1)
      NBORD = MAX0(0, NINT(X))
      IF (NBORD .GT. 0) THEN
         CALL GETDAT (
     .        'Polynomial order (0 = constant, 1 = plane, etc.):',
     .        X, 1)
         NPOLY = MAX0(0, MIN0(MAXPOL, NINT(X) ) )
         LX = 1
         LY = 1
         NX = NCOL
         NY = NROW
         CALL RDARAY ('COPY', LX, LY, NX, NY, MAXCOL, F, ISTAT)
      END IF
 1000 CALL TBLANK
 1005 DATA(2)=-1.
      CALL GETDAT ('First, last column number:', DATA, 2)
      IF (DATA(1) .LE. 0.) GO TO 9000
      IF (DATA(2) .LE. 0.) DATA(2)=DATA(1)
      LX=MAX0(1, NINT(AMIN1(DATA(1), DATA(2))) )
      MX=MIN0(NCOL, NINT(AMAX1(DATA(1), DATA(2))) )
 1010 DATA(2)=-1.
      CALL GETDAT ('First, last row number:', DATA, 2)
      IF (DATA(1) .LE. 0.) GO TO 1005
      IF (DATA(2) .LE. 0.) DATA(2)=DATA(1)
      LY=MAX0(1, NINT(AMIN1(DATA(1), DATA(2))) )
      MY=MIN0(NROW, NINT(AMAX1(DATA(1), DATA(2))) )
      IF (NBORD .GT. 0) GO TO 5000
      CALL GETDAT ('Brightness value:', DATA, 1)
      IF (DATA(1) .LE. -1.E38) GO TO 1010
      NX = MX-LX+1
      DO I=1,NX
         F(I,1)=DATA(1)
      END DO
      DO 1100 J=LY,MY
      NY=1
 1100 CALL WRARAY ('COPY', LX, J, NX, NY, MAXCOL, F, ISTAT)
      GO TO 1000
C
C-----------------------------------------------------------------------
C
 5000 CONTINUE
      LBX = MAX0(1, LX-NBORD)
      MBX = MIN0(NCOL, MX+NBORD)
      LBY = MAX0(1, LY-NBORD)
      MBY = MIN0(NROW, MY+NBORD)
      NTERM = (NPOLY+2)*(NPOLY+1)/2
C
C Loop over pixels in designated defect.
C
      DO J=LY,MY
         DO I=LX,MX
C
            DO L=1,NTERM
               V(L) = 0.
               DO K=1,NTERM
                  C(K,L) = 0.
               END DO
            END DO
C
C Lower y.
C
            IF (LBY .LT. LY) THEN
               DO L=LBY,LY-1
                  DY = REAL(L-J)
                  DYSQ = DY**2
                  DO K=LBX,MBX
                     DX = REAL(K-I)
                     M = 0
                     DO N1=0,NPOLY
                        DO N2=0,N1
                           M = M+1
                           T(M) = 1.
                           IF (N1-N2 .GT. 0) T(M) = DX**(N1-N2)
                           IF (N2 .GT. 0) T(M) = T(M)*DY**N2
                        END DO
                     END DO
C
                     W = 1./(DX**2 + DYSQ)**2
                     DO N1=1,M
                        V(N1) = V(N1) + W * T(N1) * F(K,L)
                        DO N2=1,M
                           C(N1,N2) = C(N1,N2) + W * T(N1) * T(N2)
                        END DO
                     END DO
                  END DO
               END DO
            END IF
C
            DO L=LY,MY
               DY = REAL(L-J)
               DYSQ = DY**2
C
C Lower x
C
               IF (LBX .LT. LX) THEN
                  DO K=LBX,LX-1
                     DX = REAL(K-I)
                     M = 0
                     DO N1=0,NPOLY
                        DO N2=0,N1
                           M = M+1
                           T(M) = 1.
                           IF (N1-N2 .GT. 0) T(M) = DX**(N1-N2)
                           IF (N2 .GT. 0) T(M) = T(M)*DY**N2
                        END DO
                     END DO
C
                     W = 1./(DX**2 + DYSQ)**2
                     DO N1=1,M
                        V(N1) = V(N1) + W * T(N1) * F(K,L)
                        DO N2=1,M
                           C(N1,N2) = C(N1,N2) + W * T(N1) * T(N2)
                        END DO
                     END DO
                  END DO
               END IF
C
C Upper x.
C
               IF (MBX .GT. MX) THEN
                  DO K=MX+1,MBX
                     DX = REAL(K-I)
                     M = 0
                     DO N1=0,NPOLY
                        DO N2=0,N1
                           M = M+1
                           T(M) = 1.
                           IF (N1-N2 .GT. 0) T(M) = DX**(N1-N2)
                           IF (N2 .GT. 0) T(M) = T(M)*DY**N2
                        END DO
                     END DO
C
                     W = 1./(DX**2 + DYSQ)**2
                     DO N1=1,M
                        V(N1) = V(N1) + W * T(N1) * F(K,L)
                        DO N2=1,M
                           C(N1,N2) = C(N1,N2) + W * T(N1) * T(N2)
                        END DO
                     END DO
                  END DO
               END IF
            END DO
C 
C Upper y.
C
            IF (MBY .GT. MY) THEN
               DO L=MY+1,MBY
                  DY = REAL(L-J)
                  DYSQ = DY**2
                  DO K=LBX,MBX
                     DX = REAL(K-I)
                     M = 0
                     DO N1=0,NPOLY
                        DO N2=0,N1
                           M = M+1
                           T(M) = 1.
                           IF (N1-N2 .GT. 0) T(M) = DX**(N1-N2)
                           IF (N2 .GT. 0) T(M) = T(M)*DY**N2
                        END DO
                     END DO
C
                     W = 1./(DX**2 + DYSQ)**2
                     DO N1=1,M
                        V(N1) = V(N1) + W * T(N1) * F(K,L)
                        DO N2=1,M
                           C(N1,N2) = C(N1,N2) + W * T(N1) * T(N2)
                        END DO
                     END DO
                  END DO
               END DO
            END IF
C
            CALL INVERS (C, MTERM, NTERM, ISTAT)
            CALL VMUL (C, MTERM, NTERM, V, A)
            F(I,J) = A(1)
         END DO
      END DO
      GO TO 1000
C
 9000 CONTINUE
      IF (NBORD .GT. 0) THEN
         LX = 1
         LY = 1
         NX = NCOL
         NY = NROW
         CALL WRARAY ('COPY', LX, LY, NX, NY, MAXCOL, F, ISTAT)
      END IF
      CALL CLPIC ('COPY')
C
C-----------------------------------------------------------------------
C
C Normal return.
C
      RETURN
      END!

C @(#)fftetc.for	19.1 (ES0-DMD) 02/25/03 13:25:06
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C FFTETC.F - some useful FFT and convolution routines.
C
C This file contains three subroutines:
C
C  i) An FFT implementation which is fast and flexible
C     (even though it is 25 years old). It is called DFOURT.
C
C ii) A simple piece of code which puts an image into the
C     correct form to be swallowed by DFOURT. It is DFILL.
C
C iii) A convolution code which uses the former to convolve a
C      supplied image with the FFT of a supplied PSF. It is
C      DCONV.
C
C The authors of the first of these are given in the comment
C block at the start of the code. The other two smaller routines
C were written by Richard Hook, Autumn 1992.
C
C Note that all these routines work fully in DOUBLE PRECISION.
C
C Note - this is a stripped down version, the full one
C        with different kinds of FFT and single precisio
C        versions is in 'bigfftetc.f'
C
      SUBROUTINE DFILL(DATA,NX,NY,OUT)
C
C Fill up an array in the way required by the DFOURT
C FFT routines
C
C Supplied:
C  
C DATA - a double precision 2d array.
C
C NX,NY - integers, the array dimensions.
C
C Returned:
C
C OUT - a double precision 1d array in the correct form
C       to be used by the DFOURT FFT routines. The data values
C       in DATA are simply put into alternating elements and
C       the rest set to zero.
C
C Note this routine has a 'fudge factor' of 1 pixel to align coordinate
C systems correctly.
C
      IMPLICIT NONE
                   
      INTEGER NX,NY,IP,I,J
      DOUBLE PRECISION DATA(NX,NY)
      DOUBLE PRECISION OUT(NX*NY*2)
                                   
      IP=1
          
      IF(NY.GT.1) THEN
         DO I=1,NX
            OUT(IP)=0.0D0
            IP=IP+2
         ENDDO
              
         DO J=1,NY-1
            OUT(IP)=0.0D0
            IP=IP+2
            DO I=1,NX-1
               OUT(IP-1)=0.0D0
               OUT(IP)=DATA(I,J)
               IP=IP+2
            ENDDO
          ENDDO
       ELSE
         DO I=1,NX
            OUT(IP)=DATA(I,1)
            OUT(IP+1)=0.0D0
            IP=IP+2
         ENDDO
      ENDIF
           
      RETURN
      END
         
      SUBROUTINE DCONV(DATA,NX,NY,WORK,PSFFFT,OUT,FLAG)
C
C Convolve a one or two dimensional REAL array with a PSF which is supplied as
C a double precision FFT. Uses the DFOURT FFT code. 
C
C Supplied:
C
C DATA - 2d double precision image array of dimensions (NX,NY)
C
C NX,NY - integers, the dimensions of this array
C
C WORK - double precision 1d array of dimension (NX*NY*2)
C        This is used as workspace for the FFTs.
C
C PSFFFT - double precision 1d array of dimension (NX*NY*2)
C          This is the FFT of the PSF as created by the routine
C          DFOURT.
C
C FLAG - integer (1 or -1). If this is set to 1 a simple
C        convolution operation will be performed. If -1
C        a correlation will be done instead. This is equivalent
C        to using a PSF rotated by 180 degrees or multiplying the
C        imaginary part of the PSF FFT by -1.
C
C Returned:
C
C OUT - 2d double precision image array of dimensions (NX,NY)
C       The result of the convolution.
C
C Richard Hook, ST-ECF, October 1991
C Double precision version, March 1992
C 1D version, August 1992
C Modified to use DFOURT and improved comments, October 1992
C
      IMPLICIT NONE
                   
      INTEGER I,J,N,IP,IQ
      DOUBLE PRECISION A,B,C,D,FAC
      INTEGER NX,NY                ! ARRAY SIZE
      INTEGER NDIMS,DIMS(2),NX2,NY2
      INTEGER FLAG                 ! ROTATED OR NOT?
      DOUBLE PRECISION DATA(NX,NY)             ! INPUT DATA ARRAY
      DOUBLE PRECISION OUT(NX,NY)
      DOUBLE PRECISION PSFFFT(NX*NY*2)         ! FFT OF PSF
      DOUBLE PRECISION WORK(NX*NY*2)           ! WORKSPACE FOR FFT OF DATA
      DOUBLE PRECISION SCRATCH(4096)
      DOUBLE PRECISION DFLAG
                            
      DFLAG=DBLE(FLAG)
      IF(NY.EQ.1) THEN
         NDIMS=1
      ELSE
         NDIMS=2
      ENDIF
           
C Copy the data into the real part of the working array
      IP=1
      DO J=1,NY
         DO I=1,NX
            WORK(IP)=DATA(I,J)
            WORK(IP+1)=0.0D0
            IP=IP+2
         ENDDO
      ENDDO
           
C Take the forward FFT of the data array
      DIMS(1)=NX
      DIMS(2)=NY
                
      CALL DFOURT(WORK,DIMS,NDIMS,-1,0,SCRATCH)
                                               
C Do a complex multiplication of the FFT of the data and of the PSF
C
C If the rotation flag is set (to -1) we multiply the imaginary part
C of the FFT by -1
      IP=1
      IQ=2
      DO N=1,NX*NY
         A=WORK(IP)
         B=WORK(IQ)
         C=PSFFFT(IP)
         D=DFLAG*PSFFFT(IQ)
         WORK(IP)=A*C-B*D
         WORK(IQ)=A*D+B*C
         IP=IP+2
         IQ=IQ+2
      ENDDO
           
C Take the inverse FFT
      CALL DFOURT(WORK,DIMS,NDIMS,1,1,SCRATCH)
                                              
C Copy the result into the output array
C and 'quadrant swap':
      FAC=DFLOAT(NX*NY)
      IP=1
          
      NX2=MAX(1,NX/2)
      NY2=MAX(1,NY/2)
                     
      IF(NY.GT.1) THEN
       DO J=1,NY2
          DO I=1,NX2
             OUT(I+NX/2,J+NY/2)=WORK(IP)/FAC
             IP=IP+2
          ENDDO
          IP=IP+NX
       ENDDO
            
       IP=NX+1
       DO J=1,NY2
          DO I=1,NX2
             OUT(I,J+NY/2)=WORK(IP)/FAC
             IP=IP+2
          ENDDO
          IP=IP+NX
       ENDDO
            
       IP=NX*NY+1
       DO J=1,NY2
          DO I=1,NX2
             OUT(I+NX/2,J)=WORK(IP)/FAC
             IP=IP+2
          ENDDO
          IP=IP+NX
       ENDDO
            
       IP=NX*NY+NX+1
       DO J=1,NY2
          DO I=1,NX2
             OUT(I,J)=WORK(IP)/FAC
             IP=IP+2
          ENDDO
          IP=IP+NX
       ENDDO
      ELSE
          
C 1D case
       DO I=1,NX2
         OUT(I+NX2,1)=WORK(IP)/FAC
         IP=IP+2
       ENDDO
            
       DO I=1,NX2
         OUT(I,1)=WORK(IP)/FAC
         IP=IP+2
       ENDDO
      ENDIF
           
      RETURN
      END
         
      SUBROUTINE DFOURT(DATA,NN,NDIM,ISIGN,IFORM,WORK)
C
C Double Precision version of FOURT.F
C
C Richard Hook, ST-ECF, October 1992
C
C-------------------Start of original code (modified to be more readable)
C
C  June 30, 1983
C
C  Watch out for INTEGER*4 on VAX!! NN, ISIGN and IFORM must all
C  be dimensioned INTEGER*4 
C
C     The Fast Fourier Transform in USASI basic FORTRAN
C     -------------------------------------------------
C
C     TRANSFORM(J1,J2,...) = SUM(DATA(I1,I2,...)*W1**((I1-1)*(J1-1))
C                                 *W2**((I2-1)*(J2-1))*...),
C
C     where I1 and J1 run from 1 to NN(1) and W1=EXP(ISIGN*2*PI*
C     SQRT(-1)/NN(1)), etc.  there is no limit on the dimensionality
C     (number of subscripts) of the data array.  If an inverse
C     transform (ISIGN=+1) is performed upon an array of transformed
C     (ISIGN=-1) data, the original data will reappear,
C     multiplied by NN(1)*NN(2)*...  The array of input data may be
C     real or complex, at the programmers option, with a saving of
C     up to forty per cent in running time for real over complex.
C     (for fastest transform of real data, NN(1) should be even.)
C     the transform values are always complex, and are returned in the
C     original array of data, replacing the input data.  the length
C     of each dimension of the data array may be any integer.  the
C     program runs faster on composite integers than on primes, and is
C     particularly fast on numbers rich in factors of two.
C
C     Timing is in fact given by the following formula.  Let NTOT be the
C     total number of points (real or complex) in the data array, that
C     is, NTOT=NN(1)*NN(2)*...  decompose NTOT into its prime factors,
C     such as 2**K2 * 3**K3 * 5**K5 * ...  Let SUM2 be the sum of all
C     the factors of two in NTOT, that is, SUM2 = 2*K2.  Let SUMF be
C     the sum of all other factors of NTOT, that is, SUMF = 3*K3+5*K5+..
C     The time taken by a multidimensional transform on these NTOT data
C     point add time = six microseconds), T = 3000 + NTOT*(600+40*SUM2+
C     is T = T0 + NTOT*(T1+T2*SUM2+T3*SUMF). On the CDC 3300 (floating
C     175*SUMF) microseconds on complex data.
C
C     Implementation of the definition by summation will run in a time
C     proportional to NTOT*(NN(1)+NN(2)+...). For highly composite NTOT
C     the savings offered by this program can be dramatic. A one-dimen-
C     sional array 4000 in length will be transformed in 4000*(600+
C     40*(2+2+2+2+2)+175*(5+5+5)) = 14.5 seconds versus about 4000*
C     4000*175 = 2800 seconds for the straightforward technique.
C
C     [Note added by Richard Hook, October 1992:  as a rough guide  ]
C     [the time taken for a real and imaginary FFT of a 512*512     ]
C     [array is about 8s on a SPARCStation 2                        ]         
C
C     The Fast Fourier algorithm places two restrictions upon the
C     nature of the data beyond the usual restriction that
C     the data form one cycle of a periodic function.  They are--
C     1.  The number of input data and the number of transform values
C     must be the same.
C     2. Considering the data to be in the time domain,
C     they must be equi-spaced at intervals of DT.  Further, the trans-
C     form values, considered to be in frequency space, will be equi-
C     spaced from 0 to 2*PI*(NN(I)-1)/(NN(I)*DT) at intervals of
C     2*PI/(NN(I)*DT) for each dimension of length NN(I).  Of course,
C     dt need not be the same for every dimension.
C
C     The calling sequence is--
C
C     CALL DFOURT(DATA,NN,NDIM,ISIGN,IFORM,WORK)
C
C     DATA is the array used to hold the real and imaginary parts
C     of the data on input and the transform values on output.  It
C     is a multidimensional floating point array, with the real and
C     imaginary parts of a datum stored immediately adjacent in storage
C     (such as FORTRAN IV places them).  The extent of each dimension
C     is given in the integer array NN, of length NDIM.  ISIGN is -1
C     to indicate a forward transform (exponential sign is -) and +1
C     for an inverse transform (sign is +).  IFORM is +1 if the data and
C     the transform values are complex.  It is 0 if the data are real
C     but the transform values are complex.  If it is 0, the imaginary
C     parts of the data should be set to zero.  As explained above, the
C     transform values are always complex and are stored in array data.
C     work is an array used for working storage.  It is not necessary
C     if all the dimensions of the data are powers of two.  In this case
C     it may be replaced by 0 in the calling sequence.  Thus, use of
C     powers of two can free a good deal of storage.  If any dimension
C     is not a power of two, this array must be supplied.  It is
C     floating point, one dimensional of length equal to twice the
C     largest array dimension (i.e., NN(I) ) that is not a power of
C     two.  Therefore, in one dimension for a non power of two,
C     work occupies as many storage locations as data.  If supplied,
C     work must not be the same array as data.  All subscripts of all
C     arrays begin at one.
C
C     Example 1.  Three-dimensional forward Fourier Transform of a
C     complex array dimensioned 32 by 25 by 13 in FORTRAN IV.
C
C     DOUBLE PRECISION DATA(32,25,13),WORK(50),NN(3)
C     COMPLEX DATA
C     DATA NN/32,25,13/
C     DO 1 I=1,32
C     DO 1 J=1,25
C     DO 1 K=1,13
C  1  DATA(I,J,K)=COMPLEX VALUE
C     CALL DFOURT(DATA,NN,3,-1,1,WORK)
C
C     Example 2.  One-dimensional forward transform of a real array of
C     length 64 in FORTRAN II.
C
C     DOUBLE PRECISION DATA(2,64)
C     DO 2 I=1,64
C     DATA(1,I)=REAL PART
C  2  DATA(2,I)=0.
C     CALL DFOURT(DATA,64,1,-1,0,0)
C
C     There are no error messages or error halts in this program.  The
C     program returns immediately if ndim or any nn(i) is less than one.
C
C     Program by Norman Brenner from the BASIC program by Charles
C     Rader (both of MIT Lincoln Laboratory).  May 1967.  The idea
C     for the digit reversal was suggested by Ralph Alter (also MIT LL).
C     This is the fastest and most versatile version of the FFT known
C     to the author.  A program called four2 is available that also
C     performs the fast fourier transform and is written in usasi basic
C     fortran.  It is about one third as long and restricts the
C     dimensions of the input array (which must be complex) to be powers
C     of two.  Another program, called four1, is one tenth as long and
C     runs two thirds as fast on a one-dimensional complex array whose
C     length is a power of two.
C
C     Reference--
C     Fast Fourier Transforms for Fun and Profit, W. Gentleman and
C     G. Sande, 1966 Fall Joint Computer Conference.
C
C     The work reported in this document was performed at Lincoln Lab-
C     oratory, a center for research operated by Massachusetts Institute
C     of Technology, with the support of the U.S. Air Force under
C     contract af 19(628)-5167.
C
C-------------End of original comment block.
C
      IMPLICIT  NONE
C
      DOUBLE PRECISION DATA(*),WORK(*)
      DOUBLE PRECISION TWOPI,RTHLF,THETA,WR,WI
      DOUBLE PRECISION W2R,W2I,W3R,W3I,SUMR,SUMI,DIFR,DIFI
      DOUBLE PRECISION TEMPR,TEMPI,T2R,T2I,T3R,T3I,WTEMP
      DOUBLE PRECISION T4R,T4I,WSTPR,WSTPI,THETM,WMINR,WMINI
      DOUBLE PRECISION TWOWR,SR,SI,OLDSR,OLDSI,STMPR,STMPI
      DOUBLE PRECISION U1R,U1I,U2R,U2I,U3R,U3I,U4I,U4R

      INTEGER IFACT(32),NN(1)
      INTEGER ISIGN,IFORM
      INTEGER NDIM,NTOT,NHALF,IMAX,IMIN,JMAX
      INTEGER NP1,NP2,I,J,N,M,NTWO,IF,IDIV,IQUOT,IREM,INON2,NON2P
      INTEGER ICASE,IFMIN,I1RNG,IDIM,NP0,NPREV
      INTEGER I1,I2,I3,J1,J2,J3,K1,K2,K3,IPAR,KDIF,NP1TW,MMAX
      INTEGER NP2HF,I1MAX,NWORK,IFP1,IFP2,I2MAX,LMAX,L
      INTEGER KMIN,KSTEP,K4,J2MAX,JMIN,J3MAX

C Initialise constants
      TWOPI=6.28318530717959D0
      RTHLF=DSQRT(2.0D0)/2.0D0

C Start of executable code
      IF(NDIM-1)920,1,1
1     NTOT=2
      DO 2 IDIM=1,NDIM
      IF(NN(IDIM))920,920,2
2     NTOT=NTOT*NN(IDIM)
C
C     main loop for each dimension
C
      NP1=2
      DO 910 IDIM=1,NDIM
      N=NN(IDIM)
      NP2=NP1*N
      IF(N-1)920,900,5
C
C     is n a power of two and if not, what are its factors
C
5     M=N
      NTWO=NP1
      IF=1
      IDIV=2
10    IQUOT=M/IDIV
      IREM=M-IDIV*IQUOT
      IF(IQUOT-IDIV)50,11,11
11    IF(IREM)20,12,20
12    NTWO=NTWO+NTWO
      IFACT(IF)=IDIV
      IF=IF+1
      M=IQUOT
      GO TO 10
20    IDIV=3
      INON2=IF
30    IQUOT=M/IDIV
      IREM=M-IDIV*IQUOT
      IF(IQUOT-IDIV)60,31,31
31    IF(IREM)40,32,40
32    IFACT(IF)=IDIV
      IF=IF+1
      M=IQUOT
      GO TO 30
40    IDIV=IDIV+2
      GO TO 30
50    INON2=IF
      IF(IREM)60,51,60
51    NTWO=NTWO+NTWO
      GO TO 70
60    IFACT(IF)=M
70    NON2P=NP2/NTWO
C
C     Separate four cases--
C        1. Complex transform
C        2. Real transform for the 2nd, 3rd, etc. dimension.  method--
C           transform half the data, supplying the other half by con-
C           jugate symmetry.
C        3. Real transform for the 1st dimension, n odd.  method--
C           set the imaginary parts to zero.
C        4. Real transform for the 1st dimension, n even.  method--
C           transform a complex array of length n/2 whose real parts
C           are the even numbered real values and whose imaginary parts
C           are the odd numbered real values.  separate and supply
C           the second half by conjugate symmetry.
C
      ICASE=1
      IFMIN=1
      I1RNG=NP1
      IF(IDIM-4)74,100,100
74    IF(IFORM)71,71,100
71    ICASE=2
      I1RNG=NP0*(1+NPREV/2)
      IF(IDIM-1)72,72,100
72    ICASE=3
      I1RNG=NP1
      IF(NTWO-NP1)100,100,73
73    ICASE=4
      IFMIN=2
      NTWO=NTWO/2
      N=N/2
      NP2=NP2/2
      NTOT=NTOT/2
      I=1
      DO 80 J=1,NTOT
      DATA(J)=DATA(I)
80    I=I+2
C
C     Shuffle data by bit reversal, since n=2**k.  as the shuffling
C     can be done by simple interchange, no working array is needed
C
100   IF(NON2P-1)101,101,200
101   NP2HF=NP2/2
      J=1
      DO 150 I2=1,NP2,NP1
      IF(J-I2)121,130,130
121   I1MAX=I2+NP1-2
      DO 125 I1=I2,I1MAX,2
      DO 125 I3=I1,NTOT,NP2
      J3=J+I3-I2
      TEMPR=DATA(I3)
      TEMPI=DATA(I3+1)
      DATA(I3)=DATA(J3)
      DATA(I3+1)=DATA(J3+1)
      DATA(J3)=TEMPR
125   DATA(J3+1)=TEMPI
130   M=NP2HF
140   IF(J-M)150,150,141
141   J=J-M
      M=M/2
      IF(M-NP1)150,140,140
150   J=J+M
      GO TO 300
C
C     Shuffle data by digit reversal for general n
C
200   NWORK=2*N
      DO 270 I1=1,NP1,2
      DO 270 I3=I1,NTOT,NP2
      J=I3
      DO 260 I=1,NWORK,2
      IF(ICASE-3)210,220,210
210   WORK(I)=DATA(J)
      WORK(I+1)=DATA(J+1)
      GO TO 240
220   WORK(I)=DATA(J)
      WORK(I+1)=0.0D0
240   IFP2=NP2
      IF=IFMIN
250   IFP1=IFP2/IFACT(IF)
      J=J+IFP1
      IF(J-I3-IFP2)260,255,255
255   J=J-IFP2
      IFP2=IFP1
      IF=IF+1
      IF(IFP2-NP1)260,260,250
260   CONTINUE
      I2MAX=I3+NP2-NP1
      I=1
      DO 270 I2=I3,I2MAX,NP1
      DATA(I2)=WORK(I)
      DATA(I2+1)=WORK(I+1)
270   I=I+2
C
C     Main loop for factors of two.
C     W=EXP(ISIGN*2*PI*SQRT(-1)*M/(4*MMAX)).  Check for W=ISIGN*SQRT(-1)
C     and repeat for W=W*(1+ISIGN*SQRT(-1))/SQRT(2).
C
300   IF(NTWO-NP1)600,600,305
305   NP1TW=NP1+NP1
      IPAR=NTWO/NP1
310   IF(IPAR-2)350,330,320
320   IPAR=IPAR/4
      GO TO 310
330   DO 340 I1=1,I1RNG,2
      DO 340 K1=I1,NTOT,NP1TW
      K2=K1+NP1
      TEMPR=DATA(K2)
      TEMPI=DATA(K2+1)
      DATA(K2)=DATA(K1)-TEMPR
      DATA(K2+1)=DATA(K1+1)-TEMPI
      DATA(K1)=DATA(K1)+TEMPR
340   DATA(K1+1)=DATA(K1+1)+TEMPI
350   MMAX=NP1
360   IF(MMAX-NTWO/2)370,600,600
370   LMAX=MAX0(NP1TW,MMAX/2)
      DO 570 L=NP1,LMAX,NP1TW
      M=L
      IF(MMAX-NP1)420,420,380
380   THETA=-TWOPI*DFLOAT(L)/DFLOAT(4*MMAX)
      IF(ISIGN)400,390,390
390   THETA=-THETA
400   WR=DCOS(THETA)
      WI=DSIN(THETA)
410   W2R=WR*WR-WI*WI
      W2I=2.0D0*WR*WI
      W3R=W2R*WR-W2I*WI
      W3I=W2R*WI+W2I*WR
420   DO 530 I1=1,I1RNG,2
      KMIN=I1+IPAR*M
      IF(MMAX-NP1)430,430,440
430   KMIN=I1
440   KDIF=IPAR*MMAX
450   KSTEP=4*KDIF
      IF(KSTEP-NTWO)460,460,530
460   DO 520 K1=KMIN,NTOT,KSTEP
      K2=K1+KDIF
      K3=K2+KDIF
      K4=K3+KDIF
      IF(MMAX-NP1)470,470,480
470   U1R=DATA(K1)+DATA(K2)
      U1I=DATA(K1+1)+DATA(K2+1)
      U2R=DATA(K3)+DATA(K4)
      U2I=DATA(K3+1)+DATA(K4+1)
      U3R=DATA(K1)-DATA(K2)
      U3I=DATA(K1+1)-DATA(K2+1)
      IF(ISIGN)471,472,472
471   U4R=DATA(K3+1)-DATA(K4+1)
      U4I=DATA(K4)-DATA(K3)
      GO TO 510
472   U4R=DATA(K4+1)-DATA(K3+1)
      U4I=DATA(K3)-DATA(K4)
      GO TO 510
480   T2R=W2R*DATA(K2)-W2I*DATA(K2+1)
      T2I=W2R*DATA(K2+1)+W2I*DATA(K2)
      T3R=WR*DATA(K3)-WI*DATA(K3+1)
      T3I=WR*DATA(K3+1)+WI*DATA(K3)
      T4R=W3R*DATA(K4)-W3I*DATA(K4+1)
      T4I=W3R*DATA(K4+1)+W3I*DATA(K4)
      U1R=DATA(K1)+T2R
      U1I=DATA(K1+1)+T2I
      U2R=T3R+T4R
      U2I=T3I+T4I
      U3R=DATA(K1)-T2R
      U3I=DATA(K1+1)-T2I
      IF(ISIGN)490,500,500
490   U4R=T3I-T4I
      U4I=T4R-T3R
      GO TO 510
500   U4R=T4I-T3I
      U4I=T3R-T4R
510   DATA(K1)=U1R+U2R
      DATA(K1+1)=U1I+U2I
      DATA(K2)=U3R+U4R
      DATA(K2+1)=U3I+U4I
      DATA(K3)=U1R-U2R
      DATA(K3+1)=U1I-U2I
      DATA(K4)=U3R-U4R
520   DATA(K4+1)=U3I-U4I
      KDIF=KSTEP
      KMIN=4*(KMIN-I1)+I1
      GO TO 450
530   CONTINUE
      M=M+LMAX
      IF(M-MMAX)540,540,570
540   IF(ISIGN)550,560,560
550   TEMPR=WR
      WR=(WR+WI)*RTHLF
      WI=(WI-TEMPR)*RTHLF
      GO TO 410
560   TEMPR=WR
      WR=(WR-WI)*RTHLF
      WI=(TEMPR+WI)*RTHLF
      GO TO 410
570   CONTINUE
      IPAR=3-IPAR
      MMAX=MMAX+MMAX
      GO TO 360
C
C     Main loop for factors not equal to two.
C     W=EXP(ISIGN*2*PI*SQRT(-1)*(J1+J2-I3-1)/IFP2)
C
600   IF(NON2P-1)700,700,601
601   IFP1=NTWO
      IF=INON2
610   IFP2=IFACT(IF)*IFP1
      THETA=-TWOPI/DFLOAT(IFACT(IF))
      IF(ISIGN)612,611,611
611   THETA=-THETA
612   WSTPR=DCOS(THETA)
      WSTPI=DSIN(THETA)
      DO 650 J1=1,IFP1,NP1
      THETM=-TWOPI*DFLOAT(J1-1)/DFLOAT(IFP2)
      IF(ISIGN)614,613,613
613   THETM=-THETM
614   WMINR=DCOS(THETM)
      WMINI=DSIN(THETM)
      I1MAX=J1+I1RNG-2
      DO 650 I1=J1,I1MAX,2
      DO 650 I3=I1,NTOT,NP2
      I=1
      WR=WMINR
      WI=WMINI
      J2MAX=I3+IFP2-IFP1
      DO 640 J2=I3,J2MAX,IFP1
      TWOWR=WR+WR
      J3MAX=J2+NP2-IFP2
      DO 630 J3=J2,J3MAX,IFP2
      JMIN=J3-J2+I3
      J=JMIN+IFP2-IFP1
      SR=DATA(J)
      SI=DATA(J+1)
      OLDSR=0.0D0
      OLDSI=0.0D0
      J=J-IFP1
620   STMPR=SR
      STMPI=SI
      SR=TWOWR*SR-OLDSR+DATA(J)
      SI=TWOWR*SI-OLDSI+DATA(J+1)
      OLDSR=STMPR
      OLDSI=STMPI
      J=J-IFP1
      IF(J-JMIN)621,621,620
621   WORK(I)=WR*SR-WI*SI-OLDSR+DATA(J)
      WORK(I+1)=WI*SR+WR*SI-OLDSI+DATA(J+1)
630   I=I+2
      WTEMP=WR*WSTPI
      WR=WR*WSTPR-WI*WSTPI
640   WI=WI*WSTPR+WTEMP
      I=1
      DO 650 J2=I3,J2MAX,IFP1
      J3MAX=J2+NP2-IFP2
      DO 650 J3=J2,J3MAX,IFP2
      DATA(J3)=WORK(I)
      DATA(J3+1)=WORK(I+1)
650   I=I+2
      IF=IF+1
      IFP1=IFP2
      IF(IFP1-NP2)610,700,700
C
C     Complete a real transform in the 1st dimension, N even, by con-
C     jugate symmetries.
C
700   GO TO (900,800,900,701),ICASE
701   NHALF=N
      N=N+N
      THETA=-TWOPI/DFLOAT(N)
      IF(ISIGN)703,702,702
702   THETA=-THETA
703   WSTPR=DCOS(THETA)
      WSTPI=DSIN(THETA)
      WR=WSTPR
      WI=WSTPI
      IMIN=3
      JMIN=2*NHALF-1
      GO TO 725
710   J=JMIN
      DO 720 I=IMIN,NTOT,NP2
      SUMR=(DATA(I)+DATA(J))/2.0D0
      SUMI=(DATA(I+1)+DATA(J+1))/2.0D0
      DIFR=(DATA(I)-DATA(J))/2.0D0
      DIFI=(DATA(I+1)-DATA(J+1))/2.0D0
      TEMPR=WR*SUMI+WI*DIFR
      TEMPI=WI*SUMI-WR*DIFR
      DATA(I)=SUMR+TEMPR
      DATA(I+1)=DIFI+TEMPI
      DATA(J)=SUMR-TEMPR
      DATA(J+1)=-DIFI+TEMPI
720   J=J+NP2
      IMIN=IMIN+2
      JMIN=JMIN-2
      WTEMP=WR*WSTPI
      WR=WR*WSTPR-WI*WSTPI
      WI=WI*WSTPR+WTEMP
725   IF(IMIN-JMIN)710,730,740
730   IF(ISIGN)731,740,740
731   DO 735 I=IMIN,NTOT,NP2
735   DATA(I+1)=-DATA(I+1)
740   NP2=NP2+NP2
      NTOT=NTOT+NTOT
      J=NTOT+1
      IMAX=NTOT/2+1
745   IMIN=IMAX-2*NHALF
      I=IMIN
      GO TO 755
750   DATA(J)=DATA(I)
      DATA(J+1)=-DATA(I+1)
755   I=I+2
      J=J-2
      IF(I-IMAX)750,760,760
760   DATA(J)=DATA(IMIN)-DATA(IMIN+1)
      DATA(J+1)=0.
      IF(I-J)770,780,780
765   DATA(J)=DATA(I)
      DATA(J+1)=DATA(I+1)
770   I=I-2
      J=J-2
      IF(I-IMIN)775,775,765
775   DATA(J)=DATA(IMIN)+DATA(IMIN+1)
      DATA(J+1)=0.
      IMAX=IMIN
      GO TO 745
780   DATA(1)=DATA(1)+DATA(2)
      DATA(2)=0.
      GO TO 900
C
C     Complete a real transform for the 2nd, 3rd, etc. dimension by
C     conjugate symmetries.
C
800   IF(I1RNG-NP1)805,900,900
805   DO 860 I3=1,NTOT,NP2
      I2MAX=I3+NP2-NP1
      DO 860 I2=I3,I2MAX,NP1
      IMAX=I2+NP1-2
      IMIN=I2+I1RNG
      JMAX=2*I3+NP1-IMIN
      IF(I2-I3)820,820,810
810   JMAX=JMAX+NP2
820   IF(IDIM-2)850,850,830
830   J=JMAX+NP0
      DO 840 I=IMIN,IMAX,2
      DATA(I)=DATA(J)
      DATA(I+1)=-DATA(J+1)
840   J=J-2
850   J=JMAX
      DO 860 I=IMIN,IMAX,NP0
      DATA(I)=DATA(J)
      DATA(I+1)=-DATA(J+1)
860   J=J-NP0
C
C     End of loop on each dimension
C
900   NP0=NP1
      NP1=NP2
910   NPREV=N
920   RETURN
      END

C @(#)maktab.for	19.1 (ES0-DMD) 02/25/03 14:29:42
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
        program MAKTAB
C------------------------------------------------------------------------------
C  Makes input table in proper format for DBLEND when working with combined
C   input mode
C
C  Possible inputs:
C    fit option W, input table BTAB with center positions in column :X, input
C      table ttemp with other info in normal form.
C    fit option S, FWHM value to use in BTAB, input table ttemp with other info
C      in normal form.
C    fit option A, centers in input table ttemp, FWHM's in keyword FWHM(6)
C
C  Output:
C    table ttemp with all info in proper form for DBLEND
C------------------------------------------------------------------------------
C
C  variable declarations
C
        implicit none

        integer MADRID

        INTEGER     ACOL,AROW
        INTEGER     ACTVAL
        REAL        BDATA(6,4)
        REAL        CENT(6)
        INTEGER     COL(4)
        INTEGER     CPIX(6)
        character*16  CUNIT
        REAL        DATA(50000)
        INTEGER     DTID,BTID,TID
        character*1   FOPT
        REAL        FWHM(6)
        character*72  IDENT
        character*60  IMAGE
        character*12  INTAB
        INTEGER     KUN,KNUL
        REAL        MAXVAL(6)
        INTEGER     NAXIS
        INTEGER     NCOLD,NROWD,NCOLB,NROWB,NROWT
        INTEGER     NDATA
        INTEGER     NN
        INTEGER     NO
        INTEGER     NPIX(2)
        INTEGER     NSC
        logical       NULL(4)
        REAL        PAR(4)
        INTEGER*8   PNTR
        REAL        SIDE(2)
        DOUBLE PRECISION        START(2),STEP(2)
        INTEGER     STAT
        character*72  STRING
        REAL        TABLE(22,4)
        REAL        TDATA(16,4)
        INTEGER     XCOL
        REAL        YVAL

        INTEGER       II,JJ,KK,MM

        common /VMR/MADRID(1)

        data COL/1,2,3,4/

C  connect to MIDAS environment

        call stspro('MAKTAB')

C  get inputs from keywords

        call stkrdc('BTAB',1,1,12,ACTVAL,INTAB,KUN,KNUL,STAT)
        call stkrdc('FITOPT',1,1,1,ACTVAL,FOPT,KUN,KNUL,STAT)
        call stkrdc('IN_A',1,1,60,ACTVAL,IMAGE,KUN,KNUL,STAT)

        call upcas(FOPT,FOPT)

C  rename ttemp to dummy name

        call stfrnm('ttemp.tbl','ttemp2.tbl',STAT)

C  read in values to be saved

        call tbtopn('ttemp2.tbl',2,DTID,STAT)
        call tbiget(DTID,NCOLD,NROWD,NSC,ACOL,AROW,STAT)

        do  II = 1,NROWD
          call tbrrdr(DTID,II,4,COL,PAR,NULL,STAT)
          do  JJ = 1,4
            TDATA(II,JJ) = PAR(JJ)
          end do
        end do

C  close old table

        call tbtclo(DTID,STAT)

C  open image file

        call stiget(IMAGE,10,0,1,2,NAXIS,NPIX,START,STEP,
     &                IDENT,CUNIT,PNTR,NO,STAT)

C  for option W, open table with center positions and read them in

        if (FOPT.EQ.'W') then

          call tbtopn(INTAB,0,BTID,STAT)
          call tbiget(BTID,NCOLB,NROWB,NSC,ACOL,AROW,STAT)
          call tblser(BTID,'X',XCOL,STAT)  !could be ':X' instead

          do  II = 1,NROWB
            call tberdr(BTID,II,XCOL,CENT(II),NULL,STAT)
          end do

C  read in the image

          if (NAXIS.eq.1) then
            NDATA = NPIX(1)
            call read1d(MADRID(PNTR),NPIX(1),DATA)
          else if (NAXIS.eq.2.and.(NPIX(1).eq.1.or.NPIX(2).eq.1)) then
            if (NPIX(1).eq.1) then
              NDATA = NPIX(2)
              START(1) = START(2)
              STEP(1) = STEP(2)
            else
              NDATA = NPIX(1)
            end if
            call read2d(MADRID(PNTR),NPIX,DATA,NDATA)
          else
            STRING = ' Input image is not a suitable type'
            call sttput(STRING,STAT)
            go to 9999
          end if

C  determine pixel positions of centers

          do  II = 1,NROWB
            CPIX(II)=nint((CENT(II)-real(START(1)))/real(STEP(1)))+1
          end do

C  get data values at centers

          do  II = 1,NROWB
            MAXVAL(II) = DATA(CPIX(II))
          end do

C  construct new table rows

          do  II = 1,NROWB
            BDATA(II,1) = CENT(II)
            BDATA(II,2) = MAXVAL(II)
            BDATA(II,3) = float(CPIX(II))
            BDATA(II,4) = 1.0
          end do

C  construct table

          NROWT = NROWD + NROWB

          do  JJ = 1,4

            do  II = 1,4
              TABLE(II,JJ) = TDATA(II,JJ)
            end do

            KK = 4

            do  II = 5,NROWT
              if (mod(II,3).eq.0) then
                TABLE(II,JJ) = BDATA((II/3)-1,JJ)
              else
                KK = KK+1
                TABLE(II,JJ) = TDATA(KK,JJ)
              end if
            end do
          end do

C  for option S, interpret number in INTAB

        else if (FOPT.eq.'S') then

          read (INTAB,*) FWHM(1)                !test this

C  construct new table rows

          NROWB = 0

          do  II = 5,NROWD
            SIDE(1) = TDATA(II,1) - (FWHM(1)/2)
            SIDE(2) = SIDE(1) + FWHM(1)
            YVAL = TDATA(II,2) / 2
            do  JJ = 1,2
              NROWB = NROWB + 1
              BDATA(NROWB,1) = SIDE(JJ)
              BDATA(NROWB,2) = YVAL
              BDATA(NROWB,3) = anint((SIDE(JJ)-real(START(1)))
     &                         /real(STEP(1)))+1.
              BDATA(NROWB,4) = 1.0
            end do
          end do

C  construct new table

          NROWT = NROWD + NROWB

          do  JJ = 1,4

            do  II = 1,4
              TABLE(II,JJ) = TDATA(II,JJ)
            end do

            KK = 4
            MM = 0

            do  II = 5,NROWT
              if (mod(II,3).eq.0) then
                KK = KK+1
                TABLE(II,JJ) = TDATA(KK,JJ)
              else
                MM = MM+1
                TABLE(II,JJ) = BDATA(MM,JJ)
              end if
            end do
          end do

C  for option A, get FWHM from keyword

        else if (FOPT.eq.'A') then

          call stkrdr('FWHM',1,6,ACTVAL,FWHM,KUN,KNUL,STAT)

C  construct new table rows

          NROWB = 0

          do  II = 5,NROWD
            SIDE(1) = TDATA(II,1) - (FWHM(II-4)/2)
            SIDE(2) = SIDE(1) + FWHM(II-4)
            YVAL = TDATA(II,2) / 2
            do  JJ = 1,2
              NROWB = NROWB + 1
              BDATA(NROWB,1) = SIDE(JJ)
              BDATA(NROWB,2) = YVAL
              BDATA(NROWB,3) = anint((SIDE(JJ)-real(START(1)))
     &                         /real(STEP(1)))+1.
              BDATA(NROWB,4) = 1.0
            end do
          end do

C  construct new table

          NROWT = NROWD + NROWB

          do  JJ = 1,4

            do  II = 1,4
              TABLE(II,JJ) = TDATA(II,JJ)
            end do

            KK = 4
            MM = 0

            do  II = 5,NROWT
              if (mod(II,3).eq.0) then
                KK = KK+1
                TABLE(II,JJ) = TDATA(KK,JJ)
              else
                MM = MM+1
                TABLE(II,JJ) = BDATA(MM,JJ)
              end if
            end do
          end do

C  invalid fit option used:

        else


C  write out error message

          STRING = 'fit option '// FOPT //
     +             ' incompatible with B input option'
          call sttput(STRING,STAT)

C  deposit status parameter in keyword

          PAR(1) = 1
          call stkwri('STATUS',PAR(1),1,1,KUN,STAT)   !takes KNUL par also?

C  put ttemp back where it was and exit

          call stfrnm('ttemp2.tbl','ttemp.tbl',STAT)

          call stsepi

        end if

C  write the table out

        call tbtini('ttemp',1,1,4,NROWT,TID,STAT)
        call tbcini(TID,10,1,'G13.6',CUNIT,'X_AXIS',NN,STAT)
        call tbcini(TID,10,1,'G13.6','COUNTS','Y_AXIS',NN,STAT)
        call tbcini(TID,10,1,'I5','PIXEL','LINE_NO',NN,STAT)
        call tbcini(TID,10,1,'I5','PIXEL','PIXEL_NO',NN,STAT)

        do  II = 1,NROWT
          do  JJ = 1,4
            PAR(JJ) = TABLE(II,JJ)
          end do
          call tbrwrr(TID,II,4,COL,PAR,STAT)
        end do

        call tbtclo(TID,STAT)

C  delete old table

        call STFDEL('ttemp2.tbl',STAT)

C  finished

 9999        call stsepi
             end

C===========================================================================
C Copyright (C) 1995-2005 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C 
C 050803	last modif
C 
C===========================================================================
C
      SUBROUTINE PIANT5 (RNY,MX,MY,NP,NC,IA,FIFA,FONDO,ZE)
C
      IMPLICIT NONE
      INTEGER   MX
      INTEGER   MY
      REAL      RNY(MY,MX)
      INTEGER   NP
      INTEGER   NC
      INTEGER   IA
      REAL      FIFA
      REAL      FONDO
      REAL      ZE
C
      INTEGER   KMAX, NRPX
      INTEGER   MAXPIX
      REAL      AMI, AFACT
      INTEGER   I, J, K, KKK, I1
      INTEGER   ILIN
      REAL      A, AA
      REAL      FFT
      REAL      PNY, VAL 
      INTEGER   START(2), SIZE(2)
      INTEGER   ERRCOD
      REAL      RIV(40000)
      INTEGER   LDATA(40001)
      REAL      CUTS(2)
      REAL      FAUX(3)
      INTEGER   INAUX(5)
      INTEGER   OUTAUX(2)
C
      INCLUDE  'MID_INCLUDE:ST_DEF.INC'
C 
      INCLUDE  'MID_INCLUDE:IDIDEV.INC'
      INCLUDE  'MID_INCLUDE:IDIMEM.INC'
C
      INCLUDE  'MID_INCLUDE:ST_DAT.INC'
C 
      KMAX     = QLUTSZ - 1
      START(1) = IA+1
      START(2) = 2
      CUTS(1)  = 0
      CUTS(2)  = KMAX
      SIZE(1)  = NP*3
      SIZE(2)  = NC*3
      NRPX     = SIZE(1)*SIZE(2)
      MAXPIX   = CUTS(2)
      AMI      = 10.**35
      A        = -AMI
C
C *** auxilary info array
      INAUX(1) = D_R4_FORMAT                     !we have real data
      INAUX(2) = 1
      INAUX(3) = SIZE(1)
      INAUX(4) = 1
      INAUX(5) = 1
C
C *** scale frame
      FAUX(1) = 1.0
      FAUX(2) = CUTS(1)
      FAUX(3) = CUTS(2)
C
C *** 
      OUTAUX(1) = KMAX
      OUTAUX(2) = 0
C
C ** start the code
      IF (IDINUM.LT.11) THEN
         CALL IIMSTW(QDSPNO,QIMCH,0,SIZE(1),SIZE(2),QMDEP,
     *               START(1),START(2),ERRCOD)
      ENDIF          
C
      DO 10 I = 1,NC
         DO 20 J = 1,NP
            A   = AMAX1(A,RNY(I,J))
            AMI = AMIN1(AMI,AMAX1(0.,RNY(I,J)))
  20     CONTINUE
  10  CONTINUE
C
      A   = 15000.
      FFT = FONDO
      IF (FFT.LE.0.) FFT=0.1
      IF (AMI.LT.(FONDO+ZE*SQRT(FFT))) THEN
         AMI=FONDO+ZE*SQRT(FFT)
      ENDIF
C
      A  = AMAX1(AMI, (A / FIFA))
      AA = A - AMI
      IF (AA .LT. 1) AA = 1.
      AFACT = FLOAT(MAXPIX) / AA
      ILIN  = START(2)-1
      DO 30 I = 1,NC
         K = 1
         DO 40 J = 1,NP
            PNY=RNY(I,J)
            IF (PNY.LE.-1000.) PNY=AMI
            VAL= AMIN1(FLOAT(MAXPIX),(PNY-AMI)*AFACT)
            DO 50 KKK = 0 , 2
               I1      = K+KKK
               RIV(I1) = VAL
  50        CONTINUE
            K = K + 3
  40     CONTINUE
C
C *** pack into bytes
         CALL K1PACK(RIV,RIV,INAUX,FAUX,LDATA(2),OUTAUX)
         DO 60 KKK = 1,3
            ILIN = ILIN+1
            CALL IIMWMY(QDSPNO,QIMCH,LDATA(2),SIZE(1),QMDEP,4,
     *                  START(1),ILIN,ERRCOD)
  60     CONTINUE
  30  CONTINUE
C
      RETURN
      END

C @(#)bip.for	19.1 (ES0-DMD) 02/25/03 13:29:42
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      REAL FUNCTION BIP(X1,Y1,C,IGP)
C+++
C---
      IMPLICIT  NONE
      DOUBLE PRECISION X1
      DOUBLE PRECISION Y1
      DOUBLE PRECISION C(1)
C     
      DOUBLE PRECISION AA,BB
      INTEGER IGP, IL, L, K
      REAL    VZ
C
      IL = 0
      VZ = 0
      DO 10 L = 0,IGP
         DO 11 K = 0,IGP-L
            IL = IL+1
            IF (K.EQ.0 .AND. X1.EQ.0.) THEN
               AA = 1.
            ELSE
               AA = X1**K
            END IF
            IF (L.EQ.0 .AND. Y1.EQ.0.) THEN
               BB = 1.
            ELSE
              BB = Y1**L
            END IF
            VZ = VZ+AA*BB*C(IL)
  11     CONTINUE
  10  CONTINUE
C
      BIP = VZ
      RETURN
      END

C @(#)feet.for	19.1 (ES0-DMD) 02/25/03 13:30:45
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FEET(MASK,ATEMP,IDEG,FLMSK,REJ,NMX,NMY,RXSTR,RYSTR,            
     +                RXSTP,RYSTP,NSX,NSY,SXSTR,SYSTR,SXSTP,SYSTP,ICONT,        
     +                RMEAN,SIGM1,SKEW1,RKURT,C,JER)                            
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
C.PURPOSE:   Calculate the coefficients of a 2D polinomial fitting the          
C            sky background,then give the first moments of the distribution     
C            of O-C residuals                                                   
C.ALGORITHM: Lleast squares 2-dim. polinomial fit                               
C.INPUT:     MASK  : frame masking bright objects in the field                  
C            ATEMP : temporary buffer containing the rebinned input image       
C            FLMSK : flag = .TRUE. if MASK exists                               
C            REJ   : value assigned to rejected pixels in frame ATEMP           
C            NMX,... usual descriptors of the frame MASK                        
C            NSX,... descriptors of the frame-buffer ATEMP                      
C            IDEG  : polinomial degree                                          
C.OUTPUT:    ICONT : number of processed 'good' points                          
C            RMEAN : mean value of residuals image-pol.fit for 'good' points    
C            SIGM1 : standard deviation of residuals                            
C            SKEW1 : 3rd moment of the distribution of residuals (skewness)     
C            RKURT : 4th moment of the distribution of residuals (kurtosis)     
C            C     : up to 21 coefficients of the polinomial surface            
C            JER   : error return ; 0=OK   1=interpolation failure              
C --------------------------------------------------------------------          
      IMPLICIT NONE
C
      INTEGER  NMX
      INTEGER  NMY
      REAL     MASK(NMX,NMY)
      REAL     ATEMP(128,128)
      INTEGER  IDEG
      LOGICAL  FLMSK                                                            
      REAL     REJ
      DOUBLE PRECISION RXSTR
      DOUBLE PRECISION RYSTR
      DOUBLE PRECISION RXSTP
      DOUBLE PRECISION RYSTP
      INTEGER  NSX
      INTEGER  NSY
      DOUBLE PRECISION SXSTR
      DOUBLE PRECISION SYSTR
      DOUBLE PRECISION SXSTP
      DOUBLE PRECISION SYSTP
      INTEGER  ICONT
      REAL     RMEAN
      REAL     SIGM1
      REAL     SKEW1
      REAL     RKURT
      DOUBLE PRECISION C(21)
      INTEGER  JER
C
      INTEGER  I, I1, I2
      INTEGER  I1MSK, I2MSK
      INTEGER  ICX, ICY
      INTEGER  IF1, IF2
      INTEGER  IPERC
      INTEGER  IW1, IW2, IW3, IW4
      INTEGER  IX, IY
      INTEGER  J, J1, J2
      INTEGER  J1MSK, J2MSK
      INTEGER  NC, NC1
      INTEGER  NCV(5)                                                           
      REAL     ANP
      REAL     BUP(128)
      REAL     BLW(128)                                                
      REAL     CONT
      REAL     DCX, DCY
      REAL     D1, D2, D3, D4
      REAL     POLIN
      REAL     RES, RES2
      REAL     X1, X2
      REAL     Y1, Y2
      REAL     V
      REAL     VUP1, VUP2
      REAL     VLW1, VLW2
      DOUBLE PRECISION Z(64,10),A(21,22),B(21,22),CC(6)                   
      DOUBLE PRECISION W1,W2,W3,W4,DMEAN
      DOUBLE PRECISION XD,YD,SIGMA,SKEW,DKURT
C
      EXTERNAL POLIN
      EXTERNAL SHORT,LONG
C
      DATA NCV/3,6,10,15,21/                                                    
C                                                                               
C *** initialize the powers and arrays                                          
C                                                                               
      DO 20 I = 1,64                                                            
         Z(I,1) = I - 0.5                                                       
         DO 10 J = 2,10                                                         
            Z(I,J) = Z(I,J-1)*Z(I,1)                                            
   10    CONTINUE                                                               
   20 CONTINUE                                                                  
C                                                                               
      DO 40 I = 1,21                                                            
         DO 30 J = 1,22                                                         
            A(I,J) = 0.                                                         
   30    CONTINUE                                                               
   40 CONTINUE                                                                  
C                                                                               
      DO 50 I = 1,21                                                            
         C(I)   = 0.D0                                                          
   50 CONTINUE                                                                  
C                                                                               
C ***  initialize variables                                                     
C                                                                               
      ICX    = NSX/2                                                            
      ICY    = NSY/2                                                            
C                                                                               
C *** loop: load image values (testing mask and rejected pixels)                
C                                                                               
      IF1    = 1                                                                
      IF2    = 128* (NSY-1) + 1                                                 
C                                                                               
      DO 90 J1 = 1,ICY                                                          
         J2     = NSY - J1 + 1                                                  
         IY     = ICY - J1 + 1                                                  
         Y1     = SYSTR + SYSTP* (J1-1.)                                        
         Y2     = SYSTR + SYSTP* (J2-1.)                                        
         IF (FLMSK) THEN                        !   nearest pixel in mask frame
            J1MSK  = (Y1-RYSTR)/RYSTP + 1.5                                     
            J2MSK  = (Y2-RYSTR)/RYSTP + 1.5                                     
C                                                                               
C *** mask is extrapolated outside                                              
C                                                                               
            IF (J1MSK.LT.1) THEN                                                
               J1MSK  = 1                                                       
            ELSE IF (J1MSK.GT.NMY) THEN                                         
               J1MSK  = NMY                                                     
            END IF                                                              
                                                                                
            IF (J2MSK.LT.1) THEN                                                
               J2MSK  = 1                                                       
            ELSE IF (J2MSK.GT.NMY) THEN                                         
               J2MSK  = NMY                                                     
            END IF                                                              
         END IF                                                                 
C                                                                               
C *** read needed rows from temporary array                                     
C                                                                               
         CALL ROW(ATEMP,BUP,IF1,NSX)                                            
         CALL ROW(ATEMP,BLW,IF2,NSX)                                            
         IF1    = IF1 + 128                                                     
         IF2    = IF2 - 128                                                     
C                                                                               
         DO 70 IX = 1,ICX                                                       
            I1     = ICX - IX + 1                                               
            I2     = ICX + IX                                                   
            VUP1   = 1.                                                         
            VUP2   = 1.                                                         
            VLW1   = 1.                                                         
            VLW2   = 1.                                                         
C                                                                               
            IF (FLMSK) THEN                                                     
               X1     = SXSTR + SXSTP* (I1-1.)                                  
               X2     = SXSTR + SXSTP* (I2-1.)                                  
               I1MSK  = (X1-RXSTR)/RXSTP + 1.5                                  
               I2MSK  = (X2-RXSTR)/RXSTP + 1.5                                  
               IF (I1MSK.LT.1) THEN                                             
                  I1MSK  = 1                                                    
               ELSE IF (I1MSK.GT.NMX) THEN                                      
                  I1MSK  = NMX                                                  
               END IF                                                           
                                                                                
               IF (I2MSK.LT.1) THEN                                             
                  I2MSK  = 1                                                    
               ELSE IF (I2MSK.GT.NMX) THEN                                      
                  I2MSK  = NMX                                                  
               END IF                                                           
C                                                                               
C *** find out mask values  -  assumed floating p.                              
C                                                                               
               VUP1   = MASK(I1MSK,J1MSK)                                       
               VUP2   = MASK(I2MSK,J1MSK)                                       
               VLW1   = MASK(I1MSK,J2MSK)                                       
               VLW2   = MASK(I2MSK,J2MSK)                                       
            END IF                                                              
C                                                                               
C *** a pixel is 'bad' if rejected via mask frame OR temp. buffer               
C                                                                               
            IF (BUP(I1).EQ.REJ) VUP1   = -1.                                    
            IF (BUP(I2).EQ.REJ) VUP2   = -1.                                    
            IF (BLW(I1).EQ.REJ) VLW1   = -1.                                    
            IF (BLW(I2).EQ.REJ) VLW2   = -1.                                    
C                                                                               
            IF ((VUP1.GT.0.) .AND. (VUP2.GT.0.) .AND.                           
     +         (VLW1.GT.0.) .AND. (VLW2.GT.0)) THEN                             
               D1 = BUP(I1)
               D2 = BUP(I2)
               D3 = BLW(I1)
               D4 = BLW(I2)
               CALL SHORT(D1,D2,D3,D4,IX,IY,Z,A)            
                                                                                
            ELSE                                                                
               IW2    = 1                                                       
               IF (VUP2.LE.0.) THEN                                             
                  BUP(I2) = 0.                                                  
                  IW2    = 0                                                    
               END IF                                                           
                                                                                
               IW1    = 1                                                       
               IF (VUP1.LE.0.) THEN                                             
                  BUP(I1) = 0.                                                  
                  IW1    = 0                                                    
               END IF                                                           
                                                                                
               IW4    = 1                                                       
               IF (VLW2.LE.0.) THEN                                             
                  BLW(I2) = 0.                                                  
                  IW4    = 0                                                    
               END IF                                                           
                                                                                
               IW3    = 1                                                       
               IF (VLW1.LE.0.) THEN                                             
                  BLW(I1) = 0.                                                  
                  IW3    = 0                                                    
               END IF                                                           
                                                                                
               W1     = IW1 + IW2 + IW3 + IW4                                   
               IF (W1.EQ.0.0D0) GO TO 60                                        
               W2     = IW2 + IW4 - IW1 - IW3                                   
               W3     = IW1 + IW2 - IW3 - IW4                                   
               W4     = IW2 + IW3 - IW1 - IW4                                   
               D1 = BUP(I1)
               D2 = BUP(I2)
               D3 = BLW(I1)
               D4 = BLW(I2)
               CALL LONG(W1,W2,W3,W4,D1,D2,D3,D4,IX,IY,Z,A)                                             
            END IF                                                              
   60       CONTINUE                                                            
   70    CONTINUE                                                               
   90 CONTINUE                                                                  
C                                                                               
C *** fill matrix "a" using symmetries                                          
C                                                                               
      CALL FLMTX(A)                                         !   processed points
      ANP    = 4.0D0*A(1,1)                                                     
      DO 110 I = 1,20                                                           
         I1     = I + 1                                                         
         DO 100 J = I1,21                                                       
            A(J,I) = A(I,J)                                                     
  100    CONTINUE                                                               
  110 CONTINUE                                                                  
C                                                                               
C *** calculate coefficients   --->array c                                      
C                                                                               
      NC     = NCV(IDEG)                                                        
      NC1    = NC + 1                                                           
      DO 130 I = 1,NC                                                           
         DO 120 J = 1,NC                                                        
            B(I,J) = A(I,J)                                                     
  120    CONTINUE                                                               
         B(I,NC1) = A(I,22)                                                     
  130 CONTINUE                                                                  
C                                                                               
      CALL SYST(NC,B,C,JER)                               !interpolation failure
      IF (JER.NE.0) RETURN                                                      
C                                                                               
C *** calculate parameters of distribution of residuals                         
C     initialize variables                                                      
C                                                                               
      DCX    = (NSX-1.)/2.                                                      
      DCY    = (NSY-1.)/2.                                                      
      DMEAN  = 0.D0                                                             
      SIGMA  = 0.D0                                                             
      SKEW   = 0.D0                                                             
      DKURT  = 0.D0                                                             
      ICONT  = 0                                                                
C                                                                               
C *** loop : calculate parameters                                               
C                                                                               
      DO 170 J = 1,NSY                                                          
         IY     = J - 1                                                         
         YD     = DCY - IY                                                      
         CALL COEFY(YD,C,CC,IDEG)                                               
         Y1     = SYSTR + SYSTP*FLOAT(IY)                                       
         IF (FLMSK) THEN                                                        
            J1MSK  = (Y1-RYSTR)/RYSTP + 1.5                                     
            IF (J1MSK.LT.1) THEN                                                
               J1MSK  = 1                                                       
            ELSE IF (J1MSK.GT.NMY) THEN                                         
               J1MSK  = NMY                                                     
            END IF                                                              
         END IF                                                                 
C                                                                               
         DO 150 I = 1,NSX                                                       
            IX     = I - 1                                                      
            XD     = IX - DCX                                                   
            V      = 1.                                                         
            IF (FLMSK) THEN                                                     
               X1     = SXSTR + SXSTP*FLOAT(IX)                                 
               I1MSK  = (X1-RXSTR)/RXSTP + 1.5                                  
               IF (I1MSK.LT.1) THEN                                             
                  I1MSK  = 1                                                    
               ELSE IF (I1MSK.GT.NMX) THEN                                      
                  I1MSK  = NMX                                                  
               END IF                                                           
               V      = MASK(I1MSK,J1MSK)                                       
            END IF                                                              
                                                                                
            IF (ATEMP(I,J).EQ.REJ) V      = -1                                  
            IF (V.LE.0) GO TO 140                                               
            ICONT  = ICONT + 1                                                  
            RES    = ATEMP(I,J) - POLIN(XD,CC,IDEG)                             
            RES2   = RES*RES                                                    
            DMEAN  = DMEAN + RES                                                
            SIGMA  = SIGMA + RES2                                               
            SKEW   = SKEW + RES2*RES                                            
            DKURT  = DKURT + RES2*RES2                                          
  140       CONTINUE                                                            
  150    CONTINUE                                                               
  170 CONTINUE                                                                  
C                                                                               
      CONT   = FLOAT(ICONT)                                                     
      DMEAN  = DMEAN/DBLE(CONT)                                                 
      SIGMA  = DSQRT(SIGMA/DBLE(CONT))                                          
      SKEW   = SKEW/ (DBLE(CONT)* (SIGMA**3))                                   
      DKURT  = DKURT/ (DBLE(CONT)* (SIGMA**4))                                  
      RMEAN  = SNGL(DMEAN)                                                      
      SIGM1  = SNGL(SIGMA)                                                      
      SKEW1  = SNGL(SKEW)                                                       
      RKURT  = SNGL(DKURT)                                                      
      IPERC  = (CONT/ (NSX*NSY))*100.                                           
C                                                                               
      RETURN                                                                    
      END                                                                       

C @(#)statpl.for	19.1 (ES0-DMD) 02/25/03 13:24:28
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
       PROGRAM STATPLOT
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENT  program STATPLOT			Edwin Valentijn 881011
C						Andris Lauberts 890721
C
C.KEYWORDS  table file, statistics
C
C.PURPOSE      computes mean and sd of table file column given in p2
C              AND DUMPS THAT IN TABLE WITH NAME T'P2'
C              text output in for007.dat -> T'p2'.dat
C
C.USAGE        MIDAS application programme
C	       execute as @@ STATPL P1 P2 P3 P4
C
C.PARAMETERS
C
C P1   TABLE  C*8    Input table
C P2   I2COL  I      Column number .NE.NULL      
C      TABLEO C*8    and name of output table
C P3   SELECT C*50   Expression of logical select
C P4                 1: display statistics
C
C.COMMENTS     Intended for statistics on ESOLV (PCAT) catalogue
C	       using Type = column #7 as reference
C
C----------------------------------------------------------------------
       IMPLICIT      INTEGER*4  (A-Z)
       REAL          OUT1,MORPH,SD,SDMIN,SDPLUS,MEAN,NN,ITY
       REAL          PCOUNT(16)
       REAL          PTCOUNT2,PTCOUNT5,PTCOUNT11
       REAL          XITS(16),XITS2(16)
       INTEGER       TID,TIDO
       INTEGER       KNUL,KUN
       INTEGER*4     CITS(16)
       CHARACTER     TABLE*8,TYPE1*6,TYPE2*6,FORM*6
       CHARACTER     TABLEO*60
       CHARACTER*50  SELECT
       CHARACTER*16  LABEL(6),UNIT(6)
       LOGICAL       NULL
       LOGICAL       FLAG
       CHARACTER*6   TYPER,FMTR
       CHARACTER*6   FMTI
C
       COMMON        /VMR/MADRID(1)
C
       DATA          TYPER/'R*4'/
       DATA          FMTR/'F8.2'/
       DATA          FMTI/'I6'/
C
C keywords
       CALL STSPRO ('STATPLOT')
       CALL STKRDC('P1',1,1,8,IAV,TABLE,KNUL,KUN,ISTAT)
       CALL STKRDC('IN_A',1,1,60,IAV,TABLEO,KNUL,KUN,ISTAT)
       CALL STKRDI('INPUTI',1,1,IAV,I2COL,KNUL,KUN,ISTAT)
       CALL STKRDC('P3',1,1,50,IAV,SELECT,KNUL,KUN,ISTAT)
C
C input table
C
       CALL TBTOPN(TABLE,F_O_MODE,TID,ISTAT)
       CALL TBIGET(TID,NCOL,NROW,NSCI,ACOL,AROW,ISTAT)
       CALL TBFGET(TID,7,FORM,LEN,TYPE1,ISTAT)
       CALL TBFGET(TID,I2COL,FORM,LEN,TYPE2,ISTAT)
       CALL TBUGET(TID,I2COL,UNIT(3),ISTAT)
       CALL TBLGET(TID,I2COL,LABEL(3),ISTAT)
C
      DO I = 1,16,1
        CITS(I) = 0
        XITS(I) = 0.
        XITS2(I)= 0.
      ENDDO      
C
C output table
C
       LABEL(1) = 'TYPE'
       LABEL(2) = 'COUNT'
C      LABEL(3) = 'MEAN'
       LABEL(4) = 'SD'
       LABEL(5) = 'MINSD'
       LABEL(6) = 'PLUSSD'
       UNIT(1)  = '      '
C
      CALL TBTINI(TABLEO,0,F_O_MODE,6,16,TIDO,STATUS)
      CALL TBCINI(TIDO,TYPER,1,FMTI,UNIT(1),LABEL(1),IC,STATUS)
      CALL TBCINI(TIDO,TYPER,1,FMTI,UNIT(1),LABEL(2),IC,STATUS)
      CALL TBCINI(TIDO,TYPER,1,FMTR,UNIT(3),LABEL(3),IC,STATUS)
      DO I=4,6,1
      CALL TBCINI(TIDO,TYPER,1,FMTR,UNIT(1),LABEL(I),IC,STATUS)
         ENDDO 
c enter the big loop
      DO IROW = 1,NROW,1
       CALL TBSGET(TID,IROW,FLAG,ISTAT)
       IF (FLAG) THEN
          CALL TBEGET(TID,TYPE1,IROW,7,MORPH,NULL,ISTAT)
          CALL TBEGET(TID,TYPE2,IROW,I2COL,OUT1,NULL,ISTAT)
          IF (.NOT.NULL.AND.MORPH.LT.-4.5) THEN
               N = 1
               CITS(N)      = CITS(N)  + 1
               XITS(N)      = XITS(N)  + OUT1
               XITS2(N)     = XITS2(N) + OUT1**2.               
               GOTO 333
               END IF
         IF (.NOT.NULL.AND.MORPH.LT.-3.5.AND.MORPH.GE.-4.5) THEN
               N = 2
               CITS(N)      = CITS(N)  + 1
               XITS(N)      = XITS(N)  + OUT1
               XITS2(N)     = XITS2(N) + OUT1**2.               
               GOTO 333
               END IF
         IF (.NOT.NULL.AND.MORPH.LT.-2.5.AND.MORPH.GE.-3.5) THEN
               N = 3
               CITS(N)      = CITS(N)  + 1
               XITS(N)      = XITS(N)  + OUT1
               XITS2(N)     = XITS2(N) + OUT1**2.               
               GOTO 333
               END IF
         IF (.NOT.NULL.AND.MORPH.LT.-1.5.AND.MORPH.GE.-2.5) THEN
               N = 4
               CITS(N)      = CITS(N)  + 1
               XITS(N)      = XITS(N)  + OUT1
               XITS2(N)     = XITS2(N) + OUT1**2.               
               GOTO 333
               END IF
         IF (.NOT.NULL.AND.MORPH.LT.-0.5.AND.MORPH.GE.-1.5) THEN
               N = 5
               CITS(N)      = CITS(N)  + 1
               XITS(N)      = XITS(N)  + OUT1
               XITS2(N)     = XITS2(N) + OUT1**2.               
               GOTO 333
               END IF
         IF (.NOT.NULL.AND.MORPH.LT.0.5.AND.MORPH.GE.-0.5)  THEN
               N = 6
               CITS(N)      = CITS(N)  + 1
               XITS(N)      = XITS(N)  + OUT1
               XITS2(N)     = XITS2(N) + OUT1**2.               
               GOTO 333
               END IF
         IF (.NOT.NULL.AND.MORPH.LT.1.5.AND.MORPH.GE.0.5)  THEN
               N = 7
               CITS(N)      = CITS(N)  + 1
               XITS(N)      = XITS(N)  + OUT1
               XITS2(N)     = XITS2(N) + OUT1**2.               
               GOTO 333
               END IF
         IF (.NOT.NULL.AND.MORPH.LT.2.5.AND.MORPH.GE.1.5)  THEN
               N = 8
               CITS(N)      = CITS(N)  + 1
               XITS(N)      = XITS(N)  + OUT1
               XITS2(N)     = XITS2(N) + OUT1**2.               
               GOTO 333
               END IF
         IF (.NOT.NULL.AND.MORPH.LT.3.5.AND.MORPH.GE.2.5)  THEN
               N = 9
               CITS(N)      = CITS(N)  + 1
               XITS(N)      = XITS(N)  + OUT1
               XITS2(N)     = XITS2(N) + OUT1**2.               
               GOTO 333
               END IF
         IF (.NOT.NULL.AND.MORPH.LT.4.5.AND.MORPH.GE.3.5)  THEN
               N = 10
               CITS(N)      = CITS(N)  + 1
               XITS(N)      = XITS(N)  + OUT1
               XITS2(N)     = XITS2(N) + OUT1**2.               
               GOTO 333
               END IF
         IF (.NOT.NULL.AND.MORPH.LT.5.5.AND.MORPH.GE.4.5)  THEN
               N = 11
               CITS(N)      = CITS(N)  + 1
               XITS(N)      = XITS(N)  + OUT1
               XITS2(N)     = XITS2(N) + OUT1**2.               
               GOTO 333
               END IF
         IF (.NOT.NULL.AND.MORPH.LT.6.5.AND.MORPH.GE.5.5)  THEN
               N = 12
               CITS(N)      = CITS(N)  + 1
               XITS(N)      = XITS(N)  + OUT1
               XITS2(N)     = XITS2(N) + OUT1**2.               
               GOTO 333
               END IF
         IF (.NOT.NULL.AND.MORPH.LT.7.5.AND.MORPH.GE.6.5)  THEN
               N = 13
               CITS(N)      = CITS(N)  + 1
               XITS(N)      = XITS(N)  + OUT1
               XITS2(N)     = XITS2(N) + OUT1**2.               
               GOTO 333
               END IF
         IF (.NOT.NULL.AND.MORPH.LT.8.5.AND.MORPH.GE.7.5)  THEN
               N = 14
               CITS(N)      = CITS(N)  + 1
               XITS(N)      = XITS(N)  + OUT1
               XITS2(N)     = XITS2(N) + OUT1**2.               
               GOTO 333
               END IF
         IF (.NOT.NULL.AND.MORPH.LT.9.5.AND.MORPH.GE.8.5)  THEN
               N = 15
               CITS(N)      = CITS(N)  + 1
               XITS(N)      = XITS(N)  + OUT1
               XITS2(N)     = XITS2(N) + OUT1**2.               
               GOTO 333
               END IF
         IF (.NOT.NULL.AND.MORPH.LT.11..AND.MORPH.GE.9.5)  THEN
               N = 16
               CITS(N)      = CITS(N)  + 1
               XITS(N)      = XITS(N)  + OUT1
               XITS2(N)     = XITS2(N) + OUT1**2.               
               GOTO 333
               END IF
      ENDIF
  333 ENDDO
C
      COUNTTOT=0
      DO I=1,16,1
         COUNTTOT = CITS(I) +COUNTTOT
      ENDDO
C
         TCOUNT5   = CITS(4)+CITS(5)+CITS(6)
         TCOUNT2   = CITS(1)+CITS(2)+CITS(3)
         TCOUNT11  = COUNTTOT - (TCOUNT5 + TCOUNT2)
         PTCOUNT11 = 100. * TCOUNT11/COUNTTOT
         PTCOUNT5  = 100. * TCOUNT5/COUNTTOT
         PTCOUNT2  = 100. * TCOUNT2/COUNTTOT
C
      DO I=1,16,1
         PCOUNT(I) = 100 .* CITS(I) / COUNTTOT
      ENDDO
C
C table output   ITY and N are reals  (tables do not want integers)
C
       DO II = 1,16
         ITY   = II - 6.
         NN    = CITS(II)+0.
         MEAN  = XITS(II) / NN
         SD    =  (NN*XITS2(II)) - (XITS(II)**2.)
         SD    =  SQRT( SD /(NN*(NN-1) ) )
         SDMIN = MEAN - SD
         SDPLUS= MEAN + SD
         CALL TBEPUT(TIDO,TYPER,II,1,ITY,ISTAT)
         CALL TBEPUT(TIDO,TYPER,II,2,NN,ISTAT)
         CALL TBEPUT(TIDO,TYPER,II,3,MEAN,ISTAT)
         CALL TBEPUT(TIDO,TYPER,II,4,SD,ISTAT)
         CALL TBEPUT(TIDO,TYPER,II,5,SDMIN,ISTAT)
         CALL TBEPUT(TIDO,TYPER,II,6,SDPLUS,ISTAT)
       ENDDO
C close table
       CALL TBTCLO(TIDO,STATUS)
C
C print output 
C
      WRITE(7,999) COUNTTOT,I2COL
      WRITE(7,990) SELECT
      WRITE(7,801) CITS(1),PCOUNT(1)
      WRITE(7,802) CITS(2),PCOUNT(2),TCOUNT2,PTCOUNT2
      WRITE(7,803) CITS(3),PCOUNT(3)
      WRITE(7,804) CITS(4),PCOUNT(4)
      WRITE(7,805) CITS(5),PCOUNT(5),TCOUNT5,PTCOUNT5
      WRITE(7,806) CITS(6),PCOUNT(6)
      WRITE(7,807) CITS(7),PCOUNT(7)
      WRITE(7,808) CITS(8),PCOUNT(8)
      WRITE(7,809) CITS(9),PCOUNT(9)
      WRITE(7,810) CITS(10),PCOUNT(10)
      WRITE(7,811) CITS(11),PCOUNT(11),TCOUNT11,PTCOUNT11
      WRITE(7,812) CITS(12),PCOUNT(12)
      WRITE(7,813) CITS(13),PCOUNT(13)
      WRITE(7,814) CITS(14),PCOUNT(14)
      WRITE(7,815) CITS(15),PCOUNT(15)
      WRITE(7,816) CITS(16),PCOUNT(16)
C23456
  999 FORMAT(' TOTAL COUNT: ',I8,10X,' SELECTION ON COLUMN:# ',I8)
  990 FORMAT(16X,' LOGICAL SELECT ON:',A50)
  801 FORMAT(' TYPE -5 : ',I8,F8.1) 
  802 FORMAT(' TYPE -4 : ',I8,F8.1,10X,' TOTAL -5,-4,-3 :',I8,F8.1) 
  803 FORMAT(' TYPE -3 : ',I8,F8.1)
  804 FORMAT(' TYPE -2 : ',I8,F8.1) 
  805 FORMAT(' TYPE -1 : ',I8,F8.1,10X,' TOTAL -2,-1,0  :',I8,F8.1)
  806 FORMAT(' TYPE  0 : ',I8,F8.1) 
  807 FORMAT(' TYPE  1 : ',I8,F8.1) 
  808 FORMAT(' TYPE  2 : ',I8,F8.1) 
  809 FORMAT(' TYPE  3 : ',I8,F8.1) 
  810 FORMAT(' TYPE  4 : ',I8,F8.1) 
  811 FORMAT(' TYPE  5 : ',I8,F8.1,10X,' TOTAL >0.5     :',I8,F8.1)
  812 FORMAT(' TYPE  6 : ',I8,F8.1) 
  813 FORMAT(' TYPE  7 : ',I8,F8.1) 
  814 FORMAT(' TYPE  8 : ',I8,F8.1) 
  815 FORMAT(' TYPE  9 : ',I8,F8.1) 
  816 FORMAT(' TYPE 10 : ',I8,F8.1) 
C
       CALL STSEPI
       END

C @(#)ftcpgv.for	19.1 (ES0-DMD) 02/25/03 13:17:32
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FTCPGV(ISTAT)                                                  
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                   
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:25 - 13 JAN 1988                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C.IDENTIFICATION                                                                
C                                                                               
C  FITLIB.FOR   VERSION 1.0  27 MAR 1984                                        
C                                                                               
C.PURPOSE                                                                       
C                                                                               
C  INTERFACE ROUTINES FOR THE FITTING STRUCTURES                                
C COPY GUESSES INTO ACTUAL PARAMS                                               
C                                                                               
C.ALGORITHM                                                                     
C                                                                               
C  USE MIDAS I/O INTERFACES TO FRAMES AND TABLES                                
C                                                                               
C.KEYWORDS                                                                      
C                                                                               
C  NON LINEAR FITTING                                                           
C                                                                               
C                                                                               
C----------------------------------------------------------------               
C                                                                               
C      IMPLICIT NONE                                                            
C                                                                               
       INTEGER I,ISTAT
       INCLUDE 'MID_INCLUDE:FITI.INC/NOLIST'                                     
       INCLUDE 'MID_INCLUDE:FITC.INC/NOLIST'                                     
C                                                                               
C COPY                                                                          
C                                                                               
      DO 10 I = 1,FZPARMAX                                                    
          FZVALUE(I) = FZGUESS(I)                                           
   10 CONTINUE                                                                  
      RETURN                                                                    
                                                                                
      END                                                                       

C @(#)ftspar.for	19.1 (ES0-DMD) 02/25/03 13:17:36
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FTSPAR(PARM1,LEN,ISEQ,ITYPE)                                   
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                   
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:25 - 13 JAN 1988                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C.IDENTIFICATION                                                                
C                                                                               
C  FITLIB.FOR   VERSION 1.0  27 MAR 1984                                        
C                                                                               
C.PURPOSE                                                                       
C                                                                               
C  INTERFACE ROUTINES FOR THE FITTING STRUCTURES                                
C SEARCHS FOR PARAMETER PARAM                                                   
C RETURNS THE FUNCTION NUMBER AND THE TYPE OF PARAMETER                         
C                                                                               
C.ALGORITHM                                                                     
C                                                                               
C  USE MIDAS I/O INTERFACES TO FRAMES AND TABLES                                
C                                                                               
C.KEYWORDS                                                                      
C                                                                               
C  NON LINEAR FITTING                                                           
C                                                                               
C                                                                               
C----------------------------------------------------------------               
C                                                                               
C                                                                               
C INPUT ARGUMENTS                                                               
C PARM1 CHAR PARAMETER NAME                                                     
C LEN INTG PARAMETER LENGTH                                                     
C                                                                               
C OUTPUT ARGUMENTS                                                              
C ITYPE INTG PARAMETER TYPE : 1 - Y VALUE                                       
C      2 - X VALUE                                                              
C      3 - FWHM VALUE                                                           
C     -1 - PARAMETER WITH CONSTRAIN                                             
C      0 - UNKNOWN TYPE OR PARAM NOT FOUND                                      
C                                                                               
      INTEGER LEN,ISEQ,ITYPE,I,J,IOFF,IFUN
      CHARACTER*(*) PARM1                                                       
      CHARACTER*12 NAME                                                         
      CHARACTER*40 PARAM
       INCLUDE 'MID_INCLUDE:FITI.INC/NOLIST'                                     
       INCLUDE 'MID_INCLUDE:FITC.INC/NOLIST'                                     
C                                                                               
C SEARCH FOR PARAMETER                                                          
C                       
      PARAM  = PARM1                                                        
      CALL FORUPC(PARAM,PARAM)
      ITYPE  = 0                                                                
      DO 10 I = 1,FZNPTOT                                                     
          NAME   = FZPTOKEN(I)                                                
          CALL FORUPC(NAME,NAME)
          IF (NAME(1:FZPLEN(I)).EQ.PARAM(1:LEN)) GO TO 20                     
   10 CONTINUE                                                                  
      RETURN                                                                    
C                                                                               
C CHECK TYPE                                                                    
C                                                                               
   20 IF (FZFIXED(I).LT.0) THEN                                               
          ITYPE  = -1                                                           
      ELSE                                                                      
          IOFF   = 0                                                            
          DO 30 J = 1,FZNFUN                                                  
              IF (I.LE.IOFF+FZACTPAR(J)) THEN                                 
                  ITYPE  = I - IOFF                                             
                  IFUN   = FZFCODE(J)                                         
                  GO TO 40                                                      
              END IF                                                            
              IOFF   = IOFF + FZACTPAR(J)                                     
   30     CONTINUE                                                              
   40     IF (IFUN.LE.1 .OR. IFUN.GE.24) ITYPE  = 0                             
      END IF                                                                    
      RETURN                                                                    
                                                                                
      END                                                                       

C @(#)distri.for	19.1 (ES0-DMD) 02/25/03 13:21:22
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C

        REAL FUNCTION GAMMAQ(A,X)
        REAL X,A
        REAL GLN,GAMSER,GAMMCF
        IF (X.LT.A+1)THEN
           CALL GSER(GAMSER,A,X,GLN)
           GAMMAQ=1-GAMSER
        ELSE
           CALL GCF(GAMMCF,A,X,GLN)
           GAMMAQ=GAMMCF
        ENDIF
        RETURN
        END

        REAL FUNCTION GAMMAP(A,X)
        REAL X,A
        REAL GLN,GAMSER,GAMMCF
        IF (X.LT.A+.1)THEN
           CALL GSER(GAMSER,A,X,GLN)
           GAMMAP=GAMSER
        ELSE
           CALL GCF(GAMMCF,A,X,GLN)
           GAMMAP=1.-GAMMCF
        ENDIF
        RETURN
        END



               
        SUBROUTINE GSER(GAMSER,A,X,GLN)
        REAL GAMSER,X,GLN,SUM,DEL,EPS,A
        REAL GAMMLN,AP
        INTEGER ITMAX,N
        PARAMETER (ITMAX=100,EPS=3.E-7)
        GLN=GAMMLN(A)
        IF (X.LE.0)THEN
           IF(X.LT.0)RETURN
           GAMSER=0
           RETURN
        ENDIF
        AP = A
       SUM = 1./A
        DEL = SUM
        DO 10 N=1,ITMAX
           AP = AP+1
           DEL = DEL*X/AP
           SUM = SUM+DEL
           IF (ABS(DEL).LT.ABS(SUM)*EPS)GOTO 20
10      CONTINUE
20       GAMSER=SUM*EXP(-X+A*LOG(X)-GLN)
        RETURN
       END

        SUBROUTINE GCF(GAMMCF,A,X,GLN)
        REAL GAMMCF,X,GLN,GOLD,A0,A1,B0,B1,FAC,EPS,ANA,G,A
        REAL GAMMLN,ANF
        INTEGER N,ITMAX
        PARAMETER (ITMAX=100,EPS=3.E-7)
        GLN=GAMMLN(A)
        A0 = 1.
        A1 = X
        B0 = 0
        B1 = 1
        FAC = 1
        DO 10 N = 1,ITMAX
           ANA = N-A
           A0 = (A1+A0*ANA)*FAC
           B0 = (B1+B0*ANA)*FAC
           ANF = N*FAC
           A1 = X*A0+ANF*A1
           B1 = X*B0+ANF*B1
           IF(A1.NE.0)THEN
             FAC = 1./A1
             G=B1*FAC
             IF(ABS((G-GOLD)/G).LT.EPS)GOTO 20
             GOLD=G
           ENDIF
10      CONTINUE
20      GAMMCF = EXP(-X+A*ALOG(X)-GLN)*G
        RETURN
        END        

  
        REAL FUNCTION GAMMLN(XX)
        REAL XX
        INTEGER J
        DOUBLE PRECISION COF(6),STP,HALF,ONE,FPF,X,TMP,SER
        DATA COF/76.18009173,-86.50532033,24.01409822,
     1        -1.231739516,0.120858003D-2,-0.536382D-5/
        DATA STP/2.50662827465/
        DATA HALF,ONE,FPF/0.5,1.,5.5/
        X = XX - ONE
        TMP = X + FPF
        TMP = (X+HALF)*LOG(TMP)-TMP
        SER = ONE
        DO 10 J=1,6
           X = X + ONE
           SER = SER + COF(J)/X
10      CONTINUE
        GAMMLN = TMP + LOG(STP*SER)
        RETURN
        END


       REAL FUNCTION ERF(X)
       REAL X,GAMMAP
c       returns the error function erf(X)
       IF(X.LT.0) THEN
           ERF = -1*GAMMAP(0.5,X**2)
       ELSE
           ERF = GAMMAP(0.5,X**2)
       ENDIF
       RETURN
       END

       REAL FUNCTION BETAI(A,B,X)
C       returns the imcomplete beta function
       REAL*4 A,B,X,GAMMLN,BT,BETACF       
       IF (X.EQ.0.OR.X.EQ.1.)THEN
           BT = 0.
       ELSE
           BT = EXP(GAMMLN(A+B)-GAMMLN(A)-GAMMLN(B)+
     1            A*LOG(X)+B*LOG(1.-X))
       ENDIF
       IF (X.LT.(A+1.)/(A+B+2.))THEN      
           BETAI = BT*BETACF(A,B,X)/A
       ELSE
           BETAI = 1.-1*(BT*BETACF(B,A,1.-X)/B)
       ENDIF
       END
       
       REAL FUNCTION BETACF(A,B,X)
       REAL A,B,X,TEM,APP,BPP,AOLD
       REAL EPS,AM,BM,AZ,QAB,QAM,QAP,BZ,EM,D,AP,BP
       INTEGER ITMAX,M
       PARAMETER (ITMAX=100,EPS=3.E-7)
       AM = 1.
       BM = 1.
       AZ = 1.
       QAB = A+B
       QAP = A+1.
       QAM = A-1.
       BZ = 1.-QAB*X/QAP
       DO 10 M = 1,ITMAX
           EM = M
           TEM = EM+EM
           D = EM*(B-M)*X/((QAM+TEM)*(A+TEM))
           AP = AZ+D*AM
           BP = BZ+D*BM
           D = -(A+EM)*(QAB+EM)*X/((A+TEM)*(QAP+TEM))
           APP = AP+D*AZ
           BPP = BP+D*BZ
           AOLD = AZ
           AM = AP/BPP
           BM = BP/BPP
           AZ = APP/BPP
           BZ = 1.
           IF(ABS(AZ-AOLD).LT.EPS*ABS(AZ))GOTO 20
10        CONTINUE
20       BETACF = AZ
        RETURN
        END                    

       REAL FUNCTION ERFCC(X)
       REAL X,Z,T
       Z = ABS(X)
       T = 1./(1.+0.5*Z)
       ERFCC = T*EXP(-Z*Z-1.26551223+T*(1.00002368+T*(0.37409196+
     1        T*(0.09678418+T*(-0.18628806+T*(0.27886807+T*(-1.13520398+
     2     T*(1.48851587+T*(-0.82215223+T*0.17087277)))))))))
       IF (X.LT.0.) ERFCC = 2.-ERFCC
       RETURN
       END


       REAL FUNCTION UNIF(X,PARA)
       REAL X,PARA(2),A,B
       A = PARA(1)
       B = PARA(2)
       IF (X.LT.B.AND.X.GT.A)THEN
         UNIF = (B-X)/(B-A)
       ELSE
         UNIF = 0
       ENDIF
       END


       REAL FUNCTION BINOM(NOBS,N,PROB)
       REAL FACT
       INTEGER NOBS,N,I
       REAL PROB
       BINOM = 0.
       DO 10 I = 0,NOBS
         BINOM = BINOM+FACT(N)/FACT(I)/FACT(N-I)*(PROB**I)*
     1              ((1-PROB)**(N-I))
10     CONTINUE
       RETURN
       END

       REAL FUNCTION FACT(N)
       REAL GAMMLN
       INTEGER N,J
       FACT = 1.
       IF (N.LT.0) THEN
          RETURN
       ELSE IF (N.LT.32) THEN
          DO 11 J=1,N
              FACT = FACT*J
11        CONTINUE          
       ELSE
         FACT = EXP(GAMMLN(N+1.))
       ENDIF
       RETURN
       END

       
       

C===========================================================================
C Copyright (C) 1995-2005 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  9:51 - 26 NOV 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: K.BANSE
C
C.VERSION
C 051017	last modif
C 


      SUBROUTINE GENEXT(STRING,DELIM,START,SS,SLEN)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C      IMPLICIT NONE
C
C.IDENTIFICATION
C  subroutine GENEXT         version 2.50       860217
C  K. Banse                      ESO - Garching
C
C.KEYWORDS
C  character string , parsing
C
C.PURPOSE
C  from a given string extract a substring limited by given
C  delimiters
C
C.ALGORITHM
C  find the given delimiter in the string
C  copy the relevant part into the substring
C  spaces in front or after delimiters are ignored
C
C.INPUT/OUTPUT
C  call as  GENEXT(STRING,DELIM,START,SS,SLEN)
C
C  input par:
C  STRING: char. exp. character string which is to be parsed
C  DELIM: char. exp. delimiter string
C
C  input/output par:
C  START: I*4  starting index within the input
C    string - will be set to the position
C    just following the next delimiter
C    upon return
C
C  output par:
C  SS:  char. exp. extracted substring
C    will be set to spaces, if nothing there
C  SLEN: I*4  length of extracted substring in bytes
C
C--------------------------------------------------
C
C
      INTEGER       SLEN, START, SKIP, SOSS, EOSS,FORSKP
      INTEGER NXTDL1,NEXT1
      CHARACTER*(*) STRING,DELIM,SS
      CHARACTER*200 SDUMMY
C
      SS     = ' '
      SLEN   = 0
C
C  see, if already the end of string reached
      IF (LEN(STRING).LT.START) GO TO 30
C
C  skip leading blanks
      SKIP   = FORSKP(' ',STRING(START:))  !  only blanks
      IF (SKIP.LE.0) GO TO 30
C
C  find begin of substring + next delimiter
      SOSS   = START + SKIP - 1  !  points to next delim. - 1
      SDUMMY = STRING(SOSS:)//DELIM
      NXTDL1 = INDEX(SDUMMY,DELIM) + SOSS - 2  !  1. non-blank character = delimiter
      IF (NXTDL1.LT.SOSS) GO TO 20
C
C  cut off trailing blanks
      IF (DELIM.EQ.' ') THEN
          EOSS   = NXTDL1

      ELSE
          SDUMMY = STRING(SOSS:NXTDL1)//' '
          EOSS   = INDEX(SDUMMY,' ') + SOSS - 2
      END IF
C
C  look for character constants with embedded blanks, ".. .."
      IF ((DELIM.NE.' ') .OR. (STRING(SOSS:SOSS).NE.'"')) GO TO 10
      IF ((SOSS.EQ.EOSS) .OR. (STRING(EOSS:EOSS).NE.'"')) THEN
C    !don't consider first '"' again...
          SDUMMY = STRING(SOSS+1:)//' '
          NEXT1  = INDEX(SDUMMY,'" ')
          IF (NEXT1.GT.0) THEN  !  update end of substring
              EOSS   = NEXT1 + SOSS  !  as well as NXTDL1...
              NXTDL1 = EOSS
          END IF

      END IF
C
C  copy string
   10 SS(1:) = STRING(SOSS:EOSS)
      SLEN   = EOSS - SOSS + 1
   20 START  = NXTDL1 + LEN(DELIM) + 1
      RETURN
C
   30 START  = 0
      RETURN

      END

      SUBROUTINE DISFIL(FILNAM,PREFIX,LABEL,STAT)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine DSPFIL		version 3.03	841213
C  K. Banse			ESO - Garching
C  					3.10	871201
C
C.KEYWORDS
C  display, ASCII files
C
C.PURPOSE
C  display a given section of a file (may be complete file) on the terminal
C  and store it in the logfile
C
C.ALGORITHM
C  search file till line PREFIX//LABEL is found + display all records
C  from there on until line PREFIX//anything is encountered.
C
C.INPUT/OUTPUT
C  call as  DSPFIL(FILNAM,PREFIX,LABEL,USR_LEVL,STAT)
C
C  input par:
C  FILNAM:	char.exp.	FILNAMe
C  PREFIX:	char.exp.	this string marks different section in a file
C  LABEL:	char.exp.	this label determines the start of the
C				file section to be displayed when concatenated
C				to PREFIX
C
C  output par:
C  STAT:	I*4		return status
C
C.VERSIONS
C  3.10		get rid of ERRSIGNAL_ST
C--------------------------------------------------
C
        INTEGER        STAT
        INTEGER        N,LCOUNT,EMODE,ULEVL,IAV
        INTEGER        L0,L1,LL,TFLAG
        INTEGER        NLINES,RECLIM,KUN,KNUL
C        
        CHARACTER*(*)    FILNAM,PREFIX,LABEL
        CHARACTER        LINMS*35,RETURN*1
        CHARACTER        RECORD*80
        CHARACTER        SDUMMY*200
C
        DATA        LINMS /' MIDAS> hit RETURN to continue ... '/
        DATA        NLINES  /18/
        DATA        RECLIM  /100000/
C
C  get user level + execution mode
        CALL STKRDI('MID$MODE',3,1,IAV,EMODE,KUN,KNUL,STAT)
        CALL STKRDI('ERROR',2,1,IAV,ULEVL,KUN,KNUL,STAT)
C
C  set up TFLAG
        IF ((ULEVL.LT.2).AND.(EMODE.NE.1)) THEN
           TFLAG = 1                
        ELSE
           TFLAG = 0                
        ENDIF
        LCOUNT = 0                        
        L0 = 0
C        
C  display contents of a file section, determined by PREFIX//LABEL
        OPEN(UNIT=11,FILE=FILNAM,STATUS='OLD',ERR=8800)
C
C  look for PREFIX//LABEL to find start of file section
        IF (PREFIX.EQ.' ') GOTO 3000        
        L0 = LEN(PREFIX)
        L1 = LEN(LABEL)
        LL = L0 + L1
        SDUMMY = PREFIX//LABEL
        DO 2450 N=1,RECLIM
           READ(11,10000,END=2500) RECORD
           IF (RECORD(1:LL).EQ.SDUMMY) GOTO 3000
2450    CONTINUE
C        
C  desired PREFIX//LABEL not found
2500        STAT = 1
        RETURN
C
C  max. 100 000 records
3000    DO 3900 N=1,RECLIM                        
           RECORD = ' '
           READ(11,10000,END=4000) RECORD
C        
           IF ((PREFIX.NE.' ').AND.(RECORD(1:L0).EQ.PREFIX)) THEN
              GOTO 4000
           ELSE
              CALL STTPUT(RECORD,STAT)
C        
C  if TFLAG set, check no. of lines on terminal screen ...
              IF (TFLAG.EQ.1) THEN
                 LCOUNT = LCOUNT + 1
                 IF (LCOUNT.GT.NLINES) THEN
                    WRITE(*,10002) LINMS
                    READ(*,10000) RETURN        
                    LCOUNT = 0
                 ENDIF
              ENDIF
           ENDIF
C        
3900    CONTINUE
C
C  close message file
4000    CLOSE(UNIT=11)
        STAT = 0
        RETURN
C
C  problems with file opening
8800    STAT = 2
        RETURN
C
C  formats
10000   FORMAT(A)
10002   FORMAT(A)
        END
C
C       UNDEFINED REFERENCES FOR THE MOMENT
C
        SUBROUTINE TZSBAC(STATUS)
C
        INTEGER STATUS
        STATUS = 0
        RETURN
        END
        SUBROUTINE TZSBAD(STATUS)
C
        INTEGER STATUS
        STATUS = 0
        RETURN
        END
        SUBROUTINE TZSBAR(STATUS)
C
        INTEGER STATUS
        STATUS = 0
        RETURN
        END
        SUBROUTINE TZSBDC(STATUS)
C
        INTEGER STATUS
        STATUS = 0
        RETURN
        END
        SUBROUTINE TZSBDR(STATUS)
C
        INTEGER STATUS
        STATUS = 0
        RETURN
        END
        SUBROUTINE TZSBDD(STATUS)
C
        INTEGER STATUS
        STATUS = 0
        RETURN
        END
        SUBROUTINE TZSCSC(STATUS)
C
        INTEGER STATUS
        STATUS = 0
        RETURN
        END
        SUBROUTINE TZSCSD(STATUS)
C
        INTEGER STATUS
        STATUS = 0
        RETURN
        END
        SUBROUTINE TZSCSR(STATUS)
C
        INTEGER STATUS
        STATUS = 0
        RETURN
        END

C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C
C-----------------------------------------------------------------------
      SUBROUTINE NRMLEQ ( AS , MAS , JAPYS , IBUFS , LPXL ,
     &                    APSF , FPSF , IOFF0 , IOFF1 , IOFF2 ,
     &                    IOFFI , BGRD , I0 , J0 , SCA ,
     &                    COMP , SCC , CENTER , IDF , JDF ,
     &                    XDF , YDF , IOFFC , IC , SIGM ,
     &                    NPX , AR ) 
C
      IMPLICIT           NONE
      INCLUDE            'MID_REL_INCL:INVENT.INC/NOLIST'
C
      REAL               AS(1)             ! IN: Data array
      INTEGER            MAS((-MAXSUB):MAXSUB,(-MAXSUB):MAXSUB) ! Mask array
      INTEGER            JAPYS(1)          ! IN: Pointers to data lines
      INTEGER            IBUFS(4)          ! IN: Limits of image buffer
      INTEGER            LPXL              ! IN: Pixel's extend
      REAL               APSF(0:MAXSUB)    ! IN: One dimensional p.s.f.
      REAL               FPSF(1)           ! MOD: Two dimensional p.s.f.
      INTEGER            IOFF0             ! IN: P.s.f. offset
      INTEGER            IOFF1             ! IN: X gradient offset
      INTEGER            IOFF2             ! IN: Y gradient offset
      INTEGER            IOFFI             ! IN: Corrections offset
      REAL               BGRD              ! IN: Sky background
      INTEGER            I0                ! IN: Object x shift
      INTEGER            J0                ! IN: Object y shift
      REAL               SCA               ! IN: Object intensity
      LOGICAL            COMP              ! IN: TRUE if there is a component
      REAL               SCC               ! IN: Component intensity
      LOGICAL            CENTER            ! IN: TRUE if close component
      INTEGER            IDF               ! IN: X pixel offset of component
      INTEGER            JDF               ! IN: Y pixel offset of component
      REAL               XDF               ! IN: X real offset of component
      REAL               YDF               ! IN: Y real offset of component
      INTEGER            IOFFC             ! IN: Adress offset of component
      INTEGER            IC                ! IN: Iteration number
      REAL               SIGM              ! IN: Sigma of pixel data
      INTEGER            NPX               ! IN: Number of good pixels
      DOUBLE PRECISION   AR(25)            ! OUT: Normal equations coefficients
C
      INTEGER   I , I1 , I2 , IDIF , IOF
      INTEGER   J , J1 , J2 , JARG , JOF , JOFC
      INTEGER   K , L , MPXL , NNOR , NR
      REAL      ADIF , DIFF , TMP(5)
      LOGICAL   JCNTR
C
      MPXL = 2 * LPXL + 1
C
C *** Prepare for calculations.
C
      DO 50 J = 1 , 25
          AR(J) = 0.0
   50 CONTINUE
      JOFC = 0
      NPX = 0
      I1 = MAX( (-LPXL) , IBUFS(1)-I0 )
      I2 = MIN( LPXL , IBUFS(3)-I0 )
      J1 = MAX( (-LPXL) , IBUFS(2)-J0 )
      J2 = MIN( LPXL , IBUFS(4)-J0 )
C
C *** Form normal equations for least squares solution.
C
      DO 10 J = J1 , J2
          JARG = JAPYS(J+J0-IBUFS(2)+1) + I0
          JOF = MPXL * J
          IF ( CENTER .AND. ABS(J+JDF) .LE. LPXL ) THEN
              JCNTR = .TRUE.
              JOFC = MPXL * (J+JDF)
          ELSE
              JCNTR = .FALSE.
          ENDIF
          DO 20 I = I1 , I2
              IF ( MAS(I,J) .GE. 1 ) THEN
                  IOF = JOF + I
                  TMP(1) = FPSF(IOFF0+IOF)
                  TMP(2) = FPSF(IOFF1+IOF) * SCA
                  TMP(3) = FPSF(IOFF2+IOF) * SCA
                  IF ( COMP ) THEN
                      IF ( JCNTR .AND. ABS(I+IDF) .LE. LPXL ) THEN
                          TMP(4) = FPSF(IOFF0+IOFFC+JOFC+I+IDF)
                      ELSE
                          DIFF = SQRT( (XDF-FLOAT(I))**2.0 +
     &                                 (YDF-FLOAT(J))**2.0 )
                          IDIF = INT(DIFF)
                          IF ( IDIF .LT. MAXSUB ) THEN
                              ADIF = DIFF - IDIF
                              TMP(4) = APSF(IDIF) * (1.0-ADIF) +
     &                                 APSF(IDIF+1) * ADIF
                          ELSE
                              TMP(4) = 0.0
                          ENDIF
                      ENDIF
                      TMP(5) = AS(JARG+I) - BGRD - TMP(1) * SCA -
     &                                             TMP(4) * SCC
                      NNOR = 5
                  ELSE
                      TMP(4) = AS(JARG+I) - BGRD - TMP(1) * SCA
                      NNOR = 4
                  ENDIF
                  IF ( ABS(TMP(NNOR)) .LT. 2.0 * SIGM ) THEN
                      NPX = NPX + 1
                      DO 70 L = 1 , NNOR
                          DO 80 K = L , NNOR
                              NR = (L-1)*NNOR + K
                              AR(NR) = AR(NR) + DBLE(TMP(K)*TMP(L))
   80                     CONTINUE
   70                 CONTINUE
                  ENDIF
                  IF ( IC .EQ. 7 ) THEN
                      FPSF(IOFFI+IOF) = TMP(NNOR) / SCA
                  ENDIF
              ENDIF
   20     CONTINUE
   10 CONTINUE
C
      RETURN
C
      END
C

C @(#)getlst.for	19.1 (ES0-DMD) 02/25/03 13:25:34
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine GETLST         version 1.0        880901
C  A. Kruszewski             Warsaw U. Obs.
C.PURPOSE
C  Find an object less distant to L-th object then LDIS.
C  Only objects listed after LACT are considered.
C  Number of found object is returned as LACT and DONE is .TRUE.
C  otherwise DONE is .FALSE.
C.INPUT/OUTPUT
C  Input parameters
C  L        integer*4          object's number
C  L0       integer*4          offset to catalog buffer
C  L1       integer*4          last object in catalog buffer
C  LDIS     integer*4          looks for objects closer than that
C  LSTP     integer*4 array    limits of regions
C  NREG     integer*4          number of regional linked lists
C  NCAT     integer*4 array    integer catalog
C  PMTR     real*4 array       real catalog
C  PRCT     real*4 array       catalog of profiles
C  NP       integer*4          dimension of catalog buffers
C  LACT     integer*4          searching starts with that object
C  NCT      integer*4 array    small integer buffer
C  PMT      real*4 array       small real buffer
C  Output parameters
C  LACT     integer*4          found object
C  DONE     logical            .true. if found
C-----------------------------------------------------------------------
      SUBROUTINE GETLST(L, L0, L1, LDIS, NREG,
     &                    LSTP, NCAT, PMTR, PRCT, LACT,
     &                    NCT, PMT, PRC, DONE)
C
      IMPLICIT  NONE
      INCLUDE   'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER   L
      INTEGER   L0
      INTEGER   L1
      INTEGER   LDIS
      INTEGER   NREG
      INTEGER   LSTP(0:4,0:NREG)
      INTEGER   NCAT(NIPAR,MAXCNT)
      REAL      PMTR(NRPAR,MAXCNT)
      REAL      PRCT(0:MAXSUB,MAXCNT)
      INTEGER   LACT
      INTEGER   NCT(NIPAR)
      REAL      PMT(NRPAR)
      REAL      PRC(0:MAXSUB)
      LOGICAL   DONE
C
      INTEGER   LDIS2
      INTEGER   LZ
      INTEGER   I, J
      INTEGER   IREG
      INTEGER   LLZ
      INTEGER   IA, JA
      LOGICAL   NEAR
C
      DONE = .FALSE.
      LDIS2 = LDIS * LDIS
C      IF ( L .GT. L0 .AND. L .LE. L1 ) THEN
          LZ = L - L0
          I = NCAT(1,LZ)
          J = NCAT(2,LZ)
C      ELSE
C          READ ( ISF , REC=L ) NCT , PMT , PRC
C          I = NCT(1)
C          J = NCT(2)
C      ENDIF
      IREG = 0
   30 CONTINUE
      IF ( LACT .EQ. 0 ) THEN
C
C ***     Look for nearby region.
C
   10     CONTINUE
C
C ***     Pick up next region.
C
          IREG = IREG + 1
          IF ( IREG .GT. NREG ) RETURN
C
C ***     Check if region is sufficiently nearby.
C
          NEAR = .FALSE.
          CALL IFNEAR( NREG , LSTP , IREG , I , J , LDIS , NEAR )
          IF ( NEAR ) THEN
              LACT = LSTP(0,IREG)
              IF ( LACT .NE. 0 ) GOTO 20
          ENDIF
          GOTO 10
      ELSE
C
C ***     Pick object next to LACT.
C
C          IF ( LACT .GT. L0 .AND. LACT .LE. L1 ) THEN
              LLZ = LACT - L0
              IREG = NCAT(7,LLZ)
              LACT = NCAT(8,LLZ)
C          ELSE
C              READ ( ISF , REC = LACT ) NCT , PMT , PRC
C              IREG = NCT(7)
C              LACT = NCT(8)
C          ENDIF
      ENDIF
   20 CONTINUE
C
C *** Try again when LACT = 0 or LACT = L or when
C *** an object is not sufficiently close.
C
      IF ( LACT .EQ. 0 .OR. LACT .EQ. L ) GOTO 30
C      IF ( LACT .GT. L0 .AND. LACT .LE. L1 ) THEN
          LLZ = LACT - L0
          IA = NCAT(1,LLZ)
          JA = NCAT(2,LLZ)
          PMT(2) = PMTR(2,LLZ)
C      ELSE
C          READ ( ISF , REC = LACT ) NCT , PMT , PRC
C          IA = NCT(1)
C          JA = NCT(2)
C      ENDIF
      IF ( (IA-I)*(IA-I)+(JA-J)*(JA-J) .GT. LDIS2 ) GOTO 30
      DONE = .TRUE.
C
      RETURN
C
      END
C

C @(#)astrm.for	19.1 (ES0-DMD) 02/25/03 13:30:45
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++           
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C.IDENTIFICATION: ASTRM                                                         
C.PURPOSE:        Routine for main program star written by P.B.Stetson          
C                 performs the gaussian astrometric fitting                     
C.LANGUAGE:       F77+ESOext                                                    
C.AUTHOR:         P. Stetsan                                                    
C.ALGORITHM:      see Stetson,  P.B.,  1979  Astron. J. 84  1149                
C.INPUT/OUTPUT:   ->  KRX    input array                                        
C                 ->  JX     low  side local minimun                            
C                 ->  LX     high side local minimum                            
C                 <-> XI     input/ouput estimates of the image centre          
C                 <-  S1     error estimate of the output image centre          
C                            0. fitting procedure failed or if                  
C                            KOUNT .NE. 0  then KOUNT too small                 
C                 <-> SX     input/output estimate of the image width           
C                 <-  DO     output estimate of the image height                
C                 <-  B      output estimate of the background marginal iensity.
C                 <-> KOUNT  number of iterations required/ status              
C                            0 fitting procedure failed                         
C.COMMENTS:       If the solution fails to converge, XI will come back with     
C                 the input value.... with S1 = 0. just in case you want to try 
C                 doing the photometry with the estimated centre from SERCH.    
C.KEYWORDS :      photometry,astrometry                                         
C.VERSION:        8212?? P. Stetsan                                             
C.VERSION:        871123 R.H. Warmels  ESO Fortran Conversion                   
C.VERSION:        ?????? H. Waldhausen Vax implementation                       
C ---------------------------------------------------------------------         
      SUBROUTINE ASTRM(KRX,JX,LX,XI,S1,SX,DO,B,KOUNT)                           
C                                                                               
      IMPLICIT         NONE
      DOUBLE PRECISION KRX(1)
      INTEGER          JX
      INTEGER          LX
      REAL             XI
      REAL             S1
      REAL             SX
      REAL             DO
      REAL             B
      INTEGER          KOUNT
C
      INTEGER          I
      INTEGER          J
      INTEGER          KNT
      INTEGER          L
      REAL             D, DX, DELX
      REAL             EX
      REAL             F, FF, FOLD
      REAL             S, S2, SXSI
      REAL             XO
      REAL             Y
      DOUBLE PRECISION CTF(5)                         
      DOUBLE PRECISION CTC(5,5)                         
      DOUBLE PRECISION V(5)                         
      DOUBLE PRECISION DABS                         
      REAL             C(3)                                                     
C                                                                               
C                                                                               
C..  this part of the program uses the estimates of the image centre            
C..  and width from SERCH to derive initial estimates of the image              
C..  height and background density by linear least-squares.                     
C                                                                               
      IF ((LX-JX).GT.4) THEN                                                    
         XO     = XI                                                            
         DELX   = LX - JX + 1                                                   
         XO     = XI                                                            
         DELX   = LX - JX + 1                                                   
         S1     = 0.0                                                           
         S2     = 0.0                                                           
         DO     = 0.0                                                           
         B      = 0.0                                                           
         SXSI   = 0.5/(SX*SX)                                                   
C                                                                               
         DO 10 I = JX,LX                                                        
            DX     = I - XO                                                     
            EX     = EXP(-DX*DX*SXSI)                                           
            DO     = DO + EX*KRX(I)                                             
            B      = B + EX*EX                                                  
            S1     = S1 + KRX(I)                                                
            S2     = S2 + EX                                                    
   10    CONTINUE                                                               
C                                                                               
         F      = LX - JX + 1                                                   
         DO     = (DO-S1*S2/F)/ (B-S2*S2/F)                                     
         B      = (S1-DO*S2)/F                                                  
         IF (DO.LT.20.0) D  = 20.0                                              
         IF (SX.LT.2.0)  SX = 2.0                                               
         FOLD   = 1.0E38                                                        
C                                                                               
C..  main iteration loop                                                        
         DO 90 KNT = 1,KOUNT                           !   iteration loop       
            S1     = 0.0                                                        
            S2     = 0.0                                                        
            FF     = 0.0                                                        
            SXSI   = 1.0/ (SX*SX)                                               
            DO 30 I = 1,4                                                       
               CTF(I) = 0.0D0                                                   
               DO 20 J = I,4                                                    
                  CTC(I,J) = 0.0D0                                              
   20          CONTINUE                                                         
   30       CONTINUE                                                            
C                                                                               
C..  set normal equations                                                       
            DO 60 L = JX,LX                              !   equation loop      
               DX     = L - XO                                                  
               EX     = 0.5*DX*DX*SXSI                                          
               C(2)   = EXP(-EX)                                                
               S      = DO*C(2)                                                 
               Y      = S + B                                                   
               F      = Y - KRX(L)                                              
               C(1)   = DX*SXSI*S                                               
               EX     = C(1)*C(1)                                               
               S1     = S1 + EX*F*F                                             
               S2     = S2 + EX                                                 
               FF     = FF + F*F                                                
               C(3)   = C(1)*DX/SX                                              
               DO 50 I = 1,3                                                    
                  CTF(I) = CTF(I) + F*C(I)                                      
                  CTC(I,4) = CTC(I,4) + C(I)                                    
                  DO 40 J = I,3                                                 
                     CTC(I,J) = CTC(I,J) + C(I)*C(J)                            
   40             CONTINUE                                                      
   50          CONTINUE                                                         
               CTF(4) = CTF(4) + F  !   equation loop                           
   60       CONTINUE                                                            
C                                                                               
            CTC(4,4) = FLOAT(LX-JX+1)                                           
            DO 80 I = 2,4                                                       
               L      = I - 1                                                   
               DO 70 J = 1,L                                                    
                  CTC(I,J) = CTC(J,I)                                           
   70          CONTINUE                                                         
   80       CONTINUE                                                            
C                                                                               
C..  solve normal equations                                                     
            CALL INVRS(CTC,4)                                                   
            CALL VMUL(CTC,4,CTF,V)                                              
C                                                                               
C..  if DA is the correction to the estimate of A, then replace DA by           
C..  DA/(1+(DA/X)) = DA' prevents an ill-determined solution from               
C..  jumping around too much in subsequent iterations. DA' is less              
C..  than X, and DA' goes to DA for DA much less than X.                        
C..  If X = A/R for some R greater than one, then an intrinsically              
C..  positive parameter will never be permitted to pass through zero.           
C..  This can be helpful for parameters like image width or height.             
C                                                                               
            XO     = XO - V(1)/ (1.0+DABS(V(1)/5.0))                            
            DO     = DO - V(2)/ (1.0+2.0*DABS(V(2)/DO))                         
            SX     = SX - V(3)/ (1.0+2.0*DABS(V(3)/SX))                         
            B      = B - V(4)/ (1.0+2.0*DABS(V(4)/B))                           
C                                                                               
C..  failure                                                                    
            IF ((DO.LT.20.0) .OR. (SX.LT.1.0) .OR.                              
     +         (SX.GT.0.5*DELX)) THEN                                           
               KOUNT  = 0                                                       
               S1     = 0.0                                                     
               RETURN                                                           
            END IF                                                              
C                                                                               
C..  success                                                                    
            IF ((DABS(V(1)).LT.0.01) .AND.                                      
     +         ((FOLD-FF)/FOLD.LT.0.05)) THEN                                   
               XI     = XO                                                      
               S1     = S1*CTC(1,1)*DELX/ (S2* (DELX-4.0))                      
               RETURN                                                           
            END IF                                                              
C                                                                               
            FOLD   = FF                                                         
   90    CONTINUE                                         !   iteration loop    
C                                                                               
C..  number of iterations too small                                             
         S1     = 0.0                                                           
C                                                                               
C..  undersampled                                                               
      ELSE                                                                      
         KOUNT  = 0                                                             
         S1     = 0.0                                                           
      END IF                                                                    
C..  exit                                                                       
      RETURN                                                                    
      END                                                                       

C @(#)moffat.for	19.1 (ES0-DMD) 02/25/03 13:17:42
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE MOFFAT(X,NP,PARAM,Y,DERIV)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  18:01 - 21 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: P.Magain, M.Remy, M.Peron 
C
C--------------------------------------------------------------
C**********************************************
C
C      IMPLICIT NONE
C 2-D Moffat 
C
C**********************************************
C
C
      INTEGER NP
      DOUBLE PRECISION PARAM(NP),DERIV(NP)
      DOUBLE PRECISION XX(2),F,Y
      REAL X(2)


      XX(1)=(X(1)-PARAM(2))/PARAM(4)
      XX(2)=(X(2)-PARAM(3))/PARAM(5)
      F=(XX(1)*XX(1)+XX(2)*XX(2)-2.*PARAM(6)*XX(1)*XX(2))+1.
      DERIV(1)=EXP(-PARAM(7)*LOG(F))
      Y=PARAM(1)*DERIV(1)
      DERIV(2)=Y*2./F*PARAM(7)*(XX(1)-PARAM(6)*XX(2))/PARAM(4)
      DERIV(3)=Y*2./F*PARAM(7)*(XX(2)-PARAM(6)*XX(1))/PARAM(5)
      DERIV(4)=DERIV(2)*XX(1)
      DERIV(5)=DERIV(3)*XX(2)
      DERIV(6)=2.*Y/F*PARAM(7)*XX(1)*XX(2)
      DERIV(7)=-Y*LOG(F)
      RETURN
      END

C @(#)spskyfit.for	19.1 (ES0-DMD) 02/25/03 14:25:24
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C @(#)spskyfit.for	19.1  (ESO)  02/25/03  14:25:24 
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++
C .COPYRIGHT   (C) 1993 European Southern Observatory    
C .IDENT       .prg                                      
C .AUTHORS     Pascal Ballester (ESO/Garching)           
C              Cristian Levin   (ESO/La Silla)           
C .KEYWORDS    Spectroscopy, Long-Slit                   
C .PURPOSE                                               
C .VERSION     1.0  Package Creation  17-MAR-1993        
C -------------------------------------------------------

C @(#)skyfit.for	2.1.1.1 (ESO-IPG) 9/27/91 19:06:46
         PROGRAM SKYFIT
C+
C
C.IDENTIFICATION
C
C  PROGRAM  SKYFIT                            VERSION 1.0        880420 OS
C
C  Otmar Stahl                          Landessternwarte Heidelberg
C
C.KEYWORDS
C
C  SPECTRA, SKY DETERMINATION
C
C.PURPOSE
C
C  DETERMINE A SKY FRAME  BY FITTING A POLYNOMIAL TO EVERY COLUMN
C  OF A FRAME. THE SKY IS MEASURED IN TWO SELECTED SKY WINDOWS. 
C
C.ALGORITHM
C
C  THE SKY IS TAKEN IN TWO WINDOWS (NORMALLY ONE BELOW AND ONE ABOVE 
C  THE OBJECT. THESE DATA ARE FITTED WITH A POLYNOMIAL. THE COEFFI-
C  CIENTS OF THE POLYNOMIAL ARE USED TO CREATE A SKY FRAME OF THE SIZE
C  OF THE INPUT FRAME. TWO MODES ARE POSSIBLE: 
C  1) FIT THE AVERAGE SPATIAL PROFILE AND SCALE TO THE COLUMNS AND
C  2) FIT EVERY COLUMN INDEPENDENTLY
C
C.INPUT/OUTPUT
C
C  FIT/COULMN OUTPUT INPUT A1,A2,B1,B2 ORDER MODE GAIN,RON,THRESHOLD RADIUS
C
C  OUT_A            output frame
C  IN_A             input frame
C  INPUTI/1/7       sky windows, two window can be selected, typically
C                   one below and one above the object spectrum, 
C                   the order of the fit and the mode.
C
      IMPLICIT NONE
      INTEGER          STAT,NPIX(2),IPAR(10),I,IAV,NAXIS
      INTEGER*8        IPN,IPNR,IPNTRA,IPNTRB,IPNTRC
      INTEGER          ICHECK
      INTEGER          MADRID, KUN, KNUL, IDI, IDO, ISS
      INTEGER          NBYT1, NBYT2
      REAL             RPAR(3)
      CHARACTER*80        INFILE,OUTFIL
      CHARACTER*48       CUNIT
      CHARACTER*72       IDENT
      CHARACTER*80       OUTPUT
      DOUBLE PRECISION START(2),STEP(2)
      INCLUDE          'MID_INCLUDE:ST_DEF.INC'
      COMMON/VMR/MADRID(1)
      INCLUDE          'MID_INCLUDE:ST_DAT.INC'
C
C  INITIALIZE MIDAS ENVIRONMENT
C
      CALL STSPRO('SKYFIT')
C
C  GET PARAMETERS 
C
      CALL STKRDC('IN_A',1,1,80,IAV,INFILE,KUN,KNUL,STAT)
      CALL STKRDC('OUT_A',1,1,80,IAV,OUTFIL,KUN,KNUL,STAT)
      CALL STKRDI('INPUTI',1,7,IAV,IPAR,KUN,KNUL,STAT)
      CALL STKRDR('INPUTR',1,3,IAV,RPAR,KUN,KNUL,STAT)

C
C  MAP INPUT FILE
C
      CALL STIGET(INFILE,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     .2,NAXIS,NPIX,START,STEP,IDENT,CUNIT,IPN,IDI,STAT)
C
C CHECK LIMITS
C
      ICHECK = 0
      IF(IPAR(1) .GT. IPAR(2)) ICHECK = 1
      IF(IPAR(3) .GT. IPAR(4)) ICHECK = 1
      IF(IPAR(1) .LT. 1)       ICHECK = 1
      IF(IPAR(4) .GT. NPIX(2)) ICHECK = 1 
      IF (ICHECK.EQ.1) THEN
          WRITE(OUTPUT,100)
          CALL STTPUT(OUTPUT,STAT)
          WRITE(OUTPUT,200) (IPAR(I),I=1,4)
          CALL STTPUT(OUTPUT,STAT)
          WRITE(OUTPUT,300) NPIX(2)
          CALL STTPUT(OUTPUT,STAT)
          GOTO 999
      ENDIF
C
C  MAP OUTPUT FILE
C
      CALL STIPUT(OUTFIL,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .2,NPIX,START,STEP,IDENT,CUNIT,IPNR,IDO,STAT)
C
C  get virtual memory for arrays
C
      NBYT1 = NPIX(2)*4
      NBYT2 = NPIX(1)*4
      CALL TDMGET(NBYT1,IPNTRA,ISS)
      CALL TDMGET(NBYT1,IPNTRB,ISS)
      CALL TDMGET(NBYT2,IPNTRC,ISS)
C
C      IPAR(7)=NPIX(1)
C      IPAR(8)=NPIX(2)
C
C DO THE FITTING IN THE SELECTED MODE
C
      IF (IPAR(6).EQ.0) THEN      
           CALL FITPL1(NPIX(1),NPIX(2),MADRID(IPN),MADRID(IPNR),
     .     MADRID(IPNTRA),MADRID(IPNTRB),MADRID(IPNTRC),IPAR)
      ELSE
           CALL FITPL2(NPIX(1),NPIX(2),MADRID(IPN),MADRID(IPNR),
     .     MADRID(IPNTRA),MADRID(IPNTRB),MADRID(IPNTRC),IPAR,RPAR)
      ENDIF
C
      CALL TDMFRE(NBYT1,IPNTRA,ISS)
      CALL TDMFRE(NBYT1,IPNTRB,ISS)
      CALL TDMFRE(NBYT2,IPNTRC,ISS)
999   CALL STSEPI
100     FORMAT('ERROR IN LIMITS')
200     FORMAT('USED WINDOWS',4(1X,I4))
300     FORMAT('ALLOWED LIMITS ARE 1',1X,I4)
      END

C******************************************************************************
C FIRST VERSION: FIT ONE POLYNOMIAL FOR ALL COLUMNS. ASSUMES THAT 
C THE NORMALIZED STATIAL PROFILE IS CONSTANT WITH X-POSITION. 
C 
      SUBROUTINE FITPL1(IX,IY,IN,SKY,Y,FLUX,X,IPAR)
C
      IMPLICIT NONE
      INTEGER         IPAR(10),I,N,J,NUM,ORDER,IX,IY
      REAL            IN(IX,IY),SKY(IX,IY)
      REAL            A(10),B(10),S(10),W(10)
      REAL            X(1),Y(1),FLUX(1),YY,CHISQ,SUM
C
      ORDER = IPAR(5)
      NUM = IPAR(2)-IPAR(1)+IPAR(4)-IPAR(3)+2
C
C------mean profile perpendicular to dispersion
C
      N = 0
      DO 20 J=IPAR(1),IPAR(2)
        N = N+1
        Y(N) = J
        FLUX(N) = 0.
        DO 10 I = 1,IX
          FLUX(N) = FLUX(N)+IN(I,J)
10      CONTINUE 
20    CONTINUE
      DO 40 J=IPAR(3),IPAR(4)
        N = N+1
        Y(N) = J
        FLUX(N) = 0.
        DO 30 I = 1,IX
          FLUX(N) = FLUX(N)+IN(I,J)
30      CONTINUE
40    CONTINUE
C
C normalize and enforce positivity
C
      SUM = 0.
      DO 50 I = 1,NUM
        IF(FLUX(I).LT.0.) FLUX(I) = 0.
        SUM = SUM+FLUX(I)
50    CONTINUE
      DO 60 I = 1,NUM
        FLUX(I) = FLUX(I)/SUM
60    CONTINUE
C
C------mean sky spectrum as scaling factor
C
      DO 90 I = 1,IX
        X(I) = 0.
        DO  70 J = IPAR(1),IPAR(2)
          X(I) = X(I)+IN(I,J)
70      CONTINUE
        DO 80 J = IPAR(3),IPAR(4)
          X(I) = X(I)+IN(I,J)
80      CONTINUE
90    CONTINUE
C
C the case of ORDER = 0 is treated seperately
C
      IF (ORDER.LE.0) THEN
        SUM = 0
        DO 100 J = 1,NUM
          SUM = SUM+FLUX(J)
100     CONTINUE
        SUM = SUM/NUM
        DO 120 J =  1,IY
          DO 110 I = 1,IX
            SKY(I,J) = SUM*X(I)
110       CONTINUE
120     CONTINUE
      ELSE
C
C fit polynomial and scale it for all rows in the column
C
        CALL LSORTH(Y,FLUX,A,B,S,W,NUM,CHISQ,ORDER)
        DO 140 J =  1,IY
          YY = J
          CALL POLY(YY,FLUX(J),A,B,S,W,ORDER)
          DO 130 I = 1,IX
            SKY(I,J) = FLUX(J)*X(I)
130       CONTINUE
140     CONTINUE
      ENDIF
C
      RETURN
      END
C
C******************************************************************************
C SECOND VERSION: FIT AN INDEPENDENT POLYNOMIAL FOR EVERY COLUMN
C
      SUBROUTINE FITPL2(IX,IY,IN,SKY,Y,FLUX,X,IPAR,RPAR)
C
      IMPLICIT NONE
      INTEGER         IPAR(10),I,N,J,NUM,ORDER,IX,IY
      INTEGER         NS,COSMIC(4000),RADIUS
      REAL            IN(IX,IY),SKY(IX,IY),RPAR(3)
      REAL            A(10),B(10),S(10),W(10)
      REAL            X(1),Y(1),FLUX(1),YY,CHISQ,SUM
      REAL            WDT(4000),WDTY(4000)
      REAL            GAIN,RON,THRESHOLD
C

      ORDER = IPAR(5)
      RADIUS = IPAR(7)
      NUM = IPAR(2)-IPAR(1)+IPAR(4)-IPAR(3)+2
      GAIN = RPAR(1)
      RON = RPAR(2)
      THRESHOLD = RPAR(3)

C
C-------COLLECT SKY VALUES
C
      DO 60 I=1,IX
        N = 0
        NS = 0

          DO 10 J=IPAR(1),IPAR(2)
            N = N+1
            WDT(N) = IN(I,J)
            WDTY(N) = J
10        CONTINUE
          CALL FCOSMIC(WDT,WDTY,COSMIC,N,GAIN,RON,THRESHOLD,RADIUS)
          DO 12 J=RADIUS+1,N-RADIUS
            IF (COSMIC(J) .EQ. 0) THEN
               NS = NS+1
               FLUX(NS) = WDT(J)
               Y(NS) = WDTY(J)
            ENDIF
 12      CONTINUE

         N=0
         DO 20  J=IPAR(3),IPAR(4)
            N = N+1
            WDT(N)=IN(I,J)
            WDTY(N) = J
 20      CONTINUE
         CALL FCOSMIC(WDT,WDTY,COSMIC,N,GAIN,RON,THRESHOLD,RADIUS)
         DO 22 J=RADIUS+1,N-RADIUS
            IF (COSMIC(J) .EQ. 0) THEN
               NS = NS+1
               FLUX(NS) = WDT(J)
               Y(NS) = WDTY(J)
            ENDIF
 22      CONTINUE
         NUM = NS
C
C the case of ORDER = 0 is treated seperately
C
          IF (ORDER.LE.0) THEN
            SUM = 0
            DO 30 J = 1,NUM
              SUM = SUM+FLUX(J)
30          CONTINUE
            SUM = SUM/NUM
            DO 40 J = 1,IY
              SKY(I,J) = SUM
40          CONTINUE
          ELSE
C
C fit polynomial and evaluate it for all rows in the column
C
            CALL LSORTH(Y,FLUX,A,B,S,W,NUM,CHISQ,ORDER)
            DO 50  J = 1,IY
              YY = J
              CALL POLY(YY,SKY(I,J),A,B,S,W,ORDER)
50          CONTINUE
          ENDIF
60      CONTINUE
C
        RETURN
        END
C
C*****************************************************************************
C        POLY :  EVALUATES A POLYNOMIAL AT A POSITION XFIT
C       INPUT:  XFIT AND POLYNOMIAL COEFFICIENTS COMPUTED WITH LSORTH
C
C       OUTPUT: YFIT
C                                                                      
        SUBROUTINE POLY(XFIT,YFIT,A,B,S,W,IORD)  
C
        IMPLICIT NONE
        INTEGER           K,IORD
        REAL              A(10),B(10),S(10),W(10),P(10) 
        REAL              XFIT,YFIT
C   
        P(1)=1.  
        YFIT=S(1) 
C     
        P(2)=XFIT-A(1)   
        YFIT=YFIT+S(2)*P(2) 
C  
        DO 10 K=3,IORD+1   
        P(K)=(XFIT-A(K-1))*(P(K-1))-B(K-1)*P(K-2)
        YFIT=YFIT+S(K)*P(K)   
10        CONTINUE   
        RETURN     
        END 
C
C***************************************************************************   
C        LSORTH : FITS ORTHOGONAL POLYNOMIAL OF MAXIMUM DEGREE IORD
C                 THROUGH X-Y TABLE. AN F-TEST DECIDES WHETHER THE FIT
C                 STOPS ALREADY AT A LOWER ORDER THAN IORD.
C       INPUT:   THE ARRAYS X AND Y OF SIZE M CONTAIN THE VARIABLES.
C                THE ARRAY Y IS RETURNED AS A VECTOR WITH THE RESIDUALS.
C                 THE ROUTINE IS DESCRIBED IN PASP 91 (1979), PG. 546.    
C 
C       OUTPUT:  THE POLYNOMIAL COEFFICIENTS AND CHISQ ARE RETURNED 
C
        SUBROUTINE LSORTH (X,Y,A,B,S,W,M,CHISQ,IORD)
C
        IMPLICIT  NONE
        INTEGER      IMAX,IMAXST,IFAUTO,IORD,I,N,M,I1,IFF,K,K1
        INTEGER      IFTEST
        REAL         X(1),Y(1),A(10),B(10),S(10),W(10),P(10)
        REAL         CHISQ,DEL,XNU,F,F95,DCHI,P2
C
        DATA IMAXST/10/,IFTEST/2/ 
        IMAX=IMAXST     
        IFAUTO=0   
        IF(IORD .LT. 10) GOTO 110
        IORD=9
        IFAUTO=1
110     CONTINUE 
        IF(IORD .NE. 0) IMAX=MAX0(IABS(IORD)+1,2) 
        DO 10 I=1,IMAXST
          W(I)=0. 
          S(I)=0. 
          A(I)=0. 
10        B(I)=0.
        P(1)=1.
        DO 20 N=1,M
          W(1)=W(1)+1.   
          S(1)=S(1)+Y(N)  
20        A(1)=A(1)+X(N)
        S(1)=S(1)/W(1)
        A(1)=A(1)/W(1)    
        I=1   
        XNU=M-1
30      IFF=1  
40      I1=I   
        IF(IMAX .GT. I) I = I+1    
        CHISQ=0.  
        DO 70 N=1,M    
          P(2)=X(N)-A(1)    
          IF(I .EQ. 2) GOTO 60 
          DO 50 K=3,I
            K1=K-1    
50          P(K)=(X(N)-A(K1))*P(K1)-B(K1)*P(K-2)  
60        DEL=Y(N)-S(I1)*P(I1)   
          Y(N)=DEL  
          CHISQ=CHISQ+DEL*DEL 
          IF(IMAX .LE. I1) GOTO 70  
          P2=P(I)**2
          S(I)=S(I)+DEL*P(I)                                                     
          A(I)=A(I)+X(N)*P2  
          W(I)=W(I)+P2    
70      CONTINUE       
        IF(IMAX .LE. I1) GOTO 80  
        A(I)=A(I)/W(I)  
        B(I)=W(I)/W(I1)  
        S(I)=S(I)/W(I)      
        XNU=XNU-1.     
        DCHI=S(I)**2*W(I)  
        IF(DCHI .GE. CHISQ) GOTO 30   
        F=XNU*DCHI/(CHISQ-DCHI)   
        F95=3.84+(10.+(12.+(30.+105./XNU/XNU)/XNU)/XNU)/XNU    
        IF(F .GT. F95) GOTO 30  
        IF(IFAUTO.EQ.0) GOTO 30  ! F-TEST OFF
        XNU=XNU+1.   
        IFF=IFF+1      
        S(I)=0.   
        IF(IFF .LE. IFTEST) GOTO 40  
80      IORD=MIN0(IMAX-1,I1)-IFF+1
        RETURN 
        END




C
C**********************************************************************
C      FCOSMIC: SEARCH FOR COSMICS DEFINED AS PIXELS WHOSE VALUES ARE 
C               THRESHOLD TIMES THE STANDARD DEVIATION ABOVE THE MEDIAN 
C               AVERAGE ON PIXELS WITHIN RADIUS (TAKING INTO ACCOUNT 
C               THE RON AND THE CONVERSION FACTOR) 
C
C       INPUT:  ARRAYS WDT (VALUES), WDTY (POSITIONS), N (NUMBER OF VALUES)
C               RON, CONVERSION FACTOR, THRESHOLD, RADIUS
C
C       OUTPUT: COSMIC = INTEGER ARRAY WITH SUSPECTED COSMIC = 1

        SUBROUTINE FCOSMIC(WDT,WDTY,COSMIC,N,GAIN,RON,THRESHOLD,RADIUS)


        INTEGER N, RADIUS, COSMIC(1),I,IS,IE,K,NC,J
C
        REAL WDT(1),WDTY(1),GAIN,RON,THRESHOLD,RONSQ
        REAL AVR,DIFF,ARR(4000),AA,VAL,SGA
C

        RONSQ = RON*RON
C
        DO 10 I = 1,N 
           COSMIC(I) = 0
 10     CONTINUE

        DO 20 I=RADIUS+1,N-RADIUS

           AVR = 0
           DIFF = 0

           IS = I-RADIUS
           IE = I+RADIUS

           NC = 0

           DO 30 K = IS,IE
              IF (K .NE. I ) THEN 
                 NC = NC+1
                 ARR(NC) = WDT(K)
              ENDIF
 30        CONTINUE

           DO 40 K = 2,NC
              AA = ARR(K)
              DO 45 J=K-1,1,-1
                 IF (ARR(J) .LE. AA ) GO TO 90
                 ARR(J+1) = ARR(J)
 45           CONTINUE
              J = 0
 90           ARR(J+1) = AA
 40        CONTINUE

           AVR = ARR(RADIUS)
           SGA = AVR/GAIN+RONSQ

           DIFF = WDT(I)-AVR
           IF (SGA.GT.0.) THEN
               VAL = THRESHOLD*SQRT(SGA)
           ELSE
               VAL = 0.
           ENDIF

           IF (ABS(DIFF) .GT. VAL) COSMIC(I) = 1

 20     CONTINUE


        RETURN

        END

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM ATREF
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION: program ATREF
C.PURPOSE: Compensation for atmospheric refraction effects by modification
C          of the nominal "OPTOPUS" starplate (X,Y) coordinate values.
C.AUTHOR: A. Gemmo       Padova Department of Astronomy
C.VERSION: 860414 G. Lund, P. Angebault   Version n.10 for HP machine.
C          910412 A. Gemmo                Version running in MIDAS env.
C          910603 A. Gemmo                Version for OPTOPUS context.
C          910906 A. Gemmo                Modified to use TBLSER routine.
C 
C 100616	last modif
C-------------------------------------------------------------------------------
      IMPLICIT NONE
C
C ***
C
      INTEGER 	        MADRID(1)
      INTEGER		NRINP
      INTEGER		NCINP
      INTEGER		NROUT
      INTEGER		NCOUT
      INTEGER		NCPAR
      INTEGER		NCOL
      PARAMETER	        (NCINP=6)
      PARAMETER	        (NCOUT=6)
      PARAMETER	        (NCPAR=3)
      PARAMETER	        (NROUT=300)
      INTEGER		ISTAT,IAC,IAV
      INTEGER		KUN,KNUL
      INTEGER		NACINP,NARINP,NSINP
      INTEGER		OUTTYP,OUTCOL(10),COLNUM(10)
      INTEGER		TIDINP
      INTEGER		TIDOUT
      INTEGER		I1,I2,I3,I4,I5,I6,I7,I8,I9,J
      INTEGER		IMONTH,IMON1
      INTEGER		IO,ITIME
      INTEGER		INTD,ITST,ITEN,ID,IE,ID1,IE1
      INTEGER		IWAVL
      INTEGER		IEXPTI,IRANGE,ILAM1,ILAM2
      INTEGER		ISTSTH,ISTSTM,ISTENH,ISTENM
      INTEGER		IUTSTH,IUTSTM,IUTENH,IUTENM
      INTEGER		IBETST,IBETEN
      INTEGER           DUN,STAT
C
C ***
C
      DOUBLE PRECISION		X(NROUT),Y(NROUT),Z(NROUT)
      DOUBLE PRECISION		PI
      DOUBLE PRECISION		CRA,CDEC,CRARAD,CDECRA
      DOUBLE PRECISION          DATE
      DOUBLE PRECISION		ST1(12),ST2(12)
      DOUBLE PRECISION		SSLOT,ESLOT,ST,SST 
      DOUBLE PRECISION  	AHS,AHE
      DOUBLE PRECISION		TESS,TESE
      DOUBLE PRECISION		ERINT,SERR
      DOUBLE PRECISION		AH(NROUT),COZ(NROUT),ZZ(NROUT),ERR(NROUT)
      DOUBLE PRECISION		ZIN(3),ZOS(3)
      DOUBLE PRECISION		OBLAT,ZIPHI,TAPHI,A(3),BET(3),ABET(3),SIG
      DOUBLE PRECISION  	ZIO,AHIO,SS,TIME,TTIME,BETA2
      DOUBLE PRECISION		EXPTI,EXPTI1,SEXPT,SEX,EXPST,EXPEN
      DOUBLE PRECISION		STSTH,STENH,STSTM,STENM,D,EXSTUT,EXENUT
      DOUBLE PRECISION		UTSTH,UTENH,UTSTM,UTENM
      DOUBLE PRECISION  	EXST,EXEN,ZOST,ZOEN,ZIST,ZIEN
      DOUBLE PRECISION  	ABETST,ABETEN,TEST,BETST,BETEN,RANGE
      DOUBLE PRECISION		LAMBD1,LAMBD2,LA1(22),LA2(22)
      DOUBLE PRECISION		CHINT,CHINA,FRAC,CHERR,CORRX,CORRY
      DOUBLE PRECISION		DX(NROUT),DY(NROUT),XO(NROUT),YO(NROUT)
      DOUBLE PRECISION  	STD,STF,WAVL
      DOUBLE PRECISION		YEAR,MONTH,DAY,EPP
C
C ***
C
      CHARACTER*80 	STRING(20)
      CHARACTER*60	INPFIL
      CHARACTER*60	OUTFIL
      CHARACTER*16	LABEL(NCPAR),OUTLAB
      CHARACTER*16	UNIT(NCPAR),OUTUNI
      CHARACTER*16	OUTFOR
      CHARACTER*16	FORMC16,FORMC1,FORMR8,FORMI4
      CHARACTER*16	IDENT(NROUT)
      CHARACTER*1	TYPE(NROUT)
      CHARACTER*1       CHECK(NROUT)
      CHARACTER*1       ASTFLA
      CHARACTER      CTEST*16
C
C ***
C      
      INCLUDE		'MID_INCLUDE:ST_DEF.INC'
      COMMON		/VMR/ MADRID
      INCLUDE		'MID_INCLUDE:ST_DAT.INC'
C
C ***
C
      DATA		LABEL/'X       ','Y       ','Z       '/
      DATA		UNIT /'MICRONS ','MICRONS ','MICRONS '/
C
C ***
C
      DATA		FORMC16/'A16'/
      DATA		FORMC1 /'A1' /
      DATA		FORMR8 /'F7.0'/
      DATA		FORMI4 /'I3'/
      DATA		PI/3.14159265358979D0/
C
C *** sidereal time data
C
      DATA ST1/3.46,5.19,6.51,7.93,9.36,11.29,
     2          13.32,14.44,17.69,19.83,22.17,25.12/
      DATA ST2/10.27,12.92,15.05,17.39,19.63,21.76,24.0,
     2          26.14,27.66,28.88,30.1,31.83/
C
C *** wavelength data
C
      DATA LA1/3800.,4000.,4200.,4400.,4600.,4800.,5000.,
     2          5200.,5400.,5600.,5800.,6000.,6200.,6400.,
     3          6600.,6800.,7000.,7200.,7400.,7600.,7800.,
     4          8000./
      DATA LA2/1.23,1.02,.83,.69,.58,.49,.4,.33,.26,.19,.14,
     2          .09,.05,.02,-.02,-.06,-.1,-.125,-.15,-.175,-.195,-.21/
C
C *** start the code
C
      CALL STSPRO('ATREF')
C
C *** get the input table and the output table
C
      CALL STKRDC('INPUTFI',1,1,60,IAC,INPFIL,KUN,KNUL,ISTAT)
      CALL STKRDC('OUTPUTF',1,1,60,IAC,OUTFIL,KUN,KNUL,ISTAT)
C
C *** open input table
C
      CALL TBTOPN(INPFIL,F_I_MODE,TIDINP,ISTAT)
C
C *** get information about input table
C
      CALL TBIGET(TIDINP,NCOL,NRINP,NSINP,NACINP,NARINP,ISTAT)
C
C *** create the output table
C
      CALL TBTINI(OUTFIL,0,F_O_MODE,NCOUT,NROUT,TIDOUT,ISTAT)
C
      OUTTYP = D_C_FORMAT     !initialize ident column
      OUTFOR = FORMC16
      OUTUNI = '        '
      OUTLAB = 'IDENT   '
      CALL TBCINI(TIDOUT,OUTTYP,16,OUTFOR,OUTUNI,
     2                     OUTLAB,OUTCOL(1),ISTAT)
C
      OUTTYP = D_C_FORMAT     !initialize type column
      OUTFOR = FORMC1
      OUTUNI = '        '
      OUTLAB = 'TYPE    '
      CALL TBCINI(TIDOUT,OUTTYP,1,OUTFOR,OUTUNI,
     2                     OUTLAB,OUTCOL(2),ISTAT)
C
      DO I1=1,NCPAR
         OUTTYP = D_R8_FORMAT  !initialize x y z columns
         OUTFOR = FORMR8
         OUTUNI = UNIT(I1)
         OUTLAB = LABEL(I1)
         CALL TBCINI(TIDOUT,OUTTYP,1,OUTFOR,OUTUNI,
     2                        OUTLAB,OUTCOL(2+I1),ISTAT)
        ENDDO
C
      OUTTYP = D_I4_FORMAT     !initialize number column
      OUTFOR = FORMI4
      OUTUNI = '        '
      OUTLAB = 'NUMBER  '
      CALL TBCINI(TIDOUT,OUTTYP,1,OUTFOR,OUTUNI,
     2                     OUTLAB,OUTCOL(6),ISTAT)
C
C *** read center coordinates
C
      CALL STKRDD('PLATEC1',1,1,IAV,CRA,KUN,KNUL,ISTAT)
      CALL STKRDD('PLATEC1',2,1,IAV,CDEC,KUN,KNUL,ISTAT)
C
C *** do the work
C
      IF(CDEC.LT.-89.9)THEN
        WRITE(STRING(2),922)
922     FORMAT('*** FATAL: DEC of center can`t be lower than -89.9 deg
     2rees!!')
        CALL STETER(9,STRING(2))
      ELSE IF(CDEC.GT.30.0)THEN
        WRITE(STRING(2),923)
923     FORMAT('*** FATAL: DEC of center can`t be higher than +30.0 de
     2grees!!')
        CALL STETER(9,STRING(2))
      ENDIF
C
C *** convert CRA and CDEC to radians
C
      CRARAD = CRA*1.5D1*(PI/1.8D2)
      CDECRA = CDEC*(PI/1.8D2)
C
C *** read year, month and day of the observation
C
      CALL STKRDD('DATE',1,1,IAV,YEAR,KUN,KNUL,ISTAT)
      CALL STKRDD('DATE',2,1,IAV,MONTH,KUN,KNUL,ISTAT)
      CALL STKRDD('DATE',3,1,IAV,DAY,KUN,KNUL,ISTAT)
C
      IF(YEAR.NE.0..AND.MONTH.EQ.0..AND.DAY.EQ.0.)THEN
       EPP = YEAR
       CALL DAYMON(EPP,YEAR,MONTH,DAY)
      ELSE IF(YEAR.NE.0..AND.MONTH.EQ.0..AND.DAY.NE.0.)THEN
       CALL STETER(9,
     2  '*** FATAL: MONTH can`t be 0 if date not in decimals of year!')
      ELSE IF(YEAR.NE.0..AND.MONTH.NE.0..AND.DAY.EQ.0.)THEN
       CALL STETER(9,
     2  '*** FATAL: DAY can`t be 0 if date not in decimals of year!')
      ENDIF
C
C *** determination of hours of darkness (ST)
C
      DATE   = MONTH+DAY/30.42
      IMONTH = INT(DATE)
      IF(IMONTH.EQ.12)THEN
        IMON1 = 1
        STD   = ST1(IMONTH)+(24.+ST1(IMON1)-ST1(IMONTH))*(DATE-IMONTH)
        STF   = ST2(IMONTH)+(24.+ST2(IMON1)-ST2(IMONTH))*(DATE-IMONTH)
      ELSE IF(IMONTH.NE.12)THEN
        IMON1 = IMONTH+1
        STD   = ST1(IMONTH)+(ST1(IMON1)-ST1(IMONTH))*(DATE-IMONTH)
        STF   = ST2(IMONTH)+(ST2(IMON1)-ST2(IMONTH))*(DATE-IMONTH)
      ENDIF
      IF(STD.GT.24.)STD=STD-24.
      IF(STF.GT.24.)STF=STF-24.
      WRITE(STRING(3),221)
221   FORMAT(1X,'   ')
      CALL STTPUT(STRING(3),ISTAT)
      WRITE(STRING(3),222)STD,STF
      CALL STTPUT(STRING(3),ISTAT)
      CALL STDWRD(TIDOUT,'NIGHT_BEG',STD,1,1,DUN,STAT)
      CALL STDWRD(TIDOUT,'NIGHT_END',STF,1,1,DUN,STAT)
C
C *** read earliest and latest ST at which the exposure could begin and end
C
      CALL STKRDD('STSLOT',1,1,IAV,SSLOT,KUN,KNUL,ISTAT)
      CALL STKRDD('STSLOT',2,1,IAV,ESLOT,KUN,KNUL,ISTAT)
C
C *** read exposure time
C
      CALL STKRDD('EXPTIME',1,1,IAV,EXPTI,KUN,KNUL,ISTAT)
C
      SS    = ESLOT-SSLOT
      IF(SS.LT.0.)SS=SS+24.
      EXPTI1 = EXPTI/60.
C
      IF((EXPTI1).GE.SS)CALL STETER
     1    (9,'*** FATAL: Exposure time can`t be > or = st_slot!')
C
C ***
C
      AHS = 15.*(SSLOT-CRA)	
      IF(AHS.GT.180.)THEN
        AHS = AHS-360.
      ELSE IF(AHS.LT.-180.)THEN
        AHS = 360.+AHS
      ENDIF
C
      AHE = 15.*(ESLOT-CRA)
      IF(AHE.GT.180.)THEN
        AHE = AHE-360.
      ELSE IF(AHE.LT.-180.)THEN
        AHE = 360.+AHE
      ENDIF
C
      TESS = DABS(AHS)
      TESE = DABS(AHE)
      IF(TESS.GE.70.)THEN
        WRITE(STRING(4),944)AHS
944     FORMAT('*** FATAL: START hour angle can`t be >+/-70 deg, and y   
     2ours is: ',F6.2,' deg')
        CALL STETER(9,STRING(4))
      ENDIF
      IF(TESE.GE.70.)THEN
        WRITE(STRING(4),945)AHE
945     FORMAT('*** FATAL: END hour angle can`t be >+/-70 deg, and you  
     2rs is: ',F6.2,' deg')
        CALL STETER(9,STRING(4))
      ENDIF
      IF(TESS.GT.60.)THEN
        WRITE(STRING(4),946)AHS
946     FORMAT('START hour angle is: ',F6.2,' deg, hence approaching t
     2elesc. limit = +/-70 deg')
        CALL STTPUT(STRING(4),ISTAT)
      ENDIF
      IF(TESE.GT.60.)THEN
        WRITE(STRING(4),947)AHE
947     FORMAT('END hour angle is: ',F6.2,' deg, hence approaching tel
     2esc. limit = +/-70 deg')
        CALL STTPUT(STRING(4),ISTAT)
      ENDIF
C
C *** 
C
      ERINT = 0.
      SERR  = 0.
      DO I2=1,NROUT
        AH(I2) = (AHS+(AHE-AHS)*(I2-1)/99.)*(PI/1.8D2)
        COZ(I2)= -.4886*DSIN(CDECRA)+(.8725*DCOS(CDECRA)*DCOS(AH(I2)))
        ZZ(I2) = DACOS(COZ(I2))
        ERR(I2)= 43.97*(DTAN(ZZ(I2)+.004363)-TAN(ZZ(I2)))
        ERINT  = ERINT+ERR(I2)
      ENDDO
C
C *** read ASTFLAG and ST values
C
      CALL STKRDC('ASTFLAG',1,1,1,IAV,ASTFLA,KUN,KNUL,ISTAT)
      CALL STKRDD('SIDTIME',1,1,IAV,ST,KUN,KNUL,ISTAT)
C
222   FORMAT(1X,' Darkness will begin at ST: ',F5.2,' and end at ST: ',
     2       F5.2)
510   FORMAT(1X,'   ')
553   FORMAT(1X,' Sidereal time for observation:                 ',F6.2)
554   FORMAT(1X,'   ')
555   FORMAT(1X,' Optimal observing time:                        ',F6.2)
556   FORMAT(1X,' Optimized observational hour angle in degrees: ',F6.2)
557   FORMAT(1X,' Corresponding distance from the zenith:        ',F6.2)
558   FORMAT(1X,' Maximum necessary correction (in arcsecs):     ',F6.2)
559   FORMAT(1X,' Direction of correction vectors on starplate:  ',F7.2)
560   FORMAT(1X,' (i.e. Perpendicular to the projection of the horizon')
561   FORMAT(1X,' on the starplate at the above determined hour angle)')
5551  FORMAT(1X,'   ')
C
671   FORMAT(1X,' Chosen length of observation:      ',I3,' minutes')
672   FORMAT(1X,' Approx. optimal obs. slot (ST):    ',I2,'h ',
     2       I2,'m to ',I2,'h ',I2,'m')
673   FORMAT(1X,' Corresponding obser. slot (UT):    ',I2,'h ',
     2       I2,'m to ',I2,'h ',I2,'m')
674   FORMAT(1X,' Corresp. range of corr. vectors:   From',I5,
     2       '  to',I5,' deg.')
675   FORMAT(1X,' WARNING!!! The needed correction vector varies')
676   FORMAT(1X,' STRONGLY in DIRECTION during your exposure ...')
677   FORMAT(1X,' i.e. by approximately ',I3,' degrees.         ')
678   FORMAT(1X,' BE CAREFUL TO RESPECT THE OPTIMAL OBSERVATION TIME')
679   FORMAT(1X,' SLOT GIVEN ABOVE, WHEN OBSERVING AT THE TELESCOPE')
C
6661  FORMAT(1X,'   ')
6662  FORMAT(1X,'   ')
6664  FORMAT(1X,'   ')
C
777   FORMAT(1X,' Wavelength range for optimisation: ',I4,' to ',
     2  I4,' angstroms')
778   FORMAT(1X,' Optimal correction at wavelength:  ',I4,' Angstroms'
     2)
779   FORMAT(1X,' Chromatic correction needed in X:  ',F5.0,
     2' microns ')
780   FORMAT(1X,' Chromatic correction needed in Y:  ',F5.0,
     2' microns ')
C
      CALL STTPUT(STRING(6),ISTAT)
      IF(ASTFLA.EQ.'N'.OR.ASTFLA.EQ.'n')THEN
       IF(ST.GE.SSLOT.AND.ST.LE.ESLOT)THEN
        SST   = ST-SSLOT
        IF(SST.LT.0.)SST=SST+24.
        ITIME = INT((SST/SS)*99.+1.)  
        IO    = ITIME
        WRITE(STRING(5),510)
        CALL STTPUT(STRING(5),ISTAT)
        WRITE(STRING(5),553)ST
        CALL STTPUT(STRING(5),ISTAT)
        CALL STDWRD(TIDOUT,'OPT_SID_TIME',ST,1,1,DUN,STAT)
       ELSE
        CALL STETER(9,'*** FATAL: Opt_st must be inside st_slot !!')
       ENDIF
      ELSE IF(ASTFLA.EQ.'Y'.OR.ASTFLA.EQ.'y')THEN
C
C
C *** Calculation of the "optimal" observing time, for which the integral
C *** differential error will be the same for both of the intervals, i.e.
C *** from earliest start to "opt. time", and from "opt. time" to latest
C *** termination.
C
C
C
      DO I3=1,NROUT
        SERR   = SERR+(2.*ERR(I3))
        IF(SERR.LE.ERINT)THEN
             GOTO 444
        ELSE IF(SERR.GT.ERINT)THEN
             IO = I3-1
           GOTO 445
        ENDIF
444   ENDDO
C
      IO = 50	

445   TIME  = SSLOT+IO*((SS)/99.)
      TTIME = TIME
      IF(TIME.GE.24.)TTIME = TIME-24.
      ST = TTIME
      SST   = TTIME-SSLOT
      IF(SST.LT.0.)SST=SST+24.
C
      WRITE(STRING(5),554)
      CALL STTPUT(STRING(5),ISTAT)
      WRITE(STRING(5),555)TTIME
      CALL STTPUT(STRING(5),ISTAT)
      WRITE(STRING(5),5551)
      CALL STTPUT(STRING(5),ISTAT) 
C
      CALL STDWRD(TIDOUT,'OPT_SID_TIME',TTIME,1,1,DUN,STAT)
      ENDIF
C
C *** According to "optimised" time (related to 'IO'), determine the 
C *** corresponding hour angle, zenith distance, maximum differential 
C *** error (at plate edge), and correction direction - given by the
C *** perpendicular (away from the zenith) of the projection of the 
C *** horizon onto the starplate.
C
      ZIN(1) = DSIN(ZZ(1))
      ZIN(2) = DSIN(ZZ(IO))
      ZIN(3) = DSIN(ZZ(NROUT))
      ZOS(1) = DCOS(ZZ(1))
      ZOS(2) = DCOS(ZZ(IO))
      ZOS(3) = DCOS(ZZ(NROUT))
C
      OBLAT = -29.25*PI/1.8D2
      ZIPHI = DSIN(OBLAT)
      TAPHI = DTAN(OBLAT)
C
      A(1)  = AH(1)
      A(2)  = AH(IO)
      A(3)  = AH(NROUT)
C
      DO I4=1,3
        IF(ZIN(I4).EQ.0.)THEN
            BET(I4)=0.
        ELSE IF(ZIN(I4).NE.0.)THEN
            ABET(I4) = (.4886+DSIN(CDECRA)*ZOS(I4))/
     2                 (DCOS(CDECRA)*ZIN(I4))
          SIG=1.
          IF(A(I4).LT.0.)SIG=-1.
          BET(I4) = SIG*DACOS(ABET(I4))
        ENDIF
      ENDDO
C
      ZIO   = ZZ(IO)/(PI/1.8D2)
      AHIO  = AH(IO)/(PI/1.8D2)
      BETA2 = BET(2)/(PI/1.8D2)
C
      WRITE(STRING(5),556)AHIO
      CALL STTPUT(STRING(5),ISTAT)
      CALL STDWRD(TIDOUT,'HOUR_ANGLE',AHIO,1,1,DUN,STAT)
      WRITE(STRING(5),557)ZIO
      CALL STTPUT(STRING(5),ISTAT)
      CALL STDWRD(TIDOUT,'ZENITH_DIST',ZIO,1,1,DUN,STAT)
      WRITE(STRING(5),558)ERR(IO)
      CALL STTPUT(STRING(5),ISTAT)
      CALL STDWRD(TIDOUT,'MAX_CORR',ERR(IO),1,1,DUN,STAT)
      WRITE(STRING(5),559)BETA2
      CALL STTPUT(STRING(5),ISTAT)
      CALL STDWRD(TIDOUT,'CORR_VECT_DIR',BETA2,1,1,DUN,STAT)
      WRITE(STRING(5),560)
      CALL STTPUT(STRING(5),ISTAT)
      WRITE(STRING(5),561)
      CALL STTPUT(STRING(5),ISTAT) 
C
C *** determine the approximate optimal observation slot, in ST and UT,
C *** according to the expected exposure length at the telescope.
C
      SEXPT = EXPTI/60.
      SEX   = SEXPT*SST/SS
      EXPST = ST-SEX
      IF(EXPST.LE.0.)EXPST = EXPST+24.
      EXPEN = EXPST+SEXPT
      IF(EXPEN.GT.24.)EXPEN = EXPEN-24.
      STSTH = INT(EXPST)
      STENH = INT(EXPEN)
      STSTM = INT(60.*(EXPST-STSTH))
      STENM = INT(60.*(EXPEN-STENH))
      D     = ((MONTH-1.)*30.42)+DAY-264.
      IF(D.LT.0.)D=D+365.
      INTD  = INT(D)
      EXSTUT=EXPST-0.06575*D+4.7156
      EXENUT=EXPEN-0.06575*D+4.7156
      IF(EXSTUT.LE.0.)EXSTUT=EXSTUT+24.
      IF(EXENUT.LE.0.)EXENUT=EXENUT+24.
      UTSTH = INT(EXSTUT)
      UTENH = INT(EXENUT)
      UTSTM = INT(60.*(EXSTUT-UTSTH))
      UTENM = INT(60.*(EXENUT-UTENH))
C
C *** calculation of corresponding range of correction vector angles
C
      EXST  = SST-SEX
      IF(EXST.LE.0.)EXST=EXST+24.
      EXEN  = EXST+SEXPT
      IF(EXEN.GT.24.)EXEN=EXEN-24.
      ITST  = INT((EXST/SS)*99.)+1.
      ITEN  = INT((EXEN/SS)*99.)+1.
      ZOST  = DCOS(ZZ(ITST))
      ZOEN  = DCOS(ZZ(ITEN))
      ZIST  = DSIN(ZZ(ITST))
      ZIEN  = DSIN(ZZ(ITEN))
      ABETST= (.4886+DSIN(CDECRA)*ZOST)/(DCOS(CDECRA)*ZIST)
      ABETEN= (.4886+DSIN(CDECRA)*ZOEN)/(DCOS(CDECRA)*ZIEN)
      SIG   = 1.
      TEST  = AH(ITST)
      IF(TEST.LT.0.)SIG=-1.
      BETST = (SIG/(PI/1.8D2))*DACOS(ABETST)
      SIG   = 1.
      TEST  = AH(ITEN)
      IF(TEST.LT.0.)SIG=-1.
      BETEN = (SIG/(PI/1.8D2))*DACOS(ABETEN)
      RANGE = DABS(BETEN-BETST)
C
C *** print out the results
C
      WRITE(STRING(6),6661)
      CALL STTPUT(STRING(6),ISTAT)
      IEXPTI = EXPTI
      WRITE(STRING(6),671)IEXPTI
      CALL STTPUT(STRING(6),ISTAT)
      CALL STDWRD(TIDOUT,'EXPTIME',EXPTI,1,1,DUN,STAT)
      ISTSTH = INT(STSTH)
      ISTSTM = INT(STSTM)
      ISTENH = INT(STENH)
      ISTENM = INT(STENM)
      WRITE(STRING(6),672)ISTSTH,ISTSTM,ISTENH,ISTENM
      CALL STTPUT(STRING(6),ISTAT)
      CALL STDWRD(TIDOUT,'STSLOT',EXPST,1,1,DUN,STAT)
      CALL STDWRD(TIDOUT,'STSLOT',EXPEN,2,1,DUN,STAT)
      IUTSTH = INT(UTSTH)
      IUTSTM = INT(UTSTM)
      IUTENH = INT(UTENH)
      IUTENM = INT(UTENM)
      WRITE(STRING(6),673)IUTSTH,IUTSTM,IUTENH,IUTENM
      CALL STTPUT(STRING(6),ISTAT)
      CALL STDWRD(TIDOUT,'UTSLOT',EXSTUT,1,1,DUN,STAT)
      CALL STDWRD(TIDOUT,'UTSLOT',EXENUT,2,1,DUN,STAT)
      IBETST = INT(BETST)
      IBETEN = INT(BETEN)
      WRITE(STRING(6),674)IBETST,IBETEN
      CALL STDWRD(TIDOUT,'RANGE_CORR_VECT',BETST,1,1,DUN,STAT)
      CALL STDWRD(TIDOUT,'RANGE_CORR_VECT',BETEN,2,1,DUN,STAT)
      WRITE(STRING(6),6662)
      CALL STTPUT(STRING(6),ISTAT)
C
      IF(RANGE.GT.75.)THEN
        WRITE(STRING(6),675)
        CALL STTPUT(STRING(6),ISTAT)
        WRITE(STRING(6),676)
        CALL STTPUT(STRING(6),ISTAT)
        IRANGE = INT(RANGE)
        WRITE(STRING(6),677)IRANGE
        CALL STTPUT(STRING(6),ISTAT)
        WRITE(STRING(6),678)
        CALL STTPUT(STRING(6),ISTAT)
        WRITE(STRING(6),679)
        CALL STTPUT(STRING(6),ISTAT)
        WRITE(STRING(6),6664)
        CALL STTPUT(STRING(6),ISTAT)
      ENDIF
C
C *** calculation of the optimal wavelength for correction of the chromatic
C *** dependancy of differential refraction
C
      CALL STKRDD('LAMBDA',1,1,IAV,LAMBD1,KUN,KNUL,ISTAT)
      CALL STKRDD('LAMBDA',2,1,IAV,LAMBD2,KUN,KNUL,ISTAT)
C
      ILAM1 = INT(LAMBD1)
      ILAM2 = INT(LAMBD2)
      WRITE(STRING(7),777)ILAM1,ILAM2
      CALL STTPUT(STRING(7),ISTAT)
      CALL STDWRD(TIDOUT,'LAMBDA',LAMBD1,1,1,DUN,STAT)
      CALL STDWRD(TIDOUT,'LAMBDA',LAMBD2,2,1,DUN,STAT)
      IF(LAMBD1.LT.3800.)LAMBD1=3800.
      IF(LAMBD2.GT.8000.)LAMBD2=8000.
      ID    = INT((LAMBD1-3800.)*21./4200.+1.)
      IE    = INT((LAMBD2-3800.)*21./4200.+1.)
      IF(ID.LE.0) ID=1
      IF(IE.GT.22)IE=22
      ID1   = ID+1
      IE1   = IE-1
      CHINT = 0.5*(LA2(ID)+LA2(IE))
      CHINA = LA2(ID)
C      	
      DO I5=ID1,IE1
         CHINT = CHINT+LA2(I5)
      ENDDO
C
      DO I6=ID1,IE
         CHINA = CHINA+2.*LA2(I6)
         TEST  = CHINA-LA2(I6)
         IF(TEST.GE.CHINT)GOTO 1613
      ENDDO
C
1613      J     = I6-1
      FRAC  = (CHINT+LA2(I6)+LA2(J)-TEST)/(LA2(I6)+LA2(J))
      CHERR = LA2(J)+FRAC*(LA2(I6)-LA2(J))
      IWAVL = INT(LA1(J)+FRAC*200.)
      WAVL  = DBLE(IWAVL)
C
C *** calculate the corresponding correction of guidestar coordinates
C *** needed to compensate for the shift at the optimised wavelength
C
      CORRX = 140.06*CHERR*DSIN(BET(2))*DTAN(ZZ(IO))
      CORRY = 140.06*CHERR*DCOS(BET(2))*DTAN(ZZ(IO))
C
      WRITE(STRING(7),778)IWAVL
      CALL STTPUT(STRING(7),ISTAT)
      CALL STDWRD(TIDOUT,'OPT_WAVEL',WAVL,1,1,DUN,STAT)
      WRITE(STRING(7),779)CORRX
      CALL STTPUT(STRING(7),ISTAT)
      CALL STDWRD(TIDOUT,'CORR_X',CORRX,1,1,DUN,STAT)
      WRITE(STRING(7),780)CORRY
      CALL STTPUT(STRING(7),ISTAT)
      CALL STDWRD(TIDOUT,'CORR_Y',CORRY,1,1,DUN,STAT)
C
C *** read input table elements
C
         CALL TBLSER(TIDINP,'IDENT',COLNUM(1),ISTAT)
         CALL TBLSER(TIDINP,'TYPE',COLNUM(2),ISTAT)
         CALL TBLSER(TIDINP,'CHECK',COLNUM(3),ISTAT)
         CALL TBLSER(TIDINP,'X',COLNUM(4),ISTAT)
         CALL TBLSER(TIDINP,'Y',COLNUM(5),ISTAT)
         CALL TBLSER(TIDINP,'Z',COLNUM(6),ISTAT)
C
      DO I7=1,NRINP
         CALL TBERDC(TIDINP,I7,COLNUM(1),CTEST,KNUL,ISTAT)
         CALL FT_EOS(CTEST,16,IDENT(I7),ISTAT)
         CALL TBERDC(TIDINP,I7,COLNUM(2),CTEST,KNUL,ISTAT)
         TYPE(I7) = CTEST(1:1)
         CALL TBERDC(TIDINP,I7,COLNUM(3),CTEST,KNUL,ISTAT)
         CHECK(I7) = CTEST(1:1)
         CALL TBERDD(TIDINP,I7,COLNUM(4),X(I7),KNUL,ISTAT)
         CALL TBERDD(TIDINP,I7,COLNUM(5),Y(I7),KNUL,ISTAT)
         CALL TBERDD(TIDINP,I7,COLNUM(6),Z(I7),KNUL,ISTAT)
       ENDDO
C
C *** application of the corrections to the input file:
C *** (1) add the differential corrections to all the coordinates;
C *** (2) add the chromatic corrections to the guidestar coordinates.
C
      DO I8=1,NRINP
         DX(I8) = -1.111D-3*ERR(IO)*(DSIN(BET(2))**2)*
     2                             (X(I8)+Y(I8)/DTAN(BET(2)))
         DY(I8) = -1.111D-3*ERR(IO)*(DCOS(BET(2))**2)*
     2                             (Y(I8)+X(I8)*DTAN(BET(2)))
         XO(I8) = X(I8)+DX(I8)
         YO(I8) = Y(I8)+DY(I8)
C
         IF(TYPE(I8).NE.'O')THEN
           DX(I8) = DX(I8)+CORRX
           DY(I8) = DY(I8)+CORRY
           XO(I8) = XO(I8)+CORRX
           YO(I8) = YO(I8)+CORRY
         ENDIF
      ENDDO   
C
C *** fill in the output table
C
      DO I9=1,NRINP
         CALL TBEWRC(TIDOUT,I9,OUTCOL(1),IDENT(I9),ISTAT)
         CALL TBEWRC(TIDOUT,I9,OUTCOL(2),TYPE(I9),ISTAT)
         CALL TBEWRD(TIDOUT,I9,OUTCOL(3),XO(I9),ISTAT)
         CALL TBEWRD(TIDOUT,I9,OUTCOL(4),YO(I9),ISTAT)
         CALL TBEWRD(TIDOUT,I9,OUTCOL(5),Z(I9),ISTAT)
         CALL TBEWRI(TIDOUT,I9,OUTCOL(6),I9,ISTAT)
      ENDDO
C
C *** initialize row selection flag
C
      CALL TBSINI(TIDOUT,ISTAT)
C
C *** close the table
C
      CALL TBTCLO(TIDOUT,ISTAT)
C
C *** over and out
C
      CALL STSEPI
      END
C-------------------------------------------------------------------------------
      SUBROUTINE DAYMON(EPP,YEAR,MONTH,DAY)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.PURPOSE: Calculate year, month and day from epoch.
C.AUTHOR: Alessandra Gemmo       Padova Department of Astronomy
C.VERSION: 910906 AG Creation
C.------------------------------------------------------------------------------
      IMPLICIT NONE
C
C ***
C
      DOUBLE PRECISION     YEAR,MONTH,DAY
      DOUBLE PRECISION     DAY1
      DOUBLE PRECISION     EPP,NDAYS
      DOUBLE PRECISION     RES0,RES1
C
C ***
C
      DATA                 NDAYS/365./
C
C *** determine year
C
      YEAR = INT(EPP)
C
C *** determine month and day
C
      RES0 = DMOD(YEAR,4.0D0)
      RES1 = DMOD(YEAR,4.0D2)
      IF(RES0.EQ.0..AND.RES1.NE.0.)NDAYS = 366.
C
      DAY1 = (EPP - YEAR)*NDAYS
C
      IF(DAY1.GT.0..AND.DAY1.LE.31.)THEN
       MONTH = 1.
       DAY = DAY1 - 0.
      ELSE IF(DAY1.GT.31..AND.DAY1.LE.59.)THEN
       MONTH = 2. 
       DAY = DAY1 - 31.
      ELSE IF(DAY1.GT.59..AND.DAY1.LE.90.)THEN
       MONTH = 3.
       DAY = DAY1 - 59.
      ELSE IF(DAY1.GT.90..AND.DAY1.LE.120.)THEN
       MONTH = 4.
       DAY = DAY1 - 90.
      ELSE IF(DAY1.GT.120..AND.DAY1.LE.151.)THEN
       MONTH = 5.
       DAY = DAY1 - 120.
      ELSE IF(DAY1.GT.151..AND.DAY1.LE.181.)THEN
       MONTH = 6.
       DAY = DAY1 - 151.
      ELSE IF(DAY1.GT.181..AND.DAY1.LE.212.)THEN
       MONTH = 7.
       DAY = DAY1 - 181.
      ELSE IF(DAY1.GT.212..AND.DAY1.LE.243.)THEN
       MONTH = 8.
       DAY = DAY1 - 212.
      ELSE IF(DAY1.GT.243..AND.DAY1.LE.273.)THEN
       MONTH = 9.
       DAY = DAY1 - 243.
      ELSE IF(DAY1.GT.273..AND.DAY1.LE.304.)THEN
       MONTH = 10.
       DAY = DAY1 - 273.
      ELSE IF(DAY1.GT.304..AND.DAY1.LE.334.)THEN
       MONTH = 11.
       DAY = DAY1 - 304.
      ELSE IF(DAY1.GT.334..AND.DAY1.LE.366.)THEN
       MONTH = 12.
       DAY = DAY1 - 334.
      ENDIF
C
      RETURN
      END
C-------------------------------------------------------------------------------

C @(#)tsadel.for	19.1 (ESO-DMD) 02/25/03 13:33:25
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT (c) 1992 European Southern Observatory & Copernicus Astron. Center
C.IDENT     tsadel.for
C.AUTHOR    Alex Schwarzenberg-Czerny, Copernicus Astron. Center, Warsaw
C.KEYWORD   MIDAS, time analysis, DELAY/TIME

C.LANGUAGE  FORTRAN 77
C.PURPOSE   Compute chi2-time lag function
C           Reference:  ApJ 385, 404
C.RETURNS   None
C.ENVIRON   TSA context
C.VERSION   0.0               June 1992
C 
C 021031	last modif
C 
C-----------------------------------------------------------------------------
C
C
      INCLUDE 'MID_REL_INCL:TSA_DEF.INC'
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      CHARACTER*60        INAME1         !  NAME OF 1ST OBSERVATION TABLE
      CHARACTER*60        INAME2         !  NAME OF 2ND OBSERVATION TABLE
      CHARACTER*60        ONAME          !  NAME OF OUTPUT CHI2 TABLE
      REAL*8              TLAG1          !  START TIME LAG
      REAL*8              DTLAG          !  TIME LAG INCREMENT
      INTEGER             NLAG           !  NUMBER OF TIME LAGS
      CHARACTER*3         CFUNC          !  TYPE OF ACF
      CHARACTER*3         CMODE          !  MODE
      DOUBLE PRECISION    PARM(12)       !  PARAMETERS OF ACF
      INTEGER             MODE
      DOUBLE PRECISION ACFLIN,ACFPOL,ACFPOW,ACFEXP,
     $                 ACFLOG,ACFIPO
      EXTERNAL         ACFLIN,ACFPOL,ACFPOW,ACFEXP,
     $                 ACFLOG,ACFIPO
      DOUBLE PRECISION TSADELUR0,TSADELUR1,TSADELUR2,TSADELUR3,
     $                 TSADELUR4,TSADELUR5,TSADELUR6,TSADELUR7,
     $                 TSADELUR8,TSADELUR9
      EXTERNAL         TSADELUR0,TSADELUR1,TSADELUR2,TSADELUR3,
     $                 TSADELUR4,TSADELUR5,TSADELUR6,TSADELUR7,
     $                 TSADELUR8,TSADELUR9
C
      INTEGER      NOBS1, NOBS2, NOBS,  NOBSP1
      INTEGER      NPAR,  ISIZE, ASIZE
      INTEGER      IACTS, KUN,   KNUL
      INTEGER      TID1,  TID2,  OTID,  ITIME, IDAT, IVAR
      INTEGER      NCOL,  ICOL,  NROW,  ISOR
      INTEGER      LFIELD,TTYP,  DTYP,  VTYP
      INTEGER      IOBS
      INTEGER      ICOBS, ICOND, IPAR
      INTEGER      ICHI2L,ICHI2D
C 
      INTEGER*8    POBS1T,POBS1D,POBS1V
      INTEGER*8    POBS2T,POBS2D,POBS2V
      INTEGER*8    POBS
      INTEGER*8    PCOBS, PCOND, PPAR
      INTEGER*8    PCHI2L,PCHI2D
C 
      CHARACTER*10 FORM
      CHARACTER*80 TEXT
C
      INCLUDE 'MID_REL_INCL:TSA_DAT.INC'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C
C   Get parameters
C
      CALL STSPRO ('tsadel')
      CALL STKRDC ('IN_A',  1,1,60,IACTS,INAME1,KUN,KNUL,ISTAT)
      CALL STKRDC ('IN_B' ,1,1,60,IACTS,INAME2,KUN,KNUL,ISTAT)
      CALL STKRDC ('OUT_A',  1,1,60,IACTS,ONAME, KUN,KNUL,ISTAT)
      CALL STKRDD ('STARTTSA',    1, 1,IACTS,TLAG1, KUN,KNUL,ISTAT)
      CALL STKRDD ('STEPTSA',     1, 1,IACTS,DTLAG, KUN,KNUL,ISTAT)
      CALL STKRDI ('NSTEPS',   1, 1,IACTS,NLAG,  KUN,KNUL,ISTAT)
      CALL STKRDC ('CFUNC',  1,1, 3,IACTS,CFUNC, KUN,KNUL,ISTAT)
      CALL STKRDC ('CMODE',  1,1, 3,IACTS,CMODE, KUN,KNUL,ISTAT)
      CALL STKRDD ('INPUTD',   1,12,IACTS,PARM,  KUN,KNUL,ISTAT)
      CALL STKRDI ('ORDERTSA',
     $    1, 1,IACTS,MODE,  KUN,KNUL,ISTAT)
      IF     (LLE(CMODE,'NOR').AND.LGE(CMODE,'NOR')) THEN
        MODE=1
        NPAR=2
      ELSEIF (LLE(CMODE,'ORI').AND.LGE(CMODE,'ORI')) THEN
        MODE=2
        NPAR=1
      ELSE
        CALL STETER(10,'Wrong MODE')
      ENDIF
C
C   Map input data
C
      CALL TBTOPN (INAME1,F_I_MODE,TID1,ISTAT)
      CALL TBIGET (TID1,NCOL,NOBS1,ISOR,ICOL,NROW,ISTAT)
      CALL TBLSER (TID1,'TIME' ,ITIME,ISTAT)
      IF (ITIME.LT.0) THEN
        CALL STETER(31,'Column :TIME not found in 1st table')
      ENDIF
      CALL TBLSER (TID1,'VALUE',IDAT ,ISTAT)
      IF (IDAT.LT.0) THEN
        CALL STETER(32,'Column :VALUE not found in 1st table')
      ENDIF
      CALL TBLSER (TID1,'VAR'  ,IVAR, ISTAT)
      IF (IVAR.LT.0) THEN
        CALL STETER(33,'Column :VAR not found in 1st table')
      ENDIF
      CALL TBFGET (TID1,ITIME,FORM,LFIELD,TTYP,ISTAT)
      CALL TBFGET (TID1,IDAT, FORM,LFIELD,DTYP,ISTAT)
      CALL TBFGET (TID1,IVAR, FORM,LFIELD,VTYP,ISTAT)
      CALL TBDGET (TID1,ISTORE,ISTAT)
      IF (ISTORE.NE.F_TRANS) THEN
        TEXT='Input table '//INAME1//' stored not transposed'
        CALL STETER(1,TEXT)
      ENDIF
      IF (TTYP.NE.D_R8_FORMAT.OR.DTYP.NE.D_R8_FORMAT.OR.
     $     VTYP.NE.D_R8_FORMAT) THEN
        CALL STETER(2,
     $     'Column(s) in 1st table must be in DOUBLE PRECISION')
      ENDIF
      CALL TBCMAP (TID1,ITIME,POBS1T,ISTAT)
      CALL TBCMAP (TID1,IDAT, POBS1D,ISTAT)
      CALL TBCMAP (TID1,IVAR, POBS1V,ISTAT)
C
      CALL TBTOPN (INAME2,F_I_MODE,TID2,ISTAT)
      CALL TBIGET (TID2,NCOL,NOBS2,ISOR,ICOL,NROW,ISTAT)
      CALL TBLSER (TID2,'TIME' ,ITIME,ISTAT)
      IF (ITIME.LT.0) THEN
        CALL STETER(34,'Column :TIME not found in 2nd table')
      ENDIF
      CALL TBLSER (TID2,'VALUE',IDAT ,ISTAT)
      IF (IDAT.LT.0) THEN
        CALL STETER(35,'Column :VALUE not found in 2nd table')
      ENDIF
      CALL TBLSER (TID2,'VAR'  ,IVAR, ISTAT)
      IF (IVAR.LT.0) THEN
        CALL STETER(36,'Column :VAR not found in 2nd table')
      ENDIF
      CALL TBFGET (TID2,ITIME,FORM,LFIELD,TTYP,ISTAT)
      CALL TBFGET (TID2,IDAT, FORM,LFIELD,DTYP,ISTAT)
      CALL TBFGET (TID2,IVAR, FORM,LFIELD,VTYP,ISTAT)
      CALL TBDGET (TID2,ISTORE,ISTAT)
      IF (ISTORE.NE.F_TRANS) THEN
        TEXT='Input table '//INAME2//' stored not transposed'
        CALL STETER(3,TEXT)
      ENDIF
      IF (TTYP.NE.D_R8_FORMAT.OR.DTYP.NE.D_R8_FORMAT.OR.
     $     VTYP.NE.D_R8_FORMAT) THEN
        CALL STETER(4,
     $     'Column(s) in 2nd table must be in DOUBLE PRECISION')
      ENDIF
      CALL TBCMAP (TID2,ITIME,POBS2T,ISTAT)
      CALL TBCMAP (TID2,IDAT, POBS2D,ISTAT)
      CALL TBCMAP (TID2,IVAR, POBS2V,ISTAT)
C
C   Create and map work tables  OBS,OBS1,OBS2,COBS,COND,CPAR
C
      NOBS=NOBS1+NOBS2
      NOBSP1=NOBS+1
      ISIZE=NOBS*3
      CALL STFCRE('ZZMIDAWORK',D_R8_FORMAT,F_X_MODE,F_IMA_TYPE,
     $   ISIZE,IOBS, ISTAT)
      CALL STFMAP(IOBS, F_X_MODE,1,ISIZE,ASIZE,POBS, ISTAT)
C
      ISIZE=NOBSP1*NOBSP1
      CALL STFCRE('ZZMIDDWORK',D_R8_FORMAT,F_X_MODE,F_IMA_TYPE,
     $   ISIZE,ICOBS,ISTAT)
      CALL STFMAP(ICOBS,F_X_MODE,1,ISIZE,ASIZE,PCOBS,ISTAT)
C
      ISIZE=(NPAR+1)*NOBS
      CALL STFCRE('ZZMIDEWORK',D_R8_FORMAT,F_X_MODE,F_IMA_TYPE,
     $   ISIZE,ICOND,ISTAT)
      CALL STFMAP(ICOND,F_X_MODE,1,ISIZE,ASIZE,PCOND,ISTAT)
C
      ISIZE=(NPAR+1)*(NPAR+1)
      CALL STFCRE('ZZMIDFWORK',D_R8_FORMAT,F_X_MODE,F_IMA_TYPE,
     $   ISIZE,IPAR, ISTAT)
      CALL STFMAP(IPAR, F_X_MODE,1,ISIZE,ASIZE,PPAR, ISTAT)
C
C   Create and map output table
C
      NCOL=2
      CALL TBTINI (ONAME,F_TRANS,F_IO_MODE,NCOL,NLAG,OTID,ISTAT)
      CALL TBCINI (OTID,D_R8_FORMAT,1,'E15.6',' ','LAG', ICHI2L,ISTAT)
      CALL TBCINI (OTID,D_R8_FORMAT,1,'E15.6',' ','CHI2',ICHI2D,ISTAT)
      CALL TBCMAP (OTID,ICHI2L,PCHI2L,ISTAT)
      CALL TBCMAP (OTID,ICHI2D,PCHI2D,ISTAT)
C
C   Compute covariance function
C
C
      IF (LLE(CFUNC,'LIN').AND.LGE(CFUNC,'LIN')) THEN
        CALL DELAY(
     $    MADRID(POBS1T), MADRID(POBS1D), MADRID(POBS1V),
     $    MADRID(POBS2T), MADRID(POBS2D), MADRID(POBS2V),
     $    MADRID(POBS),
     $    ACFLIN,PARM,    MADRID(PCOBS),  MADRID(PCOND),
     $    MADRID(PPAR),   MADRID(PCHI2L), MADRID(PCHI2D),
     $    NOBS1,NOBS2,NPAR+1,MODE,NLAG,TLAG1,DTLAG)
      ELSEIF (LLE(CFUNC,'POL').AND.LGE(CFUNC,'POL')) THEN
        CALL DELAY(
     $    MADRID(POBS1T), MADRID(POBS1D), MADRID(POBS1V),
     $    MADRID(POBS2T), MADRID(POBS2D), MADRID(POBS2V),
     $    MADRID(POBS),
     $    ACFPOL,PARM,    MADRID(PCOBS),  MADRID(PCOND),
     $    MADRID(PPAR),   MADRID(PCHI2L), MADRID(PCHI2D),
     $    NOBS1,NOBS2,NPAR+1,MODE,NLAG,TLAG1,DTLAG)
      ELSEIF (LLE(CFUNC,'POW').AND.LGE(CFUNC,'POW')) THEN
        CALL DELAY(
     $    MADRID(POBS1T), MADRID(POBS1D), MADRID(POBS1V),
     $    MADRID(POBS2T), MADRID(POBS2D), MADRID(POBS2V),
     $    MADRID(POBS),
     $    ACFPOW,PARM,    MADRID(PCOBS),  MADRID(PCOND),
     $    MADRID(PPAR),   MADRID(PCHI2L), MADRID(PCHI2D),
     $    NOBS1,NOBS2,NPAR+1,MODE,NLAG,TLAG1,DTLAG)
      ELSEIF (LLE(CFUNC,'EXP').AND.LGE(CFUNC,'EXP')) THEN
        CALL DELAY(
     $    MADRID(POBS1T), MADRID(POBS1D), MADRID(POBS1V),
     $    MADRID(POBS2T), MADRID(POBS2D), MADRID(POBS2V),
     $    MADRID(POBS),
     $    ACFEXP,PARM,    MADRID(PCOBS),  MADRID(PCOND),
     $    MADRID(PPAR),   MADRID(PCHI2L), MADRID(PCHI2D),
     $    NOBS1,NOBS2,NPAR+1,MODE,NLAG,TLAG1,DTLAG)
      ELSEIF (LLE(CFUNC,'LOG').AND.LGE(CFUNC,'LOG')) THEN
        CALL DELAY(
     $    MADRID(POBS1T), MADRID(POBS1D), MADRID(POBS1V),
     $    MADRID(POBS2T), MADRID(POBS2D), MADRID(POBS2V),
     $    MADRID(POBS),
     $    ACFLOG,PARM,    MADRID(PCOBS),  MADRID(PCOND),
     $    MADRID(PPAR),   MADRID(PCHI2L), MADRID(PCHI2D),
     $    NOBS1,NOBS2,NPAR+1,MODE,NLAG,TLAG1,DTLAG)
      ELSEIF (LLE(CFUNC,'IPO').AND.LGE(CFUNC,'IPO')) THEN
        CALL DELAY(
     $    MADRID(POBS1T), MADRID(POBS1D), MADRID(POBS1V),
     $    MADRID(POBS2T), MADRID(POBS2D), MADRID(POBS2V),
     $    MADRID(POBS),
     $    ACFIPO,PARM,    MADRID(PCOBS),  MADRID(PCOND),
     $    MADRID(PPAR),   MADRID(PCHI2L), MADRID(PCHI2D),
     $    NOBS1,NOBS2,NPAR+1,MODE,NLAG,TLAG1,DTLAG)
      ELSEIF (LLE(CFUNC,'UR0').AND.LGE(CFUNC,'UR0')) THEN
        CALL DELAY(
     $    MADRID(POBS1T), MADRID(POBS1D), MADRID(POBS1V),
     $    MADRID(POBS2T), MADRID(POBS2D), MADRID(POBS2V),
     $    MADRID(POBS),
     $    TSADELUR0,PARM, MADRID(PCOBS),  MADRID(PCOND),
     $    MADRID(PPAR),   MADRID(PCHI2L), MADRID(PCHI2D),
     $    NOBS1,NOBS2,NPAR+1,MODE,NLAG,TLAG1,DTLAG)
      ELSEIF (LLE(CFUNC,'UR1').AND.LGE(CFUNC,'UR1')) THEN
        CALL DELAY(
     $    MADRID(POBS1T), MADRID(POBS1D), MADRID(POBS1V),
     $    MADRID(POBS2T), MADRID(POBS2D), MADRID(POBS2V),
     $    MADRID(POBS),
     $    TSADELUR1,PARM, MADRID(PCOBS),  MADRID(PCOND),
     $    MADRID(PPAR),   MADRID(PCHI2L), MADRID(PCHI2D),
     $    NOBS1,NOBS2,NPAR+1,MODE,NLAG,TLAG1,DTLAG)
      ELSEIF (LLE(CFUNC,'UR2').AND.LGE(CFUNC,'UR2')) THEN
        CALL DELAY(
     $    MADRID(POBS1T), MADRID(POBS1D), MADRID(POBS1V),
     $    MADRID(POBS2T), MADRID(POBS2D), MADRID(POBS2V),
     $    MADRID(POBS),
     $    TSADELUR2,PARM, MADRID(PCOBS),  MADRID(PCOND),
     $    MADRID(PPAR),   MADRID(PCHI2L), MADRID(PCHI2D),
     $    NOBS1,NOBS2,NPAR+1,MODE,NLAG,TLAG1,DTLAG)
      ELSEIF (LLE(CFUNC,'UR3').AND.LGE(CFUNC,'UR3')) THEN
        CALL DELAY(
     $    MADRID(POBS1T), MADRID(POBS1D), MADRID(POBS1V),
     $    MADRID(POBS2T), MADRID(POBS2D), MADRID(POBS2V),
     $    MADRID(POBS),
     $    TSADELUR3,PARM, MADRID(PCOBS),  MADRID(PCOND),
     $    MADRID(PPAR),   MADRID(PCHI2L), MADRID(PCHI2D),
     $    NOBS1,NOBS2,NPAR+1,MODE,NLAG,TLAG1,DTLAG)
      ELSEIF (LLE(CFUNC,'UR4').AND.LGE(CFUNC,'UR4')) THEN
        CALL DELAY(
     $    MADRID(POBS1T), MADRID(POBS1D), MADRID(POBS1V),
     $    MADRID(POBS2T), MADRID(POBS2D), MADRID(POBS2V),
     $    MADRID(POBS),
     $    TSADELUR4,PARM, MADRID(PCOBS),  MADRID(PCOND),
     $    MADRID(PPAR),   MADRID(PCHI2L), MADRID(PCHI2D),
     $    NOBS1,NOBS2,NPAR+1,MODE,NLAG,TLAG1,DTLAG)
      ELSEIF (LLE(CFUNC,'UR5').AND.LGE(CFUNC,'UR5')) THEN
        CALL DELAY(
     $    MADRID(POBS1T), MADRID(POBS1D), MADRID(POBS1V),
     $    MADRID(POBS2T), MADRID(POBS2D), MADRID(POBS2V),
     $    MADRID(POBS),
     $    TSADELUR5,PARM, MADRID(PCOBS),  MADRID(PCOND),
     $    MADRID(PPAR),   MADRID(PCHI2L), MADRID(PCHI2D),
     $    NOBS1,NOBS2,NPAR+1,MODE,NLAG,TLAG1,DTLAG)
      ELSEIF (LLE(CFUNC,'UR6').AND.LGE(CFUNC,'UR6')) THEN
        CALL DELAY(
     $    MADRID(POBS1T), MADRID(POBS1D), MADRID(POBS1V),
     $    MADRID(POBS2T), MADRID(POBS2D), MADRID(POBS2V),
     $    MADRID(POBS),
     $    TSADELUR6,PARM, MADRID(PCOBS),  MADRID(PCOND),
     $    MADRID(PPAR),   MADRID(PCHI2L), MADRID(PCHI2D),
     $    NOBS1,NOBS2,NPAR+1,MODE,NLAG,TLAG1,DTLAG)
      ELSEIF (LLE(CFUNC,'UR7').AND.LGE(CFUNC,'UR7')) THEN
        CALL DELAY(
     $    MADRID(POBS1T), MADRID(POBS1D), MADRID(POBS1V),
     $    MADRID(POBS2T), MADRID(POBS2D), MADRID(POBS2V),
     $    MADRID(POBS),
     $    TSADELUR7,PARM, MADRID(PCOBS),  MADRID(PCOND),
     $    MADRID(PPAR),   MADRID(PCHI2L), MADRID(PCHI2D),
     $    NOBS1,NOBS2,NPAR+1,MODE,NLAG,TLAG1,DTLAG)
      ELSEIF (LLE(CFUNC,'UR8').AND.LGE(CFUNC,'UR8')) THEN
        CALL DELAY(
     $    MADRID(POBS1T), MADRID(POBS1D), MADRID(POBS1V),
     $    MADRID(POBS2T), MADRID(POBS2D), MADRID(POBS2V),
     $    MADRID(POBS),
     $    TSADELUR8,PARM, MADRID(PCOBS),  MADRID(PCOND),
     $    MADRID(PPAR),   MADRID(PCHI2L), MADRID(PCHI2D),
     $    NOBS1,NOBS2,NPAR+1,MODE,NLAG,TLAG1,DTLAG)
      ELSEIF (LLE(CFUNC,'UR9').AND.LGE(CFUNC,'UR9')) THEN
        CALL DELAY(
     $    MADRID(POBS1T), MADRID(POBS1D), MADRID(POBS1V),
     $    MADRID(POBS2T), MADRID(POBS2D), MADRID(POBS2V),
     $    MADRID(POBS),
     $    TSADELUR9,PARM, MADRID(PCOBS),  MADRID(PCOND),
     $    MADRID(PPAR),   MADRID(PCHI2L), MADRID(PCHI2D),
     $    NOBS1,NOBS2,NPAR+1,MODE,NLAG,TLAG1,DTLAG)
      ELSE
        CALL STETER(5,'Wrong name for ACF type')
      ENDIF
      CALL TBIPUT (OTID,NCOL,NLAG,ISTAT)
C
C   Wind-up
C
      CALL DSCUPT(OTID,OTID,' ',ISTAT)
      CALL STSEPI
C
      END
C
C
C
C
C
C   DELAY
C
C   Determine joint chi2 of two observation samples as a function of time
C   and signal shift.
C
C   Input:
C   NOBS                      - number of observations in 1+2 sample
C   NOBSP1                    - number of observations in 1+2 sample +1
C   NOBS1                     - number of observations in 1 sample
C   NOBS2                     - number of observations in 2 sample
C   OBS1T,OBS1D,OBS1V(NOBS1)  - 1st observation set (time, value, variance)
C   OBS2T,OBS2D,OBS2V(NOBS2)  - 2nd observation set (time, value, variance)
C   ACFUNC(TLAG,PARM)         - autocorrelation function (ACF)
C   PARM(12)                  - parameters of ACF
C   NLAG                      - number of time lags to be considered
C   TLAG1                     - value of the 1st lag
C   DLAG                      - lag increment
C
C   Work tables:
C   OBS(NOBS,3)
C   COBS(NOBSP1,NOBSP1)
C   COND(NPAR1,NOBS)
C   CPAR(NPAR1,NPAR1)
C
C   Output:
C   CHI2L(NLAG)                - lags
C   CHI2D(NLAG)                - chi2 for given lags
C
      SUBROUTINE DELAY(
     $   OBS1T,OBS1D,OBS1V,OBS2T,OBS2D,OBS2V,OBS,
     $   ACFUNC,PARM,COBS,COND,CPAR,CHI2L,CHI2D,
     $   NOBS1,NOBS2,NPAR1,MODE,NLAG,TLAG1,DLAG)
C
      INCLUDE 'MID_REL_INCL:TSA_DEF.INC'
      EXTERNAL ACFUNC
      INTEGER          NOBS1, NOBS2
      INTEGER          NPAR1, MODE,  NLAG
      DOUBLE PRECISION OBS1T(NOBS1), OBS1D(NOBS1),  OBS1V(NOBS1)
      DOUBLE PRECISION OBS2T(NOBS2), OBS2D(NOBS2),  OBS2V(NOBS2)
      DOUBLE PRECISION OBS(NOBS1+NOBS2,3)
      DOUBLE PRECISION ACFUNC                    ! EXTERNAL FUNCTION
      DOUBLE PRECISION PARM(12)
      DOUBLE PRECISION COBS(NOBS1+NOBS2+1,NOBS1+NOBS2+1)
      DOUBLE PRECISION COND(NPAR1,NOBS1+NOBS2)
      DOUBLE PRECISION CPAR(NPAR1,NPAR1)
      DOUBLE PRECISION CHI2L(NLAG),  CHI2D(NLAG)
      REAL*8           TLAG1, DLAG
C
      INTEGER          NOBS,  NOBSP1
      INTEGER          NFIRST,IOBS,  JOBS,  ILAG,  I
      REAL*8           TLAG,  SAV
      DOUBLE PRECISION WGHT1, WGHT2, AVRG1, AVRG2, VAR1, VAR2
      CHARACTER*80     TEXT
      INCLUDE 'MID_REL_INCL:TSA_CONST.INC'
C
      NOBS=NOBS1+NOBS2
      NOBSP1=NOBS+1
      NFIRST=NOBS1
      DO 1 ILAG=1,NLAG
        TLAG=TLAG1+DLAG*(ILAG-1)
C
C   Copy time and apply time lag
C
        CALL INPCPY(OBS1T, OBS(1,1),       NOBS1)
        CALL INPCPY(OBS2T, OBS(NOBS1+1,1), NOBS2)
        DO 2 IOBS=NOBS1+1,NOBS
           OBS(IOBS,1)=OBS(IOBS,1)-TLAG
 2      CONTINUE
C
C   Get parameters for condition equations
C
        CALL INPCPY(OBS1D, OBS(1,2),       NOBS1)
        CALL INPCPY(OBS1V, OBS(1,3),       NOBS1)
        CALL INPCPY(OBS2D, OBS(NOBS1+1,2), NOBS2)
        CALL INPCPY(OBS2V, OBS(NOBS1+1,3), NOBS2)
        IF (MODE.EQ.1) THEN
          WGHT1=-HALF
          WGHT2=+HALF
        ELSEIF (MODE.EQ.2) THEN
          CALL INTERPOL(
     $       OBS(1,1),       OBS(1,2),       OBS(1,3),
     $       OBS(NOBS1+1,1), OBS(NOBS1+1,2), OBS(NOBS1+1,3),
     $       ACFUNC,PARM,NOBS1,NOBS2,2,AVRG1,VAR1,
     $       COBS,COND(1,1),COND(2,1))
          CALL INPCPY(OBS2D, OBS(NOBS1+1,2), NOBS2)
          CALL INPCPY(OBS2V, OBS(NOBS1+1,3), NOBS2)
          CALL INTERPOL(
     $       OBS(NOBS1+1,1), OBS(NOBS1+1,2), OBS(NOBS1+1,3),
     $       OBS(1,1),       OBS(1,2),       OBS(1,3),
     $       ACFUNC,PARM,NOBS2,NOBS1,2,AVRG2,VAR2,
     $       COBS,COND(1,1),COND(2,1))
          CALL INPCPY(OBS1D, OBS(1,2),       NOBS1)
          CALL INPCPY(OBS1V, OBS(1,3),       NOBS1)
          DO 3 IOBS=1,NOBS1
            OBS(IOBS,2)=OBS(IOBS,2)-AVRG1
 3        CONTINUE
          DO 4 IOBS=NOBS1+1,NOBS
            OBS(IOBS,2)=OBS(IOBS,2)-AVRG2
 4        CONTINUE
        ELSEIF (MODE.EQ.3) THEN
          AVRG1=ZERO
          AVRG2=ZERO
          VAR1=1E-32
          VAR2=1E-32
        ENDIF
C
C   Set condition equations
C
        DO 10 IOBS=1,NOBS
          IF (MODE.EQ.1) THEN
            IF (IOBS.GT.NFIRST) THEN
              COND(2,IOBS)=WGHT2
            ELSE
              COND(2,IOBS)=WGHT1
            ENDIF
          ELSEIF (MODE.EQ.2.OR.MODE.EQ.3) THEN
          ENDIF
          COND(1,IOBS)=ONE
          COND(NPAR1,IOBS)=OBS(IOBS,2)
 10     CONTINUE
C
C   Set covariance matrix
C
        DO 20 IOBS=1,NOBS
          DO 21 JOBS=IOBS,NOBS
            SAV=OBS(IOBS,1)-OBS(JOBS,1)
            COBS(JOBS,IOBS)=ACFUNC(SAV,PARM)
            IF (IOBS.EQ.JOBS) THEN
              COBS(IOBS,IOBS)=COBS(IOBS,IOBS)+OBS(IOBS,3)
            ENDIF
 21       CONTINUE
 20     CONTINUE
        CALL FITCOR(COND,COBS,CPAR,NOBS,NPAR1,CHI2D(ILAG))
        CHI2D(ILAG)=CHI2D(ILAG)*(NOBS-2)
        CHI2L(ILAG)=TLAG
C
C      Print progress report
C
        IF (MOD(ILAG,NLAG/10+1).EQ.0) THEN
          IF (ILAG.EQ.NLAG/10+1) THEN
            TEXT='    Lag     Std.Dev.'//
     $        '    Mean      Error   Difference  Error'
            CALL STTPUT(TEXT,ISTAT)
          ENDIF
          SAV=SQRT(CPAR(NPAR1,NPAR1))
          IF (MODE.EQ.1.OR.MODE.EQ.3) THEN
            WRITE(TEXT,'(1PE10.3,1PE10.3,3(1PE12.4,1PE8.1))')
     $        TLAG,SAV,(CPAR(I,NPAR1),SQRT(CPAR(I,I)),I=1,NPAR1-1)
          ELSEIF (MODE.EQ.2) THEN
            WRITE(TEXT,'(1PE10.3,1PE10.3,3(1PE12.4,1PE8.1))')
     $        TLAG,SAV,(CPAR(I,NPAR1)+HALF*(AVRG1+AVRG2),
     $        SQRT(CPAR(I,I)),I=1,NPAR1-1),
     $        AVRG2-AVRG1,SQRT((VAR1/(NOBS1-1)+VAR2/(NOBS2-1)))
          ENDIF
          CALL STTPUT(TEXT,ISTAT)
        ENDIF
 1    CONTINUE
      END
C
C
C
C
C    FITCOR
C
C   General purpose least squares routine for correlated observations.
C   The correlation function must be given analyticaly
C   and observation equations in the matrix form.
C
C   A. Schwarzenberg-Czerny, ESO & Warsaw Observatory, June 1992
C
C   Input:
C   COBS(NOBS,NOBS)     - observation correlation matrix (to be destroyed)
C   COND(NPAR1,NPAR1)   - normal equations
C   NOBS                - number of observations
C   NPAR1               - number of parameters+1 (1 for chi2 only)
C   MODE                - returned RHS are:
C                       - 0 - none
C                       - 1 - restored by least squares
C                       - 2 - detrended
C                       - 3 - restored and detrended
C
C   Output:
C   CHI2DF              - chi2 per degree of freedom
C   CPAR(NPAR1,NPAR1)   - fitted parameters and their covariance matrix
C                         (See CRACOW for details)
C
C   Method:
C   The AC matrix is inverted first. This requires its storage.
C   The inversion can be done with a call of CRACOW. Both mean that
C   both observation equations and the AC matrix have to be stored.
C   Algorithm:
C   Find triangle root of CO, invert it and multiply CND by the triangle
C   inverse. Square the result to get the normal equations. Solve them and
C   return values of the parameters and their correlation matrix.
C
      SUBROUTINE FITCOR(COND,COBS,CPAR,NOBS,NPAR1,CHI2DF)
C
      INCLUDE 'MID_REL_INCL:TSA_DEF.INC'
      DOUBLE PRECISION CRACOW
      INTEGER NOBS,NPAR1
      DOUBLE PRECISION COND(NPAR1,NOBS)
      DOUBLE PRECISION COBS(NOBS+1,NOBS+1)
      DOUBLE PRECISION CPAR(NPAR1,NPAR1)
      DOUBLE PRECISION CHI2DF
C
      INTEGER I,J,K,NOBSP1
      DOUBLE PRECISION SUM
      INCLUDE 'MID_REL_INCL:TSA_CONST.INC'
C
      NOBSP1=NOBS+1
      CHI2DF=ZERO
C   Find inverse triangle root and get normal equations
      IF (CRACOW(COBS,NOBSP1,NOBSP1,0).EQ.ZERO) THEN
        CALL STETER(20,
     $   ' Covariance matrix of observations is singular (empty?)')
        RETURN
      ENDIF
      DO 1 I=NOBS,1,-1
        DO 1 J=1,NPAR1
          SUM=ZERO
          DO 2 K=1,I
            SUM=SUM+COBS(K,I)*COND(J,K)
 2        CONTINUE
          COND(J,I)=SUM
 1    CONTINUE
      DO 10 I=1,NPAR1
        DO 10 J=I,NPAR1
          SUM=ZERO
          DO 11 K=1,NOBS
            SUM=SUM+COND(I,K)*COND(J,K)
 11       CONTINUE
          CPAR(J,I)=SUM
 10   CONTINUE
C
C   Fit parameters by least squares and return chi2
C
      IF (CRACOW(CPAR,NPAR1,NPAR1,NOBS).EQ.ZERO) THEN
        CALL STETER(21,
     $   ' Normal equations are singular, modify trend functions')
        RETURN
      ENDIF
      CHI2DF=CPAR(NPAR1,NPAR1)
      END
C
C
C

C @(#)intnul.for	19.1 (ES0-DMD) 02/25/03 13:30:46
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE INTNUL(N,X)
C +++
C.PURPOSE: Initialize contents of output image to zero
C ---
      IMPLICIT  NONE
      INTEGER   N
      REAL      X(N)
C
      INTEGER   I
C
      DO 10 I = 1,N
         X(I)   = 0.
   10 CONTINUE

      RETURN
      END

C @(#)srhobj.for	19.1 (ES0-DMD) 02/25/03 13:25:39
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine SRHOBJ         version 1         820506
C  A. Kruszewski             ESO Garching
C  A. Lauberts                                 840511
C  modified to FX            version 1.1       870219
C  A. Kruszewski             Obs. de Geneve
C  modified to MSDOS         version 1.2       880522
C  A. Kruszewski             Warsaw U. Obs.
C.KEYWORDS
C  search
C.PURPOSE
C  Compares pixel of coordinates I,J with its eight closest neighbours.
C  Sets DETECT to .TRUE. when pixel I,J is equal or higher than
C  any of its eight neighbours.
C  Calculates average value of all nine pixels if DETECT is .TRUE.
C.INPUT/OUTPUT
C  input arguments:
C  A           real*4 array        image buffer
C  JAPY        integer*4 array     array of line pointers
C  JOFF        integer*4           line number offset
C  I           integer*4           x-pixel coordinate
C  J           integer*4           y-pixel coordinate
C  AV          real*4              value of I,J pixel
C  output arguments:
C  DETECT      logical*4           object detection flag
C  AV          real*4              average of 9 pixels centered on I,J
C-----------------------------------------------------------------------
      SUBROUTINE SRHOBJ(A, JAPY, JOFF, I, J, DETECT, AV)
C
      IMPLICIT  NONE
      INTEGER   I , II
      INTEGER   J , JAPY(1) , JOF , JOFF
      REAL      A(1) , AV , TEMP , SUM
      LOGICAL    DETECT
C
C ******      Compare pixel I,J with 8 neighbours.
C
      SUM = AV
      DETECT = .FALSE.
      JOF = JAPY(J-JOFF-1) + I
      DO 10 II = -1 , 1
          TEMP = A(JOF+II)
          IF ( TEMP .GT. AV ) RETURN
          SUM = SUM + TEMP
   10      CONTINUE
      JOF = JAPY(J-JOFF) + I
      DO 20 II = -1 , 1 , 2
          TEMP = A(JOF+II)
          IF ( TEMP .GT. AV ) RETURN
          SUM = SUM + TEMP
   20      CONTINUE
      JOF = JAPY(J-JOFF+1) + I
      DO 30 II = -1 , 1
          TEMP = A(JOF+II)
          IF ( TEMP .GT. AV ) RETURN
          SUM = SUM + TEMP
   30      CONTINUE
C
C ******      Central pixel is the maximum value.
C
      DETECT = .TRUE.
C
C ******      Calculates average AV of pixels on a 3x3
C ******      matrix which is centered on pixel I,J.
C
      AV = SUM / 9.0
C
      RETURN
C
      END 

C @(#)rectspec.for	19.1 (ES0-DMD) 02/25/03 14:25:23
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C @(#)rectspec.for	19.1  (ESO)  02/25/03  14:25:23 
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C.IDENTIFICATION RECTSPEC
C.PURPOSE:       Geometrically rectificy distorted 2-D spectra, rebin to 
C                constant step size in wavelength maintaining the number of 
C                pixels, take care that flux is conserved
C.AUTHOR:        D. Baade, J.D.Ponz
C.KEYWORDS:      geometrical rectification of 2-D spectra, rebinning, flux
C                conservation, wavelength calibration
C.LANGUAGE:      F77+ESOext
C.ALGORITHM:     a) rectification: The parameters of a bipolynomial regression
C                   of variable degree have to be calculated first by 
C                   REGRESSION/POLY on TABLE data (e.g. with positions of 
C                   reseaux marks). They are stored in the keyword COEFXj 
C                   (x-transformation) and COEFYj (y-transformation), where
C                   j = I, C, R, D to keep all the regression information.
C                b) rebinning:     Each pixel is routinely subdivided into 9 
C                   subpixels (unless SUBF=1.). Assuming that
C                   the coordinates of the input pixel refer to its center
C                   and that its contents is the average flux integrated over
C                   its area (no dead space), a simple linear interpolation
C                   with nearest neighboring original pixels is done for each
C                   of the 9 subpixels. After this interpolation the flux
C                   summed over the subpixels is scaled to the flux of the
C                   original pixel so that flux conservation is achieved on a
C                   pixel basis. Finally, each subpixel is imaged to the
C                   rectified coordinate frame and its contents added to the
C                   appropriate pixel(s) (of about the same size as in the input
C                   frame). Optionally (NREP.GT.1) each subpixel can first be
C                   subdivided into still smaller units. Sub-subpixels
C                   originating from the same parent-subpixel all contain the
C                   same flux, i.e. no further interpolation is done.
C.RESTRICTIONS:  All STEP sizes are implicitly assumed to be positive.
C.INPUT/OUTPUT:  the following keywords are used:
C                P1    name of input frame
C                P2    name of output frame
C                P3    reference frame or sampling domain 
C                COEFXj  regression coefficients for X-coordinate
C                COEFYj  regression coefficients for Y-coordinate
C                INPUTI/I/1/1   repetition factor (for the further 
C                                 subdivision of subpixel
C                INPUTR/R/1/1     SUBF
C.VERSION:       861010  D. Baade                  ESO
C.VERSION:       871123  R.H. Warmels              ESO-FORTRAN Conversion
C.VERSION:       881214  J.D.Ponz                  New functionality
C --------------------------------------------------------------------
      PROGRAM     RCTSPC
C
      IMPLICIT    NONE
C
      INTEGER      NLEN
      PARAMETER    (NLEN=80)
      INTEGER      MADRID
      INTEGER      I,IAV,IAC,KUN,KNUL,COEFXI(13),COEFYI(13)
      INTEGER      NAXIS,NPIX(2),ISTAT
      INTEGER*8    IPNTRA,IPNTRC
      INTEGER      NREP,OUTNPX(2)
      INTEGER      IMA,IMC,IMD
      INTEGER*8    IPNTRD
      INTEGER      NPIXIP(2)
C 
      REAL         SUBF
C 
      DOUBLE PRECISION OUTSTR(2),OUTSTP(2)
      DOUBLE PRECISION INSTR(2),INSTP(2)
      DOUBLE PRECISION COEFXD(100),COEFYD(100),START(2),STEP(2)
C 
      CHARACTER*80 FRAMEA,FRAMEC,COEFXC,COEFYC
      CHARACTER*60 FRAMER
      CHARACTER    IDENT*72,CUNIT*64
C 
      INCLUDE     'MID_INCLUDE:ST_DEF.INC'
      COMMON      /VMR/MADRID(1)
      INCLUDE     'MID_INCLUDE:ST_DAT.INC'
C
C ... get into MIDAS
C
      CALL STSPRO('RECTIFY')  
C
C ... read parameters
C
      CALL STKRDC('P1',1,1,NLEN,IAC,FRAMEA,KUN,KNUL,ISTAT)
      CALL STIGET(FRAMEA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     .       2,NAXIS,NPIX,START,STEP,IDENT,CUNIT,IPNTRA,IMA,ISTAT)
C
      IF (NAXIS.NE.2) THEN                ! insist that frame be two-dimensional
         CALL STTPUT('*** FATAL: only 2-d frames allowed ... ',ISTAT)
         GO TO 1111
      END IF
      CALL STKRDC('P2',1,1,NLEN,IAC,FRAMEC,KUN,KNUL,ISTAT)
      CALL STKRDC('IN_B',1,1,60,IAC,FRAMER,KUN,KNUL,ISTAT)
C
C ... read coefficients
C
      CALL STKRDC('KEYLONGC',1,1,NLEN,IAC,COEFXC,KUN,KNUL,ISTAT)
      CALL STKRDI('KEYLONGI',1,13,IAC,COEFXI,KUN,KNUL,ISTAT)
      CALL STKRDD('KEYLONGD',1,50,IAC,COEFXD,KUN,KNUL,ISTAT)

      CALL STKRDC('COEFYC',1,1,NLEN,IAC,COEFYC,KUN,KNUL,ISTAT)
      CALL STKRDI('COEFYI',1,13,IAC,COEFYI,KUN,KNUL,ISTAT)
      CALL STKRDD('COEFYD',1,50,IAC,COEFYD,KUN,KNUL,ISTAT)

       DO 66 I = 1,13
          COEFYI(I) = 0
66     CONTINUE

       DO 67 I = 1, 50
          COEFYD(I) = 0.D0
67     CONTINUE
C
C ... repetition factor and substepping flag
C
      CALL STKRDI('INPUTI',1,1,IAV,NREP,KUN,KNUL,ISTAT)
      CALL STKRDR('INPUTR',1,1,IAV,SUBF,KUN,KNUL,ISTAT)
      CALL STKRDD('INPUTD',1,2,IAV,INSTR,KUN,KNUL,ISTAT)
      CALL STKRDD('INPUTD',3,2,IAV,INSTP,KUN,KNUL,ISTAT)
C
      IF (NREP.GT.5) THEN                                      ! limit nrep to 5
         NREP   = 5
         CALL STTPUT('*** WARNING: Substepping factor set to 5 !',
     .               ISTAT)
      END IF
C
C ... calculate values of outstr and outnpx for output frame
C
      CALL OUTDSP(FRAMER,START,STEP,NPIX,
     .            COEFXI(6),COEFXI(7),COEFXD,
     .            OUTSTR,OUTSTP,OUTNPX)
C
      CALL STIPUT(FRAMEC,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .   NAXIS,OUTNPX,OUTSTR,OUTSTP,IDENT,CUNIT,IPNTRC,IMC,ISTAT)
      CALL INTNUL(OUTNPX(1)*OUTNPX(2),MADRID(IPNTRC))  ! initialize its contents
      CALL STDCOP(IMA,IMC,4,'LHCUTS',ISTAT)       ! copy descriptor lhcuts
C
C ... test if deconvolution required
C
      IF (SUBF.GT.1.1) THEN                           
         DO 10 I = 1,2         
            NPIXIP(I) = NPIX(I)*SUBF
   10    CONTINUE
         CALL STIPUT('IPOLDUM',D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .    NAXIS,NPIXIP,START,STEP,IDENT,CUNIT,IPNTRD,IMD,ISTAT)
         CALL INTNUL(NPIXIP(1)*NPIXIP(2),MADRID(IPNTRD))
         CALL RCTSIN(MADRID(IPNTRA),NPIX(1),NPIX(2),
     .               MADRID(IPNTRD))
         CALL RCTSPE(MADRID(IPNTRC),OUTNPX(1),OUTNPX(2),START,
     .               MADRID(IPNTRD),NPIXIP(1),NPIXIP(2), 
     .               COEFXI(6),COEFXI(7),COEFXD,
     .               COEFYI(6),COEFYI(7),COEFYD,
     .               OUTSTR,OUTSTP,SUBF,NREP,INSTR,INSTP)
  
      ELSE                                                
C
C ... no deconvolution required
C
         CALL RCTSPE(MADRID(IPNTRC),OUTNPX(1),OUTNPX(2),START,
     .               MADRID(IPNTRA),NPIX(1),NPIX(2),
     .               COEFXI(6),COEFXI(7),COEFXD,
     .               COEFYI(6),COEFYI(7),COEFYD,
     .               OUTSTR,OUTSTP,SUBF,NREP,INSTR,INSTP)
      END IF
C
C ...  release files and update keywords
C
1111  CALL STSEPI
      END

      SUBROUTINE INTNUL(N, X)
C
C ... initialize to zero
C
      IMPLICIT NONE
      INTEGER N
      REAL    X(N)
C
      INTEGER I
C
      DO 10 I = 1, N
         X(I) = 0.
10    CONTINUE
      RETURN
      END


      SUBROUTINE RCTSPE(OUT,NPX,NPY,START,IPOL,NPXIP,NPYIP,
     .          KX,LX,CX,KY,LY,CY,OUTSTA,OUTSTP,SUBFAC,NREP,INSTR,INSTP)
C +++
C.PURPOSE: This subroutine maps each set of subpixels into the rectified
C          coordinate frame and adds the contents of each subpixel into
C          the output pixel concerned.
C ---
      IMPLICIT NONE
C
      INTEGER      NPXIP, NPYIP, NPX, NPY, KX, KY, LX, LY
      REAL         IPOL(NPXIP,NPYIP)
      REAL         OUT(NPX,NPY)
      DOUBLE PRECISION XS,YS,XR,YR
      DOUBLE PRECISION INSTR(2),INSTP(2)
      DOUBLE PRECISION START(2),WIDTH,OFFX,OFFY
      DOUBLE PRECISION FXIN,FXOUT,FYIN,FYOUT,OFFMAX,FLUX
      DOUBLE PRECISION OFFINT,OUTSTA(2),OUTSTP(2)
      REAL         SUBFAC
      DOUBLE PRECISION CX(20),CY(20),X,Y,X0,Y0, XR1, YR1
      LOGICAL      LOWX,CENTX,HIGHX,LOWY,CENTY,HIGHY
      INTEGER      IXR, IYR, NREP, NPERC, K, L, M, N, ISTAT
      CHARACTER*50 PROGR
C
 9000 FORMAT ('          ',I3,' percent completed ...')
C  
      XS     = 0.                                     ! permit work on
      YS     = 0.                                          ! subframes
      WIDTH  = 1./(SUBFAC*NREP)                        ! width of (sub-)subpixel
      OFFMAX = 0.5* (1-WIDTH)   ! max. offs. to be still in nearest output pixel
      OFFINT = INT(SUBFAC/2.)
      NPERC  = 0
      CALL STTPUT('*** INFO: Mapping started',ISTAT)
C
C *** map coordinates of subpixels into rectified grid
C
      DO 40 L = 1,NPYIP
         DO 30 K = 1,NPXIP
            X0     = XS + (K+OFFINT)/SUBFAC           ! coordinates of subpixels
            Y0     = YS + (L+OFFINT)/SUBFAC
            FLUX   = IPOL(K,L)/(NREP*NREP)
            DO 20 M = 1,NREP           ! if requested, go to still smaller units
               X      = X0 + (M-0.5-NREP*0.5)*WIDTH
               DO 10 N = 1,NREP
                  Y  = Y0 + (N-0.5-NREP*0.5)*WIDTH

C
C ... coefficients apply to wolrd coordinates
C
                  X = (X-1.D0)*INSTP(1)+INSTR(1)
                  Y = (Y-1.D0)*INSTP(2)+INSTR(2)
C
C ... transformation in x
C
                  CALL COMPOL(KX, LX, CX, X, Y, XR1)
C
C *** and the same in y
C
                  IF (KY.LE.0 .AND. LY.LE.0) THEN
                     YR1 = Y
                  ELSE
                     CALL COMPOL(KY, LY, CY, X, Y, YR1)
                  ENDIF
C
C *** transformation from world coordinates to pixel coordinates 
C     to be used throughout the rest of this subroutine
C
                  XR = (XR1 - OUTSTA(1))/OUTSTP(1) + 1
                  YR = (YR1 - OUTSTA(2))/OUTSTP(2) + 1
C
C *** drop flux into respective output pixel
C     if necessary, divide flux in one subpixel among several output
C     pixels assuming that the flux does not vary over one subpixel
C  
                  IXR    = NINT(XR)                     !   nearest output pixel
                  IYR    = NINT(YR)        !   (should receive most of the flux)
                  OFFX   = XR - IXR           !   offset of subpixel center from
                  OFFY   = YR - IYR                      !   output pixel center
                  IF (IXR.LE.1 .OR. IXR.GE.NPX .OR.
     .                IYR.LE.1 .OR. IYR.GE.NPY) GOTO 10
C
C *** determine position in x of subpixel relative to nearest output pixel
C
                  IF ((ABS(OFFX)-OFFMAX).LE.0) THEN     ! within cen. pixel in x
                     LOWX   = .FALSE.  
                     CENTX  = .TRUE.
                     HIGHX  = .FALSE.
                     FXIN   = 1.
                  ELSE IF ((XR-IXR-OFFMAX).GT.0) THEN  ! beyond cent. pixel in x
                     LOWX   = .FALSE.
                     CENTX  = .FALSE.  
                     HIGHX  = .TRUE.
                     FXIN   = (IXR+0.5-XR)/WIDTH + 0.5
                  ELSE                                ! below central pixel in x
                     LOWX   = .TRUE.
                     CENTX  = .FALSE.
                     HIGHX  = .FALSE.
                     FXIN   = (XR-IXR+0.5)/WIDTH + 0.5
                  END IF
                  FXOUT  = 1. - FXIN
C
C *** the same in y
C
                  IF ((ABS(OFFY)-OFFMAX).LE.0) THEN
                      LOWY   = .FALSE.
                      CENTY  = .TRUE.
                      HIGHY  = .FALSE.
                      FYIN   = 1.
                  ELSE IF ((YR-IYR-OFFMAX).GT.0) THEN
                      LOWY   = .FALSE.
                      CENTY  = .FALSE.
                      HIGHY  = .TRUE.
                      FYIN   = (IYR+0.5-YR)/WIDTH + 0.5
                  ELSE
                      LOWY   = .TRUE.
                      CENTY  = .FALSE.
                      HIGHY  = .FALSE.
                      FYIN   = (YR-IYR+0.5)/WIDTH + 0.5
                  END IF
                  FYOUT  = 1. - FYIN
C
C ***  First case, then: subpixel completely within one output pixel
                  IF (CENTX .AND. CENTY) THEN
                     OUT(IXR,IYR) = OUT(IXR,IYR) + FLUX
                  ELSE IF (HIGHX) THEN          ! test if subpixel on right edge
                     IF (HIGHY) THEN               ! pixel on upper right corner
C
C *** direct flux of subpixel into the four output pixels concerned
                        OUT(IXR+1,IYR+1) = OUT(IXR+1,IYR+1) +
     +                                     FXOUT*FYOUT*FLUX
                        OUT(IXR+1,IYR)   = OUT(IXR+1,IYR) +
     +                                     FXOUT*FYIN*FLUX
                        OUT(IXR,IYR+1)   = OUT(IXR,IYR+1) +
     +                                     FXIN*FYOUT*FLUX
                        OUT(IXR,IYR)     = OUT(IXR,IYR) +
     +                                     FXIN*FYIN*FLUX
                     ELSE IF (LOWY) THEN     ! three subp. on lower right corner
                        OUT(IXR+1,IYR-1) = OUT(IXR+1,IYR-1) +
     +                                     FXOUT*FYOUT*FLUX
                        OUT(IXR+1,IYR) = OUT(IXR+1,IYR) +
     +                                     FXOUT*FYIN*FLUX
                        OUT(IXR,IYR-1) = OUT(IXR,IYR-1) +
     +                                     FXIN*FYOUT*FLUX
                        OUT(IXR,IYR) = OUT(IXR,IYR) +
     +                                     FXIN*FYIN*FLUX
C
                     ELSE          ! four: subpixel on center right edge
C                                  ! (need to consider now only 2 output pixels)
                        OUT(IXR+1,IYR) = OUT(IXR+1,IYR) + FXOUT*FLUX
                        OUT(IXR,IYR)   = OUT(IXR,IYR) + FXIN*FLUX
                     END IF
                  ELSE IF (LOWX) THEN              ! subpixel falls on left edge
                     IF (HIGHY) THEN       ! five: subpixel on upper left corner
                        OUT(IXR-1,IYR+1) = OUT(IXR-1,IYR+1) +
     +                                     FXOUT*FYOUT*FLUX
                        OUT(IXR-1,IYR)   = OUT(IXR-1,IYR) +
     +                                     FXOUT*FYIN*FLUX
                        OUT(IXR,IYR+1)   = OUT(IXR,IYR+1) +
     +                                     FXIN*FYOUT*FLUX
                        OUT(IXR,IYR)     = OUT(IXR,IYR) +
     +                                     FXIN*FYIN*FLUX
C
                     ELSE IF (LOWY) THEN    ! six: subpixel on lower left corner
                        OUT(IXR-1,IYR-1) = OUT(IXR-1,IYR-1) +
     +                                     FXOUT*FYOUT*FLUX
                        OUT(IXR-1,IYR)   = OUT(IXR-1,IYR) +
     +                                     FXOUT*FYIN*FLUX
                        OUT(IXR,IYR-1)   = OUT(IXR,IYR-1) +
     +                                     FXIN*FYOUT*FLUX
                        OUT(IXR,IYR)     = OUT(IXR,IYR) +
     +                                      FXIN*FYIN*FLUX
C
                      ELSE          ! seventh case: subpixel on center left edge
                         OUT(IXR-1,IYR) = OUT(IXR-1,IYR) + FXOUT*FLUX
                         OUT(IXR,IYR)   = OUT(IXR,IYR) + FXIN*FLUX
                      END IF
C
                  ELSE      ! now only the center upper and lower edges are left
                     IF (LOWY) THEN       ! eigth: subpixel on center lower edge
                        OUT(IXR,IYR-1) = OUT(IXR,IYR-1) + FYOUT*FLUX
                        OUT(IXR,IYR) = OUT(IXR,IYR) + FYIN*FLUX

                     ELSE                  !nine: subpixel on center upper edge 
                        OUT(IXR,IYR+1) = OUT(IXR,IYR+1) + FYOUT*FLUX
                        OUT(IXR,IYR) = OUT(IXR,IYR) + FYIN*FLUX
                     END IF
                  END IF  
   10          CONTINUE                       !   this row of sub-subpixels done
   20       CONTINUE                       !   this column of sub-subpixels done
   30    CONTINUE                             !   this row of (sub-) pixels done
C
C *** feed them progress messages ...
C
         IF (((10*L)/NPYIP).GE. (NPERC+1)) THEN
            NPERC  = NPERC + 1
            WRITE (PROGR,9000) 10*NPERC
            CALL STTPUT(PROGR,ISTAT)
         END IF
C  
   40 CONTINUE                             !   this column of (sub-) pixels done
C
      RETURN
      END


      SUBROUTINE RCTSIN(IN,NPX,NPY,IPOL)
C +++
C.PURPOSE:     Interpolation
C.ALGORITHM:   Each input pixel is divided into 9 subpixels
C              Their indices are defined as follows:
C              1,3   2,3   3,3       FIRST INDEX:  X
C              1,2   2,2   3,2
C              1,1   2,1   3,1     SECOND INDEX: Y
C
C              For the interpolation, the following weighting scheme is used:
C             .1667       .1667      .333      .1667       .1667
C                      --------------------------------
C             .1667    |  .5         .667      .5     |    .1667
C             .333     |  .667      (1.)       .667   |    .333
C             .1667    |  .5         .667      .5     |    .1667
C                      --------------------------------
C             .1667       .1667      .333      .1667       .1667
C
C                (the box marks the edges of one input pixel)
C
C.NOTE:        This "deconvolution" makes an implicit assumption about
C              the point spread function, namely that its fwhm is smaller 
C              than or roughly equal to one input pixel. future improvements
C              could include reading in a more realistic or even exact 
C              point spread function and doing a proper deconvolution.
C ---
      IMPLICIT  NONE
C
      INTEGER   NPX, NPY
      REAL      IPOL(3*NPX,3*NPY)
      REAL      SUB(3,3),IN(*)
C
      INTEGER   NPERC,INDXX,INDXY
      INTEGER   ISTAT, K, L, I, J, IPOS
      CHARACTER PROGR*50

 9000 FORMAT ('*** INFO: ',I3,' percent completed ...')
C
      CALL STTPUT('*** INFO: Deconvolution started',ISTAT)
      NPERC  = 0
C
C *** Begin with all pixels on the edge of the input frame
C *** lower left corner
C
      DO 20 K = 1,3
         DO 10 L = 1,3
            SUB(K,L) = IN(1)
   10    CONTINUE
   20 CONTINUE
C  
      SUB(3,1) = .667*IN(1) + .333*IN(2)          !   first index: x, second: y
      SUB(3,2) =  SUB(3,1)
      SUB(3,3) = .5*IN(1) + .1667* (IN(2)+IN(NPX+1)+IN(NPX+2))
      SUB(2,3) = .667*IN(1) + .333*IN(NPX+1)
      SUB(1,3) =  SUB(2,3)
      CALL RCTSSC(SUB,IN(1))
C
      DO 40 K = 1,3
         DO 30 L = 1,3
            INDXX  = K
            INDXY  = L
            IPOL(INDXX,INDXY) = IPOL(INDXX,INDXY) + SUB(K,L)
   30    CONTINUE
   40 CONTINUE
C
C *** lower right corner
C
      DO 60 K = 1,3
         DO 50 L = 1,3
            SUB(K,L) = IN(NPX)
   50    CONTINUE
   60 CONTINUE
C
      SUB(1,1) = .667*IN(NPX) + .333*IN(NPX-1)
      SUB(1,2) = SUB(1,1)
      SUB(1,3) = .5*IN(NPX) + .1667* (IN(NPX-1)+IN(2*NPX-1)+IN(2*NPX))
      SUB(2,3) = .667*IN(NPX) + .333*IN(2*NPX)
      SUB(3,3) = SUB(2,3)
C
      CALL RCTSSC(SUB,IN(NPX))
C
      DO 80 K = 1,3
         DO 70 L = 1,3
            INDXX  = NPX*3 - 3 + K
            INDXY  = L
            IPOL(INDXX,INDXY) = IPOL(INDXX,INDXY) + SUB(K,L)
   70    CONTINUE
   80 CONTINUE
C
C *** upper left corner
C
      IPOS  = NPX*(NPY-1) + 1
      DO 100 K = 1,3
         DO 90 L = 1,3
            SUB(K,L) = IN(IPOS)
   90    CONTINUE
  100 CONTINUE
C
      SUB(1,1) = .667*IN(IPOS) + .333*IN(IPOS-NPX)
      SUB(2,1) = SUB(1,1)
      SUB(3,1) = .5*IN(IPOS) + .1667* (IN(IPOS-NPX)+IN(IPOS-NPX-1)+
     +           IN(IPOS+1))
      SUB(3,2) = .667*IN(IPOS) + .333*IN(IPOS+1)
      SUB(3,3) = SUB(3,2)
      CALL RCTSSC(SUB,IN(IPOS))
C
      DO 120 K = 1,3
         DO 110 L = 1,3
            INDXX  = K
            INDXY  = NPY*3 - 3 + L
            IPOL(INDXX,INDXY) = IPOL(INDXX,INDXY) + SUB(K,L)
  110    CONTINUE
  120 CONTINUE
C
C *** upper right corner
C
      IPOS   = NPX*NPY
      DO 140 K = 1,3
         DO 130 L = 1,3
            SUB(K,L) = IN(IPOS)
  130    CONTINUE
  140 CONTINUE
C
      SUB(1,3) = .667*IN(IPOS) + .333*IN(IPOS-1)
      SUB(1,2) =  SUB(1,3)
      SUB(3,1) = .5*IN(IPOS) + .1667* (IN(IPOS-1)+IN(IPOS-NPX-1)+
     +            IN(IPOS-NPX))
      SUB(2,1) = .667*IN(IPOS) + .333*IN(IPOS-NPX)
      SUB(3,1) =  SUB(2,1)
      CALL RCTSSC(SUB,IN(IPOS))
C
      DO 160 K = 1,3
         DO 150 L = 1,3
            INDXX  = NPX*3 - 3 + K
            INDXY  = NPY*3 - 3 + L
            IPOL(INDXX,INDXY) = IPOL(INDXX,INDXY) + SUB(K,L)
  150    CONTINUE
  160 CONTINUE
C
C  *** bottom edge
C
      DO 210 I = 2,NPX - 1
         IPOS   = I
         DO 180 K = 1,3
            DO 170 L = 1,3
               SUB(K,L) = IN(IPOS)
  170       CONTINUE
  180    CONTINUE
C
         SUB(1,1) = .667*IN(IPOS) + .333*IN(IPOS-1)
         SUB(1,2) = SUB(1,1)
         SUB(1,3) = .5*IN(IPOS) + .1667*
     +              (IN(IPOS-1)+IN(IPOS+NPX-1)+IN(IPOS+NPX))
         SUB(2,3) = .667*IN(IPOS) + .333*IN(IPOS+NPX)
         SUB(3,3) = .5*IN(IPOS) + .1667*
     +              (IN(IPOS+1)+IN(IPOS+NPX)+IN(IPOS+NPX+1))
         SUB(3,2) = .667*IN(IPOS) + .333*IN(IPOS+1)
         SUB(3,1) = SUB(3,2)
         CALL RCTSSC(SUB,IN(IPOS))
C
         DO 200 K = 1,3
            DO 190 L = 1,3
               INDXX  = I*3 - 3 + K
               INDXY  = L
               IPOL(INDXX,INDXY) = IPOL(INDXX,INDXY) + SUB(K,L)
  190       CONTINUE
  200    CONTINUE
  210 CONTINUE
C
C *** top edge
C
      DO 260 I = 2,NPX - 1
         IPOS   = (NPY-1)*NPX + I
         DO 230 K = 1,3
            DO 220 L = 1,3
               SUB(K,L) = IN(IPOS)
  220       CONTINUE
  230    CONTINUE
C
         SUB(1,3) = .667*IN(IPOS) + .333*IN(IPOS-1)
         SUB(1,2) = SUB(1,3)
         SUB(1,1) = .5*IN(IPOS) + .1667*
     +              (IN(IPOS-1)+IN(IPOS-NPX-1)+IN(IPOS-NPX))
         SUB(2,1) = .667*IN(IPOS) + .333*IN(IPOS-NPX)
         SUB(3,1) = .5*IN(IPOS) + .1667*
     +              (IN(IPOS-NPX)+IN(IPOS-NPX)+IN(IPOS-NPX+1))
         SUB(3,2) = .667*IN(IPOS) + .333*IN(IPOS+1)
         SUB(3,3) = SUB(3,2)
         CALL RCTSSC(SUB,IN(IPOS))
C
         DO 250 K = 1,3
            DO 240 L = 1,3
               INDXX  = I*3 - 3 + K
               INDXY  = NPY*3 - 3 + L
               IPOL(INDXX,INDXY) = IPOL(INDXX,INDXY) + SUB(K,L)
  240       CONTINUE
  250    CONTINUE
  260 CONTINUE
C
C *** left edge
C
      DO 310 J = 2,NPY - 1
         IPOS   = (J-1)*NPX + 1
         DO 280 K = 1,3
            DO 270 L = 1,3
               SUB(K,L) = IN(IPOS)
  270       CONTINUE
  280    CONTINUE
C
         SUB(1,1) = .667*IN(IPOS) + .333*IN(IPOS-NPX)
         SUB(2,1) = SUB(1,1)
         SUB(3,1) = .5*IN(IPOS) + .1667*
     +              (IN(IPOS-NPX)+IN(IPOS-NPX+1)+IN(IPOS+1))
         SUB(3,2) = .667*IN(IPOS) + .333*IN(IPOS+1)
         SUB(3,3) = .5*IN(IPOS) + .1667*
     +              (IN(IPOS+1)+IN(IPOS+NPX+1)+IN(IPOS+NPX))
         SUB(2,3) = .667*IN(IPOS) + .333*IN(IPOS+NPX)
         SUB(1,3) = SUB(2,3)
         CALL RCTSSC(SUB,IN(IPOS))
C
         DO 300 K = 1,3
            DO 290 L = 1,3
               INDXX  = K
               INDXY  = J*3 - 3 + L
               IPOL(INDXX,INDXY) = IPOL(INDXX,INDXY) + SUB(K,L)
  290       CONTINUE
  300    CONTINUE
  310 CONTINUE
C
C *** right edge
C
      DO 360 J = 2,NPY - 1
         IPOS   = J*NPX
         DO 330 K = 1,3
            DO 320 L = 1,3
               SUB(K,L) = IN(IPOS)
  320       CONTINUE
  330    CONTINUE
C
         SUB(3,1) = .667*IN(IPOS) + .333*IN(IPOS-NPX)
         SUB(2,1) = SUB(3,1)
         SUB(1,1) = .5*IN(IPOS) + .1667*
     +              (IN(IPOS-NPX)+IN(IPOS-NPX-1)+IN(IPOS-1))
         SUB(1,2) = .667*IN(IPOS) + .333*IN(IPOS-1)
         SUB(1,3) = .5*IN(IPOS) + .1667*
     +              (IN(IPOS-1)+IN(IPOS+NPX-1)+IN(IPOS+NPX))
         SUB(2,3) = .667*IN(IPOS) + .333*IN(IPOS+NPX)
         SUB(3,3) = SUB(2,3)
         CALL RCTSSC(SUB,IN(IPOS))
C
         DO 350 K = 1,3
            DO 340 L = 1,3
               INDXX  = NPX*3 - 3 + K
               INDXY  = J*3 - 3 + L
               IPOL(INDXX,INDXY) = IPOL(INDXX,INDXY) + SUB(K,L)
  340       CONTINUE
  350    CONTINUE
  360 CONTINUE
C
C *** and now the rest is straight forward
C
      DO 400 J = 2,NPY - 1
         DO 390 I = 2,NPX - 1
            IPOS   = (J-1)*NPX + I  !   CENTRAL SUBPIXEL
            SUB(2,2) = IN(IPOS)
            SUB(1,1) = .5*IN(IPOS) + .1667*
     +                 (IN(IPOS-1)+IN(IPOS-NPX-1)+IN(IPOS-NPX))
            SUB(2,1) = .667*IN(IPOS) + .333*IN(IPOS-NPX)
            SUB(3,1) = .5*IN(IPOS) + .1667*
     +                 (IN(IPOS-NPX)+IN(IPOS-NPX+1)+IN(IPOS+1))
            SUB(3,2) = .667*IN(IPOS) + .333*IN(IPOS+1)
            SUB(3,3) = .5*IN(IPOS) + .1667*
     +                (IN(IPOS+1)+IN(IPOS+NPX+1)+IN(IPOS+NPX))
            SUB(2,3) = .667*IN(IPOS) + .333*IN(IPOS+NPX)
            SUB(1,3) = .5*IN(IPOS) + .1667*
     +                 (IN(IPOS+NPX)+IN(IPOS+NPX-1)+IN(IPOS-1))
            SUB(1,2) = .667*IN(IPOS) + .333*IN(IPOS-1)
            CALL RCTSSC(SUB,IN(IPOS))
C
            DO 380 K = 1,3
               DO 370 L = 1,3
                  INDXX  = I*3 - 3 + K
                  INDXY  = J*3 - 3 + L
                  IPOL(INDXX,INDXY) = IPOL(INDXX,INDXY) + SUB(K,L)
  370          CONTINUE
  380       CONTINUE
  390    CONTINUE
C
C *** feed them progress messages ...
C
         IF (((10*J)/NPY).GE. (NPERC+1)) THEN
            NPERC  = NPERC + 1
            WRITE (PROGR,9000) 10*NPERC
            CALL STTPUT(PROGR,ISTAT)
         END IF
  400 CONTINUE

      RETURN
      END


      SUBROUTINE RCTSSC(SUB,IN)
C +++
C.PURPOSE: This subroutine compares the sum of the fluxes in the individual
C          subpixels to the flux in the original input pixel. The fluxes in
C          the subpixels are then scaled such that their sum equals the
C          original flux. Hence, flux conservation should be achieved on the
C          pixel scale.
C ---
      IMPLICIT  NONE
C
      REAL      SUB(3,3),IN,SUM,SCALE
C
      INTEGER   L, K
C
      SCALE  = 1
      SUM    = SUB(1,1) + SUB(1,2) + SUB(1,3) + SUB(2,1) + SUB(2,2) +
     +         SUB(2,3) + SUB(3,1) + SUB(3,2) + SUB(3,3)
C  
      IF (SUM.NE.0) THEN     ! assume sum does not vanish due to neg. fluxes ...
         SCALE  = IN/SUM 
      ENDIF
C
      DO 20 K = 1,3
         DO 10 L = 1,3
            SUB(K,L) = SUB(K,L)*SCALE
   10    CONTINUE
   20 CONTINUE
C
      RETURN
      END

      SUBROUTINE OUTDSP(REFIMA,START,STEP,NPIX,
     .                  K,L,CX,OUTSTA,OUTSTP,OUTPIX)
C +++
C.PURPOSE: Determine starting coordinates and stepsizes of output frame
C.ALGORITHM
C          Use the coordinates in REFIMA if specified, otherwise
C          use default values for the wavelength domain.
C          
C ---
      IMPLICIT NONE
C
      CHARACTER*60     REFIMA
      DOUBLE PRECISION START(2),STEP(2),OUTSTA(2),END(2),OUTSTP(2)
      DOUBLE PRECISION OUTEND(2),CORNER(4,2)
      DOUBLE PRECISION CX(20),X,Y,OUTX,WORK(2)
      INTEGER          NPIX(2),OUTPIX(2),K,L
      INTEGER          IMF,KUN,KNUL
C
      INTEGER  MADRID, I, IAC, ISTAT
      DOUBLE PRECISION RESULT
      DOUBLE PRECISION OUTXMN,OUTXMX
C
      INCLUDE    'MID_INCLUDE:ST_DEF.INC/NOLIST'
      COMMON     /VMR/MADRID(1)
      INCLUDE    'MID_INCLUDE:ST_DAT.INC/NOLIST'
C
      DATA     OUTXMN/1.E8/
      DATA     OUTXMX/-1.E8/
C
      IF (REFIMA(1:1) .EQ. '?') THEN
        DO 10 I = 1,2
           END(I) = START(I) + (NPIX(I)-1)*STEP(I)
   10   CONTINUE
C
        CORNER(1,1) = START(1)
        CORNER(1,2) = START(2)
        CORNER(2,1) = START(1)
        CORNER(2,2) = END(2)
        CORNER(3,1) = END(1)
        CORNER(3,2) = START(2)
        CORNER(4,1) = END(1)
        CORNER(4,2) = END(2)
C
C ... image corners to output space
C
        DO 20 I = 1,4
            X      = CORNER(I,1)
            Y      = CORNER(I,2)
            CALL COMPOL(K,L,CX,X,Y,RESULT)
            OUTX = RESULT
            IF (OUTX.GT.OUTXMX) OUTXMX = OUTX
            IF (OUTX.LT.OUTXMN) OUTXMN = OUTX
   20   CONTINUE
C            OUTX   = CX(1) + X * (CX(2)+X  * (CX(3)+X*CX(4))) +
C     +             (CX(5)+X  * (CX(6)+X  * (CX(7)+X*CX(8))))*Y +
C     +             (CX(9)+X  * (CX(10)+X * (CX(11)+X*CX(12))))*Y*Y +
C     +             (CX(13)+X * (CX(14)+X * (CX(15)+X*CX(16))))*Y*Y*Y
C
C ... find new steps
C
        OUTSTP(1) = (OUTXMX-OUTXMN)/NPIX(1)
        OUTSTP(2) = STEP(2)
C
C ... Deduce maximal dimensions of output frame
C
        OUTSTA(1) = OUTXMN - 5*OUTSTP(1)               ! safety margin
        OUTEND(1) = OUTXMX + 5*OUTSTP(1)               ! safety margin
        OUTSTA(2) = START(2)
        OUTPIX(1) = (OUTEND(1)-OUTSTA(1))/OUTSTP(1) + 1
        OUTPIX(2) = NPIX(2)
      ELSE
C
C ... get descriptors from reference image
C
        CALL STFOPN(REFIMA,D_R4_FORMAT,0,F_IMA_TYPE,IMF,ISTAT)
        CALL STDRDI(IMF,'NPIX',1,2,IAC,OUTPIX,KUN,KNUL,ISTAT)
        CALL STDRDD(IMF,'START',1,2,IAC,WORK,KUN,KNUL,ISTAT)
        OUTSTA(1) = WORK(1)
        OUTSTA(2) = WORK(2)
        CALL STDRDD(IMF,'STEP',1,2,IAC,WORK,KUN,KNUL,ISTAT)
        OUTSTP(1) = WORK(1)
        OUTSTP(2) = WORK(2)
      ENDIF
      RETURN
      END

      SUBROUTINE COMPOL(K,L,CX,X,Y,RESULT)
C +++
C.PURPOSE: Compute polynomial value
C ---
      IMPLICIT NONE
C
      DOUBLE PRECISION CX(20),X,Y,WORK(30)
      INTEGER  K,L
C
      INTEGER  IP, K1, L1
      DOUBLE PRECISION DC, RESULT
C
      IP     = 0
      DC     = 1.D0
      RESULT = 0.D0
      DO 20 L1 = 0, L
         IP       = IP + 1
         WORK(IP) = DC
         RESULT   = RESULT + WORK(IP)*CX(IP)
         DO 10 K1 = 1, K
            IP = IP + 1
            WORK(IP) = WORK(IP-1)*X
            RESULT   = RESULT + WORK(IP)*CX(IP)
10       CONTINUE
         DC = DC*Y
20    CONTINUE 
      RETURN
      END

C @(#)necripp1.for	19.1 (ESO-DMD) 02/25/03 14:20:25
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
       PROGRAM ECHRP1
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C
C  program  ECHRIPP1              version 1.0       870820
C
C  Author :   J.D.Ponz            ESO - Garching
C
C.MODIFICATIONS
C
C  version 1.1   P. Ballester   901009   Option to freeze K and Alpha
C
C.KEYWORDS
C
C  ECHELLE, CASPEC, BLAZE FUNCTION
C
C.PURPOSE
C
C  COMPUTE THE ECHELLE CONSTANTS ALPHA AND K FOR EACH ECHELLE ORDER
C  (only if the flag is not set to FREEZE)
C
C.ALGORITHM
C
C  a new one...
C
C.INPUT/OUTPUT
C
C  RIPPLE/ECHELLE INPUT OUTPUT  K0,A0
C
C.VERSION
C 
C 010713		last modif
C 
C-------------------------------------------------------------
C 
       IMPLICIT  NONE
C 
       INTEGER          NPIXA(2),NPTOT(100),NORDER(100)
       INTEGER          I, ISTAT, KUN, KNUL, INIMA, OUTIMA
       INTEGER          MADRID(1), NAXISA
       INTEGER*8        IPNTRA, IPNTRB
C 
       DOUBLE PRECISION WSTART(100),STEPA(2),STARTA(2)
       DOUBLE PRECISION K0, ALPHA0,LAMBDA1,LAMBDA2
C 
       REAL             CUT(4), PARS(4), XMIN, XMAX
C 
       CHARACTER*80     INFRM, OUTFRM, TABLE, FREEZE
       CHARACTER        IDENTA*72,CUNITA*64
C 
       INCLUDE          'MID_INCLUDE:ST_DEF.INC'
       COMMON/VMR/MADRID
       INCLUDE          'MID_INCLUDE:ST_DAT.INC'
C
C ... INITIALIZE SYSTEM
C
       CALL STSPRO('ECHRP1')
       CALL STKRDC('P1',1,1,80,I,INFRM,KUN,KNUL,ISTAT)
       CALL STKRDC('P2',1,1,80,I,OUTFRM,KUN,KNUL,ISTAT)
       CALL CLNFRA(INFRM,INFRM,0)
       CALL CLNFRA(OUTFRM,OUTFRM,0)
       CALL STKRDR('INPUTR',1,4,I,PARS,KUN,KNUL,ISTAT)
       TABLE = 'riptab'
C       CALL STKRDC('P4',1,1,80,I,TABLE,KUN,KNUL,ISTAT)
       CALL STKRDC ('P5',1,1,80,I,FREEZE,KUN,KNUL,ISTAT)
       CALL STTPUT(' Ripple correction. Method FIT',ISTAT)
       LAMBDA1 = PARS(1)
       LAMBDA2 = PARS(2)
       K0     = PARS(3)
       ALPHA0 = PARS(4)
C
C ... MAP INPUT/OUTPUT FRMS
C
       CALL STIGET(INFRM,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     .             2,NAXISA,NPIXA,STARTA,STEPA,IDENTA,
     .             CUNITA,IPNTRA,INIMA,ISTAT)
       CALL STDRDR(INIMA,'LHCUTS',1,4,I,CUT,KUN,KNUL,ISTAT)
       CALL STDRDD(INIMA,'WSTART',1,NPIXA(2),I,WSTART,KUN,KNUL,ISTAT)
       CALL STDRDI(INIMA,'NPTOT',1,NPIXA(2),I,NPTOT,KUN,KNUL,ISTAT)
       CALL STDRDI(INIMA,'NORDER',1,NPIXA(2),I,NORDER,KUN,KNUL,ISTAT)
       CALL STIPUT(OUTFRM,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .             NAXISA,NPIXA,STARTA,STEPA,IDENTA,
     .             CUNITA,IPNTRB,OUTIMA,ISTAT)
C
C ... RIPPLE FUNCTION
C
       CALL RIPPLE1(NPIXA(1),NPIXA(2),MADRID(IPNTRA),MADRID(IPNTRB),
     .      WSTART,STEPA(1),NPTOT,NORDER,K0,ALPHA0,XMIN,XMAX,TABLE,
     .      LAMBDA1,LAMBDA2,FREEZE)
       XMIN = CUT(3)
       XMIN = CUT(4)
C
C ... WRITE PROCESS DESCRIPTORS
C
       CUT(1) = XMIN
       CUT(2) = XMAX
       CUT(3) = XMIN
       CUT(4) = XMAX
       CALL DSCUPT(INIMA,OUTIMA,' ',ISTAT)
       CALL STDWRR(OUTIMA,'LHCUTS',CUT,1,4,KUN,ISTAT)
       CALL STSEPI
       END

       SUBROUTINE RIPPLE1(NX,NY,X,Y,WS,WSTEP,NP,NO,K0,A0,
     .                        XMIN,XMAX,TABLE,LAMBDA1,LAMBDA2,FREEZE)
C
C       CORRECT FOR BLAZE EFFECT USING THE OVERLAPPING REGION
C
C       INPUT ARGUMENTS
C       NX       INTG       MAXIMUM NUMBER OF SAMPLES PER ORDER
C       NY       INTG       NUMBER OF ORDERS
C       X       REAL       X(NX,NY) INPUT IMAGE
C       WS       REAL       STARTING WAVELENGTH PER EACH ORDER
C       WSTEP       REAL       WAVELENGTH STEP
C       NP       INTG       NUMBER OF USEFUL SAMPLES PER ORDER
C       NO       INTG       SPECTRAL ORDER NUMBER
C       K0       REAL       INITIAL GUESS FOR THE CONSTANT K
C       A0       REAL       INITIAL GUESS FOR ALPHA
C       FREEZE   CHARACTER  Flag (NULL/FREEZE) to freeze values of K and Alpha
C
C       OUTPUT ARGUMENTS
C       Y       REAL       Y(NX,NY) CORRECTED IMAGE
C       XMIN       REAL       MINIMUN AND
C       XMAX       REAL       MAXIMUM VALUES
C
       IMPLICIT NONE
C 
       INTEGER           NX, NY
       INTEGER           NP(NY),NO(NY),IERR(2),ICOL(7), TID
       INTEGER           ISTAT, ISEQ, I, IORDER, I1, I2, ILR
C 
       REAL              X(NX,NY), Y(NX,NY), XMIN, XMAX
       REAL              VAL(7)
C 
       DOUBLE PRECISION  WS(NY), WSTEP, K0, A0,LAMBDA1,LAMBDA2
       DOUBLE PRECISION  K(2), KM, AM, A(2)
       DOUBLE PRECISION  DVAL1, DVAL2
C 
       LOGICAL           NULL(2)
C 
       CHARACTER*16      LABEL(7),UNIT(7),FORM
       CHARACTER*80      LINE,FREEZE
       CHARACTER*(*)     TABLE
C 
       INCLUDE          'MID_INCLUDE:ST_DEF.INC'
       INCLUDE          'MID_INCLUDE:ST_DAT.INC'
       DATA              FORM/'G12.4'/
       DATA              LABEL(1)/'ORDER'/,UNIT(1)/'UNITLESS'/
       DATA              LABEL(2)/'K'/,UNIT(2)/'UNITLESS'/
       DATA              LABEL(3)/'ALPHA'/,UNIT(3)/'UNITLESS'/
       DATA              LABEL(4)/'KFIT'/,UNIT(4)/'UNITLESS'/
       DATA              LABEL(5)/'AFIT'/,UNIT(5)/'UNITLESS'/
       DATA              LABEL(6)/'YMAX'/,UNIT(6)/'FLUX'/
       DATA              LABEL(7)/'STATUS'/,UNIT(7)/'UNITLESS'/
       DATA              TID /-1/
C
       ISEQ = 0
       XMIN = 1.E30
       XMAX = -XMIN
       IF (K0.LE.0.0) THEN                     
C
C ... CORRECT RIPPLE IF K0 IS NEGATIVE
C
         CALL TBTOPN(TABLE,F_I_MODE,TID,ISTAT)
         CALL TBLSER(TID,LABEL(2),ICOL(1),ISTAT)
         CALL TBLSER(TID,LABEL(3),ICOL(2),ISTAT)
         DO 10 IORDER=1, NY
           CALL TBRRDR(TID,IORDER,2,ICOL,VAL,NULL,ISTAT)
           DVAL1 = VAL(1)
           DVAL2 = VAL(2)
           CALL RIPCOR(WS(IORDER),WSTEP,NP(IORDER),X(1,IORDER),
     .                 Y(1,IORDER),NO(IORDER),DVAL1,DVAL2,NX)
10       CONTINUE
       ELSE
C
C ... FIND BLAZE PARAMETERS
C
         CALL TBTINI(TABLE,F_TRANS,F_O_MODE,8,NY,TID,ISTAT)
         DO 20 I = 1, 6
           CALL TBCINI(TID,D_R4_FORMAT,1,FORM,UNIT(I),LABEL(I),
     .                 ICOL(I),ISTAT)
20       CONTINUE
C
C ... ITERATION ON ALL CONSECUTIVE PAIRS OF ORDERS
C
         CALL STTPUT(' ORDER NUMER  FITTED K  FITTED ALPHA',ISTAT)
         CALL STTPUT(' ----------- ---------- ------------',ISTAT)
         DO 40 IORDER = 2, NY-1

         IF (FREEZE(1:1).EQ.'F'.OR.FREEZE(1:1).EQ.'f') THEN

           KM = K0
           AM = A0

         ELSE

           I1 = IORDER-2
C
C ... CONSIDER LEFT AND RIGHT OVERLAPPING REGIONS
C
           DO 30 ILR = 0, 1
             I1 = I1 + 1
             I2 = I1 + 1
             CALL FITKA(WS(I1),WSTEP,NP(I1),X(1,I1),NO(I1),     
     .                  WS(I2),NP(I2),X(1,I2),NO(I2),
     .                  K0,A0,K(ILR+1),A(ILR+1),IERR(ILR+1),
     .                  LAMBDA1,LAMBDA2)
30         CONTINUE
C
C ... COMPUTE MEAN VALUE
C
           KM = 0.5*(K(1) + K(2))
           AM = 0.5*(A(1) + A(2))

         ENDIF		! End of test on FREEZE

C           TYPE *,IORDER,KM,AM
C
C ... CORRECT FOR RIPPLE
C
           CALL RIPCOR(WS(IORDER),WSTEP,NP(IORDER),X(1,IORDER),
     .                     Y(1,IORDER),NO(IORDER),KM,AM,NX)
           IF (IORDER.EQ.2) THEN
             CALL RIPCOR(WS(1),WSTEP,NP(1),X(1,1),Y(1,1),
     .                       NO(1),KM,AM,NX)
             VAL(1) = NO(1)
             VAL(2) = KM
             VAL(3) = AM
             VAL(4) = KM
             VAL(5) = AM
             ISEQ = ISEQ + 1
             CALL TBRWRR(TID,ISEQ,6,ICOL,VAL,ISTAT)
           ENDIF
           VAL(1) = NO(IORDER)
           VAL(2) = KM
           VAL(3) = AM
           VAL(4) = KM
           VAL(5) = AM
           ISEQ = ISEQ + 1
           CALL TBRWRR(TID,ISEQ,6,ICOL,VAL,ISTAT)
           IF (IORDER.EQ.NY-1) THEN
             CALL RIPCOR(WS(NY),WSTEP,NP(NY),X(1,NY),Y(1,NY),
     .                   NO(NY),KM,AM,NX)
             VAL(1) = NO(NY)
             VAL(2) = KM
             VAL(3) = AM
             VAL(4) = KM
             VAL(5) = AM
             ISEQ = ISEQ + 1
             CALL TBRWRR(TID,ISEQ,6,ICOL,VAL,ISTAT)
           ENDIF
C
C ... WRITE OUT RESULTS
C
           WRITE(LINE,100) NO(IORDER),KM,AM
           CALL STTPUT(LINE,ISTAT)
40       CONTINUE
         CALL TBSINI(TID,ISTAT)
       ENDIF
       CALL TBTCLO(TID,ISTAT)
       RETURN
100    FORMAT(4X,I8,F12.2,F12.4)
       END

       SUBROUTINE RIPCOR(W1,WS,NP,X,Y,M,K,A,NX)
C
C       CORRECT FOR RIPPLE FUNCTION
C
C       INPUT ARGUMENTS
C       W1      INITIAL WAVELENGTH
C       WS      WAVELENGTH STEP
C       NP      NO. OF POINTS
C       X       INPUT FLUX
C       M       ORDER NUMBER
C       K       K CONSTANT
C       A       ALPHA CONSTANT
C
C       OUTPUT ARGUMENTS
C       Y       CORRECTED FLUX
C
       IMPLICIT NONE
       INTEGER          NP, NX, M
       REAL             X(NP),Y(NX)
       DOUBLE PRECISION W1,WS,K,A
       DOUBLE PRECISION PI,DK,DA,DW,DM,R,DX,PA,DC
       INTEGER          I
       DATA             PI/3.1415926535897932D0/
C
       DK = K
       DA = A
       DM = M
       PA = PI*A
       DC = DM/DK
       DO 10 I = 1, NP
         DW   = W1 + (I-1)*WS
         DX   = (PA*DM*DC)*(DW-1.D0/DC)
         IF (DABS(DX).LT.1.D-10) THEN
           Y(I) = X(I)
         ELSE                  
           R    = DSIN(DX)/DX
           Y(I) = X(I)/(R*R) 
         ENDIF
10     CONTINUE
       DO 20 I = NP+1, NX
         Y(I) = 0.
20     CONTINUE
       RETURN
       END

       SUBROUTINE FITKA(WSTART1,WSTEP,N1,X1,NO1,     
     .                  WSTART2,N2,X2,NO2,K0,A0,K,A,IERR,
     .                  LAMBDA1,LAMBDA2)
C
C       COMPUTE CONTANT K AND ALPHA
C
C       INPUT ARGUMENTS
C       WSTEP    WAVELENGTH STEP
C       WSTART1  STARTING WAVELENGTH ORDER M+1
C       N1       NUMBER OF POINTS IN ORDER M+1
C       X1       FLUX IN ORDER M+1
C       NO1      ORDER M+1
C       WSTART2  STARTING WAVELENGTH ORDER M
C       N2       NUMBER OF POINTS IN ORDER M
C       X2       FLUX IN ORDER M
C       NO2      ORDER M
C       K0       INITIAL K VALUE
C       A0       ALPHA
C
C       OUTPUT ARGUMENTS
C       K       FINAL K VALUE
C       A       FINAL A VALUE
C       IERR    CONVERGENCE FLAG 0 - GOOD VALUE
C                               OTHERWISE IT DOES NOT CONVERGE
C
C
       IMPLICIT NONE
       INTEGER           N1, N2
       REAL              X1(N1), X2(N2)
       DOUBLE PRECISION  WSTART1, WSTART2, WSTEP
       DOUBLE PRECISION  DW1, DW2, W2, K0, K, A0, A,LAMBDA1,LAMBDA2
       DOUBLE PRECISION  ETA, XTOL, STEPMX, XPAR(2), FSUMSQ
       DOUBLE PRECISION  FVEC(300), FJAC(300,2),S(2), V(2,2), W(1500)
       DOUBLE PRECISION  XX1(300),XX2(300),XSTART,XSTEP
       INTEGER           ORD1, ORD2, IW(1), ISTAT, NPIX, I1, I2
       INTEGER           NO1, NO2, J, J1, IPRINT, NPAR, MAXCAL
       INTEGER           IERR, NF, NITER, IFAIL, LV, LW, LJ, LIW
C       INTEGER           I
C       CHARACTER*80      LINE
C
       DOUBLE PRECISION  DSQRT, X02AAF
       EXTERNAL          LSQFUN, LSQMON
       COMMON/E04PAR/XSTART,XSTEP,ORD1,ORD2,XX1,XX2
C
       DW1  = (WSTART1 + (N1-1)*WSTEP) - WSTART2
       IF (DW1.LE.0.D0) THEN
         CALL STTPUT('Warning: There is no order overlap',ISTAT)
         RETURN
       ENDIF
C       DW2  = DW1*0.8D0
C       W2   = DW1*0.1D0
       DW2 = LAMBDA2
       W2 = LAMBDA1
       IF ((DW2+W2).GT.DW1) THEN 
          CALL STTPUT('Warning: Wrong wavelengths !',ISTAT)
C          TYPE *,DW1
       ENDIF
C       TYPE *,' *** ORDERS :',NO1,NO2,' ***',W2,DW2
       NPIX = DW2/WSTEP
       NPIX = MIN(NPIX,300)
       I1   = (WSTART2+W2-WSTART1)/WSTEP 
       I2   = W2/WSTEP 
C
C ... PREPARE INPUT
C
       ORD1 = NO1
       ORD2 = NO2
       XSTEP  = WSTEP
       XSTART = WSTART2 + W2 
       DO 10 J = 1, NPIX
         J1 = J-1
         XX1(J) = X1(I1 + J1)
         XX2(J) = X2(I2 + J1)
10     CONTINUE
C100    CONTINUE
C
C ... START MINIMIZATION 
C
       IPRINT = 1
       NPAR   = 2
       MAXCAL = 50*NPAR
       ETA    = 0.9
       XTOL   = 10.*DSQRT(X02AAF(XTOL))
       STEPMX = 10.
       XPAR(1)= K0
       XPAR(2)= A0
       LV     = 2
       LJ     = 300
       LIW    = 1
       LW     = 1500
       IFAIL  = 1
       CALL E04GDF(NPIX,NPAR,LSQFUN,LSQMON,IPRINT,MAXCAL,ETA,XTOL,
     .      STEPMX,XPAR,FSUMSQ,FVEC,FJAC,LJ,S,V,LV,NITER,NF,
     .      IW,LIW,W,LW,IFAIL)
C
C ... TYPE RESULTS
C
C       TYPE *,'IFAIL,SUMSQ',IFAIL,FSUMSQ
C       TYPE *,'K,A',XPAR(1),XPAR(2)
       K = XPAR(1)
       A = XPAR(2)
       RETURN
       END

       SUBROUTINE LSQFUN(IFLAG,M,N,XC,FVECC,FJACC,LJC,IW,LIW,W,LW)
C
C       SUBROUTINE TO COMPUTE THE RESIDUALS AND THEIR FIRST DERIVATIVE
C
C
       IMPLICIT NONE
       INTEGER              IFLAG, M, N, LJC, LIW, LW
C
       DOUBLE PRECISION     FJACC(LJC,N), FVECC(M), W(LW), XC(N)       
C
       DOUBLE PRECISION     XX1(300),XX2(300),XSTART,XSTEP
       INTEGER              ORD1, ORD2, IW(LIW), I
C
       DOUBLE PRECISION     PA, PI, WL, PA2, P2
       DOUBLE PRECISION     X10, X1, X13, S1, C1, R1, DKR1, DAR1
       DOUBLE PRECISION     X20, X2, X23, S2, C2, R2, DKR2, DAR2
C
       COMMON/E04PAR/XSTART,XSTEP,ORD1,ORD2,XX1,XX2
       DATA              PI/3.1415926535897932D0/
C
       PA = PI*XC(2)
       PA2 = 2.D0*PA
       P2  = 2.D0*PI
       DO 10 I = 1, M
         WL  = XSTART + (I-1)*XSTEP
         X10 = ORD1 - XC(1)/WL
         X1  = PA*X10
         X13 = X1*X1*X1
         S1  = DSIN(X1)
         C1  = DCOS(X1)
         R1  = S1/X1
         X20 = ORD2 - XC(1)/WL
         X2  = PA*X20
         X23 = X2*X2*X2
         S2  = DSIN(X2)
         C2  = DCOS(X2)
         R2  = S2/X2
         IF (IFLAG.EQ.2) FVECC(I) = R1*R1/XX1(I) - R2*R2/XX2(I)
         DKR1 = (PA2/(WL*X13))*(S1*S1-X1*S1*C1) 
         DKR2 = (PA2/(WL*X23))*(S2*S2-X2*S2*C2)
         DAR1 = (X1*S1*C1-S1*S1)*P2*X10/X13
         DAR2 = (X2*S2*C2-S2*S2)*P2*X20/X23
         FJACC(I,1) = DKR1/XX1(I) - DKR2/XX2(I)
         FJACC(I,2) = DAR1/XX1(I) - DAR2/XX2(I)
10     CONTINUE
       RETURN
       END

       SUBROUTINE LSQMON(M,N,XC,FVECC,FJACC,LJC,S,IGRADE,NITER,NF,
     .                       IW,LIW,W,LW)
C
C       MONITORING SUBROUTINE
C
       IMPLICIT NONE
       INTEGER          M, N, LJC, IGRADE, NITER, NF, LIW, LW
       DOUBLE PRECISION FJACC(LJC,N), FVECC(M), W(LW), XC(N), S(N)
       INTEGER          IW(LIW)
C
C       DOUBLE PRECISION FSUMSQ, GTG, G(50), F01DEF
C       INTEGER          J
C
C       FSUMSQ = F01DEF(FVECC,FVECC, M)
C       CALL LSQGRD(M, N, FVECC, FJACC, LJC, G)
C       GTG    = F01DEF(G,G,N)
C       WRITE(6, 99999) NITER, NF, FSUMSQ, GTG, IGRADE
C       WRITE(6, 99998)
C       DO 20 J = 1,  N
C          WRITE(6, 99997) XC(J), G(J), S(J)
C20     CONTINUE
       RETURN
C99999  FORMAT(///'    ITNS',4X,'F  EVALS',10X, ' SUMSQ',13X,'GTG',
C     . 8X,'GRADE'/1X I4,6X,I5,6X,1PE13.5,6X,1PE9.1,6X,I3)
C99998  FORMAT(/8X,'X',20X,'G',11X,'SINGULAR VALUES')
C99997  FORMAT(1X,1PE13.5,10X,1PE9.1,10X,1PE9.1)
       END

       SUBROUTINE LSQGRD(M, N, FVECC, FJACC, LJC, G)
C
       IMPLICIT NONE
       INTEGER LJC, M, N
       DOUBLE PRECISION FVECC(M), FJACC(LJC, N), G(N)
       DOUBLE PRECISION SUM
       INTEGER          J, I
C
       DO 40 J = 1, N
          SUM = 0.D0
          DO 20 I =1, M
             SUM = SUM + FJACC(I, J)*FVECC(I)
20        CONTINUE
          G(J) = SUM + SUM
40     CONTINUE
C
       RETURN
       END

C @(#)sunsubs.for	19.1 (ES0-DMD) 02/25/03 13:23:51
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      subroutine fabort
      call sun_abort
      return
      end
c
c=================================================================
c
      subroutine clfile (lun)
      close (lun)
      end
c
c=========================================================================
c
      subroutine byebye
      write (6,*)
      write (6,*) 'Good bye.'
      write (6,*)
      stop
      end
c
c==========================================================================
c
      subroutine  oops
      write (6,*)
      write (6,*) 'Sorry about that.'
      write (6,*)
      stop
      end
c
c==============================================================================
c
      subroutine infile (lun, file, istat)
      character*100 expand
      character*30 file
      open (lun, file=expand(file), status='old', err=999)
      istat = 0
      return
  999 istat = -1
      return
      end
c
c========================================================
c
      character*100 function expand(file)
      character*30 file
      do i=2,29
         if (file(i:i) .eq. ':') then
            call getenv (file(1:i-1), expand)
            do j=1,100
               if (expand(j:j) .ne. ' ') k=j
            end do
            if (k .ne. 0) then
               expand = expand(1:k)//'/'//file(i+1:30)
               return
            end if
         end if
      end do
      expand = file
      return
      end
c
c======================================================
c
      subroutine outfil (lun, file, istat)
      character*100 expand
      character*30 file, answer
      logical exist
 1000 inquire (file=expand(file), exist=exist)
      if (exist) then
         call stupid ('This file already exists: '//file)
         answer = 'OVERWRITE'
         call getnam ('New output file name:', answer)
         if (answer .eq. 'OVERWRITE') then
            open (lun, file=expand(file), status='old')
            close (lun, status='delete')
         else
            file = answer
            go to 1000
         end if
      end if
      open (lun, file=expand(file), status='new', iostat=istat)
      return
      end
c
c====================================================
c
      character*(*) function case (string)
      character*(*) string
c
c For UNIX, leave the cases of the characters alone!
c
      case = string
      return
      end 
c
c
c
      subroutine ovrwrt (line, iwhich)
      character*(*) line
      character*79 output
      integer len
      if (iwhich .eq. 1) then
         write (6,1) line
    1    format (a)
      else if (iwhich .eq. 2) then
         if (len(line) .lt. 79) then
            output = ' '
            output = line
            write (6,2) output, char(13)
    2       format (a, a1, $)
         else
            write (6,2) line, char(13)
         end if
      else if (iwhich .eq. 3) then
         write (6,3) line
    3    format (a)
      else
         write (6,4) line, char(13)
    4    format (/a, a1, $)
      end if
      return
      end

C @(#)lisib.for	19.1 (ES0-DMD) 02/25/03 13:29:44
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE LISIB(RMT,VC,NIN,NCD,SIGP)
C
C++++
C
C----
      IMPLICIT   NONE
      INTEGER    NCD
      REAL       RMT(NCD,NCD)
      REAL       VC(NCD)
      INTEGER    NIN	
      REAL       SIGP(1)
C
      REAL       DEL(1000)
      INTEGER    I, J, K
      REAL       DET
C 
C ***
      DO 10 I = 1,NIN
         DEL(I) = 0
   10 CONTINUE
C
      CALL SMAIN(RMT,NCD,NIN,DET)
      DO 20 J = 1,NIN
         DO 21 K = 1,NIN
            DEL(J) = DEL(J)+VC(K)*RMT(J,K)
   21    CONTINUE
   20 CONTINUE
C
      DO 30 J=1,NIN
         VC(J)   = DEL(J)
         SIGP(J) = SQRT(RMT(J,J))
   30 CONTINUE
      
      RETURN
      END

C @(#)octfrr.for	19.1 (ES0-DMD) 02/25/03 13:25:37
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine OCTFRR         version 1.2       830908
C  A. Kruszewski             ESO Garching
C  modified                  version 1.3       870303
C  A. Kruszewski             Obs. de Geneve
C.KEYWORDS
C  profiles, Fourier coefficients
C.PURPOSE
C  calculates Fourier coefficients of a profile "PRFL" as a function
C  of octants "COEF"
C  calculates also Fourier amplitudes "FAMP"
C.INPUT/OUTPUT
C  input arguments
C  PRFL        real*4 array      two-dimensional profile
C  ICNT        integer*4 array   numbers of used pixels at calculating PRFL
C  AVPR        real*4 array      one dimensional profile
C  LIM         integer*4         number of rings considered
C  LOUT        integer*4         flag enabling output
C  output arguments
C  COEF        real*4 array      Fourier coefficients
C  FAMP        real*4 array      Fourier amplitudes
C  average profiles "AVPR" and Fourier amplitudes are outputted
C  into log file when "LOUT=3"
C-----------------------------------------------------------------------
      SUBROUTINE OCTFRR(PRFL, ICNT, AVPR, LIM, COEF, FAMP)
C
      IMPLICIT  NONE
C
      INTEGER      LIM
      REAL         PRFL(8,0:LIM)
      INTEGER      ICNT(8,0:LIM)
      REAL         AVPR(0:LIM)
      REAL         COEF(7,LIM)
      REAL         FAMP(3,LIM)
C
      INTEGER      K, L
      LOGICAL      GOOD
C
      DO 10 K = 1 , LIM
            DO 20 L = 1 , 7
                  COEF(L,K) = 0.0
   20            CONTINUE
               DO 30 L = 1 , 3
                  FAMP(L,K) = 0.0
   30            CONTINUE
   10      CONTINUE
C
C ******      Calculate Fourier coefficients.
C
      K = 1
      GOOD = .TRUE.
   40      CONTINUE
               COEF(1,K) = 0.25*PRFL(1,K) + 0.17677*PRFL(2,K) -
     &                  0.17677*PRFL(4,K) - 0.25*PRFL(5,K) -
     &                  0.17677*PRFL(6,K) + 0.17677*PRFL(8,K)
                 COEF(2,K) = 0.17677*PRFL(2,K) + 0.25*PRFL(3,K) +
     &                  0.17677*PRFL(4,K) - 0.17677*PRFL(6,K) -
     &                  0.25*PRFL(7,K) - 0.17677*PRFL(8,K)
                 COEF(3,K) = 0.25*PRFL(1,K) - 0.25*PRFL(3,K) +
     &                  0.25*PRFL(5,K) - 0.25*PRFL(7,K)
                 COEF(4,K) = 0.25*PRFL(2,K) - 0.25*PRFL(4,K) +
     &                  0.25*PRFL(6,K) - 0.25*PRFL(8,K)
                 COEF(5,K) = 0.25*PRFL(1,K) - 0.17677*PRFL(2,K) +
     &                  0.17677*PRFL(4,K) - 0.25*PRFL(5,K) +
     &                  0.17677*PRFL(6,K) - 0.17677*PRFL(8,K)
                 COEF(6,K) = 0.17677*PRFL(2,K) - 0.17677*PRFL(3,K) +
     &                  0.25*PRFL(4,K) - 0.17677*PRFL(6,K) +
     &                  0.17677*PRFL(7,K) - 0.25*PRFL(8,K)
                 COEF(7,K) = 0.25*PRFL(1,K) - 0.25*PRFL(2,K) +
     &                  0.25*PRFL(3,K) - 0.25*PRFL(4,K) +
     &                  0.25*PRFL(5,K) - 0.25*PRFL(6,K) +
     &                  0.25*PRFL(7,K) - 0.25*PRFL(8,K)
C
C ******            Calculate Fourier amplitudes.
C
            FAMP(1,K) = SQRT( COEF(1,K)*COEF(1,K) +
     &                                    COEF(2,K)*COEF(2,K) )
            FAMP(2,K) = SQRT( COEF(3,K)*COEF(3,K) +
     &                                    COEF(4,K)*COEF(4,K) )
            FAMP(3,K) = SQRT( COEF(5,K)*COEF(5,K) +
     &                                    COEF(6,K)*COEF(6,K) )
                 K = K + 1
            IF ( K .LE. LIM ) THEN
                  IF ( MIN( ICNT(1,K) , ICNT(2,K) , ICNT(3,K) ,
     &                        ICNT(4,K) , ICNT(5,K) , ICNT(6,K) ,
     &                        ICNT(7,K) , ICNT(8,K) ) .EQ. 0 ) THEN
                             GOOD = .FALSE.
                  ENDIF
            ELSE
                  GOOD = .FALSE.
            ENDIF
      IF ( K .LE. LIM .AND. GOOD ) GOTO 40
C
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2006 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or
C modify it under the terms of the GNU General Public License as
C published by the Free Software Foundation; either version 2 of
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public
C License along with this program; if not, write to the Free
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C       Internet e-mail: midas@eso.org
C       Postal address: European Southern Observatory
C                       Data Management Division
C                       Karl-Schwarzschild-Strasse 2
C                       D 85748 Garching bei Muenchen
C                       GERMANY
C===========================================================================

      SUBROUTINE IIIGSE(DSPLAY,EVALNO,KSTRING,LL,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   KSTRING
      INTEGER     DSPLAY,EVALNO,LL,STATUS
C
      CALL STLOC(1,1,KSTRING)                       !blank CHAR_LOC
C 
      CALL III1(DSPLAY,EVALNO,LL,STATUS)            !get string
C
      RETURN
      END


      SUBROUTINE IIIGCE(DSPLAY,EVALNO,KSTRING,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   KSTRING
      INTEGER     DSPLAY,EVALNO,STATUS
C
      CALL STLOC(1,0,KSTRING)                       !untouched CHAR_LOC
C
      CALL III2(DSPLAY,EVALNO,STATUS)               !get char
C
      RETURN
      END

C @(#)necrebi.for	19.1 (ESO-IPG) 02/25/03 14:20:25
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM ECHREB
C
C+
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  10:37 - 11 JAN 1988
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: D.PONZ
C
C
C.IDENTIFICATION
C
C  program  ECHREBI1
C
C.MODIFICATIONS
C
C  910128   P.Ballester   Define and set variables
C
C.KEYWORDS
C
C  ECHELLE, CASPEC, REBIN
C
C.PURPOSE
C
C  OBTAIN A 1D FRM CALIBRATED IN WAVELENGTHS FROM A 2D FRM
C  OF TYPE ECHELLE WITH THE DISPERSION COEFFS DEFINED AS DESCRIPTORS
C
C.ALGORITHM
C
C  EACH LINE IN THE INPUT FRM IS REBINNED IN LINEAR STEP IN WAVELENGTH
C  ACCORDING TO THE DISPERSION COEFFS.
C
C.INPUT/OUTPUT
C
C  REBIN/ECHELLE INPUT OUTPUT STEP [METHOD] [TABLE]
C  OR
C  REBIN/ECHELLE INPUT OUTPUT REFER_IMAGE [METHOD] [TABLE]
C
C METHOD CAN BE EITHER "NONLINEAR" - NON LINEAR REBINNING USING
C                                     THE COEFFS IN THE TABLE
C                      "LINEAR"    - LINEAR REBINNING
C
C.MODIFICATIONS
C [2.2]  DEFINE THE SAMPLING DOMAIN VIA A REFER IMAGE
C 
C 010201		last modif
C 
C 
C-
      IMPLICIT NONE
C
      INTEGER      MADRID, ID, IR
      INTEGER      I,I1,IMNO
      INTEGER*8    IPNTRA
      INTEGER*8    IPNTRB
      INTEGER      ISTAT,NAXISA,NAXISB
      INTEGER      PIXBN, KUN,KNUL, NNNN
      INTEGER      NPIXA(3),NPIXB(3),IORD(2),IORD2(2),TID
      INTEGER      IORDER(100),NCOE(2),IA1(100),NPTOT(100)
      DOUBLE PRECISION WSTART(100),STEPA(3),STARTA(3)
      DOUBLE PRECISION STEPB(3),STARTB(3)
      DOUBLE PRECISION WSTEP, A1(7,100)
      REAL         CUT(4),XMIN,XMAX
      CHARACTER*60 OUTFRM,INFRM,REFER,TABLE
      CHARACTER    METHOD*1, LINE*80, DSCNAM*8
      CHARACTER    IDENTA*72,CUNITA*64,CUNITB*64
      LOGICAL      IREF
      INCLUDE      'MID_INCLUDE:ST_DEF.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE      'MID_INCLUDE:ST_DAT.INC'
      DATA CUNITB/'Flux            Relative wavel.'/
      DATA NPIXA /3*1/, STARTA /3*0.0/, STEPA /3*1.0/
      DATA NPIXB /3*1/, STARTB /3*0.0/, STEPB /3*1.0/
C
C ... INITIALIZE SYSTEM
C
      CALL STSPRO('ECHREB')
      CALL STKRDC('IN_A',1,1,60,I,INFRM,KUN,KNUL,ISTAT)
      CALL STKRDC('OUT_A',1,1,60,I,OUTFRM,KUN,KNUL,ISTAT)
      CALL CLNFRA(INFRM,INFRM,0)
      CALL CLNFRA(OUTFRM,OUTFRM,0)
      CALL STKRDC('P3',1,1,60,I,REFER,KUN,KNUL,ISTAT)
      CALL STKRDC('P4',1,1,1,I,METHOD,KUN,KNUL,ISTAT)
      I1     = INDEX('.+1234567890',REFER(1:1))
      IF (I1.NE.0) THEN
          CALL GENCNV(REFER,4,1,NNNN,XMIN,WSTEP,ISTAT)
          IF (ISTAT.LT.1) CALL STETER(11,'Wrong sampling step')
C 
          WRITE(LINE,9010) WSTEP
          CALL STTPUT(LINE,ISTAT)
          IREF   = .FALSE.
      ELSE
          IREF   = .TRUE.
          CALL CLNFRA(REFER,REFER,0)
      END IF
      IF (METHOD.EQ.'N' .OR. METHOD.EQ.'n') THEN
          CALL STKRDC('IN_B',1,1,60,I,TABLE,KUN,KNUL,ISTAT)
          CALL CLNTAB(TABLE,TABLE,0)
          CALL TBTOPN(TABLE,F_I_MODE,TID,ISTAT)
          CALL STDRDI(TID,'ORDER',1,2,I,IORD,KUN,KNUL,ISTAT)
          CALL STDRDI(TID,'COEFS',1,2,I,NCOE,KUN,KNUL,ISTAT)
          CALL STDRDD(TID,'COEFD',1,7*NCOE(2),I,A1,
     .                KUN,KNUL,ISTAT)
          CALL STDRDI(TID,'COEFI',1,NCOE(2),I,IA1,
     .                KUN,KNUL,ISTAT)
          CALL TBTCLO(TID,ISTAT)
      END IF
C
C ... MAP INPUT IMAGE
C
      CALL STIGET(INFRM,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     .            3,NAXISA,NPIXA,STARTA,STEPA,IDENTA,CUNITA,
     .            IPNTRA,IMNO,ISTAT)

      IF (NAXISA.EQ.1 .OR. NPIXA(2).EQ.1) THEN
          NPIXA(2) = 1
          NAXISA = 1
      END IF

      IF (NPIXA(2).GT.100)  THEN
          CALL STETER(9,
     +   'Module ECHRE31: Too many orders (limit 100). Buffer overflow')
      ENDIF

      IF (STEPA(2).NE.1.)  THEN
          CALL STETER(9,'Module ECHREBI: Wrong step(2) .ne. 1 ')
      ENDIF

      IORD2(1) = STARTA(2)                  ! Starting relative order number
      IORD2(2) = STARTA(2) + NPIXA(2) - 1   ! Final relative order number
C
C ... MAP OUTPUT FRM
C
      IF (METHOD.EQ.'N' .OR. METHOD.EQ.'n') THEN
          NAXISB = 2
          IF (IREF) THEN
              CALL STFOPN(REFER,D_R4_FORMAT,0,F_IMA_TYPE,
     .                    IR,ISTAT)
              CALL STDRDI(IR,'NPIX',1,2,I,NPIXB,KUN,KNUL,ISTAT)
              CALL STDRDD(IR,'START',1,2,I,STARTB,KUN,KNUL,ISTAT)
              CALL STDRDD(IR,'STEP',1,2,I,STEPB,KUN,KNUL,ISTAT)
              WSTEP  = STEPB(1)
              CALL STDRDI(IR,'NORDER',1,NPIXB(2),I,IORDER,
     .                    KUN,KNUL,ISTAT)
              CALL STDRDI(IR,'NPTOT',1,NPIXB(2),I,NPTOT,
     .                    KUN,KNUL,ISTAT)
              CALL STDRDD(IR,'WSTART',1,NPIXB(2),I,WSTART,
     .                    KUN,KNUL,ISTAT)
              DO 10 I = 1,NPIXB(2)
                  WSTART(I) = WSTART(I)/1000.
   10         CONTINUE
          ELSE
              CALL WRANGE(NCOE(2),A1,IA1,WSTEP,IORD,NPIXA(1),WSTART,
     .                    NPIXB(1),NPTOT,IORDER,STARTA,STEPA,IORD2)
              NPIXB(2)  = NPIXA(2)
              STARTB(1) = 0.D0
              STARTB(2) = STARTA(2)
              STEPB(1)  = WSTEP
              STEPB(2)  = STEPA(2)
          END IF

          CALL STIPUT(OUTFRM,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .                NAXISB,NPIXB,STARTB,STEPB,
     .                IDENTA,CUNITB,IPNTRB,ID,ISTAT)
C
C ... NON LINEAR REBINNING
C
          CALL ECHRE3(MADRID(IPNTRA),NPIXA(1),NPIXA(2),STARTA,STEPA,
     .                NCOE(2),A1,IA1,IORD,MADRID(IPNTRB),NPIXB(1),
     .                NPIXB(2),WSTART,WSTEP,IORD2)
C
C ... WRITE PROCESS DESCRIPTORS
C
          NNNN = NPIXB(1)*NPIXB(2)
          CALL MNMX(MADRID(IPNTRB),NNNN,XMIN,XMAX)
          CUT(1) = XMIN
          CUT(2) = XMAX
          CUT(3) = XMIN
          CUT(4) = XMAX
          DO 20 I = 1,NPIXB(2)
              WSTART(I) = 1000.*WSTART(I)
   20     CONTINUE
          CALL STDCOP(IMNO,ID,3,DSCNAM,ISTAT)
          CALL STDWRD(ID,'WSTART',WSTART,1,NPIXB(2),KUN,ISTAT)
          CALL STDWRI(ID,'NPTOT',NPTOT,1,NPIXB(2),KUN,ISTAT)
          CALL STDWRI(ID,'NORDER',IORDER,1,NPIXB(2),KUN,ISTAT)
          CALL STDWRR(ID,'LHCUTS',CUT,1,4,KUN,ISTAT)
      ELSE
C ... LINEAR REBINNING
          IF (NPIXA(2).GT.1) THEN
CCCCCCCCCCCCC              CALL STDFND(IMNO,'WSTART',I1,I2,I3,ISTAT)
C              IF (TYPE(1:1).EQ.' ') THEN
C                  CALL STTPUT(' Wrong input image ... ',ISTAT)
C                  GO TO 40
CCCCCCCCCCCCC              END IF
              CALL STDRDD(IMNO,'WSTART',1,NPIXA(2),I,WSTART,
     .                    KUN,KNUL,ISTAT)
              CALL STDRDI(IMNO,'NPTOT',1,NPIXA(2),I,NPTOT,
     .                    KUN,KNUL,ISTAT)
          END IF
          CALL STDRDR(IMNO,'LHCUTS',1,4,I,CUT,KUN,KNUL,ISTAT)
          PIXBN     = STEPA(1)/WSTEP
          NAXISB    = NAXISA
          NPIXB(1)  = NPIXA(1)*PIXBN
          NPIXB(2)  = NPIXA(2)
          STARTB(1) = STARTA(1)
          STARTB(2) = STARTA(2)
          STEPB(1)  = WSTEP
          STEPB(2)  = STEPA(2)
          IF (NPIXB(2).GT.1) THEN
              DO 30 I = 1,NPIXB(2)
                  NPTOT(I) = NPTOT(I)*PIXBN
   30         CONTINUE
          ELSE
              WSTART(1) = STARTB(1)
              NPTOT(1) = NPIXB(1)
          END IF
          CALL STIPUT(OUTFRM,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .                NAXISB,NPIXB,STARTB,STEPB,IDENTA,
     .                CUNITB,IPNTRB,ID,ISTAT)
          CALL ECHR01(MADRID(IPNTRA),NPIXA(1),NPIXA(2),STARTA,STEPA,
     .                NPTOT,WSTART,
     .                MADRID(IPNTRB),NPIXB(1),NPIXB(2),WSTEP)

          CALL STDCOP(IMNO,ID,3,DSCNAM,ISTAT)
          IF (NPIXB(2).GT.1) THEN
            CALL STDWRD(ID,'WSTART',WSTART,1,NPIXB(2),KUN,ISTAT)
            CALL STDWRI(ID,'NPTOT',NPTOT,1,NPIXB(2),KUN,ISTAT)
          END IF
          CALL STDWRR(ID,'LHCUTS',CUT,1,4,KUN,ISTAT)
      END IF
      CALL STSEPI
C10000 FORMAT(G<I1>.0)
 9000 FORMAT (G6.0)
 9010 FORMAT(' Sampling step = ',F10.4)
      END

      SUBROUTINE ECHRE3(X,NPIXA1,NPIXA2,STARTA,STEPA,NO,A,IA,IORD,
     +                  Y,NPIXB1,NPIXB2,YSTR,YSTP,IORD2)
C
C REBIN THE ORDERS
C
      IMPLICIT NONE
C
      INTEGER NO, NPIXB1, NPIXB2
      INTEGER NPIXA1,NPIXA2,IORD(2),IA(NO),IORD2(2)
      REAL X(NPIXA1,NPIXA2)
      REAL Y(NPIXB1,NPIXB2)
      DOUBLE PRECISION YSTR(1), YSTP, STARTA(2), STEPA(2)
      DOUBLE PRECISION A(7,NO),B1(3)
C
      INTEGER KMIN, KMAX, I0, I2, I1, K1, II, MIN, MAX, I3
      DOUBLE PRECISION WLSTP, WLST2
C
C ... GET LIMITS FOR THE FIRST ORDER (LOWER WAVELENGTHS)
C
      KMIN   = MIN(IORD(1),IORD(2))
      KMAX   = MAX(IORD(1),IORD(2))
      IF (IORD(1).LT.IORD(2)) THEN
          I0     = NO
          I2     = -1
      ELSE
          I0     = 1  
          I2     = 1
      END IF
      I1     = I0
      WLSTP  = YSTP/1000.
C
C ... ITERATION ON ORDERS
C
      DO 20 K1 = IORD2(2), IORD2(1), -1
          I3 = I1 + IORD2(1) - 1
          IF (IA(I3).LT.0) THEN
              B1(1)  = A(1,I3)
              B1(2)  = -A(2,I3)
              B1(3)  = A(3,I3)
          END IF
          WLST2  = YSTR(I1)
          IF (IA(I3).LT.0) THEN
              CALL LREBIN(X(1,I1),NPIXA1,STARTA,STEPA,B1,3,Y(1,I1),
     +                    NPIXB1,WLST2,WLSTP)
C
C ... SIGN CHANGE
              DO 10 II = 1,NPIXB1
                  Y(II,I1) = -Y(II,I1)
   10         CONTINUE
          ELSE
              CALL LREBI1(X(1,I1),NPIXA1,STARTA,STEPA,A(1,I3),IA(I3),
     +                     Y(1,I1),NPIXB1,WLST2,WLSTP)
          END IF
          I1     = I1 + I2
          IF (I1.GT.NO) RETURN
   20 CONTINUE
      RETURN
      END

      DOUBLE PRECISION FUNCTION POLEV(IA,A,XX)
C
C
C
      IMPLICIT NONE
C
      INTEGER IA
      DOUBLE PRECISION A(IA),XX,YY

      YY     = A(1) + XX* (A(2)+XX* (A(3)+XX* (A(4)+XX* (A(5)+XX* (A(6)+
     +         XX*A(7))))))
      POLEV  = YY
      RETURN
      END

      SUBROUTINE MNMX(X,N,XMIN,XMAX)
C
C FIND MIN MAX VALS
C
      IMPLICIT NONE
      INTEGER  N
      REAL     X(N), XMIN, XMAX
C
      INTEGER I
C
      XMIN   = X(1)
      XMAX   = XMIN
      DO 10 I = 2,N
          XMIN   = AMIN1(XMIN,X(I))
          XMAX   = AMAX1(XMAX,X(I))
   10 CONTINUE
      RETURN
      END

      SUBROUTINE WRANGE(NCOE,A,IA,WSTEP,IORD,NPIXA,WSTART,NPIXB,NPTOT,
     +                  IORDER,STARTA,STEPA,IORD2)
C
C GET STARTING POSITIONS FOR EACH ORDER AND NO. OF PIXELS PER ORDER
C
C
C ... GET LIMITS FOR THE FIRST ORDER (LOWER WAVELENGTHS)
C
      IMPLICIT NONE
C
      INTEGER NCOE, NPIXA, NPIXB
      DOUBLE PRECISION A(7,NCOE),POLEV,B(3), STARTA(1), STEPA(1)
      DOUBLE PRECISION WSTART(1), WSTEP, WLST1, WLEN1
      INTEGER IA(NCOE),IORD(2),NPTOT(1),IORDER(1), IORD2(2)
C
      INTEGER KMIN, KMAX, I0, I1, I2, I, ISTEP, K, N1, I3
c      INTEGER*8 N1
      DOUBLE PRECISION WS1, WW1, IX_IR8
C
      KMIN   = MIN(IORD(1),IORD(2))
      KMAX   = MAX(IORD(1),IORD(2))
      IF (IORD(1).LT.IORD(2)) THEN
          I0     = NCOE 
          I2     = -1
      ELSE
          I0     = 1 
          I2     = 1
      END IF
      I1     = I0
      NPIXB  = 0
      WS1    = WSTEP/1000.
C
C ... get order number
C
      ISTEP  = 1
      IF (IORD(1).GT.IORD(2)) ISTEP  = -1 ! Default case in present versions
      IORDER(1) = IORD(1) - IORD2(1) + 1
      DO 10 I = 2, IORD2(2) - IORD2(1) + 1
          IORDER(I) = IORDER(I-1) + ISTEP
   10 CONTINUE
C
C ... iteration on orders to get starting wavelength and no. of pixels
C
      DO 20 K = IORD2(2), IORD2(1), -1
          I3 = I1 + IORD2(1) - 1
          IF (IA(I3).LT.0) THEN
              B(1)   = A(1,I3)
              B(2)   = -A(2,I3)
              B(3)   = A(3,I3)
              CALL ECHORD(B,3,NPIXA,WLST1,WLEN1,STARTA,STEPA)
          ELSE
              WW1    = POLEV(IA(I3),A(1,I3),IX_IR8(1,STARTA,STEPA))
              WLST1  = WW1
              WW1    = POLEV(IA(I3),A(1,I3),IX_IR8(NPIXA,STARTA,STEPA))
              WLEN1  = WW1
          END IF
          WLST1  = WLST1*10.
          WLEN1  = WLEN1*10.
          N1     = (WLEN1-WLST1)/WS1
          IF (N1.GT.65534) THEN !added swolf@eso.org
             N1 = 0             !if WLEN1 and WLST1 are NaN N1 gets wrong!
          ENDIF                 !--> NPIXB gets wrong, too!
          NPTOT(I1) = N1
          NPIXB  = MAX(NPIXB,N1)
          IF (I1.EQ.I0) THEN
              WSTART(I1) = WS1*NINT(WLST1/WS1) !before: WLST1 (swolf@eso.org)
          ELSE
              WSTART(I1) = WSTART(I0) + WS1*NINT((WLST1-WSTART(I0))/WS1)
          END IF
          I1     = I1 + I2
          IF (I1.GT.NCOE) GO TO 30
   20 CONTINUE
   30 NPIXB  = NPIXB + 3
      RETURN
      END

      SUBROUTINE ECHR01(A,NPIXA1,NPIXA2,STARTA,STEPA,NPTOT,WSTART,
     +                  B,NPIXB1,NPIXB2,WSTEP)
C
C REBIN ECHELLE ORDERS
C
      IMPLICIT NONE
C
      INTEGER NPIXA1,NPIXA2,NPIXB1,NPIXB2
      DOUBLE PRECISION  STEPA(2),STARTA(2)
      REAL A(NPIXA1,NPIXA2),B(NPIXB1,NPIXB2)
      DOUBLE PRECISION  WSTART(NPIXA2), WSTEP
      INTEGER NPTOT(NPIXA2)
C
      INTEGER NORD, IORD, I, NPREB
      DOUBLE PRECISION XSTART, XP, ADEX, PIXBN
      REAL   VBIN
C
      PIXBN  = WSTEP/STEPA(1)
      NORD   = NPIXA2
      DO 30 IORD = 1,NORD
          XSTART = WSTART(IORD)
          NPREB  = NPTOT(IORD)
          DO 10 I = 1,NPREB
              XP     = XSTART + (I-1)*WSTEP
              ADEX   = (XP-XSTART)/STEPA(1) + 1.
              B(I,IORD) = VBIN(A(1,IORD),PIXBN,ADEX)
   10     CONTINUE
          DO 20 I = NPREB + 1,NPIXB1
              B(I,IORD) = 0.
   20     CONTINUE
   30 CONTINUE
      RETURN
      END

      REAL FUNCTION VBIN(ARRAY,PIXPBN,ADEX)
C
C FUNCTION TO RETURN A VALUE FOR A REBINNED BIN
C
C INPUT ARGUMENTS
C ARRAY REAL*4 ARRAY WITH REAL ORIGINAL PIXELS
C PIXPBN REAL*4 PIXELS PER BIN, NUMBER OF ORIGINAL
C   PIXELS IN THE NEW BIN, WITH FRACTIONS
C ADEX REAL*4 CENTER INDEX IN THE ARRAY FOR THE NEW BIN,
C   WITH FRACTIONS
C
      IMPLICIT NONE
      INTEGER          IBOTDX,ITOPDX,IENLP,I,ISTLP
      REAL             HBIN,BOTDX,TOPDX,SUM,BOTFRA,TOPFRA
      REAL             ARRAY(1)
      DOUBLE PRECISION PIXPBN, ADEX
C  !   HALF BIN
      HBIN   = PIXPBN*0.5  !   BOTTOM POINTER, FRACTION
      BOTDX  = ADEX - HBIN  !   TOP POINTER, FRACTION
      TOPDX  = ADEX + HBIN  !   BOTTOM POINTER, WITHOUT FRACTION
      IBOTDX = BOTDX  !   TOP POINTER, WITHOUT FRACTION
      ITOPDX = TOPDX
C
      IF (IBOTDX.EQ.ITOPDX) THEN
C
C   BIN SMALLER THAN ORIGINAL PIXELS
C   AND NEW BIN WITHIN AN ORIGINAL PIXEL
C
          SUM    = PIXPBN*ARRAY(IBOTDX+1)
      ELSE
C
C   BIN LARGER THAN ORIGINAL PIXELS, OR
C   SMALL BIN OVER TWO PIXELS
C
          BOTFRA = 1. - (BOTDX-FLOAT(IBOTDX))
          TOPFRA = TOPDX - FLOAT(ITOPDX)  !   START LOOP INDEX
          ISTLP  = IBOTDX + 2
          IENLP  = ITOPDX
          IBOTDX = IBOTDX + 1
          ITOPDX = ITOPDX + 1
C
          SUM    = 0.
          IF (IENLP.GE.ISTLP) THEN
              DO 10 I = ISTLP,IENLP
                  SUM    = SUM + ARRAY(I)
   10         CONTINUE
          END IF  !   LOWER FRACTION
          SUM    = SUM + BOTFRA*ARRAY(IBOTDX)  !   UPPER FRACTION
          SUM    = SUM + TOPFRA*ARRAY(ITOPDX)
      END IF
C
C AREA CORRECTION
C
      VBIN   = SUM/PIXPBN
      RETURN
      END

      SUBROUTINE ECHORD(AC,NC,NPIX,W1,W2,STARTA,STEPA)
C
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  22:34 - 3 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: D.PONZ
C
C.KEYWORDS:
C  SPECTROSCOPY, CASPEC, ORDER DEFINITION
C
C.PURPOSE:
C  GET WAVELENGTH RANGE OF A GIVEN ORDER
C
C.ALGORITHM:
C
C.INPUT/OUTPUT
C  INPUT ARGUMENTS
C
C  AC(NC) REAL*8 COEFFICIENTS OF THE TRANSFORMATION
C  NC  REAL*4 NO. OF COEFFICIENTS
C  NPIX  INTG*4 NO OF SAMPLES
C
C  OUTPUT ARGUMENTS
C
C  W1  REAL*4  LOWER LIMIT
C  W2  REAL*4  UPPER LIMIT
C
C-------------------------------------------------------------
C
C
      IMPLICIT NONE
      INTEGER NPIX, NC
      DOUBLE PRECISION AC(NC), STARTA(1), STEPA(1)
      DOUBLE PRECISION W1, W2, IX_IR8
C
      DOUBLE PRECISION A0,A1,A2,F1,FN
C
C
C ... ASSIGN COEFFS
C
C      F1     = 1.D0
C      FN     = NPIX

      F1     = IX_IR8(1,STARTA(1),STEPA(1))
      FN     = IX_IR8(NPIX,STARTA(1),STEPA(1))

      A0     = AC(1)
      A1     = AC(2)
      IF (NC.GE.3) THEN
          A2     = AC(3)
          W1     = (-A1+DSQRT(A1*A1-4.D0*A2* (A0-F1)))/ (2.D0*A2)
          W2     = (-A1+DSQRT(A1*A1-4.D0*A2* (A0-FN)))/ (2.D0*A2)

      ELSE
          W1     = (F1-A0)/A1
          W2     = (FN-A0)/A1
      END IF
      RETURN
      END


      SUBROUTINE LREBI1(X,NX,XSTR,XSTP,AC,NC,Y,NY,YSTR,YSTP)
C
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  0:22 - 4 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: D.PONZ
C
C.IDENTIFICATION
C  SUBROUTINE  LREBIN1 VERSION 1   22 MAR 1983
C  J.D.PONZ
C
C.KEYWORDS:
C  SPECTROSCOPY, CASPEC, REBINNING
C
C.PURPOSE:
C  DATA REBINNING
C  CONVERSION FROM SAMPLES INTO WAVELENGTHS
C
C.ALGORITHM:
C  LINEAR INTERPOLATION. THE TRANSFORMATION SAMPLE NUMBER INTO
C  WAVELENGTH IS DEFINED BY
C  W = A0 + A1*S + A2*S**2 + ...
C
C.INPUT/OUTPUT
C  INPUT ARGUMENTS
C
C  X(NX) REAL*4 INPUT ARRAY
C  NX  INTG*4 NO OF SAMPLES
C  XSTR  REAL*4 STARTING VALUE OF INPUT
C  XSTP  REAL*4 INPUT STEP
C  AC(NC) REAL*8 COEFFICIENTS OF THE TRANSFORMATION
C  NC  REAL*4 NO. OF COEFFICIENTS
C  NY  INTG*4 NO. OF OUTPUT VALUES
C  YSTR  REAL*4 STARTING VALUE OF THE INPUT
C  YSTP  REAL*4 STEP OF THE OUTPUT
C
C  OUTPUT ARGUMENTS
C
C  Y(NY) REAL*4 OUTPUT ARRAY
C
C-------------------------------------------------------------
C
C
      IMPLICIT NONE
      INTEGER  NX, NY, NC
      REAL X(NX),Y(NY)
      DOUBLE PRECISION YSTR, YSTP, XSTR, XSTP
C
      DOUBLE PRECISION AC(NC),A0,A1,A2,A3,A4,A5,A6,FN,FL,WPOLY
      DOUBLE PRECISION FACTOR,DPOLY,CNORM, IX_R8R8, XN, XNP1
      DOUBLE PRECISION PN,PNP1,TM,TMP1,C,COV,VAL, COVX
      DOUBLE PRECISION B2, B3, B4, B5, B6, DELT, STARTL
      INTEGER          M1, MST, N, K, MPT
C
      WPOLY(FL) = A0 + FL* (A1+FL* (A2+FL* (A3+FL* (A4+FL* (A5+FL*
     +            A6)))))
      DPOLY(FL) = A1 + FL* (B2+FL* (B3+FL* (B4+FL* (B5+FL*B6))))
C
C ... ASSIGN COEFFS
C
      A0     = AC(1)
      A1     = AC(2)
      A2     = AC(3)
      A3     = AC(4)
      A4     = AC(5)
      A5     = AC(6)
      A6     = AC(7)
      B2     = 2.D0*A2
      B3     = 3.D0*A3
      B4     = 4.D0*A4
      B5     = 5.D0*A5
      B6     = 6.D0*A6
      CNORM  = 10.D0/YSTP

C
C ... CHECK FOR OUTPUT START
C
      STARTL = YSTR - 0.5*YSTP
      FN     = 0.5D0
      XN     = IX_R8R8(FN,XSTR,XSTP)
      PN     = 10.D0*WPOLY(XN)

      DELT   = PN - STARTL
      IF (DELT.GT.0.) THEN
          M1     = DELT/YSTP + 1.
          TMP1   = PN + YSTP
          TM     = PN
      ELSE
          M1     = 1
          TMP1   = STARTL + YSTP
          TM     = STARTL
      END IF
C
C ... CHECK FOR INPUT START
C
      DO 10 N = 1,NX
          FN     = FN + 1.D0
          XNP1   = IX_R8R8(FN,XSTR,XSTP)
          PNP1   = 10.D0*WPOLY(XNP1)

          IF (PNP1.GT.TM) GO TO 20
          PN     = PNP1
   10 CONTINUE
      N      = NX + 1
      GO TO 30
   20 C      = X(N)
   30 VAL    = 0.

      COVX   = XNP1 - XN
      COV    = (PNP1 - PN)/COVX
C
C ... REBINNING LOOP
C
      MPT    = 1
      MST    = 1
      K      = 0
   35 CONTINUE
          IF ( .NOT. (MPT.LE.NY)) GO TO 80
          K      = K + 1
          IF ((K.LT.M1) .OR. (N.GT.NX)) GO TO 60
C 
   40     IF (PNP1.EQ.PN) GO TO 90
          VAL    = VAL + C* (DMIN1(TMP1,PNP1)-DMAX1(TM,PN))/COV
          IF (TMP1.LT.PNP1) GO TO 50
          N      = N + 1
          IF (N.GT.NX) GO TO 60

          PN     = PNP1
          XN     = XNP1

          FN     = FN + 1.D0
          XNP1   = IX_R8R8(FN,XSTR,XSTP)
          PNP1   = 10.D0*WPOLY(XNP1)

          C      = X(N)
          COV    = (PNP1 - PN)/(XNP1-XN)

          GO TO 40
   50     TM     = TMP1
          TMP1   = TMP1 + YSTP
   60     FACTOR = CNORM*DPOLY(IX_R8R8(FN,XSTR,XSTP))
C          FACTOR = FACTOR*10.D0*DABS(DPOLY(IX_R8R8(FN,XSTR,XSTP)))/YSTP
          Y(MPT) = VAL*FACTOR
          MPT    = MPT + 1
          VAL    = 0.
          GOTO 35
   80 CONTINUE
   90 CONTINUE
      DO 100 K = MPT + 1,NY
          Y(K)   = 0.
  100 CONTINUE
      RETURN
      END

      SUBROUTINE LREBIN(X,NX,XSTR,XSTP,AC,NC,Y,NY,YSTR,YSTP)
C
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  19:08 - 6 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: D.PONZ
C
C.KEYWORDS:
C  SPECTROSCOPY, CASPEC, REBINNING
C
C.PURPOSE:
C  DATA REBINNING
C  CONVERSION FROM SAMPLES INTO WAVELENGTHS
C
C.ALGORITHM:
C  LINEAR INTERPOLATION. THE TRANSFORMATION WAVELENGTH INTO
C  SAMPLE NUMBER IS DEFINED BY
C  S = A0+A1*T+A2*T**2
C
C.INPUT/OUTPUT
C  INPUT ARGUMENTS
C
C  X(NX) REAL*4 INPUT ARRAY
C  NX  INTG*4 NO OF SAMPLES
C  XSTR  REAL*4 STARTING VALUE OF INPUT
C  XSTP  REAL*4 INPUT STEP
C  AC(NC) REAL*8 COEFFICIENTS OF THE TRANSFORMATION
C  NC  REAL*4 NO. OF COEFFICIENTS
C  NY  INTG*4 NO. OF OUTPUT VALUES
C  YSTR  REAL*4 STARTING VALUE OF THE INPUT
C  YSTP  REAL*4 STEP OF THE OUTPUT
C
C  OUTPUT ARGUMENTS
C
C  Y(NY) REAL*4 OUTPUT ARRAY
C
C-------------------------------------------------------------
C
C
      IMPLICIT NONE
      INTEGER NX, NY, NC, N, M1
      REAL X(NX),Y(NY)
      DOUBLE PRECISION AC(NC),A0,A1,A2,A3,A4,A5,FN
      DOUBLE PRECISION FACTOR,CNORM, START, PN, DELT, STARTL
      DOUBLE PRECISION TM, TMP1
      DOUBLE PRECISION IX_R8R8
      DOUBLE PRECISION XSTR, XSTP, YSTR, YSTP
C
      INTEGER K, MPT, MST
      DOUBLE PRECISION PNP1, C, VAL, COV, DSQRT, DMIN1, DMAX1
      DOUBLE PRECISION XN, XNP1, COVX
C
C WPOLY(FL) = FL*(A1+FL*(A2+FL*(A3+FL*(A4+FL*A5))))
C
C ... ASSIGN COEFFS
C
      A0     = AC(1)
      A1     = -AC(2)
      A2     = AC(3)
      A3     = A1*A1
      A4     = 4.D0*A2
      A5     = 2.D0*A2
      CNORM  = 10.D0/ (A5*YSTP)
C A0 = AC(1)
C A1 = AC(2)
C A2 = AC(3)
C
C ... CHECK FOR OUTPUT START
C
      START  = YSTR - 0.5*YSTP
C STARTL= START - A0
      STARTL = START
      M1     = 1
      FN     = 0.5D0
      XN     = IX_R8R8(FN,XSTR,XSTP)

C PN    = WPOLY(IX_R8R8(FN,XSTR,XSTP))
      PN     = 10.D0* (A1+DSQRT(A3-A4* (A0-XN)))/A5
      DELT   = PN - STARTL
      IF (DELT.GT.0.) THEN
          M1     = DELT/YSTP + 1.
          TMP1   = STARTL + M1*YSTP
          TM     = TMP1 - YSTP
      ELSE
          TMP1   = STARTL + YSTP
          TM     = STARTL
      END IF
C
C ... CHECK FOR INPUT START
C
      DO 10 N = 1,NX
          FN     = FN + 1.D0
          XNP1   = IX_R8R8(FN,XSTR,XSTP)

C   PNP1 = WPOLY(IX_R8R8(FN,XSTR,XSTP))
          PNP1   = 10.D0* (A1+DSQRT(A3-A4* (A0-XNP1)))/A5
          IF (PNP1.GT.TM) GO TO 20
          PN     = PNP1
          XN     = XNP1
   10 CONTINUE
      N      = NX + 1
      GO TO 30
   20 C      = X(N)
   30 VAL    = 0.
      COVX   = XNP1 - XN
      COV    = (PNP1 - PN)/COVX
C
C ... REBINNING LOOP
C
      MPT    = 1
      MST    = 1
      K      = 0
C   35 CONTINUE
          IF ( .NOT. (MPT.LE.NY)) GO TO 80
          K      = K + 1
          IF ((K.LT.M1) .OR. (N.GT.NX)) GO TO 60
   40     VAL    = VAL + C* (DMIN1(TMP1,PNP1)-DMAX1(TM,PN))/COV
          IF (TMP1.LT.PNP1) GO TO 50
          N      = N + 1
          IF (N.GT.NX) GO TO 60
          PN     = PNP1
          XN     = XNP1
          FN     = FN + 1.D0
          XNP1   = IX_R8R8(FN,XSTR,XSTP)
C         PNP1 = WPOLY(IX_R8R8(FN,XSTR,XSTP))
          PNP1   = 10.D0* (A1+DSQRT(A3-A4* (A0-XNP1)))/A5

          C      = X(N)

          COVX   = XNP1 - XN
          COV    = (PNP1 - PN)/COVX

          GO TO 40
   50     TM     = TMP1
          TMP1   = TMP1 + YSTP
   60     FACTOR = CNORM*(DSQRT(A3-A4* (A0-XNP1))-
     +             DSQRT(A3-A4* (A0-XNP1-1.D0)))
          Y(MPT) = VAL*FACTOR
          MPT    = MPT + 1
          VAL    = 0.
   80 CONTINUE
      DO 90 K = MPT + 1,NY
          Y(K)   = 0.
   90 CONTINUE
      RETURN
      END

C @(#)terror.for	19.1 (ES0-DMD) 02/25/03 13:28:48
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C  @(#)terror.for	19.1  (ESO-IPG)  02/25/03  13:28:48
      SUBROUTINE TERROR(ITBL,N,MSG)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT (c) European Southern Observatory 1992
C.IDENT		terror.for
C.MODULE
C.AUTHOR	Andrew T. Young
C.KEYWORD
C.LANGUAGE	FORTRAN 77
C.PURPOSE       closes table file and writes error message, with rtn.value
C.COMMENTS
C.VERSION	0.0
C.RETURNS
C.ENVIRONMENT
C.
C-----------------------------------------------------------------------------
C
C
      IMPLICIT NONE
C
      INTEGER ITBL, N, JCONT, JLOG, JDISP, ISTAT
C
      CHARACTER*(*) MSG
C
      COMMON/FLAGS/JCONT,JLOG,JDISP
C
      CALL TBTCLO(ITBL,ISTAT)
      CALL STECNT('PUT', JCONT,JLOG,JDISP)
      CALL STETER(N,MSG)
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2009 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C 
C.VERSION
C 091202	last modif
C 
C===========================================================================
C
      SUBROUTINE E02ADZ(MFIRST,MLAST,MTOT,KPLUS1,NROWS,KALL,NDV,X,Y,W,
     *                  XMIN,XMAX,INUP1,NU,WORK1,WORK2,A,S,SERR,EPS,
     *                  IFAIL)
C     MARK 7 RELEASE. NAG COPYRIGHT 1978.
C     MARK 8 REVISED. IER-228 (APR 1980).
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C
C     E02ADZ  COMPUTES WEIGHTED LEAST-SQUARES POLYNOMIAL
C     APPROXIMATIONS TO AN ARBITRARY SET OF DATA POINTS,
C     WITH, IF REQUIRED, SEVERAL SETS OF VALUES OF THE
C     DEPENDENT VARIABLE.
C
C     FORSYTHE-CLENSHAW METHOD WITH MODIFICATIONS DUE TO
C     REINSCH AND GENTLEMAN.
C
C     STARTED - 1973.
C     COMPLETED - 1978.
C     AUTHORS - MGC AND GTA.
C
C     WORK1  AND  WORK2  ARE WORKSPACE AREAS.
C     WORK1(1, R)  CONTAINS THE VALUE OF  X(R)  TRANSFORMED
C     TO THE RANGE  -1  TO  +1.
C     WORK1(2, R)  CONTAINS THE WEIGHTED VALUE OF THE CURRENT
C     ORTHOGONAL POLYNOMIAL (OF DEGREE  I)  AT THE  R TH
C     DATA POINT.
C     WORK2(1, J)  CONTAINS THE COEFFICIENT OF THE CHEBYSHEV
C     POLYNOMIAL OF DEGREE  J - 1  IN THE CHEBYSHEV-SERIES
C     REPRESENTATION OF THE CURRENT ORTHOGONAL POLYNOMIAL
C     (OF DEGREE  I).
C     WORK2(2, J)  CONTAINS THE COEFFICIENT OF THE CHEBYSHEV
C     POLYNOMIAL OF DEGREE  J - 1  IN THE CHEBYSHEV-SERIES
C     REPRESENTATION OF THE PREVIOUS ORTHOGONAL POLYNOMIAL
C     (OF DEGREE  I - 1).
C
C     .. Scalar Arguments ..
      DOUBLE PRECISION  XMAX, XMIN
      INTEGER           IFAIL, INUP1, KALL, KPLUS1, MFIRST, MLAST, MTOT,
     *                  NDV, NROWS
C     .. Array Arguments ..
      DOUBLE PRECISION  A(NDV,NROWS,KPLUS1), EPS(NDV,MLAST), NU(INUP1),
     *                  S(NDV,KPLUS1), SERR(KPLUS1), W(MLAST),
     *                  WORK1(2,MTOT), WORK2(2,KPLUS1), X(MLAST),
     *                  Y(NDV,MLAST)
C     .. Local Scalars ..
      DOUBLE PRECISION  ALPIP1, BETAI, BJ, BJP1, BJP2, CIL, D, DF, DI,
     *                  DIM1, DJ, EPSLR, FACTOR, PIJ, SIGMAI, WR, WRPR,
     *                  WRPRSQ, X1, XCAPR, XM
      INTEGER           I, IERROR, II, IM1, INU, IPLUS1, IPLUS2, J,
     *                  JPLUS1, JPLUS2, JREV, K, L, M, MDIST, MR, R
      LOGICAL           WNZ
C     .. Local Arrays ..
      DOUBLE PRECISION  CI(10)
C     .. Intrinsic Functions ..
      INTRINSIC         SQRT
C     .. Executable Statements ..
      K = KPLUS1 - 1
      INU = INUP1 - 1
C
C     TEST THE VALIDITY OF THE DATA.
C
C     CHECK INPUT PARAMETERS.
C
      M = MLAST - MFIRST + 1
      I = KPLUS1 - INU
      IERROR = 5
      IF (MFIRST.LT.1 .OR. INUP1.LT.1 .OR. KPLUS1.LT.INUP1 .OR. M.LT.
     *    I .OR. NDV.LT.1 .OR. (KALL.NE.1 .AND. KALL.NE.0)) GO TO 600
C
C     CHECK THAT THE VALUES OF X(R) ARE NON-DECREASING AND
C     DETERMINE THE NUMBER (MDIST) OF DISTINCT VALUES OF X(R)
C     WITH NON-ZERO WEIGHT
C
      IERROR = 2
      MDIST = 1
      IF (W(MFIRST).EQ.0.0D+0) MDIST = 0
      L = MFIRST + 1
      IF (L.GT.MLAST) GO TO 40
      WNZ = W(MFIRST) .NE. 0.0D+0
      DO 20 R = L, MLAST
         IF (X(R).LT.X(R-1)) GO TO 600
         IF (X(R).GT.X(R-1)) WNZ = .FALSE.
         IF (W(R).EQ.0.0D+0 .OR. WNZ) GO TO 20
         MDIST = MDIST + 1
         WNZ = .TRUE.
   20 CONTINUE
C
C     CHECK THAT XMIN.LT.XMAX AND THAT XMIN AND XMAX SPAN THE DATA
C     X VALUES.
C
   40 IERROR = 1
      IF (XMIN.GT.X(MFIRST) .OR. XMAX.LT.X(MLAST) .OR. XMIN.GE.XMAX)
     *    GO TO 600
C
C     IF THE NUMBER OF DISTINCT VALUES OF  X(R)  WITH NON-ZERO
C     WEIGHT IS LESS THAN THE NUMBER OF INDEPENDENT COEFFICIENTS
C     IN THE FIT OF MAXIMUM DEGREE  K  THERE IS NO UNIQUE
C     POLYNOMIAL
C     APPROXIMATION OF THAT DEGREE.
C
      L = K - INU
      IERROR = 3
      IF (MDIST.LE.L) GO TO 600
C
C     CHECK THAT  NROWS  HAS BEEN SET SUFFICIENTLY LARGE.
C
      IERROR = 5
      IF (KALL.EQ.1 .AND. NROWS.LT.KPLUS1) GO TO 600
      IF (INUP1.EQ.1) GO TO 80
C
C     NORMALIZE THE FORCING FACTOR SO THAT ITS LEADING COEFFICIENT
C     IS UNITY, CHECKING THAT THIS COEFFICIENT WAS NOT ZERO.
C
      IERROR = 4
      DI = NU(INUP1)
      IF (DI.EQ.0.0D0) GO TO 600
      DO 60 I = 1, INUP1
         WORK2(1,I) = NU(I)/DI
         WORK2(2,I) = 0.0D0
   60 CONTINUE
C
   80 IERROR = 0
      X1 = XMIN
      XM = XMAX
      D = XM - X1
C
C     THE INITIAL VALUES OF EPS(L,R) (L = 1,2,....NDV AND R =
C     MFIRST, MFIRST+1,....MLAST) OF THE WEIGHTED RESIDUALS AND
C     THE VALUES WORK1(1,R)(R=1,2...M) OF THE NORMALIZED
C     INDEPENDENT VARIABLE ARE COMPUTED. N.B. WORK1(1,R) IS
C     COMPUTED FROM THE EXPRESSION BELOW RATHER THAN THE MORE
C     NATURAL FORM   (2.0*X(R) - X1 - XM)/D
C     SINCE THE FORMER GUARANTEES THE COMPUTED VALUE TO DIFFER FROM
C     THE TRUE VALUE BY AT MOST  4.0*MACHINE ACCURACY,  WHEREAS THE
C     LATTER HAS NO SUCH GUARANTEE.
C
C     MDIST IS NOW USED TO RECORD THE TOTAL NUMBER OF DATA POINTS
C     WITH NON-ZERO WEIGHT.
C
      MDIST = 0
      DO 120 R = MFIRST, MLAST
         WR = W(R)
         IF (WR.NE.0.0D0) MDIST = MDIST + 1
         MR = R - MFIRST + 1
         DO 100 L = 1, NDV
            EPS(L,R) = WR*Y(L,R)
  100    CONTINUE
         WORK1(1,MR) = ((X(R)-X1)-(XM-X(R)))/D
  120 CONTINUE
      IM1 = INU*KALL + 1
      BETAI = 0.0D0
      DO 160 JPLUS1 = 1, KPLUS1
         SERR(JPLUS1) = 0.0D0
         DO 140 L = 1, NDV
            A(L,IM1,JPLUS1) = 0.0D0
  140    CONTINUE
  160 CONTINUE
      DO 560 IPLUS1 = INUP1, KPLUS1
C
C        SET STARTING VALUES FOR DEGREE  I.
C
         II = (IPLUS1-1)*KALL + 1
         IPLUS2 = IPLUS1 + 1
         IF (IPLUS1.EQ.KPLUS1) GO TO 240
         IF (KALL.EQ.0) GO TO 220
         DO 200 JPLUS1 = IPLUS2, KPLUS1
            DO 180 L = 1, NDV
               A(L,II,JPLUS1) = 0.0D0
  180       CONTINUE
  200    CONTINUE
  220    WORK2(1,IPLUS2) = 0.0D0
         WORK2(2,IPLUS2) = 0.0D0
  240    ALPIP1 = 0.0D0
         DI = 0.0D0
         DO 260 L = 1, NDV
            CI(L) = 0.0D0
  260    CONTINUE
         WORK2(1,IPLUS1) = 1.0D0
         IF (KPLUS1.GT.1) WORK2(2,1) = WORK2(1,2)
         DO 440 R = MFIRST, MLAST
            IF (W(R).EQ.0.0D0) GO TO 440
            MR = R - MFIRST + 1
            XCAPR = WORK1(1,MR)
C
C           THE WEIGHTED VALUE WORK1(2, R)  OF THE ORTHOGONAL POLYNOMIAL
C           OF DEGREE I AT X = X(R) IS COMPUTED BY RECURRENCE FROM ITS
C           CHEBYSHEV-SERIES REPRESENTATION.
C
            IF (IPLUS1.GT.1) GO TO 280
            WRPR = W(R)*0.5D0*WORK2(1,1)
            WORK1(2,MR) = WRPR
            GO TO 400
  280       J = IPLUS2
            IF (XCAPR.GT.0.5D0) GO TO 360
            IF (XCAPR.GE.-0.5D0) GO TO 320
C
C           GENTLEMAN*S MODIFIED RECURRENCE.
C
            FACTOR = 2.0D0*(1.0D0+XCAPR)
            DJ = 0.0D0
            BJ = 0.0D0
            DO 300 JREV = 2, IPLUS1
               J = J - 1
               DJ = WORK2(1,J) - DJ + FACTOR*BJ
               BJ = DJ - BJ
  300       CONTINUE
            WRPR = W(R)*(0.5D0*WORK2(1,1)-DJ+0.5D0*FACTOR*BJ)
            WORK1(2,MR) = WRPR
            GO TO 400
C
C           CLENSHAW*S ORIGINAL RECURRENCE.
C
  320       FACTOR = 2.0D0*XCAPR
            BJP1 = 0.0D0
            BJ = 0.0D0
            DO 340 JREV = 2, IPLUS1
               J = J - 1
               BJP2 = BJP1
               BJP1 = BJ
               BJ = WORK2(1,J) - BJP2 + FACTOR*BJP1
  340       CONTINUE
            WRPR = W(R)*(0.5D0*WORK2(1,1)-BJP1+0.5D0*FACTOR*BJ)
            WORK1(2,MR) = WRPR
            GO TO 400
C
C           REINSCH*S MODIFIED RECURRENCE.
C
  360       FACTOR = 2.0D0*(1.0D0-XCAPR)
            DJ = 0.0D0
            BJ = 0.0D0
            DO 380 JREV = 2, IPLUS1
               J = J - 1
               DJ = WORK2(1,J) + DJ - FACTOR*BJ
               BJ = BJ + DJ
  380       CONTINUE
            WRPR = W(R)*(0.5D0*WORK2(1,1)+DJ-0.5D0*FACTOR*BJ)
            WORK1(2,MR) = WRPR
C
C           THE COEFFICIENTS CI(L) OF THE I TH ORTHOGONAL POLYNOMIAL
C           L=1,2....NDV AND THE COEFFICIENTS ALPIP1 AND BETAI IN THE
C           THREE-TERM RECURRENCE RELATION FOR THE ORTHOGONAL
C           POLYNOMIALS ARE COMPUTED.
C
  400       WRPRSQ = WRPR**2
            DI = DI + WRPRSQ
            DO 420 L = 1, NDV
               CI(L) = CI(L) + WRPR*EPS(L,R)
  420       CONTINUE
            ALPIP1 = ALPIP1 + WRPRSQ*XCAPR
  440    CONTINUE
         DO 460 L = 1, NDV
            CI(L) = CI(L)/DI
  460    CONTINUE
         IF (IPLUS1.NE.INUP1) BETAI = DI/DIM1
         ALPIP1 = 2.0D0*ALPIP1/DI
C
C        THE WEIGHTED RESIDUALS EPS(L,R)(L=1,2....NDV AND R=MFIRST,
C        MFIRST+1....MLAST) FOR DEGREE I ARE COMPUTED, TOGETHER
C        WITH THEIR SUM OF SQUARES, SIGMAI
C
         DF = MDIST - (IPLUS1-INU)
         DO 500 L = 1, NDV
            CIL = CI(L)
            SIGMAI = 0.0D0
            DO 480 R = MFIRST, MLAST
               IF (W(R).EQ.0.0D0) GO TO 480
               MR = R - MFIRST + 1
               EPSLR = EPS(L,R) - CIL*WORK1(2,MR)
               EPS(L,R) = EPSLR
               SIGMAI = SIGMAI + EPSLR**2
  480       CONTINUE
C
C           THE ROOT MEAN SQUARE RESIDUAL  S(L, I + 1)  FOR DEGREE  I
C           IS THEORETICALLY UNDEFINED IF  M = I + 1 - INU  (THE
C           CONDITION FOR THE POLYNOMIAL TO PASS EXACTLY THROUGH THE
C           DATA POINTS). SHOULD THIS CASE ARISE THE R.M.S. RESIDUAL
C           IS SET TO ZERO.
C
            IF (DF.LE.0.0D0) S(L,IPLUS1) = 0.0D0
            IF (DF.GT.0.0D0) S(L,IPLUS1) = SQRT(SIGMAI/DF)
  500    CONTINUE
C
C        THE CHEBYSHEV COEFFICIENTS A(L, I+1, 1), A(L, I+1, 2)....
C        A(L, I+1, I+1) IN THE POLYNOMIAL APPROXIMATION OF DEGREE I
C        TO EACH SET OF VALUES OF THE INDEPENDENT VARIABLE
C        (L=1,2,...,NDV) TOGETHER WITH THE COEFFICIENTS
C        WORK2(1, 1), WORK2(1, 2), ..., WORK2(1, I + 1),   IN THE
C        CHEBYSHEV-SERIES REPRESENTATION OF THE  (I + 1) TH
C        ORTHOGONAL POLYNOMIAL ARE COMPUTED.
C
         DO 540 JPLUS1 = 1, IPLUS1
            JPLUS2 = JPLUS1 + 1
            PIJ = WORK2(1,JPLUS1)
            SERR(JPLUS1) = SERR(JPLUS1) + PIJ**2/DI
            DO 520 L = 1, NDV
               A(L,II,JPLUS1) = A(L,IM1,JPLUS1) + CI(L)*PIJ
  520       CONTINUE
            IF (JPLUS1.EQ.KPLUS1) GO TO 560
            WORK2(1,JPLUS1) = WORK2(1,JPLUS2) + WORK2(2,JPLUS1) -
     *                        ALPIP1*PIJ - BETAI*WORK2(2,JPLUS2)
            WORK2(2,JPLUS2) = PIJ
  540    CONTINUE
         DIM1 = DI
         IM1 = II
  560 CONTINUE
      DO 580 IPLUS1 = 1, KPLUS1
         SERR(IPLUS1) = 1.0D0/SQRT(SERR(IPLUS1))
  580 CONTINUE
  600 IFAIL = IERROR
      RETURN
      END

      SUBROUTINE E02AEF(NPLUS1,A,XCAP,P,IFAIL)
C     NAG LIBRARY SUBROUTINE  E02AEF
C
C     E02AEF  EVALUATES A POLYNOMIAL FROM ITS CHEBYSHEV-
C     SERIES REPRESENTATION.
C
C     CLENSHAW METHOD WITH MODIFICATIONS DUE TO REINSCH
C     AND GENTLEMAN.
C
C     USES NAG LIBRARY ROUTINES  P01AAF  AND  X02AAF.
C     USES INTRINSIC FUNCTION  ABS.
C
C     STARTED - 1973.
C     COMPLETED - 1976.
C     AUTHOR - MGC AND JGH.
C
C     NAG COPYRIGHT 1975
C     MARK 5 RELEASE
C     MARK 7 REVISED IER-140 (DEC 1978)
C     MARK 9 REVISED. IER-352 (SEP 1981)
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C
C     .. Parameters ..
      CHARACTER*6       SRNAME
      PARAMETER         (SRNAME='E02AEF')
C     .. Scalar Arguments ..
      DOUBLE PRECISION  P, XCAP
      INTEGER           IFAIL, NPLUS1
C     .. Array Arguments ..
      DOUBLE PRECISION  A(NPLUS1)
C     .. Local Scalars ..
      DOUBLE PRECISION  BK, BKP1, BKP2, DK, ETA, FACTOR
      INTEGER           IERROR, K, KREV, N, NPLUS2
C     .. Local Arrays ..
      CHARACTER*1       P01REC(1)
C     .. External Functions ..
      DOUBLE PRECISION  X02AAF
      INTEGER           P01ABF
      EXTERNAL          X02AAF, P01ABF
C     .. Intrinsic Functions ..
      INTRINSIC         ABS
C     .. Executable Statements ..
      IERROR = 0
      ETA = X02AAF(ETA)
C     INSERT CALL TO X02AAF
C
C     ETA  IS THE SMALLEST POSITIVE NUMBER SUCH THAT
C     THE COMPUTED VALUE OF  1.0 + ETA  EXCEEDS UNITY.
C
      IF (NPLUS1.GE.1) GO TO 20
      IERROR = 2
      GO TO 180
   20 IF (ABS(XCAP).LE.1.0D0+4.0D0*ETA) GO TO 40
      IERROR = 1
      P = 0.0D0
      GO TO 180
   40 IF (NPLUS1.GT.1) GO TO 60
      P = 0.5D0*A(1)
      GO TO 180
   60 N = NPLUS1 - 1
      NPLUS2 = N + 2
      K = NPLUS2
      IF (XCAP.GT.0.5D0) GO TO 140
      IF (XCAP.GE.-0.5D0) GO TO 100
C
C     GENTLEMAN*S MODIFIED RECURRENCE.
C
      FACTOR = 2.0D0*(1.0D0+XCAP)
      DK = 0.0D0
      BK = 0.0D0
      DO 80 KREV = 1, N
         K = K - 1
         DK = A(K) - DK + FACTOR*BK
         BK = DK - BK
   80 CONTINUE
      P = 0.5D0*A(1) - DK + 0.5D0*FACTOR*BK
      GO TO 180
C
C     CLENSHAW*S ORIGINAL RECURRENCE.
C
  100 FACTOR = 2.0D0*XCAP
      BKP1 = 0.0D0
      BK = 0.0D0
      DO 120 KREV = 1, N
         K = K - 1
         BKP2 = BKP1
         BKP1 = BK
         BK = A(K) - BKP2 + FACTOR*BKP1
  120 CONTINUE
      P = 0.5D0*A(1) - BKP1 + 0.5D0*FACTOR*BK
      GO TO 180
C
C     REINSCH*S MODIFIED RECURRENCE.
C
  140 FACTOR = 2.0D0*(1.0D0-XCAP)
      DK = 0.0D0
      BK = 0.0D0
      DO 160 KREV = 1, N
         K = K - 1
         DK = A(K) + DK - FACTOR*BK
         BK = BK + DK
  160 CONTINUE
      P = 0.5D0*A(1) + DK - 0.5D0*FACTOR*BK
  180 IF (IERROR.EQ.0) THEN
         IFAIL = 0
      ELSE
         IFAIL = P01ABF(IFAIL,IERROR,SRNAME,0,P01REC)
      ENDIF
CC 
CC  180 IF (IERROR) 200, 220, 200
CC  200 IFAIL = P01ABF(IFAIL,IERROR,SRNAME,0,P01REC)
CC      RETURN
CC  220 IFAIL = 0
CC 
      RETURN
      END


      SUBROUTINE E02CAF(M,N,K,L,X,Y,F,W,NX,A,NA,XMIN,XMAX,NUX,INUXP1,
     *                  NUY,INUYP1,WORK,NWORK,IFAIL)
C     MARK 7 RELEASE. NAG COPYRIGHT 1978.
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C
C     E02CAF IS A CALLING ROUTINE WHICH SETS UP WORK SPACE ARRAYS
C     FOR THE SUBROUTINE E02CAZ AND THEN CALLS IT TO OBTAIN AN
C     APPROXIMATION TO THE LEAST SQUARES POLYNOMIAL SURFACE FIT
C     TO DATA ARBITRARILY DISTRIBUTED ON LINES PARALLEL TO ONE
C     INDEPENDENT COORDINATE AXIS.
C
C     STARTED - 1978.
C     COMPLETED - 1978.
C     AUTHOR - GTA.
C
C
C     FIND MAXIMUM OF N AND THE ELEMENTS OF M, AND LARGER OF K AND
C     L, AND THE SUM OF THE ELEMENTS OF M
C
C     .. Parameters ..
      CHARACTER*6       SRNAME
      PARAMETER         (SRNAME='E02CAF')
C     .. Scalar Arguments ..
      INTEGER           IFAIL, INUXP1, INUYP1, K, L, N, NA, NWORK, NX
C     .. Array Arguments ..
      DOUBLE PRECISION  A(NA), F(NX), NUX(INUXP1), NUY(INUYP1), W(NX),
     *                  WORK(NWORK), X(NX), XMAX(N), XMIN(N), Y(N)
      INTEGER           M(N)
C     .. Local Scalars ..
      INTEGER           I, IERROR, IW, KP1, MI, MJ, MJP1, MSUM, NCI,
     *                  NCII, NFI, NRESID, NS, NW, NWI, NWT, NYW
C     .. Local Arrays ..
      CHARACTER*1       P01REC(1)
C     .. External Functions ..
      INTEGER           P01ABF
      EXTERNAL          P01ABF
C     .. External Subroutines ..
      EXTERNAL          E02CAZ
C     .. Executable Statements ..
      IERROR = 1
      IF (INUXP1.LT.1 .OR. INUYP1.LT.1 .OR. INUXP1.GT.K+1 .OR.
     *    INUYP1.GT.L+1) GO TO 80
      IF (N.LT.L-INUYP1+2) GO TO 80
      MSUM = 0
      MI = N
      DO 20 I = 1, N
         MJ = M(I)
         IF (MJ.LT.K-INUXP1+2) GO TO 80
         MSUM = MSUM + MJ
         IF (MJ.GT.MI) MI = MJ
   20 CONTINUE
      MJ = L
      IF (K.GT.L) MJ = K
      MJP1 = MJ + 1
C
C     CHECK THAT THE INTEGER PARAMETERS HAVE REASONABLE VALUES
C
      KP1 = K + 1
      MJ = KP1*(L+1)
      NW = 2*MI + 2*N*KP1 + 5*MJP1 + 2*N + MSUM
      IF (NX.LT.MSUM .OR. NA.LT.MJ .OR. NWORK.LT.NW) GO TO 80
C
C     CHECK THAT THE Y(I) ARE STRICTLY INCREASING
C
      IF (N.EQ.1) GO TO 60
      IERROR = 3
      DO 40 I = 2, N
         IF (Y(I).LE.Y(I-1)) GO TO 80
   40 CONTINUE
      IERROR = 1
C
C     ALLOCATE WORKSPACE FOR E02CAZ
C
   60 NWI = 1
      NCI = NWI + N
      NYW = NCI + N*KP1
      NCII = NYW + N*KP1
      NWT = NCII + MJP1
      NS = NWT + MJP1
      NFI = NS + MJP1
      NRESID = NFI + N
      NW = NRESID + MSUM
      IW = NWORK - NW + 1
      CALL E02CAZ(M,N,KP1,L,X,Y,F,W,NX,A,NA,XMIN,XMAX,NUX,INUXP1,NUY,
     *            INUYP1,WORK(NWI),WORK(NCI),WORK(NYW),WORK(NCII)
     *            ,WORK(NWT),WORK(NS),WORK(NFI),WORK(NRESID)
     *            ,MSUM,MJP1,WORK(NW),IW,IERROR)
   80 IFAIL = P01ABF(IFAIL,IERROR,SRNAME,0,P01REC)
      RETURN
      END

      SUBROUTINE E02CAZ(M,N,KP1,L,X,Y,F,W,NX,A,NA,XMIN,XMAX,NUX,INUXP1,
     *                  NUY,INUYP1,WI,CI,YW,CII,WT,S,FI,RESID,MTOT,MJ1,
     *                  WORK,NWORK,IFAIL)
C     MARK 7 RELEASE. NAG COPYRIGHT 1978.
C     MARK 8C REVISED. IER-270 (OCT. 1980).
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C
C     THIS SUBROUTINE OBTAINS A BIVARIATE CHEBYSHEV SERIES
C     APPROXIMATION OF DEGREE K IN X AND L IN Y TO A SET OF DATA
C     POINTS ARBITRARILY DISTRIBUTED ON LINES PARALLEL TO THE X
C     AXIS.
C     SUBROUTINE E02ADZ IS FIRST USED TO OBTAIN CHEBYSHEV SERIES
C     COEFFICIENTS OF THE WEIGHTED LEAST-SQUARES CURVE FIT OF
C     DEGREE K TO THE DATA ON EACH LINE IN TURN. THE SAME ROUTINE
C     IS THEN USED TO FIT THESE COEFFICIENTS AS POLYNOMIALS OF
C     DEGREE L IN Y, GIVING THE COEFFICIENTS OF THE BIVARIATE FIT.
C     THE FIT CAN BE CONSTRAINED TO CONTAIN GIVEN POLYNOMIAL
C     FACTORS IN X AND IN Y.
C     THE SUBROUTINE IS BASED ON THE METHOD GIVEN IN SECTIONS 5,6
C     AND 8 OF CLENSHAW, C.W. AND HAYES, J.G., CURVE AND SURFACE
C     FITTING, J. INST. MATHS APPLICS, 1, PP.164-188, 1965.
C
C     STARTED - 1978.
C     COMPLETED - 1978.
C     AUTHOR - GTA.
C
C     .. Scalar Arguments ..
      INTEGER           IFAIL, INUXP1, INUYP1, KP1, L, MJ1, MTOT, N, NA,
     *                  NWORK, NX
C     .. Array Arguments ..
      DOUBLE PRECISION  A(NA), CI(N,KP1), CII(MJ1), F(NX), FI(N),
     *                  NUX(INUXP1), NUY(INUYP1), RESID(MTOT), S(MJ1),
     *                  W(NX), WI(N), WORK(NWORK), WT(MJ1), X(NX),
     *                  XMAX(N), XMIN(N), Y(N), YW(N,KP1)
      INTEGER           M(N)
C     .. Local Scalars ..
      INTEGER           I, IERROR, J, LP1, MFIRST, MLAST, T
C     .. External Subroutines ..
      EXTERNAL          E02ADZ
C     .. Executable Statements ..
      LP1 = L + 1
      MLAST = 0
      IFAIL = 0
C
C     FIT THE DATA ON EACH OF THE N LINES Y = Y(I), I = 1,2,...N.
C
      DO 60 I = 1, N
         IERROR = 1
         MFIRST = MLAST + 1
         MLAST = MLAST + M(I)
         CALL E02ADZ(MFIRST,MLAST,MTOT,KP1,1,0,1,X,F,W,XMIN(I),XMAX(I)
     *               ,INUXP1,NUX,WORK(2*KP1+1),WORK(1)
     *               ,CII,S,WT,RESID,IERROR)
         IF (IERROR.EQ.0) GO TO 20
         IFAIL = IERROR + 1
         IF (IFAIL.EQ.6) IFAIL = 1
         GO TO 200
C
C        STORE THE COEFFICIENTS OF THE DEGREE K FIT TO DATA ON THE ITH
C        LINE
C
   20    DO 40 J = 1, KP1
            CI(I,J) = CII(J)
            YW(I,J) = WT(J)
   40    CONTINUE
   60 CONTINUE
C
C     FIT THE COEFFICIENTS A(J) ON EACH LINE AS A POLYNOMIAL IN Y.
C
      IF (N.GT.1) GO TO 100
      DO 80 J = 1, KP1
         A(J) = 2.0D+0*CI(1,J)
   80 CONTINUE
      RETURN
  100 DO 180 J = 1, KP1
         DO 120 I = 1, N
            FI(I) = CI(I,J)
            WI(I) = YW(I,J)
  120    CONTINUE
         IERROR = 1
         CALL E02ADZ(1,N,N,LP1,1,0,1,Y,FI,WI,Y(1),Y(N)
     *               ,INUYP1,NUY,WORK(2*LP1+1),WORK(1)
     *               ,CII,S,WT,RESID,IERROR)
         IF (IERROR.EQ.0) GO TO 140
         IFAIL = IERROR + 1
         IF (IFAIL.EQ.6) IFAIL = 1
         GO TO 200
  140    T = (J-1)*LP1
         DO 160 I = 1, LP1
            T = T + 1
            A(T) = CII(I)
  160    CONTINUE
  180 CONTINUE
  200 RETURN
      END

      SUBROUTINE E02CBF(MFIRST,MLAST,K,L,X,XMIN,XMAX,Y,YMIN,YMAX,FF,A,
     *                  NA,WORK,NWORK,IFAIL)
C     MARK 7 RELEASE. NAG COPYRIGHT 1978.
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C
C     THIS SUBROUTINE EVALUATES A POLYNOMIAL OF DEGREE K AND L
C     RESPECTIVELY IN THE INDEPENDENT VARIABLES X AND Y.  THE
C     POLYNOMIAL IS GIVEN IN DOUBLE CHEBYSHEV SERIES FORM
C     A(I,J) * TI(XCAP) * TJ(YCAP),
C     SUMMED OVER I = 0,1,...K AND J = 0,1,...L WITH THE CONVENTION
C     THAT TERMS WITH EITHER I OR J ZERO ARE HALVED AND THE TERM
C     WITH BOTH I AND J ZERO IS MULTIPLIED BY 0.25. HERE TI(XCAP)
C     IS THE CHEBYSHEV POLYNOMIAL OF THE FIRST KIND OF DEGREE I
C     WITH ARGUMENT XCAP=((X - XMIN) - (XMAX - X))/(XMAX - XMIN).
C     TJ(YCAP) IS DEFINED SIMILARLY. THE COEFFICIENT A(I,J)
C     SHOULD BE STORED IN ELEMENT (L + 1)*I + J + 1 OF THE SINGLE
C     DIMENSION ARRAY A. THE EVALUATION IS PERFORMED FOR A SINGLE
C     GIVEN VALUE OF Y WITH EACH X VALUE GIVEN IN X(R), FOR R =
C     MFIRST, MFIRST+1,....,MLAST.
C
C     STARTED - 1978.
C     COMPLETED - 1978.
C     AUTHOR - GTA.
C
C     .. Parameters ..
      CHARACTER*6       SRNAME
      PARAMETER         (SRNAME='E02CBF')
C     .. Scalar Arguments ..
      DOUBLE PRECISION  XMAX, XMIN, Y, YMAX, YMIN
      INTEGER           IFAIL, K, L, MFIRST, MLAST, NA, NWORK
C     .. Array Arguments ..
      DOUBLE PRECISION  A(NA), FF(MLAST), WORK(NWORK), X(MLAST)
C     .. Local Scalars ..
      DOUBLE PRECISION  D, XCAP, YCAP
      INTEGER           I, IERROR, KP1, LP1, M, R
C     .. Local Arrays ..
      CHARACTER*1       P01REC(1)
C     .. External Functions ..
      INTEGER           P01ABF
      EXTERNAL          P01ABF
C     .. External Subroutines ..
      EXTERNAL          E02AEF
C     .. Executable Statements ..
      KP1 = K + 1
      LP1 = L + 1
      M = MLAST - MFIRST + 1
C
C     CHECK THAT THE INTEGER INPUT PARAMETERS HAVE REASONABLE
C     VALUES
C
      IERROR = 1
      IF (M.LE.0 .OR. K.LT.0 .OR. L.LT.0 .OR. NA.LT.KP1*LP1 .OR.
     *    NWORK.LT.KP1) GO TO 80
C
C     CHECK THAT THE Y RANGE IS REASONABLE AND THAT THE GIVEN
C     VALUE OF Y IS NOT OUTSIDE IT
C
      IERROR = 2
      IF (YMIN.GE.YMAX .OR. Y.LT.YMIN .OR. Y.GT.YMAX) GO TO 80
      D = XMAX - XMIN
C
C     CHECK THAT THE X RANGE IS REASONABLE AND THAT NONE OF
C     THE GIVEN VALUES OF X IS OUTSIDE IT
C
      IERROR = 3
      IF (D.LE.0.0D+0) GO TO 80
      DO 20 R = MFIRST, MLAST
         IF (X(R).LT.XMIN .OR. X(R).GT.XMAX) GO TO 80
   20 CONTINUE
C
C     CALCULATE YCAP, THE NORMALIZED VALUE OF Y
C
      YCAP = ((Y-YMIN)-(YMAX-Y))/(YMAX-YMIN)
      IERROR = 1
      R = -L
C
C     EVALUATE THE COEFFICIENTS OF THE POLYNOMIAL FOR THE GIVEN Y
C
      DO 40 I = 1, KP1
         R = R + LP1
         CALL E02AEF(LP1,A(R),YCAP,WORK(I),IERROR)
         IERROR = IERROR + 1
         IF (IERROR.NE.1) GO TO 80
   40 CONTINUE
C
C     EVALUATE THE POLYNOMAL AT THE GIVEN X VALUES
C
      DO 60 R = MFIRST, MLAST
         XCAP = ((X(R)-XMIN)-(XMAX-X(R)))/D
         IERROR = 1
         CALL E02AEF(KP1,WORK,XCAP,FF(R),IERROR)
         IF (IERROR.EQ.0) GO TO 60
         IERROR = 3
         GO TO 80
   60 CONTINUE
   80 IFAIL = P01ABF(IFAIL,IERROR,SRNAME,0,P01REC)
      RETURN
      END


CX      DOUBLE PRECISION FUNCTION G05DDF(A,B)
C     MARK 6 RELEASE  NAG COPYRIGHT 1976
C     MARK 11 REVISED. IER-441 (FEB 1984).
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     WRITTEN BY N.M.MACLAREN
C     UNIVERSITY OF CAMBRIDGE COMPUTER LABORATORY
C     THIS RETURNS A REAL NUMBER, NORMALLY DISTRIBUTED (GAUSSIAN)
C     WITH MEAN A AND STANDARD DEVIATION B.
C     THE METHOD USED IS A MODIFICATION OF CACM ALGORITHM 488
C     (BY R.P.BRENT).
C     THE FOLLOWING CAN BE EXTENDED IF A TRUNCATION PROBABILITY
C     OF 1.0E-12 IS REGARDED AS UNSATISFACTORY.
C     THE CODE ASSUMES THAT THE CONTENTS OF COMMON BLOCK /BG05CA/
C     ARE SAVED BETWEEN CALLS OF THIS ROUTINE AND CALLS OF OTHER
C     G05 ROUTINES THAT REFERENCE IT. A SAVE STATEMENT
C     ENSURES THAT THIS IS SO.
C     .. Scalar Arguments ..
CX      DOUBLE PRECISION                 A, B
C     .. Scalars in Common ..
CX      DOUBLE PRECISION                 STORE1, STORE2
C     .. Local Scalars ..
CX      DOUBLE PRECISION                 HALF, ONE, T, U, V, W
CX      INTEGER                          N
C     .. Local Arrays ..
CX      DOUBLE PRECISION                 D(41)
C     .. External Functions ..
CX      DOUBLE PRECISION                 G05CAF
CX      EXTERNAL                         G05CAF
C     .. Common blocks ..
CX      COMMON                           /BG05CA/STORE1, STORE2
C     .. Save statement ..
CX      SAVE                             /BG05CA/
C     .. Data statements ..
CX      DATA                             ONE/1.0D0/, HALF/0.5D0/
CX      DATA                             D(1), D(2), D(3), D(4), D(5),
CX     *                                 D(6), D(7), D(8), D(9), D(10),
CX     *                                 D(11), D(12), D(13), D(14)/0.0D0,
CX     *                                 0.674489750196082D0,
CX     *                                 1.150349380376008D0,
CX     *                                 1.534120544352546D0,
CX     *                                 1.862731867421652D0,
CX     *                                 2.153874694061456D0,
CX     *                                 2.417559016236505D0,
CX     *                                 2.660067468617460D0,
CX     *                                 2.885634912426757D0,
CX     *                                 3.097269078198785D0,
CX     *                                 3.297193345691964D0,
CX     *                                 3.487104104114431D0,
CX     *                                 3.668329285121323D0,
CX     *                                 3.841930685501911D0/
CX      DATA                             D(15), D(16), D(17), D(18),
CX     *                                 D(19), D(20), D(21), D(22),
CX     *                                 D(23), D(24), D(25), D(26),
CX     *                                 D(27)/4.008772594168585D0,
CX     *                                 4.169569323349106D0,
CX     *                                 4.324919040826046D0,
CX     *                                 4.475328424654204D0,
CX     *                                 4.621231001499247D0,
CX     *                                 4.763001034267814D0,
CX     *                                 4.900964207963193D0,
CX     *                                 5.035405969463927D0,
CX     *                                 5.166578119728753D0,
CX     *                                 5.294704084854598D0,
CX     *                                 5.419983174916868D0,
CX     *                                 5.542594057802940D0,
CX     *                                 5.662697617459439D0/
CX      DATA                             D(28), D(29), D(30), D(31),
CX     *                                 D(32), D(33), D(34), D(35),
CX     *                                 D(36), D(37), D(38), D(39),
CX     *                                 D(40)/5.780439324478935D0,
CX     *                                 5.895951216739571D0,
CX     *                                 6.009353565530745D0,
CX     *                                 6.120756285971941D0,
CX     *                                 6.230260137989044D0,
CX     *                                 6.337957754553790D0,
CX     *                                 6.443934526538564D0,
CX     *                                 6.548269367831731D0,
CX     *                                 6.651035379893011D0,
CX     *                                 6.752300431407015D0,
CX     *                                 6.852127665896068D0,
CX     *                                 6.950575947916750D0,
CX     *                                 7.047700256664409D0/
CX      DATA                             D(41)/7.143552034352190D0/
C     .. Executable Statements ..
C     FIRST CALL TO G05CAF COMES BEFORE FIRST REFERENCE TO STORE1
C     TO MAKE SURE THAT STORE1 IS INITIALIZED
CX      V = G05CAF(0.0D0)
CX      U = STORE1
CX      DO 20 N = 1, 39
CX         IF (U.GT.HALF) GO TO 40
CX         U = U + U
CX   20 CONTINUE
CX      N = 40
CX   40 T = D(N)
CX      U = V
CX   60 W = (D(N+1)-T)*U
CX      V = W*(W*HALF+T)
CX   80 U = G05CAF(0.0D0)
CX      IF (V.LE.U) GO TO 100
CX      V = G05CAF(0.0D0)
CX      IF (U.GT.V) GO TO 80
CX      U = (V-U)/(ONE-U)
CX      GO TO 60
CX  100 U = (U-V)/(ONE-V)
CX      IF (U.GT.HALF) GO TO 120
CX      STORE1 = U + U
CX      G05DDF = A + B*(W+T)
CX      RETURN
CX  120 STORE1 = U + U - ONE
CX      G05DDF = A - B*(W+T)
CX      RETURN
CX      END

      INTEGER FUNCTION P01AAF(IFAIL,ERROR,SRNAME)
C     MARK 1 RELEASE.  NAG COPYRIGHT 1971
C     MARK 3 REVISED
C     MARK 4A REVISED, IER-45
C     MARK 4.5 REVISED
C     MARK 7 REVISED (DEC 1978)
C     MARK 11 REVISED (FEB 1984)
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     RETURNS THE VALUE OF ERROR OR TERMINATES THE PROGRAM.
C     TEST IF NO ERROR DETECTED
C     .. Scalar Arguments ..
      DOUBLE PRECISION        SRNAME
      INTEGER                 ERROR, IFAIL
C     .. Local Scalars ..
      INTEGER                 NOUT
C     .. External Subroutines ..
      EXTERNAL                X04AAF
C     .. Intrinsic Functions ..
      INTRINSIC               MOD
C     .. Executable Statements ..
      IF (ERROR.EQ.0) GO TO 40
C     DETERMINE OUTPUT UNIT FOR MESSAGE
      CALL X04AAF(0,NOUT)
C     TEST FOR SOFT FAILURE
      IF (MOD(IFAIL,10).EQ.1) GO TO 20
C     HARD FAILURE
      WRITE (NOUT,FMT=99999) SRNAME, ERROR
C     ******************** IMPLEMENTATION NOTE ********************
C     THE FOLLOWING STOP STATEMENT MAY BE REPLACED BY A CALL TO AN
C     IMPLEMENTATION-DEPENDENT ROUTINE TO DISPLAY A MESSAGE AND/OR
C     ABORT THE PROGRAM.
C     *************************************************************
      STOP
C     SOFT FAIL
C     TEST IF ERROR MESSAGES SUPPRESSED
   20 IF (MOD(IFAIL/10,10).EQ.0) GO TO 40
      WRITE (NOUT,FMT=99999) SRNAME, ERROR
   40 P01AAF = ERROR
      RETURN
C
99999 FORMAT (/' ERROR DETECTED BY NAG LIBRARY ROUTINE ',A8,' - IFAIL ',
     *  '= ',I5,//)
      END

      INTEGER FUNCTION P01ABF(IFAIL,IERROR,SRNAME,NREC,REC)
C     MARK 11.5(F77) RELEASE. NAG COPYRIGHT 1986.
C
C     P01ABF is the error-handling routine for the NAG Library.
C
C     P01ABF either returns the value of IERROR through the routine
C     name (soft failure), or terminates execution of the program
C     (hard failure). Diagnostic messages may be output.
C
C     If IERROR = 0 (successful exit from the calling routine),
C     the value 0 is returned through the routine name, and no
C     message is output
C
C     If IERROR is non-zero (abnormal exit from the calling routine),
C     the action taken depends on the value of IFAIL.
C
C     IFAIL = 1: soft failure, silent exit (i.e. no messages are output)
C     IFAIL =-1: soft failure, noisy exit (i.e. messages are output)
C     IFAIL = 0: hard failure, noisy exit
C
C     For compatibility with certain routines included before Mark 12
C     P01ABF also allows an alternative specification of IFAIL in which
C     it is regarded as a decimal integer with least significant digits
C     cba. Then
C
C     a = 0: hard failure  a = 1: soft failure
C     b = 0: silent exit   b = 1: noisy exit
C
C     except that hard failure now always implies a noisy exit.
C
C     S.Hammarling, M.P.Hooper and J.J.du Croz, NAG Central Office.
C
C     .. Scalar Arguments ..
      INTEGER                 IERROR, IFAIL, NREC
      CHARACTER*(*)           SRNAME
C     .. Array Arguments ..
      CHARACTER*(*)           REC(*)
C     .. Local Scalars ..
      INTEGER                 I, NERR
      CHARACTER*72            MESS
C     .. External Subroutines ..
      EXTERNAL                X04AAF, X04BAF
C     .. Intrinsic Functions ..
      INTRINSIC               ABS, MOD
C     .. Executable Statements ..
      IF (IERROR.NE.0) THEN
C        Abnormal exit from calling routine
         IF (IFAIL.EQ.-1 .OR. IFAIL.EQ.0 .OR.
     *       (IFAIL.GT.0 .AND. MOD(IFAIL/10,10).NE.0)) THEN
C           Noisy exit
            CALL X04AAF(0,NERR)
            DO 20 I = 1, NREC
               CALL X04BAF(NERR,REC(I))
   20       CONTINUE
            WRITE (MESS,FMT=99999) SRNAME, IERROR
            CALL X04BAF(NERR,MESS)
            IF (ABS(MOD(IFAIL,10)).NE.1) THEN
C              Hard failure
               CALL X04BAF(NERR,
     *                     ' ** NAG hard failure - execution terminated'
     *                     )
               STOP
            ELSE
C              Soft failure
               CALL X04BAF(NERR,
     *                     ' ** NAG soft failure - control returned')
            END IF
         END IF
      END IF
      P01ABF = IERROR
      RETURN
C
99999 FORMAT (' ** ABNORMAL EXIT from NAG Library routine ',A,': IFAIL',
     *  ' =',I6)
      END

      DOUBLE PRECISION FUNCTION X02AAF(X)
C     MARK 12 RE-ISSUE. NAG COPYRIGHT 1986.
C
C     RETURNS  (1/2)*B**(1-P)  IF ROUNDS IS .TRUE.
C     RETURNS  B**(1-P)  OTHERWISE
C     I.E. RETURNS THE SAME VALUE AS X02AJF
C
C     .. Scalar Arguments ..
      DOUBLE PRECISION          X
C     .. External Functions ..
      DOUBLE PRECISION          X02AJF
      EXTERNAL                  X02AJF
C     .. Executable Statements ..
      X02AAF = X02AJF()
      RETURN
      END

      DOUBLE PRECISION FUNCTION X02AJF()
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C
C     RETURNS  (1/2)*B**(1-P)  IF ROUNDS IS .TRUE.
C     RETURNS  B**(1-P)  OTHERWISE
C
C     .. Executable Statements ..
C     IN THEORY THIS SHOULD BE 2.0**(-56) BUT 2.0**(-55) HAS BEEN FOUND
C     TO BE MORE PRACTICAL IN THE PAST.
      X02AJF = 2.0D0**(-55)
      RETURN
      END

      SUBROUTINE X04AAF(I,NERR)
C     MARK 7 RELEASE. NAG COPYRIGHT 1978
C     MARK 7C REVISED IER-190 (MAY 1979)
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     IF I = 0, SETS NERR TO CURRENT ERROR MESSAGE UNIT NUMBER
C     (STORED IN NERR1).
C     IF I = 1, CHANGES CURRENT ERROR MESSAGE UNIT NUMBER TO
C     VALUE SPECIFIED BY NERR.
C
C     .. Scalar Arguments ..
      INTEGER           I, NERR
C     .. Local Scalars ..
      INTEGER           NERR1
C     .. Save statement ..
      SAVE              NERR1
C     .. Data statements ..
      DATA              NERR1/6/
C     .. Executable Statements ..
      IF (I.EQ.0) NERR = NERR1
      IF (I.EQ.1) NERR1 = NERR
      RETURN
      END

      SUBROUTINE X04BAF(NOUT,REC)
C     MARK 11.5(F77) RELEASE. NAG COPYRIGHT 1986.
C
C     X04BAF writes the contents of REC to the unit defined by NOUT.
C
C     Trailing blanks are not output, except that if REC is entirely
C     blank, a single blank character is output.
C     If NOUT.lt.0, i.e. if NOUT is not a valid Fortran unit identifier,
C     then no output occurs.
C
C     .. Scalar Arguments ..
      INTEGER           NOUT
      CHARACTER*(*)     REC
C     .. Local Scalars ..
      INTEGER           I
C     .. Intrinsic Functions ..
      INTRINSIC         LEN
C     .. Executable Statements ..
      IF (NOUT.GE.0) THEN
C        Remove trailing blanks
         DO 20 I = LEN(REC), 2, -1
            IF (REC(I:I).NE.' ') GO TO 40
   20    CONTINUE
C        Write record to external file
   40    WRITE (NOUT,FMT=99999) REC(1:I)
      END IF
      RETURN
C
99999 FORMAT (A)
      END

C @(#)airmass.for	19.1 (ESO-DMD) 02/25/03 14:01:40
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM AIRMAS
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.NAME
C      AIRMASS.FOR                            VERSION 3.0
C
C.AUTHOR
C      M. ROSA (STECF)	VERSION 1.0	29-OCT-1985
C
C.MODIFICATIONS
C      M. ROSA (STECF)	VERSION 2.0	29-MAR-1986
C         Add JD and Sid. Time part, correct bug in airmass part
C         Input is in DEGREES for RA, DEC, Long., Lat.
C         Add more output
C      M. ROSA (STECF)	VERSION 3.0	30-MAY-1986
C         Verify for inclusion in MIDAS release
C      D. Baade (ST-ECF) VERSION 4.0    07-FEB-1987
C         a) chop off calculation of ST and JD
C         b) improved formula for calculation of airmass as a function of
C            zenith distance
C      D. Baade (ESO) VERSION 4.1       21-DEC-1988
C         Use more accurate weights for calculation of mean airmass
C         in the case of long exposures (formula given by P. Stetson,
C         1988 September, Dominion Astrophysical Observatory Preprint)
C
C.PURPOSE  a) Calculate airmass through sec z
C
C             Correct expansion
C
C             Airm = sec(z) - 0.0018167(sec(z)-1)
C                           - 0.002875 (sec(z)-1)**2
C                           - 0.0008083(sec(z)-1)**3
C
C.INPUT
C      hour angle (real degrees)        INPUTR(1:1)
C      declination (degree,min,sec)     INPUTR(2:4)
C      exposure time (sec)              INPUTR(5:5)
C      latitude (degree,min,sec)        INPUTR(6:8)
C
C.OUTPUT
C	OUTPUTR(1)  Airmass
C
C 020503	last modif	KB
C 
C---------------------------------------------------------------
C
      IMPLICIT NONE
C
      REAL     RB(8),AIR,DELT,WEIGHT(3)
C
      DOUBLE PRECISION HA,DD,SECZ,LAT
      DOUBLE PRECISION FACTO,PI,RLAT,RDD,RHA
C
      INTEGER  I,IACTV,ISTAT,KUN(1),KNUL
C
      CHARACTER*2 SIGNS
C
      DATA PI /3.1415926535D0/
      DATA WEIGHT /1.,4.,1./
      DATA RB /8*0.0/,  SIGNS /'  '/
C
      CALL STSPRO('AIRMAS')
C
      CALL STKRDC('SIGNS',1,1,2,IACTV,SIGNS,KUN,KNUL,ISTAT)
      CALL STKRDR('INPUTR',1,8,IACTV,RB,KUN,KNUL,ISTAT)
C
      FACTO = PI / 180.0D0
C
      HA = RB(1)                           ! hour angle in degrees
10    IF (HA.LT.-180.0D0) THEN
         HA = HA+360.
         GOTO 10
      ENDIF
C
11    IF (HA.GT.180.0D0) THEN
         HA = HA-360.
         GOTO 11
      ENDIF
C
C declination in real degrees
      DD = ABS(RB(2))+(ABS(RB(3))+ABS(RB(4))/60.)/60.
      IF (SIGNS(2:2).EQ.'-') DD = -DD            !negative declination
C
C latitude in real degrees
      LAT = ABS(RB(6))+(ABS(RB(7))+ABS(RB(8))/60.)/60. 
      IF (SIGNS(1:1).EQ.'-') LAT = -LAT          !negative latitude
      RLAT = LAT * FACTO                         !move from degrees to radians
      RDD = DD * FACTO
C
C first case: exposure time infinitly short
C
      IF (RB(5).LE.0.0) THEN
         RHA = HA * FACTO
         SECZ = DSIN(RLAT)*DSIN(RDD)+
     +          DCOS(RLAT)*DCOS(RDD)*DCOS(RHA)
         SECZ = (1.0D0/SECZ)                           ! zenith distance
C
C calulate airmass
C (formula by Young and Irvine, Astron. J. 72, 945 (1967) used below
C includes refraction correction but is in principle valid only
C for observations made at sea level)
C
         AIR = SNGL(SECZ*(1.-0.0012*(SECZ*SECZ-1.)))
C
C Second case: exposure time > 0.0. Then, the  airmass calculated is the
C weighted average of airmasses at t0, 0.5(t1-t0) and t1 with weighting
C factors w0 = 1/6, w1/2 = 4/6, and w1 = 1/6:
C
C W A R N I N G:  What follows is a linear interpolation of a
C hyperexponentially varying function !
C
      ELSE
         DELT = RB(5)/480.0D0             ! 0.5 * (sec)*15/3600
         HA = HA-DELT
         AIR = 0.0
C
         DO 1000, I=1,3
            HA = HA+DELT
            RHA = HA * FACTO
            SECZ = DSIN(RLAT)*DSIN(RDD)+
     +             DCOS(RLAT)*DCOS(RDD)*DCOS(RHA)
            SECZ = (1.0D0/SECZ)                      ! zenith distance
C
C calulate airmass
C (below formula by Young and Irvine, Astron. J. 72, 945 (1967)
C includes refraction correction but is in principle valid only
C for observations made at sea level)
C
            AIR = AIR + WEIGHT(I)*SNGL(SECZ*(1.-0.0012*(SECZ*SECZ-1.)))
1000     CONTINUE
C 
         AIR = AIR/6.0
      ENDIF
C
C write airmass to keyword OUTPUTR
      CALL STKWRR('OUTPUTR',AIR,1,1,KUN,ISTAT)
      CALL STSEPI
C
      END

C  @(#)tdcspl.for	19.1 (ESO-DMD) 02/25/03 14:11:16 
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  14:27 - 19 NOV 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION
C
C  program TDCSPL
C
C.PURPOSE
C
C  TABLE TO IMAGE CONVERSION
C  Execute the command
C  CONV/TAB image = table colx [z] refima SPLINE deg
C
C.KEYWORDS
C
C  table, image, conversion
C
C
C.ALGORITHM
C
C  spline interpolation
C
C  Ref.: P.Diercxx, 1982, Computer Graphics and Image Processing
C                         vol. 20, 171 - 184.
C
C.MODIFS
C     M Peron 071190 , in order to avoid a shift in the output frame
C  
C.VERSION
C 020807	last modif
C 
C-----------------------------------------------------------
C
      SUBROUTINE TDCSPL
      IMPLICIT NONE
C
      INTEGER     MADRID
      INTEGER PNVALS, IMNO
      INTEGER ICOL(3),NPTOT(100),NPIX(2)
      INTEGER NORDER(100)
      INTEGER NRDATA(1000)
      INTEGER STATUS, N1, IDEGR, NPAR, ISTAT, NN, NAXIS, NO, NB
      INTEGER NBY, TID, IS, NCOL, NROW, NSC, NAC, NAR, I, IREF
      INTEGER I1, I2, NDIM, KUN, KNUL
C 
      INTEGER*8  IP1, IP2, IP3, PNTR
C
      REAL S,SS,DELTA,YMAX,YMIN
      REAL STEP(2),START(2),RMIN,RMAX
      REAL CUTS(4),WSTART(100)
      REAL T(1000),C(1000)
C
      DOUBLE PRECISION DSTART(2), DSTEP(2)
C
      CHARACTER*16 MSG
      CHARACTER*80 TABLE,IMAGE,REFIMA
      CHARACTER*8 TYPE
      CHARACTER*17 COLREF(2)
      CHARACTER*60 WORK
      CHARACTER*72 IDENT
      CHARACTER*80 CUNIT
C
      INCLUDE 'MID_INCLUDE:TABLES.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:TABLED.INC'
C
      DATA PNVALS/8/
      DATA MSG/'ERR:TCONVTBLxxxx'/
      DATA NPIX /1,1/
      DATA DSTEP /1.,1./
      DATA DSTART /0.,0./
C
C ... get input parameters + default
C
      CALL TDPGET(PNVALS,NPAR,ISTAT)
      IF (ISTAT.NE.0) GO TO 30
      IMAGE     = TPARBF(1)
      TABLE     = TPARBF(3)
      COLREF(1) = TPARBF(4)
      COLREF(2) = TPARBF(5)
      REFIMA = TPARBF(6)
      CALL STKRDR('INPUTR',1,1,NN,SS,KUN,KNUL,ISTAT)
      CALL STKRDR('INPUTR',2,1,NN,S,KUN,KNUL,ISTAT)
C      IDEGR = SS
C .................................... change parameters
      IDEGR = S
C 
      CALL STFOPN(REFIMA,D_R4_FORMAT,0,F_IMA_TYPE,IREF,ISTAT)
      CALL STDRDI(IREF,'NAXIS',1,1,NN,NAXIS,KUN,KNUL,ISTAT)
      CALL STDRDI(IREF,'NPIX',1,NAXIS,NN,NPIX,KUN,KNUL,ISTAT)
      CALL STDRDD(IREF,'START',1,NAXIS,NN,DSTART,KUN,KNUL,ISTAT)
      START(1) = DSTART(1)
      START(2) = DSTART(2)
      CALL STDRDD(IREF,'STEP',1,NAXIS,NN,DSTEP,KUN,KNUL,ISTAT)
      STEP(1) = DSTEP(1)
      STEP(2) = DSTEP(2)
      IF (NAXIS.GT.1 .AND. NPIX(2).GT.1) THEN
          TYPE   = ' '
          CALL STDFND(IREF,'WSTART',TYPE,NO,NB,ISTAT)
          IF (TYPE(1:1).EQ.' ') THEN
              CALL STTPUT(' Wrong reference image ',ISTAT)
              GO TO 30
          END IF
          CALL STDRDR
     .         (IREF,'WSTART',1,NPIX(2),NN,WSTART,KUN,KNUL,ISTAT)
          CALL STDRDI
     .         (IREF,'NPTOT',1,NPIX(2),NN,NPTOT,KUN,KNUL,ISTAT)
          CALL STDRDI
     .         (IREF,'NORDER',1,NPIX(2),NN,NORDER,KUN,KNUL,ISTAT)
          NDIM   = 2

      ELSE
          NPIX(2) = 1
          NDIM   = 1
      END IF
C
C ... init input table
C
      TID = -1
      CALL TBTOPN(TABLE,F_I_MODE,TID,STATUS)
      IF (ISTAT.NE.0) GO TO 30
      CALL TBIGET(TID,NCOL,NROW,NSC,NAC,NAR,ISTAT)
      IF (ISTAT.NE.0) GO TO 30
C
C ... find input column
C
      DO 10, I = 1, 2
          CALL TBCSER(TID,COLREF(I),ICOL(I),ISTAT)
          IF (ICOL(I).EQ.-1) THEN
              ISTAT  = ERRCOL
              GO TO 30
          END IF
          CALL TBUGET(TID,ICOL(I),WORK,ISTAT)
          I1     = (I-1)*16 + 1
          I2     = I1 + 15
          CUNIT(I1:I2) = WORK(1:16)
   10 CONTINUE
C
C ... copy selected values of the table into work space
C
      NBY = 4*NROW
      CALL TDMGET(NBY,IP1,IS)
      CALL TDMGET(NBY,IP2,IS)
      CALL TDMGET(NBY,IP3,IS)
      CALL ACOPY(TID,ICOL(1),ICOL(2),NROW,
     +          MADRID(IP1),MADRID(IP2),MADRID(IP3),YMIN,YMAX,N1)
      IF (N1.LT.IDEGR+1) THEN
          CALL STTPUT(' Not enough points in table ',ISTAT)
          GO TO 20

      END IF
C
C ... map image
C
      CUNIT(1:16) = 'FLUX'
      I2 = INDEX(TABLE,' ')
      IF (I2.lt.1) I2 = LEN(TABLE)
      IDENT  = 'TABLE: '//TABLE(1:I2)//'COLS. :'//COLREF(1)//COLREF(2)
      CALL STIPUT(IMAGE,10,1,1,NDIM,NPIX,DSTART,DSTEP,IDENT,CUNIT,
     +            PNTR,IMNO,STATUS)
C
C ... interpolate from table values
C
      DELTA  = YMAX - YMIN
      SS     = DELTA* (DELTA*0.5+YMIN)*SS*0.01
      CALL AINTER(N1,MADRID(IP1),MADRID(IP2),NPIX(1),NPIX(2),
     +            MADRID(PNTR),START,STEP,WSTART,NPTOT,RMIN,RMAX,
     +            MADRID(IP3),IDEGR,SS,T,C,NRDATA)
C
C ... write cuts
C
      CUTS(1) = RMIN
      CUTS(2) = RMAX
      CUTS(3) = RMIN
      CUTS(4) = RMAX
      CALL STDWRR(IMNO,'LHCUTS',CUTS,1,4,KUN,ISTAT)
      IF (NPIX(2).GT.1) THEN
          CALL STDWRR(IMNO,'WSTART',WSTART,1,NPIX(2),KUN,ISTAT)
          CALL STDWRI(IMNO,'NPTOT',NPTOT,1,NPIX(2),KUN,ISTAT)
          CALL STDWRI(IMNO,'NORDER',NORDER,1,NPIX(2),KUN,ISTAT)
      END IF
C
C ... free memory
C
   20 CALL TDMFRE(NBY,IP1,IS)
      CALL TDMFRE(NBY,IP2,IS)
      CALL TDMFRE(NBY,IP3,IS)
C
C ... end
C
      CALL DSCUPT(IMNO,IMNO,' ',ISTAT)
      CALL TBTCLO(TID,ISTAT)
   30 IF (ISTAT.NE.0) THEN
          WRITE (MSG(13:16),9000) ISTAT
          CALL TDERRR(ISTAT,MSG,STATUS)
      END IF
      RETURN
 9000 FORMAT (I4)
      END

      SUBROUTINE ACOPY(TID,ICOL1,ICOL2,NROW,X1,Y1,W,YMIN,YMAX,N1)
C
C copy relevant part of the table
C
      IMPLICIT NONE
C
      INTEGER TID, ICOL1, ICOL2
      INTEGER NROW, N1, I
      INTEGER STATUS
C
      REAL YMIN, YMAX
      REAL X1(NROW),Y1(NROW), X, Y
      REAL W(NROW)
C 
      LOGICAL ISEL, INULL1, INULL2
C
C
      N1     = 0
      DO 10, I = 1,NROW
          CALL TBSGET(TID,I,ISEL,STATUS)
          CALL TBERDR(TID,I,ICOL1,X,INULL1,STATUS)
          CALL TBERDR(TID,I,ICOL2,Y,INULL2,STATUS)
          IF (ISEL.AND. .NOT.INULL1 .AND. .NOT.INULL2) THEN
              N1     = N1 + 1
              X1(N1) = X
              Y1(N1) = Y
              W(N1)  = 1.
              IF (N1.EQ.1) THEN
                  YMIN   = Y
                  YMAX   = Y
              ELSE
                  IF (Y.GT.YMAX) YMAX   = Y
                  IF (Y.LT.YMIN) YMIN   = Y
              END IF
          END IF
   10 CONTINUE
      RETURN
      END

      SUBROUTINE AINTER(NROW,X,Y,NPIX1,NPIX2,F,START,STEP,WSTART,NPTOT,
     +                  RMIN,RMAX,W,IDEGR,S,T,C,NRDATA)
C
C call for each order to the interpolation routine
C
      IMPLICIT NONE
C 
      INTEGER MADRID
      INTEGER NROW,NPIX1, NPIX2,IDEGR
      INTEGER NPTOT(NPIX2)
      INTEGER ISTAT, NRDATA(1),NBYTES
      INTEGER IORD, NP, I, NK1, LD, NK, NPLUS,IERR
C 
      INTEGER*8   IPQ
C 
      REAL X(NROW),WSTART(NPIX2),F(NPIX1,NPIX2)
      REAL Y(NROW),START(2),STEP(2),RMIN,RMAX,S
      REAL W(1),T(1),C(1)
      REAL    DERIV, STARTX, STEPX, ENDX, VAL, XP, FP, FP0
      REAL    FPOLD, AMIN1, AMAX1
C 
      INCLUDE 'MID_INCLUDE:TABLES.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:TABLED.INC'
C
      RMIN   = 0.
      RMAX   = 0.
      STARTX = START(1)
      STEPX  = STEP(1)
      NP     = NPIX1
      NBYTES = NROW*24  
C     NBYTES = NROW*6   M.Peron 23/07/93
      CALL TDMGET(NBYTES,IPQ,ISTAT)
C
C ... order loop
C
      DO 50, IORD = 1,NPIX2
          IF (NPIX2.GT.1) THEN
C              STARTX = WSTART(IORD)
              NP     = NPTOT(IORD)
          END IF
C
C ... loop for each point  W(1), IDEGR, S, T(1), C(1), NRDATA(1)
C
C          ENDX   = STARTX + (NP-1)*STEPX
           ENDX   = X(NROW)
           STARTX = X(1)
          CALL SMOOT(X,Y,W,MADRID(IPQ),NROW,STARTX,ENDX,IDEGR,S,NK,T,
     +               C,FP,0,IERR,NRDATA,FP0,FPOLD,NPLUS)
          IF (IERR.EQ.-2)
     .    CALL STTPUT('Polynomial approximation',ISTAT)
          IF (IERR.EQ.1) 
     .    CALL STTPUT('Local storage exceeded (S too small)',ISTAT)
          IF (IERR.EQ.2) 
     .    CALL STTPUT('Tolerance parameter too small',ISTAT)
          IF (IERR.EQ.3)
     .    CALL STTPUT('Maximum number of iter. exceeded',ISTAT)
          IF (IERR.EQ.10) 
     .    CALL STTPUT('Invalid input arguments',ISTAT)
          IF (IERR.GT.0) RETURN
          LD     = IDEGR + 1
          NK1    = NK - IDEGR - 1
          IF (NPIX2.EQ.1) STARTX = START(1) 
          DO 30, I = 1,NP
              XP     = STARTX + (I-1)*STEPX
   10         IF ((XP.LT.T(LD+1)) .OR. (LD.EQ.NK1)) GO TO 20
              LD     = LD + 1
              GO TO 10
   20         VAL    = DERIV(T,NK,C,NK1,0,XP,LD)
              RMIN   = AMIN1(RMIN,VAL)
              RMAX   = AMAX1(RMAX,VAL)
              F(I,IORD) = VAL
   30     CONTINUE
          DO 40, I = NP + 1,NPIX1
              F(I,IORD) = 0.
   40     CONTINUE
   50 CONTINUE
      CALL TDMFRE(NBYTES,IPQ,ISTAT)
      RETURN

      END

C===========================================================================
C Copyright (C) 1995-2006 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================

C ++++++++++++++++++++++++  ystk.for +++++++++++++++++++++++++++++++++++++++
C .LANGUAGE Fortran 77
C .IDENTIFICATION Module ystk.for
C .COMMENTS
C Module contains layer between the keyword related FORTRAN STxxxx interfaces
C and the SC_interfaces written in (hopefully independent) C
C .AUTHOR         K. Banse        ESO - Garching
C .KEYWORDS       standard interfaces.
C .ENVIRONMENT    FORTRAN and C standards
C .VERSION  [1.00] 871207:  created from SXFTOC.C
C 
C 060330	last modif
C -----------------------------------------------------------------------------
C
      SUBROUTINE STKRDI(KEY,FELEM,MAXVALS,ACTVALS,VALUES,KUNIT,
     +                  KNULL,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   KEY        
      INTEGER     FELEM, MAXVALS, ACTVALS
      INTEGER     VALUES(*)
      INTEGER     KUNIT, KNULL
C 
      KUNIT = 0
      KNULL =-1
C 
      CALL STSTR(1,KEY)                           !STRIPPED_STRING
C 
      CALL STK1(FELEM,MAXVALS,ACTVALS,VALUES,STATUS)
C
      RETURN
      END
C
      SUBROUTINE STKRDR(KEY,FELEM,MAXVALS,ACTVALS,VALUES,KUNIT,
     +                  KNULL,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   KEY        
      INTEGER     FELEM, MAXVALS, ACTVALS
      REAL     VALUES(*)
      INTEGER     KUNIT, KNULL
C 
      KUNIT = 0
      KNULL = 0
C 
      CALL STSTR(1,KEY)                           !STRIPPED_STRING
C
      CALL STK2(FELEM,MAXVALS,ACTVALS,VALUES,STATUS)
C
      RETURN
      END
C
      SUBROUTINE STKRDD(KEY,FELEM,MAXVALS,ACTVALS,VALUES,KUNIT,
     +                  KNULL,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   KEY        
      INTEGER     FELEM, MAXVALS, ACTVALS
      DOUBLE PRECISION     VALUES(*)
      INTEGER     KUNIT, KNULL
C 
      KUNIT = 0
      KNULL = 0
C 
      CALL STSTR(1,KEY)                           !STRIPPED_STRING
C
      CALL STK3(FELEM,MAXVALS,ACTVALS,VALUES,STATUS)
C
      RETURN
      END
C 
C
      SUBROUTINE STKRDC(KEY,NOELM,FELEM,MAXVALS,ACTVALS,VALUES,KUNIT,
     +                  KNULL,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   KEY, VALUES
      INTEGER     NOELM, FELEM, MAXVALS, ACTVALS
      INTEGER     KUNIT, KNULL
C 
      KUNIT = 0
      KNULL = 0
C 
      CALL STSTR(1,KEY)                           !STRIPPED_STRING
      CALL STLOC(1,1,VALUES)                      !blanked CHAR_LOC
C
      CALL STK4(NOELM,FELEM,MAXVALS,ACTVALS,STATUS)
C
      RETURN
      END
C 
C 
      SUBROUTINE STKPRC(PROMPT,KEY,NOELM,FELEM,MAXVALS,ACTVALS,VALUES,
     +                  KUNIT,KNULL,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   PROMPT, KEY, VALUES
      INTEGER     NOELM, FELEM, MAXVALS, ACTVALS
      INTEGER     KUNIT, KNULL
C 
      KUNIT = 0
      KNULL = 0
C 
      CALL STSTR(1,KEY)                           !STRIPPED_STRING
      CALL STSTR(2,PROMPT)                        !STRIPPED_STRING
      CALL STLOC(1,1,VALUES)                      !blanked CHAR_LOC
C
      CALL STK5(NOELM,FELEM,MAXVALS,ACTVALS,STATUS)
C
      RETURN
      END
C 
C
C
      SUBROUTINE STKPRI(PROMPT,KEY,FELEM,MAXVALS,ACTVALS,VALUES,
     +                  KUNIT,KNULL,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   PROMPT, KEY
      INTEGER     FELEM, MAXVALS, ACTVALS
      INTEGER   VALUES(*)
      INTEGER     KUNIT, KNULL
C
      KUNIT = 0
      KNULL = 0
C
      CALL STSTR(1,KEY)                           !STRIPPED_STRING
      CALL STSTR(2,PROMPT)                        !STRIPPED_STRING
C
      CALL STK6(FELEM,MAXVALS,ACTVALS,VALUES,STATUS)
C
      RETURN
      END
C
C
C
      SUBROUTINE STKPRR(PROMPT,KEY,NOELM,FELEM,MAXVALS,ACTVALS,VALUES,
     +                  KUNIT,KNULL,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   PROMPT, KEY
      INTEGER     FELEM, MAXVALS, ACTVALS
      REAL        VALUES(*)
      INTEGER     KUNIT, KNULL
C
      KUNIT = 0
      KNULL = 0
C
      CALL STSTR(1,KEY)                           !STRIPPED_STRING
      CALL STSTR(2,PROMPT)                        !STRIPPED_STRING
C
      CALL STK7(FELEM,MAXVALS,ACTVALS,VALUES,STATUS)
C
      RETURN
      END
C
C
C
      SUBROUTINE STKPRD(PROMPT,KEY,NOELM,FELEM,MAXVALS,ACTVALS,VALUES,
     +                  KUNIT,KNULL,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   PROMPT, KEY
      INTEGER     FELEM, MAXVALS, ACTVALS
      DOUBLE PRECISION   VALUES(*)
      INTEGER     KUNIT, KNULL
C
      KUNIT = 0
      KNULL = 0
C
      CALL STSTR(1,KEY)                           !STRIPPED_STRING
      CALL STSTR(2,PROMPT)                        !STRIPPED_STRING
C
      CALL STK8(FELEM,MAXVALS,ACTVALS,VALUES,STATUS)
C
      RETURN
      END
C
      SUBROUTINE STKWRC(KEY,NOELM,VALUES,FELEM,MAXVALS,KUNIT,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   KEY, VALUES
      INTEGER     NOELM, FELEM, MAXVALS
      INTEGER     KUNIT
C
      KUNIT = 0
C 
      CALL STSTR(1,KEY)                           !STRIPPED_STRING
      CALL STLOC(1,0,VALUES)                      !untouched CHAR_LOC
C 
      CALL STK9(NOELM,FELEM,MAXVALS,STATUS)

C
      RETURN
      END
C 
      SUBROUTINE STKWRI(KEY,VALUES,FELEM,MAXVALS,KUNIT,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   KEY
      INTEGER     FELEM, MAXVALS
      INTEGER   VALUES(*)
      INTEGER     KUNIT
C
      KUNIT = 0
C
      CALL STSTR(1,KEY)                           !STRIPPED_STRING
C
      CALL STK10(VALUES,FELEM,MAXVALS,STATUS)
C
      RETURN
      END
C
      SUBROUTINE STKWRD(KEY,VALUES,FELEM,MAXVALS,KUNIT,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   KEY
      INTEGER     FELEM, MAXVALS
      DOUBLE PRECISION   VALUES(*)
      INTEGER     KUNIT
C
      KUNIT = 0
      CALL STSTR(1,KEY)                           !STRIPPED_STRING
C
      CALL STK11(VALUES,FELEM,MAXVALS,STATUS)
C
      RETURN
      END
C
      SUBROUTINE STKWRR(KEY,VALUES,FELEM,MAXVALS,KUNIT,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   KEY
      INTEGER     FELEM, MAXVALS
      REAL        VALUES(*)
      INTEGER     KUNIT
C
      KUNIT = 0
C
      CALL STSTR(1,KEY)                           !STRIPPED_STRING
C
      CALL STK12(VALUES,FELEM,MAXVALS,STATUS)
C
      RETURN
      END
C 
      SUBROUTINE STKFND(KEY,CTYPE,NOELEM,BYTELEM,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   KEY, CTYPE
      INTEGER     NOELEM, BYTELEM, STATUS
C 
      CALL STSTR(1,KEY)                           !STRIPPED_STRING
      CALL STLOC(1,1,CTYPE)                       !blanked CHAR_LOC
C 
      CALL STK13(NOELEM,BYTELEM,STATUS)
C
      RETURN
      END
C
      SUBROUTINE STKINF(NPOS,FIELD,BUF,NUMBUF,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   BUF
      INTEGER     FIELD, NUMBUF, STATUS
C
      CALL STLOC(1,1,BUF)                         !blanked CHAR_LOC
C
      CALL STK14(NPOS,FIELD,NUMBUF,STATUS)
C
      RETURN
      END

C @(#)putlss.for	19.1 (ES0-DMD) 02/25/03 13:25:37
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine PUTLSS         version 1.0        880901
C  A. Kruszewski             Warsaw U. Obs.
C.PURPOSE
C.INPUT/OUTPUT
C-----------------------------------------------------------------------
      SUBROUTINE PUTLSS(L, NREG, LSTP, NCAT, PMTR, PRCT)
C
      IMPLICIT  NONE
      INCLUDE  'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER   NREG
      INTEGER   I , IPTR , IREG , ISIDE , IX , IY
      INTEGER   J , L , LSTP(0:4,0:NREG) , LZ
      INTEGER   KX , KY , NCAT(NIPAR,MAXCNT)
      REAL   PMTR(NRPAR,MAXCNT) , PRCT(0:MAXSUB,MAXCNT)
C
      IF ( LSTP(3,0) .NE. L-1 ) THEN
          WRITE(*,*) 'Regional linked lists are corrupted'
          STOP ' '
      ENDIF
C
C ******      Return if an object is already in the linked list.
C
      IF ( NCAT(7,L) .GT. 0 ) RETURN
C
C ******      Restore object's position.
C
      I = NCAT(1,L)
      J = NCAT(2,L)
C
C ******      Calculate region's number IREG.
C
      ISIDE = LSTP(0,0)
      KX = LSTP(1,0)
      KY = LSTP(2,0)
      IX = ( I - LSTP(1,1) ) / ISIDE + 1
      IY = ( J - LSTP(2,1) ) / ISIDE + 1
      IREG = (IY-1) * KX + IX
      IF ( IREG .LE. 0 . OR. IREG .GT. NREG ) THEN
          LSTP(3,0) = L
          NCAT(7,L) = 0
          NCAT(8,L) = 0
          RETURN
      ENDIF
C
C ******      Write region's number.
C
      NCAT(7,L) = IREG
C
C ******      Find pointer to begining of linked list.
C
      IPTR = LSTP(0,IREG)
C
C ******      Check if the list has any elements.
C
      IF ( IPTR .EQ. 0 ) THEN
            LSTP(0,IREG) = L
            NCAT(8,L) = 0
      ELSE IF ( IPTR .EQ. L ) THEN
            CONTINUE
      ELSE
   10            CONTINUE
            LZ = IPTR
            IPTR = NCAT(8,LZ)
            IF ( IPTR .NE. 0 ) GOTO 10
            NCAT(8,LZ) = L
            NCAT(8,L) = 0
      ENDIF
C
      LSTP(3,0) = L
C
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2006 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++
C.IDENTIFICATION for_test.for
C.LANGUAGE       F77
C.AUTHOR         Francois Ochsenbein
C.ENVIRONMENT    Any
C.KEYWORDS       FOR to C
C.PURPOSE        Check Fortran to C interface
C.COMMENTS       
C.VERSION  1.0   16-Oct-1990
C 
C 060228	last modif
C----------------
C 
      INTEGER    MADRID(3)
C 
      CHARACTER*79  s1
      CHARACTER*161 s2
      CHARACTER*4   s3
C 
      CHARACTER*5   s4
      CHARACTER*40  st1, st2, st3
C 
      COMMON/VMR/MADRID
C 
      s1 = 'sY<01234567890ABCDEFGHIJKLMNOPQRSTUVWXYZ>'
      s2 = 's2<abcdefghijklmnopqrstuvwxyz01234567890>XYZ'
      s3 = 's3.X'
      st1 = 'where does this string go? '
      st2 = 'filling up space... '
      st3 = '&now, occupying 40 characters over here&& '
      s4 = 'Klaus'
C
      MADRID(2) = 99
      CALL CSUB()
      IF (MADRID(1) .NE. -1) THEN
         WRITE(*,1123) MADRID(1)
         STOP 1
      ENDIF
C 
CC      write(*,1234) 'call SSP1(s1,-71,s2,-2)'
      CALL SSP1(s1,-71,s2,-2)
C 
CC      write(*,1234) 'call SSP2(3,-2,400,-71,555,666)'
      CALL SSP2(3,-2,400,-71,555,666)
C 
CC      write(*,1234) 'call SSP3(s4,s3,s1)'
      CALL SSP3(s4,s3,s1)
C 
C 
      STOP
C 
1234  FORMAT(A)
1123  FORMAT('COMMON MADRID(1) is ',I5,' instead of -1 ...')
C 
      END

C.IDENTIFICATION
C
C  Program IUECONCAT                   version 1.1      
C     A. Fuente     INSA/VILSPA May 21, 97.
C                       
C.KEYWORDS
C
C  TABLE, ORDERS, IUE HIGH DISPERSION, 
C
C.PURPOSE
C
C  Rebin IUE High Dispersion Extracted Spectra & connect overlapping regions
C
C.ALGORITHM
C
C
C.INPUT
C
C  Keys:  IN_A/C/1/60           input table
C         OUT_A/C/1/60          output table
C         COLW/C/1/60           wavelength col
C         COLO/C/1/60           order col
C         COLF/C/1/60           flux col
C         COLE/C/1/60           epsilon/quality col
C         CAME/I/1/1            camera number 
C         FLAG/C/1/1            selection method flag   
C         INPUTR/R/1/3          start,end,stepsize of the output table
C
C.VERSION
C 080722	last modif
C
C-----------------------------------------------------------
C
C
      PROGRAM IUECONCAT
      IMPLICIT NONE

      INTEGER		ICOL,MAX,MAXORD	
      PARAMETER         (ICOL = 4)
      PARAMETER         (MAX  = 70000)
      PARAMETER         (MAXORD = 125)
C
      INTEGER           COL(ICOL)
      INTEGER*8         ADDR(ICOL)
      INTEGER           INDEX(MAX)
      CHARACTER*60      TABIN
      CHARACTER*60      TABOUT
      CHARACTER*60      COLS(ICOL)
      INTEGER           NCAM  
      CHARACTER*1       FLAG,CAME
      REAL              LMIN(MAXORD),LMAX(MAXORD)
C
      CHARACTER*80      MSG
      INTEGER           N
      REAL              DIMS(3),START,STEP
      REAL              RX(MAX)
      REAL              RY(MAX)
      INTEGER           REPS(MAX)
      INTEGER           MASK
      INTEGER           I,IACT,KUN,KNUL,ISTAT,Z
      INTEGER           NCOL,NRO,NSC,NAC,NAR,NP
      INTEGER           MADRID
      INTEGER           TID   
C
      COMMON /VMR/MADRID(1)
C 
      DATA MSG  	/'*** ERROR (IUECONCAT):'/	
 
C
C ... get into MIDAS
C
      CALL stspro('IUECONCAT')
C                                         
C ... get input parameters 
C
 
      CALL STKRDC('IN_A',1,1,60,IACT,TABIN,KUN,KNUL,ISTAT)
      CALL STKRDC('OUT_A',1,1,60,IACT,TABOUT,KUN,KNUL,ISTAT)
      CALL STKRDC('COLW',1,1,60,IACT,COLS(1),KUN,KNUL,ISTAT)
      CALL STKRDC('COLO',1,1,60,IACT,COLS(2),KUN,KNUL,ISTAT)
      CALL STKRDC('COLF',1,1,60,IACT,COLS(3),KUN,KNUL,ISTAT)
      CALL STKRDC('COLE',1,1,60,IACT,COLS(4),KUN,KNUL,ISTAT)
      CALL STKRDC('FLAG',1,1,1,IACT,FLAG,KUN,KNUL,ISTAT)
      CALL STKRDC('CAME',1,1,1,IACT,CAME,KUN,KNUL,ISTAT)
      READ (CAME,FMT='(I1)') NCAM   
      CALL STKRDR('INPUTR',1,3,IACT,DIMS,KUN,KNUL,ISTAT)
C
C ... init input table
C
      CALL TBTOPN(TABIN,2,TID,ISTAT)
         IF (ISTAT.NE.0) GO TO 1000
      CALL TBIGET(TID,NCOL,NRO,NSC,NAC,NAR,ISTAT)
         IF (ISTAT.NE.0) GO TO 1000
      CALL TBCMAP(TID,0,MASK,ISTAT)
         IF (ISTAT.NE.0) GO TO 1000
C
C ... find wavelength column          i=1
C ... find order column               i=2
C ... find flux column                i=3
C ... find epsilon column             i=4
C
      DO I=1,ICOL
         CALL TBCSER(TID,COLS(I),COL(I),ISTAT)
            IF (ISTAT.NE.0)   GO TO 1000
            IF (COL(I).EQ.-1) GO TO 1000
         CALL TBCMAP(TID,COL(I),ADDR(I),ISTAT)   
            IF (ISTAT.NE.0) GO TO 1000
      ENDDO
C
C ... compute valid wavelength range for each order
C
C
      CALL ORDRANGE(NCAM,NRO,MADRID(ADDR(1)),MADRID(ADDR(2)),
     &              MADRID(ADDR(3)),FLAG,LMIN,LMAX,Z)
 
      IF (Z.EQ.0) THEN
         WRITE(MSG,FMT='(A)')'*** ERROR: flux column not calibrated' 
         CALL STTPUT(MSG,ISTAT)
         GOTO 1000
      ENDIF 
 
C
C ... select and sort the points 
C
      CALL ORDSEL(NRO,MADRID(ADDR(1)),MADRID(ADDR(2)),
     &            LMIN,LMAX,INDEX,NP)
 
C
C ... rebin the table
C
      START = DIMS(1)
      STEP  = DIMS(3)
      N     = (DIMS(2) - DIMS(1)) / STEP
C 
      CALL REBIN(START,STEP,N,MADRID(ADDR(1)),MADRID(ADDR(3)),
     &           MADRID(ADDR(4)),INDEX,NP,RX,RY,REPS)
C
C ... write output table
C
      CALL WRITEOUT(TABOUT,N,RX,RY,REPS,COLS(4))
 
C
C ... end
C
      CALL TBTCLO(TID, ISTAT)
C
C ... end
C
1000  IF (ISTAT.NE.0) THEN
         CALL STETER(ISTAT,MSG)
      ENDIF
 
1002  CALL STSEPI ('IUECONCAT')

      END

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      SUBROUTINE ORDSEL (NROW,WAVE,ORDER,LMIN,LMAX,INDEX,NP)
C
C------------------------------------------------------------------------------
C
      IMPLICIT NONE
      INTEGER               NROW
      REAL                  WAVE(NROW)               
      INTEGER               ORDER(NROW)
      REAL                  LMIN(*),LMAX(*)
      INTEGER               INDEX(*)
      INTEGER               NP
 
      INTEGER               I
C
C
      NP = 0
      DO I = 1, NROW
         IF (WAVE(I).GE.LMIN(ORDER(I)).AND.
     &       WAVE(I).LT.LMAX(ORDER(I))) THEN
                NP = NP + 1 
                INDEX(NP) = I
         ENDIF
      ENDDO
C
C ... sort the index in wavelength ascending order
C
      CALL INDEXX(NP,WAVE,INDEX)
C
       RETURN
C
      END       

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C 
      SUBROUTINE ORDRANGE(CAM,NROW,WAVE,ORDER,FLUX,FLAG,LMIN,LMAX,Z)
C
C---------------------------------------------------------------------------
C     a. fuente   Jul. 17, 1991.
C     define wavelength regions for overlapping orders:
C       note that the order number m, decreases with  wavelength
C
C       order m       min(m) ---------------------max(m)  
C       order m-1                 min(m-1)----------------------max(m-1)
C                                     
C                             ^      ^      ^
C                                       L      C      R
C
C      flag = L eft     cut wavelength  = min(m-1)
C           = R ight                    = max(m)
C           = C enter                   = (max(m) + min(m-1))/2.
C           = O ptimal  (default)
C               SWP: the order ends      have worse quality
C               LW : the order beginings have worse quality
C           = E chelle  define wavelength regions for order m as
C                                 [lc(m+1/2),lc(m-1/2)]
C             coef. from NASA IUE Newsletters, July 82, n. 19, pag. 37-47
C             Ake (1982)
C
      IMPLICIT NONE
      INTEGER        	CAM,NROW
      REAL     		WAVE(*)
      INTEGER   	ORDER(*)
      REAL              FLUX(*)
      CHARACTER*1       FLAG
      REAL              LMIN(*),LMAX(*)
      INTEGER 		Z
C
      REAL		ZERO	
      PARAMETER         (ZERO = 0.0)
C
      REAL              MIN(125),MAX(125),DELTA
      INTEGER           LAST_ORD(4),FIRST_ORD
      INTEGER           M,MMIN,MMAX,STAT,I,NEXT
      REAL              K1(4),K2(4),K3(4),CO,CN
      CHARACTER*80      RECORD,HD,HD2
C     
      DATA FIRST_ORD    /125/
      DATA LAST_ORD     /72,72,66,66/
 
      DATA K1 /230036.0 ,230036.0  ,138827.0,0/
      DATA K2 / 15.3456 ,15.3456  ,-27.426 ,0/
      DATA K3 /-0.050638,-0.050638,0.165883,0 /
 
      IF (FLAG.EQ.'R'.OR.FLAG.EQ.'r') THEN
         CO = 1.00
         CN = 1.00
      ELSEIF (FLAG.EQ.'L'.OR.FLAG.EQ.'l') THEN
         CO = 0.00
         CN = 0.00
      ELSEIF (FLAG.EQ.'C'.OR.FLAG.EQ.'c') THEN
         CO = 0.50
         CN = 0.50
      ELSE                    
C            	                                ! default optimal cuts
         IF (CAM.EQ.3) THEN                 
C                                               ! SWP
            CO = 0.30
            CN = 0.23
         ELSEIF (CAM.EQ.1.OR.CAM.EQ.2) THEN     
C                                               !LWP & LWR
            CO = 0.75
            CN = 0.65
         ENDIF
      ENDIF             
 

      DO M=FIRST_ORD, LAST_ORD(CAM), -1
         MIN(M) = 5000.0
         MAX(M) = 0.0
      ENDDO
C
      Z = 0 
      DO I=1,NROW
          IF (FLUX(I).NE.ZERO) THEN
             Z = Z + 1
             IF (WAVE(I).GE.MAX(ORDER(I))) MAX(ORDER(I)) = WAVE(I)
             IF (WAVE(I).LE.MIN(ORDER(I))) MIN(ORDER(I)) = WAVE(I)
          ENDIF 
      ENDDO
C 
      LMIN(FIRST_ORD) = MIN(FIRST_ORD)
      LMAX(LAST_ORD(CAM)) = MAX(LAST_ORD(CAM))  
C 
      IF (FLAG.EQ.'E'.OR.FLAG.EQ.'e') THEN
         DO M = FIRST_ORD, LAST_ORD(CAM), -1
            MMIN = FLOAT(M) + 0.5
            MMAX = FLOAT(M) - 0.5
            LMIN(M) = (K1(CAM) / MMIN) + K2(CAM) + (K3(CAM) * MMIN)
            LMAX(M) = (K1(CAM) / MMAX) + K2(CAM) + (K3(CAM) * MMAX)
         ENDDO
      ELSE
         DO M=FIRST_ORD, LAST_ORD(CAM)+1, -1
            NEXT = M-1
            IF (MAX(M).GT.MIN(NEXT)) THEN    
C							 ! Overlapping
               DELTA = MAX(M) - MIN(NEXT) 
               LMAX(M)    = MIN(NEXT) +  CO*DELTA
               LMIN(NEXT) = MIN(NEXT) +  CN*DELTA
            ELSE
               LMAX(M)    = MAX(M)
               LMIN(NEXT) = MIN(NEXT) 
            ENDIF
         ENDDO
      ENDIF
C                                           
 
      HD =' Order  Lambda_min  Lambda_max  Cut_min      Cut_max   '
      HD2=' -----  ----------  ----------  ----------   ----------'
C      
C    					 ! Write in the MIDAS log too           
      CALL STTPUT(HD,STAT) 
      CALL STTPUT(HD2,STAT)
 
      DO M=FIRST_ORD,LAST_ORD(CAM), -1
         IF (MIN(M).LT.5000) THEN
            WRITE(RECORD,1001) M,MIN(M),MAX(M),LMIN(M),LMAX(M)
1001        FORMAT(1X,I5,2X,F10.3,2X,F10.3,2X,F10.3,2X,F10.3)
            CALL STTPUT(RECORD,STAT)   
         ENDIF
      ENDDO
C
      RETURN
      END


C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      SUBROUTINE WRITEOUT(TABOUT,NP,WAVE,FLUX,EPSI,EPSLAB)
C
C-----------------------------------------------------------------------------
C
      IMPLICIT NONE
      CHARACTER*60    TABOUT
      INTEGER         NP
      REAL            WAVE(*)
      REAL            FLUX(*)
      INTEGER         EPSI(*)
C
      CHARACTER*(*)   EPSLAB
      CHARACTER*16    LABEL(3)
      CHARACTER*16    UNIT(3)
      CHARACTER*8     FMT(3)
      INTEGER         DATYPE(3)
      INTEGER         IROW,C,TID,STAT,I   
C     
      INCLUDE  'MID_INCLUDE:ST_DEF.INC'
      INCLUDE  'MID_INCLUDE:ST_DAT.INC'
C
      DATA  LABEL/'WAVELENGTH', 'FLUX',      'EPSILON'/
      DATA  UNIT /'ANGSTROM',   'ERG/CM2/A', 'UNITLESS'/
      DATA  FMT  /'F8.3',       'E12.4',     'I5'/
      DATYPE(1) = D_R4_FORMAT
      DATYPE(2) = D_R4_FORMAT
      DATYPE(3) = D_I4_FORMAT
C
C ... create the output file and columns
C
      LABEL(3) = EPSLAB(1:16)
      CALL TBTINI(TABOUT,F_TRANS,F_IO_MODE,5,NP,TID,STAT)
           IF (STAT.NE.0) RETURN
C
      DO I=1,3
         CALL TBCINI(TID,DATYPE(I),1,FMT(I),UNIT(I),LABEL(I),C,STAT)
      ENDDO
C                                             
C ... write columns
C
      DO IROW=1,NP
         CALL TBEWRR(TID,IROW,1,WAVE(IROW),STAT)
      ENDDO
C
      DO IROW=1,NP
         CALL TBEWRR(TID,IROW,2,FLUX(IROW),STAT)
      ENDDO
C
      DO IROW=1,NP
         CALL TBEWRI(TID,IROW,3,EPSI(IROW),STAT)
      ENDDO
C
      CALL TBTCLO(TID,STAT)
C
      RETURN
C
      END
 

C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      SUBROUTINE REBIN(START,STEP,N,X,Y,EPS,INDEX,NP,RX,RY,REPS)
C
C----------------------------------------------------------------------
C
      IMPLICIT NONE
      REAL       START
      REAL       STEP
      INTEGER    N
      REAL       X(*)
      REAL       Y(*)
      INTEGER    EPS(*)
      INTEGER    INDEX(*)
      INTEGER    NP
      REAL       RX(*)
      REAL       RY(*)
      INTEGER    REPS(*)
C               
      INTEGER    GOODEPS
      PARAMETER  (GOODEPS = 0)
      REAL       TRESHOLD
      PARAMETER  (TRESHOLD  = 1/10.)
C                                   ! fraction of bad pixles into a bin 
C                                   ! to be marked as bad bin
C
      INTEGER    I,K,PIX,BADPIX,TINULL,MINEPS,MAXEPS
      REAL       TRNULL,STEP2
      DOUBLE PRECISION  SY,RXMIN,RXMAX,TDNULL
C                    
      CALL TBMNUL(TINULL,TRNULL,TDNULL)
C
C ...
C
      STEP2 =  STEP / 2.
C
      DO I=1,N
         RX(I) =   START + STEP * (I-1)
         RY(I) =   TRNULL
         REPS(I) = TINULL
      ENDDO
C
      I = 1
      RXMIN = START  - STEP2 
1000  CONTINUE      
      IF (X(INDEX(I)).LE.RXMIN) THEN 
         I = I + 1
         IF (I.GT.NP) RETURN
         GOTO 1000
      ENDIF
C
      DO K = 1, N
C!       RXMIN = RX(K) - STEP2      
         RXMAX = RX(K) + STEP2
         PIX = 0
         BADPIX = 0
         SY = 0
         MINEPS = GOODEPS
         MAXEPS = GOODEPS
2000	 CONTINUE
         IF (X(INDEX(I)).LE.RXMAX) THEN
            PIX = PIX + 1
            SY = SY + Y(INDEX(I))
            IF (EPS(INDEX(I)).LT.GOODEPS) BADPIX = BADPIX + 1
            IF (MINEPS.GT.EPS(INDEX(I))) MINEPS = EPS(INDEX(I))
            IF (MAXEPS.LT.EPS(INDEX(I))) MAXEPS = EPS(INDEX(I))
            I = I + 1
            IF (I.GT.NP) RETURN
            GOTO 2000
         ENDIF      
         IF (PIX.GT.0) THEN 
            RY(K) = SY / PIX
            IF (BADPIX.GT.(PIX*TRESHOLD)) THEN
               REPS(K) = MINEPS
            ELSE 
               REPS(K) = MAXEPS   
            ENDIF 
         ENDIF 
      ENDDO
C 
      RETURN
      END                          

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      SUBROUTINE INDEXX(N,ARRIN,INDX)
C
C---------------------------------------------------------------------------
C     Sorts the index to an array ARRIN in ascending order 
C     ARRIN values are not changed.
C
C     From Numerical Recipes pag. 233
C
      IMPLICIT NONE
      INTEGER  N
      REAL     ARRIN(*)
      INTEGER  INDX(N)
C
      INTEGER L,IR,INDXT,I,J
      REAL    Q
            
      L=N/2+1
      IR=N
 
10    CONTINUE
         IF (L.GT.1) THEN
            L=L-1
            INDXT=INDX(L)
            Q=ARRIN(INDXT)
         ELSE
            INDXT=INDX(IR)
            Q=ARRIN(INDXT)
            INDX(IR)=INDX(1)
            IR=IR-1
            IF (IR.EQ.1) THEN
               INDX(1)=INDXT
               RETURN
            ENDIF
         ENDIF
         I=L
         J=L+L
20       IF (J.LE.IR) THEN
            IF (J.LT.IR) THEN
               IF (ARRIN(INDX(J)).LT.ARRIN(INDX(J+1))) J=J+1
            ENDIF
            IF (Q.LT.ARRIN(INDX(J))) THEN
               INDX(I)=INDX(J)
               I=J
               J=J+J
            ELSE
               J=IR+1
            ENDIF
            GO TO 20
         ENDIF
         INDX(I)=INDXT
         GO TO 10
      END

C===========================================================================
C Copyright (C) 1995-2008 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM REPLA
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  program REPLA			version 1.00	880902
C  K. Banse				ESO - Garching
C
C.KEYWORDS
C  pixels
C
C.PURPOSE
C  replace pixels in a given interval by another value
C
C.ALGORITHM
C  get the names of input + output frames from IN_A + IN_B,
C  get the low + hi limits of replacement interval and replacing value from P3
C  in the form low,hi=repla or low=repla, if interval is only 1 value
C
C  copy descriptor LHCUTS to output frame to keep same colours at same pixels!
C
C.INPUT/OUTPUT
C  the following keys are used:
C
C  IN_A/C/1/80		input frame
C  OUT_A/C/1/80		output frame
C  P3/C/1/100		interval and replacing value in the form:
C			test_frame/low,hi=in_fram1'op'val1[,in_fram2'op'val2]
C			with op = +,-.* or /
C			or test_frame/low,hi=value
C			if test_frame/ is omitted, main input frame is used
C
C.VERSIONS
C  
C 081114		last modif
C	
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      I,IAV,II,LL,N,M
      INTEGER      NAXIS,NAXISA
      INTEGER      IMNOA,IMNOB1,IMNOB2,IMNOC,IMNOT
      INTEGER      NLIMIT,SIZE,SIZET,STAT
      INTEGER      NPIXA(6),NPIX(6)
      INTEGER      GENNUM,IFNUMB,CLONY
      INTEGER      MAPSIZ,NOFF,NOCO,RMAIND
      INTEGER      UNI(1),NULO,MADRID(1)
      INTEGER*8    PNTRA,PNTRB1,PNTRB2,PNTRC,PNTRT
C
      CHARACTER*80 FRAMEA,FRAMB1,FRAMB2,FRAMET,FRAMEC
      CHARACTER    STRING*100,LOSTR*40,HISTR*40,VALSTR*40
      CHARACTER    RSIDE*60,RSIDEA*60,RSIDEB*60
      CHARACTER    NEWSTR*100,XSTR*40
      CHARACTER    OP*2,OPS(4)*1,ETEST*1
C
      REAL        LOVAL,HIVAL,VALUE(2)
C 
      DOUBLE PRECISION  DVAL
C
      COMMON  /VMR/  MADRID
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      DATA   OPS   /'+','-','*','/'/
      DATA   LOVAL /0./, HIVAL /0./, VALUE /0.,0./
      DATA   IMNOA /-1/,  IMNOC /-1/
      DATA   IMNOT /-1/,  IMNOB1 /-1/,  IMNOB2 /-1/
      DATA   PNTRA /-1/,  PNTRC /-1/
      DATA   PNTRT /-1/,  PNTRB1 /-1/,  PNTRB2 /-1/
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C  set up MIDAS environment + enable automatic error abort
      CALL STSPRO('REPLA')
      OP = '  '
      CLONY = 1
C
C  get input + result frame + map them
      CALL STKRDC('IN_A',1,1,80,IAV,FRAMEA,UNI,NULO,STAT)
      CALL STKRDC('OUT_A',1,1,80,IAV,FRAMEC,UNI,NULO,STAT)
      STRING(1:) = ' '
      CALL STKRDC('P3',1,1,100,IAV,STRING,UNI,NULO,STAT)
      CALL STFOPN(FRAMEA,D_R4_FORMAT,0,F_IMA_TYPE,IMNOA,STAT)
      CALL STDRDI(IMNOA,'NAXIS',1,1,IAV,NAXISA,UNI,NULO,STAT)
      CALL STDRDI(IMNOA,'NPIX',1,NAXISA,IAV,NPIXA,UNI,NULO,STAT)
C 
C  get total size
      SIZE = 1
      DO 400, N=1,NAXISA
         SIZE = SIZE * NPIXA(N)
400   CONTINUE
C 
C  create buffer space
      CALL STKRDI('MONITPAR',20,1,IAV,MAPSIZ,UNI,NULO,STAT)
      MAPSIZ = MAPSIZ * MAPSIZ                !org_val = NPIX of square image
      IF (MAPSIZ .LT. 1000) MAPSIZ = 40000
      NOCO = SIZE / MAPSIZ                    !get chunk size
      N = NOCO * MAPSIZ
      RMAIND = SIZE - N                       !remainder
      CALL STFXMP(MAPSIZ,D_R4_FORMAT,PNTRA,STAT)
C
      CALL GENEQF(FRAMEA,FRAMEC,STAT)
      IF (STAT.EQ.1) THEN                     !if equal, just update ...
         IMNOC = IMNOA
         PNTRC = PNTRA
         CLONY = 1
      ELSE                                    !create new frame ...
         CALL GENBLD(IMNOA,FRAMEC,D_R4_FORMAT,SIZE,IMNOC,CLONY,STAT)
         CALL STFXMP(MAPSIZ,D_R4_FORMAT,PNTRC,STAT)       !map working space
      ENDIF                                   !CLONY = 1 for cloned descr's
C
C  isolate expression after the `=' sign
      II = INDEX(STRING,'=')
      IF (II.LE.1)
     +   CALL STETER(5,'no replacement string found...')
      RSIDE = STRING(II+1:)//' '
      STRING(II:) = ' '
C
C  get the other parameters
      I = INDEX(STRING,'/')                   !look for test_frame...
      IF (I.GT.0) THEN                        !yes.
         FRAMET = STRING(1:I-1)//' '
         CALL CLNFRA(FRAMET,FRAMET,0)
C
         CALL GENEQF(FRAMEA,FRAMET,STAT)
         IF (STAT.NE.1) THEN
            CALL STFOPN(FRAMET,D_R4_FORMAT,0,F_IMA_TYPE,IMNOT,STAT)
            CALL STDRDI(IMNOT,'NAXIS',1,1,IAV,NAXIS,UNI,NULO,STAT)
            CALL STDRDI(IMNOT,'NPIX',1,NAXIS,IAV,NPIX,UNI,NULO,STAT)
            SIZET = 1
            DO 600, N=1,NAXIS
               SIZET = SIZET*NPIX(N)
600         CONTINUE
            IF (SIZET.NE.SIZE) GOTO 9800
            CALL STFXMP(MAPSIZ,D_R4_FORMAT,PNTRT,STAT)
         ELSE
            IMNOT = IMNOA
            PNTRT = PNTRA
         ENDIF
         NEWSTR = STRING(I+1:)//' '
      ELSE  
         IMNOT = IMNOA                        !use basic input frame
         PNTRT = PNTRA
         NEWSTR = STRING
      ENDIF
C
C  process the replacement interval
      NLIMIT = 0                              !default to full interval
      I = INDEX(NEWSTR,',')
      IF ((I.LE.1).OR.(I.GT.31))
     +   CALL STETER(5,'low replacement interval invalid...')
C 
      LOSTR = NEWSTR(1:I-1)//' '
      IF (LOSTR.EQ.'<') THEN
         NLIMIT = -1
      ELSE
         CALL GENCNV(LOSTR,4,1,IAV,LOVAL,DVAL,LL)
         IF (LL.LE.0) GOTO 9900
         LOVAL = SNGL(DVAL)
      ENDIF
C 
      HISTR = NEWSTR(I+1:II-1)//' '
      IF (HISTR.EQ.'>') THEN
         IF (NLIMIT.EQ.0) THEN
            NLIMIT = 1
         ELSE
            GOTO 9900
         ENDIF
      ELSE
         CALL GENCNV(HISTR,4,1,IAV,HIVAL,DVAL,LL)
         IF (LL.LE.0) GOTO 9900
         HIVAL = SNGL(DVAL)
      ENDIF
C
C  look for separating comma in right hand expression
      I = INDEX(RSIDE,',')
      IF (I.LE.0) THEN
         RSIDEA(1:) = RSIDE(1:)
         RSIDEB(1:) = ' '
      ELSE IF (I.EQ.1) THEN
         CALL STETER(5,'wrong syntax ...')
      ELSE
         RSIDEA(1:) = RSIDE(1:I-1)//' '
         RSIDEB(1:) = RSIDE(I+1:)//' '
      ENDIF
C
C  now let's analyze the right side(s)
C
      I = INDEX(RSIDEA,'(')
      IF (I.GT.1) THEN                              !frame`op'(xxx)
         XSTR(1:) = RSIDEA(I+1:)
         RSIDEA(I:) = '0 '                           !put in a 0 as place holder
         I = INDEX(XSTR,')')                        !and cut off closing ')'
         IF (I.LT.2) GOTO 9900
         XSTR(I:I) = ' '
      ELSE
         XSTR(1:1) = ' '
      ENDIF
C 
      DO 1000, N=1,4
         I = INDEX(RSIDEA,OPS(N))
         IF (I.GT.1) THEN
            IF ((N.LE.2) .AND. (GENNUM(RSIDEA).EQ.1)) THEN    !test if 123.E+05
               ETEST = RSIDEA(I-1:I-1)          !get char. before + or -
               IF ((ETEST.EQ.'E') .OR. (ETEST.EQ.'e')) THEN
                  LL = I + 2                    !skip past `+' or `-'
                  DO 900, M=1,4
                     II = INDEX(RSIDEA(LL:),OPS(M))    !check for operands
                     IF (II.GT.0)
     +               CALL STETER(2,'first operand must be a frame...')
900               CONTINUE
                  GOTO 1100
               ENDIF
            ENDIF
            OP(1:1) = OPS(N)
            GOTO 2000
         ENDIF
1000  CONTINUE
C
C  only constant or frame
1100  IF (GENNUM(RSIDEA).EQ.1) THEN
         OP(1:1) = 'C'
         IF (XSTR(1:1) .EQ. ' ') THEN
            VALSTR(1:) = RSIDEA(1:)
         ELSE
            VALSTR(1:) = XSTR(1:)
         ENDIF
         PNTRB1 = PNTRA                   !use basic in frame as 2. input frame
         IMNOB1 = IMNOA
         GOTO 3000
      ELSE
         OP(1:1) = 'F'
         CALL CLNFRA(RSIDEA,RSIDEA,0)
         CALL STFOPN(RSIDEA,D_R4_FORMAT,0,F_IMA_TYPE,IMNOB1,STAT)
         CALL STDRDI(IMNOB1,'NAXIS',1,1,IAV,NAXIS,UNI,NULO,STAT)
         CALL STDRDI(IMNOB1,'NPIX',1,NAXIS,IAV,NPIX,UNI,NULO,STAT)
         SIZET = 1
         DO 1200, N=1,NAXIS
            SIZET = SIZET*NPIX(N)
1200     CONTINUE
         IF (SIZET.NE.SIZE) GOTO 9800
         IF (IMNOB1.EQ.IMNOA) THEN
            PNTRB1 = PNTRA 
         ELSE
            CALL STFXMP(MAPSIZ,D_R4_FORMAT,PNTRB1,STAT)
         ENDIF
C
         GOTO 3333
      ENDIF
C
C  we have another input frame
2000  FRAMB1(1:) = RSIDEA(1:I-1)//' '
      IF (GENNUM(FRAMB1).EQ.1)
     +   CALL STETER(2,'first operand must be a frame...')
C
      CALL CLNFRA(FRAMB1,FRAMB1,0)
      CALL STFOPN(FRAMB1,D_R4_FORMAT,0,F_IMA_TYPE,IMNOB1,STAT)
      CALL STDRDI(IMNOB1,'NAXIS',1,1,IAV,NAXIS,UNI,NULO,STAT)
      CALL STDRDI(IMNOB1,'NPIX',1,NAXIS,IAV,NPIX,UNI,NULO,STAT)
      SIZET = 1
      DO 2400, N=1,NAXIS
         SIZET = SIZET*NPIX(N)
2400  CONTINUE
      IF (SIZET.NE.SIZE) GOTO 9800
      IF (IMNOB1.EQ.IMNOA) THEN
         PNTRB1 = PNTRA 
      ELSE
         CALL STFXMP(MAPSIZ,D_R4_FORMAT,PNTRB1,STAT)
      ENDIF
      IF (XSTR(1:1) .EQ. ' ') THEN
         VALSTR = RSIDEA(I+1:)
      ELSE
         VALSTR(1:) = XSTR(1:)
      ENDIF
C
3000  CALL GENCNV(VALSTR,2,1,VALUE(1),VALUE(1),VALUE(1),LL)
      IF (LL.LE.0) GOTO 9900
C
C  look, if we have an alternative for the IF clause (if not we use FRAME)
3333  IF (RSIDEB(1:1).EQ.' ') GOTO 8000
C
      I = INDEX(RSIDEB,'(')
      IF (I.GT.1) THEN                              !frame`op'(xxx)
         XSTR(1:) = RSIDEB(I+1:)
         RSIDEB(I:) = '0 '                           !put in a 0 as place holder
         I = INDEX(XSTR,')')                        !and cut off closing ')'
         IF (I.LT.2) GOTO 9900
         XSTR(I:I) = ' '
      ELSE
         XSTR(1:1) = ' '
      ENDIF
C
      DO 4000, N=1,4
         I = INDEX(RSIDEB,OPS(N))
         IF (I.GT.1) THEN
            IF ((N.LE.2) .AND. (GENNUM(RSIDEB).EQ.1)) THEN    !test for 123.E+05
               ETEST = RSIDEB(I-1:I-1)          !get char. before + or -
               IF ((ETEST.EQ.'E') .OR. (ETEST.EQ.'e')) THEN
                  LL = I + 2                    !skip past `+' or `-'
                  DO 3900, M=1,4
                     II = INDEX(RSIDEB(LL:),OPS(M))    !check for operands
                     IF (II.GT.0) 
     +               CALL STETER(2,'first operand must be a frame...')
3900              CONTINUE
                  GOTO 4100
               ENDIF
            ENDIF
            OP(2:2) = OPS(N)
            GOTO 5000
         ENDIF
4000  CONTINUE
C
C  only constant or frame
4100  IF (GENNUM(RSIDEB).EQ.1) THEN
         OP(2:2) = 'C'
         IF (XSTR(1:1) .EQ. ' ') THEN
            VALSTR(1:) = RSIDEB(1:)
         ELSE
            VALSTR(1:) = XSTR(1:)
         ENDIF
         PNTRB2 = PNTRA                     !use basic inframe as 2. input frame
         IMNOB2 = IMNOA
         GOTO 6000
      ELSE
         OP(2:2) = 'F'
         CALL CLNFRA(RSIDEB,RSIDEB,0)
         CALL STFOPN(RSIDEB,D_R4_FORMAT,0,F_IMA_TYPE,IMNOB2,STAT)
         CALL STDRDI(IMNOB2,'NAXIS',1,1,IAV,NAXIS,UNI,NULO,STAT)
         CALL STDRDI(IMNOB2,'NPIX',1,NAXIS,IAV,NPIX,UNI,NULO,STAT)
         SIZET = 1
         DO 4200, N=1,NAXIS
            SIZET = SIZET*NPIX(N)
4200     CONTINUE
         IF (SIZET.NE.SIZE) GOTO 9800
         IF (IMNOB2.EQ.IMNOA) THEN
            PNTRB2 = PNTRA 
         ELSE
            CALL STFXMP(MAPSIZ,D_R4_FORMAT,PNTRB2,STAT)
         ENDIF
         GOTO 8000
      ENDIF
C
C  we have another input frame
5000  FRAMB2(1:) = RSIDEB(1:I-1)//' '
      IF (GENNUM(FRAMB2).EQ.1)
     +   CALL STETER(2,'first operand must be a frame...')
C
      CALL CLNFRA(FRAMB2,FRAMB2,0)
      CALL STFOPN(FRAMB2,D_R4_FORMAT,0,F_IMA_TYPE,IMNOB2,STAT)
      CALL STDRDI(IMNOB2,'NAXIS',1,1,IAV,NAXIS,UNI,NULO,STAT)
      CALL STDRDI(IMNOB2,'NPIX',1,NAXIS,IAV,NPIX,UNI,NULO,STAT)
      SIZET = 1
      DO 5400, N=1,NAXIS
         SIZET = SIZET*NPIX(N)
5400  CONTINUE
      IF (SIZET.NE.SIZE) GOTO 9800
      IF (IMNOB2.EQ.IMNOA) THEN
         PNTRB2 = PNTRA 
      ELSE
         CALL STFXMP(MAPSIZ,D_R4_FORMAT,PNTRB2,STAT)
      ENDIF
      IF (XSTR(1:1) .EQ. ' ') THEN
         VALSTR(1:) = RSIDEB(I+1:)
      ELSE
         VALSTR(1:) = XSTR(1:)
      ENDIF
C
6000  CALL GENCNV(VALSTR,2,1,VALUE(2),VALUE(2),VALUE(2),LL)
      IF (LL.LE.0) GOTO 9900
C
C  now do replacements
C
8000  NOFF = 1
      IFNUMB = 0
C 
8080  IF (NOCO.GT.0) THEN
         SIZET = MAPSIZ
      ELSE IF (RMAIND.GT.0) THEN
         SIZET = RMAIND
         RMAIND = 0
      ELSE
         GOTO 9000
      ENDIF
C 
      LL = 0
      CALL STFGET(IMNOA,NOFF,SIZET,IAV,MADRID(PNTRA),STAT)
      IF (IMNOT.NE.IMNOA)
     +   CALL STFGET(IMNOT,NOFF,SIZET,IAV,MADRID(PNTRT),STAT)
      IF ((IMNOB1.GE.0) .AND. (IMNOB1.NE.IMNOA))
     +   CALL STFGET(IMNOB1,NOFF,SIZET,IAV,MADRID(PNTRB1),STAT)
      IF ((IMNOB2.GE.0) .AND. (IMNOB2.NE.IMNOA))
     +   CALL STFGET(IMNOB2,NOFF,SIZET,IAV,MADRID(PNTRB2),STAT)
 
C 
      IF (OP(1:1).EQ.'C') THEN
         CALL IREPLA(MADRID(PNTRA),MADRID(PNTRT),
     +               MADRID(PNTRB2),MADRID(PNTRC),LL,
     +               OP,SIZET,LOVAL,HIVAL,NLIMIT,VALUE)
      ELSE IF (OP(1:1).EQ.'+') THEN
         CALL IREPLB(MADRID(PNTRA),MADRID(PNTRT),MADRID(PNTRB1),
     +               MADRID(PNTRB2),MADRID(PNTRC),LL,
     +               OP,SIZET,LOVAL,HIVAL,NLIMIT,VALUE)
      ELSE IF (OP(1:1).EQ.'-') THEN
         CALL IREPLC(MADRID(PNTRA),MADRID(PNTRT),MADRID(PNTRB1),
     +               MADRID(PNTRB2),MADRID(PNTRC),LL,
     +               OP,SIZET,LOVAL,HIVAL,NLIMIT,VALUE)
      ELSE IF (OP(1:1).EQ.'*') THEN
         CALL IREPLD(MADRID(PNTRA),MADRID(PNTRT),MADRID(PNTRB1),
     +               MADRID(PNTRB2),MADRID(PNTRC),LL,
     +               OP,SIZET,LOVAL,HIVAL,NLIMIT,VALUE)
      ELSE IF (OP(1:1).EQ.'/') THEN
         CALL IREPLE(MADRID(PNTRA),MADRID(PNTRT),MADRID(PNTRB1),
     +               MADRID(PNTRB2),MADRID(PNTRC),LL,
     +               OP,SIZET,LOVAL,HIVAL,NLIMIT,VALUE)
      ELSE
         CALL IREPLF(MADRID(PNTRA),MADRID(PNTRT),MADRID(PNTRB1),
     +               MADRID(PNTRB2),MADRID(PNTRC),LL,
     +               OP,SIZET,LOVAL,HIVAL,NLIMIT,VALUE)
      ENDIF
C 
      CALL STFPUT(IMNOC,NOFF,IAV,MADRID(PNTRC),STAT)
      IFNUMB = IFNUMB + LL
      NOCO = NOCO - 1
      NOFF = NOFF + IAV
      GOTO 8080                             !work on next chunk
C
C  take care of descriptors
9000  IF (CLONY.EQ.0) THEN                     !copy descr's + update history
         CALL DSCUPT(IMNOA,IMNOC,' ',STAT)  
      ELSE                                     !only update history
         CALL DSCUPT(IMNOC,IMNOC,' ',STAT)  
      ENDIF
      WRITE(STRING,10000) IFNUMB
      CALL STTPUT(STRING,STAT)
      CALL STKWRI('OUTPUTI',IFNUMB,15,1,NULO,STAT)
C
C  free data + exit
      CALL STSEPI
C
C  wrong input
9800  CALL STETER
     +  (4,'input/test frames must all have same dimensions...')
C 
9900  CALL STETER(1,'invalid parameters...')
C
10000 FORMAT(I8,' pixels in given interval replaced ...')
      END

C @(#)invanalys.for	19.1 (ES0-DMD) 02/25/03 13:26:20
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.IDENTIFICATION: ANALYS       VERSION 2.0           840522
C.PURPOSE:        For an input list of objects, calcul of classifying 
C                 parameters,  magnitudes, positions, gradients, profiles
c                 (see inventory user's manual from a. kruszewski)
C.AUTHOR:         A. Kruszewski
C.LANGUAGE:       F77+ESOext
C.KEYWORDS:       classifying parameters, magnitudes, positions, profiles
C.VERSION:        1.0  ESO-FORTRAN Conversion, AA  8:56 - 23 NOV 1987
C.VERSION:        Ch O, ESO - Garching  850115
C.VERSION:        AK, Obs. de Geneva    870303  changes for the Alliant FX
C.VERSION:        AK, ESO Garching      870702  new table column names
C.VERSION         MP, ESO Garching      890216  change length of TYPE
C-----------------------------------------------------------------------
      PROGRAM ANALYS
C
      IMPLICIT NONE
      INCLUDE  'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER   IACOL, IACT, IAROW, IARR(32)
      INTEGER*8  ICOLP, IPNTR, JPNTR, KPNTR, LPNTR
      INTEGER   ICOL(6), IHED, IMF
      INTEGER   ISTAT, ITF, ITOB(4), IXYU(4)
      INTEGER   JSIZE
      INTEGER   KNUL, KSIZE, KUN
      INTEGER   LPXL, LSBP, LSIZE
      INTEGER   MADRID(1)
      INTEGER   NAXIS, NBYTE, NCOLI, NEL
      INTEGER   NCAT(NIPAR,MAXCNT), NPIX(2), NROWI
      INTEGER   NX, NY, NSC
      INTEGER   IMAX, INIP
C
      REAL      PMTR(NRPAR,MAXCNT)
      REAL      PRCT(0:MAXSUB,MAXCNT)
      REAL      RARR(64)
C
      DOUBLE PRECISION  START(2)
      DOUBLE PRECISION  STEP(2)
      DOUBLE PRECISION  DBLONE
C
      CHARACTER*1    TYPE
      CHARACTER*16   COLAR, COLAV9, COLBGD
      CHARACTER*16   COLID, COLISO, COLX, COLY
      CHARACTER*48   CUNIT
      CHARACTER*60   FRAME, INTABL, OUTABL , OUTPSF
      CHARACTER*40   OPTION 
      CHARACTER*72   IDENT
      CHARACTER*80   OUTPUT
C
C     INCLUDE  'MID_INCLUDE:TABLES.INC/NOLIST'
      INCLUDE  'MID_INCLUDE:ST_DEF.INC/NOLIST'
      COMMON   /VMR/MADRID
C     INCLUDE  'MID_INCLUDE:TABLED.INC/NOLIST'
      INCLUDE  'MID_INCLUDE:ST_DAT.INC/NOLIST'
C
C *** Start Midas.
C
      CALL STSPRO('ANALYSE')
C
C *** Initialisation of column labels.
C
      DO IMAX = 1, MAXCNT
         DO INIP = 1, NIPAR
            NCAT(INIP,IMAX) = 0
         ENDDO 
      ENDDO

      DBLONE = 1.0
      COLID  = 'IDENT'
      COLX   = 'X'
      COLY   = 'Y'
      COLISO = 'RAD_ISO'
      COLBGD = 'BG'
      COLAV9 = 'INT'
      COLAR  = 'AR'
C
C *** Read arrays IARR and RARR.
C
      CALL RDKINV(IARR, RARR, ISTAT)
C
C *** Read image and tables names.
C
      CALL STKRDC('IN_A', 1, 1, 60, IACT, FRAME, KUN, KNUL, ISTAT)
      CALL STKRDC('IN_B', 1, 1, 60, IACT, INTABL, KUN, KNUL, ISTAT)
      CALL STKRDC('OUT_A', 1, 1, 60, IACT, OUTABL, KUN, KNUL, ISTAT)
      CALL STKRDC('INPUTC', 1, 1, 10, IACT, OPTION, KUN, KNUL, ISTAT)
      CALL STKRDC('OUT_B', 1, 1, 60, IACT, OUTPSF, KUN, KNUL, ISTAT)
C
C *** Open image frame.
C
      CALL STIGET(FRAME,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,2,
     &            NAXIS, NPIX, START, STEP, IDENT, CUNIT, IPNTR,
     &            IMF, ISTAT)
      NX = NPIX(1)
      NY = NPIX(2)
C
C *** Check if descriptor STARS is present if needed.
C
      IF (IARR(11) .LT. 0) THEN
         CALL STDFND(IMF, 'STARS', TYPE, NEL, NBYTE, ISTAT)
         IF (TYPE .EQ. ' ' .OR. NEL .LE. 0) THEN
            OUTPUT = '*** FATAL: '//
     2               'Descriptor STARS is missing in your frame'
            CALL STTPUT(OUTPUT, ISTAT)
            OUTPUT = '    Create it via GET/CURS STARS/DES or'
            CALL STTPUT(OUTPUT, ISTAT)
            OUTPUT = '    set keyword PRFLCTRL to non-negative value.'
            CALL STTPUT(OUTPUT, ISTAT)
            CALL STSEPI
         ENDIF
      ENDIF
C
C *** Read descriptor DPROFILE after testing its presence.
C
      CALL STDFND(IMF, 'DPROFILE', TYPE, NEL, NBYTE, ISTAT)
      IF (.NOT. (TYPE .EQ. ' ' .OR. NEL .LE. 0)) THEN
         CALL STDRDR(IMF, 'DPROFILE', 1, 25, IACT, RARR(14),
     &               KUN, KNUL, ISTAT)
      ENDIF
C
C *** Find borders of an area on which the search
C *** shall be made. It has the form of rectangle.
C *** The keyword PHYSICAL = IARR(7) tells if the
C *** search rectangle is defined by physical coordinates
C *** RARR(54) - RARR(57) (IARR(7)=1), or by pixel
C *** coordinates IARR(12) - IARR(15) (IARR(7)=0).
C
      IF (IARR(7) .EQ. 1) THEN
         IARR(12) = 1 + NINT((DBLE(RARR(54)) - START(1))/STEP(1))
         IARR(13) = 1 + NINT((DBLE(RARR(55)) - START(2))/STEP(2))
         IARR(14) = 1 + NINT((DBLE(RARR(56)) - START(1))/STEP(1))
         IARR(15) = 1 + NINT((DBLE(RARR(57)) - START(2))/STEP(2))
      ENDIF
C
C *** Default is whole frame.
C
      IF (IARR(14) .LE. MAX(IARR(12), 0)) THEN
         IARR(12) = 1
         IARR(14) = NX
      ENDIF
      IF (IARR(15) .LE. MAX(IARR(13), 0)) THEN
         IARR(13) = 1
         IARR(15) = NY
      ENDIF
C
C *** Check if searched region overlaps with the frame.
C
      IF (IARR(12).GE.NX-IARR(19) .OR. IARR(13).GE.
     &             NY-IARR(19) .OR. IARR(14).LE.1+IARR(19)
     &             .OR. IARR(15).LE.1+IARR(19)) THEN
          OUTPUT = '*** FATAL: '//
     &             'Frame and searched region do not overlap'
          CALL STTPUT(OUTPUT, ISTAT)
      ENDIF
C
C *** Frame margins IARR(19)-pixels wide are not used.
C
      IARR(12) = MAX(IARR(12), IARR(19)+1)
      IARR(13) = MAX(IARR(13), IARR(19)+1)
      IARR(14) = MIN(IARR(14), NX-IARR(19))
      IARR(15) = MIN(IARR(15), NY-IARR(19))
C
C *** IARR(12) to IARR(15) give limits of searched region.
C *** Temporary objects can be detected in little larger
C *** region bounded by array ITOB.
C
      IHED = IARR(8)
      ITOB(1) = MAX( IARR(12)-IHED , IARR(19)+1 )
      ITOB(2) = MAX( IARR(13)-IHED , IARR(19)+1 )
      ITOB(3) = MIN( IARR(14)+IHED , NX-IARR(19) )
      ITOB(4) = MIN( IARR(15)+IHED , NY-IARR(19) )
C
C *** Data in still larger region is used. It is limited by array IXYU.
C
      IXYU(1) = MAX(ITOB(1)-IHED, 1)
      IXYU(2) = MAX(ITOB(2)-IHED, 1)
      IXYU(3) = MIN(ITOB(3)+IHED, NX)
      IXYU(4) = MIN(ITOB(4)+IHED, NY)
C
C *** Allocate memory for line pointers array.
C
      JSIZE = 4 * NY
      CALL TDMGET(JSIZE, JPNTR, ISTAT)
C
C *** Allocate memory for two dimensional p.s.f.
C
      LPXL  = IARR(20)
      LSBP  = IARR(21)
      KSIZE = 4 * ( (7+NOSP) * (2*LPXL+1)**2 + 1) * (2*LSBP+1)**2
      CALL TDMGET(KSIZE, KPNTR, ISTAT)
      LSIZE = 4 * ( (2*LSBP+1)**2 + NOSP + 1 )
      CALL TDMGET(LSIZE, LPNTR, ISTAT)
C
C *** Open input table.
C
      CALL TBTOPN(INTABL,F_I_MODE,ITF,ISTAT)
C
C *** Read number of input table rows NROWI and columns NCOLI.
C
      CALL TBIGET(ITF, NCOLI, NROWI, NSC, IACOL, IAROW, ISTAT)
C
C *** Find columns X and Y and read them into array NCAT.
C
      CALL TBLSER(ITF, COLX, ICOL(1), ISTAT)
      IF (ICOL(1) .LE. 0 .OR. ISTAT .NE. 0) THEN
         OUTPUT = '*** FATAL: The column label X is not present.'
         CALL STTPUT(OUTPUT, ISTAT)
         CALL STSEPI
      ELSE
         CALL TBCMAP(ITF, ICOL(1), ICOLP, ISTAT)
         CALL TBLAI(MADRID(ICOLP), NROWI, START(1), STEP(1),
     &              NCAT, NIPAR, 1)
         CALL TBLAR(MADRID(ICOLP), NROWI, START(1), STEP(1),
     &              PMTR, NRPAR, 10)
      ENDIF
C
      CALL TBLSER(ITF, COLY, ICOL(2), ISTAT)
      IF (ICOL(2) .LE. 0 .OR. ISTAT .NE. 0) THEN
         OUTPUT = '*** FATAL: The column label Y is not present'
         CALL STTPUT(OUTPUT, ISTAT)
         CALL STSEPI
      ELSE
         CALL TBCMAP(ITF, ICOL(2), ICOLP, ISTAT)
         CALL TBLAI(MADRID(ICOLP), NROWI, START(2), STEP(2),
     &              NCAT, NIPAR, 2)
         CALL TBLAR(MADRID(ICOLP), NROWI, START(2), STEP(2),
     &              PMTR, NRPAR, 11)
      ENDIF
C
C *** Find column RAD_ISO if IARR(5) = 1.
C
      IF (IARR(5) .EQ. 1) THEN
         CALL TBLSER(ITF, COLISO, ICOL(5), ISTAT)
         IF (ICOL(5) .LE. 0 .OR. ISTAT .NE. 0) THEN
            OUTPUT = '*** WARNING: '//
     2               'The column label RAD_ISO is not present'
            CALL STTPUT(OUTPUT, ISTAT)
            ICOL(5) = 0
         ELSE
         CALL TBCMAP(ITF, ICOL(5), ICOLP, ISTAT)
         CALL TBLAR(MADRID(ICOLP), NROWI, DBLONE, DBLONE, PMTR,
     &              NRPAR, 5)
         ENDIF
      ELSE
         ICOL(5) = 0
      ENDIF
C
C *** Find columns LOC_BGD and AVER_9.
C
      CALL TBLSER(ITF, COLBGD, ICOL(3), ISTAT)
      IF (ICOL(3) .LE. 0 .OR. ISTAT .NE. 0) THEN
         ICOL(3) = 0
      ELSE
         CALL TBCMAP(ITF, ICOL(3), ICOLP, ISTAT)
         CALL TBLAR(MADRID(ICOLP), NROWI, DBLONE, DBLONE, PMTR,
     &              NRPAR, 1)
      ENDIF
      CALL TBLSER(ITF, COLAV9, ICOL(4), ISTAT)
      IF (ICOL(4) .LE. 0 .OR. ISTAT .NE. 0) THEN
         ICOL(4) = 0
      ELSE
         CALL TBCMAP(ITF, ICOL(4), ICOLP, ISTAT)
         CALL TBLAR(MADRID(ICOLP), NROWI, DBLONE, DBLONE, PMTR,
     &              NRPAR, 2)
      ENDIF
C
C ***  Find column ID or create its values if absent.
C
C      CALL TXLSER(INTABL,COLID,ICOL(6),ISTAT)
C      IF (ICOL(6).LE.0) THEN
C          DO 10 L = 1,NROWI
C              IDCAT(L) = L
C   10     CONTINUE
C      ELSE
C          CALL TXCMAP(INTABL,ICOL(6),ICOLP,ISTAT)
C          CALL TBLAI(MADRID(ICOLP),NROWI,DBLONE,DBLONE,IDCAT,1,1)
C      END IF
C
C ***  Perform calculations.
C
      CALL CALCUL(IMF, MADRID(IPNTR), MADRID(JPNTR), NX, NY,
     &            ITOB, IXYU, IARR, RARR, ICOL, NROWI, NCAT,
     &            PMTR, PRCT, MADRID(KPNTR), MADRID(LPNTR), OUTPSF)
C
C *** Free resources.
C
      CALL TDMFRE(LSIZE, LPNTR, ISTAT)
      CALL TDMFRE(KSIZE, KPNTR, ISTAT)
      CALL TDMFRE(JSIZE, JPNTR, ISTAT)
      CALL TBTCLO(ITF, ISTAT)
C
      CALL STSEPI
      END
C
C **********************************************************************
C
      SUBROUTINE TBLAI(ARR, N, START, STEP, NARR, NCOL, ICOL)
C
      IMPLICIT  NONE
C
      REAL       ARR(1)
      INTEGER    N
      INTEGER    NCOL
      DOUBLE PRECISION START
      DOUBLE PRECISION STEP
      INTEGER    NARR(NCOL,N)
      INTEGER    ICOL
C
      INTEGER   L
      DOUBLE PRECISION FCTR
C
      IF (START .EQ. 1.0 .AND. STEP .EQ. 1.0) THEN
         DO 10 L = 1, N
            NARR(ICOL,L) = NINT(ARR(L))
   10    CONTINUE
      ELSE
         FCTR = 1.0 / STEP
         DO 20 L = 1, N
           NARR(ICOL,L) = NINT((ARR(L) - REAL(START))*FCTR) + 1
   20    CONTINUE
      ENDIF
C
      RETURN
      END
C
C **********************************************************************
C
      SUBROUTINE TBLAR(ARR, N, START, STEP, AARR, NCOL, ICOL)
C
      IMPLICIT       NONE
      INTEGER        N
      INTEGER        NCOL
      REAL           ARR(1)
      DOUBLE PRECISION  START
      DOUBLE PRECISION  STEP
      REAL           AARR(NCOL,N)
      INTEGER        ICOL
C
      INTEGER        L
      REAL           FCTR
C
      IF (START .EQ. 1.0 .AND. STEP .EQ. 1.0) THEN
         DO 10 L = 1, N
            AARR(ICOL,L) = ARR(L)
   10    CONTINUE
      ELSE
         FCTR = 1.0 / REAL(STEP)
         DO 20 L = 1, N
            AARR(ICOL,L) = (ARR(L) - REAL(START))*FCTR + 1.0
   20    CONTINUE
      ENDIF
C
      RETURN
      END

C @(#)testf.for	19.1 (ES0-DMD) 02/25/03 13:52:16
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C @(#)testf.for	19.1 (ESO) 02/25/03 13:52:16
      PROGRAM TESTF
C
C.IDENT: TESTF
C.PURPOSE: To test if variables in subroutines are kept or
C          reinitialized
C.USE    : testf.exe
C
      INTEGER IIN
      INTEGER IOUT
C
      IIN = 0
      CALL INIT(IIN,IOUT)
      IIN = 1      
      CALL INIT(IIN,IOUT)
C      STOP
      END
C
C
C
C
      SUBROUTINE INIT(IN,KINIT)
C 
      INTEGER      IN
      INTEGER      IINIT
      INTEGER      KINIT
      INTEGER      JINIT
      DATA         JINIT/12345/
 210  FORMAT('SAVE')
 220  FORMAT('NOSAVE')
C
      IF (IN.EQ.0) THEN
C        WRITE (6,100) 
        IINIT = JINIT
        KINIT = -1

      ELSE
        IF (IINIT.EQ.JINIT) THEN
           WRITE (6,210)
           KINIT = 0
        ELSE
           WRITE (6,220) 
           KINIT = 1
        ENDIF
      ENDIF

      RETURN
      END

C @(#)outdim.for	19.1 (ES0-DMD) 02/25/03 13:30:47
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE OUTDIM(START,STEP,NPIX,CX,CY,OUTSTA,OUTPIX)
C +++
C.PURPOSE: Determine starting coordinates and stepsizes of output frame
C ---
      DOUBLE PRECISION START(2)
      DOUBLE PRECISION STEP(2)
      INTEGER  NPIX(2)
      DOUBLE PRECISION CX(20)
      DOUBLE PRECISION CY(20)
      REAL     OUTSTA(2)
      INTEGER  OUTPIX(2)
C
      INTEGER  I
      REAL     END(2)
      REAL     OUTEND(2)
      REAL     CORNER(4,2)
      REAL     OUTXMN,OUTXMX,OUTYMN,OUTYMX
      DOUBLE PRECISION X,Y
      DOUBLE PRECISION OUTX,OUTY
C
      DATA     OUTXMN/1.E8/
      DATA     OUTXMX/-1.E8/
      DATA     OUTYMN/1.E8/
      DATA     OUTYMX/-1.E8/

C
      DO 10 I = 1,2
         END(I) = START(I) + (NPIX(I)-1)*STEP(I)
   10 CONTINUE
C
C *** For the type of distortions caused by most image tubes, the space
C     needed for the output frame can be rather safely determined
C     from the four corners of the input frame. these are:
C
      CORNER(1,1) = START(1)
      CORNER(1,2) = START(2)
      CORNER(2,1) = START(1)
      CORNER(2,2) = END(2)
      CORNER(3,1) = END(1)
      CORNER(3,2) = START(2)
      CORNER(4,1) = END(1)
      CORNER(4,2) = END(2)
C
C *** image corners to output space
C
      DO 20 I = 1,4
          X      = CORNER(I,1)
          Y      = CORNER(I,2)
          OUTX   = CX(1) + X * (CX(2)+X  * (CX(3)+X*CX(4))) +
     +             (CX(5)+X  * (CX(6)+X  * (CX(7)+X*CX(8))))*Y +
     +             (CX(9)+X  * (CX(10)+X * (CX(11)+X*CX(12))))*Y*Y +
     +             (CX(13)+X * (CX(14)+X * (CX(15)+X*CX(16))))*Y*Y*Y
          OUTY   = CY(1) + X * (CY(2)+X  * (CY(3)+X*CY(4))) +
     +             (CY(5)+X  * (CY(6)+X  * (CY(7)+X*CY(8))))*Y +
     +             (CY(9)+X  * (CY(10)+X * (CY(11)+X*CY(12))))*Y*Y +
     +             (CY(13)+X * (CY(14)+X * (CY(15)+X*CY(16))))*Y*Y*Y
          IF (OUTX.GT.OUTXMX) OUTXMX = OUTX
          IF (OUTX.LT.OUTXMN) OUTXMN = OUTX
          IF (OUTY.GT.OUTYMX) OUTYMX = OUTY
          IF (OUTY.LT.OUTYMN) OUTYMN = OUTY
   20 CONTINUE
C
C *** Deduce maximal dimensions of output frame
C
      OUTSTA(1) = OUTXMN - 5*STEP(1)                             ! safety margin
      OUTSTA(2) = OUTYMN - 5*STEP(2)                             ! safety margin
      OUTEND(1) = OUTXMX + 5*STEP(1)                             ! safety margin
      OUTEND(2) = OUTYMX + 5*STEP(1)
C
      DO 30 I = 1,2
         OUTPIX(I) = (OUTEND(I)-OUTSTA(I))/STEP(I) + 1
   30 CONTINUE
C
      RETURN
      END

C @(#)gridtab.for	19.1 (ES0-DMD) 02/25/03 13:31:23
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT:    Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C.IDENTIFICATION: GRIDTAB
C.PURPOSE:      Produce 2-D coordinate frame with rectangular grid subjected
C               to "S-type" distortion (output to TABLE)
C.LANGUAGE:     F77+ESOext
C.AUTHOR:       D.BAADE
C.KEYWORDS:     Ingeneering frames
C.ALGORITHM:    trivial
C.PECULARITIES: The size of the coordinate frame is fixed to 510 by 510 pixels
C               as is the separation of the lines of the undistorted grid to 
C               60 pixels
C.INPUT/OUTPUT: The following key words are used:
C               ALPHA/R/1/1  angle ALPHA0 of the distortion in the following
C                            parametrizion  ALPHA = ALPHA0 * R**2, with R 
C                            being the distance from the point about which
C                            the rotation takes place. ALPHA0 to be given 
C                            in degrees/pixel.
C.VERSION:      850322  Creation                D. Baade, ST-ECF
C.VERSION:      850820  ???                     K. Banse
C.VERSION:      871123  ESO-FORTRAN Conversion, Rein H. Warmels
C --------------------------------------------------------------------
      PROGRAM GRDTAB
C
      IMPLICIT  NONE

      INTEGER   MADRID
      INTEGER   IAV,I,J
      INTEGER   NSEP
      REAL      X,Y,XD,YD,ALPHA,ALPHA0,RSQUAR,XORIG,YORIG,DATA(4)
      INTEGER   ISTAT,COLUMN(4),IROW
      INTEGER   TIDO,NCOL,NROW
      INTEGER   KUN,KNUL
      CHARACTER TBOUT*64,FORM*4
C
      INCLUDE   'MID_INCLUDE:ST_DEF.INC'
      COMMON    /VMR/MADRID(1)
      INCLUDE   'MID_INCLUDE:ST_DAT.INC'
C
      DATA      NSEP/60/
      DATA      COLUMN/1,2,3,4/    
      DATA      XORIG/100./
      DATA      YORIG/255./
      DATA      TBOUT/'GRID'/
      DATA      FORM/'F8.3'/
      DATA      NCOL/4/
      DATA      NROW/81/
C
C *** begin code
      CALL STSPRO('GRIDTAB')                        ! get into midas environment
C
      CALL STKRDR('ALPHA',1,1,IAV,ALPHA0,KUN,KNUL,ISTAT)  ! get distortion angle
      ALPHA0 = ALPHA0*3.14159/180.                        ! convert to radians
      CALL TBTINI(TBOUT,0,F_O_MODE,NCOL,NROW,TIDO,ISTAT)  ! output table (new)
C
C *** define columns
      CALL TBCINI(TIDO,D_R4_FORMAT,1,FORM,'PIXELS','X_RECTANGULAR',
     2            COLUMN(1),ISTAT)
      CALL TBCINI(TIDO,D_R4_FORMAT,1,FORM,'PIXELS','Y_RECTANGULAR',
     2            COLUMN(2),ISTAT)
      CALL TBCINI(TIDO,D_R4_FORMAT,1,FORM,'PIXELS','X_ACTUAL',
     2            COLUMN(3),ISTAT)
      CALL TBCINI(TIDO,D_R4_FORMAT,1,FORM,'PIXELS','Y_ACTUAL',
     2            COLUMN(4),ISTAT)
C
C ... The following command sequence creates 'reseau marks' in a
C ... regularly spaced rectangular grid. using the simple
C ... parametrization:
C ...                    ALPHA = ALPHA0 * R**2
C ... With R being the distance from the origin about which the
C ... rotation takes place, this first grid is distorted into a
C ... second one. Output of x,y_rectangular is to columns #1 and #2
C ... of table 'GRID.TBL'. Columns #3 and #4 receive x,y_actual.
      IROW   = 0
      DO 20 I = 1,9
         X = (I-1)*NSEP + 15. - XORIG
         DO 10 J = 1,9
            IROW    = IROW + 1
            Y       = (J-1)*NSEP + 15. - YORIG
            RSQUAR  = X**2 + Y**2
            ALPHA   = RSQUAR*ALPHA0
            XD      = X*COS(ALPHA) - Y*SIN(ALPHA) + XORIG
            YD      = X*SIN(ALPHA) + Y*COS(ALPHA) + YORIG
            DATA(1) = X + XORIG
            DATA(2) = Y + YORIG
            DATA(3) = XD
            DATA(4) = YD
            CALL TBRWRR(TIDO,IROW,4,COLUMN,DATA,ISTAT)
   10     CONTINUE
   20 CONTINUE
C
C *** release files and update keywords
      CALL TBTCLO(TIDO,ISTAT)
      CALL STSEPI
      END

C @(#)dummy.for	19.1 (ES0-DMD) 02/25/03 13:24:20
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE LFIT(X,Y,W,N,MODE,A,SA,B,SB,R)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C   SUBROUTINE  LFIT                VER. 1.0                MAY  17, 1986
C   P.GROSBOL                       ESO/GARCHING
C
C.PURPOSE
C   FIT A STRAIGHT LINE TO A SET OF DATA.
C   ALGORITHM IS TAKEN FROM BEVINGTON 'LINFIT' ROUTINE
C
C.INPUT/OUTPUT
C   THE PARAMETERS ARE
C       X(N)    :  ARRAY WITH INDEPENDENT VARIABLE
C       Y(N)    :  ARRAY WITH DEPENDENT VARIABLE
C       W(I)    :  ARRAY WITH WEIGHTS
C       N       :  NO. OF DATA SETS
C       MODE    :  MODE IS 0:NO WEIGHTS, 1: USE WEIGHTS
C       A       :  CONSTANT IN   Y = A + B*X
C       SA      :  SIGMA FOR A
C       B       :  SLOPE IN EQUATION :  Y = A + B*X
C       SB      :  SIGMA FOR B
C       R       :  REGRESSION COEFFICIENT
C
C-------------------------------------------------------------------------
      IMPLICIT NONE
C
      INTEGER  N
      REAL     X(N)
      REAL     Y(N)
      REAL     W(N)
      INTEGER  MODE
      REAL     A
      REAL     SA
      REAL     B
      REAL     SB
      REAL     R
C
      INTEGER  I
      REAL     CN
      REAL     DEL
      REAL     S,SX,SY,SXX,SXY,SYY,XX,YY
      REAL     WW,VAR
C
C     ACCUMULATE SUMS
C
      S   = 0.0
      SX  = 0.0
      SY  = 0.0
      SXX = 0.0
      SXY = 0.0
      SYY = 0.0
      DO 100, I = 1,N
         XX = X(I)
         YY = Y(I)
         IF (MODE.EQ.0) THEN
            WW = 1.0
         ELSE
            WW = W(I)
         ENDIF
         S   = S   + WW
         SX  = SX  + WW*XX
         SY  = SY  + WW*YY
         SXX = SXX + WW*XX*XX
         SXY = SXY + WW*XX*YY
         SYY = SYY + WW*YY*YY
  100 CONTINUE
C
C     COMPUTE COEFFICIENTS
C
      DEL = S*SXX - SX*SX
      A   = (SXX*SY - SX*SXY) / DEL
      B   = (SXY*S  - SX*SY) / DEL
      IF (MODE.EQ.0) THEN
         CN  = N - 2
         VAR = (SYY+A*A*S+B*B*SXX-2.0*(A*SY+B*SXY+A*B*SXX))/CN
      ELSE
         VAR = 1.0
      ENDIF
      SA  = SQRT( VAR*SXX/DEL )
      SB  = SQRT( VAR*S/DEL )
      R   = (S*SXY - SX*SY) / SQRT(DEL*(S*SYY-SY*SY))
      RETURN
      END

C @(#)spec.for	19.1 (ES0-DMD) 02/25/03 14:29:03
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT:      Copyright (c) 1987 European Southern Observatory,
C                            all rights reserved
C.IDENTIFICATION: SPEC
C.PURPOSE:        Interactive line routines
C.LANGUAGE:       F77+ESOext
C.AUTHOR:         J.D.Ponz
C.KEYWORDS:       Line, centre
C.ALGORITHM:      Line center is found by:
C                 maximum/minimum - position of the maximum/minimum value
C                 gaussian        - center of the fitted gaussian
C                 gravity         - gravity center of the 2 highest pixels
C                                   with respect to the third one
C-----------------------------------------------------------------
      SUBROUTINE FIND(X,N1,N2,XSTR,XSTP,NL,IPL1,IPL2,IMODE,IMETH,
     +                XCENTR,PEAK,IFAIL,W1,W2,ACOE,Y1,Y2)
C
C INTERMEDIATE ROUTINE
C FIND CENTER
C
      IMPLICIT NONE
      INTEGER   N1,N2,NL,IPL1,IPL2,IMODE,IMETH,IFAIL,NPIX
      REAL      XSTR,XSTP,XCENTR,PEAK,CHICHK,XGO
      REAL X(N1,N2),W1(1),W2(1),ACOE(4),Y1,Y2
C
      CHICHK = 0.005
      XGO    = XSTR + (IPL1-1)*XSTP
      NPIX   = IPL2 - IPL1 + 1
      Y1     = X(IPL1,NL)
      Y2     = X(IPL2,NL)
      IF (IMETH) 10,20,30
C
C  GAUSSIAN CENTER
C
   10 CALL SGAUS(X(IPL1,NL),W1,W2,IMODE,NPIX,IFAIL,XGO,XSTP,XCENTR,
     +           CHICHK,0,PEAK,ACOE)
      RETURN
C
C  GRAVITY
C
   20 CALL GRAVT(X(IPL1,NL),NPIX,IMODE,IFAIL,XGO,XSTP,XCENTR,PEAK)
      RETURN
C
C  MAXUMUM
C
C  30 CALL CNTRH(X(IPL1,NL),NPIX,IMODE,IFAIL,XGO,XSTP,XCENTR,PEAK) ! Min/Max
   30 CALL CNTRW(X(IPL1,NL),NPIX,IMODE,IFAIL,XGO,XSTP,XCENTR,PEAK) ! Moment
      RETURN
      END



      SUBROUTINE SFIND(X,XSTR,XSTP,IPL1,IPL2,IMODE,IMETH,
     +                XCENTR,PEAK,IFAIL,W1,W2,ACOE,Y1,Y2)
C++++
C. PURPOSE: Find center
C---
      IMPLICIT NONE
      REAL             X(1)
      DOUBLE PRECISION XSTR,XSTP
      INTEGER          IPL1,IPL2,IMODE,IMETH
      REAL             XCENTR,PEAK,CHICHK,XSP,XGO
      INTEGER          IFAIL,NPX
      REAL             W1(1),W2(1),ACOE(4),Y1,Y2
C
      CHICHK = 0.005
      XSP    = REAL(XSTP)
      XGO    = REAL(XSTR) + (IPL1-1)*XSP
      NPX    = IPL2 - IPL1 + 1
      Y1     = X(IPL1)
      Y2     = X(IPL2)
      IF (IMETH.LT.0) THEN                                     ! gaussian center
         CALL SGAUS(X(IPL1),W1,W2,IMODE,NPX,IFAIL,XGO,XSP,
     +              XCENTR,CHICHK,0,PEAK,ACOE)
      ELSE IF (IMETH.EQ.0) THEN
         CALL GRAVT(X(IPL1),NPX,IMODE,IFAIL,XGO,XSP,XCENTR,PEAK)
      ELSE
         CALL CNTRH(X(IPL1),NPX,IMODE,IFAIL,XGO,XSP,XCENTR,PEAK)
      ENDIF

      RETURN
      END

      SUBROUTINE GRAVT(WINDOW,NPIX,IWID,IWERR,XGO,DXSTP,XCNTR,AM)       
C                                                                              
C LINE CENTERING BY FINDING THE CENTER OF GRAVITY OF 2 HIGHEST                 
C POINTS OF 3 POINTS                                                           
C THE 2 HIGHEST POINTS HAVE VALUES RELATIVES TO THE THIRD                      
C ONLY APPLICABLE IN EMISSION MODE                                             
C PARAMETERS :                                                                 
C WINDOW BUFFER WITH EXPECTED LINE CENTER IN MIDDLE                            
C NPIX NUMBER OF SAMPLES IN WINDOW                                             
C IWID CODE 0 ABSORPTION, 1 EMISSION                                           
C IWERR  ERROR RETURN, 0 OK, 1 ERROR                                           
C XGO XCOORDINATE FIRST ELEMENT IN WINDOW                                      
C DXSTP STEP IN X                                                              
C XCNTR RETURN X CENTER CALCULATED                                             
C AM INTENSITY CENTER PIXEL                                                    
C                                                                              
      IMPLICIT NONE
C
      REAL     AM, WINDOW(1), AL, AH, DR
      INTEGER  NPIX, IWID, IWERR, I, K
C      modified MP 900119 , 
C      DOUBLE PRECISION XGO, DXSTP, XCNTR, A, B, XSHIFT
       REAL XGO, DXSTP, XCNTR, A, B, XSHIFT
C
      IF (IWID.NE.1) GO TO 20                                                  
C                                                                              
C FIND MAXIMUM                                                                 
C                                                                              
      AM     = WINDOW(1)                                                       
      I      = 1                                                               
      DO 10 K = 2,NPIX                                                         
          IF (WINDOW(K).GT.AM) THEN                                            
              AM     = WINDOW(K)                                               
              I      = K                                                       
          END IF                                                               
   10 CONTINUE                                                                 
C                                                                              
C CHECK NOT BOUNDARY                                                           
C                                                                              
      IF (I.EQ.1 .OR. I.EQ.NPIX) GO TO 20                                      
      XCNTR  = XGO + (I-1)*DXSTP                                               
C                                                                              
C FIND LOWEST OF THE FLANKING PIXELS                                           
C                                                                              
      AL     = WINDOW(I-1)                                                     
      AH     = WINDOW(I+1)                                                     
      DR     = 1.                                                              
      IF (AL.GE.AH) THEN                                                       
          AL     = WINDOW(I+1)                                                 
          AH     = WINDOW(I-1)                                                 
          DR     = -1.                                                         
      END IF                                                                   
      AM     = WINDOW(I)                                                       
      A      = AM - AL                                                         
      B      = AH - AL                                                         
      XSHIFT = (B/ (A+B))*DXSTP                                                
      XCNTR  = XCNTR + XSHIFT*DR                                               
      IWERR  = 0                                                               
      RETURN                                                                   
C                                                                              
C ERROR RETURN                                                                 
C                                                                              
   20 IWERR  = 1                                                               
      RETURN                                                                   
                                                                               
      END


      SUBROUTINE CNTRW (WINDOW,NPIX,IWID,IWERR,XGO,DXSTP,XCNTR,AM) 
C
C CENTER OF LINE ESTIMATED BY FIRST MOMENT OF THE VALUES
C                        
C PARAMETERS :                                                        
C WINDOW BUFFER WITH EXPECTED LINE CENTER IN MIDDLE 
C NPIX NUMBER OF SAMPLES IN WINDOW
C IWID CODE 0 ABSORPTION, 1 EMISSION
C IWERR  ERROR RETURN, 0 OK, 1 ERROR
C XGO XCOORDINATE FIRST ELEMENT IN WINDOW
C DXSTP STEP IN X 
C XCNTR RETURN X CENTER CALCULATED 
C AM INTENSITY CENTER PIXEL 
C
      IMPLICIT NONE
C
      REAL    WINDOW(1), AM
      INTEGER NPIX, IWID, IWERR
      REAL    XGO, DXSTP, XCNTR
C
      INTEGER IPN, I
      REAL    SUMY, SUMXY,XMOM
C
      IWERR  = 0 
      AM     = WINDOW(1)
      IPN    = 1         

      SUMY  = 0.
      SUMXY = 0.  
                                                     
      DO 10 I = 1,NPIX

         SUMXY = SUMXY + I*WINDOW(I)
         SUMY  = SUMY  + WINDOW(I)

10    CONTINUE

      XMOM = SUMXY / SUMY

C CHECK RESULT          
C                       
      IF (XMOM.LE.1 .OR. XMOM.GE.NPIX) GO TO 30 
      XCNTR  = XGO + (XMOM-1)*DXSTP             
      RETURN 
C
C ERROR RETURN 
C
   30 IWERR  = 1 
      RETURN 
      END 



      SUBROUTINE CNTRH(WINDOW,NPIX,IWID,IWERR,XGO,DXSTP,XCNTR,AM)              
C                                                                              
C CENTER OF LINE FOUND BY SIMPLE MAXIMUM WITHIN A WINDOW                       
C                                                                              
C PARAMETERS :                                                                 
C WINDOW BUFFER WITH EXPECTED LINE CENTER IN MIDDLE                            
C NPIX NUMBER OF SAMPLES IN WINDOW                                             
C IWID CODE 0 ABSORPTION, 1 EMISSION                                           
C IWERR  ERROR RETURN, 0 OK, 1 ERROR                                           
C XGO XCOORDINATE FIRST ELEMENT IN WINDOW                                      
C DXSTP STEP IN X                                                              
C XCNTR RETURN X CENTER CALCULATED                                             
C AM INTENSITY CENTER PIXEL                                                    
C                                                                              
      IMPLICIT NONE
C
      REAL    WINDOW(1), AM
      INTEGER NPIX, IWID, IWERR
      REAL    XGO, DXSTP, XCNTR
C
      INTEGER IPN, I
C
      IWERR  = 0                                                               
      AM     = WINDOW(1)                                                       
      IPN    = 1                                                               
      IF (IWID.NE.1) THEN                                                      
C                                                                              
C FIND MINIMUM                                                                 
C                                                                              
          DO 10 I = 2,NPIX                                                     
              IF (WINDOW(I).LT.AM) THEN                                        
                  AM     = WINDOW(I)                                           
                  IPN    = I                                                   
              END IF                                                           
   10     CONTINUE                                                             
      ELSE                                                                     
C                                                                              
C FIND MAXIMUM                                                                 
C                                                                              
          DO 20 I = 2,NPIX                                                     
              IF (WINDOW(I).GT.AM) THEN                                        
                  AM     = WINDOW(I)                                           
                  IPN    = I                                                   
              END IF                                                           
   20     CONTINUE                                                             
      END IF                                                                   
C                                                                              
C CHECK RESULT                                                                 
C                                                                              
      IF (IPN.EQ.1 .OR. IPN.EQ.NPIX) GO TO 30                                  
      XCNTR  = XGO + (IPN-1)*DXSTP                                             
      RETURN                                                                   
C                                                                              
C ERROR RETURN                                                                 
C                                                                              
   30 IWERR  = 1                                                               
      RETURN                                                                   
      END                                                                      
                                                                     

      SUBROUTINE SGAUS(WINDOW,XBUF,YFIT,IWID,NPIX,IWERR,XGO,DXSTP,
     2                 XCNTR,CHICHK,IOUTPT,AM,A)                              
C                                                                              
C LINE CENTER FINDING WITH GAUSSIAN FIT                                        
C                                                                              
C PARAMETERS :                                                                 
C WINDOW BUFFER WITH EXPECTED LINE CENTER IN MIDDLE                            
C XBUF WORK BUFFER                                                             
C YFIT WORK BUFFER                                                             
C IWID CODE 0 ABSORPTION, 1 EMISSION                                           
C NPIX NUMBER OF SAMPLES IN WINDOW                                             
C IWERR  ERROR RETURN, 0 OK, 1 ERROR                                           
C XGO XCOORDINATE FIRST ELEMENT IN WINDOW                                      
C DXSTP STEP IN X                                                              
C XCNTR RETURN X CENTER CALCULATED                                             
C CHICHK CHECK CHISQUARE                                                       
C IOUTPT DISPLAY INTERMEDIATE RESULTS 0 NO, 1 YES                              
C AM INTENSITY CENTER PIXEL                                                    
C A ARRAY(4) COEFFICIENTS                                                      
C                                                                              
      INTEGER I,K1,K2,NPIX,IWID,IWERR,IOUTPT
      INTEGER ITCNT,ITCHK,JER,IBRK
      REAL WINDOW(*),XBUF(*),YFIT(*),A(*)                                  
      REAL DELTAA(4),SIGMAA(4),XCNTR,XGO,CHICHK
      REAL DXSTP,CHISQR,FLAMDA,OLDCH,DIF,HALF,WIDTH                            
      REAL AM,X,STOP,TOPM
      CHARACTER*70 IHDD                                                        
      DATA IHDD/'  CHISQ      FWHM     CENTER'/                                
C                                                                              
C BUFFER WITH X VALUES                                                         
C                                                                              
      X      = XGO                                                             
      DO 10 I = 1,NPIX                                                         
          XBUF(I) = XGO + (I-1)*DXSTP                                          
   10 CONTINUE                                                                 
C                                                                              
C FIND INITIAL GUESS                                                           
C                                                                              
      CALL CNTRH(WINDOW,NPIX,IWID,IWERR,XGO,DXSTP,A(2),AM)                     
      IF (IWERR.NE.0) GO TO 120                                                
      A(4)   = (WINDOW(1)+WINDOW(NPIX))/2.                                     
      A(1)   = AM - A(4)                                                       
C                                                                              
C CALCULATE HALF WIDTH                                                         
C                                                                              
      HALF   = A(1)/2. + A(4)                                                  
C                                                                              
C CALCULATION OF FWHM DEPENDS ON SIGN OF THE LINE                              
C                                                                              
      IF (IWID.NE.1) THEN                                                      
          DO 20 I = 1,NPIX                                                     
              IF (WINDOW(I).LT.HALF) GO TO 30                                  
   20     CONTINUE                                                             
   30     K1     = I                                                           
          DO 40 I = K1,NPIX                                                    
              IF (WINDOW(I).GT.HALF) GO TO 50                                  
   40     CONTINUE                                                             
   50     K2     = I                                                           
                                                                               
      ELSE                                                                     
          DO 60 I = 1,NPIX                                                     
              IF (WINDOW(I).GT.HALF) GO TO 70                                  
   60     CONTINUE                                                             
   70     K1     = I                                                           
          DO 80 I = K1,NPIX                                                    
              IF (WINDOW(I).LT.HALF) GO TO 90                                  
   80     CONTINUE                                                             
   90     K2     = I                                                           
      END IF                                                                   
                                                                               
      WIDTH  = ABS(FLOAT(K2-K1)*DXSTP)                                         
      A(3)   = WIDTH/2.354                                                     
      OLDCH  = 9.E16                                                           
C                                                                              
C OPTIONAL OUTPUT                                                              
C                                                                              
C IF (IOUTPT .NE. 0) CALL WRUSER(0,IHDD,' ',' ',ISTAT)                         
C                                                                              
C CALL FITTING ROUTINE                                                         
C ITERATE 50 TIMES                                                             
C                                                                              
      ITCNT  = 0                                                               
      ITCHK  = 50                                                              
  100 FLAMDA = 0.001                                                           
      IBRK   = 0                                                               
C                                                                              
      CALL CURFI(XBUF,WINDOW,SIGMAA,NPIX,4,0,A,DELTAA,FLAMDA,YFIT,             
     +           CHISQR,JER)                                                   
      IF (JER.NE.0) GO TO 120                                                  
C                                                                              
C CALC AND DISPLAY INTERMEDIATE RESULTS                                        
C                                                                              
      IF (IBRK.EQ.-1) GO TO 110                                                
C IF (IOUTPT.NE.0) THEN                                                        
C     TYPE *,NPIX                                                              
C     WRITE(LABL, 100) CHISQR,A(3)*2.345,A(2)                                  
C     CALL STTPUT(LABL,ISTAT)                                                  
C ENDIF                                                                        
C                                                                              
C SEE IF CHISQR HAS CHANGED SIGNIFICANTLY                                      
C                                                                              
      DIF    = OLDCH - CHISQR                                                  
      STOP   = DIF/CHISQR                                                      
      OLDCH  = CHISQR                                                          
      ITCNT  = ITCNT + 1                                                       
      IF (ITCNT.GT.ITCHK) GO TO 120                                            
      IF (STOP.GT.CHICHK) GO TO 100                                            
  110 XCNTR  = A(2)                                                            
C                                                                              
C LAST CHECK THAT WE ARE WITHIN THE WINDOW                                     
C                                                                              
      TOPM   = XBUF(NPIX)                                                      
      IF (DXSTP.LT.0.) THEN                                                    
          IF ((XCNTR.GT.XGO) .OR. (XCNTR.LT.TOPM)) GO TO 120                   
                                                                               
      ELSE                                                                     
          IF ((XCNTR.LT.XGO) .OR. (XCNTR.GT.TOPM)) GO TO 120                   
      END IF                                                                   
                                                                               
      IWERR  = 0                                                               
      A(3)   = A(3)*2.345                                                      
      RETURN                                                                   
C                                                                              
C ERROR RETURN                                                                 
C                                                                              
  120 IWERR  = 1                                                               
      RETURN                                                                   
                                                                               
C9000 FORMAT (E10.3,E10.3,F9.3)                                                
      END                                                                      


      SUBROUTINE CURFI(X,Y,SIGMAY,NPTS,NTERMS,MODE,A,DELTAA,FLAMDA,YFIT,       
     +                 CHISQR,IERR)                                            
C                                                                              
C LEAST SQUARES FIT TO A NON-LINEAR FUNCTION                                   
C                                                                              
C PARAMETERS:                                                                  
C X ARRAY OF DATA POINTS IND. VAR.                                             
C Y ARRAY OF DATA POINTS DEP. VAR.                                             
C SIGMAY ARRAY OF STD DEV FOR Y DATA POINTS                                    
C NPTS NUMBER OF PAIRS OF DATA POINTS                                          
C MODE DETERMINES METHOD OF WEIGHTING LEAST-SQUARES FIT                        
C  +1 (INSTRUMENTAL) WEIGHT = 1./SIGMAY(I)**2                                  
C   0 (NO WEIGHTING) WEIGHT = 1.                                               
C  -1 (STATISTICAL ) WEIGHT = 1./Y(I)                                          
C A ARRAY OF PARAMETERS                                                        
C DELTAA ARRAY OF INCREMENTS FOR PARAMETERS A                                  
C SIGMAA ARRAY OF STANDARD DEVIATIONS FOR PARAMETERS A                         
C FLAMDA PROPORTION OF GRADIENT SEARCH INCLUDED                                
C YFIT ARRAY OF CALCULATED VALUES OF Y                                         
C CHISQR REDUCED CHI SQUARE FOR FIT                                            
C IERR ERROR RETURN 0 OK, 1 NOT CONVERGING                                     
C                                                                              
C DIMENSION STATEMENT VALID FOR NTERMS UP TO 10                                
C SET FLAMDA TO 0.001 AT THE BEGINNING OF THE SEARCH                           
C     
      INTEGER I,J,K,NPTS,NFREE ,NTERMS,IERR  
      INTEGER MODE ,ICNT                                  
      REAL X(*),Y(*),SIGMAY(*),DELTAA(*),YFIT(*)                           
      REAL A(*),DET,FLAMDA,CHISF,FUNCT                                         
      REAL WEIGHT(400),ALPHA(10,10),BETA(10)                               
      REAL DERIV(10),B(10),CHISQR ,CHISQ1                                   
      DOUBLE PRECISION ARRAY(10,10)
      EXTERNAL FUNCT
C                                                                              
      ICNT   = 0                                                               
      IERR   = 1                                                               
      NFREE  = NPTS - NTERMS                                                   
      IF (NFREE) 20,20,30                                                      
   20 CHISQR = 0.                                                              
      RETURN                                                                   
C                                                                              
C EVALUATE WEIGHTS                                                             
C                                                                              
   30 CONTINUE                                                                 
      IERR   = 0                                                               
      DO 100 I = 1,NPTS                                                        
          IF (MODE) 40,70,80                                                   
   40     IF (Y(I)) 60,70,50                                                   
   50     WEIGHT(I) = 1./Y(I)                                                  
          GO TO 90                                                             
                                                                               
   60     WEIGHT(I) = 1./ (-Y(I))                                              
          GO TO 90                                                             
                                                                               
   70     WEIGHT(I) = 1.                                                       
          GO TO 90                                                             
                                                                               
   80     WEIGHT(I) = 1./SIGMAY(I)**2                                          
   90     CONTINUE                                                             
  100 CONTINUE                                                                 
C                                                                              
C EVALUATE ALPHA AND BETA MATRICES                                             
C                                                                              
      DO 120 J = 1,NTERMS                                                      
          BETA(J) = 0.                                                         
          DO 110 K = 1,J                                                       
              ALPHA(J,K) = 0.                                                  
  110     CONTINUE                                                             
  120 CONTINUE                                                                 
      DO 150 I = 1,NPTS                                                        
          CALL FDERI(X,I,A,DELTAA,NTERMS,DERIV)                                
          DO 140 J = 1,NTERMS                                                  
              BETA(J) = BETA(J) + WEIGHT(I)* (Y(I)-FUNCT(X,I,A))*              
     +                  DERIV(J)                                               
              DO 130 K = 1,J                                                   
                  ALPHA(J,K) = ALPHA(J,K) + WEIGHT(I)*DERIV(J)*DERIV(K)        
  130         CONTINUE                                                         
  140     CONTINUE                                                             
  150 CONTINUE                                                                 
      DO 170 J = 1,NTERMS                                                      
          DO 160 K = 1,J                                                       
              ALPHA(K,J) = ALPHA(J,K)                                          
  160     CONTINUE                                                             
  170 CONTINUE                                                                 
C                                                                              
C EVALUATE CHI SQUARE AT STARTING POINT                                        
C                                                                              
      DO 180 I = 1,NPTS                                                        
          YFIT(I) = FUNCT(X,I,A)                                               
  180 CONTINUE                                                                 
      CHISQ1 = CHISF(Y,SIGMAY,NPTS,NFREE,MODE,YFIT)                            
C                                                                              
C INVERT MATRIX                                                                
C                                                                              
  190 DO 210 J = 1,NTERMS                                                      
          DO 200 K = 1,NTERMS                                                  
              IF (ABS(ALPHA(J,J)).LT.1.E-10.OR.
     .                  ABS(ALPHA(K,K)).LT.1.E-10) GOTO 987
              ARRAY(J,K) = ALPHA(J,K)/SQRT(ALPHA(J,J)*ALPHA(K,K))              
  200     CONTINUE                                                             
          ARRAY(J,J) = 1. + FLAMDA                                             
  210 CONTINUE                                                                 
      CALL INVMAT(ARRAY,NTERMS,DET)                                            
      DO 230 J = 1,NTERMS                                                      
          B(J)   = A(J)                                                        
          DO 220 K = 1,NTERMS                                                  
              B(J)   = B(J) + BETA(K)*ARRAY(J,K)/                              
     +                 SQRT(ALPHA(J,J)*ALPHA(K,K))                             
  220     CONTINUE                                                             
  230 CONTINUE                                                                 
C                                                                              
C IF CHI SQUARE INCREASED, INCREASE FLAMDA AND TRY AGAIN                       
C                                                                              
      DO 240 I = 1,NPTS                                                        
          YFIT(I) = FUNCT(X,I,B)                                               
  240 CONTINUE                                                                 
      CHISQR = CHISF(Y,SIGMAY,NPTS,NFREE,MODE,YFIT)                            
      IF (CHISQ1-CHISQR) 250,270,270                                           
C                                                                              
C CHECK LOOPS                                                                  
C                                                                              
  250 ICNT   = ICNT + 1                                                        
      IF (ICNT.LT.60) GO TO 260                                                
  987 IERR   = 1                                                               
      RETURN                                                                   
                                                                               
  260 FLAMDA = 10.*FLAMDA                                                      
      GO TO 190                                                                
C                                                                              
C EVALUATE PARAMETERS                                                          
C                                                                              
  270 DO 280 J = 1,NTERMS                                                      
          A(J)   = B(J)                                                        
  280 CONTINUE                                                                 
      FLAMDA = FLAMDA/10.                                                      
      RETURN                                                                   
                                                                               
      END                                                                      

      REAL FUNCTION FUNCT(X,I,A)
C
C EVALUATE TERMS OF FUNCTION FOR NON-LINEAR LEAST-SQUARES SEARCH
C WITH FORM OF GAUSSIAN PEAK
C
C PARAMETERS:
C X ARRAY OF DATA POINTS
C I INDEX OF DATA POINTS
C A ARRAY OF PARAMETERS
C
      REAL X(*),A(*),Z,XI,Z2
      INTEGER I
      XI     = X(I)
      FUNCT  = A(4)
      Z      = (XI-A(2))/A(3)
      Z2     = Z*Z
      IF (Z2-50.) 40,50,50
   40 FUNCT  = FUNCT + A(1)*EXP(-Z2*0.5)
   50 RETURN

      END

      FUNCTION CHISF(Y,SIGMAY,NPTS,NFREE,MODE,YFIT)
C
C EVALUATE REDUCED CHI SQUARE FOR FIT TO DATA
C CHISF = SUM((Y-YFIT)**2/SIGMA**2)/NFREE
C
C PARAMETERS:
C Y ARRAY OF DATA POINTS
C SIGMAY ARRAY OF STANDARD DEVIATIONS
C NPTS NUMBER OF DATA POINTS
C NFREE NUMBER OF DEGREES OF FREEDOM
C MODE DETERMINES METHOD OF WEIGHTING LEAST-SQUARES FIT
C  +1 (INSTRUMENTAL) WEIGHT = 1./SIGMAY(I)**2
C   0 (NO WEIGHTING) WEIGHT = 1.
C  -1 (STATISTICAL ) WEIGHT = 1./Y(I)
C YFIT ARRAY OF CALCULATED VALUES OF Y
C
      INTEGER NFREE,MODE,NPTS,I
      REAL Y(*),SIGMAY(*),YFIT(*),CHISF
      DOUBLE PRECISION CHISQ,WEIGHT
C
      CHISQ  = 0.
      IF (NFREE) 30,30,40
   30 CHISF  = 0.
      RETURN
C
C ACCUMULATE CHI SQUARE
C
   40 DO 110 I = 1,NPTS
          IF (MODE) 50,80,90
   50     IF (Y(I)) 70,80,60
   60     WEIGHT = 1./Y(I)
          GO TO 100

   70     WEIGHT = 1./ (-Y(I))
          GO TO 100

   80     WEIGHT = 1.
          GO TO 100

   90     WEIGHT = 1./SIGMAY(I)**2
  100     CHISQ  = CHISQ + WEIGHT* (Y(I)-YFIT(I))**2
  110 CONTINUE
C
C DIVIDE BY NUMBER OF DEGREES OF FREEDOM
C
      CHISF  = CHISQ/NFREE
      RETURN

      END


      SUBROUTINE FDERI(X,I,A,DELTAA,NTERMS,DERIV)                              
C                                                                              
C EVALUATES DERIVATIVES OF FUNCTION FOR LEAST SQUARES SEARCH                   
C WITH FORM OF GAUSSIAN PEAK                                                   
C                                                                              
C PARAMETERS:                                                                  
C X ARRAY OF DATA POINTS OF INDEPENDENT VARIABLE                               
C I INDEX OF DATA POINTS                                                       
C A ARRAY OF PARAMETERS                                                        
C DELTAA ARRAY OF PARAMETER INCREMENTS                                         
C NTERMS NUMBER OF PARAMETERS                                                  
C DERIV DERIVATIVES OF FUNCTION                                                
C                                                                              
      INTEGER I,J,NTERMS
      REAL X(*),A(*),DELTAA(*),DERIV(*)                                    
      REAL Z,Z2,XI
                                                                               
      XI     = X(I)                                                            
      Z      = (XI-A(2))/A(3)                                                  
      Z2     = Z*Z                                                             
      IF (Z2-50.) 40,20,20                                                     
   20 DO 30 J = 1,3                                                            
          DERIV(J) = 0.                                                        
   30 CONTINUE                                                                 
      GO TO 50                                                                 
C                                                                              
C ANALYTICAL EXPRESSION FOR DERIVATIVES                                        
C                                                                              
   40 DERIV(1) = EXP(-Z2/2.)                                                   
      DERIV(2) = A(1)*DERIV(1)*Z/A(3)                                          
      DERIV(3) = DERIV(2)*Z                                                    
   50 DERIV(4) = 1.                                                            
      RETURN                                                                   
                                                                               
      END                                                                      


      SUBROUTINE INVMAT(ARR,N,DET)
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  0:26 - 4 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: D.PONZ
C         INVERTS A SYMMETRIC MATRIX AND CALCULATES ITS DETERMINANT
C         USING A GAUSS-JORDAN ELIMINATION METHOD. THE DEGREE N OF
C         THE MATRIX MUST NOT BE GREATER THAN 10.
C         THE INVERSION IS IN DOUBLE PRECISION, AND
C         THE ARRAY ARR MUST BE D-P. THE DETERMINANT IS ALLWAYS REAL.
C
C   PARAMS :
C         ARR :  ARRAY CONTAINING THE (N*N) MATRIX TO BE INVERTED.
C                THE INVERTED MATRIX IS RETURNED IN ARR.
C         N   :  DEGREE OF MATRIX
C         DET :  DETERMINANT OF INPUT-MATRIX
C
C      IMPLICIT NONE
      REAL DET
      DOUBLE PRECISION ARR(10,10),AMAX,SAVE,DDET
      INTEGER IK(10),JK(10),I,J,K,N,L
C
      DET    = 1.0
      DDET   = 1.0D0
      DO 210 K = 1,N
          AMAX   = 0.0D0
C
C  FIND LARGEST ELEMENT ARR(I,J) IN REST OF MATRIX
C
   10     DO 40 I = K,N
              DO 30 J = K,N
                  IF (DABS(AMAX)-DABS(ARR(I,J))) 20,20,30
   20             AMAX   = ARR(I,J)
                  IK(K)  = I
                  JK(K)  = J
   30         CONTINUE
   40     CONTINUE
C  ----------------------------------------------------
C  INTERCHANGE ROWS AND COLUMNS TO PUT AMAX IN ARR(K,K)
C  ----------------------------------------------------
          IF (AMAX) 60,50,60
   50     DET    = 0.
          GO TO 280

   60     I      = IK(K)
          IF (I-K) 10,90,70
   70     DO 80 J = 1,N
              SAVE   = ARR(K,J)
              ARR(K,J) = ARR(I,J)
              ARR(I,J) = -SAVE
   80     CONTINUE
C
   90     J      = JK(K)
          IF (J-K) 10,120,100
  100     DO 110 I = 1,N
              SAVE   = ARR(I,K)
              ARR(I,K) = ARR(I,J)
              ARR(I,J) = -SAVE
  110     CONTINUE
C  -------------------------------------
C  ACCUMULATE ELEMENTS OF INVERSE MATRIX
C  -------------------------------------
  120     DO 140 I = 1,N
              IF (I-K) 130,140,130
  130         ARR(I,K) = -ARR(I,K)/AMAX
  140     CONTINUE
C
          DO 180 I = 1,N
              DO 170 J = 1,N
                  IF (I-K) 150,170,150
  150             IF (J-K) 160,170,160
  160             ARR(I,J) = ARR(I,J) + ARR(I,K)*ARR(K,J)
  170         CONTINUE
  180     CONTINUE
C
          DO 200 J = 1,N
              IF (J-K) 190,200,190
  190         ARR(K,J) = ARR(K,J)/AMAX
  200     CONTINUE
          ARR(K,K) = 1.0/AMAX
          DET    = DET*AMAX
          DDET   = DDET*AMAX
C
  210 CONTINUE
C  --------------------------
C  RESTORE ORDERING OF MATRIX
C  --------------------------
      DO 270 L = 1,N
          K      = N - L + 1
          J      = IK(K)
          IF (J-K) 240,240,220
  220     DO 230 I = 1,N
              SAVE   = ARR(I,K)
              ARR(I,K) = -ARR(I,J)
              ARR(I,J) = SAVE
  230     CONTINUE
C
  240     I      = JK(K)
          IF (I-K) 270,270,250
  250     DO 260 J = 1,N
              SAVE   = ARR(K,J)
              ARR(K,J) = -ARR(I,J)
              ARR(I,J) = SAVE
  260     CONTINUE
C
  270 CONTINUE
      DET    = DDET
      RETURN
C  -------------------
C  DETERMINANT IS ZERO
C  -------------------
  280 DET    = 0.0
      RETURN
      END

C @(#)tdlist.for	19.1 (ES0-DMD) 02/25/03 14:11:18
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:40 - 11 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C  900219  KB, throw out SX calls
C
C
C.IDENTIFICATION        TDLIST.FOR
C.KEYWORDS           TABLE, APPLICATIONS
C.ENVIRONMENT  MIDAS
C.PURPOSE
C  LIST TABLE WITH EXTERNAL FORMAT FILE
C
C------------------------------------------------------------------
      SUBROUTINE TDLIST(TABLE,FILE,NCHAN,FFORMT,NCOL,ICOL,IRANGE,
     +                  STATUS)
      IMPLICIT NONE
      INTEGER TABLE         !   IN : table ident
      CHARACTER*(*) FILE    !   IN : output file
      INTEGER NCHAN         !   IN : output channel
      CHARACTER*(*) FFORMT  !   IN : format file
      INTEGER NCOL          !   IN : number of columns
      INTEGER ICOL(NCOL)    !   IN : column indices
      INTEGER IRANGE(2)     !   IN : range of rows
      INTEGER STATUS        !  OUT : STATUS
C
      INTEGER LIMIT
      PARAMETER (LIMIT=256)
      INTEGER        ISTAT,ERNORM,I,J,J1
      LOGICAL        ITERM,SELECT,NULL(LIMIT)
      CHARACTER*4096 LINE
      CHARACTER*80   ERRMSG
C
       INCLUDE 'MID_INCLUDE:TABLES.INC/NOLIST'
       INCLUDE 'MID_INCLUDE:TABLEF.INC/NOLIST'
       INCLUDE 'MID_INCLUDE:TABLED.INC/NOLIST'
C
      DATA ERRMSG/' *** format conversion error ***'/
C
C ... READ FORMAT
C
      ERNORM = 0
      CALL TDFFRM(FFORMT,STATUS)
      IF (STATUS.NE.ERNORM) THEN
          CALL STTPUT('Error in format definition file ...',ISTAT)
          RETURN
      END IF
C
C ... MODIFY FORMAT IF NEEDED
C
      CALL TDFMOD(TABLE,NCOL,ICOL,STATUS)
C
C ... LIST TABLE
C
      ITERM  = FILE(1:4) .EQ. 'TTY:'
      DO 10 I = IRANGE(1),IRANGE(2)
          CALL TBSGET(TABLE,I,SELECT,STATUS)
          IF (SELECT) THEN
              CALL TBRRDC(TABLE,I,NCOL,ICOL,LINE,NULL,STATUS)
              IF (STATUS.NE.ERNORM) CALL STTPUT(ERRMSG,STATUS)
              DO 15 J = 1, NCOL
                 J1 = FMFIRS(J)
                 IF (NULL(J)) LINE(J1:J1) = '*'
15            CONTINUE
              IF (ITERM) THEN
                  CALL STTPUT(LINE(1:FMLLEN),STATUS)
              ELSE
                  WRITE (NCHAN,9000) LINE(1:FMLLEN)
              END IF
          END IF
   10 CONTINUE
      RETURN
 9000 FORMAT (A)
      END

C @(#)raddet.for	19.1 (ESO-DMD) 02/25/03 13:25:38
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  Subroutine RADDET          version 1.0          870626
C  A. Kruszewski              ESO Garching
C.PURPOSE
C  Find active radius of detected object.
C.ALGORYTHM
C  Goes out from the object center in four directions looking when
C  intensity drop down below detection threshold. Active radius is
C  adopted as the second least distant drop-down point.
C.INPUT/OUTPUT
C  Input parameters
C  B_A       real*4 array          image data array
C  B_N       integer*4             number of elements in data array
C  B_PY      integer*4 array       line pointers
C  B_NYA     integer*4             number of active lines
C  A_NX      integer*4             number of line elements
C  A_YP      integer*4             offset of first active line
C  I         integer*4             x-coordinate
C  J         integer*4             y-coordinate
C  MINCR     integer*4             controls faint components
C  TRLM      real*4                detection threshold
C  Output parameters
C  AR        real*4                active radius
C 
C.Versions
C 
C 010118		last modif
C 
C-----------------------------------------------------------------------
      SUBROUTINE RADDET(A, JAPY, IBUF, I, J,
     &                  MINCR, TRLM, AVER, TRSH, AR) 
C
      IMPLICIT  NONE
C
      REAL      A(1)                    ! IN:  Image buffer
      INTEGER   JAPY(1)                 ! IN:  Pointers to image lines
      INTEGER   IBUF(4)                 ! IN:  Limits of image buffer
      INTEGER   I                       ! IN:  Object x-coordinate
      INTEGER   J                       ! IN:  Object y-coordinate
      INTEGER   MINCR                   ! IN:  Faint component control
      REAL      TRLM                    ! IN:  Detection level
      REAL      AVER                    ! IN:  9 pixels average
      REAL      TRSH                    ! IN:  Detection threshold
      REAL      AR                      ! OUT: Active radius
C
      INTEGER   ISTEP , IX
      INTEGER   JOF , JOFF , JY
      INTEGER   L
      INTEGER   MINCR2
      INTEGER   NX1 , NX2 , NY1 , NY2
C
      REAL   AC1 , AC2 , AC3
      REAL   CORR , DDR(8) , FCNTR
      REAL   SR2 , TEMP , TMPMX
C
      LOGICAL   UP , SKIP
C
      SR2 = SQRT(2.0)
      MINCR2 = NINT( FLOAT(MINCR) / SQRT(2.0) )
      MINCR2 = (MINCR+MINCR2) / 2
      NX2 = IBUF(3)
C 
      AC1 = 0.0				! was NOT initialized before...
      AC2 = 0.0
      Ac3 = 0.0
C
C *** JOF is the adrress of the start of central pixel line.
C
      JOFF = IBUF(2) - 1
      JOF = JAPY(J-JOFF)
C
C *** TEMP is a current pixel value.
C
      TEMP = A(JOF+I)
C
C *** FCNTR is the central pixel value.
C
      FCNTR = TEMP + 0.01 * TRSH
      IX = I + 1
      ISTEP = 0
      TMPMX = FCNTR
      UP = .TRUE.
      SKIP = .FALSE.
   10 CONTINUE
          IF ( TEMP .LT. TRLM .OR. IX .GE. NX2 ) GOTO 20
          IX = IX + 1
          TEMP = A(JOF+IX)
          IF ( UP .AND. IX-I .LE. MINCR .AND. TEMP .GE. TMPMX ) THEN
              TMPMX = TEMP
              ISTEP = ISTEP + 1
              SKIP = .FALSE.
          ELSE IF ( ( .NOT. SKIP ) .AND. TEMP .GT. TRLM .AND.
     &                                  TEMP .GE. TMPMX-TRSH ) THEN
              SKIP = .TRUE.
          ELSE
              UP = .FALSE.
          ENDIF
          GOTO 10
   20 CONTINUE
      CORR = A(JOF+IX-1) - TEMP
      IF ( CORR .GT. 0.0 ) THEN
          CORR = (TRLM-TEMP) / CORR
          IF ( CORR .LT. 0.0 ) THEN
              CORR = 0.0
          ELSE IF ( CORR .GT. 1.0 ) THEN
              CORR = 1.0
          ENDIF
      ELSE
          CORR = -1.0
      ENDIF
      DDR(1) = FLOAT(IX-I) - CORR
C
      TEMP = FCNTR
      IX = I - 1
      TMPMX = FCNTR
      NX1 = IBUF(1)
      UP = .TRUE.
      SKIP = .FALSE.
   30 CONTINUE
          IF ( TEMP .LT. TRLM .OR. IX .LE. NX1 ) GOTO 40
          IX = IX - 1
          TEMP = A(JOF+IX)
          IF ( UP .AND. I-IX .LE. MINCR .AND. TEMP .GE. TMPMX ) THEN
              TMPMX = TEMP
              ISTEP = ISTEP + 1
              SKIP = .FALSE.
          ELSE IF ( ( .NOT. SKIP ) .AND. TEMP .GE. TMPMX-TRSH
     &                           .AND. TEMP .GT. TRLM ) THEN
              SKIP = .TRUE.
          ELSE
              UP = .FALSE.
          ENDIF
          GOTO 30
   40 CONTINUE
      CORR = A(JOF+IX+1) - TEMP
      IF ( CORR .GT. 0.0 ) THEN
          CORR = (TRLM-TEMP) / CORR
          IF ( CORR .LT. 0.0 ) THEN
              CORR = 0.0
          ELSE IF ( CORR .GT. 1.0 ) THEN
              CORR = 1.0
          ENDIF
      ELSE
          CORR = -1.0
      ENDIF
      DDR(2) = FLOAT(I-IX) - CORR
C
      TEMP = FCNTR
      TMPMX = FCNTR
      NY2 = IBUF(4)
      JY = J + 1
      UP = .TRUE.
      SKIP = .FALSE.
   50 CONTINUE
          IF ( TEMP .LT. TRLM .OR. JY .GE. NY2 ) GOTO 60
          JY = JY + 1
          TEMP = A(JAPY(JY-JOFF)+I)
          IF ( UP .AND. JY-J .LE. MINCR .AND. TEMP .GE. TMPMX ) THEN
              TMPMX = TEMP
              ISTEP = ISTEP + 1
              SKIP = .FALSE.
          ELSE IF ( ( .NOT. SKIP ) .AND. TEMP .GE. TMPMX-TRSH
     &                          .AND. TEMP .GT. TRLM ) THEN
              SKIP = .TRUE.
          ELSE
              UP = .FALSE.
          ENDIF
          GOTO 50
   60 CONTINUE
      CORR = A(JAPY(JY-1-JOFF)+I) - TEMP
      IF ( CORR .GT. 0.0 ) THEN
          CORR = (TRLM-TEMP) / CORR
          IF ( CORR .LT. 0.0 ) THEN
              CORR = 0.0
          ELSE IF ( CORR .GT. 1.0 ) THEN
              CORR = 1.0
          ENDIF
      ELSE
          CORR = -1.0
      ENDIF
      DDR(3) = FLOAT(JY-J) - CORR
C
      JY = J - 1
      TEMP = FCNTR 
      TMPMX = FCNTR
      NY1 = IBUF(2)
      UP = .TRUE.
      SKIP = .FALSE.
   70 CONTINUE
          IF ( TEMP .LT. TRLM .OR. JY .LE. NY1 ) GOTO 80
          JY = JY - 1
          TEMP = A(JAPY(JY-JOFF)+I)
          IF ( UP .AND. J-JY .LE. MINCR .AND. TEMP .GE. TMPMX ) THEN
              TMPMX = TEMP
              ISTEP = ISTEP + 1
              SKIP = .FALSE.
          ELSE IF ( ( .NOT. SKIP ) .AND. TEMP .GE. TMPMX-TRSH
     &                      .AND. TEMP .GT. TRLM ) THEN
              SKIP = .TRUE.
          ELSE
              UP = .FALSE.
          ENDIF
          GOTO 70 
   80 CONTINUE
      CORR = A(JAPY(JY+1-JOFF)+I) - TEMP
      IF ( CORR .GT. 0.0 ) THEN
          CORR = (TRLM-TEMP) / CORR
          IF (CORR.LT.0.0) THEN
              CORR = 0.0
          ELSE IF ( CORR .GT. 1.0 ) THEN
              CORR = 1.0
          ENDIF
      ELSE
          CORR = -1.0
      ENDIF
      DDR(4) = FLOAT(J-JY) - CORR 
C
      IX = I + 1
      JY = J + 1
      TEMP = FCNTR
      TMPMX = FCNTR
      UP = .TRUE.
      SKIP = .FALSE.
   90 CONTINUE
          IF ( TEMP .LT. TRLM .OR. IX .GE. NX2 .OR. JY .GE. NY2 ) THEN
              GOTO 100
          ENDIF
          IX = IX + 1
          JY = JY + 1
          TEMP = A(JAPY(JY-JOFF)+IX)
          IF ( UP .AND. JY-J .LE. MINCR2 .AND. TEMP .GE. TMPMX ) THEN
              TMPMX = TEMP
              ISTEP = ISTEP + 1
              SKIP = .FALSE.
          ELSE IF ( ( .NOT. SKIP ) .AND. TEMP .GE. TMPMX-TRSH
     &                           .AND. TEMP .GT. TRLM ) THEN
              SKIP = .TRUE.
          ELSE
              UP = .FALSE.
          ENDIF
          GOTO 90
  100 CONTINUE
      CORR = A(JAPY(JY-1-JOFF)+IX-1) - TEMP
      IF ( CORR .GT. 0.0 ) THEN
          CORR = (TRLM-TEMP) / CORR
          IF ( CORR .LT. 0.0 ) THEN
              CORR = 0.0
          ELSE IF ( CORR .GT. 1.0 ) THEN
              CORR = 1.0
          ENDIF
      ELSE
          CORR = -1.0
      ENDIF
      DDR(5) = SR2 * ( FLOAT(JY-J) - CORR )
C
      IX = I - 1
      JY = J + 1
      TEMP = FCNTR
      TMPMX = FCNTR
      UP = .TRUE.
      SKIP = .FALSE.
  110 CONTINUE
          IF ( TEMP .LT. TRLM .OR. IX .LE. NX1 .OR. JY .GE. NY2 ) THEN
              GOTO 120
          ENDIF
          IX = IX - 1
          JY = JY + 1
          TEMP = A(JAPY(JY-JOFF)+IX)
          IF ( UP .AND. JY-J .LE. MINCR2 .AND. TEMP .GE. TMPMX ) THEN
              TMPMX = TEMP
              ISTEP = ISTEP + 1
              SKIP = .FALSE.
          ELSE IF ( ( .NOT. SKIP ) .AND. TEMP .GE. TMPMX-TRSH
     &                             .AND. TEMP .GT. TRLM ) THEN
              SKIP = .TRUE.
          ELSE
              UP = .FALSE.
          ENDIF
          GOTO 110
  120 CONTINUE
      CORR = A(JAPY(JY-1-JOFF)+IX+1) - TEMP
      IF ( CORR .GT. 0.0 ) THEN
          CORR = (TRLM-TEMP) / CORR
          IF ( CORR .LT. 0.0 ) THEN
              CORR = 0.0
          ELSE IF ( CORR .GT. 1.0 ) THEN
              CORR = 1.0
          ENDIF
      ELSE
          CORR = -1.0
      ENDIF
      DDR(6) = SR2 * ( FLOAT(JY-J) - CORR )
C
      IX = I - 1
      JY = J - 1
      TEMP = FCNTR
      TMPMX = FCNTR
      UP = .TRUE.
      SKIP = .FALSE.
  130 CONTINUE
          IF ( TEMP .LT. TRLM .OR. IX .LE. NX1 .OR. JY .LE. NY1 ) THEN
              GOTO 140
          ENDIF
          IX = IX - 1
          JY = JY - 1
          TEMP = A(JAPY(JY-JOFF)+IX)
          IF ( UP .AND. J-JY .LE. MINCR2 .AND. TEMP .GE. TMPMX ) THEN
              TMPMX = TEMP
              ISTEP = ISTEP + 1
              SKIP = .FALSE.
          ELSE IF ( ( .NOT. SKIP ) .AND. TEMP .GE. TMPMX-TRSH
     &                            .AND. TEMP .GT. TRLM ) THEN
              SKIP = .TRUE.
          ELSE
              UP = .FALSE.
          ENDIF
          GOTO 130
  140 CONTINUE
      CORR = A(JAPY(JY+1-JOFF)+IX+1) - TEMP
      IF ( CORR .GT. 0.0 ) THEN
          CORR = (TRLM-TEMP) / CORR
          IF ( CORR .LT. 0.0 ) THEN
              CORR = 0.0
          ELSE IF ( CORR .GT. 1.0 ) THEN
              CORR = 1.0
          ENDIF
      ELSE
          CORR = -1.0
      ENDIF
      DDR(7) = SR2 * ( FLOAT(J-JY) - CORR )
C
      IX = I + 1
      JY = J - 1
      TEMP = FCNTR
      TMPMX = FCNTR
      UP = .TRUE.
      SKIP = .FALSE.
  150 CONTINUE
          IF ( TEMP .LT. TRLM .OR. IX .GE. NX2 .OR. JY .LE. NY1 ) THEN
              GOTO 160
          ENDIF
          IX = IX + 1
          JY = JY - 1
          TEMP = A(JAPY(JY-JOFF)+IX)
          IF ( UP .AND. J-JY .LE. MINCR2 .AND. TEMP .GE. TMPMX ) THEN
              TMPMX = TEMP
              ISTEP = ISTEP + 1
              SKIP = .FALSE.
          ELSE IF ( ( .NOT. SKIP ) .AND. TEMP .GE. TMPMX-TRSH
     &                             .AND. TEMP .GT. TRLM ) THEN
              SKIP = .TRUE.
          ELSE
              UP = .FALSE.
          ENDIF
          GOTO 150
  160 CONTINUE
      CORR = A(JAPY(JY+1-JOFF)+IX-1) - TEMP
      IF ( CORR .GT. 0.0 ) THEN
          CORR = (TRLM-TEMP) / CORR
          IF ( CORR .LT. 0.0 ) THEN
              CORR = 0.0
          ELSE IF ( CORR .GT. 1.0 ) THEN
              CORR = 1.0
          ENDIF
      ELSE
          CORR = -1.0
      ENDIF
      DDR(8) = SR2 * ( FLOAT(J-JY) - CORR )
C
C *** Check if the detection is not spurious.
C
      IF ( ISTEP .GT. 2 ) THEN
          AR = -1.0
          RETURN
      ENDIF
C
C *** Calculate active radius.
C
      AC2 = FLOAT(NX2)
      AC3 = FLOAT(NX2)
      DO 170 L = 2 , 8
          IF ( DDR(L) .LE. AC1 ) THEN
              AC3 = AC2
              AC2 = AC1
              AC1 = DDR(L)
          ELSE IF ( DDR(L) .LE. AC2 ) THEN
              AC3 = AC2
              AC2 = DDR(L)
          ELSE IF ( DDR(L) .LT. AC3 ) THEN
              AC3 = DDR(L)
          ENDIF
  170 CONTINUE
      AR = (AC2+AC3) / 2.0
C
      RETURN
C
      END

C @(#)redsubs.for	19.1 (ESO-DMD) 02/25/03 13:28:47
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE STDNAME(C32, NUMBER)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT (c) European Southern Observatory 1992
C.IDENT         redsubs.for
C.MODULE
C.AUTHOR        Andrew T. Young
C.KEYWORD
C.LANGUAGE      FORTRAN 77
C.PURPOSE       some subroutines used by REDUCE
C.COMMENTS
C.VERSION       4.5
C.RETURNS
C.ENVIRONMENT
C.
C-----------------------------------------------------------------------------
C
C
C       splits input string C32 into NUMBER star names in std. format,
C                                           stored in STAR5 in /STDNAM/.
C
C       CAUTION: assumes ASCII collating sequence!!
C
C       method: input string is split into tokens in token(ntok),
C               which begins in nbgn(ntok) and ends in nend(ntok)
C               of the input string.  The (possibly modified) token
C               has length len(ntok), and if recognized has type
C               ntype(ntok), or zero if not recognized.
C
C
      IMPLICIT NONE
      INTEGER NUMBER, NBGN, NEND, NTYPE, LEN, NWORDS, NITEM, NEXT, N,
     1 NBIN, K, NTOK, NTOKENS, JUMP, LAST, M, KOL, NEW, NERR
C
      CHARACTER*80 CARD
C
      INCLUDE 'MID_REL_INCL:mstars.inc'
C     PARAMETER (MSTARS=1650)
C   common for name matching:
      INTEGER MSTARK
      PARAMETER (MSTARK=2*MSTARS)
      CHARACTER*20 STDNAMES(MSTARK), STAR5(5)
      COMMON /STDNAM/ STDNAMES,STAR5
C
      CHARACTER C32*32, STDNAM*32, STR*20, TOKEN(12)*20
      DIMENSION NBGN(12),NEND(12),NTYPE(12),LEN(12)
C
        INTEGER     NTYPES(3*6*24+3)
        INTEGER     NT1(6*24),NT2(6*24),NT3(6*24+3)
CC        EQUIVALENCE (NTYPES,NT1),(NTYPES(6*24+1),NT2)	   compiler warnings...
CC        EQUIVALENCE (NTYPES(2*6*24+1),NT3)
C
        CHARACTER*3 WORD(6*3*24+3),NAME
        CHARACTER*3 C3P1(3*24),C3P2(3*24),C3P3(3*24)
        CHARACTER*3 C3P4(3*24),C3P5(3*24+2),C3P6(3*24+1)
        EQUIVALENCE (WORD,C3P1),(WORD(3*24+1),C3P2)
        EQUIVALENCE (WORD(2*3*24+1),C3P3),(WORD(3*3*24+1),C3P4)
        EQUIVALENCE (WORD(4*3*24+1),C3P5),(WORD(5*3*24+3),C3P6)
C
        CHARACTER*7 STDWD(6*3*24+3),STD1(3*12),STD2(3*12),STD3(3*12)
        CHARACTER*7 STD4(3*12),STD5(3*12),STD6(3*12)
        CHARACTER*7 STD7(3*12),STD8(3*12),STD9(3*12+2)
        CHARACTER*7 STD10(3*12),STD11(3*12),STD12(3*12+1)
        EQUIVALENCE (STDWD,STD1),(STDWD(3*12+1),STD2)
        EQUIVALENCE (STDWD(2*3*12+1),STD3),(STDWD(3*3*12+1),STD4)
        EQUIVALENCE (STDWD(4*3*12+1),STD5),(STDWD(5*3*12+1),STD6)
        EQUIVALENCE (STDWD(6*3*12+1),STD7),(STDWD(7*3*12+1),STD8)
        EQUIVALENCE (STDWD(8*3*12+1),STD9),(STDWD(9*3*12+3),STD10)
        EQUIVALENCE (STDWD(10*3*12+3),STD11),(STDWD(11*3*12+3),STD12)
C
C     The following entries *** MUST *** be ordered
C     according to the collating sequence!
C
        DATA C3P1/
     1'1U ','2U ','3C ','3U ','4U ','ADS','AGK','ALP','AND',
     2'ANT','APS','APU','AQL','AQR','AQU','ARA','ARI','AUR',
     3'AUS','Alp','And','Ant','Aps','Apu','Aql','Aqr','Aqu',
     4'Ara','Ari','Aur','Aus','BD ','BD+','BD-','BER','BET',
     5'BOO','BOR','BS ','BS1','BS2','BS3','BS4','BS5','BS6',
     6'BS7','BS8','BS9','BSD','Ber','Bet','Boo','Bor','CAE',
     7'CAM','CAN','CAP','CAR','CAS','CD ','CD+','CD-','CEN',
     8'CEP','CET','CHA','CHI','CIR','CMA','CMI','CMa','CMi'/
        DATA C3P2/
     1'CNC','COD','COL','COM','COR','CPD','CRA','CRB','CRT',
     2'CRU','CRV','CVN','CVn','CYG','Cae','Cam','Can','Cap',
     3'Car','Cas','Cen','Cep','Cet','Cha','Chi','Cir','Cnc',
     4'CoD','Col','Com','Cor','CrA','CrB','Crt','Cru','Crv',
     5'Cyg','DEL','DOR','DRA','Del','Dor','Dra','EPS','EQU',
     6'ERI','ETA','Eps','Equ','Eri','Eta','FEI','FK5','FOR',
     7'For','GAM','GC ','GEM','GRU','GSC','Gam','Gem','Grb',
     8'Gro','Gru','Grw','HD ','HDE','HER','HOR','HR ','HYA'/
        DATA C3P3/
     1'HYD','HYI','Her','Hor','Hya','Hyd','Hyi','IC ','IND',
     2'IOT','IRC','Ind','Iot','KAP','Kap','LAC','LAM','LEO',
     3'LEP','LIB','LMC','LMI','LMi','LS ','LUP','LYN','LYR',
     4'Lac','Lal','Lam','Leo','Lep','Lib','LkH','Lup','Lyn',
     5'Lyr','M  ','MAJ','MEN','MIC','MIN','MON','MU ','MUS',
     6'Maj','Mel','Men','Mic','Min','Mon','Mu ','Mus','N  ',
     7'NGC','NLT','NOR','NOV','NU ','Nor','Nov','Nu ','OCT',
     8'OME','OMI','OPH','ORI','Oct','Ome','Omi','Oph','Ori'/
        DATA C3P4/
     1'PAL','PAV','PEG','PER','PHE','PHI','PI ','PIC','PIS',
     2'PK ','PPM','PSA','PSC','PSI','PUP','PYX','Pal','Pav',
     3'Peg','Per','Phe','Phi','Pi ','Pic','Pis','PsA','Psc',
     4'Psi','Pup','Pyx','QSO','RET','RHO','Ret','Rho','SAG',
     5'SAO','SCL','SCO','SCT','SCU','SER','SEX','SGE','SGR',
     6'SIG','SMC','SN ','Sag','Scl','Sco','Sct','Scu','Ser',
     7'Sex','Sge','Sgr','Sig','TAU','TEL','THE','TRA','TRI',
     8'TUC','Tau','Tel','The','TrA','Tri','Tuc','UGC','UMA'/
        DATA C3P5/
     1'UMI','UMa','UMi','UPS','URS','Ups','Urs','VEL','VEN',
     X'VIR','VOL',
     2'VUL','Vel','Ven','Vir','Vol','Vul','XI ','Xi ','ZET',
     3'Zet','alp','and','ant','aps','apu','aql','aqr','aqu',
     4'ara','ari','aur','aus','ber','bet','boo','bor','cae',
     5'cam','can','cap','car','cas','cen','cep','cet','cha',
     6'chi','cir','cma','cmi','cnc','col','com','cor','cra',
     7'crb','crt','cru','crv','cvn','cyg','del','dor','dra',
     8'eps','equ','eri','eta','for','gam','gem','gru','gsc'/
        DATA C3P6/
     1'her','hor','hya','hyd','hyi','ind','iot','kap','lac',
     2'lam','leo','lep','lib','lmi','lup','lyn','lyr','maj',
     3'men','mic','min','mon','mu ','mus','nor','nu ','oct',
     4'ome','omi','oph','ori','pav','peg','per','phe','phi',
     5'pi ','pic','pis','psa','psc','psi','pup','pyx','ret',
     6'rho','sag','scl','sco','sct','scu','ser','sex','sge',
     7'sgr','sig','tau','tel','the','tra','tri','tuc','uma',
     8'umi','ups','urs','vel','ven','vir',
     9'vol','vul','xi ','zet'/
C
C     Here are the 7-character std. spellings for Greek & constellations:
C
        DATA STD1/
     1'1U ','2U ','3C ','3U ','4U ','ADS','AGK','Alpha','And',
     2'Ant','Aps','Apu','Aql','Aqr','Aqu','Ara','Ari','Aur',
     3'AUS','Alpha','And','Ant','Aps','Apu','Aql','Aqr','Aqu',
     4'Ara','Ari','Aur','Aus','BD ','BD+','BD-','BER','Beta'/
        DATA STD2/
     5'Boo','BOR','BS ','BS1','BS2','BS3','BS4','BS5','BS6',
     6'BS7','BS8','BS9','BSD','Ber','Bet','Boo','Bor','Cae',
     7'Cam','CAN','Cap','Car','Cas','CD ','CD+','CD-','Cen',
     8'Cep','Cet','Cha','Chi','Cir','CMa','CMi','CMa','CMi'/
        DATA STD3/
     1'Cnc','COD','Col','Com','Cor','CPD','Cra','CrB','Crt',
     2'Cru','Crv','CVn','CVn','Cyg','Cae','Cam','Can','Cap',
     3'Car','Cas','Cen','Cep','Cet','Cha','Chi','Cir','Cnc',
     4'CoD','Col','Com','Cor','CrA','CrB','Crt','Cru','Crv'/
        DATA STD4/
     5'Cyg','DEL','Dor','Dra','Del','Dor','Dra','Epsilon','Equ',
     6'Eri','Eta','Epsilon','Equ','Eri','Eta','FEI','FK5','For',
     7'For','Gamma','GC ','Gem','Gru','GSC','Gam','Gem','Grb',
     8'Gro','Gru','Grw','HD ','HDE','Her','Hor','HR ','Hya'/
        DATA STD5/
     1'Hyd','Hyi','Her','Hor','Hya','Hyd','Hyi','IC ','Ind',
     2'Iota','IRC','Ind','Iot','Kappa','Kappa','Lac','Lambda','Leo',
     3'Lep','Lib','LMC','LMi','LMi','LS ','Lup','Lyn','Lyr',
     4'Lac','Lal','Lam','Leo','Lep','Lib','LkH','Lup','Lyn'/
        DATA STD6/
     5'Lyr','M  ','MAJ','Men','Mic','MIN','Mon','Mu ','Mus',
     6'Maj','Mel','Men','Mic','Min','Mon','Mu ','Mus','Nova',
     7'NGC','NLT','Nor','Nova','Nu ','Nor','Nova','Nu ','Oct',
     8'Omega','Omicron','Oph','Ori','Oct','Ome','Omi','Oph','Ori'/
        DATA STD7/
     1'Pal','Pav','Peg','Per','Phe','Phi','Pi ','Pic','Pis',
     2'PK ','PPM','PsA','Psc','Psi','Pup','Pyx','Pal','Pav',
     3'Peg','Per','Phe','Phi','Pi ','Pic','Pis','PsA','Psc',
     4'Psi','Pup','Pyx','QSO','Ret','Rho','Ret','Rho','Sag'/
        DATA STD8/
     5'SAO','Scl','Sco','Sct','SCU','Ser','Sex','Sge','Sgr',
     6'Sigma','SMC','SN ','Sag','Scl','Sco','Sct','Scu','Ser',
     7'Sex','Sge','Sgr','Sig','Tau','Tel','Theta','TrA','Tri',
     8'Tuc','Tau','Tel','The','TrA','Tri','Tuc','UGC','UMa'/
        DATA STD9/
     1'UMi','UMa','UMi','UPS','URS','Upsilon','Urs','Vel','VEN',
     X'Vir',
     2'Vol','Vul','Vel','Ven','Vir','Vol','Vul','Xi ','Xi ','Zeta',
     3'Zeta','Alpha','And','Ant','Aps','apu','Aql','Aqr','Aqu',
     4'Ara','Ari','Aur','aus','ber','Beta','Boo','bor','Cae'/
        DATA STD10/
     5'Cam','can','Cap','Car','Cas','Cen','Cep','Cet','Cha',
     6'Chi','Cir','CMa','CMi','Cnc','Col','Com','cor','Cra',
     7'CrB','Crt','Cru','Crv','CVn','Cyg','del','Dor','Dra',
     8'Epsilon','Equ','Eri','Eta','For','Gamma','Gem','Gru','GSC'/
        DATA STD11/
     1'Her','Hor','Hya','Hyd','Hyi','Ind','Iota','Kappa','Lac',
     2'Lambda','Leo','Lep','Lib','LMi','Lup','Lyn','Lyr','maj',
     3'Men','Mic','min','Mon','Mu ','Mus','Nor','Nu ','Oct',
     4'Omega','Omicron','Oph','Ori','Pav','Peg','Per','Phe','Phi'/
        DATA STD12/
     5'Pi ','Pic','pis','PsA','Psc','Psi','Pup','Pyx','Ret',
     6'Rho','sag','Scl','Sco','Sct','scu','Ser','Sex','Sge',
     7'Sgr','Sigma','Tau','Tel','Theta','TrA','Tri','Tuc','UMa',
     8'UMi','Upsilon','urs','Vel','ven','Vir','Vol','Vul','Xi ','Zeta'/
C
C     The type numbers here correspond to the keys above.
C
C     Key codes:
C
C        1 = Greek letter
C        2 = Constellation name
C        3 = AGK, Grw, other zone cats.
C        4 = BD (or CD)
C        5 = BD+ or BD-
C        6 = CoD or COD
C        7 = BS
C        8 = BS1 to BS9...
C        9 = Aust.
C       10 = Borealis
C       11 = CPD
C       12 = Tau (unresolved on 1st pass).
C       13 = NGC, IC, ... (composite objects)
C       14 = Nova
C       15 = ordinary catalogs
C       16 = LS
C       17 = PK
C       18 =
C       19 =
C       20 =
C       21 = AQU                26 = HYD        31 = TAU
C       22 = CAN                27 = LEO        32 = TRI
C       23 = COR                28 = PIS        33 = URS
C       24 = CRA                29 = SAG        34 =
C       25 = DEL                30 = SCU
C
C       35 = MAJ
C       36 = MIN
C       37 = BER
C       38 = VEN
C
        DATA NT1/
C
C     '1U ','2U ','3C ','3U ','4U ','ADS','AGK','ALP','AND',
C     'ANT','APS','APU','AQL','AQR','AQU','ARA','ARI','AUR',
     115,15,15,15,15,15, 3, 1, 2, 2, 2, 2, 2, 2,21, 2, 2, 2,
C
C     'AUS','Alp','And','Ant','Aps','Apu','Aql','Aqr','Aqu',
C     'Ara','Ari','Aur','Aus','BD ','BD+','BD-','BER','BET',
     2 9, 1, 2, 2, 2, 2, 2, 2,21, 2, 2, 2, 9, 4, 5, 5,37, 1,
C
C     'BOO','BOR','BS ','BS1','BS2','BS3','BS4','BS5','BS6',
C     'BS7','BS8','BS9','BSD','Ber','Bet','Boo','Bor','CAE',
     3 2,10, 7, 8, 8, 8, 8, 8, 8, 8, 8, 8, 2,37, 1, 2,10, 2,
C
C     'CAM','CAN','CAP','CAR','CAS','CD ','CD+','CD-','CEN',
C     'CEP','CET','CHA','CHI','CIR','CMA','CMI','CMa','CMi'/
     4 2,22, 2, 2, 2, 4, 5, 5, 2, 2, 2, 2, 1, 2, 2, 2, 2, 2,
C
C     'CNC','COD','COL','COM','COR','CPD','CRA','CRB','CRT',
C     'CRU','CRV','CVN','CVn','CYG','Cae','Cam','Can','Cap',
     5 2, 6, 2, 2,23,11,24, 2, 2, 2, 2, 2, 2, 2, 2, 2,22, 2,
C
C     'Car','Cas','Cen','Cep','Cet','Cha','Chi','Cir','Cnc',
C     'CoD','Col','Com','Cor','CrA','CrB','Crt','Cru','Crv',
     6 2, 2, 2, 2, 2, 2, 1, 2, 2, 6, 2, 2,23, 2, 2, 2, 2, 2,
C
C     'Cyg','DEL','DOR','DRA','Del','Dor','Dra','EPS','EQU',
C     'ERI','ETA','Eps','Equ','Eri','Eta','FEI','FK5','FOR',
     7 2,25, 2, 2,25, 2, 2, 1, 2, 2, 1, 1, 2, 2, 1, 2, 2, 2,
C
C     'For','GAM','GC ','GEM','GRU','GSC','Gam','Gem','Grb',
C     'Gro','Gru','Grw','HD ','HDE','HER','HOR','HR ','HYA'/
     8 2, 1, 2, 2, 2, 2, 1, 2,15,15, 2, 3,15,15, 2, 2,15, 2/
C
        DATA NT2/
C
C     'HYD','HYI','Her','Hor','Hya','Hyd','Hyi','IC ','IND',
C     'IOT','IRC','Ind','Iot','KAP','Kap','LAC','LAM','LEO',
     126, 2, 2, 2, 2,26, 2,13, 2, 1,15, 2, 1, 1, 1, 2, 1,27,
C
C     'LEP','LIB','LMC','LMI','LMi','LS ','LUP','LYN','LYR',
C     'Lac','Lal','Lam','Leo','Lep','Lib','LkH','Lup','Lyn',
     2 2, 2,13, 2, 2,16, 2, 2, 2, 2, 2, 1,27, 2, 2,15, 2, 2,
C
C     'Lyr','M  ','MAJ','MEN','MIC','MIN','MON','MU ','MUS',
C     'Maj','Mel','Men','Mic','Min','Mon','Mu ','Mus','N  ',
     3 2,13,35, 2, 2,36, 2, 1, 2,35, 2, 2, 2,36, 2, 1, 2,14,
C
C     'NGC','NLT','NOR','NOV','NU ','Nor','Nov','Nu ','OCT',
C     'OME','OMI','OPH','ORI','Oct','Ome','Omi','Oph','Ori'/
     413,15, 2,14, 1, 2,14, 1, 2, 1, 1, 2, 2, 2, 1, 1, 2, 2,
C
C     'PAL','PAV','PEG','PER','PHE','PHI','PI ','PIC','PIS',
C     'PK ','PPM','PSA','PSC','PSI','PUP','PYX','Pal','Pav',
     513, 2, 2, 2, 2, 1, 1, 2,28,17,15, 2, 2, 1, 2, 2,13, 2,
C
C     'Peg','Per','Phe','Phi','Pi ','Pic','Pis','PsA','Psc',
C     'Psi','Pup','Pyx','QSO','RET','RHO','Ret','Rho','SAG',
     6 2, 2, 2, 1, 1, 2,28, 2, 2, 1, 2, 2,15, 2, 1, 2, 1,29,
C
C     'SAO','SCL','SCO','SCT','SCU','SER','SEX','SGE','SGR',
C     'SIG','SMC','SN ','Sag','Scl','Sco','Sct','Scu','Ser',
     715, 2, 2, 2,30, 2, 2, 2, 2, 1,13,15,29, 2, 2, 2,30, 2,
C
C     'Sex','Sge','Sgr','Sig','TAU','TEL','THE','TRA','TRI',
C     'TUC','Tau','Tel','The','TrA','Tri','Tuc','UGC','UMA'/
     8 2, 2, 2, 1,31, 2, 1, 2,32, 2,31, 2, 1, 2,32, 2,13, 2/
C
        DATA NT3/
C
C     'UMI','UMa','UMi','UPS','URS','Ups','Urs','VEL','VEN',
C     'VIR',
C     'VOL','VUL','Vel','Ven','Vir','Vol','Vul','XI ','Xi ','ZET',
     1 2, 2, 2, 1,33, 1,33, 2,38, 2, 2, 2, 2,38, 2, 2, 2, 1, 1, 1,
C
C     'Zet','alp','and','ant','aps','apu','aql','aqr','aqu',
C     'ara','ari','aur','aus','ber','bet','boo','bor','cae',
     2 1, 1, 2, 2, 2, 2, 2, 2,21, 2, 2, 2, 9,37, 1, 2,10, 2,
C
C     'cam','can','cap','car','cas','cen','cep','cet','cha',
C     'chi','cir','cma','cmi','cnc','col','com','cor','cra',
     3 2,22, 2, 2, 2, 2, 2, 2, 2, 1, 2, 2, 2, 2, 2, 2,23,24,
C
C     'crb','crt','cru','crv','cvn','cyg','del','dor','dra',
C     'eps','equ','eri','eta','for','gam','gem','gru','gsc'/
     4 2, 2, 2, 2, 2, 2,25, 2, 2, 1, 2, 2, 1, 2, 1, 2, 2, 2,
C
C     'her','hor','hya','hyd','hyi','ind','iot','kap','lac',
C     'lam','leo','lep','lib','lmi','lup','lyn','lyr','maj',
     5 2, 2, 2,26, 2, 2, 1, 1, 2, 1,27, 2, 2, 2, 2, 2, 2,35,
C
C     'men','mic','min','mon','mu ','mus','nor','nu ','oct',
C     'ome','omi','oph','ori','pav','peg','per','phe','phi',
     6 2, 2,36, 2, 1, 2, 2, 1, 2, 1, 1, 2, 2, 2, 2, 2, 2, 1,
C
C     'pi ','pic','pis','psa','psc','psi','pup','pyx','ret',
C     'rho','sag','scl','sco','sct','scu','ser','sex','sge',
     7 1, 2,28, 2, 2, 1, 2, 2, 2, 1,29, 2, 2, 2,30, 2, 2, 2,
C
C     'sgr','sig','tau','tel','the','tra','tri','tuc','uma',
C     'umi','ups','urs','vel','ven','vir','vol','vul','xi ','zet'/
     8 2, 1,31, 2, 1, 2,32, 2, 2, 2, 1,33, 2,38, 2, 2, 2, 1, 1/
C
      DATA TOKEN/12*'                    '/
C
C       ******************  BEGIN EXECUTION  ******************
C
      M=6*24
      NWORDS=3*M+3
      NITEM=0
C
C  initialize array NTYPES
C
      DO 99123, N=1,M
         NTYPES(N) = NT1(N)
         NTYPES(N+M) = NT2(N)
         NTYPES(N+M+M) = NT3(N)
99123 CONTINUE
      NTYPES(NWORDS-2) = NT3(M+1)
      NTYPES(NWORDS-1) = NT3(M+2)
      NTYPES(NWORDS) = NT3(M+3)
C 
C the loop above replaces the original EQUIVALENCE statements:
C        EQUIVALENCE (NTYPES,NT1),(NTYPES(6*24+1),NT2)
C        EQUIVALENCE (NTYPES(2*6*24+1),NT3)
C which gave problems with the Fortran compiler of VAX/VMS
C K. Banse  980310
C 
C       Tokenize name:
C
    2 NEXT=INDEX(C32,' ')
C
      IF (NEXT.EQ.1) THEN
C         skip leading blanks.
          DO 12 NEXT=2,32
             IF(C32(NEXT:NEXT).NE.' ')GO TO 13
   12     CONTINUE
C         name was blank.
          NEXT=32
   13     CONTINUE
          NBGN(1)=NEXT
          NEND(1)=INDEX(C32(NBGN(1):),' ')+NEXT-2
          IF (NEND(1).EQ.NEXT-2) NEND(1)=32
          LEN(1)=NEND(1)-NBGN(1)+1
      ELSE
C         usual case.
          NBGN(1)=1
          NEND(1)=NEXT-1
          LEN(1)=NEND(1)
      END IF
C
C     CALL TV('Tokens are:')
      NAME=C32(NBGN(1):NEND(1))
      N=NBIN(NAME(:3),WORD,NWORDS)
C
      IF (N.GT.0) THEN
          NTYPE(1)=NTYPES(N)
C         set len(ntok) to length of std.string if ntype < 3:
          IF (NTYPE(1).LT.3) THEN
              DO 14 K=7,1,-1
                  IF (STDWD(N)(K:K).NE.' ') GO TO 15
   14         CONTINUE
   15         CONTINUE
              LEN(1)=K
              TOKEN(1)(:LEN(1))=STDWD(N)
          ELSE
              LEN(1)=NEND(1)-NBGN(1)+1
              TOKEN(1)(:LEN(1))=C32(NBGN(1):NEND(1))
          END IF
C         PRINT*,'Found ',WORD(N), NTYPES(N),' ',TOKEN(1)
      ELSE
          NTYPE(1)=0
          LEN(1)=NEND(1)-NBGN(1)+1
          TOKEN(1)(:LEN(1))=C32(NBGN(1):NEND(1))
C         PRINT*,NAME//': Not in list.'
      END IF
C     CALL TVN(TOKEN(1))
C
      DO 20 NTOK=2,12
C         look for next token:
          DO 16 K=NEND(NTOK-1)+2,32
          IF (C32(K:K).NE.' ') THEN
              NBGN(NTOK)=K
              GO TO 17
          END IF
   16     CONTINUE
          NTOKENS=NTOK-1
          GO TO 21
C
   17     CONTINUE
          NEND(NTOK)=INDEX(C32(NBGN(NTOK):),' ')
          IF (NEND(NTOK).EQ.0) NEND(NTOK)=34-NBGN(NTOK)
          NEND(NTOK)=NEND(NTOK)+NBGN(NTOK)-2
          LEN(NTOK)=NEND(NTOK)-NBGN(NTOK)+1
C
C         PRINT*,'Token ',NTOK,' is "',C32(NBGN(NTOK):NEND(NTOK))//'"'
C
          N=NBIN(C32(NBGN(NTOK):NBGN(NTOK)+2),WORD,NWORDS)
          IF (N.GT.0) THEN
C             listed keyword.
              NTYPE(NTOK)=NTYPES(N)
              IF (NTYPE(NTOK).LT.3) THEN
C                 Greek letter or constellation.
                  DO 18 K=7,1,-1
                      IF (STDWD(N)(K:K).NE.' ') GO TO 19
   18             CONTINUE
   19             CONTINUE
                  LEN(NTOK)=K
                  TOKEN(NTOK)(:LEN(NTOK))=STDWD(N)
              ELSE
C                 Constellation or catalog.
                  TOKEN(NTOK)(:LEN(NTOK))=C32(NBGN(NTOK):NEND(NTOK))
              END IF
C             PRINT*,'Found ',WORD(N), NTYPES(N),' ',STDWD(N)
          ELSE
C             not a listed keyword.
              NTYPE(NTOK)=0
              TOKEN(NTOK)(:LEN(NTOK))=C32(NBGN(NTOK):NEND(NTOK))
C             PRINT*,C32(NBGN(NTOK):NEND(NTOK))//': Not in list.'
          END IF
C
C     CALL TVN(TOKEN(NTOK))
   20 CONTINUE
C
C       End of reading loop.
C
   21 CONTINUE
C
C       Start of fixup loop.
C
      DO 60 NTOK=1,NTOKENS
C         Fix up ambiguous names.
          JUMP=NTYPE(NTOK)-20
          GO TO (31,32,33,34,35,36,37,38,39,40,41,42,43),JUMP
C
      GO TO 60
C
C     AQU: Aquarius or Aquila?
   31 CONTINUE
      IF (TOKEN(NTOK)(5:5).EQ.'r' .OR. TOKEN(NTOK)(5:5).EQ.'R')THEN
          TOKEN(NTOK)(:3)='Aqr'
          GO TO 50
      ELSE IF (TOKEN(NTOK)(5:5).EQ.'l' .OR. TOKEN(NTOK)(5:5).EQ.'L')THEN
          TOKEN(NTOK)(:3)='Aql'
          GO TO 50
      END IF
      GO TO 60
C
C     CAN: Cancer or Canis M. or Canes Ven.?
   32 CONTINUE
      IF (TOKEN(NTOK)(4:4).EQ.'i' .OR. TOKEN(NTOK)(4:4).EQ.'I') THEN
C         Canis.
          IF (NTOKENS.GT.NTOK .AND. NTYPE(NTOK+1).EQ.35) THEN
              TOKEN(NTOK)(:3)='CMa'
              GO TO 45
          ELSE IF (NTOKENS.GT.NTOK .AND. NTYPE(NTOK+1).EQ.36) THEN
              TOKEN(NTOK)(:3)='CMi'
              GO TO 45
          END IF
      ELSE IF (TOKEN(NTOK)(4:4).EQ.'e' .OR. TOKEN(NTOK)(4:4).EQ.'E' .OR.
     1         TOKEN(NTOK)(4:4).EQ.'u' .OR. TOKEN(NTOK)(4:4).EQ.'U' .OR.
     2         TOKEN(NTOK)(4:4).EQ.'.' .OR. LEN(NTOK).EQ.3) THEN
C         Canes or Canum.
          IF (NTOKENS.GT.NTOK .AND. NTYPE(NTOK+1).EQ.38) THEN
              TOKEN(NTOK)(:3)='CVn'
              GO TO 45
          END IF
      ELSE IF (TOKEN(NTOK)(4:4).EQ.'c' .OR. TOKEN(NTOK)(4:4).EQ.'C')THEN
C         Cacer or Cancri.
          TOKEN(NTOK)(:3)='Cnc'
          GO TO 50
      END IF
      GO TO 60
C
C     COR: Corona or Corvus?
   33 CONTINUE
      IF (TOKEN(NTOK)(4:4).EQ.'o' .OR. TOKEN(NTOK)(4:4).EQ.'O' .OR.
     1    TOKEN(NTOK)(4:4).EQ.'.' .OR. LEN(NTOK).EQ.3) THEN
C         Corona.
          IF (NTOKENS.GT.NTOK .AND. NTYPE(NTOK+1).EQ.9) THEN
              TOKEN(NTOK)(:3)='CrA'
              GO TO 45
          ELSE IF (NTOKENS.GT.NTOK .AND. NTYPE(NTOK+1).EQ.10) THEN
              TOKEN(NTOK)(:3)='CrB'
              GO TO 45
          END IF
      ELSE IF (TOKEN(NTOK)(4:4).EQ.'v' .OR. TOKEN(NTOK)(4:4).EQ.'V')THEN
          TOKEN(NTOK)(:3)='Crv'
          GO TO 50
      END IF
      GO TO 60
C
C     CRA: Crater or CrA?
   34 CONTINUE
      IF (LEN(NTOK).EQ.3) THEN
C         CrA.
          TOKEN(NTOK)(:3)='CrA'
          GO TO 50
      ELSE IF (TOKEN(NTOK)(4:4).EQ.'t' .OR. TOKEN(NTOK)(4:4).EQ.'T')THEN
          TOKEN(NTOK)(:3)='Crt'
          GO TO 50
      END IF
      GO TO 60
C
C     DEL: Delta or Delphinus?
   35 CONTINUE
      IF (TOKEN(NTOK)(4:4).EQ.'t' .OR. TOKEN(NTOK)(4:4).EQ.'T')THEN
          TOKEN(NTOK)(:5)='Delta'
          LEN(NTOK)=5
          NTYPE(NTOK)=1
          GO TO 60
      ELSE IF (TOKEN(NTOK)(4:4).EQ.'p' .OR. TOKEN(NTOK)(4:4).EQ.'P' .OR.
     1         NTOK.EQ.NTOKENS .OR.
     2        (NTOKENS.GT.NTOK .AND. TOKEN(NTOK+1)(:1).EQ.'=') .OR.
     3        (NTOK.GT.1 .AND. NTYPE(NTOK-1).EQ.1) )THEN
          TOKEN(NTOK)(:3)='Del'
          GO TO 50
      END IF
      GO TO 60
C
C     HYD: Hydrus or Hydra?
   36 CONTINUE
      IF (TOKEN(NTOK)(5:5).EQ.'a' .OR. TOKEN(NTOK)(5:5).EQ.'A')THEN
          TOKEN(NTOK)(:3)='Hya'
          GO TO 50
      ELSE IF (TOKEN(NTOK)(5:5).EQ.'i' .OR. TOKEN(NTOK)(5:5).EQ.'I' .OR.
     1         TOKEN(NTOK)(5:5).EQ.'u' .OR. TOKEN(NTOK)(5:5).EQ.'U')THEN
          TOKEN(NTOK)(:3)='Hyi'
          GO TO 50
      END IF
      GO TO 60
C
C     LEO: or Leo Minor?
   37 CONTINUE
      IF (NTOKENS.GT.NTOK .AND. NTYPE(NTOK+1).EQ.36) THEN
          TOKEN(NTOK)(:3)='LMi'
          GO TO 45
      ELSE IF (LEN(NTOK).EQ.3 .OR. LEN(NTOK).EQ.6) THEN
          TOKEN(NTOK)(:3)='Leo'
          GO TO 50
      END IF
      GO TO 60
C
C     PIS: Pisces or PsA?
   38 CONTINUE
      IF (NTOKENS.GT.NTOK .AND. NTYPE(NTOK+1).EQ.9) THEN
C         Austrinus.
          TOKEN(NTOK)(:3)='PsA'
          GO TO 45
      ELSE IF (TOKEN(NTOK)(5:5).EQ.'i' .OR. TOKEN(NTOK)(5:5).EQ.'I' .OR.
     1         TOKEN(NTOK)(5:5).EQ.'e' .OR. TOKEN(NTOK)(5:5).EQ.'E')THEN
C         Pisces or Piscium.
          TOKEN(NTOK)(:3)='Psc'
          GO TO 50
      END IF
      GO TO 60
C
C     SAG: Sagitta or Sagittarius?
   39 CONTINUE
      IF (LEN(NTOK).EQ.8 .OR. LEN(NTOK).EQ.7) THEN
C         Sagittae or Sagitta.
          TOKEN(NTOK)(:3)='Sge'
          GO TO 50
      ELSE IF (LEN(NTOK).EQ.10 .OR. LEN(NTOK).EQ.11) THEN
C         Sagittarii or Sagittarius.
          TOKEN(NTOK)(:3)='Sgr'
          GO TO 50
      END IF
      GO TO 60
C
C     SCU: Sculptor or Scutum?
   40 CONTINUE
      IF (TOKEN(NTOK)(4:4).EQ.'l' .OR. TOKEN(NTOK)(4:4).EQ.'L')THEN
          TOKEN(NTOK)(:3)='Scl'
          GO TO 50
      ELSE IF (TOKEN(NTOK)(4:4).EQ.'t' .OR. TOKEN(NTOK)(4:4).EQ.'T')THEN
          TOKEN(NTOK)(:3)='Sct'
          GO TO 50
      END IF
      GO TO 60
C
C     TAU: Tau or Taurus?
   41 CONTINUE
      IF (LEN(NTOK).EQ.3)THEN
C         "Tau" input.
          IF (NTOK.EQ.NTOKENS .OR.
     1        NTOKENS.GT.NTOK .AND. TOKEN(NTOK+1)(:1).EQ.'=') THEN
C             Probably constellation name.
              NTYPE(NTOK)=2
          ELSE
C             Wait till later to resolve ntype.
              NTYPE(NTOK)=12
          END IF
          TOKEN(NTOK)(:3)='Tau'
          LEN(NTOK)=3
          GO TO 60
      ELSE IF (TOKEN(NTOK)(4:4).EQ.'r' .OR. TOKEN(NTOK)(4:4).EQ.'R')THEN
C         Tauri or Taurus.
          IF (LEN(NTOK).EQ.5) THEN
              TOKEN(NTOK)(:5)='Tauri'
          ELSE IF (LEN(NTOK).EQ.6) THEN
              TOKEN(NTOK)(:6)='Taurus'
          END IF
          GO TO 50
      END IF
      GO TO 60
C
C     TRI: Triangulum or TrA?
   42 CONTINUE
      IF (NTOKENS.GT.NTOK .AND. NTYPE(NTOK+1).EQ.9) THEN
          TOKEN(NTOK)(:3)='TrA'
          GO TO 45
      ELSE IF (LEN(NTOK).EQ.3 .OR.LEN(NTOK).EQ.9.OR.LEN(NTOK).EQ.10)THEN
          TOKEN(NTOK)(:3)='Tri'
          GO TO 50
      END IF
      GO TO 60
C
C     URS: Ursa Major or Minor?
   43 CONTINUE
      IF (TOKEN(NTOK)(4:4).EQ.'a' .OR. TOKEN(NTOK)(4:4).EQ.'A') THEN
          IF (NTOKENS.GT.NTOK .AND. NTYPE(NTOK+1).EQ.35) THEN
              TOKEN(NTOK)(:3)='UMa'
              GO TO 45
          ELSE IF (NTOKENS.GT.NTOK .AND. NTYPE(NTOK+1).EQ.36) THEN
              TOKEN(NTOK)(:3)='UMi'
              GO TO 45
          END IF
      END IF
      GO TO 60
C
C
   45 CONTINUE
C     Remove ntok+1st item from list:
      DO 46 K=NTOK+1,NTOKENS-1
      TOKEN(K)=TOKEN(K+1)
      LEN(K)=LEN(K+1)
      NTYPE(K)=NTYPE(K+1)
      NBGN(K)=NBGN(K+1)
      NEND(K)=NEND(K+1)
   46 CONTINUE
      TOKEN(NTOKENS)='='
      LEN(NTOKENS)=1
      NTYPE(NTOKENS)=0
C
   50 CONTINUE
C     set to constellation.
      LEN(NTOK)=3
      NTYPE(NTOK)=2
C
   60 CONTINUE
C
      IF (TOKEN(NTOKENS).EQ.'=') NTOKENS=NTOKENS-1
C
C       Now assemble pieces, and decide if a synonym exists:
C
      NTOK=1
      LAST=1
   70 GO TO (100, 200, 300, 400, 500, 600, 700, 800, 900, 1000,
C           Greek Cons AGK  BD   BD+  CoD  BS   BSn  Aus  Bor
C
     1      1100,1200,1300,1400,1500,1600,1700),NTYPE(NTOK)
C            CPD  TAU  NGC Nova  cat  LS   PK
C
C
C       Falls through to here for "other".
C
      IF (NTOKENS.EQ.NTOK .OR. TOKEN(NTOK+1)(:1).EQ.'=') THEN
          IF (LEN(NTOK).GT.2)THEN
C             one-word name; we are done.
              GO TO 2100
          ELSE
C             could be 1- or 2-letter component suffix to previous name.
              IF (TOKEN(NTOK)(:1).GE.'A' .AND. NITEM.GT.0 .AND.
     1             TOKEN(NTOK-1)(:1).NE.'=' .AND.
     2             NBGN(NTOK).EQ.NEND(NTOK-1)+2 .AND.
     3             (TOKEN(NTOK)(LEN(NTOK):LEN(NTOK)).LE.'G' .OR.
     4             (TOKEN(NTOK)(LEN(NTOK):LEN(NTOK)).GE.'a' .AND.
     5              TOKEN(NTOK)(LEN(NTOK):LEN(NTOK)).LE.'g') ) ) THEN
C                  add to previous name.
                  GO TO 2600
              ELSE
C                 not a suffix, so DON'T convert to caps.
                  GO TO 2150
              END IF
          END IF
C
C     - - - - -  from here on, more tokens may belong to name  - - - - -
C
      ELSE IF (TOKEN(NTOK)(:1).LE.'9') THEN
C         name begins with NUMBER.
          IF (LEN(NTOK).LT.4 .AND.
     1        TOKEN(NTOK)(LEN(NTOK):LEN(NTOK)).LE.'9') THEN
C             could be Flamsteed number.
              IF (NTYPE(NTOK+1).EQ.2) THEN
C                 followed by constl., so accept as Flamsteed.
                  GO TO 2200
              ELSE IF (NTOKENS.GT.NTOK+1 .AND. NTYPE(NTOK+2).EQ.2) THEN
                  IF ( (LEN(NTOK+1).EQ.1 .AND.
     1                TOKEN(NTOK+1)(:1).GE.'A') .OR.
C                     might be "44 i Boo" form.
     2               NTYPE(NTOK+1).EQ.1 .OR. NTYPE(NTOK+1).EQ.12) THEN
C                     might be "54 alpha Peg" form.
C                     save Flamsteed pair...
                      NITEM=NITEM+1
                      STAR5(NITEM)=TOKEN(NTOK)(:LEN(NTOK))//
     1                             TOKEN(NTOK+2)
C                     then save letter pair.
                      NTOK=NTOK+1
                      GO TO 2500
                  END IF
              ELSE IF (NTOKENS.GT.NTOK+2 .AND. NTYPE(NTOK+3).EQ.2) THEN
                  IF (LEN(NTOK+2).EQ.1 .AND.
     1                NTYPE(NTOK+1).EQ.1) THEN
C                     might be "78 Theta 3 Tauri" form.
C                     save Flamsteed pair...
                      NITEM=NITEM+1
                      STAR5(NITEM)=TOKEN(NTOK)(:LEN(NTOK))//
     1                             TOKEN(NTOK+3)
C                     then save letter pair.
                      NTOK=NTOK+1
                      GO TO 2300
                  END IF
              END IF
          ELSE IF (LEN(NTOK).LE.5 .AND. NTYPE(NTOK+1).EQ.2 .AND.
     1             TOKEN(NTOK)(LEN(NTOK):LEN(NTOK)).GE.'A' .AND.
     2             TOKEN(NTOK)(LEN(NTOK)-1:LEN(NTOK)-1).LE.'9' .AND.
     3             NTOKENS.GT.NTOK) THEN
C             looks like "44i Boo".
              NITEM=NITEM+1
              STAR5(NITEM)=TOKEN(NTOK)(:LEN(NTOK)-1)//TOKEN(NTOK+1)
              STDNAM=TOKEN(NTOK)(LEN(NTOK):LEN(NTOK))//
     1                       '_'//TOKEN(NTOK+1)
              LAST=NTOK+1
              GO TO 3000
          ELSE
C             could be like 3C273...
              DO 77 K=1,LEN(NTOK)-1
                  IF (TOKEN(NTOK)(K:K).GT.'9') GO TO 78
   77         CONTINUE
              IF (NTOKENS.GT.NTOK .AND. NTYPE(NTOK+1).GT.0) GO TO 2100
              NERR=77
              GO TO 9000
   78         CONTINUE
C             string contains non-numeric char; assume 1-word name.
              GO TO 2100
          END IF
C
      ELSE IF (TOKEN(NTOK).GE.'A') THEN
C         name begins with LETTER.
          M=LEN(NTOK)
          IF (TOKEN(NTOK)(M:M).LE.'9' .AND. NTOKENS.GT.NTOK .AND.
C                 this token begins with letter, ends with digit.
     1           (NTYPE(NTOK+1).GT.0
C                 next token is recognized.
     2                        .OR.
     3            (TOKEN(NTOK+1)(:1).GE.'A' .AND.
     4             TOKEN(NTOK+1)(LEN(NTOK+1):LEN(NTOK+1)).LE.'9')
C                 next token looks like catalog&number.
     5                        .OR.
     6            (NTOKENS.GT.NTOK+1 .AND.
C                 next 2 tokens look like...
     7                  (NTYPE(NTOK+2).EQ.2 .OR.
C                        ...something + constl.
     8            (TOKEN(NTOK+1)(:1).GE.'A' .AND.
     9             TOKEN(NTOK+2)(:1).LE.'9') ) )
C                        ...catalog + number.
     X                 ) ) THEN
C             next word looks like start of new name & this one ends in digit.
              IF (NTOKENS.GT.NTOK .AND.
     1              NTYPE(NTOK+1).EQ.2 .AND. TOKEN(NTOK)(:1).EQ.'V')THEN
C                 variable star number.
                  GO TO 2200
              ELSE
                  GO TO 2100
              END IF
          ELSE IF (TOKEN(NTOK)(M:M).LE.'9' .AND.
     1             TOKEN(NTOK)(:1).EQ.'H' .AND.
     2             (TOKEN(NTOK)(2:2).EQ.'D' .OR.TOKEN(NTOK)(2:2).EQ.'R')
     3        .AND. TOKEN(NTOK)(3:3).GE.'1' .AND.TOKEN(NTOK)(3:3).LE.'9'
     4                )THEN
C             HD or HR number concatenated.
              GO TO 2100
          END IF
C
          IF (LEN(NTOK).GT.5)THEN
              IF (TOKEN(NTOK)(M:M).GE.'A' .AND.
C                 first word ends in letter, second begins w. number;
     1            TOKEN(NTOK+1)(:1).LT.'A') THEN
C                probably a catalog name; reduce to cap + l.c.:
                 IF(TOKEN(NTOK)(:1).GT.'Z')
     1                TOKEN(NTOK)(:1)=CHAR(ICHAR(TOKEN(NTOK)(:1))-32)
                 DO 80 K=2,M
                 IF(TOKEN(NTOK)(K:K).GE.'A'.AND.TOKEN(NTOK)(K:K).LE.'Z')
     1                TOKEN(NTOK)(K:K)=CHAR(ICHAR(TOKEN(NTOK)(K:K))+32)
   80            CONTINUE
                 GO TO 2200
              ELSE IF (TOKEN(NTOK)(M:M).GE.'A' .AND.
     1                NTYPE(NTOK+1).GT.0) THEN
C                 probably a long single name.
                  GO TO 2100
              END IF
          ELSE IF (LEN(NTOK).LE.2) THEN
C             could be var.star OR unknown catalog OR suffix "A", "AB", etc.
              IF (NTOKENS.GT.NTOK .AND. NTYPE(NTOK+1).EQ.2 .AND.
     1              TOKEN(NTOK)(:1).LE.TOKEN(NTOK)(M:M) .AND.
     2              TOKEN(NTOK)(M:M).LE.'Z') THEN
                  IF (NTOKENS.GT.NTOK+1 .AND.TOKEN(NTOK)(:1).LT.'G'.AND.
     1                TOKEN(NTOK+2)(:1).EQ.'X' .AND. NITEM.GT.0)THEN
C                     suffix, not a variable; next field is X-ray source.
                      GO TO 2600
                  ELSE
C                     variable star.
                      GO TO 2500
                  END IF
              ELSE IF (NTOKENS.GT.NTOK .AND.
     1                 NBGN(NTOK+1).EQ.NEND(NTOK)+2 .AND.
     2                 TOKEN(NTOK+1)(:1).GE.'0' .AND.
     3                 TOKEN(NTOK+1)(:1).LE.'9') THEN
C                 unknown 1- or 2-letter catalog.
                  GO TO 2200
              ELSE IF (NITEM.GT.0 .AND. TOKEN(NTOK-1)(:1).NE.'=' .AND.
     1             NBGN(NTOK).EQ.NEND(NTOK-1)+2 .AND.
     2             (TOKEN(NTOK)(:1).LT.'G' .OR.
     3              TOKEN(NTOK)(:1).GE.'a' .AND. TOKEN(NTOK)(:1).LT.'g')
     4                  .AND.
     5              (TOKEN(NTOK)(M:M).LT.'G' .OR.
     6              TOKEN(NTOK)(M:M).GE.'a'.AND.TOKEN(NTOK)(M:M).LT.'g')
     7                 ) THEN
C                 suffix.
                  GO TO 2600
              ELSE IF (NTOKENS.GT.NTOK .AND. NTYPE(NTOK+1).EQ.2 .AND.
     1                 LEN(NTOK).EQ.1) THEN
C                 something like P Cyg or i Boo.
                  GO TO 2500
              ELSE IF (NTOKENS.GT.NTOK .AND. NTYPE(NTOK+1).GT.0 .AND.
     1                 NITEM.GT.0) THEN
C                 probably a suffix.
                  GO TO 2600
              ELSE
C                 not a suffix, so DON'T convert to caps.
                  GO TO 2150
              END IF
          ELSE IF (NTOKENS.GT.NTOK+1 .AND. NTYPE(NTOK+2).EQ.0 .AND.
     1     (TOKEN(NTOK+1)(:1).EQ.'+' .OR. TOKEN(NTOK+1)(:1).EQ.'-').AND.
     2              TOKEN(NTOK+2)(:1).LE.'9') THEN
C             looks like a zone cat.
              GO TO 500
          ELSE IF (NTOKENS.GT.NTOK .AND. TOKEN(NTOK+1)(:1).LE.'9'.AND.
     1             TOKEN(NTOK)(M:M).LE.'Z') THEN
C             next token starts w.number; probably a catalog abbreviation.
              GO TO 2200
          ELSE IF (NTYPE(NTOK+1).GT.0) THEN
C             probably a single name.
              GO TO 2100
          END IF
          GO TO 1300
C
      ELSE IF (TOKEN(NTOK)(:1).EQ.'=')THEN
          NTOK=NTOK+1
          LAST=NTOK
          GO TO 70
      END IF
      NERR=99
      GO TO 9000
C
C     Greek letter.
  100 CONTINUE
      IF (NTOKENS.GT.NTOK .AND. NTYPE(NTOK+1).EQ.2) THEN
C         like "Alpha Cyg".
          GO TO 2500
      ELSE IF(NTOKENS.GE.NTOK+2 .AND. NTYPE(NTOK+2).EQ.2 .AND.
     1          LEN(NTOK+1).EQ.1 .AND. TOKEN(NTOK+1)(:1).LE.'9') THEN
C         like "Pi 5 Ori".
          GO TO 2300
      ELSE
          NERR=160
          GO TO 9000
      END IF
C      NERR=180
C      GO TO 9000
C
C     Constellation name first.
  200 CONTINUE
      IF (NTOKENS.GT.NTOK+2 .AND. TOKEN(NTOK+1)(:1).EQ.'X') THEN
C         special for X-ray sources with other names:
          IF (NTYPE(NTOK+3).EQ.2 .AND.
     1        (LEN(NTOK+2).LT.3 .OR. TOKEN(NTOK+2)(:1).EQ.'V')) THEN
C             probably followed by var.star name.
              GO TO 2200
          ELSE IF (TOKEN(NTOK+2)(:1).GE.'A' .AND.
     1             TOKEN(NTOK+3)(:1).LE.'9') THEN
C              probably followed by catalog + number.
              GO TO 2200
          END IF
      ELSE IF (NTOKENS.GT.NTOK+1 .AND. TOKEN(NTOK+1)(:1).EQ.'X') THEN
C         special for X-ray sources with other names:
          IF (TOKEN(NTOK+2)(:1).GE.'A' .AND.
     1             TOKEN(NTOK+2)(LEN(NTOK+2):LEN(NTOK+2)).LE.'9') THEN
C              probably followed by catalog + number.
              GO TO 2200
          END IF
      END IF
      GO TO 1300
C
C     AGK, Grw, etc.
  300 CONTINUE
      IF (TOKEN(NTOK+1)(:1).EQ.'+' .OR. TOKEN(NTOK+1)(:1).EQ.'-') THEN
C         zone in next field.
          GO TO 400
      ELSE
C         zone appended.
          GO TO 500
      END IF
C
C     BD or CD
  400 CONTINUE
      K=LEN(NTOK+1)
      M=LEN(NTOK+2)
C     normal format: BD +12 3456
      IF (NTOKENS.GE.NTOK+2 .AND. LEN(NTOK+1).LE.3 .AND.
     1    (TOKEN(NTOK+1)(:1).EQ.'+' .OR. TOKEN(NTOK+1)(:1).EQ.'-') .AND.
     2  (TOKEN(NTOK+1)(K:K).GE.'0' .AND. TOKEN(NTOK+1)(K:K).LE.'9').AND.
     3  (TOKEN(NTOK+2)(1:1).GE.'0' .AND. TOKEN(NTOK+2)(1:1).LE.'9')
     4    ) THEN
          IF (LEN(NTOK+1).EQ.3 .AND. TOKEN(NTOK+1)(2:2).EQ.'0')THEN
C             trim leading zero from zone.
              TOKEN(NTOK+1)(2:2)=TOKEN(NTOK+1)(3:3)
              LEN(NTOK+1)=2
          END IF
          GO TO 2400
C
      ELSE IF (NTOKENS.GT.NTOK .AND. NTYPE(NTOK+1).EQ.2) THEN
C         it is a variable-star name.
          GO TO 2500
      ELSE
          NERR=480
          GO TO 9000
      END IF
C
C     BD+ or BD- or CD+ or CD-
  500 CONTINUE
      M=LEN(NTOK+2)
C     normal format: BD+12 3456
      IF (NTOKENS.GE.NTOK+1 .AND.
     1   TOKEN(NTOK)(LEN(NTOK):LEN(NTOK)).GE.'0' .AND.
     2   TOKEN(NTOK)(LEN(NTOK):LEN(NTOK)).LE.'9' .AND.
     3   TOKEN(NTOK+1)(:1).GE.'0' .AND. TOKEN(NTOK+1)(:1).LE.'9'
     5    ) THEN
          IF (LEN(NTOK).EQ.5 .AND. TOKEN(NTOK)(4:4).EQ.'0')THEN
C             trim leading zero from zone.
              TOKEN(NTOK)(4:4)=TOKEN(NTOK)(5:5)
              LEN(NTOK)=4
          END IF
          GO TO 2500
C
C     wierd format: BD+ 2 3456
      ELSE IF (NTOKENS.GE.NTOK+2 .AND. LEN(NTOK+1).EQ.1 .AND.
     1  (TOKEN(NTOK+1)(:1).GE.'0' .AND. TOKEN(NTOK+1)(:1).LE.'9').AND.
     3  (TOKEN(NTOK+2)(1:1).GE.'0' .AND. TOKEN(NTOK+2)(1:1).LE.'9').AND.
     4  (TOKEN(NTOK+2)(M:M).GE.'0' .AND. TOKEN(NTOK+2)(M:M).LE.'9')
     5    ) THEN
          GO TO 2400
C
      ELSE
C         complain.
          NERR=580
          GO TO 9000
      END IF
C
C     CoD or COD (always -)
  600 CONTINUE
      IF (LEN(NTOK).EQ.3) THEN
          TOKEN(NTOK)(2:3)='D '
          LEN(NTOK)=2
          GO TO 400
      ELSE IF (LEN(NTOK).GE.4 .AND. TOKEN(NTOK)(4:4).EQ.'-') THEN
          TOKEN(NTOK)(2:2)='D '
          STR(3:LEN(NTOK))=TOKEN(NTOK)(4:)
          TOKEN(NTOK)(3:LEN(NTOK))=STR(3:LEN(NTOK))
          LEN(NTOK)=LEN(NTOK)-1
          GO TO 500
      END IF
      GO TO 2200
C
C     BS
  700 CONTINUE
      IF (NTOKENS.GT.NTOK .AND. NTYPE(NTOK+1).NE.2) THEN
          TOKEN(NTOK)(:2)='HR'
          GO TO 2200
      ELSE IF (NTOKENS.GT.NTOK .AND. NTYPE(NTOK+1).EQ.2) THEN
C         var.star.
          GO TO 2500
      ELSE
          GO TO 2100
      END IF
C
C     BS1 to BS9
  800 CONTINUE
      TOKEN(NTOK)(:2)='HR'
      GO TO 2100
C
C     AUST... (used)
  900 CONTINUE
C
C     BOR... (used)
 1000 CONTINUE
C
C     CPD
 1100 CONTINUE
C     format: CPD -12 3456
      IF (LEN(NTOK).EQ.3) THEN
          GO TO 400
      ELSE IF (TOKEN(NTOK)(4:4).EQ.'-') THEN
      K=LEN(NTOK+1)
      M=LEN(NTOK+2)
C     format: CPD-12 3456
      IF (NTOKENS.GE.NTOK+1 .AND. LEN(NTOK+1).LE.4 .AND.
     1   TOKEN(NTOK)(LEN(NTOK):LEN(NTOK)).GE.'0' .AND.
     2   TOKEN(NTOK)(LEN(NTOK):LEN(NTOK)).LE.'9' .AND.
     3   TOKEN(NTOK+1)(:1).GE.'0' .AND. TOKEN(NTOK+1)(:1).LE.'9' .AND.
     4   TOKEN(NTOK+1)(K:K).GE.'0' .AND. TOKEN(NTOK+1)(K:K).LE.'9'
     5    ) THEN
          IF (LEN(NTOK).EQ.6 .AND. TOKEN(NTOK)(5:5).EQ.'0')THEN
C             trim leading zero from zone.
              TOKEN(NTOK)(5:5)=TOKEN(NTOK)(6:6)
              LEN(NTOK)=5
          END IF
          GO TO 2500
C
C     wierd format: CPD+ 2 3456
      ELSE IF (NTOKENS.GE.NTOK+2 .AND. LEN(NTOK+1).EQ.1 .AND.
     1  (TOKEN(NTOK+1)(:1).GE.'0' .AND. TOKEN(NTOK+1)(:1).LE.'9').AND.
     3  (TOKEN(NTOK+2)(1:1).GE.'0' .AND. TOKEN(NTOK+2)(1:1).LE.'9').AND.
     4  (TOKEN(NTOK+2)(M:M).GE.'0' .AND. TOKEN(NTOK+2)(M:M).LE.'9')
     5    ) THEN
          GO TO 2400
C
      ELSE
C         complain.
          NERR=1180
          GO TO 9000
      END IF
C
      ELSE
          NERR=1190
          GO TO 9000
      END IF
C
C     TAU (TAU or Taurus?)
 1200 CONTINUE
      IF (LEN(NTOK).EQ.3 .AND. NTYPE(NTOK+1).EQ.2) THEN
C         definitely Greek Tau, followed by constellation.
          GO TO 2500
      ELSE IF (LEN(NTOK).EQ.6 .AND. NTYPE(NTOK+1).NE.2) THEN
C         definitely Taurus.
           GO TO 2300
      ELSE IF (LEN(NTOK).EQ.3 .AND. NTYPE(NTOK+1).EQ.12) THEN
C         Tau Tauri.
          GO TO 2500
      ELSE
          NERR=1290
          GO TO 9000
      END IF
C
C     NGC, IC, Pal, UGC, M, LMC, SMC -- likely to have other stuff after it.
 1300 CONTINUE
      KOL=1
      NEW=0
      DO 1310 K=NTOK,NTOKENS
          IF (TOKEN(K)(:1).EQ.'=' .OR.
     1          K.GT.NTOK .AND. NTYPE(K).GT.0) THEN
              LAST=K-1
              GO TO 1311
          ELSE
              NEW=NEW+LEN(K)
              STDNAM(KOL:NEW)=TOKEN(K)(:LEN(K))
              KOL=NEW+1
          END IF
 1310 CONTINUE
      LAST=NTOKENS
 1311 CONTINUE
      STDNAM(NEW+1:)=' '
      GO TO 3000
C
C     Nova
 1400 CONTINUE
      IF (NTOKENS.GT.NTOK+1 .AND. NTYPE(NTOK+1).EQ.2 .AND.
     1    TOKEN(NTOK+2)(:1).GE.'1' .AND.
     2    TOKEN(NTOK+2)(:1).LE.'9') THEN
C     Nova constl year
          STDNAM=TOKEN(NTOK)(:LEN(NTOK))//'_'//
     1           TOKEN(NTOK+1)(:LEN(NTOK+1))//'_'//
     2           TOKEN(NTOK+2)(:LEN(NTOK+2))
          LAST=NTOK+2
C
      ELSE IF (NTOKENS.GT.NTOK .AND. NTYPE(NTOK+1).EQ.2) THEN
C     Nova constl
          STDNAM=TOKEN(NTOK)(:LEN(NTOK))//'_'//
     1           TOKEN(NTOK+1)(:LEN(NTOK+1))
          LAST=NTOK+1
C
      ELSE IF (NTOKENS.EQ.NTOK .OR. TOKEN(NTOK+1).EQ.'=') THEN
          GO TO 2100
      ELSE
          NERR=1490
          GO TO 9000
      END IF
      GO TO 3000
C
C     common catalog if followed by number.
 1500 CONTINUE
      IF (NTOKENS.GT.NTOK .AND. TOKEN(NTOK+1)(:1).LE.'9' .AND.
     1         ( TOKEN(NTOK+1)(LEN(NTOK+1):LEN(NTOK+1)).LE.'9' .OR.
     2          (TOKEN(NTOK+1)(LEN(NTOK+1):LEN(NTOK+1)).GE.'A' .AND.
     3           TOKEN(NTOK+1)(LEN(NTOK+1):LEN(NTOK+1)).LE.'D') ) ) THEN
C         next token numeric, maybe with A-D; assume it is catalog number.
          GO TO 2200
      ELSE IF ( (LEN(NTOK).GT.3 .AND.
     1           TOKEN(NTOK)(LEN(NTOK):LEN(NTOK)).LE.'9') .OR.
     2           (NTOKENS.GT.NTOK .AND.
     3           TOKEN(NTOK+1)(:1).GE.'A')
     4            ) THEN
C         cat.number appears to be concatenated.
          GO TO 2100
      END IF
C      missing cat.number.
      NERR=1590
      GO TO 9000
C
C     LS II+42 123  (could be Var.star)
 1600 CONTINUE
      IF (NTOKENS.GT.NTOK+1 .AND. TOKEN(NTOK+1)(:1).EQ.'I') THEN
          IF ((TOKEN(NTOK+2)(:1).GE.'1') .AND.
     1         TOKEN(NTOK+2)(:1).LE.'9') THEN
C             3 tokens.
              STDNAM=TOKEN(NTOK)(:LEN(NTOK))//'_'//
     1               TOKEN(NTOK+1)(:LEN(NTOK+1))//'_'//
     2               TOKEN(NTOK+2)(:LEN(NTOK+2))
              LAST=NTOK+2
              GO TO 3000
C
          ELSE IF (NTOKENS.GT.NTOK+2 .AND.
     1             (TOKEN(NTOK+2)(:1).EQ.'+' .OR.
     1             TOKEN(NTOK+2)(:1).EQ.'-') .AND.
     3             TOKEN(NTOK+3)(:1).LE.'9') THEN
C             4 tokens.
              STDNAM=TOKEN(NTOK)(:LEN(NTOK))//'_'//
     1               TOKEN(NTOK+1)(:LEN(NTOK+1))//
     2               TOKEN(NTOK+2)(:LEN(NTOK+2))//'_'//
     3               TOKEN(NTOK+3)(:LEN(NTOK+3))
              LAST=NTOK+3
              GO TO 3000
C
          ELSE IF (NTYPE(NTOK+1).EQ.2) THEN
C             var.star.
              GO TO 2500
          ELSE
              NERR=1680
              GO TO 9000
          END IF
C
      ELSE IF (NTYPE(NTOK+1).EQ.2) THEN
C         var.star.
          GO TO 2500
      END IF
      NERR=1690
      GO TO 9000
C
C     PK LLL+BB 123
 1700 CONTINUE
      IF (NTOKENS.GT.NTOK+1 .AND.
     1    TOKEN(NTOK+1)(:1).LE.'9' .AND.
     2    TOKEN(NTOK+1)(LEN(NTOK):LEN(NTOK)).LE.'9' .AND.
     3    TOKEN(NTOK+2)(:1).LE.'9' .AND.
     4    TOKEN(NTOK+2)(LEN(NTOK):LEN(NTOK)).LE.'9') THEN
          GO TO 2400
      END IF
      GO TO 3000
C
C       1-word name.
C
 2100 CONTINUE
C     convert to caps.
      DO 2120 K=1,LEN(NTOK)
             IF(TOKEN(NTOK)(K:K).GT.'Z')
     1          TOKEN(NTOK)(K:K)=CHAR(ICHAR(TOKEN(NTOK)(K:K))-32)
C                     32 is ascii offset from A to a.
 2120 CONTINUE
C
 2150 CONTINUE
      STDNAM=TOKEN(NTOK)
      LAST=NTOK
      GO TO 3000
C
C       combine 2 words.
C
 2200 CONTINUE
      STDNAM=TOKEN(NTOK)(:LEN(NTOK))//TOKEN(NTOK+1)
      LAST=NTOK+1
      GO TO 3000
C
C       combine 3 words.
C
 2300 CONTINUE
      STDNAM=TOKEN(NTOK)(:LEN(NTOK))//TOKEN(NTOK+1)(:LEN(NTOK+1))
     1           //TOKEN(NTOK+2)
      LAST=NTOK+2
      GO TO 3000
C
C       combine 3 words with "_" between last 2.
C
 2400 CONTINUE
      STDNAM=TOKEN(NTOK)(:LEN(NTOK))//TOKEN(NTOK+1)(:LEN(NTOK+1))
     1           //'_'//TOKEN(NTOK+2)
      LAST=NTOK+2
      GO TO 3000
C
C       combine 2 words with "_" between them.
C
 2500 CONTINUE
      STDNAM=TOKEN(NTOK)(:LEN(NTOK))//'_'//TOKEN(NTOK+1)
      LAST=NTOK+1
      GO TO 3000
C
C       add to end of previous name.
C
 2600 CONTINUE
C     stdnam contains no embedded blanks, so find end by binary search.
      IF (STDNAM(16:16).NE.' ') THEN
          LAST=5
      ELSE
          LAST=0
      END IF
      IF (STDNAM(LAST+8:LAST+8).NE.' ') LAST=LAST+8
      IF (STDNAM(LAST+4:LAST+4).NE.' ') LAST=LAST+4
      IF (STDNAM(LAST+2:LAST+2).NE.' ') LAST=LAST+2
      IF (STDNAM(LAST+1:LAST+1).NE.' ') LAST=LAST+1
C     last is now the last non=blank char.
      IF (STDNAM(LAST:LAST).GE.'A') THEN
          STDNAM(LAST+1:)='_'//TOKEN(NTOK)
      ELSE
          STDNAM(LAST+1:)=TOKEN(NTOK)
      END IF
      LAST=NTOK
      NITEM=NITEM-1
      GO TO 3000
C
C       Done with name.
C
 3000 CONTINUE
      NITEM=NITEM+1
      STAR5(NITEM)=STDNAM
C
C     Uncomment for debugging:
C     PRINT*
C     PRINT*,'Std.name is '//STDNAM
C     PRINT*,(TOKEN(K)(:LEN(K)),K=1,NTOKENS)
C     PRINT*,(NTYPE(K),K=1,NTOKENS)
C
      IF (LAST .LT. NTOKENS) THEN
C         loop back to do remaining tokens.
          NTOK=LAST+1
          GO TO 70
      END IF
C
C     Clear tokens used:
      DO 3010 K=1,NTOKENS
      TOKEN(K)(2:LEN(K))=' '
 3010 CONTINUE
      NUMBER=NITEM
      RETURN
C
C       Here for help.
C
 9000 CONTINUE
      IF (C32.EQ.' ') THEN
          CALL TV('Blank name read')
          NUMBER=0
          RETURN
      END IF
      CALL SPACE2
      CALL TV('           *** HELP ***')
C
C     Uncomment for debugging:
C     PRINT*
C     PRINT*,'Std.name is '//STDNAM
C     PRINT*,(TOKEN(K)(:LEN(K)),K=1,NTOKENS)
C     PRINT*,(NTYPE(K),K=1,NTOKENS)
C
      WRITE(CARD,'(''Cannot parse: '',A32)') C32
      WRITE(CARD(60:),'(''near'',I5)') NERR
      CALL TV(CARD)
      CALL TV('Please re-enter this star name, with = between synonyms')
      CALL TVN('-->..............................<-- 32 characters MAX')
      DO 9010 K=1,NTOKENS
      TOKEN(K)=' '
 9010 CONTINUE
      CALL ASKFIL(' ? ',C32)
      GO TO 2
C
      END
      FUNCTION NBIN(WORD,WORDS,N)
C
C       Does binary search for word in previously sorted word list of length N.
C       Returns position of word if found, or 0 if not found.
C
C       Method: see p.87 of Jon Bentley's "Programming Pearls".
C
C       CAUTION: This version ONLY supports arrays shorter than 4096 entries !!
C
C
      IMPLICIT NONE
      INTEGER NBIN, N, L
C
      CHARACTER*(*) WORDS(N),WORD
C
C
      L=0
      IF (N.GT.2048) THEN
          IF(WORDS(2048).LT.WORD) L=N+1-2048
          GOTO 2048
      ELSE IF (N.GT.1024) THEN
          IF(WORDS(1024).LT.WORD) L=N+1-1024
          GOTO 1024
      ELSE IF (N.GT.512) THEN
          IF(WORDS(512).LT.WORD) L=N+1-512
          GOTO 512
      ELSE IF (N.GT.256) THEN
          IF(WORDS(256).LT.WORD) L=N+1-256
          GOTO 256
      ELSE IF (N.GT.128) THEN
          IF(WORDS(128).LT.WORD) L=N+1-128
          GOTO 128
      ELSE IF (N.GT.64) THEN
          IF(WORDS(64).LT.WORD) L=N+1-64
          GOTO 64
      ELSE IF (N.GT.32) THEN
          IF(WORDS(32).LT.WORD) L=N+1-32
          GOTO 32
      ELSE IF (N.GT.16) THEN
          IF(WORDS(16).LT.WORD) L=N+1-16
          GOTO 16
      ELSE IF (N.GT.8) THEN
          IF(WORDS(8).LT.WORD) L=N+1-8
          GOTO 8
      ELSE IF (N.GT.4) THEN
          IF(WORDS(4).LT.WORD) L=N+1-4
          GOTO 4
      ELSE IF (N.GT.2) THEN
          IF(WORDS(2).LT.WORD) L=N+1-2
          GOTO 2
      ELSE
          IF(WORDS(1).LT.WORD) L=N+1-1
          GOTO 1
      END IF
C
 2048 IF (WORDS(L+1024).LT.WORD) L=L+1024
 1024 IF (WORDS(L+512).LT.WORD) L=L+512
  512 IF (WORDS(L+256).LT.WORD) L=L+256
  256 IF (WORDS(L+128).LT.WORD) L=L+128
  128 IF (WORDS(L+64).LT.WORD) L=L+64
   64 IF (WORDS(L+32).LT.WORD) L=L+32
   32 IF (WORDS(L+16).LT.WORD) L=L+16
   16 IF (WORDS(L+8).LT.WORD) L=L+8
    8 IF (WORDS(L+4).LT.WORD) L=L+4
    4 IF (WORDS(L+2).LT.WORD) L=L+2
    2 IF (WORDS(L+1).LT.WORD) L=L+1
    1 CONTINUE
C
      NBIN=L+1
      IF (NBIN.GT.N .OR. WORDS(NBIN).NE.WORD) NBIN=0
C
      RETURN
      END
      SUBROUTINE SRTNAM(WORDS, NTYPE, N)
C
C       sorts word list of length N.  Carries ntype along.
C
C
      IMPLICIT NONE
      INTEGER N, I, M, JJ, NDUM
C
      CHARACTER*(20) WORDS(N)
      INTEGER NTYPE(N)
      CHARACTER*20 WORD
C
C
      I=1
    1 I=I+I
      IF(I.LT.N) GO TO 1
      M=I-1
    2 M=M/2
      IF (M.EQ.0) RETURN
      DO 10 JJ=1,N-M
      DO 8 I=JJ,1,-M
      IF(WORDS(I+M).GE.WORDS(I)) GO TO 10
      WORD=WORDS(I)
      WORDS(I)=WORDS(I+M)
      WORDS(I+M)=WORD
      NDUM=NTYPE(I)
      NTYPE(I)=NTYPE(I+M)
      NTYPE(I+M)=NDUM
    8 CONTINUE
   10 CONTINUE
      GO TO 2
C
      END

C===========================================================================
C Copyright (C) 1995-2008 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================

C ++++++++++++++++++++++++  YSTF.FOR +++++++++++++++++++++++++++++++++++++++
C .LANGUAGE Fortran 77
C .IDENTIFICATION Module YSTF.FOR
C .COMMENTS
C Module contains layer between the keyword related FORTRAN STxxxx interfaces
C and the SC_interfaces written in (hopefully independent) C
C .AUTHOR         K. Banse        ESO - Garching
C .KEYWORDS       standard interfaces.
C .ENVIRONMENT    FORTRAN and C standards
C .VERSION  [1.00] 871207:  created from SXFTOC.C
C 
C 080722	last modif
C -----------------------------------------------------------------------------
C

      SUBROUTINE STFOPN(NAME,DATTYPE,IOMODE,FILTYPE,NO,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   NAME        
      INTEGER    DATTYPE, IOMODE, FILTYPE, NO
      INTEGER    STATUS
C 
      CALL STSTR(1,NAME)                              !STRIPPED_STRING
C 
      CALL STF1(DATTYPE,IOMODE,FILTYPE,NO,STATUS)
C
      RETURN
      END
C


      SUBROUTINE STFCRE(NAME,DATTYPE,IOMODE,FILTYPE,ISIZE,NO,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   NAME        
      INTEGER    DATTYPE, IOMODE, FILTYPE, ISIZE, NO
      INTEGER    STATUS
C 
      CALL STSTR(1,NAME)                              !STRIPPED_STRING
C 
      CALL STF2(DATTYPE,IOMODE,FILTYPE,ISIZE,NO,STATUS)
C
      RETURN
      END
C


      SUBROUTINE STFXCR(NAME,DATTYPE,IOMODE,FILTYPE,ISIZE,OPTFLAGS,
     +                  NO,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   NAME        
      INTEGER    DATTYPE, IOMODE, FILTYPE, ISIZE, OPTFLAGS(*), NO
      INTEGER    STATUS
C 
      CALL STSTR(1,NAME)                              !STRIPPED_STRING
C 
      CALL STF3(DATTYPE,IOMODE,FILTYPE,ISIZE,OPTFLAGS,NO,STATUS)
C
      RETURN
      END
C


      SUBROUTINE STFMAP(NO,IOMODE,FELEM,ISIZE,ACTSIZE,PNTR,STATUS)
C
      IMPLICIT NONE
C
      INTEGER    NO, IOMODE, FELEM, ISIZE, ACTSIZE
      INTEGER*8  PNTR
      INTEGER    STATUS
C 
      CALL STF4(NO,IOMODE,FELEM,ISIZE,ACTSIZE,PNTR,STATUS)
C
      RETURN
      END
C

CC   SUBROUTINE STFCLO(NO,STATUS)
CC   directly done in stf.fc ...

CC   SUBROUTINE STFUNM(NO,STATUS)
CC   directly done in stf.fc ...


      SUBROUTINE STFDEL(NAME,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   NAME        
      INTEGER    STATUS
C
      CALL STSTR(1,NAME)                              !STRIPPED_STRING
C
      CALL STF5(STATUS)
C
      RETURN
      END
C



      SUBROUTINE STFRNM(OLDNAME,NEWNAME,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   OLDNAME, NEWNAME
      INTEGER    STATUS
C
      CALL STSTR(1,OLDNAME)                           !STRIPPED_STRING
      CALL STSTR(2,NEWNAME)                           !STRIPPED_STRING
C
      CALL STF6(STATUS)
C
      RETURN
      END
C


CC   SUBROUTINE STFGET(NO,FELEM,ISIZE,ACTSIZE,BUFADR,STATUS)
CC   directly done in stf.fc ...

CC   SUBROUTINE STFPUT(NO,FELEM,ISIZE,BUFADR,STATUS)
CC   directly done in stf.fc ...


      SUBROUTINE STFINF(NAME,FNO,IBUF,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   NAME
      INTEGER    FNO, IBUF(*)
      INTEGER    STATUS
C
      CALL STSTR(1,NAME)                           !STRIPPED_STRING
C
      CALL STF7(FNO,IBUF,STATUS)
C
      RETURN
      END
C


      SUBROUTINE STFNAM(NO,NAME,NAMLEN,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   NAME
      INTEGER    NO, NAMLEN
      INTEGER    STATUS
C
      CALL STLOC(1,1,NAME)                            !blanked CHAR_LOC
C
      CALL STF8(NO,NAMLEN,STATUS)
C
      RETURN
      END
C

CC   SUBROUTINE STFXMP(NOPIX,DATFORM,PNTR,STATUS)
CC   directly done in stf.fc ...

CC   SUBROUTINE STFYMP(NOPIX,DATFORM,IMNO,PNTR,STATUS)
CC   directly done in stf.fc ...

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  18:08 - 11 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.IDENTIFICATION
C    TDREBIN.FOR
C
C
C.AUTHOR: M.ROSA
C REBPOL modified 900117 M Peron
C remove call to NAG 900903 M Peron
C 
C 100811	last modif
C--------------------------------------------------------------------

      SUBROUTINE REBMET(NIN,XI,YI,WI,NOUT,XO,WO,IRFUN,NPAR,NPACT,DPAR,
     +                  IOPT,MINT,YO,RMIN,RMAX)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.KEYWORDS
C        NonLINEAR rebin
C
C.PURPOSE
C        NonLINEAR rebin
C
C.ALGORITHM
C
C        TBF
C
C.USAGE
C        CALL REBMET(NIN,XI,YI,WI,NOUT,XO,WO,IRFUN,NPAR,NPACT,DPAR,
C     IOPT,MINT,YO,RMIN,RMAX)
C
C.PARAMETERS
C        Inputs:
C   NIN,XI,YI,WI    no. of (input) points, indep, dep and bin inputs
C   NOUT,XO,WO      no, of (output) points, indep, bin outputs
C   IRFUN,NPAR,NPACT,PAR  func. no., size par., act no par., parameters
C
C        Note, function relates XO --> XI  i.e.  xi(f(xo))  !!!!!!
C
C        IRFUN = 1: linear    x (old) = A + Bx
C              = 2: poly.     x       = A + Bx + Cxx + (<= 16 coeffs)
C              = 3: inv.      x       = A + B/x
C              = 4: exp.      x       = A + B*EXP(Cx)
C              = 5: dexp.     x       = A + B*10.**(Cx)
C              = 6: log       x       = A + B*LOG(Cx)
C              = 7: dlog      x       = A + B*LOG10(Cx)
C              = 8: inv.pol.  x       = A + B/(x-x0) + C/(x-x0)**2 + ...
C              = 9: user defined function
C
C        IOPT,MINT     interpol/integrate option, no. of
C                                      points to be interpolated
C        IOPT = 1: spline interpolation and gaussian integration (most
C     accurate but most time consuming option)
C             = 2: intensity is simply relevant portion of pixel's
C                  intensity; for heavy oversampling of input, use this.
C             = 3: linear interpolation, followed by staightforward
C                  integration (use if i/p and o/p binwidths similar).
C
C        Outputs:
C        YO,RMIN,RMAX   dep and maxmin of output
C
C.RESTRICTIONS
C
C.MODIFICATIONS
C
C.LONG DESCRIPTION
C       The subroutines below are well commented.  For background
C       information on the use of this routine, see the Users Guide
C       for the modelling system in USG.MEM in [STMODEL.DOC]
C       (available through M. Rosa, ST-ECF).
C
C--------------------------------------------------------------------
C
      IMPLICIT NONE
C 
      INTEGER NIN,NOUT,IRFUN,NPAR,NPACT,IOPT,MINT
      INTEGER NA,NZ,I,J,LOP,LIP,INNI,KO,KF,LL,LH,ML,MH
C 
      DOUBLE PRECISION XI(NIN),YI(NIN),WI(NIN)
      DOUBLE PRECISION XO(NOUT),WO(NOUT),DPAR(NPAR),PL,PH
      DOUBLE PRECISION XL,XH,XW,XINCR,XVLS,DLOP,DLIP,DL,DH
C 
      REAL YO(NOUT),RMIN,RMAX,VAL,VALI
C 
C 
C     No. of intervals
      XVLS   = DBLE(MINT-1)
C
C  We start here doing some brain work in order to speed up
C  the program --- all this should be ok but who knows (MR/19/4/85)
C
C  There are 4 cases for the indep. arrays
C XI(i) < XI(i+1)
C XI(i) > XI(i+1)
C XO(i) < XO(i+1)
C XO(i) > XO(i+1)
C
C  and two for the mapping of XO onto XI
C       XO small onto XI small
C       XO small onto XI large
C
C  lets make a few tests, so we can optimize the DO LOOPS
C       XO increasing

      IF (XO(1).LE.XO(2)) THEN
          KO     = 1
          XL     = XO(1)
          XH     = XO(NOUT)
      ELSE
          KO     = -1
          XH     = XO(1)
          XL     = XO(NOUT)
      END IF

      CALL REBFNC(IRFUN,XL,NPAR,NPACT,DPAR)
C  the function is inverting direction
      CALL REBFNC(IRFUN,XH,NPAR,NPACT,DPAR)  
C  1: normal, -1: inverted direction
      KF     = 1  
      IF (XL.GT.XH) KF     = -1
      LOP    = KF*KO
C
C  So we set up the loops in such a way that the input indep. will be
C  increasing for all cases. That means we can keep track of search
C  limits (large gain in search for long arrays).
C
C  REBIN with flux conservation means that we have to integrate the flux
C  in the input data between the projected flanks of our new pixel.
C   Remember, that the binwidth is negative if the arrays are
C  monotonicaly decreasing !!! Since we will have to look for the
C  projection of the flanks of each pixel XO in the XI array (XL,XR),
C  where Left and Right referes to the direction of indexing in XI,
C  we have to be careful with the directions (4 cases):
C
C  XO incr, LOP pos, WO pos, xl = xo - 0.5*wo , xr = xl + wo
C  XO incr, LOP neg, WO pos, xl = xo + 0.5*wo , xr = xl - wo
C  XO decr, LOP pos, WO neg, xl = xo + 0.5*wo , xr = xl - wo
C  XO decr, LOP neg, WO neg, xl = xo - 0.5*wo , xr = xl + wo
C
C  Hence, XL = XO - 0.5*LOP*WO, XR = XL + LOP*WO  (in REAL*8)
C
C  The new indep. may not map completely onto the old and vice versa.
C  We will NOT extrapolate and we will fill undefined output with
C  NULLVALUE. Now we need
C  to obtain the applicable limits in XO, the direction in XI and the
C  search boundaries for XI and fill YO with 0 outside, in order to
C  avoid all sorts of limit testing in the actual run through XO.
C     XI increasing  !        decreasing
      LIP    = 1
      IF (XI(1).GT.XI(2)) LIP    = -1
      DLIP   = 0.5D0*DBLE(LIP)
      DLOP   = 0.5D0*DBLE(LOP)
C
C Check for the active area in XO
C
      IF (LOP.GT.0) THEN
          NA     = 1
          NZ     = NOUT
      ELSE
          NA     = NOUT
          NZ     = 1
      ENDIF
C
      DL = XI(1)
      DH = XI(NIN)
C
      XL = XO(NA) - DLOP*WO(NA)
      XH = XO(NZ) + DLOP*WO(NZ)
      CALL REBFNC(IRFUN,XL,NPAR,NPACT,DPAR)
      CALL REBFNC(IRFUN,XH,NPAR,NPACT,DPAR)
C  complete mapping of XO
      IF (XL.GE.DL .AND. XH.LE.DH) GO TO 50
C  no mapping of XO
      IF (XL.GE.DH .OR. XH.LE.DL) THEN
          WRITE (*,*) ' No overlap between input',
     +      ' and output independent !','/'
      END IF
C  check lower DX bound
      INNI = NA
      DO 10, I=NA,NZ,LOP
          XL = XO(I) - DLOP*WO(I)
          INNI = I
          CALL REBFNC(IRFUN,XL,NPAR,NPACT,DPAR)
          IF (XL.GE.DL) GO TO 20
          YO(I) = 0.00
10    CONTINUE
20    NA = INNI  
C  check upper DX bound
      INNI     = NZ
      DO 30, I=NZ,NA,-LOP
          XH = XO(I) + DLOP*WO(I)
          INNI = I
          CALL REBFNC(IRFUN,XH,NPAR,NPACT,DPAR)
          IF (XH.LT.DH) GO TO 40
          YO(I)  = 0.00
30    CONTINUE
40    NZ     = INNI
C  the initial lower limit DX
50    IF (LIP.EQ.1) THEN
          LL = 1
          LH = NIN
      ELSE
          LL = NIN
          LH = 1
      ENDIF
C
C ... and finally we go through the XO array
C
      DO 130, I = NA,NZ,LOP
          VAL = 0.0
          XW  = DLOP*WO(I)
          XL  = XO(I) - XW
          XH  = XL + XW + XW
          CALL REBFNC(IRFUN,XL,NPAR,NPACT,DPAR)
          CALL REBFNC(IRFUN,XH,NPAR,NPACT,DPAR)
C
C   This is overdoing it for arrays with equal binwidth and pixel
C   filling factors of 1, (i.e. next run through loop XR could be
C   copied into the new XL), but we want to be fancy (general).
C
C   Now search for the XI(j's) falling between XL and XR
C   Recall that we set up everything in such a way that we are
C   increasing in the value of XI and that the first XL will fall
C   after XI(LL) and the last XR before XI(LH). We will update
C   LL each time (we can do so because XO and XI were assumed to be
C   monotonic (or at least constant, but that doesn't make sense
C   at all).
C
C   Fast loop here to find full pixels falling into XL,XR
C   A complete pix is defined GE left, LT right border
C
C   DL is the distance between the lower border of pix XI(j) and
C   XL - if positive or 0 then we found the first applic. pixel.
C
C   found the pix

          DO 60, J = LL,LH,LIP  
C   this is the low pix
              DL = XL - XI(J) - DLIP*WI(J)  
              IF (DL.LT.0.0D0) THEN
                  ML = J
C   all in one pix
                  DH = XI(J) + DLIP*WI(J) - XH  
C   goto one-pix handling
                  IF (DH.GE.0.0D0) THEN  
                      MH = ML
                      GO TO 110
                  ENDIF
                  GOTO 70
              ENDIF
60        CONTINUE
C
          CALL STETER(41,' ERROR - no lower bound of pixel')
C
C   DR is the distance between the left border of pix XI(j) and
C   XR - if positive or 0 then we found the last applic. pixel.
C   Note that ML+1 is always .LE.LH because of boundary search
C
C  dist. to right border
CMvK   70     DO 80, J = ML + 1,LH,LIP  
   70     DO 80, J = ML+LIP,LH,LIP  
              MH = J
              DH = XI(J) + DLIP*WI(J) - XH  
C  JMP to MH integration
              IF (DH.GT.0.0D0) THEN
                  GO TO 90
              ELSE  
C  JMP to ML integration
                  VAL = VAL + SNGL(YI(J))
                  IF (DABS(DH) .LT. 1.D-30) GOTO 100
              ENDIF
80        CONTINUE
C
          CALL STETER(41,' ERROR - no upper bound of pixel')
C
C  handle the integrations (MH.NE.ML), in MH first
C
90        PL = XI(MH) - DLIP*WI(MH)
          XINCR  = (XH-PL)/XVLS
          CALL REBPIX(IOPT,NIN,XI,YI,PL,XH,MINT,XINCR,MH,LIP,VALI)
          VAL = VAL + VALI/WI(MH)
C
C  and look into ML in any case
C
100       DL     = XL - XI(ML) + DLIP*WI(ML)
          IF (DABS(DL).LT.1.D-33) THEN
              VAL = VAL + SNGL(YI(ML))

          ELSE
              PH  = XI(ML) + DLIP*WI(ML)
              XINCR = (PH-XL)/XVLS
              CALL REBPIX(IOPT,NIN,XI,YI,XL,PH,MINT,XINCR,ML,LIP,
     +                    VALI)
              VAL = VAL + VALI/WI(ML)
          END IF
C
          GO TO 120
C
C  handle the single pix case (MH.EQ.ML)
C
C  only one full pixel
110       DL     = XL - XI(ML) + DLIP*WI(ML)  
          IF ((DABS(DL).LT.1.D-33) .AND.
     +        (DABS(DH).LT.1.D-33)) THEN
              VAL = SNGL(YI(MH))
          ELSE
              XINCR  = (XH-XL)/XVLS
              CALL REBPIX(IOPT,NIN,XI,YI,XL,XH,MINT,XINCR,ML,LIP,
     +                    VALI)
              VAL = VALI/WI(ML)
          END IF
C
C  update cuts and result array, CONSERVE FLUX IN PIXEL DOMAIN
C
120       YO(I)  = VAL
CC          write(6,1234) I,YO(I)
CC1234  FORMAT ('YO(',i5,') = ',F15.7)

          IF (I.EQ.1) THEN
             RMIN = YO(1)
             RMAX = RMIN
          ELSE
             RMIN   = AMIN1(RMIN,YO(I))
             RMAX   = AMAX1(RMAX,YO(I))
          ENDIF
C
C  update the loop start LL
C
CMvK       LL     = MH
          LL = ML
130   CONTINUE
C
C  Here is the end of REBMET
C
      RETURN
      END
C 
      SUBROUTINE REBPIX(JOP,NP,DX,DY,XA,XB,NPOI,DINCR,ISTA,IDIR,F)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C  Determine flux in fractions of pixel using various options JOP
C
C.INPUT
C JOP I*4 option
C NP      I*4 number of array elements DX,DY
C DX      R*8 independent array
C       DY      R*8     dependent array
C XA      R*8     lower boundary of area of interest
C       XB      R*8     upper boundary
C       NPOI    I*4     number of points for integration/interpolation
C                       to be used
C       DINCR   R*8     interval between succesive points NPOI
C       ISTA    I*4     start index or search loop in DX
C       IDIR    I*4     Direction of DX array (X(1) < X(2) => -1)
C
C.OUTPUT
C       F       R*4     intensity between XA and XB under DY = f(DX)
C
C -------------------------------------------------------------------
C
      IMPLICIT NONE
C 
      INTEGER JOP,NP,NPOI,ISTA,IDIR
C 
      REAL F
C 
      DOUBLE PRECISION DX(NP),DY(NP),XA,XB
      DOUBLE PRECISION DINCR
C
      F = 0.0
      GO TO (10,20,30),JOP
C 
C all other options goto linear interpolation
      GOTO 20
C
C  Spline interpolation and gaussian integration
C
10    CALL REBISP(NP,DX,DY,XA,XB,NPOI,DINCR,ISTA,IDIR,F)
      RETURN
C
C   Intensity is simply the corresponding proportion of the pixel's
C   intensity
20    F = DY(ISTA)* (XB-XA)
      RETURN
C
C  linear interpolation and integration
30    CALL REBLNR(NP,DX,DY,XA,XB,ISTA,IDIR,F)
      RETURN
C
      END

      SUBROUTINE REBISP(NP,DX,DY,XA,XB,NPOI,DINCR,IST,IDI,F)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C  F. Murtagh ST-ECF  Version 1.0 15-AUG-1985
C  M. Rosa      ST-ECF                  2.0     15-OCT-1985
C
C  Set up for REBIPL and integrate --> F
C
      IMPLICIT NONE
C 
      INTEGER I,NP,NPOI,IST,IDI,IFAIL,IS,ID,FLAG
      REAL F
      DOUBLE PRECISION DX(NP),DY(NP),XA,XB
      DOUBLE PRECISION VECI(10),VECD(10)
      DOUBLE PRECISION DINCR,DVAL,DER,XP
C
      IFAIL  = 0
      IS     = IST
      ID     = IDI
C
      XP     = XA
      FLAG=1
      CALL REBIPL(FLAG,XP,DVAL,DX,DY,NP,IS,ID)
      VECI(1) = XP
      VECD(1) = DVAL
C
      DO 10 I = 2,NPOI
          XP     = XP + DINCR
          FLAG=0
          CALL REBIPL(FLAG,XP,DVAL,DX,DY,NP,IS,ID)
          VECI(I) = XP
          VECD(I) = DVAL
   10 CONTINUE
C
      DVAL = 0
      DER = 0
      CALL FINDIFF(VECI,VECD,NPOI,DVAL,DER,IFAIL)
      F      = SNGL(DVAL)
      RETURN

      END

      SUBROUTINE REBIPL(FLAG,XP,P,X,F,N,IS,ID)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C Interpolate a function P at a given value XP using
C the table of values (X,F).
C Spline interpolation scheme based on Hermite polynomials.
C
C Ref.: U.S. Airforce Surveys in Geophysics, no.272
C       Publ of the Dominion Astrophys. Obs. 204, 1982
C
C.AUTHOR  J.D. PONZ (ESO)
C
C.MODIFIED  M. ROSA (STECF) 02-OCT-1985
C
C                 DOUBLE PRECISION calculation
C                 Stepping through X is always increasing X and XP
C                 All checking for validity range done outside
C                 Loop parameters IS (start) and ID (direction)
C           supplied from outside
C
C Arguments :
C XP      Input argument
C P Output interpolated value
C X Input vector of independent values
C F Input vector of dependent values
C N Input number of points in (X,F) vector
C       IS      Input   index of respective pixel
C       ID      Input   direction of X array
C
      IMPLICIT NONE
C 
      INTEGER N,IS,ID,KA,KZ,IRUN,I,FLAG
      DOUBLE PRECISION F(N),X(N)
      DOUBLE PRECISION XP,P
      DOUBLE PRECISION LP1,LP2,L1,L2,FP1,FP2,XPI1,XPI,L1S,L2S
      SAVE KA,KZ,IRUN,FP1,FP2,LP1,LP2
C
      IF (FLAG.EQ.1) THEN
      IF (ID.GT.0) THEN
          KA     = MAX0(IS-ID,1)
          KZ     = N

      ELSE
          KA     = MIN0(IS-ID,N)
          KZ     = 1
      END IF

      IRUN   = 0
      ENDIF
C
C
      DO 10 I = KA,KZ,ID
          IF (XP.LT.X(I)) GO TO 20
   10 CONTINUE
      P      = 10.**36
      RETURN
C
   20 I      = I - ID
      IF (I.EQ.KA-1 .AND. IRUN.NE.0) GO TO 30
      KA     = I + ID
      IRUN   = 1
      LP1    = 1./ (X(I)-X(I+1))
      LP2    = 1./ (X(I+1)-X(I))
C
      IF (I.EQ.1) THEN
          FP1    = (F(2)-F(1))/ (X(2)-X(1))

      ELSE
          FP1    = (F(I+1)-F(I-1))/ (X(I+1)-X(I-1))
      END IF
C
      IF (I.EQ.N-1) THEN
          FP2    = (F(N)-F(N-1))/ (X(N)-X(N-1))

      ELSE
          FP2    = (F(I+2)-F(I))/ (X(I+2)-X(I))
      END IF
C
   30 XPI1   = XP - X(I+1)
      XPI    = XP - X(I)
      L1     = XPI1*LP1
      L2     = XPI*LP2
      L1S    = L1*L1
      L2S    = L2*L2
      P      = F(I)* (1.D0-2.D0*LP1*XPI)*L1S +
     +         F(I+1)* (1.D0-2.D0*LP2*XPI1)*L2S + FP2*XPI1*L2S +
     +         FP1*XPI*L1S
C
      RETURN

      END

      SUBROUTINE REBFNC(NF,D,NPA,NPAC,PA)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.AUTHOR M.ROSA (STECF)  VERSION 1.0     02-OCT-1985
C        F.MURTAGH (STECF)              1.1     11-NOV-1985
C              (more options, check on existence)
C
C  Dummy routine to call the requested function f[NF]
C  Returns D[new] as f(D[old])
C
C  Functions:  1 LIN    D --> a + b*D
C              2 POL    D --> a + b*D + c*DD + ...
C              3 INV    D --> a + b/D
C              4 EXP    D --> a + b*exp(D*c)
C              5 DEX    D --> a + b*10.**(D*c)
C              6 LOG    D --> a + b*LOG(D*c)
C              7 DLG    D --> a + b*LOG10(D*c)
C              8 IPO    D --> a + b/(D-q) + c/((D-q)**2) + ...
C               where q = PA(NPAC) and a,b,c... = PA(1,2,...(NPAC-1))
C              9 U01    User defined function REBU01
C
      IMPLICIT NONE
C 
      INTEGER NF,NPA,NPAC
      DOUBLE PRECISION D,PA(NPA)
C
      GO TO (10,20,30,40,50,60,70,80,90) NF
C
      WRITE (*,*) ' Function not existent, sorry - look up manual '
      D      = 0.
      RETURN
C
   10 CALL REBLIN(D,PA,NPA,NPAC)
      RETURN

   20 CALL REBPOL(D,PA,NPA,NPAC)
      RETURN

   30 CALL REBINV(D,PA,NPA,NPAC)
      RETURN

   40 CALL REBEXP(D,PA,NPA,NPAC)
      RETURN

   50 CALL REBDEX(D,PA,NPA,NPAC)
      RETURN

   60 CALL REBLOG(D,PA,NPA,NPAC)
      RETURN

   70 CALL REBDLG(D,PA,NPA,NPAC)
      RETURN

   80 CALL REBIPO(D,PA,NPA,NPAC)
      RETURN

   90 CALL REBU01(D,PA,NPA,NPAC)
      RETURN
C
      END

      SUBROUTINE REBLIN(DV,P,NP,NPC)
      INTEGER NP,NPC
      DOUBLE PRECISION DV,P(NP)

      DV     = P(1) + P(2)*DV
      RETURN

      END
C
      SUBROUTINE REBPOL(DV,P,NP,NPC)
      INTEGER NP,NPC,I
      DOUBLE PRECISION DV,P(NP),VD  !MP 900117
      VD     = 0.0D0
      DO 10 I = NPC,1,-1
          VD     = VD*DV + P(I)
   10 CONTINUE
      DV     = VD
      RETURN

      END
C
      SUBROUTINE REBINV(DV,P,NP,NPC)
      INTEGER NP,NPC
      DOUBLE PRECISION DV,P(NP)

      DV     = P(1) + P(2)/DV
      RETURN

      END
C
      SUBROUTINE REBEXP(DV,P,NP,NPC)
      INTEGER NP,NPC
      DOUBLE PRECISION DV,P(NP)

      DV     = P(1) + P(2)*EXP(DV*P(3))
      RETURN

      END
C
      SUBROUTINE REBDEX(DV,P,NP,NPC)
      INTEGER NP,NPC
      DOUBLE PRECISION DV,P(NP)

      DV     = P(1) + P(2)*10.0D0** (DV*P(3))
      RETURN

      END
C
      SUBROUTINE REBLOG(DV,P,NP,NPC)
      INTEGER NP,NPC
      DOUBLE PRECISION DV,P(NP)

      DV     = P(1) + P(2)*LOG(DV*P(3))
      RETURN

      END
C
      SUBROUTINE REBDLG(DV,P,NP,NPC)
      INTEGER NP,NPC
      DOUBLE PRECISION DV,P(NP)

      DV     = P(1) + P(2)*LOG10(DV*P(3))
      RETURN

      END
C
      SUBROUTINE REBIPO(DV,P,NP,NPC)
C
C INVERSE POLYNOMIAL WITH OFFSET
C Implement the PRISM formula for dispersion relations
C
C y = a + bz + cz**2 + dz**3 + .... P(npc-1)z**(npc-1)
C
C where z = x - p(npc)
C
      INTEGER NP,NPC,I
      DOUBLE PRECISION P(NP),DV,VD

      VD     = 0.0D0
      DV     = 1./ (DV-P(NPC))
      IF (NPC.EQ.1) RETURN
      DO 10 I = NPC - 1,1,-1
          VD     = VD*DV + P(I)
   10 CONTINUE
      DV     = VD
      RETURN

      END
C

      SUBROUTINE REBLNR(NP,DX,DY,XA,XB,ISTA,IDIR,F)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C   Subroutine linear
C
C   F. Murtagh   ST-ECF  Version 1.0 17-Oct-1985
C
C   linear interpolation and subsequent integration.
C
C.INPUT
C  NP I*4 Number of array elements DX, DY
C  DX R*8 Independent array
C DY R*8 Dependent array
C XA R*8 Lower boundary of area of interest
C XB R*8 Upper boundary
C ISTA I*4 Start index for search loop in DX;
C   index number of pixel in which both
C   XA and XB are located
C IDIR I*4 Direction of DX array (X(1) < X(2) => -1)
C
C.OUTPUT
C F R*4 Intensity between XA and XB under DY = f(DX)
C
C------------------------------------------------------------------
      INTEGER NP,ISTA,IDIR
      REAL F,YA,YB,XLIN
      DOUBLE PRECISION DX(NP),DY(NP),XA,XB
      DOUBLE PRECISION X,Y,X2,Y2
C
C For convenience:
      X      = DX(ISTA)
      Y      = DY(ISTA)
C
C Four cases arise: XA or XB = X; otherwise, XA and XB are on the same
C side of the pixel-centre, or they are on different sides.
      IF (XA.EQ.X) THEN
          IF (XB-X.GE.0) THEN
              Y2     = DY(ISTA+IDIR)
              X2     = DX(ISTA+IDIR)

          ELSE
              Y2     = DY(ISTA-IDIR)
              X2     = DX(ISTA-IDIR)
          END IF

          YB     = XLIN(Y2,Y,X,XB,X2)
          F      = ABS(X-XB)* (Y+YB)/2.

      ELSE IF (XB.EQ.X) THEN
          IF (XA-X.GE.0) THEN
              Y2     = DY(ISTA+IDIR)
              X2     = DX(ISTA+IDIR)

          ELSE
              Y2     = DY(ISTA-IDIR)
              X2     = DX(ISTA-IDIR)
          END IF

          YA     = XLIN(Y2,Y,X,XA,X2)
          F      = ABS(X-XA)* (Y+YA)/2.

      ELSE IF (((XA-X)/ (XB-X)).GT.0) THEN
C       (If XA and XB are both on the same side of the pixel-centre,
C       we get num. and denom. both of same sign, hence above is true:
          IF (XA-X.GT.0) THEN
              Y2     = DY(ISTA+IDIR)
              X2     = DX(ISTA+IDIR)

          ELSE
              Y2     = DY(ISTA-IDIR)
              X2     = DX(ISTA-IDIR)
          END IF

          YA     = XLIN(Y2,Y,X,XA,X2)
          YB     = XLIN(Y2,Y,X,XB,X2)
          F      = (XB-XA)* (YA+YB)/2.

      ELSE IF (((XA-X)/ (XB-X)).LE.0) THEN
          IF (XA-X.GT.0) THEN
              YA     = XLIN(DY(ISTA+IDIR),Y,X,XA,DX(ISTA+IDIR))
              YB     = XLIN(DY(ISTA-IDIR),Y,X,XB,DX(ISTA-IDIR))

          ELSE
              YA     = XLIN(DY(ISTA-IDIR),Y,X,XA,DX(ISTA-IDIR))
              YB     = XLIN(DY(ISTA+IDIR),Y,X,XB,DX(ISTA+IDIR))
          END IF

          F      = ABS(X-XA)* (Y+YA)/2. + ABS(X-XB)* (Y+YB)/2.
      END IF
C
      RETURN

      END

      REAL FUNCTION XLIN(Y2,Y1,X1,X,X2)
C
C Function which returns linearly interpolated value corresponding to
C X, where we have X1 <= X <= X2 or vice versa, and Y1 = f(X1) and
C Y2 = f(X2).
C
      DOUBLE PRECISION Y1,Y2,X,X1,X2
C
      XLIN   = (Y2-Y1)* (X-X1)/ (X2-X1) + Y1
C
      END

      SUBROUTINE FINDIFF(X,Y,N,INT,ERR,IFAIL)
C       This subroutine integrates a function which is specified numerically
C       at four or more points, using third-order finite-difference formulae 
C       according to a method due to Gill and Miller. (Computer Journal 15,
C       page 80-83,1972).
C       Author: Michele Peron, ESO-IPG. August 1990



        INTEGER N,I,J,K,IFAIL
        DOUBLE PRECISION X(N),Y(N),INT,ERR,E,H1,H2,H3,H4,R1,R2,R3,R4
        DOUBLE PRECISION D1,D2,D3,C,S,H3S
        IFAIL = 0
        J  = 3
        K  =  N-1
        ERR = 0
        E = 0
        INT=0
        H1 = 0
        H2 = 0
        H3 = 0
        H4 = 0
        R1 = 0
        R2 =0
        R3 = 0
        R4 = 0
        D1  = 0
        D2 = 0
        D3 = 0
        C = 0
        S = 0
        DO 10 I=J,K
         IF (I.EQ.J) THEN        
             H2 = X(J-1)-X(J-2)
             D3 = (Y(J-1)-Y(J-2))/H2
             H3 = X(J)-X(J-1)
             D1  = (Y(J)-Y(J-1))/H3
             H1 = H2+H3
             D2 = (D1-D3)/H1
             H4 = X(J+1)-X(J)
             R1 = (Y(J+1)-Y(J))/H4
             R2 = (R1-D1)/(H4+H3)
             H1 = H1+H4
             R3 = (R2-D2)/H1
             INT = H2*(Y(1)+H2*(D3/2.0-H2*
     1               (D2/6.-(H2+2.*H3)*R3/12.)))
             S  = -H2**3*(H2*(3.*H2+5.*H4)+10.*H3*H1)/60.
         ELSE
             H4 = X(I+1)-X(I)
             R1 = (Y(I+1)-Y(I))/H4
             R4 = H4+H3
             R2 = (R1-D1)/R4
             R4 = R4+H2
             R3 = (R2-D2)/R4
             R4 = R4+H1
             R4 = (R3-D3)/R4
         ENDIF
         H3S = H3**2
        INT = INT+H3*((Y(I)+Y(I-1))/2.-H3S*
     1         (D2+R2+(H2-H4)*R3)/12.)
        C = H3*H3S*(2.*H3S+5.*(H3*(H4+H2)+
     2             2.*H4*H2))/120.
        E = E+(C+S)*R4
        IF (I.EQ.J) THEN 
           S = 2*C+S
        ELSE
           S = C
        ENDIF
        IF (I.EQ.K) THEN
            INT = INT+H4*(Y(N)-H4*(R1/2.+H4*(R2/6.+
     1                (2.*H3+H4)*R3/12.)))
            E = E-H4**3*R4*(H4*(3.*H4+5.*H2)+10.
     2            *H3*(H2+H3+H4))/60. 
            E = E+S*R4
        ELSE
            H1 = H2
            H2 = H3
            H3 = H4
            D1 = R1
            D2 = R2
            D3 = R3
        ENDIF
10      CONTINUE
        ERR = E
        INT = INT+E
        END
           

C @(#)smosub3.for	13.1.1.1 (ESO-DMD) 06/02/98 18:11:31
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE NORMIT(A,NDIM)
C
      IMPLICIT NONE
C
      INTEGER  NDIM,N
      REAL     A(NDIM),R
      DOUBLE PRECISION   SUM,DR
C
      SUM = 0.D0
      DO 1000, N=1,NDIM
         SUM = SUM + A(N)
1000  CONTINUE
C 
      IF (SUM.GT.10.D-20) THEN
         DR = 1.D0 / SUM
         R = SNGL(DR)
         DO 2000, N=1,NDIM
            A(N) = A(N) * R
2000     CONTINUE
      ENDIF
C 
      RETURN
      END

      SUBROUTINE TEMPLB(FLAG,A,B,NPIX,WEITS,RADIUS,CUTS,STAT)
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C	
C.IDENTIFICATION
C  subroutine TEMPLB			version 1.50	860610
C  K. Banse				ESO - Garching
C
C.KEYWORDS
C  template matching, neighbourhood
C
C.PURPOSE
C replace pixels by weighted sum of nw*nw matrix (nw = 2*radius + 1)
C
C.ALGORITHM
C  filter image by taking the weighted sum W(x,y) of all points in neighbourhood
C  of x,y with given radius, and replace original value I(x,y) by W(x,y)
C	
C.INPUT/OUTPUT
C  call as TEMPLATE(A,B,NPIX,WEITS,RADIUS,STAT)
C
C input par:
C  FLAG:	I*4 		function flag:
C				= 1 for Gauss filter
C				= 2 for digital filter
C				= 3 for max filter
C				= 4 for min filter
C  A:		R*4 array	input array
C  B:		R*4 array	output array
C  NPIX:	I*4 array	no. of pixels per line, no. of lines
C  WEITS:	R*4 array	weights for NWX*NWY matrix, ordered as
C				1 2 3 ... NWX
C				NWX+1 ... 2NWX
C				............
C				(NWY-1)*NWX+1 ... NWX*NWY
C  RADIUS:	I*4 array	radius of template matrix in x,y
C	
C  output par:
C  CUTS:	R*4 array	cut values of result frame
C  STAT:	I*4		return status, should be = 0, else problems...
C	
C --------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER     FLAG,NPIX(*),RADIUS(*)
      INTEGER     NX,NY,DIAMX,DIAMY,RADYNX
      INTEGER     N,NP,NL,BINDX,STAT
      INTEGER     WINDX,OFFSET,OFF
      INTEGER     NRDXP1,RADXP1,NXRADX,LEFT
C
      REAL        A(*),B(*),WEITS(*),CUTS(*)
      REAL        TEST
C 
      DOUBLE PRECISION  DTEST
C
C  init variables + test size of template
      BINDX = 1                                !index for frame B
      NX = NPIX(1)
      NY = NPIX(2)
      DIAMX = RADIUS(1) * 2
      DIAMY = RADIUS(2) * 2
      IF ((DIAMX.GE.NX).OR.(DIAMY.GE.NY)) THEN        !data matrix at least NW
         STAT = 1
         RETURN
      ELSE
         STAT = 0
      ENDIF
C
      RADYNX = RADIUS(2) * NX                  !all following constants for
      RADXP1 = RADIUS(1) + 1                   !speed reasons...
      NXRADX = NX - RADIUS(1)
      NRDXP1 = NXRADX + 1
      LEFT = RADYNX + RADIUS(1)            !lower left corner of template matrix
      OFFSET = RADYNX
C
C  branch according to filter type
      IF (FLAG.GE.3) GOTO 5000
C
C*******
C
C  main loop over inner lines
C
C*******
C
      DO 2000, NL=RADIUS(2)+1,NY-RADIUS(2)            !step through each line
C
C  step through each pixel of data frame
C  i.e., OFFSET+RADIUS(1)+1  >>>  OFF SET+NX-RADIUS(1)
C 
         DO 1500, NP=OFFSET+RADXP1,OFFSET+NXRADX 
            DTEST = 0.D0                              !clear sum
            WINDX = 1                                !index for weight matrix
C
C  sum + weigh inner part
            DO 1000, OFF=NP-LEFT,NP+LEFT,NX        !step through lines of window
               DO 800, N=OFF,OFF+DIAMX
                  DTEST = DTEST + ( A(N) * WEITS(WINDX) )
                  WINDX = WINDX + 1
800            CONTINUE
1000        CONTINUE
C
            B(BINDX) = DTEST                     !fill output frame
            BINDX = BINDX + 1
1500     CONTINUE
C
C  update main offset
         OFFSET = OFFSET + NX
C
2000  CONTINUE
C
C finally update the cuts
      CALL CHCUTS(B,BINDX,CUTS)
      RETURN
C
C  here for min/max filter
C 
5000  IF (FLAG.EQ.3) THEN
C 
C  max filter
         DO 7000, NL=RADIUS(2)+1,NY-RADIUS(2)            !step through each line
C
C  step through each pixel of data frame
C  i.e., OFFSET+RADIUS(1)+1  >>>  OFF SET+NX-RADIUS(1)
C
            DO 6000, NP=OFFSET+RADXP1,OFFSET+NXRADX
               TEST = A(NP-LEFT)                        !take lower left pixel
C
C  find max in inner part
               DO 5500, OFF=NP-LEFT,NP+LEFT,NX    
                  DO 5400, N=OFF,OFF+DIAMX
                     IF (A(N).GT.TEST) TEST = A(N)
5400              CONTINUE
5500           CONTINUE
C
               B(BINDX) = TEST                     !fill output frame
               BINDX = BINDX + 1
6000        CONTINUE
C
            OFFSET = OFFSET + NX                   !update main offset
7000     CONTINUE
C 
      ELSE
C 
C  min filter
         DO 9000, NL=RADIUS(2)+1,NY-RADIUS(2)            !step through each line
C
C  step through each pixel of data frame
C  i.e., OFFSET+RADIUS(1)+1  >>>  OFF SET+NX-RADIUS(1)
C
            DO 8800, NP=OFFSET+RADXP1,OFFSET+NXRADX
               TEST = A(NP-LEFT)                        !take lower left pixel
C
C  find min in inner part
               DO 8600, OFF=NP-LEFT,NP+LEFT,NX   
                  DO 8400, N=OFF,OFF+DIAMX
                     IF (A(N).LT.TEST) TEST = A(N)
8400              CONTINUE
8600           CONTINUE
C
               B(BINDX) = TEST                     !fill output frame
               BINDX = BINDX + 1
8800        CONTINUE
C
            OFFSET = OFFSET + NX                   !update main offset
9000     CONTINUE
      ENDIF
C
C finally update the cuts
      CALL CHCUTS(B,BINDX,CUTS)
      RETURN
C
      END

      SUBROUTINE CHCUTS(A,ASZ1,CUTS)
C 
      INTEGER     ASZ1
      INTEGER     N,NDIM
C 
      REAL        A(*),CUTS(*)
      REAL        TEST
C 
      NDIM = ASZ1 - 1
      IF (NDIM.LT.3) RETURN
C 
      IF (A(1).GT.A(2)) THEN
         CUTS(1) = A(2)
         CUTS(2) = A(1)
      ELSE
         CUTS(1) = A(1)
         CUTS(2) = A(2)
      ENDIF
C 
      DO 1000, N=3,NDIM
         TEST = A(N)
         IF (TEST.LT.CUTS(1)) THEN
            CUTS(1) = TEST
         ELSE IF (TEST.GT.CUTS(2)) THEN
            CUTS(2) = TEST
         ENDIF
1000  CONTINUE
C 
      RETURN
      END

      SUBROUTINE EXPAX(IMNOA,OFFPIX,OUTFR,INBUF,RSTAT)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine EXPX
C  K. Banse				ESO - Garching
C  1.00    910517
C
C.KEYWORDS
C  border regions
C
C.PURPOSE
C  expand image by duplicating border lines + columns
C
C.ALGORITHM
C  get the no. of columns to expand at left + at right
C  get the no. of lines to expand in the beginning + end
C  flip columns in x, lines in y and add to image
C
C.INPUT/OUTPUT
C  call via
C   EXPAX(IMNOA,OFFPIX,OUTFR,INBUF,RSTAT)
C
C  input par:
C  IMNOA	integer         file no. of input frame
C  OFFPIX	integer		offset for 1. pixel to map
C  OUTFR	char. array	output frame
C  INBUF	integer array	xl,xr,yb,ye: no. of cols (left/right)
C					     no. of lines (beginning/end)
C  output par:
C  RSTAT	integer         return status, 0 = o.k.
C
C.VERSIONS
C  1.00   creation
C	
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      INBUF(4),RSTAT,OFFPIX
      INTEGER      IAV,N,NN,LOOPLM,RMAIND,CHUNKI,CHUNKO
      INTEGER      NAXISA,MOFF,LOFF,NOLIN
      INTEGER*8    PNTRX,PNTRY
      INTEGER      IMNOA,IMNOC,IMNOX,IMNOY
      INTEGER      TRUSIZ,SIZE,STAT
      INTEGER      NPIXA(2),NPIXC(2)
      INTEGER      UNI(1),NULO,MADRID(1)
C
      CHARACTER*(*) OUTFR
      CHARACTER    CUNITA*64,IDENTA*72
C 
      REAL         CUTVAL(4)
C
      DOUBLE PRECISION    STEPA(2),STARTA(2)
      DOUBLE PRECISION    STARTC(2)
C
      COMMON  /VMR/  MADRID
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      DATA    NPIXA  /1,1/,   NPIXC /1,1/
      DATA    STARTA /0.0,0.0/,  STEPA  /1.0,1.0/
      DATA    CUNITA /' '/,   IDENTA /' '/
C 
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C 
      RSTAT = 0
      CALL STDRDI(IMNOA,'NAXIS',1,1,IAV,NAXISA,UNI,NULO,STAT)
      IF (NAXISA.GT.2) NAXISA = 2                                !max 2-dim 
      CALL STDRDI(IMNOA,'NPIX',1,NAXISA,IAV,NPIXA,UNI,NULO,STAT)
      CALL STDRDD(IMNOA,'START',1,NAXISA,IAV,STARTA,UNI,NULO,STAT)
      CALL STDRDD(IMNOA,'STEP',1,NAXISA,IAV,STEPA,UNI,NULO,STAT)
      CALL STDRDC(IMNOA,'IDENT',1,1,72,IAV,IDENTA,UNI,NULO,STAT)
      N = (NAXISA+1) * 16
      CALL STDRDC(IMNOA,'CUNIT',1,1,N,IAV,CUNITA,UNI,NULO,STAT)
      CALL STDRDR(IMNOA,'LHCUTS',1,4,IAV,CUTVAL,UNI,NULO,STAT)
C
C  get size of input + output frame
      SIZE = NPIXA(1) * NPIXA(2)
      IF ( (INBUF(1).GT.NPIXA(1)) .OR.
     +     (INBUF(2).GT.NPIXA(1)) .OR.
     +     (INBUF(1).LT.0) .OR.
     +     (INBUF(2).LT.0) ) THEN
         RSTAT = 1
         RETURN
      ENDIF
C 
      NPIXC(1) = NPIXA(1) + INBUF(1) + INBUF(2)
      IF (NAXISA.GT.1) THEN
         IF ( (INBUF(3).GT.NPIXA(2)) .OR.
     +        (INBUF(4).GT.NPIXA(2)) .OR.
     +        (INBUF(3).LT.0) .OR.
     +        (INBUF(4).LT.0) ) THEN
            RSTAT = 2
            RETURN
         ENDIF
         NPIXC(2) = NPIXA(2) + INBUF(3) + INBUF(4)
      ENDIF
C
C create result frame
      IF (OFFPIX.LE.0) THEN
         TRUSIZ = NPIXC(1) * NPIXC(2)
         CALL STFCRE(OUTFR,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +               TRUSIZ,IMNOC,STAT)
C 
         CALL STDWRI(IMNOC,'NAXIS',NAXISA,1,1,UNI,STAT)
         CALL STDWRI(IMNOC,'NPIX',NPIXC,1,NAXISA,UNI,STAT)
         STARTC(1) = STARTA(1) - (INBUF(1)*STEPA(1))
         IF (NAXISA.GT.1)
     +      STARTC(2) = STARTA(2) - (INBUF(3)*STEPA(2))
         CALL STDWRD(IMNOC,'START',STARTC,1,NAXISA,UNI,STAT)
         CALL STDWRD(IMNOC,'STEP',STEPA,1,NAXISA,UNI,STAT)
         CALL STDWRC(IMNOC,'IDENT',1,IDENTA,1,72,UNI,STAT)
         N = (NAXISA+1) * 16
         CALL STDWRC(IMNOC,'CUNIT',1,CUNITA,1,N,UNI,STAT)
         CALL STDWRR(IMNOC,'LHCUTS',CUTVAL,1,4,UNI,STAT)
      ELSE
         CALL STFOPN(OUTFR,D_R4_FORMAT,0,F_IMA_TYPE,IMNOC,STAT)
      ENDIF
C 
C  get buffersize of at least one line but no more than total size
      NN = 40000                                !first guess ...
      IF (NN.LT.NPIXA(1)) NN = NPIXA(1)
      IF (NN.GT.SIZE) NN = SIZE
      NOLIN = NN / NPIXA(1)                     !buffer = NOLIN * NPIXA(1)
      CHUNKI = NOLIN * NPIXA(1)
      CHUNKO = NOLIN * NPIXC(1)
      IF (NAXISA.GT.1) THEN
         LOOPLM = NPIXA(2) / NOLIN              !get no. of passes through loop
         RMAIND = NPIXA(2) - (LOOPLM*NOLIN)     !and remainder
      ELSE
         LOOPLM = 1
         RMAIND = 0
      ENDIF
C 
      CALL STFCRE('expaxi',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +            CHUNKI,IMNOX,STAT)
      CALL STFMAP(IMNOX,F_X_MODE,1,CHUNKI,IAV,PNTRX,STAT)
      CALL STFCRE('expaxo',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +            CHUNKO,IMNOY,STAT)
      CALL STFMAP(IMNOY,F_X_MODE,1,CHUNKO,IAV,PNTRY,STAT)
C 
C  now we loop through input frame
      MOFF = 1 + OFFPIX                        !point to 1. pixel in input fr.
      IF (NAXISA.GT.1) THEN                    !point to 1. pixel in output fr.
         LOFF = (INBUF(3)*NPIXC(1)) + 1       
      ELSE
         LOFF = 1
      ENDIF
C 
      DO 2000, N=1,LOOPLM
         CALL STFGET(IMNOA,MOFF,CHUNKI,IAV,MADRID(PNTRX),STAT)    !data in
         CALL EXPA1(MADRID(PNTRX),MADRID(PNTRY),NOLIN,NPIXA(1),
     +              NPIXC(1),INBUF)
         CALL STFPUT(IMNOC,LOFF,CHUNKO,MADRID(PNTRY),STAT)          !data out
         MOFF = MOFF + CHUNKI
         LOFF = LOFF + CHUNKO
2000  CONTINUE
C 
      IF (RMAIND.GT.0) THEN
         CHUNKI = RMAIND * NPIXA(1)
         CHUNKO = RMAIND * NPIXC(1)
         CALL STFGET(IMNOA,MOFF,CHUNKI,IAV,MADRID(PNTRX),STAT) 
         CALL EXPA1(MADRID(PNTRX),MADRID(PNTRY),RMAIND,NPIXA(1),
     +              NPIXC(1),INBUF)
         CALL STFPUT(IMNOC,LOFF,CHUNKO,MADRID(PNTRY),STAT)  
      ENDIF
C 
C  for 1-dim frames we are finished
      CALL STFCLO(IMNOX,STAT)
      CALL STFCLO(IMNOY,STAT)
      IF (NAXISA.EQ.1) GOTO 8000
C 
C  get buffersize of INBUF(3/4)*2 lines
      IF (INBUF(3).GE.INBUF(4)) THEN
         NN = INBUF(3)
      ELSE
         NN = INBUF(4)
      ENDIF
      IF (NN.EQ.0) GOTO 8000                !nothing to do in Y
C 
      NN = (2*NN + 1) * NPIXC(1)
      CALL STFCRE('expaxz',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +            NN,IMNOX,STAT)
      CALL STFMAP(IMNOX,F_X_MODE,1,NN,IAV,PNTRX,STAT)
C  
      NN = 2*INBUF(3) + 1
      CHUNKI = NN * NPIXC(1)
      IF (CHUNKI.GT.0) THEN
         CALL STFGET(IMNOC,1,CHUNKI,IAV,MADRID(PNTRX),STAT) 
         CALL EXPA2(1,MADRID(PNTRX),NPIXC,INBUF(3))
         CALL STFPUT(IMNOC,1,CHUNKI,MADRID(PNTRX),STAT)  
      ENDIF
C  
      NN = 2*INBUF(4) + 1
      CHUNKI = NN * NPIXC(1)
      IF (CHUNKI.GT.0) THEN
         MOFF = ((NPIXC(2)-NN)*NPIXC(1)) + 1
         CALL STFGET(IMNOC,MOFF,CHUNKI,IAV,MADRID(PNTRX),STAT) 
         CALL EXPA2(2,MADRID(PNTRX),NPIXC,INBUF(4))
         CALL STFPUT(IMNOC,MOFF,CHUNKI,MADRID(PNTRX),STAT)  
      ENDIF
      CALL STFCLO(IMNOX,STAT)
C 
8000  CALL STFCLO(IMNOC,STAT)
      RETURN
C 
      END

      SUBROUTINE EXPA1(X,Y,NOLIN,NPIXA,NPIXC,INBUF)
C 
      IMPLICIT NONE
C 
      REAL     X(*),Y(*)
C 
      INTEGER  NOLIN,NPIXA,NPIXC,INBUF(*)
      INTEGER  N,NN,IDX,KDX,IOFF,KOFF
C 
C  loop over all lines
      IOFF = 0
      KOFF = 0
      DO 5000, NN=1,NOLIN
C 
C fill first Y pixels with first flipped X pixels
         IF (INBUF(1).GT.0) THEN
            IDX = 1 + IOFF
            KDX = INBUF(1) + KOFF + 1
            DO 1000, N=1,INBUF(1)
               Y(IDX) = X(KDX)
               IDX = IDX + 1
               KDX = KDX - 1
1000        CONTINUE
         ELSE
            IDX = 1 + IOFF
            KDX = 1 + KOFF
         ENDIF
C 
C copy center Y pixels from all X pixels
         DO 2000, N=1,NPIXA
            Y(IDX) = X(KDX)
            IDX = IDX + 1
            KDX = KDX + 1
2000     CONTINUE
C 
C fill last Y pixels with last flipped X pixels
         KDX = KDX - 1
         IF (INBUF(2).GT.0) THEN
            DO 3000, N=1,INBUF(2)
               KDX = KDX - 1
               Y(IDX) = X(KDX)
               IDX = IDX + 1
3000        CONTINUE
         ENDIF
C 
         IOFF = IOFF + NPIXC
         KOFF = KOFF + NPIXA
5000  CONTINUE
C 
      RETURN
      END

      SUBROUTINE EXPA2(FLAG,X,NPIXC,INB)
C 
      IMPLICIT NONE
C 
      REAL     X(*)
C 
      INTEGER  FLAG,NPIXC(*),INB
      INTEGER  N,NN,IDX,KDX,IOFF,KOFF,MX,MMX
C 
      MX = NPIXC(1)
C 
      IF (FLAG.EQ.1) THEN
         IOFF = 0
         KOFF = 2*INB * MX
         MMX = MX
      ELSE
         IOFF = 2*INB * MX
         KOFF = 0
         MMX = -MX
      ENDIF
C 
      DO 2000, NN=1,INB
         IDX = IOFF + 1
         KDX = KOFF + 1
         DO 1000, N=1,MX
            X(IDX) = X(KDX)
            IDX = IDX + 1
            KDX = KDX + 1
1000     CONTINUE
C 
         IOFF = IOFF + MMX
         KOFF = KOFF - MMX
2000  CONTINUE
C 
      RETURN
      END

      SUBROUTINE SORTIT(RA,N,NH,LL)
C 
C  N  = full dimension of RA
C  NH = index of median - we only sort fully until NH
C  then we insert
C 
C  this is the Heapsort algorithm from "Numerical Recipes", page 231
C 
      IMPLICIT NONE
C 
      INTEGER   N,NH,LL
      INTEGER   L,IR,J,I
      INTEGER   JL,JU,JM,M
C 
      REAL      RA(N),RRA
C 
      L = LL                      !that is L = NH/2 + 1  
      IR = NH
C 
10    IF (L.GT.1) THEN            !still hiring
         L = L - 1
         RRA = RA(L)
      ELSE                        !in retirement + promotion phase
         RRA = RA(IR)             !clear a space at end of array
         RA(IR) = RA(1)           !retire the top of the heap into it
         IR = IR - 1           !decrease the size of the corporation
         IF (IR.EQ.1) THEN        !done with last promotion
            RA(1) = RRA           !the least competent guy of all...
            GOTO 1000             !now move to insertion part
         ELSE
         ENDIF
      ENDIF
C 
      I = L                       !in hiring as well as in promotion phase
      J = L + L              !we here set up to sift down RRA to its right level
C 
20    IF (J.LE.IR) THEN           !"Do while J<=IR"
         IF (J.LT.IR) THEN
            IF (RA(J).LT.RA(J+1)) J = J + 1   !compare to the better underling
         ENDIF
         IF (RRA.LT.RA(J)) THEN   !demote RRA
            RA(I) = RA(J)
            I = J
            J = J + J
         ELSE
            J = IR + 1
         ENDIF
         GOTO 20
      ENDIF
C 
      RA(I) = RRA                 !put RRA into its slot
      GOTO 10
C 
C 
1000  I = NH + 1
      DO 2000 L=I,N
         IF (RA(L).LT.RA(NH)) THEN
            RRA = RA(L)
            JL = 0
            JU = I
C 
1010        JM = (JU+JL) / 2
            IF (RRA.LT.RA(JM)) THEN
               JU = JM
            ELSE
               JL = JM
            ENDIF
            IF ((JU-JL).GT.1) GOTO 1010               !loop
C 
CC            DO 1100 M=L,JL+2,-1          !RA kept intact
            DO 1100 M=NH,JL+2,-1           !ojo - RA not kept intact that way!
               RA(M) = RA(M-1)             !but faster
1100        CONTINUE
            RA(JL+1) = RRA
         ENDIF
2000  CONTINUE
C 
      RETURN
      END

      SUBROUTINE XSORT1(RA,NDIM,NH,RINDX)
C 
C  RA  = real array of which the elements were used for sorting INDARR
C  NDIM  = full dimension of RA
C  NH = index of median - we only sort fully until NH
C  then we insert
C 
C  this is the Heapsort algorithm from "Numerical Recipes", page 233
C 
      IMPLICIT NONE
C 
      PARAMETER (IXXSIZ = 25000)
C 
      INTEGER   NDIM,NH,RINDX
      INTEGER   L,IR,J,I
      INTEGER   INDXT
C 
      INTEGER   INDARR(IXXSIZ),BACKAR(IXXSIZ),SAVARR(IXXSIZ)
      COMMON    /TMPARR/  INDARR,BACKAR,SAVARR
C 
      REAL      RA(NDIM),RRA
C 
      DO 5, J=1,NDIM
         INDARR(J) = J
5     CONTINUE
C 
      L = NDIM/2 + 1
      IR = NDIM
C 
10    IF (L.GT.1) THEN            !still hiring
         L = L - 1
         INDXT = INDARR(L)
         RRA = RA(INDXT)
      ELSE                        !in retirement + promotion phase
         INDXT = INDARR(IR)
         RRA = RA(INDXT)          !clear a space at end of array
         INDARR(IR) = INDARR(1)   !retire the top of the heap into it
         IR = IR - 1              !decrease the size of the corporation
         IF (IR.EQ.1) THEN        !done with last promotion
            INDARR(1) = INDXT     !the least competent guy of all...
            GOTO 1000
         ENDIF
      ENDIF
C 
      I = L                 !in hiring as well as in promotion phase
      J = L + L             !we here set up to sift down RRA to its right level
C 
20    IF (J.LE.IR) THEN                    !"Do while J<=IR"
         IF (J.LT.IR) THEN
            IF (RA(INDARR(J)).LT.RA(INDARR(J+1)))
     +         J = J + 1                   !compare to the better underling
         ENDIF
         IF (RRA.LT.RA(INDARR(J))) THEN    !demote RRA
            INDARR(I) = INDARR(J)
            I = J
            J = J + J
         ELSE
            J = IR + 1
         ENDIF
         GOTO 20
      ENDIF
C 
      INDARR(I) = INDXT                 !put RRA into its slot
      GOTO 10
C
1000  DO 4000, J=1,NDIM                 !set up the back index array
         BACKAR(INDARR(J)) = J
4000  CONTINUE
C 
      RINDX = INDARR(NH)
C 
      RETURN
      END

      SUBROUTINE XSORT2(RA,NDIM,NH,JWOFF,NEWRA,XSIZE,NCOUNT,RINDX)
C 
C  RA  = real array of which the elements were used for sorting INDARR
C  NDIM  = full dimension of RA
C  NH = index of median - we only sorted fully until NH then we inserted
C  IOFF = index of RA element in question
C  INDARR = semi sorted index array from last sorting of RA
C 
C 
      IMPLICIT NONE
C 
      PARAMETER (IXXSIZ = 25000)
C 
      INTEGER   NDIM,NH,JWOFF,XSIZE,NCOUNT,RINDX
      INTEGER   IOFF,INDXT,JL,JU,JM,M,N
C 
      INTEGER   INDARR(IXXSIZ),BACKAR(IXXSIZ),SAVARR(IXXSIZ)
      COMMON    /TMPARR/  INDARR,BACKAR,SAVARR
C 
      REAL      RA(NDIM),NEWRA(NCOUNT)
      REAL      NEWR,QR
C 
      IOFF = JWOFF
C 
      DO 5000, N=1,NCOUNT
C 
         NEWR = NEWRA(N) 
         RA(IOFF) = NEWR               !new value
         INDXT = BACKAR(IOFF)
C 
         IF (INDXT.EQ.1) THEN
            IF (NEWR.LE.RA(INDARR(2)))             !it stays very first
     +         GOTO 4900
         ELSE
            IF (NEWR.LE.RA(INDARR(1))) THEN        !it's very first
               DO 1000, M=INDXT,2,-1               !remove old entry
                  INDARR(M) = INDARR(M-1)          !by shifting up
                  BACKAR(INDARR(M)) = M
1000           CONTINUE
               INDARR(1) = IOFF 
               BACKAR(IOFF) = 1
               GOTO 4900
            ENDIF
         ENDIF
C 
         IF (INDXT.EQ.NDIM) THEN
            IF (NEWR.GE.RA(INDARR(NDIM-1)))        !it stays very last
     +         GOTO 4900
         ELSE
            IF (NEWR.GE.RA(INDARR(NDIM))) THEN     !it very last
               DO 2000, M=INDXT,NDIM-1             !remove old entry
                  INDARR(M) = INDARR(M+1)          !by shifting down
                  BACKAR(INDARR(M)) = M
2000           CONTINUE
               INDARR(NDIM) = IOFF
               BACKAR(IOFF) = NDIM
               GOTO 4900
            ENDIF
         ENDIF
C 
         IF (INDXT.EQ.1) THEN
            QR = NEWR - 1.0                        !so we satisy following test
         ELSE
            QR = RA(INDARR(INDXT-1))
         ENDIF
C 
         IF (NEWR.GT.QR) THEN                      !INDXT = 1 also done here...
            IF (NEWR.LE.RA(INDARR(INDXT+1))) GOTO 4900
            JL = INDXT
            JU = NDIM + 1
C
2010        JM = (JU+JL) / 2
            IF (NEWR.LT.RA(INDARR(JM))) THEN
               JU = JM
            ELSE
               JL = JM
            ENDIF
            IF ((JU-JL).GT.1) GOTO 2010          !loop
C
            DO 2100, M=INDXT,JL-1
               INDARR(M) = INDARR(M+1)
               BACKAR(INDARR(M)) = M
2100        CONTINUE
            INDARR(JL) = IOFF
            BACKAR(IOFF) = JL 
C            
         ELSE IF (NEWR.LT.QR) THEN
            JL = 0
            JU = INDXT
C
3010        JM = (JU+JL) / 2
            IF (NEWR.LT.RA(INDARR(JM))) THEN
               JU = JM
            ELSE
               JL = JM
            ENDIF
            IF ((JU-JL).GT.1) GOTO 3010          !loop
C
            DO 3100, M=INDXT,JL+2,-1
               INDARR(M) = INDARR(M-1)
               BACKAR(INDARR(M)) = M
3100        CONTINUE
            INDARR(JL+1) = IOFF
            BACKAR(IOFF) = JL + 1
         ENDIF
C 
4900     IOFF = IOFF + XSIZE
5000  CONTINUE
C 
      RINDX = INDARR(NH)
C
      RETURN
      END

      SUBROUTINE XSAVX(DIRFLG,NDIM)
C 
      INTEGER   DIRFLG, NDIM
      INTEGER   N,TEST
C
      PARAMETER (IXXSIZ = 25000)
C 
      INTEGER   INDARR(IXXSIZ),BACKAR(IXXSIZ),SAVARR(IXXSIZ)
      COMMON    /TMPARR/  INDARR,BACKAR,SAVARR
C 
      IF (DIRFLG.EQ.1) THEN
         DO 100, N=1,NDIM
            TEST = INDARR(N)
            SAVARR(N) = TEST
100      CONTINUE
      ELSE
C 
         DO 500, N=1,NDIM
            TEST = SAVARR(N)
            INDARR(N) = TEST
500      CONTINUE
         DO 600, N=1,NDIM                       !rebuild back index array
            BACKAR(INDARR(N)) = N
600      CONTINUE
      ENDIF
C 
      RETURN
      END

C @(#)allstsubs.for	19.1 (ES0-DMD) 02/25/03 13:23:48
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE STRIP (ID, X, Y, MAG, SKY, SKIP, MAXSTR,
     .     NSTAR, NDISAP, RADIUS, INDEX, HOLD)
C
      IMPLICIT NONE
C
      INTEGER  MAXSTR
      INTEGER  ID(MAXSTR)
      REAL     X(MAXSTR), Y(MAXSTR)
      REAL     MAG(MAXSTR), SKY(MAXSTR)
      LOGICAL  SKIP(MAXSTR)
      INTEGER  NSTAR
      INTEGER  NDISAP
      REAL     RADIUS
      INTEGER  INDEX(MAXSTR)
      REAL     HOLD(MAXSTR)
C
      INTEGER  I, J
      REAL     DX, DY
      REAL     RADSQ
      INTEGER  ISTAR
C
      NDISAP = 0
      RADSQ = RADIUS**2
      IF (NSTAR .LE. 1) RETURN
      DO I=1,NSTAR
         SKIP(I) = .FALSE.
      END DO
C
      CALL QUICK (Y, NSTAR, INDEX)
      CALL IRECTFY (ID, NSTAR, INDEX, HOLD)
      CALL RECTFY (X, NSTAR, INDEX, HOLD)
      CALL RECTFY (MAG, NSTAR, INDEX, HOLD)
      CALL RECTFY (SKY, NSTAR, INDEX, HOLD)
C
      DO 1200 I=1,NSTAR-1
         IF (SKIP(I)) GO TO 1200
         DO 1100 J=I+1,NSTAR
            IF (SKIP(J)) GO TO 1100
            DY = Y(J)-Y(I)
            IF (DY .GT. RADIUS) GO TO 1200
            DX = X(J)-X(I)
            IF (ABS(DX) .GT. RADIUS) GO TO 1100
            IF (DX**2+DY**2 .GT. RADSQ) GO TO 1100
            IF (MAG(J) .LE. MAG(I)) THEN
               SKIP(J) = .TRUE.
               GO TO 1100
            ELSE
               SKIP(I) = .TRUE.
               GO TO 1200
            END IF
 1100    CONTINUE
 1200 CONTINUE
C
      ISTAR = 0
 2000 CONTINUE
      IF (SKIP(NSTAR)) THEN
         NSTAR = NSTAR-1
         NDISAP = NDISAP+1
         GO TO 2000
      END IF
 2100 ISTAR = ISTAR+1
      IF (ISTAR .GE. NSTAR) RETURN
      IF (SKIP(ISTAR)) THEN
         ID(ISTAR) = ID(NSTAR)
         X(ISTAR) = X(NSTAR)
         Y(ISTAR) = Y(NSTAR)
         MAG(ISTAR) = MAG(NSTAR)
         SKY(ISTAR) = SKY(NSTAR)
         SKIP(ISTAR) = .FALSE.
         NSTAR = NSTAR-1
         NDISAP = NDISAP+1
         GO TO 2000
      ELSE
         GO TO 2100
      END IF
      END
C
C#######################################################################
C
      SUBROUTINE  REGRP (ID, X, Y, MAG, SKY, CHI, DXOLD, DYOLD,
     .     XCLAMP, YCLAMP, MAXSTR, NSTAR, FITRAD, LAST, INDEX, HOLD)
C
C=======================================================================
C
C This subroutine accepts a list of stellar coordinates, and
C associates the stars into natural groups based on a critical
C separation:  stars within one critical separation of each other are
C put into the same group; no star is within one critical separation of
C any star outside its group.
C
C             OFFICIAL DAO VERSION:  1985 August 15
C
C======================================================================
      IMPLICIT NONE
C
      INTEGER  MAXSTR
      INTEGER  ID(MAXSTR)
      REAL     X(MAXSTR), Y(MAXSTR)
      REAL     MAG(MAXSTR), SKY(MAXSTR)
      REAL     CHI(MAXSTR)
      REAL     DXOLD(MAXSTR), DYOLD(MAXSTR)
      REAL     XCLAMP(MAXSTR), YCLAMP(MAXSTR)
      INTEGER  NSTAR
      REAL     FITRAD
      LOGICAL  LAST(MAXSTR)
      INTEGER  INDEX(MAXSTR)
      REAL     HOLD(MAXSTR)
C
      REAL     CRITSQ
      REAL     CRIT
      REAL     XTEST, YTEST
      INTEGER  I, J, K
      REAL     DX, DY
      INTEGER  ITOP, ITEST
C
C-----------------------------------------------------------------------
C
C SECTION 1
C
C Get set up.
C
      IF (NSTAR .LE. 1) RETURN
      CRIT=2.*FITRAD
      CRITSQ=CRIT**2
C
C Check that the stars are sorted by y-coordinate on input.
C
      INDEX(1) = 1
      DO I=2,NSTAR
         IF (Y(I) .GE. Y(I-1)) THEN
            INDEX(I) = I
         ELSE
            CALL QUICK (Y, NSTAR, INDEX)
            CALL RECTFY (X, NSTAR, INDEX, HOLD)
            GO TO 900
         END IF
      END DO
C
  900 ITEST=0
      ITOP=2
C
C The stars are currently in a stack NSTAR stars long.  The variable
C ITEST will point to the position in the stack occupied by the star
C which is currently the center of a circle of the critical radius,
C within which we are looking for other stars; this also starts out
C with a value of 1.  ITOP points to the top position in the stack of
C the stars which have not yet been assigned to groups; this starts
C out with the value 2.  Each time through, the
C program goes down through the stack from ITOP and looks for stars
C within the critical distance from the star at stack position
C ITEST.  When such a star is found, it changes places in the stack
C with the star at ITOP and ITOP is incremented by one.  When the
C search reaches a star J such that Y(J)-Y(ITEST) > CRIT it is known
C that no further stars will be found within the critical distance, the
C pointer ITEST is incremented by one, and the search proceeds again
C from the new value of ITOP.  If the pointer ITEST catches up
C with the pointer ITOP, that means that the group currently being
C built up is complete.  Then a new group is started beginning with
C the star at the current position ITEST, ( = the instantaneous
C value of ITOP), ITOP is incremented by 1, and the next group is built
C up as before.
C
 2100 ITEST=ITEST+1
      LAST(ITEST)=.FALSE.
      IF (ITEST .EQ. ITOP) THEN
C
C ITEST has reached ITOP; no other unassigned stars are within a
C critical separation of any member of the current group.  The group is
C therefore complete.  Signify this by setting LAST(ITEST-1)=.TRUE.
C (ITEST = the current value of ITOP), and then increment the value of
C ITOP by one.
C
         J=ITEST-1
         IF (J .GT. 0) LAST(J)=.TRUE.
         ITOP=ITOP+1                              ! Increment ITOP
C
C If ITOP is greater than NSTAR at this point, then we are finished
C (the last group contains one star).  Otherwise, on with the search.
C
         IF (ITOP .GT. NSTAR) THEN
            LAST(ITEST)=.TRUE.
            GO TO 3000
         END IF
      END IF
C
C Now go through the list of unassigned stars, occupying positions ITOP
C through NSTAR in the stack, to look for stars within the critical
C distance of the star at position ITEST in the stack.  If one is found,
C move it up to stack position ITOP and increment ITOP by one.
C
      XTEST=X(ITEST)
      YTEST=Y(ITEST)
      J=ITOP
      DO 2120 I=J,NSTAR
         DY=Y(I)-YTEST
         IF (DY .GT. CRIT) GO TO 2100
         DX=X(I)-XTEST
         IF (ABS(DX) .GT. CRIT) GO TO 2120
         IF (DX**2+DY**2 .GT. CRITSQ) GO TO 2120
C
C This star is within the critical distance of the star at stack
C position ITEST.  Therefore it should be added to the current group by
C moving it up to position ITOP in the stack, where the pointer ITEST
C may eventually reach it.
C
         CALL ASWAP (MAXSTR, ITOP, I, X, Y, INDEX)
C
C Now increment ITOP by 1 to point at the topmost unassigned star in the
C stack.
C
         ITOP=ITOP+1
C
C If ITOP is greater than NSTAR, then all stars have been assigned to
C groups, and we are finished.
C
         IF (ITOP .GT. NSTAR) THEN
            DO K=ITEST,NSTAR-1
               LAST(K)=.FALSE.
            END DO
            LAST(NSTAR)=.TRUE.
            GO TO 3000
         END IF
 2120 CONTINUE
      GO TO 2100
C
 3000 CONTINUE
C
C Rectify the remaining quantities.
C
      CALL IRECTFY (ID, NSTAR, INDEX, HOLD)
      CALL RECTFY (ID, NSTAR, INDEX, HOLD)
      CALL RECTFY (MAG, NSTAR, INDEX, HOLD)
      CALL RECTFY (SKY, NSTAR, INDEX, HOLD)
      CALL RECTFY (CHI, NSTAR, INDEX, HOLD)
      CALL RECTFY (DXOLD, NSTAR, INDEX, HOLD)
      CALL RECTFY (DYOLD, NSTAR, INDEX, HOLD)
      CALL RECTFY (XCLAMP, NSTAR, INDEX, HOLD)
      CALL RECTFY (YCLAMP, NSTAR, INDEX, HOLD)
C
      RETURN
      END
C
C#######################################################################
C
      SUBROUTINE  ASWAP (MAXSTR, I, J, X, Y, INDEX)
C
C=======================================================================
C
C Make the I-th and J-th stars in the stack change places (J > I),
C without otherwise altering the order of the stars.  The other
C arguments are self-evident.
C
C=======================================================================
C
      IMPLICIT NONE
      INTEGER MAXSTR
C
      REAL X(MAXSTR), Y(MAXSTR)
      INTEGER INDEX(MAXSTR)
C
      REAL XHOLD, YHOLD
      INTEGER I, J, K, L, IHOLD
C
C-----------------------------------------------------------------------
C
C     CALL OVRWRT ('ASWAP', 2)
      XHOLD=X(J)
      YHOLD=Y(J)
      IHOLD=INDEX(J)
      DO K=J,I+1,-1
         L=K-1
         X(K)=X(L)
         Y(K)=Y(L)
         INDEX(K)=INDEX(L)
      END DO
      X(I)=XHOLD
      Y(I)=YHOLD
      INDEX(I)=IHOLD
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2014 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION: INTEAPER.FOR
C.AUTHOR:         Ch. Ounnas                  ESO - Garching
C.LANGUAGE:       F77+ESOext
C.KEYWORDS:       Image display, cursor, flux-magnitude
C.PURPOSE:        read the position of the two cursors on the DeAnza display
C                 and get integrated density of relevant pixels inside an 
C                 aperture
C.ALGORITHM:      Use cursor(s) or table entries to get center pixels
C		  for circular aperture integration
C.INPUT/OUTPUT:   the following keywords are used:
C                 IN_A/C/1/80		input frame (or Cursor)
C                 IN_B/C/1/80		input table (if not cursor input)
C		                        if = '* ', then fixed coord input
C 					           in inputr(11,12)
C                 INPUTC/C/1/80		name of output table
C                 INPUTR/R/1/2		(1) radius of the aperture
C					(2) pixel_type, = 1 (frame pixel)
C							= 0 (world coords)
C					used for radius
C.VERSION:        830610  CO  creation
C 140817	  fixed cursor input for scaled images:  KB
C 
C-------------------------------------------------------------------

      PROGRAM  INTAPR
C
      IMPLICIT     NONE
C
      DOUBLE PRECISION START(3),STEP(3)
C 
      INTEGER      MADRID
      INTEGER      IMF
      INTEGER      ST1,ST2,ISTAT,COORDC,COOFF
      INTEGER      INCURS,IAV,I,KRAY
      INTEGER      TIDI,TIDO,NROW,NCOL,NOP,N1,N2,ND1,ND2,NACOL,NAROW
      INTEGER      XY1(2),XY2(2)
      INTEGER      NAXIS,NPIX(3),ICOL(2),OCOL(7)
      INTEGER      XFIG(2048),YFIG(2048)
      INTEGER      COORD(3),NX,NY,ISCALE
      INTEGER      KUN,KNUL,PIXFLG,TABNUL(2)
      INTEGER      PACCESS, PLMODE
      INTEGER      LTYPE, STYPE, BIN,COLTYP

      INTEGER*8    IP,WPTR
C
      CHARACTER    IDENT*72,CUNIT*64
      CHARACTER    DSCTYP*1,DSCNAM*20
      CHARACTER*80 FRAME,INTAB,OUTAB
      CHARACTER    CERCLE*2
      CHARACTER*16 COLX,COLY
      CHARACTER*16 UNITO(7),LABELO(7)
      CHARACTER*16 TABFOR
      CHARACTER    TEXT*88
C
      REAL         RBUF(6), ARCS(2)
      REAL         PXLS1(6), PXLS2(6)
      REAL         XE,YE,RAYON,BEAM,BGSB,XEYE(2),ACAT(7)
      REAL         XSTA,YSTA,XSTE,YSTE,YOFF
C
      LOGICAL      SELFLG
C
      INCLUDE      'MID_INCLUDE:ST_DEF.INC'
      INCLUDE      'MID_INCLUDE:IDIDEV.INC'
      INCLUDE      'MID_INCLUDE:IDIMEM.INC'
C 
      COMMON       /VMR/MADRID(1)
C
      INCLUDE      'MID_INCLUDE:ST_DAT.INC' 
      DATA         UNITO /'World coord','World coord',' ',' ',
     +                    ' ',' ',' '/
      DATA         LABELO/'X_COORD','Y_COORD','RADIUS ','NPIX ',
     +                    'FLUX ','BGSB ','MAG '/
      DATA         TABFOR/'G13.6'/
      DATA         DSCNAM/'BACKGROUND'/
      DATA         CERCLE/'CI'/
      DATA         FRAME/' '/, INTAB/' '/, OUTAB/' '/
      DATA         KNUL/-1/
      DATA         ARCS/-1.0,-1.0/
C 
      DATA         STYPE/5/
      DATA         BIN/0/
      DATA         YOFF/0.0/
      DATA         PACCESS/1/
      DATA         PLMODE/-1/
C
C
      CALL STSPRO('INTAPR')
C
C get input option + map frame 
      CALL STKRDC('IN_A',1,1,80,IAV,FRAME,KUN,KNUL,ISTAT)
      IF (FRAME(1:1).EQ.'*') THEN           !display/graphics cursor
         IF (FRAME(2:2).EQ.'*') THEN                !use grpahics cursor
            CALL STKRDC('PLCDATA',1,1,60,IACT,TEXT,KUN,KNUL,ISTAT)
            IAV = INDEX(TEXT//' ',' ') - 1
            FRAME = TEXT(1:IAV)
            INCURS = 2                              !use graphics cursor
         ELSE
            CALL CLNFRA(FRAME,FRAME,0)  
            INCURS = 1                              !use display cursor
         ENDIF
      ELSE  
         INCURS = 0                                 !use table
         CALL STKRDC('IN_B',1,1,80,IAV,INTAB,KUN,KNUL,ISTAT)
      ENDIF
C 
      IMF = -1                             !map complete image (as real)
      CALL STIGET(FRAME,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,3,NAXIS,NPIX,
     +            START,STEP,IDENT,CUNIT,IP,IMF,ISTAT)
      XSTA = START(1)
      YSTA = START(2)
      XSTE = STEP(1)
      YSTE = STEP(2)
C 
      CALL PIXXCV('INIT',IMF,RBUF,ISTAT)
      IF (ISTAT .GT. 0) 
     +   CALL STETER(37,
     +   'Problem with setup of : world coord conversion')
C 
C read INPUTC to fill OUTAB if output table
      CALL STKRDC('INPUTC',1,1,80,IAV,OUTAB,KUN,KNUL,ISTAT)
      IF (OUTAB(1:1).NE.'?') THEN                   !new table with 7 columns
         COORDC = 100                               !initial no. of rows
         CALL TBTINI(OUTAB,0,F_O_MODE,7,COORDC,TIDO,ISTAT)
         DO 60, IAV = 1,7
            CALL TBCINI(TIDO,D_R4_FORMAT,1,TABFOR,UNITO(IAV),
     +                  LABELO(IAV),OCOL(IAV),ISTAT)
60       CONTINUE
      END IF
C
C does the descriptor BACKGROUND exist in FRAME ??
      CALL STDFND(IMF,DSCNAM,DSCTYP,ND1,ND2,ISTAT)
      IF (DSCTYP.EQ.' ') THEN
         BGSB   = 0.
      ELSE
         CALL STDRDR(IMF,DSCNAM,1,1,IAV,BGSB,KUN,KNUL,ISTAT)
      END IF
C
C get the radius of the aperture and pixel_spec flag
      CALL STKRDR('INPUTR',1,2,IAV,RBUF,KUN,KNUL,ISTAT) 
      BEAM = RBUF(1)
      IF (RBUF(2) .GT. 0.) THEN
         PIXFLG = 0                 ! use radius in frame pixels
      ELSE
         PIXFLG = 1                 ! use radius in world coord
      ENDIF
C  
      COORDC = 0
      TEXT(1:) = 'Center (w.c.)      Radius (w.c.)  '
      TEXT(35:) = '#Pixels    Flux      Background  Magnitude'
      CALL STTPUT(TEXT,ISTAT)
C 
C -----------------------------
C 
C read cursor positions in display window
C 
C -----------------------------
      IF (INCURS.EQ.1) THEN
         CALL STFXMP(2048,D_R4_FORMAT,WPTR,ISTAT)   !map 2K pixel space
         CALL DTOPEN(1,ISTAT)                       !attach display
         CALL CONCHA(QDSPNO,QOVCH,1,0)
         IF (BEAM.LT.0.) THEN
            CALL STTPUT
     +      ('use cursors to specify size of aperture',ISTAT)
         ELSE
            CALL STTPUT
     +      ('fixed aperture - single cursor to mark center',ISTAT)
            RAYON = BEAM
            CALL SCRPIX(IMF,PIXFLG,BEAM,1,NOP,ISTAT)
            IF (ISTAT.NE.0) THEN
               COORD(3) = 10
               CALL STTPUT
     +       ('Problems with screen pixel radius - set it to 10 pix...',
     +        ISTAT)
            ELSE
               COORD(3) = NOP
            ENDIF
         ENDIF
C      
C image must be loaded with equal scaling factors ...
         IF (SCALX .NE. SCALY) THEN 
            CALL STETER(47,
     +            'scale in X and Y must be the same...')
         ENDIF
C
         COOFF = 0
         FRAME  = ' '
C
10       CALL GETCUR('NNYY ',FRAME,XY1,PXLS1(3),PXLS1(5),RBUF(1),ST1,
     +                            XY2,PXLS2(3),PXLS2(5),RBUF(1),ST2)
         IF ((ST1.EQ.0) .AND. (ST2.EQ.0)) THEN
            GO TO 20
         ELSE
            GO TO 30
         END IF
C
20       IF ((COORDC.EQ.0).AND.(COOFF.EQ.0)) THEN
            CALL STTPUT
     +      ('switch cursor(s) on - next time we exit...',ISTAT)
            FRAME(1:)  = ' '
            COOFF = 1
            GO TO 10
         ELSE
            CALL DTCLOS(QDSPNO)
            CALL REFOVR(ISTAT)
            GO TO 50
         END IF
30       COORDC = COORDC + 1                       !update coordinate counter
C
         XE = PXLS1(5)
         YE = PXLS1(6)
         COORD(1) = XY1(1)
         COORD(2) = XY1(2)
         IF (BEAM.LT.0.0) THEN
            COORD(3) = NINT(PXLS2(3))
            RAYON = PXLS2(3)
C
            IF (SCALX .LT. -1) THEN                !adjust radius of circle
               ISCALE = -SCALX                     !to scaling of image
               KRAY = NINT(RAYON)/ISCALE
               RAYON = FLOAT(KRAY) 
            ELSE IF (SCALX .GT. 1) THEN
               KRAY = NINT(RAYON)*SCALX
               RAYON = FLOAT(KRAY) 
            ENDIF
         ENDIF
C 
C draw the aperture in the overlay channel
         CALL BLDGRA(CERCLE,COORD,ARCS,XFIG,YFIG,2048,NOP)
         CALL IIGPLY(QDSPNO,QOVCH,XFIG,YFIG,NOP,255,1,ISTAT)
C
         IF (NAXIS .GT. 1) THEN
            CALL SFLUX2(MADRID(WPTR),MADRID(IP),IMF,NAXIS,NPIX,START,
     +                 STEP,XE,YE,PIXFLG,RAYON,BGSB,ACAT)
         ELSE
            CALL SFLUX1(MADRID(WPTR),MADRID(IP),IMF,NPIX,START,
     +                 STEP,XE,PIXFLG,RAYON,BGSB,ACAT)
         ENDIF
C
         IF (ACAT(7).LE.-1000.) THEN
            ACAT(1) = XE
            ACAT(2) = YE
            ACAT(3) = 0.0
            ACAT(4) = 0.0
            ACAT(5) = 0.0
            ACAT(6) = 0.0
            ACAT(7) = 0.0
         ENDIF
 
         WRITE(TEXT,902) ACAT(1),ACAT(2),ACAT(3),ACAT(4),ACAT(5),
     +                   ACAT(6),ACAT(7)
         CALL STTPUT(TEXT,ISTAT) 
         IF (OUTAB(1:1).NE.'?') THEN
            CALL TBRWRR(TIDO,COORDC,7,OCOL,ACAT,ISTAT)
         ENDIF
         GOTO 10
C -----------------------------
C 
C  here the graphics cursor option
C 
C -----------------------------
      ELSE IF (INCURS.EQ.2) THEN
         CALL STFXMP(2048,D_R4_FORMAT,WPTR,ISTAT)      !map 2K pixel space
         CALL PTOPEN(' ','none',PACCESS,PLMODE)        !restore graphics dw.
         IF (BEAM.GT.0.) THEN
            CALL STTPUT
     +     ('fixed interval - single cursor to mark center',ISTAT)
         ELSE
            CALL STTPUT
     +     ('twice cursor input to mark interval',ISTAT)
         ENDIF
         YE = 0.0
C
130      CALL PTGCUR(PXLS1(1),PXLS1(2),IAV,ISTAT)      !get 1st x-coord. (w.c.)
         IF (ISTAT.EQ.1) THEN
            GOTO 130
         ELSE IF (IAV.EQ.32) THEN
            CALL PTCLOS()
            GOTO 50
         ENDIF
         LTYPE = 0
         BIN   = 0
         CALL PTDATA(STYPE,LTYPE,BIN,PXLS1(1),PXLS1(2),YOFF,1)
C
         IF (BEAM.GT.0.) THEN
            XE = PXLS1(1) 
            RAYON = BEAM
         ELSE                                          !get 2nd x-coord. (w.c.)
140         CALL PTGCUR(PXLS2(1),PXLS2(2),IAV,ISTAT) 
            IF (ISTAT.EQ.1) THEN
               GOTO 140
            ELSE IF (IAV.EQ.32) THEN
               CALL PTCLOS()
               GOTO 50
            ENDIF
            LTYPE = 0
            CALL PTDATA(STYPE,LTYPE,BIN,PXLS2(1),PXLS2(2),YOFF,1)
            XE = (PXLS1(1) + PXLS2(1)) / 2
            RAYON = ABS(PXLS2(1)-PXLS1(1)) / 2 
         ENDIF
C
         COORDC = COORDC + 1
         CALL SFLUX1(MADRID(WPTR),MADRID(IP),IMF,NPIX,START,
     +               STEP,XE,PIXFLG,RAYON,BGSB,ACAT)
C
         IF (ACAT(7).LE.-1000) THEN
            ACAT(1) = XE
            ACAT(2) = YE
            ACAT(3) = 0.0
            ACAT(4) = 0.0
            ACAT(5) = 0.0
            ACAT(6) = 0.0
            ACAT(7) = 0.0
         ENDIF
C
         WRITE(TEXT,902) ACAT(1),ACAT(2),ACAT(3),ACAT(4),ACAT(5),
     +                   ACAT(6),ACAT(7)
         CALL STTPUT(TEXT,ISTAT)
         IF (OUTAB(1:1).NE.'?') 
     +      CALL TBRWRR(TIDO,COORDC,7,OCOL,ACAT,ISTAT)
C -----------------------------
C 
C  here the table input option
C 
C -----------------------------
      ELSE               
         RAYON = ABS(BEAM)
         BEAM = 2 * RAYON                  !we use start + 2*radius as endpoint
         IF (PIXFLG.EQ.0) 
     +      BEAM = BEAM * ABS(STEP(1))            !radius now also in w.c.
C 
C        determine mapping size needed
         IF (STEP(1) .LT. 0.0) THEN
            RBUF(1) = SNGL(START(1)) - BEAM
         ELSE                           !so framepix = 2*(no. pixels) 
            RBUF(1) = SNGL(START(1)) + BEAM 
         ENDIF
         IF (NAXIS .GT. 1) THEN
            IF (STEP(2) .LT. 0.0) THEN
               RBUF(2) = SNGL(START(2)) - BEAM 
            ELSE
               RBUF(2) = SNGL(START(2)) + BEAM 
            ENDIF
         ELSE
            RBUF(2) = START(2)
         ENDIF
         CALL PIXXCV('WR_',IMF,RBUF,ISTAT)         !wc -> fp
         IF (ISTAT .GT. 0) THEN
            CALL STETER(38,
     +      'Problem with conversion: world coord -> frame pixels')
         ENDIF
         NX = RBUF(3) + 2          ! + 2 for security
         IF ((NX.LT.1) .OR. (NX.GT.NPIX(1)))
     +      CALL STETER(77,'bad radius...')  
         NY = 1
         IF (NAXIS .GT. 1) THEN
            NY = RBUF(4) + 2          ! + 2 for security
            IF ((NY.LT.1) .OR. (NY.GT.NPIX(2))) 
     +         CALL STETER(77,'bad radius...')  
         ENDIF
         CALL STFXMP(NX*NY,D_R4_FORMAT,WPTR,ISTAT)
C
C check, if table input, or fixed coords
         IF (INTAB(1:2).EQ.'* ') THEN
            NROW = 1				!ensure we only loop once
            I = 1
            COLTYP = 1				!we expect world coords
            CALL STKRDR('INPUTR',11,2,IAV,XEYE,KUN,KNUL,ISTAT)
            GOTO 44				!skip all table stuff
         ENDIF
C 
         CALL TBTOPN(INTAB,F_I_MODE,TIDI,ISTAT)
C 
C find columns X_COORD, Y_COORD or X_COORDPIX, Y_COORDPIX
         COLX = 'X_COORD'
         COLTYP = 1
         CALL TBLSER(TIDI,COLX,ICOL(1),ISTAT)
         IF (ICOL(1).LE.0) THEN
            COLTYP = 0
            COLX   = 'X_COORDPIX'
            CALL TBLSER(TIDI,COLX,ICOL(1),ISTAT)
            IF (ICOL(1).LE.0) THEN
               CALL STTPUT('The column label for X is not present',
     +                      ISTAT)
               CALL TBTCLO(TIDI,ISTAT)
               GOTO 50
            ENDIF
         ENDIF
         NCOL = 1
         IF (NAXIS .GT. 1) THEN
            IF (COLTYP.EQ.1) THEN
               COLY = 'Y_COORD'
            ELSE
               COLY = 'Y_COORDPIX'
            ENDIF
            CALL TBLSER(TIDI,COLY,ICOL(2),ISTAT)
            IF (ICOL(2).LE.0) THEN
               CALL STTPUT('The column label for Y is not present',
     +                      ISTAT)
               CALL TBTCLO(TIDI,ISTAT)
               GOTO 50
            ENDIF
            NCOL = 2
         ENDIF
C
C find number of rows
         CALL TBIGET(TIDI,N1,NROW,N2,NACOL,NAROW,ISTAT)
         I = 0
C
C ***    Read each row for XE,YE
40       I = I + 1
         IF (I.GT.NROW) THEN
            IF (INTAB(1:2).NE.'* ') CALL TBTCLO(TIDI,ISTAT)
            GOTO 50
         ENDIF
C
         CALL TBSGET(TIDI,I,SELFLG,ISTAT)        !only use selected rows
         IF (.NOT. SELFLG) GOTO 40
         CALL TBRRDR(TIDI,I,NCOL,ICOL,XEYE,TABNUL,ISTAT)
C 
44       XE = XEYE(1)
         IF (NAXIS .GT. 1) THEN
            YE = XEYE(2)
         ELSE
            YE = 0.0
         ENDIF
         IF (COLTYP.EQ.0) THEN                  !center pixels as f.p.
            RBUF(1) = XE
            RBUF(2) = YE
            CALL PIXXCV('_RW',IMF,RBUF,ISTAT)
            IF (ISTAT.NE.0) THEN
               CALL STTPUT('*** INFO: Problems in fp -> wc conversion',
     +                     ISTAT)
               GOTO 40
            ENDIF
            XE = RBUF(5)                        !XE,YE now in w.c.
            YE = RBUF(6)
         ENDIF
         COORDC = COORDC + 1                    !count of selected rows
C
         IF (NAXIS .GT. 1) THEN
            CALL SFLUX2(MADRID(WPTR),MADRID(IP),IMF,NAXIS,NPIX,START,
     +                 STEP,XE,YE,PIXFLG,RAYON,BGSB,ACAT)
         ELSE
            CALL SFLUX1(MADRID(WPTR),MADRID(IP),IMF,NPIX,START,
     +                 STEP,XE,PIXFLG,RAYON,BGSB,ACAT)
         ENDIF
C
         IF (ACAT(7).LE.-1000) THEN
            ACAT(1) = XE
            ACAT(2) = YE
            ACAT(3) = 0.0
            ACAT(4) = 0.0
            ACAT(5) = 0.0
            ACAT(6) = 0.0
            ACAT(7) = 0.0
         ENDIF
C 
         WRITE(TEXT,902) ACAT(1),ACAT(2),ACAT(3),ACAT(4),ACAT(5),
     +                   ACAT(6),ACAT(7)
         CALL STTPUT(TEXT,ISTAT) 
         IF (OUTAB(1:1).NE.'?') THEN
            CALL TBRWRR(TIDO,COORDC,7,OCOL,ACAT,ISTAT)
         ENDIF
         GOTO 40
      END IF
C
C *** That's it folks...
50    CONTINUE
C
C *** put the last entry in the keyword OUTPUTR
      CALL STKWRR('OUTPUTR',ACAT,1,7,KUN,ISTAT)
      IF (OUTAB(1:1).NE.'?') CALL TBTCLO(TIDO,ISTAT)
C
      CALL STSEPI
C
902   FORMAT(G11.5,1X,G11.5,1X,G9.4,1X,G9.4,2X,G10.4,2X,
     +       G11.6,1X,G12.6)
      END

C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION: SFLUX
C.AUTHOR:         Ch. Ounnas                  ESO - Garching
C.LANGUAGE:       F77+ESOext
C.KEYWORDS:       flux-magnitude
C.PURPOSE:        compute flux inside an aperture
C.VERSION:        880919 RHW ESO-FORTRAN Conversion
C ----------------------------------------------------------------------
      SUBROUTINE SFLUX2(WBUF,RDAT,IMP,NAXIS,NPIX,START,STEP,XE,YE,
     +                 PIXFLG,RAYON,BGSB,TAB)
C
      IMPLICIT   NONE
C
      REAL       WBUF(1), RDAT(1)
      INTEGER    IMP,NAXIS,NPIX(2)
      DOUBLE PRECISION START(*),STEP(*)
      REAL       XE,YE
      INTEGER    PIXFLG
      REAL       RAYON,BGSB,TAB(7)
C 
      INTEGER    IMIN,IMAX
      INTEGER    LMIN,LMAX
      INTEGER    IST,LM,IL,IM,NPL
      INTEGER    NXP,NYP
C     
      REAL       DIF
      REAL       DX,DY,ADX
      REAL       PIX,RADIUS
      REAL       PS2,OPS2,POIDS
      REAL       R2,RES,RBUF(6)
      REAL       XP,YP
      REAL       XC,YC
      REAL       XSTA,YSTA
      REAL       XMIN,XMAX
      REAL       YMIN,YMAX
      REAL       VMAG
C 
      CHARACTER  ERSTRG*12,TEXT*60
C
      DX = STEP(1)
      DY = STEP(2)
      XSTA = START(1)
      YSTA = START(2)
C
      IF (PIXFLG.EQ.1) THEN
         RADIUS = RAYON                !radius  in w.c.
      ELSE
         RADIUS = RAYON * ABS(DX)      !radius now in w.c.
      ENDIF
C 
      XMIN   = XE - RADIUS
      XMAX   = XE + RADIUS
      IF (NAXIS .GT. 1) THEN
         YMIN   = YE - RADIUS
         YMAX   = YE + RADIUS
      ELSE
         YMIN   = START(2)
         YMAX   = YMIN
      ENDIF
      TAB(7) = 0.0
C 
      RBUF(1) = XMIN 
      RBUF(2) = YMIN 
      CALL PIXXCV('WR_',IMP,RBUF,IST)    !world coord -> frame pixel
      IF (IST .EQ. 0) THEN
         IMIN = NINT(RBUF(3))
         LMIN = NINT(RBUF(4))
         IF ((IMIN.LT.1) .OR. (IMIN.GT.NPIX(1)) .OR.
     +       (LMIN.LT.1) .OR. (LMIN.GT.NPIX(2))) THEN
            ERSTRG = '(lo x,y) '
            GOTO 40
         ENDIF
      ELSE
         ERSTRG = '(lo x,y) '
         GOTO 40
      ENDIF
C
      RBUF(1) = XMAX 
      RBUF(2) = YMAX 
      CALL PIXXCV('WR_',IMP,RBUF,IST)    ! world coord -> frame pixel
      IF (IST .EQ. 0) THEN
         IMAX = NINT(RBUF(3))
         LMAX = NINT(RBUF(4))
         IF ((IMAX.LT.1) .OR. (IMAX.GT.NPIX(1)) .OR.
     +       (LMAX.LT.1) .OR. (LMAX.GT.NPIX(2))) THEN
            ERSTRG = '(hi x,y) '
            GOTO 40
         ENDIF
      ELSE
         ERSTRG = '(hi x,y) '
         GOTO 40
      ENDIF
C 
      IF (DX.LE.0.) THEN
         IM = IMIN
         IMIN = IMAX
         IMAX = IM
      END IF
C
      IF (DY.LE.0.) THEN
         IM = LMIN
         LMIN = LMAX
         LMAX = IM
      ENDIF
C
C
      IM = IMAX - IMIN + 1
      LM = LMAX - LMIN + 1
      PIX = 0.
      RES = 0.
      ADX = ABS(DX)
      PS2 = ADX/2
      OPS2 = 2./ADX
C 
      DO 20, IL = 1,LM                   !loop over y-lines
         CALL LIRE(IL+LMIN-1,NPIX(1),IMIN,IMAX,1,RDAT,WBUF)
         NYP = LMIN + IL -1          ! YP = YSTA + FLOAT(LMIN+IL-2)*DY
         IF (DY.LT.0.) THEN
            CALL LIRE(LMAX-IL+1,NPIX(1),IMIN,IMAX,1,RDAT,WBUF)
            NYP = 1 + LMAX - IL          ! YP = YSTA + FLOAT(LMAX-IL)*DY
         END IF
C
         DO 10, NPL = 1,IM               !loop over x-pixels
            NXP = IMIN + NPL -1      ! XP = XSTA + FLOAT(IMIN+NPL-2)*DX
            IF (DX.LT.0.) THEN
               NXP = 1 + IMAX - NPL      ! XP = XSTA + FLOAT(IMAX-NPL)*DX
            END IF
C
            RBUF(1) = FLOAT(NXP)
            RBUF(2) = FLOAT(NYP)
            CALL PIXXCV('_RW',IMP,RBUF,IST)    ! frame pix -> world coord
            IF (IST .EQ. 0) THEN
               XP = RBUF(5)
               YP = RBUF(6)
            ELSE
               CALL STTPUT('*** INFO: Problems in fp -> wc conversion',
     +                     IST)
               GO TO 44
            ENDIF
C
            YC = (YE-YP)**2
            XC = (XE-XP)**2
            R2 = SQRT(YC+XC)               !distance to center pixel
            DIF = RADIUS - R2
C
C RADIUS, R2 refer to center of pixels (seen as area):
C DIF >= 0. => pixel center inside circle, but some part of pixel area
C could still be outside ...
C DIF < 0. => pixel center outside circle, but some part of pixel area
C could still be inside ...
C 
            IF (DIF.GE.0.) THEN           !pixel center inside
               IF (DIF.GE.PS2) THEN
                  POIDS = 1.              !completely inside
               ELSE
                  POIDS = 0.5 * (1.+DIF*OPS2)        !take inside portion
               END IF
            ELSE
               DIF = -DIF
               IF (DIF.GT.PS2) THEN
                  POIDS = 0.              !completely outside
               ELSE
                  POIDS = 0.5 * (1.-DIF*OPS2)        !take inside portion
               END IF
            END IF
C
            RES = RES + POIDS*WBUF(NPL)
            PIX = PIX + POIDS
   10    CONTINUE
   20 CONTINUE
C
      VMAG = RES - PIX*BGSB
      IF (VMAG.GT.0) THEN
         VMAG = -2.5*ALOG10(VMAG)
      ELSE
         VMAG = -9999.99
      END IF
C
      TAB(1) = XE
      TAB(2) = YE
      TAB(3) = RADIUS
      TAB(4) = PIX
      TAB(5) = RES
      TAB(6) = BGSB
      TAB(7) = VMAG
      RETURN
C 
40    TEXT = '*** INFO: Aperture area outside frame boundaries '
      CALL STTPUT(TEXT // ERSTRG,IST)
44    TAB(7) = -9999.99
      RETURN
      END

      SUBROUTINE LIRE(NL,NPX,LOWX,HIX,XSCAL,RDAT,WBUF)
C 
C PURPOSE:  Copy image area to work array
C	NL = y-line no.
C	NPX = no. of x-pixel per line
C	LOWX = first x-pixel
C	HIX = last x-pixel
C	XSCAL = x-pixel scaling
C	RDAT = image data array
C	WBUF = work array
C 
      IMPLICIT   NONE
C 
      INTEGER    NL,NPX,LOWX,HIX,XSCAL
      REAL       RDAT(1),WBUF(1)                                                
C 
      INTEGER    NPD, NPF, K, I 
C
C 
      NPD = (NL - 1)*NPX + LOWX                  !start pixel
      NPF = NPD + HIX - LOWX                     !end pixel
      K = 0
C 
      DO 10, I=NPD,NPF,XSCAL
         K = K + 1   
         WBUF(K) = RDAT(I)
10    CONTINUE
C
      RETURN
      END

      SUBROUTINE SFLUX1(WBUF,RDAT,IMP,NPIX,START,STEP,XE,
     +                 PIXFLG,RAYON,BGSB,TAB)
C
      IMPLICIT   NONE
C
      INTEGER    IMP,NPIX(1)
      INTEGER    PIXFLG
      REAL       WBUF(1), RDAT(1)
      REAL       XE
      REAL       RAYON,BGSB,TAB(7)
      DOUBLE PRECISION START(1),STEP(1)
C 
      INTEGER    IMIN,IMAX
      INTEGER    IST,IM,NPL,NXP
C     
      REAL       DIF
      REAL       DX,ADX
      REAL       PIX,RADIUS,YE
      REAL       PS2,OPS2,POIDS
      REAL       R2,RES,RBUF(6)
      REAL       XP,XSTA
      REAL       XMIN,XMAX
      REAL       VMAG
C 
      CHARACTER  ERSTRG*12,TEXT*60
C
      DX = STEP(1)
      XSTA = START(1)
      ADX = ABS(DX)
      PS2 = ADX/2
      OPS2 = 2./ADX
      YE = 0.0
      RBUF(2) = YE 
C
      XMIN   = XE - RAYON
      XMAX   = XE + RAYON
      TAB(7) = 0.0
C
      IF (PIXFLG.EQ.1) THEN
         RADIUS = RAYON                  !radius in w.c.
      ELSE                            !here we work with frame pixels
         RADIUS = RAYON * ADX            !radius now also in w.c.
      ENDIF
C 
      RBUF(1) = XMIN 
      CALL PIXXCV('WR_',IMP,RBUF,IST)    ! world coord -> frame pixel
      ERSTRG = '(lo x) '
      IF (IST .EQ. 0) THEN
         IMIN = NINT(RBUF(3))
         IF ((IMIN.LT.1) .OR. (IMIN.GT.NPIX(1))) GOTO 40
      ELSE
         GOTO 40
      ENDIF
C
      RBUF(1) = XMAX 
      CALL PIXXCV('WR_',IMP,RBUF,IST)    ! world coord -> frame pixel
      ERSTRG = '(hi x) '
      IF (IST .EQ. 0) THEN
         IMAX = NINT(RBUF(3))
         IF ((IMAX.LT.1) .OR. (IMAX.GT.NPIX(1))) GOTO 40
      ELSE
         GOTO 40
      ENDIF
C 
      IF (DX.LE.0.) THEN
         IM = IMIN
         IMIN = IMAX
         IMAX = IM
      ENDIF
C
      IM = IMAX - IMIN + 1
      PIX = 0.
      RES = 0.
C 
      CALL LIRE(1,NPIX(1),IMIN,IMAX,1,RDAT,WBUF)
      DO 10, NPL = 1,IM               !loop over x-pixels
         NXP = IMIN + NPL - 1   
         IF (DX.LT.0.) THEN
            NXP = 1 + IMAX - NPL      !XP = XSTA + FLOAT(IMAX-NPL)*DX
         ENDIF
C
         RBUF(1) = DBLE(NXP)
         CALL PIXXCV('_RW',IMP,RBUF,IST)    !frame pix -> world coord
         IF (IST .EQ. 0) THEN
            XP = RBUF(5)
         ELSE
            CALL STTPUT
     +      ('*** INFO: Problems in fp -> wc conversion',IST)
            GO TO 44
         ENDIF
C
         R2 = ABS(XE-XP)                      !distance to center pixel
         DIF = RADIUS - R2
C
C RADIUS, R2 refer to center of pixels (seen as area):
C DIF >= 0. => pixel center inside interval, but some part of pixel area
C could still be outside ...
C DIF < 0. => pixel center outside interval, but some part of pixel area
C could still be inside ...
C 
         IF (DIF.GE.0.) THEN           !pixel center inside
            IF (DIF.GE.PS2) THEN
               POIDS = 1.              !completely inside
            ELSE
               POIDS = 0.5 * (1.+DIF*OPS2)        !take inside portion
            END IF
         ELSE
            DIF = -DIF
            IF (DIF.GT.PS2) THEN
               POIDS = 0.              !completely outside
            ELSE
               POIDS = 0.5 * (1.-DIF*OPS2)        !take inside portion
            END IF
         END IF
C
         RES = RES + POIDS*WBUF(NPL)
         PIX = PIX + POIDS
10    CONTINUE
C
      VMAG = RES - PIX*BGSB
      IF (VMAG.GT.0) THEN
         VMAG = -2.5*ALOG10(VMAG)
      ELSE
         VMAG = -9999.99
      END IF
C
      TAB(1) = XE
      TAB(2) = YE
      TAB(3) = RADIUS
      TAB(4) = PIX
      TAB(5) = RES
      TAB(6) = BGSB
      TAB(7) = VMAG
      RETURN
C 
40    TEXT = '*** INFO: Aperture area outside frame boundaries '
      CALL STTPUT(TEXT // ERSTRG,IST)
44    TAB(7) = -9999.99
      RETURN
      END

C @(#)guess.for	19.1 (ES0-DMD) 02/25/03 14:29:01
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C

      SUBROUTINE GUESS (MODE,COEFF,SIZE,IDEG)

C --- Reads descriptors of table line and load initial
C --- coefficients of the dispersion relation X = f(lambda).
C
C INPUT:
C KEYNAM  CHAR*8  Generic name of descriptors storing the coefficients
C SIZE    INTG    Size of double precision array COEFF
C IDEG    INTG    Degree of the fit. If guess option, this value is 
C                 checked against the stored value.
C KEYWORDS INPUT:
C IN_A/C/1/60     Mode of operation IN_A  = GUESS for guess mode
C IN_B/C/1/60     Name of guess table.
C INPUTD/D/1/1    Shift in pixels
C
C DESCRIPTORS INPUT:
C GUESSI/I/5/1    Degree of the regression
C GUESSD/D/1/20   Coefficients of the regression.
C
C OUTPUT:
C MODE    INTG    Mode=0 (no Guess) or Mode=1 (Guess)
C COEFF   REAL*8  Coefficients
C IDEG    INTG    Stored value if guess option.
C

      IMPLICIT NONE
      INTEGER  MODE, SIZE, IDEG, GDEG
      INTEGER  KUN, KNUL, STATUS, IACT, TID
      CHARACTER  GUETAB*60, WLCMTD*8
      DOUBLE PRECISION COEFF(SIZE), SHIFT

C --- Read keyword WLCMTD and check if Guess mode. Optionally read
C --- keyword GUETAB.

      CALL STKRDC('IN_A',1,1,8,IACT,WLCMTD,KUN,KNUL,STATUS)

      MODE = 0
      IF (WLCMTD(1:1).EQ.'G' .OR. WLCMTD(1:1).EQ.'g') THEN
          MODE = 1
          CALL STKRDC('IN_B',1,1,60,IACT,GUETAB,KUN,KNUL,STATUS)
          CALL TBTOPN(GUETAB, 10, TID, STATUS)
          CALL STDRDI(TID,'GUESSI',6,1,IACT,GDEG,KUN,KNUL,STATUS)
          IF (GDEG.NE.IDEG) THEN
             CALL STTPUT ('Changed degree to the value
     . stored in guess table',STATUS)
             IDEG = GDEG
          ENDIF
          CALL STDRDD(TID,'GUESSD',1,20,IACT,COEFF,KUN,KNUL,STATUS)
          CALL STKRDD('INPUTD',1,1,IACT,SHIFT,KUN,KNUL,STATUS)
          COEFF(1) = COEFF(1) + SHIFT
          CALL TBTCLO(TID,STATUS)
      ENDIF

      RETURN
      END

C @(#)sperebin.for	19.1 (ES0-DMD) 02/25/03 14:29:43
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM SPEREB
C
C+
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:23 - 6 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION
C
C  program  SPEREBIN  version 2.0 840314
C  J.D.Ponz   ESO - Graching
C
C.KEYWORDS
C
C  SPECTRA, REBIN
C
C.PURPOSE
C
C  CONVERT FROM PIXEL INTO WAVELENGTH SAMPLING SPACE
C
C.ALGORITHM
C
C  EACH LINE IN THE INPUT FRAME IS REBINNED IN LINEAR STEP IN WAVELENGTH
C  ACCORDING TO THE DISPERSION COEFFS.
C
C.INPUT/OUTPUT
C
C  REBIN/ECHELLE INPUT OUTPUT STEP [METHOD]
C
C METHOD CAN BE EITHER "NONLINEAR" - NON LINEAR REBINNING USING
C                                     THE COEFFS IN THE TABLE
C-
      IMPLICIT NONE
C
      INTEGER   MADRID,KUN,KNUL
      INTEGER   IA1,IAV,II,II1
      INTEGER*8 IPNTRA,IPNTRB
      INTEGER   ISTAT
      INTEGER   JJ,NAXISA,NAXISB,NPP,IMIN,IMOUT
      INTEGER   NPIXA(2),NPIXB(2),NCOE(2)
      INTEGER   IMF,TID
C
      REAL WSTART,WSTEP
      REAL STEPA(2),STARTA(2),STEPB(2),STARTB(2)
      REAL CUT(4),XMIN,XMAX
C
      DOUBLE PRECISION A1(10),DSTEP(2),DSTART(2)
C
      CHARACTER*80 OUTFR,INFR
      CHARACTER*8  REDSTA
      CHARACTER    HISTOR*80
      CHARACTER    IDENTA*72,CUNITA*64,CUNITB*64
      CHARACTER*60 TABLE
      CHARACTER*80 REFER,TABLEF
C
      INCLUDE    'MID_INCLUDE:ST_DEF.INC/NOLIST'
      COMMON     /VMR/MADRID(1)
      INCLUDE    'MID_INCLUDE:ST_DAT.INC/NOLIST'
C
      DATA CUNITB/'FLUX            WAVELENGTH'/
C
C ... INITIALIZE SYSTEM
C
      CALL STSPRO('SPEREBIN')
C
C ... READ PARAMETERS
C
      CALL STKRDC('P1',1,1,80,IAV,INFR,KUN,KNUL,ISTAT)
      CALL STKRDC('P2',1,1,80,IAV,OUTFR,KUN,KNUL,ISTAT)
      CALL STKRDC('P3',1,1,80,IAV,REFER,KUN,KNUL,ISTAT)
      II     = INDEX('.0123456789',REFER(1:1))
      IF (II.EQ.0) THEN
          CALL STFOPN(REFER,D_R4_FORMAT,0,F_IMA_TYPE,IMF,ISTAT)
          CALL STDRDD(IMF,'START',1,1,IAV,DSTART,KUN,KNUL,ISTAT)
          CALL STDRDD(IMF,'STEP',1,1,IAV,DSTEP,KUN,KNUL,ISTAT)
          CALL STDRDI(IMF,'NPIX',1,1,IAV,NPP,KUn,KNUL,ISTAT)
          WSTART = DSTART(1)
          WSTEP  = DSTEP(1)
      ELSE
          READ (REFER,9000) WSTEP
          WSTART = -1000.
      END IF
C
C     CALL STKRDR('INPUTR',1,1,IAV,WSTEP,KUN,KNUL,STAT)
      CALL STKRDC('MID$CMND',1,1,72,IAV,HISTOR,KUN,KNUL,ISTAT)
      CALL STKRDC('IN_A',1,1,60,IAV,TABLE,KUN,KNUL,ISTAT)
      II1    = INDEX(TABLE,' ') - 1
      TABLEF = TABLE(1:II1)//'.TBL'

      CALL TBTOPN(TABLEF,F_I_MODE,TID,ISTAT)
      CALL STDRDI(TID,'COEFS',1,2,IAV,NCOE,KUN,KNUL,ISTAT)
      CALL STDRDD(TID,'COEFD',1,10,IAV,A1,KUN,KNUL,ISTAT)
      CALL STDRDI(TID,'COEFI',1,1,IAV,IA1,KUN,KNUL,ISTAT)
      DO 10 JJ = IA1 + 1,10
          A1(JJ) = 0.D0
   10 CONTINUE
C
C ... MAP INPUT FRAME
C
      CALL STIGET(INFR,10,0,1,2,NAXISA,NPIXA,DSTART,DSTEP,
     +     IDENTA,CUNITA,IPNTRA,IMIN,ISTAT)
      STARTA(1) = DSTART(1)
      STARTA(2) = DSTART(2)
      STEPA(1) = DSTEP(1)
      STEPA(2) = DSTEP(2)
      IF (NAXISA.EQ.1 .OR. NPIXA(2).EQ.1) THEN
          NPIXA(2) = 1
          NAXISA = 1
      ELSE
          NAXISA = 2
      END IF
C
C ... MAP OUTPUT FRAME
C
      IF (WSTART.LE.0.0) THEN
          CALL WRANGE(A1,IA1,WSTEP,NPIXA(1),STARTB(1),NPIXB(1))
      ELSE
          STARTB(1) = WSTART
          NPIXB(1) = NPP
      END IF
      NAXISB    = NAXISA
      NPIXB(2)  = NPIXA(2)
      STARTB(2) = STARTA(2)
      STEPB(1)  = WSTEP
      STEPB(2)  = STEPA(2)
      REDSTA = 'EXTRACT'
      DSTART(1) = STARTB(1)
      DSTART(2) = STARTB(2)
      DSTEP(1) = STEPB(1)
      DSTEP(2) = STEPB(2)
      CALL STIPUT(OUTFR,10,1,1,NAXISB,NPIXB,DSTART,DSTEP,
     +     IDENTA,CUNITB,IPNTRB,IMOUT,ISTAT)
C
C ... NON LINEAR REBINNIG
C
      CALL REBINB(MADRID(IPNTRA),NAXISA,NPIXA(1),NPIXA(2),
     +     STARTA,STEPA,A1,IA1,MADRID(IPNTRB),NPIXB(1),
     +     NPIXB(2),STARTB,STEPB)
C
C ... WRITE PROCESS DESCRIPTORS
C
      CALL MNMX(MADRID(IPNTRB),NPIXB(1)*NPIXB(2),XMIN,XMAX)
      CUT(1) = XMIN
      CUT(2) = XMAX
      CUT(3) = XMIN
      CUT(4) = XMAX
      CALL STDCOP(IMIN,IMOUT,3,' ',ISTAT)
      CALL STDWRC(IMOUT,'REDSTAT',1,REDSTA,1,8,KUN,ISTAT)
      CALL STDWRC(IMOUT,'HISTORY',1,HISTOR,-1,72,KUN,ISTAT)
      CALL STDWRR(IMOUT,'LHCUTS',CUT,1,4,KUN,ISTAT)
      DSTART(1) = STARTB(1)
      DSTART(2) = STARTB(2)
      CALL STDWRD(IMOUT,'START',DSTART,1,2,KUN,ISTAT)
C      WRITE (*,*) STARTB(1)
      CALL STSEPI
      STOP 
 9000 FORMAT (F8.4)
      END

      DOUBLE PRECISION FUNCTION POLEV(IA,A,XX)
C
C
C
      IMPLICIT NONE
      INTEGER IA
      DOUBLE PRECISION A(IA),XX,YY

      YY     = A(1) + XX* (A(2)+XX* (A(3)+XX* (A(4)+XX* (A(5)+XX* (A(6)+
     +         XX*A(7))))))
      POLEV  = YY
      RETURN
      END

      SUBROUTINE MNMX(X,N,XMIN,XMAX)
C
C FIND MIN MAX VALS
C
      IMPLICIT NONE
      INTEGER  N,I
      REAL     XMIN,XMAX
      REAL X(N)

      XMIN   = X(1)
      XMAX   = XMIN
      DO 10 I = 2,N
          XMIN   = AMIN1(XMIN,X(I))
          XMAX   = AMAX1(XMAX,X(I))
   10 CONTINUE
      RETURN

      END

      SUBROUTINE WRANGE(A,IA,WSTEP,NPIXA,WSTART,NPIXB)
C
C GET STARTING POSITIONS AND NO. OF PIXELS
C
      IMPLICIT NONE
      INTEGER    IA,NPIXA,NPIXB
      REAL       WSTEP
      DOUBLE PRECISION WW,A(1),POLEV
      REAL WSTART
C
      WW     = POLEV(IA,A,1.D0)
      WSTART = WW
      WW     = NPIXA
      WW     = POLEV(IA,A,WW)
      NPIXB  = (WW-WSTART)/WSTEP + 1
      RETURN

      END

      SUBROUTINE LREBI2(X,NX,XSTR,XSTP,AC,NC,Y,NY,YSTR,YSTP)
C
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  SUBROUTINE  LREBI2 VERSION 1   22 MAR 1983
C  J.D.PONZ
C
C.KEYWORDS:
C  SPECTROSCOPY, CASPEC, REBINNING
C
C.PURPOSE:
C  DATA REBINNING
C  CONVERSION FROM SAMPLES INTO WAVELENGTHS
C
C.ALGORITHM:
C  LINEAR INTERPOLATION. THE TRANSFORMATION SAMPLE NUMBER INTO
C  WAVELENGTH IS DEFINED BY
C  W = A0 + A1*S + A2*S**2 + ...
C
C.INPUT/OUTPUT
C  INPUT ARGUMENTS
C
C  X(NX) REAL*4 INPUT ARRAY
C  NX  INTG*4 NO OF SAMPLES
C  XSTR  REAL*4 STARTING VALUE OF INPUT
C  XSTP  REAL*4 INPUT STEP
C  AC(NC) REAL*8 COEFFICIENTS OF THE TRANSFORMATION
C  NC  REAL*4 NO. OF COEFFICIENTS
C  NY  INTG*4 NO. OF OUTPUT VALUES
C  YSTR  REAL*4 STARTING VALUE OF THE INPUT
C  YSTP  REAL*4 STEP OF THE OUTPUT
C
C  OUTPUT ARGUMENTS
C
C  Y(NY) REAL*4 OUTPUT ARRAY
C
C
C
      IMPLICIT NONE
      INTEGER      NX,NY,NC,M1,N,MPT,MST,K,KZ6904
      REAL         XSTR,XSTP,YSTR,YSTP,DELT
      REAL         B2,B3,B4,B5,B6,STARTL,START
      REAL X(NX),Y(NY)
      DOUBLE PRECISION AC(NC),A0,A1,A2,A3,A4,A5,A6,FN,FL,WPOLY
      DOUBLE PRECISION FACTOR,DPOLY,CNORM
      DOUBLE PRECISION PN,PNP1,TM,TMP1,C,COV,VAL
C
      WPOLY(FL) = A0 + FL* (A1+FL* (A2+FL* (A3+FL* (A4+FL* (A5+FL*
     +            A6)))))
      DPOLY(FL) = A1 + FL* (B2+FL* (B3+FL* (B4+FL* (B5+FL*B6))))
C
C ... ASSIGN COEFFS
C
      A0     = AC(1)
      A1     = AC(2)
      A2     = AC(3)
      A3     = AC(4)
      A4     = AC(5)
      A5     = AC(6)
      A6     = AC(7)
      B2     = 2.D0*A2
      B3     = 3.D0*A3
      B4     = 4.D0*A4
      B5     = 5.D0*A5
      B6     = 6.D0*A6
C CNORM = 10.D0/YSTP
      CNORM  = 1.D0/YSTP
C
C ... CHECK FOR OUTPUT START
C
      START  = YSTR - 0.5*YSTP
      STARTL = START
      M1     = 1
      FN     = 0.5D0
C PN    = 10.D0*WPOLY(FN)
      PN     = WPOLY(FN)
      DELT   = PN - STARTL
      IF (DELT.GT.0.) THEN
          M1     = DELT/YSTP + 1.
          TMP1   = STARTL + M1*YSTP
          TM     = TMP1 - YSTP

      ELSE
          TMP1   = STARTL + YSTP
          TM     = STARTL
      END IF
C
C ... CHECK FOR INPUT START
C
      DO 10 N = 1,NX
          FN     = FN + 1.D0
          PNP1   = WPOLY(FN)
C   PNP1 = 10.D0*WPOLY(FN)
          IF (PNP1.GT.TM) GO TO 20
          PN     = PNP1
   10 CONTINUE
      N      = NX + 1
      GO TO 30

   20 C      = X(N)
   30 VAL    = 0.D0
      COV    = PNP1 - PN
C
C ... REBINNING LOOP
C
C      MMSP   = NSP
      MPT    = 1
      MST    = 1
      K      = 0
99    KZ6904 = 1
          IF ( .NOT. (MPT.LE.NY)) GO TO 80
          K      = K + 1
          IF ((K.LT.M1) .OR. (N.GT.NX)) GO TO 60
C ?
   40     IF (PNP1.EQ.PN) GO TO 90
          VAL    = VAL + C* (DMIN1(TMP1,PNP1)-DMAX1(TM,PN))/COV
          IF (TMP1.LT.PNP1) GO TO 50
          N      = N + 1
          IF (N.GT.NX) GO TO 60
          PN     = PNP1
          FN     = FN + 1.D0
C         PNP1 = 10.D0*WPOLY(FN)
          PNP1   = WPOLY(FN)
          C      = X(N)
          COV    = PNP1 - PN
          GO TO 40

   50     TM     = TMP1
          TMP1   = TMP1 + YSTP
   60     FACTOR = CNORM*DPOLY(FN)
          Y(MPT) = VAL*FACTOR
          MPT    = MPT + 1
          VAL    = 0.
      GOTO 99
   80 CONTINUE
   90 CONTINUE
      DO 100 K = MPT + 1,NY
          Y(K)   = 0.
  100 CONTINUE
      RETURN

      END

      SUBROUTINE REBINB(X,NAXISA,NPIXA1,NPIXA2,STARTA,STEPA,
     +           A1,IA1,Y,NPIXB1,NPIXB2,STARTB,STEPB)
C
C intermediate routine to rebin each line
C
      IMPLICIT NONE
      INTEGER      NAXISA,NPIXA1,NPIXA2,IA1,NPIXB1,NPIXB2,I
      REAL STARTA(2),STEPA(2)
      REAL STARTB(2),STEPB(2)
      DOUBLE PRECISION A1(1)
      REAL X(NPIXA1,NPIXA2),Y(NPIXB1,NPIXB2)

      DO 10 I = 1,NPIXA2
          CALL LREBI2(X(1,I),NPIXA1,STARTA,STEPA,A1,IA1,
     +         Y(1,I),NPIXB1,STARTB,STEPB)
   10 CONTINUE
      RETURN
      END

C @(#)joinmd.for	19.1 (ES0-DMD) 02/25/03 13:25:35
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C.IDENTIFICATION: JOINMD.FOR
C.LANGUAGE:       ESO-FOR
C.AUTHOR:         A. Kruszewski
C.KEYWORDS:       GALAXIES, IMAGES, SEARCH, STARS
C.ENVIRONMENT:    Portable MIDAS
C.COMMENTS:
C  subroutine JOINMD         version 3          820618
C  A. Kruszewski             ESO Garching
C  modified by               version 3.1        830905
C  Ch. Ounnas                ESO - Garching
C  modified to FX            version 3.2        870219
C  A. Kruszewski             Obs. de Geneve
C  modified to MSDOS         version 3.3        880610
C  A. Kruszewski             Warsaw U. Obs.
C.PURPOSE
C  joins together multiple detections of the same object
C  and checks if multiple detection corresponds to a single
C  or a double object
C.ALGORITHM
C  treats two detections as belonging to the same object if
C  they are no more than DLIM pixels apart
C.INPUT/OUTPUT
C  input arguments
C  A           real*4 array      image frame
C  JAPY        integer*4 array   pointers to image lines
C  IBUF        integer*4 array   limits of image buffer
C  IXYU        integer*4 array   limits of used area
C  NC          integer*4         number of entries in detection buffer
C  BCAT        real*4 array      real parameters of detections
C  MCAT        integer*4 array   integer parameters of detections
C  NL          integer*4         number of entries in catalog buffer
C  IDET        integer*4 array   rolling array with detections
C  NXS         integer*4         number of searched pixels in a line
C  ILIM        integer*4         maximal distance between detections of a
C                                single object
C  IARR        integer*4 array   values of integer keywords
C  RARR        real*4 array      values of real keywords
C  M           integer*4         number of detections
C  output arguments
C  ACAT        real*4 array      real parameters of detected objects
C  MM          integer*4         number of detected objects
C-----------------------------------------------------------------------
C
      SUBROUTINE JOINMD(A, JAPY, IBUF, IXYU, ACAT,
     &                  NC, BCAT, MCAT, NL, IDET,
     &                  NXS, ILIM, IARR, RARR, M, MM)
C
      IMPLICIT  NONE
      INTEGER   ILIM
      INTEGER   NC
      INTEGER   NL
      INTEGER   NXS
      REAL      A(1)
      INTEGER   JAPY(1)
      INTEGER   IBUF(4)
      INTEGER   IXYU(4)
      REAL      ACAT(5,NC)
      REAL      BCAT(2,NL)
      INTEGER   MCAT(4,NL)
      INTEGER   IDET(NXS,0:ILIM)
      INTEGER   IARR(32)
      REAL      RARR(64)
      INTEGER   M
      INTEGER   MM
C
      INTEGER   ISTAT
      INTEGER   JBE, JOFF
      INTEGER   K, L
      INTEGER   M1, M2, M3, M4
      INTEGER   MB
      INTEGER   MMB, MOB, MS
      REAL      B1, B2, GCUT
      REAL      TRLM , TRSH
C
      CHARACTER*80 TEXT
C
      TRSH = RARR(3)
      GCUT = 0.9 * RARR(2)
      JOFF = IBUF(2) - 1
      JBE = IBUF(4)
      MS = M - MOD( M-1 , NL ) - 1
      MMB = MOD( MM-1 , NC ) + 1
      M4 = 0
      M3 = 0
      M2 = 0
      M1 = 0
      B1 = 0.0
      B2 = 0.0
C
C ******      Find objects in last line of array IDET.
C
      DO 10 K = 1 , NXS
          MOB = IDET(K,ILIM)
          IF ( MOB .NE. 0 ) THEN
C
C ******            Read object's data.
C
            IF ( MOB .GT. MS ) THEN
                MB = MOB - MS
                M1 = MCAT(1,MB)
                M2 = MCAT(2,MB)
                M3 = MCAT(3,MB)
                M4 = MCAT(4,MB)
                B1 = BCAT(1,MB)
                B2 = BCAT(2,MB)
c            ELSE
c                READ ( ISF , REC=MOB ) M1, M2, M3, M4, B1, B2
            ENDIF
            IF ( M4 .EQ. 0 ) THEN
C
C ******                The object is identified.
C
                IF ( M3 .EQ. 0 ) THEN
C
C ******                  The detection is single.
C
                  IF ( MMB .EQ. NC ) THEN
                      WRITE (TEXT,'(A)') 'Too many detections'
                      CALL STTPUT(TEXT,ISTAT)
c                      CALL CTLG( ITF , START , STEP , ACAT ,
c     &                                          NC , MM , MMB )
c                      MMB = 0
                  ENDIF
                  MMB = MMB + 1
                  MM = MM + 1
                  ACAT(1,MMB) = FLOAT(M1)
                  ACAT(2,MMB) = FLOAT(M2)
                  ACAT(3,MMB) = B1
                  ACAT(4,MMB) = B2
                  TRLM = B1 + TRSH
                  CALL RADDET( A , JAPY , IBUF , M1 , M2 ,
     &                      IARR(22) , TRLM , B2 , TRSH , ACAT(5,MMB) )
                  IF ( ACAT(5,MMB) .LE. 0.0 .AND. B2 .LT. GCUT ) THEN
                      MMB = MMB - 1
                      MM = MM - 1
                  ENDIF
                ELSE
C
C ******                  The detection is multiple.
C
                  CALL MLTOBJ( A , JAPY , IBUF , JBE , IXYU ,
     &                        ACAT , NC , MCAT , BCAT , NL , M ,
     &                              MM , MMB , MOB , IARR , RARR )
                ENDIF
            ENDIF
          ENDIF
   10      CONTINUE
C
      DO 20 K = ILIM , 1 , -1
          DO 30 L = 1 , NXS
            IDET(L,K) = IDET(L,K-1)
   30          CONTINUE
   20      CONTINUE
        DO 40 L = 1 , NXS
          IDET(L,0) = 0
   40      CONTINUE
C
      RETURN
C
      END

C @(#)cpcntr.for	19.1 (ES0-DMD) 02/25/03 13:25:32
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENT:  subroutine CPCNTR         version 1.1       830907
C         A. Kruszewski             ESO Garching
C         modified for FX           version 1.2       870303
C         A. Kruszewski             Obs. de Geneve
C.PURPOSE:finds center of a blended component
C.INPUT/OUTPUT
C  input arguments
C
C  A           real*4 array      image frame
C  JAPY        integer*4 array   pointers to image lines
C  IBUF        integer*4 array   limits of image buffer
C  I           integer*4         x-coordinate of a parent object
C  J           integer*4         y-coordinate of a parend object
C  L           integer*4         octant of a component
C  K           integer*4         ring of a component
C  output arguments
C
C  IK          integer*4         x-coordinate of a component
C  JK          integer*4         y-coordinate of a component
C-----------------------------------------------------------------------
      SUBROUTINE CPCNTR(A, JAPY, IBUF, I, J, L, K, IK, JK)
C
      IMPLICIT  NONE
      INCLUDE  'MID_REL_INCL:INVENT.INC/NOLIST'
C
      REAL      A(1)
      INTEGER   JAPY(1)
      INTEGER   IBUF(4)
      INTEGER   I , J , L , K , IK , JK
C
      INTEGER   ICOR
      INTEGER   KK
      INTEGER   II1
      INTEGER   II2
      INTEGER   JJ1
      INTEGER   JJ2
      INTEGER   JJJ
      INTEGER   JOF
      INTEGER   III
      INTEGER   IDIST
      INTEGER   IARG
C
      REAL      TMP1
      REAL      TMP
C
C ****** Find approximate position IK,JK
C
      ICOR = NINT( 0.7071 * FLOAT(K) )
      IF ( L .EQ. 1 ) THEN
            IK = I + K
            JK = J
      ELSE IF ( L .EQ. 2 ) THEN
            IK = I + ICOR
            JK = J + ICOR
      ELSE IF ( L .EQ. 3 ) THEN
            IK = I
            JK = J + K
      ELSE IF ( L .EQ. 4 ) THEN
            IK = I - ICOR
            JK = J + ICOR
      ELSE IF ( L .EQ. 5 ) THEN
            IK = I - K
            JK = J
      ELSE IF ( L .EQ. 6 ) THEN
            IK = I - ICOR
            JK = J - ICOR
      ELSE IF ( L .EQ. 7 ) THEN
            IK = I
            JK = J - K
      ELSE IF ( L .EQ. 8 ) THEN
            IK = I + ICOR
            JK = J - ICOR
      ENDIF
C
C ******      Define square to be searched for highest pixel.
C
      TMP = 0.0
      KK = NINT( 0.4 * FLOAT(K) ) + 1
      II1 = MAX( IBUF(1) , IK - KK )
      II2 = MIN( IBUF(3) , IK + KK )
      JJ1 = MAX( IBUF(2) , JK - KK )
      JJ2 = MIN( IBUF(4) , JK + KK )
C
C ******      Find highest pixel in an arc of radius k crossing
C ******      small square centered on approximate position.
C
      DO 10 JJJ = JJ1 , JJ2
            JOF = JJJ - IBUF(2) + 1
            DO 20 III = II1 , II2
                  IARG = JAPY(JOF) + III
                  TMP1 = A(IARG)
                  IF ( TMP1 .GT. TMP ) THEN
                        IDIST = (I-III)*(I-III)+(J-JJJ)*(J-JJJ)
                        IDIST = NINT( SQRT( FLOAT( IDIST ) ) )
                        IF ( IDIST .EQ. K ) THEN
                              TMP = TMP1
                              IK = III
                              JK = JJJ
                        ENDIF
                  ENDIF
   20            CONTINUE
   10      CONTINUE
C
      RETURN
      END

C @(#)dlsq.for	19.1 (ES0-DMD) 02/25/03 13:28:46
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C  @(#)dlsq.for	19.1  (ESO-IPG)  02/25/03  13:28:46
      SUBROUTINE DLSQ(YP,NPTS,NPARMS,NBLOX,MBLOK,NIX,NARGS,NKARGS,TEST)
C
C  14 OCT 1985 VERSION.    **********     USES PARTITIONING.
C
C       Copyright (C) Andrew T. Young, 1990, 1991
C
C  Fits data to nonlinear models by Damped Least Squares.
C  (This version uses robust estimation.)
C
C
C   ARGUMENTS:
C
C  YP      is the subroutine called to calculate YT and PARTial derivs.
C             --> MUST be declared EXTERNAL in calling pgm!
C  NPTS    is the number of Data POINTS in the problem.
C             --> must be .LE. MXPT.
C  NPARMS  is the Number of PARAMETERS actually adjusted.
C             --> must be .LE. MXP.
C  NBLOX   is the Number of BLOCKS in the block-diagonal (first)
C             part of the normal eqns.
C  MBLOK   is the Number of PARAMETERS in a Block.
C             --> (NBLOX*MBLOK) must be .LE. NPARMS.
C  NIX     is the Number of Parameters that are held FIXed.
C             --> must be .LE. NPARMS.
C  NARGS   is the Number of REAL independent variables actually used.
C             --> must be .LE. MXX.
C  NKARGS  is the Number of INTEGER independent variables actually used.
C             --> must be .LE. MKX.
C  TEST    When the relative change in every parameter is less than
C             TEST, we are done.
C
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        IMPLICIT INTEGER (I-N)
C
        EXTERNAL YP
        REAL TEST
C
      INCLUDE 'MID_REL_INCL:kingfit.inc'
C     PARAMETER (MXPT=xxx, MXX=1, MKX=x, MXP=xxx)
C
C       MXPT = MAXimum number of data POINTS.
C
C       MXP  = MAXimum number of Parameters.
C
C       MXX  = MAX.no.of real independent variables.
C
C       MKX  = MAX.no.of integer independent variables.
C
      INCLUDE 'MID_REL_INCL:dlsq.inc'
C       Defines common/LEASTC/; Equiv's (KDUM,MAXK etc.)
C
C
C  The above COMMON & PARAMETER statements MUST be in both the subroutine
C  YP, which the user supplies, and the main program that uses these
C  subroutines.  ****  The ORDERING of  /LEASTC/  MUST be identical.
C
C
C  Here are the variables in /LEASTC/:
C
C   A    is the matrix of normal equations, or (on exit) its inverse.
C  DUM   is a DUMmy set of Real numbers carried throughout the problem.
C        These may be used to transmit information to YP directly
C        from the calling program.  May be removed or redimensioned.
C  KDUM  is a DUMmy set of integers (same purpose).
C  IDF   is the number of Degrees of Freedom, not counting points
C           with zero weight.
C  KIP   is the number of active Partials for each datum.  (set in YP.)
C  IP    Indexes the active Partials for each datum.  (set in YP.)
C  IPR   is the print flag.  IPR > 0 produces output on the progress of
C             the iterations.
C          IPR = 1 gives WVAR, DAMP, & MODE; IPR = 2 gives P's as well;
C          IPR = 3 adds internal state & SCALE; IPR=7 checks derivatives.
C  IT    is the ITeration number.  (limited to MAXIT.)
C  IX    are the 'serial numbers' of parameters that are held FIXed
C           for a particular problem.  Only the first NIX of the
C           IX's are used  (see example below).
C  MAXP  is the MAX.no.of P's being used (=NPARMS, to YP via /LEASTC/).
C  NEQS  is the number of equations being used ( = NPARMS-NIX ).
C  NONEQ tells subroutine YP whether partial derivatives are needed.
C           NONEQ = 0 if needed,   NONEQ =1 if "NO Normal EQuations".
C  NPT   is the Number of the datum Y() being processed in YP.
C  PG    are Preliminary Guesses (starting values).
C  P     are the values of the PARAMETERS being solved for.
C  PART  are the PARTial derivatives of YT with respect to the P's.
C  SP    are the Standard deviations of the Parameters.
C  W     are the Weights associated with the  Y  data.
C  WVAR  is the Weighted VARiance.  STD.ERR.(unit wt) = sqrt(WVAR).
C  X     are the Real  INDEPENDENT  variables.  The I th value of the
C           J  th indepedent variable is  X(J,I).
C  KX    are the Integer  INDEPENDENT  variables (similar indexing).
C  Y     are the  DEPENDENT  variables. (data being fit)
C  YC    are the values of Y Calculated for the
C           current values of the parameters, P.
C  YT    is the value of the fitted fcn.calc.by YP for arguments Z, KZ.
C  Z(J)  = X(J,NPT).
C KZ(J)  = KX(J,NPT).
C
C  Example of use of IX:  to fix the 2nd,5th, and 6th parameters,
C              set NIX=3, IX(1)=2, IX(2)=5, and IX(3)=6.
C  NOTE: Order is unimportant.  If all P are held fixed, DLSQ gives
C        residuals.
C
C
C   Use of KIP, IP, etc. and the YP subroutine:
C
C   YP generates the value of YT for each equation of condition.
C      It also generates the values of KIP partial derivatives, PART.
C      In block-diagonal problems, these are only a small subset of the
C      total number of partials.  The ones that are generated are listed
C      in the IP array; e.g., if the 4 partials PART(1), PART(2), PART(5),
C      and PART(9) are non-zero for a given datum, then set KIP=4 and
C      IP(1)=1, IP(2)=2, IP(3)=5, and IP(4)=9 in YP.  The order is not
C      important -- it's just a list to tell this subroutine which PARTs
C      are non-zero.  This saves a lot of time in building the normal
C      equations in sparse, block-diagonal problems.  YP may generate
C      other, unused partials, but they should not be returned to this
C      program in the IP list.
C
C   Note that MAXP (= NPARMS) and NEQS are both available in /LEASTC/
C   so that YP can decide which PARTs to index in IP.  Note also that
C   the block to which a given datum contributes (in block-diagonal
C   problems) is usually inferred from the KZ (KX in calling pgm.)
C   integer variables.
C
C
C   There is a conflict between this and earlier versions of DLSQ.
C   To preserve the block-diagonal format of the normal equations, we
C   have to carry ALL the P's through the solution, even if some are
C   kept fixed.  This is handled here by NOT indexing the normal eqns.
C   The equations corresponding to a non-zero IX(n) are simply replaced
C   by a 1 on the main diagonal, and zeros on RHS (i.e., in B).
C
C   This makes this version less efficient than the older one for simple
C   problems.  Also, we lose more efficiency here in problems with NBLOX=1
C   because we explicitly invert the matrix.  But for little problems, who
C   cares?
C
C   Note that this version stores the input data (X, Y, W, and PG) as REAL,
C   but does the matrix work (A, B, P, YT, YC, WVAR) in DOUBLE PRECISION.
C
C
C   LOCAL variables:
C
      DIMENSION B(MXP),DP(MXP),PC(MXP),PLOW(MXP)
      DIMENSION WT(MXPT)
      REAL S1(MXPT)
C
C   B    is the RHS vector (in the normal equations: AX = B ).
C   DP   is the change to P(I) on each iteration.
C   PC   = P(I) + DP(I)  is the Corrected value of P.
C   PLOW is the set of P's that gave the LOWest value of WVAR in the past.
C   USED is .TRUE. if the corresponding P is *not* in the IX list.
C   USED is .FALSE. if the corresponding P *is* in the IX list.
C   PAGE is used to store the printed version of matrix rows.
C   S1   is used to save residuals for sorting.
C
C
      LOGICAL PARTSW, USED(MXP), HUBER
      CHARACTER*79 CARD,PAGE(MXP/4+1)
C
      DATA PARTSW/.FALSE./,MAXIT1/99/
C
C  ***********************  INITIALIZE EVERYTHING  ******************
C
      MODE=0
      NZD=0
      K=0
      IT=0
      IRESET=0
      LAST4=0
      NONEQ=0
C  Compute variance but not normal equations if NONEQ.NE.0.
      WVAR=0.
      RESETS=0.
      RESTART=0.
      SCALE=0.
      IF (MAXIT.EQ.0.) MAXIT=MAXIT1
      OLDVAR=-1.
      DAMP=1.E-4
      FACTOR=100.
      HUBER=.TRUE.
      RTTEST=SQRT(TEST)
      MAXP=NPARMS
      NEQS = NPARMS - NIX
C   NEQS=No. of parameters actually solved for.
      FNEQS=NEQS
C
C     Dummy write to space o/p.
      IF (IPR.GT.0) CALL SPACE2
      DO 80 I=1,NPARMS
      DP(I)=0.0
      PART(I)=0.0
      P(I)=PG(I)
      PC(I)=PG(I)
      PLOW(I)=PG(I)
      DO 75 J=1,NIX
         IF (IX(J).LE.0 .OR. IX(J).GT.NPARMS) THEN
            WRITE(CARD,'(A,I4,A,I4)')'Invalid entry in IX(',J,')=',IX(J)
            CALL TV(CARD)
            GO TO 80
         else IF(I.EQ.IX(J)) THEN
            USED(I)=.FALSE.
            DO 70 KK=J+1,NIX
C              make sure there are no dupes...
               IF (I.EQ.IX(KK)) THEN
                  WRITE(CARD,'(I4,A,I4,A)')i,' Duplicated in IX(',J,')'
                  CALL TV(CARD)
                  GO TO 80
               END IF
   70       CONTINUE
C           OK, I is a legal IX and is not repeated in rest of IX list.
            K=K+1
            GO TO 80
         END IF
   75 CONTINUE
      USED(I)=.TRUE.
   80 CONTINUE
      IF (NPTS.LT.NEQS) THEN
          CALL TV('More unknown parameters than data!')
          RETURN
      END IF
C
C  NOTE:
C    --> YP *MUST* return KIP and IP, as well as YT and PART's.
C
C  K should equal NIX, but is less if IX contains duplicates.
C
      IF(K.LT.NIX) THEN
          WRITE(PAGE,85)NIX,K,NPARMS,IX
   85 FORMAT('WARNING: The first',I4,' entries of IX contain only',I4,
     1' unique values .LE.',I4/(10I4/))
          CALL TV(PAGE(1))
          DO 86 I=2,NPARMS/4+1
   86     CALL TVN(PAGE(I))
          CALL STSEPI
      END IF
C
C  **********************************************   END SETUP  ******
C
      NONEQ = 1
C  NONEQ=1 suppresses partials in YP & normal eqns.
      IF (NEQS.EQ.0) GO TO 120
C
C  INITIALIZE FOR NORMAL EQNS.  **************BEGIN ITERATION *******
  100 IT=IT+1
C$$$
      IF(IT.GE.MAXIT)GOTO 905
C$$$
C  IT is the iteration counter.
C
  101 K=0
      NREJ=0
      NUSED=0
      IF (HUBER) THEN
         CTUNE=1.5
      ELSE
         CTUNE=6.
         SCLNUM=0.
         SCLDEN=0.
      END IF
      CS=CTUNE*SCALE
      DO 105 I=1,NPARMS
      B(I)=0.
      DO 105 J=1,I
      K=K+1
  105 A(K)=0.
C
  120 VAR=0.
C  NOW FORM NORMAL EQNS.  **********  BEGIN NORMAL EQUATIONS.********
C
C  Form EQ.OF COND. for NPT-th point.
      DO 129 NPT=1,NPTS
      DO 121 J = 1, NARGS
  121 Z(J) = X(J,NPT)
      DO 122 J=1,NKARGS
  122 KZ(J)=KX(J,NPT)
C
      CALL YP
C
C   note that all values are transmitted via COMMON /LEASTC/
C
      YC(NPT) = YT
      IF(W(NPT).EQ.0.) GO TO 129
C  Skip zero-weight points.   ******** ACCUMULATE VARIANCES. ********
      DY = Y(NPT) - YT
      IF (SCALE.NE.0.) THEN
C         normal iteration.
          U=DY/CS
C         CS valid for unit weight, so include weight here.
          USQ=U*U*W(NPT)
C
          IF(MODE.EQ.0) THEN
C             adjust weights.
              IF (HUBER) THEN
                  IF (USQ.GE.1.) THEN
                      WT(NPT)=W(NPT)/USQ
                      NREJ=NREJ+1
                  ELSE
                      WT(NPT)=W(NPT)
                  END IF
              ELSE
C                 Compute biweight:
                  IF (USQ.GE.1.) THEN
                      WT(NPT)=0.
                      GO TO 129
                  ELSE
                      WT(NPT)=W(NPT)*(1.-USQ)**2
                  END IF
              END IF
          END IF
C
          IF (WT(NPT).EQ.0.) GO TO 129
          VAR=VAR+WT(NPT)*DY*DY
C         prepare to reset scales.
          NUSED=NUSED+1
          IF (HUBER) THEN
C            use MAD:
             S1(NUSED)=W(NPT)*DY*DY
          ELSE
C            do sums for A-estimator:
             SCLNUM=SCLNUM + WT(NPT)*DY*DY*(1.-USQ)**2
             SCLDEN=SCLDEN + (1.-USQ)*(1.-5.*USQ)
          END IF
      ELSE
C         initial iteration.
          NUSED=NUSED+1
          S1(NUSED)=W(NPT)*DY*DY
      END IF
C  Skip normal equations if not needed.
      IF(NONEQ.NE.0) GO TO 129
      NULKIP=0
C       KIP and IP are set by YP.
      DO 123 J=1,KIP
          I1=IP(J)
          IF (.NOT.USED(I1) .OR. PART(I1).EQ.0.) THEN
C           shrink IP stack.
            NULKIP=NULKIP+1
          ELSE
            IF(NULKIP.NE.0) IP(J-NULKIP)=IP(J)
          END IF
  123 CONTINUE
C  Add CONTRIBUTION of NPT-th point to NORMAL EQUATIONS.
      DO 125 I=1,KIP-NULKIP
      I1=IP(I)
C ***  IF(kindex(I1).ne.0. .and. PART(I1).NE.0.)THEN
      TERM=PART(I1)*WT(NPT)
      B(I1)=B(I1)+TERM*DY
      DO 124 J=1,I
          J1=IP(J)
C *** if (kindex(J1).eq.0.) go to 124
          K= (MAX(J1,I1) -1) * MAX(J1,I1) /2
     1       +MIN(J1,I1)
          A(K)=A(K)+TERM*PART(J1)
  124 CONTINUE
C ***  END IF
  125 CONTINUE
C  The above is very efficient.  DON'T MESS!
  129 CONTINUE
C
C     Make sure VAR is OK:
      IF (VAR.GE.0. .AND. VAR.LT.3.E33) THEN
C        VAR is OK.
      ELSE
C        VAR is bad.  Force reset:
         IF (IPR.GT.0)
     1      WRITE (CARD,'(''VAR has unreasonable value: '',E8.2)')VAR
         CALL TV(CARD)
         VAR=CAP+1.
         GO TO 136
      END IF
C
      IF (SCALE.EQ.0.) THEN
C         set initial scale to 1.4*median of rough estimates.
          IF (NUSED.EQ.0) THEN
             CALL TV('NUSED=0.  Probably all data have weight 0.')
             CALL STSEPI
          END IF
          CALL SORT1(S1,NUSED)
          SCALE=SQRT(S1((NUSED+1)/2) + S1(NUSED/2+1))
          IF (NEQS.GT.0) NONEQ=0
          IF (SCALE.LE.0.) THEN
              SCALE=1.
              IF (IPR.GT.0) CALL TV('SCALE fell to zero at 129.')
          END IF
          GO TO 101
      END IF
C
      IF(IPR.LT.2 .OR. MODE.NE.5) GO TO 135
C
C  PRINT normal equations on final pass.....
      CALL SPACE2
      WRITE(CARD,131)
  131 FORMAT(3X,'I',30X,'A(I,J)',30X,'B(I)')
C       formats 131 - 133 changed to fit on 80-col.screen.
      CALL TV(CARD)
      CALL SPACE2
      K=0
      DO 134 I=1,NPARMS
         IF (.NOT.USED(I)) GO TO 134
         WRITE(PAGE,132)I,(A(J),J=K+1,K+I)
  132    FORMAT(I4,1P5E15.5/(E19.5,4E15.5))
         CALL PRPAGE(PAGE,(I+4)/5)
         WRITE(CARD,133) B(I)
  133    FORMAT(63X,1PE16.7)
         CALL TVN(CARD)
         CALL SPACE2
         K=K+I
  134 CONTINUE
C     Print a row of *'s:
      WRITE(CARD,555)
      CALL TV(CARD)
C
  135 IF(NEQS.EQ.0 .OR. MODE.EQ.5) GO TO 800
        IF(MODE.EQ.6) GO TO 498
C                          ****** NORMAL EQUATIONS COMPLETE.   ******
      IF(OLDVAR.EQ.-1.)THEN
         ABSMIN=VAR
         CAP=VAR+VAR
         GO TO 230
      END IF
C                                ********** TEST VARIANCES **********
C    ***
  136   IF(VAR.LT.CAP)THEN
C    ***
C  WELL-BEHAVED.
        IF (VAR.EQ.0.) GO TO 800
C   --
       IF(VAR.LE.OLDVAR .AND. NREJ*5.LT.NPTS)THEN
C   --
C   previous iteration went downhill, safely.
      MODE=2
      IF(DAMP.EQ.0.) NZD=NZD+1
C
        IF(VAR.LT.ABSMIN)THEN
C    we are at a new low.
          DO 139 I=1,NPARMS
  139     PLOW(I)=P(I)
          CAP=CAP+VAR
          ABSMIN=VAR
          IF(DAMP.NE.0.) FACTOR=FACTOR*1.2
          MODE=4
          LAST4=IT
        END IF
C
          IF (MODE.EQ.4) THEN
             DAMP=DAMP/FACTOR
          ELSE IF (MODE.EQ.2) THEN
             IF(DAMP.EQ.0. .AND. NZD.GE.5+IT/20)THEN
               NZD=0
C              Restore damping if undamped not converging.
               DAMP=TEST
            END IF
            DAMP=DAMP*(RESETS+1.)/(RESETS+2.)
          END IF
C   --
       ELSE
C   --
C    if many rejects, continue without adjustment.
         IF (VAR.LT.OLDVAR) THEN
           MODE=3
           GO TO 231
         END IF
C    previous iteration went uphill, but safe.
         IF(VAR.GT.SQRT(ABSMIN*CAP)) DAMP=(DAMP+1.E-9)*(FACTOR+FACTOR)
         FACTOR=SQRT(FACTOR)+1.
         MODE=1
         IF(LAST4.EQ.0) DAMP=DAMP*2.
         DAMP=DAMP*10.**(MAX(0,(IT-LAST4)+4/(IT+1-IRESET))/6) + 1.E-9
C   --
       END IF
C   --
C   prevent endless wandering above absmin.
      IF(MODE.NE.4) CAP=ABSMIN+CAP/2.
C    ***
        ELSE
C    ***
C  VAR.gt.CAP, or dangerous number of rejects.
C
      RESETS=RESETS+1.
      FACTOR=1.+SQRT(FACTOR)
          IF (CAP.LE.0. .OR. RESETS.GT.100.) THEN
             DO 205 NPT=1,NPTS
                IF (W(NPT).LT.0.) THEN
                   CALL TV('Negative weight -- PROGRAM ERROR !!')
                   CALL STSEPI
                END IF
  205        CONTINUE
             IF (IPR.GT.0) CALL TV('Weights checked -- OK.')
          END IF
                        IF(IPR.GT.0)THEN
                           WRITE(CARD,*)CAP,RESETS,NREJ,SCALE
                           CALL TV(CARD)
                           WRITE(CARD,*) FACTOR, DAMP
                           CALL TVN(CARD)
                        END IF
        IF(DAMP.EQ.0.)THEN
          DAMP=1.E-4*FACTOR
          IF (IPR.GT.0) CALL TV('DAMP reset to 1.E-4')
        ELSE IF(IRESET.EQ.IT) THEN
C         Reset loop.  Raise CAP.
               MODE=0
               OLDVAR=-1.
          CAP=VAR+2.*(VAR-ABSMIN)
          IF (CAP.LE.0.) CAP=1.+RESETS
                  CALL TV('Reset looping.')
          DAMP=FACTOR*(DAMP+1.E-4)
          IF (DAMP.GT.1./TEST) GO TO 905
        ELSE IF(RESETS.GT.1.) THEN
          DAMP=DAMP*FACTOR*RESETS
          CAP=(CAP+ABSMIN+ABSMIN)/2.
        ELSE
C         Big damp on 1st reset.
          DAMP=FACTOR
C         sets damp to 1.
        END IF
C
C  Restart from best previous position.          *****  RESET  *****
      OLDVAR=ABSMIN
      IF(IPR.GT.0) THEN
         WRITE(CARD,208)
  208    FORMAT(68X,'RESET *****')
         CALL TV(CARD)
      END IF
      IRESET=IT
      DO 210 I=1,NPARMS
  210 P(I)=PLOW(I)
      GO TO 101
C    ***
        END IF
C    ***
  230 OLDVAR=VAR
  231 CONTINUE
C
C  ****************************  NOW SOLVE NORMAL EQUATIONS. ********
      DO 490 I=1,NPARMS
      K=I*(I+1)/2
C       Diagonal element: ignore missing parms...
      IF (A(K).EQ.0.D0) A(K)=1.D0
  490 CONTINUE
       IF((1.+DAMP).EQ.1.)THEN
      DAMP=0.
      GO TO 500
       END IF
C                       Check derivatives if IPR=7:
                         IF (IPR.EQ.7) GO TO 905
      IF(DAMP.LE.1./TEST) GO TO 498
      WRITE(CARD,491)DAMP
  491 FORMAT('EXCESSIVE DAMPING',1PE10.1,
     1' possibly due to bad derivatives in YP,')
      CALL TV(CARD)
      CALL TVN('very bad starting values, or unsuitable model.')
      GO TO 905
C
  495 WRITE(CARD,496)DAMP,IT
  496 FORMAT('DAMP =',1PE10.2,' gave SINGULAR MATRIX on iteration',I3)
      CALL TV(CARD)
      IF (IPR.GT.0) THEN
         WRITE(CARD,*)'PARTIT was called with NEQS=',NEQS,
     1                     ' NBLOX=',NBLOX,' MBLOK=',MBLOK
         CALL TV(CARD)
      END IF
      IF(MODE.EQ.5) GO TO 905
      DAMP=(DAMP+1.E-9)/1.E-4
C   force reset.
      VAR=CAP+CAP+1.E-4
      GO TO 136
C
C       Apply damping...
  498 DO 499 I=1,NPARMS
      K=I*(I+1)/2
  499 A(K)=A(K)*(1.+DAMP)
        IF(MODE.EQ.6) GO TO 800
C
  500 CALL PARTIT(A,NPARMS,SP,NBLOX,MBLOK,*495)
C  use SP as SCRATCH SPACE to invert A, so X = (A-1)*B.
      K=0
C   FORM X IN SP.
      DO 520 I=1,NPARMS
      SP(I)=0.
C    FIRST PART.
      DO 510 J=1,I
  510 SP(I)=SP(I)+A(K+J)*B(J)
      K=K+I
C    SECOND PART.
      KOL=K+I
      DO 512 J=I+1,NPARMS
      SP(I)=SP(I)+A(KOL)*B(J)
  512 KOL=KOL+J
  520 CONTINUE
C
C     *****   NORMAL EQNS.NOW SOLVED, SOLN.IN SP.   REVISE PC'S. ******
C  UPDATE P'S.
      DO 540 I=1,NPARMS
      DP(I) =SP(I)
      PC(I) = P(I) + DP(I)
  540 Continue
C                                   **********  PC'S NOW SET. *******
      IF(IPR.EQ.0) GO TO 580
      WRITE(CARD,550) IT, VAR, SCALE, MODE
  550 FORMAT('IT =',I3,6X,'WVAR =',1PE22.15,6X,'SCALE =',E9.2,6X,
     1'MODE =',I2)
      CALL TV(CARD)
      IF (IPR.GT.1) THEN
         WRITE(CARD,551) FACTOR, CAP, DAMP
  551    FORMAT(13X,'FACTOR =',F6.2,5X,'CAP =',1PE9.2,5X,'DAMP =',E10.3)
         CALL TVN(CARD)
      END IF
      IF(IPR.EQ.1) GO TO 580
      WRITE(CARD,552)
  552 FORMAT('VAR.NO',6X,'PG',13X,'P',14X,'PC',13X,'DP')
      CALL TV(CARD)
      CALL SPACE
      DO 553 J=1,NPARMS
      IF (IPR.LT.3 .AND. .NOT.USED(J)) GO TO 553
      I=J
      WRITE(PAGE,132) I,PG(I),P(I),PC(I),DP(I)
      CALL PRPAGE(PAGE,1)
  553 CONTINUE
C
C  omit fixed P's unless this is last iteration.
       IF(MODE.EQ.5 .AND. NIX.NE.0)THEN
      WRITE(CARD,'('' Fixed Parameters:'')')
      CALL TVN(CARD)
      DO 554 J=1,NIX
      I=IX(J)
  554 WRITE(PAGE,132) I,PG(I),P(I)
      CALL PRPAGE(PAGE,1)
       END IF
C
      IF(IPR.GE.2)THEN
         WRITE(CARD,555)
  555 FORMAT(39(' *'))
         CALL TV(CARD)
      END IF
C
  580 DO 590 I=1,NPARMS
  590 P(I)=PC(I)
C     prevent changes to weights.
      IF(MODE.EQ.0) MODE=7
C            *************** END OF ITERATION ********************
      IF(IT.LT.MAXIT) GO TO 670
      WRITE(CARD,667)MAXIT
  667 FORMAT('DLSQ  DID NOT CONVERGE in',I3,' iterations.',16(' $'))
      CALL TV(CARD)
      GO TO 790
C
  670 CONTINUE
C     Recompute scale:
      IDF=NPTS-NEQS
      IF (IDF.LT.0) THEN
          CALL TV('You are trying to solve for more parameters than')
          CALL TVN('the number of available data!')
          CALL TV('QUITTING')
          CALL STSEPI
      ELSE IF (IDF.EQ.0) THEN
          CALL TV('No degrees of freedom left!')
          GO TO 790
      END IF
C
      IF(HUBER) THEN
C        check for excesssive rejected points (scale too small):
         IF ( (NREJ*5.GT.NPTS .AND. IT.GT.1) .OR.
     1          NPTS-NREJ.LT.NEQS) THEN 
                        IF (IPR.GT.0) CALL TVN('Restarted at 671')
            MODE=0
            RESTART=RESTART+1.
            SCALE=SCALE*3.
            OLDVAR=-1.
            DAMP=1.
            DO 671 I=1,NPARMS
  671       P(I)=PLOW(I)
            GO TO 100
         END IF
         IF (MODE.GT.1) THEN
C           see if we can use a redescending M-estimator:
            HUBER=.FALSE.
            DO 672 I = 1,NPARMS
               IF(ABS(DP(I)).GT.ABS(P(I)/128.)) HUBER=.TRUE.
  672       CONTINUE
         END IF
         IF (.NOT.HUBER) THEN
C           may be ready to switch.
            CALL SORT1(S1,NUSED)
            IF (IDF.GT.NREJ) THEN
              SCLNEW=SQRT(((S1((NUSED+1)/2) + S1(NUSED/2+1))*NEQS)/IDF)
            ELSE
              SCLNEW=SCALE*1.2
            END IF
            IF (ABS(SCLNEW-SCALE).GT.SCALE/16. .AND. RESTART.LT.3.)THEN
C               not converged.  Keep Huber.
                HUBER=.TRUE.
                DAMP=DAMP+1.E-9
            ELSE
C               converged, so can switch.
                DAMP=1.E-4
                IF (IPR.EQ.1) CALL TV('Using BIWEIGHT')
            END IF
C           re-scale, in any case.
            IF (RESTART.LT.3.) SCALE=SCLNEW
                        IF (IPR.GT.0) CALL TVN('Restarted at 672')
            MODE=0
            OLDVAR=-1.
         END IF
      ELSE
C        using biweight.
         IF (SCLDEN.GT.1. .AND. NPTS-NREJ.GT.NEQS) THEN
            SCLNEW=SQRT(NUSED*SCLNUM/(SCLDEN*(SCLDEN-1.)))
         ELSE
            SCLNEW=SCALE*2.
         END IF
         IF (ABS(SCLNEW-SCALE).GT.SCALE*RTTEST)THEN
C           need more iterations.
            IF (MODE.EQ.4) THEN
               IF(SCLNEW.GT.0. .AND. ABS(SCLNEW-SCALE).GT.SCALE/16.)THEN
                  DAMP=DAMP+1.E-9
                  MODE=0
C                       IF (IPR.GT.0) CALL TVN('Restarted at 673')
                  OLDVAR=-1.
               END IF
C		   debug biweight:
C                  write(card,*)SCALE,SCLNEW,NUSED
C                  call tv(card)
               IF (SCLNEW.GT.SCALE/2.) THEN
C                 fudge to allow for effects of scale change:
                  ABSMIN=ABSMIN*1.00000001D0
                  IF (SCLNEW.GT.SCALE) THEN
C                    Scale is increasing; adopt full change.
                     SCALE=SCLNEW
                     ABSMIN=ABSMIN*1.00000001D0
                  ELSE
C                    Scale is decreasing; adopt half change.
                     SCALE=(SCLNEW + SCALE)*0.5
                  END IF
               ELSE IF(SCLNEW.GT.0.) THEN
c                 Allow cautious decrease.
                  SCALE=SCALE*0.9
               END IF
            END IF
            GO TO 100
         END IF
      END IF
C
C     HUBER is now false if we can use biweight.
                IF (IPR.GT.1) THEN
                        IF(HUBER) THEN
                           CALL TV('HUBER')
                        ELSE
                           CALL TV('BIWEIGHT')
                        END IF
                END IF
      IF (HUBER) GO TO 100
C
C  TEST PARAMETERS for CONVERGENCE.  *******  (AT END OF ITERATION.)
      DO 775 I = 1,NPARMS
C                  debugging:
C                  write(card,*)I,DP(I),P(I)
C        IF(ABS(DP(I)).GT.ABS(TEST*P(I))) call tv(card)
         IF(ABS(DP(I)).GT.ABS(TEST*P(I))) GO TO 100
C  skip to 100 for another iteration if TEST is not met.
  775 CONTINUE
C  here if TEST is met by all non-zero P's.
      IF(DAMP.GT.RTTEST .OR. MODE.LT.4) GO TO 100
C  do not quit if overdamped.
C                            ******  FINAL RESULTS NOW  *********
  790 MODE=5
C  use lowest values for final results.
      DO 791 I=1,NPARMS
      P(I)=PLOW(I)
  791 PC(I)=PLOW(I)
C  do inverse of undamped matrix to find SP's.
      GO TO 101
C  get normal eqns.for final values.  return here from 135.
  800 DO 801 I=1,NPARMS
      K=I*(I+1)/2
C       Diagonal element: ignore missing parms...
      IF (A(K).EQ.0.D0) A(K)=1.D0
  801 CONTINUE
      CALL PARTIT(A,NPARMS,SP,NBLOX,MBLOK,*880)
C  USE SP AS SCRATCH SPACE TO INVERT A.
C
C  ************* CLEAN UP FINAL LEFTOVERS WHEN PROBLEM IS SOLVED.****
C  get final residuals and covariances, then
C  compute variances of parameters.
  802 I=0
      DO 810 NPT=1,NPTS
      IF(W(NPT).EQ.0.) I=I+1
C  remove deleted points from degrees of freedom.
  810 CONTINUE
      IDF = NPTS - NEQS - I
      IF(NEQS.EQ.0 .OR. IPR.LT.2) GO TO 820
C  print inverse matrix if IPR < 2.
      WRITE(CARD,812)
  812 FORMAT(3X,'I',30X,'Inverse of A(I,J)')
      CALL TV(' ')
      CALL TV(CARD)
      CALL TV(' ')
      K=0
      DO 815 I=1,NPARMS
      IF (.NOT.USED(I)) GO TO 815
      WRITE(PAGE,132)I,(A(J),J=K+1,K+I)
      CALL PRPAGE(PAGE,(I+4)/5)
      CALL TV (' ')
  815 K=K+I
      CALL TV (' ')
      WRITE(CARD,818)IT
  818 FORMAT(I6,' Iterations')
      CALL TV(CARD)
C
  820 IF(IDF.GT.0) WVAR=VAR/FLOAT(IDF)
C    clear SP.
      DO 830 I=1,NPARMS
  830 SP(I)=0.
C  compute STD.ERR's of P'S.
      DO 850 J=1,NPARMS
      I=J
      IF(A(J*(J+1)/2).LE.0.) A(J*(J+1)/2)=1.E38
C   fix up bad results from singular matrices.
      IF (.NOT.USED(I)) THEN
          SP(I) =0.D0
      ELSE
          SP(I) =SQRT(A(J*(J+1)/2)*WVAR)
      END IF
  850 CONTINUE
      RETURN
C  NORMAL TERMINATION. *****
C
C   singular matrix on cleanup:
  880 WRITE(CARD,496) 0.,IT
      CALL TV(CARD)
      IF (MODE.EQ.6) THEN
        DAMP=DAMP*4.
      ELSE
        DAMP=1./2.**48
        MODE=6
      END IF
      WRITE(CARD,901) DAMP
 901  FORMAT('Final matrix inversion damped by ',
     2       1PE9.2,' for stability')
C
C       ...but we have to regenerate the A matrix now.
      CALL TVN(CARD)
      GO TO 101
C
  905 WRITE(CARD,906) NEQS,NIX
  906 FORMAT('DLSQ FAILED.  No. of parameters VARIED =',I3,6X,
     1'No. held fixed =',I3)
      CALL TV(CARD)
      call SPACE2
      call tv('     checking derivatives...')
      CALL SPACE
C                     ******* CHECK DERIVATIVES NUMERICALLY. ******
C  DO ONCE ONLY.
      IF(PARTSW) GO TO 999
C     PARTSW=.TRUE.
      DO 910 I=1,NPARMS
C       denominator is 16777216.d0 for double-precision P's.
        DP(I)=P(I)/16777216.D0
        IF(DP(I).EQ.0.) DP(I)=1./16777216.D0
  910 CONTINUE
      TERM=0.
      VAR=0.
      DO 930 NPT=1,NPTS
      DO 915 J=1,NARGS
  915 Z(J)=X(J,NPT)
      DO 916 J=1,NKARGS
  916 KZ(J)=KX(J,NPT)
      NONEQ=0
C   COMPUTE PART.DERIV.'S IN YP.
      CALL YP
      YC(NPT)=YT
      NONEQ=1
      DO 920 J=1,NPARMS
      I=J
      PC(I)=P(I)
C     skip unused P's:
      IF (.NOT.USED(J)) GO TO 920
      P(I)=P(I)+DP(I)
      CALL YP
      DY=YT-YC(NPT)
      DY=DY/DP(I)
      IF(DY.EQ.0.) GO TO 920
C    SKIP ZERO TERMS.
      TERM=TERM+DY*DY
      VAR=VAR+(PART(I)-DY)**2
  918 IF(IPR.GT.1) THEN
         WRITE(CARD,919)NPT,I,PART(I),DY
  919    FORMAT(' Point no.',I5,5X,'PART(',I3,') =',1P,E15.7,5X,
     1   'Numer.Est.=',E15.7)
         IF (ABS((PART(I)-DY)/DY).GT.0.1)THEN
             CARD(79:)='*'
             IF (IPR.GT.1) CALL TVN(CARD)
         ELSE
             CARD(79:)=' '
             IF (IPR.GT.2) CALL TVN(CARD)
         END IF
      END IF
  920 P(I)=PC(I)
  930 CONTINUE
      IF (TERM.GT.0.) THEN
         VAR=SQRT(VAR/TERM)
         WRITE(CARD,935)VAR
  935    FORMAT('R.M.S. relative error of Partial Derivatives =',
     1    1PE10.2)
      ELSE
         CARD='Zero divisor; numerical test failed.'
      END IF
      CALL TV(CARD)
      IF(VAR.GT.0.1)THEN
        WRITE(CARD,'(''BAD DERIVATIVES'')')
        CALL TV(CARD)
      ELSE IF(VAR.LT.1.E-5) THEN
        WRITE(PAGE,990)
  990 FORMAT(/'Derivatives seem to be satisfactory.  Trouble may be'//
     110X,'A) incompatible model and data, due either to bad data'/
     215X,'or inappropriate model.'//10X,'B) found wrong minimum.'/)
        CALL TV(PAGE(2))
        CALL TV(PAGE(4))
        CALL TVN(PAGE(5))
        CALL TV(PAGE(7))
      ELSE
      END IF
      CALL TV('   Solution abandoned.')
  999 RETURN
      END
      SUBROUTINE PRPAGE(PAGE,N)
C
C       prints page loaded by fmt. 132 in dlsq.
C
        IMPLICIT INTEGER (I-N)
C
        INCLUDE 'MID_REL_INCL:kingfit.inc'
        INCLUDE 'MID_REL_INCL:dlsq.inc'
        CHARACTER PAGE(*)
C
      DO 1320 I=1,N
 1320 CALL TVN(PAGE(I))
      RETURN
      END
      SUBROUTINE FIXP(L,VALUE,NIX)
C
C       Fixes P(L) at VALUE, whether already fixed or not.
C
      IMPLICIT NONE
C
C       Arguments:
C
      INTEGER L,NIX
      REAL VALUE
C
      INTEGER II
C
      INCLUDE 'MID_REL_INCL:kingfit.inc'
      INCLUDE 'MID_REL_INCL:dlsq.inc'
C
C
C
      PG(L)=VALUE
C
      DO 671 II=1,NIX
C           make sure it is not already fixed:
            IF(IX(II).EQ.L) RETURN
  671       CONTINUE
C     it is NOT already fixed.
      NIX=NIX+1
      IX(NIX)=L
C
      RETURN
C
      END
      SUBROUTINE UNFIXP(L,NIX)
C
C       Varies P(L), whether already fixed or not.
C
      IMPLICIT NONE
C
C       Arguments:
C
      INTEGER L,NIX
C
      INTEGER II
C
      INCLUDE 'MID_REL_INCL:kingfit.inc'
      INCLUDE 'MID_REL_INCL:dlsq.inc'
C
C
C
      DO 671 II=1,NIX
C           see if it is already fixed:
            IF(IX(II).EQ.L) GO TO 675
  671       CONTINUE
C     It is NOT already fixed.  We are OK.
      RETURN
C
C     It IS already fixed.  Remove it from NIX list:
  675 CONTINUE
      DO 680 II=II,NIX-1
C        (Just move rest of list down 1 slot.)
         IX(II)=IX(II+1)
  680 CONTINUE
      NIX=NIX-1
C
      RETURN
C
      END
      SUBROUTINE QFIX(L,VALUE,NIX)
C
C       Asks if user wants to hold P(L) fixed at VALUE.
C
      IMPLICIT NONE
C
C       Arguments:
C
      INTEGER L,NIX
      REAL VALUE
C
C
      INCLUDE 'MID_REL_INCL:kingfit.inc'
      INCLUDE 'MID_REL_INCL:dlsq.inc'
C
      CHARACTER*79 PAGE(21)
      COMMON /SCREEN/PAGE
C
      CHARACTER A1
C
C
   10 IF (ABS(VALUE).GT.0.01) THEN
        WRITE(PAGE(1),'(A,F6.3)')'Want to hold this fixed at ',VALUE
      ELSE
        WRITE(PAGE(1),'(A,1PE9.2)')'Want to hold this fixed at ',VALUE
      END IF
      CALL TV(PAGE(1))
      CALL ASKN('?',A1)
C
      IF (A1.EQ.'Y' .OR. A1.EQ.'O') THEN
         CALL FIXP(L,VALUE,NIX)
      ELSE IF (A1.EQ.'H') THEN
         CALL TV('The value suggested is a reasonable one.  Unless you')
         CALL TVN('know of a better value, reply YES.')
         GO TO 10
      ELSE
         IF (P(L).GT.0.01) THEN
           WRITE(PAGE(1),'(A,F6.3,A)')'Is',P(L),' acceptable?'
         ELSE
           WRITE(PAGE(1),'(A,1PE9.2,A)')'Is',P(L),' acceptable?'
         END IF
   20    CALL ASK(PAGE(1),A1)
         IF (A1.EQ.'Y')THEN
C            OK.
         ELSE IF (A1.EQ.'H') THEN
             CALL TV('That''s the current value; PEPSYS thinks it is a')
             WRITE (PAGE(1),'(A,G9.3)')'bad one.  A reasonable value is'
     1             ,VALUE
             CALL TVN(PAGE(1))
             GO TO 20
         ELSE
C            ask for advice.
             CALL QF('Please enter a reasonable value:',PG(L))
             CALL FIXP(L,PG(L),NIX)
         END IF
      END IF
C
      RETURN
      END
      SUBROUTINE IPRSET(IPR)
C
C       Sets IPR.
C
      INTEGER IPR
C
      REAL ARG
C
C
      CALL SPACE2
      CALL TV('Please specify how much ITERATION OUTPUT you want:')
      CALL SPACE
      CALL TV('     1:  no information about iterations')
      CALL TV('     2:  only iteration number and variance')
      CALL TV('     3:  values of parameters at each iteration')
      CALL TV('     4:  additional details')
      CALL TV('     5:  everything possible')
      CALL SPACE
      CALL QF('Please enter the NUMBER of your choice:',ARG)
      IPR=ARG-0.75
C
C
      RETURN
      END

C @(#)fitell3.for	19.1 (ESO-DMD) 02/25/03 13:31:22
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
        PROGRAM ELLIPS
C*****************************************************************************
C*
C*... Author             :  M.Schloetelburg based on formulas of
C*                          R.Bender & C.Moellenhof published in
C*                          Astron. Astrophys. 177,71 (1987)
C*
C*... Version            :  11-December-1990
C*
C*... Purpose            :  fit ellipses to isophotes
C*
C 
C 010201		last modif
C 
C******************************************************************************
 
        IMPLICIT         NONE
C
        INTEGER          NPIX(2),MADRID(1)
        INTEGER          KUN, KNUL, NX, NY
        INTEGER          ISTAT, IAV
        INTEGER          N, NID, NP, NL, NO, NAXIS
        INTEGER*8        IO,IP

        REAL             CSTEP
        REAL             CENTER(2),CUTS(2),RANGE(2)
        REAL             A(500),B(500),C(500),X(500),Y(500)

        DOUBLE PRECISION START(2),STEP(2)

        LOGICAL          OPT

        CHARACTER        INIMAG*60,RESULT*60
        CHARACTER        IDENT*72,CUNIT*64,OPTION*1
        CHARACTER*80     TEXT

        INCLUDE          'MID_INCLUDE:ST_DEF.INC/NOLIST'
        COMMON           /PARA/A,B,C,X,Y
        COMMON           /VMR/MADRID
        INCLUDE          'MID_INCLUDE:ST_DAT.INC/NOLIST'
C
  777   FORMAT('*** FATAL: invalid cuts ...')
C--
C--     initialize MIDAS environment
        CALL STSPRO('ELLIPSES')
C--
C--     get keys
        CALL STKRDC('P1',1,1,60,IAV,INIMAG,KUN,KNUL,ISTAT)
        CALL STKRDC('P2',1,1,60,IAV,RESULT,KUN,KNUL,ISTAT)
        CALL STKRDR('INPUTR',1,1,IAV,CSTEP,KUN,KNUL,ISTAT)
        CALL STKRDR('INPUTR',2,2,IAV,CUTS,KUN,KNUL,ISTAT)
        CALL STKRDR('INPUTR',4,2,IAV,RANGE,KUN,KNUL,ISTAT)
        CALL STKRDR('INPUTR',6,2,IAV,CENTER,KUN,KNUL,ISTAT)
        CALL STKRDC('P7',1,1,1,IAV,OPTION,KUN,KNUL,ISTAT)
C--
C--     map input frame
        CALL STIGET(INIMAG,10,0,1,2,NAXIS,NPIX,START,STEP,
     1              IDENT,CUNIT,IP,NP,ISTAT)
        NX = NPIX(1)
        NY = NPIX(2)
C--
C--     get secton to exclude in fit
        IF (RANGE(1).LT.0..OR.RANGE(2).LT.0.) THEN
          RANGE(1) = RANGE(1) + 360.
          RANGE(2) = RANGE(2) + 360.
        ENDIF
C--
C--     get lowest and highest isophote levels
        IF (CUTS(2).GT.CUTS(1)) GOTO 888
          CALL STDRDR(NP,'LHCUTS',1,2,IAV,CUTS,KUN,KNUL,ISTAT)
        IF (CUTS(2).GT.CUTS(1)) GOTO 888
          CALL STDRDR(NP,'LHCUTS',3,2,IAV,CUTS,KUN,KNUL,ISTAT)
        IF (CUTS(2).GT.CUTS(1)) GOTO 888
          WRITE (TEXT,777)
          CALL  STTPUT(TEXT,ISTAT)
C--
C--     convert center coordinates from world to pixel frame
  888   CENTER(1) = (CENTER(1) - START(1))/STEP(1) + 1.
        CENTER(2) = (CENTER(2) - START(2))/STEP(2) + 1.
C--
C--     create output table 'RESULT'.TBL
        CALL TBTINI(RESULT,1,F_O_MODE,7,500,NID,ISTAT)

        CALL TBCINI(NID,10,1,'G15.7','counts','Z',N,ISTAT)
        CALL TBCINI(NID,10,1,'G15.7','pixels','A',N,ISTAT)
        CALL TBCINI(NID,10,1,'G15.7','pixels','B',N,ISTAT)
        CALL TBCINI(NID,10,1,'G15.7','degree','PA',N,ISTAT)
        CALL TBCINI(NID,10,1,'G15.7','pixels','X',N,ISTAT)
        CALL TBCINI(NID,10,1,'G15.7','pixels','Y',N,ISTAT)
        CALL TBCINI(NID,10,1,'G15.7','number','NOISE',N,ISTAT)
C--
C--     fit contours and store parameters in 'RESULT'.TBL
        OPT = .false.
        IF (OPTION(1:1).EQ.'Y'.OR.OPTION(1:1).EQ.'y') OPT = .true.
C--
C--     fit contours and store parameters in 'RESULT'.TBL
        CALL CFIT(MADRID(IP),NX,NY,CUTS,CENTER,CSTEP,
     2            RANGE,NL,NID,OPT)
C--
C--     map output frame
        CALL STIPUT(RESULT,10,1,1,2,NPIX,START,STEP,
     1              IDENT,CUNIT,IO,NO,ISTAT)
C--
C--     copy descriptors and close input frame
        CALL STDCOP(NP,NO,1,' ',ISTAT)
        CALL STFCLO(NP,ISTAT)
C--
C--     reconstruct model image from fitted parameters
        WRITE (TEXT,100)
 100    FORMAT ('*** INFO: reconstructing output image now ...')
        CALL STTPUT(TEXT,ISTAT)
        CALL FILLBDF(MADRID(IO),NX,NY,NL,CUTS,CSTEP)
        CALL STFCLO(NO,ISTAT)
        CALL STSEPI
        END



        SUBROUTINE CFIT (M,NPX,NPY,EZ,CENTER,CSTEP,RANGE,NL,NID,OPT)
C*****************************************************************************
C*
C*                            fit isophotes
C*
C*****************************************************************************
        IMPLICIT      NONE
C
        INTEGER       NPX, NPY
        REAL          M(NPX,NPY)
        REAL          EZ(2)
        INTEGER       HG, VG
        REAL          CENTER(2)
        REAL          CSTEP
        REAL          RANGE(2)
        INTEGER       NL
        INTEGER       NID
        LOGICAL       OPT
C
        INTEGER       I, L, ITURN, IMAX, IW, ISTAT
        REAL          HABS(71),VABS(71),Z(71),G(2)
        REAL          A(500),B(500),C(500),X(500),Y(500)
        REAL          WZ, VV, EV
        REAL          AFIT0, BFIT0 
        REAL          AFIT, BFIT, HFIT, VFIT, WFIT
        REAL          HSIN, HCOS, VSIN, VCOS
        REAL          CEP, SEP, EPS
        REAL          T, P, Q, O, U, R
        REAL          H, V, HB, VB
        REAL          BW, BW0, BX
        REAL          USIGN, PI
        CHARACTER     TEXT*80
C
        COMMON        /PARA/A,B,C,X,Y
C
        DATA IW/71/               ! points per isophote
        DATA G/0.1,0.1/           ! quality limits of fit
        DATA IMAX/25/             ! maximal # iterations
        DATA PI/3.1415926535897932/
C
  112   FORMAT('*** WARNING: Fit parameters outside quality limits !')
  113   FORMAT('*** WARNING: maximum 500 isophotes !')
  400   FORMAT(17X,'parameters of each contour')
  401   FORMAT(17X,26('-'))
  500   FORMAT(1X,'No',1X,'level ',5X,'1.axis',5X,'2.axis',
     +         6X,'angle',7X,'x-cen',6X,'y-cen',6x,'sigma')
  600   FORMAT(1X,I3,3(1X,G10.4),1X,G8.2,3(1X,G10.4))
C
        EZ(2) = EZ(2) - EZ(1)     ! subtract background from maximum
        WZ    = REAL(IW)
        EPS   = 0.0
        VV    = 0.

        DO 1 L = 1,IW             ! reset array
           Z(L) = 0.
   1    CONTINUE
  
        WRITE(TEXT,400)
        CALL STTPUT(TEXT,ISTAT)
        WRITE(TEXT,401)
        CALL STTPUT(TEXT,ISTAT)
        WRITE(TEXT,500)
        CALL STTPUT(TEXT,ISTAT)

        AFIT = 1.                 ! start with circle
        BFIT = 1.                 ! approximately
 
        DO 10 L = 1,500           ! isophote loop (not more then 500)
          ITURN = 0
          EV    = EZ(2) * 10.**(-CSTEP*REAL(L))

          IF (EV.LT.EZ(1)) THEN
             NL = L - 1
             CALL TBTCLO (NID,ISTAT)
             RETURN
          ENDIF

 100      AFIT0 = AFIT
          BFIT0 = BFIT
          HFIT  = 0.
          VFIT  = 0.
          HSIN  = 0.
          HCOS  = 0.
          VSIN  = 0.
          VCOS  = 0.

          DO 20 I = 1,IW          ! angle loop
             T = 360.*REAL(I)/WZ - 0.1      ! polar angle of reference points
             P = T - EPS
             Q = EPS
 
C            IF (ABS(COSD(P)).GT.0.000001) THEN      ! to avoid tan(0.)
C               Q = EPS + ATAN2D((BFIT0*TAND(P)),AFIT0)
C            ENDIF
             IF (ABS(COS(P)/180*PI).GT.0.000001) THEN      ! to avoid tan(0.)
                Q = EPS + ATAN2((BFIT0*TAN(P/180*PI)),AFIT0)*180/PI
             ENDIF

             IF (P.LT.-90.) Q = Q - 180.
             IF (P.GT.+90.) Q = Q + 180.
             IF (P.GT.270.) Q = Q + 180.
             IF (Q.LT.0.)   Q = Q + 360.
             IF (Q.GT.360.) Q = Q - 360.

             O = Q
C            P  = COSD(O)
C            Q  = SIND(O)
             P  = COS(O/180*PI)
             Q  = SIN(O/180*PI)
             U  = AMAX1(Z(I),0.) 
             BW = EZ(2)
 
 200         U     = U + 1.
             BW0   = BW
             USIGN = 1.

             IF (O.GT.RANGE(1).AND.O.LT.RANGE(2)) THEN
                USIGN = -USIGN
             ENDIF

             H  = CENTER(1) + USIGN*U*P
             V  = CENTER(2) + USIGN*U*Q
             HG = INT(H)
             VG = INT(V)

             IF (HG.GE.NPX .OR. HG.LT.1) THEN
                USIGN = -USIGN
             ENDIF

             H  = CENTER(1) + USIGN*U*P
             V  = CENTER(2) + USIGN*U*Q
             HG = INT(H)
             VG = INT(V)

             IF (VG.GE.NPY .OR. VG.LT.1) THEN
                USIGN = -USIGN
             ENDIF

             H  = CENTER(1) + USIGN*U*P
             V  = CENTER(2) + USIGN*U*Q
             HG = INT(H)
             VG = INT(V)

             IF (HG.GE.NPX .OR. HG.LT.1) THEN
                NL = L - 1
                CALL TBTCLO(NID,ISTAT)
                RETURN
             ENDIF
             IF (VG.GE.NPY .OR. VG.LT.1) THEN
                NL = L - 1
                CALL TBTCLO(NID,ISTAT)
                RETURN
             ENDIF

             HB = H - REAL(HG)
             VB = V - REAL(VG)
             BW = (1.-VB)*((1.-HB)*M(HG,VG) + HB*M(HG+1,VG)) +
     +            VB *((1.-HB)*M(HG,VG+1) + HB*M(HG+1,VG+1))
             BW = BW - EZ(1)

             IF (OPT) THEN
                USIGN = -USIGN
                H     = CENTER(1) + USIGN*U*P
                V     = CENTER(2) + USIGN*U*Q
                HG    = INT(H)
                VG    = INT(V)

                IF (HG.GE.NPX .OR. HG.LT.1) THEN
                   USIGN = -USIGN
                ENDIF

                H = CENTER(1) + USIGN*U*P
                V = CENTER(2) + USIGN*U*Q
                HG = INT(H)
                VG = INT(V)
 
                IF (VG.GE.NPY .OR. VG.LT.1) THEN
                   USIGN = -USIGN
                ENDIF

                H  = CENTER(1) + USIGN*U*P
                V  = CENTER(2) + USIGN*U*Q
                HG = INT(H)
                VG = INT(V)

                IF (HG.GE.NPX .OR. HG.LT.1) THEN      
                   NL = L - 1
                   CALL TBTCLO(NID,ISTAT)
                   RETURN
                ENDIF
                IF (VG.GE.NPY .OR. VG.LT.1) THEN      
                   NL = L - 1
                   CALL TBTCLO(NID,ISTAT)
                  RETURN
                ENDIF

                HB = H - REAL(HG)
                VB = V - REAL(VG)
                BX = (1.-VB)*((1.-HB)*M(HG,VG) + HB*M(HG+1,VG)) +
     +               VB *((1.-HB)*M(HG,VG+1) + HB*M(HG+1,VG+1))
                BX = BX - EZ(1)
                BW = AMIN1 (BW,BX)
             ENDIF

             IF (BW.GT.EV) GO TO 200

             R       = U - (EV - BW)/(BW0 - BW)
             HABS(I) = R*P + CENTER(1)
             VABS(I) = R*Q + CENTER(2)
C            HSIN    = HSIN + HABS(I)*SIND(T)
C            HCOS    = HCOS + HABS(I)*COSD(T)
C            VSIN    = VSIN + VABS(I)*SIND(T)
C            VCOS    = VCOS + VABS(I)*COSD(T)
             HSIN    = HSIN + HABS(I)*SIN(T/180*PI)
             HCOS    = HCOS + HABS(I)*COS(T/180*PI)
             VSIN    = VSIN + VABS(I)*SIN(T/180*PI)
             VCOS    = VCOS + VABS(I)*COS(T/180*PI)
             HFIT    = HFIT + HABS(I)/WZ
             VFIT    = VFIT + VABS(I)/WZ
             Z(I)    = U - 2. - 4.*VV
   20     CONTINUE     
          
C         EPS  = 0.5*MOD(ATAN2D((HSIN+VCOS),(HCOS-VSIN))+180.,180.)
C         CEP  = COSD(EPS)
C         SEP  = SIND(EPS)
          EPS  = 0.5*180.0/PI*
     2               MOD(ATAN2((HSIN+VCOS),(HCOS-VSIN))+PI,PI)
          CEP  = COS(EPS/180*PI)
          SEP  = SIN(EPS/180*PI)
          P    = HCOS*CEP*CEP + (HSIN+VCOS)*CEP*SEP + VSIN*SEP*SEP
          Q    = HCOS*SEP*SEP - (VCOS+HSIN)*SEP*CEP + VSIN*CEP*CEP   
          P    = 2.*P/WZ
          Q    = 2.*Q/WZ
          AFIT = AMAX1(P,Q)
          BFIT = AMIN1(P,Q)

          IF (P.LT.Q) EPS = EPS + 90.

          P     = AFIT / BFIT
          Q     = AFIT0/BFIT0
          ITURN = ITURN + 1

          IF (ITURN.GT.IMAX) GOTO 111

          IF (ABS(Q/P - 1.).GT.G(1))  GO TO 100

          P         = ABS(HFIT - CENTER(1))
          Q         = ABS(VFIT - CENTER(2))
          CENTER(1) = HFIT
          CENTER(2) = VFIT

          IF (P.GT.G(2) .OR. Q.GT.G(2)) GO TO 100

  111     IF (ITURN.GT.IMAX) THEN
             WRITE(TEXT,112)
             CALL STTPUT(TEXT,ISTAT)
          ENDIF
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C+
C+                    compute standart deviation
C+
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
           V = 0.
C          CEP = COSD(EPS)
C          SEP = SIND(EPS)
           CEP = COS(EPS/180*PI)
           SEP = SIN(EPS/180*PI)
 
           DO 30 I = 1,IW
              H = 360.*REAL(I)/WZ - EPS
C             P = CEP*COSD(H)*AFIT - SEP*SIND(H)*BFIT
C             Q = SEP*COSD(H)*AFIT + CEP*SIND(H)*BFIT
              P = CEP*COS(H/180*PI)*AFIT - SEP*SIN(H/180*PI)*BFIT
              Q = SEP*COS(H/180*PI)*AFIT + CEP*SIN(H/180*PI)*BFIT
              R = HABS(I) - HFIT 
              T = VABS(I) - VFIT
              P = (P - R)*(P - R)
              Q = (Q - T)*(Q - T)
              V = V + (P + Q)/(WZ - 1.)
   30      CONTINUE

           VV   = SQRT(V/(AFIT*BFIT))
           WFIT = EPS - 90.
           A(L) = AFIT
           B(L) = BFIT
           C(L) = WFIT
           X(L) = HFIT
           Y(L) = VFIT

           CALL TBEWRR(NID,L,1,EV,ISTAT)
           CALL TBEWRR(NID,L,2,AFIT,ISTAT)
           CALL TBEWRR(NID,L,3,BFIT,ISTAT)
           CALL TBEWRR(NID,L,4,WFIT,ISTAT)
           CALL TBEWRR(NID,L,5,HFIT,ISTAT)
           CALL TBEWRR(NID,L,6,VFIT,ISTAT)
           CALL TBEWRR(NID,L,7,VV,ISTAT)
           WRITE(TEXT,600) L,EV,AFIT,BFIT,WFIT,HFIT,VFIT,VV
           CALL STTPUT(TEXT,ISTAT)
   10   CONTINUE
C
        WRITE(TEXT,113)
        CALL STTPUT(TEXT,ISTAT)
        NL = L - 1
        CALL TBTCLO(NID,ISTAT)
        RETURN
        END



        SUBROUTINE FILLBDF (K,NPX,NPY,NL,EZ,CSTEP)
C*****************************************************************************
C*
C*                  fill output image
C*
C*****************************************************************************
        IMPLICIT      NONE
        INTEGER       NPX,NPY
        REAL          K(NPX,NPY)
        INTEGER       NL
        REAL          EZ(2)
        REAL          CSTEP
        REAL          A(500),B(500),C(500),X(500),Y(500)
C
        INTEGER       IMIN, IMAX, JMIN, JMAX
        INTEGER       J, I, L
        REAL          U, S, T, V, O, P, Q, D, F, H, W
        REAL          PI
C
        COMMON        /PARA/A,B,C,X,Y
C
        DATA PI/3.1415926535897932/

        IMIN = NINT(X(1) - A(NL) - 1.)      ! there is clearly no
        IMAX = NINT(X(1) + A(NL) + 1.)      ! reconstruction
        JMIN = NINT(Y(1) - A(NL) - 1.)      ! outside of the
        JMAX = NINT(Y(1) + A(NL) + 1.)      ! largest [A(NL)] isophote
        IMIN = MAX(IMIN,1)
        IMAX = MIN(IMAX,NPX)
        JMIN = MAX(JMIN,1)
        JMAX = MIN(JMAX,NPY)

        DO J = 1,NPY
           DO I = 1,NPX
              K(I,J) = 0.           ! initialize output image
           ENDDO
        ENDDO

        L = NL
        DO J = JMIN,JMAX
          DO I = IMIN,IMAX

            U = Y(L) - REAL(J)              ! shift to
            S = X(L) - REAL(I)              ! ellipses frame
C           T = S*COSD(C(L)) + U*SIND(C(L)) ! rotate to
C           V = U*COSD(C(L)) - S*SIND(C(L)) ! ellipses frame
            T = S*COS(C(L)/180*PI) + U*SIN(C(L)/180*PI) ! rotate to
            V = U*COS(C(L)/180*PI) - S*SIN(C(L)/180*PI) ! ellipses frame
            O = V/A(L)                      ! scale to
            P = T/B(L)                      ! ellipses frame

  900       Q = SQRT(O*O + P*P)             ! 'radius' of ellipses
            D = REAL(L)                     ! find the next
            L = L + NINT(SIGN(1.,(Q-1.)))   ! neigbouring
            L = MAX(L,1)                    ! ellipses, if
            L = MIN(L,NL)                   ! there is
            F = REAL(L)                     ! one.

            IF (ABS(D-F).GT.0.5) THEN       ! switch if R is outside

              U = Y(L) - REAL(J)              ! shift to
              S = X(L) - REAL(I)              ! ellipses frame
C             T = S*COSD(C(L)) + U*SIND(C(L)) ! rotate to
C             V = U*COSD(C(L)) - S*SIND(C(L)) ! ellipses frame
              T = S*COS(C(L)/180*PI) + U*SIN(C(L)/180*PI) ! rotate to
              V = U*COS(C(L)/180*PI) - S*SIN(C(L)/180*PI) ! ellipses frame
              O = V/A(L)                      ! scale to
              P = T/B(L)                      ! ellipses frame
              H = SQRT(O*O + P*P)             ! 'radius' of ellipses
              W = (1.-H)/(Q-H)                ! interpolate

              IF (W.LT.0. .OR. W.GT.1.) GO TO 900 ! not the right intervall

              F = F + (D-F)*W

              K(I,J) = EZ(2)*10.**(-CSTEP*F)+EZ(1)

            ENDIF
          ENDDO
        ENDDO

        RETURN
        END

C===========================================================================
C Copyright (C) 1995,2003 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM AVESUB
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION:                
C  program AVESUB			version 3.00	881028
C  K. Banse				ESO - Garching
C
C.KEYWORDS:
C  statistics, subimage
C
C.PURPOSE:
C  calculate the average value (and rms) according to different methods 
C  of an area defined by the cursor rectangle or a table or by coordinates
C
C.ALGORITHM:
C  This info may also be stored either in a descriptor or a table...
C  
C.INPUT/OUTPUT:
C  
C  The following keywords are used:
C  IN_A/C/1/60				input frame
C  IN_B/C/1/60				input specs,
C					= +, for cursor input
C					= name or name/TABLE for table input
C  ACTION/C/1/1				averaging method,
C					K for kappa-sigma clipping,
C					M for median, A for simple average
C  INPUTC/C/1/50			specs for data storage
C					= :label for table or table,:label (a)
C					= descr for descriptor (b)
C					= + for just display of data
C  INPUTC/C/51/1			(b) append flag for descriptor,
C					= A, append data to descriptor
C					= +, start again at position 1 in descr
C					(a) center flag for table
C					= C, add also columns with center points
C					= +, no
C	
C  OUTPUTR/R/1/5			last displayed results
C  OUTPUTI/I/1/1			no. of loops in program
C	
C.VERSIONS
C  3.00		use new IDI interfaces
C	
C 031021	last modif
C 
C--------------------------------------------------------------------------
C
      IMPLICIT NONE
C      
      INTEGER      FELEM,IAV,INFLAG,ISTOP
      INTEGER      KAPITR,LEAP,NMAL,NROW,NN,N
      INTEGER      OUTFLG,STAT1,STAT2,STAT
      INTEGER      TPIX(2),MAXSIZ
      INTEGER      TBCOLN(7),OUTCOL
      INTEGER      SUBPIX(2,2),IPIXS(4),NPON(5)
      INTEGER      ICUR1(2),ICUR2(2)
      INTEGER*8    PNTRA,PNTRX
      INTEGER      NAXIS,NPIX(2),IMNOA
      INTEGER      TABNUL(7),COOS(4),CURSOF
      INTEGER      UNI(1),NULO,TID
      INTEGER      MADRID(1)
C
      CHARACTER*80 FRAME,TABLE
      CHARACTER    DESCR*48,APPFLG*1
      CHARACTER    CUNIT*48,IDENT*72,CBUF*80,ACTION*1
      CHARACTER    INFO*48
      CHARACTER    OUTUNI*16,OUTLAB(7)*16,DRAWY*8
C      
      REAL         PCUR1(6),PCUR2(6),PCEN(3),RDUM
      REAL         BGR,BGVL(5),RMSV(5),AVAREA
      REAL         REAL1(5),RBUF(10)
C 
      DOUBLE PRECISION START(2),STEP(2)
C
      LOGICAL      SELFLG
C 
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      INCLUDE 'MID_INCLUDE:IDIDEV.INC'
      INCLUDE 'MID_INCLUDE:IDIMEM.INC'
C
      COMMON   /VMR/ MADRID
C 
      DATA  SUBPIX   /4*1/
      DATA  COOS     /-1,-1,-1,-1/,  CURSOF /0/
      DATA  TID      /-1/
      DATA  INFO     /'switch cursor(s) on - next time we exit... '/
C
      DATA      OUTLAB /'XSTART ','YSTART ','XEND ','YEND ',
     +                  ' ','XCEN ','YCEN '/
      DATA      OUTUNI /' '/
      DATA      REAL1  /5*0./
      DATA      CUNIT  /' '/,    IDENT  /' '/, DESCR /' '/
      DATA      CBUF  /' '/,  FRAME  /' '/, TABLE /' '/
C 
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C  set up MIDAS environment + enable automatic error abort
      CALL STSPRO('AVESUB')
C
C  get method 
      CALL STKRDC('ACTION',1,1,1,IAV,ACTION,UNI,NULO,STAT)
      IF (INDEX('AKM',ACTION).LE.0) ACTION = 'A'            !default to A(verage)
      CALL STKRDI('INPUTI',1,2,IAV,NPON,UNI,NULO,STAT) 
C      
      IF (ACTION.EQ.'M') THEN
         MAXSIZ = NPON(2)
         CALL STFXMP(MAXSIZ,D_R4_FORMAT,PNTRX,STAT)
      ELSE IF (ACTION.EQ.'K') THEN                    !for kappa-sigma clipping
         KAPITR = NPON(1)
      ENDIF
C      
C  get the subarea input options
      CALL STKRDC('IN_B',1,1,80,IAV,TABLE,UNI,NULO,STAT)
      IF (TABLE(1:1).EQ.'+') THEN
         INFLAG = 1                              !INFLAG = 1 for cursor
         DRAWY(1:7) = 'N YY?C0'
         CALL STKRDC('P4',1,1,1,IAV,DRAWY(2:2),UNI,NULO,STAT)
      ELSE
         CALL STKRDC('IN_A',1,1,80,IAV,FRAME,UNI,NULO,STAT)
         CALL CLNFRA(FRAME,FRAME,0)
         CALL STIGET(FRAME,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +               2,NAXIS,NPIX,START,STEP,IDENT,
     +               CUNIT,PNTRA,IMNOA,STAT)
         IF (NAXIS.LT.2) 
     +      CALL STETER(77,'1-dim frames currently not supported...')
         CALL CLNTAB(TABLE,TABLE,0)
         INFLAG = 2                              !INFLAG = 2 for table
      ENDIF
C
C  get descriptor or table label for storage of data + output_options
      DESCR(1:1) = '+'
      OUTFLG = 1                          !OUTFLG = 1 for descriptor or nothing
      CALL STKRDC('INPUTC',1,1,51,IAV,CBUF,UNI,NULO,STAT)
      APPFLG = CBUF(51:51)
      IF (APPFLG .EQ. 'c') THEN                !take care of lower case options
         APPFLG = 'C'
      ELSE IF (APPFLG .EQ. 'a') THEN
         APPFLG = 'A'
      ENDIF
      CBUF(51:51) = ' '
      IF (CBUF(1:1).EQ.'+') GOTO 500           !neither table nor descriptor
C      
C  test for :label or table,:label or #no. or table,#no.
      IF (INDEX(CBUF,'#') .GT. 0) 
     +   CALL STETER(73,'We need a column label, no # sign, please.')
C 
      IF (CBUF(1:1).EQ.':') THEN
         N = 1
      ELSE
         N = INDEX(CBUF,',:')           
         IF (N.EQ.1) THEN
            CALL STETER(76,'Invalid syntax (missing table name)...')
         ELSE IF (N.GT.1) THEN
            CALL CLNTAB(CBUF(1:N-1),TABLE,0)      
            N = N + 1                !skip the ','
         ELSE
            GOTO 400                     !it's a descriptor
         ENDIF
      ENDIF
C      
C  handle table storage
      OUTFLG = 2                               !OUTFLG = 2 for table
      OUTLAB(5) = CBUF(N+1:50)
      IF (INFLAG.EQ.1) THEN                    !cursor input
         DO 80, N=1,7
            IF (N.NE.5) THEN
               IF (OUTLAB(5).EQ.OUTLAB(N))
     +            CALL STETER(78,'Invalid column label !')
            ENDIF
80       CONTINUE
C 
C  for cursor input create table with 100 rows
         IF (APPFLG.EQ.'C') THEN
            OUTCOL = 7
         ELSE
            OUTCOL = 5
         ENDIF
         CALL TBTINI(TABLE,0,F_O_MODE,OUTCOL,100,TID,STAT) 
         DO 100, N=1,OUTCOL
            CALL TBCINI(TID,D_R4_FORMAT,1,'E12.5',OUTUNI,OUTLAB(N),
     +                  TBCOLN(N),STAT)
100      CONTINUE
         GOTO 500
      ELSE
         IF (N.GT.1)           !for table input is table,:label not allowed...
     +      CALL STETER(79,'No table name possible in out_specs... ')
      ENDIF
C      
C  for existing table, test, if label(s) already there
      CALL TBTOPN(TABLE,F_IO_MODE,TID,STAT)
      IF (APPFLG.EQ.'C') THEN
         NN = 7
      ELSE
         NN = 5
      ENDIF
      DO 150, N=5,NN
         CALL TBLSER(TID,OUTLAB(N),TBCOLN(N),STAT)
         IF (TBCOLN(N).LE.0)                          !No. We have to define it...
     +      CALL TBCINI(TID,D_R4_FORMAT,1,'E12.5',OUTUNI,OUTLAB(N),
     +                  TBCOLN(N),STAT)
150   CONTINUE
      GOTO 500
C      
C  handle descriptor storage
400   DESCR(1:48) = CBUF(1:48)
      IF (APPFLG.EQ.'A') THEN                   !see, if data is to be appended
         FELEM = -1
      ELSE
         FELEM = 1
      ENDIF
C      
C  branch according to input option
500   NMAL = 0                                  !init counter
      IF (INFLAG.EQ.2) GOTO 2000
C      
C  a) cursor defined subimage(s) - attach Image Display + get all info
C 
      CALL DTOPEN(1,STAT)
      CALL SETCUR(QDSPNO,2,1,2,COOS,STAT)       !set up cursor rectangle
      FRAME(1:) = ' '
C
C  input cursor positions and check status
1000  CALL GETCUR(DRAWY,FRAME,                  !draw box in overlay channel
     +            ICUR1,PCUR1(3),PCUR1(5),RDUM,STAT1,
     +            ICUR2,PCUR2(3),PCUR2(5),RDUM,STAT2)
C
C  check cursor status  
      IF ( (STAT1.EQ.0) .AND. (STAT2.EQ.0) ) THEN
         IF (NMAL.EQ.0) THEN
            IF (CURSOF.EQ.1) GOTO 9000
            CALL STTPUT(INFO,STAT)
            FRAME(1:) = ' '
            CURSOF = 1
            GOTO 1000
         ELSE
            GOTO 9000                             !cursor loop terminated ...
         ENDIF
      ENDIF
C      
      NMAL = NMAL + 1                             !update counter
C      
C  fill output buffer
      REAL1(1) = PCUR1(5)
      REAL1(2) = PCUR1(6)
      REAL1(3) = PCUR2(5)
      REAL1(4) = PCUR2(6)
C      
C  finally map displayed frame
      CALL STIGET(FRAME,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,2,
     +            NAXIS,NPIX,START,STEP,
     +            IDENT,CUNIT,PNTRA,IMNOA,STAT)
      GOTO 3000
C      
C  b) table defined subimage(s) 
C 
2000  IF (OUTFLG.NE.2) CALL TBTOPN(TABLE,F_IO_MODE,TID,STAT)
      CALL TBIGET(TID,N,NROW,N,N,N,STAT)              !get total no. of rows
      DO 2020, N=1,4
         CALL TBLSER(TID,OUTLAB(N),TBCOLN(N),STAT)
2020  CONTINUE
C      
C  here we loop
2100  IF (NMAL.GE.NROW) GOTO 9000
      NMAL = NMAL + 1
      CALL TBSGET(TID,NMAL,SELFLG,STAT)             !only use selected rows
      IF (.NOT.SELFLG) GOTO 2100
C      
C  get next row of values
      CALL TBRRDR(TID,NMAL,4,TBCOLN,REAL1(1),TABNUL,STAT)
      PCUR1(3) = (REAL1(1)-START(1))/STEP(1) + 1.
      PCUR1(4) = (REAL1(2)-START(2))/STEP(2) + 1.
      PCUR2(3) = (REAL1(3)-START(1))/STEP(1) + 1.
      PCUR2(4) = (REAL1(4)-START(2))/STEP(2) + 1.
C 
C  -----------------------------------
C  common section for option a) and b)
C  -----------------------------------
C 
3000  SUBPIX(1,1) = PCUR1(3)
      SUBPIX(2,1) = PCUR1(4)
      SUBPIX(1,2) = PCUR2(3)
      SUBPIX(2,2) = PCUR2(4)
C      
      IF (APPFLG.EQ.'C') THEN
         N = (SUBPIX(1,1)+SUBPIX(1,2)+1) / 2
         PCEN(2) = (N-1)*STEP(1) + START(1)
         N = (SUBPIX(2,1)+SUBPIX(2,2)+1) / 2
         PCEN(3) = (N-1)*STEP(2) + START(2)
      ENDIF
C      
C  and finally let's do the averaging 
C      
      IF (ACTION.EQ.'K') THEN
         IPIXS(1) = SUBPIX(1,1)
         IPIXS(2) = SUBPIX(1,2)
         IPIXS(3) = SUBPIX(2,1)
         IPIXS(4) = SUBPIX(2,2)
         LEAP = 0
         ISTOP = 0
         CALL BGVAL(1,MADRID(PNTRA),NPIX(1),NPIX(2),IPIXS,KAPITR,
     +              2,LEAP,BGVL,RMSV,NPON,ISTOP,N)
         BGR = BGVL(1)
CC       SIG = RMSV(1)
CC       NPN = NPON(1)
      ELSE
         TPIX(1) = SUBPIX(1,2) - SUBPIX(1,1) + 1            !get size of subimage
         TPIX(2) = SUBPIX(2,2) - SUBPIX(2,1) + 1
         IF ((ACTION.EQ.'M').AND.(TPIX(1)*TPIX(2).GT.MAXSIZ)) THEN
            CALL STTPUT('subimage too large for internal buffers -'//
     +                  ' skipped...',STAT)
            IF (INFLAG.EQ.1) NMAL = NMAL - 1                !modify counter
            GOTO 7000
         ENDIF
         BGR = AVAREA(ACTION,MADRID(PNTRA),NPIX(1),SUBPIX,TPIX,
     +                MADRID(PNTRX))
      ENDIF
C
C  display results
      IF (NMAL.EQ.1) THEN                               !here for the 1. time...?
         CBUF(1:) = '   xstart        ystart          xend           '//
     +              'yend        average_val'
         CALL STTPUT(CBUF,STAT)
      ENDIF
      REAL1(5) = BGR
      WRITE(CBUF,20000) (REAL1(N),N=1,5)
      CALL STTPUT(CBUF,STAT)
C
C  fill table, if applicable
      IF (OUTFLG.EQ.2) THEN
         IF (INFLAG.EQ.2) THEN                  !table input
            PCEN(1) = BGR
            IF (APPFLG.EQ.'C') THEN
               N = 3
            ELSE
               N = 1
            ENDIF                               !row already exists
            CALL TBRWRR(TID,NMAL,N,TBCOLN(5),PCEN,STAT)
         ELSE                                    !cursor input
            DO 3500, N=1,5
               RBUF(N) = REAL1(N)
3500        CONTINUE
            IF (APPFLG.EQ.'C') THEN
               RBUF(6) = PCEN(2)
               RBUF(7) = PCEN(3)
            ENDIF
            CALL TBRWRR(TID,NMAL,OUTCOL,TBCOLN,RBUF,STAT)
         ENDIF
      ELSE
C      
C  fill descriptor, if applicable
         IF (DESCR(1:1).NE.'+') THEN
            CALL STDWRR(IMNOA,DESCR,REAL1,FELEM,5,UNI,STAT) 
            FELEM = -1
         ENDIF
      ENDIF
C      
C  store info also in keyword OUTPUTR
      CALL STKWRR('OUTPUTR',REAL1(1),1,5,UNI,STAT)

C      
C  and loop again
7000  GOTO (1000,2100),INFLAG
C  
C  That's it folks...
9000  IF ((TID.NE.-1) .AND. (OUTFLG.EQ.2)) THEN
         CALL TBSINI(TID,STAT)
         CALL TBTCLO(TID,STAT)
      ENDIF
C      
C  save no. of coordinates obtained for subsequent applications
      CALL STKWRI('OUTPUTI',NMAL,1,1,UNI,STAT)
C      
      IF (INFLAG.EQ.1) CALL DTCLOS(QDSPNO)
      CALL STSEPI
C      
C  format statements
20000 FORMAT(1X,5G15.7)
C 
      END         

C  @(#)ftcval.for	19.1 (ESO-DMD) 02/25/03 13:17:33 
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FTCVAL(NIN,XVAL,XOUT)                                          
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                   
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:25 - 13 JAN 1988                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C.IDENTIFICATION                                                                
C                                                                               
C  FITLIB.FOR   VERSION 1.0  27 MAR 1984                                        
C                                                                               
C.PURPOSE                                                                       
C                                                                               
C  INTERFACE ROUTINES FOR THE FITTING STRUCTURES                                
C COMPUTE FITTED VALUE FOR THE INPUT VARIABLES XVAL                             
C                                                                               
C.ALGORITHM                                                                     
C                                                                               
C  USE MIDAS I/O INTERFACES TO FRAMES AND TABLES                                
C                                                                               
C.KEYWORDS                                                                      
C                                                                               
C  NON LINEAR FITTING                                                           
C                                                                               
C.VERSION
C 021122	last modif
C                                                                               
C----------------------------------------------------------------               
C                                                                               
C      IMPLICIT NONE                                                            
C                                                                               
C INPUT PARAMETERS                                                              
C NIN INTG NO.OF INDEPENDENT VARIABLES                                          
C XVAL REAL INDEPENDENT VARIABLES                                               
C                                                                               
C OUTPUT PARAMETERS                                                             
C XOUT DBLE COMPUTED VALUE, ERROR                                               
C ISTAT INTG STATUS RETURN                                                      
C                                                                               
      INTEGER NIN,I,NOFFSET,limi
      REAL XVAL(NIN)                                                            
      DOUBLE PRECISION Y1,XOUT(2)                                               
       INCLUDE 'MID_INCLUDE:FITI.INC/NOLIST'                                     
      DOUBLE PRECISION DY(FZPARMAX)                                           
       INCLUDE 'MID_INCLUDE:FITC.INC/NOLIST'                                     
                                                                                
      XOUT(1) = 0.D0                                                            
      XOUT(2) = 0.D0                                                            
      NOFFSET = 1                                                               
      DO 10, I = 1,FZNFUN                                                      
          DY(I) = 0.D0
          IF (FZSELE(I).EQ.1) THEN                                            
              CALL FTFUNC(FZFCODE(I),FZNIND,XVAL,FZACTPAR(I),             
     +                    FZVALUE(NOFFSET),Y1,DY(NOFFSET))                    
              XOUT(1) = XOUT(1) + Y1                                            
          END IF                               
          NOFFSET = NOFFSET + FZACTPAR(I)                                     
   10 CONTINUE                                                                  
C 
      IF (FZNPTOT.GT.FZNFUN) THEN		!take the samller value
         LIMI = FZNFUN
      ELSE
         LIMI = FZNPTOT
      ENDIF
      DO 20, I = 1,LIMI  
          XOUT(2) = XOUT(2) + (DY(I)*FZERROR(I))**2                           
   20 CONTINUE                                                                  
      XOUT(2) = DSQRT(XOUT(2))                                                  
      RETURN                                                                    
                                                                                
      END                                                                       

C @(#)necnorm.for	19.1 (ES0-DMD) 02/25/03 14:20:24
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM ECHNRM
C
C+
C
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  12:14 - 11 JAN 1988
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: D.PONZ
C
C.IDENTIFICATION
C
C  program  ECHNORM  version 1.5 830610
C
C.MODIFICATIONS
C
C  910128   P. Ballester  Define and set variables (test mmake -i)
C
C.KEYWORDS
C
C  ECHELLE, CASPEC, RIPPLE NORMALIZATION
C
C.PURPOSE
C
C  FIT A POLYNOMIAL TO THE IMAGE ROWS
C
C.ALGORITHM
C
C
C.INPUT/OUTPUT
C
C  NORMALIZE/ECHELLE INPUT OUTPUT TABLE METHOD PARS
C                                    if METHOD='POLY' then PARS=IDEG
C-
C
      IMPLICIT  NONE
      INTEGER   MADRID, TID
      INTEGER   I,IAV,IDEG
      INTEGER*8 IPNTRA,IPNTRB
      INTEGER*8 IS,ISTAT
      INTEGER   J,NAXISA,NCOL,NITER,IMNO,IMNI
      REAL CONST,ER,RELAX,RIDEN,STEPA1
      REAL WSTR1,XMAX1,XMIN1
C
      INTEGER NPIXA(2),IC(20),KUN,KNUL
      REAL RPAR(5),VALUE(20),P0(3)
      REAL XMIN,XMAX,LHCUTS(4)
      DOUBLE PRECISION STEPA(2),STARTA(2)
      DOUBLE PRECISION A(10),DSTP(2),DSTA(2)
      CHARACTER*8 OUTFRM,INFRM,TABLE
      CHARACTER*16 UNIT(5),LABEL(5),UNIT1(12),LABEL1(12),LABELT,UNITT
      CHARACTER*6 FORM(5),FORM1(12),FORMT
      CHARACTER METH*1
      CHARACTER IDENTA*72,CUNITA*64
C
      INCLUDE   'MID_INCLUDE:ST_DEF.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE   'MID_INCLUDE:ST_DAT.INC'
C
      DATA NCOL/5/
      DATA LABEL(1)/'ORDER'/,UNIT(1)/'UNITLESS'/,FORM(1)/'I5'/
      DATA LABEL(2)/'Y0'/,UNIT(2)/'DN'/,FORM(2)/'E13.3'/
      DATA LABEL(3)/'ALFA'/,UNIT(3)/'UNITLESS'/,FORM(3)/'E13.3'/
      DATA LABEL(4)/'BETA'/,UNIT(4)/'UNITLESS'/,FORM(4)/'E13.4'/
      DATA LABEL(5)/'ERROR'/,UNIT(5)/'UNITLESS'/,FORM(5)/'E13.4'/
      DATA LABEL1(1)/'ORDER'/,UNIT1(1)/'UNITLESS'/,FORM1(1)/'I5'/
      DATA LABEL1(2)/'DEGREE'/,UNIT1(2)/'UNITLESS'/,FORM1(2)/'I4'/
      DATA LABEL1(3)/'A0'/,UNIT1(3)/'UNITLESS'/,FORM1(3)/'E13.3'/
      DATA LABEL1(4)/'A1'/,UNIT1(4)/'UNITLESS'/,FORM1(4)/'E13.3'/
      DATA LABEL1(5)/'A2'/,UNIT1(5)/'UNITLESS'/,FORM1(5)/'E13.3'/
      DATA LABEL1(6)/'A3'/,UNIT1(6)/'UNITLESS'/,FORM1(6)/'E13.3'/
      DATA LABEL1(7)/'A4'/,UNIT1(7)/'UNITLESS'/,FORM1(7)/'E13.3'/
      DATA LABEL1(8)/'A5'/,UNIT1(8)/'UNITLESS'/,FORM1(8)/'E13.3'/
      DATA LABEL1(9)/'A6'/,UNIT1(9)/'UNITLESS'/,FORM1(9)/'E13.3'/
      DATA LABEL1(10)/'A7'/,UNIT1(10)/'UNITLESS'/,FORM1(10)/'E13.3'/
      DATA LABEL1(11)/'A8'/,UNIT1(11)/'UNITLESS'/,FORM1(11)/'E13.3'/
      DATA LABEL1(12)/'A9'/,UNIT1(12)/'UNITLESS'/,FORM1(12)/'E13.3'/
C
C ... INITIALIZE SYSTEM
C
      CALL STSPRO('ECHNRM')
      CALL STKRDC('P1',1,1,8,IAV,INFRM,KUN,KNUL,ISTAT)
      CALL STKRDC('P2',1,1,8,IAV,OUTFRM,KUN,KNUL,ISTAT)
      CALL STKRDC('P3',1,1,8,IAV,TABLE,KUN,KNUL,ISTAT)
      CALL STKRDR('INPUTR',1,3,IAV,RPAR,KUN,KNUL,ISTAT)
      METH   = 'P'
      IF (METH.EQ.'S') THEN
          NITER  = NINT(RPAR(3))
      ELSE
          IDEG   = NINT(RPAR(1))
          IDEG   = MIN(IDEG,9)
          NCOL   = IDEG + 3
          VALUE(2) = IDEG
      END IF
C
C ... MAP INPUT FRM
C
      CALL STIGET(INFRM,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     .            2,NAXISA,NPIXA,STARTA,STEPA,IDENTA,CUNITA,
     .            IPNTRA,IMNI,ISTAT)
C
C ... MAP OUTPUT FRM
C
      IDENTA = 'FITTED VALUES :'//INFRM
      DSTA(1) = STARTA(1)
      DSTA(2) = STARTA(2)
      DSTP(1) = STEPA(1)
      DSTP(2) = STEPA(2)
      CALL STIPUT(OUTFRM,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .            NAXISA,NPIXA,DSTA,DSTP,IDENTA,
     .            CUNITA,IPNTRB,IMNO,ISTAT)
C      CALL SXIPUT(OUTFRM,'O',NAXISA,NPIXA,STARTA,STEPA,IDENTA,CUNITA,
C    +            IPNTRB,ISTAT)
C
C ... INITIALIZE TABLE
C
      CALL TBTINI(TABLE,F_TRANS,F_O_MODE,15,NPIXA(2),TID,ISTAT)
      DO 10 I = 1,NCOL
          IF (METH.EQ.'S') THEN
              UNITT  = UNIT(I)
              LABELT = LABEL(I)
              FORMT  = FORM(I)
          ELSE
              UNITT  = UNIT1(I)
              LABELT = LABEL1(I)
              FORMT  = FORM1(I)
          END IF
          CALL TBCINI(TID,D_R4_FORMAT,1,
     .                FORMT,UNITT,LABELT,IC(I),ISTAT)
   10 CONTINUE
C
C ... ITERATION ON EACH ECHELLE ORDER
C
      IS     = 0  !   DUMPING FACTOR
      RELAX  = RPAR(1)  !   ERROR
      ER     = RPAR(2)
      RIDEN  = 1.0
      STEPA1 = STEPA(1)
      XMIN   = 0.
      XMAX   = XMIN
      DO 30 I = 1,NPIXA(2)
          WSTR1 = WSTR1  !   ORDER NUMBER
          VALUE(1) = STARTA(2) + (I-1)*STEPA(2)
          IF (METH.EQ.'S') THEN  !   INITAL GUESSES
              P0(2)  = 1.
C     P0(3) = 1./(WSTR(I)+NPIXA(1)*STEPA(1)*0.5)
              P0(3)  = 1./ (WSTR1+NPIXA(1)*STEPA1*0.5)
              CONST  = VALUE(1)*3.1415926535897932/10800.0
              CALL FIT1(NPIXA(1),NPIXA(2),MADRID(IPNTRA),MADRID(IPNTRB),
     +                  I,CONST,P0,ER,RELAX,NITER,WSTR1,STEPA1,
     +                  VALUE(2),VALUE(4))
          ELSE
              CALL FIT2(NPIXA(1),NPIXA(2),MADRID(IPNTRA),MADRID(IPNTRB),
     +                  I,STARTA(1),STEPA(1),IDEG,A,XMAX1,XMIN1)
              DO 20 J = 1,IDEG + 1
                  VALUE(J+2) = A(J)
   20         CONTINUE
          END IF
          XMIN   = AMIN1(XMIN,XMIN1)
          XMAX   = AMAX1(XMAX,XMAX1)
          IS     = IS + 1
          CALL TBRWRR(TID,IS,NCOL,IC,VALUE,ISTAT)
   30 CONTINUE
      LHCUTS(1) = XMIN
      LHCUTS(2) = XMAX
      LHCUTS(3) = XMIN
      LHCUTS(4) = XMAX
      CALL STDWRR(IMNO,'LHCUTS',LHCUTS,1,4,KUN,ISTAT)
      CALL TBTCLO(TID,ISTAT)
C
C ... END
C
      CALL STSEPI
      END

      SUBROUTINE FIT1(NX,NY,IN,OUT,I,CONST,P0,ER,RELAX,NITER,X0,DX,P,
     +                ERROR)
C
C NONLINEAR FIT ROUTINE INTERFACE
C      IMPLICIT NONE
C
C INPUT ARGUMENTS
C
C NX INTG*4 NUMBER OF SAMPLES
C  NY INTG*4 NUMBER OF LINES (ORDERS)
C IN REAL*4 INPUT IMAGE
C OUT REAL*4 FITTED VALUES
C I INTG*4 NUMBER OF THE LINE
C M REAL*4 SPECTRAL ORDER
C P0(3) REAL*4 INITIAL GUESSES
C ER REAL*4 ERROR BOUND
C RELAX REAL*4 DUMPING FACTOR
C NITER INTG*4 NUMBER OF ITERATIONS
C X0 REAL*4 STARTING WAVELENGTH
C DX REAL*4 WAVELENGTH STEP
C
C OUTPUT PARAMETERS
C
C P(3) REAL*4 ESTIMATED PARAMETER
C ERROR REAL*4 FINAL ERROR
C
      IMPLICIT NONE

      INTEGER  NX,NY,I,NITER,ISTAT
      REAL     CONST,ER,RELAX,X0,DX,ERROR

      REAL IN(NX,NY),OUT(NX,NY),P0(3),P(3)
      CHARACTER*80 LINE

      P0(1)  = IN(NX/2,I)
      WRITE (LINE,9000) I,P0(1),P0(2),P0(3),ER
      CALL STTPUT(LINE,ISTAT)
      CALL LSQSIN(NX,X0,DX,IN(1,I),OUT(1,I),RELAX,NITER,ER,CONST,P0,P,
     +             ERROR)
      RETURN

 9000 FORMAT (' Line :',I4,' Init.pars :',3E10.4,' Error :',E10.4)
      END

      SUBROUTINE LSQSIN(NP,X0,DX,Y,YFIT,RELAX,NITER,ER,CONST,P0,P,
     +                   ERROR)
C
      IMPLICIT NONE
C     Modified version of the program LSQFIT for the problem :
C
C     find A and B in the expression
C     Y = (sinc(pi*M*A*(X*B-1)))**2
C
      INTEGER    NP,NITER,ITER,INDEP,KZ6901,IPAR,ISTAT,I,J,K,NF
      REAL       X0,DX,RELAX,ER,CONST,ERROR,X,Y2,W,DET,ERR
      REAL       Y(NP),YFIT(NP),P(3),P0(3),D(3)
      DOUBLE PRECISION CHI,PP,Q
      DOUBLE PRECISION AL(3),B(3),A(3,3)
      CHARACTER*80     LINE
C
C ... initialize relevant parameters
C
      ITER   = 0
C     IWEIGH,RELAX  !   one independent variable
      INDEP  = 1  !   three parameters
      IPAR   = 3  !   initial guesses
      P(1)   = P0(1)
      P(2)   = P0(2)
      P(3)   = P0(3)
      NF     = NP - 3
C
C ... iteration loop
C
      DO 80 KZ6901 = 1,2147483647
         IF( .NOT. (ITER.LT.NITER)) GO TO 90
         ITER   = ITER + 1
         WRITE (LINE,9000) ITER,P(1),P(2),P(3)
         CALL STTPUT(LINE,ISTAT)
C
C ... initalize normal equation matrix
C
         DO 20 I = 1,IPAR
             B(I)   = 0.0D0
             DO 10 J = 1,IPAR
                 A(I,J) = 0.0D0
   10        CONTINUE
   20    CONTINUE
         CHI    = 0.0D0
         DO 50 I = 1,NP
C
C ... compute function and derivatives
C
             X      = X0 + (I-1)*DX
             CALL FSINC(X,YFIT(I),CONST,P,D)
C
C ... compute residuals
C
             Y2     = Y(I) - YFIT(I)
             W      = 1.0
             PP     = DBLE(W)
             Q      = DBLE(Y2)
             CHI    = CHI + Q*Q*PP
C
C ... enter derivatives into normal equation matrix
C
             DO 40 J = 1,IPAR
                 AL(1)  = DBLE(D(J))
                 DO 30 K = 1,IPAR
                     A(J,K) = A(J,K) + AL(1)*DBLE(D(K))*PP
   30            CONTINUE
                 B(J)   = B(J) + PP*Q*AL(1)
   40        CONTINUE
   50    CONTINUE
C
C ... invert normal equation
C
         WRITE (*,*) A(1,1),A(1,2),A(1,3),B(1)
         WRITE (*,*) A(2,1),A(2,2),A(2,3),B(2)
         WRITE (*,*) A(3,1),A(3,2),A(3,3),B(3)
C        DO K=1,IPAR
C           KK=IPAR+1-K
C           PP=A(1,1)
C           DO I=2,IPAR
C              Q=A(I,1)
C              AL(I)=Q/PP
C              IF (I.LE.KK) AL(I)=-AL(I)
C              DO J=2,I
C          IF (I.EQ.2.AND.J.EQ.2)WRITE(*,*) A(2,2)
C                 A(I-1,J-1)=A(I,J)+Q*AL(J)
C          IF (I.EQ.2.AND.J.EQ.2)WRITE(*,*) K,Q,AL(J),A(1,1)
C              ENDDO
C           ENDDO
C           A(IPAR,IPAR)=1.0D0/PP
C           DO I=2,IPAR
C              A(IPAR,I-1)=AL(I)
C           ENDDO
C        ENDDO
C
C ... fill matrix
C
C        DO I=2,IPAR
C           DO J=1,I
C              A(J,I)=A(I,J)
C           ENDDO
C        ENDDO
         CALL MATINV(A,3,DET)
         IF (DET.EQ.0.0) THEN
             WRITE (*,*) 'ERROR ------------------------------'
         END IF

         WRITE (*,*) DET
         WRITE (*,*) A(1,1),A(1,2),A(1,3)
         WRITE (*,*) A(2,1),A(2,2),A(2,3)
         WRITE (*,*) A(3,1),A(3,2),A(3,3)
C
C ... compute reduced chi**2 and corrections for unknowns
C
         CHI    = CHI/DBLE(NF)
         DO 70 I = 1,IPAR
             Q      = 0.0D0
             DO 60 J = 1,IPAR
                Q      = Q + A(I,J)*B(J)
   60        CONTINUE
C
C ... compute errors of the corrections
C
            D(I)   = SNGL(DSQRT(DMAX1(A(I,I)*CHI,0.0D0)))
            P(I)   = P(I) + RELAX*SNGL(Q)  !   DEBUG <------------- !
            WRITE (*,*) D(I),P(I)
   70    CONTINUE
         ERROR  = SNGL(DSQRT(DMAX1(CHI,0.0D0)))
         LINE   = ' '
         WRITE (LINE,9010) ERROR
         CALL STTPUT(LINE,ISTAT)
         IF (ABS(ERROR).LE.ERR) RETURN
   80 CONTINUE
   90 CONTINUE
      RETURN

 9000 FORMAT (' Iteration :',I4,' Params :',3E13.4)
 9010 FORMAT (' Error     :',E13.4)
      END

      SUBROUTINE FSINC(X,Y1,CONST,P,D)
C
      IMPLICIT NONE
C     INTERNAL FUNCTION SINC, SINGULARITY AT (X*P(3)->1.)
C
      REAL      CONST,X,Y1,A0,A,A2,SINCA,CA,SA,P,D
      DIMENSION P(3),D(3)

      A0     = X*P(3) - 1.
      IF (ABS(A0).LT.0.1E-20) THEN
          Y1     = 1.
          D(1)   = 1.
          D(2)   = 0.
          D(3)   = 0.

      ELSE
          A      = CONST*P(2)*A0
          A2     = A*A
          SINCA  = SIN(A)/A
          CA     = COS(A) - SA
          D(1)   = SINCA*SINCA
          Y1     = P(1)*D(1)
          D(2)   = (2.*P(1)*SINCA*CA)/P(2)
          D(3)   = (2.*P(1)*SINCA*CA*X)/A0
      END IF

      RETURN

      END

      SUBROUTINE FIT2(NX,NY,IN,OUT,I,X0,DX,IDEG,A,XMIN,XMAX)
C      IMPLICIT NONE
C
C LINEAR FIT ROUTINE INTERFACE
C
C INPUT ARGUMENTS
C
C NX INTG*4 NUMBER OF SAMPLES
C  NY INTG*4 NUMBER OF LINES (ORDERS)
C IN REAL*4 INPUT IMAGE
C OUT REAL*4 FITTED VALUES
C I INTG*4 NUMBER OF THE LINE
C IDEG INTG*4 POLYNOMIAL DEGREE
C
C OUTPUT PARAMETERS
C
C A REAL*8 COEFFS
C
      IMPLICIT NONE
      INTEGER          NX,NY,I,IDEG,NT,J
      REAL             X0,DX,XMIN,XMAX
      REAL             IN(NX,NY),OUT(NX,NY)
      DOUBLE PRECISION A(1)

      NT     = NX - NX/50
      CALL LSQFIT(NT,X0,DX,IN(1,I),OUT(1,I),IDEG,A,XMIN,XMAX)
      DO 10 J = NT + 1,NX
          OUT(J,I) = 0.
   10 CONTINUE
      RETURN

      END

      SUBROUTINE LSQFIT(NX,X0,DX,X,FIT,K,A,XMIN,XMAX)
      IMPLICIT NONE
C
C SOLVE LEAST SQUARE PROBLEM
C
      INTEGER          N,NX,K,L,LL,N1,I,KMIN,K1,J
      REAL             X0,DX,XMIN,XMAX,X1,X2,Y,ERROR
      REAL             X(NX),FIT(NX)
      DOUBLE PRECISION G,XC,A(1)
      COMMON /LS/G(50,50),XC(50),N
C
C ITERATION
C
      L      = 0
      LL     = 0
      N1     = 0
      N      = (K+1)* (L+1)
      DO 20 I = 10,NX - 20
          X1     = X0 + (I-1)*DX
          X2     = X1
          Y      = X(I)
          N1     = N1 + 1
          CALL SETUP(LL+1,X1,X2,Y,K,L)
          IF (LL.NE.0) THEN
              KMIN   = MIN(LL,N+1)
              DO 10 K1 = 1,KMIN
                  CALL HT(K1,LL+1)
   10         CONTINUE
          END IF

          LL     = MIN(LL+1,N+1)
   20 CONTINUE
      CALL SOLVE
      ERROR  = ABS(G(N+1,N+1))
      CALL COMP(NX,X0,DX,FIT,K,L,XMIN,XMAX)
      DO 30 J = 1,K + 1
          A(J)   = XC(J)
   30 CONTINUE
      RETURN

      END

      SUBROUTINE SETUP(LL,X1,X2,Y,K,L)
      IMPLICIT NONE
C
C PREPARE DATA IN WORK SPACE
C
      INTEGER          N,LL,K,L,IP,L1,K1
      REAL             X1,X2,Y
      DOUBLE PRECISION G,X,DC
      COMMON /LS/G(50,50),X(50),N

      IP     = 0
      DC     = 1.D0
C DX1 = DBLE(X1)*0.001D0
C DX2 = DBLE(X2)*0.001D0
C DY  = DBLE(Y)*0.001D0
      DO 20 L1 = 0,L
          IP     = IP + 1
          G(LL,IP) = DC
          DO 10 K1 = 1,K
              IP     = IP + 1
              G(LL,IP) = G(LL,IP-1)*X1
   10     CONTINUE
          DC     = DC*X2
   20 CONTINUE
      G(LL,N+1) = Y
      RETURN

      END

      SUBROUTINE HT(K,L1)
      IMPLICIT NONE

C     FUNCTION : Apply a Householder transformation to the
C                two rows K and L1 of G.
C
C     INPUT :    * matrix G(1:L1,1:n+1)
C                * numbers L1 and K of the two rows
C                * n : rank of the matrix
C
C     OUTPUT :   modified rows K and L1 of the matrix G.
      DOUBLE PRECISION G,X,S,H,B
      COMMON /LS/G(50,50),X(50),N

C     Construct the transformation
      INTEGER   N,K,L1,KH,J 

      S      = DSQRT(G(K,K)**2+G(L1,K)**2)
      IF (G(K,K).GE.0) THEN
          S      = -S
      END IF

      H      = G(K,K) - S
      G(K,K) = S
      B      = G(K,K)*H

C     Apply the transformation to the rows K and L1 of G.

      KH     = N + 1 - K

      IF ((KH.NE.0) .AND. (B.NE.0)) THEN
          DO 10 J = 1,KH
              S      = (G(K,K+J)*H+G(L1,K+J)*G(L1,K))/B
              G(K,K+J) = G(K,K+J) + S*H
              G(L1,K+J) = G(L1,K+J) + S*G(L1,K)
   10     CONTINUE
      END IF

      END

      SUBROUTINE SOLVE
      IMPLICIT NONE
C     FUNCTION : Solve the set of linear equations which are
C                represented by the upper triangular part
C                of the matrix G(1:n,1:n+1).
C
C     INPUT :    * matrix G(1:n,1:n+1)
C                * n : rank of the matrix
C
C     OUTPUT :   solution vector x(1:n)
      DOUBLE PRECISION G,X,S
      COMMON /LS/G(50,50),X(50),N

      INTEGER   N,I,II,J

      DO 10 I = 1,N
          X(I)   = G(I,N+1)
   10 CONTINUE

      DO 30 II = 1,N
          I      = N - II + 1
          S      = 0.D0
          IF (I.NE.N) THEN
              DO 20 J = 2,N + 1 - I
                  S      = S + G(I,I+J-1)*X(I+J-1)
   20         CONTINUE
          END IF

          X(I)   = (X(I)-S)/G(I,I)
   30 CONTINUE

      END

      SUBROUTINE COMP(NPIX1,START,STEP,OUT,K,L,XMIN,XMAX)
      IMPLICIT NONE
C

      INTEGER          N,NPIX1,K,L,IX,IP,L1,K1
      REAL             START,STEP,XMIN,XMAX
      REAL             OUT(NPIX1)
      DOUBLE PRECISION WORK(50),DC,YVAL,G,A
      DOUBLE PRECISION X1,X2,XSTART,XSTEP
      COMMON /LS/G(50,50),A(50),N
C
C  initialize variables
      XMIN   = 0.
      XMAX   = XMIN
      XSTART = START
      XSTEP  = STEP
C
C  start loop
      DO 30 IX = 1,NPIX1
          X1     = (IX-1)*XSTEP + XSTART
          IP     = 0
          DC     = 1.D0
          YVAL   = 0.D0
          DO 20 L1 = 0,L
              IP     = IP + 1
              WORK(IP) = DC
              YVAL   = YVAL + WORK(IP)*A(IP)
              DO 10 K1 = 1,K
                  IP     = IP + 1
                  WORK(IP) = WORK(IP-1)*X1
                  YVAL   = YVAL + WORK(IP)*A(IP)
   10         CONTINUE
              DC     = DC*X2
   20     CONTINUE
          OUT(IX) = YVAL
          XMIN   = AMIN1(XMIN,OUT(IX))
          XMAX   = AMAX1(XMAX,OUT(IX))
   30 CONTINUE
      RETURN

      END

C @(#)semilog.for	19.1 (ES0-DMD) 02/25/03 13:17:43
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE SEMILG(IND,X,NP,P,Y1,DY)                                      
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                  
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  18:01 - 21 DEC 1987                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C--------------------------------------------------------------                 
C                                                                               
C SEMI-LOGISTIC DISTRIBUTION                                                    
C      IMPLICIT NONE                                                            
C                                                                               
C Y1 = 2.*P(1)/(1.+EXP(LN(3)*ABS(X-P(2))/P(3)))                                 
C                                                                               
      INTEGER IND,NP
      DOUBLE PRECISION Y1,P(NP),DY(NP),A,B,C,D,E,F                              
      REAL X(1)                                                                 
C                                                                               
      A      = X(1) - P(2)                                                      
      B      = DABS(A)                                                          
      C      = 1.098612289/P(3)                                                 
      D      = B*C                                                              
      E      = DEXP(D)                                                          
      F      = 1./ (1.+E)                                                       
      DY(1)  = 2.*F                                                             
      Y1     = DY(1)*P(1)                                                       
      F      = C*E*F                                                            
      DY(2)  = DSIGN(-Y1*F,A)                                                   
      DY(3)  = F*B/P(3)                                                         
      RETURN                                                                    
                                                                                
      END                                                                       

C @(#)cauchy2d.for	19.1 (ES0-DMD) 02/25/03 13:17:28
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE CAUC2D(X,NP,PARAM,Y,DERIV)                                   
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                  
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  18:01 - 21 DEC 1987                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C--------------------------------------------------------------                 
C**********************************************                                 
C                                                                               
C      IMPLICIT NONE                                                            
C      COMMON /VMR/MADRID(1)                                                   
C  CAUCHY DISTRIBUTION                                                          
C                                                                               
C  Y(X;P1,P2,P3) = P1/(1.+(2(X-P2)/P3)**2)                                      
C                                                                               
C**********************************************                                 
C  Author: O.-G. Richter, ESO Garching                                          
C                                                                               
      INTEGER NP
      REAL X(2)                                                            
      DOUBLE PRECISION Y,PARAM(NP),DERIV(NP)                                    
C                                                                               
      DOUBLE PRECISION A,B                                                      
C                                                                               
      A      = 2.0D0* (X(1)-PARAM(2))/PARAM(4)                                  
      B      = 2.0D0* (X(2)-PARAM(3))/PARAM(5)                                  
      DERIV(1) = 1.0D0/ (1.D0+A*A+B*B)                                          
      Y      = PARAM(1)*DERIV(1)                                                
      DERIV(2) = 4.0D0*Y*DERIV(1)*A/PARAM(4)                                    
      DERIV(3) = 4.0D0*Y*DERIV(1)*B/PARAM(5)                                    
      DERIV(4) = 0.5D0*A*DERIV(2)                                               
      DERIV(5) = 0.5D0*B*DERIV(3)                                               
C                                                                               
      RETURN                                                                    
                                                                                
      END                                                                       

C @(#)mean.for	19.1 (ES0-DMD) 02/25/03 13:23:05
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C @(#)mean.for	19.1 (ESO-SDAG) 02/25/03 13:23:05
      SUBROUTINE MEAN(XTEMP,YTEMP,IX,XMEAN,YMEAN,NKICK,RESA,SIG) 

      IMPLICIT REAL*8 (A-H,O-Z), INTEGER*4 (I-N)
C
C MEAN COMPUTES MEAN VALUES OF (X,Y) MEASUREMENTS OF THE SAME OBJECT.
C IF THERE ARE MORE THAN 2 MEASUREMENTS, THE R.M.S. VALUES OF X, Y
C AND R (=SQRT(X**2+Y**2)) ARE ALSO RETURNED IN RESA(3).
C IF R.M.S. (R) IS LARGER THAN SIG, THEN THE (X,Y) WITH THE
C LARGEST RESIDUAL IS REMOVED. THIS PROCESS IS CONTINUED UNTIL
C R.M.S. (R) < SIG, OR IF THERE ARE ONLY 2 MEASUREMENTS LEFT.
C
C A REASONABLE VALUE IS SIG = 5.0 MICRONS
C
      DIMENSION XTEMP(20),YTEMP(20),RESA(3)

      NKICK = 0 
   10 RESX = 0
      RESY = 0
      RESD = 0
      XMEAN = 0 
      YMEAN = 0 

      DO 20 I = 1,IX
         XMEAN = XMEAN + XTEMP(I)
   20    YMEAN = YMEAN + YTEMP(I)
      XMEAN = XMEAN/IX
      YMEAN = YMEAN/IX

      IF(IX.LE.2) GO TO  60 

      DO 30 I=1,IX
         RESX = RESX+(XMEAN-XTEMP(I))**2 
         RESY = RESY+(YMEAN-YTEMP(I))**2 
   30    RESD = RESD+((XMEAN-XTEMP(I))**2+(YMEAN-YTEMP(I))**2) 
      RESX = SQRT(RESX/(IX**2-IX))
      RESY = SQRT(RESY/(IX**2-IX))
      RESD = SQRT(RESD/(IX**2-IX))

      IF(RESD.LT.SIG) GO TO  60 

      DIFF = 0

C
C NOW FIND THE WORST (X,Y) AND REMOVE IT
C
      DO 40 I=1,IX
         DIF = SQRT((XMEAN-XTEMP(I))**2+(YMEAN-YTEMP(I))**2) 
         IF(DIF.LT.DIFF) GO TO 40
         IKICK = I 
         DIFF = DIF
   40    CONTINUE

C
C CLOSE THE RANKS
C
      DO 50 I=IKICK,IX
         XTEMP(I) = XTEMP(I+1) 
   50    YTEMP(I) = YTEMP(I+1) 
      IX = IX-1 
      NKICK = NKICK + 1 
      GO TO 10


C The End
   60 RESA(1) = RESX
      RESA(2) = RESY
      RESA(3) = RESD
      RETURN
      END 

C @(#)tsadelur1.for	19.1 (ES0-DMD) 02/25/03 13:32:59
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C  @(#)tsadelur1.for	5.1 (ESO-IPG) 4/5/93 15:58:28
C
C
C
C    TSADELUR1
C
C   Autocorrelation function of data in analytic form, for FITCOR
C
C   Input:
C   TLAG                        - time lag
C
C   Output:
C   TSADELUR1                     - ACF function value
C
      DOUBLE PRECISION FUNCTION TSADELUR1(TLAG,PARM)
      DOUBLE PRECISION TLAG, PARM(12)
      CALL STETER(1,' Undefined user ACF: create tsadelur1.for')
      TSADELUR1=0.
      END

C @(#)sdp.for	19.1 (ESO-DMD) 02/25/03 13:24:48
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM SDP
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  program SDP			version 1.00	910110
C  K. Banse				ESO - Garching
C    1.20	920430
C
C.KEYWORDS
C  dynamic systems, bulk data frame
C
C.PURPOSE
C  create a MIDAS image
C
C.ALGORITHM
C  use MIDAS interfaces
C
C.INPUT/OUTPUT
C  the following keywords are used:
C
C IN_A/C/1/60                  	name of input 1-dim image
C OUT_A/C/1/60                 	name of output 2-dim image
C
C.VERSIONS
C
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      NAXIS
      INTEGER*8    PNTRA,PNTRB,PNTRW
      INTEGER      IAV,NO,STAT,IBUF(10)
      INTEGER      INOA,INOB,INOW,NPIXA,NPIX(2)
      INTEGER      NTOP,NLO,UNIT(1),MADRID(1)
C
      DOUBLE PRECISION START(2),STEP(2)
C
      CHARACTER    CUNIT*48,IDENT*72,INFRA*60,OUTFRA*60
      CHARACTER    CBUF*60
C 
      REAL         CUTS(4)
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      COMMON   /VMR/ MADRID
C
      DATA      CUNIT /'none given '/, CBUF /' '/
      DATA      NPIX      /2*1/,       START /2*0.D0/, STEP /2*1.D0/
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C  get into MIDAS
      CALL STSPRO('SDP')
C
C  get name of input, result frame
      CALL STKRDC('IN_A',1,1,60,IAV,INFRA,UNIT,NLO,STAT)
      CALL STKRDC('OUT_A',1,1,60,IAV,OUTFRA,UNIT,NLO,STAT)
      CALL STKRDI('INPUTI',1,10,IAV,IBUF,UNIT,NLO,STAT)
      NTOP = IBUF(1)
C
C  get input frame + create working buffer and output graph
      CALL STIGET(INFRA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +            1,NAXIS,NPIX,START,STEP,IDENT,
     +            CUNIT,PNTRA,INOA,STAT)
      NAXIS = 1                                   !force to 1-dim frame...
      CALL STIPUT('dummy',D_I4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +            NAXIS,NPIX,START,STEP,IDENT,
     +            CUNIT,PNTRW,INOW,STAT)
      NPIXA = NPIX(1)
      CALL STDRDR(INOA,'LHCUTS',1,4,IAV,CUTS,UNIT,NLO,STAT)
      IF (CUTS(1).GE.CUTS(2)) THEN
         NO = 3
      ELSE
         NO = 1
      ENDIF
C 
      NPIX(1) = 2*NTOP + 1
      NPIX(2) = NPIX(1)
      NAXIS = 2
      START(1) = -NTOP
      START(2) = START(1)
      STEP(1) = 1.
      STEP(2) = STEP(1)
      CALL STIPUT(OUTFRA,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +            NAXIS,NPIX,START,STEP,IDENT,
     +            CUNIT,PNTRB,INOB,STAT)
C
C map dat into interval [0,NTOP]
      CALL MYSCAL(MADRID(PNTRA),MADRID(PNTRW),NPIXA,NTOP,CUTS(NO))
C
C and do the symmetrical dot pattern
      CALL DOSDP(MADRID(PNTRW),NPIXA,MADRID(PNTRB),NPIX,IBUF)
C 
C  that's it folks...
      CALL STSEPI
      END

      SUBROUTINE MYSCAL(A,IB,NDIM,NTOP,FCUTS)
C 
      IMPLICIT NONE
C 
      INTEGER   IB(1),NDIM,NTOP
      INTEGER   N
C 
      REAL      A(1),FCUTS(2)
      REAL      AMIN,AMAX,FACT
C 
      AMIN = FCUTS(1)
      AMAX = FCUTS(2)
C 
C  now scale
      FACT = NTOP / (AMAX-AMIN)
      DO 2000 N=1,NDIM
         IF (A(N).LE.AMIN) THEN
            IB(N) = 0
         ELSE IF (A(N).GE.AMAX) THEN
            IB(N) = NTOP
         ELSE
            IB(N) = NINT((A(N)-AMIN)*FACT)
         ENDIF
2000  CONTINUE
C 
      RETURN
      END

      SUBROUTINE DOSDP(IB,NDIM,C,NPIX,KBUF)
C 
      IMPLICIT NONE
C 
      INTEGER  IB(*),NDIM,NPIX(2),KBUF(*)
      INTEGER  N,NN,KR,JB,NHALF,OFF
      INTEGER  LAG,IANG,IX,IY
C 
      REAL  C(1)
      REAL  PI,RF,ANGLE,COLOR,CO,SI
C 
      DATA     PI /3.141593/                         !Pi
C 
      DO 200 N=1,NPIX(1)*NPIX(2)
         C(N) = 0.0
200   CONTINUE
C 
      IANG = 60
      LAG = KBUF(2)
      RF = PI / 180.
      NHALF = KBUF(1) + 1
C 
      DO 1000 N=1,NDIM-LAG
         JB = IB(N+LAG)
         KR = IB(N)
         IF (JB.GE.KR) THEN               !IB(n+lag) >= IB(n)
            COLOR = KBUF(3)
         ELSE
            COLOR = KBUF(4)
         ENDIF
C
         DO 500 NN=1,360,IANG
            IF (KR.EQ.0) THEN
               OFF = (NHALF-1)*NPIX(1) + NHALF
               IF (KBUF(5).EQ.1) THEN
                  C(OFF) = C(OFF) + COLOR 
               ELSE
                  C(OFF) = COLOR
               ENDIF
            ELSE
               ANGLE = NN + JB
               ANGLE = ANGLE * RF
               CO = COS(ANGLE)
               SI = SIN(ANGLE)
               IX = NINT(KR * CO)
               IY = NINT(KR * SI)
               IX = IX + NHALF                  !center of array = 0
               IY = IY + NHALF 
               OFF = (IY-1)*NPIX(1) + IX
               IF (KBUF(5).EQ.1) THEN
                  C(OFF) = C(OFF) + COLOR
               ELSE
                  C(OFF) = COLOR
               ENDIF
C 
               ANGLE = NN - JB
               ANGLE = ANGLE * RF
               CO = COS(ANGLE)
               SI = SIN(ANGLE)
               IX = NINT(KR * CO)
               IY = NINT(KR * SI)
               IX = IX + NHALF                  !center of array = 0
               IY = IY + NHALF 
               OFF = (IY-1)*NPIX(1) + IX
               IF (KBUF(5).EQ.1) THEN
                  C(OFF) = C(OFF) + COLOR
               ELSE
                  C(OFF) = COLOR
               ENDIF
            ENDIF
500      CONTINUE
1000  CONTINUE
C 
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2008 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================

C ++++++++++++++++++++++++  ygen.for +++++++++++++++++++++++++++++++++++++++
C .LANGUAGE Fortran 77
C .IDENTIFICATION Module ygen.for
C .COMMENTS
C Module contains layer between the keyword related FORTRAN STxxxx interfaces
C and the SC_interfaces written in (hopefully independent) C
C .AUTHOR         K. Banse        ESO - Garching
C .KEYWORDS       standard interfaces.
C .ENVIRONMENT    FORTRAN and C standards
C .VERSION  [1.00] 871207:  created from SXFTOC.C
C 
C 080722		last modif
C -----------------------------------------------------------------------------
C
      SUBROUTINE GENCNV(TEXT,TYPE,MAXVAL,IBUF,RBUF,DBUF,ACTVAL)
C
      IMPLICIT NONE
C
      CHARACTER*(*)  TEXT
      INTEGER     TYPE,MAXVAL
      INTEGER     IBUF(*)
      REAL        RBUF(*)
      DOUBLE PRECISION   DBUF(*)
      INTEGER     ACTVAL
C 
      CALL STSTR(1,TEXT)                          !STRIPPED_STRING
C 
      CALL STGN1(TYPE,MAXVAL,IBUF,RBUF,DBUF,ACTVAL)
C
      RETURN
      END
C
C 
      SUBROUTINE GENBLD(SIMNO,NAME,DATFORM,SIZE,IMNO,CLONED,STATUS)
C
      IMPLICIT NONE
C
      INTEGER     SIMNO
      CHARACTER*(*)  NAME
      INTEGER     DATFORM,SIZE,IMNO,CLONED
      INTEGER     STATUS
C
      CALL STSTR(1,NAME)                          !STRIPPED_STRING
C 
      CALL STGN2(SIMNO,DATFORM,SIZE,IMNO,CLONED,STATUS)
C
      RETURN
      END
C
C 
      INTEGER FUNCTION GENNUM(TEXT)
C
      IMPLICIT NONE
C
      CHARACTER*(*)  TEXT
      INTEGER     STATUS
C
      CALL STSTR(1,TEXT)                          !STRIPPED_STRING
C
      CALL STGN3(STATUS)
      GENNUM = STATUS
C
      RETURN
      END
C
C 
      SUBROUTINE GENLGN(INFILE,OUTFILE,MAXOUT)
C
      IMPLICIT NONE
C
      CHARACTER*(*)  INFILE, OUTFILE
      INTEGER     MAXOUT
C
      CALL STSTR(1,INFILE)                          !STRIPPED_STRING
      CALL STLOC(1,1,OUTFILE)                       !blanked CHAR_LOC
C
      CALL STGN4(MAXOUT)
C
      RETURN
      END
C
C 
      SUBROUTINE GENTIM(TIME)
C
      IMPLICIT NONE
C
      CHARACTER*(*)  TIME
      INTEGER     STATUS
C
      CALL STLOC(1,1,TIME)                          !blanked CHAR_LOC
C
      CALL STGN5(STATUS)
C
      RETURN
      END
C
C 
      SUBROUTINE GENEQF(AFILE,BFILE,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)  AFILE, BFILE
      INTEGER     STATUS
C
      CALL STSTR(1,AFILE)                          !STRIPPED_STRING
      CALL STSTR(2,BFILE)                         !STRIPPED_STRING
C
      CALL STGN6(STATUS)
C
      RETURN
      END
C
C 
      SUBROUTINE GENLEN(STRUNG,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)  STRUNG
      INTEGER     STATUS
C
      CALL STSTR(1,STRUNG)                          !STRIPPED_STRING
C
      CALL STGN7(STATUS)
C
      RETURN
      END
C
C 
      SUBROUTINE ISSUBF(INFILE,INDX)
C
      IMPLICIT NONE
C
      CHARACTER*(*)  INFILE
      INTEGER     INDX
C
      CALL STSTR(1,INFILE)                          !STRIPPED_STRING
C
      CALL STGN8(INDX)
C
      RETURN
      END
C
C 
      SUBROUTINE DSCUPT(INNO,OUTNO,HISTORY,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)  HISTORY
      INTEGER     INNO,OUTNO,STATUS
C
      CALL STSTR(1,HISTORY) 
C
      CALL STGN9(INNO,OUTNO,STATUS)
C
      RETURN
      END
C

C  @(#)tdcmph.for	19.1 (ESO-IPG) 02/25/03 14:11:15 
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION:
C       TDCMPH.FOR
C
C.KEYWORDS
C       histogram, tables, images
C
C.PURPOSE
C
C  execute the command
C
C  COMP/HIST OUTPUT = TABLE COLUMN-REF [STEP [MIN-VAL  [MAX-VAL]]]
C        --------or---------
C  COMP/HIST OUTPUT = IMAGE [START1,START2:END1,END2] [step min max]
C
C  WHERE 'OUTPUT' CAN BE EITHER 'frame' OR 'name/TABLE'
C
C.ALGORITHM
C
C  USE TABLE INTERFACE ROUTINES
C 
C 020807		last modif
C 
C-----------------------------------------------------------
C
      SUBROUTINE TDCMPH
      IMPLICIT NONE
C
C ... PARAMETER DEFINITION
C
      INTEGER       MADRID
      INTEGER       NEVALS
      INTEGER       TID, TID1, II1, II2, IDUMMY, NVALS
      INTEGER       STATUS, ISTAT, ICOL
      INTEGER       NROW, OTAB, IX, NNN
      INTEGER       NCOL, NSC, NAC, NAR
      INTEGER       NPAR, DUMMY, II, LEN
      INTEGER*8     IPTR, ADDR1, OPNTR
      INTEGER       NBINS, IC1, IC2
      INTEGER       INDEX, NPIX(3), SUBDIM, SUBLO(3), SUBHI(3)
      INTEGER       TYPE, RESPIX(4), TINULL
      INTEGER       NAXIS, IMNO, IVAL(4),TLEN,LLEN
C
      LOGICAL       ITAB
C
      REAL X0,X1,XT,AXMAX,AXMIN,START, CUTVLS(4), OUTPR(4)
      REAL XMIN,XMAX,RPAR(3),STEP,LHCUTS(4), TRNULL
C
      DOUBLE PRECISION DSTART, DSTEP, START1(3), STEP1(3), TDNULL
C
      CHARACTER*16  LABEL, UNIT
      CHARACTER*8   FORM
      CHARACTER     COLREF*17,WORK*60
      CHARACTER     CUNIT*72
      CHARACTER*80  DUNIT, CIDEN, TABLE, FRAME
      CHARACTER*16  MSG
C
      INCLUDE   'MID_INCLUDE:TABLES.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE   'MID_INCLUDE:TABLED.INC'
C
      DATA      NEVALS/7/
      DATA      MSG/'ERR:TCOMPHSTxxxx'/
      DATA      NPIX /1,1,1/
      DATA      START1 /0.,0.,0./, STEP1 /1.,1.,1./
C
C ... GET INPUT PARAMETERS + DEFAULT
C
      CALL TDPGET(NEVALS,NPAR,ISTAT)
      IF (ISTAT.NE.0) GO TO 30
      TABLE   = TPARBF(3)
      CALL GENLEN(TABLE,TLEN)
      COLREF  = TPARBF(4)
      IF (COLREF(1:1).EQ.':' .OR. COLREF(1:1).EQ.'#') THEN
         ITAB = .TRUE.
      ELSE
         ITAB = .FALSE.
      ENDIF
      CALL TBMNUL(TINULL, TRNULL, TDNULL)
      RPAR(2) = TRNULL
      RPAR(3) = RPAR(2)
      RPAR(1) = 0.0
      II1     = 1
      DO 20 II2 = 5,NPAR
          II     = INDEX(TPARBF(II2),' ') - 1
          WORK   = TPARBF(II2) (1:II)
          CALL GENCNV(WORK,2,1,IDUMMY,RPAR(II1),DUMMY,NVALS)
          II1    = II1 + 1
          IF (NVALS.NE.1) GO TO 30
   20 CONTINUE
      STEP   = RPAR(1)
      AXMIN  = RPAR(2)
      AXMAX  = RPAR(3)
C
C ... READ INPUT DATA SET
C
C                                                 TABLE INPUT DATA
      IF (ITAB) THEN
        TID = -1
        CALL TBTOPN(TABLE,F_I_MODE,TID,ISTAT)
        IF (ISTAT.NE.0) GO TO 30
        CALL TBIGET(TID,NCOL,NROW,NSC,NAC,NAR,ISTAT)
        IF (ISTAT.NE.0) GO TO 30
C
C ... FIND INPUT COLUMN
C
        ICOL   = -1
        CALL TBCSER(TID,COLREF,ICOL,ISTAT)
        IF (ICOL.EQ.-1) THEN
            CALL STTPUT('Column not found...',ISTAT)
            GO TO 30
        END IF
        CALL TBLGET(TID,ICOL,LABEL,ISTAT)
        CALL GENLEN(LABEL,LLEN)
        CALL TBUGET(TID,ICOL,UNIT,ISTAT)
        CALL TBFGET(TID,ICOL,FORM,LEN,TYPE,ISTAT)
        IF (TYPE.EQ.D_C_FORMAT) THEN
            CALL STTPUT('Error, Column of type Character',ISTAT)
          GO TO 30
        END IF
C
C ... BUILD THE GRID
C
        IF (AXMIN.EQ.TRNULL .OR. AXMAX.EQ.TRNULL) THEN
            CALL TDUMNX(TID,ICOL,NROW,0,XMIN,XMAX)
            CALL TDSCAL(XMIN,XMAX,1.,X0,X1,IX,XT,NNN)
            IF (AXMIN.EQ.TRNULL) AXMIN  = X0*10.**IX
            IF (AXMAX.EQ.TRNULL) AXMAX  = X1*10.**IX
        ENDIF
        IF (STEP.EQ.0.0) THEN
            CALL TDSCAL(AXMIN,AXMAX,1.,X0,X1,IX,XT,NNN)
            STEP   = XT
        END IF
        NBINS  = (AXMAX-AXMIN)/STEP
        START  = AXMIN + STEP*0.5
      ELSE
C                                                          IMAGE INPUT DATA
        CALL STIGET(TABLE,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     .  3,NAXIS,NPIX,START1,STEP1,CIDEN,CUNIT,IPTR,IMNO,ISTAT)
        IF (ISTAT.NE.0) GO TO 30
C
C ... GET SUBIMAGE SPECIFICATION
C
        IF (COLREF(1:1) .EQ. '[') THEN
           CALL EXTCOO(IMNO,COLREF,3,SUBDIM,SUBLO,SUBHI,ISTAT)
        ELSE
           SUBDIM   = NAXIS
           SUBLO(1) = 1
           SUBLO(2) = 1
           SUBLO(3) = 1
           SUBHI(1) = NPIX(1)
           SUBHI(2) = NPIX(2)
           SUBHI(3) = NPIX(3)
        ENDIF
C
C ... BUILD THE GRID
C
        IF (AXMIN.EQ.TRNULL .OR. AXMAX.EQ.TRNULL) THEN
            CALL STVALS('MIN',MADRID(IPTR),SUBDIM,NPIX,
     .      SUBLO,SUBHI,CUTVLS,OUTPR,RESPIX,IVAL,ISTAT)
            XMIN = OUTPR(1)
            XMAX = OUTPR(2)
            CALL TDSCAL(XMIN,XMAX,1.,X0,X1,IX,XT,NNN)
            IF (AXMIN.EQ.TRNULL) AXMIN  = X0*10.**IX
            IF (AXMAX.EQ.TRNULL) AXMAX  = X1*10.**IX
        ENDIF
        IF (STEP.EQ.0.0) THEN
            CALL TDSCAL(AXMIN,AXMAX,1.,X0,X1,IX,XT,NNN)
            STEP   = XT
        END IF
        NBINS  = (AXMAX-AXMIN)/STEP
        START  = AXMIN + STEP*0.5
      ENDIF
C
C ... CREATE OUTPUT TABLE OR FRAME
C
      OTAB   = INDEX(TPARBF(1),'/T')
      IF (OTAB.EQ.0) OTAB   = INDEX(TPARBF(1),'/t')
      IF (OTAB.EQ.0) THEN
          FRAME  = TPARBF(1)
          WORK   = ' HISTOGRAM TABLE '//TABLE(1:TLEN)//
     1             ' .COLUMN '//LABEL(1:LLEN)
          CUNIT  = 'FREQUENCY       '//UNIT
          DSTART = AXMIN
          DSTEP  = STEP
          CALL STIPUT(FRAME,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .    1,NBINS,DSTART,DSTEP,WORK,CUNIT,OPNTR,TID1,ISTAT)
      ELSE
          FRAME  = TPARBF(1) (1:OTAB-1)
          NVALS  = 4
          CALL TBTINI(FRAME,F_TRANS,F_O_MODE,NVALS,NBINS,TID1,ISTAT)
          CALL TBCINI(TID1,D_R4_FORMAT,1,FORM,UNIT,LABEL,IC1,ISTAT)
          UNIT   = ' '
          LABEL  = 'FREQUENCY'
          CALL TBCINI(TID1,D_R4_FORMAT,1,FORM,UNIT,LABEL,IC2,ISTAT)
          CALL TBCMAP(TID1,IC1,ADDR1,ISTAT)
          CALL TBCMAP(TID1,IC2,OPNTR,ISTAT)
          CALL SAMPLE(NBINS,MADRID(ADDR1),START,STEP)
          CALL TBIPUT(TID1,0,NBINS,ISTAT)
      END IF
C
C ... FREQUENCY ANALYSIS
C
      IF (ITAB) THEN
          CALL TDHSTM(TID,ICOL,NROW,NBINS,MADRID(OPNTR),
     .    AXMIN,STEP,LHCUTS(3),LHCUTS(4))
          CALL TBTCLO(TID,ISTAT)
      ELSE
          CUTVLS(1) = AXMIN
          CUTVLS(2) = CUTVLS(1)
          CALL TDIHST(MADRID(IPTR),SUBDIM,NPIX,SUBLO,SUBHI,CUTVLS,
     .    STEP,NBINS,MADRID(OPNTR),LHCUTS(3),LHCUTS(4))
      END IF
C
C ... END
C
      CALL TDHSTR(TID1,ISTAT)
      IF (OTAB.NE.0) THEN
          CALL TBSINI(TID1,ISTAT)
          CALL DSCUPT(TID1,TID1,' ',ISTAT)
          CALL TBTCLO(TID1,ISTAT)
      ELSE
          CALL STDWRR(TID1,'LHCUTS',LHCUTS,1,4,DUNIT,ISTAT)
      END IF
   30 IF (ISTAT.NE.0) THEN
          WRITE (MSG(13:16),9000) ISTAT
          CALL TDERRR(ISTAT,MSG,STATUS)
      END IF
      RETURN
 9000 FORMAT (I4)
      END

      SUBROUTINE SAMPLE(N,X,X0,XS)
C
C GENERATES SAMPLING STEPS IN THE ARRAY X AS
C X(I) = X0 + (I-1)*XS
C
      IMPLICIT NONE
      INTEGER N
      REAL    X(N)
      REAL    X0, XS
      INTEGER I
C
      DO 10 I = 1,N
          X(I)   = X0 + (I-1)*XS
   10 CONTINUE
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
       PROGRAM POS1a
C---------------------------------------------------------------------------
c.file: pos1a.for
c.purpose:	POS1 astrometric package
C      THIS PROGRAM COMPUTES (ALFA,DELTA) FOR OBJECTS 
C      MEASURED ON PHOTOGRAPHIC PLATES.
C
C.remarks:
C      The plates can be from the Schmidt or any other telescope. If they
c      are from the Schmidt, the plate curvature will be taken into account.
c 
c      INPUT is from two midas tables:
c            STANDARD: the following columns must exist
c                :PPM Identifier (<=6digit intg)
c                :R_A  Right Ascension in deg.
c                :DEC  Decl. in deg
c                :MAG  Magnitude
c                :PMA  Proper Motion in RA  in arcsecond/year (NOT time_second)
c                :PMD  Proper Motion in Dec in arcsecond/year 
C            DATA FILE:  the following columns must exist
c                :IDENT Identifier; must contain a number, leading
c                       letters (eg, PPM) are ignored 
c                :Xcen X measurement
c                :YCEN Y Measurement
C
C      The following parameters are read from MIDAS keywords:
C            FLAGS(1): Schmidt plate? (takes the curvature into account)
C            FLAGS(2): Measured with the La Silla blink?
c            SIG: Permitted measurement RMS, in measurement unit (eg  micron)
C            CENTCOOR: coordinates of the plate center; either
C                  h,m,s,d,'," (the routine take care of the -0deg), or
C                  MEAN: takes the barycenter of standard stars
C            EPO_PLA: epoch of the plate
C            EPO_CAT: epoch of the catalogue (NB: This is NOT
C                  necessaryly the equinox of the catalogue coordinates.
C            TERMS: which from the following terms should be used 
C                  for the transfo. 1: set, 0: ignored; same for Y
C                  X Y  XY X**2 Y**2 X**3 Y**3 XY**2 YX**2
C            STDSEL: Standard selection
C                  A: take ALL the available standards (eg, 1st run)
C                  U: take only the standard not marked as deleted (eg, 
C                     subsequent run).
C      OUTPUT:
C            The parameter of the transformation are stored in the 
C            Following Midas keywords:
C            CX, CY: constant terms
C            BX, BY: parameters of x and y and their power
C            NX, NY: how many terms in x and y
c            ALDE0: Alpha, Delta, cos Delta, sin Delta
C           
C      Call this prg with the pos1.prg or pos1a.prg.
C      pos1a.f computes ONLY the transformation parameters.
C      The actual coordinate conversion is performed by pos1b.
C      The standard can be selected/deleted by residual.prg
C--------------------------------------------------------------------------- 
c.author: 	OR Hainaut
C.versions:
C         - GENEVA, DECEMBER 16, 1976 R.M.West
C         -         REVISED SEPTEMBER 20, 1977 RMW
C         - MUNICH, THOROUGHLY REVISED OCTOBER 1980 RMW
C         - TRANSFERED TO VAX 31.1.1985 RMW
C         - INSTALLED AT LA SILLA 22.7.1985 RMW
C         - REVISED MARCH 1987 (PROPER MOTION R.A.) RMW
C         - transfered to Sun/Unix at la Silla, 1992, A Smette & OR Hainaut
C         - re-installed on Sun/Unix at Garching, 9/92 ORH
C         - Structure cleaned (IF-THEN-ELSE, GOTO...) 5/93 ORH
c         - transfered to MIDAS 8/93 ORH
c         - a bug fixed: accuracy similar to original POS1 
C 
C #Version: Sat Sep 17 19:18:47 1994
C.VERSION   1995-Mar-26 : Use PARAMETER + Increase buffer size to 10000, PJG
C 
C 100615
C----------------------------------------------------------------------------
C
      IMPLICIT REAL*8 (A-H,O-Z), INTEGER*4 (I-N)
C
      PARAMETER    (MAXOBJ=100001)
C add parameter MAXSTD to increase the size  PN12/00:  
      PARAMETER    (MAXSTD=100001)
C
      CHARACTER*1 STDSEL,DSIG
      CHARACTER*2 ITEGN1,ITEGN2,FLAGS,KTEXT(3,9)
      CHARACTER*16 PSFILE,DFILE
      CHARACTER*16 ACUR, AFOR, CTEST
      CHARACTER*19 STRING_TERM
      CHARACTER*72 CENTCOOR
      CHARACTER*250 MSG


C here the variables for measurements     
      INTEGER TIDD
      INTEGER NCOLD
      INTEGER NROWD
      INTEGER NCDIDENT
 
      INTEGER NSC,ACOL,AROW,ISTAT
      INTEGER ILOOP
      
C here the variables for standards file:  
      INTEGER TIDS
      INTEGER NCOLS
      INTEGER NROWS
      INTEGER NCSPPM

      LOGICAL LOG, NULL, SELECT, ROWSEL, SCHMIDT,BLINK, CENTER

      DIMENSION MNOST(MAXOBJ),IFOUND(MAXOBJ),NOST(MAXOBJ)
      DIMENSION KK(9),X(10),AR(MAXOBJ,4),BX(9),BY(9),IDX(9),IDY(9) 
      DIMENSION A0(3),D0(3),ST(MAXSTD,2),XY(MAXOBJ,2),ALFA(3),DELTA(3)
      DIMENSION SSX(10,10),S(10,10),R(10,10),SIY(10),SLSSC(9)
      DIMENSION SDC(9),PRXY(MAXOBJ,2) 
      DIMENSION VBI(9),B(9),SV(10),SIGMA(10),XBAR(10),SP(10) 
      DIMENSION SSINV(9,9),ERXY(3),PRST(MAXSTD,2)
      DIMENSION ISTDR(MAXOBJ), ISTDR2(MAXSTD)

      DIMENSION XTEMP(20),YTEMP(20),RESA(3),RESB(3) 
      DIMENSION STMAG(MAXSTD),IA1(2),ID1(2),IA2(2),ID2(2)
      DIMENSION KICK(MAXSTD),PRSTMAG(MAXSTD)

      EQUIVALENCE 
     >     (SSX,S,R),
     >     (S(2,1),B),
     >     (S(3,2),DEV),
     >     (S(4,2),SW,V),
     >     (S(5,2),SSR,RSW),
     >     (S(6,2),CONST),
     >     (S(7,2),SSDR,SUM),
     >     (S(8,2),RSQD),
     >     (S(9,2),CHG,ROFF),
     >     (S(4,3),XMSDR),
     >     (S(5,3),XMSDD),
     >     (S(6,3),VE),
     >     (S(7,3),SDE),
     >     (S(1,4),SLSSC),
     >     (S(1,5),TSQDC),
     >     (S(1,6),SDC),
     >     (S(1,7),VBI),
     >     (SV,SIGMA),
     >     (X,XBAR)
 
C---------------------------------------------------------------------
C---  MIDAS...
C---------------------------------------------------------------------
      INCLUDE          'MID_INCLUDE:ST_DEF.INC'
      COMMON           /VMR/MADRID
      INCLUDE          'MID_INCLUDE:ST_DAT.INC'

      DATA KTEXT/' X', '  ', '  ', ' Y', '  ', '  ', ' X', 'Y ', '  ',
     >           ' X', '**', '2 ', ' Y', '**', '2 ', ' X', '**', '3 ',
     >           ' Y', '**', '3 ', ' X', 'Y*', '*2', ' Y', 'X*', '*2'/ 

C---------------------------------------------------------------------
C---  init
      CALL STSPRO('POS1A')
C---------------------------------------------------------------------
      LU = 30
      DO0 = 0.0D0 
      DO1 = 1.0D0 
      DO12 = 1.2D1
      DO24 = 2.4D1
      DO60 = 6.0D1
      DO180 = 1.8D2 
      DO3600 = 3.6D3
      PI = 4.0D0*DATAN(1.0D0)
      DOPI18 = PI/DO180 
      FOC = 3.054D2/3.6D3
C 
      PSFILE = ' '
      DFILE = ' '
C 
      DO 5, J=1,100 
    5   KICK(J) = 0 
      NKICK = 0 

      ITRY = 0
   10 WRITE(MSG,9015) 
 9015 FORMAT('   POS1: Astrometric solution for Schmid/CCD images')
      CALL STTPUT(MSG,ISTAT)
      CALL STTPUT(' ',ISTAT)

C---  Read the instrument flags:
      CALL STKRDC('FLAGS',1,1,2,N1,FLAGS,IDUM1,IDUM2,ISTAT)

      IF (FLAGS(1:1) .EQ. 'S' .OR. FLAGS(1:1) .EQ. 's' 
     $        .OR. FLAGS(1:1).EQ.'Y' .OR. FLAGS(1:1).EQ.'y') THEN
         SCHMIDT = .TRUE.
      ELSE
         SCHMIDT = .FALSE.
      ENDIF
      
      IF (FLAGS(2:2) .EQ. 'y' .OR. FLAGS(2:2) .EQ. 'Y' 
     >     .OR. FLAGS(2:2) .EQ. 'B' .OR. FLAGS(2:2) .EQ. 'b' ) THEN
         BLINK = .TRUE.
      ELSE
         BLINK = .FALSE.
      ENDIF
      

C---  Get the permitted permitted RMS 
      CALL STKRDD('SIG',1,1,N1,SIG,IDUM1,IDUM2,ISTAT)

C---  Get the center of plate
      CALL STKRDC('CENTCOOR',1,1,72,N1,CENTCOOR,IDUM1,IDUM2,ISTAT)
      IF (CENTCOOR.NE.'MEAN' .AND. CENTCOOR.NE.'mean') THEN
C        * Not "mean": try to read the coordinates.
C        * check if there is a '-': negative decl.
         RH = DO1
         IF(INDEX(CENTCOOR,'-').GT.0) RH = -DO1
C        * Reads the coord.
         READ(CENTCOOR,*,ERR=105,END=105) A0,D0
         DO 103 I = 1, 3
 103        D0(I) =  DABS(D0(I))
         ALFA0 = (A0(1)+A0(2)/DO60+A0(3)/DO3600)*1.5D1*DOPI18
         DELTA0 = RH*(D0(1)+D0(2)/DO60+D0(3)/DO3600)*DOPI18
         CENTER = .TRUE.
         GOTO 106
 105     CENTER = .FALSE.
 106     CONTINUE
      ELSE
C        * "Mean", or error reading the coordinates 
         CENTER = .FALSE.
      ENDIF

C---  Read the plate and catalogue epochs:
      CALL STKRDD('EPO_PLA',1,1,N1,EPOCH,IDUM1,IDUM2,ISTAT)
      CALL STKRDD('EPO_CAT',1,1,N1,EP1,IDUM1,IDUM2,ISTAT)


C---  Reads the xy transformation terms selection flags
      CALL STKRDC('TERMS',1,1,19,N1,STRING_TERM,IDUM1,IDUM2,ISTAT)

C---  read the standard stars status: 
C     * A= check all standards
C     * U= check only the previously identified/undeleted stars.
      CALL STKRDC('STDSEL',1,1,1,N1,STDSEL,IDUM1,IDUM2,ISTAT)
      SELECT = .FALSE.
      IF (STDSEL .eq. 'U') SELECT = .TRUE.


*---  initialize the ASCII log file
cc      LU_LOG = 30
cc      OPEN(UNIT=LU_LOG,FILE='pos1.log')

      IF (SCHMIDT)THEN
         WRITE(MSG,9053)
         CALL STTPUT(MSG,ISTAT)
      ELSE
         WRITE(MSG,9153)
         CALL STTPUT(MSG,ISTAT)
      ENDIF
 9053 FORMAT('   The plate is assumed to be a SCHMIDT plate (curved)')
 9153 FORMAT('   The frame is assumed NOT to be a SCHMIDT',
     $     ' plate (NOT curved)')

      MSG = ' '
      IF (BLINK) WRITE(MSG,9052)
      CALL STTPUT(MSG,ISTAT)
 9052 FORMAT(' (X,Y) measurements in data file were measured by BLINK')



C---------------------------------------------------------------------
C---  open the input files
C---------------------------------------------------------------------

C---  *standards file
      CALL STKRDC('IN_STD',1,1,20,N1,PSFILE,IDUM1,IDUM2,ISTAT)

C     * opening the table      
      CALL TBTOPN(PSFILE,F_IO_MODE,TIDS,ISTAT)

C     * check the numbers of rows and columns of the table
      CALL TBIGET(TIDS,NCOLS,NROWS,NSC,ACOL,AROW,ISTAT)      

C     * check if the columns exists
C     * PPM identifier
      CALL TBCSER(TIDS,':PPM',NCSPPM,ISTAT)
      IF (NCSPPM.LE.0) THEN
         CALL STTPUT('*error* Input column PPM not found',ISTAT)
         STOP
         ENDIF

C     * magnitude
      CALL TBCSER(TIDS,':MAG',NCSMAG,ISTAT)
      IF (NCSMAG.LE.0) THEN
         CALL STTPUT('*error* Input column MAG not found',ISTAT)
         STOP
         ENDIF

C     * right asc.
      CALL TBCSER(TIDS,':R_A',NCSR_A,ISTAT)
      IF (NCSR_A.LE.0) THEN
         CALL STTPUT('*error* Input column R_A not found',ISTAT)
         STOP
         ENDIF

C     * declination
      CALL TBCSER(TIDS,':DEC',NCSDEC,ISTAT)
      IF (NCSDEC.LE.0) THEN
         CALL STTPUT('*error* Input column DEC not found',ISTAT)
         STOP
      ENDIF

C     * Proper motion in right asc.
      CALL TBCSER(TIDS,':PMA',NCSPMA,ISTAT)
      IF (NCSPMA.LE.0) THEN
         CALL STTPUT('*error* Input column PMA not found',ISTAT)
         STOP
      ENDIF

C     * proper motion in decl.
      CALL TBCSER(TIDS,':PMD',NCSPMD,ISTAT)
      IF (NCSPMD.LE.0) THEN
         CALL STTPUT('*error* Input column PMD not found',ISTAT)
         STOP
      ENDIF

C     * status
      CALL TBCSER(TIDS,':STD',NCSSTD,ISTAT)
      IF (NCSSTD.LE.0) THEN
C        * if the column does not exist, it's created.
      CALL STTPUT('*info* Input column :STD not found; created',ISTAT)
      CALL TBCINI( TIDS, D_I4_FORMAT, 1, 'I1', 'Flg', 
     >        'STD', NCSSTD, ISTAT )
      ENDIF

C     * error in x 
      CALL TBCSER(TIDS,':XERR',NCSXER,ISTAT)
      IF (NCSXER.LE.0) THEN
C        * if the column does not exist, it's created.
      CALL STTPUT('*info* Input column XERR not found; created',ISTAT)
      CALL TBCINI( TIDS, D_R8_FORMAT, 1, 'F8.4' , 
     >        'ArcSec', 'XERR', NCSXER ,ISTAT)
      ENDIF

C     * error in y
      CALL TBCSER(TIDS,':YERR',NCSYER,ISTAT)
      IF (NCSYER.LE.0) THEN
C        * if the column does not exist, it's created.
      CALL STTPUT('*info* Input column YERR not found; created',ISTAT)
      CALL TBCINI( TIDS, D_R8_FORMAT, 1, 'F8.4' , 
     >        'ArcSec', 'YERR', NCSYER ,ISTAT)
      ENDIF


C---  *measurements file
      CALL STKRDC('IN_MES',1,1,20,N1,DFILE,IDUM1,IDUM2,ISTAT)

C     * opening the table      
      CALL TBTOPN(DFILE,F_I_MODE,TIDD,ISTAT)
C     * check the numbers of rows and columns of the table
      CALL TBIGET(TIDD,NCOLD,NROWD,NSC,ACOL,AROW,ISTAT)      

C     * check if the columns exists
C     * PPM identifier
      CALL TBCSER(TIDD,':IDENT',NCDIDENT,ISTAT)
      IF (NCDIDENT.LE.0) THEN
         CALL STTPUT('*error* Input column IDENT not found',ISTAT)
         STOP
         ENDIF

C     * x position
      CALL TBCSER(TIDD,':XCEN',NCDX,ISTAT)
      IF (NCDX.LE.0) THEN
         CALL STTPUT('*error* Input column XCEN not found',ISTAT)
         STOP
         ENDIF

C     * y position
      CALL TBCSER(TIDD,':YCEN',NCDY,ISTAT)
      IF (NCDY.LE.0) THEN
         CALL STTPUT('*error* Input column YCEN not found',ISTAT)
         STOP
         ENDIF


   55 DO I = 1,3
         RESA(I) = 0.0
         RESB(I) = 0.0
         ENDDO

      ITOT = 0
      IRES = 0
      IRESNO = 0


C--   Write to the log file:


      WRITE(MSG,9056) PSFILE
      CALL STTPUT(MSG,ISTAT)
 9056 FORMAT(' Standard stars from table :  ',A16)
      WRITE(MSG,9156) DFILE
      CALL STTPUT(MSG,ISTAT)
 9156 FORMAT(' XY measurements from table : ',A16)
      CALL STTPUT(' ',ISTAT)


C---------------------------------------------------------------------
C---  Reads the measurements (X,Y)
C---------------------------------------------------------------------
      WRITE(MSG,9157)
 9157 FORMAT('   --- (X,Y) MEASUREMENTS ---')
      CALL STTPUT(MSG,ISTAT)
  

      IF (BLINK) WRITE(MSG,9057)
      CALL STTPUT(MSG,ISTAT)
 9057 FORMAT(' The following (X,Y)s are expressed in microns') 

      WRITE(MSG,9058) SIG
      CALL STTPUT(MSG,ISTAT)
 9058 FORMAT(' Mean measured (X,Y) after cleaning  R.M.S. > ',F5.2)
      CALL STTPUT(' ',ISTAT)

      WRITE(MSG,9158)
      CALL STTPUT(MSG,ISTAT)
 9158 FORMAT('      ID.',7X,'X',11X,'Y',7X,'N  SigmaX  SigmaY  ',
     >'SigmaR  Deleted')
      WRITE(MSG,9258)
 9258 FORMAT('  <----> <---------> <--------->  <->',
     $     '  <-----> <---->  <---->  <->')
      CALL STTPUT(MSG,ISTAT)


C loop from ILOOP = 1 to ILOOP = number of measurement rows
      DO 62 ILOOP = 1, NROWD
C        *identifier
         CALL TBERDC(TIDD,ILOOP,NCDIDENT,CTEST,NULL,ISTAT)
         CALL FT_EOS(CTEST,16,ACUR,ISTAT)

C        *(x/ycen are r*4 read as r*8)
         CALL TBERDD(TIDD,ILOOP,NCDX,XCUR,NULL,ISTAT)
         CALL TBERDD(TIDD,ILOOP,NCDY,YCUR,NULL,ISTAT)

         IF (BLINK) THEN
C        *blink funny format: conversion to (+,-) microns
            XBLINK = XCUR
            YBLINK = YCUR
            CALL BLINKXY(XBLINK,YBLINK,XCUR,YCUR,1)
 9999       Format(80a)
         ENDIF

C---  Compute mean (x,y) for each object and R.M.S. in X,Y,R

         IF (ILOOP .LE. 1) THEN
C     *first (X,Y)
            AFOR = ACUR
            XTEMP(1) = XCUR
            YTEMP(1) = YCUR
            IX = 1
            GO TO 62
         ENDIF

         IF (ACUR .EQ. AFOR) THEN
C     *still same object
            IX = IX + 1
            XTEMP(IX) = XCUR
            YTEMP(IX) = YCUR
         ENDIF

         IF (ACUR .NE. AFOR .OR. ILOOP .EQ. NROWD) THEN
C     *New object or last measurement
c-    *--> do means for the one before
            CALL MEAN(XTEMP,YTEMP,IX,XMEAN,YMEAN,NOUT,RESA,SIG)
            IF (IX.GT.2) THEN
               DO I = 1,3
                  RESB(I) = RESB(I) + RESA(I)
               ENDDO
               IRES = IRES + IX
               IRESNO = IRESNO + 1
            ENDIF
       
            XTEMP(1) = XCUR
            YTEMP(1) = YCUR
            
            ITOT = ITOT + 1

C     *Maximum # of objects is MAXOBJ
            IF (ITOT.GT.MAXOBJ) THEN
               WRITE(MSG,9074)
               CALL STTPUT(MSG,ISTAT)
 9074          FORMAT('*error* too many objects ! ')
               CALL STSEPI
               STOP
            ENDIF
         
            PRXY(ITOT,1) = XMEAN/1.0D3
            PRXY(ITOT,2) = YMEAN/1.0D3
            
C     *conversion Text ident --> Nr ident
            IID = 0
 628        IF (IID .LT. 16) THEN
               IID = IID+1
            ELSE
               WRITE(MSG,*) '*warning* identiers must contain numbers'
               CALL STTPUT(MSG,ISTAT)
               WRITE(MSG,*) '          identifier set to 0'
               CALL STTPUT(MSG,ISTAT)
               NFOR = 0
               GOTO 629
            ENDIF
            READ(AFOR(IID:16),*,err=628) NFOR
            WRITE(MSG,9076) NFOR,XMEAN,YMEAN,IX+NOUT,RESA,NOUT
            CALL STTPUT(MSG,ISTAT)
 9076       FORMAT(I8,2F12.3,I5,3F8.3,I5)
         
 629        MNOST(ITOT) = NFOR
            AFOR = ACUR
            IX = 1
            

         ENDIF

C     *go to read next line
 62   CONTINUE

C     *file is finished
 63   NOBJ = ITOT
      WRITE(MSG,9080) NOBJ
      CALL STTPUT(MSG,ISTAT)
 9080 FORMAT('  No. of objects in (X,Y)-table: ',I5)


C     CALCULATE MEAN R.M.S. FOR MEASURED (X,Y) IN MICRONS

      IF (IRES.GT.0) THEN
         DO I = 1,3
            RESB(I) = RESB(I)/FLOAT(IRESNO)
         ENDDO
         WRITE(MSG,9082) RESB
         CALL STTPUT(MSG,ISTAT)
 9082    FORMAT('  Mean R.M.S. (microns or pix) in (X,Y,R) :',3f8.2)
         WRITE(MSG,9182) IRES,IRESNO
         CALL STTPUT(MSG,ISTAT)
 9182    FORMAT('  based on ',i3,' (X,Y) measurements of ',i3,
     >        ' objects ')
      ELSE
         WRITE(MSG,9083)
         CALL STTPUT(MSG,ISTAT)
 9083    FORMAT('*info*  Not enough measurements of same object to ',
     >        ' calculate mean r.m.s. values ')
      ENDIF


C----------------------------------------------------------------------
C     * STANDARD STARS
C----------------------------------------------------------------------
      CALL STTPUT(' ',ISTAT)
      CALL STTPUT(' ',ISTAT)
      WRITE(MSG,9183)
 9183 FORMAT('   --- STANDARD STARS ---')
      CALL STTPUT(MSG,ISTAT)
  
      NOSAO = 0
      IF (.NOT. CENTER) THEN
         ALFA0 = 0.
         DELTA0 = 0.
      ENDIF
      DEP = EPOCH - EP1 


C this loop from ILOOP = 1 to ILOOP = number of standards file
      DO 111 ILOOP = 1, NROWS
C     * Read the table:
C       *is the current star selected (= measured and non deleted)
         IF ( SELECT ) THEN
            CALL TBSGET(TIDS, ILOOP, ROWSEL, ISTAT)
            IF (.NOT. ROWSEL) GOTO 111
            ENDIF
               
C       * Identifier (ppm #) and magnitude
         CALL TBERDI(TIDS,ILOOP,NCSPPM,NOS,NULL,ISTAT)
         CALL TBERDD(TIDS,ILOOP,NCSMAG,STM,NULL,ISTAT)

C       * R_A and Dec are BOTH read in degree
         CALL TBERDD(TIDS,ILOOP,NCSR_A,R_A,NULL,ISTAT)
         CALL TBERDD(TIDS,ILOOP,NCSDEC,DEC,NULL,ISTAT)

C       * pma and pmd are read in arcsec/year
         CALL TBERDD(TIDS,ILOOP,NCSPMA,PMA,NULL,ISTAT)
         CALL TBERDD(TIDS,ILOOP,NCSPMD,PMD,NULL,ISTAT)


 9115    FORMAT(I6,F6.2,2I3,F7.3,A2,I2,I3,F6.2,2I6)

C       *cross check the measurements and the standards
         DO 120 I = 1,NOBJ
C            write(6,*) ILOOP,NOS,I,MNOST(i)
            IF (NOS.EQ.MNOST(I)) then
C             * the current object is a std!
C             * converts the coordinates
 125           PRSTMAG(I) = STM
               PRST(I,1) = R_A*DOPI18
 135           PRST(I,2) = DEC*DOPI18

C             * and propoer motion
C             * PM_RA(radians) = pma(arcsec)/3600/cos(delta) * pi/180
               PMAL = PMA*DOPI18 / DO3600/DCOS(PRST(I,2))
C             * PM_Dec(radians) = pmd(arcsec)
               PMDEL = PMD*DOPI18/DO3600 

C             * coordinates a the epoch of the measurements
               PRST(I,1) = PRST(I,1)+PMAL*DEP
               PRST(I,2) = PRST(I,2)+PMDEL*DEP 

C     ( Original pos1 was using plate center read from the standard stars 
C       file header as reference for the alpha < or > 360 deg dilemma.
C       This version uses the 1st standard found )
               IF (NOSAO.EQ.0) THEN
C                * First std: we keep it as ref.
                  ALFA00 = PRST(I,1)
               ELSE
C                * adjust the alpha if no in the same region as the ref.
                  IF(ALFA00.LT.PI/2D0.AND.PRST(I,1).GT.1.5D0*PI) 
     >                 PRST(I,1) = PRST(I,1) - 2.0D0*PI
                  IF(ALFA00.GT.1.5D0*PI.AND.PRST(I,1).LT.PI/2D0) 
     >                 PRST(I,1) = PRST(I,1) + 2.D0*PI
               ENDIF


               IF (IFOUND(I).EQ.0)THEN
C                * this standard was not found before:
C                * so we have one more
                  NOSAO = NOSAO + 1
                  IFOUND(I) = 1
                  IF(.NOT. CENTER)THEN
                     ALFA0 = ALFA0 + PRST(I,1)
                     DELTA0 = DELTA0 + PRST(I,2)
                  ENDIF
C                * write in the table that the std was found
                  CALL TBEWRI(TIDS,ILOOP,NCSSTD,1,ISTAT)
C                * store the row for further use
                  ISTDR(I) = ILOOP
               ENDIF

C             * found, so it is not necessary to continue to search
               GO TO 111
            ENDIF

 120     CONTINUE
 111  CONTINUE


      IF (NOSAO .EQ. 0) THEN
         CALL STTPUT('*ERROR* No standard star??',ISTAT)
         STOP
      ENDIF

C     *compute the plate/field center:
      IF (.NOT. CENTER) THEN
C        * Center is mean of the standards
         ALFA0 = ALFA0/DFLOAT(NOSAO)
         DELTA0 = DELTA0/DFLOAT(NOSAO)
      ENDIF
C     * ELSE: the coordinates have been read from the parameters.

      COSD0 = DCOS(DELTA0) 
      SIND0 = DSIN(DELTA0) 

      CALL ADCON(ALFA0,DELTA0,A0,D0)

      IF (CENTER) THEN
         WRITE(MSG,9091)
 9091    FORMAT('  Plate/field center (read from the parameters):')
      ELSE
         WRITE(MSG,9591)
 9591    FORMAT('  Plate/field center (MEAN of the standards coord.):')
      ENDIF
      CALL STTPUT(MSG,ISTAT)

      WRITE(MSG,9191) A0
      CALL STTPUT(MSG,ISTAT)
      DSIG='+'
      IF(DELTA0.LT.0.) DSIG='-'
      WRITE(MSG,9291) DSIG,D0
      CALL STTPUT(MSG,ISTAT)
      WRITE(MSG,9391) EPOCH
      CALL STTPUT(MSG,ISTAT)
      WRITE(MSG,9491) EP1
      CALL STTPUT(MSG,ISTAT)

 9191 FORMAT('         Alpha: ',F5.0,1X,F3.0,1X,F6.3)
 9291 FORMAT('         Delta: ',1A,F4.0,1X,F3.0,1X,F5.2)
 9391 FORMAT('  Plate epoch: ',F8.3)
 9491 FORMAT('  Standard stars  catalogue epoch: ',F8.3)

C     *decode the xy transformation terms selection flags
 150  NX = 0
      NY = 0
      DO I = 1,9
         READ(STRING_TERM(I:I),*)IDX(I)
         READ(STRING_TERM(I+10:I+10),*)IDY(I)
         IF (IDX(I).NE.0) NX=NX+1
         IF (IDY(I).NE.0) NY=NY+1
      ENDDO
  165 FORMAT(1X,'  CHECK ',9I2,1X,9I2) 
 


C---  Check if any stars deleted and delete it if yes

  180 L = 0
      ERXY(1) = DO0
      ERXY(2) = DO0
      ERXY(3) = DO0

      DO 200 I = 1,NOBJ
         LOG = (IFOUND(I) .EQ. 1)
         IF (NKICK.NE.0) THEN
            DO 185 J = 1,NKICK
               IF (MNOST(I).EQ.KICK(J)) LOG = .FALSE.
  185          CONTINUE
            ENDIF 

  190    IF ( LOG ) THEN
C          * this star is an undeleted standard
            L = L+ 1
            NOST(L) = MNOST(I)
            XY(L,1) = PRXY(I,1)
            XY(L,2) = PRXY(I,2)
            ST(L,1) = PRST(I,1)
            ST(L,2) = PRST(I,2)
            STMAG(L) = PRSTMAG(I)
            ISTDR2(L) = ISTDR(I)
 9195           FORMAT(2I7,6F15.10/)
            ENDIF
  200    CONTINUE

  205 NSTAN = NOSAO - NKICK
Coli      WRITE(MSG,9210) NOSAO,NKICK,NSTAN
Coli      CALL STTPUT(MSG,ISTAT)
 9210 FORMAT('  Standard stars: ',I3,'. Manually removed: ',
     $     I2,'. Now left: ',I3)

      IF (NSTAN.NE.L) THEN
         WRITE(MSG,9215) NSTAN,L
         CALL STTPUT(MSG,ISTAT)
      ENDIF
 9215 FORMAT('*ERROR* Wrong No. of standard stars !',2I6)

      IF (ITRY.GT.0) GO TO 325


C
C OUTPUT STANDARD STAR FILE HEADER
C

      
      CALL STTPUT(' ',ISTAT)
      CALL STTPUT(' ',ISTAT)
      WRITE(MSG,9315) 
      CALL STTPUT(MSG,ISTAT)
 9315 FORMAT('   --- ASTROMETRIC RESOLUTION ---')
c$$$      WRITE(MSG,9090) NOFI
c$$$      CALL STTPUT(MSG,ISTAT)
c$$$ 9090 FORMAT('  FIELD NO.: ',I5)
c$$$      WRITE(MSG,9190) IA3,A0(3)
c$$$      CALL STTPUT(MSG,ISTAT)
c$$$ 9190 FORMAT('  ALPHA: ',2I3,F7.3)
c$$$      WRITE(MSG,9290) ID3,D0(3)
c$$$      CALL STTPUT(MSG,ISTAT)
c$$$ 9290 FORMAT('  DELTA: ',2I3,F7.2)
c$$$      WRITE(MSG,9390) EPOCH
c$$$      CALL STTPUT(MSG,ISTAT)
c$$$ 9390 FORMAT('  PLATE EPOCH: ',F8.3)
c$$$      WRITE(MSG,9490) EP1
c$$$      CALL STTPUT(MSG,ISTAT)
c$$$ 9490 FORMAT('  STANDARD STARS  CATALOGUE EPOCH: ',F8.3)

  325 M = NSTAN 
      DO 330 I = 1,NSTAN
         COSRH = COSD0*DCOS(ST(I,2))*DCOS(ST(I,1)-ALFA0)+
     1           SIND0*DSIN(ST(I,2)) 
         SINRH = DSQRT(1.d0-COSRH**2) 
         SINPH = DCOS(ST(I,2))*DSIN(ST(I,1)-ALFA0)/SINRH 
         COSPH = (DSIN(ST(I,2))-SIND0*COSRH)/(COSD0*SINRH)

C       ( If plate curved (Schmidt) use distance along arc, otherwise use
C         linear distance in tangential plane )
         IF (SCHMIDT) THEN 
            RH = DATAN(SINRH/COSRH)
         ELSE
            RH = SINRH/COSRH
         ENDIF 

         AKSI = RH*SINPH/DOPI18
         ANU  = RH*COSPH/DOPI18
         XR = XY(I,1)
         YR = XY(I,2)
         AR(I,1) = XR
         AR(I,2) = YR
         AR(I,3) = AKSI
         AR(I,4) = ANU 
C         write(6,*) i,(AR(I,io),io=1,4)
  330    CONTINUE 

      DO 650 IXY = 1,2
         IF (IXY.EQ.2) then
            N = NY + 1
            WRITE(MSG,9350)
            CALL STTPUT(' ',ISTAT)
            CALL STTPUT(MSG,ISTAT)
 9350       FORMAT(' *- Y-Transformation')
         else  
            N = NX + 1
            WRITE(MSG,9340) 
            CALL STTPUT(' ',ISTAT)
            CALL STTPUT(MSG,ISTAT)
 9340       FORMAT(' *- X-Transformation') 
         endif



C
C COMPUTE THE MATRICES
C 
  355   L=N-1 
        SW=DBLE(FLOAT(M)) 
        IZERO=32
        IDSK=1

        DO 360 I1=1,N 
           SIGMA(I1)=DO0
           DO 360 I1B=I1,N 
  360         SSX(I1,I1B)=DO0 

        DO 410 I3=1,M 
           CALL RAR(I3,0,N,KK,IXY,IDX,IDY,X,AR)
           DO 380 I10=1,N
              SIGMA(I10)=SIGMA(I10)+X(I10)
              DO 380 I10B=I10,N 
  380            SSX(I10,I10B)=SSX(I10,I10B)+X(I10)*X(I10B)
  410      CONTINUE

        WRITE(MSG,9420) M,N
        CALL STTPUT(MSG,ISTAT)
 9420   FORMAT('   No of data = ',I3,'   No of variables = ',I2) 
  430   RSW=DO1/SW

        DO 440 I4=1,N 
  440      XBAR(I4)=SIGMA(I4)*RSW 

        DO 450 I5=1,N 
        DO 450 I5B=I5,N 
  450      S(I5,I5B)=SSX(I5,I5B)-SW*XBAR(I5)*XBAR(I5B) 

  460   DO 470 I6=1,N 
           SIY(I6)=S(I6,N) 
           AH = S(I6,I6) 
  470      SIGMA(I6)=DSQRT(AH) 

        DO 480 I11=1,L
        DO 480 I11B=I11,L 
           SSINV(I11,I11B)=S(I11,I11B) 
  480      SSINV(I11B,I11)=SSINV(I11,I11B) 

        CALL QKDIN(SSINV,L) 

        DO 490 I12=1,L
  490      SP(I12)=SSINV(I12,I12)

  500   DO 510 I19=1,L
           B(I19)=DO0
           DO 510 I19B=1,L 
  510         B(I19)=B(I19)+SIY(I19B)*SSINV(I19,I19B) 

        CALL QKDIN(SSINV,L) 

  520   DO 530 I7=1,L 
           K=I7+1
           DO 530 I7B=K,N
  530        R(I7,I7B)=S(I7,I7B)/(SIGMA(I7)*SIGMA(I7B))

        K=N-2 
  540   DO 550 I13=1,L
           R(I13,I13)=DO1
           DO 550 I13B=I13,L 
              SSINV(I13,I13B)=R(I13,I13B) 
  550         SSINV(I13B,I13)=SSINV(I13,I13B) 

        CALL QKDIN(SSINV,L) 

  560   SSR=DO0 
        SUM=DO0 

        DO 570 I14=1,L
           SUM=SUM+B(I14)*XBAR(I14)
  570      SSR=SSR+B(I14)*SIY(I14) 

        CONST  =XBAR(N)-SUM 
        SSDR=SIY(N)  -SSR 
        RSQD=SSR/SIY(N) 
        ITDF=M-1
        KDF=N-1 
        MK1DF=M-KDF-1 
        CHG=DBLE(FLOAT(KDF))
        XMSDR=SSR/CHG 
        CHG=DBLE(FLOAT(MK1DF))
        XMSDD=SSDR/CHG
        ROFF=XMSDR/XMSDD
        VE=XMSDD
        IF (VE.LE.0.0) VE = 0.0
        SDE=DSQRT(VE) 

        DO 580 I15=1,L
  580      VBI(I15)=VE*SP(I15) 
        WRITE(MSG,9590) CONST
        CALL STTPUT(MSG,ISTAT)
 9590   FORMAT('     Constant term = ',E15.8) 

        WRITE(MSG,9600) 
        CALL STTPUT(MSG,ISTAT)
 9600   FORMAT('     Variable      Coefficient'
     $       ,'    Variation of coefficient') 

        DO 595 J1 = 1,L 
           I = KK(J1)
           WRITE(MSG,9601) (KTEXT(K,I),K=1,3), B(J1), VBI(J1)
           CALL STTPUT(MSG,ISTAT)
 595       CONTINUE
 9601      FORMAT('     Fct(',3A2,')',2X,E13.6,4x,E13.6)

        WRITE (MSG,9610) RSQD 
        CALL STTPUT(MSG,ISTAT)
 9610   FORMAT('   R square =',E18.5) 

        IF (IXY.EQ.1) THEN
           SCALE = B(1)*3.6D3 
        ELSE
           SCALE = B(2)*3.6D3
        ENDIF

        SCALE = DABS(SCALE)
        WRITE(MSG,9615) SCALE
        CALL STTPUT(MSG,ISTAT)
 9615   FORMAT('   Approx. plate scale: ', F10.3,
     $       ' arcsec per 1000 Pixel or Micron ')

        IDSK=1

        DO 630 I16=1,M
           V=DO0 
           CALL RAR(I16,0,N,KK,IXY,IDX,IDY,X,AR)
           DO 620 I17=1,L
  620         V=V+B(I17)*X(I17) 
           YHAT=CONST+V
           XY(I16,IXY) = YHAT
           DEV=X(N)-YHAT 
  630      CONTINUE

        IF (IXY.EQ.1) CX = CONST
        IF (IXY.EQ.2) CY = CONST
        DO 640 J=1,9
           IF (IXY.EQ.1) BX(J) = B(J)
           IF (IXY.EQ.2) BY(J) = B(J)
  640      CONTINUE
  650   CONTINUE

c      WRITE(MSG,9660)NOFI,EPOCH
c      CALL STTPUT(MSG,ISTAT)
 9660 FORMAT('***pipo*** FIELD NO.',I5,'  EPOCH',F10.3, 
     >     '  Epoch of std stars cat')
c      WRITE(MSG,9760)A0,D0
c      CALL STTPUT(MSG,ISTAT)
 9760 FORMAT('***pipo*** FIELD CENTER ',3F4.0,1X,3F4.0)
c      WRITE(MSG,9860)NSTAN 
c      CALL STTPUT(MSG,ISTAT)
 9860 FORMAT('***pipo*** NO OF STANDARD STARS MEASURED',I5)


      CALL STTPUT(' ',ISTAT)
      CALL STTPUT(' ',ISTAT)
      WRITE(MSG,9960)
      CALL STTPUT(MSG,ISTAT)
 9960 FORMAT('Row    No   Mag        Measured'
     $     '               Catalogue         Deviation' )
      WRITE(MSG,9963)
      CALL STTPUT(MSG,ISTAT)
 9963 FORMAT('<-> <----> <--> <---RA---> <---Dec---> '
     $     ,'<---RA---> <---Dec--->  -X-arcsec-Y-')

cc      WRITE(MSG,9661)
cc      CALL STTPUT(MSG,ISTAT)
cc 9661 FORMAT(2('  Row No     Mag ',4X,'(X)RMS(Y)   '))
cc      WRITE(MSG,9761)
cc      CALL STTPUT(MSG,ISTAT)
cc 9761 FORMAT(2(23X,'Arcsec   '))
      SUMD1 = DO0 
      SUMD2 = DO0 

      DO 700 I = 1,NSTAN
         AKSI = XY(I,1)
         ANU = XY(I,2) 
         CALL XYAD(AKSI,ANU,IA1,ID1,DA1S,DD1S,ITEGN1,ALFAS,DELTS,
     *             COSD0,SIND0,ALFA0)
         CALL ADCON(ST(I,1),ST(I,2),ALFA,DELTA)

         DO 680 J=1,2
            IA2(J) = IDINT(ALFA(J)+1.0D-3)
  680       ID2(J) = IDINT(DELTA(J)+DSIGN(1.0D-3,DELTA(J))) 

         ID2(1) = IABS(ID2(1)) 
         ITEGN2 = ' +' 
         IF (ST(I,2).LT.DO0) ITEGN2 = ' -' 
         SUMD3 = (ALFAS - ST(I,1))*DCOS(ST(I,2))*DO3600/DOPI18 
         SUMD4 = (DELTS-ST(I,2))*DO3600/DOPI18 
         SUMD5 = DSQRT(SUMD3**2+SUMD4**2)
         SUMD1 = SUMD1 + SUMD3**2
         SUMD2 = SUMD2 + SUMD4**2

C        *write the errors in the standard table:
         CALL TBEWRD(TIDS,ISTDR2(I),NCSXER,SUMD3,ISTAT)
         CALL TBEWRD(TIDS,ISTDR2(I),NCSYER,SUMD4,ISTAT)

         IF (SUMD5.GT.ERXY(3)) THEN
            IERROW = ISTDR2(I)
            IERXY = NOST(I)
            ERXY(1) = SUMD3 
            ERXY(2) = SUMD4 
            ERXY(3) = SUMD5
            endif

  685    CONTINUE
         WRITE(MSG,9690)ISTDR2(I),NOST(I),STMAG(I),
     $       IA1(1),IA1(2),DA1S,ITEGN1,
     >       ID1(1),ID1(2),DD1S,IA2(1),IA2(2),ALFA(3),ITEGN2,ID2(1),
     >       ID2(2),DELTA(3),SUMD3,SUMD4 
 9690    FORMAT(I3,I7,F5.1,2(I3,I2,F6.3,A2,I2,I2,F6.2),2F7.3) 
         CALL STTPUT(MSG,ISTAT)

c$$$         WRITE(MSG,9691) ISTDR2(I),NOST(I),STMAG(I),SUMD3,SUMD4
c$$$         CALL STTPUT(MSG,ISTAT)
c$$$ 9691    FORMAT(I5,I7,F4.1,2X,2F7.3,' ',$)
c$$$C 9691    FORMAT(I6,F4.1,2X,2F7.3,' ',$)
c$$$         IF (MOD(I,2).EQ.0) WRITE(MSG,9692) 
c$$$         CALL STTPUT(MSG,ISTAT)
c$$$ 9692    FORMAT($)
  700    CONTINUE

      RH = DBLE(FLOAT(NSTAN-1)) 
      SUMD1 = DSQRT(SUMD1/RH) 
      SUMD2 = DSQRT(SUMD2/RH) 

c$$$      WRITE(MSG,9692)
c$$$      CALL STTPUT(MSG,ISTAT)

      WRITE(MSG,9710)SUMD1
      CALL STTPUT(MSG,ISTAT)
      WRITE(MSG,9711)SUMD2
      CALL STTPUT(MSG,ISTAT)
 9710 FORMAT('  RMS in X-direction (arcsec):',F7.3)
 9711 FORMAT('  RMS in Y-direction (arcsec):',F7.3)


  740 IF (DABS(ERXY(1)).ge.DO1 .or. DABS(ERXY(2)).ge.DO1) THEN
          WRITE(MSG,742) IERXY,IERROW,ERXY(1),ERXY(2) 
          CALL STTPUT(MSG,ISTAT)
      ENDIF

  742 FORMAT(' *TIP* star No. ',i8,' (row ',i5,') has large RMS: '
     >    ,2f10.2) 


C---  write the transformation matrix in output keyword
      CALL STKWRD('BX',BX,1,9,IDUM,ISTAT)
      CALL STKWRD('BY',BY,1,9,IDUM,ISTAT)
      CALL STKWRD('CX',CX,1,1,IDUM,ISTAT)
      CALL STKWRD('CY',CY,1,1,IDUM,ISTAT)
      CALL STKWRD('AL_DE0',ALFA0,1,1,IDUM,ISTAT)
      CALL STKWRD('AL_DE0',DELTA0,2,1,IDUM,ISTAT)
      CALL STKWRD('AL_DE0',COSD0,3,1,IDUM,ISTAT)
      CALL STKWRD('AL_DE0',SIND0,4,1,IDUM,ISTAT)
      CALL STKWRI('NX',NX,1,1,IDUM,ISTAT)
      CALL STKWRI('NY',NY,1,1,IDUM,ISTAT)

      CALL STSEPI

 9045 FORMAT(A50)
 9050 FORMAT(2X,A50)
      END

C @(#)iodev.for	19.1 (ES0-DMD) 02/25/03 14:32:27
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT  (c)   1988   European Southern Observatory
C.IDENT      iodev.for
C.LANGUAGE   VAX/VMS FORTRAN-77
C.AUTHOR     P.Grosbol      ESO/IPG
C.KEYWORDS   VMS QIO, tape I/O
C.ENVIRON    VAX/VMS
C.COMMENT    Ref. to VAX/VMS I/O User's Guide Vol.1, Chap.7 for
C            status codes etc.
C.VERSION    1.0    1989-Mar-11 : Creation,  PJG
C--------------------------------------------------------------------
      INTEGER FUNCTION  IOOPEN(DEVICE,MODE,DEN)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.PURPOSE    Assign I/O channel to device
C.RETURN     I/O channel of OK else -1 if assign error
C--------------------------------------------------------------------
      INCLUDE    '($SYSSRVNAM)/NOLIST'
      INCLUDE    '($MNTDEF)/NOLIST'
      INCLUDE    '($IODEF)/NOLIST'
      INCLUDE    '($SSDEF)/NOLIST'
C
      CHARACTER*(*)   DEVICE
      CHARACTER*32    DEV
      INTEGER         MODE
      INTEGER         DEN
C
      INTEGER         STATUS
      INTEGER         TDEN,FLAG,SIZ
      INTEGER*2       QIO_CHAN
      INTEGER*2       W_L1,W_L2,W_L3,W_L4,W_L5,W_L6,W_L7
      INTEGER*2       W_F1,W_F2,W_F3,W_F4,W_F5,W_F6,W_F7
      INTEGER         L_A1,L_A2,L_A3,L_A4,L_A5,L_A6,L_A7
      INTEGER         L_T1,L_T2,L_T3,L_T4,L_T5,L_T6,L_T7
      COMMON /MNTL/
     1             W_L1,W_F1,L_A1,L_T1,
     2             W_L2,W_F2,L_A2,L_T2,
     3             W_L3,W_F3,L_A3,L_T3,
     4             W_L4,W_F4,L_A4,L_T4,
     5             W_L5,W_F5,L_A5,L_T5,
     6             W_L6,W_F6,L_A6,L_T6,
     7             W_L7,W_F7,L_A7,L_T7
      COMMON /DEVNAM/DEV
C
C     CHECK IF DEVICE NAME HAS A ':' ELSE INSERT ONE
C
      N = INDEX(DEVICE,' ')
      IF (DEVICE(N-1:N-1).NE.':') DEVICE(N:N) = ':'
      DEV = DEVICE(1:N)
C
C     SETUP PARAMETERS FOR MOUNT
C
      SIZ = 32000
      TDEN = DEN
      FLAG = IOR(MNT$M_FOREIGN,MNT$M_NOLABEL)
      W_L1 = N
      W_F1 = MNT$_DEVNAM
      L_A1 = %LOC(DEVICE)
      L_T1 = 0
      W_L2 = 4
      W_F2 = MNT$_FLAGS
      L_A2 = %LOC(FLAG)
      L_T2 = 0
      W_L3 = 4
      W_F3 = MNT$_DENSITY
      L_A3 = %LOC(TDEN)
      L_T3 = 0
      W_L4 = 4
      W_F4 = MNT$_BLOCKSIZE
      L_A4 = %LOC(SIZ)
      L_T4 = 0
      W_L5 = 4
      W_F5 = MNT$_RECORDSIZ
      L_A5 = %LOC(SIZ)
      L_T5 = 0
      W_L6 = 0
      W_F6 = 0
      L_A6 = 0
      L_T6 = 0
      W_L7 = 0
      W_F7 = 0
      L_A7 = 0
      L_T7 = 0
C
C     MOUNT DEVICE
C
      STATUS = SYS$MOUNT(W_L1)
      STATUS = IAND(STATUS,'FFFF'X)
      IF (STATUS.NE.SS$_NORMAL.AND.STATUS.NE.SS$_DEVMOUNT) THEN
         IOOPEN = -1
         RETURN
      ENDIF
      IF (STATUS.EQ.SS$_DEVMOUNT) THEN
         WRITE(6,600)
  600    FORMAT(' Warning: Device already mounted')
      ENDIF
C
C     ASSIGN TAPE TO CHANNEL
C
      STATUS = SYS$ASSIGN(DEVICE(1:N),QIO_CHAN,,)
      IF (STATUS.EQ.SS$_NORMAL) THEN
         IOOPEN = QIO_CHAN
      ELSE
         IOOPEN = -1
      ENDIF
      RETURN
      END
C-------------------------------------------------------------------
      INTEGER FUNCTION  IOCLOSE(FD)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.PURPOSE    Deassign or close I/O channel to device
C.RETURN     0: OK ,else  -1: error
C--------------------------------------------------------------------
      INCLUDE    '($SYSSRVNAM)/NOLIST'
      INCLUDE    '($DMTDEF)/NOLIST'
      INCLUDE    '($IODEF)/NOLIST'
      INCLUDE    '($SSDEF)/NOLIST'
C
      CHARACTER*32  DEV
      INTEGER       FD
C
      INTEGER       STATUS
      INTEGER*2     QIO_CHAN,IOSB(4)
C
      COMMON /DEVNAM/DEV
C
      QIO_CHAN = FD
      STATUS = SYS$QIOW(,%VAL(QIO_CHAN),%VAL(IO$_REWIND),
     ,                  IOSB,,,,,,,,)
      STATUS = SYS$DASSGN(%VAL(QIO_CHAN))
      IF (STATUS.NE.SS$_NORMAL) THEN
         IOCLOSE = -1
         RETURN
      ENDIF
      STATUS = SYS$DISMOU(DEV,%VAL(DMT$M_NOUNLOAD))
      IOCLOSE = 0
      RETURN
      END
C-------------------------------------------------------------------
      INTEGER FUNCTION  IOREAD(FD,BUF,NO)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.PURPOSE    Read data from a VMS I/O-channel
C.RETURN     no. of bytes read if OK 
C            else 0: EOF, -2: QIO error
C--------------------------------------------------------------------
      INCLUDE    '($SYSSRVNAM)/NOLIST'
      INCLUDE    '($IODEF)/NOLIST'
      INCLUDE    '($SSDEF)/NOLIST'
C
      INTEGER     FD
      LOGICAL*1   BUF
      INTEGER     NO
C
      INTEGER     STATUS
      INTEGER*2   QIO_CHAN,IOSB(4)
C
      QIO_CHAN = FD
      STATUS = SYS$QIOW(,%VAL(QIO_CHAN),%VAL(IO$_READLBLK),
     ,                  IOSB,,,BUF,%VAL(NO),,,,)
      IOREAD = IOSB(2)
      IF (IOSB(1).EQ.SS$_ENDOFFILE) IOREAD = 0
      IF (STATUS.NE.SS$_NORMAL) IOREAD = -1
      RETURN
      END
C-----------------------------------------------------------------
      INTEGER FUNCTION  IOWRITE(FD,BUF,NO)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.PURPOSE    Write data to a VMS I/O-channel
C.RETURN     no. of bytes written if OK 
C            else -1: EOT, -2: QIO error, -3: Timeout
C-------------------------------------------------------------------
      INCLUDE    '($SYSSRVNAM)/NOLIST'
      INCLUDE    '($IODEF)/NOLIST'
      INCLUDE    '($SSDEF)/NOLIST'
C
      INTEGER     FD
      LOGICAL*1   BUF
      INTEGER     NO
C
      INTEGER     STATUS
      INTEGER*2   QIO_CHAN,IOSB(4)
C
      QIO_CHAN = FD
      STATUS = SYS$QIOW(,%VAL(QIO_CHAN),%VAL(IO$_WRITELBLK),
     ,                  IOSB,,,BUF,%VAL(NO),,,,)
      IOWRITE = IOSB(2)
      IF (STATUS.NE.SS$_NORMAL.OR.
     .    IOSB(1).EQ.SS$_ENDOFTAPE.OR.
     .    IOSB(1).EQ.SS$_TIMEOUT) IOWRITE = -1
      RETURN
      END
C-----------------------------------------------------------------
      INTEGER FUNCTION  IOWEOF(FD)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.PURPOSE    Write EOF's on tape assigned to a VMS I/O-channel
C.RETURN     0: OK ,else -1: QIO error, -2: EOT
C-------------------------------------------------------------------
      INCLUDE    '($SYSSRVNAM)/NOLIST'
      INCLUDE    '($IODEF)/NOLIST'
      INCLUDE    '($SSDEF)/NOLIST'
C
      INTEGER     FD
C
      INTEGER     STATUS
      INTEGER*2   QIO_CHAN,IOSB(4)
C
      QIO_CHAN = FD
      STATUS = SYS$QIOW(,%VAL(QIO_CHAN),%VAL(IO$_WRITEOF),
     ,                  IOSB,,,,,,,,)
      IOWEOF = 0
      IF (STATUS.NE.SS$_NORMAL.OR.
     .    IOSB(1).EQ.SS$_ENDOFTAPE) IOWEOF = -1
      RETURN
      END
C-------------------------------------------------------------------
      INTEGER FUNCTION  IOREW(FD)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.PURPOSE    Rewind tape assigned to a VMS I/O-channel.
C.RETURN     0: OK , -1: QIO error
C-------------------------------------------------------------------
      INCLUDE    '($SYSSRVNAM)/NOLIST'
      INCLUDE    '($IODEF)/NOLIST'
      INCLUDE    '($SSDEF)/NOLIST'
C
      INTEGER     FD
C
      INTEGER     STATUS
      INTEGER*2   QIO_CHAN,IOSB(4)
C
      QIO_CHAN = FD
      STATUS = SYS$QIOW(,%VAL(QIO_CHAN),%VAL(IO$_REWIND),
     ,                  IOSB,,,,,,,,)
      IOREW = 0
      IF (STATUS.NE.SS$_NORMAL) IOREW = -1
      RETURN
      END
C-------------------------------------------------------------------
      INTEGER FUNCTION  IOSF(FD,NO)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.PURPOSE    Skip files on tape assigned to a VMS I/O-channel
C.RETURN     0: OK , -1: QIO error
C-------------------------------------------------------------------
      INCLUDE    '($SYSSRVNAM)/NOLIST'
      INCLUDE    '($IODEF)/NOLIST'
      INCLUDE    '($SSDEF)/NOLIST'
C
      INTEGER     FD
      INTEGER     NO
C
      INTEGER     STATUS
      INTEGER*2   QIO_CHAN,IOSB(4)
C
      QIO_CHAN = FD
      STATUS = SYS$QIOW(,%VAL(QIO_CHAN),%VAL(IO$_SKIPFILE),
     ,                  IOSB,,,%VAL(NO),,,,,)
      IOSF = 0
      IF (STATUS.NE.SS$_NORMAL) IOSF = -1
      RETURN
      END
C-------------------------------------------------------------------
      INTEGER FUNCTION  IOSR(FD,NO)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.PURPOSE    Skip files on tape assigned to a VMS I/O-channel
C.RETURN     0: OK , -1: QIO error
C-------------------------------------------------------------------
      INCLUDE    '($SYSSRVNAM)/NOLIST'
      INCLUDE    '($IODEF)/NOLIST'
      INCLUDE    '($SSDEF)/NOLIST'
C
      INTEGER     FD
      INTEGER     NO
C
      INTEGER     STATUS
      INTEGER*2   QIO_CHAN,IOSB(4)
C
      QIO_CHAN = FD
      STATUS = SYS$QIOW(,%VAL(QIO_CHAN),%VAL(IO$_SKIPRECORD),
     ,                  IOSB,,,%VAL(NO),,,,,)
      IOSR = 0
      IF (STATUS.NE.SS$_NORMAL) IOSR = -1
      RETURN
      END
C-------------------------------------------------------------------
      INTEGER FUNCTION IOFSF(FD,NO)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.PURPOSE    Forward Skip Files on tape assigned to a VMS I/O-channel
C.RETURN     0: OK , -1: QIO error
C--------------------------------------------------------------------
      INTEGER     FD
      INTEGER     NO
C
      IOFSF = IOSF(FD,NO)
      RETURN
      END
C-------------------------------------------------------------------
      INTEGER FUNCTION IOBSF(FD,NO)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.PURPOSE    Backward Skip Files on tape assigned to a VMS I/O-channel
C.RETURN     0: OK , -1: QIO error
C-------------------------------------------------------------------
      INTEGER     FD
      INTEGER     NO
C
      IOBSF = IOSF(FD,-NO)
      RETURN
      END
C-------------------------------------------------------------------
      INTEGER FUNCTION IOFSR(FD,NO)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.PURPOSE    Forward Skip Files on tape assigned to a VMS I/O-channel
C.RETURN     0: OK , -1: QIO error
C-------------------------------------------------------------------
      INTEGER     FD
      INTEGER     NO
C
      IOFSR = IOSR(FD,NO)
      RETURN
      END
C-------------------------------------------------------------------
      INTEGER FUNCTION IOBSR(FD,NO)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.PURPOSE    Bachward Skip Record on tape assigned to a VMS I/O-channel
C.RETURN     0: OK , -1: QIO error
C---------------------------------------------------------------------
      INTEGER     FD
      INTEGER     NO
C
      IOBSR = IOSR(FD,-NO)
      RETURN
      END

C @(#)lorentz.for	19.1 (ES0-DMD) 02/25/03 13:17:40
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE LORENZ(INDEP,X,NP,PARAM,Y,DERIV)                              
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                  
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  18:01 - 21 DEC 1987                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C--------------------------------------------------------------                 
C***************************************************                            
C                                                                               
C      IMPLICIT NONE                                                            
C  FIT WITH A (MODIFIED) LORENTZ-DISTRIBUTION                                   
C                                                                               
C   Y = P1/(1+(2(X-P2)/P3)**2)**P4                                              
C                                                                               
C.AUTHOR   O. RICHTER                                                           
C.MODIFICATION                                                                  
C    20 AUG 87        FM PHD     (error y1 <-> y + factor of 2)                 
C                                                                               
      INTEGER NP,INDEP
      DOUBLE PRECISION Y,PARAM(NP),DERIV(NP)                                    
      REAL X(INDEP)                                                        
      DOUBLE PRECISION B,C,D,E                                                
C                                                                               
      B      = 2.D0* (X(1)-PARAM(2))/PARAM(3)                                   
      C      = B*B                                                              
      D      = 1.0D0 + C                                                        
      E      = D** (-PARAM(4))                                                  
      DERIV(1) = E                                                              
      Y      = PARAM(1)*E                                                       
      DERIV(2) = 4.0D0*PARAM(4)*B*Y/D/PARAM(3)                                  
C      DERIV(3) = 2.D0*DERIV(2)*B                                               
C      DERIV(4) = -E*DLOG(D)                                                    
      DERIV(3) = 0.5D0*DERIV(2)*B                                               
      DERIV(4) = -Y*DLOG(D)                                                     
      RETURN                                                                    
                                                                                
      END                                                                       

C===========================================================================
C Copyright (C) 1995,2004 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FTEXT1(NAME,ISTAT)                                             
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                   
C.COPYRIGHT: Copyright (c) 1987,2004 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:25 - 13 JAN 1988                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C.IDENTIFICATION                                                                
C                                                                               
C  FITLIB.FOR   VERSION 1.0  27 MAR 1984                                        
C                                                                               
C.PURPOSE                                                                       
C                                                                               
C  INTERFACE ROUTINES FOR THE FITTING STRUCTURES                                
C FINISH FIT SESSION                                                            
C CLOSE  DATA FILE                                                              
C CREATE FIT FILE NAME.FIT                                                      
C                                                                               
C.ALGORITHM                                                                     
C                                                                               
C  use MIDAS I/O interfaces to frames and tables                                
C                                                                               
C.KEYWORDS                                                                      
C                                                                               
C  non linear fitting                                                           
C                                                                               
C.VERSION
C 040210	last modif
C 
C----------------------------------------------------------------               
C                                                                               
C                                                                               
C INPUT PARAMETERS                                                              
C NAME CHAR FIT DATA FILE NAME                                                  
C                                                                               
C OUTPUT PARAMETERS                                                             
C ISTAT INTG STATUS RETURN                                                      
C                                                                               
      INTEGER IP,DUN, N1,ISTAT,I,II
      CHARACTER*(*) NAME                                                        
      CHARACTER*60 FITNAME                                                      
      CHARACTER WS*5,FITSPEC*7
      CHARACTER*5 TYPE                                                          
       INCLUDE 'MID_INCLUDE:ST_DEF.INC/NOLIST'                    
       INCLUDE 'MID_INCLUDE:FITI.INC/NOLIST'                    
       INCLUDE 'MID_INCLUDE:FITC.INC/NOLIST'                          
       INCLUDE 'MID_INCLUDE:ST_DAT.INC/NOLIST'                    
      DATA FITSPEC/'FIT....'/                                       
      DATA TYPE/'R*4 '/                                                         
C                                                                               
C CLOSE DATA FILE                                                               
C                                                                               
      IF (FZMAPPED.NE.0) THEN                                                 
          IF (FZTYPE.EQ.'BDF ') THEN                                          
              CALL STFCLO(FZIDEN,ISTAT)                                       
                                                                                
          ELSE                                                                  
              CALL TBTCLO(FZIDEN,ISTAT)                                       
          END IF                                                                
                                                                                
          FZMAPPED = 0                                                        
      END IF                                                                    
C                                                                               
C EXIT DATA                                                                     
C                                                                               
      II     = INDEX(NAME,' ') - 1                                         
      FITNAME = NAME(1:II)//'.fit'                                              
      CALL STFCRE(FITNAME,D_R4_FORMAT,F_O_MODE,F_FIT_TYPE,1,IP,ISTAT)
C
      II = 0                         !NAXIS = 0 needed for FITS output
      CALL STDWRI(IP,'NAXIS',II,1,1,DUN,ISTAT)
      CALL STDWRC(IP,'FITCHAR',1,FZCHAR,1,FZNCHAR,DUN,ISTAT)             
      CALL STDWRI(IP,'FITINTG',FZINTG,1,FZNINTG,DUN,ISTAT)             
      CALL STDWRR(IP,'FITREAL',FZREAL,1,FZNREAL,DUN,ISTAT)           
      IF (FZNPTOT .EQ. 0) THEN
          N1 = 128
      ELSE
          N1 = FZNPTOT
      ENDIF
      CALL STDWRD(IP,'FITPARAM',FZVALUE,1,N1,DUN,ISTAT)         
      CALL STDWRD(IP,'FITERROR',FZERROR,1,N1,DUN,ISTAT)         
      DO 10 I = 1,FZNFUN                                                      
          WRITE (WS,9000) 10000 + I                                             
          FITSPEC(4:7) = WS(2:5)                                                
          CALL STDWRC(IP,FITSPEC,1,FZSPEC(I),1,80,DUN,ISTAT)               
   10 CONTINUE                                                                  
      CALL STFCLO(IP,ISTAT)                                                
      RETURN                                                                    
                                                                                
 9000 FORMAT (I5)                                                               
      END                                                                       

C @(#)mvautil.for	19.1 (ES0-DMD) 02/25/03 13:27:15
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C

        SUBROUTINE MAPSM(IN,OUT,NAR,NSEL,NCOL)
        INTEGER NAR,NSEL,NCOL,I,J
        REAL*4 IN(NAR,NCOL),OUT(NSEL,NCOL)
        DO 20 J=1,NCOL
          DO 10 I=1,NSEL
             OUT(I,J) = IN(I,J)
10        CONTINUE
20      CONTINUE
        RETURN
        END
        SUBROUTINE MIPSM(IN,OUT,NAR,NSEL,NCOL)
        INTEGER NAR,NSEL,NCOL,I,J
        REAL*4 IN(NAR,NCOL)
        INTEGER OUT(NSEL,NCOL)
        DO 20 J=1,NCOL
          DO 10 I=1,NSEL
             OUT(I,J) = IN(I,J)
10        CONTINUE
20      CONTINUE
        RETURN
        END
        SUBROUTINE MAPBG(IN,OUT,NAR,NSEL,NCOL)
        INTEGER NAR,NSEL,NCOL,TINULL,I,J
        REAL*4 IN(NSEL,NCOL),OUT(NAR,NCOL)
        REAL*4 TRNULL
        DOUBLE PRECISION TDNULL
        CALL TBMNUL(TINULL,TRNULL,TDNULL)
        DO 30 J=1,NCOL
           DO 10 I=1,NSEL
              OUT(I,J) = IN(I,J)
10         CONTINUE
           DO 20 I=NSEL+1,NAR
              OUT(I,J) =  TDNULL 
20         CONTINUE
30      CONTINUE       
        RETURN
        END
        SUBROUTINE MIPBG(IN,OUT,NAR,NSEL,NCOL)
        INTEGER NAR,NSEL,NCOL,TINULL,I,J
        INTEGER IN(NSEL,NCOL)
        REAL*4 OUT(NAR,NCOL)
        REAL*4 TRNULL
        DOUBLE PRECISION TDNULL
        CALL TBMNUL(TINULL,TRNULL,TDNULL)
        DO 30 J=1,NCOL
           DO 10 I=1,NSEL
              OUT(I,J) = IN(I,J)
10         CONTINUE
           DO 20 I=NSEL+1,NAR
              OUT(I,J) =  TDNULL 
20         CONTINUE
30      CONTINUE       
        RETURN
        END
        SUBROUTINE CHSEL(TID,NROW,NSEL)
C
C       COUNT SELECTED ELEMENTS
C
        INTEGER*4          TID,STATUS,NROW,NSEL,I
        LOGICAL            SEL
C
        NSEL = 0
        DO I = 1, NROW
          CALL TBSGET(TID,I,SEL,STATUS)
          IF (SEL) NSEL = NSEL+1
        ENDDO
        RETURN
        END

C===========================================================================
C Copyright (C) 1995-2005 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  15:55 - 19 NOV 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION
C  program TDCMPR
C
C.PURPOSE
C  creates a new column with values computed using coefficients
C  generated in a regression command
C  COMP/REGR table output = coefs[(col1,...)]  [R*8]
C
C.KEYWORDS
C  REGRESSION, TABLES
C
C.ALGORITHM
C use table interface routines
C
C.VERSION
C 051017	last modif
C 
C-----------------------------------------------------------
C
      SUBROUTINE TDCMPR
      IMPLICIT NONE
C
      LOGICAL NULL(9),NEXT,IPOL,NEWCOL
C
      INTEGER PARVAL,IPAR(13),ICOL(10)
      INTEGER ISTAT, NPAR, I, TID, NCOL, NROW, NSC, NAC, NAR
      INTEGER OCOL, LL, INDX, IAV, NIND, NIND1, NA, K, L
      INTEGER NN, K1, IP, I1, I2, DUNIT, DNULL
      INTEGER INDVAR, L1, J
      INTEGER INDEX, TYPE, TYPE1
      INTEGER EC, EL, ED, N1, N2
C
      DOUBLE PRECISION DPAR(100),VAL(9),WORK(100),RESULT,DC
C
      CHARACTER*80 TABLE
      CHARACTER*80 LINE1, LINE
      CHARACTER*20 DESNAM, NAME
      CHARACTER*8  FORM, OUTFMT
      CHARACTER*18 OUTCOL
      CHARACTER*80 MSG
      CHARACTER*16 UNIT, LABEL, CTYP
C
      INCLUDE 'MID_INCLUDE:TABLES.INC'
      INCLUDE 'MID_INCLUDE:TABLED.INC'
C 
      DATA PARVAL/5/
      DATA MSG/'ERR:TREGRCOMxxxx'/
      DATA UNIT/' '/,LABEL/' '/
C
C ... GET PARAMETERS
C
      K = 0
      L = 0
      CALL TDPGET(PARVAL,NPAR,ISTAT)
      IF (ISTAT.NE.0) GO TO 80
      TABLE  = TPARBF(1)
      OUTCOL = TPARBF(2)
      LINE   = ' '
      LINE   = TPARBF(4)
      OUTFMT = TPARBF(5)
      DO 10 I = 1,9
         NULL(I) = .FALSE.
         VAL(I) = 0.D0
   10 CONTINUE
      TID = -1
C
C ... read table and check output column
C
      CALL TBTOPN(TABLE,F_U_MODE,TID,ISTAT)
      CALL TBIGET(TID,NCOL,NROW,NSC,NAC,NAR,ISTAT)
      CALL TBCSER(TID,OUTCOL,OCOL,ISTAT)
      IF (OCOL.EQ.-1) THEN
          LABEL  = OUTCOL(2:)
          IF (OUTFMT(3:3) .EQ. '8') THEN
             TYPE   = D_R8_FORMAT
          ELSE
             TYPE   = D_R4_FORMAT
          ENDIF
          FORM   = 'G14.7'
          CALL TBCINI(TID,TYPE,1,FORM,UNIT,LABEL,OCOL,ISTAT)
      ELSE
          CALL TBFGET(TID,OCOL,FORM,LL,TYPE,ISTAT)
          IF (TYPE.EQ.D_C_FORMAT) THEN
              ISTAT  = ERRFMT
              GO TO 80
          END IF
      END IF
C
C ... read regression parameters
C
      INDX   = INDEX(LINE,'(')
      IF (INDX.EQ.0) THEN
          NEWCOL = .FALSE.
          INDX   = INDEX(LINE,' ') - 1
      ELSE
          NEWCOL = .TRUE.
          INDX   = INDX - 1
      END IF
      DESNAM = LINE(1:INDX)//'C '
      CALL STECNT('GET',EC,EL,ED)
      CALL STECNT('PUT',1,0,0)            !disable errors ...
      CALL STDRDC(TID,DESNAM,1,17,4,IAV,NAME,DUNIT,DNULL,ISTAT)
      CALL STECNT('PUT',EC,EL,ED)
      IF (ISTAT.NE.0) THEN
         CALL STDFND(TID,DESNAM,CTYP,N1,N2,ISTAT)
         IF ((CTYP(1:1) .NE. 'C') .OR. (N1 .LT. 4)) THEN
            CALL STDRDC(TID,DESNAM,1,1,N2,IAV,NAME,DUNIT,DNULL,ISTAT)
         ELSE
            CALL STDRDC(TID,DESNAM,1,N1-3,N1,IAV,NAME,DUNIT,DNULL,ISTAT)
            WRITE(MSG,123) DESNAM,N1
            CALL STTPUT('!OJO! compute/regression: ',ISTAT)
123         FORMAT('!OJO! descr. ',A,' has size',i3,' (not 20)')
            CALL STTPUT(MSG,ISTAT)
         ENDIF
      ENDIF
      DESNAM = LINE(1:INDX)//'I '
      CALL STDRDI(TID,DESNAM,1,13,IAV,IPAR,DUNIT,DNULL,ISTAT)
      NIND   = IPAR(2)
      DO 20, I=1,NIND
          ICOL(I) = IPAR(3+I)
   20 CONTINUE
      IF (NAME(1:4).EQ.'LINE') THEN
          NA     = NIND + 1
          IPOL   = .FALSE.
      ELSE
          K      = IPAR(6)
          L      = IPAR(7)
          NA     = (K+1)* (L+1)
          IPOL   = .TRUE.
      END IF
      DESNAM = LINE(1:INDX)//'D '
      CALL STDRDD(TID,DESNAM,1,NA,IAV,DPAR,DUNIT,DNULL,ISTAT)
C
C ... modify independent variables if required in the syntax
C
      IF (NEWCOL) THEN
          NIND1  = 0
          I1     = INDX + 2
          NN     = INDEX(LINE,')')
          IF (NN.EQ.0) THEN
              ISTAT  = ERRPAR
              GO TO 80
          END IF
          LINE(NN:NN) = ','
          NN     = NN + 1
   30     I2     = INDEX(LINE,',') - 1
          LINE(I2+1:I2+1) = ';'
          OUTCOL = LINE(I1:I2)
          CALL TBCSER(TID,OUTCOL,INDVAR,ISTAT)
          IF (INDVAR.EQ.-1) THEN
              ISTAT  = ERRPAR
              GO TO 80
          END IF
          CALL TBFGET(TID,INDVAR,FORM,LL,TYPE1,ISTAT)
          IF (TYPE1.EQ.D_C_FORMAT) THEN
              ISTAT  = ERRFMT
              GO TO 80
          END IF
          NIND1  = NIND1 + 1
          ICOL(NIND1) = INDVAR
          I1     = I2 + 2
          IF (I1.LT.NN) GO TO 30
          IF (NIND1.NE.NIND) THEN
              ISTAT  = ERRPAR
              GO TO 80
          END IF
      END IF
C
C ... iterate on rows
C
      DO 70 I = 1,NROW
          CALL TBRRDD(TID,I,NIND,ICOL,VAL,NULL,ISTAT)
          NEXT   = ( .NOT. NULL(1)) .AND. ( .NOT. NULL(2)) .AND.
     +             ( .NOT. NULL(3)) .AND. ( .NOT. NULL(4)) .AND.
     +             ( .NOT. NULL(5)) .AND. ( .NOT. NULL(6)) .AND.
     +             ( .NOT. NULL(7)) .AND. ( .NOT. NULL(8)) .AND.
     +             ( .NOT. NULL(9))
          IF (NEXT) THEN
              IF (IPOL) THEN
                  IP     = 0
                  DC     = 1.D0
                  RESULT = 0.D0
                  DO 50 L1 = 0,L
                      IP     = IP + 1
                      WORK(IP) = DC
                      RESULT = RESULT + WORK(IP)*DPAR(IP)
                      DO 40 K1 = 1,K
                          IP     = IP + 1
                          WORK(IP) = WORK(IP-1)*VAL(1)
                          RESULT = RESULT + WORK(IP)*DPAR(IP)
   40                 CONTINUE
                      DC     = DC*VAL(2)
   50             CONTINUE
              ELSE
CC                RESULT = VAL(1)
CC Bug corrected by M.-F. Landrea, Meudon - Paris    23 Oct 1987
                  RESULT = DPAR(1)
                  DO 60 J = 2,NA
                      RESULT = RESULT + VAL(J-1)*DPAR(J)
   60             CONTINUE
              END IF
              CALL TBEWRD(TID,I,OCOL,RESULT,ISTAT)
          ELSE
              CALL TBEDEL(TID,I,OCOL,ISTAT)
          END IF
   70 CONTINUE
C
C ... END
C
      LINE1 = '-'
      CALL TDWSEL(TID,LINE1,ISTAT)
      CALL TDHSTR(TID,ISTAT)
      CALL TBSINI(TID,ISTAT)
      CALL DSCUPT(TID,TID,' ',ISTAT)
      CALL TBTCLO(TID,ISTAT)
   80 IF (ISTAT.NE.0) THEN
          WRITE (MSG(13:16),9000) ISTAT
          CALL STTPUT(MSG,ISTAT)
      END IF
      RETURN
C 
 9000 FORMAT (I4)
      END

C @(#)irsbbfit.for	19.1 (ES0-DMD) 02/25/03 14:23:43
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.COPYRIGHT   (C) 1992 European Southern Observatory
C.IDENT       .for
C.AUTHOR      E. Oliva,  Firenze-Arcetri
C.KEYWORDS    Spectroscopy, IRSPEC
C
C.PURPOSE     Execute command  ...
C
C.ALGORITHM
C
C
C.INPUT/OUTPUT
C
C
C.VERSION     1.0    Creation     02.09.1992   E. Oliva
C
C-------------------------------------------------------
C
      PROGRAM BBFIT

      IMPLICIT REAL(A-H,O-Z)
      IMPLICIT INTEGER(I-N)
      CHARACTER*60 TABLE
      INTEGER UNITS
      LOGICAL NULL
      DIMENSION WL(10000),FLUX(10000)
      COMMON /VMR/ MADRID(1)

      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'

      DATA MAXDIM/2/

      IRET=1
      CALL STSPRO('BBFIT')
C
C Get units flag
C
      CALL STKRDI('units',1,1,IRET,UNITS,KUNIT,KNUL,ISTAT)
C
C Get name of input table
C
      CALL STKRDC('table',1,1,60,IRET,TABLE,KUNIT,KNUL,ISTAT)
      CALL CLNTAB(TABLE,TABLE,0)
C
C OPEN TABLE FOR READING (IOPEN=0)
C
      IOPEN=0
      CALL TBTOPN(TABLE,IOPEN,IDETAB,ISTAT)
C
C GET NUMBERS CORRESPONDING TO wl AND flux
C
      CALL TBLSER(IDETAB,'wl',NXCOL,ISTAT)
      CALL TBLSER(IDETAB,'flux',NYCOL,ISTAT)
C
C GET INFORMATION UPON THE TABLE SIZE (N.B. NROW = # OF WL points)
C
      CALL TBIGET(IDETAB,NCOL,NROW,NSORT,NCALL,NRALL,ISTAT)
      NWL=NROW
C
C COPY TABLE ELEMENTS INTO VECTORS WL,FLUX
C
      DO IROW=1,NWL
        CALL TBERDR(IDETAB,IROW,NXCOL,RVAL,NULL,ISTAT)
        IF(RVAL.LE.0) 
     +    CALL STETER(1,'One of the wavelengths is <=0')
        WL(IROW)=RVAL
        IF(UNITS.EQ.1) WL(IROW)=WL(IROW)/1.E4
        CALL TBERDR(IDETAB,IROW,NYCOL,RVAL,NULL,ISTAT)
        IF(RVAL.LE.0) 
     +    CALL STETER(1,'One of the fluxes is <=0')
        FLUX(IROW)=RVAL
      ENDDO
      CALL TBTCLO(IDETAB,ISTAT)
C
C CALL ROUTINE WHICH fits the black-body
C
      CALL FIT_BB(WL,FLUX,NWL,TEMP,FACT0)
C
C Write TEMP, FACT0 in OUTPUTR keywords
C
      CALL STKWRR('outputr',TEMP,1,1,KUN,ISTAT)
      CALL STKWRR('outputr',FACT0,2,1,KUN,ISTAT)
C
C RELEASE FILES, UPDATE KEYWORDS AND EXIT
C
      CALL STSEPI
      END
C
C
C
      SUBROUTINE FIT_BB(WL,FLUX,NWL,T,F0)
      IMPLICIT REAL(A-H,O-Z)
      IMPLICIT INTEGER(I-N)
      DIMENSION WL(NWL),FLUX(NWL),F(3)

      T=5000.
      DT=1000.
      FMIN=1E30
      NITER=0
10    CONTINUE
      DO I=1,3
        F(I)=FUNCT(T+(I-1)*DT,F0,WL,FLUX,NWL)
      ENDDO
      IF(F(1).GT.F(2) .AND. F(2).GT.F(3)) THEN
        T=T+2.*DT
        GO TO 10
      ENDIF
      IF(F(1).LT.F(2) .AND. F(2).LT.F(3)) THEN
        T=T-DT
        GO TO 10
      ENDIF
      IF(F(1).EQ.F(2) .AND. F(2).EQ.F(3)) THEN
        T=T+DT
      ELSE
        T=T+2*DT-DT*((F(3)-F(2))/(F(3)-2*F(2)+F(1))+0.50)
      ENDIF
      FNEW=FUNCT(T,F0,WL,FLUX,NWL)
C	WRITE(*,*) 'T,F0,FNEW',T,F0,FNEW
      ERR=ABS(FNEW/FMIN-1)
      IF(ERR.GT.1e-4) THEN
        DT=DT/2.
        DT=MAX(DT,.1)
        FMIN=FNEW
        NITER=NITER+1
        IF(NITER.GT.100) THEN
          CALL STETER(1,'No convergency after 100 iterations')
        ELSE
          GO TO 10
        ENDIF
      ENDIF
      RETURN
      END

      FUNCTION FUNCT(T,F0,WL,FLUX,NWL)
      IMPLICIT REAL(A-H,O-Z)
      IMPLICIT INTEGER(I-N)
      DIMENSION WL(NWL),FLUX(NWL)

      SUMB2=0.0
      SUMFB=0.0
      DO I=1,NWL
        BBI=1/WL(I)**5/(EXP(14388./WL(I)/T)-1)
        SUMB2=SUMB2+BBI*BBI
        SUMFB=SUMFB+BBI*FLUX(I)
      ENDDO
      F0=SUMFB/SUMB2
      FUNCT=0.0
      DO I=1,NWL
        BBI=1/WL(I)**5/(EXP(14388./WL(I)/T)-1)
        CONTR=F0*BBI-FLUX(I)
        FUNCT=FUNCT+CONTR*CONTR
      ENDDO
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM CENTER
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION:                
C  program CENTER		version 2.70	850322
C  K. Banse			ESO - Garching
C
C.KEYWORDS:
C  Gaussian profiles, intensity moments
C
C.PURPOSE:
C  Compute the central position of an object via Gaussian fit or
C  first moments of intensity
C
C.ALGORITHM:
C  See P.B. Stetson , 1979 Astron. J., 84, 1149
C  
C.INPUT/OUTPUT:
C  The following keywords are used:
C  IN_A/C/1/60		in_frame or in_frame,in_table
C			= CURSOR for cursor input
C			= + for no cursor
C  ACTION/C/1/2		(1) centering method,
C			    G: Gaussian fitting
C			    M: first moments of intensity
C			    I: 2-dim Gaussian fitting + get angle of major axis
C			(2) invert_flag
C			    Y: yes, we invert data (Gaussian valleys)
C			    N: no, we have normal Gaussian peaks
C  INPUTC/C/1/30	specs for data storage
C			= :label for table or table,:label (a)
C			= descr/DESCR for descriptor (b)
C			= ? for just display of data
C  INPUTC/C/31/2	(a) identifier flag for table,
C			= I, append an identifier, else no.
C  			(b) append flag for descriptor/table,
C			= A, append data to descriptor
C			= ?, start again at position 1 in descr
C
C  OUTPUTR/R/1/11	last displayed results
C  OUTPUTI/I/1/1	no. of loops in program
C	
C.VERSIONS
C 
C 100615		last modif
C--------------------------------------------------------------------------
C
      IMPLICIT NONE
C      
      INTEGER      FELEM,IAV,IDFLAG,INFLAG,OUTFL,IDYES
      INTEGER      KSTAT              !retstat from centering: <0, 0,1,2,3, >3
      INTEGER      N,NN,NMAL,NLIM,NCOOS,INVFLG
      INTEGER      NAXIS,NROW,OUTCOL,NOCURS,FIRTIM
      INTEGER      IMNO,STAT,STAT1,STAT2,LLABL
      INTEGER      NPIX(3),NPIXT(3),DRAWY(3)
      INTEGER      INBUF(5),NCOU,ALOW(3),BLOW(3),HIGH(3)
      INTEGER      SPIX(4),XYALP(3)
      INTEGER      ICUR1(2),ICUR2(2),NW(2),XU,XL,YU,YL
      INTEGER      INCOLN(17),OUCOLN(17),LRVALS
      INTEGER      TABNUL(12),TIDA,TIDB
      INTEGER      COOS(4),OVCON,INPUT(3),CPIX(4),BOX(4),OLDBOX(4)
      INTEGER      NAPP,ONEDIM,COOFF,FRPIX(2)
      INTEGER      UNI(1),NULO,MAPROW,TIMNO,GAUS1,INDG(6),REWRITE
      INTEGER      MADRID(1)
      INTEGER*8    PNTRA,PNTRC
C
      CHARACTER    FRAME*60
      CHARACTER    DESCR*15,APPFLG*2,CACT*8
      CHARACTER    CUNIT*48,IDENT*72,CBUF*82,ACTION*4,METHOD*4
      CHARACTER    IDF*8,OLDIDF*8,LABL*8, CTEST*8
      CHARACTER    CSTAT*32,INFO*50
      CHARACTER    INTAB*60,OUTTAB*60,TABUW*16,TABUNI(17)*16
      CHARACTER    LABEL(17)*16,LABEL1(17)*16,LABEL2(17)*16,GLABEL*16
C 
      REAL         RBUF(17),PCUR1(6),PCUR2(6)
      REAL         ICENT
      REAL         RVALS(17),RINF(8),RV
      REAL         XOUT,YOUT,XERR,YERR,XSIG,YSIG,XFWHM,YFWHM
      REAL         XOFF,YOFF,XCUTS,ANGLE,ANGSIG,AXMAJ,AXMIN
C 
      DOUBLE PRECISION STEP(3),START(3)
      DOUBLE PRECISION  DIN(4),DOUT(4)                 !MaxDim = 4 in wrldco.c
      DOUBLE PRECISION  DVALS(10)
      DOUBLE PRECISION  W1(2048),W2(2048),ACOE(4)
C
      LOGICAL      SELFLG
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      INCLUDE 'MID_INCLUDE:IDIDEV.INC'
      INCLUDE 'MID_INCLUDE:IDIMEM.INC'
C 
      COMMON    /VMR/  MADRID
C      
      DATA    INFO /'switch cursor(s) on  - next time we exit... '/
C
      DATA    LABEL1 /'XSTART ','YSTART ','XEND ','YEND ',
     +               'XCEN ','YCEN ','XERR ','YERR ',
     +               'XSIG ','YSIG ',
     +               'XFWHM','YFWHM','ICENT',
     +               'STATUS ',' ',' ','IDENT '/
      DATA    LABEL2 /'XSTART ','YSTART ','XEND ','YEND ',
     +               'XCEN ','YCEN ','XERR ','YERR ',
     +               'XSIG ','YSIG ',
     +               'AX_MAJ ','AX_MIN ','ICENT',
     +               'STATUS ','ANGLE ','ANGLE_SIG ','IDENT '/
      DATA    GLABEL /'X_POSITION '/
      DATA    INCOLN /17*0/, OUCOLN /17*0/
      DATA    TABUW  /'World Coords '/
      DATA    TABUNI /17*' '/
C      
      DATA    IDF    /'ID '/, OLDIDF /' '/
      DATA    SPIX   /4*1/,   DESCR  /' '/
      DATA    IDENT  /' '/,   CUNIT  /' '/
      DATA    XYALP  /3*0/,   NPIX   /3*1/,   NPIXT   /3*1/
      DATA    ALOW   /3*1/,   BLOW   /3*1/,   HIGH    /3*1/
      DATA    CACT   /'NNYY?C0 '/
      DATA    COOS   /-1,-1,-1,-1/
      DATA    NCOOS  /0/, IDFLAG /0/, ONEDIM /0/
      DATA    LRVALS /11/, REWRITE /0/
      DATA    INTAB  /' '/,   OUTTAB /' '/
      DATA    DVALS /10*0.0/, DIN /4*1.0/
      DATA    START /3*0.0/, STEP /3*1.0/
      DATA    INDG /1,3,5,9,11,13/
C 
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C  set up MIDAS environment + enable automatic error abort
      CALL STSPRO('CENTER')
      NCOU = 0
      DRAWY(1) = -1                         !set draw flag to start
      DRAWY(2) = 0
      DRAWY(3) = 0
      FIRTIM = 0
      IMNO = -1
      TIDA = -1
      TIDB = -1                             !default to NO output table
      IDYES = 0
      NLIM = 0
      XU = 0
      XL = 0
      YU = 0
      COFF = 0
      AXMAJ = 0
      AXMIN = 0
      GAUS1 = 0
C      
C  get method
      CALL STKRDC('ACTION',1,1,2,IAV,ACTION,UNI,NULO,STAT)
      IF (ACTION(1:1).EQ.'M') THEN
         METHOD(1:) = 'MOM '
      ELSE IF (ACTION(1:1).EQ.'1') THEN        !1-dim Gauss 
         METHOD(1:) = '1DG '
         GAUS1 = 1
         ONEDIM = 1
      ELSE IF (ACTION(1:1).EQ.'I') THEN
         METHOD(1:) = 'IQE '
      ELSE
         METHOD(1:) = 'GAU '
      ENDIF
      IF ((ACTION(2:2).NE.'Y') .AND. (ACTION(2:2).NE.'y')) THEN
         INVFLG = 0                         !usual Gaussian with max at center
      ELSE
         INVFLG = 1
      ENDIF
C 
      IF (METHOD(1:1).EQ.'I') THEN
         DO 21, IAV=1,17
            LABEL(IAV)(1:) = LABEL2(IAV)(1:)
21       CONTINUE
      ELSE
         DO 25, IAV=1,17
            LABEL(IAV)(1:) = LABEL1(IAV)(1:)
25       CONTINUE
      ENDIF
C
C  get input options
      CBUF(1:) = ' '
      CALL STKRDC('P1',1,1,80,IAV,CBUF,UNI,NULO,STAT)
      NN = INDEX(CBUF,',')
C      
      IF (NN.GT.1) THEN                          !image,Option
         FRAME(1:) = CBUF(1:NN-1)//' '
         INTAB(1:) = CBUF(NN+1:)//' '
         NN = INDEX(INTAB,',')
         IF (NN.GT.1) THEN                       !Option = xfpix,yfpix
            CALL GENCNV(INTAB,1,2,FRPIX,RBUF,STEP,IAV)
            IF (IAV .LT. 2) THEN
               CALL STETER(3,'Invalid frame pixels given...')
            ENDIF
            INFLAG = 4                           !INFLAG = 4 for frame pixels
         ELSE                                    !Option = table
            CALL CLNTAB(INTAB,INTAB,0)
            CALL TBTOPN(INTAB,F_IO_MODE,TIDA,STAT)
            INFLAG = 2                           !INFLAG = 2 for table
         ENDIF
      ELSE                                 
         IF ((CBUF(1:6).EQ.'CURSOR') .OR.
     +       (CBUF(1:6).EQ.'cursor')) THEN
            CALL STKRDC('IN_A',1,1,60,IAV,FRAME,UNI,NULO,STAT)
            INFLAG = 1                           !INFLAG = 1 for cursor
            COOFF = 0                            !cursor_off flag
         ELSE 
            FRAME(1:) = CBUF(1:60)
            INFLAG = 3                           !INFLAG = 3 for complete image
            CALL STTPUT
     +      ('We work on crude center of input frame. ',STAT)
         ENDIF
      ENDIF
C 
C  open input frame + map it
      CALL CLNFRA(FRAME,FRAME,0)
      NN = 1
      CALL STPSET(F_FITS_PARM,NN,STAT)        !don't read in ESO.xyz keywords
      CALL STFOPN(FRAME,D_R4_FORMAT,0,F_IMA_TYPE,IMNO,STAT)
      CALL STDRDI(IMNO,'NAXIS',1,1,IAV,NAXIS,UNI,NULO,STAT)
      CALL STDRDI(IMNO,'NPIX',1,3,IAV,NPIX,UNI,NULO,STAT)
C 
      N = NAXIS                                   !get true NAXIS
      IF (NAXIS.GT.2) THEN
         IF (NPIX(3).EQ.1) THEN
            IF (NPIX(2).EQ.1) THEN
               N = 1
            ELSE
               N = 2
            ENDIF
         ELSE
            CALL STTPUT('only first plane of input frame used...',STAT)
            N = 2
         ENDIF
      ELSE IF (NAXIS.EQ.2) THEN
         IF (NPIX(2).EQ.1) N = 1
      ENDIF
      IF (N.EQ.1) ONEDIM = 1
C      
      CALL STDRDD(IMNO,'START',1,2,IAV,START,UNI,NULO,STAT)
      CALL STDRDD(IMNO,'STEP',1,2,IAV,STEP,UNI,NULO,STAT)
      IF (INVFLG.EQ.1)
     +   CALL STDRDR(IMNO,'LHCUTS',4,1,IAV,XCUTS,UNI,NULO,STAT)
C 
C  init frame pixls  <->  world coords conversion
      CALL FPXWCO(0,IMNO,DIN,DOUT,STAT)
      IF (STAT .GT. 0) 
     +   CALL STETER(11,'problems with WCS of input frame...')
C
C  map temporary work frames, start with max. 220 rows
      MAPROW = 220
      IF (ONEDIM.EQ.1) THEN
         N = NPIX(1)
      ELSE
         N = NPIX(1)*MAPROW
      ENDIF
      IF (GAUS1.EQ.1) THEN
         CALL STFMAP(IMNO,F_I_MODE,1,N,IAV,PNTRA,ISTAT)
      ELSE
         CALL STFYMP(N,D_R4_FORMAT,TIMNO,PNTRA,STAT)
         N = 200 * 200
         CALL STFXMP(N,D_R4_FORMAT,PNTRC,STAT)
      ENDIF
C
C  get out_specs + output_options
      CALL STKRDC('INPUTC',1,1,32,IAV,CBUF,UNI,NULO,STAT)
      APPFLG(1:2) = CBUF(31:32)
      CBUF(31:32) = '  '
      CALL UPCAS(APPFLG,APPFLG)
C      
      IF (CBUF(1:1).EQ.'+') THEN
         OUTFL = 0
         GOTO 500                        !neither table nor descriptor
      ENDIF
C      
      NN = INDEX(CBUF,',D')              !test for ,D
      IF (NN.LE.1) NN = INDEX(CBUF,',d')
C      
C  handle descriptor storage
      IF (NN.GT.1) THEN                  !it's a descriptor
         DESCR = CBUF(1:NN-1)
         IF (APPFLG(1:1).EQ.'A') THEN    !see, if data is to be appended
            FELEM = -1
         ELSE
            FELEM = 1
         ENDIF
         OUTFL = 1                       !OUTFL = 1 for descriptor 
         GOTO 500                        !skip following table stuff
      ENDIF
C      
C  ++++
C  handle table storage
C  ++++
C 
      IF ( ((APPFLG(1:1).EQ.'I').OR.(APPFLG(2:2).EQ.'I'))
     +     .AND. (INFLAG.EQ.1) ) IDFLAG = 1
      CALL CLNTAB(CBUF(1:30),OUTTAB,0)
      DO 90, IAV=1,12
         TABUNI(IAV)(1:) = TABUW(1:)
90    CONTINUE
      TABUNI(13)(1:) = 'Intensity '
      TABUNI(14)(1:) = 'Center_Status '
      IF (ACTION(1:1).EQ.'I') THEN
         OUTCOL = 16 
         TABUNI(15)(1:) = TABUW(1:)
         TABUNI(16)(1:) = TABUW(1:)
      ELSE
         OUTCOL = 14 
      ENDIF
C      
C   either same table involved
C      
      CALL GENEQF(OUTTAB,INTAB,IAV)
      IF (IAV.EQ.1) THEN            !results go to same table
         TIDB = TIDA
         OUTFL = 2                         !OUTFL = 2 for same table
C      
         IF (GAUS1.EQ.1) THEN
            IAV = INDG(3)       !see, if :XCEN there (iav = 5)
            CALL TBLSER(TIDA,LABEL(IAV),OUCOLN(IAV),STAT)
            IF (OUCOLN(IAV).LE.0)          !No. We have to define it...
     +         CALL TBCINI(TIDA,D_R8_FORMAT,1,'E24.15',TABUNI(IAV),
     +         LABEL(IAV),OUCOLN(IAV),STAT)
C
            DO 120 N=4,6               !test, if columns already there
               IAV = INDG(N)           != 9, 11, 13
               CALL TBLSER(TIDA,LABEL(IAV),OUCOLN(IAV),STAT)
               IF (OUCOLN(IAV).LE.0)          !No. We have to define it...
     +            CALL TBCINI(TIDA,D_R4_FORMAT,1,'E12.5',TABUNI(IAV),
     +                        LABEL(IAV),OUCOLN(IAV),STAT)
120         CONTINUE
C
         ELSE
            DO 150 IAV=5,6                !see, if :XCEN,:YCEN already there
               CALL TBLSER(TIDA,LABEL(IAV),OUCOLN(IAV),STAT)
               IF (OUCOLN(IAV).LE.0)          !No. We have to define it...
     +            CALL TBCINI(TIDA,D_R8_FORMAT,1,'E24.15',TABUNI(IAV),
     +                        LABEL(IAV),OUCOLN(IAV),STAT)
150         CONTINUE
C      
            DO 180 IAV=7,OUTCOL               !test, if columns already there
               CALL TBLSER(TIDA,LABEL(IAV),OUCOLN(IAV),STAT)
               IF (OUCOLN(IAV).LE.0)          !No. We have to define it...
     +            CALL TBCINI(TIDA,D_R4_FORMAT,1,'E12.5',TABUNI(IAV),
     +                        LABEL(IAV),OUCOLN(IAV),STAT)
180         CONTINUE
C      
            CALL TBLSER(TIDA,LABEL(17),OUCOLN(17),STAT)
            IF (OUCOLN(17).LE.0)              !No. We have to define it...
     +         CALL TBCINI(TIDA,D_C_FORMAT,8,'A8',TABUNI(17),LABEL(17),
     +                     OUCOLN(17),STAT) 
         ENDIF
C      
C   or different output table - new or existing (append mode) 
C      
      ELSE
         IF ((APPFLG(1:1).EQ.'A') .OR. (APPFLG(2:2).EQ.'A')) THEN
            OUTFL = 4
            CALL TBTOPN(OUTTAB,F_IO_MODE,TIDB,STAT)
            IF (GAUS1.EQ.1) THEN
               DO 200 N=1,6            !test, if label(s) already there
                  IAV = INDG(N)           != 1, 3, 5, 9, 11, 13
                  CALL TBLSER(TIDB,LABEL(IAV),OUCOLN(IAV),STAT)
                  IF (OUCOLN(IAV).LE.0)          !Not found, error..
     +               CALL STETER(9,'Missing columns in output table...')
200            CONTINUE
            ELSE
               DO 350 IAV=1,OUTCOL            !test, if label(s) already there
                  CALL TBLSER(TIDB,LABEL(IAV),OUCOLN(IAV),STAT)
                  IF (OUCOLN(IAV).LE.0)          !Not found, error..
     +               CALL STETER(9,'Missing columns in output table...')
350            CONTINUE
               CALL TBLSER(TIDB,LABEL(17),OUCOLN(17),STAT)
               CALL TBIGET(TIDB,N,NAPP,N,N,N,STAT)     !get rows already there
            ENDIF
C 
         ELSE
            OUTFL = 3                         !for new table, create it
            CALL TBTINI(OUTTAB,0,F_O_MODE,25,100,TIDB,STAT) 
            IF (GAUS1.EQ.1) THEN
               DO 400 N=1,3
                  IAV = INDG(N)           != 1, 3, 5
                  CALL TBCINI(TIDB,D_R8_FORMAT,1,'E24.15',
     +                        TABUNI(IAV),LABEL(IAV),OUCOLN(IAV),STAT)
400            CONTINUE
               DO 420 N=4,6
                  IAV = INDG(N)           != 9, 11, 13
                  CALL TBCINI(TIDB,D_R4_FORMAT,1,'E12.5',
     +                        TABUNI(IAV),LABEL(IAV),OUCOLN(IAV),STAT)
420            CONTINUE
            ELSE
               DO 450 IAV=1,6
                  CALL TBCINI(TIDB,D_R8_FORMAT,1,'E24.15',
     +                        TABUNI(IAV),LABEL(IAV),OUCOLN(IAV),STAT)
450            CONTINUE
               DO 470 IAV=7,OUTCOL
                  CALL TBCINI(TIDB,D_R4_FORMAT,1,'E12.5',
     +                        TABUNI(IAV),LABEL(IAV),OUCOLN(IAV),STAT)
470            CONTINUE
               CALL TBCINI(TIDB,D_C_FORMAT,8,'A8',
     +                     TABUNI(17),LABEL(17),OUCOLN(17),STAT)
            ENDIF
         ENDIF
      ENDIF
C      
C  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  here all output options join:
C  display header line + branch according to input option
C  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C      
500   IF (METHOD(1:1).EQ.'I') THEN
         CBUF(1:) = '    xcenter     ycenter         angle'//
     +              '         angl-err'
         CALL STTPUT(CBUF,STAT)
         CBUF(1:) = ' '
         CBUF(35:) =  'maj-axis     min-axis'// 
     +                '     icent      ident'
      ELSE
         IF (GAUS1.EQ.1) THEN
            CBUF(1:) = '    xstart        xend       xcenter     '//
     +                 '  xfwhm          xsigma     icent'
         ELSE
            CBUF(1:) = '    xcenter     ycenter         xerr'//
     +                 '          yerr'
            CALL STTPUT(CBUF,STAT)
            CBUF(1:) = ' '
            CBUF(35:) =  ' xfwhm         yfwhm'//
     +                   '      icent      ident'
         ENDIF
      ENDIF
      CALL STTPUT(CBUF,STAT)
C      
C  branch according to input option
      NMAL = 0                        !init counter
      IF (INFLAG.EQ.1) THEN
         GOTO 900
      ELSE IF (INFLAG.EQ.2) THEN
         GOTO 2000
      ELSE IF (INFLAG.EQ.4) THEN
         GOTO 1500
      ENDIF
C 
C  --------------------------------------------------------------------
C      
C      
C  a) complete input frame is used - extract max. 200 * 200 window
C     around crude center
C     INFLAG = 3  (no looping)
C      
C  --------------------------------------------------------------------
C 
      N = NPIX(1)/2 - 100                        !get start of window
      IF (N.LE.0) N = 1
      IF (ONEDIM.EQ.1) THEN
         NN = 1
      ELSE
         NN = NPIX(2)/2 - 100
         IF (NN.LE.0) NN = 1
      ENDIF
      SPIX(1) = N
      SPIX(2) = NN
C 
      N = N  + 199                               !get end of window
      IF (N.GT.NPIX(1)) N = NPIX(1)
      IF (ONEDIM.EQ.1) THEN
         NN = 1
      ELSE
         NN = NN + 199
         IF (NN.GT.NPIX(2)) NN = NPIX(2)
      ENDIF
      SPIX(3) = N
      SPIX(4) = NN
C 
      DIN(1) = SPIX(1)
      DIN(2) = SPIX(2)
      CALL FPXWCO(1,IMNO,DIN,DOUT,STAT)          !move from fp's to wco's 
      DVALS(1) = DOUT(1)
      DVALS(2) = DOUT(2)
      DIN(1) = SPIX(3)
      DIN(2) = SPIX(4)
      CALL FPXWCO(1,IMNO,DIN,DOUT,STAT)     
      DVALS(3) = DOUT(1)
      DVALS(4) = DOUT(2)
      DO 800,IAV=1,4
         RVALS(IAV) = REAL(DVALS(IAV))
800   CONTINUE
      NMAL = 1                                   !maybe we write a row to table
      GOTO 3000
C 
C  --------------------------------------------------------------------
C      
C  b) cursor defined subimage(s) - get main control block of ImageDisplay
C     INFLAG = 1   (loop on cursor input)
C 
C  --------------------------------------------------------------------
C      
900   CALL DTOPEN(1,STAT)
      CALL STKRDI('DAZIN',1,1,IAV,INBUF,UNI,NULO,STAT)
      CALL STKRDI('DAZHOLD',14,1,IAV,OVCON,UNI,NULO,STAT)
      CALL STKRDI('CURSOR',1,3,IAV,INPUT,UNI,NULO,STAT)
      IF (INPUT(1).EQ.1) THEN
         NOCURS = 0
         CALL STKRDI('INPUTI',1,2,IAV,NW,UNI,NULO,STAT)
         IF (NW(2).GT.MAPROW) THEN                     !free allocated space
            CALL STFYMP(-1,D_R4_FORMAT,TIMNO,PNTRA,STAT) 
            MAPROW = NW(2)
            N = NPIX(1)*MAPROW
            CALL STFYMP(N,D_R4_FORMAT,TIMNO,PNTRA,STAT)
         ENDIF
         XU = NW(1) / 2
         XL = XU
         IF ((XU+XL).EQ.NW(1)) XL = XL - 1
         YU = NW(2) / 2
         YL = YU
         IF ((YU+YL).EQ.NW(2)) YL = YL - 1
      ELSE
         NOCURS = 2
      ENDIF
      DRAWY(2) = INPUT(2)
      NLIM = INPUT(3)
      IF (NLIM.LT.1) NLIM = 1
C 
      CALL DTGICH(QDSPNO,QIMCH,CBUF,RINF,STAT)
      CALL STKRDI('AUX_MODE',9,1,IAV,N,UNI,NULO,STAT)
      IF (N.NE.0) CALL CONCHA(QDSPNO,QOVCH,1,0)      !clear overlay channel
      IF (OVCON.EQ.QIMCH)
     +   CALL DAZZSC(QDSPNO,QOVCH,ZOOMX,SCROLX,SCROLY,STAT)
      FRAME(1:) = ' '                  !that's needed for cursor interface
C 
      IF (INBUF(1).GT.0) THEN          !we use the zoom window...
         IF (NOCURS.EQ.0) THEN
            CACT(5:7) = 'ZC0'          !prepare zoom_window stuff for GETCUR
         ELSE
            CACT(5:7) = 'ZC2'
         ENDIF
         DRAWY(3) = 1
         INBUF(1) = (QDSZX * 3) / 4            !use 3/4 of main display
         INBUF(2) = (QDSZY * 3) / 4 
         INBUF(3) = 0                          !start at lower left of screen
         INBUF(4) = 0
         CALL STKWRI('DAZIN',INBUF,2,4,UNI,STAT)
         N = 0
         CALL SETCUR(QDSPNO,N,3,2,COOS,STAT)          !use open_cross
C
C  if `novice', display initial help, show current zoomfactor
         CALL STKRDI('ERROR',2,1,IAV,N,UNI,NULO,STAT)
         IF (N.EQ.1) CALL AUXHLP(0)             !for novice users display help
      ELSE
         IF (NOCURS.EQ.0) THEN
            CALL SETCUR(QDSPNO,NOCURS,3,2,COOS,STAT)          !open_cross
         ELSE
            CALL SETCUR(QDSPNO,NOCURS,1,2,COOS,STAT)          !rectangle
         ENDIF
      ENDIF
      CALL PIXXCV('INIT',IMNO,RBUF,N)
C
C  input cursor positions and check status
1000  IF (IDFLAG.EQ.0) THEN
         WRITE(IDF(3:),10010) NMAL+1
      ELSE
         CALL STTPUT
     +   ('Enter identifier (cursor must be in display window) :',
     +    STAT)                  !ask for identifier...
         IAV = 8
         CALL GETSTR(IDF,IAV)
         IF (IDF.EQ.' ') IDF = OLDIDF
         OLDIDF = IDF                               !save last identifier
      ENDIF
      GOTO 1100
C 
C  invalid/bad cursor coords
1010  CALL STTDIS('Invalid cursor coords. ...',99,STAT)
C      
C  here the real thing...
C      
1100  CALL GETCUR(CACT,FRAME,
     +            ICUR1,PCUR1(1),RVALS(1),RV,STAT1,
     +            ICUR2,PCUR2(1),RVALS(3),RV,STAT2)
      IF (NOCURS.EQ.0) STAT2 = 0
C
C  check cursor status  
      IF ( (STAT1.EQ.0) .AND. (STAT2.EQ.0) ) THEN
         IF (NMAL.EQ.0) THEN
            IF (COOFF.EQ.1) GOTO 9000
            CALL STTPUT(INFO,STAT)
            COOFF = 1
            FRAME(1:) = ' '
            GOTO 1000
         ELSE
            GOTO 9000                        !cursor loop terminated ...
         ENDIF
      ENDIF
C 
C  show graph used for centering
      IF (NOCURS.GT.1) THEN
C      
C  do nothing on degenerated rectangles
         IF ((ICUR1(1).EQ.ICUR2(1)).AND.(ICUR1(2).EQ.ICUR2(2))) THEN
            CALL STTDIS('increase size of cursor rectangle ...',99,STAT)
            GOTO 1000
         ENDIF
         SPIX(1) = NINT(PCUR1(1)) 
         SPIX(2) = NINT(PCUR1(2))  
         SPIX(3) = NINT(PCUR2(1))   
         SPIX(4) = NINT(PCUR2(2))   
         BOX(1) = ICUR1(1)
         BOX(2) = ICUR1(2)
         BOX(3) = ICUR2(1)
         BOX(4) = ICUR2(2)
      ELSE
         NN = NINT(PCUR1(1)) 
         SPIX(1) = NN - XL
         IF (SPIX(1).LT.1) SPIX(1) = 1       !check limits
         SPIX(3) = NN + XU
         IF (SPIX(3).GT.NPIX(1)) SPIX(3) = NPIX(1)
         NN = NINT(PCUR1(2)) 
         SPIX(2) = NN - YL
         IF (SPIX(2).LT.1) SPIX(2) = 1
         SPIX(4) = NN + YU
         IF (SPIX(4).GT.NPIX(2)) SPIX(4) = NPIX(2)
         PCUR1(1) = SPIX(1)                  !frame pixels of rectangle
         PCUR1(2) = SPIX(2)
         PCUR2(1) = SPIX(3)
         PCUR2(2) = SPIX(4)
         CALL PIXXCV('_RS',0,PCUR1,STAT)         !convert to screen pixels
         IF (STAT.NE.0) GOTO 1010
         CALL PIXXCV('_RS',0,PCUR2,STAT)
         IF (STAT.NE.0) GOTO 1010
         BOX(1) = PCUR1(5) 
         BOX(2) = PCUR1(6) 
         BOX(3) = PCUR2(5)
         BOX(4) = PCUR2(6) 
         CALL PIXXCV('_RW',0,PCUR1,STAT)         !we also need world coordinates
         IF (STAT.NE.0) GOTO 1010
         CALL PIXXCV('_RW',0,PCUR2,STAT)
         IF (STAT.NE.0) GOTO 1010
         RVALS(1) = PCUR1(5)                   
         RVALS(2) = PCUR1(6)
         RVALS(3) = PCUR2(5)
         RVALS(4) = PCUR2(6)
      ENDIF
C 
C  get more precise wco's
      DIN(1) = PCUR1(1) 
      DIN(2) = PCUR1(2) 
      CALL FPXWCO(1,IMNO,DIN,DVALS(1),STAT)
      DIN(1) = PCUR2(1) 
      DIN(2) = PCUR2(2) 
      CALL FPXWCO(1,IMNO,DIN,DVALS(3),STAT)
C 
C  draw surrounding rectangle
      CALL DRAWCN(DRAWY,BOX,OLDBOX,STAT)
      IF (STAT.NE.0) THEN
         WRITE(CBUF,20002) NCOU
         CALL STTDIS(CBUF,99,STAT)
         NCOU = NCOU + 1
         GOTO 1000
      ENDIF
C
C  continue at common section
      IF (SPIX(2).EQ.SPIX(4)) ONEDIM = 1
      NMAL = NMAL + 1                              !update coords. counter
      GOTO 3000
C
C  --------------------------------------------------------------------
C
C
C  c) subimage around xfpix,yfpix
C
C
C  --------------------------------------------------------------------
C
1500  CALL STKRDI('INPUTI',1,2,IAV,NW,UNI,NULO,STAT)
      N = FRPIX(1) - NW(1)/2                     !get start of window
      IF (N.LE.0) N = 1
      IF (ONEDIM.EQ.1) THEN
         NN = 1
      ELSE
         NN = FRPIX(2) - NW(2)/2
         IF (NN.LE.0) NN = 1
      ENDIF
      SPIX(1) = N
      SPIX(2) = NN
C
      N = N  + NW(1)                               !get end of window
      IF (N.GT.NPIX(1)) N = NPIX(1)
      IF (ONEDIM.EQ.1) THEN
         NN = 1
      ELSE
         NN = NN + NW(2)
         IF (NN.GT.NPIX(2)) NN = NPIX(2)
      ENDIF
      SPIX(3) = N
      SPIX(4) = NN
C
      DIN(1) = SPIX(1)
      DIN(2) = SPIX(2)
      CALL FPXWCO(1,IMNO,DIN,DOUT,STAT)          !move from fp's to wco's
      IF (STAT.NE.0) THEN
         WRITE(CBUF,10070) DIN(1),DIN(2)
         CALL STTPUT(CBUF,STAT)
      ENDIF
      DVALS(1) = DOUT(1)
      DVALS(2) = DOUT(2)
      DIN(1) = SPIX(3)
      DIN(2) = SPIX(4)
      CALL FPXWCO(1,IMNO,DIN,DOUT,STAT)
      IF (STAT.NE.0) THEN
         WRITE(CBUF,10070) DIN(1),DIN(2)
         CALL STTPUT(CBUF,STAT)
      ENDIF
      DVALS(3) = DOUT(1)
      DVALS(4) = DOUT(2)
      DO 1800,IAV=1,4
         RVALS(IAV) = REAL(DVALS(IAV))
1800  CONTINUE
      NMAL = 1                                   !maybe we write a row to table
      GOTO 3000
C 
C  --------------------------------------------------------------------
C      
C      
C  d) table defined subimage(s) 
C      
C      
C  --------------------------------------------------------------------
C 
2000  NOCURS = 2
      CALL TBIGET(TIDA,N,NROW,N,N,N,STAT)            !get total no. of rows
      IF (NROW .LT. 1) CALL STETER (8,' Empty input table...')
C 
      CALL TBLSER(TIDA,LABEL(1),INCOLN(1),STAT)      !look for :XSTART
      IF (INCOLN(1).LE.0) THEN
         IF (GAUS1 .EQ. 1) THEN
            CALL TBLSER(TIDA,'START ',INCOLN(1),STAT)   !look for :START
            IF (INCOLN(1).LE.0) THEN
               CBUF(1:) = 'Neither column :XSTART nor :START '//
     +                    'in input table found...'
               CALL STETER(4,CBUF)
            ELSE
               IF (OUTFL.EQ.2) THEN
                  CALL TBCINI(TIDA,D_R8_FORMAT,1,'E24.15',TABUNI(1),
     +                        LABEL(1),OUCOLN(1),STAT)
                  REWRITE = 1
               ENDIF
            ENDIF
         ELSE
            CALL TBLSER(TIDA,GLABEL,INCOLN(1),STAT)     !look for :X_POSITION
            IF (INCOLN(1).LE.0) THEN
               CBUF(1:) = 'Neither column :XSTART nor :X_POSITION '//
     +                    'in input table found...'
               CALL STETER(4,CBUF)
            ELSE
               ONEDIM = 1
               NOCURS = 1                 !only 1 value (start/end) per row
               NROW = 2 * (NROW/2)        !so make sure NROW is a multiple of 2
               GOTO 2080
            ENDIF
         ENDIF
      ENDIF
C 
      IF (ONEDIM.EQ.1) THEN
         CALL TBLSER(TIDA,LABEL(3),INCOLN(2),STAT)       !look for :XEND 
         IF (INCOLN(2).LE.0) THEN
            IF (GAUS1 .EQ. 1) THEN
               CALL TBLSER(TIDA,'END ',INCOLN(2),STAT)   !look for :END
               IF (INCOLN(2).LE.0) THEN
                  CBUF(1:) = 'Neither column :XEND nor :END '//
     +                    'in input table found...'
                  CALL STETER(4,CBUF)
               ELSE
                  IF (OUTFL.EQ.2) THEN
                     CALL TBCINI(TIDA,D_R8_FORMAT,1,'E24.15',TABUNI(3),
     +                           LABEL(3),OUCOLN(3),STAT)
                     REWRITE = 1
                  ENDIF
               ENDIF
            ENDIF
         ENDIF
      ELSE
         DO 2040 IAV=2,4                  !look for :YSTART,:XEND,:YEND
            CALL TBLSER(TIDA,LABEL(IAV),INCOLN(IAV),STAT)
            IF (INCOLN(IAV).LE.0) THEN
               CBUF(1:) = 'column labelled '//LABEL(IAV)//
     +                    ' is missing in input table...'
               CALL STETER(4,CBUF)
            ENDIF
2040     CONTINUE
      ENDIF
C      
C  look for IDENT column 
2080  CALL TBLSER(TIDA,LABEL(17),INCOLN(17),STAT)
      IF (INCOLN(17).NE.-1) THEN
         IDYES = 1
      ELSE
         IDYES = 0
         IF ((OUTFL.EQ.2).AND.(GAUS1.EQ.0))
     +      CALL TBCINI(TIDA,D_C_FORMAT,8,'A8',
     +                  TABUNI(17),LABEL(17),OUCOLN(17),STAT)
      ENDIF
C      
C  here we loop
2100  NMAL = NMAL + 1
      IF (NMAL.GT.NROW) THEN                  !test for end of table
         WRITE(CBUF,10001) NCOU,' table entries processed '
         CALL STTPUT(CBUF,STAT)
         GOTO 9000
      ENDIF
C      
C  get next row of values + read as double data
      CALL TBSGET(TIDA,NMAL,SELFLG,STAT)
      IF (.NOT.SELFLG) GOTO 2100
C 
      IF (IDYES.EQ.1) THEN
         CALL TBERDC(TIDA,NMAL,INCOLN(17),CTEST,TABNUL,STAT)
         CALL FT_EOS(CTEST,8,IDF,STAT)       !get clean Fortran string
      ELSE
         WRITE(IDF(3:),10010) NMAL
      ENDIF
C      
      IF (ONEDIM.NE.1) THEN
         CALL TBRRDD(TIDA,NMAL,4,INCOLN,DVALS(1),TABNUL,STAT)
         DIN(1) = DVALS(1)                   !convert from wco's to fp's
         DIN(2) = DVALS(2)
         CALL FPXWCO(-1,IMNO,DIN,DOUT,STAT)
         IF (STAT.NE.0) THEN
            WRITE(CBUF,10077) NMAL
            CALL STTPUT(CBUF,STAT)
            GOTO 2100
         ENDIF
         SPIX(1) = NINT(DOUT(1))
         SPIX(2) = NINT(DOUT(2))
         DIN(1) = DVALS(3)
         DIN(2) = DVALS(4)
         CALL FPXWCO(-1,IMNO,DIN,DOUT,STAT)
         IF (STAT.NE.0) THEN
            WRITE(CBUF,10077) NMAL
            CALL STTPUT(CBUF,STAT)
            GOTO 2100
         ENDIF
         SPIX(3) = NINT(DOUT(1))
         SPIX(4) = NINT(DOUT(2))
      ELSE
         IF (NOCURS.EQ.1) THEN
            CALL TBRRDD(TIDA,NMAL,1,INCOLN,DVALS(1),TABNUL,STAT)
            DIN(1) = DVALS(1)
            CALL FPXWCO(-1,IMNO,DIN,DOUT,STAT)
            IF (STAT.NE.0) THEN
               WRITE(CBUF,10077) NMAL
               CALL STTPUT(CBUF,STAT)
               GOTO 2100
            ENDIF
            SPIX(1) = NINT(DOUT(1))
            NMAL = NMAL + 1
            CALL TBRRDD(TIDA,NMAL,1,INCOLN,DVALS(3),TABNUL,STAT)
            DIN(1) = DVALS(3)
            CALL FPXWCO(-1,IMNO,DIN,DOUT,STAT)
            IF (STAT.NE.0) THEN
               WRITE(CBUF,10077) NMAL
               CALL STTPUT(CBUF,STAT)
               GOTO 2100
            ENDIF
            SPIX(3) = NINT(DOUT(1))
         ELSE
            CALL TBRRDD(TIDA,NMAL,2,INCOLN,DVALS(1),TABNUL,STAT)
            DVALS(3) = DVALS(2)
            DIN(1) = DVALS(1)
            CALL FPXWCO(-1,IMNO,DIN,DOUT,STAT)
            IF (STAT.NE.0) THEN
               WRITE(CBUF,10077) NMAL
               CALL STTPUT(CBUF,STAT)
               GOTO 2100
            ENDIF
            SPIX(1) = NINT(DOUT(1))
            DIN(1) = DVALS(3)
            CALL FPXWCO(-1,IMNO,DIN,DOUT,STAT)
            IF (STAT.NE.0) THEN
               WRITE(CBUF,10077) NMAL
               CALL STTPUT(CBUF,STAT)
               GOTO 2100
            ENDIF
            SPIX(3) = NINT(DOUT(1))
         ENDIF

         DVALS(2) = 0.0                   !put into 2-dimj order
         DVALS(4) = 0.0
         SPIX(2) = 1
         SPIX(4) = 1
      ENDIF
C 
      DO 2200,IAV=1,4                     !save also in real array
         RVALS(IAV) = REAL(DVALS(IAV))
2200  CONTINUE
      NCOU = NCOU + 1
C      
C  +++++++++++++++++++++++++++++++++++++
C 
C  common section for option a) and b) and c)
C 
C  +++++++++++++++++++++++++++++++++++++
C
C  check subimages dimensions
3000  NPIXT(1) = SPIX(3) - SPIX(1) + 1            !get size of subimage
      NPIXT(2) = SPIX(4) - SPIX(2) + 1
      XOFF = SPIX(1) - 1.
      YOFF = SPIX(2) - 1.
      INBUF(1) = NPIX(1)
      INBUF(2) = NPIXT(2)
      INBUF(3) = 1
C
      IF (NPIXT(1).LT.3) THEN
         CBUF(1:) = 'x-dimension < 3 pixels -'//
     +                 ' subimage skipped...'
         CALL STTPUT(CBUF,STAT)
         GOTO 7000
      ELSE IF (NPIXT(2) .GT. MAPROW) THEN
         CALL STFYMP(-1,D_R4_FORMAT,TIMNO,PNTRA,STAT) 
         MAPROW = NPIXT(2)
         N = NPIX(1)*MAPROW
         CALL STFYMP(N,D_R4_FORMAT,TIMNO,PNTRA,STAT)
      ENDIF
      IF ((NPIXT(1)*NPIXT(2)).GT.40000) THEN         !200 * 200 max. subwindow
         CBUF(1:) = 'subimage > 200*200 pixels - subimage skipped... '
         CALL STTPUT(CBUF,STAT)
         GOTO 7000
      ENDIF
C
      NCOOS = NCOOS + 1                        !increment coord. counter
C 
C  if 1-dim Gauss method, take different algorithm
      IF (GAUS1.EQ.1) THEN
         IF (INVFLG.EQ.1)
     +      CALL UPSIDE(MADRID(PNTRA),NPIX(1),XCUTS)  !move to `normal' Gaussian

         CALL PLFIND(MADRID(PNTRA),START(1),STEP(1),SPIX(1),SPIX(3),
     +             1,-1,DVALS(5),DVALS(8),KSTAT,W1,W2,ACOE,
     +             DVALS(9),DVALS(10))
C
         RVALS(1) = REAL(DVALS(1))
         RVALS(2) = REAL(DVALS(3))
         XOUT = REAL(DVALS(5))
         RVALS(3) = XOUT
         ICENT = REAL(DVALS(8))
         RVALS(4) = ICENT
         XFWHM = REAL(ACOE(3))
         RVALS(5) = XFWHM
         XSIG = XFWHM/2.35482
         RVALS(6) = XSIG
         DVALS(6) = 0.D0
C
         WRITE (CBUF,29000) RVALS(1),RVALS(2),XOUT,XFWHM,XSIG,ICENT
         CALL STTPUT(CBUF,STAT)
         IAV = 6
         GOTO 6600
      ENDIF
C
C  get a y-stripe from disk + copy subwindow out
      N = INBUF(1) * INBUF(2)               !size of y-dim stripe in frame
      NN = ((SPIX(2)-1)*NPIX(1)) + 1        !1. pixel in there
      IF ((ONEDIM.NE.1).OR.(FIRTIM.EQ.0))
     +   CALL STFGET(IMNO,NN,N,IAV,MADRID(PNTRA),STAT)
      FIRTIM = 1
C
      ALOW(1) = SPIX(1)                     !first x,y pixel in source
      ALOW(2) = 1                           !and destination frame
      HIGH(1) = SPIX(3)
      HIGH(2) = NPIXT(2)

      CALL COPWND(MADRID(PNTRA),INBUF(1),MADRID(PNTRC),NPIXT,
     +            ALOW,BLOW,HIGH)

      IF (INVFLG.EQ.1) 
     +   CALL UPSIDE(MADRID(PNTRC),NPIXT,XCUTS)  !move to `normal' Gaussian
C      
C  actual centering algorithm
C      
      CPIX(1) = 1                             !xstart
      CPIX(2) = NPIXT(1)                      !xend
      CPIX(3) = 1                             !ystart
      CPIX(4) = NPIXT(2)                      !yend
C 
      IF (METHOD(1:1) .EQ. 'I') THEN
         CALL IQEFUN(MADRID(PNTRC),NPIXT,RBUF(1),RBUF(11),KSTAT)
         RV = 1.0                             !added to offset later on
         XOUT = RBUF(1)
         XSIG = RBUF(2)/2.35482
         XERR = RBUF(11)
         YOUT = RBUF(3)
         YSIG = RBUF(4)/2.35482
         YERR = RBUF(13)
         ICENT = RBUF(6)
         ANGLE = RBUF(5)
         ANGSIG = RBUF(15)
         IF (XSIG .GE. YSIG) THEN             !the larger one -> major axis
            AXMAJ = RBUF(2)*STEP(1)
            AXMIN = RBUF(4)*STEP(2)
         ELSE
            AXMAJ = RBUF(4)*STEP(2)
            AXMIN = RBUF(2)*STEP(1)
         ENDIF
      ELSE
         CALL STACEN(MADRID(PNTRC),NPIXT(1),NPIXT(2),METHOD,CPIX,
     +               XOUT,YOUT,XERR,YERR,XSIG,YSIG,ICENT,KSTAT)
         RV = 0.0
         ANGLE = 0.0
         ANGSIG = 0.0
      ENDIF
C 
C  check status
      XOUT = XOUT + XOFF + RV                  !relate to complete frame
      IF (KSTAT.EQ.0) THEN
         CSTAT(1:) = ' '
         XERR = XERR*ABS( STEP(1) )
         XSIG = XSIG*ABS( STEP(1) )
         XFWHM = XSIG*2.35482
      ELSE 
         XERR = 0.
         XSIG = 0.
         XFWHM = 0.
         IF (KSTAT.LT.0) THEN                  !must be from IQEFUN
            CSTAT(1:) = 'estimation failed '
         ELSE IF (KSTAT.EQ.1) THEN
            CSTAT(1:) = 'ambiguos sources '
         ELSE IF (KSTAT.EQ.2) THEN
            CSTAT(1:) = 'no source '
         ELSE IF (KSTAT.EQ.3) THEN
            CSTAT(1:) = 'iteration failed '
         ELSE
            CSTAT(1:) = 'routine error '
         ENDIF
      ENDIF
C 
      DIN(1) = XOUT
      IF (NPIXT(2).GT.1) THEN
         YOUT = YOUT + YOFF + RV               !relate to complete frame
         IF (KSTAT.EQ.0) THEN
            YERR = YERR*ABS( STEP(2) )
            YSIG = YSIG*ABS( STEP(2) )       
            YFWHM = YSIG*2.35482
         ELSE
            YERR = 0.
            YSIG = 0.
            YFWHM = 0.
         ENDIF
         DIN(2) = YOUT
      ELSE
         YERR = 0.
         YSIG = 0.
         YFWHM = 0.
         DIN(2) = SPIX(2)
      ENDIF
      CALL FPXWCO(1,IMNO,DIN,DVALS(5),STAT)
      XOUT = REAL(DVALS(5))                   !DVALS(1 - 4) hold are coords
      YOUT = REAL(DVALS(6))
C
C  for cursor input draw numbers...
      IF ( (INFLAG.EQ.1) .AND. (DRAWY(2).GT.1) ) THEN
         IF (IDFLAG.EQ.1) THEN
            LABL = IDF
            NN = 1
            LLABL = INDEX(LABL,' ') - 1
            IF (LLABL.LE.0) LLABL = LEN(LABL)
         ELSE
            WRITE(LABL(5:),10011) NCOOS
            NN = 5
            DO 3300 N=5,7
               IF (LABL(N:N).EQ.' ') NN = N + 1
3300        CONTINUE
            LLABL = 9 - NN
         ENDIF
C
         XYALP(2) = ICUR1(2) - 9                  !place string below
         N = ICUR2(1) - ICUR1(1)
         LLABL = 7 * LLABL
         IF (N.LE.LLABL) THEN
            XYALP(1) = ICUR1(1)
         ELSE
            N = (N-LLABL) / 2
            XYALP(1) = ICUR1(1) + N
         ENDIF
         CALL IIGTXT(QDSPNO,QOVCH,LABL(NN:),XYALP(1),XYALP(2),
     +               0,0,255,1,STAT)
      ENDIF
C
C Before we display the results, we should check if FWHM values make sense
      IF (  ( XFWHM .GT. (NPIXT(1) * ABS(STEP(1)) )  ) .OR.
     +      ( YFWHM .GT. (NPIXT(2) * ABS(STEP(2)) )  )     ) THEN
          KSTAT = 4
          CSTAT(1:) = 'FWHM exceeds size of image '
      ENDIF
      IF ((XFWHM .LT. 0.0) .OR. (YFWHM .LT. 0.0)) THEN
          KSTAT = 5
          CSTAT(1:) = 'Negative FWHM calculated '
      ENDIF
C
C  display results
      RVALS(5) = XOUT
      RVALS(6) = YOUT
      RVALS(7) = XERR
      RVALS(8) = YERR
      RVALS(9) = XSIG
      RVALS(10) = YSIG
      RVALS(11) = KSTAT
      RVALS(14) = ICENT
C 
      IAV = 14
      IF (CSTAT(1:1).EQ.' ') THEN
         IF (METHOD(1:1) .EQ.'I') THEN
            RVALS(12) = AXMAJ
            RVALS(13) = AXMIN
            RVALS(15) = ANGLE
            RVALS(16) = ANGSIG
            WRITE(CBUF,20100) RVALS(5),RVALS(6),RVALS(15),RVALS(16)
            CALL STTPUT(CBUF,STAT)
            WRITE(CBUF,20101) RVALS(12),RVALS(13),RVALS(14),IDF
            IAV = 16
         ELSE
            RVALS(12) = XFWHM
            RVALS(13) = YFWHM
            WRITE(CBUF,20100) RVALS(5),RVALS(6),RVALS(7),RVALS(8)
            CALL STTPUT(CBUF,STAT)
            WRITE(CBUF,20101) RVALS(12),RVALS(13),RVALS(14),IDF
         ENDIF
      ELSE
         RVALS(12) = 0.
         RVALS(13) = 0.
         WRITE(CBUF,20020) RVALS(5),RVALS(6),CSTAT,IDF
      ENDIF
      CALL STTPUT(CBUF,STAT)
      CBUF = ' '                        !clear last line
      CALL STTPUT(CBUF,STAT)
C      
6600  CALL STKWRR('OUTPUTR',RVALS(1),1,IAV,UNI,STAT)
      CALL STKWRD('OUTPUTD',DVALS(1),1,6,UNI,STAT)
C
C  fill descriptor, table or nothing
      IF (OUTFL.EQ.1) THEN
         CALL STDWRR(IMNO,DESCR,RVALS,FELEM,IAV,UNI,STAT)      !fill descr
         FELEM = -1
C      
      ELSE IF (OUTFL.GT.1) THEN
         IF (OUTFL.EQ.2) THEN                    !same table 
            IAV = 5
            NN = NMAL                            !use same rows
         ELSE                                    !different table
            IAV = 1
            IF (OUTFL.EQ.4) THEN
               NAPP = NAPP + 1
               NN = NAPP                         !append new rows
            ELSE                                 !use sequential, new rows
               IF (INFLAG.NE.2) THEN             !no table input
                  NN = NMAL
               ELSE
                  NN = NCOU                      !table input 
               ENDIF
            ENDIF
         ENDIF
C 
         IF (GAUS1.EQ.1) THEN
            IF ((REWRITE.EQ.1).OR.(OUTFL.EQ.3)) THEN 
               CALL TBRWRD(TIDB,NN,1,OUCOLN(1),DVALS(1),STAT) 
               CALL TBRWRD(TIDB,NN,1,OUCOLN(3),DVALS(3),STAT) 
            ENDIF
            CALL TBRWRD(TIDB,NN,1,OUCOLN(5),DVALS(5),STAT) 
            CALL TBRWRR(TIDB,NN,1,OUCOLN(9),XSIG,STAT)    
            CALL TBRWRR(TIDB,NN,1,OUCOLN(11),XFWHM,STAT)    
            CALL TBRWRR(TIDB,NN,1,OUCOLN(13),ICENT,STAT)    
         ELSE
            YL = 7 - IAV                            !write 6 or 2 double columns
            CALL TBRWRD(TIDB,NN,YL,OUCOLN(IAV),DVALS(IAV),STAT) 
            IAV = 7
            CALL TBRWRR(TIDB,NN,4,OUCOLN(IAV),RVALS(IAV),STAT)    
            RV = KSTAT
            CALL TBRWRR(TIDB,NN,1,OUCOLN(14),RV,STAT)
            CALL TBRWRR(TIDB,NN,3,OUCOLN(11),RVALS(12),STAT)
            IF (METHOD(1:1) .EQ.'I') 
     +         CALL TBRWRR(TIDB,NN,2,OUCOLN(15),RVALS(15),STAT)
            CALL TBEWRC(TIDB,NN,OUCOLN(17),IDF,STAT)
         ENDIF
      ENDIF
C      
C  and loop again
7000  IF (INFLAG.EQ.1) THEN
         IF (NMAL.LT.NLIM) GOTO 1000
      ELSE IF (INFLAG.EQ.2) THEN
         GOTO 2100
      ENDIF
C  
C  That's it folks...
9000  IF (OUTFL.EQ.3) CALL TBSINI(TIDB,STAT)
      IF (TIDB.GE.0) THEN
         IF (ACTION(1:1).EQ.'G') THEN
            IDENT(1:) = 'GAUSS '
            N = 5
         ELSE IF (ACTION(1:1).EQ.'I') THEN
            IDENT(1:) = 'IQE '
            N = 3
         ELSE
            IDENT(1:) = 'MOMENT '
            N = 6
         ENDIF
         CBUF(1:) = 
     +   'From CENTER/'//IDENT(1:N)//' using frame: '//FRAME
         CALL STDWRC(TIDB,'HISTORY',1,CBUF,-1,80,UNI,STAT)
      ENDIF
C      
      IF (INFLAG.EQ.1) THEN
         CALL DTCLOS(QDSPNO)
         CALL REFOVR(STAT)                      !refresh overlay
      ENDIF
C      
C  save no. of coordinates obtained for subsequent applications
      CALL STKWRI('OUTPUTI',NCOOS,1,1,UNI,STAT)
      CALL STSEPI
C      
C  format statements
10001 FORMAT(I4,A)
10010 FORMAT(I4.4)
10011 FORMAT(I4)
10070 FORMAT('bad coord(s) - X, Y: ',2F20.10)
10077 FORMAT('row no. ',I5,' contains bad coord(s) - we skip ...')
20000 FORMAT(G10.4,1X,G10.4,1X,G8.2,1X,G8.2,1X,G9.3,1X,G9.3,
     +       1X,G10.4,1X,A8)
20002 FORMAT(I4,' cursor rectangle too small...')
20020 FORMAT(G10.4,1X,G10.4,10X,A,8X,A)
20100 FORMAT(G14.8,1X,G14.8,1X,G12.5,2X,G12.5)
20101 FORMAT(32X,G12.5,1X,G12.5,2X,G12.5,1X,A8)
29000 FORMAT(3F13.3,3G13.5)
C 
      END         

      SUBROUTINE UPSIDE(A,MPIX,RMAX)
C
      IMPLICIT NONE
C
      REAL   A(*),RMAX
C 
      INTEGER MPIX(2)
      INTEGER  N, OFF
C 
      OFF = 1
      DO 1000,N=1,MPIX(1)*MPIX(2)
         A(OFF) = RMAX - A(OFF)
         OFF = OFF + 1
1000  CONTINUE
C 
      RETURN
      END         

      SUBROUTINE DRAWCN(DRAWY,NBOX,OLDBOX,STAT)
C
      IMPLICIT NONE
C
      INTEGER      DRAWY(3),NBOX(4),OLDBOX(4),STAT
      INTEGER      INFO(11)
      INTEGER      BOX(4)
      INTEGER      OFIGX(5),OFIGY(5)
      INTEGER      OFAGX(5),OFAGY(5)
      INTEGER      NPO,NAPO
      INTEGER      DSPNO,OVL,ZOOM,N
      INTEGER      XOFF,YOFF
      INTEGER      SIZE,SIZEA
C 
      REAL         RTEMP(2) 
C
      INCLUDE  'MID_INCLUDE:IDIDEV.INC'
      INCLUDE  'MID_INCLUDE:IDIMEM.INC'
C 
      DATA    RTEMP  /-1.0,-1.0/
C
C  test DRAWY options
      STAT = 0
      ZOOM = 0
      XOFF = 0
      YOFF = 0
C
C  here for start up - update disp no. + overlay, if we use aux_window
      IF (DRAWY(1).EQ.-1) THEN
         DRAWY(1) = 0
         IF (DRAWY(3).EQ.1) THEN
            CALL AUXWND(6,INFO,BOX,BOX,STAT)
            DSPNO = INFO(1)                !get display no. of aux_window
            OVL = 1
         ELSE
            DSPNO = QDSPNO                 !use main window
            OVL = QOVCH
            ZOOM = 1
            XOFF = 0
            YOFF = 0
         ENDIF
C
C  here for DRAWY(1) = 0
      ELSE
         DO 200 N=1,4                        !check, if cursor moved
            IF (NBOX(N).NE.OLDBOX(N)) GOTO 1000
200      CONTINUE
         RETURN                              !nothing to do...
      ENDIF
C
C  test, if we use aux_window
1000  IF (DRAWY(3).EQ.1) THEN
         CALL IIMCMY(DSPNO,OVL,1,0,STAT)
         CALL AUXWND(6,INFO,BOX,BOX,STAT)
         ZOOM = INFO(4)
         XOFF = INFO(6)                 !lower left screen pixel of
         YOFF = INFO(7)                 !extracted square
      ENDIF
C
C  get center and size of new box
      SIZE = NBOX(3) - NBOX(1) + 1
      SIZEA = NBOX(4) - NBOX(2) + 1
      IF (SIZE.GT.SIZEA) SIZE = SIZEA        !take min of x-, y-size
C
C  build + draw box for aux_window + main display
      IF (DRAWY(3).EQ.1) THEN
         BOX(1) = (NBOX(1) - XOFF) * ZOOM            !take out offset
         BOX(2) = (NBOX(2) - YOFF) * ZOOM            !of extracted zoom square
         BOX(3) = (NBOX(3) - XOFF) * ZOOM            !and
         BOX(4) = (NBOX(4) - YOFF) * ZOOM            !adapt to zoom factor
         CALL BLDGRA('REC',BOX,RTEMP,OFAGX,OFAGY,5,NAPO)   
         CALL IIGPLY(DSPNO,OVL,OFAGX,OFAGY,NAPO,255,1,STAT)
      ENDIF
      IF (DRAWY(2).EQ.1) THEN                        !box for original channel
         CALL BLDGRA('REC',NBOX,RTEMP,OFIGX,OFIGY,5,NPO) 
         CALL IIGPLY(QDSPNO,QOVCH,OFIGX,OFIGY,NPO,255,1,STAT)
      ENDIF
C
C  finally update OLDBOX
      DO 5000, N=1,4
         OLDBOX(N) = NBOX(N)
5000  CONTINUE
C
C  that's it folks...
C
      STAT = 0
      RETURN
      END

C @(#)ftrdpr.for	19.1 (ES0-DMD) 02/25/03 13:17:36
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FTRDPR(ISEQ,NAME,NPAR,PAR,ERR,FIX,ISTAT)                       
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                   
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:25 - 13 JAN 1988                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C.IDENTIFICATION                                                                
C                                                                               
C  FITLIB.FOR   VERSION 1.0  27 MAR 1984                                        
C                                                                               
C.PURPOSE                                                                       
C                                                                               
C  INTERFACE ROUTINES FOR THE FITTING STRUCTURES                                
C READ FUNCTION PARAMETERS, ACCESS BY SEQ.NO.                                   
C                                                                               
C.ALGORITHM                                                                     
C                                                                               
C  USE MIDAS I/O INTERFACES TO FRAMES AND TABLES                                
C                                                                               
C.KEYWORDS                                                                      
C                                                                               
C  NON LINEAR FITTING                                                           
C                                                                               
C                                                                               
C----------------------------------------------------------------               
C                                                                               
C                                                                               
C INPUT PARAMETERS                                                              
C ISEQ INTG SEQ.NO. OF THE FUNCTION                                             
C                                                                               
C OUTPUT PARAMETERS                                                             
C NAME CHAR FUNCTION NAME                                                       
C NPAR INTG NUMBER OF FUNCTION PARAMETERS                                       
C PAR DBLE ARRAY WITH PARAMETER VALUES                                          
C ERR DBLE ARRAY WITH ASSOCIATED ERRORS                                         
C FIX INTG ARRAY WITH FIXED FLAG (0    - CONSTANT)                              
C                         (>0   - CONSTR.POINTER)                               
C                  (<0   - VARIABLE)                                            
C ISTAT INTG STATUS RETURN                                                      
C                                                                               
      CHARACTER*(*) NAME                                                        
      INTEGER FIX(1),I,ISTAT,NPAR,NOFFSET,I1,ISEQ                                                            
      DOUBLE PRECISION PAR(1)                                                   
      DOUBLE PRECISION ERR(1)                                                   
       INCLUDE 'MID_INCLUDE:FITI.INC/NOLIST'                                     
       INCLUDE 'MID_INCLUDE:FITC.INC/NOLIST'                                     
      NAME   = FZFNAM(FZFCODE(ISEQ))                                        
      CALL FORUPC(NAME,NAME)
      NPAR   = FZACTPAR(ISEQ)                                                 
      NOFFSET = 0                                                               
      DO 10 I = 1,ISEQ - 1                                                      
          NOFFSET = NOFFSET + FZACTPAR(I)                                     
   10 CONTINUE                                                                  
      DO 20 I = 1,NPAR                                                          
          I1     = I + NOFFSET                                                  
          PAR(I) = FZVALUE(I1)                                                
          FIX(I) = FZFIXED(I1)                                                
          ERR(I) = FZERROR(I1)                                                
   20 CONTINUE                                                                  
      RETURN                                                                    
      END                                                                       

C @(#)partif.for	19.1 (ES0-DMD) 02/25/03 13:27:33
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C
C  program PARTIF.FOR
C  F.Murtagh,J.D.Ponz           ESO/ST-ECF - Garching
C                               VERSION 1.0     22 JAN 85
C  F.Murtagh.                   VERSION 2.0     16 JUN 86
C  F.Murtagh                    Version 3.0     3  AUG 88 (new std. i/f's.)
C  M.Peron                      Version 4.0     9 SEP 91
C.PURPOSE
C
C  Execute the command
C  PARTITION/TABLE  intable outable nclasses method ngrps seed
C
C.KEYWORDS
C
C  Tables, Cluster Analysis, Partitioning, Minimal Distance Algorithm,
C  Exchange Algorithm.
C
C.INPUT/OUTPUT
C
C  P1 - P6  contain input parameters
C
C.ALGORITHM
C
C . uses table interface routines
C . input table is assumed to contain entries in single precision,
C . no select or null values
C . description of clustering algorithm in the corresponding routine
C . the output of the command consists of
C   one column with the class number for each entry.
C
C-----------------------------------------------------------
        PROGRAM         PARTIF
C
        IMPLICIT INTEGER*4      (A-Z)
        INTEGER*4       NCLASS,METHOD,ITER,NNCOL,NROW
        REAL*4          CTOT
        CHARACTER*6     FORM
        CHARACTER*60     INTAB, OUTAB
        CHARACTER*16    LABEL,UNIT
        CHARACTER*80    LINE
        LOGICAL         INULL
        INTEGER         MADRID, KUN, KNUL, DTYPE
        INCLUDE         'MID_INCLUDE:TABLES.INC/NOLIST'
        COMMON          /VMR/MADRID(1)
        INCLUDE         'MID_INCLUDE:TABLED.INC/NOLIST'
        DATA            FORM/'I4'/,LABEL/'CL'/,UNIT/' '/ 
C
C ... GET INTO MIDAS
C
        CALL STSPRO('PARTIF')
        DTYPE = D_R4_FORMAT
C
C ... GET INPUT PARAMETERS
C
        CALL STKRDC('P1',1,1,60,IAV,INTAB,KUN,KNUL,ISTAT)
        CALL STKRDC('P2',1,1,60,IAV,OUTAB,KUN,KNUL,ISTAT)
        CALL STKRDI('INPUTI',1,1,IAV,NCLASS,KUN,KNUL,ISTAT)
        CALL STKRDI('INPUTI',2,1,IAV,METHOD,KUN,KNUL,ISTAT)
        CALL STKRDI('INPUTI',3,1,IAV,NGP0,KUN,KNUL,ISTAT)
        CALL STKRDI('INPUTI',4,1,IAV,ISEED,KUN,KNUL,ISTAT)
C
C ... READ INPUT TABLE
C
        CALL TBTOPN(INTAB, 16, TID1, ISTAT)
        CALL TBIGET(TID1,NCOL,NROW,NSC1,NAC,NAR,ISTAT)
C        CALL TBCMAP(TID1,0,IADD0,ISTAT)
        CALL CHSEL(TID1,NROW,NSEL)
        IF (NSEL.LE.0) THEN
          CALL STTPUT(' Empty table, check SELECT', ISTAT)
          GOTO 1000
        ENDIF
        IF (NSEL.NE.NROW) THEN
          WRITE(LINE,100) NSEL,NROW
          CALL STTPUT(LINE, ISTAT)
          STOP
        ENDIF
        NSEL = NROW
C
C ... CREATE OUTPUT TABLE
C
        NCOLOUT = NCOL + 1
        CALL TBTINI(OUTAB, F_TRANS, 17, NCOLOUT, NSEL, TID, ISTAT)
        DO I = 1, NCOL
          CALL TBFGET(TID1, I, FORM, LEN, DTYPE, ISTAT)
          IF (DTYPE.NE.D_R4_FORMAT) THEN
            CALL STTPUT(' Illegal format', ISTAT)
            CALL STTPUT(' Only R*4 column type allowed' , ISTAT)
            GOTO 1000
          ENDIF
          CALL TBCMAP(TID1,I,IADD1,ISTAT)
          CALL TBLGET(TID1, I, LABEL, ISTAT)
          CALL TBUGET(TID1, I, UNIT, ISTAT)
          CALL TBCINI(TID, DTYPE, 1, FORM, UNIT, LABEL, I1, ISTAT)
          CALL TBCMAP(TID,I1,IADD2,ISTAT)
          CALL CPYCOL(MADRID(IADD1), MADRID(IADD2), NROW)
        ENDDO
C
C ... CREATE CLUSTER COLUMN
C
        LABEL = 'CL'
        UNIT  = ' '
        FORM  = 'I4'
        CALL TBCINI(TID, DTYPE, 1, FORM, UNIT, LABEL, I1, ISTAT)
C
C ... GET ADDRESSES
C
C     DATA ARRAY ADDRESS
        CALL TDMGET(4*NCOL*NSEL,IWADD1,ISTAT)
        CALL TBIGET(TID,NNCOL,NNROW,NSC1,NAC,NAR,ISTAT)
        CALL TBCMAP(TID,1,IADD1,ISTAT)
        CALL MAPSM(MADRID(IADD1),MADRID(IWADD1),
     1              NAR,NSEL,NCOL)
C
C ... CHECK IF NULL VALUE
C
        NDAT = NCOL*NSEL
        CALL CHECK(MADRID(IWADD1),NDAT,INULL)
        IF (INULL) THEN
          CALL STTPUT(' Null entries in the table are not allowed'
     .                     , ISTAT)
          CALL STTPUT(' Use the SELECT command ' , ISTAT)
          GOTO 1000
        ENDIF
C     CLASS ARRAY ADDRESS
        CALL TBCMAP(TID, NCOL+1, IADD2, ISTAT)
C
        LENSTOR = (NCLASS*NCOL + NCLASS + NSEL)
        CALL TDMGET(4*LENSTOR,IWORK1,ISTAT)
        CALL TDMGET(4*NCLASS*NCOL,IWORK2,ISTAT)
        CALL TDMGET(4*NCLASS,IWORK3,ISTAT)
C
C ... ALGORITHM
C
        IWORK2 = IWORK1 +4*NCLASS*NCOL
        IWORK3 = IWORK2 +4*NCLASS
        CALL RANDP(NSEL,NCLASS,MADRID(IADD2),ISEED)
        IF (METHOD.EQ.2) THEN
           CALL READIMA(MADRID(IWADD1),NSEL,NCOL)
           CALL EXCH(MADRID(IWADD1),NSEL,NCOL,MADRID(IADD2),
     X               NGP0,MADRID(IWORK3),MADRID(IWORK1),NCLASS,
     X               MADRID(IWORK2),
     X               CTOT,ITER,IERR)
        ELSE
           CALL MINDST(MADRID(IWADD1),NSEL,NCOL,MADRID(IADD2),
     X               NGP0,MADRID(IWORK3),MADRID(IWORK1),NCLASS,
     X               MADRID(IWORK2),
     X               CTOT,ITER,IERR)
        ENDIF
C
        IF (IERR.EQ.2) THEN
           CALL STTPUT
     X(' A group has < minimum allowed number of members.',ISTAT)
           CALL STTPUT
     X(' Reduce number of groups and try again.',ISTAT)
           STOP
        ENDIF
        IF (IERR.EQ.1) THEN
           CALL STTPUT(' Invalid group assignment has been detected',
     X                                                          ISTAT)
           CALL STTPUT(' (i.e. < 1 or > no. of groups).',ISTAT)
           CALL STTPUT(' Is the no. of gps. correctly specified?',
     X                                                          ISTAT)
           STOP
        ENDIF
        WRITE(LINE,140) CTOT, ITER
  140   FORMAT(' Sum of variances:',F16.4,'; No. of iterations:',I8)
        CALL STTPUT(LINE,ISTAT)

        CALL TDMFRE(4*LENSTOR,IWORK1,ISTAT)
        CALL TDMFRE(4*NCLASS*NCOL,IWORK2,ISTAT)
        CALL TDMFRE(4*NCLASS,IWORK3,ISTAT)
C
C ... CONVERT VALUES IN IADD2 FROM INTG*4 INTO REAL*4
C
        NTOT = NSEL
        CALL CONVERT(MADRID(IADD2),MADRID(IADD2),NTOT)
C
C ... COPY ORIGINAL ARRAY BACK INTO THE OUTPUT TABLE
C
        CALL TBCMAP(TID1,0,IADD0,ISTAT)
        DO I = 1, NCOL
          CALL TBCMAP(TID1,I,IADD1,ISTAT)
          CALL TBCMAP(TID,I,IADD2,ISTAT)
          CALL CPYCOL(MADRID(IADD1), MADRID(IADD2), NROW)
        ENDDO
C
C ... END
C
        CALL TBIPUT(TID,NCOLOUT,NSEL,ISTAT)
        CALL TBSINI(TID,ISTAT)
        CALL TBTCLO(TID,ISTAT)
        CALL TBTCLO(TID1,ISTAT)
1000    CONTINUE
        CALL STSEPI
100     FORMAT(' Must SELECT all rows',2I1)
200     FORMAT(' Selected ',I6,' rows from ',I6,' in total')
        END
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        SUBROUTINE CONVERT(INPUT,OUTPUT,NTOT)
C
C       CONVERT FROM INTEGER*4 TO REAL*4
C
        INTEGER         I,NTOT
        REAL*4          OUTPUT(NTOT)
        INTEGER*4       INPUT(NTOT)
C
        DO I = 1, NTOT
          OUTPUT(I) = FLOAT(INPUT(I))
        ENDDO
        RETURN
        END
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        SUBROUTINE CHECK(X,NDAT,INULL)
C
C       CHECK IF NULL VALUE
C
        INTEGER         I,NDAT
        REAL*4          X(NDAT), TRNULL
        INTEGER         TINULL
        DOUBLE PRECISION TDNULL
        LOGICAL         INULL
        CALL TBMNUL(TINULL,TRNULL,TDNULL)
C
        INULL = .FALSE.
        DO I = 1, NDAT
          IF(X(I).EQ.TRNULL) GOTO 10
        ENDDO
        RETURN
10      INULL = .TRUE.
        RETURN
        END
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        SUBROUTINE CPYCOL(A,B,N)   ! COPY COLUMN VECTOR
        INTEGER I,N
        REAL*4          A(N),B(N)
        DO I = 1,N
           B(I)=A(I)
        ENDDO
        RETURN
        END
        SUBROUTINE READIMA(A,NSEL,NCOL)
        INTEGER NSEL,NCOL,I,J
        REAL*4 A(NSEL,NCOL)
        DO 1000 J = 1,NCOL
          DO 2000 I = 1,NSEL
             WRITE(6,*)A(I,J)
2000      CONTINUE 
1000    CONTINUE
        RETURN
        END

C @(#)prf.for	19.1 (ES0-DMD) 02/25/03 14:29:02
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
CC
CC   *MOVE* : MOVES A CHARACTER FROM LEFT TO RIGHT
CC              (USED FOR ADJUSTING VARIABLE LABELS TO THE RIGHT)
CC
       SUBROUTINE MOVE(KARAK)

       INCLUDE 'MID_REL_INCL:implicit.inc'

       CHARACTER KARAK(10)
       NB=0
       DO 10 J=1,10
       JPL=11-J
       IF (KARAK(JPL).EQ.' ') NB=NB+1
C       write(6,*) 'JPL, KARAK,NB:',JPL,':',KARAK(JPL),':',NB
       IF((JPL.NE.1.AND.KARAK(JPL-1).NE.' ').OR.(NB.EQ.10))GOTO 20
 10    CONTINUE
 20    CONTINUE
C       write(6,*) 'MOVE/NB = ',NB
       IF(NB.EQ.10.OR.NB.EQ.0) RETURN
       NBM=10-NB
       DO 30 J=1,NBM
       JPB=NBM+1-J
       JPL=11-J
       KARAK(JPL)=KARAK(JPB)
       write(6,*) 'JPL, JPB, KARAK(JPL), KARAK(JPB), J',
     +             JPL, JPB, KARAK(JPL), KARAK(JPB), J
       KARAK(JPB)=' '
 30    CONTINUE
       RETURN
       END
CC
CC    *PVAL* : THIS IS A FORTRAN VERSION OF THE LACKRITZ ALGORITHM
CC             (AMERICAN STATISTICIAN 1984, VOL. 38, P.312-314)
CC             FOR CALCULATING THE ONE-SIDED TAIL AREA OF AN F-DISTRIBUTION
CC             WITH N1 AND N2 DEGREES OF FREEDOM. IMPLEMENTED BY
CC             J. VAN SOEST AND B. VAN ZOMEREN, JUNE 1986.
CC
       FUNCTION PVAL(F,N1,N2)

       INCLUDE 'MID_REL_INCL:implicit.inc'

       EXTERNAL SUM
       DOUBLE PRECISION F,PI
       DOUBLE PRECISION PVAL,SUM,T,TINV,T1,TINV1,DSUM,T5,A,B
       LOGICAL ODD
       DATA PI/3.14159265/
       IF(F.GT.(0.000001))GOTO 5
       PVAL=1.0
       RETURN
  5    T=N1*F/N2
       TINV=1/T
       T1=T+1
       TINV1=TINV+1
       IF (.NOT.ODD(N1) .AND. .NOT. ODD(N2)) THEN
          M1=N1/2
          M2=N2/2
          PVAL=SUM(M1-1,DBLE(M2-1),T/T1)/DEXP(DBLE(M2)*DLOG(T1))
       ENDIF
       IF (.NOT.ODD(N1).AND.ODD(N2)) THEN
           M1=N1/2
           M2=(N2-1)/2
           A=SUM(M1-1,DBLE(M2-0.5),T/T1)
           PVAL=A/DEXP(DBLE(M2+0.5)*DLOG(T1))
       ENDIF
       IF (ODD(N1).AND..NOT.ODD(N2)) THEN
           M1=(N1-1)/2
           M2=N2/2
           A=SUM(M2-1,DBLE(M1-0.5),TINV/TINV1)
           PVAL=1-A/DEXP(DBLE(M1+0.5)*DLOG(TINV1))
       ENDIF
       IF (ODD(N1).AND.ODD(N2)) THEN
           M1=(N1-1)/2
           M2=(N2-1)/2
           A=0.0
           IF (M1.GT.0) THEN
              DSUM=2*(DSQRT(T))/(PI*T1)
              DO 10 I=1,M2
                 DSUM=DSUM*DBLE(I)/(T1*DBLE(I-0.5))
 10                 CONTINUE
              A=DSUM
              DO 20 I=2,M1
                 DSUM=DSUM*T*2*DBLE(M2+I-1)/(T1*DBLE(2*I-1))
                 A=A+DSUM
 20                 CONTINUE
           ENDIF
           B=0.0
           IF (M2.GT.0) THEN
              DSUM=DSQRT(TINV)*2/(PI*TINV1)
              B=DSUM
              T5=2*TINV/TINV1
              DO 30 I=2,M2
              DSUM=DSUM*T5*DBLE(I-1)/DBLE(2*I-1)
              B=B+DSUM
 30              CONTINUE
           ENDIF
           PVAL=A-B+(2/PI)*DATAN(DSQRT(TINV))
       ENDIF
       RETURN
       END
CC
CC   *PTVAL* : FUNCTION (BASED ON THE FUNCTION PVAL) FOR CALCULATING
CC             THE TWO-SIDED TAIL AREA OF A STUDENT DISTRIBUTION
CC             WITH N DEGREES OF FREEDOM
CC
       FUNCTION PTVAL(TVAL,N)

       INCLUDE 'MID_REL_INCL:implicit.inc'

       DOUBLE PRECISION PTVAL
       DOUBLE PRECISION PVAL
       DOUBLE PRECISION TVAL
       PTVAL=PVAL(TVAL*TVAL,1,N)
       RETURN
       END
CC
CC   *SUM* : AUXILIARY FUNCTION (FOR FUNCTION PVAL)
CC
       FUNCTION SUM(N,F1,F2)

       INCLUDE 'MID_REL_INCL:implicit.inc'

       DOUBLE PRECISION SUM
       DOUBLE PRECISION F1,F2,DSUM,TSUM
       DSUM=1
       TSUM=1
       IF (N.NE.0) THEN
       DO 10 I=1,N
          DSUM=DSUM*(F1+I)*F2/I
          TSUM=TSUM+DSUM
 10    CONTINUE
       ENDIF
       SUM=TSUM
       RETURN
       END
CC
CC   *ODD* : AUXILIARY FUNCTION (FOR FUNCTION PVAL)
CC
       FUNCTION ODD(N)

       INCLUDE 'MID_REL_INCL:implicit.inc'

       LOGICAL ODD
       ODD=.TRUE.
       IF(2*(N/2).EQ.N) ODD=.FALSE.
       RETURN
       END
CC
CC  *GRAF* : PERFORMS RESIDUAL PLOTS AND/OR A PLOT OF THE
CC           OBSERVATIONS IN THE TWO-DIMENSIONAL CASE.
CC
       SUBROUTINE GRAF(X,Y,NCAS,JPLXY,JPL2,JPLT,NMVAL,NDXY,LUB,JREG,
     1 JHEAD,NDXX,NVAD,LAB)

       INCLUDE 'MID_REL_INCL:implicit.inc'

       DIMENSION X(NCAS),Y(NCAS),MGRAF(41,51),NMVAL(NDXY)
       CHARACTER JDRAW(51),NUM(14)
       CHARACTER*10 LAB(NDXX)
       CHARACTER*60 JHEAD
       LOGICAL ODD
       NUM(1)=' '
       NUM(2)='1'
       NUM(3)='2'
       NUM(4)='3'
       NUM(5)='4'
       NUM(6)='5'
       NUM(7)='6'
       NUM(8)='7'
       NUM(9)='8'
       NUM(10)='9'
       NUM(11)='*'
       NUM(12)='-'
       NUM(13)='+'
       NUM(14)=' '
       JXSCA=51
       JYSCA=41
       AFR=10.0E-02
       DO 10 J=1,JXSCA
       DO 10 K=1,JYSCA
 10    MGRAF(K,J)=0
       IF (JPLT.EQ.2.AND.JPLXY.NE.1) X(1)=NMVAL(1)
       XMIN=X(1)
       XMAX=X(1)
       YMAX2=2.5
       YKLE2=-2.5
       YKLE=Y(1)
       YMAX=Y(1)
       DO 20 JNC=1,NCAS
       IF (JPLT.EQ.2.AND.JPLXY.NE.1) X(JNC)=NMVAL(JNC)
       IF (X(JNC).GT.XMAX) XMAX=X(JNC)
       IF (X(JNC).LT.XMIN) XMIN=X(JNC)
       IF (Y(JNC).GT.YMAX) YMAX=Y(JNC)
       IF (Y(JNC).LT.YKLE) YKLE=Y(JNC)
 20    CONTINUE
       IF((YMAX-YKLE).LE.AFR.AND.JPLXY.EQ.1)THEN
         YKLE=YKLE-1.0
         YMAX=YMAX+1.0
       ENDIF
       IF (NVAD.EQ.2.AND.JPLXY.EQ.1) THEN
       IF(0.0.GT.XMAX)XMAX=0.0
       IF(0.0.LT.XMIN)XMIN=0.0
       IF(0.0.GT.YMAX)YMAX=0.0
       IF(0.0.LT.YKLE)YKLE=0.0
       ENDIF
 30    IF (YMAX.GT.2.5.OR.JPLXY.EQ.1.OR.(JPL2.EQ.0.AND.YKLE.NE.YMAX))
     1 YMAX2=YMAX
       IF (YKLE.LT.(-2.5).OR.JPLXY.EQ.1.OR.(JPL2.EQ.0.AND.YKLE.NE.YMAX))
     1 YKLE2=YKLE
       XSCA=JXSCA
       YSCA=JYSCA
       IF((XMAX-XMIN).LE.AFR)THEN
         XMIN=XMIN-1.0
         XMAX=XMAX+1.0
       ENDIF
 40    A=(XSCA-1.0)/(XMAX-XMIN)
       B=1.0-A*XMIN
       C=(YSCA-1.0)/(YMAX2-YKLE2)
       D=1.0-C*YKLE2
       IF (JPLXY.EQ.1) GOTO 50
       JNUL=INT(YSCA-D)
       IF ((JNUL.LE.1.OR.ABS(YMAX2).LT.AFR).AND.JPL2.NE.0) THEN
          J2P=1
          JNUL=2
          J2M=3
          GOTO 50
       ENDIF
       IF ((JNUL.GE.JYSCA.OR.ABS(YKLE2).LT.AFR).AND.JPL2.NE.0) THEN
          J2P=JYSCA-2
          JNUL=JYSCA-1
          J2M=JYSCA
          GOTO 50
       ENDIF
       IF (JPL2.EQ.0) THEN
          IF (JNUL.LE.1.OR.ABS(YMAX2).LE.AFR) JNUL=1
          IF (JNUL.GT.JYSCA.OR.ABS(YKLE2).LE.AFR) JNUL=JYSCA
       ENDIF
       IF ((JPL2.EQ.0.AND.YKLE.NE.YMAX)) GOTO 50
       J2P=INT(YSCA-(2.5*C+D))
       IF (JNUL.EQ.J2P) J2P=JNUL-1
       IF (ABS(YMAX2-2.5).LT.AFR) J2P=1
       IF (J2P.LE.0) THEN
          IF (ABS(YMAX2-2.5).LT.AFR) THEN
             J2P=1
                                     ELSE
             J2P=2
          ENDIF
       ENDIF
       IF (J2P.GT.JYSCA) J2P=JYSCA-2
       IF (ABS(YKLE2-2.5).LT.AFR) J2P=JYSCA-2
       J2M=2*JNUL-J2P
       IF (J2M.LE.0.OR.ABS(YMAX2+2.5).LT.AFR) THEN
          J2P=1
          JNUL=2
          J2M=3
          GOTO 50
       ENDIF
       IF (J2M.GT.JYSCA.OR.ABS(YKLE2+2.5).LT.AFR) THEN
          J2M=JYSCA
          JS=J2M+J2P
          IF (ODD(JS)) THEN
             J2P=J2P+1
          ENDIF
          JNUL=(J2M+J2P)/2
       ENDIF
 50    DO 110 JNC=1,NCAS
       XJNC=X(JNC)
       YJNC=Y(JNC)
 60    JX=INT(XJNC*A+B)
       IF (JX.LE.0) JX=1
       IF (JX.GT.JXSCA) JX=JXSCA
       IF(.NOT.(ABS(YJNC-YMAX2).LT.AFR.OR.ABS(YJNC-YKLE2).LT.AFR))
     1 GOTO 70
       IF (ABS(YJNC-YMAX2).LT.AFR) JEY=1
       IF (ABS(YJNC-YKLE2).LT.AFR) JEY=JYSCA
       IF (ABS(YJNC).LT.AFR.AND.JPLXY.EQ.0) JEY=JNUL
       GOTO 90
 70    JEY=INT(YSCA-(YJNC*C+D))
       IF (JPLXY.NE.1) THEN
         IF (ABS(YJNC).LT.AFR) JEY=JNUL
         IF (JEY.EQ.J2P.AND.YJNC.LT.(2.5-AFR)) JEY=J2P+1
         IF (JEY.EQ.J2P.AND.YJNC.GT.(2.5+AFR)) JEY=J2P-1
         IF (JEY.EQ.J2M.AND.YJNC.LT.(-2.5-AFR)) JEY=J2M+1
         IF (JEY.EQ.J2M.AND.YJNC.GT.(-2.5+AFR)) JEY=J2M-1
         IF (ABS(YJNC-2.5).LT.AFR.OR.(JEY.GT.J2P.AND.YJNC.GT.2.5)
     1            .OR.(JEY.LT.J2P.AND.YJNC.LT.2.5)) JEY=J2P
         IF (ABS(YJNC+2.5).LT.AFR.OR.(JEY.GT.J2M.AND.YJNC.GT.-2.5)
     1         .OR.(JEY.LT.J2M.AND.YJNC.LT.-2.5)) JEY=J2M
       ENDIF
 80    IF (JEY.LE.0) JEY=1
       IF (JEY.GT.JYSCA) JEY=JYSCA
 90    MGRAF(JEY,JX)=MGRAF(JEY,JX)+1
       IF(NUM(14).NE.'0') GOTO 100
       MGRAF(JEY,JX)=-20
       GOTO 120
 100   IF (.NOT.(JNC.EQ.NCAS.AND.JPLXY.EQ.1.AND.NVAD.EQ.2)) GOTO 110
       XJNC=0.0
       YJNC=0.0
       NUM(14)='0'
       GOTO 60
 110   CONTINUE
 120   IF (JREG.EQ.0) WRITE(LUB,8000) JHEAD
       IF (JREG.EQ.1) WRITE(LUB,8010) JHEAD
       IF (JREG.EQ.2) WRITE(LUB,8020) JHEAD
       IF (JREG.EQ.3) WRITE(LUB,8030) JHEAD
       IF (JPLXY.EQ.0.AND.JPL2.NE.0) WRITE(LUB,8050)
       IF (JPLXY.EQ.0.AND.JPL2.EQ.0) WRITE(LUB,8060)
       IF (JPLXY.EQ.1) WRITE(LUB,8070) LAB(NVAD)
       WRITE(LUB,8075)
       DO 240 J=1,JYSCA
       IF (JPLXY.EQ.1) GOTO 160
       IF(J.NE.JNUL) GOTO 140
       DO 130 K=1,JXSCA
       MJK=MGRAF(J,K)+1
       IF (MJK.EQ.1) JDRAW(K)=NUM(12)
       IF (MJK.GT.10) JDRAW(K)=NUM(11)
       IF (MJK.GE.2.AND.MJK.LE.10) JDRAW(K)=NUM(MJK)
 130   CONTINUE
       GOTO 180
 140   IF ((JPL2.EQ.0.AND.YKLE.NE.YMAX)) GOTO 160
       IF (J.NE.J2P.AND.J.NE.J2M) GOTO 160
       DO 150 K=1,JXSCA
       MJK=MGRAF(J,K)+1
       IF (MJK.EQ.1) JDRAW(K)=NUM(13)
       IF (MJK.GT.10) JDRAW(K)=NUM(11)
       IF (MJK.GE.2.AND.MJK.LE.10) JDRAW(K)=NUM(MJK)
 150   CONTINUE
       GOTO 180
 160   DO 170 K=1,JXSCA
       MJK=MGRAF(J,K)+1
       IF(MJK.GT.10) JDRAW(K)=NUM(11)
       IF(MJK.LE.10) JDRAW(K)=NUM(MJK)
       IF(MJK.LT.0) JDRAW(K)=NUM(14)
 170   CONTINUE
 180   JREST=MOD(J,5)
       IF (JPLXY.EQ.1) GOTO 190
       IF ((JPL2.EQ.0.AND.YKLE.NE.YMAX)) GOTO 190
       IF (J.NE.J2P) GOTO 190
       IF (JREST.EQ.1) WRITE(LUB,8080)(JDRAW(K),K=1,JXSCA)
       IF (JREST.NE.1) WRITE(LUB,8085)(JDRAW(K),K=1,JXSCA)
       GOTO 240
 190   IF (J.NE.1) GOTO 200
       WRITE(LUB,8130) YMAX2,(JDRAW(K),K=1,JXSCA)
       GOTO 240
 200   IF (JPLXY.EQ.1) GOTO 220
       IF (J.NE.JNUL) GOTO 210
       IF (JREST.EQ.1) WRITE(LUB,8090)(JDRAW(K),K=1,JXSCA)
       IF (JREST.NE.1) WRITE(LUB,8100)(JDRAW(K),K=1,JXSCA)
       GOTO 240
 210   IF (J.NE.J2M.OR.(JPL2.EQ.0.AND.YKLE.NE.YMAX)) GOTO 220
       IF (JREST.EQ.1) WRITE(LUB,8110) (JDRAW(K),K=1,JXSCA)
       IF (JREST.NE.1) WRITE(LUB,8120) (JDRAW(K),K=1,JXSCA)
       GOTO 240
 220   IF(J.NE.JYSCA) GOTO 230
       WRITE(LUB,8130) YKLE2,(JDRAW(K),K=1,JXSCA)
       GOTO 240
 230   IF (JREST.EQ.1) WRITE(LUB,8140)(JDRAW(K),K=1,JXSCA)
       IF (JREST.NE.1) WRITE(LUB,8150)(JDRAW(K),K=1,JXSCA)
 240   CONTINUE
       WRITE(LUB,8075)
       IF (JPLT.NE.2.OR.JPLXY.EQ.1) WRITE(LUB,8160) XMIN,XMAX
       IF ((JPLT.EQ.1.OR.JPLT.EQ.3).AND.JPLXY.EQ.0)
     1 WRITE(LUB,8170) LAB(NVAD)
       IF (JPLXY.EQ.1) WRITE(LUB,8180) LAB(1)
       IF (JPLT.NE.2.OR.JPLXY.EQ.1) GOTO 250
       J1=XMIN
       JN=XMAX
       WRITE(LUB,8190) J1,JN
       WRITE(LUB,8200)
 8000  FORMAT(//16X,A60)
 8010  FORMAT(//16X,A60//29X,'--- L E A S T  S Q U A R E S ---')
 8020  FORMAT(//16X,A60//20X,'--- L E A S T  M E D I A N  O F ',
     1 ' S Q U A R E S ---')
 8030  FORMAT(//16X,A60//13X,'--- R E W E I G H T E D',3X,'L S',6X,
     1 '( B A S E D',3X,'O N',3X,'L M S ) ---')
 8050  FORMAT(/'  STAND. RESIDUAL',1X,'I-+',10('----+'),'-I')
 8060  FORMAT(/7X,'RESIDUAL',3X,'I-+',10('----+'),'-I')
 8070  FORMAT(/6X,'OBSERVED'/6X,A10,2X,'I-+',10('----+'),'-I')
 8075  FORMAT(18X,'I',53X,'I')
 8080  FORMAT(14X,'2.5',1X,'++',51A1,'++')
 8085  FORMAT(14X,'2.5',1X,'I+',51A1,'+I')
 8090  FORMAT(14X,'0.0',1X,'+-',51A1,'-+')
 8100  FORMAT(14X,'0.0',1X,'I-',51A1,'-I')
 8110  FORMAT(13X,'-2.5',1X,'++',51A1,'++')
 8120  FORMAT(13X,'-2.5',1X,'I+',51A1,'+I')
 8130  FORMAT(6X,E11.4,1X,'+',1X,51A1,1X,'+')
 8140  FORMAT(18X,'+',1X,51A1,1X,'+')
 8150  FORMAT(18X,'I',1X,51A1,1X,'I')
 8160  FORMAT(18X,'I-+',10('----+'),'-I'/10X,E11.4,46X,E11.4)
 8170  FORMAT(/49X,'ESTIMATED ',A10//)
 8180  FORMAT(/54X,'OBSERVED ',A10//)
 8190  FORMAT(18X,'I-+',10('----+'),'-I'/17X,I4,46X,I4)
 8200  FORMAT(/48X,' INDEX OF THE OBSERVATION'//)
 250   RETURN
       END

C @(#)driver.for	19.1 (ES0-DMD) 02/25/03 13:29:07
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C  @(#)driver.for	19.1  (ESO-IPG)  02/25/03  13:29:07
         PROGRAM DRIVER
C
C       tests subroutines converted to MIDAS style
C
C
      IMPLICIT REAL (A-H,O-Z)
      IMPLICIT INTEGER (I-N)
C
      COMMON /FILNOS/ KB, KTV, K2, K3, K4, K7, K8, K9
C
        CHARACTER*40 STRING
C
C               in MIDAS:  RUN DRIVER   (to test subroutines)
C
        CALL STSPRO ('DRIVER')
        KB=5
        KTV=6
C
        CALL ASKFIL('Enter a lower-case filename:',STRING)
        CALL TV('Filename was read as:')
        CALL TVN(STRING)
        CALL ASK('Enter a string:',STRING)
        CALL TV('String was read as:')
        CALL TVN(STRING)
        CALL QF('Enter a real number:',VALUE)
        WRITE(STRING,'(G10.4)') VALUE
        CALL TV('value was read as: '//STRING)
        CALL STSEPI
        END

C===========================================================================
C Copyright (C) 1995-2011 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C 
C.VERSION
C 110216	last modif
C 
C===========================================================================
C
      SUBROUTINE AVER1M(METH,A,B,NX,NY,RADIUS,TR,ALL,V,CUTS)
C
C ----------------------------------------------------------
C
C  handle median filtering with all different possibilities
C
C ----------------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      NX,NY,ALL
      INTEGER      ICOUNT,KCOUNT,INDX
      INTEGER      NH,NL,NN,NO,NOZ
      INTEGER      NP,NXMRX,KK,K
      INTEGER      OFF,RX,RX1,RXM1
      INTEGER      RADIUS(2),NW1,NW2,BINDX,NAUX
C
      REAL         A(*),B(*),TR(*),CUTS(*)
      REAL         AA,TEST,COUNT,W,THRESH,THRB,RR
C
      REAL         V(*)
C
      CHARACTER*(*)      METH
C
C  initialize
C
      BINDX = 1
      RX = RADIUS(1)
      NW1 = RX*2 + 1                 !no. of values on row of filter
      NW2 = 1                        !no. of values on column of filter
      ICOUNT = NW1
      COUNT = FLOAT(ICOUNT)          !no. of pixels in neighbourh. with center
      NXMRX = NX - RX
      RX1 = RX + 1
      RXM1 = RX - 1
C
      OFF = 0                        !offset for center row
      THRESH = TR(1)
C 
      IF (ALL.EQ.0) THEN
         NH = ICOUNT/2                  !index of median
         NOZ = RX*NW2 + 1                  !index of center value
         KCOUNT = ICOUNT - 1
      ELSE
         NH = (ICOUNT+1) / 2                  !index of median
         KCOUNT = ICOUNT
      ENDIF
      NAUX = NH/2 + 1
C
      IF (METH(2:2).EQ.'Q') GOTO 5000 
      IF (METH(2:2).EQ.'Z') GOTO 7000 
C 
C -------------------------
C
      IF ( (METH(2:2).NE.'F') .AND.
     +     (THRESH.LE.0.) .AND.
     +     (ALL.NE.0.) ) THEN              !the fastest we can do
C 
         DO 300,NL=1,NY
C 
C  build up 1st V buffer
            INDX = OFF + RX1                  !pixel to work on
            NO = 1                            !init work array index...
C
            DO 80, NN=INDX-RX,INDX+RX
               V(NO) = A(NN)
               NO = NO + 1
80          CONTINUE
            CALL SORTIT(V,KCOUNT,NH,NAUX)
C
            B(BINDX) = V(NH)
            BINDX = BINDX + 1
C
C  for following pixels check against V buffer before sorting it all
C 
            DO 200,NP=RX1+1,NXMRX
               INDX = OFF + NP                  !pixel to work on
C
               IF (A(INDX-RX-1) .GT. V(NH)) THEN      !outgoing pixel > median?
                  AA = A(INDX+RX)          
                  IF (AA .GE. V(NH)) GOTO 180      !new pixel > median  => O.K.
C 
                  DO 150, K=NH-1,1,-1
                     IF (V(K) .LE. AA) THEN
                        DO 100, KK=NH,K+1,-1
                           V(KK+1) = V(KK)
100                     CONTINUE
                        V(K+1) = AA               !insert new pixel in sorted V
                        GOTO 180
                     ENDIF
150               CONTINUE
C 
                  DO 160, K=NH-1,1,-1            !AA is the smallest pixel in V
                     V(K+1) = V(K)
160               CONTINUE
                  V(1) = AA 
C 
               ELSE                        !we have to fill + sort the V buffer
                  NO = 1 
                  DO 170, NN=INDX-RX,INDX+RX
                     V(NO) = A(NN)
                     NO = NO + 1
170               CONTINUE
                 CALL SORTIT(V,KCOUNT,NH,NAUX)
               ENDIF
C
180            B(BINDX) = V(NH)
               BINDX = BINDX + 1
C 
200         CONTINUE
C 
            OFF = OFF + NX
300      CONTINUE
C 
         CALL CHCUTS(B,BINDX,CUTS)
         RETURN
      ENDIF
C
C 
      DO 4000 NL=1,NY
C
C  fork according to threshold option (just for speed reasons)
         IF (METH(2:2).EQ.'F') GOTO 3000
         IF (THRESH.GT.0.) GOTO 1000
C
C  extract values in the inner part
         DO 600,NP=RX1,NXMRX
            INDX = OFF + NP                  !pixel to work on
            NO = 1                        !init work array index...
C
            DO 400,NN=INDX-RX,INDX+RX
               V(NO) = A(NN)
               NO = NO + 1
400         CONTINUE
C
            IF (ALL.EQ.0) V(NOZ) = V(ICOUNT)  !replace center value by last one
            CALL SORTIT(V,KCOUNT,NH,NAUX)
C
            B(BINDX) = V(NH)
            BINDX = BINDX + 1
600      CONTINUE
         GOTO 3700                        !continue as other part
C
C  extract values in the inner part
1000     IF (METH(2:2).NE.'A') GOTO 2000
C
C  handle absolute threshold
         DO 1900,NP=RX1,NXMRX
            INDX = OFF + NP                  !pixel to work on
            W = A(INDX)                  !save original pixel value
            NO = 1                        !init work array index...
C
            DO 1400,NN=INDX-RX,INDX+RX
               V(NO) = A(NN)
               NO = NO + 1
1400        CONTINUE
C
            IF (ALL.EQ.0) V(NOZ) = V(ICOUNT)  !replace center value by last one
            CALL SORTIT(V,KCOUNT,NH,NAUX)
            TEST = V(NH)
C
C  compare meadian of neighbourhood with threshold
            IF (ABS(TEST-W).LE.THRESH) TEST = W
            B(BINDX) = TEST
            BINDX = BINDX + 1
1900     CONTINUE
         GOTO 3700
C
C  handle relative threshold
2000     DO 2900,NP=RX1,NXMRX
            INDX = OFF + NP                  !pixel to work on
            W = A(INDX)                  !save original pixel value
            NO = 1                        !init work array index...
C
            DO 2400,NN=INDX-RX,INDX+RX
               V(NO) = A(NN)
               NO = NO + 1
2400        CONTINUE
C
            IF (ALL.EQ.0) V(NOZ) = V(ICOUNT)  !replace center value by last one
            CALL SORTIT(V,KCOUNT,NH,NAUX)
            TEST = V(NH)
C
C  compare median of neighbourhood with pixel in question
            IF (ABS(TEST-W).LE.ABS(THRESH*W)) TEST = W
            B(BINDX) = TEST
            BINDX = BINDX + 1
2900     CONTINUE
         GOTO 3700
C
C  handle fixed threshold-interval
3000     DO 3600,NP=RX1,NXMRX
            INDX = OFF + NP                  !pixel to work on
            TEST = A(INDX)                   !save original pixel value
            IF ( (TEST.LT.TR(1)) .OR. (TEST.GT.TR(2)) ) THEN
               B(BINDX) = TEST
            ELSE
               NO = 1                        !init work array index...
               DO 3400,NN=INDX-RX,INDX+RX
                  V(NO) = A(NN)
                  NO = NO + 1
3400           CONTINUE
               IF (ALL.EQ.0) V(NOZ) = V(ICOUNT)
               CALL SORTIT(V,KCOUNT,NH,NAUX)
               B(BINDX) = V(NH)
            ENDIF
C
            BINDX = BINDX + 1
3600     CONTINUE
C
3700     OFF = OFF + NX                        !update offset...
C
4000  CONTINUE                             !outer loop over all lines
C
C finally update the cuts
      CALL CHCUTS(B,BINDX,CUTS)
      RETURN
C
C  handle relative threshold
C
5000  DO 6000,NL=1,NY
         DO 5900,NP=RX1,NXMRX
            INDX = OFF + NP                  !pixel to work on
            W = A(INDX)                  !save original pixel value
            NO = 1                        !init work array index...
C
            DO 5400,NN=INDX-RX,INDX+RX
               V(NO) = A(NN)
               NO = NO + 1
5400        CONTINUE
C
            IF (ALL.EQ.0) V(NOZ) = V(ICOUNT)  !replace center value by last one
            CALL SORTIT(V,KCOUNT,NH,NAUX)
            TEST = V(NH)
C
C  compare median of neighbourhood with pixel in question
            IF (ABS(TEST-W).LE.ABS(THRESH*TEST)) TEST = W
            B(BINDX) = TEST
            BINDX = BINDX + 1
5900     CONTINUE
C
C  check progress
         OFF = OFF + NX                        !update offset...
6000  CONTINUE
C
C finally update the cuts
      CALL CHCUTS(B,BINDX,CUTS)
      RETURN
C
C  handle threshold = a + b*SQRT(median)
C
7000  THRB = TR(2)
      DO 8000,NL=1,NY
         DO 7900,NP=RX1,NXMRX
            INDX = OFF + NP               !pixel to work on
            W = A(INDX)                   !save original pixel value
            NO = 1                        !init work array index...
C
            DO 7400,NN=INDX-RX,INDX+RX
               V(NO) = A(NN)
               NO = NO + 1
7400        CONTINUE
C
            IF (ALL.EQ.0) V(NOZ) = V(ICOUNT)  !replace center value by last one
            CALL SORTIT(V,KCOUNT,NH,NAUX)
            TEST = V(NH)
C
C  compare a + b*SQRT(median) of neighbourhood with pixel in question
            IF (TEST.LT.0.0) THEN
               RR = SQRT(-TEST)
            ELSE
               RR = SQRT(TEST)
            ENDIF
            IF (ABS(TEST-W).LE.(THRESH+(THRB*RR))) TEST = W
            B(BINDX) = TEST
            BINDX = BINDX + 1
7900     CONTINUE
C
C  check progress
         OFF = OFF + NX                        !update offset...
8000  CONTINUE
C
C finally update the cuts
      CALL CHCUTS(B,BINDX,CUTS)
      RETURN
C
      END

      SUBROUTINE AVER1A(METH,A,B,NX,NY,RADIUS,TR,ALL,V,CUTS)
C
C --------------------------
C
C  we handle boxcar filtering (smoothing, averaging)
C
C --------------------------
C
      IMPLICIT NONE
C
      INTEGER      NX,NY,ALL
      INTEGER      ICOUNT,INDX
      INTEGER      NL,NO,NOZ
      INTEGER      NP,NXMRX,NXMRX1
      INTEGER      OFF,RX,RX1,RXM1,TOP
      INTEGER      RADIUS(2),NW1,NW2,BINDX
C
      REAL         A(*),B(*),TR(*),CUTS(*)
      REAL         TEST,COUNT,FACTOR,W,THRESH
C
      DOUBLE PRECISION  V(*)
C 
      CHARACTER*(*)      METH
C
C  initialize
C
      BINDX = 1
      RX = RADIUS(1)
      NW1 = RX*2 + 1                 !no. of values on row of filter
      NW2 = 1                        !no. of values on column of filter
      ICOUNT = NW1
      COUNT = FLOAT(ICOUNT)          !no. of pixels in neighbourh. with center
      NXMRX = NX - RX
      NXMRX1 = NXMRX - 1
      RX1 = RX + 1
      RXM1 = RX - 1
      OFF = 0                     !offset for center row
      THRESH = TR(1)
C
      IF (ALL.EQ.0) THEN
         FACTOR = 1. / (COUNT-1.)
      ELSE
         FACTOR = 1. / COUNT
      ENDIF
C
      NOZ = 0                                   !offset for lower left
      NO = 1                                    !offset for lower left + 1
C
C  fork according to test criterion (just for speed reasons)
      IF (METH(2:2).EQ.'F') GOTO 4000
      IF (METH(2:2).EQ.'Q') GOTO 5000
      IF (THRESH.GT.0.) THEN     !check, if absolute or relative thresholding
         IF (METH(2:2).NE.'A') THEN
            GOTO 3000
         ELSE
            GOTO 2000
         ENDIF
      ENDIF
C
C ...........
C
C  here average without thresholding for each line
C
C ...........
C
C
      DO 1500, NL=1,NY                    !for row-average in 2-dim frame
         V(1) = 0.D0                     !build new high row sum
         DO 100, NP=NOZ+1,NOZ+NW1
            V(1) = V(1) + A(NP)
100      CONTINUE
         NOZ = NOZ + NX                        !follow with offset...
C
C  average in the inner part
         TOP = NO                        !init to left corner of interval
C
         IF (ALL.EQ.0) THEN
            DO 400, INDX=OFF+RX1,OFF+NXMRX1
               B(BINDX) = (V(1) - A(INDX)) * FACTOR
               BINDX = BINDX + 1
C
C  sum over neighbourhood + update the row-sum on the fly
               V(1) = V(1) - A(TOP) + A(TOP+NW1)
               TOP = TOP + 1
400         CONTINUE
            B(BINDX) = (V(1) - A(OFF+NXMRX)) * FACTOR
            OFF = OFF + NX                      !update offset of center line
         ELSE
            DO 600, INDX=RX1,NXMRX1
               B(BINDX) = V(1) * FACTOR
               BINDX = BINDX + 1
               V(1) = V(1) - A(TOP) + A(TOP+NW1)
               TOP = TOP + 1
600         CONTINUE
            B(BINDX) = V(1) * FACTOR            !avoid out_of_bounds in TOP+NW1
         ENDIF
C
         BINDX = BINDX + 1
         NO = NO + NX                           !follow with initial offset...
1500  CONTINUE
C
C finally update the cuts
      CALL CHCUTS(B,BINDX,CUTS)
      RETURN
C
C
C ...........
C
C  here average with absolute thresholding for each line
C
C ...........
C
C
2000  DO 2900, NL=1,NY
         V(1) = 0.D0
         DO 2050,NP=NOZ+1,NOZ+NW1
            V(1) = V(1) + A(NP)
2050     CONTINUE
         NOZ = NOZ + NX                        !follow with offset...
C
C  average in the inner part
         TOP = NO                        !init to left corner of interval
C
         IF (ALL.EQ.0) THEN
            DO 2200 INDX=OFF+RX1,OFF+NXMRX1
               W = A(INDX)                  !save original pixel value
C
C  sum over neighbourhood + update the row-sum on the fly
               TEST = (V(1) - W) * FACTOR
               V(1) = V(1) - A(TOP) + A(TOP+NW1)
C
C  compare average of neighbourhood with threshold
               IF (ABS(TEST-W).LE.THRESH) THEN
                  B(BINDX) = W
               ELSE
                  B(BINDX) = TEST 
               ENDIF
               BINDX = BINDX + 1
               TOP = TOP + 1
2200        CONTINUE
            W = A(OFF+NXMRX)                !for last pixel no A(TOP+NW1)
            TEST = (V(1) - W) * FACTOR
         ELSE
            DO 2300 INDX=OFF+RX1,OFF+NXMRX1
               W = A(INDX)                  !save original pixel value
               TEST = V(1) * FACTOR
               V(1) = V(1) - A(TOP) + A(TOP+NW1)
C
C  compare average of neighbourhood with threshold
               IF (ABS(TEST-W).LE.THRESH) THEN
                  B(BINDX) = W
               ELSE
                  B(BINDX) = TEST 
               ENDIF
               BINDX = BINDX + 1
               TOP = TOP + 1
2300        CONTINUE
            W = A(OFF+NXMRX)                   !for last pixel no A(TOP+NW1)
            TEST = V(1) * FACTOR
         ENDIF
C
         IF (ABS(TEST-W).LE.THRESH) TEST = W
         B(BINDX) = TEST 
         BINDX = BINDX + 1
C
         NO = NO + NX                          !follow with initial offset...
         OFF = OFF + NX                        !update offset of center line
2900  CONTINUE
C
C finally update the cuts
      CALL CHCUTS(B,BINDX,CUTS)
      RETURN
C
C ...........
C
C  here average with relative thresholding for each line
C
C ...........
C
C
3000  DO 3900,NL=1,NY
         V(1) = 0.D0
         DO 3050,NP=NOZ+1,NOZ+NW1
            V(1) = V(1) + A(NP)
3050     CONTINUE
         NOZ = NOZ + NX                        !follow with offset...
C
C  average in the inner part
         TOP = NO                        !init to lower left corner of matrix
C
         IF (ALL.EQ.0) THEN
            DO 3200,INDX=OFF+RX1,OFF+NXMRX1
               W = A(INDX)                  !save original pixel value
C
C  sum over neighbourhood + update the row sum on the fly
               TEST = (V(1) - W) * FACTOR
               V(1) = V(1) - A(TOP) + A(TOP+NW1)
C
C  compare average of neighbourhood with threshold
               IF (ABS(TEST-W).LE.ABS(THRESH*W)) THEN
                  B(BINDX) = W
               ELSE
                  B(BINDX) = TEST
               ENDIF
               BINDX = BINDX + 1
               TOP = TOP + 1
3200        CONTINUE
            W = A(OFF+NXMRX)                   !for last pixel no A(TOP+NW1)
            TEST = (V(1) - W) * FACTOR
         ELSE
            DO 3300,INDX=OFF+RX1,OFF+NXMRX1
               W = A(INDX)                  !save original pixel value
               TEST = V(1) * FACTOR
               V(1) = V(1) - A(TOP) + A(TOP+NW1)
               IF (ABS(TEST-W).LE.ABS(THRESH*W)) THEN
                  B(BINDX) = W
               ELSE
                  B(BINDX) = TEST
               ENDIF
               BINDX = BINDX + 1
               TOP = TOP + 1
3300        CONTINUE
            W = A(OFF+NXMRX)                   !for last pixel no A(TOP+NW1)
            TEST = V(1) * FACTOR
         ENDIF
C
         IF (ABS(TEST-W).LE.ABS(THRESH*W)) TEST = W
         B(BINDX) = TEST
         BINDX = BINDX + 1
C
         NO = NO + NX                          !follow with initial offset...
         OFF = OFF + NX                        !update offset of center line
3900  CONTINUE
C
C finally update the cuts
      CALL CHCUTS(B,BINDX,CUTS)
      RETURN
C
C
C ...........
C
C  here average with fixed threshold-interval for each line
C
C ...........
C
C
4000  DO 4900,NL=1,NY
         V(1) = 0.D0
         DO 4050,NP=NOZ+1,NOZ+NW1
            V(1) = V(1) + A(NP)
4050     CONTINUE
         NOZ = NOZ + NX                        !follow with offset...
C
C  average in the inner part
         TOP = NO                        !init to lower left corner of matrix
C
         IF (ALL.EQ.0) THEN
            DO 4200,INDX=OFF+RX1,OFF+NXMRX1
               TEST = A(INDX)                  !save original pixel value
C
C  compare average of neighbourhood with threshold
               IF ( (TEST.GE.TR(1)) .AND. (TEST.LE.TR(2)) ) THEN
                  B(BINDX) = (V(1) - TEST) * FACTOR
               ELSE
                  B(BINDX) = TEST 
               ENDIF
               BINDX = BINDX + 1
C 
C  sum over neighbourhood + update the row-sum on the fly
               V(1) = V(1) - A(TOP) + A(TOP+NW1)
               TOP = TOP + 1
4200        CONTINUE
            TEST = A(OFF+NXMRX)                !for last pixel no A(TOP+NW1)
            IF ( (TEST.GE.TR(1)) .AND. (TEST.LE.TR(2)) ) 
     +         TEST = (V(1) - TEST) * FACTOR
         ELSE
            DO 4300,INDX=OFF+RX1,OFF+NXMRX1
               TEST = A(INDX)                  !save original pixel value
               IF ( (TEST.GE.TR(1)) .AND. (TEST.LE.TR(2)) ) THEN
                  B(BINDX) = V(1) * FACTOR
               ELSE
                  B(BINDX) = TEST 
               ENDIF
               BINDX = BINDX + 1
               V(1) = V(1) - A(TOP) + A(TOP+NW1)
               TOP = TOP + 1
4300        CONTINUE
            TEST = A(OFF+NXMRX)                !for last pixel no A(TOP+NW1)
            IF ( (TEST.GE.TR(1)) .AND. (TEST.LE.TR(2)) )
     +         TEST = V(1) * FACTOR
         ENDIF
C
         B(BINDX) = TEST 
         BINDX = BINDX + 1
C
         NO = NO + NX                          !follow with initial offset...
         OFF = OFF + NX                        !update offset of center line
4900  CONTINUE
C
C finally update the cuts
      CALL CHCUTS(B,BINDX,CUTS)
      RETURN
C
C ...........
C
C  here average with relative thresholding for each line
C
C ...........
C
C
5000  IF (ALL.EQ.0) THEN
         FACTOR = 1. / (COUNT-1.)
      ELSE
         FACTOR = 1. / COUNT
      ENDIF
C
      DO 5900,NL=1,NY
         V(1) = 0.D0 
         DO 5050,NP=NOZ+1,NOZ+NW1
            V(1) = V(1) + A(NP)
5050     CONTINUE
         NOZ = NOZ + NX                        !follow with offset...
C
C  average in the inner part
         TOP = NO                        !init to lower left corner of matrix
C
         IF (ALL.EQ.0) THEN
            DO 5200,INDX=OFF+RX1,OFF+NXMRX1
               W = A(INDX)                  !save original pixel value
C
C  sum over neighbourhood + update the row sum on the fly
               TEST = (V(1) - W) * FACTOR
               V(1) = V(1) - A(TOP) + A(TOP+NW1)
C
C  compare average of neighbourhood with threshold
               IF (ABS(TEST-W).LE.ABS(THRESH*TEST)) THEN
                  B(BINDX) = W
               ELSE
                  B(BINDX) = TEST
               ENDIF
               BINDX = BINDX + 1
               TOP = TOP + 1
5200        CONTINUE
C
         ELSE
            DO 5300,INDX=OFF+RX1,OFF+NXMRX1
               W = A(INDX)                  !save original pixel value
               TEST = V(1) * FACTOR
               V(1) = V(1) - A(TOP) + A(TOP+NW1)
               IF (ABS(TEST-W).LE.ABS(THRESH*TEST)) THEN
                  B(BINDX) = W
               ELSE
                  B(BINDX) = TEST
               ENDIF
               BINDX = BINDX + 1
               TOP = TOP + 1
5300        CONTINUE
            W = A(OFF+NXMRX)                   !for last pixel no A(TOP+NW1)
            TEST = V(1) * FACTOR
         ENDIF
C 
         IF (ABS(TEST-W).LE.ABS(THRESH*TEST)) TEST = W
         B(BINDX) = TEST
         BINDX = BINDX + 1
C
         NO = NO + NX                          !follow with initial offset...
         OFF = OFF + NX                        !update offset of center line
5900  CONTINUE
C
C finally update the cuts
      CALL CHCUTS(B,BINDX,CUTS)
      RETURN
C
      END

      SUBROUTINE AVER2M(METH,A,B,NX,NY,RADIUS,TR,ALL,O,VB,CUTS)
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine AVER2M  			version 1.00	861215
C  K. Banse                     	ESO - Garching
C  1.10     870303	1.20	880707		1.30	910529
C  1.40     920210
C
C.KEYWORDS
C  median, neighbourhood
C
C.PURPOSE
C remove spot noise
C
C.ALGORITHM
C  a) smooth image by taking the average A(x,y)of all points in neighbourhood
C     of x,y with given radius, and replace original value I(x,y) by A(x,y),
C     if average differs more than THRESH*I(x,y) from original value
C  b) as a) but take median instead of average
C
C.INPUT/OUTPUT
C  call as   AVER2M(METH,A,B,NX,NY,RADIUS,TR,ALL,O,VB,CUTS)
C
C input par:
C  METH:      char.exp.      (1:1) = method to use: always M for median
C                            (2:2) = A for absolute,
C                                    R for relative threshold
C                                    Q is handled in BVER2M ...
C                                    F for fixed threshold-interval
C  A:         R*4 array      input array
C  B:         R*4 array      output array
C  NX:        I*4            no. of pixels per line
C  NY:        I*4            no. of lines in input array
C  RADIUS:    I*4 array      "radius" of neighbourhood in x and y,
C                            i.e. no. of pixels in horizontal and vertical
C			     direction to include
C  TR:        R*4 array      threshold(s) for center point to determine 
C			     replacement
C  ALL:       I*4            flag for inclusion of center point in
C			     averaging process:
C                            1 = include center point, 0 = no inclusion
C  O:         R*4            working buffer
C  VB:        R*4            buffer for columns if x-radius = 0
C  			     temp buffer otherwise
C
C.VERSIONS
C  1.00       has been built on 2.80 of old module AVERAGE
C  1.10       add fixed threshold-interval option
C  1.20       fix bugs with fixed-threshold option (jump into inner loop at 8000)
C  1.30       also filter borders (input image is larger now) and use
C	      heapsort and binary insertion for median determination
C  1.40       fix bug with METH(2:2)=F (fixed interval)
C  1.50       work on faster algorithm for 1-dim column filters
C
C --------------------------------------------------------------------
C
      IMPLICIT NONE
C 
C  IXXSIZ is the buffer size in the sorting algorithms in smosub3.for
C  and has to be synchronized with that code
C 
      PARAMETER (IXXSIZ = 25000)
C
      INTEGER      NX,NY,ALL
      INTEGER      ICOUNT,KCOUNT
      INTEGER      INDX,AUX1,AUX2,AUX3,AUX4,AUX5
      INTEGER      N,NH,NINDX,NL,NN,NO,NOZ
      INTEGER      NP,NXMRX,MFLAG
      INTEGER      OFF,RX,RX1,RX2,RY,RYNX
      INTEGER      RADIUS(2),NW1,NW11,NW2,NAUX
      INTEGER      JWOFF,KWOFF,KWOF1,KINDX,BINDX,WINDX
C
      REAL         A(*),B(*),TR(*)
      REAL         O(*),VB(*),CUTS(*)
      REAL         TEST,W,THRESH,THRB,QQ,RR
      REAL         COLO(200)
C
      CHARACTER*(*)      METH
      CHARACTER*80       CBUF
C
C  initialize
C
      BINDX = 1
      RX = RADIUS(1)
      RY = RADIUS(2)
      NW1 = RX*2 + 1                  !no. of values on row of filter
      NW2 = RY*2 + 1                  !no. of values on column of filter
      ICOUNT = NW1 * NW2
      RYNX = RY * NX
      NXMRX = NX - RX
      RX1 = RX + 1
      AUX1 = RYNX + RX
      AUX2 = NX - NW1
C
      OFF = RYNX                      !offset for center row
      THRESH = TR(1)
C
C
      IF (ALL.EQ.0) THEN                      !center pixel not included
         NH = ICOUNT/2                        !index of median
         NOZ = (RX * NW2) + RY + 1            !index of center value
         KCOUNT = ICOUNT - 1                  !one pixel less
         NAUX = NH/2 + 1                      !needed for sorting algorithm
      ELSE
         KCOUNT = ICOUNT
         NH = (ICOUNT+1) / 2                  !index of median
         NAUX = NH/2 + 1                      !needed for sorting algorithm
      ENDIF
C                                            !we need a size check (ugly...)
CC      IF ((KCOUNT.GT.2500) .OR. (NW1.GT.200)) THEN
      IF (KCOUNT.GT.IXXSIZ) THEN
         WRITE (CBUF,99778) KCOUNT,IXXSIZ
         CALL STTPUT(CBUF,N)
         RETURN
      ENDIF
C 
C  branch according to different options
      IF (METH(2:2).EQ.'F') GOTO 8000         !fixed interval elsewhere
C 
      MFLAG = 0
      IF (METH(2:2).EQ.'Z') THEN
         THRB = TR(2)
         MFLAG = 3                            !a+b*SQRT(median) elsewhere
      ELSE IF (METH(2:2).EQ.'Q') THEN
         MFLAG = 4                            !relative threshold with median
      ELSE
         IF (THRESH.GT.0.) THEN
            IF (METH(2:2).NE.'A') THEN           !relative thr > 0.
               MFLAG = 2                         
            ELSE                                 !absolute thr > 0.
               MFLAG = 1                     
            ENDIF
         ENDIF
      ENDIF
C 
      IF (ALL.EQ.0) GOTO 6000                 !exclude the center pixel
C
C ---------------------------------------------------------------
C  order the complete filter kernel completeley only for first 
C  center pixel + first row
C  then just update the ordered set with the new pixels which are
C  added to the already ordered set
C ---------------------------------------------------------------
C
      OFF = OFF - AUX1                       !saves 1 addition...
      NW11 = NW1 - 1                           !additional constants
      AUX3 = RX1 + (NW2 - 1) * (NW1 + AUX2)    !for this section
      AUX4 = KCOUNT - NW1 + 1
      AUX5 = NXMRX + NW11
      RX2 = RX1 + NW1
C
C  .........................
C
C  include the center pixel
C
C  .........................
C
      NO = 1                           !first line + first kernel
      NINDX = OFF + RX1
      DO 150, NN=1,NW2
         DO 100, N=1,NW1
            O(NO) = A(NINDX)
            VB(NO) = O(NO)             !save 1. neighbourhood
            NO = NO + 1
            NINDX = NINDX + 1
100      CONTINUE
         NINDX = NINDX + AUX2          != NINDX + NX - NW1
150   CONTINUE
C
      CALL XSORT1(O,KCOUNT,NH,KINDX)
      CALL XSAVX(1,KCOUNT)             !copy internal sort arrays out
C
C  compare median of neighbourhood with threshold
      IF (MFLAG.GT.0) THEN              !threshold > 0
         WINDX = OFF + AUX1 + RX1       !index for input pixel we work on
         W = A(WINDX)                   !save original pixel value
         TEST = O(KINDX)
         RR = ABS(TEST-W)
         IF (MFLAG.EQ.1) THEN             !absolute threshold
            IF (RR.LE.THRESH) TEST = W
         ELSE IF (MFLAG.EQ.2) THEN        !relative threshold
            IF (RR.LE.ABS(THRESH*W)) TEST = W
         ELSE IF (MFLAG.EQ.3) THEN      
            IF (TEST.LT.0.0) THEN
               QQ = SQRT(-TEST)
            ELSE
               QQ = SQRT(TEST)
            ENDIF
            IF (RR.LE.(THRESH+(THRB*QQ))) TEST = W
         ELSE
            IF (RR.LE.ABS(THRESH*TEST)) TEST = W
         ENDIF
         B(BINDX) = TEST
      ELSE
         B(BINDX) = O(KINDX)
      ENDIF
      BINDX = BINDX + 1
C
C  now move along first line
      JWOFF = 1
      DO 250, NP=RX2,AUX5
         NINDX = OFF + NP
         DO 200, N=1,NW2
            COLO(N) = A(NINDX)            !new values
            NINDX = NINDX + NX
200      CONTINUE
C
         CALL XSORT2(O,KCOUNT,NH,JWOFF,COLO,NW1,NW2,KINDX)
         JWOFF = JWOFF + 1                !point to next column start
         IF (JWOFF.GT.NW1) JWOFF = 1
C
C  compare median of neighbourhood with threshold
         IF (MFLAG.GT.0) THEN              !threshold > 0
            WINDX = WINDX + 1 
            W = A(WINDX)                   !save original pixel value
            TEST = O(KINDX)
            RR = ABS(TEST-W)
            IF (MFLAG.EQ.1) THEN             !absolute threshold
               IF (RR.LE.THRESH) TEST = W
            ELSE IF (MFLAG.EQ.2) THEN        !relative threshold
               IF (RR.LE.ABS(THRESH*W)) TEST = W
            ELSE IF (MFLAG.EQ.3) THEN      
               IF (TEST.LT.0.0) THEN
                  QQ = SQRT(-TEST)
               ELSE
                  QQ = SQRT(TEST)
               ENDIF
               IF (RR.LE.(THRESH+(THRB*QQ))) TEST = W
            ELSE
               IF (RR.LE.ABS(THRESH*TEST)) TEST = W
            ENDIF
            B(BINDX) = TEST
         ELSE
            B(BINDX) = O(KINDX)
         ENDIF
         BINDX = BINDX + 1
250   CONTINUE
      OFF = OFF + NX                      !update offset...
      KWOFF = 1
      KWOF1 = 0
C
C  use last 1. buffer for beginning of all following lines
      IF ((RY+2).GT.(NY-RY)) GOTO 3000
C 
      DO 1000, NL=RY+2,NY-RY
         DO 330, N=1,KCOUNT            !copy 1. neighbourhood
            O(N) = VB(N)
330      CONTINUE
         CALL XSAVX(-1,KCOUNT)         !copy internal sort arrays back in
C
         NINDX = OFF + AUX3
         DO 400, N=1,NW1
            COLO(N) = A(NINDX)
            VB(N+KWOF1) = COLO(N)
            NINDX = NINDX + 1
400      CONTINUE
C
         CALL XSORT2(O,KCOUNT,NH,KWOFF,COLO,1,NW1,KINDX)
         CALL XSAVX(1,KCOUNT)          !copy internal sort arrays out
         KWOFF = KWOFF + NW1           !point to next row start
         IF (KWOFF.GT.AUX4) KWOFF = 1
         KWOF1 = KWOFF - 1
C
C  compare median of neighbourhood with threshold
         IF (MFLAG.GT.0) THEN              !threshold > 0
            WINDX = OFF + AUX1 + RX1 
            W = A(WINDX)                   !save original pixel value
            TEST = O(KINDX)
            RR = ABS(TEST-W)
            IF (MFLAG.EQ.1) THEN             !absolute threshold
               IF (RR.LE.THRESH) TEST = W
            ELSE IF (MFLAG.EQ.2) THEN        !relative threshold
               IF (RR.LE.ABS(THRESH*W)) TEST = W
            ELSE IF (MFLAG.EQ.3) THEN      
               IF (TEST.LT.0.0) THEN
                  QQ = SQRT(-TEST)
               ELSE
                  QQ = SQRT(TEST)
               ENDIF
               IF (RR.LE.(THRESH+(THRB*QQ))) TEST = W
            ELSE
               IF (RR.LE.ABS(THRESH*TEST)) TEST = W
            ENDIF
            B(BINDX) = TEST
         ELSE
            B(BINDX) = O(KINDX)
         ENDIF
         BINDX = BINDX + 1
C 
C  now move along each line
         JWOFF = 1
         DO 800, NP=RX2,AUX5                  !AUX5 = NXMRX + NW11
            NINDX = OFF + NP 
            DO 700, N=1,NW2
               COLO(N) = A(NINDX)             !new values
               NINDX = NINDX + NX
700         CONTINUE
C 
            CALL XSORT2(O,KCOUNT,NH,JWOFF,COLO,NW1,NW2,KINDX)
            JWOFF = JWOFF + 1
            IF (JWOFF.GT.NW1) JWOFF = 1
C
C  compare median of neighbourhood with threshold
            IF (MFLAG.GT.0) THEN              !threshold > 0
               WINDX = WINDX + 1 
               W = A(WINDX)                   !save original pixel value
               TEST = O(KINDX)
               RR = ABS(TEST-W)
               IF (MFLAG.EQ.1) THEN             !absolute threshold
                  IF (RR.LE.THRESH) TEST = W
               ELSE IF (MFLAG.EQ.2) THEN        !relative threshold
                  IF (RR.LE.ABS(THRESH*W)) TEST = W
               ELSE IF (MFLAG.EQ.3) THEN      
                  IF (TEST.LT.0.0) THEN
                     QQ = SQRT(-TEST)
                  ELSE
                     QQ = SQRT(TEST)
                  ENDIF
                  IF (RR.LE.(THRESH+(THRB*QQ))) TEST = W
               ELSE
                  IF (RR.LE.ABS(THRESH*TEST)) TEST = W
               ENDIF
               B(BINDX) = TEST
            ELSE
               B(BINDX) = O(KINDX)
            ENDIF
            BINDX = BINDX + 1
800      CONTINUE
C
         OFF = OFF + NX                        !update offset...
1000  CONTINUE
C
C finally update the cuts
3000  CALL CHCUTS(B,BINDX,CUTS)
      RETURN
C 
C  .........................
C
C  exclude the center pixel
C 
C  .........................
C  
6000  DO 6900,NL=RY+1,NY-RY
         DO 6800,NP=RX1,NXMRX
            NO = 1                           !extract neighbourhood
            INDX = OFF + NP                  !pixel to work on
            NINDX = INDX - AUX1              != INDX - RYNX + RX
            DO 6400,NN=1,NW2
               DO 6350,N=1,NW1
                  O(NO) = A(NINDX)
                  NO = NO + 1
                  NINDX = NINDX + 1
6350           CONTINUE
               NINDX = NINDX + AUX2          != NINDX + NX - NW1
6400        CONTINUE
C
            O(NOZ) = O(ICOUNT)           !replace center value by last one
            CALL SORTIT(O,KCOUNT,NH,NAUX)
            IF (MFLAG.GT.0) THEN
               W = A(INDX)                      !save original pixel value
               TEST = O(NH)
               RR = ABS(TEST-W)
               IF (MFLAG.EQ.1) THEN             !absolute threshold
                  IF (RR.LE.THRESH) TEST = W
               ELSE IF (MFLAG.EQ.2) THEN           !relative threshold
                  IF (RR.LE.ABS(THRESH*W)) TEST = W
               ELSE IF (MFLAG.EQ.3) THEN      
                  IF (TEST.LT.0.0) THEN
                     QQ = SQRT(-TEST)
                  ELSE
                     QQ = SQRT(TEST)
                  ENDIF
                  IF (RR.LE.(THRESH+(THRB*QQ))) TEST = W
               ELSE
                  IF (RR.LE.ABS(THRESH*TEST)) TEST = W
               ENDIF
               B(BINDX) = TEST
            ELSE
               B(BINDX) = O(NH)
            ENDIF
            BINDX = BINDX + 1
6800     CONTINUE
C
         OFF = OFF + NX                        !update offset...
6900  CONTINUE
C
C finally update the cuts
      CALL CHCUTS(B,BINDX,CUTS)
      RETURN
C 
C
C ---------------------------------------------------------------
C  handle fixed threshold-interval
C ---------------------------------------------------------------
C
C 
8000  DO 8900,NL=RY+1,NY-RY
         DO 8800,NP=RX1,NXMRX
            INDX = OFF + NP                  !pixel to work on
            TEST = A(INDX)                      !save original pixel value
C
C  check if pixel should be replaced
            IF ( (TEST.GE.TR(1)) .AND. (TEST.LE.TR(2)) ) THEN
               NO = 1                           !extract neighbourhood
               NINDX = INDX - AUX1              != INDX - RYNX - RX
               DO 8400,NN=1,NW2
                  DO 8350,N=1,NW1
                     O(NO) = A(NINDX)
                     NO = NO + 1
                     NINDX = NINDX + 1
8350              CONTINUE
                  NINDX = NINDX + AUX2          != NINDX + NX - NW1
8400           CONTINUE
C 
               IF (ALL.EQ.0)
     +            O(NOZ) = O(ICOUNT)           !replace cent_val by last one
               CALL SORTIT(O,KCOUNT,NH,NAUX)
               B(BINDX) = O(NH)
            ELSE
               B(BINDX) = TEST
            ENDIF
            BINDX = BINDX + 1
8800     CONTINUE
C
         OFF = OFF + NX                        !update offset...
8900  CONTINUE
C
C finally update the cuts
      CALL CHCUTS(B,BINDX,CUTS)
      RETURN
C
99778 FORMAT('Filter size = ',I8,' > ',I8,'  - we abort...')
C 
      END

C  @(#)ftdivi.for	19.1 (ESO-DMD) 02/25/03 13:17:33 
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FTDIVI(REFIMA,ISTAT)                                           
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                   
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:25 - 13 JAN 1988                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C.IDENTIFICATION                                                                
C                                                                               
C  FITLIB.FOR   VERSION 1.0  27 MAR 1984                                        
C                                                                               
C.PURPOSE                                                                       
C                                                                               
C  INTERFACE ROUTINES FOR THE FITTING STRUCTURES                                
C DEFINE NEW INDEPENDENT VARIABLES BASED ON THE REFERENCE IMAGE                 
C                                                                               
C.ALGORITHM                                                                     
C                                                                               
C  USE MIDAS I/O INTERFACES TO FRAMES AND TABLES                                
C                                                                               
C.KEYWORDS                                                                      
C                                                                               
C  NON LINEAR FITTING                                                           
C                                                                               
C.VERSION
C 901025	M PeroN                                                 
C 021122	last modif
C 
C----------------------------------------------------------------               
C                                                                               
C                                                                               
C INPUT PARAMETERS                                                              
C REFIMA CHAR REFERENCE IMAGE                                                   
C                                                                               
C OUTPUT PARAMETERS                                                             
C ISTAT INTG STATUS RETURN                                                      
C                                                                               
      IMPLICIT NONE                                                            

      CHARACTER*(*) REFIMA                                                      
      CHARACTER*72 IDENT,UNIT                                                   

      INTEGER NPIX(3)  
      INTEGER INO,ISTAT,I,NAXIS
      INTEGER*8 IPTR
C 
       INCLUDE 'MID_INCLUDE:ST_DEF.INC/NOLIST'  
       INCLUDE 'MID_INCLUDE:FITI.INC/NOLIST'   
       INCLUDE 'MID_INCLUDE:FITC.INC/NOLIST'  
       INCLUDE 'MID_INCLUDE:ST_DAT.INC/NOLIST' 
C                                                                               
C READ REFERENCE IMAGE                                                          
C                                                                               
      CALL STIGET(REFIMA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     .     3,NAXIS,NPIX,FZSTART,FZSTEP,IDENT,UNIT,IPTR,INO,ISTAT)        
      IF (NAXIS.NE.FZNIND .AND. FZNIND.NE.0) THEN                           
          ISTAT  = FERPAR                                                   
          RETURN                                                                
      END IF                                                                    
      FZRIMA = REFIMA                                                         
      FZNIND = NAXIS                                                          
      DO 10, I = 1,3 
          FZIVAR(I) = I                                                       
          FZNPIX(I) = MAX(1,NPIX(I))                                          
   10 CONTINUE                                                                  
      FZTYPE = 'BDF '                                                         
      RETURN                                                                    
      END                                                                       

C @(#)ifgood.for	19.1 (ES0-DMD) 02/25/03 13:25:34
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C
C-----------------------------------------------------------------------
      SUBROUTINE IFGOOD(A, JAPY, IBUF, MAS, I,
     &                    J, IK, JK, BGRD,
     &                    FLTR, TRSH, GOOD)
C
      IMPLICIT    NONE	
      INCLUDE     'MID_REL_INCL:INVENT.INC/NOLIST'
C
      REAL        A(1)
      INTEGER     JAPY(1)
      INTEGER     IBUF(4)
      INTEGER     MAS((-MAXSUB):MAXSUB,(-MAXSUB):MAXSUB)
      INTEGER     I
      INTEGER     J
      INTEGER     IK
      INTEGER     JK
      REAL        BGRD
      REAL        FLTR
      REAL        TRSH
      LOGICAL     GOOD
C
      INTEGER     IK1, IK2
      INTEGER     JK1, JK2
      INTEGER     ITMP
      INTEGER     JOF, JOFF
      INTEGER     L
      INTEGER     K
      REAL        AVER
      REAL        TEMP
C
      GOOD = .TRUE.
      IK1 = MAX( IBUF(1) , IK-1 , I-MAXSUB )
      JK1 = MAX( IBUF(2) , JK-1 , J-MAXSUB )
      IK2 = MIN( IBUF(3) , IK+1 , I+MAXSUB )
      JK2 = MIN( IBUF(4) , JK+1 , J+MAXSUB )
      TEMP = 0.0
      ITMP = 0
      JOFF = IBUF(2) - 1
      DO 10 L = JK1 , JK2
          JOF = JAPY(L-JOFF)
          DO 20 K = IK1 , IK2
              IF ( MAS(K-I,L-J) .EQ. -1 ) THEN
                  GOOD = .FALSE.
                  RETURN
              ELSE
                  TEMP = TEMP + A(JOF+K)
                  ITMP = ITMP + 1
              ENDIF
   20     CONTINUE
   10 CONTINUE
      IF ( ITMP .GT. 0 ) THEN
          AVER = TEMP / ITMP
      ELSE
          GOOD = .FALSE.
          RETURN
      ENDIF
C
      IF ( IK .GT. IBUF(1) .AND. JK .GT. IBUF(2) .AND.
     &                   IK .LT. IBUF(3) .AND. JK .LT. IBUF(4) ) THEN
          CALL FLTRBP( A , JAPY , IBUF , IK , JK , BGRD , FLTR , AVER )
      ELSE
          GOOD = .FALSE.
          RETURN
      ENDIF
C
      IF ( ( A(JAPY(JK-JOFF)+IK) - AVER ) .GT. FLTR*(AVER-BGRD) ) THEN
          GOOD = .FALSE.
          MAS(IK-I,JK-J) = 0
      ELSE IF ( AVER .LT. BGRD+TRSH ) THEN
          GOOD = .FALSE.
      ENDIF
C
      RETURN
C
      END

C===========================================================================
C Copyright (C) 1995-2005 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FTTNTR(NITER,RELAX,PREC,V1,V2,NACT,ACTCH,ISTAT)                
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                   
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C.IDENTIFICATION                                                                
C                                                                               
C  FITLIB.FOR   VERSION 1.0  27 MAR 1984                                        
C                                                                               
C.PURPOSE                                                                       
C                                                                               
C  INTERFACE ROUTINES FOR THE FITTING STRUCTURES                                
C ITERATE ON THE FITTING PROCESS                                                
C THE ITERATION IS FINISHED IF                                                  
C - NITER IS REACHED OR                                                         
C - CHISQ IS REACHED                                                            
C - CONVERGENCE IS ACHIEVED                                                     
C                                                                               
C                                                                               
C.ALGORITHM                                                                     
C                                                                               
C  USE MIDAS I/O INTERFACES TO FRAMES AND TABLES                                
C                                                                               
C.KEYWORDS                                                                      
C                                                                               
C  NON LINEAR FITTING                                                           
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:25 - 13 JAN 1988                 
C 051109	last modif 
C                                                                               
C----------------------------------------------------------------               
C                                                                               
C INPUT PARAMETERS                                                              
C NITER INTG NO. OF ITERATIONS TO BE DONE                                       
C   <0 USE PREVIOUS COMPUTED VALUES                                             
C   >0 USE GUESS                                                                
C RELAX REAL RELAXATION FACTOR                                                  
C CHISQ REAL CHI SQUARE                                                         
C V1,V2 REAL OPTIONAL FITTING INTERVAL (IF V1.NE.V2)                            
C                                                                               
C OUTPUT PARAMETERS                                                             
C NACT INTG ACTUAL NUMBER OF ITERATIONS                                         
C ACTCH REAL ACTUAL CHI SQ.                                                     
C ISTAT INTG STATUS RETURN                                                      
C                                                                               
      INTEGER NITER,NACT,ISTAT,IPRINT,I,J,NITER1,ICOUNT,NN,NP,NNP
      INTEGER ISTAR,NCOL,NS,KZ6941,N,IDAT,NOFFSET,IFUN,K,IP,NILAST
      INTEGER ICOL(10),ACOL,AROW,NC,NROW

      REAL RELAX,PREC,V1,V2,ACTCH,VS,VE,CHIOLD,CHIPERC,AC1,AC2,AC3
      REAL DELTA,C1,C2
      REAL XVAL(10),X(8),W,FSUMSQ                                               

      CHARACTER*80 LINE                                                         
      CHARACTER*6 TYPE                                                          

      DOUBLE PRECISION CHI,PP,Q,Y,Y1,Y2,YOUT,CORRNRM                            

      LOGICAL NULL(10),VALID,NEXT,AUTO,ISEL,VCMATPR                             

      INCLUDE 'MID_INCLUDE:FITI.INC/NOLIST'                                     
      DOUBLE PRECISION FZDERIV(FZPARMAX)                                    
      DOUBLE PRECISION AL,B(FZPARMAX),A(FZPARMAX,FZPARMAX)
      INCLUDE 'MID_INCLUDE:FITC.INC/NOLIST'                                     

      EQUIVALENCE (XVAL(1),W)                                                   
C      EQUIVALENCE (XVAL(2),Y)
      EQUIVALENCE (XVAL(3),X(1))     

      DATA TYPE/'R*4'/                
                                                                                
      DO 200, I=1,10
         NULL(I) = .FALSE.
200   CONTINUE

      CALL STTPUT(' ',ISTAT)                                                    
      CALL STTPUT('Non-linear Least Square Fitting : '//                        
     +            'Newton-Raphson Method (defaulted)',ISTAT)                    
      CALL STTPUT('_______'//                                                   
     +     '___________________________________________________________'        
     +            ,ISTAT)                                                       
      CALL STTPUT(' ',ISTAT)                                                    
      CALL STTPUT(' ',ISTAT)                                                    
      CALL STTPUT(                                                              
     +         ' Print   Max. Fct. eval.  Prec. on Param.  Relax. Fact.'        
     +            ,ISTAT)                                                       
      WRITE (LINE,9000) NINT(FZMETPAR(1)),NINT(FZMETPAR(2)),                
     +  FZMETPAR(3),FZMETPAR(4)                                             
      CALL STTPUT(LINE,ISTAT)                                                   
      CALL STTPUT(' ',ISTAT)                                                    
      VCMATPR = FZMETPAR(1) .LE. 0.1                                          
      IPRINT = NINT(ABS(FZMETPAR(1)))                                         
      IF (IPRINT.EQ.0) IPRINT = ABS(NITER)                                      
      AUTO   = RELAX .LT. 0.                                                    
      RELAX  = ABS(RELAX)                                                       
      DO 10, I = 1,8  
          NULL(I) = .FALSE.                                                     
   10 CONTINUE                                                                  
      NEXT   = .TRUE.                                                           
      IF (NITER.GT.0) THEN                                                      
          DO 20, J = 1,FZNPTOT                                                 
              FZVALUE(J) = FZGUESS(J)                                       
   20     CONTINUE                                                              
          FZNITER = 0                                                         
          NITER1 = NITER 
      ELSE                                                                      
          NITER1 = -NITER                                                       
      END IF                                                                    
                                                                                
      VS     = MIN(V1,V2)                                                       
      VE     = MAX(V1,V2)                                                       
      FZCCHIS = 9999.                                                         
      FZCHISQ = 1.D-6                                                         
      FZRELAX = RELAX                                                         
      CORRNRM = 1.D6                                                            
      CHI    = 0.D0                                                             
      ICOUNT = 0                                                                
      IF (FZWEIGHT.EQ.0) THEN                                                 
          ISTAR  = 2                                                            
          W      = 1.                                                           
          NCOL   = FZNIND + 1                                                 
          ICOL(1) = 0                                                           
                                                                                
      ELSE                                                                      
          ISTAR  = 1                                                            
          NCOL   = FZNIND + 2                                                 
          ICOL(1) = FZWEIGHT                                                  
      END IF                                                                    
                                                                                
      ICOL(2) = FZDVAR                                                        
      NULL(1) = .FALSE.                                                         
      DO 30, I = 1,FZNIND                                                      
          ICOL(I+2) = FZIVAR(I)                                               
   30 CONTINUE                                                                  

      CALL TBIGET(FZIDEN,NC,NROW,NS,ACOL,AROW,ISTAT)                        
      KZ6941 = 0
99    KZ6941 = KZ6941 + 1
          IF ( .NOT. (NEXT)) GO TO 180                                          
          DO 50, I = 1,FZPARMAX 
              DO 40, J = 1,FZPARMAX
                  A(J,I) = 0.D0                                                 
   40         CONTINUE                                                          
              B(I)   = 0.D0                                                     
   50     CONTINUE                                                              
          CHIOLD = CHI                                                          
          CHI    = 0.D0                                                         
C                                                                               
C ITERATION FOR TABLES                                                          
C                                                                               
          N      = 0                                                            
          DO 100 IDAT = 1,NROW                                                  
              CALL TBSGET(FZIDEN,IDAT,ISEL,ISTAT)                             
C              XVAL(2) = Y     ! to avoid problems with the equivalence
              CALL TBRRDR(FZIDEN,IDAT,NCOL,ICOL(ISTAR),                  
     +                    XVAL(ISTAR),NULL(ISTAR),ISTAT)                        
              Y=XVAL(2)
              VALID  = ISEL .AND. ( .NOT. NULL(1)) .AND.                        
     +                 ( .NOT. NULL(2)) .AND. ( .NOT. NULL(3))                  
C                                                                               
C ...       COMPUTE FUNCTION VALUES AND DERIVATIVES (0 IF FIXED PARAM)          
C                                                                               
              IF (V1.NE.V2) VALID  = VALID .AND. XVAL(1) .GE. VS .AND.          
     +                               XVAL(1) .LE. VE                            
              IF (VALID) THEN                                                   
                  N      = N + 1                                                
                  Y1     = 0.                                                   
                  NOFFSET = 1                                                   
                  DO 60 IFUN = 1,FZNFUN                                       
                      CALL FTFUNC(FZFCODE(IFUN),FZNIND,X,                   
     +                            FZACTPAR(IFUN),FZVALUE(NOFFSET),          
     +                            YOUT,FZDERIV(NOFFSET))                      
                      Y1     = Y1 + YOUT                                        
                      NOFFSET = NOFFSET + FZACTPAR(IFUN)                      
   60             CONTINUE                                                      
                  DO 70 J = 1,FZNPTOT                                         
                      IP     = FZFIXED(J)                                     
                      IF (IP.EQ.0) FZDERIV(J) = 0.D0                          
                      IF (IP.GT.0) THEN                                         
                          FZDERIV(IP) = FZDERIV(IP) +                       
     +                                    FZDERIV(J)/FZPFAC(J)              
                          FZDERIV(J) = 0.D0                                   
                      END IF                                                    
                                                                                
   70             CONTINUE                                                      
C                                                                               
C ...         COMPUTE RESIDUALS, WEIGHTED RESIDUALS AND CHI**2                  
C                                                                               
                  W      = 1./ (W*W)                                            
                  Y2     = Y - Y1                                               
                  PP     = DBLE(W)                                              
                  IF (FZFLAG.EQ.1) PP     = 1.D0/AMAX1(1.0,SNGL(Y1))          
                  Q      = Y2                                                   
                  CHI    = CHI + Q*Q*PP                                         
C                                                                               
C ...         BUILD NORMAL EQUATION MATRIX                                      
C                                                                               
                  DO 90 J = 1,FZNPTOT                                         
                      AL     = FZDERIV(J)                                     
                      DO 80 K = 1,FZNPTOT                                     
                          A(J,K) = A(J,K) + AL*PP*FZDERIV(K)                  
   80                 CONTINUE                                                  
                      B(J)   = B(J) + PP*Q*AL                                   
   90             CONTINUE                                                      
              END IF                                                            
                                                                                
  100     CONTINUE                                                              
C                                                                               
C ...     ADD (PROBABILISTIC) PARAMETER CONSTRAINTS                             
C                                                                               
          NN     = N                                                            
          NP     = 0                                                            
          DO 110 I = 1,FZNPTOT                                                
              IF (FZFIXED(I).GE.0) THEN                                       
                  A(I,I) = 1.0D0                                                
                                                                                
              ELSE                                                              
                  NP     = NP + 1                                               
                  IF (FZUNCER(I).GT.0.) THEN                                  
                      NN     = NN + 1                                           
                      Q      = 1.0D0/DBLE(FZUNCER(I)*FZUNCER(I))            
                      A(I,I) = A(I,I) + Q                                       
                      B(I)   = B(I) + Q* (FZGUESS(I)-FZVALUE(I))            
C     ^                                                                         
C   To be modified for soft constraints                                         
                  END IF                                                        
                                                                                
              END IF                                                            
                                                                                
  110     CONTINUE                                                              
C                                                                               
C ...     INVERT NORMAL EQUATION MATRIX TO GET THE COVARIANCE MATRIX            
C                                                                               
          CALL DMATIN(A,FZNPTOT,FZPARMAX,FZFIXED,ISTAT) 
          NNP    = FZNPTOT                                                    
          IF (ISTAT.NE.0) THEN                                                  
              CALL STTPUT('*** ERR-NR  : Problems inverting matrix ***',        
     +                    ISTAT)                                                
              RETURN                                                            
                                                                                
          END IF                                                                
C                                                                               
C ... COMPUTE REDUCED CHI**2 AND CORRECTIONS FOR THE UNKNOWNS                   
C      
          FSUMSQ = CHI                                                         
          CHI    = DMAX1(CHI/DBLE(NN-NP),0.D0)                                
          CORRNRM = 0.D0                                                        
          DO 130 I = 1,FZNPTOT                                                
              Q      = 0.0D0                                                    
              DO 120 J = 1,FZNPTOT                                            
                  Q      = Q + A(I,J)*B(J)                                      
  120         CONTINUE                                                          
C                                                                               
C ... COMPUTE ERRORS OF THE CORRECTIONS (I.E. THE UNKNOWNS)                     
C ... AND APPLY CORRECTIONS (DO THE ADJUSTMENT!)                                
C                                                                               
              IF (FZFIXED(I).EQ.0) THEN                                       
                  FZERROR(I) = 0.D0                                           
                                                                                
              ELSE                                                              
                  Q      = RELAX*Q                                              
                  CORRNRM = CORRNRM + Q*Q                                       
                  FZERROR(I) = DSQRT(A(I,I)*CHI)                              
                  FZVALUE(I) = FZVALUE(I) + Q                               
              END IF                                                            
                                                                                
  130     CONTINUE                                                              
          CORRNRM = DSQRT(CORRNRM)                                              
C                                                                               
C ... LINEAR CONSTR. BETWEEN TWO PARAMS                                         
C                                                                               
          DO 140 I = 1,FZNPTOT                                                
              IP     = FZFIXED(I)                                             
              IF (IP.GT.0) THEN                                                 
                  FZERROR(I) = FZPFAC(I)*FZERROR(IP)                      
                  FZVALUE(I) = FZPFAC(I)*FZVALUE(IP)                      
              END IF                                                            
                                                                                
  140     CONTINUE                                                              
          ICOUNT = ICOUNT + 1                                                   
          FZNITER = FZNITER + 1                                             
          FZCCHIS = SNGL(CHI)                                                 
          NEXT   = ICOUNT .LT. NITER1 .AND. CORRNRM .GT. PREC                   
          IF ( .NOT. NEXT .OR. MOD(ICOUNT,IPRINT).EQ.0) THEN                    
              CALL STTPUT(' ',ISTAT)                                            
              CALL STTPUT(                                                      
     +        ' Iter  Fct. Eval.  Sum of Squares  Red. Chisq.   % Decr.'        
     +                    ,ISTAT)                                               
              IF (ICOUNT.GT.1) THEN                                             
                  CHIPERC = 100.* (CHIOLD-CHI)/CHIOLD                           
                  WRITE (LINE,9010) FZNITER,FZNITER,FSUMSQ,                 
     +              FZCCHIS,CHIPERC                                           
                                                                                
              ELSE                                                              
                  WRITE (LINE,9010) FZNITER,FZNITER,FSUMSQ,                 
     +              FZCCHIS                                                   
              END IF                                                            
                                                                                
              CALL STTPUT(LINE,ISTAT)                                           
              CALL STTPUT(' ',ISTAT)                                            
              CALL STTPUT('        Parameters   ',ISTAT)                        
              DO 150, I = 1,FZNPTOT                                            
                  WRITE (LINE,9020) FZVALUE(I)                                
                  CALL STTPUT(LINE,ISTAT)                                       
  150         CONTINUE                                                          
              CALL STTPUT(' ',ISTAT)                                            
          END IF                                                                
C                                                                               
C ... STORE THE CHISQ                                                           
C                                                                               
          IF (FZNITER.LE.100) THEN                                            
              FZCHI(FZNITER) = CHI                                          
              NILAST = FZNITER                                                
                                                                                
          ELSE                                                                  
              DO 160 I = 1,99                                                   
                  FZCHI(I) = FZCHI(I+1)                                     
  160         CONTINUE                                                          
              FZCHI(100) = CHI                                                
              NILAST = 100                                                      
          END IF                                                                
C                                                                               
C ...                                                                           
C                                                                               
          IF (AUTO) THEN                                                        
              IF (NILAST.GT.10) THEN                                            
C                                                                               
C ... CHECK FOR CONVERGENCE                                                     
C                                                                               
                  IF (FZCHI(NILAST-1).EQ.FZCHI(NILAST)) GO TO 190           
                  AC1    = ALOG(AMAX1(FZCHI(NILAST-2),0.0001))                
                  AC2    = ALOG(AMAX1(FZCHI(NILAST-1),0.0001))                
                  AC3    = ALOG(AMAX1(FZCHI(NILAST),0.0001))                  
                  C1     = AC1 - AC2                                            
                  C2     = AC2 - AC3                                            
                  IF (ABS(C2).LE.1.E-5) GO TO 190                               
                  DELTA  = ABS((C1-C2)/C2)                                      
                  IF (C2.GT.0.0 .AND. DELTA.LE.0.25) RELAX  = (1.0-             
     +                DELTA)**4                                                 
              END IF                                                            
                                                                                
          END IF                                                                
                                                                                
      GOTO 99
  180 CONTINUE                                                                  
  190 CALL STTPUT(' ',ISTAT)                                                    
      NACT   = FZNITER                                                        
      ACTCH  = FZCCHIS                                                        
      FZNDAT = N                                                              
      IF (CORRNRM.LE.PREC) THEN                                                 
          CALL STTPUT('  --> NR  : Convergence achieved <--',ISTAT)             
                                                                                
      ELSE                                                                      
          CALL STTPUT('*** WARN-NR  : No convergence reached ***',ISTAT)        
      END IF                                                                    
                                                                                
      CALL STTPUT(' ',ISTAT)                                                    
C                                                                               
C ... PRINT CORREL. MATRIX                                                      
C                                                                               
      IF (VCMATPR) CALL DCPRIN(A,NNP,FZPARMAX)
      RETURN                                                                    
                                                                                
 9000 FORMAT (I6,7X,I7,7X,1PE9.1,8X,0PF4.2)                                     
 9010 FORMAT (I5,6X,I5,3X,1PE12.4,2X,1PE12.4,4X,0PF5.2)                         
 9020 FORMAT (2X,1PD15.7)                                                       
      END                                                                       

C===========================================================================
C Copyright (C) 1995-2006 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================

C ++++++++++++++++++++++++  ytbr.for +++++++++++++++++++++++++++++++++++++++
C .LANGUAGE Fortran 77
C .IDENTIFICATION Module ytbr.foR
C  AUTHOR         K. Banse
C  Module contains layer between the table related FORTRAN TBxxxx interfaces
C  and the TC_interfaces written in (hopefully independent) C
C .KEYWORDS       standard interfaces.
C .ENVIRONMENT    FORTRAN and C standards
C .VERSION  [1.00] 871207:  created from SXFTOC.C
C 
C 060407	last modif
C -----------------------------------------------------------------------------
C
      SUBROUTINE TBRRDC(TID, ROW, NC, COLS, VALUE, NULL, STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   VALUE
      INTEGER     TID, ROW, NC, COLS, NULL
      INTEGER     STATUS
C 
      CALL STLOC(1,1,VALUE)                              !blanked CHAR_LOC
C 
      CALL TBR1(TID,ROW,NC,COLS,NULL,STATUS)
C
      RETURN
      END
C 
C 
      SUBROUTINE TBRGET(TID, CTYPE, ROW, NC, COLS, VALUE, NULL, STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   CTYPE
      INTEGER     TID, ROW, NC, COLS, NULL
      INTEGER     VALUE(*)
      INTEGER     STATUS
C
      CALL STSTR(1,CTYPE)                     !STRIPPED_STRING
C 
      CALL TBR3(TID,ROW,NC,COLS,VALUE,NULL,STATUS)
C
      RETURN
      END
C
C
      SUBROUTINE TBRPUT(TID, CTYPE, ROW, NC, COLS, VALUE, STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   CTYPE
      INTEGER     TID, ROW, NC, COLS
      INTEGER     VALUE(*)
      INTEGER     STATUS
C
      CALL STSTR(1,CTYPE)                     !STRIPPED_STRING
C
      CALL TBR4(TID,ROW,NC,COLS,VALUE,STATUS)
C
      RETURN
      END
C 
C
      SUBROUTINE TBRWRC(TID, ROW, NC, COLS, VALUE, STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   VALUE
      INTEGER     TID, ROW, NC, COLS
      INTEGER     STATUS
C
      CALL STLOC(1,0,VALUE)                              !untouched CHAR_LOC
C 
      CALL TBR2(TID,ROW,NC,COLS,STATUS)
C
      RETURN
      END
CC
CC all other TBRxyz functions
CC handled directly in tbr.fc

C @(#)blinkxy.for	19.1 (ES0-DMD) 02/25/03 13:23:04
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C @(#)blinkxy.for	19.1 (ESO-SDAG) 02/25/03 13:23:04
      SUBROUTINE BLINKXY(XBLINK,YBLINK,XCUR,YCUR,ITYP)
C
C TRANSFORMS BLINK COORDINATES INTO (+,-) MICRONS (ITYP=1) OR
C VICE VERSA (ITYP = 2). THE BLINK HAS 0.5 MICRON STEP AND
C NEGATIVE VALUES ARE REPRESENTED BY (10000000 + VALUE)
C
      IMPLICIT REAL*8 (A-H,O-Z), INTEGER*4 (I-N)
C
C BLINK COORDINATES INTO (+,-) MICRONS
C
      IF (ITYP.EQ.1) THEN
         IF (XBLINK.GT.5000000.) XBLINK = XBLINK -10000000.
         IF (YBLINK.GT.5000000.) YBLINK = YBLINK -10000000.
         XCUR = XBLINK/2.
         YCUR = YBLINK/2.
      ELSE
         XBLINK = XCUR*2.
         YBLINK = YCUR*2.
         IF (XBLINK.LT.0) XBLINK = XBLINK + 10000000.
         IF (YBLINK.LT.0) YBLINK = YBLINK + 10000000.
      ENDIF
      RETURN
      END   

C @(#)match.for	19.1 (ES0-DMD) 02/25/03 13:28:46
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C  @(#)match.for	19.1  (ESO-IPG)  02/25/03  13:28:46
      FUNCTION MATCH(WORD,KEY)
C
C       Copyright (C) Andrew T. Young, 1990
C
C   MATCH IS .TRUE. IF WORD MATCHES KEY.    Aug.10,1989
C
C
      IMPLICIT NONE
C
      INTEGER L1,L2,LWORD
C
      LOGICAL MATCH
      CHARACTER*(*) WORD, KEY
      CHARACTER*10 W1,W2
C
      W1=' '//WORD
      L1=LWORD(W1)
      IF(L1.EQ.0) GO TO 9
      W2=' '//KEY
      L2=LWORD(W2)
      IF (L1.LT.L2) THEN
        IF(INDEX(W2(:L2),W1(:L1)).GE.1)THEN
       MATCH=.TRUE.
       RETURN
        END IF
      ELSE
        IF(INDEX(W1(:L1),W2(:L2)).GE.1)THEN
       MATCH=.TRUE.
       RETURN
        END IF
      END IF
C  NO MATCH.
    9 MATCH=.FALSE.
      RETURN
      END

C @(#)carif.for	19.1 (ES0-DMD) 02/25/03 13:27:32
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C-----------------------------------------------------------------------
C
C.IDENTIFICATION
C
C  Program CARIF
C
C.AUTHOR
C
C  F. Murtagh, ST-ECF, Garching.             Version 1.0  9 May 1986
C  F. Murtagh                                Version 2.0  Oct. 1988
C                                             (New std. ifs.)
C
C.PURPOSE
C
C  Pass parameters to, and execute, CA (Correspondence Analysis).
C  The rows, only, are studied (i.e. in the parameter space).
C
C.INPUT/OUTPUT
C
C  P1 - P4 contain parameters; these are: input table name, output
C  table name, number of factors wanted (optional, - default
C  = 3), and whether or not a second output table is required, to store
C  the factor coordinates.
C
C.ALGORITHM
C
C . uses Midas Table interface routines;
C . input table is assumed to contain entries in single precision;
C . no select or null values;
C . all columns of the input table are sent to the CA routine;
C . description of the CA routine is in the corresponding program;
C . the output produced consists of one (or two) tables, and descriptors
C   to the first of these (eigenvalues): view with
C   READ/DESC outtable.TBL *
C . storage is limited only by the Midas Table system, and by the
C   overall system limitations;
C . assumed is: NROW > 7 or NCOLIN (this isn't a restrictive assumption).
C
C.MODIFICATIONS
C
C  NEW STANDARD INTERFACES, F. MURTAGH, AUG. 1988
C  New Table File System,   M. Peron,   SEP91 
C-----------------------------------------------------------------------
        PROGRAM CARIF
C
        CHARACTER*60     NAMEIN, NAMEOUT, TABEVEC
        CHARACTER*6     FORM
        CHARACTER*16    UNIT, LABEL, LABEL2
        INTEGER         MADRID, KUN, KNUL, DTYPE
        INTEGER         ISTAT,NACTV,NCOLIN,NROW,TID1
        INTEGER         NSORTC,NAC,NAR,I,IPTRIN
        INTEGER         LEN,NSEL,IWPTRIN,NTOT,INULL
        INTEGER         IACTV,TID,NCOLOUT,NNCOL,NNROW
        INTEGER         NSC1,NAROUT,IWPTROUT,IPTROUT
        INTEGER         IEVEC,TID2,NNAC,NAROUT2,IWPTROUT2
        INTEGER         IPTROUT2,IADD0,IADD1,IADD2,IADD3
        INTEGER         IADD4,IADD5,IADD6,IERR,KUNIT 
C
        INCLUDE         'MID_INCLUDE:TABLES.INC/NOLIST'
        COMMON          /VMR/MADRID(1)
        INCLUDE         'MID_INCLUDE:TABLED.INC/NOLIST'
C
C
C ...   Assuming this is our first action ...
C
        CALL STSPRO('CARIF')
        DTYPE  = D_R4_FORMAT
C
C ...   Get table name as a keyword passed in the command line.
C
        CALL STKRDC('P1',1,1,60,NACTV,NAMEIN,KUN,KNUL,ISTAT)
C
C ...   Read input table.
C
        CALL TBTOPN(NAMEIN,16,TID1,ISTAT)
        CALL TBIGET(TID1,NCOLIN,NROW,NSORTC,NAC,NAR,ISTAT)
        CALL TBCMAP(TID1,0,IPTRIN,ISTAT)
C
C ...   Some error checking on input.
C
        IF (NROW.LT.1.OR.NCOLIN.LT.1) THEN
           CALL STTPUT(' Nos. of rows/columns are less than 1.',ISTAT)
           CALL STTPUT(' What sort of a table is this ??',ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
C
        DO I = 1, NCOLIN
           CALL TBFGET(TID1,I,FORM,LEN,DTYPE,ISTAT)
           IF (DTYPE.NE.D_R4_FORMAT) THEN
              CALL STTPUT(' Illegal format:',ISTAT)
              CALL STTPUT(' Only R*4 column type allowed.',ISTAT)
              CALL STTPUT(' Aborting.',ISTAT)
              GOTO 9000
           ENDIF
        ENDDO
C
        CALL CHSEL(TID1,NROW,NSEL)
        IF (NSEL.NE.NROW) THEN
           CALL STTPUT(' Not all rows are SELECTed. ',ISTAT)
           CALL STTPUT(' In current implementation, MUST select all.',
     X                                                         ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
C
        CALL TDMGET(4*NROW*NCOLIN,IWPTRIN,ISTAT)
        CALL TBCMAP(TID1,1,IPTRIN,ISTAT)
        CALL MAPSM(MADRID(IPTRIN),MADRID(IWPTRIN),
     1              NAR,NROW,NCOLIN)
        NTOT = NROW*NCOLIN
        CALL CHNULL(MADRID(IWPTRIN),NTOT,INULL)
        IF (INULL.NE.0) THEN
           CALL STTPUT
     X     (' Null entries in the table are not allowed.',ISTAT)
           CALL STTPUT
     X     (' Use SELECT, and then construct another table.',
     X                                                   ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
C
C
C ...   Get the output table name, and no. of
C       cols. via keywords.
C
        CALL STKRDC('P2',1,1,60,IACTV,NAMEOUT,KUN,KNUL,ISTAT)
        CALL STKRDI('INPUTI',1,1,IACTV,NCOLOUT,KUN,KNUL,ISTAT)
C
C ...   Now create the output (projections) table.
C
        CALL TBTINI(NAMEOUT,F_TRANS,17,NCOLOUT,NROW,TID,ISTAT)
        FORM = 'G14.6'
        UNIT = ' '
C       (The messing around with LABEL2 which follows is so that
C       leading zeros in a column label appear as such, and not as
C       blanks.)
        LABEL = 'FAC00'
        LABEL2 = '10001'
        DO I = 1, NCOLOUT
           WRITE (LABEL2(1:5),100) I+10000
           LABEL(4:5) = LABEL2(4:5)
           CALL TBCINI(TID,DTYPE,1,FORM,UNIT,LABEL,NSORTC,ISTAT)
        ENDDO
  100   FORMAT(I5)
C
        CALL TBIGET(TID,NNCOL,NNROW,NSC1,NAC,NAROUT,ISTAT)
        CALL TDMGET(4*NCOLOUT*NROW,IWPTROUT,ISTAT)
        CALL TBCMAP(TID,1,IPTROUT,ISTAT)
        CALL MAPSM(MADRID(IPTROUT),MADRID(IWPTROUT),
     1              NAROUT,NROW,NCOLOUT)

C
        IEVEC = 0
        CALL STKRDC('INPUTC',1,1,60,IACTV,TABEVEC,KUN,KNUL,ISTAT)
        IF (TABEVEC.NE.'NO') THEN
           IEVEC = 1
C
C ...      Create the output (eigenvectors) table.
C
           CALL TBTINI(TABEVEC,F_TRANS,17,NCOLOUT,NCOLIN,TID2,ISTAT)
C          (The messing around with LABEL2 which follows is so that
C          leading zeros in a column label appear as such, and not as
C          blanks.)
           LABEL = 'EVC00'
           LABEL2 = '10001'
           DO I = 1, NCOLOUT
              WRITE (LABEL2(1:5),100) I+10000
              LABEL(4:5) = LABEL2(4:5)
              CALL TBCINI(TID2,DTYPE,1,FORM,UNIT,LABEL,NSORTC,ISTAT)
           ENDDO
C
           CALL TBIGET(TID2,NNCOL,NNROW,NSC1,NNAC,NAROUT2,ISTAT)
           CALL TDMGET(4*NCOLOUT*NCOLIN,IWPTROUT2,ISTAT)
           CALL TBCMAP(TID2,1,IPTROUT2,ISTAT)
           CALL MAPSM(MADRID(IPTROUT2),MADRID(IWPTROUT2),
     1                NAROUT2,NCOLIN,NCOLOUT)
        ENDIF
C

C
C ...   Allocate storage.
C
        CALL GETSTOR(NROW*NCOLIN,IADD0)
        CALL GETSTOR(NCOLIN*NCOLIN,IADD1)
        CALL GETSTOR(NCOLIN*NCOLIN,IADD2)
        CALL GETSTOR(NCOLIN,IADD3)
        CALL GETSTOR(NCOLIN,IADD4)
        CALL GETSTOR(NROW,IADD5)
        CALL GETSTOR(NCOLIN,IADD6)
C
C ...   We now have all the storage we need; APPL will look after
C       a few further odds and ends - e.g. setting a few hard-wired
C       options, rearranging output, etc.  Then it will call the
C       application program.
C
        IERR = 0
        IF (IEVEC.EQ.0) THEN
        CALL APPL1(NROW,NCOLIN,NCOLOUT,MADRID(IWPTRIN),MADRID(IWPTROUT),
     X     MADRID(IADD0),MADRID(IADD1),MADRID(IADD2),MADRID(IADD3),
     X     MADRID(IADD4),
     X     MADRID(IADD5),MADRID(IADD6),IERR)
        CALL MAPBG(MADRID(IWPTROUT),MADRID(IPTROUT),
     1             NAROUT,NROW,NCOLOUT)

        ELSE
        CALL APPL2(NROW,NCOLIN,NCOLOUT,MADRID(IWPTRIN),MADRID(IWPTROUT),
     X     MADRID(IADD0),MADRID(IADD1),MADRID(IADD2),MADRID(IADD3),
     X     MADRID(IADD4),
     X     MADRID(IWPTROUT2),MADRID(IADD5),MADRID(IADD6),IERR)
        CALL MAPBG(MADRID(IWPTROUT),MADRID(IPTROUT),
     1             NAROUT,NROW,NCOLOUT)
        CALL MAPBG(MADRID(IWPTROUT2),MADRID(IPTROUT2),
     1             NAROUT2,NCOLIN,NCOLOUT)

        ENDIF
        IF (IERR.EQ.1) THEN
           CALL STTPUT(' IERR = 1 on return from CA.',ISTAT)
           CALL STTPUT(' No convergence in eigenroutine.',ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
        IF (IERR.EQ.2) THEN
           CALL STTPUT(' IERR = 2 on return from CA.',ISTAT)
           CALL STTPUT(' All values in a row or column = 0.',ISTAT)
           CALL STTPUT
     X          (' Please remove this row or column and redo.',ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
        IF (IERR.NE.0) THEN
           CALL STTPUT(' IERR not 0 on return from CA.',ISTAT)
           CALL STTPUT(' Aborting.',ISTAT)
           GOTO 9000
        ENDIF
C
C ...   Write out descriptors with output table.
C
        CALL DSCROUT(NAMEOUT,NCOLIN,MADRID(IADD3),TID,KUNIT)
C
C ...   Finish up: write output file to disk, and release memory space.
C
        CALL RELSTOR(NROW*NCOLIN,IADD0)
        CALL RELSTOR(NCOLIN*NCOLIN,IADD1)
        CALL RELSTOR(NCOLIN*NCOLIN,IADD2)
        CALL RELSTOR(NCOLIN,IADD3)
        CALL RELSTOR(NCOLIN,IADD4)
        CALL RELSTOR(NROW,IADD5)
        CALL RELSTOR(NCOLIN,IADD6)
C
        CALL TBTCLO(TID1,ISTAT)
C
        CALL TBIPUT(TID,NCOLOUT,NROW,ISTAT)
        CALL TBSINI(TID,ISTAT)
        CALL TBTCLO(TID,ISTAT)
        IF (IEVEC.NE.0) THEN
           CALL TBIPUT(TID2,NCOLOUT,NCOLIN,ISTAT)
           CALL TBSINI(TID2,ISTAT)
           CALL TBTCLO(TID2,ISTAT)
        ENDIF
C
 9000   CONTINUE
        CALL STSEPI
C
        END
C----------------------------------------------------------------------
        SUBROUTINE APPL1(NR,NC1,NC2,AIN,AOUT,ACREA,A1,A2,W1,W2,
     X                          RR,CC,IERR)
C
C ...   This is now the application routine - note the setting of
C       IPRINT which in the future may be passed if desired
C       on the command line.
C
        INTEGER NR,NC1,NC2,IERR,I,IPRINT,J
        REAL*4  AIN(NR,NC1), AOUT(NR,NC2), ACREA(NR,NC1),A1(NC1,NC1),
     X          A2(NC1,NC1),W1(NC1),W2(NC1),RR(NR),CC(NC1)
C
        IPRINT = 1
C
        DO I = 1, NR
           DO J = 1, NC1
              ACREA(I,J) = AIN(I,J)
           ENDDO
        ENDDO
C
        CALL CA(NR,NC1,ACREA,IPRINT,A1,W1,W2,A2,RR,CC,IERR)
C
        IF (IERR.NE.0) RETURN
C
        DO I = 1, NR
           DO J = 1, NC2
              AOUT(I,J) = ACREA(I,J)
           ENDDO
        ENDDO
C
        RETURN
        END
C----------------------------------------------------------------------
        SUBROUTINE APPL2(NR,NC1,NC2,AIN,AOUT,ACREA,A1,A2,W1,W2,
     X             EVEC,RR,CC,IERR)
C
C ...   This is now the application routine - note the setting of
C       IPRINT which in the future may be passed if desired
C       on the command line.
C
        INTEGER   NR,NC1,NC2,IERR,IPRINT,I,J
        REAL*4  AIN(NR,NC1), AOUT(NR,NC2), ACREA(NR,NC1),A1(NC1,NC1),
     X          A2(NC1,NC1),W1(NC1),W2(NC1),EVEC(NC1,NC2),RR(NR),CC(NC1)
C
        IPRINT = 1
C
        DO I = 1, NR
           DO J = 1, NC1
              ACREA(I,J) = AIN(I,J)
           ENDDO
        ENDDO
C
        CALL CA(NR,NC1,ACREA,IPRINT,A1,W1,W2,A2,RR,CC,IERR)
C
        IF (IERR.NE.0) RETURN
C
        DO I = 1, NR
           DO J = 1, NC2
              AOUT(I,J) = ACREA(I,J)
           ENDDO
        ENDDO
C
        DO I = 1, NC1
           DO J = 1, NC2
              EVEC(I,J) = A2(I,NC1-J+1)
           ENDDO
        ENDDO
C
        RETURN
        END
C-------------------------------------------------------------------------
        SUBROUTINE CHNULL(X,NT,NULL)
C ...   Check if null values are present.
        INTEGER I,NT,NULL
        REAL*4  X(NT), TRNULL
        INTEGER TINULL
        DOUBLE PRECISION TDNULL
        CALL TBMNUL(TINULL,TRNULL,TDNULL)
        NULL = 0
        DO I = 1, NT
           IF (X(I).EQ.TRNULL) NULL = NULL + 1
           IF (NULL.GT.0) RETURN
        ENDDO
        RETURN
        END
C-------------------------------------------------------------------------
        SUBROUTINE GETSTOR(NVALS,IPTR)
        INTEGER NVALS,IPTR,ISTAT
C ...   Allocate storage space for NVALS real values.
        CALL TDMGET(4*NVALS,IPTR,ISTAT)
        RETURN
        END
C-------------------------------------------------------------------------
        SUBROUTINE RELSTOR(NVALS,IPTR)
        INTEGER NVALS,IPTR,ISTAT
C ...   Release storage space (already allocated) for NVALS real values.
        CALL TDMFRE(4*NVALS,IPTR,ISTAT)
        RETURN
        END
C---------------------------------------------------------------------
        SUBROUTINE DSCROUT(TAB,M,VALS,TID1,KUNIT)
C ...   Output descriptors, with table.
        INTEGER M,TID1,KUNIT,I,INDX,ISTAT
        REAL*4 VALS(M),V
        CHARACTER TAB*8, TABNAME*12
C
C ...   The following values are rearranged in decreasing rather
C       than increasing order.
        DO I = 1, M/2
           V = VALS(I)
           VALS(I) = VALS(M-I+1)
           VALS(M-I+1) = V
        ENDDO
C
        INDX = INDEX(TAB//' ',' ')-1
        TABNAME = TAB(1:INDX)//'.TBL'
C
C       CALL PUTDSCR_ST(TABNAME,'EIGENVALUES','R',VALS,1,M,ISTAT)
        CALL STDWRR(TID1,'EIGENVALUES',VALS,1,M,KUNIT,ISTAT)
C
        RETURN
        END

C @(#)row.for	19.1 (ES0-DMD) 02/25/03 13:30:48
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++   
C.IDENT:   ROW                                                                  
C.PURPOSE: Extracts a vector V from the array A ,starting from the element IF.  
C.NOTE   : Be careful with the out-of-bounds in A !                             
C          Must be IF+N-1 .LE. 'lastaddress'                                    
C          V has N elements.                                                    
C ------------------------------------------------------------------------------
      SUBROUTINE ROW(A,V,IF,N)                                                  
      IMPLICIT NONE
C
      REAL     A(1)
      REAL     V(1)                                                       
      INTEGER  IF
      INTEGER  N
C
      INTEGER  I
C                                                                               
      DO 10 I = 1,N                                                             
         V(I)   = A(I+IF-1)                                                     
   10 CONTINUE                                                                  
C                                                                               
      RETURN                                                                    
      END                                                                       

C @(#)peak.for	19.1 (ES0-DMD) 02/25/03 13:23:50
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE  DAOPK (PAR, MAXPAR, PSF, MAXPSF, MAXEXP, F, 
     .     WATCH, FITRAD, PERERR, PROERR)
C
C=======================================================================
C
C Single-star profile-fitting routine.
C
C              OFFICIAL DAO VERSION:  1991 April 18
C
C This subroutine reads in an array around each star in an input
C photometry file and fits the point-spread function to the observed 
C stellar profile by least-squares.  The three parameters solved for 
C are the brightness ratio between the PSF and the program star, and 
C the coordinates of the centroid of the program star.  
C
C Arguments
C
C  WATCH (INPUT) governs whether information relating to the progress 
C        of the reductions is to be typed on the terminal screen
C        during execution.
C
C FITRAD (INPUT) is the fitting radius.  Only pixels within FITRAD of 
C        the current estimate of a star's centroid will be included in 
C        the least-squares determination of its centroid and magnitude.
C
C All are user-definable optional parameters.
C
C=======================================================================
C
      IMPLICIT NONE
      INTEGER MAXPSF, MAXEXP, MAXBOX, MAXPAR
      PARAMETER  (MAXBOX=69)
C
C Parameters
C
C MAXPSF is the length of the side of the largest PSF look-up table
C        allowed.  (Note:  half-pixel grid size)
C
C MAXBOX is the length of the side of the largest box within which the
C        PSF can be evaluated.  (MAXBOX = (MAXPSF-7)/2 )
C
      CHARACTER*30 COOFIL, MAGFIL, PSFFIL, PROFIL, GRPFIL, SWITCH
      CHARACTER LINE*80, EXTEND*30, CASE*3
      REAL F(MAXBOX,MAXBOX)
      REAL PSF(MAXPSF,MAXPSF,MAXEXP), PAR(MAXPAR)
      INTEGER NINT, MIN0
C
      REAL LOBAD, AMAG, SHARP, CHI, ERRMAG, DELTAX, DELTAY
      REAL APMAG, RADIUS, FRAD, READNS, AP1, THRESH, HIBAD
      REAL PROERR, PERERR, FITRAD, WATCH, PHPADU, RONOIS
      REAL PERR, PKERR
      REAL X, Y, PSFMAG, BRIGHT, XPSF, YPSF, SCALE, SKY
      INTEGER RDPSF, NITER, IST, LX, LY, NX, NY
      INTEGER NFRAC, IBEG, ISTAR, NEXP, NPAR, NPSF, IPSTYP
      INTEGER IDUM, NL, ISTAT, NCOL, NROW, NTERM
C
      COMMON /SIZE/ NCOL, NROW
      COMMON /FILNAM/ COOFIL, MAGFIL, PSFFIL, PROFIL, GRPFIL
      COMMON /ERROR/ PHPADU, RONOIS, PERR, PKERR
C
C-----------------------------------------------------------------------
C
C SECTION 1
C
C Ascertain the name of the file containing coordinates and magnitude
C estimates for the program stars.  Open it and read the header.
C
      CALL TBLANK
  950 CALL GETNAM ('File with aperture results:', MAGFIL)
      IF ((MAGFIL .EQ. 'END OF FILE') .OR.
     .     (MAGFIL .EQ. 'GIVE UP')) THEN
         MAGFIL = ' '
         RETURN
      END IF
      CALL INFILE (2, MAGFIL, ISTAT)
      IF (ISTAT .NE. 0) THEN
         MAGFIL = 'GIVE UP'
         GO TO 950
      END IF
C
      CALL RDHEAD (2, NL, IDUM, IDUM, LOBAD, HIBAD, THRESH, AP1, 
     .     PHPADU, READNS, FRAD)
      RONOIS=READNS**2
C
C Ascertain the name of the PSF file, open it, and read the PSF.
C
  900 CALL GETNAM ('File with the PSF:', PSFFIL)
      IF ((PSFFIL .EQ. 'END OF FILE') .OR.
     .     (PSFFIL .EQ. 'GIVE UP')) THEN
         PSFFIL = ' '
         CALL CLFILE (2)
         RETURN
      END IF
C
      ISTAT = RDPSF (PSFFIL, IPSTYP, PAR, MAXPAR, NPAR,
     .     PSF, MAXPSF, MAXEXP, NPSF, NEXP, NFRAC,
     .     PSFMAG, BRIGHT, XPSF, YPSF)
      IF (ISTAT .NE. 0) THEN
         PSFFIL = 'GIVE UP'
         GO TO 900
      END IF
C
      NTERM = NEXP+NFRAC
      PERR = 0.01*PERERR
      PKERR = 0.01*PROERR/(PAR(1)*PAR(2)) ! **2
C
C Get ready to do the PEAK fitting:  get the name of the output file.
C Open it and write the header.
C
      PROFIL=SWITCH(MAGFIL, CASE('.pk'))
  960 CALL GETNAM ('File for PEAK results:', PROFIL)
      IF ((PROFIL .EQ. 'END OF FILE') .OR.
     .     (PROFIL .EQ. 'GIVE UP')) THEN
         CALL CLFILE (2)
         PROFIL = ' '
         RETURN
      END IF
      PROFIL = EXTEND(PROFIL, CASE('pk'))
      CALL OUTFIL (3, PROFIL, ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error opening output file '//PROFIL)
         PROFIL = 'GIVE UP'
         GO TO 960
      END IF
C
      RADIUS = AMIN1( FITRAD, (REAL(NPSF-1)/2. - 1.)/2. )
      CALL WRHEAD (3, 1, NCOL, NROW, 7, LOBAD, HIBAD, THRESH, AP1, 
     .     PHPADU, READNS, RADIUS)
      IF (WATCH .GT. 0.5) CALL TBLANK               ! Type a blank line
      IBEG=1
C
C-----------------------------------------------------------------------
C
C SECTION 2
C
C Reduce the stars, one by one.
C
C Read data for the next star and initialize things.
C
 2000 CALL RDSTAR (2, NL, ISTAR, X, Y, APMAG, SKY)
      IF (ISTAR .LT. 0) GO TO 9000            ! End-of-file encountered
      IF (ISTAR .EQ. 0) GO TO 2000            ! Blank line encountered
      IF (APMAG .GE. 99.) APMAG=PSFMAG+5.     ! The ol' college try
      DELTAX=(X-1.)/XPSF-1.
      DELTAY=(Y-1.)/YPSF-1.
      LX=MAX0(1, INT(X-RADIUS)+1)
      LY=MAX0(1, INT(Y-RADIUS)+1)
      NX=MIN0(NCOL, INT(X+RADIUS)) - LX + 1
      NY=MIN0(NROW, INT(Y+RADIUS)) - LY + 1
      CALL RDARAY ('DATA', LX, LY, NX, NY, MAXBOX, F, IST)
C
C At this point LX, LY are the coordinates in the big picture of the
C first pixel in the subarray.  The dimensions of the subarray are
C NX, NY.  
C
      X=X-LX+1
      Y=Y-LY+1
C
C X,Y are now the coordinates of the star's centroid in the subframe 
C (where (x,y)=(1.0,1.0) are the coordinates of the center of the first
C pixel and (x,y)=(NX,NY) are the coordinates of the center of the last
C pixel in the subarray).
C
C Display the subarray on the terminal, if desired, and type out headers
C if appropriate.
C
      IF (WATCH .GT. 1.5) CALL SHOW (F, F(NINT(X),NINT(Y)), 0.9*SKY,
     .     NX, NY, MAXBOX)
      IF ((WATCH .GT. 1.5) .OR. ((WATCH .GT. 0.5) .AND. (IBEG .EQ. 1)))
     .     WRITE (6,620)
  620 FORMAT (9X, 'STAR', 6X, 'X', 8X, 'Y', 8X, 'MAGNITUDE', 7X,
     .     'CHI  SHARP   IT')
      IBEG=2
      SCALE=10.**(-0.4*(APMAG-PSFMAG))                 ! Starting value
      CALL PKFIT (F, NX, NY, MAXBOX, X, Y, SCALE, SKY, RADIUS, LOBAD, 
     .     HIBAD, BRIGHT, IPSTYP, PAR, MAXPAR, NPAR, 
     .     PSF, MAXPSF, MAXEXP, NPSF, NEXP, NFRAC, 
     .     DELTAX, DELTAY, ERRMAG, CHI, SHARP, NITER)
      IF (NITER .GT. 0) GO TO 2010
C
C A singular matrix occurred during the least-squares solution.
C
      WRITE (LINE,621) ISTAR
  621 FORMAT (8X, I5, ' had a singular matrix.')
      CALL STUPID (LINE)
      GO TO 2000
C
C Everything went fine.
C
 2010 X=X+LX-1.
      Y=Y+LY-1.
      AMAG=PSFMAG-2.5*ALOG10(SCALE)
      ERRMAG=AMIN1(2.0, 1.086*ERRMAG/SCALE)
      IF (WATCH .GT. 0.5) WRITE (6,622) ISTAR, X, Y, AMAG, ERRMAG,
     .     CHI, SHARP, NITER
  622 FORMAT (8X, I5, 2F9.2, F9.3, ' +- ', F5.3, 2F7.2, I5)
      WRITE (3,320) ISTAR, X, Y, AMAG, ERRMAG, SKY, FLOAT(NITER), CHI,
     .     SHARP
  320 FORMAT (I6, 3F9.3, F9.4, F9.3, F9.0, F9.2, F9.3)
      GO TO 2000
C
C-----------------------------------------------------------------------
C
C Normal return.
C
 9000 CALL CLFILE (3)
      CALL CLFILE (2)
      CALL STUPID ('    Done.')
      RETURN
C
      END!
C
C#######################################################################
C
      SUBROUTINE  PKFIT (F, NX, NY, MAXBOX, X, Y, SCALE, SKY, RADIUS,
     .     LOBAD, HIBAD, BRIGHT, IPSTYP, PAR, MAXPAR, NPAR,
     .     PSF, MAXPSF, MAXEXP, NPSF, NEXP, NFRAC, 
     .     DELTAX, DELTAY, ERRMAG, CHI, SHARP, NITER)
C
C=======================================================================
C
C This is the subroutine which does the actual one-star least-squares
C profile fit for PEAK. 
C
C           OFFICIAL DAO VERSION:  1991 April 6
C
C Arguments
C      F (INPUT) is an NX by NY array containing actual picture data.
C
C MAXBOX (INPUT) is the maximum value allowable for either NX or NY,
C        needed for the dimension statements below.  PEAK and PSF will
C        provide different values of MAXBOX.
C
C  SCALE (INPUT/OUTPUT) is the initial estimate of the brightness of
C        the star, expressed as a fraction of the brightness of the
C        PSF.  Upon return, the final computed value of SCALE will
C        be passed back to the calling routine.
C
C   X, Y (INPUT/OUTPUT) are the initial estimates of the centroid of 
C        the star relative to the corner (1,1) of the subarray.  Upon
C        return, the final computed values of X and Y will be passed 
C        back to the calling routine.
C
C    SKY (INPUT) is the local sky brightness value, carried on from
C        PHOTOMETRY via the data files.
C
C RADIUS (INPUT) is the fitting radius-- only pixels within RADIUS of
C        the instantaneous estimate of the star's centroid will be
C        included in the fit.
C
C LOBAD and HIBAD (INPUT) are bad pixel limits-- any pixel whose 
C        brightness value falls outside this range will be presumed to 
C        be bad, and will be ignored.
C
C BRIGHT (INPUT) contains the brightness normalization of the model
C        analytic point spread function
C
C    PAR (INPUT) contains the values of the remaining NPARAM parameters 
C        defining the analytic function which approximates the core of 
C        the PSF.
C
C    PSF (INPUT) is an NPSF by NPSF by NEXP+NFRAC look-up table 
C        containing corrections from the analytic approximation of the 
C        PSF to the true PSF.
C
C ERRMAG (OUTPUT) is the estimated standard error of the value of SCALE
C        returned by this routine.
C
C    CHI (OUTPUT) is the estimated goodness-of-fit statistic:  the ratio
C        of the observed pixel-to-pixel mean absolute deviation from
C        the profile fit, to the value expected on the basis of the
C        read-out noise and the photons/ADU (which are brought in
C        through COMMON block /ERROR/).
C
C  SHARP (OUTPUT) is a goodness-of-fit statistic describing how much
C        broader the actual profile of the object appears than the
C        profile of the PSF.
C
C  NITER (OUTPUT) is the number of iterations the solution required to
C        achieve convergence.  If NITER = 50, the solution did not 
C        converge.  If for some reason a singular matrix occurs during
C        the least-squares solution, this will be flagged by setting
C        NITER = -1.
C
C=======================================================================
C        
      IMPLICIT NONE
      INTEGER MAXPSF, MAXEXP, MAXBOX, MAXPAR
C
C Parameter
C
C MAXPSF is the length of the side of the largest PSF look-up table
C        allowed.  (Note:  half-pixel grid spacing)
C
      REAL C(3,3), V(3), CLAMP(3), DTOLD(3)
      REAL F(MAXBOX,MAXBOX), T(3), DT(3), NUMER
      REAL PSF(MAXPSF,MAXPSF,MAXEXP), PAR(MAXPAR)
      REAL USEPSF, AMAX1, AMIN1, ABS
      INTEGER MIN0, MAX0
C
      REAL LOBAD, DF, WT, DFDSIG, RHOSQ, RELERR, SIG, SIGSQ
      REAL FPOS, DVDXC, DVDYC, RSQ, DX, DXSQ, DY, DYSQ, DATUM
      REAL DENOM, SUMWT, CHIOLD, RADSQ, SHARP, CHI, ERRMAG
      REAL DELTAX, DELTAY, X, Y, PHPADU, RONOIS, PERR, PKERR
      REAL SCALE, SKY, RADIUS, HIBAD, BRIGHT
      INTEGER I, J, IX, IY, IXLO, IXHI, IYLO, IYHI, ISTAT
      INTEGER NPIX, NFRAC, NEXP, NITER, NPAR, NPSF, IPSTYP
      INTEGER NX, NY, NCOL, NROW
      LOGICAL CLIP, REDO
C
      COMMON /SIZE/ NCOL, NROW
      COMMON /ERROR/ PHPADU, RONOIS, PERR, PKERR
C
C-----------------------------------------------------------------------
C
C Initialize a few things for the solution.
C
      RADSQ=RADIUS**2
      DO 1010 I=1,3
      CLAMP(I)=1.
 1010 DTOLD(I)=0.0
      CHIOLD=1.
      NITER=0
      SHARP=0.
      CLIP = .FALSE.
C
C-----------------------------------------------------------------------
C
C Here begins the big least-squares loop.
C
 2000 NITER=NITER+1
C
C Initialize things for this iteration.  CHI and SHARP will be 
C goodness-of-fit indices.  CHI will also be used in determining the 
C weights of the individual pixels.  As the solution iterates, the new 
C value of CHI will be built up in the variable CHI, while a smoothed
C value of CHI computed from the previous iteration will be carried 
C along in CHIOLD.
C
      CHI=0.0
      SUMWT=0.0
      NUMER=0.0
      DENOM=0.0
      DO 2010 I=1,3
      V(I)=0.0                          ! Zero the vector of residuals
      DO 2010 J=1,3
 2010 C(I,J)=0.0                        ! Zero the normal matrix
C
C Choose the little box containing points inside the fitting radius.
C
      IXLO=MAX0(1, INT(X-RADIUS))
      IYLO=MAX0(1, INT(Y-RADIUS))
      IXHI=MIN0(NX, INT(X+RADIUS)+1)
      IYHI=MIN0(NY, INT(Y+RADIUS)+1)
C
C Now build up the normal matrix and vector of residuals.
C
      NPIX=0
      DO 2090 IY=IYLO,IYHI
      DY=FLOAT(IY)-Y
      DYSQ=DY**2
      DO 2090 IX=IXLO,IXHI
      DATUM=F(IX,IY)
      IF ((DATUM .LT. LOBAD) .OR. (DATUM .GT. HIBAD)) GO TO 2090
      DX=FLOAT(IX)-X
      DXSQ=DX**2
C
C DX and DY are the distance of this pixel from the centroid of the 
C star.  Is this pixel truly inside the fitting radius?
C
      RSQ=(DXSQ+DYSQ)/RADSQ
      IF (1.-RSQ .LE. 2.E-6) GO TO 2090   ! Prevents floating underflows
C
C The fitting equation is of the form
C 
C Observed brightness = 
C     [SCALE + delta(SCALE)] * [PSF + delta(Xcen)*d(PSF)/d(Xcen) +
C                                           delta(Ycen)*d(PSF)/d(Ycen) ]
C
C and is solved for the unknowns delta(SCALE) ( = the correction to 
C the brightness ratio between the program star and the PSF) and 
C delta(Xcen) and delta(Ycen) ( = corrections to the program star's 
C centroid).
C
C The point-spread function is equal to the sum of the integral under
C a two-dimensional analytic profile plus values interpolated from
C a look-up table.
C
      T(1)=USEPSF(IPSTYP, DX, DY, BRIGHT, PAR, PSF, NPSF, NPAR, NEXP, 
     .     NFRAC, DELTAX, DELTAY, DVDXC, DVDYC)
      IF ((SCALE*T(1)+SKY .GT. HIBAD) .AND. (NITER.GE.3)) GO TO 2090
      T(2)=SCALE*DVDXC
      T(3)=SCALE*DVDYC
      DF=F(IX,IY)-SKY-SCALE*T(1)
C
C DF is the residual of the brightness in this pixel from the PSF fit.
C
C The expected random error in the pixel is the quadratic sum of
C the Poisson statistics, plus the readout noise, plus an estimated
C error of PERERR% of the total brightness for the difficulty of flat-
C fielding and bias-correcting the chip, plus an estimated error of 
C some fraction of the fourth derivative at the peak of the profile,
C to account for the difficulty of accurately interpolating within the 
C point-spread function.  The fourth derivative of the PSF is roughly
C proportional to H/sigma**4 (sigma is the width parameter for
C the stellar core); using the geometric mean of sigma(x) and sigma(y), 
C this becomes H/[sigma(x)*sigma(y)]**2.  The ratio of the fitting 
C error to this quantity is estimated from a good-seeing CTIO frame to 
C be approximately 0.027.  NOWADAYS, PAR(1) and PAR(2) are the HWHM,
C not the sigma, so the coefficient is now of order 0.05 = 5.0%.
C
      FPOS=AMAX1(0., F(IX,IY)-DF)
C
C FPOS = raw data minus residual = model-predicted value of the 
C intensity at this point (which presumably is non-negative).
C
      SIGSQ=FPOS/PHPADU+RONOIS+(PERR*FPOS)**2+(PKERR*(FPOS-SKY))**2
      SIG=SQRT(SIGSQ)
      RELERR=ABS(DF/SIG)
C
C SIG is the anticipated standard error of the intensity in this pixel,
C including readout noise, Poisson photon statistics, and an estimate
C of the standard error of interpolating within the PSF.  
C
      WT=5./(5.+RSQ/(1.-RSQ))             ! Weight as function of radius
C
C Now add this pixel into the quantities which go to make up the SHARP
C index.
C
      RHOSQ=DXSQ/PAR(1)**2+DYSQ/PAR(2)**2
C
C Include in the sharpness index only those pixels within six
C HWHMs of the centroid of the star.  (This saves time and
C floating underflows by excluding pixels which contribute less than
C about one part in a million to the index.)
C
      IF (RHOSQ .LE. 36.) THEN
         RHOSQ=0.6931472*RHOSQ
         DFDSIG=EXP(-RHOSQ)*(RHOSQ-1.)
         FPOS=AMAX1(0., F(IX,IY)-SKY)+SKY
         NUMER=NUMER+DFDSIG*DF/SIGSQ
         DENOM=DENOM+DFDSIG**2/SIGSQ
      END IF
C
C Derive the weight of this pixel.  First of all, the weight depends
C upon the distance of the pixel from the centroid of the star-- it
C is determined from a function which is very nearly unity for radii
C much smaller than the fitting radius, and which goes to zero for
C radii very near the fitting radius.  Then reject any pixels with 
C 10-sigma residuals (after the first iteration).
C
      CHI=CHI+WT*RELERR
      SUMWT=SUMWT+WT
C
C Now the weight is scaled to the inverse square of the expected mean 
C error.
C
      WT=WT/SIGSQ
C
C Reduce the weight of a bad pixel.  A pixel having a residual of 2.5
C sigma gets reduced to half weight; a pixel having a residual of 5.
C sigma gets weight 1/257.
C
      IF (CLIP) WT=WT/(1.+(0.4*RELERR/CHIOLD)**8)
C
C Now add the pixel into the vector of residuals and the normal matrix.
C
      DO 2030 I=1,3
      V(I)=V(I)+DF*T(I)*WT
      DO 2030 J=1,3
 2030 C(I,J)=C(I,J)+T(I)*T(J)*WT
C
      NPIX=NPIX+1
 2090 CONTINUE                                 ! End of loop over pixels
C
C Compute the (robust) goodness-of-fit index CHI.
C
      IF (SUMWT .GT. 3.) THEN
         CHI=1.2533141*CHI/SQRT(SUMWT*(SUMWT-3.))
C
C CHI is pulled toward its expected value of unity before being stored
C in CHIOLD to keep the statistics of a small number of pixels from 
C completely dominating the error analysis.  
C
         CHIOLD=((SUMWT-3.)*CHI+3.)/SUMWT
      ELSE
         CHI = 1.
         CHIOLD = 1.
      END IF
C
C Compute the parameter corrections and check for convergence.
C
      IF (NPIX .LT. 3) THEN
         NITER=-1
         RETURN
      END IF
      CALL INVERS (C, 3, 3, ISTAT)
      IF (ISTAT .EQ. 0) GO TO 2100
      NITER=-1
      RETURN
C
C Everything OK so far.
C
 2100 CALL VMUL (C, 3, 3, V, DT)
C 
C In the beginning, the brightness of the star will not be permitted
C to change by more than two magnitudes per iteration (that is to say, 
C if the estimate is getting brighter, it may not get brighter by
C more than 525% per iteration, and if it is getting fainter, it may
C not get fainter by more than 84% per iteration).  The x and y
C coordinates of the centroid will be allowed to change by no more
C than one-half pixel per iteration.  Any time that a parameter
C correction changes sign, the maximum permissible change in that
C parameter will be reduced by a factor of 2.
C
      DO 2110 I=1,3
      IF (DTOLD(I)*DT(I) .LT. 0.) THEN
         CLAMP(I)=0.5*CLAMP(I)
      ELSE
         CLAMP(I)=MIN(1., 1.1*CLAMP(I))
      END IF
 2110 DTOLD(I)=DT(I)
C
      SCALE=SCALE+DT(1)/
     .  (1.+AMAX1(DT(1)/(5.25*SCALE),-DT(1)/(0.84*SCALE))/CLAMP(1))
      X=X+DT(2)/(1.+ABS(DT(2))/(0.4*CLAMP(2)))
      Y=Y+DT(3)/(1.+ABS(DT(3))/(0.4*CLAMP(3)))
      IF (NITER .LE. 1) GO TO 2000
      REDO=.FALSE.
C
C Convergence criteria:  if the most recent computed correction to the 
C brightness is larger than 0.01% or than 0.05 * sigma(brightness),
C whichever is larger, OR if the absolute change in X or Y is
C greater than 0.001 pixels, convergence has not been achieved.
C
      ERRMAG=CHIOLD*SQRT(C(1,1))
      IF (CLIP) THEN
         IF (ABS(DT(1)) .GT. 
     .        AMAX1( 0.05*ERRMAG, 0.0001*SCALE )) THEN
            REDO=.TRUE.
         ELSE IF (AMAX1(ABS(DT(2)),ABS(DT(3))) .GT. 0.001) THEN
            REDO=.TRUE.
         END IF
      ELSE
         IF (ABS(DT(1)) .GT. 
     .        AMAX1( ERRMAG, 0.002*SCALE )) THEN
            REDO = .TRUE.
         ELSE IF (AMAX1(ABS(DT(2)),ABS(DT(3))) .GT. 0.02) THEN
            REDO = .TRUE.
         END IF
      END IF
C
      IF (NITER .GE. 50) REDO = .FALSE.
      IF (REDO) GO TO 2000
      IF ((NITER .LT. 50) .AND. (.NOT. CLIP)) THEN
         CLIP = .TRUE.
         DO I=1,3
            DTOLD(I) = 0.
            CLAMP(I) = AMAX1(CLAMP(I), 0.25)
         END DO
         GO TO 2000
      ELSE
         SHARP=1.4427*PAR(1)*PAR(2)*NUMER/(BRIGHT*SCALE*DENOM)
         SHARP=AMIN1(99.999,AMAX1(SHARP,-99.999))
         RETURN
      END IF
C
      END!

C @(#)modcol.for	13.1.1.2 (ESO-DMD) 02/12/99 19:14:48
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  program MODCOL		version 1.00	881028
C  K. Banse			ESO - Garching
C  M.Peron                      910417  modif in the call of TCLSER
C  S. Wolf                      980113  not selected table-rows has not
C                                       to be processed (swolf@eso.org)!
C.KEYWORDS
C  bulk data frame, bad pixels
C
C.PURPOSE
C
C  to replace a column or row of undefined or bad pixels values by quadratic
C  interpolation of adjacent columns or rows.The bad columns or rows are
C  defined via the cursor or coordinates or taken from a table.
C
C.ALGORITHM
C
C  The adjacent pixels are used to compute the coefficients of a least-squares
C  approximating second order polynomial
C
C.INPUT/OUTPUT
C  the following keywords are used:
C  P1/C/1/60			input frame, table
C				or
C				CURSOR
C				or
C				input frame
C  IN_A/C/1/60			input frame, if P1 does not indicate table use
C  OUT_A/C/1/60			result frame
C  ACTION/C/1/2			C or R, for column or row
C  				V or C for variable or constant offset
C				of column/row in question
C  P4/C/1/80			column or row world coords. if P1 holds just
C				input frame
C
C.VERSIONS
C
C  1.00		from program MODICOL version 2.20 as of 850212
C  		use FORTRAN 77 + new ST interfaces
C
C-------------------------------------------------------------------
C
      PROGRAM MODCOL
C 
      IMPLICIT NONE
C
      INTEGER      N,NCOUNT,IAV,ISTAT
      INTEGER*8    PNTRA,PNTRB,PNTRX,PNTRY
      INTEGER      IMNOA,IMNOB,STAT
      INTEGER      INDXFL,SIZE,NAXIS,SLEN,SLEN1,TBLFLG
      INTEGER      NCOL,NROW
      INTEGER      IBUF(2),KINDEX,OFF,KROW,KROW1,KROW2
      INTEGER      TIDI,TABCLN(1)
      INTEGER      UNI(1),NULO,MADRID(1)
      INTEGER      NPIXA(2)
C
      CHARACTER    CUNITA*48,IDENTA*72,ACTION*2,COLROW*80
      CHARACTER    FRAMEA*80,FRAMEB*80,TABLE*80
      CHARACTER    OUTPUT*80,COLNAM*20
      CHARACTER    MESS(2)*50,ERRMS1*40,ERRMS2*40
      CHARACTER    SUBPAR(40)*30
C
      REAL         TEMP,CUTS(4),FMIN,FMAX,RMIN,RMAX,RR
C
      DOUBLE PRECISION STARTA(2),STEPA(2),DD
C
      LOGICAL      TABNUL(1),SELFLG
C
      COMMON   /VMR/  MADRID
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      DATA      FRAMEA   /' '/,    FRAMEB   /' '/
      DATA      IDENTA   /' '/,    CUNITA    /' '/
      DATA      OUTPUT   /' '/,    TABLE    /' '/
      DATA      MESS     /'column/row too close to image boundary... ',
     +                   'column/row too large...'/
      DATA      ERRMS1   /'col/row no.s missing...'/
      DATA      ERRMS2   /'invalid syntax for col/row no.s ...'/
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C  get into MIDAS environment
      CALL STSPRO('MODCOL')
C
C  get input option (frame or frame,table) + read keys
      CALL STKRDC('IN_A',1,1,80,IAV,OUTPUT,UNI,NULO,STAT)
      CALL STKRDC('ACTION',1,1,2,IAV,ACTION,UNI,NULO,STAT)
      CALL UPCAS(ACTION,ACTION)
      IF (ACTION(1:1).EQ.'C') THEN
         INDXFL = 1                  !index = 1 for columns...
      ELSE
         INDXFL = 2                  !index = 2 for rows
      ENDIF
C
      N = INDEX(OUTPUT,',')
      IF (N.GT.0) THEN
         TBLFLG = 2
         FRAMEA(1:) = OUTPUT(1:N-1)
         CALL CLNFRA(FRAMEA,FRAMEA,0)             !because it's not isolated
         TABLE(1:) = OUTPUT(N+1:)
         N = INDEX(TABLE,',')
         IF (N.GT.0) THEN
            IAV = N
            IF (TABLE(N+1:N+1).EQ.':') IAV = N + 1
            COLNAM(1:) = TABLE(IAV+1:)//' '
            TABLE(N:) = ' '
         ELSE
            IF (ACTION(1:1).EQ.'C') THEN         !default column labels
               COLNAM(1:) = 'X '
            ELSE
               COLNAM(1:) = 'Y '
            ENDIF
         ENDIF
         CALL TBTOPN(TABLE,F_I_MODE,TIDI,STAT)
         CALL TBIGET(TIDI,NCOL,NROW,N,N,N,STAT)
         CALL TBLSER(TIDI,COLNAM,TABCLN(1),STAT)      !find columns...
         IF (TABCLN(1).LE.0) THEN
            N = INDEX(COLNAM,' ')
            OUTPUT(1:) = 'column '//COLNAM(1:N)//
     +                   ' not found in input table...'
            CALL STETER (9,OUTPUT)
         ENDIF
      ELSE
         TBLFLG = 1
         FRAMEA(1:) = OUTPUT(1:)
         CALL STKRDC('P4',1,1,80,IAV,COLROW,UNI,NULO,STAT)      !get coords.
      ENDIF
      CALL STKRDC('OUT_A',1,1,80,IAV,FRAMEB,UNI,NULO,STAT)
C
C  map input + result frame
      CALL GENEQF(FRAMEA,FRAMEB,STAT)
      IF (STAT.EQ.1) THEN                !same name
         CALL STIGET(FRAMEA,D_R4_FORMAT,F_IO_MODE,F_IMA_TYPE,
     +               2,NAXIS,NPIXA,STARTA,STEPA,IDENTA,
     +               CUNITA,PNTRA,IMNOA,STAT)
         IF (NAXIS.LT.2) THEN
            CALL STETER(1,'input frame must be a 2-dim frame...')
         ELSE IF (NAXIS.GT.2) THEN
            CALL STTPUT
     +      ('only first plane of 3-dim input frame processed',STAT)
            NAXIS = 2
         ENDIF
         PNTRB = PNTRA
         IMNOB = IMNOA
         SIZE = NPIXA(1)*NPIXA(2)
      ELSE
         CALL STIGET(FRAMEA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +               2,NAXIS,NPIXA,STARTA,STEPA,IDENTA,
     +               CUNITA,PNTRA,IMNOA,STAT)
         IF (NAXIS.LT.2) THEN
            CALL STETER(1,'input frame must be a 2-dim frame...')
         ELSE IF (NAXIS.GT.2) THEN
            CALL STTPUT
     +      ('only first plane of 3-dim input frame processed',STAT)
            NAXIS = 2
         ENDIF
         CALL STIPUT(FRAMEB,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +               NAXIS,NPIXA,STARTA,STEPA,IDENTA,
     +               CUNITA,PNTRB,IMNOB,STAT)
         SIZE = NPIXA(1)*NPIXA(2)
         CALL COPYF(MADRID(PNTRA),MADRID(PNTRB),SIZE)            !copy data...
      ENDIF
      CALL FRAMOU(FRAMEA)
C
      IF (ACTION(1:1).EQ.'C') THEN                !allocate workspace
         SIZE = NPIXA(2)
      ELSE
         SIZE = NPIXA(1)
      ENDIF
      CALL STFXMP(SIZE,D_R4_FORMAT,PNTRX,STAT)
      CALL STFXMP(SIZE,D_R4_FORMAT,PNTRY,STAT)
C 
C  save min,max + cuts of image
      CALL STDRDR(IMNOA,'LHCUTS',1,4,IAV,CUTS,UNI,NULO,STAT)
      RMIN = CUTS(3)
      RMAX = CUTS(4)
C
C  fork according to input mode
      IF (TBLFLG.EQ.2) THEN
         KROW2 = 0
         ISTAT = 2                           !thus we start with KROW = 0
         GOTO 3000                           !and ISTAT != 1
      ENDIF
C
C  extract columns/rows from COLROW
      ISTAT = 1  
      KINDEX = 0
      NCOUNT = 0
      OFF = 1
      DO 600, N=1,40
         CALL EXTRSS(COLROW,',',OFF,SUBPAR(N),SLEN)
         IF (SLEN.LE.0) THEN
            IF (NCOUNT.LE.0) CALL STETER(2,ERRMS1)
            GOTO 1000                                   !we reached the end...
         ELSE
            NCOUNT = N
         ENDIF
600   CONTINUE
C
C  finally loop through columns or rows
C
1000  KINDEX = KINDEX + ISTAT
      IF (KINDEX.GT.NCOUNT) GOTO 4000
C 
      N = KINDEX
      IF (SUBPAR(N)(1:1).EQ.'@') THEN               !input = @pixel
         CALL GENCNV(SUBPAR(N)(2:),1,1,IBUF,RR,DD,SLEN)
         IF (SLEN.LE.0) CALL STETER(3,ERRMS2)
      ELSE                                          !input = world coord
         CALL GENCNV(SUBPAR(N),2,1,IAV,TEMP,DD,SLEN)
         IF (SLEN.LE.0) CALL STETER(3,ERRMS2)
         IBUF(1) = NINT((TEMP - STARTA(INDXFL))/STEPA(INDXFL)) + 1
      ENDIF
      IF (KINDEX.EQ.NCOUNT) THEN
         IBUF(2) = 0
      ELSE
         N = N + 1
         IF (SUBPAR(N)(1:1).EQ.'@') THEN               !input = @pixel
            CALL GENCNV(SUBPAR(N)(2:),1,1,IBUF(2),TEMP,DD,SLEN)
            IF (SLEN.LE.0) CALL STETER(3,ERRMS2)
         ELSE                                          !input = world coord
            CALL GENCNV(SUBPAR(N),2,1,IAV,TEMP,DD,SLEN)
            IF (SLEN.LE.0) CALL STETER(3,ERRMS2)
            IBUF(2) = NINT((TEMP - STARTA(INDXFL))/STEPA(INDXFL)) + 1
         ENDIF
      ENDIF
C 
1010  FMIN = RMIN
      FMAX = RMAX
      CALL DOIT(ACTION,MADRID(PNTRB),MADRID(PNTRX),MADRID(PNTRY),
     +          STARTA,STEPA,NPIXA,
     +          IBUF,FMIN,FMAX,ISTAT)

      IF (ISTAT.LT.0) THEN
         CALL STTPUT(MESS(-ISTAT),STAT)
         ISTAT = 1            !on return, ISTAT = 1 or 2
      ELSE                    !depending on no. of columns/rows used
         SLEN = INDEX(SUBPAR(KINDEX),' ')            !cut off trailing blanks
         IF (SLEN.LE.0) SLEN = LEN(SUBPAR(KINDEX))
C
         IF (ISTAT.EQ.1) THEN
            OUTPUT(1:) = 'column/row at x/y = '
     +                   //SUBPAR(KINDEX)(1:SLEN)//
     +                   'cleaned... '
         ELSE
            SLEN1 = INDEX(SUBPAR(KINDEX+1),' ')      !cut off trailing blanks
            IF (SLEN1.LE.0) SLEN1 = LEN(SUBPAR(KINDEX+1))
            OUTPUT(1:) = 'columns/rows at x/y = '//
     +                   SUBPAR(KINDEX)(1:SLEN)//', '//
     +                   SUBPAR(KINDEX+1)(1:SLEN1)//'cleaned...'
         ENDIF
         CALL STTPUT(OUTPUT,STAT)
         RMIN = MIN(RMIN,FMIN)
         RMAX = MAX(RMAX,FMAX)
      ENDIF
      GOTO (1000,3000),TBLFLG                  !look for more...
C
C  here we get our input data from a table
3000  KROW = KROW2 + ISTAT - 1                 !KROW -> KROW2 or -> KROW2+1
      IF (KROW.LE.NROW) THEN
         KROW1 = KROW
         IF (ISTAT.EQ.1) THEN                  !only one row used last time...
            IBUF(1) = IBUF(2)
            SUBPAR(1)(1:) = SUBPAR(2)(1:)
            GOTO 3100                          !so reuse last value
         ENDIF
C 
3030     CALL TBSGET(TIDI,KROW1,SELFLG,STAT)       !only use selected rows
         IF (.NOT.SELFLG) THEN
            KROW1 = KROW1 + 1                      !get next row
            IF (KROW1.LE.NROW) THEN
               GOTO 3030
            ELSE
               GOTO 3300                           !end of table reached
            ENDIF
         ENDIF
C 
         CALL TBRRDR(TIDI,KROW1,1,TABCLN,TEMP,TABNUL,STAT)
         IBUF(1) = NINT((TEMP - STARTA(INDXFL))/STEPA(INDXFL)) + 1
         WRITE(SUBPAR(1),10000) TEMP
         DO 3060, N=1,30
            IF (SUBPAR(1)(N:N).NE.' ') THEN
               IF (N.GT.1) SUBPAR(1)(1:) = SUBPAR(1)(N:)//' '
               GOTO 3100
            ENDIF
3060     CONTINUE
C 
3100     KROW2 = KROW1 + 1                      !point to next possible row
         IF (KROW1.EQ.NROW) THEN   
            IBUF(2) = 0
         ELSE
3130        CALL TBSGET(TIDI,KROW2,SELFLG,STAT)       !only use selected rows
            IF (.NOT.SELFLG) THEN
               KROW2 = KROW2 + 1                      !get next row
               IF (KROW2.LE.NROW) THEN
                  GOTO 3130
               ELSE
                  IBUF(2) = 0
                  GOTO 3200 
               ENDIF
            ENDIF
C 
            CALL TBRRDR(TIDI,KROW2,1,TABCLN,TEMP,TABNUL,STAT)
            IBUF(2) = NINT((TEMP - STARTA(INDXFL))/STEPA(INDXFL)) + 1
            WRITE(SUBPAR(2),10000) TEMP
            DO 3160, N=1,30
               IF (SUBPAR(2)(N:N).NE.' ') THEN
                  IF (N.GT.1) SUBPAR(2)(1:) = SUBPAR(2)(N:)//' '
                  GOTO 3200
               ENDIF
3160        CONTINUE
         ENDIF
C 
3200     KINDEX = 1                              !force index to 1
         GOTO 1010                               !now continue as above
      ENDIF
C 
C  close table
3300  CALL TBTCLO(TIDI,STAT)
C
C  get new dynamic range + write descriptor LHCUTS
4000  CUTS(3) = MIN(RMIN,CUTS(3))
      CUTS(4) = MAX(RMAX,CUTS(4))
C
C  copy descriptors + append HISTORY
      CALL DSCUPT(IMNOA,IMNOB,' ',STAT)
      CALL STDWRR(IMNOB,'LHCUTS',CUTS,1,4,UNI,STAT)      !use old cuts...
C
C  That's it folks...
      CALL STSEPI
C
C  format statements
10000 FORMAT(F20.10)
      END

      SUBROUTINE DOIT(ACTION,A,TEMPA,TEMPB,
     +                START,STEP,NPIX,COORD,FMIN,FMAX,ISTAT)
C
      IMPLICIT NONE
C
      INTEGER      COORD(2),ISTAT
      INTEGER      JOF,JOF1,N,M,NFLAG,KFLAG
      INTEGER      NEXT,NP,JNDX,NOLINS
      INTEGER      NPIX(2),INDX(4),IOF(4)
C
      CHARACTER    ACTION*2
C
      REAL         A(*),TEMPA(*),TEMPB(*),FMIN,FMAX
      REAL         V,VV,W,WW,XX,XXX
      REAL         RMIN,RMAX
C
      DOUBLE PRECISION START(2),STEP(2)
      DOUBLE PRECISION   S(4),Z(4),X(4),F(4)
      DOUBLE PRECISION   RR1,RR2,RR3,P1,P2,P3,Q
      DOUBLE PRECISION   SUM1,SUM2
      DOUBLE PRECISION   A0,A1,A2
C
      IF (ACTION(1:1).EQ.'C') THEN
         NFLAG = 1                              !columns...
      ELSE
         NFLAG = 2                              !rows...
      ENDIF
      KFLAG = 3 - NFLAG 
      INDX(1) = COORD(1) - 2                    !take 2 pixels less
      NEXT = COORD(2) - 2
C
      INDX(2) = INDX(1) + 1
      JNDX = INDX(2) + 1                        !keep index of bad line...
      IF (NEXT .EQ. INDX(1)+1) THEN
         NOLINS = 2                             !double lines...
      ELSE
         NOLINS = 1
      ENDIF
      INDX(3) = INDX(2) + NOLINS + 1                  !single line...
      INDX(4) = INDX(3) + 1
C 
C  check input pars
      IF ((INDX(1).LT.1).OR.(INDX(4).GT.NPIX(NFLAG))) THEN
         ISTAT = -1
         RETURN
      ELSE
         ISTAT = NOLINS
      ENDIF
C
C  get "x" values + related sums for later calculations
      DO 200, N=1,4                              !get x values...
         X(N) = START(NFLAG) + (INDX(N)-1)*STEP(NFLAG)
         Z(N) = 1.D0
200   CONTINUE
      XX = START(NFLAG) + (JNDX-1)*STEP(NFLAG)      !x of bad row/column...
      XXX = XX + STEP(NFLAG)
C
      DO 1000, M=1,4
         DO 400, N=1,4                               !get x**2,x**3,x**4 ...
            Z(N) = Z(N)*X(N)
400      CONTINUE
         S(M) = 0.D0                                !compute sums
         DO 600, N=1,4
            S(M) = S(M) + Z(N)
600      CONTINUE
1000  CONTINUE
C
C  branch according to columns + rows
      IF (ACTION(1:1).EQ.'C') GOTO 5000
C
C  handle rows...
      DO 1200, N=1,4                                 !get y values...
         IOF(N) = (INDX(N)-1)*NPIX(1)
1200  CONTINUE
      JOF = (JNDX-1)*NPIX(1)
      JOF1 = JOF + NPIX(1)
C
C  go through the row
      DO 3300, NP=1,NPIX(1)
         DO 1400, M=1,4                              !get function values
            F(M) = A(IOF(M)+NP)
            Z(M) = 0.D0
1400     CONTINUE
C
         DO 1600, M=1,4                              !compute sums on right side
            Z(1) = Z(1) + F(M)
            Z(2) = Z(2) + F(M)*X(M)
            Z(3) = Z(3) + F(M)*X(M)*X(M)
1600     CONTINUE
C
C  reduce + solve the linear system  4.*A0 + S1*A1 + S2*A2 = Z1
C                                    S1*A0 + S2*A1 + S3*A2 = Z2
C                                    S2*A0 + S3*A1 + S4*A2 = Z3
         Q = S(1) * 0.25D0
         RR1 = S(2) - S(1)*Q
         RR2 = S(3) - S(2)*Q
         RR3 = Z(2) - Z(1)*Q
         Q = S(2) * 0.25D0
         P1 = S(3) - S(1)*Q
         P2 = S(4) - S(2)*Q
         P3 = Z(3) - Z(1)*Q
C                   we now have:          RR1*A1 + RR2*A2 = RR3
C                                         P1*A1 + P2*A2 = P3
         Q = P1/RR1
         IF (ABS(P2-RR2*Q).LE.10.D-30) THEN
            IF (ABS(P1 - RR1*Q).LE.10.D-30) THEN      !linearly dependant system
               A0 = 0.D0
               A1 = 1.D0
               A2 = 0.D0
               GOTO 3000
            ENDIF
            Q = P2/RR2
            A1 = (P3 - RR3*Q) / (P1 - RR1*Q)
            A2 = (RR3 - A1*RR1)/RR2
         ELSE
            A2 = (P3 - RR3*Q) / (P2 - RR2*Q)
            A1 = (RR3 - A2*RR2)/RR1
         ENDIF
C
         A0 = (Z(1) - S(2)*A2 - S(1)*A1) * .25D0
C
C  finally calculate interpolated value...!
3000     TEMPA(NP) = A0 + A1*XX + A2*XX*XX
         IF (NOLINS.EQ.2)
     +      TEMPB(NP) = A0 + A1*XXX + A2*XXX*XXX
3300  CONTINUE
C
C  check, if we work on single line or not
C
      IF (NOLINS.EQ.2) GOTO 4000
C
C  for constant offset, get average difference to orignal bad row
      IF (ACTION(2:2).EQ.'C') THEN
         SUM1 = 0.D0
         DO 3500, NP=1,NPIX(1)
            SUM1 = SUM1 + DBLE(A(JOF+NP) - TEMPA(NP))  !sum differences
3500     CONTINUE
         V = SNGL(SUM1/NPIX(1))            !get average offset
C
C  and correct pixels in bad row with that offset
         DO 3600, NP=1,NPIX(1)
            W = A(JOF+NP)
            A(JOF+NP) = W - V
            IF (W.LT.FMIN) THEN
               FMIN = W
            ELSE
               IF (W.GT.FMAX) FMAX = W
            ENDIF
3600     CONTINUE
C
      ELSE
C
C  store approximated pixels in bad row
         DO 3800, NP=1,NPIX(1)
            W = TEMPA(NP)
            A(JOF+NP) = W
            IF (W.LT.FMIN) THEN
               FMIN = W
            ELSE
               IF (W.GT.FMAX) FMAX = W
            ENDIF
3800     CONTINUE
      ENDIF
      RETURN
C
C  here to handle two adjacent "bad" rows
C
4000  IF (ACTION(2:2).EQ.'C') THEN
         SUM1 = 0.D0                  !get average difference to adjacent lines
         SUM2 = 0.D0
         DO 4200, NP=1,NPIX(1)
            SUM1 = SUM1 + DBLE(A(JOF+NP) - TEMPA(NP))   !sum differences
            SUM2 = SUM2 + DBLE(A(JOF1+NP) - TEMPB(NP))  !sum differences
4200     CONTINUE
         V = SNGL(SUM1/NPIX(1))                         !get average offset
         VV = SNGL(SUM2/NPIX(1))
C
C  and correct pixels in bad rows with these offsets
         DO 4400, NP=1,NPIX(1)
            W = A(JOF+NP)
            A(JOF+NP) = W - V
            WW = A(JOF1+NP)
            A(JOF1+NP) = WW - VV
            RMIN = MIN(W,WW)
            RMAX = MAX(W,WW)
            IF (RMIN.LT.FMIN) FMIN = RMIN
            IF (RMAX.GT.FMAX) FMAX = RMAX
4400     CONTINUE
C
      ELSE
C
C  store approximated pixels in bad rows
         DO 4600, NP=1,NPIX(1)
            W = TEMPA(NP)
            WW = TEMPB(NP)
            A(JOF+NP) = W
            A(JOF1+NP) = WW
            RMIN = MIN(W,WW)
            RMAX = MAX(W,WW)
            IF (RMIN.LT.FMIN) FMIN = RMIN
            IF (RMAX.GT.FMAX) FMAX = RMAX
4600     CONTINUE
      ENDIF
      RETURN
C
C  handle columns...
C
C  go through the column
5000  JOF = 0
      DO 6600, NP=1,NPIX(2)
         DO 5200, M=1,4                        !get function values
            F(M) = A(JOF+INDX(M))
            Z(M) = 0.D0
5200     CONTINUE
C
         DO 5400, M=1,4                        !compute sums on right side
            Z(1) = Z(1) + F(M)
            Z(2) = Z(2) + F(M)*X(M)
            Z(3) = Z(3) + F(M)*X(M)*X(M)
5400     CONTINUE
C
C  reduce + solve the linear system     4.*A0 + S1*A1 + S2*A2 = Z1
C                                       S1*A0 + S2*A1 + S3*A2 = Z2
C                                       S2*A0 + S3*A1 + S4*A2 = Z3
         Q = S(1)*.25D0
         RR1 = S(2) - S(1)*Q
         RR2 = S(3) - S(2)*Q
         RR3 = Z(2) - Z(1)*Q
         Q = S(2)*.25D0
         P1 = S(3) - S(1)*Q
         P2 = S(4) - S(2)*Q
         P3 = Z(3) - Z(1)*Q
C  we now have:                         RR1*A1 + RR2*A2 = RR3
C                                       P1*A1 + P2*A2 = P3
         Q = P1/RR1
         IF (ABS(P2-RR2*Q).LE.10.D-30) THEN
            IF (ABS(P1 - RR1*Q).LE.10.D-30) THEN      !linearly dependant system
               A0 = 0.D0
               A1 = 1.D0
               A2 = 0.D0
               GOTO 6000
            ENDIF
            Q = P2/RR2
            A1 = (P3 - RR3*Q) / (P1 - RR1*Q)
            A2 = (RR3 - A1*RR1)/RR2
         ELSE
            A2 = (P3 - RR3*Q) / (P2 - RR2*Q)
            A1 = (RR3 - A2*RR2)/RR1
         ENDIF
C
         A0 = (Z(1) - S(2)*A2 - S(1)*A1)*.25D0
C
C  finally calculate interpolated value...!
6000     TEMPA(NP) = A0 + A1*XX + A2*XX*XX
         IF (NOLINS.EQ.2)
     +      TEMPB(NP) = A0 + A1*XXX + A2*XXX*XXX
         JOF = JOF + NPIX(1)                  !update offset to next row...
6600  CONTINUE
C
C  check, if we work on single line or not
C
      IF (NOLINS.EQ.2) GOTO 8000
C
C  for constant offset, get average difference to original bad column
      IF (ACTION(2:2).EQ.'C') THEN
         SUM1 = 0.D0
         JOF = JNDX
         DO 6800, NP=1,NPIX(2)
            SUM1 = SUM1 + DBLE(A(JOF) - TEMPA(NP))      !sum differences
            JOF = JOF + NPIX(1)
6800     CONTINUE
         W = SNGL(SUM1/NPIX(2))                         !get average offset
C
C  and correct pixels in bad column with that offset
         JOF = JNDX
         DO 7000, NP=1,NPIX(2)
            V = A(JOF) - W
            A(JOF) = V 
            IF (V.LT.FMIN) THEN
               FMIN = V
            ELSE
               IF (V.GT.FMAX) FMAX = V
            ENDIF
            JOF = JOF + NPIX(1)
7000     CONTINUE
C
      ELSE
C
C  fill approximated pixels into frame
         JOF = JNDX
         DO 7400, NP=1,NPIX(2)
            V = TEMPA(NP)
            A(JOF) = V
            IF (V.LT.FMIN) THEN
               FMIN = V
            ELSE
               IF (V.GT.FMAX) FMAX = V
            ENDIF
            JOF = JOF + NPIX(1)
7400     CONTINUE
      ENDIF
      RETURN
C
C  here to handle two adjacent "bad" columns
8000  IF (ACTION(2:2).EQ.'C') THEN
         SUM1 = 0.D0                  !get average difference to adjacent lines
         SUM2 = 0.D0
         JOF = JNDX
C
         DO 8200, NP=1,NPIX(2)
            SUM1 = SUM1 + DBLE(A(JOF) - TEMPA(NP))        !sum differences
            SUM2 = SUM2 + DBLE(A(JOF+1) - TEMPB(NP))
            JOF = JOF + NPIX(1)
8200     CONTINUE
         V = SNGL(SUM1/NPIX(2))                           !get average offset
         VV = SNGL(SUM2/NPIX(2))
C
C  and correct pixels in bad columns with these offsets
         JOF = JNDX
         DO 8400, NP=1,NPIX(2)
            W = A(JOF)
            WW = A(JOF+1)
            A(JOF) = W - V
            A(JOF+1) = WW - VV
            RMIN = MIN(W,WW)
            RMAX = MAX(W,WW)
            IF (RMIN.LT.FMIN) FMIN = RMIN
            IF (RMAX.GT.FMAX) FMAX = RMAX
            JOF = JOF + NPIX(1)
8400     CONTINUE
C
      ELSE
C
C  fill approximated pixels into frame
         JOF = JNDX
         DO 8600, NP=1,NPIX(2)
            W = TEMPA(NP)
            WW = TEMPB(NP)
            A(JOF) = W
            A(JOF+1) = WW
            W = A(JOF)
            RMIN = MIN(W,WW)
            RMAX = MAX(W,WW)
            IF (RMIN.LT.FMIN) FMIN = RMIN
            IF (RMAX.GT.FMAX) FMAX = RMAX
            JOF = JOF + NPIX(1)
8600     CONTINUE
      ENDIF
      RETURN
C
      END

C @(#)polfil.for	19.1 (ES0-DMD) 02/25/03 14:01:08
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE POLFIL(CASE,INIM,TSTIM,IN2IM,
     +			OUTIM,NPIX,WINDOW,THRESH,FILL)
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C	
C.IDENTIFICATION
C  subroutine POLFIL			version 1.00	880912
C  subroutine ISCAN			version 1.00	880912
C  subroutine OVRLAP			version 1.30	881028
C  subroutine PROGRS			version 2.20	880919
C  subroutine MEMDSK			version 1.00	891129
C  K. Banse				ESO - Garching
C 
C.KEYWORDS
C  polygon fill
C 
C.PURPOSE
C  fill pixels inside given polygon (including borderline pixels)
C 
C.ALGORITHM
C  get beginning + end of polygon per line in UP, DOWN
C  replace all pixels inside with constant or other pixel values
C	
C.IN/OUTPUT:
C call as   POLFIL(CASE,INIM,TSTIM,IN2IM,OUTIM,NPIX,WINDOW,THRESH,FILL)
C
C input par:
C CASE:		char. exp.	= C for constant, I for image
C INIM:		R*4		input image
C TSTIM:	R*4		test image
C IN2IM:	R*4		second input image
C OUTIM:	R*4		output image
C NPIX:         I*4 array       NPIX of images
C WINDOW:       I*4 array       lower left + upper right corner of window
C                               in images
C THRESH:       R*4 array       low,high threshold for polygon detection
C FILL:         R*4             fill value
C
C.VERSIONS
C  1.00         from version 1.00 as of 860707
C
C-----------------------------------------------------------------------
C
      IMPLICIT NONE
C
      CHARACTER*1    CASE
C
      INTEGER     WINDOW(4),NPIX(2)
      INTEGER     NOLINS,NOPIX,OFF,UP,DOWN,SW,KX,JX
      INTEGER     M,NN,N,KLO,KHI,MLO,MHI,JLO,JHI
      INTEGER     LOWUP
C      
      REAL        INIM(*),TSTIM(*),OUTIM(*),IN2IM(*)
      REAL        THRESH(2),FILL
C      
C  initalize pointer to lower left corner of window
      OFF = ( (WINDOW(2) - 1) * NPIX(1) ) + WINDOW(1) - 1
      NOLINS = WINDOW(4) - WINDOW(2) + 1
      NOPIX = WINDOW(3) - WINDOW(1) + 1
C
C  here we go
C      
      SW = 0
      IF (CASE.EQ.'C') THEN
         DO 1000 N=1,NOLINS
            IF (SW.NE.0) WRITE(*,12000) (N-1)
            SW = 0
            UP = 0
            DOWN = 0
            KX = 0
            JX = 0
            JLO = 0
            JHI = 0
            DO 400, NN=OFF+1,OFF+NOPIX
               M = NN - 1
               IF ( (TSTIM(NN).GE.THRESH(1)) .AND. 
     +              (TSTIM(NN).LE.THRESH(2)) ) THEN
                  IF (UP.NE.M) THEN
                     IF (DOWN.EQ.0) THEN
                        SW = 1 
                        KLO = LOWUP(TSTIM,THRESH,NPIX,1,NN)
                        KHI = LOWUP(TSTIM,THRESH,NPIX,2,NN)
                        KX = NN
                     ELSE
                        JX = NN
                        JLO = LOWUP(TSTIM,THRESH,NPIX,1,NN)
                        JHI = LOWUP(TSTIM,THRESH,NPIX,2,NN)
                     ENDIF
                  ENDIF
                  UP = NN
               ELSE
                  IF (UP.EQ.M) THEN
                     MLO = LOWUP(TSTIM,THRESH,NPIX,1,M)    !check line below
                     MHI = LOWUP(TSTIM,THRESH,NPIX,2,M)    !check line above
                     IF (DOWN.EQ.0) THEN
                        DOWN = 1 - DOWN
                        IF (KX.NE.M) THEN
                           IF ((MLO.EQ.1).AND.(MHI.EQ.1)) THEN
                              SW = 0
                              DOWN = 0
                           ELSE IF ((KLO.EQ.MLO) .AND. 
     +                              (KHI.EQ.MHI)) THEN
                              SW = 1 - SW 
                              DOWN = 0
                           ENDIF
                        ELSE IF (MHI.NE.MLO) THEN
                           IF ((KLO.EQ.MLO) .AND. (KHI.EQ.MHI)) THEN
                              SW = 1 - SW 
                              DOWN = 0
                           ENDIF
                        ENDIF
                     ELSE
                        IF ((JX.NE.M) .OR.(MHI.NE.MLO)) THEN
                           IF ((JLO.NE.MLO) .OR. (JHI.NE.MHI)) THEN
                              SW = 1 - SW
                              DOWN = 0
                           ENDIF
                        ELSE
                           SW = 1 - SW
                           DOWN = 0
                        ENDIF
                     ENDIF
                  ENDIF
               ENDIF
C 
               IF (SW.NE.0) OUTIM(NN) = FILL
400         CONTINUE
            OFF = OFF + NPIX(1)
1000     CONTINUE
C      
C  use second input image
      ELSE
         DO 2000 N=1,NOLINS
            IF (SW.NE.0) WRITE(*,12000) (N-1)
            SW = 0
            UP = 0
            DOWN = 0
            KX = 0
            JX = 0
            JLO = 0
            JHI = 0
            DO 1400, NN=OFF+1,OFF+NOPIX
               M = NN - 1
               IF ( (TSTIM(NN).GE.THRESH(1)) .AND.
     +              (TSTIM(NN).LE.THRESH(2)) ) THEN
                  IF (UP.NE.M) THEN
                     IF (DOWN.EQ.0) THEN
                        SW = 1
                        KLO = LOWUP(TSTIM,THRESH,NPIX,1,NN)
                        KHI = LOWUP(TSTIM,THRESH,NPIX,2,NN)
                        KX = NN
                     ELSE
                        JX = NN
                        JLO = LOWUP(TSTIM,THRESH,NPIX,1,NN)
                        JHI = LOWUP(TSTIM,THRESH,NPIX,2,NN)
                     ENDIF
                  ENDIF
                  UP = NN
               ELSE
                  IF (UP.EQ.M) THEN
                     MLO = LOWUP(TSTIM,THRESH,NPIX,1,M)    !check line below
                     MHI = LOWUP(TSTIM,THRESH,NPIX,2,M)    !check line above
                     IF (DOWN.EQ.0) THEN
                        DOWN = 1 - DOWN
                        IF (KX.NE.M) THEN
                           IF ((MLO.EQ.1).AND.(MHI.EQ.1)) THEN
                              SW = 0
                              DOWN = 0
                           ELSE IF ((KLO.EQ.MLO) .AND. 
     +                              (KHI.EQ.MHI)) THEN
                              SW = 1 - SW
                              DOWN = 0
                           ENDIF
                        ELSE IF (MHI.NE.MLO) THEN
                           IF ((KLO.EQ.MLO) .AND. (KHI.EQ.MHI)) THEN
                              SW = 1 - SW
                              DOWN = 0
                           ENDIF
                        ENDIF
                     ELSE
                        IF ((JX.NE.M) .OR.(MHI.NE.MLO)) THEN
                           IF ((JLO.NE.MLO) .OR. (JHI.NE.MHI)) THEN
                              SW = 1 - SW
                              DOWN = 0
                           ENDIF
                        ELSE
                           SW = 1 - SW
                           DOWN = 0
                        ENDIF
                     ENDIF
                  ENDIF
               ENDIF
C
               IF (SW.NE.0) OUTIM(NN) = IN2IM(NN)
1400        CONTINUE
            OFF = OFF + NPIX(1)
2000     CONTINUE
C
      ENDIF
C 
C  that's it folks
      RETURN
C 
12000 FORMAT(' line',I5,' has problems...')
C 
      END

      INTEGER FUNCTION LOWUP(A,THR,NPIX,LFLAG,PIXNO)
C      
      IMPLICIT NONE
C      
      REAL        A(*),THR(2)
C      
      INTEGER     PIXNO,NPIX(2),LFLAG
      INTEGER     N,K
C      
      LOWUP = 0
      N = PIXNO - 1
      IF (LFLAG.EQ.1) THEN                  !check lower line
         N = N - NPIX(1)
         IF (N.LT.1) RETURN
C 
         DO 200, K=1,3
            IF ((A(N).GE.THR(1)).AND.(A(N).LE.THR(2))) GOTO 1000
            N = N + 1
200      CONTINUE
      ELSE
         N = N + NPIX(1)
         IF (N.GT.(NPIX(1)*NPIX(2))) RETURN
C 
         DO 400, K=1,3
            IF ((A(N).GE.THR(1)).AND.(A(N).LE.THR(2))) GOTO 1000
            N = N + 1
400      CONTINUE
      ENDIF
      RETURN
C      
1000  LOWUP = 1
      RETURN
      END

      SUBROUTINE OVRLAP(STARTA,STEPA,NPIXA,STARTB,STEPB,NPIXB,
     +                  BEGIN,END,STAT)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine OVRLAP            version 1.30      881028
C  K. Banse                     ESO - Garching
C
C.KEYWORDS
C  conjunction
C
C.PURPOSE
C  determine overlapping region of two "lines" in real space
C
C.ALGORITHM
C  straight forward
C
C.INPUT/OUTPUT
C  call as   OVRLAP(STARTA,STEPA,NPIXA,STARTB,STEPB,NPIXB,BEGIN,END,STAT)
C
C  input par:
C  STARTA:	R*8	start of "line" A
C  STEPA:	R*8	stepsize of A
C  NPIXB:	I*4	no. of steps in A
C  STARTB:	R*8	start of "line" B
C  STEPB:	R*8	stepsize of B
C  NPIXB:	I*4	no. of steps in B
C
C  output par:
C  BEGIN:	R*8	begin of overlapping interval
C  END:		R*8	end of overlapping interval
C  STAT:	I*4	return status, should be = 0
C
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      NPIXA,NPIXB,STAT
C
      DOUBLE PRECISION STARTA,STEPA,STARTB,STEPB
      DOUBLE PRECISION EB,BEGIN,END
C
C  compute position of last pixel
      STAT = 0
      END = STARTA + (NPIXA-1)*STEPA
      EB = STARTB + (NPIXB-1)*STEPB
C
C  negative stepsize
      IF (STEPA.LT.0.D0) THEN
         IF (STARTA.LT.STARTB) THEN            !low begin
            BEGIN = STARTA
         ELSE
            BEGIN = STARTB
         ENDIF
         IF (END.LT.EB) END = EB            !high end
C
         IF (END.GT.BEGIN) STAT = 1            !no overlap...!
C
C  positive stepsize
      ELSE
         IF (STARTA.LT.STARTB) THEN            !high begin
            BEGIN = STARTB
         ELSE
            BEGIN = STARTA
         ENDIF
         IF (END.GT.EB) END = EB            !low end
C
         IF (END.LT.BEGIN) STAT = 1            !no overlap...!
      ENDIF
C
      RETURN
      END

      SUBROUTINE PROGRS(INC,CINC,PRCNT,CHECK)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine PROGRS		version 2.00	860609
C  K. Banse			ESO - Garching
C  					2.20	880919
C
C.KEYWORDS
C  time, progress of work
C
C.PURPOSE
C  display current time + percentage of work already done
C
C.ALGORITHM
C  straight forward 
C
C.INPUT/OUTPUT
C  call as PROGRS(INC,CINC,PRCNT,CHECK)
C
C  input par:
C  INC:		I*4		no. of percent to increase
C  CINC:	I*4		increment for check
C  
C  in/output par:
C  PRCNT:	I*4		percent of processing done
C  CHECK:	I*4		check value
C 
C.VERSIONS
C  2.10		do not write to logfile - only to terminal...
C  2.20		move to FORTRAN 77 + use system independent calls
C 
C--------------------------------------------------
C
      IMPLICIT NONE
C      
      INTEGER     INC,CINC,PRCNT,CHECK
      INTEGER     N,IAV,KLOG,NLOG,STAT
      INTEGER     UNIT(1),NULLO
C      
      CHARACTER   TIME*40,PBUF*60
C      
      IF (PRCNT.GT.100) RETURN
C
C  get current time, convert percentage to ASCII + display all that
      TIME = ' '
      CALL GENTIM(TIME)
      DO 100 N=40,2,-1
         IF (TIME(N:N).NE.' ') THEN
            IAV = N
            GOTO 200
         ENDIF
100   CONTINUE
      IAV = 1
C 
200   PBUF(1:) = ' '
      WRITE(PBUF(1:),10000) TIME(1:IAV),PRCNT
C      
C  set log flag to 0, so we do not write into the log file...
      CALL STKRDI('LOG',1,1,IAV,KLOG,UNIT,NULLO,STAT)
      NLOG = 0
      CALL STKWRI('LOG',NLOG,1,1,UNIT,STAT)
      CALL STTPUT(PBUF,STAT)
      CALL STKWRI('LOG',KLOG,1,1,UNIT,STAT)
C      
C  update
      PRCNT = PRCNT + INC
      CHECK = CHECK + CINC
      RETURN
C      
10000 FORMAT(A,I4,'% done ... ')
C      
      END

      SUBROUTINE MEMDSK(IMNO,FLAG,A,NPIX,STA,WSIZE,STAT)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine MEMDSK            version 1.00      891129
C  K. Banse                     ESO - Garching
C
C.KEYWORDS
C  memory, diskfile
C
C.PURPOSE
C  copy data stored in virtual memory to right place in disk file
C
C.ALGORITHM
C  use STFPUT interface
C
C.INPUT/OUTPUT
C  call as   MEMDSK(IMNO,FLAG,A,NPIX,STA,WSIZE,STAT)
C
C  input par:
C  IMNO:	Integer		file no.
C  FLAG:	Integer		= 0, buffer A holds full frame
C				= 1, buffer A holds data from window start on
C				= 2, buffer A holds only the data of the window
C  A:		Real		buffer with data
C  NPIX:	Integer		no. of pixels in A
C  STA:		Integer		start of window in total frame
C  WSIZE:	Integer		no. of pixels in window
C
C  output par:
C  STAT:	Integer		return status, should be = 0
C
C--------------------------------------------------
C
      IMPLICIT NONE
C 
      INTEGER     IMNO,FLAG,NPIX(*),STA(*),WSIZE(*),STAT
      INTEGER     FELEM,SIZE,N,IOFF
C 
      REAL        A(*)
C 
      FELEM = ((STA(2)-1) * NPIX(1)) + STA(1)
      IF (FLAG .EQ. 0) THEN
         SIZE = WSIZE(2) * NPIX(1)              !WSIZE(2) lines...
         CALL STFPUT(IMNO,FELEM,SIZE,A(FELEM),STAT)
      ELSE IF (FLAG .EQ. 1) THEN
         SIZE = WSIZE(2) * NPIX(1)              !WSIZE(2) lines...
         CALL STFPUT(IMNO,FELEM,SIZE,A(1),STAT)
      ELSE IF (FLAG .EQ. 2) THEN
         IOFF = 1
         DO 1000 N=1,WSIZE(2)                   !again WSIZE(2) lines ...
            CALL STFPUT(IMNO,FELEM,WSIZE(1),A(IOFF),STAT)
            IOFF = IOFF + WSIZE(1)
            FELEM = FELEM + NPIX(1)
1000     CONTINUE
      ENDIF
C 
      RETURN
      END

C @(#)alpha.for	19.1 (ES0-DMD) 02/25/03 14:27:33
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE ALPHA(A,LENGTH,NCHAR,NREST)
C+++                                        
C.PURPOSE:  Alphanumeric handling routine
C.AUTHOR:   Rein H. Warmels
C.COMMENTS: none
C.VERSION:  87???? RHW  creation
C.VERSION:  910115 RHW  IMPLICIT NONE added
C---
      IMPLICIT     NONE
      CHARACTER*(*) A                  ! IN: input array of dimension n        
      INTEGER      LENGTH              ! IN: max length of the character string
      INTEGER      NCHAR               ! OUT: number of actual characters
      INTEGER      NREST               ! OUT: number of remaining characters
C
      CHARACTER    X
      INTEGER      I
C
C***
      NCHAR  = 0 
      DO 10 I = 1,LENGTH 
         X      = A(LENGTH-I+1:LENGTH-I+1)
         IF (X.NE.' ') THEN 
            NCHAR  = LENGTH + 1 - I 
            NREST  = LENGTH - NCHAR
            RETURN
         END IF
   10 CONTINUE 
      RETURN 
      END



      SUBROUTINE LENBUF(BUF,L) 
C+++
C.PURPOSE:  counts the number of effective characters in a buffer           
C.AUTHOR:   Rein H. Warmels
C.COMMENTS: none                                                            
C.VERSION:  880205 RHW Creation                                             
C.VERSION:  910115 RHW  IMPLICIT NONE added
C---
      IMPLICIT      NONE
      CHARACTER*(*) BUF                   ! IN : character string with text 
      INTEGER       L                     ! OUT: number of characters in string
C
      INTEGER       LB
C
C ***
      LB = LEN(BUF)
  100 CONTINUE
         IF (BUF(LB:LB).NE.' ' .OR. LB.EQ.0) GO TO 200
         LB = LB - 1
      GO TO 100
  200 CONTINUE
      L = LB 
      RETURN 
      END 


      INTEGER FUNCTION LENC(C)
C+++ 
C.PURPOSE:  counts the number of effective characters in a buffer
C.AUTHOR:   Rein H. warmels
C.COMMENTS: none
C.VERSION:  880205 RHW Creation
C.VERSION:  910115 RHW  IMPLICIT NONE added
C---
      IMPLICIT      NONE
      CHARACTER*(*) C                          ! IN: string containing the text
      INTEGER       I 
C
C ***
      DO 10 I = LEN(C),1,-1
         LENC = I
         IF(C(I:I).NE.' '.AND.ICHAR(C(I:I)).NE.0) GOTO 11
10    CONTINUE
 
11    CONTINUE

      RETURN
      END

C @(#)srhnew.for	19.1 (ES0-DMD) 02/25/03 13:25:39
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C
C-----------------------------------------------------------------------
      SUBROUTINE SRHNEW(AS, MAS, JAPYS, IBUFS, LHED,
     &                  II, JJ, TRSH, FLTR, BGRD,
     &                  SIGMA, MCM)
C
      IMPLICIT   NONE
      INCLUDE    'MID_REL_INCL:INVENT.INC/NOLIST'
C
      REAL        AS(1)                 ! IN: Subarray with subtracted objects
      INTEGER     MAS((-MAXSUB):MAXSUB,(-MAXSUB):MAXSUB) ! IN: Mask subarray
      INTEGER     JAPYS(1)              ! IN: Array with pointers to lines
      INTEGER     IBUFS(4)              ! IN: Limits of usable data region
      INTEGER     LHED                  ! IN: Half-size of data subarray
      INTEGER     II                    ! IN: X position of subarray center
      INTEGER     JJ                    ! IN: Y position of subarray center
      REAL        TRSH                  ! IN: Detection threshold
      REAL        FLTR                  ! IN: Filtering threshold
      REAL        BGRD                  ! IN: Local sky background
      REAL        SIGMA                 ! IN: Sigma of pixel data
      INTEGER     MCM(21)               ! MOD: New objects coordinates
C
      REAL        ALIM, AOLD, AVER
      INTEGER     IARG
      INTEGER     I, I1, I2, III
      INTEGER     J, J1, J2, JJJ
      INTEGER     JOFF, JOF
      INTEGER     KM
      LOGICAL     DETECT , GOOD
C
C *** Set local detection limit.
C
      ALIM = MAX( TRSH , 2.0*SIGMA ) + BGRD 
C
C *** Determine region to be searched for new objects.
C
      I1 = MAX( (-LHED) , IBUFS(1) ) + 1
      I2 = MIN( LHED , IBUFS(3) ) - 1
      J1 = MAX( (-LHED) , IBUFS(2) ) + 1
      J2 = MIN( LHED , IBUFS(4) ) - 1
      JOFF = IBUFS(2) - 1
      AOLD = 0.0
C
C *** Start search.
C
      DO 10 J = J1 , J2
          JOF = JAPYS(J-JOFF)
          DO 20 I = I1 , I2
              DETECT = .FALSE.
              IARG = JOF + I
              AVER = AS(IARG)
C
C ***         Pixels lower than limit ALIM is no longer considered.
C
              IF ( AVER .LT. ALIM ) GOTO 20
C
C ***         Compare with eight neighbours.
C
              CALL SRHOBJ( AS , JAPYS , JOFF , I , J , DETECT , AVER )
              IF ( ( .NOT. DETECT ) .OR. AVER .LT. ALIM ) GOTO 20
              IF ( AVER .GT. AOLD ) THEN
                  CALL FLTRBP( AS , JAPYS , IBUFS , I , J ,
     &                         BGRD , FLTR , AVER )
                  IF ( AVER .GT. AOLD ) THEN
                      AOLD = AVER
                      III = I
                      JJJ = J
                  ENDIF
              ENDIF
   20     CONTINUE
   10 CONTINUE
C
      IF ( AOLD .GT. ALIM ) THEN
C
C ***     Check if good object.
C
          III = III + II
          JJJ = JJJ + JJ
          CALL IFGOOD( AS , JAPYS , IBUFS , MAS , II ,
     &                 JJ , III , JJJ , BGRD , FLTR ,
     &                 TRSH , GOOD )
          IF ( GOOD ) THEN
C
C ***         Write a new object into array MCM.
C
              KM = MCM(1)
              IF ( KM .GE. 10 ) THEN
                  KM = 9
              ENDIF
              MCM(2*(KM+1)) = III
              MCM(2*(KM+1)+1) = JJJ
              MCM(1) = KM + 1
          ENDIF
      ENDIF
C
      RETURN
C
      END

C @(#)arthmd.for	19.2 (ESO-DMD) 05/20/03 09:41:52
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE ARTHMD(ZDEFA,ZRESFR,ZLINE)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine ARTHMD			951011
C  K. Banse            		      	ESO - Garching
C
C.KEYWORDS
C  double precision, arithmetic operations, bulk data frames
C
C.PURPOSE
C  evaluate an arithmetic expression involving frames, constants and functions
C  and store the result into a data frame or key OUTPUTR(1), 
C  if used as pocket calculator
C
C.ALGORITHM
C  "clean" the expression by replacing all frame names by F, all constants by C
C  and all functions by P, convert it to polish (postfix) notation and evaluate it piecewise
C  establish special condition handler for arithmetic traps...
C  copy all descriptors of first frame operand to result frame.
C
C.INPUT/OUTPUT
C  call as ARTHMD(ZDEFA,ZRESFR,ZLINE)
C  
C  input par:
C  ZDEFA:	char.		2 char. default string
C				(1) Y or N for result frame or not
C				(2) P, I, X for COMPUTE/PIXEL, /IMAGE, /PLANE
C  ZRESFR:	char.		name of result frame
C  ZLINE:	char.		char.string with arithmetic expression
C	
C.VERSIONS
C 030516	last modif
C 
C-------------------------------------------------------------------------
C
      IMPLICIT NONE
C
C  important parameter: WORKLM = 45
C
      CHARACTER*(*)  ZRESFR,ZLINE
      CHARACTER      ZDEFA*2
      CHARACTER      INFRAM(23)*80                   !MAXFRAM = WORKLM/2 + 1
      CHARACTER      ATOM(23)*80,OPER(23)*5          !size = MAXFRAM
      CHARACTER      RESFRA*80,DSCFRA*80
      CHARACTER      CUNIT*80,IDENT*72
      CHARACTER      WORK*50,WORK1*50,OUTPU*80,WORKY*1
      CHARACTER      ERROR3*50,ERROR4*30,ERROR5*30
C      
      REAL           RCUTS(4),RDUM(1) 
      REAL           USRNUL
C 
      DOUBLE PRECISION STEP(6),START(6),STEPA(6),STARTA(6)
      DOUBLE PRECISION DATTA(23),EPS,DIF,DDUM(1)
      DOUBLE PRECISION CONST,CUTS(4)
C      
      INTEGER      NULCNT,NNN
      INTEGER      LATOM(23),FELEM(23),WORKLM        !size = MAXFRAM
      INTEGER      APNTRS(48)                        !size = WORKLM + 3
      INTEGER*8    PNTR(27)                          !size = MAXFRAM + 4
      INTEGER*8    RPNTR
      INTEGER      PIDX(23),PPP(23),IMNO(23)         !size = MAXFRAM
      INTEGER      FRACNT,NPIX(6),NAXISA,NPIXA(6)
      INTEGER      COUNT,IAV,K,M,LL
      INTEGER      N,NAXIS,TOTAL
      INTEGER      SIZE,INFO(5),DATFMT
      INTEGER      RFELEM,OPCNT
      INTEGER      MAPSIZ,STAT
      INTEGER      TRSIZE,NNULL,UNIT(1),INPU(1)
      INTEGER      RIMNO,WIMNO,MADRID(1)
      INTEGER      UPDA,DSCORG
      INTEGER      OPTFLG(2),CLONY
      INTEGER      EC,EL,ED
C 
      INCLUDE  'MID_INCLUDE:ST_DEF.INC'
C      
      COMMON      /NULCOM/ NULCNT,USRNUL
      COMMON      /IPOOL/  FRACNT
      COMMON      /VMR/ MADRID
C 
      SAVE
C 
      DATA      WORKLM      /45/
      DATA      CUNIT       /' '/,  IDENT       /' '/
      DATA      ERROR3
     +          /'wrong syntax in arithmetic expression ...'/
      DATA      ERROR4      /'too many operands...'/
      DATA      ERROR5      /'invalid plane no...'/
C      
      INCLUDE  'MID_INCLUDE:ST_DAT.INC'
C      
C  init variables
      CUTS(1) = 0.
      CUTS(2) = 0.
      CUTS(3) = + 999999.9
      CUTS(4) = - 999999.9
      RCUTS(1) = 0.
      RCUTS(2) = 0.
      RCUTS(3) = CUTS(3)
      RCUTS(4) = CUTS(4)
      RIMNO = -1
      RFELEM = 1
      OPTFLG(1) = 0
      CLONY = 1                               !default = try to clone
C 
      DO 120, N=1,6
         NPIX(N) = 1
         START(N) = 0.D0
         STEP(N) = 1.D0
120   CONTINUE
C 
      DO 130, N=1,23
         DATTA(N) = 0.D0
         FELEM(N) = 1
130   CONTINUE
      DO 140, N=1,48
         APNTRS(N) = -1
140   CONTINUE
C 
C  reduce expression... (clean up + fill ATOM, LATOM)
200   SIZE = 80                                !length of ATOM(i) strings
      CALL EXPCLE(ZLINE,WORK,SIZE,COUNT,ATOM,LATOM)      
      IF (COUNT.EQ.-1) THEN
         CALL STETER(1,ERROR3)     
      ELSE IF (COUNT.EQ.-2) THEN
         CALL STETER(5,'arithmetic expression too long...')
C      
C  take care of operand without operation   (extend F or C to F+C or C+C)
      ELSE IF (COUNT.EQ.1) THEN    
         ATOM(2) = '0.'    
         LATOM(2) = 2
         WORK(2:3) = '+C'
         COUNT = 2
      ENDIF
C      
C  convert cleaned algebraic expression to polish postfix
      ZLINE(1:) = ' '
      CALL EXPPOL(WORK,ZLINE,STAT)                 
      IF (STAT.NE.0) CALL STETER(2,ERROR3)     
      LL = INDEX(ZLINE,' ') - 1
      IF (LL.GT.WORKLM) 
     +   CALL STETER(8,'Too many operands - reduce expression...')
C      
C  fill pointers for atoms
      DATFMT = D_R8_FORMAT                   !that's what we use currently
      K = 1
      DO 220, N=1,LL
         WORKY = ZLINE(N:N)
         IF ( (WORKY.EQ.'C').OR. (WORKY.EQ.'F').OR.
     +        (WORKY.EQ.'Q').OR. (WORKY.EQ.'P') ) THEN
            APNTRS(N) = K
            K = K + 1
         ENDIF
220   CONTINUE
C 
C  check for descriptor-origin-frame (other than 1. frame)
C  but be careful of frame[.. , ..:.. , ..] syntax
C 
      DSCFRA(1:) = ' '
      LL = 0
      K = INDEX(ZRESFR,']')
      IF (K.GT.1) THEN                          !abc[...],descframe possible
         K = K + 1
         IF (ZRESFR(K:K).EQ.',') LL = K
      ELSE
         LL = INDEX(ZRESFR,',')                 !abc,descframe possible
      ENDIF
      IF (LL.GT.1) THEN
         OUTPU(1:) = ZRESFR(LL+1:)
         CALL CLNFRA(OUTPU,DSCFRA,0)
         ZRESFR(LL:) = ' '
      ENDIF
C 
C  if COMPUTE/PLANE we have to work more
      IF (ZDEFA(2:2).EQ.'X') THEN
         M = INDEX(ZRESFR,'.P')                 !we know it's there...
         CALL GENCNV(ZRESFR(M+2:),1,1,INPU,RDUM,DDUM,STAT)
         IF (STAT.LT.1) CALL STETER(24,ERROR5)
         RFELEM = INPU(1)
         IF (RFELEM.LT.1) CALL STETER(24,ERROR5)
         ZRESFR(M:) = ' '
      ENDIF
      CALL CLNFRA(ZRESFR,RESFRA,0)
C      
C  find frames + constants
      LL = 0                        !counter in ATOM
      K = 0
C 
      DO 250, N=1,WORKLM
         WORKY = WORK(N:N)
         IF (WORKY.EQ.' ') GOTO 300
C 
         IF (WORKY.EQ.'F') THEN
            K = K + 1                   !not more than 23 frames possible
            LL = LL + 1
C 
            IF (ZDEFA(2:2).EQ.'X') THEN
               M = INDEX(ATOM(LL),'.P')
               IF (M.LT.2) M = INDEX(ATOM(LL),'.p')
               IF (M.LT.2) THEN                       !check, if it's p#
                  IF ((ATOM(LL)(1:1).EQ.'P').OR.
     +                (ATOM(LL)(1:1).EQ.'p')) THEN
                     CALL GENCNV(ATOM(LL)(2:),1,1,INPU,RDUM,DDUM,STAT)
                     IF (STAT.EQ.1) THEN
                        FELEM(K) = INPU(1)
                        INFRAM(K) = RESFRA
                        GOTO 240
                     ENDIF
                  ENDIF
               ELSE                                   !it's frame.p#
                  CALL GENCNV(ATOM(LL)(M+2:),1,1,INPU,RDUM,DDUM,STAT)
                  IF (STAT.LT.1) CALL STETER(24,ERROR5)
                  FELEM(K) = INPU(1)
                  ATOM(LL)(M:) = ' '
               ENDIF
            ENDIF
C 
            CALL CLNFRA(ATOM(LL),INFRAM(K),0)
240         PIDX(LL) = K                !we'll use PIDX instead of ATOM later
C      
         ELSE IF (WORKY.EQ.'C') THEN
            LL = LL + 1                 !we'll use DATTA instead of ATOM later
            CALL GENCNV(ATOM(LL),4,1,INPU,RDUM,DATTA(LL),STAT)
            IF (STAT.LE.0) CALL STETER
     +         (10,'conversion error of ASCII -> number ...')
C
         ELSE IF ((WORKY.EQ.'P').OR.(WORKY.EQ.'Q')) THEN
            LL = LL + 1
         ENDIF
250   CONTINUE
C      
C  extract 1-arg, 2-arg operations and save them (with offsets)
300   WORK1(1:) = ZLINE(1:)
      LL = (WORKLM+1) / 2
      DO 350, N=1,999
         CALL EXPRDC(WORK1,WORK,OPER(N),PPP(N))
         IF (PPP(N).LT.1) CALL STETER(1,ERROR3)
         IF (WORK(2:2).NE.' ') THEN
            WORK1 = WORK
         ELSE
            IF (N.GT.LL) CALL STETER
     +         (11,'too many operations in expression - split it up...')
            OPCNT = N 
            GOTO 1000
         ENDIF
350   CONTINUE
C 
1000  IF (ZDEFA(2:2).EQ.'X') THEN               !we must have a result frame
         CALL STFOPN(RESFRA,D_R8_FORMAT,0,F_IMA_TYPE,RIMNO,STAT)
         CALL STDRDI(RIMNO,'NAXIS',1,1,IAV,NAXIS,UNIT,NNULL,STAT)
         IF (NAXIS.LT.3) 
     +      CALL STETER(25,'invalid 2-dim result frame...')
         CALL STDRDI(RIMNO,'NPIX',1,3,IAV,NPIX,UNIT,NNULL,STAT)
         IF (RFELEM.GT.NPIX(3)) CALL STETER(24,ERROR5)
         SIZE = NPIX(1)*NPIX(2)
         RFELEM = (RFELEM-1)*SIZE+ 1               !now first elem
         NAXIS = 2
         CALL STDRDR(RIMNO,'LHCUTS',1,4,IAV,RCUTS,UNIT,NNULL,STAT)
         CUTS(3) = DBLE (RCUTS(3))
         CUTS(4) = DBLE (RCUTS(4))
      ENDIF
C      
C  if no frames involved ... do it right now + skip the loop
C      
      IF (K.LE.0) THEN
         CALL COMPUX(PNTR,OPER,PPP,OPCNT,APNTRS,ATOM,DATTA,PIDX,
     +               COUNT,NPIX(1),RPNTR,CUTS(3))
         CONST = CUTS(3)
         IF (ZDEFA(1:1).EQ.'N') THEN    !put resulting constant into OUTPUTD(1)
            CALL STKWRD('OUTPUTD',CONST,1,1,UNIT,STAT)
            WRITE(OUTPU,10000) CONST
            CALL STTPUT(OUTPU,STAT)
         ELSE
            IF (ZDEFA(2:2).NE.'X') THEN 
               CALL STIGET(RESFRA,D_R8_FORMAT,F_IO_MODE,F_IMA_TYPE,
     +                     6,NAXIS,NPIX,START,STEP,IDENT,
     +                     CUNIT,RPNTR,RIMNO,STAT)
               CALL STDRDR(RIMNO,'LHCUTS',1,4,IAV,RCUTS,UNIT,NNULL,STAT)
               SIZE = 1
               DO 1100, N=1,NAXIS
                  SIZE = SIZE * NPIX(N)
1100           CONTINUE
               CALL DOPFC('FC=',0.,CONST,MADRID(RPNTR),SIZE,
     +                    USRNUL,NNN)
               RCUTS(3) = REAL (CONST)          !copy constant to frame
               RCUTS(4) = REAL (CONST)
            ELSE
               CALL STFCRE('WORK',D_R8_FORMAT,F_X_MODE,F_IMA_TYPE,
     +                     SIZE,WIMNO,STAT)
               CALL STFMAP(WIMNO,F_X_MODE,1,SIZE,IAV,RPNTR,STAT)
               CALL DOPFC('FC=',0.,CONST,MADRID(RPNTR),SIZE,
     +                    USRNUL,NNN)
               CALL STFPUT(RIMNO,RFELEM,SIZE,MADRID(RPNTR),STAT)
               IF (CONST.LT.CUTS(3)) THEN
                  CUTS(3) = CONST
               ELSEIF (CONST.GT.CUTS(4)) THEN
                  CUTS(4) = CONST
               ELSE
                  GOTO 9000
               ENDIF
               RCUTS(3) = REAL (CUTS(3))
               RCUTS(4) = REAL (CUTS(4))
            ENDIF
            IF (NNN.GT.0) NULCNT = NULCNT + NNN
            CALL STDWRR(RIMNO,'LHCUTS',RCUTS,1,4,UNIT,STAT)
            CALL DSCUPT(RIMNO,RIMNO,' ',STAT)
         ENDIF
         GOTO 9000
      ENDIF
C      
C  at least one frame involved ...
C      
      FRACNT = K
      CALL ISSUBF(RESFRA,K)
      IF (K.GT.0) THEN
         UPDA = 1
      ELSE 
         UPDA = 0
      ENDIF
C 
      IF (DSCFRA(1:1).NE.' ') THEN
         DSCORG = 0
      ELSE
         DSCORG = 1
      ENDIF
C 
C  loop over all input frames to check, if we update result frame
C 
      DO 1250, N=1,FRACNT
         CALL STFINF(INFRAM(N),2,INFO,STAT)
         CALL STFOPN(INFRAM(N),D_R8_FORMAT,0,F_IMA_TYPE,IMNO(N),STAT)
C 
         IF (ZDEFA(2:2).NE.'X')THEN
            IF (UPDA.EQ.0) 
     +         CALL GENEQF(INFRAM(N),RESFRA,UPDA)   !input_frame = res_frame?
            IF (DSCORG.EQ.0)  THEN
               CALL GENEQF(INFRAM(N),DSCFRA,LL)
               IF (LL.NE.0) DSCORG = N
            ENDIF
         ENDIF
1250  CONTINUE
C 
      IF (ZDEFA(2:2).EQ.'X')THEN
         UPDA = 1
         DSCORG = 0
         CLONY = 0
      ELSE
         IF (DSCORG.EQ.0) DSCORG = 1         !if not found take 1. frame
         M = INDEX(INFRAM(DSCORG),'@')
         IF (M.GT.0) THEN
            CLONY = 0
         ELSE
            M = INDEX(INFRAM(DSCORG),'[')
            IF (M.GT.0) CLONY = 0
         ENDIF
      ENDIF
      CALL STKRDI('AUX_MODE',10,1,LL,M,UNIT,NNULL,STAT)
      IF (M.EQ.123) CLONY = 0               !no cloning with old descr. format
C 
C  if no frame is equal to result frame, we create it
C
      IF (UPDA.EQ.0) THEN                !get standard descr. from DSCORG frame
         CALL STDRDI(IMNO(DSCORG),
     +               'NAXIS',1,1,IAV,NAXIS,UNIT,NNULL,STAT)
         CALL STDRDI(IMNO(DSCORG),
     +               'NPIX',1,NAXIS,IAV,NPIX,UNIT,NNULL,STAT)
         CALL STDRDD(IMNO(DSCORG),
     +               'START',1,NAXIS,IAV,START,UNIT,NNULL,STAT)
         CALL STDRDD(IMNO(DSCORG),
     +               'STEP',1,NAXIS,IAV,STEP,UNIT,NNULL,STAT)
         CALL STDRDC(IMNO(DSCORG),
     +               'IDENT',1,1,72,IAV,IDENT,UNIT,NNULL,STAT)
         M = (NAXIS+1) * 16
         CALL STDRDC(IMNO(DSCORG),
     +               'CUNIT',1,1,M,IAV,CUNIT,UNIT,NNULL,STAT)
C      
         SIZE = 1
         DO 1300, N=1,NAXIS
            SIZE = SIZE*NPIX(N)
1300     CONTINUE
C
C  try to clone descriptors of input frame
C  only possible, if same data type
C
         IF (CLONY.EQ.1) THEN
            OPTFLG(1) = 1
            OPTFLG(2) = IMNO(DSCORG)
            CALL STECNT('GET',EC,EL,ED)            !disable error abort
            CALL STECNT('PUT',1,0,0)

            CALL STFXCR(RESFRA,DATFMT,F_O_MODE,F_IMA_TYPE,
     +                  SIZE,OPTFLG,RIMNO,STAT)
            CALL STECNT('PUT',EC,EL,ED)
         ELSE                                !it's an extracted frmae
            STAT = 40                        !force fresh descriptors
         ENDIF
C      
         IF (STAT.GT.0) THEN     !could NOT clone descriptors...
            CLONY = 0
            CALL STFCRE(RESFRA,DATFMT,F_O_MODE,F_IMA_TYPE,
     +                  SIZE,RIMNO,STAT)
            CALL STDWRI(RIMNO,'NAXIS',NAXIS,1,1,UNIT,STAT)
            CALL STDWRI(RIMNO,'NPIX',NPIX,1,NAXIS,UNIT,STAT)
            CALL STDWRD(RIMNO,'START',START,1,NAXIS,UNIT,STAT)
            CALL STDWRD(RIMNO,'STEP',STEP,1,NAXIS,UNIT,STAT)
            CALL STDWRC(RIMNO,'IDENT',1,IDENT,1,72,UNIT,STAT)
            CALL STDWRC(RIMNO,'CUNIT',1,CUNIT,1,M,UNIT,STAT)
         ENDIF
C 
C  else we just open the frame
C 
      ELSE
         IF (ZDEFA(2:2).NE.'X') THEN
            CALL STFOPN(RESFRA,DATFMT,0,F_IMA_TYPE,RIMNO,STAT)
            CALL STDRDI(RIMNO,'NAXIS',1,1,IAV,NAXIS,UNIT,NNULL,STAT)
            CALL STDRDI(RIMNO,'NPIX',1,NAXIS,IAV,NPIX,UNIT,NNULL,STAT)
            SIZE = 1
            DO 1330, N=1,NAXIS
               SIZE = SIZE*NPIX(N)
1330        CONTINUE
         ENDIF
         CALL STFINF(RESFRA,2,INFO,STAT)
         IF (INFO(2).NE.D_R8_FORMAT) THEN
            CUNIT(1:) =
     +      'Warning: Result frame is not real - '//
     +      'you may get truncation errors... '
            CALL STTPUT(CUNIT,STAT)
         ENDIF
         CALL STDRDD(RIMNO,'START',1,NAXIS,IAV,START,UNIT,NNULL,STAT)
         CALL STDRDD(RIMNO,'STEP',1,NAXIS,IAV,STEP,UNIT,NNULL,STAT)
         DSCORG = 0
      ENDIF
C 
C  here we determine, if we have to use windows or take the complete frames
C  also COMPUTE/PIX command or if just one frame ...
C      
      IF (ZDEFA(2:2).EQ.'X') THEN
         DO 1600, N=1,FRACNT
            CALL STDRDI(IMNO(N),
     +                  'NAXIS',1,1,IAV,NAXISA,UNIT,NNULL,STAT)
            CALL STDRDI(IMNO(N),
     +                  'NPIX',1,NAXISA,IAV,NPIXA,UNIT,NNULL,STAT)
            IF (FELEM(N).GT.1) THEN
               IF ((NAXISA.LT.3) .OR. (NPIXA(3).LT.FELEM(N)))
     +            CALL STETER(27,ERROR5)
               FELEM(N) = (FELEM(N)-1)*SIZE + 1
            ELSE IF (NAXISA.LT.2)THEN
               CALL STETER(26,'1-dim input frame not supported...')
            ENDIF
            DO 1500, K=1,NAXIS
               IF (NPIX(K).NE.NPIXA(K)) 
     +            CALL STETER(26,'non-matching NPIX...')
1500        CONTINUE
1600     CONTINUE
C 
      ELSE IF (ZDEFA(2:2).EQ.'P') THEN
         DO 1800, N=1,FRACNT
            IF (N.NE.DSCORG) THEN
               CALL STDRDI(IMNO(N),
     +                     'NAXIS',1,1,IAV,NAXISA,UNIT,NNULL,STAT)
               IF (NAXISA.NE.NAXIS)
     +            CALL STETER(26,'non-matching NAXIS...')
               CALL STDRDI(IMNO(N),
     +                     'NPIX',1,NAXISA,IAV,NPIXA,UNIT,NNULL,STAT)
               DO 1700, K=1,NAXIS
                  IF (NPIX(K).NE.NPIXA(K)) 
     +               CALL STETER(26,'non-matching NPIX...')
1700           CONTINUE
            ENDIF
1800     CONTINUE
C      
      ELSE
         DO 2000, N=1,FRACNT
            IF (N.NE.DSCORG) THEN
               CALL STDRDI(IMNO(N),
     +                     'NPIX',1,NAXIS,IAV,NPIXA,UNIT,NNULL,STAT)
               CALL STDRDD(IMNO(N),
     +                     'START',1,NAXIS,IAV,STARTA,UNIT,NNULL,STAT)
               CALL STDRDD(IMNO(N),
     +                     'STEP',1,NAXIS,IAV,STEPA,UNIT,NNULL,STAT)
               DO 1900, K=1,NAXIS
                  IF (NPIX(K).NE.NPIXA(K)) GOTO 3000
                  EPS = 0.0001 * ABS(STEP(K))              !0.01 % of step
                  DIF = ABS(STEP(K) - STEPA(K))
                  IF (DIF.GT.EPS) GOTO 3000
                  EPS = 0.01 * ABS(STEP(K))                !1.0 % of step
                  DIF = ABS(START(K) - STARTA(K))
                  IF (DIF.GT.EPS) GOTO 3000
1900           CONTINUE
            ENDIF
2000     CONTINUE
         GOTO 5000
C      
C  frames are not of same size or unaligned
C  so we only work on overlapping area (done in COMPUY)
C  but open DESCR originator frame again, so we can use DSCUPT after
C  
3000     CALL COMPUY(DATFMT,ZLINE,ATOM,APNTRS,UPDA,RESFRA,CUTS(3))
         CALL STFOPN(RESFRA,DATFMT,0,F_IMA_TYPE,RIMNO,STAT)
         IF (DSCORG.NE.0) THEN
            CALL STFOPN(INFRAM(DSCORG),
     +                  DATFMT,0,F_IMA_TYPE,IMNO(DSCORG),STAT)
            CALL DSCUPT(IMNO(DSCORG),RIMNO,' ',STAT)
         ELSE
            CALL DSCUPT(RIMNO,RIMNO,' ',STAT)
         ENDIF
         RCUTS(3) = REAL(CUTS(3))
         RCUTS(4) = REAL(CUTS(4))
         CALL STDWRR(RIMNO,'LHCUTS',RCUTS,1,4,UNIT,STAT)
         GOTO 9000
      ENDIF
C      
C  here we can work in pixel space
C      
5000  CALL STKRDI('MONITPAR',20,1,LL,MAPSIZ,UNIT,NNULL,STAT)
      IF (MAPSIZ.LT.100) MAPSIZ = 100               !default chunk size
      MAPSIZ = MAPSIZ*MAPSIZ
      IF (FRACNT.GT.3) MAPSIZ = MAPSIZ/2
      IF (MAPSIZ.GT.SIZE) THEN
         MAPSIZ = SIZE
         TOTAL = 1
      ELSE
         TOTAL = SIZE / MAPSIZ
         IF ( (TOTAL*MAPSIZ) .LT. SIZE) TOTAL = TOTAL + 1
      ENDIF
C 
C  map virtual memory for input files, 4 working buffers + result frame
      K = (FRACNT + 5) * MAPSIZ
      CALL STFCRE('WORK',D_R8_FORMAT,F_X_MODE,F_IMA_TYPE,
     +            K,WIMNO,STAT)
      CALL STFMAP(WIMNO,F_X_MODE,1,K,IAV,PNTR(1),STAT)
      IF (FRACNT.GT.1) THEN
         DO 5200, N=2,FRACNT                 !no more pointers,
            PNTR(N) = PNTR(N-1) + 2*MAPSIZ     !but indices of MADRID ...
5200     CONTINUE
      ENDIF
C 
      RPNTR = PNTR(FRACNT) + 2*MAPSIZ         !double precision...
C 
C  get pointers for 4 working chunks
      DO 5250, N=1,4
         PNTR(N+23) = RPNTR + (2*N*MAPSIZ)
5250  CONTINUE
C      
C  loop over all chunks
C
      DO 5800, N=1,TOTAL
         DO 5600, K=1,FRACNT
            CALL STFGET(IMNO(K),FELEM(K),MAPSIZ,TRSIZE,
     +                  MADRID(PNTR(K)),STAT)
            FELEM(K) = FELEM(K) + TRSIZE
5600     CONTINUE
C      
         CALL COMPUX(PNTR,OPER,PPP,OPCNT,APNTRS,ATOM,DATTA,PIDX,
     +               COUNT,TRSIZE,RPNTR,CUTS(3))
C      
         CALL STFPUT(RIMNO,RFELEM,TRSIZE,MADRID(RPNTR),STAT)
         RFELEM = RFELEM + TRSIZE
5800  CONTINUE
C  
C  ***
C  we're done - set dynamic range of result frame
C  ***
C      
C  take care of descriptors
      IF (DSCORG.NE.0) THEN
         IF (CLONY.EQ.1) THEN
            CALL DSCUPT(RIMNO,RIMNO,' ',STAT)
         ELSE
            CALL DSCUPT(IMNO(DSCORG),RIMNO,' ',STAT)
         ENDIF
      ELSE IF (UPDA.EQ.1) THEN                       !just update history
         CALL DSCUPT(RIMNO,RIMNO,' ',STAT)
      ENDIF
      RCUTS(3) = REAL(CUTS(3))
      RCUTS(4) = REAL(CUTS(4))
      CALL STDWRR(RIMNO,'LHCUTS',RCUTS,1,4,UNIT,STAT)
C      
C  That's it folks...
9000  RETURN
C
C  formats...
10000 FORMAT(G24.15)
      END

      SUBROUTINE COMPUX(PNTR,OPER,PPP,OPCNT,APNTRS,ATOM,DATTA,PIDX,
     +                     COUNT,MAPSIZ,RPNTR,CUTS)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine COMPUX			951011
C  K. Banse				ESO - Garching
C
C.KEYWORDS
C  arithmetic operations
C
C.PURPOSE
C  evaluate the arithmetic expression specified in the main module
C  for the currently mapped section of the complete data space
C
C.ALGORITHM
C  straight forward but rather tricky - we have to juggle pointers like hell...
C
C.INPUT/OUTPUT
C  call as COMPUX(PNTR,OPER,PPP,OPCNT,APNTRS,ATOM,DATTA,PIDX,
C               COUNT,MAPSIZ,RPNTR,CUTS)
C  input par:
C  PNTR:	I*8 array	data pointers
C  OPER:	char. array	holds the individual operations
C  				which make up the complete expression
C  PPP:		I*4 array	points to the first atom to be used 
C  				with OPER(n)
C  OPCNT:	I*4		size of OPER + PPP
C  APNTRS:	I*4 array	initial array of pointers to ATOM
C  ATOM:	char. array 	holds names of frames, names of functions
C  				and constants in ASCII
C  				only needed for function names...
C  DATTA:	R*8 array	holds constants already as reals
C  PIDX:	I*4 array	array of pointers to frames
C  COUNT:	I*4		total no. of operands in original expression
C  MAPSIZ:	I*4		size of mapped chunks
C  RPNTR:	I*8		pointer to result frame
C  
C  output par:
C  CUTS:	R*8 array	minmax values for result frame
C      
C.VERSIONS
C  see SCCS
C      
C-------------------------------------------------------------------------
C      
      IMPLICIT NONE
C
      CHARACTER      ATOM(23)*80,OPER(23)*5
      CHARACTER      BTOM(23)*80
      CHARACTER      OPERA*5
C      
      DOUBLE PRECISION  DATTA(*)
      DOUBLE PRECISION  CUTS(2),CNSTAB(2),CONST
      DOUBLE PRECISION  BDATA(23),FMIN,FMAX
C      
      REAL         USRNUL
C 
      INTEGER      NULCNT,NNN
      INTEGER      PPP(*),OPCNT,APNTRS(*),PIDX(*),COUNT
      INTEGER      BPNTRS(48),BPIDX(23)
      INTEGER*8    RPNTR,OUTPTR,KPNTR,LPNTR,PNTR(27)
      INTEGER      MAPSIZ
      INTEGER      FRACNT
      INTEGER      N,IDUMMY
      INTEGER      NBRA,P1,P2,P3,PP
      INTEGER      OPINDX,NOUT
      INTEGER      MADRID(1)
C      
      COMMON      /NULCOM/ NULCNT,USRNUL
      COMMON      /IPOOL/  FRACNT
C 
      COMMON      /VMR/ MADRID
C      
C  first initialize pointers for ATOM
      OPINDX = 0
      DO 100 N=1,COUNT
         BTOM(N) = ATOM(N)
         BDATA(N) = DATTA(N)
         BPIDX(N) = PIDX(N)
100   CONTINUE
      FMIN = CUTS(1)
      FMAX = CUTS(2)
C 
      DO 150, N=1,48
         BPNTRS(N) = APNTRS(N)
150   CONTINUE
      IDUMMY = 0                        !init DUMMY counter
C      
C  extract basic OPERAs
1000  OPINDX = OPINDX + 1
      OPERA = OPER(OPINDX)
      PP = PPP(OPINDX)
C      
C  extract operands
      P1 = BPNTRS(PP)
      P2 = BPNTRS(PP+1)
      P3 = BPNTRS(PP+2)
C      
C  find out what kind of OPERA to do
      IF (INDEX(OPERA,'C').GT.0) THEN
         IF (INDEX(OPERA,'F').GT.0) GOTO 1600            !also F involved...?
      ELSE
         IF (OPERA(1:1).EQ.'P') THEN
            GOTO 1600                              !handle PF)
         ELSE
            GOTO 2000                              !handle FF or QFF)
         ENDIF
      ENDIF
C      
C  ***
C  only constants involved, do it right now
C  ***
C      
      IF (OPERA(1:2).EQ.'CC') THEN
         CALL DOPCC(OPERA,BDATA(P1),BDATA(P2),CONST)
      ELSE
         IF (OPERA(1:1).EQ.'P') THEN                  !1-arg functions
            CALL DF1C(BTOM(P1)(1:5),BDATA(P2),CONST)
         ELSE                                          !2-arg functions
            CNSTAB(1) = BDATA(P2)
            CNSTAB(2) = BDATA(P3)
            CALL DF2CC(BTOM(P1)(1:5),CNSTAB,CONST)
         ENDIF
      ENDIF
C
C  put resulting constant back into relevant BTOM + goto loopend
      IF (OPCNT.NE.OPINDX) THEN
         BDATA(P1) = CONST
         GOTO 5000
      ELSE                        !we're done already...
         CUTS(1) = CONST
         GOTO 8000
      ENDIF
C
C  ***
C  one operand is a file
C  ***
C      
1600  IF (OPERA(1:2).EQ.'FC') THEN
         KPNTR = PNTR(BPIDX(P1))
         CONST = BDATA(P2)
         NBRA = 1                                    !no function
      ELSE IF (OPERA(1:2).EQ.'CF') THEN
         KPNTR = PNTR(BPIDX(P2))
         CONST = BDATA(P1)
         NBRA = 1                                    !no function
      ELSE IF (OPERA(1:2).EQ.'PF') THEN
         KPNTR = PNTR(BPIDX(P2))
         NBRA = 2                                    !1-arg function
      ELSE
         NBRA = 3                                    !2-arg function
         IF (OPERA(1:2).NE.'QC') THEN
            KPNTR = PNTR(BPIDX(P2))
            CONST = BDATA(P3)
         ELSE
            KPNTR = PNTR(BPIDX(P3))
            CONST = BDATA(P2)
         ENDIF
      ENDIF
C      
C determine where result should go to
C      
      IF (OPCNT.EQ.OPINDX) THEN            !last OPERA ?
         OUTPTR = RPNTR
      ELSE
         DO 1700, N=24,27                  !24,25,26,27 are the dummy pointers
            IF (KPNTR.EQ.PNTR(N)) THEN     !operand is one of the dummy frames
               OUTPTR = PNTR(N)
               NOUT = N
               GOTO 1900
            ENDIF
1700     CONTINUE
C                                    !we have to use up one of the dummy frames
         IF (IDUMMY.LE.3) THEN
            IDUMMY = IDUMMY + 1
            NOUT = 23 + IDUMMY            !keep no. of dummy area used 
            OUTPTR = PNTR(NOUT)            !for output
         ELSE
            CALL STETER(99,'error in internal logic ...!')
         ENDIF
      ENDIF
C
C  now do the actual OPERA
1900  IF (NBRA.EQ.1) THEN
         CALL DOPFC(OPERA,MADRID(KPNTR),CONST,MADRID(OUTPTR),
     +              MAPSIZ,USRNUL,NNN)
      ELSE IF (NBRA.EQ.2) THEN
         CALL DFN1F(BTOM(P1)(1:5),MADRID(KPNTR),MADRID(OUTPTR),
     +              MAPSIZ,USRNUL,NNN)
      ELSE
         CALL DFN2FC(BTOM(P1)(1:5),MADRID(KPNTR),CONST,
     +              MADRID(OUTPTR),MAPSIZ,USRNUL,NNN)
      ENDIF
      NULCNT = NULCNT + NNN                 !update null count
C      
      IF (OPCNT.NE.OPINDX) THEN
         GOTO 4400                              !goto loopend
      ELSE
         GOTO 7700
      ENDIF
C
C  ***
C  both operands are files 
C  ***
C      
2000  IF (OPERA(1:1).NE.'Q') THEN
         KPNTR = PNTR(BPIDX(P1))
         LPNTR = PNTR(BPIDX(P2))
      ELSE
         KPNTR = PNTR(BPIDX(P2))
         LPNTR = PNTR(BPIDX(P3))
      ENDIF
C      
C determine where result should go to
C      
      IF (OPCNT.EQ.OPINDX) THEN            !last OPERA ?
         OUTPTR = RPNTR
      ELSE
         DO 2100, N=24,27                  !24,25,26,27 are the dummy pointers
            IF ( (KPNTR.EQ.PNTR(N)) .OR.   !operand is one of the dummy frames
     +           (LPNTR.EQ.PNTR(N)) ) THEN      
               OUTPTR = PNTR(N)
               NOUT = N
               GOTO 4000
            ENDIF
2100     CONTINUE
C                              !we have to use up one of the dummy frames
         IF (IDUMMY.LE.3) THEN
            IDUMMY = IDUMMY + 1
            NOUT = 23 + IDUMMY            !keep no. of dummy area used 
            OUTPTR = PNTR(NOUT)            !for output
         ELSE
            CALL STETER(99,'error in internal logic ...!')
         ENDIF
      ENDIF
C
C  now do the actual OPERA
4000  IF (OPERA(1:1).NE.'Q') THEN
         CALL DOPFF(OPERA,MADRID(KPNTR),MADRID(LPNTR),
     +              MADRID(OUTPTR),MAPSIZ,USRNUL,NNN)
      ELSE
         CALL DFN2FF(BTOM(P1)(1:5),MADRID(KPNTR),MADRID(LPNTR),
     +              MADRID(OUTPTR),MAPSIZ,USRNUL,NNN)
      ENDIF
C      
      NULCNT = NULCNT + NNN               !update null count
      IF (OPCNT.EQ.OPINDX) GOTO 7700
C
C  put resulting frame pointer back into relevant BPIDX, if we are not finished yet
4400  BPIDX(P1) = NOUT
C      
C  loopend for all basic OPERAs
5000  IF (OPERA(1:1).NE.'Q') THEN
         NBRA = 2
      ELSE
         NBRA = 3
      ENDIF
      DO 5100, N=PP+1,45                        !update pointers for BTOM
         BPNTRS(N) = BPNTRS(N+NBRA)
5100  CONTINUE
      GOTO 1000                        !get next OPERA
C      
C  finally get min + max
7700  CALL DMYMX(MADRID(RPNTR),MAPSIZ,CUTS)
      IF (CUTS(1).GT.FMIN) CUTS(1) = FMIN
      IF (CUTS(2).LT.FMAX) CUTS(2) = FMAX
C      
C  that's it folks...
8000  RETURN
C      
      END

C @(#)pntspf.for	19.1 (ES0-DMD) 02/25/03 13:25:37
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine PNTSPF         version 1         820624
C  A. Kruszewski             ESO Garching
C  modified                  version 1.1       870303
C  A. Kruszewski             Obs. de Geneve
C.KEYWORDS
C  classifying parameters, profiles
C.PURPOSE
C  calculates  standard profile "SPRF" and relative, with respect
C  to standard profile, gradients for a list of objects
C.ALGORITHM
C  an approximate differential standard profile "STPR" is read
C  from keywords "
C  used method depends on a value of keyword "PRFLCTRL" which
C  is stored in variable KSGR
C  when "KSGR" is 0 then approximate profile is not improved
C  when "KSGR" is negative then stars whose coordinates are stored
C  in descriptor "STARS" are used for correcting standard profile
C  when "KSRG" is positive an iterative automatic procedure is used
C  for choosing proper standard stars
C.INPUT/OUTPUT
C  input arguments
C  NCAT        integer*4 array   integer parameters of objects
C  M           integer           number of detected objects
C  PRCT        real*4 array      array holding one-dimensional
C                                profiles for a list of objects
C  PMTR        real*4 array      array holding classifiers for
C                                a list of objects
C  IARR        integer*4 array   values of integer keywords
C  RARR        real*4 array      values of real keywords
C  output arguments
C  PMTR        real*4 array      array holding classifiers
C  SPRF        real*4 array      one dimensional point spread function
C-----------------------------------------------------------------------
      SUBROUTINE PNTSPF ( IMF , L0 , L1 , LW , NREG ,
     &                    LSTP , FPSF , NCAT , PMTR , PRCT ,
     &                    IARR , RARR , ABGRD )
C
      IMPLICIT  NONE
      INCLUDE  'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER  IMF
      INTEGER  L0 
      INTEGER  L1 
      INTEGER  LW
      INTEGER  NREG
      INTEGER  LSTP(0:4,0:NREG)
      REAL     FPSF(1)
      INTEGER  NCAT(NIPAR,MAXCNT)
      REAL     PMTR(NRPAR,MAXCNT)
      REAL     PRCT(0:MAXSUB,MAXCNT)
      INTEGER  IARR(32)
      REAL     RARR(64)
      REAL     ABGRD
C
      INTEGER  IHED
      INTEGER  KSGR
      INTEGER  K, K1, KK, KKK
      INTEGER  L, LZ
      INTEGER  LDBG
      INTEGER  M
      INTEGER  NM
      INTEGER  NK(MPSF)
      INTEGER  NSTS
      INTEGER  NP
      INTEGER  NCAT1(NIPAR,MPSF)

      REAL     BIAS
      REAL     CRMD(3)
      REAL     HCUT, HHCUT
      REAL     PRCT1(0:MAXSUB,MPSF)
      REAL     PMTR1(NRPAR,MPSF)
      REAL     SPRF(0:MAXSUB)
      REAL     STPR(MAXSUB)
      REAL     TRSH
      REAL     UPGR, UPGR2
C
C ******      Recall values of keywords.
C
      NP = MAXCNT
      LDBG = IARR(1)
      IHED = IARR(8)
      KSGR = IARR(11)
      HCUT = RARR(2)
      TRSH = RARR(3)
      CRMD(1) = RARR(39)
      CRMD(2) = RARR(40)
      CRMD(3) = RARR(41)
      UPGR = RARR(5)
      M = MAX( L1 , LW )
C
C *** Calculate average background ABGRD and
C *** upper limit for useful data HHCUT.
C
      IF ( ABGRD .EQ. 0.0 ) THEN
          CALL AVBGRD( L0 , L1 , PMTR , CRMD , ABGRD )
      ENDIF
      HHCUT = 0.7 * (HCUT-ABGRD)
C
C *** Read one-dimensional point spread function.
C
      K1 = MIN( MAXSUB , 25 )
      DO 10 K = 1 , K1
          STPR(K) = RARR(K+13)
   10 CONTINUE
      DO 20 K= 26 , MAXSUB
          STPR(K) = STPR(K1)
   20 CONTINUE
C
C *** Improve differential logarithmic point
C *** spread function STPR if KSGR .GT. 0.
C
      UPGR2 = 2.0 * UPGR
      IF ( KSGR .GT. 0 ) THEN
          CALL STGRNT( L0 , L1 , LW , NREG , LSTP ,
     &                 NCAT , PMTR , PRCT , KSGR , HHCUT ,
     &                 TRSH , UPGR2 , CRMD , STPR )
      ENDIF
C
C *** Calculate cumalative logarithmic point spread function SPRF.
C
      SPRF(0) = 0.0
      DO 30 K = 1 , MAXSUB
         SPRF(K) = SPRF(K-1) + STPR(K)
   30 CONTINUE
C
C *** Calculate relative gradients.
C
      NM=3
   41 CONTINUE
          IF ( NM .EQ.0 ) GOTO 40
          IF (KSGR.LT.0) THEN
C
C ***         Read descriptor STARS with positions of standard
C ***         stars. NSTS is a number of standard stars. NK
C ***         holds identification numbers of standard stars.
C
              CALL RDCRIN( IMF , NCAT , M , NK , NSTS )
              IF ( NSTS .GT. MPSF ) THEN
                  NSTS = MPSF
              ENDIF
              DO 70 KK = 1 , NSTS
                  K = NK(KK)
                  PMTR1(3,KK) = 0.0
                  DO 80 L = 0 , MAXSUB
                      PRCT1(L,KK) = PRCT(L,K)
   80             CONTINUE
   70         CONTINUE
C
C ***         Improve standard profile with help of standard stars.
C
              KKK = -KSGR
              CALL FSGRNT ( L0 , L1 , LW , NREG , LSTP ,
     &                      NSTS , NCAT1 , PMTR1 , PRCT1 , KKK ,
     &                      HHCUT ,TRSH , UPGR2 , CRMD , SPRF )
              NM=1
          ENDIF
          DO 50 L = 1 , M
c                  IF ( L .GT. L1 .OR. L .LE. L0 ) THEN
c                        CALL PARFIL ( ISF , L0 , L1 , LW ,
c     &                              L , LSTP , NREG , NCAT ,
c     &                                    PMTR , PRCT , NP )
c                       ENDIF
              LZ = L - L0
C
C ***         Calculate relative gradients. 
C
              CALL RLGRNT( PRCT(0,LZ) , SPRF , HHCUT , TRSH ,
     &                              PMTR(3,LZ) , PMTR(4,LZ) )
              BIAS = EXP( -(PMTR(25,LZ)**2.0) ) * ( 0.3 - STPR(1) )
              IF ( PMTR(3,LZ) .NE. -1.0 ) THEN
                  PMTR(3,LZ) = PMTR(3,LZ) - BIAS
              ENDIF
C
C ***         Mark stellar objects.
C
              IF ( ABS( PMTR(3,LZ) ) .LT. UPGR .AND. PMTR(4,LZ)
     &                                    .LT. UPGR2 ) THEN
                  PMTR(21,LZ) = 1.0
              ELSE
                  PMTR(21,LZ) = 0.0
              ENDIF
   50     CONTINUE
          IF ( NM .GE. 2 ) THEN
              IF ( KSGR .GT. 0 ) THEN
C
C ***             Improve standard profile in an automatic way.
C
                  CALL FSGRNT( L0 , L1 , LW , NREG , LSTP ,
     &                         M , NCAT , PMTR , PRCT , KSGR ,
     &                         HHCUT , TRSH , UPGR , CRMD , SPRF )
              ELSE
                  NM = 1
              ENDIF
          ENDIF
          NM = NM - 1
          GOTO 41
   40 CONTINUE
C
C ******      Write back improved one-dimensionl standard profile.
C
      K1 = ABS(KSGR)
      DO 60 K = 1 , K1
          RARR(K+13) = SPRF(K) - SPRF(K-1)
   60 CONTINUE
C
      RETURN
C
      END
C

C @(#)trsfrm.for	19.1 (ES0-DMD) 02/25/03 13:25:40
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C.IDENTIFICATION
C  subroutine TRSFRM         version 1.2        870729
C  A. Kruszewski             ESO Garching
C.AUTHOR: A.KRUSZEWSKI
C.PURPOSE
C.LANGUAGE: F77+ESOext
C.INPUT/OUTPUT
C  input arguments
C  PMTR        real*4 array      array holding classifiers
C  M           integer*4         number of objects
C                                of stallar objects
C  output arguments
C  PCLA        real*4 array      array holding corrected classifiers
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  10:07 - 22 NOV 1987
C
C-----------------------------------------------------------------------
      SUBROUTINE TRSFRM(PMTR,PCLA,M)
C
      IMPLICIT NONE
      INCLUDE 'MID_REL_INCL:INVENT.INC/NOLIST' 
C
      REAL     PMTR(30,MAXCNT)
      REAL     PCLA(0:13,MAXCNT)
      INTEGER  M
C
      INTEGER  I
      REAL     TEMP
C
C  ****    Transforms some parameters in order to make them
C	   more independent.
C
      DO 10 I = 1,M
          TEMP   = PMTR(2,I)
          IF (TEMP.LT.0.0001) THEN
              TEMP   = 0.0001
          END IF

          PCLA(0,I) = 19 - 2.5*LOG10(TEMP)
          PCLA(1,I) = 10.0*PMTR(3,I)
          PCLA(2,I) = PMTR(4,I)
          PCLA(3,I) = PCLA(3,I) - PCLA(0,I)
          TEMP   = PCLA(4,I)
          IF (TEMP.GT.1.0) THEN
              PCLA(4,I) = LOG(TEMP)

          ELSE
              PCLA(4,I) = 0.0
          END IF

          TEMP   = PCLA(5,I)
          IF (TEMP.GT.1.0) THEN
              PCLA(5,I) = LOG(TEMP)

          ELSE
              PCLA(5,I) = 0.0
          END IF

          PCLA(6,I) = PMTR(8,I)
          PCLA(7,I) = PMTR(12,I) - PCLA(0,I)
          PCLA(8,I) = PMTR(13,I) - PCLA(0,I)
          TEMP   = PCLA(9,I)
          IF (TEMP.GT.1.0) THEN
              PCLA(9,I) = LOG(TEMP)

          ELSE
              PCLA(9,I) = 0.0
          END IF

          PCLA(10,I) = PMTR(16,I) - PCLA(0,I)
          TEMP   = PMTR(17,I)
          IF (TEMP.GT.1.0) THEN
              PCLA(11,I) = LOG(TEMP)

          ELSE
              PCLA(11,I) = 0.0
          END IF

          TEMP   = PCLA(12,I)
          IF (TEMP.GT.0.1) THEN
              PCLA(12,I) = LOG(TEMP)

          ELSE
              PCLA(12,I) = -1.0
          END IF

          PCLA(13,I) = PMTR(19,I)
   10 CONTINUE
      RETURN

      END

C @(#)fitlyman.for	10.4 (ESO-IPG) 2/9/96 12:10:18
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C       Internet e-mail: midas@eso.org
C       Postal address: European Southern Observatory
C                       Data Management Division 
C                       Karl-Schwarzschild-Strasse 2
C                       D 85748 Garching bei Muenchen 
C                       GERMANY
C===========================================================================
C


      program lyminit
      
      implicit none
      include 'MID_REL_INCL:fit_var.inc'
      
                                ! copies of keywords coming from line
      character*80 SESSYS


c      character*30 choice
      character*70 sjunk


      integer ist,i,ijk,iok
      real c
      parameter (c=2.997e5)

C      include 'MID_REL_INCL:fit_mid.inc'
        INTEGER MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DEF.INC'

        COMMON/VMR/MADRID

        INCLUDE 'MID_INCLUDE:ST_DAT.INC'

C!!!!!!!
C     MIDAS SET-UP
C!!!!!!!
      call STSPRO('lyminit')
      
      call STKRDC('SESSNAM',1,1,80,i,SESSYS,ijk,ijk,iok)
      if (iok.ne.0) then
         call ErrMsg('Error in reading keywords: check context..')
         call STSEPI() 
         stop
      end if   


C!!!!!!!
C     Videata iniziale
C!!!!!!!
      call DisMsg('Initializing FITLYMAN...')
      call DisMsg('...Wait please...')
      
C!!!!!!!
C     Inizializzazione programma
C!!!!!!!
      if (SESSYS.ne.'NULL') then
         i=index(SESSYS,' ')
         sjunk=SESSYS(1:i-1)//PARTBL
      else
         sjunk=PARTBL
      end if
      call rsetup(sjunk,ist)  ! read set-up 

      if (ist.ne.0) then        ! on error, default values
         call WrnMsg('Error in reading set-up: using defaults')
         TURBLN=0
         i_grap = .false.
         call F_TBLR('SCRATCH',1,ist) !initializes lypar (in memory!)

      else

         call f_tblr(sjunk,1,ist) !read init. param.

      end if

      call f_tblw(PARTBL,1,ist)
c     call AskStp('PROGRAM',ist)
      call ssetup(PARTBL,ist)
      if (ist.ne.0) then
         call ErrMsg('Error in writing set-up: check disk space')
         call STSEPI() 
         stop
      end if   

c      call AtmRD(ist)            !read atompar.dat
c      NPUNTI=NMXSPE
c      call reaspe(FILSPE,NPUNTI)    !read spectrum
c      if (NPUNTI.lt.1) then
c         call STSEPI() 
c         stop
c      endif
c      i=index(FILLOG,' ')
c      filnam=fillog(1:i-1)//PARTBL
c      call GETIDN(filnam,IDnum,ist) 
c      if (ist.ne.0) then
c         call WrnMsg('Log files not found: starting from scratch')
c         IDnum=0
c      end if
                                ! read fit limits
      if (SESSYS.ne.'NULL') then
         i=index(SESSYS,' ')
         sjunk=SESSYS(1:i-1)//LIMTBL
      else
         sjunk=LIMTBL
      end if   
      call rintvl(sjunk,1,ist)  
      call sintvl(sjunk,1,ist) 

                                ! read minuit instructions
      if (SESSYS.ne.'NULL') then
         i=index(SESSYS,' ')
         sjunk=SESSYS(1:i-1)//MINTBL
      else
         sjunk=MINTBL
      end if   
      call rminui(sjunk,1,ist) 
      call sminui(sjunk,1,ist)

c      call ReaRes
c      call GraMai(ist)          ! plot 


c     call DisMsg('        ..done')
c     call sttdis(' ',0,ist)


      call STSEPI() 

      end
      

C===========================================================================
C Copyright (C) 1995-2005 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM FOURI
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  program FOURI		version 1.00	881028
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  Fourier transformation
C
C.PURPOSE
C  calculate the Fourier transformation of given real + imaginary frame
C
C.ALGORITHM
C  use the FFT algorithm as in E.O. Brigham: "The Fast Fourier Transform",
C  Prentice-Hall, Inc., 1974, page 164
C
C.INPUT/OUTPUT
C  the following keywords are used:
C
C  P1/C/1/120			name of real data frame
C  P2/C/1/120			name of imaginary data frame
C                               if IN_B is "+", only real input data
C  P3/C/1/120			name of frame holding real part of FT
C  P4/C/1/120			name of frame holding imaginary part of FT
C
C  CACTIO/C/1/3			'???' = normal way
C				'INV' = inverse FFT
C				'POW' = return also power spectrum
C				'FRE' = use frequencies 
C				        (center shifted to the middle)
C				'FPO' = FRE + POW combined
C				'FIN' = FRE + INV combined
C  TMPBUF/C/1/3			(1:1) = spare
C				(2:2) = I for inverse, P for power stuff
C				(3:3) will be set to Y, if expansion
C				      to a power2 frame took place or not
C	
C  P5/C/1/120			if action = POWER or FPOWER,
C				name of power spectrum
C
C.VERSIONS
C 
C 050629	last modif
C	
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER    IAV,M,N,NAXISA,NAXISB,NN,NOPIX
      INTEGER    IMNOA,IMNOB,IMNOC,IMNOD,IMNOP
      INTEGER*8  PNTRA,PNTRB,PNTRC,PNTRD,PNTRP
      INTEGER*8  DI,DR,CT,DT,TS,TC,SWAP1,SWAP2
      INTEGER    IMNODI,IMNODR,IMNOTC,IMNOTS
      INTEGER    SIZE,DSTAT,STAT
      INTEGER    NLOG(3),NPIXA(3),NPIXB(3),NPIXF(3),EXTFLG,POW2(22)
      INTEGER    LOW(3)
      INTEGER    UNI(1),NULO,MADRID(1)
      INTEGER    EC,EL,ED
C
      CHARACTER*120 WFRAME,FRAMEA,FRAMEB,FRAMEC,FRAMED,FRAMEP
      CHARACTER     IDENT*72,CUNIT*48,ACTION*3,TMP*3
C
      DOUBLE PRECISION STARTA(3),STARTB(3),STEPA(3),STEPB(3)
      DOUBLE PRECISION DBUF(6)
C
      REAL      CUTS(4),RC
C
      COMMON  /VMR/ MADRID
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      DATA      FRAMEA /' '/,    FRAMEB /' '/
      DATA      FRAMEC /' '/,    FRAMED /' '/
      DATA      IDENT  /' '/,    CUNIT  /' '/
      DATA      ACTION /' '/
      DATA      NPIXA  /3*1/,    NPIXB  /3*1/,    NPIXF  /3*1/
      DATA      STARTA /3*0.D0/, STARTB /3*0.D0/
      DATA      STEPA  /3*1.D0/, STEPB  /3*1.D0/
      DATA      EXTFLG /0/
      DATA      POW2   /1,2,4,8,16,32,64,128,256,512,1024,2048,4096,
     +                  8192,16384,32768,65536,131072,262144,524288,
     +                  1048576,2097152/
      DATA      RC     /0.0/
      DATA      LOW    /3*1/     NLOG   /3*0/
      DATA      CT     /1/,      DT     /1/
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C  get into MIDAS environment
      CALL STSPRO('FOURI')
C
C  get action
      CALL STKRDC('CACTIO',1,1,3,IAV,ACTION,UNI,NULO,STAT)
      CALL UPCAS(ACTION,ACTION)
      CALL STKRDC('TMPBUF',1,1,3,IAV,TMP,UNI,NULO,STAT)
C
C  get data frames involved
      CALL STKRDC('P1',1,1,120,IAV,FRAMEA,UNI,NULO,STAT)
      CALL STKRDC('P2',1,1,120,IAV,FRAMEB,UNI,NULO,STAT)
      CALL STKRDC('P3',1,1,120,IAV,FRAMEC,UNI,NULO,STAT)
      CALL STKRDC('P4',1,1,120,IAV,FRAMED,UNI,NULO,STAT)
C
C  map real input frame
      CALL STIGET(FRAMEA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +            3,NAXISA,NPIXA,STARTA,STEPA,
     +            IDENT,CUNIT,PNTRA,IMNOA,STAT)
C
      IF (NAXISA.GT.2) 
     +   CALL STETER(1,'only 2-dim frames supported currently...')
C
C  get imaginary part
      IF (FRAMEB(1:1).NE.'+') THEN
         CALL STIGET(FRAMEB,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +               3,NAXISB,NPIXB,STARTB,STEPB,
     +               IDENT,CUNIT,PNTRB,IMNOB,STAT)
         IF (NAXISB.NE.NAXISA) GOTO 9000
C
         DO 200, N=1,NAXISA                      !frames have to be identical
            IF (NPIXA(N).NE.NPIXB(N)) GOTO 9000
            IF (ACTION(1:1).EQ.'F') THEN
               IF (ABS(STEPA(N)-STEPB(N)).GT.10.D-15) GOTO 9000
               IF (ABS(STARTA(N)-STARTB(N)).GT.10.D-15) GOTO 9000
            ENDIF
200      CONTINUE
      ENDIF
C
C  for inverse FFT check descriptor FFT_SPECIAL with original START, STEP
C  and eventual NPIX before expansion
C
      DBUF(1) = STARTA(1)
      DBUF(2) = STARTA(2)
      DBUF(3) = STEPA(1)
      DBUF(4) = STEPA(2)
      DBUF(5) = DBLE(NPIXA(1))
      DBUF(6) = DBLE(NPIXA(2))
C 
      IF (TMP(2:2).EQ.'I') THEN
         CALL STECNT('GET',EC,EL,ED)
         CALL STECNT('PUT',1,0,0)             !test, if FFT_SPECIAL is there
         CALL STDRDD(IMNOA,'FFT_SPECIAL',1,6,IAV,DBUF,UNI,NULO,DSTAT)
         CALL STECNT('PUT',EC,EL,ED)
         IF (DSTAT.EQ.0) THEN
            STARTA(1) = DBUF(1)
            STARTA(2) = DBUF(2)
            STEPA(1) = DBUF(3)
            STEPA(2) = DBUF(4)
         ENDIF
      ELSE
         DSTAT = 1                            !indicate error...
      ENDIF
C
C  calculate log of dimension(s)
      DO 400, M=1,NAXISA
         NN = NPIXA(M)
         NPIXF(M) = NN
         DO 300, N=1,22
            IF (NN.LE.POW2(N)) THEN
               IF (NN.LT.POW2(N)) THEN
                  NPIXF(M) = POW2(N)
                  EXTFLG = 1
               ENDIF
               NLOG(M) = N - 1
               GOTO 400                           !jump out of loop
            ENDIF
300      CONTINUE
         CALL STETER(3,'x- or y-dimension larger than 2097152 ...')
400   CONTINUE
C
C  calculate size
      IF (NAXISA.EQ.1) THEN                     !max. 2-dim frame...
         SIZE = NPIXF(1)
      ELSE
         SIZE = NPIXF(1) * NPIXF(2)
         CALL STFXMP(2*SIZE,D_R4_FORMAT,CT,STAT)
         DT = CT + SIZE
      ENDIF
C
C  see, if we have to expand real input frame
      IF (EXTFLG.EQ.1) THEN
         CALL STFCRE('wworrkfr',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +               SIZE,IMNOC,STAT)
         CALL STFMAP(IMNOC,F_X_MODE,1,SIZE,IAV,PNTRC,STAT)
         CALL OPFC('FC=',0.0,RC,MADRID(PNTRC),SIZE,RC,STAT)    !fill with zero
         CALL COPWND(MADRID(PNTRA),NPIXA,MADRID(PNTRC),NPIXF,
     +               LOW,LOW,NPIXA)                   !and insert input frame
         CALL STFCLO(IMNOA,STAT)
         IMNOA = IMNOC
         PNTRA = PNTRC
C
         IF (FRAMEB(1:1).NE.'+') THEN              !also expand imaginary file
            CALL STFCRE('wworrkfi',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +                  SIZE,IMNOC,STAT)
            CALL STFMAP(IMNOC,F_X_MODE,1,SIZE,IAV,PNTRC,STAT)
            CALL OPFC('FC=',0.0,RC,MADRID(PNTRC),SIZE,RC,STAT)   !fill with zero
            CALL COPWND(MADRID(PNTRB),NPIXA,MADRID(PNTRC),NPIXF,
     +                  LOW,LOW,NPIXA)                   !and insert 
            CALL STFCLO(IMNOB,STAT)
            IMNOB = IMNOC
            PNTRB = PNTRC
         ENDIF
      ENDIF
C
C  update start, step for forward FFT
      IF (TMP(2:2).NE.'I') THEN
         DO 2400, N=1,NAXISA
            STEPA(N) = ABS( 1.D0 / (DBLE(NPIXF(N)) * STEPA(N)) )
            IF (ACTION(1:1).EQ.'F') THEN
               STARTA(N) = - ( (NPIXF(N)/2) * STEPA(N) )
            ELSE
               STARTA(N) = 0.0D0
            ENDIF
2400     CONTINUE
      ENDIF
C
C  create + map result frames
      IF (EXTFLG.EQ.1) THEN
         WFRAME(1:) = 'exp_fftr '
      ELSE
         WFRAME(1:) = FRAMEC(1:)
      ENDIF
      CALL STIPUT(WFRAME,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +            NAXISA,NPIXF,STARTA,STEPA,
     +            IDENT,CUNIT,PNTRC,IMNOC,STAT)
      IF (EXTFLG.EQ.1) THEN
         WFRAME(1:) = 'exp_ffti '
      ELSE
         WFRAME(1:) = FRAMED(1:)
      ENDIF
      CALL STIPUT(WFRAME,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +            NAXISA,NPIXF,STARTA,STEPA,
     +            IDENT,CUNIT,PNTRD,IMNOD,STAT)
C
C  allocate memory for working buffer DREAL + DIMAG 
C  as well as for sine + cosine look-up tables (all double prec. data)
C
      NOPIX = MAX(NPIXF(1),NPIXF(2))
      CALL STFCRE('wworkkdr',D_R8_FORMAT,F_X_MODE,F_IMA_TYPE,
     +            NOPIX,IMNODR,STAT)
      CALL STFMAP(IMNODR,F_X_MODE,1,NOPIX,IAV,DR,STAT)
      CALL STFCRE('wworkkdi',D_R8_FORMAT,F_X_MODE,F_IMA_TYPE,
     +            NOPIX,IMNODI,STAT)
      CALL STFMAP(IMNODI,F_X_MODE,1,NOPIX,IAV,DI,STAT)
C 
      CALL STFCRE('wworkkts',D_R8_FORMAT,F_X_MODE,F_IMA_TYPE,
     +            NOPIX,IMNOTS,STAT)
      CALL STFMAP(IMNOTS,F_X_MODE,1,NOPIX,IAV,TS,STAT)
      CALL STFCRE('wworkktc',D_R8_FORMAT,F_X_MODE,F_IMA_TYPE,
     +            NOPIX,IMNOTC,STAT)
      CALL STFMAP(IMNOTC,F_X_MODE,1,NOPIX,IAV,TC,STAT)
C 
C  and allocate space for swap tables
      CALL STFXMP(NOPIX,D_I4_FORMAT,SWAP1,STAT)
      SWAP2 = SWAP1 + NOPIX/2
C
C  now do it in a subroutine
      IF (FRAMEB(1:1).NE.'+') THEN                  !imaginary part exists...
         IF (TMP(2:2).EQ.'I') THEN
            CALL DFFTB(MADRID(PNTRA),MADRID(PNTRB),
     +                 MADRID(PNTRC),MADRID(PNTRD),
     +                 NPIXF,ACTION,MADRID(DR),MADRID(DI),NLOG,POW2,
     +                 MADRID(TS),MADRID(TC),
     +                 MADRID(CT),MADRID(DT),
     +                 MADRID(SWAP1),MADRID(SWAP2))
         ELSE
            CALL DFFTF(MADRID(PNTRA),MADRID(PNTRB),
     +                 MADRID(PNTRC),MADRID(PNTRD),
     +                 NPIXF,ACTION,MADRID(DR),MADRID(DI),NLOG,POW2,
     +                 MADRID(TS),MADRID(TC),
     +                 MADRID(CT),MADRID(DT),
     +                 MADRID(SWAP1),MADRID(SWAP2))
         ENDIF
         CALL STFCLO(IMNOB,STAT)
      ELSE                                          !just real data
         IF (TMP(2:2).EQ.'I') THEN
            CALL DRFFTB(MADRID(PNTRA),MADRID(PNTRC),
     +                  MADRID(PNTRD),NPIXF,ACTION,
     +                  MADRID(DR),MADRID(DI),NLOG,POW2,
     +                  MADRID(TS),MADRID(TC),
     +                  MADRID(CT),MADRID(DT),
     +                  MADRID(SWAP1),MADRID(SWAP2))
         ELSE
            CALL DRFFTF(MADRID(PNTRA),MADRID(PNTRC),
     +                  MADRID(PNTRD),NPIXF,ACTION,
     +                  MADRID(DR),MADRID(DI),NLOG,POW2,
     +                  MADRID(TS),MADRID(TC),
     +                  MADRID(CT),MADRID(DT),
     +                  MADRID(SWAP1),MADRID(SWAP2))
         ENDIF
      ENDIF
C 
C  get rid of all the allocated temporary space
      CALL STFCLO(IMNODR,STAT)
      CALL STFCLO(IMNODI,STAT)
      CALL STFCLO(IMNOTS,STAT)
      CALL STFCLO(IMNOTC,STAT)
C 
      CALL STFCLO(IMNOA,STAT)
      CALL STFOPN(FRAMEA,D_OLD_FORMAT,0,F_IMA_TYPE,IMNOA,STAT)
      CALL DSCUPT(IMNOA,IMNOC,' ',STAT)
      CALL STDWRD(IMNOC,'FFT_SPECIAL',DBUF,1,6,UNI,STAT)
C
C  if we also want power spectrum (absolute value), do it now...
      IF (TMP(2:2).EQ.'P') THEN
         CALL STKRDC('P5',1,1,120,IAV,FRAMEP,UNI,NULO,STAT)
         IF (EXTFLG.EQ.1) THEN
            WFRAME(1:) = 'exp_pow '
         ELSE
            WFRAME(1:) = FRAMEP(1:)
         ENDIF
         CALL STIPUT(WFRAME,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +               NAXISA,NPIXF,STARTA,STEPA,
     +               IDENT,CUNIT,DR,IMNODR,STAT)
         CALL POWER(MADRID(PNTRC),MADRID(PNTRD),MADRID(DR),SIZE)
         CALL DSCUPT(IMNOA,IMNODR,' ',STAT)
         CALL STDWRD(IMNODR,'FFT_SPECIAL',DBUF,1,6,UNI,STAT)
C 
         IF (EXTFLG.EQ.1) THEN
            CALL STIPUT(FRAMEP,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +                  NAXISA,NPIXA,STARTA,STEPA,
     +                  IDENT,CUNIT,PNTRP,IMNOP,STAT)
            CALL COPWND(MADRID(DR),NPIXF,MADRID(PNTRP),NPIXA,
     +                  LOW,LOW,NPIXA) 
            SIZE = NPIXA(1)*NPIXA(2)
            CALL MYMX(MADRID(PNTRP),SIZE,CUTS(1))
         ELSE
            CALL MYMX(MADRID(DR),SIZE,CUTS(1))
         ENDIF
         CUTS(3) = CUTS(1)
         CUTS(4) = CUTS(2)
         CALL STDWRR(IMNODR,'LHCUTS',CUTS,1,4,UNI,STAT)
         CALL STFCLO(IMNODR,STAT)
         IF (EXTFLG.EQ.1) THEN                     !also update extracted frame
            CALL DSCUPT(IMNOA,IMNOP,' ',STAT)
            CALL STDWRR(IMNOP,'LHCUTS',CUTS,1,4,UNI,STAT)
            CALL STDWRD(IMNOP,'FFT_SPECIAL',DBUF,1,6,UNI,STAT)
            CALL STFCLO(IMNOP,STAT)
         ENDIF
      ENDIF
C 
C  for inverse FFT, check DBUF(5,6) to see if we have to extract frames
      IF ((TMP(2:2).EQ.'I').AND.(DSTAT.EQ.0)) THEN
         NLOG(1) = NINT(DBUF(5))
         NLOG(2) = NINT(DBUF(6))
         IF ((NLOG(1).NE.NPIXA(1)) .OR. (NLOG(2).NE.NPIXA(2))) THEN
            FRAMEC(1:) = 'orig_r '
            FRAMED(1:) = 'orig_i '
            NPIXA(1) = NLOG(1)
            NPIXA(2) = NLOG(2)
            EXTFLG = 2
         ENDIf
      ENDIF
C 
C  if necessary, extract result frames
      IF (EXTFLG.GE.1) THEN
         CALL STIPUT(FRAMEC,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +               NAXISA,NPIXA,STARTA,STEPA,
     +               IDENT,CUNIT,DR,IMNODR,STAT)
         CALL COPWND(MADRID(PNTRC),NPIXF,MADRID(DR),NPIXA,
     +               LOW,LOW,NPIXA) 
         CALL STFCLO(IMNOC,STAT)
         IMNOC = IMNODR
         PNTRC = DR
         CALL DSCUPT(IMNOA,IMNOC,' ',STAT)
         CALL STDWRD(IMNOC,'FFT_SPECIAL',DBUF,1,6,UNI,STAT)
C 
         CALL STIPUT(FRAMED,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +               NAXISA,NPIXA,STARTA,STEPA,
     +               IDENT,CUNIT,PNTRB,IMNOB,STAT)
         CALL COPWND(MADRID(PNTRD),NPIXF,MADRID(PNTRB),NPIXA,
     +               LOW,LOW,NPIXA) 
         CALL STFCLO(IMNOD,STAT)
         IMNOD = IMNOB
         PNTRD = PNTRB
         SIZE = NPIXA(1)*NPIXA(2)
         IF (EXTFLG.EQ.1) THEN
            TMP(3:3) = 'Y'                   !tell fft.prg about the extension
         ELSE
            TMP(3:3) = 'Z'                   !tell fft.prg about the extraction
         ENDIF
         CALL STKWRC('TMPBUF',1,TMP,1,3,UNI,STAT)
      ENDIF
C
C  get dynamic range
      CALL MYMX(MADRID(PNTRC),SIZE,CUTS(1))
      CUTS(3) = CUTS(1)
      CUTS(4) = CUTS(2)
      CALL STDWRR(IMNOC,'LHCUTS',CUTS,1,4,UNI,STAT)
      CALL MYMX(MADRID(PNTRD),SIZE,CUTS(1))
      CUTS(3) = CUTS(1)
      CUTS(4) = CUTS(2)
      CALL STDWRR(IMNOD,'LHCUTS',CUTS,1,4,UNI,STAT)
C
C  That's it folks...
      CALL STSEPI
C 
C  here if real + imaginary input frames don't match
9000  CALL STETER(2,'input frames do not have same dimensions...')
      END

      SUBROUTINE DFFTF(A,B,C,D,NPIX,ACT,DREAL,DIMAG,NLOG,POW2,
     +                 TSIN,TCOS,CT,DT,SWAPI,SWAPO)
C
      IMPLICIT NONE
C
      INTEGER    INDX,N,NDIM,NX,NY,MM
      INTEGER    XFROM,NSIZE(2),NWORK
      INTEGER    KMM,MPOW(21)
      INTEGER    NPIX(2),NLOG(*),POW2(*)
      INTEGER    SWAPI(*),SWAPO(*),SWALIM
C
      REAL      A(*),B(*),C(*),D(*),CT(*),DT(*)
C
      DOUBLE PRECISION   DREAL(*),DIMAG(*),TSIN(*),TCOS(*)
      DOUBLE PRECISION   DFACT
      DOUBLE PRECISION   DX,DY
C
      CHARACTER*1  ACT
C
C  init
      NDIM = NPIX(1)
      DFACT = 1.D0 / DBLE(FLOAT(NDIM))
C
C  compute array MPOW:            2**(NLOG(1)-1), ..., 2**1, 2**0
      MM = NLOG(1) 
      DO 200, N=1,NLOG(1)
         MPOW(N) = POW2(MM)
         MM = MM - 1
200   CONTINUE
C
C  generate sine + cosine look-up table in x-dimension
      CALL DSCTB(TSIN,TCOS,NDIM,NLOG(1),SWAPI,SWAPO,SWALIM)
C
C  here we handle 1-dim FFT
C
      IF (NPIX(2).EQ.1) THEN
         IF (ACT.NE.'F') THEN
            DO 400, NX=1,NDIM
               DREAL(NX) = DBLE(A(NX))                  !copy A to DREAL
               DIMAG(NX) = DBLE(B(NX))                  !copy B to DIMAG
400         CONTINUE
C
            CALL DFFT(1,DREAL,DIMAG,NDIM,NLOG(1),MPOW,
     +               TSIN,TCOS,DFACT,C,D,SWAPI,SWAPO,SWALIM)        !do the FFT
         ELSE
C
C  here for frequency business (1-dim case)
C
            MM = 0
            DO 1000, NX=1,NDIM
               DX = DBLE(A(NX))
               DY = DBLE(B(NX))
               IF (MM.EQ.0) THEN
                  DREAL(NX) = DX                 !copy A*(-1)**(NX+NY) to DREAL
                  DIMAG(NX) = DY                 !copy B*(-1)**(NX+NY) to DIMAG
                  MM = 1
               ELSE
                  DREAL(NX) = -DX                !copy A*(-1)**(NX+NY) to DREAL
                  DIMAG(NX) = -DY                !copy B*(-1)**(NX+NY) to DIMAG
                  MM = 0
               ENDIF
1000        CONTINUE
C
            CALL DFFT(1,DREAL,DIMAG,NDIM,NLOG(1),MPOW,
     +               TSIN,TCOS,DFACT,C,D,SWAPI,SWAPO,SWALIM)         !do the FFT
         ENDIF
         RETURN
      ENDIF
C
C
C  -------------- here we handle 2-dim FFT -------------------
C
      NSIZE(1) = 128
      NSIZE(2) = 256
C
C  branch, if frequency scaling is wanted
      XFROM = 1
      IF (ACT.EQ.'F') GOTO 6000
      NWORK = NDIM - 1
C
C  do FFT on each line
      DO 5800, NY=1,NPIX(2)
         N = 1
         DO 5400, NX = XFROM,XFROM+NWORK
            DREAL(N) = DBLE(A(NX))                  !copy A to DREAL
            DIMAG(N) = DBLE(B(NX))                  !copy B to DIMAG
            N = N + 1
5400     CONTINUE
C
         CALL DFFT(0,DREAL,DIMAG,NDIM,NLOG(1),MPOW,
     +            TSIN,TCOS,DFACT,C(XFROM),D(XFROM),
     +            SWAPI,SWAPO,SWALIM)                    !do the FFT
C
         XFROM = XFROM + NDIM
5800  CONTINUE
C
      GOTO 7000
C
C  here for frequency business (2-dim case)
6000  KMM = 0
      DO 6800, NY=1,NPIX(2)
         N = 1
         MM = KMM
         NWORK = XFROM - 1
C
         DO 6400, NX = 1,NDIM
            INDX = NWORK + NX
            DX = DBLE(A(INDX))
            DY = DBLE(B(INDX))
            IF (MM.EQ.0) THEN
               DREAL(N) = DX                  !copy A*(-1)**(NX+NY) to DREAL
               DIMAG(N) = DY                  !copy B*(-1)**(NX+NY) to DIMAG
               MM = 1
            ELSE
               DREAL(N) = -DX                 !copy A*(-1)**(NX+NY) to DREAL
               DIMAG(N) = -DY                 !copy B*(-1)**(NX+NY) to DIMAG
               MM = 0
            ENDIF
            N = N + 1
6400     CONTINUE
C
         CALL DFFT(0,DREAL,DIMAG,NDIM,NLOG(1),MPOW,
     +            TSIN,TCOS,DFACT,C(XFROM),D(XFROM),
     +            SWAPI,SWAPO,SWALIM)                    !do the FFT

C
         XFROM = XFROM + NDIM
         KMM = 1 - KMM                        !alternate between 0 and 1
6800  CONTINUE
C
C  we now do another FFT along the columns
7000  CALL LINCOL(C,NPIX,NSIZE,CT)            !change lines -> columns
      CALL LINCOL(D,NPIX,NSIZE,DT)
      NDIM = NPIX(2)
      DFACT = DFACT / DBLE(FLOAT(NDIM))
C
C  compute array MPOW in y-dim:            2**(NLOG(2)-1), ..., 2**1, 2**0
      IF (NLOG(2).NE.NLOG(1)) THEN
         MM = NLOG(2)
         DO 7400, N=1,NLOG(2)
            MPOW(N) = POW2(MM)
            MM = MM - 1
7400     CONTINUE
C
C  and generate sine + cosine look-up table in y-dimension
         CALL DSCTB(TSIN,TCOS,NDIM,NLOG(2),SWAPI,SWAPO,SWALIM) 
      ENDIF
C
      XFROM = 1
      NWORK = NDIM - 1
C
      DO 8000, NY=1,NPIX(1)
         N = 1
         DO 7700, NX=XFROM,XFROM+NWORK
            DREAL(N) = DBLE(CT(NX))
            DIMAG(N) = DBLE(DT(NX))
            N = N + 1
7700     CONTINUE
C
         CALL DFFT(1,DREAL,DIMAG,NDIM,NLOG(2),MPOW,
     +            TSIN,TCOS,DFACT,CT(XFROM),DT(XFROM),
     +            SWAPI,SWAPO,SWALIM)                    !do the FFT
C
         XFROM = XFROM + NDIM
8000  CONTINUE
C
C  finally transpose back again
      CALL TRAPO(CT,DT,NPIX,NSIZE,C,D)
C
      RETURN
      END

      SUBROUTINE DFFTB(A,B,C,D,NPIX,ACT,DREAL,DIMAG,NLOG,POW2,
     +                 TSIN,TCOS,CT,DT,SWAPI,SWAPO)
C
      IMPLICIT NONE
C
      INTEGER    N,NDIM,NX,NY,MM
      INTEGER    XFROM,NSIZE(2),NWORK
      INTEGER    NPIX(2),NLOG(*),POW2(*)
      INTEGER    KMM,MPOW(21)
      INTEGER    SWAPI(*),SWAPO(*),SWALIM
C
      REAL      A(*),B(*),C(*),D(*),CT(*),DT(*)
C
      DOUBLE PRECISION      DREAL(*),DIMAG(*),TSIN(*),TCOS(*)
      DOUBLE PRECISION      DFACT
C
      CHARACTER*1      ACT
C
C  init
      NDIM = NPIX(1)
      DFACT = 1.D0 / DBLE(FLOAT(NDIM))
C
C  compute array MPOW:            2**(NLOG(1)-1), ..., 2**1, 2**0
      MM = NLOG(1)
      DO 200, N=1,NLOG(1)
         MPOW(N) = POW2(MM)
         MM = MM - 1
200   CONTINUE
C
C  generate sine + cosine look-up table in x-dimension
      CALL DSCTB(TSIN,TCOS,NDIM,NLOG(1),SWAPI,SWAPO,SWALIM)
C
C  do 1-dim inverse FFT
      IF (NPIX(2).EQ.1) THEN
         IF (ACT.NE.'F') THEN
            DO 400, NX=1,NDIM
               DREAL(NX) = DBLE(A(NX))            !copy A to DREAL
               DIMAG(NX) = DBLE(-B(NX))           !copy -B to DIMAG
400         CONTINUE
C
            CALL DFFT(0,DREAL,DIMAG,NDIM,NLOG(1),MPOW,
     +               TSIN,TCOS,DFACT,C,D,SWAPI,SWAPO,SWALIM)        !do the FFT
         ELSE
C
C  frequency business...
            DO 600, NX=1,NDIM
               DREAL(NX) = DBLE(A(NX))            !copy A to DREAL
               DIMAG(NX) = DBLE(-B(NX))           !copy -B to DIMAG
600         CONTINUE
C
            CALL DFFT(0,DREAL,DIMAG,NDIM,NLOG(1),MPOW,
     +               TSIN,TCOS,DFACT,C,D,SWAPI,SWAPO,SWALIM)        !do the FFT
C 
            MM = 0
            DO 1000, NX=1,NDIM
               IF (MM.EQ.0) THEN
                  MM = 1
               ELSE
                  C(NX) = - C(NX)
                  D(NX) = - D(NX)
                  MM = 0
               ENDIF
1000        CONTINUE
         ENDIF
C
         RETURN
      ENDIF
C
C
C  ------------------------- do 2-dim inverse FFT -------------------------
C
      NSIZE(1) = 128
      NSIZE(2) = 256
C
C  handle each line
      XFROM = 1
      NWORK = NDIM - 1
C
      DO 5800, NY=1,NPIX(2)
         N = 1
         DO 5400, NX=XFROM,XFROM+NWORK
            DREAL(N) = DBLE(A(NX))                  !copy A to DREAL
            DIMAG(N) = DBLE(-B(NX))                 !copy -B to DIMAG
            N = N + 1
5400     CONTINUE
C
         CALL DFFT(0,DREAL,DIMAG,NDIM,NLOG(1),MPOW,
     +            TSIN,TCOS,DFACT,C(XFROM),D(XFROM),
     +            SWAPI,SWAPO,SWALIM)                    !do the FFT
         XFROM = XFROM + NDIM
5800  CONTINUE
C
C  handle each column
      CALL LINCOL(C,NPIX,NSIZE,CT)
      CALL LINCOL(D,NPIX,NSIZE,DT)
      NDIM = NPIX(2)
CC      DFACT = DFACT * DBLE(FLOAT(NDIM))
      DFACT = 1.D0
C
C  compute array MPOW in y-dim:            2**(NLOG(2)-1), ..., 2**1, 2**0
      IF (NLOG(2).NE.NLOG(1)) THEN
         MM = NLOG(2)
         DO 6000, N=1,NLOG(2)
            MPOW(N) = POW2(MM)
            MM = MM - 1
6000     CONTINUE
C
C  and generate sine + cosine look-up table in y-dimension
         CALL DSCTB(TSIN,TCOS,NDIM,NLOG(2),SWAPI,SWAPO,SWALIM) 
      ENDIF
C
      XFROM = 1
      NWORK = NDIM - 1
C
      IF (ACT.NE.'F') THEN
         DO 6800, NY=1,NPIX(1)
            N = 1
            DO 6400, NX=XFROM,XFROM+NWORK
               DREAL(N) = DBLE(CT(NX))
               DIMAG(N) = DBLE(DT(NX))
               N = N + 1
6400        CONTINUE
C
            CALL DFFT(1,DREAL,DIMAG,NDIM,NLOG(2),MPOW,
     +               TSIN,TCOS,DFACT,CT(XFROM),DT(XFROM),
     +               SWAPI,SWAPO,SWALIM)                    !do the FFT
            XFROM = XFROM + NDIM
6800     CONTINUE
C
      ELSE
C
C  frequency business...
         KMM = 0
         DO 7800, NY=1,NPIX(1)
            N = 1
            DO 7400, NX=XFROM,XFROM+NWORK
               DREAL(N) = DBLE(CT(NX))
               DIMAG(N) = DBLE(DT(NX))
               N = N + 1
7400        CONTINUE
C
            CALL DFFT(1,DREAL,DIMAG,NDIM,NLOG(2),MPOW,
     +               TSIN,TCOS,DFACT,CT(XFROM),DT(XFROM),
     +               SWAPI,SWAPO,SWALIM)                    !do the FFT
C
            MM = KMM
            DO 7600, NX=XFROM,XFROM+NWORK
               IF (MM.EQ.0) THEN
                  MM = 1
               ELSE
                  CT(NX) = - CT(NX)
                  DT(NX) = - DT(NX)
                  MM = 0
               ENDIF
7600        CONTINUE
C
            XFROM = XFROM + NDIM
            KMM = 1 - KMM                     !alternate between 0 and 1
7800     CONTINUE
C
      ENDIF
C
C  finally transpose back again
      CALL TRAPO(CT,DT,NPIX,NSIZE,C,D)
C
      RETURN
      END

      SUBROUTINE DRFFTF(A,C,D,NPIX,ACT,DREAL,DIMAG,NLOG,POW2,
     +                  TSIN,TCOS,CT,DT,SWAPI,SWAPO)
C
      IMPLICIT NONE
C
      INTEGER    INDX,N,NDIM,NX,NY,MM
      INTEGER    XFROM,NSIZE(2),NWORK
      INTEGER    NPIX(2),NLOG(*),POW2(*)
      INTEGER    KMM,MPOW(21)
      INTEGER    SWAPI(*),SWAPO(*),SWALIM
C
      REAL      A(*),C(*),D(*),CT(*),DT(*)
C
      DOUBLE PRECISION      DREAL(*),DIMAG(*),TSIN(*),TCOS(*)
      DOUBLE PRECISION      DFACT
      DOUBLE PRECISION      DX
C
      CHARACTER*1  ACT
C
C  init
      NDIM = NPIX(1)
      DFACT = 1.D0 / DBLE(FLOAT(NDIM))
C
C  compute array MPOW:            2**(NLOG(1)-1), ..., 2**1, 2**0
      MM = NLOG(1)
      DO 200, N=1,NLOG(1)
         MPOW(N) = POW2(MM)
         MM = MM - 1
200   CONTINUE
C
C  generate sine + cosine look-up table in x-dimension
      CALL DSCTB(TSIN,TCOS,NDIM,NLOG(1),SWAPI,SWAPO,SWALIM)
C
C  here we handle 1-dim FFT
C
      IF (NPIX(2).EQ.1) THEN
         IF (ACT.NE.'F') THEN
C
            DO 400, NX=1,NDIM
               DREAL(NX) = DBLE(A(NX))                  !copy A to DREAL
               DIMAG(NX) = 0.D0
400         CONTINUE
C
            CALL DFFT(1,DREAL,DIMAG,NDIM,NLOG(1),MPOW,
     +               TSIN,TCOS,DFACT,C,D,SWAPI,SWAPO,SWALIM)        !do the FFT
         ELSE
C
C  here for frequency business
            MM = 0
            DO 1000, NX=1,NDIM
               DX = DBLE(A(NX))
               IF (MM.EQ.0) THEN
                  DREAL(NX) = DX                 !copy A*(-1)**(NX+NY) to DREAL
                  MM = 1
               ELSE
                  DREAL(NX) = -DX                !copy A*(-1)**(NX+NY) to DREAL
                  MM = 0
               ENDIF
               DIMAG(NX) = 0.D0
1000        CONTINUE
C
            CALL DFFT(1,DREAL,DIMAG,NDIM,NLOG(1),MPOW,
     +               TSIN,TCOS,DFACT,C,D,SWAPI,SWAPO,SWALIM)        !do the FFT
         ENDIF
C
         RETURN
      ENDIF
C
C
C  ---------------------- here we handle 2-dim FFT ---------------------
C
      NSIZE(1) = 128
      NSIZE(2) = 256
C
C  branch, if frequency scaling is wanted
      XFROM = 1
      IF (ACT.EQ.'F') GOTO 6000
      NWORK = NDIM - 1
C
C  do FFT on each line
      DO 5800, NY=1,NPIX(2)
         N = 1
         DO 5400, NX = XFROM,XFROM+NWORK
            DREAL(N) = DBLE(A(NX))                  !copy A to DREAL
            DIMAG(N) = 0.D0
            N = N + 1
5400     CONTINUE
C
         CALL DFFT(0,DREAL,DIMAG,NDIM,NLOG(1),MPOW,
     +            TSIN,TCOS,DFACT,C(XFROM),D(XFROM),
     +            SWAPI,SWAPO,SWALIM)                    !do the FFT
         XFROM = XFROM + NDIM
5800  CONTINUE
C
      GOTO 7000
C
C  here for frequency business
6000  KMM = 0
      DO 6800, NY=1,NPIX(2)
         N = 1
         MM = KMM
         NWORK = XFROM - 1
C
         DO 6400, NX = 1,NDIM
            INDX = NWORK + NX
            DX = DBLE(A(INDX))
            IF (MM.EQ.0) THEN
               DREAL(N) = DX                  !copy A*(-1)**(NX+NY) to DREAL
               MM = 1
            ELSE
               DREAL(N) = -DX                 !copy A*(-1)**(NX+NY) to DREAL
               MM = 0
            ENDIF
            DIMAG(N) = 0.D0
            N = N + 1
6400     CONTINUE
C
         CALL DFFT(0,DREAL,DIMAG,NDIM,NLOG(1),MPOW,
     +            TSIN,TCOS,DFACT,C(XFROM),D(XFROM),
     +            SWAPI,SWAPO,SWALIM)                    !do the FFT
C
         KMM = 1 - KMM
         XFROM = XFROM + NDIM
6800  CONTINUE
C
C  we now do another FFT along the columns
7000  CALL LINCOL(C,NPIX,NSIZE,CT)            !change lines -> columns
      CALL LINCOL(D,NPIX,NSIZE,DT)
      NDIM = NPIX(2)
      DFACT = DFACT / DBLE(FLOAT(NDIM))
C
C  compute array MPOW in y-dim:            2**(NLOG(2)-1), ..., 2**1, 2**0
      IF (NLOG(2).NE.NLOG(1)) THEN
         MM = NLOG(2)
         DO 7400, N=1,NLOG(2)
            MPOW(N) = POW2(MM)
            MM = MM - 1
7400     CONTINUE
C
C  and generate sine + cosine look-up table in y-dimension
         CALL DSCTB(TSIN,TCOS,NDIM,NLOG(2),SWAPI,SWAPO,SWALIM) 
      ENDIF
C
      XFROM = 1
      NWORK = NDIM - 1
C
      DO 8000, NY=1,NPIX(1)
         N = 1
         DO 7700, NX=XFROM,XFROM+NWORK
            DREAL(N) = DBLE(CT(NX))
            DIMAG(N) = DBLE(DT(NX))
            N = N + 1
7700     CONTINUE
C
         CALL DFFT(1,DREAL,DIMAG,NDIM,NLOG(2),MPOW,
     +            TSIN,TCOS,DFACT,CT(XFROM),DT(XFROM),
     +            SWAPI,SWAPO,SWALIM)                    !do the FFT
         XFROM = XFROM + NDIM
8000  CONTINUE
C
C  finally transpose back again
      CALL TRAPO(CT,DT,NPIX,NSIZE,C,D)
C
      RETURN
      END

      SUBROUTINE DRFFTB(A,C,D,NPIX,ACT,DREAL,DIMAG,NLOG,POW2,
     +                  TSIN,TCOS,CT,DT,SWAPI,SWAPO)
C
      IMPLICIT NONE
C
      INTEGER    N,NDIM,NX,NY,MM
      INTEGER    XFROM,NSIZE(2),NWORK
      INTEGER    NPIX(2),NLOG(*),POW2(*)
      INTEGER    KMM,MPOW(21)
      INTEGER    SWAPI(*),SWAPO(*),SWALIM
C
      REAL      A(*),C(*),D(*),CT(*),DT(*)
C
      DOUBLE PRECISION      DREAL(*),DIMAG(*),TSIN(*),TCOS(*)
      DOUBLE PRECISION      DFACT
C
      CHARACTER*1      ACT
C
C  init
      NDIM = NPIX(1)
      DFACT = 1.D0 / DBLE(FLOAT(NDIM))
C
C  compute array MPOW:            2**(NLOG(1)-1), ..., 2**1, 2**0
      MM = NLOG(1)
      DO 200, N=1,NLOG(1)
         MPOW(N) = POW2(MM)
         MM = MM - 1
200   CONTINUE
C
C  generate sine + cosine look-up table in x-dimension
      CALL DSCTB(TSIN,TCOS,NDIM,NLOG(1),SWAPI,SWAPO,SWALIM)
C
C  do 1-dim inverse FFT
      IF (NPIX(2).EQ.1) THEN
         IF (ACT.NE.'F') THEN
            DO 400, NX=1,NDIM
               DREAL(NX) = DBLE(A(NX))            !copy A to DREAL
               DIMAG(NX) = 0.D0
400         CONTINUE
C
            CALL DFFT(0,DREAL,DIMAG,NDIM,NLOG(1),MPOW,
     +               TSIN,TCOS,DFACT,C,D,SWAPI,SWAPO,SWALIM)        !do the FFT
         ELSE
C
C  frequency business...
            DO 600, NX=1,NDIM
               DREAL(NX) = DBLE(A(NX))            !copy A to DREAL
               DIMAG(NX) = 0.D0
600         CONTINUE
C
            CALL DFFT(0,DREAL,DIMAG,NDIM,NLOG(1),MPOW,
     +               TSIN,TCOS,DFACT,C,D,SWAPI,SWAPO,SWALIM)        !do the FFT
C
            MM = 0
            DO 1000, NX=1,NDIM
               IF (MM.EQ.0) THEN
                  MM = 1
               ELSE
                  C(NX) = - C(NX)
                  D(NX) = - D(NX)
                  MM = 0
               ENDIF
1000        CONTINUE
C
         ENDIF
         RETURN
      ENDIF
C
C
C  ------------------------- do 2-dim inverse FFT -------------------------
C
      NSIZE(1) = 128
      NSIZE(2) = 256
C
C  handle each line
      XFROM = 1
      NWORK = NDIM - 1
C
      DO 5800, NY=1,NPIX(2)
         N = 1
         DO 5400, NX=XFROM,XFROM+NWORK
            DREAL(N) = DBLE(A(NX))                  !copy A to DREAL
            DIMAG(N) = 0.D0
            N = N + 1
5400     CONTINUE
C
         CALL DFFT(0,DREAL,DIMAG,NDIM,NLOG(1),MPOW,
     +            TSIN,TCOS,DFACT,C(XFROM),D(XFROM),
     +            SWAPI,SWAPO,SWALIM)                    !do the FFT
C
         XFROM = XFROM + NDIM
5800  CONTINUE
C
C  handle each column
      CALL LINCOL(C,NPIX,NSIZE,CT)
      CALL LINCOL(D,NPIX,NSIZE,DT)
      NDIM = NPIX(2)
      DFACT = DFACT * DBLE(FLOAT(NDIM))
C
C  compute array MPOW in y-dim:            2**(NLOG(2)-1), ..., 2**1, 2**0
      IF (NLOG(2).NE.NLOG(1)) THEN
         MM = NLOG(2)
         DO 6000, N=1,NLOG(2)
            MPOW(N) = POW2(MM)
            MM = MM - 1
6000     CONTINUE
C
C  and generate sine + cosine look-up table in y-dimension
         CALL DSCTB(TSIN,TCOS,NDIM,NLOG(2),SWAPI,SWAPO,SWALIM) 
      ENDIF
C
      XFROM = 1
      NWORK = NDIM - 1
C
      IF (ACT.NE.'F') THEN
         DO 6800, NY=1,NPIX(1)
            N = 1
            DO 6400, NX=XFROM,XFROM+NWORK
               DREAL(N) = DBLE(CT(NX))
               DIMAG(N) = DBLE(DT(NX))
               N = N + 1
6400        CONTINUE
C
            CALL DFFT(1,DREAL,DIMAG,NDIM,NLOG(2),MPOW,
     +               TSIN,TCOS,DFACT,CT(XFROM),DT(XFROM),
     +               SWAPI,SWAPO,SWALIM)                    !do the FFT
C
            XFROM = XFROM + NDIM
6800     CONTINUE
C
      ELSE
C
C  frequency business...
         KMM = 0
         DO 7800, NY=1,NPIX(1)
            N = 1
            DO 7400, NX=XFROM,XFROM+NWORK
               DREAL(N) = DBLE(CT(NX))
               DIMAG(N) = DBLE(DT(NX))
               N = N + 1
7400        CONTINUE
C
            CALL DFFT(1,DREAL,DIMAG,NDIM,NLOG(2),MPOW,
     +               TSIN,TCOS,DFACT,CT(XFROM),DT(XFROM),
     +               SWAPI,SWAPO,SWALIM)                    !do the FFT
C
            MM = KMM
            DO 7600, NX=XFROM,XFROM+NWORK
               IF (MM.EQ.0) THEN
                  MM = 1
               ELSE
                  CT(NX) = - CT(NX)
                  DT(NX) = - DT(NX)
                  MM = 0
               ENDIF
7600        CONTINUE
C
            XFROM = XFROM + NDIM
            KMM = 1 - KMM
7800     CONTINUE
C
      ENDIF
C
C  finally transpose back again
      CALL TRAPO(CT,DT,NPIX,NSIZE,C,D)
C
      RETURN
      END

      SUBROUTINE DFFT(IFACT,XREAL,XIMAG,N,NU,MPOW,TSIN,TCOS,DFACT,
     +                XR,XI,SWAPI,SWAPO,SWLIM)
C
C  FAST FOURIER TRANSFORM ALGORITHM
C  K. Banse        version 2.10      850625
C                          2.20      860217
C                          2.40      870109
C                          2.50      921022
C
C  IFACT - factor flag:  1 - yes, multiply by DFACT
C                     0 - no, do not multiply
C  XREAL - double precision real part of input array
C  XIMAG - double precision imaginary part of input array
C  N     - dimension of input array
C  NU    - LOG(N) i.e.: N  =  2**NU
C  MPOW  - array with powers of 2 from 1 - N
C  TSIN  - array precomputed sine values
C  TCOS  - array precomputed cosine values
C  DFACT - double precision constant for multiplication (IFACT = 1)
C  XR    - real part of XREAL
C  XI    - imag part of XIMAG
C
      IMPLICIT NONE
C
      INTEGER    IFACT,N,NU
      INTEGER    N1,MPL
      INTEGER    I,K,K1,K1N2,L
      INTEGER    N2,LP
      INTEGER    MPOW(*)
      INTEGER    SWAPI(*),SWAPO(*),SWLIM
C
      DOUBLE PRECISION      XREAL(*),XIMAG(*),TSIN(*),TCOS(*),DFACT
      DOUBLE PRECISION      TREAL,TIMAG,TCC,TSS
C
      REAL      XR(*),XI(*)
      REAL      TR
C
C  initialize
      N2 = MPOW(1)                        ! the same as: N2 = N/2
      N1 = N - 1
C
C  handle vertical arrays
      DO 500, L=1,NU
         K = 0
         MPL = MPOW(L)
C
50       DO 200, I=1,N2
            LP = K/MPL + 1
            TCC = TCOS(LP)
            TSS = TSIN(LP)
            K = K + 1
            K1N2 = K + N2
            TREAL = XREAL(K1N2)*TCC + XIMAG(K1N2)*TSS
            TIMAG = XIMAG(K1N2)*TCC - XREAL(K1N2)*TSS
            XREAL(K1N2) = XREAL(K) - TREAL
            XIMAG(K1N2) = XIMAG(K) - TIMAG
            XREAL(K) = XREAL(K) + TREAL
            XIMAG(K) = XIMAG(K) + TIMAG
200      CONTINUE
C
         K = K + N2
         IF (K.LT.N1) GOTO 50
C
         N2 = N2/2                  !set up variables for next array
500   CONTINUE
C
C  convert from double precision to single + multiply (if IFACT = 1)
      IF (IFACT.EQ.1) THEN
         DO 1000, K=1,N
            XR(K) = SNGL(XREAL(K) * DFACT)
            XI(K) = SNGL(XIMAG(K) * DFACT)
1000     CONTINUE
      ELSE
         DO 1200, K=1,N
            XR(K) = SNGL(XREAL(K))
            XI(K) = SNGL(XIMAG(K))
1200     CONTINUE
      ENDIF
C
C  unscramble final vector
      DO 2000, K=1,SWLIM 
         K1 = SWAPI(K)
         I = SWAPO(K)
         TR = XR(K1)
         XR(K1) = XR(I)
         XR(I) = TR
         TR = XI(K1)
         XI(K1) = XI(I)
         XI(I) = TR
2000  CONTINUE
C
C  that's it folks...
      RETURN
      END

      SUBROUTINE DSCTB(TSIN,TCOS,NDIM,NU,TIN,TOUT,SWLIM)
C
C subroutine to generate sine and cosine look-up tables
C and also to generate swap tables
C
      IMPLICIT NONE
C
      INTEGER    IBITR,NDIM,NU,K,M,IBR
      INTEGER    TIN(NDIM),TOUT(NDIM),SWLIM
C
      DOUBLE PRECISION      TSIN(*),TCOS(*),ARG,ARG1
C
      ARG1 = 6.2831852D0 / DBLE(FLOAT(NDIM))
      SWLIM = 0
C
      DO 1000, K=1,NDIM
         M = K - 1
         IBR = IBITR(M,NU)
         ARG = ARG1 * IBR
         TSIN(K) = SIN(ARG)
         TCOS(K) = COS(ARG)
C
         IF (IBR.GT.M) THEN                !fill swap tables already
            SWLIM = SWLIM + 1
            TIN(SWLIM) = K 
            TOUT(SWLIM) = IBR + 1
         ENDIF
1000  CONTINUE
C
      RETURN
      END

      SUBROUTINE TRAPO(A,B,NPIX,NSIZE,C,D)
C      
      IMPLICIT NONE
C      
      INTEGER    NPIX(2),NSIZE(2)
      INTEGER    NPAX(2)
C      
      REAL       A(*),B(*),C(*),D(*)
C      
      NPAX(1) = NPIX(2)
      NPAX(2) = NPIX(1)
      CALL LINCOL(A,NPAX,NSIZE,C)
      CALL LINCOL(B,NPAX,NSIZE,D)
C      
      RETURN
      END

      FUNCTION IBITR(J,NU)
C      
      IMPLICIT NONE
C      
      INTEGER    IBITR,J,NU
      INTEGER    I,J1,J2
C      
      J1 = J
      IBITR = 0
      DO 1000 I=1,NU
         J2 = J1/2
         IBITR = IBITR*2 + (J1-2*J2)
         J1 = J2
1000  CONTINUE
C      
      RETURN
      END

      SUBROUTINE POWER(A,B,C,NDIM)
C      
      IMPLICIT NONE
C      
      INTEGER    N,NDIM
C      
      REAL       A(NDIM),B(NDIM),C(NDIM)
C      
      DO 1000 N=1,NDIM
         C(N) = SQRT(  ( A(N)*A(N) )  + ( B(N)*B(N) )  )
1000  CONTINUE
C      
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2006 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================

C ++++++++++++++++++++++++  YSTC.FOR +++++++++++++++++++++++++++++++++++++++
C .LANGUAGE Fortran 77
C .IDENTIFICATION Module YSTC.FOR
C .COMMENTS
C Module contains layer between the keyword related FORTRAN STxxxx interfaces
C and the SC_interfaces written in (hopefully independent) C
C .AUTHOR         K. Banse        ESO - Garching
C .KEYWORDS       standard interfaces.
C .ENVIRONMENT    FORTRAN and C standards
C .VERSION  [1.00] 871207:  
C 
C 060322		last modif
C -----------------------------------------------------------------------------
C
      SUBROUTINE STCGET(CATFILE,FLAG,NAME,IDENT,NO,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   CATFILE        
      INTEGER     FLAG, NO
      CHARACTER*(*)    NAME, IDENT
      INTEGER    STATUS
C 
      CALL STSTR(1,CATFILE)                          !STRIPPED_STRING
      CALL STLOC(1,1,NAME)                           !blanked CHAR_LOC
      CALL STLOC(2,1,IDENT)                          !blanked CHAR_LOC
C 
      CALL STC1(FLAG,NO,STATUS)
C
      RETURN
      END
C


      SUBROUTINE STCADD(CATFILE,NAME,IDENT,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   CATFILE        
      CHARACTER*(*)   NAME, IDENT
      INTEGER    STATUS
C 
      CALL STSTR(1,CATFILE)
      CALL STSTR(2,NAME)
      CALL STSTR(3,IDENT)
C 
      CALL STC2(STATUS)
C
      RETURN
      END
C 

      SUBROUTINE STCSUB(CATFILE,NAME,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   CATFILE        
      CHARACTER*(*)   NAME
      INTEGER    STATUS
C 
      CALL STSTR(1,CATFILE)
      CALL STSTR(2,NAME)
C 
      CALL STC3(STATUS)
C
      RETURN
      END


      SUBROUTINE STCCRE(CATFILE,ITYPE,FLAG,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   CATFILE
      INTEGER    ITYPE,FLAG
      INTEGER    STATUS
C
      CALL STSTR(1,CATFILE)
C
      CALL STC4(ITYPE,FLAG,STATUS)
C
      RETURN
      END
 

      SUBROUTINE STCLIS(CATFILE,INTVAL,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   CATFILE
      INTEGER    INTVAL(2)
      INTEGER    STATUS
C
      CALL STSTR(1,CATFILE)
C
      CALL STC5(INTVAL,STATUS)
C
      RETURN
      END


      SUBROUTINE STCSHO(CATFILE,TOTENT,LASTENT,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   CATFILE
      INTEGER    TOTENT, LASTENT
      INTEGER    STATUS
C
      CALL STSTR(1,CATFILE)
C
      CALL STC6(TOTENT,LASTENT,STATUS)
C
      RETURN
      END


      SUBROUTINE STCFND(CATFILE,FRMNO,NAME,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   CATFILE
      CHARACTER*(*)   NAME
      INTEGER    FRMNO, STATUS
C
      CALL STSTR(1,CATFILE)
      CALL STLOC(1,1,NAME)
C
      CALL STC7(FRMNO,STATUS)
C
      RETURN
      END

C @(#)tdrdpar.for	19.1 (ES0-DMD) 02/25/03 14:11:19
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  18:02 - 11 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION        TDRDPAR
C.KEYWORDS           TABLE, APPLICATIONS
C.ENVIRONMENT  MIDAS
C.PURPOSE
C  READ STANDARD SYSTEM PARAMETERS IN KEYWORDS
C
C
C------------------------------------------------------------------
      SUBROUTINE TDPGET(NEPAR,NPAR,STATUS)
      IMPLICIT NONE
      INTEGER NEPAR  !  IN : no. of expected parameters
      INTEGER NPAR   !  OUT: actual no. of parameters
      INTEGER STATUS !  OUT: status
C
      INTEGER IAV,NARG,I,KNUL,KUN
      CHARACTER*8 TBARGN(8)
       INCLUDE 'MID_INCLUDE:TABLES.INC/NOLIST'
       INCLUDE 'MID_INCLUDE:TABLED.INC/NOLIST'
      DATA TBARGN/'P1 ','P2 ','P3 ','P4 ','P5 ','P6 ','P7 ','P8 '/
C
      CALL STKRDI('PCOUNT',1,1,IAV,NARG,KUN,KNUL,STATUS)
      NPAR   = NARG
      DO 10 I = 1,MIN(NEPAR,NARG)
          CALL STKRDC(TBARGN(I),1,1,64,IAV,TPARBF(I),KUN,KNUL,STATUS)
   10 CONTINUE
      IF (NARG.GT.NEPAR) STATUS = ERRPAR
      RETURN
      END

C @(#)rfotadapt.for	19.1 (ES0-DMD) 02/25/03 13:30:13
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
       PROGRAM ADAPT
C+++
C.IDENT:   RFOTADAPT
C.PURPOSE: Use fit on template frame to derive trial values for fitting new 
C          frame
C.AUTHOR:  R. Buonanno, G. Buscema, C. Corsi, I. Ferraro, G. Iannicola
C          Osservatorio Astronomico di Roma
C.VERSION: 880930 RHW Installation in MIDAS
C          890915 RHW MIDAS tables included; partially rewritten 
C.VERSION: 900121 RHW All variables declared; implicit none included 
C.VERSION: 900122 RHW IMPLICIT NONE added; all variables defined
C----
      IMPLICIT     NONE
      INCLUDE      'MID_REL_INCL:RFOTDECL.INC'
C
      INTEGER      EC, ED, EL
      INTEGER      IAV,IAC
      INTEGER      ICP, IHL
      INTEGER      IROW
      INTEGER      ISTAT
      INTEGER      JC, JH
      INTEGER      KF
      INTEGER      KSX,KSY
      INTEGER      KUN,KNUL
      INTEGER      KVI(2)
      INTEGER      MADRID(1)
      INTEGER      NCP, NHL
      INTEGER      NCINT,NRINT,NSINT
      INTEGER      NACINT,NARINT
      INTEGER      TIDINT
C
      REAL         DX, DY
      REAL         CDS
      REAL         FMA
      REAL         HF
      REAL         TSH
C
      CHARACTER    INTFIL*60
      CHARACTER    RSN
      CHARACTER    STRING*80
C
      INCLUDE      'MID_INCLUDE:ST_DEF.INC'
      COMMON       /VMR/MADRID
      INCLUDE      'MID_INCLUDE:ST_DAT.INC'
C
C *** Is MIDAS out there
      CALL STSPRO('ADAPT')
C
C *** read the intermediate file
      CALL STKRDC('IN_A',1,1,60,IAC,INTFIL,KUN,KNUL,ISTAT)  ! intermediate file
      CALL STECNT('GET',EC,ED,EL)
      CALL STECNT('PUT',1,0,0)
      CALL TBTOPN(INTFIL,F_IO_MODE,TIDINT,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL: Problems with opening intermediate'//
     2            ' table ... '
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
C
C *** get table info
      CALL TBIGET(TIDINT,NCINT,NRINT,NSINT,NACINT,NARINT,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL: Problems with getting info for '//
     2            ' intermediate table; Try again ... '
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
      IF (NRINT.EQ.0) THEN
         STRING = '*** FATAL: No data points in intermediate table'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ENDIF
      CALL STECNT('PUT',EC,ED,EL)
C
C *** get the multiplier intensity, background, and holes
      CALL STKRDR('INPUTR',1,1,IAV,TSH,KUN,KNUL,ISTAT)            ! threshold
      CALL STKRDR('INPUTR',2,1,IAV,FMA,KUN,KNUL,ISTAT)            ! intensity
      CALL STKRDR('INPUTR',3,1,IAV,CDS,KUN,KNUL,ISTAT)            ! background
      CALL STKRDR('INPUTR',4,1,IAV,HF,KUN,KNUL,ISTAT)             ! holes factor
      CALL STKRDI('INPUTI',1,2,IAV,KVI,KUN,KNUL,ISTAT)            ! area
      KSX = KVI(1)
      KSY = KVI(2)
C
C *** do the work
      RSN  = 'Y'
      IROW = 1
C
C *** loop through all groups
  101 CONTINUE               
         CALL INTWRD(TIDINT,IROW,NCP,NHL)
         DX  = 0
         DY  = 0
         KF  = 0
C
         IF (PARINT(1).LT.1) THEN
            KF = 2
            IF (PARINT(1)+PARINT(6) .GT. 3) THEN
               PARINT(6) = PARINT(6) + PARINT(1) - 1
               DX        = PARINT(1)-1
               PARINT(1) = 1
            ELSE
               KF=1
            END IF
         END IF
C
         IF (KF.NE.1) THEN
            IF (PARINT(2).LT.1) THEN
               KF = 2
               IF (PARINT(2)+PARINT(7) .GT. 3) THEN
                  PARINT(7) = PARINT(7)+PARINT(2)-1
                  DY        = PARINT(2)-1
                  PARINT(2) = 1
               ELSE
                  KF = 1
               END IF
            ENDIF
         END IF
C
         IF (KSX.NE.0) THEN
            IF (KF.NE.1) THEN
               IF (PARINT(1)+PARINT(6)-1 .GT. KSX) THEN
                  KF = 2
                  IF (KSX-PARINT(1)+1 .GT. 3) THEN
                     PARINT(6) = KSX-PARINT(1)+1
                  ELSE
                     KF = 1
                  END IF
               ENDIF
            END IF
         END IF
C
         IF (KSY.NE.0) THEN
            IF (KF.NE.1) THEN
               IF (PARINT(2)+PARINT(7)-1 .GT. KSY) THEN
                  KF = 2
                  IF (KSY-PARINT(2)+1.GT.3) THEN
                     PARINT(7) = KSY-PARINT(2)+1
                  ELSE
                     KF = 1
                  END IF
              END IF
            ENDIF
         END IF
C
C*** chnage the background with a factor CDS
         PARINT(10) = PARINT(10)*CDS
C
         DO 200 JC = 1,NCP
            ICP = (JC-1)*6
            FITCMP(ICP+2) = FITCMP(ICP+2)+DX
            FITCMP(ICP+3) = FITCMP(ICP+3)+DY
            IF (FITCMP(ICP+1).LT.TSH) THEN
               FLGCMP(JC) = 0
            ELSE
               IF (FLGCMP(JC).NE.1 .AND. RSN.EQ.'Y') THEN
                  FLGCMP(JC) = 1
               ENDIF
            END IF
C
            FITCMP(ICP+1) = FITCMP(ICP+1)*FMA
            IF (KF.EQ.1) THEN
               FLGCMP(JC) = 0

            ELSE IF (KF.EQ.2) THEN
               IF (FITCMP(ICP+2).LT.2) THEN
                  FLGCMP(JC) = 0
               ENDIF
               IF (FITCMP(ICP+3).LT.2) THEN
                  FLGCMP(JC) = 0
               ENDIF
               IF (FITCMP(ICP+2) .GE. PARINT(6)-1) THEN
                  FLGCMP(JC) = 0
               ENDIF
               IF (FITCMP(ICP+3).GE.PARINT(7)-1) THEN
                  FLGCMP(JC) = 0
               ENDIF
            END IF
  200    CONTINUE
C
         DO 400 JH = 1,NHL
               IHL = (JH-1)*3
               FITHOL(IHL+1) = FITHOL(IHL+1)*HF
               FITHOL(IHL+2) = FITHOL(IHL+2)+DX
               FITHOL(IHL+3) = FITHOL(IHL+3)+DY
  400    CONTINUE
C
C *** rewrite the window
         CALL INTWWR(TIDINT,IROW,NCP,NHL)
         IROW = IROW + NCP + NHL
         IF (IROW.LE.NRINT) THEN
            GO TO 101
         ENDIF
C
      CALL TBTCLO(TIDINT,ISTAT)
      CALL STSEPI
      END

C @(#)tdsearch.for	13.1.1.1 (ES0-DMD) 06/02/98 18:18:55
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C
C  TBESEARCH.FOR              2.0   17FEB1988
C  J.D.PONZ                     ESO - GARCHING
C
C.KEYWORDS
C
C  TABLE, SEARCH
C
C.PURPOSE
C
C  SEARCHING IN TABLE COLUMNS
C  DOCUMENT MTS/2.0
C
C.INPUT/OUTPUT
C
C       TBESRC(TID, COLUMN, VALUE, ISTART, NCHAR, FIRST, NEXT, STATUS)
C       TBESRD(TID, COLUMN, VALUE, ERROR, FIRST, NEXT, STATUS)
C       TBESRI(TID, COLUMN, VALUE, ERROR, FIRST, NEXT, STATUS)
C       TBESRR(TID, COLUMN, VALUE, ERROR, FIRST, NEXT, STATUS)
C
C------------------------------------------------------------------
       SUBROUTINE TBESRC(TID,COLUMN,INVAL,ISTART,NCHAR,
     .                   FIRST,NEXT,STATUS)
C
C       SEARCH FOR VALUE IN COLUMNS
C       SEARCHING FIELD IS A SUBSTRING IN CHARACTER FORMAT COLUMN
C
       IMPLICIT NONE
       INTEGER        TID
       INTEGER        COLUMN
       CHARACTER*(*)  INVAL
       INTEGER        ISTART
       INTEGER        NCHAR
       INTEGER        FIRST
       INTEGER        NEXT
       INTEGER        STATUS
C
       INTEGER        MADRID(1), NCOL, NROW, NSC, NAC, NAR, LEN
       INTEGER*8      NEWADD
       INTEGER        IS, NW, NBYT2, TYPE
       LOGICAL        VALUE(256)
       CHARACTER*256  VALUEC
       CHARACTER*8         FORM
C
       INCLUDE        'MID_INCLUDE:TABLES.INC'
       COMMON/VMR/ MADRID
       INCLUDE        'MID_INCLUDE:TABLED.INC'
C
CCCC       EQUIVALENCE   (VALUEC,VALUE(1))
C
       VALUEC = INVAL
C
C ... CHECK ARGUMENTS
C
       CALL TBIGET(TID,NCOL,NROW,NSC,NAC,NAR,STATUS)
       IF (COLUMN.LT.0.OR.COLUMN.GT.NCOL) THEN
           STATUS = 1
           GO TO 1000
       ENDIF
       CALL TBFGET(TID,COLUMN,FORM,LEN,TYPE,STATUS)
       IF (TYPE.NE.D_C_FORMAT) THEN       
           STATUS = 1
           GO TO 1000
       ENDIF
C
C ... MAP COLUMN
C
       CALL TBCMAP(TID,COLUMN,NEWADD,STATUS)
       IS = NSC
C
C ... BINARY OR SEQUENTIAL SEARCH DEPENDING ON THE SORTED COLUMN
C
       NBYT2 = MIN(ISTART+NCHAR-1,LEN)
       NW    = (LEN+3)/4
       IF (IABS(IS) .EQ. COLUMN) THEN
         IF(IS.GT.0) THEN
           CALL TYSBAC(MADRID(NEWADD),NW,NROW,VALUE,ISTART,NBYT2,
     .                        FIRST,NEXT)
         ELSE
           CALL TYSBDC(MADRID(NEWADD),NW,NROW,VALUE,ISTART,NBYT2,
     .                        FIRST,NEXT)
         ENDIF
       ELSE
           CALL TYSSSC(MADRID(NEWADD),NW,NROW,VALUE,ISTART,NBYT2,
     .                        FIRST,NEXT)
       ENDIF
C
C ... ERROR HANDLING
C
1000   CONTINUE
C    CALL ERRCNTRL_ST('PUT',E_C,E_L,E_D)
C       IF (STATUS.NE.ERR_NORMAL)
C     .       CALL ERRSIGNAL_ST('TBL','TBL_SEARCHC',STATUS)
       RETURN
       END

       SUBROUTINE TBESRD(TID,COLUMN,VALUE,ERROR,FIRST,NEXT,STATUS)
C
C       SEARCH ELEMENT IN A COLUMN. 
C       DOUBLE PRECISION ARGUMENT
C
       IMPLICIT NONE
       INTEGER  TID          ! IN : TABLE ID
       INTEGER  COLUMN       ! IN : COLUMN NUMBER
       DOUBLE PRECISION VALUE        ! IN : VALUE TO SEARCH
       DOUBLE PRECISION ERROR        ! IN : ERROR IN THE SEARCH
       INTEGER  FIRST        ! IN : INDEX TO FIRST ROW TO SEARCH
       INTEGER  NEXT         ! OUT: INDEX TO THE VALUE
       INTEGER  STATUS       ! OUT: STATUS
C
       INTEGER  MADRID(1), NCOL, NROW, NSC, NAC, NAR, LEN, IS
       INTEGER*8   NEWADD
       INTEGER  TYPE
       REAL     RERR, RVAL
       CHARACTER*8         FORM
C
       INCLUDE        'MID_INCLUDE:TABLES.INC'
       COMMON/VMR/ MADRID
       INCLUDE        'MID_INCLUDE:TABLED.INC'
C
C ... CHECK ARGUMENTS
C
       CALL TBIGET(TID,NCOL,NROW,NSC,NAC,NAR,STATUS)
       IF (COLUMN.LT.0.OR.COLUMN.GT.NCOL) THEN
           STATUS = 1
           GO TO 1000
       ENDIF
       CALL TBFGET(TID,COLUMN,FORM,LEN,TYPE,STATUS)
       IF (TYPE.EQ.D_C_FORMAT) THEN       
           STATUS = 1
           GO TO 1000
       ENDIF
C
C ... MAP COLUMN
C
       CALL TBCMAP(TID,COLUMN,NEWADD,STATUS)
       IS = NSC
C
C ... SEARCH ACCORDING TO INTRINSIC TYPE
C ... BINARY OR SEQUENTIAL SEARCH DEPENDING ON THE SORTED COLUMN
C
       IF (TYPE.EQ.D_R4_FORMAT) THEN
         RVAL = VALUE
         RERR = ERROR
         IF (IABS(IS) .EQ. COLUMN) THEN
           IF(IS.GT.0) THEN
             CALL TYSBAR(MADRID(NEWADD),NROW,RVAL,RERR,FIRST,NEXT)
           ELSE
             CALL TYSBDR(MADRID(NEWADD),NROW,RVAL,RERR,FIRST,NEXT)
           ENDIF
         ELSE
             CALL TYSSSR(MADRID(NEWADD),NROW,RVAL,RERR,FIRST,NEXT)
         ENDIF
       ENDIF
       IF (TYPE.EQ.D_R8_FORMAT) THEN
         IF (IABS(IS) .EQ. COLUMN) THEN
           IF(IS.GT.0) THEN
             CALL TYSBAD(MADRID(NEWADD),NROW,VALUE,ERROR,FIRST,NEXT)
           ELSE
             CALL TYSBDD(MADRID(NEWADD),NROW,VALUE,ERROR,FIRST,NEXT)
           ENDIF
         ELSE
             CALL TYSSSD(MADRID(NEWADD),NROW,VALUE,ERROR,FIRST,NEXT)
         ENDIF
       ENDIF
C
C ... ERROR HANDLING
C
1000   CONTINUE
C       CALL ERRCNTRL_ST('PUT',E_C,E_L,E_D)
C       IF (STATUS.NE.ERR_NORMAL)
C     .       CALL ERRSIGNAL_ST('TBL','TBL_SEARCH',STATUS)
       RETURN
       END

       SUBROUTINE TBESRI(TID,COLUMN,VALUE,ERROR,FIRST,NEXT,STATUS)
C
C       SEARCH ELEMENT IN A COLUMN. 
C       INTEGER ARGUMENT
C
       IMPLICIT NONE
       INTEGER  TID          ! IN : TABLE ID
       INTEGER  COLUMN       ! IN : COLUMN NUMBER
       INTEGER  VALUE        ! IN : VALUE TO SEARCH
       INTEGER  ERROR        ! IN : ERROR IN THE SEARCH
       INTEGER  FIRST        ! IN : INDEX TO FIRST ROW TO SEARCH
       INTEGER  NEXT         ! OUT: INDEX TO THE VALUE
       INTEGER  STATUS       ! OUT: STATUS
C
       INTEGER  MADRID(1), NCOL, NROW, NSC, NAC, NAR, LEN, IS
       INTEGER*8  NEWADD
       INTEGER             TYPE
       REAL                RERR, RVAL
       DOUBLE PRECISION    DERR, DVAL
       CHARACTER*8         FORM
C
       INCLUDE        'MID_INCLUDE:TABLES.INC'
       COMMON/VMR/ MADRID
       INCLUDE        'MID_INCLUDE:TABLED.INC'
C
C ... CHECK ARGUMENTS
C
       CALL TBIGET(TID,NCOL,NROW,NSC,NAC,NAR,STATUS)
       IF (COLUMN.LT.0.OR.COLUMN.GT.NCOL) THEN
           STATUS = 1
           GO TO 1000
       ENDIF
       CALL TBFGET(TID,COLUMN,FORM,LEN,TYPE,STATUS)
       IF (TYPE.EQ.D_C_FORMAT) THEN       
           STATUS = 1
           GO TO 1000
       ENDIF
C
C ... MAP COLUMN
C
       CALL TBCMAP(TID,COLUMN,NEWADD,STATUS)
       IS = NSC
C
C ... SEARCH ACCORDING TO INTRINSIC TYPE
C ... BINARY OR SEQUENTIAL SEARCH DEPENDING ON THE SORTED COLUMN
C
       IF (TYPE.EQ.D_R8_FORMAT) THEN
         DVAL = VALUE
         DERR = ERROR
         IF (IABS(IS) .EQ. COLUMN) THEN
           IF(IS.GT.0) THEN
             CALL TYSBAD(MADRID(NEWADD),NROW,DVAL,DERR,FIRST,NEXT)
           ELSE
             CALL TYSBDD(MADRID(NEWADD),NROW,DVAL,DERR,FIRST,NEXT)
           ENDIF
         ELSE
             CALL TYSSSD(MADRID(NEWADD),NROW,DVAL,DERR,FIRST,NEXT)
         ENDIF
       ENDIF
       IF (TYPE.EQ.D_R4_FORMAT) THEN
         RVAL = VALUE
         RERR = ERROR
         IF (IABS(IS) .EQ. COLUMN) THEN
           IF(IS.GT.0) THEN
             CALL TYSBAR(MADRID(NEWADD),NROW,RVAL,RERR,FIRST,NEXT)
           ELSE
             CALL TYSBDR(MADRID(NEWADD),NROW,RVAL,RERR,FIRST,NEXT)
           ENDIF
         ELSE
             CALL TYSSSR(MADRID(NEWADD),NROW,RVAL,RERR,FIRST,NEXT)
         ENDIF
       ENDIF
C
C ... ERROR HANDLING
C
1000   CONTINUE
C       CALL ERRCNTRL_ST('PUT',E_C,E_L,E_D)
C       IF (STATUS.NE.ERR_NORMAL)
C     .       CALL ERRSIGNAL_ST('TBL','TBL_SEARCH',STATUS)
       RETURN
       END

       SUBROUTINE TBESRR(TID,COLUMN,VALUE,ERROR,FIRST,NEXT,STATUS)
C
C       SEARCH ELEMENT IN A COLUMN. 
C
       IMPLICIT NONE
       INTEGER  TID          ! IN : TABLE ID
       INTEGER  COLUMN       ! IN : COLUMN NUMBER
       REAL     VALUE        ! IN : VALUE TO SEARCH
       REAL     ERROR        ! IN : ERROR IN THE SEARCH
       INTEGER  FIRST        ! IN : INDEX TO FIRST ROW TO SEARCH
       INTEGER  NEXT         ! OUT: INDEX TO THE VALUE
       INTEGER  STATUS       ! OUT: STATUS
C
       INTEGER  MADRID(1), NCOL, NROW, NSC, NAC, NAR, LEN, TYPE, IS
       INTEGER*8       NEWADD
       DOUBLE PRECISION    DERR, DVAL
       CHARACTER*8         FORM
C
       INCLUDE        'MID_INCLUDE:TABLES.INC'
       COMMON/VMR/ MADRID
       INCLUDE        'MID_INCLUDE:TABLED.INC'
C
C ... CHECK ARGUMENTS
C
       CALL TBIGET(TID,NCOL,NROW,NSC,NAC,NAR,STATUS)
       IF (COLUMN.LT.0.OR.COLUMN.GT.NCOL) THEN
           STATUS = 1
           GO TO 1000
       ENDIF
       CALL TBFGET(TID,COLUMN,FORM,LEN,TYPE,STATUS)
       IF (TYPE.EQ.D_C_FORMAT) THEN       
           STATUS = 1
           GO TO 1000
       ENDIF
C
C ... MAP COLUMN
C
       CALL TBCMAP(TID,COLUMN,NEWADD,STATUS)
       IS = NSC
C
C ... SEARCH ACCORDING TO INTRINSIC TYPE
C ... BINARY OR SEQUENTIAL SEARCH DEPENDING ON THE SORTED COLUMN
C
       IF (TYPE.EQ.D_R8_FORMAT) THEN
         DVAL = VALUE
         DERR = ERROR
         IF (IABS(IS) .EQ. COLUMN) THEN
           IF(IS.GT.0) THEN
             CALL TYSBAD(MADRID(NEWADD),NROW,DVAL,DERR,FIRST,NEXT)
           ELSE
             CALL TYSBDD(MADRID(NEWADD),NROW,DVAL,DERR,FIRST,NEXT)
           ENDIF
         ELSE
             CALL TYSSSD(MADRID(NEWADD),NROW,DVAL,DERR,FIRST,NEXT)
         ENDIF
       ENDIF
       IF (TYPE.EQ.D_R4_FORMAT) THEN
         IF (IABS(IS) .EQ. COLUMN) THEN
           IF(IS.GT.0) THEN
             CALL TYSBAR(MADRID(NEWADD),NROW,VALUE,ERROR,FIRST,NEXT)
           ELSE
             CALL TYSBDR(MADRID(NEWADD),NROW,VALUE,ERROR,FIRST,NEXT)
           ENDIF
         ELSE
             CALL TYSSSR(MADRID(NEWADD),NROW,VALUE,ERROR,FIRST,NEXT)
         ENDIF
       ENDIF
C
C ... ERROR HANDLING
C
1000   CONTINUE
C       CALL ERRCNTRL_ST('PUT',E_C,E_L,E_D)
C       IF (STATUS.NE.ERR_NORMAL)
C     .       CALL ERRSIGNAL_ST('TBL','TBL_SEARCH',STATUS)
       RETURN
       END

       SUBROUTINE TYSSSR(ARRAY, N, VALUE, ERROR, IFIRST,IPOS)
C
C       SEQUENTIAL SEARCH OF VALUE IN THE ARRAY
C       SINGLE PRECISION VERSION
C
       IMPLICIT NONE
C
       INTEGER   N
       REAL      ARRAY(N)
       REAL      VALUE
       REAL      ERROR
       INTEGER   IFIRST
       INTEGER   IPOS
C
       INTEGER   I
C
C ... INITIALIZE FLAG
C
       IPOS  = 0
C
C ... LOOP ON VALUES
C
       DO 10 I = IFIRST, N
         IF (ABS(ARRAY(I)-VALUE).LE.ERROR) THEN
           IPOS = I
           RETURN
         ENDIF
10     CONTINUE
       RETURN
       END

       SUBROUTINE TYSBAR(ARRAY, N, VALUE, ERROR, IFIRST,IPOS)
C
C       BINARY SEARCH OF ELEMENTS IN THE ARRAY
C       SINGLE PRECISION VERSION
C       ASCENDING ORDER
C
       IMPLICIT NONE
       INTEGER   N
       REAL      ARRAY(N)
       REAL      VALUE
       REAL      ERROR
       INTEGER   IFIRST
       INTEGER   IPOS
C
       INTEGER   LOWER, UPPER, I
C
C ... INITIALIZE COUNTERS
C
       LOWER = IFIRST
       UPPER = N
       IPOS  = 0
C
C ... LOOP
C
5      CONTINUE
         I = (LOWER + UPPER)/2
C
C ... COMPARE KEYS
C
         IF (ABS(VALUE-ARRAY(I)).LE.ERROR) THEN
           IPOS = I
           GO TO 10
         ELSE
           IF (VALUE.LT.ARRAY(I)) THEN
             UPPER = I - 1
           ELSE
             LOWER = I + 1
           ENDIF
         ENDIF
       IF (LOWER.LE.UPPER) GO TO 5
C
C ... FIND FIRST ENTRY IN A SET OF EQUAL KEYS
C
10     IF (IPOS.LE.IFIRST) RETURN
       IF (ABS(VALUE-ARRAY(IPOS-1)).GT.ERROR) RETURN
20     CONTINUE
         IPOS = IPOS - 1
         IF (IPOS.EQ.IFIRST) RETURN
       IF (ABS(VALUE-ARRAY(IPOS-1)).LE.ERROR) GOTO 20
       RETURN
       END

       SUBROUTINE TYSBDR(ARRAY, N, VALUE, ERROR, IFIRST,IPOS)
C
C       BINARY SEARCH OF ELEMENTS IN THE ARRAY
C       SINGLE PRECISION VERSION
C       DESCENDING ORDER
C
       IMPLICIT NONE
       INTEGER   N
       REAL      ARRAY(N)
       REAL      VALUE
       REAL      ERROR
       INTEGER   IFIRST
       INTEGER   IPOS
C
       INTEGER   LOWER, UPPER, I
C
C ... INITIALIZE COUNTERS
C
       LOWER = IFIRST
       UPPER = N
       IPOS  = 0
C
C ... LOOP
C
5      CONTINUE
         I = (LOWER + UPPER)/2
C
C ... COMPARE KEYS
C
         IF (ABS(VALUE-ARRAY(I)).LE.ERROR) THEN
           IPOS = I
           GO TO 10
         ELSE
           IF (VALUE.GT.ARRAY(I)) THEN
             UPPER = I - 1
           ELSE
             LOWER = I + 1
           ENDIF
         ENDIF
       IF (LOWER.LE.UPPER) GOTO 5
C
C ... FIND FIRST ENTRY IN A SET OF EQUAL KEYS
C
10     IF (IPOS.LE.IFIRST) RETURN
       IF (ABS(VALUE-ARRAY(IPOS-1)).GT.ERROR) RETURN
20     CONTINUE
         IPOS = IPOS - 1
         IF (IPOS.EQ.IFIRST) RETURN
       IF (ABS(VALUE-ARRAY(IPOS-1)).LE.ERROR) GOTO 20
       RETURN
       END

       SUBROUTINE TYSSSD(ARRAY, N, VALUE, ERROR, IFIRST,IPOS)
C
C       SEQUENTIAL SEARCH OF VALUE IN THE ARRAY
C       DOUBLE PRECISION VERSION
C
       IMPLICIT NONE
       INTEGER   N
       DOUBLE PRECISION ARRAY(N)
       DOUBLE PRECISION VALUE
       DOUBLE PRECISION ERROR
       INTEGER   IFIRST
       INTEGER   IPOS
C
       INTEGER   I
C
C ... INITIALIZE FLAG
C
       IPOS  = 0
C
C ... LOOP ON VALUES
C
       DO 10 I = IFIRST, N
         IF (DABS(ARRAY(I)-VALUE).LE.ERROR) THEN
           IPOS = I
           RETURN
         ENDIF
10     CONTINUE
       RETURN
       END

       SUBROUTINE TYSBAD(ARRAY, N, VALUE, ERROR, IFIRST,IPOS)
C
C       BINARY SEARCH OF ELEMENTS IN THE ARRAY
C       DOUBLE  PRECISION VERSION
C       ASCENDING ORDER
C
       IMPLICIT NONE
       INTEGER   N
       DOUBLE PRECISION ARRAY(N)
       DOUBLE PRECISION VALUE
       DOUBLE PRECISION ERROR
       INTEGER   IFIRST
       INTEGER   IPOS
C
       INTEGER I, LOWER, UPPER
C
C ... INITIALIZE COUNTERS
C
       LOWER = IFIRST
       UPPER = N
       IPOS  = 0
C
C ... LOOP
C
5      CONTINUE
         I = (LOWER + UPPER)/2
C
C ... COMPARE KEYS
C
         IF (DABS(VALUE-ARRAY(I)).LE.ERROR) THEN
           IPOS = I
           GO TO 10
         ELSE
           IF (VALUE.LT.ARRAY(I)) THEN
             UPPER = I - 1
           ELSE
             LOWER = I + 1
           ENDIF
         ENDIF
       IF (LOWER.LE.UPPER) GO TO 5
C
C ... FIND FIRST ENTRY IN A SET OF EQUAL KEYS
C
10     IF (IPOS.LE.IFIRST) RETURN
       IF (DABS(VALUE-ARRAY(IPOS-1)).GT.ERROR) RETURN
20     CONTINUE
         IPOS = IPOS - 1
         IF (IPOS.EQ.IFIRST) RETURN
       IF (DABS(VALUE-ARRAY(IPOS-1)).LE.ERROR) GOTO 20
       RETURN
       END

       SUBROUTINE TYSBDD(ARRAY, N, VALUE, ERROR, IFIRST,IPOS)
C
C       BINARY SEARCH OF ELEMENTS IN THE ARRAY
C       SINGLE PRECISION VERSION
C       DESCENDING ORDER
C
       IMPLICIT NONE
       INTEGER   N
       DOUBLE PRECISION ARRAY(N)
       DOUBLE PRECISION VALUE
       DOUBLE PRECISION ERROR
       INTEGER   IFIRST
       INTEGER   IPOS
C
       INTEGER   LOWER, UPPER, I
C
C ... INITIALIZE COUNTERS
C
       LOWER = IFIRST
       UPPER = N
       IPOS  = 0
C
C ... LOOP
C
5      CONTINUE
         I = (LOWER + UPPER)/2
C
C ... COMPARE KEYS
C
         IF (DABS(VALUE-ARRAY(I)).LE.ERROR) THEN
           IPOS = I
           GO TO 10
         ELSE
           IF (VALUE.GT.ARRAY(I)) THEN
             UPPER = I - 1
           ELSE
             LOWER = I + 1
           ENDIF
         ENDIF
       IF (LOWER.LE.UPPER) GOTO 5
C
C ... FIND FIRST ENTRY IN A SET OF EQUAL KEYS
C
10     IF (IPOS.LE.IFIRST) RETURN
       IF (DABS(VALUE-ARRAY(IPOS-1)).GT.ERROR) RETURN
20     CONTINUE
         IPOS = IPOS - 1
         IF (IPOS.EQ.IFIRST) RETURN
       IF (DABS(VALUE-ARRAY(IPOS-1)).LE.ERROR) GOTO 20
       RETURN
       END

       SUBROUTINE TYSSSC(ARRAY, NW, N, VALUE, IST,IEN, IFIRST,IPOS)
C
C       SEQUENTIAL SEARCH OF VALUE IN THE ARRAY
C       CHARACTER ARRAY
C
       IMPLICIT NONE
       INTEGER NW
       INTEGER N
       REAL    ARRAY(NW,N)
       REAL    VALUE(1)
       INTEGER IST
       INTEGER IEN
       INTEGER IFIRST
       INTEGER IPOS
C
       INTEGER I
       INTEGER TYSORD
C
C ... INITIALIZE FLAG
C
       IPOS  = 0
C
C ... LOOP ON VALUES
C
       DO 10 I = IFIRST, N
         IF (TYSORD(IST,IEN,ARRAY(1,I),VALUE)) 10,20,10
10       CONTINUE
       RETURN
20       IPOS = I
       RETURN
       END

       SUBROUTINE TYSBAC(ARRAY, NW, N, VALUE, IST,IEN, IFIRST,IPOS)
C
C       BINARY SEARCH OF ELEMENTS IN THE ARRAY
C       CHARACTER ARRAY
C       ASCENDING ORDER
C
       IMPLICIT NONE
       INTEGER NW
       INTEGER N
       REAL    ARRAY(NW,N)
       REAL    VALUE(1)
       INTEGER IST
       INTEGER IEN
       INTEGER IFIRST
       INTEGER IPOS
C
       INTEGER I, LOWER, UPPER
       INTEGER TYSORD
C
C ... INITIALIZE COUNTERS
C
       LOWER = IFIRST
       UPPER = N
       IPOS  = 0
C
C ... LOOP
C
5      CONTINUE
         I = (LOWER + UPPER)/2
C
C ... COMPARE KEYS
C
         IF (TYSORD(IST,IEN,VALUE,ARRAY(1,I))) 20,10,30
10         IPOS = I
         GOTO 50
20         UPPER = I - 1
         GOTO 40
30         LOWER = I + 1
40         CONTINUE
       IF (LOWER.LE.UPPER) GOTO 5
C
C ... FIND FIRST ENTRY IN A SET OF EQUAL KEYS
C
50     IF (IPOS.LE.IFIRST) RETURN
60     CONTINUE
         IPOS = IPOS - 1
         IF (IPOS.EQ.IFIRST) RETURN
       IF (TYSORD(IST,IEN,ARRAY(1,IPOS),VALUE).EQ.0) GOTO 60
       RETURN
       END

       SUBROUTINE TYSBDC(ARRAY, NW, N, VALUE, IST,IEN, IFIRST,IPOS)
C
C       BINARY SEARCH OF ELEMENTS IN THE ARRAY
C       CHARACTER ARRAY
C       DESCENDING ORDER
C
       IMPLICIT NONE
       INTEGER NW
       INTEGER N
       REAL    ARRAY(NW,N)
       REAL    VALUE(1)
       INTEGER IST
       INTEGER IEN
       INTEGER IFIRST
       INTEGER IPOS
C
       INTEGER I, LOWER, UPPER
       INTEGER TYSORD
C
C ... INITIALIZE COUNTERS
C
       LOWER = IFIRST
       UPPER = N
       IPOS  = 0
C
C ... LOOP
C
5      CONTINUE
         I = (LOWER + UPPER)/2
C
C ... COMPARE KEYS
C
         IF (TYSORD(IST,IEN,VALUE,ARRAY(1,I))) 30,10,20
10         IPOS = I
         GOTO 50
20         UPPER = I - 1
         GOTO 40
30         LOWER = I + 1
40         CONTINUE
       IF (LOWER.LE.UPPER) GOTO 5
C
C ... FIND FIRST ENTRY IN A SET OF EQUAL KEYS
C
50       IF (IPOS.LE.IFIRST) RETURN
60     CONTINUE
         IPOS = IPOS - 1
         IF (IPOS.EQ.IFIRST) RETURN
       IF (TYSORD(IST,IEN,ARRAY(1,IPOS),VALUE).EQ.0) GOTO 60
       RETURN
       END

       INTEGER FUNCTION TYSORD(IST,IEN,IX,IY)
C
C       RETURNS THE VALUES -1,0,+1 IF THE ALPHANUMERIC CHARACTER
C       STRING IN
C       IX IS < , = , > TO THAT IN IY, IN THE SENSE THAT
C       0<1<2,...<9<SPACE<A<B<...<Z   .
C
       IMPLICIT NONE
       INTEGER        IST
       INTEGER        IEN
C       BYTE           IX(IEN)
C       BYTE           IY(IEN)
       INTEGER           IX(IEN)
       INTEGER           IY(IEN)
C
       INTEGER        K
       DO 10 K=IST, IEN
         IF(IX(K).GT.IY(K)) GO TO 20
         IF(IX(K).LT.IY(K)) GO TO 30
10     CONTINUE
       TYSORD = 0
       RETURN
20     TYSORD = 1
       RETURN
30     TYSORD = -1
       RETURN
       END

C @(#)invclass.for	19.1 (ESO-DMD) 02/25/03 13:26:20
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C.IDENTIFICATION:  INVCLASS.FOR
C.PURPOSE:         Classifies objects into stars,galaxies and image defects
C.AUTHOR:          A. Kruszewski             ESO Garching
C.LANGUAGE:        F77+ESOext
C.INPUT/OUTPUT:    INPUT:  input table, result of the analyse command
C                  OUTPUT: on the same table in column 21: classify results
C.VERSION:         AK   831017  Creation
C.VERSION:         CHO. 850115  ???
C.VERSION:         KB   870520  ???
C.VERSION:         AK   870729  ???
C.VERSION:         RHW  871121  ESO-FORTRAN Conversion
C -------------------------------------------------------------------
      PROGRAM   CLASSI
C
      IMPLICIT  NONE
      INCLUDE   'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER   ITF,IACOL,IAROW
      INTEGER   IAC,IST
      INTEGER   ICLS(2,MAXCNT)
      INTEGER   ITLM(2)
      INTEGER   NCOL,NN,NROW 
      INTEGER   KUN,KNUL
C
      REAL      PMTR(30,MAXCNT)
      REAL      STPR(MAXSUB)
      REAL      CPAR(3)
      REAL      BLMT
      REAL      SGLM
      REAL      TRSH
C
      CHARACTER INTAB*60
C
      LOGICAL   FAIL
C
      INCLUDE   'MID_INCLUDE:TABLES.INC/NOLIST'
      INCLUDE   'MID_INCLUDE:TABLED.INC/NOLIST'
C
      CALL STSPRO('CLASSIFY')
C
      CALL STKRDC('IN_B',1,1,60,IAC,INTAB,KUN,KNUL,IST)
      FAIL   = .FALSE.
C
      CALL TBTOPN(INTAB, F_U_MODE, ITF, IST)
      CALL TBIGET(ITF, NCOL, NROW, NN, IACOL, IAROW, IST)
C
C *** Prepare the array PMTR
C
      CALL COPY(ITF,23,NROW,NROW,PMTR)
C
C *** Prepare the array STPR and the values TRSH,BLMT,SGLM,CPAR,ITLM
C
      CALL STDRDR(ITF, 'DPROFILE', 1, MAXSUB, IAC, STPR, KUN, KNUL, IST)
C
      CALL STKRDR('INV_REAL', 3, 1, IAC, TRSH, KUN, KNUL, IST)
      CALL STKRDR('INV_REAL', 8, 1, IAC, BLMT, KUN, KNUL, IST)
      CALL STKRDR('INV_REAL', 9, 1, IAC, SGLM, KUN, KNUL, IST)
      CALL STKRDR('INV_REAL', 5, 3, IAC, CPAR, KUN, KNUL, IST)
      CALL STKRDI('INV_INTG', 17, 2, IAC, ITLM, KUN, KNUL, IST)
C
C *** Perform classification.
C
      CALL CLPMTR(PMTR, ICLS, NROW, STPR, TRSH, FAIL)
      IF (.NOT. FAIL) THEN
C
C *** Copy the results ICLS(2,I) in column 21 of INTAB.
C
          CALL COPY1(ITF, 23, NROW, NROW, ICLS)
      END IF
C
C *** Write used parameters as table descriptors
C
      CALL STDWRR(ITF, 'CLASSPAR', CPAR, 1, 3, KUN, IST)
      CALL STDWRR(ITF, 'BRGHTLMT', BLMT, 1, 1, KUN, IST)
      CALL STDWRR(ITF, 'DISTANCE', SGLM, 1, 1, KUN, IST)
      CALL STDWRI(ITF, 'ITERATE', ITLM, 1, 2, KUN, IST)
C
      CALL TBTCLO(ITF, IST)
      CALL STSEPI
      END

C
C ***********************************************************
C
      SUBROUTINE COPY(TID,NTCOL,NTROW,NROW,OUTB)
C
      IMPLICIT NONE
      INCLUDE 'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER  TID
      INTEGER  NTCOL
      INTEGER  NTROW
      INTEGER  NROW
      REAL     OUTB(30,MAXCNT)
C
      INTEGER  I
      INTEGER  ICOL(30)
      INTEGER  ISTAT
      INTEGER  J
      INTEGER  KUNR(30)
      REAL     FINTB(30)
C
      DATA    ICOL/ 1, 2, 3, 4, 5, 6, 7, 8, 9,10,
     2             11,12,13,14,15,16,17,18,19,20,
     3             21,22,23,24,25,26,27,28,29,30/
C
      DO 20 I = 1,NROW
         CALL TBRRDR(TID,I,NTCOL,ICOL,FINTB,KUNR,ISTAT)
         OUTB(1,I)  = FINTB(9)
         OUTB(2,I)  = FINTB(10)
         OUTB(3,I)  = FINTB(7)
         OUTB(4,I)  = FINTB(8)
         OUTB(5,I)  = FINTB(20)
         OUTB(6,I)  = FINTB(11)
         OUTB(7,I)  = FINTB(12)
         OUTB(8,I)  = FINTB(13)
         OUTB(9,I)  = FINTB(14)
         OUTB(10,I) = FINTB(2)
         OUTB(11,I) = FINTB(3)
         OUTB(12,I) = FINTB(4)
         OUTB(13,I) = FINTB(5)
         OUTB(14,I) = 0.0
         DO 10 J = 15, 19
            OUTB(J,I) = FINTB(J)
   10    CONTINUE
         OUTB(20,I) = FINTB(6)
         OUTB(21,I) = FINTB(21)
         OUTB(22,I) = FINTB(22)
   20 CONTINUE
C
      RETURN
      END
C
C ********************************************************
C
      SUBROUTINE COPY1(TID,NTCOL,NTROW,NROW,ICLS)
C
      IMPLICIT NONE
      INCLUDE  'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER  TID
      INTEGER  NTCOL
      INTEGER  NTROW
      INTEGER  NROW
      INTEGER  ICLS(2,MAXCNT)
C
      INTEGER  I
      INTEGER  IC
      INTEGER  ISTAT
      REAL     FINTB
C
      DATA     IC/21/
C
      DO 10 I = 1,NROW
         FINTB = FLOAT(ICLS(2,I))
         CALL TBRWRR(TID,I,1,IC,FINTB,ISTAT)
   10 CONTINUE
C
      RETURN
      END

C @(#)stseed.for	19.1 (ES0-DMD) 02/25/03 13:25:40
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine STSEED         version 1.1        870729
C  A. Kruszewski             ESO Garching
C.PURPOSE
C  Set seed classifications of objects that are surely stars or galaxies.
C.ALGORYTHM
C  The relative gradient is used for intial separation. Three parameters
C  are used for defining the stars and galaxies regions. If there is a too
C  small number of objects in a particular region then this region is
C  enlarged until regions overlap.
C.INPUT/OUTPUT
C  input arguments
C  PMTR        real*4 array      array holding classifiers
C  BRGT        logical array     array indicating saturated objects
C  M           integer*4         number of objects
C  TRSH        real*4            detection treshold above the sky background
C  output arguments
C  ICLS        integer*4 array   array holding the seed classification
C                                coded: 0-unclassified, 1-star, 2-galaxy
C                                in elements ICLS(1,*)
C  PMTR        real*4 array      modified classifiers holding array
C-----------------------------------------------------------------------
      SUBROUTINE STSEED(PMTR,BRGT,ICLS,M,TRSH,FAIL)
C
      IMPLICIT NONE
      INCLUDE 'MID_REL_INCL:INVENT.INC/NOLIST'
C
      REAL         PMTR(30,MAXCNT)
      LOGICAL      BRGT(MAXCNT)
      INTEGER      ICLS(2,MAXCNT)
      INTEGER      M	
      REAL         TRSH
      LOGICAL      FAIL
C
      INTEGER      I
      INTEGER      IAC
      INTEGER      ISTAT
      INTEGER      KUN, KNUL
      INTEGER      NS, NG
      REAL         ALS, ALG, ALT
      REAL         CLPR(3)
      REAL         TEMP
      REAL         TVAR
      LOGICAL      COND
      CHARACTER*80 OUTPUT
C
C     ALS-range of relative gradients for stars.
C     ALG-upper limit of relative gradients for galaxies.
C *** ALT-lower limit of central intensity in terms of TRSH.
C     NS-number of seed stars.
C     NG-number of seed galaxies.
C
      CALL STKRDR( 'INV_REAL' , 5 , 3 , IAC , CLPR , KUN , KNUL , ISTAT)
C
      ALS    = CLPR(1)
      ALG    = CLPR(2)
      ALT    = CLPR(3)
      NS     = 0
      NG     = 0
C
C     Initiates logical variable FAIL which is
C *** used for signaling the inability to find
C     sufficient number of seed objects.
C
      FAIL   = .FALSE.
C
C *** Terminates execution when there is too few or too many objects.
C
      IF (M.LT.40 .OR. M.GT.MAXCNT) THEN
          FAIL   = .TRUE.
      END IF
C
C *** Initiates faint objects elements of array ICLS.
C
      IF ( .NOT. FAIL) THEN
          DO 10 I = 1,M
              IF ( .NOT. BRGT(I)) THEN
                  ICLS(1,I) = 0
                  ICLS(2,I) = 0
              END IF

   10     CONTINUE
      END IF
C
C     Repeates selection of seed objects until
C *** there are at least 20 objects in each
C     cathegory and object regions do not overlap.
C

   30 CONTINUE
          COND   = ((NS.LT.20) .OR. (NG.LT.20)) .AND. ( .NOT. FAIL)
     &                              .AND. (ALG.LE.-ALS)
          IF ( .NOT. (COND)) GO TO 40
C
C *** Clear object counters.
C
          NS     = 0
          NG     = 0
C
C *** Perform the segregation.
C
          DO 20 I = 1,M
              IF ((.NOT.BRGT(I))) THEN
                  TEMP   = PMTR(3,I)
                  TVAR   = PMTR(2,I)/TRSH
                  IF (TEMP.GT. (-ALS) .AND. TEMP.LT.ALS .AND. TVAR.GT.
     +                ALT) THEN
                      NS     = NS + 1
                      ICLS(1,I) = 1
                      ICLS(2,I) = 1

                  ELSE IF (TEMP.LT.ALG .AND. TVAR.GT.0.5*ALT) THEN
                      NG     = NG + 1
                      ICLS(1,I) = 2
                      ICLS(2,I) = 2
                  END IF

              END IF

   20     CONTINUE
C
C *** Modify the criteria.
C
          IF (NS.LT.20) THEN
              ALS    = ALS + 0.01
              ALT    = 1.0 + (ALT-1.0)/2.0
          END IF

          IF (NG.LT.20) THEN
              ALG    = ALG + 0.01
          END IF
C
C      Signal failure when star and galaxy
C ***  regions overlap and there is not enough
C      stars in at least one class of objects.
C
          IF ((ALG.GT.-ALS) .AND. ((NS.LT.20).OR. (NG.LT.20))) THEN
              FAIL   = .TRUE.
          END IF
      GO TO 30
   40 CONTINUE
C
C *** Abnormal termination of the execution.
C
      IF (FAIL) THEN
          IF (M.GT.5000) THEN
              WRITE (OUTPUT,'(A)') 'Too many objects'
              CALL STTPUT(OUTPUT,ISTAT)

          ELSE
              WRITE (OUTPUT,'(A)') 'Unable to find seed objects'
              CALL STTPUT(OUTPUT,ISTAT)
              IF (M.LT.40) THEN
                  WRITE (OUTPUT,'(A)') 'Too few objects'
                  CALL STTPUT(OUTPUT,ISTAT)

              ELSE
                  WRITE (OUTPUT,'(A)') 'Too few objects?'
                  CALL STTPUT(OUTPUT,ISTAT)
              END IF

          END IF
      END IF
C
      RETURN
      END

C @(#)tdsavr.for	19.1 (ESO-DMD) 02/25/03 14:11:20
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  16:04 - 19 NOV 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION:
C
C  program TDSAVR
C
C.KEYWORDS:
C  REGRESSION, FIT
C
C.PURPOSE:
C
C  SAVE DISPERSION COEFFICIENTS AS TABLE DESCRIPTORS
C
C  SAVE/REGRESSION TABLE NAME
C
C.ALGORITHM:
C
C  OUT PARAMETERS OF THE REGRESSION ARE STORED IN THE
C  DESCRIPTORS :
C  XXXXC/C/1/20 - CHARACTER INFOR
C  XXXXI/I/1/20 - REFERENCE TO VARIABLES IN THE REGRESSION
C  XXXXD/D/1/20 - COEFFICIENTS
C  XXXXR/R/1/20 - ASSOCIATED REAL*4 PARAMETERS
C  WHERE XXXX IS THE NAME GIVEN TO THE REGRESSION COEFFS IN THE
C  SAVE/REGRESSION COMMAND
C
C.VERSIOn
C 020807	last modif
C 
C-------------------------------------------------------------------
C
      SUBROUTINE TDSAVR
      IMPLICIT   NONE
C
      INTEGER   NPAR,STAT,INDX,TID,NAV,STATUS
      INTEGER   NOELM,BYTELM
      INTEGER   KUNIT
      INTEGER   OUTI(20)
      INTEGER   INDEX, INDKEY, KUN, KNUL
C
      REAL             OUTR(20)
C
      DOUBLE PRECISION OUTD(200)
C
      CHARACTER*80     TABLE*80
      CHARACTER*20     NAME, DESNAM, KEYNAM, INPNAM
      CHARACTER*20     OUTC
      CHARACTER*16     MSG,TYPE
C
C
      INCLUDE   'MID_INCLUDE:TABLES.INC'
      INCLUDE   'MID_INCLUDE:TABLED.INC'
      DATA MSG/'ERR:TREGRSAV'/
C
C ... get parameters
C
      CALL TDPGET(3,NPAR,STAT)
      IF (STAT.NE.0) GO TO 10
      TABLE  = TPARBF(1)
      NAME   = ' '
      NAME   = TPARBF(2)
      INDX   = INDEX(NAME,' ') - 1
      KEYNAM = ' '
      KEYNAM = TPARBF(3)
      INDKEY = INDEX(KEYNAM,' ') - 1
C
C ... access to the table
C
      TID = -1
      CALL TBTOPN(TABLE,F_D_MODE,TID,STAT)
      IF (STAT.NE.0) GO TO 10
C
C ... write descriptors
C
      INPNAM = KEYNAM(1:INDKEY)//'C'
      CALL STKRDC(INPNAM,1,1,20,NAV,OUTC,KUN,KNUL,STATUS)
      DESNAM = NAME(1:INDX)//'C '
      CALL STDWRC(TID,DESNAM,1,OUTC,1,20,KUNIT,STATUS)

      INPNAM = KEYNAM(1:INDKEY)//'I'
      CALL STKRDI(INPNAM,1,20,NAV,OUTI,KUN,KNUL,STATUS)
      DESNAM = NAME(1:INDX)//'I '
      CALL STDWRI(TID,DESNAM,OUTI,1,20,KUNIT,STATUS)

      INPNAM = KEYNAM(1:INDKEY)//'D'
      CALL STKFND(INPNAM,TYPE,NOELM,BYTELM,STAT)
      CALL STKRDD(INPNAM,1,NOELM,NAV,OUTD,KUN,KNUL,STATUS)
      DESNAM = NAME(1:INDX)//'D '
      CALL STDWRD(TID,DESNAM,OUTD,1,NOELM,KUNIT,STATUS)


      INPNAM = KEYNAM(1:INDKEY)//'R'
      CALL STKRDR(INPNAM,1,20,NAV,OUTR,KUN,KNUL,STATUS)
      DESNAM = NAME(1:INDX)//'R '
      CALL STDWRR(TID,DESNAM,OUTR,1,20,KUNIT,STATUS)
C
C ... end
C
      CALL DSCUPT(TID,TID,' ',STAT)
      CALL TBTCLO(TID,STAT)
   10 IF (STAT.NE.0) THEN
          WRITE (MSG(13:16),9000) STAT
          CALL TDERRR(STAT,MSG,STATUS)
      END IF
      RETURN
 9000 FORMAT (I4)
      END

C @(#)precep.for	19.1 (ES0-DMD) 02/25/03 13:28:47
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C  @(#)precep.for	19.1  (ESO-IPG)  02/25/03  13:28:47
      SUBROUTINE PRECEP(EF,ED,RA,DEC)
c
c	Copyright (C) Andrew T. Young, 1990
C
C  PRECESS FROM EPOCH EF TO EPOCH ED.
C
C    SEE LIESKE, A.& AP. 73,282(1979).
C
C
      IMPLICIT NONE
      REAL EF, ED, RA, DEC, TWOPI, BIGT, T, TSQ, A11, A22, A33, A12,A21, 
     1         A13, A31, A23, A32, COSDEC, X, Y, Z, X1, Y1, Z1
C
      SAVE A11,A12,A13,A21,A22,A23,A31,A32,A33
C
      DATA TWOPI/6.2831853071796/
C
C   BIGT=(EFJD-2451545.0)/36525.
C   T=(EDJD-EFJD)/36525.
C
      BIGT=(EF-2000.)/100.
      T=(ED-EF)/100.
C  JULIAN CENTURIES.
      TSQ=T*T
C   THIS VERSION TRUNCATED TO 0.1 ARCSEC/CENTURY.
      A11=1.-TSQ*29724.E-8
      A22=1.-TSQ*(25002.E-8+BIGT*3.E-7)
      A33=1.-TSQ*4721.E-8
      A12=-T*(2236172.E-8+BIGT*1354.E-8 + T*(677.E-8 - T*222.E-8))
      A21=-A12
      A13=T*(-971717.E-8+BIGT*414.E-8 + T*(207.E-8 + T*96.E-8))
      A31=-A13
      A23=-TSQ*10865.E-8
      A32=A23
C
C  NOW USE MATRIX TO PRECESS RA,DEC.
C
      ENTRY PRECST(RA,DEC)
C
      COSDEC=COS(DEC)
      X=COS(RA)*COSDEC
      Y=SIN(RA)*COSDEC
      Z=SIN(DEC)
      X1=A11*X + A12*Y + A13*Z
      Y1=A21*X + A22*Y + A23*Z
      Z1=A31*X + A32*Y + A33*Z
      DEC=ATAN(Z1/SQRT(X1*X1+Y1*Y1))
      RA=MOD(ATAN2(Y1,X1)+TWOPI,TWOPI)
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2005 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  16:02 - 19 NOV 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION
C
C  program TDREGP
C
C.PURPOSE
C
C  Execute the command
C  REGRESSION/POL table dep_var ind_var1[,ind_var2] deg1[,deg2]  [outkey]
C  OR
C  REGRESSION/POL table dep_var ind_var1[,ind_var2,...]   ?      [outkey]
C
C.KEYWORDS
C
C  Tables, Multiple linear regression, POLYNOMIAL FIT
C
C.ALGORITHM
C
C  uses table interface routines
C  fitting algorithm using Householder transformation
C
C.VERSION
C 051019	last modif
C 
C-----------------------------------------------------------
C
      SUBROUTINE TDREGP
      IMPLICIT NONE
C
      LOGICAL NULL(9), SEL, IPOL, NEXT
C
      INTEGER PARVAL
      INTEGER IVAR(9),IDEG(2),IPAR(13)
      INTEGER NROW,NCOL, NAC, NAR, I, ISTAT, STATUS
      INTEGER IAV, TID, NSC1, NN, NVAR, I1, I2, K, L, N, LL, N1
      INTEGER IROW, KMIN, NPAR, NM1, K1
      INTEGER INDEX, KUN, KNUL, TYPE, MAXPAR, INDKEY
      INTEGER NOELM,BYTELM,DEGMAX
      PARAMETER (MAXPAR=100)
C
      REAL ERROR,RPAR1(4),RPAR(13)
C
      DOUBLE PRECISION XMIN,XMAX,YMIN,YMAX
      DOUBLE PRECISION VAL(9)
      DOUBLE PRECISION G(MAXPAR,MAXPAR),X(MAXPAR)
C
      CHARACTER*16 MSG
      CHARACTER*80 TABLE,LINE,SELE
      CHARACTER*90 SDUM
      CHARACTER*17 COLUMN(9)
      CHARACTER*8  FORM,TYPKEY
      CHARACTER*20 CPAR, KEYNAM, INPNAM
C
      INCLUDE 'MID_INCLUDE:TABLES.INC'
      INCLUDE 'MID_INCLUDE:TABLED.INC'
C 
      DATA MSG/'ERR:TREGRMUL'/
      DATA PARVAL/5/
      DATA CPAR/' '/
      DATA IPAR/13*0/
      DATA RPAR/13*0./
C
C ... GET INPUT PARAMETERS
C
      DO 10, I=1,9
          NULL(I) = .FALSE.
          IVAR(I) = 0
          VAL(I) = 0
   10 CONTINUE

      CALL TDPGET(PARVAL,NPAR,ISTAT)

      IF (ISTAT.NE.0) GO TO 70
      IF (NPAR.LT.4) THEN
          ISTAT  = ERRPAR
          GO TO 70
      END IF

      TABLE  = TPARBF(1)
      KEYNAM = TPARBF(5)
      INDKEY = INDEX(KEYNAM,' ') - 1

      DO 15 I = 1, MAXPAR
          X(I) = 0.D0
   15 CONTINUE
      INPNAM = KEYNAM(1:INDKEY)//'D'
      CALL STKFND(INPNAM,TYPKEY,NOELM,BYTELM,ISTAT)
      CALL STKWRD(INPNAM,X,1,NOELM,KUN,ISTAT)

      CALL STKRDR('INPUTR',1,2,IAV,RPAR1,KUN,KNUL,ISTAT)
      IDEG(1) = RPAR1(1)
      IDEG(2) = RPAR1(2)

      DEGMAX = 0
      IF (IDEG(2).GT.0)   DEGMAX = IDEG(1)

      IF (DEGMAX.GT.8) THEN
         CALL STETER(9,'REGRES/POLY: degree along X is limited to 8')
      ENDIF

      IF (IDEG(2).GT.8) THEN
         CALL STETER(9,'REGRES/POLY: degree along Y is limited to 8')
      ENDIF
C
C ... READ INPUT TABLE
C
      TID = -1
      CALL TBTOPN(TABLE,F_I_MODE,TID,ISTAT)
      CALL TBIGET(TID,NCOL,NROW,NSC1,NAC,NAR,ISTAT)
      CALL TDRSEL(TID,SELE,ISTAT)
C
C ... DECODE PARAMETERS
C
      COLUMN(1) = TPARBF(2)
      LINE   = ' '
      LINE   = TPARBF(3)
      NN     = INDEX(LINE,' ') - 1
      NVAR   = 1
      I1     = 1
      SDUM   = LINE//','
   20 CONTINUE
      I2     = INDEX(SDUM,',')
      SDUM(I2:I2) = ';'
      NVAR   = NVAR + 1
      IF (NVAR.GT.9) THEN
          ISTAT  = ERRPAR
          GO TO 70
      END IF
      COLUMN(NVAR) = LINE(I1:I2-1)
      I1     = I2 + 1
      IF (I1.LT.NN) GO TO 20
      K      = IDEG(1)
      L      = IDEG(2)
      IF (K.EQ.0 .AND. L.EQ.0) THEN
          IPOL   = .FALSE.
          N      = NVAR
          NM1    = N - 1
      ELSE
          IPOL   = .TRUE.
          N      = (K+1)* (L+1)
      END IF
      IF (N.GT.NOELM) THEN
          ISTAT  = ERRPAR
          GO TO 70
      END IF
C
C ... SEARCH FOR COLUMNS AND CHECK FORMAT
C
      DO 30 I = 1,NVAR
          CALL TBCSER(TID,COLUMN(I),IVAR(I),ISTAT)
          IF (ISTAT.NE.0) GO TO 70
          IF (IVAR(I).EQ.-1) THEN
              ISTAT  = ERRPAR
              GO TO 70
          END IF
          CALL TBFGET(TID,IVAR(I),FORM,LL,TYPE,ISTAT)
          IF (TYPE.EQ.D_C_FORMAT) THEN
              ISTAT  = ERRFMT
              GO TO 70
          END IF
   30 CONTINUE
      CALL STTPUT(TABLE,ISTAT)
C
C ... SOLVE LEAST SQUARE PROBLEM
C
      XMIN   = 1.D30
      YMIN   = 1.D30
      XMAX   = -XMIN
      YMAX   = -YMIN
      LL     = 0
      N1     = 0
      DO 50 IROW = 1,NROW
          CALL TBSGET(TID,IROW,SEL,ISTAT)
          IF (SEL) THEN
              CALL TBRRDD(TID,IROW,NVAR,IVAR,VAL,NULL,ISTAT)
              NEXT   = ( .NOT. NULL(1)) .AND. ( .NOT. NULL(2)) .AND.
     +                 ( .NOT. NULL(3)) .AND. ( .NOT. NULL(4)) .AND.
     +                 ( .NOT. NULL(5)) .AND. ( .NOT. NULL(6)) .AND.
     +                 ( .NOT. NULL(7)) .AND. ( .NOT. NULL(8)) .AND.
     +                 ( .NOT. NULL(9))
              IF (NEXT) THEN
                  N1     = N1 + 1
                  IF (IPOL) THEN
                      XMIN   = MIN(XMIN,VAL(2))
                      XMAX   = MAX(XMAX,VAL(2))
                      YMIN   = MIN(YMIN,VAL(3))
                      YMAX   = MAX(YMAX,VAL(3))
                      CALL TDSET2(LL+1,VAL(2),VAL(3),VAL(1),K,L,G,X,N,
     +                            MAXPAR)
                  ELSE
                      CALL TDSET1(LL+1,VAL(2),VAL(1),NM1,G,X,N,MAXPAR)
                  END IF
                  IF (LL.NE.0) THEN
                      KMIN   = MIN(LL,N+1)
                      DO 40 K1 = 1,KMIN
                          CALL TDHHTR(K1,LL+1,G,X,N,MAXPAR)
   40                 CONTINUE
                  END IF
                  LL     = MIN(LL+1,N+1)
              END IF
          END IF
   50 CONTINUE
      CALL TDSOLV(G,X,N,MAXPAR)
      ERROR  = ABS(G(N+1,N+1))
C
C ... COPY RESULT OF REGRESSION
C
      CPAR(9:16) = TABLE
      IPAR(1) = N1
      IPAR(2) = NVAR - 1
      IPAR(3) = IVAR(1)
      IF (IPOL) THEN
          CPAR(17:20) = 'MULT'
          IPAR(4) = IVAR(2)
          IPAR(5) = IVAR(3)
          IPAR(6) = IDEG(1)
          IPAR(7) = IDEG(2)
      ELSE
          CPAR(17:20) = 'LINE'
          DO 60 I = 1,NVAR - 1
              IPAR(I+3) = IVAR(I+1)
   60     CONTINUE
      END IF
      RPAR(1) = XMIN
      RPAR(2) = XMAX
      RPAR(3) = YMIN
      RPAR(4) = YMAX
      RPAR(5) = SQRT((ERROR*ERROR)/IPAR(1))

      INPNAM = KEYNAM(1:INDKEY)//'C'
      CALL STKWRC(INPNAM,1,CPAR,1,20,KUN,ISTAT)
      INPNAM = KEYNAM(1:INDKEY)//'I'
      CALL STKWRI(INPNAM,IPAR,1,13,KUN,ISTAT)
      INPNAM = KEYNAM(1:INDKEY)//'R'
      CALL STKWRR(INPNAM,RPAR,1,5,KUN,ISTAT)
      INPNAM = KEYNAM(1:INDKEY)//'D'
      CALL STKWRD(INPNAM,X,1,N,KUN,ISTAT)
C
C ... PRINT RESULT
C
      IF (SELE(1:1).NE.'-') THEN
          LINE   = ' SELECT  '//SELE
          CALL STTPUT(LINE,ISTAT)
      END IF
      RPAR(5) = ERROR
      CALL TDRDIS(CPAR,IPAR,RPAR,X,ISTAT)
      IF (ISTAT.NE.0) GO TO 70
C
C ... END
C
      CALL DSCUPT(TID,TID,' ',ISTAT)
      CALL TBTCLO(TID,ISTAT)
   70 IF (ISTAT.NE.0) THEN
          WRITE (MSG(13:16),9000) ISTAT
          CALL TDERRR(ISTAT,MSG,STATUS)
      END IF
      RETURN
 9000 FORMAT (I4)
      END

C @(#)fdtotd.for	19.1 (ES0-DMD) 02/25/03 13:25:33
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.INPUT/OUTPUT
C  Input parameters
C  A4        real*4 array       four dimensional p.s.f.
C  LPXL      integer*4          half-size in pixels
C  LSBP      integer*4          half-size in sub-pixels
C  LL        integer*4          half-size of 2-d p.s.f.
C  Output parameters
C  A2        real*4 array       two dimensional p.s.f.
C-----------------------------------------------------------------------
C
C
      SUBROUTINE FDTOTD(A4, A2, LPXL, LSBP, LL)
C
      IMPLICIT  NONE
      INTEGER   LPXL
      INTEGER   LSBP
      INTEGER   LL
      REAL      A4((-LPXL):LPXL,(-LPXL):LPXL,(-LSBP):LSBP,(-LSBP):LSBP)
      REAL      A2((-LL):LL,(-LL):LL)
C
      INTEGER   I, IK
      INTEGER   J, JL
      INTEGER   K
      INTEGER   L
C
C
      DO 10 L = -LSBP , LSBP
          DO 20 K = -LSBP , LSBP
              DO 30 J = -LPXL , LPXL
                  JL = J * (2*LSBP+1) - L
                  DO 40 I = -LPXL , LPXL
                      IK = I * (2*LSBP+1) - K
                      A2(IK,JL) = A4(I,J,K,L)
   40             CONTINUE
   30         CONTINUE
   20     CONTINUE
   10 CONTINUE
C
      RETURN
      END

C @(#)irstilt.for	19.1 (ES0-DMD) 02/25/03 14:23:43
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.COPYRIGHT   (C) 1992 European Southern Observatory
C.IDENT       .for
C.AUTHOR      E. Oliva,  Firenze-Arcetri
C.KEYWORDS    Spectroscopy, IRSPEC
C
C.PURPOSE     Execute command  ...
C
C.ALGORITHM
C
C
C.INPUT/OUTPUT
C
C
C.VERSION     1.0    Creation     02.09.1992   E. Oliva
C
C-------------------------------------------------------
C
      PROGRAM TILT
      IMPLICIT REAL(A-H,O-Z)
      IMPLICIT INTEGER(I-N)

      CHARACTER*60 FRAMEI,FRAMEO
      CHARACTER*64 CUNIT
      CHARACTER*72 IDENT
      INTEGER*8 INPNTR,OUPNTR
      INTEGER NPIX(2)
      DOUBLE PRECISION START(2),STEP(2),DCW
      DIMENSION GRARUL(2)
      COMMON/ISTPAR/COSG_SIG(2),SING0,CSI0
      COMMON /VMR/ MADRID(1)

      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'

      DATA MAXDIM/2/

      IRET=1
      CALL STSPRO('TILT')
C
C GET NAME OF INPUT FRAME AND MAP IT
C
      CALL STKRDC('framei',1,1,60,IRET,FRAMEI,KUNIT,KNUL,ISTAT)
      CALL CLNFRA(FRAMEI,FRAMEI,0)
      CALL STIGET(FRAMEI,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,MAXDIM,
     ,          NAXIS,NPIX,START,STEP,
     ,          IDENT,CUNIT,INPNTR,NIN,ISTAT)
      IF(NAXIS.NE.2) 
     +     CALL STETER(1,'Input frame must be 2-D')
C
C GET NAME OF OUTPUT FRAME AND MAP IT 
C
      CALL STKRDC('frameo',1,1,60,IRET,FRAMEO,KUNIT,KNUL,ISTAT)
      CALL CLNFRA(FRAMEO,FRAMEO,0)
      CALL STIPUT(FRAMEO,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     ,          NAXIS,NPIX,START,STEP,
     ,          IDENT,CUNIT,OUPNTR,NOU,ISTAT)
C
C Get values of gamma0,csi0,grarul
C and compute COSG_SIG(1:2)=cos(gamma0)*1000/grarul
C             SING0=sin(gamma0)
C
      CALL STKRDR('Igamma0',1,1,IRET,GAMMA0,KUNIT,KNUL,ISTAT)
      SING0=SIN(GAMMA0)
      CALL STKRDR('Igrarul',1,2,IRET,GRARUL,KUNIT,KNUL,ISTAT)
      DO I=1,2
        COSG_SIG(I)=COS(GAMMA0)*1000/GRARUL(I)
      ENDDO
      CALL STKRDR('Icsi0',1,1,IRET,R4,KUNIT,KNUL,ISTAT)
      CSI0=R4
C
C Get key which contain the reference row # (i.e. the #
C of the row which is left untouched
C
      CALL STKRDI('rowref',1,1,IRET,IRREF,KUNIT,KNUL,ISTAT)
C
C GET NAME OF KEY WHICH MIGHT CONTAIN THE VALUE OF THE TANGENT
C OF THE TILT ANGLE (CSI) ENTERED BY THE USER.
C IF = 0 TAKE THE VALUES OF CW, C GRAT # AND ORDER # C FROM THE 
C FILE DESCRIPTORS AND COMPUTE CSI ACCORDING TO THE PROPER 
C FORMULA (SEE FUNCTION VALUE_TILT).
C
      CALL STKRDR('angle',1,1,IRET,CSI,KUNIT,KNUL,ISTAT)
C
C Get values of grating#
C               order#
C               center wavelength
C
      IF(CSI.EQ.0.) THEN
        CALL STKRDI('ngrat',1,1,IRET,IGRAT,KUNIT,KNUL,ISTAT)
        CALL STKRDI('order',1,1,IRET,IORDER,KUNIT,KNUL,ISTAT)
        CALL STKRDD('wlcen',1,1,IRET,DCW,KUNIT,KNUL,ISTAT)
        CW=DCW
        CSI=VALUE_TILT(CW,IGRAT,IORDER)
      ENDIF
C
C CALL ROUTINE WHICH CORRECT SLIT TILT BY MEANS OF LINEAR REBINNING 
C ROW BY ROW.
C
      CALL RECTIFY(MADRID(INPNTR),MADRID(OUPNTR),
     ,           NPIX(1),NPIX(2),CSI,IRREF)
C
C RELEASE FILES, UPDATE KEYWORDS AND EXIT
C
      CALL STSEPI
      END
C
C
C
      SUBROUTINE RECTIFY(A,B,NX,NY,CSI,IRREF)
C
C RECTIFY THE SLIT, I.E. LEAVE THE SCAN-LINE #IRREF OF THE
C IMAGE UNTOUCHED AND SHIFT (=LINEAR REBIN....) THE OTHERS
C BY CSI*DISTANCE FROM CENTRAL COLUMN.
C
      IMPLICIT REAL(A-H,O-Z)
      IMPLICIT INTEGER(I-N)

      DIMENSION A(NX,NY),B(NX,NY)
C
C SET OUTPUT IMAGE TO ZERO
C
      DO J=1,NY
        DO I=1,NX
          B(I,J)=0.0
        ENDDO
      ENDDO
C
      ICROW=IRREF
      DO IY=1,NY
        SHIFT=CSI*FLOAT(ICROW-IY)
        DO IX=1,NX
          A1=FLOAT(IX)+SHIFT
          IA1=AINT(A1)
          IF(A1.LT.0.) IA1=IA1-1
          IF(IA1.LT.1) THEN
            B(IX,IY)=A(1,IY)
            GO TO 10
          ENDIF
          IF(IA1.GT.(NX-1)) THEN
            B(IX,IY)=A(NX,IY)
            GO TO 10
          ENDIF
          W1=1-A1+FLOAT(IA1)
          IA2=IA1+1
          W2=1.-W1
          X1=A(IA1,IY)
          X2=A(IA2,IY)
          B(IX,IY)=W1*X1+W2*X2
10        CONTINUE
        ENDDO
      ENDDO
C
      RETURN
      END
C
C
      FUNCTION VALUE_TILT(WAVE,NGRAT,IORDER)
C
      IMPLICIT REAL(A-H,O-Z)
      IMPLICIT INTEGER(I-N)

      COMMON/ISTPAR/COSG_SIG(2),SING0,CSI0
      CHARACTER*80 OUTPUT

      ORDER=IORDER
      CSI=TAN
     +(ATAN(2.*SING0/SQRT((2.*COSG_SIG(NGRAT)/ORDER/WAVE)**2-1.))-CSI0)
      WRITE(OUTPUT,100) CSI
100   FORMAT('Assumed value of tan(tilt) : ',F7.4)
      CALL STTPUT(OUTPUT,ISTAT)
      VALUE_TILT=CSI
      RETURN
      END

C @(#)cfaint.for	19.1 (ES0-DMD) 02/25/03 13:25:31
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENIFICATION
C
C  subroutine CFAINT         version 1.2       870729
C  A. Kruszewski             ESO Garching
C
C.PURPOSE
C
C  classifies unsaturated objects into stars, galaxies and image defects
C
C.INPUT/OUTPUT
C
C  input arguments
C
C  PMTR        real*4 array      array holding classifiers
C  BRGT        logical array     array indicating saturated objects
C  M           integer*4         number of objects
C  STPR        real*4 array      one-dimensional point spread function
C                                of stallar objects
C  TRSH        real*4            detection treshold above the sky 
C				 background
C
C  output arguments
C
C  ICLS        integer*4 array   array holding the classification
C                                coded: 0-defect or not classified,
C                                1-star, 2-galaxy. for each object 
C				 the first element gives a seed value,
C				 the second gives a current value.
C  FAIL        logical           fail flag
C-----------------------------------------------------------------------
      SUBROUTINE CFAINT(PMTR,BRGT,ICLS,M,STPR,TRSH,FAIL)
C
      IMPLICIT NONE
      INCLUDE 'MID_REL_INCL:INVENT.INC/NOLIST'
C
      REAL    PMTR(30,MAXCNT)
      LOGICAL BRGT(MAXCNT)
      INTEGER ICLS(2,MAXCNT)
      INTEGER M
      REAL    STPR(MAXCNT)
      REAL    TRSH
      LOGICAL FAIL
C
      INTEGER ITER
      INTEGER KZ6901
      REAL    PCLA(0:13,MAXCNT)
C
      LOGICAL DONE
C
C sets seed samples of stars and galaxies
C
      CALL STSEED(PMTR,BRGT,ICLS,M,TRSH,FAIL)
      IF (FAIL) THEN
          RETURN

      END IF
C
C corrects radius parameters for distortions due to
C finite sizes of objects
C
      CALL RADCOR(PMTR,PCLA,M,STPR,TRSH)
C
C transforms parameters in order to make them more independend
C and to assure similar ranges of variability
C
      CALL TRSFRM(PMTR,PCLA,M)
C
C performs classification
C
      DONE   = .FALSE.
      ITER   = 0
      DO 10 KZ6901 = 1,100000000
          IF ( .NOT. (.NOT.DONE.AND.ITER.LE.20)) GO TO 20
          CALL CLASFY(PCLA,BRGT,ICLS,M,ITER,DONE)
   10 CONTINUE
   20 CONTINUE
C
C seed classification is coded in ICLS(1,*)
C final classification is coded in ICLS(2,*)
C 0-defect or unclassified, 1-star, 2-galaxy
C
      RETURN

      END

C===========================================================================
C Copyright (C) 1995-2006 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM CRFRAM
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  program CRFRAM			version 1.00	881122
C  K. Banse				ESO - Garching
C  1.10      890512	1.20	900601		1.30	930110
C
C.KEYWORDS
C  bulk data frame
C
C.PURPOSE
C  create a MIDAS image
C
C.ALGORITHM
C  use MIDAS interfaces
C
C.INPUT/OUTPUT
C  the following keywords are used:
C
C IN_A/C/1/60                  	name of new image file
C DEFAULT/C/1/1         	= Y, all image info given in command line
C                  		= N, use frame given in key P2 for that
C P3/C/1/60                  	info frame, if DEFAULT = N
C INPUTI/I/1/7                 	NAXIS + NPIX
C INPUTR/R/1/12                	START + STEP
C P4/C/1/20                  	type of data function
C                  		= POLY, GAUSS, EXPO_DISK, RADIUS_LAW
C                  		= CIRCLE, ELLIPS
C                  		= NODATA if just a reference frame
C                  		= ASCII_FILE if input from a file
C                  		= TABLE_FILE if input from a table
C P5/C/1/60                  	coefficients for data function
C 				or name of data file if option ASCII above
C 				or name of table file if option TABLE above
C P6/C/1/8                  	optional data type (stored in local key PP6)
C                I1 for bytes,
C                I2 for 16bit integer, UI2 for unsigned 16bit integer,    
C                I4 for 32bit integer,
C                R4 for 32bit real, R8 or D for 64bit (double precision)   
C
C.VERSIONS
C 1.00		from version 3.60 (as of 880411) of CREFRAM
C
C 060531	last modif
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      NAXIS,CUNLEN,MAPSIZ,IMSIZE
      INTEGER      IAV,IDUM,METHOD,N,NCOEF,NO,STAT
      INTEGER      INO,RNO,IBUF(7),NPIX(6)
      INTEGER      IMNOX,EMPTY
      INTEGER      UNIT(1),NLO,DFORM,MADRID(1)
      INTEGER*8    PNTR,PNTRX
C
      REAL         CUTS(4),COEFS(6),FMIN,FMAX
C
      DOUBLE PRECISION START(6),STEP(6)
      DOUBLE PRECISION DBUF(12),DDUM, DSIZE
C
      CHARACTER    CUNIT*112,IDENT*72,NAME*60,INFRAM*60
      CHARACTER    CBUF*60,DEFAUL*1,PXTYPE*8
      CHARACTER    FUNCY*20,TABLE*60
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      COMMON   /VMR/ MADRID
C
      DATA      IDENT /' '/
      DATA      CUNIT /'none given '/, CBUF /' '/
      DATA      NPIX      /6*1/,       START /6*0.D0/, STEP /6*1.D0/
      DATA      EMPTY     /0/
      DATA      FMIN      /+99999.99/
      DATA      FMAX      /-99999.99/
      DATA      NAME      /' '/,       INFRAM /' '/
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C  get into MIDAS
      CALL STSPRO('CREFRAM')
      DSIZE = 1.0
C
C  get name and type of new frame and DEFAULT flag
      CALL STKRDC('IN_A',1,1,60,IAV,NAME,UNIT,NLO,STAT)
      CALL STKRDC('DEFAULT',1,1,1,IAV,DEFAUL,UNIT,NLO,STAT)
      CALL UPCAS(DEFAUL,DEFAUL)
C
C  image info from command line or reference frame
      IF (DEFAUL.NE.'Y') THEN
         CALL STKRDC('P3',1,1,60,IAV,INFRAM,UNIT,NLO,STAT)  !get ref. frame
C
C  read all relevant descriptors
         CALL STFOPN(INFRAM,D_OLD_FORMAT,0,F_IMA_TYPE,RNO,STAT)
         CALL STDRDI(RNO,'NAXIS',1,1,IAV,NAXIS,UNIT,NLO,STAT)
         IF (NAXIS.EQ.0) THEN
            EMPTY = 1
            NAXIS = 1
         ENDIF
         CALL STDRDI(RNO,'NPIX',1,NAXIS,IAV,NPIX,UNIT,NLO,STAT)
         CALL STDRDD(RNO,'START',1,NAXIS,IAV,START,UNIT,NLO,STAT)
         CALL STDRDD(RNO,'STEP',1,NAXIS,IAV,STEP,UNIT,NLO,STAT)
         CALL STDRDC(RNO,'IDENT',1,1,72,IAV,IDENT,UNIT,NLO,STAT)
         CALL STDRDC(RNO,'CUNIT',1,1,112,IAV,CUNIT,UNIT,NLO,STAT)
      ELSE
C
C     get NAXIS, NPIX, START + STEP (max 6 dimensions)
         CALL STKRDI('INPUTI',1,7,IAV,IBUF,UNIT,NLO,STAT)
         CALL STKRDD('INPUTD',1,12,IAV,DBUF,UNIT,NLO,STAT)
         NAXIS = IBUF(1)
C
C     set descriptor values
         IF ((NAXIS.LT.0).OR.(NAXIS.GT.6)) 
     +      CALL STETER(1,'invalid NAXIS ...')      !invalid NAXIS ...
C 
         IF (NAXIS.EQ.0) THEN                 !want to build a real empty frame
            EMPTY = 1
            NAXIS = 1
            NPIX(1) = 1
            START(1) = 0.0
            STEP(1) = 1.0
         ELSE
            DO 800, N=1,NAXIS
               NPIX(N) = IBUF(N+1)
               START(N) = DBUF(N)
               STEP(N) = DBUF(N+NAXIS)
800         CONTINUE
         ENDIF
      ENDIF
C 
      IMSIZE = 1
      DO 900, N=1,NAXIS
         IMSIZE = IMSIZE * NPIX(N)
         DSIZE = DSIZE * DBLE(NPIX(N))
900   CONTINUE
C 
      DDUM = DSIZE - DBLE(IMSIZE)                !check for overflow
      IF (ABS(DDUM) .GT. 0.5) THEN
         CALL STETER(66,'file size too large for host architecture')
      ENDIF
C
C  finally look for coefficients + function type
      CALL STKRDC('P4',1,1,20,IAV,FUNCY,UNIT,NLO,STAT)
      CALL UPCAS(FUNCY,FUNCY)
      CALL STKRDC('P5',1,1,60,IAV,CBUF,UNIT,NLO,STAT)
C
C  be sure, to handle the NODATA option...
      DFORM = D_R4_FORMAT                     !default data format
      CUNLEN = (NAXIS+1)*16
C
C  create reference frame on disk + write descriptors
      IF (FUNCY(1:1).EQ.'N') THEN                      !NODATA option
         IMSIZE = 1                                    !frame with 1 pixel
         CALL STFCRE(NAME,DFORM,F_O_MODE,F_IMA_TYPE,IMSIZE,INO,STAT)
         CALL STDWRI(INO,'NAXIS',NAXIS,1,1,UNIT,STAT)
         CALL STDWRI(INO,'NPIX',NPIX,1,NAXIS,UNIT,STAT)
         CALL STDWRD(INO,'START',START,1,NAXIS,UNIT,STAT)
         CALL STDWRD(INO,'STEP',STEP,1,NAXIS,UNIT,STAT)
         IF (EMPTY.EQ.0) THEN
            IDENT = 'reference image (no data) '
         ELSE
            IDENT = 'empty image (no data) '
         ENDIF
         CALL STDWRC(INO,'IDENT',1,IDENT,1,72,UNIT,STAT)
         CALL STDWRC(INO,'CUNIT',1,CUNIT,1,CUNLEN,UNIT,STAT)
         GOTO 8800            	!FMIN,FMAX are initialize to inhibit loading
      ELSE
         IDENT = 'artificial image '                   !will be updated later
         IF (FUNCY(1:1).EQ.'P') THEN              !only used for poly work
            CALL STKRDC('PP6',1,1,4,IAV,PXTYPE,UNIT,NLO,STAT)
            CALL UPCAS(PXTYPE,PXTYPE)
            IF (PXTYPE(1:1) .EQ. 'I') THEN
               IF (PXTYPE(2:2) .EQ. '2') THEN
                  DFORM = D_I2_FORMAT
               ELSE IF (PXTYPE(2:2) .EQ. '1') THEN
                  DFORM = D_I1_FORMAT
               ELSE
                  DFORM = D_I4_FORMAT
               ENDIF
            ELSE IF (PXTYPE(1:3) .EQ. 'UI2') THEN
               DFORM = D_UI2_FORMAT
            ELSE IF ((PXTYPE(1:1) .EQ. 'D') .OR.
     +               (PXTYPE(1:2) .EQ. 'R8')) THEN
               DFORM = D_R8_FORMAT
            ENDIF
         ENDIF
         CALL STKRDI('MONITPAR',20,1,IAV,MAPSIZ,UNIT,NLO,STAT)
         MAPSIZ = MAPSIZ * MAPSIZ
         IF ((NAXIS.GT.2) .AND. (MAPSIZ.LT.IMSIZE)) THEN
            CALL STFCRE(NAME,DFORM,F_O_MODE,F_IMA_TYPE,IMSIZE,INO,STAT)
            CALL STDWRI(INO,'NAXIS',NAXIS,1,1,UNIT,STAT)
            CALL STDWRI(INO,'NPIX',NPIX,1,NAXIS,UNIT,STAT)
            CALL STDWRD(INO,'START',START,1,NAXIS,UNIT,STAT)
            CALL STDWRD(INO,'STEP',STEP,1,NAXIS,UNIT,STAT)
            CALL STDWRC(INO,'IDENT',1,IDENT,1,72,UNIT,STAT)
            CALL STDWRC(INO,'CUNIT',1,CUNIT,1,CUNLEN,UNIT,STAT)
            PNTR = 0                                   !as reminder...
         ELSE
            CALL STIPUT(NAME,DFORM,F_O_MODE,F_IMA_TYPE,
     +                  NAXIS,NPIX,START,STEP,IDENT,
     +                  CUNIT(1:CUNLEN),PNTR,INO,STAT)
         ENDIF
      ENDIF
C
C  branch according to function type
      IF (FUNCY(1:1).EQ.'P') THEN
         IDENT = 'image built from polygon ' 
C
C  build polynomial of the form: p(x) = a + bx + cy + dxy + exx + fyy
         CALL GENCNV(CBUF,2,6,IDUM,COEFS,DDUM,NCOEF)
         IF (NCOEF.LE.0) THEN
            COEFS(1) = 0.
            NCOEF = 1
         ENDIF
C 
C  if no real data image, we close image and open it again as real
C  and force to NCOEF = 1 (constant setting only)
C 
         IF (DFORM .NE. D_R4_FORMAT) THEN
            CALL STFCLO(INO,STAT)
            CALL STFOPN(NAME,D_R4_FORMAT,F_IO_MODE,F_IMA_TYPE,
     +                  INO,STAT)
            PNTR = 0
         ENDIF
C
C  and fill frame ...
         IF (PNTR.EQ.0) THEN                     !do it in pieces
            CALL STFCRE('fillwork',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +                  MAPSIZ,IMNOX,STAT)
            CALL STFMAP(IMNOX,F_X_MODE,1,MAPSIZ,IAV,PNTRX,STAT)
            CALL BIGFIL(MADRID(PNTRX),INO,IMSIZE,MAPSIZ,COEFS,FMIN,FMAX)
            CALL STFCLO(IMNOX,STAT)
         ELSE
            CALL IFILL(MADRID(PNTR),NAXIS,NPIX,START,STEP,COEFS,
     +                 NCOEF,FMIN,FMAX)
         ENDIF
         GOTO 8800
C
C  input from an ASCII data file
      ELSE IF (FUNCY(1:1).EQ.'A') THEN
         IDENT = 'image created from ASCII file ' 
         IDUM = 1
         DO 3000 N=1,NAXIS
            IDUM = IDUM * NPIX(N)
3000     CONTINUE
         CALL DATFIL(CBUF,2,IDUM,MADRID(PNTR),MADRID(PNTR),1,FMIN,FMAX)
         IF (FMIN.GT.FMAX) CALL STTPUT
     +      ('no valid data in file - pixels set to 0.0',STAT)
         GOTO 8800
C
C  input from a table with columns X:, Y:
      ELSE IF (FUNCY(1:1).EQ.'T') THEN
         IDENT = 'image created from Midas table ' 
         CALL CLNTAB(CBUF,TABLE,0)
         CALL LINFOL(MADRID(PNTR),NPIX(1),START(1),STEP(1),TABLE)
         CALL MYMX(MADRID(PNTR),NPIX(1),CUTS)
         FMIN = CUTS(1)
         FMAX = CUTS(2)
         GOTO 8800
C
      ELSE IF (FUNCY(1:1).EQ.'G') THEN
C
C  build Gaussian function
         IF ( (NAXIS.GE.3) .AND. (NPIX(3).GT.1) )
     +      CALL STETER(3,'not more than 2 dimensions supported yet')
C
         NO = NAXIS * 2                              !we expect NO numbers
         CALL GENCNV(CBUF,2,NO,IDUM,COEFS,DDUM,NCOEF)
         IF (NCOEF.LT.NO) THEN         !default to center for mean, sigma = 1
            COEFS(1) = START(1) + ((NPIX(1)-1)*STEP(1)*0.5)
            COEFS(2) = 3. * STEP(1)
            IF (NAXIS.EQ.2) THEN
               COEFS(3) = START(2) + ((NPIX(2)-1)*STEP(2)*0.5)
               COEFS(4) = 3. * STEP(2)
            ENDIF
         ENDIF
C
         CALL GAUSS(MADRID(PNTR),NAXIS,NPIX,START,STEP,COEFS,NCOEF,
     +              FMIN,FMAX)
         IF (NAXIS.EQ.1) THEN
            WRITE(IDENT,10000) COEFS(1),COEFS(2)
         ELSE
            WRITE(IDENT,10001) COEFS(1),COEFS(2),COEFS(3),COEFS(4)
         ENDIF
         GOTO 8800
      ENDIF
C
      CALL GENCNV(CBUF,2,4,IDUM,COEFS,DDUM,NCOEF)
C
C  handle FFT filters
      IF (FUNCY(1:5).EQ.'FILT_') THEN
         IF (NCOEF.LT.3) COEFS(3) = 1.
         IF (NCOEF.LT.2) COEFS(2) = 1.
         IF (NCOEF.LT.1) COEFS(1) = ( STEP(1)+STEP(2) ) * 5
         IF (COEFS(1).LT.10.E-12)
     +      CALL STETER(2,'cut-off frequency must be > 0.0 ...')
         IF (FUNCY(6:7).EQ.'BL') METHOD = 5
         IF (FUNCY(6:7).EQ.'EL') METHOD = 6
         IF (FUNCY(6:7).EQ.'BH') METHOD = 7
         IF (FUNCY(6:7).EQ.'EH') METHOD = 8
C
C  handle circle and ellips functions
      ELSE IF (FUNCY(1:1).EQ.'C') THEN
         METHOD = 3
         IF (NCOEF.LT.3) COEFS(3) = 0.            	!outside
         IF (NCOEF.LT.2) COEFS(2) = 1.            	!inside
         IF (NCOEF.LT.1) COEFS(1) =             	!radius
     +      (STEP(1)+STEP(2)) * (NPIX(1)+NPIX(2)) / 16.
         WRITE(IDENT,30001) COEFS(1),COEFS(2),COEFS(3)
      ELSE IF (FUNCY(1:2).EQ.'EL') THEN
         METHOD = 4
         IF (NCOEF.LT.4) COEFS(4) = 0.            	!outside
         IF (NCOEF.LT.3) COEFS(3) = 1.            	!inside
         IF (NCOEF.LT.1) COEFS(1) =             	!a
     +      (STEP(1)+STEP(2)) * (NPIX(1)+NPIX(2)) / 16.
         IF (NCOEF.LT.2) COEFS(2) = 0.6 * COEFS(1)      !b
         WRITE(IDENT,40001) COEFS(1),COEFS(2),COEFS(3),COEFS(4)
C
C  it remains exponential disk, radius law
      ELSE
         IF (NCOEF.LT.4) COEFS(4) = 0.
         IF (NCOEF.LT.3) COEFS(3) = 0.
         IF (NCOEF.LT.2) COEFS(2) = 4.
         IF (NCOEF.LT.1) COEFS(1) = 200.
         IF (FUNCY(1:1).EQ.'R') THEN
            METHOD = 2
            WRITE(IDENT,50001) COEFS(1),COEFS(2),COEFS(3),COEFS(4)
         ELSE
            IF (FUNCY(1:2).NE.'EX') 
     +         CALL STTPUT
     +   ('Invalid func_type, changed to `exponential disk''...',
     +         STAT)
            METHOD = 1                                  !for exponential disk
            WRITE(IDENT,60001) COEFS(1),COEFS(2),COEFS(3),COEFS(4)
         ENDIF
      ENDIF
      CALL IMFUNC(METHOD,MADRID(PNTR),NAXIS,NPIX,START,STEP,
     +            COEFS,FMIN,FMAX)
C
C  update cuts and add descr. HISTORY
8800  CUTS(1) = 0.
      CUTS(2) = 0.
      CUTS(3) = FMIN
      CUTS(4) = FMAX
      CALL STDWRR(INO,'LHCUTS',CUTS,1,4,UNIT,STAT)
      CALL STDWRC(INO,'IDENT',1,IDENT,1,72,UNIT,STAT)
      CBUF(1:) = ' '
      CALL DSCUPT(INO,INO,CBUF,STAT)
C 
C  check for empty frames
      IF (EMPTY.EQ.1) THEN
         NAXIS = 0
         CALL STDWRI(INO,'NAXIS',NAXIS,1,1,UNIT,STAT)
      ENDIF
C
C  that's it folks...
      CALL STSEPI
C
10000 FORMAT('Gaussian, mean,sigma:',G12.5,',',G12.5)
10001 FORMAT('Gaussian, xm,xsig,ym,ysig:',3(G10.5,','),G10.5)
30001 FORMAT('Circle with coeffs =',2(G10.5,','),G10.5)
40001 FORMAT('Ellips with coeffs =',3(G10.5,','),G10.5)
50001 FORMAT('Radius Law, coeffs =',3(G10.5,','),G10.5)
60001 FORMAT('Exponential Disk, coeffs =',3(G10.5,','),G10.5)
      END

      SUBROUTINE BIGFIL(A,IMNO,IMSIZE,CHUNK,RC,RMIN,RMAX)
C
      IMPLICIT NONE
C
      INTEGER   IMNO,IMSIZE,CHUNK
      INTEGER   LOOPLM,RMAIND,STAT
      INTEGER   N,K
      INTEGER   MADRID(1)
C
      REAL      A(*),RC(*),RMIN,RMAX
      REAL      RR
C 
      COMMON   /VMR/ MADRID
C
      LOOPLM = IMSIZE / CHUNK
      RMAIND = IMSIZE - (CHUNK*LOOPLM)
      K = 1
      RR = RC(1)
      RMIN = RR
      RMAX = RR
C
      DO 100, N=1,CHUNK
         A(N) = RR
100   CONTINUE
C 
      DO 1000, N=1,LOOPLM
         CALL STFPUT(IMNO,K,CHUNK,A,STAT)      !data -> disk
         K = K + CHUNK
1000  CONTINUE
C
      IF (RMAIND.NE.0) THEN
         CALL STFPUT(IMNO,K,RMAIND,A,STAT)
      ENDIF
C 
      RETURN
      END

C @(#)fitell2.for	19.1 (ESO-DMD) 02/25/03 13:31:22
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C.IDENTIFICATION: ELLIPS.FOR
C.PURPOSE:   Fit ellipses to 2-dim images,retrieve parameters relevant 
C            to isophotal twisti
C.LANGUAGE:  F77+ESOext
C.AUTHOR:    Edwin A. Valentijn
C.KEYWORDS:  Ellipse fitting,isophotal twisting, display fit
C.ALGORITHM: Make polar coord frames, search for points selected on radius and
C            intensity, least square fit to the polar coord of thee points,
C            retrieve ellips parameters, display points + fit
C.VERSION:   821101 EAV  creation
C.VERSION:   871002 RHW  conversion to standard interfaces
C.VERSION:   871015 RHW  conversion to standard fortran
C 
C 021205	last modif
C 
C ---------------------------------------------------------------------
      PROGRAM FITELL2
C
      IMPLICIT  NONE
C
      INTEGER   MADRID
      INTEGER   I,J,K,NN,IAV,ICAL,IPOL,ISTAT
      INTEGER   MAXLEV,NAXIS,NGAL,NP,NX,NY
      INTEGER   STAT,XSTEP,YSTEP
      INTEGER   NA,NF,NM,NR
      INTEGER   NPIX(2),N(10)
      INTEGER   KUN,KNUL
      INTEGER*8   PNTRA,PNTRF,PNTRM,PNTRR
C
      DOUBLE PRECISION  START(2),STEP(2)
      REAL      IRLIM,XSTRT,YSTRT,CENTER(2),SKY
      REAL      RAD(500),ANG(500),YV(500),X1(500),X2(500),X3(500)
      REAL      CUTS(4),ISOP1(10),ISOP
      REAL      CO1,CO2,CON,CC,B(10),A(10),E(10),EX(10),ANGU(10),PI,EE
C
      CHARACTER IDENT*72,CUNIT*48,TEXT*80,CINPUT*72,INSTRM*72
      CHARACTER INFR*60,RADII*8,ANGLI*8,MASK*8,CTYPE
C
      INCLUDE   'MID_INCLUDE:ST_DEF.INC/NOLIST'
      COMMON    /VMR/MADRID(1)
      INCLUDE   'MID_INCLUDE:ST_DAT.INC/NOLIST'
C
      DATA      PI/3.1415926/
      DATA      MAXLEV/10/
      DATA      CTYPE/'R'/
C
C *** start code
C
      CALL STSPRO('FITELL2 ')                        ! set up Midas environment
C
C ** get keywords
C  
      CALL STKRDC('IN_A',1,1,60,IAV,INFR,KUN,KNUL,STAT)       !  get frame name
      CALL STKRDI('INPUTI',1,1,IAV,IPOL,KUN,KNUL,STAT)         !  polar frame ?
      CALL STKRDI('INPUTI',2,1,IAV,ICAL,KUN,KNUL,STAT)      !  isophotal window
      CALL STKRDC('INPUTC',1,1,72,IAV,CINPUT,KUN,KNUL,STAT)         !  contours
      CALL GETINP(CTYPE,CINPUT,MAXLEV,ISOP1,NGAL,STAT)
      IF (NGAL.GT.1) THEN
         CALL SORT1(ISOP1,NGAL)  
      ENDIF
      CALL STKRDR('INPUTR',1,2,IAV,CENTER,KUN,KNUL,STAT)              !  center
      CALL STKRDR('INPUTR',3,1,IAV,IRLIM,KUN,KNUL,STAT) !  radius around center
      CALL STKRDR('INPUTR',4,1,IAV,SKY,KUN,KNUL,STAT)         !  sky background
C
C *** get the image
C
      CALL STIGET(INFR,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +            2,NAXIS,NPIX,START,STEP,IDENT,
     +            CUNIT,PNTRF,NF,STAT)
C
C  initialize coordinates, parameters
C
      NX     = NPIX(1)
      NY     = NPIX(2)
      NP     = NX*NY
      XSTRT  = SNGL(START(1))
      YSTRT  = SNGL(START(2))
      XSTEP  = SNGL(STEP(1))
      YSTEP  = SNGL(STEP(2))
C
C *** polar coordinates
C     create two images with polar coord: radii and angles
C
      RADII  = 'SCRRADII'
      ANGLI  = 'SCRANGLI'
C
C *** but enable run of program with preexisting polar frames
C
      IF (IPOL.EQ.1) THEN
          CALL STIGET(RADII,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +                1,NAXIS,NPIX,START,STEP,
     +                INSTRM,CUNIT,PNTRR,NR,STAT)
          CALL STIGET(ANGLI,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +                1,NAXIS,NPIX,START,STEP,
     +                INSTRM,CUNIT,PNTRA,NA,STAT)
      ELSE
          CALL STIPUT(RADII,10,1,1,NAXIS,NPIX,START,STEP,
     +                'POLAR-RAD',CUNIT,PNTRR,NR,STAT)
          CALL STIPUT(ANGLI,10,1,1,NAXIS,NPIX,START,STEP,
     +                'POL-ANG',CUNIT,PNTRA,NA,STAT)
          CALL POLAR(NP,NPIX,START,STEP,CENTER,
     +               MADRID(PNTRR),MADRID(PNTRA))
      END IF
C
C     create image for retrieved points and ellipses
C
      MASK   = 'ELLIPS  '
      CUTS(1) = 0.
      CUTS(3) = 0.
      CUTS(2) = NGAL*10.
      CUTS(4) = NGAL*10.
      CALL STIPUT(MASK,10,1,1,NAXIS,NPIX,START,STEP,
     +            'ELLIPS',CUNIT,PNTRM,NM,STAT)
      CALL STDWRR(NM,'LHCUTS',CUTS,1,4,KUN,STAT)
      CALL STDWRC(NM,'INSTRUM',1,INSTRM,1,72,KUN,STAT)
C
C *** Enter main loop
C
      DO 30 K = 1,NGAL
C
C *** Search for points wthin radius and isophotal window
C     For found points retrieve only their polar coord in RAD and ANG
C
         NN = N(K)
         ISOP = ISOP1(K)
         CALL FITEL(NP,MADRID(PNTRF),MADRID(PNTRR),
     +              MADRID(PNTRA),RAD,ANG,ISOP,
     +              ICAL,SKY,IRLIM,NN)
         N(K) = NN
         ISOP1(K) = ISOP
C
C *** Check on the actual number of points found
C
         IF (N(K).GT.499) THEN
            CALL STTPUT('*** WARNING: More then 500 points found '//
     +                   ' results unreliable',ISTAT)
            CALL STTPUT('*** ADVICE:  make window smaller',ISTAT)
            N(K) = 500
         END IF
C
C *** Continue the proces when no or few points were found
C
         IF (N(K).LT.6) THEN
            A(K)  = 0.
            B(K)  = 0.
            E(K)  = 0.
            EX(K) = 0.
            ANGU(K) = 0.
            GO TO 20
         END IF
C
C *** set up for least square fit
C
         DO 10 I = 1,N(K)
            YV(I)  = 2./RAD(I)**2
            X1(I)  = SIN(2.*ANG(I))
            X2(I)  = COS(2.*ANG(I))
            X3(I)  = 1.0
   10    CONTINUE
         NN = N(K)
         CALL LSS3(NN,YV,X1,X2,X3,CO1,CO2,CON)
         N(K) = NN
C
C *** recover the fit parameters  ABS to avoid interuption in batch
C
         ANGU(K) = -0.5*ATAN2(CO1,CO2)
         ANGU(K) = 180.*ANGU(K)/PI + 90.0
         CC       = SQRT(ABS(CO1*CO1+CO2*CO2))
         B(K)    = SQRT(ABS(2./ (CON+CC)))
         A(K)    = SQRT(ABS(2./ (CON-CC)))
         E(K)    = A(K)/B(K)
         EE       = B(K)/A(K)
         EX(K)   = SQRT(ABS(1.-EE*EE))
C
C *** retrieve found datapoints and ellips in mask frame
C
         NN = N(K)
         CALL PLMASK(K,RAD,ANG,NN,NP,NPIX,START,STEP,CENTER,
     +               MADRID(PNTRM),CON,CO1,CO2)
         N(K) = NN
   20    CONTINUE
   30 CONTINUE
C
C *** Print table
C
      CALL STTPUT(' ',ISTAT)
      CALL STTPUT('*** Summary of the Results ***',ISTAT)
      CALL STTPUT('Isophote      #Points     A         B         '//
     +            'A/B      exc.     angle',ISTAT)
      DO 40 J = 1,NGAL
         WRITE (TEXT,8000) ISOP1(J),N(J),A(J),B(J),E(J),EX(J),ANGU(J)
         CALL STTPUT(TEXT,ISTAT)
   40 CONTINUE

      CALL STSEPI
      STOP ' '
C
 8000 FORMAT (G9.3,2X,I8,5F10.2)
C
      END


C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION: POLAR
C.PURPOSE:        Creates 2 virtual images containing the polar coordinates 
C                 with respect to CENTER using descripters of a MIDAS image
C.AUTHOR:         E.A.Valentijn  ESO/Garching
C.INPUT/OUTPUT:   NP,NPIX,START,STEP standard descriptor parameters
C                 radii  go to image R
C                 angles go to image ANGLE
C.VERSION:        821028  EAV  tested and works ok
C.VERSION:        880707  RHW  Converted to standard fortran
C --------------------------------------------------------------------
      SUBROUTINE POLAR(NP,NPIX,START,STEP,CENTER,R,ANGLE)
C
      IMPLICIT NONE
C
      COMMON /VMR/MADRID(1)
C
      INTEGER   MADRID
      INTEGER   NP,NPIX(2),NX,NY,I,IX,IY
      REAL      X,Y,XSTRT,YSTRT,XSTEP,YSTEP,XCT,YCT,CENTER(2)
      REAL      R(NP),ANGLE(NP)
      DOUBLE PRECISION START(2),STEP(2)
C
      XSTRT  = SNGL(START(1))
      YSTRT  = SNGL(START(2))
      XSTEP  = SNGL(STEP(1))
      YSTEP  = SNGL(STEP(2))
      XCT    = CENTER(1)
      YCT    = CENTER(2)
      NX     = NPIX(1)
      NY     = NPIX(2)
      I      = 0
C
      DO 20 IY = 1,NY
         Y      = YSTRT + ((IY-1)*YSTEP)
         DO 10 IX = 1,NX
            X      = XSTRT + ((IX-1)*XSTEP)
            I      = I + 1
            R(I)   = SQRT((X-XCT)**2+ (Y-YCT)**2)
            IF (R(I).EQ.0) THEN                !   avoid singularity at center
               R(I)   = 0.D-10
               ANGLE(I) = 0.0D-10
            ELSE
               ANGLE(I) = ATAN2(X-XCT,Y-YCT)
            END IF
   10    CONTINUE
   20 CONTINUE
      RETURN
      END



C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION: FITEL
C.AUTHOR:   Edwin A. Valentijn
C.PURPOSE:  Selects out of image a on int and radius and fills rad and ang
C.INPUT:    NP    total number of pixels
C           A     image intensities                           input
C           R     polar coord image of raddi                  input
C           ANGLE polar coord image of angles                 input
C           RAD   radii of found points                       output
C           ANG   angles of found points                      output
C           ISOP1 isophotal level in % of background          keyword
C           ICAL  isophotal window in pro mille of background keyword
C           SKY   background level to be added before fitting keyword
C           IRLIM maximum radius used for search              keyword
C           N     number of points found                      output
C.VERSION:  880707 Converted to standard fortran
C --------------------------------------------------------------------
      SUBROUTINE FITEL(NP,A,R,ANGLE,RAD,ANG,ISOP1,ICAL,SKY,IRLIM,N)
C
      IMPLICIT NONE
C
      COMMON /VMR/MADRID(1)
C
      INTEGER   MADRID
      INTEGER   NP,N,ICAL,NI,ISTAT
      REAL      A(NP),R(NP),ANGLE(NP)
      REAL      RAD(500),ANG(500),ISOP1
      REAL      SKY(2),RISOP,LOLIM,UPLIM,CAL1,IRLIM
      CHARACTER TEXT*80
C
      RISOP = ISOP1
      CAL1  = (ICAL*ISOP1)/1000.
      LOLIM = SKY(1) + RISOP - CAL1
      UPLIM = SKY(1) + RISOP + CAL1
C
C *** search int array for filtered values
C     simultaneously R array for radii
C     if true put corresponding R and ANGLE in RAD and ANG
C
      N = 0
      DO 10 NI = 1,NP
         IF (R(NI).LT.IRLIM .AND. A(NI).LT.UPLIM .AND. 
     2      A(NI).GT.LOLIM) THEN
            N      = N + 1
            IF (N.LE.500) THEN
               RAD(N) = R(NI)
               ANG(N) = ANGLE(NI)
            END IF
         END IF
   10 CONTINUE

      WRITE (TEXT,9000) ISOP1,ICAL,LOLIM,UPLIM,IRLIM,N
      CALL STTPUT(TEXT,ISTAT)
C
      RETURN
C
 9000 FORMAT ('Isoph=',G9.3,'  Window=',I4,'  Lim=',F8.2,1X,F8.2,
     +        '  Rad=',F8.2,'  #Pnts=',I4)
C
      END


C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION: LSS3
C.PURPOSE:        least square solution of a system of equations with 3 unknown:
C                 A * X  +  B * Y  +  C * Z  =  CNS
C.AUTHOR:         Edwin A. Valentijn
C.INPUT.OUTPUT:   N  :   number of equations
C                 CNS:   array containing the constants
C                 AAR:   coef.  of X
C                 BAR:   coef.  of Y
C                 CAR:   coef.  of Z
C                 X  :   least square solution of first unknown
C                 Y  :                            second
C                 Z  :                            third
C.VERSION:        880707 RHW  conversion to standard fortran
C -----------------------------------------------------------------
      SUBROUTINE LSS3(N,CNS,AAR,BAR,CAR,X,Y,Z)
C
      IMPLICIT NONE
C
      COMMON /VMR/MADRID(1)
C 
      INTEGER   MADRID
      INTEGER   N,I
      REAL      CNS(N),AAR(N),BAR(N),CAR(N),X,Y,Z
      DOUBLE PRECISION AA,AB,AC,AN,BB,BC,BN,CC,CN,DA,DB,DC,DN
      DOUBLE PRECISION FBB,FBN,FBC,FCC,FCN
C
      IF (N.LT.3) THEN               !  Check if there are more then 3 equations
         RETURN             
      ENDIF
C
C *** initiate the sum - variables
C
      AA     = 0.0D+0
      AB     = 0.0D+0
      AC     = 0.0D+0
      AN     = 0.0D+0
      BB     = 0.0D+0
      BC     = 0.0D+0
      BN     = 0.0D+0
      CC     = 0.0D+0
      CN     = 0.0D+0
C  
      DO 10 I = 1,N                                      !   start the summing
         DA     = DBLE(AAR(I))
         DB     = DBLE(BAR(I))
         DC     = DBLE(CAR(I))
         DN     = DBLE(CNS(I))
         AA     = AA + DA*DA
         AB     = AB + DA*DB
         AC     = AC + DA*DC
         AN     = AN + DA*DN
         BB     = BB + DB*DB
         BC     = BC + DB*DC
         BN     = BN + DB*DN
         CC     = CC + DC*DC
         CN     = CN + DC*DN
   10 CONTINUE
C
C *** first step in solving
C
      FBB    = BB - AB*AB/AA
      FBC    = BC - AB*AC/AA
      FCC    = CC - AC*AC/AA
      FCN    = CN - AC*AN/AA
      FBN    = BN - AB*AN/AA
C
C *** get the unknown
C
      Z      = SNGL((FCN-FBC*FBN/FBB)/ (FCC-FBC*FBC/FBB))
      Y      = SNGL((FBN-FBC*Z)/FBB)
      X      = SNGL((AN-AB*Y-AC*Z)/AA)
C
      RETURN
      END


C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION: PLMASK
C.PURPOSE:        Finds rectangular image coordinates and labels that in mask
C                 frame(A) of:
C                 set of (N) points in polar coord given by RAD and ANG
C                 ellips given by least square parameters CON,CO1,CO2
C.AUTHOR:         Edwin A. Valentijn
C.NOTE:           mask does not work : instead use normal image
C.VERSION:        880707  RHW  conversion to standard fortran
C -------------------------------------------------------------------
      SUBROUTINE PLMASK(K,RAD,ANG,N,NP,NPIX,START,STEP,CENTER,A,CON,
     +                  CO1,CO2)
C
      IMPLICIT NONE
C
      COMMON   /VMR/MADRID(1)
C
      INTEGER   MADRID
      INTEGER   K,N,NP,NPIX(2),I,II,IX,IY
      REAL      A(NP)
      REAL      RAD(500),ANG(500),CENTER(2)
      REAL      R,TH,CON,CO1,CO2,XX,YY
      DOUBLE PRECISION START(2),STEP(2)
C
C *** initialize Mask frame
C
      IF (K.EQ.1) THEN
         DO 10 I = 1,NP
             A(I)   = 0.
   10    CONTINUE
      END IF
C
C *** find indices of points of the polar coord array
C
      DO 20 I = 1,N
         XX    = RAD(I)*SIN(ANG(I))
         YY    = RAD(I)*COS(ANG(I))
         IX    = IFIX((XX+CENTER(1)+0.5-SNGL(START(1)))/SNGL(STEP(1)))
         IY    = IFIX((YY+CENTER(2)+0.5-SNGL(START(2)))/SNGL(STEP(2)))
         II    = (IY-1)*NPIX(1) + IX                   !    put a label in mask
         A(II) = K*10.
   20 CONTINUE
C
C *** now for the ellips; take 90 points duplication does not harm
C     data of found points from previous step are lost if they coincide
C
      DO 30 I = 1,91
         TH    = (I-1)*4.0
         TH    = 3.1415926*TH/180.
         R     = CON + CO1*SIN(2.*TH) + CO2*COS(2.*TH)
         R     = SQRT(ABS(2.0/R))
         XX    = R*SIN(TH)
         YY    = R*COS(TH)
         IX    = IFIX((XX+CENTER(1)+0.5-SNGL(START(1)))/SNGL(STEP(1)))
         IY    = IFIX((YY+CENTER(2)+0.5-SNGL(START(2)))/SNGL(STEP(2)))
         II    = (IY-1)*NPIX(1) + IX
         A(II) = K*10.
   30 CONTINUE
      
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C                                         all rights reserved
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM DESCR
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: K.Banse
C
C.IDENTIFICATION
C  program DESCR 	  version 3.50	861003
C 
C.KEYWORDS
C  descriptors
C
C.PURPOSE
C  read/write or delete descriptors
C
C.ALGORITHM
C  use MIDAS interfaces to do the job
C
C.INPUT/OUTPUT
C  the following keys are used:
C  IN_A/C/1/120         name of data frame (input)
C                    	"cleaned" name (output)
C  ACTION/C/1/2         (1) up to 6 different action flags
C                    	  = R, for reading a complete descriptor
C                    	  = W, for writing a descriptor
C                   	  = D, for deleting a descriptor
C                   	  = P, for printing a complete descriptor
C                   	  = C, for copying all descriptors
C                   	  = S, for showing all existing descriptors
C                  	(2) display flag for READ option
C                    	  = F, for full display
C                    	  = B, for brief display
C                    	  = H, for display of data only (no header line)
C                  	or hidden flag for SHOW option
C                    	  = H, for hidden display
C  P2/C/1/80            for (W) descriptor/type/1.elem./novals	
C  or as default        descriptor => has to exist
C                       1.elem. = 1 + fill as much as is there
C                  	for (C) *,MASK with MASK as defined in STDCOP
C                    	only descriptor(s) separated by a comma (R,D,P)LINE
C  P3/C/1/60            data values in ASCII (W)
C  P4/C/1/3             = ALL, if complete descr. should be filled (W)
C  INPUTI/I/10/1        dsc_process_flag for dest_descr's:
C 			2 = No Overwrite, 1 = clean first exisiting descr
C			0 = just copy
C  OUT_A/C/1/120        name of output frame (C)
C
C  for option READ, PRINT + SHOW the integer keyword OUTPUTI(1-4) is set to
C  (1) 1/0 if descr exists or not
C  (2) 1/2/3/4 for int, real, char, double descr.
C  (3) noelem, (4) bytelem of descr
C 
C.VERSIONS
C 
C 101220	last modif
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      ACTVAL,BYTELM,DSCMSK,DSCVERS
      INTEGER      FIRST,FLAG,I,IAV,IOFF
      INTEGER      LL,N,NOELEM,CLEN
      INTEGER      SLEN,START,STAT,MAXNO
      INTEGER*8    WPNTR2
      INTEGER      IMNO,RIMNO,ALLFLG
      INTEGER      EC,EL,ED,LINLEN
      INTEGER      UNIT(1),NULLO,MADRID(1)
C
      CHARACTER    LINE*120,OUTPUT*120,ACTION*2
      CHARACTER    FRAME*120,RESFRA*120,DSCR*80,TYPE*20
      CHARACTER    INSTRM*1,COMPAR(6)*1,DTYPE*1
C
      INTEGER      IBUF(65535)                    !descr data buffers
      INTEGER*8    SBUF(65535) 
      REAL         RBUF(65535)
      CHARACTER    CBUF*65535
      DOUBLE PRECISION  DBUF(65535)
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      COMMON  /VMR/ MADRID
C
      EQUIVALENCE      (IBUF,DBUF),(RBUF,DBUF),(SBUF,DBUF)
C
      DATA      COMPAR /'R','W','D','P','C','S'/
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C  get into MIDAS
      CALL STSPRO('DESCR ')
      IMNO = -1
C
C  get frame + open it (do not extract subframe data...)
      CALL STKRDC('IN_A',1,1,120,IAV,FRAME,UNIT,NULLO,STAT)
      CALL STFINF(FRAME,9,IBUF,STAT)
      IF (STAT .NE. 0) then     
        CALL STETER(5,'could not read (FITS) file header...')
      endif
      IF (IBUF(2).EQ.F_TBL_TYPE) THEN
         CALL TBTOPN(FRAME,F_I_MODE,IMNO,STAT)
      ELSE
         CALL STFOPN(FRAME,D_OLD_FORMAT,0,F_OLD_TYPE,IMNO,STAT)
      ENDIF
      IBUF(1) = IMNO
      CALL STFINF(FRAME,-6,IBUF,STAT)   !we reuse IMNO with flag < 0
      DSCVERS = IBUF(3)                 !get descr. format version
C
C  get action flag              ( ACTION(2:2) = display flag )
      CALL STKRDC('ACTION',1,1,2,IAV,ACTION,UNIT,NULLO,STAT)
      CALL UPCAS(ACTION,ACTION)
      DO 50, N=1,6
         IF (ACTION(1:1).EQ.COMPAR(N)) THEN
            FLAG = N
            GOTO 200
         ENDIF
50    CONTINUE
      CALL STETER(23,'module DESCR: invalid option...')
C
C  branch according to desired action
200   GOTO (1000,2000,3500,1000,5000,1000),FLAG
C
C  read, show or print descriptor (all values)
C
1000  CALL STKRDC('P2',1,1,80,LINLEN,LINE,UNIT,NULLO,STAT)
      IF (ACTION(2:2).NE.'H') CALL FRAMOU(FRAME)     !show frame and data type 
C
      IF (LINE(1:1).EQ.'*') THEN                     !all descriptors?
         IF ((LINE(2:2).EQ.' ') .OR. (LINE(2:2).EQ.','))
     +      LINE(1:1) = ' '
         IF (DSCVERS.EQ.0) THEN
            CALL ODSCLS(IMNO,LINE(1:80),IBUF,RBUF,CBUF,DBUF,ACTION)
         ELSE
            CALL DSCLIS(IMNO,LINE(1:80),IBUF,RBUF,CBUF,DBUF,SBUF,ACTION)
         ENDIF
         GOTO 8000
      ENDIF
C
      CALL LOWCAS(LINE,LINE)                         !check for ASCII file
      N = INDEX(LINE,'.ascii')
      IF (N.GT.1) THEN
         N = INDEX(LINE,' ') - 1                     !cut off trailing blanks
         IF (N.LT.1) N = LEN(LINE)
         OPEN(UNIT=33,FILE=LINE(1:N),STATUS='OLD',ERR=1090)
C 
1050     LINE(1:) = ' '
         READ(33,10000,END=1080) LINE
         START = 1
1060     CALL EXTRSS(LINE,',',START,DSCR,SLEN)
         IF (SLEN.GT.0) THEN
            IF (DSCVERS.EQ.0) THEN
               CALL ODSCLS(IMNO,LINE,IBUF,RBUF,CBUF,DBUF,ACTION)
            ELSE
               CALL DSCLIS(IMNO,LINE,IBUF,RBUF,CBUF,DBUF,SBUF,ACTION)
            ENDIF
            GOTO 1060
         ELSE
            GOTO 1050                                !read next line
         ENDIF
C 
1080     CLOSE(UNIT=33)
         GOTO 8000
1090     CALL STETER(4,'could not open ASCII file...')
         GOTO 8000
      ENDIF
C 
C  extract descriptor(s) separated by a comma from single line
      START = 1
1100  CALL EXTRSS(LINE(1:LINLEN),',',START,DSCR,SLEN)
      IF (SLEN.LE.0) THEN
         GOTO 8000
      ELSE
         IF (DSCVERS.EQ.0) THEN
            CALL ODSCLS(IMNO,DSCR,IBUF,RBUF,CBUF,DBUF,ACTION)
         ELSE
            CALL DSCLIS(IMNO,DSCR,IBUF,RBUF,CBUF,DBUF,SBUF,ACTION)
         ENDIF
         GOTO 1100
      ENDIF
C
C  write descriptor (not necessarily all values)
C
2000  CALL STKRDC('P2',1,1,80,IAV,LINE,UNIT,NULLO,STAT)
      CALL STKRDC('P4',1,1,1,IAV,CBUF,UNIT,NULLO,STAT)
      IF ((CBUF(1:1).EQ.'A') .OR.
     +    (CBUF(1:1).EQ.'a')) THEN
         ALLFLG = 1
      ELSE
         ALLFLG = 0
      ENDIF
      CBUF(1:81) = ' '                                   !we need [81] if "..."
      CALL STKRDC('P3',1,1,80,IAV,CBUF,UNIT,NULLO,STAT)       !get data string
C
C  either use defaults (1. element,...)
C   		                                     test, if default is used
      LL = INDEX(LINE,'/')
      IF (LL.LE.0) THEN
         START = 0            !set START to the "wrong" value = 0, to remember
         DSCR = LINE
         FIRST = 1
         CALL STDFND(IMNO,DSCR,DTYPE,NOELEM,BYTELM,STAT)

         IF (DTYPE.EQ.' ') CALL STETER
     +     (1,'default option invalid - descriptor does not exist... ')
C
C  or extract specific info about starting element, etc.
      ELSE
         START = 1
         CALL EXTRSS(LINE,'/',START,DSCR,SLEN)
         CALL EXTRSS(LINE,'/',START,TYPE,SLEN)
         CALL DTCHK(TYPE,DTYPE,BYTELM,MAXNO)
C                                                         wrong type given...
         IF (DTYPE.EQ.' ') GOTO 8900
C
         CALL EXTRSS(LINE,'/',START,OUTPUT,SLEN)
         CALL GENCNV(OUTPUT,1,1,FIRST,RBUF,DBUF,LL)
         IF (LL.LT.1) GOTO 8900
         CALL EXTRSS(LINE,'/',START,OUTPUT,SLEN)
         CALL GENCNV(OUTPUT,1,1,NOELEM,RBUF,DBUF,LL)
         IF (LL.LT.1) GOTO 8900
         IF (NOELEM .GT. MAXNO) THEN
            NOELEM = MAXNO
            WRITE(OUTPUT,10005) NOELEM
            CALL STTPUT(OUTPUT,STAT)
         ENDIF
      ENDIF
C 
C  get input stream
      CALL STKRDC('MID$IN',1,1,120,IAV,OUTPUT,UNIT,NULLO,STAT)  
      INSTRM = OUTPUT(1:1)
      IF (INSTRM.EQ.'F') GOTO 2660
C
C  integer descriptor
      IF (DTYPE.EQ.'I') THEN
         IF (ALLFLG.EQ.1) THEN
            CALL GENCNV(CBUF(1:20),1,1,IBUF,RBUF,DBUF,LL)
            IF (LL.LE.0) GOTO 8800
            ACTVAL = NOELEM
            DO 2250 N=2,ACTVAL
               IBUF(N) = IBUF(1)
2250        CONTINUE
         ELSE
            CALL GENCNV(CBUF(1:80),1,NOELEM,IBUF,RBUF,DBUF,ACTVAL)
            IF (ACTVAL.LE.0) GOTO 8800
         ENDIF
         CALL STDWRI(IMNO,DSCR,IBUF,FIRST,ACTVAL,UNIT,STAT)
C
C  real descriptor
      ELSE IF (DTYPE.EQ.'R') THEN
         IF (ALLFLG.EQ.1) THEN
            CALL GENCNV(CBUF(1:20),2,1,IBUF,RBUF,DBUF,LL)
            IF (LL.LE.0) GOTO 8800
            ACTVAL = NOELEM
            DO 2280, N=2,ACTVAL
               RBUF(N) = RBUF(1)
2280        CONTINUE
         ELSE
            CALL GENCNV(CBUF(1:80),2,NOELEM,IBUF,RBUF,DBUF,ACTVAL)
            IF (ACTVAL.LE.0) GOTO 8800
         ENDIF
         CALL STDWRR(IMNO,DSCR,RBUF,FIRST,ACTVAL,UNIT,STAT)
C
C  character descriptor 
      ELSE IF ((DTYPE.EQ.'C') .OR. (DTYPE.EQ.'H')) THEN
         LL = 80                                    !cut off trailing blanks
         DO 2300, I=LL,1,-1
            IF (CBUF(I:I).NE.' ') THEN
               CLEN = I
               GOTO 2310
            ENDIF
2300     CONTINUE
         CLEN = 1
2310     IF ((START.EQ.0) .AND. (ALLFLG.EQ.0)) NOELEM = CLEN 
C 
C  now look for " ... "
         IOFF = 1
         IF ((CBUF(1:1).EQ.'"')       .AND.
     +       (CBUF(CLEN:CLEN).EQ.'"') .AND.
     +       (CLEN.GT.2)) THEN                  !only possible for CLEN > 2
            IOFF = 2
            CBUF(CLEN:CLEN) = ' '
            IF ((START.EQ.0) .AND. (ALLFLG.EQ.0)) 
     +         NOELEM = NOELEM - 2
         ENDIF
C
C  character array
         IF (BYTELM.GT.1) THEN
            IF (ALLFLG.EQ.1) THEN
C		                   this makes it work for only 1 element, too
               LL = 1
               DO 2320, N=1,NOELEM 
                  CBUF(LL:LL+BYTELM-1) = CBUF(IOFF:IOFF+BYTELM-1)
                  LL = LL + BYTELM
2320           CONTINUE
               IOFF = 1
            ENDIF
            CALL STDWRC(IMNO,DSCR,BYTELM,CBUF(IOFF:),FIRST,NOELEM,
     +                  UNIT,STAT)
C
C  flat character string
         ELSE
            IF (ALLFLG.EQ.1) THEN
               DO 2330, N=1,NOELEM
                  CBUF(N:N) = CBUF(IOFF:IOFF)
2330           CONTINUE
               IOFF = 1
            ENDIF
            IF (DTYPE.EQ.'H') THEN
               CALL STDWRH(IMNO,DSCR,CBUF(IOFF:),FIRST,NOELEM,STAT)
            ELSE
               CALL STDWRC(IMNO,DSCR,1,CBUF(IOFF:),FIRST,NOELEM,
     +                     UNIT,STAT)
            ENDIF

         ENDIF
C
C  double prec. descriptor
      ELSE IF (DTYPE.EQ.'D') THEN
         IF (ALLFLG.EQ.1) THEN
            CALL GENCNV(CBUF(1:40),4,1,IBUF,RBUF,DBUF,LL)
            IF (LL.LE.0) GOTO 8800
            ACTVAL = NOELEM
            DO 2350, N=2,ACTVAL
               DBUF(N) = DBUF(1)
2350        CONTINUE
         ELSE
            CALL GENCNV(CBUF(1:80),4,NOELEM,IBUF,RBUF,DBUF,ACTVAL)
            IF (ACTVAL.LE.0) GOTO 8800
         ENDIF
         CALL STDWRD(IMNO,DSCR,DBUF,FIRST,ACTVAL,UNIT,STAT)
C 
C  logical descriptor
      ELSE IF (DTYPE.EQ.'L') THEN
         IF (ALLFLG.EQ.1) THEN
            IF ((CBUF(1:1).EQ.'T') .OR. (CBUF(1:1).EQ.'t')) THEN
               IBUF(1) = 1
            ELSE IF ((CBUF(1:1).EQ.'F') .OR. (CBUF(1:1).EQ.'f')) THEN
               IBUF(1) = 0
            ELSE
               CALL GENCNV(CBUF(1:20),1,1,IBUF,RBUF,DBUF,LL)
               IF (LL.LE.0) GOTO 8800
            ENDIF
            ACTVAL = NOELEM
            DO 2400, N=2,ACTVAL
               IBUF(N) = IBUF(1)
2400        CONTINUE
         ELSE
            ACTVAL = 1           !for single value, also T(rue), F(alse) is o.k.
            IF ((CBUF(1:1).EQ.'T') .OR. (CBUF(1:1).EQ.'t')) THEN
               IBUF(1) = 1
            ELSE IF ((CBUF(1:1).EQ.'F') .OR. (CBUF(1:1).EQ.'f')) THEN
               IBUF(1) = 0
            ELSE
               CALL GENCNV(CBUF(1:80),1,NOELEM,IBUF,RBUF,DBUF,ACTVAL)
               IF (ACTVAL.LE.0) GOTO 8800
            ENDIF
         ENDIF
         CALL STDWRL(IMNO,DSCR,IBUF,FIRST,ACTVAL,UNIT,STAT)
      ENDIF
      GOTO 8000
C
C  come here, if we read the data from file
C  get data from file used as input stream in MIDAS into temporary buffer
2660  ACTVAL = 1
      ALLFLG = 0
C
C  integer descr
      IF (DTYPE.EQ.'I') THEN
         CALL CNTDAT(OUTPUT(3:),'NUM',ACTVAL)            !count data in file
         IF (ACTVAL.LE.0)
     +      CALL STETER(22,'Invalid integer input file...')
C 
         CALL STFXMP(ACTVAL,D_I4_FORMAT,WPNTR2,STAT)
         CALL DATFIL(OUTPUT(3:),1,ACTVAL,MADRID(WPNTR2),MADRID(WPNTR2),
     +               0,RBUF(1),RBUF(2))              !now get the integer data
         CALL STDWRI(IMNO,DSCR,MADRID(WPNTR2),FIRST,ACTVAL,UNIT,STAT)
C
C  real descr
      ELSE IF (DTYPE.EQ.'R') THEN
         CALL CNTDAT(OUTPUT(3:),'NUM',ACTVAL)            !count data in file
         IF (ACTVAL.LE.0) CALL STETER(22,'Invalid real input file...')
C
         CALL STFXMP(ACTVAL,D_R4_FORMAT,WPNTR2,STAT)
         CALL DATFIL(OUTPUT(3:),2,ACTVAL,MADRID(WPNTR2),MADRID(WPNTR2),
     +               0,RBUF(1),RBUF(2))              !now get the real data
         CALL STDWRR(IMNO,DSCR,MADRID(WPNTR2),FIRST,ACTVAL,UNIT,STAT)
C
C  character descr
      ELSE IF ((DTYPE.EQ.'C') .OR. (DTYPE.EQ.'H')) THEN
         CALL CNTDAT(OUTPUT(3:),'CHAR',ACTVAL)            !count chars. in file
         IF (ACTVAL.LE.0) CALL STETER(22,'Invalid char. input file...')
C 
         N = ACTVAL/4 + 1
         CALL STFXMP(N,D_I4_FORMAT,WPNTR2,STAT)
         CALL CARFIL(OUTPUT(3:),ACTVAL,MADRID(WPNTR2))   !now get the characters
         IF (DTYPE.EQ.'H') THEN
            CALL STDWRH(IMNO,DSCR,MADRID(WPNTR2),FIRST,ACTVAL,STAT)
         ELSE
            CALL STDWRC(IMNO,DSCR,BYTELM,MADRID(WPNTR2),
     +                  FIRST,ACTVAL,UNIT,STAT)
         ENDIF
C
C  double prec. descr
      ELSE IF (DTYPE.EQ.'D') THEN
         CALL CNTDAT(OUTPUT(3:),'NUM',ACTVAL)            !count data in file
         IF (ACTVAL.LE.0) CALL STETER(22,'Invalid double input file...')
C
         CALL STFXMP(ACTVAL,D_R8_FORMAT,WPNTR2,STAT)
         CALL DATFIL(OUTPUT(3:),4,ACTVAL,MADRID(WPNTR2),MADRID(WPNTR2),
     +               0,RBUF(1),RBUF(2))              !now get the real data
         CALL STDWRD(IMNO,DSCR,MADRID(WPNTR2),FIRST,ACTVAL,UNIT,STAT)
C
C  logical descr
      ELSE IF (DTYPE.EQ.'L') THEN
         CALL CNTDAT(OUTPUT(3:),'NUM',ACTVAL)            !count data in file
         IF (ACTVAL.LE.0)
     +      CALL STETER(22,'Invalid logical input file...')
C 
         CALL STFXMP(ACTVAL,D_I4_FORMAT,WPNTR2,STAT)
         CALL DATFIL(OUTPUT(3:),1,ACTVAL,MADRID(WPNTR2),MADRID(WPNTR2),
     +               0,RBUF(1),RBUF(2))              !now get the integer data
         CALL STDWRL(IMNO,DSCR,MADRID(WPNTR2),FIRST,ACTVAL,UNIT,STAT)
      ENDIF
      GOTO 8000
C
C  delete descriptors
C
3500  CALL STKRDC('P2',1,1,80,IAV,DSCR,UNIT,NULLO,STAT)
      CALL STKRDC('P3',1,1,4,IAV,TYPE,UNIT,NULLO,STAT)       !TYPE = stopflag
      IF (TYPE(1:1).EQ.'n') TYPE(1:1) = 'N'
      IF (DSCR(1:2).EQ.'* ') THEN
         CALL STDDEL(IMNO,DSCR,STAT)
C 
      ELSE
         CALL STECNT('GET',EC,EL,ED)
         IF (TYPE(1:1).EQ.'N') CALL STECNT('PUT',1,0,0)
C
C  extract descriptor(s) separated by a comma from single line
         START = 1
         ACTVAL = 0
3550     CALL EXTRSS(DSCR,',',START,OUTPUT,SLEN)
         IF (SLEN.GT.0) THEN
            N = INDEX(OUTPUT,'*')
            IF (N.GT.0) THEN                           !we have a pattern
               IF (DSCVERS.EQ.0) THEN
                  CALL ODSCDL(IMNO,OUTPUT,IAV)
               ELSE
                  CALL DSCDEL(IMNO,OUTPUT,IAV)
               ENDIF
               ACTVAL = ACTVAL + IAV
            ELSE
               CALL STDDEL(IMNO,OUTPUT,STAT)           !delete single descr
               ACTVAL = ACTVAL + 1
            ENDIF
            GOTO 3550
         ENDIF
         CALL STECNT('PUT',EC,EL,ED)
         CALL STKWRI('OUTPUTI',ACTVAL,1,1,UNIT,STAT) 
      ENDIF
      GOTO 8000
C
C  copy descriptors
C 
5000  CALL STKRDC('OUT_A',1,1,120,IAV,RESFRA,UNIT,NULLO,STAT)
      CALL STFOPN(RESFRA,D_OLD_FORMAT,0,F_OLD_TYPE,RIMNO,STAT)
C                                   get *,1 *,2 *,3, ...  or just *
      CALL STKRDC('P2',1,1,100,IAV,CBUF,UNIT,NULLO,STAT)
      DSCMSK = 1
      LL = INDEX(CBUF(1:100),' ')              !find end of buffer
      IF (LL.LT.1) LL = 100
      IF (CBUF(2:2).EQ.',') THEN
         CALL GENCNV(CBUF(3:3),1,1,DSCMSK,RBUF,DBUF,IAV)
         IF (IAV.NE.1)
     +      CALL STETER(12,'wrong flag in COPY/DD ...')

         IF (CBUF(4:4).EQ.',') THEN            !*,n,descrNOT,descrNOT,...
            CBUF(1:LL) = CBUF(5:LL) //' '               
            DSCMSK = DSCMSK + 5                !update the copy-mask
         ELSE
            CBUF(1:LL) = ' '
         ENDIF
C 
      ELSE IF (CBUF(1:1).EQ.'?') THEN
         CBUF(1:LL) = CBUF(2:LL)//' '
         DSCMSK = 4                         !we have descnames or patterns
5100     N = INDEX(CBUF(1:LL),'*') 
         IF (N .GT. 0) THEN              
            IAV = INDEX(CBUF(1:LL),',')
            IF (IAV.GT.1) THEN
               CBUF(101:200) = CBUF(1:IAV-1)//' '
               CBUF(1:LL) = CBUF(IAV+1:LL)//' '
               CALL STDCOP(IMNO,RIMNO,DSCMSK,CBUF(101:200),STAT)
               LL = INDEX(CBUF(1:),' ')                  !we do have a ' '
               GOTO 5100
            ENDIF
         ENDIF
      ENDIF
C                         get descr_process_flag and copy all descriptors
      CALL STKRDI('INPUTI',10,1,IAV,N,UNIT,NULLO,STAT)
      IF (N.GT.0) DSCMSK = DSCMSK + (N*100)          !include dsc_process_flag
      CALL STDCOP(IMNO,RIMNO,DSCMSK,CBUF(1:LL),STAT)
C
C  we're done without problems
C
8000  CALL STSEPI
C
C  here, if syntax error in data string
8800  CALL STETER(2,'wrong syntax in data string... ')
C
C  here for syntax errors detected while reading stuff...
8900  CALL STETER(3,'wrong syntax in descriptor string... ')
C
C 
10000 FORMAT(A)
10005 FORMAT('Warning: only ',I5,
     +       ' descriptor elements written in one go ...')
C 
      END

      SUBROUTINE DSCLIS(IMNO,INDSC,IVALS,RVALS,CVALS,DVALS,SVALS,FLAG)
C
C+++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine DSCLIS			version 3.50	090323
C  K. Banse                  		ESO - Garching
C
C.KEYWORDS
C  descriptors
C
C.PURPOSE
C  display contents of one or all descriptors of a bulk data frame
C
C.ALGORITHM
C  read all existing descriptor names + display their contents
C
C.INPUT/OUTPUT
C  call as DSCLIS(IMNO,INDSC,IVALS,RVALS,CVALS,DVALS,SVALS,FLAG)
C
C  IMNO:      I*4         frame no. of data frame
C  INDSC:     char.exp.   descriptor to be displayed
C                   	  if = ' ', all descriptors are displayed
C  IVALS:     I*4 array   integer buffer
C  RVALS:     R*4 array   real buffer
C  CVALS:     char.exp.   character buffer
C  DVALS:     R*8 array   double precision buffer
C  SVALS:     I*8 array   size_t buffer
C  FLAG:      char.exp.   2-char. flag:
C			  (1) = R(ead), P(rint) or S(how)
C			  (2) = F(ull), B(rief) or H(idden)
C
C-------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      IMNO,IVALS(*)
      INTEGER      LIM(7)
      INTEGER      BYTELM,NOELEM,NPOS
      INTEGER      DSCNO(2),DSCLEN,IAV,IOFF,ITY,L,LL,M,MM,N,KCASE
      INTEGER      NDI,STAT,IJK(5),NPT
      INTEGER      EL1,NEL2,NOTDS,HNC
      INTEGER      OPTIO,UNIT(1),NULLO,XLONG
      INTEGER*8    SVALS(*)
C
      CHARACTER*(*)  INDSC
      CHARACTER*(*)  CVALS
      CHARACTER*(*)  FLAG
      CHARACTER      LF*1,TYPE*1
      CHARACTER      DISCR*80,DSCDIR*24,DSCTYP*24
      CHARACTER      NOTDSC(4)*72,OUTPUT*80,CCC*14,CBUF*80
      CHARACTER      CC(7)*12,CTYPE*4,CHTYP*14,BLANK*20
C
      REAL           RVALS(*)
C
      DOUBLE PRECISION DVALS(*)
C 
      DATA      CC/'integer ','real ','character ','double prec.',
     +		   ' ','logical ','size_t '/
      DATA      CHTYP /'character* '/
      DATA      LIM      /6,4,60,2,1,10,2/
      DATA      BLANK /' '/, CCC /' '/
C
      LF = CHAR(10)                   !LineFeed character ( \n in C)
      DSCNO(1) = 0                    !for descriptor
      DSCNO(2) = -1                   !for help text of descriptor
      NPOS = 1
      NDI = 0
      DSCDIR = 'DESCRIPTOR.DIRECTORY'
      EL1 = 1
      NEL2 = 0
C
C  clean + convert to uppercase
      DISCR(1:) = ' '
      CALL UPCAS(INDSC,DISCR)
      IF (DISCR.EQ.DSCDIR) THEN
         OPTIO = -1                                !descr. directory
         NOELEM = 0
         CALL STDRDZ(IMNO,NOELEM,DSCNO(1),STAT) 
         RETURN
C
      ELSE IF (DISCR(1:1).EQ.' ') THEN
         IF ((DISCR(2:2).EQ.',') .OR.              !descriptors NOT to display
     +       (DISCR(2:2).EQ.'|')) THEN
            NOTDS = 1
            DISCR(2:2) = ' '
110         N = INDEX(DISCR,',')
            IF (N.GT.1) THEN
               NOTDSC(NOTDS)(1:) = DISCR(3:N-1)//' ' 
               DISCR(3:) = DISCR(N+1:)
               IF (NOTDS.LT.4) THEN
                  NOTDS = NOTDS + 1
                  GOTO 110 
               ENDIF
            ELSE
               NOTDSC(NOTDS)(1:) = DISCR(3:)
               IF (NOTDS.EQ.1) THEN
                  N = INDEX(NOTDSC(1),'*')
                  IF (N.GT.0) THEN
                     CALL PATTST(1,NOTDSC(1),STAT)
                     NOTDS = -1
                  ENDIF
               ENDIF
            ENDIF
         ELSE
            NOTDS = 0
         ENDIF
         OPTIO = 1                    !all descriptors
         DISCR(1:) = ' '
         CALL STDRDX(IMNO,1,DISCR,DSCTYP,BYTELM,NOELEM,HNC,STAT)  !get dscdir
         CALL STDRDX(IMNO,10,DISCR,DSCTYP,BYTELM,NOELEM,HNC,STAT) !get 1.dsc
         IF (DISCR(1:1).EQ.' ') GOTO 9000
         DSCNO(1) = 2                 !at least 1 descr. + directory
C 
      ELSE
         N = INDEX(DISCR,'*') 
         IF (N.GT.0) THEN                  !we have a pattern
            N = INDEX(DISCR,'|')
            IF (N.GT.1) THEN               !is it incl-patrn | excl-patrn?
               OPTIO = 3
               CALL PATTST(1,DISCR(1:N-1),STAT)    !save the two patterns
               CALL PATTST(11,DISCR(N+1:),STAT)
            ELSE
               OPTIO = 2
               CALL PATTST(1,DISCR,STAT)
            ENDIF
            NPT = 0
            CALL STDRDX(IMNO,1,DISCR,DSCTYP,BYTELM,NOELEM,HNC,STAT) 
            NPOS = 0
            GOTO 8000
         ENDIF
C 
         OPTIO = 0                 !single descriptor 
         DSCNO(1) = 1         
         N = INDEX(DISCR,'/')                  !see, if it's descr/type/f/no
         IF (N.GT.1) THEN
            CBUF(1:) = DISCR(N+1:)
            DISCR(N:) = ' '
         ENDIF
         CALL STDFND(IMNO,DISCR,DSCTYP,NOELEM,BYTELM,STAT)
C 
         IF (N.GT.1) THEN
            N = INDEX(CBUF,'/')               !skip type
            IF (N.GT.1) THEN
               CBUF(1:) = CBUF(N+1:)
               DO 440,N=1,30
                  IF (CBUF(N:N).EQ.'/') THEN
                     CBUF(N:N) = ','
                     CALL GENCNV(CBUF,1,2,IVALS,RVALS,DVALS,LL)
                     IF (LL.EQ.2) THEN
                        EL1 = IVALS(1)
                        NEL2 = IVALS(2)
                        GOTO 500
                     ENDIF
                  ENDIF
440            CONTINUE
            ENDIF
         ENDIF
C 
      ENDIF
C
C
C  loop through descr. list
C
500   IF (OPTIO.GE.2) THEN                          !we have pattern(s)
         CALL PATTST(2,DISCR,STAT)
         IF (STAT.EQ.0) GOTO 8000                   !no match
C 
         IF (OPTIO.EQ.3) THEN
            CALL PATTST(12,DISCR,STAT)
            IF (STAT.EQ.1) GOTO 8000                !it's an excluded descr
         ENDIF
         NPT = NPT + 1                              !matching descr. found
C 
      ELSE IF (OPTIO.EQ.1) THEN
         IF (NOTDS.NE.0) THEN 
            IF (NOTDS.GT.0) THEN                    !loop thru excluded descrs
               DO 550, N=1,NOTDS
                  IF (DISCR.EQ.NOTDSC(N)) THEN
                     DSCNO(1) = DSCNO(1) - 1
                     GOTO 8000
                  ENDIF
550            CONTINUE
            ELSE 
               CALL PATTST(2,DISCR,STAT)
               IF (STAT.EQ.1) THEN
                  DSCNO(1) = DSCNO(1) - 1
                  GOTO 8000
               ENDIF
            ENDIF
         ENDIF
      ENDIF
C 
      IF (NEL2.GT.0) NOELEM = NEL2
C 
      DSCLEN = INDEX(DISCR,' ') - 1              !real length of descr name
      TYPE = DSCTYP(1:1)
      IF (TYPE.EQ.' ') THEN
         IJK(1) = 0
         IF (FLAG(2:2).NE.'H') THEN
            OUTPUT(1:) = 'descriptor '//DISCR(1:DSCLEN)//
     +                   ' not present... '
            CALL STTPUT(OUTPUT,STAT)
         ENDIF
         GOTO 8000
      ENDIF
C 
      IJK(1) = 1
      STAT = 0
      XLONG = 0
      IF (NOELEM.GT.65535) THEN
         XLONG = NOELEM - 65535
         NOELEM = 65535                   !ojo: synchronize with MAIN ...
      ENDIF
C
C  get integer data
700   IF (TYPE.EQ.'I') THEN
         ITY = 1
         IF (FLAG(1:1).NE.'S') CALL STDRDI
     +   (IMNO,DISCR,EL1,NOELEM,IAV,IVALS,UNIT,NULLO,STAT)
C
C  get real data
      ELSE IF (TYPE.EQ.'R') THEN
         ITY = 2
         IF (FLAG(1:1).NE.'S') CALL STDRDR
     +   (IMNO,DISCR,EL1,NOELEM,IAV,RVALS,UNIT,NULLO,STAT)
C
C  get character data
      ELSE IF (TYPE.EQ.'C') THEN
         IF (BYTELM.GT.1) THEN
            ITY = 5
            WRITE(CTYPE,30000) BYTELM
C                                                     omit leading blanks...
            DO 800 LL=1,3
               IF (CTYPE(LL:LL).NE.' ') GOTO 1000
800         CONTINUE
            LL = 4
1000        CHTYP(11:) = CTYPE(LL:)
            IF (FLAG(1:1).NE.'S')
     +         CALL STDRDC(IMNO,DISCR,BYTELM,EL1,NOELEM,
     +                     IAV,CVALS,UNIT,NULLO,STAT)
         ELSE
            ITY = 3
            IF (FLAG(1:1).NE.'S')
     +         CALL STDRDC(IMNO,DISCR,1,EL1,NOELEM,
     +                     IAV,CVALS,UNIT,NULLO,STAT)
         ENDIF
C
C  get double prec. data
      ELSE IF (TYPE.EQ.'D') THEN
         ITY = 4
         IF (FLAG(1:1).NE.'S') 
     +      CALL STDRDD(IMNO,DISCR,EL1,NOELEM,
     +                  IAV,DVALS,UNIT,NULLO,STAT)
C
C  get size_t data (as I*4 or I*8)
      ELSE IF (TYPE.EQ.'S') THEN
         ITY = 7
         IF (FLAG(1:1).NE.'S') 
     +      CALL STDRDS(IMNO,DISCR,EL1,NOELEM,
     +                  IAV,SVALS,UNIT,NULLO,STAT)
C
C  get logical data
      ELSE IF (TYPE.EQ.'L') THEN
         ITY = 6
         IF (FLAG(1:1).NE.'S') 
     +      CALL STDRDL(IMNO,DISCR,EL1,NOELEM,
     +                  IAV,IVALS,UNIT,NULLO,STAT)
      ENDIF
C 
C  return, if problems with reading descriptors
      IF (STAT.NE.0) THEN
         WRITE(OUTPUT,10000) DISCR(1:DSCLEN)
         CALL STTPUT(OUTPUT,STAT)
         GOTO 8000
      ENDIF
C
C  fill header line
      IF (ITY.NE.5) THEN
         IJK(2) = ITY
         CCC = CC(ITY)
      ELSE
         IJK(2) = 3
         CCC = CHTYP
      ENDIF
C
C  display header line - except for display_flag = H or B
      IF (FLAG(2:2).EQ.'H') THEN
         IF (FLAG(1:1) .EQ. 'S') THEN 
            GOTO 8000                !nothing to do for SHOW/DESCR
         ELSE
            GOTO (5500,5600,5700,5800,5700,5900),ITY      !only display data
         ENDIF
C 
      ELSE IF (FLAG(2:2).NE.'B') THEN
         IF (DSCLEN .LE. 15) THEN
            WRITE(OUTPUT,10001) DISCR(1:15)        !help text begins at 15
         ELSE
            WRITE(OUTPUT,10001) DISCR(1:DSCLEN)
         ENDIF
         MM = INDEX(OUTPUT,'( ') + 1               !find end of text
         IF (MM .GT. 72) THEN
            OUTPUT(MM-1:) = '    '
            CALL STTPUT(OUTPUT,STAT)
            OUTPUT(1:) = '( '
            MM = 2
         ENDIF
         LL = 77 - MM                              !LL = 53 for short descr
C 
         CALL STDRDH(IMNO,DISCR,1,72,IAV,CBUF,HNC,STAT)
         IF (HNC.GT.0) THEN                     !Yes, there is help
            DO 1600, M=IAV,1,-1                 !get rid of trailing blanks
               IF (CBUF(M:M) .NE. ' ') THEN
                  IAV = M
                  GOTO 1660
               ENDIF
1600        CONTINUE
1660        IF (IAV.GT.LL) THEN
               OUTPUT(MM-1:) = '    '
               CALL STTPUT(OUTPUT,STAT)         !print name on one line
               OUTPUT(1:) = '( '                !help text on next line
               MM = 2
            ENDIF
            OUTPUT(MM:) = CBUF(1:IAV)//') '
         ELSE
            OUTPUT(MM:) = '...) '
         ENDIF
         DSCNO(2) = HNC                         !save size of help text
         CALL STTPUT(OUTPUT,STAT)
C 
         IF (FLAG(1:1).EQ.'S') THEN                !SHOW/DESCR
            WRITE(OUTPUT,10004) CCC,(XLONG+NOELEM)
            CALL STTPUT(OUTPUT,STAT)
            GOTO 8000
         ELSE                                      !READ/DESCR
            IF (NOELEM .GT. 99999) THEN
               WRITE(OUTPUT,10004) CCC,NOELEM
            ELSE
               WRITE(OUTPUT,10005) CCC,NOELEM
            ENDIF
            CALL STTPUT(OUTPUT,STAT)
C
            GOTO (5500,5600,5700,5800,5700,5900,6000),ITY
         ENDIF
      ELSE
C
C  short display
         IF ((TYPE.EQ.'C') .AND.
     +       (DISCR(1:6).EQ.'IDENT ')) THEN        !truncate IDENT
            MM = 0
            LL = MIN(NOELEM,72)
            DO 3000, M=LL,1,-1
               IF (CVALS(M:M).NE.' ') THEN
                  MM = M                           !mark last char.
                  GOTO 3050
               ENDIF
3000        CONTINUE
3050        IF (MM.EQ.0) THEN                      !only blanks
               NOELEM = 1
            ELSE
               NOELEM = MM
            ENDIF
         ENDIF
C
         DISCR(DSCLEN+1:) = ': '
         IF ( (DSCLEN .GT. 15) .OR.
     +        (NOELEM.GT.LIM(ITY)) .OR.
     +        (ITY.EQ.5) ) THEN
             CALL STTPUT(DISCR,STAT)
             GOTO (5500,5600,5700,5800,5700,5900,6000),ITY
         ELSE                                      !brief display
             GOTO (5550,5650,5790,5850,5790,5950,6050),ITY
         ENDIF
      ENDIF
C
C here the output of the descr. values
C 
5500  DO 5510, M=1,NOELEM,8
         MM = MIN(NOELEM,M+7)
         WRITE(OUTPUT,10002) (IVALS(L),L=M,MM)
         CALL STTPUT(OUTPUT,STAT)
5510  CONTINUE
      GOTO 7700
C
5550  WRITE(OUTPUT,10002) (IVALS(L),L=1,NOELEM)
      LL = NOELEM*10
      CBUF(1:) = DISCR(1:17)//OUTPUT(1:LL)//' '
      CALL STTPUT(CBUF,STAT)
      GOTO 7700
C
5600  DO 5610, M=1,NOELEM,5
         MM = MIN(NOELEM,M+4)
         WRITE(OUTPUT,20002) (RVALS(L),L=M,MM)
         CALL STTPUT(OUTPUT,STAT)
5610  CONTINUE
      GOTO 7700
C
5650  WRITE(OUTPUT,20002) (RVALS(L),L=1,NOELEM)
      LL = NOELEM*15
      CBUF(1:) = DISCR(1:17)//OUTPUT(1:LL)//' '
      CALL STTPUT(CBUF,STAT)
      GOTO 7700
C
C  character data has to be treated specially
5700  IF (BYTELM.GT.1) THEN
         LL = 1
         MM = BYTELM
         DO 5720, L=1,NOELEM
            DO 5710, IOFF=LL,MM,80
               M = IOFF + 79
               IF (M.GT.MM) M = MM
               OUTPUT(1:) = CVALS(IOFF:M)//' '
               CALL STTPUT(OUTPUT,STAT)
5710        CONTINUE
            LL = LL + BYTELM
            MM = MM + BYTELM
5720     CONTINUE
      ELSE
C 
         M = 1                            !chop up in pieces of 80 chars
5730     MM = M + 79
         IF (MM.GE.NOELEM) THEN
            KCASE = 0                     !indicate that we reached the end
            MM = NOELEM
         ELSE
            KCASE = 1
         ENDIF
C
         OUTPUT(1:) = CVALS(M:MM)//' '
5750     CALL STTPUT(OUTPUT,STAT)
5760     IF (KCASE.EQ.1) THEN
            M = MM + 1                     !move to after current end
            IF (M.LE.NOELEM) GOTO 5730
         ENDIF
      ENDIF
      GOTO 7700
C
5790  OUTPUT(1:) = DISCR(1:17)//CVALS(1:NOELEM)//' '
      CALL STTPUT(OUTPUT,STAT)
      GOTO 7700
C
5800  DO 5810, M=1,NOELEM,3
         MM = MIN(NOELEM,M+2)
         WRITE(OUTPUT,20003) (DVALS(L),L=M,MM)
         CALL STTPUT(OUTPUT,STAT)
5810  CONTINUE
      GOTO 7700
C
5850  WRITE(OUTPUT,20004) (DVALS(L),L=1,NOELEM)
      LL = NOELEM*24
      CBUF(1:) = DISCR(1:17)//OUTPUT(1:LL)//' '
      CALL STTPUT(CBUF,STAT)
      GOTO 7700
C 
5900  DO 5910, M=1,NOELEM,8
         MM = MIN(NOELEM,M+7)
         WRITE(OUTPUT,10002) (IVALS(L),L=M,MM)
         CALL STTPUT(OUTPUT,STAT)
5910  CONTINUE
      GOTO 7700
C
5950  WRITE(OUTPUT,10002) (IVALS(L),L=1,NOELEM)
      LL = NOELEM*10
      CBUF(1:) = DISCR(1:17)//OUTPUT(1:LL)//' '
      CALL STTPUT(CBUF,STAT)
      GOTO 7700
C
6000  DO 6010, M=1,NOELEM,3
         MM = MIN(NOELEM,M+2)
         WRITE(OUTPUT,30003) (SVALS(L),L=M,MM)
         CALL STTPUT(OUTPUT,STAT)
6010  CONTINUE
      GOTO 7700
C
6050  WRITE(OUTPUT,30004) (SVALS(L),L=1,NOELEM)
      LL = NOELEM*12
      CBUF(1:) = DISCR(1:17)//OUTPUT(1:LL)//' '
      CALL STTPUT(CBUF,STAT)
      GOTO 7700
C 
7700  IF (XLONG.GT.0) THEN
         EL1 = EL1 + 65535
         IF (XLONG.LE.65535) NOELEM = XLONG
         XLONG = XLONG - 65535
         DISCR(DSCLEN+1:) = '  '             !remove ':' again
         GOTO 700
      ENDIF
C
C  increment counter + loop if there are more descriptors
C 
8000  DISCR(1:) = ' '
      IF (OPTIO.NE.0) THEN
         CALL STDRDX(IMNO,10,DISCR,DSCTYP,BYTELM,NOELEM,HNC,STAT)
         IF (DISCR(1:1).NE.' ') THEN
            DSCNO(1) = DSCNO(1) + 1
            GOTO 500
         ENDIF
      ENDIF
C
9000  IF (OPTIO.EQ.0) THEN                   !single descriptor
         IF (IJK(1).EQ.1) THEN
            IJK(3) = NOELEM
            IJK(4) = BYTELM
            IJK(5) = DSCNO(2)
         ENDIF
         CALL STKWRI('OUTPUTI',IJK,1,5,UNIT,STAT) 
      ELSE   
         IF (OPTIO.EQ.1) THEN                !all descr's
            DSCNO(1) = DSCNO(1) - 1          !avoid descr. directory itself
         ELSE 
            DSCNO(1) = NPT
         ENDIF
         WRITE(OUTPUT,40000) DSCNO(1)
         CALL STTPUT(OUTPUT,STAT)
         CALL STKWRI('OUTPUTI',DSCNO,1,1,UNIT,STAT) 
      ENDIF
C
C  That's it folks ...
      RETURN
C
C  formats
10000 FORMAT('Problems reading descriptor: ',A)
10001 FORMAT('name: ',A,' ( ')
10002 FORMAT(8I10)
10004 FORMAT('type: ',A,'  no. of elements:',I8)
10005 FORMAT('type: ',A,'  no. of elements:',I5)
20002 FORMAT(5G15.7)
20003 FORMAT(3G24.14)
20004 FORMAT(2G24.14)
30000 FORMAT(I4)
30003 FORMAT(3I12)
30004 FORMAT(2I12)
33000 FORMAT('Descriptor directory: total length =',I8,
     +       '   => no. of decriptors =',I6)   
40000 FORMAT('total no. of descriptors:',I6)
      END

      SUBROUTINE DTCHK(INTYP,OUTTYP,BYTELM,MAXNO)
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine DTCHK			version 1.50	841114
C  K. Banse 				ESO - Garching
C  1.60	    860226	1.70	871027		1.80	900215
C
C.KEYWORDS
C  keyword data base
C
C.PURPOSE
C  check given data type + return cleaned type and no. of bytes per element
C
C.ALGORITHM
C  straight forward
C
C.INPUT/OUTPUT
C  call as DTCHK(INTYP,OUTTYP,BYTELM,MAXNO)
C
C  input par:
C  INTYP:	char.exp.	type of keyword/descr
C
C  output par:
C  OUTTYP:	char*1		type of keyword/descr
C				currently I,R,C,D,H, L are recognized for
C				I*4,R*4,CHAR*n,R*8 or Double or HELP
C				set to ' ', if invalid INTYP given
C  BYTELM:	I*4		no. of bytes per element of keyword/descr data
C  MAXNO:	I*4 		max. no. of elements which can be written
C				(= size of internal buffer)
C
C.VERSIONS
C  1.60		also allow LOGICAL*4 type - will be converted to I*4
C  1.70		add output par. MAXNO
C
C----------------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      BYTELM
      INTEGER      LL,MAXNO
      INTEGER      LIMES(3)
C 
      REAL  RR
C 
      DOUBLE PRECISION  DD
C
      CHARACTER*(*)  INTYP
      CHARACTER      OUTTYP*1,TEST*1
C
      DATA   LIMES /65535,65535,65535/
C                                   
      MAXNO = 0                        !default to no_success ...
      OUTTYP = ' '
      CALL UPCAS(INTYP(1:1),TEST)
C
C  first look for type CHAR*len
      IF (TEST.EQ.'C') THEN
         LL = INDEX(INTYP,'*')
         IF (LL.LE.0) THEN
            BYTELM = 1
            OUTTYP = 'C'
         ELSE
            CALL GENCNV(INTYP(LL+1:),1,1,BYTELM,RR,DD,LL)
            IF (LL.GT.0) OUTTYP = 'C'
         ENDIF
         MAXNO = LIMES(3) / BYTELM
C
C  then for integer, real + double precision
      ELSE IF (TEST.EQ.'I') THEN
         BYTELM = 4
         OUTTYP = 'I'
         MAXNO = LIMES(2)
      ELSE IF (TEST.EQ.'R') THEN
         IF (INDEX(INTYP,'*8').GT.0) THEN
            BYTELM = 8
            OUTTYP = 'D'
            MAXNO = LIMES(1)
         ELSE
            BYTELM = 4
            OUTTYP = 'R'
            MAXNO = LIMES(2)
         ENDIF
      ELSE IF (TEST.EQ.'D') THEN
         BYTELM = 8
         OUTTYP = 'D'
         MAXNO = LIMES(1)
      ELSE IF (TEST.EQ.'H') THEN
         BYTELM = 1
         OUTTYP = 'H'
         MAXNO = LIMES(2)
      ELSE IF (TEST.EQ.'L') THEN
         BYTELM = 4
         OUTTYP = 'L'
         MAXNO = LIMES(2)
      ENDIF
C
C OUTTYP only set, if correct type was entered
      RETURN
      END

      SUBROUTINE PATTST(FLAG,STR,STAT)
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine PATTST		version 1.0	980421
C  K. Banse			ESO - Garching
C
C.KEYWORDS
C  pattern matching
C
C.PURPOSE
C  check if descriptor name matches a given pattern
C
C.ALGORITHM
C  straight forward
C  support two patterns patternA, patternB
C
C.INPUT/OUTPUT
C  call as  PATTST(FLAG,STR,STAT)
C
C  input par:
C  FLAG:	I*4		flag = 1 (11), for saving patternA/B
C  				     = 2 (12), for checking patternA/B
C				< 10 for patternA, > 10 for patternB
C  STR:		char.exp.	pattern string (FLAG=1,11)
C				descr. name (FLAG=2,12)
C
C  output par:
C  STAT:	I*4		= 1, if matching, else = 0
C
C.VERSIONS
C  see SCCS
C
C----------------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER    FLAG,STAT
      INTEGER    N,M
      INTEGER    IPT,IPTA,PATFLG
      INTEGER    JPT,JPTA,QATFLG
C 
      CHARACTER*(*) STR
      CHARACTER  PATTRN*80,PATTRA*80
      CHARACTER  QATTRN*80,QATTRA*80
C 
      SAVE       PATTRN,PATTRA
      SAVE       QATTRN,QATTRA
      SAVE       PATFLG,IPT,IPTA
      SAVE       QATFLG,JPT,JPTA

C 
      STAT = 0
      IF (FLAG.LT.10) THEN
         IF (FLAG.EQ.1) THEN
C 
C extract pattern for patternA
C 
            M = INDEX(STR,' ') - 1              !real length
            IF (M.LT.1) M = LEN(STR)
C 
            N = INDEX(STR,'*')
            IF (N.EQ.1) THEN
               IF (STR(M:M).EQ.'*') THEN  
                  PATTRN(1:) = STR(2:M-1)//' '
                  IPT = M - 2
                  PATFLG = 4                    ! = 4, for checking *pattern*
               ELSE
                  PATTRN(1:) = STR(2:)//' '      
                  IPT = INDEX(PATTRN,' ') - 1
                  IF (IPT.LT.1) IPT = LEN(PATTRN)
                  PATFLG = 1                    ! = 1, for checking *pattern
               ENDIF
            ELSE
               IF ((M.EQ.N) .OR. (STR(N+1:N+1).EQ.' ')) THEN
                  IPT = N - 1
                  PATTRN(1:) = STR(1:IPT)//' '       
                  PATFLG = 2                    ! = 2, for checking pattern*
               ELSE
                  PATTRN(1:) = STR(1:N-1)//' '
                  IPT = INDEX(PATTRN,' ') - 1
                  IF (IPT.LT.1) IPT = LEN(PATTRN)
                  PATTRA(1:) = STR(N+1:)//' '
                  IPTA = INDEX(PATTRA,' ') - 1
                  IF (IPTA.LT.1) IPTA = LEN(PATTRA)
                  PATFLG = 3                 ! = 3, for checking pattr1*pattr2
               ENDIF
            ENDIF
C 
C match patternA
C 
         ELSE
            N = INDEX(STR,' ') - 1
            IF (N.LT.1) N = LEN(STR)
C 
            IF (PATFLG.EQ.1) THEN                            !*pattern
               IF (N.GE.IPT) THEN
                  M = N - IPT + 1
                  IF (STR(M:N).EQ.PATTRN(1:IPT)) STAT = 1
               ENDIF
            ELSE IF (PATFLG.EQ.2) THEN                       !pattern*
               IF (STR(1:IPT).EQ.PATTRN(1:IPT)) STAT = 1
            ELSE IF (PATFLG.EQ.3) THEN                       !pattr1*pattr2
               IF (N.GE.(IPT+IPTA)) THEN
                  M = N - IPTA + 1
                  IF ((STR(1:IPT).EQ.PATTRN(1:IPT)) .AND.
     +                (STR(M:N).EQ.PATTRA(1:IPTA))) STAT = 1
               ENDIF
            ELSE                                             !*pattern*
               IF (INDEX(STR,PATTRN(1:IPT)).GT.0) STAT = 1
            ENDIF
         ENDIF
C 
      ELSE
         IF (FLAG.EQ.11) THEN
C
C extract pattern for patternB
C
            M = INDEX(STR,' ') - 1              !real length
            IF (M.LT.1) M = LEN(STR)
C
            N = INDEX(STR,'*')
            IF (N.EQ.1) THEN
               IF (STR(M:M).EQ.'*') THEN 
                  QATTRN(1:) = STR(2:M-1)//' '
                  JPT = M - 2
                  QATFLG = 4                    ! = 4, for checking *pattern*
               ELSE
                  QATTRN(1:) = STR(2:)//' '
                  JPT = INDEX(QATTRN,' ') - 1
                  IF (JPT.LT.1) JPT = LEN(QATTRN)
                  QATFLG = 1                    ! = 1, for checking *pattern
               ENDIF
            ELSE
               IF ((M.EQ.N) .OR. (STR(N+1:N+1).EQ.' ')) THEN
                  JPT = N - 1
                  QATTRN(1:) = STR(1:JPT)//' '      
                  QATFLG = 2                    ! = 2, for checking pattern*
               ELSE
                  QATTRN(1:) = STR(1:N-1)//' '
                  JPT = INDEX(QATTRN,' ') - 1
                  IF (JPT.LT.1) JPT = LEN(QATTRN)
                  QATTRA(1:) = STR(N+1:)//' '
                  JPTA = INDEX(QATTRA,' ') - 1
                  IF (JPTA.LT.1) JPTA = LEN(QATTRA)
                  QATFLG = 3                 ! = 3, for checking pattr1*pattr2
               ENDIF
            ENDIF
C
C match patternB
C
         ELSE
            N = INDEX(STR,' ') - 1
            IF (N.LT.1) N = LEN(STR)
C
            IF (QATFLG.EQ.1) THEN                            !*pattern
               IF (N.GE.JPT) THEN
                  M = N - JPT + 1
                  IF (STR(M:N).EQ.QATTRN(1:JPT)) STAT = 1
               ENDIF
            ELSE IF (QATFLG.EQ.2) THEN                       !pattern*
               IF (STR(1:JPT).EQ.QATTRN(1:JPT)) STAT = 1
            ELSE IF (QATFLG.EQ.3) THEN                       !pattr1*pattr2
               IF (N.GE.(JPT+JPTA)) THEN
                  M = N - JPTA + 1
                  IF ((STR(1:JPT).EQ.QATTRN(1:JPT)) .AND.
     +                (STR(M:N).EQ.QATTRA(1:JPTA))) STAT = 1
               ENDIF
            ELSE                                             !*pattern*
               IF (INDEX(STR,QATTRN(1:JPT)).GT.0) STAT = 1
            ENDIF
         ENDIF
      ENDIF
C 
      RETURN
      END

      SUBROUTINE DSCDEL(IMNO,INDSC,DELCNT)
C
C+++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine DSCDEL                    990114
C  K. Banse                             ESO - Garching
C
C.KEYWORDS
C  descriptors
C
C.PURPOSE
C  delete descriptors matching a pattern
C
C.ALGORITHM
C  read all existing descriptors + delete if pattern match
C
C.INPUT/OUTPUT
C  call as DSCDEL(IMNO,INDSC,DELCNT)
C
C input:
C  IMNO:      I*4         frame no. of data frame
C  INDSC:     char.exp.   pattern of descriptors to be deleted
C output:
C  DELCNT:    I*4         no. of deleted descriptors
C
C-------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      IMNO,DELCNT,HNC
      INTEGER      STAT,NOELEM,BYTELM
C 
      CHARACTER*(*)  INDSC
      CHARACTER      DISCR*80,DSCTYP*24
C 
      DISCR(1:) = ' '
      CALL UPCAS(INDSC,DISCR)
      CALL PATTST(1,DISCR,STAT)                !store the pattern(s)
      DELCNT = 0
C
      CALL STDRDX(IMNO,1,DISCR,DSCTYP,BYTELM,NOELEM,HNC,STAT)
      CALL STDRDX(IMNO,10,DISCR,DSCTYP,BYTELM,NOELEM,HNC,STAT)   !skip dscdir
C
C  loop through descr. list
500   DISCR(1:) = ' '
      CALL STDRDX(IMNO,10,DISCR,DSCTYP,BYTELM,NOELEM,HNC,STAT)
      IF (DISCR(1:1).EQ.' ') RETURN
C
C  increment counter + loop if there are more descriptors
      CALL PATTST(2,DISCR,STAT)
      IF (STAT.NE.0) THEN    
         DELCNT = DELCNT + 1                   !matching descr. found
         CALL STDDEL(IMNO,DISCR,STAT)
      ENDIF
      GOTO 500                                 !look for more
C
      END
 

C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION        ISDHED.FOR
C.AUTHOR:               J.D.PONZ  ESA-VILSPA        
C.KEYWORDS              IUE, GO FORMAT, FILE HEADER
C.ENVIRONMENT           VMS
C.PURPOSE
C \begin{TeX}
C  Reads the first record of the IUE GO file header
C  to find file characteristics.
C  The record is converted into ASCII and stored in a buffer for later
C  usage.
C
C  The routine performs the following functions (routine names in brackets)
C \begin{enumerate}
C  \item Reads first record (ISDREA)
C  \item Translates EBCDIC into ASCII 
C  \item Decodes Camera number, Dispersion, Number of bytes per record in the
C     data matrix and Number of records in the data matrix
C  \item Computes the file type as:
C       \begin{itemize}
C        \item 0 = FES, 
C        \item 1 = RAW, 
C        \item 2 = PHOTOM, 
C        \item 3 = (E)LBL, 
C        \item 4 = MELO, 
C        \item 5 = MEHI
C       \end{itemize}
C  \end{enumerate}
C  \end{TeX}
C.LANGUAGE              F77 
C.COMMENTS
C \begin{TeX}
C The following extensions are used:
C   \begin{itemize}
C    \item IMPLICIT NONE
C    \item INCLUDE statement
C    \item long variable names
C    \item underscore character
C   \end{itemize}
C \end{TeX}
C.VERSION: 1.0  INITIAL CODING  24 JUN 1994
C------------------------------------------------------------------
      SUBROUTINE ISDHED(CHANL,BUFF,CAMERA,IMANUM,APERTU,DISPER,
     .                  FTYPE,NRECO,NBYTE,IOFF,STATUS)
C
      IMPLICIT NONE
      INTEGER       CHANL             ! IN: tape channel number
      CHARACTER*(*) BUFF              ! OUT: buffer with the ascii header
      INTEGER       CAMERA            ! OUT: camera code number
      INTEGER       IMANUM            ! OUT: image number
      INTEGER       APERTU            ! OUT: LAP-SAP code
      INTEGER       DISPER            ! OUT: dispersion code
      INTEGER       FTYPE             ! OUT: file type
      INTEGER       NRECO             ! OUT: number of lines
      INTEGER       NBYTE             ! OUT: number of bytes per line
      INTEGER       IOFF
      INTEGER       STATUS            ! OUT: status
C
      INTEGER ISTAT, LEN, LABLEN, I1, I2, I3, I
      CHARACTER*78   LINE
      CHARACTER*360 CBUFF
C
      STATUS = 0
      LABLEN = 360
      APERTU = 0
      IOFF   = 0
      CALL ISDREC(CHANL,CBUFF,LABLEN,LEN,IOFF,STATUS)
      IF (STATUS.NE.0) RETURN
      IF (LEN.NE.LABLEN) THEN
          CALL STTPUT('*** Not an IUE GO format ***',ISTAT)
          STATUS = 1
          RETURN
      ENDIF
C
C ... check record offset 
C
      DO I = 0, 4, 2
         I1 =   72 + I
         I2 = 2*72 + I
         I3 = 3*72 + I
         IF (CBUFF(I1:I1).EQ.'C'.AND.CBUFF(I2:I2).EQ.'C'
     .       .AND.CBUFF(I3:I3).EQ.'C') GOTO 10
      ENDDO
      CALL STTPUT('*** Error: File is not in GO format ***',ISTAT)
      STATUS = 1
      RETURN
10    IOFF = I
C
C ... start over again
C
      CALL ISDREW(CHANL, ISTAT)
      CALL ISDREC(CHANL,CBUFF,LABLEN,LEN,IOFF,STATUS)
      BUFF = CBUFF
      READ(BUFF(33:36),1000,ERR=999) NRECO       ! decode number of lines
      READ(BUFF(37:40),1000,ERR=999) NBYTE       ! decode number of bytes/line
      READ(BUFF(50:50),1001,ERR=999) CAMERA      ! decode camera number
      READ(BUFF(51:51),1001,ERR=999) DISPER      ! decode dispersion
      READ(BUFF(52:56),1002,ERR=999) IMANUM      ! decode image number
      IF ((NRECO.EQ.113 .AND. NBYTE.EQ.113) .OR.      ! ERES (VILSPA std)     
     .    (NRECO.EQ. 81 .AND. NBYTE.EQ. 81) .OR.      ! DRES (Default)
     .    (NRECO.EQ.127 .AND. NBYTE.EQ.127) .OR.      ! FRES (Full field)
     .    (NRECO.EQ.  7 .AND. NBYTE.EQ.  7))  THEN    ! PRES (Postage)
           FTYPE = 0                               ! FES 
      ELSEIF (NRECO.EQ.768 .AND. NBYTE.EQ.768) THEN
           FTYPE = 1                               ! RAW 
      ELSEIF (NRECO.EQ.768 .AND. NBYTE.EQ.1536) THEN
           FTYPE = 2                               ! PHOTOM
      ELSEIF ( (NRECO.EQ.166 .OR. NRECO.EQ.331) .AND. 
     .        (NBYTE.EQ.2048 .OR. NBYTE.EQ.1204) ) THEN
           FTYPE = 3                               ! (E)LBL 
      ELSEIF ( NRECO.EQ.7 ) THEN
           FTYPE = 4                               ! LOW 
      ELSEIF ( NRECO.EQ.325 .OR. NRECO.EQ.361 .OR.
     .         NRECO.EQ.379 .OR. NRECO.EQ.421 ) THEN
           FTYPE = 5                               ! HIGH
      ELSE
           WRITE(LINE,2000) NRECO,NBYTE,CAMERA,IMANUM
           CALL STTPUT(LINE,ISTAT)
           CALL STTPUT('*** Error in file type ***',ISTAT)
           STATUS = 2
C
      ENDIF 
      RETURN
 999  CONTINUE
      CALL STTPUT('*** Error decoding the header info ***',ISTAT)
      CALL STTPUT('*** File is not in GO format ***',ISTAT)
      STATUS = 1
      RETURN
 1000 FORMAT(I4)
 1001 FORMAT(I1)
 1002 FORMAT(I5)
 2000 FORMAT(' NREC:',I5,' NBYTE:',I5,' CAMERA:',I1,'IMAGE:',I6)
      END

C===========================================================================
C Copyright (C) 1995-2011 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION: CENTERROW
C.PURPOSE:        Interactive line centering. output stored in a table
C.LANGUAGE:       F77+ESOext
C.AUTHOR:         J.D.Ponz
C.KEYWORDS:       Line, centre
C.ALGORITHM:      Line center is found by:
C                 maximum/minimum - position of the maximum/minimum value
C                 gaussian        - center of the fitted gaussian
C                 gravity         - gravity center of the 2 highest pixels
C                                   with respect to the third one
C.INPUT/OUTPUT:   Interactive input via the graphics cursor
C                 table columns :
C                 :XSTART - first cursor input
C                 :XEND   - second cursor input
C                 :XCEN   - computed center
C                 :YSTART - image value for first cursor input
C                 :YEND   - image value for second cursor input
C                 :PEAK   - maximum value
C                 :YFIT   - fitted maximum in gaussian method only
C                 :FWHM   - fwhm in gaussian method only
C 
C.OJO:	to increase the size of the interval, increment all the
C arrays which currently have dimension = 2048 (031112)
C SW1, SW2, W1, W2, WEIGHT
C 
C.VERSION: 840328  JDP  Creation   
C.VERSION: 880703  RHW  ESO-FORTRAN Conversion 
C.VERSION: 900430  RHW  Change to standard graphic interfaces 
C 
C 110629	last modif
C-----------------------------------------------------------------
C 
      PROGRAM   SPCNTR

      IMPLICIT  NONE

      INTEGER   MADRID
      INTEGER   I1,I2,IAC,IACT,IAV,IFAIL,II,II1,IMETH,NPTS
      INTEGER   IMODE,IPL1,IPL2,ISEQ,ISORT,ISTAT
      INTEGER   L,NAXIS,NCOLS,NCOUNT,NNCOL,NPL,NL
      INTEGER   NVAL, NSIZE(2)
      INTEGER   IMNOI, IMNOT, IMNOW
      INTEGER   IMAGE(4)
      INTEGER   NPIX(3),NN, INP
      INTEGER   KEY
      INTEGER   APPFLG
      INTEGER   STATUS,IC(8)
      INTEGER   KUN, KNUL, TID,ACOL, AROW
      INTEGER   ACCESS, PLMODE
      INTEGER   LTYPE, STYPE, BIN

      INTEGER*8 PNTRI, PNTRW, PNTRT

      REAL      SXY,X1,X2,XYS,YOFF
      REAL      XCUR,YCUR,RRBUF(5)
      REAL      RMAGE(4), SVALUE(8), SW1(2048), SW2(2048)

      DOUBLE PRECISION VALUE(8),W1(2048),W2(2048),ACOE(4)
      DOUBLE PRECISION START(3),STEP(3)
      DOUBLE PRECISION DXYS, DSXY

      CHARACTER NAME*60,INFO*60,METH*2
      CHARACTER TABLE*64,TABU(8)*16,TABL(8)*16,IEA*1
      CHARACTER CLINE*72,HEAD1*72,HEAD2*72,FORM(8)*6,PROMPT*72,IAPP*1
      CHARACTER IDENT*72,CUNIT*48,COML*80

      INCLUDE   'MID_INCLUDE:ST_DEF.INC/NOLIST' 
      COMMON    /VMR/MADRID(1)
      INCLUDE   'MID_INCLUDE:ST_DAT.INC/NOLIST' 
C
      DATA      NCOLS/6/
      DATA      STYPE/5/
      DATA      BIN/0/
      DATA      YOFF/0.0/
      DATA      ACCESS/1/
      DATA      PLMODE/-1/
      DATA      NPIX/1,1,1/, STEP/1.0,1.0,1.0/, START/0.0,0.0,0.0/

      DATA      TABU/' ',' ',' ',' ',' ',' ',' ',' '/
      DATA      TABL/'START','END','CENTER','INT_START','INT_END',
     +               'INT_PEAK','INT_FIT','FWHM'/
      DATA      FORM/'F10.3','F10.3','F10.3','G15.5','G15.5','G15.5',
     +               'G15.5','F10.3'/
      DATA      HEAD1/
     +  '     start         end        center     pixel_value    FWHM'/
      DATA      HEAD2/
     +  '     start         end        center     pixel_value'/
      DATA      PROMPT/' Ready for cursor input ...'/
C
C
      CALL STSPRO('CLINE')                                       !  initialize
      CALL STKRDC('PLCDATA',1,1,60,IACT,INFO,KUN,KNUL,STATUS)
      L      = INDEX(INFO//' ',' ') - 1
      NAME  = INFO(1:L)
C
      CALL STKRDC('P3',1,1,1,IACT,IEA,KUN,KNUL,STATUS)
      CALL UPCAS(IEA,IEA)
      IF (IEA.EQ.'E') THEN
         IMODE  = 1
      ELSE
         IMODE  = 0
      END IF
C
      CALL STKRDC('MID$CMND',1,1,80,IACT,COML,KUN,KNUL,STATUS)
      METH   = COML(11:12)
      IF (METH.EQ.'GA') THEN
         IMETH  = -1
         NCOLS  = 8
      ELSE
         IF (METH.EQ.'GR') THEN
            IMETH  = 0
         ELSE
            IMETH  = 1
         END IF
      END IF
C
      CALL STKRDC('P4',1,1,1,IACT,IAPP,KUN,KNUL,STATUS)
      CALL UPCAS(IAPP,IAPP)
      IF (IAPP.EQ.'A') THEN
         APPFLG = 1
      ELSE
         APPFLG = 0
      END IF
      ISEQ   = 0
C
C *** read image
      CALL STFOPN(NAME,D_R4_FORMAT,0,F_IMA_TYPE,IMNOI,ISTAT)
      CALL STDRDI(IMNOI,'NAXIS',1,1,IAC,NAXIS,KUN,KNUL,ISTAT)
      CALL STDRDI(IMNOI,'NPIX',1,NAXIS,IAC,NPIX,KUN,KNUL,ISTAT)
      CALL STDRDD(IMNOI,'START',1,NAXIS,IAC,START,KUN,KNUL,ISTAT)
      CALL STDRDD(IMNOI,'STEP',1,NAXIS,IAC,STEP,KUN,KNUL,ISTAT)
      CALL STDRDC(IMNOI,'IDENT',1,1,72,IAC,IDENT,KUN,KNUL,ISTAT)
      CALL STDRDC(IMNOI,'CUNIT',1,1,64,IAC,CUNIT,KUN,KNUL,ISTAT)
C
      NPL     = NPIX(1)
      NL      = NPIX(2)
      II1     = 16*NAXIS
      NVAL    = NPIX(2)
C
C *** allocate virtual memory for a single line of the frame
      CALL PTKRDR('PIXEL',4,IAC,RMAGE)
CC above call = CALL STKRDR('PLRGRAP',25,4,IAV,RMAGE,KUN,KNUL,ISTAT)
      IMAGE(1) = RMAGE(1)
      IMAGE(2) = RMAGE(2)
      IMAGE(3) = RMAGE(3)
      IMAGE(4) = RMAGE(4)
      IF (IMAGE(3).EQ.IMAGE(4)) THEN
         II = (IMAGE(3)-1)*NPL + 1
         CALL STFMAP(IMNOI,F_I_MODE,II,NPL,IAC,PNTRW,ISTAT)
         SXY  = STEP(1)
         XYS  = START(1)
         DSXY = STEP(1)
         DXYS = START(1)
      ELSE
C                                                        ! here for the columns
         NN = NPIX(1)*NPIX(2)   
         CALL STFMAP(IMNOI,F_I_MODE,1,NN,IAC,PNTRI,ISTAT)
         CALL STFCRE('MIDTRAN',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +               NN,IMNOT,ISTAT)
         CALL STFMAP(IMNOT,F_X_MODE,1,NN,IAV,PNTRT,ISTAT)
         NSIZE(1) = 128
         NSIZE(2) = 256
         CALL LINCOL(MADRID(PNTRI),NPIX,NSIZE,MADRID(PNTRT))  ! transpose frame
         CALL STFUNM(IMNOI,ISTAT)
C
         IF (NVAL.LT.512) NVAL = 512
         CALL STFCRE('PLOTWORK', D_R4_FORMAT,F_X_MODE, F_IMA_TYPE,
     +               NVAL,IMNOW,ISTAT)                   ! create scratch frame	
         CALL STFMAP(IMNOW,F_X_MODE,1,NVAL,IAC,PNTRW,ISTAT)
         II = (IMAGE(1)-1)*NL
         PNTRT = PNTRT + II
         CALL COPYF(MADRID(PNTRT),MADRID(PNTRW),NVAL)       ! copy right column
         CALL STFUNM(IMNOT,ISTAT)
         SXY  = STEP(2)
         XYS  = START(2)
         DSXY = STEP(2)
         DXYS = START(2)
      ENDIF
C
      TABU(1) = CUNIT(II1+1:II1+16)
      TABU(2) = TABU(1)
      TABU(3) = TABU(1)
      TABU(4) = CUNIT(1:16)
      TABU(5) = TABU(4)
      TABU(6) = TABU(4)
      TABU(7) = TABU(4)
      TABU(8) = TABU(1)
C
C *** get table name for storage of data
      CALL STKRDC('P2',1,1,64,IACT,TABLE,KUN,KNUL,STATUS)
      IF (APPFLG.EQ.0) THEN
         CALL TBTINI(TABLE,F_TRANS,F_O_MODE,10,200,TID,STATUS)
         DO 10 IAV = 1,NCOLS
            CALL TBCINI(TID,D_R4_FORMAT,1,FORM(IAV),TABU(IAV),
     +                  TABL(IAV),IC(IAV),STATUS)
   10    CONTINUE
      ELSE
         CALL TBTOPN(TABLE,F_U_MODE,TID,STATUS)
         CALL TBIGET(TID,NNCOL,ISEQ,ISORT,ACOL,AROW,STATUS)
         DO 20 IAV = 1,NCOLS
            CALL TBLSER(TID,TABL(IAV),IC(IAV),STATUS)
            IF (IC(IAV).EQ.-1) THEN
               CALL STTPUT('*** FATAL: Wrong input table ',STATUS)
               CALL TBTCLO(TID,STATUS)
               CALL STSEPI
            END IF
   20    CONTINUE
      END IF
C
C *** restore the graphics display
      CALL PTOPEN(' ',' ',ACCESS,PLMODE)
C
C *** loop on input - pairs of points
      IF (IMETH.EQ.-1) THEN
         CALL STTPUT(HEAD1,STATUS)
      ELSE
         CALL STTPUT(HEAD2,STATUS)
      END IF
      CALL STTPUT(' ',STATUS)
      NCOUNT = 0
C
   30 CONTINUE
      CALL PTGCUR(XCUR,YCUR,KEY,STATUS)
      IF (STATUS.EQ.1) THEN
         GOTO 30
      ELSE IF (KEY.EQ.32) THEN
         CALL TBTCLO(TID,STATUS)
         CALL PTCLOS()
         CALL STSEPI
      ELSE
         LTYPE = 0
         BIN   = 0
         CALL PTDATA(STYPE,LTYPE,BIN,XCUR,YCUR,YOFF,1)
         X1       = XCUR
         VALUE(1) = DBLE(XCUR)
         IPL1     = NINT((X1-XYS)/SXY) + 1
      END IF
C
   40 CONTINUE
      CALL PTGCUR(XCUR,YCUR,KEY,STATUS)
      IF (STATUS.EQ.1) THEN
         GOTO 40
      ELSE IF (KEY.EQ.32) THEN
         CALL TBTCLO(TID,STATUS)
         CALL PTCLOS()
         CALL STSEPI
      ELSE
         LTYPE = 0
         CALL PTDATA(STYPE,LTYPE,BIN,XCUR,YCUR,YOFF,1)
         X2       = XCUR
         VALUE(2) = DBLE(XCUR)
         IPL2     = NINT((X2-XYS)/SXY) + 1
      ENDIF
C
C *** find center
      I1     = MIN(IPL1,IPL2)
      I2     = MAX(IPL1,IPL2)
      CALL PLFIND(MADRID(PNTRW),DXYS,DSXY,I1,I2,IMODE,IMETH,
     +          VALUE(3),VALUE(6),IFAIL,W1,W2,ACOE,VALUE(4),VALUE(5))
      VALUE(7) = ACOE(1)
      VALUE(8) = ACOE(3)
C
      IF (IFAIL.EQ.0) THEN
         ISEQ   = ISEQ + 1
         SVALUE(1) = VALUE(1)
         SVALUE(2) = VALUE(2)
         SVALUE(3) = VALUE(3)
         SVALUE(4) = VALUE(4)
         SVALUE(5) = VALUE(5)
         SVALUE(6) = VALUE(6)
         SVALUE(7) = VALUE(7)
         SVALUE(8) = VALUE(8)
C
         RRBUF(1)  = SVALUE(1)
         RRBUF(2)  = SVALUE(2)
         RRBUF(3)  = SVALUE(3)
         RRBUF(4)  = SVALUE(6)
         RRBUF(5)  = SVALUE(8)
         CALL TBRWRR(TID,ISEQ,NCOLS,IC,SVALUE,STATUS)
         IF (IMETH.EQ.-1) THEN
            WRITE (CLINE,9000) SVALUE(1), SVALUE(2),
     +                         SVALUE(3), SVALUE(6), SVALUE(8)
            CALL STKWRR('OUTPUTR',RRBUF,1,5,KUN,STATUS)
         ELSE
            WRITE (CLINE,9000) SVALUE(1), SVALUE(2), 
     +                         SVALUE(3), SVALUE(6)
            CALL STKWRR('OUTPUTR',RRBUF,1,4,KUN,STATUS)
         ENDIF
C
         CALL STTPUT(CLINE,STATUS)
         NCOUNT = NCOUNT + 1
         IF (IMETH.EQ.-1) THEN
            NPTS = I2 - I1 + 1
            LTYPE = 1
            DO INP = 1, NPTS
               SW1(INP) = SNGL(W1(INP))
               SW2(INP) = SNGL(W2(INP))
            ENDDO
            CALL PTDATA(STYPE,LTYPE,BIN,SW1,SW2,YOFF,NPTS)
         END IF
      END IF
C
      GO TO 30
C 
9000  FORMAT(3F13.3,G13.5,G13.5)
      END

C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine MLTDET         version 1         820519
C  A. Kruszewski             ESO Garching
C  modified by               version 1.1
C  A. Kruszewski             Obs. de Geneve    870224
C.KEYWORDS
C  search, detections
C.PURPOSE
C  identifies detections which are closer than "DLIM" pixels apart
C  multiple detections are marked by assigning the same
C  value of "MCAT(3,*)"
C.INPUT/OUTPUT
C  input arguments
C  MCAT        integer*4 array   integer parameters of detections
C  BCAT        real*4 array      real parameters of detections
C  NL          integer*4         number of entries in detections buffer
C  M           integer*4         number of detections
C  MOB         integer*4         detections buffer offset
C  AVI         real*4            average x-coordinate
C  AVJ         real*4            average y-coordinate
C  AVIJ        real*4            variance in x-coordinate
C  AVIJ        real*4            covariance of x and y coordinates
C  AVJJ        real*4            variance in y-coordinate
C  AVBG        real*4            average background
C  IM          integer*4         x-coordinate of maximal detection
C  JM          integer*4         y-coordinate of maximal detection
C  AVM         real*4            average of 9 central pixels
C                                for maximal detection
C  ISIZ        integer*4         maximal distance between detections
C  output arguments
C  MCAT        integer*4 array   integer parameters of detections
C  OBJECT      logical           object detection flag
C-----------------------------------------------------------------------
      SUBROUTINE MLTDET(MCAT, BCAT, NL, M, MOB, AVI, AVJ,
     &            AVII, AVIJ, AVJJ, AVBG, IM, JM, AVM, ISIZ, OBJECT)
C
      IMPLICIT  NONE 
      INTEGER   NL
      INTEGER   MCAT(4,NL)
      REAL      BCAT(2,NL)
      INTEGER   M
      INTEGER   MOB
      REAL      AVI
      REAL      AVJ
      REAL      AVII
      REAL      AVIJ
      REAL      AVJJ
      REAL      AVBG
      INTEGER   IM
      INTEGER   JM
      REAL      AVM
      INTEGER   ISIZ
      LOGICAL   OBJECT
C
      INTEGER   M1, M2, M3, M4
      INTEGER   MB, MMT, MOT, MS
C
      REAL      AV
      REAL      BG
      REAL      SBG, SI, SII, SIJ, SJ, SJJ, SUM
      REAL      TMP
      REAL      X1, X11, X12, X2, X21, X22, XSIZ
C
      M1 = 0
      M2 = 0
      M3 = 0
      BG = 0.0
      AV = 0.0
C 
      MB = MOD( M-1 , NL ) + 1
      MS = M - MB
      IF ( MOB .GT. MS ) THEN
          MOT = MOB - MS
          M1 = MCAT(1,MOT)
          M2 = MCAT(2,MOT)
          M3 = MCAT(3,MOT)
          BG = BCAT(1,MOT)
          AV = BCAT(2,MOT)
c      ELSE
c          READ ( ISF , REC=MOB ) M1 , M2 , M3 , M4 , BG , AV
      ENDIF
      X1 = FLOAT(M1)
      X2 = FLOAT(M2)
      X11 = X1
      X12 = X1
      X21 = X2
      X22 = X2
      IM = M1
      JM = M2
      AVM = 0.0
      SBG = 0.0
      SUM = 0.0
      SI = 0.0
      SJ = 0.0
      SII = 0.0
      SIJ = 0.0
      SJJ = 0.0
      M4 = M3
  10      CONTINUE
c      IF ( M4 .GT. MS ) THEN
          MMT = M4 - MS
          M1 = MCAT(1,MMT)
          M2 = MCAT(2,MMT)
          X1 = FLOAT( M1 )
          X2 = FLOAT( M2 )
          M4 = MCAT(4,MMT)
          BG = BCAT(1,MMT)
          AV = BCAT(2,MMT)
c      ELSE
c          READ ( ISF , REC=M4 ) M1 , M2 , M3 , M4 , BG , AV
c          X1 = FLOAT( M1 )
c          X2 = FLOAT( M2 )
c      ENDIF
      TMP = AV - BG
      SUM = SUM + TMP
      SI = SI + X1 * TMP
      SJ = SJ + X2 * TMP
      SII = SII + X1*X1 * TMP
      SIJ = SIJ + X1*X2 * TMP
      SJJ = SJJ + X2*X2 * TMP
      SBG = SBG + BG * TMP
      IF ( AV .GT. AVM ) THEN
          AVM = AV
          IM = M1
          JM = M2
      ENDIF
      IF ( X1 .LT. X11 ) THEN
          X11 = X1
      ENDIF
      IF ( X1 .GT. X12 ) THEN
          X12 = X1
      ENDIF
      IF ( X2 .LT. X21 ) THEN
          X21 = X2
      ENDIF
      IF ( X2 .GT. X22 ) THEN
          X22 = X2
      ENDIF 
      IF ( M4 .NE. 0 ) THEN
          GOTO 10
      ENDIF
      IF ( SUM .GT. 0.0 ) THEN
          AVI = SI / SUM
          AVJ = SJ / SUM
          AVII = SII / SUM
          AVII = AVII - AVI * AVI
          IF ( AVII .LT. 0.0 ) THEN
            AVII = 0.0
          ENDIF
          AVIJ = SIJ / SUM
          AVIJ = AVIJ - AVI * AVJ
          AVJJ = SJJ / SUM
          AVJJ = AVJJ - AVJ * AVJ
          IF ( AVJJ .LT. 0.0 ) THEN
            AVJJ = 0.0
          ENDIF
          AVBG = SBG / SUM
          XSIZ = ( (X12-X11)*(X12-X11) + (X22-X21)*(X22-X21) )
          IF ( XSIZ .GT. 0.0 ) THEN
            XSIZ = SQRT( XSIZ )
          ELSE
            XSIZ = 0.0
          ENDIF
          ISIZ = NINT( XSIZ )
          OBJECT = .TRUE.
      ELSE
          OBJECT = .FALSE.
      ENDIF
C
      RETURN
C
      END

C @(#)lsfun3.for	19.1 (ES0-DMD) 02/25/03 13:17:41
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE LSFUN3(IFLAG,NRRES,NRPRM,PRM,FCTVEC,IW,LIW,W,LW)               
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++        
C                                                                               
C.MODULE                                                                        
C       FIT                                                                     
C                                                                               
C.NAME                                                                          
C       LSFUN3                                                                  
C                                                                               
C.PURPOSE                                                                       
C   Function to compute the approximating function at each point.               
C   Pass the control to different routines according to IMAGE or TABLE          
C                                                                               
C.KEYWORDS                                                                      
C       Approximating Function.                                                 
C                                                                               
C.DESCRIPTION                                                                   
C       Test the type of FIT and go to respective routines                      
C                                                                               
C.LANGUAGE                                                                      
C       FORTRAN                                                                 
C                                                                               
C.CALLING SEQUENCE                                                              
C      CALL LSFUN3(IFLAG,NRRES,NRPRM,PRM,FCTVEC,IW,LIW,W,LW)                    
C                                                                               
C.INPUT PARAMETERS                                                              
C       IFLAG               INTEGER  unused                                     
C       NRRES               INTEGER  Number of residuals                        
C       NRPRM             INTEGER  Number of parameters                         
C       PRM (NRPRM)       DOUBLE   Parameters                                   
C       IW (LIW)            INTEGER  unused                                     
C       LIW                 INTEGER                                             
C       W (LW)              DOUBLE                                              
C       LW                  INTEGER                                             
C                                                                               
C.MODIFIED PARAMETERS                                                           
C       none                                                                    
C                                                                               
C.OUTPUT PARAMETERS                                                             
C       FCTVEC (NRRES)      DOUBLE   Approximating values                       
C                                                                               
C.FILES                                                                         
C       FIT_NAG.INC/NOLIST                                                      
C                                                                               
C.MODULES CALLED                                                                
C       LSFUN1_T                                                                
C       LSFUN1_I                                                                
C                                                                               
C.AUTHOR                                                                        
C       Ph. DEFERT,      Feb 1986                                               
C                                                                               
C.MODIFICATIONS                                                                 
C                                                                               
C                                                                               
C-----------------------------------------------------------------------        
C                                                                               
C      IMPLICIT NONE                                                            
C     .. Scalar Arguments ..                                                    
      INTEGER IFLAG,LIW,LW,NRPRM,NRRES,IW(LIW),MADRID(1) 
C     ..                                                                        
C     .. Array Arguments ..                                                     
      DOUBLE PRECISION FCTVEC(NRRES),PRM(NRPRM),W(LW)                   
C     ..                                                                        
C     .. External Files ..                                                      
       INCLUDE 'MID_INCLUDE:FITNAGI.INC/NOLIST'                                 
      COMMON /VMR/MADRID                                 
       INCLUDE 'MID_INCLUDE:FITNAGC.INC/NOLIST'                                 

C     ..                                                                        
C     .. Executable Statements ..                                               
                                                                                
      IF (FILTYP(1:1).EQ.'T') THEN                                              
          CALL LSFU1T(NRRES,NRPRM,PRM,FCTVEC)                                 
                                                                                
      ELSE                                                                      
          CALL LSFU1I(NRRES,NRPRM,PRM,FCTVEC,MADRID(PTRI),                    
     +                  MADRID(PTRM),NRPIX(1),NRPIX(2),NRPIX(3))                
      END IF                                                                    
                                                                                
      RETURN                                                                    
                                                                                
      END                                                                       

C @(#)logistic.for	19.1 (ES0-DMD) 02/25/03 13:17:40
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE LOGIST(IND,X,NP,P,Y1,D)                                      
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                  
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  18:01 - 21 DEC 1987                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C--------------------------------------------------------------                 
C                                                                               
C LOGISTIC DISTRIBUTION                                                         
C      IMPLICIT NONE                                                            
C                                                                               
C Y1 = 4.*P(1)*EXP(-ABS(X-P(2))/P(3))/(1.+EXP(-ABS(X-P(2))/P(3)))**2            
C                                                                               
      INTEGER NP,IND
      DOUBLE PRECISION Y1,P(NP),D(NP),A,B,C,E,F,G                               
      REAL X(1)                                                                 
C                                                                               
      A      = X(1) - P(2)                                                      
      B      = 1.76274716/P(3)                                                  
      C      = B*DABS(A)                                                        
      E      = DEXP(-C)                                                         
      F      = 1. + E                                                           
      D(1)   = 4.*E/ (F*F)                                                      
      Y1     = D(1)*P(1)                                                        
      G      = (1.0-E)*Y1/F                                                     
      D(2)   = DSIGN(G*B,A)                                                     
      D(3)   = G*C/P(3)                                                         
      RETURN                                                                    
                                                                                
      END                                                                       

C @(#)sort.for	19.1 (ES0-DMD) 02/25/03 13:32:58
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C  @(#)sort.for	5.1 (ESO-IPG) 4/5/93 15:58:34
      SUBROUTINE SORT(N,X)
      INTEGER N
      DOUBLE PRECISION X(1),SAVE
C
      INTEGER M,J,I
C
C ... shell sort
C
      M=-N
 2      M=M/2
        IF (M.LT.0) THEN
          DO 3 J=1,N+M
            DO 1 I=J,1,M
              IF (X(I).LE.X(I-M)) THEN
                GOTO 3
              ELSE
                SAVE=X(I)
                X(I)=X(I-M)
                X(I-M)=SAVE
              ENDIF
 1          CONTINUE
 3        CONTINUE
          GOTO 2
        ENDIF
      END

C @(#)intsat.for	19.1 (ES0-DMD) 02/25/03 13:29:43
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE INTSAT(MTS,NR,NC,NI,IST,NLI,KSAT)
C+++
C---
      IMPLICIT NONE
      INTEGER  NR
      INTEGER  NC
      INTEGER  MTS(NR,NC)
      INTEGER  NI
      INTEGER  IST(1)
      INTEGER  NLI
      INTEGER  KSAT
C
      INTEGER  I, K
C
      I = IST(NI)
      K = I-1
   20 CONTINUE
      IF (K.LT.1.OR.IABS(MTS(I,2)-MTS(K,2)).GE.2) THEN
         GO TO 10
      ENDIF
C
      IF (MTS(K,4).EQ.0) THEN
         IF (MTS(K,2).EQ.MTS(I,2)-1) THEN
           IF (MTS(K,3).GE.MTS(I,1).AND.MTS(I,3).GE.MTS(K,1)) THEN
             NLI      = NLI+1
             MTS(K,4) = 1
             IST(NLI) = K
           END IF
         END IF
      END IF
      K=K-1
      GO TO 20
C
   10 CONTINUE
      K = I+1
C
   30 CONTINUE
      IF (K.GT.KSAT.OR.IABS(MTS(K,2)-MTS(I,2)).GE.2) THEN
         GO TO 40
      ENDIF
C
      IF (MTS(K,4).EQ.0) THEN
         IF (MTS(K,2).EQ.MTS(I,2)+1) THEN
           IF (MTS(K,3).GE.MTS(I,1).AND.MTS(I,3).GE.MTS(K,1)) THEN
             NLI      = NLI+1
             MTS(K,4) = 1
             IST(NLI) = K
           END IF
         END IF
      END IF
      K=K+1
      GO TO 30

   40 CONTINUE
      RETURN
      END

C @(#)averow.for	19.1 (ESO-IPG) 02/25/03 14:27:03
      PROGRAM AVEROW
C --------------------------------------------------------------------
C
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  13:37 - 5 JAN 1988
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.Ponz
C         900202   KB  take care of options in lower case
C
C.MODIF : M.Peron cosmectic changes
C.MODIF : 910417 replace numbers by symbolic constants in ST calls !!
C.MODIF : 940518 O. Stahl
C.MODIF : replace STIGET with STFGET to speed up operation for large frames
C.IDENTIFICATION
C
C AVEROW.FOR
C
C.KEYWORDS
C
C  average
C
C.PURPOSE
C
C  produce a 1d image from a 2d by averaging over rows or columns
C
C  COMMAND
C  AVERAGE/ROW    OUTPUT = INPUT START,END
C  AVERAGE/COLUMN OUTPUT = INPUT START,END
C
C.ALGORITHM
C
C  add rows/columns
C
C.INPUT/OUTPUT
C
C KEYWORDS P1 - P3
C
C ------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER MADRID(1)
      INTEGER NDIM,KUN,KNUL,DUN,DNUL
      INTEGER I,I1,I2,II,II1,II2,K,IFIRST,IAV
      INTEGER NAXISA,NAXISB,NN,IMNOA,IMNOB,INUM
      INTEGER NPIXA(3),NPIXB(3),STATUS
      INTEGER*8 PNTRB,IPNTR
C
      REAL ACTVAL,LHCUTS(4),RN
C
      DOUBLE PRECISION STEPA(3),STEPB(3),STP,STR
      DOUBLE PRECISION STARTA(3),STARTB(3)
C
      CHARACTER*80    FRAMEA, FRAMEB
      CHARACTER*72    CUNITA,RANGE
      CHARACTER*72    IDENT
      CHARACTER       IOP*1,COMLIN*14,AUX*72
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      COMMON  /VMR/ MADRID
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      DATA   NDIM    /2/
      DATA   IDENT   /' '/,   CUNITA  /' '/
C
C  initialize system
C
      CALL STSPRO('AVEROW')
C
C  read params
C
      CALL STKRDC('P1',1,1,80,ACTVAL,FRAMEB,KUN,KNUL,STATUS)
      CALL STKRDC('P3',1,1,80,ACTVAL,FRAMEA,KUN,KNUL,STATUS)
      CALL STKRDC('P4',1,1,72,ACTVAL,RANGE,KUN,KNUL,STATUS)
      CALL STKRDC('P5',1,1,1,ACTVAL,IOP,KUN,KNUL,STATUS)
      CALL STKRDC('MID$CMND',1,1,14,ACTVAL,COMLIN,KUN,KNUL,STATUS)
C
C  open input frame and read descriptors
C
      CALL STFOPN(FRAMEA,D_R4_FORMAT,0,F_IMA_TYPE,IMNOA,STATUS)
      CALL STDRDI(IMNOA,'NAXIS',1,1,IAV,NAXISA,DUN,DNUL,STATUS)
      CALL STDRDI(IMNOA,'NPIX',1,2,IAV,NPIXA,DUN,DNUL,STATUS)
      CALL STDRDD(IMNOA,'START',1,2,IAV,STARTA,DUN,DNUL,STATUS)
      CALL STDRDD(IMNOA,'STEP',1,2,IAV,STEPA,DUN,DNUL,STATUS)
      CALL STDRDC(IMNOA,'IDENT',1,1,72,IAV,IDENT,DUN,DNUL,STATUS)
      CALL STDRDC(IMNOA,'CUNIT',1,1,72,IAV,CUNITA,DUN,DNUL,STATUS)
C
C  map output frame
C
      NAXISB = 1
      NPIXB(2) = 1
      STARTB(2) = 1.D0
      STEPB(2) = 0.D0
      IF (COMLIN(11:11).EQ.'R') THEN
         NPIXB(1) = NPIXA(1)
         STARTB(1) = STARTA(1)
         STEPB(1) = STEPA(1)
         NN = NPIXA(2)
         STR = STARTA(2)
         STP = STEPA(2)
      ELSE
         NPIXB(1) = NPIXA(2)
         STARTB(1) = STARTA(2)
         STEPB(1)= STEPA(2)
         NN = NPIXA(1)
         STR = STARTA(1)
         STP = STEPA(1)
      ENDIF
C
C  get range of pixels I1,I2
C
      II = INDEX(RANGE,'[')
      IF (II.EQ.1) THEN
         AUX = RANGE(2:)
         II = INDEX(AUX,']') - 1
         RANGE= AUX(1:II)
      ENDIF
      II2 = INDEX(RANGE,' ')
      II1 = INDEX(RANGE,',')
      CALL GETSNG(RANGE(1:II1-1),NN,STR,STP,I1)
      CALL GETSNG(RANGE(II1+1:II2-1),NN,STR,STP,I2)
      IF ((I1.LT.0).OR.(I2.LT.0).OR.(I1.GT.I2)) 
     +   CALL STETER(22,'Invalid range')
C
C  do it
C
      CALL STIPUT(FRAMEB,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,NAXISB,
     +            NPIXB,STARTB,STEPB,IDENT,CUNITA,PNTRB,IMNOB,STATUS)

      IF (COMLIN(11:11).EQ.'R') THEN

      CALL STFXMP(NPIXB,D_R4_FORMAT,IPNTR,STATUS)
      DO 30 I = I1,I2
         IFIRST = (I-1)*NPIXA(1)+1
C
C read row after row and sum up
C
         CALL STFGET(IMNOA,IFIRST,NPIXB,IAV,MADRID(IPNTR),STATUS)
         CALL AVER1(MADRID(PNTRB),MADRID(IPNTR),NPIXB)
 30   CONTINUE
C     
      ELSE
C     
         INUM = I2-I1+1
         CALL STFXMP(INUM,D_R4_FORMAT,IPNTR,STATUS)
         DO I = 1, NPIXA(2)
            IFIRST = (I-1)*NPIXA(1)+I1
            K = I
C
C read the columns which are to be  summed up
C
            CALL STFGET(IMNOA,IFIRST,INUM,IAV,MADRID(IPNTR),STATUS)
            CALL AVER2(MADRID(PNTRB),MADRID(IPNTR),
     +           K,INUM,NPIXA(1),NPIXA(2))
         ENDDO
      ENDIF
C
C find minmax and optionally average
C
      RN = I2-I1+1
      CALL MINMAX(MADRID(PNTRB),NPIXB(1),LHCUTS(3),LHCUTS(4),IOP,RN)
      CALL STDWRR(IMNOB,'LHCUTS',LHCUTS,1,4,KUN,STATUS)
C     
C  free data
C
      CALL STSEPI
      STOP
      END
C
      SUBROUTINE AVER1(Y,Y1,NPIX1)
C
C SUM OVER ROWS
C
      IMPLICIT NONE
      INTEGER  NPIX1,J
      REAL     Y(NPIX1), Y1(NPIX1)
C
      DO 20 J = 1,NPIX1
         Y(J)   = Y(J) + Y1(J)
 20   CONTINUE
C
      RETURN
      END

      SUBROUTINE AVER2(Y,Y1,ICOL,INUM,NPIX1,NPIX2)
C
C SUM OVER COLUMNS
C
      IMPLICIT NONE
      INTEGER  ICOL,J,INUM,NPIX1,NPIX2
      REAL     Y(NPIX1), Y1(NPIX2)
C
      Y(ICOL) = 0.0
      DO J = 1,INUM
         Y(ICOL) = Y(ICOL)+Y1(J)
      ENDDO
C     
      RETURN
      END
      
      SUBROUTINE MINMAX(Y,NPIX,YMIN,YMAX,IOP,RN)
C
C FIND MIN AND MAX OF SUM OR AVERAGE
C
      IMPLICIT NONE
      INTEGER  I,NPIX
      REAL     Y(NPIX),YMIN,YMAX,RN
      CHARACTER*1 IOP

      IF (IOP.NE.'S'.AND.IOP.NE.'s') THEN
         DO I = 1,NPIX
            Y(I) = Y(I)/RN
         ENDDO
      ENDIF
      YMIN = 1.0E30
      YMAX = -1.0E30
      DO I =  1, NPIX
         YMIN = MIN(YMIN,Y(I))
         YMAX = MAX(YMAX,Y(I))
      ENDDO
      RETURN 
      END
      

C===========================================================================
C Copyright (C) 1995-2005 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FTINIT(NAME,ISTAT)                                             
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:25 - 13 JAN 1988                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C.IDENTIFICATION                                                                
C                                                                               
C  FITLIB.FOR   VERSION 1.0  27 MAR 1984                                        
C                                                                               
C.PURPOSE                                                                       
C                                                                               
C  INTERFACE ROUTINES FOR THE FITTING STRUCTURES                                
C INIT FIT SESSION                                                              
C READ FIT FILE NAME.FIT                                                        
C                                                                               
C.ALGORITHM                                                                     
C  use MIDAS I/O interfaces to frames and tables                                
C                                                                               
C.KEYWORDS                                                                      
C  non linear fitting                                                           
C                                                                               
C.VERSION
C 051109	last modif
C 
C----------------------------------------------------------------               
C                                                                               
C                                                                               
C INPUT PARAMETERS                                                              
C NAME CHAR FIT DATA FILE NAME                                                  
C                                                                               
C OUTPUT PARAMETERS                                                             
C ISTAT INTG STATUS RETURN                                                      
C                                                                               
      IMPLICIT NONE
C 
      INTEGER ISTAT,II,IP,NACT,NI,NR,N1,I1
      INTEGER EUC,EUL,EUD,I,DNUL,DUN,ACT
C 
      CHARACTER*(*) NAME                                                        
      CHARACTER WS*5,FITSPEC*7
      CHARACTER*60 FITNAME                                                      
C 
      INCLUDE 'MID_INCLUDE:ST_DEF.INC/NOLIST'
      INCLUDE 'MID_INCLUDE:FITI.INC/NOLIST'                                     
C
      DOUBLE PRECISION STASTEP(2*FZINDMAX)
C
      INCLUDE 'MID_INCLUDE:FITC.INC/NOLIST'                                     
      INCLUDE 'MID_INCLUDE:ST_DAT.INC/NOLIST'
      DATA FITSPEC/'FIT....'/                                       
C                                                                               
C READ DATA                                                                     
C                                                                               
      II     = INDEX(NAME,' ') - 1                                         
      FITNAME = NAME(1:II)//'.fit'                                              
      CALL STFOPN(FITNAME,D_R4_FORMAT,0,F_FIT_TYPE,IP,ISTAT)
      IF (FZTYPE(1:1).EQ.' ') THEN                                            
          CALL STDRDC(IP,'FITCHAR',1,1, 
     +         FZNCHAR,NACT,FZCHAR,DNUL,DUN,ISTAT) 
          NI     = FZNINTG                                                    
          NR     = FZNREAL                                                    
      ELSE                                                                      
          NI     = FZCINTG                                                    
          NR     = FZCREAL                                                    
      END IF                                                                    
      CALL STDRDI(IP,'FITINTG',1,NI,ACT,FZINTG,DUN,DNUL,ISTAT)                  
      CALL STDRDR(IP,'FITREAL',1,NR,ACT,FZREAL,DUN,DNUL,ISTAT)                
C 
      IF (FZNPTOT.EQ.0) THEN
         N1 = 128
      ELSE
         N1 = FZNPTOT
      ENDIF
      CALL STDRDD(IP,'FITPARAM',1,N1,ACT,FZVALUE,DUN,DNUL,ISTAT)
      CALL STDRDD(IP,'FITERROR',1,N1,ACT,FZERROR,DUN,DNUL,ISTAT)
C 
      CALL STECNT('GET',EUC,EUL,EUD)                                            
      CALL STECNT('PUT',1,0,0)                                                  
      N1 = 2 * FZINDMAX
      CALL STDRDD(IP,'FITDOUBLE',1,N1,ACT,STASTEP,DUN,DNUL,ISTAT)
      IF (ISTAT.NE.0) THEN                                                
         DO 90,II=1,FZINDMAX 
            FZSTART(II) = 0.D0
            FZSTEP(II) = 1.D0
90       CONTINUE                                                              
      ELSE
         DO 100,II=1,FZINDMAX                  !get start, step from FITDOUBLE
            FZSTART(II) = STASTEP(II)
            FZSTEP(II) = STASTEP(II+FZINDMAX)
100      CONTINUE
      END IF                                                                    
C 
      CALL STDRDI(IP,'FITSELE',1,FZFUNMAX,ACT,FZSELE,DUN,DNUL,ISTAT) 
      CALL STECNT('PUT',EUC,EUL,EUD)                                            
      IF (ISTAT.NE.0) THEN                                                
         DO 1000,I = 1,FZFUNMAX 
            FZSELE(I) = 1                                                   
1000     CONTINUE                                                              
      END IF                                                                    
C                                                                               
C ASSIGN FUNCTION NAMES                                                         
C                                                                               
      DO 2000,I = FZNFUN + 1,FZFUNMAX                                         
         FZSPEC(I) = ' '                                                     
2000  CONTINUE                                                                  
      FZNPTOT = 0                                                             
      I1     = FZNFUN                                                         
      FZNFUN = 0                                                              
      DO 3000,I = 1,I1  
         WRITE (WS,9000) 10000 + I                                             
         FITSPEC(4:7) = WS(2:5)                                                
         CALL STDRDC(IP,FITSPEC,1,1,80,ACT,FZSPEC(I),DNUL,
     +               DUN,ISTAT)            
         CALL FTDFUN(I,FZSPEC(I),ISTAT)                                      
3000  CONTINUE                                                                  
      CALL FTPARV(ISTAT)                                                        
      RETURN                                                                    
C 
9000  FORMAT (I5)                                                               
      END                                                                       

C @(#)rcosmic.for	13.1.1.1 (ES0-DMD) 06/02/98 18:17:32
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C.IDENTIFICATION: RCOSMIC
C.PURPOSE:        Remove cosmic ray events on single ccd exposure and replace
C                 them by interpolation on neighbourhood pixels.
C.LANGUAGE:       F77+ESOext
C.AUTHOR:         P.Magain, M.Remy, Institut d'Astrophysique de Liege 
C.INPUT/OUTPUT:   IN_A/C/1/60      = Input frame.
C                 IN_B/C/1/60      = median filter of the input frame
C                 OUT_B/C/1/12     = Output frame.
C                 PARAMS/R/1/1     = Mean value of the background.
C                 PARAMS/R/2/1     = Readout noise in ADU units.
C                 PARAMS/R/3/1     = Inverse gain factor (e-/ADU).
C VERSION  1.2    New ST interfaces M.Peron 221191
C VERSION  1.3    remove limitation of size, suggestion from Hans Schwengeler
C ----------------------------------------------------------------------------
      PROGRAM RCOSMIC
      INTEGER*4 IAV,I
      INTEGER*4 STATUS,MADRID,SIZEX,IOMODE
      INTEGER*4 NAXIS,NPIX(2),IMNI,IMNO,IMNF,IMNC
      INTEGER*8 PNTRI,PNTRF,PNTRO,PNTRC
      INTEGER*4 KUN,KNUL
      CHARACTER*60 IMAGE,OBJET,COSMIC
      CHARACTER*72 IDENT1,IDENT2,IDENT3
      CHARACTER*48 CUNIT
      DOUBLE PRECISION START(2),STEP(2)
      REAL*4 SKY,GAIN,RON,NS,RC,PARAM(5),CUTS(2)
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON/VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
      DATA IDENT1 /' '/
      DATA IDENT2 /' '/
      DATA IDENT3 /'cosmic ray mask '/
      DATA CUNIT /' '/
      CALL STSPRO('RCOSMIC')
      CALL STKRDC('IN_A',1,1,60,IAV,IMAGE,KUN,KNUL,STATUS)
      CALL STIGET(IMAGE,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     1                2,NAXIS,NPIX,START,STEP
     1                ,IDENT1,CUNIT,PNTRI,IMNI,STATUS)

      CALL STKRDR('PARAMS',1,5,IAV,PARAM,KUN,KNUL,STATUS)
      CALL STIGET('middumma',D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     1                2,NAXIS,NPIX,START,STEP
     1                ,IDENT2,CUNIT,PNTRF,IMNF,STATUS)
      SKY = PARAM(1)
      GAIN = PARAM(2)
      RON = PARAM(3)
      NS = PARAM(4)
      RC = PARAM(5)
      CALL STKRDC('OUTIMA',1,1,60,IAV,OBJET,KUN,KNUL,STATUS)
      CALL STIPUT(OBJET,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     1                 NAXIS,NPIX,START,STEP
     1                ,IDENT1,CUNIT,PNTRO,IMNO,STATUS)

      SIZEX = 1
      DO I=1,NAXIS
         SIZEX = SIZEX*NPIX(I)
      ENDDO
      CALL STKRDC('COSMIC',1,1,60,IAV,COSMIC,KUN,KNUL,STATUS)
      IF (COSMIC(1:1).EQ.'+') THEN
            COSMIC = 'dummy_frame'
            IOMODE = F_X_MODE
      ELSE
            IOMODE = F_O_MODE
      ENDIF    
      CALL STIPUT(COSMIC,D_I2_FORMAT,IOMODE,F_IMA_TYPE
     1                 ,NAXIS,NPIX,START,STEP
     1                ,IDENT3,CUNIT,PNTRC,IMNC,STATUS)
      CALL COSROUT(MADRID(PNTRI),MADRID(PNTRC),NPIX(1),NPIX(2),
     1             RON,GAIN,NS,SKY,RC
     1            ,MADRID(PNTRF),MADRID(PNTRO))

      CUTS(1) = 0
      CUTS(2) = 1
      IF (IOMODE.EQ.F_O_MODE) 
     + CALL STDWRR(IMNC,'LHCUTS',CUTS,1,2,KUN,STATUS)
      CALL DSCUPT(IMNI,IMNO,' ',STATUS) 
      CALL STSEPI
      END
      SUBROUTINE COSROUT(AI,COSMIC,I_IMA,J_IMA,RON,GAIN,
     1                   NS,SKY,RC,AM,AO)
      INTEGER I_IMA,J_IMA,NUM
      INTEGER ORD(10000)
      INTEGER K,L
      INTEGER IDUMAX,JDUMAX,I1,I2,J1,II,JJ
      INTEGER I,J,IMAX,JMAX,IMIN,JMIN
      INTEGER FIRST(2),NEXT(2)
      INTEGER*2 COSMIC(I_IMA,J_IMA)
      REAL*4 VECTEUR(10000),FMAX,ASUM,RC
      REAL*4 AI(I_IMA,J_IMA),AO(I_IMA,J_IMA),AM(I_IMA,J_IMA)
      REAL*4 SIGMA,SKY,S1,S2
      REAL*4 RON,GAIN,NS,AMEDIAN
      DO 10 J=1,J_IMA
      DO 5 I=1,I_IMA
      AO(I,J)=AI(I,J)
      COSMIC(I,J)= 0
    5 CONTINUE
   10 CONTINUE
C
C     La boucle suivante selectionne les pixels qui sont
C     significativement au dessus de l'image filtree medianement.
C
C
C     COSMIC =-1 ----> candidate for cosmic
C            = 0 ----> not a cosmic
C            = 1 -----> a cosmic (at the end)
C            = 2 ----> member of the group
C            = 3 ----> member of a group which has been examined
C            = 4 ----> neighbourhood  of the group
      K=1
      DO 80 J=2,J_IMA-1
      DO 70 I=2,I_IMA-1
      SIGMA=SQRT(RON**2+AM(I,J)/GAIN)
      IF ((AI(I,J)-AM(I,J)).GE.(NS*SIGMA)) THEN
            COSMIC(I,J) = -1
            K = K+1
      ENDIF
   70 CONTINUE
   80 CONTINUE
C
C ------------------------
C
C
C
C
C     Ces pixels sont regroupes par ensembles connexes dans la boucle
C
C
C  -----------------------------
      FIRST(1) = 2
      FIRST(2) = 2
  100 CALL FINDNEXT(COSMIC,I_IMA,J_IMA,FIRST,NEXT)
      IF (NEXT(1).EQ.-1) RETURN
      I = NEXT(1)
      J = NEXT(2) 
      COSMIC(I,J) = 2
      IMIN = I
      IMAX = I 
      JMIN = J
      JMAX = J
      IDUMAX = I
      JDUMAX = J
      FMAX = AI(I,J)
  110 I1 = 0
      I2 = 0
      CONTINUE
      DO 125 L=1,2
          DO 115 K=1,2
               II = I+K-L
               JJ = J+K+L-3
               IF (COSMIC(II,JJ).EQ.-1) THEN
                   I1 = II
                   J1 = JJ  
                   IMIN = MIN(IMIN,II) 
                   IMAX = MAX(IMAX,II)
                   JMIN = MIN(JMIN,JJ)
                   JMAX = MAX(JMAX,JJ)
                   COSMIC(II,JJ) = 2
                   IF (AI(II,JJ).GT.FMAX) THEN
                         FMAX = AI(II,JJ)
                         IDUMAX = II
                         JDUMAX = JJ
                   ENDIF
                ELSE IF (COSMIC(II,JJ).EQ.0) THEN
                   COSMIC(II,JJ) = 4
                ENDIF
  115     CONTINUE 
  125 CONTINUE 
      COSMIC(I,J) = 3
      IF (I1.NE.0) THEN
      I = I1
      J = J1
      GOTO 110
      ENDIF        
      DO 140 L = JMIN,JMAX  
         DO 130 K = IMIN,IMAX
              IF (COSMIC(K,L).EQ.2) THEN
                 I = K
                 J = L
                 GOTO 110
              ENDIF
  130 CONTINUE
  140 CONTINUE   
      FIRST(1) = NEXT(1)+1
      FIRST(2) = NEXT(2) 
C We start here the real work....
C 1- decide if the pixel's group is a cosmic
C 2-replace these values by another one
      
      S1 = AI(IDUMAX-1,JDUMAX-1) + AI(IDUMAX+1,JDUMAX-1)
     +     + AI(IDUMAX,JDUMAX-1) +AI(IDUMAX,JDUMAX+1)
      S2 = AI(IDUMAX-1,JDUMAX+1) + AI(IDUMAX+1,JDUMAX+1)
     +     + AI(IDUMAX-1,JDUMAX) + AI(IDUMAX+1,JDUMAX)
      ASUM = (S1+S2)/8.-SKY
      IF ((FMAX-SKY).GT.RC*ASUM) THEN
         NUM = 1
         DO L = JMIN-1,JMAX+1
            DO K = IMIN-1,IMAX+1
               IF (COSMIC(K,L).EQ.4) THEN
                   VECTEUR(NUM) = AI(K,L)
                   NUM = NUM+1
               ENDIF    
            ENDDO
         ENDDO
         CALL SORT(NUM-1,VECTEUR,ORD)
         AMEDIAN = VECTEUR(ORD((NUM-1)/2))
         DO L = JMIN-1,JMAX+1
            DO K = IMIN-1,IMAX+1
               IF (COSMIC(K,L).EQ.3) THEN
                   COSMIC(K,L) = 1
                   AO(K,L) = AMEDIAN
               ELSE IF (COSMIC(K,L).EQ.4) THEN
                   COSMIC(K,L) = 0
               ENDIF
            ENDDO
         ENDDO
      ELSE 
         DO L = JMIN-1,JMAX+1
            DO K = IMIN-1,IMAX+1
               IF (COSMIC(K,L).NE.-1) COSMIC(K,L) = 0
            ENDDO
          ENDDO
      ENDIF
        
      
 
      IF (NEXT(1).GT.0) GOTO 100
C
C
C
      RETURN
      END

      SUBROUTINE FINDNEXT(COSMIC,I_IMA,J_IMA,FIRST,NEXT)
      INTEGER I_IMA,J_IMA,FIRST(2),NEXT(2)
      INTEGER I,J
      INTEGER*2 COSMIC(I_IMA,J_IMA)
      DO J = FIRST(2), J_IMA
          DO I = 2, I_IMA
             IF (COSMIC(I,J).EQ.-1) THEN
                 NEXT(1) = I
                 NEXT(2) = J
                 RETURN
             ENDIF
          ENDDO
      ENDDO 
      NEXT(1) = -1
      NEXT(2) = -1
      RETURN
      END

      SUBROUTINE SORT(KMAX,INP,ORD)
      INTEGER KMAX,IMIN,IMAX,I,J,K,L
      INTEGER ORD(10000)
      REAL*4 INP(10000),F
      DO 4100 J=1,KMAX
      ORD(J)=J
 4100 CONTINUE
      IF (INP(1).GT.INP(2)) THEN 
             ORD(1)=2
             ORD(2)=1
      END IF
      DO 4400 J=3,KMAX
      F=INP(J)
      L=ORD(J-1)
      IF (INP(L).LE.F) GO TO 4400
      L=ORD(1)
      IMIN=1
      IF (F.LE.INP(L)) GO TO 4250
      IMAX=J-1
 4200 I=(IMIN+IMAX)/2
      L=ORD(I)
      IF (INP(L).LT.F) THEN
              IMIN=I
              ELSE
              IMAX=I
      END IF
      IF (IMAX.GT.(IMIN+1)) GO TO 4200
      IMIN=IMAX
 4250 DO 4300 K=J-1,IMIN,-1
      ORD(K+1)=ORD(K)
 4300 CONTINUE
      ORD(IMIN)=J
 4400 CONTINUE
      RETURN
      END

C @(#)caliline.for	19.1 (ESO-DMD) 02/25/03 14:29:40
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  16:39 - 3 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION
C
C  CALILINE.FOR
C
C.PURPOSE
C
C  WAVELENGTH CALIBRATION. THE PROGRAM COMPUTES DISPERSION COEFFS,
C  ESTIMATED WAVELENGTHS AND RESIDUALS BY MEANS OF A REGRESSION ANALYSIS
C
C  DISPERSION COEFFICIENTS ARE REALLY THE POLYNOMIAL COEFFS OF THE
C  TRANSFORMATION
C  X <- F(WAVE)
C
C.KEYWORDS
C
C  TABLES, IDENTIFICATIONS
C
C.ALGORITHM
C
C  THERE ARE TWO MODES OF OPERATION :
C  1. INITIAL GUESS FOR THE CORRESPONDENCE IS DEFINED BY THE
C     REFERENCE COLUMNS OF BOTH TABLES
C     IN THIS CASE REFERNCE COLUMN IN SECOND OUTPUT HAS TO BE SORTED
C  2. INITIAL GUESS IS DEFINED BY A SET OF COEFFS. WITH THE
C     GEOMETRIC TRANSFORMATION
C
C.INPUT/OUTPUT
C
C  CALIBRATE/LINE error,degree tabline CATALue
C
C  error     - window defining the tolerance in pixels
C  degree    - degree of the polynomial approximation
C  tabline   - table with the positions of the lines. It contains the
C              following information:
C              X        line position in pixels
C              Y        scan line
C              PEAK     maximum value
C              IDENT    initial identification
C              WAVE     actual  identification
C              WAVEC    computed values
C              RESIDUAL residuals WAVE-WAVEC
C              DELTA    relative residuals (a0+a1*X - WAVEC)
C              DELTA1   relative residuals (a0+a1*X - WAVE)
C  CATALue - line CATALue
C
C 020506		last modif
C 
C-----------------------------------------------------------
C
C
C ... PARAMETER DEFINITION
C
      IMPLICIT NONE
C
      CHARACTER*17 COLY
      CHARACTER*16 LABEL(7),UNIT
      CHARACTER*8  FORM
      CHARACTER*80 TABLE,CATAL,LINE
C
      INTEGER   MADRID(1),NAC2,NAR2,NAC1,NAR1
      INTEGER   IDEG,ICOL1(7),ICOL2(2)
      INTEGER   NPIX1(2),NPIX2(2),STATUS,IACT,I
      INTEGER   NCOL1,NROW1,NSC1,NCOL2,NROW2,NSC2
      INTEGER*8 IBUF1,IBUF2
      INTEGER   IST,NACT1,NACT2,NIDENT
      INTEGER   NINCL1,NINCL2,TID,TIC
      INTEGER   NWORK1, NWORK2, KUN, KNUL
C
      INTEGER SIZE,MODE
      PARAMETER (SIZE=30)
      DOUBLE PRECISION ERROR,COEFF(SIZE)
C
      REAL TOL(2)
      REAL START(2)
      REAL STEP(2)
C
      INCLUDE     'MID_INCLUDE:TABLES.INC'
      COMMON/VMR/MADRID
      INCLUDE     'MID_INCLUDE:TABLED.INC'
C
      DATA UNIT/'ANGSTROM'/
      DATA FORM/'F15.7'/
      DATA START/0.,0./
      DATA STEP/1.,1./
      DATA LABEL(1)/'X'/,LABEL(2)/'IDENT'/,LABEL(3)/'WAVE'/,
     +     LABEL(4)/'WAVEC'/,LABEL(5)/'RESIDUAL'/,
     +     LABEL(6)/'DELTA'/,LABEL(7)/'DELTAC'/
      DATA COLY/':WAVE'/
C
C ... GET INTO MIDAS
C
      CALL STSPRO('CALILINE')
C
C ... GET INPUT PARAMETERS + DEFAULT
C
      CALL STKRDC('P2',1,1,64,IACT,TABLE,KUN,KNUL,STATUS)
      CALL STKRDC('P3',1,1,64,IACT,CATAL,KUN,KNUL,STATUS)
      CALL STKRDR('INPUTR',1,2,IACT,TOL,KUN,KNUL,STATUS)
      ERROR  = TOL(1)
      IDEG   = TOL(2)
C
C ... INIT INPUT TABLE
C
      CALL TBTOPN(TABLE,F_U_MODE,TID,STATUS)
      CALL TBIGET(TID,NCOL1,NROW1,NSC1,NAC1,NAR1,STATUS)

      DO 15 I = 1,2
         CALL TBCSER(TID,LABEL(I),ICOL1(I),STATUS)
         IF (ICOL1(I).LT.0) THEN
             WRITE (LINE,17) LABEL(I)
17           FORMAT ('Could not find column label ',A20)
             CALL STETER (9,LINE)
         ENDIF
15    CONTINUE

      DO 10 I = 3,7
         CALL TBCSER(TID,LABEL(I),ICOL1(I),STATUS)
         IF (ICOL1(I).LT.0) THEN
            CALL TBCINI(TID,D_R8_FORMAT,1,FORM,UNIT,LABEL(I),
     +               ICOL1(I),STATUS)
         ENDIF
   10 CONTINUE
C
C ... INIT REFERENCE TABLE
C
      CALL TBTOPN(CATAL,0,TIC,STATUS)
      CALL TBIGET(TIC,NCOL2,NROW2,NSC2,NAC2,NAR2,STATUS)
      CALL TBCSER(TIC,COLY,ICOL2(1),STATUS)
C
C ... PREPARE WORK SPACE
C
      NINCL1 = 2
      NPIX1(1) = NROW1
      NPIX1(2) = 7*2
      NWORK1   = 7*8*NROW1
      CALL TDMGET(NWORK1,IBUF1,STATUS)
      CALL SPCOP1(TID,NROW1,NINCL1,ICOL1,MADRID(IBUF1),NACT1)
      NINCL2 = 1
      NPIX2(1) = NROW2
      NPIX2(2) = 2
      NWORK2   = 8*NROW2
      CALL TDMGET(NWORK2,IBUF2,STATUS)
      CALL SPCOP3(TIC,NROW2,NINCL2,ICOL2,MADRID(IBUF2),NACT2)
C
C ... VERIFY IDENTIFICATIONS
C
      CALL GUESS(MODE,COEFF,SIZE,IDEG)

      IF (MODE.EQ.0)  THEN
      CALL MYVERIFY(NROW1,NACT1,MADRID(IBUF1),NACT2,
     +            MADRID(IBUF2),NIDENT)
      IF (NIDENT.LE.IDEG) THEN
          CALL STTPUT(' Not enough identifications',STATUS)
          GO TO 20
      END IF
      ENDIF
C
C ... IDENTIFICATION
C
      CALL IDENTF(NROW1,NACT1,MADRID(IBUF1),NROW2,NACT2,
     +            MADRID(IBUF2),ERROR,IDEG,COEFF,IST,MODE)
      IF (IST.NE.0) THEN
          CALL STTPUT(' Wrong identifications in input table',
     +                STATUS)
          GO TO 20
      END IF
C
C ... COMPUTE WAVELENGTHS AND RESIDUALS
C
      CALL COMPRS(NROW1,NACT1,MADRID(IBUF1),IDEG)
C
C ... COPY FINAL RESULTS WITH THE IDENTIFICATIONS IN OUTPUT TABLE
C
      NINCL1 = 5
      CALL SPCOP2(NROW1,MADRID(IBUF1),TID,NINCL1,ICOL1(3))
C
C ... SAVE COEFFICIENTS
C
      CALL STKWRD('OUTPUTD',COEFF,1,20,KUN,STATUS)
C
C ... END
C
20    CONTINUE
      CALL TDMFRE(NWORK1,IBUF1,STATUS)
      CALL TDMFRE(NWORK2,IBUF2,STATUS)
      CALL TBTCLO(TID,STATUS)
      CALL TBTCLO(TIC,STATUS)
      CALL STSEPI
      STOP 
      END

      SUBROUTINE LSIDEN(IDEG,NV,COEFF,NROW1,NACT1,BUF1,NROW2,BUF2,
     +                   ERROR,NTOT,STDEV)
C
C IDENTIFY DETECTED LINES USING DISPERSION COEFFS
C
      IMPLICIT NONE
C
      INTEGER NV,NROW1,NACT1,NROW2
      DOUBLE PRECISION COEFF(NV),BUF1(NROW1,5),ERROR,SAMPLE
      DOUBLE PRECISION BUF2(NROW2)
      DOUBLE PRECISION POLEV,DD(2),STDEV
      DOUBLE PRECISION VALUE
      INTEGER IDEG,NTOT,K,L,I,IPOINT
C
      DATA DD/0.D0,0.D0/
C
C ... LOOP ON THE LINES IN THE CATALUE
C
      NTOT   = 0
      STDEV  = 0.D0
      K      = IDEG + 1
      L      = 1
      DO 10 I = 1,NROW2
C
C ... USE ONLY SUITABLE RANGE !!
C
          DD(1)  = BUF2(I)
          SAMPLE = POLEV(K,L,NV,COEFF,DD)
C
C ... CHECK LIMITS
C
          CALL TZSSD1(BUF1(1,1),NACT1,SAMPLE,ERROR,IPOINT,VALUE)
C
C ... LINE IDENTIFIED
C
          IF (IPOINT.GT.0) THEN
              BUF1(IPOINT,3) = DD(1)
              BUF1(IPOINT,2) = -1.D0
              BUF1(IPOINT,5) = VALUE - SAMPLE
              STDEV  = STDEV + BUF1(IPOINT,5)*BUF1(IPOINT,5)
              NTOT   = NTOT + 1
          END IF
   10 CONTINUE
      IF (NTOT.GT.0) STDEV  = DSQRT(STDEV/NTOT)
      RETURN
      END

      SUBROUTINE LSOLVE(NROW1,NACT1,BUF,IDEG,NV,COEFF)
C
C SOLVE THE L-S FIT TO THE DATA
C
      IMPLICIT NONE
C
      INTEGER NROW1,NACT1,IDEG,NV
      DOUBLE PRECISION BUF(NROW1,6),COEFF(NV)
      DOUBLE PRECISION G(20,20)
C
      INTEGER K,L,NTOTAL,LL,N,N1,I,KMIN,K1,ISTAT
C
C BUILD INPUT ARRAYS
C
      K      = IDEG
      L      = 0
      NTOTAL = 0
      LL     = 0
      N      = NV
      N1     = N + 1
      DO 20 I = 1,NACT1
          IF (DABS(BUF(I,2)).GT.0.5D0) THEN
              NTOTAL = NTOTAL + 1
              CALL TDSET2(LL+1,BUF(I,3),BUF(I,4),BUF(I,1),
     +             K,L,G,COEFF,N,20)
              IF (LL.NE.0) THEN
                  KMIN   = MIN(LL,N1)
                  DO 10 K1 = 1,KMIN
                      CALL TDHHTR(K1,LL+1,G,COEFF,N,20)
   10             CONTINUE
              END IF
              LL     = MIN(LL+1,N1)
          END IF
   20 CONTINUE
C
C SOLVE THE LINEAR SYSTEM
C
      IF (NTOTAL.LT.NV) THEN
          CALL STTPUT(' Not enough identified features',ISTAT)
          RETURN
      END IF
      CALL TDSOLV(G,COEFF,N,20)
      RETURN
      END

      DOUBLE PRECISION FUNCTION POLEV(K,L,NV,DPAR,VAL)
C
C COMPUTE FUNCTION VALUE
C
      IMPLICIT NONE
      INTEGER  K,L,NV
      DOUBLE PRECISION DPAR(NV),VAL(2)
      DOUBLE PRECISION DC,RESULT,WORK(30)
C
      INTEGER IP,L1,K1
C
      IP     = 0
      DC     = 1.D0
      RESULT = 0.D0
      DO 20 L1 = 0,L
          IP     = IP + 1
          WORK(IP) = DC
          RESULT = RESULT + WORK(IP)*DPAR(IP)
          DO 10 K1 = 1,K
              IP     = IP + 1
              WORK(IP) = WORK(IP-1)*VAL(1)
              RESULT = RESULT + WORK(IP)*DPAR(IP)
   10     CONTINUE
          DC     = DC*VAL(2)
   20 CONTINUE
      POLEV  = RESULT
      RETURN
      END

      SUBROUTINE SPCOP1(TABLE,N,NC1,IC1,BUF,NACT)
C
C PREPARE WORK SPACE
C
      IMPLICIT NONE
C
      INTEGER TABLE,N,NC1,NACT
      DOUBLE PRECISION BUF(N,NC1),VAL1(2)
C
      INTEGER IC1(NC1),STATUS,I
      LOGICAL SEL
      LOGICAL NULL1(2)
      DATA VAL1/0.D0,0.D0/
      DATA NULL1/.FALSE.,.FALSE./
C
      NACT   = 0
      VAL1(2) = 0.D0
C
C ... READ COLUMNS
C
      DO 10 I = 1,N
C
C ...  READ SELECTION FLAG
C
          CALL TBSGET(TABLE,I,SEL,STATUS)
          IF (SEL) THEN
C
C ...    READ ROW
C
              CALL TBRRDD(TABLE,I,NC1,IC1,VAL1,NULL1,STATUS)
C     IF (.NOT.NULL1(1)) THEN
              NACT   = NACT + 1  !   ASSIGN SAMPLE
              BUF(NACT,1) = VAL1(1)  !   ASSIGN IDENTIFICATION
              BUF(NACT,2) = VAL1(2)  !   CLEAR  WAVE
              BUF(NACT,3) = 0.D0  !   CLEAR  WAVEC
              BUF(NACT,4) = 0.D0  !   CLEAR FLAG
              BUF(NACT,5) = 0.D0  !   CLEAR RESIDUAL
              BUF(NACT,6) = 0.D0
              VAL1(1) = 0.D0
              VAL1(2) = 0.D0
C     ENDIF
          END IF
   10 CONTINUE
      RETURN
      END

      SUBROUTINE SPCOP2(N,BUF,TABLE,NC,IC)
C
C COPY FINAL IDENTIFICATIONS
C
      IMPLICIT NONE
C
      INTEGER N,NC
      INTEGER TABLE
      DOUBLE PRECISION BUF(N,7),VAL(5)
      INTEGER IC(NC)
      LOGICAL SEL
      INTEGER I,NACT,STATUS
C
      NACT   = 0
      DO 10 I = 1,N
          CALL TBSGET(TABLE,I,SEL,STATUS)
          IF (SEL) THEN
              NACT   = NACT + 1
              IF (DABS(BUF(NACT,2)).GT.0.5D0) THEN
                  VAL(1) = BUF(NACT,3)
                  VAL(2) = BUF(NACT,4)
                  VAL(3) = BUF(NACT,5)
                  VAL(4) = BUF(NACT,6)
                  VAL(5) = BUF(NACT,7)
                  CALL TBRWRD(TABLE,I,NC,IC,VAL,STATUS)
              ELSE
                  CALL TBEDEL(TABLE,I,IC(1),STATUS)
                  CALL TBEWRD(TABLE,I,IC(2),BUF(NACT,4),STATUS)
                  CALL TBEDEL(TABLE,I,IC(3),STATUS)
                  CALL TBEWRD(TABLE,I,IC(4),BUF(NACT,6),STATUS)
                  CALL TBEDEL(TABLE,I,IC(5),STATUS)
              END IF
          END IF
   10 CONTINUE
      RETURN
      END

      SUBROUTINE SPCOP3(TABLE,N,NC1,IC1,BUF,NACT)
C
C PREPARE WORK SPACE
C
      IMPLICIT NONE
C
      INTEGER N,NC1,NACT
      INTEGER TABLE
      DOUBLE PRECISION BUF(N,NC1),VAL1(2)
      INTEGER IC1(NC1),STATUS,I
      LOGICAL SEL
      LOGICAL NULL1(2)
      DATA NULL1/.FALSE.,.FALSE./
      DATA VAL1/0.D0,0.D0/
C
      NACT   = 0
      VAL1(2) = 0.D0
C
C ... READ COLUMNS
C
      DO 10 I = 1,N
C
C ...  READ SELECTION FLAG
C
          CALL TBSGET(TABLE,I,SEL,STATUS)
          IF (SEL) THEN
C
C ...    READ ROW
C
              CALL TBRRDD(TABLE,I,NC1,IC1,VAL1,NULL1,STATUS)
C     IF (.NOT.NULL1(1)) THEN
              NACT   = NACT + 1  !   ASSIGN SAMPLE
              BUF(NACT,1) = VAL1(1)
              VAL1(1) = 0.D0
C     ENDIF
          END IF
   10 CONTINUE
      RETURN
      END

      SUBROUTINE MYVERIFY(NROW1,NACT1,BUF1,NACT2,BUF2,NIDENT)
C
C VERIFY IDENTIFICATIONS, ASSIGN CLOSEST IDENTIFICATION
C IN THE COMPARISON TABLE
C
C INPUT ARGUMENTS
C NROW1 INTG*4 DIMENSION OF BUF1
C NACT1 INTG*4 NUMBER OF ENTRIES IN BUF1
C BUF1 REAL*8 ARRAY WITH LINES
C NACT2 INTG*4 NUMBER OF ENTRIES IN BUF2
C BUF2 REAL*8 ARRAY WITH REFERENCE LINES
C
C OUTPUT ARGUENTS
C NIDENT INTG*4 NUMBER OF IDENTIFICATIONS
C
      IMPLICIT NONE
C
      INTEGER NROW1,NACT1,NACT2,NIDENT,STAT
      DOUBLE PRECISION BUF1(NROW1,3),BUF2(NACT2),VAL
      REAL   REF,DIF, RATIO, NXTLINE
      CHARACTER*80   LINE
      INTEGER I,J
C
      NIDENT = 0
C
C ... ITERATION ON ROWS
C
      DO 20 I = 1,NACT1
          VAL    = BUF1(I,2)

          IF (VAL.GT.0) THEN
              REF    = VAL
              NIDENT = NIDENT + 1
C
C ... ASSIGN USER PROVIDED VALUE
C     AND FLAG THE ENTRY
C
              BUF1(I,3) = VAL  !   FLAG ENTRY
              BUF1(I,2) = 1.D0
C
C ... CHECK THAT THERE IS AN IDENTIFICATION
C
              DO 10 J = 1,NACT2
                  DIF    = ABS(VAL-BUF2(J))
                  IF (DIF.LT.REF) THEN
                      REF     = DIF
                      NXTLINE = BUF2(J)
                  END IF
   10         CONTINUE

              RATIO = ABS(NXTLINE/VAL - 1.)
              IF (RATIO.GT.1.E-05) THEN
                  WRITE(LINE,610) VAL,NXTLINE
610               FORMAT('Warning: Line ',F12.6,' not found in catalog.'
     +        ,' Closest line:',F12.6)
                  CALL STTPUT(LINE,STAT)
              ENDIF

          END IF
   20 CONTINUE

      RETURN
      END

      SUBROUTINE COMPRS(NROW1,NACT1,BUF,IDEG)
C
C COMPUTE ESTIMATED WAVELENGTHS AND RESIDUALS
C
      IMPLICIT NONE
C
      INTEGER NROW1,NACT1,IDEG
      DOUBLE PRECISION BUF(NROW1,7),COEFF(20)
      DOUBLE PRECISION G(20,20)
C
      INTEGER K,L,LL,NTOTAL,N,N1,NV,I,K1,KMIN,ISTAT
      DOUBLE PRECISION DD(2),LINEAR,POLEV
C
C BUILD INPUT ARRAYS
C
      K      = IDEG
      L      = 0
      NTOTAL = 0
      LL     = 0
      NV     = K + 1
      N      = NV
      N1     = N + 1
      DO 20 I = 1,NACT1
          IF (DABS(BUF(I,2)).GT.0.5D0) THEN
              NTOTAL = NTOTAL + 1
              CALL TDSET2(LL+1,BUF(I,1),BUF(I,1),BUF(I,3),
     +             K,L,G,COEFF,N,20)
              IF (LL.NE.0) THEN
                  KMIN   = MIN(LL,N1)
                  DO 10 K1 = 1,KMIN
                      CALL TDHHTR(K1,LL+1,G,COEFF,N,20)
   10             CONTINUE
              END IF
              LL     = MIN(LL+1,N1)
          END IF
   20 CONTINUE
C
C SOLVE THE LINEAR SYSTEM
C
      IF (NTOTAL.LT.NV) THEN
          CALL STTPUT(' Not enough identified features',ISTAT)
          RETURN
      END IF
      CALL TDSOLV(G,COEFF,N,20)
C
C ... COMPUTE ESTIMATED VALUES AND RESIDUALS
C
      DD(2)  = 0.D0
      DO 30 I = 1,NACT1
          DD(1)  = BUF(I,1)
          BUF(I,4) = POLEV(K,L,NV,COEFF,DD)
          BUF(I,5) = BUF(I,3) - BUF(I,4)
   30 CONTINUE
C
C ... REPEAT FOR LINEAR TERMS
C
      K      = 1
      L      = 0
      NTOTAL = 0
      LL     = 0
      NV     = K + 1
      N      = NV
      N1     = N + 1
      DO 50 I = 1,NACT1
          NTOTAL = NTOTAL + 1
          CALL TDSET2(LL+1,BUF(I,1),BUF(I,1),BUF(I,4),
     +                K,L,G,COEFF,N,20)
          IF (LL.NE.0) THEN
              KMIN   = MIN(LL,N1)
              DO 40 K1 = 1,KMIN
                  CALL TDHHTR(K1,LL+1,G,COEFF,N,20)
   40         CONTINUE
          END IF
          LL     = MIN(LL+1,N1)
   50 CONTINUE
C
C SOLVE THE LINEAR SYSTEM
C
      IF (NTOTAL.LT.NV) THEN
          CALL STTPUT(' Not enough identified features',ISTAT)
          RETURN
      END IF
      CALL TDSOLV(G,COEFF,N,20)
C
C ... COMPUTE ESTIMATED VALUES AND RESIDUALS
C
      DD(2)  = 0.D0
      DO 60 I = 1,NACT1
          DD(1)  = BUF(I,1)
          LINEAR = POLEV(K,L,NV,COEFF,DD)
          BUF(I,6) = LINEAR - BUF(I,4)
          IF (DABS(BUF(I,2)).GT.0.5D0) BUF(I,7) = LINEAR - BUF(I,3)
   60 CONTINUE
      RETURN
      END

        SUBROUTINE TZSSD1(ARRAY, N, VALUE, ERROR, IPOS, ACTVAL)
C
C        SEQUENTIAL SEARCH FOR ENTRY CLOSE TO VALUE
C        DOUBLE PRECISION VERSION
C
        IMPLICIT NONE
        INTEGER                 N
        DOUBLE PRECISION        ARRAY(N)
        DOUBLE PRECISION        VALUE, ERROR, ACTVAL
        INTEGER                 IPOS
C
        INTEGER                 I, IFIRST, TINULL
        DOUBLE PRECISION        DIST, DIST1, TDNULL
        REAL                    TRNULL
C
C ... INITIALIZE FLAG
C
        IPOS  = 0
        DIST1 = 1.D30
        CALL TBMNUL(TINULL,TRNULL,TDNULL)
C
C ... LOOP ON VALUES
C
        IFIRST = 1
        DO 10 I = IFIRST, N
          IF (ARRAY(I).NE.TDNULL) THEN
            DIST=DABS(ARRAY(I)-VALUE)
            IF (DIST.LT.DIST1.AND.DIST.LE.ERROR) THEN
              IPOS   = I
              DIST1  = DIST
              ACTVAL = ARRAY(I)
            ENDIF
          ENDIF
10      CONTINUE
        RETURN
        END

C @(#)sqztmp.for	19.1 (ES0-DMD) 02/25/03 13:30:49
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++             
C.PURPOSE: Rebin the original image to a reasonable size to give faster         
C          execution.                                                           
C.INPUT:   AIMAGE : INPUT_A is the image frame                                  
C          NIX,...  usual descriptors of AIMAGE                                 
C.OUTPUT:  ATEMP  : an internal buffer used for rebinning of AIMAGE             
C          NSX,...  the same for ATEMP which will be managed as an image frame  
C ------------------------------------------------------------------            
      SUBROUTINE SQZTMP(AIMAGE,ATEMP,NIX,NIY,DXSTR,DYSTR,DXSTP,                 
     +                       DYSTP,NSX,NSY,SXSTR,SYSTR,SXSTP,SYSTP)             
C
      IMPLICIT         NONE
      REAL             AIMAGE(1)
      REAL             ATEMP(128,128)
      INTEGER          NIX
      INTEGER          NIY
      DOUBLE PRECISION DXSTR
      DOUBLE PRECISION DYSTR
      DOUBLE PRECISION DXSTP
      DOUBLE PRECISION DYSTP
      INTEGER          NSX
      INTEGER          NSY
      DOUBLE PRECISION SXSTR
      DOUBLE PRECISION SYSTR
      DOUBLE PRECISION SXSTP
      DOUBLE PRECISION SYSTP
C
      INTEGER          I, IF, IP, IND
      INTEGER          J, JP
      INTEGER          K
      INTEGER          L
      INTEGER          NUPX
      INTEGER          NUPY
      INTEGER          MODX
      INTEGER          MODY
      INTEGER          NORX
      INTEGER          NORY
      INTEGER          NXPIX
      INTEGER          NYPIX
      REAL             DIV
C
C *** begin code; set parameters                                                
C                                                                               
      NUPX   = NIX/128 + 1                                                      
      NUPY   = NIY/128 + 1                                                      
      MODX   = MOD(NIX,128)                                                     
      MODY   = MOD(NIY,128)                                                     
      NSX    = (NIX/NUPX)/2*2                                                   
      NSY    = (NIY/NUPY)/2*2                                                   
      NORX   = NSX*NUPX                                                         
      NORY   = NSY*NUPY                                                         
      NXPIX  = NUPX                                                             
      NYPIX  = NUPY                                                             
C                                                                               
      IF (NIX.LE.128) THEN                                                      
         NXPIX  = 1                                                             
         NSX    = NIX/2*2                                                       
         NORX   = NSX                                                           
      ELSE                                                                      
         IF (MODX.LE. (NIX-NORX)) THEN                                          
            NXPIX  = NUPX - 1                                                   
            NORX   = NIX - MODX                                                 
            NSX    = 128                                                        
         END IF                                                                 
      END IF                                                                    
C                                                                               
      IF (NIY.LE.128) THEN                                                      
         NYPIX  = 1                                                             
         NSY    = NIY/2*2                                                       
         NORY   = NSY                                                           
      ELSE                                                                      
         IF (MODY.LE. (NIY-NORY)) THEN                                          
            NYPIX  = NUPY - 1                                                   
            NORY   = NIY - MODY                                                 
            NSY    = 128                                                        
         END IF                                                                 
      END IF                                                                    
C                                                                               
      DIV    = FLOAT(NXPIX*NYPIX)                                               
      SXSTR  = DXSTR + ((NXPIX-1.)*DXSTP)/2.                                    
      SYSTR  = DYSTR + ((NYPIX-1.)*DYSTP)/2.                                    
      SXSTP  = DXSTP*NXPIX                                                      
      SYSTP  = DYSTP*NYPIX                                                      
C                                                                               
C *** squeeze the image                                                        
C                                                                               
      IF     = 1                                                                
      DO 100 J = 1,NSY                                                          
         DO 10 IND = 1,NSX                                                      
            ATEMP(IND,J) = 0.                                                   
   10    CONTINUE                                                               
C                                                                               
         DO 70 JP = 1,NYPIX                                                     
            K      = 0                                                          
            DO 50 I = 1,NORX,NXPIX                                              
               K      = K + 1                                                   
               DO 30 L = I,I + NXPIX - 1                                        
                  ATEMP(K,J) = ATEMP(K,J) + AIMAGE(IF-1+L)                      
   30          CONTINUE                                                         
   50       CONTINUE                                                            
            IF     = IF + NIX                                                   
   70    CONTINUE                                                               
C                                                                               
          DO 80 IP = 1,NSX                                                      
             ATEMP(IP,J) = ATEMP(IP,J)/DIV                                      
   80     CONTINUE                                                              
  100 CONTINUE                                                                  
C                                                                               
      RETURN                                                                    
      END                                                                       

C @(#)utilx.for	19.1 (ES0-DMD) 02/25/03 14:01:09
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE CNTDAT(INFILE,DAT,TOTAL)
C	
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C	
C.IDENTIFICATION
C  subroutine CNTDAT		version 1.00	911205
C  K. Banse			ESO - Garching
C
C.KEYWORDS
C  ASCII data file 
C
C.PURPOSE
C  get no. of data values in ASCII file
C
C.ALGORITHM
C  read all records of an ASCII file + return exact no. of chars.
C
C.INPUT/OUTPUT
C  call as  CNTDAT(INFILE,DAT,TOTAL)
C
C  input parameter:
C  INFILE:	char		name of ASCII data file
C  DAT:         char            CHAR or NUM for char. or numeric data
C 
C  output parameter:
C  TOTAL:	integer		no. of chars to get
C
C-----------------------------------------------------------------------
C	
      IMPLICIT NONE
C 
      INTEGER  TOTAL,IDUM(1)
      INTEGER  K,N,FB
C 
      CHARACTER*(*)  INFILE,DAT
      CHARACTER   RECORD*80,NEWREC*80
C 
      REAL    RBUF(60)
C 
      DOUBLE PRECISION  DDUM(1)
C 
      TOTAL = 0
C 
      N = INDEX(INFILE,' ') - 1
      IF (N.LE.0) N = LEN(INFILE)
      OPEN(UNIT=33,FILE=INFILE(1:N),STATUS='OLD',ERR=9900)
C 
C  branch on DAT
      IF (DAT(1:1) .EQ. 'C') THEN              !get total no. of chars.
1000     DO 1010, K=1,80
            RECORD(K:K) = '^'
1010     CONTINUE
         READ(33,10000,END=5000) RECORD
         DO 1050, K=80,1,-1
            IF (RECORD(K:K).NE.'^') THEN
               N = K
               GOTO 1100
            ENDIF
1050     CONTINUE
         N = 0                                 !nothing in the record
1100     TOTAL = TOTAL + N
         GOTO 1000
      ELSE          
C                                              !get total no. of numbers
2000     RECORD(1:) = ' '
         NEWREC(1:) = ' '
         READ(33,10000,END=5000) RECORD
C
         K = 1
         FB = 1                        !first blank flag is set in the beginning
         DO 2500 N=1,80
            IF (RECORD(N:N).NE.' ') THEN
               NEWREC(K:K) = RECORD(N:N)
               K = K + 1
               FB = 0
            ELSE
               IF (FB.EQ.0) THEN
                  NEWREC(K:K) = ','
                  K = K + 1
                  FB = 1
               ENDIF
            ENDIF
2500     CONTINUE
C
C  convert to real numbers to get the count
         CALL GENCNV(NEWREC,2,60,IDUM,RBUF,DDUM,K)
         IF (K.GT.0) TOTAL = TOTAL + K
         GOTO 2000
      ENDIF
C 
C  end-of-file reached
5000  CLOSE(UNIT=33)
      RETURN
C
C  file open error
9900  RECORD(1:) = 'Problems with ASCII data file: '
      RECORD(32:) = INFILE(1:)
      CALL STETER(65,RECORD)
      RETURN
C
10000 FORMAT(A)
C
      END

      SUBROUTINE CARFIL(INFILE,TOTAL,A)
C	
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C	
C.IDENTIFICATION
C  subroutine CARFIL		version 1.00	911204
C  K. Banse			ESO - Garching
C
C.KEYWORDS
C  ASCII data file 
C
C.PURPOSE
C  get character data from ASCII file
C
C.ALGORITHM
C  read all records of an ASCII file, fill buffer + return exact no. of chars.
C
C.INPUT/OUTPUT
C  call as  CARFIL(INFILE,TOTAL,A)
C
C  input parameter:
C  INFILE:	char		name of ASCII data file
C  TOTAL:	integer		no. of chars to get
C 
C  output parameter:
C  A:		char array	buffer to be filled
C
C-----------------------------------------------------------------------
C	
      IMPLICIT NONE
C 
      INTEGER  TOTAL
      INTEGER  K,N,I
C 
      CHARACTER*(*)  A,INFILE
      CHARACTER   RECORD*80
C 
      N = INDEX(INFILE,' ') - 1
      IF (N.LE.0) N = LEN(INFILE)
      OPEN(UNIT=33,FILE=INFILE(1:N),STATUS='OLD',ERR=9900)
      K = 0
C 
3000  IF (K.LT.TOTAL) THEN
         DO 3010, I=1,80
            RECORD(I:I) = '^'
3010     CONTINUE
         READ(33,10000,END=5000) RECORD
         DO 3050, I=80,1,-1
            IF (RECORD(I:I).NE.'^') THEN
               N = I
               GOTO 3100
            ENDIF
3050     CONTINUE
         GOTO 3000
C 
3100     IF (K+N.GT.TOTAL) N = TOTAL - K
         A(K+1:K+N) = RECORD(1:N)
         K = K + N
         GOTO 3000
      ENDIF
C 
C  end-of-file reached
5000  CLOSE(UNIT=33)
      RETURN
C
C  file open error
9900  RECORD(1:) = 'Problems with ASCII data file: '
      RECORD(32:) = INFILE(1:)
      CALL STETER(1,RECORD)
      RETURN
C
10000 FORMAT(A)
C
      END

C @(#)apfftc.for	19.1 (ES0-DMD) 02/25/03 13:30:44
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION:
C  SUBROUTINE  APFFTC            VERSION 1.1             FEB  15, 1988
C  P.GROSBOL                     ESO-GARCHING
C
C.PURPOSE
C  COMPUTE FOURIER COMPONENTS FOR AN AZIMUTHAL PROFILE OF A GALAXY 
C  EXTRACTED ALONG AN ELLIPSE WITH (PA,AI).
C
C.ALGORITHM
C  POINTS A INTERPOLATED BILINEAR ALONG AN ELLIPSE. THIS PROFILE IS
C  FOURIER TRANSFORMED AND THE FIRST 'NF' COMPONENTS ARE SAVED.
C
C.INPUT/OUTPUT
C  THE SUBROUTINE IS CALLED AS
C
C   CALL APFFTC( AR, NX, NY, XC, YC, R, PA, AI, NF, MF, AMP, PHA, AN)
C
C  WHERE THE PARAMETERS ARE
C     AR(NX,NY) :  ARRAY CONTAINING THE IMAGE                      (I)
C     NX        :  NO. OF X PIXELS                                 (I)
C     NY        :  NO. OF Y PIXELS                                 (I)
C     XC        :  X CENTER OF ELLIPSE IN PIXELS                   (I)
C     YC        :  Y CENTER OF ELLIPSE IN PIXELS                   (I)
C     R         :  MAJOR AXIS OF ELLIPSE IN PIXELS                 (I)
C     PA        :  POSITION ANGLE (MATH) IN RAD.                   (I)
C     AI        :  INCLINATION ANGLE IN RAD.                       (I)
C     NF        :  NO. OF FFT COMPONENT TO COMPUTE                 (I)
C     MF        :  HIGHEST FFT COEFFICIENT AVAILABLE               (O)
C     AMP(NF)   :  AMPLITUDES (N=0,1,2,...,NF-1)                   (O)
C     PHA(NF)   :  PHASES (N=0,1,2,...NF-1)                        (O)
C     AN        :  AMPLITUDE OF HIGHEST FFT FREQUENCE (NOISE)      (O)
C
C----------------------------------------------------------------------
      SUBROUTINE APFFTC(AR,NX,NY,XC,YC,R,PA,AI,NF,MF,AMP,PHA,AN)
C
      IMPLICIT  NONE
      INTEGER   NX
      INTEGER   NY
      REAL      AR(NX,NY)
      REAL      XC
      REAL      YC
      REAL      R
      REAL      PA
      REAL      AI
      INTEGER   NF
      INTEGER   MF
      REAL      AMP(NF)
      REAL      PHA(NF)
      REAL      AN
C
      INTEGER   I, IERR
      INTEGER   L
      INTEGER   MP
      PARAMETER (MP=2048)
      INTEGER   NP, NP2, NC
      REAL      FNR
      REAL      PROF(MP)
      REAL      AAA, BBB
      CHARACTER*80 MSG
C
C     INITIATE VARIABLES AND CHECK NO. OF FFT COEFFICIENT
C
      DO 100, I = 1,NF
         AMP(I) = 0.0
         PHA(I) = 0.0
  100 CONTINUE
      MF = 0
      AN = 0.0
      IF (NF.LT.1) RETURN
C
C     EXTRACT PROFINE
C
      CALL EXTELL(AR,NX,NY,XC,YC,R,PA,AI,MP,PROF,NP)
      CALL STTPUT(MSG,IERR)
      IF (NP.LE.0) RETURN
C
C     COMPUTE FFT AND COEFFICIENTS
C
      NP2 = INT( LOG(FLOAT(NP))/LOG(2.0)+0.5 )
      MF  = 2**(NP2-1)
      NC  = MIN( NF , MF )
      CALL FFA(NP2,PROF)
      FNR = 2.0 / FLOAT(NP)
      AMP(1) = 0.5 * FNR * PROF(1)
      AN     = FNR * ABS(PROF(2))
      DO 200, I = 2,NC
         L = 2*I - 1
         AMP(I) = FNR * SQRT(PROF(L)**2+PROF(L+1)**2)
C Next line gives compiler error with F77 5.1 in SunOS 5.6. CG.
C         PHA(I) = ATAN2( PROF(L+1), PROF(L) )
         AAA = PROF(L+1)
         BBB = PROF(L)
         PHA(I) = ATAN2( AAA, BBB )
  200 CONTINUE
      CALL STTPUT(MSG,IERR)
      RETURN
      END

C @(#)cracow.for	19.1 (ES0-DMD) 02/25/03 13:32:57
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C  @(#)cracow.for	5.1 (ESO-IPG) 4/5/93 15:58:27
C
C
C
C   C R A C O W
C
C   Purpose:
C   To find least squares solution of normal equations.
C
C   Input:
C   A(n1,n1) - a symmetric matrix. If matrix A represents normal
C     equations, put the sum of squares of RHS into element A(n1,n1)
C     for calculation of the chi2 and covariance matrix. Only A(i,j)
C     for i>=j are requires for input.
C   N1       - size of matrix A (number of unknowns) +1
C   M        - M>=N1 - number of condition equations
C            - M< N1 - only triangle root and its triangle inverse are
C              returned
C
C   Output:
C   M>=N1:
C     A(i,n1) - unknowns (i=1,...,n)
C     A(i,i)  - their variances
C     A(n1,n1)- variance of an observation of unit weight (Chi2/D.F.)
C     A(i,j)  - for j>=i half of the covariance matrix of unknowns
C
C   M<N1:
C     A(i,j)  - for j>=i inverse triangle root matrix (its square is A**(-1))
C     A(i,j)  - for j<i contains square root matrix except of diagonal.
C               The diagonal contains arithmetic inverses of its elements.
C
C   Method:
C   Banachiewicz-Cholesky decomposition of the normal equations.
C   This subroutine is particularly suitable for well posed problems
C   with near-orthogonal base functions.
C     This method should not be used for near singular matrices,
C   since it sufferes from large numerical errors then. Use the singular
C   value decomposition method in such cases.
C
C   Alex Schwarzenberg-Czerny                         Warsaw, October 1987
C
      DOUBLE PRECISION FUNCTION CRACOW(A,N1,MAXN1,M)
C
      INCLUDE 'MID_REL_INCL:TSA_DEF.INC'
C
      INTEGER N1,MAXN1,M
      DOUBLE PRECISION A(MAXN1,MAXN1)
C
      INTEGER I,J,K
      DOUBLE PRECISION AII,S
C
      INCLUDE 'MID_REL_INCL:TSA_CONST.INC'
C
C
C   Find Banachiewicz-Cholesky triangle root and its inverse Q, so that
C   Q*Q=A**(-1). The unknowns -a(i,n1) are a byproduct. So...
C
      CRACOW=ZERO
      IF (N1.GT.MAXN1) GOTO 99
      DO 1 I=1,N1-1
        IF (A(I,I).LE.ZERO) GOTO 99
        AII=SQRT(A(I,I))
C
C   ... complete previous i step, ...
C
        DO 5 J=1,N1
          A(J,I)=A(J,I)/AII
 5      CONTINUE
C
C   ... complete next row of the triangle matrix, ...
C
        DO 4 J=I+1,N1
          DO 41 K=1,I
            A(J,I+1)=A(J,I+1)-A(J,K)*A(I+1,K)
 41       CONTINUE
 4      CONTINUE
C
C   ... compute next column of the inverse matrix.
C
        A(I,I)=ONE/AII
        DO 6 J=1,I
          A(J,I+1)=ZERO
          DO 7 K=J,I
            A(J,I+1)=A(J,I+1)-A(J,K)*A(I+1,K)
 7        CONTINUE
 6      CONTINUE
 1    CONTINUE
C
C   Compute covariance matrix and reverse sign of unknowns
C
      IF (M.GE.N1) THEN
        A(N1,N1)=A(N1,N1)/(M-N1+1)
        DO 10 I=1,N1-1
          A(I,N1)=-A(I,N1)
          DO 12 J=1,I
            S=ZERO
            DO 11 K=I,N1-1
              S=S+A(I,K)*A(J,K)
 11         CONTINUE
            A(J,I)=S*A(N1,N1)
 12       CONTINUE
 10     CONTINUE
      ENDIF
      CRACOW=ONE
 99   END
C
C
C

C @(#)gd8c.for	19.1 (ES0-DMD) 02/25/03 13:55:08
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
	SUBROUTINE GD8029(DISPLAY,CHAN,CURSNO,SHAPE,COLOUR,XC,YC,IDST)
C	
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  a) subroutine IICINC		version 1.00	880921
C  b) subroutine IICSCV		version 1.00	880915
C  c) subroutine IICWCP		version 1.00	880915
C  d) subroutine IICRCP		version 1.00	880915
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  DeAnza, cursor boards
C
C.PURPOSE
C  fulfill the requirements as described in the IDI document
C
C.ALGORITHM
C  use DeAnza level-0 software
C
C.INPUT/OUTPUT
C  call as
C  a) IICINC(DISPLAY,CHAN,CURSNO,SHAPE,COLOUR,XC,YC,IDST)
C  b) IICSCV(DISPLAY,CURSNO,VIS,IDST)
C  c) IICWCP(DISPLAY,CHAN,CURSNO,XC,YC,IDST)
C  d) IICRCP(DISPLAY,CHAN,CURSNO,XC,YC,MEMO,IDST)
C
C  input par:
C  DISPLAY:	I*4		display id.
C  CHAN:	I*4		memory id (not used, always assumed to be -1 ...)
C  CURSNO:	I*4		cursor number, 0 or 1
C  SHAPE:	I*4		cursor shape
C				= 0 for DeAnza programmable or fixed cursors
C				  1,2,3,7 as in IDI doc. page 44
C  COLOUR:	I*4		cursor colour
C				if shape = 0 
C				= 0 for just set cursor on 
C				  1,...,16 for fixed forms 0,...,15 
C				  99 for loading a programmable cursor,
C				     name stored in keyword IN_A
C				if shape > 0 
C				  0,1,2 as in IDI doc. page 38
C  XC:		I*4		x cursor position
C  YC:		I*4		y cursor position
C
C  VIS:		I*4		1 = visible, 0 = invisible
C
C  output par:
C  MEMO:	I*4		memory cursor is currently pointing to
C
C  IDST:	I*4		return status
C	
C--------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,CHAN,CURSNO,SHAPE,COLOUR,XC,YC,IDST
	INTEGER*4	N,FIX
C		
	INTEGER*2	UNIT,CURSAR(1024)
	INTEGER*2	PMASK,COFF,RESREG,I2WORD(2),XY
	INTEGER*2	RR,LR,LCR,RCR,LPA
C 
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
C	
	EQUIVALENCE	(I2WORD(1),N)
C 
	EXTERNAL	LR,RR,LCR,RCR,LPA
C
C  get unit
	UNIT = DISPLAY
	IDST = 0
C	
C  get cursor control register
	CALL IP8QW(RCR,UNIT,DZIOSB,,,CURREG(5),2,0,4)
C	
C  set up bit masks
	IF (CURSNO.EQ.0) THEN
	   PMASK = "40000
	   COFF = "177717			!leave P2 bit as it is
	   XY = "60
	ELSE
	   PMASK = "100000
	   COFF = "176377			!leave P1 bit as it is
	   XY = "1400
	ENDIF
C
C  clear P2 (15), Y2, X2 (9,8) or P1 (14), Y1, X1 (5,4)
C  clear F3, F2,F1,F0 bits (3, 2,1,0)
C	
	N = IAND(CURREG(5),COFF)
	N = IAND(N,"177760)
	CURREG(5) = I2WORD(1)			!to avoid integer overflow ....
C	
C  branch according to cursor shape
C	
	IF (SHAPE.NE.0) GOTO 1000
C 
C  DeAnza specific stuff, see if fixed (COLOUR in [1,16]) or programmable
        IF ( (COLOUR.GE.1) .AND. (COLOUR.LE.16) ) THEN
	   FIX = COLOUR - 1
	   FIX = IAND(FIX,"17)				!cut out last 4 bits
	   CURREG(5) = IOR(CURREG(5),FIX)		!insert fixed cursor shape
	   CURREG(5) = IOR(CURREG(5),XY)		!insert X, Y components
	ELSE
	   CURREG(5) = IOR(CURREG(5),PMASK)
C	
C  check, if just enable current cursor
	   IF (COLOUR.EQ.0) GOTO 5000
C
C  read specified cursor shape from table file (COLOUR = 99)
	   CALL KKCTAB(SHAPE,COLOUR,CURSAR,IDST)
	   IF (IDST.NE.0) THEN
	      IDST = 71
	      RETURN
	   ENDIF
C	
C  set resolution register for low byte transfer
	   CALL IP8QW(RR,UNIT,DZIOSB,,,SYSREG(12),2,0,11)
	   RESREG = IAND(SYSREG(12),"177677)
	   RESREG = IOR(RESREG,"100)
	   CALL IP8QW(LR,UNIT,DZIOSB,,,RESREG,2,0,11)
C
C  finally load the cursor table into the DeAnza + reset SYSREG(12)
	   CALL IP8QW(LPA,UNIT,DZIOSB,,,CURSAR,2048,CURSNO,3)
	   CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(12),2,0,11)
	ENDIF
        GOTO 5000
C	
C  handle the "official" IDI cursor shapes
C	
1000	IF ( SHAPE.EQ.1) THEN				!Cross hair
	   CURREG(5) = IOR(CURREG(5),XY)		!insert X, Y components
	ELSE
	   CURREG(5) = IOR(CURREG(5),PMASK)		!all others are implemented
C							!via programmable cursors
C  read specified cursor shape from table file 
	   CALL KKCTAB(SHAPE,COLOUR,CURSAR,IDST)
	   IF (IDST.NE.0) THEN
	      IDST = 71
	      RETURN
	   ENDIF
C	
C  set resolution register for low byte transfer
	   CALL IP8QW(RR,UNIT,DZIOSB,,,SYSREG(12),2,0,11)
	   RESREG = IAND(SYSREG(12),"177677)
	   RESREG = IOR(RESREG,"100)
	   CALL IP8QW(LR,UNIT,DZIOSB,,,RESREG,2,0,11)
C
C  finally load the cursor table into the DeAnza + reset SYSREG(12)
	   CALL IP8QW(LPA,UNIT,DZIOSB,,,CURSAR,2048,CURSNO,3)
	   CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(12),2,0,11)
	ENDIF
C	
C  send cursor control register to the Deanza
5000	CALL IP8QW(LCR,UNIT,DZIOSB,,,CURREG(5),2,0,4)
C
C  look, if we also want to position the cursor
	IF (XC.GE.0)
     +	   CALL GD8032(DISPLAY,CHAN,CURSNO,XC,YC,IDST)
C	
C  alright then...
	RETURN
	END

	SUBROUTINE GD8030(DISPLAY,CURSNO,VIS,IDST)
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,CURSNO,VIS,IDST
	INTEGER*4	IPROG
C		
	INTEGER*2	UNIT
	INTEGER*2	CURSOFF,CURSON,PMASK,CMASK
	INTEGER*2	LCR,RCR
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
C	
	EXTERNAL	LCR,RCR
C
C  get unit
	UNIT = DISPLAY
C	
C  get cursor register 4
	CALL IP8QW(RCR,UNIT,DZIOSB,,,CURREG(5),2,0,4)
C	
C  set bit masks
	IF (CURSNO.EQ.0) THEN
	   PMASK = "40000
	   CURSOFF = "137717
	   CMASK = "60
	ELSE
	   PMASK = "100000
	   CURSOFF = "076377
	   CMASK = "1400
	ENDIF
C
C  test, if we are using fixed or programmable cursors
	IPROG = 0			! 4 bytes = 0
	IPROG = IAND(CURREG(5),PMASK)
C	
	IF (IPROG.NE.0) THEN
	   CURSON = PMASK
	ELSE
	   CURSON = CMASK
	ENDIF
C	
C  dis/enable cursor
	IF (VIS.EQ.0) THEN
	   CURREG(5) = IAND(CURREG(5),CURSOFF)
	ELSE
	   CURREG(5) = IOR(CURREG(5),CURSON)
	ENDIF
C	
C  and send it to the Deanza
	CALL IP8QW(LCR,UNIT,DZIOSB,,,CURREG(5),2,0,4)
C	
C  alright then...
	IDST = 0
	RETURN
	END

	SUBROUTINE GD8032(DISPLAY,CHAN,CURSNO,XC,YC,IDST)
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,CHAN,CURSNO,XC,YC,IDST
	INTEGER*4	N1,N
C		
	INTEGER*2	UNIT
	INTEGER*2	LCR
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
C	
	EXTERNAL	LCR
C
C  get unit
	UNIT = DISPLAY
C	
C  set index
	IF (CURSNO.EQ.0) THEN
	   N = 0
	   N1 = 1
	ELSE
	   N = 2
	   N1 = 3
	ENDIF
C	
C  cut off irrelevant parts of XC, YC
	CURREG(N1) = IAND(XC,"777)
	CURREG(N1+1) = IAND(YC,"777)
C	
C  and send it to the Deanza
	CALL IP8QW(LCR,UNIT,DZIOSB,,,CURREG(N1),4,0,N)
C	
C  alright then...
	IDST = 0
	RETURN
	END

	SUBROUTINE GD8031(DISPLAY,CHAN,CURSNO,XC,YC,MEMO,IDST)
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,CHAN,CURSNO,XC,YC,MEMO,IDST
	INTEGER*4	N1,N,ISS
C		
	INTEGER*2	UNIT,CONTROL,FCREG
	INTEGER*2	RCR,RVR,LPR
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
C	
	EXTERNAL	RCR,RVR,LPR
C
C  get unit
	UNIT = DISPLAY
C	
C  set index
	IF (CURSNO.EQ.0) THEN
	   N = 0
	   N1 = 1
	ELSE
	   N = 2
	   N1 = 3
	ENDIF
C	
C  get cursor registers from the Deanza
	CALL IP8QW(RCR,UNIT,DZIOSB,,,CURREG(N1),4,0,N)
C	
C  fill parameters
	XC = CURREG(N1)
	YC = CURREG(N1+1)
C	
C  get X-, Y- split registers + FCRs
	CALL IP8QW(RVR,UNIT,DZIOSB,,,VOCREG(1),4,0,0)
	CALL IP8QW(RVR,UNIT,DZIOSB,,,FCR(1),16,0,8)
C	
C  determine relevant FCR
	IF ( (VOCREG(1).EQ.0) .AND. (VOCREG(2).EQ.511) ) THEN
	   FCREG = FCR(4)			!no split screen
	ELSE
	   IF (XC.LT.VOCREG(1)) THEN
	      ISS = 1
	      IF (YC.LT.VOCREG(2)) ISS = 2
	   ELSE
	      ISS = 0
	      IF (YC.LT.VOCREG(2)) ISS = 3
	   ENDIF
	   FCREG = FCR(ISS+1)
	ENDIF
C	
C  pull out memory channel from FCR
	MEMO = IAND(FCREG,"17)
C	
C  alright then...
	IDST = 0
	RETURN
	END

C @(#)tdsearch1.for	19.1 (ES0-DMD) 02/25/03 14:11:20
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C
C  TDSEARCH1.FOR              2.0   17OCT1985
C                            2.1   25OCT1985
C  J.D.PONZ                     ESO - GARCHING
C
C.KEYWORDS
C
C  TABLE, SEARCH
C
C.PURPOSE
C
C  SEARCHING IN TABLE COLUMNS USING TWO REAL OR DOUBLE PRECISION VALUES
C
C.INPUT/OUTPUT
C
C       TBES1D(TID, COLUMN, VALUE, ROW, ACTVAL, STATUS)
C       TBES1I(TID, COLUMN, VALUE, ROW, ACTVAL, STATUS)
C       TBES1R(TID, COLUMN, VALUE, ROW, ACTVAL, STATUS)
C       TBES2D(TID, COLUMN1, COLUMN2, VALUE, ROW, ACTVAL, STATUS)
C       TBES2I(TID, COLUMN1, COLUMN2, VALUE, ROW, ACTVAL, STATUS)
C       TBES2R(TID, COLUMN1, COLUMN2, VALUE, ROW, ACTVAL, STATUS)
C
C.ALGORTIHM
C
C   USE THE EUCLIDEAN DISTANCE
C
C------------------------------------------------------------------
       SUBROUTINE TBES1D(TID, COLUMN, VALUE, NEXT, ACTVAL, STATUS)
C
C       SEARCH FOR ENTRY CLOSEST TO VALUE.
C       DOUBLE PRECISION VERSION
C
        IMPLICIT NONE
C
        INTEGER  TID
        INTEGER  COLUMN
        DOUBLE PRECISION VALUE
        INTEGER  NEXT
        DOUBLE PRECISION ACTVAL
        INTEGER  STATUS
C
        LOGICAL NULL, SELECT
        INTEGER NCOL, NROW, NSC, NAC, NAR, LEN, I, I1,TYPE
        DOUBLE PRECISION NEWVAL, DIST, DIST1
        CHARACTER*8   FORM
C
        INCLUDE  'MID_INCLUDE:TABLES.INC'
        INCLUDE  'MID_INCLUDE:TABLED.INC'
C
C ... CHECK ARGUMENTS
C
        CALL TBIGET(TID, NCOL, NROW, NSC, NAC, NAR, STATUS)
        IF (COLUMN.LT.0.OR.COLUMN.GT.NCOL) THEN
           STATUS = 1
           RETURN
        ENDIF
        CALL TBFGET(TID,COLUMN,FORM,LEN,TYPE,STATUS)
        IF (TYPE.EQ.D_C_FORMAT) THEN
           STATUS = 1
           RETURN
        ENDIF
C
C ... START SEARCHING 
C
        NEXT = 0
        I1    = 0
10      I1    = I1+1
        CALL TBSGET(TID, I1, SELECT, STATUS)
        IF (.NOT.SELECT) GOTO 10
        CALL TBERDD(TID, I1, COLUMN, NEWVAL, NULL, STATUS)
        IF (NULL.AND.I1.LT.NROW) GOTO 10
        NEXT   = I1
        ACTVAL = NEWVAL
        DIST   = DABS(ACTVAL-VALUE)
C
C ... ITERATION
C
        DO 20 I = I1, NROW
          CALL TBSGET(TID, I, SELECT, STATUS)
          IF (.NOT.SELECT) GOTO 20
          CALL TBERDD(TID, I, COLUMN, NEWVAL, NULL, STATUS)
          IF (.NOT. NULL) THEN
             DIST1 = DABS(NEWVAL-VALUE)
             IF (DIST1.LT.DIST) THEN
               NEXT   = I            
               DIST   = DIST1
               ACTVAL = NEWVAL
             ENDIF
          ENDIF
20      CONTINUE
       RETURN
       END

       SUBROUTINE TBES1I(TID, COLUMN, VALUE, NEXT, ACTVAL, STATUS)
C
C       SEARCH FOR ENTRY CLOSEST TO VALUE.
C       INTEGER VERSION
C
        IMPLICIT NONE
C
        INTEGER  TID
        INTEGER  COLUMN
        INTEGER  VALUE
        INTEGER  NEXT
        INTEGER  ACTVAL
        INTEGER  STATUS
C
        LOGICAL NULL, SELECT
        INTEGER NCOL, NROW, NSC, NAC, NAR, LEN, I, I1
        INTEGER NEWVAL, DIST, DIST1, TYPE
        CHARACTER*8   FORM
        INCLUDE  'MID_INCLUDE:TABLES.INC'
        INCLUDE  'MID_INCLUDE:TABLED.INC'
C
C ... CHECK ARGUMENTS
C
        CALL TBIGET(TID, NCOL, NROW, NSC, NAC, NAR, STATUS)
       IF (COLUMN.LT.0.OR.COLUMN.GT.NCOL) THEN
           STATUS = 1
           RETURN
       ENDIF
        CALL TBFGET(TID,COLUMN,FORM,LEN,TYPE,STATUS)
        IF (TYPE .EQ. D_C_FORMAT) THEN
           STATUS = 1
           RETURN
       ENDIF
C
C ... START SEARCHING 
C
        NEXT = 0
        I1    = 0
10      I1    = I1+1
        CALL TBSGET(TID, I1, SELECT, STATUS)
        IF (.NOT.SELECT) GOTO 10
        CALL TBERDI(TID, I1, COLUMN, NEWVAL, NULL, STATUS)
        IF (NULL.AND.I1.LT.NROW) GOTO 10
        NEXT   = I1
        ACTVAL = NEWVAL
        DIST   = IABS(ACTVAL-VALUE)
C
C ... ITERATION
C
        DO 20 I = I1, NROW
          CALL TBSGET(TID, I, SELECT, STATUS)
          IF (.NOT.SELECT) GOTO 20
          CALL TBERDI(TID, I, COLUMN, NEWVAL, NULL, STATUS)
          IF (.NOT. NULL) THEN
             DIST1 = IABS(NEWVAL-VALUE)
             IF (DIST1.LT.DIST) THEN
               NEXT   = I            
               DIST   = DIST1
               ACTVAL = NEWVAL
             ENDIF
          ENDIF
20      CONTINUE
       RETURN
       END

       SUBROUTINE TBES1R(TID, COLUMN, VALUE, NEXT, ACTVAL, STATUS)
C
C       SEARCH FOR ENTRY CLOSEST TO VALUE.
C       SINGLE PRECISION  VERSION
C
       IMPLICIT NONE
C
        INTEGER  TID
        INTEGER  COLUMN
        REAL     VALUE
        INTEGER  NEXT
        REAL     ACTVAL
        INTEGER  STATUS
C
        LOGICAL NULL, SELECT
        INTEGER TYPE
        INTEGER NCOL, NROW, NSC, NAC, NAR, LEN, I, I1
        REAL    NEWVAL, DIST, DIST1
        CHARACTER*8   FORM
        INCLUDE  'MID_INCLUDE:TABLES.INC'
        INCLUDE  'MID_INCLUDE:TABLED.INC'
C
C ... CHECK ARGUMENTS
C
        CALL TBIGET(TID, NCOL, NROW, NSC, NAC, NAR, STATUS)
       IF (COLUMN.LT.0.OR.COLUMN.GT.NCOL) THEN
           STATUS = 1
           RETURN
       ENDIF
        CALL TBFGET(TID,COLUMN,FORM,LEN,TYPE,STATUS)
        IF (TYPE .EQ. D_C_FORMAT) THEN
           STATUS = 1
           RETURN
       ENDIF
C
C ... START SEARCHING 
C
        NEXT  = 0
        I1    = 0
10      I1    = I1+1
        CALL TBSGET(TID, I1, SELECT, STATUS)
        IF (.NOT.SELECT) GOTO 10
        CALL TBERDR(TID, I1, COLUMN, NEWVAL, NULL, STATUS)
        IF (NULL.AND.I1.LT.NROW) GOTO 10
        NEXT   = I1
        ACTVAL = NEWVAL
        DIST   = ABS(ACTVAL-VALUE)
C
C ... ITERATION
C
        DO 20 I = I1, NROW
          CALL TBSGET(TID, I, SELECT, STATUS)
          IF (.NOT.SELECT) GOTO 20
          CALL TBERDR(TID, I, COLUMN, NEWVAL, NULL, STATUS)
          IF (.NOT. NULL) THEN
             DIST1 = ABS(NEWVAL-VALUE)
             IF (DIST1.LT.DIST) THEN
               NEXT   = I            
               DIST   = DIST1
               ACTVAL = NEWVAL
             ENDIF
          ENDIF
20      CONTINUE
       RETURN
       END

       SUBROUTINE TBES2D(TID,COLUMN1,COLUMN2,VALUE,
     .                       NEXT, ACTVAL, STATUS)
C
C       SEARCH FOR ENTRY CLOSEST TO VALUE
C       DOUBLE PRECISION VERSION
C
       IMPLICIT NONE
C
        INTEGER  TID
        INTEGER  COLUMN1
        INTEGER  COLUMN2
        DOUBLE PRECISION VALUE(2)
        INTEGER  NEXT
        DOUBLE PRECISION ACTVAL(2)
        INTEGER  STATUS
C
        LOGICAL NULL(2), SELECT
        INTEGER NCOL, NROW, NSC, NAC, NAR, LEN, I, I1, ICOL(2)
        INTEGER          TYPE
        DOUBLE PRECISION NEWVAL(2), DIST, DIST1
        CHARACTER*8      FORM
        INCLUDE  'MID_INCLUDE:TABLES.INC'
        INCLUDE  'MID_INCLUDE:TABLED.INC'
C
C ... CHECK ARGUMENTS
C
        CALL TBIGET(TID, NCOL, NROW, NSC, NAC, NAR, STATUS)
       IF (COLUMN1.LT.0.OR.COLUMN1.GT.NCOL.OR.
     .     COLUMN2.LT.0.OR.COLUMN2.GT.NCOL) THEN
           STATUS = 1
           RETURN
       ENDIF
        CALL TBFGET(TID,COLUMN1,FORM,LEN,TYPE,STATUS)
        IF (TYPE .EQ. D_C_FORMAT) THEN
           STATUS = 1
           RETURN
       ENDIF
        CALL TBFGET(TID,COLUMN2,FORM,LEN,TYPE,STATUS)
        IF (TYPE .EQ. D_C_FORMAT) THEN
           STATUS = 1
           RETURN
       ENDIF
C
C ... START SEARCHING 
C
        ICOL(1) = COLUMN1
        ICOL(2) = COLUMN2
        NEXT    = 0
        I1      = 0
10      I1      = I1+1
        CALL TBSGET(TID, I1, SELECT, STATUS)
        IF (.NOT.SELECT) GOTO 10
        CALL TBRRDD(TID, I1, 2, ICOL, NEWVAL, NULL, STATUS)
        IF ((NULL(1).OR.NULL(2)).AND.I1.LT.NROW) GOTO 10
        NEXT   = I1
        ACTVAL(1) = NEWVAL(1)
        ACTVAL(2) = NEWVAL(2)
        DIST      = DSQRT((ACTVAL(1)-VALUE(1))**2 + 
     .                    (ACTVAL(2)-VALUE(2))**2)  
C
C ... ITERATION
C
        DO 20 I = I1, NROW
          CALL TBSGET(TID, I, SELECT, STATUS)
          IF (.NOT.SELECT) GOTO 20
          CALL TBRRDD(TID, I, 2, ICOL, NEWVAL, NULL, STATUS)
          IF (.NOT. NULL(1) .AND. .NOT. NULL(2)) THEN
            DIST1     = DSQRT((NEWVAL(1)-VALUE(1))**2 + 
     .                        (NEWVAL(2)-VALUE(2))**2)  
             IF (DIST1.LT.DIST) THEN
               NEXT   = I            
               DIST   = DIST1
               ACTVAL(1) = NEWVAL(1)
               ACTVAL(2) = NEWVAL(2)
             ENDIF
          ENDIF
20      CONTINUE
       RETURN
       END

       SUBROUTINE TBES2I(TID,COLUMN1,COLUMN2,VALUE,
     .                       NEXT, ACTVAL, STATUS)
C
C       SEARCH FOR ENTRY CLOSEST TO VALUE
C       INTEGER  VERSION
C
       IMPLICIT NONE
C
        INTEGER  TID
        INTEGER  COLUMN1
        INTEGER  COLUMN2
        INTEGER  VALUE(2)
        INTEGER  NEXT
        INTEGER  ACTVAL(2)
        INTEGER  STATUS
C
        LOGICAL NULL(2), SELECT
        INTEGER NCOL, NROW, NSC, NAC, NAR, LEN, I, I1, ICOL(2)
        INTEGER NEWVAL(2), TYPE
        DOUBLE PRECISION DIST, DIST1
        CHARACTER*8   FORM
        INCLUDE  'MID_INCLUDE:TABLES.INC'
        INCLUDE  'MID_INCLUDE:TABLED.INC'
C
C ... CHECK ARGUMENTS
C
        CALL TBIGET(TID, NCOL, NROW, NSC, NAC, NAR, STATUS)
       IF (COLUMN1.LT.0.OR.COLUMN1.GT.NCOL.OR.
     .     COLUMN2.LT.0.OR.COLUMN2.GT.NCOL) THEN
           STATUS = 1
           RETURN
       ENDIF
        CALL TBFGET(TID,COLUMN1,FORM,LEN,TYPE,STATUS)
        IF (TYPE .EQ. D_C_FORMAT) THEN
           STATUS = 1
           RETURN
       ENDIF
        CALL TBFGET(TID,COLUMN2,FORM,LEN,TYPE,STATUS)
        IF (TYPE.EQ. D_C_FORMAT) THEN
           STATUS = 1
           RETURN
       ENDIF
C
C ... START SEARCHING 
C
        ICOL(1) = COLUMN1
        ICOL(2) = COLUMN2
        NEXT    = 0
        I1      = 0
10      I1      = I1+1
        CALL TBSGET(TID, I1, SELECT, STATUS)
        IF (.NOT.SELECT) GOTO 10
        CALL TBRRDI(TID, I1, 2, ICOL, NEWVAL, NULL, STATUS)
        IF ((NULL(1).OR.NULL(2)).AND.I1.LT.NROW) GOTO 10
        NEXT   = I1
        ACTVAL(1) = NEWVAL(1)
        ACTVAL(2) = NEWVAL(2)
        DIST1     = (ACTVAL(1)-VALUE(1))**2 + (ACTVAL(2)-VALUE(2))**2  
        DIST      = DSQRT(DIST1) 
C
C ... ITERATION
C
        DO 20 I = I1, NROW
          CALL TBSGET(TID, I, SELECT, STATUS)
          IF (.NOT.SELECT) GOTO 20
          CALL TBRRDI(TID, I, 2, ICOL, NEWVAL, NULL, STATUS)
          IF (.NOT. NULL(1) .AND. .NOT. NULL(2)) THEN
            DIST1 = (NEWVAL(1)-VALUE(1))**2 + (NEWVAL(2)-VALUE(2))**2  
            DIST1 = DSQRT(DIST1)
             IF (DIST1.LT.DIST) THEN
               NEXT   = I            
               DIST   = DIST1
               ACTVAL(1) = NEWVAL(1)
               ACTVAL(2) = NEWVAL(2)
             ENDIF
          ENDIF
20      CONTINUE
       RETURN
       END


       SUBROUTINE TBES2R(TID,COLUMN1,COLUMN2,VALUE,
     .                       NEXT, ACTVAL, STATUS)
C
C       SEARCH FOR ENTRY CLOSEST TO VALUE
C       SINGLE PRECISION VERSION
C
       IMPLICIT NONE
C
        INTEGER  TID
        INTEGER  COLUMN1
        INTEGER  COLUMN2
        REAL     VALUE(2)
        INTEGER  NEXT
        REAL     ACTVAL(2)
        INTEGER  STATUS
C
        LOGICAL NULL(2), SELECT
        INTEGER NCOL, NROW, NSC, NAC, NAR, LEN, I, I1, ICOL(2)
        INTEGER TYPE
        REAL    NEWVAL(2), DIST, DIST1
        CHARACTER*8   FORM
        INCLUDE  'MID_INCLUDE:TABLES.INC'
        INCLUDE  'MID_INCLUDE:TABLED.INC'
C
C ... CHECK ARGUMENTS
C
        CALL TBIGET(TID, NCOL, NROW, NSC, NAC, NAR, STATUS)
       IF (COLUMN1.LT.0.OR.COLUMN1.GT.NCOL.OR.
     .     COLUMN2.LT.0.OR.COLUMN2.GT.NCOL) THEN
           STATUS = 1
           RETURN
       ENDIF
        CALL TBFGET(TID,COLUMN1,FORM,LEN,TYPE,STATUS)
        IF (TYPE .EQ. D_C_FORMAT) THEN
           STATUS = 1
           RETURN
       ENDIF
        CALL TBFGET(TID,COLUMN2,FORM,LEN,TYPE,STATUS)
        IF (TYPE .EQ. D_C_FORMAT) THEN
           STATUS = 1
           RETURN
       ENDIF
C
C ... START SEARCHING 
C
        ICOL(1) = COLUMN1
        ICOL(2) = COLUMN2
        NEXT    = 0
        I1      = 0
10      I1      = I1+1
        CALL TBSGET(TID, I1, SELECT, STATUS)
        IF (.NOT.SELECT) GOTO 10
        CALL TBRRDR(TID, I1, 2, ICOL, NEWVAL, NULL, STATUS)
        IF ((NULL(1).OR.NULL(2)).AND.I1.LT.NROW) GOTO 10
        NEXT   = I1
        ACTVAL(1) = NEWVAL(1)
        ACTVAL(2) = NEWVAL(2)
        DIST      = SQRT((ACTVAL(1)-VALUE(1))**2 + 
     .                   (ACTVAL(2)-VALUE(2))**2)  
C
C ... ITERATION
C
        DO 20 I = I1, NROW
          CALL TBSGET(TID, I, SELECT, STATUS)
          IF (.NOT.SELECT) GOTO 20
          CALL TBRRDR(TID, I, 2, ICOL, NEWVAL, NULL, STATUS)
          IF (.NOT. NULL(1) .AND. .NOT. NULL(2)) THEN
            DIST1     = SQRT((NEWVAL(1)-VALUE(1))**2 + 
     .                       (NEWVAL(2)-VALUE(2))**2)  
             IF (DIST1.LT.DIST) THEN
               NEXT   = I            
               DIST   = DIST1
               ACTVAL(1) = NEWVAL(1)
               ACTVAL(2) = NEWVAL(2)
             ENDIF
          ENDIF
20      CONTINUE
       RETURN
       END

C @(#)phamod.for	19.1 (ES0-DMD) 02/25/03 13:30:47
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE PHAMOD(PNEW,POLD,NP)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C   SUBROUTINE  PHAMOD              VER. 1.1                MAY  13, 1987
C   P.GROSBOL                       ESO/GARCHING
C
C.PURPOSE
C   ADDS A NUMBER OF PI/M TO PHASES IN ORDER TO REMOVE PHASE JUMPS
C   I.E. MINUMIZE THE DIFFERENCE BETWEEN PHASES IN PNEW AND POLD.
C   IT IS ASSUMED THAT THE PHASES COME FROM A FOURIER TRANSFORM
C   MODULO 2*PI AND THE IN RADIANS. THE TWO PHASE ARRAYS CONTAIN
C   THE PHASES OF M=0,1,2,3,4,5,.. IN INDEX N=1,2,3,4,5,6,..
C
C.INPUT/OUTPUT
C   THE PARAMETERS ARE
C       PNEW(NP) :  ARRAY WITH NEW PHASES PNEW(1):M=0, PNEW(2):M=1 ETC.
C       POLD(NP) :  ARRAY WITH OLD PHASES
C       NP       :  NO. OF PHASES IN ARRAY
C
C-------------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER  NP
      REAL     PNEW(NP)
      REAL     POLD(NP)
C
      INTEGER  I,IDF
      REAL     PI2
      REAL     DIF
      REAL     RFQ
C
C     SETUP CONSTANTS ETC.
C
      PI2 = 8.0 * ATAN(1.0)
C
C     CORRECT PHASE JUMPS BETWEEN OLD AND NEW
C
      DO 1000, I = 2, NP
         RFQ = 1.0 / FLOAT(I-1)
         DIF = RFQ * PI2
         PNEW(I) = RFQ * PNEW(I)
         IDF = INT( (PNEW(I)-POLD(I))/DIF + 10000.5) - 10000
         PNEW(I) = PNEW(I) - FLOAT(IDF) * DIF
 1000 CONTINUE
C
C     COPY PHASES FROM NEW TO OLD AND RETURN
C
      DO 3000, I = 1,NP
         POLD(I) = PNEW(I)
 3000 CONTINUE
      RETURN
      END

C @(#)setzero.for	19.1 (ES0-DMD) 02/25/03 13:17:44
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE SETZER(VECTOR,DIM)                                            
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++        
C                                                                               
C.MODULE                                                                        
C       FIT                                                                     
C                                                                               
C.NAME                                                                          
C       SETZERO                                                                 
C                                                                               
C.PURPOSE                                                                       
C       Set zero in a vector                                                    
C                                                                               
C.KEYWORDS                                                                      
C       Linear algebra.                                                         
C                                                                               
C.DESCRIPTION                                                                   
C       trivial                                                                 
C                                                                               
C.RESTRICTIONS                                                                  
C       ...                                                                     
C                                                                               
C.LANGUAGE                                                                      
C       FORTRAN                                                                 
C                                                                               
C.CALLING SEQUENCE                                                              
C       CALL SETZERO (VECTOR,DIM)                                               
C                                                                               
C.INPUT PARAMETERS                                                              
C       DIM                           INTEGER Dimension of the vector           
C                                                                               
C.MODIFIED PARAMETERS                                                           
C       none                                                                    
C                                                                               
C.OUTPUT PARAMETERS                                                             
C       VECTOR    (DIM)               DOUBLE  Input vector                      
C                                                                               
C.FILES                                                                         
C       none                                                                    
C                                                                               
C.MODULES CALLED                                                                
C       none                                                                    
C                                                                               
C.AUTHOR                                                                        
C       Ph. DEFERT,      Feb 1986                                               
C                                                                               
C.MODIFICATIONS                                                                 
C                                                                               
C                                                                               
C-----------------------------------------------------------------------        
C      IMPLICIT NONE                                                            
C     ..                                                                        
C     .. Scalar Arguments ..                                                    
      INTEGER DIM                                                               
C     ..                                                                        
C     .. Array Arguments ..                                                     
      DOUBLE PRECISION VECTOR(DIM)                                              
C     ..                                                                        
C     .. Local Scalars ..                                                       
      INTEGER I                                                                 
                                                                                
      DO 10 I = 1,DIM                                                           
          VECTOR(I) = 0.D0                                                      
   10 CONTINUE                                                                  
      RETURN                                                                    
                                                                                
      END                                                                       

C @(#)tdsel.for	19.1 (ES0-DMD) 02/25/03 14:11:20
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  19:57 - 11 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION        TDSEL.FOR
C.KEYWORDS           TABLE, APPLICATIONS
C.ENVIRONMENT  MIDAS
C.PURPOSE
C
C     Handle descriptor with selection criterion
C     The routine TDRSEL has to be upgraded to avoid a 
C     terrible crash when the descriptor is not present
C
C------------------------------------------------------------------
      SUBROUTINE TDRSEL(TID,LINE,ISTAT)
C
C    READ SELECT FLAG
C
      IMPLICIT NONE
      INTEGER       TID          !  IN : table ident
      CHARACTER*(*) LINE         !  OUT: selection criterion
      INTEGER       ISTAT        !  OUT: output status
C
      INTEGER ACTVAL
      CHARACTER*10   SELDES
      INTEGER       START, LENGTH,DNULL,DUNIT(16)
      DATA          START/1/
      DATA          LENGTH/64/        
      DATA          SELDES/'TSELTABL '/
C
      LINE   = '-'
C
C ... MODIFY THE ERROR CONTROL
C
C
C ... READ DESCRIPTOR
C
      CALL STDRDC(TID,SELDES,1,START,LENGTH,ACTVAL,LINE,
     +            DUNIT,DNULL,ISTAT)
      RETURN

      END

      SUBROUTINE TDWSEL(TID,LINE,ISTAT)
C
C    WRITE SELECT FLAG
C
      IMPLICIT NONE
      INTEGER       TID      ! IN : table ident
      CHARACTER*(*) LINE     ! IN : selection criterion
      INTEGER       ISTAT    ! OUT: output status
C
      CHARACTER*10  SELDES
      INTEGER       START, LENGTH, DUNIT(16)
      DATA          START/1/
      DATA          LENGTH/64/        
      DATA          SELDES/'TSELTABL  '/
C
C ... WRITE DESCRIPTOR
C
      CALL STDWRC(TID,SELDES,1,LINE,START,LENGTH,DUNIT,ISTAT)
      RETURN
      END

C @(#)genzz1.for	13.1.1.3 (ESO-DMD) 02/12/99 19:14:53
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM GENZZ1
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  program GENZZ1		version 1.00    890705
C  K. Banse                     ESO - Garching
C  1.10   910204
C
C.KEYWORDS
C  general image processing functions
C
C.PURPOSE
C  merge FNDPIX.FOR, POLYGO.FOR, ROTATE.FOR, ROTGEN.FOR 
C        SCALE.FOR, WEIGHT.FOR
C
C.ALGORITHM
C  straight forward
C
C.INPUT/OUTPUT
C  the following keys are used:
C
C  ACTION/C/1/2			option,
C				= FN, for FNDPIX
C				= PO, for POLYGO
C
C.VERSIONS
C  010410		last modif
C 
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      IAV,STAT
      INTEGER      UNIT(1),NULLO
C
      CHARACTER    ACTION*2
C
C  get into MIDAS
      CALL STSPRO('GENZZ1')
C
C  get action flag
      CALL STKRDC('ACTION',1,1,2,IAV,ACTION,UNIT,NULLO,STAT)
C 
      IF (ACTION.EQ.'FN') THEN
         CALL SUBFNP
      ELSE IF (ACTION.EQ.'PO') THEN
         CALL SUBPOL
      ELSE
         CALL STETER(11,'Invalid task for module "genzz1.for"...')
      ENDIF
C
C  That's it folks...
      CALL STSEPI
C
      END

      SUBROUTINE SUBFNP
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine SUBFNP		version 1.40    850822
C  K. Banse                     ESO - Garching
C  1.50	890123	1.60	891124
C
C.KEYWORDS
C  bulk data frame, pixel range
C
C.PURPOSE
C  1) find 1. pixel which falls inside or outside given interval
C  2) find pixel no's. of min + max
C
C.ALGORITHM
C  straight forward
C
C.INPUT/OUTPUT
C  the following keys are used:
C
C  IN_A/C/1/60                 	name of input frame
C  INPUTR/R/1/2                 XL, XH for interval [XL,XH]
C  ACTION/C/3/4			IN or OUT, to indicate search for inside or 
C				           outside of given interval
C                  		or MI, if we search for min + max
C  OUTPUTI/I/1/2                x-, y-coordinate of 1. pixel which
C                  		matches,
C                  		= 0,0 if no match
C  OUTPUTR/R/1/1                value, if matching pixel found
C  or
C  OUTPUTI/I/1/4                x-, y-coords. of minimum and maximum
C  OUTPUTR/R/1/2                min + max value,
C                  		also stored into descriptor LHCUTS/R/3/2
C  OUTPUTR/R/3/4                world coords. of OUTPUTI
C
C.VERSIONS
C  1.40		creation
C  1.50		move to FORTRAN 77 + new ST interfaces
C		and add table option to record all pixels in/out of interval
C  1.60		really put 0,0 into OUTPUTI if nothing found ...
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      IAV,IDUM
      INTEGER      N,NAXIS,NPIX(3),SPIX(3),EPIX(3)
      INTEGER*8    PNTR
      INTEGER      IMNO,STAT
      INTEGER      UNIT(1),NULLO,MADRID(1)
      INTEGER      TID,TCOLS(4),NCOLS,ROWMAX,XRFLAG
      INTEGER      RETBUF(3),CHUNK
C
      REAL         XRNG(2)
C
      DOUBLE PRECISION DDUM
C
      CHARACTER    FRAME*60,ACTION*4,TABLE*72,AREA*80
      CHARACTER    TLABL(4)*16,TUNIT(4)*16,CXRNG*60
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      COMMON  /VMR/ MADRID
C
      DATA    TLABL   /'X_PIX ','Y_PIX ','Z_PIX ','VALUE '/
      DATA    TUNIT   /'FRAME_PIXEL','FRAME_PIXEL','FRAME_PIXEL',' '/
      DATA    XRNG    /0.0,0.0/
      DATA    NPIX    /1,1,1/,  SPIX  /1,1,1/,   EPIX  /1,1,1/
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      CALL STPSET(F_FITS_PARM,1,STAT)
C 
C  get name of input image, interval + action flags
      CALL STKRDC('IN_A',1,1,60,IAV,FRAME,UNIT,NULLO,STAT)
      CALL STKRDC('P2',1,1,60,IAV,CXRNG,UNIT,NULLO,STAT)
      CALL STKRDC('ACTION',1,3,4,IAV,ACTION,UNIT,NULLO,STAT)
      CALL UPCAS(ACTION,ACTION)
C
C  find max. no. of lines we can use
      CALL STFOPN(FRAME,D_R4_FORMAT,0,F_IMA_TYPE,IMNO,STAT)
      CALL STDRDI(IMNO,'NAXIS',1,1,IAV,NAXIS,UNIT,NULLO,STAT)
      CALL STDRDI(IMNO,'NPIX',1,3,IAV,NPIX,UNIT,NULLO,STAT)
      CALL HACKUP(NPIX(1),D_R4_FORMAT,RETBUF)
C
      CHUNK = RETBUF(1)*NPIX(1)	                 !size of memory to allocate
      CALL STFXMP(CHUNK,D_R4_FORMAT,PNTR,STAT)
C
C  handle FIND/MINMAX 
C 
      IF (ACTION(1:2).EQ.'MI') THEN
         CALL FNDMX(RETBUF,IMNO,MADRID(PNTR),NAXIS,NPIX)
      ELSE
C
C  handle FIND/PIXEL 
C 
         XRFLAG = 0                                 !check interval
         IF (CXRNG(1:2).EQ.'<,') THEN
            IF (CXRNG(3:3).EQ.'>') THEN
               XRFLAG = 3                           !  <,>
            ELSE
               XRFLAG = 1                           !  <,m 
               CALL GENCNV(CXRNG(3:),2,1,IDUM,XRNG(2),DDUM,N)
               IF (N.NE.1) CALL STETER(3,'Bad syntax for interval...')
            ENDIF
         ELSE
            N = INDEX(CXRNG,',')
            IF (N.LT.2) CALL STETER(3,'Bad syntax for interval...')
            N = N + 1
            IF (CXRNG(N:N).EQ.'>') THEN
               XRFLAG = 2                           !  n,>
               CALL GENCNV(CXRNG,2,1,IDUM,XRNG(1),DDUM,N)
               IF (N.NE.1) CALL STETER(3,'Bad syntax for interval...')
            ELSE
               CALL GENCNV(CXRNG,2,2,IDUM,XRNG,DDUM,N)
               IF (N.NE.2) CALL STETER(3,'Bad syntax for interval...')
            ENDIF
         ENDIF
C 
         CALL STKRDC('P7',1,1,60,IAV,AREA,UNIT,NULLO,STAT)
         IF (AREA(1:1).NE.'?')                   !check sub-area option 
     +      CALL EXTCOO(IMNO,AREA,3,IAV,SPIX,EPIX,STAT)
C 
         IF (ACTION(4:4).NE.'A') THEN            !only look for first one
            IF (AREA(1:1).NE.'?') THEN   
               CALL FNDPXA(RETBUF,IMNO,MADRID(PNTR),NAXIS,NPIX,
     +                     ACTION(1:3),XRNG,XRFLAG,CXRNG,SPIX,EPIX)
            ELSE
               CALL FNDPX(RETBUF,IMNO,MADRID(PNTR),NAXIS,NPIX,
     +                    ACTION(1:3),XRNG,XRFLAG,CXRNG)
            ENDIF
C
         ELSE                                    !look for all pixels
            CALL STKRDI('INPUTI',1,1,IAV,ROWMAX,UNIT,NULLO,STAT)
            CALL STKRDC('IN_B',1,1,72,IAV,TABLE,UNIT,NULLO,STAT)
            N = INDEX(TABLE,',')
            IF (TABLE(1:1).EQ.'+') THEN
               TID = -99                         !no table or image output
               IF (AREA(1:1).NE.'?') THEN 
                  CALL FNDPXS(RETBUF,IMNO,MADRID(PNTR),NAXIS,NPIX,
     +                        ACTION(1:3),XRNG,XRFLAG,CXRNG,
     +                        TID,TCOLS,ROWMAX,SPIX,EPIX)
               ELSE
                  CALL FNDPXT(RETBUF,IMNO,MADRID(PNTR),NAXIS,NPIX,
     +                        ACTION(1:3),XRNG,XRFLAG,CXRNG,
     +                        TID,TCOLS,ROWMAX)
               ENDIF
C
            ELSE IF (N.GT.0) THEN       !we have name,image
               TABLE(N:) = ' '
               N = NPIX(1)*NPIX(2)*NPIX(3)
               CALL STFCRE('middummprov',D_R4_FORMAT,F_O_MODE,
     +                     F_IMA_TYPE,N,TID,STAT)
               TID = -TID                              !so the subroutine knows
               IF (AREA(1:1).NE.'?') THEN
                  CALL FNDPXS(RETBUF,IMNO,MADRID(PNTR),NAXIS,NPIX,
     +                        ACTION(1:3),XRNG,XRFLAG,CXRNG,
     +                        TID,TCOLS,ROWMAX,SPIX,EPIX)
               ELSE
                  CALL FNDPXT(RETBUF,IMNO,MADRID(PNTR),NAXIS,NPIX,
     +                        ACTION(1:3),XRNG,XRFLAG,CXRNG,
     +                        TID,TCOLS,ROWMAX)
               ENDIF
               CALL STFCLO(IMNO,STAT)                  !close input frame
               IF (RETBUF(2).LT.1) THEN                !no pixel there...
                  CALL STFCLO(TID,STAT)
                  CALL STFDEL('middummprov.bdf',STAT)
                  CALL STTPUT('no output file created',STAT)
                  RETURN
               ENDIF
               IF (ROWMAX.NE.0) THEN
                  IF (ROWMAX.LT.0) ROWMAX = -ROWMAX
                  IF (RETBUF(2).GT.ROWMAX) RETBUF(2) = ROWMAX
               ENDIF
C 
C  if more than 5 percent different in size, crop out image
               IDUM = (N / 100) * 5 
               IF ((N-RETBUF(2)).GT.IDUM) THEN
                  NPIX(1) = RETBUF(2)                  !real no. of pixels
                  CALL STFCRE(TABLE,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +                     RETBUF(2),IMNO,STAT)
                  IF (NPIX(1).LE.CHUNK) THEN
                     CALL STFGET(TID,1,NPIX(1),IAV,MADRID(PNTR),STAT)
                     CALL STFPUT(IMNO,1,NPIX(1),MADRID(PNTR),STAT)
                  ELSE
                     IDUM = NPIX(1)/CHUNK
                     TCOLS(1) = 1
                     DO 770, N=1,IDUM
                        CALL STFGET(TID,TCOLS(1),CHUNK,IAV,MADRID(PNTR),
     +                              STAT)
                        CALL STFPUT(IMNO,TCOLS(1),CHUNK,MADRID(PNTR),
     +                              STAT)
                        TCOLS(1) = TCOLS(1) + CHUNK
770                  CONTINUE
                     IDUM = NPIX(1) - (IDUM*CHUNK)     !look for remainder
                     IF (IDUM.GT.0) THEN
                        CALL STFGET(TID,TCOLS(1),IDUM,IAV,MADRID(PNTR),
     +                              STAT)
                        CALL STFPUT(IMNO,TCOLS(1),IDUM,MADRID(PNTR),
     +                              STAT)
                     ENDIF
                  ENDIF
                  CALL STFCLO(TID,STAT)
                  CALL STFDEL('middummprov.bdf',STAT)
                  TID = -99                            !switch for later
               ELSE
                  NPIX(1) = N
                  IMNO = TID
               ENDIF
               TCOLS(1) = 1                            !use 1-dim result image
               CALL STDWRI(IMNO,'NAXIS',TCOLS,1,1,UNIT,STAT)
               CALL STDWRI(IMNO,'NPIX',NPIX,1,1,UNIT,STAT)
               DDUM = 0.0
               CALL STDWRD(IMNO,'START',DDUM,1,1,UNIT,STAT)
               DDUM = 1.0
               CALL STDWRD(IMNO,'STEP',DDUM,1,1,UNIT,STAT)
               AREA(1:) = 'FIND/PIX outfile '
               CALL STDWRC(IMNO,'IDENT',1,AREA,1,72,UNIT,STAT)
               AREA(1:) = 'data '
               CALL STDWRC(IMNO,'CUNIT',1,AREA,1,32,UNIT,STAT)
               IF (TID.NE.-99) THEN
                  N = INDEX(TABLE,'.')                !already file type?
                  IF (N.LT.1) THEN
                     N = INDEX(TABLE,' ')
                     TABLE(N:) = '.bdf'
                  ENDIF
               CALL STFRNM('middummprov.bdf',TABLE,STAT)
               ENDIF
C
            ELSE
               NCOLS = NAXIS + 1
               CALL TBTINI(TABLE,0,F_O_MODE,NCOLS+5,200,TID,STAT)
               DO 800, N=1,NCOLS-1
                  CALL TBCINI(TID,D_R4_FORMAT,1,'F10.1',TUNIT(N),
     +                        TLABL(N),TCOLS(N),STAT)
800            CONTINUE
               CALL TBCINI(TID,D_R4_FORMAT,1,'G12.6',TUNIT(4),
     +                     TLABL(4),TCOLS(NCOLS),STAT)
C
               IF (AREA(1:1).NE.'?') THEN
                  CALL FNDPXS(RETBUF,IMNO,MADRID(PNTR),NAXIS,NPIX,
     +                        ACTION(1:3),XRNG,XRFLAG,CXRNG,
     +                        TID,TCOLS,ROWMAX,SPIX,EPIX)
               ELSE
                  CALL FNDPXT(RETBUF,IMNO,MADRID(PNTR),NAXIS,NPIX,
     +                        ACTION(1:3),XRNG,XRFLAG,CXRNG,
     +                        TID,TCOLS,ROWMAX)
               ENDIF
               CALL TBSINI(TID,STAT)
               CALL DSCUPT(TID,TID,' ',STAT)           !create descr. HISTORY 
               CALL TBTCLO(TID,STAT)
            ENDIF
         ENDIF
      ENDIF
C
      RETURN
      END

      SUBROUTINE FNDMX(INFO,IMNO,A,NAXIS,NPIX)
C
      IMPLICIT NONE
C
      INTEGER      INFO(*),IMNO,NAXIS,NPIX(*)
      INTEGER      K,M,N,UNIT(1),NOLOOP
      INTEGER      KOFF,KLAST,CHUNK,IAV,STAT
      INTEGER      MIMPIX(2),MINPIX,MMIN,LMIN,KMIN
      INTEGER      OUTI(6),MAXPIX,MMAX,LMAX,KMAX
C 
      DOUBLE PRECISION     FINDXY(4),WINDXY(4)
C 
      REAL         A(*)
      REAL         CUTS(2),FCUTS(2),OUTR(8)
C 
      CHARACTER    CBUF*80
C 
      CHUNK = INFO(1) * NPIX(1)                      !no. of lines * x-dim
      KLAST = NPIX(2) * NPIX(3)                      !total no. of lines
      NOLOOP = KLAST / INFO(1)
      IF ((NOLOOP*INFO(1)).LT.KLAST) NOLOOP = NOLOOP + 1
      KOFF = 1
      CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
      CALL MNMX(A,IAV,CUTS(1),MIMPIX)                !do it once
      MINPIX = MIMPIX(1)
      MAXPIX = MIMPIX(2)
C
      IF (NOLOOP.GT.1) THEN
         DO 100, N=2,NOLOOP
            KOFF = KOFF + IAV
            CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
            CALL MNMX(A,IAV,FCUTS(1),MIMPIX)
            IF (FCUTS(1).LT.CUTS(1)) THEN
               MINPIX = MIMPIX(1) + KOFF - 1         
               CUTS(1) = FCUTS(1)
            ENDIF
            IF (FCUTS(2).GT.CUTS(2)) THEN
               MAXPIX = MIMPIX(2) + KOFF - 1         
               CUTS(2) = FCUTS(2)
            ENDIF
100      CONTINUE
      ENDIF
C
C  now we have the final data
      IF (NAXIS.EQ.3) THEN
         K = NPIX(1)*NPIX(2)
         M = MINPIX/K
         MMIN = MINPIX - M*K
         IF (MMIN.EQ.0) THEN
            MMIN = M
            LMIN = NPIX(2)
            KMIN = NPIX(1)
         ELSE
            MINPIX = MMIN
            MMIN = M + 1
            N = MINPIX/NPIX(1)
            KMIN = MINPIX - N*NPIX(1)
            IF (KMIN.EQ.0) THEN
               LMIN = N
               KMIN = NPIX(1)
            ELSE
               LMIN = N + 1
            ENDIF
         ENDIF
      ELSE IF (NAXIS.EQ.2) THEN
         N = MINPIX/NPIX(1)
         KMIN = MINPIX - N*NPIX(1)
         IF (KMIN.EQ.0) THEN
            LMIN = N
            KMIN = NPIX(1)
         ELSE
            LMIN = N + 1
         ENDIF
      ELSE
         KMIN = MINPIX
      ENDIF
C 
      IF (NAXIS.EQ.3) THEN
         K = NPIX(1)*NPIX(2)
         M = MAXPIX/K
         MMAX = MAXPIX - M*K
         IF (MMAX.EQ.0) THEN
            MMAX = M
            LMAX = NPIX(2)
            KMAX = NPIX(1)
         ELSE
            MAXPIX = MMAX
            MMAX = M + 1
            N = MAXPIX/NPIX(1)
            KMAX = MAXPIX - N*NPIX(1)
            IF (KMAX.EQ.0) THEN
               LMAX = N
               KMAX = NPIX(1)
            ELSE
               LMAX = N + 1
            ENDIF
         ENDIF
      ELSE IF (NAXIS.EQ.2) THEN
         N = MAXPIX/NPIX(1)
         KMAX = MAXPIX - N*NPIX(1)
         IF (KMAX.EQ.0) THEN
            LMAX = N
            KMAX = NPIX(1)
         ELSE
            LMAX = N + 1
         ENDIF
      ELSE
         KMAX = MAXPIX
      ENDIF
C 
C use the correct WCS conversion routines
C 
      DO 440,N=1,4
         FINDXY(N) = 0.0
         WINDXY(N) = 0.0
440   CONTINUE
      OUTR(1) = CUTS(1)
      OUTR(2) = CUTS(2)
      DO 500,N=1,6
         OUTI(N) = 1
         OUTR(N+2) = 0.0
500   CONTINUE
      CALL FPXWCO(0,IMNO,FINDXY,WINDXY,STAT)          !init conversion
C 
      OUTI(1) = KMIN
      OUTI(3) = KMAX
      FINDXY(1) = KMIN
C 
      IF (NAXIS.EQ.1) THEN
         CALL FPXWCO(1,IMNO,FINDXY,WINDXY,STAT)       !frame pix -> wc
         OUTR(3) = WINDXY(1)
         FINDXY(1) = KMAX
         CALL FPXWCO(1,IMNO,FINDXY,WINDXY,STAT) 
         OUTR(5) = WINDXY(1)
         WRITE(CBUF,20000) CUTS(1),CUTS(2),KMIN,KMAX
C 
      ELSE IF (NAXIS.EQ.2) THEN
         FINDXY(2) = LMIN
         OUTI(2) = LMIN
         CALL FPXWCO(1,IMNO,FINDXY,WINDXY,STAT)       !frame pix -> wc
         OUTR(3) = WINDXY(1)
         OUTR(4) = WINDXY(2)
         FINDXY(1) = KMAX
         FINDXY(2) = LMAX
         OUTI(4) = LMAX
         CALL FPXWCO(1,IMNO,FINDXY,WINDXY,STAT)       !frame pix -> wc
         OUTR(5) = WINDXY(1)
         OUTR(6) = WINDXY(2)
         WRITE(CBUF,20001) CUTS(1),CUTS(2)
         CALL STTPUT(CBUF,STAT)
         WRITE(CBUF,20002) KMIN,LMIN,KMAX,LMAX
C 
      ELSE IF (NAXIS.EQ.3) THEN
         FINDXY(2) = LMIN
         FINDXY(3) = MMIN
         OUTI(2) = LMIN
         OUTI(5) = MMIN
         CALL FPXWCO(1,IMNO,FINDXY,WINDXY,STAT)       !frame pix -> wc
         OUTR(3) = WINDXY(1)
         OUTR(4) = WINDXY(2)
         OUTR(7) = WINDXY(3)
         FINDXY(1) = KMAX
         FINDXY(2) = LMAX
         FINDXY(3) = MMAX
         OUTI(4) = LMAX
         OUTI(6) = MMAX
         CALL FPXWCO(1,IMNO,FINDXY,WINDXY,STAT)       !frame pix -> wc
         OUTR(5) = WINDXY(1)
         OUTR(6) = WINDXY(2)
         OUTR(8) = WINDXY(3)
         WRITE(CBUF,20001) CUTS(1),CUTS(2)
         CALL STTPUT(CBUF,STAT)
         WRITE(CBUF,20003) KMIN,LMIN,MMIN,KMAX,LMAX,MMAX
      ENDIF
C
      CALL STTPUT(CBUF,STAT)
      CALL STKWRI('OUTPUTI',OUTI,1,6,UNIT,STAT)
      CALL STKWRR('OUTPUTR',OUTR,1,8,UNIT,STAT)
C
C  finally update descr. LHCUTS
      CALL STDWRR(IMNO,'LHCUTS',CUTS,3,2,UNIT,STAT)
C
C  that's it folks...
      RETURN
C
C  Formats
20000 FORMAT('min =',G15.5,', max =',G15.5,
     +       ' at frame pixel (',I6,'), (',I6,')')
20001 FORMAT('min =',G15.5,', max =',G15.5)
20002 FORMAT('at frame pixel (',I6,',',I6,'), (',I6,',',I6,')')
20003 FORMAT('at frame pixel (',I6,',',I6,',',I6,'), (',
     +       I6,',',I6,',',I6,')')
      END

      SUBROUTINE FNDPX(INFO,IMNO,A,NAXIS,NPIX,ACTION,
     +                 XRNG,XRFLAG,CXB)
C
      IMPLICIT NONE
C
      INTEGER      INFO(*),IMNO,NAXIS,NPIX(*),XRFLAG
      INTEGER      N,IX,IY,IZ,KX,KY,KZ,INDXY(3),UNIT(1)
      INTEGER      KOFF,KLAST,CHUNK,IAV,STAT
C
      REAL         A(*),XRNG(*)
      REAL         XL,XH,VAL
C
      CHARACTER*(*) ACTION,CXB
      CHARACTER     SIDE*8,CBUF*80
C
C  init
      KX = 0
      KY = 0
      KZ = 0
      XL = XRNG(1)
      XH = XRNG(2)
      CBUF(1:) = ' '
      CHUNK = INFO(1) * NPIX(1)                   !no. of lines * x-dim
      KLAST = NPIX(1) * NPIX(2) * NPIX(3)         !total no. of pixels
      KOFF = 1
      CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
      KOFF = KOFF + IAV
      N = 1 
C
C  branch according to action
      IF (ACTION(1:3).EQ.'OUT') GOTO 2000
C
      SIDE(1:) = 'inside '
C
C  find 1. pixel inside [XL,XH]
      IF (XRFLAG.EQ.0) THEN
         DO 500, IZ=1,NPIX(3)
            DO 450, IY=1,NPIX(2)
               DO 400, IX=1,NPIX(1)
                  IF ((A(N).GE.XL).AND.(A(N).LE.XH)) THEN
                     KX = IX
                     KY = IY
                     KZ = IZ
                     VAL = A(N)
                     GOTO 8000
                  ENDIF
                  N = N + 1
400            CONTINUE
               IF ((N .GT. CHUNK) .AND.               !get next chunk of data
     +             (KOFF.LE.KLAST)) THEN
                  CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
                  KOFF = KOFF + IAV
                  N = 1 
               ENDIF
450         CONTINUE
500      CONTINUE
C 
      ELSE IF (XRFLAG.EQ.1) THEN                  ! <,XH
         DO 700, IZ=1,NPIX(3)
            DO 650, IY=1,NPIX(2)
               DO 600, IX=1,NPIX(1)
                  IF (A(N).LE.XH) THEN
                     KX = IX
                     KY = IY
                     KZ = IZ
                     VAL = A(N)
                     GOTO 8000
                  ENDIF
                  N = N + 1
600            CONTINUE
               IF ((N .GT. CHUNK) .AND.               !get next chunk of data
     +             (KOFF.LE.KLAST)) THEN
                  CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
                  KOFF = KOFF + IAV
                  N = 1
               ENDIF
650         CONTINUE
700      CONTINUE
C 
      ELSE IF (XRFLAG.EQ.2) THEN                  ! XL,>
         DO 900, IZ=1,NPIX(3)
            DO 850, IY=1,NPIX(2)
               DO 800, IX=1,NPIX(1)
                  IF (A(N).GE.XL) THEN
                     KX = IX
                     KY = IY
                     KZ = IZ
                     VAL = A(N)
                     GOTO 8000
                  ENDIF
                  N = N + 1
800            CONTINUE
               IF ((N .GT. CHUNK) .AND.               !get next chunk of data
     +             (KOFF.LE.KLAST)) THEN
                  CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
                  KOFF = KOFF + IAV
                  N = 1
               ENDIF
850         CONTINUE
900      CONTINUE
C 
      ELSE
         KX = 1
         KY = 1
         KZ = 1
         VAL = A(N)
         GOTO 8000
      ENDIF
C
C  no pixel found
      N = INDEX(CXB,' ') - 1
      IF (N.LT.1) N = LEN(CXB)
      WRITE(CBUF,10000) SIDE,CXB(1:N)
      CALL STTPUT(CBUF,STAT)
      GOTO 8100
C
C  find 1. pixel outside [XL,XH]
C
2000  SIDE(1:) = 'outside '
C
      IF (XRFLAG.EQ.0) THEN
         DO 2200, IZ=1,NPIX(3)
            DO 2150, IY=1,NPIX(2)
               DO 2100, IX=1,NPIX(1)
                  IF ((A(N).LT.XL).OR.(A(N).GT.XH)) THEN
                     KX = IX
                     KY = IY
                     KZ = IZ
                     VAL = A(N)
                     GOTO 8000
                  ENDIF
                  N = N + 1
2100           CONTINUE
               IF ((N .GT. CHUNK) .AND.               !get next chunk of data
     +             (KOFF.LE.KLAST)) THEN
                  CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
                  KOFF = KOFF + IAV
                  N = 1
               ENDIF
2150        CONTINUE
2200     CONTINUE
C
      ELSE IF (XRFLAG.EQ.1) THEN                   ! <,XH
         DO 2400, IZ=1,NPIX(3)
            DO 2350, IY=1,NPIX(2)
               DO 2300, IX=1,NPIX(1)
                  IF (A(N).GT.XH) THEN
                     KX = IX
                     KY = IY
                     KZ = IZ
                     VAL = A(N)
                     GOTO 8000
                  ENDIF
                  N = N + 1
2300           CONTINUE
               IF ((N .GT. CHUNK) .AND.               !get next chunk of data
     +             (KOFF.LE.KLAST)) THEN
                  CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
                  KOFF = KOFF + IAV
                  N = 1
               ENDIF
2350        CONTINUE
2400     CONTINUE
C
      ELSE IF (XRFLAG.EQ.2) THEN                   ! XL,>
         DO 2600, IZ=1,NPIX(3)
            DO 2550, IY=1,NPIX(2)
               DO 2500, IX=1,NPIX(1)
                  IF (A(N).LT.XL) THEN
                     KX = IX
                     KY = IY
                     KZ = IZ
                     VAL = A(N)
                     GOTO 8000
                  ENDIF
                  N = N + 1
2500           CONTINUE
               IF ((N .GT. CHUNK) .AND.               !get next chunk of data
     +             (KOFF.LE.KLAST)) THEN
                  CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
                  KOFF = KOFF + IAV
                  N = 1
               ENDIF
2550        CONTINUE
2600     CONTINUE
      ENDIF
C 
C  no pixel found
      N = INDEX(CXB,' ') - 1
      IF (N.LT.1) N = LEN(CXB)
      WRITE(CBUF,10000) SIDE,CXB(1:N)
      CALL STTPUT(CBUF,STAT)
      GOTO 8100
C
C  we found a matching pixel
8000  N = INDEX(CXB,' ') - 1
      IF (N.LT.1) N = LEN(CXB)
C 
      IF (NAXIS.EQ.1) THEN
         WRITE(CBUF,20000) KX,VAL
      ELSE IF (NAXIS.EQ.2) THEN
         WRITE(CBUF,20001) KX,KY,VAL
      ELSE
         WRITE(CBUF,20002) KX,KY,KZ,VAL
      ENDIF
      CALL STTPUT(CBUF,STAT)
      WRITE(CBUF,30001) SIDE,CXB(1:N)
      CALL STTPUT(CBUF,STAT)
      CALL STKWRR('OUTPUTR',VAL,1,1,UNIT,STAT)
C
8100  INDXY(1) = KX
      INDXY(2) = KY
      INDXY(3) = KZ
      CALL STKWRI('OUTPUTI',INDXY,1,3,UNIT,STAT)
      RETURN
C
10000 FORMAT('No pixel ',A,'[',A,'] ...')
20000 FORMAT('frame pixel (',I5,'), value = ',G12.5)
20001 FORMAT('frame pixel (',I5,',',I5,'), value = ',G12.5)
20002 FORMAT('frame pixel (',I5,',',I5,',',I5,'), value = ',G12.5)
30001 FORMAT('is 1. pixel ',A, '[',A,']')
C
      END

      SUBROUTINE FNDPXT(INFO,IMNO,A,NAXIS,NPIX,ACTION,XRNG,XRFLAG,
     +                  CXB,TID,TCOLS,MMAX)
C
C  work on full frame
C 
      IMPLICIT NONE
C
      INTEGER      INFO(*),NAXIS,NPIX(*),XRFLAG,TID,TCOLS(*),MMAX,RMAX
      INTEGER      N,IX,IY,IZ,NCOLS,KCOUNT,UNIT(1),STAT
      INTEGER      KOFF,KLAST,CHUNK,IAV,IMNO
      INTEGER      TFLAG,NDUM,NDOFF,DUMLIM
C
      REAL         A(*),XRNG(*)
      REAL         XL,XH,RVALS(4),DUMBUF(1000)
C
      CHARACTER*(*) ACTION,CXB
      CHARACTER     SIDE*8,CBUF*80
C
C  init
      KCOUNT = 0
      NCOLS = NAXIS + 1
      XL = XRNG(1)
      XH = XRNG(2)
      CBUF(1:) = ' '
      IF (MMAX.LT.0) THEN
         RMAX = -MMAX
      ELSE IF (MMAX.GT.0) THEN
         RMAX = MMAX
      ELSE
         RMAX = 99999999                   !99 999 999
      ENDIF
      CHUNK = INFO(1) * NPIX(1)                      !no. of lines * x-dim
      N = 1
      KLAST = NPIX(1) * NPIX(2) * NPIX(3)            !total no. of pixels
      KOFF = 1
      CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
      KOFF = KOFF + IAV
C 
      IF (TID.LT.0) THEN
         TID = -TID
         IF (TID.EQ.99) THEN
            TFLAG = -1                   !only display output w. coords
         ELSE
            TFLAG = 0                    !image output pixels only, no coords
            NDOFF = 1
            NDUM = 1
            DUMLIM = 1000                !synchronize with array DUMBUF !!!
         ENDIF
      ELSE
         TFLAG = 1                       !table output w. coords
      ENDIF
C
C  branch according to action
      IF (ACTION(1:3).EQ.'OUT') GOTO 2000
C
      SIDE(1:) = 'inside '
C
C  find all pixels inside [XL,XH]
      IF (XRFLAG.EQ.0) THEN
         DO 200, IZ=1,NPIX(3)
            DO 150, IY=1,NPIX(2)
               DO 100, IX=1,NPIX(1)
                  IF ((A(N).GE.XL).AND.(A(N).LE.XH)) THEN
                     KCOUNT = KCOUNT + 1
                     RVALS(NCOLS) = A(N)
                     IF (KCOUNT.GT.RMAX) THEN
                        IF (MMAX.LT.0) THEN
                           KCOUNT = RMAX
                           GOTO 3000         !stop already
                        ENDIF
                     ELSE
                        IF (TFLAG.EQ.1) THEN
                           RVALS(1) = IX
                           IF (NAXIS.GE.2) RVALS(2) = IY
                           IF (NAXIS.GE.3) RVALS(3) = IZ
                           CALL TBRWRR(TID,KCOUNT,NCOLS,TCOLS,
     +                                 RVALS,STAT)
                        ELSE IF (TFLAG.EQ.0) THEN
                           DUMBUF(NDUM) = A(N)
                           NDUM = NDUM + 1
                           IF (NDUM.GT.DUMLIM) THEN
                              CALL STFPUT(TID,NDOFF,DUMLIM,DUMBUF,STAT)
                              NDOFF = NDOFF + DUMLIM
                              NDUM = 1
                           ENDIF
                        ELSE
                           IF (NAXIS.EQ.1) THEN
                              WRITE(CBUF,10050) IX,RVALS(NCOLS)
                           ELSE IF (NAXIS.EQ.2) THEN
                              WRITE(CBUF,10051) IX,IY,RVALS(NCOLS)
                           ELSE 
                              WRITE(CBUF,10052) IX,IY,IZ,RVALS(NCOLS)
                           ENDIF
                           CALL STTPUT(CBUF,STAT)
                        ENDIF
                     ENDIF
                  ENDIF
                  N = N + 1
100            CONTINUE
               IF ((N .GT. CHUNK) .AND.               !get next chunk of data
     +             (KOFF.LE.KLAST)) THEN
                  CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
                  KOFF = KOFF + IAV
                  N = 1
               ENDIF
150         CONTINUE
200      CONTINUE
C
      ELSE IF (XRFLAG.EQ.1) THEN                   ! <,XH
         DO 400, IZ=1,NPIX(3)
            DO 350, IY=1,NPIX(2)
               DO 300, IX=1,NPIX(1)
                  IF (A(N).LE.XH) THEN
                     KCOUNT = KCOUNT + 1
                     RVALS(NCOLS) = A(N)
                     IF (KCOUNT.GT.RMAX) THEN
                        IF (MMAX.LT.0) THEN
                           KCOUNT = RMAX
                           GOTO 3000         !stop already
                        ENDIF
                     ELSE
                        IF (TFLAG.EQ.1) THEN
                           RVALS(1) = IX
                           IF (NAXIS.GE.2) RVALS(2) = IY
                           IF (NAXIS.GE.3) RVALS(3) = IZ
                           CALL TBRWRR(TID,KCOUNT,NCOLS,TCOLS,
     +                                 RVALS,STAT)
                        ELSE IF (TFLAG.EQ.0) THEN
                           DUMBUF(NDUM) = A(N)
                           NDUM = NDUM + 1
                           IF (NDUM.GT.DUMLIM) THEN
                              CALL STFPUT(TID,NDOFF,DUMLIM,DUMBUF,STAT)
                              NDOFF = NDOFF + DUMLIM
                              NDUM = 1
                           ENDIF
                        ELSE
                           IF (NAXIS.EQ.1) THEN
                              WRITE(CBUF,10050) IX,RVALS(NCOLS)
                           ELSE IF (NAXIS.EQ.2) THEN
                              WRITE(CBUF,10051) IX,IY,RVALS(NCOLS)
                           ELSE 
                              WRITE(CBUF,10052) IX,IY,IZ,RVALS(NCOLS)
                           ENDIF
                           CALL STTPUT(CBUF,STAT)
                        ENDIF
                     ENDIF
                  ENDIF
                  N = N + 1
300            CONTINUE
               IF ((N .GT. CHUNK) .AND.               !get next chunk of data
     +             (KOFF.LE.KLAST)) THEN
                  CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
                  KOFF = KOFF + IAV
                  N = 1
               ENDIF
350         CONTINUE
400      CONTINUE
C
      ELSE IF (XRFLAG.EQ.2) THEN                   ! XL,>
         DO 600, IZ=1,NPIX(3)
            DO 550, IY=1,NPIX(2)
               DO 500, IX=1,NPIX(1)
                  IF (A(N).GE.XL) THEN
                     KCOUNT = KCOUNT + 1
                     RVALS(NCOLS) = A(N)
                     IF (KCOUNT.GT.RMAX) THEN
                        IF (MMAX.LT.0) THEN
                           KCOUNT = RMAX
                           GOTO 3000         !stop already
                        ENDIF
                     ELSE
                        IF (TFLAG.EQ.1) THEN
                           RVALS(1) = IX
                           IF (NAXIS.GE.2) RVALS(2) = IY
                           IF (NAXIS.GE.3) RVALS(3) = IZ
                           CALL TBRWRR(TID,KCOUNT,NCOLS,TCOLS,
     +                                 RVALS,STAT)
                        ELSE IF (TFLAG.EQ.0) THEN
                           DUMBUF(NDUM) = A(N)
                           NDUM = NDUM + 1
                           IF (NDUM.GT.DUMLIM) THEN
                              CALL STFPUT(TID,NDOFF,DUMLIM,DUMBUF,STAT)
                              NDOFF = NDOFF + DUMLIM
                              NDUM = 1
                           ENDIF
                        ELSE
                           IF (NAXIS.EQ.1) THEN
                              WRITE(CBUF,10050) IX,RVALS(NCOLS)
                           ELSE IF (NAXIS.EQ.2) THEN
                              WRITE(CBUF,10051) IX,IY,RVALS(NCOLS)
                           ELSE 
                              WRITE(CBUF,10052) IX,IY,IZ,RVALS(NCOLS)
                           ENDIF
                           CALL STTPUT(CBUF,STAT)
                        ENDIF
                     ENDIF
                  ENDIF
                  N = N + 1
500            CONTINUE
               IF ((N .GT. CHUNK) .AND.               !get next chunk of data
     +             (KOFF.LE.KLAST)) THEN
                  CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
                  KOFF = KOFF + IAV
                  N = 1
               ENDIF
550         CONTINUE
600      CONTINUE
      ENDIF
C
      GOTO 3000
C
C  find 1. pixel outside [XL,XH]
C
2000  SIDE(1:) = 'outside '
C
      IF (XRFLAG.EQ.0) THEN
         DO 2200, IZ=1,NPIX(3)
            DO 2150, IY=1,NPIX(2)
               DO 2100, IX=1,NPIX(1)
                  IF ((A(N).LT.XL).OR.(A(N).GT.XH)) THEN
                     KCOUNT = KCOUNT + 1
                     RVALS(NCOLS) = A(N)
                     IF (KCOUNT.GT.RMAX) THEN
                        IF (MMAX.LT.0) THEN
                           KCOUNT = RMAX
                           GOTO 3000         !stop already
                        ENDIF
                     ELSE
                        IF (TFLAG.EQ.1) THEN
                           RVALS(1) = IX
                           IF (NAXIS.GE.2) RVALS(2) = IY
                           IF (NAXIS.GE.3) RVALS(3) = IZ
                           CALL TBRWRR(TID,KCOUNT,NCOLS,TCOLS,
     +                                 RVALS,STAT)
                        ELSE IF (TFLAG.EQ.0) THEN
                           DUMBUF(NDUM) = A(N)
                           NDUM = NDUM + 1
                           IF (NDUM.GT.DUMLIM) THEN
                              CALL STFPUT(TID,NDOFF,DUMLIM,DUMBUF,STAT)
                              NDOFF = NDOFF + DUMLIM
                              NDUM = 1
                           ENDIF
                        ELSE
                           IF (NAXIS.EQ.1) THEN
                              WRITE(CBUF,10050) IX,RVALS(NCOLS)
                           ELSE IF (NAXIS.EQ.2) THEN
                              WRITE(CBUF,10051) IX,IY,RVALS(NCOLS)
                           ELSE
                              WRITE(CBUF,10052) IX,IY,IZ,RVALS(NCOLS)
                           ENDIF
                           CALL STTPUT(CBUF,STAT)
                        ENDIF
                     ENDIF
                  ENDIF
                  N = N + 1
2100           CONTINUE
               IF ((N .GT. CHUNK) .AND.               !get next chunk of data
     +             (KOFF.LE.KLAST)) THEN
                  CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
                  KOFF = KOFF + IAV
                  N = 1
               ENDIF
2150        CONTINUE
2200     CONTINUE
C
      ELSE IF (XRFLAG.EQ.1) THEN                   !  <,XH
         DO 2400, IZ=1,NPIX(3)
            DO 2350, IY=1,NPIX(2)
               DO 2300, IX=1,NPIX(1)
                  IF (A(N).GT.XH) THEN
                     KCOUNT = KCOUNT + 1
                     RVALS(NCOLS) = A(N)
                     IF (KCOUNT.GT.RMAX) THEN
                        IF (MMAX.LT.0) THEN
                           KCOUNT = RMAX
                           GOTO 3000         !stop already
                        ENDIF
                     ELSE
                        IF (TFLAG.EQ.1) THEN
                           RVALS(1) = IX
                           IF (NAXIS.GE.2) RVALS(2) = IY
                           IF (NAXIS.GE.3) RVALS(3) = IZ
                           CALL TBRWRR(TID,KCOUNT,NCOLS,TCOLS,
     +                                 RVALS,STAT)
                        ELSE IF (TFLAG.EQ.0) THEN
                           DUMBUF(NDUM) = A(N)
                           NDUM = NDUM + 1
                           IF (NDUM.GT.DUMLIM) THEN
                              CALL STFPUT(TID,NDOFF,DUMLIM,DUMBUF,STAT)
                              NDOFF = NDOFF + DUMLIM
                              NDUM = 1
                           ENDIF
                        ELSE
                           IF (NAXIS.EQ.1) THEN
                              WRITE(CBUF,10050) IX,RVALS(NCOLS)
                           ELSE IF (NAXIS.EQ.2) THEN
                              WRITE(CBUF,10051) IX,IY,RVALS(NCOLS)
                           ELSE
                              WRITE(CBUF,10052) IX,IY,IZ,RVALS(NCOLS)
                           ENDIF
                           CALL STTPUT(CBUF,STAT)
                        ENDIF
                     ENDIF
                  ENDIF
                  N = N + 1
2300           CONTINUE
               IF ((N .GT. CHUNK) .AND.               !get next chunk of data
     +             (KOFF.LE.KLAST)) THEN
                  CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
                  KOFF = KOFF + IAV
                  N = 1
               ENDIF
2350        CONTINUE
2400     CONTINUE
C
      ELSE IF (XRFLAG.EQ.2) THEN                   !  XL,>
         DO 2600, IZ=1,NPIX(3)
            DO 2550, IY=1,NPIX(2)
               DO 2500, IX=1,NPIX(1)
                  IF (A(N).LT.XL) THEN
                     KCOUNT = KCOUNT + 1
                     RVALS(NCOLS) = A(N)
                     IF (KCOUNT.GT.RMAX) THEN
                        IF (MMAX.LT.0) THEN
                           KCOUNT = RMAX
                           GOTO 3000         !stop already
                        ENDIF
                     ELSE
                        IF (TFLAG.EQ.1) THEN
                           RVALS(1) = IX
                           IF (NAXIS.GE.2) RVALS(2) = IY
                           IF (NAXIS.GE.3) RVALS(3) = IZ
                           CALL TBRWRR(TID,KCOUNT,NCOLS,TCOLS,
     +                                 RVALS,STAT)
                        ELSE IF (TFLAG.EQ.0) THEN
                           DUMBUF(NDUM) = A(N)
                           NDUM = NDUM + 1
                           IF (NDUM.GT.DUMLIM) THEN
                              CALL STFPUT(TID,NDOFF,DUMLIM,DUMBUF,STAT)
                              NDOFF = NDOFF + DUMLIM
                              NDUM = 1
                           ENDIF
                        ELSE
                           IF (NAXIS.EQ.1) THEN
                              WRITE(CBUF,10050) IX,RVALS(NCOLS)
                           ELSE IF (NAXIS.EQ.2) THEN
                              WRITE(CBUF,10051) IX,IY,RVALS(NCOLS)
                           ELSE
                              WRITE(CBUF,10052) IX,IY,IZ,RVALS(NCOLS)
                           ENDIF
                           CALL STTPUT(CBUF,STAT)
                        ENDIF
                     ENDIF
                  ENDIF
                  N = N + 1
2500           CONTINUE
               IF ((N .GT. CHUNK) .AND.               !get next chunk of data
     +             (KOFF.LE.KLAST)) THEN
                  CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
                  KOFF = KOFF + IAV
                  N = 1
               ENDIF
2550        CONTINUE
2600     CONTINUE
      ENDIF
C
C  test, if no pixel found
3000  N = INDEX(CXB,' ') - 1
      IF (N.LT.1) N = LEN(CXB)
      IF (KCOUNT.LE.0) THEN
         WRITE(CBUF,10000) SIDE,CXB(1:N)
      ELSE
         IF (KCOUNT.EQ.1) THEN
            WRITE(CBUF,20001) SIDE,CXB(1:N)
         ELSE
            WRITE(CBUF,20000) KCOUNT,SIDE,CXB(1:N)
         ENDIF
      ENDIF
      CALL STTPUT(CBUF,STAT)
      CALL STKWRI('OUTPUTI',KCOUNT,1,1,UNIT,STAT)
      INFO(2) = KCOUNT
C
C  for image output we have to check more
      IF ((TFLAG.EQ.0) .AND. (NDUM.GT.1)) THEN
         DUMLIM = NDUM - 1
         CALL STFPUT(TID,NDOFF,DUMLIM,DUMBUF,STAT)
      ENDIF
      RETURN
C
10000 FORMAT('No pixel ',A,'[',A,'] ...')
10050 FORMAT('frame pixel (',I6,'),  value = ',G12.5)
10051 FORMAT('frame pixel (',I6,',',I6,'),  value = ',G12.5)
10052 FORMAT('frame pixel (',I6,',',I6,',',I6,'),  value = ',G12.5)
20000 FORMAT(I6,' pixels ',A,'[',A,']')
20001 FORMAT('1 pixel ',A,'[',A,']')
C
      END

      SUBROUTINE SUBPOL
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION:
C  subroutine SUBPOL		version 1.00	881028
C  K. Banse			ESO - Garching
C
C.KEYWORDS:
C  polygon fill
C
C.PURPOSE:
C  calculate the average value (and rms) according to different methods
C  of an area defined by the cursor rectangle or a table or by coordinates
C
C.ALGORITHM:
C  This info may also be stored either in a descriptor or a table...
C
C.INPUT/OUTPUT:
C
C  The following keywords are used:
C  IN_A/C/1/60				input frame/mask
C  IN_B/C/1/60				test frame/mask
C  INPUTC/C/1/60			name of table with subimages of IN_A
C  OUT_A/C/1/60				output frame/mask
C  P4/C/1/80				thresholds for polygon detection +
C				 	right hand side of replacement
C.VERSIONS
C  1.00		created from version 1.00 as of 860701
C  		use FORTRAN 77 + new ST interfaces
C	
C--------------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER     IAV,N,NROW,TABFLG,STAT
      INTEGER*8   PNTRA,PNTRB,PNTRC,PNTRT
      INTEGER     NAXIS,NPIX(3)
      INTEGER     IMNOA,IMNOB,IMNOC,IMNOT,TID
      INTEGER     TNAXIS,TNPIX(2)
      INTEGER     SUBPIX(4)
      INTEGER     TABCLN(4)
      INTEGER     UNI(1),NULO,MADRID(1)
      INTEGER     GENNUM,INDEX
C
      CHARACTER*60   INFRAM,OUTFRA,TABLE,TSTFRA
      CHARACTER      CUNIT*64,IDENT*72
      CHARACTER      OUTLAB(4)*16,CBUF*80
      CHARACTER      CASE*1,INFRA2*60,P4*80
C
      REAL         THRESH(2),FILL,RPIX(4)
      REAL         CUTS(4)
C
      DOUBLE PRECISION START(3),STEP(3),TSTART(3),TSTEP(3),DD
C
      LOGICAL      TABNUL(4),SELFLG
C
      COMMON   /VMR/  MADRID
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      DATA   OUTLAB   /'XSTART ','YSTART ','XEND ','YEND '/
      DATA   CUNIT    /' '/,  IDENT /' '/
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C  get input, test, output frame as well as intable (optional)
C
      CALL STKRDC('IN_A',1,1,60,IAV,INFRAM,UNI,NULO,STAT)
      CALL STKRDC('IN_B',1,1,60,IAV,TSTFRA,UNI,NULO,STAT)
      CALL STKRDC('OUT_A',1,1,60,IAV,OUTFRA,UNI,NULO,STAT)
C
C  process threshold values + right hand side
      CALL STKRDC('P4',1,1,80,IAV,P4,UNI,NULO,STAT)
      IAV = INDEX(P4,'=')
      IF (IAV.LE.1)
     +   CALL STETER(7,'invalid replacement string...')
      CALL GENCNV(P4(1:IAV-1),2,2,UNI,THRESH,DD,STAT)
      IF (STAT.NE.2)
     +   CALL STETER(7,'invalid replacement string...')
      INFRA2(1:) = P4(IAV+1:)//' '
C
      IF (GENNUM(INFRA2).EQ.1) THEN                        !constant
         CASE = 'C'
         CALL GENCNV(INFRA2,2,1,UNI,FILL,DD,STAT)
      ELSE                                                 !second input frame
         CASE = 'I'
         CALL CLNFRA(INFRA2,INFRA2,0)
      ENDIF
C
C  look if we use a table
      CALL STKRDC('INPUTC',1,1,60,IAV,TABLE,UNI,NULO,STAT)
      IF (TABLE(1:1).EQ.'+') THEN
         TABFLG = 0
      ELSE
         CALL CLNTAB(TABLE,TABLE,0)
         TABFLG = 1
C
C  test, if labels there
         CALL TBTOPN(TABLE,F_I_MODE,TID,STAT)
         CALL TBIGET(TID,N,NROW,N,N,N,STAT)                !get total no. of rows
         DO 600, N=1,4
            CALL TBLSER(TID,OUTLAB(N),TABCLN(N),STAT)      !without the `:'
            IF (TABCLN(N).EQ.-1) THEN
               CBUF(1:) = 'column labelled '//CBUF(1:10)//
     +                    'not found... '
               CALL STETER(1,CBUF)
            ENDIF
600      CONTINUE
      ENDIF
C
C  map input + check dimensions
      CALL STIGET(INFRAM,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +            3,NAXIS,NPIX,START,STEP,
     +            IDENT,CUNIT,PNTRA,IMNOA,STAT)
      CALL STDRDR(IMNOA,'LHCUTS',1,4,IAV,CUTS,UNI,NULO,STAT)
C
      IF (NAXIS.NE.2) THEN
         IF (NAXIS.GE.3) THEN
            IF (NPIX(3).GT.1) THEN
               CALL STETER(2,'only 2-dim frames supported...')
            ELSE
               NAXIS = 2
            ENDIF
         ELSE
            CALL STETER(2,'only 2-dim frames supported...')
         ENDIF
      ENDIF
C
C  map test frame
      IF (TSTFRA.NE.INFRAM) THEN
         CALL STIGET(TSTFRA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +               2,TNAXIS,TNPIX,TSTART,TSTEP,
     +               IDENT,CUNIT,PNTRT,IMNOT,STAT)
         IF ( TNPIX(1)*TNPIX(2) .NE. NPIX(1)*NPIX(2) )
     +      CALL STETER(6,'frames must have same dimensions...')
      ELSE
         IMNOT = IMNOA
         PNTRT = PNTRA
      ENDIF
C
C  map second input frame
      IF ( (CASE.NE.'C') .AND. (TSTFRA.NE.INFRA2) ) THEN
         CALL STIGET(INFRA2,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +               2,TNAXIS,TNPIX,TSTART,TSTEP,
     +               IDENT,CUNIT,PNTRB,IMNOB,STAT)
         IF ( TNPIX(1)*TNPIX(2) .NE. NPIX(1)*NPIX(2) )
     +      CALL STETER(6,'frames must have same dimensions...')
      ELSE
         IMNOB = IMNOT
         PNTRB = PNTRT
      ENDIF
C
C  o.k. - map output frame + copy input frame
      IF (OUTFRA.NE.INFRAM) THEN
         CALL STIPUT(OUTFRA,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +               NAXIS,NPIX,START,STEP,
     +               IDENT,CUNIT,PNTRC,IMNOC,STAT)
         CALL STDWRR(IMNOC,'LHCUTS',CUTS,1,4,UNI,STAT)
         CALL COPYF(MADRID(PNTRA),MADRID(PNTRC),NPIX(1)*NPIX(2))
      ELSE
         IMNOC = IMNOA
         PNTRC = PNTRA
      ENDIF
C
C  if complete frame we just have to do it once
      IF (TABFLG.EQ.0) THEN
         SUBPIX(1) = 1
         SUBPIX(2) = 1
         SUBPIX(3) = NPIX(1)
         SUBPIX(4) = NPIX(2)
C
C  and do it via POLY_FILL
         CALL POLFIL(CASE,MADRID(PNTRA),MADRID(PNTRT),
     +               MADRID(PNTRB),MADRID(PNTRC),
     +               NPIX,SUBPIX,THRESH,FILL)
C
      ELSE
C
C  loop through table
         DO 2000, N=1,NROW
            CALL TBSGET(TID,N,SELFLG,STAT)        !only use selected rows
            IF (.NOT.SELFLG) GOTO 2000
C
C  get next row of values
            CALL TBRRDR(TID,N,4,TABCLN,RPIX,TABNUL,STAT)
            SUBPIX(1) = NINT( (RPIX(1)-START(1))/STEP(1) ) + 1      !xbeg
            SUBPIX(2) = NINT( (RPIX(2)-START(2))/STEP(2) ) + 1      !ybeg
            SUBPIX(3) = NINT( (RPIX(3)-START(1))/STEP(1) ) + 1      !xend
            SUBPIX(4) = NINT( (RPIX(4)-START(2))/STEP(2) ) + 1      !yend
C
C  and do it via POLFIL
            CALL POLFIL(CASE,MADRID(PNTRA),MADRID(PNTRT),
     +                  MADRID(PNTRB),MADRID(PNTRC),
     +                  NPIX,SUBPIX,THRESH,FILL)
2000     CONTINUE
      ENDIF
C
C  That's it folks...
      IF (TABFLG.EQ.1) CALL TBTCLO(TID,STAT)
C
      RETURN
      END

      SUBROUTINE FNDPXA(INFO,IMNO,A,NAXIS,NPIX,ACTION,
     +                  XRNG,XRFLAG,CXB,SPIX,EPIX)
C
      IMPLICIT NONE
C
      INTEGER      INFO(*),IMNO,NAXIS,NPIX(*),XRFLAG
      INTEGER      SPIX(3),EPIX(3),XOFF,YOFF,ZOFF,XSAV,YSAV
      INTEGER      N,IX,IY,IZ,KX,KY,KZ,INDXY(3),UNIT(1)
      INTEGER      KOFF,KLAST,KPLANE,CHUNK,IAV,STAT
C
      REAL         A(*),XRNG(*)
      REAL         XL,XH,VAL
C
      CHARACTER*(*) ACTION,CXB
      CHARACTER     SIDE*8,CBUF*80
C
C  init
      KX = 0
      KY = 0
      KZ = 0
      XL = XRNG(1)
      XH = XRNG(2)
      CBUF(1:) = ' '
      CHUNK = INFO(1) * NPIX(1)                   !no. of lines * x-dim
      KPLANE = NPIX(1) * NPIX(2)
      KLAST = KPLANE * NPIX(3)                    !total no. of pixels
      XOFF = SPIX(1) - 1                   
      YOFF = (SPIX(2)-1) * NPIX(1)         
      ZOFF = (SPIX(3)-1) * KPLANE
      KOFF = ZOFF + YOFF + 1                      !start at beginning of line
      CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
      N = 1 + XOFF                                !first valid pixel in A
C
C  branch according to action
      IF (ACTION(1:3).EQ.'OUT') GOTO 2000
C
      SIDE(1:) = 'inside '
C
C  find 1. pixel inside [XL,XH]
      IF (XRFLAG.EQ.0) THEN
         DO 500, IZ=SPIX(3),EPIX(3)
            YSAV = N
            DO 450, IY=SPIX(2),EPIX(2)
               XSAV = N
               DO 400, IX=SPIX(1),EPIX(1)
                  IF ((A(N).GE.XL).AND.(A(N).LE.XH)) THEN
                     KX = IX
                     KY = IY
                     KZ = IZ
                     VAL = A(N)
                     GOTO 8000
                  ENDIF
                  N = N + 1
400            CONTINUE
               N = XSAV + NPIX(1)
               IF ((N .GT. CHUNK) .AND.              !get next chunk of data
     +             (IY.NE.EPIX(2))) THEN             !if not last line of plane
                  KOFF = ((IZ-1)*KPLANE) + (IY*NPIX(1)) + 1
                  CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
                  KOFF = KOFF + IAV
                  N = 1 + XOFF
               ENDIF
450         CONTINUE
            N = YSAV + KPLANE
            IF ((N .GT. CHUNK) .AND.              !get next chunk of data
     +          (IZ.NE.EPIX(3))) THEN             !if not last plane
               KOFF = (IZ*KPLANE) + YOFF + 1
               CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
               KOFF = KOFF + IAV
               N = 1 + XOFF
            ENDIF
500      CONTINUE
C 
      ELSE IF (XRFLAG.EQ.1) THEN                  ! <,XH
         DO 700, IZ=SPIX(3),EPIX(3)
            YSAV = N
            DO 650, IY=1,NPIX(2)
               XSAV = N
               DO 600, IX=1,NPIX(1)
                  IF (A(N).LE.XH) THEN
                     KX = IX
                     KY = IY
                     KZ = IZ
                     VAL = A(N)
                     GOTO 8000
                  ENDIF
                  N = N + 1
600            CONTINUE
               N = XSAV + NPIX(1)
               IF ((N .GT. CHUNK) .AND.              !get next chunk of data
     +             (IY.NE.EPIX(2))) THEN             !if not last line of plane
                  KOFF = ((IZ-1)*KPLANE) + (IY*NPIX(1)) + 1
                  CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
                  KOFF = KOFF + IAV
                  N = 1 + XOFF
               ENDIF
650         CONTINUE
            N = YSAV + KPLANE
            IF ((N .GT. CHUNK) .AND.              !get next chunk of data
     +          (IZ.NE.EPIX(3))) THEN             !if not last plane
               KOFF = (IZ*KPLANE) + YOFF + 1
               CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
               KOFF = KOFF + IAV
               N = 1 + XOFF
            ENDIF
700      CONTINUE
C 
      ELSE IF (XRFLAG.EQ.2) THEN                  ! XL,>
         DO 900, IZ=SPIX(3),EPIX(3)
            YSAV = N
            DO 850, IY=1,NPIX(2)
               XSAV = N
               DO 800, IX=1,NPIX(1)
                  IF (A(N).GE.XL) THEN
                     KX = IX
                     KY = IY
                     KZ = IZ
                     VAL = A(N)
                     GOTO 8000
                  ENDIF
                  N = N + 1
800            CONTINUE
               N = XSAV + NPIX(1)
               IF ((N .GT. CHUNK) .AND.              !get next chunk of data
     +             (IY.NE.EPIX(2))) THEN             !if not last line of plane
                  KOFF = ((IZ-1)*KPLANE) + (IY*NPIX(1)) + 1
                  CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
                  KOFF = KOFF + IAV
                  N = 1 + XOFF
               ENDIF
850         CONTINUE
            N = YSAV + KPLANE
            IF ((N .GT. CHUNK) .AND.              !get next chunk of data
     +          (IZ.NE.EPIX(3))) THEN             !if not last plane
               KOFF = (IZ*KPLANE) + YOFF + 1
               CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
               KOFF = KOFF + IAV
               N = 1 + XOFF
            ENDIF
900      CONTINUE
C 
      ELSE
         KX = 1
         KY = 1
         KZ = 1
         VAL = A(N)
         GOTO 8000
      ENDIF
C
C  no pixel found
      N = INDEX(CXB,' ') - 1
      IF (N.LT.1) N = LEN(CXB)
      WRITE(CBUF,10000) SIDE,CXB(1:N)
      CALL STTPUT(CBUF,STAT)
      GOTO 8100
C
C  find 1. pixel outside [XL,XH]
C
2000  SIDE(1:) = 'outside '
C
      IF (XRFLAG.EQ.0) THEN
         DO 2200, IZ=SPIX(3),EPIX(3)
            YSAV = N
            DO 2150, IY=1,NPIX(2)
               XSAV = N
               DO 2100, IX=1,NPIX(1)
                  IF ((A(N).LT.XL).OR.(A(N).GT.XH)) THEN
                     KX = IX
                     KY = IY
                     KZ = IZ
                     VAL = A(N)
                     GOTO 8000
                  ENDIF
                  N = N + 1
2100           CONTINUE
               N = XSAV + NPIX(1)
               IF ((N .GT. CHUNK) .AND.              !get next chunk of data
     +             (IY.NE.EPIX(2))) THEN             !if not last line of plane
                  KOFF = ((IZ-1)*KPLANE) + (IY*NPIX(1)) + 1
                  CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
                  KOFF = KOFF + IAV
                  N = 1 + XOFF
               ENDIF
2150        CONTINUE
            N = YSAV + KPLANE
            IF ((N .GT. CHUNK) .AND.              !get next chunk of data
     +          (IZ.NE.EPIX(3))) THEN             !if not last plane
               KOFF = (IZ*KPLANE) + YOFF + 1
               CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
               KOFF = KOFF + IAV
               N = 1 + XOFF
            ENDIF
2200     CONTINUE
C
      ELSE IF (XRFLAG.EQ.1) THEN                   ! <,XH
         DO 2400, IZ=SPIX(3),EPIX(3)
            YSAV = N
            DO 2350, IY=1,NPIX(2)
               XSAV = N
               DO 2300, IX=1,NPIX(1)
                  IF (A(N).GT.XH) THEN
                     KX = IX
                     KY = IY
                     KZ = IZ
                     VAL = A(N)
                     GOTO 8000
                  ENDIF
                  N = N + 1
2300           CONTINUE
               N = XSAV + NPIX(1)
               IF ((N .GT. CHUNK) .AND.              !get next chunk of data
     +             (IY.NE.EPIX(2))) THEN             !if not last line of plane
                  KOFF = ((IZ-1)*KPLANE) + (IY*NPIX(1)) + 1
                  CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
                  KOFF = KOFF + IAV
                  N = 1 + XOFF
               ENDIF
2350        CONTINUE
            N = YSAV + KPLANE
            IF ((N .GT. CHUNK) .AND.              !get next chunk of data
     +          (IZ.NE.EPIX(3))) THEN             !if not last plane
               KOFF = (IZ*KPLANE) + YOFF + 1
               CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
               KOFF = KOFF + IAV
               N = 1 + XOFF
            ENDIF
2400     CONTINUE
C
      ELSE IF (XRFLAG.EQ.2) THEN                   ! XL,>
         DO 2600, IZ=SPIX(3),EPIX(3)
            YSAV = N
            DO 2550, IY=1,NPIX(2)
               XSAV = N
               DO 2500, IX=1,NPIX(1)
                  IF (A(N).LT.XL) THEN
                     KX = IX
                     KY = IY
                     KZ = IZ
                     VAL = A(N)
                     GOTO 8000
                  ENDIF
                  N = N + 1
2500           CONTINUE
               N = XSAV + NPIX(1)
               IF ((N .GT. CHUNK) .AND.              !get next chunk of data
     +             (IY.NE.EPIX(2))) THEN             !if not last line of plane
                  KOFF = ((IZ-1)*KPLANE) + (IY*NPIX(1)) + 1
                  CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
                  KOFF = KOFF + IAV
                  N = 1 + XOFF
               ENDIF
2550        CONTINUE
            N = YSAV + KPLANE
            IF ((N .GT. CHUNK) .AND.              !get next chunk of data
     +          (IZ.NE.EPIX(3))) THEN             !if not last plane
               KOFF = (IZ*KPLANE) + YOFF + 1
               CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
               KOFF = KOFF + IAV
               N = 1 + XOFF
            ENDIF
2600     CONTINUE
      ENDIF
C 
C  no pixel found
      N = INDEX(CXB,' ') - 1
      IF (N.LT.1) N = LEN(CXB)
      WRITE(CBUF,10000) SIDE,CXB(1:N)
      CALL STTPUT(CBUF,STAT)
      GOTO 8100
C
C  we found a matching pixel
8000  N = INDEX(CXB,' ') - 1
      IF (N.LT.1) N = LEN(CXB)
C 
      IF (NAXIS.EQ.1) THEN
         WRITE(CBUF,20000) KX,VAL
      ELSE IF (NAXIS.EQ.2) THEN
         WRITE(CBUF,20001) KX,KY,VAL
      ELSE
         WRITE(CBUF,20002) KX,KY,KZ,VAL
      ENDIF
      CALL STTPUT(CBUF,STAT)
      WRITE(CBUF,30001) SIDE,CXB(1:N)
      CALL STTPUT(CBUF,STAT)
      CALL STKWRR('OUTPUTR',VAL,1,1,UNIT,STAT)
C
8100  INDXY(1) = KX
      INDXY(2) = KY
      INDXY(3) = KZ
      CALL STKWRI('OUTPUTI',INDXY,1,3,UNIT,STAT)
      RETURN
C
10000 FORMAT('No pixel ',A,'[',A,'] ...')
20000 FORMAT('frame pixel (',I5,'), value = ',G12.5)
20001 FORMAT('frame pixel (',I5,',',I5,'), value = ',G12.5)
20002 FORMAT('frame pixel (',I5,',',I5,',',I5,'), value = ',G12.5)
30001 FORMAT('is 1. pixel ',A, '[',A,']')
C
      END

      SUBROUTINE FNDPXS(INFO,IMNO,A,NAXIS,NPIX,ACTION,XRNG,XRFLAG,
     +                  CXB,TID,TCOLS,MMAX,SPIX,EPIX)
C
C  as FNDPXT but work on window of frame
C 
      IMPLICIT NONE
C
      INTEGER      INFO(*),NAXIS,NPIX(*),XRFLAG,TID,TCOLS(*),MMAX,RMAX
      INTEGER      SPIX(3),EPIX(3),XOFF,YOFF,ZOFF,XSAV,YSAV
      INTEGER      N,IX,IY,IZ,NCOLS,KCOUNT,UNIT(1),STAT
      INTEGER      KOFF,KLAST,KPLANE,CHUNK,IAV,IMNO
      INTEGER      TFLAG,NDUM,NDOFF,DUMLIM
C
      REAL         A(*),XRNG(*)
      REAL         XL,XH,RVALS(4),DUMBUF(1000)
C
      CHARACTER*(*) ACTION,CXB
      CHARACTER     SIDE*8,CBUF*80
C
C  init
      KCOUNT = 0
      NCOLS = NAXIS + 1
      XL = XRNG(1)
      XH = XRNG(2)
      CBUF(1:) = ' '
      IF (MMAX.LT.0) THEN
         RMAX = -MMAX
      ELSE IF (MMAX.GT.0) THEN
         RMAX = MMAX
      ELSE
         RMAX = 99999999                   !99 999 999
      ENDIF
      CHUNK = INFO(1) * NPIX(1)                      !no. of lines * x-dim
      KPLANE = NPIX(1) * NPIX(2)
      KLAST = KPLANE * NPIX(3)                    !total no. of pixels
      XOFF = SPIX(1) - 1
      YOFF = (SPIX(2)-1) * NPIX(1)
      ZOFF = (SPIX(3)-1) * KPLANE
      KOFF = ZOFF + YOFF + 1                      !start at beginning of line
      CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
      N = 1 + XOFF                                !first valid pixel in A
C 
      IF (TID.LT.0) THEN
         TID = -TID
         IF (TID.EQ.99) THEN
            TFLAG = -1                   !only display output w. coords
         ELSE
            TFLAG = 0                    !image output pixels only, no coords
            NDOFF = 1
            NDUM = 1
            DUMLIM = 1000                !synchronize with array DUMBUF !!!
         ENDIF
      ELSE
         TFLAG = 1                       !table output w. coords
      ENDIF
C
C  branch according to action
      IF (ACTION(1:3).EQ.'OUT') GOTO 2000
C
      SIDE(1:) = 'inside '
C
C  find all pixels inside [XL,XH]
      IF (XRFLAG.EQ.0) THEN
         DO 200, IZ=SPIX(3),EPIX(3)
            YSAV = N
            DO 150, IY=SPIX(2),EPIX(2)
               XSAV = N
               DO 100, IX=SPIX(1),EPIX(1)
                  IF ((A(N).GE.XL).AND.(A(N).LE.XH)) THEN
                     KCOUNT = KCOUNT + 1
                     RVALS(NCOLS) = A(N)
                     IF (KCOUNT.GT.RMAX) THEN
                        IF (MMAX.LT.0) THEN
                           KCOUNT = RMAX
                           GOTO 3000         !stop already
                        ENDIF
                     ELSE
                        IF (TFLAG.EQ.1) THEN
                           RVALS(1) = IX
                           IF (NAXIS.GE.2) RVALS(2) = IY
                           IF (NAXIS.GE.3) RVALS(3) = IZ
                           CALL TBRWRR(TID,KCOUNT,NCOLS,TCOLS,
     +                                 RVALS,STAT)
                        ELSE IF (TFLAG.EQ.0) THEN
                           DUMBUF(NDUM) = A(N)
                           NDUM = NDUM + 1
                           IF (NDUM.GT.DUMLIM) THEN
                              CALL STFPUT(TID,NDOFF,DUMLIM,DUMBUF,STAT)
                              NDOFF = NDOFF + DUMLIM
                              NDUM = 1
                           ENDIF
                        ELSE
                           IF (NAXIS.EQ.1) THEN
                              WRITE(CBUF,10050) IX,RVALS(NCOLS)
                           ELSE IF (NAXIS.EQ.2) THEN
                              WRITE(CBUF,10051) IX,IY,RVALS(NCOLS)
                           ELSE 
                              WRITE(CBUF,10052) IX,IY,IZ,RVALS(NCOLS)
                           ENDIF
                           CALL STTPUT(CBUF,STAT)
                        ENDIF
                     ENDIF
                  ENDIF
                  N = N + 1
100            CONTINUE
               N = XSAV + NPIX(1)
               IF ((N .GT. CHUNK) .AND.              !get next chunk of data
     +             (IY.NE.EPIX(2))) THEN             !if not last line of plane
                  KOFF = ((IZ-1)*KPLANE) + (IY*NPIX(1)) + 1
                  CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
                  KOFF = KOFF + IAV
                  N = 1 + XOFF
               ENDIF
150         CONTINUE
            N = YSAV + KPLANE
            IF ((N .GT. CHUNK) .AND.              !get next chunk of data
     +          (IZ.NE.EPIX(3))) THEN             !if not last plane
               KOFF = (IZ*KPLANE) + YOFF + 1
               CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
               KOFF = KOFF + IAV
               N = 1 + XOFF
            ENDIF
200      CONTINUE
C
      ELSE IF (XRFLAG.EQ.1) THEN                   ! <,XH
         DO 400, IZ=SPIX(3),EPIX(3)
            YSAV = N
            DO 350, IY=SPIX(2),EPIX(2)
               XSAV = N
               DO 300, IX=SPIX(1),EPIX(1)
                  IF (A(N).LE.XH) THEN
                     KCOUNT = KCOUNT + 1
                     RVALS(NCOLS) = A(N)
                     IF (KCOUNT.GT.RMAX) THEN
                        IF (MMAX.LT.0) THEN
                           KCOUNT = RMAX
                           GOTO 3000         !stop already
                        ENDIF
                     ELSE
                        IF (TFLAG.EQ.1) THEN
                           RVALS(1) = IX
                           IF (NAXIS.GE.2) RVALS(2) = IY
                           IF (NAXIS.GE.3) RVALS(3) = IZ
                           CALL TBRWRR(TID,KCOUNT,NCOLS,TCOLS,
     +                                 RVALS,STAT)
                        ELSE IF (TFLAG.EQ.0) THEN
                           DUMBUF(NDUM) = A(N)
                           NDUM = NDUM + 1
                           IF (NDUM.GT.DUMLIM) THEN
                              CALL STFPUT(TID,NDOFF,DUMLIM,DUMBUF,STAT)
                              NDOFF = NDOFF + DUMLIM
                              NDUM = 1
                           ENDIF
                        ELSE
                           IF (NAXIS.EQ.1) THEN
                              WRITE(CBUF,10050) IX,RVALS(NCOLS)
                           ELSE IF (NAXIS.EQ.2) THEN
                              WRITE(CBUF,10051) IX,IY,RVALS(NCOLS)
                           ELSE 
                              WRITE(CBUF,10052) IX,IY,IZ,RVALS(NCOLS)
                           ENDIF
                           CALL STTPUT(CBUF,STAT)
                        ENDIF
                     ENDIF
                  ENDIF
                  N = N + 1
300            CONTINUE
               N = XSAV + NPIX(1)
               IF ((N .GT. CHUNK) .AND.              !get next chunk of data
     +             (IY.NE.EPIX(2))) THEN             !if not last line of plane
                  KOFF = ((IZ-1)*KPLANE) + (IY*NPIX(1)) + 1
                  CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
                  KOFF = KOFF + IAV
                  N = 1 + XOFF
               ENDIF
350         CONTINUE
            N = YSAV + KPLANE
            IF ((N .GT. CHUNK) .AND.              !get next chunk of data
     +          (IZ.NE.EPIX(3))) THEN             !if not last plane
               KOFF = (IZ*KPLANE) + YOFF + 1
               CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
               KOFF = KOFF + IAV
               N = 1 + XOFF
            ENDIF
400      CONTINUE
C
      ELSE IF (XRFLAG.EQ.2) THEN                   ! XL,>
         DO 600, IZ=SPIX(3),EPIX(3)
            YSAV = N
            DO 550, IY=SPIX(2),EPIX(2)
               XSAV = N
               DO 500, IX=SPIX(1),EPIX(1)
                  IF (A(N).GE.XL) THEN
                     KCOUNT = KCOUNT + 1
                     RVALS(NCOLS) = A(N)
                     IF (KCOUNT.GT.RMAX) THEN
                        IF (MMAX.LT.0) THEN
                           KCOUNT = RMAX
                           GOTO 3000         !stop already
                        ENDIF
                     ELSE
                        IF (TFLAG.EQ.1) THEN
                           RVALS(1) = IX
                           IF (NAXIS.GE.2) RVALS(2) = IY
                           IF (NAXIS.GE.3) RVALS(3) = IZ
                           CALL TBRWRR(TID,KCOUNT,NCOLS,TCOLS,
     +                                 RVALS,STAT)
                        ELSE IF (TFLAG.EQ.0) THEN
                           DUMBUF(NDUM) = A(N)
                           NDUM = NDUM + 1
                           IF (NDUM.GT.DUMLIM) THEN
                              CALL STFPUT(TID,NDOFF,DUMLIM,DUMBUF,STAT)
                              NDOFF = NDOFF + DUMLIM
                              NDUM = 1
                           ENDIF
                        ELSE
                           IF (NAXIS.EQ.1) THEN
                              WRITE(CBUF,10050) IX,RVALS(NCOLS)
                           ELSE IF (NAXIS.EQ.2) THEN
                              WRITE(CBUF,10051) IX,IY,RVALS(NCOLS)
                           ELSE 
                              WRITE(CBUF,10052) IX,IY,IZ,RVALS(NCOLS)
                           ENDIF
                           CALL STTPUT(CBUF,STAT)
                        ENDIF
                     ENDIF
                  ENDIF
                  N = N + 1
500            CONTINUE
               N = XSAV + NPIX(1)
               IF ((N .GT. CHUNK) .AND.              !get next chunk of data
     +             (IY.NE.EPIX(2))) THEN             !if not last line of plane
                  KOFF = ((IZ-1)*KPLANE) + (IY*NPIX(1)) + 1
                  CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
                  KOFF = KOFF + IAV
                  N = 1 + XOFF
               ENDIF
550         CONTINUE
            N = YSAV + KPLANE
            IF ((N .GT. CHUNK) .AND.              !get next chunk of data
     +          (IZ.NE.EPIX(3))) THEN             !if not last plane
               KOFF = (IZ*KPLANE) + YOFF + 1
               CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
               KOFF = KOFF + IAV
               N = 1 + XOFF
            ENDIF
600      CONTINUE
      ENDIF
C
      GOTO 3000
C
C  find 1. pixel outside [XL,XH]
C
2000  SIDE(1:) = 'outside '
C
      IF (XRFLAG.EQ.0) THEN
         DO 2200, IZ=SPIX(3),EPIX(3)
            YSAV = N
            DO 2150, IY=SPIX(2),EPIX(2)
               XSAV = N
               DO 2100, IX=SPIX(1),EPIX(1)
                  IF ((A(N).LT.XL).OR.(A(N).GT.XH)) THEN
                     KCOUNT = KCOUNT + 1
                     RVALS(NCOLS) = A(N)
                     IF (KCOUNT.GT.RMAX) THEN
                        IF (MMAX.LT.0) THEN
                           KCOUNT = RMAX
                           GOTO 3000         !stop already
                        ENDIF
                     ELSE
                        IF (TFLAG.EQ.1) THEN
                           RVALS(1) = IX
                           IF (NAXIS.GE.2) RVALS(2) = IY
                           IF (NAXIS.GE.3) RVALS(3) = IZ
                           CALL TBRWRR(TID,KCOUNT,NCOLS,TCOLS,
     +                                 RVALS,STAT)
                        ELSE IF (TFLAG.EQ.0) THEN
                           DUMBUF(NDUM) = A(N)
                           NDUM = NDUM + 1
                           IF (NDUM.GT.DUMLIM) THEN
                              CALL STFPUT(TID,NDOFF,DUMLIM,DUMBUF,STAT)
                              NDOFF = NDOFF + DUMLIM
                              NDUM = 1
                           ENDIF
                        ELSE
                           IF (NAXIS.EQ.1) THEN
                              WRITE(CBUF,10050) IX,RVALS(NCOLS)
                           ELSE IF (NAXIS.EQ.2) THEN
                              WRITE(CBUF,10051) IX,IY,RVALS(NCOLS)
                           ELSE
                              WRITE(CBUF,10052) IX,IY,IZ,RVALS(NCOLS)
                           ENDIF
                           CALL STTPUT(CBUF,STAT)
                        ENDIF
                     ENDIF
                  ENDIF
                  N = N + 1
2100           CONTINUE
               N = XSAV + NPIX(1)
               IF ((N .GT. CHUNK) .AND.              !get next chunk of data
     +             (IY.NE.EPIX(2))) THEN             !if not last line of plane
                  KOFF = ((IZ-1)*KPLANE) + (IY*NPIX(1)) + 1
                  CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
                  KOFF = KOFF + IAV
                  N = 1 + XOFF
               ENDIF
2150        CONTINUE
            N = YSAV + KPLANE
            IF ((N .GT. CHUNK) .AND.              !get next chunk of data
     +          (IZ.NE.EPIX(3))) THEN             !if not last plane
               KOFF = (IZ*KPLANE) + YOFF + 1
               CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
               KOFF = KOFF + IAV
               N = 1 + XOFF
            ENDIF
2200     CONTINUE
C
      ELSE IF (XRFLAG.EQ.1) THEN                   !  <,XH
         DO 2400, IZ=SPIX(3),EPIX(3)
            YSAV = N
            DO 2350, IY=SPIX(2),EPIX(2)
               XSAV = N
               DO 2300, IX=SPIX(1),EPIX(1)
                  IF (A(N).GT.XH) THEN
                     KCOUNT = KCOUNT + 1
                     RVALS(NCOLS) = A(N)
                     IF (KCOUNT.GT.RMAX) THEN
                        IF (MMAX.LT.0) THEN
                           KCOUNT = RMAX
                           GOTO 3000         !stop already
                        ENDIF
                     ELSE
                        IF (TFLAG.EQ.1) THEN
                           RVALS(1) = IX
                           IF (NAXIS.GE.2) RVALS(2) = IY
                           IF (NAXIS.GE.3) RVALS(3) = IZ
                           CALL TBRWRR(TID,KCOUNT,NCOLS,TCOLS,
     +                                 RVALS,STAT)
                        ELSE IF (TFLAG.EQ.0) THEN
                           DUMBUF(NDUM) = A(N)
                           NDUM = NDUM + 1
                           IF (NDUM.GT.DUMLIM) THEN
                              CALL STFPUT(TID,NDOFF,DUMLIM,DUMBUF,STAT)
                              NDOFF = NDOFF + DUMLIM
                              NDUM = 1
                           ENDIF
                        ELSE
                           IF (NAXIS.EQ.1) THEN
                              WRITE(CBUF,10050) IX,RVALS(NCOLS)
                           ELSE IF (NAXIS.EQ.2) THEN
                              WRITE(CBUF,10051) IX,IY,RVALS(NCOLS)
                           ELSE
                              WRITE(CBUF,10052) IX,IY,IZ,RVALS(NCOLS)
                           ENDIF
                           CALL STTPUT(CBUF,STAT)
                        ENDIF
                     ENDIF
                  ENDIF
                  N = N + 1
2300           CONTINUE
               N = XSAV + NPIX(1)
               IF ((N .GT. CHUNK) .AND.              !get next chunk of data
     +             (IY.NE.EPIX(2))) THEN             !if not last line of plane
                  KOFF = ((IZ-1)*KPLANE) + (IY*NPIX(1)) + 1
                  CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
                  KOFF = KOFF + IAV
                  N = 1 + XOFF
               ENDIF
2350        CONTINUE
            N = YSAV + KPLANE
            IF ((N .GT. CHUNK) .AND.              !get next chunk of data
     +          (IZ.NE.EPIX(3))) THEN             !if not last plane
               KOFF = (IZ*KPLANE) + YOFF + 1
               CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
               KOFF = KOFF + IAV
               N = 1 + XOFF
            ENDIF
2400     CONTINUE
C
      ELSE IF (XRFLAG.EQ.2) THEN                   !  XL,>
         DO 2600, IZ=SPIX(3),EPIX(3)
            YSAV = N
            DO 2550, IY=SPIX(2),EPIX(2)
               XSAV = N
               DO 2500, IX=SPIX(1),EPIX(1)
                  IF (A(N).LT.XL) THEN
                     KCOUNT = KCOUNT + 1
                     RVALS(NCOLS) = A(N)
                     IF (KCOUNT.GT.RMAX) THEN
                        IF (MMAX.LT.0) THEN
                           KCOUNT = RMAX
                           GOTO 3000         !stop already
                        ENDIF
                     ELSE
                        IF (TFLAG.EQ.1) THEN
                           RVALS(1) = IX
                           IF (NAXIS.GE.2) RVALS(2) = IY
                           IF (NAXIS.GE.3) RVALS(3) = IZ
                           CALL TBRWRR(TID,KCOUNT,NCOLS,TCOLS,
     +                                 RVALS,STAT)
                        ELSE IF (TFLAG.EQ.0) THEN
                           DUMBUF(NDUM) = A(N)
                           NDUM = NDUM + 1
                           IF (NDUM.GT.DUMLIM) THEN
                              CALL STFPUT(TID,NDOFF,DUMLIM,DUMBUF,STAT)
                              NDOFF = NDOFF + DUMLIM
                              NDUM = 1
                           ENDIF
                        ELSE
                           IF (NAXIS.EQ.1) THEN
                              WRITE(CBUF,10050) IX,RVALS(NCOLS)
                           ELSE IF (NAXIS.EQ.2) THEN
                              WRITE(CBUF,10051) IX,IY,RVALS(NCOLS)
                           ELSE
                              WRITE(CBUF,10052) IX,IY,IZ,RVALS(NCOLS)
                           ENDIF
                           CALL STTPUT(CBUF,STAT)
                        ENDIF
                     ENDIF
                  ENDIF
                  N = N + 1
2500           CONTINUE
               N = XSAV + NPIX(1)
               IF ((N .GT. CHUNK) .AND.              !get next chunk of data
     +             (IY.NE.EPIX(2))) THEN             !if not last line of plane
                  KOFF = ((IZ-1)*KPLANE) + (IY*NPIX(1)) + 1
                  CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
                  KOFF = KOFF + IAV
                  N = 1 + XOFF
               ENDIF
2550        CONTINUE
            N = YSAV + KPLANE
            IF ((N .GT. CHUNK) .AND.              !get next chunk of data
     +          (IZ.NE.EPIX(3))) THEN             !if not last plane
               KOFF = (IZ*KPLANE) + YOFF + 1
               CALL STFGET(IMNO,KOFF,CHUNK,IAV,A,STAT)
               KOFF = KOFF + IAV
               N = 1 + XOFF
            ENDIF
2600     CONTINUE
      ENDIF
C
C  test, if no pixel found
3000  N = INDEX(CXB,' ') - 1
      IF (N.LT.1) N = LEN(CXB)
      IF (KCOUNT.LE.0) THEN
         WRITE(CBUF,10000) SIDE,CXB(1:N)
      ELSE
         IF (KCOUNT.EQ.1) THEN
            WRITE(CBUF,20001) SIDE,CXB(1:N)
         ELSE
            WRITE(CBUF,20000) KCOUNT,SIDE,CXB(1:N)
         ENDIF
      ENDIF
      CALL STTPUT(CBUF,STAT)
      CALL STKWRI('OUTPUTI',KCOUNT,1,1,UNIT,STAT)
      INFO(2) = KCOUNT
C
C  for image output we have to check more
      IF ((TFLAG.EQ.0) .AND. (NDUM.GT.1)) THEN
         DUMLIM = NDUM - 1
         CALL STFPUT(TID,NDOFF,DUMLIM,DUMBUF,STAT)
      ENDIF
      RETURN
C
10000 FORMAT('No pixel ',A,'[',A,'] ...')
10050 FORMAT('frame pixel (',I6,'),  value = ',G12.5)
10051 FORMAT('frame pixel (',I6,',',I6,'),  value = ',G12.5)
10052 FORMAT('frame pixel (',I6,',',I6,',',I6,'),  value = ',G12.5)
20000 FORMAT(I6,' pixels ',A,'[',A,']')
20001 FORMAT('1 pixel ',A,'[',A,']')
C
      END

C @(#)adxy.for	19.1 (ESO-DMD) 02/25/03 13:23:04
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
c----------------------------------------------------------------------
      SUBROUTINE ADXY(A0,D0,XEST,YEST,NITER,INEX,COSD0,SIND0,ALFA0,
     *NX,NY,KK,IXY,IDX,IDY,BX,BY,CX,CY,SCHMIDT)
c----------------------------------------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z), INTEGER*4 (I-N)
C 
      PARAMETER   (MAXOBJ=100001)
C 
      DIMENSION A0(3),D0(3),D0A(3),AR(MAXOBJ,4),BX(9),BY(9),
     * XEST(2,2),YEST(2,2),X(10),KK(9),IDX(9),IDY(9)
      CHARACTER*1 SCHMIDT
C 
      PI = 4.0D0*DATAN(1.0D0)
      DOPI18 = PI/1.8D2
      DO0 = 0.0D0
      DO1 = 1.0D0
      DO60 = 6.0D1
      DO3600 = 3.6D3
      NITER = 0 
      INEX = 0
      ALFAS = (A0(1)+A0(2)/DO60+A0(3)/DO3600)*1.5D1*DOPI18
      RH = DO1

      DO 20 I = 1,3 
         IF (D0(I).LT.DO0) RH = -DO1 
   20    D0A(I) = DABS(D0(I))

      DELTS = RH*(D0A(1)+D0A(2)/DO60+D0A(3)/DO3600)*DOPI18
      IF (ALFA0.LT.PI/2D0.AND.ALFAS.GT.1.5D0*PI) ALFAS = ALFAS-2D0*PI 
      IF (ALFA0.GT.1.5D0*PI.AND.ALFAS.LT.PI/2D0) ALFAS = ALFAS+2D0*PI 
      COSRH = COSD0*DCOS(DELTS)*DCOS(ALFAS-ALFA0) + SIND0*DSIN(DELTS) 
      SINRH = DSQRT(DO1-COSRH**2) 
      SINPH = DCOS(DELTS)*DSIN(ALFAS-ALFA0)/SINRH 
      COSPH = (DSIN(DELTS)-SIND0*COSRH)/(COSD0*SINRH)
      IF (SCHMIDT.EQ.'Y') THEN 
          RH = DATAN(SINRH/COSRH)
      ELSE
          RH = SINRH/COSRH
      ENDIF 

      AKSI = RH*SINPH/DOPI18
      ANU = RH*COSPH/DOPI18 
      XEST(1,1) = ((AKSI-CX)*BY(2)-(ANU-CY)*BX(2))/ 
     1(BX(1)*BY(2)-BX(2)*BY(1)) 
      YEST(1,1) = ((AKSI-CX)*BY(1)-(ANU-CY)*BX(1))/ 
     1(BX(2)*BY(1)-BX(1)*BY(2)) 


   30 XEST(2,1) = XEST(1,1)*1.0D3 
      YEST(2,1) = YEST(1,1)*1.0D3 

      IF (DABS(XEST(2,1)).GT.2.0D5.OR.DABS(YEST(2,1)).GT.2.0D5) 
     >   then
         WRITE(6,9050) XEST(2,1),YEST(2,1) 
 9050    FORMAT(/,1X,'COMPUTED (X,Y):',2(F12.2),/, 
     >          1X,'POSITION OUTSIDE PLATE AREA. SORRY')
         INEX = 1
         return
         endif

   60 NITER = NITER + 1 
   70 AR(1,1) = XEST(1,1) 
      AR(1,2) = YEST(1,1)
      AR(1,3) = DO0 
      AR(1,4) = DO0 
      I16 = 1 
      N = NX+1
      IXY = 1 

      CALL RAR(I16,0,N,KK,IXY,IDX,IDY,X,AR) 

      L = NX
      V = DO0 

      DO 80 I17 = 1,L 
   80   V = V + BX(I17)*X(I17)
      AKSI1 = V + CX
      N = NY + 1
      IXY = 2 

      CALL RAR(I16,0,N,KK,IXY,IDX,IDY,X,AR) 

      L = NY
      V = DO0 

      DO 90 I17 = 1,L 
   90   V = V + BY(I17)*X(I17)

      ANU1 = V + CY 
      DKSI = AKSI1 - AKSI 
      DNU = ANU1 - ANU
      DDIST = DSQRT(DKSI**2 + DNU**2) 
      DCRIT = 1.0D-6
      IF (DDIST.LE.DCRIT ) return

      N = NX + 1
      IXY = 1 
      CALL RAR(1,1,N,KK,IXY,IDX,IDY,X,AR) 
      L = NX
      V = DO0 

      DO 110 I17 = 1,L
  110   V = V + BX(I17)*X(I17)

      DKDX = V
      N = NX + 1
      IXY = 1 
      CALL RAR(1,2,N,KK,IXY,IDX,IDY,X,AR) 
      L = NX
      V = DO0 

      DO 120 I17 = 1,L
  120   V = V + BX(I17)*X(I17)

      DKDY = V
      N = NY + 1
      IXY = 2 
      CALL RAR(1,1,N,KK,IXY,IDX,IDY,X,AR) 
      L = NY
      V = DO0 

      DO 130 I17 = 1,L
  130 V = V + BY(I17)*X(I17)

      DNDX = V
      N = NY + 1
      IXY = 2 
      CALL RAR(1,2,N,KK,IXY,IDX,IDY,X,AR) 
      L = NY
      V = DO0 

      DO 140 I17 = 1,L
  140   V = V + BY(I17)*X(I17)

      DNDY = V
      YEST(1,2) = (DKSI*DNDX-DNU*DKDX)/(DNDX*DKDY-DKDX*DNDY)
      XEST(1,2) = (DKSI*DNDY-DNU*DKDY)/(DKDX*DNDY-DNDX*DKDY)
      XEST(1,1) = XEST(1,1) - XEST(1,2) 
      YEST(1,1) = YEST(1,1) - YEST(1,2)
      GO TO 30

      END 

C @(#)poisson.for	19.1 (ES0-DMD) 02/25/03 13:17:43
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE POISSN(INDEP,X,NP,PARAM,Y1,DERIV)                             
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                  
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  18:01 - 21 DEC 1987                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C--------------------------------------------------------------                 
C****************************************************                           
C                                                                               
C      IMPLICIT NONE                                                            
C   Poisson Distribution                                                        
C                                                                               
C   Y = P1*(P2**X)*EXP(-P2)/GAMMA(X+1)                                          
C                                                                               
C****************************************************                           
C                                                                               
C   Author: O.-G. Richter, ESO Garching                                         
C                                                                               
      INTEGER NP,INDEP
      DOUBLE PRECISION Y1,PARAM(NP),DERIV(NP),Z,ZZ                              
      REAL X(INDEP)                                                             
      DOUBLE PRECISION DGAMMA                                                   
C                                                                               
      Z      = 0.0D0 + X(1)                                                     
      ZZ     = 1.0D0 + X(1)                                                     
      DERIV(1) = (PARAM(2)**Z)*DEXP(-PARAM(2))/DGAMMA(ZZ)                       
      Y1     = PARAM(1)*DERIV(1)                                                
      DERIV(2) = Y1* (Z/PARAM(2)-1.0D0)                                         
      RETURN                                                                    
                                                                                
      END                                                                       

C @(#)corpsf.for	19.1 (ES0-DMD) 02/25/03 13:25:32
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C
C
C
C-----------------------------------------------------------------------
      SUBROUTINE CORPSF(LPXL, LSBP, LL, CPSF, IPSF,
     &                  CRMD, BPSF, DPSF)
C
      IMPLICIT  NONE
      INCLUDE   'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER   LPXL
      INTEGER   LSBP
      INTEGER   LL
      REAL      CPSF((-LPXL):LPXL,(-LPXL):LPXL,(-LSBP):LSBP,
     &               (-LSBP):LSBP,NOSP)
      INTEGER   IPSF((-LSBP):LSBP,(-LSBP):LSBP)
      REAL      CRMD(3)
      REAL      BPSF((-LL):LL,(-LL):LL)
      REAL      DPSF((-LL):LL,(-LL):LL)
C
      INTEGER   I, II
      INTEGER   IT, IK
      INTEGER   ISTAT
      INTEGER   ITMP
      INTEGER   J
      INTEGER   JL
      INTEGER   K
      INTEGER   L
C
      REAL      AIT
C     REAL      SIGMA
C
      REAL   TEMP(NOSP)
C
      CHARACTER*80   OUTPUT
C
      IT = 0
      DO 10 L = -LSBP , LSBP
          DO 20 K = -LSBP , LSBP
              ITMP = IPSF(K,L)
              IT = IT + ITMP
              DO 30 J = -LPXL , LPXL
                  JL = J * (2*LSBP+1) - L
                  DO 40 I = -LPXL , LPXL
                      IK = I * (2*LSBP+1) - K
                      DO 50 II = 1 , ITMP
                          TEMP(II) = CPSF(I,J,K,L,II)
   50                 CONTINUE
                      IF ( ITMP .GT. 2 ) THEN
                          CALL MODE( TEMP , ITMP , CRMD , BPSF(IK,JL) ,
     &                               DPSF(IK,JL) )
                          IF ( ITMP .EQ. 3 ) THEN
                              DPSF(IK,JL) = 1.5 * DPSF(IK,JL)
                          ENDIF
                      ELSE IF ( ITMP .EQ. 2 ) THEN
                          BPSF(IK,JL) = ( TEMP(1) + TEMP(2) ) / 2.0
                          DPSF(IK,JL) = MAX(0.1,ABS(TEMP(1)-TEMP(2)))
                      ELSE IF ( ITMP .EQ. 1 ) THEN
                          BPSF(IK,JL) = TEMP(1)
                          DPSF(IK,JL) = 1.0
                      ELSE
                          BPSF(IK,JL) = 0.0
                          DPSF(IK,JL) = 10.0
                      ENDIF
   40             CONTINUE
   30         CONTINUE
   20     CONTINUE
   10 CONTINUE
      AIT = FLOAT(IT) / FLOAT((2*LSBP+1)**2)
      WRITE( OUTPUT , '(A,A,F7.2)' ) 'Average number of standard stars '
     &               ,'per subpixel =',AIT
      CALL STTPUT( OUTPUT , ISTAT )
C
      RETURN
C
      END

C @(#)setopto.for	19.1 (ES0-DMD) 02/25/03 14:27:54
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C @(#)setopto.for	19.1 (ESO-IPG) 14:27:54 02/25/03
      PROGRAM SETOP
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION: setopto.for
C.PURPOSE: set OPTOPUS parameters according to the comand:
C          SET/OPTO parameter=value ...
C                   set plate center (RA and DEC)
C                   set original and new equinox (OLDEQ and NEWEQ)
C                   set label to be put on top of graphics
C                   set date (YEAR,MONTH,DAY)
C                   set exposure time in minutes
C                   set wavelength range in angstrom
C                   set observation slot in sidereal time
C                   set optimal sidereal time
C                   set automatic center determination flag
C                   set center precession flag
C                   set automatic optimal ST determination flag
C                   set E-W flip flag
C.AUTHOR: Alessandra Gemmo      Padova Department of Astronomy
C.VERSION: 910522 AG Creation
C.VERSION: 910719 AG Modified to set RA and DEC in HH,MM,SS and DD,PP,AA
C                    format, taking care of "-00" case.
C          910827 AG Modified to introduce character flags (Y or N).
C-------------------------------------------------------------------------------
      IMPLICIT NONE
C
C ***
C
      INTEGER      KUN,KNUL
      INTEGER      NPAR,IST,IPAR
      INTEGER      MADRID(1)
      INTEGER      IACT,I,II
      INTEGER      NEL,ISTAT
      INTEGER      IVAL(10)
      INTEGER      INDX,LEN,ILEN,N
      INTEGER      CSIGN,IND,IND1,IND2
C
C ***
C
      REAL         RVAL(10), RDUM(10)
C
C ***
C
      DOUBLE PRECISION       DVAL(10),PLTC(2),EPP
C
C ***
C
      CHARACTER*80 CVAL,INPUT,NAME,VALUE,VALU1
      CHARACTER*8  PNAME,FORM
      CHARACTER*80 DECCHA(3)
      CHARACTER*72 CINPUT
C
C ***
C
      INCLUDE      'MID_INCLUDE:ST_DEF.INC/NOLIST'
      COMMON       /VMR/MADRID
      INCLUDE      'MID_INCLUDE:ST_DAT.INC/NOLIST'
C
C ***
C  
      DATA          CSIGN/0/
C
C *** start the code
C
      CALL STSPRO('SET_OPTO')
C
C *** do the work
C
      CALL STKRDI('PCOUNT',1,1,IACT,NPAR,KUN,KNUL,IST) !get number of param.
      CVAL = ' '                                       !to be modified
      DO 10 IPAR=1,NPAR
         WRITE(PNAME,9000)IPAR
9000     FORMAT('P',I1)
         CALL STKRDC(PNAME,1,1,80,IACT,INPUT,KUN,KNUL,IST)
         CALL UPCAS(INPUT,INPUT)             !convert to uppercase
         II = INDEX(INPUT,'=')
         IF(II.EQ.0)THEN
           NAME  = INPUT
           VALUE = ' '
         ELSE
           NAME  = INPUT(1:II-1)
           VALUE = INPUT(II+1:)
C
         IF(NAME(1:3).EQ.'OLD'.OR.NAME(1:3).EQ.'NEW'.OR.
     1    NAME(1:3).EQ.'DAT')THEN
           IF(VALUE(1:2).EQ.'19')THEN
            VALU1 = VALUE(3:80)
           ELSE IF(VALUE(1:2).NE.'19')THEN
            VALU1 = VALUE(1:80)
           ENDIF
          ELSE
            VALU1 = VALUE(1:80)
          ENDIF
     
       ENDIF
C
       IF(NAME(1:3).EQ.'DEF')THEN 
          CALL STSEPI                         !default setting; done in .prg
       ELSE 
C
C *** character-number conversion
C
      CALL DECAG(NAME,CINPUT,VALU1,FORM,IVAL,RVAL,CVAL,INDX,LEN,IST)
          IF(IST.NE.0)CALL STETER(IST,'*** FATAL: Wrong syntax ... ')
C
           IF(NAME(1:3).EQ.'OLD'.OR.NAME(1:3).EQ.'NEW'.OR.
     1        NAME(1:3).EQ.'DAT')THEN
            IF(VALUE(1:2).EQ.'19'.OR.CINPUT(1:2).EQ.'19')THEN
             DVAL(1) = DBLE(RVAL(1)) + 1900.
            ELSE IF(VALUE(1:2).NE.'19'.OR.CINPUT(1:2).NE.'19')THEN
             DVAL(1) = DBLE(RVAL(1))
            ENDIF
             ELSE
             DVAL(1) = DBLE(RVAL(1))
           ENDIF
C
          DO I=2,10
            DVAL(I) = DBLE(RVAL(I))
          ENDDO
C
       ENDIF
C
C *** do some checking
C
      IF(NAME(1:2).EQ.'CR')THEN                !consistency of coord. values
        ILEN = NEL(RVAL,3)
        IF(ILEN.LT.3)THEN                      !not enough input
          CALL STETER(ISTAT,'*** FATAL: Specify hours,min,sec of RA')
        ELSE IF(RVAL(1).LT.0..OR.RVAL(1).GT.24.)THEN
          CALL STETER(ISTAT,'*** FATAL: Wrong RA-hours value!!')
        ELSE IF(RVAL(2).LT.0..OR.RVAL(2).GT.60.)THEN
          CALL STETER(ISTAT,'*** FATAL: Wrong RA-min value!!')
        ELSE IF(RVAL(3).LT.0..OR.RVAL(3).GT.60.)THEN
          CALL STETER(ISTAT,'*** FATAL: Wrong RA-sec value!!')
        ELSE
          PLTC(1) = DVAL(1)+DVAL(2)/60.+DVAL(3)/3600.
          CALL STKWRD('PLATEC1',PLTC(1),1,1,KUN,IST)
          CALL STKWRD('PLATECEN',DVAL(1),1,1,KUN,IST)
          CALL STKWRD('PLATECEN',DVAL(2),2,1,KUN,IST)
          CALL STKWRD('PLATECEN',DVAL(3),3,1,KUN,IST)
        ENDIF
C
      ELSE IF(NAME(1:2).EQ.'CD')THEN
        IND1 = INDEX(CVAL,',')
        IND2 = INDEX(CVAL(IND1+1:80),',') + IND1
        DECCHA(1) = CVAL(1:IND1-1)
        DECCHA(2) = CVAL(IND1+1:IND2-1)
        DECCHA(3) = CVAL(IND2+1:80)
C
C *** decode character DECCHA to real array
C
        CALL USRINP(RVAL(1),80,'R',DECCHA(1))
        CALL USRINP(RVAL(2),80,'R',DECCHA(2))
        CALL USRINP(RVAL(3),80,'R',DECCHA(3))
C
        DVAL(1) = DBLE(RVAL(1))
        DVAL(2) = DBLE(RVAL(2))
        DVAL(3) = DBLE(RVAL(3))
C
        ILEN = NEL(RVAL,3)
        IND = INDEX(CVAL,'-')
        IF(ILEN.LT.3)THEN                      !not enough input
          CALL STETER(ISTAT,'*** FATAL: Specify deg,amin,asec of DEC')
        ELSE IF(RVAL(1).LT.-90..OR.RVAL(1).GT.90.)THEN
          CALL STETER(ISTAT,'*** FATAL: Wrong DEC-degrees value!!')
        ELSE IF(RVAL(2).GT.60.)THEN
          CALL STETER(ISTAT,'*** FATAL: Wrong DEC-arcmin value!!')
        ELSE IF (RVAL(3).GT.60.)THEN
          CALL STETER(ISTAT,'*** FATAL: Wrong DEC-arcsec value!!')
        ELSE 
          IF(IND.NE.0)CSIGN = 1
          DVAL(1) = DABS(DVAL(1))
          DVAL(2) = DABS(DVAL(2))
          DVAL(3) = DABS(DVAL(3))
          PLTC(2) = DVAL(1)+DVAL(2)/60.+DVAL(3)/3600.
          IF(CSIGN.EQ.1)PLTC(2)=-PLTC(2)
          CALL STKWRD('PLATEC1',PLTC(2),2,1,KUN,IST)
          CALL STKWRC('PLATECHA',1,CVAL,1,80,KUN,IST)
          CALL STKWRD('PLATECEN',DVAL(1),4,1,KUN,IST)
          CALL STKWRD('PLATECEN',DVAL(2),5,1,KUN,IST)
          CALL STKWRD('PLATECEN',DVAL(3),6,1,KUN,IST)
        ENDIF
C
      ELSE IF(NAME(1:2).EQ.'OL')THEN
        IF(DVAL(1).LT.1800..OR.DVAL(1).GT.2100.)THEN
          CALL STETER(ISTAT,'*** FATAL: Value of equinox0 not allowed')
        ELSE
          CALL STKWRD('EQUINOX',DVAL(1),1,1,KUN,IST)
        ENDIF
C
      ELSE IF(NAME(1:2).EQ.'NE')THEN
        IF(DVAL(1).LT.1800..OR.DVAL(1).GT.2100.)THEN
          CALL STETER(ISTAT,'*** FATAL: Value of equinox1 not allowed')
        ELSE
          CALL STKWRD('EQUINOX',DVAL(1),2,1,KUN,IST)
        ENDIF
C
      ELSE IF (NAME(1:2).EQ.'LA')THEN
        CALL STKWRC('LABEL',1,CVAL,INDX,LEN,KUN,IST)
C
      ELSE IF (NAME(1:2).EQ.'DA')THEN
        DO 991, N=1,10                         !double -> real
           RDUM(N) = DVAL(N)
991     CONTINUE
        ILEN = NEL(RDUM,3)
        DO 992, N=1,10                         !double -> real
           DVAL(N) = RDUM(N)
992     CONTINUE
        IF(ILEN.LT.3)THEN     !not enough input
          CALL STETER(ISTAT,'*** FATAL: Specify year,month,day')
        ELSE IF(DVAL(1).LT.1980.)THEN
          CALL STETER(ISTAT,'*** FATAL: Wrong year value')
        ELSE IF(DVAL(2).LT.0..OR.DVAL(2).GT.12.)THEN
          CALL STETER(ISTAT,'*** FATAL: Wrong month value')
        ELSE IF(DVAL(3).LT.0..OR.DVAL(3).GT.31.)THEN
          CALL STETER(ISTAT,'*** FATAL: Wrong day value')
        ELSE
          CALL STKWRD('DATE',DVAL(1),1,1,KUN,IST)
          CALL STKWRD('DATE',DVAL(2),2,1,KUN,IST)
          CALL STKWRD('DATE',DVAL(3),3,1,KUN,IST)
C
C *** calculate epoch from date
C
          CALL EPOCH(DVAL(1),DVAL(2),DVAL(3),EPP)
C
C *** write epoch in keyword
C
          CALL STKWRD('EPOCH',EPP,1,1,KUN,ISTAT)
C
        ENDIF
C
      ELSE IF(NAME(1:2).EQ.'EX')THEN
        IF(DVAL(1).LT.0.)THEN
          CALL STETER(ISTAT,'*** FATAL: Exposure time can`t be < 0 !!')
        ELSE
          CALL STKWRD('EXPTIME',DVAL(1),1,1,KUN,IST)
        ENDIF
C
      ELSE IF(NAME(1:2).EQ.'WR')THEN
        ILEN = NEL(RVAL,2)
        IF(ILEN.LT.2)THEN     !not enough input
          CALL STETER(ISTAT,'*** FATAL: Specify start and end of range')
        ELSE
          CALL STKWRD('LAMBDA',DVAL(1),1,1,KUN,IST)
          CALL STKWRD('LAMBDA',DVAL(2),2,1,KUN,IST)
        ENDIF
C
      ELSE IF(NAME(1:2).EQ.'SI')THEN
        ILEN = NEL(RVAL,2)
        IF(ILEN.LT.2)THEN     !not enough input
          CALL STETER(ISTAT,'*** FATAL: Specify start and end of observa
     1tion slot')
        ELSE IF(RVAL(1).LT.0..OR.RVAL(1).GT.24.)THEN
          CALL STETER(ISTAT,'*** FATAL: Absurd start ST value!!')
        ELSE IF(RVAL(2).LT.0..OR.RVAL(2).GT.24.)THEN
          CALL STETER(ISTAT,'*** FATAL: Absurd end ST value!!')
        ELSE
          CALL STKWRD('STSLOT',DVAL(1),1,1,KUN,IST)
          CALL STKWRD('STSLOT',DVAL(2),2,1,KUN,IST)
        ENDIF
C
      ELSE IF(NAME(1:2).EQ.'OS')THEN
        IF(RVAL(1).LT.0..OR.RVAL(1).GT.24.)THEN
          CALL STETER(ISTAT,'*** FATAL: ST must be in range 0 - 24 !')
        ELSE
          CALL STKWRD('SIDTIME',DVAL(1),1,1,KUN,IST)
        ENDIF
C
      ELSE IF (NAME(1:2).EQ.'AC')THEN
        IF(CVAL(1:1).NE.'Y'.AND.CVAL(1:1).NE.'N')THEN
          CALL STETER(ISTAT,
     2     '*** FATAL: AC-flag can be only either Y or N !!')
        ELSE
          CALL STKWRC('ACFLAG',1,CVAL(1:1),1,1,KUN,IST)
        ENDIF
C
      ELSE IF (NAME(1:2).EQ.'PF')THEN
        IF(CVAL(1:1).NE.'Y'.AND.CVAL(1:1).NE.'N')THEN
          CALL STETER(ISTAT,
     2     '*** FATAL: PREC-flag can be only either Y or N !!')
        ELSE
          CALL STKWRC('PFLAG',1,CVAL(1:1),1,1,KUN,IST)
        ENDIF
C
      ELSE IF (NAME(1:2).EQ.'AS')THEN
        IF(CVAL(1:1).NE.'Y'.AND.CVAL(1:1).NE.'N')THEN
          CALL STETER(ISTAT,
     2     '*** FATAL: AST-flag can be only either Y or N !!')
        ELSE
          CALL STKWRC('ASTFLAG',1,CVAL(1:1),1,1,KUN,IST)
        ENDIF
C
      ELSE IF(NAME(1:2).EQ.'EW')THEN
        IF(CVAL(1:1).NE.'Y'.AND.CVAL(1:1).NE.'N')THEN
          CALL STETER(ISTAT,
     2     '*** FATAL: EW-flag can be only either Y or N !!')
        ELSE
          CALL STKWRC('EWFLAG',1,CVAL(1:1),1,1,KUN,IST)
        ENDIF
C
       ENDIF
10    CONTINUE
C
C *** over and out
C
      CALL STSEPI
      END
C
C *** 
C
      SUBROUTINE DECAG(NAME,CINPUT,VALU1,FORM,
     1                            IVAL,RVAL,CVAL,INDX,LEN,IST)
C+++                                                                            
C.PURPOSE:  Decode parameter in the contents
C.AUTHOR:   J.D Ponz, ESO-Garching
C.COMMENTS: none
C.VERSION:  ?????? JDP  creation
C.VERSION:  890117 RHW  convert to ST interfaces
C.VERSION:  910621 AG   modified for Optopus context
C---                                                                            
      IMPLICIT       NONE
      CHARACTER*(*)  NAME                ! IN:  par name                        
      CHARACTER*(*)  VALU1               ! IN:  par value (blanks if defaulted) 
      CHARACTER*(*)  FORM                ! IN:  format                          
      CHARACTER*(*)  CVAL                ! OUT: character output                
      REAL           RVAL(10)            ! OUT: real output                     
      INTEGER        INDX                ! OUT: array index                     
      INTEGER        LEN                 ! OUT: output length                   
      INTEGER        IVAL(10)            ! OUT: integer output                  
C                                                                               
C *** definition                                                                
      INTEGER       NP
      PARAMETER     (NP=14)                                                    
      INTEGER       I, I1, IST
      INTEGER       IND(NP)       !   -- output index                           
      INTEGER       LENGTH(NP)    !   -- parameter length                       
      INTEGER       MINL(NP)      !   -- minimum matching length                
      INTEGER       NR
      CHARACTER*20  CDEF(NP)      !   -- parameter defaults                     
      CHARACTER*1   FORM1(NP)     !   -- parameter format                       
      CHARACTER*8   TEMPL(NP)     !   -- parameter names                        
      CHARACTER*72   CINPUT,CINPU1                                   
C
      DATA          TEMPL/'CRA     ','CDEC    ','OLDEQ   ',
     5                    'NEWEQ   ','LABEL   ','DATE    ','EXTIM   ',
     6                    'WRANGE  ','SITSLT  ','OST     ','ACFLAG  ',
     7                    'ASTFLAG ','EWFLAG  ','PFLAG   '/
      DATA          FORM1/'R'       ,'C'       ,'R',
     5                    'R'       ,'C'       ,'R'      ,'R',
     6                    'R'       ,'R'       ,'R'      ,'C',
     7                    'C'       ,'C'       ,'C'/
      DATA          MINL/  2         ,2        ,2,
     5                     1        ,1         ,1        ,2,
     6                     1        ,2         ,2        ,2,
     7                     2        ,2         ,2/
      DATA          IND/   1        ,4         ,1,
     5                     2        ,1         ,1        ,1,
     6                     1        ,1         ,1        ,1,
     7                     1        ,1         ,1/
      DATA          LENGTH/3        ,3         ,1,
     5                     1        ,40        ,3        ,1,
     6                     2        ,2         ,1        ,1,
     7                     1        ,1         ,1/
      DATA          CDEF/ '0.,0.,0.','0.,0.,0.','1950.   ',
     5                    '2000.  ','Optopus Plate','1999.,12.,31.',
     6                    '0.      ','3800.,8000. ','0.,0.       ',
     7                    '0.      ','Y       ','Y    ','N       ',
     8                    'Y       '/
C                                                                               
C *** iterate on parameter names (minimum match)                               
      DO 10 I = 1,NP                                                            
         I1     = MINL(I)                                                       
         IF (NAME(1:I1).EQ.TEMPL(I)(1:I1)) THEN              ! matching found   
            FORM   = FORM1(I)                                                   
            INDX   = IND(I)                                                     
            LEN    = LENGTH(I)                                                  
            IF (VALU1(1:1).EQ.' ') THEN
               CINPUT = CDEF(I) 
               IF(NAME(1:2).EQ.'OL'.OR.NAME(1:2).EQ.'NE'.OR.
     1           NAME(1:2).EQ.'DA')THEN
                 IF(CINPUT(1:2).EQ.'19')THEN
                   CINPU1 = CINPUT(3:72)
                 ELSE IF(CINPUT(1:2).NE.'19')THEN
                   CINPU1 = CINPUT(1:72)
                 ENDIF
                ELSE
                  CINPU1 = CINPUT(1:72)
             ENDIF
            ELSE                                                                
               CINPU1 = VALU1
            ENDIF                                                               
C                                                                               
             IF (FORM(1:1).EQ.'C') THEN                                   
               CVAL   = CINPU1                                                  
               IF (NAME(1:2).EQ.'XA') THEN                                      
                  IF (CVAL(1:1).NE.'A') THEN                                    
                     CVAL   = 'MANU'                                            
                     CALL USRINP(RVAL,LEN,'R',CINPU1)                           
                  ENDIF                                                         
                                                                                
               ELSE IF (NAME(1:2).EQ.'YA') THEN                                 
                  IF (CVAL(1:1).NE.'A') THEN                                    
                     CVAL   = 'MANU'                                            
                     CALL USRINP(RVAL,LEN,'R',CINPU1)                           
                  ENDIF                                                         
               ENDIF                                                            
C                                                                               
            ELSE IF (FORM(1:1).EQ.'I') THEN                                     
               CALL USRINP(RVAL,LEN,'R',CINPU1)                                 
               DO NR = 1,LEN                                                    
                  IVAL(NR) = INT(RVAL(NR))                                      
               ENDDO                                                            
C                                                                               
            ELSE                                                                
               CALL USRINP(RVAL,LEN,'R',CINPU1)                                 
            ENDIF                                                               
            RETURN                                                              
         ENDIF                                                                  
C
   10 CONTINUE                                                                  
      CALL STTPUT('*** FATAL: Illegal parameter name ... ',IST)                 
      IST  = 1                                                                  
C                                                                               
      RETURN                                                                    
      END                                                                       
C-------------------------------------------------------------------------------
      SUBROUTINE EPOCH(YEAR,MONTH,DAY,EPP)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.PURPOSE: Calculate epoch from year, month and day.
C.AUTHOR:  Alessandra Gemmo       Padova Department of Astronomy
C.VERSION: 910827 AG Creation
C.------------------------------------------------------------------------------
      IMPLICIT NONE
C
C ***
C
      DOUBLE PRECISION     YEAR,MONTH,DAY
      DOUBLE PRECISION     DAY1
      DOUBLE PRECISION     EPP,NDAYS
      DOUBLE PRECISION     RES0,RES1
C
C ***
C
      DATA                 NDAYS/365./
C
C ***
C
      IF(YEAR.NE.0..AND.MONTH.EQ.0..AND.DAY.EQ.0.)THEN
       DAY1 = 0.
      ELSE IF(YEAR.NE.0..AND.MONTH.EQ.0..AND.DAY.NE.0.)THEN
       CALL STETER(9,
     2  '*** FATAL: MONTH can`t be 0 if date not in decimals of year !')
      ELSE IF(YEAR.NE.0..AND.MONTH.NE.0..AND.DAY.EQ.0.)THEN
       CALL STETER(9,
     2  '*** FATAL: DAY can`t be 0 if date not in decimals of year!')
      ENDIF
      IF(MONTH.EQ.1.)DAY1 = 0.  + DAY
      IF(MONTH.EQ.2.)DAY1 = 31. + DAY
      IF(MONTH.EQ.3.)DAY1 = 59. + DAY
      IF(MONTH.EQ.4.)DAY1 = 90. + DAY
      IF(MONTH.EQ.5.)DAY1 = 120.+ DAY
      IF(MONTH.EQ.6.)DAY1 = 151.+ DAY
      IF(MONTH.EQ.7.)DAY1 = 181.+ DAY
      IF(MONTH.EQ.8.)DAY1 = 212.+ DAY
      IF(MONTH.EQ.9.)DAY1 = 243.+ DAY
      IF(MONTH.EQ.10.)DAY1= 273.+ DAY
      IF(MONTH.EQ.11.)DAY1= 304.+ DAY
      IF(MONTH.EQ.12.)DAY1= 334.+ DAY
C
      RES0 = DMOD(YEAR,4.0D0)
      RES1 = DMOD(YEAR,4.0D2)
      IF(RES0.EQ.0..AND.RES1.NE.0.)NDAYS= 366.
C
      EPP  = DAY1/NDAYS+YEAR 
      RETURN
      END
C-------------------------------------------------------------------------------

C @(#)gridima.for	19.1 (ESO-DMD) 02/25/03 13:31:22
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C.IDENTIFICATION: GRIDIMA
C.LANGUAGE:       F77+ESOext
C.AUTHOR:         D.Baade
C.KEYWORDS:       Ingeneering frames
C.PURPOSE:        Produce 2-D frame with rectangular grid subjected to
C                 "S-type" distortion
C.ALGORITHM:      trivial
C.PECULARITIES:   The size of the frame is fixed to 510 by 510 pixels as is the
C                 separation of the lines of the undistorted grid to 60 pixels
C.INPUT/OUTPUT:   The following key words are used:
C                 ALPHA/R/1/1  angle ALPHA_0 of the distortion in the following 
C                 parametrization:
C                                 ALPHA = ALPHA0 * R**2
C                 with R being the distance from the point about which
C                 the rotation takes place. ALPHA_0 to be given in degrees/pixel.
C.VERSION:        850322 DB  Creation
C.VERSION:        871123 RHW ESO-FORTRAN Conversion
C
C 021031	last modif
C 
C ---------------------------------------------------------------------
      PROGRAM GRDIMA

      IMPLICIT     NONE
C
      INTEGER      MADRID,IMF
      INTEGER      IAV,ISTAT
      INTEGER      NPIX(2)
      INTEGER      NAXIS
      INTEGER      KUN,KNUL
      INTEGER*8    IPNTR
C
      CHARACTER    IDENT*72,CUNIT*48,IMAG*64
C
      REAL         ALPHA0
      REAL         LHCUTS(4)
      DOUBLE PRECISION START(2),STEP(2)
C
      INCLUDE      'MID_INCLUDE:ST_DEF.INC/NOLIST'
      COMMON       /VMR/MADRID(1)
      INCLUDE      'MID_INCLUDE:ST_DAT.INC/NOLIST'
C
      DATA         START/1.,1./
      DATA         STEP/1.,1./
      DATA         NAXIS/2/
      DATA         NPIX/510,510/
      DATA         LHCUTS/0.,100.,0.,100./
      DATA         IMAG/'GRID'/
      DATA         IDENT/'GRID'/
      DATA         CUNIT/'FLUX'/
C
C *** begin code
      CALL STSPRO('GRIDIMA')                        ! get into midas environment
      CALL STKRDR('ALPHA',1,1,IAV,ALPHA0,KUN,KNUL,ISTAT)  ! get distortion angle
      ALPHA0 = ALPHA0*3.14159/180.                        !   convert to radians
      CALL STIPUT(IMAG,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,NAXIS,
     2            NPIX,START,STEP,IDENT,CUNIT,IPNTR,IMF,ISTAT)
C
C *** we already know (by definition) the cuts. let's set them now:
      CALL FLLGRD(MADRID(IPNTR),ALPHA0)            ! call fillgrid to do the job
      CALL STDWRR(IMF,'LHCUTS',LHCUTS,1,4,KUN,ISTAT)
C
      CALL STSEPI                            ! release files and update keywords
      END

C @(#)tsadelur2.for	10.2 (ES0-DMD) 1/16/96 00:53:01
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C                                                                               
C                                                                               
C                                                                               
C    TSADELUR2                                                                        
C                                                                               
C   Autocorrelation function of data in analytic form, for FITCOR
C   An example from Ap.J. 385,404 (case B)               
C                                                                               
C   Input:                                                                      
C   TLAG                          - time lag                                      
C                                                                               
C   Output:                                                                     
C   TSADELUR2                     - ACF function value                            
C                                                                               
      DOUBLE PRECISION FUNCTION TSADELUR2(TLAG,PARM)                                                   
      DOUBLE PRECISION TLAG, PARM(12)
      TSADELUR2=0.2**2-(0.011*ABS(TLAG)**0.34)**2                                     
      END                                                                       

C @(#)sbtrct.for	19.1 (ES0-DMD) 02/25/03 13:30:48
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE SBTRCT(FRAMEA,FRAMEC,FRAMED,NIX,NIY,DXSTR,DYSTR,               
     +                  DXSTP,DYSTP,NSX,NSY,SXSTR,SYSTR,SXSTP,SYSTP,C,          
     +                  IDEG,FLGSB,FLGSU)                                       
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++:           
C.PURPOSE: Create new image frames with the background subtracted image and/or  
C          the polinomial surface ,testing option flags FLGSB and FLGSU:        
C.INPUT:   FRAMEA : INPUT_A is the input image                                  
C          FLGSB  : flag = .TRUE. if you want backgrond subtraction             
C          FLGSU  : flag = .TRUE. if you want a background surface image        
C.OUTPUT:  FRAMEC : OUTPUT_C is the background subtracted image                 
C          FRAMED : OUTPUT_D is the polinomial surface                          
C   ------------------------------------------------------------------          
      IMPLICIT         NONE
      REAL             FRAMEA(1)                        
      REAL             FRAMEC(1)                        
      REAL             FRAMED(1)                        
      INTEGER          NIX
      INTEGER          NIY
      DOUBLE PRECISION DXSTR
      DOUBLE PRECISION DYSTR
      DOUBLE PRECISION DXSTP
      DOUBLE PRECISION DYSTP
      INTEGER          NSX
      INTEGER          NSY
      REAL             SXSTR
      REAL             SYSTR
      REAL             SXSTP
      REAL             SYSTP
      DOUBLE PRECISION C(21)                                        
      INTEGER          IDEG
      LOGICAL          FLGSB                                              
      LOGICAL          FLGSU                                              
C
      DOUBLE PRECISION CC(6)                                        
      DOUBLE PRECISION XD,YD                                        
      INTEGER          I, IF, IY, IX
      INTEGER          J
      REAL             DCX, DCY
      REAL             X1
      REAL             XSRV
      REAL             Y1
      REAL             YSRV
C
      REAL             POLIN

C                                                                               
C *** initialize variables                                                      
C                                                                               
      DCX    = (NSX-1.)/2.                                                      
      DCY    = (NSY-1.)/2.                                                      
C                                                                               
C *** fill image(S)                                                             
C                                                                               
      IF     = 1                                                                
      DO 20 J = 1,NIY                                                           
         IY     = J - 1                                                         
         Y1     = DYSTR + DYSTP*FLOAT(IY)                                       
C                                                                               
C *** find pixel coord. in temporary array used by fitting routine              
C                                                                               
         YSRV   = (Y1-SYSTR)/SYSTP                                              
         YD     = DCY - YSRV                                                    
C                                                                               
C *** initialize calculation of coefficients                                    
C                                                                               
         CALL COEFY(YD,C,CC,IDEG)                                               
C                                                                               
         DO 10 I = IF,IF + NIX - 1                                              
            IX     = I - IF                                                     
            X1     = DXSTR + DXSTP*FLOAT(IX)                                    
            XSRV   = (X1-SXSTR)/SXSTP                                           
            XD     = XSRV - DCX                                                 
            IF (FLGSB) THEN                                                     
               FRAMEC(I) = FRAMEA(I) - POLIN(XD,CC,IDEG)                        
               IF (FLGSU) FRAMED(I) = POLIN(XD,CC,IDEG)                         
            ELSE                                                                
               IF (FLGSU) FRAMED(I) = POLIN(XD,CC,IDEG)                         
            END IF                                                              
   10    CONTINUE                                                               
C                                                                               
         IF     = IF + NIX                                                      
   20 CONTINUE                                                                  
C                                                                               
      RETURN                                                                    
      END                                                                       

C @(#)modpsf.for	19.1 (ES0-DMD) 02/25/03 13:25:36
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.INPUT/OUTPUT
C  Input parameters
C  RARR      real*4 array         real parameters
C  MAXSUB    integer*4            maximal subarray half-edge
C  IPSF      integer*4            pointers to FPSF
C  LPXL      integer*4            extend of 2-d point spread function
C  LSBP      integer*4            number of subpixels
C  Output parameters
C  FPSF      real*4 array         2-d point spread function
C-----------------------------------------------------------------------
      SUBROUTINE MODPSF(RARR, FPSF, NPRF, IPSF, LPXL, LSBP)
C
      IMPLICIT    NONE
      INCLUDE     'MID_REL_INCL:INVENT.INC/NOLIST'
C
      REAL      RARR(64)
      REAL      FPSF(1)
      INTEGER   NPRF
      INTEGER   IPSF(0:NPRF)
      INTEGER   LPXL
      INTEGER   LSBP
C
      INTEGER   I, II
      INTEGER   IT1, IT2, IT3, IT4
      INTEGER   IDM, IDN, IDK1, IDK2, INZ
      INTEGER   IOFN, IOF4, IOF5, IOF42, IOF6
      INTEGER   K
      INTEGER   J
      INTEGER   L, LL
      INTEGER   MPXL, MPXL2
      INTEGER   MSBP, MSBP2
      INTEGER   NN, NI
      INTEGER   NOSP1
      REAL      AMEAN	
      REAL      GRI, GRJ
      REAL      SIGMA
      REAL      TEMP
      REAL      X
C
C ***
      MPXL  = 2 * LPXL + 1
      MSBP  = 2 * LSBP + 1
      MPXL2 = MPXL * MPXL
      MSBP2 = MSBP * MSBP
      IDM   = MPXL2 * MSBP2
      IOF4  = 3 * IDM + 1
      IOF5  = IOF4 + IDM
      IOF6  = IOF5 + IDM
      IDN   = 2 * IDM
C
C *** Calculate corrections to point spread function.
      LL = ( MPXL * MSBP ) / 2
      CALL CORPSF( LPXL , LSBP , LL , FPSF(IOF6) , IPSF(NOSP+1) ,
     &             RARR(39) , FPSF(IOF4) , FPSF(IOF5) )
C
C *** Check data accuracy.
      CALL MEAN( FPSF(IOF4) , IDM , AMEAN , SIGMA )
C
C *** Correct for zeroes in data.
      IDK1 = NOSP + 1
      IDK2 = NOSP + MSBP2
      INZ = 0
      DO 10 II = IDK1 , IDK2
          IF ( IPSF(II) .GT. 0 ) THEN
              INZ = INZ + 1
          ENDIF
   10 CONTINUE
      IF ( INZ .GT. 0 ) THEN
          SIGMA = SIGMA * SQRT( FLOAT(IDM-1) / FLOAT(INZ*MPXL2-1) )
      ELSE
          RETURN
      ENDIF
C
C *** Count non zero values of corrections.
      NN = 0
      IOF42 = IOF5 - 1
      DO 80 NI = IOF4 , IOF42
          IF ( FPSF(NI) .NE. 0.0 ) THEN
              NN = NN + 1
          ENDIF
   80 CONTINUE
C
      IF ( NN .LT. 7 ) RETURN
C
C     CALL MEAN( FPSF(IOF4) , IDM , AMEAN , SIGMA )
C
C     SIGMA = SIGMA * SQRT( FLOAT(IDM-1) / FLOAT(NN-1) )
C
C *** Smooth corrections to point spread function
C *** and calculate corrections to gradients.
C
      IF ( INZ .LT. 1 .OR. INZ*MPXL2 .LT. 9 ) RETURN
      DO 20 L = -LSBP , LSBP
          IT1 = (L+LSBP) * MSBP + LSBP
          DO 30 K = -LSBP , LSBP
              IT2 = ( IT1 + K ) * MPXL2
              DO 40 J = -LPXL , LPXL
                  IT3 = IT2 + (J+LPXL) * MPXL + LPXL + 1
                  DO 50 I = -LPXL , LPXL
                      IT4 = IT3 + I
                      CALL SMTPSF( LPXL, LSBP, LL, FPSF(IOF4),
     &                             FPSF(IOF5), IPSF(NOSP+1), INZ,
     &                             NN, SIGMA, I, J, K, L, X, GRI, GRJ)
                      FPSF(IT4) = FPSF(IT4) + X
                      TEMP = FPSF(IT4+IDM) + GRI
                      IF ( TEMP*FLOAT(I) .GT. 0.0 ) THEN
                          TEMP = 0.0
                      ENDIF
                      FPSF(IT4+IDM) = TEMP
                      TEMP = FPSF(IT4+IDN) + GRJ
                      IF ( TEMP*FLOAT(J) .GT. 0.0 ) THEN
                          TEMP = 0.0
                      ENDIF
                      FPSF(IT4+IDN) = TEMP
   50             CONTINUE
   40         CONTINUE
   30     CONTINUE
   20 CONTINUE
C
C *** Adjust one- and two-dimensional point spread functions.
      CALL ADJPSF( RARR , LPXL , LSBP , FPSF )
C
      IOFN = IOF6 + IDM * (NOSP+2) - 1
      DO 60 II = IOF6 , IOFN
          FPSF(II) = 0.0
   60 CONTINUE
      NOSP1 = NOSP+1
      DO 70 II = NOSP1 , NPRF
          IPSF(II) = 0
   70 CONTINUE
C
      RETURN
      END

C @(#)tderror.for	19.1 (ES0-DMD) 02/25/03 14:11:17
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:27 - 11 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C  900219  KB, throw out SX calls...
C  901008  MP, add call to GENLGN....
C
C.IDENTIFICATION        TDERROR.FOR
C.KEYWORDS           TABLE, APPLICATIONS
C.ENVIRONMENT  MIDAS
C.PURPOSE
C              Display error messages for different user levels
C
C------------------------------------------------------------------
      SUBROUTINE TDERRR(ERROR,MSG,STATUS)
      IMPLICIT NONE
      INTEGER ERROR      !   IN  : ERROR CODE
      CHARACTER*(*) MSG  !   IN  : MESSAGE
      INTEGER STATUS     !   OUT : STATUS
C
      INTEGER IERR,STAT,IAV,ICODE,KUN,KNUL
      CHARACTER*3 ERRLAB
      CHARACTER*60 ERRFIL,FILNAM*80
      CHARACTER*8 KEY
      CHARACTER*80 MESS
C
      ERRFIL = 'MID_INCLUDE:APP1ERR.INC'//' '
      IF (ERROR.GE.0) THEN
          MESS = 'TBL_'//MSG
          CALL STETER(ERROR,MESS)
      ELSE
          IERR   = -ERROR
C
C ... convert error code into ASCII
C
          WRITE (ERRLAB,9000) IERR
C
C ... branch according to error level
C
          CALL GENLGN(ERRFIL,FILNAM,80) 
          CALL STKRDI('ERROR',2,1,IAV,ICODE,KUN,KNUL,STAT)
          GO TO (20,10,30),ICODE + 1
C
C  novice user (= 1)
   10     KEY    = 'NOVICE.'
          CALL DISFIL(FILNAM,KEY(1:7),ERRLAB,STAT)
          GO TO 40
C
C  average user (= 0, default)
   20     KEY    = 'USER.'
          CALL DISFIL(FILNAM,KEY(1:5),ERRLAB,STAT)
          GO TO 40
C
C  expert user (= 2)
   30     KEY    = 'EXPERT.'
          CALL DISFIL(FILNAM,KEY(1:7),ERRLAB,STAT)
      END IF

   40 RETURN
C
 9000 FORMAT (I3.3)
      END

C @(#)vfl.for	19.1 (ES0-DMD) 02/25/03 13:30:49
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE VFL(VAL,STRING)                                                
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++   
C.PURPOSE:  Internal file formatted write of VAL into STRING                    
C           VAL is checked for over- and underflow before writing               
C ------------------------------------------------------------------------------
      IMPLICIT      NONE
C
      REAL          VAL
      CHARACTER*(*) STRING                                                      
C                                                                               
C *** begin code                                                                
C                                                                               
      IF ((VAL.GE..001.AND.VAL.LE.9999.999) .OR.                                
     +   (VAL.LE.-.001.AND.VAL.GE.-999.999)) THEN                               
         WRITE (STRING,'(F8.3)') VAL                                            
      ELSE                                                                      
         WRITE (STRING,'('' ...... '')')                                        
      END IF                                                                    
C                                                                               
      RETURN                                                                    
      END                                                                       

C @(#)gd8i1.for	19.1 (ES0-DMD) 02/25/03 13:55:08
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
	SUBROUTINE 
     +  GD8037(DISPLAY,INTATY,INTAID,OBJTY,OBJID,INTAOP,EXTRIG,IDST)
C	
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine IIIENI		version 1.20	880929
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  Image Display, cursor boards
C
C.PURPOSE
C  fulfill the requirements as described in the IDI document
C
C.ALGORITHM
C  use DeAnza level-0 software
C
C.INPUT/OUTPUT
C  call as IIIENI(DISPLAY,INTATY,INTAID,OBJTY,OBJID,INTAOP,EXTRIG,IDST)
C
C  input par:
C  DISPLAY:	I*4		Display Unit
C  INTATY:	I*4	        Interactor type 
C  INTAID:	I*4	        Interactor identifier
C  OBJTY:	I*4		Object type
C  OBJID:	I*4		Object identifier
C  INTAOP:	I*4		interactive operation
C  EXTRIG:	I*4		exit trigger number
C
C  output par:
C  IDST:	I*4		return status
C	
C--------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,INTATY,INTAID,OBJTY,OBJID
	INTEGER*4	INTAOP,EXTRIG,IDST
	INTEGER*4	ITY,N,TRGLIM
C		
	INTEGER*2	UNIT,ENTER,CONTROL
	INTEGER*2	LPR
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
C	
	EXTERNAL	LPR
C	
        DATA   TRGLIM  /10/
C 
C  get unit
	UNIT = DISPLAY
	IDST = 0
C 
        IF (INTAOP.GT.1) RETURN
C	
C  test input for interaction (we do not support everything yet...)
C  and determine internal number ITY
C	
	IF (INTATY.EQ.5) THEN			!Trigger handling
	   IF (OBJTY.EQ.0) THEN			!no visible effect
	      ITY = 5 + INTAID                  !EXIT or ENTER button/trigger
	   ELSE
	      IDST = 403
	      RETURN
	   ENDIF
C 
	ELSE IF (INTATY.EQ.0) THEN		!Locator handling
	   IF (OBJTY.EQ.1) THEN			!Cursor
	      ITY = 1 + OBJID			!curor #0 or cursor #1
	   ELSE IF (OBJTY.EQ.0) THEN		!no visible effect
	      ITY = 4                           !just use locator (joystick/trackball)
	   ELSE IF (OBJTY.EQ.4) THEN		!ROI (= 2 cursors)
	      ITY = 3
	   ELSE
	      IDST = 403			!wrong object type
	      RETURN
	   ENDIF
C 
	ELSE
	   IDST = 401				!wrong interaction type
	   RETURN
	ENDIF
C 
C  we do not use interrupts...
	CALL IP8QW(LPR,UNIT,DZIOSB,,,1,2,0,1)		!set CL bit (bit 0)
C 
        DO N=1,TRGLIM
           IF (DZTRIG(1,N).LE.0) THEN
              DZTRIG(1,N) = ITY
	      DZTRIG(2,N) = INTAOP		
              RETURN
	   ENDIF
        ENDDO
C	
C  let's get the hell out of here...
	RETURN
	END

	SUBROUTINE GD8038(DISPLAY,TRIGSTAT,IDST)
C	
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine IIIEIW		version 1.20	880915
C  K. Banse                  	ESO - Garching
C  1.30	    890104		1.40     900327
C
C.KEYWORDS
C  Image Display, event flags, cursor boards
C
C.PURPOSE
C  fulfill the requirements as described in the IDI document 
C
C.ALGORITHM
C  use DeAnza level-0 software
C
C.INPUT/OUTPUT
C  call as IIIEIW(DISPLAY,TRIGSTAT,IDST)
C
C  input par:
C  DISPLAY:	I*4		Display Unit
C
C  output par:
C  TRIGSTAT:	I*4 array	trigger status array, each element = 0 or 1
C  IDST:	I*4		return status
C	
C.VERSIONS
C  1.30		provide also for trigger status for EXECUTE button,
C		even though only used in X Windows
C  1.40		increase size of DZTRIG and TRIGSTAT to 10
C 
C--------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,TRIGSTAT(1),IDST
	INTEGER*4	ISS,KK(10),PUSH,N,TRGLIM
C
	INTEGER*2	UNIT
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
	INCLUDE	'MID_INCLUDE:IDIDEV.INC'
C	
        DATA   TRGLIM  /10/                 !KK needs same dimension...
C	
	UNIT = DISPLAY
	IDST = 0
	DO N=1,TRGLIM
           TRIGSTAT(N) = 0
        ENDDO
C 
500	N = -1
	CALL DAZWAI(N)		  !force synchro loop (delay from DAZHOLD(12)
C 
C  main loop over all TRGLIM (currently = 10) slots
C 
	DO 1000 N=1,TRGLIM
	   KK(N) = 0
	   IF (DZTRIG(1,N).LE.0) GOTO 1000
C 
C  get cursor status + info about ENTER button
C 
	   IF (QJOYFL.EQ.0) THEN			!we have a joystick
	      IF (DZTRIG(1,1).EQ.1) THEN
	         ISS = "000400				!cursor no. 0
	      ELSE IF (DZTRIG(1,1).EQ.2) THEN
	         ISS = "001000				!cursor no. 1
	      ELSE
	         ISS = "001400				!cursor no. 0 or 1
	      ENDIF
	      CALL JOYPSH(UNIT,PUSH,ISS)
C 
	   ELSE						!we have a trackball
	      IF (DZTRIG(1,1).EQ.1) THEN
	         ISS = 0				!cursor no. 0
	      ELSE IF (DZTRIG(1,1).EQ.2) THEN
	         ISS = 1				!cursor no. 1
	      ELSE
	         ISS = 2				!cursor no. 0 or 1
	      ENDIF
	      CALL TRKPSH(UNIT,PUSH,ISS)
	   ENDIF
C	
C  find out, if ENTER pressed
C	
	IF (PUSH.EQ.1) THEN
	   IF (ISS.EQ.0) THEN			!cursor(s) off => this means EXIT
	      TRIGSTAT(1) = 1
	   ELSE
	      TRIGSTAT(2) = 1	
	   ENDIF
	   KK(N) = 1				!idicate reason to leave loop...
	ELSE
           IF (DZTRIG(2,N).EQ.0) KK(N) = 1	!for inter. op. = 0, we leave anyway
	ENDIF
C 
1000	ENDDO					!end of main loop
C 
C	
C  check, if something came in, so we can leave ...
C	
	DO N=1,TRGLIM
	   IF (KK(N).NE.0) RETURN
	ENDDO
C 
	GOTO 500				!loop more
C 
	END

	SUBROUTINE GD8039(DISPLAY,IDST)
C	
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine IIISTI		version 1.20	880915
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  Image Display
C
C.PURPOSE
C  fulfill the requirements as described in the IDI document 
C
C.ALGORITHM
C  use DeAnza level-0 software
C
C.INPUT/OUTPUT
C  call as IIISTI(DISPLAY,IDST)
C
C  input par:
C  DISPLAY:	I*4		Display Unit
C
C  output par:
C  IDST:	I*4		return status
C	
C.VERSIONS
C	
C--------------------------------------------------
C
	IMPLICIT NONE
C 
	INTEGER*4	DISPLAY,IDST
	INTEGER*4	N,TRGLIM
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
C 
        DATA  TRGLIM  /10/
C 
	IDST = 0
C	
	DO N=1,TRGLIM
	   DZTRIG(1,N) = 0
	ENDDO
C	
	RETURN
	END

	SUBROUTINE GD8040(DISPLAY,INTATY,INTAID,DEVDSC,LL,IDST)
C	
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine IIIQID		version 1.00	880205
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  Image Display
C
C.PURPOSE
C  fulfill the requirements as described in the IDI document 
C
C.ALGORITHM
C  use DeAnza level-0 software
C
C.INPUT/OUTPUT
C  call as IIIQID(DISPLAY,INTATY,INTAID,DEVDSC,LL,IDST)
C
C  input par:
C  DISPLAY:	I*4		Display Unit
C
C  output par:
C  IDST:	I*4		return status
C	
C.VERSIONS
C	
C--------------------------------------------------
C
	IMPLICIT NONE
C 
	INTEGER*4	DISPLAY,INTATY,INTAID,LL,IDST
	INTEGER*4	KK
C	
	CHARACTER*(*)	DEVDSC
C 
	INCLUDE	'MID_INCLUDE:IDIDEV.INC'
C	
	IF (INTATY.EQ.0) GOTO 1000
	IF (INTATY.EQ.5) GOTO 2000
C 
	IDST = 404
	RETURN
C 
C  we return info about the locator
1000	IF (QJOYFL.EQ.0) THEN
	   DEVDSC(1:) = 'Joystick '
	   LL = 8
	ELSE
	   DEVDSC(1:) = 'Trackball '
	   LL = 9
	ENDIF
	GOTO 9000
C 
C  we return info about the ENTER button at the locator
2000	IF (QJOYFL.EQ.0) THEN
	   DEVDSC(1:) = 'ENTER button (= lowest b.) '
	   LL = 26
	ELSE
	   DEVDSC(1:) = 'ENTER button (= rightmost b.) '
	   LL = 29
	ENDIF
	GOTO 9000
C 
9000	KK = LEN(DEVDSC)
	IF (KK.LT.LL) LL = KK
	IDST = 0
C 
	RETURN
	END

C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.PURPOSE:
C  Take 3 bdf-files and create a PPM raster file.
C
C.VERSION: 1.0          MIDAS-VERSION: 94NOV portable
C
C.LANGUAGE: F77+ESOext+...
C
C.AUTHOR: HJRoeser
C
C.IDENTIFICATION: rgbhjr.for
C
C.KEYWORDS:
C  ???
C
C.ALGORITHM:
C  ???
C
C.INPUT/OUTPUT:
C
C  The following keywords are used:
C
C
C.REVISIONS
C
C               none thus far
C
C.COPYRIGHT: Copyright (c)        1995  MPIA Heidelberg
C                                       all rights reserved
C
C.VERSION
C 090130	integrated in MIDAS 09SEP, KB
C 090210	last modif
C 
C-----------------------------------------------------------------------
C
C
C
      IMPLICIT NONE
C
      INTEGER    STATUS, EX_STAT, ACT_VAL,
     +               naxis1, naxis2, naxis3,
     +               npix1(2), npix2(2), npix3(2),
     +               ncol, nrow, length, lo, n_ima, no_f1, no_f2, no_f3
C
      INTEGER KNULL, KUNIT(1), DNULL, DUNIT(1)
C
C  define pointers for MIDAS
      integer*8 pntr_in,  pntr_in2,  pntr_in3
C
      CHARACTER*18    DATE
      character*48    cunit1, cunit2, cunit3
      character*72    ident1, ident2, ident3
      CHARACTER*80    MESSAGE, frame1, frame2, frame3, output
      CHARACTER*8     KEYWORD
C
      REAL            cutsr(2), cutsg(2), cutsb(2)
C
      LOGICAL         LOG_MODE, NO_R, NO_G, NO_B
C
      DOUBLE PRECISION
     +  start1(2), start2(2), start3(2), step1(2), step2(2), step3(2)
C
      INTEGER      MADRID(1)
C
      INCLUDE  'MID_INCLUDE:ST_DEF.INC'
      COMMON    /VMR/ MADRID
C
      DATA  KNULL, KUNIT, DNULL, DUNIT /4*0/
      INCLUDE  'MID_INCLUDE:ST_DAT.INC'
C
C  get into MIDAS
      CALL STSPRO('RGBHJR')
C
      CALL STKRDC('P1',1,1,80,ACT_VAL,output, KUNIT, KNULL, STATUS)
      LO = INDEX(OUTPUT,' ') - 1		!was: lo = length(output)
      n_ima = 0
      CALL STKRDC('P3',1,1,80,ACT_VAL,frame1, KUNIT, KNULL, STATUS)
      IF (frame1(1:4) .eq. 'NULL') then
           no_r = .true.
      else
           no_r = .false.
           n_ima = n_ima + 1
      endif
      CALL STKRDC('P4',1,1,80,ACT_VAL,frame2, KUNIT, KNULL, STATUS)
      IF (frame2(1:4) .eq. 'NULL') then
           no_g = .true.
      else
           no_g = .false.
           n_ima = n_ima + 1
      endif
      CALL STKRDC('P5', 1, 1, 80, ACT_VAL, frame3, KUNIT, KNULL, STATUS)
      IF (frame3(1:4) .eq. 'NULL') then
           no_b = .true.
      else
           no_b = .false.
           n_ima = n_ima + 1
      endif
      CALL STKRDR('cutr', 1, 2, ACT_VAL, cutsr, KUNIT, KNULL, STATUS)
      CALL STKRDR('cutg', 1, 2, ACT_VAL, cutsg, KUNIT, KNULL, STATUS)
      CALL STKRDR('cutb', 1, 2, ACT_VAL, cutsb, KUNIT, KNULL, STATUS)
      CALL STKRDC('CTRL_KEY',1,1,4,ACT_VAL,KEYWORD,KUNIT,KNULL,STATUS)
      if ((keyword(1:1) .eq. 'L') .or.
     +    (keyword(1:1) .eq. 'l'))  then
           log_mode = .true.			!LOG scaling
      else
           log_mode = .false.			!RAMP scaling
      endif
C 
      IF (N_IMA .LT. 2) THEN
         MESSAGE = 'we need at least 2 colour components '
         STATUS = 99
         GOTO 9999
      ENDIF
         
C 
      if (.not. no_r) then
         call stiget (frame1, d_r4_format, f_i_mode, f_ima_type, 2,
     +        naxis1, npix1, start1, step1, ident1, cunit1, pntr_in, 
     +        no_f1, status)
      endif
      if (.not. no_g) then
         call stiget (frame2, d_r4_format, f_i_mode, f_ima_type , 2,
     +        naxis2, npix2, start2, step2, ident2, cunit2, pntr_in2, 
     +        no_f2, status)
      endif
      if (.not. no_b) then
         call stiget (frame3, d_r4_format, f_i_mode, f_ima_type , 2,
     +        naxis3, npix3, start3, step3, ident3, cunit3, pntr_in3, 
     +        no_f3, status)
      endif
                     
      if (n_ima .eq. 3)  then
         if (npix1(1) .ne. npix2(1) .or. npix1(1) .ne. npix3(1) .or.
     +       npix1(2) .ne. npix2(2) .or. npix1(2) .ne. npix3(2))  then
            message = 'Unequal dimensions!'
            status = 100
            go to 9999
         endif
         ncol    = npix1(1)
         nrow    = npix1(2)
C 
      else				!only 2 components
         if (no_r)  then
            if (npix2(1) .ne. npix3(1) .or.
     +          npix2(2) .ne. npix3(2)      )  then
               message = 'Unequal dimensions!'
               status = 101
               go to 9999
            endif
            cutsr(1) = (cutsg(1) + cutsb(1)) / 2.
            cutsr(2) = (cutsg(2) + cutsb(2)) / 2.
            ncol    = npix2(1)
            nrow    = npix2(2)
         endif
         if (no_g)  then
            if (npix1(1) .ne. npix3(1) .or.
     +          npix1(2) .ne. npix3(2)      )  then
               message = 'Unequal dimensions!'
               status = 102
               go to 9999
            endif
            cutsg(1) = (cutsr(1) + cutsb(1)) / 2.
            cutsg(2) = (cutsr(2) + cutsb(2)) / 2.
            ncol    = npix1(1)
            nrow    = npix1(2)
         endif
         if (no_b)  then
            if (npix1(1) .ne. npix2(1) .or.
     +          npix1(2) .ne. npix2(2)      )  then
               message = 'Unequal dimensions!'
               status = 103
               go to 9999
            endif
            cutsb(1) = (cutsg(1) + cutsr(1)) / 2.
            cutsb(2) = (cutsg(2) + cutsr(2)) / 2.
            ncol    = npix1(1)
            nrow    = npix1(2)
         endif
      endif


      status = 110
      message = 'Cannot open output file!'
      open (unit=1, file=output(1:lo)//'.ppm', iostat=status, 
     +      status='unknown', err=9999)
      write (1, '("P3"/I6,I6/"255")') ncol, nrow
C 
      call do_it(madrid(pntr_in),madrid(pntr_in2),madrid(pntr_in3),
     +   cutsr,cutsg,cutsb,ncol,nrow,log_mode,no_r,no_g,no_b)

9999  EX_STAT = STATUS
      if (ex_stat .ne. 0)  then
         call sttput (message, status)
         call sttput ('RGB not successful!', status)
      endif
      call stkwri ('outputi', ex_stat, 1, 1, kunit, status)
      call stsepi
      END

      subroutine do_it (redf, greenf, bluef, cutsr, cutsg, cutsb, 
     +                    ncol, nrow, log_mode, no_r, no_g, no_b)
C
      implicit none
C
      integer max_x
      parameter  (max_x = 3 * 8600)		! was:  3 * max_dimx
      integer ncol, nrow, i, j, l, k

      integer*2 buffer(max_x), blue, green, red

      real redf(ncol,nrow), greenf(ncol,nrow), bluef(ncol,nrow),
     +       cutsr(2),cutsg(2),cutsb(2),cutsrl(2),cutsgl(2),cutsbl(2),
     +       help, redr, greenr, bluer, diffr, diffg, diffb

      logical   log_mode, no_r, no_g, no_b
C 
C 
      if (log_mode)  then
           diffr = log10(cutsr(2) - cutsr(1))
           diffg = log10(cutsg(2) - cutsg(1))
           diffb = log10(cutsb(2) - cutsb(1))
      else
           diffr = cutsr(2) - cutsr(1)
           diffg = cutsg(2) - cutsg(1)
           diffb = cutsb(2) - cutsb(1)
      endif

      do j = nrow, 1, -1
           do i = 1, ncol
              if (.not. no_r)  then
                 redr = redf(i,j)
              else
                 redr = (bluef(i,j)+greenf(i,j))/2.
              endif
              redr = min(redr, cutsr(2))
              redr = max(redr, cutsr(1))
              help = max(1.,redr - cutsr(1))
              if (log_mode)  help = log10(help)
              redr = 255. * help / diffr
              red = nint(redr)

              if (.not. no_g)  then
                 greenr = greenf(i,j)
              else
                 greenr = (redf(i,j)+bluef(i,j))/2.
              endif
              greenr = min(greenr, cutsg(2))
              greenr = max(greenr, cutsg(1))
              help = max(1.,greenr - cutsg(1))
              if (log_mode)  help = log10(help)
              greenr = 255. * help / diffg
              green = nint(greenr)

              if (.not. no_b) then
                 bluer = bluef(i,j)
              else
                 bluer = (redf(i,j)+greenf(i,j))/2.
              endif
              bluer = min(bluer, cutsb(2))
              bluer = max(bluer, cutsb(1))
              help = max(1.,bluer - cutsb(1))
              if (log_mode)  help = log10(help)
              bluer = 255. * help / diffb
              blue = nint(bluer)
              
              k = 3*(i-1)
              buffer(k+1) = red
              buffer(k+2) = green
              buffer(k+3) = blue
           enddo    ! i = columns
           
           write (1, '(5(3I4," "))') (buffer(l), l=1,3*ncol)

      enddo       !  j =rows
C
      return
      end

C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION        ISTHIG.FOR
C.AUTHOR:               J.D.PONZ  ESA-VILSPA        
C.KEYWORDS              IUE, GO FORMAT, HIGH DISPERSION SPECTRUM
C.ENVIRONMENT           MIDAS, IUE context
C.PURPOSE
C \begin{TeX}
C   Reads High dispersion MEHI file from tape.
C   The routine performs the following functions (routine names in brackets):
C   \begin{enumerate}
C   \item Handles the file header (ISTFHD)
C   \item Creates the MIDAS table file on disk (TBTINI)
C   \item Creates the table columns (TBCINI)
C   \item Iterates on orders to 
C      \begin{itemize}
C         \item Read wavelength record (ISTREA)
C         \item Decode wavelengths
C         \item Write the wavelengths into the table (TBEWRR)
C         \item Read epsilon record (ISTREA)
C         \item Decode epsilon
C         \item Write the epsilon values into the table (TBEWRR)
C         \item Read/decode/write the extracted spectra
C               (Gross, background, net, 
C               ripple-corrected net and absolute flux)
C         \item Write the spectral order number
C       \end{itemize}
C    \item Writes IUE specific descriptors (ISTDES)
C    \item Closes the table file (TBTCLO)
C \end{enumerate}
C \end{TeX}
C   
C.LANGUAGE:             F77 
C.COMMENTS
C \begin{TeX}
C   The following extensions are used:
C   \begin{itemize}
C     \item IMPLICIT NONE
C     \item INCLUDE statement
C     \item Long variable names
C     \item Underscore character
C   \end{itemize}
C \end{TeX}
C.VERSION: 1.0  9 Jul 1991. Initial coding.
C.VERSION: 1.1  27 Nov 1991. Include variable number of records per group.
C.VERSION: 1.2  29 Nov 1991. Warning when Calibrated spectrum not present.
C.VERSION: 1.3  14 APR 1992. Remove VMS extensions
C------------------------------------------------------------------
      SUBROUTINE ISTHIG(CHANL,BUFF,FILE,DSKFMT,K,KORD,NRECO,NBYTE,
     .                  DSPFLG,STATUS)
C
      IMPLICIT NONE
      INTEGER       CHANL             ! IN: tape channel number
      CHARACTER*(*) BUFF              ! IN: buffer with the ascii header
      CHARACTER*(*) FILE              ! IN: file name
      INTEGER       DSKFMT            ! IN: file format (-1 no file)
      INTEGER       K                 ! IN: number of orders requested
      INTEGER       KORD(1)           ! IN: actual orders requested
      INTEGER       NRECO             ! IN: number of records
      INTEGER       NBYTE             ! IN: number of bytes per record
      INTEGER       DSPFLG            ! IN: display flag
      INTEGER       STATUS            ! OUT: status
C
      INTEGER I, LEN, NROW, TID, IROW, IVAL, IVALUE
      INTEGER JG, KG, JB, KB, JN, KN, JF, KF, IC, JR, KR
      INTEGER NORD, IPREV, JORDER, M, INUM, LAMB, IACT
      INTEGER NRECPO
      INTEGER    BBUFF(1024), BZERO(1024)
      INTEGER    IZERO(1024)
      INTEGER    IBUFF(1024), LAMB0(100), IORD(100), NVAL(100)
      REAL    VALUE, SCG, SCB, SCN, SCR, SCF
      CHARACTER*16 LLABEL,ELABEL,GLABEL,BLABEL,NLABEL,FLABEL
      CHARACTER*16 RLABEL, RUNIT, OLABEL, OUNIT
      CHARACTER*16 LUNIT,EUNIT,GUNIT,BUNIT,NUNIT,FUNIT
      CHARACTER*8  LFORM,EFORM,GFORM,BFORM,NFORM,FFORM,RFORM
      CHARACTER*8  OFORM
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      EQUIVALENCE (BBUFF, IBUFF)
      EQUIVALENCE (BZERO, IZERO)
      EQUIVALENCE (IZERO(103), LAMB0(1))
      EQUIVALENCE (IZERO(203), IORD(1))
      EQUIVALENCE (IZERO(303), NVAL(1))
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      DATA LLABEL/'WAVELENGTH'/,ELABEL/'EPSILON'/
      DATA GLABEL/'GROSS'/,     BLABEL/'BACKGROUND'/
      DATA NLABEL/'NET'/,       RLABEL/'RNET'/
      DATA OLABEL/'ORDER'/, FLABEL/'FLUX'/
      DATA LUNIT/'ANGSTROM'/, EUNIT/'UNITLESS'/
      DATA GUNIT/'FN'/,       BUNIT/'FN'/
      DATA NUNIT/'FN'/,       RUNIT/'FN'/
      DATA FUNIT/'ERGS/CM2/A'/, OUNIT/'UNITLESS'/
      DATA LFORM/'F8.3'/, EFORM/'I5'/, OFORM/'I4'/
      DATA GFORM/'E12.4'/
      DATA BFORM/'E12.4'/
      DATA NFORM/'E12.4'/
      DATA RFORM/'E12.4'/
      DATA FFORM/'E12.4'/
C
      STATUS = 0
C
C ... decode full header, print it and put info in common area
C
      CALL ISTFHD(CHANL,BUFF,DSPFLG,STATUS)
      IF (STATUS.NE.0) RETURN
      IF (DSKFMT.LT.0) RETURN        ! only displays header
C
C ... reads record zero
C
      CALL ISTRHW(CHANL,BZERO,NBYTE,LEN,STATUS)
      IF (NBYTE.NE.LEN .OR. STATUS.NE.0) RETURN
C
C ... extracts useful info
C
      NORD   = IZERO(5)
      NRECPO = IZERO(8)
      JG   = IZERO(23)
      KG   = IZERO(24)
      JB   = IZERO(27)
      KB   = IZERO(28)
      JN   = IZERO(31)
      KN   = IZERO(32)
      JR   = IZERO(35)
      KR   = IZERO(36)
      JF   = IZERO(67)
      KF   = IZERO(68)  
      SCG  = JG/(2.**KG)
      SCB  = JB/(2.**KB)
      SCN  = JN/(2.**KN)
      SCR  = JR/(2.**KR)
      SCF  = JF/(2.**KF)
      IF (NRECPO.LT.6.OR.NRECPO.GT.7) THEN
          STATUS = 1
          RETURN
      ELSE
          IF (NRECPO.EQ.6) THEN
            CALL STTPUT('*** Calibrated flux not present ***',STATUS)
            CALL STTPUT('*** Output flux set to zero ***',STATUS)
          ENDIF
      ENDIF
C
C ... finds orders and number of samples
C
      NROW = 0
      DO 6 I = 1, NORD
         NROW = NROW + NVAL(I)   ! CHECK ORDER SELECTION
 6    CONTINUE
C
C ... create the table file and columns
C
      CALL TBTINI(FILE,F_TRANS,F_O_MODE,10,NROW,TID,STATUS)
      IF (STATUS.NE.0) RETURN
      CALL TBCINI(TID,D_R4_FORMAT,1,LFORM,LUNIT,LLABEL,IC,STATUS)
      CALL TBCINI(TID,D_I4_FORMAT,1,EFORM,EUNIT,ELABEL,IC,STATUS)
      CALL TBCINI(TID,D_R4_FORMAT,1,GFORM,GUNIT,GLABEL,IC,STATUS)
      CALL TBCINI(TID,D_R4_FORMAT,1,BFORM,BUNIT,BLABEL,IC,STATUS)
      CALL TBCINI(TID,D_R4_FORMAT,1,NFORM,NUNIT,NLABEL,IC,STATUS)
      CALL TBCINI(TID,D_R4_FORMAT,1,RFORM,RUNIT,RLABEL,IC,STATUS)
      CALL TBCINI(TID,D_R4_FORMAT,1,FFORM,FUNIT,FLABEL,IC,STATUS)
      CALL TBCINI(TID,D_I4_FORMAT,1,OFORM,OUNIT,OLABEL,IC,STATUS)
C
C ... iteration on orders
C
      IPREV = 1
      DO 100 JORDER = 1, NORD
         IROW = IPREV
         M    = IORD(JORDER)
         INUM = NVAL(JORDER)
         LAMB = LAMB0(JORDER)
C
C ... scaled wavelengths
C
         CALL ISTRHW(CHANL,BBUFF,NBYTE,LEN,STATUS)
         IF (NBYTE.NE.LEN .OR. STATUS.NE.0) RETURN
         IROW = IPREV
         IVAL = 3
         IACT = 1
         IC   = 1
         DO 10 I = 5, NBYTE, 2
            VALUE      = LAMB+0.002*IBUFF(IVAL)    
            CALL TBEWRR(TID,IROW,IC,VALUE,STATUS)
            IVAL = IVAL + 1
            IROW = IROW + 1
            IACT = IACT + 1
            IF (IACT.GT.INUM) GOTO 15
 10      CONTINUE
C
C ... epsilons
C
 15      CALL ISTRHW(CHANL,BBUFF,NBYTE,LEN,STATUS)
         IF (NBYTE.NE.LEN .OR. STATUS.NE.0) RETURN
         IROW = IPREV
         IVAL = 3
         IACT = 1
         IC   = 2
         DO 20 I = 5, NBYTE, 2
            IVALUE     = IBUFF(IVAL)    
            CALL TBEWRI(TID,IROW,IC,IVALUE,STATUS)
            IVAL = IVAL + 1
            IROW = IROW + 1
            IACT = IACT + 1
            IF (IACT.GT.INUM) GOTO 25
 20     CONTINUE
C
C ... GROSS
C
 25     CALL ISTRHW(CHANL,BBUFF,NBYTE,LEN,STATUS)
        IF (NBYTE.NE.LEN .OR. STATUS.NE.0) RETURN
         IROW = IPREV
         IVAL = 3
         IACT = 1
         IC   = 3
         DO 30 I = 5, NBYTE, 2
            VALUE      = IBUFF(IVAL)*SCG
            CALL TBEWRR(TID,IROW,IC,VALUE,STATUS)
            IVAL = IVAL + 1
            IROW = IROW + 1
            IACT = IACT + 1
            IF (IACT.GT.INUM) GOTO 35
 30   CONTINUE
C
C ... BACKGROUND
C
 35      CALL ISTRHW(CHANL,BBUFF,NBYTE,LEN,STATUS)
         IF (NBYTE.NE.LEN .OR. STATUS.NE.0) RETURN
         IROW = IPREV
         IVAL = 3
         IACT = 1
         IC   = 4
         DO 40 I = 5, NBYTE, 2
            VALUE      = IBUFF(IVAL)*SCB
            CALL TBEWRR(TID,IROW,IC,VALUE,STATUS)
            IVAL = IVAL + 1
            IROW = IROW + 1
            IACT = IACT + 1
            IF (IACT.GT.INUM) GOTO 45
 40      CONTINUE
C
C ... NET
C
 45      CALL ISTRHW(CHANL,BBUFF,NBYTE,LEN,STATUS)
         IF (NBYTE.NE.LEN .OR. STATUS.NE.0) RETURN
         IROW = IPREV
         IVAL = 3
         IACT = 1
         IC   = 5
         DO 50 I = 5, NBYTE, 2
            VALUE      = IBUFF(IVAL)*SCN    
            CALL TBEWRR(TID,IROW,IC,VALUE,STATUS)
            IVAL = IVAL + 1
            IROW = IROW + 1
            IACT = IACT + 1
            IF (IACT.GT.INUM) GOTO 55
 50      CONTINUE
C
C ... RNET
C
 55      CALL ISTRHW(CHANL,BBUFF,NBYTE,LEN,STATUS)
         IF (NBYTE.NE.LEN .OR. STATUS.NE.0) RETURN
         IROW = IPREV
         IVAL = 3
         IACT = 1
         IC   = 6
         DO 60 I = 5, NBYTE, 2
            VALUE      = IBUFF(IVAL)*SCR
            CALL TBEWRR(TID,IROW,IC,VALUE,STATUS)
            IVAL = IVAL + 1
            IROW = IROW + 1
            IACT = IACT + 1
            IF (IACT.GT.INUM) GOTO 65
 60      CONTINUE
C
C ... FLUX
C
 65      CONTINUE
         IF (NRECPO.EQ.7) THEN
C
C ...     calibrated flux included in the file
C
            CALL ISTRHW(CHANL,BBUFF,NBYTE,LEN,STATUS)
            IF (NBYTE.NE.LEN .OR. STATUS.NE.0) RETURN
            IROW = IPREV
            IVAL = 3
            IACT = 1
            IC   = 7
            DO 70 I = 5, NBYTE, 2
               VALUE      = IBUFF(IVAL)*SCF    
               CALL TBEWRR(TID,IROW,IC,VALUE,STATUS)
               IVAL = IVAL + 1
               IROW = IROW + 1
               IACT = IACT + 1
               IF (IACT.GT.INUM) GOTO 75
 70         CONTINUE
         ELSE
C
C ...    calibrated flux is not present in the file. Output column set to zero
C
            IROW  = IPREV
            IACT  = 1
            IC    = 7
            VALUE = 0.
            DO 71 I = 5, NBYTE, 2
               CALL TBEWRR(TID,IROW,IC,VALUE,STATUS)
               IROW = IROW + 1
               IACT = IACT + 1
               IF (IACT.GT.INUM) GOTO 75
 71         CONTINUE
         ENDIF
C
C ...  generates the order number
C
 75      IC   = 8
         IROW = IPREV
         DO 80 I = 1, INUM
            CALL TBEWRI(TID,IROW,IC,M,STATUS)
            IROW = IROW + 1
 80      CONTINUE
         IPREV = IPREV + INUM
 100  CONTINUE
C
C ... write label descriptors
C
      CALL ISTDES(TID,BUFF,STATUS)
      CALL TBTCLO(TID,STATUS)
      RETURN
      END

C @(#)inteline.for	19.1 (ES0-DMD) 02/25/03 13:19:45
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                    all rights reserved
C.IDENTIFICATION: INTEGR
C.PURPOSE:        Integrate a line or a portion of a line interactively 
C                 using cursor control, or in batch mode
C.LANGUAGE:       F77+ESOext
C.ALGORITHM:      Uses the AGL plotting package
C.KEYWORDS:       Graphics, bulk data frame, integration, line profile
C.INPUT/OUTPUT:   IN_A/C/1/60   = input frame
C                 INPUTI/I/1/1  = line number (defaulted to 1)
C.AUTHOR:         Ch. Ounnas
C.VERSION:        ?????? Ch. Ounnas    Creation
C.VERSION:        850513 K. Banse      ???
C.VERSION:        870625 RHW rewritten and restructured
C.VERSION:        871203 RHW ESO-FORTRAN Conversion
C.VERSION:        890131 RHW ST interfaces
C.VERSION:        900430 RHW Mapping of frame with STFMAP and STFGET
C.VERSION:        910115 RHW IMPLICIT NONE added
C.VERSION:        9312?? RHW change to new graphics interfaces
C.VERSION:        990316 K. Banse   NPMAX => 300 000
C  -----------------------------------------------------------------
      PROGRAM    INTEGR
      IMPLICIT   NONE
C 
      INTEGER    NPMAX
      PARAMETER  (NPMAX=300000)
      INTEGER    MADRID(1)
      INTEGER    I, IAC,II,III,IMF
      INTEGER    IST,ISTAT,NAXIS,NL,NPL
      INTEGER    NVAL,NPIX(3)
      INTEGER    NPL1, NPL2, NPS
      INTEGER    NCH1,NCH2,NCHA(2),KUN(1),KNUL
      INTEGER*8  WPNTR1,WPNTR2
      INTEGER    WIMNO
      INTEGER    NCUR,NDEG, INDX(2)
      INTEGER    ACCESS
      INTEGER    BNMOD,LTYPE

      REAL       SX,SY,XS,YS
      REAL       X0,XPS(NPMAX)
      REAL       FRAME(8),SCALES(3)
      REAL       OFFSET(2),AREA(4)
      REAL       IMAGE(4)
      REAL       DELTAX
      REAL       XC(12),CURS(12)
      REAL       YOFF
      REAL       PLTEPS
C
      DOUBLE PRECISION START(2),STEP(2)
C
      CHARACTER  MODE*1,INPUT*72,TEXT*80
      CHARACTER  LABEL1*80,LABEL2*80
      CHARACTER  LAB1U*16,LAB2U*16
      CHARACTER  NAME*60,IDENT*72,CUNIT*64
      CHARACTER  BINMOD*4
      CHARACTER  XFRAME*4, YFRAME*4
C
      INTEGER    PLMODE
C
      INCLUDE    'MID_INCLUDE:ST_DEF.INC/NOLIST'
      COMMON     /VMR/MADRID
      INCLUDE    'MID_INCLUDE:ST_DAT.INC/NOLIST'

      DATA       LABEL1(1:10)/'Position ('/
      DATA       LABEL2(1:13)/'Pixel value ('/
      DATA       YOFF/0.0/
      DATA       PLMODE/1/
      DATA       ACCESS/0/
      DATA       SCALES/0.0,0.0,0.0/
      DATA       OFFSET/-999.,-999./
      DATA       PLTEPS/1.0E-20/
      DATA       XFRAME/'MANU'/
      DATA       YFRAME/'MANU'/
C
 9001 FORMAT('Row: ', I6)
 9002 FORMAT('*** WARNING: zero dynamics range in data: value = ',
     2        G13.6)
C
C  *** start of executable code ***************************************
      CALL STSPRO('INTEGR')                    ! contact with the MIDAS monitor
C
C *** find file name and read the data
      CALL STKRDC('IN_A',1,1,60,IAC,NAME,KUN,KNUL,IST)
      CALL STFOPN(NAME,D_R4_FORMAT,0,F_IMA_TYPE,IMF,IST)
      CALL STDRDI(IMF,'NAXIS',1,1,IAC,NAXIS,KUN,KNUL,IST)
      CALL STDRDI(IMF,'NPIX',1,NAXIS,IAC,NPIX,KUN,KNUL,IST)
      CALL STDRDD(IMF,'START',1,NAXIS,IAC,START,KUN,KNUL,IST)
      CALL STDRDD(IMF,'STEP',1,NAXIS,IAC,STEP,KUN,KNUL,IST)
      CALL STDRDC(IMF,'IDENT',1,1,72,IAC,IDENT,KUN,KNUL,IST)
      CALL STDRDC(IMF,'CUNIT',1,1,64,IAC,CUNIT,KUN,KNUL,IST)
C
C *** read the manual setting
      CALL PTKRDR('XAXIS',4,IAC,FRAME)
      CALL PTKRDR('YAXIS',4,IAC,FRAME(5))
C 
C  allocate virtual memory for a single line of the frame
      NVAL = NPIX(1)
      IF (NVAL.EQ.1) THEN
         CALL STTPUT('*** FATAL: Image row contains only one point!',
     2               ISTAT)
      ENDIF
      IF (NVAL.LT.512) NVAL = 512
      CALL STFCRE('PLOTWORK',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +            NVAL,WIMNO,IST)
      CALL STFMAP(WIMNO,F_X_MODE,1,NVAL,IAC,WPNTR1,IST)
C 
C *** determine the various pameters for the plotting
      NPL = NPIX(1)
      NL  = NPIX(2)
      SX  = STEP(1)
      SY  = STEP(2)
      XS  = START(1)
      YS  = START(2)
C
C *** line number
      IF (NAXIS.GT.1) THEN
         CALL STKRDC('P2',1,1,72,IAC,INPUT,KUN,KNUL,IST)
         II     = INDEX(INPUT,' ')
         CALL GETSIN(INPUT(1:II-1),NL,YS,SY,IMAGE(3))
         IMAGE(4)  = IMAGE(3)
         CALL BOXPTW(IMAGE(3),NL,YS,SY,AREA(3))
C
      ELSE
         IMAGE(3) = 1.
         IMAGE(4) = 1.
      ENDIF
C
C *** first and last pixel
      CALL STKRDC('INPUTC',1,1,72,IAC,INPUT,KUN,KNUL,IST)
      CALL UPCAS(INPUT,INPUT)
      IF (INPUT(1:1).EQ.'M') THEN                                  ! manu input
         CALL BOXWTP(FRAME(1),NPL,XS,SX,IMAGE(1))
         CALL BOXPTW(IMAGE(1),NPL,XS,SX,AREA(1))
C
      ELSE
         II     = INDEX(INPUT,',')
         CALL GETSIN(INPUT(1:II-1),NPL,XS,SX,IMAGE(1))
         III    = INDEX(INPUT,' ')
         CALL GETSIN(INPUT(II+1:III-1),NPL,XS,SX,IMAGE(2))
         CALL BOXPTW(IMAGE(1),NPL,XS,SX,AREA(1))
      ENDIF
C
C *** pixels to be plotted
      CALL PTKWRR('PIXEL',4,IMAGE)
      NPL1   = INT(MIN(IMAGE(1),IMAGE(2))) 
      NPL2   = INT(MAX(IMAGE(1),IMAGE(2))) 
      NPS    = ABS(NPL1-NPL2) + 1 
      WPNTR2 = WPNTR1 + NPL1 - 1
C
C *** set the array indexes
      II = (INT(IMAGE(3))-1)*NPL + 1                         ! offset in frame
      CALL STFGET(IMF,II,NPL,IAC,MADRID(WPNTR1),IST)
C
C *** get the number of cursor and the interpolation
      CALL STKRDI('INPUTI',1,2,IAC,NCHA,KUN,KNUL,IST)
      NCUR   = NCHA(1)
      NDEG   = NCHA(2)
C
C *** batch mode or in forground
      CALL STKRDC('P5',1,1,1,IAC,MODE,KUN,KNUL,IST)
      CALL UPCAS(MODE,MODE)
C
C *** interactive or batch mode
      IF (MODE.EQ.'B') THEN
         CALL STKRDR('CURS',1,12,IAC,CURS,KUN,KNUL,IST)          !get positions
         DO 10 II = 1,NCUR
             XC(II) = CURS(II)
   10    CONTINUE
         DELTAX   = CURS(NCUR+1)
         IMAGE(1) = 1.
         IMAGE(2) = FLOAT(NPL)
         CALL INTFRB(MADRID(WPNTR1),NPL,IMAGE,SX,XS,NCUR,NDEG,
     2                DELTAX,XC)

      ELSE
C
C *** calculate the frame of the x axis
         IF ((ABS(FRAME(1)).LT.PLTEPS) .AND. 
     2       (ABS(FRAME(2)).LT.PLTEPS)) THEN
            XFRAME   = 'AUTO'
            FRAME(1) = AREA(1)
            FRAME(2) = AREA(2)
            FRAME(3) = 0.0
            FRAME(4) = 0.0
         ELSE
            XFRAME   = 'MANU'
         ENDIF
C
C *** set min and max pixel values
         IF ((ABS(FRAME(5)).LT.PLTEPS) .AND. 
     2       (ABS(FRAME(6)).LT.PLTEPS)) THEN
            YFRAME = 'AUTO'
            CALL MNMX(MADRID(WPNTR2),NPS,FRAME(5),INDX)
            IF (FRAME(5).EQ.FRAME(6)) THEN
               WRITE (TEXT,9002) FRAME(5)
               CALL STTPUT(TEXT,ISTAT)
            ENDIF
            FRAME(7) = 0.0
            FRAME(8) = 0.0
         ELSE
            YFRAME   = 'MANU'
         ENDIF
C 
         CALL GETAXS(XFRAME,FRAME)
         CALL GETAXS(YFRAME,FRAME(5))
         CALL PTKWRR('XWNDL',4,FRAME)
         CALL PTKWRR('YWNDL',4,FRAME(5))
C
C *** statistics determined; get the setups
         CALL PTKRDC('BINMOD',4,IAC,BINMOD)
         IF (BINMOD(1:2).EQ.'ON') THEN
             BNMOD = 1
         ELSE
             BNMOD = 0
         ENDIF
C
         CALL PTKRDI('LTYPE',1,IAC,LTYPE) 
         CALL PTOPEN(' ',' ',ACCESS,PLMODE)
C
C *** do the work
         X0 = FLOAT(NPL1-1)*SX + XS
         DO 20 I = 1,NPS
            XPS(I) = X0 + (I-1)*SX
   20    CONTINUE
         CALL PTDATA(0,LTYPE,BNMOD,XPS,MADRID(WPNTR2),YOFF,NPS)
C
C *** draw the axis and the label
         LAB1U = CUNIT(17:32) 
         NCH1 = INDEX(LAB1U,' ')-1
         IF (NCH1 .LT. 0) THEN 
            LABEL1(10:) = ' '
         ELSE
    	    LABEL1(11:) = LAB1U(1:NCH1)//')'
         ENDIF
         LAB2U = CUNIT(33:48)
         NCH2 = INDEX(LAB2U,' ')-1
         IF (NCH2 .LT. 0) THEN
            LABEL2(13:) = ' '
         ELSE
            LABEL2(14:) = LAB2U(1:NCH2)//')' 
         ENDIF
         CALL PTFRAM(FRAME(1),FRAME(5),LABEL1,LABEL2)
C
C *** do the integration
         CALL INTFRI(MADRID(WPNTR1),NPS,IMAGE,SX,XS,NCUR,NDEG)
         CALL PTCLOS()
      END IF
C
C *** finish this bastard and exit
      CALL STSEPI
      END

      SUBROUTINE GETSIN(STRING,NOPIX,START,STEP,PIXEL) 
C+++
C.PURPOSE:  Convert the user coordinate input string into pixel value         
C.AUTHOR:   Klaus Banse, ESO-Garching
C.COMMENTS: If coord outside valid interval PIXEL .LE. 0 will be returned...  
C.VERSION:  87???? RHW small adjustments of the plotting package
C.VERSION:  910115 RHW IMPLICIT NONE added
C---
      IMPLICIT      NONE
      CHARACTER*(*) STRING                  ! IN: coordinate string
      INTEGER       NOPIX                   ! IN: number pixels in frame
      REAL          START                   ! IN: start value of frame
      REAL          STEP                    ! IN: step between pixel
      REAL          PIXEL                   ! OUT: pixel number     
C
      INTEGER       IVAL, ISTAT
      INTEGER       MADRID(1)
      REAL          RVAL
      CHARACTER*1   TEST
      DOUBLE PRECISION DVAL

C
      COMMON        /VMR/MADRID
C
C *** 
      TEST  = STRING(1:1)                  ! check 1. character of input string
      IF (TEST.EQ.'<') THEN                                !  handle "<" format
          PIXEL  = 1
          RETURN
C
      ELSE IF (TEST.EQ.'>') THEN                            ! handle ">" format
         PIXEL  = NOPIX
         RETURN
C
      ELSE IF (TEST.EQ.'@') THEN                            ! handle "@" format
         CALL GENCNV(STRING(2:),1,1,IVAL,RVAL,DVAL,ISTAT)
         IF (ISTAT.GT.0) THEN
C           PIXEL = IVAL-1  
            PIXEL = IVAL
         ENDIF
C
      ELSE                                     ! here we have world coordinates
         CALL GENCNV(STRING,2,1,IVAL,RVAL,DVAL,ISTAT)
         IF (ISTAT.GT.0) THEN
            PIXEL  = NINT((RVAL-START)/STEP) + 1 
         ENDIF
      END IF
C
C  test, if pixel too large...
      IF (PIXEL.GT.NOPIX) THEN 
         PIXEL  = 0
      ELSE IF (PIXEL.LT.1) THEN
         PIXEL  = -1 
      END IF
C       
      RETURN
      END 

C @(#)integbin.for	19.1 (ES0-DMD) 02/25/03 14:29:41
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM INGBIN
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:13 - 3 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: D.PONZ
C
C.IDENTIFICATION
C  program    INTEGBIN              version 1.0          851028
C
C.Keywords
C  flux integration over fixed bins in 1-D images
C
C.PURPOSE
C   to be used for normalization of spectra or construction of 
C   response curves
C
C.ALGORITHM
C  get central positions of bins and their widths from table (in keyword
C  NFTAB), integrate flux in image (keyword NFIMA) over bins (where
C  necessary do a linear interpolation), write results to table
C
C.INPUT/OUTPUT
C the following keywords are used:
C NFIMA/C/1/60         name of input image
C NFTAB/C/1/60        name of table with central wavelengths, bin 
C                       widths, will also receive fluxes derived
C
C. modif MPeron 130291 add TBTCLO
C --------------------------------------------------------------------
C
      IMPLICIT NONE
      INTEGER MADRID
      CHARACTER*60 NFIMA,NFTAB
      CHARACTER    FORM*6,IDENT*72,CUNIT*72
      INTEGER   NPIX,ISTAT,IAV,ERROR(2),ICOL(3),IRCOL(2)
      INTEGER   NCOL,NROW,LL,I,NSC1
      INTEGER*8 PNTR
      INTEGER   NAXIS,KUN,KNUL
      INTEGER   IMNO,TID,NAC,NAR,DTYPE
      REAL      DATA(2),BINFLX
      DOUBLE PRECISION DEND, DSTEP, DSTART, LAMLO, LAMHI
      LOGICAL CURRY,NULL(3)
C
      INCLUDE  'MID_INCLUDE:TABLES.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE  'MID_INCLUDE:TABLED.INC'
C
C ... set up MIDAS environment
C
      CALL STSPRO('INTEGBIN')
C
C ... get name of input frame, map it
C
      CALL STKRDC('NFIMAGE',1,1,60,IAV,NFIMA,KUN,KNUL,ISTAT)
      IF (ISTAT.NE.0) GO TO 20
      CALL STIGET(NFIMA,10,0,1,1,NAXIS,NPIX,DSTART,DSTEP,
     +IDENT,CUNIT,PNTR,IMNO,ISTAT)
      IF (ISTAT.NE.0) GO TO 20
      IF (NAXIS.NE.1) THEN
          CALL STTPUT('ERROR: input frame must be one-dimensional',
     +                ISTAT)
          ERROR(1) = 1
          GO TO 20
      END IF
      DEND    = DSTART + (NPIX-1)*DSTEP
C
C ... get name of table
C
      CALL STKRDC('NFTABLE',1,1,60,IAV,NFTAB,KUN,KNUL,ISTAT)
      IF (ISTAT.NE.0) GO TO 20
C
C ... intialize table
C
      CALL TBTOPN(NFTAB,2,TID,ISTAT)
      IF (ISTAT.NE.0) GO TO 20
      CALL TBIGET(TID,NCOL,NROW,NSC1,NAC,NAR,ISTAT)
      IF (ISTAT.NE.0) GO TO 20
C
C ... find column 'X_AXIS' (wavelength)
C
      CALL TBLSER(TID,'X_AXIS',ICOL(1),ISTAT)
      IF (ICOL(1).EQ.-1) THEN
          ISTAT  = 10
          CALL STTPUT('ERROR: column not found',ISTAT)
          GO TO 20
      END IF
      CALL TBFGET(TID,ICOL(1),FORM,LL,DTYPE,ISTAT)
      IF (DTYPE.EQ.D_C_FORMAT) THEN
          ISTAT  = 11
          CALL STTPUT('ERROR: wrong column format',ISTAT)
          GO TO 20
      END IF
C
C ... find column 'BIN_WIDTH'
C
      CALL TBLSER(TID,'BIN_WIDTH',ICOL(2),ISTAT)
      IF (ICOL(2).EQ.-1) THEN
          ISTAT  = 10
          CALL STTPUT('ERROR: column not found',ISTAT)
          GO TO 20
      END IF
      CALL TBFGET(TID,ICOL(2),FORM,LL,DTYPE,ISTAT)
      IF (DTYPE.EQ.D_C_FORMAT) THEN
          ISTAT  = 11
          CALL STTPUT('ERROR: wrong column format',ISTAT)
          GO TO 20
      END IF
C
C ... find column 'Y_AXIS' (flux)
C
      CALL TBLSER(TID,'Y_AXIS',ICOL(3),ISTAT)
      IF (ICOL(3).EQ.-1) THEN
          ISTAT  = 10
          CALL STTPUT('ERROR: column not found',ISTAT)
          GO TO 20
      END IF
      CALL TBFGET(TID,ICOL(3),FORM,LL,DTYPE,ISTAT)
      IF (DTYPE.EQ.D_C_FORMAT) THEN
          ISTAT  = 11
          CALL STTPUT('ERROR: wrong column format',ISTAT)
          GO TO 20
      END IF
      IRCOL(1) = ICOL(1)
      IRCOL(2) = ICOL(2)
C
C ... read table
C
      DO 10 I = 1,NROW
          CALL TBRRDR(TID,I,2,IRCOL,DATA,NULL,ISTAT)
          CURRY = ( .NOT. NULL(1)) .AND. ( .NOT. NULL(2))
          IF (CURRY) THEN  !   lower limit in lambda of bin
              LAMLO  = DATA(1) - DATA(2)/2.  !   upper limit in lambda of bin
              LAMHI  = DATA(1) + DATA(2)/2.
              IF ((LAMLO.GE.DSTART) .AND. (LAMHI.LE.DEND)) THEN
C
C ... let subroutine DOINTG do the job
C
                CALL DOINTG(MADRID(PNTR),DSTART,DSTEP,NPIX,LAMLO,LAMHI,
     +                         BINFLX)
                CALL TBEWRR(TID,I,ICOL(3),BINFLX,ISTAT)
              END IF
          END IF
   10 CONTINUE
C
C the end
C
      CALL TBTCLO(TID,ISTAT)
      CALL STSEPI
      STOP 
C
C ... direct trouble makers here:
C
   20 ERROR(1) = ISTAT
      CALL STKWRI('PROGSTAT',ERROR,1,2,KUN,ISTAT)
      CALL STSEPI
      STOP 
C
      END

      SUBROUTINE DOINTG(FLUX,DSTART,DSTEP,NPIX,LAMLO,LAMHI,BINFLX)
C
C
      IMPLICIT NONE
      INTEGER NPIX,IPIXHI,IPIXLO,I
      REAL FLUX(1),PIXLO,PIXHI,FPIXHI,FPIXLO,BINFLX
      DOUBLE PRECISION DSTART, DSTEP, LAMLO, LAMHI
C
C ... all operations below assume that the flux is evenly distributed
C ... ver the pixel and that its coordinates refer to the pixel's 
C ... center !
C  !   first pixel hit (only partly)
      PIXLO  = 0.5 + (LAMLO-DSTART)/DSTEP  !   last pixel hit (also only partly)
      PIXHI  = 0.5 + (LAMHI-DSTART)/DSTEP  !   nmubers of first ...
      IPIXLO = INT(PIXLO)  !   ... and last pixel
      IPIXHI = INT(PIXHI)  !   fraction of first and ...
      FPIXLO = IPIXLO + 1 - PIXLO  !   ... last pixel to be considered
      FPIXHI = PIXHI - IPIXHI
C
C ... do a linear interpolation across the first and last pixel,
C ... add up the pixels in between, return mean flux per pixel
C
      BINFLX = FPIXLO*FLUX(IPIXLO) + FPIXHI*FLUX(IPIXHI)
      DO 10 I = IPIXLO + 1,IPIXHI - 1
          BINFLX = BINFLX + FLUX(I)
   10 CONTINUE
      BINFLX = BINFLX/ (IPIXHI-IPIXLO-1+FPIXLO+FPIXHI)
C
      RETURN
      END

C @(#)rlgrnt.for	19.1 (ES0-DMD) 02/25/03 13:25:38
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine RLGRNT         version 2.3       830916
C  A. Kruszewski             ESO Garching
C  modified                  version 2.4       870304
C  A. Kruszewski             Obs. de Geneve
C.KEYWORDS
C  profile gradient
C.PURPOSE
C  calculates gradient in an observed profile relative to the
C  standard stellar profile
C  this relative gradient should be close to zero for stars
C  negative for galaxies, and positive for majority of defects
C.ALGORYTHM
C  quantity  -LOG10(AVPR)-SPRF , or in other words, deviations of
C  an observed profile from the standard profile, is subjected to
C  the regression with respect to a ring number K expressed
C  in pixels
C  the coefficient of regression is accepted as relative gradient
C.INPUT/OUTPUT
C  input arguments
C  AVPR        real*4 array      observed one-dimensional profile
C  SPRF        real*4 array      cumulative standard profile
C  HHCUT       real*4            upper limit of usable data
C  TRSH        real*4            lower limiting treshold
C  output arguments
C  AVGR        real*4            relative gradient
C  SIGMA       real*4            sigma of single data point
C-----------------------------------------------------------------------
      SUBROUTINE RLGRNT(AVPR, SPRF, HHCUT, TRSH, AVGR, SIGMA)
C
      IMPLICIT  NONE
      INCLUDE  'MID_REL_INCL:INVENT.INC/NOLIST'
C
      REAL      AVPR(0:MAXSUB)
      REAL      SPRF(0:MAXSUB)
      REAL      HHCUT
      REAL      TRSH
      REAL      AVGR
      REAL      SIGMA
C
      INTEGER   K
      INTEGER   M1
      INTEGER   N, NN
      INTEGER   L
      REAL      ALIM, AMEAN
      REAL      BLIM
      REAL      GRSL
      REAL      ZRLV
      REAL      SGGR
      REAL      IC, ID
      INTEGER   IW(0:MAXSUB )
      REAL      X(0:MAXSUB), Y(0:MAXSUB)
      REAL      DVGR(0:MAXSUB)
      REAL      YY(MAXSUB+1)
C
      DO 10 K = 0 , MAXSUB
          IW(K) = 0
          X(K) = 0.0
          Y(K) = 0.0
   10 CONTINUE
      M1 = MAXSUB + 1
      DO 20 K = 1 , M1
          YY(K) = 0.0
   20 CONTINUE
      NN = 0
      BLIM = MIN( AVPR(0) , HHCUT )
      ALIM = MAX( 0.01*BLIM , 0.5*TRSH )
      L = 0
C
C ******      Select usable part of an observed profile.
C
   31 CONTINUE
          IF ( AVPR(L) .LT. ALIM .OR. L .GT. MAXSUB ) THEN
              N = L - 1
              GOTO 30
          ENDIF
          IF ( AVPR(L) .LT. HHCUT ) THEN
              X(L) = FLOAT(L)
              Y(L) = -ALOG10( AVPR(L) ) - SPRF(L)
              IW(L) = 1
              NN = NN + 1
              YY(NN) = Y(L)
          ELSE
              IW(L) = 0
          ENDIF
          L = L + 1
          GOTO 31
   30 CONTINUE
C
C ******      Calculate root mean square deviation SIGMA of used data.
C
      IF ( NN .GT. 1 ) THEN
          CALL MEAN( YY , NN , AMEAN , SIGMA )
      ELSE
          SIGMA = 1.0
      ENDIF
C
C ******      Calculate first approximation for relative gradient.
C
      IF ( NN .GE. 2 ) THEN
          CALL GRADET( L , X , Y , IW , AVGR , ZRLV , DVGR , SGGR )
          IF ( NN .EQ. 2 ) THEN
              IC = 0
              SGGR = 1.0
          ELSE
              IC = 3
          ENDIF
      ELSE
          AVGR = 1.0
          SGGR = 1.0
          IC = 0
      ENDIF
C
C ******      Repeat calculations after rejecting
C ******      points deviating more than 1.4*SGGR.
C
   41 CONTINUE
      IF ( IC .EQ. 0 ) GOTO 40
          GRSL = 1.4 * SGGR
          NN = 0
          ID = 0
          DO 50 L = 0 , N
              IF ( IW(L) .EQ. 1 ) THEN
                  IF ( ABS( DVGR(L) ) .GT. GRSL ) THEN
                      IW(L) = 0
                      ID = ID + 1
                  ELSE
                      NN = NN + 1
                  ENDIF
              ENDIF
   50     CONTINUE
          IF ( ID .EQ. 0 .OR. NN .LT. 2 ) THEN
              IC = 0
          ELSE
              CALL GRADET( MAXSUB , X , Y , IW , AVGR ,
     &                                    ZRLV , DVGR , SGGR )
              IF ( NN .GT. 2 ) THEN
                  IC = IC - 1
              ELSE 
                  IC = 0
                  SGGR = 1.0
              ENDIF
          ENDIF
          GOTO 41
   40 CONTINUE
C
      RETURN
      END

C @(#)replsubt.for	19.1 (ES0-DMD) 02/25/03 14:01:45
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE IREPLD(A,T,B,BB,C,IFCNT,OPER,NDIM,LOW,HI,NLIMIT,VAL)
C
      IMPLICIT NONE
C
      INTEGER   NDIM,NLIMIT,IFCNT
      INTEGER   N
C
      REAL      A(NDIM),T(NDIM),B(NDIM),BB(NDIM),C(NDIM)
      REAL      LOW,HI,VAL(2)
      REAL      RVAL
C
      CHARACTER*(*)    OPER
C
C  first part B(N) * VAL(1)
      IF (NLIMIT.EQ.-1) GOTO 200
      IF (NLIMIT.EQ.1) GOTO 400
C
      IF (OPER(2:2).EQ.' ') THEN                      !check if alternative...
         DO 100 N=1,NDIM
            IF ((T(N).GE.LOW).AND.(T(N).LE.HI)) THEN
               IFCNT = IFCNT + 1
               C(N) = B(N) * VAL(1)
            ELSE
               C(N) = A(N)
            ENDIF
100      CONTINUE
      ELSE
C
         IF (OPER(2:2).EQ.'C') THEN
            DO 110 N=1,NDIM
               IF ((T(N).GE.LOW).AND.(T(N).LE.HI)) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * VAL(1)
               ELSE
                  C(N) = VAL(2)
               ENDIF
110         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'+') THEN
            DO 120 N=1,NDIM
               IF ((T(N).GE.LOW).AND.(T(N).LE.HI)) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * VAL(1)
               ELSE
                  C(N) = BB(N) + VAL(2)
               ENDIF
120         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'-') THEN
            DO 130 N=1,NDIM
               IF ((T(N).GE.LOW).AND.(T(N).LE.HI)) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * VAL(1)
               ELSE
                  C(N) = BB(N) - VAL(2)
               ENDIF
130         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'*') THEN
            DO 140 N=1,NDIM
               IF ((T(N).GE.LOW).AND.(T(N).LE.HI)) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * VAL(1)
               ELSE
                  C(N) = BB(N) * VAL(2)
               ENDIF
140         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'/') THEN
            RVAL = 1. / VAL(2)
            DO 150 N=1,NDIM
               IF ((T(N).GE.LOW).AND.(T(N).LE.HI)) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * VAL(1)
               ELSE
                  C(N) = BB(N) * RVAL
               ENDIF
150         CONTINUE
C
         ELSE
            DO 160 N=1,NDIM
               IF ((T(N).GE.LOW).AND.(T(N).LE.HI)) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * VAL(1)
               ELSE
                  C(N) = BB(N)
               ENDIF
160         CONTINUE
         ENDIF
      ENDIF
      RETURN
C
C
200   IF (OPER(2:2).EQ.' ') THEN                      !check if alternative...
         DO 205 N=1,NDIM
            IF (T(N).LE.HI) THEN
               IFCNT = IFCNT + 1
               C(N) = B(N) * VAL(1)
            ELSE
               C(N) = A(N)
            ENDIF
205      CONTINUE
      ELSE
C
         IF (OPER(2:2).EQ.'C') THEN
            DO 210 N=1,NDIM
               IF (T(N).LE.HI) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * VAL(1)
               ELSE
                  C(N) = VAL(2)
               ENDIF
210         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'+') THEN
            DO 220 N=1,NDIM
               IF (T(N).LE.HI) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * VAL(1)
               ELSE
                  C(N) = BB(N) + VAL(2)
               ENDIF
220         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'-') THEN
            DO 230 N=1,NDIM
               IF (T(N).LE.HI) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * VAL(1)
               ELSE
                  C(N) = BB(N) - VAL(2)
               ENDIF
230         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'*') THEN
            DO 240 N=1,NDIM
               IF (T(N).LE.HI) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * VAL(1)
               ELSE
                  C(N) = BB(N) * VAL(2)
               ENDIF
240         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'/') THEN
            RVAL = 1. / VAL(2)
            DO 250 N=1,NDIM
               IF (T(N).LE.HI) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * VAL(1)
               ELSE
                  C(N) = BB(N) * RVAL
               ENDIF
250         CONTINUE
C
         ELSE
            DO 260 N=1,NDIM
               IF (T(N).LE.HI) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * VAL(1)
               ELSE
                  C(N) = BB(N)
               ENDIF
260         CONTINUE
         ENDIF
      ENDIF
      RETURN
C
400   IF (OPER(2:2).EQ.' ') THEN                      !check if alternative...
         DO 405 N=1,NDIM
            IF (T(N).GE.LOW) THEN
               IFCNT = IFCNT + 1
               C(N) = B(N) * VAL(1)
            ELSE
               C(N) = A(N)
            ENDIF
405      CONTINUE
C
      ELSE
         IF (OPER(2:2).EQ.'C') THEN
            DO 410 N=1,NDIM
               IF (T(N).GE.LOW) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * VAL(1)
               ELSE
                  C(N) = VAL(2)
               ENDIF
410         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'+') THEN
            DO 420 N=1,NDIM
               IF (T(N).GE.LOW) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * VAL(1)
               ELSE
                  C(N) = BB(N) + VAL(2)
               ENDIF
420         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'-') THEN
            DO 430 N=1,NDIM
               IF (T(N).GE.LOW) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * VAL(1)
               ELSE
                  C(N) = BB(N) - VAL(2)
               ENDIF
430         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'*') THEN
            DO 440 N=1,NDIM
               IF (T(N).GE.LOW) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * VAL(1)
               ELSE
                  C(N) = BB(N) * VAL(2)
               ENDIF
440         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'/') THEN
            RVAL = 1. / VAL(2)
            DO 450 N=1,NDIM
               IF (T(N).GE.LOW) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * VAL(1)
               ELSE
                  C(N) = BB(N) * RVAL
               ENDIF
450         CONTINUE
C
         ELSE
            DO 460 N=1,NDIM
               IF (T(N).GE.LOW) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * VAL(1)
               ELSE
                  C(N) = BB(N)
               ENDIF
460         CONTINUE
         ENDIF
C
         RETURN
      ENDIF
C
      END

      SUBROUTINE IREPLE(A,T,B,BB,C,IFCNT,OPER,NDIM,LOW,HI,NLIMIT,VAL)
C
      IMPLICIT NONE
C
      INTEGER   NDIM,NLIMIT,IFCNT
      INTEGER   N
C
      REAL      A(NDIM),T(NDIM),B(NDIM),BB(NDIM),C(NDIM)
      REAL      LOW,HI,VAL(2)
      REAL      RVAL1,RVAL
C
      CHARACTER*(*)    OPER
C
C  first part B(N) / VAL(1)
      RVAL1 = 1. / VAL(1)
      IF (NLIMIT.EQ.-1) GOTO 200
      IF (NLIMIT.EQ.1) GOTO 400
C
      IF (OPER(2:2).EQ.' ') THEN                      !check if alternative...
         DO 100 N=1,NDIM
            IF ((T(N).GE.LOW).AND.(T(N).LE.HI)) THEN
               IFCNT = IFCNT + 1
               C(N) = B(N) * RVAL1
            ELSE
               C(N) = A(N)
            ENDIF
100      CONTINUE
      ELSE
C
         IF (OPER(2:2).EQ.'C') THEN
            DO 110 N=1,NDIM
               IF ((T(N).GE.LOW).AND.(T(N).LE.HI)) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * RVAL1
               ELSE
                  C(N) = VAL(2)
               ENDIF
110         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'+') THEN
            DO 120 N=1,NDIM
               IF ((T(N).GE.LOW).AND.(T(N).LE.HI)) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * RVAL1
               ELSE
                  C(N) = BB(N) + VAL(2)
               ENDIF
120         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'-') THEN
            DO 130 N=1,NDIM
               IF ((T(N).GE.LOW).AND.(T(N).LE.HI)) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * RVAL1
               ELSE
                  C(N) = BB(N) - VAL(2)
               ENDIF
130         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'*') THEN
            DO 140 N=1,NDIM
               IF ((T(N).GE.LOW).AND.(T(N).LE.HI)) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * RVAL1
               ELSE
                  C(N) = BB(N) * VAL(2)
               ENDIF
140         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'/') THEN
            RVAL = 1. / VAL(2)
            DO 150 N=1,NDIM
               IF ((T(N).GE.LOW).AND.(T(N).LE.HI)) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * RVAL1
               ELSE
                  C(N) = BB(N) * RVAL
               ENDIF
150         CONTINUE
C
         ELSE
            DO 160 N=1,NDIM
               IF ((T(N).GE.LOW).AND.(T(N).LE.HI)) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * RVAL1
               ELSE
                  C(N) = BB(N)
               ENDIF
160         CONTINUE
         ENDIF
      ENDIF
      RETURN
C
C
200   IF (OPER(2:2).EQ.' ') THEN                      !check if alternative...
         DO 205 N=1,NDIM
            IF (T(N).LE.HI) THEN
               IFCNT = IFCNT + 1
               C(N) = B(N) * RVAL1
            ELSE
               C(N) = A(N)
            ENDIF
205      CONTINUE
      ELSE
C
         IF (OPER(2:2).EQ.'C') THEN
            DO 210 N=1,NDIM
               IF (T(N).LE.HI) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * RVAL1
               ELSE
                  C(N) = VAL(2)
               ENDIF
210         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'+') THEN
            DO 220 N=1,NDIM
               IF (T(N).LE.HI) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * RVAL1
               ELSE
                  C(N) = BB(N) + VAL(2)
               ENDIF
220         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'-') THEN
            DO 230 N=1,NDIM
               IF (T(N).LE.HI) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * RVAL1
               ELSE
                  C(N) = BB(N) - VAL(2)
               ENDIF
230         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'*') THEN
            DO 240 N=1,NDIM
               IF (T(N).LE.HI) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * RVAL1
               ELSE
                  C(N) = BB(N) * VAL(2)
               ENDIF
240         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'/') THEN
            RVAL = 1. / VAL(2)
            DO 250 N=1,NDIM
               IF (T(N).LE.HI) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * RVAL1
               ELSE
                  C(N) = BB(N) * RVAL
               ENDIF
250         CONTINUE
C
         ELSE
            DO 260 N=1,NDIM
               IF (T(N).LE.HI) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * RVAL1
               ELSE
                  C(N) = BB(N)
               ENDIF
260         CONTINUE
         ENDIF
      ENDIF
      RETURN
C
400   IF (OPER(2:2).EQ.' ') THEN                      !check if alternative...
         DO 405 N=1,NDIM
            IF (T(N).GE.LOW) THEN
               IFCNT = IFCNT + 1
               C(N) = B(N) * RVAL1
            ELSE
               C(N) = A(N)
            ENDIF
405      CONTINUE
C
      ELSE
         IF (OPER(2:2).EQ.'C') THEN
            DO 410 N=1,NDIM
               IF (T(N).GE.LOW) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * RVAL1
               ELSE
                  C(N) = VAL(2)
               ENDIF
410         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'+') THEN
            DO 420 N=1,NDIM
               IF (T(N).GE.LOW) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * RVAL1
               ELSE
                  C(N) = BB(N) + VAL(2)
               ENDIF
420         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'-') THEN
            DO 430 N=1,NDIM
               IF (T(N).GE.LOW) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * RVAL1
               ELSE
                  C(N) = BB(N) - VAL(2)
               ENDIF
430         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'*') THEN
            DO 440 N=1,NDIM
               IF (T(N).GE.LOW) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * RVAL1
               ELSE
                  C(N) = BB(N) * VAL(2)
               ENDIF
440         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'/') THEN
            RVAL = 1. / VAL(2)
            DO 450 N=1,NDIM
               IF (T(N).GE.LOW) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * RVAL1
               ELSE
                  C(N) = BB(N) * RVAL
               ENDIF
450         CONTINUE
C
         ELSE
            DO 460 N=1,NDIM
               IF (T(N).GE.LOW) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N) * RVAL1
               ELSE
                  C(N) = BB(N)
               ENDIF
460         CONTINUE
         ENDIF
C
         RETURN
      ENDIF
C
      END

      SUBROUTINE IREPLF(A,T,B,BB,C,IFCNT,OPER,NDIM,LOW,HI,NLIMIT,VAL)
C
      IMPLICIT NONE
C
      INTEGER   NDIM,NLIMIT,IFCNT
      INTEGER   N
C
      REAL      A(NDIM),T(NDIM),B(NDIM),BB(NDIM),C(NDIM)
      REAL      LOW,HI,VAL(2)
      REAL      RVAL
C
      CHARACTER*(*)    OPER
C
C  first part only frame B(N)
      IF (NLIMIT.EQ.-1) GOTO 200
      IF (NLIMIT.EQ.1) GOTO 400
C
      IF (OPER(2:2).EQ.' ') THEN                      !check if alternative...
         DO 100 N=1,NDIM
            IF ((T(N).GE.LOW).AND.(T(N).LE.HI)) THEN
               IFCNT = IFCNT + 1
               C(N) = B(N)
            ELSE
               C(N) = A(N)
            ENDIF
100      CONTINUE
      ELSE
C
         IF (OPER(2:2).EQ.'C') THEN
            DO 110 N=1,NDIM
               IF ((T(N).GE.LOW).AND.(T(N).LE.HI)) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N)
               ELSE
                  C(N) = VAL(2)
               ENDIF
110         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'+') THEN
            DO 120 N=1,NDIM
               IF ((T(N).GE.LOW).AND.(T(N).LE.HI)) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N)
               ELSE
                  C(N) = BB(N) + VAL(2)
               ENDIF
120         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'-') THEN
            DO 130 N=1,NDIM
               IF ((T(N).GE.LOW).AND.(T(N).LE.HI)) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N)
               ELSE
                  C(N) = BB(N) - VAL(2)
               ENDIF
130         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'*') THEN
            DO 140 N=1,NDIM
               IF ((T(N).GE.LOW).AND.(T(N).LE.HI)) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N)
               ELSE
                  C(N) = BB(N) * VAL(2)
               ENDIF
140         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'/') THEN
            RVAL = 1. / VAL(2)
            DO 150 N=1,NDIM
               IF ((T(N).GE.LOW).AND.(T(N).LE.HI)) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N)
               ELSE
                  C(N) = BB(N) * RVAL
               ENDIF
150         CONTINUE
C
         ELSE
            DO 160 N=1,NDIM
               IF ((T(N).GE.LOW).AND.(T(N).LE.HI)) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N)
               ELSE
                  C(N) = BB(N)
               ENDIF
160         CONTINUE
         ENDIF
      ENDIF
      RETURN
C
C
200   IF (OPER(2:2).EQ.' ') THEN                      !check if alternative...
         DO 205 N=1,NDIM
            IF (T(N).LE.HI) THEN
               IFCNT = IFCNT + 1
               C(N) = B(N)
            ELSE
               C(N) = A(N)
            ENDIF
205      CONTINUE
      ELSE
C
         IF (OPER(2:2).EQ.'C') THEN
            DO 210 N=1,NDIM
               IF (T(N).LE.HI) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N)
               ELSE
                  C(N) = VAL(2)
               ENDIF
210         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'+') THEN
            DO 220 N=1,NDIM
               IF (T(N).LE.HI) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N)
               ELSE
                  C(N) = BB(N) + VAL(2)
               ENDIF
220         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'-') THEN
            DO 230 N=1,NDIM
               IF (T(N).LE.HI) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N)
               ELSE
                  C(N) = BB(N) - VAL(2)
               ENDIF
230         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'*') THEN
            DO 240 N=1,NDIM
               IF (T(N).LE.HI) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N)
               ELSE
                  C(N) = BB(N) * VAL(2)
               ENDIF
240         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'/') THEN
            RVAL = 1. / VAL(2)
            DO 250 N=1,NDIM
               IF (T(N).LE.HI) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N)
               ELSE
                  C(N) = BB(N) * RVAL
               ENDIF
250         CONTINUE
C
         ELSE
            DO 260 N=1,NDIM
               IF (T(N).LE.HI) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N)
               ELSE
                  C(N) = BB(N)
               ENDIF
260         CONTINUE
         ENDIF
      ENDIF
      RETURN
C
400   IF (OPER(2:2).EQ.' ') THEN                      !check if alternative...
         DO 405 N=1,NDIM
            IF (T(N).GE.LOW) THEN
               IFCNT = IFCNT + 1
               C(N) = B(N)
            ELSE
               C(N) = A(N)
            ENDIF
405      CONTINUE
C
      ELSE
         IF (OPER(2:2).EQ.'C') THEN
            DO 410 N=1,NDIM
               IF (T(N).GE.LOW) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N)
               ELSE
                  C(N) = VAL(2)
               ENDIF
410         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'+') THEN
            DO 420 N=1,NDIM
               IF (T(N).GE.LOW) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N)
               ELSE
                  C(N) = BB(N) + VAL(2)
               ENDIF
420         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'-') THEN
            DO 430 N=1,NDIM
               IF (T(N).GE.LOW) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N)
               ELSE
                  C(N) = BB(N) - VAL(2)
               ENDIF
430         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'*') THEN
            DO 440 N=1,NDIM
               IF (T(N).GE.LOW) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N)
               ELSE
                  C(N) = BB(N) * VAL(2)
               ENDIF
440         CONTINUE
C
         ELSE IF (OPER(2:2).EQ.'/') THEN
            RVAL = 1. / VAL(2)
            DO 450 N=1,NDIM
               IF (T(N).GE.LOW) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N)
               ELSE
                  C(N) = BB(N) * RVAL
               ENDIF
450         CONTINUE
C
         ELSE
            DO 460 N=1,NDIM
               IF (T(N).GE.LOW) THEN
                  IFCNT = IFCNT + 1
                  C(N) = B(N)
               ELSE
                  C(N) = BB(N)
               ENDIF
460         CONTINUE
         ENDIF
C
         RETURN
      ENDIF
C
      END

C @(#)showopto.for	19.1 (ES0-DMD) 02/25/03 14:27:55
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C @(#)showopto.for	19.1 (ESO-IPG) 14:27:55 02/25/03
      PROGRAM SHOW_OPTO
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION: program SHOW_OPTO
C.PURPOSE: to show the current values of global keywords initialized in the
C.         OPTOPUS context.
C.AUTHOR: A. Gemmo             Padova Department of Astronomy
C.VERSION: 910521 A. Gemmo     Creation
C.VERSION: 910827 AG Modified
C-------------------------------------------------------------------------------
      IMPLICIT NONE
C
C ***
C
      INTEGER      MADRID(1)
      INTEGER      KUN,KNUL,ISTAT,IAV
      INTEGER      SHH1,SHH2,SMM1,SMM2
      INTEGER      HH,MM,DD,PP
      INTEGER      IND1,IND2,IND,CSIGN
C
C *** 
C
      REAL         RVAL(10)
C
C ***
C
      DOUBLE PRECISION       CRA(3),CDEC(3),CDEC1(3)
      DOUBLE PRECISION       ETIME
      DOUBLE PRECISION       LAM1,LAM2
      DOUBLE PRECISION       ST1,ST2
      DOUBLE PRECISION       ST
      DOUBLE PRECISION       SS,AA
      DOUBLE PRECISION       EQUI1,EQUI2
      DOUBLE PRECISION       YEAR,MONTH,DAY,EPP
C 
C *** 
C
      CHARACTER*80    STRING(20)
      CHARACTER*50    INFIL,OUTFIL
      CHARACTER*40    LBL
      CHARACTER*1     FLAG1,FLAG2,FLAG3,FLAG4
      CHARACTER*80    CVAL,DECCHA(3)
      CHARACTER*1     SIGN
C
C ***
C
      INCLUDE      'MID_INCLUDE:ST_DEF.INC'
      COMMON       /VMR/MADRID
      INCLUDE      'MID_INCLUDE:ST_DAT.INC'
C
C ***
C
      DATA         CSIGN/0/
      DATA         SIGN/'+'/
C
C *** start the code
C
      CALL STSPRO('SHOW_OPTO')
C
C *** do the work
C
C
C *** read input and output file
C
      CALL STKRDC('INPUTFI',1,1,50,IAV,INFIL,KUN,KNUL,ISTAT)
      CALL STKRDC('OUTPUTF',1,1,50,IAV,OUTFIL,KUN,KNUL,ISTAT)
C
C *** read coordinates of the center of the plate
C
      CALL STKRDD('PLATECEN',1,1,IAV,CRA(1),KUN,KNUL,ISTAT)
      CALL STKRDD('PLATECEN',2,1,IAV,CRA(2),KUN,KNUL,ISTAT)
      CALL STKRDD('PLATECEN',3,1,IAV,CRA(3),KUN,KNUL,ISTAT)
      CALL STKRDD('PLATECEN',4,1,IAV,CDEC(1),KUN,KNUL,ISTAT)
      CALL STKRDD('PLATECEN',5,1,IAV,CDEC(2),KUN,KNUL,ISTAT)
      CALL STKRDD('PLATECEN',6,1,IAV,CDEC(3),KUN,KNUL,ISTAT)
      CALL STKRDC('PLATECHA',1,1,80,IAV,CVAL,KUN,KNUL,ISTAT)
C
      IF(CVAL(1:8).EQ.'0.,0.,0.')THEN
        IF(CDEC(1).LT.0..OR.CDEC(2).LT.0..OR.CDEC(3).LT.0.)THEN
          CSIGN = 1
        ENDIF
        GOTO 616
      ENDIF
C
C *** decode character CVAL to real array
C
      IND1 = INDEX(CVAL,',')
      IND2 = INDEX(CVAL(IND1+1:80),',') + IND1
      DECCHA(1) = CVAL(1:IND1-1)
      DECCHA(2) = CVAL(IND1+1:IND2-1)
      DECCHA(3) = CVAL(IND2+1:80)
C
      CALL USRINP(RVAL(1),80,'R',DECCHA(1))
      CALL USRINP(RVAL(2),80,'R',DECCHA(2))
      CALL USRINP(RVAL(3),80,'R',DECCHA(3))
C
      CDEC(1) = DBLE(RVAL(1))
      CDEC(2) = DBLE(RVAL(2))
      CDEC(3) = DBLE(RVAL(3))
C
      IND = INDEX(CVAL,'-')
      IF(IND.NE.0)CSIGN = 1 
C
C *** convert to hhmmss and ddmmss if in decimal format
C
616   CDEC1(1) = DABS(CDEC(1))
      CDEC1(2) = DABS(CDEC(2))
      CDEC1(3) = DABS(CDEC(3))
C
      IF(CRA(2).EQ.0..AND.CRA(3).EQ.0.)THEN
        HH = INT(CRA(1))
        MM = INT((CRA(1)-HH)*60.)
        SS = ((CRA(1)-HH)*60.-MM)*60.
      ENDIF
C
      IF(CDEC(2).EQ.0..AND.CDEC(3).EQ.0.)THEN
        DD = INT(CDEC1(1))
        PP = INT((CDEC1(1)-DD)*60.)
        AA = ((CDEC1(1)-DD)*60.-PP)*60.
       IF(CSIGN.EQ.1)SIGN = '-'
      ENDIF
C
      IF(CRA(2).NE.0..OR.CRA(3).NE.0.)THEN
          HH = INT(CRA(1))
          MM = INT(CRA(2))
          SS = CRA(3)
      ENDIF
C
      IF(CDEC(2).NE.0..OR.CDEC(3).NE.0.)THEN
          DD = INT(CDEC1(1))
          PP = INT(CDEC1(2))
          AA = CDEC1(3)
          IF(CSIGN.EQ.1)SIGN='-'
      ENDIF
C
C *** read original and new equinox
C
      CALL STKRDD('EQUINOX',1,1,IAV,EQUI1,KUN,KNUL,ISTAT)
      CALL STKRDD('EQUINOX',2,1,IAV,EQUI2,KUN,KNUL,ISTAT)
C
C *** read plate label
C
      CALL STKRDC('LABEL',1,1,40,IAV,LBL,KUN,KNUL,ISTAT)
C
C *** read date of the observation, allowing for decimal date (i.e. YYYY.yyyyy) 
C
      CALL STKRDD('DATE',1,1,IAV,YEAR,KUN,KNUL,ISTAT)
      CALL STKRDD('DATE',2,1,IAV,MONTH,KUN,KNUL,ISTAT)
      CALL STKRDD('DATE',3,1,IAV,DAY,KUN,KNUL,ISTAT)
C
C *** read epoch 
C
      CALL STKRDD('EPOCH',1,1,IAV,EPP,KUN,KNUL,ISTAT)
C
C *** read exposure time
C
      CALL STKRDD('EXPTIME',1,1,IAV,ETIME,KUN,KNUL,ISTAT) 
C
C *** read wavelength range 
C
      CALL STKRDD('LAMBDA',1,1,IAV,LAM1,KUN,KNUL,ISTAT)
      CALL STKRDD('LAMBDA',2,1,IAV,LAM2,KUN,KNUL,ISTAT)
C
C *** read observation time slot (ST) 
C
      CALL STKRDD('STSLOT',1,1,IAV,ST1,KUN,KNUL,ISTAT)
      CALL STKRDD('STSLOT',2,1,IAV,ST2,KUN,KNUL,ISTAT)
C
C *** convert to hhmmss format
C
      SHH1 = INT(ST1)
      SMM1 = INT((ST1-SHH1)*60.)
C
      SHH2 = INT(ST2)
      SMM2 = INT((ST2-SHH2)*60.)
C
C *** read sidereal time of the observation
C
      CALL STKRDD('SIDTIME',1,1,IAV,ST,KUN,KNUL,ISTAT)
C
C *** read the value of automatic center (AC) calculation flag
C
      CALL STKRDC('ACFLAG',1,1,1,IAV,FLAG1,KUN,KNUL,ISTAT)
C
C *** read the value of automatic precession of the center flag
C
      CALL STKRDC('PFLAG',1,1,1,IAV,FLAG4,KUN,KNUL,ISTAT)
C
C *** read the value of automatic optimal ST calculation flag
C
      CALL STKRDC('ASTFLAG',1,1,1,IAV,FLAG2,KUN,KNUL,ISTAT)
C
C *** read value of E-W flip flag
C
      CALL STKRDC('EWFLAG',1,1,1,IAV,FLAG3,KUN,KNUL,ISTAT)
C
C *** start printing out values
C
      WRITE(STRING(13),110)
110   FORMAT(1X,'   ')
      CALL STTPUT(STRING(13),ISTAT)
      WRITE(STRING(14),1111)INFIL
1111  FORMAT(1X,'Input file:             ',A50)
      CALL STTPUT(STRING(14),ISTAT)
      WRITE(STRING(14),1112)OUTFIL
1112  FORMAT(1X,'Output file:            ',A50)
      CALL STTPUT(STRING(14),ISTAT)
      WRITE(STRING(1),111)LBL
111   FORMAT(1X,'Plate label:            ',A40)
      CALL STTPUT(STRING(1),ISTAT)
      WRITE(STRING(2),112)HH,MM,SS,SIGN,DD,PP,AA
112   FORMAT(1X,'Plate center:           R.A.: ',I2,'h ',I2,'m ',F6.3,
     1          's ',' DEC.: ',A1,I2,'d ',I2,'` ',F5.2,'"')
      CALL STTPUT(STRING(2),ISTAT)
      WRITE(STRING(3),222)EQUI1,EQUI2
222   FORMAT(1X,'Equinoxes:              Old:  ',F10.5,' New: ',F10.5)
      CALL STTPUT(STRING(3),ISTAT)
      WRITE(STRING(4),333)YEAR,MONTH,DAY,EPP
333   FORMAT(1X,'Date:                   Year: ',F10.5,' Month: ',F3.0,
     1          ' Day: ',F3.0,' Epoch: ',F10.5)
      CALL STTPUT(STRING(4),ISTAT)
      WRITE(STRING(5),444)ETIME
444   FORMAT(1X,'Exposure time:          ',F6.2,' m')
      CALL STTPUT(STRING(5),ISTAT)
      WRITE(STRING(6),555)LAM1,LAM2
555   FORMAT(1X,'Wavelength range:       from: ',F5.0,
     1          ' Angstrom',' to:',F5.0,' Angstrom')
      CALL STTPUT(STRING(6),ISTAT)
      WRITE(STRING(7),666)SHH1,SMM1,SHH2,SMM2
666   FORMAT(1X,'Optimal sid. time slot: from: ',I2,'h ',I2,'m ',
     1          'to: ',I2,'h ',I2,'m')
      CALL STTPUT(STRING(7),ISTAT)
      WRITE(STRING(9),888)ST
888   FORMAT(1X,'Optimal sid. time:      ',F6.2,' h')
      CALL STTPUT(STRING(9),ISTAT)
      WRITE(STRING(11),1009)FLAG1
1009  FORMAT(1X,'ACFLAG:                 ',A1)
      CALL STTPUT(STRING(11),ISTAT)
      WRITE(STRING(11),1010)FLAG4
1010  FORMAT(1X,'PFLAG:                  ',A1)
      CALL STTPUT(STRING(11),ISTAT)
      WRITE(STRING(11),1011)FLAG2
1011  FORMAT(1X,'ASTFLAG:                ',A1)
      CALL STTPUT(STRING(11),ISTAT)
      WRITE(STRING(11),1012)FLAG3
1012  FORMAT(1X,'EWFLAG:                 ',A1)
      CALL STTPUT(STRING(11),ISTAT)
C
C *** over and out
C
      CALL STSEPI
      END

C @(#)mnag.for	19.1 (ES0-DMD) 02/25/03 13:30:47
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE E04GAF(M, N, X, F, SS, E, MODE, D, W, IW, FUNCT,LSQ,
     * MONIT, IPRINT, MAXFUN, IFAIL)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENT  subroutine  E04GAF		modified by A. Lauberts  11.10.1985
C
C     MARK 4 RE-ISSUE. NAG COPYRIGHT 1974
C     MARK 5C REVISED
C     MARK 6B REVISED  IER-118 (SEP 1978)
C---------------------------------------------------------------------------
      INTEGER PAR1, PAR2, PAR3, PAR4, PAR5, PAR6, P01AAF, N, I, M,
     *MAXFUN, IFAIL, IW, MODE, NN, NWA, NWV, NWT, NWU, NWS, NWW,IERR,
     * IR, IT, NA, NWTI, IPRINT, NB, NWUI, JJ, NWWI, NWSI,NWVI, J, II,
     * NWTJ, ND, NDJ
      DOUBLE PRECISION ACC, RHO, SIG, Q, QC, SS, Z, VW, DQ, SSP,DS,
     * Y, TR, X(N), F(M), W(IW), D(N), E(N), X02AAF
      EXTERNAL   FUNCT, LSQ, MONIT
C
      LOGICAL IFL, CHECK
C
C     E04GAF IS BASED ON HARWELL SUBROUTINE VA07A (SEE 'A MODIFIED
C     MARQU
C     SUBROUTINE FOR NON-LINEAR LEAST SQUARES' BY R. FLETCHER,
C     HARWELL R
C     AERE-R6799, H.M.S.O. (MAY,1971)). IT IS NOT QUITE A
C     STRAIGHTFORWAR
C     TRANSLATION, AS CERTAIN CHANGRS HAVE BEEN MADE IN ORDER TO
C     CONFORM
C     CONVENTIONS, AND TO USE OTHER NAG ROUTINES.
C     ALL PRINTING HAS BEEN REMOVED. IT IS ASSUMED THAT THE USER WI
C     SUPPLY A PROCEDURE MONIT WHICH WILL BE CALLED ONCE EVERY
C     IPRINT IT
C     - IF IPRINT <=0, MONIT IS NOT CALLED. INSTEAD OF PRINTING
C     ERROR MA
C     E04GAF SETS THE ERROR INDICATOR IFAIL.
C     E04GAZ IS USED FOR THE FORMATION OF INNER PRODUCTS , AND F03A
C     F04AGF ARE USED TO SOLVE THE MARQUARDT EQUATIONS.
C     SO E0JGAF ASSUMES THAT LSQ SETS THE UPPER TRIANGLE OF A, UNLIK
C     WHICH ASSUMES THAT THE LOWER TRIANGLE IS GIVEN. THUS ,
C     THROUGHOUT
C     A REFERENCE TO A(I,J), SAY, CORRESPONDS TO A(J,I) IN THE
C     ORIGINAL.
C     THERE ARE NO MACHINE DEPENDENT CONSTANTS IN THE BODY OF E04GA
C     HOWEVER, ITS BEHAVIOUR MAY BE AFFECTED BY THE ACCURACY OF THE
C     MACH
C     (AND TO A LESSER EXTENT BY THE WAY IN WHICH ARITHMETIC
C     EXPRESSIONS
C     COMPILED AND EXECUTED).
C     W IS USED TO STORE MOST OF THE INTERNAL ARRAYS OF VA07A
C--------------------------------------------------------------------
C
      IF (N.LT.1) GO TO 40
      ACC = X02AAF(1.0D0)
      CHECK = .FALSE.
      DO 20 I=1,N
         CHECK = CHECK .OR. E(I).LT.ACC
         IF (MODE.NE.3) GO TO 20
         CHECK = CHECK .OR. D(I).LT.ACC
   20 CONTINUE
      IF (M.GE.1 .AND. MAXFUN.GE.1 .AND. (IFAIL.EQ.0 .OR.IFAIL.EQ.1) .
     *AND. IW.GE.N*(N+4)+M .AND. .NOT. CHECK) GO TO 60
   40 IFAIL = P01AAF(IFAIL,1)
      RETURN
   60 IF (MODE.NE.1 .AND. MODE.NE.2 .AND. MODE.NE.3) MODE = 1
      NN = N*N
      NWA = 0
      NWV = NN
      NWT = NWV + N
      NWU = NWT + N
      NWS = NWU + N
      NWW = NWS + N
      IERR = 0
      RHO = .25D0
      SIG = .75D0
      Q = 0.D0
      QC = 1.D0
      IFL = .FALSE.
      CALL FUNCT(M, N, X, F, IFL)
      IF (.NOT.IFL) GO TO 80
      IERR = 3
      GO TO 860
   80 CONTINUE
      IR = 1
      CALL E04GAZ(F, M, 1, 2, F, M, 1, 2, 0.0D0, SS, M, 4)
      CALL LSQ(M, N, X, F, W(NWA+1), W(NWV+1))
      IT = 0
      IF (MODE.EQ.3) GO TO 120
      IF (MODE.EQ.2) GO TO 160
      NA = NWA - N
      DO 100 I=1,N
         NA = NA + N + 1
         D(I) = W(NA)
         IF (D(I).LE.0.D0) D(I) = 1.D0
  100 CONTINUE
  120 CONTINUE
      DO 140 I=1,N
         NWTI = NWT + I
         W(NWTI) = DSQRT(D(I))
  140 CONTINUE
      GO TO 200
  160 CONTINUE
      DO 180 I=1,N
         NWTI = NWT + I
         W(NWTI) = 1.D0
         D(I) = 1.D0
  180 CONTINUE
  200 CONTINUE
      IF (IPRINT.LE.0) GO TO 220
      IF (MOD(IT,IPRINT).NE.0) GO TO 220
      CALL MONIT(M, N, X, F, SS, W(NWV+1), IR)
  220 CONTINUE
      IT = IT + 1
      NB = NWA - N
      DO 240 I=1,N
         NB = NB + N + 1
         NWUI = NWU + I
         W(NWUI) = W(NB)
         IF (W(NWUI).GE.0.0D0) GO TO 240
         IERR = 4
         GO TO 800
  240 CONTINUE
  260 CONTINUE
      NA = NWA - N
      DO 280 I=1,N
         NA = NA + N + 1
         NWUI = NWU + I
         W(NA) = W(NWUI) + Q*D(I)
  280 CONTINUE
      JJ = 1
      CALL F03AEF(N, W(NWA+1), N, W(NWW+1), Z, I, JJ)
C     W NOW CONTAINS THE RECIPROCALS OF THE DIAGONAL ELEMENTS OF
C     THE CHO
C     FACTORS.
      IF (JJ.EQ.0) GO TO 300
      Q = 2.D0*Q
      IF (Q.EQ.0.D0) Q = 1.D0
      GO TO 260
  300 CONTINUE
      CALL F04AGF(N, 1, W(NWA+1), N, W(NWW+1), W(NWV+1), N,W(NWS+1), N)
C     THE DIAGONAL ELEMENTS OF A ARE NOW THE RECIPROCALS OF THE
C     THOSE TH
C     WOULD BE PRODUCED BY THE ORIGINAL VA07A
      NA = NWA - N
      DO 320 I=1,N
         NA = NA + N + 1
         NWWI = NWW + I
         NWSI = NWS + I
         W(NA) = W(NWWI)
         W(NWWI) = W(NWSI)
  320 CONTINUE
      CALL E04GAZ(W(NWV+1), N, 1, 2, W(NWW+1), M, 1, 2, 0.0D0, VW, N,4)
      IF (VW.GT.0.D0) GO TO 340
      IERR = 5
      GO TO 800
  340 DO 360 I=1,N
         NWUI = NWU + I
         NWWI = NWW + I
         Z = W(NWUI)*W(NWWI)
         PAR1 = (I-1)*N + 1
         PAR2 = PAR1 + 1
         PAR3 = I*(N+1)
         PAR4 = PAR3 + N
         PAR5 = I + 1
         PAR6 = I + 2
         IF (I.GT.1) CALL E04GAZ(W(NWA+1), NN, PAR1, PAR2,W(NWW+1), M,
     *    1, 2, Z, Z, I-1, 4)
         IF (I.LT.N) CALL E04GAZ(W(NWA+1), NN, PAR3, PAR4,W(NWW+1), M,
     *    PAR5, PAR6, Z, Z, N-I, 4)
         NWSI = NWS + I
         NWVI = NWV + I
         W(NWSI) = 2.0D0*W(NWVI) - Z
  360 CONTINUE
      DQ = 0.D0
      CALL E04GAZ(W(NWS+1), N, 1, 2, W(NWW+1), M, 1, 2, 0.0D0, DQ, N,4)
      J = 0
      DO 380 I=1,N
         NWWI = NWW + I
         NWSI = NWS + I
         IF (DABS(W(NWWI)).GT.E(I)) J = 1
         W(NWSI) = X(I) - W(NWWI)
  380 CONTINUE
      IFL = .FALSE.
      CALL FUNCT(M, N, W(NWS+1), W(NWW+1), IFL)
      IF (IFL) GO TO 440
C 390 CONTINUE
      CONTINUE
      IR = IR + 1
      CALL E04GAZ(W(NWW+1), M, 1, 2, W(NWW+1), M, 1, 2, 0.0D0, SSP,M, 4)
      DS = SS - SSP
C     ONLY THE DIAGONAL ELEMENTS OF A HAVE BEEN CHANGED SINCE
C     F04AGF WAS
C     SO , IF AN EXIT IS MADE, ONLY THE DIAGONAL ELEMENTS NEED TO
C     BE RES
      IF (J.EQ.0) GO TO 740
C     NOTICE THAT E04GAF USES IFAIL TO DISTINGUISH BETWEEN
C     DIFFERENT TYP
C     EXIT.
      IF (DQ.GT.0.0D0) GO TO 400
      IERR = 5
      GO TO 740
  400 CONTINUE
      IF (IR.LT.MAXFUN) GO TO 420
      IERR = 2
      GO TO 740
  420 CONTINUE
      IF (DS.GE.RHO*DQ) GO TO 660
      Y = .5D0
      Z = 2.D0*VW - DS
      IF (Z.GT.0.D0) Y = VW/Z
      IF (Y.GT..5D0) Y = .5D0
      IF (Y.LT..1D0) Y = .1D0
      GO TO 460
  440 Y = .1D0
      DS = 0.D0
  460 CONTINUE
      IF (Q.NE.0.D0) GO TO 640
C     THE DIAGONAL ELEMENTS OF A ARE ALREADY THE RECIPROCALS OF
C     THOSE TH
C     BE PRODUCED BY VA07A. SO, 2 LINES HAVE BEEN OMMITTED HERE IN
C     THE
C     TRANSLATION .
      Y = 2.D0*Y
      NB = NWA + 1
      DO 500 I=2,N
         II = I - 1
         NA = NWA + I - N
         NB = NB + N + 1
         DO 480 J=1,II
            PAR1 = (J-1)*N + J
            PAR2 = PAR1 + 1
            PAR3 = (J-1)*N + I
            PAR4 = PAR3 + N
            CALL E04GAZ(W(NWA+1), NN, PAR1, PAR2, W(NWA+1), NN,PAR3,
     *       PAR4, 0.0D0, Z, I-J, 3)
            Z = -Z
            NA = NA + N
            W(NA) = Z*W(NB)
  480    CONTINUE
  500 CONTINUE
      DO 540 I=1,N
         NA = NWA + (I-1)*(N+1)
         DO 520 J=I,N
            PAR1 = (I-1)*N + J
            PAR2 = PAR1 + 1
            PAR3 = (J-1)*N + J
            PAR4 = PAR3 + 1
            CALL E04GAZ(W(NWA+1), NN, PAR1, PAR2, W(NWA+1), NN,PAR3,
     *       PAR4, 0.0D0, Z, N-J+1, 4)
            NA = NA + 1
            W(NA) = DABS(Z)
  520    CONTINUE
  540 CONTINUE
      Q = 0.D0
      TR = 0.D0
      NA = NWA - N
      DO 620 I=1,N
         NA = NA + N + 1
         TR = TR + W(NA)*D(I)
         Z = 0.D0
         NB = NWA + I - N
         DO 560 J=1,I
            NB = NB + N
            NWTJ = NWT + J
            Z = Z + W(NB)*W(NWTJ)
  560    CONTINUE
         IF (I.EQ.N) GO TO 600
         II = I + 1
         ND = NWA + (I-1)*N
         DO 580 J=II,N
            NWTJ = NWT + J
            NDJ = ND + J
            Z = Z + W(NDJ)*W(NWTJ)
  580    CONTINUE
  600    CONTINUE
         NWTI = NWT + I
         Z = Z*W(NWTI)
         IF (Z.GT.Q) Q = Z
  620 CONTINUE
      IF (TR.LT.Q) Q = TR
      Q = 1.D0/Q
      QC = Q
  640 CONTINUE
      Q = Q/Y
      IF (DS) 260, 260, 680
  660 CONTINUE
      IF (DS.LE.SIG*DQ) GO TO 680
      Q = Q*.5D0
      IF (Q.LT.QC) Q = 0.D0
  680 CONTINUE
      SS = SSP
      DO 700 I=1,N
         NWSI = NWS + I
         X(I) = W(NWSI)
  700 CONTINUE
      DO 720 I=1,M
         NWWI = NWW + I
         F(I) = W(NWWI)
  720 CONTINUE
      CALL LSQ(M, N, X, F, W(NWA+1), W(NWV+1))
      GO TO 200
  740 CONTINUE
      IF (DS.LE.0.D0) GO TO 800
      SS = SSP
      DO 760 I=1,N
         NWSI = NWS + I
         X(I) = W(NWSI)
  760 CONTINUE
      DO 780 I=1,M
         NWWI = NWW + I
         F(I) = W(NWWI)
  780 CONTINUE
  800 CONTINUE
      NA = NWA - N
C     RESTORE THE DIAGONAL ELEMENTS OF A.
      DO 820 I=1,N
         NA = NA + N + 1
         NWUI = NWU + I
         W(NA) = W(NWUI)
  820 CONTINUE
      IF (IERR) 840, 840, 860
  840 IFAIL = 0
      GO TO 880
  860 IFAIL = P01AAF(IFAIL,IERR)
  880 RETURN
      END


      SUBROUTINE E04GAZ(A, M1, I, J, B, M2, K, L, X, SUM, N, IFLAG)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENT subroutine E04GAZ
C
C     MARK 2 RELEASE. NAG COPYRIGHT 1972
C---------------------------------------------------------------
      INTEGER M, N, MM, I, J, K, L, IFLAG, M1, M2
C
      DOUBLE PRECISION SX, AX, BX, XX
      DOUBLE PRECISION X, SUM, A(M1), B(M2)
      SX = 0.0D0
      DO 20 M=1,N
         MM = I + (M-1)*(J-I)
         AX = A(MM)
         MM = K + (M-1)*(L-K)
         BX = B(MM)
         SX = SX + AX*BX
   20 CONTINUE
      XX = X
      M = IFLAG + 1
      GO TO (40, 60, 80, 100, 40, 60, 80, 100), M
   40 SX = SX + XX
      GO TO 120
   60 SX = XX - SX
      GO TO 120
   80 SX = SX - XX
      GO TO 120
  100 SX = -SX - XX
  120 SUM = SX
      RETURN
      END


      SUBROUTINE F03AEF(N, A, IA, P, D1, ID, IFAIL)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENT subroutine F03AEF
C
C     MARK 2 RELEASE. NAG COPYRIGHT 1972
C     MARK 3 REVISED.
C     MARK 4.5 REVISED
C
C     CHOLDET1
C     THE UPPER TRIANGLE OF A POSITIVE DEFINITE SYMMETRIC MATRIX,
C     A, IS STORED IN THE UPPER TRIANGLE OF AN N*N ARRAY A(I,J),
C     I=1,N, J=1,N. THE CHOLESKY DECOMPOSITION A = LU, WHERE
C     U IS THE TRANSPOSE OF L, IS PERFORMED AND STORED IN THE
C     REMAINDER OF THE ARRAY A EXCEPT FOR THE RECIPROCALS OF THE
C     DIAGONAL ELEMENTS WHICH ARE STORED IN P(I), I = 1,N,
C     INSTEAD OF THE ELEMENTS THEMSELVES. A IS RETAINED SO THAT
C     THE SOLUTION OBTAINED CAN BE SUBSEQUENTLY IMPROVED. THE
C     DETERMINANT, D1 * 2.0**ID, OF A IS ALSO COMPUTED. THE
C     SUBROUTINE
C     WILL FAIL IF A, MODIFIED BY THE ROUNDING ERRORS, IS NOT
C     POSITIVE DEFINITE.
C     1ST DECEMBER 1971
C----------------------------------------------------------------------
      INTEGER ISAVE, IFAIL, IFAIL1, ID, I, N, ISTART, J, IA, P01AAF
C
      DOUBLE PRECISION D1, X, D2, P(N), A(IA,N)
      ISAVE = IFAIL
      IFAIL1 = 0
      D1 = 1.0D0
      ID = 0
      DO 120 I=1,N
         ISTART = I
         DO 100 J=ISTART,N
            CALL X03AAF(A(I,1), IA*N+1-I, A(J,1), IA*N+1-J, I-1,IA, IA,
     *       -A(I,J), 0.0D0, X, D2, .FALSE., IFAIL1)
            X = -X
            IF (J.NE.I) GO TO 80
            D1 = D1*X
            IF (X.LE.0.0D0) GO TO 140
   20       IF (DABS(D1).LT.1.0D0) GO TO 40
            D1 = D1*0.0625D0
            ID = ID + 4
            GO TO 20
   40       IF (DABS(D1).GE.0.0625D0) GO TO 60
            D1 = D1*16.0D0
            ID = ID - 4
            GO TO 40
   60       P(I) = 1.0D0/DSQRT(X)
            GO TO 100
   80       A(J,I) = X*P(I)
  100    CONTINUE
  120 CONTINUE
      IFAIL = 0
      RETURN
  140 IFAIL = P01AAF(ISAVE,1)
      RETURN
      END


      SUBROUTINE F04AGF(N, IR, A, IA, P, B, IB, X, IX)
C.IDENT subroutine F04AGF
C
C     MARK 2 RELEASE. NAG COPYRIGHT 1972
C     MARK 4.5 REVISED
C     CHOLSOL1
C     SOLVES AX=B, WHERE A IS A POSITIVE DEFINITE SYMMETRIC MATRIX
C     AND B IS AN N*IR MATRIX OF IR RIGHT-HAND SIDES. THE
C     SUBROUTINE
C     F04AGF MUST BY PRECEDED BY F03AEF IN WHICH L IS
C     PRODUCED IN A(I,J) AND P(I), FROM A. AX=B IS SOLVED IN TWO
C     STEPS, LY=B AND UX=Y, AND X IS OVERWRITTEN ON Y.
C     1ST AUGUST 1971
C-----------------------------------------------------------------------
      INTEGER IFAIL1, J, IR, I, N, I1, IA, IX, II, IB
      DOUBLE PRECISION D1, D2, A(IA,N), P(N), B(IB,IR), X(IX,IR)
      IFAIL1 = 0
      DO 60 J=1,IR
C     SOLUTION OF LY= B
         DO 20 I=1,N
            I1 = I - 1
            CALL X03AAF(A(I,1), IA*N-I+1, X(1,J), (IR-J+1)*IX, I1,IA, 1,
     *       B(I,J), 0.0D0, D1, D2, .FALSE., IFAIL1)
            X(I,J) = -P(I)*D1
   20    CONTINUE
C     SOLUTION OF UX= Y
         X(N,J) = -P(N)*X(N,J)
         IF (N.EQ.1) GO TO 60
         DO 40 II=2,N
            I = N - II + 1
            I1 = I + 1
            CALL X03AAF(A(I1,I), (N-I+1)*IA-I, X(I1,J),(IR-J+1)*IX-I, N-
     *      I, 1, 1, X(I,J), 0.0D0, D1, D2, .FALSE.,IFAIL1)
            X(I,J) = -P(I)*D1
   40    CONTINUE
   60 CONTINUE
      RETURN
      END


      INTEGER FUNCTION P01AAF(IFAIL, ERROR)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENT integer function P01AAF
C
C     MARK 1 RELEASE.  NAG COPYRIGHT 1971
C     MARK 3 REVISED
C     MARK 4A REVISED, IER-45
C     MARK 4.5 REVISED
C     MARK 7 REVISED (DEC 1978)
C     RETURNS THE VALUE OF ERROR, REVISED (AL, NOV 1982)
C------------------------------------------------------------------
      INTEGER ERROR, IFAIL, NOUT
C
C     TEST IF NO ERROR DETECTED
      IF (ERROR.EQ.0) GO TO 20
C     DETERMINE OUTPUT UNIT FOR MESSAGE
      CALL X04AAF (0,NOUT)
C     TEST FOR SOFT FAILURE
      IF (MOD(IFAIL,10).EQ.1) GO TO 10
C     HARD FAILURE
C     WRITE (NOUT,99999) ERROR
C     STOPPING MECHANISM NOT APPLIED (REVISED/AL)
C     CALL P01AAZ
      P01AAF=0                                     ! inserted RHW
      RETURN
C     SOFT FAIL
C     TEST IF ERROR MESSAGES SUPPRESSED
   10 IF (MOD(IFAIL/10,10).EQ.0) GO TO 20
C     WRITE (NOUT,99999) ERROR
   20 P01AAF = ERROR
      RETURN
C99999FORMAT (1H0, 38HERROR_DETECTED_BY_LIBRARY_ROUTINE_, A8,
C    * 11H - IFAIL = , I5//)
      END


      DOUBLE PRECISION FUNCTION X02AAF(X)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENT double precision function X02AAF
C
C     NAG COPYRIGHT 1975
C     MARK 4.5 RELEASE
C-----------------------------------------------------------------
      DOUBLE PRECISION X
C+
C     * EPS *
C     RETURNS THE VALUE EPS WHERE EPS IS THE SMALLEST
C     POSITIVE
C     NUMBER SUCH THAT 1.0 + EPS > 1.0
C     THE X PARAMETER IS NOT USED
C     FOR DEC VAX 11/780
C     X02AAF = 2.0**(-56.0)
C-
      X02AAF = 2.0D0**(-55)
      RETURN
      END


      SUBROUTINE X03AAF(A, ISIZEA, B, ISIZEB, N, ISTEPA, ISTEPB,C1, C2,
     * D1, D2, SW, IFAIL)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENT subroutine X03AAF
C
C     NAG COPYRIGHT 1975
C     MARK 4.5 RELEASE
C     MARK 6 REVISED
C
C     CALCULATES THE VALUE OF A SCALAR PRODUCT USING BASIC
C     OR ADDITIONAL PRECISION AND ADDS IT TO A BASIC OR ADDITIONAL
C     PRECISION INITIAL VALUE.
C--------------------------------------------------------------------
C.... DELETE THIS LINE WHEN ADDITIONAL PRECISION HAS BEEN DEALT WITH
      INTEGER P01AAF, ISAVE, ISIZEA, ISIZEB, ISTEPA, ISTEPB, IFAIL,IS,
     * IT, N, I
C
      DOUBLE PRECISION SUM
      DOUBLE PRECISION A(ISIZEA), B(ISIZEB), C1, C2, D1, D2, X
      LOGICAL SW
      ISAVE = IFAIL
      IFAIL = 0
      IF (ISTEPA.GT.0 .AND. ISTEPB.GT.0) GO TO 20
      IFAIL = P01AAF(ISAVE,1)
      RETURN
   20 IS = 1 - ISTEPA
      IT = 1 - ISTEPB
      IF (SW) GO TO 80
      X = 0.0D0
      IF (N.LT.1) GO TO 60
      DO 40 I=1,N
         IS = IS + ISTEPA
         IT = IT + ISTEPB
         X = X + A(IS)*B(IT)
   40 CONTINUE
   60 D1 = X + (C1+C2)
      D2 = 0.0D0
      RETURN
C
   80 SUM = 0.0D0
      IF (N.LT.1) GO TO 120
      DO 100 I=1,N
         IS = IS + ISTEPA
         IT = IT + ISTEPB
C
C        SUM = SUM + DBLE(A(IS))*B(IT)
         SUM = SUM + (A(IS))*B(IT)
  100 CONTINUE
C
C 120 SUM = SUM + (DBLE(C1)+C2)
  120 SUM = SUM + ((C1)+C2)
C
C     D1 = SUM + SUM - DBLE(SNGL(SUM))
      D1 = SUM + SUM - ((SUM))
C     THE LAST STATEMENT ASSUMES THAT THE MACHINE SIMPLY
C     TRUNCATES WHEN ASSIGNING A DOUBLE PRECISION QUANTITY
C     TO A SINGLE PRECISION VARIABLE. IF INSTEAD THE MACHINE
C     ROUNDS, REPLACE THE LAST STATEMENT BY
C     D1 = SUM
      D2 = SUM - D1
      RETURN
      END


      SUBROUTINE X04AAF(I,NERR)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENT subroutine X04AAF
C
C     MARK 7 RELEASE. NAG COPYRIGHT 1978
C     MARK 7C REVISED IER-190 (MAY 1979)
C     IF I = 0, SETS NERR TO CURRENT ERROR MESSAGE UNIT NUMBER
C     (STORED IN NERR1).
C     IF I = 1, CHANGES CURRENT ERROR MESSAGE UNIT NUMBER TO
C     VALUE SPECIFIED BY NERR.
C
C     *** NOTE ***
C     THIS ROUTINE ASSUMES THAT THE VALUE OF NERR1 IS SAVED
C     BETWEEN CALLS.  IN SOME IMPLEMENTATIONS IT MAY BE
C     NECESSARY TO STORE NERR1 IN A LABELLED COMMON
C     BLOCK /AX04AA/ TO ACHIEVE THIS.
C-------------------------------------------------------------------
C     .. SCALAR ARGUMENTS ..
      INTEGER I, NERR
C     ..
C     .. LOCAL SCALARS ..
      INTEGER NERR1
C     ..
      DATA NERR1 /6/
      IF (I.EQ.0) NERR = NERR1
      IF (I.EQ.1) NERR1 = NERR
      RETURN
      END

C @(#)ftdivt.for	19.1 (ES0-DMD) 02/25/03 13:17:34
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C @(#)ftdivt.for	2.1.1.1 (ESO-IPG) 9/27/91 18:08:44
      SUBROUTINE FTDIVT(NAME,IVAR,ISTAT)                                        
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                   
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:25 - 13 JAN 1988                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C.IDENTIFICATION                                                                
C                                                                               
C  FITLIB.FOR   VERSION 1.0  27 MAR 1984                                        
C                                                                               
C.PURPOSE                                                                       
C                                                                               
C  INTERFACE ROUTINES FOR THE FITTING STRUCTURES                                
C                                                                               
C.ALGORITHM                                                                     
C                                                                               
C  USE MIDAS I/O INTERFACES TO FRAMES AND TABLES                                
C                                                                               
C.KEYWORDS                                                                      
C                                                                               
C  NON LINEAR FITTING                                                           
C                                                                               
C MODIF MP apr 92: make compute/fit table funct(:x,:y) working   
C----------------------------------------------------------------               
C                                                                               
C DEFINE NEW INDEPENDENT VARIABLES AS COLUMNS IN A TABLE                        
C      IMPLICIT NONE                                                            
C                                                                               
C INPUT PARAMETERS                                                              
C NAME CHAR TABLE NAME                                                          
C IVAR CHAR COLUMNS ACTING AS IND.VARS                                          
C                                                                               
C OUTPUT PARAMETERS                                                             
C ISTAT INTG STATUS RETURN                                                      
C                                                                               
      INTEGER ISTAT,IND2,KZ6952
      CHARACTER*(*) NAME,IVAR                                                   
      CHARACTER*80 LINE,LINE1                                                   
      CHARACTER*8 NAME1                                                         
      CHARACTER*17 LAB1
      LOGICAL NEXT                                                              
       INCLUDE 'MID_INCLUDE:FITI.INC/NOLIST'                                     
       INCLUDE 'MID_INCLUDE:FITC.INC/NOLIST'                                     
C                                                                               
C READ TABLE                                                                    
C                                                                               
      NAME1  = NAME                                                             
      IF (FZMAPPED.EQ.1 .AND. FZTYPE.EQ.'TBL ') THEN                        
          IF (FZNAME(1:8).NE.NAME1) THEN  !   TABLE MUST BE THE SAME          
              ISTAT  = FERTAB                                               
              RETURN                                                            
                                                                                
          END IF                                                                
                                                                                
      ELSE                                                                      
          IF (FZMAPPED.EQ.0) THEN                                             
              CALL TBTOPN(NAME,2,FZIDEN,ISTAT)                                           
              FZMAPPED = 1                                                    
              FZNAME = NAME                                                   
              FZTYPE = 'TBL '                                                 
          END IF                                                                
                                                                                
      END IF                                                                    
C                                                                               
C DECODE INDEPENDENT VARIABLES                                                  
C                                                                               
      IND2   = INDEX(IVAR,' ') - 1                                              
      LINE   = IVAR(1:IND2)//','                                             
C      LINE = IVAR(1:IND2)
      IND2   = INDEX(LINE,',')                                               
      NEXT   = .TRUE.                                                           
      FZNIND = 0                                                              
      KZ6952 = 0
10    KZ6952 = KZ6952 + 1
      IF ( .NOT. (NEXT)) GO TO 20                                           
C                                                                               
C   LAB1 CONTAINS NEXT LABEL                                                    
C                                                                               
      LAB1   = LINE(1:IND2-1)                                            
      LINE1  = LINE(IND2+1:)                                                
      LINE   = LINE1                                                        
      FZNIND = FZNIND + 1                                               
      CALL TBCSER(FZIDEN,LAB1,FZIVAR(FZNIND),ISTAT)                       
      IF (FZIVAR(FZNIND).EQ.-1) THEN                                    
         ISTAT  = FERPAR                                               
         RETURN                                                            
      END IF                                                                
C
      IND2   = INDEX(LINE,',')                                           
      NEXT   = IND2 .NE. 0                                                  
      GOTO 10
C 
   20 CONTINUE                                                                  
C                                                                               
C INITIALIZE VARIABLES IN THE COMMON AREA                                       
C                                                                               
      FZNAME = NAME                                                           
      FZTYPE = 'TBL '                                                         
      FZMAPPED = 1                                                            
      RETURN                                                                    
                                                                                
      END                                                                       

C @(#)rdcrin.for	19.1 (ES0-DMD) 02/25/03 13:25:38
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine RDCRIN         version 1.1       831011
C  A. Kruszewski             ESO Garching
C.PURPOSE
C  reads descriptor "STARS" containing physical coordinates of
C  stars which are suitable for determining standard
C  point spread function, converts physical coordinates into
C  pixel coordinates and identifies these stars with detected
C  objects
C.INPUT/OUTPUT
C  input arguments
C  NCAT        integer*4 array   array holding integer data on
C                                objects, NCAT(1,*) is equal to
C                                X-pixel coordinate
C                                N(2,*) is Y-pixel coordinate
C  M           integer*4         number of objects
C  output arguments
C  NKK         integer*4 array   array holding identification numbers
C                                of identified objects
C  NSTS        integer*4         number of standard stars which are
C                                identified with objects
C-----------------------------------------------------------------------
      SUBROUTINE RDCRIN(IMF, NCAT, M, NKK, NSTS)
C
      IMPLICIT NONE
      INCLUDE 'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER   IMF
      INTEGER   M
      INTEGER   NCAT(NIPAR,M)
      INTEGER   NKK(MPSF)
      INTEGER   NSTS
C
      INTEGER   ISTAT, IACT
      INTEGER   IC(MPSF)
      INTEGER   IDX, IDY, IDIS
      INTEGER   K, KK
      INTEGER   KUN, KNUL
      INTEGER   L
      INTEGER   NK(MPSF)
      INTEGER   NN, NSTR1, NSTR2
C
      REAL   STST(3*MPSF)
C
      DOUBLE PRECISION   START(2) , STEP(2)
C
C ******      Read descriptor STARS containing
C ******      coordinates of standard stars.
C
      CALL STDRDR( IMF , 'STARS' , 1 , 3*MPSF , IACT , STST , KUN ,
     &                                          KNUL , ISTAT )
C
C ******      Find number of standard stars.
C
      KK = IACT/3
C
C ******      Read descriptors START and STEP.
C
      CALL STDRDD( IMF , 'START' , 1 , 2 , IACT , START , KUN ,
     &                                          KNUL , ISTAT )
      CALL STDRDD( IMF , 'STEP' , 1 , 2 , IACT , STEP , KUN ,
     &                                          KNUL , ISTAT )
C
C ******      Perform identification of standard stars
C ******      with objects listed in array NCAT.
C
      DO 20 K = 1 , KK
          IC(K) = 0
          NK(K) = 0
          NSTR1 = NINT( (DBLE(STST(K*3-2))-START(1)) / STEP(1) ) + 1
          NSTR2 = NINT( (DBLE(STST(K*3-1))-START(2)) / STEP(2) ) + 1
          DO 10 L = 1 , M
            IDX = NSTR1 - NCAT(1,L)
            IDY = NSTR2 - NCAT(2,L)
            IDIS = IDX*IDX + IDY*IDY
            IF (IDIS.LT.9) THEN
                IC(K) = IC(K) + 1
                NK(K) = L
            ENDIF
   10          CONTINUE
   20      CONTINUE
C
C ******      Check if each standard star has been
C ******      identified with one and only one object.
C
      NN = 0
      DO 30 K = 1 , KK
          IF (IC(K).EQ.1) THEN
            NN = NN + 1
            NKK(NN) = NK(K)
          ENDIF

   30      CONTINUE
C
C ******      NSTS is a number of succesfully identified objects.
C
      NSTS   = NN
      IF (NSTS.LT.1) THEN
         CALL STTPUT(' No standard stars identified',ISTAT)
      ENDIF
C
      RETURN
C
      END

C @(#)gd8g.for	19.1 (ES0-DMD) 02/25/03 13:55:08
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
	SUBROUTINE
     +	GD8021(DISPLAY,CHAN,XFIG,YFIG,NDIM,INTENS,STYLE,IDST)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine IIGPLY		version 1.00	880627
C  K. Banse                  	ESO - Garching
C  					1.20	890215
C
C.KEYWORDS
C  DeAnza, overlay graphics
C
C.PURPOSE
C  draw a graph in graphics memory according to IDI decoument (Feb. 86)
C.ALGORITHM
C  use 'write+update instruction' to draw (via IP8QW call with WV)
C
C.INPUT/OUTPUT
C  call as  IDI_PL(DISPLAY,CHAN,XFIG,YFIG,NDIM,INTENS,STYLE,IDST)
C
C  input par:
C  DISPLAY:	I*4		unit no.
C  CHAN:	I*4		no. of memory board used as overlay channel
C				if = -1, no overlay channel existing
C  XFIG:	I*4 array	contains the x-coordinates
C  YFIG:	I*4 array	contains the y-coordinates
C  NDIM:	I*4		dimension of XFIG and YFIG
C  INTENS:	I*4		intensity for drawing (0 - 255)
C  STYLE:	I*4		line style, currently ignored (always straight line)
C	
C  output par:
C  IDST:	I*4		return status
C
C.VERSIONS
C  1.20		make it work for "unlimited" polygon length
C
C--------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4 	DISPLAY,CHAN,XFIG(1),YFIG(1),NDIM,IDST
	INTEGER*4	INTENS,STYLE,IPI
	INTEGER*4	N,NN,REM
C
	INTEGER*2	FIGURE(2,1000)
	INTEGER*2	UNIT,INTNS
	INTEGER*2	RI,LR,RR,WV
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
	INCLUDE	'MID_INCLUDE:IDIDEV.INC'
C	
	EXTERNAL 	RI,LR,RR,WV
C
	UNIT = DISPLAY
C 
C  set RESOLUTION register (reg 11) to 2 bytes transfer
	CALL IP8QW(RR,UNIT,DZIOSB,,,SYSREG(12),2,0,11)
	SYSREG(12) = IAND(SYSREG(12),"177677)	
	CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(12),2,0,11)
C 
	SYSREG(33) = 2**CHAN
	CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(33),4,1,32)
C	
C  at the moment the colours red, green, blue, ...   are not supported
	IF ( (INTENS.GT.1) .AND. (INTENS.LE.8) ) THEN
	   INTNS = 255					!map all to white
	ELSE
	   INTNS = INTENS
	ENDIF
C	
C  copy figure
	REM = 0
C 
1000	NN = NDIM - REM
	IF (NN.GT.1000) NN = 1000
C
	DO N=1,NN
	   IPI = XFIG(N+REM)
	   IF (IPI.GE.QMSZX) THEN
	      IPI = QMSZX - 1
	   ELSE
	      IF (IPI.LT.0) IPI = 0
	   ENDIF
	   FIGURE(1,N) = IPI
	   IPI = YFIG(N+REM)
	   IF (IPI.GE.QMSZY) THEN
	      IPI = QMSZY - 1
	   ELSE
	      IF (IPI.LT.0) IPI = 0
	   ENDIF
	   FIGURE(2,N) = IPI
	ENDDO
C
C  now draw the vector
	DO N=1,NN-1
 	   CALL IP8QW(WV,UNIT,DZIOSB,,,FIGURE(1,N),8,0,INTNS)
	ENDDO
C 
C  test, if we are finished
	IF ((REM+NN).LT.NDIM) THEN
	   REM = REM + NN
	   GOTO 1000
	ENDIF
C
	IDST = 0
	RETURN
	END

	SUBROUTINE GD8022(DISPLAY,CHAN,STRING,XPOS,YPOS,PATH,
     +	                  ORIENT,INTENS,HT,IDST)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine IIGTXT		version 1.00	880513
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  DeAnza, overlay channel, alphabet
C
C.PURPOSE
C  fulfill the requirements as defined in the IDI document
C
C.ALGORITHM
C  characters are built in a 7*8 matrix (x:0-6, y:0-7)
C  use IDI_PL to plot the stuff in the overlay plane
C
C.INPUT/OUTPUT
C call as   IIGTXT(DISPLAY,CHAN,STRING,XPOS,YPOS,PATH,ORIENT,INTENS,HT,IDST)
C
C  input par:
C  DISPLAY:	I*4		unit no.
C  CHAN:	I*4		memory id
C  STRING:	char. expr.	character string to be displayed
C  XPOS:	I*4 		x-position
C  YPOS:	I*4 		y-position
C  PATH:	I*4		text path:
C  INTENS:	I*4		intensity
C  HT:		I*4		text height, currently not supported
C				characters are built in a 7*8 matrix
C                               or fixed in the alphanumerics memory
C	
C  output par:
C  IDST:	I*4		return status
C
C--------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,CHAN,ORIENT
	INTEGER*4	INTENS,XPOS,YPOS,PATH,HT,IDST
	INTEGER*4	LSTR
C	
	CHARACTER*(*)	STRING
C	
	LSTR = LEN(STRING)
C	
	IF (CHAN.LT.90) THEN
	   CALL KKGRA(DISPLAY,CHAN,STRING,LSTR,XPOS,YPOS,PATH,
     +	              ORIENT,INTENS,HT,IDST)
 
	ELSE
	   CALL KKALP(DISPLAY,STRING,LSTR,XPOS,YPOS,INTENS,IDST)
	ENDIF
C	
	RETURN
	END

C @(#)gd8l.for	19.1 (ES0-DMD) 02/25/03 13:55:08
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
	SUBROUTINE GD8025(DISPLAY,NLUT,ISTA,COUNT,RLUT,IDST)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine IILWLT		version 1.00		880120
C	      IILRLT			1.00		880120
C  K. Banse			ESO - Garching
C
C.KEYWORDS
C  DeAnza display , LUT
C
C.PURPOSE
C  to load an LUT into the DeAnza,
C  to read an LUT from DeAnza,
C  according to the IDI document
C
C.ALGORITHM
C  use DeAnza level 0 software
C
C.INPUT/OUTPUT
C  call as IILWLT(DISPLAY,NLUT,ISTA,COUNT,RLUT,IDST)
C	   IILRLT(DISPLAY,NLUT,ISTA,COUNT,RLUT,IDST)
C
C  input par:
C  DISPLAY:	I*4		DISPLAY no.
C  NLUT:	I*4		LUT section no. (0 - 3)
C  				if = 4, it's for the overlay !!
C  ISTA:	I*4		start within LUT table in DeAnza
C  COUNT:	I*4		no. of entries in table to send/read
C	
C  input/output par:
C  RLUT:	R*4 array	LUT table with R,G,B entries
C  IDST:	I*4		return status
C
C-----------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,NLUT,ISTA,COUNT,IDST
	INTEGER*4	N,NN,ISW
C	
	REAL*4		RLUT(3,COUNT)
C	
	INTEGER*2 	UNIT,LUT(1024,2),RESREG
	INTEGER*2	RR,LR,LPA,LVR
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
C	
	EXTERNAL	RR,LR,LPA,LVR
C
	UNIT = DISPLAY
C
C  check, if we want to load an overlay table
	IF (NLUT.EQ.4) THEN
	   CALL KKOWLT(UNIT,ISTA,COUNT,RLUT,IDST)
	   RETURN
	ENDIF
C	
C  set resolution register for low byte transfer
	CALL IP8QW(RR,UNIT,DZIOSB,,,SYSREG(12),2,0,11)
	RESREG = IAND(SYSREG(12),"177677)
	RESREG = IOR(RESREG,"100)
	CALL IP8QW(LR,UNIT,DZIOSB,,,RESREG,2,0,11)
C	
C  set LUT address in the DeAnza
	N = IAND("377,ISTA)			!cut out low byte
	VOCREG(4) = IOR(N,ISHFT(NLUT,8))
C
C  main loop:
C  convert R, G, B real table to I*2 and send it to the DeAnza
C	
	ISW = 1
	DO NN=1,3
C	
	   DO N=1,COUNT
	      LUT(N,ISW) = NINT(RLUT(NN,N)*255.)
	   ENDDO
C	
	   CALL IP8W(UNIT)					!wait till ready ...
	   CALL IP8QW(LVR,UNIT,DZIOSB,,,VOCREG(4),2,0,3)	
	   CALL IP8Q(LPA,UNIT,DZIOSB,,,LUT(1,ISW),COUNT*2,NN-1,1)
	   ISW = 3 - ISW					!switch buffer
	ENDDO
C
	CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(12),2,0,11)
	IDST = 0
	RETURN
	END	

	SUBROUTINE GD8026(DISPLAY,NLUT,ISTA,COUNT,RLUT,IDST)
C	
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,NLUT,ISTA,COUNT,IDST
	INTEGER*4	N,ISW,JSW
C	
	REAL*4		RLUT(3,COUNT)
	REAL*4		F
C	
	INTEGER*2 	UNIT,LUT(1024,2),RESREG
	INTEGER*2	RR,LR,RPA,LVR
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
C	
	EXTERNAL	RR,LR,RPA,LVR
C
	UNIT = DISPLAY
C	
C  set resolution register for low byte transfer
	CALL IP8QW(RR,UNIT,DZIOSB,,,SYSREG(12),2,0,11)
	RESREG = IAND(SYSREG(12),"177677)
	RESREG = IOR(RESREG,"100)
	CALL IP8QW(LR,UNIT,DZIOSB,,,RESREG,2,0,11)
C	
C  set LUT address in the DeAnza
	N = IAND("377,ISTA)			!cut out low byte
	VOCREG(4) = IOR(N,ISHFT(NLUT,8))
C
C  main loop:
C  get LUT from the DeAnza and convert I*2 table to R, G, B real table
C	
	ISW = 1
	JSW = 3 - ISW					!switch buffer
	F = 1./255.
C	
C  read red table with wait + greeen table without wait
	CALL IP8QW(LVR,UNIT,DZIOSB,,,VOCREG(4),2,0,3)	
	CALL IP8QW(RPA,UNIT,DZIOSB,,,LUT(1,ISW),COUNT*2,0,1)
	CALL IP8QW(LVR,UNIT,DZIOSB,,,VOCREG(4),2,0,3)	
	CALL IP8Q(RPA,UNIT,DZIOSB,,,LUT(1,JSW),COUNT*2,1,1)
C	
C  make sure high byte is 0 and convert red table to real
	DO N=1,COUNT						
	   RLUT(1,N) = F * FLOAT(IAND(LUT(N,ISW),"377))
	ENDDO
C	
C  fire up reading of blue as soon as green table is in
	CALL IP8W(UNIT)					!wait till ready ...
	CALL IP8QW(LVR,UNIT,DZIOSB,,,VOCREG(4),2,0,3)	
	CALL IP8Q(RPA,UNIT,DZIOSB,,,LUT(1,ISW),COUNT*2,2,1)
C
C  convert green table
	DO N=1,COUNT
	   RLUT(2,N) = F * FLOAT(IAND(LUT(N,JSW),"377))
	ENDDO
C	
C  wait + convert blue table
	CALL IP8W(UNIT)	
	DO N=1,COUNT
	   RLUT(3,N) = F * FLOAT(IAND(LUT(N,ISW),"377))
	ENDDO
C
	CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(12),2,0,11)
	IDST = 0
	RETURN
	END	

	SUBROUTINE GD8023(DISPLAY,CHAN,NITT,ISTA,COUNT,RITT,IDST)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine IILWIT		version 1.00	880120
C	      IILRIT			1.00	880120
C  K. Banse			ESO - Garching
C
C.KEYWORDS
C  DeAnza display , ITT
C
C.PURPOSE
C  to load an ITT into the DeAnza,
C  to read an ITT from DeAnza
C  according to the IDI document
C
C.ALGORITHM
C  use DeAnza level 0 software
C
C.INPUT/OUTPUT
C  call as IILWIT(DISPLAY,CHAN,NITT,ISTA,COUNT,RITT,IDST)
C  	   IILRIT(DISPLAY,CHAN,NITT,ISTA,COUNT,RITT,IDST)
C
C  input par:
C  DISPLAY:	I*4		display no.
C  CHAN:	I*4		memory board no.
C  NITT:	I*4		ITT section no. (0 - 3)
C  ISTA:	I*4		start in ITT table inside DeAnza
C  COUNT:	I*4		no. of bytes to send/read
C	
C  input/output par:
C  RITT:	R*4 array	ITT table
C  IDST:	I*4		return stat
C
C-----------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,CHAN,NITT,ISTA,COUNT,IDST
	INTEGER*4	N
C	
	REAL*4		RITT(1)
C	
	INTEGER*2 	UNIT,ITT(256),ILADR,RESREG
	INTEGER*2	RR,LR,LMC,LPA
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
C	
	EXTERNAL	RR,LR,LMC,LPA
C
	UNIT = DISPLAY
C	
C  set resolution register for low byte transfer
	CALL IP8QW(RR,UNIT,DZIOSB,,,SYSREG(12),2,0,11)
	RESREG = IAND(SYSREG(12),"177677)
	RESREG = IOR(RESREG,"100)
	CALL IP8QW(LR,UNIT,DZIOSB,,,RESREG,2,0,11)
C
C  convert real table to I*2
	DO N=1,COUNT
	   ITT(N) = NINT(RITT(N)*255.)
	ENDDO
C	
C  build ITT address
	N = IAND("377,ISTA)			!cut out start (usually = 0 anyway)
	N = IOR("10000,ISTA)			!add ITT enable bit (bit 12)
	ILADR = IOR(N,ISHFT(NITT,8))		!integrate also ITT section
	N = CHAN + 1
	MEMREG(4,N) = IAND(MEMREG(4,N),"176377)		!clear L9,L8 bit (9,8)
	MEMREG(4,N) = IOR(MEMREG(4,N),ILADR)
C	
C  send the table to the DeAnza
	CALL IP8QW(LMC,UNIT,DZIOSB,,,MEMREG(4,N),2,CHAN,3)	!set LUT address reg.
	CALL IP8QW(LPA,UNIT,DZIOSB,,,ITT,COUNT*2,CHAN,0)
C
	CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(12),2,0,11)
	IDST = 0
	RETURN
	END	

	SUBROUTINE GD8024(DISPLAY,CHAN,NITT,ISTA,COUNT,RITT,IDST)
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,CHAN,NITT,ISTA,COUNT,IDST
	INTEGER*4	N
C	
	INTEGER*2	UNIT,ITT(256),ILADR,RESREG
	INTEGER*2	RR,LR,LMC,RPA
C	
	REAL*4		RITT(1)
	REAL*4		F
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
C
	EXTERNAL	RR,LR,LMC,RPA
C
C  set resolution register for low byte transfer
	CALL IP8QW(RR,UNIT,DZIOSB,,,SYSREG(12),2,0,11)
	RESREG = IAND(SYSREG(12),"177677)
	RESREG = IOR(RESREG,"100)
	CALL IP8QW(LR,UNIT,DZIOSB,,,RESREG,2,0,11)
C	
C  build ITT address
	N = IAND("377,ISTA)			!cut out start (usually = 0 anyway)
	N = IOR("10000,ISTA)			!add ITT enable bit (bit 12)
	ILADR = IOR(N,ISHFT(NITT,8))		!integrate also ITT section
	N = CHAN + 1
	MEMREG(4,N) = IAND(MEMREG(4,N),"176377)		!clear L9,L8 bit (9,8)
	MEMREG(4,N) = IOR(MEMREG(4,N),ILADR)
C
C  read the table from the DeAnza
	CALL IP8QW(LMC,UNIT,DZIOSB,,,MEMREG(4,N),2,CHAN,3)	!set LUT address reg.
	CALL IP8QW(RPA,UNIT,DZIOSB,,,ITT,COUNT*2,CHAN,0)
C	
C  make sure high byte is 0 and convert to real
	F = 1./255.
	DO N=1,COUNT
	   RITT(N) = F * FLOAT(IAND(ITT(N),"377))
	ENDDO
C
	CALL IP8QW(LR,UNIT,DZIOSB,,,SYSREG(12),2,0,11)
	IDST = 0
	RETURN
	END	

	SUBROUTINE GD8049(DISPLAY,CHAN,VISI,IDST)
C	
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine IILSBV		version 1.00	880125
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  DeAnza, LUT
C
C.PURPOSE
C  fulfill the requirements as described in the IDI document 
C
C.ALGORITHM
C  use DeAnza level 0 software
C
C.INPUT/OUTPUT
C  call as IILSBV(DISPLAY,CHAN,VISI,IDST)
C
C  input par:
C  DISPLAY:	I*4		display id.
C  CHAN:	I*4		memory id
C  VISI:	I*4		LUT bar visibility, 0 = off, > 0 = on
C
C  output par:
C  IDST:	I*4		return status
C	
C--------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,CHAN,VISI,IDST
	INTEGER*4	N,STAT
C	
	INTEGER*2	UNIT,CLREF,SETREF
	INTEGER*2	LMC
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
C	
	DATA	CLREF	/"167777/, SETREF /"010000/
C	
	EXTERNAL	LMC
C
	N = CHAN + 1
	UNIT = DISPLAY
C	
C  clear + set RF bit (12) of memory register 0 of channel CHAN
C  depending upon VISI
C	
	MEMREG(1,N) = IAND(MEMREG(1,N),CLREF)
	IF (VISI.GT.0)
     +	   MEMREG(1,N) = IOR(MEMREG(1,N),SETREF)	
C	
	CALL IP8QW(LMC,UNIT,DZIOSB,,,MEMREG(1,N),2,CHAN,0)
C	
	IDST = 0
	RETURN
	END

C @(#)lsqsol.for	19.1 (ES0-DMD) 02/25/03 13:25:35
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine LSQSOL         version 1.0       870130
C  A. Kruszewski             Obs. de Geneve
C.PURPOSE
C  Solves a set of normal equations given by array A.
C  Results are stored in array X. The last element of array X
C  contains a sum of squared deviations. Mean errors are stored in
C  array S. The last element of array S contains the mean error
C  of an observation of unit weight. The dimension N1 is equal to
C  number of unknowns plus one.
C.INPUT/OUTPUT
C  input arguments
C  A           real*8 array     symmetrical array
C  N1          integer*4        dimension of array
C  M           integer*4        number of conditional equations
C  output arguments
C  X           real*8 array     unknowns + vv
C  S           real*8 array     mean errors + sigma0
C-----------------------------------------------------------------------
      SUBROUTINE LSQSOL ( N1 , A , M , X , S )
C
      IMPLICIT          NONE
      INTEGER           N1
      DOUBLE PRECISION  A(N1,N1)
      INTEGER           M
      DOUBLE PRECISION  X(N1)
      DOUBLE PRECISION  S(N1)
C
      INTEGER            N, NN
      INTEGER            I, I1
      INTEGER            J, J1
      INTEGER            K
      DOUBLE PRECISION   TEMP
C
C *** N - number of unknowns.
C
      N = N1 - 1
C
C *** Calculate triangular square root of the input array.
C
      IF ( A(1,1) .LE. 0.0 ) THEN
          S(N1) = -1.0
          RETURN
      ENDIF
      A(1,1) = SQRT( A(1,1) )
      DO 10 I = 2 , N1
          I1 = I - 1
          DO 20 J = 1 , I1
              IF ( A(J,J) .LE. 0.0 ) THEN
                  S(N1) = -1.0
                  RETURN
              ENDIF 
              TEMP = A(I,J)
              J1 = J - 1
              DO 30 K = 1 , J1
                  TEMP = TEMP - A(I,K) * A(J,K)
   30         CONTINUE
              A(I,J) = TEMP / A(J,J)
   20     CONTINUE
          TEMP = A(I,I)
          DO 40 K = 1 , I1
              TEMP = TEMP - A(I,K) * A(I,K)
   40     CONTINUE
          IF ( TEMP .LE. 0.0 ) THEN
              S(N1) = -1.0
              RETURN
          ENDIF
          A(I,I) = SQRT( TEMP )
   10 CONTINUE
C
C *** Invert the triangular square root matrix of size N. 
C
      DO 50 I = 1 , N
          A(I,I) = 1.0 / A(I,I)
   50 CONTINUE
      NN = N - 1
      DO 60 I = 1 , NN
          I1 = I + 1
          DO 70 J = I1 , N
              J1 = J - 1
              TEMP = 0.0
              DO 80 K = I , J1
                  TEMP = TEMP + A(I,K) * A(J,K)   
   80         CONTINUE
              A(I,J) = -TEMP * A(J,J)
   70     CONTINUE
   60 CONTINUE
C
C *** Calculate unknowns. 
C
      DO 90 I = 1 , N
          TEMP = 0.0
          DO 100 J = I , N
              TEMP=TEMP + A(I,J) * A(N1,J)
  100     CONTINUE
          X(I) = SNGL( TEMP )
   90 CONTINUE
C
C *** Calculate vv and sigma0.
C
      TEMP = A(N1,N1)
      X(N1) = SNGL( TEMP * TEMP )
      S(N1) = SNGL( TEMP / SQRT( DBLE( M-N ) ) )
C
C *** Calculate mean errors of unknowns.
C
      DO 110 I = 1 , N
          TEMP = 0.0
          DO 120 J = I , N
              TEMP = TEMP + A(I,J) * A(I,J)
  120     CONTINUE
          S(I) = SNGL( SQRT(TEMP) * S(N1) )
  110 CONTINUE
C
      RETURN
C
      END

C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION        ISDFHD.FOR
C.AUTHOR:               J.D.PONZ  ESA-VILSPA        
C.KEYWORDS              IUE, GO FORMAT, FILE HEADER
C.PURPOSE
C  \begin{TeX}
C  Reads from 2nd record until the end of the IUE GO file header.
C  The routine performs the following functions (routine names in brackets)
C  \begin{enumerate}
C  \item Reads record record (ISDREC)
C  \item Translates EBCDIC into ASCII (ISTEAS)
C  \item Displays the header according to the argument DSPFLG (STTPUT)
C  \item If it is not the last header record go to 1.
C  \end{enumerate}
C  \end{TeX}
C         
C.LANGUAGE              F77 
C.COMMENTS
C  \begin{TeX}
C    The following extensions are used:
C  \begin{itemize}
C   \item IMPLICIT NONE
C   \item INCLUDE statement
C   \item long variable names
C   \item underscore character
C  \end{itemize}
C  \end{TeX}
C.VERSION: 1.0  INITIAL CODING  24 JUN 1994
C------------------------------------------------------------------
      SUBROUTINE ISDFHD(CHANL,BUFF,DSPFLG,IOFF,STATUS)
C
      IMPLICIT NONE
      INTEGER       CHANL             ! IN: tape channel number
      CHARACTER*(*) BUFF              ! IN: buffer with the ascii header
      INTEGER       DSPFLG            ! IN: display flag
      INTEGER       IOFF              ! IN: byte offset
      INTEGER       STATUS            ! OUT: status
C
       INTEGER                I, NLEN, LEN, ICOUNT
       CHARACTER*72           TEXT2, TEXT3, TEXT4
       CHARACTER*360          CBUFF
       CHARACTER*1            CC
       LOGICAL                LAST
       DATA                   TEXT2
     ./'.........1.........2.........3.........4.........5.........6....
     ......7..'/
       DATA                    TEXT3
     ./'1234567890123456789012345678901234567890123456789012345678901234
     .56789012'/
       DATA                    TEXT4
     ./'----------------------------------------------------------------
     .--------'/
C
      NLEN   = 360
      STATUS = 0
      IF (DSPFLG.GE.1) THEN
        CALL STTPUT(TEXT2,STATUS)
        CALL STTPUT(TEXT3,STATUS)
        CALL STTPUT(TEXT4,STATUS)
      ENDIF
C
C ... writes the first header lines
C
      LAST = .FALSE.
      DO 10 I = 72, NLEN, 72
           IF (DSPFLG.GE.1) CALL STTPUT(BUFF(I-71:I),STATUS)
           IF (BUFF(I:I).EQ.'L') LAST = .TRUE.
 10   CONTINUE
      IF (LAST) THEN
        IF (DSPFLG.GE.1)  CALL STTPUT(TEXT4,STATUS)
        RETURN
      ENDIF
      ICOUNT = 6
C
C ... skip records
C
 15   CALL ISDREC(CHANL,CBUFF,NLEN,LEN,IOFF,STATUS)
      IF ((NLEN+IOFF).NE.LEN .OR. STATUS.NE.0) RETURN
      DO 20  I = 72, NLEN, 72
         IF (DSPFLG.GE.2 .AND. .NOT.LAST .AND.
     .       (ICOUNT.LT.38 .OR. ICOUNT.GT.100))
     .                 CALL STTPUT(CBUFF(I-71:I),STATUS)
         ICOUNT = ICOUNT + 1
         CC = CBUFF(I:I)
         IF (CC.EQ.'L') LAST = .TRUE.
 20   CONTINUE
      IF (.NOT.LAST) GOTO 15
      RETURN
      END      

C @(#)rmflst.for	19.1 (ES0-DMD) 02/25/03 13:25:38
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C
C----------------------------------------------------------------------
      SUBROUTINE RMFLST(M, L0, L1, NREG, LSTP, NCAT)
C
      IMPLICIT  NONE
      INCLUDE   'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER   M
      INTEGER   L0
      INTEGER   L1
      INTEGER   NREG
      INTEGER   LSTP(0:4,0:NREG)
      INTEGER   NCAT(NIPAR,MAXCNT)
C
      INTEGER   LM, LL
      INTEGER   IREG , LOBJ
C     INTEGER   NCT1(NIPAR) , NCT2(NIPAR) 
      INTEGER   NOBJ , NP
C
C     REAL   PMT1(NRPAR) , PMT2(NRPAR)
C     REAL   PRC1(0:MAXSUB) , PRC2(0:MAXSUB)
C
      LOGICAL   BUFF1 , BUFF2
C
      NP = MAXCNT
C
C ******      Find first object in the region LOBJ.
C
C      IF ( M .GT. L0 .AND. M .LE. L1 ) THEN
          BUFF1 = .TRUE.
          LM = M - L0
          IREG = NCAT(7,LM)
C      ELSE
C          BUFF1 = .FALSE.
C          READ ( ISF , REC=M ) NCT1 , PMT1 , PRC1
C          IREG = NCT1(7)
C      ENDIF
      LOBJ = LSTP(0,IREG)
      IF ( LOBJ .EQ. M ) THEN
C
C ***     M is the first object on list.
C
C          IF ( BUFF1 ) THEN
              NOBJ = NCAT(8,LM)
C          ELSE
C              NOBJ = NCT1(8)
C          ENDIF
          LSTP(0,IREG) = NOBJ
C          IF ( BUFF1 ) THEN
              NCAT(7,LM) = 0
              NCAT(8,LM) = 0
C          ELSE
C              NCT1(7) = 0
C              NCT1(8) = 0
C              WRITE ( ISF , REC=M ) NCT1 , PMT1 , PRC1
C          ENDIF
      ELSE IF ( LOBJ .EQ. 0 ) THEN
C          IF ( BUFF1 ) THEN
              NCAT(7,LM) = 0
              NCAT(8,LM) = 0
C          ELSE
C              NCT1(7) = 0
C              NCT1(8) = 0
C              WRITE ( ISF , REC=M ) NCT1 , PMT1 , PRC1
C          ENDIF
      ELSE
C
C *** M is in the middle or on the end of list.
C
   10     CONTINUE
C              IF ( LOBJ .GT. L0 .AND. LOBJ .LE. L1 ) THEN
                  LL = LOBJ - L0
                  NOBJ = NCAT(8,LL)
                  BUFF2 = .TRUE.
C              ELSE
C                  READ ( ISF , REC=LOBJ ) NCT2 , PMT2 , PRC2
C                  NOBJ = NCT2(8)
C                  BUFF2 = .FALSE.
C              ENDIF
              IF ( NOBJ .EQ. M ) THEN
C                  IF ( BUFF1 ) THEN
                      NOBJ = NCAT(8,LM)
                      NCAT(7,LM) = 0
                      NCAT(8,LM) = 0 
C                  ELSE
C                      NOBJ = NCT1(8)
C                      NCT1(7) = 0
C                      NCT1(8) = 0
C                      WRITE ( ISF , REC=M ) NCT1 , PMT1 , PRC1
C                  ENDIF
C                  IF ( BUFF2 ) THEN
                      NCAT(8,LL) = NOBJ
C                  ELSE
C                      NCT2(8) = NOBJ
C                      WRITE ( ISF , REC=LOBJ ) NCT2 , PMT2 , PRC2
C                  ENDIF
              ELSE IF ( NOBJ .EQ. 0 ) THEN
C                  IF ( BUFF1 ) THEN
                      NCAT(7,LM) = 0
                      NCAT(8,LM) = 0
C                  ELSE
C                      NCT1(7) = 0
C                      NCT1(8) = 0
C                      WRITE ( ISF , REC=M ) NCT1 , PMT1 , PRC1
C                  ENDIF
              ELSE
                  LOBJ = NOBJ
                  GOTO 10
              ENDIF
          CONTINUE
      ENDIF
C
      IF ( LSTP(3,0) .EQ. M ) THEN
          LSTP(3,0) = M - 1
      ENDIF
C
      RETURN
C
      END
C

C @(#)rfotcheck.for	19.1 (ES0-DMD) 02/25/03 13:30:13
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM CHECK
C+++
C.IDENTIFICATION: RFOTCHECK
C.PURPOSE: Examine the number of artificial stars recovered and check their
C          photometric accuracy
C.AUTHOR:  R. Buonanno, G. Buscema, C. Corsi, I. Ferraro, G. Iannicola
C          Osservatorio Astronomico di Roma
C          Rewritten by Rein H. Warmels, ESO-IPG Garching
C.VERSION: 890912  RHW MIDAS table file system implemented; new ST interfaces
C----
      IMPLICIT     NONE
C
      INTEGER      NNN
      PARAMETER    (NNN=100000)
C
      INTEGER      IFL(NNN)
      INTEGER      ISTO(1000),IISTO(1000)
      INTEGER      EC, ED, EL
      INTEGER      I, IC, IR, II
      INTEGER      IAV, ISTAT
      INTEGER      IDUM2, IDUM3, IDUM6, IDUM7, IDUM8, IDUM9
      INTEGER      IDUM14, IDUM15
      INTEGER      ISTM
      INTEGER      KW
      INTEGER      KUN, KNUL
      INTEGER      KKO
      INTEGER      NCO, NRO
      INTEGER      NSC, NSA
      INTEGER      NOG
      INTEGER      NCAN
      INTEGER      NCM
      INTEGER      NH
     
      INTEGER      TIDCAT,TIDREG
      INTEGER      MADRID
      INTEGER      ICMP
      INTEGER      ICOL(12)
C
      REAL         TAB(12)
      REAL         X(NNN),Y(NNN),PMA(NNN)
      REAL         DIF(NNN)
      REAL         ACER
      REAL         APPO, APPO2, APPO3
      REAL         DFMX, DFMN
      REAL         FL
      REAL         PMAX, PMIN
      REAL         PM
      REAL         RDUM1, RDUM2, RDUM3, RDUM4, RDUM5, RDUM6, RDUM7
      REAL         RDUM8, RDUM9, RDUM10, RDUM11, RDUM12, RDUM13
      REAL         XX, YY
      REAL         FON, DIS
C
      LOGICAL      NUL(12)
C
      CHARACTER    STRING*80,XXX*30
      CHARACTER*60 CATFIL,REGFIL
C
      INCLUDE      'MID_INCLUDE:TABLES.INC'
      COMMON       /VMR/MADRID
      INCLUDE      'MID_INCLUDE:TABLED.INC'
C
      DATA         ICOL/2,3,4,5,6,7,8,9,10,11,12,13/
      DATA         ISTO/1000*0/
      DATA         IISTO/1000*0/
C
   99 FORMAT('*** INFO: Number of objects not detected: ',I6)
   98 FORMAT(I5,'% of',I5,2X,E10.3,2X,'I',A30)
C
C *** Let's start the fun; is MIDAS out there?
      CALL STSPRO('CHECK')
C
C *** get the input catalogue file
      CALL STKRDC('IN_A',1,1,60,IAV,CATFIL,KUN,KNUL,ISTAT)
      CALL STECNT('GET',EC,ED,EL)
      CALL STECNT('PUT',1,0,0)
      CALL TBTOPN(CATFIL,F_IO_MODE,TIDCAT,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL: Catalogue table not present ...'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ELSE
         CALL CATDRD(TIDCAT,NOG,IDUM2,IDUM3,RDUM4,RDUM5,IDUM6,
     2               IDUM7,IDUM8,IDUM9,RDUM10,RDUM11,RDUM12,RDUM13,
     3               IDUM14,IDUM15)
      ENDIF
C
C *** get the registration table created by FCLEAN/ROMAFOT
      CALL STKRDC('IN_B',1,1,60,IAV,REGFIL,KUN,KNUL,ISTAT)
      CALL TBTOPN(REGFIL,F_I_MODE,TIDREG,ISTAT)
      IF (ISTAT.NE.0) THEN
         STRING = '*** FATAL: Registration table not present ...'
         CALL STTPUT(STRING,ISTAT)
         CALL STSEPI
      ELSE
         CALL TBIGET(TIDREG,NCO,NRO,NSC,KW,NSA,ISTAT)
      ENDIF
      CALL STECNT('PUT',EC,ED,EL)
C
C *** get the error in magnitude
      CALL STKRDR('INPUTR',1,1,IAV,ACER,KUN,KNUL,ISTAT)
C
C *** open a dump file 
C     OPEN(UNIT=8,FILE='CHECK.DMP',STATUS='NEW')
C
C *** initialize the arrays
      DO 10 I=1,NNN
         DIF(I) = 0.0
         IFL(I) = 0
   10 CONTINUE
      PMAX = -1000
      PMIN = -PMAX
C
C *** run through the entire catalogue
      DO 20 IC=1,NOG
         CALL CATTRD(TIDCAT,IC,ICMP,X(IC),Y(IC),RDUM3,PMA(IC),
     2               RDUM5,RDUM6,RDUM7,RDUM8,RDUM9,RDUM10,
     3               RDUM11,RDUM12,RDUM13)
         PMAX = AMAX1(PMAX,PMA(IC))
         PMIN = AMIN1(PMIN,PMA(IC))
   20 CONTINUE
C
C *** read the registration table
      DFMX = -99999.
      DFMN = -DFMX
      DO 30 IR = 1,NRO
         CALL TBRRDR(TIDREG,IR,12,ICOL,TAB,NUL,ISTAT)
         XX  = TAB(1)
         YY  = TAB(2)
         FON = TAB(4)
         DO 31 I=1,NOG
            IF (IFL(I).EQ.0) THEN
               DIS = (XX-X(I))**2+(YY-Y(I))**2
               IF (DIS.LT.2) THEN
                  IF (ABS(TAB(8)-PMA(I)).LT.ACER) THEN
                     IFL(I) = 1
                     DIF(I) = TAB(8) - PMA(I)
                     DFMX   = AMAX1(DFMX,DIF(I))
                     DFMN   = AMIN1(DFMN,DIF(I))
                  END IF
               END IF
            END IF
   31    CONTINUE
   30 CONTINUE
C
      KKO = 0
      DO 40 I=1,NOG
         NCAN = (PMA(I)-PMIN)/.5+1                               !.5 e' il passo
         IF (IFL(I).NE.1) THEN                  ! istogramma pmag(i) non trovate
            ISTO(NCAN)  = ISTO(NCAN)+1
            KKO         = KKO+1
          ELSE
            IISTO(NCAN) = IISTO(NCAN)+1
         END IF
   40 CONTINUE
C
      WRITE (STRING,99) KKO
      CALL STTPUT(STRING,ISTAT)
C
      NCM  = (PMAX-PMIN)/.5+1
      ISTM = 0
      DO 50 I=1,NCM
         IISTO(I) = ISTO(I)+IISTO(I)
         APPO     = ISTO(I)
         APPO2    = IISTO(I)
         IF (APPO2.GT.0)THEN
            APPO3 = (APPO/APPO2)*100 
         ELSE
            APPO3 = 0
         END IF
         ISTO(I) = APPO3
   50 CONTINUE
C
      DO 60 I=1,NCM
         ISTM=MAX0(ISTM,ISTO(I))
   60 CONTINUE
C
      IF (ISTM.GT.0) THEN
         PM = PMIN-.49
         DO 70 I=1,NCM
            XXX(1:30) = ' '
            PM        = PM+.5
            NH        = 30.*ISTO(I)/ISTM
            DO 71 II=1,NH
               XXX(II:II) = 'X'
   71       CONTINUE
            WRITE(STRING,98) ISTO(I),IISTO(I),PM,XXX
            CALL STTPUT(STRING,ISTAT)
   70    CONTINUE
      ELSE
         CALL STTPUT('*** INFO: No data available',ISTAT)
      END IF
C
      DO 80 IC=1,NOG
         CALL CATTRD(TIDCAT,IC,ICMP,RDUM1,RDUM2,RDUM3,RDUM4,
     2               RDUM5,RDUM6,RDUM7,RDUM8,RDUM9,RDUM10,RDUM11,
     3               RDUM12,RDUM13)
         FL = FLOAT(IFL(IC))
         CALL CATTWR(TIDCAT,IC,ICMP,RDUM1,RDUM2,RDUM3,RDUM4,
     2               RDUM5,RDUM6,FL,DIF(IC),RDUM9,
     3               RDUM10,RDUM11,RDUM12,RDUM13)
   80 CONTINUE
      CALL TBTCLO(TIDCAT,ISTAT)
      CALL TBTCLO(TIDREG,ISTAT)
      CALL STSEPI
      END

C @(#)fitcopy.for	19.1 (ES0-DMD) 02/25/03 13:18:46
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  15:22 - 20 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.IDENTIFICATION
C
C  program FITCOPY.FOR
C
C.PURPOSE
C
C  Execute the command
C  MODIFY/FIT  table seq_no [fitname]
C  SAVE/FIT  table seq_no [fitname]
C
C.KEYWORDS
C
C  fit, parameter initializaton
C
C.INPUT/OUTPUT
C
C  P1 - P2     contain input parameters
C
C.ALGORITHM
C
C  Use fit interface routines
C  The program defines the parameter guesses from table columns
C  or saves fitted values (and errors) in a table
C
C  In the form INIT/FIT the table contains the
C  initial guesses as :par_GUES for each parameter 'par' in the fit
C  In the form SAVE/FIT fitted parameter values and error are
C  stored as :par and :par_ERROR for each parameter 'par'
C
C-----------------------------------------------------------
C
C ... define data
      IMPLICIT  NONE
C
      INTEGER      PL,TID,SEQ,STATUS,KUN,KNUL
      INTEGER      IAV, ISTAT, I, NCOL, I2, NC1
      INTEGER      ICOL(100), NAMLEN
      INTEGER      MADRID(1),EC,EL,ED
C
      REAL VAL(100)
C
      LOGICAL ISEL,NULL(100)
C
      CHARACTER*16  MSG,UNIT
      CHARACTER*80  TABLE,NAME
      CHARACTER*8   FORM
      CHARACTER*80  COM
      CHARACTER*16  LABEL(100)
C
       INCLUDE 'MID_INCLUDE:FITI.INC/NOLIST'
       INCLUDE 'MID_INCLUDE:TABLES.INC/NOLIST'
       INCLUDE 'MID_INCLUDE:FITC.INC/NOLIST'
       COMMON/VMR/MADRID
       INCLUDE 'MID_INCLUDE:TABLED.INC/NOLIST'
C
      DATA MSG/'ERR:FITCOPYxxxx'/,UNIT/' '/
      DATA FORM/'G14.6'/
      DATA NAMLEN/80/
C
C ... get parameters
C
      CALL STSPRO('FITCOPY')
      CALL FITBL 
      CALL STKRDC('P1',1,1,NAMLEN,IAV,TABLE,KUN,KNUL,ISTAT)
      CALL STKRDC('P3',1,1,NAMLEN,IAV,NAME,KUN,KNUL,ISTAT)
      CALL STKRDI('INPUTI',1,1,IAV,SEQ,KUN,KNUL,ISTAT)
      CALL STKRDC('MID$CMND',1,1,4,IAV,COM,KUN,KNUL,ISTAT)
C
C ... get fitname and handle default
C
      IF (NAME(1:1).EQ.'?') THEN
          CALL STKRDC('FITNAME',1,1,NAMLEN,IAV,NAME,KUN,KNUL,ISTAT)
      ELSE
          CALL STKWRC('FITNAME',1,NAME,1,NAMLEN,KUN,ISTAT)
      END IF
C
C ... init fit structure
C
      CALL FTINIT(NAME,ISTAT)
      IF (COM(1:1).EQ.'M') THEN
          DO 10 I = 1,FZNPTOT
              PL     = FZPLEN(I)
              LABEL(I) = FZPTOKEN(I) (1:PL)//'_GUESS'
   10     CONTINUE
          NCOL   = FZNPTOT
      ELSE
          DO 20 I = 1,FZNPTOT
              I2     = 2*I
              PL     = FZPLEN(I)
              LABEL(I2-1) = FZPTOKEN(I)
              LABEL(I2) = FZPTOKEN(I) (1:PL)//'_ERROR'
   20     CONTINUE
          NCOL   = 2*FZNPTOT
      END IF
C
C ... init table
C
      CALL STECNT('GET',EC,EL,ED)
      CALL STECNT('PUT',1,0,0)
      CALL TBTOPN(TABLE,F_IO_MODE,TID,ISTAT)
      CALL STECNT('PUT',EC,EL,ED)
      IF (ISTAT.NE.0) 
     +    CALL TBTINI(TABLE,F_TRANS,F_O_MODE,NCOL,10,TID,ISTAT)
      DO 30 I = 1,NCOL
          CALL TBLSER(TID,LABEL(I),ICOL(I),ISTAT)
          IF (ICOL(I).LE.0) THEN
              ICOL(I) = 0
              IF (COM(1:1).EQ.'S') THEN
                  CALL TBCINI(TID,D_R4_FORMAT,1,FORM,
     .                        UNIT,LABEL(I),ICOL(I),
     +                        ISTAT)
              END IF
          END IF
   30 CONTINUE
C
C ... copy to/from table
C
      IF (COM(1:1).EQ.'M') THEN
          CALL TBSGET(TID,SEQ,ISEL,ISTAT)
          IF ( .NOT. ISEL) THEN
              CALL STTPUT(' Non selected row ',ISTAT)
              GO TO 70
          END IF
          DO 40 I = 1,NCOL
              IF (ICOL(I).NE.0 .AND. FZFIXED(I).LT.0) THEN
                CALL TBERDR(TID,SEQ,ICOL(I),VAL(I),NULL(I),ISTAT)
                FZVALUE(I) = VAL(I)
              ENDIF
   40     CONTINUE
      ELSE
          NC1    = NCOL/2
          DO 50 I = 1,NC1
              I2     = 2*I
              VAL(I2-1) = FZVALUE(I)
              VAL(I2) = FZERROR(I)
   50     CONTINUE
          CALL TBRWRR(TID,SEQ,NCOL,ICOL,VAL,ISTAT)
      END IF
      CALL TBTCLO(TID,ISTAT)
C
C ... end
C
      CALL FTEXIT(NAME,ISTAT)
   70 IF (ISTAT.NE.0) THEN
          WRITE (MSG(13:16),9000) ISTAT
          CALL TDERRR(ISTAT,MSG,STATUS)
      END IF
      CALL STSEPI
 9000 FORMAT (I4)
      END
   

C @(#)averow.for	19.1 (ESO-DMD) 02/25/03 14:01:40
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM AVEROW
C --------------------------------------------------------------------
C
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  13:37 - 5 JAN 1988
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.Ponz
C         900202   KB  take care of options in lower case
C
C.IDENTIFICATION
C
C AVEROW.FOR
C
C.KEYWORDS
C
C  average
C
C.PURPOSE
C
C  produce a 1d image from a 2d by averaging over rows or columns
C
C  COMMAND
C  AVERAGE/ROW    output = input start,end [SUM]
C  AVERAGE/COLUMN output = input start,end [SUM]
C
C.ALGORITHM
C
C  add rows/columns
C
C.INPUT/OUTPUT
C
C KEYWORDS out_a, in_a, p4, p5, action
C
C 001207			last modif
C 
C ------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER MADRID(1)
      INTEGER NDIM,KUN,KNUL
      INTEGER I1,I2,II1,II2
      INTEGER I,IFIRST,INUM,SUBLO(3)
      INTEGER NAXISA,NAXISB,NN,IMNOA,IMNOB
      INTEGER NPIXA(2),NPIXB(2),STATUS
      INTEGER*8 PNTRA,PNTRB
C
      REAL IAV,LHCUTS(4),FACT
C
      DOUBLE PRECISION STEPA(2),STEPB(2)
      DOUBLE PRECISION STARTA(2),STARTB(2)
C
      CHARACTER*80    FRAMEA, FRAMEB
      CHARACTER*72    IDENT,CUNITA,RANGE
      CHARACTER*72    CUNITB 
      CHARACTER*1     IOP,COMLIN
      CHARACTER       NEWSTR*80
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      COMMON  /VMR/ MADRID
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      DATA   NDIM    /2/
      DATA   IDENT   /' '/,   CUNITA  /' '/
      DATA   CUNITB  /' '/
      DATA   LHCUTS  /0.,0.,0.,0./
C
C  connect to Midas environment
C
      CALL STSPRO('AVEROW')
C
C  read params
C
      CALL STKRDC('OUT_A',1,1,80,IAV,FRAMEB,KUN,KNUL,STATUS)
      CALL STKRDC('IN_A',1,1,80,IAV,FRAMEA,KUN,KNUL,STATUS)
      CALL STKRDC('P4',1,1,72,IAV,RANGE,KUN,KNUL,STATUS)
      CALL STKRDC('P5',1,1,1,IAV,IOP,KUN,KNUL,STATUS)
      CALL STKRDC('ACTION',1,2,1,IAV,COMLIN,KUN,KNUL,STATUS)
C
C  open input frame and read descriptors
C
      CALL STFOPN(FRAMEA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,IMNOA,STATUS)
      CALL STDRDI(IMNOA,'NAXIS',1,1,IAV,NAXISA,KUN,KNUL,STATUS)
      CALL STDRDI(IMNOA,'NPIX',1,2,IAV,NPIXA,KUN,KNUL,STATUS)
      CALL STDRDD(IMNOA,'START',1,2,IAV,STARTA,KUN,KNUL,STATUS)
      CALL STDRDD(IMNOA,'STEP',1,2,IAV,STEPA,KUN,KNUL,STATUS)
      CALL STDRDC(IMNOA,'IDENT',1,1,72,IAV,IDENT,KUN,KNUL,STATUS)
      CALL STDRDC(IMNOA,'CUNIT',1,1,72,IAV,CUNITA,KUN,KNUL,STATUS)    
C
C  setup descriptors of result frame
C
      NAXISB = 1
      NPIXB(2) = 1
      STARTB(2) = 1.D0
      STEPB(2) = 0.D0
      IF (RANGE(1:1).EQ.'[') THEN
         II1 = 2
      ELSE
         II1 = 1
      ENDIF
      II2 = INDEX(RANGE,',')
      IF (II2.LT.2) CALL STETER(22,'missing comma in range spec.')
C
C  get range of pixels I1,I2
C
      IF (COMLIN.EQ.'R') THEN
         NPIXB(1) = NPIXA(1)
         STARTB(1) = STARTA(1)
         STEPB(1) = STEPA(1)
         CUNITB(1:16) = CUNITA(1:16)
         CUNITB(17:32) = CUNITA(17:32)
         NEWSTR(1:) = '[@1, '
         NEWSTR(5:) = RANGE(II1:II2-1)
         NN = INDEX(NEWSTR,' ')
         NEWSTR(NN:) = '] '
         CALL EXTCO1(IMNOA,NEWSTR,2,NN,SUBLO,STATUS)
         IF (STATUS.NE.0) CALL STSEPI
         I1 = SUBLO(2)
         NEWSTR(1:) = '[@1, '
         NEWSTR(5:) = RANGE(II2+1:)
         IF (II1.EQ.2) THEN
            NN = INDEX(NEWSTR,']')
         ELSE
            NN = INDEX(NEWSTR,' ')
         ENDIF
         NEWSTR(NN:) = '] '
         CALL EXTCO1(IMNOA,NEWSTR,2,NN,SUBLO,STATUS)
         IF (STATUS.NE.0) CALL STSEPI
         I2 = SUBLO(2)
      ELSE
         NPIXB(1) = NPIXA(2)
         STARTB(1) = STARTA(2)
         STEPB(1)= STEPA(2)
         CUNITB(1:16) = CUNITA(1:16)
         CUNITB(17:32) = CUNITA(33:49)	 
         NEWSTR(1:) = '[ '
         NEWSTR(2:) = RANGE(II1:II2-1)
         NN = INDEX(NEWSTR,' ')
         NEWSTR(NN:) = ',@1] '
         CALL EXTCO1(IMNOA,NEWSTR,2,NN,SUBLO,STATUS)
         IF (STATUS.NE.0) CALL STSEPI
         I1 = SUBLO(1)
         NEWSTR(1:) = '[ '
         NEWSTR(2:) = RANGE(II2+1:)
         IF (II1.EQ.2) THEN
            NN = INDEX(NEWSTR,']')
         ELSE
            NN = INDEX(NEWSTR,' ')
         ENDIF
         NEWSTR(NN:) = ',@1] '
         CALL EXTCO1(IMNOA,NEWSTR,2,NN,SUBLO,STATUS)
         IF (STATUS.NE.0) CALL STSEPI
         I2 = SUBLO(1)
      ENDIF
      IF (I1.GT.I2) CALL STETER(22,'Invalid range')
C
C  map output frame + initialize data
C
      CALL STIPUT(FRAMEB,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,NAXISB,
     +            NPIXB,STARTB,STEPB,IDENT,CUNITA,PNTRB,IMNOB,STATUS)
      CALL WORK(0,MADRID(PNTRB),NPIXB,0.0,LHCUTS(3))
C
C  do it
C
      IF (COMLIN.EQ.'R') THEN
         CALL STFXMP(NPIXB(1),D_R4_FORMAT,PNTRA,STATUS)
         IFIRST = (I1-1)*NPIXA(1)+1
         DO 100, I=I1,I2
C
C read row after row and sum up
            CALL STFGET(IMNOA,IFIRST,NPIXA(1),IAV,MADRID(PNTRA),STATUS)
            CALL AVER1(MADRID(PNTRB),MADRID(PNTRA),NPIXB(1))
            IFIRST = IFIRST + NPIXA(1)
100      CONTINUE
C 
      ELSE
         INUM = I2-I1+1
         CALL STFXMP(INUM,D_R4_FORMAT,PNTRA,STATUS)
         IFIRST = I1
         DO 200, I=1,NPIXA(2)
C
C read the columns which are to be  summed up
            CALL STFGET(IMNOA,IFIRST,INUM,IAV,MADRID(PNTRA),STATUS)
            CALL AVER2(MADRID(PNTRB),MADRID(PNTRA),
     +           I,INUM,NPIXA(1),NPIXA(2))
            IFIRST = IFIRST + NPIXA(1)
200      CONTINUE
      ENDIF
      FACT = 1.0/(I2-I1+1)
      IF ((IOP.NE.'S').AND.(IOP.NE.'s')) THEN
         CALL WORK(1,MADRID(PNTRB),NPIXB(1),FACT,
     +             LHCUTS(3))                      !average + find minmax
      ELSE
         CALL WORK(2,MADRID(PNTRB),NPIXB(1),FACT,
     +             LHCUTS(3))                      !find minmax only
      ENDIF
      CALL STDWRR(IMNOB,'LHCUTS',LHCUTS,1,4,KUN,STATUS)
      CALL STDWRC(IMNOB,'CUNIT',1,CUNITB,1,72,KUN,STATUS)
      CALL DSCUPT(IMNOA,IMNOB,' ',STATUS)
C
      CALL STSEPI
      END

      SUBROUTINE WORK(FLAG,Y,NPIX,FACT,AUX)
C
      IMPLICIT NONE
C 
      INTEGER  FLAG,NPIX,J
C 
      REAL     Y(NPIX),FACT,AUX(2)
C
      IF (FLAG.EQ.0) THEN
         DO 20, J=1,NPIX
            Y(J) = 0.
20       CONTINUE
      ELSE IF (FLAG.EQ.1) THEN
         AUX(1) = Y(1)*FACT
         AUX(2) = AUX(1)
         DO 30, J=1,NPIX
            Y(J) = Y(J)*FACT
            IF (Y(J).LT.AUX(1)) AUX(1) = Y(J)
            IF (Y(J).GT.AUX(2)) AUX(2) = Y(J)
30       CONTINUE
      ELSE
         AUX(1) = Y(1)
         AUX(2) = AUX(1)
         DO 40, J=1,NPIX
            IF (Y(J).LT.AUX(1)) AUX(1) = Y(J)
            IF (Y(J).GT.AUX(2)) AUX(2) = Y(J)
40       CONTINUE
      ENDIF
C
      RETURN
      END

      SUBROUTINE AVER1(Y,Y1,NPIX1)
C
C sum over rows
C
      IMPLICIT NONE
      INTEGER  NPIX1,J
      REAL     Y(NPIX1), Y1(NPIX1)
C
      DO 20, J=1,NPIX1
         Y(J) = Y(J) + Y1(J)
20    CONTINUE
C
      RETURN
      END

      SUBROUTINE AVER2(Y,Y1,ICOL,INUM,NPXA,NPXB)
C
C sum over columns
C
      IMPLICIT NONE
      INTEGER  ICOL,J,INUM,NPXA,NPXB
      REAL     Y(NPXA), Y1(NPXB)
C
      DO 20, J=1,INUM
         Y(ICOL) = Y(ICOL)+Y1(J)
20    CONTINUE
C    
      RETURN
      END

C @(#)prc.for	19.1 (ES0-DMD) 02/25/03 14:29:02
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
CC
CC  *STATIS* : STANDARDIZATION OF THE OBSERVATIONS AND
CC               CALCULATION OF SOME STATISTICS
CC
       SUBROUTINE STATIS(X,Y,XMED,XMAD,RESDU,WEIGHTS,AW,
     1 NMVAL,C,H,JNDVC,NSTOP,NVAR,NVAD,NVSB,NCAS,JCST,JPRT,
     1 NDXX,NDXY,LUB,NMXV,PREC,LAB)

       INCLUDE 'MID_REL_INCL:implicit.inc'

       INTEGER J,JCST,JNC,JPRT,JS,JSM,JSPA,JSPB,JSPP,LUB
       INTEGER NCAS,NDXX,NDXY,NMXV,NVAD,NSTOP,NVAR,NVSB
       REAL AL,AMDAN,DIAG,SPEAR,PEARC,PREC
C       
       REAL X(NDXX,NDXY),Y(NDXY),XMED(NDXX),XMAD(NDXX)
       REAL RESDU(NDXY),WEIGHTS(NDXY),AW(NDXY),C(NMXV,NDXX)
       INTEGER NMVAL(NDXY),JNDVC(NDXX)       
       
C       DIMENSION X(NDXX,NDXY),Y(NDXY),XMED(NDXX),XMAD(NDXX)
C       DIMENSION RESDU(NDXY),WEIGHTS(NDXY),AW(NDXY),NMVAL(NDXY)
C       DIMENSION C(NMXV,NDXX),JNDVC(NDXX)

       DOUBLE PRECISION H(NMXV,NDXX)
       CHARACTER*10 LAB(NDXX)
CC-----IN THIS SUBROUTINE THE VECTOR "RESDU" WILL BE USED AS A
CC-----WORKING VECTOR
       AL=NCAS
       IF (JCST.NE.0) GOTO 60
       DO 50 J=1,NVAD
       XMED(J)=0.0
       DO 10 JNC=1,NCAS
 10    RESDU(JNC)=ABS(X(J,JNC))
       XMAD(J)=AMDAN(AW,NDXY,RESDU,NCAS)*1.4826
       IF (ABS(XMAD(J)).GT.PREC) GOTO 30
       XMAD(J)=0.0
       DO 20 JNC=1,NCAS
 20    XMAD(J)=XMAD(J)+RESDU(JNC)
       XMAD(J)=(XMAD(J)/AL)*1.2533
       IF (ABS(XMAD(J)).GT.PREC) GOTO 30
       WRITE(LUB,8000) LAB(J)
       NSTOP=1
       RETURN
 30    DO 40 JNC=1,NCAS
       X(J,JNC)=X(J,JNC)/XMAD(J)
 40    CONTINUE
 50    CONTINUE
       WRITE(LUB,8015)
       GOTO 150
 60    DO 120 J=1,NVAD
       IF(J.EQ.NVAR) GOTO 120
       DO 70 JNC=1,NCAS
 70    RESDU(JNC)=X(J,JNC)
       XMED(J)=AMDAN(AW,NDXY,RESDU,NCAS)
       DO 80 JNC=1,NCAS
 80    RESDU(JNC)=ABS(RESDU(JNC)-XMED(J))
       XMAD(J)=AMDAN(AW,NDXY,RESDU,NCAS)*1.4826
       IF (ABS(XMAD(J)).GT.PREC) GOTO 100
       XMAD(J)=0.0
       DO 90 JNC=1,NCAS
 90    XMAD(J)=XMAD(J)+RESDU(JNC)
       XMAD(J)=(XMAD(J)/AL)*1.2533
       IF (ABS(XMAD(J)).GT.PREC) GOTO 100
       WRITE(LUB,8000) LAB(J)
       NSTOP=1
       RETURN
 100   DO 110 JNC=1,NCAS
       X(J,JNC)=(X(J,JNC)-XMED(J))/XMAD(J)
 110   CONTINUE
 120   CONTINUE
       XMED(NVAR)=1.0
       WRITE(LUB,8010)
       IF (JCST.EQ.1) WRITE(LUB,8020) (LAB(J),J=1,NVSB),LAB(NVAD)
       IF (JCST.EQ.0) WRITE(LUB,8020) (LAB(J),J=1,NVAD)
       IF ((NVAD.GT.6.AND.JCST.EQ.0).OR.(NVAD.GT.7.AND.JCST.EQ.1))
     1 GOTO 130
       IF (JCST.EQ.0) WRITE(LUB,8030)(XMED(J),J=1,NVAD)
       IF (JCST.EQ.1) WRITE(LUB,8030)(XMED(J),J=1,NVSB),XMED(NVAD)
       GOTO 140
 130   WRITE(LUB,8030)(XMED(J),J=1,6)
       IF (JCST.EQ.0) WRITE(LUB,8040)(XMED(J),J=7,NVAD)
       IF (JCST.EQ.1.AND.NVSB.GE.7)
     1 WRITE(LUB,8040)(XMED(J),J=7,NVSB),XMED(NVAD)
       IF (JCST.EQ.1.AND.NVSB.LT.7) WRITE(LUB,8040) XMED(NVAD)
 140   XMED(NVAR)=0.0
       WRITE(LUB,8050)
       IF (JCST.EQ.1) WRITE(LUB,8020) (LAB(J),J=1,NVSB),LAB(NVAD)
       IF (JCST.EQ.0) WRITE(LUB,8020) (LAB(J),J=1,NVAD)
 150   IF((NVAD.GT.6.AND.JCST.EQ.0).OR.(NVAD.GT.7.AND.JCST.EQ.1))
     1 GOTO 160
       IF (JCST.EQ.0) WRITE(LUB,8030)(XMAD(J),J=1,NVAD)
       IF (JCST.EQ.1) WRITE(LUB,8030)(XMAD(J),J=1,NVSB),XMAD(NVAD)
       GOTO 170
 160   WRITE(LUB,8030)(XMAD(J),J=1,6)
       IF (JCST.EQ.0) WRITE(LUB,8040)(XMAD(J),J=7,NVAD)
       IF (JCST.EQ.1.AND.NVSB.GE.7)
     1 WRITE(LUB,8040)(XMAD(J),J=7,NVSB),XMAD(NVAD)
       IF (JCST.EQ.1.AND.NVSB.LT.7) WRITE(LUB,8040) XMAD(NVAD)
 170   IF(JCST.NE.0) XMAD(NVAR)=1.0
       IF (JPRT.LT.2) GOTO 200
       WRITE(LUB,8060)
       IF (JCST.EQ.1) WRITE(LUB,8020) (LAB(J),J=1,NVSB),LAB(NVAD)
       IF (JCST.EQ.0) WRITE(LUB,8020) (LAB(J),J=1,NVAD)
       DO 190 JNC=1,NCAS
       IF((NVAD.GT.6.AND.JCST.EQ.0).OR.(NVAD.GT.7.AND.JCST.EQ.1))
     1 GOTO 180
       IF (JCST.EQ.1) WRITE(LUB,8070) NMVAL(JNC),(X(J,JNC),J=1,NVSB),
     1 X(NVAD,JNC)
       IF (JCST.EQ.0) WRITE(LUB,8070) NMVAL(JNC),(X(J,JNC),J=1,NVAD)
       GOTO 190
 180   WRITE(LUB,8070) NMVAL(JNC),(X(J,JNC),J=1,6)
       IF (JCST.EQ.1.AND.NVSB.GE.7)
     1 WRITE(LUB,8040) (X(J,JNC),J=7,NVSB),X(NVAD,JNC)
       IF (JCST.EQ.1.AND.NVSB.LT.7) WRITE(LUB,8040) X(NVAD,JNC)
       IF (JCST.EQ.0) WRITE(LUB,8040) (X(J,JNC),J=7,NVAD)
 190   CONTINUE
 200   IF(JPRT.EQ.0) GOTO 260
       DO 220 JSPA=1,NVAR
       IF(JSPA.EQ.NVAR.AND.JCST.EQ.1) GOTO 220
       JS=JSPA+1
       DO 210 JSPB=JS,NVAD
       IF(JSPB.EQ.NVAR.AND.JCST.EQ.1) GOTO 210
       JSM=JSPB-1
       CALL CORR(X,JSPB,JSPA,NCAS,NVSB,JCST,AW,Y,RESDU,NDXX,NDXY,
     1 SPEAR,PEARC,PREC)
       C(JSM,JSPA)=SPEAR
       H(JSM,JSPA)=PEARC
 210   CONTINUE
 220   CONTINUE
       WRITE(LUB,8080) LAB(NVAD)
       DIAG=1.0
       WRITE(LUB,8090) LAB(1),DIAG
       DO 230 JSPA=1,NVSB
       JSPP=JSPA+1
       IF(JCST.EQ.1.AND.JSPP.EQ.NVAR) GOTO 230
       WRITE(LUB,8090) LAB(JSPP),(H(JSPA,JSPB),JSPB=1,JSPA),DIAG
 230   CONTINUE
       IF(JCST.EQ.1) WRITE(LUB,8090) LAB(NVAD),(H(JSPA,JSPB),
     1 JSPB=1,NVSB),DIAG
       IF (JCST.EQ.0) WRITE(LUB,8090) LAB(NVAD),(H(JSPA,JSPB),
     1 JSPB=1,NVAR),DIAG
       DO 240 J=1,NVAR
 240   JNDVC(J)=J
       WRITE(LUB,8100) LAB(NVAD)
       WRITE(LUB,8090) LAB(1),DIAG
       DO 250 JSPA=1,NVSB
       JSPP=JSPA+1
       IF(JCST.EQ.1.AND.JSPP.EQ.NVAR) GOTO 250
       WRITE(LUB,8090) LAB(JSPP),(C(JSPA,JSPB),JSPB=1,JSPA),DIAG
 250   CONTINUE
       IF(JCST.EQ.1) WRITE(LUB,8090) LAB(NVAD),(C(JSPA,JSPB),
     1 JSPB=1,NVSB),DIAG
       IF (JCST.EQ.0) WRITE(LUB,8090) LAB(NVAD),(C(JSPA,JSPB),
     1 JSPB=1,NVAR),DIAG
 260   DO 270 JNC=1,NCAS
CC-----MEANWHILE, INITIALIZATION OF THE WEIGHTS
       WEIGHTS(JNC)=1.0
       Y(JNC)=X(NVAD,JNC)
 270   CONTINUE
 8000  FORMAT(/' VARIABLE WITH LABEL ',A10,' IS CONSTANT OVER'/
     1 ' ALL OBSERVATIONS HENCE THE PROGRAM CANNOT RUN.',
     1 /' PLEASE REPEAT THE ANALYSIS WITHOUT THIS VARIABLE.'/)
 8010  FORMAT(//' MEDIANS  = '/)
 8015  FORMAT(//' DISPERSION OF ABSOLUTE VALUES = '/)
 8020  FORMAT(7X,6(A10,1X)/15X,5(A10,1X))
 8030  FORMAT(7X,6(F10.4,1X))
 8040  FORMAT(15X,5(F10.4,1X))
 8050  FORMAT(//' DISPERSIONS = '/)
 8060  FORMAT(//' THE STANDARDIZED OBSERVATIONS ARE:'/)
 8070  FORMAT(I5,2X,6(F10.4,1X))
 8080  FORMAT(//' PEARSON CORRELATION COEFFICIENTS',
     1 ' BETWEEN THE VARIABLES'/1X,'( ',
     1 A10,' IS THE RESPONSE VARIABLE)'/)
 8090  FORMAT(1X,A10,(2X,11F6.2)/)
 8100  FORMAT(//' SPEARMAN RANK CORRELATION COEFFICIENTS',
     1 ' BETWEEN THE VARIABLES'/1X,'( ',A10,
     1 ' IS THE RESPONSE VARIABLE)'/ )
       RETURN
       END
CC
CC  *CORR* : CALCULATES THE SPEARMAN RANK CORRELATION COEFFICIENT
CC             BETWEEN VARIABLES JSPA AND JSPB.
       SUBROUTINE CORR(X,JSPB,JSPA,NCAS,NVSB,JCST,AW,Y,RESDU,NDXX,NDXY,
     1 SPEAR,PEARC,PREC)

C       INCLUDE 'MID_REL_INCL:implicit.inc'
C       DIMENSION X(NDXX,NDXY),AW(NDXY),Y(NDXY),RESDU(NDXY)
        INTEGER JCST,JSPA,JSPB,JTA,K,KK,NCM,NDX,NDXX,NDXY,NCAS
        INTEGER NJ,NJA,NJAP,NJB,NJP,NTWE,NVSB
        REAL AL,CVVAR,PEARC,PREC,SPEAR,SUMA,SUMB,STDA,STDB,TA,TB,W

        REAL X(NDXX,NDXY),AW(NDXY),Y(NDXY),RESDU(NDXY)
       
       
CC-----IN THIS SUBROUTINE THE VECTOR "RESDU" IS USED AS A WORKING
CC-----VECTOR FOR CALCULATING THE CORRELATION MATRICES
       SPEAR=0.0
       SUMA=0.0
       SUMB=0.0
       STDA=0.0
       STDB=0.0
       CVVAR=0.0
       AL=NCAS
       IF (((JSPB-JSPA).EQ.1).OR.(JCST.EQ.1.AND.JSPA.EQ.NVSB))
     1 GOTO  5
       GOTO 105
 5     NTWE=0
       DO 10 NJ=1,NCAS
       AW(NJ)=X(JSPA,NJ)
       RESDU(NJ)=NJ
 10    CONTINUE
       NCM=NCAS-1
 15    DO 20 NJ=1,NCM
       NJP=NJ+1
       NJA=NJ
       DO 30 NJB=NJP,NCAS
       IF(AW(NJB).GE.AW(NJA)) GOTO 30
       NJA=NJB
 30    CONTINUE
       IF(NJA.EQ.NJ) GOTO 20
       W=AW(NJ)
       AW(NJ)=AW(NJA)
       AW(NJA)=W
       W=RESDU(NJA)
       RESDU(NJA)=RESDU(NJ)
       RESDU(NJ)=W
 20    CONTINUE
       DO 40 NJ=1,NCAS
       NDX=RESDU(NJ)
       IF(NTWE.EQ.0) Y(NDX)=NJ
       IF(NTWE.NE.0) AW(NDX)=NJ
 40    CONTINUE
       NJ=1
 55    TA=1
       NJA=RESDU(NJ)
       IF(NTWE.EQ.0) TB=Y(NJA)
       IF(NTWE.NE.0) TB=AW(NJA)
 60    NJA=RESDU(NJ)
       NJAP=RESDU(NJ+1)
       IF(NTWE.EQ.0.AND.(X(JSPA,NJA).NE.X(JSPA,NJAP))) GOTO 70
       IF(NTWE.NE.0.AND.(X(JSPB,NJA).NE.X(JSPB,NJAP))) GOTO 70
       TA=TA+1.0
       IF(NTWE.EQ.0) TB=TB+Y(NJAP)
       IF(NTWE.NE.0) TB=TB+AW(NJAP)
       NJ=NJ+1
       IF (NJ.EQ.NCAS) GOTO 70
       GOTO 60
 70    IF(TA.EQ.1.0) GOTO 100
       JTA=TA
       NJB=NJ+1-JTA
       DO 80 K=NJB,NJ
       KK=RESDU(K)
       IF(NTWE.EQ.0) Y(KK)=TB/TA
       IF(NTWE.NE.0) AW(KK)=TB/TA
 80    CONTINUE
 100   NJ=NJ+1
       IF (NJ.LT.NCAS) GOTO 55
       IF(NTWE.NE.0) GOTO 150
 105   DO 110 NJ=1,NCAS
       AW(NJ)=X(JSPB,NJ)
       RESDU(NJ)=NJ
       SUMA=SUMA+X(JSPA,NJ)
       SUMB=SUMB+X(JSPB,NJ)
 110   CONTINUE
       SUMA=SUMA/AL
       SUMB=SUMB/AL
       NTWE=1
       GOTO 15
 150   DO 120 NJ=1,NCAS
       SPEAR=SPEAR+(Y(NJ)-AW(NJ))**2
       STDA=STDA+(X(JSPA,NJ)-SUMA)**2
       STDB=STDB+(X(JSPB,NJ)-SUMB)**2
       CVVAR=CVVAR+(X(JSPA,NJ)-SUMA)*(X(JSPB,NJ)-SUMB)
 120   CONTINUE
       SPEAR=1.0-6.0*SPEAR/(AL*(AL**2-1.0))
       STDA=SQRT(STDA*STDB)
       IF(ABS(STDA).GT.PREC) PEARC=CVVAR/(STDA)
       IF(ABS(STDA).LE.PREC) PEARC=99.99
       RETURN
       END
CC
CC  *PULL* : SEARCHES THE KTH VALUE IN A VECTOR
CC             OF LENGTH 'NCAS'.
       FUNCTION PULL(AW,NDXY,AA,NCAS,K)

C       INCLUDE 'MID_REL_INCL:implicit.inc'
C       DIMENSION AA(NCAS),AW(NDXY)

       INTEGER J,JNC,K,L,LR,NCAS,NDXY
       REAL AX,PULL,WA

       REAL AA(NCAS),AW(NDXY)




       DO 10 JNC=1,NCAS
 10    AW(JNC)=AA(JNC)
       L=1
       LR=NCAS
 20    IF(L.GE.LR) GOTO 90
       AX=AW(K)
       JNC=L
       J=LR
 30    IF(JNC.GT.J) GOTO 80
 40    IF(AW(JNC).GE.AX) GOTO 50
       JNC=JNC+1
       GOTO 40
 50    IF(AW(J).LE.AX) GOTO 60
       J=J-1
       GOTO 50
 60    IF(JNC.GT.J) GOTO 70
       WA=AW(JNC)
       AW(JNC)=AW(J)
       AW(J)=WA
       JNC=JNC+1
       J=J-1
 70    GOTO 30
 80    IF(J.LT.K) L=JNC
       IF (K.LT.JNC) LR=J
       GOTO 20
 90    PULL=AW(K)
       RETURN
       END
CC
CC  *AMDAN* : CALCULATES THE MEDIAN OF A VECTOR
CC              OF LENGTH 'NCAS'.

       FUNCTION AMDAN(AW,NDXY,AA,NCAS)

C       INCLUDE 'MID_REL_INCL:implicit.inc'
C       DIMENSION AA(NCAS),AW(NDXY)

       INTEGER JNDL,NCAS,NDXY
       REAL AL,AMDAN,PULL

       REAL AA(NCAS),AW(NDXY)

       AL=NCAS
       JNDL=INT(AL/2.0)
       IF (MOD(NCAS,2).EQ.0) THEN
          AMDAN= (PULL(AW,NDXY,AA,NCAS,JNDL)+
     1                    PULL(AW,NDXY,AA,NCAS,JNDL+1))/2.0
                             ELSE
       AMDAN= PULL(AW,NDXY,AA,NCAS,JNDL+1)
       ENDIF
       RETURN
       END
CC
CC  *RSQU* : CALCULATES COEFFICIENT OF DETERMINATION AND F-VALUE
CC           OF LS OR RLS
CC
       FUNCTION RSQU(NCAS,NVAD,JCST,Y,NDXY,SSE,FVALUE,PREC,
     1 XMAD,XMED,NDXX,WEIGHTS,NNUL)

C       INCLUDE 'MID_REL_INCL:implicit.inc'
C       DIMENSION Y(NDXY),XMAD(NDXX),XMED(NDXX),WEIGHTS(NDXY)

       INTEGER  JCST,JNC,NCAS,NDXX,NDXY,NNUL,NVAD
       REAL  AL,DF1,DF2,FVALUE,PREC,RSQU,RYM,SSE,SSEL,SST

       REAL Y(NDXY),XMAD(NDXX),XMED(NDXX),WEIGHTS(NDXY)



       RYM=0.0
       IF (JCST.EQ.0) GOTO 20
       DO 10 JNC=1,NCAS
 10    RYM=(Y(JNC)*XMAD(NVAD)+XMED(NVAD))*WEIGHTS(JNC)+RYM
       AL=NNUL
       RYM=RYM/AL
 20    SST=0.0
       DO 30 JNC=1,NCAS
 30    SST=SST+(((Y(JNC)*XMAD(NVAD)+XMED(NVAD))-RYM)**2)*WEIGHTS(JNC)
       DF1=(NVAD-1)-JCST
       DF2=NNUL-(NVAD-1)
       IF(SST.LT.PREC)SST=PREC
       RSQU=1.0-(SSE/SST)
       IF (RSQU.LT.0.0) RSQU=0.0
       IF (RSQU.GT.1.0) RSQU=1.0
       SSEL=SSE
       IF(SSEL.LT.PREC)SSEL=PREC
       FVALUE=((SST-SSEL)/DF1)/(SSEL/DF2)
       IF(FVALUE.LT.(0.0))FVALUE=0.0
       RETURN
       END
CC
CC  *RESTT* : CALCULATES FOR ALL JNC (JNC=1,..,NCAS) THE RESIDUAL
CC              Y(JNC)-SUM (GESCF(J)*X(J,JNC)), FOR J=1,..,LTSTE.

       SUBROUTINE RESTT(GESCF,JABS,JTR,LTSTE,NCAS,NVAD,NZWE,
     1 X,Y,RESDU,WEIGHTS,XMED,XMAD,NDXX,NDXY,NOPT,SCAL,QUAN,PREC)

C       INCLUDE 'MID_REL_INCL:implicit.inc'
C       DIMENSION GESCF(LTSTE),X(NDXX,NDXY),Y(NDXY),WEIGHTS(NDXY)
C       DIMENSION RESDU(NDXY),XMED(NDXX),XMAD(NDXX)

       INTEGER J,JABS,JNC,JTR,LTSTE,NCAS,NDXX,NDXY,NOPT,NVAD,NZWE
       REAL ANVAR,AVLQS,PREC,QUAN,SCAL,WSC

       REAL GESCF(LTSTE),X(NDXX,NDXY),Y(NDXY),WEIGHTS(NDXY)
       REAL RESDU(NDXY),XMED(NDXX),XMAD(NDXX)



CC-----JTR = 1, THEN CALCULATE THE RESIDUALS FOR THE STANDARDIZED OBSERVATIONS
CC-----      0         "      "             "              RAW
CC-----JABS = 1, CALCULATE THE ABSOLUTE RESIDUALS
CC-----       0                RESIDUALS
CC-----NOPT = 1, CALCULATE THE LMS FINAL SCALE AND THE RESULTING WEIGHTS
CC-----       0, OTHERWISE
       NZWE=0
       SCAL=0.0
       AVLQS=0.0
       ANVAR=NVAD-1
       DO 10 JNC=1,NCAS
       IF (JTR.NE.1)  THEN
          RESDU(JNC)=Y(JNC)
                      ELSE
          RESDU(JNC)=Y(JNC)*XMAD(NVAD)+XMED(NVAD)
       ENDIF
       DO 20 J=1,LTSTE
       IF (JTR.NE.1) THEN
          RESDU(JNC)=RESDU(JNC)-X(J,JNC)*GESCF(J)
                     ELSE
          RESDU(JNC)=RESDU(JNC)-((X(J,JNC)*XMAD(J)+XMED(J))*GESCF(J))
       ENDIF
 20    CONTINUE
       IF (JABS.EQ.1.AND.NOPT.NE.1) RESDU(JNC)=ABS(RESDU(JNC))
       IF (ABS(RESDU(JNC)).LT.PREC) NZWE=NZWE+1
       IF (NOPT.EQ.0) GOTO 10
       IF (ABS(RESDU(JNC)).LE.(2.5*QUAN)) THEN
          WSC=1.0
                                     ELSE
          WSC=0.0
       ENDIF
       AVLQS=AVLQS+WSC
       SCAL=SCAL+(RESDU(JNC)*RESDU(JNC))*WSC
 10    CONTINUE
C       write(6,*) 'In PRC/RESTT: NOPT = ',NOPT
       IF (NOPT.EQ.0) RETURN
       SCAL=SQRT(SCAL/(AVLQS-ANVAR)) + PREC
       NZWE=0
       DO 40 JNC=1,NCAS
       IF (ABS(RESDU(JNC)).LE.(2.5*SCAL)) THEN
          WEIGHTS(JNC)=1.0
          NZWE=NZWE+1
                                          ELSE
          WEIGHTS(JNC)=0.0
       ENDIF
C       write(6,*) 'In PRC: ',jnc,resdu(jnc),scal,nzwe,weights(jnc)
 40    CONTINUE
       RETURN
       END

C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION        ISTFN2.FOR
C.AUTHOR:               J.D.PONZ  ESA-VILSPA        
C.KEYWORDS              IUE, GO FORMAT, FILE HEADER
C.ENVIRONMENT           VMS
C.PURPOSE
C \begin{TeX}
C    Defines the file name as <{\tt root}><{\tt number}>
C    where 
C   \begin{description}
C    \item[{\tt root}] is a character string and
C    \item[{\tt number}] is a four digit number, position of the file on tape 
C   \end{description}
C \end{TeX}
C.LANGUAGE              F77
C.VERSION: 1.0  INITIAL CODING  09 JUL 1990
C------------------------------------------------------------------
      SUBROUTINE ISTFN2(FID,NUMBER,FILE)
C
      IMPLICIT NONE
      CHARACTER*(*) FID               ! IN: root filename
      INTEGER       NUMBER            ! IN: sequential number
      CHARACTER*(*) FILE              ! OUT: filename
C
      INTEGER       I, INDEX
C
      FILE = FID
      I    = INDEX(FILE,' ') 
      WRITE(FILE(I:I+4),1000) NUMBER
      RETURN
 1000 FORMAT(I4.4)
      END

C @(#)sinc.for	19.1 (ES0-DMD) 02/25/03 13:17:44
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE SINC(X,NP,PARAM,Y1,DERIV)                                      
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                  
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  18:01 - 21 DEC 1987                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C--------------------------------------------------------------                 
C                                                                               
C SINC                                                                          
C      IMPLICIT NONE                                                            
C Y = P(1)*SINC(P(2)+P(3)*X)                                                    
C                                                                               
      REAL X
      INTEGER NP
      DOUBLE PRECISION Y1,PARAM(NP),DERIV(NP)                                   
      DOUBLE PRECISION W                                                        
C                                                                               
      W      = PARAM(3)*X + PARAM(2)                                            
      IF (DABS(W).LT.10.E-20) THEN                                              
          Y1     = PARAM(1)                                                     
          DERIV(1) = 1.D0                                                       
          DERIV(2) = 0.D0                                                       
          DERIV(3) = 0.D0                                                       
                                                                                
      ELSE                                                                      
          DERIV(1) = DSIN(W)/W                                                  
          Y1     = DERIV(1)*PARAM(1)                                            
          DERIV(2) = PARAM(1)* (W*DCOS(W)-DSIN(W))/ (W*W)                       
          DERIV(3) = X*DERIV(2)                                                 
      END IF                                                                    
                                                                                
      RETURN                                                                    
                                                                                
      END                                                                       

C===========================================================================
C Copyright (C) 1995-2008 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM FRIPLE
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  11:28 - 7 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.Ponz, but I did not code it!
C
C.IDENTIFICATION
C  program    FRIPPLE              version 1.0          851030
C                                  correct some bugs    900619  MP
C
C.Keywords
C  filtering
C
C.PURPOSE
C  correct 1-D images for periodic modulation (FRIPLE)
C
C.ALGORITHM
C  Fold flux with period, calculate mean flux per phase bin, determine
C  deviation from total mean, adjust to mean level.
C
C.INPUT/OUTPUT
C the following keywords are used:
C IN_A/C/1/8           name of input image
C INPUTR/R/1/1         period
C INPUTI/I/1/2         first and last pixel to be considered
C OUT_A/C/1/8          name of ripple corrected image
C
C.VERSIOn
C 080717	last modif
C 
C --------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      MADRID
      CHARACTER*60 INIMA,OUTIMA
      CHARACTER*80 OUTEXT,HISTOR
      CHARACTER    IDENT*72,CUNIT*64
      INTEGER      NAXIS,NPIX,ISTAT,IAV
      INTEGER*8    PNTRIN,PNTRO
      INTEGER      RANGE(2),ERROR(2),NWORK
      INTEGER      NBIN,I,SCNPIX
      INTEGER*8    SCRPTR
      INTEGER      KUN,KNUL,IMIN,IMOUT
      REAL         PERIOD,AMP(500),TEST
C
      DOUBLE PRECISION DSTART(3),DSTEP(3)
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'

      COMMON /VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'

C
C ... set up MIDAS environment
C
      CALL STSPRO('FRIPLE')
C
C ... get name of input frame, map it
C
      CALL STKRDC('IN_A',1,1,60,IAV,INIMA,KUN,KNUL,ISTAT)
      IF (ISTAT.NE.0) GO TO 20
      CALL STIGET(INIMA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,1,NAXIS,NPIX,
     +     DSTART,DSTEP,IDENT,CUNIT,PNTRIN,IMIN,ISTAT)
      IF (ISTAT.NE.0) GO TO 20
      IF (NAXIS.NE.1) THEN
          CALL STTPUT('ERROR: input frame must be one-dimensional',
     +                ISTAT)
          ERROR(1) = 1
          GO TO 20
      END IF
C
C ... get name of output frame, map it
C
      CALL STKRDC('OUT_A',1,1,60,IAV,OUTIMA,KUN,KNUL,ISTAT)
      CALL STIPUT(OUTIMA,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,NAXIS,NPIX,
     +            DSTART,DSTEP,IDENT,CUNIT,PNTRO,IMOUT,ISTAT)
C
C  ...  get period, branch according to type (integer or real) of
C  ...  period to subroutines IAMPLT or RAMPLT to find 
C  ...  amplitude of modulation
C
      CALL STKRDR('INPUTR',1,1,IAV,PERIOD,KUN,KNUL,ISTAT)
C
      CALL STKRDI('INPUTI',1,2,IAV,RANGE,KUN,KNUL,ISTAT)
C
      TEST   = PERIOD - INT(PERIOD)
C  !   period near-integer?
      IF (TEST*NPIX/PERIOD.LT.0.05) THEN
          NBIN   = PERIOD
          CALL IAMPLT(MADRID(PNTRIN),PERIOD,RANGE,AMP)  !   no, real
      ELSE  !   use a fixed number of 20 phase bins
          NBIN   = 20
C
C ... in this case, map SCRAT file to hold intermediate results
C ... first, determine number of pixels needed
C
          SCNPIX = INT(20*NPIX/PERIOD)
          NWORK  = SCNPIX*4
          CALL TDMGET(NWORK,SCRPTR,ISTAT)
          CALL RAMPLT(MADRID(PNTRIN),SCNPIX,PERIOD,RANGE,AMP,
     +                    MADRID(SCRPTR))
      END IF
C
C ... communicate results:
C
      CALL STTPUT('Results:',ISTAT)
      DO 10 I = 1,NBIN,4
          WRITE (OUTEXT,9000) I,I + 3,AMP(I),AMP(I+1),AMP(I+2),
     +      AMP(I+3)
          CALL STTPUT(OUTEXT,ISTAT)
   10 CONTINUE
C
C ... the ripple correction is, then, done by subroutines
C ... IRIPC and RRIPC, respectively
C
      IF (TEST*NPIX/PERIOD.LT.0.05) THEN
          CALL IRIPC(MADRID(PNTRIN),NPIX,PERIOD,RANGE,AMP,
     +                 MADRID(PNTRO))
      ELSE
          CALL RRIPC(MADRID(PNTRIN),NPIX,PERIOD,RANGE,AMP,
     +                 MADRID(SCRPTR),SCNPIX,MADRID(PNTRO))
      END IF
C
C ... copy descriptor LHCUTS
C
      CALL STDCOP(IMIN,IMOUT,4,'LHCUTS',ISTAT)
C
C ... copy and update descriptor HISTOR
C
      CALL STDCOP(IMIN,IMOUT,4,'HISTORY',ISTAT)
      CALL STKRDC('HISTORY',1,1,80,IAV,HISTOR,KUN,KNUL,ISTAT)
      CALL STDWRC(IMOUT,'HISTOR',1,HISTOR,-1,80,KUN,ISTAT)
C
C ... the end
C
      CALL STSEPI
      STOP 
C
C ... direct trouble makers here:
C
   20 ERROR(1) = ISTAT
      CALL STKWRI('PROGSTAT',ERROR,1,2,KUN,ISTAT)
      CALL STSEPI
      STOP 
C
 9000 FORMAT ('Phase bins No.',I3,' to',I3,' have ','amplitudes ',
     +       3 (F7.4,1X),F7.4)
      END
C
C
C
      SUBROUTINE IAMPLT(IN,PERIOD,RANGE,AMP)
C
C
      INTEGER NCYCL,I,J,RANGE(2),IPER, IR1, IR2
      REAL PERIOD,IN(1),AMP(500),SUM(500),MEAN
C  !   consider only integer number of cycles
      NCYCL  = INT((RANGE(2)-RANGE(1)+1)/PERIOD)
C
      IPER = PERIOD
      DO 10 I = 1,IPER
          SUM(I) = 0
   10 CONTINUE
C
C ... build up flux in phase bins
C ... to compensate for slopes in input data, refer to mean 
C ... flux per cycle
C
      IR1 = RANGE(1)
      IR2 = RANGE(1) + (NCYCL-1)*PERIOD
      DO 40 I = IR1, IR2,IPER
          MEAN   = 0
          DO 20 J = 1,IPER
              MEAN   = MEAN + IN(I+J-1)
   20     CONTINUE  !   average flux in one cycle
          MEAN   = MEAN/PERIOD
          DO 30 J = 1, IPER
              SUM(J) = SUM(J) + IN(I+J-1)/MEAN
   30     CONTINUE
   40 CONTINUE
C
C  ... division into mean flux yields the relative amplitude of
C  ... each phase bin
C
      MEAN   = 0
      DO 50 I = 1,IPER
          MEAN   = MEAN + SUM(I)
   50 CONTINUE
      MEAN   = MEAN/PERIOD
C
      DO 60 I = 1,IPER
          AMP(I) = MEAN/SUM(I)
   60 CONTINUE
C
      RETURN

      END
C
C
C
      SUBROUTINE IRIPC(IN,NPIX,PERIOD,RANGE,AMP,OUT)
C
C
      INTEGER RANGE(2),NPIX,OFF,PHASE,I,J,INDX,IPER
      REAL IN(1),OUT(1),PERIOD,AMP(500)
C
C ... take into account possible phase offset introduced if RANGE
C ... was not defaulted to [1,NPIX]
C
      OFF    = NINT(((RANGE(1)-1.)/PERIOD-INT((RANGE(1)-1.)/PERIOD))*
     +         PERIOD)
C
      IPER = PERIOD
      DO 20 I = 1,NPIX,IPER
          DO 10 J = 1,IPER
              INDX  = I + J - 1
              IF (INDX.GT.NPIX) GO TO 30
              PHASE  = OFF + J
              IF (PHASE.GT.PERIOD) PHASE  = PHASE - PERIOD  !   do the FRIPLE compensation
              OUT(INDX) = IN(INDX)*AMP(PHASE)
   10     CONTINUE
   20 CONTINUE
C
   30 RETURN
      END
C
C
C
      SUBROUTINE RAMPLT(IN,SCNPIX,PERIOD,RANGE,AMP,SCRAT)
C
      INTEGER RANGE(2),PIXLO,PIXHI,I,J,SCNPIX,BIN,START,OFF,END
      REAL PERIOD,IN(1),AMP(500),SUM(20),FRACLO,FRACHI,XLO,XHI,MEAN,
     +     SCRAT(1),STEP
C
      DO 10 I = 1,20
          SUM(I) = 0.
   10 CONTINUE
C
C ... rebin to stepsize corresponding to one phasebin
C ... the algorithm is a pure projection, no interpolation is done
C ... (since the origin and nature of the ripple are not known)
C
      STEP   = 0.05*PERIOD
      DO 30 I = 1,SCNPIX  !   ith pixel extends from i to i+1 in both spaces
          XLO    = (I-1)*STEP + 1  !   lower and upper limit of projected output pixel
          XHI    = XLO + STEP
          PIXLO  = INT(XLO)
          PIXHI  = INT(XHI)  !   all in same output pixel
          IF ((PIXHI-PIXLO).EQ.0) THEN
              FRACLO = XHI - XLO
              SCRAT(I) = FRACLO*IN(PIXLO)  !   at least two output pixels hit
          ELSE
              FRACLO = PIXLO + 1 - XLO
              FRACHI = XHI - PIXHI
              SCRAT(I) = FRACLO*IN(PIXLO) + FRACHI*IN(PIXHI)  !   if in fact more than two
              DO 20 J = PIXLO + 1,PIXHI - 1
                  SCRAT(I) = SCRAT(I) + IN(J)
   20         CONTINUE
          END IF

   30 CONTINUE
C
C ... evaluate the periodicity over the given range
C ... do so over an integer number of periods
C ... compensate for a slope in the input data by averaging over
C ... one cycle of 20 pixels each
C
      START  = 20*INT((RANGE(1)-1.)/PERIOD) + 1  !   phase offset due to zeropoint used
      OFF    = 20*INT((RANGE(1)-1.)/PERIOD) + 1 - START
      END    = 20*INT((RANGE(2)-1.)/PERIOD) + 1
      DO 60 I = START,END,20
          MEAN   = 0
          DO 40 J = 1,20
              MEAN   = MEAN + SCRAT(I+J-1)
   40     CONTINUE
          MEAN   = MEAN/20
          DO 50 J = 1,20
C              BIN    = JMOD(I+J-1+OFF,20) + 1
              BIN    = MOD(I+J-1+OFF,20) + 1
              SUM(BIN) = SUM(BIN) + SCRAT(I+J-1)/MEAN
   50     CONTINUE
   60 CONTINUE
C
C  ...  division into mean value yields the relative amplitudes of 
C  ...  each each phas
C
      MEAN   = 0
      DO 70 I = 1,20
          MEAN   = MEAN + SUM(I)
   70 CONTINUE
      MEAN   = MEAN/20.
C
      DO 80 I = 1,20
          AMP(I) = MEAN/SUM(I)
   80 CONTINUE
C
      RETURN

      END
C
C
C
      SUBROUTINE RRIPC(IN,NPIX,PERIOD,RANGE,AMP,SCRAT,SCNPIX,OUT)
C
C
      INTEGER RANGE(2),NPIX,SCNPIX,I,J,BIN,PIXLO,PIXHI
      REAL IN(1),OUT(1),PERIOD,AMP(500),XLO,XHI,FRACLO,FRACHI,
     +     SCRAT(1),STEP
C
      DO 10 I = 1,NPIX  !   initialize output frame to zero
          OUT(I) = 0
   10 CONTINUE
C
C ... here the amplitude correction is done
C
      DO 20 I = 1,SCNPIX
C          BIN    = JMOD(I,20) + 1
          BIN    = MOD(I,20) + 1
          SCRAT(I) = SCRAT(I)*AMP(BIN)
   20 CONTINUE
C
C ... finally rebin to step = 1 (as in the input frame)
C ... the algorithm is a pure projection, no interpolation is done
C ... (since the origin and nature of the ripple are not known)
C
      STEP   = 20/PERIOD
      DO 40 I = 1,NPIX
          XLO    = (I-1)*STEP + 1
          XHI    = XLO + STEP
          PIXLO  = INT(XLO)
          PIXHI  = INT(XHI)  !   all into one output pixel
          IF ((PIXHI-PIXLO).EQ.0) THEN
              FRACLO = XHI - XLO
              OUT(I) = OUT(I) + FRACLO*SCRAT(PIXLO)  !   at least two output pixels hit
          ELSE
              FRACLO = PIXLO + 1 - XLO
              FRACHI = XHI - PIXHI
              OUT(I) = OUT(I) + FRACLO*SCRAT(PIXLO) +
     +                 FRACHI*SCRAT(PIXHI)  !   if in fact more than two hit
              DO 30 J = PIXLO + 1,PIXHI - 1
                  OUT(I) = OUT(I) + SCRAT(J)
   30         CONTINUE
          END IF

   40 CONTINUE
C
      RETURN

      END

C @(#)tsaaov.for	19.1 (ESO-DMD) 02/25/03 13:33:25
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C  @(#)tsaaov.for	5.1 (ESO-IPG) 4/5/93 15:58:45
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT (c) 1992 European Southern Observatory & Copernicus Astron. Center
C.IDENT     tsaaov.for
C.AUTHOR    Alex Schwarzenberg-Czerny, Copernicus Astron. Center, Warsaw
C.KEYWORD   MIDAS, time series, AOV/TSA
C.LANGUAGE  FORTRAN 77
C.PURPOSE   Compute analysis of variance periodogramme
C.RETURNS   None
C.ENVIRON   TIME/ANAL context
C.VERSION   0.0               June 1992
C
C 021031	last modif
C 
C-----------------------------------------------------------------------------
C
C
      INCLUDE 'MID_REL_INCL:TSA_DEF.INC'
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      INTEGER      NAXIS
      PARAMETER    (NAXIS=2)
      REAL*8       START(NAXIS)         !  START FREQUENCY
      REAL*8       STEP(NAXIS)          !  STEP IN FREQUENCY
      INTEGER      LENGTH(NAXIS)        !  NUMBER OF FREQUENCIES
      INTEGER      ORDER                !  NUMBER OF BINS
      INTEGER      COVER                !  NUMBER OF BIN COVERAGES
      CHARACTER*60 INAME                !  NAME OF INPUT TABLE
      CHARACTER*60 ONAME                !  NAME OF OUTPUT IMAGE
C
      INTEGER      IACTS,KUN,KNUL
      INTEGER      TID,ITIME,IVAL
      INTEGER      NCOL,ICOL,NROW,IROW,ISOR
      INTEGER      LFIELD,TTYP,VTYP
      INTEGER      IDPER
      INTEGER*8    PTIME,PVAL,PPER
C 
      CHARACTER*10 FORM
      CHARACTER*80 TEXT
C
      INCLUDE 'MID_REL_INCL:TSA_DAT.INC'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C   Get parameters
C
      CALL STSPRO ('tsaaov')
      CALL STKRDC ('IN_A'  ,1,1,60,IACTS,INAME    ,KUN,KNUL,ISTAT)
      CALL STKRDC ('OUT_A', 1,1,60,IACTS,ONAME    ,KUN,KNUL,ISTAT)
      CALL STKRDD ('STARTTSA',
     $     1, 1,IACTS,START(1) ,KUN,KNUL,ISTAT)
      CALL STKRDD ('STEPTSA',
     $     1, 1,IACTS,STEP(1)  ,KUN,KNUL,ISTAT)
      CALL STKRDI ('NSTEPS',  1, 1,IACTS,LENGTH(1),KUN,KNUL,ISTAT)
      CALL STKRDI ('ORDERTSA',
     $     1, 1,IACTS,ORDER, KUN,KNUL,ISTAT)
      CALL STKRDI ('COVER',   1, 1,IACTS,COVER, KUN,KNUL,ISTAT)
      START(NAXIS)=  ZERO
      STEP(NAXIS)=   ONE
      LENGTH(NAXIS)= 2
C
C   Map input data
C
      CALL TBTOPN (INAME,F_I_MODE,TID,ISTAT)
      CALL TBIGET (TID,NCOL,NROW,ISOR,ICOL,IROW,ISTAT)
      CALL TBLSER (TID,'TIME',ITIME,ISTAT)
      IF (ITIME.LT.0) THEN
        CALL STETER(3,'Column :TIME not found')
      ENDIF
      CALL TBLSER (TID,'VALUE',IVAL,ISTAT)
      IF (IVAL.LT.0) THEN
        CALL STETER(3,'Column :VALUE not found')
      ENDIF
      CALL TBFGET (TID,ITIME,FORM,LFIELD,TTYP,ISTAT)
      CALL TBFGET (TID,IVAL, FORM,LFIELD,VTYP,ISTAT)
      CALL TBDGET (TID,ISTORE,ISTAT)
      IF (ISTORE.NE.F_TRANS) THEN
        TEXT='Input table '//INAME//' stored not transposed'
        CALL STETER(2,TEXT)
      ENDIF
      IF (TTYP.NE.D_R8_FORMAT.OR.VTYP.NE.D_R8_FORMAT) THEN
        CALL STETER(1,'Column(s) must be of DOUBLE PRECISION type')
      ENDIF
      CALL TBCMAP (TID,ITIME,PTIME,ISTAT)
      CALL TBCMAP (TID,IVAL, PVAL, ISTAT)
C
C   Map output data
C
      CALL STIPUT (ONAME,D_R8_FORMAT,F_IO_MODE,
     $   F_IMA_TYPE,NAXIS,LENGTH,
     $   START,STEP,ONAME,'AXIS: 1/TIME DATA: UNITLESS',
     $   PPER,IDPER,ISTAT)
C
C   Compute AOV periodogramme
C
      CALL TIMAOV (MADRID(PTIME),MADRID(PVAL),
     $    MADRID(PPER),NROW,LENGTH(1),
     $   START(1),STEP(1),ORDER,COVER)
C
C   Wind-up
C
      CALL DSCUPT(IDPER,IDPER,' ',ISTAT)
      CALL STSEPI
C
      END
C
C
C
      SUBROUTINE TIMAOV(T,X,Y,N,NFREQ,FREQIN,FSTEP,NORDER,NCOVER)
C
C     Analysis of Variance Periodogramme
C     Reference:   M.N.R.A.S. 241, 153
C     Alex Schwarzenberg-Czerny               Warsaw Observatory 1988
C
C
      INCLUDE  'MID_REL_INCL:TSA_DEF.INC'
C
      INTEGER  NORDER                   ! ORDER (NUMBER OF BINS)
      INTEGER  NCOVER                   ! NUMBER OF BIN COVERS
      INTEGER  N                        ! NUMBER OF OBSERVATIONS
      INTEGER  NFREQ                    ! NUMBER OF FREQUENCIES
      DOUBLE PRECISION   T(N),X(N)      ! TIMES AND VALUES OF OBSERVATIONS
      DOUBLE PRECISION   Y(NFREQ,2)     ! PERIODOGRAMME
      REAL*8   FREQIN,FSTEP             ! FREQUENCY START AND INCREMENT
C
      INTEGER  MAXORD
      PARAMETER(MAXORD=100)
C
      INTEGER      ICOVER,IF,I,NO,IBIN,NR
      INTEGER      NINCMPL,NINSUFF,NALL
      INTEGER      NBIN(MAXORD)
      DOUBLE PRECISION       BMEAN(MAXORD)
      DOUBLE PRECISION       T0,XM,VA,SAVE,COVER,VAR
      DOUBLE PRECISION       FREQ,XMEAN,S1,S2
      CHARACTER*80 TEXT
C
      INCLUDE 'MID_REL_INCL:TSA_CONST.INC'
C
      IF (NORDER.GT.MAXORD) THEN
        WRITE(TEXT,'(A,I3)')
     1     'WARNING: Used maximum alllowed order of ',MAXORD
        CALL STTPUT(TEXT,ISTAT)
        NORDER=MAXORD
      ENDIF
C
C   Set variables (incl. mean and variance)
C
             NINCMPL=0
             NINSUFF=0
             T0=T(1)
             XM=ZERO
             VA=ZERO
             DO 10 I=1,N
               XM=XM+X(I)
 10          CONTINUE
             XM=XM/N
             DO 11 I=1,N
               SAVE=X(I)-XM
               VA=VA+SAVE*SAVE
 11          CONTINUE
             DO 12 IF=1,NFREQ
               DO 14 I=1,2
                 Y(IF,I)=ZERO
 14            CONTINUE
 12          CONTINUE
C
C   Loop over coverages and frequencies
C
             DO 1 ICOVER=1,NCOVER
               COVER=(ICOVER-1.)/NCOVER
               NO=NORDER
               DO 7 IF=1,NFREQ
                 FREQ=((IF-1)*FSTEP+FREQIN)*NO
                 DO 3 IBIN=1,NO
                   BMEAN(IBIN)=ZERO
                   NBIN(IBIN)=0
 3               CONTINUE
C
C   Assign data to bins and add
C
                 DO 2 I=1,N
                   IBIN=1+MOD(INT((T(I)-T0)*FREQ+COVER),NO)
                   BMEAN(IBIN)=X(I)+BMEAN(IBIN)
                   NBIN(IBIN)=1+NBIN(IBIN)
 2               CONTINUE
C
C   Correct for incomplete bins
C
                 NR=NO
                 NALL=N
                 XMEAN=0.
                 VAR=VA
                 DO 4 IBIN=1,NO
                   BMEAN(IBIN)=BMEAN(IBIN)-NBIN(IBIN)*XM
                   IF (NBIN(IBIN).LE.1) THEN
                     NINCMPL=NINCMPL+1
                     NR=NR-1
                     XMEAN=XMEAN-BMEAN(IBIN)
                     VAR=VAR-BMEAN(IBIN)*BMEAN(IBIN)
                     NALL=NALL-NBIN(IBIN)
                   ENDIF
 4               CONTINUE
C
C    Calculate A.O.V. statistics for a given frequency
C
                 IF (NR.GT.1) THEN
                   XMEAN=XMEAN/NALL
                   S1=ZERO
                   DO 5 IBIN=1,NO
                     IF (NBIN(IBIN).GT.1) THEN
                       SAVE=BMEAN(IBIN)/NBIN(IBIN)-XMEAN
                       S1=SAVE*SAVE*NBIN(IBIN)+S1
                     ENDIF
 5                 CONTINUE
                   IF (S1.LT.VAR) THEN
                     S2=VAR-S1
                     Y(IF,1)=Y(IF,1)+S1/(NR-1)/S2*(NALL-NR)
                   ELSE
                     NINSUFF=NINSUFF+1
                     Y(IF,1)=Y(IF,1)+ONE
                     Y(IF,2)=MAX(Y(IF,2),ONE)
                     IF (NINSUFF.LE.1) THEN
                       CALL STTPUT(
     $                 'fatal calculation/rounding error',ISTAT)
                     ENDIF
                   ENDIF
                 ELSE
                   NINSUFF=NINSUFF+1
                   Y(IF,1)=Y(IF,1)+ONE
                   Y(IF,2)=MAX(Y(IF,2),TWO)
                 ENDIF
 7             CONTINUE
 1           CONTINUE
             DO 20 IF=1,NFREQ
               Y(IF,1)=Y(IF,1)/NCOVER
 20          CONTINUE
             IF (NINCMPL.GT.0.OR.NINSUFF.GT.0) THEN
               CALL STTPUT(
     $        'Statistics of bad events (see quality row for details):',
     $         ISTAT)
               WRITE(TEXT,'(2(i8,a))')
     $           NINCMPL,' underpopulated bins'
               CALL STTPUT(TEXT,ISTAT)
               WRITE(TEXT,'(2(i8,a))')
     $           NINSUFF,' of',NFREQ*NCOVER,
     $          ' bad frequencies'
               CALL STTPUT(TEXT,ISTAT)
             ENDIF
      Y(NFREQ,2)=TWO
      END
C

C  @(#)ftcomp.for	19.1 (ESO-DMD) 02/25/03 13:17:31 
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FTCOMP(ISTAT)                                                  
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                   
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:25 - 13 JAN 1988                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C.IDENTIFICATION                                                                
C                                                                               
C  FTCOMP.FOR
C                                                                               
C.PURPOSE                                                                       
C                                                                               
C  INTERFACE ROUTINES FOR THE FITTING STRUCTURES                                
C
C COMPUTE FITTED VALUES FOR THE DEFINED INDEPENDENT                             
C VARIABLES, RESULT ON THE DEFINED DEPENDENT VARIABLE                           
C                                                                               
C                                                                               
C.KEYWORDS                                                                      
C                                                                               
C  NON LINEAR FITTING                                                           
C                                                                               
C.VERSION
C 021122	last modif
C                                                                               
C----------------------------------------------------------------               
C                                                                               
C                                                                               
C      IMPLICIT NONE                                                            
C                                                                               

      INTEGER ICOL(2),ISTAT,NCOL,NROW,NSC,I,IUNIT 
      INTEGER NP1, NP2, NP3, NAC, NAR
      INTEGER MADRID(1)
       
      REAL CUT(4),VALUE(8)                                

      DOUBLE PRECISION RES(2),RES1(2)                                                   
      LOGICAL NULL(8),VALID,ISEL                                                
C
      INCLUDE 'MID_INCLUDE:FITI.INC/NOLIST'                                    
      INCLUDE 'MID_INCLUDE:FITC.INC/NOLIST'                                    
      COMMON/VMR/MADRID
C                                                                               
C 
      DO 100, I=1,8
         NULL(I) = .FALSE.
100   CONTINUE

      IF (FZMAPPED.EQ.0) THEN                                                 
         ISTAT  = FERDAT                                                   
         RETURN                                                                
      END IF                                                                    
C                                                                               
C TABLE DATA                                                                    
C                                                                               
      IF (FZTYPE.EQ.'TBL ') THEN                                              
C                                                                               
C   READ GENERAL INFO AND SET UP OUTPUT COLUMNS                                 
C                                                                               
          CALL TBIGET(FZIDEN,NCOL,NROW,NSC,NAC,NAR,ISTAT)                             
          ICOL(1) = FZDVAR                                                    
          IF (FZWEIGHT.GT.0) THEN                                             
              NCOL   = 2                                                        
              ICOL(2) = FZWEIGHT                                              
          ELSE                                                                  
              NCOL   = 1                                                        
          END IF                                                                
C                                                                               
C   COMPUTE LOOP                                                                
C                                                                               
          DO 10 I = 1,NROW                                                      
              CALL TBSGET(FZIDEN,I,ISEL,ISTAT)                                
              CALL TBRRDR(FZIDEN,I,FZNIND,FZIVAR,VALUE,NULL,        
     +                    ISTAT)                                                
              VALID  = ISEL .AND. ( .NOT. NULL(1)) .AND.                        
     +                 ( .NOT. NULL(2)) .AND. ( .NOT. NULL(3))                  
              IF (VALID) THEN                                                   
                  CALL FTCVAL(FZIVAR,VALUE,RES)                               
                  RES1(1) = RES(1)                                              
                  RES1(2) = RES(2)                                              
                  CALL TBRWRD(FZIDEN,I,NCOL,ICOL,RES1,ISTAT)            
              END IF                                                            
                                                                                
   10     CONTINUE                                                              
C                                                                               
C RELEASE TABLE DATA                                                            
C                                                                               
          CALL TBSINI(FZIDEN,ISTAT)                                           
          CALL TBTCLO(FZIDEN,ISTAT)                                           
          FZMAPPED = 0                                                        
                                                                                
      ELSE                                                                      
C                                                                               
C IMAGE DATA                                                                    
C                                                                               
          IF (FZNAXIS.GT.3) THEN                                              
              CALL STTPUT('Max.no. of dim.exceded',ISTAT)                       
              RETURN                                                            
                                                                                
          END IF                                                                
                                                                                
          NP1 = FZNPIX(1)
          NP2 = FZNPIX(2)
          NP3 = FZNPIX(3)
          CALL FTCVA1(MADRID(FZPTRI),MADRID(FZPTRM),FZNAXIS,              
     +                NP1,NP2,NP3,FZSTART,FZSTEP,CUT)                          
          CALL STDWRR(FZIDEN,'LHCUTS',CUT,1,4,IUNIT,ISTAT)                      
          CALL STFCLO(FZIDEN,ISTAT)                                           
          FZMAPPED = 0                                                        
      END IF                                                                    
                                                                                
      RETURN                                                                    
                                                                                
      END                                                                       

C===========================================================================
C Copyright (C) 1995,2004 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM LUTMOD
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION:
C  program LUTMOD		version 1.00	870522
C  K. Banse			ESO - Garching
C
C.KEYWORDS:
C  LUT, Image Display
C
C.PURPOSE:
C  a1) manipulate the colour lookup tables of the ImageDisplay interactively
C      in the same way as the IHAP command KTABLE...
C  a2) rotate the offset of one or all LUTs
C 
C  b1) manipulate the colour lookup tables of ImageDisplay interactively
C      like IHAP command KLOOKUP
C 
C  c1) squeeze/stretch the colour lookup tables of the ImageDisplay interactively
C  
C.ALGORITHM:
C  a1) The joystick is used to move + modify a one-colour band along 
C      the refscale
C      the LUTs are modified accordingly and sent to the Image Display
C  a2) The joystick is used to move the start of a LUT along the refscale
C	
C  b1) In the upper right hand corner of the screen a graphic repesentation
C      of a linear function mapping gray scale values to the current colour
C      table is shown.
C      Moving the joystick horizontally changes the slope of the function,
C      moving it vertically changes the intercept.
C	
C  c1) An arrow will point to the start of the sqeezed/stretched colours 
C      of the old colour band in the new colour band, 
C      this start point is controlled via the horizontal joystick movements.
C      Vertical joystick movements control the sqeezing or stretching of the 
C      old colour band.
C
C  On the cursor board the cursor #1 has to be on.
C  Turning cursor #1 off will terminate the program.
C	
C.INPUT/OUTPUT:
C  DEFAULT/C/15/1		L or I for LUT or ITT business
C  DEFAULT/C/16/1		A, B or C to determine which section
C				of LUTMOD should be executed
C  DAZHOLD/I/10/1		LUT section no.
C 
C  A:
C  P1/C/1/1			method to use, R for rotate, B for band
C  P2/C/1/1			colour to work with, R (red), G (green),
C  				B (blue), W (white), D (dark) or A (all)
C  P3/C/1/1			print flag, Yes or No
C  or
C  INPUTI/I/1/3			intensities for red, green + blue LUT
C	
C  output values are written to:
C  OUTPUTR/R/1/3		if method BAND is used: the data values
C				corresponding to start, center + end of band
C  
C  B:
C  P2/C/1/1			colour to work with: A (all), R (red), G (green)
C				and B (blue)
C 
C  C:
C  P1/C/1/1			S(queeze) or C(ursor modified)
C
C.VERSION
C 040121	last modif
C 
C  --------------------------------
C
C.PURPOSE for the ITT part:
C  1) overlay a band on active ITT of DeAnza interactively
C  2) rotate the offset of the ITT
C  3) squeeze + stretch the ITT
C  4) convolve with another ITT
C  5) equalize histogram and send it as an ITT to the ImageDisplay
C  6) do contrast stretching with the ITT
C
C.ALGORITHM:
C  1) the joystick is used to move + modify a one-value band along the refscale
C     the ITT is modified accordingly and sent to the DeAnza
C  2) the joystick is used to move the start of the ITT along the refscale
C  3) vertical joystick movements control the sqeezing or stretching of the ITT
C  4) map output from current ITT through new one
C  5) see Gonzalez + Wintz: "Digital Image Processing"
C  6) use the joystick to identify the interval where contrast should be 
C     enhanced
C
C.INPUT/OUTPUT:
C  the following keywords are used:
C
C  DEFAULT/C/16/1		method to use, R for rotate, B for band
C				S for squeeze, C for convolve
C				H for histogram equalisation
C				K for contrast stretching
C  INPUTI/I/1/1			value to work with
C  INPUTC/C/1/60	for method = C, name of new ITT
C  IN_A/C/1/60		for method = H, name of input image
C  P3/C/1/60		for method = H, name of optional result ITT
C	
C  output values are written to:
C	
C  OUTPUTR/R/1/3		if method BAND is used: the data values
C				corresponding to start, center + end of band
C	
C.VERSIONS
C  1.00		from LUTA, LUTB and LUTC
C  for later changes see SCCS
C 
C 020502	last modif
C 
C---------------------------------------------------------
C
      IMPLICIT NONE
C      
      INTEGER      IAV,IMNO
      INTEGER      JX,JY,JF(2),N,LEN
      INTEGER      NOCURS,ICOLR,STAT
      INTEGER      DAZHLD(10),DISPI
      INTEGER      KSECT,BA,BB,DB,DB2,CB,OLDBA,OLDBB
      INTEGER      XA,XAA,XB,XBB,XMAX,XMIN,XOFF
      INTEGER      YA,YAA,YB,YBB,YMIN,YMAX,YOFF
      INTEGER      VECTOR(2,2),XFIG(5),YFIG(5),XVEC(2),YVEC(2)
      INTEGER      NN,LUTLIM,LUT2SZ,LUT3SZ
      INTEGER      IZZ,NAXIS,NPIX(3),NAXPIX(4),IVAL
      INTEGER      IOFF,BINS(256),KBINS(256),ITT(256)
      INTEGER      EC,ED,EL,TID
      INTEGER      TABNUL,TBCOLN,NCOLS,NROWS
      INTEGER      KUNI(1),KNUL,MADRID(1)
C      
      CHARACTER    COLOUR*1,ACTION*1,DEFA*2
      CHARACTER    FRAME*60,MORE*72,PFLAG*4
      CHARACTER    OUTPUT*80,DSCRO*15
      CHARACTER    NEWITT*60,PROMPT*80,FILE*80
      CHARACTER    TBLABL*16
C      
      REAL         RBUF(8),CUTS(4),DIF,COLVAL(3)
      REAL         ROLD(768),RNEW(768)
      REAL         FB,RM,ARM,RB,RX,RY,RLUTLM,RLUTSZ
      REAL         F,FDIST,FXB,FXA,FLOW,FHI,ZZ
      REAL         ROOT(768)
      REAL         OLD(256),NEW(256),AUX(256)
      REAL         VALUE,RINF(8)
C      
      DOUBLE PRECISION  START(3),STEP(3)
C 
      INCLUDE      'MID_INCLUDE:ST_DEF.INC'
C 
      INCLUDE  'MID_INCLUDE:IDIDEV.INC'
      INCLUDE  'MID_INCLUDE:IDIMEM.INC'
C
      COMMON  /VMR/ MADRID
C
      EQUIVALENCE      (VECTOR(1,1),XAA),(VECTOR(2,1),YAA)
      EQUIVALENCE      (VECTOR(1,2),XBB),(VECTOR(2,2),YBB)
C      
      DATA   XOFF   /400/, YOFF /400/
      DATA   XMIN   /0/,   YMIN /0/,   XMAX /100/,  YMAX /100/
      DATA   FRAME  /' '/
      DATA   BINS   /256*0/
      DATA   TBLABL /'ITT '/
C 
      INCLUDE      'MID_INCLUDE:ST_DAT.INC'
C
C  initialize MIDAS 
      CALL STSPRO('LUTMOD')
      PFLAG(1:) = ' '
      LUTLIM = 255
      RLUTLM = LUTLIM
      FILE(1:80) = ' '
C      
C  get DEFAULT(15:16) to determine what we should do
      CALL STKRDC('DEFAULT',1,15,2,IAV,DEFA,KUNI,KNUL,STAT)
      ACTION = DEFA(2:2)
      CALL UPCAS(ACTION,ACTION)
C 
C  for histogram equalization we have to par. 4
      DISPI = 1
      IF (DEFA(1:2).EQ.'IH') THEN
         CALL STKRDC('P4',1,1,2,IAV,OUTPUT,KUNI,KNUL,STAT)
         IF ((OUTPUT(1:1).EQ.'N') .OR. (OUTPUT(1:1).EQ.'n')) THEN
            DISPI = 0                         !we don't work with a display
            GOTO 15000
         ENDIF
      ENDIF
C
C  get main control block for ImageDisplay + attach
      STAT = 0
      CALL DTOPEN(1,STAT)
      CALL DTGICH(QDSPNO,QIMCH,FRAME,RINF,STAT)
C      
C  get currently used LUT section + enable joystick action
      CALL STKRDI('DAZHOLD',1,10,IAV,DAZHLD,KUNI,KNUL,STAT)
      KSECT = DAZHLD(10)
      NOCURS = DAZHLD(1)
      CALL JOYSTK(QDSPNO,0,NOCURS,JX,JY,STAT)
      RLUTSZ = QLUTSZ
      LUT2SZ = QLUTSZ + QLUTSZ
      LUT3SZ = LUT2SZ + QLUTSZ
C 
      CALL STKRDI('MODSCALE',1,2,IAV,JF,KUNI,KNUL,STAT)  !get scalings
C 
C  branch to LUT or ITT part
      IF (DEFA(1:1).NE.'L') GOTO 10000

C 
C  handle LUT modification business
      IF (ACTION(1:1).EQ.'B') THEN
         GOTO 3000
      ELSE IF (ACTION(1:1).EQ.'C') THEN
         GOTO 6000
      ELSE IF (ACTION(1:1).EQ.'D') THEN
         GOTO 9000
      ENDIF
C 
C -----------------------------------------------------------------
C      
C  here we work on section a)
C      
C -----------------------------------------------------------------
C      
C  get method + colour we want to work on
      CALL STKRDC('P1',1,1,1,IAV,ACTION,KUNI,KNUL,STAT)
      CALL UPCAS(ACTION,ACTION)
C      
C  read current LUT (all colours)
      CALL RDLUT(QDSPNO,KSECT,1,QLUTSZ,ROLD,STAT)
C      
C  branch according to method chosen
      IF (ACTION.EQ.'R') GOTO 2000
C      
C ***
C      
C  overlay a one colour band on the LUTs
C      
C ***
C      
      CALL STKRDC('P3',1,1,4,IAV,PFLAG,KUNI,KNUL,STAT)
      CALL UPCAS(PFLAG,PFLAG)
      CALL STKRDR('INPUTR',1,3,IAV,COLVAL,KUNI,KNUL,STAT)
      DO 40, N=1,3
         IF (COLVAL(N).GT.1.0) COLVAL(N) = COLVAL(N) / RLUTLM
         IF (COLVAL(N).LT.0.0) COLVAL(N) = 0.
         IF (COLVAL(N).GT.1.0) COLVAL(N) = 1.0
40    CONTINUE
C      
C  get displayed frame info and low + high cuts
      CALL DTGICH(QDSPNO,QIMCH,FRAME,RBUF,STAT)
      IF (PFLAG(1:1).EQ.'Y') THEN
         CALL STFOPN(FRAME,D_OLD_FORMAT,0,F_IMA_TYPE,IMNO,STAT)
         CALL STDRDR(IMNO,'LHCUTS',1,4,IAV,CUTS,KUNI,KNUL,STAT)
         DIF = CUTS(2) - CUTS(1)
         IF (DIF.LT.10.E-20) THEN 
            CUTS(1) = CUTS(3)
            DIF = CUTS(4) - CUTS(3)
         ENDIF
         DIF = DIF / RLUTSZ                  !normalize
      ENDIF
C      
C  put small band into middle of refscale
      BA = NINT(RLUTSZ * 0.5)             !start of band
      BB = BA + 4                         !end of band
      OLDBA = 0
      OLDBB = 0
C      
C  here we start the action
100   IF ( (BA.EQ.OLDBA) .AND. (BB.EQ.OLDBB) ) GOTO 200      !nothing changed 
C      
      OLDBA = BA
      OLDBB = BB
      DO 120, N=1,LUT3SZ                  !copy original tables
         RNEW(N) = ROLD(N)
120   CONTINUE
C      
C  modify LUTs in the interval defined by [BA,BB]
      DO 140, N=BA,BB
         RNEW(N) = COLVAL(1)
         RNEW(QLUTSZ+N) = COLVAL(2)
         RNEW(LUT2SZ+N) = COLVAL(3)
140   CONTINUE
C      
C  and send new LUT to ImageDisplay
      CALL QWRLUT(QDSPNO,QIMCH,QRGBFL,KSECT,1,QLUTSZ,RNEW,STAT)
CC      CALL WRLUT(QDSPNO,KSECT,1,QLUTSZ,RNEW,STAT)
C      
C  display corresponding pixel levels on terminal
      IF (PFLAG(1:1).EQ.'Y') THEN
         CB = (BA+BB)/2
         RBUF(1) = CUTS(1) + (BA*DIF)
         RBUF(2) = CUTS(1) + (CB*DIF)
         RBUF(3) = CUTS(1) + (BB*DIF)
C      
C  display, but not log the stuff (to save space)
         WRITE(MORE,30000) RBUF(1),RBUF(2),RBUF(3)
         CALL STTDIS(MORE,99,STAT)
      ENDIF
C      
C  now get joystick input
200   CALL JOYSTK(QDSPNO,1,NOCURS,JX,JY,STAT)
      IF (STAT.EQ.1) THEN                     !if all cursors off, terminate
         CALL STKWRR('OUTPUTR',RBUF,1,3,KUNI,STAT)
         GOTO 90000
      ENDIF
C      
C modify band according to joystick movement
      IF ((JX.LE.-64).OR.(JX.GE.64)) THEN
         JX = JX/JF(1)
      ELSE
         JX = JX/JF(2)
      ENDIF
      IF ((JY.LE.-64).OR.(JY.GE.64)) THEN
         JY = JY/JF(1)
      ELSE
         JY = JY/JF(2)
      ENDIF
C      
      IF (JX.EQ.0) GOTO 800                  !no horizontal movement
      DB = BB - BA                           !save band width
      IF (JX.GT.0) THEN
         BB = MIN(QLUTSZ,BB+JX)              !move band right
         BA = BB - DB
      ELSE
         BA = MAX(1,BA+JX)                   !move band left
         BB = BA + DB
      ENDIF
C      
800   IF (JY.EQ.0) GOTO 1000                 !no vertical  movement
      CB = (BA + BB)/2                       !save center of band
      DB = BB - BA                           !save band width
      IF (JY.GT.0) THEN
         DB = MIN(QLUTSZ,DB+JY)              !widen the band
         FB = DB
         DB2 = NINT(FB*0.5)
         BB = MIN(QLUTSZ,CB+DB2)
         BA = MAX(1,CB-DB2)
      ELSE
         DB = MAX(1,DB+JY)                   !sqeeze the band
         DB2 = DB/2
         BB = CB + DB2
         BA = CB - DB2
      ENDIF
C      
C  now loop
1000  GOTO 100
C      
C ***
C      
C  handle rotation of LUTs
C      
C ***
C      
2000  CALL STKRDC('P2',1,1,1,IAV,COLOUR,KUNI,KNUL,STAT)
      CALL UPCAS(COLOUR,COLOUR)
      ICOLR = 4
      IF (COLOUR.EQ.'R') ICOLR = 1
      IF (COLOUR.EQ.'G') ICOLR = 2
      IF (COLOUR.EQ.'B') ICOLR = 3
C      
C  set start, end of LUT to 0, QLUTSZ-1
      BA = 0             
      OLDBA = 0
      IZZ = QLUTSZ - 1
      DO 2020, N=1,LUT3SZ                        !copy original tables
         RNEW(N) = ROLD(N)
2020  CONTINUE
C      
C  now get joystick input
2100  CALL JOYSTK(QDSPNO,1,NOCURS,JX,JY,STAT)
      IF (STAT.EQ.1) GOTO 90000                  !if all cursors off, terminate
C      
C modify start of LUT according to joystick movement
      IF ((JX.LE.-64).OR.(JX.GE.64)) THEN
         JX = JX/JF(1)
      ELSE
         JX = JX/JF(2)
      ENDIF
      BA = BA + JX                               !move start addr.
      IF (BA .GT. IZZ) BA = BA - IZZ             !and wrap around
      IF (BA .LT. 0) BA = IZZ + BA
C      
C  only update, if changed
      IF (BA.NE.OLDBA) THEN
         OLDBA = BA
         LEN = QLUTSZ - BA
C      
C  handle only one colour
         IF (ICOLR.LT.4) THEN
            IAV = (ICOLR-1)*QLUTSZ
            DO 2200, N=1,QLUTSZ-BA
               RNEW(IAV+N+BA) = ROLD(IAV+N)
2200        CONTINUE
            IF (BA.GT.0) THEN
               DO 2300, N=1,BA
                  RNEW(IAV+N) = ROLD(IAV+LEN+N)
2300           CONTINUE
            ENDIF
C      
C  handle all colours
         ELSE
            DO 2400, N=1,QLUTSZ-BA
               RNEW(N+BA) = ROLD(N)
               RNEW(QLUTSZ+N+BA) = ROLD(QLUTSZ+N)
               RNEW(LUT2SZ+N+BA) = ROLD(LUT2SZ+N)
2400        CONTINUE
            IF (BA.GT.0) THEN
               DO 2440, N=1,BA
                  RNEW(N) = ROLD(LEN+N)
                  RNEW(QLUTSZ+N) = ROLD(QLUTSZ+LEN+N)
                  RNEW(LUT2SZ+N) = ROLD(LUT2SZ+LEN+N)
2440           CONTINUE
            ENDIF
         ENDIF
C      
C  send updated LUT
         CALL QWRLUT(QDSPNO,QIMCH,QRGBFL,KSECT,1,QLUTSZ,RNEW,STAT)
      ENDIF
C      
C  now loop
      GOTO 2100

C -----------------------------------------------------------------
C      
C  here we work on section b)
C      
C -----------------------------------------------------------------
C      
C  get colour we want to work on
3000  CALL STKRDC('P2',1,1,1,IAV,COLOUR,KUNI,KNUL,STAT)
      CALL UPCAS(COLOUR,COLOUR)
C      
C      
      ICOLR = 1                        !default = all
      IF (COLOUR.EQ.'R') ICOLR = 2
      IF (COLOUR.EQ.'G') ICOLR = 3
      IF (COLOUR.EQ.'B') ICOLR = 4
C      
C  read current LUT (all colours)
      CALL RDLUT(QDSPNO,KSECT,1,QLUTSZ,ROLD,STAT)
      IF (ICOLR.NE.1) THEN
         DO 3040, N=1,LUT3SZ
            RNEW(N) = ROLD(N)
3040     CONTINUE
      ENDIF      
C      
C  put small rectangle into right hand upper corner of screen
      XFIG(1) = XMIN + XOFF
      YFIG(1) = YMIN + YOFF
      XFIG(2) = XFIG(1)
      YFIG(2) = YMAX + YOFF
      XFIG(3) = XMAX + XOFF
      YFIG(3) = YFIG(2)
      XFIG(4) = XFIG(3)
      YFIG(4) = YFIG(1)
      XFIG(5) = XFIG(1)
      YFIG(5) = YFIG(1)
C      
      XA = XMIN                  !initialize vector
      XB = XMAX
      YA = YMIN
      YB = YMAX
      RB = 0.
      RM = 1.0
      ARM = 1.0
      CALL IIGPLY(QDSPNO,QOVCH,XFIG,YFIG,5,99,1,STAT)          !draw frame once
C      
C  here we start the action
3100  XAA = XA + XOFF
      XBB = XB + XOFF
      YAA = YA + YOFF
      YBB = YB + YOFF
C      
      XVEC(1) = VECTOR(1,1)
      XVEC(2) = VECTOR(1,2)
      YVEC(1) = VECTOR(2,1)
      YVEC(2) = VECTOR(2,2)

C draw the function y = LUT(x)
      CALL IIGPLY(QDSPNO,QOVCH,XVEC,YVEC,2,99,1,STAT)
C      
C  build new LUTs 
      FB = RB / RLUTSZ
      GOTO (3200,3300,3400,3500),ICOLR
C      
3200  DO 3220, N=1,256
         RNEW(N) = MAX(0.,MIN(1.,(ROLD(N)*RM)+FB))
         RNEW(QLUTSZ+N) = MAX(0.,MIN(1.,(ROLD(QLUTSZ+N)*RM)+FB))
         RNEW(LUT2SZ+N) = MAX(0.,MIN(1.,(ROLD(LUT2SZ+N)*RM)+FB))
3220  CONTINUE
      GOTO 3550
C      
3300  DO 3320, N=1,256
         RNEW(N) = MAX(0.,MIN(1.,(ROLD(N)*RM)+FB))
3320  CONTINUE
      GOTO 3550
C      
3400  DO 3420, N=1,256
         RNEW(QLUTSZ+N) = MAX(0.,MIN(1.,(ROLD(QLUTSZ+N)*RM)+FB))
3420  CONTINUE
      GOTO 3550
C      
3500  DO 3520, N=1,256
         RNEW(LUT2SZ+N) = MAX(0.,MIN(1.,(ROLD(LUT2SZ+N)*RM)+FB))
3520  CONTINUE
C      
C  and send new LUT to ImageDisplay
3550  CALL QWRLUT(QDSPNO,QIMCH,QRGBFL,KSECT,1,QLUTSZ,RNEW,STAT)
C      
C  now get joystick input
3600  CALL JOYSTK(QDSPNO,1,NOCURS,JX,JY,STAT)
      IF (STAT.EQ.1) GOTO 4400                  !if cursor(s) off, terminate
C      
C modify function according to joystick movement
      IF (JX.EQ.0) GOTO 3800                  !no horizontal movement
      IF ((JX.LE.-64).OR.(JX.GE.64)) THEN
         RX = FLOAT(JX)/32.
      ELSE
         RX = FLOAT(JX)/64.
      ENDIF
C      
      IF ((RM.GT.0.4).AND.(RM.LT.1.6)) RX = RX/4.
      RM = MAX(0.,(RM - RX))                  !update slope of function
      ARM = ABS(RM)
      YB = NINT(RM*XMAX + RB)
      YB = MAX(YMIN,MIN(YB,YMAX))            !keep new YB in rectangle
      IF (ARM.LT.10.E-6) THEN
         XB = XMAX
      ELSE
         XB = NINT((YB - RB)/RM)
      ENDIF
      XB = MAX(XMIN,MIN(XB,XMAX))      !keep XB in rectangle
C      
3800  IF (JY.EQ.0) GOTO 4000
      IF ((JY.LE.-64).OR.(JY.GE.64)) THEN
         RY = FLOAT(JY)/6.
      ELSE
         RY = FLOAT(JY)/10.
      ENDIF
      RB = MIN(FLOAT(YMAX),(RB + RY))            !update intercept of function
      YA = RB
      YA = MAX(YMIN,MIN(YA,YMAX))
      IF (ARM.LT.10.E-6) THEN
         XA = XMIN
      ELSE
         XA = NINT((YA - RB)/RM)
      ENDIF
      XA = MAX(XMIN,MIN(XA,XMAX))      !keep XA in rectangle
C      
      YB = NINT(RM*XMAX + RB)
      YB = MAX(YMIN,MIN(YB,YMAX))            !keep new YB in rectangle
      IF (ARM.LT.10.E-6) THEN
         XB = XMAX
      ELSE
         XB = NINT((YB - RB)/RM)
      ENDIF
      XB = MAX(XMIN,MIN(XB,XMAX))      !keep XB in rectangle
C      
C  now loop
4000  IF ((JX.EQ.0).AND.(JY.EQ.0)) GOTO 3600
C      
      XVEC(1) = VECTOR(1,1)
      XVEC(2) = VECTOR(1,2)
      YVEC(1) = VECTOR(2,1)
      YVEC(2) = VECTOR(2,2)
      CALL IIGPLY(QDSPNO,QOVCH,XVEC,YVEC,2,99,1,STAT)      !erase old vector
      GOTO 3100
C      
C  that's it folks...
C      
4400  XVEC(1) = VECTOR(1,1)
      XVEC(2) = VECTOR(1,2)
      YVEC(1) = VECTOR(2,1)
      YVEC(2) = VECTOR(2,2)
      CALL IIGPLY(QDSPNO,QOVCH,XVEC,YVEC,2,99,1,STAT)      !clear vector
      CALL IIGPLY(QDSPNO,QOVCH,XFIG,YFIG,5,99,1,STAT)      !clear frame
C      
      GOTO 90000

C -----------------------------------------------------------------
C      
C  here we work on section c)
C      
C -----------------------------------------------------------------
C      
6000  ZZ = RLUTSZ * RLUTSZ
C      
C
C  here for squeezing + stretching of LUT
C      
C
C  read current LUT
      CALL RDLUT(QDSPNO,KSECT,1,QLUTSZ,ROLD,STAT)
C      
C  initialize 
      FLOW = - ZZ
      FHI = (RLUTSZ + 1.) + ZZ
      FXA = 0.
      FXB = FXA + RLUTSZ
C      
C  here we start the action
6100  FDIST = FXB - FXA
      F = RLUTSZ / FDIST                     !get sqeeze/stretch factor
C      
C  update LUT accordingly
      DO 6200, N=1,QLUTSZ
         RNEW(N) = 0.
         RNEW(QLUTSZ+N) = 0.
         RNEW(LUT2SZ+N) = 0.
         IF ((N.GE.FXA).AND.(N.LE.FXB)) THEN
            NN = NINT((N - FXA)*F)
            IF ((NN.GE.1).AND.(NN.LE.QLUTSZ)) THEN
               RNEW(N) = ROLD(NN)
               RNEW(QLUTSZ+N) = ROLD(QLUTSZ+NN)
               RNEW(LUT2SZ+N) = ROLD(LUT2SZ+NN)
            ENDIF
         ENDIF
6200  CONTINUE
C      
C  and send new LUT to the De Anza
      CALL QWRLUT(QDSPNO,QIMCH,QRGBFL,KSECT,1,QLUTSZ,RNEW,STAT)
C      
C  now get joystick input
6600  CALL JOYSTK(QDSPNO,1,NOCURS,JX,JY,STAT)      
      IF (STAT.EQ.1) GOTO 90000            !if cursor(s) off, terminate
C      
C modify function according to joystick movement
      IF (JX.EQ.0) GOTO 6800                  !no horizontal movement
      IF ((JX.LE.-64).OR.(JX.GE.64)) THEN
         RX = FLOAT(JX)/FLOAT(JF(1))
      ELSE
         RX = FLOAT(JX)/FLOAT(JF(2))
      ENDIF
C      
      FXA = FXA + RX                     !virtual position
      FXA = MAX(FLOW,MIN(FXA,RLUTSZ))    !keep virt. pos. within limits
      FXB = FXA + FDIST                  !keep FXB at same distance from FXA
C      
6800  IF (JY.EQ.0) GOTO 7000
      IF ((JY.LE.-64).OR.(JY.GE.64)) THEN
         RY = FLOAT(JY)/FLOAT(JF(1))
      ELSE
         RY = FLOAT(JY)/FLOAT(JF(2))
      ENDIF
      FXB = FXB + RY                        !virtual position
      FXB = MIN(MAX(FXA+1.,FXB),FHI)
C 
7000  IF ( (JX.EQ.0) .AND. (JY.EQ.0) ) THEN
         GOTO 6600
      ELSE
         GOTO 6100
      ENDIF

C -----------------------------------------------------------------
C      
C  here we work on section d)
C      
C -----------------------------------------------------------------
C      
C ***
C      
C  handle modification of LUTs in HSI space
C      
C ***
C      
9000  CALL STKRDC('P2',1,1,1,IAV,COLOUR,KUNI,KNUL,STAT)
      CALL UPCAS(COLOUR,COLOUR)
C 
      IF (COLOUR.EQ.'S') THEN
         ICOLR = 2
         ZZ = 1.0
      ELSE IF (COLOUR.EQ.'I') THEN
         ICOLR = 3
         ZZ = 1.0
      ELSE
         ICOLR = 1
         ZZ = 360.
      ENDIF
C      
C  read current LUT (all colours)
      CALL RDLUT(QDSPNO,KSECT,1,QLUTSZ,RNEW,STAT)
      CALL MAKLUT(2,QLUTSZ,RNEW,256,ROOT)  
C      
C   convert RGB table to HSI table
      CALL HSIRGB(1,ROLD,ROOT)             !ROOT -> ROLD
C      
C   reconvert HSI table to RGB table
      CALL HSIRGB(2,ROLD,ROOT)             !ROLD -> ROOT
C      
C  send updated LUT
      CALL MAKLUT(1,256,ROOT,QLUTSZ,RNEW)
      CALL QWRLUT(QDSPNO,QIMCH,QRGBFL,KSECT,1,QLUTSZ,RNEW,STAT)
C 
C  now get joystick input
9100  CALL JOYSTK(QDSPNO,1,NOCURS,JX,JY,STAT)
      IF (STAT.EQ.1) GOTO 90000                  !if all cursors off, terminate
C      
C modify start of LUT according to joystick movement
      IF ((JX.LE.-64).OR.(JX.GE.64)) THEN
         JX = JX/JF(1)
      ELSE
         JX = JX/JF(2)
      ENDIF
C      
C  only update, if changed
      IF (JX.NE.0) THEN
         FXB = JX
         FXB = FXB / RLUTLM
         FDIST = FXB * ZZ                         !relate to H/S/I interval
C      
         IAV = (ICOLR-1) * QLUTSZ
         DO 9200, N=1,256
            ROLD(IAV+N) = ROLD(IAV+N)+FDIST
            IF (ROLD(IAV+N).LT.0.) THEN
               ROLD(IAV+N) = 0.
            ELSE IF (ROLD(IAV+N).GT.ZZ) THEN
               ROLD(IAV+N) = ZZ
            ENDIF
9200     CONTINUE
C      
C   convert RGB table to HSI table
         CALL HSIRGB(2,ROLD,ROOT)                !ROLD -> ROOT
C      
C  send updated LUT
         CALL MAKLUT(1,256,ROOT,QLUTSZ,RNEW)
         CALL QWRLUT(QDSPNO,QIMCH,QRGBFL,KSECT,1,QLUTSZ,RNEW,STAT)
      ENDIF
C      
C  now loop
      GOTO 9100

C      
C  here we handle the ITT modifications
C  get value we want to work on
C 
10000 CALL STKRDR('INPUTR',1,1,IAV,VALUE,KUNI,KNUL,STAT)
      IF (VALUE.GT.1.1) VALUE = VALUE / RLUTSZ
      IF (VALUE.GT.1.0) VALUE = 1.
      IF (VALUE.LT.0.0) VALUE = 0.
C      
C  force ITT visibility
      IF (ITTYES.EQ.0) THEN
         ITTYES = 1
         CALL DTPICH(QDSPNO,QIMCH,FRAME,RINF,STAT)
      ENDIF
      KSECT = 0
C
C  read current ITT
      CALL RDITT(QDSPNO,QIMCH,KSECT,1,QLUTSZ,OLD,STAT)
      DO 10020, N=1,256                  !copy original table
         NEW(N) = OLD(N)
10020 CONTINUE
C      
C  branch according to method chosen
      IF (ACTION.EQ.'R') THEN
         GOTO 12000
      ELSE IF (ACTION.EQ.'S') THEN
         GOTO 13000
      ELSE IF (ACTION.EQ.'C') THEN
         GOTO 14000
      ELSE IF (ACTION.EQ.'H') THEN
         GOTO 15000
      ELSE IF (ACTION.EQ.'K') THEN
         GOTO 16000
      ENDIF

C      
C ***
C      
C  overlay a one value band on the ITT
C      
C ***
C      
      CALL STKRDC('P3',1,1,4,IAV,PFLAG,KUNI,KNUL,STAT)
      CALL UPCAS(PFLAG,PFLAG)
C 
C  get displayed frame info + get low + high cuts
      CALL DTGICH(QDSPNO,QIMCH,FRAME,RBUF,STAT)
      IF (PFLAG(1:1).EQ.'Y') THEN
         CALL STFOPN(FRAME,D_OLD_FORMAT,0,F_IMA_TYPE,IMNO,STAT)
         CALL STDRDR(IMNO,'LHCUTS',1,4,IAV,CUTS,KUNI,KNUL,STAT)
         DIF = CUTS(2) - CUTS(1)
         IF (DIF.LT.10.E-20) THEN 
            CUTS(1) = CUTS(3)
            DIF = CUTS(4) - CUTS(3)
         ENDIF
         DIF = DIF / RLUTSZ                  !normalize
      ENDIF
C      
C  put small band into middle of refscale
      BA = NINT(RLUTSZ * 0.5)             !start of band
      BB = BA + 4                         !end of band
      OLDBA = 0
      OLDBB = 0
C      
C  here we start the action
10100 IF ( (BA.EQ.OLDBA) .AND. (BB.EQ.OLDBB) ) GOTO 10400
C      
      OLDBA = BA
      OLDBB = BB
      DO 10120, N=1,QLUTSZ                  !copy original table
         NEW(N) = OLD(N)
10120 CONTINUE
C      
C  modify ITT in the interval defined by [BA,BB]
      DO 10130, N=BA,BB
         NEW(N) = VALUE
10130 CONTINUE
C      
C  send new ITT to ImageDisplay
      CALL WRITT(QDSPNO,QIMCH,KSECT,1,QLUTSZ,NEW,STAT)
C      
C  display corresponding pixel levels on terminal
      IF (PFLAG(1:1).EQ.'Y') THEN
         CB = (BA+BB)/2
         RBUF(1) = CUTS(1) + (BA*DIF)
         RBUF(2) = CUTS(1) + (CB*DIF)
         RBUF(3) = CUTS(1) + (BB*DIF)
C      
C  display, but not log the stuff (to save space)
         WRITE(MORE,30000) RBUF(1),RBUF(2),RBUF(3)
         CALL STTDIS(MORE,99,STAT)
      ENDIF
C      
C  now get joystick input
10400 CALL JOYSTK(QDSPNO,1,NOCURS,JX,JY,STAT)      
      IF (STAT.EQ.1) THEN                  !if cursor(s) off, terminate
         CALL STKWRR('OUTPUTR',RBUF,1,3,KUNI,STAT)
         GOTO 90000
      ENDIF
C      
C modify band according to joystick movement
      IF ((JX.LE.-64).OR.(JX.GE.64)) THEN
         JX = JX/JF(1)
      ELSE
         JX = JX/JF(2)
      ENDIF
      IF ((JY.LE.-64).OR.(JY.GE.64)) THEN
         JY = JY/JF(1)
      ELSE
         JY = JY/JF(2)
      ENDIF
C      
      IF (JX.EQ.0) GOTO 10800                  !no horizontal movement
      DB = BB - BA                             !save band width
      IF (JX.GT.0) THEN
         BB = MIN(QLUTSZ,BB+JX)                !move band up
         BA = BB - DB
      ELSE
         BA = MAX(1,BA+JX)                     !move band down
         BB = BA + DB
      ENDIF
C      
10800 IF (JY.EQ.0) GOTO 11000
      CB = (BA + BB)/2                         !save center of band
      DB = BB - BA                             !save band width
      IF (JY.GT.0) THEN
         DB = MIN(QLUTSZ,DB+JY)                !widen the band
         FB = DB
         DB2 = NINT(FB*0.5)
         BB = MIN(QLUTSZ,CB+DB2)
         BA = MAX(1,CB-DB2)
      ELSE
         DB = MAX(1,DB+JY)                     !sqeeze the band
         DB2 = DB/2
         BB = CB + DB2
         BA = CB - DB2
      ENDIF
C      
C  now loop
11000 GOTO 10100
C      
C ***
C      
C  handle rotation of ITT
C      
C ***
C      
C      
C  init offset to 0
12000 BA = 0
      OLDBA = BA
      IZZ = QLUTSZ - 1
C      
C  now get joystick input
12100 CALL JOYSTK(QDSPNO,1,NOCURS,JX,JY,STAT)      
      IF (STAT.EQ.1) GOTO 90000            !if cursor(s) off, terminate
C      
      IF ((JX.LE.-64).OR.(JX.GE.64)) THEN
         JX = JX/JF(1)
      ELSE
         JX = JX/JF(2)
      ENDIF
      BA = BA + JX                               !move start addr.
      IF (BA .GT. IZZ) BA = BA - IZZ             !and wrap around
      IF (BA .LT. 0) BA = IZZ + BA
C      
C  only update, if a change occurred
      IF (BA.NE.OLDBA) THEN
         OLDBA = BA
         DO 12120, N=1,QLUTSZ-BA                  !shift ITT
            NEW(N+BA) = OLD(N)
12120    CONTINUE
         IF (BA.GT.0) THEN
            DO 12140, N=1,BA
               NEW(N) = OLD(QLUTSZ-BA+N)
12140       CONTINUE
         ENDIF
C      
         CALL WRITT(QDSPNO,QIMCH,KSECT,1,QLUTSZ,NEW,STAT)
      ENDIF
      GOTO 12100
C      
C ***
C      
C  squeeze/stretch ITT
C      
C ***
C      
C  initialize
13000 ZZ = RLUTSZ * RLUTSZ
      FLOW = - ZZ
      FHI = RLUTSZ + 1. + ZZ
      FXA = 0.
      FXB = FXA + RLUTSZ
C      
C  here we start the action
13100 FDIST = FXB - FXA
      F = RLUTSZ/FDIST                              !get sqeeze/stretch factor
C      
C  update ITT accordingly
      DO 13200, N=1,QLUTSZ
         NEW(N) = 0.
         IF ((N.GE.FXA).AND.(N.LE.FXB)) THEN
            NN = NINT((N - FXA)*F)
            IF ((NN.GE.1).AND.(NN.LE.QLUTSZ)) THEN
               NEW(N) = OLD(NN)
            ENDIF
         ENDIF
13200 CONTINUE
C      
C  and send it to the Image Display
      CALL WRITT(QDSPNO,QIMCH,KSECT,1,QLUTSZ,NEW,STAT)
C      
C  now get joystick input
13600 CALL JOYSTK(QDSPNO,1,NOCURS,JX,JY,STAT)
      IF (STAT.EQ.1) GOTO 90000            !if cursor(s) off, terminate
C      
C modify function according to joystick movement
      IF (JX.EQ.0) GOTO 13700                  !no horizontal movement
      IF ((JX.LE.-64).OR.(JX.GE.64)) THEN
         RX = FLOAT(JX)/FLOAT(JF(1))
      ELSE
         RX = FLOAT(JX)/FLOAT(JF(2))
      ENDIF
C      
      FXA = FXA + RX                     !virtual position
      FXA = MAX(FLOW,MIN(FXA,RLUTSZ))    !keep virt. pos. within limits
      FXB = FXA + FDIST                  !keep FXB at same distance from FXA
C      
13700 IF (JY.EQ.0) GOTO 13800
      IF ((JY.LE.-64).OR.(JY.GE.64)) THEN
         RY = FLOAT(JY)/FLOAT(JF(1))
      ELSE
         RY = FLOAT(JY)/FLOAT(JF(2))
      ENDIF
      FXB = FXB + RY                        !virtual position
      FXB = MIN(MAX(FXA+1.,FXB),FHI)
13800 IF ( (JX.EQ.0) .AND. (JY.EQ.0) ) THEN
         GOTO 13600
      ELSE
         GOTO 13100
      ENDIF
C      
C ***
C      
C  convolve current ITT with another one
C      
C ***
C      
14000 PROMPT(1:) = 'Enter ITT name to convolve with and RETURN '//
     +             '(just RETURN to stop): '
      IF (VALUE.GT.0.5) THEN
         IVAL = 1
      ELSE
         IVAL = 0
      ENDIF
C      
14100 NEWITT(1:) = ' '
      CALL STKWRC('INPUTC',1,NEWITT,1,60,KUNI,STAT)      !clear also key INPUTC
      CALL STKPRC(PROMPT,'INPUTC',1,1,60,IAV,NEWITT,KUNI,KNUL,STAT)
      DO 14110, N=60,1,-1
         IF (NEWITT(N:N).NE.' ') THEN
            NN = N + 1
            GOTO 14115
         ENDIF
14110 CONTINUE
      GOTO 90000
C 
14115 NEWITT(NN:) = '.itt'                  !append type of ITT table
C      
C  look for ITT table - first in MID_SYSTAB
      FILE(1:) = 'MID_SYSTAB:'//NEWITT
      CALL STECNT('GET',EC,EL,ED)
      CALL STECNT('PUT',1,0,0)            !disable errors ...
      CALL TBTOPN(FILE,F_I_MODE,TID,STAT)
      CALL STECNT('PUT',EC,EL,ED)
      IF (STAT.NE.0) THEN
         STAT = 0
         FILE = NEWITT//' '
         CALL TBTOPN(FILE,F_I_MODE,TID,STAT)
      ENDIF
C      
C  now get table info
      CALL TBIGET(TID,NCOLS,NROWS,N,N,N,STAT)
      CALL TBLSER(TID,TBLABL,TBCOLN,STAT)
      IF (TBCOLN.LE.0)                         !this stops everything...
     +   CALL STETER(1,'column labeled :ITT not found')
C      
C  now read the table
      DO 14200, N=1,256
         CALL TBRRDR(TID,N,1,TBCOLN,AUX(N),TABNUL,STAT)
14200 CONTINUE
      CALL MAKITT(256,AUX,QLUTSZ,RNEW)         !squeeze to QLUTSZ
C      
C  and finally do the convolution
      DO 14250, N=1,QLUTSZ
         NN = NINT(OLD(N)*RLUTSZ) + 1
         NEW(N) = RNEW(NN)
14250 CONTINUE
      CALL WRITT(QDSPNO,QIMCH,KSECT,1,QLUTSZ,NEW,STAT)
C      
C  if IVAL = 1, we want to convolve again and again...
      IF (IVAL.EQ.1) THEN
         DO 14300, N=1,256
            OLD(N) = NEW(N)
14300    CONTINUE
      ENDIF
C      
C  and loop for another ITT
      CALL TBTCLO(TID,STAT)
      GOTO 14100
C      
C ***
C      
C  equalize histogram and send appropriate ITT to the display
C      
C ***
C
C  get name of image + map data 
15000 CALL STKRDC('IN_A',1,1,80,IAV,FILE,KUNI,KNUL,STAT)
      CALL STFOPN(FILE,D_OLD_FORMAT,0,F_IMA_TYPE,IMNO,STAT)
      CALL STDRDI(IMNO,'NAXIS',1,1,IAV,NAXIS,KUNI,KNUL,STAT)
      IF (NAXIS.GT.3) NAXIS = 3              !max. 3 axes supported
      CALL STDRDI(IMNO,'NPIX',1,NAXIS,IAV,NPIX,KUNI,KNUL,STAT)
      CALL STDRDD(IMNO,'START',1,NAXIS,IAV,START,KUNI,KNUL,STAT)
      CALL STDRDD(IMNO,'STEP',1,NAXIS,IAV,STEP,KUNI,KNUL,STAT)
      IVAL = 1
      DO 15200, N=1,NAXIS
         IVAL = IVAL*NPIX(N)
15200 CONTINUE
      F = FLOAT(IVAL)
C
C  get descriptor for output + histogram info
      CALL STKRDC('P2',1,1,15,IAV,DSCRO,KUNI,KNUL,STAT)
      CALL STECNT('GET',EC,EL,ED)
      BA = 1
      BB = 0
      DB = 0
      CALL STECNT('PUT',BA,BB,DB)
      CALL STDRDR(IMNO,'STATISTIC',1,11,IAV,OLD,KUNI,KNUL,STAT)
      CALL STECNT('PUT',EC,EL,ED)
      IF (STAT.NE.0) THEN
         RBUF(1) = 256.0
         RBUF(2) = 0.0
         RBUF(3) = 0.0
         OUTPUT(1:) = 'E15.6 '
         OUTPUT(11:) = 'YYFNY '
         NAXPIX(1) = NAXIS
         DO 15220, N=1,NAXIS
            NAXPIX(1+N) = NPIX(N)
15220    CONTINUE
         CALL ZMSTAT(IMNO,PFLAG,NAXPIX,START,STEP,RBUF,
     +               OUTPUT(1:5),OUTPUT(11:15))
         CALL STDRDR(IMNO,'STATISTIC',1,11,IAV,OLD,KUNI,KNUL,STAT)
      ENDIF
      CALL STDRDR(IMNO,'HIST_BINS',1,1,IAV,ZZ,KUNI,KNUL,STAT)
      IOFF = 1
      IZZ = NINT(ZZ)
      IF ((IZZ.NE.256) .AND. (IZZ.NE.258)) THEN
         N = INDEX(FILE,' ') - 1
         OUTPUT(1:) = 'Warning: Histogram of frame '//
     +               FILE(1:N)//' has not exactly 256 bins...'
         CALL STTPUT(OUTPUT,STAT)
      ENDIF
      IF (IZZ.EQ.258) IOFF = 2            !omit excess bins
      CALL STDRDI(IMNO,'HISTOGRAM',IOFF,256,IAV,BINS,KUNI,KNUL,STAT)
C      
C  histogram equalisation
      IF (OLD(11).GT.OLD(8)) THEN
         CALL STTPUT
     +    ('ill formed histogram - no equalization possible',STAT)
         CALL STTPUT
     +    ('use low,high excess bins to get "better" histogram',STAT)
         DO 15250, N=1,256
            ITT(N) = N - 1
15250    CONTINUE
         IZZ = -1
      ELSE
         CALL HISTEQ(BINS,256,F,KBINS,ITT)
         IF (DSCRO(1:1).NE.'+')
     +      CALL STDWRI(IMNO,DSCRO,KBINS,1,256,KUNI,STAT)
         IZZ = 0
      ENDIF
      CALL STKWRI('PROGSTAT',IZZ,5,1,KUNI,STAT)
C      
C  now apply it to image
      ZZ = 1./RLUTLM
      DO 15300, N=1,256
         AUX(N) = ZZ * ITT(N)
15300 CONTINUE
      IF (DISPI .EQ. 1) THEN
         CALL MAKITT(256,AUX,QLUTSZ,NEW)
         CALL WRITT(QDSPNO,QIMCH,KSECT,1,QLUTSZ,NEW,STAT)
      ENDIF
C 
C  if desired, we also save the ITT in a table
      FILE(1:) = ' '
      CALL STKRDC('P3',1,1,60,IAV,FILE,KUNI,KNUL,STAT)
      IF (FILE(1:1).NE.'+') CALL BLDITT(FILE,AUX,STAT)
      GOTO 90000

C      
C ***
C      
C  stretch contrast in designated interval
C      
C ***
C      
C  initialize ITT to ramp
16000 F = 1./(QLUTSZ-1)
      DO 16030, N=1,QLUTSZ
         NEW(N) = (N-1) * F
16030 CONTINUE
      CALL WRITT(QDSPNO,QIMCH,KSECT,1,QLUTSZ,NEW,STAT)
C 
      BA = 1                  !start of interval
      BB = QLUTSZ             !end of interval
      OLDBA = BA
      OLDBB = BB
C      
C  here we start the action
16100 IF ( (BA.EQ.OLDBA) .AND. (BB.EQ.OLDBB) ) GOTO 16400
C      
      OLDBA = BA
      OLDBB = BB
C      
C  modify ITT in the interval defined by [BA,BB]
      DO 16120, N=1,BA                  ![1,BA] = 0
         NEW(N) = 0.
16120 CONTINUE
C 
      IF (BB.GT.BA) THEN
         F = 1. / (BB - BA)
         DO 16130, N=BA+1,BB
            NEW(N) = F * (N-BA)
16130    CONTINUE
      ENDIF
C 
      IF (BB.LT.QLUTSZ) THEN
         DO 16140, N=BB+1,QLUTSZ
            NEW(N) = 1.
16140    CONTINUE
      ENDIF
C 
C  send new ITT to ImageDisplay
      CALL WRITT(QDSPNO,QIMCH,KSECT,1,QLUTSZ,NEW,STAT)
C      
C  now get joystick input
16400 CALL JOYSTK(QDSPNO,1,NOCURS,JX,JY,STAT)      
      IF (STAT.EQ.1) THEN                  !if cursor(s) off, terminate
         CALL STKWRR('OUTPUTR',RBUF,1,3,KUNI,STAT)
         GOTO 90000
      ENDIF
C      
C modify band according to joystick movement
      IF ((JX.LE.-64).OR.(JX.GE.64)) THEN
         JX = JX/JF(1)
      ELSE
         JX = JX/JF(2)
      ENDIF
      IF ((JY.LE.-64).OR.(JY.GE.64)) THEN
         JY = JY/JF(1)
      ELSE
         JY = JY/JF(2)
      ENDIF
C      
      IF (JX.EQ.0) GOTO 16800                  !no horizontal movement
      DB = BB - BA                             !save band width
      IF (JX.GT.0) THEN
         BB = MIN(QLUTSZ,BB+JX)                !move band up
         BA = BB - DB
      ELSE
         BA = MAX(1,BA+JX)                     !move band down
         BB = BA + DB
      ENDIF
C      
16800 IF (JY.EQ.0) GOTO 16900
      CB = (BA + BB)/2                         !save center of band
      DB = BB - BA                             !save band width
      IF (JY.GT.0) THEN
         IF (JY.EQ.1) JY = 2
         DB = MIN(QLUTSZ,DB+JY)                !widen the band
         DB2 = DB/2
         BB = MIN(QLUTSZ,CB+DB2)
         BA = MAX(1,CB-DB2)
      ELSE
         IF (JY.EQ.-1) JY = -2
         DB = MAX(1,DB+JY)                     !sqeeze the band
         DB2 = DB/2
         BB = CB + DB2
         BA = CB - DB2
      ENDIF
C      
C  now loop
16900 GOTO 16100
C      

C 
C--------------------------------------------------------------------      
C      
C                          that's it folks...
C 
C--------------------------------------------------------------------      
C 
90000 IF (PFLAG(1:1).EQ.'Y') WRITE(*,30010)
      IF (DISPI.EQ.1) CALL DTCLOS(QDSPNO)
      CALL STSEPI
C      
30000 FORMAT(' start, center, end of band = ',3G10.4)
30010 FORMAT(' ')
C      
      END

      SUBROUTINE HISTEQ(BINS,LEVEL,FSIZE,KBINS,ITT)
C 
C +++++++++++++++++++++++++++++++++++++++++++++++++
C  input par:
C  BINS:       I*4 array      histogram
C  LEVEL:      I*4            no. of levels in histogram (= dim. of BINS)
C  FSIZE:      R*4            no. of pixels in image
C  KBINS:      I*4 array      equalized histogram
C  ITT:        I*2 array      ITT table to realize the equalized histogram
C --------------------------------------------------
C
      IMPLICIT NONE
C 
      INTEGER     BINS(*),LEVEL,KBINS(*),ITT(*)
      INTEGER     IS(512)
      INTEGER     N,NN,NST
C 
      REAL        T(512),S(512),RLEVL,FSIZE
C
      RLEVL = FLOAT((LEVEL-1) * 2)
      T(1) = 1./RLEVL                        !T(n) will be set to midpoints between intervals
      S(1) = FLOAT(BINS(1))/FSIZE            !S(n) is the transfer function
C
      DO 100, N=2,LEVEL
         T(N) = (2*N-1)/RLEVL
         S(N) = S(N-1) + FLOAT(BINS(N))/FSIZE
100   CONTINUE
C
C  assign values of transfer function to nearest slot
      NST = 1                        	!start at slot 1
      DO 1000, N=1,LEVEL
C
         IF (NST.EQ.LEVEL) THEN            !if last slot already reached,
            IS(N) = LEVEL                  !index must be the last possible one
         ELSE
C
            DO 500, NN=NST,LEVEL           !use T(n), to find nearest slot
               IF (S(N).LT.T(NN)) THEN     !in increasing order
                  IS(N) = NN
                  NST = NN
                  GOTO 1000
               ENDIF
500         CONTINUE
         ENDIF
1000  CONTINUE
C
C  calculate equalized histogram
      DO 2100, N=1,LEVEL
         KBINS(N) = 0
2100  CONTINUE
C
      DO 2500, N=1,LEVEL
         NN = IS(N)
         KBINS(NN) = KBINS(NN) + BINS(N)
         ITT(N) = NN - 1
2500  CONTINUE
C
      RETURN
      END

      SUBROUTINE QWRLUT(QD,QCH,QR,KS,KVAL,KLU,KNEW,STAT)

C 
      INTEGER  QD,QCH,QR,KS,KVAL,KLU,KNEW,STAT
      INTEGER  IVIS
C 
      CALL WRLUT(QD,KS,KVAL,KLU,KNEW,STAT)
      IF (QR.GE.2) THEN
         IVIS = 1
         CALL IILSBV(QD,QCH,IVIS,STAT)
      ENDIF
C 
      RETURN 
      END

C @(#)necwlcopt.for	19.1 (ES0-DMD) 02/25/03 14:20:26
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT   (C) 1992 European Southern Observatory
C.IDENT       wlcoptim.for
C.AUTHOR      Pascal Ballester,  ESO - Garching
C.KEYWORDS    Spectroscopy, Echelle,
C.PURPOSE     Computes optimal parameters for the 
C             wavelength calibration
C.VERSION     1.0    Creation    1992-MAY-26
C-------------------------------------------------------
C
C
C  Program : Wavelength Calibration Least Squares Solutions
C
C  This program has been partly generated using Macsyma to 
C  solve the following least-square problem:
C
C     Xr(i) = cos(a) * X(i) + bin * sin(a) * Y(i)    (1)
C
C  takes into account a binning factor of the ccd and a rotation
C  of the detector.
C
C     F(Xr(i)) = B * Xr(i) + A = (m+p(i))*lambda(i)  (2)
C
C  is the echelle relation applied in the rotated space and approximated
C  by a linear relation. m is the absolute order number of a line
C  and p(i) is relative order number of the other lines.
C
C  Macsyma has been used to find different optima, like:
C    - The absolute order number of the first identification : m
C    - The binning factor    : bin
C    - In method ANGLE, the angle of rotation : a
C    - In method PAIR, the wavelength of the two pairs : lambda(1), lambda(2)
C
C  The different least-square solutions are used to compute the optimal
C  value of a parameter, assuming that all other parameters are correctly
C  provided. This is a cross-check of the entered values. By computing 
C  the new rms after replacement of a parameter by its optimal value,
C  it is possible to provide a diagnosis of what action would benefit
C  the most to solve the problem.
C
C  INPUT:
C   IN_A/C/1/60   Name of line table
C   IN_B/C/1/60   Method (PAIR or ANGLE)
C   INPUTR/R/1/2  Angle of rotation, Binning ratio.
C
C  OUTPUT:
C   OUTPUTI/I/1/1 Order number of the first line
C   OUTPUTR/R/1/2 Optimal rotation angle, Optimal binning factor
C
        IMPLICIT NONE

        INTEGER  MAXDIM
        PARAMETER (MAXDIM=1500)
        DOUBLE PRECISION    IX(MAXDIM), IY(MAXDIM)
        DOUBLE PRECISION    IP(MAXDIM), IL(MAXDIM)
        DOUBLE PRECISION    SX, SY, SX2, SY2, SXY
C        DOUBLE PRECISION    SML2K, SXMLK, SYMLK, SMLK
        DOUBLE PRECISION    SP2L2K, BUFFER
        DOUBLE PRECISION    SXLK, SXPLK, SYLK, SYPLK, SPLK, SLK
        DOUBLE PRECISION    SL2K, SPL2K, PK, LK, XK, YK, RMSLK
        DOUBLE PRECISION    SML2, SP2L2, SXML, SYML, SML
        DOUBLE PRECISION    SXL, SXPL, SYL, SYPL, SPL, SL
        DOUBLE PRECISION    SL2, SPL2, SBIN
        INTEGER             M, N, K, M2OPT, LOOP, ERROR, P
        DOUBLE PRECISION    BIN, PI, MDP, MINRMS(MAXDIM)
        DOUBLE PRECISION    A, B1
        DOUBLE PRECISION    TGA1, TGA2, AOPT
        REAL                OUTANG, RBIN
        DOUBLE PRECISION    L1,L2,X1,X2,XP1,XP2,L1OPT,L2OPT
        DOUBLE PRECISION    SXR, SXR2, SXRML, DET, COEFA, COEFB, RMS
        DOUBLE PRECISION    L1OLD, L2OLD, RMSL1, RMSL2
        CHARACTER           MODE*5, METHOD*10, TEXT*80
        INTEGER             MOLD, ROW
        DOUBLE PRECISION    RMSM, MRMS, ARMS, BRMS, AOLD, BOLD
        DOUBLE PRECISION    LKOPT(MAXDIM), LKO

        CHARACTER           TABLE*60
        INTEGER             IAV, KUN, KNUL, ISTAT, ICOLX, ICOLW
        INTEGER             ICOLO, ICOLN, TID, NCOL1, NROW1, NSC1
        INTEGER             NACOL, NAROW, MADRID
        LOGICAL             SELECT

        INCLUDE 'MID_INCLUDE:ST_DEF.INC'
        COMMON/VMR/MADRID(1)
        INCLUDE 'MID_INCLUDE:ST_DAT.INC'

C
C Initialisations

C
C ... Init input table
C
      CALL STSPRO('WLCLS')

      CALL STKRDC('IN_A',1,1,60,IAV,TABLE,KUN,KNUL,ISTAT)
      CALL TBTOPN(TABLE,F_U_MODE,TID,ISTAT)
C
      CALL TBIGET(TID,NCOL1,NROW1,NSC1,NACOL,NAROW,ISTAT)
      CALL TBCSER(TID,':X '    ,ICOLX,ISTAT)
      CALL TBCSER(TID,':IDENT' ,ICOLW,ISTAT)
      CALL TBCSER(TID,':ORDER' ,ICOLO,ISTAT)
      CALL TBCSER(TID,':YNEW'  ,ICOLN,ISTAT)

      CALL STKRDC('IN_B',1,1,10,IAV,METHOD,KUN,KNUL,ISTAT)
      CALL STKRDR('INPUTR',1,1,IAV,OUTANG,KUN,KNUL,ISTAT)   ! Rotation angle
      CALL STKRDR('INPUTR',2,1,IAV,RBIN,KUN,KNUL,ISTAT) ! Binning factor
      PI     = 3.14159
      A      = OUTANG*PI/180.
      BIN    = RBIN
      ERROR  = 0
      IF (METHOD(1:1) .EQ. 'p')  WRITE(METHOD,111) 'PAIR'
      IF (METHOD(1:1) .EQ. 'a')  WRITE(METHOD,111) 'ANGLE'
111   FORMAT(A5)

      N = 0
      DO 100 ROW = NROW1, 1, -1
        CALL TBSGET(TID, ROW, SELECT, ISTAT)
        IF (SELECT) THEN
            N = N + 1
            CALL TBERDD(TID, ROW, ICOLO,  IP(N), KNUL, ISTAT)
            CALL TBERDD(TID, ROW, ICOLX,  IX(N), KNUL, ISTAT)
            CALL TBERDD(TID, ROW, ICOLN,  IY(N), KNUL, ISTAT)
            CALL TBERDD(TID, ROW, ICOLW,  IL(N), KNUL, ISTAT)
        ENDIF
100   CONTINUE
      M = IP(1)
      DO 110 ROW = 1, N
         IP(ROW) = IP(ROW) - M
110   CONTINUE

C Check maximum size of arrays

      IF (MAXDIM .LE. (N+10)) THEN
         CALL STTPUT(
     +   'Buffer size MAXDIM too small in module wlcoptim',ISTAT)
         GOTO 1900
      ENDIF

C Check organisation of data if method PAIR

      IF (METHOD(1:1) .EQ. 'P') THEN

         IF (IL(1) .NE. IL(2))     ERROR = 1
         IF (IL(3) .NE. IL(4))     ERROR = 1
         IF (IP(2) .NE. (IP(1)+1)) ERROR = 1
         IF (IP(4) .NE. (IP(3)+1)) ERROR = 1
         IF (N   .NE. 4)           ERROR = 1

         IF (ERROR .EQ. 1) THEN

           IF (IL(1).EQ.IL(3).AND.IL(2).EQ.IL(4).AND.IP(3).EQ.
     C       (IP(1)+1).AND.IP(4).EQ.(IP(2)+1).AND.N.EQ.4) THEN

              ERROR  = 0

              BUFFER = IL(2)
              IL(2)  = IL(3)
              IL(3)  = BUFFER

              BUFFER = IX(2)
              IX(2)  = IX(3)
              IX(3)  = BUFFER

              BUFFER = IY(2)
              IY(2)  = IY(3)
              IY(3)  = BUFFER

              BUFFER = IP(2)
              IP(2)  = IP(3)
              IP(3)  = NINT(BUFFER)

           ELSE
         CALL STTPUT(
     +   'Error:     Identifications are wrongly organized',ISTAT)
         CALL STTPUT(
     +   'Remember : First line:  left-hand side, then right-side',
     +   ISTAT)
         CALL STTPUT(
     +   '           Second line: left-hand side, then right-side',
     +   ISTAT)
         GOTO 1900

           ENDIF

         ENDIF

       ENDIF

C Check that identifications are in different orders for method ANGLE

       IF (METHOD(1:1) .EQ. 'A') THEN

          SPL = 0.D0
          DO 200 ROW = 1,N
             SPL = SPL + IP(ROW)
200       CONTINUE
C234567890123456789012345678901234567890123456789012345678901234567890123456
          IF (SPL .LT. 0.5) THEN
             CALL STTPUT(
     + 'Error: Identifications cannot be all in the same order',ISTAT)
             GOTO 1900
          ENDIF

       ENDIF

C Computes sums

        SX    = 0.D0
        SY    = 0.D0
        SX2   = 0.D0
        SXY   = 0.D0
        SY2   = 0.D0

        SYL   = 0.D0
        SYPL  = 0.D0
        SPL   = 0.D0
        SL    = 0.D0
        SL2   = 0.D0
        SPL2  = 0.D0
        SP2L2 = 0.D0
        SXL   = 0.D0
        SXPL  = 0.D0

        DO 10 LOOP = 1 , N

           SX    = SX    + IX(LOOP)
           SY    = SY    + IY(LOOP)
           SX2   = SX2   + IX(LOOP)*IX(LOOP)
           SY2   = SY2   + IY(LOOP)*IY(LOOP)
           SXY   = SXY   + IX(LOOP)*IY(LOOP)
           SYL   = SYL   + IY(LOOP)*IL(LOOP)
           SYPL  = SYPL  + IY(LOOP)*IP(LOOP)*IL(LOOP)
           SPL   = SPL   + IP(LOOP)*IL(LOOP)
           SL    = SL    + IL(LOOP)
           SL2   = SL2   + IL(LOOP)*IL(LOOP)
           SPL2  = SPL2  + IP(LOOP)*IL(LOOP)**2
           SP2L2 = SP2L2 + IP(LOOP)**2*IL(LOOP)**2
           SXL   = SXL   + IX(LOOP)*IL(LOOP)
           SXPL  = SXPL  + IX(LOOP)*IP(LOOP)*IL(LOOP)

10      CONTINUE

      SXML = M*SXL + SXPL
      SYML = M*SYL + SYPL
      SML  = M*SL  + SPL
      SML2 = M*M*SL2 + 2*M*SPL2 + SP2L2

C  Computes a linear fit and display results

      SXR   = COS(A)*SX + BIN*SIN(A)*SY
      SXR2  = SX2*COS(A)**2+2*SXY*COS(A)*BIN*SIN(A)+
     1        SY2*SIN(A)**2*BIN**2
      SXRML = SXML*COS(A)+SYML*SIN(A)*BIN
      DET   = N*SXR2-SXR*SXR
      COEFA = (SML*SXR2-SXR*SXRML)/DET
      COEFB = (N*SXRML-SXR*SML)/DET
      RMS   = SML2-2*COEFA*COEFB*SXR-COEFB*COEFB*SXR2-N*COEFA*COEFA
      RMS   = SQRT(RMS/N)

C     Display header

      WRITE(TEXT,510)
      CALL STTPUT(TEXT,ISTAT)
      WRITE(TEXT,570)
      CALL STTPUT(TEXT,ISTAT)
      WRITE(TEXT,510)
      CALL STTPUT(TEXT,ISTAT)
      WRITE(TEXT,520)
      CALL STTPUT(TEXT,ISTAT)
      WRITE(TEXT,500) COEFA,COEFB,RMS
      CALL STTPUT(TEXT,ISTAT)
      WRITE(TEXT,510)
      CALL STTPUT(TEXT,ISTAT)
      WRITE(TEXT,530)
      CALL STTPUT(TEXT,ISTAT)
      WRITE(TEXT,510)
      CALL STTPUT(TEXT,ISTAT)

500   FORMAT (1X,'* A = ',F12.5,' B= ',F12.5,' RMS = ',F12.3,7X,'*')
510   FORMAT (1X,61('*'))
520   FORMAT (1X,'*',10X,'Linear fit of : m * lambda = b * xr + a',
     C        10X,'*')
530   FORMAT (1X,'*    Parameter    *    Value    *    Optimum   *',
     C        '    RMS     *')
540   FORMAT (1X,'*',A16,' *',F12.5,' *',F13.5,' *',F11.2,' *')
550   FORMAT (1X,'*',' Ident ',I6,4X,'*',F12.5,' *',F13.5,' *',
     C        F11.2,' *')
560   FORMAT (1X,'*',A16,' *   ',I6,'    *   ',I7,'    *',F11.2,' *')
570   FORMAT (1X,'*',13X,'Wavelength Calibration Diagnosis',14X,'*')
C Least square solutions for the methods PAIR and ANGLE

C   Optimal Rotation Angle

      DET = ABS(N*SYML-SML*SY)

      IF (DET .GT. 0.01) THEN

      TGA1 = (N*(SX2*SYML-SXML*SXY)-SX**2*SYML+SML*(SX*SXY-SX2
     1   *SY)+SX*SXML*SY)/(BIN*(N*(SXML*SY2-SXY*SYML)+SX*SY*SYML+SML*(SX
     2   Y*SY-SX*SY2)-SXML*SY**2))

      TGA2 = -(N*SXML-SML*SX)/(BIN*(N*SYML-SML*SY))

      AOPT = ATAN(TGA1)

      ELSE

      AOPT = -999
   
      ENDIF

C   Optimal Binning Factor

      IF (ABS(A) .GT. 0.02) THEN

      B1 = COS(A)*(N*(SX2*SYML-SXML*SXY)-SX**2*SYML+SML*(SX*SXY-SX2*SY
     1   )+SX*SXML*SY)/(SIN(A)*(N*(SXML*SY2-SXY*SYML)+SX*SY*SYML+SML*(SX
     2   Y*SY-SX*SY2)-SXML*SY**2))

      ELSE

      B1 = -999

      ENDIF

C   Optimal Absolute Order Number for the first identified line

      MDP = -((SIN(A)**2*BIN**2*N*SYL-SIN(A)**2*BIN**2*SL*SY+COS(
     1   A)*SIN(A)*BIN*N*SXL-COS(A)*SIN(A)*BIN*SL*SX)*SYPL+(-SIN(A)**2*B
     2   IN**2*SPL*SY+COS(A)*SIN(A)*BIN*N*SXPL-COS(A)*SIN(A)*BIN*SPL*SX)
     3   *SYL+(SIN(A)**2*BIN**2*SL*SPL-SIN(A)**2*BIN**2*N*SPL2)*SY2+SIN(
     4   A)**2*BIN**2*SPL2*SY**2+(-COS(A)*SIN(A)*BIN*SL*SXPL-COS(A)*SIN(
     5   A)*BIN*SPL*SXL+2*COS(A)*SIN(A)*BIN*SPL2*SX)*SY+(2*COS(A)*SIN(A)
     6   *BIN*SL*SPL-2*COS(A)*SIN(A)*BIN*N*SPL2)*SXY+(COS(A)**2*N*SXL-CO
     7   S(A)**2*SL*SX)*SXPL-COS(A)**2*SPL*SX*SXL+(COS(A)**2*SL*SPL-COS(
     8   A)**2*N*SPL2)*SX2+COS(A)**2*SPL2*SX**2)/(SIN(A)**2*BIN**2*N*SYL
     9   **2+(-2*SIN(A)**2*BIN**2*SL*SY+2*COS(A)*SIN(A)*BIN*N*SXL-2*COS(
     :   A)*SIN(A)*BIN*SL*SX)*SYL+(SIN(A)**2*BIN**2*SL**2-SIN(A)**2*BIN*
     ;   *2*N*SL2)*SY2+SIN(A)**2*BIN**2*SL2*SY**2+(2*COS(A)*SIN(A)*BIN*S
     <   L2*SX-2*COS(A)*SIN(A)*BIN*SL*SXL)*SY+(2*COS(A)*SIN(A)*BIN*SL**2
     =   -2*COS(A)*SIN(A)*BIN*N*SL2)*SXY+COS(A)**2*N*SXL**2-2*COS(A)**2*
     >   SL*SX*SXL+(COS(A)**2*SL**2-COS(A)**2*N*SL2)*SX2+COS(A)**2*SL2*S
     ?   X**2)

      M2OPT = NINT(MDP)

C Compute new rms if a value is changed.

      MOLD = M         ! Keep the old value in memory
      M = M2OPT        ! Replace current value by optimum
      MODE = 'M'       ! Set the mode
      GOTO 1000        ! Compute rms 
1001  CONTINUE         ! Return point
      M = MOLD         ! Restore old value
      MRMS = RMSM      ! Store rms
      MINRMS(1) = RMSM

      WRITE(TEXT,560) 'Order number',M,M2OPT,MRMS
      CALL STTPUT(TEXT,ISTAT)
      CALL STKWRI('OUTPUTI',M2OPT,1,1,KUN,ISTAT)

      AOLD = A
      A = AOPT
      MODE = 'A'
      GOTO 1000
1002  CONTINUE         ! Return point
      A = AOLD
      ARMS = RMSM
      MINRMS(2) = RMSM

      WRITE(TEXT,540) 'Rotation angle',(A*180./PI),(AOPT*180/PI),ARMS
      CALL STTPUT(TEXT,ISTAT)
      OUTANG = AOPT*180./PI
      CALL STKWRR('OUTPUTR',OUTANG,1,1,KUN,ISTAT)

      BOLD = BIN
      BIN = B1
      MODE = 'B'
      GOTO 1000
1003  CONTINUE         ! Return point
      BIN = BOLD
      BRMS = RMSM
      MINRMS(3) = RMSM

      IF (B1 .GT. 0) THEN
        WRITE(TEXT,540) 'Binning factor',BIN,SQRT(B1),BRMS
        CALL STTPUT(TEXT,ISTAT)
      ELSE
        WRITE(TEXT,540) 'Binning factor',BIN,BIN,0.
        CALL STTPUT(TEXT,ISTAT)
      ENDIF

C
C Least square solutions for the method PAIR

      IF (METHOD(1:1) .EQ. 'P') THEN

      X1  = IX(1)
      XP1 = IX(2)
      X2  = IX(3)
      XP2 = IX(4)
      P   = IP(3) - IP(1)
      L1  = IL(1)
      L2  = IL(3)

      L1OPT = (((2*L2*M+L2)*P+2*L2*M**2+L2*M)*XP2**2+((L2*P+2*L2*M+2*L2)
     1   *XP1+((-4*L2*M-2*L2)*P-4*L2*M**2-4*L2*M-L2)*X2+(-L2*P-L2)*X1)
     2   *XP2+(2*L2*M*P+2*L2*M**2+L2*M)*XP1**2+((L2*P-L2)*X2+
     3   ((-4*L2*M-2*L2)*P-4*L2*M**2-4*L2*M-L2)*X1)*XP1+((2*L2*M+L2)*P+
     4   2*L2*M**2+3*L2*M+L2)*X2**2+(-L2*P-2*L2*M)*X1*X2+((2*L2*M+2*L2)
     5   *P+2*L2*M**2+3*L2*M+L2)*X1**2)/((2*M**2+2*M+2)*XP2**2+(2*M*XP1
     6   +(-4*M**2-4*M-2)*X2+(-2*M-2)*X1)*XP2+2*M**2*XP1**2+(2*M*X2+(-4
     7   *M**2-4*M)*X1)*XP1+(2*M**2+2*M+2)*X2**2+(-2*M-2)*X1*X2+(2*M**2
     8   +4*M+2)*X1**2)

         L1OLD = L1
         L1 = L1OPT

      RMSL1 = -4*((2*L2*P+2*(L2+L1)*M+L2+L1)*(XP2**2+XP1**2+X2**2+X1**2)
     1 -(XP2+XP1+X2+X1)*(L2*(P+M+1)*XP2+L1*(M+1)*XP1+L2*(P+M)*X2+L1*M*X1
     2   ))**2/(4*(XP2**2+XP1**2+X2**2+X1**2)-(XP2+XP1+X2+X1)**2)**2-2*(
     3   XP2+XP1+X2+X1)*(4*(L2*(P+M+1)*XP2+L1*(M+1)*XP1+L2*(P+M)*X2+L1*M
     4   *X1)-(2*L2*P+2*(L2+L1)*M+L2+L1)*(XP2+XP1+X2+X1))*((2*L2*P+2*(L2
     5   +L1)*M+L2+L1)*(XP2**2+XP1**2+X2**2+X1**2)-(XP2+XP1+X2+X1)*(L2*(
     6   P+M+1)*XP2+L1*(M+1)*XP1+L2*(P+M)*X2+L1*M*X1))/(4*(XP2**2+XP1**2
     7   +X2**2+X1**2)-(XP2+XP1+X2+X1)**2)**2-(4*(L2*(P+M+1)*XP2+L1*(M+1
     8   )*XP1+L2*(P+M)*X2+L1*M*X1)-(2*L2*P+2*(L2+L1)*M+L2+L1)*(XP2+XP1+
     9   X2+X1))**2*(XP2**2+XP1**2+X2**2+X1**2)/(4*(XP2**2+XP1**2+X2**2+
     :   X1**2)-(XP2+XP1+X2+X1)**2)**2+L2**2*(P+M+1)**2+L2**2*(P+M)**2+L
     ;   1**2*(M+1)**2+L1**2*M**2

         L1 = L1OLD

      L2OPT = (((2*L1*M+L1)*P+2*L1*M**2+L1*M)*XP2**2+((L1*P+2*L1*M+2
     1   *L1)*XP1+((-4*L1*M-2*L1)*P-4*L1*M**2-4*L1*M-L1)*X2+(-L1*P-L1)*X
     2   1)*XP2+(2*L1*M*P+2*L1*M**2+L1*M)*XP1**2+((L1*P-L1)*X2+((-4*L1*M
     3   -2*L1)*P-4*L1*M**2-4*L1*M-L1)*X1)*XP1+((2*L1*M+L1)*P+2*L1*M**2+
     4   3*L1*M+L1)*X2**2+(-L1*P-2*L1*M)*X1*X2+((2*L1*M+2*L1)*P+2*L1*M**
     5   2+3*L1*M+L1)*X1**2)/((2*P**2+4*M*P+2*M**2)*XP2**2+((2*P+2*M)*XP
     6   1+(-4*P**2+(-8*M-4)*P-4*M**2-4*M)*X2+(2*P+2*M)*X1)*XP2+(2*P**2+
     7   (4*M+2)*P+2*M**2+2*M+2)*XP1**2+((-2*P-2*M-2)*X2+(-4*P**2+(-8*M-
     8   4)*P-4*M**2-4*M-2)*X1)*XP1+(2*P**2+(4*M+4)*P+2*M**2+4*M+2)*X2**
     9   2+(-2*P-2*M-2)*X1*X2+(2*P**2+(4*M+2)*P+2*M**2+2*M+2)*X1**2)

         L2OLD = L2
         L2 = L2OPT

      RMSL2 = -4*((2*L2*P+2*(L2+L1)*M+L2+L1)*(XP2**2+XP1**2+X2**2+X1**2)
     1 -(XP2+XP1+X2+X1)*(L2*(P+M+1)*XP2+L1*(M+1)*XP1+L2*(P+M)*X2+L1*M*X1
     2   ))**2/(4*(XP2**2+XP1**2+X2**2+X1**2)-(XP2+XP1+X2+X1)**2)**2-2*(
     3   XP2+XP1+X2+X1)*(4*(L2*(P+M+1)*XP2+L1*(M+1)*XP1+L2*(P+M)*X2+L1*M
     4   *X1)-(2*L2*P+2*(L2+L1)*M+L2+L1)*(XP2+XP1+X2+X1))*((2*L2*P+2*(L2
     5   +L1)*M+L2+L1)*(XP2**2+XP1**2+X2**2+X1**2)-(XP2+XP1+X2+X1)*(L2*(
     6   P+M+1)*XP2+L1*(M+1)*XP1+L2*(P+M)*X2+L1*M*X1))/(4*(XP2**2+XP1**2
     7   +X2**2+X1**2)-(XP2+XP1+X2+X1)**2)**2-(4*(L2*(P+M+1)*XP2+L1*(M+1
     8   )*XP1+L2*(P+M)*X2+L1*M*X1)-(2*L2*P+2*(L2+L1)*M+L2+L1)*(XP2+XP1+
     9   X2+X1))**2*(XP2**2+XP1**2+X2**2+X1**2)/(4*(XP2**2+XP1**2+X2**2+
     :   X1**2)-(XP2+XP1+X2+X1)**2)**2+L2**2*(P+M+1)**2+L2**2*(P+M)**2+L
     ;   1**2*(M+1)**2+L1**2*M**2


         RMSL1 = SQRT(RMSL1/4.)
         RMSL2 = SQRT(RMSL2/4.)

        WRITE(TEXT,540) 'Ident. 1 and 2',L1OLD,L1OPT,RMSL1
        CALL STTPUT(TEXT,ISTAT)
        WRITE(TEXT,540) 'Ident. 3 and 4',L2OLD,L2OPT,RMSL2
        CALL STTPUT(TEXT,ISTAT)

        MINRMS(4) = RMSL1
        MINRMS(5) = RMSL1
        MINRMS(6) = RMSL2
        MINRMS(7) = RMSL2
        LKOPT(1)  = L1OPT
        LKOPT(2)  = L1OPT
        LKOPT(3)  = L2OPT
        LKOPT(4)  = L2OPT

      ENDIF


C  Optimal Wavelength for each of the computed wavelength IL(LOOP)

      IF (METHOD(1:1) .EQ. 'A') THEN


      DO 50 K = 1,N

        PK  = IP(K)
        LK  = IL(K)
        XK  = IX(K)
        YK  = IY(K)

        SYLK   = 0.D0
        SYPLK  = 0.D0
        SPLK   = 0.D0
        SLK    = 0.D0
        SL2K   = 0.D0
        SPL2K  = 0.D0
        SP2L2K = 0.D0
        SXLK   = 0.D0
        SXPLK  = 0.D0

        DO 30 LOOP = 1 , N

         IF (LOOP.NE.K) THEN
           SYLK   = SYLK   + IY(LOOP)*IL(LOOP)
           SYPLK  = SYPLK  + IY(LOOP)*IP(LOOP)*IL(LOOP)
           SPLK   = SPLK   + IP(LOOP)*IL(LOOP)
           SLK    = SLK    + IL(LOOP)
           SL2K   = SL2K   + IL(LOOP)*IL(LOOP)
           SPL2K  = SPL2K  + IP(LOOP)*IL(LOOP)**2
           SP2L2K = SP2L2K + IP(LOOP)**2*IL(LOOP)**2
           SXLK   = SXLK   + IX(LOOP)*IL(LOOP)
           SXPLK  = SXPLK  + IX(LOOP)*IP(LOOP)*IL(LOOP)
         ENDIF

30      CONTINUE

C The formula for LKOPT is splitted in two parts (too big for the poor
C  compiler !!)

        SBIN = (
     <   (SIN(A)**2*BIN**2*N*PK+SIN(A)**2*BIN**2*M*N)*YK**2+((2*COS(A)*S
     =   IN(A)*BIN*N*PK+2*COS(A)*SIN(A)*BIN*M*N)*XK+(-2*SIN(A)**2*BIN**2
     >   *PK-2*SIN(A)**2*BIN**2*M)*SY+(-2*COS(A)*SIN(A)*BIN*PK-2*COS(A)*
     ?   SIN(A)*BIN*M)*SX)*YK+(COS(A)**2*N*PK+COS(A)**2*M*N)*XK**2+((-2*
     @   COS(A)*SIN(A)*BIN*PK-2*COS(A)*SIN(A)*BIN*M)*SY+(-2*COS(A)**2*PK
     1   -2*COS(A)**2*M)*SX)*XK+((SIN(A)**2*BIN**2-SIN(A)**2*BIN**2*N)*P
     2   K-SIN(A)**2*BIN**2*M*N+SIN(A)**2*BIN**2*M)*SY2+(SIN(A)**2*BIN**
     3   2*PK+SIN(A)**2*BIN**2*M)*SY**2+(2*COS(A)*SIN(A)*BIN*PK+2*COS(A)
     4   *SIN(A)*BIN*M)*SX*SY+((2*COS(A)*SIN(A)*BIN-2*COS(A)*SIN(A)*BIN*
     5   N)*PK-2*COS(A)*SIN(A)*BIN*M*N+2*COS(A)*SIN(A)*BIN*M)*SXY+((COS(
     6   A)**2-COS(A)**2*N)*PK-COS(A)**2*M*N+COS(A)**2*M)*SX2+(COS(A)**2
     7   *PK+COS(A)**2*M)*SX**2)

       LKOPT(K) = -((SIN(A)**2*BIN**2*N*SYPLK+SIN(A)**2*BIN**2*M*N*SY
     1   LK+(-SIN(A)**2*BIN**2*SPLK-SIN(A)**2*BIN**2*M*SLK)*SY+COS(A)*SI
     2   N(A)*BIN*N*SXPLK+COS(A)*SIN(A)*BIN*M*N*SXLK+(-COS(A)*SIN(A)*BIN
     3   *SPLK-COS(A)*SIN(A)*BIN*M*SLK)*SX)*YK+(COS(A)*SIN(A)*BIN*N*SYPL
     4   K+COS(A)*SIN(A)*BIN*M*N*SYLK+(-COS(A)*SIN(A)*BIN*SPLK-COS(A)*SI
     5   N(A)*BIN*M*SLK)*SY+COS(A)**2*N*SXPLK+COS(A)**2*M*N*SXLK+(-COS(A
     6   )**2*SPLK-COS(A)**2*M*SLK)*SX)*XK+(-SIN(A)**2*BIN**2*SY-COS(A)*
     7   SIN(A)*BIN*SX)*SYPLK+(-SIN(A)**2*BIN**2*M*SY-COS(A)*SIN(A)*BIN*
     8   M*SX)*SYLK+(SIN(A)**2*BIN**2*SPLK+SIN(A)**2*BIN**2*M*SLK)*SY2+(
     9   -COS(A)*SIN(A)*BIN*SXPLK-COS(A)*SIN(A)*BIN*M*SXLK)*SY+(2*COS(A)
     :   *SIN(A)*BIN*SPLK+2*COS(A)*SIN(A)*BIN*M*SLK)*SXY-COS(A)**2*SX*SX
     ;   PLK-COS(A)**2*M*SX*SXLK+(COS(A)**2*SPLK+COS(A)**2*M*SLK)*SX2)/
     +   SBIN

         LKO = LKOPT(K)

      RMSLK = -N*((SPLK+M*SLK+LKO*(PK+M))*(SIN(A)**2*BIN**2*SY2+2*COS(A)
     1   *SIN(A)*BIN*SXY+COS(A)**2*SX2)-(SIN(A)*BIN*SY+COS(A)*SX)*(SIN(A
     2   )*BIN*(M*(LKO*YK+SYLK)+LKO*PK*YK+SYPLK)+COS(A)*(M*(LKO*XK+SXLK)
     C   +LKO
     3   *PK*XK+SXPLK)))**2/(N*(SIN(A)**2*BIN**2*SY2+2*COS(A)*SIN(A)*BIN
     4   *SXY+COS(A)**2*SX2)-(SIN(A)*BIN*SY+COS(A)*SX)**2)**2-2*(SIN(A)*
     5 BIN*SY+COS(A)*SX)*(N*(SIN(A)*BIN*(M*(LKO*YK+SYLK)+LKO*PK*YK+SYPLK
     6)+COS(A)*(M*(LKO*XK+SXLK)+LKO*PK*XK+SXPLK))-(SPLK+M*SLK+LKO*(PK+M)
     7  )*(SIN(A)*BIN*SY+COS(A)*SX))*((SPLK+M*SLK+LKO*(PK+M))*(SIN(A)**2
     8   *BIN**2*SY2+2*COS(A)*SIN(A)*BIN*SXY+COS(A)**2*SX2)-(SIN(A)*BIN*
     9 SY+COS(A)*SX)*(SIN(A)*BIN*(M*(LKO*YK+SYLK)+LKO*PK*YK+SYPLK)+COS(A
     : )*(M*(LKO*XK+SXLK)+LKO*PK*XK+SXPLK)))/(N*(SIN(A)**2*BIN**2*SY2+2*
     ;   COS(A)*SIN(A)*BIN*SXY+COS(A)**2*SX2)-(SIN(A)*BIN*SY+COS(A)*SX)*
     <   *2)**2-(SIN(A)**2*BIN**2*SY2+2*COS(A)*SIN(A)*BIN*SXY+COS(A)**2*
     + SX2)*(N*(SIN(A)*BIN*(M*(LKO*YK+SYLK)+LKO*PK*YK+SYPLK)+COS(A)*(M*(
     >LKO*XK+SXLK)+LKO*PK*XK+SXPLK))-(SPLK+M*SLK+LKO*(PK+M))*(SIN(A)*BIN
     ?   *SY+COS(A)*SX))**2/(N*(SIN(A)**2*BIN**2*SY2+2*COS(A)*SIN(A)*BIN
     @   *SXY+COS(A)**2*SX2)-(SIN(A)*BIN*SY+COS(A)*SX)**2)**2+2*M*SPL2K+
     1   SP2L2K+M**2*SL2K+LKO**2*(PK+M)**2


         RMSLK = SQRT(RMSLK/N)
         MINRMS(3+K) = RMSLK
         WRITE(TEXT,550) K,LK,LKOPT(K),RMSLK
         CALL STTPUT(TEXT,ISTAT)

50      CONTINUE

        ENDIF

        WRITE(TEXT,510)
        CALL STTPUT(TEXT,ISTAT)

        GOTO 2000

C **********************************************************************

1000    CONTINUE
C       Computes RMS(A,M,BIN). There are too many parameters to create
C       a subroutine. Let's use the good old GOTO.

       RMSM = -N*((SPL+M*SL)*(SIN(A)**2*BIN**2*SY2+2*COS(A)*SIN(A)*BIN*S
     1   XY+COS(A)**2*SX2)-(SIN(A)*BIN*SY+COS(A)*SX)*(SIN(A)*BIN*(SYPL+M
     2   *SYL)+COS(A)*(SXPL+M*SXL)))**2/(N*(SIN(A)**2*BIN**2*SY2+2*COS(A
     3   )*SIN(A)*BIN*SXY+COS(A)**2*SX2)-(SIN(A)*BIN*SY+COS(A)*SX)**2)**
     4   2-2*(SIN(A)*BIN*SY+COS(A)*SX)*(N*(SIN(A)*BIN*(SYPL+M*SYL)+COS(A
     5   )*(SXPL+M*SXL))-(SPL+M*SL)*(SIN(A)*BIN*SY+COS(A)*SX))*((SPL+M*S
     6   L)*(SIN(A)**2*BIN**2*SY2+2*COS(A)*SIN(A)*BIN*SXY+COS(A)**2*SX2)
     7   -(SIN(A)*BIN*SY+COS(A)*SX)*(SIN(A)*BIN*(SYPL+M*SYL)+COS(A)*(SXP
     8   L+M*SXL)))/(N*(SIN(A)**2*BIN**2*SY2+2*COS(A)*SIN(A)*BIN*SXY+COS
     9   (A)**2*SX2)-(SIN(A)*BIN*SY+COS(A)*SX)**2)**2-(SIN(A)**2*BIN**2*
     :   SY2+2*COS(A)*SIN(A)*BIN*SXY+COS(A)**2*SX2)*(N*(SIN(A)*BIN*(SYPL
     ;   +M*SYL)+COS(A)*(SXPL+M*SXL))-(SPL+M*SL)*(SIN(A)*BIN*SY+COS(A)*S
     <   X))**2/(N*(SIN(A)**2*BIN**2*SY2+2*COS(A)*SIN(A)*BIN*SXY+COS(A)*
     =   *2*SX2)-(SIN(A)*BIN*SY+COS(A)*SX)**2)**2+2*M*SPL2+SP2L2+M**2*SL
     >   2

         RMSM = SQRT(RMSM/N)

        IF (MODE(1:1) .EQ. 'M') GOTO 1001  ! Absolute order number
        IF (MODE(1:1) .EQ. 'A') GOTO 1002  ! Angle
        IF (MODE(1:1) .EQ. 'B') GOTO 1003  ! Bin

C **********************************************************************

1900    CONTINUE
        ERROR = 1

2000    CONTINUE
        CALL STKWRI('OUTPUTI',ERROR,1,1,KUN,ISTAT)
        CALL STSEPI
        STOP
        END

C @(#)lmtdet.for	19.1 (ES0-DMD) 02/25/03 13:25:35
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  Subroutine LMTDET          version 1.0          870615
C  A. Kruszewski              ESO Garching
C.PURPOSE
C  Sets a region around current detection to be searched for other
C  detections
C.INPUT/OUTPUT
C  Input parameters
C  DLIM        real*4                  maximum separation between
C                                      different detections to belong
C                                      to the same object
C  ILIM        integer*4               the same but integer
C  Output parameters
C  LMAR        integer*4 array         array with region limits
C-----------------------------------------------------------------------
      SUBROUTINE LMTDET(ILIM, DLIM, LMAR)
C 
      IMPLICIT  NONE
      INTEGER   ILIM
      REAL      DLIM
      INTEGER   LMAR(2,0:ILIM)
C
      INTEGER   ITMP
      INTEGER   L
      REAL      TEMP
C
      LMAR(1,0) = ILIM
      LMAR(2,0) = -1
      DO 10 L = 1 , ILIM
          TEMP   = DLIM*DLIM - FLOAT(L*L)
          IF ( TEMP .GE. 1.0 ) THEN
            ITMP = INT(SQRT(TEMP))
            LMAR(1,L) = ITMP
            LMAR(2,L) = ITMP
          ELSE
            LMAR(1,L) = 0
            LMAR(2,L) = 0
          ENDIF
   10      CONTINUE
C
      RETURN
C
      END

C @(#)poly1d.for	19.1 (ES0-DMD) 02/25/03 13:17:43
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE POLY1D(X,NP,PARAM,Y1,DERIV)                                    
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                  
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  18:01 - 21 DEC 1987                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C--------------------------------------------------------------                 
C***************************************************                            
C                                                                               
C      IMPLICIT NONE                                                            
C  FIT WITH A 1-DIMENSIONAL POLYNOMIAL OF ORDER NP-1                            
C                                                                               
C Y1 = SUM(A(I)*X**(I-1))                                                       
C                                                                               
C***************************************************                            
C                                                                               
C  Author: O.-G. Richter, ESO Garching                                          
C                                                                               
      INTEGER I,NP
      REAL X
      DOUBLE PRECISION Y1,PARAM(NP),DERIV(NP)                                   
      DOUBLE PRECISION A                                                        
C                                                                               
      Y1     = PARAM(1)                                                         
      DERIV(1) = 1.0D0                                                          
      IF (NP.LT.2) RETURN                                                       
      A      = 1.0D0                                                            
      DO 10 I = 2,NP                                                            
          A      = A*X                                                          
          DERIV(I) = A                                                          
          Y1     = Y1 + A*PARAM(I)                                              
   10 CONTINUE                                                                  
      RETURN                                                                    
                                                                                
      END                                                                       

C @(#)aprbgr.for	19.1 (ES0-DMD) 02/25/03 13:25:31
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine APRBGR         version 1         820507
C  A. Kruszewski             ESO Garching
C  modified for FX           version 1.1       870219
C  A. Kruszewski             Obs. de Geneve
C  modified for MSDOS        version 1.2       880522
C.KEYWORDS
C  background
C.PURPOSE
C  calculates approximate value of local sky background
C.ALGORITHM
C  averages of 9 pixels are calculated in four corners
C  of a detection square
C  second smallest of these averages is accepted as background
C.INPUT/OUTPUT
C  input arguments
C  A           real*4 array         image buffer
C  JAPY        integer*4 array      array of line pointers
C  JOFF        integer*4            line number offset
C  JXY         integer*4 array      limits of subarray
C  output arguments
C  SB2         real*4            approximate background
C-----------------------------------------------------------------------
      SUBROUTINE APRBGR(A, JAPY, JOFF, JXY, SB2)
C
      IMPLICIT NONE
C
      REAL      A(1)
      INTEGER   JAPY(1)
      INTEGER   JOFF
      INTEGER   JXY(4)
      REAL      SB2
C
      INTEGER   J1, J2, JJ, JJJ, JOF
      REAL      AA , AVER(4) 
      REAL      SUM
      INTEGER   I1 , I2 , II , III , IJ(2,4) , ITMP
      INTEGER   K
C
C   
C ******      Averages of four 3x3 arrays of pixels are obtained.
C ******      These arrays are situated in corners of a bigger
C ******      array defined by its borders stored in array JXY.
C
      IJ(1,1) = JXY(1) + 1
      IJ(2,1) = JXY(2) + 1
      IJ(1,2) = JXY(3) - 1
      IJ(2,2) = JXY(2) + 1
      IJ(1,3) = JXY(1) + 1
      IJ(2,3) = JXY(4) - 1
      IJ(1,4) = JXY(3) - 1
      IJ(2,4) = JXY(4) - 1
      DO 10 K = 1 , 4
          SUM = 0.0
          ITMP = IJ(2,K)
          J1 = ITMP - 1
          J2 = ITMP + 1
          DO 20 JJ = J1 , J2
            JOF = JAPY(JJ-JOFF)
            ITMP = IJ(1,K)
            I1 = ITMP - 1
            I2 = ITMP + 1
            DO 30 II = I1 , I2
                SUM = SUM + A(JOF+II)
   30            CONTINUE
   20          CONTINUE
            AVER(K) = SUM / 9.0
   10      CONTINUE
C
C ******      Find second smallest value of array AVER.
C
      DO 11 JJJ = 2 , 3
          DO 12 III = JJJ , 4
            IF ( AVER(III-1) .LT. AVER(III) ) THEN
                AA = AVER(III-1)
                AVER(III-1) = AVER(III)
                AVER(III) = AA
            ENDIF
   12          CONTINUE
   11      CONTINUE
C
      SB2 = AVER(3)
C
      RETURN
C
      END

C @(#)sfft.for	19.1 (ES0-DMD) 02/25/03 13:30:48
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  SUBROUTINE FFT           VERSION 1.0               JAN. 30, 1983
C  IEEE TRANS AU 17
C 
C FAST FOURIER ANALYSIS SUBROUTINE (FFA)
C THIS PROGRAM IS TAKEN FROM IEEE TRANS. AU 17 (1969) 138 
C THIS SUBROUTINE REPLACES THE REAL VECTOR B(K), (K=1,2,...,N)
C WITH ITS FINITE DISCRETE FOURIER TRANSFORM X(J) WHICH IS RETURNED 
C SUCH THAT X(0) = B(1), X(N/2) = B(2), AND X(J) = B(2*J+1)+I*B(2*J+2), 
C (I.E. X(1) = B(3) + I B(4), X(2) = B(5) + I B(6), ETC.) THE 
C SUBROUTINE IS CALLED AS FFA(M,B) WHERE N = 2**M AND B IS AN 
C N TERM REAL ARRAY. A REAL-VALUED, RADIX 8 ALGORITHM IS USED 
C WITH IN-PLACE REORDERING AND THE TRIG FUNCTIONS ARE COMPUTED AS 
C NEEDED. 
C
C     SINGLE PRECISION VERSION
C 
C---------------------------------------------------------------------
      SUBROUTINE FFA(M,B)
      IMPLICIT NONE
      INTEGER  M
      REAL     B(1)
C
      INTEGER  N, NN
      INTEGER  N8POW
      INTEGER  INT, IT
C
      N = 2**M
      N8POW = M/3 
C 
C DO A RADIX 2 OR RADIX 4 ITERATION FIRST IF ONE IS REQUIRED
C 
      IF (M-N8POW*3-1) 30,20,10
   10 NN = 4
      INT = N/NN
      CALL R4TR(INT,B(1),B(INT+1),B(2*INT+1),B(3*INT+1))
      GO TO 40
   20 NN = 2
      INT = N/NN
      CALL R2TR(INT,B(1),B(INT+1))
      GO TO 40
   30 NN = 1
C 
C PERFORM RADIX 8 ITERATIONS
C 
   40 IF (N8POW) 70,70,45
   45 DO 50 IT = 1,N8POW
      NN = NN*8 
      INT = N/NN
      CALL R8TR(INT,NN,B(1),B(INT+1),B(INT*2+1),B(3*INT+1), 
     1 B(4*INT+1),B(5*INT+1),B(6*INT+1),B(7*INT+1),B(1),B(INT+1), 
     2 B(2*INT+1),B(3*INT+1),B(4*INT+1),B(5*INT+1),B(6*INT+1),
     3 B(7*INT+1))
   50 CONTINUE
C 
C PERFORM IN-PLACE REORDERING 
C 
      CALL ORD1(M,B)
      CALL ORD2(M,B)
   70 RETURN
      END
C--------------------------------------------------------------------
      SUBROUTINE FFS(M,B) 
C 
C FAST FOURIER SYNTHESIS SUBROUTINE (FFS) 
C THIS SUBROUTINE SYNTHESIZES THE REAL VECTOR B(K), WHERE 
C K = 1,2,...N. THE INITIAL FOURIER COEFFICIENTS ARE PLACED IN
C THE B ARRAY WITH THE DC AND HIGHEST HARMONIC COEFFICIENTS 
C STORED IN B(1) AND B(2) RESPECTIVELY AND ALL OTHERS LOCATED 
C SUCH THAT THE JTH HARMONIC IS STORED AS B(2*J+1) + I*B(2*J+2).
C B IS THE N TERM REAL ARRAY DISCUSSED ABOVE. 
C------------------------------------------------------------------- 
      IMPLICIT  NONE
      INTEGER   M
      REAL      B(1)
C
      INTEGER   N, NN
      INTEGER   N8POW
      INTEGER   INT, IT
C
      N = 2**M
      N8POW = M/3 
      IF (N8POW) 15,15,5 
C 
C REORDER THE INPUT FOURIER COEFFICIENTS
C 
    5 CALL ORD2(M,B)
      CALL ORD1(M,B)
C 
C PERFORM THE RADIX 8 ITERATIONS
C 
      NN = 8*N
      DO 10 IT=1,N8POW
      NN = NN/8 
      INT = N/NN
      CALL R8SYN(INT,NN,B(1),B(INT+1),B(2*INT+1),B(3*INT+1),
     1 B(4*INT+1),B(5*INT+1),B(6*INT+1),B(7*INT+1),B(1),
     2 B(INT+1),B(2*INT+1),B(3*INT+1),B(4*INT+1),B(5*INT+1),
     3 B(6*INT+1),B(7*INT+1)) 
   10 CONTINUE
C 
C DO A RADIX 2 OR RADIX 4 ITERATION IF ONE IS REQUIRED
C 
   15 IF (M-N8POW*3-1) 40,30,20
   20 INT = N/4 
      CALL R4SYN(INT,B(1),B(INT+1),B(2*INT+1),B(INT*3+1)) 
      GO TO 40
   30 INT = N/2 
      CALL R2TR(INT,B(1),B(INT+1))
   40 RETURN
      END 
C---------------------------------------------------------------------
      SUBROUTINE R2TR(INT,B0,B1)
C 
C RADIX 2 ITERATION SUBROUTINE
C 
      IMPLICIT   NONE	
      INTEGER   INT
      REAL      B0(1),B1(1) 
C
      INTEGER   K
      REAL      T
C
      DO 100 K=1,INT
      T = B0(K)+B1(K) 
      B1(K) = B0(K)-B1(K) 
      B0(K) = T 
  100 CONTINUE
      RETURN
      END 
C---------------------------------------------------------------------
      SUBROUTINE R4TR(INT,B0,B1,B2,B3)
C 
C RADIX 4 ITERATION SUBROUTINE
C 
      IMPLICIT  NONE
      INTEGER   INT
      REAL      B0(1),B1(1),B2(1),B3(1) 
C
      INTEGER   K
      REAL      R0, R1
C
      DO 200 K=1,INT
      R0 = B0(K)+B2(K)
      R1 = B1(K)+B3(K)
      B2(K) = B0(K)-B2(K) 
      B3(K) = B1(K)-B3(K) 
      B0(K) = R0+R1 
      B1(K) = R0-R1 
  200 CONTINUE
      RETURN
      END 
C---------------------------------------------------------------------
      SUBROUTINE R4SYN(INT,B0,B1,B2,B3) 
C 
C RADIX 4 SYNTHESIS SUBROUTINE
C 
      IMPLICIT  NONE
      INTEGER   INT
      REAL      B0(1),B1(1),B2(1),B3(1) 
C
      INTEGER   K
      REAL      T0, T1, T2, T3
C
      DO 200 K=1,INT
      T0 = B0(K)+B1(K)
      T1 = B0(K)-B1(K)
      T2 = B2(K)+B2(K)
      T3 = B3(K)+B3(K)
      B0(K) = T0+T2 
      B2(K) = T0-T2 
      B1(K) = T1+T3 
      B3(K) = T1-T3 
  200 CONTINUE
      RETURN
      END 
C-------------------------------------------------------------------
      SUBROUTINE R8TR(INT,NN,BR0,BR1,BR2,BR3,BR4,BR5,BR6,BR7
     1 ,BI0,BI1,BI2,BI3,BI4,BI5,BI6,BI7)
C 
C RADIX 8 ITERATION SUBROUTINE
C 
      IMPLICIT  NONE
      INTEGER   INT
      INTEGER   NN
      REAL      BR0(1),BR1(1),BR2(1),BR3(1),BR4(1), 
     1          BR5(1),BR6(1),BR7(1),BI0(1),BI1(1),BI2(1),BI3(1),
     2          BI4(1),BI5(1),BI6(1),BI7(1)
      INTEGER   L(15)
C
      INTEGER   INT8
      INTEGER   J, J0, JLAST
      INTEGER   JI, JL, JR
      INTEGER   J1, J2, J3, J4, J5, J6, J7, J8, J9, J10
      INTEGER   J11, J12, J13, J14
      INTEGER   JTHET 
      INTEGER   K0, KL
      INTEGER   K, KS
      INTEGER   L1, L2, L3, L4, L5, L6, L7, L8, L9, L10
      INTEGER   L11, L12, L13, L14, L15
      REAL      ARG
      REAL      C1, C2, C3, C4, C5, C6, C7
      REAL      C22
      REAL      PR, PI
      REAL      PIOVN, P7
      REAL      S1, S2, S3, S4, S5, S6, S7
      REAL      S22
      REAL      T0, T1, T2, T3, T4, T5, T6, T7
      REAL      TH2
      REAL      TR0, TR1, TR2, TR3, TR4, TR5, TR6, TR7
      REAL      TI0, TI1, TI2, TI3, TI4, TI5, TI6, TI7
C
      EQUIVALENCE (L15,L(1)),(L14,L(2)),(L13,L(3)),(L12,L(4)),
     1 (L11,L(5)),(L10,L(6)),(L9,L(7)),(L8,L(8)),(L7,L(9)), 
     2 (L6,L(10)),(L5,L(11)),(L4,L(12)),(L3,L(13)),(L2,L(14)),
     3 (L1,L(15)) 
C
      L(1) = NN/8 
      DO 10 K=2,15
      IF(L(K-1)-2) 11,12,13 
   11 L(K-1) = 2
   12 L(K) = 2
      GO TO 10
   13 L(K) = L(K-1)/2 
   10 CONTINUE
      PIOVN = 3.14159265358979D0/DBLE(NN) 
      P7 = 0.707106781186548D0
      C22 = 0.923879532511287D0
      S22 = 0.382683432365090D0
      JI = 3
      JL = 2
      JR = 2
      DO 70 J1=2,L1,2 
      DO 70 J2=J1,L2,L1 
      DO 70 J3=J2,L3,L2 
      DO 70 J4=J3,L4,L3 
      DO 70 J5=J4,L5,L4 
      DO 70 J6=J5,L6,L5 
      DO 70 J7=J6,L7,L6 
      DO 70 J8=J7,L8,L7 
      DO 70 J9=J8,L9,L8 
      DO 70 J10=J9,L10,L9 
      DO 70 J11=J10,L11,L10 
      DO 70 J12=J11,L12,L11 
      DO 70 J13=J12,L13,L12 
      DO 70 J14=J13,L14,L13 
      DO 70 JTHET=J14,L15,L14 
      TH2 = JTHET-2 
      IF(TH2) 71,71,76
   71 DO 72 K=1,INT 
      T0 = BR0(K)+BR4(K)
      T1 = BR1(K)+BR5(K)
      T2 = BR2(K)+BR6(K)
      T3 = BR3(K)+BR7(K)
      T4 = BR0(K)-BR4(K)
      T5 = BR1(K)-BR5(K)
      T6 = BR2(K)-BR6(K)
      T7 = BR3(K)-BR7(K)
      BR2(K) = T0-T2
      BR3(K) = T1-T3
      T0 = T0+T2
      T1 = T1+T3
      BR0(K) = T0+T1
      BR1(K) = T0-T1
      PR = P7*(T5-T7) 
      PI = P7*(T5+T7) 
      BR4(K) = T4+PR
      BR7(K) = T6+PI
      BR6(K) = T4-PR
      BR5(K) = PI-T6
   72 CONTINUE
      IF(NN-8) 70,70,73 
   73 K0 = INT*8+1
      KL = K0+INT-1 
      DO 75 K=K0,KL 
      PR = P7*(BI2(K)-BI6(K)) 
      PI = P7*(BI2(K)+BI6(K)) 
      TR0 = BI0(K)+PR 
      TI0 = BI4(K)+PI 
      TR2 = BI0(K)-PR 
      TI2 = BI4(K)-PI 
      PR = P7*(BI3(K)-BI7(K)) 
      PI = P7*(BI3(K)+BI7(K)) 
      TR1 = BI1(K)+PR 
      TI1 = BI5(K)+PI 
      TR3 = BI1(K)-PR 
      TI3 = BI5(K)-PI 
      PR = TR1*C22-TI1*S22
      PI = TI1*C22+TR1*S22
      BI0(K) = TR0+PR 
      BI6(K) = TR0-PR 
      BI7(K) = TI0+PI 
      BI1(K) = PI-TI0 
      PR = -TR3*S22-TI3*C22 
      PI =  TR3*C22-TI3*S22 
      BI2(K) = TR2+PR 
      BI4(K) = TR2-PR 
      BI5(K) = TI2+PI 
      BI3(K) = PI-TI2 
   75 CONTINUE
      GO TO 70
   76 ARG = TH2*PIOVN 
      C1 = COS(ARG) 
      S1 = SIN(ARG) 
      C2 = C1*C1-S1*S1
      S2 = C1*S1+C1*S1
      C3 = C1*C2-S1*S2
      S3 = C2*S1+S2*C1
      C4 = C2*C2-S2*S2
      S4 = C2*S2+C2*S2
      C5 = C2*C3-S2*S3
      S5 = C3*S2+S3*C2
      C6 = C3*C3-S3*S3
      S6 = C3*S3+C3*S3
      C7 = C3*C4-S3*S4
      S7 = C4*S3+S4*C3
      INT8 = INT*8
      J0 = JR*INT8+1
      K0 = JI*INT8+1
      JLAST = J0+INT-1
      DO 77 J=J0,JLAST
      KS = K0+J-J0
      DO 77 K=KS,KS 
      TR1 = BR1(J)*C1-BI1(K)*S1 
      TI1 = BR1(J)*S1+BI1(K)*C1 
      TR2 = BR2(J)*C2-BI2(K)*S2 
      TI2 = BR2(J)*S2+BI2(K)*C2 
      TR3 = BR3(J)*C3-BI3(K)*S3 
      TI3 = BR3(J)*S3+BI3(K)*C3 
      TR4 = BR4(J)*C4-BI4(K)*S4 
      TI4 = BR4(J)*S4+BI4(K)*C4 
      TR5 = BR5(J)*C5-BI5(K)*S5 
      TI5 = BR5(J)*S5+BI5(K)*C5 
      TR6 = BR6(J)*C6-BI6(K)*S6 
      TI6 = BR6(J)*S6+BI6(K)*C6 
      TR7 = BR7(J)*C7-BI7(K)*S7 
      TI7 = BR7(J)*S7+BI7(K)*C7 
      T0 = BR0(J)+TR4 
      T1 = BI0(K)+TI4 
      TR4 = BR0(J)-TR4
      TI4 = BI0(K)-TI4
      T2 = TR1+TR5
      T3 = TI1+TI5
      TR5 = TR1-TR5 
      TI5 = TI1-TI5 
      T4 = TR2+TR6
      T5 = TI2+TI6
      TR6 = TR2-TR6 
      TI6 = TI2-TI6 
      T6 = TR3+TR7
      T7 = TI3+TI7
      TR7 = TR3-TR7 
      TI7 = TI3-TI7 
      TR0 = T0+T4 
      TI0 = T1+T5 
      TR2 = T0-T4 
      TI2 = T1-T5 
      TR1 = T2+T6 
      TI1 = T3+T7 
      TR3 = T2-T6 
      TI3 = T3-T7 
      T0 = TR4-TI6
      T1 = TI4+TR6
      T4 = TR4+TI6
      T5 = TI4-TR6
      T2 = TR5-TI7
      T3 = TI5+TR7
      T6 = TR5+TI7
      T7 = TI5-TR7
      BR0(J) = TR0+TR1
      BI7(K) = TI0+TI1
      BI6(K) = TR0-TR1
      BR1(J) = TI1-TI0
      BR2(J) = TR2-TI3
      BI5(K) = TI2+TR3
      BI4(K) = TR2+TI3
      BR3(J) = TR3-TI2
      PR = P7*(T2-T3) 
      PI = P7*(T2+T3) 
      BR4(J) = T0+PR
      BI3(K) = T1+PI
      BI2(K) = T0-PR
      BR5(J) = PI-T1
      PR = -P7*(T6+T7)
      PI = P7*(T6-T7) 
      BR6(J) = T4+PR
      BI1(K) = T5+PI
      BI0(K) = T4-PR
      BR7(J) = PI-T5
   77 CONTINUE
      JR = JR+2 
      JI = JI-2 
      IF (JI-JL) 78,78,70
   78 JI = 2*JR-1 
      JL = JR 
   70 CONTINUE
      RETURN
      END 
C-----------------------------------------------------------------
      SUBROUTINE R8SYN(INT,NN,BR0,BR1,BR2,BR3,BR4,BR5,BR6,BR7 
     1 ,BI0,BI1,BI2,BI3,BI4,BI5,BI6,BI7)
C 
C RADIX 8 SYNTHESIS SUBROUTINE
C

      IMPLICIT  NONE
      INTEGER   INT
      INTEGER   NN
      REAL      BR0(1),BR1(1),BR2(1),BR3(1),BR4(1),
     1          BR5(1),BR6(1),BR7(1),BI0(1),BI1(1),BI2(1),BI3(1),
     2          BI4(1),BI5(1),BI6(1),BI7(1)
      INTEGER   L(15)
C
      INTEGER   INT8
      INTEGER   J, J0, JLAST
      INTEGER   JI, JL, JR
      INTEGER   J1, J2, J3, J4, J5, J6, J7, J8, J9, J10
      INTEGER   J11, J12, J13, J14
      INTEGER   JTHET
      INTEGER   K0, KL
      INTEGER   K, KS
      INTEGER   L1, L2, L3, L4, L5, L6, L7, L8, L9, L10
      INTEGER   L11, L12, L13, L14, L15
      REAL      ARG
      REAL      C1, C2, C3, C4, C5, C6, C7
      REAL      C22
      REAL      PR, PI
      REAL      PIOVN, P7
      REAL      P7TWO
      REAL      RI, RR
      REAL      S1, S2, S3, S4, S5, S6, S7
      REAL      S22
      REAL      T0, T1, T2, T3, T4, T5, T6, T7
      REAL      TH2
      REAL      TR0, TR1, TR2, TR3, TR4, TR5, TR6, TR7
      REAL      TI0, TI1, TI2, TI3, TI4, TI5, TI6, TI7
      REAL      T8, TT0, TT1
      REAL      TTR6, TTR7
C 
      EQUIVALENCE (L15,L(1)),(L14,L(2)),(L13,L(3)),(L12,L(4)),
     1 (L11,L(5)),(L10,L(6)),(L9,L(7)),(L8,L(8)),(L7,L(9)), 
     2 (L6,L(10)),(L5,L(11)),(L4,L(12)),(L3,L(13)),(L2,L(14)),
     3 (L1,L(15)) 
C
      L(1) = NN/8 
      DO 10 K=2,15
      IF (L(K-1)-2) 11,12,13 
   11 L(K-1) = 2
   12 L(K) = 2
      GO TO 10
   13 L(K) = L(K-1)/2 
   10 CONTINUE
      PIOVN = 3.14159265358979D0/DBLE(NN) 
      P7 = 0.707106781186548D0
      P7TWO = 1.414213562373095D0
      C22 = 0.923879532511287D0
      S22 = 0.382683432365090D0
      JI = 3
      JL = 2
      JR = 2
      DO 70 J1=2,L1,2 
      DO 70 J2=J1,L2,L1 
      DO 70 J3=J2,L3,L2 
      DO 70 J4=J3,L4,L3 
      DO 70 J5=J4,L5,L4 
      DO 70 J6=J5,L6,L5 
      DO 70 J7=J6,L7,L6 
      DO 70 J8=J7,L8,L7 
      DO 70 J9=J8,L9,L8 
      DO 70 J10=J9,L10,L9 
      DO 70 J11=J10,L11,L10 
      DO 70 J12=J11,L12,L11 
      DO 70 J13=J12,L13,L12 
      DO 70 J14=J13,L14,L13 
      DO 70 JTHET=J14,L15,L14 
      TH2 = JTHET-2 
      IF (TH2) 71,71,76
   71 DO 72 K=1,INT 
      T0 = BR0(K)+BR1(K)
      T1 = BR0(K)-BR1(K)
      T2 = BR2(K)+BR2(K)
      T3 = BR3(K)+BR3(K)
      T4 = BR4(K)+BR6(K)
      T6 = BR7(K)-BR5(K)
      T5 = BR4(K)-BR6(K)
      T7 = BR7(K)+BR5(K)
      PR = P7*(T7+T5) 
      PI = P7*(T7-T5) 
      TT0 = T0+T2 
      TT1 = T1+T3 
      T2 = T0-T2
      T3 = T1-T3
      T4 = T4+T4
      T5 = PR+PR
      T6 = T6+T6
      T7 = PI+PI
      BR0(K) = TT0+T4 
      BR1(K) = TT1+T5 
      BR2(K) = T2+T6
      BR3(K) = T3+T7
      BR4(K) = TT0-T4 
      BR5(K) = TT1-T5 
      BR6(K) = T2-T6
      BR7(K) = T3-T7
   72 CONTINUE
      IF (NN-8) 70,70,73 
   73 K0 = INT*8+1
      KL = K0+INT-1 
      DO 75 K=K0,KL 
      T1 = BI0(K)+BI6(K)
      T2 = BI7(K)-BI1(K)
      T3 = BI0(K)-BI6(K)
      T4 = BI7(K)+BI1(K)
      PR = T3*C22+T4*S22
      PI = T4*C22-T3*S22
      T5 = BI2(K)+BI4(K)
      T6 = BI5(K)-BI3(K)
      T7 = BI2(K)-BI4(K)
      T8 = BI5(K)+BI3(K)
      RR = T8*C22-T7*S22
      RI = -T8*S22-T7*C22 
      BI0(K) = (T1+T5)+(T1+T5)
      BI4(K) = (T2+T6)+(T2+T6)
      BI1(K) = (PR+RR)+(PR+RR)
      BI5(K) = (PI+RI)+(PI+RI)
      T5 = T1-T5
      T6 = T2-T6
      BI2(K) = P7TWO*(T6+T5)
      BI6(K) = P7TWO*(T6-T5)
      RR = PR-RR
      RI = PI-RI
      BI3(K) = P7TWO*(RI+RR)
      BI7(K) = P7TWO*(RI-RR)
   75 CONTINUE
      GO TO 70
   76 ARG = TH2*PIOVN 
      C1 = COS(ARG) 
      S1 = -SIN(ARG)
      C2 = C1*C1-S1*S1
      S2 = C1*S1+C1*S1
      C3 = C1*C2-S1*S2
      S3 = C2*S1+S2*C1
      C4 = C2*C2-S2*S2
      S4 = C2*S2+C2*S2
      C5 = C2*C3-S2*S3
      S5 = C3*S2+S3*C2
      C6 = C3*C3-S3*S3
      S6 = C3*S3+C3*S3
      C7 = C3*C4-S3*S4
      S7 = C4*S3+S4*C3
      INT8 = INT*8
      J0 = JR*INT8+1
      K0 = JI*INT8+1
      JLAST = J0+INT-1
      DO 77 J=J0,JLAST
      KS = K0+J-J0
      DO 77 K=KS,KS 
      TR0 = BR0(J)+BI6(K) 
      TI0 = BI7(K)-BR1(J) 
      TR1 = BR0(J)-BI6(K) 
      TI1 = BI7(K)+BR1(J) 
      TR2 = BR2(J)+BI4(K) 
      TI2 = BI5(K)-BR3(J) 
      TR3 = BI5(K)+BR3(J) 
      TI3 = BI4(K)-BR2(J) 
      TR4 = BR4(J)+BI2(K) 
      TI4 = BI3(K)-BR5(J) 
      T0 = BR4(J)-BI2(K)
      T1 = BI3(K)+BR5(J)
      TR5 = P7*(T0+T1)
      TI5 = P7*(T1-T0)
      TR6 = BR6(J)+BI0(K) 
      TI6 = BI1(K)-BR7(J) 
      T0 = BR6(J)-BI0(K)
      T1 = BI1(K)+BR7(J)
      TR7 = -P7*(T0-T1) 
      TI7 = -P7*(T1+T0) 
      T0 = TR0+TR2
      T1 = TI0+TI2
      T2 = TR1+TR3
      T3 = TI1+TI3
      TR2 = TR0-TR2 
      TI2 = TI0-TI2 
      TR3 = TR1-TR3 
      TI3 = TI1-TI3 
      T4 = TR4+TR6 
      T5 = TI4+TI6 
      T6 = TR5+TR7 
      T7 = TI5+TI7 
      TTR6 = TI4-TI6
      TI6 = TR6-TR4 
      TTR7 = TI5-TI7
      TI7 = TR7-TR5 
      BR0(J) = T0+T4
      BI0(K) = T1+T5
      BR1(J) = C1*(T2+T6)-S1*(T3+T7)
      BI1(K) = C1*(T3+T7)+S1*(T2+T6)
      BR2(J) = C2*(TR2+TTR6)-S2*(TI2+TI6) 
      BI2(K) = C2*(TI2+TI6)+S2*(TR2+TTR6) 
      BR3(J) = C3*(TR3+TTR7)-S3*(TI3+TI7) 
      BI3(K) = C3*(TI3+TI7)+S3*(TR3+TTR7) 
      BR4(J) = C4*(T0-T4)-S4*(T1-T5)
      BI4(K) = C4*(T1-T5)+S4*(T0-T4)
      BR5(J) = C5*(T2-T6)-S5*(T3-T7)
      BI5(K) = C5*(T3-T7)+S5*(T2-T6)
      BR6(J) = C6*(TR2-TTR6)-S6*(TI2-TI6) 
      BI6(K) = C6*(TI2-TI6)+S6*(TR2-TTR6) 
      BR7(J) = C7*(TR3-TTR7)-S7*(TI3-TI7) 
      BI7(K) = C7*(TI3-TI7)+S7*(TR3-TTR7) 
   77 CONTINUE
      JR = JR+2 
      JI = JI-2 
      IF (JI-JL) 78,78,70
   78 JI = 2*JR-1 
      JL = JR 
   70 CONTINUE
      RETURN
      END 
C---------------------------------------------------------------------
      SUBROUTINE ORD1(M,B)
C 
C IN-PLACE REORDERING SUBROUTINES 
C 
      IMPLICIT  NONE
      INTEGER   M
      REAL      B(1)
C
      INTEGER   K, KL
      INTEGER   N
      INTEGER   J
      REAL      T
C
      K = 4 
      KL = 2
      N = 2**M
      DO 94 J=4,N,2 
      IF (K-J) 92,92,91 
   91 T = B(J)
      B(J) = B(K) 
      B(K) = T
   92 K = K-2 
      IF (K-KL) 93,93,94
   93 K = 2*J 
      KL = J
   94 CONTINUE
      RETURN
      END 
C---------------------------------------------------------------------
      SUBROUTINE ORD2(M,B)
C
      IMPLICIT NONE
      INTEGER  M
      REAL     B(1)
C
      INTEGER  IJ
      INTEGER  J1, J2, J3, J4, J5, J6, J7, J8, J9, J10
      INTEGER  J11, J12, J13, J14, J15, J16, J17, J18
      INTEGER  L1, L2, L3, L4, L5, L6, L7, L8, L9, L10
      INTEGER  L11, L12, L13, L14, L15, L16, L17, L18, L19
      INTEGER  JI
      INTEGER  L(20)
      INTEGER  N
      INTEGER  K
      REAL     T
C
      EQUIVALENCE (L19,L(1)),(L18,L(2)),(L17,L(3)),(L16,L(4)),
     1 (L15,L(5)),(L14,L(6)),(L13,L(7)),(L12,L(8)),(L11,L(9)),
     2 (L10,L(10)),(L9,L(11)),(L8,L(12)),(L7,L(13)),(L6,L(14)), 
     3 (L5,L(15)),(L4,L(16)),(L3,L(17)),(L2,L(18)),(L1,L(19)) 
C
      N = 2**M
      L(1) = N
      DO 101 K=2,M
  101 L(K) = L(K-1)/2 
      DO 102 K=M,19 
  102 L(K+1) = 2
      IJ = 2
      DO 103 J1=2,L1,2
      DO 103 J2=J1,L2,L1
      DO 103 J3=J2,L3,L2
      DO 103 J4=J3,L4,L3
      DO 103 J5=J4,L5,L4
      DO 103 J6=J5,L6,L5
      DO 103 J7=J6,L7,L6
      DO 103 J8=J7,L8,L7
      DO 103 J9=J8,L9,L8
      DO 103 J10=J9,L10,L9
      DO 103 J11=J10,L11,L10
      DO 103 J12=J11,L12,L11
      DO 103 J13=J12,L13,L12
      DO 103 J14=J13,L14,L13
      DO 103 J15=J14,L15,L14
      DO 103 J16=J15,L16,L15
      DO 103 J17=J16,L17,L16
      DO 103 J18=J17,L18,L17
      DO 103 JI =J18,L19,L18
      IF (IJ-JI) 108,103,103
 108  T = B(IJ-1) 
      B(IJ-1) = B(JI-1) 
      B(JI-1) = T 
      T = B(IJ) 
      B(IJ) = B(JI) 
      B(JI) = T 
  103 IJ = IJ+2 
      RETURN
      END 

C @(#)danstarx.for	19.1 (ES0-DMD) 02/25/03 13:29:07
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
         PROGRAM DANSTX
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT (c)
C.IDENT         danstarx.for
C.MODULE
C.AUTHOR        Andrew T. Young
C.KEYWORD
C.LANGUAGE      FORTRAN 77
C.PURPOSE       extract star positions from Danish photometric data files
C.COMMENTS
C.VERSION       0.0
C.RETURNS
C.ENVIRONMENT
C.
C-----------------------------------------------------------------------------
C*****************************************************************************
C
C       This program reads data recorded in intermixed formats and combines
C       them into a uniform format, in the file 'sdata.dat' that is converted
C       into a MIDAS table-format file, using the *.fmt file 'sdata.fmt'.
C
C       The version you see here is designed to convert data from the Danish
C       0.5-meter telescope.  Data codes are in col. 1.
C       These codes are read and decoded at statements 110-190 in the main
C       program.
C
C       The basic method is to load the data as they are read from different
C       types of cards into the COMMON blocks /OUTR/ and /OUTC/, which hold
C       real and character variables, respectively.  (Some compilers want you
C       to keep such blocks separate.)  When enough card images have been read
C       to make a complete observation, the contents of /OUT*/ are written to
C       the uniform-format file 'sdata.dat'; then the common blocks are cleared,
C       to the appropriate "null" values.  (Blanks are used to clear character
C       strings.)
C
C       The MIDAS command CREATE/TABLE can then be used, with the *.fmt file
C       supplied, to convert the uniform 'sdata.dat' file to MIDAS table format.
C       This is done in the command CONVERT/PHOT.
C
C       As this is based on the esodcon program, it probably contains fossils.
C
C
C*****************************************************************************
C
      IMPLICIT NONE
C
C  BEGIN Declarations:
C
      DOUBLE PRECISION DJD, DJZ
      REAL EQUINOX
C
      LOGICAL MATCH
      LOGICAL EFLAG
      INTEGER NDATA, NOUTP
C
C
      CHARACTER*80 LINE(2), DATFIL
      COMMON /LINES/LINE
C
      CHARACTER A*1, CODE*2
      CHARACTER*10 RASTR, DESTR
C
C
C
C       Declarations for the output (must be in WRITER too!):
C
      CHARACTER OBJECT*9
      COMMON /OUTC/ OBJECT,RASTR,DESTR
C
C  Set up MIDAS declarations:
C
      INTEGER MADRID(1)
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      COMMON /VMR/ MADRID
C
      INTEGER NACTEL, IUNIT, NULLS, ISTAT
C
C  END Declarations.
C
C
C  BEGIN DATA statements:
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      DATA NDATA/7/, NOUTP/8/
C
C
C  END DATA statements.
C
C
C
C  ********************  PROLOGUE  ********************
C
        CALL STSPRO ('DANSTARX')
C
C
C  Real program begins here:            (use RUN DANSTARX to test in MIDAS)
C
C
        INQUIRE(FILE='sdata.dat',EXIST=EFLAG)
        IF (EFLAG) THEN
                CALL TV('File "sdata.dat" already exists!')
    1           CALL ASK ('Do you want to write over it?? ',A)
                IF (MATCH(A,'Y')) THEN
                        CONTINUE
                ELSE IF (MATCH(A,'N')) THEN
                        CALL STETER(1,
     1                  'Please move "sdata.dat" to a new name.')
                ELSE
                        CALL TV('Please reply "yes" or "no".')
                        GO TO 1
                END IF
         END IF
C               Open the uniform-format ascii file:
        OPEN(NOUTP,FILE='sdata.dat',STATUS='UNKNOWN')
        REWIND NOUTP
C
C
C       clear data storage:
C
        OBJECT=' '
        RASTR=' '
        DESTR=' '
        DJZ=0.D0
C
C       *** Prepare input buffer ***
C
        CALL TV(' ')
C       Get file name:
    7   Call STKRDC ('RAWDAT',1,1,80,  NACTEL,DATFIL,IUNIT,NULLS,ISTAT)
C   7   CALL ASKFIL('What is the name of the file of observed data?',
C    1                  DATFIL)
        INQUIRE(FILE=DATFIL,EXIST=EFLAG)
        IF (.NOT.EFLAG) THEN
                CALL TV('No such file exists!')
                CALL TVN('Please try again:')
                GO TO 7
        END IF
        OPEN(NDATA,FILE=DATFIL,STATUS='UNKNOWN')
        REWIND NDATA
        CALL TV('Extracting star positions...')
C
C
C       Read data.
C
  110   READ (7,'(A80)',END=200) LINE(1),LINE(2)
C
C
C           Skip comment cards:
            IF (LINE(1)(:1).EQ.'c') GO TO 110
C
C           Read first card:
            READ (LINE(1),111,ERR=199) A,DJD,OBJECT,CODE,RASTR,DESTR
  111       FORMAT(A1,4X,F12.5,27X,A9,A2,2X,2A8)
C
C           Skip background data.
            IF (CODE.NE.' *') GO TO 110
C
C           Convert Danish MJD to real JD.
            DJD=DJD+2440000.D0
C           Convert real JD to MJD.
            IF (DJZ.EQ.0.D0) THEN
               DJZ=INT(DJD)+0.5
               EQUINOX=REAL(DJZ-2451545.D0)/365.25 + 2000.
            END IF
C
C
            IF (A.EQ.'s') THEN
C
C                       s: measurement
C
C               reject sky positions:
                IF (LINE(1)(55:55).EQ.'B') GO TO 110
C
                CALL WRITER(EQUINOX)
C
C               clear data arrays:
C
  160           OBJECT=' '
                RASTR=' '
                DESTR=' '
C
                GO TO 110
C
C
C
C           ELSE IF (A.EQ.'c')THEN
C
C                       c: comment
C
C               GO TO 110
C
C
            ELSE IF (A.EQ.'f') THEN
C
C                       f: error
C
                GO TO 110
C
C
            ELSE
C
C                       other: Illegal card.
C
                GO TO 199
C
            END IF
C
  199           CONTINUE
                CALL TV('These cards are not in standard format:')
                CALL TV(LINE(1))
                CALL TVN(LINE(2))
                CALL SPACE
                CALL TV('Please fix data and try again.')
                CALL STETER(199,'Data not in std. format')
C
C
  200   CLOSE(NOUTP)
C
C       Now make format file:
C
        OPEN (NOUTP,FILE='sdata.fmt',STATUS='UNKNOWN')
        WRITE(NOUTP,'(A46)')'! Format file for Danish Star Positions'
  300   FORMAT(A39)
C       Caution -- columns here MUST match FORMAT 5 in WRITER !!
        WRITE(NOUTP,300)'DEFINE/FIELD   1  32 C  A9    :OBJECT  '
        WRITE(NOUTP,300)'DEFINE/FIELD  33  48 R  R11.6 :RA      '
        WRITE(NOUTP,300)'DEFINE/FIELD  49  64 R  s11.5 :DEC     '
        WRITE(NOUTP,300)'DEFINE/FIELD  65  74 R  F8.3  :EQUINOX '
        WRITE(NOUTP,'(A3)')'END'
        CLOSE(NOUTP)
C
        CALL TV('DANSTARX is finished')
C
C
C       End MIDAS:
C
        CALL STSEPI
        END
      SUBROUTINE WRITER(EQUINOX)
C
C     writes output to uniform ascii file 'sdata.dat'
C
C
      REAL EQUINOX
C
      CHARACTER OBJECT*9
      CHARACTER*10 RASTR, DESTR
      COMMON /OUTC/ OBJECT,RASTR,DESTR
C
      CHARACTER C*74
C
C
      WRITE(C,5)OBJECT,RASTR(:2),RASTR(3:4),RASTR(5:6),RASTR(7:8),
     1                 DESTR(:3),DESTR(4:5),DESTR(6:7),DESTR(8:),EQUINOX
    5 FORMAT (A9,23X,5X,A2,':',A2,':',A2,'.',A2,5X,A3,':',A2,':',A2,'.',
     1A1,F10.3)
C
      WRITE(8,'(A74)') C
C
      RETURN
      END

C @(#)fsinh.for	19.1 (ES0-DMD) 02/25/03 13:17:32
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FSINH(X,NP,PARAM,Y1,DERIV)                                     
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                  
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  18:01 - 21 DEC 1987                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C--------------------------------------------------------------                 
C                                                                               
C HYPERBOLIC SINUS                                                              
C      IMPLICIT NONE                                                            
C Y = A1*SINH(A2+A3*X)                                                          
C                                                                               
      INTEGER NP
      REAL X
      DOUBLE PRECISION Y1,PARAM(NP),DERIV(NP),W                                 
C                                                                               
      W      = PARAM(3)*X + PARAM(2)                                            
      DERIV(1) = DSINH(W)                                                       
      Y1     = PARAM(1)*DERIV(1)                                                
      DERIV(2) = PARAM(1)*DCOSH(W)                                              
      DERIV(3) = DERIV(2)*X                                                     
      RETURN                                                                    
                                                                                
      END                                                                       

C===========================================================================
C Copyright (C) 1995-2010 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine SKYMOD         version 1.0         880510
C  A. Kruszewski             Warsaw U. Obs.
C.PURPOSE
C  Calculates sky background level by means of subroutine MODE.
C  Do not use central region of subarray.
C.INPUT/OUTPUT
C  input arguments
C  A           real*4 array        image buffer
C  JAPY        integer*4 array     pointers to image lines
C  JBS         integer*4           first line in buffer
C  IXYU        integer*4           limits of used area
C  I           integer*4           x-coordinate of an object
C  J           integer*4           y-coordinate of an object
C  CRMD        integer*4 array     control parameters used by MODE
C  IHED        integer*4           half edge size of used subarray
C  IFULL       integer*4           all pixels used when IFULL=1
C  output arguments
C  BGRD        real*4              sky background
C-----------------------------------------------------------------------
      SUBROUTINE SKYMOD(A, JAPY, IBUF, I, J, CRMD,
     &                                    IHED, IFULL, BGRD)
C
      IMPLICIT NONE
      INCLUDE  'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER   I , IBUF(4) , IFULL , IHED , IOFF , IRED
      INTEGER   J , JAPY(1) , JOF , JOFF
      INTEGER   K , K1 , K2 , K3 , K4 , K5 , K6
      INTEGER   L , L1 , L2 , L3 , L4 , L5 , L6 , LM
      INTEGER   N , NPIX
C
      REAL      A(1)
      REAL      B(4*MAXSUB**2) , BGRD
      REAL      CRMD(3)
      REAL      SIGMA
C
C ******      Find offsets.
C
      SIGMA = 0.0
      BGRD = 0.0
      K2 = 0
      K5 = 0
      L2 = 0
      L3 = 0
      L4 = 0
      L5 = 0
      JOFF = IBUF(2) - 1
      IOFF = IBUF(1) - 1
C
C
C ******      Set limits of used subarray.
C
      K1 = MAX( IBUF(1) , I-IHED )
      K6 = MIN( IBUF(3) , I+IHED )
      L1 = MAX( IBUF(2) , J-IHED )
      L6 = MIN( IBUF(4) , J+IHED )
C 
      IF ( IFULL .EQ. 0 ) THEN
         LM = IHED/2 + 1     ! Calculate size LM of not used central region.
          K2 = MAX( IBUF(1)-1 , I-LM-1 )
          K3 = MAX( IBUF(1) , I-LM )
          K4 = MIN( IBUF(3) , I+LM )
          K5 = MIN( IBUF(3)+1 , I+LM+1 )
          L2 = MAX( IBUF(2)-1 , J-LM-1 )
          L3 = MAX( IBUF(2) , J-LM )
          L4 = MIN( IBUF(4) , J+LM )
          L5 = MIN( IBUF(4)+1 , J+LM+1 )
          NPIX = (K6-K1+1)*(L6-L1+1) - (K4-K3+1)*(L4-L3+1)
      ELSE
          NPIX = (K6-K1+1) * (L6-L1+1)
      ENDIF
      IRED = ( (NPIX-1) / (4*MAXSUB*MAXSUB) ) + 1
C
C ******      Pick out usable pixels.
C
      N = 0
      IF ( IFULL .EQ. 1 ) THEN
          DO 20 L = L1 , L6
            JOF = JAPY(L-JOFF)
            DO 21 K = K1 , K6
                IF ( IRED .EQ. 1 .OR. MOD(L+K,IRED) .EQ. 0 ) THEN
                  N = N + 1
                  B(N) = A(JOF+K)
                ENDIF
   21            CONTINUE 
   20          CONTINUE
      ELSE
          DO 10 L = L1 , L2
            JOF = JAPY(L-JOFF)
            DO 11 K = K1 , K6
                IF ( IRED .EQ. 1 .OR. MOD(L+K,IRED) .EQ. 0 ) THEN
                  N = N + 1
                  B(N) = A(JOF+K)
                ENDIF
   11            CONTINUE 
   10          CONTINUE
            DO 12 L = L3 , L4
            JOF = JAPY(L-JOFF)
            DO 13 K = K1 , K2
                IF ( IRED .EQ. 1 .OR. MOD(L+K,IRED) .EQ. 0 ) THEN
                  N = N + 1
                  B(N) = A(JOF+K)
                ENDIF
   13            CONTINUE 
              DO 14 K = K5 , K6
                IF ( IRED .EQ. 1 .OR. MOD(L+K,IRED) .EQ. 0 ) THEN
                  N = N + 1
                  B(N) = A(JOF+K)
                ENDIF
   14            CONTINUE 
   12          CONTINUE
            DO 15 L = L5 , L6
            JOF = JAPY(L-JOFF)
            DO 16 K = K1 , K6
                IF ( IRED .EQ. 1 .OR. MOD(L+K,IRED) .EQ. 0 ) THEN
                  N = N + 1
                  B(N) = A(JOF+K)
                ENDIF
   16            CONTINUE 
   15          CONTINUE
        ENDIF
C
C ******      Calculate mode BGRD.
C
      CALL MODE( B , N , CRMD , BGRD , SIGMA )
C
      RETURN
C
      END

C @(#)prfcnv.for	19.1 (ES0-DMD) 02/25/03 13:25:37
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine PRFCNV         version 1         820719
C  A. Kruszewski             ESO Garching
C.KEYWORDS
C  magnitude profile
C.PURPOSE
C  calculates stellar magnitudes "AMAG" by convolving observed
C  profiles "PRCT" with one dimensional standard point spread
C  function "SPRF"
C.INPUT/OUTPUT
C  input arguments
C  PRCT        real*4 array      catalog of observed profiles
C  SPRF        real*4 array      one-dimensional standard point
C                                spread function
C  M           integer*4         number of catalogued objects
C  HHCUT       real*4            higher limit for usable profiles
C  output parameters
C  AMAG        real*4 array      calculated stellar magnitudes
C-----------------------------------------------------------------------
      SUBROUTINE PRFCNV(L0, L1, LW, NREG, LSTP,
     &                  NCAT, PMTR, PRCT, IARR, RARR,
     &                  ICT, ABGRD)
C
      IMPLICIT  NONE
      INCLUDE  'MID_REL_INCL:INVENT.INC/NOLIST'
C
      INTEGER   L0
      INTEGER   L1
      INTEGER   LW
      INTEGER   NREG
      INTEGER   LSTP(0:4,0:NREG)
      INTEGER   NCAT(NIPAR,MAXCNT)
      REAL      PMTR(NRPAR,MAXCNT)
      REAL      PRCT(0:MAXSUB,MAXCNT)
      INTEGER   IARR(32)
      REAL      RARR(64)
      INTEGER   ICT
      REAL      ABGRD
C
      INTEGER   NB, NP
      INTEGER   I, I1, IUNT, ICNT
      INTEGER   K, K2
      INTEGER   M, MARK
      INTEGER   L, LZ, LIM
C
      REAL      AAMG
      REAL      SAMG
      REAL      BCOR
      REAL      TRSH
      REAL      ZRMG
      REAL      TINT
      REAL      PRIN
      REAL      PINL
C     
      REAL      APSF(0:MAXSUB) , HHCUT
      REAL      NPXL(0:MAXSUB)
C     REAL      SPRF(0:MAXSUB)
C
C *** Define array NPXL holding numbers
C *** of pixels in each of annular rings.
C
      DATA NPXL/1,8,12,16,32,28,40,40,48,68,56,72,68,88,88,84,112,
     +  112,112,116,112,144,140,144,144,168,164,160,184,172,200,192,
     +  188,208,224,224,228,224,248,236,264,248,264,276,264,288,276,
     +  304,304,312,316/
C
      NP = MAXCNT
      TRSH = RARR(3)
      ZRMG = RARR(11)
      TINT = RARR(10)
      IUNT = IARR(10)
      MARK = 1
C
C *** Transform logarithmic profile into one dimensional psf
C *** APRF, which is normalized to 1.0 at the central pixel.
C
      APSF(0) = 1.0
      I1 = MIN( MAXSUB , 25 ) 
      DO 10 I = 1 , I1
          APSF(I) = APSF(I-1) * 10.0**(-RARR(I+13))
   10 CONTINUE
      DO 20 I = 26 , MAXSUB
          APSF(I) = APSF(I-1) * 10.0**(-RARR(I1+13))
   20 CONTINUE
      HHCUT = 0.7 * ( RARR(2) - ABGRD )
C
C *** Calculate normalizing integral over the profile
C *** PRIN and its value expressed in magnitudes PINL.
C
      PRIN = 0.0
      DO 30 K = 0 , MAXSUB
          PRIN = PRIN + NPXL(K) * APSF(K)
   30 CONTINUE
      PINL = 2.5 * ALOG10( PRIN )
      IF ( IUNT .EQ. 1 ) THEN
          BCOR = -2.5 * ALOG10(TINT)
      ELSE
          BCOR = -2.5 * ALOG10(ABGRD)
      ENDIF
C
C *** Perform convolution.
C
      M = MAX( L1 , LW )
      K2 = NINT( RARR(13) ) + 1
      NB = 0
      DO 40 L = 1 , M
C          IF ( L .GT. L1 .OR. L .LE. L0 ) THEN
C              IOCOD = 0
C              CALL PARFIL( ISF , L , L0 , L1 , LW ,
C     &                     IOCOD , MARK , NCAT , PMTR , PRCT )
C              IF ( NB .EQ. 0 ) THEN
C                  ABGRD = 0.0
C              ENDIF
C              CALL AVBGRD( L0 , L1 , PMTR , RARR(39) , BGRD )
C              NC = L1 - L0
C              ABGRD = ( NB * ABGRD + NC * BGRD ) / ( NB + NC )
C              NB = NB + NC
C          ENDIF
          LZ = L - L0
          IF ( NCAT(9,LZ) .GT. 0 ) GOTO 60
          LIM = NCAT(5,LZ)
          ICNT = 0
          K = 0
          AAMG = 0.0
          SAMG = 0.0
   50     CONTINUE
              IF ( ICNT .GT. K2 .OR. K .GT. LIM ) GOTO 51
              IF ( PRCT(K,LZ) .LT. HHCUT ) THEN
                  AAMG = AAMG + APSF(K)*PRCT(K,LZ)*NPXL(K)
                  SAMG = SAMG + APSF(K)*APSF(K)*NPXL(K)
                  ICNT = ICNT + 1
              ENDIF
              K = K + 1
              GOTO 50
   51     CONTINUE
C
C ***     Calculate magnitude.
C
          IF ( MIN( AAMG , SAMG ) .GT. 0.0 ) THEN
              PMTR(12,LZ) = AAMG / SAMG
          ELSE
              PMTR(12,LZ) = 1.0E-20 * TRSH
          ENDIF
   60     CONTINUE
          IF ( ICT .EQ. 1 ) THEN
C
C ***         Magnitudes are transformed  before being output.
C
              IF ( PMTR(12,LZ) .GT. 0.0 ) THEN
                  PMTR(12,LZ) = -2.5 * ALOG10( PMTR(12,LZ) )
     &                          - PINL + ZRMG - BCOR
              ELSE
                  PMTR(12,LZ) = 80.0
              ENDIF
              PMTR(5,LZ) = PMTR(5,LZ) - BCOR
              PMTR(13,LZ) = PMTR(13,LZ) - BCOR
              PMTR(16,LZ) = PMTR(16,LZ) - BCOR
              PMTR(20,LZ) = PMTR(20,LZ) - BCOR
          ENDIF
   40 CONTINUE
C
      RETURN
C
      END

C===========================================================================
C Copyright (C) 1995-2005 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C
C  subroutine CALCUL         version 2.4       831007
C  A. Kruszewski             ESO Garching
C
C  modified by
C  Ch. Ounnas                ESO - GARCHING    831013
C                                              840523
C                                              840628
C
C  modified for FX           version 2.5       870303
C  A. Kruszewski             Obs. de Geneva
C
C  modified for huge images  version 4.0       880915
C  A. Kruszewski             Warsaw U. Obs.
C
C.KEYWORDS
C
C  classifying parameters, magnitudes, positions, profiles
C
C.PURPOSE
C
C  for an input list of objects it calculates classifying parameters,
C  magnitudes, positions, gradients, sizes
C
C.INPUT/OUTPUT
C
C  input arguments
C
C  IMF         integer*4         image file
C  A           real*4 array      image frame
C  JAPY        integer*4 array   pointers to image lines
C  NX          integer*4         x-dimension of an array A
C  NY          integer*4         y-dimension of an array A
C  ITOB        integer*4 array   limits of objects area
C  IXYU        integer*4 array   limits of used area
C  IARR        integer*4 array   values of integer keywords
C  RARR        real*4 array      values of real keywords
C  ICOL        integer*4 array   positions of special table columns
C  M0          integer           number of objects
C  NCAT        integer*4 array   integer parameters of objects
C  PMTR        real*4 array      real parameters of objects
C  PRCT        real*4 array      catalog of objects profiles
C  FPSF        real*4 array      two-dimensional p.s.f.
C  IPSF        integer*4 array   pointers to FPSF
C 
C.VERSIONS
C 051026	last modif
C 
C-----------------------------------------------------------------------
C 
        SUBROUTINE CALCUL(IMF, A, JAPY, NX, NY, ITOB, IXYU,
     &                    IARR, RARR, ICOL, M0, NCAT, PMTR, PRCT,
     &                    FPSF, IPSF, OUTPSF)
C
        IMPLICIT  NONE
        INCLUDE  'MID_REL_INCL:INVENT.INC/NOLIST'
C
        INTEGER   I, IACT, IADR, IARR(32), IAVDIS
        INTEGER   IBUF(4), ICOL(6), ICT, IDLM, IHED, IMF, IOF
        INTEGER   IPF, IPSF(1), ISTAT, ITOB(4)
        INTEGER   IUSD(4), IVRF, IXYU(4)
        INTEGER   J, JAPY(1)
        INTEGER   K, KNUL, KUN
        INTEGER   L, L0, L1, LACT, LDBG
        INTEGER   LI, LL, LL2, LLZ, LM, LPXL
        INTEGER   LSBP, LSTP(LPBUF), LW, LZ
        INTEGER   M, M0, MAXS, MCM(21), MM
        INTEGER   MADRID(1)
        INTEGER   NACT, NAXISP, NBYTE, NCAT(NIPAR,MAXCNT)
        INTEGER   NCOL, NCNT, NCT(NIPAR), NEL, NROW
        INTEGER   NLPB, NP, NPIXP(2), NPRF
        INTEGER   NREG, NTMP, NVAL, NX, NY
        INTEGER*8  NPNTRP
C
        REAL      ADLM
        REAL      A(1), ABGRD, APSF(0:MAXSUB)
        REAL      DIST
        REAL      FPSF(1), FTMP(2)
        REAL      PMT(NRPAR), PMTR(NRPAR,MAXCNT)
        REAL      PRCT(0:MAXSUB,MAXCNT)
        REAL      RARR(64)
        REAL      STPR(MAXSUB)
        REAL      TRSH
        REAL      XCMP, YCMP
        REAL      XOBJ, YOBJ
        REAL      PRC
C       REAL      DUMP(40000)
C       REAL      TEMP
C
        DOUBLE PRECISION   START(2), STARTP(2), STEP(2), STEPP(2)
C
        CHARACTER*1    TYPE
        CHARACTER*48   CUNIT
        CHARACTER*60   OUTPSF
        CHARACTER*72   IDENT
        CHARACTER*80   OUTPUT
        CHARACTER*60   OUTABL
C
        LOGICAL   DONE, TWOD
C
        INCLUDE   'MID_INCLUDE:ST_DEF.INC/NOLIST'
        COMMON   /VMR/MADRID
        INCLUDE   'MID_INCLUDE:ST_DAT.INC/NOLIST'
C
C *** Recall often used quantities.
C
      NP   = MAXCNT
      LDBG = IARR(1)
      IVRF = IARR(4)
      IHED = IARR(8)
      LPXL = IARR(20)
      LSBP = IARR(21)
      TRSH = RARR(3)
      ADLM = RARR(42)
      IDLM = NINT(RARR(42)) + 1
      IF (LPXL .GT. 0 .OR. LSBP .GT. 0) THEN
         TWOD = .TRUE.
      ELSE
         TWOD = .FALSE.
      ENDIF
      ABGRD = 0.0
      NROW = 100                              !initially allocate 100 rows
C
C ******      Initialize point spread function.
C
      CALL INAPSF(RARR, MAXSUB, APSF)
C
C *** Find number of lines per buffer NLPB.
C
      NLPB = NY
C     NLPB = NIBUF /(IXYU(3) - IXYU(1) + 1)
C
C *** Catalog data is accesible for objects starting
C *** with L0+1 and ending with L1. Last object written
C *** into scratch file is LW.
C
      L0 = 0
      L1 = M0
      LW = 0
C
C *** ICOL(3) .GT. 0  when background column is present.
C *** ICOL(4) .GT. 0  when central intensities are present.
C *** ICOL(5) .GT. 0  when isophotal radii are present.
C *** Abort when there is no coordinate data.
C
      IF (ICOL(1) .EQ. 0 .OR. ICOL(2) .EQ. 0) THEN
          WRITE(OUTPUT,'(A)') 'No coordinate data present'
          CALL STTPUT(OUTPUT, ISTAT)
      ENDIF
C
C *** M0 is an original number of objects. M is number of
C *** objects at loop start. MM is an actual number of
C *** objects, it is updated inside the internal DO WHILE loop.
C *** IBUF define limits of image buffer.
C
      IBUF(1) = 1
      IBUF(2) = 1
      IBUF(3) = NX
      IBUF(4) = NY
C     IBUF(1) = 0
C     IBUF(2) = 0
C     IBUF(3) = 0
C     IBUF(4) = 0
C
C *** Divide analysed area into regions.
C
      CALL DEFLST(LSTP, ITOB, M0, NREG)
C
C *** Initialize linked lists of objects in regions.
C
      CALL INILST(LSTP, ITOB, NREG, NCAT, PMTR, PRCT, M0)
      M       = M0
      MM      = M0
      IF (LDBG .GE. 1) THEN
          WRITE(OUTPUT,'(A,I7,A,I3)')
     &                   'Initial number of objects = ',
     &                   M0, ' Number of iterations = ', IARR(2)
          CALL STTPUT(OUTPUT, ISTAT)
      ENDIF
C
C *** Copy input table data into scratch file.
C
C     CALL PARCPY(ITF, ISF, START, STEP, NICOL, M0,
C    &            ITSTRT, ICOL)
C     LW = M0
C
C *** External loop is repeated IARR(2)+1 times.
C *** Number of current iteration is kept in NCNT.
C
      NCNT = 0
   10 CONTINUE
C
          WRITE (OUTPUT, '(A,I3)') 'Starts iteration', 	NCNT
          CALL STTPUT(OUTPUT, ISTAT)
          NCNT = NCNT + 1
          M = MM
          L = 0
C
C ***     Calculate average separation between objects.
C
          IAVDIS = (ITOB(3)-ITOB(1)+1) * (ITOB(4)-ITOB(2)+1)
          IAVDIS = INT(SQRT(FLOAT(IAVDIS / M)))
C
C ***     Start inner loop.
   20     CONTINUE
C
              L = L + 1
              LM = M / 5
              IF (MOD(L, LM) .EQ. 0) THEN
                  WRITE (OUTPUT,'(I5,A)') L,' objects processed'
                  CALL STTPUT(OUTPUT, ISTAT)
              ENDIF
C
C ***         Check if object is in catalog buffer,
C ***         and swap buffer if necessary.
C
C             IF (L .GT. L1 .OR. L .LE. L0) THEN
C                 CALL PARFIL(ISF, L0, L1, LW, L,LSTP, NREG, NCAT,
C    &                        PMTR, PRCT, NP)
C             ENDIF
C
C ***         Actual pixel position is designed I,J.
C ***         Object number in buffer arrays is LZ.
C
              LZ = L - L0
              I = NCAT(1,LZ)
              J = NCAT(2,LZ)
C
C ***         Fill image buffers if necessary.
C
C              IUSD(1) = MAX(I-IHED, IXYU(1))
C              IUSD(2) = MAX(J-IHED, IXYU(2))
C              IUSD(3) = MIN(I+IHED, IXYU(3))
C              IUSD(4) = MIN(J+IHED, IXYU(4))
C              IF (IUSD(1).LT.IBUF(1) .OR. IUSD(2).LT.IBUF(2) .OR. 
C    2             IUSD(3).GT.IBUF(3) .OR. IUSD(4).GT.IBUF(4)) THEN
C
              IF (L.EQ.1) THEN
                  IUSD(1) = IBUF(1)
                  IUSD(2) = IBUF(2)
                  IUSD(3) = IBUF(3)
                  IUSD(4) = IBUF(4)
                  CALL FILBUF(IMF, A, JAPY,NX,IXYU,IUSD,IBUF)
              ENDIF
C
C ***         Check if object is in investigated area.
C
              IF (I .LT. ITOB(1) .OR. J .LT. ITOB(2) .OR. I .GT.
     &                        ITOB(3) .OR. J .GT. ITOB(4)) THEN
                  PMTR(2,L) = 0.0
                  GOTO 21
              ENDIF
C
              IF (LDBG .GE. 2) THEN
                  OUTPUT = ' '
                  CALL STTPUT(OUTPUT, ISTAT)
                  WRITE(OUTPUT,'(A,I5,A,I5,A,I5)') 'Next object:  ID =',
     2                            L,'    I =', I, '    J =', J
                  CALL STTPUT(OUTPUT, ISTAT)
              ENDIF
C
C ***         Calculate local background if needed.
C
              IF (ICOL(3) .EQ. 0 .AND. NCNT .EQ. 1) THEN
                  CALL SKYMOD(A, JAPY, IBUF, I, J, RARR(39),
     &                        IHED, 0, PMTR(1,LZ))
              ENDIF
C
C ***         Find distance to nearest other object.
C
              CALL NRDIST(L, L0, L1, IAVDIS, NREG, LSTP,
     &                    NCAT, PMTR, PRCT)
C
C ****        Calculate and analyze profile in 8 octants. Results
C ***         are returned in arrays NCAT, PRCT, PMTR and MCM.
C ***         NCAT contain integer parameters, PRCT one-dimensional
C ***         profile, PMTR floating point parameters and MCM
C ***         contain informations about newly found objects.
C
              CALL PRANLZ(A, JAPY, NX, ITOB, IXYU ,
     &                    IBUF, L0, L1, LW, L ,
     &                    M, M0, MM, LSTP, NREG ,
     &                    IARR, RARR, APSF, FPSF, IPSF ,
     &                    NCNT, NCAT, PMTR, PRCT ,
     &                    IAVDIS, MCM)
C
C ***         Check if object is in the frame.
C
              LZ = L - L0
              IF (.NOT.(IVRF .EQ. 0 .AND. L .LE. M0)) THEN
                  I = NINT(PMTR(10,LZ))
                  J = NINT(PMTR(11,LZ))
                  NCAT(1,LZ) = I
                  NCAT(2,LZ) = J
                  IF ((NCNT.GT.IARR(2)) .AND. 
     2                    (I.LT.IARR(12) .OR. I.GT.IARR(14) .OR.
     &                    J.LT.IARR(13) .OR. J .GT. IARR(15))) THEN
                      PMTR(2,LZ) = 0.0
                  ENDIF
                  IF ((NCNT.LE.IARR(2)) .AND. 
     2                    (I.LT.ITOB(1) .OR. I.GT.ITOB(3) .OR.
     &                    J.LT.ITOB(2) .OR. J.GT.ITOB(4))) THEN
                      PMTR(2,LZ) = 0.0
                  ENDIF
              ENDIF
C
C ***         Eliminate fainter components of close blends.
C
              IF (IVRF .EQ. 1 .OR. L .GT. M0) THEN
                  LACT = 0
   51             CONTINUE
                      CALL GETLST(L, L0, L1, IDLM, NREG ,
     &                            LSTP, NCAT, PMTR, PRCT, LACT ,
     &                            NCT, PMT, PRC, DONE)
                      IF (DONE .AND. LACT .LT. L) THEN
C
C ***                     Fetch new component central intensity
C ***                     LL2 and positions XCMP and YCMP.
C
                          LLZ = LACT - L0
                          LL2 = PMTR(2,LLZ)
                          XCMP = PMTR(10,LLZ)
                          YCMP = PMTR(11,LLZ)
C
C ***                     Final check on component distance.
C
                          XOBJ = PMTR(10,LZ)
                          YOBJ = PMTR(11,LZ)
                          DIST = SQRT((XOBJ-XCMP)**2.0 +
     &                                 (YOBJ-YCMP)**2.0)
C
C ***                     Look for another component
C ***                     if that is not close enough.
C
                          IF (DIST .GE. ADLM) GOTO 51
C
C ***                     Do not contest objects that
C ***                     are not to be veryfied.
C
                          IF (IVRF .EQ. 0 .AND. LACT .LE. M0) THEN
C
C ***                         The object with higher number is rejected.
C
                              PMTR(2,LZ) = 0.0
                              GOTO 50
                          ENDIF
C
C ***                     Check which of two objects is brighter.
C
                          IF (PMTR(2,LZ) .LE. LL2) THEN
                              PMTR(2,LZ) = 0.0
                          ELSE
                              PMTR(2,LLZ) = 0.0
                          ENDIF
                          GOTO 51
                      ELSE
                          IF (DONE) GOTO 51
                      ENDIF
   50             CONTINUE
              ENDIF
C
C ***         Calculate additional classifiers.
C
              CALL APPMTR(PRCT(0,LZ), NCAT(5,LZ), IARR(5) ,
     &                     RARR, APSF, PMTR(1,LZ))
C
   21         CONTINUE
          IF (L .LT. MM) GOTO 20
C
          IF (LDBG .GT. 0) THEN
              OUTPUT = ' '
              CALL STTPUT(OUTPUT, ISTAT)
              WRITE (OUTPUT,'(A)') 'PROFILES ANALYSED'
              CALL STTPUT(OUTPUT, ISTAT)
              WRITE (OUTPUT,'(A)') '-----------------'
              CALL STTPUT(OUTPUT, ISTAT)
          ENDIF
C
C ***     Improve one dimensional point spread function
C ***     and calculate relative gradients.
C
          L0 = 0
          L1 = MM
          LW = MM
          CALL PNTSPF(IMF, L0, L1, LW, NREG ,
     &                LSTP, FPSF, NCAT, PMTR, PRCT ,
     &                IARR, RARR, ABGRD)
C
C ***     Initialize two-dimensional psf.
C
          IF (IARR(2).GT.0 .AND. NCNT.EQ.1 .AND.
     2                (LPXL.GT.0 .OR. LSBP.GT.0)) THEN
              NPRF = NOSP + (2*LSBP+1)**2
              CALL DEFPSF(RARR, FPSF, NPRF, IPSF, LPXL, LSBP)
          ENDIF
C
C ***     Modify two-dimensional point spread function.
C
          IF (NCNT.GT.1 .AND. (LPXL.GT.0 .OR. LSBP.GT.0)) THEN
              NPRF = NOSP + (2*LSBP+1)**2
              CALL MODPSF(RARR, FPSF, NPRF, IPSF, LPXL, LSBP)
          ENDIF
C
C ***     Calculate stellar magnitudes by convolving
C ***     one dimensional observed profiles with the
C ***     one dimensional point spread function.
C
          ICT = NCNT - IARR(2)
          CALL PRFCNV(L0, L1, LW, NREG, LSTP ,
     &                NCAT, PMTR, PRCT, IARR, RARR ,
     &                ICT, ABGRD)
C
C ***     Update scratch file.
C
C          IF (L1 .GT. LW) THEN
C              NPP = L1 - L0
C              CALL PARFIL(ISF, L0, L1, LW, L, LSTP,
C    &                 NREG, NCAT, PMTR, PRCT, NPP)
C          ENDIF
C
C ***     Remove objects which are too faint.
C
          CALL RENMBR(L0, L1, LW, NREG, LSTP ,
     &                NCAT, PMTR, PRCT, IVRF, TRSH ,
     &                M0, MM, M)
          MM = M
          WRITE (OUTPUT, '(A,I5)') 'Actual number of objects = ',M
          CALL STTPUT(OUTPUT, ISTAT)
C
C ***     End of external loop.
C
      IF (NCNT .LE. IARR(2)) GOTO 10
C
C *** Write two dimensional psf into descriptor UPROFILE.
C
      IF (TWOD .AND. IARR(2) .GT. 0 .AND. NCNT .GT. IARR(2)) THEN
          IF (OUTPSF .NE. 'NONE') THEN
              NTMP = (2*LPXL+1)*(2*LSBP+1)
              LL = NTMP / 2
              NVAL = NTMP*NTMP
              NAXISP = 2
              NPIXP(1) = NTMP
              NPIXP(2) = NTMP
              STARTP(1) = 1.0
              STARTP(2) = 1.0
              STEPP(1) = 1.0
              STEPP(2) = 1.0
              MAXS = 1
              CALL STDRDC(IMF, 'IDENT', 72, 1, 1 ,
     &                     NACT, IDENT, KUN, KNUL, ISTAT)
              CALL STDRDC(IMF, 'CUNIT', 48, 1, 1 ,
     &                     NACT, CUNIT, KUN, KNUL, ISTAT)
              CALL STIPUT(OUTPSF, D_R4_FORMAT, F_IO_MODE ,
     &                     F_IMA_TYPE, NAXISP, NPIXP, STARTP ,
     &                     STEPP, IDENT, CUNIT, NPNTRP, IPF ,
     &                     ISTAT)
              IADR = 4 * NVAL + 1  
              CALL FDTOTD(FPSF(1), FPSF(IADR), LPXL, LSBP, LL)
              CALL COPYF(FPSF(IADR),MADRID(NPNTRP),NVAL)
              FTMP(1) = -0.1
              FTMP(2) = 1.1
              CALL STDWRR(IPF, 'LHCUTS', FTMP, 1, 2, KUN, ISTAT)
              CALL STFCLO(IPF,ISTAT)
          ENDIF
      ENDIF
C
C *** Display some informations.
C
      IF (LDBG .GE. 1) THEN
         WRITE(OUTPUT,'(A)') 
     2   'Logarithmic differential point spread function'
         CALL STTPUT(OUTPUT, ISTAT)
         WRITE (OUTPUT,'(8F10.3)') (RARR(L),L=14,21)
         CALL STTPUT(OUTPUT, ISTAT)
         WRITE (OUTPUT,'(8F10.3)') (RARR(L),L=22,29)
         CALL STTPUT(OUTPUT, ISTAT)
         WRITE (OUTPUT,'(8F10.3)') (RARR(L),L=30,37)
         CALL STTPUT(OUTPUT, ISTAT)
       ENDIF      
C
      IF (LDBG .GE. 2) THEN
         DO 30 L = 1, M
            I = NCAT(1,L)
            J = NCAT(2,L)
            IF (I .LT. ITOB(1) .OR. J .LT. ITOB(2) .OR. I .GT.
     &                 ITOB(3) .OR. J .GT. ITOB(4)) GOTO 30
            OUTPUT = ' '
            CALL STTPUT(OUTPUT, ISTAT)
            WRITE (OUTPUT,'(A)') '           ID          X          Y'//
     &            ' CLOSEST_N  UNBLENDED  OBJ_SIZE  SATURATED'
            CALL STTPUT(OUTPUT, ISTAT)
            WRITE(OUTPUT,'(7I11)') L, (NCAT(LI,L),LI=1,6)
            CALL STTPUT(OUTPUT, ISTAT)
            IF (LDBG.EQ.2) THEN
               WRITE (OUTPUT,'(A)') '   BACKGRND  CENTRAL_9     '//
     &               'REL_GRAD ISOPHOT_MAG  CNV_MAG  ISOPHOT_RAD'//
     &               '  CLASS'
               CALL STTPUT(OUTPUT, ISTAT)
               WRITE(OUTPUT,'(1X,7G11.3)') PMTR(1,L), PMTR(2,L),
     &               PMTR(3,L), PMTR(5,L), PMTR(12,L),
     &               PMTR(15,L), PMTR(21,L)
               CALL STTPUT(OUTPUT, ISTAT)
            ENDIF
            IF (LDBG .GT. 2) THEN
               WRITE (OUTPUT,'(A)') 'Output parameters'
               CALL STTPUT(OUTPUT, ISTAT)
               WRITE(OUTPUT,'(1X,7G11.3)') PMTR(10,L),PMTR(11,L),
     &               PMTR(12,L),PMTR(13,L),PMTR(20,L),PMTR(3,L),
     &               PMTR(4,L)
               CALL STTPUT(OUTPUT, ISTAT)
               WRITE(OUTPUT,'(1X,7G11.3)') PMTR(1,L),PMTR(2,L),
     &               PMTR(6,L),PMTR(7,L),PMTR(8,L),PMTR(9,L),PMTR(15,L)
               CALL STTPUT(OUTPUT, ISTAT)
               WRITE(OUTPUT,'(1X,6G11.3)') PMTR(16,L),PMTR(17,L),
     &              PMTR(18,L),PMTR(19,L),PMTR(5,L),PMTR(21,L)
               CALL STTPUT(OUTPUT, ISTAT)
               WRITE(OUTPUT,*) 'Pixel spaced average profile'
               CALL STTPUT(OUTPUT, ISTAT)
               WRITE(OUTPUT,'(1X,7G11.3,2X)') (PRCT(K,L),K=0,6)
               CALL STTPUT(OUTPUT, ISTAT)
               WRITE(OUTPUT,'(1X,7G11.3,2X)') (PRCT(K,L),K=7,13)
               CALL STTPUT(OUTPUT, ISTAT)
               WRITE(OUTPUT,'(1X,7G11.3,2X)') (PRCT(K,L),K=14,20)
               CALL STTPUT(OUTPUT, ISTAT)
            ENDIF
   30    CONTINUE
      ENDIF
C
C *** Create or update descriptor DPROFILE in an input image
C *** frame containing the used point spread function.
C
      CALL STDFND(IMF, 'DPROFILE', TYPE, NEL, NBYTE, ISTAT)
      IF (TYPE .EQ. 'R' .AND. NEL .GT. 0) THEN
         IF (IARR(11) .NE. 0) THEN
            CALL STDWRR(IMF, 'DPROFILE', RARR(14), 1,
     &                                  ABS(IARR(11)), KUN, ISTAT)
         ENDIF
      ELSE
         CALL STDWRR(IMF, 'DPROFILE', RARR(14), 1, 25, KUN, ISTAT)
      ENDIF
C
C *** Quit if output table is not to be written.
C
      IF (IARR(3) .NE. 1) RETURN
C
C***  Initialize and open output table file.
C 
      CALL STKRDC('OUT_A', 1, 1, 60, IACT, OUTABL, KUN, KNUL, ISTAT)
      IF (IARR(6) .GT. 0) THEN
         NCOL = 27 + MIN(IARR(6), MAXSUB)
      ELSE
         NCOL = 26
      ENDIF
      CALL TBTINI(OUTABL, 0, F_O_MODE, NCOL, NROW, IOF, ISTAT)
      CALL STDRDD(IMF, 'START', 1, 2, IACT, START, KUN, KNUL, ISTAT)
      CALL STDRDD(IMF, 'STEP', 1, 2, IACT, STEP, KUN, KNUL, ISTAT)
      CALL CTABLE(IOF, NCOL, MM, START, STEP, NCAT, PMTR, PRCT, NP)
      CALL STDWRD(IOF, 'START', START, 1, 2, KUN, ISTAT)
      CALL STDWRD(IOF, 'STEP', STEP, 1, 2, KUN, ISTAT) 
C
C *** Write descriptors into output table.
C
      DO 75 K = 1, 25
         STPR(K) = RARR(13+K)
   75 CONTINUE
      DO 76 K = 26, MAXSUB
         STPR(K) = RARR(38)
   76 CONTINUE
      CALL STDWRR(IOF, 'DPROFILE', STPR, 1, MAXSUB, KUN, ISTAT)
C
C ******      Close output table.
C
      CALL TBSINI(IOF, ISTAT)
      CALL TBTCLO(IOF, ISTAT)
C
C
C     DO L=1,M
C        PMTR(12,L)=AMGN(L)+ZRMG
C        ICLS(2,L)=INT(PMTR(21,L))
C     END DO
C
C***********************************************************************
C
C         *****        Two options to choose         *****
C
C      CALL RD_DESCR_R(8,'FLAT_SKY',ABGR,ISTAT)
C
C      CALL GETDSCR_ST(FRAMEA,'FLAT_SKY','REAL',1,8,ABGR,IACT,ISTAT)
C
C      ABGR=1.0            ! If none of options is valid
C
C***********************************************************************
C
C
C displays on terminal screen and writes into log file most important
C informations
C
C      WRITE(OUTPUT,'(1X,A)') FRAMEA
C      CALL STTPUT(OUTPUT, ISTAT)
C      WRITE(OUTPUT,'(1X,A,2F8.2)') 'Low and high cuts = ',RARR(1),
C     +      RARR(2)
C      CALL STTPUT(OUTPUT, ISTAT)
C      WRITE(OUTPUT,'(1X,A,I3)') 'Subarray half-edge = ',IHED
C      CALL STTPUT(OUTPUT, ISTAT)
C      WRITE(OUTPUT,'(1X,A,F5.3)') 'Limiting threshold = ',TRSH
C      CALL STTPUT(OUTPUT, ISTAT)
C      WRITE(OUTPUT,'(1X,A,F7.3)') 'Zero magnitude = ',RARR(11)
C      CALL STTPUT(OUTPUT, ISTAT)
C      WRITE(OUTPUT,'(1X,A,2F8.3)')'Aperture sizes in pixels',RARR(12),
C     +      RARR(54)
C      CALL STTPUT(OUTPUT, ISTAT)
C
C outputs a list of objects with relevant parameters
C
C      IF (LDBG.GE.1) THEN
C         DO L=1,M
C            WRITE (OUTPUT,'(/A)') '      ID          X          Y'//
C     +            '  CLOSEST_N  UNBLENDED   OBJ_SIZE  SATURATED'
C           CALL STTPUT(OUTPUT, ISTAT)
C           WRITE (OUTPUT,'(7I11)') L,(NCAT(LI,L),LI=1,6)
C           CALL STTPUT(OUTPUT, ISTAT)
C           IF (LDBG.EQ.2) THEN
C              WRITE (OUTPUT,'(A)') '    BACKGRND  CENTRAL_9   R_GRADIENT'//
C     +              ' ISOPHOT_MAG  CNV_MAG  ISOPHOT_RAD  CLASS'
C              CALL STTPUT(OUTPUT, ISTAT)
C              WRITE (OUTPUT,'(1X,7F11.3)') PMTR(1,L),PMTR(2,L),
C     +              PMTR(3,L),PMTR(5,L),PMTR(12,L),PMTR(15,L),PMTR(21,L)
C              CALL STTPUT(OUTPUT, ISTAT)
C           END IF
C           IF (LOUT.GT.2) THEN
C               WRITE (OUTPUT,'(A)') 'Output parameters'
C               CALL STTPUT(OUTPUT, ISTAT)
C               WRITE (OUTPUT,'(1X,8F7.3,3F7.1)') (PMTR(K,L),K=1,11)
C               CALL STTPUT(OUTPUT, ISTAT)
C               WRITE (OUTPUT,'(1X,9F7.3,F7.0,F7.1)') (PMTR(K,L),K=12,22)
C               CALL STTPUT(OUTPUT, ISTAT)
C               WRITE (OUTPUT,'(A)') 'Pixel spaced average profile'
C               CALL STTPUT(OUTPUT, ISTAT)
C               WRITE (OUTPUT,'(10F8.3)') (PRCT(K,L),K=0,19)
C               CALL STTPUT(OUTPUT, ISTAT)
C            END IF
C         END DO
C      END IF
C
C ****   Writes output table file.
C
C      IF (LTAB.EQ.1) THEN
C
C ****   Reads needed informations from image
C
C***********************************************************************
C
C         *****         Two options to choose !!!         *****
C
C                  In case of temporary image format
C
C         CALL RD_DESCR_C(8,'IDENT',IDENT,ISTAT)
C         CALL RD_DESCR_R(8,'STARTX',START(1),ISTAT)
C         CALL RD_DESCR_R(8,'STARTY',START(2),ISTAT)
C         CALL RD_DESCR_R(8,'STEPX',STEP(1),ISTAT)
C         CALL RD_DESCR_R(8,'STEPY',STEP(2),ISTAT)
C
C                    In case of Midas image format
C
C         CALL GETDSCR_ST(FRAMEA,'IDENT','CHARACTER',1,72,IACT,IDENT,IS)
C         CALL GETDSCR_ST(FRAMEA,'START','REAL',1,2,IACT,START,ISTAT)
C         CALL GETDSCR_ST(FRAMEA,'STEP','REAL',1,2,IACT,STEP,ISTAT)
C
C***********************************************************************
C
C          *****         Two options to choose          *****
C
C                  In case of temporary table format
C
C         OPEN (11,FILE=TABLE,STATUS='new')
C         ICOL=22+IPRF
C         CALL CRTAB(11,IDENT,START,STEP,PMTR,PRCT,ICOL,M,IDP)
C         write (OUTPUT,*) idp
C         CALL STTPUT(OUTPUT, ISTAT)
C         CALL WRDESR(11,IDP,'FLAT_SKY',1,ABGR,ISTAT)
C         CALL WRDESR(11,IDP,'TRESHOLD',1,TRSH,ISTAT)
C         CALL WRDESI(11,IDP,'HALFEDGE',1,IHED,ISTAT)
C         CALL WRDESR(11,IDP,'STMETRIC',2,STMT,ISTAT)
C         CALL WRDESR(11,IDP,'SPROFILE',25,STPR,ISTAT)
C         IF (MGCR2.EQ.1) THEN
C            CALL WRDESR(11,IDP,'EXPRTIME',1,TINT,ISTAT)
C         END IF
C         CLOSE(11)
C
C                   In case of Midas table format
C
C         CALL CTABLE(TABLE,NCAT,PMTR,PRCT,ICLS,M,START,STEP,IPRF)
C         I1=INDEX(TABLE//' ',' ')-1
C         TABLET=TABLE(1:I1)//'.TBL'
C         CALL PUTDSCR_ST(TABLET,'NORFRAME','CHARACTER',FRAMEA,1,8,
C     +         ISTAT)
C         CALL PUTDSCR_ST(TABLET,'FLAT_SKY','REAL',ABGR,1,1,ISTAT)
C         CALL PUTDSCR_ST(TABLET,'TRESHOLD','REAL',TRSH,1,1,ISTAT)
C         CALL PUTDSCR_ST(TABLET,'HALFEDGE','INTEGER',IHED,1,1,ISTAT)
C         CALL PUTDSCR_ST(TABLET,'ZEROMAGN','REAL',ZRMG,1,1,ISTAT)
C         CALL PUTDSCR_ST(TABLET,'STMETRIC','REAL',STMT,1,2,ISTAT)
C         CALL PUTDSCR_ST(TABLET,'SPROFILE','REAL',STPR,1,25,ISTAT)
C         IF (MGCR2.EQ.1) THEN
C             CALL PUTDSCR_ST(TABLET,'EXPRTIME','REAL',TINT,1,1,ISTAT)
C         END IF
C
C***********************************************************************
C
C      END IF
C
C writes "LHCUTS" descriptor into an output image frame, adjusted
C for inspecting image on DeAnza monitor with lookup table "RAINBOW".
C
C      CUTS(1)=0.7
C      CUTS(2)=3.0
C
C      CALL PUTDSCR_ST(FRAMEA,'LHCUTS','REAL',CUTS,1,2,ISTAT)
C
      RETURN
      END

C @(#)group.for	19.1 (ES0-DMD) 02/25/03 13:23:49
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE  GROUP (PAR, MAXPAR, PSF, MAXPSF, MAXEXP, 
     .     ID, X, Y, MAG, SKY, ISIZE, NUMBER, INDEX, MAXSTR, 
     .     FITRAD, PSFRAD)
C
C=======================================================================
C
C This subroutine accepts a file containing stellar coordinates, and
C associates the stars into natural groups based on the magnitude level
C at which they overlap:  if two stars are within a distance equal to
C one PSF radius plus one fitting radius plus one pixel of each other, 
C the PSF of the brighter is evaluated at a point one fitting radius 
C plus one pixel away from the fainter.  If this value is larger than 
C some user-defined fraction of the anticipated noise per pixel, the 
C two stars are put into the same group.
C
C Groups are written out into the disk file in order of increasing 
C size.  (This is done to minimize the length of time the array 
C processor must be attached to the program in NSTAR).
C
C             OFFICIAL DAO VERSION:  1991 April 18
C
C======================================================================
C
      IMPLICIT NONE
      INTEGER MAXSTR, MAXPSF, MAXBOX, MAXPAR, MAXEXP
      PARAMETER  (MAXBOX=69)
C
C Parameter
C
C MAXSTR is the largest number of stars that may be contained in a data
C        file.
C
      CHARACTER*30 COOFIL, MAGFIL, PSFFIL, PROFIL, GRPFIL, SWITCH
      CHARACTER EXTEND*30, CASE*4
      REAL X(MAXSTR), Y(MAXSTR), MAG(MAXSTR), SKY(MAXSTR)
      REAL PSF(MAXPSF,MAXPSF,MAXEXP), DATA(MAXBOX,MAXBOX), PAR(MAXPAR)
      INTEGER ID(MAXSTR), INDEX(MAXSTR), RDPSF
      INTEGER ISIZE(MAXSTR), NUMBER(MAXSTR)
C
      REAL SQRT, USEPSF, ALOG10
C
      CHARACTER*4 PLSTR, PLGRP
      REAL HIBAD, THRESH, AP1, PHPADU, READNS, FRAD, PSFMAG, BRIGHT
      REAL XPSF, YPSF, CRIT, BRTMAG, DENOM, DX, DY, RSQ, FRSQ, VAL
      REAL DELTAX, DELTAY, DVDXC, DVDYC, FITRAD, PSFRAD, WT, FR
      REAL CRITSQ, CRITSEP, DXTEST, DYTEST, DXI, DYI, RATIO, ERR
      REAL LOBAD, MTEST, NUMER, XTEST, YTEST, STEST
      INTEGER I, J, II, IPSTYP, NPSF, NPAR, NEXP, NFRAC, LX, LY
      INTEGER NCOL, NROW, NL, JTEST, NGRP, NX, NY, IST, K, ISTAT
      INTEGER NTOT, ITEST, ITOP, N, IFIRST, MAXGRP, JTOP, LENGRP
C
      COMMON /FILNAM/ COOFIL, MAGFIL, PSFFIL, PROFIL, GRPFIL
C
C-----------------------------------------------------------------------
C
C SECTION 1
C
C Get set up.
C
C Open input photometry file.
C
      CALL TBLANK                                   ! Type a blank line
  950 CALL GETNAM ('File with photometry:', MAGFIL)
      IF ((MAGFIL .EQ. 'END OF FILE') .OR.
     .     (MAGFIL .EQ. 'GIVE UP')) THEN
         MAGFIL = ' '
         RETURN
      END IF
      CALL INFILE (2, MAGFIL, ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error opening input file '//MAGFIL)
         MAGFIL = 'GIVE UP'
         GO TO 950
      END IF
      CALL RDHEAD (2, NL, NCOL, NROW, LOBAD, HIBAD, THRESH, AP1, 
     .     PHPADU, READNS, FRAD)
      IF (NL .LE. 0) NL=1
C
C Read the point-spread function into memory.
C
  960 CALL GETNAM ('File with the PSF:', PSFFIL)
      IF ((PSFFIL .EQ. 'END OF FILE') .OR. 
     .     (PSFFIL .EQ. 'GIVE UP')) THEN
         CALL CLFILE (2)
         PSFFIL = ' '
         RETURN
      END IF
      ISTAT = RDPSF (PSFFIL, IPSTYP, PAR, MAXPAR, NPAR,
     .     PSF, MAXPSF, MAXEXP, NPSF, NEXP, NFRAC,
     .     PSFMAG, BRIGHT, XPSF, YPSF)
      IF (ISTAT .NE. 0) THEN
         PSFFIL = 'GIVE UP'
         GO TO 960
      END IF
C
C Obtain the critical overlap.
C
      CALL GETDAT ('Critical overlap:', CRIT, 1)
      IF (CRIT .LE. -1.E38) GO TO 9090
      CRIT=CRIT**2
C
C Open output group file.
C
      GRPFIL=SWITCH(MAGFIL, CASE('.grp'))
  970 CALL GETNAM ('File for stellar groups:', GRPFIL)
      IF ((GRPFIL .EQ. 'END OF FILE') .OR.
     .     (GRPFIL .EQ. 'GIVE UP')) THEN
         CALL CLFILE (2)
         RETURN
      END IF
      GRPFIL = EXTEND(GRPFIL, CASE('grp'))
      CALL OUTFIL (3, GRPFIL, ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error opening output file '//GRPFIL)
         GRPFIL = 'GIVE UP'
         GO TO 970
      END IF
      CALL WRHEAD (3, 3, NCOL, NROW, 6, LOBAD, HIBAD, THRESH, AP1, 
     .     PHPADU, READNS, FRAD)
      READNS=READNS**2
C
C-----------------------------------------------------------------------
C
C SECTION 2
C
C Associate stars into natural groupings.
C
C Read in and count the stars.
C
      I=0
      BRTMAG=1.E38
      FRSQ=FITRAD**2
 2010 I=I+1
      IF (I .GT. MAXSTR) THEN
         CALL STUPID ('Too many stars in input file.')
         WRITE (6,6) MAXSTR
    6    FORMAT (I10, ' is the most you are currently allowed.')
         CALL CLFILE (2)
         CALL CLFILE (3)
         RETURN
      END IF
 2020 CALL RDSTAR (2, NL, ID(I), X(I), Y(I), MAG(I), SKY(I))
      IF (ID(I) .LT. 0) GO TO 2030             ! End-of-file encountered
      IF (ID(I) .EQ. 0) GO TO 2020             ! Blank line encountered
      ISIZE(I)=0                               ! Initialize ISIZE
      NUMBER(I)=0                              ! Initialize NUMBER
      IF (MAG(I) .GT. 90.) THEN                ! Null magnitude
         LX=INT(X(I)-FITRAD)+1
         LY=INT(Y(I)-FITRAD)+1
         NX=INT(X(I)+FITRAD)-LX+1
         NY=INT(Y(I)+FITRAD)-LY+1
         IF ((NX .LT. 1) .OR. (NY .LT. 1)) GO TO 2010
         CALL RDARAY ('DATA', LX, LY, NX, NY, MAXBOX, DATA, IST)
         IF ((NX .LT. 1) .OR. (NY .LT. 1)) GO TO 2010
         DELTAX=(X(I)-1.)/XPSF-1.
         DELTAY=(Y(I)-1.)/YPSF-1.
         DENOM=0.
         NUMER=0.
         DO K=1,NY
            DO J=1,NX
               DX=REAL(LX+J-1)-X(I)
               DY=REAL(LY+K-1)-Y(I)
               RSQ=DX**2+DY**2
               IF ((RSQ .LT. FRSQ) .AND. (DATA(J,K) .LE. HIBAD) .AND.
     .              (DATA(J,K) .GE. LOBAD)) THEN
                  VAL=USEPSF(IPSTYP, DX, DY, BRIGHT, PAR, PSF, NPSF, 
     .                 NPAR, NEXP, NFRAC, DELTAX, DELTAY, DVDXC, DVDYC)
                  RSQ=RSQ/FRSQ
                  WT=5./(5.+RSQ/(1.-RSQ))
                  NUMER=NUMER+WT*VAL*(DATA(J,K)-SKY(I))
                  DENOM=DENOM+WT*VAL**2
               END IF
            END DO
         END DO
         IF ((DENOM .LE. 0.) .OR. (NUMER .LE. 0.)) GO TO 2010
         MAG(I)=PSFMAG-2.5*ALOG10(NUMER/DENOM)
      ELSE
         IF (MAG(I) .LT. BRTMAG) BRTMAG=MAG(I)
      END IF
      GO TO 2010
C
 2030 NTOT=I-1
      IF (NTOT .LE. 0) GO TO 9080
C
C All the stars have now been read in.
C NTOT is the number of stars in the file, which is also the 
C theoretical maximum number of groups that can be found.
C
      CALL QUICK (Y, NTOT, INDEX)
C
C The vector of stellar y-values is now in increasing order.  ID, X,
C MAG, and SKY are still in the order in which they were read in.
C The array INDEX tells how they are to be cross-matched:  The i-th
C star in increasing y-order has ID(INDEX(i)), X(INDEX(i)), Y(i),
C MAG(INDEX(i)), and SKY(INDEX(i)).
C
      IF (BRTMAG .LT. 90.) THEN
         BRTMAG=10.**(0.4*(PSFMAG-BRTMAG))
      ELSE
         BRTMAG=1.
      END IF
C
C BRTMAG is the apparent magnitude of the brightest star in the
C input file.  (If all stars have apparent magnitudes greater than
C 90.0-- i.e. the aperture photometry blew up on all stars, BRTMAG
C is equal to the apparent magnitude of the point-spread function.)
C
      IF (NEXP+NFRAC .GE. 1) 
     .     CALL SMTHPS (PSF, MAXPSF, MAXEXP, NPSF, NEXP+NFRAC)
C
C Compute the effective radius of the point-spread function, and
C add one fitting radius plus one pixel.
C
      FR=FITRAD+1.
      FRSQ=FR**2
      CRITSEP=AMIN1(PSFRAD, (REAL(NPSF-1)/2.-1.)/2. ) + FR
      CRITSQ=CRITSEP**2
C
C Now search the star list for stars lying within a critical distance of
C each other.  Stars are considered in order of increasing y-coordinate.
C
C Initialize the counters.  The variable N will count the 
C number of stars in the current group.
C
      ITEST=0
      ITOP=2
      N=1
      IFIRST=1
      MAXGRP=0
C
C The stars are currently in a stack NTOT stars long.  The variable 
C IFIRST points to the first star in the current group; this starts out,
C of course, with the value 1.  ITEST will point to the position in the 
C stack occupied by the star which is currently the center of a circle 
C of the critical radius, within which we are looking for other stars; 
C this also starts out with a value of 1.  ITOP points to the top 
C position in the stack of the stars which have not yet been assigned 
C to groups; this starts out with the value 2.  Each time through, the 
C program goes down through the stack from ITOP to NTOT and looks for 
C stars within the critical distance from the star at stack position 
C ITEST.  When such a star is found, it changes places in the stack 
C with the star at ITOP and ITOP is incremented by one.  When the 
C search has gotten to the last position in the stack (NTOT), the 
C pointer ITEST is incremented by one, and the search proceeds again 
C from the new value of ITOP to NTOT.  If the pointer ITEST catches up 
C with the pointer ITOP, that means that the group currently being 
C built up is complete.  The number of stars in the newly-created 
C group (the first star of which is at stack position IFIRST) is stored 
C in array element ISIZE(IFIRST).  Then a new group is started 
C beginning with the star at the current position ITEST, ( = ITOP for 
C the moment), ITOP is incremented by 1, and the next group is built
C up as before.
C
 2100 ITEST=ITEST+1
      IF (ITEST .LT. ITOP) GO TO 2110
C
C ITEST has reached ITOP; no other unassigned stars are within a 
C critical separation of any member of the current group.  The group is 
C therefore complete. Store N in ISIZE(IFIRST). Then start a new group 
C with the star currently at ITEST ( = the old value of ITOP), and then 
C increment the value of ITOP by one.
C
      ISIZE(IFIRST)=N
      IF (N .GT. MAXGRP) MAXGRP=N
      NUMBER(N)=NUMBER(N)+1
C
C The array NUMBER(i) builds up a histogram giving the number of
C groups of size i as a function of i.
C
      N=1                                   ! Re-initialize star counter
      IFIRST=ITEST
C
C If ITEST equals NTOT at this point, then we are finished (the last
C group contains one star).  Otherwise, set ITOP to the first star
C below ITEST and on with the search.
C
      IF (ITEST .GE. NTOT) GO TO 4000
      ITOP=ITOP+1                              ! Increment ITOP
      JTOP=INDEX(ITOP)
C
 2110 JTEST=INDEX(ITEST)
      XTEST=X(JTEST)
      YTEST=Y(ITEST)
      DXTEST=XTEST-XPSF
      DYTEST=YTEST-YPSF
C
      IF (MAG(JTEST) .GT. 90.) THEN
         MTEST=BRTMAG
      ELSE
         MTEST=10.**(0.4*(PSFMAG-MAG(JTEST)))
      END IF
C
      STEST=SKY(JTEST)
C
C Now go through the list of unassigned stars, occupying positions ITOP
C through NTOT in the stack, to look for stars within one critical
C distance of the star at position ITEST in the stack.  If one is found,
C compute the point-spread function of the brighter at a point one
C fitting radius plus one pixel from the fainter one along the line
C connecting them.  If this is larger than the input critical fraction
C of the total noise per pixel, move the new star up to stack position 
C ITOP and increment ITOP by one.  Note:  if any star has an apparent 
C magnitude greater than 90.0 (which means that the aperture 
C photometry bombed), the brightest reasonable magnitude (= BRTMAG) 
C will be assumed.
C 
      II=ITOP
      DO 2120 I=II,NTOT
      DY=Y(I)-YTEST
      IF (DY .GT. CRITSEP) GO TO 2130
      J=INDEX(I)
      DX=X(J)-XTEST
      IF (ABS(DX) .GT. CRITSEP) GO TO 2120
      RSQ=DX**2+DY**2
      IF (RSQ .GT. CRITSQ) GO TO 2120
      DXI=X(J)-XPSF
      DYI=Y(I)-YPSF
C
C This star is within one critical separation of the star at stack 
C position ITEST.  If their separation is less than one fitting radius
C plus one pixel put them in the same group no matter what.  Likewise,
C if the user entered a critical overlap less than or equal to zero,
C they belong in the same group no matter what.
C
      IF ((RSQ .LE. FRSQ) .OR. (CRIT .LE. 1.E-10)) GO TO 2115
C
C It is necessary to compute the PSF of the brighter star to determine
C whether the stars overlap by more than the critical amount.
C The two stars are already known to be separated by more than 
C FR = (one fitting radius plus one pixel), and by less than one
C CRITSEP = (one PSF radius plus one fitting radius plus one pixel).
C Evaluate the point-spread function of the brighter star at a point 
C FR pixels from the fainter, on the line segment connecting them.  
C If this value is greater than CRIT times the standard error per 
C pixel, then put them in the same group.  
C
      IF (MAG(J) .GT. 90.) THEN
         VAL=BRTMAG
      ELSE
         VAL=10.**(0.4*(PSFMAG-MAG(J)))
      END IF
C
C For the time being, VAL is the brightness of the star currently
C being compared with the star at ITEST.
C
      RSQ=SQRT(RSQ)
      RATIO=(RSQ-FR)/RSQ
      DX=RATIO*DX
      DY=RATIO*DY
C
C Which is brighter?  What is the value of its PSF at a position DX, DY
C from the center of the fainter?
C
      IF (MTEST .GT. VAL) THEN
         VAL=MTEST*USEPSF(IPSTYP, DX, DY, BRIGHT, PAR, PSF, NPSF, 
     .                 NPAR, NEXP, NFRAC, DELTAX, DELTAY, DVDXC, DVDYC)
      ELSE
         VAL=VAL*USEPSF(IPSTYP, DX, DY, BRIGHT, PAR, PSF, NPSF, 
     .                 NPAR, NEXP, NFRAC, DELTAX, DELTAY, DVDXC, DVDYC)
      END IF
C
C Standard error per pixel.
C
      ERR=READNS+0.5*(STEST+SKY(J))/PHPADU
C
C If the point-spread function of the brighter star is less than 
C fraction CRIT (input above) of the standard error per pixel, the 
C two stars are considered NOT to overlap.
C
      IF (VAL**2 .LT. CRIT*ERR) GO TO 2120
C
C The two stars overlap.  Increment the group-size counter.
C
 2115 N=N+1
C
C Now move this star up to position ITOP in the stack, where the pointer
C ITEST may eventually reach it.
C
      CALL SWAP2 (I, ITOP, INDEX, Y)
C
C Now increment ITOP by 1 to point at the topmost unassigned star in the
C stack.
C
      ITOP=ITOP+1
      JTOP=INDEX(ITOP)
CD     TYPE *, 'ITEST=', ITEST, ' ITOP=', ITOP
CD     DO III=ITOP,ITOP+10
CD       TYPE *, III, ID(INDEX(III)), X(INDEX(III)), Y(III)
CD     END DO
CD     ACCEPT *
 2120 CONTINUE
C
C If ITOP is greater than NTOT, then all stars have been assigned to
C groups, and we are finished.  Otherwise, increment ITEST by 1 and
C keep going.
C
 2130 IF (ITOP .LE. NTOT) GO TO 2100
C
C-----------------------------------------------------------------------
C
C Normal completion.
C
C ITOP has exceeded NTOT.  That means that all the stars in the input 
C file have been assigned to groups and have been written into the 
C output file.  Now we may write out the groups, in order of 
C increasing size, and close up shop.
C
 4000 ISIZE(IFIRST)=N
      NUMBER(N)=NUMBER(N)+1
      IF (N .GT. MAXGRP) MAXGRP=N
C
C Beginning of loop over group size.
C
      WRITE (6,640)
  640 FORMAT (/' Size of   Number of'/
     .         '  group     groups'/)
      NGRP=0
      DO 4040 I=1,MAXGRP
      IF (NUMBER(I) .LE. 0) GO TO 4040
C
C Now loop over actual groups, writing out any group whose size is
C equal to the current value of I.
C
      IFIRST=1
 4010 IF (ISIZE(IFIRST) .NE. I) GO TO 4030
      DO 4020 J=IFIRST,IFIRST+I-1
      K=INDEX(J)
 4020 WRITE (3,340) ID(K), X(K), Y(J), MAG(K), SKY(K)
  340 FORMAT (1X, I5, 4F9.3)
      NGRP=NGRP+1
      WRITE (3,340)                                 ! Write a blank line
 4030 IFIRST=IFIRST+ISIZE(IFIRST)
C
C End of loop over actual groups.
C
      IF (IFIRST .LE. NTOT) GO TO 4010
      WRITE (6,641) I, NUMBER(I)
  641 FORMAT (I6, I10)
C
C End of loop over group size.
C
 4040 CONTINUE
C
C Type out the number of stars and the number of groups NEATLY.
C
      PLSTR='s in'
      IF (NTOT .EQ. 1) PLSTR=' in '
      PLGRP='s.  '
      IF (NGRP .EQ. 1) PLGRP='.   '
      LENGRP=INT(ALOG10(NGRP+0.5))+2
      IF (NTOT .EQ. 1) LENGRP=LENGRP-1
      WRITE (6,643) NTOT, PLSTR, NGRP, PLGRP
  643 FORMAT (/I6, ' star', A4, I5, ' group', A4/)
 9080 CALL CLFILE (3)
 9090 CALL CLFILE (2)
      RETURN
      END!
C
C#######################################################################
C
      SUBROUTINE  SWAP2 (I, ITOP, INDEX, Y)
C
C=======================================================================
C
C Replace the ITOP-th star in the stack with the I-th star, then shift
C the intervening stars down the stack by one place.  
C
C=======================================================================
C
      IMPLICIT NONE
      REAL Y(*)
      INTEGER INDEX(*)
C
      REAL YHOLD
      INTEGER I, J, K, L, ITOP, IHOLD
C
C-----------------------------------------------------------------------
C
      YHOLD=Y(I)
      IHOLD=INDEX(I)
      L=I+ITOP
      DO J=ITOP,I-1
         K=L-J
         Y(K)=Y(K-1)
         INDEX(K)=INDEX(K-1)
      END DO
      Y(ITOP)=YHOLD
      INDEX(ITOP)=IHOLD
      RETURN
      END!
C
C#######################################################################
C
      SUBROUTINE  SMTHPS (PSF, MAXPSF, MAXEXP, NPSF, NEXPND)
C
C Smooth the PSF azimuthally, so that noise will not influence whether
C or not stars belong in the same group.  Averages will be computed for
C four quadrants.
C
      IMPLICIT NONE
      INTEGER MAXPSF, MAXEXP, MAXR, NSEC, IRMIN
      PARAMETER (MAXR=145, NSEC=4, IRMIN=4)
C
      REAL PSF(MAXPSF,MAXPSF,MAXEXP)
      REAL SUM(NSEC,MAXR), HIGH(NSEC,MAXR), LOW(NSEC,MAXR)
      INTEGER N(NSEC,MAXR)
C
      REAL REAL, SQRT
      INTEGER INT, ISCTR
C
      REAL RMAX, R, DYSQ
      INTEGER I, J, K, ICENTR, NPSF, IR, IS, NEXPND, IDX, IDY
C
      ICENTR=(NPSF+1)/2
      RMAX=0.7071068*REAL(NPSF-1)
C
      DO 3900 K=1,NEXPND
      DO IR=1,INT(RMAX+1.E-5)
         DO IS=1,NSEC
            SUM(IS,IR)=0.0
            HIGH(IS,IR)=-1.E38
            LOW(IS,IR)=1.E38
            N(IS,IR)=0
         END DO
      END DO
C
      DO 1900 J=1,NPSF
         IDY=J-ICENTR
         DYSQ=REAL(IDY**2)
         DO 1900 I=1,NPSF
            IDX=I-ICENTR
            R=SQRT(REAL(IDX**2)+DYSQ)
            IF (R .GT. RMAX) GO TO 1900
            IR=INT(R+1.E-5)
            IF (IR .LT. IRMIN) GO TO 1900
            IS=ISCTR(IDX,IDY)
            SUM(IS,IR)=SUM(IS,IR)+PSF(I,J,K)
            IF (PSF(I,J,K) .GT. HIGH(IS,IR)) HIGH(IS,IR)=PSF(I,J,K)
            IF (PSF(I,J,K) .LT. LOW(IS,IR)) LOW(IS,IR)=PSF(I,J,K)
            N(IS,IR)=N(IS,IR)+1
 1900 CONTINUE
C
      DO IR=IRMIN,INT(RMAX+1.E-5)
         DO IS=1,NSEC
            IF (N(IS,IR) .GT. 2) 
     .           SUM(IS,IR)=(SUM(IS,IR)-HIGH(IS,IR)-LOW(IS,IR))
     .                         /REAL(N(IS,IR)-2)
         END DO
      END DO
C
      DO 2900 J=1,NPSF
         IDY=J-ICENTR
         DYSQ=REAL(IDY**2)
         DO 2900 I=1,NPSF
            IDX=I-ICENTR
            R=SQRT(REAL(IDX**2)+DYSQ)
            IF (R .GT. RMAX) GO TO 2900
            IR=INT(R+1.E-5)
            IF (IR .LT. IRMIN) GO TO 2900
            IS=ISCTR(IDX,IDY)
            PSF(I,J,K)=SUM(IS,IR)
 2900 CONTINUE
 3900 CONTINUE
C
      RETURN
      END!
C
C######################################################################
C
C Convert an x,y coordinate pair into a numbered sector from 1 to 4.
C
      FUNCTION ISCTR (I,J)
C
      IMPLICIT NONE
      INTEGER ISCTR, I, J
      IF (I .GT. 0) THEN
         ISCTR=1
      ELSE IF (I .LT. 0) THEN
         ISCTR=3
      ELSE
         IF (J .LE. 0) THEN
            ISCTR=1
         ELSE
            ISCTR=3
         END IF
      END IF
      IF (J .GT. 0) THEN
         ISCTR=ISCTR+1
      ELSE IF (J .EQ. 0) THEN
         IF (I .GT. 0) ISCTR=2
      END IF
      RETURN
      END!

C @(#)dipole.for	19.1 (ES0-DMD) 02/25/03 13:17:29
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE DIPOLE(NIND,X,NPAR,PARAM,Y,DERIV)                              
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                  
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  18:01 - 21 DEC 1987                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C--------------------------------------------------------------                 
C***************************************************                            
C                                                                               
C      IMPLICIT NONE                                                            
C FIT WITH A LINEAR INFALL MODEL                                                
C                                                                               
C Fit the observed radial velocities (in any                                    
C reference system) with a dipole velocity                                      
C field with respect to this reference                                          
C                                                                               
C * * * * * * * * * * * * * * * * * * * * * * * * *                             
C                                                                               
C Independent variables:                                                        
C                                                                               
C  X(1): Galactic longitude                                                     
C  X(2): Galactic latitude                                                      
C                                                                               
C * * * * * * * * * * * * * * * * * * * * * * * * *                             
C                                                                               
C Free parameters:                                                              
C                                                                               
C  PARAM(1): Solar motion (in km/s)                                             
C  PARAM(2): Galactic longitude of Apex                                         
C  PARAM(3): Galactic latitude of Apex                                          
C                                                                               
C (All angles are in degrees !)                                                 
C                                                                               
C * * * * * * * * * * * * * * * * * * * * * * * * *                             
C                                                                               
C Author: O.-G. Richter, ESO Garching                                           
C                                                                               
      INTEGER NIND,NPAR
      REAL X(NIND),RAD,D1,A1,A2,D2,BC,BS,A                                      
      DOUBLE PRECISION Y,PARAM(NPAR),DERIV(NPAR)                                
      DATA RAD/1.74532925E-2/                                                   
C  !   Galactic latitude of object                                              
      D1     = X(2)*RAD  !   Galactic latitude of apex                          
      D2     = PARAM(3)*RAD                                                     
      A1     = COS(D1)                                                          
      A2     = COS(D2)                                                          
      D1     = SIN(D1)                                                          
      D2     = SIN(D2)                                                          
      A      = A1*A2  !   Difference in galactic longitude                      
      BS     = (PARAM(2)-X(1))*RAD                                              
      BC     = COS(BS)                                                          
      DERIV(1) = -D1*D2 - A*BC  !   Predicted radial velocity                   
      Y      = DERIV(1)*PARAM(1)                                                
      DERIV(2) = PARAM(1)*A*SIN(BS)*RAD                                         
      DERIV(3) = PARAM(1)* (D2*A1*BC-A2*D1)*RAD                                 
C                                                                               
      RETURN                                                                    
                                                                                
      END                                                                       

C @(#)tdinter.for	19.1 (ESO-DMD) 02/25/03 14:11:16 
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  9:41 - 9 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C
C.KEYWORDS
C
C  TABLE, IMAGES, SPLINE, INTERPOLATION
C
C.PURPOSE
C
C  spline interpolation image to image in 1 dimension
C
C.ALGORITHM
C
C  Interpolate input data YI sampled at XI to
C  output data YO sampled at XO with binwidth.
C
C  Restriction:  Input and output independent variables are
C                assumed to be monotonic increasing or decreasing
C
C
C  Detailed flux conservation obtained by REAL*8 spline interpolation
C  and NAGLIB REAL*8 integration of input data over the projected
C  bin WI for fractions of input pixels and summation of flux in
C  entire input pixels covered within the valid domain of input data
C  i.e. from x(1)-0.5*step to x(n)+0.5*step. Several options available
C  to handle undefined input at the extremes and for NULLVALUE assigned
C  parts of input array.
C
C   Optimized for long arrays by search for valid range, optimum
C  direction or DO LOOPS and updating of loop boundaries - therefore
C  overdoing it for small arrays.
C
C
C  WARNINGS : module to be tested. Replace allocated arrays by alloc memory
C
C-----------------------------------------------------------
C
      SUBROUTINE TDINII
      IMPLICIT   NONE
      INTEGER    NFPAR
      PARAMETER (NFPAR = 3)
C
      INTEGER MADRID
      INTEGER*8  IP1,IP2,IPQ,IPNTR,JPNTR
      INTEGER IACT,IDEGRE,IDERIV,IERR
      INTEGER IS,ISTAT,NAXISI,NAXISO
      INTEGER NDIMI,NDIMO,NFPACT,NI,NK,NN,NO
      INTEGER NPLUS, NBY, KUN, KNUL
      INTEGER NRDATA(1000),IMNO, IREF, IMOUT
      INTEGER NPIXI(3),NPIXO(3)
C
      REAL DELTA,FP,FP0,FPOLD,S,X1
      REAL RMIN,RMAX
      REAL CUTS(4)
      REAL FPARM(NFPAR),X0,WX
      REAL T(1000),C(1000)
C
      DOUBLE PRECISION STARTI(3), STEPI(3)
      DOUBLE PRECISION STARTO(3), STEPO(3)
C
      CHARACTER*60 INPIMA,OUTIMA,REFIMA
      CHARACTER*72 IDENTO,IDENTI
      CHARACTER*80 CUNITO,CUNITI
      CHARACTER    KBUF*40
C
      INCLUDE 'MID_INCLUDE:TABLES.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:TABLED.INC'
      DATA INPIMA/'   '/
      DATA OUTIMA/'   '/
      DATA REFIMA/'   '/
C
C ... get input parameters
C
      CALL STKRDC('OUT_A',1,1,60,IACT,OUTIMA,KUN,KNUL,ISTAT)
      CALL STKRDC('IN_A',1,1,60,IACT,INPIMA,KUN,KNUL,ISTAT)
      CALL STKRDC('IN_B',1,1,60,IACT,REFIMA,KUN,KNUL,ISTAT)
      CALL STKRDR('INPUTR',1,NFPAR,NFPACT,FPARM,KUN,KNUL,ISTAT)
      IDEGRE = FPARM(2)
      IDERIV = FPARM(3)
      IF (IDEGRE.LT.1 .OR. IDEGRE.GT.5) THEN
          CALL STTPUT(' Degree parameter out of range',ISTAT)
          GO TO 10
      END IF
C
C ... get parameters form reference image
C
      IREF = -1
      CALL STFOPN(REFIMA,D_R4_FORMAT,0,F_IMA_TYPE,IREF,ISTAT)
      CALL STDRDI(IREF,'NAXIS',1,1,NN,NAXISO,KUN,KNUL,ISTAT)
      CALL STDRDI(IREF,'NPIX', 1,NAXISO,NN,NPIXO,KUN,KNUL,ISTAT)
      CALL STDRDD(IREF,'START',1,NAXISO,NN,STARTO,KUN,KNUL,ISTAT)
      CALL STDRDD(IREF,'STEP',1,NAXISO,NN,STEPO,KUN,KNUL,ISTAT)
      CALL STDRDC(IREF,'IDENT',1,1,72,NN,IDENTO,KUN,KNUL,ISTAT)
      CALL STDRDC(IREF,'CUNIT',1,1,80,NN,CUNITO,KUN,KNUL,ISTAT)
      IF (NAXISO.GT.1 .AND. NPIXO(2).GT.1) THEN
          CALL STTPUT(' Only 1D images are considered ...',ISTAT)
          CALL STFCLO(IREF,ISTAT)
          GO TO 20
      ELSE
          NPIXO(2) = 1
          NDIMO  = 1
      END IF
      CALL STFCLO(IREF,ISTAT)
C
C ... get input image
C
      CALL STIGET(INPIMA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     .     2,NAXISI,NPIXI,STARTI,STEPI,IDENTI,CUNITI,IPNTR,IMNO,ISTAT)
      IF (NAXISI.GT.1 .AND. NPIXI(2).GT.1) THEN
          CALL STTPUT(' Only 1-D images are considered.',ISTAT)
          GO TO 10
      ELSE
          NPIXI(2) = 1
          NDIMI  = 1
      END IF
C
C ... map output image
C
      CALL STIPUT(OUTIMA,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .     NDIMO,NPIXO,STARTO,STEPO,IDENTO,CUNITO,JPNTR,IMOUT,ISTAT)
C
C ... fill the arrays XI,WI
C
      NI     = NPIXI(1)  !   XI
      NBY    = 4*NI
      CALL TDMGET(NBY,IP1,IS)
      CALL TDMGET(NBY,IP2,IS)
      CALL TDMGET(NBY*6,IPQ,IS)
      X0     = STARTI(1)
      WX     = STEPI(1)
      X1     = X0 + (NI-1)*WX
      CALL IMVAL1(NI,X0,WX,MADRID(IP1),MADRID(IP2),MADRID(IPNTR),RMIN,
     +             RMAX)
C
C ... setup parameters
C
      DELTA  = RMAX - RMIN
      S      = DELTA* (DELTA*0.5+RMIN)*FPARM(1)*0.01
C S       = FPARM(1)
      S = ABS(S)
      IDEGRE = FPARM(2)
      IDERIV = FPARM(3)
C
C ... compute spline coeffs
C
      WRITE (KBUF,12345) S
      CALL STTPUT(KBUF,ISTAT)
      CALL SMOOT(MADRID(IP1),MADRID(IPNTR),MADRID(IP2),MADRID(IPQ),
     +           NI,X0,X1,IDEGRE,
     +           S,NK,T,C,FP,0,IERR,NRDATA,FP0,FPOLD,NPLUS)
      IF (IERR.EQ.-2) CALL STTPUT('Polynomial approximation',ISTAT)
      IF (IERR.EQ.1) THEN
          CALL STTPUT('Local storage exceeded (S too small)',ISTAT)
          GO TO 10
      END IF
      IF (IERR.EQ.2) THEN
          CALL STTPUT('Tolerance parameter too small',ISTAT)
          GO TO 10
      END IF
      IF (IERR.EQ.3) THEN
          CALL STTPUT('Maximum number of iter. exceeded',ISTAT)
          GO TO 10
      END IF
      IF (IERR.EQ.10) THEN
          CALL STTPUT('Invalid input arguments',ISTAT)
          GO TO 10
      END IF
      NO     = NPIXO(1)
      X0     = STARTO(1)
      WX     = STEPO(1)
C
C ... compute interpolated values
C
      CALL COMPIM(NO,X0,WX,MADRID(JPNTR),NK,IDEGRE,IDERIV,T,C,RMIN,RMAX)
C
C ... write cuts
C
      CUTS(1) = RMIN
      CUTS(2) = RMAX
      CUTS(3) = RMIN
      CUTS(4) = RMAX
      CALL STDWRR(IMOUT,'LHCUTS',CUTS,1,4,KUN,ISTAT)
      CALL DSCUPT(IMOUT,IMOUT,' ',ISTAT)
C
C ... free memory
C
      CALL TDMFRE(NBY,IP1,IS)
      CALL TDMFRE(NBY,IP2,IS)
      CALL TDMFRE(NBY*6,IPQ,IS)
C
C ... end
C
      CALL STFCLO(IMOUT,ISTAT)
   10 CALL STFCLO(IMNO, ISTAT)
   20 RETURN
C 
12345 FORMAT('S = ',F12.6)
      END

      SUBROUTINE TDINIT
      IMPLICIT NONE
      INTEGER     NFPAR
      PARAMETER  (NFPAR = 3)
C
      INTEGER MADRID
      INTEGER IACT,IC,IDEGRE,IDERIV,IERR,II,NBY, TID
      INTEGER*8   IP1,IP2,IPQ,IPNTR
      INTEGER IS,ISTAT,JSTAT,NAXIS
      INTEGER NCOL,NDIM,NI,NK,NPLUS,NROW,NSC,NAC,NAR
      INTEGER INDEX,IMNO
      INTEGER NFPACT,KUN,KNUL
      INTEGER ICOL(3),NPIX(3)
      INTEGER NRDATA(1000)
C
      REAL DELTA,FP,FP0,FPOLD,S,X1
      REAL RMIN,RMAX
      REAL FPARM(NFPAR),X0,WX
      REAL T(1000),C(1000)
C
      DOUBLE PRECISION START(3), STEP(3)
C
      CHARACTER*60 TABLE,IMAGE
      CHARACTER*16 MSG
      CHARACTER*17 COLREF(3),LABEL
      CHARACTER*53 OCOLS
      CHARACTER*72 IDENT
      CHARACTER*80 CUNIT
      CHARACTER   KBUF*40
C
      INCLUDE 'MID_INCLUDE:TABLES.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:TABLED.INC'
C
      DATA MSG/'ERR:REBISTBxxx'/
      DATA TABLE/'  '/
      DATA IMAGE/'  '/
C
C ... get input parameters
C
      CALL STKRDC('OUT_A',1,1,60,IACT,TABLE,KUN,KNUL,ISTAT)
      CALL STKRDC('COLO',1,1,53,IACT,OCOLS,KUN,KNUL,ISTAT)
      CALL STKRDC('IN_A',1,1,60,IACT,IMAGE,KUN,KNUL,ISTAT)
      CALL STKRDR('INPUTR',1,NFPAR,NFPACT,FPARM,KUN,KNUL,ISTAT)
      IDEGRE = FPARM(2)
      IDERIV = FPARM(3)
      IF (IDEGRE.LT.1 .OR. IDEGRE.GT.5) THEN
          CALL STTPUT('Parameter degree out of range',ISTAT)
          GO TO 20
      END IF
C
C ... sort out ind., dep. (and bin) variables
C
      II     = INDEX(OCOLS,',')
      IF (II.EQ.0) THEN
          WRITE (*,*) ' Specification of relevant input',
     +      ' table cols insufficient'
          RETURN
      ELSE
          COLREF(1) = OCOLS(1:II-1)
          COLREF(2) = OCOLS(II+1:)
      END IF
C
C ... access input/output table
C
      TID = -1
      CALL TBTOPN(TABLE,F_U_MODE,TID,ISTAT)
      IF (ISTAT.NE.0) GO TO 20
      CALL TBIGET(TID,NCOL,NROW,NSC,NAC,NAR,ISTAT)
      IF (ISTAT.NE.0) GO TO 20
C
C ... find input column
C
      CALL TBCSER(TID,COLREF(1),ICOL(1),ISTAT)
      IF (ICOL(1).EQ.-1) THEN
          CALL STTPUT('Error in column reference',IS)
          GO TO 20
      END IF
C
C ... get input image
C
      CALL STIGET(IMAGE,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     .     2,NAXIS,NPIX,START,STEP,IDENT,CUNIT,IPNTR,IMNO,ISTAT)
      IF (NAXIS.GT.1 .AND. NPIX(2).GT.1) THEN
          CALL STTPUT(' Only 1-dim images are considered.',ISTAT)
          GO TO 20
      ELSE
          NPIX(2) = 1
          NDIM   = 1
      END IF
C
C image input, then fill the XO and WO arrays OF INTERPOLn
C
      NI     = NPIX(1)
      NBY    = 4*NI
      CALL TDMGET(NBY,IP1,IS)
      CALL TDMGET(NBY,IP2,IS)
      CALL TDMGET(NBY*6,IPQ,IS)
      X0     = START(1)
      WX     = STEP(1)
      X1     = X0 + (NI-1)*WX
      CALL IMVAL1(NI,X0,WX,MADRID(IP1),MADRID(IP2),MADRID(IPNTR),RMIN,
     +             RMAX)
C
C setup parameters
C
      DELTA  = RMAX - RMIN
      S      = DELTA*(DELTA*0.5+RMIN)*FPARM(1)*0.01
      S = ABS(S)
C
C ... compute spline coeffs
C
      WRITE (KBUF,12345) S
      CALL STTPUT(KBUF,ISTAT)
      CALL SMOOT(MADRID(IP1),MADRID(IPNTR),MADRID(IP2),MADRID(IPQ),
     +           NI,X0,X1,IDEGRE,
     +           S,NK,T,C,FP,0,IERR,NRDATA,FP0,FPOLD,NPLUS)
      IF (IERR.EQ.-2) CALL STTPUT('Polynomial approximation',ISTAT)
      IF (IERR.EQ.1) THEN
          CALL STTPUT('Local storage exceeded (S too small)',ISTAT)
          GO TO 20
      END IF
      IF (IERR.EQ.2) THEN
          CALL STTPUT('Tolerance parameter too small',ISTAT)
          GO TO 20
      END IF
      IF (IERR.EQ.3) THEN
          CALL STTPUT('Maximum number of iter. exceeded',ISTAT)
          GO TO 20
      END IF
      IF (IERR.EQ.10) THEN
          CALL STTPUT('Invalid input arguments',ISTAT)
          GO TO 20
      END IF
C
C ... find if column already exists
C
      CALL TBCSER(TID,COLREF(2),IC,ISTAT)
      IF (IC.EQ.-1) THEN
          LABEL  = COLREF(2) (2:)
          CALL TBCINI(TID,D_R4_FORMAT,1,'E16.8',CUNIT,LABEL,IC,ISTAT)
      END IF
C
C ... compute interpolated values
C
      CALL COMPTA(TID,ICOL(1),IC,NROW,NK,IDEGRE,IDERIV,T,C)
C
      CALL DSCUPT(TID,TID,' ',ISTAT)
      CALL TDMFRE(NBY,IP1,IS)
      CALL TDMFRE(NBY,IP2,IS)
      CALL TDMFRE(NBY*6,IPQ,IS)
C
C ... end
C
      CALL TBTCLO(TID,ISTAT)
   20 IF (ISTAT.NE.0) THEN
          WRITE (MSG(13:16),9000) ISTAT
          CALL TDERRR(ISTAT,MSG,JSTAT)
      END IF
      RETURN
C 
 9000 FORMAT (I4)
12345 FORMAT('S = ',F12.6)
      END

      SUBROUTINE TDINTI
      IMPLICIT NONE
      INTEGER   NFPAR
      PARAMETER (NFPAR = 3)
C
      INTEGER MADRID
      INTEGER I,I1,I2,IACT,IB,IDEGRE,IDERIV, NBY
      INTEGER*8    IP1,IP2,IP3,IPQ,IPNTR
      INTEGER IERR,II,IS,ISTAT
      INTEGER JSTAT,NAXIS,NCOL,NDIM,NI,NK
      INTEGER NN,NO,NPLUS,NROW,NSC,NAC,NAR,TID
      INTEGER INDEX,IMOUT
      INTEGER NFPACT,KUN,KNUL,IREF
      INTEGER ICOL(3),NPIX(3)
      INTEGER NRDATA(1000)
      REAL DELTA,FP,FPO,FPOLD,S,X1
      REAL RMIN,RMAX
      REAL CUTS(4)
      REAL FPARM(NFPAR),X0,WX
      REAL T(1000),C(1000)
      DOUBLE PRECISION START(3), STEP(3)
      CHARACTER*60 TABLE,IMAGE,REFIMA
      CHARACTER*16 MSG
      CHARACTER*17 COLREF(3)
      CHARACTER*53 INCOLS
      CHARACTER*60 WORK
      CHARACTER*72 IDENT
      CHARACTER*80 CUNIT
      CHARACTER    KBUF*40
C
      INCLUDE  'MID_INCLUDE:TABLES.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE  'MID_INCLUDE:TABLED.INC'
C
      DATA MSG/'ERR:REBISTBxxx'/
      DATA TABLE/'  '/
      DATA IMAGE/'  '/
      DATA REFIMA/'  '/
C
C ... get input parameters
C
      CALL STKRDC('OUT_A',1,1,60,IACT,IMAGE,KUN,KNUL,ISTAT)
      CALL STKRDC('IN_A',1,1,60,IACT,TABLE,KUN,KNUL,ISTAT)
      CALL STKRDC('COLI',1,1,53,IACT,INCOLS,KUN,KNUL,ISTAT)
      CALL STKRDC('IN_B',1,1,60,IACT,REFIMA,KUN,KNUL,ISTAT)
      CALL STKRDR('INPUTR',1,NFPAR,NFPACT,FPARM,KUN,KNUL,ISTAT)
      IDEGRE = FPARM(2)
      IDERIV = FPARM(3)
      IF (IDEGRE.LT.1 .OR. IDEGRE.GT.5) THEN
          CALL STTPUT('Parameter degree out of range',ISTAT)
          GO TO 30
      END IF
C
C ... get parameters from reference image
C
      IREF = -1
      CALL STFOPN(REFIMA,D_R4_FORMAT,0,F_IMA_TYPE,IREF,ISTAT)
      CALL STDRDI(IREF,'NAXIS',1,1,NN,NAXIS,KUN,KNUL,ISTAT)
      CALL STDRDI(IREF,'NPIX', 1,NAXIS,NN,NPIX,KUN,KNUL,ISTAT)
      CALL STDRDD(IREF,'START',1,NAXIS,NN,START,KUN,KNUL,ISTAT)
      CALL STDRDD(IREF,'STEP',1,NAXIS,NN,STEP,KUN,KNUL,ISTAT)
      CALL STDRDC(IREF,'IDENT',1,1,72,NN,IDENT,KUN,KNUL,ISTAT)
      CALL STDRDC(IREF,'CUNIT',1,1,80,NN,CUNIT,KUN,KNUL,ISTAT)
      IF (NAXIS.GT.1 .AND. NPIX(2).GT.1) THEN
          CALL STTPUT(' Only 1D images are considered ...',ISTAT)
          CALL STFCLO(IREF,ISTAT)
          GO TO 30
      ELSE
          NPIX(2) = 1
          NDIM   = 1
      END IF
      CALL STFCLO(IREF,ISTAT)
C
C ... sort out ind., dep. (and bin) variables
C
      II     = INDEX(INCOLS,',')
      IF (II.EQ.0) THEN
          WRITE (*,*) ' Specification of relevant input',
     +      ' table cols insufficient'
          RETURN
      ELSE
          COLREF(1) = INCOLS(1:II-1)
          COLREF(2) = INCOLS(II+1:)
      END IF
C
C ... init input table
C
      TID = -1
      CALL TBTOPN(TABLE,F_I_MODE,TID,ISTAT)
      IF (ISTAT.NE.0) GO TO 30
      CALL TBIGET(TID,NCOL,NROW,NSC,NAC,NAR,ISTAT)
      IF (ISTAT.NE.0) GO TO 30
C
C ... find input column
C
      IB     = 2
      DO 10 I = 1,IB
          CALL TBCSER(TID,COLREF(I),ICOL(I),ISTAT)
          IF (ICOL(I).EQ.-1) THEN
              CALL STTPUT('Error in column reference',IS)
              GO TO 30
          END IF
C
C ... copy units from table into output image
C
          IF (I.LE.2) THEN
              CALL TBUGET(TID,ICOL(I),WORK,ISTAT)
              I1     = (I-1)*16 + 1
              I2     = I1 + 15
              CUNIT(I1:I2) = WORK(1:16)
          END IF
   10 CONTINUE
C
C ... copy selected values of the table into work space
C  !   indep
      NBY    = 4*NROW
      CALL TDMGET(NBY,IP1,IS)
      CALL TDMGET(NBY,IP2,IS)
      CALL TDMGET(NBY,IP3,IS)
      CALL TDMGET(NBY*6,IPQ,IS)
      CALL BCOPYT(TID,ICOL(1),ICOL(2),NROW,
     +            MADRID(IP1),MADRID(IP2),MADRID(IP3),
     +            NI,RMIN,RMAX,X0,X1)
      IF (NI.LE.3) THEN
          CALL STTPUT(' Not enough points in table ',ISTAT)
          GO TO 20
      END IF
C
C ... map image
C
      CUNIT(1:16) = 'FLUX'
      I2 = INDEX(TABLE,' ')
      IF (I2.lt.1) I2 = LEN(TABLE)
      IDENT  = 'TABLE: '//TABLE(1:I2)//'COLS. :'//COLREF(1)//COLREF(2)
      CALL STIPUT(IMAGE,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .     NDIM,NPIX,START,STEP,IDENT,CUNIT,IPNTR,IMOUT,ISTAT)
C
C setup parameters
C
      DELTA  = RMAX - RMIN
      S      = DELTA* (DELTA*0.5+RMIN)*FPARM(1)*0.01
      S      = ABS(S)
C
C compute spline coeffs.
C
      WRITE (KBUF,12345) S
      CALL STTPUT(KBUF,ISTAT)
      CALL SMOOT(MADRID(IP1),MADRID(IP2),MADRID(IP3),MADRID(IPQ),
     +           NI,X0,X1,IDEGRE,S,
     +           NK,T,C,FP,0,IERR,NRDATA,FPO,FPOLD,NPLUS)
      IF (IERR.EQ.-2) CALL STTPUT('Polynomial approximation',ISTAT)
      IF (IERR.EQ.1) THEN
          CALL STTPUT('Local storage exceeded (S too small)',ISTAT)
          GO TO 30
      END IF
      IF (IERR.EQ.2) THEN
          CALL STTPUT('Tolerance parameter too small',ISTAT)
          GO TO 30
      END IF
      IF (IERR.EQ.3) THEN
          CALL STTPUT('Maximum number of iter. exceeded',ISTAT)
          GO TO 30
      END IF
      IF (IERR.EQ.10) THEN
          CALL STTPUT('Invalid input arguments',ISTAT)
          GO TO 30
      END IF
C
C image output, then fill the XO and WO arrays OF INTERPOLn
C
      NO     = NPIX(1)
      X0     = START(1)
      WX     = STEP(1)
      X1     = X0 + (NO-1)*WX
      CALL COMPIM(NO,X0,WX,MADRID(IPNTR),NK,IDEGRE,IDERIV,T,C,RMIN,RMAX)
C
C ... write cuts
C
      CUTS(1) = RMIN
      CUTS(2) = RMAX
      CUTS(3) = RMIN
      CUTS(4) = RMAX
      CALL STDWRR(IMOUT,'LHCUTS',CUTS,1,4,KUN,ISTAT)
      CALL DSCUPT(IMOUT,IMOUT,' ',ISTAT)
C
C ... free memory
C
C
   20 CONTINUE
      CALL TDMFRE(NBY,IP1,IS)
      CALL TDMFRE(NBY,IP2,IS)
      CALL TDMFRE(NBY,IP3,IS)
      CALL TDMFRE(NBY*6,IPQ,IS) 
C
C ... end
C
      CALL TBTCLO(TID,ISTAT)
   30 IF (ISTAT.NE.0) THEN
          WRITE (MSG(13:16),9000) ISTAT
          CALL TDERRR(ISTAT,MSG,JSTAT)
      END IF
      RETURN
C 
 9000 FORMAT (I4)
12345 FORMAT('S = ',F12.6)
      END

      SUBROUTINE TDINTT
      IMPLICIT NONE
      INTEGER   NFPAR
      PARAMETER (NFPAR = 3)
C
      INTEGER MADRID
      INTEGER I,IACT,IB,IC,IDEGRE,IDERIV,IERR,II
      INTEGER ISTAT,JSTAT,NBY
      INTEGER NCO,NCOL,NI,NK,NPLUS,NRO,NROW,NSC
      INTEGER TID1,TID2,NAC,NAR,INDEX
      INTEGER NFPACT,KUN,KNUL
      INTEGER ICOL(3),OCOL(3)
      INTEGER NRDATA(1000)
C 
      INTEGER*8  IP1,IP2,IP3,IPQ
C 
      REAL DELTA,FP,FP0,FPOLD
      REAL RMAX,RMIN,S,X0,X1
      REAL FPARM(NFPAR)
      REAL T(1000),C(1000)
C 
      CHARACTER*60 TABIN,TABOUT
      CHARACTER*16 MSG
      CHARACTER*17 COLRFI(3),COLRFO(3),LABEL
      CHARACTER*53 INCOLS,OUTCLS
      CHARACTER*80 CUNIT
      CHARACTER    KBUF*40
C
      INCLUDE 'MID_INCLUDE:TABLES.INC'
      COMMON/VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:TABLED.INC'
C
      DATA MSG/'ERR:REBISTBxxx'/
      DATA TABIN/'  '/
      DATA TABOUT/'  '/
C
C ... get input parameters
C
      CALL STKRDC('OUT_A',1,1,60,IACT,TABOUT,KUN,KNUL,ISTAT)
      CALL STKRDC('COLO',1,1,53,IACT,OUTCLS,KUN,KNUL,ISTAT)
      CALL STKRDC('IN_A',1,1,60,IACT,TABIN,KUN,KNUL,ISTAT)
      CALL STKRDC('COLI',1,1,53,IACT,INCOLS,KUN,KNUL,ISTAT)
      CALL STKRDR('INPUTR',1,NFPAR,NFPACT,FPARM,KUN,KNUL,ISTAT)
      IDEGRE = FPARM(2)
      IDERIV = FPARM(3)
      IF (IDEGRE.LT.1 .OR. IDEGRE.GT.5) THEN
          CALL STTPUT('Parameter degree out of range',ISTAT)
          GO TO 30
      END IF
C
C ... sort out ind., dep. (and bin) variables
C
      II     = INDEX(INCOLS,',')
      IF (II.EQ.0) THEN
          WRITE (*,*) ' Specification of relevant input',
     +      ' table cols insufficient'
          RETURN
      ELSE
          COLRFI(1) = INCOLS(1:II-1)
          COLRFI(2) = INCOLS(II+1:)
      END IF
C
C ... init input table
C
      TID1 = -1
      CALL TBTOPN(TABIN,F_I_MODE,TID1,ISTAT)
      IF (ISTAT.NE.0) GO TO 30
      CALL TBIGET(TID1,NCOL,NROW,NSC,NAC,NAR,ISTAT)
      IF (ISTAT.NE.0) GO TO 30
C
C ... find input column
C
      IB     = 2
      DO 10 I = 1,IB
          CALL TBCSER(TID1,COLRFI(I),ICOL(I),ISTAT)
          IF (ICOL(I).EQ.-1) THEN
              CALL STTPUT('Error in column reference',ISTAT)
              GO TO 30
          END IF
   10 CONTINUE
C
C ... copy selected values of the table into work space
C
      NBY    = 4*NROW
      CALL TDMGET(NBY,IP1,ISTAT)
      CALL TDMGET(NBY,IP2,ISTAT)
      CALL TDMGET(NBY,IP3,ISTAT)
      CALL TDMGET(NBY*6,IPQ,ISTAT)
      CALL BCOPYT(TID1,ICOL(1),ICOL(2),NROW,
     +            MADRID(IP1),MADRID(IP2),MADRID(IP3),
     +            NI,RMIN,RMAX,X0,X1)
      IF (NI.LE.3) THEN
          CALL STTPUT(' Not enough points in table ',ISTAT)
          GO TO 20
      END IF
C
C ... sort out ind., dep. (and bin) variables for output table
C
      II     = INDEX(OUTCLS,',')
      IF (II.EQ.0) THEN
          WRITE (*,*) ' Specification of relevant output',
     +      ' table cols insufficient'
          RETURN
      ELSE
          COLRFO(1) = OUTCLS(1:II-1)
          COLRFO(2) = OUTCLS(II+1:)
      END IF
C
C ... access output table
C
      TID2 = -1
      CALL TBTOPN(TABOUT,F_U_MODE,TID2,ISTAT)
      IF (ISTAT.NE.0) GO TO 30
      CALL TBIGET(TID2,NCO,NRO,NSC,NAC,NAR,ISTAT)
      IF (ISTAT.NE.0) GO TO 30
C
C ... find output column
C
      CALL TBCSER(TID2,COLRFO(1),OCOL(1),ISTAT)
      IF (OCOL(1).EQ.-1) THEN
          CALL STTPUT('Error in column reference',ISTAT)
          GO TO 30
      END IF
C
      CALL TBCSER(TID2,COLRFO(2),IC,ISTAT)
      IF (IC.EQ.-1) THEN
          LABEL  = COLRFO(2) (2:)
          CUNIT  = '  '
          CALL TBCINI(TID2,D_R4_FORMAT,1,'E16.8',
     .                CUNIT,LABEL,IC,ISTAT)
      END IF
C
C ... setup parameters
C
      DELTA  = RMAX - RMIN
      S      = DELTA* (DELTA*0.5+RMIN)*FPARM(1)*0.01
      S      = ABS(S)
C
C ... compute spline coeffs
C
      WRITE (KBUF,12345) S
      CALL STTPUT(KBUF,ISTAT)
      CALL SMOOT(MADRID(IP1),MADRID(IP2),MADRID(IP3),MADRID(IPQ),
     +            NI,X0,X1,IDEGRE,S,
     +           NK,T,C,FP,0,IERR,NRDATA,FP0,FPOLD,NPLUS)
      IF (IERR.EQ.-2) CALL STTPUT('Polynonial approximation',ISTAT)
      IF (IERR.EQ.1) THEN
          CALL STTPUT('Local storage exceeded (S too small)',ISTAT)
          GO TO 30
      END IF
      IF (IERR.EQ.2) THEN
          CALL STTPUT('Tolerance parameter too small',ISTAT)
          GO TO 30
      END IF
      IF (IERR.EQ.3) THEN
          CALL STTPUT('Maximum number of iter. exceeded',ISTAT)
          GO TO 30
      END IF
      IF (IERR.EQ.10) THEN
          CALL STTPUT('Invalid input arguments',ISTAT)
          GO TO 30
      END IF
C
C ... compute interpolated values
C
      CALL COMPTA(TID2,OCOL(1),IC,NRO,NK,IDEGRE,IDERIV,T,C)
C
C ... end
C
      CALL TBTCLO(TID1,ISTAT)
C
C ... free memory
C
C
   20 CONTINUE
      CALL TDMFRE(NBY,IP1,ISTAT)
      CALL TDMFRE(NBY,IP2,ISTAT)
      CALL TDMFRE(NBY,IP3,ISTAT)
      CALL TDMFRE(NBY*6,IPQ,ISTAT)
C
C ... end
C
      CALL DSCUPT(TID2,TID2,' ',ISTAT)
      CALL TBTCLO(TID2,ISTAT)
   30 IF (ISTAT.NE.0) THEN
          WRITE (MSG(13:16),9000) ISTAT
          CALL TDERRR(ISTAT,MSG,JSTAT)
      END IF
      RETURN
C 
 9000 FORMAT (I4)
12345 FORMAT('S = ',F12.6)
      END

      SUBROUTINE IMVAL1(NP,XS,WS,X,W,Y,YMIN,YMAX)
C
C  Subroutine IMVAL1
C
C
C  Fill arrays X,W for image world coordinates and pixel size data
C
      IMPLICIT NONE
      INTEGER  NP, I
      REAL     WS, XS, YMIN, YMAX
      REAL X(NP),W(NP),Y(NP)
C
      YMIN   = Y(1)
      YMAX   = Y(1)
      DO 10 I = 1,NP
          X(I)   = XS + WS* (I-1)
          W(I)   = 1.
          YMIN   = AMIN1(YMIN,Y(I))
          YMAX   = AMAX1(YMAX,Y(I))
   10 CONTINUE
      RETURN
      END

      SUBROUTINE COMPTA(TID,IX,IY,NROW,NK,IDEGRE,IDERIV,T,C)
C
      IMPLICIT NONE
C
      INTEGER   NROW, IDEGRE, IDERIV, IX, IY, NK, TID
      REAL X, Y
      REAL T(1),C(1)
C
      INTEGER I, LD, NK1, STATUS
      REAL    DERIV
      LOGICAL ISEL, INULL
C
      LD     = IDEGRE + 1
      NK1    = NK - IDEGRE - 1
C
      DO 30 I = 1,NROW
         CALL TBSGET(TID, I, ISEL, STATUS)
          IF (ISEL) THEN
              CALL TBERDR(TID, I, IX, X, INULL, STATUS)
              IF (.NOT.INULL) THEN
   10             IF ((X.LT.T(LD+1)) .OR. (LD.EQ.NK1)) GO TO 20
                  LD     = LD + 1
                  GO TO 10
   20             Y   = DERIV(T,NK,C,NK1,IDERIV,X,LD)
                  CALL TBEWRR(TID, I, IY, Y, STATUS)
              ELSE
                  CALL TBEDEL(TID, I, IY, STATUS)
              END IF
          END IF
   30 CONTINUE
      RETURN
      END

      SUBROUTINE COMPIM(NO,X0,WX,Y,NK,IDEGRE,IDERIV,T,C,RMIN,RMAX)
C
C COMPUTE INTERPOLATED VALUES
      IMPLICIT NONE
C
      INTEGER NO, IDEGRE, IDERIV, NK
      REAL Y(NO),T(1),C(1)
C
      INTEGER    LD, I, NK1
      REAL       XP, X0, WX, RMIN, RMAX
      REAL       DERIV
C
      LD     = IDEGRE + 1
      NK1    = NK - IDEGRE - 1
      DO 30 I = 1,NO
          XP     = X0 + (I-1)*WX
   10     IF ((XP.LT.T(LD+1)) .OR. (LD.EQ.NK1)) GO TO 20
          LD     = LD + 1
          GO TO 10
   20     Y(I)   = DERIV(T,NK,C,NK1,IDERIV,XP,LD)
          IF (I.EQ.1) THEN
              RMIN   = Y(1)
              RMAX   = Y(1)
          ELSE
              RMIN   = AMIN1(RMIN,Y(I))
              RMAX   = AMAX1(RMAX,Y(I))
          END IF
   30 CONTINUE
      RETURN
      END
 
      SUBROUTINE BCOPYT(TID,IX,IY,NROW,X1,Y1,W1,N1,RMIN,RMAX,XS,XE)
C
C COPY TABLE VALUES
C
      IMPLICIT NONE
      INTEGER  NROW, IX, IY
      REAL X,Y
      REAL X1(NROW),Y1(NROW),W1(NROW)
      REAL RMIN, RMAX, XS, XE
C
      INTEGER N1, I, STATUS, TID
      LOGICAL ISEL, INULL1, INULL2
C
      N1     = 0
      DO 10 I = 1,NROW
          CALL TBSGET(TID, I, ISEL, STATUS)
          CALL TBERDR(TID, I, IX, X, INULL1, STATUS)
          CALL TBERDR(TID, I, IY, Y, INULL2, STATUS)
          IF (ISEL.AND.(.NOT.INULL1).AND.(.NOT.INULL2)) THEN
              N1     = N1 + 1
              X1(N1) = X
              Y1(N1) = Y
              W1(N1) = 1.
              IF (N1.EQ.1) THEN
                  RMIN   = Y1(1)
                  RMAX   = Y1(1)
                  XS     = X1(1)
              ELSE
                  RMIN   = AMIN1(RMIN,Y1(N1))
                  RMAX   = AMAX1(RMAX,Y1(N1))
                  XE     = X1(N1)
              END IF
          END IF
   10 CONTINUE
      RETURN
      END

C @(#)gd8i2.for	19.1 (ES0-DMD) 02/25/03 13:55:08
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
	SUBROUTINE GD8041(DISPLAY,LOCNO,JX,JY,IDST)
C	
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine IIIGLD		version 1.00	880505
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  IDI Locator = joystick, trackball
C
C.PURPOSE
C  fulfill the requirements as described in the IDI document
C
C.ALGORITHM
C  distinguish between joystick + trackball,
C  and use DeAnza level-0 software
C
C.INPUT/OUTPUT
C  call as IIIGLD(DISPLAY,LOCNO,JX,JY,IDST)
C
C  input par:
C  DISPLAY:	I*4		display id.
C  LOCNO:	I*4		locator number
C  JX:		I*4		x-displacement
C  JY:		I*4		y-displacement
C	
C  output par:
C  IDST:	I*4		return status
C	
C.VERSIONS
C
C--------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,LOCNO,JX,JY,IDST
	INTEGER*4	N1,N
C		
	INTEGER*2	UNIT,CONTROL
	INTEGER*2	RPR
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
	INCLUDE	'MID_INCLUDE:IDIDEV.INC'
C	
	EXTERNAL	RPR
C
C  get unit
	UNIT = DISPLAY
C	
C  for trackball we do the stuff in a separate subroutine
	IF (QJOYFL.EQ.1) THEN
	   CALL TRKRD(UNIT,JX,JY)
	ELSE
C
C  get joystick displacement register (reg. 3)  from the Deanza
	   CALL IP8QW(RPR,UNIT,DZIOSB,,,CONTROL,2,0,3)
	   JX = IAND(CONTROL,"377) - 128
	   JY = ISHFT(CONTROL,-8) - 128
	ENDIF
C	
C  allright then...
	IDST = 0
	RETURN
	END

	SUBROUTINE GD8044(DISPLAY,EVAL,JJ,IDST)
C 
	IMPLICIT NONE
C 
	INTEGER*4	DISPLAY,EVAL,JJ,IDST
C 
	JJ = 1
	IDST = 0
C 
	RETURN
	END

	SUBROUTINE GD8045(DISPLAY,EVAL,OUTSTR,JJ,IDST)
C 
	IMPLICIT NONE
C 
	INTEGER*4	DISPLAY,EVAL,JJ,IDST
C 
	CHARACTER*(*)   OUTSTR
C 
	JJ = LEN(OUTSTR)
        OUTSTR(1:) = ' '
	READ(*,10000) OUTSTR
	IDST = 0
	RETURN
C 
10000   FORMAT(A)
	END

C @(#)nosci.for	19.1 (ES0-DMD) 02/25/03 14:36:00
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
c	"nosci" and "noscf" are nosc routines which
c	write run timing results to file "{directory_name}results"
c	in the current directory.  The environment
c	file "../environ",  containing the compiler
c	names and options, is copied to "*results",
c	along with any local "environ" file.  This local
c	"environ" defines info unique to the individual
c	benchmark , e.g. hspice.  The current date and 
c	wall clock time is also written to "*results".
c	The Timings are then referenced to our "baseline" machine.
c
c	The "*results" file is always appended to which
c	gives a benchmark history for this benchmark
c	using different compiler options.
c
c
c	"iu" is unit to use when writing to "*results".
c	Unit "iu+1" is also used to read in "environ" and "baseline" 
c	files.
c
c	Usage: call nosci(iu)		Initalize "results" file.
c	       call noscf()		Finalize "results".
c


	subroutine nosci(iu)
c	  This should be the 1st thing the program does!
c	  set up file "results" and initialize timing

	character*24 fdate
	character*10 envir
	character line*80,path*80
	character *16 group,name
	character *25 results
	real t1(2),t2(2)
	external fdate
	save iout,t1,group
	iout=iu
c
c	get directory name
	call getcwd(path)
	i=1
c	strip path name from directory
	last=index(path,' ')-1
	do 40 j=1,6
	  ii=index(path(i:last),'/')
	  if(ii.lt.1)go to 45
	  i=i+ii
40	continue
45	continue
	results=path(i:last)//'results'
c
c	open the 'results' file and position to end of file.
c	if file not there, create it.
c
	
	open(iout,file=results,status='old',err=20)
c	file exists - position to end of file
5	read(iout,*,end=30,err=5) line(1:1)
	go to 5
c	'results' doesn't exist - open new file
20	open(iout,file=results,status='new',err=300)
	call chmod(results,'ugo+rw')
30	continue
	write(iout,*)'*********************************'
	write(iout,*)path(i:last),'  ',fdate()
	group=path(i:last)
	in=iout + 1
c	copy "../environ" and "./environ" (if one exists)
c	files to "./*results" file
	envir = 'environ'
	ie = 1
	do 55 i=1,2
	  open(in,file=envir(ie:10),status='old',err=55)
47	  read(in,49,end=50)line
49	  format(a80)
	  write(iout,*)line
	  go to 47
50	  close(in,err=65)
55	  ie=4
60	call etime(t1)
65	return
c
c
c	****************** NOSCF ***********************	
	entry noscf()
c	This should be the last thing the program does!
c	get elapsed time for run and write to "*results"
	call etime(t2)
	u=t2(1)-t1(1)
	s=t2(2)-t1(2)
	t=u+s
	write(iout,*)'Total elapsed time (sec) =',t,' system  ='
     *  ,s,' user =',u
c
c	***********************************************
c	reference to baseline   '../baseline'
	in=iout+1
	open (in,file='../baseline',status='old',err=90)
80	read(in,*,end=90,err=90)name,bt,bs,bu
	if (name.ne.group)go to 80
	bt1=0.
	bs1=0.
	bu1=0.
	if(t.ne.0.) bt1=bt/t
	if(s.ne.0.) bs1=bs/s
	if(u.ne.0.) bu1=bu/u
	write(iout,*)'BASELINED   total =',bt1,'  system =',bs1,
     1	             '  user =',bu1
90	return

c	  Come here on errors!
300	continue
c	call perror('nosci error')
	end

C @(#)ftdodo.for	19.1 (ES0-DMD) 02/25/03 13:17:34
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE FTDODO(NITER,RELAX,CHISQ,V1,V2,NACT,ACTCH,ISTAT)               
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                   
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  17:25 - 13 JAN 1988                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.PONZ                                                              
C                                                                               
C.IDENTIFICATION                                                                
C                                                                               
C  FITLIB.FOR   VERSION 1.0  27 MAR 1984                                        
C                                                                               
C.PURPOSE                                                                       
C                                                                               
C  INTERFACE ROUTINES FOR THE FITTING STRUCTURES                                
C                                                                               
C ITERATE ON THE FITTING PROCESS                                                
C THE ITERATION IS FINISHED IF                                                  
C - NITER IS REACHED OR                                                         
C - CHISQ IS REACHED                                                            
C - CONVERGENCE IS ACHIEVED                                                     
C.ALGORITHM                                                                     
C                                                                               
C  USE MIDAS I/O INTERFACES TO FRAMES AND TABLES                                
C                                                                               
C.KEYWORDS                                                                      
C                                                                               
C  NON LINEAR FITTING                                                           
C                                                                               
C                                                                               
C----------------------------------------------------------------               
C                                                                               
C                                                                               
C      IMPLICIT NONE                                                            
C INPUT PARAMETERS                                                              
C NITER INTG NO. OF ITERATIONS TO BE DONE                                       
C RELAX REAL RELAXATION FACTOR                                                  
C CHISQ REAL CHI SQUARE                                                         
C V1,V2 REAL OPTIONAL FITTING INTERVAL (IF V1.NE.V2)                            
C                                                                               
C OUTPUT PARAMETERS                                                             
C NACT INTG ACTUAL NUMBER OF ITERATIONS                                         
C ACTCH REAL ACTUAL CHI SQ.                                                     
C ISTAT INTG STATUS RETURN                                                      
C                                                                               
      LOGICAL NAG                                                               
      INTEGER MADRID(1)
      INTEGER KUN,KNUL,NITER,ISTAT,STATUS,NACT,K
      REAL RELAX,CHISQ,V1,V2,ACTCH
      CHARACTER*8 KEYMM                                                         
      CHARACTER*12 FZMETHOD                                                   
       INCLUDE 'MID_INCLUDE:FITI.INC/NOLIST'                                     
       INCLUDE 'MID_INCLUDE:FITC.INC/NOLIST'                                     
      COMMON/VMR/MADRID
      DATA KEYMM/'FITCHAR'/                                                     
C                                                                               
C BRANCH ON IMAGE OR TABULAR DATA                                               
C                                                                               
      CALL STKRDC(KEYMM,1,FZIMET,6,K,FZMETHOD,KUN,KNUL,STATUS)                           
C      CALL SXKGET(KEYMM,'C',FZIMET,6,K,FZMETHOD,STATUS)                           
      CALL FORUPC(FZMETHOD,FZMETHOD)
      NAG    = (FZMETHOD(1:5).EQ.'CGNND') .OR.                                
     +         (FZMETHOD(1:2).EQ.'QN') .OR. (FZMETHOD(1:3).EQ.'MGN')        
      IF ((.NOT.NAG) .AND. (FZMETHOD(1:2).NE.'NR')) 
     .    CALL STETER(3,'FIT : Error in method name')                                         
      IF (NAG) THEN                                                             
          CALL FITNAG(FZMETHOD,ISTAT)                                        
      ELSE                                                                      
          IF (FZTYPE.EQ.'TBL ') THEN                                          
              CALL FTTNTR(NITER,RELAX,CHISQ,V1,V2,NACT,ACTCH,ISTAT)             
          ELSE                                                                  
              CALL FTINTR(MADRID(FZPTRI),MADRID(FZPTRM),FZNPIX(1),        
     +                    FZNPIX(2),FZNPIX(3),NITER,RELAX,CHISQ,V1,         
     +                    V2,NACT,ACTCH,ISTAT)                                  
          END IF                                                                
      END IF                                                                    
      RETURN                                                                    
      END                                                                       

C @(#)intdet.for	19.1 (ES0-DMD) 02/25/03 13:25:35
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.INPUT/OUTPUT
C  Input parameters
C  AVPR     real*4 array        average object profile
C  IAVR     integer*4 array     valid points in AVPR
C  APSF     real*4 array        one dimensional p.s.f.
C  LIM      integer*4           object size
C  Output parameters
C  AVER     real*4              average intensity of 9 central pixels
C-----------------------------------------------------------------------
      SUBROUTINE INTDET(AVPR, IAVR, APSF, LIM, AVER)
C
      IMPLICIT  NONE
C
      INTEGER   LIM
      REAL      AVPR(0:LIM)
      INTEGER   IAVR(0:LIM)
      REAL      APSF(0:LIM)
      REAL      AVER
C
      INTEGER   K
      REAL      TEMP
C
      IF ( IAVR(0) .GT. 0 .AND. IAVR(1) .GT. 0 ) THEN
            AVER = ( AVPR(0) + 8.0 * AVPR(1) ) / 9.0
      ELSE
            AVER = 0.0
            TEMP = ( APSF(0) + 8.0 * APSF(1) ) / 9.0
            K = 0
   10            CONTINUE
               IF ( IAVR(K) .GT. 0 .AND. APSF(K) .GT. 0.0 ) THEN
                  AVER = AVPR(K) * TEMP / APSF(K)
            ELSE IF ( K .LT. LIM ) THEN
                  K = K + 1
                  GOTO 10
            ENDIF
      ENDIF
C
      RETURN
      END

C @(#)smoot.for	19.1 (ES0-DMD) 02/25/03 13:29:45
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE SMOOT (RMAT,NY,NX)
C
C      11.X.88
C
      IMPLICIT  NONE
      INTEGER   NX
      INTEGER   NY
      REAL      RMAT(NY,NX)
      INTEGER   MX1
      INTEGER   MY1
      PARAMETER (MX1=55)
      PARAMETER (MY1=55)
C
      INTEGER   N35, N36
      INTEGER   I, J, L, K, INC, INR
      REAL      SP, S
      REAL      TMT(3,3)
      REAL      RMAT2(MY1,MX1)
C
      DATA      TMT/1.0,1.0,1.0,1.0,2.0,1.0,1.0,1.0,1.0/
C
      N35 = 3
      N36 = N35/2+1
      SP  = 10.
      DO 100 K = N36,NY-N36+1
         INC = K-N36
         DO 110 I = N36,NX-N36+1
            S   = 0.
            INR = I-N36
            DO 120 J = 1,N35
               DO 130 L = 1,N35
                  S = S+RMAT(INR+L,INC+J)*TMT(L,J)
  130          CONTINUE
  120       CONTINUE
            RMAT2(I,K) = S/SP
  110    CONTINUE
  100 CONTINUE
C
      DO 200 K = N36,NY-N36+1
         DO 210 I = N36,NX-N36+1
            RMAT(I,K) = RMAT2(I,K)
  210    CONTINUE
  200 CONTINUE

      RETURN
      END


      REAL FUNCTION GALE2(NPX,NPY,H,SIG,BET,XA,YA,X0,Y0)
C++++++++++
C     CALCOLA L' INTEGRALE BIDIMENSIONALE DI UNA
C     CURVA DI MOFFAT IN UN PIXEL CON IL METODO
C     DI GAUSS-LEGENDRE
C
C     H       = ALTEZZA       CURVA DI MOFFAT
C     SIG     = R               "    "    "
C     BET     = BETA            "    "    "
C     X0 - Y0 = COORD. CENTRO   "    "    "
C     XA - YA = COORD. INIZIALI DI INTEGRAZIONE
C     NPX     = NUMERO DI PUNTI INTERMEDI SULL' ASSE X
C               SU CUI CALCOLARE L' INTEGRALE NUMERICO (MAX=6)
C     NPY     = NUMERO DI PUNTI INTERMEDI SULL' ASSE Y
C               SU CUI CALCOLARE L' INTEGRALE NUMERICO (MAX=6)
C-------------
      IMPLICIT NONE
      INTEGER  NPX
      INTEGER  NPY
      REAL     H
      REAL     SIG
      REAL     BET
      REAL     XA
      REAL     YA
      REAL     X0
      REAL     Y0
C
      REAL     X, Y
      REAL     XB, YB
      REAL     XT, YT
      REAL     VT
      REAL     PSF
      INTEGER  I, J
      REAL     HE(6,6),HX(6,6)
C
      DATA     HX/ 0.0    ,0.0     ,0.0     ,0.0    ,0.0    ,0.0,
     *            -.577350,.577350 ,0.0     ,0.0    ,0.0    ,0.0,
     *            -.774597, 0.     ,.774597 ,0.0    ,0.0    ,0.0,
     *            -.861136,-.339981,.339981 ,.861136,0.0    ,0.0,
     *            -.906179,-.538469,0.      ,.538469,.906179,0.0,
     *            -.932469,-.661209,-.238619,.238619,.661209,.932469/
      DATA     HE/2.    ,0.0    ,0.0    ,0.0    ,0.0    ,0.0,
     *            1.    ,1.     ,0.0    ,0.0    ,0.0    ,0.0,
     *           .555555,.888889,.555555,0.0    ,0.0    ,0.0,
     *           .347855,.652145,.652145,.347855,0.0    ,0.0,
     *           .236927,.478629,.568889,.478629,.236927,0.0,
     *           .171324,.360762,.467914,.467914,.360762,.171324/
C
      PSF(H,X,Y,X0,Y0,SIG,BET) = H*(1+((X-X0)**2+(Y-Y0)**2)
     *                            /SIG**2)**(-BET)
      XB = XA+1
      YB = YA+1
      VT = 0.
C
      DO 10  I = 1,MIN0(6,NPX)
         XT = .5*(HX(I,NPX)+XB+XA)
         DO 20  J = 1,MIN0(6,NPY)
            YT = .5*(HX(J,NPY)+YB+YA)
            VT = VT+HE(I,NPX)*HE(J,NPY)*PSF(H,XT,YT,X0,Y0,SIG,BET)
  20     CONTINUE
  10  CONTINUE
      GALE2 = VT/4.

      RETURN
      END


      REAL FUNCTION GALEG(NPX,NPY,H,SIG,XA,YA,X0,Y0)
C
C     CALCOLA L' INTEGRALE BIDIMENSIONALE DI UNA
C     CURVA DI MOFFAT IN UN PIXEL CON IL METODO
C     DI GAUSS-LEGENDRE
C
C     H       = ALTEZZA       CURVA DI MOFFAT
C     SIG     = R               "    "    "
C     X0 - Y0 = COORD. CENTRO   "    "    "
C     XA - YA = COORD. INIZIALI DI INTEGRAZIONE
C     NPX     = NUMERO DI PUNTI INTERMEDI SULL' ASSE X
C               SU CUI CALCOLARE L' INTEGRALE NUMERICO (MAX=6)
C     NPY     = NUMERO DI PUNTI INTERMEDI SULL' ASSE Y
C               SU CUI CALCOLARE L' INTEGRALE NUMERICO (MAX=6)
C
      IMPLICIT NONE
      INTEGER  NPX
      INTEGER  NPY
      REAL     H
      REAL     SIG
      REAL     XA
      REAL     YA
      REAL     X0
      REAL     Y0
C
      REAL     X, Y
      REAL     XB, YB
      REAL     XT, YT
      REAL     VT
      REAL     PSF
      INTEGER  I, J
      REAL     HE(6,6),HX(6,6)
C
      DATA     HX/ 0.0    ,0.0     ,0.0     ,0.0    ,0.0    ,0.0,
     *            -.577350,.577350 ,0.0     ,0.0    ,0.0    ,0.0,
     *            -.774597, 0.     ,.774597 ,0.0    ,0.0    ,0.0,
     *            -.861136,-.339981,.339981 ,.861136,0.0    ,0.0,
     *            -.906179,-.538469,0.      ,.538469,.906179,0.0,
     *            -.932469,-.661209,-.238619,.238619,.661209,.932469/
      DATA     HE/2.    ,0.0    ,0.0    ,0.0    ,0.0    ,0.0,
     *            1.    ,1.     ,0.0    ,0.0    ,0.0    ,0.0,
     *           .555555,.888889,.555555,0.0    ,0.0    ,0.0,
     *           .347855,.652145,.652145,.347855,0.0    ,0.0,
     *           .236927,.478629,.568889,.478629,.236927,0.0,
     *           .171324,.360762,.467914,.467914,.360762,.171324/
C
      PSF(H,X,Y,X0,Y0,SIG) = H*EXP(-4*ALOG(2.)*((X-X0)**2+(Y-Y0)**2)
     *                        /SIG**2)
      XB = XA+1
      YB = YA+1
      VT = 0.
C
      DO 10  I=1,MIN0(6,NPX)
         XT = .5*(HX(I,NPX)+XB+XA)
         DO 20 J=1,MIN0(6,NPY)
            YT = .5*(HX(J,NPY)+YB+YA)
            VT = VT+HE(I,NPX)*HE(J,NPY)*PSF(H,XT,YT,X0,Y0,SIG)
   20    CONTINUE
   10 CONTINUE
C
      GALEG=VT/4.
      RETURN
      END

C @(#)gd8z.for	19.1 (ES0-DMD) 02/25/03 13:55:09
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
	SUBROUTINE GD8012(DISPLAY,CHAN,NOCHAN,SCX,SCY,IDST)
C	
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine IIWSC	version 1.00	880125
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  DeAnza, memory, scroll
C
C.PURPOSE
C  fulfill the requirements as described in the IDI document
C
C.ALGORITHM
C  use DeAnza level 0 software
C
C.INPUT/OUTPUT
C  call as  IIZWSC(DISPLAY,CHAN,NOCHAN,SCX,SCY,IDST)
C
C  input par:
C  DISPLAY:	I*4		display id.
C  CHAN:	I*4 array	memory ids
C  NOCHAN:	I*4 		no. of memory ids
C  SCX:		I*4		x-scroll value
C  SCY:		I*4		y-scroll value
C
C  output par:
C  IDST:	I*4		return status
C	
C--------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,CHAN(1),NOCHAN,SCX,SCY,IDST
	INTEGER*4	SCRTOP,N,NN
C	
	INTEGER*2	UNIT,SC,C1,NSCX,NSCY
	INTEGER*2	LMC
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
	INCLUDE	'MID_INCLUDE:IDIDEV.INC'
	INCLUDE	'MID_INCLUDE:IDIMEM.INC'
C	
	EXTERNAL	LMC
C	
	DATA	C1 /"176000/
C	
	SCRTOP = QDSZY - 1			!top line on screen
C	
	UNIT = DISPLAY
	NSCX = - SCX				!offsets from 0,0 are
	NSCY = SCRTOP - SCY			!to DeAnza 0,511 business...
C	
C  set up scroll value in DeAnza memory
C  bits X9 - X0 in reg.0 and bits Y9 - Y0 in reg. 1
C	
	DO NN=1,NOCHAN
	   N = CHAN(NN) + 1
C
	   MEMREG(1,N) = IAND(MEMREG(1,N),C1)	!clear scroll
	   SC = IAND(NSCX,"001777)			!cut out last 10 bits
	   MEMREG(1,N) = IOR(MEMREG(1,N),SC)
C
	   MEMREG(2,N) = IAND(MEMREG(2,N),C1)	!clear scroll
	   SC = IAND(NSCY,"001777)			!cut out last 10 bits
	   MEMREG(2,N) = IOR(MEMREG(2,N),SC)
C	
C  and send it to the DeAnza
	   CALL IP8QW(LMC,UNIT,DZIOSB,,,MEMREG(1,N),4,CHAN(NN),0)
	ENDDO
C	
C  alright then...
	IDST = 0
	RETURN
	END

	SUBROUTINE GD8013(DISPLAY,CHAN,NOCHAN,ZOOM,IDST)
C	
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine IIZWZM	version 1.00	880118
C  K. Banse                  	ESO - Garching
C
C.KEYWORDS
C  DeAnza, memory, scroll
C
C.PURPOSE
C  fulfill the requirements as described in the IDI document
C
C.ALGORITHM
C  use DeAnza level 0 software
C
C.INPUT/OUTPUT
C  call as  IIDZWZM(DISPLAY,CHAN,NOCHAN,ZOOM,IDST)
C
C  input par:
C  DISPLAY:	I*4		display id.
C  CHAN:	I*4 array 	memory ids
C  NOCHAN:	I*4 		no. of memory ids
C  ZOOM:	I*4		zoom factor
C
C  output par:
C  IDST:	I*4		return status
C	
C--------------------------------------------------
C
	IMPLICIT NONE
C	
	INTEGER*4	DISPLAY,CHAN(1),NOCHAN,ZOOM,IDST
	INTEGER*4	N,NN
C	
	INTEGER*2	UNIT,IZ,IZO
	INTEGER*2	LMC
C
	INCLUDE	'MID_INCLUDE:DEANZAH.INC'
	INCLUDE	'MID_INCLUDE:DEANZAS.INC'
C	
	EXTERNAL	LMC
C	
	UNIT = DISPLAY
C	
C  set up zoom value in DeAnza memory
C  bits Z3 - Z0 (15 - 13) in reg.0 and bits Z3 - Z0 (15 - 13) in reg. 1
C	
	DO NN=1,NOCHAN
	   N = CHAN(NN) + 1
	   IZ = IAND((ZOOM-1),"000007)		!cut out last 3 bits of ZOOM - 1
	   IZO = ISHFT(IZ,13)
	   MEMREG(1,N) = IAND(MEMREG(1,N),"017777)	!clear zoom
	   MEMREG(1,N) = IOR(MEMREG(1,N),IZO)
	   MEMREG(2,N) = IAND(MEMREG(2,N),"017777)	
	   MEMREG(2,N) = IOR(MEMREG(2,N),IZO)
C	
C  and send it to the DeAnza
	   CALL IP8QW(LMC,UNIT,DZIOSB,,,MEMREG(1,N),4,CHAN(NN),0)
	ENDDO
C	
C  alright then...
	IDST = 0
	RETURN
	END

C===========================================================================
C Copyright (C) 1995-2012 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or
C modify it under the terms of the GNU General Public License as
C published by the Free Software Foundation; either version 2 of
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public
C License along with this program; if not, write to the Free
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C       Internet e-mail: midas@eso.org
C       Postal address: European Southern Observatory
C                       Data Management Division
C                       Karl-Schwarzschild-Strasse 2
C                       D 85748 Garching bei Muenchen
C                       GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION:
C  program MAGNI			version 1.00	881028
C  K. Banse				ESO - Garching
C
C.KEYWORDS:
C  Gaussian profiles, intensity moments
C
C.PURPOSE:
C  find magnitude of objects
C
C.ALGORITHM:
C  simple integration over center part and subtraction of background
C  it is the JMAG command of IHAP (Author: P. Grosbol)
C
C.INPUT/OUTPUT:
C
C  The following keywords are used:
C  IN_A/C/1/60				input frame
C  P1/C/1/80				input specs,
C					= CURSOR for cursor input
C					= image for image center or
C					= image,xpix,ypix for image pixel or
C					= image,table for table input
C  ACTION/C/1/3				magnitude method,
C					CEN for center method 
C					CIR for method with circular aperture
C					REC for method with rect. aperture
C  P2/C/1/80				out specs (for data storage)
C					= :label for table or table,:label (a)
C					= descr,DESCR for descriptor (b)
C					= + for just display of data
C  P4/C/1/2				(a) identifier flag for table,
C					= I(D), append an identifier, else no.
C  					(b) append flag for descriptor,
C					= A, append data to descriptor
C					= +, start again at position 1 in descr
C  AREA/C/1/80				nopix, (npiy) for magnitude, 
C					nopix for no_mans_land,
C					nopix for sky - as char. string
C  P5/C/1/30				first char: '1' or '0' for center flag
C					then optional ",kappa" (default = 2.0)
C  COPTION/I/1/4			no. of cursors to use,
C                                       draw_flag for circles/rectangles,
C                                       draw_flag for labels (INPUTC(31)='I',
C                                       max. no. of cursor inputs
C	
C  DAZIN/I/1/5				zoom,aux_win_sizes (for cursor only)
C  OUTPUTR/R/1/12			last displayed results
C  OUTPUTI/I/1/1			no. of loops in program
C	
C.VERSIONS
C
C 120207		last modif
C--------------------------------------------------------------------------
C 
      PROGRAM MAGNI
C
      IMPLICIT NONE
C      
      INTEGER      BAKPIX,MAGPIX,MAGPIY,NOMPIX
      INTEGER      COOS(5),CUROPT
      INTEGER      CENTFL,IDFL,INFL,OUTFL,TBMAG
      INTEGER      IDYES,FELEM
      INTEGER      IAV,N,NN,NLIMIT,NMAL
      INTEGER      LLABL,OVCON,COOFF
      INTEGER      NCOOS,NROW
      INTEGER      OUCOLS,CENTY,TBAPP
      INTEGER*8    PNTRA,PNTRC
      INTEGER      STAT1,STAT2,STAT,INPUT(4),NOCURS
      INTEGER      VIMNO1,VIMNO2,IMNO
      INTEGER      NAXIS,NPIX(3),NPIXT(3),XYALP(3)
      INTEGER      ALOW(3),BLOW(3),HIGH(3)
      INTEGER      ICUR1(2),ICUR2(2),INBUF(5)
      INTEGER      BOX(5),SPIX(4)
      INTEGER      INCOLN(13),OUCOLN(13)
      INTEGER      OPTION,LRVALS,NCOU,YESNO,LOOPI,DRAWY
      INTEGER      TIDI,TIDO,TABNUL(13)
      INTEGER      XFIGU(256),YFIGU(256),MAXPNT,NPNTS
      INTEGER      CXSIZE,CYSIZE,KXSIZE,KYSIZE,KXS,KYS
      INTEGER      ZMPIX,ZMPIY,ZNPIX,ZBPIX
      INTEGER      RADIUS(4)
      INTEGER      XINDX,UNI(1),NULO,MADRID(1),EC,EL,ED
C 
      INTEGER      GENNUM
C 
      LOGICAL      SELFLG
C
      CHARACTER    FRAME*60
      CHARACTER    DESCR*15,APPFL*2
      CHARACTER    CUNIT*48,IDENT*72,CBUF*80,ACTION*3
      CHARACTER    IDF*8,OLDIDF*8,LABL*8,INFO*50
      CHARACTER    INTABL*60,OUTABL*60,CURACT*8
      CHARACTER    TUNITW*16,TUNIT*16,LABEL(13)*16
C      
      DOUBLE PRECISION  STEP(3),START(3)
      DOUBLE PRECISION  DIN(4),DOUT(4)                 !MaxDim = 4 in wrldco.c
      DOUBLE PRECISION  DVALS(10)
C 
      REAL         RBUF(17),PCUR1(6),PCUR2(6)
      REAL         RVALS(12),RR(2),R1,R2,R3,R4,FAC
      REAL         AMAG,AMSIG,SKY,SSKY,APIX,XC,YC,XCC,YCC
      REAL         TEMP(2),FLUX,RINF(8),XOFF,YOFF
C
      INCLUDE      'MID_INCLUDE:ST_DEF.INC'
C 
      INCLUDE  'MID_INCLUDE:IDIDEV.INC'
      INCLUDE  'MID_INCLUDE:IDIMEM.INC'
C 
      COMMON  /VMR/  MADRID
      COMMON  /FLAGS/  INFL,OUTFL,OPTION,TBMAG
C      
      DATA      LABEL /'XSTART ','YSTART ','XEND ','YEND ',
     +                 'MAGNITUDE ','MAG_SIGMA ','SKY ','SKY_SIGMA ',
     +                 'IDENT ','XCEN ','YCEN ','MAGPIX ',
     +                 'FLUX '/
      DATA      INCOLN /13*0/,      OUCOLN /13*0/
      DATA      TUNITW /'WORLD COORD '/
      DATA      TUNIT  /' '/
C      
      DATA      IDF    /'ID '/,      OLDIDF /' '/
      DATA      COOS   /5*-1/,       RADIUS /4*0/,    TEMP/-1.0,-1.0/
      DATA      NPIXT  /3*1/,  ALOW /3*1/,   BLOW /3*1/,   HIGH /3*1/
      DATA      DESCR  /' '/
      DATA      IDENT  /' '/,  CUNIT /' '/
      DATA      XYALP  /0,0,0/,   DVALS /10*0.0/
      DATA      INTABL /' '/,  OUTABL /' '/
      DATA      MAXPNT /256/
      DATA      INFO   /'switch cursors on - next time we exit... '/
C
      INCLUDE      'MID_INCLUDE:ST_DAT.INC'
C      
C  set up MIDAS environment + enable automatic error abort
      CALL STSPRO('MAGNI')
      NCOOS = 0               !init no. of coords. read
      IDFL = 0
      IDYES = 0
      CUROPT = 0
      CENTFL = 1              !if = 1, shift window
      CENTY = 1               !if = 1, we have already center vals in in_table
      NCOU = 0                !count used for various purposes
      TIDO = -1               !default to NO output table
      TBAPP = 0               !point to start of table
      TBMAG = 0               !use MAGPIX,MAGPIY...
      OUTFL = 0       
      XCC = -1                !init to invalid value
      YCC = -1
      INFL = -1
C 
C  INFL = 1, cursor input		OUTFL = 0, just display data 
C  INFL = 2, table input		      = 1, results to descriptor
C  INFL = 3, image center 		OUTFL > 1, results to table:
C  INFL = 4, image pixel			2 = same input, output table 
C          					3 = new output table
C  OPTION = 1, MAGNITUDE/CENTER
C  OPTION = 2, MAGNITUDE/RECTANGLE
C  OPTION = 3, MAGNITUDE/CIRCLE
C 
C      
C  get method 
C 
      CALL STKRDC('ACTION',1,1,3,IAV,ACTION,UNI,NULO,STAT)
      CALL UPCAS(ACTION,ACTION)
      IF (ACTION.EQ.'CIR') THEN
         OPTION = 3                                 !MAGNI/CIRCLE
      ELSE IF (ACTION(1:1).EQ.'R') THEN
         OPTION = 2                                 !MAGNI/RECT
      ELSE
         OPTION = 1                                 !MAGNI/CENT
      ENDIF
      LRVALS = 12                                   !for "real" data
      XINDX = LRVALS + 1                            !index for control data
      R1 = -1.111                                   !OUTPUTR(xindx) < 0.0
      CALL STKWRR('OUTPUTR',R1,XINDX,1,UNI,STAT)
C
C  get the input options
C 
      CALL STKRDC('P1',1,1,78,IAV,CBUF,UNI,NULO,STAT)
      NN = INDEX(CBUF,',')
      IF (NN.GT.1) THEN
         FRAME(1:) = CBUF(1:NN-1)//' '
         INTABL(1:) = CBUF(NN+1:)//' '
         IAV = GENNUM(INTABL)                     !check for image,xpix,ypix
         IF ((INTABL(1:1).EQ.'@') .OR. (IAV.EQ.1)) THEN
            INFL = 4
         ELSE
            CALL CLNTAB(INTABL,INTABL,0)
            CALL TBTOPN(INTABL,F_IO_MODE,TIDI,STAT)
            INFL = 2                              !INFL = 2 for table
            CENTY = 0                             !default to No Center columns
C 
            CALL TBLSER(TIDI,LABEL(9),INCOLN(9),STAT)  !look for :IDENT column
            IF (INCOLN(9).NE.-1) IDYES = 1
            CALL TBLSER(TIDI,LABEL(10),INCOLN(10),STAT)   !look for center cols 
            CALL TBLSER(TIDI,LABEL(11),INCOLN(11),STAT)
            IF ( (INCOLN(10).GT.0) .AND. (INCOLN(11).GT.0)) THEN
               CENTY = 1                !indicate that we already have a center
            ENDIF
         ENDIF
      ELSE
         CALL UPCAS(CBUF(1:6),IDENT)
         IF (IDENT(1:6).EQ.'CURSOR') THEN
            CALL STKRDC('IN_A',1,1,60,IAV,FRAME,UNI,NULO,STAT)
            INFL = 1                              !INFL = 1 for cursor
            COOFF = 0
         ELSE
            FRAME(1:) = CBUF(1:60)
            INFL = 3                              !INFL = 3 for image center
            CALL STTPUT
     +      ('We work on crude center of input frame. ',STAT)
         ENDIF
      ENDIF
      IF (INFL.LT.1) CALL STETER(12,'invalid input')
C      
C  get center flag + kappa for kappa-sigma clipping
C 
      CALL STKRDC('P5',1,1,30,IAV,CBUF,UNI,NULO,STAT)
      IF (CBUF(1:1).EQ.'0') THEN
         CENTFL = 0
      ELSE IF (CBUF(1:1).NE.'1') THEN
         IF ((INFL.EQ.4) .OR. (CENTY.EQ.1)) CENTFL = 0      !force to NO
      ENDIF
      NN = INDEX(CBUF,',')
      IF (NN.GT.1) THEN
         CALL GENCNV(CBUF(NN+1:),2,1,N,FAC,STEP,IAV)
         IF (IAV.LE.0) THEN
            CALL STTPUT
     +   ('Wrong syntax for center params, Kappa set to 2.0',STAT)
            FAC = 2.0
         ENDIF
      ELSE
         FAC = 2.0
      ENDIF
C 
C  open input frame 
      CALL CLNFRA(FRAME,FRAME,0)
      CALL STFOPN(FRAME,D_R4_FORMAT,0,F_IMA_TYPE,IMNO,STAT)
      CALL STDRDI(IMNO,'NAXIS',1,1,IAV,NAXIS,UNI,NULO,STAT)
      IF (NAXIS.EQ.1)
     +   CALL STETER(1,'input frame must be at least 2-dim frame...')
      CALL STDRDI(IMNO,'NPIX',1,2,IAV,NPIX,UNI,NULO,STAT)
      CALL STDRDD(IMNO,'START',1,2,IAV,START,UNI,NULO,STAT)
      CALL STDRDD(IMNO,'STEP',1,2,IAV,STEP,UNI,NULO,STAT)
C
C  init frame pixls  <->  world coords conversion
      CALL FPXWCO(0,IMNO,DIN,DOUT,STAT)
      IF (STAT .GT. 0)
     +   CALL STETER(11,'problems with WCS of input frame...')
C      
C  get integration sizes + check them
C 
      CALL STKRDC('AREA',1,1,78,IAV,CBUF,UNI,NULO,STAT)
      CALL PULLOU(CBUF,STEP,2,2,MAGPIX,MAGPIY,NOMPIX,BAKPIX)
      IF ((MAGPIX.LE.0).OR.(NOMPIX.LT.0).OR.(BAKPIX.LT.0))
     +   CALL STETER(2,'invalid pixel string ...')
      IF (MAGPIY.LE.0) MAGPIY = MAGPIX
C 
      NN = 2*(BAKPIX+NOMPIX)
      IF (OPTION.EQ.1) THEN
         MAGPIX = 3                !only take 9 center pixels
         CXSIZE = MAGPIX + NN
         CYSIZE = CXSIZE
      ELSE IF (OPTION.EQ.3) THEN
         NN =  2 * ((MAGPIX/2) + BAKPIX + NOMPIX)
         CXSIZE = 1 + NN        !add center pixel for total no. of x/y-pixel
         CYSIZE = CXSIZE
      ELSE                      !for rectangle xpix, ypix may differ
         CXSIZE = MAGPIX + NN
         CYSIZE = MAGPIY + NN
      ENDIF
C 		get size of subwindow to pull out, at least 100 lines
      IF (CXSIZE .LT. 100) THEN
         KXS = 100
      ELSE
         KXS = CXSIZE
      ENDIF
      IF (CYSIZE .LT. 100) THEN
         KYS = 100
      ELSE
         KYS = CYSIZE
      ENDIF
      KXS = MIN(NPIX(1),KXS)
      KYS = MIN(NPIX(2),KYS)
      KXSIZE = KXS
      KYSIZE = KYS
C      
C  map temporary work frames:
C                           virtual1 = npix(1) * kysize
C                           virtual2 = kxsize * kysize
      N = NPIX(1)*KYSIZE                !full KYSIZE lines
      CALL STFCRE('virtual1',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +            N,VIMNO1,STAT)
      CALL STFMAP(VIMNO1,F_X_MODE,1,N,IAV,PNTRA,STAT)
      N = KXSIZE * KYSIZE               !KYSIZE lines * KXSIZE pixels
      CALL STFCRE('virtual2',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +            N,VIMNO2,STAT)
      CALL STFMAP(VIMNO2,F_X_MODE,1,N,IAV,PNTRC,STAT)

C
C  get append_flag + output_specs 
C 
      CALL STKRDC('P4',1,1,2,IAV,CBUF,UNI,NULO,STAT)
      CALL UPCAS(CBUF(1:2),APPFL)
      IF ((APPFL(1:1).EQ.'I').OR.(APPFL(2:2).EQ.'I')) IDFL = 1 
C 
      CALL STKRDC('P2',1,1,80,IAV,CBUF,UNI,NULO,STAT)
      IF (CBUF(1:1).EQ.'+') GOTO 500              !neither table nor descriptor
C      
      NN = INDEX(CBUF,',D')              !test for ,D or ,d
      IF (NN .LE. 0) NN = INDEX(CBUF,',d')    
C      
C  handle descriptor storage
      IF (NN.GT.1) THEN                  !it's a descriptor
         DESCR = CBUF(1:NN-1)
         IF (APPFL(1:1).EQ.'A') THEN     !see, if data is to be appended
            FELEM = -1
         ELSE
            FELEM = 1
         ENDIF
         OUTFL = 1                       !OUTFL = 1 for descriptor
         GOTO 500                        !skip following table stuff
      ENDIF
C      
C +++
C  handle table storage
C +++
C      
      OUCOLS = 13                         !no. of columns in out_table
      CALL CLNTAB(CBUF,OUTABL,0)
C      
C  either same table involved ...
      IF (OUTABL.EQ.INTABL) THEN            !results go to same table
         TIDO = TIDI
         OUTFL = 2                          !OUTFL = 2 for same table
C      
         DO 100,IAV=5,8                     !test, if label(s) already there
            CALL TBLSER(TIDI,LABEL(IAV),OUCOLN(IAV),STAT)
            IF (OUCOLN(IAV).EQ.-1)             !No. We have to define it...
     +         CALL TBCINI(TIDI,D_R4_FORMAT,1,'E12.5',
     +                     TUNIT,LABEL(IAV),OUCOLN(IAV),STAT)
100      CONTINUE
C      
         IF (CENTY.EQ.1) THEN
            OUCOLN(10) = INCOLN(10)
            OUCOLN(11) = INCOLN(11)
         ELSE
            DO 120,IAV=10,11               !create :XCEN,:YCEN as double
               CALL TBCINI(TIDI,D_R8_FORMAT,1,'E24.15',
     +                     TUNITW,LABEL(IAV),OUCOLN(IAV),STAT)
120         CONTINUE
         ENDIF
         IF (IDFL.EQ.1) THEN
            IF (IDYES.EQ.1) THEN
               OUCOLN(9) = INCOLN(9)
            ELSE
               CALL TBCINI
     +           (TIDI,D_C_FORMAT,8,'A8',TUNIT,LABEL(9),OUCOLN(9),STAT)
            ENDIF
         ENDIF
C      
         DO 140,IAV=12,13
            CALL TBLSER(TIDI,LABEL(IAV),OUCOLN(IAV),STAT)
            IF (OUCOLN(IAV).EQ.-1)
     +         CALL TBCINI(TIDI,D_R4_FORMAT,1,'E12.5',
     +                     TUNIT,LABEL(IAV),OUCOLN(IAV),STAT)
140      CONTINUE
C      
C  or just output table ...
C 
      ELSE                       !output to table - valid for any input option
         OUTFL = 3
C 
         IF (APPFL(1:1).EQ.'A') THEN        !append to existing table
            CALL STECNT('GET',EC,EL,ED)
            CALL STECNT('PUT',1,0,0)            !disable errors ...
            CALL TBTOPN(OUTABL,F_IO_MODE,TIDO,STAT)
            CALL STECNT('PUT',EC,EL,ED)
            IF (STAT.NE.0) THEN             !continue only, if TBTOPN o.k.
               APPFL(1:1) = '+'
            ELSE
               CALL TBIGET(TIDO,N,TBAPP,N,N,N,STAT)      !get no. of rows
               DO 260,IAV=1,4
                  CALL TBLSER(TIDO,LABEL(IAV),OUCOLN(IAV),STAT)
                  IF (OUCOLN(IAV).EQ.-1) 
     +               CALL TBCINI(TIDO,D_R8_FORMAT,1,'E24.15',
     +                           TUNITW,LABEL(IAV),OUCOLN(IAV),STAT)
260            CONTINUE
               DO 270,IAV=5,8
                  CALL TBLSER(TIDO,LABEL(IAV),OUCOLN(IAV),STAT)
                  IF (OUCOLN(IAV).EQ.-1) 
     +               CALL TBCINI(TIDO,D_R4_FORMAT,1,'E12.5',
     +                           TUNIT,LABEL(IAV),OUCOLN(IAV),STAT)
270            CONTINUE
C
               IF (IDFL.EQ.1) THEN
                  CALL TBLSER(TIDO,LABEL(9),OUCOLN(9),STAT)
                  IF (OUCOLN(9).EQ.-1)
     +               CALL TBCINI(TIDO,D_C_FORMAT,8,'A8',
     +                           TUNIT,LABEL(9),OUCOLN(9),STAT)
               ENDIF
               DO 280,IAV=10,11
                  CALL TBLSER(TIDO,LABEL(IAV),OUCOLN(IAV),STAT)
                  IF (OUCOLN(IAV).EQ.-1)
     +               CALL TBCINI(TIDO,D_R8_FORMAT,1,'E24.15',
     +                           TUNITW,LABEL(IAV),OUCOLN(IAV),STAT)
280            CONTINUE
C 
               DO 290,IAV=12,13
                  CALL TBLSER(TIDO,LABEL(IAV),OUCOLN(IAV),STAT)
                  IF (OUCOLN(IAV).EQ.-1)
     +               CALL TBCINI(TIDO,D_R4_FORMAT,1,'E12.5',
     +                           TUNIT,LABEL(IAV),OUCOLN(IAV),STAT)
290            CONTINUE
C 
               GOTO 500
            ENDIF
         ENDIF
C 
C  we create a new table (starting with 100 rows)
C 
         CALL TBTINI(OUTABL,0,F_O_MODE,OUCOLS+10,100,TIDO,STAT)
         DO 460,IAV=1,4
            CALL TBCINI(TIDO,D_R8_FORMAT,1,'E24.15',
     +                  TUNITW,LABEL(IAV),OUCOLN(IAV),STAT)
460      CONTINUE
         DO 470,IAV=5,8
            CALL TBCINI(TIDO,D_R4_FORMAT,1,'E12.5',
     +                  TUNIT,LABEL(IAV),OUCOLN(IAV),STAT)
470      CONTINUE
C      
         IF (IDFL.EQ.1) 
     +      CALL TBCINI(TIDO,D_C_FORMAT,8,'A8',
     +                  TUNIT,LABEL(9),OUCOLN(9),STAT)
         DO 480,IAV=10,11
            CALL TBCINI(TIDO,D_R8_FORMAT,1,'E24.15',
     +                  TUNITW,LABEL(IAV),OUCOLN(IAV),STAT)
480         CONTINUE
C      
         DO 490,IAV=12,13
            CALL TBCINI(TIDO,D_R4_FORMAT,1,'E12.5',
     +                  TUNIT,LABEL(IAV),OUCOLN(IAV),STAT)
490      CONTINUE
      ENDIF
C      
C  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  here all options join:
C  display header line + branch according to input option
C  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C      
500   IF (INFL.NE.2) THEN
         IF (CENTFL.EQ.1) 
     +      CALL STTPUT
     +      ('input windows will be adjusted around the center ',
     +      STAT)
      ELSE
         IF (CENTFL.EQ.0) THEN
            IF (CENTY.EQ.1) THEN
               CBUF(1:) = 'x,ycenter will be taken from input table '
               CALL STTPUT(CBUF,STAT)
            ENDIF
         ELSE
            IF (CENTY.EQ.1) THEN
               CBUF(1:) = 
     +         'x,ycenter of input table will be overwritten '
               CALL STTPUT(CBUF,STAT)
            ENDIF
         ENDIF
      ENDIF
      IF (INFL.NE.1) THEN
         CBUF(1:) =
     +   'xcenter    ycenter    magnitude  mag-sigma  sky '//
     +   '  sky-sigma  magpix   flux '
         CALL STTPUT(CBUF,STAT)
         IF (IDFL.EQ.1) CALL STTPUT(' ident ',STAT)      
      ENDIF
C      
C  branch according to input option
      NMAL = 0                        !init counter
      IF (INFL.EQ.1) THEN
         GOTO 900
      ELSE IF (INFL.EQ.2) THEN
         GOTO 2000
      ENDIF
C      
C  --------------------------------------------------------------------
C      
C  a) input frame is used - use crude center or given x,ypixel
C     INFL = 3 or 4  (no looping)
C      
C  --------------------------------------------------------------------
C      
      IF (INFL.EQ.3) THEN
         COOS(1) = NPIX(1)/2 
         COOS(2) = NPIX(2)/2 
      ELSE
         CALL EXTCO1(IMNO,INTABL,2,N,COOS,STAT)    !get frame pixels
         IF (STAT.NE.0) THEN
            CALL STTPUT('invalid pixel specification,...')
            R1 = -2.22
            GOTO 7000
         ENDIF
      ENDIF
      XCC = COOS(1)
      YCC = COOS(2)
C 
      IF (OPTION.NE.3) THEN
         BOX(1) = COOS(1) - CXSIZE/2
         BOX(2) = COOS(2) - CYSIZE/2
         BOX(3) = BOX(1) + CXSIZE - 1
         BOX(4) = BOX(2) + CYSIZE - 1
         PCUR1(1) = FLOAT(BOX(1))
         PCUR1(2) = FLOAT(BOX(2))
         PCUR2(1) = FLOAT(BOX(3))
         PCUR2(2) = FLOAT(BOX(4))
      ELSE                                       !circle option
         PCUR1(1) = FLOAT(COOS(1))
         PCUR1(2) = FLOAT(COOS(2))
      ENDIF
C 
      NMAL = 1                                   !maybe we write a row to table
      WRITE(IDF(3:),10010) NMAL
      GOTO 3000
C      
C  --------------------------------------------------------------------
C      
C  b) cursor defined subimage(s) - get main control block for ImageDisplay
C     INFL = 1    (loop on cursor input)
C      
C  --------------------------------------------------------------------
C      
900   CALL DTOPEN(1,STAT)
      CALL STKRDI('DAZHOLD',14,1,IAV,OVCON,UNI,NULO,STAT)
      CALL STKRDI('COPTION',1,4,IAV,INPUT,UNI,NULO,STAT)
      IF (OPTION.EQ.1) THEN
         NOCURS = 0                          !for CENTER use 1 cursor
      ELSE IF (OPTION.EQ.2) THEN
         IF (INPUT(1).EQ.1) THEN
            NOCURS = 0
         ELSE
            NOCURS = 2
         ENDIF
      ELSE
         NOCURS = 2                          !for CIRCLE use 2 cursors
         CUROPT = INPUT(1)                   !save 1 or 2 cursor mode
         IF (CUROPT.EQ.1) THEN
            N = 2*MAGPIX + 1
            YESNO = N + 2*NOMPIX
            NLIMIT = YESNO + 2*BAKPIX
            WRITE(CBUF,20004) MAGPIX,NOMPIX,BAKPIX
            CALL STTDIS(CBUF,0,STAT)
            WRITE(CBUF,20009) N,YESNO,NLIMIT
            CALL STTDIS(CBUF,0,STAT)
         ENDIF
      ENDIF
      DRAWY = INPUT(2)
      YESNO = INPUT(3)
      NLIMIT = INPUT(4)
C 
C  adjust cursor shape
      CALL DTGICH(QDSPNO,QIMCH,CBUF,RINF,STAT)
      ZMPIX = MAGPIX
      ZMPIY = MAGPIY
      IAV = ZMPIX/2
      ZNPIX = NOMPIX
      ZBPIX = BAKPIX
      IF ((SCALX.EQ.-1) .OR. (SCALX.EQ.0)) SCALX = 1
      IF ((SCALY.EQ.-1) .OR. (SCALY.EQ.0)) SCALY = 1
      IF (SCALX.NE.SCALY) CALL STETER
     +      (6,'image not loaded with same x-, y-scale...')
      IF (SCALX.LT.-1) THEN
         NN = -SCALX
         ZMPIX = MAGPIX*NN
         ZMPIY = MAGPIY*NN
         IAV = (MAGPIX*NN)/2
         ZNPIX = NOMPIX*NN
         ZBPIX = BAKPIX*NN
      ELSE IF (SCALX.GT.1) THEN
         ZMPIX = MAGPIX/SCALX + 1           !so we have at least 1 pixel
         ZMPIY = MAGPIY/SCALY + 1
         IAV = MAGPIX/(2*SCALX) + 1
         ZNPIX = NOMPIX/SCALX + 1
         ZBPIX = BAKPIX/SCALX + 1
      ENDIF
      COOS(1) = QDSZX/2
      COOS(2) = QDSZY/2
      LOOPI = 2
      IF (OPTION.NE.3) THEN 
         IF (NOCURS.EQ.0) THEN
            NN = 3                          !use rectangle
            LOOPI = 2
         ELSE
            NN = 1                          !use rectangle
            N = ZMPIX + 2*(ZNPIX+ZBPIX)
            COOS(3) = COOS(1) + N - 1
            N = ZMPIY + 2*(ZNPIX+ZBPIX)
            COOS(4) = COOS(2) + N - 1
         ENDIF
      ELSE
         NN = 2                             !use circle
         COOS(3) = IAV
         COOS(4) = COOS(3) + ZNPIX
         COOS(5) = COOS(4) + ZBPIX
         RADIUS(1) = COOS(3)                !save original radius
         RADIUS(2) = COOS(4)
         RADIUS(3) = COOS(5)
      ENDIF
      CALL SETCUR(QDSPNO,NOCURS,NN,LOOPI,COOS,STAT)
C      
      CALL STKRDI('AUX_MODE',9,1,IAV,N,UNI,NULO,STAT)
      IF (N.NE.0) CALL CONCHA(QDSPNO,QOVCH,1,0)      !clear overlay channel
      IF (OVCON.EQ.QIMCH)
     +   CALL DAZZSC(QDSPNO,QOVCH,ZOOMX,SCROLX,SCROLY,STAT)
C 
      FRAME(1:) = ' '
      CALL STKRDI('DAZIN',1,1,IAV,INBUF,UNI,NULO,STAT)
      CURACT = 'NNYY?C0 '              !set up for Cursor with ENTER button
      IF (INBUF(1).GT.0) THEN          !we use the zoom window...
         IF (NOCURS.EQ.0) THEN
            CURACT(5:7) = 'ZC0'        !prepare zoom_window stuff for GETCUR
         ELSE
            IF (OPTION.EQ.3) THEN      !we want circles in zoom window
               CURACT(5:7) = 'ZC7'
            ELSE
               CURACT(5:7) = 'ZC2'
            ENDIF
         ENDIF
         INBUF(1) = (QDSZX * 3) / 4    !use 3/4 of main display size
         INBUF(2) = (QDSZY * 3) / 4
         INBUF(3) = 0                  !start at lower left of display
         INBUF(4) = 0
         CALL STKWRI('DAZIN',INBUF,2,4,UNI,STAT)
         N = 0
         CALL AUXHLP(-10)              !initialize display_it for parallel view
         CALL SETCUR(QDSPNO,N,3,2,COOS,STAT)          !use cross
C
C  if `novice', display initial help, show current zoomfactor
         CALL STKRDI('ERROR',2,1,IAV,N,UNI,NULO,STAT)
         IF (N.EQ.1) CALL AUXHLP(0)         !for novice users display help
      ENDIF
C 
      CALL PIXXCV('INIT',IMNO,RBUF,NN)
      GOTO 1000
C
990   WRITE(CBUF,30000) MAGPIX,BAKPIX
      CALL STTDIS(CBUF,99,STAT)
C 
C  get cursor positions 
1000  IF (NMAL.GE.NLIMIT) GOTO 9000
C      
      CALL GETCUR(CURACT,FRAME,
     +            ICUR1,PCUR1(1),RVALS(1),FLUX,STAT1,
     +            ICUR2,PCUR2(1),RVALS(3),FLUX,STAT2)
C
C  check cursor status for EXIT condition
      IF ((STAT1.EQ.0).AND.(STAT2.EQ.0)) THEN
         IF ((NMAL.EQ.0) .AND. (COOFF.EQ.0)) THEN
            CALL STTPUT(INFO,STAT)
            COOFF = 1
            FRAME(1:) = ' '
            GOTO 1000
         ELSE
            GOTO 9000
         ENDIF
      ELSE IF (NMAL.EQ.0) THEN
         CBUF(1:) =
     +   'xcenter        ycenter      magnitude    mag-sigma'
         CALL STTPUT(CBUF,STAT)
         CBUF(1:) =
     +   '        sky         sky-sigma       magpix        flux '
         CALL STTPUT(CBUF,STAT)
         IF (IDFL.EQ.1) CALL STTPUT(' ident ',STAT)
      ENDIF
C
C  show graph used for magnitude determination
C 
      IF (OPTION.EQ.3) THEN                       !MAGNI/CIRCLE
         BOX(1) = ICUR1(1)
         BOX(2) = ICUR1(2)
         INBUF(1) = PCUR2(1)
         INBUF(2) = PCUR2(2)
         INBUF(3) = RVALS(3)
C 
C  check radii if in 1 cursor option for circle
         IF (CUROPT.EQ.1) THEN
            IF ((RADIUS(1).NE.INBUF(1)) .OR.
     +          (RADIUS(2).NE.INBUF(2)) .OR.
     +          (RADIUS(3).NE.INBUF(3))) THEN
               IF (RADIUS(4).GT.2) GOTO 1200
C              
               RADIUS(4) = RADIUS(4) + 1
               CALL STTDIS
     +         ('The radii of the circles should not be modified!',
     +          0,STAT)
               CALL STTDIS
     +         ('Original size of circles will be used anyway!',
     +          0,STAT)
               IF (SCALX.NE.SCALY) GOTO 1500    !skip the radius update part
C
1200           INBUF(1) = RADIUS(1)             !draw original radii again
               INBUF(2) = RADIUS(2)
               INBUF(3) = RADIUS(3)
            ENDIF
C 
C  update radii only in 2 cursor option for circle
         ELSE
            IF (SCALX.GT.1) THEN
               INBUF(1) = INBUF(1)*SCALX
               INBUF(2) = INBUF(2)*SCALX
               INBUF(3) = INBUF(3)*SCALX
            ELSE IF (SCALX.LT.-1) THEN
               NN = -SCALX
               INBUF(1) = INBUF(1)/NN
               INBUF(2) = INBUF(2)/NN
               INBUF(3) = INBUF(3)/NN
            ENDIF
            NOMPIX = INBUF(2) - INBUF(1)
            BAKPIX = INBUF(3) - INBUF(1) - NOMPIX
            CXSIZE = 1 + 2*INBUF(3)            !in frame pixels
            INBUF(1) = PCUR2(1)                !reset for following drawing
            INBUF(2) = PCUR2(2)
            INBUF(3) = RVALS(3)
         ENDIF
C
         IF (DRAWY.EQ.1) THEN
            BOX(3) = INBUF(1)
            CALL BLDGRA('CIR',BOX,TEMP,XFIGU,YFIGU,MAXPNT,NPNTS)
            CALL IIGPLY(QDSPNO,QOVCH,XFIGU,YFIGU,NPNTS,255,1,STAT)
            BOX(3) = INBUF(2)
            CALL BLDGRA('CIR',BOX,TEMP,XFIGU,YFIGU,MAXPNT,NPNTS)
            CALL IIGPLY(QDSPNO,QOVCH,XFIGU,YFIGU,NPNTS,255,1,STAT)
            BOX(3) = INBUF(3)
            CALL BLDGRA('CIR',BOX,TEMP,XFIGU,YFIGU,MAXPNT,NPNTS)
         ENDIF
         XCC = PCUR1(1)                        !xc,yc in frame pixels
         YCC = PCUR1(2)
C 
      ELSE                                         !MAGNI/RECT + MAGNI/CENT
         IF (NOCURS.EQ.2) THEN                     !with two cursors
            IF ( (ICUR1(1).EQ.ICUR2(1)) .OR.
     +           (ICUR1(2).EQ.ICUR2(2)) ) GOTO 990
            CXSIZE = ICUR2(1) - ICUR1(1) + 1
            CYSIZE = ICUR2(2) - ICUR1(2) + 1
            ZMPIX = CXSIZE - 2*(ZNPIX+ZBPIX)
            ZMPIY = CYSIZE - 2*(ZNPIX+ZBPIX)
            IF ((ZMPIX.LT.1) .OR. (ZMPIY.LT.1)) GOTO 990
C 
            IF (OPTION.EQ.2) THEN                 !only for RECT we modify
               IF (SCALX.GT.1) THEN
                  MAGPIX = ZMPIX*SCALX
                  CXSIZE = CXSIZE*SCALX
               ELSE IF (SCALX.LT.-1) THEN
                  NN = -SCALX
                  MAGPIX = ZMPIX/NN
                  CXSIZE = CXSIZE/NN
               ELSE
                  MAGPIX = ZMPIX
               ENDIF
               IF (SCALY.GT.1) THEN
                  MAGPIY = ZMPIY*SCALY
                  CYSIZE = CYSIZE*SCALY
               ELSE IF (SCALY.LT.-1) THEN
                  NN = -SCALY
                  MAGPIY = ZMPIY/NN
                  CYSIZE = CYSIZE/NN
               ELSE
                  MAGPIY = ZMPIY
               ENDIF
            ENDIF
C 
            SPIX(1) = (ICUR1(1)+ICUR2(1))/2            !xcenter
            SPIX(2) = (ICUR1(2)+ICUR2(2))/2            !ycenter
            XCC = (PCUR1(1)+PCUR2(1))/2                !xc,yc in frame pixels
            YCC = (PCUR1(2)+PCUR2(2))/2
C 
         ELSE                                      !single cursor
            SPIX(1) = ICUR1(1)                         !xcenter
            SPIX(2) = ICUR1(2)                         !ycenter
            XCC = PCUR1(1)                             !xc,yc in frame pixels
            YCC = PCUR1(2)
            PCUR1(1) = XCC - CXSIZE/2
            PCUR1(2) = YCC - CYSIZE/2
            PCUR2(1) = PCUR1(1) + CXSIZE - 1
            PCUR2(2) = PCUR1(2) + CYSIZE - 1
         ENDIF
C 
         BOX(1) = SPIX(1) - ZMPIX/2
         BOX(2) = SPIX(2) - ZMPIY/2
         BOX(3) = SPIX(1) + ZMPIX/2 - 1
         BOX(4) = SPIX(2) + ZMPIY/2 - 1
         IF (DRAWY.EQ.0) THEN
            BOX(1) = BOX(1) - ZNPIX - ZBPIX
            BOX(2) = BOX(2) - ZNPIX - ZBPIX
            BOX(3) = BOX(3) + ZNPIX + ZBPIX
            BOX(4) = BOX(4) + ZNPIX + ZBPIX
         ELSE
            CALL BLDGRA('REC',BOX,TEMP,XFIGU,YFIGU,MAXPNT,NPNTS)
            CALL IIGPLY(QDSPNO,QOVCH,XFIGU,YFIGU,NPNTS,255,1,STAT)
            BOX(1) = BOX(1) - ZNPIX
            BOX(2) = BOX(2) - ZNPIX
            BOX(3) = BOX(3) + ZNPIX 
            BOX(4) = BOX(4) + ZNPIX 
            CALL BLDGRA('REC',BOX,TEMP,XFIGU,YFIGU,MAXPNT,NPNTS)
            CALL IIGPLY(QDSPNO,QOVCH,XFIGU,YFIGU,NPNTS,255,1,STAT)
            BOX(1) = BOX(1) - ZBPIX
            BOX(2) = BOX(2) - ZBPIX
            BOX(3) = BOX(3) + ZBPIX
            BOX(4) = BOX(4) + ZBPIX
            CALL BLDGRA('REC',BOX,TEMP,XFIGU,YFIGU,MAXPNT,NPNTS)
         ENDIF
      ENDIF
      IF (DRAWY.EQ.1)
     +   CALL IIGPLY(QDSPNO,QOVCH,XFIGU,YFIGU,NPNTS,255,1,STAT)
C 
1500  NMAL = NMAL + 1
      IF (IDFL.EQ.1) THEN
         CALL STTDIS('enter identifier: ',1,STAT)
         READ(*,10003) IDF 
         IF (IDF.EQ.' ') IDF = OLDIDF
         OLDIDF = IDF                            !save last identifier
      ELSE
         WRITE(IDF(3:),10010) NMAL
      ENDIF
C 
      KXSIZE = CXSIZE
      KYSIZE = CYSIZE
      GOTO 3000
C      
C  --------------------------------------------------------------------
C      
C  c) table defined subimage(s)
C     INFL = 2    (loop through table rows)
C      
C  --------------------------------------------------------------------
C      
2000  CALL TBIGET(TIDI,N,NROW,N,N,N,STAT)        !get total no. of rows
C      
2300  DO 2350,IAV=1,4                            !search for columns
         CALL TBLSER(TIDI,LABEL(IAV),INCOLN(IAV),STAT)
         IF (INCOLN(IAV).LE.0) THEN
            CBUF(1:) = 'column labelled '//LABEL(IAV)//
     +                 ' is missing in input table... '
            CALL STETER(4,CBUF)
         ENDIF
2350  CONTINUE
C      
C  here we loop
2800  NMAL = NMAL + 1
      IF (NMAL.GT.NROW) THEN                  !test for end of table
         WRITE(CBUF,10001) 'no. of table entries processed = ',NCOU
         CALL STTPUT(CBUF,STAT)
         IF (OUTFL.NE.2) CALL TBTCLO(TIDI,STAT)
         GOTO 9000
      ENDIF
C      
C  get next row of values
C 
      CALL TBSGET(TIDI,NMAL,SELFLG,STAT)
      IF (.NOT.SELFLG) GOTO 2800
C 
      IF (IDYES.EQ.1) THEN
         CALL TBRRDC(TIDI,NMAL,1,INCOLN(9),IDF,TABNUL,STAT)
      ELSE
         WRITE(IDF(3:),10010) NMAL
      ENDIF
C 
      CALL TBRRDD(TIDI,NMAL,4,INCOLN,DVALS,TABNUL,STAT)

      DIN(1) = DVALS(1)                   !convert from wco's to fp's
      DIN(2) = DVALS(2)
      CALL FPXWCO(-1,IMNO,DIN,DOUT,STAT)
      IF (STAT.NE.0) THEN
         WRITE(CBUF,10077) NMAL
         CALL STTPUT(CBUF,STAT)
         GOTO 2800
      ENDIF
C 
      PCUR1(1) = REAL(DOUT(1))
      PCUR1(2) = REAL(DOUT(2))
      DIN(1) = DVALS(3)
      DIN(2) = DVALS(4)
      CALL FPXWCO(-1,IMNO,DIN,DOUT,STAT)
      IF (STAT.NE.0) THEN
         WRITE(CBUF,10077) NMAL
         CALL STTPUT(CBUF,STAT)
         GOTO 2800
      ENDIF
      PCUR1(3) = REAL(DOUT(1))
      PCUR1(4) = REAL(DOUT(2))
CC       write(*,50000) pcur1(1),pcur1(2),pcur1(3),pcur1(4)
CC 50000 format('pcur1(1,2,3,4) = ',4f12.2)
C 
      IF (TBMAG.NE.0) THEN                     !that implies OPTION = 2 (RECT)
         CXSIZE = PCUR1(3) - PCUR1(1) + 1      !get size of pixel interval
         CYSIZE = PCUR1(4) - PCUR1(2) + 1
         NN = 2*(BAKPIX+NOMPIX)
         IF (TBMAG.EQ.1) THEN                  !pix_intv + BAKPIX + NOMPIX
            MAGPIX = CXSIZE
            MAGPIY = CYSIZE
            CXSIZE = CXSIZE + NN
            CYSIZE = CYSIZE + NN
         ELSE                                  !pix_intv - BAKPIX - NOMPIX
            MAGPIX = CXSIZE - NN
            MAGPIY = CYSIZE - NN
         ENDIF
         KXSIZE = CXSIZE
         KYSIZE = CYSIZE
      ENDIF
C 
      IF (CENTY.EQ.1) THEN
         CALL TBRRDD(TIDI,NMAL,2,INCOLN(10),DVALS(5),TABNUL,STAT)
         DIN(1) = DVALS(5)
         DIN(2) = DVALS(6)
         CALL FPXWCO(-1,IMNO,DIN,DOUT,STAT)
         IF (STAT.NE.0) THEN
            WRITE(CBUF,10077) NMAL
            CALL STTPUT(CBUF,STAT)
            GOTO 2800
         ENDIF
         XCC = REAL(DOUT(1))
         YCC = REAL(DOUT(2))
      ENDIF
C 
C  if center_flag = 0 .and. centy = 1, use `final' sized rectangle already
      IF ((CENTY.EQ.1) .AND. (CENTFL.EQ.0)) THEN         !use center from table
         IF (OPTION.EQ.3) THEN  
            PCUR1(1) = XCC 
            PCUR1(2) = YCC                      !use given areas, not the
            KXSIZE = CXSIZE                     !size of the mapped window
            KYSIZE = KXSIZE
         ELSE
            PCUR1(1) = XCC - CXSIZE/2 
            PCUR1(2) = YCC - CYSIZE/2
            PCUR2(1) = PCUR1(1)+ CXSIZE - 1
            PCUR2(2) = PCUR1(2)+ CYSIZE - 1
         ENDIF
      ELSE
         IF (OPTION.EQ.3) THEN  
            PCUR1(1) = (PCUR1(1)+PCUR1(3))/2             !get center
            PCUR1(2) = (PCUR1(2)+PCUR1(4))/2
            PCUR1(3) = PCUR1(3)-PCUR1(1)                 !get diameter
            PCUR1(4) = PCUR1(4)-PCUR1(2)
            KXSIZE = NINT((PCUR1(3)+PCUR1(4)))/2         !from mean radius
            KXSIZE = 2*KXSIZE + 1
            KYSIZE = KXSIZE
         ELSE
            DIN(1) = DVALS(3)
            DIN(2) = DVALS(4)
            CALL FPXWCO(-1,IMNO,DIN,DOUT,STAT)
            IF (STAT.NE.0) THEN
               WRITE(CBUF,10077) NMAL
               CALL STTPUT(CBUF,STAT)
               GOTO 2800
            ENDIF
            PCUR2(1) = REAL(DOUT(1))
            PCUR2(2) = REAL(DOUT(2))
         ENDIF
      ENDIF
CC       write(*,50000) pcur1(1),pcur1(2),pcur1(3),pcur1(4)
      NCOU = NCOU + 1
C 
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C      
C  common section for option a) and b) and c)
C
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C      
C  pull out subwindow of frame 
C 
3000  LOOPI = 0
      STAT1 = 0
      IF (OPTION.EQ.3) THEN               !circle
         NN = KXSIZE/2
         SPIX(1) = NINT(PCUR1(1)) - NN            !xstart in frame pixels
         SPIX(2) = NINT(PCUR1(2)) - NN            !ystart
         SPIX(3) = SPIX(1) + KXSIZE - 1           !xend
         SPIX(4) = SPIX(2) + KXSIZE - 1           !yend
      ELSE                                !rectangle
         SPIX(1) = NINT(PCUR1(1))                 !xstart in frame pixels
         SPIX(2) = NINT(PCUR1(2))                 !ystart
         SPIX(3) = NINT(PCUR2(1))                 !xend
         SPIX(4) = NINT(PCUR2(2))                 !yend
      ENDIF
      IAV = 0
C 
C  check for out-of-bounds
3030  N = 0
      IF (SPIX(1).LT.1) THEN
         WRITE(CBUF,10020) 'start x'
         CALL STTDIS(CBUF,0,STAT)
         NN = 1 - SPIX(1)
         SPIX(1) = 1
         SPIX(3) = MIN(SPIX(3)+NN,NPIX(1))
         N = 99
      ENDIF
      IF (SPIX(3).GT.NPIX(1)) THEN
         WRITE(CBUF,10020) 'end x'
         CALL STTDIS(CBUF,0,STAT)
         NN = SPIX(3) - NPIX(1)
         SPIX(3) = NPIX(1)
         SPIX(1) = MAX(SPIX(1)-NN,1)
         N = 99
      ENDIF
      IF (SPIX(2).LT.1) THEN
         WRITE(CBUF,10020) 'start y'
         CALL STTDIS(CBUF,0,STAT)
         NN = 1 - SPIX(2)
         SPIX(2) = 1
         SPIX(4) = MIN(SPIX(4)+NN,NPIX(2))
         N = 99
      ENDIF
      IF (SPIX(4).GT.NPIX(2)) THEN
         WRITE(CBUF,10020) 'end y'
         CALL STTDIS(CBUF,0,STAT)
         NN = SPIX(4) - NPIX(2)
         SPIX(4) = NPIX(2)
         SPIX(2) = MAX(SPIX(2)-NN,1)
         N = 99
      ENDIF
      XFIGU(1) = SPIX(3) - SPIX(1)
      YFIGU(1) = SPIX(4) - SPIX(2)
C 
C  check for changes
      IF (N.NE.0) THEN
         IF (IAV.NE.0) THEN
            CBUF(1:) = 
     +      'we should not come here - contact the ESO Midas team...'
            CALL STETER(47,CBUF)
         ENDIF
         CXSIZE = XFIGU(1) + 1
         CYSIZE = YFIGU(1) + 1
         KXS = CXSIZE
         KYS = CYSIZE
         KXSIZE = KXS
         KYSIZE = KYS
         IAV = 111
         GOTO 3030                       !check once more - should be o.k., now
      ENDIF
C 
      DIN(1) = SPIX(1)
      DIN(2) = SPIX(2)
      CALL FPXWCO(1,IMNO,DIN,DOUT,STAT)          !move from fp's to wco's
      IF (STAT.NE.0) THEN
         WRITE(CBUF,10070) DIN(1),DIN(2)
         CALL STETER(13,CBUF)
      ENDIF
C 
      DVALS(1) = DOUT(1)
      DVALS(2) = DOUT(2)
      DIN(1) = SPIX(3)
      DIN(2) = SPIX(4)
      CALL FPXWCO(1,IMNO,DIN,DOUT,STAT)
      IF (STAT.NE.0) THEN
         WRITE(CBUF,10070) DIN(1),DIN(2)
         CALL STETER(13,CBUF)
      ENDIF
C 
      DVALS(3) = DOUT(1)
      DVALS(4) = DOUT(2)
      DO 3100,IAV=1,4
         RVALS(IAV) = REAL(DVALS(IAV))
3100  CONTINUE
C 
3130  XOFF = SPIX(1) - 1.                       !offset from pixel 1 on
      YOFF = SPIX(2) - 1.
      INBUF(1) = NPIX(1)
      INBUF(2) = SPIX(4) - SPIX(2) + 1          !ysize
      KYSIZE = INBUF(2) 
C 
C check, if we have to augment working subimages
      IF (KYSIZE.GT.KYS) THEN
         CALL STFCLO(VIMNO1,STAT)
         CALL STFCLO(VIMNO2,STAT)
         N = NPIX(1)*KYSIZE             !full KYSIZE lines
         CALL STFCRE('virtual1',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +               N,VIMNO1,STAT)
         CALL STFMAP(VIMNO1,F_X_MODE,1,N,IAV,PNTRA,STAT)
         N = KXSIZE * KYSIZE            !KYSIZE lines * KXSIZE pixels
         CALL STFCRE('virtual2',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +               N,VIMNO2,STAT)
         CALL STFMAP(VIMNO2,F_X_MODE,1,N,IAV,PNTRC,STAT)
C 
         WRITE(CBUF,10071) KXSIZE,KYSIZE,KXS,KYS
         CALL STTPUT(CBUF,STAT)
         KXS = KXSIZE
         KYS = KYSIZE
      ENDIF
      INBUF(3) = 1
C 
C  get a y-stripe from disk + copy subwindow out
C 
      N = INBUF(1) * INBUF(2)               !size of y-dim stripe in frame
      NN = ((SPIX(2)-1)*NPIX(1)) + 1        !1. pixel in there
      CALL STFGET(IMNO,NN,N,IAV,MADRID(PNTRA),STAT)
C 
      NPIXT(1) = SPIX(3) - SPIX(1) + 1      !xsize, ysize to copy
      NPIXT(2) = INBUF(2)
      ALOW(1) = SPIX(1)                     !first x,y pixel in source
      ALOW(2) = 1                           !and destination frame
      HIGH(1) = SPIX(3)
      HIGH(2) = INBUF(2)
      CALL COPWND(MADRID(PNTRA),INBUF(1),MADRID(PNTRC),NPIXT,
     +            ALOW,BLOW,HIGH)
C 
C  get center points - but only once and if CENTFL = 1
C 
      IF (LOOPI.EQ.0) THEN
         IF ((CENTY.EQ.0).OR.(CENTFL.EQ.1)) THEN   
C 
C  use STACEN to get center
            INPUT(1) = 1                         !xstart
            INPUT(2) = NPIXT(1)                  !xend 
            INPUT(3) = 1                         !ystart
            INPUT(4) = NPIXT(2)                  !yend 
            NN = INPUT(4) - INPUT(3) + INPUT(2) - INPUT(1)
            IF (NN.GT.300)                       !marginal points = NN*2 < 600 !
     +         CALL STETER
     +         (7,'window too large for centering algorithm')
C      
            CALL STACEN(MADRID(PNTRC),NPIXT(1),NPIXT(2),'M',INPUT,XC,YC,
     +                  R1,R2,R3,R4,AMAG,STAT1)  !get x,y-center in subframe
            IF (STAT1.NE.0)
     +         CALL STTPUT('Cent. algorithm: center not in array...',
     +                     STAT)
            XCC = XC + XOFF                      !center in full frame
            YCC = YC + YOFF
         ELSE
            XC = XCC - XOFF                      !relate center to subwindow
            YC = YCC - YOFF
         ENDIF
C 
         DIN(1) = XCC
         DIN(2) = YCC
         CALL FPXWCO(1,IMNO,DIN,DVALS(5),STAT)        !move from fp's to wco's
         RR(1) = REAL(DVALS(5))
         RR(2) = REAL(DVALS(6))
C      
C  check, if we use recentered window or CSIZE .NE. KSIZE
C 
         IF ((CENTFL.EQ.1) .OR. 
     +       (KXSIZE.NE.CXSIZE) .OR. (KYSIZE.NE.CYSIZE)) THEN
            NN = CXSIZE / 2
            N = NINT(XCC) - NN          !relate to complete frame
            IAV = N - SPIX(1)                     !difference to old start
            XC = XC - IAV                         !update xcent accordingly
            SPIX(1) = N
            NN = CYSIZE / 2
            N = NINT(YCC) - NN
            IAV = N - SPIX(2)                     !difference to old start
            YC = YC - IAV                         !update ycent accordingly
            SPIX(2) = N
            SPIX(3) = SPIX(1) + CXSIZE - 1 
            SPIX(4) = SPIX(2) + CYSIZE - 1
            LOOPI = 1                             !avoid passing here again...
            GOTO 3130                   !go + extract new subframe
         ENDIF
      ENDIF
C      
C  actual magnitude algorithm
C      
      CALL JMAGN(OPTION,MADRID(PNTRC),NPIXT(1),NPIXT(2),NOMPIX,
     +           BAKPIX,FAC,XC,YC,AMAG,AMSIG,SKY,SSKY,APIX,FLUX,STAT)
C 
      R1 = 1.11
      IF (STAT1.EQ.0) THEN
         IF (STAT.LT.0) THEN
            IF (STAT.EQ.-2)
     +         CALL STTPUT('Mag. algorithm: center not in array...',
     +                     STAT)
            IF (STAT.EQ.-3)
     +         CALL STTPUT('Mag. algorithm: area too small...',STAT)
            AMAG = 0.
            AMSIG = 0.
            SKY = 0.
            SSKY = 0.
            FLUX = 0.
            R1 = -1.11
         ELSE IF (STAT.EQ.1) THEN
            CALL STTPUT(
     +           'Mag. algorithm: (Warning) source not in center ...',
     +           STAT)
         ELSE IF (STAT.EQ.2) THEN
            AMAG = 0.
            AMSIG = 0.
            FLUX = 0.
            CALL STTPUT
     +  ('Mag. algorithm: (Warning) flux not above sky background ...',
     +           STAT)
            R1 = -1.11
         ENDIF
      ENDIF
C      
      NCOOS = NCOOS + 1                  !increment coord. counter
      IF ((INFL.EQ.1).AND.(YESNO.EQ.1)) THEN     !for cursor input draw numbers
         IF (IDFL.EQ.1) THEN
            LABL = IDF
            NN = 1
            LLABL = INDEX(LABL,' ') - 1
         ELSE
            WRITE(LABL(5:),10011) NCOOS
            NN = 5
            DO 3900,N=5,7
               IF (LABL(N:N).EQ.' ') NN = N + 1
3900        CONTINUE
            LLABL = 9 - NN
         ENDIF
         IF (OPTION.NE.3) THEN                !place string right of center
            XYALP(1) = (BOX(1)+BOX(3))/2 + 5
            XYALP(2) = (BOX(2)+BOX(4))/2 + 2
         ELSE
            XYALP(1) = BOX(1) + 5
            XYALP(2) = BOX(2) + 2
         ENDIF
         CALL IIGTXT(QDSPNO,QOVCH,LABL(NN:),XYALP(1),XYALP(2),
     +               0,0,255,0,STAT)
      ENDIF
C
C  prepare results (but check for infinity, nan ... first)
      WRITE(CBUF,70001) AMAG
      CALL BADVAL(CBUF,N)
      IF (N.NE.1) THEN
         R1 = -1.11                          !magnitude algorithm failed!
      ENDIF
C 
      RVALS(5) = RR(1)
      RVALS(6) = RR(2)
      RVALS(7) = AMAG
      RVALS(8) = AMSIG
      RVALS(9) = SKY
      RVALS(10) = SSKY
      RVALS(11) = APIX
      RVALS(12) = FLUX
C      
      WRITE(CBUF,20005) (RVALS(N),N=5,8)
      CALL STTPUT(CBUF,STAT)
      WRITE(CBUF,20006) (RVALS(N),N=9,12)
      CALL STTPUT(CBUF,STAT)
      IF (IDFL.EQ.1) CALL STTPUT(IDF,STAT)
C
C  fill descriptor, table or nothing
      IF (OUTFL.EQ.1) THEN
         CALL STDWRR(IMNO,DESCR,RVALS,FELEM,LRVALS,UNI,STAT)   !fill descr
         FELEM = -1
      ELSE IF (OUTFL.GT.1) THEN                                !fill table
         N = NMAL + TBAPP
         IF (OUTFL.EQ.3) THEN        
            CALL TBRWRD(TIDO,N,4,OUCOLN(1),DVALS(1),STAT)
            CALL TBRWRD(TIDO,N,2,OUCOLN(10),DVALS(5),STAT)
            IF (IDFL.EQ.1) CALL TBEWRC(TIDO,N,OUCOLN(9),IDF,STAT)
         ELSE 
            IF (CENTY.NE.1) 
     +         CALL TBRWRD(TIDO,N,2,OUCOLN(10),DVALS(5),STAT)
            IF (IDFL.EQ.1) CALL TBEWRC(TIDO,N,OUCOLN(9),IDF,STAT)
         ENDIF
         CALL TBRWRR(TIDO,N,4,OUCOLN(5),RVALS(7),STAT)
         CALL TBRWRR(TIDO,N,2,OUCOLN(12),RVALS(11),STAT)
      ENDIF
C      
C  and loop again  (only for INFL=1,2)
C 
7000  IF (INFL.EQ.1) THEN 
         GOTO 1000
      ELSE IF (INFL.EQ.2) THEN 
         GOTO 2800
      ENDIF
C
C  That's it folks...
9000  IF (OUTFL.EQ.3) CALL TBSINI(TIDO,STAT)
      IF (TIDO.GE.0) THEN
         CALL STKRDC('MID$LINE',1,1,80,IAV,CBUF,UNI,NULO,STAT)
         CALL STDWRC(TIDO,'HISTORY',1,CBUF,-1,80,UNI,STAT)
      ENDIF
C      
C  save last set of data + no. of coordinates obtained
      CALL STKWRR('OUTPUTR',RVALS,1,LRVALS,UNI,STAT)
      CALL STKWRR('OUTPUTR',R1,XINDX,1,UNI,STAT)         !set control flag
      CALL STKWRD('OUTPUTD',DVALS,1,6,UNI,STAT)
      CALL STKWRI('OUTPUTI',NCOOS,1,1,UNI,STAT)
C      
      IF (INFL.EQ.1) THEN
         CALL DTCLOS(QDSPNO)
         CALL REFOVR(STAT)
      ENDIF
      CALL STSEPI
C      
C  format statements
10001 FORMAT(A,I4)
10003 FORMAT(A)
10010 FORMAT(I4.4)
10011 FORMAT(I4)
10020 FORMAT(A,
     + '-pixel out of frame ...')
10070 FORMAT('bad coord(s) - X, Y: ',2F20.10)
10071 FORMAT('new subwindow dims = ',I4,',',I4,' > ',I4,',',I4,
     +       ' (last dims)')
10072 FORMAT('Radii of Flux, Noman, Backgr = ',
     +       I4,',',I4,',',I4,' pixels, total diameter = ',I5)
10077 FORMAT('row no. ',I5,' contains bad coord(s) - we skip ...')
20004 FORMAT('diameter of circles according to Fsiz(',I3,
     + '),Nsiz(',I3,'),Bsiz(',I3,')')
20009 FORMAT('will be ',I3,',',I4,',',I4,' pixels')
20005 FORMAT(G13.7,1X,G13.7,1X,G11.5,1X,G11.5)
20006 FORMAT(6X,G13.7,1X,G13.7,1X,G13.7,1X,G13.7)
30000 FORMAT('Square too small for Fsize =',I3,' Bsize = ',I3)
70001 FORMAT('[',G12.5,']')
      END         

      SUBROUTINE PULLOU(CBUF,STEP,NDF,BDF,
     +                  MAGPIX,MAGPIY,NOMPIX,BAKPIX)
C      
      IMPLICIT NONE
C
      INTEGER    BAKPIX,MAGPIX,MAGPIY,NOMPIX
      INTEGER    BDF,NDF
      INTEGER    LL,COUNT
      INTEGER    OPTION,INFL,OUTFL,TBMAG
C
      CHARACTER*(*)  CBUF
      CHARACTER      SAVBUF*80,STRING*30
C
      DOUBLE PRECISION STEP(2)
C 
      COMMON  /FLAGS/  INFL,OUTFL,OPTION,TBMAG
C
      MAGPIY = -1
C 
      LL = INDEX(CBUF,',')               !we expect "a,b,c" or "a,b" or "a"
      IF (LL.LE.0) THEN                  !only "a" given
         NOMPIX = NDF
         BAKPIX = BDF
         CALL SPULLO(CBUF,STEP(1),MAGPIX)
         RETURN
      ENDIF
C
      IF (OPTION.EQ.2) THEN              !for RECT we may have magpix,magpiy,..
         IF (INFL.EQ.2) THEN             !for table input only...
            IF (CBUF(1:2).EQ.'+,') THEN
               TBMAG = 1                 !we use the table interval
               CBUF(1:) = CBUF(3:)
               MAGPIX = 1
               GOTO 4000
            ELSE IF (CBUF(1:2).EQ.'-,') THEN
               TBMAG = -1                !we use the table interval
               CBUF(1:) = CBUF(3:)
               MAGPIX = 1
               GOTO 4000
            ENDIF
         ENDIF
C 
         SAVBUF(1:) = CBUF(1:)
         DO 1000, COUNT=1,3
            LL = INDEX(CBUF,',')
            IF (LL.LE.0) GOTO 2000        !NO - magpiy = magpix
            CBUF(LL:LL) = '^'
1000     CONTINUE
C 
         LL = INDEX(CBUF,'^')
         STRING(1:) = CBUF(1:LL-1)//' '      !copy out "ax" from "ax,ay,b,c"
         CALL SPULLO(STRING,STEP(1),MAGPIX)
         CBUF = CBUF(LL+1:)//' '
         LL = INDEX(CBUF,'^')
         STRING(1:) = CBUF(1:LL-1)//' '      !copy out "ay" 
         CALL SPULLO(STRING,STEP(2),MAGPIY)
         CBUF = CBUF(LL+1:)//' '
         LL = INDEX(CBUF,'^')
         STRING(1:) = CBUF(1:LL-1)//' '      !copy out "b" from "a,b,c"
         CALL SPULLO(STRING,STEP(1),NOMPIX)
         CALL SPULLO(CBUF(LL+1:),STEP(1),BAKPIX)
         RETURN
C 
2000     CBUF(1:) = SAVBUF(1:)
         LL = INDEX(CBUF,',')               !reset LL
       ENDIF
C 
      STRING(1:) = CBUF(1:LL-1)//' '         !copy out "a" from "a,b" or "a,b,c"
      CALL SPULLO(STRING,STEP(1),MAGPIX)
      CBUF = CBUF(LL+1:)//' '
C 
4000  LL = INDEX(CBUF,',')
      IF (LL.LE.0) THEN                      !only "a,b" given
         BAKPIX = BDF
         CALL SPULLO(CBUF,STEP(1),NOMPIX)
      ELSE
         STRING(1:) = CBUF(1:LL-1)//' '      !copy out "b" from "a,b,c"
         CALL SPULLO(STRING,STEP(1),NOMPIX)
         CALL SPULLO(CBUF(LL+1:),STEP(1),BAKPIX)
      ENDIF
C      
      RETURN
      END

      SUBROUTINE BADVAL(CBUF,OK)
C      
      IMPLICIT NONE
C      
      INTEGER    OK
C 
      CHARACTER*(*)      CBUF
      CHARACTER*24       MYBUF
      DATA       MYBUF /' '/
C      
      CALL UPCAS(CBUF,MYBUF)
      IF (INDEX(MYBUF,'INF').GE.1) THEN
         OK = -1
      ELSE IF (INDEX(MYBUF,'NAN').GE.1) THEN
         OK = -1
      ELSE
         OK = 1
      ENDIF

      RETURN
      END

      SUBROUTINE SPULLO(CBUF,STEP,PIX)
C      
      IMPLICIT NONE
C      
      INTEGER    PIX
      INTEGER    SL
C      
      CHARACTER*(*)      CBUF
C      
      REAL     RR
C 
      DOUBLE PRECISION   STEP,DD
C      
      IF (CBUF(1:1).EQ.'@') THEN
         CALL GENCNV(CBUF(2:),1,1,PIX,RR,DD,SL)
         IF (SL.LE.0) PIX = -1            !indicate wrong syntax...
      ELSE
         CALL GENCNV(CBUF(1:),4,1,PIX,RR,DD,SL)
         IF (SL.LE.0) THEN
            PIX = -1            !indicate wrong syntax...
         ELSE
            PIX = NINT(DD/STEP)
         ENDIF
      ENDIF
C      
      RETURN
      END

C @(#)wtape.for	19.1 (ES0-DMD) 02/25/03 14:32:28
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT    (c) 1989  European Southern Observatory
C.LANGUAGE     VAX/VMS FORTRAN
C.IDENT        wtape.for
C.AUTHOR       P.Grosbol   ESO/IPG
C.KEYWORDS     copy file to tape, write tape
C.ENVIRON      VAX/VMS
C.PURPOSE      copy FITS file in byte stream format to mag. tape
C.VERSION      1.0  1989-Mar-12 : Creation,   PJG
C--------------------------------------------------------------------
      PARAMETER     (MBUF=31680,NFLR=2880)
C
      LOGICAL*1     BUF(MBUF)
C
      LOGICAL       FITS
      INTEGER       NO,NOF,N,REC,NR,DEN
      INTEGER       MB,IDX,NB,I,BF,FDO
      INTEGER       DEFLIST,GETLIST,IOWRITE,IOOPEN,IOWEOF
      CHARACTER*9   SIMPLE
      CHARACTER*64  LIST,APP,OUTPUT,PREFIX,INPUT
C
      SIMPLE(1:9) = 'SIMPLE  ='
C
C     READ PARAMETERS
C
      WRITE(6,601)
  601 FORMAT(' Name of output tape unit   : ',$)
      READ(5,500) OUTPUT
  500 FORMAT(A)
      WRITE(6,602)
  602 FORMAT(' Prefix on FITS filename    : ',$)
      READ(5,500) PREFIX
      IPF = INDEX(PREFIX,' ') - 1
      WRITE(6,603)
  603 FORMAT(' List of file no. to copy   : ',$)
      READ(5,500) LIST
      IF (DEFLIST(LIST).NE.0)  THEN
         WRITE(6,690)
  690    FORMAT(' Error: Invalid list specification')
         GOTO 90000
      ENDIF
      WRITE(6,604)
  604 FORMAT(' Append file to tape (Y/N)  : ',$)
      READ(5,500) APP
      WRITE(6,605)
  605 FORMAT(' Tape density in bpi        : ',$)
      READ(5,*) DEN
C
C     GET BLOCKING FACTOR AND CHECK IT
C
      WRITE(6,606)
  606 FORMAT(' FITS blocking factor (1-10): ',$)
      READ(5,*) BF
      BF = MAX( 1 , MIN( 10, BF ) ) * NFLR
C
C     OPEN MAG. TAPE UNIT
C
      FDO = IOOPEN(OUTPUT,1,DEN)
      IF (FDO.LE.0) THEN
         WRITE(6,691)
  691    FORMAT(' Error: Cannot open mag. tape unit')
         GOTO 90000
      ENDIF
C
C     POSITION TAPE
C
      IF (APP(1:1).NE.'n'.AND.APP(1:1).NE.'N') THEN ! move to end of tape
         WRITE(6,692)
  692    FORMAT(' Files will be appended to tape!')
         N = IOREAD(FDO,BUF,BF)
         IF (N.LE.0) THEN
            WRITE(6,693)
  693       FORMAT(' Warning: Tape was empty!')
            CALL IOBSF(FDO,1)
         ELSE                                     ! not empty - skip to end
  300       CONTINUE
            CALL IOFSF(FDO,1)
            N = IOREAD(FDO,BUF,BF)
            IF (N.GT.0) GOTO 300
            CALL IOBSF(FDO,1)                     ! position between EOF's
         ENDIF
      ENDIF
C
C     COPY FILE BY FILE
C
 1000 IF (GETLIST(NOF).EQ.0) GOTO 5000
         WRITE(INPUT,610) PREFIX(1:IPF),NOF
  610    FORMAT(A,I4.4,'.mt')
         IIP = INDEX(INPUT,' ') - 1
         OPEN(UNIT=10,FILE=INPUT(1:IIP),RECORDTYPE='FIXED',
     ,        ACCESS='SEQUENTIAL',FORM='UNFORMATTED',
     ,        STATUS='OLD',IOSTAT=IOS)
         IF (IOS.NE.0) GOTO 1000
         INQUIRE(UNIT=10,RECL=MNO)
         MNO = 4 * MNO
         REC = 0
         IDX = 1
         NR = 0
         MB = MBUF - NFLR
 2000    CONTINUE                                 ! copy block by block
           LIDX = IDX + MNO - 1
           READ(10,END=2005) (BUF(I),I=IDX,LIDX)
           NO = MNO
           GOTO 2010
 2005      NO = 0
 2010      CONTINUE
           NR = NR + 1
      print *,'Block read ',NR,IDX,NO
           IF (NR.EQ.1.AND.NO.GT.0) THEN          ! check if FITS file
              FITS = .TRUE.
              DO 2100, I = 1,9
                 FITS = FITS .AND. BUF(I).EQ.ICHAR(SIMPLE(I:I))
 2100         CONTINUE
              IF (.NOT.FITS) THEN                 ! no FITS file - skip
                 WRITE(6,695) INPUT(1:IIP)
  695            FORMAT(' Error: >',A,'< not FITS format - skipped!')
                 CLOSE(10)
                 GOTO 1000
              ENDIF
           ENDIF
           IF (NO.GT.0) IDX = IDX + NO
           IF (BF.LT.IDX .OR. NO.LE.0) THEN     ! write block to tape
              NB = 1
              N = ((IDX-1)/NFLR) * NFLR
              N = MIN( BF, N )
 3000         IF (N.LT.1.OR.N.GT.IDX-NB) GOTO 4000
                 I = IOWRITE(FDO,BUF(NB),N)
      print *,'Block to tape ',REC,I,NB
                 IF (I.LT.0) THEN               ! End of tape reached
                    CALL IOBSF(FDO,1)
                    CALL IOWEOF(FDO)
                    CLOSE(10)
                    WRITE(6,696)
  696               FORMAT(' Warning: End of tape MARK detected!')
                    CALL IOCLOSE(FDO)
                    GOTO 90000
                 ENDIF
                 NB = NB + I
                 REC = REC + 1
              GOTO 3000
 4000         CONTINUE
              N = IDX - 1
              IDX = 1
              DO 2300, I = NB,N
                 BUF(IDX) = BUF(I)
                 IDX = IDX + 1
 2300         CONTINUE
           ENDIF
         IF (NO.GT.0) GOTO 2000
         CLOSE(10)
         IF (REC.GT.0) THEN
            I = IOWEOF(FDO)
            WRITE(6,630) INPUT(1:IIP),REC
  630       FORMAT(' File >',A,'< written to tape with ',I5,' records')
         ENDIF
      GOTO 1000
C
C     FINISHED - CLOSE FILES AND EXIT
C
 5000 CONTINUE
      CALL IOWEOF(FDO)
      CALL IOBSF(FDO,1)
90000 CONTINUE
      END

C @(#)edist.for	19.1 (ES0-DMD) 02/25/03 13:27:14
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                         C
C  Determine standardized distances.                                      C
C                                                                         C
C  To call:   CALL DIST(N,M,DATA,A,W1,W2)              where              C
C                                                                         C
C                                                                         C
C  N, M  : integer dimensions of ...                                      C
C  DATA  : input data.                                                    C
C  A     : distances matrix (dimensions N by N).                          C
C  W1,W2 : real vectors of dimension N.                                   C
C                                                                         C
C  F. Murtagh, ST-ECF/ESA/ESO, Garching-bei-Muenchen, January 1986.       C
C                                                                         C
C-------------------------------------------------------------------------C
        SUBROUTINE DIST(N,M,DATA,A,W1,W2)
        INTEGER N,M
        REAL    DATA(N,M), A(N,N), W1(N), W2(N)
C
        CALL DST(N,M,DATA,W1,W2,A)
C
        RETURN
        END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                         C
C  Determine inter-row distances.                                         C
C  First determine the means, storing in WORK1.                           C
C                                                                         C
C-------------------------------------------------------------------------C
        SUBROUTINE DST(N,M,DATA,WORK1,WORK2,OUT,ISTAT)
        INTEGER         N,M,ISTAT,I1,J,I2
        REAL       DATA(N,M), OUT(N,N), WORK1(N), WORK2(N)
        REAL EPS
        DATA            EPS/1.E-10/
C
        DO 100 I1 = 1, N-1
           OUT(I1,I1) = 1.0
           DO 90 I2 = I1+1, N
              OUT(I1,I2) = 0.0
              DO 80 J = 1, M
                 OUT(I1,I2) = OUT(I1,I2) + (DATA(I1,J)-DATA(I2,J))**2
   80         CONTINUE
              OUT(I1,I2) = OUT(I1,I2)/FLOAT(M)
              OUT(I2,I1) = OUT(I1,I2)
   90      CONTINUE
  100   CONTINUE
        OUT(N,N) = 1.0
C
        RETURN
        END

C===========================================================================
C Copyright (C) 1995-2005 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
CC
CC  *LSL* : CALCULATES THE (REWEIGHTED) LS WHEN 'NVAR' EQUALS 1
CC          AND 'JCST'=0.
CC
       SUBROUTINE LSL(NCAS,NDXY,X,Y,RESDU,A,FCKW,H,NMXV,NDXX)

       INCLUDE 'MID_REL_INCL:implicit.inc'

       DOUBLE PRECISION H(NMXV,NDXX)
       DIMENSION A(NMXV),X(NDXX,NDXY),Y(NDXY),RESDU(NDXY)

       AL=NCAS
       SXY=0.0
       SX2=0.0
       DO 10 JNC=1,NCAS
       SXY=SXY+X(1,JNC)*Y(JNC)*RESDU(JNC)
       SX2=SX2+(X(1,JNC)**2)*RESDU(JNC)
 10    CONTINUE
       A(1)=SXY/SX2
       FCKW=0.0
       DO 20 JNC=1,NCAS
 20    FCKW=FCKW+( (Y(JNC)-X(1,JNC)*A(1))**2 )*RESDU(JNC)
       H(1,1)=DBLE((FCKW/(AL-1.0))/SX2)
       RETURN
       END
CC
CC  *FCN* : PUTS A ROW OF THE MATRIX X IN A VECTOR.
CC
       SUBROUTINE FCN(K,M,F,X,JFLAG)

       INCLUDE 'MID_REL_INCL:implicit.inc'

       DIMENSION F(K),X(M)

       DO 10 J=1,K
       F(J)=X(J)
 10    CONTINUE
       RETURN
       END
CC
CC  *LSREG* : CALCULATES THE LEAST SQUARES REGRESSION ESTIMATES.
CC
      SUBROUTINE LSREG(NDXX,NDXY,NMXV,K,N,M,F,X,Y,W,DA,
     1 H,FCKW,HVEC,JDMB,JNDEX)

       INCLUDE 'MID_REL_INCL:implicit.inc'

      DIMENSION X(NDXX,NDXY),F(K),Y(N),W(N),H(NMXV,NDXX),DA(K)
      DIMENSION HVEC(JDMB),JNDEX(NDXX)
      DOUBLE PRECISION H,HVEC,DTEM,DFCKW,DFACT
      DOUBLE PRECISION DWJNC,DYJ,DFKA

      KPLUS=K+1
      DO 10 JNC=1,K
      DO 20 J=1,KPLUS
      H(JNC,J) = 0.D0
 20   CONTINUE
 10   CONTINUE
      JFLAG=1
      ANUL=0.0
      DO 30 JNC=1,N
      CALL FCN(K,M,F,X(1,JNC),JFLAG)
      JFLAG=4
      DWJNC = DBLE(W(JNC))
      ANUL=ANUL+W(JNC)
      DYJ = DBLE(Y(JNC))
      DO 40 KA=1,K
      DFKA = DBLE(F(KA))
      H(KA,K+1) = H(KA,K+1) + DWJNC*DFKA*DYJ
      DO 50 L=1,KA
      H(KA,L) = H(KA,L) + DWJNC*DFKA*DBLE(F(L))
 50   CONTINUE
 40   CONTINUE
 30   CONTINUE
      DO 60 J=1,K
      DO 70 JNC=1,J
      H(JNC,J)=H(J,JNC)
 70   CONTINUE
 60   CONTINUE
      CALL MATNV(H,NMXV,NDXX,HVEC,JDMB,K,1,NERR,DTEM,JNDEX)
      MM=K+1
      FCKW = QLSRG(K,N,M,NDXX,NDXY,NMXV,F,X,Y,W,DA,H,MM)
      DO 80 JNC=1,K
      F(JNC)=H(JNC,K+1)
 80   CONTINUE
      DFCKW=DBLE(FCKW)
      ANK=ANUL-K
      DFACT=DBLE(ANK)
      DFACT=DFCKW/DFACT
      DO 90 JNC=1,K
      DO 100 J=1,K
      H(JNC,J)=H(JNC,J)*DFACT
 100  CONTINUE
 90   CONTINUE
      DO 110 JNC=1,K
      HDA=H(JNC,JNC)
      DA(JNC)=SQRT(HDA)
 110  CONTINUE
      RETURN
      END
CC
CC  *QLSRG* : EVALUATES THE OBJECTIVE FUNCTION FOR LS REGRESSION.
CC
      FUNCTION QLSRG(K,N,M,NDXX,NDXY,NMXV,F,X,Y,W,DA,H,MM)

       INCLUDE 'MID_REL_INCL:implicit.inc'

      DIMENSION F(K),X(NDXX,NDXY),DA(K),H(NMXV,NDXX),Y(N),W(N)
      DOUBLE PRECISION H,Q,HSUM

      JFLAG = 4
      Q=0.
      DO 30 JNC=1,N
      CALL FCN(K,M,F,X(1,JNC),JFLAG)
      HSUM=0.
      DO 20 JNCB=1,K
 20   HSUM=H(JNCB,MM)*F(JNCB)+HSUM
 30   Q=(HSUM-Y(JNC))*(HSUM-Y(JNC))*W(JNC)+Q
      QLSRG = Q
      RETURN
      END
CC
CC  *MATNV* : PERFORMS A MATRIX INVERSION.
CC
      SUBROUTINE MATNV(AM,NMXV,NDXX,HVEC,JDMB,NA,NB,NERR,DTEM,JNDEX)

       INCLUDE 'MID_REL_INCL:implicit.inc'

      DOUBLE PRECISION AM,HVEC,DTEM,DETER,TURN,SWAP
      DIMENSION HVEC(JDMB),JNDEX(NDXX),AM(NMXV,NDXX)

      DETER=1.0D0
      N=NA
      NPNB=N+NB
      JNK=0
      DO 10 J=1,NPNB
      JNK=(J-1)*NMXV
      DO 10 NC=1,NMXV
      JNK=JNK+1
      HVEC(JNK)=AM(NC,J)
 10   CONTINUE
      JDM=NMXV
      NMA=N-1
      JDELC=1-JDM
      DO 130 JHFD=1,N
      TURN=0.0D0
      JDELC=JDELC+JDM
      JDLA=JDELC+JHFD-1
      JDLB=JDELC +NMA
      DO 40 JNCB=JDLA,JDLB
      IF(DABS(HVEC(JNCB))-DABS(TURN)) 40,40,30
 30   TURN=HVEC(JNCB)
      LDEL=JNCB
 40   CONTINUE
      IF(TURN) 50,170,50
 50   JPAAL=LDEL-JDELC+1
      JNDEX(JHFD)=JPAAL
      IF(JPAAL-JHFD) 80,80,60
 60   DETER=-DETER
      JPAAL=JPAAL-JDM
      JNCD=JHFD-JDM
      DO 70 JNC=1,NPNB
      JPAAL=JPAAL+JDM
      JNCD=JNCD+JDM
      SWAP=HVEC(JNCD)
      HVEC(JNCD)=HVEC(JPAAL)
 70   HVEC(JPAAL)=SWAP
 80   DETER=DETER*TURN
      TURN=1./TURN
      JNCD=JDELC+NMA
      DO 90 JNC=JDELC,JNCD
 90   HVEC(JNC)=-HVEC(JNC)*TURN
      HVEC(JDLA)=TURN
      JNCB=JHFD-JDM
      JPAAL=1-JDM
      DO 120 JNC=1,NPNB
      JPAAL=JPAAL+JDM
      JNCB=JNCB+JDM
      IF(JNC-JHFD) 100,120,100
 100  JCL=JPAAL+NMA
      SWAP=HVEC(JNCB)
      JNCD=JDELC-1
      DO 110 JNCC=JPAAL,JCL
      JNCD=JNCD+1
 110  HVEC(JNCC)=HVEC(JNCC)+SWAP*HVEC(JNCD)
      HVEC(JNCB)=SWAP*TURN
 120  CONTINUE
 130  CONTINUE
      DO 160 JNCB=1,N
      JHFD=N+1-JNCB
      LDEL=JNDEX(JHFD)
      IF(LDEL-JHFD) 140,160,140
 140  JPAAL=(LDEL-1)*JDM+1
      JCL=JPAAL+NMA
      JDELC=(JHFD-1)*JDM+1-JPAAL
      DO 150 JNCC=JPAAL,JCL
      JNCD=JNCC+JDELC
      SWAP=HVEC(JNCC)
      HVEC(JNCC)=HVEC(JNCD)
 150  HVEC(JNCD)=SWAP
 160  CONTINUE
      DTEM=DETER
      NERR=0
      GOTO 180
 170  NERR=JHFD
      DTEM=DETER
 180  JNK=0
      DO 190 J=1,NPNB
      DO 190 NC=1,NMXV
      JNK=JNK+1
      AM(NC,J)=HVEC(JNK)
 190  CONTINUE
      RETURN
      END
CC
CC  *LCAT* : CALCULATES LOCATION ESTIMATES.
CC
       SUBROUTINE LCAT(NCAS,NVAR,JCST,JPRT,NVAD,X,Y,RESDU,WEIGHTS,PREC,
     1 XMED,XMAD,NZWE,AVW,JPLT,AW,NMVAL,NDXX,NDXY,MVAL,LUA,LUB,LUC,
     1 JREG,JHEAD,FNAMEA,FNAMEB,FNAMEC,YNSAVE,LAB,JFMT,JVARS,YN,JPLACE)

       INCLUDE 'MID_REL_INCL:implicit.inc'

       DIMENSION A(11),X(NDXX,NDXY),Y(NDXY),RESDU(NDXY),WEIGHTS(NDXY)
       DIMENSION XMED(NDXX),XMAD(NDXX),AW(NDXY),NMVAL(NDXY),JPLACE(NDXX)
       CHARACTER YN,YNSAVE
       CHARACTER*10 LAB(NDXX)
       CHARACTER*30 FNAMEA,FNAMEB,FNAMEC
       CHARACTER*60 JFMT,JHEAD
       CHARACTER*80 CBUF
       INTEGER      ISTAT
       LOGICAL      NULL
       INTEGER      STATUS

 10    WRITE(LUB,8000) NCAS
       WRITE(LUB,8010) JHEAD
       IF (JPRT.EQ.0) THEN
          WRITE(LUB,8020)
       ELSEIF (JPRT.EQ.1) THEN
          WRITE(LUB,8030)
       ELSEIF (JPRT.EQ.2) THEN
          WRITE(LUB,8040)
       ENDIF  
       IF (JPLT.NE.0) WRITE(LUB,8050)
       DO 5 J=1,11
 5     A(J)=0.0
       IF (NCAS.LE.2) THEN
          WRITE(CBUF,8070) NCAS
          CALL STTPUT(CBUF,ISTAT)
          STOP
       ENDIF
       IF (FNAMEA.EQ.'CON') THEN
          WRITE(CBUF,8060)
          CALL STTPUT(CBUF,ISTAT)
       ENDIF	  
       DO 40 JNC=1,NCAS
       NMVAL(JNC)=JNC
       IF (FNAMEA.EQ.'CON'.AND.JNC.EQ.1) THEN
           WRITE(CBUF,8080) JNC
       	   CALL STTPUT(CBUF,ISTAT)
       ENDIF   
       IF (FNAMEA.EQ.'CON'.AND.JNC.NE.1) THEN
           WRITE(CBUF,8090) JNC
           CALL STTPUT(CBUF,ISTAT)
       ENDIF
       IF (YN.NE.'Y') GOTO 30
C       READ(LUA,*) (AW(J),J=1,JVARS)
       JH=JPLACE(NVAD)

       CALL TBERDR(LUA,JNC,JH,AW(JH),NULL,STATUS)
       CALL STTPUT('Module PRE.F/LCAT: Beware the selection flag',
     1 ISTAT) 

       Y(JNC)=AW(JH)
       IF (YNSAVE.EQ.'Y') WRITE(LUC,*) Y(JNC)
       GOTO 40
 30    READ(LUA,JFMT) (AW(J),J=1,JVARS)
       JH=JPLACE(NVAD)
       Y(JNC)=AW(JH)
       IF (YNSAVE.EQ.'Y') WRITE(LUC,JFMT) Y(JNC)
 40    X(1,JNC)=Y(JNC)
       IF (YNSAVE.EQ.'Y') CLOSE(LUC,STATUS='KEEP')
       IF (MVAL.NE.0) CALL SMISLOC(NCAS,NDXX,NDXY,X,Y,NMVAL,NSTOP)
       IF (NCAS.LE.2) THEN
          WRITE(CBUF,8070) NCAS
          CALL STTPUT(CBUF,ISTAT)
          STOP
       ENDIF
       IF (NSTOP.EQ.1) STOP
       AL=NCAS
       ANVAR=NVAR
       JQU=INT(AL/2.0)+INT((ANVAR+1.0)/2.0)
       IF (JPRT.EQ.0) GOTO 60
       WRITE(LUB,8100)
       DO 50 JNC=1,NCAS
 50    WRITE(LUB,8110) JNC,Y(JNC)
 60    XMED(1)=AMDAN(AW,NDXY,Y,NCAS)
       DO 70 JNC=1,NCAS
       RESDU(JNC)=ABS(Y(JNC)-XMED(1))
 70    A(1)=A(1)+Y(JNC)
       XMAD(1)=AMDAN(AW,NDXY,RESDU,NCAS)
       XMAD(2)=XMAD(1)*1.4826
       WRITE(LUB,8120) XMED(1),XMAD(2)
       IF (ABS(XMAD(1)).LE.1.0E-12) THEN
          WRITE(LUB,8125)
          STOP
       ENDIF
       WRITE(LUB,8130)
       A(1)=A(1)/AL
       DO 80 JNC=1,NCAS
 80    A(2)=A(2)+(Y(JNC)-A(1))**2
       A(2)=SQRT(A(2)/(AL-1.0))
       WRITE(LUB,8140) A(1),A(2)
       JREG=1
       CALL RDUAL(A,0,NVAD,NCAS,NVAR,JCST,JPRT,NVAD,LUB,PREC,JREG,
     1 X,Y,RESDU,WEIGHTS,XMED,XMAD,NZWE,AVW,JPLT,AW,NMVAL,
     1 NDXX,NDXY,JHEAD,LAB)
 90    WRITE(LUB,8130)
       CALL RANGS(Y,NCAS)
       CALL SHHLF(Y,NCAS,JQU,SLUTN,BSTD,PREC)
       BSTD=BSTD*1.4826*(5.0/(AL-ANVAR)+1.0)
       WRITE(LUB,8150) SLUTN,BSTD
       A(1)=SLUTN
       A(2)=BSTD
CC-----DETERMINATION OF THE WEIGHTS
       NZWE=0
       DO 100 JNC=1,NCAS
       Y(JNC)=X(1,JNC)
       RESDU(JNC)=(Y(JNC)-A(1))/A(2)
       IF (ABS(RESDU(JNC)).LT.2.5) THEN
          WEIGHTS(JNC)=1.0
          NZWE=NZWE+1
                                   ELSE
          WEIGHTS(JNC)=0.0
       ENDIF
       write(CBUF,*) jnc,y(jnc),resdu(jnc),nzwe,weights(jnc)
       CALL STTPUT(CBUF,ISTAT)
 100   CONTINUE
       AVW=(NZWE*1.0)/AL
       AL=NZWE
       JREG=2
       CALL RDUAL(A,1,NVAD,NCAS,NVAR,JCST,JPRT,NVAD,LUB,PREC,JREG,
     1 X,Y,RESDU,WEIGHTS,XMED,XMAD,NZWE,AVW,JPLT,AW,NMVAL,
     1 NDXX,NDXY,JHEAD,LAB)
       WRITE(LUB,8130)
       WRITE(LUB,8160)
       IF (NZWE.LE.2) THEN
          WRITE(CBUF,8170) NZWE
          CALL STTPUT(CBUF,ISTAT)
          STOP
       ENDIF
       A(1)=0.0
       A(2)=0.0
       DO 110 JNC=1,NCAS
 110   A(1)=A(1)+Y(JNC)*WEIGHTS(JNC)
       A(1)=A(1)/AL
       DO 120 JNC=1,NCAS
 120   A(2)=A(2)+((Y(JNC)-A(1))**2)*WEIGHTS(JNC)
       A(2)=SQRT(A(2)/(AL-1.0))
       WRITE(LUB,8180) A(1),A(2)
       WRITE(LUB,8190) NZWE
       WRITE(LUB,8200) AVW
       JREG=3
       CALL RDUAL(A,2,NVAD,NCAS,NVAR,JCST,JPRT,NVAD,LUB,PREC,JREG,
     1 X,Y,RESDU,WEIGHTS,XMED,XMAD,NZWE,AVW,JPLT,AW,NMVAL,
     1 NDXX,NDXY,JHEAD,LAB)
 130   WRITE (LUB,8130)
       WRITE(CBUF,8210)
       CALL STTPUT(CBUF,ISTAT)
       IF (YNSAVE.EQ.'Y') THEN
          WRITE(CBUF,8220) FNAMEC
          CALL STTPUT(CBUF,ISTAT)
       ENDIF   
       IF (FNAMEA.NE.'CON') THEN
          WRITE(CBUF,8230) FNAMEA
          CALL STTPUT(CBUF,ISTAT)
       ENDIF	  
       IF (FNAMEB.NE.'CON'.AND.FNAMEB.NE.'PRN') THEN
          WRITE(CBUF,8240) FNAMEB
          CALL STTPUT(CBUF,ISTAT)
       ENDIF	   
       IF (JPRT.NE.10) STOP
 8000  FORMAT(1X,34('*')/' * ROBUST ESTIMATION OF LOCATION. *'/
     1 1X,34('*')///' NUMBER OF CASES = ',I5//)
 8010  FORMAT(' DATA SET = ',A60/)
 8020  FORMAT(/' THE DESIRED OUTPUT IS SMALL.'/)
 8030  FORMAT(/' THE DESIRED OUTPUT IS MEDIUM-SIZED.'/)
 8040  FORMAT(/' THE DESIRED OUTPUT IS LARGE.'/)
 8050  FORMAT(/' AN INDEX PLOT WILL BE DRAWN.'/)
 8070  FORMAT(/' THERE ARE ONLY ',I4,' CASES. THE ANALYSIS MUST',
     1 ' BE STOPPED.'/)
 8060  FORMAT(//' PLEASE ENTER YOUR DATA.'/)
 8080  FORMAT(1X,' THE DATA FOR CASE NUMBER ',I4,' : ',$)
 8090  FORMAT(' THE DATA FOR CASE NUMBER ',I4,' : ',$)
 8100  FORMAT(' THE OBSERVATIONS ARE:'/)
 8110  FORMAT(I5,2X,F10.4)
 8120  FORMAT(//' THE MEDIAN',12X,'= ',F11.4,2X,
     1 ' THE MAD (X 1.4826)',4X,'= ',F11.4/)
 8125  FORMAT(/' MORE THAN HALF OF THE DATA ARE EQUAL.'//)
 8130  FORMAT(/1X,78('*')/)
 8140  FORMAT(//' THE MEAN',14X,'= ',F11.4,2X,
     1 ' STANDARD DEVIATION',4X,'= ',F11.4//)
 8150  FORMAT(//' LMS',19X,'= ',F11.4,3X,
     1 'CORRESPONDING SCALE',3X,'= ',F11.4//)
 8160  FORMAT(/' REWEIGHTING USING THE WEIGHTS BASED ON THE LMS.'/
     1 1X,47('*')/)
 8170  FORMAT(/' THERE ARE ONLY ',I4,' CASES WITH NON-ZERO WEIGHT.'/
     1 ' THE ANALYSIS MUST BE STOPPED.'/)
 8180  FORMAT(//' WEIGHTED MEAN',9X,'= ',F11.4,2X,
     1 ' WEIGHTED STAND. DEV.  = ',F11.4//)
 8190  FORMAT(/' THERE ARE',2X,I4,' POINTS WITH NON-ZERO WEIGHT. ')
 8200  FORMAT(/' AVERAGE WEIGHT',13X,'= ',F20.6//)
 8210  FORMAT(////' THE RUN HAS SUCCESSFULLY BEEN EXECUTED . '//)
 8220  FORMAT(' THE DATA IS SAVED IN FILE : ',A30)
 8230  FORMAT(' THE DATA HAS BEEN READ FROM FILE : ',A30)
 8240  FORMAT(' THE OUTPUT HAS BEEN WRITTEN IN FILE : ',A30)
       RETURN
       END
CC
CC   *SMISLOC* : handling of missing values in the case of location
CC
       SUBROUTINE SMISLOC(NCAS,NDXX,NDXY,X,Y,NMVAL,NSTOP)

       INCLUDE 'MID_REL_INCL:implicit.inc'

       DIMENSION X(NDXX,NDXY),Y(NDXY),NMVAL(NDXY)
       CHARACTER*80 CBUF
       INTEGER      ISTAT
 
       MAXM=(NCAS*4)/5
       JND=0
       JCAS=0
CC-----GIVE THE MISSING VALUE CODE
       WRITE(CBUF,8000)
       CALL STTPUT(CBUF,ISTAT)
  5    READ(*,*,ERR=50)CODE
       DO 10 JNC=1,NCAS
       IF (Y(JNC).EQ.CODE) THEN
          JND=JND+1
                           ELSE
          JCAS=JCAS+1
          X(1,JCAS)=Y(JNC)
          NMVAL(JCAS)=JNC
       ENDIF
 10    CONTINUE
       NCAS=JCAS
       WRITE(CBUF,8010) NCAS
       CALL STTPUT(CBUF,ISTAT)
       IF (JND.GT.MAXM) THEN
           CALL STTPUT('More than 80 percent of the cases had to 
     1   be deleted because of the missing values.',ISTAT) 
           CALL STTPUT('The analysis will be stopped.',ISTAT)
          NSTOP=1
          RETURN
       ENDIF
       DO 20 JNC=1,NCAS
             Y(JNC)=X(1,JNC)
 20    CONTINUE
       RETURN
 50    CALL STETER('Error reading input!')
       RETURN

 8000  FORMAT(/' Please enter the value of this variable which'/
     1 ' has to be interpreted as the missing value code : ',$)
 8010  FORMAT(/' There are ',I4,' cases staying in the analysis.'/)
       END

C=========================================================================== 
C 
Copyright (C) 1995-2010 European Southern Observatory (ESO) 
C 
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.  
C 
C This program is distributed in the hope that it will be useful, 
C but WITHOUT ANY WARRANTY; without even the implied warranty of 
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
C GNU General Public License for more details.  
C 
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM REBIN
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  program    REBIN			version 1.00	881028
C  K. Banse             	     	ESO - Garching
C  from version 3.30 as of 871215 of VMS based REBIN.FOR
C
C.KEYWORDS
C  linear rebinning
C
C.PURPOSE
C  rebin an image, i.e. calculate new gridpoints with new stepsizes
C
C.ALGORITHM
C  get the names of input + output frames from IN_A + OUT_A
C  scale everything down to unity, i.e. original grid will have distances = 1.
C  start point is 1,1 and end point nx,ny
C  if flux_consv = Y  scale intensity of new pixels
C  to preserve total_signal/no._of_pixels ratio 
C  (very crude thing - not really recommended)
C	
C.INPUT/OUTPUT
C  the following keys are used:
C
C  IN_A/C/1/80			input frame
C  IN_B/C/1/80			reference frame if given
C  OUT_A/C/1/80			output frame
C  INPUTD/D/1/6			new stepsize in x and y
C  				"real" offsets in x and y (in wc)
C  				translation values for start in x and y (in wc)
C  DEFAULT/C/1/5		(1) = Y for flux conservation, else = N
C  				(2) = Y for absolute new start,
C				    else old start + offset
C  				(3) = qualif of command, S(pline) or L(inear)
C  				(4) = processing option, R(ow), P(lane), all
C                               (5) = input WC(world coordinates) or PIX(pixels)
C
C.VERSIONS
C	
C 100319		last modif
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      IAV,NAXIS,MAPSIZ,MAXLIN
      INTEGER      N,NK,NL,FELEI,FELEO,FLINI,FLINO,NOFFA,NOFFB
      INTEGER      NLINES,NPROC,NZ,INSTA,IALL
      INTEGER      NSAVE,MAXO,OPTIO,MXPROC,NKK
      INTEGER      IMNOA,IMNOC,IMNOX,IMNOI
      INTEGER      NSIZE(2),NULCNT,N1X,SWI
      INTEGER      SIZE,SIZEA,SIZEC,STAT,IFLU
      INTEGER      PLINCI,PLINCO,PLNSZI,PLNSZO
      INTEGER      NPIXA(3),NPIXC(3),NPIXT(3),SUBLO(2)
      INTEGER      RSMP,UNI(1),NULO,MADRID(1)
C 
      INTEGER*8    PNTRA,PSAVE,PNTRC,PNTRT,PNTRW,PNTRX,PNTRY,PNTRZ
      INTEGER*8    RESPTR
C
      CHARACTER*80    FRAMEA,FRAMEC,REFFRA,CBUF
      CHARACTER       CUNIT*64,IDENT*72
      CHARACTER       KFLUX*1,DEFAUL*5,PROCOP*1
C
      DOUBLE PRECISION STEPA(3),STARTA(3)    ! old stepsize, old start
      DOUBLE PRECISION STEPC(3),STARTC(3)    ! new stepsize, new start
      DOUBLE PRECISION INPUTD(6),OFFA(2),DDUM,ENDA(2),ZFRAC,XREST
      DOUBLE PRECISION STEP(2)               ! stepsize in u.p.s.
      DOUBLE PRECISION STA(2),OFF(2),ASX,ASY
C
      REAL          RNULL,CUTS(4),CUTVAL(2),RFLU
C
      COMMON  /NULLC/  NULCNT,RNULL,CUTVAL
      COMMON  /VMR/    MADRID
C
      INCLUDE  'MID_INCLUDE:ST_DEF.INC'
C
      DATA   SUBLO  /1,1/
      DATA   NPIXA  /1,1,1/,     NPIXC /1,1,1/
      DATA   STARTA /1.D0,1.D0,1.D0/,     STARTC /1.D0,1.D0,1.D0/
      DATA   STEPA  /1.D0,1.D0,1.D0/,     STEPC  /1.D0,1.D0,1.D0/
      DATA   STEP   /1.0,1.0/
      DATA   IDENT  /' '/,     CUNIT /' '/
C
      INCLUDE  'MID_INCLUDE:ST_DAT.INC'
C
C  set up MIDAS environment + enable automatic error abort
      CALL STSPRO('REBIN')
      NULCNT = 0
      CUTVAL(1) = 999999.9
      CUTVAL(2) = -999999.9
      PLNSZI = 0                                 !increment between in-planes
      PLNSZO = 0                                 !same for result planes
      PLINCI = 0                                 !start increment for in-planes
      PLINCO = 0                                 !same for result planes
      RESPTR = 0
      RSMP = 0
C 
C  get absolute_start, flux_conservation and rebin_method flag
      CALL STKRDC('DEFAULT',1,1,5,IAV,DEFAUL,UNI,NULO,STAT)
      KFLUX = DEFAUL(1:1)
      CALL STKRDR('NULL',2,1,IAV,RNULL,UNI,NULO,STAT)
      CALL STKRDI('MONITPAR',20,1,IAV,MAPSIZ,UNI,NULO,STAT)
      MAPSIZ = MAPSIZ * MAPSIZ                    !recommended buffer size
      PROCOP = DEFAUL(4:4)
C
C  get input frame + open (or map) it
      CALL STKRDC('IN_A',1,1,80,IAV,FRAMEA,UNI,NULO,STAT)
      IF (DEFAUL(3:3).NE.'S') THEN                     !linear rebinning
         CALL STFOPN(FRAMEA,D_R4_FORMAT,0,F_IMA_TYPE,IMNOA,STAT)
         CALL STDRDI(IMNOA,'NAXIS',1,1,IAV,NAXIS,UNI,NULO,STAT)
         CALL STDRDI(IMNOA,'NPIX',1,3,IAV,NPIXA,UNI,NULO,STAT)
         CALL STDRDD(IMNOA,'START',1,3,IAV,STARTA,UNI,NULO,STAT)
         CALL STDRDD(IMNOA,'STEP',1,3,IAV,STEPA,UNI,NULO,STAT)
         CALL STDRDC(IMNOA,'CUNIT',1,1,64,IAV,CUNIT,UNI,NULO,STAT)
         CALL STDRDC(IMNOA,'IDENT',1,1,72,IAV,IDENT,UNI,NULO,STAT)
         IF (NAXIS.GT.3) NAXIS = 3
      ELSE
         CALL STIGET(FRAMEA,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +               2,NAXIS,NPIXA,STARTA,STEPA,
     +               IDENT,CUNIT,PNTRA,IMNOA,STAT)
         IF (NAXIS.GT.3) NAXIS = 2
      ENDIF
C 
      IF (NAXIS.EQ.3) THEN
         IF (PROCOP.EQ.'p') PROCOP = 'P'         !process plane after plane
         IF (PROCOP.NE.'P') THEN
            CALL STTPUT('only 1. plane of cube is processed...',STAT)
         ELSE
            PLNSZI = NPIXA(1)*NPIXA(2)
         ENDIF
         STARTC(3) = STARTA(3)
         STEPC(3) = STEPA(3)
         NPIXC(3) = NPIXA(3)
         NAXIS = 2
      ENDIF
      IF (NAXIS.EQ.2) THEN
         IF ((PROCOP.EQ.'R') .OR. (PROCOP.EQ.'r')) THEN 
            PROCOP = 'R'                             !process row after row
            NAXIS = 1                                !fake 1-dim input
            STEP(2) = 1.0D0
            OFF(2) = 0.D0
            STEPC(2) = STEPA(2)
            STARTC(2) = STARTA(2)
         ENDIF
      ELSE IF (NAXIS.EQ.1) THEN
         PROCOP = '+'
      ENDIF
C 
C  test for RESAMPLE/IMAGE
      IF (DEFAUL(3:3).EQ.'I') THEN
         CALL STDRDR(IMNOA,'LHCUTS',1,4,IAV,CUTS,UNI,NULO,STAT)
         STARTC(1) = STARTA(1)
         STARTC(2) = STARTA(2)
         CALL STKRDC('P3',1,1,80,IAV,REFFRA,UNI,NULO,STAT)
         IF ((REFFRA(1:1).EQ.'H').OR.(REFFRA(1:1).EQ.'h')) THEN
            RSMP = 1
            STEPC(1) = STEPA(1) / 2
            STEPC(2) = STEPA(2) / 2
            NPIXC(1) = 2*NPIXA(1) - 1
            NPIXC(2) = 2*NPIXA(2) - 1
         ELSE
            RSMP = 2
            STEPC(1) = STEPA(1) * 2.0D0
            STEPC(2) = STEPA(2) * 2.0D0
            NPIXC(1) = (NPIXA(1) + 1) / 2
            NPIXC(2) = (NPIXA(2) + 1) / 2
         ENDIF
         GOTO 1220
      ENDIF
C 
C  look, if we use a reference frame
      CALL STKRDC('IN_B',1,1,80,IAV,REFFRA,UNI,NULO,STAT)
      IF (REFFRA(1:1).NE.'+') THEN
C        check, if same as input frame (that happens...)
         CALL GENEQF(REFFRA,FRAMEA,STAT)
         IF (STAT .NE. 0) THEN				!yes.
            DO 500 N=1,NAXIS
               STEP(N) = 1.		!stepsize in unit pixel space
               OFFA(N) = 0.
               OFF(N) = 0.		!offset in unit pixel space
500         CONTINUE
         ELSE
            CALL STFOPN(REFFRA,D_OLD_FORMAT,0,F_IMA_TYPE,IMNOX,STAT)
            CALL STDRDI(IMNOX,'NAXIS',1,1,IAV,N,UNI,NULO,STAT)
            IF (NAXIS.NE.N) CALL STETER
     +         (4,'NAXIS must be the same as of input frame...')
            CALL STDRDD(IMNOX,'START',1,2,IAV,STARTC,UNI,NULO,STAT)
            CALL STDRDD(IMNOX,'STEP',1,2,IAV,STEPC,UNI,NULO,STAT)
            DO 505 N=1,NAXIS
               STEP(N) = STEPC(N)/STEPA(N)      !stepsize in unit pixel space
               OFFA(N) = STARTC(N) - STARTA(N)
               OFF(N) = OFFA(N) / STEPA(N)      !offset in unit pixel space
505         CONTINUE
            CALL STFCLO(IMNOX,STAT)
         ENDIF
      ELSE
C
C  get new stepsizes, offsets and translation values in x + y
C  get input like entered in MIDAS command line
            CALL STKRDD('INPUTD',1,6,IAV,INPUTD,UNI,NULO,STAT)

C now let see, if P8 set to pixels PIX:
         IF (DEFAUL(5:5).EQ.'P') THEN 
C                      input in pixels instead of worlds coordinates	 
             DO 900 N=1,NAXIS
C handle pixels: 	    
               STEP(N) = INPUTD(N)               ! new stepsize in pixels
               OFFA(N) = INPUTD(N+2)             !"real" offset from old start
                       	                         ! this value would be still wc   
C 
C  adjust for pixel center - new stepsize
               STEPC(N) = STEP(N) * STEPA(N)  !stepsize is already in u.p.s.
                                              !stepc is later needed for output  
               OFFA(N) = OFFA(N) + (0.5D0*(STEPC(N)-STEPA(N)))       
               OFF(N) = OFFA(N) / STEPA(N)        !offset in unit pixel space
C 
               IF (DEFAUL(2:2).EQ.'Y') THEN
                  STARTC(N) = INPUTD(N+4)         !absolute value for new start
               ELSE
                  STARTC(N) = STARTA(N) + OFFA(N)
               ENDIF
C ^^^^^^^ end of part with pixels    
900         CONTINUE
C
         ELSE
C           this is the default case: input in world coordinates
            DO 1000 N=1,NAXIS
               STEPC(N) = INPUTD(N)               !new stepsize
               OFFA(N) = INPUTD(N+2)              !"real" offset from old start
C 
C  adjust for pixel center - new stepsize
               OFFA(N) = OFFA(N) + (0.5D0*(STEPC(N)-STEPA(N)))
               OFF(N) = OFFA(N) / STEPA(N)        !offset in unit pixel space
               STEP(N) = STEPC(N) / STEPA(N)      !stepsize in u.p.s.
               IF (DEFAUL(2:2).EQ.'Y') THEN
                  STARTC(N) = INPUTD(N+4)         !absolute value for new start
               ELSE
                  STARTC(N) = STARTA(N) + OFFA(N)
               ENDIF
1000        CONTINUE
         ENDIF

C new end

      ENDIF
C
C  calculate no. of points for output frame
      DO 1200,N=1,NAXIS
         IF (STEP(N) .LT. 1.0D-20) THEN
            WRITE(CBUF,10000) STEPC(N),N
            CALL STETER(1,CBUF)
         ENDIF
C 
         STA(N) = 0.5D0 + OFF(N)        !shift 0 -> 1 origin (- half pixel)
         ENDA(N) = STARTA(N)+(NPIXA(N)-1)*STEPA(N)     !end of input frame
         DDUM = ENDA(N) + 0.5*STEPA(N) - 
     +          ((STARTA(N)+OFFA(N)) - 0.5*STEPC(N))   !do not use STARTC...
         IF (STEP(N).GT.1.D0) THEN
            NPIXC(N) = INT(DDUM/STEPC(N)+0.0000001D0)
         ELSE
            NPIXC(N) = NINT(DDUM/STEPC(N))
         ENDIF
1200  CONTINUE
C
C  get output frame
1220  CALL STKRDC('OUT_A',1,1,80,IAV,FRAMEC,UNI,NULO,STAT)
      IF (FRAMEC.EQ.FRAMEA)             !in- and output frame must be different
     +   CALL STETER(2,'input + output frame must be different...')
C
C  calculate different image sizes
      IF (PROCOP.EQ.'R') THEN
         NAXIS = 2                                    !reset NAXIS
         NPIXC(2) = NPIXA(2)
      ENDIF
      SIZEA = 1
      SIZEC = 1
      DO 2000 N=1,NAXIS
         IF (NPIXC(N).LT.1) THEN
            WRITE(CBUF,10001) N,NPIXC(N)
            CALL STETER(12,CBUF)
         ENDIF
         SIZEA = SIZEA * NPIXA(N)
         SIZEC = SIZEC * NPIXC(N)
2000  CONTINUE
C
      IFLU = 0
      RFLU = 0.0
      IF (DEFAUL(3:3).NE.'I') THEN
         IF ((KFLUX.EQ.'Y') .OR. (KFLUX.EQ.'y')) THEN
            DDUM = STEP(1) * STEP(2)
            IF (DDUM .GT. 1.D0) THEN
               IFLU = 1
               RFLU = (1.D0 / DDUM)
            ENDIF
         ENDIF
      ENDIF
C
C  branch according to method (bilinear or cubic spline)
      IF (DEFAUL(3:3).NE.'S') GOTO 3900
C 
C 
C  here for cubic spline rebinning
C 
C
      CALL STDRDR(IMNOA,'LHCUTS',1,4,IAV,CUTS,UNI,NULO,STAT)    !get old cuts
C
C  map output file
      CALL STIPUT(FRAMEC,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +            NAXIS,NPIXC,STARTC,STEPC,
     +            IDENT,CUNIT,PNTRC,IMNOC,STAT)
C 
      ASX = STEP(1)                      !but for stepsize > 1.0 no splines...!
      IF (NAXIS.EQ.1) THEN
         ASY = ASX
      ELSE
         ASY = STEP(2)
      ENDIF
      IF ((ASX.GT.1.0D0).OR.(ASY.GT.1.0D0)) THEN
         CALL STTPUT
     +   ('new step(s) larger than input => linear rebinning...',STAT)
         GOTO 3900                       !no spline for those
      ENDIF
C
C  map array for 2. derivative (row) and temporary space (row)
      SIZE = MAX(NPIXA(1),NPIXA(2))
      CALL STFXMP(SIZE,D_R4_FORMAT,PNTRW,STAT)
      CALL STFXMP(SIZE,D_R4_FORMAT,PNTRT,STAT)
C
C  if 2-dim frame, map intermed. arrays with interpolated points only rowwise
      IF (NPIXC(2) .GT. 1) THEN
         SIZE = NPIXC(1) * NPIXA(2)
         CALL STFXMP(SIZE,D_R4_FORMAT,PNTRZ,STAT)
         CALL STFXMP(SIZE,D_R4_FORMAT,PNTRX,STAT)
C 
C  we need also temporary result frame, because we have to transpose again
         SIZE = NPIXC(1) * NPIXC(2)
         CALL STFXMP(SIZE,D_R4_FORMAT,PNTRY,STAT)
         RESPTR = PNTRZ
         NPIXT(1) = NPIXC(1)
         NPIXT(2) = NPIXA(2)
      ELSE
         RESPTR = PNTRC
      ENDIF
C
C  first do it along the rows
      NOFFA = 0
      NOFFB = 0
C
      DO 3000 NL=1,NPIXA(2)
C                            calculate the second derivative along the rows
         CALL DERIV2(MADRID(PNTRA),NOFFA,MADRID(PNTRW),
     +               MADRID(PNTRT),NPIXA(1)) 
C                                            and resample in x
         CALL RESMPX(MADRID(PNTRA),NOFFA,NPIXA(1),STA(1),STEP(1),
     +               MADRID(PNTRW),MADRID(RESPTR),NPIXC(1),NOFFB)
         NOFFA = NOFFA + NPIXA(1)
         NOFFB = NOFFB + NPIXC(1)
3000  CONTINUE
C
      IF (NPIXC(2).LE.1) GOTO 6000
C 
C  if 2-dim frame we transpose and move along the former columns
      NSIZE(1) = 128
      NSIZE(2) = 256
      CALL LINCOL(MADRID(PNTRZ),NPIXT,NSIZE,MADRID(PNTRX))
C
C  now do it along the columns
      NOFFA = 0
      NOFFB = 0
      DO 3300 NL=1,NPIXC(1)
C                            calculate the second derivative along the columns
         CALL DERIV2(MADRID(PNTRX),NOFFA,MADRID(PNTRW),
     +               MADRID(PNTRT),NPIXA(2)) 
C                                            and resample in y
         CALL RESMPX(MADRID(PNTRX),NOFFA,NPIXA(2),STA(2),STEP(2),
     +               MADRID(PNTRW),MADRID(PNTRY),NPIXC(2),NOFFB)
         NOFFA = NOFFA + NPIXA(2)
         NOFFB = NOFFB + NPIXC(2)
3300  CONTINUE
C
C  transpose back
      NPIXA(1) = NPIXC(2)
      NPIXA(2) = NPIXC(1)
      CALL LINCOL(MADRID(PNTRY),NPIXA,NSIZE,MADRID(PNTRC))
      IF (IFLU.EQ.1) THEN
         CALL FLUFAC(MADRID(PNTRC),SIZEC,RFLU)
         DO 3500, N=1,4
            CUTS(N) = RFLU * CUTS(N)
3500     CONTINUE
      ENDIF
      GOTO 6000
C 
C 
C  here for bilinear rebinning
C 
C 
3900  IF (PLNSZI.GT.0) THEN
         NAXIS = 3                                      !reset input NAXIS
         PLNSZO = NPIXC(1)*NPIXC(2)
         SIZEC = SIZEC*NPIXC(3)
      ENDIF
C 
      CALL STFCRE(FRAMEC,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,   !create result
     +            SIZEC,IMNOC,STAT)                         !frame
      CALL STDWRI(IMNOC,'NAXIS',NAXIS,1,1,UNI,STAT)
      CALL STDWRI(IMNOC,'NPIX',NPIXC,1,NAXIS,UNI,STAT)
      CALL STDWRD(IMNOC,'START',STARTC,1,NAXIS,UNI,STAT)
      CALL STDWRD(IMNOC,'STEP',STEPC,1,NAXIS,UNI,STAT)
      CALL STDWRC(IMNOC,'IDENT',1,IDENT,1,72,UNI,STAT)
      NL = (NAXIS+1)*16
      CALL STDWRC(IMNOC,'CUNIT',1,CUNIT,1,NL,UNI,STAT)
C 
      IF (RSMP.GE.1) THEN
         CALL STFXMP(NPIXA(1),D_R4_FORMAT,PNTRA,STAT)
         CALL STFXMP(NPIXC(1),D_R4_FORMAT,PNTRX,STAT)       !1 line of output
         CALL STFXMP(NPIXC(1),D_R4_FORMAT,PNTRY,STAT) 
         CALL STFXMP(NPIXC(1),D_R4_FORMAT,PNTRZ,STAT) 
C 
         CALL RESMPS(RSMP,IMNOA,IMNOC,MADRID(PNTRA),MADRID(PNTRX),
     +               NPIXA,NPIXC,MADRID(PNTRY),MADRID(PNTRZ))
         GOTO 6000
      ENDIF
C 
      CALL STFXMP(NPIXC(1),D_R8_FORMAT,PNTRX,STAT)       !XS array of RESMPA
      CALL STFXMP(NPIXC(1),D_I4_FORMAT,PNTRY,STAT)       !LS array of RESMPA
      CALL STFXMP(NPIXC(1),D_I4_FORMAT,PNTRZ,STAT)       !HS array of RESMPA
      CALL BUILDA(NPIXA(1),STA(1),STEP(1),NPIXC(1),
     +            MADRID(PNTRX),MADRID(PNTRY),MADRID(PNTRZ),NKK)
      NULCNT = NKK * NPIXA(2)
      CUTS(1) = 0.0
      CUTS(2) = 0.0
C 
C  1-dim processing
C 
      IF (NPIXA(2) .LE. 1) THEN
         CALL STFXMP(NPIXA(1),D_R4_FORMAT,PNTRA,STAT)
         CALL STFXMP(NPIXC(1),D_R4_FORMAT,PNTRC,STAT)
         CALL STFGET(IMNOA,1,NPIXA(1),IAV,MADRID(PNTRA),STAT)
C 
         CALL RESMPA(MADRID(PNTRA),NPIXA(1),STA(1),STEP(1),NPIXC(1),
     +               MADRID(PNTRC),1,NKK,
     +               MADRID(PNTRX),MADRID(PNTRY),MADRID(PNTRZ))
C 
         CUTS(3) = CUTVAL(1)
         CUTS(4) = CUTVAL(2)                           !calculate also min,max
         CALL FLUFAK(IFLU,MADRID(PNTRC),NPIXC(1),RFLU,CUTS(3))
         CALLSTFPUT(IMNOC,1,NPIXC(1),MADRID(PNTRC),STAT)
C 
C  2-dim processing
C 
      ELSE
         IF (NPIXC(1).GT.NPIXA(1)) THEN             !determine no. of lines 
            N = NPIXC(1)                            !for all buffers 
         ELSE                                       !with different line length
            N = NPIXA(1)
         ENDIF
         NLINES = MAPSIZ / N
         IF (NPIXC(2).GT.NPIXA(2)) THEN             !also depends on offset
            MAXLIN = NPIXC(2)
         ELSE
            MAXLIN = NPIXA(2)
         ENDIF
         IF (NLINES .GT. MAXLIN) NLINES = MAXLIN
C 
         INSTA = 1
         IF (STEP(2).GE.1.D0) THEN
            DDUM = STA(2) - (STEP(2)*0.5D0)         !go half a new stepsize back
            IF (DDUM.LE.0.D0) THEN
               NZ = 0
               ZFRAC = 0.D0
            ELSE
               NZ = INT(DDUM)
               ZFRAC = DDUM - NZ   
               INSTA = NZ - 1
            ENDIF
            N = (INT(STEP(2)) + 1) * 3 
            IF (NLINES .LT. N) NLINES = N           !at least 3 steps must fit
            SWI = 1
         ELSE 
            INSTA = INT(STA(2)) 
            IF (NLINES .LT. 10) NLINES = 10
            SWI = 0
         ENDIF
         IF (INSTA.LT.1) INSTA = 1                  !1. row we have to work on
C 
         NSAVE = NLINES                                   !save it for later
         NL = NLINES * NPIXC(1)
         CALL STFXMP(NL,D_R4_FORMAT,PNTRW,STAT)           !out buffer
         CALL STFXMP(NL,D_R4_FORMAT,PNTRC,STAT)           !out buffer
         NK = NLINES * NPIXA(1)
         CALL STFCRE('middummin',D_R4_FORMAT,F_X_MODE,    !alloc memory
     +               F_IMA_TYPE,NK,IMNOI,STAT)
         CALL STFMAP(IMNOI,F_X_MODE,1,NK,IAV,PNTRA,STAT)           !in buffer
C 
         FLINI = INSTA
         IF ((FLINI+NLINES-1).GE.NPIXA(2)) THEN
            IALL = 1                                !all data fits into int_buff
            PSAVE = PNTRW
            NLINES = NPIXA(2)
         ELSE
            PSAVE = 0
            IALL = 0
            IF (PROCOP.NE.'R') THEN
               SIZE = NPIXC(1) * NPIXA(2)
               CALL STFCRE('middummbin.bdf',D_R4_FORMAT,    !create tempfile in
     +              F_O_MODE,F_IMA_TYPE,SIZE,IMNOX,STAT)    !Midas binary format
            ENDIF
         ENDIF
C 
4000     FELEI = (FLINI-1)*NPIXA(1) + 1 
         FELEO = (FLINI-1)*NPIXC(1) + 1
         CALL STFGET(IMNOA,(FELEI+PLINCI),NK,IAV,MADRID(PNTRA),STAT)
C
4040     CALL RESMPA(MADRID(PNTRA),NPIXA(1),STA(1),STEP(1),NPIXC(1),
     +               MADRID(PNTRW),NLINES,NKK,
     +               MADRID(PNTRX),MADRID(PNTRY),MADRID(PNTRZ))
C 
         IF (PROCOP.EQ.'R') THEN                 !we work only on the rows
            IMNOX = IMNOC                        !write already to result frame
            CALL FLUFAK(IFLU,MADRID(PNTRW),NL,RFLU,CUTVAL)
            IF (IALL.EQ.1) 
     +         CALL STFPUT(IMNOX,FELEO,NL,MADRID(PNTRW),STAT) 
         ENDIF
C 
         IF (IALL.EQ.0) THEN                  !we use intermediate disk file
            CALL STFPUT(IMNOX,FELEO,NL,MADRID(PNTRW),STAT)    !write to disk
            FELEO = FELEO + NL
            FLINI = FLINI + NLINES
C
            IF (FLINI .LE. NPIXA(2)) THEN
               FELEI = FELEI + NK
               CALL STFGET(IMNOA,(FELEI+PLINCI),NK,IAV,
     +                     MADRID(PNTRA),STAT)
               N = NPIXA(2) - FLINI + 1
               IF (NLINES .GT. N) THEN
                  NLINES = N
                  NL = NLINES * NPIXC(1)
                  NK = NLINES * NPIXA(1)
               ENDIF
               GOTO 4040
            ENDIF
         ENDIF
C 
         IF (NAXIS.LT.3)
     +      CALL STFCLO(IMNOI,STAT)             !we can get rid of that buffer
         IF (PROCOP.EQ.'R') THEN                !we work only on the rows
            IF (IFLU.EQ.1) THEN
               CUTS(3) = CUTVAL(1) * RFLU
               CUTS(4) = CUTVAL(2) * RFLU
            ELSE
               CUTS(3) = CUTVAL(1)
               CUTS(4) = CUTVAL(2)
            ENDIF
            GOTO 6000                           !job already done
         ENDIF
C 
C  prepare processing along columns
         OPTIO = 0
         NLINES = NSAVE                         !we must reset no. of new rows
         NL = NLINES * NPIXC(1)
         FLINI = INSTA                          !FLINI is updated in RESMPB
         FELEI = (FLINI-1)*NPIXC(1) + 1 
         FLINO = 1                              !FLINO is updated here
         FELEO = 1 
         MAXO = SIZEC
         MXPROC = NPIXC(2)
         IF (IALL.EQ.0) THEN
            CALL STFGET(IMNOX,FELEI,NL,IAV,MADRID(PNTRW),STAT)
         ELSE
            RESPTR = PSAVE - (INSTA - 1)*NPIXC(1)     !only use buffer offset
            PNTRW = RESPTR + FELEI - 1 
         ENDIF
C 
4400     IF (SWI .EQ. 0) THEN
            CALL RESMPB(OPTIO,MADRID(PNTRW),NPIXA,STA,STEP,NPIXC,
     +                  MADRID(PNTRC),FLINI,NLINES,MAXO,NPROC)
         ELSE
            CALL RESMPC(OPTIO,XREST,N1X,MADRID(PNTRW),NPIXA,STA,
     +                  STEP,NPIXC,ZFRAC,NZ,MADRID(PNTRC),FLINI,
     +                  NLINES,MXPROC,NPROC)
         ENDIF
         IF (NPROC.GT.0) THEN
            NK = NPROC * NPIXC(1)
            IF (IFLU.EQ.1) 
     +         CALL FLUFAC(MADRID(PNTRC),NK,RFLU)
            CALL STFPUT(IMNOC,(FELEO+PLINCO),NK,MADRID(PNTRC),STAT)
C 
            FELEO = FELEO + NK
            FLINO = FLINO + NPROC
            MAXO = MAXO - NK
C 
            IF (FLINO .LE. NPIXC(2)) THEN
               IF (OPTIO.NE.0) THEN
                  FELEI = (FLINI-1)*NPIXC(1) + 1 
                  IF (IALL.EQ.0) THEN
                     CALL STFGET(IMNOX,FELEI,NL,IAV,MADRID(PNTRW),STAT)
                  ELSE
                     PNTRW = RESPTR + FELEI - 1
                  ENDIF
               ENDIF
               IF (STEP(2).GE.1.D0) THEN
                  N = NPIXA(2) - FLINI + 1           !max no. of lines available
                  IF (NLINES.GT.N) NLINES = N
               ENDIF
               GOTO 4400
            ENDIF
         ENDIF
C 
         IF (NAXIS.EQ.3) THEN                     !if we work on planes of cube
            PLINCI = PLINCI + PLNSZI              !move to next plane + loop
            PLINCO = PLINCO + PLNSZO
            IF (PLINCI.LT.(PLNSZI*NPIXA(3))) THEN
               FLINI = INSTA
               NK = NSAVE * NPIXA(1)
               NL = NSAVE * NPIXC(1)
               GOTO 4000
            ENDIF
         ENDIF
C 
         IF (IFLU.EQ.1) THEN
            CUTS(3) = CUTVAL(1) * RFLU
            CUTS(4) = CUTVAL(2) * RFLU
         ELSE
            CUTS(3) = CUTVAL(1)
            CUTS(4) = CUTVAL(2)
         ENDIF
      ENDIF
C
C  copy descriptors and update LHCUTS + HISTORY
6000  CALL DSCUPT(IMNOA,IMNOC,' ',STAT)
      CALL STDWRR(IMNOC,'LHCUTS',CUTS,1,4,UNI,STAT)
      RNULL = NULCNT                                !convert NULL count to real
      CALL STKWRR('NULL',RNULL,1,1,UNI,STAT)
      CALL STSEPI
C 
10000 FORMAT('invalid stepsize ',F12.6,' in ',I1,'. dimension...')  
10001 FORMAT('invalid NPIX(',I1,') of result frame (=',I5,') ...')
C 
      END

      SUBROUTINE FLUFAK(ISW,C,SIZE,FACT,RCUTS)
C
      IMPLICIT NONE
C
      REAL         C(*),FACT,RCUTS(*)
C 
      INTEGER      ISW,SIZE
      INTEGER      N
C 
      IF (ISW.EQ.1) THEN
         DO 1000, N=1,SIZE                        !adjust result frame
            C(N) = C(N) * FACT
            IF (C(N).LT.RCUTS(1)) THEN            !and check min,max
               RCUTS(1) = C(N)
            ELSE IF (C(N).GT.RCUTS(2)) THEN
               RCUTS(2) = C(N)
            ENDIF
1000     CONTINUE
C 
      ELSE
         DO 2000, N=1,SIZE                        !just check min,max
            IF (C(N).LT.RCUTS(1)) THEN
               RCUTS(1) = C(N)
            ELSE IF (C(N).GT.RCUTS(2)) THEN
               RCUTS(2) = C(N)
            ENDIF
2000     CONTINUE
      ENDIF
C 
      RETURN
      END

      SUBROUTINE FLUFAC(C,SIZE,FACT)
C
      IMPLICIT NONE
C
      REAL         C(*),FACT
C 
      INTEGER      SIZE
      INTEGER      N
C 
C  adjust result frame
      DO 1000 N=1,SIZE
         C(N) = C(N) * FACT
1000  CONTINUE
C 
      RETURN
      END

      SUBROUTINE BUILDA(NOPI,STA,STEP,NOPC,XS,LS,HS,NKK)
C
      DOUBLE PRECISION STA,STEP,XS(*)
      DOUBLE PRECISION X,XH,STHALF
C
      INTEGER      NOPI,NOPC,LS(*),HS(*),NKK
      INTEGER      N,NX
C
      NKK = 0
C
C  here for stepsize in x < 1.0
C
      IF (STEP.LT.1.0D0) THEN
         X = STA                           !set to center of 1.interval
C
100      IF (X.LE.0.D0) THEN
            NKK = NKK + 1
            X = X + STEP                   !move on
            GOTO 100
         ENDIF
C
         DO 200, N=NKK+1,NOPC
            NX = INT(X) + 1
            XH = NX - 0.5
            IF (X .LT. XH) THEN            !X in [0,0.5]
               XS(N) = 1.D0 - (XH - X)
               NX = NX - 1
            ELSE
               XS(N) = X - XH
            ENDIF
            LS(N) = NX
            IF (NX.LE.0) LS(N) = 1
            IF (NX.GE.NOPI) THEN
               HS(N) = NOPI
            ELSE
               HS(N) = NX + 1
            ENDIF
            X = X + STEP
200      CONTINUE
C 
CO
CO  the above calculates the offsets for the original algorithm
CO  to interpolate between X and center before + after:
CO
CO    NX = INT(X) + 1
CO    XH = NX - 0.5
CO    IF (X .LT. XH) THEN            !X in [0,0.5]
CO       XFRAC = 1.D0 - (XH - X)
CO       NX = NX - 1
CO       IF (NX.LE.0) THEN
CO          R1 = A(1+IOFFA)
CO       ELSE
CO          R1 = A(NX+IOFFA)
CO       ENDIF
CO    ELSE
CO       XFRAC = X - XH
CO       R1 = A(NX+IOFFA)
CO    ENDIF
CO
CO    IF (NX.GE.NOPI) THEN
CO       R2 = A(NOPI+IOFFA)
CO    ELSE
CO       R2 = A(NX+1+IOFFA)
CO    ENDIF
CO    T(IOFFB) = R1 + (XFRAC*(R2-R1))
CO
CO above formula is same as:  A(NX)*(1.-XFRAC) + A(N1X)*XFRAC
CO
CO    IOFFB = IOFFB + 1
CO    X = X + STEP(1)
CO
C 
      ELSE
         STHALF = STEP * 0.5D0
         X = STA + STHALF         !end of start sample
1100     IF (X.LE.0.D0) THEN
            NKK = NKK + 1
            X = X + STEP                   !move on
            GOTO 1100
         ENDIF
C 
         DO 1150, N=NKK+1,NOPC
            LS(N) = INT(X)
            XS(N) = X - LS(N)
            X = X + STEP
1150     CONTINUE
      ENDIF
C 
      RETURN
      END

      SUBROUTINE RESMPS(FLAG,IMA,IMC,A,C,NOPI,NOPC,D,E)
C
      REAL A(*),C(*),D(*),E(*)
C 
      INTEGER      FLAG,IMA,IMC,NOPI(*),NOPC(*)
      INTEGER      N,NA,NY,NPXC,FELEI,FELEO,IAV,STAT
C 
      FELEI = 1
      FELEO = 1
C 
C  omit pixels + rows
C 
      IF (FLAG.EQ.2) THEN
         NA = 1
         CALL STFGET(IMA,FELEI,NOPI(1),IAV,A,STAT)           !first row
         DO 80, N=1,NOPC(1)
            C(N) = A(NA)
            NA = NA + 2
80       CONTINUE
         CALL STFPUT(IMC,FELEO,NOPC(1),C,STAT)
C 
         IF (NOPC(2) .GT. 1) THEN
            NPXC = NOPC(1)
            FELEO = FELEO + NPXC
C 
            DO 500, NY=2,NOPC(2)
               FELEI = FELEI + 2*NOPI(1)                     !omit even rows
               CALL STFGET(IMA,FELEI,NOPI(1),IAV,A,STAT)
               NA = 1
               DO 330, N=1,NOPC(1)
                  C(N) = A(NA)
                  NA = NA + 2
330            CONTINUE
               CALL STFPUT(IMC,FELEO,NOPC(1),C,STAT)
               FELEO = FELEO + NPXC
500         CONTINUE
         ENDIF
C
C rebin between pixels + rows
C 
      ELSE
         CALL STFGET(IMA,FELEI,NOPI(1),IAV,A,STAT)           !first row
         C(1) = A(1)
         NA = 2
         DO 800, N=2,NOPC(1),2
            C(N) = (A(NA-1)+A(NA))*0.5
            C(N+1) = A(NA)
            NA = NA + 1
800      CONTINUE
         C(NOPC(1)) = A(NOPI(1))
         CALL STFPUT(IMC,FELEO,NOPC(1),C,STAT)
C 
         IF (NOPC(2) .GT. 1) THEN
            NPXC = NOPC(1)
            FELEO = FELEO + NPXC
C 
            DO 10000, NY=2,NOPC(2),2
               FELEI = FELEI + NOPI(1)
               CALL STFGET(IMA,FELEI,NOPI(1),IAV,A,STAT)
               E(1) = A(1)
               NA = 2
               DO 1800, N=2,NPXC,2
                  E(N) = (A(NA-1)+A(NA))*0.5
                  E(N+1) = A(NA)
                  NA = NA + 1
1800           CONTINUE
               E(NPXC) = A(NOPI(1))
C 
               DO 2000, N=1,NPXC
                  D(N) = (C(N)+E(N))*0.5
                  C(N) = E(N)
2000           CONTINUE
C 
               CALL STFPUT(IMC,FELEO,NOPC(1),D,STAT) 
               FELEO = FELEO + NPXC
               CALL STFPUT(IMC,FELEO,NOPC(1),E,STAT) 
               FELEO = FELEO + NPXC
10000       CONTINUE
         ENDIF
      ENDIF
C 
      RETURN
      END

      SUBROUTINE RESMPA(A,NOPI,STA,STEP,NOPC,T,LINCNT,
     +                  NKK,XS,LS,HS)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine RESMPA            version 1.50      840207
C  K. Banse                        ESO - Garching
C                                1.80      870129
C
C.KEYWORDS
C  bulk data frame, rebinning
C
C.PURPOSE
C  get data values at given real pixel no's.
C
C.ALGORITHM
C  work first along the lines, change lines to columns
C  and work along the lines of the transposed image
C
C.INPUT/OUTPUT
C  call as RESMPA(A,NPIXA,STA,STEP,NPIXB,T,LINCNT,NKK,XS,LS,HS)
C
C  input par:
C  A:		R*4 array      input array of data
C  NOPI:	I*4 	       no. of pixels in x of input array
C  STA:		R*8 	       normed x-start for output array
C  STEP:	R*8 	       normed x-stepsize for output array
C  NOPC:	I*4            no. of pixels  in x for output array
C  LINCNT:	I*4            line count for buffer of line size NPIXB(1)
C  NKK:  	I*4            no. of X values .LE. 0
C  XS:		R*8 array      XFRAC for each X
C  LS:		I*4 array      low index for each X
C  HS:		I*4 array      high index for each X
C
C  output par:
C  T:		R*4 array      output array
C
C--------------------------------------------------
C
      IMPLICIT NONE
C
      REAL         A(*),T(*)
      REAL         PIX,R1,R2,VALU,CUTVAL(2)
      REAL         ZNULL
C 
      DOUBLE PRECISION STA,STEP,XS(*)
      DOUBLE PRECISION XFRAC,XREST
      DOUBLE PRECISION Z,ZFRAC,STHALF
C
      INTEGER      NOPI,NOPC,LINCNT,NKK,LS(*),HS(*)
      INTEGER      IOFFA,IOFFB,L,N,NK
      INTEGER      NN,N1X,NX,NZ
      INTEGER      NULCNT
C 
      COMMON  /NULLC/  NULCNT,ZNULL,CUTVAL
C
      IOFFA = 0
      IOFFB = 1
C 
C  ----------------------------
C  here for stepsize in x < 1.0
C  ----------------------------
C 
      IF (STEP.LT.1.0D0) THEN
         NK = NKK + 1
C 
         DO 800, L=1,LINCNT                      !loop over all input lines
            IF (NKK .GT. 0) THEN
               DO 550, N=1,NKK
                  T(IOFFB) = ZNULL
                  IOFFB = IOFFB + 1
550            CONTINUE
            ENDIF
C
            DO 600, N=NK,NOPC
               R1 = A(LS(N)+IOFFA)
               R2 = A(HS(N)+IOFFA)
               T(IOFFB) = R1 + (XS(N)*(R2-R1))
               IOFFB = IOFFB + 1
600         CONTINUE
C 
            IOFFA = IOFFA + NOPI
800      CONTINUE
C 
C  -----------------------------
C  here for stepsize in x >= 1.0
C  -----------------------------
C 
      ELSE
C 
         STHALF = STEP * 0.5D0
         Z = STA - STHALF                      !go half a new stepsize back
         IF (Z.LE.0.D0) THEN
            Z = 0.D0
            NZ = 0
         ELSE
            NZ = INT(Z)
         ENDIF
         ZFRAC = Z - NZ                           !from there go
         NK = NKK + 2
C 
         DO 1800, L=1,LINCNT                      !loop over all input lines
            IF (NKK .GT. 0) THEN
               DO 1200, N=1,NKK
                  T(IOFFB) = ZNULL
                  IOFFB = IOFFB + 1
1200           CONTINUE
            ENDIF
C
C  work on first new pixel differently...
C 
            NX = LS(NK-1)
            XFRAC = XS(NK-1)
            PIX = -(ZFRAC*A(NZ+1+IOFFA))
            DO 1300, NN=1,NX-NZ                   !sum over full regions
               PIX = PIX + A(NN+NZ+IOFFA)
1300        CONTINUE
            N1X = NX + 1                            !point to next region
            T(IOFFB) = PIX + XFRAC*A(N1X+IOFFA)     !and add fraction of that
            IOFFB = IOFFB + 1
            XREST = 1.D0 - XFRAC               !update XREST for next iteration
C
C  now the remaining pixels...
            DO 1500, N=NK,NOPC-1
               NX = LS(N)
               XFRAC = XS(N)
               PIX = XREST * A(N1X+IOFFA)     !init to remainder from last time
               N1X = N1X + 1                   !point to 1. full region
               IF (NX .GE. N1X) THEN
                  DO 1400, NN=N1X,NX               !sum over full regions
                     PIX = PIX + A(NN+IOFFA)
1400              CONTINUE
               ENDIF
               N1X = NX + 1                        !point to next region and
               T(IOFFB) = PIX + (XFRAC * A(N1X+IOFFA))  !add fraction of that
               IOFFB = IOFFB + 1
               XREST = 1.D0 - XFRAC            !update XREST for next iteration
1500        CONTINUE
C
C  take care of end of row ...
            NX = LS(NOPC)
            XFRAC = XS(NOPC)
            IF (N1X.LE.NOPI) THEN             !init to remainder from last time
               PIX = XREST * A(N1X+IOFFA)
            ELSE
               PIX = XREST * A(NOPI+IOFFA)
            ENDIF
            N1X = N1X + 1                       !point to 1. full region
C
            DO 1600, NN=N1X,NX                  !sum over full regions
               IF (NN.LE.NOPI) THEN
                  PIX = PIX + A(NN+IOFFA)
               ELSE
                  PIX = PIX + A(NOPI+IOFFA)
               ENDIF
1600        CONTINUE
C
C PN 3/99
C execute this part only if no. of pixels in outima greater/equal 2
            IF( NOPC .GE. 2) THEN
               N1X = NX + 1                        !point to next region
               IF (N1X.LE.NOPI) THEN
                  VALU = A(N1X+IOFFA)
               ELSE
                  VALU = A(NOPI+IOFFA)
               ENDIF
               T(IOFFB) = PIX + (XFRAC*VALU)       !and add fraction of that
               IOFFB = IOFFB + 1           
C
C  update pointers to offset in data arrays
               IOFFA = IOFFA + NOPI
            ENDIF
1800     CONTINUE
      ENDIF
C
      RETURN
      END

      SUBROUTINE RESMPB(FLAG,TA,NPIXA,STA,STEP,NPIXB,B,STLNI,LINCNT,
     +                  MXIOB,NPROC)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine RESMPB            version 1.00      970425
C  K. Banse                        ESO - Garching
C
C.KEYWORDS
C  bulk data frame, rebinning
C
C.PURPOSE
C  get data values at given real pixel no's.
C
C.ALGORITHM
C  work along the columns of the intermediate frame
C  on all the rows available in the buffer
C
C.INPUT/OUTPUT
C  call as  RESMPB(FLAG,TA,NPIXA,STA,STEP,NPIXB,B,STLNI,LINCNT,
C                  MXIOB,STLNO,NPROC)
C
C  input par:
C  TA:          R*4 array      input buffer of NPIXB(1)*LINCNT size
C  NPIXA:       I*4 array      no. of pixels in x+y of input frame
C  STEP:        R*8 array      normed stepsize for output array
C  NPIXB:       I*4            no. of pixels  in x+y for output frame
C  LINCNT:      I*4	       no. of lines in input buffer
C  MXIOB:       I*4	       max. no. of values to be produced
C
C  output par:
C  B:           R*4 array      output buffer of data
C  NPROC:       I*4 	       no. of output lines produced
C
C  in/output par:
C  FLAG:        I*4	       = 0, at start + set to 1, if zero data
C 				    finished
C  STA:         R*8 array      normed start for output buffer
C  STLNI:       I*4	       starting line of input buffer
C
C--------------------------------------------------
C
      IMPLICIT NONE
C
      REAL         TA(*),B(*)
      REAL         R1,VALU
      REAL         ZNULL,CUTVAL(2)
C
      DOUBLE PRECISION STA(*),STEP(*)
      DOUBLE PRECISION XFRAC,X,XH
C
      INTEGER      FLAG,NPIXA(*),NPIXB(*),STLNI,LINCNT,MXIOB,NPROC
      INTEGER      LSTLN1,L,KOFF1,KOFF2
      INTEGER      NX,IOB,NOPI
      INTEGER      NULCNT,KX
C 
      COMMON  /NULLC/  NULCNT,ZNULL,CUTVAL
C
C  use TA as input - TA is of size NPIXB(1) * LINCNT
C
      NOPI = NPIXB(1)
      NPROC = 0                             !no. of processed lines
      IOB = 1                               !index for output buffer B
      LSTLN1 = NPIXA(2) - STLNI
C
C  test FLAG
C 
      IF (FLAG .EQ. 0) THEN                 !first time, so check if outside
         IF (STA(2) .LT. 0.0D0) THEN
C 
C  determine no. of NULL lines
            X = STA(2)
2800        IF (X.LT.0.0D0) THEN
               NPROC = NPROC + 1
               X = X + STEP(2)
               IF (NPROC.LT.LINCNT) GOTO 2800
            ENDIF
C 
            STA(2) = X
            DO 3300, IOB=1,NPROC*NOPI
               B(IOB) = ZNULL
3300        CONTINUE
C 
            NULCNT = NULCNT + (NPROC*NOPI)
            IF (CUTVAL(1).GT.ZNULL) THEN
               CUTVAL(1) = ZNULL
            ELSE IF (CUTVAL(2).LT.ZNULL) THEN
               CUTVAL(2) = ZNULL
            ENDIF
            RETURN
         ENDIF
C 
         FLAG = 1
      ENDIF
      X = STA(2) 
C 
C  here we always have a line `before'
C  
6600  NX = INT(X) + 1
      XH = NX - 0.5
      KX = NX - STLNI  + 1
      IF (X .LT. XH) THEN               !X in [0,0.5[
         XFRAC = 1.D0 - (XH - X)
         NX = NX - 1                    !NX = NX - 1
         KX = KX - 1 
         IF (KX.GE.LINCNT) THEN
            NX = NX - 1                 !for security one more line at bottom
            GOTO 6900
         ENDIF
         IF (NX.LT.STLNI) THEN
            KOFF1 = 1
         ELSE
            KOFF1 = (KX-1)*NOPI + 1
         ENDIF
      ELSE                              !X in [0.5,1.0]
         IF (KX.GE.LINCNT) THEN
            NX = NX - 1                 !for security one more line at bottom
            GOTO 6900
         ENDIF
         XFRAC = X - XH
         KOFF1 = (KX-1)*NOPI + 1
      ENDIF
C 
      IF (KX.GE.LSTLN1) THEN
         KOFF2 = (LSTLN1 * NOPI) + 1
      ELSE
         KOFF2 = (KX * NOPI) + 1
      ENDIF
C 
      DO 6800, L=IOB,IOB+NOPI-1                !loop over all columns
         R1 = TA(KOFF1)
         VALU = R1 + (XFRAC*(TA(KOFF2)-R1))
         B(L) = VALU
C 
C        above formula is same as:  A(NX)*(1.-XFRAC) + A(N1X)*XFRAC
C 
         IF (CUTVAL(1).GT.VALU) THEN
            CUTVAL(1) = VALU
         ELSE IF (CUTVAL(2).LT.VALU) THEN
            CUTVAL(2) = VALU
         ENDIF
C 
         KOFF1 = KOFF1 + 1
         KOFF2 = KOFF2 + 1
6800  CONTINUE
C
      IOB = IOB + NOPI
      NPROC = NPROC + 1
      IF (IOB .GT. MXIOB) RETURN         !end_of_job check
C 
      X = X + STEP(2)
      IF (NPROC.LT.LINCNT) GOTO 6600
C 
6900  STA(2) = X
      STLNI = NX - 1
      IF (STLNI.LT.1) STLNI = 1
C 
      RETURN
      END

      SUBROUTINE RESMPC(FLAG,XREST,N1X,TA,NPIXA,STA,STEP,NPIXB,ZFRAC,NZ,
     +                  B,STLNI,LINCNT,MXPROC,NPROC)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine RESMPC            version 1.00      970425
C  K. Banse                        ESO - Garching
C
C.KEYWORDS
C  bulk data frame, rebinning
C
C.PURPOSE
C  get data values at given real pixel no's.
C
C.ALGORITHM
C  work along the lines of the transposed image
C
C.INPUT/OUTPUT
C  call as  RESMPC(FLAG,TA,NPIXA,STA,STEP,NPIXB,B,STLNI,LINCNT,
C                  MXPROC,STLNO,NPROC)
C
C  input par:
C  TA:          R*4 array      input buffer of NPIXB(1)*NPIXA(2) temp frame
C  NPIXA:       I*4 array      no. of pixels in x+y of input frame
C  STEP:        R*8 array      normed stepsize for output array
C  NPIXB:       I*4            no. of pixels  in x+y for output frame
C  MXPROC:      I*4            max. no. of rowd to be produced
C
C  output par:
C  B:           R*4 array      output buffer of data
C  NPROC:       I*4            no. of output lines produced
C
C  in/output par:
C  FLAG:        I*4            = 0, at start + set to 1, if zero data
C                                   finished
C  STA:         R*8 array      normed start for output buffer
C  STLNI:       I*4            starting line of input buffer
C
C--------------------------------------------------
C
      IMPLICIT NONE
C
      REAL         TA(*),B(*)
      REAL         PIXVAL,VALU
      REAL         ZNULL,CUTVAL(2)
C
      INTEGER      FLAG,NPIXA(*),NPIXB(*),STLNI,LINCNT,MXPROC,NPROC,NZ
      INTEGER      LASTIN,L,NX,IOB,KL,ML,JL
      INTEGER      MZ,NSAV,NN,N1X,NOLI,NOPI,STLNIM
      INTEGER      NULCNT,N2X
C
      DOUBLE PRECISION STA(*),STEP(*)
      DOUBLE PRECISION XFRAC,X,XREST
      DOUBLE PRECISION ZFRAC,STHALF
C
      COMMON  /NULLC/  NULCNT,ZNULL,CUTVAL
C
C  use TA as input - TA is of size NPIXB(1) * chunk_lines
C
      NOPI = NPIXB(1)
      NOLI = NPIXA(2)
      NPROC = 0
      STLNIM = STLNI - 1
      LASTIN = LINCNT + STLNIM
      IOB = 1
C 
C  here for stepsize >= 1.0
C
      STHALF = STEP(2) * 0.5D0
      X = STA(2) + STHALF               !end of start sample
C 
      IF (FLAG .EQ. 0) THEN
         IF (X .GT. 0.0D0) THEN             !determine no. of NULL lines
            FLAG = 1
         ELSE
2800        IF (X .LE. 0.0D0) THEN 
               NPROC = NPROC + 1
               X = X + STEP(2)
               IF (NPROC.LT.LINCNT) GOTO 2800
            ENDIF
C
            STA(2) = X - STHALF
            DO 3300, IOB=1,NPROC*NOPI
               B(IOB) = ZNULL
3300        CONTINUE
C 
            NULCNT = NULCNT + (NPROC*NOPI)
            MXPROC = MXPROC - NPROC
            IF (CUTVAL(1).GT.ZNULL) THEN
               CUTVAL(1) = ZNULL
            ELSE IF (CUTVAL(2).LT.ZNULL) THEN
               CUTVAL(2) = ZNULL
            ENDIF
            RETURN
         ENDIF
      ENDIF
C
C  if first real line, build up NX, N1X, KL, XFRAC, XREST
C 
      IF (FLAG .EQ. 1) THEN           !work on first new pixel differently...
         IF (NZ .GT. 0) THEN
            MZ = NZ - STLNIM
         ELSE
            MZ = 0
         ENDIF
         X = STA(2) + STHALF
         NX = INT(X)
         N1X = NX + 1                                !point to next region 
         XFRAC = X - NX
         XREST = 1.D0 - XFRAC              !update XREST for next iteration
         KL = MZ*NOPI + 1
         JL = (NX - STLNIM)*NOPI + 1
         NSAV = MZ * NOPI                      !save for loop
C 
         IF (NX.GT.NZ) THEN
            DO 5100, L=1,NOPI                  !loop over all columns
               PIXVAL = -(ZFRAC*TA(KL))
               ML = NSAV
               DO 5000, NN=1,NX-NZ                     !sum over full regions
                  PIXVAL = PIXVAL + TA(ML+L)
                  ML = ML + NOPI
5000           CONTINUE
               VALU = PIXVAL + (XFRAC * TA(JL))      !add fraction of that
               B(IOB) = VALU
               IOB = IOB + 1
               IF (CUTVAL(1).GT.VALU) THEN
                  CUTVAL(1) = VALU
               ELSE IF (CUTVAL(2).LT.VALU) THEN
                  CUTVAL(2) = VALU
               ENDIF
               KL = KL + 1
               JL = JL + 1
5100        CONTINUE
C 
         ELSE
            DO 5200, L=IOB,IOB+NOPI-1              !loop over all columns
               VALU = -(ZFRAC*TA(KL)) + (XFRAC*TA(JL)) 
               B(L) = VALU
               IF (CUTVAL(1).GT.VALU) THEN
                  CUTVAL(1) = VALU
               ELSE IF (CUTVAL(2).LT.VALU) THEN
                  CUTVAL(2) = VALU
               ENDIF
               KL = KL + 1
               JL = JL + 1
5200        CONTINUE
            IOB = IOB + NOPI
         ENDIF
C 
         FLAG = 2
         NPROC = 1
         MXPROC = MXPROC - 1
      ENDIF
C 
C  now the remaining rows...
C 
      IF (FLAG.EQ.2) THEN
6000     X = X + STEP(2) 
         NX = INT(X)
C 
         IF (NX .GE. LASTIN) THEN             !we have to check NX...
            IF((NPROC.EQ.0).OR.(LASTIN.EQ.NOLI)) GOTO 9090
            X = X - STEP(2)
            STLNI = INT(X)
            N1X = STLNI + 1                   !point to next region 
            XFRAC = X - STLNI
            XREST = 1.D0 - XFRAC              !update XREST for next iteration
            STA(2) = X - STHALF
            RETURN
         ENDIF
C 
         XFRAC = X - NX
         N2X = N1X + 1                  !point to 1. full region
         NSAV = (N2X - STLNI) * NOPI
         KL = (N1X - STLNI) * NOPI + 1
         JL = (NX - STLNIM) * NOPI + 1
C 
         IF (NX .GE. N2X) THEN
            DO 7500, L=1,NOPI
               PIXVAL = XREST * TA(KL)    !init to remainder from last time
               ML = NSAV
               DO 7400, NN=N2X,NX                  !sum over full regions
                  PIXVAL = PIXVAL + TA(ML+L)
                  ML = ML + NOPI
7400           CONTINUE
               VALU = PIXVAL + (XFRAC * TA(JL))   !add fraction of that
               B(IOB) = VALU
               IOB = IOB + 1
               IF (CUTVAL(1).GT.VALU) THEN
                  CUTVAL(1) = VALU
               ELSE IF (CUTVAL(2).LT.VALU) THEN
                  CUTVAL(2) = VALU
               ENDIF
               KL = KL + 1                         !instead of TA(KL+L)
               JL = JL + 1
7500        CONTINUE
C 
         ELSE
            DO 7700, L=IOB,IOB+NOPI-1
               VALU = XREST*TA(KL) + XFRAC*TA(JL) 
               B(L) = VALU
               IF (CUTVAL(1).GT.VALU) THEN
                  CUTVAL(1) = VALU
               ELSE IF (CUTVAL(2).LT.VALU) THEN
                  CUTVAL(2) = VALU
               ENDIF
               KL = KL + 1                         !instead of TA(KL+L)
               JL = JL + 1
7700        CONTINUE
            IOB = IOB + NOPI
         ENDIF
C 
         N1X = NX + 1
         XREST = 1.D0 - XFRAC            !update XREST for next iteration
         NPROC = NPROC + 1
         MXPROC = MXPROC - 1
C 
C  check, if we reached last row
         IF (MXPROC.EQ.1) THEN
            FLAG = 3
            IF (NPROC.LT.LINCNT) THEN
               GOTO 9000                !move to final section right away
            ELSE
               GOTO 8000
            ENDIF
         ENDIF
         IF (NPROC.LT.LINCNT) GOTO 6000
C 
8000     STLNI = NX
         STA(2) = X - STHALF
         RETURN
      ENDIF
C
C  take care of last row         (FLAG = 3)
C 
9000  X = X + STEP(2)   
      NX = INT(X)
C
9090  IF (NX.GE.LASTIN) THEN               !we have to check NX...
         IF ((NX.EQ.LASTIN) .AND. (LASTIN.EQ.NOLI)) GOTO 9099
         X = X - STEP(2)
         STLNI = INT(X)
         N1X = STLNI + 1                   !point to next region
         XFRAC = X - STLNI
         XREST = 1.D0 - XFRAC              !update XREST for next iteration
         STA(2) = X - STHALF
         RETURN
      ENDIF
C
9099  XFRAC = X - NX
      N2X = N1X + 1                  !point to 1. full region
      IF (N1X.LE.NOLI) THEN             !init to remainder from last time
         ML = (N1X - STLNI)*NOPI + 1
      ELSE
         ML = (NOLI - STLNI)*NOPI + 1
      ENDIF
      N1X = NX + 1                                  !point to next region
      IF (N1X.LE.NOLI) THEN
         KL = (N1X - STLNI)*NOPI + 1
      ELSE
         KL = (NOLI - STLNI)*NOPI + 1
      ENDIF
C
      IF (NX .GE. N2X) THEN
         DO 9700, L=1,NOPI                  !loop over all columns
            PIXVAL = XREST * TA(ML)
            DO 9600, NN=N2X,NX                      !sum over full regions
               IF (NN.LE.NOLI) THEN
                  JL = NN - STLNI
               ELSE
                  JL = NOLI - STLNI
               ENDIF
               PIXVAL = PIXVAL + TA(JL*NOPI+L)
9600        CONTINUE
            VALU = PIXVAL + XFRAC*TA(KL)      !and add fraction of that
            B(IOB) = VALU
            IOB = IOB + 1
            IF (CUTVAL(1).GT.VALU) THEN
               CUTVAL(1) = VALU
            ELSE IF (CUTVAL(2).LT.VALU) THEN
               CUTVAL(2) = VALU
            ENDIF
            KL = KL + 1                         !instead of TA(KL+L)
            ML = ML + 1
9700     CONTINUE
C 
      ELSE
         DO 9770, L=IOB,IOB+NOPI-1                   !loop over all columns
            VALU = XREST*TA(ML) + XFRAC*TA(KL)
            B(L) = VALU
            IF (CUTVAL(1).GT.VALU) THEN
               CUTVAL(1) = VALU
            ELSE IF (CUTVAL(2).LT.VALU) THEN
               CUTVAL(2) = VALU
            ENDIF
            KL = KL + 1                         !instead of TA(KL+L)
            ML = ML + 1
9770     CONTINUE
         IOB = IOB + NOPI
      ENDIF
      MXPROC = 0
      NPROC = NPROC + 1
C
      RETURN
      END

      SUBROUTINE RESMPX(A,OFFA,NDIMA,STAX,STEPX,DERIV,
     +                  B,NDIMB,OFFB)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  subroutine RESMPX            version 1.00      900713
C  K. Banse                        ESO - Garching
C  1.10      920109
C
C.KEYWORDS
C  bulk data frame, rebinning
C
C.PURPOSE
C  get data values at given real pixel no's. of a single row from an image
C
C.ALGORITHM
C
C.INPUT/OUTPUT
C  call as RESMPX(A,OFFA,NDIMA,STAX,STEPX,DERIV,B,NDIMB,OFFB,ZNULL)
C
C  input par:
C  A:            R*4 array      row of input data frame
C  OFFA:         I*4            offset within total input array
C  NDIMA:        I*4            size of row of A
C  STAX:         R*8            start in x of output array
C  STEPX:        R*8            normalized stepsize in x of output array
C  DERIV:        R*4 array      second derivative of row
C  NDIMB:        I*4            size of output row
C  OFFB:         I*4            offset for output array
C
C  output par:
C  B:            R*4 array      output array of data
C
C.VERSIONS
C  1.00            creation
C  1.10            clean + speed up
C
C--------------------------------------------------
C
      IMPLICIT NONE
C
      REAL         A(1),DERIV(1),B(1)
      REAL         ZNULL,CUTVAL(2)
C 
      DOUBLE PRECISION  STAX,STEPX
      DOUBLE PRECISION  X,GX,RF,QQ,RR
C
      INTEGER      NDIMA,NDIMB,OFFA,OFFB
      INTEGER      N,NO1,NO2,KOFF,NULCNT
C 
      COMMON  /NULLC/  NULCNT,ZNULL,CUTVAL
C
      GX = NDIMA
      X = STAX + (0.5D0*STEPX)
      RF = 1.0D0 / 6.0D0
      KOFF = OFFB + 1
C
      DO 1800 N=1,NDIMB
         IF ((X.LT.1.0D0) .OR. (X.GT.GX)) THEN
            B(KOFF) = ZNULL
            NULCNT = NULCNT + 1
         ELSE
C 
            NO1 = INT(X)
            IF (NO1.GE.NDIMA) THEN
               B(KOFF) = A(NO1+OFFA)
            ELSE
               NO2 = NO1 + 1              !get next pixel in x
               RR = NO2 - X
               QQ = 1.D0 - RR
C
C  original formula:  PIX = RR*A(NO1+OFFA) + QQ*A(NO2+OFFA) +
C                         ((RR**3-RR)*DERIV(NO1) + (QQ**3-QQ)*DERIV(NO2)) * RF
C 
               B(KOFF) = RR*A(NO1+OFFA) + QQ*A(NO2+OFFA) +
     +                   ( (RR*(RR*RR-1)*DERIV(NO1)) + 
     +                     (QQ*(QQ*QQ-1.)*DERIV(NO2)) ) * RF
            ENDIF
         ENDIF
C 
         KOFF = KOFF + 1
         X = X + STEPX
1800  CONTINUE
C
      RETURN
      END

      SUBROUTINE DERIV2(A,IOFF,DERV2,TEMP,NDIM)
C
      IMPLICIT NONE
C
      INTEGER    NDIM,IOFF,K,I,IM1
C
      REAL       A(NDIM),DERV2(NDIM),TEMP(NDIM)
      REAL       P
C
C  init
      DERV2(1) = 0.                        !use "natural" spline
      TEMP(1) = 0.
C
C  compute array DERV2 (second derivative of A)
C 
C  original loop:
C      DO 2000 I=2,NDIM-1
C         K = IOFF + I
C         P = 0.5*DERV2(I-1) + 2.0             !interval size = 1.0
C         DERV2(I) = -0.5 /  P
C         TEMP(I) = ( 3.0*(A(K+1) - A(K) - A(K) + A(K-1)) 
C     +               - 0.5*TEMP(I-1) ) / P
C2000  CONTINUE
C 
      DO 2000 I=2,NDIM-1
         IM1 = I - 1
         K = IOFF + I
         P = 1.0 / (DERV2(IM1) + 4.0)          !this is 0.5*(1./P) of above
         DERV2(I) = - P
         TEMP(I) = ( 6.0*(A(K+1)-A(K)-A(K)+A(K-1)) - TEMP(IM1) ) * P
2000  CONTINUE
C 
      DERV2(NDIM) = 0.0
C 
      DO 3000, I=NDIM-1,1,-1
         DERV2(I) = DERV2(I)*DERV2(I+1) + TEMP(I)
3000  CONTINUE
C 
      RETURN
      END

C @(#)profi5.for	19.1 (ES0-DMD) 02/25/03 13:29:44
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE PROFI5 (RNY,MX,MY,NP,NC,IC,FM,FM1)
C+++++
C     Authors: R. Buonanno, G. Buscema, C. Corsi, I. Ferraro, G. Iannicola
C              Osservatorio Astronomico di Roma
C-----
      IMPLICIT  NONE
      INTEGER   MX
      INTEGER   MY
      REAL      RNY(MY,MX)
      INTEGER   NP
      INTEGER   NC
      INTEGER   IC
      REAL      FM
      CHARACTER FM1
C
      INTEGER   I, J, KL
      REAL      A, B 
      REAL      PPP
      INTEGER   IX(101),IY(101)
      INTEGER   ERRCOD,WHITE
C
      INCLUDE  'MID_INCLUDE:IDIDEV.INC'
      INCLUDE  'MID_INCLUDE:IDIMEM.INC'
C
      WHITE = 2
      IF (IDINUM.LT.11) THEN
         CALL IIMSTW(QDSPNO,QOVCH,LOADDR,NSX,NSY,QMDEP,
     2               SSPX,SSPY,ERRCOD)
      ENDIF          
C
      IF (FM.EQ.0.) FM=0.0001
      I = 0
      DO 10 KL=1,NP
         A = -10.E35
         DO 20 J=1,NC
            B = RNY(J,KL)
            A = AMAX1(B,A)
  20     CONTINUE
C
         IF (A.GT.-1000000000.) THEN
            IF (A .LT. 0.0) A = 0.0
            I     = I + 1
            IX(I) = KL*3
            PPP   = A/3.*FM+IC
            IF (PPP.GE.511.) PPP=511.
            IY(I) = PPP

         ELSE
            IF (I.GT.0) THEN
               CALL IIGPLY(QDSPNO,QOVCH,IX,IY,I,WHITE,1,ERRCOD)
            END IF
            I = 0
         END IF
  10  CONTINUE
C
      IF (I.GT.0) THEN
         CALL IIGPLY(QDSPNO,QOVCH,IX,IY,I,WHITE,1,ERRCOD)
      END IF
C
      J = 0
      IF (FM1.NE.'N') THEN
         DO 30 KL = 1,NC
            A = -10.E35
            DO 40 I = 1,NP
               B = RNY(KL,I)
               A = AMAX1(B,A)
  40        CONTINUE
C
            IF (A.GT.-1000000000.) THEN
               IF (A.LT.0.0) A = 0.0
               J     = J + 1
               IX(J) = KL*3+256
               PPP   = A/3.*FM+IC
               IF (PPP.GE.511.) PPP=511.
               IY(J)  = PPP
            ELSE
               IF (J.GT.0) THEN
                  CALL IIGPLY(QDSPNO,QOVCH,IX,IY,J,WHITE,1,ERRCOD)
               END IF
               J = 0
            END IF
  30     CONTINUE
C
         IF (J.GT.0) THEN
            CALL IIGPLY(QDSPNO,QOVCH,IX,IY,J,WHITE,1,ERRCOD)
         END IF
         J = 0
      END IF
C
      IF (FM1.NE.'Y') THEN
         DO 50 KL = 1,NC
            A = -10.E35
            DO 60 I = 1,NP
               B = RNY(KL,I)
               A = AMAX1(B,A)
  60        CONTINUE
C
            IF (A.GT.-1000000000.) THEN
               IF (A.LT.0.0) A = 0.0
               J     = J + 1
               IY(J) = KL*3
               PPP   = A/3.*FM+256.+IC-300.
               IF (PPP.GE.511.) PPP=511.
               IX(J) = PPP

            ELSE
               IF (J.GT.0) THEN
                  CALL IIGPLY(QDSPNO,QOVCH,IX,IY,J,WHITE,1,ERRCOD)
               END IF
               J = 0
            END IF
 50      CONTINUE
C
         IF (J.GT.0) THEN
            CALL IIGPLY(QDSPNO,QOVCH,IX,IY,J,WHITE,1,ERRCOD)
         END IF
      END IF
C
      RETURN
      END

C @(#)aini.for	19.1 (ES0-DMD) 02/25/03 13:18:59
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
       SUBROUTINE aini(NX,NY,MT,IN,H0,HG,HL,EG,EL,SG,SL,YMT)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C      initializes the algorithm:
C      EG,SG,EL,SL: exspectation value and standard deviation
C      of gradients and Laplace-terms resp. by noise (out)
C      other parameters as in afido
C
C------------------------------------------------------------------------
       IMPLICIT NONE
C
       LOGICALL
       CHARACTER*1 YMT
       INTEGER     NX,NY,I1,J1,N1X,N1Y,I,J,T
       REAL        IN(NX,NY),H0(NX,NY),HG(NX,NY),HL(NX,NY),
     >             EG,EL,SG,SL,A,C,B,D,HX,HY,H,QG,QL,NP,NPP,
     >             MT(NX,NY)
C
C *** 1.order:smoothing
      DO  J=1,NY-1
        J1=J+1
        DO  I=1,NX-1
          I1=I+1
          H0(I1,J1)=(IN(I,J)+IN(I1,J)+IN(I,J1)+IN(I1,J1))/4.
        ENDDO
      ENDDO
C
C *** set edge lines: up and left and upper left corner pixel
      H0(1,1)=H0(2,2)                        ! corner
C
      DO I=2,NX
         H0(I,1)=H0(I,2)                     ! 1.row
      ENDDO
C
      DO J=2,NY
         H0(1,J)=H0(2,J)                     ! 1.column
      ENDDO
C
      L=.FALSE.
      NP=0.
      EL=NP
      EG=NP
      QL=NP
      QG=NP
C
C *** 2.order: centering
      DO J=1,NY-1
         J1=J+1
         DO I=1,NX-1
            I1=I+1
            A=H0(I,J)
            B=H0(I1,J)
            C=H0(I,J1)
            D=H0(I1,J1)
            H=(A+B+C+D)/4.
            H0(I,J)=H                        ! smooth
            H=IN(I,J)-H
            HL(I,J)=H                        ! Laplace
            IF (YMT.EQ.'N') GOTO 15          ! no mask for statistics
            T=MT(I,J)
            IF (T.NE.0) L=.TRUE.
            IF (L) GOTO 16                   ! pixel not used for statistics
   15       NPP=NP
            NP=NP+1
            NPP=NPP/NP
            H=H-EL
            EL=EL+H/NP                       ! estimate statistics
            QL=QL+H*H*NPP                    ! for Laplace
   16       HX=(A-B+C-D)/4.
            HY=(A+B-C-D)/4.
            H=SQRT(HX*HX+HY*HY)
            HG(I,J)=H                        ! gradient
            IF (YMT.EQ.'N') GOTO 17          ! no mask for statistics
            IF (L) GOTO 20                   ! pixel not used for statistics
   17       H=H-EG
            EG=EG+H/NP                       ! estimate statistics
            QG=QG+H*H*NPP                    ! for gradient
   20       L=.FALSE.
         ENDDO
      ENDDO

C correct statistics
      NP=NP-1
      SL=SQRT(QL/NP)
      SG=SQRT(QG/NP)
C
C *** set edge lines down and right and lower right corner pixel
      N1X=NX-1
      N1Y=NY-1
      H0(NX,NY)=H0(N1X,N1Y)                  ! corner
      HG(NX,NY)=HG(N1X,N1Y)
      HL(NX,NY)=HL(N1X,N1Y)

      DO I=1,N1X                             ! last row
         H0(I,NY)=H0(I,N1Y)
         HG(I,NY)=HG(I,N1Y)
         HL(I,NY)=HL(I,N1Y)
      ENDDO

      DO J=1,N1Y                             ! last column
         H0(NX,J)=H0(N1X,J)
         HG(NX,J)=HG(N1X,J)
         HL(NX,J)=HL(N1X,J)
      ENDDO
C
      RETURN
      END

C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or
C modify it under the terms of the GNU General Public License as
C published by the Free Software Foundation; either version 2 of
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public
C License along with this program; if not, write to the Free
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge,
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C       Internet e-mail: midas@eso.org
C       Postal address: European Southern Observatory
C                       Data Management Division
C                       Karl-Schwarzschild-Strasse 2
C                       D 85748 Garching bei Muenchen
C                       GERMANY
C===========================================================================

      SUBROUTINE IICINC(DSPLAY,CHAN,CURSNO,SHAPE,COLOUR,XC,YC,IDST)
C
      IMPLICIT NONE
C
      INTEGER     DSPLAY,CHAN
      INTEGER     CURSNO,SHAPE,COLOUR,XC,YC,IDST
C
      CALL IIC1(DSPLAY,CHAN,CURSNO,SHAPE)
      CALL IIC2(COLOUR,XC,YC,IDST)
C
      RETURN
      END

      SUBROUTINE IICRCP(DSPLAY,CHAN,CURSNO,XC,YC,MEMO,IDST)
C
      IMPLICIT NONE
C
      INTEGER     DSPLAY,CHAN
      INTEGER     CURSNO,XC,YC,MEMO,IDST
C
      CALL IIC1(DSPLAY,CHAN,CURSNO,XC)
      CALL IIC3(YC,MEMO,IDST)
C
      RETURN
      END

C @(#)simul.for	19.1 (ES0-DMD) 02/25/03 13:30:48
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE SIMUL(N,A,X)
C++++++++
C   THE GAUSS-JORDAN COMPLETE ELIMINATION METHOD IS EMPLOYED
C   WITH THE MAXIMUM PIVOT STRATEGY.
C--------
      IMPLICIT    NONE
      INTEGER     N
      DOUBLE PRECISION    A(4,4)
      REAL        X(1)
C
      INTEGER     IROW(4)
      INTEGER     JCOL(4)
      INTEGER     I, ISCAN, IROWI, IROWK
      INTEGER     J, JSCAN, JCOLI, JCOLK
      INTEGER     MAX
      INTEGER     K, KM1
      INTEGER     ISTAT
      DOUBLE PRECISION    AIJCK, PIVOT
      DOUBLE PRECISION    EPS
      PARAMETER (EPS=1.D-15)
C
      MAX=N+1   
C   BEGIN ELIMINATION PROCEDURE   
      DO 19 K=1,N                 
      KM1=K-1                     
C   SEARCH FOR THE PIVOT ELEMENT  
      PIVOT=0.D0                    
      DO 10 I=1,N                 
      DO 11 J=1,N                 
C   SEARCH IROW AND JCOL ARRAYS FOR INVALID PIVOT SUBSCRIPTS
      IF(K.EQ.1)GOTO 9            
      DO 8 ISCAN=1,KM1            
      DO 7 JSCAN=1,KM1            
      IF(I.EQ.IROW(ISCAN))GOTO 11 
      IF(J.EQ.JCOL(JSCAN))GOTO 11 
7     CONTINUE                    
8     CONTINUE                    
9     CONTINUE                    
      IF(DABS(A(I,J)).LE.DABS(PIVOT))GOTO 11
      PIVOT=A(I,J)
      IROW(K)=I   
      JCOL(K)=J   
11    CONTINUE    
10    CONTINUE    
C   INSURE THAT SELECTED PIVOT IS LARGER THAN EPS
      IF(DABS(PIVOT).GT.EPS)GOTO 13
       CALL STTPUT(' WARNING! SINGULAR MATRIX',' ',' ',ISTAT)
      RETURN                      
13    IROWK=IROW(K)               
      JCOLK=JCOL(K)               
C   NORMALIZE PIVOT ROW ELEMENTS  
      DO 14 J=1,MAX               
14    A(IROWK,J)=A(IROWK,J)/PIVOT 
C   CARRY OUT ELIMINATION         
      A(IROWK,JCOLK)=1.D0/PIVOT     
      DO 18 I=1,N                 
      AIJCK=A(I,JCOLK)            
      IF(I.EQ.IROWK)GOTO 18       
      A(I,JCOLK)=-AIJCK/PIVOT     
      DO 17 J=1,MAX               
      IF(J.NE.JCOLK) A(I,J)=A(I,J)-AIJCK*A(IROWK,J) 
17    CONTINUE              
18    CONTINUE
19    CONTINUE   
C   ORDER SOLUTION VALUES   
      DO 20 I=1,N           
      IROWI=IROW(I)         
      JCOLI=JCOL(I)         
      X(JCOLI)= A(IROWI,MAX)
20    CONTINUE
      RETURN
      END

C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION        ISTRAW.FOR
C.AUTHOR:               J.D.PONZ  ESA-VILSPA        
C.KEYWORDS              IUE, GO FORMAT, RAW IMAGE
C.PURPOSE
C \begin{TeX}
C    Reads the raw image file and stores the information into a MIDAS 
C    image. The format of the image is controlled by the argument
C    DSKFMT as follows:
C           0 = floating point
C           1 = byte
C          -1 = the disk file is not created. Used to list header only.
C
C    The routine performs the following functions (routine name in brackets)
C    \begin{enumerate}
C    \item Handles the file header (ISTFHD)
C    \item Creates the MIDAS image file (STFCRE)
C    \item Iterates on the image lines to:
C          \begin{itemize}
C           \item Read image line (ISTREA)
C           \item Decode pixel info according to DSKFMT
C           \item Write line into file (STFPUT)
C          \end{itemize}
C    \item Writes standard image descriptors (STDWRx)
C    \item Writes IUE specific descriptors (ISTDES)
C    \item Closes the image file (STFCLO)
C    \end{enumerate}
C \end{TeX}
C.LANGUAGE:               F77 
C.COMMENTS
C \begin{TeX}
C    The following extensions are used:
C   \begin{itemize}
C     \item IMPLICIT NONE
C     \item INCLUDE statement
C     \item long variable names
C     \item underscore character
C   \end{itemize}
C \end{TeX}
C.VERSION: 1.0  INITIAL CODING  09 JUL 1990
C.VERSION: 1.1  REMOVE VMS EXTENSIONS
C------------------------------------------------------------------
      SUBROUTINE ISTRAW(CHANL,BUFF,FILE,DSKFMT,DSPFLG,STATUS)
C
      IMPLICIT NONE
      INTEGER       CHANL             ! IN: tape channel number
      CHARACTER*(*) BUFF              ! IN: buffer with the ascii header
      CHARACTER*(*) FILE              ! IN: file name
      INTEGER       DSKFMT            ! IN: disk format (0:R*4,  1:Byte)
      INTEGER       DSPFLG            ! IN: DISPLAY FLAG
      INTEGER       STATUS            ! OUT: status
C
      INTEGER   DTYPE, NO, SIZE, FELM, NL, NR, LEN, I, J
      INTEGER   NAXIS(1), NPIX(2), DUM(1)
      INTEGER   IBUFF(768)
      REAL      RBUFF(768)
      REAL      CUTS(4)
      CHARACTER*72 IDENT, CUNIT
      DOUBLE PRECISION START(2), STEP(2)
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
      DATA CUNIT/'DN              PIXEL           PIXEL     '/
C
      NL     = 768
      NR     = 768
      SIZE   = 768*768
      STATUS = 0
C
C ... decode full header, print it and put info in common area
C
      CALL ISTFHD(CHANL,BUFF,DSPFLG,STATUS)
      IF (STATUS.NE.0) RETURN
      IF (DSKFMT.LT.0) RETURN    ! only header list
C
C ... create the frame
C
      IF (DSKFMT.EQ.0) THEN
          DTYPE = D_R4_FORMAT
      ELSE
          DTYPE = D_I1_FORMAT
      ENDIF
      CALL STFCRE(FILE,DTYPE,F_O_MODE,F_IMA_TYPE,SIZE,NO,STATUS)
      IF (STATUS.NE.0) RETURN
C
C ... loop to read tape and write into disk
C
      FELM = 1
      IF (DSKFMT.EQ.0) THEN                        ! write with conversion
        DO 10 I = 1, NL
           CALL ISTRBY(CHANL,IBUFF,NR,LEN,STATUS)
           IF (NR.NE.LEN .OR. STATUS.NE.0) RETURN
           DO 5 J = 1, NR
               RBUFF(J) = IBUFF(J)
  5        CONTINUE
           CALL STFPUT(NO,FELM,NR,RBUFF,STATUS)
           IF (STATUS.NE.0) RETURN            
           FELM = FELM + NR
 10     CONTINUE
      ELSE                                         ! write without conversion
        DO 20 I = 1, NL
           CALL ISTRB1(CHANL,IBUFF,NR,LEN,STATUS)
           IF (NR.NE.LEN .OR. STATUS.NE.0) RETURN
           CALL STFPUT(NO,FELM,NR,IBUFF,STATUS)
           IF (STATUS.NE.0) RETURN            
           FELM = FELM + NR
 20     CONTINUE
      ENDIF
C
C ... write image descriptors
C
      NAXIS(1) = 2
      NPIX(1)  = 768
      NPIX(2)  = 768
      START(1) = 1.0D0
      START(2) = 1.0D0
      STEP(1)  = 1.0D0
      STEP(2)  = 1.0D0
      CUTS(1)  = 0.
      CUTS(2)  = 255.
      CUTS(3)  = 0.
      CUTS(4)  = 255.
      IDENT    = BUFF(145:210)
      CALL STDWRI(NO,'NAXIS',NAXIS,1,1,DUM,STATUS)
      CALL STDWRI(NO,'NPIX',NPIX,1,2,DUM,STATUS)
      CALL STDWRD(NO,'START',START,1,2,DUM,STATUS)
      CALL STDWRD(NO,'STEP',STEP,1,2,DUM,STATUS)
      CALL STDWRR(NO,'LHCUTS',CUTS,1,4,DUM,STATUS)
      CALL STDWRC(NO,'IDENT',1,IDENT,1, 72,DUM,STATUS)
      CALL STDWRC(NO,'CUNIT',1,CUNIT,1, 48,DUM,STATUS)
C
C ... write label descriptors
C
      CALL ISTDES(NO,BUFF,STATUS)
      CALL STFCLO(NO,STATUS)
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2008 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C 
C.VERSION
C 1.0		from 1986 orig code move to ST interfaces
C 
C 080122	last modif
C 
C ----------------------------------------------------------------------
C 
      SUBROUTINE GXMOVIT(A,B,AOFF,BOFF,NOPIX,NOLINS,AXSIZE,BXSIZE,RCUTS)
C 
C  copy stuff from array A to array B
C 
C     .................
C     .................          ..............
C     ....aaaaaaa......          .bbbbbbb......
C     ....aaaaaaa......   ==>    .bbbbbbb......
C     ....aaaaaaa......          .bbbbbbb......
C     .................          ..............
C     .................          ..............
C     .................
C 
      IMPLICIT NONE
C 
      REAL    A(*),B(*),RCUTS(2)
C 
      INTEGER AOFF,BOFF,NOPIX,NOLINS,AXSIZE,BXSIZE
      INTEGER NY,NX,AAOFF,BBOFF,KOFF,LOFF,LINLIM
C 
      AAOFF = AOFF
      BBOFF = BOFF                         !we don't modify original offsets...
C 
      IF ((NOPIX+BOFF-1).GT.BXSIZE) THEN
         LINLIM = BXSIZE - BOFF + 1
      ELSE
         LINLIM = NOPIX
      ENDIF
C 
      DO 2000 NY=1,NOLINS
         KOFF = AAOFF
         LOFF = BBOFF
         DO 1000 NX=1,LINLIM
            B(LOFF) = A(KOFF)
            IF (B(LOFF).LT.RCUTS(1)) RCUTS(1) = B(LOFF)
            IF (B(LOFF).GT.RCUTS(2)) RCUTS(2) = B(LOFF)
            LOFF = LOFF + 1
            KOFF = KOFF + 1
1000     CONTINUE
         AAOFF = AAOFF + AXSIZE
         BBOFF = BBOFF + BXSIZE
2000  CONTINUE
C      
      RETURN
      END

      SUBROUTINE GXDOIT(A,B,C,THR,INOUT,SIZE,TRUSIZ)
C
      IMPLICIT NONE
C
      INTEGER    INOUT,SIZE,TRUSIZ
      INTEGER    N,NOUT
C
      REAL       A(SIZE),B(SIZE),C(*),THR(2)
C
      NOUT = 0
      IF(INOUT .EQ. 0) THEN		!use .GE. for backw. compatibility
         DO 1000, N=1,SIZE
            IF (B(N).GE.THR(1)) THEN
               NOUT = NOUT + 1
               C(NOUT) = A(N)
            ENDIF
1000     CONTINUE
C
      ELSE IF(INOUT .EQ. 1) THEN
         DO 2000, N=1,SIZE
            IF ((B(N).GE.THR(1)) .AND.
     +          (B(N).LE.THR(2))) THEN
               NOUT = NOUT + 1
               C(NOUT) = A(N)
            ENDIF
2000     CONTINUE
C 
      ELSE
         DO 5000, N=1,SIZE
            IF ((B(N).LT.THR(1)) .OR.
     +          (B(N).GT.THR(2))) THEN
               NOUT = NOUT + 1
               C(NOUT) = A(N)
            ENDIF
5000     CONTINUE
      ENDIF
C
      TRUSIZ = NOUT
      RETURN
      END

      SUBROUTINE GXIZAMAP(NPIXA,NPIXB,STARTB,STEPB,A,B,C,FLAG)
C
      IMPLICIT NONE
C
      REAL         A(*),B(*),C(*)
      REAL         RVAL,ENDB,DIFF,DIFF1,DIFF2
C
      DOUBLE PRECISION STARTB,STEPB
C
      INTEGER      NPIXA(*),NPIXB(*),FLAG(*)
      INTEGER      N,KIDX,TOTAL,IOFF,NN,MCLOSE
C
      TOTAL = NPIXA(1) * NPIXA(2) * NPIXA(3)
      IF (FLAG(2).EQ.1) GOTO 3000
      IF (FLAG(2).EQ.2) GOTO 5000
C
C -------------------------------------------------------C
C
C  here for equidistant map space
C
C -------------------------------------------------------C
C
      ENDB = STARTB + ((NPIXB(1) - 1) * STEPB)
      IF (FLAG(1).EQ.1) GOTO 1000
C
      DO 400 N=1,TOTAL
         RVAL = A(N)
C
         IF (RVAL.LE.STARTB) THEN
            KIDX = 1
         ELSE IF (RVAL.GE.ENDB) THEN
            KIDX = NPIXB(1)
         ELSE
            KIDX = NINT((RVAL-STARTB)/STEPB) + 1
         ENDIF
C
         C(N) = B(KIDX)
400   CONTINUE
C
      RETURN
C
C  here we leave all pixels with intensities outside the map coordinate space
C  as they are
C
1000  DO 1400 N=1,TOTAL
         RVAL = A(N)
C
         IF ( (RVAL.LT.STARTB) .OR. (RVAL.GT.ENDB) ) THEN
            C(N) = A(N)
         ELSE
            KIDX = NINT((RVAL-STARTB)/STEPB) + 1
            C(N) = B(KIDX)
         ENDIF
1400  CONTINUE
C
      RETURN
C
C -------------------------------------------------------C
C
C  here we have the coordinates stored in the 1. line of the map frame,
C  intensities follow in the 2. line
C
C -------------------------------------------------------C
C
3000  IOFF = NPIXB(1)
      STARTB = B(1)
      ENDB = B(IOFF)
      IF (FLAG(1).EQ.1) GOTO 4000
C
      DO 3500 N=1,TOTAL
         RVAL = A(N)
C
         IF (RVAL.LE.STARTB) THEN
            KIDX = 1 + IOFF
         ELSE IF (RVAL.GE.ENDB) THEN
            KIDX = IOFF + IOFF
         ELSE
            MCLOSE = 1
            DIFF1 = ABS(RVAL-STARTB)
C
            DO 3200 NN=2,IOFF                  !find closest coordinate
               DIFF = ABS(RVAL-B(NN))
               IF (DIFF.LT.DIFF1) THEN
                  DIFF1 = DIFF
                  MCLOSE = NN
               ELSE
                  KIDX = MCLOSE + IOFF
                  GOTO 3333
               ENDIF
3200        CONTINUE
         ENDIF
C
3333     C(N) = B(KIDX)
3500  CONTINUE
C
      RETURN
C
C  here we leave all pixels with intensities outside the map coordinate space
C  as they are
C
4000  DO 4500 N=1,TOTAL
         RVAL = A(N)
C
         IF ( (RVAL.LT.STARTB) .OR. (RVAL.GT.ENDB) ) THEN
            C(N) = A(N)
C
         ELSE
            MCLOSE = 1
            DIFF1 = ABS(RVAL-STARTB)
C
            DO 4200 NN=2,IOFF                  !find closest coordinate
               DIFF = ABS(RVAL-B(NN))
               IF (DIFF.LT.DIFF1) THEN
                  DIFF1 = DIFF
                  MCLOSE = NN
               ELSE
                  KIDX = MCLOSE + IOFF
                  GOTO 4333
               ENDIF
4200        CONTINUE
4333        C(N) = B(KIDX)
         ENDIF
C
4500  CONTINUE
C
      RETURN
C
C -------------------------------------------------------C
C
C  here we have the intervals stored in the 1. line of the map frame,
C  intensities follow in the 2. line (for start,end - in between interpolation ...)
C
C -------------------------------------------------------C
C
5000  IOFF = NPIXB(1)
      STARTB = B(1)
      ENDB = B(IOFF)
      IF (FLAG(1).EQ.1) GOTO 6000
C
      DO 5555 N=1,TOTAL
         RVAL = A(N)
C
         IF (RVAL.LT.STARTB) THEN
            RVAL = STARTB
         ELSE IF (RVAL.GT.ENDB) THEN
            RVAL = ENDB
         ENDIF
C
         DO 5200 NN=1,IOFF,2                 !find enclosing interval
            IF (RVAL.LE.B(NN+1)) THEN
                KIDX = NN
                GOTO 5333
            ELSE IF (RVAL.LT.B(NN+2)) THEN
                C(N) = A(N)
                GOTO 5555                    !no interval there ...!
            ENDIF
5200     CONTINUE
C
5333     DIFF = B(KIDX+1) - B(KIDX)
         DIFF1 = (RVAL - B(KIDX)) / DIFF
         DIFF2 = (B(KIDX+1) - RVAL) / DIFF
         KIDX = KIDX + IOFF                  !point to data line
         C(N) = ( B(KIDX+1) * DIFF1 ) + ( B(KIDX) * DIFF2 )
5555  CONTINUE
C
      RETURN
C
C  here we leave all pixels with intensities outside the map coordinate space
C  as they are
C
6000  DO 6555 N=1,TOTAL
         RVAL = A(N)
C
         IF (RVAL.LT.STARTB) THEN
            C(N) = A(N)
            GOTO 6555
         ELSE IF (RVAL.GT.ENDB) THEN
            C(N) = A(N)
            GOTO 6555
         ENDIF
C
         DO 6200 NN=1,IOFF,2                  !find enclosing interval
            IF (RVAL.LE.B(NN+1)) THEN
               KIDX = NN
               GOTO 6333
            ELSE IF (RVAL.LT.B(NN+2)) THEN
               C(N) = A(N)
               GOTO 6555                      !no interval there ...!
            ENDIF
6200     CONTINUE
C
6333     DIFF = B(KIDX+1) - B(KIDX)
         DIFF1 = (RVAL - B(KIDX)) / DIFF
         DIFF2 = (B(KIDX+1) - RVAL) / DIFF
         KIDX = KIDX + IOFF                   !point to data line
         C(N) = ( B(KIDX+1) * DIFF1 ) + ( B(KIDX) * DIFF2 )
6555  CONTINUE
C
      RETURN
      END

      SUBROUTINE GXMATRX(A,NPIX,C)
C
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C  straight forward transposition of an image (seen as a matrix)
C  this however implies, that the first element is in the upper left corner
C  since matrices are usually written like that ...
C
C -------------------------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      NPIX(*)
      INTEGER      NX,NY
      INTEGER      XDIM,YDIM,OFFA,OFFC,WORK
C
      REAL         A(*),C(*)
C
C  init
      XDIM = NPIX(1)
      YDIM = NPIX(2)
      OFFC = 0
      WORK = XDIM * (YDIM-1)
C
C  loop through rows in output matrix
      DO 1000 NX=XDIM,1,-1
         OFFA = WORK
C
         DO 400 NY=1,YDIM                          !loop till middle of row
            C(NY+OFFC) = A(NX+OFFA)
            OFFA = OFFA - XDIM
400      CONTINUE
C
         OFFC = OFFC + YDIM
1000  CONTINUE
      RETURN
C
      END

C===========================================================================
C Copyright (C) 1995-2006 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================

C ++++++++++++++++++++++++  YVECSUBS.FOR +++++++++++++++++++++++++++++++++++++++
C .LANGUAGE Fortran 77
C .IDENTIFICATION Module YVECSUBS.FOR
C .COMMENTS
C Module contains layer between the keyword related FORTRAN STxxxx interfaces
C and the SC_interfaces written in (hopefully independent) C
C .AUTHOR         K. Banse        ESO - Garching
C .KEYWORDS       standard interfaces.
C .ENVIRONMENT    FORTRAN and C standards
C .VERSION  [1.00] 871207:  created from SXFTOC.C
C 
C 060330	last modif
C ......................................................
C
C   call as OPFC(OPCODE,A,SCALR,C,NDIM,USRNUL,NCNT)
C           OPFF(OPCODE,A,B,C,NDIM,USRNUL,NCNT)
C
C   input par:
C   OPCODE:      char.exp.      operation code in postfix notation, e.g. "FF+"
C   A:           R*4 array      1. input array
C   B:           R*4 array      2. input array
C   SCALR:       R*4            scalar value
C   NDIM:        I*4            size of arrays involved
C   USRNUL:      R*4            user null value
C
C   output par:
C   C:           R*4 array      result array
C   NCNT:        I*4            null count
C
C -------------------------------------------------- 

      SUBROUTINE OPFC(OPCODE,A,RCONST,C,NDIM,USRNUL,NCOUNT)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   OPCODE
      REAL   A(*), C(*)
      REAL   RCONST, USRNUL
      INTEGER     NDIM, NCOUNT
C 
      CALL STSTR(1,OPCODE)
      CALL YOPFC(A,RCONST,C,NDIM,USRNUL,NCOUNT)
C
      RETURN
      END
C
      SUBROUTINE OPFF(OPCODE,A,B,C,NDIM,USRNUL,NCOUNT)
C 
      IMPLICIT NONE
C
      CHARACTER*(*)   OPCODE
      REAL   A(*), C(*), B(*)
      REAL   USRNUL
      INTEGER     NDIM, NCOUNT
C
      CALL STSTR(1,OPCODE)
      CALL YOPFF(A,B,C,NDIM,USRNUL,NCOUNT)
C
      RETURN
      END
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++
C 
C call as FUN1F(CFUNC,A,C,NDIM,USRNUL,NCNT)
C         FUN2FF(CFUNC,A,B,C,NDIM,USRNUL,NCNT)
C         FUN2FC(CFUNC,A,SCALR,C,NDIM,USRNUL,NCNT)
C 
C  input par:
C  CFUNC:     char.exp.      function to do
C  A:         R*4 array      1. input array
C  B:         R*4 array      2. input array
C  NDIM:      I*4            size of arrays involved
C
C  output par:
C  C:         R*4 array      result array
C
C 030514         last modif
C
C -------------------------------------------------- 
C 
      SUBROUTINE FUN1F(CFUNC,A,C,NDIM,USRNUL,NCOUNT)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   CFUNC
      REAL   A(*), C(*)
      REAL   USRNUL
      INTEGER     NDIM, NCOUNT
C
      CALL STSTR(1,CFUNC)
      CALL YFUN1F(A,C,NDIM,USRNUL,NCOUNT)
C
      RETURN
      END
C

      SUBROUTINE FUN2FF(CFUNC,A,B,C,NDIM,USRNUL,NCOUNT)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   CFUNC
      REAL   A(*), C(*), B(*)
      REAL   USRNUL
      INTEGER     NDIM, NCOUNT
C
      CALL STSTR(1,CFUNC)
      CALL YF2FF(A,B,C,NDIM,USRNUL,NCOUNT)
C
      RETURN
      END
C
      SUBROUTINE FUN2FC(CFUNC,A,SCALR,C,NDIM,USRNUL,NCOUNT)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   CFUNC
      REAL   A(*), C(*)
      REAL   SCALR, USRNUL
      INTEGER     NDIM, NCOUNT
C
      CALL STSTR(1,CFUNC)
      CALL YF2FC(A,SCALR,C,NDIM,USRNUL,NCOUNT)
C
      RETURN
      END
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++
C
C  do it according to opcode ( `, +, -, *, / or =)
C  ` means ** (to the power of)
C  special condition handler is used for division by "zero"
C 
C  call as DOPFC(OPCODE,A,SCALR,C,NDIM,USRNUL,NCNT)
C          DOPFF(OPCODE,A,B,C,NDIM,USRNUL,NCNT)
C
C  input par:
C  OPCODE:      char.exp.      operation code in postfix notation, e.g. "FF+"
C  A:           R*8 array      1. input array
C  B:           R*8 array      2. input array
C  SCALR:       R*8            scalar value
C  NDIM:        I*4            size of arrays involved
C
C  output par:
C  C:           R*8 array      result array
C
C --------------------------------------------------  

      SUBROUTINE DOPFC(OPCODE,A,SCALR,C,NDIM,USRNUL,NCOUNT)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   OPCODE
      DOUBLE PRECISION   A(*), C(*), SCALR
      REAL   USRNUL
      INTEGER     NDIM, NCOUNT
C
      CALL STSTR(1,OPCODE)
      CALL YDOPFC(A,SCALR,C,NDIM,USRNUL,NCOUNT)
C
      RETURN
      END
C

      SUBROUTINE DOPFF(OPCODE,A,B,C,NDIM,USRNUL,NCOUNT)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   OPCODE
      DOUBLE PRECISION   A(*), C(*), B(*)
      REAL   USRNUL
      INTEGER     NDIM, NCOUNT
C
      CALL STSTR(1,OPCODE)
      CALL YDOPFF(A,B,C,NDIM,USRNUL,NCOUNT)
C
      RETURN
      END
C 
C ++++++++++++++++++++++++++++++++++++++++++++++++
C 
C  use special condition handler NULLER to trap invalid input to functions
C  all trigonometric functions work with degrees...
C
C  call as DFN1F(CFUNC,A,C,NDIM,USRNUL,NCNT)
C          DFN2FF(CFUNC,A,B,C,NDIM,USRNUL,NCNT)
C          DFN2FC(CFUNC,A,SCALR,C,NDIM,USRNUL,NCNT)
C
C  input par:
C  CFUNC:      char.exp.      input function
C  NDIM:       I*4            size of arrays involved
C  A:          R*8 array      1. input array
C  B:          R*8 array      2. input array
C  SCALR:       R*8            input scalar value
C
C  output par:
C  C:          R*8 array      result array
C
C -------------------------------------------------- 
C
      SUBROUTINE DFN1F(CFUNC,A,C,NDIM,USRNUL,NCOUNT)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   CFUNC
      DOUBLE PRECISION   A(*), C(*)
      REAL   USRNUL
      INTEGER     NDIM, NCOUNT
C
      CALL STSTR(1,CFUNC)
      CALL YDF1F(A,C,NDIM,USRNUL,NCOUNT)
C
      RETURN
      END
C

      SUBROUTINE DFN2FF(CFUNC,A,B,C,NDIM,USRNUL,NCOUNT)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   CFUNC
      DOUBLE PRECISION   A(*), C(*), B(*)
      REAL   USRNUL
      INTEGER     NDIM, NCOUNT
C
      CALL STSTR(1,CFUNC)
      CALL YDF2FF(A,B,C,NDIM,USRNUL,NCOUNT)
C
      RETURN
      END
C
      SUBROUTINE DFN2FC(CFUNC,A,SCALR,C,NDIM,USRNUL,NCOUNT)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   CFUNC
      DOUBLE PRECISION   A(*), C(*), SCALR
      REAL   USRNUL
      INTEGER     NDIM, NCOUNT
C
      CALL STSTR(1,CFUNC)
      CALL YDF2FC(A,SCALR,C,NDIM,USRNUL,NCOUNT)
C
      RETURN
      END
C

C @(#)ramp.for	19.1 (ES0-DMD) 02/25/03 13:24:47
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM RAMP
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C
C  Program RAMP               version 1.00       860706
C                             version 2.00       890424 (pMIDAS)
C
C  F. Murtagh                 STECF            
C  M .Peron                   IPG               890901 add include files
C  P. Ballester               IPG               910313 Compil. option -u
C                                                      and more
C.KEYWORDS
C  Simulated images, artificial images, test images.
C
C.PURPOSE
C  Create "ramp" ("background") test image, with user-specified slope
C  (in units/pixel along the gradient), position angle, and image
C  dimension.
C
C.INPUT PARAMETERS
C
C  Keys:  OUT_A/C/1/60        output data array
C         INPUTR/R/1/1       slope
C         INPUTI/I/1/1       position angle
C         INPUTI/I/2/1       dimension of output image
C
C-----------------------------------------------------------
C
C
      IMPLICIT NONE
C
      REAL                  RMIN,RMAX
      REAL                  STEPO(3),STARTO(3),CUTS(4)
      DOUBLE PRECISION      DSTART(3),DSTEP(3)
      INTEGER               NPIXO(3),MADRID,KUN,KNUL
      CHARACTER*60            OUTIMA
      CHARACTER*72            IDENTO
      CHARACTER*80            CUNITO
C
      INTEGER               IACT,ISTAT,IANGLE,IDIM,NDIMO
      INTEGER*8             JPNTR
      INTEGER               IMNO,KUNIT
      REAL                  SLOPE
C
        INCLUDE                 'MID_INCLUDE:ST_DEF.INC/NOLIST'
        COMMON                  /VMR/MADRID(1)
        INCLUDE                 'MID_INCLUDE:ST_DAT.INC/NOLIST'


C
C
C ... get into MIDAS
C
      CALL STSPRO('RAMP')
C
C ... get name of output frame
C
        CALL STKRDC('OUT_A',1,1,60,IACT,OUTIMA,KUN,KNUL,ISTAT)
C
C ... get slope, position angle (<= 90 degrees), and dimensions.
C
        CALL STKRDR('INPUTR',1,1,IACT,SLOPE,KUN,KNUL,ISTAT)
        CALL STKRDI('INPUTI',1,1,IACT,IANGLE,KUN,KNUL,ISTAT)
        CALL STKRDI('INPUTI',2,1,IACT,IDIM,KUN,KNUL,ISTAT)
C
C ... map output image
C
      NDIMO = 2
      NPIXO(1)  = IDIM
      NPIXO(2)  = IDIM
      STARTO(1) = 1
      STARTO(2) = 1
      STEPO(1)  = 1.0
      STEPO(2)  = 1.0 
      IDENTO    = ' ARTIFICIAL RAMP BACKGROUND IMAGE'
      CUNITO    = ' NONE'
        DSTART(1) = STARTO(1)
        DSTEP(1)  = STEPO(1)
        CALL STIPUT(OUTIMA,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .            NDIMO,NPIXO,DSTART,
     .            DSTEP,IDENTO,CUNITO,JPNTR,IMNO,ISTAT)
C
C ... now do the work
C
      CALL PATTERN(MADRID(JPNTR),RMIN,RMAX,IANGLE,SLOPE,IDIM,ISTAT)
C
C ... write cuts
C
      CUTS(1) = RMIN
      CUTS(2) = RMAX
      CUTS(3) = RMIN
      CUTS(4) = RMAX
      CALL STDWRR(IMNO,'LHCUTS',CUTS,1,4,KUNIT,ISTAT)
C
C ... end
C
      CALL STFCLO(IMNO,ISTAT)
      CALL STSEPI
      END

C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C
C  Program PATTERN    
C  F. MURTAGH                                 ST-ECF  Version 1.0 860411
C
C.KEYWORDS
C
C  Test patterns, simulated images.
C
C.OUTPUT PARAMETERS
C 
C  ARR  = the frame,
C  RMIN, RMAX = cut values (max. and min. flux values).
C
C.INPUT PARAMETERS
C
C  IANGLE = position angle (0, 90 or some integer value in between),
C  SLOPE = ramp slope (units/pixel along gradient) - default = 1.0,
C  IDIM   = image dimensions (default = 128),
C  ISTAT  
C
C----------------------------------------------------------------------
      SUBROUTINE PATTERN(ARR,RMIN,RMAX,IANGLE,SLOPE,IDIM,ISTAT)
C
      IMPLICIT NONE
C
C
      INTEGER              IANGLE,IDIM,ISTAT,NDIM1,NDIM2,I,J
      REAL                 ARR(IDIM,IDIM)
      REAL                 RMIN,RMAX,SLOPE,TOT,ANGLE,C,R,RTOT
C
C
C
      NDIM1 = IDIM
      NDIM2 = IDIM
      TOT   = 0.0
C
      IF (IANGLE.EQ.90) THEN
         DO I = 1, NDIM1
            DO J = 1, NDIM2
               ARR(I,J) = SLOPE*(FLOAT(J))
             TOT = TOT + ARR(I,J)
            ENDDO
         ENDDO
      ELSE IF (IANGLE.EQ.0) THEN
         DO J = 1, NDIM1
            DO I = 1, NDIM2
               ARR(I,J) = SLOPE*(FLOAT(I))
             TOT = TOT + ARR(I,J)
            ENDDO
         ENDDO
      ELSE
         ANGLE = IANGLE
         DO I = 1, NDIM1
            C = (TAN(90.0-ANGLE)+TAN(ANGLE))*FLOAT(I)
            DO J = 1, NDIM2
             R = FLOAT(J)/SIN(ANGLE)
             RTOT = R + C*SIN(90.0-ANGLE)
             ARR(I,J) = SLOPE*RTOT
             TOT = TOT + ARR(I,J)
            ENDDO
         ENDDO
      ENDIF          
C
C  Normalize to mean flux per pixel of 100 units
C
      TOT = TOT/FLOAT(NDIM1*NDIM2)
      DO I = 1, NDIM1
         DO J = 1, NDIM2
            ARR(I,J) = 100.0+ARR(I,J)-TOT
         ENDDO
      ENDDO
C
C
C ------DETERMINE CUTS (I.E. MAX AND MIN VALUES)---------------------
C
      RMIN = 1000000.
      RMAX = -100000.
      DO I = 1, NDIM1
         DO J = 1, NDIM2
            IF (ARR(I,J).LT.RMIN) RMIN = ARR(I,J)
            IF (ARR(I,J).GT.RMAX) RMAX = ARR(I,J)
         ENDDO
      ENDDO
C
C
      RETURN
C
      END

C @(#)tdconv.for	19.1 (ESO-IPG) 02/25/03 14:11:11
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  14:22 - 19 NOV 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR: J.D.PONZ
C  900219  KB, throw out SX calls...
C
C.IDENTIFICATION
C  program TDCONV
C
C.PURPOSE
C  Table to Image conversion
C  Execute the command
C  CONV/TAB image = table colx [z] refima method
C                 for method = SPLINE                 
C
C.KEYWORDS
C  table, image, conversion
C
C
C.ALGORITHM
C  Use table interface routines for I/O
C   The conversion from table format into image is done
C  by spline interpolation.
C  The interpolation scheme is based on Hermite polynomials
C  Ref .: Publ. of the Dominion Astrophys. Obs. 204, 1982.
C
C 021129		last modif
C 
C-----------------------------------------------------------
C
      SUBROUTINE TDCONV
      IMPLICIT NONE
C
      INTEGER     MADRID
      INTEGER PNVALS, STATUS, N1, NBY, IMNO,REF
      INTEGER ICOL(3),NPTOT(100),NPIX(2),KUN,KNUL
      INTEGER NORDER(100)
      INTEGER NPAR, ISTAT, NN, NAXIS, NO, NB, NDIM, TID, IS
      INTEGER NCOL, NROW, NSC, NAC, NAR, I, I1, I2
      INTEGER*8   PNTR, IP1, IP2
C
      DOUBLE PRECISION STEP(2),START(2)
      REAL   RMIN,RMAX, CUTS(4)
      DOUBLE PRECISION WSTART(100)
C
      CHARACTER*80 TABLE,IMAGE,REFIMA
      CHARACTER*17 COLREF(2)
      CHARACTER*60 WORK
      CHARACTER*16 MSG
      CHARACTER*8  TYPE
      CHARACTER*72 IDENT
      CHARACTER*80 CUNIT
C
      INCLUDE 'MID_INCLUDE:TABLES.INC'
      COMMON /VMR/MADRID(1)
      INCLUDE 'MID_INCLUDE:TABLED.INC'
C
      DATA PNVALS/8/
      DATA MSG/'ERR:TCONVTBLxxxx'/
      DATA NPIX /1,1/, START /0.,0./, STEP /1.,1./
C
C ... get input parameters + default
C
      CALL TDPGET(PNVALS,NPAR,ISTAT)
      IF (ISTAT.NE.0) GO TO 30
      IMAGE     = TPARBF(1)
      TABLE     = TPARBF(3)
      COLREF(1) = TPARBF(4)
      COLREF(2) = TPARBF(5)
      REFIMA = TPARBF(6)
      CALL STFOPN(REFIMA,D_R4_FORMAT,0,F_IMA_TYPE,REF,ISTAT)
      CALL STDRDI(REF,'NAXIS',1,1,NN,NAXIS,KUN,KNUL,ISTAT)
      CALL STDRDI(REF,'NPIX',1,NAXIS,NN,NPIX,KUN,KNUL,ISTAT)
      CALL STDRDD(REF,'START',1,NAXIS,NN,START,KUN,KNUL,ISTAT)
      CALL STDRDD(REF,'STEP',1,NAXIS,NN,STEP,KUN,KNUL,ISTAT)
      IF (NAXIS.GT.1 .AND. NPIX(2).GT.1) THEN
          TYPE   = ' '
          CALL STDFND(REF,'WSTART',TYPE,NO,NB,ISTAT)
          IF (TYPE(1:1).EQ.' ') THEN
              CALL STTPUT(' Wrong reference image ',ISTAT)
              GO TO 30
          END IF
          CALL STDRDD(REF,'WSTART',1,NPIX(2),NN,WSTART,
     .                KUN,KNUL,ISTAT)
          CALL STDRDI(REF,'NPTOT',1,NPIX(2),NN,NPTOT,
     .                KUN,KNUL,ISTAT)
          CALL STDRDI(REF,'NORDER',1,NPIX(2),NN,NORDER,
     .                KUN,KNUL,ISTAT)
          NDIM   = 2

      ELSE
          NPIX(2) = 1
          NDIM   = 1
      END IF
C CALL EXIMAG(REFIMA,ISTAT)
C
C ... init input table
C
      TID = -1
      CALL TBTOPN(TABLE,F_I_MODE,TID,STATUS)
      IF (ISTAT.NE.0) GO TO 30
      CALL TBIGET(TID,NCOL,NROW,NSC,NAC,NAR,ISTAT)
      IF (ISTAT.NE.0) GO TO 30
C
C ... find input column
C
      DO 10 I = 1,2
          CALL TBCSER(TID,COLREF(I),ICOL(I),ISTAT)
          IF (ICOL(I).EQ.-1) THEN
              ISTAT  = ERRCOL
              GO TO 30
          END IF
          CALL TBUGET(TID,ICOL(I),WORK,ISTAT)
CC old: wrong, because CUNIT(1:16) is for unit of pixel values
CC          I1     = (I-1)*16 + 1
CC PN 8/99: add offset of 16: (I-1)*16 + 1 + 16 = 
          I1     = I*16 + 1
          I2     = I1 + 15
          CUNIT(I1:I2) = WORK(1:16)
   10 CONTINUE
C
C ... copy selected values of the table into work space
C
      NBY = 4*NROW
      CALL TDMGET(NBY, IP1, IS)
      CALL TDMGET(NBY, IP2, IS)
      CALL COPY(TID,ICOL(1),ICOL(2),NROW,MADRID(IP1),MADRID(IP2),N1)
      IF (N1.LE.3) THEN
          CALL STTPUT(' Not enough points in table ',ISTAT)
          GO TO 20
      END IF
C
C ... map image
C
CC old: wrong, because FLUX is the unit of the values in the image
CC      CUNIT(I2+1:I2+16) = 'FLUX'
CC PN 8/99: put this at the beginning
      CUNIT(1:16) = 'FLUX'
      I2 = INDEX(TABLE,' ')
      IF (I2.lt.1) I2 = LEN(TABLE)
      IDENT  = 'TABLE: '//TABLE(1:I2)//'COLS. :'//COLREF(1)//COLREF(2)
      CALL STIPUT(IMAGE,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     .            NDIM,NPIX,START,STEP,IDENT,CUNIT,
     .            PNTR,IMNO,STATUS)
C
C ... interpolate from table values
C
      CALL INTERP(N1,MADRID(IP1),MADRID(IP2),NPIX(1),NPIX(2),
     +            MADRID(PNTR),START,STEP,WSTART,NPTOT,RMIN,RMAX)
C
C ... write cuts
C
      CUTS(1) = RMIN
      CUTS(2) = RMAX
      CUTS(3) = RMIN
      CUTS(4) = RMAX
      CALL STDWRR(IMNO,'LHCUTS',CUTS,1,4,KUN,ISTAT)
      IF (NPIX(2).GT.1) THEN
          CALL STDWRD(IMNO,'WSTART',WSTART,1,NPIX(2),KUN,ISTAT)
          CALL STDWRI(IMNO,'NPTOT',NPTOT,1,NPIX(2),KUN,ISTAT)
          CALL STDWRI(IMNO,'NORDER',NORDER,1,NPIX(2),KUN,ISTAT)
      END IF
C
C ... free memory
C
   20 CALL TDMFRE(NBY, IP1, IS)
      CALL TDMFRE(NBY, IP2, IS)
C
C ... end
C
      CALL DSCUPT(IMNO,IMNO,' ',ISTAT)
      CALL TBTCLO(TID,ISTAT)
   30 IF (ISTAT.NE.0) THEN
          WRITE (MSG(13:16),9000) ISTAT
          CALL TDERRR(ISTAT,MSG,STATUS)
      END IF
      RETURN
 9000 FORMAT (I4)
      END

      SUBROUTINE COPY(TID,ICOL1,ICOL2,NROW,X1,Y1,N1)
C
C copy relevant part of the table
C
      IMPLICIT NONE
C
      INTEGER TID, ICOL1, ICOL2
      INTEGER NROW, N1, I
C
      INTEGER STATUS
      LOGICAL ISEL, INULL1, INULL2
      REAL X,Y,X1(NROW),Y1(NROW)
C
      N1     = 0
      DO 10 I = 1,NROW
          CALL TBSGET(TID,I,ISEL,STATUS)
          CALL TBERDR(TID,I,ICOL1,X,INULL1,STATUS)
          CALL TBERDR(TID,I,ICOL2,Y,INULL2,STATUS)
          IF (ISEL .AND. .NOT.INULL1 .AND. .NOT.INULL2) THEN
              N1     = N1 + 1
              X1(N1) = X
              Y1(N1) = Y
          END IF
   10 CONTINUE
      RETURN
      END

      SUBROUTINE INTERP(NROW,X,Y,NPIX1,NPIX2,F,START,STEP,WSTART,NPTOT,
     +                  RMIN,RMAX)
C
C      IMPLICIT NONE
C call for each order to the interpolation routine
C
      INTEGER NROW,NPIX1,NPIX2,IORD,I,NP,FLAG,I0
      REAL X(NROW),F(NPIX1,NPIX2),RMIN,RMAX
      REAL Y(NROW),STARTX,STEPX,VAL,XP
      INTEGER NPTOT(100)
      DOUBLE PRECISION WSTART(100)
      DOUBLE PRECISION START(2),STEP(2)
C
      RMIN   = +99999.9
      RMAX   = -99999.9
      STARTX = START(1)
      STEPX  = STEP(1)
      NP     = NPIX1
C
C ... order loop
C
      DO 30 IORD = 1,NPIX2
          IF (NPIX2.GT.1) THEN
              STARTX = WSTART(IORD)
              NP     = NPTOT(IORD)
          END IF
C
C ... loop for each point
C
          FLAG = 1
          CALL INTEP(FLAG,STARTX,VAL,X,Y,NROW,I0)
          RMIN   = AMIN1(RMIN,VAL)
          RMAX   = AMAX1(RMAX,VAL)
          F(1,IORD) = VAL
          FLAG = 0
          DO 10 I = 2,NP
              XP     = STARTX + (I-1)*STEPX
              CALL INTEP(FLAG,XP,VAL,X,Y,NROW,I0)
              RMIN   = AMIN1(RMIN,VAL)
              RMAX   = AMAX1(RMAX,VAL)
              F(I,IORD) = VAL
   10     CONTINUE
          DO 20 I = NP + 1,NPIX1
              F(I,IORD) = 0.
   20     CONTINUE
   30 CONTINUE
      RETURN

      END

      SUBROUTINE INTEP(FLAG,XP,P,X,Y,N,I0)
C
C Interpolate a function P at a given value XP using
C      IMPLICIT NONE
C the table of values (X,F).
C Spline interpolation scheme based on Hermite polynomials.
C Ref.: U.S. Airforce Surveys in Geophysics, no.272
C       Publ of the Dominion Astrophys. Obs. 204, 1982
C For random values of XP use INTEP, or after the first
C call to INTEP for incresing/decreasing values of XP consistent
C with the vector X, use EINTP
C
C Arguments :
C XP Input argument value
C P Output interpolated value
C X Input vector of independent values
C F Input vector of dependent values
C N Input number of points in (X,F) vector
C I0 will be saved in the calling routine
C
C global variables
      INTEGER FLAG,N,I0
C local variables
      INTEGER I,N1,IUP, K
C 
C global variables
      REAL Y(N),X(N),XP,P
C local variables      
      REAL FP1,FP2,XPI,XPI1
      REAL LP1,LP2,L1,L2
C
      SAVE
C
      IUP = 0
      IF (X(2).LT.X(1)) IUP = 1 
      N1 = N - 1 

C FLAG is only 1 when INTEP is called the first time
      IF (FLAG .EQ. 1) THEN 
         I0 = 1
      ENDIF

C  This part has to be outside of IF FLAG.EQ.1 loop 
C  to avoid problems on DEC machines:
      IF ((XP.GT.X(N).AND.IUP.EQ.0) .OR. 
     +       (XP.LT.X(N).AND.IUP.EQ.1) .OR.
     +       (XP.LT.X(1).AND.IUP.EQ.0) .OR. 
     +       (XP.GT.X(1).AND.IUP.EQ.1)) THEN
             P = 0.0
             RETURN
      ENDIF    

      DO 40 I = 1,N
         IF ((XP.LT.X(I) .AND. IUP.EQ.0) .OR. 
     +        (XP.GT.X(I) .AND. IUP.EQ.1)) THEN
            K = I
            GOTO 50
         ENDIF
 40   CONTINUE 
      P=0.0
      RETURN     
      
 50   I  = K - 1 
      IF (I.NE.I0-1) THEN
         I0     = I + 1
         LP1    = 1./ (X(I)-X(I+1))
         LP2    = 1./ (X(I+1)-X(I))
      ENDIF
      
      IF (I.NE.1) THEN
         FP1    = (Y(I+1)-Y(I-1))/ (X(I+1)-X(I-1))
         FP2 = 0.0 
      ELSE
         FP1    = (Y(2)-Y(1))/ (X(2)-X(1))
      ENDIF
 
C leave the IF order like in original code      
      IF (I.GE.N1) THEN
         FP2    = (Y(N)-Y(N-1))/ (X(N)-X(N-1))
      ELSE
         FP2    = (Y(I+2)-Y(I))/ (X(I+2)-X(I))
      ENDIF
      
      XPI1   = XP - X(I+1) 
      XPI    = XP - X(I)
      L1     = XPI1*LP1
      L2     = XPI*LP2
      P      = Y(I)* (1.-2.*LP1*XPI)*L1*L1 +
     +     Y(I+1)* (1.-2.*LP2*XPI1)*L2*L2 + FP2*XPI1*L2*L2 +
     +     FP1*XPI*L1*L1

      RETURN
      END

C @(#)cpfram.for	19.1 (ES0-DMD) 02/25/03 13:30:45
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++       
C.IDENTIFICATION: CPFRAM                                                  
C.AUTHOR:         R.H. Warmels     ESO Garching                        
C.PURPOSE:        Copy an image frame into a non-existing output frame
C.INPUT/OUTPUT:   INAR    real  array       input image frame               
C                 OUTAR   real  array       output image frame
C.VERSION:        880831  RHW  Creation
C -----------------------------------------------------------------------       
      SUBROUTINE CPFRAM(INAR,OUTAR,NCOL,NROW)
C
      IMPLICIT NONE
      INTEGER  NCOL
      INTEGER  NROW
      REAL     INAR(NCOL,NROW)
      REAL     OUTAR(NCOL,NROW)
C
      INTEGER  I
      INTEGER  J
C                                                                               
C                       
      DO 20 J = 1,NROW
         DO 10 I = 1,NCOL
            OUTAR(I,J) = INAR(I,J)
   10    CONTINUE
   20 CONTINUE
C
      RETURN
      END

C @(#)tcluster.for	19.1 (ES0-DMD) 02/25/03 13:27:33
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C
C.IDENTIFICATION
C
C  program TCLUSTER.FOR
C  F.Murtagh,J.D.Ponz           ESO/ST-ECF - Garching
C                               VERSION 1.0     22 JAN 85
C  F. Murtagh                   Version 2.0 New std. ifs. Oct. 1988
C
C  M. Peron                     Version 3.0 Sep 91
C.PURPOSE
C
C  Execute the command
C  CLUSTER/TABLE  intable outable [method]
C
C.KEYWORDS
C
C  Tables, Cluster Analysis
C
C.INPUT/OUTPUT
C
C  P1 - P3  contain input parameters
C
C.ALGORITHM
C
C . uses table interface routines
C . input table is assumed to contain entries in single precision,
C . No selection or null values
C . description of clustering algorithm in the corresponding routine
C . the output of the command consists of
C   .  9 columns with the class
C      number for each entry in  2 cluster classification, 3 cluster
C      and so on. Column labels :nCL where n=2,...,9
C   .  auxiliar descriptors
C      IORDER(9)
C      HEIGHT(9)
C      CRITVAL(9)
C      CRIT(9)
C
C.MODIFICATIONS
C
C F. Murtagh, Aug. 88 - new interface calls implemented.
C
C-----------------------------------------------------------
C
        IMPLICIT INTEGER*4      (A-Z)
        CHARACTER       INTAB*60, OUTAB*60, METHOD*4
        CHARACTER*80    LINE
        CHARACTER*16    LABEL,UNIT
        CHARACTER*6     FORM
        INTEGER*4       IORDER(9), HEIGHT(9), HVALS(9)
        REAL*4          CRITVAL(9)
C       REAL*4          AUX(9)
        LOGICAL         INULL
        INTEGER         MADRID, KUN, KNUL, DTYPE
        INCLUDE         'MID_INCLUDE:TABLES.INC/NOLIST'
        COMMON          /VMR/MADRID(1)
        INCLUDE         'MID_INCLUDE:TABLED.INC/NOLIST'
        DATA            LABEL/'2CL'/,UNIT/' '/,FORM/'I4'/
C
C ... GET INTO MIDAS
C
        CALL STSPRO('TCLUSTER')
        DTYPE = D_R4_FORMAT
C
C ... GET INPUT PARAMETERS
C
        CALL STKRDC('P1',1,1,60,IAV,INTAB,KUN,KNUL,ISTAT)
        CALL STKRDC('P2',1,1,60,IAV,OUTAB,KUN,KNUL,ISTAT)
        CALL STKRDC('P3',1,1,4,IAV,METHOD,KUN,KNUL,ISTAT)
C        CALL UPCAS(METHOD,METHOD)
C
C ... READ INPUT TABLE
C
        CALL TBTOPN(INTAB, F_I_MODE, TID1, ISTAT)
        CALL TBIGET(TID1, NCOL,NROW,NSC1,NAC,NAR,ISTAT)

        CALL CHSEL(TID1,NROW,NSEL)
        IF (NSEL.LE.0) THEN
          CALL STTPUT(' Empty table, check SELECT', ISTAT)
          GOTO 1000
        ENDIF
        IF (NSEL.NE.NROW) THEN
          WRITE(LINE,100) NSEL,NROW
          CALL STTPUT(LINE, ISTAT)
          STOP
        ENDIF
C
        LENDIS = (NROW*(NROW-1))/2
C
C ... CREATE OUTPUT TABLE
C
        NCOLOUT = NCOL + 8
        NAC = NCOLOUT
        CALL TBTINI(OUTAB, F_TRANS, 17, NAC, NROW, TID, ISTAT)
        DO I = 1, NCOL
          CALL TBFGET(TID1, I, FORM, LEN, DTYPE, ISTAT)
          IF (DTYPE.NE.D_R4_FORMAT) THEN
            CALL STTPUT(' Illegal format', ISTAT)
            CALL STTPUT(' Only R*4 column type allowed' , ISTAT)
            GOTO 1000
          ENDIF
          CALL TBCMAP(TID1,I,IADD1,ISTAT)
          CALL TBLGET(TID1, I, LABEL, ISTAT)
          CALL TBUGET(TID1, I, UNIT, ISTAT)
          CALL TBCINI(TID, DTYPE, 1 , FORM, UNIT, LABEL, I1, ISTAT)
          CALL TBCMAP(TID,I1,IADD2,ISTAT)
          CALL CPYCOL(MADRID(IADD1), MADRID(IADD2), NROW)
        ENDDO
C
C ... CREATE CLUSTER COLUMNS
C
        LABEL = 'CL2'
        UNIT  = ' '
        FORM  = 'I4'
        DO I = 2, 9
          WRITE(LABEL(3:3),150) I
          CALL TBCINI(TID, DTYPE, 1, FORM, UNIT, LABEL, I1, ISTAT)
        ENDDO
C
C ... GET ADDRESSES
C
C     DATA ARRAY ADDRESS
        CALL TDMGET(4*NCOL*NSEL,IWADD1,ISTAT)
        CALL TBIGET(TID,NNCOL,NNROW,NSC1,NNAC,NAR,ISTAT)
        CALL TBCMAP(TID, 1, IADD1, ISTAT)
        CALL MAPSM(MADRID(IADD1),MADRID(IWADD1),
     1              NAR,NSEL,NCOL)

C
C ... CHECK IF NULL VALUE
C
        NDAT = NCOL*NROW
        CALL CHECK(MADRID(IWADD1),NDAT,INULL)
        IF (INULL) THEN
          CALL STTPUT(' Null entries in the table are not allowed'
     .                     , ISTAT)
          CALL STTPUT(' Use the SELECT command ' , ISTAT)
          GOTO 1000
        ENDIF
C     CLASS ARRAY ADDRESS
        CALL TDMGET(32*NSEL,IWADD2,ISTAT)
        CALL TBCMAP(TID, NCOL+1, IADD2, ISTAT)
C        CALL MIPSM(MADRID(IADD2),MADRID(IWADD2),
C     1              NAR,NSEL,8)
C     ADDRESS OF 5 VECTORS USED AS WORK SPACE
        CALL TDMGET(4*NROW,IWORK1,ISTAT)
        CALL TDMGET(4*NROW,IWORK2,ISTAT)
        CALL TDMGET(4*NROW,IWORK3,ISTAT)
        CALL TDMGET(4*NROW,IWORK4,ISTAT)
        CALL TDMGET(4*NROW,IWORK5,ISTAT)
        CALL TDMGET(4*NROW,IWORK6,ISTAT)
        CALL TDMGET(4*NROW,IWORK7,ISTAT)
        IF (METHOD.NE.'MNVR') CALL TDMGET(4*LENDIS,IWORK8,ISTAT)
C
C ... ALGORITHM
C
        IF (METHOD.EQ.'MNVR')
     .  CALL CLUS(NROW, NCOL, MADRID(IWADD1), MADRID(IWORK1),
     .          MADRID(IWORK3), MADRID(IWORK2), MADRID(IWORK4),
     .          MADRID(IWORK2), MADRID(IWORK1), MADRID(IWORK5))
        IF (METHOD.EQ.'MVAR')
     .  CALL CLST(NROW, NCOL, LENDIS, 1, MADRID(IWADD1),
     .          MADRID(IWORK1), MADRID(IWORK3), MADRID(IWORK2),
     .          MADRID(IWORK4), MADRID(IWORK5), MADRID(IWORK6),
     .          MADRID(IWORK7), MADRID(IWORK8))
        IF (METHOD.EQ.'SLNK')
     .  CALL CLST(NROW, NCOL, LENDIS, 2, MADRID(IWADD1),
     .          MADRID(IWORK1), MADRID(IWORK3), MADRID(IWORK2),
     .          MADRID(IWORK4), MADRID(IWORK5), MADRID(IWORK6),
     .          MADRID(IWORK7), MADRID(IWORK8))
        IF (METHOD.EQ.'CLNK')
     .  CALL CLST(NROW, NCOL, LENDIS, 3, MADRID(IWADD1),
     .          MADRID(IWORK1), MADRID(IWORK3), MADRID(IWORK2),
     .          MADRID(IWORK4), MADRID(IWORK5), MADRID(IWORK6),
     .          MADRID(IWORK7), MADRID(IWORK8))
        IF (METHOD.EQ.'ALNK')
     .  CALL CLST(NROW, NCOL, LENDIS, 4, MADRID(IWADD1),
     .          MADRID(IWORK1), MADRID(IWORK3), MADRID(IWORK2),
     .          MADRID(IWORK4), MADRID(IWORK5), MADRID(IWORK6),
     .          MADRID(IWORK7), MADRID(IWORK8))
        IF (METHOD.EQ.'WLNK')
     .  CALL CLST(NROW, NCOL, LENDIS, 5, MADRID(IWADD1),
     .          MADRID(IWORK1), MADRID(IWORK3), MADRID(IWORK2),
     .          MADRID(IWORK4), MADRID(IWORK5), MADRID(IWORK6),
     .          MADRID(IWORK7), MADRID(IWORK8))
        IF (METHOD.EQ.'MEDN')
     .  CALL CLST(NROW, NCOL, LENDIS, 6, MADRID(IWADD1),
     .          MADRID(IWORK1), MADRID(IWORK3), MADRID(IWORK2),
     .          MADRID(IWORK4), MADRID(IWORK5), MADRID(IWORK6),
     .          MADRID(IWORK7), MADRID(IWORK8))
        IF (METHOD.EQ.'CNTR')
     .  CALL CLST(NROW, NCOL, LENDIS, 7, MADRID(IWADD1),
     .          MADRID(IWORK1), MADRID(IWORK3), MADRID(IWORK2),
     .          MADRID(IWORK4), MADRID(IWORK5), MADRID(IWORK6),
     .          MADRID(IWORK7), MADRID(IWORK8))
C
        CALL SEECL(NROW, MADRID(IWORK1), MADRID(IWORK3), MADRID(IWORK2),
     .          MADRID(IWADD2), HVALS, IORDER, CRITVAL, HEIGHT)
C
        CALL MIPBG(MADRID(IWADD2),MADRID(IADD2),
     .             NAR,NSEL,8)
        CALL DENDR(IORDER, HEIGHT, CRITVAL)
C
        CALL TDMFRE(4*NROW,IWORK1,ISTAT)
        CALL TDMFRE(4*NROW,IWORK2,ISTAT)
        CALL TDMFRE(4*NROW,IWORK3,ISTAT)
        CALL TDMFRE(4*NROW,IWORK4,ISTAT)
        CALL TDMFRE(4*NROW,IWORK5,ISTAT)
        CALL TDMFRE(4*NROW,IWORK6,ISTAT)
        CALL TDMFRE(4*NROW,IWORK7,ISTAT)
        CALL TDMFRE(32*NSEL,IWADD2,ISTAT)
        IF (METHOD.NE.'MNVR') CALL TDMFRE(4*LENDIS,IWORK8,ISTAT)
C
C ... CONVERT VALUES IN IADD2 FROM INTG*4 INTO REAL*4
C
        NTOT = 8*NROW
C        CALL CONVERT(MADRID(IADD2),MADRID(IADD2),NTOT)
C
C ... SAVE PARAMETERS AS DESCRIPTORS
C
C       CALL COPY(MADRID(IWORK2),AUX,NROW)
C       INDX      = INDEX(OUTAB//' ',' ') -1
C       TABLEFULL = OUTAB(1:INDX)//'.TBL'
C       CALL STDWRI(TID,'IORDER',IORDER,1,9,KUNIT,ISTAT)
C       CALL STDWRI(TID,'HEIGHT',HEIGHT,1,9,KUNIT,ISTAT)
C       CALL STDWRR(TID,'CRITVAL',CRITVAL,1,9,KUNIT,ISTAT)
C       CALL STDWRR(TID,'CRIT',AUX,1,9,KUNIT,ISTAT)
C
C ... COPY ORIGINAL ARRAY BACK INTO THE OUTPUT TABLE
C
C        CALL TBCMAP(TID1,0,IADD0,ISTAT)
C        DO I = 1, NCOL
C          CALL TBCMAP(TID1,I,IADD1,ISTAT)
C          CALL TBCMAP(TID,I,IADD2,ISTAT)
C          CALL CPYCOL(MADRID(IADD1), MADRID(IADD2), NROW)
C        ENDDO
C
C ... END
C
        CALL TBIPUT(TID,NCOLOUT,NROW,ISTAT)
        CALL TBSINI(TID,ISTAT)
        CALL TBTCLO(TID,ISTAT)
        CALL TBTCLO(TID1,ISTAT)
 1000   CONTINUE
        CALL STSEPI
 100    FORMAT(' No SELECT allowed; create new table.',I2)
 150    FORMAT(I1)
 200    FORMAT(' Selected ',I6,' rows from ',I6,' in total')
        END




C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        SUBROUTINE COPY(INPUT,AUX,NSEL)
C
C       COPY N-1 TO N-9 ELEMENTS FRON INPUT INTO AUX
C
        INTEGER  I,NSEL
        REAL*4  INPUT(NSEL),AUX(9)
C
        DO I = 1, 9
          AUX(I) = INPUT(NSEL-I)
        ENDDO
        RETURN
        END
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        SUBROUTINE CONVERT(INPUT,OUTPUT,NTOT)
C
C       CONVERT FROM INTEGER*4 TO REAL*4
C
        INTEGER I,NTOT
        REAL*4          OUTPUT(NTOT)
        INTEGER*4       INPUT(NTOT)
C
        DO I = 1, NTOT
          OUTPUT(I) = FLOAT(INPUT(I))
        ENDDO
        RETURN
        END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        SUBROUTINE CHECK(X,NDAT,INULL)
C
C       CHECK IF NULL VALUE
C
        INTEGER         I,NDAT
        REAL*4          X(NDAT), TRNULL
        INTEGER         TINULL
        DOUBLE PRECISION TDNULL
        LOGICAL         INULL
        CALL TBMNUL(TINULL,TRNULL,TDNULL)
C
        INULL = .FALSE.
        DO I = 1, NDAT
          IF(X(I).EQ.TRNULL) GOTO 10
        ENDDO
        RETURN
10      INULL = .TRUE.
        RETURN
        END
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        SUBROUTINE CPYCOL(A,B,N)   ! COPY VECT. TO VECT. / REAL ASSUMED.
        INTEGER I,N
        REAL*4  A(N), B(N)
        DO 100 I = 1, N
           B(I) = A(I)
  100   CONTINUE
        RETURN
        END

C @(#)subs1.for	19.1 (ES0-DMD) 02/25/03 13:28:48
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C  @(#)subs1.for	4.5  (ESO-IPG)  3/26/93  15:40:53
C *************  COMMON FUNCTIONS AND SUBROUTINES  **********************
C
C       Copyright (C) Andrew T. Young, 1990
C       Copyright (C) European Southern Observatory, 1992
C
C
      FUNCTION GETIME(STR,HRS,TMIN,SEC)
C
C  RETURNS TIME IN RADIANS.    AUG.1985
C
C
      IMPLICIT NONE
C
      REAL GETIME, HRS, TMIN, SEC, DEGRAD, DEG10
C
      CHARACTER STR*20, STR2*40
      DATA DEGRAD/0.017453292519943/
C
        IF(STR.NE.' ')THEN
      GETIME=DEG10(STR)*15.*DEGRAD
        ELSE
      IF(SEC.EQ.3.E33)SEC=0.
      IF(TMIN.EQ.3.E33)TMIN=0.
       IF(HRS.GT.24. .OR. TMIN.GT.60. .OR. SEC.GT.60.)THEN
      CALLTV('Time not legal')
      WRITE(STR2,5)HRS,TMIN,SEC
    5 FORMAT(' HRS =',F5.1,'  MIN =',F5.1,'  SEC =',F5.1)
      CALL TV(STR2)
      CALL STETER(900, 'BAD TIME')
       END IF
      GETIME=(HRS+(TMIN+SEC/60.)/60.)*15.*DEGRAD
        END IF
      RETURN
      END
      FUNCTION DEG10(STRING)
C
C       Copyright (C) Andrew T. Young, 1990
C
C  CONVERTS CHARACTER STRING FROM DEG MIN SEC TO DECIMAL DEGREES.
C     NOMINAL STRING FORMAT (3F3.0)            5 JAN.'87
C
C
      IMPLICIT NONE
C
      REAL DEG10, DEG, DMIN, SEC
      INTEGER L, LCOL, LDOT
C
      CHARACTER STRING*(*),LINE*20,LDUM*20
C
      LINE=STRING
C  LEFT-JUSTIFY.
      DO 1 L=1,10
      IF(LINE(L:L).NE.' ') GO TO 2
    1 CONTINUE
      DEG10=0.
      RETURN
C
    2 LDUM=LINE(L:)
C  FIND SEPARATORS.
    3 LCOL=INDEX(LDUM,':')
C
       IF(LCOL.NE.0)THEN
C   REPLACE COLONS.
      LDUM(LCOL:LCOL)=' '
      GO TO 3
       END IF
C
      LDOT=INDEX(LDUM,'.')
      L=INDEX(LDUM,' ')
        IF(LDOT.EQ.0 .OR. L.LT.LDOT)THEN
C   LINE UP.
      LINE=' '
      LINE(6-L:)=LDUM
      IF(LDOT.NE.0) LDOT=LDOT+5-L
C   DEGREES ARE IN COL.1-4.
C
       IF(LDOT.EQ.11 .OR. (LDOT.EQ.0 .AND. LINE(5:5).EQ.' '))THEN
C    DECIMAL SECONDS.
      READ(LINE,'(F4.0,F3.0,BZ,F6.3)',ERR=99) DEG,DMIN,SEC
       ELSE IF(LDOT.EQ.8)THEN
C    MINUTES AND TENTHS.
      READ(LINE,'(F4.0,F5.1)',ERR=99) DEG,DMIN
      SEC=0.
       ELSE
      GO TO 99
       END IF
C
        ELSE
C    DECIMAL DEGREES.
      READ(LDUM,'(F11.8)',ERR=99) DEG10
      RETURN
        END IF
C
      DEG10=ABS(DEG)+((SEC/60.+DMIN)/60.)
      IF(SEC.GT.60. .OR. DMIN.GT.60.) GO TO 98
      IF(INDEX(LDUM,'-').NE.0) DEG10=-DEG10
      RETURN
C
C
   98 CALL TV('More than 60 min.or sec.')
   99 CALL TV('BADLY FORMATTED DATA:')
      CALL TV(LINE)
      DEG10=3.E33
      RETURN
      END
      FUNCTION DEG2MS(DEG)
C
C       Copyright (C) Andrew T. Young, 1990
C
C  CONVERT DECIMAL DEG TO DEG/MIN/SEC STRING.     4 JAN.87
C
C
      IMPLICIT NONE
C
      REAL DEG, FMIN, SEC
      INTEGER LDEG, MIN, LSEC, LT
C
      CHARACTER*13 DEG2MS,B13
C
      LDEG=DEG
C   USE TRUNCATED DEG.
      FMIN=ABS(DEG-(LDEG))*60.
      MIN=FMIN
C   USE TRUNCATED MINUTE.
      SEC=(FMIN-(MIN))*60.
      LSEC=SEC
C   ROUND.
      LT=(SEC-LSEC)*10.+.5
      IF(LT.LT.10) GO TO 10
      LT=0
      LSEC=LSEC+1
      IF(LSEC.LT.60)GO TO 10
      LSEC=0
      MIN=MIN+1
      IF(MIN.LT.60)GO TO 10
      MIN=0
      LDEG=LDEG+SIGN(1.,DEG)
   10 WRITE(B13,'(3I3.2,''.'',I1)')LDEG,MIN,LSEC,LT
C    ASSUME NO NEGATIVE VALUES LARGER THAN 99.
      IF(LDEG.EQ.0 .AND. DEG.LT.0.) B13(:1)='-'
        DEG2MS=B13
      RETURN
      END
      FUNCTION MON2M(MON)
C
C       Copyright (C) Andrew T. Young, 1990
C       Copyright (C) European Southern Observatory, 1992
C
C  CONVERTS 1ST 3 LETTERS OF MONTH TO INTEGER.
C   RETURNS 0 IF NAME NOT RECOGNISED.
C
C
      IMPLICIT NONE
C
      INTEGER MON2M, M
C
      CHARACTER*3 MON, MONTHS(12), LMON(12)
      CHARACTER*20 EMSG
C
      DATA MONTHS/'JAN','FEB','MAR','APR','MAY','JUN','JUL',
     1 'AUG','SEP','OCT','NOV','DEC'/
      DATA LMON/'Jan','Feb','Mar','Apr','May','Jun','Jul',
     1 'Aug','Sep','Oct','Nov','Dec'/
C
      DO 403 M=1,12
      IF(MON.EQ.MONTHS(M))GO TO 405
  403 CONTINUE
c	Try lower-case if not found:
      DO 404 M=1,12
      IF(MON.EQ.LMON(M))GO TO 405
  404 CONTINUE
c	Complain if not found:
      EMSG='Incorrect month:'//MON
      CALL TV(EMSG)
      M=0
  405 MON2M=M
      RETURN
      END
      FUNCTION M2MON(M)
C
C       Copyright (C) Andrew T. Young, 1990
C
C  CONVERT INTEGER TO MON(TH NAME).
C
C
      IMPLICIT NONE
C
      INTEGER M
C
      CHARACTER*3 MONTHS(12), M2MON
C
      DATA MONTHS/'JAN','FEB','MAR','APR','MAY','JUN','JUL',
     1 'AUG','SEP','OCT','NOV','DEC'/
C
      M2MON=MONTHS(M)
      RETURN
      END
      SUBROUTINE DECOLR(COLORS,CNAMES,BANDS,SYSTEM,CANNED)
C
C       Copyright (C) Andrew T. Young, 1990
C       Copyright (C) European Southern Observatory, 1992
C
C  SETS UP COLOR MATRICES, ETC.      31 JAN. 1987
C
C
C	Deduces relation between bands and indices from color names CNAMES
C	and band names BANDS, and stores this matrix in COLORM.  Copies this
C	to COLORS (used as scratch space), and forms inverse in COLRIN.
C
C
      IMPLICIT NONE
C
      REAL COLORS, COLORM, COLRIN, XINV, YINV, DUM, BIG, PMULT
      INTEGER NBANDS, LENB, LENC, KX, KY, MAGS, K, J, N, MINUS, NB, L, 
     1         LWORD, I, IP1, NBGRW, NCOLB, NROW, NXS, KK
C
      INCLUDE 'MID_REL_INCL:mbands.inc'
C     PARAMETER (MBANDS=9)
      COMMON /CMAGS1/ COLORM(MBANDS,MBANDS),COLRIN(MBANDS,MBANDS),
     1 XINV,YINV,NBANDS,LENB,LENC,KX,KY
      SAVE /CMAGS1/
C
      INCLUDE 'MID_REL_INCL:mstars.inc'
C     PARAMETER (MSTARS=1650)
      CHARACTER *8 BANDS(3*MBANDS), CNAMES(2,MBANDS), SYSTEM*6, A*1
      CHARACTER *80 PAGE(MBANDS)
      DIMENSION COLORS(MBANDS,MSTARS)
      LOGICAL CANNED
C
      MAGS=0
C
      DO 4 K=1,NBANDS
      DO 1 J=1,NBANDS
      COLRIN(J,K)=0.
    1 COLORM(J,K)=0.
      COLRIN(K,K)=1.
      N=0
      MINUS=INDEX(CNAMES(1,K),'-')
C
       IF(MINUS.NE.0)THEN
C   COLOR INDEX.
C
      DO 2 NB=1,NBANDS
      L=LWORD(BANDS(NB))
      J=INDEX(CNAMES(1,K),BANDS(NB)(:L))
       IF(J.NE.0)THEN
C
        IF(J.LT.MINUS .AND. L.EQ.MINUS-J)THEN
      COLORM(NB,K)=1.
      N=N+1
        ELSE IF(J.GT.MINUS .AND. BANDS(NB).EQ.CNAMES(1,K)(MINUS+1:))THEN
      COLORM(NB,K)=-1.
      N=N+1
        END IF
C
       END IF
    2 CONTINUE
      IF(N.NE.2) MAGS=5
C
       ELSE
C   MAGNITUDE.
C
      DO 3 NB=1,NBANDS
      IF(CNAMES(1,K).EQ.BANDS(NB) .OR. CNAMES(1,K)(2:).EQ.BANDS(NB))
     1 COLORM(NB,K)=1.
    3 CONTINUE
      MAGS=MAGS+1
C
       END IF
    4 CONTINUE
C
C   SPECIALS for uvby, etc.
       IF(SYSTEM(:4).EQ.'UVBY')THEN
C    MAG.IS Y, NOT V.
         COLORM(2,1)=0.
         COLORM(4,1)=1.
C    M1 IN ROW 3, C1 IN 4.
         COLORM(2,3)=1.
         COLORM(3,3)=-2.
         COLORM(4,3)=1.
         COLORM(1,4)=1.
         COLORM(2,4)=-2.
         COLORM(3,4)=1.
       END IF
C   FIX H-BETAS.
       IF(SYSTEM.EQ.'UVBYHB')THEN
         COLORM(5,5)=-1.
         COLORM(6,5)=1.
         COLORM(5,6)=1.
       ELSE IF(SYSTEM.EQ.'H-BETA') THEN
         COLORM(1,1)=-1.
         COLORM(2,1)=1.
         COLORM(1,2)=1.
C   FIX GENEVA (VM = V).
       ELSE IF(SYSTEM.EQ.'GENEVA') THEN
         COLORM(3,1)=1.
       END IF
      IF(CANNED) MAGS=1
C   Detect problems.
    5 IF(.NOT.CANNED .OR. MAGS.GT.1)THEN
    6   CALL TV('Please check this transformation matrix:')
        WRITE(PAGE,7)(BANDS(I),I=1,NBANDS)
    7   FORMAT(/17X,9A7)
        DO 10 I=1,(NBANDS+17)/9
   10     CALL TVN(PAGE(I))
        DO 20 I=1,NBANDS
        DO 20 N=1,NBANDS,9
          WRITE(PAGE,15)I,CNAMES(1,I),(COLORM(J,I),J=N,MIN(NBANDS,N+8))
   15     FORMAT(/I2,2X,A6,' = ',9F7.1/(12X,9F7.1))
          DO 18 J=1,(NBANDS+17)/9
   18       CALL TVN(PAGE(J))
   20   CONTINUE
        CALL ASK('OK?',A)
        IF(A.EQ.'N')THEN
          CALLQF('Which ROW (number) is wrong?',DUM)
          N=DUM
   25     CALL ASK('Enter correct values for entire row.',PAGE(1))
          READ(PAGE(1),*,ERR=25) (COLORM(I,N),I=1,NBANDS)
          GO TO 6
        END IF
      END IF
C
C  COPY & INVERT MATRIX.
      DO 160 J=1,NBANDS
      DO 160 I=1,NBANDS
  160 COLORS(I,J)=COLORM(I,J)
C   START SYSTEM REDUCTION.
      DO 166 I=1,NBANDS-1
C   FIND COLUMN PIVOT, IN ROW NBGRW.
      IP1=I+1
      BIG=COLORS(I,I)
      NBGRW=I
      DO 161 J=IP1,NBANDS
      IF(ABS(BIG).GE.ABS(COLORS(I,J))) GO TO 161
      BIG=COLORS(I,J)
      NBGRW=J
  161 CONTINUE
      IF(BIG.EQ.0.)THEN
      CALL TV('MATRIX is SINGULAR')
      MAGS=5
      GO TO 5
      END IF
C    SWAP ROW I WITH ROW NBGRW UNLESS I=NBGRW.
      IF(NBGRW.NE.I)THEN
      DO 162 J=I,NBANDS
      DUM=COLORS(J,NBGRW)
      COLORS(J,NBGRW)=COLORS(J,I)
  162 COLORS(J,I)=DUM
      DO 163 J=1,NBANDS
      DUM=COLRIN(J,NBGRW)
      COLRIN(J,NBGRW)=COLRIN(J,I)
  163 COLRIN(J,I)=DUM
      END IF
C   ELIMINATE UNKNOWNS FROM FIRST COLUMN.
      DO 166 K=IP1,NBANDS
      PMULT=-COLORS(I,K)/BIG
      DO 164 J=IP1,NBANDS
  164 COLORS(J,K)=PMULT*COLORS(J,I)+COLORS(J,K)
      DO 165 L=1,NBANDS
  165 COLRIN(L,K)=PMULT*COLRIN(L,I)+COLRIN(L,K)
  166 CONTINUE
      IF(COLORS(NBANDS,NBANDS).EQ.0.)THEN
      CALL TV('MATRIX is SINGULAR')
      MAGS=5
      GO TO 5
      END IF
C   BACK SUBSTITUTION.
      DO 169 NCOLB=1,NBANDS
      DO 169 I=1,NBANDS
      NROW=NBANDS+1-I
      DUM=0.0
C    NUMBER OF PREVIOUSLY COMPUTED UNKNOWNS = NXS
      NXS=NBANDS-NROW
      IF(NXS.NE.0)THEN
      DO 168 K=1,NXS
      KK=NBANDS+1-K
  168 DUM=DUM+COLRIN(NCOLB,KK)*COLORS(KK,NROW)
      END IF
      DUM=COLRIN(NCOLB,NROW)-DUM
      COLRIN(NCOLB,NROW)=DUM/COLORS(NROW,NROW)
  169 CONTINUE
C
       IF(.NOT.CANNED .OR. MAGS.GT.1)THEN
      CALL TV('Inverse matrix:')
      WRITE(PAGE,7)(CNAMES(1,I),I=1,NBANDS)
      DO 170 I=1,(NBANDS+17)/18
  170 CALL TVN(PAGE(I))
      DO 180 I=1,NBANDS
  180 WRITE(PAGE,15)I,BANDS(I),(COLRIN(J,I),J=1,NBANDS)
      DO 200 I=1,(NBANDS+17)/9
  200 CALL TVN(PAGE(I))
       END IF
C
      RETURN
      END
      SUBROUTINE EXCEED(N,LABEL,M)
C
C       Copyright (C) Andrew T. Young, 1990
C       Copyright (C) European Southern Observatory, 1992
C
C                                     16 MAR.1987
C
      IMPLICIT NONE
C
      INTEGER M, N
C
      CHARACTER*6 LABEL
      CHARACTER*46 LINE(5)
C
      WRITE(LINE,2)N,LABEL,M
    2 FORMAT(I5,' EXCEEDS PARAMETER (',A6,'=',I3,').'/
     1 /' INCREASE PARAMETER AND RECOMPILE.'//' (FATAL ERROR)')
      CALL TV(LINE(1))
      CALL TVN(LINE(2))
      CALL TVN(LINE(3))
      CALL TVN(LINE(4))
      CALL TVN(LINE(5))
      RETURN
      END
      SUBROUTINE MDY(CARD,MONTH,DAY,YEAR)
C
C       Copyright (C) Andrew T. Young, 1990
C
C  EXTRACTS 3-CHAR.MONTH, FLOATING DAY & YEAR FROM STRING CARD.   3 JAN.87
C
C
      IMPLICIT NONE
C
      REAL DAY, YEAR
      INTEGER I, NEXT, LAST, I1, J
C
      CHARACTER CARD*80, MONTH*3, FIELD*5, CHAR
C
    1 FORMAT(A4)
C    SET ILLEGAL VALUES TO FLAG ERROR RETURNS.
      MONTH='XXX'
      DAY=99.
      YEAR=0.
      DO 2 I=1,80
      IF(CARD(I:I).NE.' ') GO TO 5
    2 CONTINUE
      RETURN
C
    4 FORMAT(BN,F4.0)
C
C  FIRST NON-BLANK...
    5 ASSIGN 25 TO NEXT
      ASSIGN 21 TO LAST
      IF(CARD(I:I).GT.'9' .OR. CARD(I:I).LT.'0') GO TO 14
C   FIRST FIELD NUMERIC, SO MONTH SECOND.
      I1=I
      DO 6 I=I,80
      CHAR=CARD(I:I)
      IF(CHAR.GT.'9' .OR. CHAR.LT.'0') GO TO 10
    6 CONTINUE
      RETURN
C
C   FIRST FIELD ENDS AT (I-1), I NON-NUM.
   10 WRITE(FIELD,1) CARD(I1:I-1)
      IF(I-I1-3) 11,24,20
C    1ST FIELD IS DAY.
   11 READ(FIELD,4)DAY
      ASSIGN 18 TO LAST
C     MONTH STARTS W.LETTER.
   12 DO 13 I=I,80
      CHAR=CARD(I:I)
      IF(CHAR.GE.'A' .AND. CHAR.LE.'Z') GO TO 14
   13 CONTINUE
      RETURN
C
C      GET MONTH.
   14 MONTH=CARD(I:I+2)
      I=I+3
C     FIND LAST NUMERIC FIELD.
   15 DO 16 I=I,80
      CHAR=CARD(I:I)
      IF(CHAR.GE.'0' .AND. CHAR.LE.'9') GO TO LAST,(18,21)
   16 CONTINUE
      RETURN
C    YEAR LAST.
   18 J=I+3
      IF(CARD(I+2:J).EQ.'  ')J=I+1
      WRITE(FIELD,1) CARD(I:J)
      READ(FIELD,4,ERR=19)YEAR
   19 RETURN
C
C    YEAR FIRST.
   20 READ(FIELD,4,ERR=24)YEAR
      ASSIGN 24 TO NEXT
      GO TO 12
C     (TO DO MONTH.)
C
C    DAY LAST. ENDS AT NON-NUM.I1.
   21 DO 22 I1=I+1,80
      CHAR=CARD(I1:I1)
      IF(CHAR.GT.'9' .OR. CHAR.LT.'0') GO TO 23
   22 CONTINUE
      RETURN
C
   23 WRITE(FIELD,1) CARD(I:I1-1)
      READ(FIELD,4,ERR=24) DAY
c	fudged to fool stupid MIDAS pre-processor:
      IF(.TRUE.)GO TO NEXT,(24,25)
   24 RETURN
C
C     SKIP 2ND PART OF DOUBLE DATE.
   25 I=I1+1
      ASSIGN 18 TO LAST
      IF(CARD(I1:I1).NE.'/' .AND. CARD(I1:I1).NE.'-') GO TO 15
C     DOUBLE DATE.  SKIP TO SEPARATOR.
      I=INDEX(CARD(I1:I1+3),',')
      IF(I.EQ.0) I=INDEX(CARD(I1:I1+3),' ')
      IF(I.EQ.0) GO TO 24
      I=I+I1
      GO TO 15
      END
      SUBROUTINE GETJD(DJ)
C
C       Copyright (C) Andrew T. Young, 1990
C
C  GETS DP JULIAN DAY FROM DATSTR, in common block /NAMES/.
C  Note: DJ is double precision.
C
C
      IMPLICIT NONE
C
      REAL RAHRS, RAMIN, RASEC, DEDEG, DEMIN, DESEC, EPOCH, SIGNAL,TINT, 
     1     CVARS, FMM, DD, YY, YEAR, DAY, UTHRS, UTMIN, UTSEC, CLKERR, 
     2     STHRS, STMIN, STSEC, ZTHRS, ZTMIN, ZTSEC, VSPARE, RAS, DECS, 
     3     EPOCHS, COLORS, DDAY, Y
      INTEGER NAM1, NAM2, NGRPS, MURAT, MURAA, MUDEC
      INTEGER M, MON2M, NSTAR, N, K
C
      DOUBLE PRECISION DJ
C
      INCLUDE 'MID_REL_INCL:mbands.inc'
C     PARAMETER (MBANDS=9)
C
C  Declare integer parameters for stupid compilers:
C
      INTEGER MGAINS,MG2,MA,MCAT,MN,MV,MGRPS,MAREST,MNREST
      PARAMETER (MGAINS=4, MG2=2*MGAINS)
      PARAMETER (MA=21+MG2+5)
      PARAMETER (MCAT=12+2*MBANDS,MN=MCAT+30, MV=MA+MN, MGRPS=8)
      PARAMETER (MAREST=MA-21-MG2, MNREST=MN-MCAT-15)
C
      CHARACTER NAMES(MV)*6,TITLE*80
      CHARACTER*32 STAR
      CHARACTER*20 RASTR,DESTR,BAYER,CONSTL,FLAMST,BSHR,HD,DM,
     1 SPECT,DESGN,DATSTR,MONTH,REM1,REM2,STSTR,ZTSTR,UTSTR,
     2 FILTCD,STARCD,STRSKY,ASPARE(MAREST),GANCDN(MGAINS),DIMCDN(MGAINS)
C
C     COMMON /NAMES/NAMES,TITLE, AVAR
      COMMON /NAMES/NAMES,TITLE, RASTR,DESTR,STAR,BAYER,CONSTL,FLAMST,
     1 BSHR,HD,DM,SPECT,DESGN,DATSTR,MONTH,REM1,REM2,STSTR,ZTSTR,UTSTR,
     2 FILTCD,STARCD,STRSKY,ASPARE,GANCDN,DIMCDN
C
      COMMON /VALUES/ NAM1(MGRPS),NAM2(MGRPS),NGRPS,RAHRS,RAMIN,RASEC,
     1 DEDEG,DEMIN,DESEC,EPOCH,MURAT,MURAA,MUDEC,SIGNAL,TINT,
     2 CVARS(2,MBANDS),FMM,DD,YY,YEAR,DAY,
     3 UTHRS,UTMIN,UTSEC,CLKERR,STHRS,STMIN,STSEC,
     4 ZTHRS,ZTMIN,ZTSEC,VSPARE(MNREST)
C
      CHARACTER MON*3
C
      INCLUDE 'MID_REL_INCL:mstars.inc'
C     PARAMETER (MSTARS=1650)
C       commons for star catalog:
      CHARACTER *32 STARS
      COMMON /SCATA/ STARS(MSTARS)
      COMMON /SCAT/ RAS(MSTARS), DECS(MSTARS), EPOCHS(MSTARS), COLORS
      DIMENSION COLORS(MBANDS,MSTARS)
C          MONTH, DAY, YEAR, MM, DD, YY   ARE EXTERNAL NAMES.
C
C    MONTH IS NAME OF MONTH,  MON IS 1ST 3 LETTERS,  MM & M ARE NUMBER.
C    YEAR IS FULL YEAR,  YY IS LAST 2 DIGITS,  Y IS INTERNAL.
C
       IF(DATSTR.NE.' ' .OR. MONTH.NE.' ')THEN
        IF(DATSTR.NE.' ')THEN
      CALL MDY(DATSTR,MON,DDAY,Y)
        ELSE
      MON=MONTH
      DDAY=DAY
      Y=YEAR
        END IF
C   CONVERT MON TO INTEGER:
      M=MON2M(MON)
      IF(M.EQ.0) CALL STETER(901, 'BAD MONTH IN DATA')
       ELSE IF(FMM.NE.3.E33 .AND. DD.NE.3.E33 .AND. YY.NE.3.E33)THEN
      DDAY=DD
      M=FMM
      Y=YY+1900.
       ELSE
      CALL TV('NO DATE. FATAL ERROR.')
      CALL STETER(902, 'NO DATE')
       END IF
C    CHECK YEAR.
      IF(Y.LT.100.)Y=Y+1900.
C  J.D.: SEE SKY & TEL.61,312 (1981).
      IF(M.GT.2)GO TO 416
      M=M+12
      Y=Y-1
  416 DJ=AINT(365.25*Y) + AINT(30.6001*(M+1)) + DDAY + 1720981.5D0
C
      RETURN
C
C
      ENTRY GETSN(NSTAR)
C
C  GETS STAR NAME FROM HEADED FILE VIA /NAMES/.   10 MAR.'85
C
      IF(STAR.NE.' ')THEN
       STARS(NSTAR)=STAR
C   HD.
      ELSE IF (HD.NE.' ') THEN
       CALL CATHED(HD,'HD ')
       STARS(NSTAR)=HD
C   BD OR OTHER DM.
      ELSE IF (DM.NE.' ') THEN
       STARS(NSTAR)=DM
C   HR.
      ELSE IF (BSHR.NE.' ') THEN
       CALL CATHED(BSHR,'HR ')
       STARS(NSTAR)=BSHR
C   BAYER/FLAMSTEED.
      ELSE IF (BAYER.NE.' ') THEN
       N=INDEX(BAYER,'  ')
       STARS(NSTAR)=BAYER(:N)//CONSTL
C    FLAMSTEED.
       IF(FLAMST.NE.' ')THEN
        N=INDEX(FLAMST,'   ')
        FLAMST(N+1:)=STARS(NSTAR)
        STARS(NSTAR)=FLAMST
       END IF
C   FLAMSTEED ALONE.
      ELSE
       IF(FLAMST.NE.' ') THEN
        N=INDEX(FLAMST,'   ')
        STARS(NSTAR)=FLAMST(:N)//CONSTL
       ELSE
C   NO NAME AT ALL.
        STARS(NSTAR)='ANON.'
      WRITE(STARS(NSTAR)(6:),'(I4)')NSTAR
       END IF
      END IF
C  ADD SECOND NAME IF SPACE.
      N=INDEX(STARS(NSTAR),'        ')
       IF(N.NE.0)THEN
      IF(BAYER.NE.' ')THEN
       K=INDEX(BAYER,'   ')
       STARS(NSTAR)(N+2:)=BAYER(:MIN(K,16-N))//CONSTL
      ELSE IF(FLAMST.NE.' ')THEN
       K=INDEX(FLAMST,'    ')
       STARS(NSTAR)(N+2:)=FLAMST(:MIN(K,16-N))//CONSTL
      ELSE IF(HD.NE.' ' .AND. BSHR.NE.' ')THEN
       CALL CATHED(BSHR,'HR ')
       STARS(NSTAR)(N+2:)=BSHR
      ELSE IF(HD.NE.' ' .AND. DM.NE.' ')THEN
       STARS(NSTAR)(N+2:)=DM
      END IF
       END IF
C
      RETURN
C
      END
      SUBROUTINE JD2DAT(DJ,DATSTR)
C
C       Copyright (C) Andrew T. Young, 1990
C
C  CONVERTS JD (IN DJ) TO DATE-STRING IN STD.FORMAT.   15 FEB.'85
C  Note: argument DJ is real, *NOT* double-precision!
C
C
      IMPLICIT NONE
C
      REAL DJ, Z, A, B, C, FK, E, D, Y
      INTEGER K,M
C
      CHARACTER DATSTR*(*),M2MON*3,A11*11
C
      EXTERNAL M2MON
C
C  SEE SKY & TEL.61, 312 (1981).
C
C     ASSUME 0 H U.T.; ROUND TO INTEGER DAY.
      Z=AINT(DJ+0.6)
      A=AINT((Z-1867216.25D0)/36524.25D0)
      B=Z+A-AINT(A/4.)+1525.
      C=AINT((B-122.1)/365.25)
      K=365.25*C
      FK=K
      E=AINT((B-FK)/30.6001)
      D=B-FK-AINT(30.6001*E)
      IF(E.LT.13.5)THEN
        M=E-1.
      ELSE
        M=E-13.
      END IF
      IF(M.GE.3)THEN
        Y=C-4716.
      ELSE
        Y=C-4715.
      END IF
C  FORMAT STRING.
      WRITE(A11,7)M2MON(M),INT(D),INT(Y)
    7 FORMAT(A3,I3,I5)
      DATSTR=A11
      RETURN
      END
      SUBROUTINE EPHEM(I1,DJMOD,COLORS,RA,DEC)
C
C       Copyright (C) Andrew T. Young, 1990
C
C  INTERPOLATES EPHEMERIS OBJECTS TO DJMOD.      15 AUG.'85
C
C
      IMPLICIT NONE
C
      REAL DJMOD, COLORS, RA, DEC, RECT, DIF, DEN, F
      INTEGER I1, I2, I, MID, J
C
C  RECT.COORDS.IN COLORS(MBM1...MBM3,I).
C
      INCLUDE 'MID_REL_INCL:mbands.inc'
C     PARAMETER (MBANDS=9)
      INTEGER MBM1,MBM2,MBM3,MBM4
      PARAMETER(MBM1=MBANDS-1,MBM2=MBANDS-2,MBM3=MBANDS-3,MBM4=MBANDS-4)
      INCLUDE 'MID_REL_INCL:mstars.inc'
C     PARAMETER (MSTARS=1650)
      DIMENSION COLORS(MBANDS,MSTARS), RECT(3)
      CHARACTER A, DATSTR*11, EMSG*38
C
C   FIND END OF TABLE.
      I2=COLORS(MBM4,I1)
      DIF=3.E33
      DO 10 I=I1,I2
       IF(ABS(COLORS(MBANDS,I)-DJMOD).LT.DIF)THEN
      DIF=ABS(COLORS(MBANDS,I)-DJMOD)
      MID=I
       ELSE
      GO TO 20
       END IF
   10 CONTINUE
      IF(DJMOD.GT.COLORS(MBANDS,I2))CALL TV('Extrapolation required.')
C    ASSUME TIMES INCREASE.
   20 IF(MID.GE.I2) MID=I2-1
      DEN=COLORS(MBANDS,MID+1)-COLORS(MBANDS,MID)
       IF(DEN.EQ.0.)THEN
      CALL TV('Duplicated dates in table.  Interpolation impossible.')
      CALL ASK('Do you want to continue?',A)
      IF(A.EQ.'N')CALL STETER(903, 'BAD TABLE')
      RECT(1)=COLORS(MBM1,MID)
      RECT(2)=COLORS(MBM2,MID)
      RECT(3)=COLORS(MBM3,MID)
      GO TO 90
       END IF
C    START AT I1+1 FOR 3-POINT FORM.
      IF(I2.GT.I1+1 .AND. MID.EQ.I1)MID=I1+1
C
C    GET WEIGHTS.
      F=(DJMOD-COLORS(MBANDS,MID))/DEN
      IF(F.LT.-2.) GO TO 99
       IF(F.GT.2.)THEN
      CALLTV('*** FATAL ERROR')
      CALL JD2DAT(DJMOD+2400001.,DATSTR)
      EMSG='Please extend tables to '//DATSTR
      CALL TV(EMSG)
      GO TO 999
       END IF
C
C   DETERMINE ORDER.
C
       IF(I2.EQ.I1+1)THEN
C
C   LINEAR INTERPOLATION.
      IF(MID.EQ.I1 .AND. F.LT.0.) CALL TV('Extrapolate backward.')
      DO 25 J=1,3
   25 RECT(J)=(1.-F)*COLORS(MBANDS-J,MID) + F*COLORS(MBANDS-J,MID+1)
C
       ELSE
C
C   QUADRATIC (3-POINT).
C
      IF(MID.EQ.I1+1 .AND. F.LT.-1.)CALL TV('Extrapolate backward.')
      DO 30 J=1,3
   30 RECT(J)=((F-1.)*COLORS(MBANDS-J,MID-1) + (F+1.)*COLORS(MBANDS-J,
     1      MID+1))*F/2. -(F+1.)*(F-1.)*COLORS(MBANDS-J,MID)
       END IF
C
   90 RA=ATAN2(RECT(2),RECT(1))
      DEC=ATAN2(RECT(3),SQRT(RECT(1)*RECT(1)+RECT(2)*RECT(2)))
      RETURN
C
   99 CALL JD2DAT(DJMOD+2399999.,DATSTR)
      EMSG='Please begin tables at '//DATSTR
      CALL TV(EMSG)
      CALLTV('*** FIRST DATE PRECEDES EPHEMERIS -- FATAL ERROR')
  999 CALL STETER(905, 'INADEQUATE EPHEMERIS')
      END

C @(#)ca.for	19.1 (ES0-DMD) 02/25/03 13:27:13
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                            C
C  Carry out a CORRESPONDENCE ANALYSIS.                                      C
C                                                                            C
C                                                                            C
C  To call:   CALL CA(N,M,DATA,IPRINT,A1,W1,W2,A2,R,C,IERR)    where         C
C                                                                            C
C                                                                            C
C  N, M  : integer dimensions of ...                                         C
C  DATA  : input data.                                                       C
C          On output, DATA contains in first 7 columns the projections of    C
C          the row-points on the first 7 factors.                            C
C  IPRINT: print options.                                                    C
C          = 1: no printed output - arrays/vectors, only, contain items      C
C              calculated.                                                   C
C          = 2: printed output, in addition, of eigenvalues and eigenvectors.C
C          = 3: full printing of items calculated.                           C
C  A1    : matrix to be diagonalized, of dimensions M * M.                   C
C          On output, A1 contains in the first 7 columns the projections of  C
C          the column-points on the first 7 factors.                         C
C  W1,W2 : real vectors of dimension M (see called routines for use).        C
C          On output, W1 contains the eigenvalues (in increasing order of    C
C          magnitude).                                                       C
C  A2    : real array of dimensions M * M (see called routines for use).     C
C  R, C  : vectors of length N and M (respectively) containing, on output,   C
C          the masses of the row and column points.                          C
C  IERR  : error indicator (normally zero).                                  C
C                                                                            C
C                                                                            C
C  Inputs here are N, M, DATA, METHOD, IPRINT (and IERR).                    C
C  Output information is contained in DATA, A1, W1, R and C.                 C
C  All printed outputting is carried out in easily recognizable subroutines  C
C  called from the first subroutine which follows.                           C
C                                                                            C
C  Note the presence of the trivial first eigenvalue, and accompanying       C
C  eigenvector (all values 1, ignoring the sign).                            C
C                                                                            C
C  Errors: IERR = 1, no convergence in eigenextraction routine; IERR = 2,    C
C  values of a row or a column (hence, mass of the row or column) are all    C
C  zero.
C                                                                            C
C                                                                            C
C  F. Murtagh, ST-ECF/ESA/ESO, Garching-bei-Muenchen, January 1986.          C
C                                                                            C
C----------------------------------------------------------------------------C
        SUBROUTINE CA(N,M,DATA,IPRINT,A,W,FV1,Z,R,C,IERR)
        REAL    DATA(N,M), A(M,M), W(M), FV1(M), Z(M,M), R(N), C(M)
        REAL    TOT
        INTEGER N,M,IPRINT,IERR,I,J,J1,J2,M2
C
C          Form row sums and total
C
        TOT = 0.0
        DO 200 I = 1, N
           R(I) = 0.0
           DO 100 J = 1, M
              TOT = TOT + DATA(I,J)
              R(I) = R(I) + DATA(I,J)
  100      CONTINUE
  200   CONTINUE
C
C          Form column sums and then means
C
        DO 400 J = 1, M
           C(J) = 0.0
           DO 300 I = 1, N
              C(J) = C(J) + DATA(I,J)
  300      CONTINUE
           IF (C(J).GT.0.0) GOTO 350
C             WRITE (6,*) ' ALL VALUES IN COL.',J,' ARE 0: PLS. REMOVE'
              IERR = 2
              RETURN
  350      CONTINUE
           C(J) = C(J)/TOT
  400   CONTINUE
C
C          Form row means and make data into frequencies
C
        DO 600 I = 1, N
           IF (R(I).GT.0.0) GOTO 450
C             WRITE (6,*) ' ALL VALUES IN ROW',I,' ARE 0: PLS. REMOVE'
              IERR = 2
              RETURN
  450      CONTINUE
           R(I) = R(I)/TOT
           DO 500 J = 1, M
              DATA(I,J) = DATA(I,J)/TOT
  500      CONTINUE
  600   CONTINUE
C
C          Form matrix to be diagonalized
C
        DO 900 J1 = 1, M
           DO 800 J2 = 1, M
              A(J1,J2) = 0.0
              DO 700 I = 1, N
                 A(J1,J2) = A(J1,J2) + DATA(I,J1)*DATA(I,J2)/
     X                                (R(I)*SQRT(C(J1)*C(J2)))
  700         CONTINUE
  800      CONTINUE
  900   CONTINUE
C
C          Carry out eigenreduction.
C
        M2 = M
        CALL TRED2C(M,M2,A,W,FV1,Z)
        CALL TQL2C(M,M2,W,FV1,Z,IERR)
        IF (IERR.NE.0) GOTO 9000
C
C          Output eigenvalues and eigenvectors.
C
        IF (IPRINT.GT.1) CALL OUTVC(M,W)
C
C          Determine factors from the eigenvectors of the symmetric
C          matrix which has been diagonalozed.
C
        DO 1100 J1 = 1, M
           DO 1000 J2 = 1, M
              Z(J1,J2) = Z(J1,J2)/SQRT(C(J1))
 1000      CONTINUE
 1100   CONTINUE
C
        IF (IPRINT.GT.1) CALL OUTVC(M,Z)
C
C          Determine projections and contributions and output them.
C
        CALL PROJXC(N,M,DATA,Z,FV1,R)
        IF (IPRINT.EQ.3) CALL OUTPXC(N,M,DATA)
        CALL PROJYC(M,W,A,Z,FV1,C)
        IF (IPRINT.EQ.3) CALL OUTPYC(M,A)
        IF (IPRINT.EQ.3) CALL OUTCTX(N,M,DATA,R)
        IF (IPRINT.EQ.3) CALL OUTCTY(M,A,C)
C
 9000   RETURN
        END
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                            C
C Reduce a real, symmetric matrix to a symmetric, tridiagonal                C
C matrix.                                                                    C
C                                                                            C
C To call:    CALL TRED2(NM,N,A,D,E,Z)    where                              C
C                                                                            C
C NM = row dimension of A and Z;                                             C
C N = order of matrix A (will always be <= NM);                              C
C A = symmetric matrix of order N to be reduced to tridiagonal form;         C
C D = vector of dim. N containing, on output, diagonal elts. of trid. matrix;C
C E = working vector of dim. at least N-1 to contain subdiagonal elts.;      C
C Z = matrix of dims. NM by N containing, on output, orthogonal              C
C                    transformation matrix producting the reduction.         C
C                                                                            C
C Normally a call to TQL2 will follow the call to TRED2 in order to          C
C produce all eigenvectors and eigenvalues of matrix A.                      C
C                                                                            C
C Algorithm used: Martin et al., Num. Math. 11, 181-195, 1968.               C
C                                                                            C
C Reference: Smith et al., Matrix Eigensystem Routines - EISPACK             C
C Guide, Lecture Notes in Computer Science 6, Springer-Verlag, 1976,         C
C pp. 489-494.                                                               C
C                                                                            C
C F. Murtagh, ST-ECF/ESA/ESO, Garching-bei-Muenchen, January 1986.           C
C                                                                            C
C----------------------------------------------------------------------------C
        SUBROUTINE TRED2C(NM,N,A,D,E,Z)
C
        REAL A(NM,N),D(N),E(N),Z(NM,N)
        REAL SCALE,H,F,G,HH
        INTEGER NM,N,I,J,II,L,K,JP1
C
        DO 100 I = 1, N
           DO 100 J = 1, I
              Z(I,J) = A(I,J)
  100   CONTINUE
        IF (N.EQ.1) GOTO 320
        DO 300 II = 2, N
           I = N + 2 - II
           L = I - 1
           H = 0.0
           SCALE = 0.0
           IF (L.LT.2) GOTO 130
           DO 120 K = 1, L
              SCALE = SCALE + ABS(Z(I,K))
  120      CONTINUE
           IF (SCALE.NE.0.0) GOTO 140
  130      E(I) = Z(I,L)
           GOTO 290
  140      DO 150 K = 1, L
              Z(I,K) = Z(I,K)/SCALE
              H = H + Z(I,K)*Z(I,K)
  150      CONTINUE
C
           F = Z(I,L)
           G = -SIGN(SQRT(H),F)
           E(I) = SCALE * G
           H = H - F * G
           Z(I,L) = F - G
           F = 0.0
C
           DO 240 J = 1, L
              Z(J,I) = Z(I,J)/H
              G = 0.0
C             Form element of A*U.
              DO 180 K = 1, J
                 G = G + Z(J,K)*Z(I,K)
  180         CONTINUE
              JP1 = J + 1
              IF (L.LT.JP1) GOTO 220
              DO 200 K = JP1, L
                 G = G + Z(K,J)*Z(I,K)
  200         CONTINUE
C             Form element of P where P = I - U U' / H .
  220         E(J) = G/H
              F = F + E(J) * Z(I,J)
  240      CONTINUE
           HH = F/(H + H)
C          Form reduced A.
           DO 260 J = 1, L
              F = Z(I,J)
              G = E(J) - HH * F
              E(J) = G
              DO 250 K = 1, J
                 Z(J,K) = Z(J,K) - F*E(K) - G*Z(I,K)
  250         CONTINUE
  260      CONTINUE
  290      D(I) = H
  300   CONTINUE
  320   D(1) = 0.0
        E(1) = 0.0
C       Accumulation of transformation matrices.
        DO 500 I = 1, N
           L = I - 1
           IF (D(I).EQ.0.0) GOTO 380
           DO 360 J = 1, L
              G = 0.0
              DO 340 K = 1, L
                 G = G + Z(I,K) * Z(K,J)
  340         CONTINUE
              DO 350 K = 1, L
                 Z(K,J) = Z(K,J) - G * Z(K,I)
  350         CONTINUE
  360      CONTINUE
  380      D(I) = Z(I,I)
           Z(I,I) = 1.0
           IF (L.LT.1) GOTO 500
           DO 400 J = 1, L
              Z(I,J) = 0.0
              Z(J,I) = 0.0
  400      CONTINUE
  500   CONTINUE
C
        RETURN
        END
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                            C
C Determine eigenvalues and eigenvectors of a symmetric,                     C
C tridiagonal matrix.                                                        C
C                                                                            C
C To call:    CALL TQL2(NM,N,D,E,Z,IERR)    where                            C
C                                                                            C
C NM = row dimension of Z;                                                   C
C N = order of matrix Z;                                                     C
C D = vector of dim. N containing, on output, eigenvalues;                   C
C E = working vector of dim. at least N-1;                                   C
C Z = matrix of dims. NM by N containing, on output, eigenvectors;           C
C IERR = error, normally 0, but 1 if no convergence.                         C
C                                                                            C
C Normally the call to TQL2 will be preceded by a call to TRED2 in           C
C order to set up the tridiagonal matrix.                                    C
C                                                                            C
C Algorithm used: QL method of Bowdler et al., Num. Math. 11,                C
C 293-306, 1968.                                                             C
C                                                                            C
C Reference: Smith et al., Matrix Eigensystem Routines - EISPACK             C
C Guide, Lecture Notes in Computer Science 6, Springer-Verlag, 1976,         C
C pp. 468-474.                                                               C
C                                                                            C
C F. Murtagh, ST-ECFESA/ESO, Garching-bei-Muenchen, January 1986.            C
C                                                                            C
C----------------------------------------------------------------------------C
        SUBROUTINE TQL2C(NM,N,D,E,Z,IERR)
C
        REAL    D(N), E(N), Z(NM,N)
        REAL    EPS,F,H,B,G,R,P,C,S
        INTEGER NM,N,IERR,I,J,L,M,L1,MML,II
        INTEGER K
        DATA    EPS/1.E-12/
C
        IERR = 0
        IF (N.EQ.1) GOTO 1001
        DO 100 I = 2, N
           E(I-1) = E(I)
  100   CONTINUE
        F = 0.0
        B = 0.0
        E(N) = 0.0
C
        DO 240 L = 1, N
           J = 0
           H = EPS * (ABS(D(L)) + ABS(E(L)))
           IF (B.LT.H) B = H
C          Look for small sub-diagonal element.
           DO 110 M = L, N
              IF (ABS(E(M)).LE.B) GOTO 120
C             E(N) is always 0, so there is no exit through the bottom
C             of the loop.
  110      CONTINUE
  120      IF (M.EQ.L) GOTO 220
  130      IF (J.EQ.30) GOTO 1000
           J = J + 1
C          Form shift.
           L1 = L + 1
           G = D(L)
           P = (D(L1)-G)/(2.0*E(L))
           R = SQRT(P*P+1.0)
           D(L) = E(L)/(P+SIGN(R,P))
           H = G-D(L)
C
           DO 140 I = L1, N
              D(I) = D(I) - H
  140      CONTINUE
C
           F = F + H
C          QL transformation.
           P = D(M)
           C = 1.0
           S = 0.0
           MML = M - L
C
           DO 200 II = 1, MML
              I = M - II
              G = C * E(I)
              H = C * P
              IF (ABS(P).LT.ABS(E(I))) GOTO 150
              C = E(I)/P
              R = SQRT(C*C+1.0)
              E(I+1) = S * P * R
              S = C/R
              C = 1.0/R
              GOTO 160
  150         C = P/E(I)
              R = SQRT(C*C+1.0)
              E(I+1) = S * E(I) * R
              S = 1.0/R
              C = C * S
  160         P = C * D(I) - S * G
              D(I+1) = H + S * (C * G + S * D(I))
C             Form vector.
              DO 180 K = 1, N
                 H = Z(K,I+1)
                 Z(K,I+1) = S * Z(K,I) + C * H
                 Z(K,I) = C * Z(K,I) - S * H
  180         CONTINUE
  200      CONTINUE
           E(L) = S * P
           D(L) = C * P
           IF (ABS(E(L)).GT.B) GOTO 130
  220      D(L) = D(L) + F
  240   CONTINUE
C
C       Order eigenvectors and eigenvalues.
        DO 300 II = 2, N
           I = II - 1
           K = I
           P = D(I)
           DO 260 J = II, N
              IF (D(J).GE.P) GOTO 260
              K = J
              P = D(J)
  260      CONTINUE
           IF (K.EQ.I) GOTO 300
           D(K) = D(I)
           D(I) = P
           DO 280 J = 1, N
              P = Z(J,I)
              Z(J,I) = Z(J,K)
              Z(J,K) = P
  280      CONTINUE
  300   CONTINUE
C
        GOTO 1001
C       Set error - no convergence to an eigenvalue after 30 iterations.
 1000   IERR = 1
 1001   RETURN
        END
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                            C
C  Output array.                                                             C
C                                                                            C
C----------------------------------------------------------------------------C
        SUBROUTINE OUTMTC(N,M,ARRAY)
C
        INTEGER   N,M,K1,K2
        REAL ARRAY(N,M)
C
        DO 100 K1 = 1, N
           WRITE (6,1000) (ARRAY(K1,K2),K2=1,M)
  100   CONTINUE
C
 1000   FORMAT(10(2X,F8.4))
        RETURN
        END
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                            C
C  Output eigenvalues in order of decreasing value.                          C
C  The first eigenvalue in Correspondence Analysis is trivially              C
C  of value 1, and so is ignored.                                            C
C                                                                            C
C----------------------------------------------------------------------------C
        SUBROUTINE OUTVLC(NVALS,VALS)
        INTEGER   NVALS,K
        REAL       VALS(NVALS),TOT,CUM,VPC,VCPC
C
        TOT = 0.0
        DO 100 K = 1, NVALS-1
           TOT = TOT + VALS(K)
  100   CONTINUE
C
        WRITE (6,1000)
        CUM = 0.0
        K = NVALS
        WRITE (6,1010)
        WRITE (6,1020)
  200   CONTINUE
        K = K - 1
        CUM = CUM + VALS(K)
        VPC = VALS(K) * 100.0 / TOT
        VCPC = CUM * 100.0 / TOT
        WRITE (6,1030) VALS(K),VPC,VCPC
        IF (K.GT.1) GOTO 200
C
        RETURN
 1000   FORMAT(1H0,'EIGENVALUES FOLLOW.',/)
 1010   FORMAT
     X  (' Eigenvalues       As Percentages    Cumul. Percentages')
 1020   FORMAT
     X  (' -----------       --------------    ------------------')
 1030   FORMAT(F10.4,9X,F10.4,10X,F10.4)
        END
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                            C
C  Output FIRST SEVEN eigenvectors associated with eigenvalues               C
C  in descending order.                                                      C
C                                                                            C
C----------------------------------------------------------------------------C
        SUBROUTINE OUTVC(NDIM,VECS)
        INTEGER         NDIM,K1,K2,NUM
        REAL       VECS(NDIM,NDIM)
C
        NUM = MIN0(NDIM,7)
        WRITE (6,1000)
        WRITE (6,1010)
        WRITE (6,1020)
        DO 100 K1 = 1, NDIM
        WRITE (6,1030) K1,(VECS(K1,NDIM-K2+1),K2=1,NUM)
  100   CONTINUE
C
        RETURN
 1000   FORMAT(1H0,'FACTORS FOLLOW.',/)
 1010   FORMAT('  VBLE.   EV-1    EV-2    EV-3    EV-4    EV-5    EV-6
     X   EV-7')
 1020   FORMAT(' ------  ------  ------  ------  ------  ------  ------
     X------')
 1030   FORMAT(I5,2X,7F8.4)
        END
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                            C
C  Output projections of row-points on first (up to) 7 factors.              C
C                                                                            C
C----------------------------------------------------------------------------C
        SUBROUTINE OUTPXC(N,M,PRJN)
        INTEGER N,M,K,NUM,J
        REAL    PRJN(N,M)
C
        NUM = MIN0(M,7)
        WRITE (6,1000)
        WRITE (6,1010)
        WRITE (6,1020)
        DO 100 K = 1, N
           WRITE (6,1030) K,(PRJN(K,J),J=1,NUM)
  100   CONTINUE
C
 1000   FORMAT(1H0,'PROJECTIONS OF ROW-POINTS FOLLOW.',/)
 1010   FORMAT(' OBJECT  PROJ-1  PROJ-2  PROJ-3  PROJ-4  PROJ-5  PROJ-6
     X  PROJ-7')
 1020   FORMAT(' ------  ------  ------  ------  ------  ------  ------
     X  ------')
 1030   FORMAT(I5,2X,7F8.4)
        RETURN
        END
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                            C
C   Output projections of column points on first 7 factors.                  C
C                                                                            C
C----------------------------------------------------------------------------C
        SUBROUTINE OUTPYC(M,PRJNS)
        INTEGER K,M,J,NUM
        REAL    PRJNS(M,M)
C
        NUM = MIN0(M,7)
        WRITE (6,1000)
        WRITE (6,1010)
        WRITE (6,1020)
        DO 100 K = 1, M
           WRITE (6,1030) K,(PRJNS(K,J),J=1,NUM)
  100   CONTINUE
C
 1000   FORMAT(1H0,'PROJECTIONS OF COLUMN-POINTS FOLLOW.',/)
 1010   FORMAT('  VBLE.  PROJ-1  PROJ-2  PROJ-3  PROJ-4  PROJ-5  PROJ-6
     X  PROJ-7')
 1020   FORMAT(' ------  ------  ------  ------  ------  ------  ------
     X  ------')
 1030   FORMAT(I5,2X,7F8.4)
        RETURN
        END
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                            C
C   Form projections of row-points on first 7 factors.                       C
C   (The first - trivial - factor is ignored.)                               C
C                                                                            C
C----------------------------------------------------------------------------C
        SUBROUTINE PROJXC(N,M,DATA,EVEC,VEC,R)
        INTEGER N,M,K,I,J,L,NUM
        REAL    DATA(N,M), EVEC(M,M), VEC(M), R(N)
C
        NUM = MIN0(M,7)
        DO 300 K = 1, N
           DO 50 L = 1, M
              VEC(L) = DATA(K,L)
   50      CONTINUE
           DO 200 I = 1, NUM
              DATA(K,I) = 0.0
              DO 100 J = 1, M
                 DATA(K,I) = DATA(K,I) + VEC(J) * EVEC(J,M-I)
  100         CONTINUE
              IF (R(K).GT.0.0) DATA(K,I) = DATA(K,I)/R(K)
              IF (R(K).EQ.0.0) DATA(K,I) = 0.0
  200      CONTINUE
  300   CONTINUE
C
        RETURN
        END
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                            C
C   Form projections of column points on first 7 factors.                    C
C   (The first - trivial - factor is ignored.)                               C
C                                                                            C
C----------------------------------------------------------------------------C
        SUBROUTINE PROJYC(M,EVALS,A,Z,VEC,C)
        INTEGER M,L,J1,J2,J3,NUM
        REAL    EVALS(M), A(M,M), Z(M,M), VEC(M), C(M)
C
        NUM = MIN0(M,7)
        DO 300 J1 = 1, M
           DO 50 L = 1, M
              VEC(L) = A(J1,L)
   50      CONTINUE
           DO 200 J2 = 1, NUM
              A(J1,J2) = 0.0
              DO 100 J3 = 1, M
                 A(J1,J2) = A(J1,J2) + VEC(J3)*Z(J3,M-J2)*
     X                                   SQRT(C(J3))
  100         CONTINUE
              IF ((EVALS(M-J2).GT.0.0).AND.(C(J1).GT.0.0))
     X                  A(J1,J2) = A(J1,J2)/SQRT(EVALS(M-J2)*C(J1))
              IF ((EVALS(M-J2).EQ.0.0).OR.(C(J1).EQ.0.0)) A(J1,J2)=0.0
  200      CONTINUE
  300   CONTINUE
C
        RETURN
        END
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                            C
C   Output contributions of row-points to first 7 factors.                   C
C                                                                            C
C----------------------------------------------------------------------------C
        SUBROUTINE OUTCTX(N,M,PRJN,R)
        INTEGER N,M,NUM,K,J
        REAL    PRJN(N,M), R(N), XDUM(7)
C
        NUM = MIN0(M,7)
        WRITE (6,1000)
        WRITE (6,1010)
        WRITE (6,1020)
        DO 100 K = 1, N
           DO 50  J = 1, NUM
              XDUM(J) = R(K)*PRJN(K,J)**2
   50      CONTINUE
           WRITE (6,1030) K,(XDUM(J),J=1,NUM)
  100   CONTINUE
C
 1000   FORMAT(1H0,'ABS. CONTRIBUTIONS OF OBJECTS TO FACTORS FOLLOW.',/)
 1010   FORMAT(' OBJECT  CNTR-1  CNTR-2  CNTR-3  CNTR-4  CNTR-5  CNTR-6
     X  CNTR-7')
 1020   FORMAT(' ------  ------  ------  ------  ------  ------  ------
     X  ------')
 1030   FORMAT(I5,2X,7F8.4)
        RETURN
        END
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++C
C                                                                            C
C   Output contributions of column-points to first 7 factors.                C
C                                                                            C
C----------------------------------------------------------------------------C
        SUBROUTINE OUTCTY(M,PRJNS,C)
        INTEGER M,K,J,NUM
        REAL    PRJNS(M,M), C(M), XDUM(7)
C
        NUM = MIN0(M,7)
        WRITE (6,1000)
        WRITE (6,1010)
        WRITE (6,1020)
        DO 100 K = 1, M
           DO 50 J = 1, NUM
              XDUM(J) = C(K)*PRJNS(K,J)**2
   50      CONTINUE
           WRITE (6,1030) K,(XDUM(J),J=1,NUM)
  100   CONTINUE
C
 1000   FORMAT
     X  (1H0,'ABS. CONTRIBUTIONS OF VARIABLES TO FACTORS FOLLOW.',/)
 1010   FORMAT('  VBLE.  CNTR-1  CNTR-2  CNTR-3  CNTR-4  CNTR-5  CNTR-6
     X  CNTR-7')
 1020   FORMAT(' ------  ------  ------  ------  ------  ------  ------
     X  ------')
 1030   FORMAT(I5,2X,7F8.4)
        RETURN
        END

C @(#)sort2.for	19.1 (ES0-DMD) 02/25/03 13:19:39
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE SORT2(RA,RB,N)                                                 
C+++                                                                            
C.IDENTIFICATION                                                                
C.AUTHOR:   M.Rosa, ESO-Garching, 831105                                        
C.PURPOSE:  Sort string of values into ascending sequence of values             
C.ALGORITM: The art of scientific computing                                     
C           Press et al., Cambridge university Press, 1986                      
C.USE:      CALL SORT2(XC,YC,N)                                                 
C.VERSION:  910115 RHW IMPLICIT NONE added
C---                                                                            
C     
      IMPLICIT   NONE
      INTEGER    N
      REAL       RA(N)
      REAL       RB(N)                                                         
C
      INTEGER    I, IR
      INTEGER    J
      INTEGER    L
      REAL       RRA, RRB
                                                                                
      L  = N/2 + 1                                                              
      IR = N                                                                    
                                                                                
10    CONTINUE                                                                  
      IF (L.GT.1) THEN                                                          
         L      = L - 1                                                         
         RRA    = RA(L)                                                         
         RRB    = RB(L)                                                         
      ELSE                                                                      
         RRA    = RA(IR)                                                        
         RRB    = RB(IR)                                                        
         RA(IR) = RA(1)                                                         
         RB(IR) = RB(1)                                                         
         IR     = IR - 1                                                        
                                                                                
         IF (IR.EQ.1) THEN                                                      
            RA(1) = RRA                                                         
            RB(1) = RRB                                                         
            RETURN                                                              
         ENDIF                                                                  
      ENDIF                                                                     
                                                                                
      I = L                                                                     
      J = L+L                                                                   
                                                                                
20    CONTINUE                                                                  
      IF (J.LE.IR) THEN                                                         
         IF (J.LT.IR) THEN                                                      
            IF (RA(J).LT.RA(J+1)) THEN                                          
               J = J + 1                                                        
            ENDIF                                                               
         ENDIF                                                                  
                                                                                
         IF (RRA.LT.RA(J)) THEN                                                 
            RA(I) = RA(J)                                                       
            RB(I) = RB(J)                                                       
            I     = J                                                           
            J     = J + J                                                       
         ELSE                                                                   
            J     = IR + 1                                                      
         ENDIF                                                                  
         GO TO 20                                                               
      ENDIF                                                                     
                                                                                
      RA(I) = RRA                                                               
      RB(I) = RRB                                                               
      GO TO 10                                                                  
      END                                                                       

C @(#)asker.for	19.1 (ES0-DMD) 02/25/03 13:28:45
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C  @(#)asker.for	19.1  (ESO-IPG)  02/25/03  13:28:45
      SUBROUTINE ASK(QUERY,REPLY)
C
C       Copyright (C) Andrew T. Young, 1990
C       Copyright (C) European Southern Observatory, 1992
C
C                                               FEB.6,1987
C  ASKS THE QUERY ON THE TERMINAL SCREEN AND
C  ACCEPTS REPLY FROM KEYBOARD.
C
C  QUITS IF REPLY IS 'Q' OR 'QUIT'.
C
      IMPLICIT NONE
      INTEGER ISTAT, NACTEL, IUNIT, NULLS, LWORD, IDIFF, IA, I
C
      CHARACTER *(*) QUERY,REPLY, A*1
      CHARACTER*80 BUFIN, BUFOUT
C
C
      LOGICAL MATCH
      EXTERNAL MATCH
C
        BUFIN=QUERY
    1   CALL STTPUT(' ',ISTAT)
    2   CALL STKPRC (BUFIN, 'INPUTC', 1, 1, 80,
     1              NACTEL, BUFOUT, IUNIT, NULLS, ISTAT)
        REPLY=BUFOUT
        IF (ISTAT.NE.0) THEN
                CALL STTPUT ( 'REPLY was:', ISTAT)
                CALL STTPUT ( REPLY, ISTAT)
                CALL STTPUT ('Please try again:', ISTAT)
                GO TO 99
        END IF
        IF(LWORD(REPLY).EQ.0) GOTO 1
C       modified to convert replies to upper case:
        IDIFF=ICHAR('A') - ICHAR('a')
        IA=ICHAR('a')
        DO 10 I=1, LWORD(REPLY)
   10   IF (ICHAR(REPLY(I:I)).GE.IA) REPLY(I:I)=
     1          CHAR(ICHAR(REPLY(I:I)) + IDIFF)
       IF(MATCH(REPLY,'QUIT'))THEN
      CALL STKPRC ('DO YOU WANT TO QUIT?','INPUTC', 1, 1, 1,
     1              NACTEL, A, IUNIT, NULLS, ISTAT)
      IF(A.EQ.'Y'.OR.A.EQ.'Q'.OR.A.EQ.'y'.OR.A.EQ.'q') THEN
        CALL TV('ABANDONED.')
        CALL STETER (9000,
     1     'Program abandoned.  You can IGNORE the "error" message.')
      END IF
      GO TO 1
       END IF
      RETURN
C
   99 CALL NOEOF
      GO TO 1
C
      ENTRY ASKN(QUERY,REPLY)
C
C  SIMILAR, BUT DOESN'T SPACE BEFORE LINE.
C
      BUFIN=QUERY
      GO TO 2
C
      END
      SUBROUTINE TV(MESAGE)
C
C  SHOWS THE MESSAGE ON THE TERMINAL SCREEN.
C
      IMPLICIT NONE
      INTEGER ISTAT
C
      CHARACTER *(*) MESAGE
C
C
    1 CALL STTPUT(' ',ISTAT)
    2 CALL STTPUT(MESAGE,ISTAT)
      IF (ISTAT.NE.0) THEN
        CALL STTPUT('ERROR in writing to screen!',ISTAT)
         GO TO 1
      END IF
      RETURN
C
      ENTRY TVN(MESAGE)
      GO TO 2
C
      END
      SUBROUTINE QF(Q,F)
C
C  ASKS QUERY Q ON THE TERMINAL SCREEN AND        18 FEB.1987
C  ACCEPTS FLOATING-POINT VALUE F FROM KEYBOARD.
C
      IMPLICIT NONE
      REAL F
      INTEGER ISTAT, I1SAV, I2SAV, I3SAV, NACTEL, IUNIT, NULLS
C
      CHARACTER *(*) Q
        CHARACTER*80 BUFIN
C
C
        BUFIN=Q
    1   CALL STTPUT(' ',ISTAT)
        CALL STECNT ('GET', I1SAV, I2SAV, I3SAV)
        CALL STECNT ('PUT', 1, 0, 0)
        CALL STKPRR (BUFIN, 'INPUTR', 1, 1,
     1              NACTEL, F, IUNIT, NULLS, ISTAT)
        IF (ISTAT.NE.0 .OR. NACTEL.NE.1) THEN
                CALL STTPUT ('Failed to obtain REAL value', ISTAT)
                CALL STTPUT ('Please try again:',ISTAT)
                GO TO 99
        END IF
      CALL STECNT ('PUT', I1SAV, I2SAV, I3SAV)
      RETURN
C
   99 CALL NOEOF
      GO TO 1
C
      END
      SUBROUTINE NOEOF
C
C  CANCELS EOF FROM KEYBOARD AND RE-STARTS INPUT FILE.
C
C ***
C This version does nothing.
      RETURN
      END
      SUBROUTINE CENTER(STRING)
C
C  Centers the input string in output.
C
      IMPLICIT NONE
C
      CHARACTER *(*) STRING
      CHARACTER *79 CARD
C
      INTEGER LEN
C
      INTEGER LWORD
C
C
      LEN=(79-LWORD(STRING))/2
      CARD(:LEN)=' '
      CARD(LEN:)=STRING
      CALL TV(CARD)
C
      RETURN
      END

C @(#)find.for	19.1 (ES0-DMD) 02/25/03 13:23:49
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE  FIND (D, H, JCYLN, G, SKIP, MAX, MAXBOX, MAXCOL,
     .     MAXSKY, OPT, NOPT)
      IMPLICIT NONE
C
C=======================================================================
C
C This subroutine is supposed to find small, positive brightness
C perturbations in a two-dimensional image.
C
C                OFFICIAL DAO VERSION:  1991 April 18
C
C First, FIND reads in several rows' worth of image data.  For each
C pixel it computes a least-squares fit of an analytic Gaussian function
C to a roughly circular array of pixels surrounding the pixel in
C question.  The overall bias level (sky brightness in that vicinity)
C is removed by the calculation and, since the function is
C symmetric about the central pixel, a smooth gradient in the sky
C brightness cancels out exactly.  This means that the user does
C not have to specify an absolute brightness threshold for star
C detection, and if the mean background brightness varies over the
C frame, to the extent that the variations are smooth and large-scale,
C to first order they will have no effect on the detection limit.
C    The derived peak heights of the Gaussian functions are stored in a
C scratch disk image file.  Later they will be read back in, and local
C maxima in the peak values will be sought.  After undergoing a few
C tests designed to select against bad pixels and bad columns, these
C local maxima will be considered to be astronomical objects, better
C image centroids will be computed, and the objects will be assigned
C sequential ID numbers and will be written to a disk data file.
C    The user is asked to specify a "lowest good data-value"-- any pixel
C whose value is found to fall below this level or above the HIBAD
C value which is passed as an argument is presumed bad, and
C is ignored during all computations in this routine.  The numerical
C value of this bad pixel ceiling will be written out in the header
C of the output data file, and will be used in other DAOPHOT routines
C as well.
C
C Arguments
C
C     FWHM (INPUT) is the estimated full width at half-maximum of the
C          objects for which the algorithm is to be optimized.  It will
C          be used (a) to determine the size of the roughly circular
C          array which will be used to compute the brightness
C          enhancements and to define local maxima, and (b) to define
C          the coefficient assigned to each pixel in the computation
C          of the brightness enhancements.
C
C    WATCH (INPUT) governs whether information relating to the progress
C          of the star-finding is to be typed on the terminal screen
C          during execution.
C
C SHRPLO, SHRPHI (INPUT) are numerical cutoffs on the image-sharpness
C          statistic, designed to eliminate brightness maxima which
C          appear to be due to bad pixels, rather than to astronomical
C          objects.
C
C RNDLO, RNDHI (INPUT) are numerical cutoffs on the image-roundness
C          statistic, designed to eliminate brightness maxima which
C          appear to be due to bad rows or columns, rather than to
C          astronomical objects.
C
C HIBAD  is the highest valid data-value-- the level above which the
C          CCD chip is presumed to be non-linear.
C
C All of the above arguments are user-definable optional parameters,
C whose numerical values may be changed by a DEFAULT.OPT file, or by
C the OPTION command.  (WATCH may also the set by the MONITOR and
C NOMONITOR commands.)
C
C=======================================================================
C
C Parameters:
C
      INTEGER MAX, MAXBOX, MAXCOL, MAXSKY, NOPT
C
C MAXBOX is the length of the side of the largest subarray that you plan
C        to need for computing the brightness enhancement in each pixel.
C
C MAX/MAXBOX is the length in the x-direction of the largest picture
C        you can try to reduce.
C
C-----------------------------------------------------------------------
C
C DIMENSIONS
C
C Arrays
C
      REAL D(MAXCOL,MAXBOX), H(MAXCOL,MAXBOX), DATA(2), OPT(NOPT)
      REAL G(MAXBOX,MAXBOX), AMAX1
      INTEGER JCYLN(MAX)
      LOGICAL SKIP(MAXBOX,MAXBOX)
C
C Variables
C
      CHARACTER*30 COOFIL, MAGFIL, PSFFIL, PROFIL, GRPFIL, CONPIC
      CHARACTER SWITCH*30, EXTEND*30, LINE*5, CASE*4, ANSWER*1
      REAL PIXELS, RADIUS, FWHM, SIGSQ, RSQ, RELERR, SKYLVL, TEMP
      REAL HMIN, LOBAD, HIBAD, WATCH, P, DATUM, HEIGHT, DENOM, SGOP
      REAL SHARP, ROUND, SHRPLO, SHRPHI, RNDLO, RNDHI
      REAL SUMG, SUMGSQ, SUMGD, SUMD, SG, SGSQ, SGD, SD, WT, HX, HY
      REAL DGDX, SDGDX, SDGDXS, SDDGDX, SGDGDX
      REAL XCEN, YCEN, DX, DY, PHPADU, READNS, SKYMOD
      INTEGER NHALF, NBOX, MIDDLE, LASTCL, LASTRO, NCOL, NROW, JSQ
      INTEGER ISTAT, NROWS, NSTAR
      INTEGER I, J, K, N, IX, IY, JX, JY, KX, LX, LY
C
C Common
C
      COMMON /SIZE/ NCOL, NROW
      COMMON /FILNAM/ COOFIL, MAGFIL, PSFFIL, PROFIL, GRPFIL
C
      HIBAD = OPT(4)
      FWHM = OPT(5)
      SHRPLO = OPT(7)
      SHRPHI = OPT(8)
      RNDLO = OPT(9)
      RNDHI = OPT(10)
      WATCH = OPT(11)
C
C-----------------------------------------------------------------------
C
C SECTION 1
C
C Setup the necessary variables and arrays, particularly the constants
C to be used in the convolutions.
C
C The brightness enhancement will be computed on the basis only of those
C pixels within 1.5 sigma = 0.637*FWHM of the central pixel.  However,
C in the limit of infinitely small FWHM the brightness enhancement will
C be based on no fewer than the following subarray of pixels:
C
C                                .
C                                .
C                                .
C
C                          -  -  +  -  -
C                          -  +  +  +  -
C                 .  .  .  +  +  X  +  +  .  .  .
C                          -  +  +  +  -
C                          -  -  +  -  -
C                                .
C                                .
C                                .
C
C This represents a 5 x 5 subarray taken out of the original picture.
C The X represents the pixel for which the brightness enhancement is
C currently being computed and the +'s represent other pixels included
C in the calculation; the -'s and all pixels lying outside this 5 x 5
C subarray will not be used in computing the brightness enhancement in
C the central pixel.  In the limit of infinitely large FWHM, only those
C pixels lying within a MAXBOX x MAXBOX square subarray centered on the
C pixel in question will be used in computing its brightness
C enhancement.
C
C Compute the size of the subarray needed.  The radius of the circular
C area desired is MAX (2.0, 0.637*FWHM), so the distance from the
C central pixel to the center of an edge pixel is the integer smaller
C than this.
C
      RADIUS=AMAX1(2.001, 0.637*FWHM)
      NHALF=MIN0((MAXBOX-1)/2, INT(RADIUS))
      NBOX=2*NHALF+1                ! Length of the side of the subarray
      MIDDLE=NHALF+1
C
C Just for future reference--
C
C MIDDLE is the index of the central pixel of the box in both x and y,
C        where the corner of the box is considered to be at (1,1).
C
C  NHALF is the number of pixels between the central pixel (exclusive)
C        and the edge of the box (inclusive).  For example, if NBOX = 7,
C        MIDDLE = 4 and NHALF = 3.  Note that all the way around the
C        picture being reduced there will be a border NHALF pixels wide
C        where define brightness enhancements can't be defined, because
C        the box would extend beyond the boundaries of the frame.  We
C        will thus be able to compute brightness enhancements only for
C        MIDDLE <= x <= LASTCL,   MIDDLE <= y <= LASTRO, where...
C
      LASTRO=NROW-NHALF
      LASTCL=NCOL-NHALF
C
C-----------------------------------------------------------------------
C
C Compute the values of a bivariate circular Gaussian function with
C unit height and the specified value of the FWHM.
C
      SIGSQ=(FWHM/2.35482)**2
      RADIUS=RADIUS**2
C
C RADIUS is now the square of the radius of the circle to be used.
C
C-----------------------------------------------------------------------
C
C EXPLANATION:
C
C The approach taken by this star-finding algorithm is defined by this
C question:  "Assuming for the moment that there is a star with a
C Gaussian light distribution centered in the central pixel of this
C subarray, then how bright is it?"  Having answered that question for
C every pixel MIDDLE <= x <= LASTCL, MIDDLE <= y <= LASTRO, we will
C then go through the picture looking for places where the numerical
C answer to the question achieves local maxima.  For the region around
C each pixel, then, we want to solve this equation via least squares:
C
C                     D(i,j) = h * G(i,j) + s
C
C where D is the observed brightness in some pixel of the subarray, G
C is the value of the Gaussian function of unit central height in the
C in that pixel
C
C G(i,j) = exp{[(i-MIDDLE)**2 + (j-MIDDLE)**2]/(2 * sigma**2)}, for
C
C                      (i-MIDDLE)**2 + (j-MIDDLE)**2 < (1.5 * sigma)**2
C
C (the center of the subarray has relative coordinates i = j = MIDDLE).
C
C      The parameters  h  (= central brightness of the hypothetical
C star centered in the central pixel of the subarray), and s (= the
C local sky background) are unknowns.  The least-squares solution
C for this system of equations is given by
C
C         [G*D] - [G] [D]/n
C    h =  ----------------- ,         s = {[D] - h [G]}/n
C         [G**2] - [G]**2/n
C
C where the square brackets denote summation (Gauss's notation).
C
C For use in solving for the many values of  h, we will save the
C array G(i,j) (= G(I,J)) and the constants [G] (= SUMG, meaning
C "sum of the Gaussian"), [G**2] (= SUMGSQ), n (= PIXELS); also the
C denominator of the fraction for  h (= DENOM), and [G]/n (= SGOP).
C [G*D] and [D] will have to be computed each time.
C
C It is possible to show that each of these least-squares problems can
C be reduced to a linear function of the image data D(i,j), and that the
C entire ensemble of least-squares problems is arithmetically identical
C with a convolution of the original image data with a truncated,
C lowered Gaussian function.  Hence, I will occasionally refer to the
C generation of the array of values h(i,j) as a "convolution."
C
C-----------------------------------------------------------------------
C
C Loop over the pixels in the subarray, computing the value of the
C Gaussian function G(i,j) at each point.  Also, accumulate the sum of
C the values of the Gaussian and the sum of the squares of the values
C of the Gaussian.  These will be held for later use in the convolution.
C
      SUMG=0.0
      SUMGSQ=0.0
      PIXELS=0.0
      DO J=1,NBOX
         JSQ=(J-MIDDLE)**2
C
         DO I=1,NBOX
            RSQ=FLOAT((I-MIDDLE)**2+JSQ)
            G(I,J)=EXP(-0.5*RSQ/SIGSQ)
            IF (RSQ .LE. RADIUS) THEN
               SKIP(I,J)=.FALSE.
               SUMG=SUMG+G(I,J)
               SUMGSQ=SUMGSQ+G(I,J)**2
               PIXELS=PIXELS+1.0
            ELSE
               SKIP(I,J)=.TRUE.
            END IF
         END DO
      END DO
      DENOM=SUMGSQ-(SUMG**2)/PIXELS
      SGOP=SUMG/PIXELS
C
C At this point the two-dimensional array G(I,J) contains the values of
C a unit Gaussian function, with the input value of FWHM, at each point
C in the SQUARE subarray.
C
C SUMG   contains the sum of the values of the Gaussian function over
C        the CIRCULAR area which will be used in the convolution.
C
C SUMGSQ contains the sum of the squares of the values of the Gaussian
C        function over the CIRCULAR area which will be used in the
C        convolution.
C
C PIXELS contains the number of pixels in the CIRCULAR area which will
C        be used in the convolution.
C
C DENOM  contains the denominator of the fraction defining  h.
C
C SGOP   contains [G]/n
C
C Using our knowledge of least squares, we can compute the standard
C error of the coefficient  h  in terms of the standard error of the
C brightness in a single pixel:
C
C      sigma**2(h) = sigma**2(1 pixel) / ([G**2] - [G]**2/n)
C
      RELERR=1.0/DENOM
      RELERR=SQRT(RELERR)
      CALL SKY (D, H, JCYLN, MIN0(MAX,MAXSKY), HIBAD, READNS,
     .     PHPADU, SKYMOD, IX)
      WRITE (6,610) RELERR
  610 FORMAT(23X, 'Relative error =', F5.2/)
C
C Now ask the user for a star-detection threshold and a bad pixel
C ceiling.
C
      CALL GETDAT ('Number of frames averaged, summed:', DATA, 2)
      IF ((DATA(1) .LT. 0.5) .OR. (DATA(2) .LT. 0.5)) RETURN
      READNS = OPT(1)**2*DATA(2)/DATA(1)
      PHPADU = OPT(2)*DATA(1)
      HMIN = SQRT(READNS + AMAX1(0.,SKYMOD)/PHPADU)
      LOBAD = 0.1*NINT(10.*(SKYMOD-OPT(3)*HMIN))
      HMIN = 0.01*NINT(100.*OPT(6)*RELERR*HMIN)
      READNS = SQRT(READNS)
C
C Later on, the threshold HMIN will be the minimum value of the local
C brightness enhancement that will be considered when searching for
C local maxima, and any pixel whose brightness value is less than LOBAD
C or greater than HIBAD will be ignored in the computations.
C
C Open the input and scratch disk files.
C
 2950 CALL GETNAM ('File for the positions:', COOFIL)
      IF ((COOFIL .EQ. 'END OF FILE') .OR.
     .     (COOFIL .EQ. 'GIVE UP')) THEN
         COOFIL = ' '
         RETURN
      END IF
C
C Open output data file for newly-discovered stars.
C
      COOFIL = EXTEND(COOFIL, CASE('coo'))
      CALL OUTFIL (3, COOFIL, ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error opening output file '//COOFIL)
         COOFIL = 'GIVE UP'
         GO TO 2950
      END IF
      IF (WATCH .GT. 0.5) THEN
         CALL TBLANK
         CALL OVRWRT('  Row', 1)
      END IF
      CONPIC=SWITCH(COOFIL, CASE('jnk'))
      CALL COPPIC (CONPIC, D, NCOL, NROW, ISTAT)
      IF (ISTAT .NE. 0) RETURN
C
C-----------------------------------------------------------------------
C
C SECTION 2
C
C Read the raw image data in, holding only a few rows' worth of data in
C memory at any one time.  Convolve the data with the appropriate
C Gaussian function, and write the resulting numbers into the scratch
C disk picture.
C
C Only NBOX rows' worth of image data will be in memory at any one
C time.  The row numbered MIDDLE of the rows in memory is the one in
C which we will be looking for objects.  As we step through the image
C row by row, the data for the row MIDDLE-1 ( = NHALF) steps ahead of
C the new MIDDLE row will overwrite the data for the row MIDDLE
C ( = NHALF+1) steps behind.  This means that there is no practical
C upper limit to the size of the picture which can be run through
C this routine.
C
C First, load the first MIDDLE-1 rows of the cylinder buffer with
C an invalid brightness value.
C
      DO JY=1,MIDDLE-1
         DO IX=1,NCOL
            D(IX,JY) = -1.1E38
         END DO
      END DO
C
C Now read the first NHALF rows into the cylinder buffer, putting
C row 1 of the image into row MIDDLE of the buffer.
C
      LX = 1
      LY = 1
      NROWS = NHALF
      CALL RDARAY ('DATA', LX, LY, NCOL, NROWS, MAXCOL,
     .     D(1,MIDDLE), ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error reading image data from disk file.')
         RETURN
      END IF
      NROWS=1
C
C The cylinder buffer D now contains the actual image data for the
C first NHALF rows of the picture.  We will soon create the file
C containing the derived values of  h  (see above) one row at a time.
C
C Now we will step through the picture row by row. JY remembers which
C row in the big picture we are working on.  For each row JY, the
C convolved data will be accumulated in the vector H(i,2), and then
C written into the JY-th row of the scratch picture.
C
      JY=0
 2020 JY=JY+1                              ! Increment image-row pointer
      IF (JY .GT. NROW) GO TO 2100         ! Have we reached the bottom?
C
C Note that at any given time we have only NBOX rows of the original
C image in memory, contained in the cylinder buffer D(i,j),
C j = 1, ..., NBOX, but not necessarily in that order.  For instance,
C if NBOX = 5, when JY = 1,
C
C      row:     1    2    3    4    5     of G is to be fitted to
C
C      row:     *    *    1    2    3     of the original picture which
C                                         is contained in
C      row:     1    2    3    4    5     of D.
C
C When row 1 of the picture is done, JY is set to 2, and row 4
C of the original picture is read into row 1 of the cylinder buffer,
C D, overwriting the null values which we put there before.
C Hence, when JY = 2,
C
C      row:     1    2    3    4    5     of G is to be fitted to
C
C      row:     *    1    2    3    4     of the original picture which
C                                         is contained in
C      row:     2    3    4    5    1     of D.
C
C As a final example, consider the situation for JY = 7:
C
C      row:     1    2    3    4    5     of G is to be fitted to
C
C      row:     5    6    7    8    9     of the original picture which
C                                         is contained in
C      row:     2    3    4    5    1     of D.
C
C In other words:
C
C      row:     1    2    3    4    5     variable J
C
C      row:     5    6    7    8    9     variable JY
C
C      row:     2    3    4    5    1     vector JCYLN(J)
C
C The cylinder buffer, D, just rolls down through the picture like a
C caterpillar tread, dropping off rows of data when they are no longer
C necessary and picking up new ones in their place.  The data are
C handled in this way (a) to minimize the amount of memory required,
C by storing only those rows that are immediately wanted, consistent
C with (b) minimizing the number of data transfers.  Now, for the
C CURRENT value of JY, which row of the cylinder buffer is to be fitted
C to each row of G?  The answers will be contained in the vector
C JCYLN.
C
C JCYLN(MIDDLE) is the row in the cylinder buffer where we will find
C the data for row JY of the big picture, which is to be fitted to row
C MIDDLE of G.  Similarly, JCYLN returns the position in the cylinder
C buffer of the row to be fitted to the J-th row of G
C (J = 1, ..., NBOX).
C
C Now that this is all straight, read in the data for row JY+NHALF
C (overwriting the data for row JY-NHALF-1, which is no longer needed).
C
      DO J=1,NBOX
         IY = JY + (J - MIDDLE)
C
C IY is that row of the big picture which is to be matched up against
C row J of the Gaussian function, during the convolution of this
C row JY of the big picture.
C
C Which row of the cylinder buffer contains row IY of the big picture?
C
         I = IY + NHALF
C
C I now represents the position that row IY of the big picture would
C have had in the cylinder buffer if the cylinder buffer were
C arbitrarily long, i.e. row 1 of the image in row 3 of D, row 2
C in row 4, row 3 in row 5, row 4 in row 6, ... in the examples
C above.  Now we wrap this around.
C
         JCYLN(J) = MOD(I-1,NBOX) + 1
      END DO
C
      LY = JY+NHALF
      IF (LY .LE. NROW) THEN
         CALL RDARAY ('DATA', LX, LY, NCOL, NROWS, MAXCOL,
     .        D(1,JCYLN(NBOX)), ISTAT)
      ELSE
         K = JCYLN(NBOX)
         DO IX=1,NCOL
            D(IX,K) = -1.1E38
         END DO
      END IF
C
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error reading image data from disk file.')
         RETURN
      END IF
C
C Compute the local brightness enhancement for each pixel in the row,
C The enhancement is computed from a circular region contained
C within an NBOX x NBOX array centered on the current pixel, using the
C array, G(I,J), and the constants SUMG, SUMGSQ, and PIXELS computed
C above.  (These constants will need to be modified if the circular
C region used in the calculation contains any bad pixels; we will use
C the variables SG, SGSQ, and P for temporary storage of these
C constants, and SGD and SD for the accumulation of [G*D] and [D] which
C are also needed.)
C
      DO 2050 JX=1,NCOL
C
      SGD=0.
      SD=0.
      SGSQ=SUMGSQ
      SG=SUMG
      P=PIXELS
C
      DO 2040 IX = JX-NHALF,JX+NHALF
        I = MIDDLE + (IX-JX)
        DO 2040 J=1,NBOX
          K = JCYLN(J)
          IF (SKIP(I,J)) GO TO 2040
            IF ((IX .GE. 1) .AND. (IX .LE. NCOL)) THEN
              DATUM = D(IX,K)
              IF ((DATUM .GE. LOBAD).AND.(DATUM .LE. HIBAD)) THEN
                SGD = SGD+G(I,J)*DATUM
                SD = SD+DATUM
                GO TO 2040
              END IF
            END IF
            SGSQ = SGSQ-G(I,J)**2
            SG = SG-G(I,J)
            P = P-1.
 2040 CONTINUE
C
C Compute the central height of the best fitting Gaussian function,
C temporarily storing it in the variable, then putting it into array
C element H(JX, 2).
C
      IF (P .GT. 1.5) THEN
         IF (P .LT. PIXELS) THEN
            SGSQ = SGSQ-(SG**2)/P
            IF (SGSQ .NE. 0.) THEN
               SGD = (SGD-SG*SD/P)/SGSQ
            ELSE
               SGD = 0.
            END IF
         ELSE
            SGD = (SGD-SGOP*SD)/DENOM
         END IF
      ELSE
         SGD = 0.
      END IF
      H(JX,2) = SGD
C
 2050 CONTINUE
C
C Write this newly-computed row of brightness enhancements to the
C scratch output picture.
C
      IF (WATCH .GT. 0.5) THEN
         WRITE (LINE,620) JY
  620    FORMAT(I5)
         CALL OVRWRT (LINE(1:5), 2)
      END IF
      CALL WRARAY ('COPY', LX, JY, NCOL, NROWS, MAXCOL, H(1,2), ISTAT)
      GO TO 2020
C
 2100 CONTINUE
      CALL OVRWRT (' ', 4)
C
C Later on, when we try to decide whether a local maximum represents
C a stellar profile or a delta function ( = bright bad pixel), we will
C compare the brightness of the central pixel to the average of the
C surrounding pixels.  To be ready for that, we here modify SKIP to
C skip over the central pixel, and set PIXELS equal to the number of
C pixels in the circular area not counting the central pixel.
C
      SKIP(MIDDLE,MIDDLE) = .TRUE.
      PIXELS = PIXELS-1.0
C
C-----------------------------------------------------------------------
C
C SECTION 3
C
C Read in both the convolved data from the scratch disk file and the raw
C data from the original picture.  Search for local maxima in the
C convolved brightness data.  When these are found, compute image-shape
C statistics from the raw data to eliminate non-stellar brightness
C enhancements (as well as possible) and estimate the position of the
C centroid of the brightness enhancement.
C
 3000 CONTINUE
C
C Now the star search may begin.  The original image data will be read
C into the cylinder buffer D again, just as before.  At the same time,
C the brightness enhancements will be read from the scratch disk file
C into another cylinder buffer, H.  The brightness enhancements will
C then be searched for local maxima.  When these are found, functions
C of the original image data will be used to derive shape parameters
C designed to identify bad pixels and bad columns or rows.
C
      CALL WRHEAD (3, 1, NCOL, NROW, 6, LOBAD, HIBAD, HMIN,
     .     0., PHPADU, READNS, 0.)
      IF (WATCH .GT. 0.5) THEN
         CALL OVRWRT (' ', 4)
         WRITE (6,630)
  630    FORMAT(6X, '                              MAGS'/
     .     6X, '                              FROM '/
     .     6X, '       STAR     X      Y     LIMIT    SHARP    ROUND')
      END IF
C
C Read the first NHALF rows into each of the cylinder buffers,
C putting row 1 of the image into row MIDDLE of the buffer.
C
      DO JY=1,MIDDLE-1
         DO IX=1,NCOL
            D(IX,JY) = -1.1E38
            H(IX,JY) = 0.
         END DO
      END DO
C
      LX = 1
      LY = 1
      NROWS = NHALF
      CALL RDARAY ('DATA', LX, LY, NCOL, NROWS, MAXCOL,
     .     D(1,MIDDLE), ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error reading image data from disk file.')
         CALL CLPIC ('COPY')
         RETURN
      END IF
      CALL RDARAY ('COPY', LX, LY, NCOL, NROWS, MAXCOL,
     .     H(1,MIDDLE), ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error reading image data from scratch file.')
         CALL CLPIC ('COPY')
         RETURN
      END IF
      NROWS = 1
C
C Now step through the picture row by row.  Again JY is the image-row
C counter.
C
      NSTAR = 0
      JY = 0
 3020 JY = JY+1
C
C Have we just finished reducing the last row? If not, work on the
C next row.  If so, go on to Section 4.
C
      IF (JY .GT. NROW) GO TO 4000
C
C Determine the position in the cylinder buffers of all the rows
C contained in the box.
C
      DO J=1,NBOX
         IY = JY+(J-MIDDLE)+NHALF
         JCYLN(J) = MOD(IY-1,NBOX) + 1
      END DO
C
C Read in the data for row JY+NHALF.
C
      LY = JY+NHALF
      IF (LY .LE. NROW) THEN
         CALL RDARAY ('DATA', LX, LY, NCOL, NROWS, MAXCOL,
     .        D(1,JCYLN(NBOX)), ISTAT)
         IF (ISTAT .NE. 0) THEN
            CALL STUPID ('Error reading image data from disk file.')
            CALL CLPIC ('COPY')
            RETURN
         END IF
         CALL RDARAY ('COPY', LX, LY, NCOL, NROWS, MAXCOL,
     .        H(1,JCYLN(NBOX)), ISTAT)
         IF (ISTAT .NE. 0) THEN
            CALL STUPID ('Error reading image data from scratch file.')
            CALL CLPIC ('COPY')
            RETURN
         END IF
      ELSE
         K = JCYLN(NBOX)
         DO IX=1,NCOL
            D(IX,K) = -1.1E38
            H(IX,K) = 0.0
         END DO
      END IF
C
C Now step across the row, pixel by pixel.
C
      JX = 1
 3040 HEIGHT = H(JX,JCYLN(MIDDLE))
C
C Sieve to locate a local maximum in the brightness enhancement.  To
C be a local maximum, the brightness enhancement in a given pixel must
C be above the threshold, and it must also be greater than the
C brightness enhancement of any pixel within a radius equal to
C 1.5 sigma.
C
      IF (HEIGHT .LT. HMIN) GO TO 3300
      DO 3051 IX=JX-NHALF,JX+NHALF
         IF ((IX .LT. 1) .OR. (IX .GT. NCOL)) GO TO 3051
         I = MIDDLE + (IX-JX)
         DO 3050 J=1,NBOX
            K = JCYLN(J)
            IF (SKIP(I,J)) GO TO 3050
            IF (HEIGHT .LT. H(IX,K)) GO TO 3300
 3050    CONTINUE
 3051 CONTINUE
C
C The brightness enhancement of this pixel is now confirmed to be above
C the threshold, and to be larger than in any other pixel within a
C radius of 1.5 sigma.
C
C Now we derive the shape indices.  First, is the object much more
C sharply peaked than the input FWHM?  Compare the central pixel to
C the mean of the surrounding (non-bad) pixels.  If this difference is
C greater than the originally estimated height of the Gaussian or less
C than two-tenths the height of the Gaussian, reject the star
C (assuming SHRPLO and SHRPHI have the default values of 0.2 and
C 1.0; otherwise, muta mutandis.)
C
C
C ********** IF THE CENTRAL PIXEL IS BAD SKIP THIS TEST. **********
C
C
CD     TYPE *, JX, JY
CD     DO 1666 J=1,NBOX
CD1666 TYPE 6661, (JNINT(D(I,JCYLN(J))),
CD    .     I=MAX0(1,JX-NHALF),MIN0(NCOL,IX+NHALF)),
CD    .     (JNINT(H(I,JCYLN(J))), I=IX-NHALF,IX+NHALF)
CD6661 FORMAT(1X, <NBOX>I6, 1X, <NBOX>I6)
C
C As one final nuance, for this and subsequent calculations I propose
C to subtract off the modal sky level.  Otherwise, for faint stars on
C bright backgrounds in large boxes, it is barely possible that
C truncation error could affect the numerical results of the analysis.
C
      SHARP=0.
      DATUM=D(JX,JCYLN(MIDDLE))
      IF ((DATUM .LT. LOBAD) .OR. (DATUM .GT. HIBAD)) GO TO 3068
      P=0.
      DO 3061 IX=JX-NHALF,JX+NHALF
      IF ((IX .LT. 1) .OR. (IX .GT. NCOL)) GO TO 3061
         I = MIDDLE + (JX-IX)
         TEMP = 0.0
         DO 3060 J=1,NBOX
            K=JCYLN(J)
            IF (SKIP(I,J)) GO TO 3060
            DATUM=D(IX,K)
            IF ((DATUM .GE. LOBAD) .AND. (DATUM .LE. HIBAD)) THEN
               TEMP = TEMP+(DATUM-SKYMOD)
               P = P + 1.
            END IF
 3060    CONTINUE
         SHARP = SHARP+TEMP
 3061 CONTINUE
C
      SHARP=(D(JX,JCYLN(MIDDLE))-SKYMOD-SHARP/P)/HEIGHT
CD     TYPE *, ' SHARP= ', SHARP
      IF ((SHARP .LT. SHRPLO) .OR. (SHARP .GT. SHRPHI)) GO TO 3200
 3068 CONTINUE
C
C Now check to see whether the object is strongly elongated either
C along the row or along the column.  Compute the height of a Gaussian
C function of x and a Gaussian function of y by least-squares fits to
C the marginal distributions of the image data.  That is, fit the
C sum over y of the actual brightness values to the sum over y of the
C values of the array G, as functions of x.  If a bad pixel is found
C omit both the picture datum and the value of G for that pixel from
C their respective sums.  If the computed height of either the
C x-marginal or the y-marginal is non-positive, or if the central
C heights of the two marginals differ by more than their average
C (assuming that RNDLO and RNDHI have their default values
C of -1.0 and 1.0; otherwise, etc.), reject the star.
C
C We will now compute the height of the one-dimensional Gaussian
C distribution which best fits the x-marginal distribution of the
C brightness.  The equation which will be used will be the same as
C in the comments above ( h = ...) except that the symbol D in the
C equation now represents stands for the brightness data in the NBOX by
C NBOX square array summed over the y spatial direction, and the
C symbol G now stands for a one-dimensional Gaussian function (= the
C two-dimensional function G(i,j) also summed over the y spatial
C direction.  This sum is actually carried out numerically, rather
C than being done analytically, in order to permit the omission of
C "bad" pixels.)  At the same time, we will set up the necessary sums
C to permit the computation of a first-order correction to the centroid
C of the Gaussian profile in x:
C
C                -[G'*(D-G)]          [G*G']-[D*G']
C Delta x = -------------------- = -------------------,
C            [G'**2] - [G']**2/n   [G'**2] - [G']**2/n
C
C where G is the one-dimensional Gaussian profile, G' = (dG/dx), and
C D = the summed actual image data.  (There would normally be a
C [G']*[(D-G)]/n term in the numerator, but because G is already the
C "best fitting" Gaussian, [(D-G)] = 0.)  We will use
C
C SD      for the marginal sum of the actual image data
C                    (mnemonic:  "temporary sum of the data")
C SG      for the marginal sum of the 2-D Gaussian function
C                               ("temporary sum of the Gaussian")
C SUMGD   for [G*D]             ("sum of the Gaussian times the data")
C SUMG    for [G]               ("sum of the Gaussian")
C SUMD    for [D]               ("sum of the data")
C SUMGSQ  for [G**2]            ("sum of the Gaussian squared")
C SDGDX   for [G']              ("sum of d(Gaussian)/dx")
C SDGDXS  for [G'**2]           ("sum of {d(Gaussian)/dx}**2")
C SDDGDX  for [D*G']            ("sum of data times d(Gaussian)/dx")
C SGDGDX  for [G*G']            ("sum of Gaussian times d(Gaussian)/dx")
C
C In addition, for these calculations, pixels will arbitrarily be
C assigned weights ranging from unity at the corners of the box to
C MIDDLE**2 at the center (e.g. if NBOX = 5 or 7, the weights will be
C
C                                 1   2   3   4   3   2   1
C      1   2   3   2   1          2   4   6   8   6   4   2
C      2   4   6   4   2          3   6   9  12   9   6   3
C      3   6   9   6   3          4   8  12  16  12   8   4
C      2   4   6   4   2          3   6   9  12   9   6   3
C      1   2   3   2   1          2   4   6   8   6   4   2
C                                 1   2   3   4   3   2   1
C
C respectively).  This is done to desensitize the derived parameters to
C possible neighboring, brighter stars.
C
C The temporary variable P will be used to accumulate the sum of the
C weights, and N will count the number of points in the marginal
C distribution that actually get used.
C
C SKIP ALL THIS IF THE STAR IS TOO NEAR THE EDGE OF THE FRAME!
C
      IF ((JX .LT. MIDDLE) .OR. (JX .GT. LASTCL) .OR.
     .     (JY .LT. MIDDLE) .OR. (JY .GT. LASTRO)) THEN
         XCEN = REAL(JX)
         YCEN = REAL(JY)
         ROUND = 0.
         GO TO 3190
      END IF
C
      IX = JX-MIDDLE
C
      SUMGD=0.0
      SUMGSQ=0.0
      SUMG=0.0
      SUMD=0.0
      SDGDX=0.0
      SDGDXS=0.0
      SDDGDX=0.0
      SGDGDX=0.0
      P=0.
      N=0
      DO 3073 I=1,NBOX
         SG=0.
         SD=0.
         KX = IX+I
         DO 3070 J=1,NBOX
            WT=FLOAT(MIDDLE-ABS(J-MIDDLE))
            K=JCYLN(J)
            DATUM=D(KX,K)
            IF ((DATUM .GE. LOBAD) .AND. (DATUM .LE. HIBAD)) THEN
               SD=SD+(DATUM-SKYMOD)*WT
               SG=SG+G(I,J)*WT
            END IF
 3070    CONTINUE
         IF (SG .GT. 0.0) THEN
            WT=FLOAT(MIDDLE-ABS(I-MIDDLE))
            SUMGD=SUMGD+WT*SG*SD
            SUMGSQ=SUMGSQ+WT*SG**2
            SUMG=SUMG+WT*SG
            SUMD=SUMD+WT*SD
            P=P+WT
            N=N+1
            DGDX=SG*(MIDDLE-I)
            SDGDXS=SDGDXS+WT*DGDX**2
            SDGDX=SDGDX+WT*DGDX
            SDDGDX=SDDGDX+WT*SD*DGDX
            SGDGDX=SGDGDX+WT*SG*DGDX
         END IF
 3073 CONTINUE
C
C We need at least three points to estimate the height and position
C of the star, and the local sky brightness.
C
      IF (N .LE. 2) GO TO 3200
      HX=(SUMGD-SUMG*SUMD/P)/(SUMGSQ-(SUMG**2)/P)
C
C DX is the height of the best-fitting marginal Gaussian.  If this is
C non-positive, this is not an acceptable star.
C
      IF (HX .LE. 0.) GO TO 3200
C
C Compute the first-order correction to the x-centroid of the star.
C Note that a factor of HX/SIGSQ is missing from SDGDX, SDDGDX, and
C SGDGDX, and a factor of (HX/SIGSQ)**2 is missing from SDGDXS.
C
      SKYLVL=(SUMD-HX*SUMG)/P
      DX=(SGDGDX-(SDDGDX-SDGDX*(HX*SUMG+SKYLVL*P)))/(HX*SDGDXS/SIGSQ)
      XCEN=JX+DX/(1.+ABS(DX))
C
C If the best estimate of the star's center falls outside the image,
C reject it.
C
      IF ((XCEN .LT. 0.5) .OR. (XCEN .GT. NCOL+0.5)) GO TO 3200
C
C Compute the height of the y-marginal Gaussian distribution.
C
      SUMGD=0.
      SUMGSQ=0.
      SUMG=0.
      SUMD=0.
      SDGDX=0.
      SDGDXS=0.
      SDDGDX=0.
      SGDGDX=0.
      P=0.
      N=0
      DO 3078 J=1,NBOX
         K=JCYLN(J)
         SG=0.
         SD=0.
         DO 3076 I=1,NBOX
            WT=FLOAT(MIDDLE-ABS(I-MIDDLE))
            KX=IX+I
            DATUM=D(KX,K)
            IF ((DATUM .GE. LOBAD) .AND. (DATUM .LE. HIBAD)) THEN
               SD=SD+(DATUM-SKYMOD)*WT
               SG=SG+G(I,J)*WT
            END IF
 3076    CONTINUE
C
         IF (SG .GT. 0.0) THEN
            WT=FLOAT(MIDDLE-ABS(J-MIDDLE))
            SUMGD=SUMGD+WT*SG*SD
            SUMGSQ=SUMGSQ+WT*SG**2
            SUMG=SUMG+WT*SG
            SUMD=SUMD+WT*SD
            P=P+WT
            DGDX=SG*(MIDDLE-J)
            SDGDX=SDGDX+WT*DGDX
            SDGDXS=SDGDXS+WT*DGDX**2
            SDDGDX=SDDGDX+WT*SD*DGDX
            SGDGDX=SGDGDX+WT*SG*DGDX
            N=N+1
         END IF
C
 3078 CONTINUE
C
      IF (N .LE. 2) GO TO 3200
      HY=(SUMGD-SUMG*SUMD/P)/(SUMGSQ-(SUMG**2)/P)
      IF (HY .LE. 0.0) GO TO 3200
      SKYLVL=(SUMD-HY*SUMG)/P
      DY=(SGDGDX-(SDDGDX-SDGDX*(HY*SUMG+SKYLVL*P)))/(HY*SDGDXS/SIGSQ)
      YCEN=JY+DY/(1.+ABS(DY))
      IF ((YCEN .LT. 0.5) .OR. (YCEN .GT. NROW+0.5)) GO TO 3200
C
      ROUND=2.*(HX-HY)/(HX+HY)
CD     TYPE *, ' ROUND= ', ROUND
      IF ((ROUND .LT. RNDLO) .OR. (ROUND .GT. RNDHI)) GO TO 3200
C
C The fully verified and located star may now be dignified with its own
C ID number.
C
 3190 NSTAR=NSTAR+1
      HEIGHT=-2.5*ALOG10(HEIGHT/HMIN)
      IF (WATCH .GT. 0.5) WRITE (6,631) NSTAR, XCEN, YCEN, HEIGHT,
     .     SHARP, ROUND
  631 FORMAT(12X, I5, 2F7.1, F9.1, 2F9.2)
      WRITE (3,330) NSTAR, XCEN, YCEN, HEIGHT, SHARP, ROUND
  330 FORMAT(I6, 14F9.3)
 3200 CONTINUE
C
C If the sieve above (between statements 3040 and 3050) has detected a
C local maximum in the brightness enhancement, whether this enhancement
C was subsequently confirmed to be a star or not, then there is no need
C to check the other pixels in this row between JX+1 and JX+NHALF,
C inclusive, since we know there can't be a local maximum there.
C
      JX = JX+NHALF
 3300 JX = JX+1
C
C Have we passed the last pixel in the row?  If not, work on this
C pixel.  If so, go to next row.
C
      IF (JX .LE. NCOL) GO TO 3040
      GO TO 3020
C
C-----------------------------------------------------------------------
C
C SECTION 4
C
C Find out whether the user is happy.  If so, delete the scratch picture
C and close up shop.  If not, return to the beginning of Section 3.
C
 4000 IF (WATCH .LE. 0.5) WRITE (6,640) NSTAR
  640 FORMAT(//1X, I5, ' stars.')
      CALL CLFILE (3)
      CALL TBLANK                                    ! Type a blank line
      CALL TBLANK                                    ! Type a blank line
      CALL GETYN ('Are you happy with this?', ANSWER)
      IF ((ANSWER .EQ. 'Y') .OR. (ANSWER .EQ. 'E')) GO TO 9000
      WRITE (6,642) OPT(6), HMIN
  642 FORMAT(/' Your old threshold was', F8.2, ' sigma =',
     .     F8.2, ' ADU.'/)
      CALL GETDAT ('New threshold (in sigmas):', OPT(6), 1)
      IF (HMIN .LT. -1.E38) GO TO 9000              ! CTRL-Z was entered
 4030 CALL GETNAM ('Output file name:', COOFIL)
      IF ((COOFIL .EQ. 'END OF FILE') .OR.
     .     (COOFIL .EQ. 'GIVE UP')) THEN
         COOFIL = ' '
         GO TO 9000
      END IF
      COOFIL = EXTEND(COOFIL, CASE('coo'))
      CALL OUTFIL (3, COOFIL, ISTAT)
      IF (ISTAT .NE. 0) THEN
         CALL STUPID ('Error opening output file '//COOFIL)
         COOFIL = 'GIVE UP'
         GO TO 4030
      END IF
      HMIN = SQRT(READNS**2 + AMAX1(0.,SKYMOD)/PHPADU)
      HMIN = OPT(6)*RELERR*HMIN
      GO TO 3000
C
C-----------------------------------------------------------------------
C
C Normal return.
C
 9000 CONTINUE
      CALL CLPIC ('COPY')
      CALL DELPIC (CONPIC, ISTAT)
      RETURN
      END!

C @(#)user09.for	19.1 (ES0-DMD) 02/25/03 13:17:46
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE USER09(IND,X,NP,PARAM,Y1,DERIV)                                
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                 
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,                  
C                                         all rights reserved                   
C                                                                               
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  16:03 - 20 DEC 1987                 
C                                                                               
C.LANGUAGE: F77+ESOext                                                          
C                                                                               
C.AUTHOR: J.D.Ponz                                                              
C                                                                               
C--------------------------------------------------------------                 
C                                                                               
C NULL ROUTINE                                                                  
C      IMPLICIT NONE                                                            
C                                                                               
      INTEGER I,NP,IND,ISTAT
      DOUBLE PRECISION Y1,PARAM(NP),DERIV(NP)                                   
      REAL X(1)                                                                 
                                                                                
      Y1     = 0.D0                                                             
      DO 10 I = 1,NP                                                           
          DERIV(I) = 0.D0                                                      
   10 CONTINUE                                                                 
      CALL STTPUT('Sorry but I am a dummy user09 routine...',ISTAT)
      CALL STSEPI

      RETURN                                                                    
                                                                                
      END                                                                       

C @(#)dclist.for	19.1 (ES0-DMD) 02/25/03 14:32:27
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT     (c)   1989   European Southern Observatory
C.IDENT         dclist.for
C.LANGUAGE      VAX/VMS FORTRAN-77
C.AUTHOR        Preben Grosbol,  ESO/IPG
C.KEYWORDS      decoding, list of numbers
C.COMMENT       Routines for decoding and accessing list of numbers
C               given as a MIDAS 'list'.
C.VERSION       1.0    1989-Mar-11 : Creation,   PJG
C------------------------------------------------------------------------
      INTEGER FUNCTION  DEFLIST(LIST)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.PURPOSE       decode string with MIDAS 'list' specification and initiate
C               internal list structure.
C.RETURN        status, 0: OK, -1:invalid list, 1: list too long
C------------------------------------------------------------------------
      PARAMETER   (MXLIST=64)
C
      INTEGER     LNO
      INTEGER     NOF(MXLIST),NOL(MXLIST)
C
      CHARACTER*(*)   LIST
      LOGICAL         LDIG
      INTEGER         L,N,LL
C
      COMMON /LIST/LNO,NOF,NOL
C
C     RESET LISTS
C
      LNO = -1
      DO 100, N = 1,MXLIST
         NOF(N) = -1
         NOL(N) = -1
  100 CONTINUE
      DEFLIST = 0
C
C     GET LENGTH OF STRING - ERROR IF NULL
C
      LL = INDEX(LIST,' ') - 1
      IF (LL.LT.1) THEN
         DEFLIST = -1
         RETURN
      ENDIF
C
C     CHECK SPECIAL CASE '*' I.E. ALL NUMBERS 1 TO 9999
C
      IF (LIST(1:1).EQ.'*') THEN
         IF (LL.GT.1) THEN
            DEFLIST = -1
            RETURN
         ENDIF
         NOF(1) = 1
         NOL(1) = 9999
         LNO = 1
         RETURN
      ENDIF
C
C     GO THROUGH LIST AND DECODE IT
C
      N = 0
      L = 1
      LDIG = .FALSE.
      DO 200, I = 1,LL
         IF (LIST(I:I).EQ.','.AND.LDIG) THEN
            IF (NOF(L).LT.0) NOF(L) = N
            IF (N.LT.NOF(L)) THEN
               NOL(L) = NOF(L)
            ELSE
               NOL(L) = N
            ENDIF
            L = L + 1
            IF (MXLIST.LT.L) THEN
               DEFLIST = 1
               LNO = 1
               RETURN
            ENDIF
         ELSE IF (LIST(I:I).EQ.'-'.AND.LDIG) THEN
            NOF(L) = N
         ELSE IF (LIST(I:I).EQ.'.') THEN
            IF (LIST(I-1:I-1).EQ.'.') GOTO 200
            IF (LIST(I+1:I+1).NE.'.'.OR..NOT.LDIG) THEN
               DEFLIST = -1
               RETURN
            ENDIF
            NOF(L) = N
         ELSE IF (LIST(I:I).LT.'0'.OR.'9'.LT.LIST(I:I)) THEN
               DEFLIST = -1
               RETURN
         ENDIF
C
C     CHECK IF NEXT CHARACTER IS A DIGIT
C
         LDIG = '0'.LE.LIST(I:I) .AND. LIST(I:I).LE.'9'
         IF (LDIG) THEN
            N = 10*N + ICHAR(LIST(I:I)) - ICHAR('0')
         ELSE
            N = 0
         ENDIF
  200 CONTINUE
C
C     CHECK IF SINGLE NO. IN RANGE
C
      IF (LDIG) THEN
         IF (NOF(L).LT.0) NOF(L) = N
         IF (N.LT.NOF(L)) THEN
            NOL(L) = NOF(L)
         ELSE
            NOL(L) = N
         ENDIF
      ELSE
         DEFLIST = -1
         RETURN
      ENDIF
C
C     NORMAL RETURN
C
      LNO = 1
      RETURN
      END
C-----------------------------------------------------------------------
      INTEGER FUNCTION GETLIST(NO)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.PURPOSE       get next no. in list previously defined. The no. is
C               return through the parameter.
C.RETURN        status, 1:valid no., 0:no number return
C------------------------------------------------------------------------
      PARAMETER   (MXLIST=64)
C
      INTEGER     NO
C
      INTEGER     LNO
      INTEGER     NOF(MXLIST),NOL(MXLIST)
C
      COMMON /LIST/LNO,NOF,NOL
C
C     CHECK IF THERE ARE MORE NUMBERS IN LIST
C
      GETLIST = 0
      IF (LNO.LT.0) RETURN
      IF (NOF(LNO).LT.0) THEN
         LNO = -1
         RETURN
      ENDIF
C
C     GET NEXT NUMBER AND UPDATE LIST
C
      NO = NOF(LNO)
      NOF(LNO) = NOF(LNO) + 1
      IF (NOL(LNO).LT.NOF(LNO)) THEN
         NOF(LNO) = -1
         LNO = LNO + 1
         IF (MXLIST.LE.LNO) LNO = -1
      ENDIF
      GETLIST = 1
      RETURN
      END

C @(#)vmsdaosubs.for	19.1 (ES0-DMD) 02/25/03 13:23:51
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C
C VMS-specific routines, mostly for ASCII input and output.
C
C Peter B. Stetson                      1991 April 18
C
C#######################################################################
C
      SUBROUTINE  INFILE (LUN, FILE, IFLAG)
      IMPLICIT    NONE
C
C=======================================================================
C
C VAX/VMS FORTRAN-specific subroutine to open a sequential disk data
C file for reading.
C
C Input arguments
C
C IFILE  is the logical unit number to be used.
C
C  FILE  is the filename.
C
C Output argument
C
C IFLAG  is an error flag: = 0 if no problem; = -1 if the file could 
C        not be opened.
C
C=======================================================================
C
      CHARACTER*30 FILE
      INTEGER      LUN
      INTEGER      IFLAG
C
C-----------------------------------------------------------------------
C
      OPEN (LUN, FILE=FILE, STATUS='OLD', ERR=9100, READONLY)
      IFLAG=0
      RETURN                                             ! Normal return
C
C-----------------------------------------------------------------------
C
C Error
C
 9100 IFLAG=-1
      RETURN
      END!
C
C#######################################################################
C
      SUBROUTINE  OUTFIL (LUN, FILE, ISTAT)
      IMPLICIT    NONE
C
C=======================================================================
C
C VAX/VMS FORTRAN-specific subroutine to open a sequential disk data
C file for writing.
C
C Input arguments
C
C   LUN  is the logical unit number to be used.
C  FILE  is the filename
C
C=======================================================================
C
      CHARACTER*30 FILE
      INTEGER      LUN
      INTEGER      ISTAT
C
      OPEN (LUN, FILE=FILE, STATUS='NEW', CARRIAGECONTROL='FORTRAN')
      ISTAT = 0
      RETURN
      END!
C
C#######################################################################
C
      SUBROUTINE  CLFILE (IFILE)
      IMPLICIT NONE
C=======================================================================
C
C VAX/VMS FORTRAN-specific subroutine to close a sequential disk data
C file.
C
C Input argument
C
C IFILE  is the logical unit number.
C
C=======================================================================
      INTEGER  IFILE
C
      CLOSE (IFILE)
      RETURN
      END!
C
C#######################################################################
C
      CHARACTER*(*) FUNCTION CASE (STRING)
      CHARACTER*(*) STRING
      INTEGER       LS
      INTEGER       LC
      INTEGER       I
      INTEGER       J
C=========================================================================
C
C For VMS, force lower-case letters to upper case.
C
      LS = LEN(STRING)
      LC = LEN(CASE)
      DO I=1,MIN(LC,LS)
         J = ICHAR(STRING(I:I))
         IF ((J .GE. 97) .AND. (J .LE. 122)) THEN
            J = J-32
            CASE(I:I) = CHAR(J)
         ELSE
            CASE(I:I) = STRING(I:I)
         END IF
      END DO
      IF (LC .GT. LS) CASE(LS+1:LC) = ' '
      RETURN
      END!
C
C#######################################################################
C
      SUBROUTINE OVRWRT (LINE, IWHICH)
      IMPLICIT   NONE
      CHARACTER*(*) LINE
      INTEGER       IWHICH
C
      IF (IWHICH .EQ. 1) THEN
C
C Do not overwrite anything.  Do not allow to be overwritten by forcing
C an extra carriage return.
C        
         WRITE (6,1) LINE
    1    FORMAT (' ', A/)
      ELSE IF (IWHICH .EQ. 2) THEN
C
C Overwrite.  Allow to be overwritten.
C
         WRITE (6,2) LINE
    2    FORMAT ('+', A)
      ELSE IF (IWHICH .EQ. 3) THEN
C
C Overwrite, but do not allow to be overwritten.
C
         WRITE (6,3) LINE
    3    FORMAT ('+', A/)
      ELSE
C
C Do not overwrite, but allow to be overwritten
C
         WRITE (6,4) LINE
    4    FORMAT (' ', A)
      END IF
      RETURN
      END!
C
C#######################################################################
C
      SUBROUTINE  BYEBYE
      IMPLICIT   NONE
      WRITE (6,6)
    6 FORMAT (/' Goodbye.'/)
      CALL EXIT
      END!
C
C#######################################################################
C
      SUBROUTINE  OOPS
      IMPLICIT   NONE
      WRITE (6,6)
    6 FORMAT (/' Sorry about that.'/)
      CALL EXIT
      END!
C
C#######################################################################
C
      SUBROUTINE FABORT
      IMPLICIT   NONE
C
C Dummy subroutine --- needed on Suns.
C
      RETURN
      END!

C @(#)iii.for	19.1 (ES0-DMD) 02/25/03 13:55:32
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE 
     +  IIIENI(DSPLAY,INTTYP,INTID,OBJTYP,OBJID,INTOP,EXTRIG,IDST)
C	
C
      IMPLICIT NONE
C	
      INTEGER   DSPLAY,INTTYP,INTID,OBJTYP,OBJID
      INTEGER   INTOP,EXTRIG,IDST
C 
      IDST = 0
C 
      RETURN
      END
C 
C 
C -----------------------------------------------------------------
C 
C 
      SUBROUTINE IIIEIW(DSPLAY,TRIGST,IDST)
C	
      IMPLICIT NONE
C	
      INTEGER   DSPLAY,TRIGST(1),IDST
C 
      IDST = 0
      RETURN
      END
C
C 
C -----------------------------------------------------------------
C 
      SUBROUTINE IIISTI(DSPLAY,IDST)
C	
      IMPLICIT NONE
C	
      INTEGER   DSPLAY,IDST
C 
      IDST = 0
C 
      RETURN
      END
C 
C 
C -----------------------------------------------------------------
C 
C 
      SUBROUTINE IIIQID(DSPLAY,INTTYP,INTID,DEVDSC,LL,IDST)
C
      IMPLICIT NONE
C 
      INTEGER   DSPLAY,INTTYP,INTID,LL,IDST
C	
      CHARACTER*(*)  DEVDSC
C 
      IDST = 0
C 
      RETURN
      END
C 
C -----------------------------------------------------------------
C 
      SUBROUTINE IIIGLD(DSPLAY,LOCNO,JX,JY,IDST)
C
      IMPLICIT NONE
C	
      INTEGER   DSPLAY,LOCNO,JX,JY,IDST
C 
      IDST = 0
C 
      RETURN
      END
C 
C 
C -----------------------------------------------------------------
C 
C 
      SUBROUTINE IIIGLE(DSPLAY,EVAL,JJ,IDST)
C 
      IMPLICIT NONE
C 
      INTEGER      DSPLAY,EVAL,JJ,IDST
C 
      IDST = 0
C 
      RETURN
      END
C 
C -----------------------------------------------------------------
C 
      SUBROUTINE IIIGSE(DSPLAY,EVAL,KSTR,JJ,IDST)
C 
      IMPLICIT NONE
C 
      INTEGER      DSPLAY,EVAL,JJ,IDST
C 
      CHARACTER*(*)    KSTR
C 
      IDST = 0
C 
      RETURN
      END
C 
C -----------------------------------------------------------------
C 
      SUBROUTINE IIIGCE(DSPLAY,EVAL,KSTR,IDST)
C 
      IMPLICIT NONE
C 
      INTEGER      DSPLAY,EVAL,IDST
C 
      CHARACTER*(*)    KSTR
C 
      IDST = 0
C 
      RETURN
      END

C===========================================================================
C Copyright (C) 1995-2006 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C     This FORTRAN code is in the file named "ftoc_commff.for"
C
C.VERSION
C 060322		last modif
C 
C
      SUBROUTINE RTST(A,SIZE,STAT)
      REAL   A(*)
      INTEGER  SIZE,STAT
C
      STAT = 0
C 
C  1st element was set to 77.7 in C routine fmap_
      IF ((A(1).LT.76.699) .OR. (A(1).GT.77.701)) THEN
         write(*,123) a(1)
123      format('a(1) = ',f9.4)
         STAT = -888
         RETURN
      ENDIF
C 
      A(2) = 66.6
      A(SIZE) = 99.9
C 
      IF ((A(2).LT.66.5999) .OR. (A(2).GT.66.6001)) THEN
         STAT = -999
      ENDIF
C 
      RETURN
      END

C @(#)iic.for	19.1 (ES0-DMD) 02/25/03 13:55:00
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE IICINC(DSPLAY,CHAN,CURSNO,SHAPE,COLOUR,XC,YC,IDST)
C
      IMPLICIT NONE
C	
      INTEGER   DSPLAY,CHAN,CURSNO,SHAPE,COLOUR,XC,YC,IDST
C 
      INCLUDE   'MID_INCLUDE:IDIDEV.INC'
C 
      IF (IDINUM.EQ.0) THEN
         CALL GD8029(DSPLAY,CHAN,CURSNO,SHAPE,COLOUR,XC,YC,IDST)
      ELSE IF (IDINUM.EQ.10) THEN
         CALL MXW029(DSPLAY,CHAN,CURSNO,SHAPE,COLOUR,XC,YC,IDST)
      ELSE
         IDST = 0
      ENDIF
C	
      RETURN
      END
C 
C 
C -----------------------------------------------------------------
C 
C 
      SUBROUTINE IICSCV(DSPLAY,CURSNO,VIS,IDST)
C
      IMPLICIT NONE
C	
      INTEGER   DSPLAY,CURSNO,VIS,IDST
C 
      INCLUDE   'MID_INCLUDE:IDIDEV.INC'
C 
      IF (IDINUM.EQ.0) THEN
         CALL GD8030(DSPLAY,CURSNO,VIS,IDST)
      ELSE IF (IDINUM.EQ.10) THEN
         CALL MXW030(DSPLAY,CURSNO,VIS,IDST)
      ELSE
         IDST = 0
      ENDIF
C	
      RETURN
      END

      SUBROUTINE IICWCP(DSPLAY,CHAN,CURSNO,XC,YC,IDST)
C
      IMPLICIT NONE
C	
      INTEGER   DSPLAY,CHAN,CURSNO,XC,YC,IDST
C 
      INCLUDE   'MID_INCLUDE:IDIDEV.INC'
C 
      IF (IDINUM.EQ.0) THEN
         CALL GD8032(DSPLAY,CHAN,CURSNO,XC,YC,IDST)
      ELSE IF (IDINUM.EQ.10) THEN
         CALL MXW032(DSPLAY,CHAN,CURSNO,XC,YC,IDST)
      ELSE
         IDST = 0
      ENDIF
C	
      RETURN
      END
C 
C 
C -----------------------------------------------------------------
C 
C 
      SUBROUTINE IICRCP(DSPLAY,CHAN,CURSNO,XC,YC,MEMO,IDST)
C
      IMPLICIT NONE
C	
      INTEGER   DSPLAY,CHAN,CURSNO,XC,YC,MEMO,IDST
C 
      INCLUDE   'MID_INCLUDE:IDIDEV.INC'
C 
      IF (IDINUM.EQ.0) THEN
         CALL GD8031(DSPLAY,CHAN,CURSNO,XC,YC,MEMO,IDST)
      ELSE IF (IDINUM.EQ.10) THEN
         CALL MXW031(DSPLAY,CHAN,CURSNO,XC,YC,MEMO,IDST)
      ELSE
         IDST = 0
      ENDIF
C	
      RETURN
      END

C @(#)newobj.for	19.1 (ES0-DMD) 02/25/03 13:25:36
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.IDENTIFICATION
C  subroutine NEWOBJ         version 1         820624
C  A. Kruszewski             ESO Garching
C  modified for FX           version 1.1       870303
C  A. Kruszewski             Obs. de Geneve
C.PURPOSE
C  adds new objects detected by subroutine "PRANLZ" to a master list
C  of objects
C.INPUT/OUTPUT
C  input arguments
C  A           real*4 array      image frame
C  N1          integer*4         x-dimension of array A
C  N2          integer*4         y-dimension of array A
C  I           integer*4         x-position of object
C  J           integer*4         y-position of object
C  NCAT        integer*4 array   integer parameters of objects
C  PMTR        real*4 array      array holding objects' parameters
C  L           integer*4         identification number of an object
C  MM          integer*4         actual number of catalogued objects
C  TRSH        real*4            limiting threshold
C  ADLM        real*4            minimum acceptable separation
C                                between components in pixels
C  MCM         integer*4 array   array holding informations about
C                                new objects
C  output parameters
C  NCAT        integer*4 array   integer parameters of objects
C  PMTR        real*4 array      array holding objects' parameters
C  MM          integer*4         actual number of catalogued objects
C
C-----------------------------------------------------------------------
      SUBROUTINE NEWOBJ(A, JAPY, IBUF, I, J,
     &                  NREG, LSTP, NCAT, PMTR, PRCT,
     &                  L, L0, L1, LW, MM,
     &                  TRSH, ADLM, MCM)
C
      IMPLICIT  NONE
      INCLUDE   'MID_REL_INCL:INVENT.INC'
C
      REAL      A(1)
      INTEGER   JAPY(1)
      INTEGER   IBUF(4)
      INTEGER   I
      INTEGER   J
      INTEGER   NREG
      INTEGER   LSTP(0:4,0:NREG)
      INTEGER   NCAT(NIPAR,MAXCNT)
      REAL      PMTR(NRPAR,MAXCNT)
      REAL      PRCT(0:MAXSUB,MAXCNT)
      INTEGER   L
      INTEGER   L0
      INTEGER   L1
      INTEGER   LW
      INTEGER   MM
      REAL      TRSH
      REAL      ADLM
      INTEGER   MCM(21)
C
      INTEGER   ID(10)
      INTEGER   IDL, IDLM
      INTEGER   IDX, IDY
      INTEGER   II
      INTEGER   IL, IL1
      INTEGER   ILX, ILY
      INTEGER   IK, IK1, IK2
      INTEGER   JDLM
      INTEGER   JJ
      INTEGER   JK, JK1, JK2
      INTEGER   JOF
      INTEGER   K, KL , KL1
      INTEGER   LL, LZ
      INTEGER   LLX, LLY
      INTEGER   L1B, LWB, LACT, LAZ
      INTEGER   NI, NJ, NP
      INTEGER   MZ
      INTEGER   IXY(2,10)
      INTEGER   NCT(NIPAR) 
      INTEGER   NCT1(NIPAR)
C
      REAL      XOBJ, YOBJ
      REAL      XCMP, YCMP
      REAL      DIST
      REAL      SUM
      REAL      PMT(NRPAR)
      REAL      PMT1(NRPAR)
      REAL      PRC(0:MAXSUB) 
      REAL      PRC1(0:MAXSUB)
C
      LOGICAL   DONE
C
      NP = MAXCNT
      LZ = L - L0
      IDLM = MAX( 1 , NINT(ADLM)-1 )
      IDL = NINT(ADLM*ADLM)
      JDLM = NINT(ADLM) + 1
C
C *** Recall number of detected new objects KL.
C
      KL=MCM(1)
C
C *** Prepare blank arrays.
C
      IF ( MM+KL .GT. L0+NP ) THEN
          DO 5 K = 1 , NIPAR
              NCT(K) = 0
    5     CONTINUE
          DO 6 K = 1 , NRPAR
              PMT(K) = 0.0
    6     CONTINUE
          DO 7 K = 0 , MAXSUB
              PRC(K) = 0.0
    7     CONTINUE
      ENDIF
      DO 8 K = 1 , 10
          ID(K) = 0
    8 CONTINUE
C
C *** Form array with new objects coordinates.
C
      DO 10 IL = 1 , KL
          IXY(1,IL) = MCM(2*IL)
          IXY(2,IL) = MCM(2*IL+1)
   10 CONTINUE
C
C *** Mark existance of objects.
C
      DO 20 IL = 1 , KL
          ID(IL) = 1
   20 CONTINUE
C
C *** Parent object coordinates may be shifted.
C
      NI = I - NCAT(1,LZ)
      NJ = J - NCAT(2,LZ)
C
C *** Combine multiple detections.
C
      KL1 = KL - 1
      DO 30 IL = 1 , KL1
          IL1 = IL + 1
          DO 40 LL = IL1 , KL
              IDX = IXY(1,IL) - IXY(1,LL)
              IDY = IXY(2,IL) - IXY(2,LL)
              IF ( IDX*IDX+IDY*IDY .LT. IDL ) THEN
                  ILX = IXY(1,IL) + NI
                  ILY = IXY(2,IL) + NJ
                  LLX = IXY(1,LL) + NI
                  LLY = IXY(2,LL) + NJ
                  IF ( A(JAPY(LLY-IBUF(2)+1)+LLX) .GT.
     &                    A(JAPY(ILY-IBUF(2)+1)+ILX) ) THEN
                      ID(LL) = 0
                  ELSE
                      ID(IL) = 0
                  ENDIF
              ENDIF
   40     CONTINUE
   30 CONTINUE
C
C *** Look for already filed object closer than ADLM.
C
      DO 50 IL = 1 , KL
          IF ( ID(IL) .EQ. 1 ) THEN
C
C ***         Trial filing of a new object.
C
              L1B = L1
              LWB = LW
C              IF ( MM+1 .GT. L0 .AND. MM+1 .LE. L0+NP ) THEN
              L1 = MAX( L1 , MM+1 )
              NCAT(1,MM+1-L0) = IXY(1,IL)
              NCAT(2,MM+1-L0) = IXY(2,IL)
C              ELSE
C                  NCT(1) = IXY(1,IL)
C                  NCT(2) = IXY(2,IL)
C                  NCT(7) = 0
C                  NCT(8) = 0
C                  WRITE ( ISF , REC = MM+1 ) NCT , PMT , PRC
C                  LW = MAX( LW , MM+1 )
C              ENDIF
              CALL PUTLSS( MM+1 , NREG , LSTP , NCAT , PMTR , PRCT )
C              IF ( MM+1 .LE. L0 .OR. MM+1 .GT. L0+NP ) THEN
C                  READ ( ISF , REC = MM+1 ) NCT , PMT , PRC
C              ENDIF
C
C ***         Check if there is already another object closer than ADLM.
C
              LACT = 0
   72         CONTINUE
              CALL GETLST( MM+1 , L0 , L1 , JDLM , NREG , 
     &                     LSTP , NCAT , PMTR , PRCT , LACT ,
     &                     NCT1 , PMT1 , PRC1 , DONE )
              IF ( DONE ) THEN
                  XOBJ = FLOAT(IXY(1,IL))
                  YOBJ = FLOAT(IXY(2,IL))
C                  IF ( LACT .GT. L0 .AND. LACT .LE. L1 ) THEN
                      LAZ = LACT - L0
                      XCMP = PMTR(10,LAZ)
                      YCMP = PMTR(11,LAZ)
C                  ELSE
C                      XCMP = PMT1(10)
C                      YCMP = PMT1(11)
C                  ENDIF
                  DIST = SQRT( (XOBJ-XCMP)**2.0 + (YOBJ-YCMP)**2.0 )
                  IF ( DIST .LT. ADLM ) THEN
                      DONE = .TRUE.
                  ELSE
                      GOTO 72
                  ENDIF
              ENDIF
              IF ( .NOT. DONE ) THEN
C 
C ***             Catalogue new object.
C
                  MM = MM + 1
C                  IF ( MM .GT. L0 .AND. MM .LE. L0+NP ) THEN
                      MZ = MM - L0
                      NCAT(1,MZ) = MCM(2*IL)
                      NCAT(2,MZ) = MCM(2*IL+1)
                      PMTR(10,MZ) = FLOAT(NCAT(1,MZ))
                      PMTR(11,MZ) = FLOAT(NCAT(2,MZ))
c                      NCAT(4,MZ) = 0
                      PMTR(1,MZ) = PMTR(1,LZ)
                      IK = NCAT(1,MZ) + NI
                      JK = NCAT(2,MZ) + NJ
                      IF ( IK .LE. IBUF(1) .OR. IK .GE. IBUF(3)
     &                                     .OR. JK .LE. IBUF(2)
     &                                     .OR. JK .GE. IBUF(4) ) THEN
                          PMTR(2,MZ) = 0.0
                          GOTO 71
                      ENDIF
                      SUM = 0.0
                      IK1 = IK - 1
                      IK2 = IK + 1
                      JK1 = JK - 1
                      JK2 = JK + 1
                      DO 60 JJ = JK1 , JK2
                          JOF = JAPY(JJ-IBUF(2)+1)
                          DO 70 II = IK1 , IK2
                              SUM = SUM + A(JOF+II)
   70                     CONTINUE
   60                 CONTINUE
                      PMTR(2,MZ) = SUM / 9.0 - PMTR(1,MZ)
   71                 CONTINUE
                      IF ( PMTR(2,MZ) .LT. TRSH ) THEN
                          CALL RMFLST( MM , L0 , L1 , NREG ,
     &                                 LSTP , NCAT ) 
                          MM = MM - 1
                          L1 = L1B
                          LW = LWB
                      ENDIF
C                  ELSE
C                      NCT(1) = MCM(2*IL)
C                      NCT(2) = MCM(2*IL+1)
C                      PMT(10) = FLOAT(NCT(1))
C                      PMT(11) = FLOAT(NCT(2))
C                      NCT(4) = 0
C                      PMT(1) = PMTR(1,LZ)
C                      IK = NCT(1) + NI
C                      JK = NCT(2) + NJ
C                      IF ( IK .LE. IBUF(1) .OR. IK .GE. IBUF(3)
C     &                                     .OR. JK .LE. IBUF(2)
C     &                                     .OR. JK .GE. IBUF(4) ) THEN
C                          PMT(2) = 0.0
C                          GOTO 91
C                      ENDIF
C                      SUM = 0.0
C                      IK1 = IK - 1
C                      IK2 = IK + 1
C                      JK1 = JK - 1
C                      JK2 = JK + 1
C                      DO 80 JJ = JK1 , JK2
C                          JOF = JAPY(JJ-IBUF(2)+1)
C                          DO 90 II = IK1 , IK2
C                              SUM = SUM + A(JOF+II)
C   90                     CONTINUE
C   80                 CONTINUE
C                      PMT(2) = SUM / 9.0 - PMT(1)
C   91                 CONTINUE
C                      IF ( PMT(2) .LT. TRSH ) THEN
C                          CALL RMFLST( ISF , MM , L0 , L1 , NREG ,
C     &                                 LSTP , NCAT ) 
C                          MM = MM - 1
C                          L1 = L1B
C                          LW = LWB
C                      ELSE
C                          WRITE ( ISF , REC=MM ) NCT , PMT , PRC
C                      ENDIF
C                  ENDIF
              ELSE
C
C ***             Remove back an added object from the list.
C
                  CALL RMFLST( MM+1 , L0 , L1 , NREG ,
     &                         LSTP , NCAT )
                  L1 = L1B
                  LW = LWB
              ENDIF
          ENDIF
   50 CONTINUE
C
      RETURN
C
      END
C

C===========================================================================
C Copyright (C) 1995-2005 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or
C modify it under the terms of the GNU General Public License as
C published by the Free Software Foundation; either version 2 of
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public
C License along with this program; if not, write to the Free
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C       Internet e-mail: midas@eso.org
C       Postal address: European Southern Observatory
C                       Data Management Division
C                       Karl-Schwarzschild-Strasse 2
C                       D 85748 Garching bei Muenchen
C                       GERMANY
C===========================================================================
      PROGRAM SMOOTH
C
C++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION
C  program SMOOTH			version 3.30	850729
C  K. Banse      			ESO - Garching
C
C.KEYWORDS
C  smoothing, average, median, template matching
C
C.PURPOSE
C  (1) filter an image with a Gaussian filter
C  (2) filter an image with a digital filter (given values)
C  (3) filter an image with a digital filter (kernel = another frame)
C  (4) smooth an image by a) averaging in the neighborhood
C                         b) taking the median in the neighbourhood
C  (5) expand an image
C  (6) filter an image with a maximum filter
C  (7) filter an image with a minimum filter	FILACT set to these values...
C
C.ALGORITHM
C  (1) get the radius in x and y + threshold for the averaging/median algorithm
C      from INPUTR and calculate new points via:
C      a) B(n) = SUM A(j), j in neighborhood of given radius around n, if
C         abs(SUM - A(n)) > abs(threshold*A(n)), else B(n) = A(n)
C         or if
C         abs(SUM - A(n)) > threshold , else B(n) = A(n)
C      b) B(n) = median of A(j), j in neighborhood of given radius around n, if
C         abs(median - A(n)) > abs(threshold*A(n)), else B(n) = A(n)
C         or if
C         abs(median - A(n)) > threshold , else B(n) = A(n)
C
C  (2) get the weights for the template from INPUTR or IN_B and calculate new
C      points via:
C      B(n) = SUM A(j)*W(l), j in neighborhood around n, l according to template
C      numbering: 1 ................ nw   (nw = 2*radius + 1)
C  	          nw+1 ........... 2*nw
C	          .....................
C	          (nw-1)*nw+1 ... nw*nw
C
C.INPUT/OUTPUT
C  the following keys are used:
C
C  IN_A/C/1/60          input frame
C  OUT_A/C/1/60         output frame
C  INPUTC/C/1/2         (1:1) = Y, include center pixel in calculation
C                  	      = N, do not include center pixel
C                  	(2:2) = A, use absolute threshold
C                  	      = R, use relative threshold with pixel value
C                  	      = Q, use rel. threshold with average/median value
C                  	      = F, use fixed threshold-interval
C                  	      = Z, use a+b*SQRT(median) as threshold
C  ACTION/C/1/5         (1:1) = A for averaging, M for median,
C				D for digital, G for Gaussian
C				K for maximum filter
C				L for minimum filter
C				E for just expanding the frame
C  			(2:2) = L for looping, N for not looping
C  			(3:3) = D for immediate display, N for no display
C  			(4:4) = E for expansion of input frame
C  			(5:5) = W for auxiliary window, N for not
C			(5:5) not implemented yet!
C  INPUTR/R/1/4         radius ( >0 )in x + y,
C                  	threshold(s) for averaging algorithm
C  INPUTC/C/3/60        area for filtering,
C			if set to +, complete frame is filtered
C                  	[...:...] or CURSOR or table_name
C  INPUTC/C/63/2        :x or :y to indicate that 1-dim digital filter
C  IN_B/C/1/60		name of filter image or template
C  INPUTR/R/1/40	for (2) weights of template
C			for (3) xmean,xsigma,ymean,ysigma
C  INPUTI/I/1/2		x-, y-radius for Gaussian filter image (must be odd)
C  INPUTI/I/1/4		xlef,xri,ylef,yri expansion pixels for EXPANSION
C 
C
C.VERSIONS
C  051014	last modif
C
C--------------------------------------------------
C
      IMPLICIT NONE
C
      INTEGER      AREAFL,IDUM(1),IAV,IOMODE
      INTEGER      MINSZX,MINSZY,FF,ZFLAG
      INTEGER      HIOFF,HOOFF,HISIZ,HOSIZ,HY,LINCO,REMAIN
      INTEGER*8    PNTRHI,PNTRHO,VPNTR
      INTEGER      HACK,RETBUF(3)
      INTEGER      N,NAXIS,NCOL,NMAL,NOPNTS,NROW,NWORK
      INTEGER      CHUNKI,CHUNKO,K1,K2
      INTEGER*8    PNTRA,PNTRC,PNTRI,PNTRO,PNTRX,PNTRY,FPNTR
      INTEGER      QPIX(2)
      INTEGER      STAT,STAT1,STAT2,SUBDIM,COOFF
      INTEGER      SUBPIX(2,2),SUBOFA(2),SUBOFB(2),RADIUS(2)
      INTEGER      SUBLO(3),SUBHI(3)
      INTEGER      ICUR1(2),ICUR2(2),LOADFL(2),CUTIDX,LOW(3)
      INTEGER      NPIX(3),TPIX(3),RESPIX(3),OPIX(2),KCOOR(4)
      INTEGER      IMNOA,IMNOC,IMNOI,IMNOO,IMNOX,FIMNO,IMNOEX
      INTEGER      TID,TBCLNM(4),ALL,TABNUL(4)
      INTEGER      FPIX(2),FILACT,KLOOP,DAZO,TRUNAX,HCOUNT
      INTEGER      FNAXIS,FSIZE,WW(4),OFFPIX,RESPLZ,INPLZ,COUNT3
      INTEGER      EXNPIX(3),EXBUF(4),OLDMAP,DEBUFL,EXPAZ,OFFEX
      INTEGER      UNIT(1),NULLO,MADRID(1)
C
      CHARACTER*60   FRAMEA,FRAMEC,FRAME,TABLE,ERMES3
      CHARACTER      CUNIT*64,IDENT*72,CBUF*80,ACTION*5,DEFAUL*2
      CHARACTER      TLABL(4)*16,CAREA*60,XYCH(2)*1,MIDUNI*2
      CHARACTER      TMPFIL*14,CACT*8
C
      DOUBLE PRECISION STEP(3),START(3),EXSTA(3)
      DOUBLE PRECISION FSTART(2),FSTEP(2)
C 
      REAL         INPUTR(40),RMIN,RMAX
      REAL         PCUR1(6),PCUR2(6)
      REAL         RDUM(1),KUTS(4),CUTS(4),RBUF(17)
      REAL         DGFIL1(9),DGFIL2(9),DGFIL3(9),DGFIL4(9)
      REAL         DGFIL5(9),DGFIL6(9),DGFIL7(25),DGFIL8(25)
C
      LOGICAL      SELFLG
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C 
      INCLUDE  'MID_INCLUDE:IDIDEV.INC'
      INCLUDE  'MID_INCLUDE:IDIMEM.INC'
C 
      COMMON   /VMR/ MADRID
C
      DATA    SUBLO    /3*1/,     SUBHI  /3*1/
      DATA    TPIX     /3*1/,     LOW    /3*1/
      DATA    NPIX     /3*1/,     KCOOR  /-1,-1,-1,-1/
      DATA    RESPIX   /3*1/,     KUTS   /4*0.0/
      DATA    IDENT    /' '/,     CUNIT  /' '/
      DATA    KLOOP    /0/,       LOADFL /0,0/
      DATA    DAZO     /0/,       FIMNO  /-1/
      DATA    ACTION   /' '/,     COOFF  /0/
      DATA    EXNPIX   /1,1,1/,   EXSTA  /0.,0.,0./
      DATA    IMNOI    /-1/,      IMNOO  /-1/
      DATA    OLDMAP   /0/,       EXPAZ  /1/
      DATA    START    /3*0.D0/,  STEP   /3*1.D0/
C 
      DATA    ERMES3   /' both cursors are off, set one on ... '/
      DATA    TLABL    /'XSTART ','YSTART ','XEND ','YEND '/
      DATA    XYCH     /'x','y'/
      DATA    CACT     /'NYYY?C0 '/
C 
C  data for filters CONE, LAPLACE, LOW_PASS, POINT, CONE5:
      DATA    DGFIL1 /1.,-6.,1.,-6.,36.,-6.,1.,-6.,1./         !CONE
      DATA    DGFIL2 /0.,-1.,0.,-1.,5.,-1.,0.,-1.,0./          !LAPLACE
      DATA    DGFIL3 /1.,2.,1.,2.,5.,2.,1.,2.,1./              !LOW_PASS
      DATA    DGFIL4 /-1.,-2.,-1.,-2.,13.,-2.,-1.,-2.,-1./     !POINT
      DATA    DGFIL5 /1.,1.,1.,1.,8.,1.,1.,1.,1./              !TENT
      DATA    DGFIL6 /-1.,-2.,-1.,-2.,13.,-2.,-1.,-2.,-1./     !SHARP
      DATA    DGFIL7 /0.,0.,1.,0.,0.,0.,2.,2.,2.,0.,           !CONE5
     +                1.,2.,5.,2.,1.,0.,2.,2.,2.,0.,0.,0.,1.,0.,0./
      DATA    DGFIL8 /1.,2.,3.,2.,1.,2.,4.,6.,4.,2.,           !PYRAMID5
     +                3.,6.,9.,6.,3.,2.,4.,6.,4.,2.,1.,2.,3.,2.,1./
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C  set up MIDAS environment + get current MIDAS unit
      CALL STSPRO('SMOOTH')
      FILACT = 0
      AREAFL = 0
      OFFEX = 0
      INPLZ = 0
      RESPLZ = 0
      CALL STKRDC('MID$SESS',1,11,2,IAV,MIDUNI,UNIT,NULLO,STAT)
      TMPFIL(1:) = 'filt'//MIDUNI//'dum.bdf '
C
C  get method + special options and branch according to filter type
      CALL STKRDC('ACTION',1,1,5,IAV,ACTION,UNIT,NULLO,STAT)
      CALL UPCAS(ACTION,ACTION)
      IF (ACTION(2:2).EQ.'L') KLOOP = 1                 !update loop flag
      IF (ACTION(3:3).EQ.'D') LOADFL(1) = -99           !set display flag
      IF ((ACTION(4:4).EQ.'N') .AND.                    !clear expansion flag
     +    (LOADFL(1).NE.-99)) EXPAZ = 0                 !only if no display...
      CALL STKRDC('MID$SPEC',1,1,5,IAV,CAREA,UNIT,NULLO,STAT)
      IF (CAREA(1:5).EQ.'DEBUG') THEN
         DEBUFL = 1
      ELSE
         DEBUFL = 0
      ENDIF
C 
      FF = 0
      PNTRHI = -1                               !to know if it's first time
      IF (ACTION(1:1).EQ.'G') THEN                    !Gaussian
         CALL STKRDI('INPUTI',1,2,IAV,RADIUS,UNIT,NULLO,STAT)
         CALL STKRDR('INPUTR',1,4,IAV,INPUTR,UNIT,NULLO,STAT)
         CALL STKRDC('IN_B',1,1,60,IAV,FRAME,UNIT,NULLO,STAT)
         ZFLAG = 1                            !flag for routine TEMPLB
      ELSE IF (ACTION(1:1).EQ.'D') THEN               !digital
         CALL STKRDC('IN_B',1,1,60,IAV,FRAME,UNIT,NULLO,STAT)
         ZFLAG = 2  
      ELSE IF ((ACTION(1:1).EQ.'K') .OR. (ACTION(1:1).EQ.'L')) THEN
         CALL STKRDI('INPUTI',1,2,IAV,RADIUS,UNIT,NULLO,STAT)
         FILACT = 6
         IF (ACTION(1:1).EQ.'K') THEN
            ZFLAG = 3                            !maximum filter
         ELSE
            ZFLAG = 4                            !minimum filter
         ENDIF
      ELSE
         CALL STKRDC('INPUTC',1,1,2,IAV,DEFAUL,UNIT,NULLO,STAT)
         CALL UPCAS(DEFAUL,DEFAUL)
         IF ((DEFAUL(2:2).EQ.'F') .OR. (DEFAUL(2:2).EQ.'Z')) THEN
            CALL STKRDR('INPUTR',1,2,IAV,INPUTR,UNIT,NULLO,STAT)
            CALL STKRDC('P3',1,1,60,IAV,CBUF,UNIT,NULLO,STAT)
            N = INDEX(CBUF,',')
            CBUF(N:N) = ' '
            N = INDEX(CBUF,',') + 1               !skip over 2. comma
            CBUF(1:) = CBUF(N:)                   !shift to front
C 
            IF (DEFAUL(2:2).EQ.'Z') THEN
               CALL GENCNV(CBUF,2,2,IDUM,INPUTR(3),STEP,IAV)
               IF (IAV.LT.2) CALL STETER
     +                  (18,'Invalid syntax for threshold factors')
            ELSE
               IF (CBUF(1:1).EQ.'<') THEN
                  FF = 1
                  CALL GENCNV(CBUF(3:),2,1,IDUM,RDUM,STEP,IAV)
                  INPUTR(4) = RDUM(1)
               ELSE
                  CALL GENCNV(CBUF,2,1,IDUM,RDUM,STEP,IAV)
                  IF (IAV.LT.1) CALL STETER
     +                     (18,'Invalid syntax for interval limits')
                  INPUTR(3) = RDUM(1)
                  N = INDEX(CBUF,',') + 1
                  IF (CBUF(N:N) .EQ. '>') THEN
                     FF = 2
                  ELSE
                     CALL GENCNV(CBUF(N:),2,1,IDUM,RDUM,STEP,IAV)
                     INPUTR(4) = RDUM(1)
                  ENDIF
               ENDIF
               IF (IAV.LT.1) 
     +            CALL STETER(18,'Invalid syntax for interval limits')
            ENDIF
         ELSE
            CALL STKRDR('INPUTR',1,3,IAV,INPUTR,UNIT,NULLO,STAT)
         ENDIF
      ENDIF
C 
C
C  get area option, input frame + output frame 
      CAREA(1:) = ' '
      CALL STKRDC('INPUTC',1,3,60,IAV,CAREA,UNIT,NULLO,STAT)
      CALL STKRDC('IN_A',1,1,60,IAV,FRAMEA,UNIT,NULLO,STAT)
      CALL STKRDC('OUT_A',1,1,60,IAV,FRAMEC,UNIT,NULLO,STAT)
      CALL GENEQF(FRAMEA,FRAMEC,IAV)  !check that in, out_frame are different
      IF (IAV.NE.0)
     +   CALL STETER
     +   (2,'input and result frame have to be different...')
C 
      CALL STFOPN(FRAMEA,D_R4_FORMAT,0,F_IMA_TYPE,IMNOA,STAT)
      CALL STDRDI(IMNOA,'NAXIS',1,1,IAV,NAXIS,UNIT,NULLO,STAT)
      CALL STDRDI(IMNOA,'NPIX',1,NAXIS,IAV,NPIX,UNIT,NULLO,STAT)
      CALL STDRDD(IMNOA,'START',1,NAXIS,IAV,START,UNIT,NULLO,STAT)
      CALL STDRDD(IMNOA,'STEP',1,NAXIS,IAV,STEP,UNIT,NULLO,STAT)
      CALL STDRDC(IMNOA,'IDENT',1,1,72,IAV,IDENT,UNIT,NULLO,STAT)
      IF (NAXIS.GT.3) CALL STETER(1,'max. 3-dim frames supported...')
      N = (NAXIS+1) * 16
      CALL STDRDC(IMNOA,'CUNIT',1,1,N,IAV,CUNIT,UNIT,NULLO,STAT)
C 
      CALL STDRDR(IMNOA,'LHCUTS',1,4,IAV,CUTS,UNIT,NULLO,STAT)
      IF (CUTS(1).GE.CUTS(2)) THEN
         CUTIDX = 3
      ELSE
         CUTIDX = 1
      ENDIF
C 
C  check for < or > in fixed interval option (only average+median)
      IF (FF.EQ.1) THEN
         INPUTR(3) = CUTS(3) - 0.1
      ELSE IF (FF.EQ.2) THEN
         INPUTR(4) = CUTS(4) + 0.1
      ENDIF
C
C  determine "real" NAXIS
      TRUNAX = NAXIS
      IF (NAXIS.EQ.3) THEN
         IF (NPIX(3).EQ.1) THEN
            IF (NPIX(2).EQ.1) THEN
               TRUNAX = 1
            ELSE
               TRUNAX = 2
            ENDIF
         ENDIF
      ELSE IF (NAXIS.EQ.2) THEN
         IF (NPIX(2).EQ.1) TRUNAX = 1
      ENDIF
C 
C  only for complete frames do we support 3-dim frames 
      IF (TRUNAX.EQ.3) THEN
         IF (CAREA(1:1).NE.'+') THEN
            CBUF(1:) = 
     +      'max 2-dim frames supported for chosen area option... '
            CALL STETER(23,CBUF)
         ENDIF
C 
         CBUF(1:) = '3-dim input frame - all planes are processed ... '
         CALL STTPUT(CBUF,STAT)
      ENDIF
C
      COUNT3 = 1                          !counter for planes in 3-dim case
      OFFPIX = 0
      LOADFL(2) = D_R4_FORMAT             !use real data format
C 
C -------------------------------------------------------------------
C 
C  construct Gaussian filter
C 
C -------------------------------------------------------------------
C
500   IF (ACTION(1:1).EQ.'G') THEN 
         IF (NAXIS.EQ.1) RADIUS(2) = 0               !force 1-dim filtering...
         IF ((RADIUS(1).LE.0).OR.(RADIUS(2).LT.0))
     +      CALL STETER(4,'invalid radius chosen...')
         IF (RADIUS(2).GT.0) THEN
            FNAXIS = 2
         ELSE
            FNAXIS = 1
         ENDIF
C
         FPIX(1) = 2*RADIUS(1) + 1                  !get no. of points
         FPIX(2) = 2*RADIUS(2) + 1                  !and no. of lines...
         FSIZE = FPIX(1) * FPIX(2)
         FSTART(1) = 0.D0
         FSTART(2) = 0.D0
         FSTEP(1) = 1.D0
         FSTEP(2) = 1.D0
C 
C  check, if we should save the filter frame
         IF (FRAME(1:1).EQ.'+') THEN                 !No, don't keep...
            FRAME = 'dummy_frame '
            IOMODE = F_X_MODE
         ELSE                                        !Yes, keep filter frame...
            IOMODE = F_O_MODE
         ENDIF
         IF (FIMNO.GT.-1) CALL STFCLO(FIMNO,STAT)           !because of loop...
         CALL STIPUT(FRAME,D_R4_FORMAT,IOMODE,F_IMA_TYPE,
     +               FNAXIS,FPIX,FSTART,FSTEP,
     +               'Gaussian filter','none ',FPNTR,FIMNO,STAT)
C
C  here we really build the filter (and normalize it)
         CALL GAUSS(MADRID(FPNTR),FNAXIS,FPIX,FSTART,FSTEP,INPUTR,
     +              4,RMIN,RMAX)
         CALL NORMIT(MADRID(FPNTR),FSIZE)
         IF (IOMODE.EQ.F_O_MODE) THEN                 !if we keep file, get cuts
            RBUF(3) = CUTS(3)
            RBUF(4) = CUTS(4)
            CALL MYMX(MADRID(FPNTR),FSIZE,RBUF(3))
            RBUF(1) = 0.
            RBUF(2) = 0.
            CALL STDWRR(FIMNO,'LHCUTS',RBUF,1,4,UNIT,STAT)
         ENDIF
         FILACT = 1
C 
C -------------------------------------------------------------------
C 
C  digital filter
C 
C -------------------------------------------------------------------
C 
      ELSE IF (ACTION(1:1).EQ.'D') THEN
         CALL UPCAS(FRAME,CBUF)
         RADIUS(1) = 1                   !default to 3*3 matrix with weights
         RADIUS(2) = 1
         FILACT = 9                      !and fixed filter name
         K1 = 9
C
C  predefined filters
         RDUM(1) = 0.                    !we want to normalize filter kernels
         IF (CBUF(1:4).EQ.'CONE') THEN
            IF (CBUF(5:5).EQ.'5') THEN
               DO 800, N=1,25
                  INPUTR(N) = DGFIL7(N)
                  RDUM(1) = RDUM(1) + INPUTR(N)
800            CONTINUE
               RADIUS(1) = 2
               RADIUS(2) = 2
               K1 = 25
            ELSE
               DO 805, N=1,9
                  INPUTR(N) = DGFIL1(N)
                  RDUM(1) = RDUM(1) + INPUTR(N)
805            CONTINUE
            ENDIF
         ELSE IF (CBUF(1:7).EQ.'LAPLACE') THEN
            DO 810, N=1,9
               INPUTR(N) = DGFIL2(N)
               RDUM(1) = RDUM(1) + INPUTR(N)
810         CONTINUE
         ELSE IF (CBUF(1:8).EQ.'LOW_PASS') THEN
            DO 820, N=1,9
               INPUTR(N) = DGFIL3(N)
               RDUM(1) = RDUM(1) + INPUTR(N)
820         CONTINUE
         ELSE IF (CBUF(1:5).EQ.'POINT') THEN
            DO 830, N=1,9
               INPUTR(N) = DGFIL4(N)
               RDUM(1) = RDUM(1) + INPUTR(N)
830         CONTINUE
         ELSE IF (CBUF(1:4).EQ.'TENT') THEN
            DO 840, N=1,9
               INPUTR(N) = DGFIL5(N)
               RDUM(1) = RDUM(1) + INPUTR(N)
840         CONTINUE
         ELSE IF (CBUF(1:5).EQ.'SHARP') THEN
            DO 850, N=1,9
               INPUTR(N) = DGFIL6(N)
               RDUM(1) = RDUM(1) + INPUTR(N)
850         CONTINUE
         ELSE IF (CBUF(1:5).EQ.'PYRAM') THEN
            DO 860, N=1,25
               INPUTR(N) = DGFIL8(N)
               RDUM(1) = RDUM(1) + INPUTR(N)
860         CONTINUE
            RADIUS(1) = 2
            RADIUS(2) = 2
            K1 = 25
C 
C  any weights file
         ELSE IF (CBUF(1:2).NE.'++') THEN
            IF (FIMNO.GT.-1) CALL STFCLO(FIMNO,STAT)
            CALL STIGET(FRAME,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,
     +                  2,FNAXIS,FPIX,FSTART,FSTEP,
     +                  CBUF,CBUF,FPNTR,FIMNO,STAT)
C
C  make sure, we have odd NPIX(i)
            IF (FPIX(1).EQ.1) THEN               !kernel is a column
               RADIUS(1) = 0
            ELSE
               IF (MOD(FPIX(1),2).EQ.0) THEN
                  FPIX(1) = FPIX(1) - 1
                  WRITE(CBUF,30001) XYCH(1),FPIX(1)
                  CALL STTPUT(CBUF,STAT)
               ENDIF
               RADIUS(1) = FPIX(1)/2
            ENDIF
            IF (FNAXIS.EQ.1) THEN                !kernel is a row
               RADIUS(2) = 0
            ELSE
               IF (MOD(FPIX(2),2).EQ.0) THEN
                  FPIX(2) = FPIX(2) - 1
                  WRITE(CBUF,30001) XYCH(2),FPIX(2)
                  CALL STTPUT(CBUF,STAT)
               ENDIF
               RADIUS(2) = FPIX(2)/2
            ENDIF
            FILACT = 3
C 
C  the weights are entered directly
         ELSE
            CALL STKRDC('P3',1,1,80,IAV,CBUF,UNIT,NULLO,STAT)
            K1 = 1
            DO 880, N=1,80                 !get no. of values entered
               IF (CBUF(N:N).EQ.',') K1 = K1 + 1
               IF (CBUF(N:N).EQ.' ') GOTO 888
880         CONTINUE
888         IF (K1.GT.39) K1 = 39
            IF (MOD(K1,2).EQ.0) THEN
               K1 = K1 - 1
               WRITE(CBUF,30006) K1
               CALL STTPUT(CBUF,STAT)
            ENDIF
C 
            CALL STKRDC('INPUTC',1,63,2,IAV,CBUF,UNIT,NULLO,STAT)
            IF (CBUF(1:1).EQ.':') THEN
               IF ((CBUF(2:2).EQ.'Y').OR.(CBUF(2:2).EQ.'y')) THEN
                  RADIUS(1) = 0
                  RADIUS(2) = K1/2
               ELSE
                  RADIUS(1) = K1/2
                  RADIUS(2) = 0
               ENDIF
            ELSE                      !2-dim square kernel
C 
               IF (K1.EQ.25) THEN
                  RADIUS(1) = 2
                  RADIUS(2) = 2
               ELSE IF (K1.NE.9) THEN
                  IF (K1.LT.23) THEN
                     K1 = 9           !3x3 or 5x5 are only possibilities
                  ELSE
                     K1 = 25
                     RADIUS(1) = 2
                     RADIUS(2) = 2
                  ENDIF
                  WRITE(CBUF,30007) K1
                  CALL STTPUT(CBUF,STAT)
               ENDIF
            ENDIF
C 
            CALL STKRDR('INPUTR',1,K1,IAV,INPUTR,UNIT,NULLO,STAT)
            IF (IAV .LT. K1) THEN
               N = K1 - IAV
               WRITE(CBUF,30005) N
               DO 890, N=IAV+1,K1
                  INPUTR(N) = 0.0
890            CONTINUE
            ENDIF
            FILACT = 2
         ENDIF
C 
C  final check of radii
         IF ( (RADIUS(1).LT.0) .OR. (RADIUS(2).LT.0) .OR.
     +        ((RADIUS(1).EQ.0).AND.(RADIUS(2).EQ.0)) )
     +      CALL STETER(6,'invalid no. of weights...')
C 
C  for predefined filters divide by kernel sum
         IF (FILACT.EQ.9) THEN
            RDUM(1) = 1./RDUM(1)
            DO 895, N=1,K1
               INPUTR(N) = INPUTR(N) * RDUM(1)
895         CONTINUE
            FILACT = 2             !we have numbers
         ENDIF
C
C -------------------------------------------------------------------
C
C  just expand input frame => result frame
C
C -------------------------------------------------------------------
C
      ELSE IF (ACTION(1:1).EQ.'E') THEN
         CALL STKRDI('INPUTI',1,4,IAV,EXBUF,UNIT,NULLO,STAT)
         CALL EXPAX(IMNOA,OFFPIX,FRAMEC,EXBUF,STAT)
         IF (STAT.NE.0) CALL STETER(17,'invalid radius...')
 
         CALL STFOPN(FRAMEC,D_OLD_FORMAT,0,F_IMA_TYPE,IMNOC,STAT)
         CALL DSCUPT(IMNOA,IMNOC,' ',STAT)
         GOTO 9900                               !leave straight away ...
C 
C -------------------------------------------------------------------
C 
C  average (smoothing) or median filter
C 
C -------------------------------------------------------------------
C 
      ELSE IF (FILACT.NE.6) THEN
         FILACT = 4
C
C  test, if center pixel should be included
         IF (DEFAUL(1:1).EQ.'Y') THEN
            ALL = 1
         ELSE
            ALL = 0
         ENDIF
         ACTION(2:2) = DEFAUL(2:2)
C
C  get radii + threshold(s) for the averaging algorithm
         RADIUS(1) = NINT(INPUTR(1))
         IF ( (NAXIS.GT.1) .AND. (NPIX(2).GT.1) ) THEN
            RADIUS(2) = NINT(INPUTR(2))
         ELSE
            RADIUS(2) = 0
         ENDIF
         IF ( (RADIUS(1).LT.0) .OR. (RADIUS(2).LT.0) .OR.
     +        ((RADIUS(1)+RADIUS(2)).EQ.0) )
     +      CALL STETER(5,'invalid x- or y-radius entered...')
C
         NOPNTS = RADIUS(2)*2 + 1
         IF (ACTION(1:1).EQ.'M') THEN
            N = (RADIUS(1)*2 + 1) * NOPNTS 
            NWORK = 2 * N                 !2 buffers of filter size
         ELSE
            IF (RADIUS(2).GT.0) THEN
               NWORK = NOPNTS + NPIX(1)
            ELSE
               NOPNTS = 0
               NWORK = 1025               !for max RADIUS(1) of 512 
            ENDIF
            NWORK = NWORK * 2             !we want double precision
         ENDIF
C 
         IF (KLOOP.GT.1) CALL STFCLO(IMNOX,STAT)
         CALL STFCRE('smoothdumx',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +               NWORK,IMNOX,STAT)
         CALL STFMAP(IMNOX,F_X_MODE,1,NWORK,IAV,PNTRX,STAT)
         IF (ACTION(1:1).EQ.'M') THEN
            VPNTR = PNTRX + N
         ELSE
            PNTRY = PNTRX + (NOPNTS*2)                  !for double precision
         ENDIF
      ENDIF
C
C  ++++++++++++++++++++++++++
C
C  build up the result frame
C
C  ++++++++++++++++++++++++++
C 
      MINSZX = RADIUS(1)*2 + 1       !minimum size of area for given filtersize
      MINSZY = RADIUS(2)*2 + 1
      IF (EXPAZ.EQ.0) THEN              !adapt size of result frame
         RESPIX(1) = NPIX(1) - RADIUS(1) - RADIUS(1)
         RESPIX(2) = NPIX(2) - RADIUS(2) - RADIUS(2)
         EXSTA(1) = START(1) + (RADIUS(1)*STEP(1))
         EXSTA(2) = START(2) + (RADIUS(2)*STEP(2))
      ELSE                              !we do expand...
         RESPIX(1) = NPIX(1) 
         RESPIX(2) = NPIX(2)
         EXSTA(1) = START(1)
         EXSTA(2) = START(2)
      ENDIF
      RESPIX(3) = NPIX(3)
      EXSTA(3) = START(3)
C 
C  if it's complete frame + NPIX(2) > MONITPAR(20) - hack it up
C  but we do it only once in  the beginning...
C 
      IF (KLOOP.LE.1) THEN
         NWORK = RESPIX(3) * RESPIX(2) * RESPIX(1)
         CALL STFCRE(FRAMEC,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,
     +               NWORK,IMNOC,STAT)
         CALL STDWRI(IMNOC,'NAXIS',NAXIS,1,1,UNIT,STAT)
         CALL STDWRI(IMNOC,'NPIX',RESPIX,1,NAXIS,UNIT,STAT)
         CALL STDWRD(IMNOC,'START',EXSTA,1,NAXIS,UNIT,STAT)
         CALL STDWRD(IMNOC,'STEP',STEP,1,NAXIS,UNIT,STAT)
         CALL STDWRC(IMNOC,'IDENT',1,IDENT,1,72,UNIT,STAT)
         N = (NAXIS+1) * 16
         CALL STDWRC(IMNOC,'CUNIT',1,CUNIT,1,N,UNIT,STAT)
         CALL STDWRR(IMNOC,'LHCUTS',CUTS,1,4,UNIT,STAT)
C 
         HACK = 0                             !get max. lines for buffers
         CALL HACKUP(RESPIX,D_R4_FORMAT,RETBUF)
         NWORK = RETBUF(1)                    !no. of lines from input frame
C 
         IF (CAREA(1:1).EQ.'+') THEN                   !complete frame
            IF ( (NWORK.LT.RESPIX(2)) .OR. (TRUNAX.EQ.3) ) THEN
               IF (TRUNAX.EQ.3) THEN
                  HACK = 2                     !cube ...
               ELSE
                  HACK = 1
                  N = RETBUF(2)
                  IF (RETBUF(3).GT.0) N = N + 1
                  WRITE(CBUF,20010) N
                  CALL STTPUT(CBUF,STAT)
               ENDIF
               CHUNKI = NWORK*RESPIX(1)         !size of memory to allocate
               CALL STFXMP(CHUNKI,D_R4_FORMAT,PNTRHO,STAT)
            ELSE                               !map complete input frame
               CHUNKI = RESPIX(1) * RESPIX(2)
               CALL STFMAP(IMNOC,F_O_MODE,1,CHUNKI,IAV,PNTRC,STAT)
            ENDIF
C 
C  if not complete area, copy first
         ELSE
            CALL STTDIS
     +      ('first we copy input frame to result frame...',0,STAT)
C 
            IF (EXPAZ.EQ.0) THEN             !copy inner window to result frame
               LOW(1) = RADIUS(1) + 1
               LOW(2) = RADIUS(2) + 1
               CALL COPWI(IMNOA,NPIX,LOW,RESPIX,
     +                    IMNOC,RESPIX,SUBLO,NWORK)
            ELSE                             !straight file copy in chunks
               CHUNKI = NWORK * NPIX(1)
               CALL STFCRE('smoothdumi',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +                     CHUNKI,IMNOI,STAT)
               CALL STFMAP(IMNOI,F_X_MODE,1,CHUNKI,IAV,PNTRI,STAT)
               CALL COPYFX(MADRID(PNTRI),IMNOA,IMNOC,NPIX,NWORK)
               CALL STFCLO(IMNOI,STAT)
            ENDIF
            IMNOI = -1                             !so that we know later on
         ENDIF
C 
         IF (EXPAZ.EQ.0) THEN
            WRITE(CBUF,30003) RESPIX(1),RESPIX(2)
            CALL STTPUT(CBUF,STAT)
            INPLZ = NPIX(1) * NPIX(2)
         ELSE
            INPLZ = 0
         ENDIF
         OFFEX = 0
         RESPLZ = RESPIX(1) * RESPIX(2)
      ENDIF
C 
C  now expand frame to include also 2*RADIUS columns + lines
      EXBUF(1) = RADIUS(1)                  !expand input frame
      EXBUF(2) = RADIUS(1)
      EXBUF(3) = RADIUS(2)
      EXBUF(4) = RADIUS(2)
C 
C  *******************************************************
C  *******************************************************
C
C  expand frame - this is a loop, if 3-dim frames involved
C
C  *******************************************************
C  *******************************************************
C 
1200  HCOUNT = 1
      FRAMEA = ' '
      CALL GENTIM(FRAMEA)                        !get current time
C 
      IF (EXPAZ.EQ.1) THEN
         IF (TRUNAX.EQ.3)THEN
            WRITE(CBUF,20000) COUNT3,FRAMEA(1:40)
         ELSE
            WRITE(CBUF,20001) FRAMEA(1:40)
         ENDIF
         CALL STTPUT(CBUF,STAT)
C 
         CALL EXPAX(IMNOA,OFFPIX,TMPFIL,EXBUF,STAT)
         IF (STAT.NE.0) CALL STETER(17,'invalid radius...')
C 
         IF (CAREA(1:1).EQ.'+') THEN                   !complete frame
            IF (HACK.GE.1) THEN       !if HACK >= 1, use STFOPN for input file
               CALL STFOPN(TMPFIL,D_R4_FORMAT,0,F_IMA_TYPE,
     +                     IMNOEX,STAT)
               CALL STDRDI(IMNOEX,'NPIX',1,2,IAV,EXNPIX,UNIT,NULLO,STAT)
               CALL STDRDD(IMNOEX,'START',1,2,IAV,EXSTA,UNIT,NULLO,STAT)
               IF (PNTRHI.EQ.-1) THEN
                  NWORK = (RETBUF(1) + 2*RADIUS(2)) * EXNPIX(1)
                  CALL STFXMP(NWORK,D_R4_FORMAT,PNTRHI,STAT)
               ENDIF
            ELSE
               CALL STIGET(TMPFIL,D_R4_FORMAT,F_I_MODE,
     +                     F_IMA_TYPE,2,               !we keep NAXIS of FRAMEA
     +                     IAV,EXNPIX,EXSTA,STEP, 
     +                     CBUF,CBUF,PNTRA,IMNOEX,STAT)
            ENDIF
         ELSE
            CALL STFOPN(TMPFIL,D_R4_FORMAT,0,F_IMA_TYPE,IMNOEX,STAT)
            CALL STDRDI(IMNOEX,'NPIX',1,2,IAV,EXNPIX,UNIT,NULLO,STAT)
            CALL STDRDD(IMNOEX,'START',1,2,IAV,EXSTA,UNIT,NULLO,STAT)
         ENDIF
C 
      ELSE
         IF (TRUNAX.EQ.3) THEN
            WRITE(CBUF,22000) COUNT3,FRAMEA(1:40)
            CALL STTDIS(CBUF,0,STAT)
         ENDIF
         IMNOEX = IMNOA
         EXNPIX(1) = NPIX(1)
         EXSTA(1) = START(1)
         EXNPIX(2) = NPIX(2)
         EXSTA(2) = START(2)
C 
         IF (CAREA(1:1).EQ.'+') THEN                   !complete frame
            IF (HACK.GE.1) THEN
               IF (PNTRHI.EQ.-1) THEN
                  NWORK = (RETBUF(1) + 2*RADIUS(2)) * EXNPIX(1)
                  CALL STFXMP(NWORK,D_R4_FORMAT,PNTRHI,STAT)
               ENDIF
            ELSE
               N = EXNPIX(1) * EXNPIX(2)               !map input frame
               CALL STFMAP(IMNOEX,F_I_MODE,1,N,IAV,PNTRA,STAT)
            ENDIF
         ELSE
            CONTINUE                   !nothing to map now for subframes
         ENDIF
      ENDIF
C
C  +++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C  get the different area options for all filters
C
C  +++++++++++++++++++++++++++++++++++++++++++++++++++++++
C 
C  if we are here from looping, we already have the area option
      IF (KLOOP.GT.1) THEN
         NMAL = 0
         IF (AREAFL.EQ.2) THEN          !it's the 2. time we're up here...
            COOFF = 0
            GOTO 1500                   !continue with cursor
         ELSE IF (AREAFL.EQ.3) THEN 
            GOTO 2100                   !continue with table
         ELSE
            NMAL = 1
            IF (AREAFL.EQ.3) THEN 
               GOTO 3000                !single subframe (fixed coords)
            ELSE
               OPIX(1) = EXNPIX(1)  
               OPIX(2) = EXNPIX(2)
               GOTO 5000                !full image
            ENDIF
         ENDIF
      ENDIF
C
C  a) complete input image - only here do we support 3-dim files
      IF (CAREA(1:1).EQ.'+') THEN
         AREAFL = 0                     !use complete input frame...
         PNTRO = PNTRC                  !filter image is output image
         PNTRI = PNTRA                  !use full input image
         OPIX(1) = EXNPIX(1)            !dimensions of expanded frame
         OPIX(2) = EXNPIX(2)
         GOTO 5000
      ENDIF
C 
C  b) subimage defined by coordinates
      IF (CAREA(1:1).EQ.'[') THEN
         CALL EXTCOO(IMNOA,CAREA,2,SUBDIM,SUBLO,SUBHI,STAT)
         IF (STAT.NE.0) CALL STETER(4,' ')      !stop, if invalid coordinates...
         SUBPIX(1,1) = SUBLO(1)
         SUBPIX(2,1) = SUBLO(2)
         SUBPIX(1,2) = SUBHI(1)
         SUBPIX(2,2) = SUBHI(2)
         AREAFL = 1
         NMAL = 1
         GOTO 3000
      ENDIF
C
C  c) cursor defined subimage(s)
      CALL UPCAS(CAREA(1:6),CUNIT)
      IF (CUNIT(1:6).NE.'CURSOR') GOTO 2000          !branch to table option
C
C  get main control block for ImageDisplay + attach
      IF (DAZO.EQ.0) THEN
         CALL DTOPEN(1,STAT)
         DAZO = 1
      ENDIF
      NMAL = 0                                 !reset counter
      CBUF(1:) = ' '
      CALL CONCHA(QDSPNO,QOVCH,1,0)            !clear overlay channel
      CALL SETCUR(QDSPNO,2,0,0,KCOOR,STAT)     !set up cursor rectangle
C 
C  input cursor positions and check status
1500  CALL GETCUR(CACT,CBUF,
     +            ICUR1,PCUR1(3),PCUR1(5),RDUM(1),STAT1,
     +            ICUR2,PCUR2(3),PCUR2(5),RDUM(1),STAT2)
C
C  check cursor status
      IF ( (STAT1.EQ.0) .AND. (STAT2.EQ.0) ) THEN
         IF (COOFF.EQ.0) THEN
            COOFF = 1
            CALL STTDIS(ERMES3,0,STAT)
            CBUF(1:) = ' '
            GOTO 1500
         ELSE
            GOTO 8000                          !cursor loop terminated ...
         ENDIF
      ELSE
         NMAL = NMAL + 1                                !update counter
         COOFF = 1
      ENDIF
C
C  and get frame pixel no's
      SUBPIX(1,1) = PCUR1(3)
      SUBPIX(2,1) = PCUR1(4)
      SUBPIX(1,2) = PCUR2(3)
      SUBPIX(2,2) = PCUR2(4)
      AREAFL = 2
      GOTO 3000
C
C  d) table defined subimage(s) - for this option we loop...
2000  CALL CLNTAB(CAREA,TABLE,0)
      CALL TBTOPN(TABLE,F_I_MODE,TID,STAT)
      CALL TBIGET(TID,NCOL,NROW,N,N,N,STAT)           !get no. of rows + columns
      DO 2050, N=1,4
         CALL TBLSER(TID,TLABL(N),TBCLNM(N),STAT)
         IF (TBCLNM(N).LE.0) THEN
            CBUF(1:) = 'column :'//TLABL(N)//'is missing ... '
            CALL STETER(7,CBUF)
         ENDIF
2050  CONTINUE
C 
      AREAFL = 3
      NMAL = 0                                         !init counter
C 
C  if we also want to display the filtered windows, we have to attach 
      IF (LOADFL(1).NE.0) THEN
         IF (DAZO.EQ.0) THEN
            CALL DTOPEN(1,STAT)
            DAZO = 1
         ENDIF
         CALL PIXXCV('INIT',IMNOA,RBUF,STAT)
      ENDIF
C
C  here we loop
2100  IF (NMAL.GE.NROW) THEN
         WRITE(CBUF,30010) NMAL
         CALL STTPUT(CBUF,STAT)
         GOTO 8000
      ENDIF
C
C  get next row of values
      NMAL = NMAL + 1
      CALL TBSGET(TID,NMAL,SELFLG,STAT)
      IF (.NOT.SELFLG) GOTO 2100
C 
      CALL TBRGET(TID,'R*4 ',NMAL,4,TBCLNM,RBUF,TABNUL,STAT)
      PCUR1(3) = (RBUF(1)-START(1))/STEP(1) + 1.
      PCUR1(4) = (RBUF(2)-START(2))/STEP(2) + 1.
      PCUR2(3) = (RBUF(3)-START(1))/STEP(1) + 1.
      PCUR2(4) = (RBUF(4)-START(2))/STEP(2) + 1.
      IF (LOADFL(1).NE.0) THEN            !we have to get related screen pixels
         RBUF(11) = PCUR1(3)
         RBUF(12) = PCUR1(4)
         CALL PIXXCV('_RS',0,RBUF(11),STAT)
         ICUR1(1) = NINT(RBUF(15))
         ICUR1(2) = NINT(RBUF(16))
      ENDIF
C
C  get frame pixel no's
      SUBPIX(1,1) = PCUR1(3)
      SUBPIX(2,1) = PCUR1(4)
      SUBPIX(1,2) = PCUR2(3)
      SUBPIX(2,2) = PCUR2(4)
C
C -------------------------------------------------
C
C  common section for option b), c) and d)
C
C -------------------------------------------------
C
C  get no.  of points involved
3000  TPIX(1) = SUBPIX(1,2) - SUBPIX(1,1) + 1
      TPIX(2) = SUBPIX(2,2) - SUBPIX(2,1) + 1
C 
      IF (TPIX(1).LT.MINSZX) THEN
         WRITE(CBUF,30004) NMAL,XYCH(1)
         CALL STTPUT(CBUF,STAT)
         GOTO 7000
      ENDIF
      IF (TPIX(2).LT.MINSZY) THEN
         WRITE(CBUF,30004) NMAL,XYCH(2)
         CALL STTPUT(CBUF,STAT)
         GOTO 7000
      ENDIF
C
C  the memory allocation scheme wastes space for options c and d), but so what..
C 
      OPIX(1) = TPIX(1) + 2*RADIUS(1)              !size we need as input frame
      OPIX(2) = TPIX(2) + 2*RADIUS(2)
      N = OPIX(1) * OPIX(2)
C 
      IF (N.GT.OLDMAP) THEN
         OLDMAP = N                                !save size
         IF (IMNOI.GT.-1) THEN
            CALL STFCLO(IMNOI,STAT)
            CALL STFCLO(IMNOO,STAT)
         ENDIF
         CALL STFCRE('smoothdumi',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +               N,IMNOI,STAT)
         CALL STFMAP(IMNOI,F_X_MODE,1,N,IAV,PNTRI,STAT)
         N = TPIX(1) * TPIX(2)
         CALL STFCRE('smoothdumo',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +               N,IMNOO,STAT)
         CALL STFMAP(IMNOO,F_X_MODE,1,N,IAV,PNTRO,STAT)
      ENDIF
C 
      IF (EXPAZ.EQ.0) THEN            !get expanded subframe from original input
         SUBOFA(1) = SUBPIX(1,1) - RADIUS(1)
         SUBOFA(2) = SUBPIX(2,1) - RADIUS(2)
         LOW(1) = SUBOFA(1) + OPIX(1) - 1
         LOW(2) = SUBOFA(2) + OPIX(2) - 1
         IF ( (SUBOFA(1).LT.1) .OR. 
     +        (SUBOFA(2).LT.1) .OR.
     +        (LOW(1).GT.NPIX(1)) .OR.
     +        (LOW(2).GT.NPIX(2))) THEN
            WRITE(CBUF,30002) NMAL
            CALL STTPUT(CBUF,STAT)
            GOTO 7000
         ENDIF
      ELSE                            !get expanded subframe from expanded input
         SUBOFA(1) = SUBPIX(1,1)              !x-pixel to start (-radius+radius)
         SUBOFA(2) = SUBPIX(2,1)              !y-pixel to start (-radius+radius)
      ENDIF
      SUBOFB(1) = 1
      SUBOFB(2) = 1
      CHUNKI = EXNPIX(1) * OPIX(2)
      K1 = (SUBOFA(2)-1)*EXNPIX(1) + 1
      CALL STFMAP(IMNOEX,F_I_MODE,K1,CHUNKI,IAV,PNTRA,STAT)
      QPIX(1) = EXNPIX(1)
      QPIX(2) = OPIX(2)
      SUBOFA(2) = 1
      CALL COPYF1(MADRID(PNTRA),QPIX,SUBOFA,OPIX,MADRID(PNTRI),
     +            OPIX,SUBOFB)
      CALL STFUNM(IMNOEX,STAT)
C
5000  IF (AREAFL.GE.2) THEN
         N = 1
         CALL STKWRI('LOG',N,4,1,UNIT,STAT)            !set LOG(4) = 1
      ENDIF
C
C  +++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C  and finally do the filtering
C
C  +++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      IF (FILACT.EQ.4) THEN
         IF (HACK.EQ.0) THEN
            PNTRO = PNTRO + OFFPIX
            IF (RADIUS(2).EQ.0) THEN                   !average/median filter
               IF (ACTION(1:1).EQ.'M') THEN
                  CALL AVER1M(ACTION,MADRID(PNTRI),MADRID(PNTRO),
     +                        OPIX(1),OPIX(2),RADIUS,INPUTR(3),ALL,
     +                        MADRID(PNTRX),KUTS(3))
               ELSE
                  CALL AVER1A(ACTION,MADRID(PNTRI),MADRID(PNTRO),
     +                        OPIX(1),OPIX(2),RADIUS,INPUTR(3),ALL,
     +                        MADRID(PNTRX),KUTS(3))
               ENDIF
            ELSE
               IF (ACTION(1:1).EQ.'M') THEN
                  CALL AVER2M(ACTION,MADRID(PNTRI),MADRID(PNTRO),
     +                        OPIX(1),OPIX(2),RADIUS,INPUTR(3),ALL,
     +                        MADRID(PNTRX),MADRID(VPNTR),KUTS(3))
               ELSE
                  IF (ACTION(2:2).EQ.'Q') THEN
                     CALL BVER2A(ACTION,MADRID(PNTRI),MADRID(PNTRO),
     +                           OPIX(1),OPIX(2),RADIUS,INPUTR(3),ALL,
     +                           MADRID(PNTRX),MADRID(PNTRY),KUTS(3))
                  ELSE
                     CALL AVER2A(ACTION,MADRID(PNTRI),MADRID(PNTRO),
     +                           OPIX(1),OPIX(2),RADIUS,INPUTR(3),ALL,
     +                           MADRID(PNTRX),MADRID(PNTRY),KUTS(3))
                  ENDIF
               ENDIF
            ENDIF
         ELSE
            HIOFF = 1 + OFFEX
            HOOFF = 1 + OFFPIX
            LINCO = 0
            REMAIN = RETBUF(1)            !we know, that NPIX(2) >= RETBUF(1)
C 
6000        HY = REMAIN + 2*RADIUS(2)
            HISIZ = HY * EXNPIX(1)
            HOSIZ = REMAIN * RESPIX(1)
            CALL STFGET(IMNOEX,HIOFF,HISIZ,IAV,MADRID(PNTRHI),STAT)
            IF (HACK.EQ.1) THEN
               FRAMEA = ' '
               CALL GENTIM(FRAMEA)                        !get current time
               WRITE(CBUF,20020) HCOUNT,FRAMEA(1:40)
               CALL STTDIS(CBUF,0,STAT)
            ENDIF
C 
            IF (RADIUS(2).EQ.0) THEN                   !average/median filter
              IF (ACTION(1:1).EQ.'M') THEN
                  CALL AVER1M(ACTION,MADRID(PNTRHI),MADRID(PNTRHO),
     +                        OPIX(1),HY,RADIUS,INPUTR(3),ALL,
     +                        MADRID(PNTRX),KUTS(3))
               ELSE
                  CALL AVER1A(ACTION,MADRID(PNTRHI),MADRID(PNTRHO),
     +                        OPIX(1),HY,RADIUS,INPUTR(3),ALL,
     +                        MADRID(PNTRX),KUTS(3))
               ENDIF
            ELSE
               IF (ACTION(1:1).EQ.'M') THEN
                  CALL AVER2M(ACTION,MADRID(PNTRHI),MADRID(PNTRHO),
     +                        OPIX(1),HY,RADIUS,INPUTR(3),ALL,
     +                        MADRID(PNTRX),MADRID(VPNTR),KUTS(3))
               ELSE
                  IF (ACTION(2:2).EQ.'Q') THEN
                     CALL BVER2A(ACTION,MADRID(PNTRHI),MADRID(PNTRHO),
     +                           OPIX(1),HY,RADIUS,INPUTR(3),ALL,
     +                           MADRID(PNTRX),MADRID(PNTRY),KUTS(3))
                  ELSE
                     CALL AVER2A(ACTION,MADRID(PNTRHI),MADRID(PNTRHO),
     +                           OPIX(1),HY,RADIUS,INPUTR(3),ALL,
     +                           MADRID(PNTRX),MADRID(PNTRY),KUTS(3))
                  ENDIF
               ENDIF
            ENDIF
C 
            CALL STFPUT(IMNOC,HOOFF,HOSIZ,MADRID(PNTRHO),STAT)
            LINCO = LINCO + REMAIN               !increase line count + check
            REMAIN = NPIX(2) - LINCO
            IF (REMAIN.GT.0) THEN
               IF (REMAIN.GT.RETBUF(1))
     +             REMAIN = RETBUF(1)        !hack up into RETBUF(1)-chunks
               HIOFF = HIOFF + HISIZ - (2*RADIUS(2)*EXNPIX(1))
               HOOFF = HOOFF + HOSIZ
               HCOUNT = HCOUNT + 1
               GOTO 6000                         !loop again
            ENDIF
         ENDIF
C 
      ELSE
         IF (HACK.EQ.0) THEN
            PNTRO = PNTRO + OFFPIX
            IF ((FILACT.EQ.1) .OR. (FILACT.EQ.3)) THEN   
               CALL TEMPLB(ZFLAG,MADRID(PNTRI),MADRID(PNTRO),OPIX,
     +                     MADRID(FPNTR),RADIUS,KUTS(3),STAT)
            ELSE 
               CALL TEMPLB(ZFLAG,MADRID(PNTRI),MADRID(PNTRO),OPIX,
     +                     INPUTR,RADIUS,KUTS(3),STAT)
            ENDIF
            IF (STAT.NE.0)
     +         CALL STETER(5,'x- or y-radius of filter too large...')
C 
         ELSE
            HIOFF = 1 + OFFEX
            HOOFF = 1 + OFFPIX
            LINCO = 0
            REMAIN = RETBUF(1)             !we know, that NPIX(2) >= RETBUF(1)
C 
6600        HY = REMAIN + 2*RADIUS(2)
            HISIZ = HY * EXNPIX(1)
            HOSIZ = REMAIN * RESPIX(1)
            OPIX(2) = HY
            CALL STFGET(IMNOEX,HIOFF,HISIZ,IAV,MADRID(PNTRHI),STAT)
            IF (HACK.EQ.1) THEN
               FRAMEA = ' '
               CALL GENTIM(FRAMEA)                        !get current time
               WRITE(CBUF,20020) HCOUNT,FRAMEA(1:40)
               CALL STTDIS(CBUF,0,STAT)
            ENDIF
C 
            IF ((FILACT.EQ.1) .OR. (FILACT.EQ.3)) THEN   
               CALL TEMPLB(ZFLAG,MADRID(PNTRHI),MADRID(PNTRHO),OPIX,
     +                     MADRID(FPNTR),RADIUS,KUTS(3),STAT)
            ELSE 
               CALL TEMPLB(ZFLAG,MADRID(PNTRHI),MADRID(PNTRHO),OPIX,
     +                     INPUTR,RADIUS,KUTS(3),STAT)
            ENDIF
            IF (STAT.NE.0)
     +         CALL STETER(5,'x- or y-radius of filter too large...')
C 
            CALL STFPUT(IMNOC,HOOFF,HOSIZ,MADRID(PNTRHO),STAT)
            LINCO = LINCO + REMAIN               !increase line count + check
            REMAIN = NPIX(2) - LINCO
            IF (REMAIN.GT.0) THEN
               IF (REMAIN.GT.RETBUF(1)) 
     +            REMAIN = RETBUF(1)            !hack up into RETBUF(1)-chunks
               HIOFF = HIOFF + HISIZ - (2*RADIUS(2)*EXNPIX(1))
               HOOFF = HOOFF + HOSIZ
               HCOUNT = HCOUNT + 1
               GOTO 6600                         !loop again
            ENDIF
         ENDIF
C 
      ENDIF
C
C  if area option used, merge filtered frame back into output frame
      IF (AREAFL.GT.0) THEN
         SUBOFA(1) = 1
         SUBOFA(2) = 1
         IF (EXPAZ.EQ.0) THEN
            SUBOFB(1) = SUBPIX(1,1) - RADIUS(1)
            SUBOFB(2) = SUBPIX(2,1) - RADIUS(2)
         ELSE
            SUBOFB(1) = SUBPIX(1,1)
            SUBOFB(2) = SUBPIX(2,1)
         ENDIF
         CHUNKO = RESPIX(1) * TPIX(2)
         QPIX(1) = RESPIX(1)
         QPIX(2) = TPIX(2)
         K2 = (SUBOFB(2)-1)*RESPIX(1) + 1
         CALL STFMAP(IMNOC,F_IO_MODE,K2,CHUNKO,IAV,PNTRC,STAT)
         SUBOFB(2) = 1
         CALL COPYF1(MADRID(PNTRO),TPIX,SUBOFA,TPIX,MADRID(PNTRC),
     +               QPIX,SUBOFB)
         CALL STFPUT(IMNOC,K2,CHUNKO,MADRID(PNTRC),STAT)
         IF (LOADFL(1).NE.0) THEN       !for display option load subwindows
            LOW(1) = PCUR1(3)
            LOW(2) = PCUR1(4)
            WW(1) = ICUR1(1)
            WW(2) = ICUR1(2)
            WW(3) = SCALX
            WW(4) = SCALY
            CALL LOADWN(LOADFL,IMNOC,RESPIX,LOW,TPIX,WW,CUTS(CUTIDX))
         ENDIF
         CALL STFUNM(IMNOC,STAT)
      ENDIF
C
C  for cursor or table input loop
7000  IF (AREAFL.GE.2) THEN
         N = 0
         CALL STKWRI('LOG',N,4,1,UNIT,STAT)      !reset LOG(4) = 0
         GOTO (1500,2100),AREAFL-1
C 
C  also loop for 3-dim frames (with complete frame option)
      ELSE IF (TRUNAX.EQ.3) THEN
         COUNT3 = COUNT3 + 1
         IF (COUNT3.LE.NPIX(3)) THEN
            OFFPIX = OFFPIX + RESPLZ
            OFFEX = OFFEX + INPLZ
            IF (EXPAZ.NE.0) CALL STFCLO(IMNOEX,STAT)
            GOTO 1200
         ENDIF
      ENDIF
C
C  update descriptors + add history
8000  IF (KLOOP.EQ.0) THEN
         CALL DSCUPT(IMNOA,IMNOC,' ',STAT)
         IF (AREAfl.EQ.0)
     +      CALL STDWRR(IMNOC,'LHCUTS',KUTS,1,4,UNIT,STAT)
         GOTO 9000
      ENDIF
C 
C +++++++++++++++++++++++++++++++++
C 
C  here we loop inside the module
C 
C +++++++++++++++++++++++++++++++++
C 
      IF (KLOOP.EQ.1) THEN
         KLOOP = 99
         IF (ACTION(1:1).EQ.'D') THEN
            WRITE(*,10000)
         ELSE
            WRITE(*,10001)
         ENDIF
      ENDIF
C 
8800  CBUF(1:) = ' '
      CALL STTDIS('> ',99,STAT)
      READ(*,30000) CBUF
      IF ((CBUF(1:1).EQ.'X').OR.(CBUF(1:1).EQ.'x')) THEN
         KLOOP = 0
         GOTO 8000
      ENDIF
      N = INDEX(CBUF,' ')
C 
      IF (ACTION(1:1).EQ.'G') THEN
         IF (CBUF(1:1).NE.'?') THEN
            CALL GENCNV(CBUF(1:N),1,2,RADIUS,RDUM,STEP,IAV)
            IF (IAV.LT.1) THEN
               WRITE(*,10011)
               GOTO 8800
            ELSE IF (IAV.LT.2) THEN
               RADIUS(2) = RADIUS(1)
            ENDIF
         ENDIF
         N = N + 1                       !move to next parameter
         INPUTR(5) = 1.0
         IF ((CBUF(N:N).NE.'?') .AND.
     +       (CBUF(1:1).NE.' ')) THEN
            CALL GENCNV(CBUF(1:N),2,4,IDUM,INPUTR,STEP,IAV)
            IF (IAV.LT.2) THEN
               INPUTR(5) = -1.0
            ELSE IF (IAV.LT.4) THEN
               INPUTR(3) = INPUTR(1)
               INPUTR(4) = INPUTR(2)
            ENDIF
         ENDIF
C 
      ELSE IF (ACTION(1:1).EQ.'D') THEN
         CALL GENCNV(CBUF,2,9,IDUM,INPUTR,STEP,IAV)
         IF (IAV.LT.9) THEN
            FRAME(1:) = CBUF(1:)               !it's a frame
         ELSE
            FRAME(1:2) = '++'
         ENDIF
C 
      ELSE
         IF ((CBUF(N:N).NE.'?') .AND.
     +       (CBUF(1:1).NE.' ')) THEN
            CALL GENCNV(CBUF(1:N),2,3,IDUM,INPUTR,STEP,IAV)
            IF (IAV.LT.3) THEN
               WRITE(*,10010)
               GOTO 8800
            ENDIF
         ENDIF
         N = N + 1                       !move to next parameter
         IF (CBUF(N:N).NE.'?') 
     +      CALL UPCAS(CBUF(N:N+1),DEFAUL)
      ENDIF 
      GOTO 500
C
C  free data
9000  IF (DAZO.NE.0) CALL DTCLOS(QDSPNO)
      CALL STFCLO(IMNOC,STAT)                 !close result frame
      CALL STFCLO(IMNOA,STAT)                 !close input frame
      CALL STFCLO(IMNOEX,STAT)
      IF (DEBUFL.EQ.0) THEN
         IF (EXPAZ.EQ.1) CALL STFDEL(TMPFIL,STAT)
      ENDIF
9900  CALL STSEPI
C
10000 FORMAT(' Enter parameter P3 like in the command syntax,',
     +       ' type X to exit')
10001 FORMAT(' Enter parameters P3 and P4 like in the command syntax,',
     +       ' type X to exit')
10010 FORMAT(' Invalid input, we need 3 real numbers, try again...')
10011 FORMAT(' Invalid input, we need 2 integer numbers, try again...')
20000 FORMAT('expanding plane ',I3,' - ',A)
20001 FORMAT('expanding frame - ',A)
20010 FORMAT('we process frame in ',I2,' chunks ...')
20020 FORMAT('working on chunk ',I2,' - ',A)
22000 FORMAT('plane ',I3,' - ',A)
30000 FORMAT(A)
30001 FORMAT('Warning: No. of ',A,'-weights must be odd => changed to ',
     +       I2,' ...')
30002 FORMAT('invalid subwindow no.',I4,' - so we skip...')
30003 FORMAT('no expansion - NPIX(1,2) of result frame = ',2I6)
30004 FORMAT
     + ('subimage no. ',I4,' too small in ',A,' for given filter size')
30005 FORMAT('missing kernel values (',I2,') are set to 0.0')
30006 FORMAT('Warning: No. of weights must be odd => changed to ',
     +       I2,' ...')
30007 FORMAT
     + ('Warning: No. of weights must be 3x3 or 5x5 => changed to ',
     +       I2,' ...')
30010 FORMAT(I4,' table entries processed ...')
C 
      END

      SUBROUTINE COPWI(IMNOA,NPIXA,BEGA,NPIXW,IMNOB,NPIXB,BEGB,STRIP)
C 
      IMPLICIT NONE
C
      INTEGER   IMNOA,NPIXA(2),BEGA(2),NPIXW(2)
      INTEGER   IMNOB,NPIXB(2),BEGB(2),STRIP
      INTEGER*8 PNTRI,PNTRO
      INTEGER   IMNOI,IMNOO
      INTEGER   CHUNKI,CHUNKO,LOOPLM,RMAIND,STAT,IAV
      INTEGER   IPIX(2),OPIX(2),WPIX(2),ILOW(2),OLOW(2)
      INTEGER   K1,K2,N
      INTEGER   MADRID(1)
C     
      COMMON   /VMR/ MADRID
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C 
      LOOPLM = NPIXW(2) /  STRIP
      RMAIND = NPIXW(2) - (LOOPLM*STRIP)
C 
      CHUNKI = STRIP * NPIXA(1)
      CALL STFCRE('copywork',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +            CHUNKI,IMNOI,STAT)
      CALL STFMAP(IMNOI,F_X_MODE,1,CHUNKI,IAV,PNTRI,STAT)
C
      CHUNKO = STRIP * NPIXB(1)
      CALL STFCRE('copzwork',D_R4_FORMAT,F_X_MODE,F_IMA_TYPE,
     +            CHUNKO,IMNOO,STAT)
      CALL STFMAP(IMNOO,F_X_MODE,1,CHUNKO,IAV,PNTRO,STAT)
C 
      IPIX(1) = NPIXA(1) 
      IPIX(2) = STRIP
      OPIX(1) = NPIXB(1) 
      OPIX(2) = STRIP
      ILOW(1) = BEGA(1)
      ILOW(2) = 1
      OLOW(1) = BEGB(1)
      OLOW(2) = 1
      WPIX(1) = NPIXW(1)
      WPIX(2) = STRIP
C 
      K1 = (BEGA(2)-1)*NPIXA(1) + 1                !full line offsets
      K2 = (BEGB(2)-1)*NPIXB(1) + 1                !full line offsets
      DO 1000, N=1,LOOPLM
         CALL STFGET(IMNOA,K1,CHUNKI,IAV,MADRID(PNTRI),STAT)  !data in
         CALL COPYF1(MADRID(PNTRI),IPIX,ILOW,WPIX,
     +               MADRID(PNTRO),OPIX,OLOW)
         CALL STFPUT(IMNOB,K2,CHUNKO,MADRID(PNTRO),STAT)      !data out
         K1 = K1 + CHUNKI
         K2 = K2 + CHUNKO
1000  CONTINUE
C 
      IF (RMAIND.NE.0) THEN
         CHUNKI = RMAIND * NPIXA(1)
         CHUNKO = RMAIND * NPIXB(1)
         WPIX(2) = RMAIND
         CALL STFGET(IMNOA,K1,CHUNKI,IAV,MADRID(PNTRI),STAT)  !data in
         CALL COPYF1(MADRID(PNTRI),IPIX,ILOW,WPIX,
     +               MADRID(PNTRO),OPIX,OLOW)
         CALL STFPUT(IMNOB,K2,CHUNKO,MADRID(PNTRO),STAT)      !data out
      ENDIF
C
      CALL STFCLO(IMNOI,STAT)
      CALL STFCLO(IMNOO,STAT)
C 
      RETURN
      END

C @(#)sgpfc.for	19.1 (ESO-DMD) 02/25/03 13:31:24
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C.IDENTIFICATION:
C  PROGRAM SGPFC               VERSION 1.0               SEP    8, 1988
C  P.GROSBOL                   ESO - GARCHING
C
C.PURPOSE:
C  PROGRAM TO EXTRACT AZIMUTHAL PROFILES FROM A GALAXY WITH GIVEN
C  PA AND AI. THE PROFILES ARE FOURIER TRANSFORMED AND THE 
C  COEFFICIENTS ARE STORED IN A TABLE FILE.
C  THE NO. OF COEFFICIENTS IS DEFINED BY THE PARAMETER 'MFC=7'
C  I.E.  INCLUDING THE 6TH HARMONIC
C
C.INPUT/OUTPUT:
C  THE PROGRAM RUNS UNDER MIDAS AND USES THE FOLLOWING KEYWORDS:
C   IN_A        :  NAME OF IMAGE FILE                               (I)
C   INPUTR(1-7) :  REAL INPUT PARAMETERS DEFINING GALAXY POSITION   (I)
C                  1:X CENTER POSITION, 2:Y CENTER POSITION,
C                  3:POSITON ANGLE (DEG), 4:INCLINATION ANGLE (DEG)
C                  5:INNER RADIUS, 6:OUTER RADIUS, 7:RADIAL STEP
C   OUT_A       :  OUTPUT TABLE NAME                                (I)
C
C.VERSION:
C   910307 RHW Included in ESO-MIDAS
C 
C 021031	last modif
C
C---------------------------------------------------------------------
      PROGRAM SGPFC
C
      IMPLICIT   NONE
      INTEGER    MFC
      INTEGER    NCOL
      INTEGER    MCOL
      PARAMETER  (MFC=7)
      PARAMETER  (NCOL=2*MFC+3)
      PARAMETER  (MCOL=NCOL+5)
C
      REAL     AMP(MFC),PHA(MFC),PH(MFC),ROW(NCOL),
     2         RANGE(3),POSI(4)
      REAL     PI, PI2, PA
      REAL     RI, RO
      REAL     R, RP
      REAL     AI, AN
      REAL     DIF
      REAL     DR, DTR
      REAL     XC, YC
C 
      DOUBLE PRECISION STEP(3),START(3)
      INTEGER  MADRID(1)
      INTEGER  NPIX(3)
      INTEGER  IC(NCOL),KUNIT(4)
      INTEGER  IMNO, INULL, ITNO
      INTEGER  I, IERR, IAV, IDF
      INTEGER  MC
      INTEGER  IX
      INTEGER  N, NA, NR, NC
      INTEGER*8 PNTR
C 
      LOGICAL  LFPHA
C
      CHARACTER*16 LAB
      CHARACTER*60 INAME,TNAME,TNN
      CHARACTER*64 UNIT
      CHARACTER*72 IDEN
      CHARACTER*80 MSG
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
      COMMON  /VMR/MADRID
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C     INITIATE MIDAS
C
      CALL STSPRO('SGPFC')
C
C     READ PARAMETERS
C
      CALL STKRDC('IN_A',1,1,60,IAV,INAME,KUNIT,INULL,IERR)
      CALL STKRDR('INPUTR',1,4,IAV,POSI,KUNIT,INULL,IERR)
      CALL STKRDR('INPUTR',5,3,IAV,RANGE,KUNIT,INULL,IERR)
      CALL STKRDC('OUT_A',1,1,60,IAV,TNAME,KUNIT,INULL,IERR)
C
C     OPEN IMAGE FRAME
C
      CALL STIGET(INAME,D_R4_FORMAT,F_I_MODE,1,3,NA,NPIX,
     ,                START,STEP,IDEN,UNIT,PNTR,IMNO,IERR)
      IF (NA.NE.2 .OR. IERR.NE.0 .OR.
     .    ABS(STEP(1)/STEP(2)-1.0).GT.1E-5) THEN
         CALL STTPUT('*** FATAL: WRONG IMAGE FORMAT',IERR)
         CALL STSEPI
      ENDIF
C
C     CHECK PARAMETERS AND CONVERT TO PIXEL VALUES
C
      LFPHA = .TRUE.
      PI  = 4.0 * ATAN(1.0)
      PI2 = 2.0 * PI
      DTR = PI / 180.0
      RI  = MAX( 0.0 , ABS(RANGE(1)) )
      RO  = MAX( RI , ABS(RANGE(2)) )
      DR  = ABS( RANGE(3) )
      XC  = (POSI(1)-START(1))/STEP(1) + 1.0
      YC  = (POSI(2)-START(2))/STEP(2) + 1.0
      PA  = DTR * POSI(3)
      AI  = DTR * MAX( 0.0 , MIN( 90.0 , POSI(4) ) )
      NR = INT( (RO-RI)/DR + 1.0 )
C
C     CREATE TABLE
C
      I = INDEX(TNAME,' ') - 1
      TNN = TNAME(1:I)//'.TBL'
      CALL TBTINI(TNAME,0,1,MCOL,NR,ITNO,IERR)
      CALL STDWRC(ITNO,'IDENT',1,IDEN,1,72,KUNIT,IERR)
      CALL STDWRR(ITNO,'POSI',POSI,1,4,KUNIT,IERR)
      CALL TBCINI(ITNO,D_R4_FORMAT,1,'F6.1',UNIT(17:32),
     ,                'R',IC(1),IERR)
      CALL TBCINI(ITNO,D_R4_FORMAT,1,'F6.3','LR','LR',IC(2),IERR)
      CALL TBCINI(ITNO,D_R4_FORMAT,1,'I4','POINTS',
     ,                'NOP',IC(3),IERR)
      CALL TBCINI(ITNO,D_R4_FORMAT,1,'F7.1',UNIT(1:16),
     ,                'AMP',IC(4),IERR)
      CALL TBCINI(ITNO,D_R4_FORMAT,1,'F6.3',UNIT(17:32),
     ,                'NOISE',IC(5),IERR)
      NC = 6
      DO 100, I = 1,MFC-1
         WRITE(LAB,650) I
  650    FORMAT('AMP',I1)
         CALL TBCINI(ITNO,D_R4_FORMAT,1,'F6.3',' ',LAB,IC(NC),IERR)
         NC = NC + 1
         WRITE(LAB,655) I
  655    FORMAT('PHA',I1)
         CALL TBCINI(ITNO,D_R4_FORMAT,1,'F7.1','DEGREES',
     ,                   LAB,IC(NC),IERR)
         NC = NC + 1
  100 CONTINUE
C
C     GET FOURIER COEFFICIENTS FROM EACH RADIUS
C
      R  = RI
      DO 200, I = 1,NR
         RP = R / STEP(1)
         CALL APFFTC(MADRID(PNTR),NPIX(1),NPIX(2),XC,YC,RP,PA,AI,
     ,               MFC,MC,AMP,PHA,AN)
         IF (MC.GE.MFC) THEN
            IF (LFPHA) THEN
               LFPHA = .FALSE.
               PH(1) = 0.0
               DO 250, IX = 2, MFC
                  DIF = PI2 / FLOAT(IX-1)
                  IDF = INT((PHA(IX)-PH(IX-1))/DIF+100.5) - 100
                  PH(IX) = PHA(IX) - FLOAT(IDF)*DIF
  250          CONTINUE
            ENDIF
            CALL PHAMOD(PHA,PH,MFC)
            ROW(1) = R
            ROW(2) = LOG(R)
            ROW(3) = 2 * MC
            ROW(4) = AMP(1)
            ROW(5) = AN / AMP(1)
            NC = 6
            DO 300, N = 2,MFC
               ROW(NC) = AMP(N) / AMP(1)
               NC = NC + 1
               ROW(NC) = PHA(N) / DTR
               NC = NC + 1
  300       CONTINUE
            CALL TBRWRR(ITNO,I,NCOL,IC,ROW,IERR)
         ENDIF
         R  = R + DR
  200 CONTINUE
      WRITE(MSG,620) IDEN,RI,DR,NR
  620 FORMAT(' IDEN,RI,DR,NR :',A18,3X,2F10.1,I8)
      CALL STTPUT(MSG,IERR)
C
C     FINISHED - EXIT
C
      CALL TBSINI(ITNO,IERR)
      CALL TBTCLO(ITNO,IERR)
      CALL STSEPI
      END

C @(#)iperd.for	19.1 (ES0-DMD) 02/25/03 13:29:43
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      SUBROUTINE IPERD (X,Y,Z,C,N,I,SQM,IN)
C+++     
C.Purpose: npa: numero parametri pari a (i**2)+3*i+2)/2
C---     
      IMPLICIT         NONE
      INTEGER          NPA
      PARAMETER        (NPA=35)
      DOUBLE PRECISION X(1)
      DOUBLE PRECISION Y(1)
      DOUBLE PRECISION Z(1)
      DOUBLE PRECISION C(1)
      INTEGER          N
      INTEGER          I
      REAL             SQM
      INTEGER          IN
C
      INTEGER          NB
      INTEGER          K, J, L, LL
      INTEGER          IL, NE
      INTEGER          ISTAT
      REAL             VZ
      DOUBLE PRECISION VD(NPA,NPA),V(NPA)
      DOUBLE PRECISION VF,AA,BB
      CHARACTER        STRING*80
C
  901 FORMAT('       SQM = ',E12.5)
C
C *** initialize parameters
      SQM = 0.
      NB  = 1
      DO 10 K=1,NPA
         C(K)=0.
         DO 11 J=1,NPA
            VD(K,J)=0.
  11     CONTINUE
  10  CONTINUE
C
C *** fit the data
      DO 20 L = 1,N
         IN = 0
         DO 30 K = 0,I,1
            DO 40 J = 0,I-K,1
               IN    = IN+1
               V(IN) = (X(L)**J)*(Y(L)**K)
               IF (IN.GT.1) THEN
                  VD(1,IN) = VD(1,IN)+V(IN)
                  VD(IN,1) = VD(1,IN)
                  C(IN)    = C(IN)+Z(L)*V(IN)
                  DO 50 LL = 2,IN
                     VF        = V(IN)*V(LL)
                     VD(LL,IN) = VD(LL,IN)+VF
                     IF (IN.NE.LL) THEN
                        VD(IN,LL)=VD(LL,IN)
                     ENDIF
   50             CONTINUE
               ELSE
                  VD(1,1) = VD(1,1)+V(1)
                  C(1)    = C(1)+Z(L)
               END IF
   40       CONTINUE
   30    CONTINUE
   20 CONTINUE
C
      NE=IN
      CALL LISID(VD,C,NE,NPA)
      DO 60 J=1,N
         IL=0
         VZ=0.
         DO 70 L=0,I
            DO 80 K=0,I-L
               IL = IL+1
               IF (K.EQ.0.AND.X(J).EQ.0.) THEN
                 AA = 1.
               ELSE 
                 AA = X(J)**K
               END IF
C
               IF (L.EQ.0.AND.Y(J).EQ.0.) THEN
                  BB = 1.
               ELSE
                  BB = Y(J)**L
               END IF
               VZ = VZ+AA*BB*C(IL)
   80       CONTINUE
   70    CONTINUE
         SQM = SQM+(Z(J)-VZ)**2
   60 CONTINUE
C
      SQM = SQRT(SQM/FLOAT(N))
      WRITE(STRING,901) SQM
      CALL STTPUT(STRING,ISTAT)
      RETURN
      END

#!/bin/sh
cd $HOME/midwork
rm -f Midas_*
rm -f FORGR* 
rm -f MIDAS*.PID
rm -f RUN* 
rm -f midjo* 
rm -f idisav*
rm -f idiserv*
rm -f midtemp*
rm -f sxw*
rm -f getXdepth**
echo directory $MID_WORK cleaned...

#!/bin/sh
# -----------------------------------------------------------------------
#
# Bourne shell procedure  devices.sh
# define logical devices names (Environment) for MIDAS on UNIX system
# 901203 CG. New directory structure.
# 910920 KB. Change PRINTER to LPRINT, add PLASER
#
# 110516	last modif
# 
# -----------------------------------------------------------------------
#
# Tape devices:
# Syntax: <MIDAS_name>=<host>:<device_name> ;export <MIDAS_name> # Comment
#
# Automatic generation of "./prim/help/tapede.alq" for the MIDAS command:
#
#   Midas> HELP [TapeDevices]
#
# if comments follows the convention: 	# :tape:model:capacity/density:location
#
# Example. The entry:
#   tape0:ns0:/dev/nrst17 ;export tape0 # :1/2 inch:6250 dpi:Tape-room
#
# will generate an entry in the "tapede.alq" file as follow: 
#
#   01234567890123456789012345678901234567890123456789012345678901234567890
#   Name      Host      Device         Tape      Cap/Den   Location
#   tape0     ns0       /dev/nrst17    1/2 inch  6250 bpi  Tape-room
#
# If your output does not fit the format you are welcome to modify the script
# "./prim/help/gentapedev.sh"
#
# To generate your "tapede.alq" type in the directory ./prim/help/:
#   % make tapede.alq
#
#tape1=ws1:/dev/nrst12  ;export tape1  #:1/2 in.:6250 bpi:User room 2nd floor
#tape1m=ws1:/dev/nrst12 ;export tape1m #:1/2 in.:1600 bpi:User room 2nd floor
#tape1h=ws1:/dev/nrst20 ;export tape1h #:1/2 in.:6250 bpi:User room 2nd floor
#
#tapedat0=ip1:/dev/nrst1 ;export tapedat0 #:DAT/DDS:1.2Gb:IPG room 4th floor
#
#tape8mm0=ip1:/dev/nrst2 ;export tape8mm0 #:8mm:2.2 Gb:IPG room 4th floor 
#tape8mm1=ws8:/dev/nrst2 ;export tape8mm3 #:8mm:2.2 Gb:SkyLight room 5th floor
#
#tapect1=ws0:/dev/nrst8 ;export tapect1	 #:QIC-24:60 Mb:User room 2nd floor
#tapect2=ws5:/dev/nrst0 ;export tapect2   #:QIC-24:60 Mb:User room 2nd floor
#
# Printer devices:
# Syntax: <MIDAS_name>=<printer_name> ; export <MIDAS_name>	# comment
#
LPRINT=lp2usr1   ;export LPRINT     # Line printer, 2nd floor, user room
LASER=ps2usr0    ;export LASER      # Postcript B/W, 2nd floor, user room
COLOUR=pc2usr0.c   ;export COLOUR   # Postcript Color, 2nd floor, user room
SLIDE=sl2usr0    ;export SLIDE      # Chromascript, 2nd floor, user room
PENPLOT=hp2usr0  ;export PENPLOT    # HP plotter, 2nd floor, user room

#!/bin/sh
# 
# shell script calib_build to install the calibration data tables
# optional parameter = directory containing compressed tarfile
# calib.tar.Z
# 
# variables MIDASHOME and MIDVERS must be set already!
# 
# K. Banse      041126
#
#.VERSION
# 041126	last modif

if [ -d $MIDASHOME/$MIDVERS ] ; then
   echo "MIDASHOME/MIDVERS = $MIDASHOME/$MIDVERS"
else
   echo env. var. MIDASHOME and/or MIDVERS not set... we abort
   exit 1
fi

cd $MIDASHOME
if  [ $# = 1 ]; then
   if [ ! -f $1/calib.tar.Z ] ; then
      echo file calib.tar.Z not found in $1 ... check that directory
      exit 1
   else
      echo copying calib.tar.Z from $1
      sleep 1
      cp $1/calib.tar.Z .
   fi
else
   if [ ! -f calib.tar.Z ] ; then
      if [ -f calib.tar ] ; then
         echo we use uncompressed file calib.tar found in $MIDASHOME
         sleep 2
      else
         echo neither file calib.tar.Z nor calib.tar found in $MIDASHOME
         echo use: calib_build dir_containing_compressed_calib_tarfile
         echo to copy the file first
         exit 1
      fi
   fi
fi

if [ -f calib.tar.Z ] ; then
   uncompress calib.tar.Z
fi

tar xvf calib.tar

cd calib/install
. dbassign.sh

echo "  "
echo in `pwd` we execute Midas
echo inmidas -j "@@ caldb; @@ filters; bye"
sleep 2

$MIDASHOME/$MIDVERS/system/unix/inmidas -j "@@ caldb; @@ filters; bye"

# get rid of temp. dirs

cd ..
rm -rf raw install

echo "   "
echo finishing up in `pwd`
 

! @(#)communi.cmd	19.1 (ESO-DMD) 02/25/03 13:58:39 
! 
! verification procedure for communication interfaces
! this is executed automatically by entering:
! communi.exe verify xy
! with xy = Midas unit (defaulted to 00)
! 
! K. Banse	ESO-Garching	960116, 990830
! 
c
write/key klaus/c*3/1/5 abc all
c 
read/key klaus
XCKWRC*3 klaus,3,3,j
c 
read/key klaus
XCKRDC*3 klaus,4,1
XCKRDC*6 klaus,2,1
! 
c,read/keyw aux_mode
! 
XCKRDI mode
! 
c,create/image &a 2,256,256 ? gauss 128,32,128,32
! 
c,create/disp 0 360,360,660,400
c,load/image &a
c,load/lut rainbow4
c,disp/lut
c,label/display Gauss_Image 290,64 ? ? 1
c 0
fft/freq &a
! 
w
! 
c,clear/chan ov
c,load/image fftr cuts=-0.00000000001,0.00000000001
c,label/display Real_FFT 290,64 ? black 1
c,wait/secs 2
xx
! 

#!/bin/sh
# -----------------------------------------------------------------------
# 
# Bourne-shell procedure  midlogs.sh  
# define logical names needed for running MIDAS
# K. Banse  910211, 920317, 980513, 991014, 000918
# C. Guirao 920221, 940121
# 050427	last modif
# 
# -----------------------------------------------------------------------
# 
MID_HOME=$MIDASHOME/$MIDVERS    ; export MID_HOME
if [ -z "$PIPE_HOME" ]; then
   PIPE_HOME=$MID_HOME/pipeline ; export PIPE_HOME
fi
MID_INCLUDE=$MID_HOME/incl 	; export MID_INCLUDE
#
SYS_EXE=$MID_HOME/system/exec	; export SYS_EXE
MID_EXE=$MID_HOME/prim/exec	; export MID_EXE
APP_EXE=$MID_HOME/applic/exec	; export APP_EXE
STD_EXE=$MID_HOME/stdred/exec	; export STD_EXE
CON_EXE=$MID_HOME/contrib/exec	; export CON_EXE
GUI_EXE=$MID_HOME/gui/exec      ; export GUI_EXE
UVES_EXE=$PIPE_HOME/uves/exec   ; export UVES_EXE
#
MID_PROC=$MID_HOME/prim/proc	; export MID_PROC # executed via @
APP_PROC=$MID_HOME/applic/proc	; export APP_PROC # executed via @a
STD_PROC=$MID_HOME/stdred/proc	; export STD_PROC # executed via @s
CON_PROC=$MID_HOME/contrib/proc	; export CON_PROC # executed via @c
GUI_PROC=$MID_HOME/gui/proc	; export GUI_PROC # executed via @g
XDO_HELP=$MID_HOME/gui/XDo/help ; export XDO_HELP
#
MID_MONIT=$MID_HOME/monit		; export MID_MONIT
MID_CONTEXT=$MID_HOME/context		; export MID_CONTEXT
MID_SETUP=$MID_PROC/setup		; export MID_SETUP
MID_LIB=$MID_HOME/lib			; export MID_LIB
XAPPLRESDIR=$MID_HOME/gui/resource	; export XAPPLRESDIR
# 
MID_SYSTAB=$MID_HOME/systab/bin 	; export MID_SYSTAB
AGL3CONFIG=$MID_HOME/systab/ascii/plot/	; export AGL3CONFIG
MID_HELP=$MID_HOME/prim/help		; export MID_HELP
MID_FIT=$MID_HOME/applic/fit/src	; export MID_FIT
#
MID_CASPEC=$MIDASHOME/calib/data/inst/caspec	; export MID_CASPEC
MID_EFOSC=$MIDASHOME/calib/data/inst/efosc	; export MID_EFOSC
MID_IRSPEC=$MIDASHOME/calib/data/inst/irspec	; export MID_IRSPEC
MID_ARC=$MIDASHOME/calib/data/spec/line		; export MID_ARC
MID_STANDARD=$MIDASHOME/calib/data/spec/flux	; export MID_STANDARD
MID_EXTINCTION=$MIDASHOME/calib/data/spec/exti	; export MID_EXTINCTION
MID_PEPSYS=$MIDASHOME/calib/data/pepsys		; export MID_PEPSYS
MID_FILTERS=$MIDASHOME/calib/data/datatrans	; export MID_FILTERS
MID_EMMI=$MIDASHOME/calib/data/inst/emmi	; export MID_EMMI
MID_FEROS=$MIDASHOME/calib/data/inst/feros	; export MID_FEROS
#
MID_TEDIT=$MID_HELP/tbledit.twh		; export MID_TEDIT
#
# only if directory /midas/version/demo/data exists, use it
# 
if [ -d "$MIDASHOME/demo/data" ]; then
   MID_TEST=$MIDASHOME/demo/data		; export MID_TEST
fi
#
# From start.csh:
TERMCAPFILE=$MID_INCLUDE/termcapfile	; export TERMCAPFILE
DEVCAPFILE=$MID_INCLUDE/devcap.dat	; export DEVCAPFILE
# the end ...

#!/bin/bash
# 
# script for emulating READ/DESCR in Midas
# using keyword file "DESCR.KEY"
# 
# K. Banse	DMD/DFS, ESO - Garching
# 031218	creation
# 040105	last modif
# 
  
# fill keyword file

echo "in_a/c/1/80 $1" > DESCR.KEY
echo action/c/1/2 rb >> DESCR.KEY

if [ $# -lt 2 ]; then
   echo p2/c/1/80 \*\   >> DESCR.KEY
else
   echo "p2/c/1/80 $2"  >> DESCR.KEY
fi

# switch to outside mode + execute
export MIDAS_OUTSIDE=1
$MID_EXE/descr.exe

#! /bin/bash
# @(#)difflogs.sh	19.1 (ESO-DMD) 02/25/03 14:34:02 
# 
# bash shell script `difflogs.sh' to compare the logfiles
# of the verifications of two Midas releases
# ojo: the width of the terminal has to be 80 columns (LOG(10))
# 
# K. Banse		last modif:	030122
# 
# use via $ sh difflogs.sh old logfile new logfile
# 
echo via sed convert $1 to old.log
sed -f $MIDASHOME/$MIDVERS/test/prim/clean.sed $1 >old.log
echo via sed convert $2 to new.log
sed -f $MIDASHOME/$MIDVERS/test/prim/clean.sed $2 >new.log
echo "'diff old.log new.log' yields: " `diff old.log new.log | wc -l` differences
#
diff old.log new.log >./difflogs.txt
#
echo "result of diff command => difflogs.txt"
#

#!/bin/sh
# 
# shell script for running multiple Midas sessions in parallel
# 
# arg1 = root dir (/home/esomidas/tmp)
# arg2 = no. of Midas sessions
# arg3 end time in minutes	(default = 2 minutes)
# 


if [ $# -lt 3 ] ; then
   stop=2			#default to 2 minutes
else
   stop=$3
fi
echo "timeout = $stop minutes"
if [ $# -lt 2 ] ; then
   nsess=1			#default to 1 Midas session
else
   nsess=$2
fi
echo "working with $nsess Midas sessions"
if [ $# -lt 1 ] ; then
   rootdir="/home/esomidas/tmp"
else
   rootdir=$1
fi
echo "working in $rootdir"

cd $rootdir
pwd

loop=0

while [ $loop -lt $nsess ] 
do
   if [ ! -d testdir$loop ] ; then
      mkdir testdir$loop
      echo making dir: testdir$loop
   fi

   cd testdir$loop
   rm -rf *
   cp ../wcs.bdf .

   ~/test/system/unix/inmidas -P 0$loop -j "@@ multi $stop" &

   cd $1
   loop=$(( $loop + 1 ))
done

#! /bin/sh
# @(#)testaccs.sh	19.1 (ESO-IPG) 02/25/03 14:09:14
#
# testaccs - test access to given dir.
#
#  K. Banse    last modif:	030124
#

if `touch $1 2>/dev/null`; then
   echo 1
else
   echo 0
fi

#!/bin/bash
# 
# set up the variables MID_MONIT, MID_EXE
# which are needed for Midas programs running
# in "outside mode"
# 
# K. Banse	ESO - Garching
# 040105	last modif
# 
## set -x
 
if [ $MIDVERS = "test" ] ; then
   export MIDASHOME=${HOME}/midas
else
   export MIDASHOME=home/esomidas
   export MIDVERS=04SEP
fi

export MID_MONIT=${MIDASHOME}/${MIDVERS}/monit
export MID_EXE=${MIDASHOME}/${MIDVERS}/prim/exec

export PATH=${PATH}:${MIDASHOME}/${MIDVERS}/outside

#! /bin/sh
# @(#)helpmidas.sh	19.1 (ESO-IPG) 02/25/03 14:31:59
# .COPYRIGHT: Copyright (c) 1988 European Southern Observatory,
#
# .TYPE         command
# .NAME         helpmidas
# .LANGUAGE     Bourne-shell script
# .ENVIRONMENT  Unix Systems. Executable under any SHELL.
# .USAGE        helpmidas [-h midashome] [-r midvers] [-d display] [-m mid_work]
#		  display:   X server for display and graphical windows.
#		  midashome: Home directory for MIDAS. (default: MIDASHOME0)
#		  midvers:   Version of MIDAS. (default: MIDVERS0)
#		  mid_work:  MIDAS startup directory (default: $HOME/mid_work)
#
# .COMMENTS     Script to start MIDAS Help. It uses the following environment:
#		MIDASHOME and MIDVERS variables if they exist, otherwise 
#	        takes defaults.
#		It checks arguments if any and exec to $GUI_EXE/XHelp.exe
#
# .REMARKS      MIDASHOME0 & MIDVERS0 are set to defaults values by option
#               "8- MIDAS setup" in the MIDAS "config" script.
#
# .VERSION 1.1	930803:	CG. Implementation
#**************************************************************************

#**************************************************************************
# Configure Here: 
# ---------------
# Modify the default values of MIDASHOME0 and MIDVERS0 
# accordingly to your site. 
#
# Environment variables MIDASHOME and MIDVERS overwrite these defaults.
#
# Done automaticaly by option "8- setup MIDAS" in the "config" script.
#
MIDASHOME0=/midas
MIDVERS0=95NOV
#
# END of Configure Here
#**************************************************************************

# Check for options:
#
while [ -n "$1" ]
do
  case $1 in
  -h)  MIDASHOME=$2; export MIDASHOME; shift; shift ;;
  -r)  MIDVERS=$2; export MIDVERS; shift; shift ;;
  -d)  DISPLAY=$2; export DISPLAY; shift; shift ;;
  -m)  MID_WORK=$2; export MID_WORK; shift; shift ;;
  *)  echo "Usage: helpmidas [-h midashome] [-r midvers] "
       echo "[-d display]  [-m mid_work]"
       exit 1 ;;
  esac
done

#
# If MIDASHOME variable not defined then set to default.
#
if [ -z "$MIDASHOME" ]; then
  if [ -z "$MIDASHOME0" ]; then
    echo "Environment variable MIDASHOME not defined" 
    echo "and no default MIDASHOME0 found in this script. EXIT." 
    exit 1
  else
    MIDASHOME="$MIDASHOME0"; export MIDASHOME
  fi
fi

#
# If MIDVERS variable not defined then set to default.
#
if [ -z "$MIDVERS" ]; then
  if [ -z "$MIDVERS0" ]; then
    echo "Environment variable MIDVERS not defined"
    echo "and no default MIDVERS0 found in this script. EXIT."
    exit 1
  else
    MIDVERS="$MIDVERS0"; export MIDVERS
  fi
fi

#
# Check access to directories and files
#
if [ ! -d $MIDASHOME ]; then
  echo "${MIDASHOME}: not such directory."
  echo "Call your MIDAS operator. EXIT."
  exit 1
fi
if [ ! -d $MIDASHOME/$MIDVERS ]; then
  echo "$MIDASHOME/${MIDVERS}: not such directory."
  echo "Call your MIDAS operator. EXIT."
  exit 1
fi

#
# get all the variables (logical names)
#
if [ -f $MIDASHOME/$MIDVERS/monit/midlogs.sh ]; then
  . $MIDASHOME/$MIDVERS/monit/midlogs.sh
else
  echo "$MIDASHOME/$MIDVERS/monit/midlogs.sh not such file."
  echo "Call your MIDAS operator. EXIT."
  exit 1
fi

#
# if necessary create MIDAS work directory
#
if [ -z "$MID_WORK" ]; then
  MID_WORK=$HOME/midwork/ ; export MID_WORK
fi

#
# if last char. of MID_WORK != '/'  append a '/'
#
if [ `expr $MID_WORK : '.*\(.\)'` != '/' ]; then
  MID_WORK=$MID_WORK/ ; export MID_WORK
fi

if [ ! -d $MID_WORK ]; then
  mkdir `expr $MID_WORK : '\(.*\).'`         #use MID_WORK except last char.
  if [ $? != 0 ]; then
    echo Could not create directory `expr $MID_WORK : '\(.*\).'`
    exit 1
  fi
fi

if [ -f $MID_MONIT/syskeys.unix ]; then
  SYSKEYS=$MID_MONIT/syskeys.unix
elif [ -f $MID_MONIT/syskeys.dat ]; then
  SYSKEYS=$MID_MONIT/syskeys.dat
else
  echo "No such file: $MID_MONIT/syskeys.unix or $MID_MONIT/syskeys.dat"
  exit 1
fi

mail=`awk -F/ '{ if (found == 1) {print $0; exit } if ($1 == "MID$MAIL") found=1 }' $SYSKEYS`

print=`awk -F/ '{ if (found == 1) {print $0; exit } if ($1 == "SYSCOMS") found=1 }' $SYSKEYS | sed -e 's/....................\(....................\).*/\1/'`

#echo MIDVERS=$MIDVERS
#echo mail=$mail
#echo print=$print
#echo MID_CONTEXT=$MID_CONTEXT
#echo MID_WORK=$MID_WORK
#echo GUI_EXE=$GUI_EXE

#
# Set PATH for shared libraries
#
os=`uname`
case "$os" in
    "SunOS"|"Linux")
	if [ -z "$LD_LIBRARY_PATH" ] ; then
	  LD_LIBRARY_PATH=$MIDASHOME/$MIDVERS/lib
	else
	  LD_LIBRARY_PATH=$MIDASHOME/$MIDVERS/lib:$LD_LIBRARY_PATH
	fi
	export LD_LIBRARY_PATH
	;;
    "HP-UX")
	if [ -z "$SHLIB_PATH" ] ; then
	  SHLIB_PATH=$MIDASHOME/$MIDVERS/lib
	else
	  SHLIB_PATH=$MIDASHOME/$MIDVERS/lib:$SHLIB_PATH
	fi
	export SHLIB_PATH
	;;
     *)
	;;
esac

# 
# run help.exe (94NOV) or XHelp.exe
#
if [ -f $GUI_EXE/help.exe ]; then
  echo "Preparing the HELP graphic user interface..."
  $GUI_EXE/help.exe $MIDVERS $mail "$print" $MID_CONTEXT $MID_WORK " "  &
elif  [ -f $GUI_EXE/XHelp.exe ]; then
  echo "Preparing the XHelp user interface..."
  $GUI_EXE/XHelp.exe $MIDVERS $mail "$print" $MID_CONTEXT $MID_WORK " "  &
else
  echo "No such file: $GUI_EXE/XHelp.exe"
  exit 1
fi

exit 0

#!/bin/sh
# @(#)rebcref.sh	19.1 (ESO-IPG) 02/25/03 14:09:14
# 
# Shell procedure rebcref.sh
# called from the midas procedure t2rebitbl.prg
# used to compile user functions
# author: M. Peron


cp $MIDASHOME/$MIDVERS/prim/table/src/tintertbl.mod .
$MIDASHOME/$MIDVERS/system/exec/esoext.exe -f rebu01.for
f77 -c rebu01.f
f77 tintertbl.mod  $MID_LIB/ftablib.a $MID_LIB/genlib.a $MID_LIB/twlib.a  $MID_LIB/tabuser.a $MID_LIB/midaslib.a -o tintertbl.exe
strip tintertbl.exe

#! /bin/sh

# this is the IDI server in debug mode
# 1st start a Midas session with unit AX
# 2nd start this script
#
DAZUNIT=AX
export DAZUNIT
WORK_STATION=DAZAX
export WORK_STATION
I_TYPE="SXW  "
export I_TYPE
MID_WORK=$HOME/midwork/
export MID_WORK
MID_SYSTAB=$MIDASHOME/$MIDVERS/systab/bin
export MID_SYSTAB
# 
gdb $MIDASHOME/$MIDVERS/system/exec/idiserv.exe 
exit

#! /bin/sh
# @(#)DHSlink.sh	19.1 (ESO-IPG) 02/25/03 14:10:52
#
# Bourne shell script  DHSlink.sh  for VLT pipeline
# K. Banse      980605, 981215
#
# this script sets a link in the directory $DFS_DATA_REDUCED_OLAS 
# to the result file
# (usually with path to DFS_PRODUCT) and sets resfile to readonly protection
#
#
chmod a-w+r $1
# 
ln -s $1 $DFS_DATA_REDUCED_OLAS/$2 

#! /bin/sh
# .COPYRIGHT: Copyright (c) 1988-2006 European Southern Observatory,
#                                         all rights reserved
# .TYPE           command
# .NAME           ftoc_params.sh
# .LANGUAGE       shell script
# .ENVIRONMENT    Unix Systems. Executable under SHELL and C-SHELL
# .COMMENTS  	  Test for Fortran to C interface     
# .REMARKS
# .AUTHOR         Carlos Guirao
# .VERSION 1.1    02-Jan-1991:	Implementation
# .VERSION 1.2    04-Oct-1991:	eval has been deleted because apollo complains.
#				but could also be used within quotes.
# 060301	last modif


show_result()
{
echo  ftoc_${FTOC_PARAM}.h          #return the result include file

echo "" >&2
echo "#################################################################" >&2
echo  ftoc_${FTOC_PARAM}.h matches local compiler \(copied to ftoc.h\) >&2
echo "#################################################################" >&2
echo "" >&2

exit
}

#
# <dirname> emulated with <sed>
#   DIR=`dirname $0`
# 
DIR=`echo $0 | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`

echo .................... trying ftoc_sun.h ............................. >&2
if [ -f $DIR/ftoc_sun.exe -a -s $DIR/ftoc_sun.exe ] ; then
        $DIR/ftoc_sun.exe >/dev/null 2>&1
        if [ $? -eq "0" ] ; then
           FTOC_PARAM="sun"
           show_result
        fi
fi

echo .................... trying ftoc_hp.h .............................. >&2
if [ -f $DIR/ftoc_hp.exe -a -s $DIR/ftoc_hp.exe ] ; then
        $DIR/ftoc_hp.exe >/dev/null 2>&1
        if [ $? -eq "0" ] ; then
           FTOC_PARAM="hp"
           show_result
        fi
fi

echo .................... trying ftoc_hpr.h .............................. >&2
if [ -f $DIR/ftoc_hpr.exe -a -s $DIR/ftoc_hpr.exe ] ; then
        $DIR/ftoc_hpr.exe >/dev/null 2>&1
        if [ $? -eq "0" ] ; then
           FTOC_PARAM="hpr"
           show_result
        fi
fi

echo .................... trying ftoc_hpn.h .............................. >&2
if [ -f $DIR/ftoc_hpn.exe -a -s $DIR/ftoc_hpn.exe ] ; then
        $DIR/ftoc_hpn.exe >/dev/null 2>&1
        if [ $? -eq "0" ] ; then
           FTOC_PARAM="hpn"
           show_result
        fi
fi

echo .................... trying ftoc_pc.h ............................... >&2
if [ -f $DIR/ftoc_pc.exe -a -s $DIR/ftoc_pc.exe ] ; then
        $DIR/ftoc_pc.exe >/dev/null 2>&1
        if [ $? -eq "0" ] ; then
           FTOC_PARAM="pc"
           show_result
        fi
fi

echo .................... trying ftoc_osf.h .............................. >&2
if [ -f $DIR/ftoc_osf.exe -a -s $DIR/ftoc_osf.exe ] ; then
        $DIR/ftoc_osf.exe >/dev/null 2>&1
        if [ $? -eq "0" ] ; then
           FTOC_PARAM="osf"
           show_result
        fi
fi

echo .................... trying ftoc_osf2.h ............................. >&2
if [ -f $DIR/ftoc_osf2.exe -a -s $DIR/ftoc_osf2.exe ] ; then
        $DIR/ftoc_osf2.exe >/dev/null 2>&1
        if [ $? -eq "0" ] ; then
           FTOC_PARAM="osf2"
           show_result
        fi
fi

echo .................... trying ftoc_axp.h .............................. >&2
if [ -f $DIR/ftoc_axp.exe -a -s $DIR/ftoc_axp.exe ] ; then
        $DIR/ftoc_axp.exe >/dev/null 2>&1
        if [ $? -eq "0" ] ; then
           FTOC_PARAM="axp"
           show_result
        fi
fi

echo .................... trying ftoc_pc3.h .............................. >&2
if [ -f $DIR/ftoc_pc3.exe -a -s $DIR/ftoc_pc3.exe ] ; then
        $DIR/ftoc_pc3.exe >/dev/null 2>&1
        if [ $? -eq "0" ] ; then
           FTOC_PARAM="pc3"
           show_result
        fi
fi

echo .................... trying ftoc_solaris.h .......................... >&2
if [ -f $DIR/ftoc_solaris.exe -a -s $DIR/ftoc_solaris.exe ] ; then
        $DIR/ftoc_solaris.exe >/dev/null 2>&1
        if [ $? -eq "0" ] ; then
           FTOC_PARAM="solaris"
           show_result
        fi
fi

echo .................... trying ftoc_alliant.h .......................... >&2
if [ -f $DIR/ftoc_alliant.exe -a -s $DIR/ftoc_alliant.exe ] ; then
        $DIR/ftoc_alliant.exe >/dev/null 2>&1
        if [ $? -eq "0" ] ; then
           FTOC_PARAM="alliant"
           show_result
        fi
fi

echo .................... trying ftoc_fx.h ............................... >&2
if [ -f $DIR/ftoc_fx.exe -a -s $DIR/ftoc_fx.exe ] ; then
        $DIR/ftoc_fx.exe >/dev/null 2>&1
        if [ $? -eq "0" ] ; then
           FTOC_PARAM="fx"
           show_result
        fi
fi

echo .................... trying ftoc_amd64.h ............................ >&2
if [ -f $DIR/ftoc_amd64.exe -a -s $DIR/ftoc_amd64.exe ] ; then
        $DIR/ftoc_amd64.exe >/dev/null 2>&1
        if [ $? -eq "0" ] ; then
           FTOC_PARAM="amd64"
           show_result
        fi
fi

echo .................... trying ftoc_amd64gcc4.h ......................... >&2
if [ -f $DIR/ftoc_amd64gcc4.exe -a -s $DIR/ftoc_amd64gcc4.exe ] ; then
        $DIR/ftoc_amd64gcc4.exe >/dev/null 2>&1
        if [ $? -eq "0" ] ; then
           FTOC_PARAM="amd64gcc4"
           show_result
        fi
fi



echo "" >&2
echo "#################################################################" >&2
echo "# ftoc_params: ERROR. Unexpected Fortran to C interface      	#" >&2
echo "# Unable to set your <ftoc.h> file                           	#" >&2
echo "# MIDAS installation will fail if you do not set your own    	#" >&2
echo "# <ftoc.h> in \$MIDASHOME/\$MIDVERS/incl                     	# ">&2
echo "#                                                            	#" >&2
echo "# Please report this to ESO-IPG.                             	#" >&2
echo "#         INTERNET:midas@eso.org                             	#" >&2
echo "#################################################################" >&2
echo "" >&2
exit 1
 

#! /bin/sh
# @(#)help.sh	19.1 (ESO-IPG) 02/25/03 13:51:10
# .COPYRIGHT: Copyright (c) 1988 European Southern Observatory,
#                                         all rights reserved
# .TYPE           command
# .NAME           help.sh 
# .LANGUAGE       shell script
# .ENVIRONMENT    Unix Systems. Executable under SHELL and C-SHELL
# .COMMENTS       Installation procedure of the MIDAS system starting from
#                 scratch.
#                 Usage: help 
#
# .AUTHOR         Carlos Guirao
# .VERSION 1.1    14-Oct-1988:		Implementation
# .VERSION 1.2    05-Dec-1989:		Adding "echo" definition
echo=echo
if [ "`echo -n`" = "-n" ] ; then
        SV_NONL="\c"
else
        echo="echo -n"
fi

#
# First of all, goto the config directory MID_INSTALL
# <dirname> & <basename> commands emulated with <sed>
#   cd `dirname $0`
#   MIDVERS=`basename $VERSDIR`
#   MIDASHOME=`dirname $VERSDIR`
#
if [ -z "$MIDASHOME" -o -z "$MIDVERS" ] ; then
    cd `echo $0 | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
    MID_INSTALL=`pwd`
    VERSDIR=`echo $MID_INSTALL | sed 's/\/install\/unix$//'`
    MIDVERS=`echo $VERSDIR | sed -e 's/^.*\///'`
    MIDASHOME=`echo $VERSDIR | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
else
    cd $MIDASHOME/$MIDVERS/install/unix
fi

MID_INSTALL=$MIDASHOME/$MIDVERS/install/unix
MID_HOME=$MIDASHOME/$MIDVERS

#
# START
#
clear

task="unknown"
while true
do
echo ""
echo "		MIDAS HELP MENU:"
echo "	========================================"
echo "	0 Config MIDAS."
echo "	1 List and description of MIDAS packages."
echo "	2 Select only required packages."
echo "	3 Select all packages."
echo "	4 Select MIDAS core & packages of your choice."
echo "	5 Preinstall MIDAS."
echo "	6 Install MIDAS."
echo "	7 Update MIDAS."
echo "	8 Setup MIDAS."
echo "	9 Clean MIDAS."
echo "	q QUIT"
echo ""
$echo "	Select: " $SV_NONL

read task
task=`echo $task | tr A-Z a-z`

case $task in
	0) 
	   clear
	   cat $MID_HOME/doc/install/config.doc | more
	   ;;
	1) 
	   clear
	   cat $MID_HOME/doc/install/list.doc | more
	   ;;
	2) 
	   clear
	   cat $MID_HOME/doc/install/select.doc | more
	   ;;
	3) 
	   clear
	   cat $MID_HOME/doc/install/select.doc | more
	   ;;
	4) 
	   clear
	   cat $MID_HOME/doc/install/select.doc | more
	   ;;
	5) 
	   clear
	   cat $MID_HOME/doc/install/preinstall.doc | more
	   ;;
	6) 
	   clear
	   cat $MID_HOME/doc/install/install.doc | more
	   ;;
	7) 
	   clear
	   cat $MID_HOME/doc/install/update.doc | more
	   ;;
	8) 
	   clear
	   cat $MID_HOME/doc/install/setup.doc | more
	   ;;
	9) 
	   clear
	   cat $MID_HOME/doc/install/cleanm.doc | more
	   ;;
	q) 
	   clear 
	   exit
	   ;;
	*) echo "	Selection unknown"
	   ;;
esac
echo ""
$echo "Type <RETURN> to continue...." $SV_NONL
read key
clear
done

#! /bin/sh
#  @(#)ftoc_nam.sh	19.1 (ESO-IPG) 02/25/03 14:31:08
# .COPYRIGHT: Copyright (c) 1988 European Southern Observatory,
#                                         all rights reserved
# .TYPE           command
# .NAME           ftoc_nam.sh
# .LANGUAGE       shell script
# .ENVIRONMENT    Unix Systems. Executable under SHELL and C-SHELL
# .COMMENTS       Test for Fortran to C interface. The output is used in
#		  the compilation of the file "ftoc_vmrc.fc".
# .REMARKS
# .AUTHOR         Carlos Guirao
# .VERSION 1.1    02-Jul-1992:  Implementation

# <dirname> emulated with <sed>
#   DIR=`dirname $0`
DIR=`echo $0 | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`

value=`$DIR/ftoc_names.exe`
case $value in
-fl) echo "-DNAMES=0" ;;
-fl_) echo "-DNAMES=1" ;;
-f_l_) echo "-DNAMES=2" ;;
-f_l) echo "-DNAMES=3" ;;
-fu) echo "-DNAMES=4" ;;
-fu_) echo "-DNAMES=5" ;;
-f_u_) echo "-DNAMES=6" ;;
-f_u) echo "-DNAMES=7" ;;
*)
esac

#!/bin/sh
# @(#)ld77.sh	19.1 (ESO-IPG) 02/25/03 14:31:59

# 
# Script to link Fortran with C in PC/Alpha using f2c 
# The script just rewrites the link command putting the arguments -lf2c -lm at
# the end. Otherwise the linker will report not resolve definitions 

exec cc `echo $* | sed 's/-o/-lf2c -lm -o/'`

#!/bin/sh
# @(#)fitrepf.sh	19.1 (ESO-IPG) 02/25/03 13:20:10
# Shell procedure fitcref.sh 
# called from fitcref.prg as $fitcref.sh
# Michele Peron    900215
# Carlos Guirao	   921224
# Carlos Guirao	   000609

rm -f fitcrea.o fitimag.o funcrea.o makefile.fit
cp $MID_LIB/libfituser.a .
cp $MID_FIT/fitcrea.mod .           
cp $MID_FIT/fitimag.mod .
cp $MID_FIT/funcrea.mod funcrea.o
cp $MID_FIT/makefile.fit makefile.fit

IFS="$IFS,"
set - $1
while [ $# -gt 0 ]
do
  OBJ="$OBJ $1.o"
  shift
done
rm -f $OBJ

make -i -f makefile.fit OBJ="$OBJ" OUT="fitcrea.exe fitimag.exe funcrea.exe"

#! /bin/sh
# @(#)onehlc.sh	19.1 (ESO-IPG) 02/25/03 14:03:31
# 
#  Bourne shell script "onehlc.sh"
#  to build single .hlc file from a group of .hlq files
#  901219  KB
#  to use it e.g. for the copy command, do  sh onehlc.sh copy
# 
touch $1.hlc
rm $1.hlc
#
ls $1*.hlq |  sed  's/_.*/ /' | sort -u | sed '/_/d' > temp0
# 
cat temp0 | sed 's/\.hlq//' | awk '{print substr($1,1,6)}' | sort -u > temp1
#
for i in `cat temp1`
do
   for file in `ls $i*.hlq`
   do
      sed  -n '/SECTION./,/\\us/p' $file | sed '/^\\/d' | sed '2d' >> $i.hlc
   done
done

#! /bin/bash
# .COPYRIGHT: Copyright (c) 1988-2011 European Southern Observatory,
#                                         all rights reserved
# .TYPE           command
# .NAME           install.sh
# .LANGUAGE       shell script
# .ENVIRONMENT    Unix Systems. Executable under SHELL and C-SHELL
# .COMMENTS       Installation procedure of the MIDAS system starting from
#                 scratch.
#                 
#                 Usage: install [options]
#                 
#                    options: are options for the "make" command. This option
#                             will be exported to all the directories of the
#                             installation procedure.
#			      Multiple definitions for keywords must be:
#				e.g.	CFLAGS=\"-O -g -I/usr/include\"
#			      to avoid quotes to be interpreted by the shell.
#
#                 The command will execute the following steps:
#
#                    - $MID_HOME/local/make_options is read if exists.
#		       It contains local options for "make" commands.
#                        
#		     - MIDAS is structured in "core" (all directories 
#			in file "core.cnf" are included in the installation).
#			and "packages" (optional, they are clasified in 
#			"applic", "stdred" and "contrib".) A package is 
#			selected for installation if it is marked with file
#			"SELECTED".
#
#                    - All the directories involved in the installation are
#                      cleaned by running "make options clean" command. 
#
#                    - Run "make options" in all the directories.
#
# .AUTHOR         Carlos Guirao
# .VERSION 5.1    910725:	New implementation.
# .VERSION 5.2    910827:	Check for file SELECTED when installing package 
# 
# 111116	last modif

umask 002
#
# First of all, goto the config directory MID_INSTALL
# <dirname> & <basename> commands emulated with <sed>
#   cd `dirname $0`
#   MIDVERS=`basename $VERSDIR`
#   MIDASHOME=`dirname $VERSDIR`
#
if [ -z "$MIDASHOME" -o -z "$MIDVERS" ] ; then
    cd `echo $0 | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
    MID_INSTALL=`pwd`
    VERSDIR=`echo $MID_INSTALL | sed 's/\/install\/unix$//'`
    MIDVERS=`echo $VERSDIR | sed -e 's/^.*\///'`
    MIDASHOME=`echo $VERSDIR | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
else
    cd $MIDASHOME/$MIDVERS/install/unix
fi

MID_INSTALL=$MIDASHOME/$MIDVERS/install/unix
MID_HOME=$MIDASHOME/$MIDVERS


echo "*********************************************************************"
echo "******************** MIDAS INSTALLATION PROCEDURE *******************"
echo "*********************************************************************"
echo "******************** MIDASHOME: $MIDASHOME  VERSION: $MIDVERS"
echo "******************** DATE:  `date`"
echo "******************** HOSTNAME: `hostname`"
echo "******************** COMMAND: $0 $*"
echo ""

export OURHOST=$(uname)
			   #for Mac we save internal system info in a file
if [ "$OURHOST" = "Darwin" ]; then
   echo "******************** System used (output from system_profiler):"
   system_profiler > $MID_HOME/tmp/mac_info
   cd $MID_HOME/tmp
   awk -f $MID_INSTALL/getMacInfo.awk ./mac_info
   cat ./mac_system

else
   echo "******************** System used (output from uname -a):"
   uname -a
fi

echo ""
echo "******************** C compiler used (output from cc -v):"
cc -v
echo ""
if [ -f /proc/cpuinfo ]; then
   cat /proc/cpuinfo
fi

#
# Local options for making commands will be read if they exist in the
# $MID_HOME/local/make_options file.
# Other options can be set as arguments in the command line of this script 
#
# These options will replace in $MID_HOME/local/make_options file 
# those definitions with the same name:
# Multiple definitions must be between \" e.g. CFLAGS=\"-O -g -I/local/incl\"
#
if [ -r $MID_HOME/local/make_options ]
then
    echo ""
    echo "*************************************************"
    echo "********* READING YOUR LOCAL OPTIONS ************"
    echo "*************************************************"
    echo "********* Date:  `date`"
    echo ""
    cat $MID_HOME/local/make_options | awk -F# '{print $1}'
    echo ""
fi

echo ""
echo "*************************************************"
echo "********* REMOVING DEPENDENT FILES **************"
echo "*************************************************"
echo "********* DATE:  `date`"
for dir in `awk -F# '{ print $1 }' $MID_INSTALL/core.cnf`
do
    echo ""
    echo "**********************************************"
    echo "****** REMOVING FILES IN $dir"
    echo "**********************************************"
    if [ ! -d $MID_HOME/$dir ]; then
	echo "Warning. $dir .No such directory."
	continue
    fi
    cd $MID_HOME/$dir
    eval make "$@" clean
done

for categ in applic stdred contrib gui
do
    if [ ! -d $MID_HOME/$categ ]; then
        continue
    fi
    cd $MID_HOME/$categ

    for dir in lib exec proc 
    do
	if [ -f $dir/makefile ]; then
	    echo ""
	    echo "**********************************************"
	    echo "****** REMOVING FILES IN  ./$categ/$dir"
	    echo "**********************************************"
	    cd $dir
	    eval make "$@" clean
	    cd $MID_HOME/$categ
	fi
    done

    for pack in `(ls */SELECTED* | awk -F/ '{print $1}' | sort -u) 2>/dev/null`
    do
        for dir in etc libsrc src proc help
        do
          if [ -f $pack/$dir/makefile ]; then
            echo ""
            echo "**********************************************"
            echo "****** REMOVING FILES IN ./$categ/$pack/$dir"
            echo "**********************************************"
            cd $pack/$dir
            eval make "$@" clean
            cd $MID_HOME/$categ
          fi
        done
    done
done
		
echo ""
echo "*************************************************"
echo "********** INSTALLING........ *******************"
echo "*************************************************"
echo "********** DATE:  `date`"
for dir in `awk -F# '{ print $1 }' $MID_INSTALL/core.cnf`
do
    echo ""
    echo "**********************************************"
    echo "****** INSTALLING IN $dir"
    echo "**********************************************"
    echo "****** DATE:  `date`"
    if [ ! -d $MID_HOME/$dir ]; then
	echo "Warning. $dir .No such directory."
	continue
    fi
    cd $MID_HOME/$dir
    eval make "$@" all
done

for categ in applic stdred contrib gui
do
    if [ ! -d $MID_HOME/$categ ]; then
        continue
    fi
    cd $MID_HOME/$categ
    first_packages=`(ls */SELECTED_BY* | awk -F/ '{print $1}' | sort -u) 2>/dev/null`
    if [ -n "$first_packages" ]; then
      excluded=`echo $first_packages | sed -e 's/^/\^/' -e 's/$/\$/' -e 's/ /\$|\^/g'`
      packages=`(ls */SELECTED | awk -F/ '{print $1}' | egrep -v "$excluded") 2>/dev/null`
    else
      packages=`(ls */SELECTED | awk -F/ '{print $1}') 2>/dev/null`
    fi
    for pack in $first_packages $packages
    do
	for dir in etc libsrc src proc help
	do
	  if [ -f $pack/$dir/makefile ]; then
    	    echo ""
    	    echo "**********************************************"
    	    echo "****** INSTALLING IN ./$categ/$pack/$dir"
    	    echo "**********************************************"
	    cd $pack/$dir
	    eval make "$@" all
	    cd $MID_HOME/$categ
	  fi
	done
    done
done
cd $MID_HOME

echo ""
echo "*********************************************************************"
echo "******************** END INSTALLATION PROCEDURE *********************"
echo "*********************************************************************"
echo "********** END DATE:  `date`"
echo "********** SYSTEM: $SYSTEM"

exit

#! /bin/sh
# @(#)make_vms.sh	19.1 (ESO-IPG) 02/25/03 13:51:11
# .TYPE           command
# .NAME           make_vms.sh
# .LANGUAGE       shell script
# .ENVIRONMENT    Unix Systems. Executable under SHELL and C-SHELL
# .COMMENTS       
# .REMARKS        
# .AUTHOR         Carlos Guirao
# .VERSION 1.0    881003	Implementation
# .VERSION 1.1    890712	take out graylib.a  KB
# .VERSION 2.1    901102	New directory structure.
# .VERSION 2.2    911003	Removing makefile.com first.

FILTER=`dirname $0`/switch_filter
#FILTER=$MIDASHOME/$MIDVERS/install/vms/switch_filter

rm -f makefile.com

# Print header for makefile.com file
dir=`pwd | sed -e 's/^.*midas/midas/' -e 's/\//\./g'`
dir=`echo [$dir] | tr "[a-z]" "[A-Z]"` 
echo '$ !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++' \
	| tee makefile.com
echo '$ !' | tee -a makefile.com
echo '$ ! .COPYRIGHT   (c) 1991 European Southern Observatory' \
	| tee -a makefile.com
echo '$ ! .ENVIRONMENT VMS' | tee -a makefile.com
echo '$ ! .AUTHOR      Carlos Guirao - [ESO/IPG]' | tee -a makefile.com
echo '$ ! .IDENT       MAKEFILE.COM' | tee -a makefile.com
echo '$ ! .COMMENTS    Compile/link procedure in' $dir | tee -a makefile.com
echo '$ ! .REMARKS     Automatically generated in Unix with make.vms command' \
	| tee -a makefile.com
echo "$ ! .DATE        `date`" | tee -a makefile.com
echo '$ !' | tee -a makefile.com
echo '$ !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++' \
	| tee -a makefile.com
echo '$ !' | tee -a makefile.com
echo '$ SET NOON' | tee -a makefile.com
echo '$ VERIFY = F$VERIFY(1)' | tee -a makefile.com
rm -rf .hidden
mkdir .hidden
chmod g+w .hidden
mv `make -n clean | grep "rm -f" | sed 's/rm -f//'` .hidden >/dev/null 2>&1
make SYS_PREFIX=vms OSSYS="" VMSLIB="ip8lib.a" XWLIB="xlink.opt" LD77=ldvms LDCC=ldvms -n | $FILTER | tee -a makefile.com
echo '$ IF VERIFY .EQ. 0 THEN SET NOVERIFY' | tee -a makefile.com
mv .hidden/* . >/dev/null 2>&1
rm -rf .hidden

#! /bin/bash
# .COPYRIGHT: Copyright (c) 1988-2011 European Southern Observatory,
#                                         all rights reserved
# .TYPE           command
# .NAME           install1.sh
# .LANGUAGE       shell script
# .ENVIRONMENT    Unix Systems. Executable under SHELL and C-SHELL
# .COMMENTS       Installation procedure of the MIDAS system starting from
#                 scratch.
#                 Usage: install system [options]
#
# .AUTHOR         K. Banse
# .VERSION 1.0  
# 060328	Creation
# 111116	last modif


echo=echo
if [ "`echo -n`" = "-n" ] ; then
  SV_NONL="\c"
else
  echo="echo -n"
fi


# link correct ftoc dir to good-ftoc
# and copy relevant .fc files (+ correct y123.for files)

rm -rf $MID_HOME/system/good-ftoc

if [ -f "$MID_HOME/libsrc/ftoc/ftocc" ] ; then
   ln -s $MID_HOME/system/ftoc $MID_HOME/system/good-ftoc
   echo "*** Use (default) $MID_HOME/system/ftoc"
   MYNO=1
else
   ln -s $MID_HOME/system/ftoc-new $MID_HOME/system/good-ftoc
   echo "*** Use (new) $MID_HOME/system/ftoc-new"
   MYNO=2
fi

echo "*** and copy ...-$MYNO files for f2c work"


cp $MID_HOME/prim/plot/libsrc/yplot-$MYNO.for $MID_HOME/prim/plot/libsrc/yplot.for
cp $MID_HOME/prim/plot/libsrc/getinp-$MYNO.fc $MID_HOME/prim/plot/libsrc/getinp.fc

cp $MID_HOME/libsrc/plot/getaxs-$MYNO.fc $MID_HOME/libsrc/plot/getaxs.fc
cp $MID_HOME/libsrc/plot/pta-$MYNO.fc $MID_HOME/libsrc/plot/pta.fc
cp $MID_HOME/libsrc/plot/ptb-$MYNO.fc $MID_HOME/libsrc/plot/ptb.fc
cp $MID_HOME/libsrc/plot/ptg-$MYNO.fc $MID_HOME/libsrc/plot/ptg.fc
cp $MID_HOME/libsrc/plot/ptk-$MYNO.fc $MID_HOME/libsrc/plot/ptk.fc
cp $MID_HOME/libsrc/plot/pto-$MYNO.fc $MID_HOME/libsrc/plot/pto.fc
cp $MID_HOME/libsrc/plot/ypt-$MYNO.for $MID_HOME/libsrc/plot/ypt.for

cp $MID_HOME/libsrc/agl/yagl-$MYNO.for $MID_HOME/libsrc/agl/yagl.for
cp $MID_HOME/libsrc/agl/fintf-$MYNO.fc $MID_HOME/libsrc/agl/fintf.fc 

cp $MID_HOME/libsrc/idi/cidi/iic-$MYNO.fc $MID_HOME/libsrc/idi/cidi/iic.fc 
cp $MID_HOME/libsrc/idi/cidi/iid-$MYNO.fc $MID_HOME/libsrc/idi/cidi/iid.fc 
cp $MID_HOME/libsrc/idi/cidi/iig-$MYNO.fc $MID_HOME/libsrc/idi/cidi/iig.fc 
cp $MID_HOME/libsrc/idi/cidi/iii-$MYNO.fc $MID_HOME/libsrc/idi/cidi/iii.fc 
cp $MID_HOME/libsrc/idi/cidi/iil-$MYNO.fc $MID_HOME/libsrc/idi/cidi/iil.fc 
cp $MID_HOME/libsrc/idi/cidi/iim-$MYNO.fc $MID_HOME/libsrc/idi/cidi/iim.fc 
cp $MID_HOME/libsrc/idi/cidi/iir-$MYNO.fc $MID_HOME/libsrc/idi/cidi/iir.fc 
cp $MID_HOME/libsrc/idi/cidi/yiic-$MYNO.for $MID_HOME/libsrc/idi/cidi/yiic.for 
cp $MID_HOME/libsrc/idi/cidi/yiid-$MYNO.for $MID_HOME/libsrc/idi/cidi/yiid.for 
cp $MID_HOME/libsrc/idi/cidi/yiig-$MYNO.for $MID_HOME/libsrc/idi/cidi/yiig.for 
cp $MID_HOME/libsrc/idi/cidi/yiii-$MYNO.for $MID_HOME/libsrc/idi/cidi/yiii.for 
cp $MID_HOME/libsrc/idi/cidi/yiim-$MYNO.for $MID_HOME/libsrc/idi/cidi/yiim.for 
cp $MID_HOME/libsrc/idi/cidi/yiir-$MYNO.for $MID_HOME/libsrc/idi/cidi/yiir.for 


cp $MID_HOME/prim/display/libsrc/f2cdsp-$MYNO.fc $MID_HOME/prim/display/libsrc/f2cdsp.fc 
cp $MID_HOME/prim/display/libsrc/yf2cdsp-$MYNO.for $MID_HOME/prim/display/libsrc/yf2cdsp.for 

cp $MID_HOME/prim/general/libsrc/f2cgen-$MYNO.fc $MID_HOME/prim/general/libsrc/f2cgen.fc 
cp $MID_HOME/prim/general/libsrc/f2cgena-$MYNO.fc $MID_HOME/prim/general/libsrc/f2cgena.fc 
cp $MID_HOME/prim/general/libsrc/extrco-$MYNO.fc $MID_HOME/prim/general/libsrc/extrco.fc 
cp $MID_HOME/prim/general/libsrc/clefra-$MYNO.fc $MID_HOME/prim/general/libsrc/clefra.fc 
cp $MID_HOME/prim/general/libsrc/vecsubs-$MYNO.fc $MID_HOME/prim/general/libsrc/vecsubs.fc 
cp $MID_HOME/prim/general/libsrc/stvals-$MYNO.fc $MID_HOME/prim/general/libsrc/stvals.fc 
cp $MID_HOME/prim/general/libsrc/zmstat-$MYNO.fc $MID_HOME/prim/general/libsrc/zmstat.fc 
cp $MID_HOME/prim/general/libsrc/yf2cgen-$MYNO.for $MID_HOME/prim/general/libsrc/yf2cgen.for 
cp $MID_HOME/prim/general/libsrc/yextrco-$MYNO.for $MID_HOME/prim/general/libsrc/yextrco.for 
cp $MID_HOME/prim/general/libsrc/yvecsubs-$MYNO.for $MID_HOME/prim/general/libsrc/yvecsubs.for 
cp $MID_HOME/prim/general/libsrc/ystvals-$MYNO.for $MID_HOME/prim/general/libsrc/ystvals.for 

cp $MID_HOME/contrib/iue/libsrc/istiue-$MYNO.fc  $MID_HOME/contrib/iue/libsrc/istiue.fc 
 
exit 0

#! /bin/sh 
#
# get rid of all temporary files generated by Midas
# in $MID_WORK (usually ~/midwork)
# Klaus Banse ESO - SDD                100908
# 
# 100908	last modif
# 
#**************************************************************************
#
if [ -z "$MID_WORK" ]; then
   echo No $MID_WORK dir. found - we exit
   exit 3
fi

#
cd $MID_WORK
rm -f FORGR* Midas_info* idisave* midlis*.prg midsav*.coms midtab*.prg
rm -f midtemp*.prg sxw*.dat RUNNING*

# ls

echo "  "
echo $MID_WORK cleaned.
exit 0

#!/bin/sh
# @(#)originator.sh	19.1 (ESO-IPG) 02/25/03 14:32:00
# Copyright (C) 1993 Free Software Foundation, Inc.

[ -z "$TMPDIR" ] && TMPDIR=/tmp
TEMP=$TMPDIR/p$$

# Find out the name of the originator of this PR.
if [ -n "$NAME" ]; then
  ORIGINATOR="$NAME"
elif [ -f $HOME/.fullname ]; then
  ORIGINATOR="`sed -e '1q' $HOME/.fullname`"
else 
  grep "^$LOGNAME:" /etc/passwd | cut -f5 -d':' | sed -e 's/,.*//' > $TEMP
  ORIGINATOR="`cat $TEMP`"
  rm -f $TEMP
fi

if [ "$ORIGINATOR" = "" -a -f /bin/domainname ]; then
  if [ "`/bin/domainname`" != "" -a -f /usr/bin/ypcat ]; then
    # Must use temp file due to incompatibilities in quoting behavior
    # and to protect shell metacharacters in the expansion of $LOGNAME
    /usr/bin/ypcat passwd 2>/dev/null | cat - /etc/passwd | grep "^$LOGNAME:" |
      cut -f5 -d':' | sed -e 's/,.*//' > $TEMP
    ORIGINATOR="`cat $TEMP`"
    rm -f $TEMP
  fi
fi

echo $ORIGINATOR
exit 0

#!/bin/sh
# @(#)ittasc.sh	19.1 (ESO-IPG) 02/25/03 14:30:08
# 
# Bourne shell script  ittasc.sh
# to delete lines 1-3 and last line of ascii table file
# and to remove 1. field
# 
sed '1,3d
     $d' $1 >temp.temp
# 
# now we use awk to throw out the sequence field
# 
awk '{ printf "                   %s\n", $2 }' temp.temp >temp.final
# 
mv temp.final $2
rm temp.temp

#! /bin/sh
# @(#)recipe.sh	19.1 (ESO-IPG) 02/25/03 14:10:53
# 
# Bourne shell script  recipe.sh  for VLT/NTT pipeline
# K. Banse	961203
# 
# this script checks if a sub-directory ./tmp_{MidasUnit}_pipe exists
# if so, this subdir is deleted and created afresh
# 
# 
if [ -d ./tmp_$1_pipe ]; then
   rm -f ./tmp_$1_pipe/*
else
   mkdir ./tmp_$1_pipe
fi
# 

#! /bin/sh
# @(#)copy.sh	19.1 (ESO-IPG) 02/25/03 13:51:10
# .TYPE           command
# .NAME           copy.sh
# .LANGUAGE       shell script
# .ENVIRONMENT    Unix Systems. Executable under SHELL and C-SHELL
# .COMMENTS       Copy file in first argument ($1) to the local directory.
#		  If the file exists previously, then it is renamed.
# .AUTHOR         Carlos Guirao
# .VERSION 1.1    27-May-1988:		Implementation

if [ -d $1 ]; then
    if [ ! -d $MIDASHOME/$MIDVERS/local/$1 ]; then
	mkdir $MIDASHOME/$MIDVERS/local/$1
    fi
else
    if [ -f $MIDASHOME/$MIDVERS/local/$1 ]; then
	mv $MIDASHOME/$MIDVERS/local/$1  $MIDASHOME/$MIDVERS/local/${1}~
    fi
    cp $1  $MIDASHOME/$MIDVERS/local/$1
    chmod ug+rw $MIDASHOME/$MIDVERS/local/$1
fi

#! /bin/sh
# @(#)crea_alll.sh	19.1 (ESO-IPG) 02/25/03 14:31:07

# CG. To avoid SCCS keywords to be expanded in the echo command.
A=%
echo "% ${A}W% (ESO-IPG) ${A}G% ${A}U%"
echo ' '

ls *.hlc | awk 'BEGIN{FS="."}{print $1}' | tr a-z A-Z |     \
awk '{ORS = " "} {for (i=1;i<=NF;i++) {l = length($i); \
ORS = substr("             ",1,12-l);                  \
print substr($i,1,12)}}' |                             \
awk '{l = length ($0)} {n = l/72 + 1} {for (i=1;i<=n;i++) \
{s = 72*(i-1) + 1; print substr($0,s,72)}}'

#!/bin/sh
# @(#)environment.sh	19.1 (ESO-IPG) 02/25/03 14:31:59
# Copyright (C) 1993 Free Software Foundation, Inc.

SYSTEM=`( [ -f /bin/uname ] && /bin/uname -a ) || \
        ( [ -f /usr/bin/uname ] && /usr/bin/uname -a ) || echo ""`
ARCH=`[ -f /bin/arch ] && /bin/arch`
MACHINE=`[ -f /bin/machine ] && /bin/machine`

[ -n "$SYSTEM" ] && echo System: $SYSTEM
[ -n "$ARCH" ] && echo Architecture: $ARCH
[ -n "$MACHINE" ] && echo Machine: $MACHINE

exit 0

#! /bin/sh
# @(#)cleanm.sh	19.1 (ESO-IPG) 02/25/03 13:51:09
# .COPYRIGHT: Copyright (c) 1988 European Southern Observatory,
#                                         all rights reserved
# .TYPE           command
# .NAME           cleanm.sh
# .LANGUAGE       shell script
# .ENVIRONMENT    Unix Systems. Executable under SHELL and C-SHELL
# .COMMENTS       Installation procedure of the MIDAS system starting from
#                 scratch.
#                 Usage: install system [options]
#
# .AUTHOR         Carlos Guirao
# .VERSION 1.1    30-Oct-1989:		Installation.
# .VERSION 1.2    05-Dec-1989:		Adding "echo" definition
# .VERSION 1.3    30-Jan-1992:		Adding factor of blocks 
# .VERSION 1.4    15-Oct-1993:		Docomuntation does not exist.

echo=echo
if [ "`echo -n`" = "-n" ] ; then
        SV_NONL="\c"
else
        echo="echo -n"
fi

#
# First of all, goto the config directory MID_INSTALL
# <dirname> & <basename> commands emulated with <sed>
#   cd `dirname $0`
#   MIDVERS=`basename $VERSDIR`
#   MIDASHOME=`dirname $VERSDIR`
#
if [ -z "$MIDASHOME" -o -z "$MIDVERS" ] ; then
    cd `echo $0 | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
    MID_INSTALL=`pwd`
    VERSDIR=`echo $MID_INSTALL | sed 's/\/install\/unix$//'`
    MIDVERS=`echo $VERSDIR | sed -e 's/^.*\///'`
    MIDASHOME=`echo $VERSDIR | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
else
    cd $MIDASHOME/$MIDVERS/install/unix
fi

MID_INSTALL=$MIDASHOME/$MIDVERS/install/unix
MID_HOME=$MIDASHOME/$MIDVERS

#
# START
#
#clear

# 
# Check weather "ls -s" command returns blocks of 1/2 or 1 kbytes.
# The file test_file_1k is 1kbyte big.
factor_ls=`ls -s test_file_1k | awk '{print $1}'`

task="unknown"
while :
do
echo ""
echo "	       MIDAS DELETE MENU:"
echo "	===================================="
echo "	1 - Delete only object files."
echo "	2 - Delete object and source files."
echo "	3 - Delete object, source files and libraries."
echo "	4 - Delete executable files."
echo "	q - Quit."
echo ""
$echo "Select: " $SV_NONL

read task
task=`echo $task | tr A-Z a-z`

echo ""
case $task in
1) 
  echo "1. This option will delete all *.o files under $MID_HOME"
  $echo "   Computing first number of kbytes to be deleted [yn]? (y): " $SV_NONL
  read answ
  if [ -z "$answ" ]; then
    answ=y
  fi
  if [ "$answ" = "y" -o "$answ" = "Y" ]; then
    $echo "   Number of kbytes to be deleted: (wait) " $SV_NONL
    expr `find $MID_HOME -name "*.o" -exec ls -s {} \; \
      | awk '{size += $1} END {printf "%d\n",size}'` / $factor_ls
  fi
  ;;
2) 
  echo "2. This option will delete all *.o *.for *.c files under $MID_HOME"
  $echo "   Computing first number of kbytes to be deleted [yn]? (y): " $SV_NONL
  read answ
  if [ -z "$answ" ]; then
    answ=y
  fi
  if [ "$answ" = "y" -o "$answ" = "Y" ]; then
    $echo "   Number of kbytes to be deleted: (wait) " $SV_NONL
    expr `find $MID_HOME \( -name "*.o" -o -name "*.for" -o -name "*.c" \) \
      -exec ls -s {} \; \
      | awk '{size += $1} END {printf "%d\n",size}'` / $factor_ls
  fi
  ;;
3) 
  echo "3. This option will delete all *.o *.for *.c *.a files under $MID_HOME"
  $echo "   Computing first number of kbytes to be deleted [yn]? (y): " $SV_NONL
  read answ
  if [ -z "$answ" ]; then
    answ=y
  fi
  if [ "$answ" = "y" -o "$answ" = "Y" ]; then
    $echo "   Number of kbytes to be deleted: (wait) " $SV_NONL
    expr `find $MID_HOME \( -name "*.o" -o -name "*.for" -o -name "*.a" -o \
      -name "*.c" \) -exec ls -s {} \; \
      | awk '{size += $1} END {printf "%d\n",size}'` / $factor_ls
  fi
  ;;
4)
  /bin/sh $MID_INSTALL/delete
  continue
  ;;
q) 
  exit
  ;;
*) 
  echo "Selection unknown"
  continue
  ;;
esac

if [ $? != 0 ]; then
    continue
fi

$echo "   Do you want to continue [yn]? (y): " $SV_NONL
read answ
if [ -z "$answ" ]; then
    answ=y
fi
if [ "$answ" != "y" -a "$answ" != "Y" ]
then
    continue
fi
#exit

echo "   Start removing."
case $task in
1)
  echo '   find $MID_HOME -name "*.o" -exec rm -f {} \;'
  find $MID_HOME -name "*.o" -exec rm -f {} \;
  ;;
2)
  echo '   find $MID_HOME \( \
     	-name "*.o" -o \
  	-name "*.for" -o  \
  	-name "*.c" \) -exec rm -f {} \;'
  find $MID_HOME \( \
  	-name "*.o" -o \
  	-name "*.for" -o  \
  	-name "*.c" \) -exec rm -f {} \;
  ;;
3)
  echo '   find $MID_HOME \( \
  	-name "*.o" -o \
  	-name "*.for" -o  \
  	-name "*.c" -o  \
  	-name "*.a" \) -exec rm -f {} \;'
  find $MID_HOME \( \
  	-name "*.o" -o \
  	-name "*.for" -o  \
  	-name "*.c" -o  \
  	-name "*.a" \) -exec rm -f {} \;
  ;;
esac

echo "   Done."
done

# @(#)clean.sed	19.1 (ESO-DMD) 02/25/03 14:34:02
# 
# "clean.sed" - script for sed
# to clean Midas logfile before comparing the logs from
# verifications with different Midas versions
# use via: sed -f clean.sed Midas_logfile >cleaned_logfile
#  
# K. Banse	last modif:	030121
# 
# delete all lines with ""
//d

# delete all lines with "Page" and the following (empty) line
/Page/{
N
d
}

# delete all lines with specific patterns

/home\/esomidas/d

/elapsed time/d

/time elapsed/d

/DATE    =/d
/DATE:/d

/yields:/d

/expanding frame -/d

/created on:/d

/vimos.fits took/d

# the end

#! /bin/bash
# .COPYRIGHT: Copyright (c) 1988-2011 European Southern Observatory,
#                                         all rights reserved
# .TYPE           command
# .NAME           config 
# .LANGUAGE       shell script
# .ENVIRONMENT    Unix Systems. Executable under SHELL and C-SHELL
# .COMMENTS       Installation procedure of the MIDAS system starting from
#                 scratch.
#                 Usage: config
#
# .REMARKS        The external variable $MIDASHOME and $MIDVERS must be set 
#
# .AUTHOR         Carlos Guirao
# .VERSION 2.2    881014:		Cosmetic changes
# 
# 111206	last modif
#
# Checks echo command which option uses to get NO NEW LINE
#

echo=echo
if [ "`echo -n `" = "-n" ] ; then
	SV_NONL="\c"
else	
	echo="echo -n"
fi

clear

#
# First of all, goto the config directory MID_INSTALL
# <dirname> & <basename> commands emulated with <sed>
#   cd `dirname $0`
#   MIDVERS=`basename $VERSDIR`
#   MIDASHOME=`dirname $VERSDIR`
#
#if [ -z "$MIDASHOME" -o -z "$MIDVERS" ] ; then
    cd `echo $0 | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
    MID_INSTALL=`pwd`
    VERSDIR=`echo $MID_INSTALL | sed 's/\/install\/unix$//'`
    MIDVERS=`echo $VERSDIR | sed -e 's/^.*\///'`
    MIDASHOME=`echo $VERSDIR | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
#else
#    cd $MIDASHOME/$MIDVERS/install/unix
#fi

MID_INSTALL=$MIDASHOME/$MIDVERS/install/unix
MID_HOME=$MIDASHOME/$MIDVERS

export MIDASHOME MIDVERS

#
# START
#
if [ ! -f test_file_1k ]; then
  dd if=/dev/zero bs=1024 count=1 of=test_file_1k
fi
echo "**********************************************************************"
echo "******************** MIDAS CONFIGURATION SCRIPT **********************"
echo "**********************************************************************"
echo "******************** MIDVERS: $MIDVERS"
echo "******************** DATE:  `date`"
echo ""

task="unknown"
while true
do
echo ""
echo "		MIDAS CONFIG MENU:"
echo "	========================================"
echo "	1 - list of MIDAS packages available"
echo "	2 - select only MIDAS core"
echo "	3 - select all MIDAS packages"
echo "	4 - select MIDAS core & packages of your choice"
echo "	5 - preinstall MIDAS"
echo "	6 - install MIDAS"
echo "	66 - install MIDAS - prepare own MAKE_OPTIONS"
echo "	67 - install MIDAS - use the MAKE_OPTIONS above"
echo "	7 - update MIDAS"
echo "	8 - setup MIDAS"
echo "	9 - clean MIDAS"
echo "	10- help"
echo "	q - quit"
echo ""

while :
do
    $echo "Select: " $SV_NONL
    read task
    if [ -n "$task" ]; then
	break
    fi
done

task=`echo $task | tr A-Z a-z`

# trap "" 2			# ignore interrupts 
case $task in
	1) /bin/bash $MID_INSTALL/list
	   ;;
	2) /bin/bash $MID_INSTALL/select core
	   ;;
	3) /bin/bash $MID_INSTALL/select all
	   ;;
	4) /bin/bash $MID_INSTALL/select own
	   ;;
	5) /bin/bash $MID_INSTALL/preinstall
	   ;;
	6) /bin/bash $MID_INSTALL/install1 auto
	   ;;
	66) /bin/bash $MID_INSTALL/install1 own
	   ;;
	67) /bin/bash $MID_INSTALL/install1 67
	   ;;
	7) /bin/bash $MID_INSTALL/update1
	   ;;
	8) /bin/bash $MID_INSTALL/setup
	   ;;
	9) /bin/bash $MID_INSTALL/cleanm
	   ;;
	10) /bin/bash $MID_INSTALL/help
	   ;;
	q) exit
	   ;;
	*) echo "Selection unknown"
	   ;;
esac

# trap 2			# obey interrupts again
done

#! /bin/bash
# .COPYRIGHT: Copyright (c) 2011 European Southern Observatory,
#                                         all rights reserved
# .TYPE           command
# .NAME           install3.sh
# .LANGUAGE       shell script
# .ENVIRONMENT    Unix Systems. Executable under SHELL and C-SHELL
# .COMMENTS       Installation procedure of the MIDAS system starting from
#                 scratch.
#                 Usage: install system [options]
#
# .AUTHOR         Klaus Banse
# .VERSION 
# 110825	creation
# 190322	last modif	take out continue statements,
#				and fix for being called from config


#*************** building dummy NAG library *********************

# the install3 script is called from install1 with one parameter
# par1   = manual (to use an edited make_options file),
# or     = -a (via  autoconfig)
# or no parameter at all
 
cd $MID_HOME/system/ext
make 
if [ $? !=  0 ]; then
   echo "Error building esoext."
   exit 1
fi
#
cd $MID_HOME/libsrc/nag
rm -f ../../lib/libnag.a

make all
if [ $? !=  0 ]; then
   echo "Error creating dummy NAG library."
   exit 1
fi

#**************************************************************


cd $MID_INSTALL

echo ""
echo "MIDAS INSTALLATION PROCEDURE"
echo "============================"
echo "MIDASHOME: $MIDASHOME"
echo "MIDVERS:   $MIDVERS"

if [ $1 = "manual" ]; then
   echo "Your own MAKE_OPTIONS after checks and/or editing:"
else
   echo "Your final MAKE_OPTIONS after all checks:"
fi

echo "<$MID_HOME/local/make_options>"

awk -F# '{if ($1 != "") {printf "\t  %s\n",$1} }' $MID_HOME/local/make_options
echo ""

echo "Do you want to check the OS library [yn]? (y): " $SV_NONL
unset answ
if [ "$1" != "-a" ]; then    
  read answ
fi
if [ -z "$answ" ]; then
    answ=y
fi
if [ "$answ" = "y" -o "$answ" = "Y" ]
then
    cd $MID_HOME/libsrc/os/unix
    rm -f $MID_HOME/lib/libos.a
    make clean_exec
    make clean
    make all
    make testos.exe
    if [ $? != 0 ]; then
	echo ""
	echo " **********************************************"
	echo " *               ATTENTION                    *"
	echo " * There was a severe error in your <oslib.a> *"
	echo " * that should be corrected before continuing *"
	echo " * with the MIDAS installation.               *"
	echo " *                                            *"
	echo " * Go to $MID_HOME/libsrc/os/unix "
	echo " * and type by hand:                          *"
	echo " *                                            *"
        echo " *     make clean_exec                        *"
        echo " *     make clean                             *"
        echo " *     make all                               *"
        echo " *     make testos.exe                        *"
	echo " *                                            *"
        echo " * The sequence above should be executed      *"
        echo " * without any error (Warnings are tolerated) *"
        echo " * MIDAS installation will be aborted !!      *"
        echo " *                                            *"
        echo " * For help contact ESO's Midas support:      *"
        echo " * midas@eso.org                              *"
	echo " **********************************************"
        echo ""
	$echo "Type return to exit: " $SV_NONL
	read return
	exit 1
    fi
fi

echo ""
echo "WARNING: MIDAS installation will delete all dependent files."
echo "         It will run in background and the output will be sent to"
echo "         the file <$MID_HOME/tmp/install.$$>"
echo ""
echo "Do you want to continue [yn]? (y): " $SV_NONL
unset answ
if [ "$1" != "-a" ]; then 
  read answ
fi
if [ -z "$answ" ]; then
    answ=y
fi
if [ "$answ" != "y" -a "$answ" != "Y" ]
then
    echo "Bye"
    exit 0
fi

#
# if $MID_HOME/tmp does not exist then create it
#
if [ ! -d $MID_HOME/tmp ]; then
    mkdir $MID_HOME/tmp
fi

# do we have the 'time' command?
if [ $CMND_YES = 2 ] ; then
   /bin/bash $MID_INSTALL/install -i > $MID_HOME/tmp/install.$$ 2>&1 &
else
   time /bin/bash $MID_INSTALL/install -i > $MID_HOME/tmp/install.$$ 2>&1 &
fi

echo "Running install in background"
echo "Results are coming in $MID_HOME/tmp/install.$$"

if [ "$1" = "-a" -o "$1" = "auto" ]; then 
  echo "Waiting for MIDAS installation to finish..."  $SV_NONL
  wait
  echo "Finished."
  echo ""
fi
exit 0

#! /bin/sh
# .COPYRIGHT: Copyright (c) 1988 European Southern Observatory,
#                                         all rights reserved
# .TYPE           command
# .NAME           delete.sh
# .LANGUAGE       shell script
# .ENVIRONMENT    Unix Systems. Executable under SHELL and C-SHELL
# .COMMENTS       
#
# .AUTHOR         Carlos Guirao
# .VERSION 1.1    30-Oct-1989:		Implementation.
# .VERSION 1.2    05-Dec-1989:		Adding "echo" definition
# 070615	last modif
# 
echo=echo
if [ "`echo -n`" = "-n" ] ; then
        SV_NONL="\c"
else
        echo="echo -n"
fi

#
# First of all, goto the config directory MID_INSTALL
# <dirname> & <basename> commands emulated with <sed>
#   cd `dirname $0`
#   MIDVERS=`basename $VERSDIR`
#   MIDASHOME=`dirname $VERSDIR`
#
if [ -z "$MIDASHOME" -o -z "$MIDVERS" ] ; then
    cd `echo $0 | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
    MID_INSTALL=`pwd`
    VERSDIR=`echo $MID_INSTALL | sed 's/\/install\/unix$//'`
    MIDVERS=`echo $VERSDIR | sed -e 's/^.*\///'`
    MIDASHOME=`echo $VERSDIR | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
else
    cd $MIDASHOME/$MIDVERS/install/unix
fi

MID_INSTALL=$MIDASHOME/$MIDVERS/install/unix
MID_HOME=$MIDASHOME/$MIDVERS

#
# START
#

# Check weather "ls -s" command returns blocks of 1/2 or 1 kbytes.
# The file test_file_1k is 1kbyte big.
factor_ls=`ls -s test_file_1k | awk '{print $1}'`

while : ; do
(echo ""
echo "	DELETE EXECUTABLES FILES FROM:"
echo ""
echo "	NAME		CATEGORY"
echo "	========================"
for categ in applic stdred contrib gui
do
    if [ ! -d $MID_HOME/$categ ]; then
	continue
    fi
    cd $MID_HOME/$categ
    for pack in `ls | egrep -v 'lib|exec|proc'`
    do
        if [ -f $pack/src/makefile ] ; then
            echo  "	$pack      	$categ	"
	fi
   done
done
echo "" ) | more
cd $MID_INSTALL
echo "Type <Q> to quit or <L> to list again."

while : ; do
    $echo "Select NAME to DELETE: " $SV_NONL
    read name
    if [ "$name" = "q" -o "$name" = "Q" ] ; then
	exit
    fi
    if [ "$name" = "l" -o "$name" = "L" ] ; then
	break
    fi
    if [ "$name" = "" ] ; then
	continue
    fi
    if [ -f $MID_HOME/applic/$name/src/makefile ] ; then
	categ=applic
    elif [ -f $MID_HOME/stdred/$name/src/makefile ] ; then
	categ=stdred
    elif [ -f $MID_HOME/contrib/$name/src/makefile ] ; then
	categ=contrib
    elif [ -f $MID_HOME/gui/$name/src/makefile ] ; then
	categ=gui
    else
	echo "$name: No such package with that name"
	continue
    fi

    $echo "Number of kbytes to be deleted: (wait) " $SV_NONL
    cd $MID_HOME/$categ/$name/src
    ls -s `make -n clean_exec | sed -e 's/^rm//' -e 's/-f//'` 2>/dev/null | \
    awk -f $MID_INSTALL/size.awk factor=$factor_ls
    if [ $? != 0 ] ; then
	continue
    fi
    $echo "Do you want to delete $name executables [yn]? (y): " $SV_NONL
    read answ
    if [ -z "$answ" ]; then
        answ=y
    fi
    if [ "$answ" != "y" -a "$answ" != "Y" ]; then
        cd $MID_INSTALL
	echo ""
        continue
    fi

    make clean_exec
    cd $MID_INSTALL
    echo ""
done
done

exit 

#!/usr/bin/awk
#
# getMacInfo.awk
#
# K. Banse      ESO - Garching  110714
# 110714        last modif
# 
# 

BEGIN {
newfile = "mac_system"
IGNORECASE = 0;
}


# look for the system software section

/^Software:/ {
getline;                #skip to next line		#first blank line
print  $0 >> newfile
getline;                #skip to next line
print  $0 >> newfile
getline;                #skip to next line
print  $0 >> newfile
getline;                #skip to next line
print  $0 >> newfile
getline;                #skip to next line
print  $0 >> newfile
getline;                #skip to next line
print  $0 >> newfile
getline;                #skip to next line
print  $0 >> newfile
getline;                #skip to next line
print  $0 >> newfile
getline;                #skip to next line
print  $0 >> newfile
getline;                #skip to next line
print  $0 >> newfile
getline;                #skip to next line
print  $0 >> newfile
getline;                #skip to next line
print  $0 >> newfile
getline;                #skip to next line		#last blank line
print  $0 >> newfile
}

END {
# printf "system info extracted to file mac_system\n";
}

#!/bin/sh
# @(#)tsaintcrf.sh	5.1 (ESO-IPG) 4/5/93 15:59:21
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
#.COPYRIGHT (c)  1992     European Southern Observatory and Warsaw Observatory
#.IDENT     tsadintcrf.sh
#.AUTHOR    Written by Alex Schwarzenberg-Czerny, ESO and Warsaw Observatory,
#           using example of REBIN/II command by M.Rosa et al.
#           
#.KEYWORD   MIDAS, time series, INTERP/TSA
#.LANGUAGE  UNIX Shell
#.PURPOSE   Compute chi2-time lag function/Compile and link ACF routine
#.VERSION   0.0               Sept 1992
#.RETURNS   None  
#.ENVIRON   TSA context
#------------------------------------------------------------------------------
#
cp $MIDASHOME/$MIDVERS/contrib/tsa/src/makefile.tsa .
sh $MIDASHOME/$MIDVERS/system/unix/makemidas -f makefile.tsa MOD=tsaint OBJ_ARG=tsaintusr.o 

#! /bin/bash
# .COPYRIGHT: Copyright (c) 1988-2011 European Southern Observatory,
#                                         all rights reserved
# .TYPE           command
# .NAME           install1.sh
# .LANGUAGE       shell script
# .ENVIRONMENT    Unix Systems. Executable under SHELL and C-SHELL
# .COMMENTS       Installation procedure of the MIDAS system starting from
#                 scratch.
#                 Usage: install system [options]
#
# .AUTHOR         Carlos Guirao
# .VERSION 1.1    25-Oct-1989:		Implementation
# .VERSION 1.2    05-Dec-1989:		Adding "echo" definition
# .VERSION 1.3    910219:               Removing System name argument
# .VERSION 1.4    911004:               Removing "set -x +x" ignored by some
# .VERSION 1.5    911118:               Checking Fortran and C compiler.
# .VERSION 2.1    920324:               Creating makemidas first.
# .VERSION 3.1    930325:		Using default.mk. CG.
# .VERSION 4.1    940124:		OS library does not require computer.h
# .VERSION 4.2    021028:       	Using -a argument for automatic
# 
# 111116	last modif
  
# the install1 script is called with one parameter 
# from script config (a) or autoconfig (b)
#
# par1 = auto - use automatic (default) compiler checks for setting
#		up /midas/version/local/make_options 
#		and start Midas installation (a)
#      = manual - use make_options file as it is, no further checks,
#		and start Midas installation (a)
#
# or     = -a  - as 'auto' but with no interaction (b)
# 
# this parameter is saved as option INSTALL_FLAG in 
# the file /midas/version/local/make_options

INSTALL_FLAG=$1

echo=echo
if [ "`echo -n`" = "-n" ] ; then
  SV_NONL="\c"
else
  echo="echo -n"
fi

#
# First of all, goto the config directory MID_INSTALL
# <dirname> & <basename> commands emulated with <sed>
#   cd `dirname $0`
#   MIDVERS=`basename $VERSDIR`
#   MIDASHOME=`dirname $VERSDIR`
#
if [ -z "$MIDASHOME" -o -z "$MIDVERS" ] ; then
    cd `echo $0 | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
    MID_INSTALL=`pwd`
    VERSDIR=`echo $MID_INSTALL | sed 's/\/install\/unix$//'`
    MIDVERS=`echo $VERSDIR | sed -e 's/^.*\///'`
    MIDASHOME=`echo $VERSDIR | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
else
    cd $MIDASHOME/$MIDVERS/install/unix
fi

MID_INSTALL=$MIDASHOME/$MIDVERS/install/unix
MID_HOME=$MIDASHOME/$MIDVERS
PATH=$PATH:$MID_INSTALL
export MIDASHOME MIDVERS MID_HOME MID_INSTALL

clear

# ************** make_options file already final *************
if [ $INSTALL_FLAG = "67" ]; then
   export SV_NONL CMND_YES
   $MID_INSTALL/install3 manual
   exit 0
fi
# ************************************************************

if [ ! -f "$MID_HOME/local/default.mk" ] ; then
  echo "*** ERROR: File <$MID_HOME/local/default.mk> does not exist."
  echo "*** You need to run <preinstall> before continuing with <install>"
  exit 1
fi

if [ -f "$MID_HOME/local/make_options" ] ; then
echo "Your current MAKE_OPTIONS:"
  awk -F# '{if ($1 != "") {printf "\t  %s\n",$1} }' $MID_HOME/local/make_options
  echo ""
else
  touch $MID_HOME/local/make_options
fi

chmod +x $MID_HOME/local/make_shared

echo "*** MIDAS INSTALLATION TESTS ***"

#*************** START: Checking existence of make, time commands *********

CMND_YES=1

which time > /dev/null 2>&1
if [  $? = 1 ] ; then
   echo "*** WARNING: Unix command 'time' not found"
   CMND_YES=2
fi

which make > /dev/null 2>&1
if [  $? = 1 ] ; then
   echo "*** ERROR: Unix command 'make' not found"
   CMND_YES=0
fi

if [ $CMND_YES = 0 ] ; then
   echo ">>> Please install the missing command(s), and redo the installation." 
   exit 1
fi
#*************** END: Checking existence of make, time commands *********


# All test modules are in the test directory

cd test
make clean >/dev/null 2>&1


#*************** START: Checking the C compiler ********************
$echo "*** Checking the C compiler...." $SV_NONL
rm -f testc.o 2>/dev/null
if (make testc.o) >/dev/null 2>&1
then
  echo "OK."
else
  CC=`ed_moptions get CC`
  while :
  do 
    echo "NOT FOUND."
    echo ""
    echo "ERROR using CC=$CC (or no 'make' command installed)"
    echo "Type the name of your C compiler,"
    echo "or CR to exit."
    $echo "C compiler: " $SV_NONL
    unset answ
    read answ
    if [ -z "$answ" ]; then
      echo "No C compiler -> No MIDAS. Exit."
      $echo "Type return to exit: " $SV_NONL
      read return
      exit 1
    fi
    CC="$answ"
    ed_moptions delete CC >/dev/null
    $echo "*** Checking the C compiler...." $SV_NONL
    rm -f testc.o 2>/dev/null
    if (make CC="$CC" testc.o)
    then
      echo "OK."
      ed_moptions add CC="$CC" >/dev/null
      break
    fi
  done 
fi

# test, if we include <varargs.h> or <stdarg.h>

rm -f testvar.o 2>/dev/null
if (make testvar.o) >/dev/null 2>&1
then
   varargs=VARARGS
   echo "*** Use <varargs.h>"
else
   varargs=NOVARARGS
   echo "*** Use <stdarg.h>"
fi

# adapt all potential ftoc_xyz files accordingly

rm -f ./temp.out

for  myfile in amd64 alfa alliant hp hpn hpr pc pc3 sun solaris 
do
   incfile=$MID_HOME/incl/ftoc_${myfile}.h
   chmod +w $incfile
   if [ "$varargs" = "VARARGS" ]; then
      sed 's/stdarg.h/varargs.h/' $incfile > ./temp.out
   else
      sed 's/varargs.h/stdarg.h/' $incfile > ./temp.out
   fi
   mv ./temp.out $incfile
done

ed_moptions add "VARARGS=-D$varargs" >/dev/null

# link correct ftoc dir to good-ftoc
# and copy relevant .fc files (+ correct y123.for files)

$MID_INSTALL/install2


#*************** END: Checking the C compiler ********************

#*************** START: Checking the C linker ********************
$echo "*** Checking the C linker...." $SV_NONL
rm -f testc.exe 2>/dev/null
if (make testc.exe) >/dev/null 2>&1
then 
  echo "OK."
else
  LDCC=`ed_moptions get LDCC`
  while :
  do
    echo "NOT FOUND."
    echo ""
    echo "ERROR using LDCC=$LDCC"
    echo "Type the name of your C linker,"
    echo "or CR to exit."
    $echo "C linker: " $SV_NONL
    unset answ
    read answ
    if [ -z "$answ" ]; then
      echo "No C linker no MIDAS. Exit."
      $echo "Type return to exit: " $SV_NONL
      read return
      exit 1
    fi
    LDCC="$answ"
    ed_moptions delete LDCC >/dev/null
    $echo "*** Checking the C linker...." $SV_NONL
    rm -f testc.exe 2>/dev/null
    if (make LDCC="$LDCC" testc.exe) 
    then
       echo "OK."
       ed_moptions add LDCC="$LDCC" >/dev/null
       break
     fi
  done
fi
#*************** END: Checking the C linker *******************

#*************** START: Checking oserror definition *****************
LSYS=""
while :
do
   $echo "*** Checking the MIDAS oserror definition...." $SV_NONL
   rm -f oserror.o oserror.exe 2>/dev/null
   if (make LSYS="$LSYS" oserror.exe) >/dev/null 2>&1
   then
      echo "OK."
      if [ -n "$LSYS" ] ; then
	ed_moptions add SYS="$LSYS" >/dev/null
      fi
      break
   else
      if [ -z "$LSYS" ]; then
        echo "NOT FOUND."
        echo "*** Trying now with LSYS=-DOSERROR_D option:"
        LSYS="-DOSERROR_D"
      else
	echo "NOT FOUND." 
        echo "###############################################################" 
        echo "#                     WARNING                                 #"
        echo "# I could not run the following command:                      #"
        echo "#       make LSYS=-DOSERROR_D oserror.exe                     #"
        echo "#                                                             #"
        echo "# For help contact ESO's Midas support: midas@eso.org         #"
        echo "###############################################################"
	$echo "Type return to exit: " $SV_NONL
	read return
	exit 1
      fi
   fi
done
#*************** END: Checking oserror definition *******************

#************* START: Checking for 32/64bit C compiler *************

cd $MIDASHOME/$MIDVERS/install/unix/test

echo "  "

X_OPT=`ed_moptions get C_OPT`
#echo X_OPT = [$X_OPT]

# if C_OPT=-O ...				skip the "-O" substring
ksize=${#X_OPT}					#length of X_OPT
c2=${X_OPT:0:2}					#extract first 2 chars
#echo c2 = [$c2]
#echo ksize = $ksize

if [ "$c2" = "-O" ]; then			#extract chars from 3rd char. on
   if [ $ksize = 2 ]; then
      X_OPT=" "
   else
      cafter=${X_OPT:2:$ksize}
      X_OPT=$cafter				#shift left over the first 2 chars...
   fi
fi
#echo now X_OPT = [$X_OPT]

ed_moptions delete F77 >/dev/null
ed_moptions delete LD77_CMD >/dev/null
ed_moptions delete E_OPT >/dev/null
ed_moptions delete C_OPT >/dev/null
ed_moptions delete INSTALL_FLAG >/dev/null

ed_moptions add "C_OPT=$X_OPT"  >/dev/null
ed_moptions add "K_OPT= $X_OPT"  >/dev/null
ed_moptions add "INSTALL_FLAG=auto" >/dev/null


rm -f testsiz.exe 2>/dev/null

# here we use already the compiler chosen for Midas
if ! (make testsiz.exe) >/dev/null 2>&1
then
     echo "      "
     echo "could not build testsiz.exe"
     echo "check directory $MID_HOME/install/unix/test !!"
     exit 7
fi

./testsiz.exe
 
#
# 32 bit compiler
if [ $? = 4 ]; then
   echo installing Midas on a 32 bit system
   MACH=" "
   EO=" "
#
# 64 bit compiler
else
   echo installing Midas on a 64 bit system
   MACH=" "
   EO="-Z"
fi
 
ed_moptions add "F77=gfortran $MACH" >/dev/null
ed_moptions add "LD77_CMD=gfortran $MACH $LDFLAGS"  >/dev/null
#ed_moptions add "LDCC=gcc $LDFLAGS"  >/dev/null
ed_moptions add "E_OPT= $EO"  >/dev/null


#if [ $? = 4 ]; then
#   echo installing Midas on a 32 bit system
#   ed_moptions add "F77=gfortran" >/dev/null
#   ed_moptions add "LD77_CMD=gfortran"  >/dev/null
#   ed_moptions add "C_OPT=-O -fPIC $X_OPT"  >/dev/null
#   ed_moptions add "K_OPT=-fPIC $X_OPT"  >/dev/null
#   ed_moptions add "E_OPT= "  >/dev/null
#   ed_moptions add "INSTALL_FLAG=auto" >/dev/null
#else
#   echo installing Midas on a 64 bit system
#   ed_moptions add "F77=gfortran -m64" >/dev/null
#   ed_moptions add "LD77_CMD=gfortran -m64" >/dev/null
#   ed_moptions add 'C_OPT=-m64 -O -fPIC $X_OPT'  >/dev/null
#   ed_moptions add "K_OPT=-m64 -fPIC $X_OPT"  >/dev/null
#   ed_moptions add "E_OPT=-Z"  >/dev/null
#   ed_moptions add "INSTALL_FLAG=auto" >/dev/null
#fi

echo "  "

#*************** END: Checking 32/64bit C compiler ****************


#*************** START: Checking the Fortran compiler ********************
$echo "*** Checking the Fortran compiler...." $SV_NONL
rm -f testf.o 2>/dev/null
if (make testf.o) >/dev/null 2>&1
then
  echo "OK."
else
  F77=`ed_moptions get F77`
  while :
  do 
    echo "NOT FOUND."
    echo ""
    echo "ERROR using F77=$F77"
    echo "Type the name of your Fortran compiler,"
    echo "or CR to exit."
    $echo "Fortran compiler: " $SV_NONL
    unset answ
    read answ
    if [ -z "$answ" ]; then
      echo "No Fortran compiler -> No MIDAS. Exit."
      $echo "Type return to exit: " $SV_NONL
      read return
      exit 1
    fi
    F77="$answ"
    ed_moptions delete F77 >/dev/null
    $echo "*** Checking the Fortran compiler...." $SV_NONL
    rm -f testf.o 2>/dev/null
    if (make F77="$F77" testf.o)
    then
      echo "OK."
      ed_moptions add F77="$F77" >/dev/null
      break
    fi
  done 
fi
#*************** END: Checking the Fortran compiler ********************

#*************** START: Checking the Fortran linker ********************
$echo "*** Checking the Fortran linker...." $SV_NONL
rm -f testf.exe 2>/dev/null
if (make testf.exe) >/dev/null 2>&1
then 
  echo "OK."
else
  LD77_CMD=`ed_moptions get LD77_CMD`
  while :
  do
    echo "NOT FOUND."
    echo ""
    echo "ERROR using LD77_CMD=$LD77_CMD"
    echo "Type the name of your Fortran linker,"
    echo "or CR to exit."
    $echo "Fortran linker: " $SV_NONL
    unset answ
    read answ
    if [ -z "$answ" ]; then
      echo "No Fortran linker no MIDAS. Exit."
      $echo "Type return to exit: " $SV_NONL
      read return
      exit 1
    fi
    LD77_CMD="$answ"
    ed_moptions delete LD77_CMD >/dev/null
    $echo "*** Checking the Fortran linker...." $SV_NONL
    rm -f testf.exe 2>/dev/null
    if (make LD77_CMD="$LD77_CMD" testf.exe) 
    then
       echo "OK."
       ed_moptions add LD77_CMD="$LD77_CMD" >/dev/null
       break
     fi
  done
fi
#*************** END: Checking the Fortran linker *******************

#*************** START: Checking math routines *****************
$echo "*** Checking some standard math routines...." $SV_NONL
rm -f mathc.o mathf.o math.exe 2>/dev/null
## if (make math.exe) >/dev/null 2>&1
if (make math.exe) 
then
  echo "OK."
else
  echo "mathlib NOT FOUND." 
  echo "*** Trying now with -lm option:"
  SLIB_ORG=`ed_moptions delete SLIB`
  SLIB=`eval echo $SLIB_ORG -lm`
  $echo "*** Checking some standard math routines...." $SV_NONL
  rm -f math.exe 2>/dev/null
  if (make SLIB="$SLIB" math.exe) >/dev/null 2>&1
  then
    ed_moptions add SLIB="$SLIB" >/dev/null
    echo "OK."
  else
    ed_moptions add SLIB="$SLIB_ORG" >/dev/null
    echo "mathlib NOT FOUND." 
    echo "###############################################################" 
    echo "#                     WARNING                                 #"
    echo "# I could not run the following commands:                     #"
    echo "#       make math.exe                                         #"
    echo "#       make SLIB=$SLIB math.exe                              #"
    echo "# a) probably the mathematical library libm.a is not found -  #"
    echo "#    edit the file $MID_HOME/local/make_options 	        #"
    echo "#    and set SLIB=<new libm.a path>.                          #" 
    echo "# b) or if this happens on a Mac -                            #"
    echo "#    maybe you have non-matching C compiler (gcc) and         #"
    echo "#    Fortran frontend (gfortran).				#"
    echo "#    E.g. 64bit C compiler and 32bit Fortran, in that case	#"
    echo "#    set in /midas/version/local/make_options:                #"
    echo "#    F77=gfortran -m64  					#"
    echo "#    LD77_CMD77=gfortran -m64  				#"
    echo "#                     					#"
    echo "# For help contact ESO's Midas support: midas@eso.org         #"
    echo "###############################################################"
    $echo "Type return to exit: " $SV_NONL
    read return
    exit 1
  fi
fi
#*************** END: Checking math routines *******************

#*************** START: Checking the ln command *************
ed_moptions delete LN >/dev/null
rm -f aaa bbb 2>/dev/null 
touch aaa
$echo "*** Checking the ln command...." $SV_NONL
if (ln -s aaa bbb ) >/dev/null 2>&1
then
    echo "(soft) OK."
else
    if (ln aaa bbb ) >/dev/null 2>&1
    then
	echo "(hard) OK."
	echo "*** LN set to ln."
        ed_moptions add LN="ln" >/dev/null
    else
	echo "NOT FOUND."
        echo "###############################################################"
        echo "#                     WARNING                                 #"
        echo "# I could neither set the hard nor symbolic link between 	    #" 
        echo "#  files:     ln -s aaa bbb                                   #"
        echo "#      	    ln aaa bbb                                      #"
        echo "# Probably the command is not found or its path not included  #"
        echo "# in the PATH variable. Without this command makefiles in     #" 
        echo "# proc and help directories will fail                         #"
        echo "#                                                             #"
        echo "# For help contact ESO's Midas support: midas@eso.org         #"
        echo "###############################################################"
        $echo "Type return to exit: " $SV_NONL
        read return
	exit 1
    fi
fi
#*************** END: Checking the ln command **************

#*************** START: Checking the strip command *************
ed_moptions delete STRIP >/dev/null
$echo "*** Checking the strip command...." $SV_NONL
before=`du -s testc.exe | awk '{print $1}'`
if (strip  testc.exe) >/dev/null 2>&1
then
   now=`du -s testc.exe | awk '{print $1}'`
   if [ "$before" != "$now" ]; then
      echo "OK."
   else
      echo "NOT STRIPPED."
      echo "*** STRIP set to echo."
      ed_moptions add STRIP=echo >/dev/null
   fi
else
   echo "NOT FOUND."
fi
echo "*** STRIP set to echo."
ed_moptions add STRIP=echo >/dev/null
#*************** END: Checking the strip command **************

#*************** START: Checking the ranlib command ***********
ed_moptions delete RANLIB >/dev/null
$echo "*** Checking the ranlib command...." $SV_NONL
rm -f testlib.a 2>/dev/null
if (make testlib.a) >/dev/null 2>&1
then
   before=`sum testlib.a | awk '{print $1}'`
   sleep 1
   if (ranlib  testlib.a) >/dev/null 2>&1
   then
      now=`sum testlib.a | awk '{print $1}'`
      if [ "$before" != "$now" ]; then
          echo "OK."
      else
          echo "NO EFFECT."
          echo "*** RANLIB set to echo."
   	  ed_moptions replace RANLIB=echo >/dev/null
      fi
   else
      echo "NOT FOUND."
      echo "*** RANLIB set to echo"
      ed_moptions replace RANLIB=echo >/dev/null
   fi
fi
#*************** END: Checking the ranlib command **************

#*************** START: Checking the ncurses development library *********
x11incl=""
$echo "*** Checking ncurses development library...." $SV_NONL

rm -f testncurs.o 2>/dev/null
if (make testncurs.exe) >/dev/null 2>&1
then
  echo "OK."
  ed_moptions replace "EDITSWITCH=-DEdit_dummy" >/dev/null
  ed_moptions replace "EDITLIBS=-lreadline -lncurses" >/dev/null
else
  echo "Not found."
  echo "*** WARNING: You'll not be able to edit Midas commands in the monitor."
  
  unset answ
  if [ "$1" != "-a" ]; then	#interactive mode
    echo "*** If that's o.k., just continue."
    echo "*** Otherwise, quit and install first this development library."
    echo "*** Type 'c' or q' (without ') to continue or quit: " $SV_NONL
    read answ
    if [ -z "$answ" ]; then	#by default continue
       answ="c"
    fi
  else				#always continue for autoconfigure
    answ="c"
  fi

  if [ $answ = "c" -o  $answ = "C" ]; then
    ed_moptions replace "EDITSWITCH=-DNO_READLINE" >/dev/null
    ed_moptions replace "EDITLIBS=-lreadline" >/dev/null
  else
    exit 1
  fi
fi
#
#*************** END: Checking the ncurses development library ***********

#*************** START: Checking the X11 include directory *********
x11incl=""
$echo "*** Checking X11 include directory...." $SV_NONL
#
rm -f testx11.o 2>/dev/null
if (make LSYS=-DONLY_INCLUDES testx11.o) >/dev/null 2>&1
then
  echo "OK."
  x11incl="found"
else
  ed_moptions delete X11INC >/dev/null
  x11inclpth='/usr/include/X11 /usr/include/X11R6 /usr/include/X11R5 /usr/X11R6/include /usr/X11R6/include/X11 /usr/X11R5/include /usr/local/include /include /usr/X/include /opt/X-local/include'
  for dir in $x11inclpth
  do
    if [ ! -d $dir ]; then
      continue
    fi
    X11INC="X11INC=-I$dir"
    rm -f testx11.o 2>/dev/null
    if (make "$X11INC" LSYS=-DONLY_INCLUDES testx11.o) >/dev/null 2>&1
    then 
      echo "OK."
      ed_moptions add "$X11INC" >/dev/null
      x11incl="found"
      break;
    fi
  done
fi
# 
# The X11 include file was not found in $x11inclpth, so ask the operator
# where it could be. 
#
if [ "$x11incl" != "found" ]; then
  echo "NOT FOUND."
  echo ""
  echo "*** WARNING:  X11 include directory not found."
  echo "*** I checked in paths:"
  echo "$x11inclpth"
  while :
  do
    echo "":
    echo "Type the full pathname for the X11 include directory,"
    echo "or CR if you do not have any."
    while :
    do
      $echo "Pathname: " $SV_NONL
      unset answ
      read answ
      if [ -z "$answ" -o -d "$answ" ]; then
	break
      else
	echo "$answ no such directory."
	continue
      fi
    done
    if [ -z "$answ" ]; then
      echo "*** WARNING: MIDAS will be installed without X11."
      break
    fi
    $echo "*** Checking X11 include files...." $SV_NONL
    rm -f testx11.o 2>/dev/null
    answ=`echo $answ | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
    X11INC="X11INC=-I$answ"
    if (make "$X11INC" LSYS=-DONLY_INCLUDES testx11.o) 
    then 
      echo "OK."
      ed_moptions add "$X11INC" >/dev/null
      x11incl="found"
      break
    else
      echo "NOT FOUND."
    fi
  done
fi
#*************** END: Checking the X11 include directory ***********

#*************** START: Checking the X11 libraries ***************
# Run this check only if include directory was found previosly
#
if [ "$x11incl" = "found" ]; then
#
  x11lib=""
  $echo "*** Checking X11 libraries...." $SV_NONL
  rm -f testx11.exe 2>/dev/null 
  if (make testx11.exe) >/dev/null 2>&1
  then 
    X11RELEASE=`./testx11.exe`
    echo "OK."
    echo "*** X11 release $X11RELEASE found."
    x11lib="found"
  else
    ed_moptions delete X11_LIBPATH >/dev/null
    x11libpth='/lib /usr/lib /usr/local/lib /usr/openwin/lib /usr/lib/X11R6 /usr/lib/X11R5 /usr/X11R6/lib64 /usr/X11R6/lib /usr/X11R5/lib /usr/lib/Motif1.2 /usr/X/lib /usr/X11/lib /usr/lpp/X11/lib /usr/lib/Motif1.1 /opt/X-local/lib'
    for dir in $x11libpth
    do
      if [ ! -d $dir ]; then
        continue
      fi
      X11_LIBPATH="X11_LIBPATH=-L$dir"
      rm -f testx11.exe 2>/dev/null 
      if (make "$X11_LIBPATH" testx11.exe) >/dev/null 2>&1
      then
	X11RELEASE=`./testx11.exe`
        echo "OK."
        echo "*** X11 release $X11RELEASE found."
        ed_moptions add "$X11_LIBPATH" >/dev/null
        x11lib="found"
        break
      fi
    done
  fi
# 
# The X11/Xt libraries not found in $x11libpth, so ask the operator
# where it could be. 
#
  if [ "$x11lib" != "found" ]; then
    echo "NOT FOUND."
    echo "*** WARNING: X11 library not found."
    echo "*** I checked in paths:"
    echo "$x11libpth"
    while :
    do
      echo ""
      echo "Type the full pathname for the directory containing the X11 library,"
      echo "or CR if you do not have any."
      while :
      do
	$echo "Pathname: " $SV_NONL
        unset answ
	read answ
	if [ -z "$answ" -o -d "$answ" ]; then
	   break
	else
	   echo "$answ no such directory."
	   continue
	fi
      done
      if [ -z "$answ" ]; then
        echo "*** WARNING: MIDAS will be installed without X11."
        break
      fi
      X11_LIBPATH="X11_LIBPATH=-L$answ"
      $echo "*** Checking X11 libraries...." $SV_NONL
      rm -f testx11.exe 2>/dev/null
      if (make "$X11_LIBPATH" testx11.exe) 
      then
	X11RELEASE=`./testx11.exe`
        echo "OK."
        echo "*** X11 release $X11RELEASE found."
	ed_moptions add "$X11_LIBPATH" >/dev/null
	break
      else
	echo "NOT FOUND."
      fi
    done
  fi
fi
#*************** END: Checking the X11 library *******************

if [ "$X11RELEASE" = "4" ]; then  
  MOTIF_RELEASE1="1001"
  MOTIF_RELEASE2="1001"
  MOTIF_RELEASE3="1001"
  MOTIF_RELEASE4="1001"
  MOTIF_RELEASE5="1001"		
  echo "*** Motif release 1.1 ($MOTIF_RELEASE1) expected."
elif [ "$X11RELEASE" = "5" ]; then
  MOTIF_RELEASE1="1002"
  MOTIF_RELEASE2="1002"
  MOTIF_RELEASE3="1002"
  MOTIF_RELEASE4="1002"
  MOTIF_RELEASE5="1002"		
  echo "*** Motif release 1.2 ($MOTIF_RELEASE1) expected."
elif [ "$X11RELEASE" = "6" ]; then  
  MOTIF_RELEASE1="2000"
  MOTIF_RELEASE2="2001"
  MOTIF_RELEASE3="2002"
  MOTIF_RELEASE4="2003"
# apparently used in Alpha/OSF4 in combination with X11 release 6
  MOTIF_RELEASE5="1002"		
  echo "*** Motif release 2.0 ($MOTIF_RELEASE1) expected."
else
  X11RELEASE="UNKNOWN"
  MOTIF_RELEASE1="UNKNOWN"
  echo "*** WARNING: X11 release 4, 5 or 6 expected"
fi

#*************** START: Checking the Motif include directory *********
if [ "$x11incl" = "found" -a "$x11lib" = "found" ]; then
xmincl=""
$echo "*** Checking Motif Xm include directory...." $SV_NONL
#
rm -f testxm.o motif_rel.exe 2>/dev/null
if (make LSYS=-DONLY_INCLUDES motif_rel.exe) >/dev/null 2>&1
then
  xmincl="found"
  MOTIFRELEASE=`./motif_rel.exe`
fi
if [ "$xmincl" = "found" -a \( "$MOTIFRELEASE" = "$MOTIF_RELEASE1" -o "$MOTIFRELEASE" = "$MOTIF_RELEASE2" -o "$MOTIFRELEASE" = "$MOTIF_RELEASE3" -o "$MOTIFRELEASE" = "$MOTIF_RELEASE4" -o "$MOTIFRELEASE" = "$MOTIF_RELEASE5" \) ]; then
  echo "OK."
  echo "*** Motif release $MOTIFRELEASE found."
else
  xmincl=""
  ed_moptions delete XMINC >/dev/null
  xminclpth='/usr/include/X11R6 /usr/include/X11R5 /usr/include/X11R4 /usr/include/X11 /usr/include/Xm /usr/include/Motif1.2 usr/include/Motif1.1 /usr/local/include /include /usr/X/include /usr/X11/include /usr/X11R5/include /usr/X11R6/include /usr/dt/include /sw/include /sw/lib'
  for dir in $xminclpth
  do
    if [ ! -d $dir ]; then
      continue
    fi
    XMINC="XMINC=-I$dir"
    rm -f testxm.o motif_rel.exe 2>/dev/null
    if (make "$XMINC" LSYS=-DONLY_INCLUDES motif_rel.exe) >/dev/null 2>&1
    then 
      xmincl="found"
      MOTIFRELEASE=`./motif_rel.exe`
    fi
    if [ "$xmincl" = "found" -a \( "$MOTIFRELEASE" = "$MOTIF_RELEASE1" -o "$MOTIFRELEASE" = "$MOTIF_RELEASE2" -o "$MOTIFRELEASE" = "$MOTIF_RELEASE3" -o "$MOTIFRELEASE" = "$MOTIF_RELEASE4" -o "$MOTIFRELEASE" = "$MOTIF_RELEASE5" \) ]; then
      echo "OK."
      echo "*** Motif release $MOTIFRELEASE found."
      ed_moptions add "$XMINC" >/dev/null
      xmincl="found"
      break;
    else
      xmincl=""
    fi
  done
fi
# 
# The Motif include file not found in $xminclpth, so ask the operator
# where it could be. 
#
if [ "$xmincl" != "found" ]; then
  echo "NOT FOUND."
  echo ""
  echo "*** WARNING:  Motif release $MOTIF_RELEASE1 include directory Xm not found."
  echo "*** I checked in paths:"
  echo "$xminclpth"
  while :
  do
    echo ""
    echo "Type the full pathname for the Motif release $MOTIF_RELEASE1 include directory, e.g. /sw/include/"
    echo "or CR if you do not have any."
    while :
    do
      $echo "Pathname: " $SV_NONL
      unset answ
      read answ
      if [ -z "$answ" -o -d "$answ" ]; then
	break
      else
	echo "$answ no such directory."
	continue
      fi
    done
    if [ -z "$answ" ]; then
      echo "*** WARNING: MIDAS will be installed without Motif applications."
      break
    fi
    $echo "*** Checking Motif include files...." $SV_NONL
    rm -f testxm.o motif_rel.exe 2>/dev/null
    answ=`echo $answ | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
    XMINC="XMINC=-I$answ"
    if (make "$XMINC" LSYS=-DONLY_INCLUDES motif_rel.exe) 
    then 
      xmincl="found"
      MOTIFRELEASE=`./motif_rel.exe`
    fi
    if [ "$xmincl" = "found" -a \( "$MOTIFRELEASE" = "$MOTIF_RELEASE1" -o "$MOTIFRELEASE" = "$MOTIF_RELEASE2" -o "$MOTIFRELEASE" = "$MOTIF_RELEASE3" -o "$MOTIFRELEASE" = "$MOTIF_RELEASE4" -o "$MOTIFRELEASE" = "$MOTIF_RELEASE5" \) ]; then
      echo "OK."
      echo "*** Motif release $MOTIFRELEASE found."
      ed_moptions add "$XMINC" >/dev/null
      xmincl="found"
      break
    else
      xmincl=""
      echo "NOT FOUND."
    fi
  done
fi
fi
#*************** END: Checking the Motif include directory ***********

#*************** START: Checking the Motif library ***************
# Run this check only if include directory was found previosly
#
if [ "$xmincl" = "found" ]; then
#
  xmlib=""
  $echo "*** Checking Motif library...." $SV_NONL
  rm -f testxm.o testxm.exe 2>/dev/null 
  if (make testxm.exe) >/dev/null 2>&1
  then 
    echo "OK."
    xmlib="found"
  else
    ed_moptions delete MOTIF_LIBPATH >/dev/null
    xmlibpth='/lib /usr/lib /usr/local/lib /usr/dt/lib /usr/lib/X11R6 /usr/lib/X11/R5 /usr/X11R6/lib /usr/X11R5/lib /usr/lib/X11/R4 /usr/lib/Motif1.2 /usr/X/lib /usr/X11/lib /usr/lpp/X11/lib /usr/lib/Motif1.1'
    for dir in $xmlibpth
    do
      if [ ! -d $dir ]; then
        continue
      fi
      MOTIF_LIBPATH="MOTIF_LIBPATH=-L$dir"
      rm -f testxm.o testxm.exe 2>/dev/null 
      if (make "$MOTIF_LIBPATH" testxm.exe) >/dev/null 2>&1
      then
        echo "OK."
        ed_moptions add "$MOTIF_LIBPATH" >/dev/null
        xmlib="found"
        break
      fi
    done
  fi
# 
# The Xm library not found in $x11libpth, so ask the operator
# where it could be. 
#
  if [ "$xmlib" != "found" ]; then
    echo "NOT FOUND."
    echo "*** WARNING: Motif library release $MOTIF_RELEASE not found."
    echo "*** I checked in paths:"
    echo "$xmlibpth"
    while :
    do
      echo "Type the full pathname for the directory containing the Motif library, e.g. /sw/lib/"
      echo "or CR if you do not have any."
      while :
      do
	$echo "Pathname: " $SV_NONL
        unset answ
	read answ
	if [ -z "$answ" -o -d "$answ" ]; then
	   break
	else
	   echo "$answ no such directory."
	   continue
	fi
      done
      if [ -z "$answ" ]; then
        echo "*** WARNING: MIDAS will be installed without Motif applications."
        break
      fi
      MOTIF_LIBPATH="MOTIF_LIBPATH=-L$answ"
      $echo "*** Checking Motif library...." $SV_NONL
      rm -f testxm.exe 2>/dev/null
      if (make "$MOTIF_LIBPATH" testxm.exe)
      then
        echo "OK."
	ed_moptions add "$MOTIF_LIBPATH" >/dev/null
	break
      else
	echo "NOT FOUND."
      fi
    done
  fi
fi
#*************** END: Checking the Motif library *******************

#
# Default UIMX=uimxR4 in default.mk
# Set UIMX=uimxR5 in make_options if X11RELEASE=5
#
if [ "$X11RELEASE" = "5" -o "$X11RELEASE" = "6" ]; then
  ed_moptions delete UIMX >/dev/null
  ed_moptions add "UIMX=uimxR5" >/dev/null
fi

#*************** for manually edited MAKE_OPTIONS ***************
 
if [ $INSTALL_FLAG = "own" ] ; then
   ed_moptions delete INSTALL_FLAG >/dev/null
   ed_moptions add "INSTALL_FLAG=user-choice" >/dev/null
   echo " "
   echo "------------------------------------------------------------"
   echo "=== now, you can edit $MID_HOME/local/make_options"
   echo "=== and adapt it to your special needs"
   echo "=== to continue, use step 67 of the config script"
   echo "------------------------------------------------------------"
   echo " "
   exit 0
fi   

# ******** now the actual installation (in background) *********

export SV_NONL CMND_YES
$MID_INSTALL/install3 $1
exit 0

#! /bin/sh
# @(#)tst.sh	19.1 (ESO-IPG) 02/25/03 14:35:25
func1()
{
#echo -n "a"
sort >sort.$$ <</*EOF
And
now
let's
see
how 
fast
is
this
text
treated
in
between
their
colleges
running
at
the
same
time
/*EOF
od sort.$$ | sort -n +1 > od.$$
grep the sort.$$ | tee grep.$$ | wc > wc.$$
cat sort.$$ | sed 's/e/E/' | awk -FA '{ print $1 }' >awk.$$
rm sort.$$ grep.$$ od.$$ wc.$$ awk.$$
#echo -n "A"
}

func2()
{
#echo -n "b"
cp ben_fpu.c fpu$$.c
cc -c fpu$$.c
cc fpu$$.o  -lm -o fpu$$
strip fpu$$
rm fpu$$.c fpu$$.o fpu$$
#echo -n "B"
}

func3()
{
#echo -n "c"
cp ben_fpu.exe fpu$$
fpu$$ 1 >/dev/null
rm fpu$$
#echo -n "C"
}

order=`expr $1 % 4`
case $order in
0)
   func1
   func2
   func3
   ;;
1)
   func2
   func1
   func3
   ;;
2)
   func3
   func1
   func2
   ;;
3)
   func3
   func2
   func1
   ;;
*)
   echo "ERROR. This line should not be printed"
   ;;
esac

#! /bin/sh
# @(#)add_sccs.sh	19.1 (ESO-IPG) 02/25/03 14:31:58 

cmd=`basename $0`
A=%
header=" ${A}W% (ESO-IPG) ${A}G% ${A}U%"

if [ -z "$1" ]; then
  echo "Usage: $cmd files"
  exit 1
fi

for file in $*
do
    if [ ! -f "$file" ]; then
	echo "${cmd}: $file not found"
   	continue
    fi
    case $file in

    *.c|*.h|*.fc)
       echo '/*'$header' */' > .$file
       ;;

    *.for|*.incl)
       echo 'C'$header > .$file
       ;;

    makefile|*.sh|*.csh)
       echo '#'$header > .$file
       ;;

    *.prg|*.ctx)
       echo '!'$header > .$file
       ;;

    *.com)
       echo '$ !'$header > .$file
       ;;

    *.hlq|*.doc|*.alc|*.alq|*.twh|*.tex)
       echo '%'$header > .$file
       ;;

    *.n)
       echo '.\"'$header > .$file
       ;;

    *.mar)
       echo ';'$header > .$file
       ;;

    *)
       echo 'File '$file' requires no SCCS header'
       touch .$file
       ;;

    esac

   cat $file >> .$file
   mv .$file $file

done

#! /bin/sh
# @(#)gomidas.sh	19.1 (ESO-IPG) 02/25/03 14:31:59
# .COPYRIGHT: Copyright (c) 1988 European Southern Observatory,
#
# .TYPE         command
# .NAME         gomidas
# .LANGUAGE     Bourne-shell script
# .ENVIRONMENT  Unix Systems. Executable under any SHELL.
# .USAGE        gomidas [-d display] [-m mid_work] 
#                 display:   X server for display and graphical windows.
#                 mid_work:  MIDAS startup directory (default: $HOME/mid_work)
#
# .COMMENTS     Resume a stopped session of MIDAS. It uses the following 
#		environment MID_WORK and DISPLAY
#               variables if they exist, otherwise takes defaults.
#               It checks arguments if any and exec to
#               $MIDASHOME/$MIDVERS/monit/prepa.exe
#
# .VERSION 1.1  900308: KB. Implementation
# .VERSION 2.1  920221: CG. Adapted to Unix scripts.
# .VERSION 3.1  930706: CG. Simplified and passing arguments.
#**************************************************************************

#
# Check for options:
#
while [ -n "$1" ]
do
  case $1 in
  -d)  DISPLAY=$2; export DISPLAY; shift; shift ;;
  -m)  MID_WORK=$2; export MID_WORK; shift; shift ;;
  *)  echo "Usage: gomidas [-d DISPLAY] [-m MID_WORK]"; exit 1 ;;
  esac
done

if [ -z "$MID_WORK" ]; then
  MID_WORK=$HOME/midwork/ ; export MID_WORK
fi

#
# if last char. of MID_WORK != '/'  append a '/'
#
if [ `expr $MID_WORK : '.*\(.\)'` != '/' ]; then
  MID_WORK=$MID_WORK/ ; export MID_WORK
fi

if [ ! -d $MID_WORK ]; then
  echo "Directory $MID_WORK does not exist"
  echo "Run inmidas first. EXIT."
  exit 1
fi

#
# Strip "/dev/", strip "pty/" (HP), "pts/" (IBM), and "tty" (all)
#
if ( tty -s )
then
  tt=`tty | sed -e 's/^.*dev\///' -e 's/pty\///' -e 's/pts\///' -e 's/tty//'`
else
  tt=none
fi

#
# Get's environment from previous inmidas
#
if [ ! -f $MID_WORK/.inmidas.$tt ]; then
  if [ ! -f $MID_WORK/.inmidas ]; then
    echo "No MIDAS session finished yet."
    echo "Run inmidas first. EXIT."
    exit 1
  else
    . $MID_WORK/.inmidas
    cp $MID_WORK/.inmidas $MID_WORK/.inmidas.$tt
  fi
else
  . $MID_WORK/.inmidas.$tt
fi

#
# Check if there is a running session already for DAZUNIT.
#
if [ -f "$MID_WORK/RUNNING$DAZUNIT" ]; then
  echo "Unit $DAZUNIT is locked by another MIDAS session. EXIT."
  exit 1
fi

#
# Check access to directories and files
#
if [ ! -d $MIDASHOME ]; then
  echo "${MIDASHOME}: not such directory."
  echo "Call your MIDAS operator. EXIT."
  exit 1
fi
if [ ! -d $MIDASHOME/$MIDVERS ]; then
  echo "$MIDASHOME/${MIDVERS}: not such directory."
  echo "Call your MIDAS operator. EXIT."
  exit 1
fi

#
# get all the variables (logical names)
#
if [ -f $MIDASHOME/$MIDVERS/monit/midlogs.sh ]; then
  . $MIDASHOME/$MIDVERS/monit/midlogs.sh
else
  echo "$MIDASHOME/$MIDVERS/monit/midlogs.sh not such file."
  echo "Call your MIDAS operator. EXIT."
  exit 1
fi

#
# logical assignements to devices. 
#
if [ -f $MID_WORK/devices.sh ] ; then
  . $MID_WORK/devices.sh
else
  . $MIDASHOME/$MIDVERS/monit/devices.sh
fi

#
# Catch any possible interrupt and remove the lock file
#
trap "rm -f $MID_WORK/RUNNING$DAZUNIT; exit 1" 1 2 3 15
touch $MID_WORK/RUNNING$DAZUNIT

#
# set TERMWIN to "yes" in any other previous release to 94NOV 
#
#if [ -z "$TERMWIN" -a "$MIDVERS" != "94NOV" ]; then
#  TERMWIN=yes; export TERMWIN
#fi


#
# Ignore CTRL-C before runnning prepa.exe
#
trap "" 2

#
# Set PATH for shared libraries
#
os=`uname`
case "$os" in
    "SunOS"|"Linux")
	if [ -z "$LD_LIBRARY_PATH" ] ; then
	  LD_LIBRARY_PATH=$MIDASHOME/$MIDVERS/lib
	else
	  LD_LIBRARY_PATH=$MIDASHOME/$MIDVERS/lib:$LD_LIBRARY_PATH
	fi
	export LD_LIBRARY_PATH
	;;
    "HP-UX")
	if [ -z "$SHLIB_PATH" ] ; then
	  SHLIB_PATH=$MIDASHOME/$MIDVERS/lib
	else
	  SHLIB_PATH=$MIDASHOME/$MIDVERS/lib:$SHLIB_PATH
	fi
	export SHLIB_PATH
	;;
     *)
	;;
esac

#
# run PREPA
#
$MID_MONIT/prepa.exe
if  [ $? = 1 ] ; then
  echo "...Midas session aborted..."
  rm -f $MID_WORK/RUNNING$DAZUNIT
  exit 1
fi

cp $MID_WORK/.inmidas.$tt $MID_WORK/.inmidas

rm -f $MID_WORK/RUNNING$DAZUNIT

exit 0

#! /bin/bash
# .COPYRIGHT: Copyright (c) 1988-2011 European Southern Observatory,
#                                         all rights reserved
# .TYPE           command
# .NAME           setup.sh
# .LANGUAGE       shell script
# .ENVIRONMENT    Unix Systems. Executable under SHELL and C-SHELL
# .COMMENTS       
#                 Usage: setup
# .REMARKS        The external variable $MIDASHOME and $MIDVERS must be set 
#
# .AUTHOR         Carlos Guirao
# .VERSION 3.2	  910213        Implementation
# .VERSION 3.3	  910929        Now also mail address for MIDAS manager.
# .VERSION 3.4	  911005        IDIDEV is changed without using s/RE/re/number
#				This feature does not exist for ed-Ultrix
# .VERSION 4.1    920119	MID$SYS (31:40) name of editor to use.
# .VERSION 4.2    920119	MID$SYS (31:40) by default "vi".
# .VERSION 4.3    920121	Using "ex" instead of "ed" (for PC/Linux)
# .VERSION 4.4    990324	Checking EDITOR (default ex, otherwise ed)
# 
# 111116	last modif KB
#
# Check how echo command removes new-line.
#
cmd=`basename $0`
echo=echo
if [ "$1" != "-a" ]; then 
  if [ "`echo -n`" = "-n" ] ; then
    SV_NONL="\c"
  else
    echo="echo -n"
  fi
fi

#
# Check if 'ex' editor exists otherwise use 'ed'
# "ed" is substituted by "ex" for PC/Linux except in SuSE
#
EDITOR=ex
which ex
if [ $? != 0 ]; then
   EDITOR=ed
fi

#
# First of all, goto the config directory adn
# <dirname> & <basename> commands emulated with <sed>
#   cd `dirname $0`
#   MIDVERS=`basename $VERSDIR`
#   MIDASHOME=`dirname $VERSDIR`
#
if [ -z "$MIDASHOME" -o -z "$MIDVERS" ] ; then
  cd `echo $0 | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
  MID_INSTALL=`pwd`
  VERSDIR=`echo $MID_INSTALL | sed 's/\/install\/unix$//'`
  MIDVERS=`echo $VERSDIR | sed -e 's/^.*\///'`
  MIDASHOME=`echo $VERSDIR | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
else
  cd $MIDASHOME/$MIDVERS/install/unix
fi

MID_INSTALL=$MIDASHOME/$MIDVERS/install/unix
MID_HOME=$MIDASHOME/$MIDVERS

#
# Reading local variables from local/setup
#
if [ -f $MIDASHOME/$MIDVERS/local/setup ]; then
  echo "Reading your local setup $MIDASHOME/$MIDVERS/local/setup..."
  echo ""
  . $MIDASHOME/$MIDVERS/local/setup		#setting host_os, debugger, ...
fi

#
# Checking existence of syskeys.unix
#
if [ ! -f $MIDASHOME/$MIDVERS/monit/syskeys.unix ]; then
  cd $MIDASHOME/$MIDVERS/monit
  make syskeys.unix >/dev/null 2>&1
  cd $MIDASHOME/$MIDVERS/install/unix
fi

while :
do
  if [ -z "$host_os" ]; then
    $echo "Name of the computer/system. (Max 20 char., e.g. IBM/AIX): " $SV_NONL
    read host_os
    if [ -z "$host_os" ] ; then
	continue
    fi
  fi
  host_os=`echo $host_os | \
    sed -e 's/$/                    /' \
	-e 's/^\(....................\).*$/\1/'`
  echo "Name of the computer/system: $host_os"
  $echo "OK? [yn] (y): " $SV_NONL
  if [ "$1" != "-a" ]; then   
    read answ
  fi
  if [ -z "$answ" ]; then
    answ=y
  fi
  if [ "$answ" = "y" -o "$answ" = "Y" ]; then
    break
  fi
  unset host_os
done


# Editor to be used, set by default to vi
editor="vi"
editor=`echo $editor | sed -e 's/$/         /' -e 's/^\(.........\).*$/\1/'`

while :
do
  if [ -z "$ps_print" ]; then
    echo "Command to print a PostScript file in a PostScript printer."
    $echo "(Max 20 char., e.g. lpr -h -P): " $SV_NONL
    read ps_print
    if [ -z "$ps_print" ] ; then
	continue
    fi
  fi
  ps_print=`echo $ps_print | \
    sed -e 's/$/                    /' \
	-e 's/^\(....................\).*$/\1/'`
  echo "Command to print a PostScript file: $ps_print"
  $echo "OK? [yn] (y): " $SV_NONL
  if [ "$1" != "-a" ]; then   
    read answ
  fi
  if [ -z "$answ" ]; then
    answ=y
  fi
  if [ "$answ" = "y" -o "$answ" = "Y" ]; then
    break
  fi
  unset ps_print
done

while :
do
  if [ -z "$ascii_print" ]; then
    echo "Command to print an ASCII file in a PostScript printer."
    $echo "(Max 20 char., e.g. lpr -h -P): " $SV_NONL
    read ascii_print
    if [ -z "$ascii_print" ] ; then
	continue
    fi
  fi
  ascii_print=`echo $ascii_print | \
    sed -e 's/$/                    /' \
	-e 's/^\(....................\).*$/\1/'`
  echo "Command to print an ASCII file: $ascii_print"
  $echo "OK? [yn] (y): " $SV_NONL
  if [ "$1" != "-a" ]; then   
    read answ
  fi
  if [ -z "$answ" ]; then
    answ=y
  fi
  if [ "$answ" = "y" -o "$answ" = "Y" ]; then
    break
  fi
  unset ascii_print
done

while :
do
  echo "Email of the MIDAS administrator at your site (problem-report service)"
  $echo "(Max 40 char., default: midas@eso.org): " $SV_NONL 
  if [ "$1" != "-a" ]; then 
    read mmail
  fi
  if [ -z "$mmail" ] ; then
    mmail="midas@eso.org"
  fi
  mmail=`echo $mmail | \
    sed -e 's/$/                                        /' \
        -e 's/^\(........................................\).*$/\1/'`
  echo "Email address: $mmail"
  $echo "OK? [yn] (y): " $SV_NONL
  if [ "$1" != "-a" ]; then 
    read answ
  fi
  if [ -z "$answ" ]; then
    answ=y
  fi
  if [ "$answ" = "y" -o "$answ" = "Y" ]; then
    break
  fi
  unset mmail
done

#echo host_os=$host_os, debugger=$debugger, editor=$editor, mail=$mmail

$echo "Editing $MIDASHOME/$MIDVERS/monit/syskeys.unix... " $SV_NONL

$EDITOR $MIDASHOME/$MIDVERS/monit/syskeys.unix <<EOF >/dev/null 2>&1
1
/^AUX_MODE/

s/^[^,]*,/2,/

1
/^MID\$SYS/

i
$host_os\$$editor
.

s/^/C /p
1
/^SYSCOMS/

s/........................................\(.*\)$/${ps_print}$ascii_print\1/

1
/^MID\$DEBUG/

s/\$dbx/\$$debugger/

1
/^MID\$MAIL/

i
$mmail
.

s/^/C /p
w
q
EOF
echo "Done."

#
# Set default MIDASHOME0 and MIDVERS0 to current values
#
MIDASHOME0=$MIDASHOME
MIDVERS0=$MIDVERS

#

FILE0=$MIDASHOME/$MIDVERS/system/unix/inmidas
FILE1=$MIDASHOME/$MIDVERS/system/unix/helpmidas
FILE2=$MIDASHOME/$MIDVERS/system/unix/drs

if [ ! -f $FILE0 ]; then
  cd $MIDASHOME/$MIDVERS/system/unix
  make >/dev/null 2>&1
  cd $MIDASHOME/$MIDVERS/install/unix
fi

unset answ
MIDASHOME0=$MIDASHOME
MIDVERS0=$MIDVERS
while :
do
  echo ""
  echo "Default definitions for <inmidas> script:"
  echo "-------------------------------------------"
  echo "MIDASHOME=$MIDASHOME0"
  echo "MIDVERS=$MIDVERS0"
  echo ""
  $echo "Do you want to modify these values [yn]? (n): " $SV_NONL
  if [ "$1" != "-a" ]; then   
    read answ
  fi
  if [ -z "$answ" ]; then
    break
  fi
  echo answ="$answ"
  if [ "$answ" = "n" -o "$answ" = "N" ]; then
    break
  fi
  while :
  do
    $echo "MIDASHOME: " $SV_NONL
    read MIDASHOME0
    if [ ! -d $MIDASHOME ]; then
      echo "No such directory: $MIDASHOME"
      continue
    else
      break
    fi
  done
  while :
  do
    $echo "MIDVERS: " $SV_NONL
    read MIDVERS0
    if [ ! -d $MIDASHOME/$MIDVERS ]; then
      echo "No such directory: $MIDASHOME/$MIDVERS"
      continue
    else
      break
    fi
  done
done

#
# NOTE: This could be done easier with ed, but in UNIX SYSTEM V
# ed exits when a pattern is not found.
#
MIDASHOME_0=`echo MIDASHOME0=$MIDASHOME0`
MIDVERS_0=`echo MIDVERS0=$MIDVERS0`
MIDASHOME_0_set="set $MIDASHOME_0"
MIDVERS_0_set="set $MIDVERS_0"

#
# IFS: To cancel space as argument separator
#
IFS=''

for file in $FILE0 $FILE1 $FILE2
do
echo "Editing $file ..."
cat $file | sed  \
        -e 's!^MIDVERS0=.*!'$MIDVERS_0'!' \
        -e 's!^set MIDVERS0=.*!'$MIDVERS_0_set'!' \
        -e 's!^MIDASHOME0=.*!'$MIDASHOME_0'!' \
        -e 's!^set MIDASHOME0=.*!'$MIDASHOME_0_set'!' \
> $file.t
chmod +xr $file.t
mv -f $file.t $file
done
echo "Done."
echo ""
echo "**********************************************************************"
echo "Copy the following files to a public directory included in \$PATH"
echo "(e.g. /usr/local/bin)"
echo "  cp $MIDASHOME/$MIDVERS/system/unix/inmidas      /usr/local/bin"
echo "  cp $MIDASHOME/$MIDVERS/system/unix/gomidas      /usr/local/bin"
echo "  cp $MIDASHOME/$MIDVERS/system/unix/helpmidas    /usr/local/bin"
echo "  cp $MIDASHOME/$MIDVERS/system/unix/drs          /usr/local/bin"
echo ""
echo "Copy the following man-pages to a directory included in \$MANPATH"
echo "(e.g. /usr/man/manl)"
echo "  cp $MIDASHOME/$MIDVERS/system/unix/manl/inmidas.l    /usr/man/manl"
echo "  cp $MIDASHOME/$MIDVERS/system/unix/manl/gomidas.l    /usr/man/manl"
echo "  cp $MIDASHOME/$MIDVERS/system/unix/manl/helpmidas.l  /usr/man/manl"
echo "  cp $MIDASHOME/$MIDVERS/system/unix/manl/readline.l   /usr/man/manl"
echo " or modify \$MANPATH to include $MIDASHOME/$MIDVERS/system/unix/manl"
echo ""
echo "To run MIDAS, type:"
echo "  inmidas         (if you want to run MIDAS defaults)"
echo "  gomidas         (to restart the previous MIDAS session)"
echo "  helpmidas       (standalone GUI help for MIDAS)"
echo "  drs <midas_command> (execute MIDAS command from Unix command line)"
echo "**********************************************************************"
echo "Type any character to continue." 
if [ "$1" != "-a" ]; then   
  read answ
fi

# 
# Send mail to esomidas@eso.org
#
#cd $MIDASHOME/$MIDVERS/local
#uname=`(uname -a) 2>/dev/null`
#(echo "MIDAS installed on $uname" | cat - setup make_options | mail esomidas@eso.org) >/dev/null 2>&1 &
#
exit

#! /bin/sh
# @(#)ed_moptions.sh	19.1 (ESO-IPG) 02/25/03 13:51:10
# .COPYRIGHT: Copyright (c) 1988 European Southern Observatory,
#                                         all rights reserved
# .TYPE           command
# .NAME           ed_make_options.sh
# .LANGUAGE       shell script
# .ENVIRONMENT    Unix Systems. Executable under SHELL and C-SHELL
# .COMMENTS       Editing the file make_options.
#
# .AUTHOR         Carlos Guirao
# .VERSION 1.1    17-Jul-1992:	Implementation
# .VERSION 2.1    20-Jan-1993:	"ex" instead of "ed" (for PC/Linux)
# .VERSION 3.1    990324        Checking EDITOR (default ex, otherwise ed)

if [ $# -lt 1 ]; then
	echo "Usage: $0 get/replace/add/delete key[=options]"
	exit 1
fi

if [ "$1" != "get" -a "$1" != "replace" -a "$1" != "add" -a "$1" != "delete" ]; then
	echo "Usage: $0 get/replace/add/delete key[=options]"
	exit 1
fi

if [ "$1" != "delete" -a $$ -lt 2 ]; then
	echo "Usage: $0 replace/add key=options"
	exit 1
fi

#
# Check if 'ex' editor exists otherwise use 'ed'
# "ed" is substituted by "ex" for PC/Linux except in SuSE
#
EDITOR=ex
which ex > /dev/null
if [ $? != 0 ]; then
   EDITOR=ed
fi

if [ -z "$MID_HOME" ]; then
    cd `echo $0 | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
    MID_INSTALL=`pwd`
    VERSDIR=`echo $MID_INSTALL | sed 's/\/install\/unix$//'`
    MIDVERS=`echo $VERSDIR | sed -e 's/^.*\///'`
    MIDASHOME=`echo $VERSDIR | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
    MID_HOME=$MIDASHOME/$MIDVERS
fi

file=$MID_HOME/local/make_options
op=$1
key=`echo $2 | awk -F= '{print $1}'`
options=`echo $2 | sed 's/^'$key'=//'`
options=`eval echo $options`
oldoptions=""

if [ -f $file ]; then
   oldoptions=`grep "^${key}=" $file | sed 's/^'$key'=//'`
fi

if [ -n "$oldoptions" ]; then
    echo $oldoptions
fi

if [ "$op" = "get" ]; then
   exit 0
fi

# Remove previous definition of $key if existed
$EDITOR $file << EOF >/dev/null 2>&1
1
/${key}=/d
w
q
EOF

if [ "$op" = "delete" ]; then
   exit 0
fi

if [ "$op" = "add" ]; then
     options=`eval echo $oldoptions $options`
fi

if [ -n "$options" ]; then
    echo "$key=$options" >> $file
fi
exit 0

#! /bin/sh
# 1. Parameter required : Context Name (Ex. hlqmake long)
# 2. Parameter : AUTHOR
# 3. Parameter : DATE
# If necessary, change AUTHOR, DATE, midas position, template position
#
# 050422	last modif
# 

cmd=`basename $0`
DIR=`pwd`
date=`date '+%d-%h-%y' | tr a-z A-Z`
author=`echo $USER | cut -c 1-2 | tr a-z A-Z`
context=`dirname $DIR` 
context=`basename $context` 
A=%

if [ -n "$1" ]; then
  context=$1
fi

if [ -n "$2" ]; then
  date=$2
fi

if [ -n "$3" ]; then
  author=$3
fi

while :
do
    DIR=`echo $DIR | sed 's/\/[^\/]*$//'`
    if [ -d $DIR/context ]; then
        break
    fi
done

if [ ! -f $DIR/context/$context.ctx ]; then
  echo "${cmd}: Context file $context.ctx not found"
  echo "Usage: $cmd context"
fi

for command in `cat $DIR/context/$context.ctx | \
                grep -i "CREA" | grep -i "/COM" | \
                awk '{if (substr($0,1,1) != "!") {print $2}}' `

do

echo 'Command : '$command

qualif=`echo $command | awk -F/ '{print $2}'`
name=`echo $command | awk '{ FS = "/"} \
     { i = index ($0,"/") - 1} \
     {if (i < 6) print  substr($0,1,i) "_" substr($2,1,4) ".hlq" } \
     {if (i >= 6) print substr ($0,1,6)  substr($2,1,4) ".hlq" } '`

name=`echo $name | tr A-Z a-z`
command=`echo $command | tr a-z A-Z |  sed 's/\//\\\\\//g'`
qualif=`echo $qualif | tr a-z A-Z`

if [ -f $name ]; then
   echo 'Already exists : '$name
else
 echo "% ${A}W% (ESO-IPG) ${A}G% ${A}U%" |
 cat - $DIR/system/unix/template.hlq |   \
 sed -e 's/\&\&COMMAND/'$command'/g'   \
    -e 's/\&\&QUALIF/'$qualif'/g'      \
    -e 's/\&\&FILE/'$name'/g'          \
    -e 's/\&\&AUTHOR/'$author'/g'           \
    -e 's/\&\&DATE/'$date'/g'             \
 > $name

 echo 'Created : '$name

fi

done

#! /bin/sh
# .COPYRIGHT: Copyright (c) 1988-2005 European Southern Observatory,
#                                         all rights reserved
# .TYPE           command
# .NAME           ftoc_vmr.sh
# .LANGUAGE       shell script
# .ENVIRONMENT    Unix Systems. Executable under SHELL and C-SHELL
# .COMMENTS  	  Test for Fortran to C interface. Executes ftoc_vmr.exe
#		  if exists and it is executable, otherwise nothing.
# .REMARKS
# .AUTHOR         Carlos Guirao
# .VERSION 1.1    06-Jul-1992:	Implementation
# 050422	last modif


# <dirname> emulated with <sed>
#   DIR=`dirname $0`
DIR=`echo $0 | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`

if [ -f $DIR/ftoc_vmr.exe -a -s $DIR/ftoc_vmr.exe ] ; then
        $DIR/ftoc_vmr.exe 
fi
exit 0

#!/bin/sh
# @(#)install.sh	19.1 (ESO-IPG) 02/25/03 14:31:59
#
#  Installation script for MIDAS from CD-ROM with binaries.
#
#set -x

###########################################################################
#
#  Initialize all the read-only variables used by this script.  Mark
#  them readonly so they don't get accidentally modified
#
###########################################################################

# Determine how to set prompt
if [ "`echo -n a`" = a ]; then
	# BSD echo
	NNN=-n 
	CCC=        
else
	# USG echo
	NNN= 
	CCC='\c'      
fi
readonly NNN CCC

# Most of this needs to updated for each new CD.
MIDAS_SOURCES="95novpl2.0.tar.z"
MIDVERS="95NOV"
DATE='February 1996'
COPYDATE="1996"
RELEASE="95NOVpl2.0"

RETURN_MSG="RETURN TO MAIN MENU"

readonly MIDAS_SOURCES MIDVERS DATE COPYDATE RETURN_MSG RELEASE

STATE_CD=1
STATE_ARCH=2
STATE_MIDASHOME=3
STATE_PROD_SELECT=4
STATE_INSTALL=5
STATE_SETUP=6
STATE_QUIT=Q

readonly STATE_CD STATE_ARCH STATE_MIDASHOME STATE_PROD_SELECT 
readonly STATE_INSTALL STATE_QUIT STATE_SETUP

PROD_BIN="MIDAS binary"
PROD_SRC="MIDAS sources"
PROD_GUI="MIDAS statically-linked GUIs"
PROD_DEMO="MIDAS demo data"
PROD_CALIB="MIDAS calibration data"

readonly PROD_BIN PROD_SRC PROD_GUI PROD_DEMO PROD_CALIB

ARCH_ALPHA="Alpha OSF"
ARCH_HP700="HP9000 Series 700/800"
ARCH_IBM="IBM RS6000 AIX"
ARCH_SGI5="SGI IRIX 5"
ARCH_SUNOS="SPARC Sunos 4.1.x"
ARCH_SOLARIS="SPARC Solaris 5.x"
ARCH_LINUX="PC LINUX 1.2.13"

REL_ALPHA="OSF1"
REL_HP700="HP-UX"
REL_IBM="AIX"
REL_SGI5="IRIX"
REL_SUNOS="SunOS_4.1.3"
REL_SOLARIS4="SunOS_5.4"
REL_SOLARIS5="SunOS_5.5"
REL_LINUX="Linux"

readonly ARCH_ALPHA ARCH_HP700 ARCH_IBM 
readonly ARCH_SGI5 ARCH_SUNOS ARCH_SOLARIS ARCH_LINUX
readonly REL_ALPHA REL_HP700 REL_IBM 
readonly REL_SGI5 REL_SUNOS REL_SOLARIS4 REL_SOLARIS5 REL_LINUX

ARCH_LIST="$ARCH_ALPHA,$ARCH_HP700,$ARCH_IBM"
ARCH_LIST="$ARCH_LIST,$ARCH_SGI5,$ARCH_SUNOS,$ARCH_SOLARIS,$ARCH_LINUX"

readonly ARCH_LIST

# Script sets these up during run (all begin with _)
MIDAS_CDDIR=
MIDAS_ARCH=
MIDAS_PROD_LIST=
MIDAS_PROD_SELECTED=
MIDAS_PROD_INSTALLED=
MIDAS_STATE=
MIDAS_SETUP=
MIDAS_BINDIR_DONE=
MIDAS_LIBDIR_DONE=
MIDAS_MANDIR_DONE=
MIDAS_ARCH_PREFIX=
MIDAS_MANDIR=/usr/man/manl
MIDAS_BINDIR=/usr/bin
MIDAS_LIBDIR=/usr/lib
MIDAS_SHID=3.1
#######################################################################
#
#  Generic support routines
#
#######################################################################

aborted()
{
	#  Catch user-generated interrupts, and quit

	echo ""
	echo "**** INSTALLATION ABORTED BY USER ****"
	echo ""
	exit 1
}
trap aborted 1 2 3

killed()
{
	#  Catch attempts to kill this process

    echo ""
    echo "**** INSTALLATION ABORTED ABNORMALLY ****"
    echo ""
    exit 1
}
trap killed 15

error()
{
	#  standard error message

	echo '***' $* > /dev/tty
	false
}

fatal_error()
{
	#  Print error message and die; this should never happen

	error $*
	kill -15 $$
}

change_ifs()
{
	#
	#  Change IFS to $1, saving previous value in $OFS.
	#  NOTE: this is not a stack!!  Do not nest calls!!

	if [ "$IFS" != "$1" ]; then
		OIFS="$IFS"
		IFS="$1"
	fi
}

restore_ifs()
{
	#  Restore the old value of IFS

	IFS="$OIFS"
}

array()
{
	#
	#  mimic the behavior of arrays; pick the $2'th element out of $1
	#  uses 1-indexing
	#

	vector="$1"
	rindex="$2"

	index=1
	change_ifs ","
	for elt in $vector; do
		if [ "$index" -eq "$rindex" ]; then
			echo "$elt"
			restore_ifs
			return
		fi
		index=`expr $index + 1`
	done

	restore_ifs
	fatal_error "Array selection failed for $vector[$rindex]"
}

necho()
{
	#
	#  A safe way to perform echo without sending a new-line
	#

	echo $NNN "$*" $CCC > /dev/tty
}

ask_return()
{
	#  Simply get the user to hit the return key

	necho 'Hit <return> to continue ...'
	read x
}

ask_yn()
{
	#
	#  Get a yes/no answer from the user; $1 is the prompt, $2 the default
	#

	prompt="$1"
	def="${2:-y}"		# yes is the default if not supplied
	while true; do
		necho "$prompt [$def]: "
		read answer
		answer="${answer:-$def}"
		case "$answer" in
			[yY])
				answer=y
				break
				;;
			[nN])
				answer=n
				break
				;;
			  *)
				error Please enter "'y'" or "'n'".
				;;
		esac
	done
	[ $answer = y ]
}

ask_response()
{
	#
	#  Get a (non-zero) response from the user
	#  $1 is the question, $2 is the default (if any).
	#

	question="$1"
	default="$2"
	while true; do
		if [ -z "$default" ]; then
			necho "$question: "
		else
			necho "$question [$default]: "
		fi
		read answer
		if [ -z "$answer" ]; then
			answer=$default
		fi
		if [ -z "$answer" ]; then
			error Please enter a non-empty string.
		else
			break
		fi
	done
	echo $answer
}

difference()
{
	#
	#  Calculate and return the list of all elements in $1, but not
	#  in $2.  This calculates set difference the hard way.
	#

	l1="$1" 
	l2="$2"
	l3=

	change_ifs ","
	for i in $l1; do
		if in_list "$l2" "$i"; then
			echo > /dev/null		# do nothing
		else
			l3=`addto "$l3" "$i"`
		fi
	done
	restore_ifs

	echo "$l3"
}

addto()
{
	#
	#  Add element $2 to list $1; return the result
	#

	ll="$1"
	el="$2"

	change_ifs ","
	if in_list "$ll" "$el"; then
		echo > /dev/null		# do nothing
	else
		if [ -z "$ll" ]; then
			ll="$el"
		else
			ll="$ll,$el"
		fi
	fi
	restore_ifs

	echo "$ll"
}

genlist()
{
	#  generate a list of numbers from $1..$2

	echo $1 $2 | awk '{
		for (i=$1; i<=$2; i++) list=list "," i
		print substr(list,2)
	}'
}

count()
{
	#  count the number of entries in $1

	echo $1 | awk -F, '{ print NF }'
}

in_list()
{
	#
	#  Determine whether $2 is in the list $1; $1 is a comma-separated
	#  list of valid values
	#

	found=f
	list="$1"
	arg="$2"
	change_ifs ","
	for i in $list
	do
		if [ "$i" = "$arg" ]; then
			found=t
			break
		fi
	done

	restore_ifs
	[ $found = t ]
}

ask_list()
{
	# 
	#  Ask the user for a value in list $2; the prompt is $1, and
	#  the default value is $3
	#

	prompt="$1"
	default="$3"
	list="$2"

	while true; do
		num=`ask_response "$prompt" "$default"`
		if in_list "$list" $num; then
			break
		else
			error "$num is not one of the choices."
		fi
	done

	echo $num
}

ask_multi()
{
	#
	#  Allow a multiple selection, by number.  $1 is the prompt
	#  to use, $2 is the list of valid inputs
	#

	prompt="$1"
	list="$2"

	while true; do
		pselect=`ask_response "$prompt"`
		err=f
		change_ifs ","
		for num in $pselect; do
			if in_list "$list" $num; then
				true
			else
				error "$num is not a valid choice"
				err=t
				break
			fi
		done
		restore_ifs
		if [ "$err" != "t" ]; then
			break
		fi
	done
	echo $pselect
}

valid_dir()
{
	#  Determine if $1 is a valid directory specification
	#  This means it must begin with a '/'

	if [ "`expr "$1" : '\(/\).*'`" != "/" ]; then
		error "Directory name must begin with a '/'"
	fi

	return $?
}

exists_dir()
{
	#  Determine whether directory $1 exists.  It must also
	#  be a valid directory (see above).

	dname=$1

	if [ -d "$dname" ]; then
		valid_dir $dname
	else
		error "Directory \"$dname\" does not exist"
	fi
	return $?
}

#######################################################################
#
#  Pre- and Post- installation banners
#
#######################################################################

banner()
{
#  Banner before the script begins.  Put trademarks, disclaimers,
#  etc. in here.

clear > /dev/tty
echo "                                                                    " > /dev/tty
echo "     ********************************************************************" > /dev/tty
echo "                       $RELEASE release of ESO-MIDAS " > /dev/tty
echo "               Copyright (C) $COPYDATE European Southern Observatory" > /dev/tty
echo "     This program is free software; you can redistribute it and/or modify" > /dev/tty
echo "     it under the terms of the GNU General Public License as published by" > /dev/tty
echo "     the Free Software Foundation; either version 2 of the License, or   " > /dev/tty
echo "     (at your option) any later version.                                 " > /dev/tty
echo "                                                                      " > /dev/tty
echo "     This program is distributed in the hope that it will be useful, but " > /dev/tty
echo "     WITHOUT ANY WARRANTY; without even the implied warranty of          " > /dev/tty
echo "     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU    " > /dev/tty
echo "     General Public License for more details.                            " > /dev/tty
echo "                                                                      " > /dev/tty
echo "     You should have received a copy of the GNU General Public License   " > /dev/tty
echo "     along with this program; if not, write to the Free Software         " > /dev/tty
echo "     Foundation,  Inc., 675 Massachusetss Ave, Cambridge, MA 02139, USA. " > /dev/tty
echo "     Corresponding concerning ESO-MIDAS should be addressed as follows:  " > /dev/tty
echo "     Internet e-mail: midas@eso.org                                      " > /dev/tty
echo "     Postal address: European Southern Observatory                       " > /dev/tty
echo "                     Data Management Division                            " > /dev/tty
echo "                     Karl-Schwarzschild-Strasse 2                        " > /dev/tty
echo "                     D-85748 Garching bei Muenchen. GERMANY              " > /dev/tty
echo "     ********************************************************************" > /dev/tty
}

banner1()
{
#  Banner before completing MIDAS installation
  clear > /dev/tty
#  echo "" > /dev/tty
  echo "  Complete the ESO-MIDAS installation means:" > /dev/tty
  echo "" > /dev/tty
  echo "  1. Create a soft link from /midas to $MIDASHOME" >/dev/tty
  echo "  2. Copy the inmidas, gomidas and helpmidas scripts from" > /dev/tty
  echo "     $MIDASHOME/$MIDVERS/system/unix to e.g.: /usr/bin" > /dev/tty
  echo "  3. Copy inmidas.l, gomidas.l and helpmidas.l man-pages from" > /dev/tty 
  echo "     $MIDASHOME/$MIDVERS/system/unix/manl to e.g. /usr/man/manl" >/dev/tty
  echo "  4. Create the system references to MIDAS shared libraries located in" >/dev/tty
  echo "       $MIDASHOME/$MIDVERS/lib" >/dev/tty
  echo "" > /dev/tty
  echo "  If you can not become superuser to run these tasks you can, as a normal" > /dev/tty 
  echo "  user, run MIDAS by setting the following environment variables and" > /dev/tty
  echo "  executing the inmidas, gomidas and helpmidas scripts located in" > /dev/tty  
  echo "  $MIDASHOME/$MIDVERS/system/unix" > /dev/tty
  echo "" >/dev/tty
  echo "    % setenv MIDASHOME $MIDASHOME" >/dev/tty
  case "$MIDAS_ARCH" in
    $ARCH_HP700)
      echo "    % setenv SHLIB_PATH $MIDASHOME/$MIDVERS/lib" >/dev/tty
      ;;
    *)
      echo "    % setenv LD_LIBRARY_PATH $MIDASHOME/$MIDVERS/lib" >/dev/tty
      ;;
    esac
  echo "    % $MIDASHOME/$MIDVERS/system/unix/inmidas" > /dev/tty
  echo "" >/dev/tty
}

post_install()
{
	# Should do something here??

	echo "                                                                " > /dev/tty
	echo "                                                                " > /dev/tty
}

#######################################################################
#
#  State Querying Functions
#     - isset_*        : only returns status
#     - check_*        : calls isset_* and print message
#     - precond_       : checks if preconditions are met
#     - check_precond_ : checks preconditions, prints message
#
#######################################################################
isset_su()
{
	if  user=`sh -c whoami 2>/dev/null` ; then
		:
	elif  user=`sh -c /usr/bin/whoami 2>/dev/null` ; then
		:
	elif  user=`sh -c /usr/ucb/whoami 2>/dev/null` ; then
		:
	else
		user="$USER"
	fi
	[ "$user" = "root" ]
}

isset_cddir()
{
	[ -n "$MIDAS_CDDIR" ]
}

isset_arch()
{
	[ -n "$MIDAS_ARCH" ]
}

isset_midashome()
{
	[ -n "$MIDASHOME" -a -d "$MIDASHOME" ]
}

isset_product()
{
	[ -n "$MIDAS_PROD_SELECTED" ]
}

isset_prod_installed()
{
	[ -n "$MIDAS_PROD_INSTALLED" ]
}

isset_setup()
{
	[ -f "$MIDASHOME/$MIDVERS/monit/prepa.exe" ]
}

isset_setup_installed()
{
	[ -n "$MIDAS_SETUP" ]
}

#
#  Check functions
#

check_cddir()
{
	isset_cddir ||
		( error "Please enter the CD mount point first (item $STATE_CD)."; 
		  ask_return;
		  false
		)
}

check_arch()
{
	isset_arch ||
		( error "Please select an architecture first (item $STATE_ARCH).";
		  ask_return;
		  false
		)
}

check_setup()
{
	isset_setup ||
		( error "MIDAS binary must be installed first (item $STATE_PROD_SELECT and/or item $STATE_INSTALL)."; 
		  ask_return;
		  false
		)
}

check_midashome()
{
	isset_midashome ||
		( error "Please select the installation directory MIDASHOME first (item $STATE_MIDASHOME).";
		  ask_return;
		  false
		)
}

check_product()
{
	isset_product ||
		( error "Please select the ESO-MIDAS product(s) to install first (item $STATE_PROD_SELECT).";
		  ask_return;
		  false
		)
}

check_prod_installed()
{
	isset_prod_installed || 
		( error "Please install the ESO-MIDAS products first (item $STATE_INSTALL).";
		  ask_return;
		  false
		)
}

#
#  Precondition functions
#

precond_product()
{
	isset_arch && isset_midashome
}

precond_install()
{
	isset_cddir && isset_arch && isset_midashome && isset_product
}

precond_setup()
{
	isset_midashome && isset_product && isset_arch && isset_prod_installed
}

precond_run_password()
{
	isset_midashome && isset_password
}

#
#  Check Precondition functions
#
check_precond_run_password()
{
	check_cddir && check_midashome 
}

check_precond_product()
{
	check_arch && check_midashome
}

check_precond_install()
{
	check_cddir && check_arch && check_midashome && check_product
}

check_precond_setup()
{
	check_midashome && check_arch && check_setup
}

######################################################################
#
#  State setting and querying functions
#
######################################################################

set_state()
{
	#  
	#  Sanity check the state; find the lowest state whose preconditions
	#  are met, and which has not been completed.  Break after two passes.

	pass=1
	while true; do
		case "$MIDAS_STATE" in
			$STATE_CD)
				if isset_cddir; then
					MIDAS_STATE=`expr $MIDAS_STATE + 1`
					continue
				else
					break
				fi
				;;
			$STATE_ARCH)
				if isset_arch; then
					MIDAS_STATE=`expr $MIDAS_STATE + 1`
					continue
				else
					break
				fi
				;;
			$STATE_MIDASHOME)
				if isset_midashome; then
					MIDAS_STATE=`expr $MIDAS_STATE + 1`
					continue
				else
					break
				fi
				;;
			$STATE_PROD_SELECT)
				if precond_product; then
					if isset_product || isset_prod_installed; then
						MIDAS_STATE=`expr $MIDAS_STATE + 1`
						continue
					fi
					break
				fi
				;;
			$STATE_INSTALL)
				if precond_install; then
					break
				elif isset_prod_installed; then
					MIDAS_STATE=`expr $MIDAS_STATE + 1`
					continue
				fi
				;;
			$STATE_SETUP)
				if precond_setup; then
					break
				fi
				;;
			$STATE_QUIT)
				break
				;;
		esac
		if [ "$pass" -gt 1 ]; then
			break
		fi

		pass=`expr $pass + 1`
		MIDAS_STATE=1
	done
}

show_state()
{
	#  Display the current state.  Prints just about everything the user
	#  needs to know about the installation process.

	if isset_cddir || isset_arch || isset_midashome; then
		# one of these must be set for anything to be displayed
		echo > /dev/null
	else
		return
	fi

	echo '***************************************************************************' > /dev/tty
		echo "  ESO-MIDAS Release MIDVERS:           $MIDVERS"       > /dev/tty
	if isset_cddir; then
		echo "  CD mount directory:                  $MIDAS_CDDIR" > /dev/tty
	fi
	if isset_arch; then
		echo "  Target Architecture:                 $MIDAS_ARCH" > /dev/tty
	fi
	if isset_midashome; then
		echo "  Installation Directory MIDASHOME:    $MIDASHOME"       > /dev/tty
	fi
	if isset_product; then
		echo "  Products selected for installation:   "       > /dev/tty
		ctr=1
		change_ifs ","
		for i in $MIDAS_PROD_SELECTED; do
			echo "              ${ctr}. ${i}.         " > /dev/tty
			ctr=`expr $ctr + 1`
		done
		restore_ifs
	fi
	if isset_prod_installed; then
		echo "  Products installed:   "       > /dev/tty
		ctr=1
		change_ifs ","
		for i in $MIDAS_PROD_INSTALLED; do
			echo "              ${ctr}. ${i}.         " > /dev/tty
			ctr=`expr $ctr + 1`
		done
		restore_ifs
	fi
	echo '***************************************************************************' > /dev/tty
}

#######################################################################
#
#  Main Action Routines
#
#######################################################################

build_prodlist()
{
	#
	#  Build a list of products supported on chosen architecture
	#

	MIDAS_PROD_LIST="$PROD_SRC"
	case "$MIDAS_ARCH" in
		$ARCH_SUNOS|$ARCH_LINUX)
		    if [ -n "$MIDAS_PROD_LIST" ]; then
			MIDAS_PROD_LIST="$MIDAS_PROD_LIST,$PROD_BIN,$PROD_GUI,$PROD_DEMO,$PROD_CALIB"
		    else
			MIDAS_PROD_LIST="$PROD_BIN,$PROD_GUI,$PROD_DEMO,$PROD_CALIB"
		    fi
			;;
		$ARCH_HP700|$ARCH_SOLARIS|$ARCH_ALPHA|$ARCH_SGI5|$ARCH_IBM)
		    if [ -n "$MIDAS_PROD_LIST" ]; then
			MIDAS_PROD_LIST="$MIDAS_PROD_LIST,$PROD_BIN,$PROD_DEMO,$PROD_CALIB"
		    else
			MIDAS_PROD_LIST="$PROD_BIN,$PROD_DEMO,$PROD_CALIB"
		    fi
			;;
		*)
			fatal_error "Unknown architecture $MIDAS_ARCH"
			;;
	esac
}

pick_cddir()
{
	#
	#  Allow the user to specify the directory on which the CD
	#  is mounted.  Usually this is /cdrom.
	#

	clear > /dev/tty

	echo "                                                       " > /dev/tty
	echo "  This installation program must know where the MIDAS  " > /dev/tty
	echo "  CD has been mounted. The usual mount point is /cdrom." > /dev/tty
	echo "                                                       " > /dev/tty
	echo "  Type in 'R' at the prompt below if you want to return" > /dev/tty
	echo "  to the main menu. " > /dev/tty
	echo "                                                       " > /dev/tty

	while true; do
		cd_def=${MIDAS_CDDIR:-/cdrom}
		dir=`ask_response 'Enter the CD mount point' $cd_def`
		if [ "$dir" = "r" -o "$dir" = "R" ]; then
			break
		elif exists_dir "$dir"; then
			ifile=`ls $dir|grep -i install.sh`
			if [ -z "$ifile" ]; then
				error "This directory does not contain any MIDAS products."
			else
				MIDAS_CDDIR=$dir
				break
			fi
		fi
	done

	isset_cddir
}

pick_arch()
{
	#
	#  Select an architecture/toolkit combination
	#

	clear > /dev/tty

	echo "                                          " 	> /dev/tty
	echo "Please select one of the following," > /dev/tty
	echo "or type 'R' to return to the main menu." > /dev/tty
	echo "                                          " 	> /dev/tty
	echo "Architecture" | awk '{ printf("     %-25s\n", $1) }'  > /dev/tty
	echo "============" | awk '{ printf("     %-25s\n", $1) }'  > /dev/tty
	ctr=1
	change_ifs ","
	for i in $ARCH_LIST; do
		arch="$i"
		echo "${ctr}.:${arch}" 
		ctr=`expr $ctr + 1`
	done | awk -F: '{ printf(" %3s %-25s\n", $1, $2) }' > /dev/tty
	echo "  R. $RETURN_MSG." > /dev/tty
	echo "                 " > /dev/tty
	restore_ifs

	# For some reason, ctr=1 after the above for loop; 
	# The pipe seems to cause this
	ctr=`count "$ARCH_LIST"`
	alist=`genlist 1 $ctr`
	alist="$alist,r,R"

	aselect=`ask_list 'Enter your selection' "$alist"`
	case "$aselect" in
		[rR])	;;
		   *)	MIDAS_ARCH=`array "$ARCH_LIST" "$aselect"`
				MIDAS_PROD_SELECTED=""
				MIDAS_PROD_INSTALLED=""
                        case "$MIDAS_ARCH" in
                                $ARCH_ALPHA)    MIDAS_ARCH_PREFIX=alphaosf;;
                                $ARCH_HP700)    MIDAS_ARCH_PREFIX=hp700;;
                                $ARCH_IBM)      MIDAS_ARCH_PREFIX=rs6000;;
                                $ARCH_SGI5)     MIDAS_ARCH_PREFIX=sgirix5;;
                                $ARCH_SUNOS)    MIDAS_ARCH_PREFIX=sparcsun;;
                                $ARCH_SOLARIS)  MIDAS_ARCH_PREFIX=sparcsol;;
                                $ARCH_LINUX)    MIDAS_ARCH_PREFIX=pclinux;;
			esac
				;;
	esac

	isset_arch
}

pick_midashome()
{
	#
	#  Pick the MIDASHOME directory; this is inherited from the environment,
	#  if already set.
	#

	clear > /dev/tty

	echo "                                                           " > /dev/tty
	echo "  All  ESO-MIDAS products  for  the same  architecture     " > /dev/tty
	echo "  are installed in the same directory.  The location of    " > /dev/tty
	echo "  this directory is stored in the environment variable     " > /dev/tty
	echo "  MIDASHOME. You will need to designate the location of    " > /dev/tty
	echo "  this directory, and possibly create it before you can     " > /dev/tty
	echo "  install any ESO-MIDAS products.                                  " > /dev/tty
	echo "                                                           " > /dev/tty
	echo "  Type in 'R' at the prompt below if you want to return    " > /dev/tty
	echo "  to the main menu. " > /dev/tty

	while true; do
		echo "                                                           " > /dev/tty
		echo 'Enter the name of the directory in which to install ESO-MIDAS products.' > /dev/tty
		dir=`ask_response 'MIDASHOME' $MIDASHOME`
		if [ "$dir" = "r" -o "$dir" = "R" ]; then
			break
		else
			if valid_dir "$dir"; then
				if [ ! -d "$dir" ]; then
					echo "Directory $dir does not exist. " > /dev/tty
					if ask_yn "OK to create new directory $dir"; then
						mkdir $dir
						if [ $? -ne 0 ]; then
							error "Unable to create directory $dir."
							continue
						fi
					else
						continue
					fi
				fi
				if ask_yn "OK to install in directory $dir"; then
					MIDASHOME=$dir
					export MIDASHOME
					break
				fi
			fi
		fi
	done

	isset_midashome
}

pick_mandir()
{
  echo "                                                                        " > /dev/tty
  echo "Enter the name of the directory in which to install ESO-MIDAS man-pages," > /dev/tty
  echo "or type in 'R' at the prompt below if you want to skip                  " > /dev/tty 
  echo "                                                                        " > /dev/tty
  while true; do
    dir=`ask_response 'MIDAS_MANDIR' $MIDAS_MANDIR`
      if [ "$dir" = "r" -o "$dir" = "R" ]; then
	break
      else
	if valid_dir "$dir"; then
	  if [ ! -d "$dir" ]; then
	    echo "Directory $dir does not exist. " > /dev/tty
	    continue
	  fi
	if ask_yn "OK to copy ESO-MIDAS man-pages in directory $dir"; then
	  man_suffix=`expr "$dir" : '.*man\(.\)'`
	  for manpage in inmidas gomidas helpmidas readline
	  do 
	    cp $MIDASHOME/$MIDVERS/system/unix/manl/$manpage.l $dir/$manpage.$man_suffix
	    echo "cp $MIDASHOME/$MIDVERS/system/unix/manl/$manpage.l $dir/$manpage.$man_suffix" >/dev/tty
	  done
	  MIDAS_MANDIR_DONE="yes"
	  break
	fi
      fi
    fi
  done
}

pick_bindir()
{
  echo "                                                                      " > /dev/tty
  echo "Enter the name of the directory in which to install ESO-MIDAS scripts," > /dev/tty
  echo "or type in 'R' at the prompt below if you want to skip                " > /dev/tty 
  echo "                                                                      " > /dev/tty
  while true; do
    dir=`ask_response 'MIDAS_BINDIR' $MIDAS_BINDIR`
    if [ "$dir" = "r" -o "$dir" = "R" ]; then
      break
    else
      if valid_dir "$dir"; then
	if [ ! -d "$dir" ]; then
          echo "Directory $dir does not exist. " > /dev/tty
	    continue
	fi
	if ask_yn "OK to copy ESO-MIDAS scripts in directory $dir"; then
	  MIDASHOME_0=`echo MIDASHOME0=$MIDASHOME | sed 's/\//\\\\\//g'`
	  MIDVERS_0=`echo MIDVERS0=$MIDVERS`
 	  for script in inmidas gomidas helpmidas
	  do 
	    cp $MIDASHOME/$MIDVERS/system/unix/$script $dir
	    echo "cp $MIDASHOME/$MIDVERS/system/unix/$script $dir" >/dev/tty
	  done
	  for file in $dir/inmidas $dir/helpmidas
	  do
	    echo "Editing $file ..."
	    cat $file | sed  \
              -e 's/^MIDASHOME0=.*/'$MIDASHOME_0'/' \
              -e 's/^MIDVERS0=.*/'$MIDVERS_0'/' \
              > $file.t
	    chmod +xr $file.t
	    mv -f $file.t $file
	  done
	  MIDAS_BINDIR_DONE="yes"
	  break
        fi
      fi
    fi
  done
}

pick_libdir()
{
  echo "                                                                      " > /dev/tty
  echo "Enter the name of the directory in which to install ESO-MIDAS libraries," > /dev/tty
  echo "or type in 'R' at the prompt below if you want to skip                " > /dev/tty 
  echo "                                                                      " > /dev/tty
  while true; do
    dir=`ask_response 'MIDAS_LIBDIR' $MIDAS_LIBDIR`
    if [ "$dir" = "r" -o "$dir" = "R" ]; then
      break
    else
      if valid_dir "$dir"; then
	if [ ! -d "$dir" ]; then
          echo "Directory $dir does not exist. " > /dev/tty
	    continue
	fi
	if ask_yn "OK to link ESO-MIDAS libraries in directory $dir"; then
 	  for library in libmidas libgmidas
	  do 
	    case "$MIDAS_ARCH" in
		$ARCH_ALPHA|$ARCH_SOLARIS)
		  rm -f $dir/$library.so
		  ln -s $MIDASHOME/$MIDVERS/lib/$library.so $dir/$library.so
		  echo "ln -s $MIDASHOME/$MIDVERS/$library.so $dir/$library.so" >/dev/tty
		  ;;
		$ARCH_SUNOS)
		  rm -f $dir/$library.so.$MIDAS_SHID
		  ln -s $MIDASHOME/$MIDVERS/lib/$library.so.$MIDAS_SHID $dir/$library.so.$MIDAS_SHID
		  echo "ln -s $MIDASHOME/$MIDVERS/lib/$library.so.$MIDAS_SHID $dir/$library.so.$MIDAS_SHID" >/dev/tty
		  /usr/etc/ldconfig
		  ;;
		*)
		  error "No ESO-MIDAS shared libraries expected for $MIDAS_ARCH"
		  return
		  ;;
            esac
	  done
	  MIDAS_LIBDIR_DONE="yes"
	  break
        fi
      fi
    fi
  done
}

pick_product()
{
	#
	#  Pick the list of products to install, based on the architecture
	#

	if check_precond_product; then
		clear > /dev/tty

		build_prodlist

		echo "                                            "  > /dev/tty
		echo "Please select any of the following products."  > /dev/tty
		echo "If you want to install more than one product," > /dev/tty
		echo "enter them in a comma-separated list."		 > /dev/tty
		echo "                                            "  > /dev/tty

		ctr=1
		plist=
		change_ifs ","
		for i in $MIDAS_PROD_LIST; do
			echo " ${ctr}. ${i}.         " > /dev/tty
			plist=`addto "$plist" "$ctr"`
			ctr=`expr $ctr + 1`
		done
		restore_ifs

		echo " A. Install ALL products." > /dev/tty
		echo " R. $RETURN_MSG." > /dev/tty
		plist="$plist,a,A,r,R"
		echo "                         " > /dev/tty
		pselect=`ask_multi 'Enter your list' "$plist"`

		case "$pselect" in
			[rR])	false; return
					;;
			[aA])	# Put all entries in pselect
					j=1
					pselect=
					while [ $j -lt $ctr ]; do
						pselect=`addto "$pselect" "$j"`
						j=`expr $j + 1`
					done
					;;
		esac

		#
		#  go back through $MIDAS_PROD_LIST and create MIDAS_PROD_SELECTED
		#  the list of selected products
		#

		change_ifs ","
		MIDAS_PROD_SELECTED=
		for j in $pselect; do
			ctr=1
			for i in $MIDAS_PROD_LIST; do
				if [ "$ctr" -eq "$j" ]; then
					case "$i" in
						$PROD_BIN)	[ -f $MIDASHOME/$MIDVERS/monit/prepa.exe ];;
						$PROD_SRC)	[ -f $MIDASHOME/$MIDVERS/monit/prepa.c ];;
						$PROD_GUI)	[ -f $MIDASHOME/$MIDVERS/gui/exec/help.exe ];;
						$PROD_DEMO)	[ -f $MIDASHOME/demo ];;
						$PROD_CALIB)	[ -f $MIDASHOME/calib ];;
					esac
					if [ $? -eq 0 ]; then
						echo "                                    " > /dev/tty
						echo "*** Directory $MIDASHOME seems to have" > /dev/tty
						echo "*** product $i already installed." > /dev/tty
						echo "                                    " > /dev/tty
						if ask_yn 'Do you want to overwrite this copy' n; then
							MIDAS_PROD_SELECTED=`addto "$MIDAS_PROD_SELECTED" "$i"`
						fi
					else
						MIDAS_PROD_SELECTED=`addto "$MIDAS_PROD_SELECTED" "$i"`
					fi
					break
				fi
				ctr=`expr $ctr + 1`
			done
		done
		restore_ifs
	fi

	isset_product
}

setup_product()
{
	# 
	# setup. Install links for shared libraries.
	# scripts and man pages.
	#
	if check_precond_setup; then
		clear > /dev/tty
		banner1
		if isset_su ; then
			if ask_yn 'OK to complete MIDAS installation'; then
				pick_mandir
				pick_bindir
        			case "$MIDAS_ARCH" in
                			$ARCH_ALPHA|$ARCH_SUNOS|$ARCH_SOLARIS)
				  		pick_libdir
						;;
					$ARCH_LINUX)
						echo $MIDASHOME/$MIDVERS/lib | cat /etc/ld.so.conf - | sort -u > /etc/ld_so_conf
						mv /etc/ld.so.conf /etc/ld.so.conf~
						mv /etc/ld_so_conf /etc/ld.so.conf
		  				/sbin/ldconfig
	  					MIDAS_LIBDIR_DONE="yes"
					  	;;
					$ARCH_HP700|$ARCH_SGI5)
						if [ "$MIDASHOME" != "/midas" ]; then
						  mv /midas /midas.org
						  rm -f midas.org 2>/dev/null
					  	  ln -s $MIDASHOME /midas
						fi
	  					MIDAS_LIBDIR_DONE="yes"
					  	;;
                        	esac
				if [ -n "$MIDAS_LIBDIR_DONE" -a -n "$MIDAS_BINDIR_DONE" ]; then
				  echo " " >/dev/tty
				  echo "ESO-MIDAS installation completed successfully." >/dev/tty
				  echo "Exit and type \"inmidas\" to start ESO-MIDAS" >/dev/tty
				  echo " " >/dev/tty
				  MIDAS_SETUP="OK"
				fi
				ask_return 
			fi
		else
			echo "Sorry. You need to be superuser to run this option" >/dev/tty
			ask_return
		fi	
	
	fi

	isset_setup_installed
}

install_product()
{
	#
	#  Install the chosen products.  
	#

	if check_precond_install; then
		clear > /dev/tty

		show_state
		if ask_yn 'OK to install this configuration'; then
			save_dir=`pwd`
			cd $MIDASHOME
			change_ifs ","

			MIDAS_PROD_INSTALLED=
			echo " " > /dev/tty
			for prod in $MIDAS_PROD_SELECTED; do
				case "$prod" in
					$PROD_BIN)		suffix=bin;;
					$PROD_SRC)		suffix=src;;
					$PROD_GUI)		suffix=gui;;
					$PROD_DEMO)		suffix=demo;;
					$PROD_CALIB)		suffix=calib;;
				esac
				if [ "$suffix" != "src" ]; then
					ifile=`ls $MIDAS_CDDIR|grep -i ${MIDAS_ARCH_PREFIX}.$suffix`
				else
					ifile=$MIDAS_SOURCES
				fi
				if [ -z "$ifile" ]; then
					error "Can't find product file ${MIDAS_ARCH_PREFIX}.$suffix for $prod"
					sleep 1
				else
					necho "Installing $prod ..." > /dev/tty
					COMMAND="zcat < $MIDAS_CDDIR/$ifile | tar xf -"
					if sh -c "$COMMAND" ; then
						MIDAS_PROD_INSTALLED=`addto "$MIDAS_PROD_INSTALLED" "$prod"`
					fi
					echo " " > /dev/tty
				fi
			done
			echo " " > /dev/tty

			restore_ifs
			cd $save_dir

			MIDAS_PROD_SELECTED=`difference "$MIDAS_PROD_SELECTED" "$MIDAS_PROD_INSTALLED"`
		fi
	fi

	isset_prod_installed
}

quit()
{
	ask_yn 'Are you sure you want to quit' y
}

infer_cddir()
{
	ifile=`ls |grep -i install.sh`
	if [ -n "$ifile" ]; then
		MIDAS_CDDIR=`pwd`
	else
		ifile=`ls /cdrom |grep -i install.sh`
		if [ -n "$ifile" ]; then
			MIDAS_CDDIR="/cdrom"
		fi
	fi
}


get_arch()
{
  case $1 in
    $REL_ALPHA)   MIDAS_ARCH=$ARCH_ALPHA   ; MIDAS_ARCH_PREFIX=alphaosf;;
    $REL_HP700)   MIDAS_ARCH=$ARCH_HP700   ; MIDAS_ARCH_PREFIX=hp700;;
    $REL_IBM)     MIDAS_ARCH=$ARCH_IBM     ; MIDAS_ARCH_PREFIX=rs6000;;
    $REL_SGI5)    MIDAS_ARCH=$ARCH_SGI5    ; MIDAS_ARCH_PREFIX=sgirix5;;
    $REL_SUNOS)   MIDAS_ARCH=$ARCH_SUNOS   ; MIDAS_ARCH_PREFIX=sparcsun;;
    $REL_SOLARIS4) MIDAS_ARCH=$ARCH_SOLARIS ; MIDAS_ARCH_PREFIX=sparcsol;;
    $REL_SOLARIS5) MIDAS_ARCH=$ARCH_SOLARIS ; MIDAS_ARCH_PREFIX=sparcsol;;
    $REL_LINUX)   MIDAS_ARCH=$ARCH_LINUX   ; MIDAS_ARCH_PREFIX=pclinux;;
  esac
}

infer_arch()
{
  MIDAS_PROD_SELECTED=""
  MIDAS_PROD_INSTALLED=""

  UNAME=`(uname) | sed 's/\//-/g' 2>/dev/null`
  URELS=`(uname -r) 2>/dev/null`

  get_arch "${UNAME}_$URELS"
  if [ -z "$MIDAS_ARCH" ] ;then
    get_arch "$UNAME"
  fi
}


select_action()
{
	#  The main routine.  It just keeps prompting the user to perform
	#  one of the listed actions.  The loop is broken when the user
	#  affirms the quit.

	MIDAS_STATE=1
	while true; do
		clear > /dev/tty

		set_state
		show_state

		pre1=" "
		pre2=" "
		pre3=" "
		pre4=" "
		pre5=" "
		pre6=" "
		pre7=" "
		preQ=" "

		echo "                                                                " > /dev/tty
		echo "  Choose one of the following actions:                       " > /dev/tty

		case "$MIDAS_STATE" in
			1)	pre1=">";;
			2)	pre2=">";;
			3)	pre3=">";;
			4)	pre4=">";;
			5)	pre5=">";;
			6)	pre6=">";;
			7)	pre7=">";;
			Q)	preQ=">";;
		esac

		echo "                                                                " > /dev/tty
		echo "${pre1}1. Enter the CD mount point.                             " > /dev/tty
		echo "${pre2}2. Select architecture.                                  " > /dev/tty
		echo "${pre3}3. Enter the installation directory (MIDASHOME).         " > /dev/tty
		echo "${pre4}4. Select ESO-MIDAS product(s) to install.               " > /dev/tty
		echo "${pre5}5. Install ESO-MIDAS product(s).                         " > /dev/tty
		echo "${pre6}6. Complete ESO-MIDAS installation in your system.       " > /dev/tty
		echo "${preQ}Q. Quit.                                                 " > /dev/tty
		echo "                                                                " > /dev/tty
		select=`ask_list 'Enter your selection' "1,2,3,4,5,6,q,Q" $MIDAS_STATE`
		case "$select" in
			   1) if pick_cddir;       then MIDAS_STATE=`expr $select + 1`; fi;;
			   2) if pick_arch;        then MIDAS_STATE=`expr $select + 1`; fi;;
			   3) if pick_midashome;   then MIDAS_STATE=`expr $select + 1`; fi;;
			   4) if pick_product;     then MIDAS_STATE=`expr $select + 1`; fi;;
			   5) if install_product;  then MIDAS_STATE=`expr $select + 1`; fi;;
			   6) if setup_product;    then MIDAS_STATE="$STATE_QUIT"; fi;;
			[qQ]) if quit; then break; fi;;
			   *) fatal_error "Improper selection $select in select_action";;
		esac
	done
}

##############################################################################
#
#  Main Processing here
#
##############################################################################

banner
ask_return 

infer_cddir
infer_arch
select_action

post_install

exit 0

#! /bin/sh
# @(#)reset.sh	19.1 (ESO-IPG) 02/25/03 14:09:00
#
# kill all the idiserv.exe's we can find
#
#  K. Banse    920525, 010206
#

cd $MID_WORK
rm -f midas_xw${1}* IDISERV*
rm -f idiserv${1}.log sxw${1}*.dat

KLAUS=`ps -ef | grep idiserv.exe | grep -v grep | awk '{print $2}'`

if [ -n "$KLAUS" ]; then
   kill -9 $KLAUS
fi

#!/bin/sh
# @(#)nmgrep.sh	19.1 (ESO-IPG) 02/25/03 14:32:00
pattern=$1
shift
for i in $*
do
  	# -h option not always recongnized (Sony/News)
	if (test -h $i 2>/dev/null); then
	   ls -l $i
	   continue
        fi
	echo "FILE: $i"
	nm $i | grep -i $pattern
done

#! /bin/sh
# @(#)idigo.sh	19.1 (ESO-IPG) 02/25/03 14:31:43
# 
# K. Banse	ESO - Garching
# 
DAZUNIT=AX
WORK_STATION=DAZAX
I_TYPE="SXW  " 
MID_WORK=$HOME/midwork/
MID_SYSTAB=$MIDASHOME/$MIDVERS/systab/bin
export DAZUNIT WORK_STATION I_TYPE MID_WORK MID_SYSTAB
$MIDASHOME/$MIDVERS/system/exec/idiserv.exe 
exit

#! /bin/sh
# .COPYRIGHT: Copyright (c) 1988-2007 European Southern Observatory,
#
# .TYPE         command
# .NAME         inmidas
# .LANGUAGE     Bourne-shell script
# .ENVIRONMENT  Unix Systems. Executable under any SHELL.
# .USAGE        inmidas [ unit ] [-h midashome] [-r midvers] [-d display] 
#		[-m mid_work] [-p/-np] [-noh ] [-j midas-comman-line]
#		  unit:      MIDAS unit (00, 01, ..., 99, xa, ..., zz)
#			     (default: 00 if NOPARALLE mode)
#		  display:   X server for display and graphical windows.
#		  midashome: Home directory for MIDAS. (default: MIDASHOME0)
#		  midvers:   Version of MIDAS. (default: MIDVERS0)
#		  mid_work:  MIDAS startup directory (default: $HOME/mid_work)
#		  -p/-nop:   Set MIDOPTIONS to PARALLEL/NOPARALLE 
#			     (default: NOPARALLEL)
#		  -noh:	     No welcome header.
#		  -drs:	     reuse keyfile from drs commands
#		  -j:	     Execute next argument as a MIDAS command.
#
# .COMMENTS     Script to start MIDAS. It uses the following environment:
#		MIDASHOME, MIDVERS and MIDOPTION.
#		variables if they exist, otherwise takes defaults.
#		It checks arguments if any and exec to 
#		$MIDASHOME/$MIDVERS/monit/prepa.exe
#
# .REMARKS      MIDASHOME0 & MIDVERS0 are set to defaults values by option
#               "8- MIDAS setup" in the MIDAS "config" script.
#
# .VERSION 1.0	this is the modified inmidas script for Sun Solaris 8
#		where we don't have the shell command "lockfile"
# 
# 070716	last modif
# 
#**************************************************************************

#**************************************************************************
# Configure Here: 
# ---------------
# Modify the default values of MIDASHOME0 and MIDVERS0 
# according to your site. 
#
# Environment variables MIDASHOME and MIDVERS overwrite these defaults.
#
# Done automaticaly by option "8- setup MIDAS" in the "config" script.
#

MIDASHOME0=/home/esomidas
MIDVERS0=test

#
# END of Configure Here
#**************************************************************************

#
DAZUNIT=''
MIDASDRS=''; export MIDASDRS 
#
# Check command "echo"
#
echo=echo
SV_NONL=
if [ "`echo -n`" = "-n" ] ; then
  SV_NONL="\c"
else
  echo="echo -n"
fi
#
# Strip "/dev/", strip "pty/" (HP), "pts/" (IBM), and "tty" (all)
#
if ( tty -s )
then
  tt=`tty | sed -e 's/^.*dev\///' -e 's/pty\///' -e 's/pts\///' -e 's/tty//'`
else
  tt=none
fi

#**************************************************************************

#
# Check for options:
#
while [ -n "$1" ]
do
  case $1 in
  -help) 
echo "Usage: inmidas [unit] [-h midashome] [-r midvers] [-d display] [-p/-P/-nop]"
echo "       [-m mid_work] [-noh] [-j \"midas-command-line\"] [-drs] [-help]"
echo "Options:"
echo "-h midashome"
echo "     Home directory for MIDAS. Sets variable MIDASHOME to midashome"
echo "-r midvers"
echo "     Release of MIDAS. Sets variable MIDVERS to midvers and it must exist as "
echo "     a subdirectory under MIDASHOME."
echo "-d display"
echo "     This option specifies the X server to contact."
echo "-p/-P/-nop"
echo "     -p and -P options set variable MIDOPTION to PARALLEL. -nop option"
echo "     sets MIDOPTION to NOPARALLEL."
echo "     With -nop (NOPARALLEL) all working files from previous MIDAS sessions"
echo "     located in the directory MID_WORK are deleted. Only one MIDAS session can"
echo "     run at a time. With -p and -P (PARALLEL) no working files are removed" 
echo "     from MID_WORK and several sessions can run simultaneously."
echo "     With -P and -nop options and if not unit is given the system will select"
echo "     automatically one free unit for you (in [01, ..., 99])."
echo "     With -p option and no unit, the user will be requested to enter one."
echo "unit"
echo "     Unit to be associated to the MIDAS session. Valid values for this option"
echo "     are in the range (00 to 99) for X environments, or (xa to zz) for ASCII"
echo "     terminals other than X (no graphics). If no unit is provided the "
echo "     system will select one for you except with -p option." 
echo "-m mid_work"
echo "     This option sets the MID_WORK variable that specifies the MIDAS working"
echo "     directory. By default MID_WORK is set to ~/midwork and it will be created"
echo "     if it does not exist."
echo "-noh"
echo "     Starts a MIDAS session without clearing the terminal and without any"
echo "     welcome message. This option is meant for background purposes."
echo "-j \"midas_command_line\""
echo "     Execute \"midas_command_line\" as the first command typed in the MIDAS"
echo "     monitor. This option sets also -noh option."
echo "-drs"
echo "     Starts a MIDAS session which reuses an existing FORGRdrs.KEY in the "
echo "     current directory, by default this keyfile is recreated each time."
echo "-help"
echo "     Display this help page."
       exit 0 ;;
  -h)   MIDASHOME=$2; export MIDASHOME; shift; shift ;;
  -r)   MIDVERS=$2; export MIDVERS; shift; shift ;;
  -d)   DISPLAY=$2; export DISPLAY; shift; shift ;;
  -m)   MID_WORK=$2; export MID_WORK; shift; shift ;;
  -P)   SELECT_UNIT=AUTO; MIDOPTION=PARALLEL; export SELECT_UNIT MIDOPTION; shift ;;
  -p)   MIDOPTION=PARALLEL; export MIDOPTION; shift ;;
  -nop) MIDOPTION=NOPARALLEL; export MIDOPTION; shift ;;
  -noh) MIDASHD=noheader; export MIDASHD; shift ;;
  -drs) MIDASDRS=yes; export MIDASDRS; shift ;;
  -j)   MIDASJOB=$2; export MIDASJOB; shift; shift ;;

  -*)   echo "Usage: inmidas [unit] [-h midashome] [-r midvers] [-d display] [-p/-P/-nop]"
        echo "       [-m mid_work] [-noh] [-j \"midas-command-line\"] [-help]" >&2
       exit 1 ;;
  *)   DAZUNIT=$1; export DAZUNIT; shift ;;
  esac
done


#
# If MIDASHOME or MIDVERS variable not defined then set to default
#
if [ -z "$MIDASHOME" ]; then
   MIDASHOME="$MIDASHOME0"; export MIDASHOME
fi
if [ -z "$MIDVERS" ]; then
   MIDVERS="$MIDVERS0"; export MIDVERS
fi

#
# Check access to Midas directory
#
if [ ! -d $MIDASHOME/$MIDVERS ]; then
  echo "$MIDASHOME/${MIDVERS}: no such directory."
  echo "Call your MIDAS operator. EXIT."
  exit 1
fi

#
# if necessary create MIDAS work directory
#
if [ -z "$MID_WORK" ]; then
  MID_WORK=$HOME/midwork/ ; export MID_WORK
fi

#
# if last char. of MID_WORK != '/'  append a '/'
#
if [ `expr $MID_WORK : '.*\(.\)'` != '/' ]; then
  MID_WORK=$MID_WORK/ ; export MID_WORK
fi

if [ ! -d $MID_WORK ]; then
  mkdir `expr $MID_WORK : '\(.*\).'`         #use MID_WORK except last char.
  if [ $? != 0 ]; then
    echo Could not create directory `expr $MID_WORK : '\(.*\).'`
    exit 1
 fi
fi

#
# get all the variables (logical names)
#
if [ -f $MIDASHOME/$MIDVERS/monit/midlogs.sh ]; then
  . $MIDASHOME/$MIDVERS/monit/midlogs.sh
else
  echo "$MIDASHOME/$MIDVERS/monit/midlogs.sh - no such file."
  echo "Call your MIDAS operator. EXIT."
  exit 1
fi

#
# Set default DAZUNIT to first unit free (~/midwork/RUNNING<unit>)
# 
if [ -z "$DAZUNIT" -a \( -z "$MIDOPTION" -o "$MIDOPTION" = "NOPARALLEL" -o "$SELECT_UNIT" = "AUTO" \) ]
then

#
#  we don't have this command in Solaris 8 
#
###  lockfile -1 -r 10 $MID_WORK/running.lock 
# 
# 
 if [ $? != 0 ] ; then
    DAZUNIT=99

 else
  DAZUNIT=`(ls $MID_WORK/RUNNING?? 2>/dev/null) | awk ' \
  { \
  tmp = index($1,"RUNNING"); \
  unit[substr($1,tmp+7,2)+0] = 1 \
  } \

  END { \
    i = 1; \
    while (i < 100) { \
      if (!unit[i]) { \
        if (i < 10) printf "0%d\n",i; \
        else printf "%d\n",i ; \
        break \
        } \
      else i++ \
      } \

    if (i == 100) { \
      printf "inmidas - Error: Too many MIDAS sessions already running.\n"; \
      exit 1 \
      } \
    exit 0 \
    }' `
  fi


  if [ $? -ne 0 ]; then
    echo $DAZUNIT >&2
    exit 1
  fi
fi

#
# If AUTOPARALLEL, DAZUNIT is now selected, and MIDOPTION is set to PARALLEL
#
if [ "$MIDOPTION" = "AUTOPARALLEL" ]; then
  MIDOPTION = PARALLEL
fi

#
# logical assignements to devices. 
#
if [ -f $MID_WORK/devices.sh ] ; then
  . $MID_WORK/devices.sh
else
  . $MIDASHOME/$MIDVERS/monit/devices.sh
fi

#
# test, if DAZUNIT defined
# 
while :
do
  if [ -z "$DAZUNIT" ]; then
    $echo "Enter Midas unit (00, 01, ..., 99, xa, ..., zz) " $SV_NONL
    read DAZUNIT
    if [ -z "$DAZUNIT" ]; then
      DAZUNIT=''
      continue
    fi
  fi

  case $DAZUNIT in
  #                          here for X Workstations
  [0123456789]?)
    WORK_STATION=DAZ$DAZUNIT
    I_TYPE="SXW  " 
    ;;
  AX)
    WORK_STATION=DAZAX
    I_TYPE="SXW  " 
    ;;
  #                          here for any other
  *) 		
    DAZUNIT=`echo $DAZUNIT | tr "[a-z]" "[A-Z]" `     # convert to upper case
    case $DAZUNIT in
    #                        no graphics capabilities
    [XYZ]?)
      WORK_STATION=DAZ$DAZUNIT
      I_TYPE="NULL "
      ;;
    *) 		
      echo "invalid Midas unit: $DAZUNIT"
      DAZUNIT=''
      continue
      ;;
    esac
    ;; 
  #
  esac
  break
done
#
export DAZUNIT WORK_STATION I_TYPE AGL3DEV 

#
# Check if there is a running session already for DAZUNIT.
#
if [ -f "$MID_WORK/RUNNING$DAZUNIT" ]; then
  echo "Unit $DAZUNIT is locked by another MIDAS session."
  echo "To unlock just continue."
  $echo "Do you want to continue [yn]? (n): " $SV_NONL
  read answ
  if [ -z "$answ" ]; then
    answ=n
  fi
  if [ "$answ" != "y" -a "$answ" != "Y" ]; then
    exit 1
  fi
  rm -f $MID_WORK/RUNNING$DAZUNIT
fi

#
# Check PARALLEL option in MIDOPTION.
#
if [ -z "$MIDOPTION" ]; then 
  MIDOPTION=NOPARALLEL; export MIDOPTION
fi
#

if [ "$MIDOPTION" != "PARALLEL" -a "$MIDOPTION" != "parallel" ] ; then
  # echo Deleting old MIDAS files ... 
  # Ensure at least one file is deleted.
  HERE=`pwd`
  cd $MID_WORK
  if (ls * 2>/dev/null | grep -s RUNNING)
  then
    echo "WARNING: Other MIDAS sessions might be running."
    echo "Exit and use option <-p> for PARALLEL mode."
    echo "If you continue all previous MIDAS sessions will be removed."
    $echo "Do you want to continue [yn]? (n): " $SV_NONL
    read answ
    if [ -z "$answ" ]; then
      answ=n
    fi
    if [ "$answ" != "y" -a "$answ" != "Y" ]; then
      exit 1
    fi
  fi
  rm -f middum* midtemp* midjob*.prg midlis*.prg midtab*.prg \
        IDISERV* idiserv* idisave*.dat .inmidas* CODE*.SAV sxw*.dat \
        getXdepth* midas_xw* MIDAS*.PID RUNNING* xhelp*

  cd $HERE
  # delete all &a,&b, ... files
  rm -f middum* midtemp* >/dev/null 2>&1
fi

#
# Catch any possible interrupt and remove the lock file
#
trap "rm -f $MID_WORK/RUNNING$DAZUNIT; exit 1" 1 2 3 15
touch $MID_WORK/RUNNING$DAZUNIT

# 
# no lockfile for Solaris 8
# 
### rm -f $MID_WORK/running.lock
# 

#
# Prepare $MID_WORK/.inmidas for next gomidas command
#
rm -f $MID_WORK/.inmidas $MID_WORK/.inmidas.$tt >/dev/null 2>&1
echo "# Date: " `date` 				  > $MID_WORK/.inmidas
echo "MIDASHOME=$MIDASHOME; export MIDASHOME"    >> $MID_WORK/.inmidas
echo "MIDVERS=$MIDVERS; export MIDVERS"    	 >> $MID_WORK/.inmidas
echo "MIDOPTION=$MIDOPTION; export MIDOPTION"    >> $MID_WORK/.inmidas
echo "DAZUNIT=$DAZUNIT; export DAZUNIT" 	 >> $MID_WORK/.inmidas
echo "WORK_STATION=$WORK_STATION; export WORK_STATION" >> $MID_WORK/.inmidas
echo "I_TYPE=$I_TYPE; export I_TYPE" 		 >> $MID_WORK/.inmidas
if [ -n "$AGL3DEV" ]; then
  echo "AGL3DEV=$AGL3DEV; export AGL3DEV" 	 >> $MID_WORK/.inmidas
fi
if [ -n "$graph_term" ]; then
  echo "graph_term=$graph_term; export graph_term"  >> $MID_WORK/.inmidas
fi

#
# Copy .inmidas to inmidas.<tt> that will be used by gomidas afterwards.
#
cp $MID_WORK/.inmidas $MID_WORK/.inmidas.$tt

#
# Set PATH for shared libraries
#
os=`uname`
case "$os" in
    "SunOS"|"Linux")
	if [ -z "$LD_LIBRARY_PATH" ] ; then
	  LD_LIBRARY_PATH=$MIDASHOME/$MIDVERS/lib
	else
	  LD_LIBRARY_PATH=$MIDASHOME/$MIDVERS/lib:$LD_LIBRARY_PATH
	fi
	export LD_LIBRARY_PATH
	;;
    "HP-UX")
	if [ -z "$SHLIB_PATH" ] ; then
	  SHLIB_PATH=$MIDASHOME/$MIDVERS/lib
	else
	  SHLIB_PATH=$MIDASHOME/$MIDVERS/lib:$SHLIB_PATH
	fi
	export SHLIB_PATH
	;;
     *)
	;;
esac

#
# run MIDASGO 
#
$MID_MONIT/midasgo.exe	
if  [ $? = 1 ] ; then
  echo "...Midas session aborted..."
  rm -f $MID_WORK/RUNNING$DAZUNIT
  exit 1
fi

#
# Ignore CTRL-C before runnning prepa.exe
#
trap "" 2

# run PREPA
#
$MID_MONIT/prepa.exe
if  [ $? = 1 ] ; then
  echo "...Midas session aborted..."
  rm -f $MID_WORK/RUNNING$DAZUNIT
  exit 1
fi

#
# remove lock file
#
rm -f $MID_WORK/RUNNING$DAZUNIT

exit 0

#! /bin/bash 
# .TYPE           command
# .NAME           preinstall.sh 
# .LANGUAGE       shell script
# .ENVIRONMENT    Unix Systems. Executable under Bourne shell 
# .COMMENTS      
#                 Usage: preinstall 
#
#	The preinstall command will :
#
#	a) Copy files from:
#
#	      $MID_INSTALL/install/unix/systems/<system>
#			to
#	      $MID_HOME/local
#                 
#
# .AUTHOR         Carlos Guirao
# .VERSION 1.1    881023:	Implementation
# .VERSION 1.3    910424:	Removing first argument
# .VERSION 2.1    910725:	Much easier.
# .VERSION 2.2    910917:	Much easier yet.
# .VERSION 3.2    930727:	Using output of uname command.
# .VERSION 3.3    021028:	Using -a argument for all packages
# 
# 120420	last modif

echo=echo
if [ "$1" != "-a" ]; then
  if [ "`echo -n`" = "-n" ] ; then
    SV_NONL="\c"
  else
    echo="echo -n"
  fi
fi

#
# First of all, goto the config directory 
# <dirname> & <basename> commands emulated with <sed>
#
if [ -z "$MIDASHOME" -o -z "$MIDVERS" ] ; then
    cd `echo $0 | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
    MID_INSTALL=`pwd`
    VERSDIR=`echo $MID_INSTALL | sed 's/\/install\/unix$//'`
    MIDVERS=`echo $VERSDIR | sed -e 's/^.*\///'`
    MIDASHOME=`echo $VERSDIR | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
else
    cd $MIDASHOME/$MIDVERS/install/unix
fi

MID_INSTALL=$MIDASHOME/$MIDVERS/install/unix
MID_HOME=$MIDASHOME/$MIDVERS

if [ ! -d $MID_HOME/local ]; then
  mkdir $MID_HOME/local
fi

if [ ! -d $MID_HOME/pipeline ]; then
  mkdir $MID_HOME/pipeline
  chmod 775 $MID_HOME/pipeline
fi

if [ -f $MID_HOME/local/default.mk ]; then
  rm -f $MID_HOME/local/default.mk~
  mv $MID_HOME/local/default.mk  $MID_HOME/local/default.mk~
fi

if [ -f $MID_HOME/local/preinstall ]; then
  mv $MID_HOME/local/preinstall $MID_HOME/local/preinstall~
fi

while :
do
  echo ""
  echo "Your current definitions:"
  echo "------------------------"
  echo "MIDASHOME=$MIDASHOME"
  echo "MIDVERS=$MIDVERS"
  echo ""
  $echo "Do you want to modify these definitions [yn]? (n): " $SV_NONL
  if [ "$1" != "-a" ]; then
    read answ
  fi
  if [ -z "$answ" ]; then
    break
  fi
  if [ "$answ" = "n" -o "$answ" = "N" ]; then
    break
  fi
  while :
  do
    $echo "MIDASHOME: " $SV_NONL
    read MIDASHOME
    if [ ! -d $MIDASHOME ]; then
      echo "No such directory: $MIDASHOME"
      continue
    else 
      break
    fi
  done
  while :
  do
    $echo "MIDVERS: " $SV_NONL
    read MIDVERS
    if [ ! -d $MIDASHOME/$MIDVERS ]; then
    echo "No such directory: $MIDASHOME/$MIDVERS"
      continue
    else
      break
    fi
  done
done

(echo "MIDASHOME=$MIDASHOME"; echo "MIDVERS=$MIDVERS" ) | cat - default_mk \
	> $MIDASHOME/$MIDVERS/local/default.mk
echo "File $MIDASHOME/$MIDVERS/local/default.mk created."

cd systems
uname=`(uname) | sed 's/\//-/g' 2>/dev/null`
unode=`(uname -n) 2>/dev/null`
urels=`(uname -r) 2>/dev/null`
machine=`(uname -m) 2>/dev/null`

if [ -d "Debian" -a -f "/etc/debian_version" ];  then
    system="Debian"

elif [ "$uname" = "Darwin" ]; then
    system="Darwin"

elif [ "$machine" = "x86_64" ]; then
    system="Linux_AMD64"

elif [ -d "${uname}_$urels" ]; then
  system="${uname}_$urels"

elif [ -d "${uname}_$machine" ]; then
  system="${uname}_$machine"

elif [ -d "$uname" ]; then
    system="$uname"

elif [ -d "$unode" ]; then
    system="$unode"

else
   uname -o  2>/dev/null		#not all systems support -o option
   exitstat=$?
   if [ $exitstat = 0 ]; then
      temp=`uname -o`
      if [ -d "$temp" ]; then
         system="$temp"
      fi
   fi
fi

if [ -z "$system" ]; then
  echo ""
  while :
  do
    echo "Select your system (or q to QUIT) :"
    echo ""
    for i in `ls`
    do
	if [ -d $i ]
	then
	     echo "		$i"
	fi
    done	
    $echo "System: " $SV_NONL
    read system
    if [ "$system" = "q" -o "$system" = "Q" ]; then
	exit 0
    fi
    if [ ! -d "$system" ]; then
	echo "No such directory: $system"
    else
	break
    fi
  done
else
   echo system chosen: $system
fi

echo ""
echo "All files from the <systems/$system> directory will be copied"
echo "into your <$MID_HOME/local> directory"
$echo "Do you want to continue [yn]? (y): " $SV_NONL
if [ "$1" != "-a" ]; then
  read answ
fi
if [ -z "$answ" ]; then
    answ=y
fi
if [ "$answ" = "n" -o "$answ" = "N" ]; then
    exit 0
fi

# 
# Choose libsrc/ftoc according to $system.
# 
rm -rf $MIDASHOME/$MIDVERS/libsrc/ftoc
ln -s $MIDASHOME/$MIDVERS/libsrc/ftoc-new $MIDASHOME/$MIDVERS/libsrc/ftoc

# 
# Using the script copy instead of cpio, which not always exists.

cd $system

# Option prune does not exist in Ultrix. Anaway SCCS is never included in tape
#find . ! \( -name "SCCS" -prune \) -print -exec ../../copy {} \;
#find . -print -exec ../../copy {} \;
# CG. For some obscure reasons "-print" has to be at the end on IBM6000

find .  -exec ../../copy {} \; -print

if [ -f "$MID_HOME/local/README" ] ; then
    cat $MID_HOME/local/README
    $echo "Type <RETURN> to continue...." $SV_NONL
    if [ "$1" != "-a" ]; then
      read key
    fi
fi

#
# CG 15.02.2017 Edit make_options with g77 only if g77 exists
#
which g77 >/dev/null 2>&1
if [ $? -eq 0 ] ; then
  if [ ! -f $MID_HOME/local/make_options ]; then
    touch $MID_HOME/local/make_options
  else
    G77_F2C_PATH=`g77 -print-libgcc-file-name`
    G77_F2C_PATH=`dirname $G77_F2C_PATH`
    echo "F2C_LIBS=-L${G77_F2C_PATH} -lg2c" >> $MID_HOME/local/make_options
  fi
fi

#
# CG 02.05.2011 Edit make_options with gfortran only if gfortran exists
#
which gfortran >/dev/null 2>&1
if [ $? -eq 0 ] ; then
  if [ ! -f $MID_HOME/local/make_options ]; then
    touch $MID_HOME/local/make_options
  else
    gccversion=`$MID_INSTALL/getvers`
    if [ "$gccversion" = "gfortran" ] ; then
       sed -e 's/g77/gfortran/' $MID_HOME/local/make_options  > $MID_INSTALL/maky
       mv $MID_INSTALL/maky $MID_HOME/local/make_options
    fi
  fi
fi

echo ""
echo "Your MAKE_OPTIONS after pre-install:"
echo " <$MID_HOME/local/make_options>"
awk -F# '{if ($1 != "") {printf "\t  %s\n",$1} }' $MID_HOME/local/make_options

echo ""
echo "Preinstallation of MIDAS completed."
$echo "Type <RETURN> to continue...." $SV_NONL
if [ "$1" != "-a" ]; then
  read key
fi
#
# Check if there is a preinstall in the local directory
#
if [ -f "$MID_HOME/local/preinstall" ] ; then
    /bin/bash $MID_HOME/local/preinstall
fi

exit

#! /bin/sh
# .COPYRIGHT: Copyright (c) 1988-2005 European Southern Observatory,
#                                         all rights reserved
# .TYPE           command
# .NAME           select.sh
# .LANGUAGE       shell script
# .ENVIRONMENT    Unix Systems. Executable under SHELL and C-SHELL
# .COMMENTS       
#                 Usage: 
#
# .AUTHOR         Carlos Guirao
# .VERSION 4.1	  910724	New implementation.
# 051129	last modif
# 

cmd=`basename $0`
echo=echo
if [ "`echo -n`" = "-n" ] ; then
    SV_NONL="\c"
else
    echo="echo -n"
fi

#
# First of all, goto the config directory adn
# <dirname> & <basename> commands emulated with <sed>
#   cd `dirname $0`
#   MIDVERS=`basename $VERSDIR`
#   MIDASHOME=`dirname $VERSDIR`
#
if [ -z "$MIDASHOME" -o -z "$MIDVERS" ] ; then
    cd `echo $0 | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
    MID_INSTALL=`pwd`
    VERSDIR=`echo $MID_INSTALL | sed 's/\/install\/unix$//'`
    MIDVERS=`echo $VERSDIR | sed -e 's/^.*\///'`
    MIDASHOME=`echo $VERSDIR | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
else
    cd $MIDASHOME/$MIDVERS/install/unix
fi

MID_INSTALL=$MIDASHOME/$MIDVERS/install/unix
MID_HOME=$MIDASHOME/$MIDVERS

#
# Check for first argument. If none select `all' packages.
#
if [ -n "$1" ] ; then
   option=$1
else
   option=all
fi

echo ""
echo ""
echo "	LIST OF AVAILABLE PACKAGES IN MIDAS:"
echo ""

case $option in 
all|core)
   echo "	Category 	Name    	 Status"    
   echo "	========================================"
   ;;
own)
   echo " 	Type [S]elect, [N]o_select, C[hange status], Q[uit] or CR"
   echo "	Category        Name   		 Status		[SNCQ]?" 
   echo "	======================================================="
   ;;
*)
   echo "$option bad argument"
   echo "Usage: $cmd [all|core|own]   (default=all)"
   exit 1
   ;;
esac

trap "stty echo; exit" 2

stty -echo

for categ in applic stdred contrib gui
do
    if [ ! -d $MID_HOME/$categ ]; then
	continue
    fi

    cd $MID_HOME/$categ
    for pack in `ls | egrep -v 'lib|exec|proc|help|resource|Xstuff'`
    do
        if [ "$pack" = "mva" ]; then		#omit the mva package
	    rm -f $pack/SELECTED 2>/dev/null
	    continue
        fi

	if [ -f $pack/src/makefile -o \
	     -f $pack/libsrc/makefile -o \
	     -f $pack/etc/makefile -o \
	     -f $pack/proc/makefile ] ; then
	    $echo  "	$categ     	$pack       	"  $SV_NONL
	    case $option in 
	    all)
		echo "(selected)"
		rm -f $pack/SELECTED 2>/dev/null
                if [ -f $pack/DEPENDENCIES ]; then
                   for depend in `cat $pack/DEPENDENCIES`
                   do
                      rm -f $depend/SELECTED_BY_$pack 2>/dev/null
                      touch $depend/SELECTED_BY_$pack
                   done
                fi
		touch $pack/SELECTED
		continue
		;;
	    core)
		echo "(not selected)"
		rm -f $pack/SELECTED* 2>/dev/null
		continue
		;;
	    esac
	    while :
	    do
	    if [ -f $pack/SELECTED ]; then
		$echo "(selected)	" $SV_NONL
	    else
		$echo "(not selected)	" $SV_NONL
	    fi
	    read answ
	    case $answ in
	    s|S)
		echo "SELECTED"
		rm -f $pack/SELECTED 2>/dev/null
		touch $pack/SELECTED
		break
		;;
	    n|N)
		echo "NOT SELECTED"
		rm -f $pack/SELECTED 2>/dev/null
                if [ -f $pack/DEPENDENCIES ]; then
                   for depend in `cat $pack/DEPENDENCIES`
                   do
                      rm -f $depend/SELECTED_BY_$pack 2>/dev/null
                   done
                fi
		break
		;;
	    c|C)
	        if [ -f $pack/SELECTED ]; then
		    echo "NOT SELECTED"
		    rm -f $pack/SELECTED 2>/dev/null
		else
		    echo "SELECTED"
		    rm -f $pack/SELECTED 2>/dev/null
		    touch $pack/SELECTED
		fi
		break
		;;
	    q|Q)
		echo QUIT
		stty echo
		exit 0
		;;
	    '')
	        if [ -f $pack/SELECTED ]; then
		    echo "SELECTED"
                else
		    echo "NOT SELECTED"
		fi
		break
		;;
	    *)
		echo "[SNCQ]?"
	        $echo  "	$categ     	$pack       	"  $SV_NONL
		;;
	    esac
	    done
		
            if [ -f $pack/DEPENDENCIES ]; then 
		for depend in `cat $pack/DEPENDENCIES`
                do
		  rm -f $depend/SELECTED_BY_$pack 2>/dev/null
                  if [ -f $pack/SELECTED ]; then 
		    touch $depend/SELECTED_BY_$pack
                  fi
                done
            fi
	fi
    done
done
cd $MID_INSTALL
stty echo
exit 0

#!/bin/bash
# 
# example script for using a Midas application
# with a keyword file "PROGR.KEY"
# as given in SCSPRO(PROGR) within application
# 
# K. Banse	DMD/DFS, ESO - Garching
# 031218	creation
# 041112	last modif
# 
  
# rm ./PROGR.KEY

# fill keyword file (according to Midas procedure intape.prg)

echo "in_a/c/1/80 $1" > PROGR.KEY
echo action/c/1/2 rb >> PROGR.KEY

if [ $# -lt 2 ]; then
   echo p2/c/1/80 \*\   >> PROGR.KEY
else
   echo "p2/c/1/80 $2"  >> PROGR.KEY
fi

# switch to outside mode + execute
export MIDAS_OUTSIDE=1
$MID_EXE/descr.exe

# cat PROGR.KEY

#!/bin/bash
MIDASHOME=/midas
MIDVERS=$1
LM_LICENSE_FILE=/usr/server/license/license_idl:1726@opus1:1726@opus2:1726@opus3
PATH=$MIDASHOME/bin:/opt/SUNWspro/bin:/usr/bin:/usr/ccs/bin:$MIDASHOME/$MIDVERS/install:$MIDASHOME/$MIDVERS/install/unix:$MIDASHOME/$MIDVERS/install/vms
LD_LIBRARY_PATH=/usr/dt/lib:/usr/openwin/lib:/opt/SUNWspro/lib:/usr/ccs/lib
export MIDASHOME MIDVERS PATH LD_LIBRARY_PATH
export LM_LICENSE_FILE
cd $MIDASHOME/$MIDVERS/install/unix
umask 002
/bin/bash updatebgr -i

#! /bin/bash
# .TYPE           command
# .NAME           updatebgr.sh
# .LANGUAGE       shell script
# .ENVIRONMENT    Unix Systems. Executable under SHELL and C-SHELL
# .COMMENTS       Installation procedure of the MIDAS system starting from
#                 the scratch.
#                 
# .REMARKS        The external variable $MIDASHOME and $MIDASVERS must be 
#		  set before run 
#                 this script. They can be defined in the ".profile" or 
#                 ".cshrc" and executed when you login in the MIDAS account.
#
# .AUTHOR         Carlos Guirao
# .VERSION 1.1    24-Jun-1988:		Implementation
# .VERSION 1.2    910219:		Removing System name
# .VERSION 2.1    910724:		Output to $MIDASHOME/$MIDVERS/local
# 111206	last modif

if [ $# -gt 1 ]
then
	echo "Use: update.bgr [MAKE_OPTIONS]"	
	exit
fi

#
# If $MID_HOME/tmp does not exists then creates it.
#
if [ ! -d $MID_HOME/tmp ]; then
    mkdir $MID_HOME/tmp
fi

time /bin/bash ./update $1 > $MIDASHOME/$MIDVERS/tmp/update.$$ 2>&1 &
echo "Running update in background"
echo "Results are coming in $MIDASHOME/$MIDVERS/tmp/update.$$"

#! /bin/bash
#.COPYRIGHT: Copyright (c) 2005-2006 European Southern Observatory,
#                           
#.TYPE           command
#.NAME           getvers.sh
#.LANGUAGE       shell script
#.ENVIRONMENT    Unix Systems. Executable under bash shell !
# 
# 
#.COMMENTS       check the version of the GNU C compiler
#.AUTHOR         K. Banse	ESO - Garching
# 
#.VERSION
# 051026	creation
# 070615	last modif
# 


gcc -v > gcc.version 2>&1			# save output in file ./gcc.version

# read the file ./gcc.version line by line, process only the last one

while read line  
do
   begi=${line:0:12}
   if [ "$begi" = "gcc version " ] ; then
      longversion=${line#"gcc version "}
      version=${longversion:0:1}
      if [ "$version" = "4" ] ; then
         echo gfortran
      else
         echo g77
      fi
   fi
done < gcc.version

rm gcc.version

exit 0

#! /bin/sh 
#
# Assign the necessary logical names for Midas
# needed for the Unix command `drs'
# Klaus Banse ESO - DMD                000503
# 
# 071108	last modif
# 
#**************************************************************************
# Configure Here:
# ---------------
# Modify the default values of MIDASHOME0 and MIDVERS0
# accordingly to your site.
#
MIDASHOME0=/midas
MIDVERS0=07SEP
#
# Environment variables MIDASHOME and MIDVERS overwrite the defaults above
#
#**************************************************************************

## set -x 

#
# If MIDASHOME variable not defined then set to default.
#
if [ -z "$MIDASHOME" ]; then
   MIDASHOME="$MIDASHOME0"; export MIDASHOME
fi

#
# If MIDVERS variable not defined then set to default.
#
if [ -z "$MIDVERS" ]; then
   MIDVERS="$MIDVERS0"; export MIDVERS
fi

#
# Check access to directories and files
#
if [ ! -d $MIDASHOME/$MIDVERS ]; then
  echo "$MIDASHOME/${MIDVERS}: not such directory."
  echo "Call your MIDAS operator. EXIT."
  exit 1
fi

#
# if necessary create MIDAS work directory
#
if [ -z "$MID_WORK" ]; then
   MID_WORK=$HOME/midwork/ ; export MID_WORK
fi

#
# get all the variables (logical names)
#
if [ -f $MIDASHOME/$MIDVERS/monit/midlogs.sh ]; then
  . $MIDASHOME/$MIDVERS/monit/midlogs.sh
else
  echo "$MIDASHOME/$MIDVERS/monit/midlogs.sh not such file."
  echo "Call your MIDAS operator. EXIT."
  exit 1
fi

#
# Catch any possible interrupt and remove the lock file
#
trap "exit 1" 1 3 15

#
# Set PATH for shared libraries
#
os=`uname`
case "$os" in
    "SunOS"|"Linux")
        if [ -z "$LD_LIBRARY_PATH" ] ; then
          LD_LIBRARY_PATH=$MIDASHOME/$MIDVERS/lib
        else
          LD_LIBRARY_PATH=$MIDASHOME/$MIDVERS/lib:$LD_LIBRARY_PATH
        fi
        export LD_LIBRARY_PATH
        ;;
    "HP-UX")
        if [ -z "$SHLIB_PATH" ] ; then
          SHLIB_PATH=$MIDASHOME/$MIDVERS/lib
        else
          SHLIB_PATH=$MIDASHOME/$MIDVERS/lib:$SHLIB_PATH
        fi
        export SHLIB_PATH
        ;;
     *)
        ;;
esac

# run QREQA
#
DAZUNIT=01; export DAZUNIT			# must be 01 ...
MIDAS_OUTSIDE=YES; export MIDAS_OUTSIDE
$MID_MONIT/qreqa.exe $*

exit 0

#!/bin/sh
#
# @(#)setmidas.sh	19.1 (ESO-IPG) 02/25/03 14:32:00
# .COPYRIGHT: Copyright (c) 1988 European Southern Observatory,
#
# .TYPE		command
# .NAME		setmidas.csh
# .LANGUAGE	Bourne-shell script
# .ENVIRONMENT	Unix Systems. Executable ONLY under "sh" or "bash" with the
#               command "."
# .USAGE	. <path_name>/setmidas.sh
# 		It can be simplified with an environment definition:
#		setmidas=". <path_name>/setmidas.sh"
#		and executed as $setmidas.
# .COMMENTS	Interface to the MIDAS environment. It sets the variables
#		MIDASHOME, MIDVERS, MIDOPTION & MIDWORK for the next script 
#		"inmidas".
#
# .REMARKS 	This file helps users to chose between several releases of 
#		MIDAS. It is not necessary if you have only one release of
#		MIDAS installed.
#
# .REMARKS 	MIDASHOME0 & MIDVERS0 are set to defaults values by option 
#		"8- MIDAS setup" in the MIDAS "config" script.
#
# .VERSION 1.1	910221:	CG. Implementation
# .VERSION 2.1	930706:	CG. Adding options
#-------------------------------------------------------------------------

#**************************************************************************
# Configure Here: 
# ---------------
# Modify the values of MIDVERS? and MIDASHOME? accordingly to your site. 
# MIDVERS0 and MIDASHOME0 represents the default release of MIDAS.
#
# Other releases of MIDAS can be invoked from here by setting MIDVERS[123]
#
# MIDVERS0: Release of MIDAS by default. Cumpulsory.
#
MIDVERS0=test
MIDASHOME0=/auto/home/ns2b/midas
#
# Other MIDAS releases here. Set them in comments if you do not use them
#
#MIDVERS1=
#MIDASHOME1=/midas
#
#MIDVERS2=
#MIDASHOME2=/midas
#
#MIDVERS3=
#MIDASHOME3=/midas
#
# END of Configure Here
#**************************************************************************
export MIDASHOME MIDVERS MIDOPTION MID_WORK

#
# Check echo command
#
necho=echo
if [ "`echo -n `" = "-n" ]; then
  SV_NONL="\c"
else
  necho="echo -n"
fi

#
# Check MIDVERS0 variable is defined.
#
if [ -z "$MIDVERS0" ]; then
	echo "MIDVERS0: Undefined variable."
	echo "File <setmidas.sh> must contain this definition."
	echo "Call your MIDAS operator. EXIT."
	shift >/dev/null 2>&1   # Equivalent to exit
fi

#
# Check MIDASHOME0 variable is defined.
#
if [ -z "$MIDASHOME0" ]; then
	echo "MIDASHOME0: Undefined variable."
	echo "File <setmidas.sh> must contain this definition."
	echo "Call your MIDAS operator. EXIT."
	shift >/dev/null 2>&1   # Equivalent to exit
fi

#
# Here comes output-text
#
VERS_AVAIL="Versions of MIDAS available: $MIDVERS0 $MIDVERS1 $MIDVERS2 $MIDVERS3"
ENTER_VERS="Enter MIDAS version (default="
OPT_AVAIL="MIDAS option: PARALLEL, NOPARALLEL"
ENTER_OPT="Enter MIDAS option (default="
DEF_WORK="Default MIDAS startup directory= "
ENTER_WORK="Enter MIDAS startup directory: "

#
# If MIDVERS variable not defined then set to default.
#
if [ -z "$MIDVERS" ]; then
   MIDVERS=$MIDVERS0
fi

#
# Check MIDAS versions:
# If none of them then set to default.
#
case  "$MIDVERS" in
"$MIDVERS0")
   MIDVERS=$MIDVERS0
   MIDASHOME=$MIDASHOME0
   ;; 
"$MIDVERS1")
   MIDVERS=$MIDVERS1
   MIDASHOME=$MIDASHOME1
   ;; 
"$MIDVERS2")
   MIDVERS=$MIDVERS2
   MIDASHOME=$MIDASHOME2
   ;; 
"$MIDVERS3")
   MIDVERS=$MIDVERS3
   MIDASHOME=$MIDASHOME3
   ;;
*)
   MIDVERS=$MIDVERS0
   MIDASHOME=$MIDASHOME0
   ;;
esac

#
# Check for another MIDVERS
#
while :
do
  echo ""
  echo $VERS_AVAIL
  $necho ${ENTER_VERS}${MIDVERS}"): " $SV_NONL
  read NEWMIDVERS

  case "$NEWMIDVERS" in
  '') 	
     ;;
  "$MIDVERS0")
     MIDVERS=$MIDVERS0
     MIDASHOME=$MIDASHOME0
     ;;
  "$MIDVERS1")
     MIDVERS=$MIDVERS1
     MIDASHOME=$MIDASHOME1
     ;;
  "$MIDVERS2")
     MIDVERS=$MIDVERS2
     MIDASHOME=$MIDASHOME2
     ;;
  "$MIDVERS3")
     MIDVERS=$MIDVERS3
     MIDASHOME=$MIDASHOME3
     ;;
  *)
     continue
     ;;
  esac
  break
done

#
# MIDOPTION set to default
#
if [ "$MIDOPTION" != "PARALLEL" ]; then
   MIDOPTION=NOPARALLEL
fi

while :
do
  echo ""
  echo $OPT_AVAIL
  $necho ${ENTER_OPT}${MIDOPTION}"): " $SV_NONL
  read NEWMIDOPT

  case "$NEWMIDOPT" in
  P*|p*)
    MIDOPTION=PARALLEL
    ;;
  N*|n*)
    MIDOPTION=NOPARALLEL
    ;;
  '')
    ;;
  *)
    continue
    ;;
  esac
  break
done

#
# MID_WORK set to default
#
if [ -z "$MID_WORK" ]; then
  MID_WORK=$HOME/midwork
fi

echo ""
echo ${DEF_WORK}${MID_WORK}
$necho ${ENTER_WORK} $SV_NONL
read NEWMIDOPT
case "$NEWMIDOPT" in
'')
  ;;
*)
  MID_WORK=$NEWMIDOPT
  ;;
esac

#! /bin/sh
# @(#)hlqtohlc.sh	19.1 (ESO-IPG) 02/25/03 14:31:08
# 
#  Bourne shell script "hlqtohlc.sh"
#  to build the .hlc files from the .hlq files
#  910529  KB
#  910712  CG. removing temporary files.
# 
if [ -f alll.hlc ]; then
	mv alll.hlc alll.hlk
fi
rm -f *.hlc
# 
for i in `ls *.hlq | \
	sed  -e 's/_.*//'  -e 's/\.hlq//' | \
	awk '{print substr($1,1,6)}' | \
	sort -u`
do
   for file in `ls $i*.hlq`
   do
      sed -n '/SECTION./,/\\us/p' $file | sed '/^\\/d' | sed '2d' >> $i.hlc
   done
done
if [ -f alll.hlk ]; then
	mv alll.hlk alll.hlc
fi

#! /bin/sh
# @(#)list.sh	19.1 (ESO-IPG) 02/25/03 13:51:11
# .COPYRIGHT: Copyright (c) 1988 European Southern Observatory,
#                                         all rights reserved
# .TYPE           command
# .NAME           list.sh
# .LANGUAGE       shell script
# .ENVIRONMENT    Unix Systems. Executable under SHELL and C-SHELL
# .COMMENTS       
#                 Usage: 
#
# .AUTHOR         Carlos Guirao
# .VERSION 2.2    14-Oct-1988:		Cosmetic changes
# .VERSION 2.3    05-Dec-1989:		Adding "echo" definition

echo=echo
if [ "`echo -n`" = "-n" ] ; then
    SV_NONL="\c"
else
    echo="echo -n"
fi

#
# First of all, goto the config directory MID_INSTALL
# <dirname> & <basename> commands emulated with <sed>
#   cd `dirname $0`
#   MIDVERS=`basename $VERSDIR`
#   MIDASHOME=`dirname $VERSDIR`
#
if [ -z "$MIDASHOME" -o -z "$MIDVERS" ] ; then
    cd `echo $0 | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
    MID_INSTALL=`pwd`
    VERSDIR=`echo $MID_INSTALL | sed 's/\/install\/unix$//'`
    MIDVERS=`echo $VERSDIR | sed -e 's/^.*\///'`
    MIDASHOME=`echo $VERSDIR | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
else
    cd $MIDASHOME/$MIDVERS/install/unix
fi

MID_INSTALL=$MIDASHOME/$MIDVERS/install/unix
MID_HOME=$MIDASHOME/$MIDVERS

clear
while : ; do
(echo ""
echo "	LIST OF AVAILABLE PACKAGES FOR MIDAS:"
echo ""
echo "	Name		Category   Status"
echo "	========================================"
for categ in applic stdred contrib gui
do
    if [ ! -d $MID_HOME/$categ ]; then
	continue
    fi
    cd $MID_HOME/$categ
    for pack in `ls | egrep -v 'lib|exec|proc'`
    do
        if [ -f $pack/src/makefile -o \
	     -f $pack/libsrc/makefile -o \
	     -f $pack/etc/makefile -o \
	     -f $pack/proc/makefile ] ; then
            $echo  "	$pack      	$categ	"  $SV_NONL
	    if ( ls $pack/SELECTED* | egrep SELECTED ) >/dev/null 2>&1
	    then
		$echo "(selected)	" $SV_NONL
	    else
		$echo "(not selected)	" $SV_NONL
	    fi
            if [ ! -f $pack/DESCRIPTION ] ; then
		echo "(DESCRIPTION not available)"
	    else
		echo ""
	    fi
	fi
   done
done
echo "" ) | more
cd $MID_INSTALL
echo "Type <Q> to quit or <L> to list again."

while : ; do
    $echo "Select NAME: " $SV_NONL
    read name
    if [ "$name" = "q" -o "$name" = "Q" ] ; then
	clear
	exit
    fi
    if [ "$name" = "l" -o "$name" = "L" ] ; then
	break
    fi
    if [ "$name" = "" ] ; then
	continue
    fi
    if [ -d $MID_HOME/applic/$name ] ; then
	categ=applic
    elif [ -d $MID_HOME/stdred/$name ] ; then
	categ=stdred
    elif [ -d $MID_HOME/contrib/$name ] ; then
	categ=contrib
    elif [ -d $MID_HOME/gui/$name ] ; then
	categ=gui
    else
	echo "$name: No such package with that name"
	continue
    fi

    if [ -f $MID_HOME/$categ/$name/DESCRIPTION ] ; then
	cat $MID_HOME/$categ/$name/DESCRIPTION | more
	echo ""
	continue
    else
	echo "DESCRIPTION file for package <$name> not available."
    fi
done
done
clear
exit

#! /bin/sh
# .COPYRIGHT: Copyright (c) 1988-2006 European Southern Observatory,
#                                         all rights reserved
# .TYPE           command
# .NAME           ftoc_params.sh
# .LANGUAGE       shell script
# .ENVIRONMENT    Unix Systems. Executable under SHELL and C-SHELL
# .COMMENTS  	  Test for Fortran to C interface     
# .REMARKS
# .AUTHOR         Carlos Guirao
# .VERSION 1.1    02-Jan-1991:	Implementation
# .VERSION 1.2    04-Oct-1991:	eval has been deleted because apollo complains.
#				but could also be used within quotes.
# 060320	last modif


echo  ftoc_pc3.h          #return the result include file

 

#! /bin/bash
# .TYPE           command
# .NAME           installbgr.sh
# .LANGUAGE       shell script
# .ENVIRONMENT    Unix Systems. Executable under SHELL and C-SHELL
# .COMMENTS       Installation procedure of the MIDAS system starting from
#                 the scratch.
#                 
# .AUTHOR         Carlos Guirao
# .VERSION 1.1    880624:		Implementation
# .VERSION 1.2    910219:		Removing NAME option
# .VERSION 2.1    910724:		Output to $MIDASHOME/$MIDVERS/tmp
# 111206	last modif
# 
if [ $# -gt 1 ]
then
	echo "Use: install.bgr [MAKE_OPTIONS]"	
	exit
fi

#
# If $MID_HOME/tmp does not exists then creates it.
#
if [ ! -d $MID_HOME/tmp ]; then
    mkdir $MID_HOME/tmp
fi

time /bin/bash ./install $1 > $MIDASHOME/$MIDVERS/tmp/install.$$ 2>&1 &
echo "Running install in background"
echo "Results are coming in $MIDASHOME/$MIDVERS/tmp/install.$$"

exit 0

#! /bin/sh
#% @(#)update.sh	19.1 (ESO-IPG) 02/25/03 13:51:12
# .COPYRIGHT: Copyright (c) 1988 European Southern Observatory,
#                                         all rights reserved
# .TYPE           command
# .NAME           update.sh
# .LANGUAGE       shell script
# .ENVIRONMENT    Unix Systems. Executable under SHELL and C-SHELL
# .COMMENTS       Updating procedure of the MIDAS system. 
#                 The MIDAS system is installed with the "install"
#                 command and is executed just once. Henceforth, the
#                 system will be updated for any modification with the
#                 "update" command.
#                 
#                 Usage: update [options]
#                 
#                    options: are options for the "make" command. This option
#                             will be exported to all the directories of the
#                             update procedure.
#			      Multiple definitions for keywords must be:
#				e.g.	CFLAGS=\"-O -g -I/usr/include\"
#			      to avoid quotes to be interpreted by the shell.
#
#                 The command executes the following steps:
#
#                    - $MIDASHOME/$MIDVERS/local/make_options is read if exists.#		       It contains local options for "make" commands.a
#                        
#                        
#		     - MIDAS is structured in "core" (all directories 
#			in file "core.cnf" are included in the installation).
#			and "packages" (optional, they are clasified in 
#			"applic", "stdred" and "contrib".) A package is 
#			selected for installation if it is marked with file
#			"SELECTED".
#
#                    - Running "make options" in all the directories updating
#                      only those files involved in the update.
#
# .AUTHOR         Carlos Guirao
# .VERSION 3.1    910725:		New implementation.

umask 002
#
# First of all, goto the config directory adn
# <dirname> & <basename> commands emulated with <sed>
#   cd `dirname $0`
#   MIDVERS=`basename $VERSDIR`
#   MIDASHOME=`dirname $VERSDIR`
#
if [ -z "$MIDASHOME" -o -z "$MIDVERS" ] ; then
    cd `echo $0 | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
    MID_INSTALL=`pwd`
    VERSDIR=`echo $MID_INSTALL | sed 's/\/install\/unix$//'`
    MIDVERS=`echo $VERSDIR | sed -e 's/^.*\///'`
    MIDASHOME=`echo $VERSDIR | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
else
    cd $MIDASHOME/$MIDVERS/install/unix
fi

MID_INSTALL=$MIDASHOME/$MIDVERS/install/unix
MID_HOME=$MIDASHOME/$MIDVERS

#
# Local options for makes commands will be read if they exits in the
# make_options file, from the local directory.
# Other options can be set in the command line of this script as the
# second parameter: $2. These option will replace those local option with 
# the same name
#
if [ -r $MID_HOME/local/make_options ]
then
    echo ""
    echo "*************************************************"
    echo "********* READING YOUR LOCAL OPTIONS ************"
    echo "*************************************************"
    echo ""
    cat $MID_HOME/local/make_options | awk -F# '{print $1}'
    echo ""
fi

echo "*********************************************************************"
echo "******************** MIDAS UPDATING PROCEDURE ***********************"
echo "*********************************************************************"
echo "******************** MIDASHOME: $MIDASHOME  VERSION: $MIDVERS"
echo "******************** DATE:  `date`"
echo "******************** COMMAND: $0 $*"

for dir in `awk -F# '{ print $1 }' $MID_INSTALL/core.cnf`
do
    echo ""
    echo "**********************************************"
    echo "****** UPDATING IN $dir"
    echo "**********************************************"
    echo "****** DATE:  `date`"
    if [ ! -d $MID_HOME/$dir ]; then
        echo "Warning. $dir .No such directory."
        continue
    fi
    cd $MID_HOME/$dir
    eval make "$@" all
done

for categ in applic stdred contrib gui
do
    if [ ! -d $MID_HOME/$categ ]; then
        continue
    fi
    cd $MID_HOME/$categ
    first_packages=`(ls */SELECTED_BY* | awk -F/ '{print $1}' | sort -u) 2>/dev/null`
    if [ -n "$first_packages" ]; then
      excluded=`echo $first_packages | sed -e 's/^/\^/' -e 's/$/\$/' -e 's/ /\$|\^/g'`
      packages=`(ls */SELECTED | awk -F/ '{print $1}' | egrep -v "$excluded") 2>/dev/null`
    else
      packages=`(ls */SELECTED | awk -F/ '{print $1}') 2>/dev/null`
    fi
    for pack in $first_packages $packages
    do
        for dir in etc libsrc src proc help
        do
          if [ -f $pack/$dir/makefile ]; then
            echo ""
            echo "**********************************************"
            echo "****** UPDATING IN ./$categ/$pack/$dir"
            echo "**********************************************"
            cd $pack/$dir
            eval make "$@" all
            cd $MID_HOME/$categ
          fi
        done
    done
done
cd $MID_HOME

echo ""
echo "*********************************************************************"
echo "************************ END UPDATING PROCEDURE *********************"
echo "*********************************************************************"
echo "********** END DATE:  `date`"

#! /bin/bash
# .COPYRIGHT: Copyright (c) 1988-2011 European Southern Observatory,
#                                         all rights reserved
# .TYPE           command
# .NAME           update1.sh
# .LANGUAGE       shell script
# .ENVIRONMENT    Unix Systems. Executable under SHELL and C-SHELL
# .COMMENTS       Installation procedure of the MIDAS system starting from
#                 scratch.
#                 Usage: install1 system [options]
#
# .AUTHOR         Carlos Guirao
# .VERSION 3.1    910724:		New implementation.
# 111206	last modif

echo=echo
if [ "`echo -n`" = "-n" ] ; then
        SV_NONL="\c"
else
        echo="echo -n"
fi

#
# First of all, goto the config directory adn
# <dirname> & <basename> commands emulated with <sed>
#   cd `dirname $0`
#   MIDVERS=`basename $VERSDIR`
#   MIDASHOME=`dirname $VERSDIR`
#
if [ -z "$MIDASHOME" -o -z "$MIDVERS" ] ; then
    cd `echo $0 | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
    MID_INSTALL=`pwd`
    VERSDIR=`echo $MID_INSTALL | sed 's/\/install\/unix$//'`
    MIDVERS=`echo $VERSDIR | sed -e 's/^.*\///'`
    MIDASHOME=`echo $VERSDIR | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
else
    cd $MIDASHOME/$MIDVERS/install/unix
fi

MID_INSTALL=$MIDASHOME/$MIDVERS/install/unix
MID_HOME=$MIDASHOME/$MIDVERS

cd $MID_INSTALL

clear
if [ ! -f "$MID_HOME/local/default.mk" ] ; then
  echo "*** ERROR: File <$MID_HOME/local/default.mk> does not exist."
  echo "*** You need to run <preinstall> before continuing with <update>"
  exit 1
fi

if [ ! -f "$MID_HOME/local/make_options" ] ; then
  touch $MID_HOME/local/make_options
fi

echo ""
echo "MIDAS UPDATE PROCEDURE"
echo "======================"
echo "MIDASHOME: $MIDASHOME"
echo "MIDVERS:   $MIDVERS"
echo "MAKE_OPTIONS:"
awk -F# '{ if ($1 != "") {printf "\t  %s\n",$1} }' $MID_HOME/local/make_options
echo ""
echo "NOTE: Update will only compile and link those files and"
echo "      executables not updated in previous installation" 
echo "      It will run in background and the output will be sent to"
echo "      the file <$MID_HOME/tmp/update.$$>"
echo ""
$echo "Do you want to continue [yn]? (y): " $SV_NONL
read answ
if [ -z "$answ" ]; then
    answ=y
fi
if [ "$answ" != "y" -a "$answ" != "Y" ]
then
    echo "Bye"
    exit 0
fi

#
# If $MID_HOME/tmp does not exists then creates it.
#
if [ ! -d $MID_HOME/tmp ]; then
    mkdir $MID_HOME/tmp
fi

time /bin/bash $MID_INSTALL/update -i > $MID_HOME/tmp/update.$$ 2>&1 &
echo "Running update in background"
echo "Results are coming in $MID_HOME/tmp/update.$$"

#!/bin/bash
#
# shell script testsuper.sh to test Midas
#
# variables MIDASHOME and MIDVERS must be set already!
#
# execute as: $ $MIDASHOME/$MIDVERS/test/prim/testsuper.sh 
# 
# if it's the very first time you execute Midas (e.g. after an installation)
# execute as: $ $MIDASHOME/$MIDVERS/test/prim/testsuper.sh 1
# 
# K. Banse      041129
#
#.VERSION
# 041223        last modif
#


if [ -d $MIDASHOME/$MIDVERS ] ; then
   echo "MIDASHOME/MIDVERS = $MIDASHOME/$MIDVERS"
else
   echo env. var. MIDASHOME and/or MIDVERS not set... we abort
   exit 1
fi


cd ~/tmp
echo "we work in `pwd`"
echo "first we clean this dir. completely...!"
echo "you have 2 seconds to abort this...!"
sleep 2

rm -rf *
ls 

echo we execute Midas in job-mode:
inmidas -j "@ vericopy; @ superverify; bye"

$MIDASHOME/$MIDVERS/system/unix/inmidas -j "@ vericopy; @ superverify; bye"

echo "now we check the Midas logfile for errors in any tutorial"
grep \(ERR\) ~/midwork/F*00.LOG

if [ $? != 0 ] ; then
   echo "-------------------------------------------------------------"
   echo procedure superverify terminated without errors
   echo "-------------------------------------------------------------"
else
   echo "-------------------------------------------------------------"
   echo procedure superverify had problems - check the Midas logfile!
   echo "-------------------------------------------------------------"
   exit 1
fi


cd $MIDASHOME

echo 
echo "as the final step, we also install the calibration data base"
echo "if we have a calib tarfile (compressed or uncompressed) in $MIDASHOME"
echo 
ls
sleep 2

if [ ! -f calib.tar.Z ] ; then
   if [ ! -f calib.tar ] ; then
      echo "neither file calib.tar.Z nor calib.tar found in $MIDASHOME"
      echo "skip calibration data base creation..."
      exit 
   fi
fi

$MIDASHOME/$MIDVERS/monit/calib_build

 

#! /bin/sh
# @(#)cleanmidas.sh	19.1 (ESO-IPG) 02/25/03 14:31:58
#
# cleanrelease procedure
# remove all dependent files
# .VERSION 1.1		04 Nov 88 - C. Guirao [ESO-IPG]

# Determine how to set prompt
if [ "`echo -n a`" = a ]; then
        # BSD echo
        NNN=-n
        CCC=
else
        # USG echo
        NNN=
        CCC='\c'
fi

necho()
{
        #
        #  A safe way to perform echo without sending a new-line
        #

        echo $NNN "$*" $CCC > /dev/tty
}

ask_yn()
{
        #
        #  Get a yes/no answer from the user; $1 is the prompt, $2 the default
        #

        prompt="$1"
        def="${2:-y}"           # yes is the default if not supplied
        while true; do
                necho "$prompt [$def]: "
                read answer
                answer="${answer:-$def}"
                case "$answer" in
                        [yY])
                                answer=y
                                break
                                ;;
                        [nN])
                                answer=n
                                break
                                ;;
                          *)
                                error Please enter "'y'" or "'n'".
                                ;;
                esac
        done
        [ $answer = y ]
}

MID_HERE=`pwd`
if [ -z "$MIDVERS" ] ; then
  MIDVERS=`echo $MID_HERE | sed 's/^.*midas\/\([^\/]*\).*$/\1/'`
fi
if [ -z "$MIDASHOME" ] ; then
  MIDASHOME=`echo $MID_HERE | sed 's/\/'$MIDVERS'.*$//'`
fi
MID_HOME=$MIDASHOME/$MIDVERS

export MIDASHOME MIDVERS

if ask_yn "REMOVING DEPENDENT FILES UNDER $MIDASHOME/$MIDVERS"; then
  echo ""
else
  exit 0
fi

cd $MIDASHOME/$MIDVERS

echo "rm -rf install/vms install/unix/test install/unix/systems"
rm -rf install/vms install/unix/test install/unix/systems
echo "rm -rf local/shlib local/preinstall local/setup local/README"
rm -rf local/util local/shlib local/preinstall local/setup local/README
echo "rm -rf test tmp contrib/lib"
rm -rf test tmp contrib/lib
echo "rm -rf util/bdf2ps util/help util/libsrc util/ltape util/tapeserv"
rm -rf util/bdf2ps util/help util/libsrc util/ltape util/tapeserv
echo "rm -rf pipeline"
echo "mkdir pipeline"
echo "chmod 775 pipeline"
echo "touch pipeline/EMPTY"
rm -rf pipeline
mkdir pipeline
chmod 775 pipeline
touch pipeline/EMPTY

echo "rm -f *.o *.for *.tex *.mar *.fc *.doc *.csh *.com *.f *.c"
echo "rm -f SELECTED DEPENDENCIES"

find . \( \
	-name "*.o" -o \
        -name "*.for" -o  \
        -name "*.tex" -o  \
        -name "*.mar" -o  \
        -name "*.fc" -o  \
        -name "*.doc" -o  \
        -name "*.csh" -o  \
        -name "*.com" -o  \
        -name "*.lasc" -o  \
        -name "*.iasc" -o  \
        -name "*.f" -o  \
        -name "SELECTED" -o \
        -name "DEPENDENCIES" -o \
        -name "*.c" \) -exec rm -f {} \;

cd $MIDASHOME/$MIDVERS/system/exec
echo "rm -f computer.exe ftoc_fx.exe ftoc_hp*  ftoc_osf.exe"
rm -f computer.exe ftoc_fx.exe ftoc_hp*  ftoc_osf.exe
echo "rm -f ftoc_pc.exe ftoc_sun.exe  ftoc_titan.exe  fontsup.exe"
rm -f ftoc_pc.exe ftoc_sun.exe  ftoc_titan.exe  fontsup.exe

cd $MIDASHOME/$MIDVERS
echo "rm -rf ./gui/GraphLib ./gui/incl ./gui/lib/*.a"
rm -rf ./gui/GraphLib ./gui/incl ./gui/lib/*.a

cd $MIDASHOME/$MIDVERS/lib

# Libraries included in libmidas.a and libgmidas.a
# For 95NOV also: rm -f libdio.a libdsp.a
rm -f libos.a libftoc.a libst.a libtbl.a libidicl.a libagl3.a libplot.a 
#
rm -f libreadline.a libmath.a libtw.a libtw3.a ../monit/libprep.a
#
# Libraries from applic
#rm -f libfit.a libfituser.a libagen.a libaplot.a libstat.a

#!/bin/bash
# 
# script pixcheck for emulating INTAPE/FITS in Midas
# using keyword file "INTAPE.KEY"
# to check for correct no. of data values in FITS file
# 
# execute as $ pixcheck FITS-file [YES]
# if 2nd param. given, full listing is shown
# 
# K. Banse	DMD/DFS, ESO - Garching
# 041112	creation
# 
  
# fill keyword file

echo "p1/c/1/40 1                                           " > INTAPE.KEY
echo "p2/c/1/40 toto                                        " >> INTAPE.KEY
echo "p3/c/1/128 $1" >> INTAPE.KEY
if [ $# -lt 2 ]; then
##   echo "p4/c/1/3 NNN " >> INTAPE.KEY
   echo "p4/c/1/3 SON " >> INTAPE.KEY
else
   echo "p4/c/1/3 FOY " >> INTAPE.KEY
fi
echo "p5/c/1/8 9999    " >> INTAPE.KEY

# switch to outside mode + execute
export MIDAS_OUTSIDE=1
$MID_EXE/intape.exe
# 
# get rid of created Midas file
rm -f toto0001.*

#! /bin/sh
# @(#)make_midfile.sh	19.1 (ESO-IPG) 02/25/03 14:32:00
# .TYPE           command
# .NAME           make_midfile.sh
# .LANGUAGE       shell script
# .ENVIRONMENT    Unix Systems. Executable under SHELL and C-SHELL
# .COMMENTS       Generates the midfile.map for the current directory
#                 midfile.map are used on HP systems with the command
#                 mapnames to recreate the original Unix File System using
#                 links, from a CD-ROM without RockRidge extensions.
# .AUTHOR         Carlos Guirao
# .VERSION 1.1    22-Jun-1995:          Implementation

# Call this script with absolute pathname
#echo $0 | egrep -s "^/" 
#if [ $? != 0 ]; then
#  echo "Use the absolute pathname to execute this script"
#  exit 1
#fi

dir=${1:-.}

cd $dir

# Remove previous midfile.map if exists
rm -f MIDFILE.MAP

echo "Creating MIDFILE.MAP in " `pwd`  

ls -l | gawk '
{
  FILENAME=""
  EXT=""

  if ( NF < 8 || $8 == "." || $8 == ".." ) continue

  original=$8
  file=$8
  flags=$1
  n=split(file,tmp,".")
  if ( n > 1 ) {
    EXT=toupper(substr(tmp[n],0,3))
    file=(substr(file,0,length(file)-length(tmp[n])-1))
    }

  FILENAME=toupper(substr(file,0,8))
  gsub(/\./,"_",FILENAME)

  type=substr(flags,0,1)
  if ( type == "-" ) {
     TOTAL=FILENAME "." EXT ";1"
     printf "F %-14s                           %s\n",TOTAL,original
     }
  if ( type == "d" ) 
     printf "D %-14s                           %s\n",FILENAME,original
}' > MIDFILE.MAP

exit 0

#!/bin/sh
# 
# @(#)lutasc.sh	19.1 (ESO-IPG) 02/25/03 14:30:09
# Bourne shell script
# to delete lines 1-3 and last line of ascii table file
# and to remove 1. field
# K. Banse	980928
# 
sed '1,3d
     $d' $1 >temp.temp
# 
# now we use awk to throw out the sequence field
# 
awk '{ printf "                   %s      %s      %s\n", $2, $3, $4 }' temp.temp >temp.final
# 
mv temp.final $2
rm temp.temp

#! /bin/sh
# 
# Bourne shell script `testdrs.sh' for testing the `drs' command
# K. Banse	ESO - Garching creation: 000607
# 090827	last modif
# 
# execute via    % testdrs.sh MIDAShomedir MIDASversion
pwd
MIDASHOME=$1; export MIDASHOME
MIDVERS=$2; export MIDVERS
# 
rm -f FORGRdrs.KEY
rm -f kukiwuki.bdf
# 
DAZUNIT=DAZ;export DAZUNIT		#inside Midas DAZUNIT is set!!!
# 
# for the verification we use the explicit path, however, for a correct
# installation, the `drs' script should have been copied to /usr/local/bin
# 
testdrs=${MIDASHOME}/${MIDVERS}/system/unix/drs; export testdrs
echo
echo "test of the drs command"
echo
echo "drs  create/image kukiwuki 2,512,512 \? poly 0.,0.3,0.3,0.8,0.8"
$testdrs  create/image kukiwuki 2,512,512 \? poly 0.,0.3,0.3,0.8,0.8
echo "drs  statist/image kukiwuki p5=FFYN"
$testdrs  statist/image kukiwuki p5=FFYN
$testdrs wait/secs 3

#! /bin/bash
# .COPYRIGHT: Copyright (c) 2002-2011 European Southern Observatory,
#                                         all rights reserved
# .TYPE           command
# .NAME           autoinstall 
# .LANGUAGE       shell script
# .ENVIRONMENT    Unix Systems. Executable under SHELL and C-SHELL
# .COMMENTS       Automatic installation procedure of MIDAS
#                 Usage: autoconfig
#
# .REMARKS        The external variable $MIDASHOME and $MIDVERS must be set 
#
# .AUTHOR         Carlos Guirao
# .VERSION    
# 021028	implementation
# 111206	last modif 
#
# Checks echo command which option to use to get NO NEW LINE
#
echo=echo
if [ "`echo -n `" = "-n" ] ; then
	SV_NONL="\c"
else	
	echo="echo -n"
fi

clear

cd `echo $0 | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
MID_INSTALL=`pwd`
VERSDIR=`echo $MID_INSTALL | sed 's/\/install\/unix$//'`
MIDVERS=`echo $VERSDIR | sed -e 's/^.*\///'`
MIDASHOME=`echo $VERSDIR | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`

MID_INSTALL=$MIDASHOME/$MIDVERS/install/unix
MID_HOME=$MIDASHOME/$MIDVERS

export MIDASHOME MIDVERS

#
# CG: The DISPLAY variable is not needed anymore. I'm using 'ascii_bin no'
#if [ -z "$DISPLAY" ];  then
#  echo "DISPLAY environment variable not set - exiting"
#  exit 1
#fi

#
# START
#
echo "**********************************************************************"
echo "********** MIDAS AUTO INSTALLATION/CONFIGURATION SCRIPT **************"
echo "**********************************************************************"
echo "********** MIDASHOME: $MIDASHOME"
echo "********** MIDVERS:   $MIDVERS"
echo ""

$echo "Do you want to continue [yn]? (y): " $SV_NONL
read answ
if [ -z "$answ" ]; then
  answ="y"
fi
if [ "$answ" = "n" -o "$answ" = "N" ]; then
  exit 1
fi

/bin/bash $MID_INSTALL/select all
/bin/bash $MID_INSTALL/preinstall -a
/bin/bash $MID_INSTALL/install1 -a
/bin/bash $MID_INSTALL/setup -a
/bin/bash ../../system/unix/inmidas -j "@ compile.all"
/bin/bash ../../system/unix/inmidas -j "@ ascii_bin no ; bye"

echo  " "
echo "**********************************************************************"
echo "Midas installation successfully terminated."
echo "on:  "`date`
echo  " "
echo "Enter:"
echo "  inmidas         (if you want to run MIDAS defaults)"
echo "  gomidas         (to restart the previous MIDAS session)"
echo "  helpmidas       (standalone GUI help for MIDAS)"
echo "  drs <midas_command> (execute MIDAS command from Unix command line)"
echo "**********************************************************************"

exit 0
